(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(function () {
      return (root.cv = factory());
    });
  } else if (typeof module === 'object' && module.exports) {
    // Node. Does not work with strict CommonJS, but
    // only CommonJS-like environments that support module.exports,
    // like Node.
    module.exports = factory();
  } else {
    // Browser globals
    root.cv = factory();
  }
}(this, function () {
  var cv = function(cv) {
  cv = cv || {};
  var Module = cv;

var Module;if(!Module)Module=(typeof cv!=="undefined"?cv:null)||{};var moduleOverrides={};for(var key in Module){if(Module.hasOwnProperty(key)){moduleOverrides[key]=Module[key]}}var ENVIRONMENT_IS_WEB=false;var ENVIRONMENT_IS_WORKER=false;var ENVIRONMENT_IS_NODE=false;var ENVIRONMENT_IS_SHELL=false;if(Module["ENVIRONMENT"]){if(Module["ENVIRONMENT"]==="WEB"){ENVIRONMENT_IS_WEB=true}else if(Module["ENVIRONMENT"]==="WORKER"){ENVIRONMENT_IS_WORKER=true}else if(Module["ENVIRONMENT"]==="NODE"){ENVIRONMENT_IS_NODE=true}else if(Module["ENVIRONMENT"]==="SHELL"){ENVIRONMENT_IS_SHELL=true}else{throw new Error("The provided Module['ENVIRONMENT'] value is not valid. It must be one of: WEB|WORKER|NODE|SHELL.")}}else{ENVIRONMENT_IS_WEB=typeof window==="object";ENVIRONMENT_IS_WORKER=typeof importScripts==="function";ENVIRONMENT_IS_NODE=typeof process==="object"&&typeof require==="function"&&!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_WORKER;ENVIRONMENT_IS_SHELL=!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_NODE&&!ENVIRONMENT_IS_WORKER}if(ENVIRONMENT_IS_NODE){if(!Module["print"])Module["print"]=console.log;if(!Module["printErr"])Module["printErr"]=console.warn;var nodeFS;var nodePath;Module["read"]=function shell_read(filename,binary){if(!nodeFS)nodeFS=require("fs");if(!nodePath)nodePath=require("path");filename=nodePath["normalize"](filename);var ret=nodeFS["readFileSync"](filename);return binary?ret:ret.toString()};Module["readBinary"]=function readBinary(filename){var ret=Module["read"](filename,true);if(!ret.buffer){ret=new Uint8Array(ret)}assert(ret.buffer);return ret};Module["load"]=function load(f){globalEval(read(f))};if(!Module["thisProgram"]){if(process["argv"].length>1){Module["thisProgram"]=process["argv"][1].replace(/\\/g,"/")}else{Module["thisProgram"]="unknown-program"}}Module["arguments"]=process["argv"].slice(2);if(typeof module!=="undefined"){module["exports"]=Module}process["on"]("uncaughtException",(function(ex){if(!(ex instanceof ExitStatus)){throw ex}}));Module["inspect"]=(function(){return"[Emscripten Module object]"})}else if(ENVIRONMENT_IS_SHELL){if(!Module["print"])Module["print"]=print;if(typeof printErr!="undefined")Module["printErr"]=printErr;if(typeof read!="undefined"){Module["read"]=read}else{Module["read"]=function shell_read(){throw"no read() available"}}Module["readBinary"]=function readBinary(f){if(typeof readbuffer==="function"){return new Uint8Array(readbuffer(f))}var data=read(f,"binary");assert(typeof data==="object");return data};if(typeof scriptArgs!="undefined"){Module["arguments"]=scriptArgs}else if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof quit==="function"){Module["quit"]=(function(status,toThrow){quit(status)})}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){Module["read"]=function shell_read(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};if(ENVIRONMENT_IS_WORKER){Module["readBinary"]=function readBinary(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.responseType="arraybuffer";xhr.send(null);return new Uint8Array(xhr.response)}}Module["readAsync"]=function readAsync(url,onload,onerror){var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=function xhr_onload(){if(xhr.status==200||xhr.status==0&&xhr.response){onload(xhr.response)}else{onerror()}};xhr.onerror=onerror;xhr.send(null)};if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof console!=="undefined"){if(!Module["print"])Module["print"]=function shell_print(x){console.log(x)};if(!Module["printErr"])Module["printErr"]=function shell_printErr(x){console.warn(x)}}else{var TRY_USE_DUMP=false;if(!Module["print"])Module["print"]=TRY_USE_DUMP&&typeof dump!=="undefined"?(function(x){dump(x)}):(function(x){})}if(ENVIRONMENT_IS_WORKER){Module["load"]=importScripts}if(typeof Module["setWindowTitle"]==="undefined"){Module["setWindowTitle"]=(function(title){document.title=title})}}else{throw"Unknown runtime environment. Where are we?"}function globalEval(x){eval.call(null,x)}if(!Module["load"]&&Module["read"]){Module["load"]=function load(f){globalEval(Module["read"](f))}}if(!Module["print"]){Module["print"]=(function(){})}if(!Module["printErr"]){Module["printErr"]=Module["print"]}if(!Module["arguments"]){Module["arguments"]=[]}if(!Module["thisProgram"]){Module["thisProgram"]="./this.program"}if(!Module["quit"]){Module["quit"]=(function(status,toThrow){throw toThrow})}Module.print=Module["print"];Module.printErr=Module["printErr"];Module["preRun"]=[];Module["postRun"]=[];for(var key in moduleOverrides){if(moduleOverrides.hasOwnProperty(key)){Module[key]=moduleOverrides[key]}}moduleOverrides=undefined;var Runtime={setTempRet0:(function(value){tempRet0=value;return value}),getTempRet0:(function(){return tempRet0}),stackSave:(function(){return STACKTOP}),stackRestore:(function(stackTop){STACKTOP=stackTop}),getNativeTypeSize:(function(type){switch(type){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:{if(type[type.length-1]==="*"){return Runtime.QUANTUM_SIZE}else if(type[0]==="i"){var bits=parseInt(type.substr(1));assert(bits%8===0);return bits/8}else{return 0}}}}),getNativeFieldSize:(function(type){return Math.max(Runtime.getNativeTypeSize(type),Runtime.QUANTUM_SIZE)}),STACK_ALIGN:16,prepVararg:(function(ptr,type){if(type==="double"||type==="i64"){if(ptr&7){assert((ptr&7)===4);ptr+=4}}else{assert((ptr&3)===0)}return ptr}),getAlignSize:(function(type,size,vararg){if(!vararg&&(type=="i64"||type=="double"))return 8;if(!type)return Math.min(size,8);return Math.min(size||(type?Runtime.getNativeFieldSize(type):0),Runtime.QUANTUM_SIZE)}),dynCall:(function(sig,ptr,args){if(args&&args.length){return Module["dynCall_"+sig].apply(null,[ptr].concat(args))}else{return Module["dynCall_"+sig].call(null,ptr)}}),functionPointers:[],addFunction:(function(func){for(var i=0;i<Runtime.functionPointers.length;i++){if(!Runtime.functionPointers[i]){Runtime.functionPointers[i]=func;return 2*(1+i)}}throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."}),removeFunction:(function(index){Runtime.functionPointers[(index-2)/2]=null}),warnOnce:(function(text){if(!Runtime.warnOnce.shown)Runtime.warnOnce.shown={};if(!Runtime.warnOnce.shown[text]){Runtime.warnOnce.shown[text]=1;Module.printErr(text)}}),funcWrappers:{},getFuncWrapper:(function(func,sig){assert(sig);if(!Runtime.funcWrappers[sig]){Runtime.funcWrappers[sig]={}}var sigCache=Runtime.funcWrappers[sig];if(!sigCache[func]){if(sig.length===1){sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func)}}else if(sig.length===2){sigCache[func]=function dynCall_wrapper(arg){return Runtime.dynCall(sig,func,[arg])}}else{sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func,Array.prototype.slice.call(arguments))}}}return sigCache[func]}),getCompilerSetting:(function(name){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"}),stackAlloc:(function(size){var ret=STACKTOP;STACKTOP=STACKTOP+size|0;STACKTOP=STACKTOP+15&-16;return ret}),staticAlloc:(function(size){var ret=STATICTOP;STATICTOP=STATICTOP+size|0;STATICTOP=STATICTOP+15&-16;return ret}),dynamicAlloc:(function(size){var ret=HEAP32[DYNAMICTOP_PTR>>2];var end=(ret+size+15|0)&-16;HEAP32[DYNAMICTOP_PTR>>2]=end;if(end>=TOTAL_MEMORY){var success=enlargeMemory();if(!success){HEAP32[DYNAMICTOP_PTR>>2]=ret;return 0}}return ret}),alignMemory:(function(size,quantum){var ret=size=Math.ceil(size/(quantum?quantum:16))*(quantum?quantum:16);return ret}),makeBigInt:(function(low,high,unsigned){var ret=unsigned?+(low>>>0)+ +(high>>>0)*+4294967296:+(low>>>0)+ +(high|0)*+4294967296;return ret}),GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};Module["Runtime"]=Runtime;var ABORT=0;var EXITSTATUS=0;function assert(condition,text){if(!condition){abort("Assertion failed: "+text)}}function getCFunc(ident){var func=Module["_"+ident];if(!func){try{func=eval("_"+ident)}catch(e){}}assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)");return func}var cwrap,ccall;((function(){var JSfuncs={"stackSave":(function(){Runtime.stackSave()}),"stackRestore":(function(){Runtime.stackRestore()}),"arrayToC":(function(arr){var ret=Runtime.stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}),"stringToC":(function(str){var ret=0;if(str!==null&&str!==undefined&&str!==0){var len=(str.length<<2)+1;ret=Runtime.stackAlloc(len);stringToUTF8(str,ret,len)}return ret})};var toC={"string":JSfuncs["stringToC"],"array":JSfuncs["arrayToC"]};ccall=function ccallFunc(ident,returnType,argTypes,args,opts){var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=Runtime.stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func.apply(null,cArgs);if(returnType==="string")ret=Pointer_stringify(ret);if(stack!==0){if(opts&&opts.async){EmterpreterAsync.asyncFinalizers.push((function(){Runtime.stackRestore(stack)}));return}Runtime.stackRestore(stack)}return ret};var sourceRegex=/^function\s*[a-zA-Z$_0-9]*\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/;function parseJSFunc(jsfunc){var parsed=jsfunc.toString().match(sourceRegex).slice(1);return{arguments:parsed[0],body:parsed[1],returnValue:parsed[2]}}var JSsource=null;function ensureJSsource(){if(!JSsource){JSsource={};for(var fun in JSfuncs){if(JSfuncs.hasOwnProperty(fun)){JSsource[fun]=parseJSFunc(JSfuncs[fun])}}}}cwrap=function cwrap(ident,returnType,argTypes){argTypes=argTypes||[];var cfunc=getCFunc(ident);var numericArgs=argTypes.every((function(type){return type==="number"}));var numericRet=returnType!=="string";if(numericRet&&numericArgs){return cfunc}var argNames=argTypes.map((function(x,i){return"$"+i}));var funcstr="(function("+argNames.join(",")+") {";var nargs=argTypes.length;if(!numericArgs){ensureJSsource();funcstr+="var stack = "+JSsource["stackSave"].body+";";for(var i=0;i<nargs;i++){var arg=argNames[i],type=argTypes[i];if(type==="number")continue;var convertCode=JSsource[type+"ToC"];funcstr+="var "+convertCode.arguments+" = "+arg+";";funcstr+=convertCode.body+";";funcstr+=arg+"=("+convertCode.returnValue+");"}}var cfuncname=parseJSFunc((function(){return cfunc})).returnValue;funcstr+="var ret = "+cfuncname+"("+argNames.join(",")+");";if(!numericRet){var strgfy=parseJSFunc((function(){return Pointer_stringify})).returnValue;funcstr+="ret = "+strgfy+"(ret);"}if(!numericArgs){ensureJSsource();funcstr+=JSsource["stackRestore"].body.replace("()","(stack)")+";"}funcstr+="return ret})";return eval(funcstr)}}))();Module["ccall"]=ccall;Module["cwrap"]=cwrap;function setValue(ptr,value,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math_abs(tempDouble)>=+1?tempDouble>+0?(Math_min(+Math_floor(tempDouble/+4294967296),+4294967295)|0)>>>0:~~+Math_ceil((tempDouble- +(~~tempDouble>>>0))/+4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;default:abort("invalid type for setValue: "+type)}}Module["setValue"]=setValue;function getValue(ptr,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];default:abort("invalid type for setValue: "+type)}return null}Module["getValue"]=getValue;var ALLOC_NORMAL=0;var ALLOC_STACK=1;var ALLOC_STATIC=2;var ALLOC_DYNAMIC=3;var ALLOC_NONE=4;Module["ALLOC_NORMAL"]=ALLOC_NORMAL;Module["ALLOC_STACK"]=ALLOC_STACK;Module["ALLOC_STATIC"]=ALLOC_STATIC;Module["ALLOC_DYNAMIC"]=ALLOC_DYNAMIC;Module["ALLOC_NONE"]=ALLOC_NONE;function allocate(slab,types,allocator,ptr){var zeroinit,size;if(typeof slab==="number"){zeroinit=true;size=slab}else{zeroinit=false;size=slab.length}var singleType=typeof types==="string"?types:null;var ret;if(allocator==ALLOC_NONE){ret=ptr}else{ret=[typeof _malloc==="function"?_malloc:Runtime.staticAlloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][allocator===undefined?ALLOC_STATIC:allocator](Math.max(size,singleType?1:types.length))}if(zeroinit){var ptr=ret,stop;assert((ret&3)==0);stop=ret+(size&~3);for(;ptr<stop;ptr+=4){HEAP32[ptr>>2]=0}stop=ret+size;while(ptr<stop){HEAP8[ptr++>>0]=0}return ret}if(singleType==="i8"){if(slab.subarray||slab.slice){HEAPU8.set(slab,ret)}else{HEAPU8.set(new Uint8Array(slab),ret)}return ret}var i=0,type,typeSize,previousType;while(i<size){var curr=slab[i];if(typeof curr==="function"){curr=Runtime.getFunctionIndex(curr)}type=singleType||types[i];if(type===0){i++;continue}if(type=="i64")type="i32";setValue(ret+i,curr,type);if(previousType!==type){typeSize=Runtime.getNativeTypeSize(type);previousType=type}i+=typeSize}return ret}Module["allocate"]=allocate;function getMemory(size){if(!staticSealed)return Runtime.staticAlloc(size);if(!runtimeInitialized)return Runtime.dynamicAlloc(size);return _malloc(size)}Module["getMemory"]=getMemory;function Pointer_stringify(ptr,length){if(length===0||!ptr)return"";var hasUtf=0;var t;var i=0;while(1){t=HEAPU8[ptr+i>>0];hasUtf|=t;if(t==0&&!length)break;i++;if(length&&i==length)break}if(!length)length=i;var ret="";if(hasUtf<128){var MAX_CHUNK=1024;var curr;while(length>0){curr=String.fromCharCode.apply(String,HEAPU8.subarray(ptr,ptr+Math.min(length,MAX_CHUNK)));ret=ret?ret+curr:curr;ptr+=MAX_CHUNK;length-=MAX_CHUNK}return ret}return Module["UTF8ToString"](ptr)}Module["Pointer_stringify"]=Pointer_stringify;function AsciiToString(ptr){var str="";while(1){var ch=HEAP8[ptr++>>0];if(!ch)return str;str+=String.fromCharCode(ch)}}Module["AsciiToString"]=AsciiToString;function stringToAscii(str,outPtr){return writeAsciiToMemory(str,outPtr,false)}Module["stringToAscii"]=stringToAscii;var UTF8Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf8"):undefined;function UTF8ArrayToString(u8Array,idx){var endPtr=idx;while(u8Array[endPtr])++endPtr;if(endPtr-idx>16&&u8Array.subarray&&UTF8Decoder){return UTF8Decoder.decode(u8Array.subarray(idx,endPtr))}else{var u0,u1,u2,u3,u4,u5;var str="";while(1){u0=u8Array[idx++];if(!u0)return str;if(!(u0&128)){str+=String.fromCharCode(u0);continue}u1=u8Array[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}u2=u8Array[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u3=u8Array[idx++]&63;if((u0&248)==240){u0=(u0&7)<<18|u1<<12|u2<<6|u3}else{u4=u8Array[idx++]&63;if((u0&252)==248){u0=(u0&3)<<24|u1<<18|u2<<12|u3<<6|u4}else{u5=u8Array[idx++]&63;u0=(u0&1)<<30|u1<<24|u2<<18|u3<<12|u4<<6|u5}}}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}}}Module["UTF8ArrayToString"]=UTF8ArrayToString;function UTF8ToString(ptr){return UTF8ArrayToString(HEAPU8,ptr)}Module["UTF8ToString"]=UTF8ToString;function stringToUTF8Array(str,outU8Array,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){if(outIdx>=endIdx)break;outU8Array[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;outU8Array[outIdx++]=192|u>>6;outU8Array[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;outU8Array[outIdx++]=224|u>>12;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=2097151){if(outIdx+3>=endIdx)break;outU8Array[outIdx++]=240|u>>18;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=67108863){if(outIdx+4>=endIdx)break;outU8Array[outIdx++]=248|u>>24;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else{if(outIdx+5>=endIdx)break;outU8Array[outIdx++]=252|u>>30;outU8Array[outIdx++]=128|u>>24&63;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}}outU8Array[outIdx]=0;return outIdx-startIdx}Module["stringToUTF8Array"]=stringToUTF8Array;function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}Module["stringToUTF8"]=stringToUTF8;function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){++len}else if(u<=2047){len+=2}else if(u<=65535){len+=3}else if(u<=2097151){len+=4}else if(u<=67108863){len+=5}else{len+=6}}return len}Module["lengthBytesUTF8"]=lengthBytesUTF8;var UTF16Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf-16le"):undefined;function demangle(func){var __cxa_demangle_func=Module["___cxa_demangle"]||Module["__cxa_demangle"];if(__cxa_demangle_func){try{var s=func.substr(1);var len=lengthBytesUTF8(s)+1;var buf=_malloc(len);stringToUTF8(s,buf,len);var status=_malloc(4);var ret=__cxa_demangle_func(buf,0,0,status);if(getValue(status,"i32")===0&&ret){return Pointer_stringify(ret)}}catch(e){}finally{if(buf)_free(buf);if(status)_free(status);if(ret)_free(ret)}return func}Runtime.warnOnce("warning: build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling");return func}function demangleAll(text){var regex=/__Z[\w\d_]+/g;return text.replace(regex,(function(x){var y=demangle(x);return x===y?x:x+" ["+y+"]"}))}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error(0)}catch(e){err=e}if(!err.stack){return"(no stack trace available)"}}return err.stack.toString()}function stackTrace(){var js=jsStackTrace();if(Module["extraStackTrace"])js+="\n"+Module["extraStackTrace"]();return demangleAll(js)}Module["stackTrace"]=stackTrace;var WASM_PAGE_SIZE=65536;var ASMJS_PAGE_SIZE=16777216;var MIN_TOTAL_MEMORY=16777216;function alignUp(x,multiple){if(x%multiple>0){x+=multiple-x%multiple}return x}var HEAP,buffer,HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function updateGlobalBuffer(buf){Module["buffer"]=buffer=buf}function updateGlobalBufferViews(){Module["HEAP8"]=HEAP8=new Int8Array(buffer);Module["HEAP16"]=HEAP16=new Int16Array(buffer);Module["HEAP32"]=HEAP32=new Int32Array(buffer);Module["HEAPU8"]=HEAPU8=new Uint8Array(buffer);Module["HEAPU16"]=HEAPU16=new Uint16Array(buffer);Module["HEAPU32"]=HEAPU32=new Uint32Array(buffer);Module["HEAPF32"]=HEAPF32=new Float32Array(buffer);Module["HEAPF64"]=HEAPF64=new Float64Array(buffer)}var STATIC_BASE,STATICTOP,staticSealed;var STACK_BASE,STACKTOP,STACK_MAX;var DYNAMIC_BASE,DYNAMICTOP_PTR;STATIC_BASE=STATICTOP=STACK_BASE=STACKTOP=STACK_MAX=DYNAMIC_BASE=DYNAMICTOP_PTR=0;staticSealed=false;function abortOnCannotGrowMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value "+TOTAL_MEMORY+", (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which allows increasing the size at runtime but prevents some optimizations, (3) set Module.TOTAL_MEMORY to a higher value before the program runs, or (4) if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 ")}if(!Module["reallocBuffer"])Module["reallocBuffer"]=(function(size){var ret;try{if(ArrayBuffer.transfer){ret=ArrayBuffer.transfer(buffer,size)}else{var oldHEAP8=HEAP8;ret=new ArrayBuffer(size);var temp=new Int8Array(ret);temp.set(oldHEAP8)}}catch(e){return false}var success=_emscripten_replace_memory(ret);if(!success)return false;return ret});function enlargeMemory(){var PAGE_MULTIPLE=Module["usingWasm"]?WASM_PAGE_SIZE:ASMJS_PAGE_SIZE;var LIMIT=2147483648-PAGE_MULTIPLE;if(HEAP32[DYNAMICTOP_PTR>>2]>LIMIT){return false}var OLD_TOTAL_MEMORY=TOTAL_MEMORY;TOTAL_MEMORY=Math.max(TOTAL_MEMORY,MIN_TOTAL_MEMORY);while(TOTAL_MEMORY<HEAP32[DYNAMICTOP_PTR>>2]){if(TOTAL_MEMORY<=536870912){TOTAL_MEMORY=alignUp(2*TOTAL_MEMORY,PAGE_MULTIPLE)}else{TOTAL_MEMORY=Math.min(alignUp((3*TOTAL_MEMORY+2147483648)/4,PAGE_MULTIPLE),LIMIT)}}var replacement=Module["reallocBuffer"](TOTAL_MEMORY);if(!replacement||replacement.byteLength!=TOTAL_MEMORY){TOTAL_MEMORY=OLD_TOTAL_MEMORY;return false}updateGlobalBuffer(replacement);updateGlobalBufferViews();return true}var byteLength;try{byteLength=Function.prototype.call.bind(Object.getOwnPropertyDescriptor(ArrayBuffer.prototype,"byteLength").get);byteLength(new ArrayBuffer(4))}catch(e){byteLength=(function(buffer){return buffer.byteLength})}var TOTAL_STACK=Module["TOTAL_STACK"]||5242880;var TOTAL_MEMORY=Module["TOTAL_MEMORY"]||134217728;if(TOTAL_MEMORY<TOTAL_STACK)Module.printErr("TOTAL_MEMORY should be larger than TOTAL_STACK, was "+TOTAL_MEMORY+"! (TOTAL_STACK="+TOTAL_STACK+")");if(Module["buffer"]){buffer=Module["buffer"]}else{{buffer=new ArrayBuffer(TOTAL_MEMORY)}}updateGlobalBufferViews();function getTotalMemory(){return TOTAL_MEMORY}HEAP32[0]=1668509029;HEAP16[1]=25459;if(HEAPU8[2]!==115||HEAPU8[3]!==99)throw"Runtime error: expected the system to be little-endian!";Module["HEAP"]=HEAP;Module["buffer"]=buffer;Module["HEAP8"]=HEAP8;Module["HEAP16"]=HEAP16;Module["HEAP32"]=HEAP32;Module["HEAPU8"]=HEAPU8;Module["HEAPU16"]=HEAPU16;Module["HEAPU32"]=HEAPU32;Module["HEAPF32"]=HEAPF32;Module["HEAPF64"]=HEAPF64;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){var callback=callbacks.shift();if(typeof callback=="function"){callback();continue}var func=callback.func;if(typeof func==="number"){if(callback.arg===undefined){Module["dynCall_v"](func)}else{Module["dynCall_vi"](func,callback.arg)}}else{func(callback.arg===undefined?null:callback.arg)}}}var __ATPRERUN__=[];var __ATINIT__=[];var __ATMAIN__=[];var __ATEXIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeExited=false;function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){if(runtimeInitialized)return;runtimeInitialized=true;callRuntimeCallbacks(__ATINIT__)}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__);runtimeExited=true}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}Module["addOnPreRun"]=addOnPreRun;function addOnInit(cb){__ATINIT__.unshift(cb)}Module["addOnInit"]=addOnInit;function addOnPreMain(cb){__ATMAIN__.unshift(cb)}Module["addOnPreMain"]=addOnPreMain;function addOnExit(cb){__ATEXIT__.unshift(cb)}Module["addOnExit"]=addOnExit;function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}Module["addOnPostRun"]=addOnPostRun;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}Module["intArrayFromString"]=intArrayFromString;function intArrayToString(array){var ret=[];for(var i=0;i<array.length;i++){var chr=array[i];if(chr>255){chr&=255}ret.push(String.fromCharCode(chr))}return ret.join("")}Module["intArrayToString"]=intArrayToString;function writeStringToMemory(string,buffer,dontAddNull){Runtime.warnOnce("writeStringToMemory is deprecated and should not be called! Use stringToUTF8() instead!");var lastChar,end;if(dontAddNull){end=buffer+lengthBytesUTF8(string);lastChar=HEAP8[end]}stringToUTF8(string,buffer,Infinity);if(dontAddNull)HEAP8[end]=lastChar}Module["writeStringToMemory"]=writeStringToMemory;function writeArrayToMemory(array,buffer){HEAP8.set(array,buffer)}Module["writeArrayToMemory"]=writeArrayToMemory;function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}Module["writeAsciiToMemory"]=writeAsciiToMemory;if(!Math["imul"]||Math["imul"](4294967295,5)!==-5)Math["imul"]=function imul(a,b){var ah=a>>>16;var al=a&65535;var bh=b>>>16;var bl=b&65535;return al*bl+(ah*bl+al*bh<<16)|0};Math.imul=Math["imul"];if(!Math["clz32"])Math["clz32"]=(function(x){x=x>>>0;for(var i=0;i<32;i++){if(x&1<<31-i)return i}return 32});Math.clz32=Math["clz32"];if(!Math["trunc"])Math["trunc"]=(function(x){return x<0?Math.ceil(x):Math.floor(x)});Math.trunc=Math["trunc"];var Math_abs=Math.abs;var Math_cos=Math.cos;var Math_sin=Math.sin;var Math_tan=Math.tan;var Math_acos=Math.acos;var Math_asin=Math.asin;var Math_atan=Math.atan;var Math_atan2=Math.atan2;var Math_exp=Math.exp;var Math_log=Math.log;var Math_sqrt=Math.sqrt;var Math_ceil=Math.ceil;var Math_floor=Math.floor;var Math_pow=Math.pow;var Math_imul=Math.imul;var Math_fround=Math.fround;var Math_round=Math.round;var Math_min=Math.min;var Math_clz32=Math.clz32;var Math_trunc=Math.trunc;var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function getUniqueRunDependency(id){return id}function addRunDependency(id){runDependencies++;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}}Module["addRunDependency"]=addRunDependency;function removeRunDependency(id){runDependencies--;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}Module["removeRunDependency"]=removeRunDependency;Module["preloadedImages"]={};Module["preloadedAudios"]={};var ASM_CONSTS=[];STATIC_BASE=Runtime.GLOBAL_BASE;STATICTOP=STATIC_BASE+1124544;__ATINIT__.push({func:(function(){__GLOBAL__I_000101()})},{func:(function(){__GLOBAL__sub_I_attr_value_pb_cc()})},{func:(function(){__GLOBAL__sub_I_iostream_cpp()})},{func:(function(){__GLOBAL__sub_I_bind_cpp()})},{func:(function(){__GLOBAL__sub_I_message_cc()})},{func:(function(){__GLOBAL__sub_I_descriptor_pb_cc()})},{func:(function(){__GLOBAL__sub_I_status_cc()})},{func:(function(){__GLOBAL__sub_I_detection_output_layer_cpp()})},{func:(function(){__GLOBAL__sub_I_prior_box_layer_cpp()})},{func:(function(){__GLOBAL__sub_I_init_cpp()})},{func:(function(){__GLOBAL__sub_I_opencv_caffe_pb_cc()})},{func:(function(){__GLOBAL__sub_I_op_def_pb_cc()})},{func:(function(){__GLOBAL__sub_I_types_pb_cc()})},{func:(function(){__GLOBAL__sub_I_function_pb_cc()})},{func:(function(){__GLOBAL__sub_I_bindings_cpp()})},{func:(function(){__GLOBAL__sub_I_tensor_pb_cc()})},{func:(function(){__GLOBAL__sub_I_versions_pb_cc()})},{func:(function(){__GLOBAL__sub_I_graph_pb_cc()})},{func:(function(){__GLOBAL__sub_I_tensor_shape_pb_cc()})},{func:(function(){__GLOBAL__sub_I_haar_cpp()})},{func:(function(){__GLOBAL__sub_I_hog_cpp()})},{func:(function(){__GLOBAL__sub_I_imgwarp_cpp()})},{func:(function(){__GLOBAL__sub_I_histogram_cpp()})},{func:(function(){__GLOBAL__sub_I_color_cpp()})},{func:(function(){__GLOBAL__sub_I_persistence_cpp()})},{func:(function(){__GLOBAL__sub_I_system_cpp()})},{func:(function(){__GLOBAL__sub_I_umatrix_cpp()})});allocate([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,192,11,177,162,10,240,111,63,32,224,31,224,31,224,239,63,136,103,16,107,42,224,127,63,240,7,252,1,127,192,239,63,118,10,129,95,71,220,135,63,18,250,1,170,28,161,239,63,227,3,252,176,168,192,143,63,32,248,129,31,248,129,239,63,116,165,70,67,164,206,147,63,181,219,160,172,16,99,239,63,26,177,213,7,27,185,151,63,113,66,74,158,101,68,239,63,151,145,175,39,192,159,155,63,181,10,35,68,246,37,239,63,0,51,120,14,155,130,159,63,8,31,124,240,193,7,239,63,127,217,35,137,217,176,161,63,2,142,69,248,199,233,238,63,95,189,254,185,135,158,163,63,192,236,1,179,7,204,238,63,212,228,200,175,91,138,165,63,235,1,186,122,128,174,238,63,252,220,50,246,88,116,167,63,103,183,240,171,49,145,238,63,235,227,200,14,131,92,169,63,228,80,151,165,26,116,238,63,190,113,25,113,221,66,171,63,116,229,1,201,58,87,238,63,82,11,219,138,107,39,173,63,115,26,220,121,145,58,238,63,166,98,17,192,48,10,175,63,30,30,30,30,30,30,238,63,113,228,152,53,152,117,176,63,30,224,1,30,224,1,238,63,224,122,163,238,54,101,177,63,138,134,248,227,214,229,237,63,22,20,10,47,246,83,178,63,202,29,160,220,1,202,237,63,208,209,27,150,215,65,179,63,219,129,185,118,96,174,237,63,240,70,166,190,220,46,180,63,138,127,30,35,242,146,237,63,63,24,6,63,7,27,181,63,52,44,184,84,182,119,237,63,195,80,55,169,88,6,182,63,178,114,117,128,172,92,237,63,75,107,229,138,210,240,182,63,29,212,65,29,212,65,237,63,204,18,123,109,118,218,183,63,26,91,252,163,44,39,237,63,32,155,49,214,69,195,184,63,116,192,110,143,181,12,237,63,172,51,32,70,66,171,185,63,198,191,68,92,110,242,236,63,99,213,74,58,109,146,186,63,11,155,3,137,86,216,236,63,161,237,176,43,200,120,187,63,231,203,1,150,109,190,236,63,67,199,91,143,84,94,188,63,145,225,94,5,179,164,236,63,93,179,108,214,19,67,189,63,66,138,251,90,38,139,236,63,229,242,42,110,7,39,190,63,28,199,113,28,199,113,236,63,166,98,17,192,48,10,191,63,134,73,13,209,148,88,236,63,186,234,219,49,145,236,191,63,240,248,195,1,143,63,236,63,110,89,202,18,21,103,192,63,28,160,46,57,181,38,236,63,89,142,208,124,126,215,192,63,224,192,129,3,7,14,236,63,172,66,103,132,133,71,193,63,139,141,134,238,131,245,235,63,160,103,47,213,42,183,193,63,247,6,148,137,43,221,235,63,203,90,10,25,111,38,194,63,123,62,136,101,253,196,235,63,35,245,31,248,82,149,194,63,208,186,193,20,249,172,235,63,210,127,228,24,215,3,195,63,35,255,24,43,30,149,235,63,116,143,30,32,252,113,195,63,139,51,218,61,108,125,235,63,41,198,236,176,194,223,195,63,5,238,190,227,226,101,235,63,30,125,203,108,43,77,196,63,79,27,232,180,129,78,235,63,229,85,154,243,54,186,196,63,206,6,216,74,72,55,235,63,55,180,161,227,229,38,197,63,217,128,108,64,54,32,235,63,133,32,152,217,56,147,197,63,164,34,217,49,75,9,235,63,211,147,167,112,48,255,197,63,40,175,161,188,134,242,234,63,80,173,114,66,205,106,198,63,94,144,148,127,232,219,234,63,28,210,25,231,15,214,198,63,27,112,197,26,112,197,234,63,164,55,64,245,248,64,199,63,253,235,135,47,29,175,234,63,9,217,16,2,137,171,199,63,190,99,106,96,239,152,234,63,234,87,67,161,192,21,200,63,89,225,48,81,230,130,234,63,16,201,32,101,160,127,200,63,109,26,208,166,1,109,234,63,64,109,136,222,40,233,200,63,74,138,104,7,65,87,234,63,180,86,244,156,90,82,201,63,26,164,65,26,164,65,234,63,131,251,125,46,54,187,201,63,160,28,197,135,42,44,234,63,99,181,226,31,188,35,202,63,2,75,122,249,211,22,234,63,24,47,136,252,236,139,202,63,26,160,1,26,160,1,234,63,242,191,128,78,201,243,202,63,217,51,16,149,142,236,233,63,164,181,143,158,81,91,203,63,45,104,107,23,159,215,233,63,214,140,45,116,134,194,203,63,2,161,228,78,209,194,233,63,192,24,140,85,104,41,204,63,218,16,85,234,36,174,233,63,33,154,154,199,247,143,204,63,154,153,153,153,153,153,233,63,220,197,9,78,53,246,204,63,255,192,142,13,47,133,233,63,145,187,79,107,33,92,205,63,114,184,12,248,228,112,233,63,125,236,171,160,188,193,205,63,174,119,227,11,187,92,233,63,229,242,42,110,7,39,206,63,224,233,214,252,176,72,233,63,95,90,170,82,2,140,206,63,230,44,155,127,198,52,233,63,54,89,220,203,173,240,206,63,41,226,208,73,251,32,233,63,55,123,75,86,10,85,207,63,213,144,1,18,79,13,233,63,42,62,94,109,24,185,207,63,250,24,156,143,193,249,232,63,28,80,173,69,108,14,208,63,63,55,241,122,82,230,232,63,64,208,180,148,37,64,208,63,211,24,48,141,1,211,232,63,13,89,205,95,184,113,208,63,58,255,98,128,206,191,232,63,227,144,115,226,36,163,208,63,170,243,107,15,185,172,232,63,75,183,154,87,107,212,208,63,156,137,1,246,192,153,232,63,213,74,174,249,139,5,209,63,74,176,171,240,229,134,232,63,176,168,147,2,135,54,209,63,185,146,192,188,39,116,232,63,14,166,171,171,92,103,209,63,24,134,97,24,134,97,232,63,111,35,212,45,13,152,209,63,20,6,120,194,0,79,232,63,250,153,105,193,152,200,209,63,221,190,178,122,151,60,232,63,242,162,72,158,255,248,209,63,160,164,130,1,74,42,232,63,101,121,207,251,65,41,210,63,24,24,24,24,24,24,232,63,57,118,223,16,96,89,210,63,6,24,96,128,1,6,232,63,163,134,222,19,90,137,210,63,64,127,1,253,5,244,231,63,36,157,184,58,48,185,210,63,29,79,90,81,37,226,231,63,48,29,225,186,226,232,210,63,244,5,125,65,95,208,231,63,132,65,84,201,113,24,211,63,124,1,46,146,179,190,231,63,84,125,152,154,221,71,211,63,195,236,224,8,34,173,231,63,90,216,191,98,38,119,211,63,139,57,182,107,170,155,231,63,233,69,105,85,76,166,211,63,200,164,120,129,76,138,231,63,15,247,193,165,79,213,211,63,13,198,154,17,8,121,231,63,227,167,134,134,48,4,212,63,177,169,52,228,220,103,231,63,19,232,4,42,239,50,212,63,109,117,1,194,202,86,231,63,194,94,28,194,139,97,212,63,70,23,93,116,209,69,231,63,208,9,64,128,6,144,212,63,141,254,65,197,240,52,231,63,160,120,119,149,95,190,212,63,188,222,70,127,40,36,231,63,105,2,96,50,151,236,212,63,9,124,156,109,120,19,231,63,45,248,45,135,173,26,213,63,112,129,11,92,224,2,231,63,98,210,173,195,162,72,213,63,23,96,242,22,96,242,230,63,108,90,69,23,119,118,213,63,199,55,67,107,247,225,230,63,225,207,244,176,42,164,213,63,97,200,129,38,166,209,230,63,202,9,88,191,189,209,213,63,23,108,193,22,108,193,230,63,211,147,167,112,48,255,213,63,61,26,163,10,73,177,230,63,149,199,185,242,130,44,214,63,144,114,83,209,60,161,230,63,242,225,3,115,181,89,214,63,192,208,136,58,71,145,230,63,174,20,155,30,200,134,214,63,23,104,129,22,104,129,230,63,61,148,53,34,187,179,214,63,26,103,1,54,159,113,230,63,227,161,43,170,142,224,214,63,249,34,81,106,236,97,230,63,53,146,120,226,66,13,215,63,163,74,59,133,79,82,230,63,6,208,187,246,215,57,215,63,100,33,11,89,200,66,230,63,206,219,57,18,78,102,215,63,222,192,138,184,86,51,230,63,162,71,221,95,165,146,215,63,64,98,1,119,250,35,230,63,191,175,55,10,222,190,215,63,148,174,49,104,179,20,230,63,195,175,130,59,248,234,215,63,6,22,88,96,129,5,230,63,149,212,160,29,244,22,216,63,252,45,41,52,100,246,229,63,23,139,30,218,209,66,216,63,231,21,208,184,91,231,229,63,160,11,51,154,145,110,216,63,165,226,236,195,103,216,229,63,90,66,193,134,51,154,216,63,87,16,147,43,136,201,229,63,138,180,88,200,183,197,216,63,145,250,71,198,188,186,229,63,199,98,54,135,30,241,216,63,192,90,1,107,5,172,229,63,61,168,69,235,103,28,217,63,170,204,35,241,97,157,229,63,250,22,33,28,148,71,217,63,237,88,129,48,210,142,229,63,88,81,19,65,163,114,217,63,96,5,88,1,86,128,229,63,138,224,23,129,149,157,217,63,58,107,80,60,237,113,229,63,98,8,220,2,107,200,217,63,226,82,124,186,151,99,229,63,75,152,191,236,35,243,217,63,85,85,85,85,85,85,229,63,149,185,213,100,192,29,218,63,254,130,187,230,37,71,229,63,10,187,229,144,64,72,218,63,235,15,244,72,9,57,229,63,234,217,107,150,164,114,218,63,75,5,168,86,255,42,229,63,73,8,154,154,236,156,218,63,21,248,226,234,7,29,229,63,228,176,88,194,24,199,218,63,197,196,17,225,34,15,229,63,107,120,71,50,41,241,218,63,21,80,1,21,80,1,229,63,91,252,189,14,30,27,219,63,155,76,221,98,143,243,228,63,98,143,204,123,247,68,219,63,57,5,47,167,224,229,228,63,93,243,60,157,181,110,219,63,76,44,220,190,67,216,228,63,251,16,147,150,88,152,219,63,110,175,37,135,184,202,228,63,10,173,13,139,224,193,219,63,225,143,166,221,62,189,228,63,123,27,167,157,77,235,219,63,91,191,82,160,214,175,228,63,38,240,21,241,159,20,220,63,74,1,118,173,127,162,228,63,77,173,205,167,215,61,220,63,103,208,178,227,57,149,228,63,247,111,255,227,244,102,220,63,128,72,1,34,5,136,228,63,33,154,154,199,247,143,220,63,123,20,174,71,225,122,228,63,201,122,77,116,224,184,220,63,102,96,89,52,206,109,228,63,235,243,133,11,175,225,220,63,154,207,245,199,203,96,228,63,100,30,114,174,99,10,221,63,202,118,199,226,217,83,228,63,213,235,0,126,254,50,221,63,251,217,98,101,248,70,228,63,131,198,226,154,127,91,221,63,77,238,171,48,39,58,228,63,62,47,138,37,231,131,221,63,135,31,213,37,102,45,228,63,84,89,44,62,53,172,221,63,81,89,94,38,181,32,228,63,160,196,193,4,106,212,221,63,20,20,20,20,20,20,228,63,181,213,6,153,133,252,221,63,102,101,14,209,130,7,228,63,38,108,124,26,136,36,222,63,251,19,176,63,1,251,227,63,4,119,104,168,113,76,222,63,7,175,165,66,143,238,227,63,135,135,214,97,66,116,222,63,2,169,228,188,44,226,227,63,245,97,152,101,250,155,222,63,198,117,170,145,217,213,227,63,192,140,70,210,153,195,222,63,231,171,123,164,149,201,227,63,244,221,64,198,32,235,222,63,85,41,35,217,96,189,227,63,236,6,175,95,143,18,223,63,20,59,177,19,59,177,227,63,91,30,129,188,229,57,223,63,34,200,122,56,36,165,227,63,172,40,112,250,35,97,223,63,99,127,24,44,28,153,227,63,194,158,254,54,74,136,223,63,142,8,102,211,34,141,227,63,30,243,120,143,88,175,223,63,20,56,129,19,56,129,227,63,113,21,246,32,79,214,223,63,238,69,201,209,91,117,227,63,152,244,87,8,46,253,223,63,72,7,222,243,141,105,227,63,138,255,37,177,250,17,224,63,248,42,159,95,206,93,227,63,254,208,165,165,82,37,224,63,193,120,43,251,28,82,227,63,59,99,206,239,158,56,224,63,70,19,224,172,121,70,227,63,210,38,169,157,223,75,224,63,178,188,87,91,228,58,227,63,156,69,38,189,20,95,224,63,250,29,106,237,92,47,227,63,64,223,28,92,62,114,224,63,191,16,43,74,227,35,227,63,14,69,75,136,92,133,224,63,182,235,233,88,119,24,227,63,32,53,87,79,111,152,224,63,144,209,48,1,25,13,227,63,209,20,206,190,118,171,224,63,96,2,196,42,200,1,227,63,130,42,37,228,114,190,224,63,104,47,161,189,132,246,226,63,183,214,185,204,99,209,224,63,75,209,254,161,78,235,226,63,139,204,209,133,73,228,224,63,151,128,75,192,37,224,226,63,125,73,155,28,36,247,224,63,160,80,45,1,10,213,226,63,150,76,45,158,243,9,225,63,160,44,129,77,251,201,226,63,248,204,135,23,184,28,225,63,17,55,90,142,249,190,226,63,188,239,147,149,113,47,225,63,64,43,1,173,4,180,226,63,68,61,36,37,32,66,225,63,5,193,243,146,28,169,226,63,233,213,244,210,195,84,225,63,158,18,228,41,65,158,226,63,14,166,171,171,92,103,225,63,165,4,184,91,114,147,226,63,160,153,216,187,234,121,225,63,19,176,136,18,176,136,226,63,6,207,245,15,110,140,225,63,77,206,161,56,250,125,226,63,110,201,103,180,230,158,225,63,53,39,129,184,80,115,226,63,158,162,125,181,84,177,225,63,39,1,214,124,179,104,226,63,36,60,113,31,184,195,225,63,241,146,128,112,34,94,226,63,3,112,103,254,16,214,225,63,178,119,145,126,157,83,226,63,208,64,112,94,95,232,225,63,146,36,73,146,36,73,226,63,76,9,135,75,163,250,225,63,91,96,23,151,183,62,226,63,109,171,146,209,220,12,226,63,223,188,154,120,86,52,226,63,235,190,101,252,11,31,226,63,42,18,160,34,1,42,226,63,66,191,190,215,48,49,226,63,120,251,33,129,183,31,226,63,51,57,72,111,75,67,226,63,230,85,72,128,121,21,226,63,203,247,152,206,91,85,226,63,217,192,103,12,71,11,226,63,223,48,52,1,98,103,226,63,18,32,1,18,32,1,226,63,26,177,137,18,94,121,226,63,112,31,193,125,4,247,225,63,130,7,246,13,80,139,226,63,76,184,127,60,244,236,225,63,138,176,194,254,55,157,226,63,116,184,63,59,239,226,225,63,173,64,38,240,21,175,226,63,189,74,46,103,245,216,225,63,139,142,68,237,233,192,226,63,29,129,162,173,6,207,225,63,157,220,46,1,180,210,226,63,89,224,28,252,34,197,225,63,104,2,228,54,116,228,226,63,41,237,70,64,74,187,225,63,70,149,80,153,42,246,226,63,227,186,242,103,124,177,225,63,190,16,79,51,215,7,227,63,150,123,26,97,185,167,225,63,106,254,167,15,122,25,227,63,158,17,224,25,1,158,225,63,113,29,18,57,19,43,227,63,156,162,140,128,83,148,225,63,148,137,50,186,162,60,227,63,219,43,144,131,176,138,225,63,211,225,156,157,40,78,227,63,18,24,129,17,24,129,225,63,160,110,211,237,164,95,227,63,132,214,27,25,138,119,225,63,181,71,71,181,23,113,227,63,121,115,66,137,6,110,225,63,126,121,88,254,128,130,227,63,1,50,252,80,141,100,225,63,25,42,86,211,224,147,227,63,13,39,117,95,30,91,225,63,249,189,126,62,55,165,227,63,201,213,253,163,185,81,225,63,34,252,255,73,132,182,227,63,59,205,10,14,95,72,225,63,5,50,247,255,199,199,227,63,36,71,52,141,14,63,225,63,250,86,113,106,2,217,227,63,17,200,53,17,200,53,225,63,91,47,107,147,51,234,227,63,172,192,237,137,139,44,225,63,66,111,209,132,91,251,227,63,51,48,93,231,88,35,225,63,233,220,128,72,122,12,228,63,38,72,167,25,48,26,225,63,174,114,70,232,143,29,228,63,17,17,17,17,17,17,225,63,191,128,223,109,156,46,228,63,128,16,1,190,251,7,225,63,103,206,249,226,159,63,228,63,17,240,254,16,240,254,224,63,10,187,51,81,154,80,228,63,162,37,179,250,237,245,224,63,194,94,28,194,139,97,228,63,144,156,230,107,245,236,224,63,173,170,51,63,116,114,228,63,17,96,130,85,6,228,224,63,223,136,234,209,83,131,228,63,150,70,143,168,32,219,224,63,7,252,162,131,42,148,228,63,58,158,53,86,68,210,224,63,187,62,176,93,248,164,228,63,59,218,188,79,113,201,224,63,115,226,86,105,189,181,228,63,113,65,139,134,167,192,224,63,57,238,204,175,121,198,228,63,200,157,37,236,230,183,224,63,0,253,57,58,45,215,228,63,181,236,46,114,47,175,224,63,176,91,183,17,216,231,228,63,167,16,104,10,129,166,224,63,232,38,80,63,122,248,228,63,96,131,175,166,219,157,224,63,107,104,1,204,19,9,229,63,84,9,1,57,63,149,224,63,70,52,186,192,164,25,229,63,226,101,117,179,171,140,224,63,170,197,91,38,45,42,229,63,132,16,66,8,33,132,224,63,124,155,185,5,173,58,229,63,226,234,184,41,159,123,224,63,151,148,153,103,36,75,229,63,198,247,71,10,38,115,224,63,205,11,180,84,147,91,229,63,251,18,121,156,181,106,224,63,153,243,179,213,249,107,229,63,252,169,241,210,77,98,224,63,144,241,54,243,87,124,229,63,134,117,114,160,238,89,224,63,137,121,205,181,173,140,229,63,4,52,215,247,151,81,224,63,125,232,250,37,251,156,229,63,197,100,22,204,73,73,224,63,44,159,53,76,64,173,229,63,16,4,65,16,4,65,224,63,115,28,231,48,125,189,229,63,252,71,130,183,198,56,224,63,100,23,108,220,177,205,229,63,26,94,31,181,145,48,224,63,35,153,20,87,222,221,229,63,233,41,119,252,100,40,224,63,117,22,36,169,2,238,229,63,8,4,2,129,64,32,224,63,24,137,209,218,30,254,229,63,55,122,81,54,36,24,224,63,216,136,71,244,50,14,230,63,16,16,16,16,16,16,224,63,239,57,250,254,66,46,230,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,192,11,177,162,10,240,111,63,32,224,31,224,31,224,239,63,136,103,16,107,42,224,127,63,240,7,252,1,127,192,239,63,118,10,129,95,71,220,135,63,18,250,1,170,28,161,239,63,227,3,252,176,168,192,143,63,32,248,129,31,248,129,239,63,116,165,70,67,164,206,147,63,181,219,160,172,16,99,239,63,26,177,213,7,27,185,151,63,113,66,74,158,101,68,239,63,151,145,175,39,192,159,155,63,181,10,35,68,246,37,239,63,0,51,120,14,155,130,159,63,8,31,124,240,193,7,239,63,127,217,35,137,217,176,161,63,2,142,69,248,199,233,238,63,95,189,254,185,135,158,163,63,192,236,1,179,7,204,238,63,212,228,200,175,91,138,165,63,235,1,186,122,128,174,238,63,252,220,50,246,88,116,167,63,103,183,240,171,49,145,238,63,235,227,200,14,131,92,169,63,228,80,151,165,26,116,238,63,190,113,25,113,221,66,171,63,116,229,1,201,58,87,238,63,82,11,219,138,107,39,173,63,115,26,220,121,145,58,238,63,166,98,17,192,48,10,175,63,30,30,30,30,30,30,238,63,113,228,152,53,152,117,176,63,30,224,1,30,224,1,238,63,224,122,163,238,54,101,177,63,138,134,248,227,214,229,237,63,22,20,10,47,246,83,178,63,202,29,160,220,1,202,237,63,208,209,27,150,215,65,179,63,219,129,185,118,96,174,237,63,240,70,166,190,220,46,180,63,138,127,30,35,242,146,237,63,63,24,6,63,7,27,181,63,52,44,184,84,182,119,237,63,195,80,55,169,88,6,182,63,178,114,117,128,172,92,237,63,75,107,229,138,210,240,182,63,29,212,65,29,212,65,237,63,204,18,123,109,118,218,183,63,26,91,252,163,44,39,237,63,32,155,49,214,69,195,184,63,116,192,110,143,181,12,237,63,172,51,32,70,66,171,185,63,198,191,68,92,110,242,236,63,99,213,74,58,109,146,186,63,11,155,3,137,86,216,236,63,161,237,176,43,200,120,187,63,231,203,1,150,109,190,236,63,67,199,91,143,84,94,188,63,145,225,94,5,179,164,236,63,93,179,108,214,19,67,189,63,66,138,251,90,38,139,236,63,229,242,42,110,7,39,190,63,28,199,113,28,199,113,236,63,166,98,17,192,48,10,191,63,134,73,13,209,148,88,236,63,186,234,219,49,145,236,191,63,240,248,195,1,143,63,236,63,110,89,202,18,21,103,192,63,28,160,46,57,181,38,236,63,89,142,208,124,126,215,192,63,224,192,129,3,7,14,236,63,172,66,103,132,133,71,193,63,139,141,134,238,131,245,235,63,160,103,47,213,42,183,193,63,247,6,148,137,43,221,235,63,203,90,10,25,111,38,194,63,123,62,136,101,253,196,235,63,35,245,31,248,82,149,194,63,208,186,193,20,249,172,235,63,210,127,228,24,215,3,195,63,35,255,24,43,30,149,235,63,116,143,30,32,252,113,195,63,139,51,218,61,108,125,235,63,41,198,236,176,194,223,195,63,5,238,190,227,226,101,235,63,30,125,203,108,43,77,196,63,79,27,232,180,129,78,235,63,229,85,154,243,54,186,196,63,206,6,216,74,72,55,235,63,55,180,161,227,229,38,197,63,217,128,108,64,54,32,235,63,133,32,152,217,56,147,197,63,164,34,217,49,75,9,235,63,211,147,167,112,48,255,197,63,40,175,161,188,134,242,234,63,80,173,114,66,205,106,198,63,94,144,148,127,232,219,234,63,28,210,25,231,15,214,198,63,27,112,197,26,112,197,234,63,164,55,64,245,248,64,199,63,253,235,135,47,29,175,234,63,9,217,16,2,137,171,199,63,190,99,106,96,239,152,234,63,234,87,67,161,192,21,200,63,89,225,48,81,230,130,234,63,16,201,32,101,160,127,200,63,109,26,208,166,1,109,234,63,64,109,136,222,40,233,200,63,74,138,104,7,65,87,234,63,180,86,244,156,90,82,201,63,26,164,65,26,164,65,234,63,131,251,125,46,54,187,201,63,160,28,197,135,42,44,234,63,99,181,226,31,188,35,202,63,2,75,122,249,211,22,234,63,24,47,136,252,236,139,202,63,26,160,1,26,160,1,234,63,242,191,128,78,201,243,202,63,217,51,16,149,142,236,233,63,164,181,143,158,81,91,203,63,45,104,107,23,159,215,233,63,214,140,45,116,134,194,203,63,2,161,228,78,209,194,233,63,192,24,140,85,104,41,204,63,218,16,85,234,36,174,233,63,33,154,154,199,247,143,204,63,154,153,153,153,153,153,233,63,220,197,9,78,53,246,204,63,255,192,142,13,47,133,233,63,145,187,79,107,33,92,205,63,114,184,12,248,228,112,233,63,125,236,171,160,188,193,205,63,174,119,227,11,187,92,233,63,229,242,42,110,7,39,206,63,224,233,214,252,176,72,233,63,95,90,170,82,2,140,206,63,230,44,155,127,198,52,233,63,54,89,220,203,173,240,206,63,41,226,208,73,251,32,233,63,55,123,75,86,10,85,207,63,213,144,1,18,79,13,233,63,42,62,94,109,24,185,207,63,250,24,156,143,193,249,232,63,28,80,173,69,108,14,208,63,63,55,241,122,82,230,232,63,64,208,180,148,37,64,208,63,211,24,48,141,1,211,232,63,13,89,205,95,184,113,208,63,58,255,98,128,206,191,232,63,227,144,115,226,36,163,208,63,170,243,107,15,185,172,232,63,75,183,154,87,107,212,208,63,156,137,1,246,192,153,232,63,213,74,174,249,139,5,209,63,74,176,171,240,229,134,232,63,176,168,147,2,135,54,209,63,185,146,192,188,39,116,232,63,14,166,171,171,92,103,209,63,24,134,97,24,134,97,232,63,111,35,212,45,13,152,209,63,20,6,120,194,0,79,232,63,250,153,105,193,152,200,209,63,221,190,178,122,151,60,232,63,242,162,72,158,255,248,209,63,160,164,130,1,74,42,232,63,101,121,207,251,65,41,210,63,24,24,24,24,24,24,232,63,57,118,223,16,96,89,210,63,6,24,96,128,1,6,232,63,163,134,222,19,90,137,210,63,64,127,1,253,5,244,231,63,36,157,184,58,48,185,210,63,29,79,90,81,37,226,231,63,48,29,225,186,226,232,210,63,244,5,125,65,95,208,231,63,132,65,84,201,113,24,211,63,124,1,46,146,179,190,231,63,84,125,152,154,221,71,211,63,195,236,224,8,34,173,231,63,90,216,191,98,38,119,211,63,139,57,182,107,170,155,231,63,233,69,105,85,76,166,211,63,200,164,120,129,76,138,231,63,15,247,193,165,79,213,211,63,13,198,154,17,8,121,231,63,227,167,134,134,48,4,212,63,177,169,52,228,220,103,231,63,19,232,4,42,239,50,212,63,109,117,1,194,202,86,231,63,194,94,28,194,139,97,212,63,70,23,93,116,209,69,231,63,208,9,64,128,6,144,212,63,141,254,65,197,240,52,231,63,160,120,119,149,95,190,212,63,188,222,70,127,40,36,231,63,105,2,96,50,151,236,212,63,9,124,156,109,120,19,231,63,45,248,45,135,173,26,213,63,112,129,11,92,224,2,231,63,98,210,173,195,162,72,213,63,23,96,242,22,96,242,230,63,108,90,69,23,119,118,213,63,199,55,67,107,247,225,230,63,225,207,244,176,42,164,213,63,97,200,129,38,166,209,230,63,202,9,88,191,189,209,213,63,23,108,193,22,108,193,230,63,211,147,167,112,48,255,213,63,61,26,163,10,73,177,230,63,149,199,185,242,130,44,214,63,144,114,83,209,60,161,230,63,242,225,3,115,181,89,214,63,192,208,136,58,71,145,230,63,174,20,155,30,200,134,214,63,23,104,129,22,104,129,230,63,61,148,53,34,187,179,214,63,26,103,1,54,159,113,230,63,227,161,43,170,142,224,214,63,249,34,81,106,236,97,230,63,53,146,120,226,66,13,215,63,163,74,59,133,79,82,230,63,6,208,187,246,215,57,215,63,100,33,11,89,200,66,230,63,206,219,57,18,78,102,215,63,222,192,138,184,86,51,230,63,162,71,221,95,165,146,215,63,64,98,1,119,250,35,230,63,191,175,55,10,222,190,215,63,148,174,49,104,179,20,230,63,195,175,130,59,248,234,215,63,6,22,88,96,129,5,230,63,149,212,160,29,244,22,216,63,252,45,41,52,100,246,229,63,23,139,30,218,209,66,216,63,231,21,208,184,91,231,229,63,160,11,51,154,145,110,216,63,165,226,236,195,103,216,229,63,90,66,193,134,51,154,216,63,87,16,147,43,136,201,229,63,138,180,88,200,183,197,216,63,145,250,71,198,188,186,229,63,199,98,54,135,30,241,216,63,192,90,1,107,5,172,229,63,61,168,69,235,103,28,217,63,170,204,35,241,97,157,229,63,250,22,33,28,148,71,217,63,237,88,129,48,210,142,229,63,88,81,19,65,163,114,217,63,96,5,88,1,86,128,229,63,138,224,23,129,149,157,217,63,58,107,80,60,237,113,229,63,98,8,220,2,107,200,217,63,226,82,124,186,151,99,229,63,75,152,191,236,35,243,217,63,85,85,85,85,85,85,229,63,149,185,213,100,192,29,218,63,254,130,187,230,37,71,229,63,10,187,229,144,64,72,218,63,235,15,244,72,9,57,229,63,234,217,107,150,164,114,218,63,75,5,168,86,255,42,229,63,73,8,154,154,236,156,218,63,21,248,226,234,7,29,229,63,228,176,88,194,24,199,218,63,197,196,17,225,34,15,229,63,107,120,71,50,41,241,218,63,21,80,1,21,80,1,229,63,91,252,189,14,30,27,219,63,155,76,221,98,143,243,228,63,98,143,204,123,247,68,219,63,57,5,47,167,224,229,228,63,93,243,60,157,181,110,219,63,76,44,220,190,67,216,228,63,251,16,147,150,88,152,219,63,110,175,37,135,184,202,228,63,10,173,13,139,224,193,219,63,225,143,166,221,62,189,228,63,123,27,167,157,77,235,219,63,91,191,82,160,214,175,228,63,38,240,21,241,159,20,220,63,74,1,118,173,127,162,228,63,77,173,205,167,215,61,220,63,103,208,178,227,57,149,228,63,247,111,255,227,244,102,220,63,128,72,1,34,5,136,228,63,33,154,154,199,247,143,220,63,123,20,174,71,225,122,228,63,201,122,77,116,224,184,220,63,102,96,89,52,206,109,228,63,235,243,133,11,175,225,220,63,154,207,245,199,203,96,228,63,100,30,114,174,99,10,221,63,202,118,199,226,217,83,228,63,213,235,0,126,254,50,221,63,251,217,98,101,248,70,228,63,131,198,226,154,127,91,221,63,77,238,171,48,39,58,228,63,62,47,138,37,231,131,221,63,135,31,213,37,102,45,228,63,84,89,44,62,53,172,221,63,81,89,94,38,181,32,228,63,160,196,193,4,106,212,221,63,20,20,20,20,20,20,228,63,181,213,6,153,133,252,221,63,102,101,14,209,130,7,228,63,38,108,124,26,136,36,222,63,251,19,176,63,1,251,227,63,4,119,104,168,113,76,222,63,7,175,165,66,143,238,227,63,135,135,214,97,66,116,222,63,2,169,228,188,44,226,227,63,245,97,152,101,250,155,222,63,198,117,170,145,217,213,227,63,192,140,70,210,153,195,222,63,231,171,123,164,149,201,227,63,244,221,64,198,32,235,222,63,85,41,35,217,96,189,227,63,236,6,175,95,143,18,223,63,20,59,177,19,59,177,227,63,91,30,129,188,229,57,223,63,34,200,122,56,36,165,227,63,172,40,112,250,35,97,223,63,99,127,24,44,28,153,227,63,194,158,254,54,74,136,223,63,142,8,102,211,34,141,227,63,30,243,120,143,88,175,223,63,20,56,129,19,56,129,227,63,113,21,246,32,79,214,223,63,238,69,201,209,91,117,227,63,152,244,87,8,46,253,223,63,72,7,222,243,141,105,227,63,138,255,37,177,250,17,224,63,248,42,159,95,206,93,227,63,254,208,165,165,82,37,224,63,193,120,43,251,28,82,227,63,59,99,206,239,158,56,224,63,70,19,224,172,121,70,227,63,210,38,169,157,223,75,224,63,178,188,87,91,228,58,227,63,156,69,38,189,20,95,224,63,250,29,106,237,92,47,227,63,64,223,28,92,62,114,224,63,191,16,43,74,227,35,227,63,14,69,75,136,92,133,224,63,182,235,233,88,119,24,227,63,32,53,87,79,111,152,224,63,144,209,48,1,25,13,227,63,209,20,206,190,118,171,224,63,96,2,196,42,200,1,227,63,130,42,37,228,114,190,224,63,104,47,161,189,132,246,226,63,183,214,185,204,99,209,224,63,75,209,254,161,78,235,226,63,139,204,209,133,73,228,224,63,151,128,75,192,37,224,226,63,125,73,155,28,36,247,224,63,160,80,45,1,10,213,226,63,150,76,45,158,243,9,225,63,160,44,129,77,251,201,226,63,248,204,135,23,184,28,225,63,17,55,90,142,249,190,226,63,188,239,147,149,113,47,225,63,64,43,1,173,4,180,226,63,68,61,36,37,32,66,225,63,5,193,243,146,28,169,226,63,233,213,244,210,195,84,225,63,158,18,228,41,65,158,226,63,14,166,171,171,92,103,225,63,165,4,184,91,114,147,226,63,160,153,216,187,234,121,225,63,19,176,136,18,176,136,226,63,6,207,245,15,110,140,225,63,77,206,161,56,250,125,226,63,110,201,103,180,230,158,225,63,53,39,129,184,80,115,226,63,158,162,125,181,84,177,225,63,39,1,214,124,179,104,226,63,36,60,113,31,184,195,225,63,241,146,128,112,34,94,226,63,3,112,103,254,16,214,225,63,178,119,145,126,157,83,226,63,208,64,112,94,95,232,225,63,146,36,73,146,36,73,226,63,76,9,135,75,163,250,225,63,91,96,23,151,183,62,226,63,109,171,146,209,220,12,226,63,223,188,154,120,86,52,226,63,235,190,101,252,11,31,226,63,42,18,160,34,1,42,226,63,66,191,190,215,48,49,226,63,120,251,33,129,183,31,226,63,51,57,72,111,75,67,226,63,230,85,72,128,121,21,226,63,203,247,152,206,91,85,226,63,217,192,103,12,71,11,226,63,223,48,52,1,98,103,226,63,18,32,1,18,32,1,226,63,26,177,137,18,94,121,226,63,112,31,193,125,4,247,225,63,130,7,246,13,80,139,226,63,76,184,127,60,244,236,225,63,138,176,194,254,55,157,226,63,116,184,63,59,239,226,225,63,173,64,38,240,21,175,226,63,189,74,46,103,245,216,225,63,139,142,68,237,233,192,226,63,29,129,162,173,6,207,225,63,157,220,46,1,180,210,226,63,89,224,28,252,34,197,225,63,104,2,228,54,116,228,226,63,41,237,70,64,74,187,225,63,70,149,80,153,42,246,226,63,227,186,242,103,124,177,225,63,190,16,79,51,215,7,227,63,150,123,26,97,185,167,225,63,106,254,167,15,122,25,227,63,158,17,224,25,1,158,225,63,113,29,18,57,19,43,227,63,156,162,140,128,83,148,225,63,148,137,50,186,162,60,227,63,219,43,144,131,176,138,225,63,211,225,156,157,40,78,227,63,18,24,129,17,24,129,225,63,160,110,211,237,164,95,227,63,132,214,27,25,138,119,225,63,181,71,71,181,23,113,227,63,121,115,66,137,6,110,225,63,126,121,88,254,128,130,227,63,1,50,252,80,141,100,225,63,25,42,86,211,224,147,227,63,13,39,117,95,30,91,225,63,249,189,126,62,55,165,227,63,201,213,253,163,185,81,225,63,34,252,255,73,132,182,227,63,59,205,10,14,95,72,225,63,5,50,247,255,199,199,227,63,36,71,52,141,14,63,225,63,250,86,113,106,2,217,227,63,17,200,53,17,200,53,225,63,91,47,107,147,51,234,227,63,172,192,237,137,139,44,225,63,66,111,209,132,91,251,227,63,51,48,93,231,88,35,225,63,233,220,128,72,122,12,228,63,38,72,167,25,48,26,225,63,174,114,70,232,143,29,228,63,17,17,17,17,17,17,225,63,191,128,223,109,156,46,228,63,128,16,1,190,251,7,225,63,103,206,249,226,159,63,228,63,17,240,254,16,240,254,224,63,10,187,51,81,154,80,228,63,162,37,179,250,237,245,224,63,194,94,28,194,139,97,228,63,144,156,230,107,245,236,224,63,173,170,51,63,116,114,228,63,17,96,130,85,6,228,224,63,223,136,234,209,83,131,228,63,150,70,143,168,32,219,224,63,7,252,162,131,42,148,228,63,58,158,53,86,68,210,224,63,187,62,176,93,248,164,228,63,59,218,188,79,113,201,224,63,115,226,86,105,189,181,228,63,113,65,139,134,167,192,224,63,57,238,204,175,121,198,228,63,200,157,37,236,230,183,224,63,0,253,57,58,45,215,228,63,181,236,46,114,47,175,224,63,176,91,183,17,216,231,228,63,167,16,104,10,129,166,224,63,232,38,80,63,122,248,228,63,96,131,175,166,219,157,224,63,107,104,1,204,19,9,229,63,84,9,1,57,63,149,224,63,70,52,186,192,164,25,229,63,226,101,117,179,171,140,224,63,170,197,91,38,45,42,229,63,132,16,66,8,33,132,224,63,124,155,185,5,173,58,229,63,226,234,184,41,159,123,224,63,151,148,153,103,36,75,229,63,198,247,71,10,38,115,224,63,205,11,180,84,147,91,229,63,251,18,121,156,181,106,224,63,153,243,179,213,249,107,229,63,252,169,241,210,77,98,224,63,144,241,54,243,87,124,229,63,134,117,114,160,238,89,224,63,137,121,205,181,173,140,229,63,4,52,215,247,151,81,224,63,125,232,250,37,251,156,229,63,197,100,22,204,73,73,224,63,44,159,53,76,64,173,229,63,16,4,65,16,4,65,224,63,115,28,231,48,125,189,229,63,252,71,130,183,198,56,224,63,100,23,108,220,177,205,229,63,26,94,31,181,145,48,224,63,35,153,20,87,222,221,229,63,233,41,119,252,100,40,224,63,117,22,36,169,2,238,229,63,8,4,2,129,64,32,224,63,24,137,209,218,30,254,229,63,55,122,81,54,36,24,224,63,216,136,71,244,50,14,230,63,16,16,16,16,16,16,224,63,239,57,250,254,66,46,230,63,0,0,0,0,0,0,224,63,4,0,0,0,0,0,0,0,208,93,0,0,214,2,0,0,215,2,0,0,252,255,255,255,252,255,255,255,208,93,0,0,216,2,0,0,217,2,0,0,0,0,0,0,0,0,0,0,180,71,2,0,121,139,2,0,180,71,2,0,137,139,2,0,180,71,2,0,156,139,2,0,180,71,2,0,9,140,2,0,140,72,2,0,221,139,2,0,0,0,0,0,1,0,0,0,88,32,0,0,0,0,0,0,140,72,2,0,185,139,2,0,0,0,0,0,1,0,0,0,96,32,0,0,0,0,0,0,112,72,2,0,46,140,2,0,0,0,0,0,120,32,0,0,112,72,2,0,83,140,2,0,1,0,0,0,120,32,0,0,180,71,2,0,144,140,2,0,140,72,2,0,210,140,2,0,0,0,0,0,1,0,0,0,88,32,0,0,0,0,0,0,140,72,2,0,174,140,2,0,0,0,0,0,1,0,0,0,184,32,0,0,0,0,0,0,112,72,2,0,254,140,2,0,0,0,0,0,208,32,0,0,112,72,2,0,35,141,2,0,1,0,0,0,208,32,0,0,140,72,2,0,126,141,2,0,0,0,0,0,1,0,0,0,88,32,0,0,0,0,0,0,140,72,2,0,90,141,2,0,0,0,0,0,1,0,0,0,8,33,0,0,0,0,0,0,112,72,2,0,170,141,2,0,0,0,0,0,32,33,0,0,112,72,2,0,207,141,2,0,1,0,0,0,32,33,0,0,140,72,2,0,58,142,2,0,0,0,0,0,1,0,0,0,88,32,0,0,0,0,0,0,140,72,2,0,6,142,2,0,0,0,0,0,1,0,0,0,88,33,0,0,0,0,0,0,112,72,2,0,118,142,2,0,0,0,0,0,112,33,0,0,112,72,2,0,171,142,2,0,1,0,0,0,112,33,0,0,180,71,2,0,225,142,2,0,140,72,2,0,31,143,2,0,0,0,0,0,1,0,0,0,88,32,0,0,0,0,0,0,140,72,2,0,241,142,2,0,0,0,0,0,1,0,0,0,176,33,0,0,0,0,0,0,112,72,2,0,85,143,2,0,0,0,0,0,200,33,0,0,112,72,2,0,132,143,2,0,1,0,0,0,200,33,0,0,180,71,2,0,180,143,2,0,140,72,2,0,241,143,2,0,0,0,0,0,1,0,0,0,88,32,0,0,0,0,0,0,140,72,2,0,190,143,2,0,0,0,0,0,1,0,0,0,8,34,0,0,0,0,0,0,112,72,2,0,44,144,2,0,0,0,0,0,32,34,0,0,112,72,2,0,96,144,2,0,1,0,0,0,32,34,0,0,112,72,2,0,149,144,2,0,0,0,0,0,0,34,0,0,112,72,2,0,160,144,2,0,1,0,0,0,0,34,0,0,180,71,2,0,172,144,2,0,180,71,2,0,221,144,2,0,220,71,2,0,204,144,2,0,128,34,0,0,0,0,0,0,220,71,2,0,187,144,2,0,136,34,0,0,0,0,0,0,180,71,2,0,2,145,2,0,180,71,2,0,33,145,2,0,180,71,2,0,64,145,2,0,180,71,2,0,95,145,2,0,180,71,2,0,126,145,2,0,180,71,2,0,157,145,2,0,180,71,2,0,188,145,2,0,180,71,2,0,241,145,2,0,180,71,2,0,33,146,2,0,180,71,2,0,57,146,2,0,180,71,2,0,76,146,2,0,180,71,2,0,91,146,2,0,180,71,2,0,119,146,2,0,180,71,2,0,144,146,2,0,180,71,2,0,221,146,2,0,140,72,2,0,158,146,2,0,0,0,0,0,1,0,0,0,24,35,0,0,0,0,0,0,180,71,2,0,10,147,2,0,180,71,2,0,163,149,2,0,112,72,2,0,198,149,2,0,0,0,0,0,152,67,0,0,112,72,2,0,220,149,2,0,1,0,0,0,152,67,0,0,220,71,2,0,38,150,2,0,248,42,0,0,0,0,0,0,112,72,2,0,66,150,2,0,0,0,0,0,104,35,0,0,112,72,2,0,95,150,2,0,1,0,0,0,104,35,0,0,220,71,2,0,125,150,2,0,104,35,0,0,0,0,0,0,112,72,2,0,157,150,2,0,0,0,0,0,152,35,0,0,112,72,2,0,190,150,2,0,1,0,0,0,152,35,0,0,180,71,2,0,224,150,2,0,220,71,2,0,10,151,2,0,248,42,0,0,0,0,0,0,112,72,2,0,22,151,2,0,0,0,0,0,208,35,0,0,112,72,2,0,35,151,2,0,1,0,0,0,208,35,0,0,180,71,2,0,49,151,2,0,112,72,2,0,80,151,2,0,0,0,0,0,248,42,0,0,112,72,2,0,97,151,2,0,1,0,0,0,248,42,0,0,112,72,2,0,115,151,2,0,0,0,0,0,64,35,0,0,112,72,2,0,151,151,2,0,1,0,0,0,64,35,0,0,180,71,2,0,188,151,2,0,112,72,2,0,213,151,2,0,0,0,0,0,72,36,0,0,112,72,2,0,239,151,2,0,1,0,0,0,72,36,0,0,220,71,2,0,90,152,2,0,128,36,0,0,0,0,0,0,180,71,2,0,165,152,2,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,205,59,127,102,158,160,230,63,204,59,127,102,158,160,230,63,70,141,50,207,107,144,237,63,99,169,174,166,226,125,216,63,176,92,247,207,151,98,239,63,10,166,105,60,184,248,200,63,38,37,209,163,141,216,239,63,44,180,41,188,166,23,185,63,126,109,121,227,33,246,239,63,21,216,13,241,101,31,169,63,13,205,132,96,136,253,239,63,127,102,163,247,85,33,153,63,219,146,155,22,98,255,239,63,135,199,222,252,209,33,137,63,146,138,142,133,216,255,239,63,118,0,103,254,240,33,121,63,2,29,98,33,246,255,239,63,195,164,204,190,248,33,105,63,230,110,88,136,253,255,239,63,66,71,230,174,250,33,89,63,52,26,22,98,255,255,239,63,55,179,236,42,251,33,73,63,117,134,133,216,255,255,239,63,248,78,238,73,251,33,57,63,156,97,33,246,255,255,239,63,2,181,174,81,251,33,41,63,103,88,136,253,255,255,239,63,245,207,158,83,251,33,25,63,26,22,98,255,255,255,239,63,106,215,26,84,251,33,9,63,134,133,216,255,255,255,239,63,72,217,57,84,251,33,249,62,98,33,246,255,255,255,239,63,78,152,65,84,251,33,233,62,88,136,253,255,255,255,239,63,136,124,67,84,251,33,217,62,22,98,255,255,255,255,239,63,196,216,67,84,251,33,201,62,134,216,255,255,255,255,239,63,0,53,68,84,251,33,185,62,33,246,255,255,255,255,239,63,136,124,67,84,251,33,169,62,136,253,255,255,255,255,239,63,136,124,67,84,251,33,153,62,98,255,255,255,255,255,239,63,103,94,70,84,251,33,137,62,217,255,255,255,255,255,239,63,169,154,64,84,251,33,121,62,246,255,255,255,255,255,239,63,36,34,76,84,251,33,105,62,254,255,255,255,255,255,239,63,36,34,76,84,251,33,89,62,255,255,255,255,255,255,239,63,58,4,30,84,251,33,73,62,0,0,0,0,0,0,240,63,15,64,122,84,251,33,57,62,0,0,0,0,0,0,240,63,15,64,122,84,251,33,41,62,220,71,2,0,34,154,2,0,152,38,0,0,0,0,0,0,180,71,2,0,57,154,2,0,220,71,2,0,73,154,2,0,152,38,0,0,0,0,0,0,220,71,2,0,32,155,2,0,128,36,0,0,0,0,0,0,220,71,2,0,102,155,2,0,208,38,0,0,0,0,0,0,180,71,2,0,120,155,2,0,220,71,2,0,136,155,2,0,208,38,0,0,0,0,0,0,220,71,2,0,17,159,2,0,8,42,0,0,0,0,0,0,220,71,2,0,126,159,2,0,8,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,192,0,0,0,0,0,0,224,193,0,0,0,224,255,255,239,199,255,255,255,255,255,255,239,255,0,0,0,0,0,0,0,0,0,0,0,0,0,224,111,64,0,0,0,0,0,192,95,64,0,0,0,0,224,255,239,64,0,0,0,0,192,255,223,64,0,0,192,255,255,255,223,65,0,0,0,224,255,255,239,71,255,255,255,255,255,255,239,127,0,0,0,0,0,0,0,0,180,71,2,0,185,189,2,0,220,71,2,0,18,187,2,0,160,39,0,0,0,0,0,0,180,71,2,0,51,187,2,0,220,71,2,0,252,187,2,0,136,39,0,0,0,0,0,0,220,71,2,0,213,207,2,0,240,98,0,0,0,0,0,0,180,71,2,0,56,212,2,0,140,72,2,0,45,233,2,0,0,0,0,0,1,0,0,0,200,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,44,180,41,188,166,23,185,63,10,166,105,60,184,248,200,63,5,159,213,46,6,148,210,63],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE);allocate([99,169,174,166,226,125,216,63,59,246,6,56,93,43,222,63,200,104,174,57,59,199,225,63,214,29,9,37,243,76,228,63,204,59,127,102,158,160,230,63,65,23,21,107,128,188,232,63,163,161,14,41,102,155,234,63,176,189,128,241,178,56,236,63,70,141,50,207,107,144,237,63,219,45,198,86,65,159,238,63,176,92,247,207,151,98,239,63,37,37,209,163,141,216,239,63,0,0,0,0,0,0,240,63,38,37,209,163,141,216,239,63,176,92,247,207,151,98,239,63,219,45,198,86,65,159,238,63,70,141,50,207,107,144,237,63,177,189,128,241,178,56,236,63,165,161,14,41,102,155,234,63,66,23,21,107,128,188,232,63,205,59,127,102,158,160,230,63,214,29,9,37,243,76,228,63,200,104,174,57,59,199,225,63,63,246,6,56,93,43,222,63,101,169,174,166,226,125,216,63,6,159,213,46,6,148,210,63,23,166,105,60,184,248,200,63,60,180,41,188,166,23,185,63,159,113,189,255,249,165,161,60,43,180,41,188,166,23,185,191,14,166,105,60,184,248,200,191,1,159,213,46,6,148,210,191,97,169,174,166,226,125,216,191,59,246,6,56,93,43,222,191,198,104,174,57,59,199,225,191,212,29,9,37,243,76,228,191,204,59,127,102,158,160,230,191,62,23,21,107,128,188,232,191,163,161,14,41,102,155,234,191,176,189,128,241,178,56,236,191,68,141,50,207,107,144,237,191,218,45,198,86,65,159,238,191,175,92,247,207,151,98,239,191,38,37,209,163,141,216,239,191,0,0,0,0,0,0,240,191,38,37,209,163,141,216,239,191,176,92,247,207,151,98,239,191,219,45,198,86,65,159,238,191,69,141,50,207,107,144,237,191,177,189,128,241,178,56,236,191,165,161,14,41,102,155,234,191,64,23,21,107,128,188,232,191,206,59,127,102,158,160,230,191,218,29,9,37,243,76,228,191,200,104,174,57,59,199,225,191,64,246,6,56,93,43,222,191,110,169,174,166,226,125,216,191,8,159,213,46,6,148,210,191,27,166,105,60,184,248,200,191,37,180,41,188,166,23,185,191,220,71,2,0,119,238,2,0,144,93,0,0,0,0,0,0,220,71,2,0,185,238,2,0,208,93,0,0,0,0,0,0,180,71,2,0,117,253,2,0,180,71,2,0,21,10,3,0,220,71,2,0,116,1,3,0,16,42,0,0,0,0,0,0,220,71,2,0,8,1,3,0,16,42,0,0,0,0,0,0,220,71,2,0,94,1,3,0,16,42,0,0,0,0,0,0,220,71,2,0,246,2,3,0,16,42,0,0,0,0,0,0,220,71,2,0,225,5,3,0,16,42,0,0,0,0,0,0,220,71,2,0,24,4,3,0,16,42,0,0,0,0,0,0,220,71,2,0,151,6,3,0,16,42,0,0,0,0,0,0,220,71,2,0,33,10,3,0,16,42,0,0,0,0,0,0,220,71,2,0,176,10,3,0,16,42,0,0,0,0,0,0,180,71,2,0,101,40,3,0,220,71,2,0,2,19,3,0,128,36,0,0,0,0,0,0,60,0,0,0,0,0,0,0,160,93,0,0,49,0,0,0,50,0,0,0,196,255,255,255,196,255,255,255,160,93,0,0,51,0,0,0,52,0,0,0,220,71,2,0,121,26,3,0,160,93,0,0,0,0,0,0,180,71,2,0,222,66,3,0,49,244,70,62,15,206,131,63,71,85,215,212,68,5,132,63,150,24,1,83,20,61,132,63,240,209,204,101,127,117,132,63,186,20,239,190,135,174,132,63,248,121,213,20,47,232,132,63,157,202,179,34,119,34,133,63,157,78,145,168,97,93,133,63,12,65,86,107,240,152,133,63,195,105,217,52,37,213,133,63,241,220,237,211,1,18,134,63,251,224,112,28,136,79,134,63,26,251,87,231,185,141,134,63,41,35,191,18,153,204,134,63,3,31,247,129,39,12,135,63,238,5,148,29,103,76,135,63,113,236,123,211,89,141,135,63,28,185,245,150,1,207,135,63,164,34,184,96,96,17,136,63,192,215,248,46,120,84,136,63,87,209,123,5,75,152,136,63,90,207,162,237,218,220,136,63,197,0,125,246,41,34,137,63,87,215,214,52,58,104,137,63,85,7,74,195,13,175,137,63,241,179,77,194,166,246,137,63,199,200,70,88,7,63,138,63,236,128,152,177,49,136,138,63,15,28,181,0,40,210,138,63,43,194,46,126,236,28,139,63,87,150,200,104,129,104,139,63,34,249,135,5,233,180,139,63,22,251,197,159,37,2,140,63,215,255,64,137,57,80,140,63,117,146,46,26,39,159,140,63,103,107,77,177,240,238,140,63,204,168,247,179,152,63,141,63,114,57,53,142,33,145,141,63,62,123,206,178,141,227,141,63,105,13,95,155,223,54,142,63,71,215,104,200,25,139,142,63,18,68,103,193,62,224,142,63,77,180,226,20,81,54,143,63,95,37,132,88,83,141,143,63,249,15,41,41,72,229,143,63,242,190,123,21,25,31,144,63,223,43,185,4,10,76,144,63,173,245,198,59,120,121,144,63,177,85,226,23,101,167,144,63,92,20,22,250,209,213,144,63,48,35,69,71,192,4,145,63,65,84,53,104,49,52,145,63,151,47,154,201,38,100,145,63,190,230,31,220,161,148,145,63,229,102,118,20,164,197,145,63,208,137,92,235,46,247,145,63,8,102,171,221,67,41,146,63,142,190,97,108,228,91,146,63,109,146,175,28,18,143,146,63,136,204,1,120,206,194,146,63,5,20,14,12,27,247,146,63,151,189,222,106,249,43,147,63,33,222,222,42,107,97,147,63,249,126,230,230,113,151,147,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,191,220,71,2,0,130,82,3,0,8,42,0,0,0,0,0,0,220,71,2,0,60,83,3,0,8,42,0,0,0,0,0,0,220,71,2,0,244,83,3,0,8,42,0,0,0,0,0,0,220,71,2,0,244,84,3,0,8,42,0,0,0,0,0,0,220,71,2,0,243,85,3,0,8,42,0,0,0,0,0,0,220,71,2,0,253,86,3,0,8,42,0,0,0,0,0,0,220,71,2,0,170,87,3,0,8,42,0,0,0,0,0,0,220,71,2,0,85,88,3,0,8,42,0,0,0,0,0,0,220,71,2,0,93,89,3,0,8,42,0,0,0,0,0,0,220,71,2,0,26,90,3,0,8,42,0,0,0,0,0,0,220,71,2,0,213,90,3,0,8,42,0,0,0,0,0,0,220,71,2,0,206,91,3,0,8,42,0,0,0,0,0,0,220,71,2,0,198,92,3,0,8,42,0,0,0,0,0,0,220,71,2,0,205,93,3,0,8,42,0,0,0,0,0,0,220,71,2,0,148,94,3,0,8,42,0,0,0,0,0,0,220,71,2,0,89,95,3,0,8,42,0,0,0,0,0,0,220,71,2,0,112,96,3,0,8,42,0,0,0,0,0,0,220,71,2,0,55,97,3,0,8,42,0,0,0,0,0,0,220,71,2,0,252,97,3,0,8,42,0,0,0,0,0,0,220,71,2,0,15,99,3,0,8,42,0,0,0,0,0,0,220,71,2,0,207,99,3,0,8,42,0,0,0,0,0,0,220,71,2,0,141,100,3,0,8,42,0,0,0,0,0,0,220,71,2,0,151,101,3,0,8,42,0,0,0,0,0,0,220,71,2,0,87,102,3,0,8,42,0,0,0,0,0,0,220,71,2,0,21,103,3,0,8,42,0,0,0,0,0,0,220,71,2,0,57,104,3,0,8,42,0,0,0,0,0,0,220,71,2,0,213,104,3,0,8,42,0,0,0,0,0,0,220,71,2,0,113,105,3,0,8,42,0,0,0,0,0,0,220,71,2,0,13,106,3,0,8,42,0,0,0,0,0,0,220,71,2,0,17,107,3,0,8,42,0,0,0,0,0,0,220,71,2,0,173,107,3,0,8,42,0,0,0,0,0,0,220,71,2,0,73,108,3,0,8,42,0,0,0,0,0,0,220,71,2,0,229,108,3,0,8,42,0,0,0,0,0,0,220,71,2,0,233,109,3,0,8,42,0,0,0,0,0,0,220,71,2,0,133,110,3,0,8,42,0,0,0,0,0,0,220,71,2,0,237,111,3,0,8,42,0,0,0,0,0,0,220,71,2,0,241,112,3,0,8,42,0,0,0,0,0,0,220,71,2,0,128,114,3,0,8,42,0,0,0,0,0,0,220,71,2,0,28,115,3,0,8,42,0,0,0,0,0,0,220,71,2,0,197,115,3,0,8,42,0,0,0,0,0,0,220,71,2,0,97,116,3,0,8,42,0,0,0,0,0,0,220,71,2,0,51,117,3,0,8,42,0,0,0,0,0,0,220,71,2,0,93,117,3,0,8,42,0,0,0,0,0,0,220,71,2,0,135,117,3,0,8,42,0,0,0,0,0,0,220,71,2,0,177,117,3,0,8,42,0,0,0,0,0,0,220,71,2,0,219,117,3,0,8,42,0,0,0,0,0,0,220,71,2,0,3,118,3,0,8,42,0,0,0,0,0,0,220,71,2,0,43,118,3,0,8,42,0,0,0,0,0,0,220,71,2,0,83,118,3,0,8,42,0,0,0,0,0,0,220,71,2,0,104,119,3,0,8,42,0,0,0,0,0,0,220,71,2,0,141,119,3,0,8,42,0,0,0,0,0,0,220,71,2,0,178,119,3,0,8,42,0,0,0,0,0,0,220,71,2,0,213,119,3,0,8,42,0,0,0,0,0,0,220,71,2,0,94,120,3,0,8,42,0,0,0,0,0,0,220,71,2,0,246,120,3,0,8,42,0,0,0,0,0,0,220,71,2,0,35,121,3,0,8,42,0,0,0,0,0,0,220,71,2,0,80,121,3,0,8,42,0,0,0,0,0,0,220,71,2,0,125,121,3,0,8,42,0,0,0,0,0,0,220,71,2,0,170,121,3,0,8,42,0,0,0,0,0,0,220,71,2,0,215,121,3,0,8,42,0,0,0,0,0,0,220,71,2,0,4,122,3,0,8,42,0,0,0,0,0,0,220,71,2,0,47,122,3,0,8,42,0,0,0,0,0,0,220,71,2,0,90,122,3,0,8,42,0,0,0,0,0,0,220,71,2,0,133,122,3,0,8,42,0,0,0,0,0,0,220,71,2,0,176,122,3,0,8,42,0,0,0,0,0,0,220,71,2,0,219,122,3,0,8,42,0,0,0,0,0,0,220,71,2,0,0,124,3,0,8,42,0,0,0,0,0,0,220,71,2,0,26,125,3,0,8,42,0,0,0,0,0,0,220,71,2,0,167,133,3,0,8,42,0,0,0,0,0,0,220,71,2,0,207,133,3,0,8,42,0,0,0,0,0,0,220,71,2,0,245,133,3,0,8,42,0,0,0,0,0,0,220,71,2,0,182,145,3,0,8,42,0,0,0,0,0,0,220,71,2,0,208,145,3,0,8,42,0,0,0,0,0,0,220,71,2,0,94,151,3,0,8,42,0,0,0,0,0,0,220,71,2,0,170,151,3,0,8,42,0,0,0,0,0,0,220,71,2,0,244,151,3,0,8,42,0,0,0,0,0,0,220,71,2,0,61,152,3,0,8,42,0,0,0,0,0,0,220,71,2,0,146,152,3,0,8,42,0,0,0,0,0,0,220,71,2,0,58,153,3,0,8,42,0,0,0,0,0,0,220,71,2,0,139,153,3,0,8,42,0,0,0,0,0,0,220,71,2,0,218,153,3,0,8,42,0,0,0,0,0,0,220,71,2,0,40,154,3,0,8,42,0,0,0,0,0,0,220,71,2,0,130,154,3,0,8,42,0,0,0,0,0,0,220,71,2,0,105,157,3,0,8,42,0,0,0,0,0,0,220,71,2,0,247,157,3,0,8,42,0,0,0,0,0,0,220,71,2,0,61,160,3,0,128,36,0,0,0,0,0,0,220,71,2,0,130,160,3,0,240,53,0,0,0,0,0,0,220,71,2,0,147,160,3,0,128,36,0,0,0,0,0,0,220,71,2,0,216,160,3,0,240,53,0,0,0,0,0,0,220,71,2,0,233,160,3,0,128,36,0,0,0,0,0,0,220,71,2,0,46,161,3,0,240,53,0,0,0,0,0,0,220,71,2,0,63,161,3,0,128,36,0,0,0,0,0,0,220,71,2,0,132,161,3,0,240,53,0,0,0,0,0,0,220,71,2,0,149,161,3,0,128,36,0,0,0,0,0,0,220,71,2,0,218,161,3,0,240,53,0,0,0,0,0,0,220,71,2,0,235,161,3,0,128,36,0,0,0,0,0,0,220,71,2,0,48,162,3,0,240,53,0,0,0,0,0,0,220,71,2,0,65,162,3,0,128,36,0,0,0,0,0,0,220,71,2,0,134,162,3,0,240,53,0,0,0,0,0,0,220,71,2,0,151,162,3,0,128,36,0,0,0,0,0,0,220,71,2,0,220,162,3,0,240,53,0,0,0,0,0,0,220,71,2,0,237,162,3,0,128,36,0,0,0,0,0,0,220,71,2,0,50,163,3,0,240,53,0,0,0,0,0,0,220,71,2,0,67,163,3,0,128,36,0,0,0,0,0,0,220,71,2,0,136,163,3,0,240,53,0,0,0,0,0,0,220,71,2,0,81,164,3,0,128,36,0,0,0,0,0,0,220,71,2,0,173,164,3,0,248,53,0,0,0,0,0,0,220,71,2,0,193,164,3,0,128,36,0,0,0,0,0,0,220,71,2,0,9,165,3,0,248,53,0,0,0,0,0,0,220,71,2,0,29,165,3,0,128,36,0,0,0,0,0,0,220,71,2,0,101,165,3,0,248,53,0,0,0,0,0,0,220,71,2,0,121,165,3,0,128,36,0,0,0,0,0,0,220,71,2,0,193,165,3,0,248,53,0,0,0,0,0,0,220,71,2,0,213,165,3,0,128,36,0,0,0,0,0,0,220,71,2,0,29,166,3,0,248,53,0,0,0,0,0,0,220,71,2,0,49,166,3,0,128,36,0,0,0,0,0,0,220,71,2,0,121,166,3,0,248,53,0,0,0,0,0,0,220,71,2,0,141,166,3,0,128,36,0,0,0,0,0,0,220,71,2,0,213,166,3,0,248,53,0,0,0,0,0,0,220,71,2,0,233,166,3,0,128,36,0,0,0,0,0,0,220,71,2,0,49,167,3,0,248,53,0,0,0,0,0,0,220,71,2,0,69,167,3,0,128,36,0,0,0,0,0,0,220,71,2,0,141,167,3,0,248,53,0,0,0,0,0,0,220,71,2,0,161,167,3,0,128,36,0,0,0,0,0,0,220,71,2,0,233,167,3,0,248,53,0,0,0,0,0,0,220,71,2,0,253,167,3,0,128,36,0,0,0,0,0,0,220,71,2,0,69,168,3,0,248,53,0,0,0,0,0,0,220,71,2,0,89,168,3,0,128,36,0,0,0,0,0,0,220,71,2,0,161,168,3,0,248,53,0,0,0,0,0,0,220,71,2,0,181,168,3,0,128,36,0,0,0,0,0,0,220,71,2,0,146,169,3,0,128,36,0,0,0,0,0,0,220,71,2,0,218,169,3,0,240,53,0,0,0,0,0,0,220,71,2,0,238,169,3,0,128,36,0,0,0,0,0,0,220,71,2,0,54,170,3,0,240,53,0,0,0,0,0,0,220,71,2,0,74,170,3,0,128,36,0,0,0,0,0,0,220,71,2,0,146,170,3,0,240,53,0,0,0,0,0,0,220,71,2,0,166,170,3,0,128,36,0,0,0,0,0,0,220,71,2,0,238,170,3,0,240,53,0,0,0,0,0,0,220,71,2,0,2,171,3,0,128,36,0,0,0,0,0,0,220,71,2,0,74,171,3,0,240,53,0,0,0,0,0,0,220,71,2,0,253,174,3,0,8,42,0,0,0,0,0,0,220,71,2,0,32,175,3,0,8,42,0,0,0,0,0,0,180,71,2,0,62,176,3,0,180,71,2,0,83,176,3,0,180,71,2,0,107,176,3,0,180,71,2,0,100,178,3,0,220,71,2,0,13,180,3,0,128,36,0,0,0,0,0,0,220,71,2,0,186,180,3,0,240,53,0,0,0,0,0,0,220,71,2,0,219,180,3,0,128,36,0,0,0,0,0,0,220,71,2,0,48,181,3,0,240,53,0,0,0,0,0,0,220,71,2,0,81,181,3,0,128,36,0,0,0,0,0,0,220,71,2,0,166,181,3,0,240,53,0,0,0,0,0,0,220,71,2,0,199,181,3,0,128,36,0,0,0,0,0,0,220,71,2,0,28,182,3,0,240,53,0,0,0,0,0,0,220,71,2,0,61,182,3,0,128,36,0,0,0,0,0,0,220,71,2,0,146,182,3,0,240,53,0,0,0,0,0,0,220,71,2,0,179,182,3,0,128,36,0,0,0,0,0,0,220,71,2,0,8,183,3,0,240,53,0,0,0,0,0,0,220,71,2,0,41,183,3,0,128,36,0,0,0,0,0,0,220,71,2,0,126,183,3,0,240,53,0,0,0,0,0,0,220,71,2,0,159,183,3,0,128,36,0,0,0,0,0,0,220,71,2,0,244,183,3,0,240,53,0,0,0,0,0,0,220,71,2,0,21,184,3,0,128,36,0,0,0,0,0,0,220,71,2,0,106,184,3,0,240,53,0,0,0,0,0,0,220,71,2,0,139,184,3,0,128,36,0,0,0,0,0,0,220,71,2,0,224,184,3,0,240,53,0,0,0,0,0,0,220,71,2,0,1,185,3,0,128,36,0,0,0,0,0,0,220,71,2,0,210,185,3,0,240,53,0,0,0,0,0,0,220,71,2,0,253,185,3,0,96,55,0,0,0,0,0,0,220,71,2,0,50,186,3,0,128,36,0,0,0,0,0,0,220,71,2,0,155,186,3,0,240,53,0,0,0,0,0,0,220,71,2,0,198,186,3,0,144,55,0,0,0,0,0,0,220,71,2,0,204,187,3,0,128,36,0,0,0,0,0,0,220,71,2,0,138,188,3,0,248,53,0,0,0,0,0,0,220,71,2,0,190,188,3,0,192,55,0,0,0,0,0,0,220,71,2,0,246,188,3,0,128,36,0,0,0,0,0,0,220,71,2,0,98,189,3,0,248,53,0,0,0,0,0,0,220,71,2,0,150,189,3,0,240,55,0,0,0,0,0,0,220,71,2,0,206,189,3,0,128,36,0,0,0,0,0,0,220,71,2,0,58,190,3,0,248,53,0,0,0,0,0,0,220,71,2,0,110,190,3,0,32,56,0,0,0,0,0,0,220,71,2,0,166,190,3,0,128,36,0,0,0,0,0,0,220,71,2,0,18,191,3,0,248,53,0,0,0,0,0,0,220,71,2,0,70,191,3,0,80,56,0,0,0,0,0,0,220,71,2,0,126,191,3,0,128,36,0,0,0,0,0,0,220,71,2,0,234,191,3,0,248,53,0,0,0,0,0,0,220,71,2,0,30,192,3,0,128,56,0,0,0,0,0,0,220,71,2,0,177,192,3,0,128,36,0,0,0,0,0,0,220,71,2,0,29,193,3,0,248,53,0,0,0,0,0,0,220,71,2,0,81,193,3,0,176,56,0,0,0,0,0,0,220,71,2,0,137,193,3,0,128,36,0,0,0,0,0,0,220,71,2,0,245,193,3,0,248,53,0,0,0,0,0,0,220,71,2,0,41,194,3,0,224,56,0,0,0,0,0,0,220,71,2,0,97,194,3,0,128,36,0,0,0,0,0,0,220,71,2,0,205,194,3,0,248,53,0,0,0,0,0,0,220,71,2,0,1,195,3,0,16,57,0,0,0,0,0,0,220,71,2,0,57,195,3,0,128,36,0,0,0,0,0,0,220,71,2,0,165,195,3,0,248,53,0,0,0,0,0,0,220,71,2,0,217,195,3,0,64,57,0,0,0,0,0,0,220,71,2,0,17,196,3,0,128,36,0,0,0,0,0,0,220,71,2,0,135,196,3,0,248,53,0,0,0,0,0,0,220,71,2,0,197,196,3,0,112,57,0,0,0,0,0,0,220,71,2,0,7,197,3,0,128,36,0,0,0,0,0,0,220,71,2,0,168,197,3,0,248,53,0,0,0,0,0,0,220,71,2,0,229,197,3,0,192,57,0,0,0,0,0,0,220,71,2,0,43,198,3,0,160,57,0,0,0,0,0,0,220,71,2,0,108,198,3,0,128,36,0,0,0,0,0,0,220,71,2,0,230,198,3,0,248,53,0,0,0,0,0,0,220,71,2,0,35,199,3,0,0,58,0,0,0,0,0,0,220,71,2,0,105,199,3,0,224,57,0,0,0,0,0,0,220,71,2,0,170,199,3,0,128,36,0,0,0,0,0,0,220,71,2,0,37,200,3,0,128,57,0,0,0,0,0,0,220,71,2,0,108,200,3,0,128,36,0,0,0,0,0,0,220,71,2,0,212,200,3,0,128,36,0,0,0,0,0,0,220,71,2,0,60,201,3,0,128,36,0,0,0,0,0,0,220,71,2,0,164,201,3,0,128,36,0,0,0,0,0,0,220,71,2,0,12,202,3,0,128,36,0,0,0,0,0,0,220,71,2,0,116,202,3,0,128,36,0,0,0,0,0,0,220,71,2,0,220,202,3,0,128,36,0,0,0,0,0,0,220,71,2,0,68,203,3,0,128,36,0,0,0,0,0,0,220,71,2,0,172,203,3,0,128,36,0,0,0,0,0,0,220,71,2,0,88,205,3,0,128,36,0,0,0,0,0,0,220,71,2,0,234,205,3,0,0,54,0,0,0,0,0,0,220,71,2,0,26,206,3,0,128,36,0,0,0,0,0,0,220,71,2,0,126,206,3,0,0,54,0,0,0,0,0,0,220,71,2,0,174,206,3,0,128,36,0,0,0,0,0,0,220,71,2,0,18,207,3,0,0,54,0,0,0,0,0,0,220,71,2,0,66,207,3,0,128,36,0,0,0,0,0,0,220,71,2,0,166,207,3,0,0,54,0,0,0,0,0,0,220,71,2,0,214,207,3,0,128,36,0,0,0,0,0,0,220,71,2,0,58,208,3,0,0,54,0,0,0,0,0,0,220,71,2,0,106,208,3,0,128,36,0,0,0,0,0,0,220,71,2,0,206,208,3,0,0,54,0,0,0,0,0,0,220,71,2,0,254,208,3,0,128,36,0,0,0,0,0,0,220,71,2,0,98,209,3,0,0,54,0,0,0,0,0,0,220,71,2,0,146,209,3,0,128,36,0,0,0,0,0,0,220,71,2,0,246,209,3,0,0,54,0,0,0,0,0,0,220,71,2,0,38,210,3,0,128,36,0,0,0,0,0,0,220,71,2,0,138,210,3,0,0,54,0,0,0,0,0,0,220,71,2,0,186,210,3,0,128,36,0,0,0,0,0,0,220,71,2,0,30,211,3,0,0,54,0,0,0,0,0,0,220,71,2,0,78,211,3,0,128,36,0,0,0,0,0,0,220,71,2,0,178,211,3,0,0,54,0,0,0,0,0,0,220,71,2,0,226,211,3,0,128,36,0,0,0,0,0,0,220,71,2,0,70,212,3,0,0,54,0,0,0,0,0,0,220,71,2,0,118,212,3,0,128,36,0,0,0,0,0,0,220,71,2,0,218,212,3,0,0,54,0,0,0,0,0,0,220,71,2,0,167,223,3,0,8,42,0,0,0,0,0,0,220,71,2,0,73,229,3,0,128,36,0,0,0,0,0,0,220,71,2,0,177,231,3,0,8,42,0,0,0,0,0,0,220,71,2,0,70,232,3,0,8,42,0,0,0,0,0,0,220,71,2,0,178,232,3,0,8,42,0,0,0,0,0,0,220,71,2,0,30,233,3,0,8,42,0,0,0,0,0,0,220,71,2,0,138,233,3,0,8,42,0,0,0,0,0,0,220,71,2,0,3,234,3,0,8,42,0,0,0,0,0,0,220,71,2,0,135,234,3,0,8,42,0,0,0,0,0,0,220,71,2,0,11,235,3,0,8,42,0,0,0,0,0,0,220,71,2,0,143,235,3,0,8,42,0,0,0,0,0,0,220,71,2,0,19,236,3,0,8,42,0,0,0,0,0,0,220,71,2,0,167,236,3,0,8,42,0,0,0,0,0,0,220,71,2,0,25,237,3,0,8,42,0,0,0,0,0,0,220,71,2,0,139,237,3,0,8,42,0,0,0,0,0,0,220,71,2,0,253,237,3,0,8,42,0,0,0,0,0,0,220,71,2,0,111,238,3,0,8,42,0,0,0,0,0,0,220,71,2,0,238,238,3,0,8,42,0,0,0,0,0,0,220,71,2,0,12,239,3,0,8,42,0,0,0,0,0,0,220,71,2,0,42,239,3,0,8,42,0,0,0,0,0,0,220,71,2,0,72,239,3,0,8,42,0,0,0,0,0,0,220,71,2,0,102,239,3,0,8,42,0,0,0,0,0,0,220,71,2,0,132,239,3,0,8,42,0,0,0,0,0,0,220,71,2,0,195,239,3,0,8,42,0,0,0,0,0,0,220,71,2,0,10,240,3,0,8,42,0,0,0,0,0,0,220,71,2,0,99,240,3,0,8,42,0,0,0,0,0,0,220,71,2,0,188,240,3,0,8,42,0,0,0,0,0,0,220,71,2,0,21,241,3,0,8,42,0,0,0,0,0,0,220,71,2,0,44,241,3,0,8,42,0,0,0,0,0,0,220,71,2,0,110,241,3,0,8,42,0,0,0,0,0,0,220,71,2,0,176,241,3,0,8,42,0,0,0,0,0,0,220,71,2,0,243,241,3,0,8,42,0,0,0,0,0,0,220,71,2,0,53,242,3,0,8,42,0,0,0,0,0,0,220,71,2,0,131,248,3,0,128,36,0,0,0,0,0,0,220,71,2,0,239,248,3,0,240,53,0,0,0,0,0,0,220,71,2,0,39,249,3,0,128,36,0,0,0,0,0,0,220,71,2,0,147,249,3,0,240,53,0,0,0,0,0,0,220,71,2,0,203,249,3,0,128,36,0,0,0,0,0,0,220,71,2,0,55,250,3,0,240,53,0,0,0,0,0,0,220,71,2,0,111,250,3,0,128,36,0,0,0,0,0,0,220,71,2,0,219,250,3,0,240,53,0,0,0,0,0,0,220,71,2,0,19,251,3,0,128,36,0,0,0,0,0,0,220,71,2,0,127,251,3,0,240,53,0,0,0,0,0,0,220,71,2,0,183,251,3,0,128,36,0,0,0,0,0,0,220,71,2,0,35,252,3,0,240,53,0,0,0,0,0,0,220,71,2,0,91,252,3,0,128,36,0,0,0,0,0,0,220,71,2,0,199,252,3,0,240,53,0,0,0,0,0,0,220,71,2,0,255,252,3,0,128,36,0,0,0,0,0,0,220,71,2,0,107,253,3,0,240,53,0,0,0,0,0,0,220,71,2,0,163,253,3,0,128,36,0,0,0,0,0,0,220,71,2,0,15,254,3,0,240,53,0,0,0,0,0,0,220,71,2,0,71,254,3,0,128,36,0,0,0,0,0,0,220,71,2,0,179,254,3,0,240,53,0,0,0,0,0,0,220,71,2,0,5,255,3,0,128,36,0,0,0,0,0,0,220,71,2,0,119,255,3,0,248,53,0,0,0,0,0,0,220,71,2,0,181,255,3,0,128,36,0,0,0,0,0,0,220,71,2,0,39,0,4,0,248,53,0,0,0,0,0,0,220,71,2,0,101,0,4,0,128,36,0,0,0,0,0,0,220,71,2,0,215,0,4,0,248,53,0,0,0,0,0,0,220,71,2,0,21,1,4,0,128,36,0,0,0,0,0,0,220,71,2,0,135,1,4,0,248,53,0,0,0,0,0,0,220,71,2,0,197,1,4,0,128,36,0,0,0,0,0,0,220,71,2,0,55,2,4,0,248,53,0,0,0,0,0,0,220,71,2,0,117,2,4,0,128,36,0,0,0,0,0,0,220,71,2,0,231,2,4,0,248,53,0,0,0,0,0,0,220,71,2,0,37,3,4,0,128,36,0,0,0,0,0,0,220,71,2,0,151,3,4,0,248,53,0,0,0,0,0,0,220,71,2,0,213,3,4,0,128,36,0,0,0,0,0,0,220,71,2,0,71,4,4,0,248,53,0,0,0,0,0,0,220,71,2,0,133,4,4,0,128,36,0,0,0,0,0,0,220,71,2,0,247,4,4,0,248,53,0,0,0,0,0,0,220,71,2,0,53,5,4,0,128,36,0,0,0,0,0,0,220,71,2,0,167,5,4,0,248,53,0,0,0,0,0,0,220,71,2,0,139,6,4,0,128,36,0,0,0,0,0,0,220,71,2,0,17,7,4,0,0,54,0,0,0,0,0,0,220,71,2,0,67,7,4,0,128,36,0,0,0,0,0,0,220,71,2,0,169,7,4,0,0,54,0,0,0,0,0,0,220,71,2,0,219,7,4,0,128,36,0,0,0,0,0,0,220,71,2,0,65,8,4,0,0,54,0,0,0,0,0,0,220,71,2,0,115,8,4,0,128,36,0,0,0,0,0,0,220,71,2,0,217,8,4,0,0,54,0,0,0,0,0,0,220,71,2,0,11,9,4,0,128,36,0,0,0,0,0,0,220,71,2,0,113,9,4,0,0,54,0,0,0,0,0,0,220,71,2,0,163,9,4,0,128,36,0,0,0,0,0,0,220,71,2,0,9,10,4,0,0,54,0,0,0,0,0,0,220,71,2,0,59,10,4,0,128,36,0,0,0,0,0,0,220,71,2,0,161,10,4,0,0,54,0,0,0,0,0,0,220,71,2,0,211,10,4,0,128,36,0,0,0,0,0,0,220,71,2,0,57,11,4,0,0,54,0,0,0,0,0,0,220,71,2,0,107,11,4,0,128,36,0,0,0,0,0,0,220,71,2,0,209,11,4,0,0,54,0,0,0,0,0,0,220,71,2,0,3,12,4,0,128,36,0,0,0,0,0,0,220,71,2,0,105,12,4,0,0,54,0,0,0,0,0,0,220,71,2,0,131,17,4,0,8,42,0,0,0,0,0,0,220,71,2,0,206,17,4,0,8,42,0,0,0,0,0,0,220,71,2,0,25,18,4,0,8,42,0,0,0,0,0,0,220,71,2,0,88,18,4,0,8,42,0,0,0,0,0,0,220,71,2,0,151,18,4,0,8,42,0,0,0,0,0,0,220,71,2,0,215,18,4,0,8,42,0,0,0,0,0,0,220,71,2,0,194,25,4,0,128,36,0,0,0,0,0,0,220,71,2,0,159,29,4,0,208,35,0,0,0,0,0,0,220,71,2,0,224,26,4,0,128,36,0,0,0,0,0,0,220,71,2,0,71,27,4,0,8,42,0,0,0,0,0,0,220,71,2,0,121,27,4,0,128,36,0,0,0,0,0,0,220,71,2,0,224,27,4,0,8,42,0,0,0,0,0,0,220,71,2,0,18,28,4,0,128,36,0,0,0,0,0,0,220,71,2,0,123,28,4,0,8,42,0,0,0,0,0,0,220,71,2,0,175,28,4,0,128,36,0,0,0,0,0,0,220,71,2,0,22,29,4,0,8,42,0,0,0,0,0,0,220,71,2,0,52,32,4,0,8,42,0,0,0,0,0,0,220,71,2,0,193,32,4,0,8,42,0,0,0,0,0,0,220,71,2,0,248,33,4,0,8,42,0,0,0,0,0,0,220,71,2,0,244,35,4,0,128,36,0,0,0,0,0,0,220,71,2,0,85,39,4,0,8,42,0,0,0,0,0,0,220,71,2,0,105,39,4,0,8,42,0,0,0,0,0,0,180,71,2,0,141,80,5,0,180,71,2,0,130,89,5,0,220,71,2,0,39,81,5,0,8,42,0,0,0,0,0,0,220,71,2,0,32,86,5,0,8,42,0,0,0,0,0,0,180,71,2,0,209,90,5,0,220,71,2,0,178,89,5,0,128,36,0,0,0,0,0,0,220,71,2,0,119,93,5,0,192,67,0,0,0,0,0,0,220,71,2,0,56,92,5,0,128,36,0,0,0,0,0,0,220,71,2,0,135,92,5,0,128,36,0,0,0,0,0,0,220,71,2,0,1,93,5,0,128,36,0,0,0,0,0,0,220,71,2,0,209,94,5,0,192,67,0,0,0,0,0,0,220,71,2,0,150,93,5,0,128,36,0,0,0,0,0,0,220,71,2,0,222,93,5,0,128,36,0,0,0,0,0,0,220,71,2,0,87,94,5,0,128,36,0,0,0,0,0,0,220,71,2,0,137,103,5,0,136,68,0,0,0,0,0,0,220,71,2,0,0,99,5,0,8,42,0,0,0,0,0,0,220,71,2,0,98,102,5,0,128,36,0,0,0,0,0,0,220,71,2,0,166,103,5,0,248,42,0,0,0,0,0,0,220,71,2,0,55,104,5,0,128,36,0,0,0,0,0,0,220,71,2,0,119,118,5,0,8,42,0,0,0,0,0,0,220,71,2,0,0,119,5,0,8,42,0,0,0,0,0,0,220,71,2,0,218,119,5,0,128,36,0,0,0,0,0,0,220,71,2,0,173,121,5,0,232,68,0,0,0,0,0,0,220,71,2,0,219,121,5,0,248,68,0,0,0,0,0,0,220,71,2,0,247,121,5,0,248,42,0,0,0,0,0,0,220,71,2,0,32,124,5,0,8,42,0,0,0,0,0,0,220,71,2,0,15,125,5,0,128,36,0,0,0,0,0,0,220,71,2,0,247,128,5,0,56,69,0,0,0,0,0,0,220,71,2,0,39,129,5,0,72,69,0,0,0,0,0,0,220,71,2,0,69,129,5,0,248,42,0,0,0,0,0,0,220,71,2,0,237,141,5,0,152,35,0,0,0,0,0,0,220,71,2,0,33,140,5,0,8,42,0,0,0,0,0,0,220,71,2,0,17,142,5,0,128,36,0,0,0,0,0,0,220,71,2,0,63,144,5,0,248,42,0,0,0,0,0,0,220,71,2,0,232,145,5,0,128,36,0,0,0,0,0,0,220,71,2,0,93,146,5,0,128,36,0,0,0,0,0,0,220,71,2,0,219,146,5,0,136,69,0,0,0,0,0,0,220,71,2,0,195,155,5,0,136,69,0,0,0,0,0,0,220,71,2,0,152,155,5,0,136,69,0,0,0,0,0,0,220,71,2,0,104,155,5,0,136,69,0,0,0,0,0,0,220,71,2,0,59,155,5,0,136,69,0,0,0,0,0,0,220,71,2,0,213,154,5,0,56,70,0,0,0,0,0,0,220,71,2,0,168,154,5,0,136,69,0,0,0,0,0,0,220,71,2,0,124,154,5,0,136,69,0,0,0,0,0,0,220,71,2,0,6,155,5,0,136,69,0,0,0,0,0,0,220,71,2,0,193,170,5,0,120,70,0,0,0,0,0,0,140,72,2,0,237,169,5,0,0,0,0,0,1,0,0,0,112,70,0,0,0,0,0,0,180,71,2,0,103,170,5,0,180,71,2,0,160,171,5,0,64,0,0,0,0,0,0,0,0,94,0,0,208,2,0,0,209,2,0,0,56,0,0,0,248,255,255,255,0,94,0,0,210,2,0,0,211,2,0,0,192,255,255,255,192,255,255,255,0,94,0,0,212,2,0,0,213,2,0,0,0,0,0,0,64,0,0,0,0,0,0,0,160,93,0,0,49,0,0,0,50,0,0,0,192,255,255,255,192,255,255,255,160,93,0,0,51,0,0,0,52,0,0,0,56,0,0,0,0,0,0,0,208,93,0,0,214,2,0,0,215,2,0,0,200,255,255,255,200,255,255,255,208,93,0,0,216,2,0,0,217,2,0,0,220,71,2,0,128,177,5,0,0,94,0,0,0,0,0,0,220,71,2,0,247,186,5,0,128,36,0,0,0,0,0,0,220,71,2,0,192,188,5,0,128,36,0,0,0,0,0,0,108,0,0,0,0,0,0,0,160,93,0,0,49,0,0,0,50,0,0,0,148,255,255,255,148,255,255,255,160,93,0,0,51,0,0,0,52,0,0,0,220,71,2,0,170,206,5,0,144,93,0,0,0,0,0,0,220,71,2,0,217,206,5,0,160,93,0,0,0,0,0,0,220,71,2,0,62,209,5,0,248,90,0,0,0,0,0,0,220,71,2,0,248,208,5,0,248,90,0,0,0,0,0,0,180,71,2,0,99,209,5,0,220,71,2,0,246,219,5,0,248,90,0,0,0,0,0,0,220,71,2,0,97,212,5,0,16,88,0,0,0,0,0,0,220,71,2,0,142,213,5,0,224,71,0,0,0,0,0,0,220,71,2,0,58,214,5,0,248,90,0,0,0,0,0,0,180,71,2,0,100,214,5,0,140,72,2,0,214,216,5,0,0,0,0,0,2,0,0,0,48,72,0,0,2,0,0,0,240,71,0,0,2,28,0,0,220,71,2,0,89,216,5,0,40,72,0,0,0,0,0,0,180,71,2,0,141,216,5,0,220,71,2,0,130,217,5,0,152,90,0,0,0,0,0,0,220,71,2,0,223,219,5,0,248,90,0,0,0,0,0,0,220,71,2,0,147,218,5,0,192,71,0,0,0,0,0,0,180,71,2,0,110,219,5,0,220,71,2,0,19,221,5,0,248,90,0,0,0,0,0,0,220,71,2,0,103,223,5,0,248,90,0,0,0,0,0,0,220,71,2,0,161,227,5,0,248,90,0,0,0,0,0,0,220,71,2,0,74,227,5,0,248,90,0,0,0,0,0,0,220,71,2,0,136,227,5,0,248,90,0,0,0,0,0,0,220,71,2,0,170,231,5,0,248,90,0,0,0,0,0,0,220,71,2,0,168,230,5,0,248,90,0,0,0,0,0,0,220,71,2,0,109,231,5,0,248,90,0,0,0,0,0,0,220,71,2,0,142,231,5,0,248,90,0,0,0,0,0,0,220,71,2,0,232,240,5,0,248,90,0,0,0,0,0,0,220,71,2,0,36,240,5,0,248,90,0,0,0,0,0,0,220,71,2,0,1,239,5,0,248,90,0,0,0,0,0,0,220,71,2,0,22,239,5,0,248,90,0,0,0,0,0,0,220,71,2,0,52,239,5,0,248,90,0,0,0,0,0,0,220,71,2,0,98,68,6,0,248,90,0,0,0,0,0,0,220,71,2,0,228,58,6,0,248,90,0,0,0,0,0,0,220,71,2,0,12,59,6,0,248,90,0,0,0,0,0,0,220,71,2,0,48,59,6,0,248,90,0,0,0,0,0,0,220,71,2,0,86,59,6,0,248,90,0,0,0,0,0,0,220,71,2,0,119,59,6,0,248,90,0,0,0,0,0,0,220,71,2,0,152,59,6,0,248,90,0,0,0,0,0,0,220,71,2,0,221,59,6,0,248,90,0,0,0,0,0,0,220,71,2,0,187,59,6,0,248,90,0,0,0,0,0,0,220,71,2,0,0,60,6,0,248,90,0,0,0,0,0,0,220,71,2,0,31,60,6,0,248,90,0,0,0,0,0,0,220,71,2,0,69,60,6,0,248,90,0,0,0,0,0,0,220,71,2,0,106,60,6,0,248,90,0,0,0,0,0,0,220,71,2,0,138,60,6,0,248,90,0,0,0,0,0,0,220,71,2,0,170,60,6,0,248,90,0,0,0,0,0,0,220,71,2,0,205,60,6,0,248,90,0,0,0,0,0,0,220,71,2,0,238,60,6,0,248,90,0,0,0,0,0,0,220,71,2,0,17,61,6,0,248,90,0,0,0,0,0,0,220,71,2,0,50,61,6,0,248,90,0,0,0,0,0,0,220,71,2,0,85,61,6,0,248,90,0,0,0,0,0,0,220,71,2,0,117,61,6,0,248,90,0,0,0,0,0,0,220,71,2,0,154,61,6,0,248,90,0,0,0,0,0,0,220,71,2,0,191,61,6,0,248,90,0,0,0,0,0,0,220,71,2,0,225,61,6,0,248,90,0,0,0,0,0,0,220,71,2,0,2,62,6,0,248,90,0,0,0,0,0,0,220,71,2,0,37,62,6,0,248,90,0,0,0,0,0,0,220,71,2,0,74,62,6,0,248,90,0,0,0,0,0,0,220,71,2,0,105,62,6,0,248,90,0,0,0,0,0,0,220,71,2,0,143,62,6,0,248,90,0,0,0,0,0,0,220,71,2,0,174,62,6,0,248,90,0,0,0,0,0,0,220,71,2,0,205,62,6,0,248,90,0,0,0,0,0,0,220,71,2,0,238,62,6,0,248,90,0,0,0,0,0,0,220,71,2,0,22,63,6,0,248,90,0,0,0,0,0,0,220,71,2,0,62,63,6,0,248,90,0,0,0,0,0,0,220,71,2,0,99,63,6,0,248,90,0,0,0,0,0,0,220,71,2,0,136,63,6,0,248,90,0,0,0,0,0,0,220,71,2,0,174,63,6,0,248,90,0,0,0,0,0,0,220,71,2,0,210,63,6,0,248,90,0,0,0,0,0,0,220,71,2,0,245,63,6,0,248,90,0,0,0,0,0,0,220,71,2,0,20,64,6,0,248,90,0,0,0,0,0,0,220,71,2,0,53,64,6,0,248,90,0,0,0,0,0,0,220,71,2,0,84,64,6,0,248,90,0,0,0,0,0,0,220,71,2,0,119,64,6,0,248,90,0,0,0,0,0,0,220,71,2,0,156,64,6,0,248,90,0,0,0,0,0,0,220,71,2,0,191,64,6,0,248,90,0,0,0,0,0,0,220,71,2,0,229,64,6,0,248,90,0,0,0,0,0,0,220,71,2,0,22,65,6,0,248,90,0,0,0,0,0,0,220,71,2,0,54,65,6,0,248,90,0,0,0,0,0,0,220,71,2,0,86,65,6,0,248,90,0,0,0,0,0,0,220,71,2,0,125,65,6,0,248,90,0,0,0,0,0,0,220,71,2,0,168,65,6,0,248,90,0,0,0,0,0,0,220,71,2,0,200,65,6,0,248,90,0,0,0,0,0,0,220,71,2,0,237,65,6,0,248,90,0,0,0,0,0,0,220,71,2,0,15,66,6,0,248,90,0,0,0,0,0,0,220,71,2,0,49,66,6,0,248,90,0,0,0,0,0,0,220,71,2,0,85,66,6,0,248,90,0,0,0,0,0,0,220,71,2,0,117,66,6,0,248,90,0,0,0,0,0,0,220,71,2,0,159,66,6,0,248,90,0,0,0,0,0,0,220,71,2,0,192,66,6,0,248,90,0,0,0,0,0,0,220,71,2,0,219,66,6,0,248,90,0,0,0,0,0,0,220,71,2,0,250,66,6,0,248,90,0,0,0,0,0,0,220,71,2,0,20,67,6,0,248,90,0,0,0,0,0,0,220,71,2,0,81,67,6,0,248,90,0,0,0,0,0,0,220,71,2,0,50,67,6,0,248,90,0,0,0,0,0,0,220,71,2,0,115,67,6,0,248,90,0,0,0,0,0,0,220,71,2,0,138,67,6,0,248,90,0,0,0,0,0,0,220,71,2,0,181,67,6,0,248,90,0,0,0,0,0,0,220,71,2,0,217,67,6,0,248,90,0,0,0,0,0,0,220,71,2,0,2,68,6,0,248,90,0,0,0,0,0,0,220,71,2,0,37,68,6,0,248,90,0,0,0,0,0,0,220,71,2,0,71,68,6,0,248,90,0,0,0,0,0,0,220,71,2,0,50,74,6,0,128,36,0,0,0,0,0,0,220,71,2,0,201,76,6,0,232,77,0,0,0,0,0,0,220,71,2,0,59,76,6,0,8,42,0,0,0,0,0,0,220,71,2,0,225,76,6,0,136,69,0,0,0,0,0,0,220,71,2,0,9,77,6,0,128,36,0,0,0,0,0,0,220,71,2,0,210,78,6,0,24,78,0,0,0,0,0,0,220,71,2,0,236,78,6,0,136,69,0,0,0,0,0,0,220,71,2,0,23,79,6,0,128,36,0,0,0,0,0,0,220,71,2,0,74,81,6,0,72,78,0,0,0,0,0,0,220,71,2,0,108,81,6,0,136,69,0,0,0,0,0,0,220,71,2,0,159,81,6,0,128,36,0,0,0,0,0,0,220,71,2,0,52,83,6,0,120,78,0,0,0,0,0,0,220,71,2,0,78,83,6,0,136,69,0,0,0,0,0,0,220,71,2,0,98,84,6,0,128,36,0,0,0,0,0,0,220,71,2,0,103,91,6,0,216,78,0,0,0,0,0,0,220,71,2,0,100,89,6,0,232,69,0,0,0,0,0,0,220,71,2,0,49,89,6,0,232,69,0,0,0,0,0,0,220,71,2,0,3,89,6,0,8,42,0,0,0,0,0,0,220,71,2,0,135,91,6,0,8,70,0,0,0,0,0,0,220,71,2,0,171,91,6,0,128,36,0,0,0,0,0,0,220,71,2,0,228,93,6,0,216,78,0,0,0,0,0,0,220,71,2,0,14,93,6,0,8,42,0,0,0,0,0,0,220,71,2,0,63,93,6,0,8,42,0,0,0,0,0,0,220,71,2,0,6,94,6,0,128,36,0,0,0,0,0,0,220,71,2,0,83,94,6,0,136,69,0,0,0,0,0,0,220,71,2,0,64,96,6,0,56,79,0,0,0,0,0,0,220,71,2,0,170,98,6,0,128,36,0,0,0,0,0,0,220,71,2,0,241,101,6,0,120,79,0,0,0,0,0,0,220,71,2,0,13,102,6,0,136,69,0,0,0,0,0,0,220,71,2,0,58,102,6,0,128,36,0,0,0,0,0,0,220,71,2,0,82,104,6,0,168,79,0,0,0,0,0,0,220,71,2,0,108,104,6,0,136,69,0,0,0,0,0,0,220,71,2,0,151,104,6,0,128,36,0,0,0,0,0,0,220,71,2,0,61,109,6,0,232,79,0,0,0,0,0,0,220,71,2,0,136,108,6,0,8,42,0,0,0,0,0,0,220,71,2,0,89,109,6,0,136,69,0,0,0,0,0,0,220,71,2,0,134,109,6,0,128,36],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+10240);allocate([220,71,2,0,73,112,6,0,24,80,0,0,0,0,0,0,220,71,2,0,103,112,6,0,136,69,0,0,0,0,0,0,220,71,2,0,150,112,6,0,128,36,0,0,0,0,0,0,220,71,2,0,201,115,6,0,200,69,0,0,0,0,0,0,220,71,2,0,237,115,6,0,136,69,0,0,0,0,0,0,220,71,2,0,22,116,6,0,128,36,0,0,0,0,0,0,220,71,2,0,4,121,6,0,72,80,0,0,0,0,0,0,220,71,2,0,29,121,6,0,128,36,0,0,0,0,0,0,220,71,2,0,74,125,6,0,168,80,0,0,0,0,0,0,220,71,2,0,162,124,6,0,8,42,0,0,0,0,0,0,220,71,2,0,109,125,6,0,136,69,0,0,0,0,0,0,220,71,2,0,159,125,6,0,128,36,0,0,0,0,0,0,220,71,2,0,164,129,6,0,216,80,0,0,0,0,0,0,220,71,2,0,193,129,6,0,136,69,0,0,0,0,0,0,220,71,2,0,239,129,6,0,128,36,0,0,0,0,0,0,220,71,2,0,119,131,6,0,136,69,0,0,0,0,0,0,220,71,2,0,137,133,6,0,248,80,0,0,0,0,0,0,220,71,2,0,163,133,6,0,128,36,0,0,0,0,0,0,220,71,2,0,48,137,6,0,248,69,0,0,0,0,0,0,220,71,2,0,150,136,6,0,8,42,0,0,0,0,0,0,220,71,2,0,76,137,6,0,128,36,0,0,0,0,0,0,220,71,2,0,26,140,6,0,104,81,0,0,0,0,0,0,220,71,2,0,55,140,6,0,136,69,0,0,0,0,0,0,220,71,2,0,101,140,6,0,128,36,0,0,0,0,0,0,220,71,2,0,130,141,6,0,136,69,0,0,0,0,0,0,220,71,2,0,246,143,6,0,136,81,0,0,0,0,0,0,220,71,2,0,18,144,6,0,128,36,0,0,0,0,0,0,220,71,2,0,216,146,6,0,200,81,0,0,0,0,0,0,220,71,2,0,243,146,6,0,136,69,0,0,0,0,0,0,220,71,2,0,31,147,6,0,128,36,0,0,0,0,0,0,220,71,2,0,75,149,6,0,248,81,0,0,0,0,0,0,220,71,2,0,103,149,6,0,136,69,0,0,0,0,0,0,220,71,2,0,164,149,6,0,128,36,0,0,0,0,0,0,220,71,2,0,129,155,6,0,40,82,0,0,0,0,0,0,220,71,2,0,165,155,6,0,136,69,0,0,0,0,0,0,220,71,2,0,83,156,6,0,128,36,0,0,0,0,0,0,220,71,2,0,121,157,6,0,88,82,0,0,0,0,0,0,220,71,2,0,147,157,6,0,136,69,0,0,0,0,0,0,220,71,2,0,190,157,6,0,128,36,0,0,0,0,0,0,220,71,2,0,82,159,6,0,136,82,0,0,0,0,0,0,220,71,2,0,106,159,6,0,136,69,0,0,0,0,0,0,220,71,2,0,146,159,6,0,128,36,0,0,0,0,0,0,220,71,2,0,178,161,6,0,216,69,0,0,0,0,0,0,220,71,2,0,204,161,6,0,128,36,0,0,0,0,0,0,220,71,2,0,87,164,6,0,216,82,0,0,0,0,0,0,220,71,2,0,129,164,6,0,136,69,0,0,0,0,0,0,220,71,2,0,203,164,6,0,128,36,0,0,0,0,0,0,220,71,2,0,111,167,6,0,168,78,0,0,0,0,0,0,220,71,2,0,151,166,6,0,8,42,0,0,0,0,0,0,220,71,2,0,213,167,6,0,128,36,0,0,0,0,0,0,220,71,2,0,185,169,6,0,72,83,0,0,0,0,0,0,220,71,2,0,222,168,6,0,8,42,0,0,0,0,0,0,220,71,2,0,234,169,6,0,232,69,0,0,0,0,0,0,220,71,2,0,21,170,6,0,128,36,0,0,0,0,0,0,220,71,2,0,243,171,6,0,136,83,0,0,0,0,0,0,220,71,2,0,27,171,6,0,8,42,0,0,0,0,0,0,220,71,2,0,35,172,6,0,232,69,0,0,0,0,0,0,220,71,2,0,76,172,6,0,128,36,0,0,0,0,0,0,220,71,2,0,60,174,6,0,200,83,0,0,0,0,0,0,220,71,2,0,91,173,6,0,8,42,0,0,0,0,0,0,220,71,2,0,111,174,6,0,232,69,0,0,0,0,0,0,220,71,2,0,156,174,6,0,128,36,0,0,0,0,0,0,220,71,2,0,116,176,6,0,8,84,0,0,0,0,0,0,220,71,2,0,159,175,6,0,8,42,0,0,0,0,0,0,220,71,2,0,163,176,6,0,232,69,0,0,0,0,0,0,220,71,2,0,203,176,6,0,128,36,0,0,0,0,0,0,220,71,2,0,181,178,6,0,72,84,0,0,0,0,0,0,220,71,2,0,215,177,6,0,8,42,0,0,0,0,0,0,220,71,2,0,231,178,6,0,232,69,0,0,0,0,0,0,220,71,2,0,15,179,6,0,128,36,0,0,0,0,0,0,220,71,2,0,237,180,6,0,136,84,0,0,0,0,0,0,220,71,2,0,21,180,6,0,8,42,0,0,0,0,0,0,220,71,2,0,29,181,6,0,232,69,0,0,0,0,0,0,220,71,2,0,88,181,6,0,128,36,0,0,0,0,0,0,220,71,2,0,60,183,6,0,200,84,0,0,0,0,0,0,220,71,2,0,97,182,6,0,8,42,0,0,0,0,0,0,220,71,2,0,109,183,6,0,232,69,0,0,0,0,0,0,220,71,2,0,184,183,6,0,128,36,0,0,0,0,0,0,220,71,2,0,47,186,6,0,184,78,0,0,0,0,0,0,220,71,2,0,60,185,6,0,8,42,0,0,0,0,0,0,220,71,2,0,104,186,6,0,128,36,0,0,0,0,0,0,220,71,2,0,67,189,6,0,40,70,0,0,0,0,0,0,220,71,2,0,165,188,6,0,8,42,0,0,0,0,0,0,220,71,2,0,94,189,6,0,128,36,0,0,0,0,0,0,220,71,2,0,93,191,6,0,88,85,0,0,0,0,0,0,220,71,2,0,121,191,6,0,136,69,0,0,0,0,0,0,220,71,2,0,166,191,6,0,128,36,0,0,0,0,0,0,220,71,2,0,85,197,6,0,24,70,0,0,0,0,0,0,220,71,2,0,162,196,6,0,8,42,0,0,0,0,0,0,49,244,70,62,15,206,131,63,254,130,43,101,71,21,87,64,0,0,0,0,0,0,144,63,0,0,0,0,0,0,240,63,97,128,119,62,154,44,240,63,116,133,21,211,176,89,240,63,200,155,117,24,69,135,240,63,15,137,249,108,88,181,240,63,162,209,211,50,236,227,240,63,81,91,18,208,1,19,241,63,224,45,169,174,154,66,241,63,123,81,125,60,184,114,241,63,117,203,111,235,91,163,241,63,170,185,104,49,135,212,241,63,214,140,98,136,59,6,242,63,56,98,117,110,122,56,242,63,221,124,226,101,69,107,242,63,225,222,31,245,157,158,242,63,11,3,228,166,133,210,242,63,21,183,49,10,254,6,243,63,255,22,100,178,8,60,243,63,203,169,58,55,167,113,243,63,247,159,229,52,219,167,243,63,34,52,18,76,166,222,243,63,42,46,247,33,10,22,244,63,45,137,97,96,8,78,244,63,208,60,193,181,162,134,244,63,39,42,54,213,218,191,244,63,167,44,157,118,178,249,244,63,130,79,157,86,43,52,245,63,218,39,181,54,71,111,245,63,41,84,72,221,7,171,245,63,72,33,173,21,111,231,245,63,133,85,58,176,126,36,246,63,37,34,85,130,56,98,246,63,205,59,127,102,158,160,246,63,47,26,101,60,178,223,246,63,116,95,236,232,117,31,247,63,201,103,66,86,235,95,247,63,135,1,235,115,20,161,247,63,98,78,207,54,243,226,247,63,19,206,76,153,137,37,248,63,237,146,68,155,217,104,248,63,219,160,42,66,229,172,248,63,54,119,21,153,174,241,248,63,229,197,205,176,55,55,249,63,80,78,222,159,130,125,249,63,144,240,163,130,145,196,249,63,101,229,93,123,102,12,250,63,93,37,62,178,3,85,250,63,191,253,121,85,107,158,250,63,173,211,90,153,159,232,250,63,251,21,79,184,162,51,251,63,71,94,251,242,118,127,251,63,210,193,75,144,30,204,251,63,156,82,133,221,155,25,252,63,75,209,87,46,241,103,252,63,105,144,239,220,32,183,252,63,124,137,7,74,45,7,253,63,135,164,251,220,24,88,253,63,133,50,219,3,230,169,253,63,95,155,123,51,151,252,253,63,246,63,139,231,46,80,254,63,218,144,164,162,175,164,254,63,39,90,97,238,27,250,254,63,64,69,110,91,118,80,255,63,216,144,158,129,193,167,255,63,239,57,250,254,66,46,230,63,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,220,71,2,0,175,212,6,0,0,93,0,0,0,0,0,0,220,71,2,0,215,212,6,0,8,93,0,0,0,0,0,0,220,71,2,0,147,213,6,0,8,93,0,0,0,0,0,0,220,71,2,0,237,214,6,0,0,93,0,0,0,0,0,0,180,71,2,0,30,215,6,0,180,71,2,0,255,215,6,0,220,71,2,0,16,219,6,0,240,98,0,0,0,0,0,0,180,71,2,0,51,219,6,0,220,71,2,0,78,219,6,0,40,88,0,0,0,0,0,0,180,71,2,0,219,222,6,0,220,71,2,0,42,225,6,0,40,88,0,0,0,0,0,0,220,71,2,0,78,243,6,0,120,92,0,0,0,0,0,0,220,71,2,0,161,243,6,0,112,90,0,0,0,0,0,0,220,71,2,0,151,27,7,0,248,90,0,0,0,0,0,0,220,71,2,0,220,23,7,0,248,90,0,0,0,0,0,0,220,71,2,0,13,24,7,0,248,90,0,0,0,0,0,0,220,71,2,0,51,24,7,0,248,90,0,0,0,0,0,0,220,71,2,0,95,24,7,0,248,90,0,0,0,0,0,0,220,71,2,0,130,24,7,0,248,90,0,0,0,0,0,0,220,71,2,0,179,24,7,0,248,90,0,0,0,0,0,0,220,71,2,0,219,24,7,0,248,90,0,0,0,0,0,0,220,71,2,0,253,24,7,0,248,90,0,0,0,0,0,0,220,71,2,0,32,25,7,0,248,90,0,0,0,0,0,0,220,71,2,0,69,25,7,0,248,90,0,0,0,0,0,0,220,71,2,0,101,25,7,0,248,90,0,0,0,0,0,0,220,71,2,0,134,25,7,0,248,90,0,0,0,0,0,0,220,71,2,0,167,25,7,0,248,90,0,0,0,0,0,0,220,71,2,0,202,25,7,0,248,90,0,0,0,0,0,0,220,71,2,0,234,25,7,0,248,90,0,0,0,0,0,0,220,71,2,0,20,26,7,0,248,90,0,0,0,0,0,0,220,71,2,0,63,26,7,0,248,90,0,0,0,0,0,0,220,71,2,0,108,26,7,0,248,90,0,0,0,0,0,0,220,71,2,0,148,26,7,0,248,90,0,0,0,0,0,0,220,71,2,0,189,26,7,0,248,90,0,0,0,0,0,0,220,71,2,0,230,26,7,0,248,90,0,0,0,0,0,0,220,71,2,0,24,27,7,0,248,90,0,0,0,0,0,0,220,71,2,0,75,27,7,0,248,90,0,0,0,0,0,0,220,71,2,0,111,27,7,0,248,90,0,0,0,0,0,0,180,71,2,0,189,27,7,0,220,71,2,0,228,27,7,0,8,90,0,0,0,0,0,0,220,71,2,0,244,29,7,0,248,90,0,0,0,0,0,0,220,71,2,0,23,30,7,0,88,92,0,0,0,0,0,0,220,71,2,0,25,31,7,0,160,92,0,0,0,0,0,0,220,71,2,0,84,31,7,0,40,72,0,0,0,0,0,0,220,71,2,0,63,44,7,0,8,91,0,0,0,0,0,0,180,71,2,0,64,45,7,0,220,71,2,0,146,49,7,0,0,93,0,0,0,0,0,0,220,71,2,0,188,49,7,0,8,88,0,0,0,0,0,0,180,71,2,0,1,50,7,0,220,71,2,0,18,53,7,0,176,90,0,0,0,0,0,0,220,71,2,0,63,53,7,0,152,90,0,0,0,0,0,0,220,71,2,0,88,54,7,0,240,90,0,0,0,0,0,0,140,72,2,0,242,53,7,0,0,0,0,0,1,0,0,0,232,90,0,0,0,0,0,0,180,71,2,0,50,54,7,0,180,71,2,0,0,55,7,0,220,71,2,0,36,57,7,0,16,88,0,0,0,0,0,0,180,71,2,0,5,63,7,0,220,71,2,0,5,58,7,0,32,91,0,0,0,0,0,0,220,71,2,0,66,58,7,0,48,91,0,0,0,0,0,0,220,71,2,0,134,58,7,0,64,91,0,0,0,0,0,0,180,71,2,0,197,58,7,0,220,71,2,0,248,58,7,0,48,91,0,0,0,0,0,0,220,71,2,0,38,59,7,0,104,91,0,0,0,0,0,0,220,71,2,0,98,59,7,0,48,91,0,0,0,0,0,0,220,71,2,0,217,59,7,0,136,91,0,0,0,0,0,0,220,71,2,0,24,60,7,0,48,91,0,0,0,0,0,0,220,71,2,0,77,60,7,0,168,91,0,0,0,0,0,0,220,71,2,0,140,60,7,0,48,91,0,0,0,0,0,0,220,71,2,0,193,60,7,0,200,91,0,0,0,0,0,0,220,71,2,0,0,61,7,0,48,91,0,0,0,0,0,0,220,71,2,0,53,61,7,0,232,91,0,0,0,0,0,0,220,71,2,0,116,61,7,0,48,91,0,0,0,0,0,0,220,71,2,0,169,61,7,0,8,92,0,0,0,0,0,0,220,71,2,0,232,61,7,0,48,91,0,0,0,0,0,0,220,71,2,0,29,62,7,0,40,92,0,0,0,0,0,0,220,71,2,0,92,62,7,0,48,91,0,0,0,0,0,0,220,71,2,0,145,62,7,0,72,92,0,0,0,0,0,0,220,71,2,0,208,62,7,0,48,91,0,0,0,0,0,0,180,71,2,0,36,63,7,0,220,71,2,0,194,63,7,0,88,92,0,0,0,0,0,0,180,71,2,0,50,66,7,0,180,71,2,0,100,66,7,0,220,71,2,0,177,71,7,0,112,90,0,0,0,0,0,0,220,71,2,0,61,72,7,0,64,88,0,0,0,0,0,0,180,71,2,0,219,73,7,0,220,71,2,0,8,74,7,0,160,92,0,0,0,0,0,0,180,71,2,0,253,74,7,0,180,71,2,0,34,75,7,0,180,71,2,0,71,75,7,0,180,71,2,0,108,75,7,0,180,71,2,0,145,75,7,0,180,71,2,0,182,75,7,0,180,71,2,0,219,75,7,0,220,71,2,0,0,76,7,0,40,72,0,0,0,0,0,0,180,71,2,0,158,76,7,0,180,71,2,0,169,77,7,0,140,72,2,0,114,93,7,0,0,0,0,0,1,0,0,0,24,35,0,0,0,0,0,0,140,72,2,0,51,93,7,0,0,0,0,0,1,0,0,0,24,35,0,0,0,0,0,0,180,71,2,0,20,93,7,0,180,71,2,0,245,92,7,0,180,71,2,0,214,92,7,0,180,71,2,0,183,92,7,0,180,71,2,0,152,92,7,0,220,71,2,0,193,104,7,0,120,93,0,0,0,0,0,0,180,71,2,0,175,104,7,0,220,71,2,0,235,104,7,0,120,93,0,0,0,0,0,0,180,71,2,0,21,105,7,0,180,71,2,0,70,105,7,0,140,72,2,0,119,105,7,0,0,0,0,0,1,0,0,0,104,93,0,0,3,244,255,255,140,72,2,0,166,105,7,0,0,0,0,0,1,0,0,0,128,93,0,0,3,244,255,255,140,72,2,0,213,105,7,0,0,0,0,0,1,0,0,0,104,93,0,0,3,244,255,255,140,72,2,0,4,106,7,0,0,0,0,0,1,0,0,0,128,93,0,0,3,244,255,255,140,72,2,0,51,106,7,0,3,0,0,0,2,0,0,0,160,93,0,0,2,0,0,0,208,93,0,0,2,8,0,0,12,0,0,0,0,0,0,0,160,93,0,0,49,0,0,0,50,0,0,0,244,255,255,255,244,255,255,255,160,93,0,0,51,0,0,0,52,0,0,0,220,71,2,0,99,106,7,0,152,93,0,0,0,0,0,0,220,71,2,0,124,106,7,0,144,93,0,0,0,0,0,0,220,71,2,0,187,106,7,0,152,93,0,0,0,0,0,0,220,71,2,0,211,106,7,0,144,93,0,0,0,0,0,0,220,71,2,0,235,106,7,0,152,94,0,0,0,0,0,0,220,71,2,0,255,106,7,0,232,98,0,0,0,0,0,0,220,71,2,0,21,107,7,0,152,94,0,0,0,0,0,0,140,72,2,0,79,107,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,216,94,0,0,0,0,0,0,140,72,2,0,147,107,7,0,0,0,0,0,1,0,0,0,240,94,0,0,0,0,0,0,180,71,2,0,169,107,7,0,140,72,2,0,194,107,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,24,95,0,0,0,0,0,0,140,72,2,0,6,108,7,0,0,0,0,0,1,0,0,0,240,94,0,0,0,0,0,0,140,72,2,0,42,108,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,80,95,0,0,0,0,0,0,140,72,2,0,110,108,7,0,0,0,0,0,1,0,0,0,104,95,0,0,0,0,0,0,180,71,2,0,132,108,7,0,140,72,2,0,157,108,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,144,95,0,0,0,0,0,0,140,72,2,0,225,108,7,0,0,0,0,0,1,0,0,0,104,95,0,0,0,0,0,0,140,72,2,0,55,110,7,0,0,0,0,0,3,0,0,0,152,94,0,0,2,0,0,0,208,95,0,0,2,0,0,0,216,95,0,0,0,8,0,0,180,71,2,0,158,110,7,0,180,71,2,0,124,110,7,0,140,72,2,0,177,110,7,0,0,0,0,0,3,0,0,0,152,94,0,0,2,0,0,0,208,95,0,0,2,0,0,0,8,96,0,0,0,8,0,0,180,71,2,0,246,110,7,0,140,72,2,0,24,111,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,48,96,0,0,0,8,0,0,180,71,2,0,93,111,7,0,140,72,2,0,114,111,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,48,96,0,0,0,8,0,0,140,72,2,0,183,111,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,120,96,0,0,2,0,0,0,180,71,2,0,211,111,7,0,140,72,2,0,232,111,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,120,96,0,0,2,0,0,0,140,72,2,0,4,112,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,120,96,0,0,2,0,0,0,140,72,2,0,32,112,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,120,96,0,0,2,0,0,0,140,72,2,0,75,112,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,0,97,0,0,0,0,0,0,180,71,2,0,145,112,7,0,140,72,2,0,181,112,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,40,97,0,0,0,0,0,0,180,71,2,0,251,112,7,0,140,72,2,0,26,113,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,80,97,0,0,0,0,0,0,180,71,2,0,96,113,7,0,140,72,2,0,121,113,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,120,97,0,0,0,0,0,0,180,71,2,0,191,113,7,0,140,72,2,0,216,113,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,160,97,0,0,2,0,0,0,180,71,2,0,237,113,7,0,140,72,2,0,132,114,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,160,97,0,0,2,0,0,0,220,71,2,0,5,114,7,0,216,97,0,0,0,0,0,0,140,72,2,0,40,114,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,248,97,0,0,2,0,0,0,180,71,2,0,75,114,7,0,220,71,2,0,98,114,7,0,216,97,0,0,0,0,0,0,140,72,2,0,153,114,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,248,97,0,0,2,0,0,0,140,72,2,0,187,114,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,248,97,0,0,2,0,0,0,140,72,2,0,221,114,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,248,97,0,0,2,0,0,0,220,71,2,0,0,115,7,0,152,94,0,0,0,0,0,0,140,72,2,0,22,115,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,160,98,0,0,2,0,0,0,180,71,2,0,40,115,7,0,140,72,2,0,61,115,7,0,0,0,0,0,2,0,0,0,152,94,0,0,2,0,0,0,160,98,0,0,2,0,0,0,220,71,2,0,79,115,7,0,152,94,0,0,0,0,0,0,220,71,2,0,100,115,7,0,152,94,0,0,0,0,0,0,180,71,2,0,121,115,7,0,180,71,2,0,35,116,7,0,220,71,2,0,131,116,7,0,8,99,0,0,0,0,0,0,220,71,2,0,48,116,7,0,24,99,0,0,0,0,0,0,180,71,2,0,81,116,7,0,220,71,2,0,94,116,7,0,248,98,0,0,0,0,0,0,220,71,2,0,101,117,7,0,240,98,0,0,0,0,0,0,220,71,2,0,117,117,7,0,48,99,0,0,0,0,0,0,220,71,2,0,134,117,7,0,48,99,0,0,0,0,0,0,220,71,2,0,165,117,7,0,240,98,0,0,0,0,0,0,220,71,2,0,213,117,7,0,8,99,0,0,0,0,0,0,220,71,2,0,177,117,7,0,112,99,0,0,0,0,0,0,220,71,2,0,247,117,7,0,8,99,0,0,0,0,0,0,84,72,2,0,31,118,7,0,84,72,2,0,33,118,7,0,84,72,2,0,36,118,7,0,84,72,2,0,233,115,6,0,84,72,2,0,231,115,6,0,84,72,2,0,38,118,7,0,84,72,2,0,40,118,7,0,84,72,2,0,49,69,7,0,84,72,2,0,42,118,7,0,84,72,2,0,44,118,7,0,84,72,2,0,128,123,7,0,84,72,2,0,46,118,7,0,84,72,2,0,57,69,7,0,84,72,2,0,48,118,7,0,220,71,2,0,50,118,7,0,248,98,0,0,0,0,0,0,160,99,0,0,224,99,0,0,160,99,0,0,232,99,0,0,160,99,0,0,64,32,0,0,160,99,0,0,72,32,0,0,160,99,0,0,80,32,0,0,160,99,0,0,224,99,0,0,144,32,0,0,160,99,0,0,144,32,0,0,224,99,0,0,160,99,0,0,144,32,0,0,232,99,0,0,224,99,0,0,232,99,0,0,160,32,0,0,176,32,0,0,120,32,0,0,232,99,0,0,176,99,0,0,120,32,0,0,232,99,0,0,224,99,0,0,232,32,0,0,160,99,0,0,232,32,0,0,0,100,0,0,160,99,0,0,232,32,0,0,232,99,0,0,0,100,0,0,232,99,0,0,248,32,0,0,176,32,0,0,208,32,0,0,232,99,0,0,176,99,0,0,208,32,0,0,232,99,0,0,0,100,0,0,56,33,0,0,160,99,0,0,56,33,0,0,8,100,0,0,160,99,0,0,56,33,0,0,232,99,0,0,8,100,0,0,232,99,0,0,72,33,0,0,176,32,0,0,32,33,0,0,232,99,0,0,176,99,0,0,32,33,0,0,232,99,0,0,8,100,0,0,136,33,0,0,160,99,0,0,136,33,0,0,168,33,0,0,160,99,0,0,136,33,0,0,232,99,0,0,168,33,0,0,232,99,0,0,152,33,0,0,176,32,0,0,112,33,0,0,232,99,0,0,176,99,0,0,112,33,0,0,232,99,0,0,168,33,0,0,224,33,0,0,160,99,0,0,224,33,0,0,0,34,0,0,160,99,0,0,224,33,0,0,232,99,0,0,0,34,0,0,232,99,0,0,240,33,0,0,176,32,0,0,200,33,0,0,232,99,0,0,176,99,0,0,200,33,0,0,232,99,0,0,0,34,0,0,56,34,0,0,160,99,0,0,56,34,0,0,80,32,0,0,160,99,0,0,56,34,0,0,232,99,0,0,80,32,0,0,232,99,0,0,72,34,0,0,176,32,0,0,32,34,0,0,232,99,0,0,176,99,0,0,32,34,0,0,232,99,0,0,80,32,0,0,88,34,0,0,88,34,0,0,0,34,0,0,88,34,0,0,120,34,0,0,224,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,152,34,0,0,88,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,224,99,0,0,232,99,0,0,0,34,0,0,120,34,0,0,224,99,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,232,99,0,0,104,34,0,0,224,99,0,0,104,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,0,34,0,0,104,34,0,0,224,99,0,0,160,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,160,99,0,0,88,34,0,0,120,34,0,0,224,99,0,0,0,34,0,0,104,34,0,0,224,99,0,0,224,99,0,0,0,34,0,0,104,34,0,0,224,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,176,99,0,0,104,34,0,0,232,99,0,0,104,34,0,0,224,99,0,0,0,34,0,0,104,34,0,0,8,100,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,8,100,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,104,34,0,0,80,32,0,0,160,99,0,0,0,34,0,0,152,34,0,0,160,99,0,0,0,34,0,0,152,34,0,0,0,34,0,0,120,34,0,0,0,34,0,0,176,32,0,0,0,34,0,0,224,99,0,0,176,32,0,0,0,34,0,0,224,99,0,0,224,99,0,0,184,99,0,0,88,34,0,0,224,99,0,0,184,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,184,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,192,99,0,0,88,34,0,0,224,99,0,0,192,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,192,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,208,99,0,0,88,34,0,0,224,99,0,0,208,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,208,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,216,99,0,0,88,34,0,0,224,99,0,0,216,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,216,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,224,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,88,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,0,100,0,0,88,34,0,0,224,99,0,0,0,100,0,0,88,34,0,0,224,99,0,0,224,99,0,0,0,100,0,0,88,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,8,100,0,0,88,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,8,100,0,0,88,34,0,0,224,99,0,0,8,100,0,0,88,34,0,0,224,99,0,0,224,99,0,0,176,32,0,0,72,32,0,0,80,32,0,0,72,32,0,0,248,34,0,0,72,32,0,0,184,39,0,0,224,99,0,0,8,35,0,0,0,34,0,0,0,35,0,0,0,34,0,0,0,34,0,0,0,35,0,0,0,34,0,0,152,34,0,0,224,99,0,0,224,99,0,0,176,32,0,0,0,34,0,0,80,32,0,0,232,34,0,0,32,35,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,8,100,0,0,224,99,0,0,176,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,8,100,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,8,100,0,0,8,100,0,0,176,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,8,100,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,120,34,0,0,8,100,0,0,8,100,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,120,34,0,0,8,100,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,120,34,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,8,100,0,0,8,100,0,0,8,100,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,8,100,0,0,8,100,0,0,8,100,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,8,100,0,0,8,100,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,8,100,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,8,100,0,0,224,99,0,0,8,100,0,0,8,100,0,0,8,100,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,8,100,0,0,224,99,0,0,8,100,0,0,8,100,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,8,100,0,0,224,99,0,0,8,100,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,8,100,0,0,224,99,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,8,100,0,0,8,100,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,8,100,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,8,100,0,0,8,100,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,8,100,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,224,99,0,0,8,100,0,0,8,100,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,224,99,0,0,8,100,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,224,99,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,224,99,0,0,224,99,0,0,224,99,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,8,100,0,0,0,34,0,0,8,100,0,0,8,100,0,0,0,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,8,100,0,0,0,34,0,0,8,100,0,0,8,100,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,176,99,0,0,8,100,0,0,0,34,0,0,176,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,8,100,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,120,34,0,0,168,33,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,120,34,0,0,168,33,0,0,160,99,0,0,0,34,0,0,0,34,0,0,120,34,0,0,80,32,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,120,34,0,0,168,33,0,0,176,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,120,34,0,0,168,33,0,0,176,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,120,34,0,0,168,33,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,120,34,0,0,160,99,0,0,200,33,0,0,176,32,0,0,0,34,0,0,0,34,0,0,176,32,0,0,8,100,0,0,160,99,0,0,200,33,0,0,176,32,0,0,0,34,0,0,0,34,0,0,176,32,0,0,176,32,0,0,176,99,0,0,160,99,0,0,200,33,0,0,176,32,0,0,0,34,0,0,0,34,0,0,176,32,0,0,176,32,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,8,100,0,0,224,99,0,0,224,99,0,0,224,99,0,0,224,99,0,0,8,100,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,120,34,0,0,224,99,0,0,232,34,0,0,224,99,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,120,34,0,0,224,99,0,0,232,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,120,34,0,0,224,99,0,0,232,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,120,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,120,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,176,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,168,33,0,0,224,99,0,0,152,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,168,33,0,0,224,99,0,0,152,34,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,168,33,0,0,224,99,0,0,152,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,168,33,0,0,224,99,0,0,152,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,8,100,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,176,99,0,0,176,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,176,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,224,99,0,0,224,99,0,0,152,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,8,100,0,0,224,99,0,0,224,99,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,168,33,0,0,224,99,0,0,224,99,0,0,152,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,168,33,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,168,33,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,168,33,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,8,100,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,8,100,0,0,160,99,0,0,8,100,0,0,0,34,0,0,0,34,0,0,224,99,0,0,160,99,0,0,8,100,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,200,33,0,0,224,99,0,0,152,34,0,0,224,99,0,0,224,99,0,0,0,34,0,0,224,99,0,0,168,33,0,0,160,99,0,0,0,34,0,0,200,33,0,0,224,99,0,0,152,34,0,0,224,99,0,0,224,99,0,0,0,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,200,33,0,0,224,99,0,0,152,34,0,0,224,99,0,0,224,99,0,0,0,34,0,0,160,99,0,0,0,34,0,0,200,33,0,0,224,99,0,0,152,34,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,200,33,0,0,224,99,0,0,152,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,200,33,0,0,224,99,0,0,152,34,0,0,176,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,176,99,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,168,33,0,0,120,34,0,0,8,100,0,0,8,100,0,0,8,100,0,0,152,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,168,33,0,0,120,34,0,0,8,100,0,0,8,100,0,0,8,100,0,0,152,34,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,168,33,0,0,120,34,0,0,8,100,0,0,8,100,0,0,8,100,0,0,152,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,168,33,0,0,120,34,0,0,8,100,0,0,8,100,0,0,8,100,0,0,152,34,0,0,160,99,0,0,0,34,0,0,72,32,0,0,152,34,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,72,32,0,0,152,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,72,32,0,0,152,34,0,0,160,99,0,0,168,33,0,0,120,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,224,99,0,0,112,33,0,0,0,34,0,0,0,34,0,0,0,34,0,0,176,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,168,33,0,0,8,100,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,168,33,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,168,33,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,160,99,0,0,0,34,0,0,200,33,0,0,0,34,0,0,224,99,0,0,224,99,0,0,168,33,0,0,160,99,0,0,0,34,0,0,200,33,0,0,0,34,0,0,224,99,0,0,224,99,0,0,8,100,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,232,34,0,0,0,34,0,0,8,100,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,232,34,0,0,8,100,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,0,34,0,0,0,34,0,0,0,34,0,0,72,32,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,0,34,0,0,8,100,0,0,0,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,0,34,0,0,8,100,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,64,32,0,0,8,100,0,0,8,100,0,0,0,34,0,0,224,99,0,0,120,34,0,0,168,33,0,0,0,34,0,0,224,99,0,0,120,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,8,100,0,0,0,34,0,0,224,99,0,0,176,99,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,8,100,0,0,0,34,0,0,224,99,0,0,176,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,8,100,0,0,0,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,8,100,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,8,100,0,0,0,34,0,0,224,99,0,0,224,99,0,0,176,99,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,8,100,0,0,0,34,0,0,224,99,0,0,224,99,0,0,176,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,8,100,0,0,0,34,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,80,32,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,80,32,0,0,0,34,0,0,0,34,0,0,224,99,0,0,160,99,0,0,32,34,0,0,120,32,0,0,224,99,0,0,8,100,0,0,160,99,0,0,32,34,0,0,120,32,0,0,224,99,0,0,160,99,0,0,200,33,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,120,34,0,0,224,99,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,8,100,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,0,34,0,0,0,34,0,0,176,99,0,0,0,34,0,0,8,100,0,0,0,34,0,0,224,99,0,0,0,34,0,0,232,34,0,0,224,99,0,0,224,99,0,0,0,34,0,0,8,100,0,0,0,34,0,0,224,99,0,0,0,34,0,0,232,34,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,168,33,0,0,168,33,0,0,152,34,0,0,224,99,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,168,33,0,0,168,33,0,0,152,34,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,168,33,0,0,168,33,0,0,152,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,168,33,0,0,168,33,0,0,152,34],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+20480);allocate([8,100,0,0,0,34,0,0,0,34,0,0,224,99,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,152,34,0,0,0,34,0,0,0,34,0,0,152,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,160,99,0,0,200,33,0,0,200,33,0,0,176,32,0,0,16,35,0,0,0,34,0,0,176,99,0,0,16,35,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,168,33,0,0,224,99,0,0,224,99,0,0,152,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,168,33,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,168,33,0,0,224,99,0,0,8,100,0,0,0,34,0,0,224,99,0,0,0,34,0,0,8,100,0,0,0,34,0,0,224,99,0,0,8,100,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,8,100,0,0,224,99,0,0,224,99,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,8,100,0,0,224,99,0,0,224,99,0,0,8,100,0,0,0,34,0,0,64,32,0,0,176,99,0,0,160,99,0,0,0,34,0,0,8,100,0,0,0,34,0,0,160,99,0,0,0,34,0,0,32,35,0,0,168,33,0,0,224,99,0,0,8,100,0,0,152,34,0,0,224,99,0,0,224,99,0,0,176,99,0,0,160,99,0,0,0,34,0,0,32,35,0,0,168,33,0,0,224,99,0,0,8,100,0,0,152,34,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,32,35,0,0,168,33,0,0,224,99,0,0,8,100,0,0,152,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,32,35,0,0,168,33,0,0,224,99,0,0,8,100,0,0,152,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,120,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,120,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,152,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,224,99,0,0,224,99,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,0,34,0,0,168,33,0,0,8,100,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,0,34,0,0,168,33,0,0,8,100,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,0,34,0,0,168,33,0,0,160,99,0,0,0,34,0,0,0,34,0,0,224,99,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,160,99,0,0,224,99,0,0,176,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,224,99,0,0,176,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,200,33,0,0,8,100,0,0,0,34,0,0,0,34,0,0,8,100,0,0,8,100,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,0,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,120,34,0,0,224,99,0,0,224,99,0,0,152,34,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,120,34,0,0,224,99,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,120,34,0,0,224,99,0,0,160,99,0,0,0,34,0,0,0,34,0,0,0,34,0,0,120,34,0,0,0,34,0,0,0,34,0,0,8,100,0,0,120,34,0,0,152,34,0,0,176,99,0,0,176,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,120,34,0,0,152,34,0,0,176,99,0,0,0,34,0,0,0,34,0,0,8,100,0,0,120,34,0,0,152,34,0,0,0,34,0,0,0,34,0,0,8,100,0,0,120,34,0,0,0,34,0,0,0,34,0,0,8,100,0,0,64,35,0,0,32,35,0,0,32,35,0,0,64,35,0,0,32,35,0,0,64,35,0,0,32,35,0,0,176,99,0,0,176,99,0,0,152,67,0,0,32,35,0,0,32,35,0,0,176,99,0,0,152,67,0,0,32,35,0,0,72,35,0,0,72,35,0,0,120,34,0,0,120,34,0,0,120,34,0,0,120,34,0,0,224,99,0,0,224,99,0,0,8,100,0,0,224,99,0,0,8,100,0,0,176,99,0,0,224,99,0,0,176,99,0,0,72,35,0,0,56,35,0,0,208,32,0,0,160,99,0,0,152,67,0,0,0,34,0,0,160,99,0,0,152,67,0,0,0,34,0,0,32,34,0,0,32,33,0,0,8,100,0,0,120,34,0,0,120,34,0,0,8,100,0,0,8,100,0,0,176,99,0,0,160,99,0,0,152,67,0,0,0,34,0,0,32,34,0,0,32,33,0,0,8,100,0,0,120,34,0,0,120,34,0,0,8,100,0,0,8,100,0,0,160,99,0,0,152,67,0,0,0,34,0,0,32,34,0,0,32,33,0,0,8,100,0,0,120,34,0,0,120,34,0,0,8,100,0,0,160,99,0,0,152,67,0,0,0,34,0,0,32,34,0,0,32,33,0,0,8,100,0,0,120,34,0,0,120,34,0,0,160,99,0,0,152,67,0,0,0,34,0,0,32,34,0,0,32,33,0,0,8,100,0,0,120,34,0,0,160,99,0,0,152,67,0,0,0,34,0,0,32,34,0,0,32,33,0,0,8,100,0,0,160,99,0,0,152,67,0,0,0,34,0,0,32,34,0,0,32,33,0,0,160,99,0,0,104,35,0,0,0,34,0,0,0,34,0,0,8,100,0,0,160,99,0,0,104,35,0,0,0,34,0,0,0,34,0,0,160,99,0,0,104,35,0,0,0,34,0,0,200,35,0,0,224,99,0,0,8,100,0,0,176,99,0,0,200,35,0,0,224,99,0,0,8,100,0,0,200,35,0,0,224,99,0,0,200,35,0,0,160,99,0,0,152,35,0,0,0,34,0,0,0,34,0,0,8,100,0,0,160,99,0,0,152,35,0,0,0,34,0,0,0,34,0,0,160,99,0,0,208,35,0,0,120,34,0,0,0,36,0,0,8,100,0,0,120,34,0,0,0,36,0,0,8,100,0,0,0,36,0,0,160,99,0,0,224,35,0,0,160,99,0,0,208,35,0,0,8,100,0,0,120,34,0,0,240,35,0,0,8,100,0,0,240,35,0,0,160,99,0,0,208,35,0,0,0,34,0,0,0,34,0,0,160,99,0,0,64,35,0,0,0,34,0,0,32,35,0,0,160,99,0,0,64,35,0,0,0,34,0,0,0,34,0,0,64,35,0,0,32,35,0,0,0,34,0,0,64,35,0,0,160,99,0,0,64,35,0,0,200,33,0,0,32,35,0,0,160,99,0,0,64,35,0,0,200,33,0,0,160,99,0,0,64,35,0,0,200,33,0,0,176,32,0,0,176,99,0,0,72,36,0,0,32,35,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,120,32,0,0,8,100,0,0,224,99,0,0,224,99,0,0,120,34,0,0,120,34,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,120,32,0,0,8,100,0,0,224,99,0,0,224,99,0,0,120,34,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,120,32,0,0,8,100,0,0,224,99,0,0,224,99,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,120,32,0,0,8,100,0,0,224,99,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,120,32,0,0,8,100,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,120,32,0,0,80,36,0,0,80,36,0,0,56,35,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,120,32,0,0,32,33,0,0,8,100,0,0,224,99,0,0,224,99,0,0,120,34,0,0,120,34,0,0,176,99,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,120,32,0,0,32,33,0,0,8,100,0,0,224,99,0,0,224,99,0,0,120,34,0,0,120,34,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,120,32,0,0,32,33,0,0,8,100,0,0,224,99,0,0,224,99,0,0,120,34,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,120,32,0,0,32,33,0,0,8,100,0,0,224,99,0,0,224,99,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,120,32,0,0,32,33,0,0,8,100,0,0,224,99,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,120,32,0,0,32,33,0,0,8,100,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,120,32,0,0,32,33,0,0,176,99,0,0,96,36,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,8,100,0,0,224,99,0,0,224,99,0,0,120,34,0,0,120,34,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,8,100,0,0,224,99,0,0,224,99,0,0,120,34,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,8,100,0,0,224,99,0,0,224,99,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,8,100,0,0,224,99,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,8,100,0,0,160,99,0,0,72,36,0,0,0,34,0,0,32,34,0,0,0,0,0,0,160,38,0,0,1,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,136,38,0,0,2,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,112,36,0,0,5,0,0,0,6,0,0,0,7,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,0,0,0,0,216,38,0,0,1,0,0,0,8,0,0,0,9,0,0,0,0,0,0,0,192,38,0,0,2,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,176,38,0,0,5,0,0,0,12,0,0,0,13,0,0,0,56,161,7,0,171,156,2,0,225,152,2,0,253,12,0,0,1,0,0,0,60,161,7,0,26,157,2,0,225,152,2,0,212,13,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,12,0,0,0,15,0,0,0,16,0,0,0,18,0,0,0,20,0,0,0,24,0,0,0,25,0,0,0,27,0,0,0,30,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,45,0,0,0,48,0,0,0,50,0,0,0,54,0,0,0,60,0,0,0,64,0,0,0,72,0,0,0,75,0,0,0,80,0,0,0,81,0,0,0,90,0,0,0,96,0,0,0,100,0,0,0,108,0,0,0,120,0,0,0,125,0,0,0,128,0,0,0,135,0,0,0,144,0,0,0,150,0,0,0,160,0,0,0,162,0,0,0,180,0,0,0,192,0,0,0,200,0,0,0,216,0,0,0,225,0,0,0,240,0,0,0,243,0,0,0,250,0,0,0,0,1,0,0,14,1,0,0,32,1,0,0,44,1,0,0,64,1,0,0,68,1,0,0,104,1,0,0,119,1,0,0,128,1,0,0,144,1,0,0,149,1,0,0,176,1,0,0,194,1,0,0,224,1,0,0,230,1,0,0,244,1,0,0,0,2,0,0,28,2,0,0,64,2,0,0,88,2,0,0,113,2,0,0,128,2,0,0,136,2,0,0,163,2,0,0,208,2,0,0,217,2,0,0,238,2,0,0,0,3,0,0,32,3,0,0,42,3,0,0,96,3,0,0,132,3,0,0,192,3,0,0,204,3,0,0,232,3,0,0,0,4,0,0,56,4,0,0,101,4,0,0,128,4,0,0,176,4,0,0,191,4,0,0,226,4,0,0,0,5,0,0,16,5,0,0,70,5,0,0,160,5,0,0,178,5,0,0,220,5,0,0,0,6,0,0,64,6,0,0,84,6,0,0,192,6,0,0,8,7,0,0,83,7,0,0,128,7,0,0,152,7,0,0,208,7,0,0,233,7,0,0,0,8,0,0,112,8,0,0,139,8,0,0,202,8,0,0,0,9,0,0,96,9,0,0,126,9,0,0,196,9,0,0,0,10,0,0,32,10,0,0,140,10,0,0,64,11,0,0,100,11,0,0,184,11,0,0,0,12,0,0,53,12,0,0,128,12,0,0,168,12,0,0,47,13,0,0,128,13,0,0,16,14,0,0,61,14,0,0,166,14,0,0,0,15,0,0,48,15,0,0,160,15,0,0,210,15,0,0,0,16,0,0,224,16,0,0,22,17,0,0,148,17,0,0,0,18,0,0,192,18,0,0,252,18,0,0,136,19,0,0,0,20,0,0,64,20,0,0,24,21,0,0,249,21,0,0,128,22,0,0,200,22,0,0,112,23,0,0,187,23,0,0,0,24,0,0,106,24,0,0,0,25,0,0,80,25,0,0,161,25,0,0,94,26,0,0,0,27,0,0,32,28,0,0,122,28,0,0,76,29,0,0,0,30,0,0,96,30,0,0,64,31,0,0,164,31,0,0,0,32,0,0,192,33,0,0,44,34,0,0,40,35,0,0,0,36,0,0,159,36,0,0,128,37,0,0,248,37,0,0,16,39,0,0,141,39,0,0,0,40,0,0,128,40,0,0,48,42,0,0,183,42,0,0,242,43,0,0,0,45,0,0,144,45,0,0,224,46,0,0,118,47,0,0,0,48,0,0,212,48,0,0,0,50,0,0,160,50,0,0,66,51,0,0,188,52,0,0,0,54,0,0,64,56,0,0,244,56,0,0,152,58,0,0,0,60,0,0,192,60,0,0,9,61,0,0,128,62,0,0,72,63,0,0,0,64,0,0,235,65,0,0,128,67,0,0,88,68,0,0,80,70,0,0,49,71,0,0,0,72,0,0,62,73,0,0,0,75,0,0,240,75,0,0,227,76,0,0,32,78,0,0,26,79,0,0,0,80,0,0,0,81,0,0,96,84,0,0,110,85,0,0,228,87,0,0,0,90,0,0,32,91,0,0,192,93,0,0,236,94,0,0,0,96,0,0,168,97,0,0,0,100,0,0,64,101,0,0,132,102,0,0,120,105,0,0,0,108,0,0,221,109,0,0,128,112,0,0,232,113,0,0,48,117,0,0,167,118,0,0,0,120,0,0,128,121,0,0,18,122,0,0,0,125,0,0,144,126,0,0,0,128,0,0,37,128,0,0,214,131,0,0,0,135,0,0,176,136,0,0,160,140,0,0,98,142,0,0,0,144,0,0,124,146,0,0,0,150,0,0,224,151,0,0,198,153,0,0,64,156,0,0,52,158,0,0,0,160,0,0,0,162,0,0,192,168,0,0,220,170,0,0,200,175,0,0,0,180,0,0,64,182,0,0,27,183,0,0,128,187,0,0,216,189,0,0,0,192,0,0,80,195,0,0,193,197,0,0,0,200,0,0,128,202,0,0,8,205,0,0,240,210,0,0,147,213,0,0,0,216,0,0,186,219,0,0,0,225,0,0,208,227,0,0,169,230,0,0,96,234,0,0,78,237,0,0,0,240,0,0,0,243,0,0,36,244,0,0,0,250,0,0,32,253,0,0,0,0,1,0,74,0,1,0,172,7,1,0,0,14,1,0,96,17,1,0,64,25,1,0,196,28,1,0,0,32,1,0,248,36,1,0,0,44,1,0,192,47,1,0,45,49,1,0,140,51,1,0,128,56,1,0,104,60,1,0,0,64,1,0,0,68,1,0,151,73,1,0,128,81,1,0,184,85,1,0,144,95,1,0,245,99,1,0,0,104,1,0,128,108,1,0,54,110,1,0,0,119,1,0,176,123,1,0,0,128,1,0,111,128,1,0,160,134,1,0,130,139,1,0,0,144,1,0,0,149,1,0,16,154,1,0,224,165,1,0,38,171,1,0,0,176,1,0,116,183,1,0,0,194,1,0,160,199,1,0,82,205,1,0,192,212,1,0,156,218,1,0,0,224,1,0,0,230,1,0,72,232,1,0,0,244,1,0,64,250,1,0,0,0,2,0,148,0,2,0,88,15,2,0,0,28,2,0,192,34,2,0,81,37,2,0,128,50,2,0,136,57,2,0,0,64,2,0,240,73,2,0,67,81,2,0,0,88,2,0,128,95,2,0,90,98,2,0,24,103,2,0,0,113,2,0,208,120,2,0,0,128,2,0,185,128,2,0,0,136,2,0,46,147,2,0,0,163,2,0,112,171,2,0,251,179,2,0,32,191,2,0,234,199,2,0,0,208,2,0,0,217,2,0,108,220,2,0,0,238,2,0,96,247,2,0,0,0,3,0,222,0,3,0,64,13,3,0,4,23,3,0,0,32,3,0,0,42,3,0,32,52,3,0,192,75,3,0,76,86,3,0,0,96,3,0,232,110,3,0,0,132,3,0,64,143,3,0,135,147,3,0,164,154,3,0,128,169,3,0,56,181,3,0,0,192,3,0,0,204,3,0,144,208,3,0,197,220,3,0,0,232,3,0,128,244,3,0,0,0,4,0,40,1,4,0,176,30,4,0,223,43,4,0,0,56,4,0,128,69,4,0,162,74,4,0,0,101,4,0,16,115,4,0,0,128,4,0,77,129,4,0,224,147,4,0,134,162,4,0,0,176,4,0,0,191,4,0,180,196,4,0,48,206,4,0,0,226,4,0,160,241,4,0,0,0,5,0,114,1,5,0,0,16,5,0,92,38,5,0,0,70,5,0,224,86,5,0,246,103,5,0,64,126,5,0,212,143,5,0,0,160,5,0,0,178,5,0,216,184,5,0,0,220,5,0,192,238,5,0,225,245,5,0,0,0,6,0,188,1,6,0,128,26,6,0,8,46,6,0,0,64,6,0,0,84,6,0,64,104,6,0,243,111,6,0,128,151,6,0,152,172,6,0,0,192,6,0,208,221,6,0,201,243,6,0,0,8,7,0,128,30,7,0,14,39,7,0,72,53,7,0,0,83,7,0,112,106,7,0,0,128,7,0,43,130,7,0,0,152,7,0,32,161,7,0,138,185,7,0,0,208,7,0,0,233,7,0,0,0,8,0,80,2,8,0,241,27,8,0,96,61,8,0,190,87,8,0,0,112,8,0,0,139,8,0,68,149,8,0,0,202,8,0,32,230,8,0,0,0,9,0,154,2,9,0,192,39,9,0,12,69,9,0,0,96,9,0,0,126,9,0,104,137,9,0,96,156,9,0,0,196,9,0,64,227,9,0,0,0,10,0,228,2,10,0,0,32,10,0,184,76,10,0,0,140,10,0,192,173,10,0,149,186,10,0,236,207,10,0,128,252,10,0,168,31,11,0,0,64,11,0,0,100,11,0,176,113,11,0,79,150,11,0,0,184,11,0,128,221,11,0,194,235,11,0,0,0,12,0,120,3,12,0,0,53,12,0,16,92,12,0,0,128,12,0,157,131,12,0,0,168,12,0,128,208,12,0,230,223,12,0,0,47,13,0,48,89,13,0,0,128,13,0,231,131,13,0,160,187,13,0,146,231,13,0,0,16,14,0,0,61,14,0,28,78,14,0,144,106,14,0,0,166,14,0,224,212,14,0,0,0,15,0,86,4,15,0,0,48,15,0,64,66,15,0,20,115,15,0,0,160,15,0,0,210,15,0,0,0,16,0,160,4,16,0,226,55,16,0,192,122,16,0,124,175,16,0,0,224,16,0,0,22,17,0,136,42,17,0,0,148,17,0,64,204,17,0,163,225,17,0,0,0,18,0,52,5,18,0,128,79,18,0,24,138,18,0,0,192,18,0,0,252,18,0,208,18,19,0,192,56,19,0,217,79,19,0,0,136,19,0,128,198,19,0,0,0,20,0,200,5,20,0,0,64,20,0,112,153,20,0,91,219,20,0,0,24,21,0,128,91,21,0,42,117,21,0,216,159,21,0,0,249,21,0,80,63,22,0,0,128,22,0,129,134,22,0,0,200,22,0,96,227,22,0,158,44,23,0,0,112,23,0,0,187,23,0,132,215,23,0,0,0,24,0,240,6,24,0,211,83,24,0,0,106,24,0,32,184,24,0,0,0,25,0,58,7,25,0,0,80,25,0,0,161,25,0,204,191,25,0,0,94,26,0,96,178,26,0,0,0,27,0,206,7,27,0,64,119,27,0,36,207,27,0,0,32,28,0,0,122,28,0,56,156,28,0,32,213,28,0,0,76,29,0,192,169,29,0,101,205,29,0,0,0,30,0,172,8,30,0,0,96,30,0,128,132,30,0,40,230,30,0,0,64,31,0,0,164,31,0,0,0,32,0,64,9,32,0,191,47,32,0,196,111,32,0,128,245,32,0,248,94,33,0,0,192,33,0,0,44,34,0,16,85,34,0,237,194,34,0,0,40,35,0,128,152,35,0,70,195,35,0,0,0,36,0,104,10,36,0,0,159,36,0,48,20,37,0,0,128,37,0,215,138,37,0,0,248,37,0,160,37,38,0,128,113,38,0,178,159,38,0,0,16,39,0,0,141,39,0,0,0,40,0,144,11,40,0,0,128,40,0,181,139,40,0,224,50,41,0,182,182,41,0,0,48,42,0,0,183,42,0,84,234,42,0,176,63,43,0,0,242,43,0,160,126,44,0,0,0,45,0,2,13,45,0,0,144,45,0,192,198,45,0,60,89,46,0,0,224,46,0,0,118,47,0,8,175,47,0,0,0,48,0,224,13,48,0,166,167,48,0,0,212,48,0,64,112,49,0,0,0,50,0,116,14,50,0,0,160,50,0,0,66,51,0,152,127,51,0,0,188,52,0,192,100,53,0,233,164,53,0,0,0,54,0,156,15,54,0,128,238,54,0,72,158,55,0,0,64,56,0,0,244,56,0,112,56,57,0,64,170,57,0,139,239,57,0,0,152,58,0,128,83,59,0,202,154,59,0,0,0,60,0,88,17,60,0,0,192,60,0,0,9,61,0,80,204,61,0,0,128,62,0,17,146,62,0,0,72,63,0,0,0,64,0,128,18,64,0,126,95,64,0,136,223,64,0,0,235,65,0,240,189,66,0,0,128,67,0,131,147,67,0,0,88,68,0,32,170,68,0,218,133,69,0,0,80,70,0,0,49,71,0,140,134,71,0,0,0,72,0,208,20,72,0,121,251,72,0,0,62,73,0,96,40,74,0,0,0,75,0,174,21,75,0,0,240,75,0,64,75,76,0,0,227,76,0,100,63,77,0,0,32,78,0,0,26,79,0,0,0,80,0,32,23,80,0,0,0,81,0,106,23,81,0,192,101,82,0,108,109,83,0,0,96,84,0,0,110,85,0,168,212,85,0,96,127,86,0,0,228,87,0,64,253,88,0,47,104,89,0,0,0,90,0,4,26,90,0,0,32,91,0,128,141,91,0,120,178,92,0,0,192,93,0,0,236,94,0,16,94,95,0,0,0,96,0,192,27,96,0,61,143,96,0,76,79,97,0,0,168,97,0,128,224,98,0,0,0,100,0,232,28,100,0,0,64,101,0,0,132,102,0,48,255,102,0,199,72,104,0,0,120,105,0,128,201,106,0,210,73,107,0,0,0,108,0,56,31,108,0,0,221,109,0,144,60,111,0,0,128,112,0,133,160,112,0,0,232,113,0,224,112,114,0,128,84,115,0,22,223,115,0,0,48,117,0,0,167,118,0,148,53,119,0,0,0,120,0,176,34,120,0,0,128,121,0,31,163,121,0,0,18,122,0,160,152,123,0,0,0,125,0,34,36,125,0,0,144,126,0,0,0,128,0,0,37,128,0,252,190,128,0,16,191,129,0,0,214,131,0,224,123,133,0,0,0,135,0,6,39,135,0,0,176,136,0,64,84,137,0,180,11,139,0,0,160,140,0,0,98,142,0,24,13,143,0,0,0,144,0,160,41,144,0,242,246,145,0,0,124,146,0,192,80,148,0,249,2,149,0,0,0,150,0,92,43,150,0,0,224,151,0,128,150,152,0,0,198,153,0,200,126,154,0,0,64,156,0,0,52,158,0,0,0,160,0,64,46,160,0,187,238,160,0,0,0,162,0,212,46,162,0,128,203,164,0,216,218,166,0,0,192,168,0,0,220,170,0,80,169,171,0,192,254,172,0,161,206,173,0,0,200,175,0,128,250,177,0,94,208,178,0,0,0,180,0,8,52,180,0,0,64,182,0,0,27,183,0,240,100,185,0,0,128,187,0,51,182,187,0,0,216,189,0,32,188,190,0,0,0,192,0,128,55,192,0,122,30,193,0,152,158,194,0,0,80,195,0,0,193,197,0,0,0,200,0,208,57,200,0,0,128,202,0,137,186,202,0,0,8,205,0,96,254,205,0,142,145,208,0,0,240,210,0,0,147,213,0,164,147,214,0,0,0,216,0,112,62,216,0,0,186,219,0,32,121,222,0,0,0,225,0,10,65,225,0,0,208,227,0,192,225,228,0,0,169,230,0,44,190,231,0,0,96,234,0,0,78,237,0,40,107,238,0,0,0,240,0,96,69,240,0,0,0,243,0,62,70,243,0,0,36,244,0,64,49,247,0,0,0,250,0,68,72,250,0,0,32,253,0,0,0,0,1,0,74,0,1,248,125,1,1,32,126,3,1,0,172,7,1,192,247,10,1,141,56,12,1,0,0,14,1,12,78,14,1,0,96,17,1,128,168,18,1,104,23,22,1,0,64,25,1,0,196,28,1,48,26,30,1,0,0,32,1,64,83,32,1,183,173,33,1,228,237,35,1,0,248,36,1,128,161,40,1,242,5,42,1,0,0,44,1,184,86,44,1,0,192,47,1,0,45,49,1,0,140,51,1,144,253,52,1,0,128,56,1,85,218,56,1,0,104,60,1,0,0,64,1,128,92,64,1,118,221,65,1,0,0,68,1,168,93,68,1,0,151,73,1,176,181,77,1,0,128,81,1,143,225,81,1,0,184,85,1,160,82,87,1,128,253,89,1,66,157,91,1,0,144,95,1,0,245,99,1,188,160,101,1,0,0,104,1,16,104,104,1,0,128,108,1,93,233,108,1,0,54,110,1,224,201,114,1,0,0,119,1,102,108,119,1,0,176,123,1,64,120,125,1,0,0,128,1,0,111,128,1,244,60,130,1,48,61,133,1,0,160,134,1,0,130,139,1,0,0,144,1,160,115,144,1,0,0,149,1,18,117,149,1,0,16,154,1,192,252,155,1,28,35,161,1,0,224,165,1,0,38,171,1,72,39,173,1,0,0,176,1,224,124,176,1,0,116,183,1,64,242,188,1,235,8,191,1,0,0,194,1,20,130,194,1,0,160,199,1,128,195,201,1,0,82,205,1,88,124,207,1,0,192,212,1,0,156,218,1,80,214,220,1,0,0,224,1,192,138,224,1,49,204,226,1,0,0,230,1,124,140,230,1,0,72,232,1,128,98,238,1,0,0,244,1,136,144,244,1,0,64,250,1,0,0,0,2,0,148,0,2,240,251,2,2,64,252,6,2,227,107,9,2,0,88,15,2,128,239,21,2,26,113,24,2,0,0,28,2,24,156,28,2,0,192,34,2,0,81,37,2,208,46,44,2,0,128,50,2,153,34,51,2,0,136,57,2,96,52,60,2,0,0,64,2,128,166,64,2,110,91,67,2,200,219,71,2,0,240,73,2,0,67,81,2,228,11,84,2,0,0,88,2,112,173,88,2,0,128,95,2,155,47,96,2,0,90,98,2,0,24,103,2,32,251,105,2,0,0,113,2,170,180,113,2,0,208,120,2,0,0,128,2,0,185,128,2,236,186,131,2,0,0,136,2,80,187,136,2,0,46,147,2,96,107,155,2,0,0,163,2,30,195,163,2,0,112,171,2,64,165,174,2,0,251,179,2,132,58,183,2,0,32,191,2,0,234,199,2,120,65,203,2,0,0,208,2,32,208,208,2,0,0,217,2,186,210,217,2,0,108,220,2,192,147,229,2,221,14,233,2,0,0,238,2,204,216,238,2,0,96,247,2,128,240,250,2,0,0,0,3,0,222,0,3,232,121,4,3,96,122,10,3,0,64,13,3,0,4,23,3,0,0,32,3,64,231,32,3,167,169,36,3,0,0,42,3,36,234,42,3,0,32,52,3,128,249,55,3,56,70,66,3,0,192,75,3,0,76,86,3,144,78,90,3,0,0,96,3,192,249,96,3,37,9,101,3,0,232,110,3,128,228,121,3,214,17,126,3,0,0,132,3,40,4,133,3,0,64,143,3,0,135,147,3,0,164,154,3,176,248,158,3,0,128,169,3,255,142,170,3,0,56,181,3,160,172,185,3,0,0,192,3,128,21,193,3,98,152,197,3,0,0,204,3,248,24,205,3,0,144,208,3,0,197,220,3,0,0,232,3,16,33,233,3,0,128,244,3,173,164,245,3,0,0,0,4,0,40,1,4,224,247,5,4,128,248,13,4,198,215,18,4,0,176,30,4,0,223,43,4,52,226,48,4,0,0,56,4,48,56,57,4,0,128,69,4,0,162,74,4,160,93,88,4,0,0,101,4,50,69,102,4,0,16,115,4,192,104,120,4,0,0,128,4,0,77,129,4,220,182,134,4,144,183,143,4,0,224,147,4,0,134,162,4,200,23,168,4,0,0,176,4,224,90,177,4,0,0,191,4,54,95,192,4,0,180,196,4,0,48,206,4,64,246,211,4,0,0,226,4,84,105,227,4,0,160,241,4,0,0,0,5,0,114,1,5,216,117,7,5,0,0,16,5,160,118,17,5,0,92,38,5,192,214,54,5,193,26,61,5,0,0,70,5,60,134,71,5,0,224,86,5,128,74,93,5,0,246,103,5,8,117,110,5,0,64,126,5,0,212,143,5,240,130,150,5,0,0,160,5,64,160,161,5,147,100,168,5,0,0,178,5,116,165,179,5,0,216,184,5,128,39,203,5,186,29,210,5,0,0,220,5,152,177,221,5,0,192,238,5,0,225,245,5,0,0,0,6,0,188,1,6,208,243,8,6,192,244,20,6,0,128,26,6,169,67,28,6,0,8,46,6,0,0,64,6,128,206,65,6,78,83,73,6,0,0,84,6,72,212,85,6,0,64,104,6,0,243,111,6,112,140,132,6,0,128,151,6,203,103,153,6,0,152,172,6,32,157,180,6,0,0,192,6,128,243,193,6,74,18,202,6,0,208,221,6,0,201,243,6,172,35,252,6,0,0,8,7,80,8,10,7,0,128,30,7,209,142,32,7,0,14,39,7,0,72,53,7,96,241,61,7,0,0,83,7,254,29,85,7,0,112,106,7,64,89,115,7,0,0,128,7,0,43,130,7,196,48,139,7,0,0,152,7,240,49,154,7,0,32,161,7,0,138,185,7,0,0,208,7,32,66,210,7,0,0,233,7,90,73,235,7,0,0,0,8,0,80,2,8,192,239,11,8,0,241,27,8,140,175,37,8,0,96,61,8,0,190,87,8,104,196,97,8,0,0,112,8,96,112,114,8,0,0,139,8,0,68,149,8,64,187,176,8,151,44,187,8,0,0,202,8,100,138,204,8,0,32,230,8,128,209,240,8,0,0,0,9,0,154,2,9,184,109,13,9,32,111,31,9,0,192,39,9,0,12,69,9,144,47,80,9,0,0,96,9,192,181,98,9,245,252,109,9,0,0,126,9,108,190,128,9,0,104,137,9,0,96,156,9,128,236,167,9,0,0,196,9,168,210,198,9,0,64,227,9,0,0,0,10,0,228,2,10,176,235,14,10,0,0,32,10,64,237,34,10,111,27,47,10,0,184,76,10,128,173,109,10,130,53,122,10,0,0,140,10,120,12,143,10,0,192,173,10,0,149,186,10,0,236,207,10,16,234,220,10,0,128,252,10,253,172,255,10,0,168,31,11,224,5,45,11,0,0,64,11,128,64,67,11,38,201,80,11,0,0,100,11,232,74,103,11,0,176,113,11,0,79,150,11,116,59,164,11,0,0,184,11,48,99,187,11,0,128,221,11,7,238,224,11,0,194,235,11,0,0,0,12,0,120,3,12,160,231,17,12,128,233,41,12,0,0,53,12,82,135,56,12,0,16,92,12,0,0,128,12,0,157,131,12,156,166,146,12,0,0,168,12,144,168,171,12,0,128,208,12,0,230,223,12,224,24,9,13,0,0,47,13,150,207,50,13,0,48,89,13,64,58,105,13,0,0,128,13,0,231,131,13,148,36,148,13,0,160,187,13,0,146,231,13,88,71,248,13,0,0,16,14,160,16,20,14,0,0,61,14,162,29,65,14,0,28,78,14,0,144,106,14,192,226,123,14,81,74,141,14,0,0,166,14,252,59,170,14,0,224,212,14,128,178,230,14,0,0,0,15,0,86,4,15,136,97,22,15,0,0,48,15,224,99,52,15,0,64,66,15,0,20,115,15,0,0,160,15,64,132,164,15,67,80,183,15,0,0,210,15,180,146,214,15,0,0,0,16,0,160,4,16,128,223,23,16,0,226,55,16,24,95,75,16,0,192,122,16,0,124,175,16,208,136,195,16,0,0,224,16,192,224,228,16,185,45,249,16,0,0,22,17,0,136,42,17,128,118,97,17,46,89,118,17,0,0,148,17,200,20,153,17,0,64,204,17,0,163,225,17,0,0,0,18,0,52,5,18,112,219,26,18,64,222,62,18,0,128,79,18,251,202,84,18,0,24,138,18,32,95,160,18,0,0,192,18,128,107,197,18,234,249,219,18,0,0,252,18,216,124,1,19,0,208,18,19,0,192,56,19,0,217,79,19,0,0,136,19,80,165,141,19,0,128,198,19,97,55,204,19,0,0,0,20,0,200,5,20,96,215,29,20,0,0,64,20,128,218,69,20,222,54,94,20,0,112,153,20,0,91,219,20,4,107,244,20,0,0,24,21,240,24,30,21,0,128,91,21,0,42,117,21,0,216,159,21,32,212,185,21,0,0,249,21,250,89,255,21,0,80,63,22,192,11,90,22,0,0,128,22,0,129,134,22,76,146,161,22,0,0,200,22,208,149,206,22,0,96,227,22,0,158,44,23,232,118,72,23,0,0,112,23,96,198,118,23,0,0,187,23,14,220,193,23,0,132,215,23,0,0,0,24,0,240,6,24,64,207,35,24,0,211,83,24,0,0,106,24,164,14,113,24,0,32,184,24,0,0,0,25,0,58,7,25,56,77,37,25,0,0,80,25,32,81,87,25,0,0,161,25,0,204,191,25,192,49,18,26,197,133,49,26,0,0,94,26,44,159,101,26,0,96,178,26,128,116,210,26,0,0,0,27,0,206,7,27,40,73,40,27,0,64,119,27,0,36,207,27,176,142,240,27,0,0,32,28,64,33,40,28,223,246,73,28,0,0,122,28,68,59,130,28,0,56,156,28,0,32,213,28,128,197,247,28,162,148,26,29,0,0,76,29,248,119,84,29,0,192,169,29,0,101,205,29,0,0,0,30,0,172,8,30,16,195,44,30,0,0,96,30,192,199,104,30,0,128,132,30,77,82,141,30,0,40,230,30,0,0,64,31,128,8,73,31,134,160,110,31,0,0,164,31,104,37,173,31,0,0,0,32,0,64,9,32,0,191,47,32,0,196,111,32,48,190,150,32,0,128,245,32,247,6,255,32,0,248,94,33,160,17,135,33,0,0,192,33,128,193,201,33,114,91,242,33,0,0,44,34,0,16,85,34,0,237,194,34,92,178,236,34,0,0,40,35,144,41,50,35,0,128,152,35,21,202,162,35,0,70,195,35,0,0,0,36,0,104,10,36,224,182,53,36,128,188,125,36,0,0,159,36,246,149,169,36,0,48,20,37,64,190,64,37,0,0,128,37,0,215,138,37,212,243,183,37,0,0,248,37,176,249,2,38,0,160,37,38,0,128,113,38,0,178,159,38,0,0,16,39,160,74,27,39,0,0,141,39,194,110,152,39,0,0,0,40,0,144,11,40,192,174,59,40,0,0,128,40,0,181,139,40,188,109,188,40,0,224,50,41,0,182,182,41,8,214,232,41,0,0,48,42,224,49,60,42,0,0,183,42,0,84,234,42,0,176,63,43,64,168,115,43,243,222,167,43,0,0,242,43,244,179,254,43,0,160,126,44,128,23,180,44,0,0,0,45,0,2,13,45,152,36,67,45,0,0,144,45,160,43,157,45,0,192,198,45,0,60,89,46,208,237,144,46,0,0,224,46,192,140,237,46,201,240,37,47,0,0,118,47,28,184,131,47,0,8,175,47,0,0,0,48,0,224,13,48,128,158,71,48,0,166,167,48,0,0,212,48,72,29,226,48,0,64,112,49,0,0,0,50,0,116,14,50,112,154,74,50,0,0,160,50,64,162,174,50,43,137,235,50,0,0,66,51,0,152,127,51,128,99,36,52,138,11,99,52,0,0,188,52,88,62,203,52,0,192,100,53,0,233,164,53,0,0,0,54,0,156,15,54,80,146,80,54,0,128,238,54,241,96,254,54,0,72,158,55,96,29,225,55,0,0,64,56,128,66,80,56,190,237,147,56,0,0,244,56,136,118,4,57,0,112,56,57,0,64,170,57,0,139,239,57,68,41,53,58,0,0,152,58,240,239,168,58,0,128,83,59,35,166,100,59,0,202,154,59,0,0,0,60,0,88,17,60,32,134,89,60,0,0,192,60,128,143,209,60,0,0,9,61,154,164,26,61,0,80,204,61,0,0,128,62,0,17,146,62,12,65,221,62,0,0,72,63,208,74,90,63,0,0,0,64,0,128,18,64,0,126,95,64,0,136,223,64,96,124,45,65,0,0,235,65,238,13,254,65,0,240,189,66,64,35,14,67,0,0,128,67,0,131,147,67,228,182,228,67,0,0,88,68,0,32,170,68,0,218,133,69,184,100,217,69,0,0,80,70,32,83,100,70,0,0,49,71,42,148,69,71,0,140,134,71,0,0,0,72,0,208,20,72,192,109,107,72,149,115,194,72,0,121,251,72,0,0,62,73,236,43,83,73,0,96,40,74,128,124,129,74,0,0,0,75,0,174,21,75,168,231,111,75,0,0,240,75,96,243,5,76,0,64,75,76,0,0,227,76,0,100,63,77,0,0,32,78,64,149,54,78,79,145,148,78,0,0,26,79,132,221,48,79,0,0,0,80,0,32,23,80,128,93,119,80,0,0,0,81,0,106,23,81,120,219,120,81,0,192,101,82,0,108,109,83,16,172,209,83,0,0,96,84,192,99,120,84,157,228,221,84,0,0,110,85,0,168,212,85,0,96,127,86,128,80,231,86,230,189,79,87,0,0,228,87,232,103,253,87,0,64,253,88,0,47,104,89,0,0,0,90,0,4,26,90,48,73,134,90,0,0,32,91,64,87,58,91,0,128,141,91,231,246,167,91,0,120,178,92,160,219,33,93,0,0,192,93,128,25,219,93,146,225,75,94,0,0,236,94,56,112,7,95,0,16,94,95,0,0,0,96,0,192,27,96,0,61,143,96,0,76,79,97,0,0,168,97,144,58,196,97,0,128,224,98,229,20,253,98,0,0,0,100,0,232,28,100,224,52,149,100,0,0,64,101,128,68,93,101,86,18,215,101,0,0,132,102,0,48,255,102,0,199,72,104,20,23,198,104,0,0,120,105,176,124,150,105,0,128,201,106,0,210,73,107,0,0,0,108,0,56,31,108,160,36,161,108,0,0,221,109,226,193,252,109,0,144,60,111,192,58,194,111,0,0,128,112,0,133,160,112,124,219,39,113,0,0,232,113,16,237,8,114,0,224,112,114,0,128,84,115,0,22,223,115,136,82,106,116,0,0,48,117,224,223,81,117,0,0,167,118,70,76,201,118,0,148,53,119,0,0,0,120,0,176,34,120,64,12,179,120,0,0,128,121,0,31,163,121,0,0,18,122,52,73,53,122,0,160,152,123,0,0,0,125,0,34,36,125,24,130,186,125,0,0,144,126,160,149,180,126,72,161,7,0,234,159,2,0,255,157,2,0,233,0,0,0,1,0,0,0,68,161,7,0,158,159,2,0,255,157,2,0,105,0,0,0,1,0,0,0,0,0,0,0,248,38,0,0,14,0,0,0,15,0,0,0,1,0,0,0,0,0,0,0,232,38,0,0,14,0,0,0,16,0,0,0,2,0,0,0,64,161,7,0,47,159,2,0,255,157,2,0,77,0,0,0,1,0,0,0,76,161,7,0,143,161,2,0,95,160,2,0,116,1,0,0,1,0,0,0,80,161,7,0,213,161,2,0,95,160,2,0,124,1,0,0,1,0,0,0,84,161,7,0,26,162,2,0,95,160,2,0,132,1,0,0,1,0,0,0,88,161,7,0,96,162,2,0,95,160,2,0,140,1,0,0,1,0,0,0,92,161,7,0,154,162,2,0,95,160,2,0,148,1,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,96,161,7,0,204,162,2,0,95,160,2,0,155,1,0,0,1,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,100,161,7,0,254,162,2,0,95,160,2,0,162,1,0,0,1,0,0,0,104,161,7,0,56,163,2,0,95,160,2,0,170,1,0,0,1,0,0,0,108,161,7,0,87,165,2,0,95,160,2,0,156,3,0,0,1,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,112,161,7,0,154,165,2,0,95,160,2,0,164,3,0,0,1,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,116,161,7,0,226,165,2,0,95,160,2,0,224,3,0,0,1,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,0,0,0,0,120,161,7,0,24,166,2,0,95,160,2,0,21,4,0,0,1,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,0,0,0,0,124,161,7,0,92,166,2,0,95,160,2,0,30,4,0,0,1,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,128,161,7,0,158,166,2,0,95,160,2,0,38,4,0,0,1,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,0,0,0,0,132,161,7,0,212,166,2,0,95,160,2,0,67,4,0,0,1,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,0,0,0,0,136,161,7,0,28,168,2,0,95,160,2,0,207,4,0,0,1,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,0,0,0,0,140,161,7,0,65,169,2,0,95,160,2,0,217,6,0,0,1,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,0,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,144,167,7,0,236,171,2,0,94,170,2,0,9,3,0,0,1,0,0,0,148,167,7,0,37,172,2,0,94,170,2,0,16,3,0,0,1,0,0,0,152,167,7,0,181,173,2,0,115,173,2,0,158,4,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,156,167,7,0,225,173,2,0,115,173,2,0,75,5,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,0,0,0,0,160,167,7,0,40,174,2,0,115,173,2,0,205,5,0,0,1,0,0,0,164,167,7,0,182,174,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+30720);allocate([115,173,2,0,71,7,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,168,167,7,0,107,175,2,0,115,173,2,0,145,10,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,172,167,7,0,211,175,2,0,115,173,2,0,213,10,0,0,1,0,0,0,176,167,7,0,215,178,2,0,115,173,2,0,109,12,0,0,1,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,180,167,7,0,232,179,2,0,115,173,2,0,47,14,0,0,1,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,0,0,0,0,56,168,7,0,37,181,2,0,57,180,2,0,47,3,0,0,1,0,0,0,52,168,7,0,228,180,2,0,57,180,2,0,142,3,0,0,1,0,0,0,60,168,7,0,78,181,2,0,57,180,2,0,207,3,0,0,1,0,0,0,64,168,7,0,128,181,2,0,173,181,2,0,14,0,0,0,1,0,0,0,68,168,7,0,248,181,2,0,173,181,2,0,22,0,0,0,1,0,0,0,72,168,7,0,121,182,2,0,52,182,2,0,145,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,76,168,7,0,223,182,2,0,52,182,2,0,245,0,0,0,1,0,0,0,84,168,7,0,92,184,2,0,52,182,2,0,70,1,0,0,1,0,0,0,5,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,0,0,0,0,80,168,7,0,6,184,2,0,52,182,2,0,58,2,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,88,168,7,0,145,184,2,0,52,182,2,0,218,1,0,0,1,0,0,0,92,168,7,0,238,184,2,0,52,182,2,0,13,3,0,0,1,0,0,0,96,168,7,0,111,185,2,0,52,182,2,0,127,3,0,0,1,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,8,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,0,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,23,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,0,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,38,0,0,0,46,0,0,0,0,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,168,7,0,181,185,2,0,52,182,2,0,162,15,0,0,1,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,0,0,0,0,104,168,7,0,27,186,2,0,52,182,2,0,194,15,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,108,168,7,0,83,186,2,0,52,182,2,0,51,16,0,0,1,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,0,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,0,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,0,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,0,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,0,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,0,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,168,7,0,187,186,2,0,52,182,2,0,91,18,0,0,1,0,0,0,0,0,0,0,144,39,0,0,1,0,0,0,2,0,0,0,3,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,128,168,7,0,4,189,2,0,112,187,2,0,132,0,0,0,1,0,0,0,0,0,0,0,168,39,0,0,20,0,0,0,21,0,0,0,1,0,0,0,1,0,0,0,4,0,0,0,9,0,0,0,5,0,0,0,110,0,0,0,111,0,0,0,1,0,0,0,6,0,0,0,132,168,7,0,127,203,2,0,112,187,2,0,4,14,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,26,0,0,0,136,168,7,0,195,203,2,0,112,187,2,0,141,4,0,0,1,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,140,168,7,0,60,205,2,0,112,187,2,0,71,12,0,0,1,0,0,0,144,168,7,0,115,205,2,0,112,187,2,0,107,12,0,0,1,0,0,0,148,168,7,0,246,205,2,0,112,187,2,0,116,12,0,0,5,0,0,0,152,168,7,0,45,206,2,0,112,187,2,0,152,12,0,0,1,0,0,0,156,168,7,0,114,206,2,0,112,187,2,0,203,12,0,0,1,0,0,0,160,168,7,0,175,206,2,0,112,187,2,0,250,12,0,0,1,0,0,0,164,168,7,0,253,206,2,0,112,187,2,0,52,14,0,0,1,0,0,0,168,168,7,0,149,207,2,0,112,187,2,0,220,15,0,0,1,0,0,0,0,0,0,0,184,39,0,0,22,0,0,0,23,0,0,0,3,0,0,0,0,0,0,0,200,39,0,0,24,0,0,0,25,0,0,0,1,0,0,0,1,0,0,0,123,22,17,0,0,0,0,0,208,39,0,0,26,0,0,0,27,0,0,0,4,0,0,0,6,0,0,0,200,172,7,0,90,233,2,0,116,233,2,0,104,0,0,0,1,0,0,0,204,172,7,0,11,234,2,0,116,233,2,0,147,0,0,0,1,0,0,0,208,172,7,0,146,234,2,0,116,233,2,0,13,1,0,0,1,0,0,0,212,172,7,0,85,235,2,0,116,233,2,0,50,2,0,0,1,0,0,0,216,172,7,0,166,235,2,0,116,233,2,0,153,2,0,0,1,0,0,0,220,172,7,0,208,235,2,0,116,233,2,0,186,2,0,0,1,0,0,0,224,172,7,0,246,235,2,0,116,233,2,0,180,4,0,0,1,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,228,172,7,0,36,236,2,0,116,233,2,0,75,5,0,0,1,0,0,0,232,172,7,0,101,236,2,0,116,233,2,0,45,6,0,0,1,0,0,0,236,172,7,0,57,237,2,0,116,233,2,0,202,6,0,0,1,0,0,0,240,172,7,0,232,237,2,0,116,233,2,0,93,7,0,0,1,0,0,0,244,172,7,0,27,238,2,0,54,238,2,0,72,3,0,0,1,0,0,0,56,0,0,0,0,0,0,0,248,41,0,0,28,0,0,0,29,0,0,0,200,255,255,255,200,255,255,255,248,41,0,0,30,0,0,0,31,0,0,0,0,0,0,0,232,41,0,0,32,0,0,0,33,0,0,0,7,0,0,0,1,0,0,0,5,0,0,0,16,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,8,0,0,0,7,0,0,0,3,0,0,0,8,0,0,0,240,168,0,0,244,70,0,0,8,71,0,0,4,169,0,0,0,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,121,0,0,0,248,172,7,0,163,239,2,0,62,239,2,0,255,0,0,0,1,0,0,0,0,173,7,0,79,240,2,0,62,239,2,0,115,1,0,0,1,0,0,0,252,172,7,0,35,240,2,0,62,239,2,0,171,1,0,0,1,0,0,0,4,173,7,0,26,241,2,0,62,239,2,0,4,2,0,0,1,0,0,0,8,173,7,0,96,241,2,0,62,239,2,0,228,2,0,0,1,0,0,0,12,173,7,0,195,241,2,0,62,239,2,0,92,3,0,0,1,0,0,0,16,173,7,0,175,242,2,0,62,239,2,0,155,4,0,0,1,0,0,0,83,252,2,0,83,252,2,0,178,40,17,0,178,40,17,0,88,252,2,0,92,252,2,0,88,252,2,0,96,252,2,0,0,0,0,195,0,0,254,194,0,0,252,194,0,0,250,194,0,0,248,194,0,0,246,194,0,0,244,194,0,0,242,194,0,0,240,194,0,0,238,194,0,0,236,194,0,0,234,194,0,0,232,194,0,0,230,194,0,0,228,194,0,0,226,194,0,0,224,194,0,0,222,194,0,0,220,194,0,0,218,194,0,0,216,194,0,0,214,194,0,0,212,194,0,0,210,194,0,0,208,194,0,0,206,194,0,0,204,194,0,0,202,194,0,0,200,194,0,0,198,194,0,0,196,194,0,0,194,194,0,0,192,194,0,0,190,194,0,0,188,194,0,0,186,194,0,0,184,194,0,0,182,194,0,0,180,194,0,0,178,194,0,0,176,194,0,0,174,194,0,0,172,194,0,0,170,194,0,0,168,194,0,0,166,194,0,0,164,194,0,0,162,194,0,0,160,194,0,0,158,194,0,0,156,194,0,0,154,194,0,0,152,194,0,0,150,194,0,0,148,194,0,0,146,194,0,0,144,194,0,0,142,194,0,0,140,194,0,0,138,194,0,0,136,194,0,0,134,194,0,0,132,194,0,0,130,194,0,0,128,194,0,0,124,194,0,0,120,194,0,0,116,194,0,0,112,194,0,0,108,194,0,0,104,194,0,0,100,194,0,0,96,194,0,0,92,194,0,0,88,194,0,0,84,194,0,0,80,194,0,0,76,194,0,0,72,194,0,0,68,194,0,0,64,194,0,0,60,194,0,0,56,194,0,0,52,194,0,0,48,194,0,0,44,194,0,0,40,194,0,0,36,194,0,0,32,194,0,0,28,194,0,0,24,194,0,0,20,194,0,0,16,194,0,0,12,194,0,0,8,194,0,0,4,194,0,0,0,194,0,0,248,193,0,0,240,193,0,0,232,193,0,0,224,193,0,0,216,193,0,0,208,193,0,0,200,193,0,0,192,193,0,0,184,193,0,0,176,193,0,0,168,193,0,0,160,193,0,0,152,193,0,0,144,193,0,0,136,193,0,0,128,193,0,0,112,193,0,0,96,193,0,0,80,193,0,0,64,193,0,0,48,193,0,0,32,193,0,0,16,193,0,0,0,193,0,0,224,192,0,0,192,192,0,0,160,192,0,0,128,192,0,0,64,192,0,0,0,192,0,0,128,191,0,0,0,0,0,0,128,63,0,0,0,64,0,0,64,64,0,0,128,64,0,0,160,64,0,0,192,64,0,0,224,64,0,0,0,65,0,0,16,65,0,0,32,65,0,0,48,65,0,0,64,65,0,0,80,65,0,0,96,65,0,0,112,65,0,0,128,65,0,0,136,65,0,0,144,65,0,0,152,65,0,0,160,65,0,0,168,65,0,0,176,65,0,0,184,65,0,0,192,65,0,0,200,65,0,0,208,65,0,0,216,65,0,0,224,65,0,0,232,65,0,0,240,65,0,0,248,65,0,0,0,66,0,0,4,66,0,0,8,66,0,0,12,66,0,0,16,66,0,0,20,66,0,0,24,66,0,0,28,66,0,0,32,66,0,0,36,66,0,0,40,66,0,0,44,66,0,0,48,66,0,0,52,66,0,0,56,66,0,0,60,66,0,0,64,66,0,0,68,66,0,0,72,66,0,0,76,66,0,0,80,66,0,0,84,66,0,0,88,66,0,0,92,66,0,0,96,66,0,0,100,66,0,0,104,66,0,0,108,66,0,0,112,66,0,0,116,66,0,0,120,66,0,0,124,66,0,0,128,66,0,0,130,66,0,0,132,66,0,0,134,66,0,0,136,66,0,0,138,66,0,0,140,66,0,0,142,66,0,0,144,66,0,0,146,66,0,0,148,66,0,0,150,66,0,0,152,66,0,0,154,66,0,0,156,66,0,0,158,66,0,0,160,66,0,0,162,66,0,0,164,66,0,0,166,66,0,0,168,66,0,0,170,66,0,0,172,66,0,0,174,66,0,0,176,66,0,0,178,66,0,0,180,66,0,0,182,66,0,0,184,66,0,0,186,66,0,0,188,66,0,0,190,66,0,0,192,66,0,0,194,66,0,0,196,66,0,0,198,66,0,0,200,66,0,0,202,66,0,0,204,66,0,0,206,66,0,0,208,66,0,0,210,66,0,0,212,66,0,0,214,66,0,0,216,66,0,0,218,66,0,0,220,66,0,0,222,66,0,0,224,66,0,0,226,66,0,0,228,66,0,0,230,66,0,0,232,66,0,0,234,66,0,0,236,66,0,0,238,66,0,0,240,66,0,0,242,66,0,0,244,66,0,0,246,66,0,0,248,66,0,0,250,66,0,0,252,66,0,0,254,66,0,0,0,67,0,0,1,67,0,0,2,67,0,0,3,67,0,0,4,67,0,0,5,67,0,0,6,67,0,0,7,67,0,0,8,67,0,0,9,67,0,0,10,67,0,0,11,67,0,0,12,67,0,0,13,67,0,0,14,67,0,0,15,67,0,0,16,67,0,0,17,67,0,0,18,67,0,0,19,67,0,0,20,67,0,0,21,67,0,0,22,67,0,0,23,67,0,0,24,67,0,0,25,67,0,0,26,67,0,0,27,67,0,0,28,67,0,0,29,67,0,0,30,67,0,0,31,67,0,0,32,67,0,0,33,67,0,0,34,67,0,0,35,67,0,0,36,67,0,0,37,67,0,0,38,67,0,0,39,67,0,0,40,67,0,0,41,67,0,0,42,67,0,0,43,67,0,0,44,67,0,0,45,67,0,0,46,67,0,0,47,67,0,0,48,67,0,0,49,67,0,0,50,67,0,0,51,67,0,0,52,67,0,0,53,67,0,0,54,67,0,0,55,67,0,0,56,67,0,0,57,67,0,0,58,67,0,0,59,67,0,0,60,67,0,0,61,67,0,0,62,67,0,0,63,67,0,0,64,67,0,0,65,67,0,0,66,67,0,0,67,67,0,0,68,67,0,0,69,67,0,0,70,67,0,0,71,67,0,0,72,67,0,0,73,67,0,0,74,67,0,0,75,67,0,0,76,67,0,0,77,67,0,0,78,67,0,0,79,67,0,0,80,67,0,0,81,67,0,0,82,67,0,0,83,67,0,0,84,67,0,0,85,67,0,0,86,67,0,0,87,67,0,0,88,67,0,0,89,67,0,0,90,67,0,0,91,67,0,0,92,67,0,0,93,67,0,0,94,67,0,0,95,67,0,0,96,67,0,0,97,67,0,0,98,67,0,0,99,67,0,0,100,67,0,0,101,67,0,0,102,67,0,0,103,67,0,0,104,67,0,0,105,67,0,0,106,67,0,0,107,67,0,0,108,67,0,0,109,67,0,0,110,67,0,0,111,67,0,0,112,67,0,0,113,67,0,0,114,67,0,0,115,67,0,0,116,67,0,0,117,67,0,0,118,67,0,0,119,67,0,0,120,67,0,0,121,67,0,0,122,67,0,0,123,67,0,0,124,67,0,0,125,67,0,0,126,67,0,0,127,67,40,173,7,0,142,0,3,0,197,0,3,0,101,2,0,0,1,0,0,0,172,176,0,0,0,0,0,0,24,42,0,0,34,0,0,0,35,0,0,0,9,0,0,0,17,0,0,0,27,0,0,0,18,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,27,0,0,0,28,0,0,0,23,0,0,0,24,0,0,0,29,0,0,0,10,0,0,0,156,177,0,0,40,177,0,0,0,0,0,0,40,42,0,0,34,0,0,0,36,0,0,0,11,0,0,0,25,0,0,0,27,0,0,0,18,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,27,0,0,0,28,0,0,0,26,0,0,0,24,0,0,0,29,0,0,0,10,0,0,0,0,0,0,0,56,42,0,0,34,0,0,0,37,0,0,0,12,0,0,0,27,0,0,0,27,0,0,0,18,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,27,0,0,0,28,0,0,0,26,0,0,0,24,0,0,0,29,0,0,0,10,0,0,0,108,180,0,0,224,178,0,0,28,178,0,0,0,0,0,0,72,42,0,0,34,0,0,0,38,0,0,0,13,0,0,0,28,0,0,0,27,0,0,0,18,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,29,0,0,0,20,0,0,0,30,0,0,0,22,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,27,0,0,0,30,0,0,0,26,0,0,0,24,0,0,0,29,0,0,0,10,0,0,0,44,173,7,0,136,1,3,0,197,0,3,0,31,6,0,0,1,0,0,0,48,173,7,0,217,1,3,0,197,0,3,0,22,6,0,0,1,0,0,0,52,173,7,0,49,2,3,0,197,0,3,0,3,6,0,0,1,0,0,0,56,173,7,0,150,2,3,0,197,0,3,0,240,5,0,0,1,0,0,0,0,0,0,0,88,42,0,0,34,0,0,0,39,0,0,0,14,0,0,0,31,0,0,0,27,0,0,0,18,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,19,0,0,0,32,0,0,0,21,0,0,0,33,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,31,0,0,0,32,0,0,0,26,0,0,0,24,0,0,0,29,0,0,0,10,0,0,0,60,173,7,0,8,3,3,0,197,0,3,0,64,5,0,0,1,0,0,0,72,173,7,0,40,4,3,0,197,0,3,0,74,5,0,0,1,0,0,0,128,179,0,0,0,0,0,0,104,42,0,0,34,0,0,0,40,0,0,0,15,0,0,0,34,0,0,0,27,0,0,0,18,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,4,0,0,0,2,0,0,0,3,0,0,0,27,0,0,0,28,0,0,0,26,0,0,0,24,0,0,0,29,0,0,0,10,0,0,0,64,173,7,0,90,3,3,0,197,0,3,0,149,5,0,0,1,0,0,0,68,173,7,0,175,3,3,0,197,0,3,0,136,5,0,0,1,0,0,0,76,173,7,0,116,4,3,0,197,0,3,0,53,5,0,0,1,0,0,0,80,173,7,0,203,4,3,0,197,0,3,0,43,5,0,0,1,0,0,0,84,173,7,0,36,5,3,0,197,0,3,0,33,5,0,0,1,0,0,0,88,173,7,0,133,5,3,0,197,0,3,0,24,5,0,0,1,0,0,0,0,0,0,0,120,42,0,0,34,0,0,0,41,0,0,0,16,0,0,0,35,0,0,0,27,0,0,0,18,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,5,0,0,0,2,0,0,0,1,0,0,0,27,0,0,0,33,0,0,0,26,0,0,0,24,0,0,0,29,0,0,0,10,0,0,0,92,173,7,0,244,5,3,0,197,0,3,0,214,5,0,0,1,0,0,0,96,173,7,0,66,6,3,0,197,0,3,0,206,5,0,0,1,0,0,0,100,173,7,0,165,6,3,0,197,0,3,0,35,2,0,0,1,0,0,0,104,173,7,0,241,6,3,0,197,0,3,0,25,2,0,0,1,0,0,0,108,173,7,0,55,7,3,0,197,0,3,0,15,2,0,0,1,0,0,0,112,173,7,0,136,7,3,0,197,0,3,0,229,1,0,0,1,0,0,0,116,173,7,0,238,7,3,0,197,0,3,0,219,1,0,0,1,0,0,0,120,173,7,0,65,8,3,0,197,0,3,0,166,1,0,0,1,0,0,0,124,173,7,0,169,8,3,0,197,0,3,0,156,1,0,0,1,0,0,0,128,173,7,0,4,9,3,0,197,0,3,0,123,1,0,0,1,0,0,0,132,173,7,0,100,9,3,0,197,0,3,0,113,1,0,0,1,0,0,0,136,173,7,0,186,9,3,0,197,0,3,0,80,1,0,0,1,0,0,0,0,0,0,0,136,42,0,0,34,0,0,0,42,0,0,0,17,0,0,0,36,0,0,0,27,0,0,0,18,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,27,0,0,0,28,0,0,0,26,0,0,0,24,0,0,0,29,0,0,0,10,0,0,0,0,0,0,0,152,42,0,0,34,0,0,0,43,0,0,0,18,0,0,0,37,0,0,0,27,0,0,0,18,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,1,0,0,0,6,0,0,0,2,0,0,0,1,0,0,0,27,0,0,0,28,0,0,0,26,0,0,0,24,0,0,0,29,0,0,0,10,0,0,0,140,173,7,0,49,10,3,0,197,0,3,0,112,6,0,0,1,0,0,0,208,181,0,0,144,173,7,0,201,10,3,0,197,0,3,0,163,4,0,0,1,0,0,0,152,173,7,0,238,10,3,0,197,0,3,0,196,4,0,0,1,0,0,0,156,173,7,0,12,11,3,0,197,0,3,0,132,6,0,0,1,0,0,0,160,173,7,0,43,11,3,0,197,0,3,0,141,6,0,0,1,0,0,0,164,173,7,0,79,11,3,0,197,0,3,0,151,6,0,0,1,0,0,0,168,173,7,0,130,11,3,0,197,0,3,0,166,6,0,0,1,0,0,0,172,173,7,0,179,11,3,0,197,0,3,0,175,6,0,0,1,0,0,0,176,173,7,0,224,11,3,0,197,0,3,0,193,6,0,0,1,0,0,0,180,173,7,0,16,12,3,0,197,0,3,0,202,6,0,0,1,0,0,0,184,173,7,0,60,12,3,0,197,0,3,0,220,6,0,0,1,0,0,0,188,173,7,0,107,12,3,0,197,0,3,0,229,6,0,0,1,0,0,0,192,173,7,0,164,13,3,0,22,13,3,0,243,2,0,0,1,0,0,0,204,173,7,0,215,15,3,0,22,13,3,0,65,3,0,0,1,0,0,0,200,173,7,0,130,15,3,0,22,13,3,0,5,6,0,0,1,0,0,0,196,173,7,0,56,14,3,0,22,13,3,0,109,5,0,0,1,0,0,0,208,173,7,0,209,16,3,0,22,13,3,0,69,4,0,0,1,0,0,0,0,0,0,0,168,42,0,0,44,0,0,0,45,0,0,0,2,0,0,0,9,0,0,0,46,0,0,0,8,0,0,0,248,173,7,0,21,40,3,0,55,17,3,0,245,26,0,0,1,0,0,0,0,0,0,0,176,42,0,0,5,0,0,0,47,0,0,0,48,0,0,0,60,0,0,0,0,0,0,0,232,42,0,0,53,0,0,0,54,0,0,0,196,255,255,255,196,255,255,255,232,42,0,0,55,0,0,0,56,0,0,0,92,184,0,0,204,42,0,0,224,42,0,0,112,184,0,0,12,174,7,0,93,61,3,0,25,61,3,0,131,3,0,0,1,0,0,0,16,174,7,0,151,63,3,0,25,61,3,0,36,8,0,0,1,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,0,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,0,0,0,0,20,174,7,0,15,64,3,0,25,61,3,0,216,8,0,0,1,0,0,0,24,174,7,0,135,64,3,0,25,61,3,0,108,9,0,0,1,0,0,0,28,174,7,0,86,65,3,0,25,61,3,0,66,11,0,0,1,0,0,0,32,174,7,0,207,65,3,0,25,61,3,0,218,12,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,248,42,0,0,57,0,0,0,58,0,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,36,174,7,0,255,65,3,0,56,66,3,0,82,0,0,0,1,0,0,0,40,174,7,0,127,66,3,0,56,66,3,0,73,0,0,0,1,0,0,0,44,174,7,0,186,66,3,0,56,66,3,0,55,0,0,0,1,0,0,0,48,174,7,0,238,66,3,0,56,66,3,0,50,0,0,0,1,0,0,0,52,174,7,0,16,67,3,0,56,66,3,0,88,0,0,0,1,0,0,0,56,174,7,0,73,67,3,0,163,67,3,0,187,0,0,0,1,0,0,0,60,174,7,0,244,67,3,0,163,67,3,0,193,0,0,0,1,0,0,0,64,174,7,0,81,68,3,0,163,67,3,0,206,0,0,0,1,0,0,0,68,174,7,0,166,68,3,0,163,67,3,0,231,0,0,0,1,0,0,0,72,174,7,0,254,68,3,0,163,67,3,0,1,1,0,0,1,0,0,0,76,174,7,0,66,69,3,0,163,67,3,0,22,1,0,0,1,0,0,0,80,174,7,0,136,69,3,0,163,67,3,0,39,1,0,0,1,0,0,0,84,174,7,0,201,69,3,0,163,67,3,0,60,1,0,0,1,0,0,0,88,174,7,0,12,70,3,0,163,67,3,0,225,1,0,0,1,0,0,0,92,174,7,0,76,70,3,0,163,67,3,0,253,2,0,0,1,0,0,0,96,174,7,0,142,70,3,0,163,67,3,0,187,4,0,0,1,0,0,0,0,0,0,0,0,0,0,187,100,174,7,0,206,70,3,0,163,67,3,0,77,5,0,0,1,0,0,0,104,174,7,0,16,71,3,0,92,71,3,0,16,0,0,0,1,0,0,0,108,174,7,0,177,71,3,0,92,71,3,0,26,0,0,0,1,0,0,0,112,174,7,0,0,72,3,0,92,71,3,0,44,0,0,0,1,0,0,0,116,174,7,0,71,72,3,0,92,71,3,0,56,0,0,0,1,0,0,0,120,174,7,0,145,72,3,0,92,71,3,0,69,0,0,0,1,0,0,0,124,174,7,0,199,72,3,0,92,71,3,0,81,0,0,0,1,0,0,0,128,174,7,0,255,72,3,0,92,71,3,0,93,0,0,0,1,0,0,0,132,174,7,0,50,73,3,0,92,71,3,0,104,0,0,0,1,0,0,0,136,174,7,0,103,73,3,0,92,71,3,0,114,0,0,0,1,0,0,0,140,174,7,0,153,73,3,0,92,71,3,0,125,0,0,0,1,0,0,0,144,174,7,0,205,73,3,0,92,71,3,0,136,0,0,0,1,0,0,0,148,174,7,0,255,73,3,0,92,71,3,0,147,0,0,0,1,0,0,0,160,174,7,0,201,74,3,0,8,75,3,0,112,0,0,0,1,0,0,0,164,174,7,0,83,75,3,0,8,75,3,0,123,0,0,0,1,0,0,0,168,174,7,0,148,75,3,0,8,75,3,0,212,0,0,0,1,0,0,0,172,174,7,0,218,75,3,0,8,75,3,0,221,0,0,0,1,0,0,0,176,174,7,0,34,76,3,0,8,75,3,0,77,1,0,0,1,0,0,0,180,174,7,0,111,76,3,0,8,75,3,0,87,1,0,0,1,0,0,0,184,174,7,0,117,77,3,0,237,76,3,0,131,0,0,0,1,0,0,0,188,174,7,0,20,78,3,0,237,76,3,0,14,1,0,0,1,0,0,0,192,174,7,0,113,81,3,0,29,79,3,0,204,0,0,0,1,0,0,0,252,174,7,0,33,84,3,0,60,82,3,0,63,39,0,0,1,0,0,0,0,0,0,0,48,45,0,0,14,0,0,0,60,0,0,0,13,0,0,0,0,0,0,0,32,45,0,0,14,0,0,0,61,0,0,0,14,0,0,0,0,0,0,0,16,45,0,0,14,0,0,0,62,0,0,0,15,0,0,0,240,174,7,0,193,81,3,0,60,82,3,0,23,1,0,0,1,0,0,0,244,174,7,0,175,82,3,0,60,82,3,0,23,1,0,0,1,0,0,0,248,174,7,0,105,83,3,0,60,82,3,0,23,1,0,0,1,0,0,0,4,175,7,0,34,85,3,0,60,82,3,0,126,39,0,0,1,0,0,0,0,0,0,0,64,45,0,0,14,0,0,0,63,0,0,0,16,0,0,0,0,175,7,0,130,84,3,0,60,82,3,0,23,1,0,0,1,0,0,0,12,175,7,0,33,86,3,0,60,82,3,0,139,39,0,0,1,0,0,0,0,0,0,0,80,45,0,0,14,0,0,0,64,0,0,0,17,0,0,0,8,175,7,0,129,85,3,0,60,82,3,0,23,1,0,0,1,0,0,0,28,175,7,0,131,88,3,0,60,82,3,0,152,39,0,0,1,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,0,0,0,0,128,45,0,0,14,0,0,0,65,0,0,0,18,0,0,0,0,0,0,0,112,45,0,0,14,0,0,0,66,0,0,0,19,0,0,0,135,22,153,62,162,69,22,63,213,120,233,61,0,0,0,0,96,45,0,0,14,0,0,0,67,0,0,0,20,0,0,0,16,175,7,0,128,86,3,0,60,82,3,0,23,1,0,0,1,0,0,0,20,175,7,0,43,87,3,0,60,82,3,0,23,1,0,0,1,0,0,0,24,175,7,0,216,87,3,0,60,82,3,0,23,1,0,0,1,0,0,0,44,175,7,0,3,91,3,0,60,82,3,0,201,39,0,0,1,0,0,0,0,0,0,0,176,45,0,0,14,0,0,0,68,0,0,0,21,0,0,0,0,0,0,0,160,45,0,0,14,0,0,0,69,0,0,0,22,0,0,0,0,0,0,0,144,45,0,0,14,0,0,0,70,0,0,0,23,0,0,0,32,175,7,0,224,88,3,0,60,82,3,0,23,1,0,0,1,0,0,0,36,175,7,0,139,89,3,0,60,82,3,0,23,1,0,0,1,0,0,0,40,175,7,0,72,90,3,0,60,82,3,0,23,1,0,0,1,0,0,0,52,175,7,0,253,91,3,0,60,82,3,0,246,39,0,0,1,0,0,0,0,0,0,0,192,45,0,0,14,0,0,0,71,0,0,0,24,0,0,0,48,175,7,0,90,91,3,0,60,82,3,0,23,1,0,0,1,0,0,0,60,175,7,0,245,92,3,0,60,82,3,0,2,40,0,0,1,0,0,0,0,0,0,0,208,45,0,0,14,0,0,0,72,0,0,0,25,0,0,0,56,175,7,0,82,92,3,0,60,82,3,0,23,1,0,0,1,0,0,0,76,175,7,0,139,95,3,0,60,82,3,0,14,40,0,0,1,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,162,45,0,0,25,36,0,0,35,19,0,0,145,37,0,0,76,7,0,0,33,56,0,0,125,31,0,0,0,0,0,0,0,46,0,0,14,0,0,0,73,0,0,0,26,0,0,0,35,19,0,0,145,37,0,0,76,7,0,0,162,45,0,0,25,36,0,0,35,19,0,0,145,37,0,0,76,7,0,0,33,56,0,0,125,31,0,0,0,0,0,0,240,45,0,0,14,0,0,0,74,0,0,0,27,0,0,0,135,22,153,62,162,69,22,63,213,120,233,61,43,135,54,63,78,98,16,63,135,22,153,62,162,69,22,63,213,120,233,61,18,131,96,63,109,231,251,62,0,0,0,0,224,45,0,0,14,0,0,0,75,0,0,0,28,0,0,0,64,175,7,0,74,93,3,0,60,82,3,0,23,1,0,0,1,0,0,0,68,175,7,0,255,93,3,0,60,82,3,0,23,1,0,0,1,0,0,0,72,175,7,0,198,94,3,0,60,82,3,0,23,1,0,0,1,0,0,0,92,175,7,0,46,98,3,0,60,82,3,0,67,40,0,0,1,0,0,0,203,89,0,0,78,210,255,255,252,233,255,255,121,113,0,0,246,72,0,0,209,218,255,255,184,230,255,255,12,130,0,0,0,0,0,0,48,46,0,0,14,0,0,0,76,0,0,0,29,0,0,0,203,89,0,0,78,210,255,255,252,233,255,255,121,113,0,0,246,72,0,0,209,218,255,255,184,230,255,255,12,130,0,0,0,0,0,0,32,46,0,0,14,0,0,0,77,0,0,0,30,0,0,0,129,149,179,63,180,200,54,191,197,32,176,190,170,241,226,63,133,235,145,63,106,188,20,191,113,61,202,190,74,12,2,64,0,0,0,0,16,46,0,0,14,0,0,0,78,0,0,0,31,0,0,0,80,175,7,0,237,95,3,0,60,82,3,0,23,1,0,0,1,0,0,0,84,175,7,0,162,96,3,0,60,82,3,0,23,1,0,0,1,0,0,0,88,175,7,0,105,97,3,0,60,82,3,0,23,1,0,0,1,0,0,0,108,175,7,0,188,100,3,0,60,82,3,0,121,40,0,0,1,0,0,0,0,0,0,0,96,46,0,0,14,0,0,0,79,0,0,0,32,0,0,0,0,0,0,0,80,46,0,0,14,0,0,0,80,0,0,0,33,0,0,0,0,0,0,0,64,46,0,0,14,0,0,0,81,0,0,0,34,0,0,0,96,175,7,0,144,98,3,0,60,82,3,0,23,1,0,0,1,0,0,0,100,175,7,0,62,99,3,0,60,82,3,0,23,1,0,0,1,0,0,0,104,175,7,0,254,99,3,0,60,82,3,0,23,1,0,0,1,0,0,0,124,175,7,0,68,103,3,0,60,82,3,0,171,40,0,0,1,0,0,0,0,0,0,0,144,46,0,0,14,0,0,0,82,0,0,0,35,0,0,0,0,0,0,0,128,46,0,0,14,0,0,0,83,0,0,0,36,0,0,0,0,0,0,0,112,46,0,0,14,0,0,0,84,0,0,0,37,0,0,0,112,175,7,0,24,101,3,0,60,82,3,0,23,1,0,0,1,0,0,0,116,175,7,0,198,101,3,0,60,82,3,0,23,1,0,0,1,0,0,0,120,175,7,0,134,102,3,0,60,82,3,0,23,1,0,0,1,0,0,0,144,187,7,0,57,106,3,0,60,82,3,0,222,40,0,0,1,0,0,0,0,0,0,0,208,46,0,0,14,0,0,0,85,0,0,0,38,0,0,0,0,0,0,0,192,46,0,0,14,0,0,0,86,0,0,0,39,0,0,0,0,0,0,0,176,46,0,0,14,0,0,0,87,0,0,0,40,0,0,0,0,0,0,0,160,46,0,0,14,0,0,0,88,0,0,0,41,0,0,0,128,175,7,0,201,103,3,0,60,82,3,0,23,1,0,0,1,0,0,0,132,175,7,0,101,104,3,0,60,82,3,0,23,1,0,0,1,0,0,0,136,175,7,0,1,105,3,0,60,82,3,0,23,1,0,0,1,0,0,0,140,187,7,0,157,105,3,0,60,82,3,0,23,1,0,0,1,0,0,0,164,187,7,0,17,109,3,0,60,82,3,0,53,41,0,0,1,0,0,0,0,0,0,0,16,47,0,0,14,0,0,0,89,0,0,0,42,0,0,0,0,0,0,0,0,47,0,0,14,0,0,0,90,0,0,0,43,0,0,0,0,0,0,0,240,46,0,0,14,0,0,0,91,0,0,0,44,0,0,0,0,0,0,0,224,46,0,0,14,0,0,0,92,0,0,0,45,0,0,0,148,187,7,0,161,106,3,0,60,82,3,0,23,1,0,0,1,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,152,187,7,0,61,107,3,0,60,82,3,0,23,1,0,0,1,0,0,0,156,187,7,0,217,107,3,0,60,82,3,0,23,1,0,0,1,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,160,187,7,0,117,108,3,0,60,82,3,0,23,1,0,0,1,0,0,0,52,188,7,0,168,113,3,0,60,82,3,0,144,41,0,0,1,0,0,0,0,0,0,0,80,47,0,0,14,0,0,0,93,0,0,0,46,0,0,0,0,0,0,0,64,47,0,0,14,0,0,0,94,0,0,0,47,0,0,0,0,0,0,0,48,47,0,0,14,0,0,0,95,0,0,0,48,0,0,0,0,0,0,0,32,47,0,0,14,0,0,0,96,0,0,0,49,0,0,0,176,187,7,0,121,109,3,0,60,82,3,0,23,1,0,0,1,0,0,0,204,187,7,0,21,110,3,0,60,82,3,0,23,1,0,0,1,0,0,0,44,188,7,0,125,111,3,0,60,82,3,0,23,1,0,0,1,0,0,0,48,188,7,0,129,112,3,0,60,82,3,0,23,1,0,0,1,0,0,0,3,0,0,0,84,188,7,0,141,116,3,0,60,82,3,0,241,41,0,0,1,0,0,0,0,0,0,0,144,47,0,0,14,0,0,0,97,0,0,0,50,0,0,0,0,0,0,0,128,47,0,0,14,0,0,0,98,0,0,0,51,0,0,0,0,0,0,0,112,47,0,0,14,0,0,0,99,0,0,0,52,0,0,0,0,0,0,0,96,47,0,0,14,0,0,0,100,0,0,0,53,0,0,0,56,188,7,0,16,114,3,0,60,82,3,0,23,1,0,0,1,0,0,0,72,188,7,0,172,114,3,0,60,82,3,0,23,1,0,0,1,0,0,0,76,188,7,0,85,115,3,0,60,82,3,0,23,1,0,0,1,0,0,0,80,188,7,0,241,115,3,0,60,82,3,0,23,1,0,0,1,0,0,0,92,188,7,0,238,118,3,0,60,82,3,0,80,42,0,0,1,0,0,0,88,188,7,0,123,118,3,0,60,82,3,0,92,42,0,0,1,0,0,0,0,0,0,0,16,48,0,0,14,0,0,0,101,0,0,0,54,0,0,0,0,0,0,0,0,48,0,0,14,0,0,0,102,0,0,0,55,0,0,0,0,0,0,0,240,47,0,0,14,0,0,0,103,0,0,0,56,0,0,0,0,0,0,0,224,47,0,0,14,0,0,0,104,0,0,0,57,0,0,0,0,0,0,0,208,47,0,0,14,0,0,0,105,0,0,0,58,0,0,0,0,0,0,0,192,47,0,0,14,0,0,0,106,0,0,0,59,0,0,0,0,0,0,0,176,47,0,0,14,0,0,0,107,0,0,0,60,0,0,0,0,0,0,0,160,47,0,0,14,0,0,0,108,0,0,0,61,0,0,0,96,188,7,0,248,119,3,0,60,82,3,0,115,42,0,0,1,0,0,0,0,0,0,0,80,48,0,0,14,0,0,0,109,0,0,0,62,0,0,0,0,0,0,0,64,48,0,0,14,0,0,0,110,0,0,0,63,0,0,0,0,0,0,0,48,48,0,0,14,0,0,0,111,0,0,0,64,0,0,0,0,0,0,0,32,48,0,0,14,0,0,0,112,0,0,0,65,0,0,0,100,188,7,0,124,120,3,0,60,82,3,0,142,42,0,0,1,0,0,0,0,0,0,0,96,48,0,0,14,0,0,0,113,0,0,0,66,0,0,0,104,188,7,0,6,123,3,0,60,82,3,0,165,42,0,0,1,0,0,0,0,0,0,0,32,49,0,0,14,0,0,0,114,0,0,0,67,0,0,0,0,0,0,0,16,49,0,0,14,0,0,0,115,0,0,0,68,0,0,0,0,0,0,0,0,49,0,0,14,0,0,0,116,0,0,0,69,0,0,0,0,0,0,0,240,48,0,0,14,0,0,0,117,0,0,0,70,0,0,0,0,0,0,0,224,48,0,0,14,0,0,0,118,0,0,0,71,0,0,0,0,0,0,0,208,48,0,0,14,0,0,0,119,0,0,0,72,0,0,0,0,0,0,0,192,48,0,0,14,0,0,0,120,0,0,0,73,0,0,0,0,0,0,0,176,48,0,0,14,0,0,0,121,0,0,0,74,0,0,0,0,0,0,0,160,48,0,0,14,0,0,0,122,0,0,0,75,0,0,0,0,0,0,0,144,48,0,0,14,0,0,0,123,0,0,0,76,0,0,0,0,0,0,0,128,48,0,0,14,0,0,0,124,0,0,0,77,0,0,0,0,0,0,0,112,48,0,0,14,0,0,0,125,0,0,0,78,0,0,0,112,188,7,0,49,124,3,0,60,82,3,0,191,42],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+40960);allocate([1,0,0,0,0,0,0,0,48,49,0,0,14,0,0,0,126,0,0,0,79,0,0,0,108,188,7,0,111,123,3,0,60,82,3,0,23,1,0,0,1,0,0,0,120,188,7,0,75,125,3,0,60,82,3,0,211,42,0,0,1,0,0,0,0,0,0,0,64,49,0,0,14,0,0,0,127,0,0,0,80,0,0,0,116,188,7,0,137,124,3,0,60,82,3,0,23,1,0,0,1,0,0,0,124,188,7,0,155,127,3,0,60,82,3,0,51,43,0,0,1,0,0,0,128,188,7,0,20,129,3,0,50,128,3,0,60,5,0,0,1,0,0,0,132,188,7,0,243,129,3,0,50,128,3,0,172,5,0,0,1,0,0,0,136,188,7,0,4,131,3,0,117,130,3,0,84,3,0,0,1,0,0,0,140,188,7,0,184,131,3,0,117,130,3,0,105,3,0,0,1,0,0,0,144,188,7,0,21,134,3,0,117,130,3,0,212,5,0,0,1,0,0,0,0,0,0,0,112,49,0,0,14,0,0,0,128,0,0,0,81,0,0,0,0,0,0,0,96,49,0,0,14,0,0,0,129,0,0,0,82,0,0,0,0,0,0,0,80,49,0,0,130,0,0,0,131,0,0,0,83,0,0,0,148,188,7,0,105,135,3,0,144,134,3,0,161,1,0,0,1,0,0,0,152,188,7,0,186,135,3,0,144,134,3,0,213,1,0,0,1,0,0,0,156,188,7,0,7,136,3,0,144,134,3,0,17,3,0,0,1,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,128,63,0,0,128,192,0,0,128,63,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,193,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,160,188,7,0,83,137,3,0,158,136,3,0,107,1,0,0,1,0,0,0,168,188,7,0,147,141,3,0,252,137,3,0,165,5,0,0,1,0,0,0,172,188,7,0,115,142,3,0,252,137,3,0,233,6,0,0,1,0,0,0,176,188,7,0,64,143,3,0,252,137,3,0,54,8,0,0,1,0,0,0,180,188,7,0,71,144,3,0,252,137,3,0,147,9,0,0,1,0,0,0,184,188,7,0,60,145,3,0,252,137,3,0,201,9,0,0,1,0,0,0,188,188,7,0,239,145,3,0,252,137,3,0,71,15,0,0,1,0,0,0,0,0,0,0,144,49,0,0,14,0,0,0,132,0,0,0,84,0,0,0,0,0,0,0,128,49,0,0,14,0,0,0,133,0,0,0,85,0,0,0,192,188,7,0,200,146,3,0,69,146,3,0,85,2,0,0,1,0,0,0,196,188,7,0,98,147,3,0,24,147,3,0,241,1,0,0,1,0,0,0,200,188,7,0,177,147,3,0,24,147,3,0,23,2,0,0,1,0,0,0,204,188,7,0,225,147,3,0,24,147,3,0,30,2,0,0,1,0,0,0,0,0,0,0,176,49,0,0,14,0,0,0,134,0,0,0,86,0,0,0,0,0,0,0,160,49,0,0,14,0,0,0,135,0,0,0,87,0,0,0,0,0,0,0,224,49,0,0,14,0,0,0,136,0,0,0,88,0,0,0,0,0,0,0,208,49,0,0,14,0,0,0,137,0,0,0,89,0,0,0,0,0,0,0,192,49,0,0,14,0,0,0,138,0,0,0,90,0,0,0,0,0,0,0,0,50,0,0,14,0,0,0,139,0,0,0,91,0,0,0,0,0,0,0,240,49,0,0,14,0,0,0,140,0,0,0,92,0,0,0,0,0,0,0,48,50,0,0,14,0,0,0,141,0,0,0,93,0,0,0,0,0,0,0,32,50,0,0,14,0,0,0,142,0,0,0,94,0,0,0,0,0,0,0,16,50,0,0,14,0,0,0,143,0,0,0,95,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,3,0,0,0,2,0,0,0,1,0,0,0,208,188,7,0,27,156,3,0,118,155,3,0,166,2,0,0,1,0,0,0,236,188,7,0,12,158,3,0,112,156,3,0,160,3,0,0,1,0,0,0,0,0,0,0,80,50,0,0,144,0,0,0,145,0,0,0,96,0,0,0,216,188,7,0,131,157,3,0,112,156,3,0,241,3,0,0,0,0,0,0,212,188,7,0,121,157,3,0,112,156,3,0,4,4,0,0,0,0,0,128,0,0,0,0,64,50,0,0,14,0,0,0,146,0,0,0,97,0,0,0,232,188,7,0,179,157,3,0,112,156,3,0,93,1,0,0,1,0,0,0,228,188,7,0,170,157,3,0,112,156,3,0,103,1,0,0,0,0,0,0,224,188,7,0,160,157,3,0,112,156,3,0,115,1,0,0,0,0,0,128,220,188,7,0,149,157,3,0,112,156,3,0,231,2,0,0,0,0,0,128,248,188,7,0,253,158,3,0,112,156,3,0,12,4,0,0,1,0,0,0,244,188,7,0,131,157,3,0,112,156,3,0,57,4,0,0,0,0,0,0,240,188,7,0,121,157,3,0,112,156,3,0,76,4,0,0,0,0,0,128,0,0,0,0,144,51,0,0,147,0,0,0,148,0,0,0,28,0,0,0,0,0,0,0,128,51,0,0,5,0,0,0,149,0,0,0,150,0,0,0,0,0,0,0,112,51,0,0,147,0,0,0,151,0,0,0,29,0,0,0,0,0,0,0,96,51,0,0,5,0,0,0,152,0,0,0,153,0,0,0,0,0,0,0,80,51,0,0,147,0,0,0,154,0,0,0,30,0,0,0,0,0,0,0,64,51,0,0,5,0,0,0,155,0,0,0,156,0,0,0,0,0,0,0,48,51,0,0,147,0,0,0,157,0,0,0,31,0,0,0,0,0,0,0,32,51,0,0,5,0,0,0,158,0,0,0,159,0,0,0,0,0,0,0,16,51,0,0,147,0,0,0,160,0,0,0,32,0,0,0,0,0,0,0,0,51,0,0,5,0,0,0,161,0,0,0,162,0,0,0,0,0,0,0,240,50,0,0,147,0,0,0,163,0,0,0,33,0,0,0,0,0,0,0,224,50,0,0,5,0,0,0,164,0,0,0,165,0,0,0,0,0,0,0,208,50,0,0,147,0,0,0,166,0,0,0,34,0,0,0,0,0,0,0,192,50,0,0,5,0,0,0,167,0,0,0,168,0,0,0,0,0,0,0,176,50,0,0,147,0,0,0,169,0,0,0,35,0,0,0,0,0,0,0,160,50,0,0,5,0,0,0,170,0,0,0,171,0,0,0,0,0,0,0,144,50,0,0,147,0,0,0,172,0,0,0,36,0,0,0,0,0,0,0,128,50,0,0,5,0,0,0,173,0,0,0,174,0,0,0,0,0,0,0,112,50,0,0,147,0,0,0,175,0,0,0,37,0,0,0,0,0,0,0,96,50,0,0,5,0,0,0,176,0,0,0,177,0,0,0,0,0,0,0,16,53,0,0,178,0,0,0,179,0,0,0,20,0,0,0,180,0,0,0,0,0,0,0,0,53,0,0,5,0,0,0,181,0,0,0,182,0,0,0,0,0,0,0,240,52,0,0,183,0,0,0,184,0,0,0,21,0,0,0,185,0,0,0,0,0,0,0,224,52,0,0,5,0,0,0,186,0,0,0,187,0,0,0,0,0,0,0,208,52,0,0,188,0,0,0,189,0,0,0,22,0,0,0,190,0,0,0,0,0,0,0,192,52,0,0,5,0,0,0,191,0,0,0,192,0,0,0,0,0,0,0,176,52,0,0,193,0,0,0,194,0,0,0,23,0,0,0,195,0,0,0,0,0,0,0,160,52,0,0,5,0,0,0,196,0,0,0,197,0,0,0,0,0,0,0,144,52,0,0,198,0,0,0,199,0,0,0,24,0,0,0,200,0,0,0,0,0,0,0,128,52,0,0,5,0,0,0,201,0,0,0,202,0,0,0,0,0,0,0,112,52,0,0,203,0,0,0,204,0,0,0,25,0,0,0,205,0,0,0,0,0,0,0,96,52,0,0,5,0,0,0,206,0,0,0,207,0,0,0,0,0,0,0,80,52,0,0,208,0,0,0,209,0,0,0,26,0,0,0,210,0,0,0,0,0,0,0,64,52,0,0,5,0,0,0,211,0,0,0,212,0,0,0,0,0,0,0,48,52,0,0,213,0,0,0,214,0,0,0,27,0,0,0,215,0,0,0,0,0,0,0,32,52,0,0,5,0,0,0,216,0,0,0,217,0,0,0,0,0,0,0,16,52,0,0,218,0,0,0,219,0,0,0,28,0,0,0,220,0,0,0,0,0,0,0,0,52,0,0,5,0,0,0,221,0,0,0,222,0,0,0,0,0,0,0,240,51,0,0,223,0,0,0,224,0,0,0,29,0,0,0,225,0,0,0,0,0,0,0,224,51,0,0,5,0,0,0,226,0,0,0,227,0,0,0,0,0,0,0,208,51,0,0,228,0,0,0,229,0,0,0,30,0,0,0,230,0,0,0,0,0,0,0,192,51,0,0,5,0,0,0,231,0,0,0,232,0,0,0,0,0,0,0,176,51,0,0,233,0,0,0,234,0,0,0,31,0,0,0,235,0,0,0,0,0,0,0,160,51,0,0,5,0,0,0,236,0,0,0,237,0,0,0,0,0,0,0,32,53,0,0,5,0,0,0,238,0,0,0,239,0,0,0,252,188,7,0,253,168,3,0,246,159,3,0,252,5,0,0,1,0,0,0,0,189,7,0,70,169,3,0,246,159,3,0,45,6,0,0,1,0,0,0,4,189,7,0,94,171,3,0,246,159,3,0,129,6,0,0,1,0,0,0,0,0,0,0,192,53,0,0,147,0,0,0,240,0,0,0,38,0,0,0,0,0,0,0,176,53,0,0,5,0,0,0,241,0,0,0,242,0,0,0,0,0,0,0,160,53,0,0,147,0,0,0,243,0,0,0,39,0,0,0,0,0,0,0,144,53,0,0,5,0,0,0,244,0,0,0,245,0,0,0,0,0,0,0,128,53,0,0,147,0,0,0,246,0,0,0,40,0,0,0,0,0,0,0,112,53,0,0,5,0,0,0,247,0,0,0,248,0,0,0,0,0,0,0,96,53,0,0,147,0,0,0,249,0,0,0,41,0,0,0,0,0,0,0,80,53,0,0,5,0,0,0,250,0,0,0,251,0,0,0,0,0,0,0,64,53,0,0,147,0,0,0,252,0,0,0,42,0,0,0,0,0,0,0,48,53,0,0,5,0,0,0,253,0,0,0,254,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,62,0,0,0,63,0,0,128,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,61,0,0,128,62,0,0,192,62,0,0,128,62,0,0,128,61,0,0,0,0,0,0,0,0,0,0,0,61,0,0,224,61,0,0,96,62,0,0,144,62,0,0,96,62,0,0,224,61,0,0,0,61,8,189,7,0,64,172,3,0,246,159,3,0,31,8,0,0,1,0,0,0,12,189,7,0,52,173,3,0,246,159,3,0,51,12,0,0,1,0,0,0,16,189,7,0,66,175,3,0,246,159,3,0,74,15,0,0,1,0,0,0,0,0,0,0,224,53,0,0,14,0,0,0,255,0,0,0,98,0,0,0,0,0,0,0,208,53,0,0,14,0,0,0,0,1,0,0,99,0,0,0,20,189,7,0,2,176,3,0,180,175,3,0,46,0,0,0,1,0,0,0,0,0,0,0,240,53,0,0,147,0,0,0,1,1,0,0,1,0,0,0,0,0,0,0,248,53,0,0,2,1,0,0,3,1,0,0,1,0,0,0,4,1,0,0,0,0,0,0,0,54,0,0,5,1,0,0,6,1,0,0,1,0,0,0,7,1,0,0,0,0,0,0,8,54,0,0,8,1,0,0,9,1,0,0,3,0,0,0,4,0,0,0,29,0,0,0,43,0,0,0,24,189,7,0,243,176,3,0,172,176,3,0,130,1,0,0,1,0,0,0,0,0,0,0,128,55,0,0,5,0,0,0,10,1,0,0,11,1,0,0,0,0,0,0,80,55,0,0,5,0,0,0,12,1,0,0,13,1,0,0,0,0,0,0,48,55,0,0,5,0,0,0,14,1,0,0,15,1,0,0,0,0,0,0,16,55,0,0,5,0,0,0,16,1,0,0,17,1,0,0,0,0,0,0,240,54,0,0,5,0,0,0,18,1,0,0,19,1,0,0,0,0,0,0,208,54,0,0,5,0,0,0,20,1,0,0,21,1,0,0,0,0,0,0,176,54,0,0,5,0,0,0,22,1,0,0,23,1,0,0,0,0,0,0,144,54,0,0,5,0,0,0,24,1,0,0,25,1,0,0,0,0,0,0,112,54,0,0,5,0,0,0,26,1,0,0,27,1,0,0,0,0,0,0,80,54,0,0,5,0,0,0,28,1,0,0,29,1,0,0,0,0,0,0,48,54,0,0,5,0,0,0,30,1,0,0,31,1,0,0,0,0,0,0,16,54,0,0,5,0,0,0,32,1,0,0,33,1,0,0,0,0,0,0,32,54,0,0,34,1,0,0,35,1,0,0,44,0,0,0,0,0,0,0,64,54,0,0,36,1,0,0,37,1,0,0,45,0,0,0,0,0,0,0,96,54,0,0,38,1,0,0,39,1,0,0,46,0,0,0,0,0,0,0,128,54,0,0,40,1,0,0,41,1,0,0,47,0,0,0,0,0,0,0,160,54,0,0,42,1,0,0,43,1,0,0,48,0,0,0,0,0,0,0,192,54,0,0,44,1,0,0,45,1,0,0,49,0,0,0,0,0,0,0,224,54,0,0,46,1,0,0,47,1,0,0,50,0,0,0,0,0,0,0,0,55,0,0,48,1,0,0,49,1,0,0,51,0,0,0,0,0,0,0,32,55,0,0,50,1,0,0,51,1,0,0,52,0,0,0,0,0,0,0,64,55,0,0,52,1,0,0,53,1,0,0,53,0,0,0,0,0,0,0,112,55,0,0,54,1,0,0,55,1,0,0,54,0,0,0,0,0,0,0,96,55,0,0,54,1,0,0,56,1,0,0,55,0,0,0,0,0,0,0,160,55,0,0,57,1,0,0,58,1,0,0,56,0,0,0,0,0,0,0,144,55,0,0,57,1,0,0,59,1,0,0,57,0,0,0,0,0,0,0,176,58,0,0,5,0,0,0,60,1,0,0,61,1,0,0,0,0,0,0,160,58,0,0,5,0,0,0,62,1,0,0,63,1,0,0,0,0,0,0,144,58,0,0,5,0,0,0,64,1,0,0,65,1,0,0,0,0,0,0,128,58,0,0,5,0,0,0,66,1,0,0,67,1,0,0,0,0,0,0,112,58,0,0,5,0,0,0,68,1,0,0,69,1,0,0,0,0,0,0,96,58,0,0,5,0,0,0,70,1,0,0,71,1,0,0,0,0,0,0,80,58,0,0,5,0,0,0,72,1,0,0,73,1,0,0,0,0,0,0,64,58,0,0,5,0,0,0,74,1,0,0,75,1,0,0,0,0,0,0,48,58,0,0,5,0,0,0,76,1,0,0,77,1,0,0,0,0,0,0,16,58,0,0,5,0,0,0,78,1,0,0,79,1,0,0,0,0,0,0,208,57,0,0,5,0,0,0,80,1,0,0,81,1,0,0,0,0,0,0,144,57,0,0,5,0,0,0,82,1,0,0,83,1,0,0,0,0,0,0,96,57,0,0,5,0,0,0,84,1,0,0,85,1,0,0,0,0,0,0,48,57,0,0,5,0,0,0,86,1,0,0,87,1,0,0,0,0,0,0,0,57,0,0,5,0,0,0,88,1,0,0,89,1,0,0,0,0,0,0,208,56,0,0,5,0,0,0,90,1,0,0,91,1,0,0,0,0,0,0,160,56,0,0,5,0,0,0,92,1,0,0,93,1,0,0,0,0,0,0,112,56,0,0,5,0,0,0,94,1,0,0,95,1,0,0,0,0,0,0,64,56,0,0,5,0,0,0,96,1,0,0,97,1,0,0,0,0,0,0,16,56,0,0,5,0,0,0,98,1,0,0,99,1,0,0,0,0,0,0,224,55,0,0,5,0,0,0,100,1,0,0,101,1,0,0,0,0,0,0,176,55,0,0,5,0,0,0,102,1,0,0,103,1,0,0,0,0,0,0,208,55,0,0,104,1,0,0,105,1,0,0,32,0,0,0,4,1,0,0,0,0,0,0,192,55,0,0,104,1,0,0,106,1,0,0,33,0,0,0,4,1,0,0,0,0,0,0,0,56,0,0,107,1,0,0,108,1,0,0,34,0,0,0,4,1,0,0,0,0,0,0,240,55,0,0,107,1,0,0,109,1,0,0,35,0,0,0,4,1,0,0,0,0,0,0,48,56,0,0,110,1,0,0,111,1,0,0,36,0,0,0,4,1,0,0,0,0,0,0,32,56,0,0,110,1,0,0,112,1,0,0,37,0,0,0,4,1,0,0,0,0,0,0,96,56,0,0,113,1,0,0,114,1,0,0,38,0,0,0,4,1,0,0,0,0,0,0,80,56,0,0,113,1,0,0,115,1,0,0,39,0,0,0,4,1,0,0,0,0,0,0,144,56,0,0,116,1,0,0,117,1,0,0,40,0,0,0,4,1,0,0,0,0,0,0,128,56,0,0,116,1,0,0,118,1,0,0,41,0,0,0,4,1,0,0,0,0,0,0,192,56,0,0,119,1,0,0,120,1,0,0,42,0,0,0,4,1,0,0,0,0,0,0,176,56,0,0,119,1,0,0,121,1,0,0,43,0,0,0,4,1,0,0,0,0,0,0,240,56,0,0,122,1,0,0,123,1,0,0,44,0,0,0,4,1,0,0,0,0,0,0,224,56,0,0,122,1,0,0,124,1,0,0,45,0,0,0,4,1,0,0,0,0,0,0,32,57,0,0,125,1,0,0,126,1,0,0,46,0,0,0,4,1,0,0,0,0,0,0,16,57,0,0,125,1,0,0,127,1,0,0,47,0,0,0,4,1,0,0,0,0,0,0,80,57,0,0,128,1,0,0,129,1,0,0,48,0,0,0,4,1,0,0,0,0,0,0,64,57,0,0,128,1,0,0,130,1,0,0,49,0,0,0,4,1,0,0,0,0,0,0,128,57,0,0,131,1,0,0,132,1,0,0,50,0,0,0,4,1,0,0,0,0,0,0,112,57,0,0,131,1,0,0,133,1,0,0,51,0,0,0,4,1,0,0,0,0,0,0,176,57,0,0,134,1,0,0,135,1,0,0,52,0,0,0,4,1,0,0,0,0,0,0,160,57,0,0,134,1,0,0,136,1,0,0,53,0,0,0,4,1,0,0,0,0,0,0,192,57,0,0,134,1,0,0,137,1,0,0,54,0,0,0,4,1,0,0,0,0,0,0,240,57,0,0,138,1,0,0,139,1,0,0,55,0,0,0,4,1,0,0,0,0,0,0,224,57,0,0,138,1,0,0,140,1,0,0,56,0,0,0,4,1,0,0,0,0,0,0,0,58,0,0,138,1,0,0,141,1,0,0,57,0,0,0,4,1,0,0,0,0,0,0,32,58,0,0,131,1,0,0,142,1,0,0,58,0,0,0,4,1,0,0,0,0,0,0,64,60,0,0,5,0,0,0,143,1,0,0,144,1,0,0,0,0,0,0,32,60,0,0,5,0,0,0,145,1,0,0,146,1,0,0,0,0,0,0,0,60,0,0,5,0,0,0,147,1,0,0,148,1,0,0,0,0,0,0,224,59,0,0,5,0,0,0,149,1,0,0,150,1,0,0,0,0,0,0,192,59,0,0,5,0,0,0,151,1,0,0,152,1,0,0,0,0,0,0,160,59,0,0,5,0,0,0,153,1,0,0,154,1,0,0,0,0,0,0,128,59,0,0,5,0,0,0,155,1,0,0,156,1,0,0,0,0,0,0,96,59,0,0,5,0,0,0,157,1,0,0,158,1,0,0,0,0,0,0,64,59,0,0,5,0,0,0,159,1,0,0,160,1,0,0,0,0,0,0,32,59,0,0,5,0,0,0,161,1,0,0,162,1,0,0,0,0,0,0,0,59,0,0,5,0,0,0,163,1,0,0,164,1,0,0,0,0,0,0,224,58,0,0,5,0,0,0,165,1,0,0,166,1,0,0,0,0,0,0,192,58,0,0,5,0,0,0,167,1,0,0,168,1,0,0,0,0,0,0,208,58,0,0,169,1,0,0,170,1,0,0,8,0,0,0,7,1,0,0,0,0,0,0,240,58,0,0,171,1,0,0,172,1,0,0,9,0,0,0,7,1,0,0,0,0,0,0,16,59,0,0,173,1,0,0,174,1,0,0,10,0,0,0,7,1,0,0,0,0,0,0,48,59,0,0,175,1,0,0,176,1,0,0,11,0,0,0,7,1,0,0,0,0,0,0,80,59,0,0,177,1,0,0,178,1,0,0,12,0,0,0,7,1,0,0,0,0,0,0,112,59,0,0,179,1,0,0,180,1,0,0,13,0,0,0,7,1,0,0,0,0,0,0,144,59,0,0,181,1,0,0,182,1,0,0,14,0,0,0,7,1,0,0,0,0,0,0,176,59,0,0,183,1,0,0,184,1,0,0,15,0,0,0,7,1,0,0,0,0,0,0,208,59,0,0,185,1,0,0,186,1,0,0,16,0,0,0,7,1,0,0,0,0,0,0,240,59,0,0,187,1,0,0,188,1,0,0,17,0,0,0,7,1,0,0,0,0,0,0,16,60,0,0,189,1,0,0,190,1,0,0,18,0,0,0,7,1,0,0,0,0,0,0,48,60,0,0,191,1,0,0,192,1,0,0,19,0,0,0,7,1,0,0,0,0,0,0,80,60,0,0,193,1,0,0,194,1,0,0,20,0,0,0,7,1,0,0,28,189,7,0,29,213,3,0,172,176,3,0,33,19,0,0,1,0,0,0,32,189,7,0,242,213,3,0,172,176,3,0,64,19,0,0,1,0,0,0,36,189,7,0,180,216,3,0,142,214,3,0,68,4,0,0,1,0,0,0,40,189,7,0,251,219,3,0,78,217,3,0,21,2,0,0,1,0,0,0,44,189,7,0,229,220,3,0,154,220,3,0,153,0,0,0,1,0,0,0,48,189,7,0,43,221,3,0,154,220,3,0,232,0,0,0,1,0,0,0,52,189,7,0,137,221,3,0,154,220,3,0,11,1,0,0,1,0,0,0,56,189,7,0,23,222,3,0,154,220,3,0,44,1,0,0,1,0,0,0,60,189,7,0,144,222,3,0,154,220,3,0,186,3,0,0,1,0,0,0,64,189,7,0,190,223,3,0,82,223,3,0,114,5,0,0,1,0,0,0,0,0,0,0,96,60,0,0,195,1,0,0,196,1,0,0,100,0,0,0,68,189,7,0,136,224,3,0,82,223,3,0,241,5,0,0,1,0,0,0,72,189,7,0,34,226,3,0,219,225,3,0,56,2,0,0,1,0,0,0,76,189,7,0,101,226,3,0,219,225,3,0,140,2,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,112,60,0,0,5,0,0,0,197,1,0,0,198,1,0,0,80,189,7,0,147,230,3,0,194,226,3,0,96,7,0,0,1,0,0,0,100,189,7,0,120,242,3,0,58,231,3,0,89,14,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,60,0,0,0,61,0,0,0,0,0,0,0,62,0,0,0,63,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,0,0,0,0,24,0,0,0,25,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,79,0,0,0,80,0,0,0,0,0,0,0,81,0,0,0,82,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,84,0,0,0,85,0,0,0,0,0,0,0,86,0,0,0,87,0,0,0,0,0,0,0,88,0,0,0,0,0,0,0,89,0,0,0,90,0,0,0,0,0,0,0,91,0,0,0,92,0,0,0,0,0,0,0,0,0,0,0,128,60,0,0,199,1,0,0,200,1,0,0,101,0,0,0,0,0,0,0,144,60,0,0,201,1,0,0,202,1,0,0,102,0,0,0,0,0,0,0,160,60,0,0,203,1,0,0,204,1,0,0,103,0,0,0,0,0,0,0,176,60,0,0,205,1,0,0,206,1,0,0,104,0,0,0,0,0,0,0,192,60,0,0,207,1,0,0,208,1,0,0,105,0,0,0,0,0,0,0,208,60,0,0,209,1,0,0,210,1,0,0,106,0,0,0,0,0,0,0,224,60,0,0,211,1,0,0,212,1,0,0,107,0,0,0,0,0,0,0,240,60,0,0,213,1,0,0,214,1,0,0,108,0,0,0,0,0,0,0,0,61,0,0,215,1,0,0,216,1,0,0,109,0,0,0,0,0,0,0,16,61,0,0,217,1,0,0,218,1,0,0,110,0,0,0,0,0,0,0,32,61,0,0,219,1,0,0,220,1,0,0,111,0,0,0,0,0,0,0,48,61,0,0,221,1,0,0,222,1,0,0,112,0,0,0,0,0,0,0,64,61,0,0,223,1,0,0,224,1,0,0,113,0,0,0,0,0,0,0,80,61,0,0,225,1,0,0,226,1,0,0,114,0,0,0,0,0,0,0,96,61,0,0,227,1,0,0,228,1,0,0,115,0,0,0,0,0,0,0,112,61,0,0,14,0,0,0,229,1,0,0,116,0,0,0,0,0,0,0,128,61,0,0,14,0,0,0,230,1,0,0,117,0,0,0,0,0,0,0,144,61,0,0,14,0,0,0,231,1,0,0,118,0,0,0,0,0,0,0,160,61,0,0,14,0,0,0,232,1,0,0,119,0,0,0,0,0,0,0,176,61,0,0,14,0,0,0,233,1,0,0,120,0,0,0,0,0,0,0,192,61,0,0,234,1,0,0,235,1,0,0,121,0,0,0,0,0,0,0,208,61,0,0,236,1,0,0,237,1,0,0,122,0,0,0,0,0,0,0,224,61,0,0,238,1,0,0,239,1,0,0,123,0,0,0,0,0,0,0,240,61,0,0,240,1,0,0,241,1,0,0,124,0,0,0,0,0,0,0,0,62,0,0,242,1,0,0,243,1,0,0,125,0,0,0,0,0,0,0,16,62,0,0,244,1,0,0,245,1,0,0,126,0,0,0,0,0,0,0,32,62,0,0,14,0,0,0,246,1,0,0,127,0,0,0,0,0,0,0,48,62,0,0,14,0,0,0,247,1,0,0,128,0,0,0,0,0,0,0,64,62,0,0,14,0,0,0,248,1,0,0,129,0,0,0,0,0,0,0,80,62,0,0,14,0,0,0,249,1,0,0,130,0,0,0,0,0,0,0,96,62,0,0,14,0,0,0,250,1,0,0,131,0,0,0,104,189,7,0,64,243,3,0,58,231,3,0,200,15,0,0,1,0,0,0,108,189,7,0,16,244,3,0,141,243,3,0,97,0,0,0,1,0,0,0,112,189,7,0,181,244,3,0,105,244,3,0,93,1,0,0,1,0,0,0,0,0,0,0,160,63,0,0,147,0,0,0,251,1,0,0,58,0,0,0,0,0,0,0,144,63,0,0,5,0,0,0,252,1,0,0,253,1,0,0,0,0,0,0,128,63,0,0,147,0,0,0,254,1,0,0,59,0,0,0,0,0,0,0,112,63,0,0,5,0,0,0,255,1,0,0,0,2,0,0,0,0,0,0,96,63,0,0,147,0,0,0,1,2,0,0,60,0,0,0,0,0,0,0,80,63,0,0,5,0,0,0,2,2,0,0,3,2,0,0,0,0,0,0,64,63,0,0,147,0,0,0,4,2,0,0,61,0,0,0,0,0,0,0,48,63,0,0,5,0,0,0,5,2,0,0,6,2,0,0,0,0,0,0,32,63,0,0,147,0,0,0,7,2,0,0,62,0,0,0,0,0,0,0,16,63,0,0,5,0,0,0,8,2,0,0,9,2,0,0,0,0,0,0,0,63,0,0,147,0,0,0,10,2,0,0,63,0,0,0,0,0,0,0,240,62,0,0,5,0,0,0,11,2,0,0,12,2,0,0,0,0,0,0,224,62,0,0,147,0,0,0,13,2,0,0,64,0,0,0,0,0,0,0,208,62,0,0,5,0,0,0,14,2,0,0,15,2,0,0,0,0,0,0,192,62,0,0,147,0,0,0,16,2,0,0,65,0,0,0,0,0,0,0,176,62,0,0,5,0,0,0,17,2,0,0,18,2,0,0,0,0,0,0,160,62,0,0,147,0,0,0,19,2,0,0,66,0,0,0,0,0,0,0,144,62,0,0,5,0,0,0,20,2,0,0,21,2,0,0,0,0,0,0,128,62,0,0,147,0,0,0,22,2,0,0,67,0,0,0,0,0,0,0,112,62,0,0,5,0,0,0,23,2,0,0,24,2,0,0,0,0,0,0,224,64,0,0,2,1,0,0,25,2,0,0,64,0,0,0,4,1,0,0,0,0,0,0,208,64,0,0,5,0,0,0,26,2,0,0,27,2,0,0,0,0,0,0,192,64,0,0,2,1,0,0,28,2,0,0,65,0,0,0,4,1,0,0,0,0,0,0,176,64,0,0,5,0,0,0,29,2,0,0,30,2,0,0,0,0,0,0,160,64,0,0,2,1,0,0,31,2,0,0,66,0,0,0,4,1,0,0,0,0,0,0,144,64,0,0,5,0,0,0,32,2,0,0,33,2,0,0,0,0,0,0,128,64,0,0,2,1,0,0,34,2,0,0,67,0,0,0,4,1,0,0,0,0,0,0,112,64,0,0,5,0,0,0,35,2,0,0,36,2,0,0,0,0,0,0,96,64,0,0,2,1,0,0,37,2,0,0,68,0,0,0,4,1,0,0,0,0,0,0,80,64,0,0,5,0,0,0,38,2,0,0,39,2,0,0,0,0,0,0,64,64,0,0,2,1,0,0,40,2,0,0,69,0,0,0,4,1,0,0,0,0,0,0,48,64,0,0,5,0,0,0,41,2,0,0,42,2,0,0,0,0,0,0,32,64,0,0,2,1,0,0,43,2,0,0,70,0,0,0,4,1,0,0,0,0,0,0,16,64,0,0,5,0,0,0,44,2,0,0,45,2,0,0,0,0,0,0,0,64,0,0,2,1,0,0,46,2,0,0,71,0,0,0,4,1,0,0,0,0,0,0,240,63,0,0,5,0,0,0,47,2,0,0,48,2,0,0,0,0,0,0,224,63,0,0,2,1,0,0,49,2,0,0,72,0,0,0,4,1,0,0,0,0,0,0,208,63,0,0,5,0,0,0,50,2,0,0,51,2,0,0,0,0,0,0,192,63,0,0,2,1,0,0,52,2,0,0,73,0,0,0,4,1,0,0,0,0,0,0,176,63,0,0,5,0,0,0,53,2,0,0,54,2,0,0,0,0,0,0,16,66,0,0,5,0,0,0,55,2,0,0,56,2,0,0,0,0,0,0,240,65,0,0,5,0,0,0,57,2,0,0,58,2,0,0,0,0,0,0,208,65,0,0,5,0,0,0,59,2,0,0,60,2,0,0,0,0,0,0,176,65,0,0,5,0,0,0,61,2,0,0,62,2,0,0,0,0,0,0,144,65,0,0,5,0,0,0,63,2,0,0,64,2,0,0,0,0,0,0,112,65,0,0,5,0,0,0,65,2,0,0,66,2,0,0,0,0,0,0,80,65,0,0,5,0,0,0,67,2,0,0,68,2,0,0,0,0,0,0,48,65,0,0,5,0,0,0,69,2,0,0,70,2,0,0,0,0,0,0,16,65,0,0,5,0,0,0,71,2,0,0,72,2,0,0,0,0,0,0,240,64,0,0,5,0,0,0,73,2,0,0,74,2,0,0,0,0,0,0,0,65,0,0,75,2,0,0,76,2,0,0,26,0,0,0,7,1,0,0,0,0,0,0,32,65,0,0,77,2,0,0,78,2,0,0,27,0,0,0,7,1,0,0,0,0,0,0,64,65,0,0,79,2,0,0,80,2,0,0,28,0,0,0,7,1,0,0,0,0,0,0,96,65,0,0,81,2,0,0,82,2,0,0,29,0,0,0,7,1,0,0,0,0,0,0,128,65,0,0,83,2,0,0,84,2,0,0,30,0,0,0,7,1,0,0,0,0,0,0,160,65,0,0,85,2,0,0,86,2,0,0,31,0,0,0,7,1,0,0,0,0,0,0,192,65,0,0,87,2,0,0,88,2,0,0,32,0,0,0,7,1,0,0,0,0,0,0,224,65,0,0,89,2,0,0,90,2,0,0,33,0,0,0,7,1,0,0,0,0,0,0,0,66,0,0,91,2,0,0,92,2,0,0,34,0,0,0,7,1,0,0,0,0,0,0,32,66,0,0,93,2,0,0,94,2,0,0,35,0,0,0,7,1,0,0,120,189,7,0,173,13,4,0,33,248,3,0,97,7,0,0,1,0,0,0,116,189,7,0,81,13,4,0,33,248,3,0,29,7,0,0,1,0,0,0,124,189,7,0,2,14,4,0,33,248,3,0,107,7,0,0,1,0,0,0,128,189,7,0,133,14,4,0,33,248,3,0,251,7,0,0,1,0,0,0,132,189,7,0,176,15,4,0,99,15,4,0,90,0,0,0,1,0,0,0,136,189,7,0,23,19,4,0,6,16,4,0,82,6,0,0,1,0,0,0,0,0,0,0,0,0,0,63,0,0,128,62,171,170,42,62,0,0,0,62,205,204,204,61,171,170,170,61,40,73,146,61,0,0,128,61,0,0,0,0,48,66,0,0,95,2,0,0,96,2,0,0,132,0,0,0,0,0,0,0,64,66,0,0,97,2,0,0,98,2,0,0,133,0,0,0,0,0,0,0,80,66,0,0,99,2,0,0,100,2,0,0,134,0,0,0,0,0,0,0,96,66,0,0,101,2,0,0,102,2,0,0,135,0,0,0,0,0,0,0,112,66,0,0,103,2,0,0,104,2,0,0,136,0,0,0,0,0,0,0,128,66,0,0,105,2,0,0,106,2,0,0,137,0,0,0,140,189,7,0,79,19,4,0,127,19,4,0,96,0,0,0,1,0,0,0,144,189,7,0,251,19,4,0,127,19,4,0,200,3,0,0,1,0,0,0,0,0,0,0,86,248,142,60,199,242,14,61,70,94,86,61,127,220,142,61,176,126,178,61,10,19,214,61,157,150,249,61,101,131,14,62,94,48,32,62,213,208,49,62,111,99,67,62,206,230,84,62,149,89,102,62,96,186,119,62,237,131,132,62,88,32,141,62,190,177,149,62,122,55,158,62,224,176,166,62,66,29,175,62,255,123,183,62,112,204,191,62,232,13,200,62,200,63,208,62,109,97,216,62,45,114,224,62,113,113,232,62,149,94,240,62,247,56,248,62,0,0,0,63,137,217,3,63,203,168,7,63,118,109,11,63,68,39,15,63,231,213,18,63,25,121,22,63,140,16,26,63,254,155,29,63,36,27,33,63,186,141,36,63,124,243,39,63,37,76,43,63,114,151,46,63,34,213,49,63,244,4,53,63,167,38,56,63,255,57,59,63,189,62,62,63,166,52,65,63,124,27,68,63,10,243,70,63,19,187,73,63,96,115,76,63,189,27,79,63,242,179,81,63,207,59,84,63,30,179,86,63,174,25,89,63,81,111,91,63,215,179,93,63,20,231,95,63,219,8,98,63,1,25,100,63,93,23,102,63,202,3,104,63,30,222,105,63,54,166,107,63,237,91,109,63,32,255,110,63,178,143,112,63,130,13,114,63,112,120,115,63,100,208,116,63,63,21,118,63,234,70,119,63,77,101,120,63,82,112,121,63,226,103,122,63,236,75,123,63,93,28,124,63,36,217,124,63,54,130,125,63,130,23,126,63,253,152,126,63,158,6,127,63,92,96,127,63,47,166,127,63,19,216,127,63,5,246,127,63,0,0,128,63,5,246,127,63,19,216,127,63,47,166,127,63,92,96,127,63,158,6,127,63,253,152,126,63,130,23,126,63,54,130,125,63,36,217,124,63,93,28,124,63,236,75,123,63,226,103,122,63,82,112,121,63,77,101,120,63,234,70,119,63,63,21,118,63,100,208,116,63,112,120,115,63,130,13,114,63,178,143,112,63,32,255,110,63,237,91,109,63,54,166,107,63,30,222,105,63,202,3,104,63,93,23,102,63,1,25,100,63,219,8,98,63,20,231,95,63,215,179,93,63,81,111,91,63,174,25,89,63,30,179,86,63,207,59,84,63,242,179,81,63,189,27,79,63,96,115,76,63,19,187,73,63,10,243,70,63,124,27,68,63,166,52,65,63,189,62,62,63,255,57,59,63,167,38,56,63,244,4,53,63,34,213,49,63,114,151,46,63,37,76,43,63,124,243,39,63,186,141,36,63,36,27,33,63,254,155,29,63,140,16,26,63,25,121,22,63,231,213,18,63,68,39,15,63,118,109,11,63,203,168,7,63,137,217,3,63,0,0,0,63,247,56,248,62,149,94,240,62,113,113,232,62,45,114,224,62,109,97,216,62,200,63,208,62,232,13,200,62,112,204,191,62,255,123,183,62,66,29,175,62,224,176,166,62,122,55,158,62,190,177,149,62,88,32,141,62,237,131,132,62,96,186,119,62,149,89,102,62,206,230,84,62,111,99,67,62,213,208,49,62,94,48,32,62,101,131,14,62,157,150,249,61,10,19,214,61,176,126,178,61,127,220,142,61,70,94,86,61,199,242,14,61,86,248,142,60,0,0,0,0,86,248,142,188,199,242,14,189,70,94,86,189,127,220,142,189,176,126,178,189,10,19,214,189,157,150,249,189,101,131,14,190,94,48,32,190,213,208,49,190,111,99,67,190,206,230,84,190,149,89,102,190,96,186,119,190,237,131,132,190,88,32,141,190,190,177,149,190,122,55,158,190,224,176,166,190,66,29,175,190,255,123,183,190,112,204,191,190,232,13,200,190,200,63,208,190,109,97,216,190,45,114,224,190,113,113,232,190,149,94,240,190,247,56,248,190,0,0,0,191,137,217,3,191,203,168,7,191,118,109,11,191,68,39,15,191,231,213,18,191,25,121,22,191,140,16,26,191,254,155,29,191,36,27,33,191,186,141,36,191,124,243,39,191,37,76,43,191,114,151,46,191,34,213,49,191,244,4,53,191,167,38,56,191,255,57,59,191,189,62,62,191,166,52,65,191,124,27,68,191,10,243,70,191,19,187,73,191,96,115,76,191,189,27,79,191,242,179,81,191,207,59,84,191,30,179,86,191,174,25,89,191,81,111,91,191,215,179,93,191,20,231,95,191,219,8,98,191,1,25,100,191,93,23,102,191,202,3,104,191,30,222,105,191,54,166,107,191,237,91,109,191,32,255,110,191,178,143,112,191,130,13,114,191,112,120,115,191,100,208,116,191,63,21,118,191,234,70,119,191,77,101,120,191,82,112,121,191,226,103,122,191,236,75,123,191,93,28,124,191,36,217,124,191,54,130,125,191,130,23,126,191,253,152,126,191,158,6,127,191,92,96,127,191,47,166,127,191,19,216,127,191,5,246,127,191,0,0,128,191,5,246,127,191,19,216,127,191,47,166,127,191,92,96,127,191,158,6,127,191,253,152,126,191,130,23,126,191,54,130,125,191,36,217,124,191,93,28,124,191,236,75,123,191,226,103,122,191,82,112,121,191,77,101,120,191,234,70,119,191,63,21,118,191,100,208,116,191,112,120,115,191,130,13,114,191,178,143,112,191,32,255,110,191,237,91,109,191,54,166,107,191,30,222,105,191,202,3,104,191,93,23,102,191,1,25,100,191,219,8,98,191,20,231,95,191,215,179,93,191,81,111,91,191,174,25,89,191,30,179,86,191,207,59,84,191,242,179,81,191,189,27,79,191,96,115,76,191,19,187,73,191,10,243,70,191,124,27,68,191,166,52,65,191,189,62,62,191,255,57,59,191,167,38,56,191,244,4,53,191,34,213,49,191,114,151,46,191,37,76,43,191,124,243,39,191,186,141,36,191,36,27,33,191,254,155,29,191,140,16,26,191,25,121,22,191,231,213,18,191,68,39,15,191,118,109,11,191,203,168,7,191,137,217,3,191,0,0,0,191,247,56,248,190,149,94,240,190,113,113,232,190,45,114,224,190,109,97,216,190,200,63,208,190,232,13,200,190,112,204,191,190,255,123,183,190,66,29,175,190,224,176,166,190,122,55,158,190,190,177,149,190,88,32,141,190,237,131,132,190,96,186,119,190,149,89,102,190,206,230,84,190,111,99,67,190,213,208,49,190,94,48,32,190,101,131,14,190,157,150,249,189,10,19,214,189,176,126,178,189,127,220,142,189,70,94,86,189,199,242,14,189,86,248,142,188,0,0,0,128,86,248,142,60,199,242,14,61,70,94,86,61,127,220,142,61,176,126,178,61,10,19,214,61,157,150,249,61,101,131,14,62,94,48,32,62,213,208,49,62,111,99,67,62,206,230,84,62,149,89,102,62,96,186,119,62,237,131,132,62,88,32,141,62,190,177,149,62,122,55,158,62,224,176,166,62,66,29,175,62,255,123,183,62,112,204,191,62,232,13,200,62,200,63,208,62,109,97,216,62,45,114,224,62,113,113,232,62,149,94,240,62,247,56,248,62,0,0,0,63,137,217,3,63,203,168,7,63,118,109,11,63,68,39,15,63,231,213,18,63,25,121,22,63,140,16,26,63,254,155,29,63,36,27,33,63,186,141,36,63,124,243,39,63,37,76,43,63,114,151,46,63,34,213,49,63,244,4,53,63,167,38,56,63,255,57,59,63,189,62,62,63,166,52,65,63,124,27,68,63,10,243,70,63,19,187,73,63,96,115,76,63,189,27,79,63,242,179,81,63,207,59,84,63,30,179,86,63,174,25,89,63,81,111,91,63,215,179,93,63,20,231,95,63,219,8,98,63,1,25,100,63,93,23,102,63,202,3,104,63,30,222,105,63,54,166,107,63,237,91,109,63,32,255,110,63,178,143,112,63,130,13,114,63,112,120,115,63,100,208,116,63,63,21,118,63,234,70,119,63,77,101,120,63,82,112,121,63,226,103,122,63,236,75,123,63,93,28,124,63,36,217,124,63,54,130,125,63,130,23,126,63,253,152,126,63,158,6,127,63,92,96,127,63,47,166,127,63,19,216,127,63,5,246,127,63,0,0,128,63,148,189,7,0,251,20,4,0,127,19,4,0,18,7,0,0,1,0,0,0,168,0,0,0,177,0,0,0,185,0,0,0,194,0,0,0,202,0,0,0,210,0,0,0,218,0,0,0,224,0,0,0,231,0,0,0,236,0,0,0,241,0,0,0,246,0,0,0,249,0,0,0,252,0,0,0,254,0,0,0,254,0,0,0,254,0,0,0,254,0,0,0,252,0,0,0,249,0,0,0,246,0,0,0,241,0,0,0,236,0,0,0,231,0,0,0,224,0,0,0,218,0,0,0,210,0,0,0,202,0,0,0,194,0,0,0,185,0,0,0,177,0,0,0,168,0,0,0,158,0,0,0,149,0,0,0,140,0,0,0,131,0,0,0,122,0,0,0,114,0,0,0,105,0,0,0,97,0,0,0,89,0,0,0,82,0,0,0,75,0,0,0,68,0,0,0,62,0,0,0,56,0,0,0,50,0,0,0,45,0,0,0,40,0,0,0,36,0,0,0,32,0,0,0,28,0,0,0,25,0,0,0,22,0,0,0,19,0,0,0,16,0,0,0,14,0,0,0,12,0,0,0,11,0,0,0,9,0,0,0,8,0,0,0,7,0,0,0,5,0,0,0,5,0,0,0,152,189,7,0,109,21,4,0,127,19,4,0,57,7,0,0,1,0,0,0,156,189,7,0,19,22,4,0,127,19,4,0,102,7,0,0,1,0,0,0,160,189,7,0,205,22,4,0,127,19,4,0,134,7,0,0,1,0,0,0,164,189,7,0,126,23,4,0,127,19,4,0,164,7,0,0,1,0,0,0,168,189,7,0,242,23,4,0,127,19,4,0,226,8,0,0,1,0,0,0,69,17,0,0,199,0,0,0,214,0,0,0,217,0,0,0,233,0,0,0,219,0,0,0,197,0,0,0,234,0,0,0,216,0,0,0,221,0,0,0,222,0,0,0,228,0,0,0,225,0,0,0,211,0,0,0,224,0,0,0,210,0,0,0,220,0,0,0,200,0,0,0,201,0,0,0,202,0,0,0,203,0,0,0,204,0,0,0,205,0,0,0,206,0,0,0,207,0,0,0,208,0,0,0,209,0,0,0,212,0,0,0,213,0,0,0,191,0,0,0,226,0,0,0,192,0,0,0,215,0,0,0,190,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,193,0,0,0,84,0,0,0,194],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+51200);allocate([85,0,0,0,86,0,0,0,87,0,0,0,151,0,0,0,152,0,0,0,153,0,0,0,154,0,0,0,155,0,0,0,156,0,0,0,157,0,0,0,158,0,0,0,159,0,0,0,160,0,0,0,161,0,0,0,162,0,0,0,163,0,0,0,164,0,0,0,165,0,0,0,166,0,0,0,167,0,0,0,168,0,0,0,169,0,0,0,170,0,0,0,171,0,0,0,172,0,0,0,173,0,0,0,174,0,0,0,175,0,0,0,176,0,0,0,195,0,0,0,223,0,0,0,196,0,0,0,88,0,0,0,69,16,0,0,199,0,0,0,214,0,0,0,217,0,0,0,233,0,0,0,219,0,0,0,197,0,0,0,234,0,0,0,216,0,0,0,221,0,0,0,222,0,0,0,228,0,0,0,225,0,0,0,211,0,0,0,224,0,0,0,210,0,0,0,220,0,0,0,200,0,0,0,201,0,0,0,202,0,0,0,203,0,0,0,204,0,0,0,205,0,0,0,206,0,0,0,207,0,0,0,208,0,0,0,209,0,0,0,212,0,0,0,213,0,0,0,191,0,0,0,226,0,0,0,192,0,0,0,215,0,0,0,190,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,193,0,0,0,84,0,0,0,194,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,195,0,0,0,223,0,0,0,196,0,0,0,88,0,0,0,201,55,0,0,151,8,0,0,204,10,0,0,218,10,0,0,222,10,0,0,209,10,0,0,223,10,0,0,208,10,0,0,217,10,0,0,211,10,0,0,212,10,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,190,10,0,0,191,10,0,0,192,10,0,0,193,10,0,0,194,10,0,0,195,10,0,0,196,10,0,0,197,10,0,0,198,10,0,0,199,10,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,205,10,0,0,225,8,0,0,3,8,0,0,4,8,0,0,5,8,0,0,6,8,0,0,7,8,0,0,8,8,0,0,9,8,0,0,10,8,0,0,11,8,0,0,12,8,0,0,13,8,0,0,14,8,0,0,15,8,0,0,16,8,0,0,17,8,0,0,18,8,0,0,19,8,0,0,20,8,0,0,21,8,0,0,22,8,0,0,23,8,0,0,24,8,0,0,25,8,0,0,26,8,0,0,27,8,0,0,28,8,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,103,8,0,0,104,8,0,0,105,8,0,0,106,8,0,0,107,8,0,0,108,8,0,0,109,8,0,0,110,8,0,0,111,8,0,0,112,8,0,0,113,8,0,0,114,8,0,0,115,8,0,0,116,8,0,0,117,8,0,0,118,8,0,0,119,8,0,0,120,8,0,0,121,8,0,0,122,8,0,0,123,8,0,0,124,8,0,0,125,8,0,0,126,8,0,0,127,8,0,0,128,8,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,48,0,0,151,8,0,0,166,8,0,0,169,8,0,0,227,8,0,0,226,8,0,0,223,8,0,0,224,8,0,0,168,8,0,0,173,8,0,0,174,8,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,152,8,0,0,153,8,0,0,154,8,0,0,155,8,0,0,156,8,0,0,157,8,0,0,158,8,0,0,159,8,0,0,160,8,0,0,161,8,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,167,8,0,0,225,8,0,0,209,7,0,0,210,7,0,0,211,7,0,0,212,7,0,0,213,7,0,0,214,7,0,0,215,7,0,0,216,7,0,0,217,7,0,0,218,7,0,0,219,7,0,0,220,7,0,0,221,7,0,0,222,7,0,0,223,7,0,0,224,7,0,0,225,7,0,0,226,7,0,0,227,7,0,0,228,7,0,0,229,7,0,0,230,7,0,0,231,7,0,0,232,7,0,0,233,7,0,0,234,7,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,53,8,0,0,54,8,0,0,55,8,0,0,56,8,0,0,57,8,0,0,58,8,0,0,59,8,0,0,60,8,0,0,61,8,0,0,62,8,0,0,63,8,0,0,64,8,0,0,65,8,0,0,66,8,0,0,67,8,0,0,68,8,0,0,69,8,0,0,70,8,0,0,71,8,0,0,72,8,0,0,73,8,0,0,74,8,0,0,75,8,0,0,76,8,0,0,77,8,0,0,78,8,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,241,10,0,0,242,10,0,0,243,10,0,0,244,10,0,0,245,10,0,0,246,10,0,0,247,10,0,0,248,10,0,0,249,10,0,0,250,10,0,0,251,10,0,0,252,10,0,0,253,10,0,0,254,10,0,0,255,10,0,0,0,11,0,0,1,11,0,0,2,11,0,0,3,11,0,0,4,11,0,0,5,11,0,0,6,11,0,0,7,11,0,0,8,11,0,0,9,11,0,0,10,11,0,0,11,11,0,0,12,11,0,0,13,11,0,0,14,11,0,0,15,11,0,0,16,11,0,0,85,11,0,0,86,11,0,0,87,11,0,0,88,11,0,0,89,11,0,0,90,11,0,0,91,11,0,0,92,11,0,0,93,11,0,0,94,11,0,0,95,11,0,0,96,11,0,0,97,11,0,0,98,11,0,0,99,11,0,0,100,11,0,0,101,11,0,0,102,11,0,0,103,11,0,0,104,11,0,0,105,11,0,0,106,11,0,0,107,11,0,0,108,11,0,0,109,11,0,0,110,11,0,0,111,11,0,0,112,11,0,0,113,11,0,0,114,11,0,0,115,11,0,0,116,11,0,0,201,23,0,0,151,8,0,0,192,12,0,0,206,12,0,0,210,12,0,0,197,12,0,0,161,12,0,0,196,12,0,0,205,12,0,0,199,12,0,0,200,12,0,0,151,12,0,0,153,12,0,0,189,12,0,0,152,12,0,0,188,12,0,0,198,12,0,0,178,12,0,0,179,12,0,0,180,12,0,0,181,12,0,0,182,12,0,0,183,12,0,0,184,12,0,0,185,12,0,0,186,12,0,0,187,12,0,0,190,12,0,0,191,12,0,0,158,12,0,0,154,12,0,0,159,12,0,0,193,12,0,0,162,12,0,0,235,11,0,0,236,11,0,0,237,11,0,0,238,11,0,0,239,11,0,0,240,11,0,0,241,11,0,0,242,11,0,0,243,11,0,0,244,11,0,0,245,11,0,0,246,11,0,0,247,11,0,0,16,8,0,0,249,11,0,0,250,11,0,0,251,11,0,0,252,11,0,0,253,11,0,0,254,11,0,0,255,11,0,0,0,12,0,0,1,12,0,0,2,12,0,0,3,12,0,0,4,12,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,79,12,0,0,80,12,0,0,81,12,0,0,82,12,0,0,83,12,0,0,84,12,0,0,85,12,0,0,86,12,0,0,87,12,0,0,88,12,0,0,89,12,0,0,90,12,0,0,91,12,0,0,92,12,0,0,93,12,0,0,94,12,0,0,95,12,0,0,96,12,0,0,97,12,0,0,98,12,0,0,99,12,0,0,100,12,0,0,101,12,0,0,102,12,0,0,103,12,0,0,104,12,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,16,0,0,151,8,0,0,142,12,0,0,156,12,0,0,160,12,0,0,147,12,0,0,161,12,0,0,146,12,0,0,155,12,0,0,149,12,0,0,150,12,0,0,151,12,0,0,153,12,0,0,139,12,0,0,152,12,0,0,138,12,0,0,148,12,0,0,128,12,0,0,129,12,0,0,130,12,0,0,131,12,0,0,132,12,0,0,133,12,0,0,134,12,0,0,135,12,0,0,136,12,0,0,137,12,0,0,140,12,0,0,141,12,0,0,158,12,0,0,154,12,0,0,159,12,0,0,143,12,0,0,162,12,0,0,185,11,0,0,186,11,0,0,187,11,0,0,188,11,0,0,189,11,0,0,190,11,0,0,191,11,0,0,192,11,0,0,193,11,0,0,194,11,0,0,195,11,0,0,196,11,0,0,197,11,0,0,222,7,0,0,199,11,0,0,200,11,0,0,201,11,0,0,202,11,0,0,203,11,0,0,204,11,0,0,205,11,0,0,206,11,0,0,207,11,0,0,208,11,0,0,209,11,0,0,210,11,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,29,12,0,0,30,12,0,0,31,12,0,0,32,12,0,0,33,12,0,0,34,12,0,0,35,12,0,0,36,12,0,0,37,12,0,0,38,12,0,0,39,12,0,0,40,12,0,0,41,12,0,0,42,12,0,0,43,12,0,0,44,12,0,0,45,12,0,0,46,12,0,0,47,12,0,0,48,12,0,0,49,12,0,0,50,12,0,0,51,12,0,0,52,12,0,0,53,12,0,0,54,12,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,118,17,0,0,175,4,0,0,190,4,0,0,193,4,0,0,251,4,0,0,250,4,0,0,247,4,0,0,248,4,0,0,192,4,0,0,197,4,0,0,198,4,0,0,195,4,0,0,208,4,0,0,187,4,0,0,207,4,0,0,186,4,0,0,196,4,0,0,176,4,0,0,177,4,0,0,178,4,0,0,179,4,0,0,180,4,0,0,181,4,0,0,182,4,0,0,183,4,0,0,184,4,0,0,185,4,0,0,188,4,0,0,189,4,0,0,217,4,0,0,214,4,0,0,218,4,0,0,191,4,0,0,249,4,0,0,27,4,0,0,28,4,0,0,29,4,0,0,30,4,0,0,31,4,0,0,32,4,0,0,33,4,0,0,34,4,0,0,35,4,0,0,36,4,0,0,37,4,0,0,38,4,0,0,39,4,0,0,40,4,0,0,41,4,0,0,42,4,0,0,43,4,0,0,44,4,0,0,45,4,0,0,46,4,0,0,47,4,0,0,48,4,0,0,49,4,0,0,50,4,0,0,51,4,0,0,52,4,0,0,199,4,0,0,60,4,0,0,200,4,0,0,223,4,0,0,74,2,0,0,225,4,0,0,127,4,0,0,128,4,0,0,129,4,0,0,130,4,0,0,131,4,0,0,132,4,0,0,133,4,0,0,134,4,0,0,135,4,0,0,136,4,0,0,137,4,0,0,138,4,0,0,139,4,0,0,140,4,0,0,141,4,0,0,142,4,0,0,143,4,0,0,144,4,0,0,145,4,0,0,146,4,0,0,147,4,0,0,148,4,0,0,149,4,0,0,150,4,0,0,151,4,0,0,152,4,0,0,201,4,0,0,205,4,0,0,202,4,0,0,222,4,0,0,118,16,0,0,175,4,0,0,190,4,0,0,193,4,0,0,251,4,0,0,250,4,0,0,247,4,0,0,248,4,0,0,192,4,0,0,197,4,0,0,198,4,0,0,195,4,0,0,208,4,0,0,187,4,0,0,207,4,0,0,186,4,0,0,196,4,0,0,176,4,0,0,177,4,0,0,178,4,0,0,179,4,0,0,180,4,0,0,181,4,0,0,182,4,0,0,183,4,0,0,184,4,0,0,185,4,0,0,188,4,0,0,165,8,0,0,217,4,0,0,214,4,0,0,218,4,0,0,191,4,0,0,249,4,0,0,233,3,0,0,234,3,0,0,235,3,0,0,236,3,0,0,237,3,0,0,238,3,0,0,239,3,0,0,240,3,0,0,241,3,0,0,242,3,0,0,243,3,0,0,244,3,0,0,245,3,0,0,246,3,0,0,247,3,0,0,248,3,0,0,249,3,0,0,250,3,0,0,251,3,0,0,252,3,0,0,253,3,0,0,254,3,0,0,255,3,0,0,0,4,0,0,1,4,0,0,2,4,0,0,199,4,0,0,60,4,0,0,200,4,0,0,223,4,0,0,74,2,0,0,225,4,0,0,77,4,0,0,78,4,0,0,79,4,0,0,80,4,0,0,81,4,0,0,82,4,0,0,83,4,0,0,84,4,0,0,85,4,0,0,86,4,0,0,87,4,0,0,88,4,0,0,89,4,0,0,90,4,0,0,91,4,0,0,92,4,0,0,93,4,0,0,94,4,0,0,95,4,0,0,96,4,0,0,97,4,0,0,98,4,0,0,99,4,0,0,100,4,0,0,101,4,0,0,102,4,0,0,201,4,0,0,205,4,0,0,202,4,0,0,222,4,0,0,201,23,0,0,151,8,0,0,204,10,0,0,218,10,0,0,222,10,0,0,209,10,0,0,223,10,0,0,208,10,0,0,217,10,0,0,211,10,0,0,212,10,0,0,171,8,0,0,184,8,0,0,163,8,0,0,183,8,0,0,162,8,0,0,172,8,0,0,190,10,0,0,191,10,0,0,192,10,0,0,193,10,0,0,194,10,0,0,195,10,0,0,196,10,0,0,197,10,0,0,198,10,0,0,199,10,0,0,164,8,0,0,165,8,0,0,193,8,0,0,190,8,0,0,194,8,0,0,167,8,0,0,225,8,0,0,247,9,0,0,248,9,0,0,249,9,0,0,250,9,0,0,251,9,0,0,252,9,0,0,253,9,0,0,254,9,0,0,255,9,0,0,0,10,0,0,1,10,0,0,2,10,0,0,3,10,0,0,4,10,0,0,5,10,0,0,6,10,0,0,7,10,0,0,8,10,0,0,9,10,0,0,10,10,0,0,11,10,0,0,12,10,0,0,13,10,0,0,14,10,0,0,15,10,0,0,16,10,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,74,2,0,0,201,8,0,0,91,10,0,0,92,10,0,0,93,10,0,0,94,10,0,0,95,10,0,0,96,10,0,0,97,10,0,0,98,10,0,0,99,10,0,0,100,10,0,0,101,10,0,0,102,10,0,0,103,10,0,0,104,10,0,0,105,10,0,0,106,10,0,0,107,10,0,0,108,10,0,0,109,10,0,0,110,10,0,0,111,10,0,0,112,10,0,0,113,10,0,0,114,10,0,0,115,10,0,0,116,10,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,17,0,0,151,8,0,0,202,2,0,0,205,2,0,0,221,2,0,0,207,2,0,0,185,2,0,0,222,2,0,0,204,2,0,0,209,2,0,0,210,2,0,0,216,2,0,0,213,2,0,0,199,2,0,0,212,2,0,0,198,2,0,0,208,2,0,0,188,2,0,0,189,2,0,0,190,2,0,0,191,2,0,0,192,2,0,0,193,2,0,0,194,2,0,0,195,2,0,0,196,2,0,0,197,2,0,0,200,2,0,0,201,2,0,0,179,2,0,0,214,2,0,0,180,2,0,0,203,2,0,0,178,2,0,0,39,2,0,0,40,2,0,0,41,2,0,0,42,2,0,0,43,2,0,0,44,2,0,0,45,2,0,0,46,2,0,0,47,2,0,0,48,2,0,0,49,2,0,0,50,2,0,0,51,2,0,0,52,2,0,0,53,2,0,0,54,2,0,0,55,2,0,0,56,2,0,0,57,2,0,0,58,2,0,0,59,2,0,0,60,2,0,0,61,2,0,0,62,2,0,0,63,2,0,0,64,2,0,0,181,2,0,0,72,2,0,0,182,2,0,0,199,8,0,0,74,2,0,0,201,8,0,0,139,2,0,0,140,2,0,0,141,2,0,0,142,2,0,0,143,2,0,0,144,2,0,0,145,2,0,0,146,2,0,0,147,2,0,0,148,2,0,0,149,2,0,0,150,2,0,0,151,2,0,0,152,2,0,0,153,2,0,0,154,2,0,0,155,2,0,0,156,2,0,0,157,2,0,0,158,2,0,0,159,2,0,0,160,2,0,0,161,2,0,0,162,2,0,0,163,2,0,0,164,2,0,0,183,2,0,0,211,2,0,0,184,2,0,0,198,8,0,0,201,16,0,0,151,8,0,0,154,10,0,0,168,10,0,0,172,10,0,0,159,10,0,0,173,10,0,0,158,10,0,0,167,10,0,0,161,10,0,0,162,10,0,0,163,10,0,0,165,10,0,0,151,10,0,0,164,10,0,0,150,10,0,0,160,10,0,0,140,10,0,0,141,10,0,0,142,10,0,0,143,10,0,0,144,10,0,0,145,10,0,0,146,10,0,0,147,10,0,0,148,10,0,0,149,10,0,0,152,10,0,0,153,10,0,0,170,10,0,0,166,10,0,0,171,10,0,0,155,10,0,0,174,10,0,0,197,9,0,0,198,9,0,0,199,9,0,0,200,9,0,0,201,9,0,0,202,9,0,0,203,9,0,0,204,9,0,0,205,9,0,0,206,9,0,0,207,9,0,0,208,9,0,0,209,9,0,0,210,9,0,0,211,9,0,0,212,9,0,0,213,9,0,0,214,9,0,0,215,9,0,0,216,9,0,0,217,9,0,0,218,9,0,0,219,9,0,0,220,9,0,0,221,9,0,0,222,9,0,0,175,8,0,0,36,8,0,0,176,8,0,0,199,8,0,0,75,2,0,0,201,8,0,0,41,10,0,0,42,10,0,0,43,10,0,0,44,10,0,0,45,10,0,0,46,10,0,0,47,10,0,0,48,10,0,0,49,10,0,0,50,10,0,0,51,10,0,0,52,10,0,0,53,10,0,0,54,10,0,0,55,10,0,0,56,10,0,0,57,10,0,0,58,10,0,0,59,10,0,0,60,10,0,0,61,10,0,0,62,10,0,0,63,10,0,0,64,10,0,0,65,10,0,0,66,10,0,0,177,8,0,0,181,8,0,0,178,8,0,0,198,8,0,0,201,16,0,0,151,8,0,0,202,2,0,0,205,2,0,0,221,2,0,0,207,2,0,0,185,2,0,0,222,2,0,0,204,2,0,0,209,2,0,0,210,2,0,0,216,2,0,0,213,2,0,0,199,2,0,0,212,2,0,0,198,2,0,0,208,2,0,0,188,2,0,0,189,2,0,0,190,2,0,0,191,2,0,0,192,2,0,0,193,2,0,0,194,2,0,0,195,2,0,0,196,2,0,0,197,2,0,0,200,2,0,0,201,2,0,0,179,2,0,0,214,2,0,0,180,2,0,0,203,2,0,0,178,2,0,0,245,1,0,0,246,1,0,0,247,1,0,0,248,1,0,0,249,1,0,0,250,1,0,0,251,1,0,0,252,1,0,0,253,1,0,0,254,1,0,0,255,1,0,0,0,2,0,0,1,2,0,0,2,2,0,0,3,2,0,0,4,2,0,0,5,2,0,0,6,2,0,0,7,2,0,0,8,2,0,0,9,2,0,0,10,2,0,0,11,2,0,0,12,2,0,0,13,2,0,0,14,2,0,0,181,2,0,0,72,2,0,0,182,2,0,0,199,8,0,0,74,2,0,0,201,8,0,0,89,2,0,0,90,2,0,0,91,2,0,0,92,2,0,0,93,2,0,0,94,2,0,0,95,2,0,0,96,2,0,0,97,2,0,0,98,2,0,0,99,2,0,0,100,2,0,0,101,2,0,0,102,2,0,0,103,2,0,0,104,2,0,0,105,2,0,0,106,2,0,0,107,2,0,0,108,2,0,0,109,2,0,0,110,2,0,0,111,2,0,0,112,2,0,0,113,2,0,0,114,2,0,0,183,2,0,0,211,2,0,0,184,2,0,0,198,8,0,0,172,189,7,0,79,25,4,0,127,19,4,0,170,9,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,255,255,255,255,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,255,255,255,255,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,160,66,0,0,107,2,0,0,108,2,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,34,0,0,0,1,0,0,0,1,0,0,0,138,0,0,0,139,0,0,0,109,2,0,0,0,0,0,0,144,66,0,0,5,0,0,0,110,2,0,0,111,2,0,0,176,189,7,0,72,29,4,0,137,26,4,0,102,1,0,0,1,0,0,0,0,0,0,0,32,67,0,0,112,2,0,0,113,2,0,0,140,0,0,0,0,0,0,0,16,67,0,0,5,0,0,0,114,2,0,0,115,2,0,0,0,0,0,0,0,67,0,0,116,2,0,0,117,2,0,0,141,0,0,0,0,0,0,0,240,66,0,0,5,0,0,0,118,2,0,0,119,2,0,0,0,0,0,0,224,66,0,0,120,2,0,0,121,2,0,0,142,0,0,0,0,0,0,0,208,66,0,0,5,0,0,0,122,2,0,0,123,2,0,0,0,0,0,0,192,66,0,0,124,2,0,0,125,2,0,0,143,0,0,0,0,0,0,0,176,66,0,0,5,0,0,0,126,2,0,0,127,2,0,0,180,253,12,0,103,32,4,0,242,29,4,0,157,6,0,0,1,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,0,0,0,0,36,0,0,0,0,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,39,0,0,0,40,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,42,0,0,0,43,0,0,0,0,0,0,0,44,0,0,0,45,0,0,0,0,0,0,0,46,0,0,0,0,0,0,0,47,0,0,0,48,0,0,0,0,0,0,0,49,0,0,0,50,0,0,0,0,0,0,0,0,0,0,0,48,67,0,0,14,0,0,0,128,2,0,0,144,0,0,0,0,0,0,0,64,67,0,0,129,2,0,0,130,2,0,0,145,0,0,0,184,253,12,0,159,33,4,0,242,29,4,0,113,10,0,0,1,0,0,0,0,0,0,0,80,67,0,0,131,2,0,0,132,2,0,0,146,0,0,0,188,253,12,0,122,34,4,0,242,29,4,0,160,11,0,0,1,0,0,0,192,253,12,0,216,34,4,0,242,29,4,0,2,12,0,0,1,0,0,0,196,253,12,0,17,35,4,0,242,29,4,0,47,12,0,0,1,0,0,0,0,0,0,0,96,67,0,0,5,0,0,0,133,2,0,0,134,2,0,0,200,253,12,0,232,36,4,0,108,36,4,0,145,2,0,0,1,0,0,0,204,253,12,0,18,37,4,0,108,36,4,0,255,2,0,0,1,0,0,0,208,253,12,0,128,39,4,0,142,37,4,0,203,2,0,0,1,0,0,0,0,0,0,0,128,67,0,0,14,0,0,0,135,2,0,0,147,0,0,0,0,0,0,0,112,67,0,0,14,0,0,0,136,2,0,0,148,0,0,0,216,253,12,0,167,40,4,0,142,37,4,0,89,3,0,0,1,0,0,0,212,253,12,0,109,40,4,0,142,37,4,0,172,2,0,0,1,0,0,0,178,40,17,0,234,40,4,0,251,40,4,0,26,41,4,0,49,41,4,0,73,41,4,0,95,41,4,0,112,41,4,0,142,41,4,0,159,41,4,0,166,41,4,0,181,41,4,0,198,41,4,0,210,41,4,0,232,41,4,0,249,41,4,0,22,42,4,0,42,42,4,0,76,42,4,0,101,42,4,0,128,42,4,0,140,42,4,0,159,42,4,0,171,42,4,0,193,42,4,0,205,42,4,0,219,42,4,0,234,40,4,0,251,40,4,0,236,42,4,0,248,42,4,0,73,41,4,0,219,42,4,0,142,41,4,0,9,43,4,0,159,41,4,0,181,41,4,0,48,43,4,0,210,41,4,0,232,41,4,0,60,43,4,0,249,41,4,0,82,43,4,0,22,42,4,0,99,43,4,0,128,42,4,0,118,43,4,0,148,43,4,0,193,42,4,0,174,43,4,0,198,43,4,0,225,43,4,0,242,43,4,0,19,44,4,0,48,44,4,0,72,44,4,0,94,44,4,0,111,44,4,0,142,44,4,0,159,44,4,0,166,44,4,0,183,44,4,0,200,44,4,0,212,44,4,0,234,44,4,0,251,44,4,0,28,45,4,0,50,45,4,0,102,45,4,0,135,45,4,0,162,45,4,0,174,45,4,0,193,45,4,0,205,45,4,0,227,45,4,0,239,45,4,0,253,45,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,8,46,4,0,25,46,4,0,32,46,4,0,44,46,4,0,51,46,4,0,58,46,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,73,46,4,0,99,46,4,0,125,46,4,0,146,46,4,0,172,46,4,0,193,46,4,0,211,46,4,0,243,46,4,0,7,47,4,0,25,47,4,0,49,47,4,0,159,41,4,0,66,47,4,0,103,47,4,0,123,47,4,0,144,47,4,0,170,47,4,0,196,47,4,0,212,47,4,0,239,47,4,0,1,48,4,0,21,48,4,0,33,48,4,0,55,48,4,0,67,48,4,0,85,48,4,0,96,48,4,0,121,48,4,0,158,48,4,0,184,48,4,0,215,48,4,0,245,48,4,0,21,49,4,0,53,49,4,0,92,49,4,0,107,49,4,0,132,49,4,0,150,49,4,0,183,49,4,0,201,49,4,0,123,47,4,0,244,49,4,0,11,50,4,0,34,50,4,0,57,50,4,0,71,50,4,0,94,50,4,0,125,50,4,0,149,50,4,0,177,50,4,0,207,50,4,0,239,50,4,0,6,51,4,0,25,51,4,0,57,51,4,0,82,51,4,0,106,51,4,0,140,51,4,0,168,51,4,0,198,51,4,0,230,51,4,0,255,51,4,0,12,52,4,0,61,52,4,0,123,47,4,0,95,52,4,0,127,52,4,0,153,52,4,0,177,52,4,0,204,52,4,0,222,52,4,0,0,53,4,0,25,53,4,0,65,53,4,0,101,53,4,0,137,53,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,162,53,4,0,191,53,4,0,217,53,4,0,251,53,4,0,25,54,4,0,178,40,17,0,178,40,17,0,50,54,4,0,108,54,4,0,117,54,4,0,126,54,4,0,137,54,4,0,148,54,4,0,173,54,4,0,198,54,4,0,246,54,4,0,249,54,4,0,252,54,4,0,21,55,4,0,30,55,4,0,49,55,4,0,79,55,4,0,93,55,4,0,121,55,4,0,150,55,4,0,162,55,4,0,200,55,4,0,229,55,4,0,242,55,4,0,1,56,4,0,25,56,4,0,51,56,4,0,74,56,4,0,108,56,4,0,115,56,4,0,127,56,4,0,148,56,4,0,180,56,4,0,187,56,4,0,202,56,4,0,217,56,4,0,224,56,4,0,231,56,4,0,243,56,4,0,255,56,4,0,11,57,4,0,28,57,4,0,41,57,4,0,56,57,4,0,71,57,4,0,85,57,4,0,107,57,4,0,150,57,4,0,188,57,4,0,178,40,17,0,225,57,4,0,249,57,4,0,55,58,4,0,178,40,17,0,62,58,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,75,58,4,0,178,40,17,0,161,58,4,0,178,40,17,0,215,58,4,0,178,40,17,0,231,58,4,0,178,40,17,0,244,58,4,0,178,40,17,0,42,59,4,0,49,59,4,0,178,40,17,0,61,59,4,0,151,59,4,0,249,59,4,0,86,60,4,0,206,60,4,0,97,61,4,0,18,62,4,0,182,62,4,0,68,63,4,0,205,63,4,0,251,63,4,0,98,64,4,0,176,64,4,0,32,65,4,0,123,65,4,0,145,65,4,0,178,40,17,0,180,65,4,0,223,65,4,0,10,66,4,0,42,66,4,0,74,66,4,0,178,40,17,0,106,66,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,123,66,4,0,140,66,4,0,187,66,4,0,226,66,4,0,2,67,4,0,24,67,4,0,41,67,4,0,87,67,4,0,104,67,4,0,111,67,4,0,134,67,4,0,151,67,4,0,163,67,4,0,185,67,4,0,202,67,4,0,247,67,4,0,19,68,4,0,69,68,4,0,102,68,4,0,145,68,4,0,157,68,4,0,180,68,4,0,192,68,4,0,214,68,4,0,226,68,4,0,240,68,4,0,123,66,4,0,140,66,4,0,1,69,4,0,13,69,4,0,2,67,4,0,240,68,4,0,87,67,4,0,30,69,4,0,104,67,4,0,134,67,4,0,80,69,4,0,163,67,4,0,185,67,4,0,92,69,4,0,202,67,4,0,109,69,4,0,247,67,4,0,126,69,4,0,145,68,4,0,145,69,4,0,183,69,4,0,225,69,4,0,237,69,4,0,17,70,4,0,52,70,4,0,93,70,4,0,175,70,4,0,224,70,4,0,39,71,4,0,96,71,4,0,151,71,4,0,210,71,4,0,30,72,4,0,81,72,4,0,132,72,4,0,209,72,4,0,12,73,4,0,101,73,4,0,165,73,4,0,224,73,4,0,31,74,4,0,96,74,4,0,173,74,4,0,230,74,4,0,24,75,4,0,90,75,4,0,155,75,4,0,203,75,4,0,19,76,4,0,95,76,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,176,76,4,0,193,76,4,0,200,76,4,0,212,76,4,0,219,76,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,232,76,4,0,12,77,4,0,48,77,4,0,79,77,4,0,115,77,4,0,152,77,4,0,170,77,4,0,216,77,4,0,238,77,4,0,0,78,4,0,24,78,4,0,104,67,4,0,41,78,4,0,78,78,4,0,100,78,4,0,137,78,4,0,173,78,4,0,209,78,4,0,227,78,4,0,8,79,4,0,26,79,4,0,48,79,4,0,60,79,4,0,82,79,4,0,94,79,4,0,114,79,4,0,131,79,4,0,179,79,4,0,240,79,4,0,18,80,4,0,67,80,4,0,105,80,4,0,151,80,4,0,189,80,4,0,244,80,4,0,7,81,4,0,44,81,4,0,62,81,4,0,103,81,4,0,131,81,4,0,188,81,4,0,225,81,4,0,250,81,4,0,33,82,4,0,70,82,4,0,86,82,4,0,119,82,4,0,162,82,4,0,190,82,4,0,230,82,4,0,20,83,4,0,65,83,4,0,112,83,4,0,141,83,4,0,189,83,4,0,224,83,4,0,17,84,4,0,73,84,4,0,131,84,4,0,163,84,4,0,203,84,4,0,12,85,4,0,49,85,4,0,114,85,4,0,160,85,4,0,207,85,4,0,254,85,4,0,52,86,4,0,83,86,4,0,115,86,4,0,146,86,4,0,184,86,4,0,218,86,4,0,11,87,4,0,51,87,4,0,97,87,4,0,144,87,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,189,87,4,0,242,87,4,0,18,88,4,0,64,88,4,0,106,88,4,0,178,40,17,0,178,40,17,0,139,88,4,0,227,88,4,0,236,88,4,0,245,88,4,0,6,89,4,0,23,89,4,0,56,89,4,0,89,89,4,0,249,54,4,0,152,89,4,0,155,89,4,0,192,89,4,0,203,89,4,0,234,89,4,0,11,90,4,0,25,90,4,0,62,90,4,0,111,90,4,0,123,90,4,0,184,90,4,0,233,90,4,0,246,90,4,0,9,91,4,0,33,91,4,0,63,91,4,0,81,91,4,0,123,91,4,0,130,91,4,0,142,91,4,0,171,91,4,0,224,91,4,0,231,91,4,0,254,91,4,0,21,92,4,0,28,92,4,0,35,92,4,0,47,92,4,0,59,92,4,0,71,92,4,0,88,92,4,0,101,92,4,0,118,92,4,0,135,92,4,0,153,92,4,0,175,92,4,0,246,92,4,0,44,93,4,0,97,93,4,0,109,93,4,0,121,93,4,0,130,93,4,0,165,93,4,0,228,93,4,0,24,94,4,0,62,94,4,0,154,94,4,0,2,95,4,0,178,40,17,0,178,40,17,0,178,40,17,0,107,95,4,0,143,95,4,0,175,95,4,0,192,95,4,0,242,95,4,0,34,96,4,0,60,96,4,0,80,96,4,0,103,96,4,0,130,96,4,0,153,96,4,0,168,96,4,0,181,96,4,0,196,96,4,0,211,96,4,0,254,96,4,0,41,97,4,0,104,97,4,0,144,97,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,204,97,4,0,211,97,4,0,218,97,4,0,225,97,4,0,232,97,4,0,239,97,4,0,246,97,4,0,178,40,17,0,253,97,4,0,4,98,4,0,11,98,4,0,18,98,4,0,178,40,17,0,25,98,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,32,98,4,0,51,98,4,0,70,98,4,0,89,98,4,0,108,98,4,0,119,98,4,0,130,98,4,0,141,98,4,0,152,98,4,0,199,98,4,0,246,98,4,0,37,99,4,0,84,99,4,0,127,99,4,0,166,99,4,0,178,40,17,0,217,99,4,0,234,99,4,0,245,99,4,0,1,100,4,0,18,100,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,35,100,4,0,72,100,4,0,85,100,4,0,96,100,4,0,109,100,4,0,134,100,4,0,146,100,4,0,158,100,4,0,178,40,17,0,178,40,17,0,175,100,4,0,239,100,4,0,31,101,4,0,62,101,4,0,93,101,4,0,124,101,4,0,155,101,4,0,178,40,17,0,178,40,17,0,178,40,17,0,195,101,4,0,220,101,4,0,241,101,4,0,11,102,4,0,43,102,4,0,80,102,4,0,101,102,4,0,130,102,4,0,194,102,4,0,214,102,4,0,24,103,4,0,138,103,4,0,54,104,4,0,132,104,4,0,194,104,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,221,104,4,0,234,104,4,0,255,104,4,0,28,105,4,0,35,100,4,0,65,105,4,0,110,105,4,0,179,105,4,0,248,105,4,0,93,106,4,0,161,106,4,0,226,106,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,31,107,4,0,63,107,4,0,129,107,4,0,177,107,4,0,227,107,4,0,11,108,4,0,47,108,4,0,115,108,4,0,162,108,4,0,184,108,4,0,221,108,4,0,12,109,4,0,38,109,4,0,90,109,4,0,127,109,4,0,190,109,4,0,237,109,4,0,72,110,4,0,141,110,4,0,205,110,4,0,235,110,4,0,17,111,4,0,44,111,4,0,86,111,4,0,123,111,4,0,159,111,4,0,31,107,4,0,63,107,4,0,189,111,4,0,215,111,4,0,227,107,4,0,159,111,4,0,115,108,4,0,242,111,4,0,162,108,4,0,221,108,4,0,69,112,4,0,38,109,4,0,90,109,4,0,96,112,4,0,127,109,4,0,158,112,4,0,190,109,4,0,195,112,4,0,205,110,4,0,232,112,4,0,39,113,4,0,86,111,4,0,114,113,4,0,175,113,4,0,242,113,4,0,18,114,4,0,82,114,4,0,132,114,4,0,182,114,4,0,222,114,4,0,2,115,4,0,66,115,4,0,113,115,4,0,135,115,4,0,172,115,4,0,219,115,4,0,245,115,4,0,41,116,4,0,78,116,4,0,141,116,4,0,186,116,4,0,19,117,4,0,84,117,4,0,140,117,4,0,170,117,4,0,208,117,4,0,235,117,4,0,21,118,4,0,58,118,4,0,94,118,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,124,118,4,0,131,118,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,143,118,4,0,205,118,4,0,4,119,4,0,52,119,4,0,112,119,4,0,163,119,4,0,201,119,4,0,25,120,4,0,76,120,4,0,109,120,4,0,153,120,4,0,200,120,4,0,222,120,4,0,46,121,4,0,97,121,4,0,152,121,4,0,212,121,4,0,11,122,4,0,52,122,4,0,104,122,4,0,131,122,4,0,182,122,4,0,209,122,4,0,251,122,4,0,32,123,4,0,75,123,4,0,105,123,4,0,167,123,4,0,243,123,4,0,24,124,4,0,100,124,4,0,152,124,4,0,208,124,4,0,2,125,4,0,71,125,4,0,97,125,4,0,146,125,4,0,174,125,4,0,223,125,4,0,3,126,4,0,72,126,4,0,127,126,4,0,163,126,4,0,219,126,4,0,18,127,4,0,44,127,4,0,92,127,4,0,160,127,4,0,193,127,4,0,247,127,4,0,61,128,4,0,123,128,4,0,184,128,4,0,228,128,4,0,39,129,4,0,85,129,4,0,130,129,4,0,196,129,4,0,251,129,4,0,46,130,4,0,97,130,4,0,157,130,4,0,188,130,4,0,20,131,4,0,72,126,4,0,84,131,4,0,151,131,4,0,204,131,4,0,247,131,4,0,39,132,4,0,70,132,4,0,44,127,4,0,134,132,4,0,206,132,4,0,24,133,4,0,92,133,4,0,143,133,4,0,216,133,4,0,13,134,4,0,62,134,4,0,150,134,4,0,234,134,4,0,178,40,17,0,0,135,4,0,41,135,4,0,109,135,4,0,174,135,4,0,178,40,17,0,178,40,17,0,178,40,17,0,218,135,4,0,49,136,4,0,122,136,4,0,194,136,4,0,57,137,4,0,175,137,4,0,178,40,17,0,215,137,4,0,218,137,4,0,221,137,4,0,20,138,4,0,39,138,4,0,107,138,4,0,183,138,4,0,207,138,4,0,14,139,4,0,85,139,4],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+61440);allocate([126,139,4,0,224,139,4,0,39,140,4,0,52,140,4,0,69,140,4,0,93,140,4,0,121,140,4,0,150,140,4,0,207,140,4,0,219,140,4,0,241,140,4,0,6,141,4,0,23,141,4,0,30,141,4,0,62,141,4,0,94,141,4,0,116,141,4,0,138,141,4,0,187,141,4,0,236,141,4,0,245,141,4,0,254,141,4,0,5,142,4,0,17,142,4,0,24,142,4,0,36,142,4,0,53,142,4,0,70,142,4,0,82,142,4,0,95,142,4,0,124,142,4,0,136,142,4,0,153,142,4,0,170,142,4,0,179,142,4,0,188,142,4,0,207,142,4,0,226,142,4,0,13,143,4,0,45,143,4,0,61,143,4,0,75,143,4,0,89,143,4,0,117,143,4,0,134,143,4,0,151,143,4,0,168,143,4,0,178,40,17,0,185,143,4,0,208,143,4,0,231,143,4,0,254,143,4,0,21,144,4,0,49,144,4,0,74,144,4,0,99,144,4,0,124,144,4,0,149,144,4,0,222,144,4,0,249,144,4,0,12,145,4,0,64,145,4,0,143,145,4,0,196,145,4,0,247,145,4,0,72,146,4,0,130,146,4,0,196,146,4,0,218,146,4,0,40,147,4,0,95,147,4,0,177,147,4,0,178,40,17,0,199,147,4,0,247,147,4,0,53,148,4,0,97,148,4,0,144,148,4,0,192,148,4,0,239,148,4,0,34,149,4,0,86,149,4,0,136,149,4,0,187,149,4,0,227,149,4,0,15,150,4,0,37,150,4,0,105,150,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,173,150,4,0,210,150,4,0,247,150,4,0,31,151,4,0,71,151,4,0,93,151,4,0,115,151,4,0,166,151,4,0,217,151,4,0,9,152,4,0,57,152,4,0,81,152,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,145,152,4,0,177,152,4,0,7,153,4,0,71,153,4,0,129,153,4,0,169,153,4,0,205,153,4,0,26,154,4,0,73,154,4,0,95,154,4,0,134,154,4,0,181,154,4,0,207,154,4,0,3,155,4,0,40,155,4,0,127,155,4,0,182,155,4,0,51,156,4,0,136,156,4,0,204,156,4,0,234,156,4,0,22,157,4,0,49,157,4,0,91,157,4,0,128,157,4,0,164,157,4,0,145,152,4,0,177,152,4,0,194,157,4,0,220,157,4,0,129,153,4,0,164,157,4,0,26,154,4,0,247,157,4,0,73,154,4,0,134,154,4,0,98,158,4,0,207,154,4,0,3,155,4,0,125,158,4,0,40,155,4,0,187,158,4,0,127,155,4,0,224,158,4,0,204,156,4,0,5,159,4,0,68,159,4,0,91,157,4,0,159,159,4,0,236,159,4,0,63,160,4,0,95,160,4,0,173,160,4,0,241,160,4,0,43,161,4,0,83,161,4,0,119,161,4,0,201,161,4,0,248,161,4,0,14,162,4,0,55,162,4,0,102,162,4,0,128,162,4,0,180,162,4,0,217,162,4,0,44,163,4,0,95,163,4,0,214,163,4,0,37,164,4,0,107,164,4,0,137,164,4,0,185,164,4,0,212,164,4,0,254,164,4,0,35,165,4,0,71,165,4,0,101,165,4,0,186,165,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,245,165,4,0,252,165,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,8,166,4,0,84,166,4,0,147,166,4,0,203,166,4,0,15,167,4,0,76,167,4,0,118,167,4,0,234,167,4,0,29,168,4,0,62,168,4,0,110,168,4,0,157,168,4,0,179,168,4,0,3,169,4,0,54,169,4,0,125,169,4,0,193,169,4,0,0,170,4,0,43,170,4,0,107,170,4,0,138,170,4,0,189,170,4,0,216,170,4,0,2,171,4,0,39,171,4,0,80,171,4,0,110,171,4,0,188,171,4,0,42,172,4,0,96,172,4,0,183,172,4,0,245,172,4,0,51,173,4,0,113,173,4,0,200,173,4,0,230,173,4,0,29,174,4,0,73,174,4,0,126,174,4,0,171,174,4,0,2,175,4,0,65,175,4,0,105,175,4,0,166,175,4,0,234,175,4,0,8,176,4,0,69,176,4,0,142,176,4,0,187,176,4,0,253,176,4,0,83,177,4,0,159,177,4,0,228,177,4,0,22,178,4,0,103,178,4,0,155,178,4,0,224,178,4,0,52,179,4,0,111,179,4,0,162,179,4,0,225,179,4,0,33,180,4,0,68,180,4,0,168,180,4,0,2,175,4,0,240,180,4,0,65,181,4,0,128,181,4,0,179,181,4,0,235,181,4,0,14,182,4,0,86,182,4,0,138,182,4,0,218,182,4,0,44,183,4,0,124,183,4,0,183,183,4,0,8,184,4,0,69,184,4,0,133,184,4,0,233,184,4,0,80,185,4,0,178,40,17,0,102,185,4,0,151,185,4,0,235,185,4,0,60,186,4,0,178,40,17,0,178,40,17,0,114,186,4,0,203,186,4,0,82,187,4,0,183,187,4,0,31,188,4,0,198,188,4,0,112,189,4,0,178,40,17,0,249,54,4,0,152,89,4,0,152,189,4,0,231,189,4,0,252,189,4,0,84,190,4,0,176,190,4,0,200,190,4,0,19,191,4,0,114,191,4,0,173,191,4,0,39,192,4,0,233,90,4,0,134,192,4,0,9,91,4,0,151,192,4,0,179,192,4,0,208,192,4,0,15,193,4,0,27,193,4,0,142,91,4,0,49,193,4,0,224,91,4,0,247,150,4,0,31,151,4,0,71,151,4,0,93,151,4,0,115,151,4,0,166,151,4,0,66,193,4,0,75,193,4,0,21,92,4,0,84,193,4,0,28,92,4,0,35,92,4,0,96,193,4,0,113,193,4,0,59,92,4,0,130,193,4,0,153,193,4,0,47,92,4,0,182,193,4,0,199,193,4,0,227,88,4,0,236,88,4,0,216,193,4,0,235,193,4,0,254,193,4,0,41,194,4,0,89,194,4,0,105,194,4,0,119,194,4,0,133,194,4,0,118,92,4,0,101,92,4,0,169,194,4,0,186,194,4,0,203,194,4,0,222,194,4,0,249,194,4,0,20,195,4,0,47,195,4,0,74,195,4,0,106,195,4,0,127,195,4,0,148,195,4,0,169,195,4,0,190,195,4,0,21,196,4,0,48,196,4,0,81,152,4,0,67,196,4,0,166,196,4,0,219,196,4,0,26,197,4,0,123,197,4,0,233,197,4,0,153,92,4,0,59,198,4,0,149,198,4,0,205,198,4,0,52,199,4,0,178,40,17,0,74,199,4,0,149,199,4,0,233,199,4,0,29,200,4,0,84,200,4,0,144,200,4,0,197,200,4,0,254,200,4,0,83,201,4,0,152,201,4,0,211,201,4,0,3,202,4,0,55,202,4,0,77,202,4,0,173,202,4,0,13,203,4,0,38,203,4,0,63,203,4,0,88,203,4,0,178,40,17,0,113,203,4,0,191,203,4,0,34,204,4,0,90,204,4,0,182,204,4,0,21,205,4,0,111,205,4,0,190,205,4,0,246,205,4,0,49,206,4,0,114,206,4,0,180,206,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,14,207,4,0,37,207,4,0,72,207,4,0,107,207,4,0,107,207,4,0,174,207,4,0,237,207,4,0,13,208,4,0,45,208,4,0,93,208,4,0,125,208,4,0,157,208,4,0,246,208,4,0,38,209,4,0,208,209,4,0,145,210,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,14,207,4,0,37,207,4,0,72,207,4,0,197,210,4,0,107,207,4,0,174,207,4,0,237,207,4,0,13,208,4,0,45,208,4,0,93,208,4,0,125,208,4,0,4,211,4,0,72,211,4,0,38,209,4,0,120,211,4,0,29,212,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,190,212,4,0,227,212,4,0,13,213,4,0,69,213,4,0,125,213,4,0,151,213,4,0,177,213,4,0,252,213,4,0,71,214,4,0,135,214,4,0,199,214,4,0,225,214,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,80,215,4,0,116,215,4,0,200,215,4,0,20,216,4,0,82,216,4,0,130,216,4,0,168,216,4,0,0,217,4,0,40,217,4,0,56,217,4,0,96,217,4,0,136,217,4,0,162,217,4,0,208,217,4,0,244,217,4,0,68,218,4,0,120,218,4,0,214,218,4,0,22,219,4,0,108,219,4,0,136,219,4,0,184,219,4,0,210,219,4,0,0,220,4,0,30,220,4,0,62,220,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,98,220,4,0,172,220,4,0,52,221,4,0,134,221,4,0,220,221,4,0,60,222,4,0,150,222,4,0,254,222,4,0,106,223,4,0,172,223,4,0,240,223,4,0,98,224,4,0,178,224,4,0,16,225,4,0,90,225,4,0,158,225,4,0,6,226,4,0,92,226,4,0,218,226,4,0,34,227,4,0,109,227,4,0,185,227,4,0,1,228,4,0,79,228,4,0,182,228,4,0,8,229,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,95,229,4,0,165,229,4,0,235,229,4,0,43,230,4,0,113,230,4,0,185,230,4,0,230,230,4,0,68,231,4,0,116,231,4,0,162,231,4,0,208,231,4,0,40,217,4,0,248,231,4,0,72,232,4,0,120,232,4,0,192,232,4,0,6,233,4,0,76,233,4,0,116,233,4,0,210,233,4,0,240,233,4,0,32,234,4,0,58,234,4,0,104,234,4,0,134,234,4,0,166,234,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,202,234,4,0,10,235,4,0,55,235,4,0,99,235,4,0,163,235,4,0,209,235,4,0,7,236,4,0,81,236,4,0,138,236,4,0,175,236,4,0,222,236,4,0,24,237,4,0,57,237,4,0,143,237,4,0,205,237,4,0,7,238,4,0,64,238,4,0,132,238,4,0,178,238,4,0,221,238,4,0,3,239,4,0,55,239,4,0,100,239,4,0,169,239,4,0,249,239,4,0,55,240,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,249,54,4,0,152,89,4,0,129,240,4,0,210,240,4,0,234,240,4,0,44,241,4,0,134,241,4,0,167,241,4,0,10,242,4,0,129,242,4,0,152,242,4,0,29,243,4,0,148,243,4,0,180,243,4,0,226,243,4,0,32,244,4,0,108,244,4,0,154,244,4,0,8,245,4,0,54,245,4,0,100,245,4,0,239,245,4,0,82,246,4,0,98,246,4,0,146,246,4,0,194,246,4,0,9,247,4,0,25,247,4,0,55,247,4,0,85,247,4,0,106,247,4,0,146,247,4,0,205,247,4,0,225,247,4,0,245,247,4,0,47,248,4,0,171,248,4,0,78,249,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,249,54,4,0,152,89,4,0,180,249,4,0,7,250,4,0,35,250,4,0,117,250,4,0,215,250,4,0,234,250,4,0,53,251,4,0,144,251,4,0,201,251,4,0,67,252,4,0,158,252,4,0,171,252,4,0,188,252,4,0,210,252,4,0,238,252,4,0,14,253,4,0,81,253,4,0,98,253,4,0,115,253,4,0,224,253,4,0,48,254,4,0,55,254,4,0,95,254,4,0,135,254,4,0,28,92,4,0,35,92,4,0,47,92,4,0,152,254,4,0,164,254,4,0,186,254,4,0,227,88,4,0,236,88,4,0,215,254,4,0,237,254,4,0,123,197,4,0,166,196,4,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,145,152,4,0,44,255,4,0,177,152,4,0,194,157,4,0,103,255,4,0,129,153,4,0,158,255,4,0,37,0,5,0,125,0,5,0,172,0,5,0,238,0,5,0,63,1,5,0,207,154,4,0,26,154,4,0,40,155,4,0,187,158,4,0,127,155,4,0,7,153,4,0,204,156,4,0,110,1,5,0,155,1,5,0,91,157,4,0,246,1,5,0,37,2,5,0,88,2,5,0,140,2,5,0,202,2,5,0,5,3,5,0,80,3,5,0,135,3,5,0,212,3,5,0,68,4,5,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,8,166,4,0,153,4,5,0,247,4,5,0,61,5,5,0,87,5,5,0,15,167,4,0,128,5,5,0,239,5,5,0,65,6,5,0,112,6,5,0,178,6,5,0,249,6,5,0,34,7,5,0,86,7,5,0,54,169,4,0,133,7,5,0,125,169,4,0,147,166,4,0,170,7,5,0,200,7,5,0,241,7,5,0,2,171,4,0,83,8,5,0,124,8,5,0,175,8,5,0,227,8,5,0,27,9,5,0,78,9,5,0,145,9,5,0,192,9,5,0,3,10,5,0,99,10,5,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,174,10,5,0,236,10,5,0,121,11,5,0,194,11,5,0,50,12,5,0,192,12,5,0,56,13,5,0,168,13,5,0,49,14,5,0,116,14,5,0,199,14,5,0,60,15,5,0,149,15,5,0,0,16,5,0,67,16,5,0,172,16,5,0,21,17,5,0,169,17,5,0,57,18,5,0,144,18,5,0,241,18,5,0,66,19,5,0,125,19,5,0,220,19,5,0,56,20,5,0,139,20,5,0,174,10,5,0,236,10,5,0,210,20,5,0,43,21,5,0,50,12,5,0,139,20,5,0,168,13,5,0,80,21,5,0,49,14,5,0,199,14,5,0,245,21,5,0,149,15,5,0,0,16,5,0,46,22,5,0,67,16,5,0,218,22,5,0,172,16,5,0,89,23,5,0,144,18,5,0,152,23,5,0,10,24,5,0,220,19,5,0,156,24,5,0,52,25,5,0,161,25,5,0,227,25,5,0,112,26,5,0,193,26,5,0,51,27,5,0,188,27,5,0,52,28,5,0,174,28,5,0,55,29,5,0,122,29,5,0,209,29,5,0,75,30,5,0,159,30,5,0,19,31,5,0,93,31,5,0,202,31,5,0,53,32,5,0,203,32,5,0,87,33,5,0,174,33,5,0,10,34,5,0,97,34,5,0,158,34,5,0,1,35,5,0,93,35,5,0,181,35,5,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,242,35,5,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,20,36,5,0,124,36,5,0,212,36,5,0,23,37,5,0,119,37,5,0,198,37,5,0,15,38,5,0,185,38,5,0,43,39,5,0,118,39,5,0,194,39,5,0,42,40,5,0,96,40,5,0,14,41,5,0,128,41,5,0,217,41,5,0,70,42,5,0,171,42,5,0,248,42,5,0,75,43,5,0,117,43,5,0,195,43,5,0,249,43,5,0,71,44,5,0,153,44,5,0,225,44,5,0,40,45,5,0,143,45,5,0,17,46,5,0,111,46,5,0,228,46,5,0,68,47,5,0,169,47,5,0,249,47,5,0,116,48,5,0,167,48,5,0,16,49,5,0,70,49,5,0,150,49,5,0,223,49,5,0,128,41,5,0,98,50,5,0,168,50,5,0,1,51,5,0,104,51,5,0,154,51,5,0,232,51,5,0,91,52,5,0,161,52,5,0,8,53,5,0,114,53,5,0,210,53,5,0,53,54,5,0,120,54,5,0,230,54,5,0,39,55,5,0,127,55,5,0,237,55,5,0,57,56,5,0,123,56,5,0,209,56,5,0,44,57,5,0,93,57,5,0,208,57,5,0,32,58,5,0,121,58,5,0,244,58,5,0,93,59,5,0,151,59,5,0,242,59,5,0,30,60,5,0,110,60,5,0,167,60,5,0,3,61,5,0,102,61,5,0,196,61,5,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,13,62,5,0,128,62,5,0,213,62,5,0,64,63,5,0,177,63,5,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,249,54,4,0,152,89,4,0,1,64,5,0,98,64,5,0,147,64,5,0,10,65,5,0,156,65,5,0,205,65,5,0,54,66,5,0,188,66,5,0,13,67,5,0,163,67,5,0,148,243,4,0,180,243,4,0,226,243,4,0,32,244,4,0,41,68,5,0,105,68,5,0,8,245,4,0,54,245,4,0,205,68,5,0,91,69,5,0,82,246,4,0,200,69,5,0,253,69,5,0,194,246,4,0,9,247,4,0,25,247,4,0,55,247,4,0,85,247,4,0,106,247,4,0,146,247,4,0,205,247,4,0,225,247,4,0,245,247,4,0,50,70,5,0,186,70,5,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,249,54,4,0,152,89,4,0,62,71,5,0,175,71,5,0,212,71,5,0,56,72,5,0,180,72,5,0,208,72,5,0,45,73,5,0,164,73,5,0,237,73,5,0,174,74,5,0,37,75,5,0,69,75,5,0,112,75,5,0,174,75,5,0,247,75,5,0,55,76,5,0,169,76,5,0,212,76,5,0,255,76,5,0,139,77,5,0,240,77,5,0,0,78,5,0,62,78,5,0,124,78,5,0,9,247,4,0,25,247,4,0,55,247,4,0,195,78,5,0,216,78,5,0,0,79,5,0,205,247,4,0,225,247,4,0,59,79,5,0,117,79,5,0,253,79,5,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,178,40,17,0,0,0,0,0,0,0,0,0,144,67,0,0,137,2,0,0,138,2,0,0,51,0,0,0,149,0,0,0,0,0,0,0,152,67,0,0,139,2,0,0,140,2,0,0,150,0,0,0,19,0,0,0,35,0,0,0,4,0,0,0,36,0,0,0,151,0,0,0,74,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,75,0,0,0,1,0,0,0,1,0,0,0,228,253,12,0,61,81,5,0,225,80,5,0,82,14,0,0,1,0,0,0,0,0,0,0,160,67,0,0,141,2,0,0,142,2,0,0,152,0,0,0,224,253,12,0,156,80,5,0,225,80,5,0,182,13,0,0,1,0,0,0,232,253,12,0,243,82,5,0,225,80,5,0,226,13,0,0,1,0,0,0,236,253,12,0,29,84,5,0,225,80,5,0,239,0,0,0,1,0,0,0,240,253,12,0,134,84,5,0,225,80,5,0,64,8,0,0,1,0,0,0,248,253,12,0,50,86,5,0,225,80,5,0,9,8,0,0,1,0,0,0,0,0,0,0,176,67,0,0,143,2,0,0,144,2,0,0,153,0,0,0,244,253,12,0,181,85,5,0,225,80,5,0,202,14,0,0,1,0,0,0,252,253,12,0,203,86,5,0,225,80,5,0,237,6,0,0,1,0,0,0,0,254,12,0,152,87,5,0,225,80,5,0,124,6,0,0,1,0,0,0,4,254,12,0,51,88,5,0,225,80,5,0,57,6,0,0,1,0,0,0,96,128,7,0,60,133,91,61,105,191,22,190,2,153,98,189,108,247,79,61,246,123,236,61,167,217,46,189,62,226,61,61,57,250,95,189,212,151,168,61,35,124,213,61,136,247,187,188,168,158,53,60,147,226,97,60,59,62,229,61,79,209,79,60,24,169,174,61,149,54,129,189,240,173,5,62,38,231,165,61,19,100,85,189,154,195,48,189,193,79,191,61,81,255,225,61,15,146,155,189,76,255,97,189,6,230,54,189,19,114,241,60,66,152,58,61,65,71,105,187,217,33,160,61,168,84,158,61,18,154,161,61,195,227,126,61,40,89,184,61,26,104,18,189,208,217,11,61,93,138,104,61,160,134,67,189,86,118,25,61,50,58,16,189,138,114,142,61,23,168,29,189,94,104,44,60,232,56,142,60,25,146,222,61,48,45,179,61,33,25,88,59,61,96,223,61,226,18,162,61,158,217,212,61,161,93,171,60,17,114,237,61,236,252,6,62,68,84,202,61,23,168,91,61,71,37,138,189,4,202,229,187,53,239,171,59,152,142,4,61,71,172,102,60,194,224,180,60,128,219,207,60,177,72,58,61,179,120,147,61,81,51,0,61,72,128,128,189,73,155,172,60,190,51,119,61,192,222,176,61,41,126,148,59,40,174,179,60,10,56,189,60,116,18,100,61,159,175,216,188,243,55,54,61,22,115,232,60,125,210,183,61,99,190,54,61,182,208,183,61,13,229,153,61,235,252,188,60,210,50,213,61,174,108,130,61,189,113,115,61,27,55,150,59,51,211,85,61,176,184,136,61,249,46,171,61,189,118,137,61,18,84,134,61,23,254,32,189,43,17,22,188,31,148,113,189,77,185,230,60,254,31,78,61,63,222,138,61,58,89,10,61,73,193,31,186,241,14,147,188,138,157,252,188,195,101,85,188,236,125,243,188,194,56,1,60,97,108,16,189,197,25,36,187,177,214,86,61,86,124,241,61,186,143,177,188,134,15,89,61,120,255,135,61,224,151,84,61,44,140,7,188,73,121,248,60,160,75,111,61,138,106,131,187,176,213,204,187,146,37,112,61,119,248,201,188,55,50,99,61,112,131,168,189,36,39,148,189,151,19,62,61,38,88,86,188,162,78,205,188,91,3,254,60,230,26,63,189,56,17,60,189,116,168,241,60,104,54,119,61,163,225,183,60,11,39,139,188,123,102,42,60,181,84,57,60,104,252,93,61,38,131,174,188,138,4,49,189,99,32,22,189,106,144,56,60,4,134,213,188,109,139,182,188,10,201,184,188,45,97,12,189,146,1,254,187,175,193,125,189,2,158,6,60,249,75,195,61,243,245,23,189,179,46,142,189,24,75,21,62,111,40,95,189,111,107,168,188,104,105,107,61,83,226,227,60,227,242,144,189,143,26,84,189,14,150,213,189,104,26,230,189,217,49,154,61,131,208,154,189,209,243,179,189,185,111,244,60,80,135,218,60,161,117,98,60,57,64,147,188,220,169,0,189,94,224,171,188,8,235,184,61,33,245,74,61,218,122,12,62,186,15,233,61,101,244,235,58,184,127,59,189,210,161,145,186,226,244,193,189,219,124,237,189,42,226,55,61,158,41,146,60,0,25,73,59,8,208,220,61,17,135,92,59,89,14,222,189,116,78,152,189,28,194,215,189,189,237,152,188,204,110,36,62,200,60,166,187,61,243,47,189,202,125,193,187,233,129,16,60,28,142,116,188,208,255,77,189,89,217,3,190,106,97,102,58,215,135,84,188,1,128,155,189,113,161,218,188,73,223,53,186,30,40,197,60,193,68,145,188,107,238,29,189,202,193,112,189,97,132,5,61,31,88,3,62,75,223,128,61,220,150,134,187,126,53,225,61,178,101,90,60,243,27,171,60,76,96,37,61,199,110,85,189,253,236,158,61,2,15,131,61,92,153,107,189,249,226,205,189,239,179,153,61,123,74,175,188,138,36,147,60,241,157,25,59,108,95,44,189,172,161,150,61,165,159,80,61,8,127,245,188,80,201,181,188,47,111,9,61,222,253,52,61,239,149,100,189,200,86,78,189,29,75,58,189,3,5,98,60,215,46,176,60,241,191,179,188,98,28,12,190,99,216,95,61,236,187,131,60,30,118,89,61,202,141,64,61,14,59,175,58,76,38,155,61,83,32,197,61,91,64,18,60,75,241,230,188,124,141,222,61,240,223,12,189,115,64,145,189,175,244,117,189,3,49,222,188,170,210,231,187,204,26,134,188,9,5,91,60,0,57,211,189,62,249,72,61,11,205,106,189,225,186,223,188,129,194,42,60,31,209,170,189,196,255,22,61,150,50,122,61,19,184,88,60,108,240,159,189,218,156,26,61,128,206,11,189,179,182,121,189,82,135,44,189,151,121,163,189,154,29,165,186,201,124,249,188,70,150,74,188,33,71,129,189,72,46,68,61,41,128,60,189,237,165,175,61,225,134,206,60,245,200,244,60,31,62,211,61,235,150,144,61,87,41,57,61,213,80,53,189,215,158,6,62,92,193,171,61,190,82,177,60,183,30,11,187,54,254,22,189,187,250,169,188,8,224,28,189,217,197,122,188,68,87,220,60,92,11,243,61,96,138,119,189,42,38,228,188,72,150,67,189,89,213,71,61,77,17,130,61,130,37,15,61,56,107,112,60,98,133,154,58,149,99,51,61,37,124,5,59,6,37,34,189,204,191,47,188,243,237,210,59,41,121,245,60,165,5,12,189,158,150,160,188,6,191,71,188,65,50,143,187,232,217,208,188,80,201,216,60,71,188,133,188,198,217,211,59,117,21,158,188,68,221,156,59,59,66,75,61,108,5,28,61,82,205,148,61,81,218,107,61,10,65,25,189,209,13,135,60,217,125,10,188,194,181,35,61,121,163,167,189,56,45,216,60,30,238,36,189,252,215,224,188,243,196,38,189,122,192,137,58,108,51,66,189,54,229,137,189,176,156,14,60,246,156,179,188,44,104,177,58,100,109,250,188,51,193,243,188,35,145,236,188,252,92,70,188,196,198,69,189,68,173,185,189,146,45,204,189,8,32,22,189,47,208,104,186,104,207,139,189,1,224,152,188,144,150,20,189,225,187,102,188,164,137,153,60,106,13,170,188,14,75,187,61,11,76,17,189,87,13,93,61,130,253,43,61,177,78,85,60,134,159,10,189,127,229,249,189,178,229,139,61,117,49,24,189,46,155,28,60,251,179,165,59,0,206,103,61,179,11,128,59,78,18,230,60,113,5,98,189,43,7,24,189,28,74,232,188,237,15,53,189,255,18,41,188,37,75,154,60,174,47,11,188,255,231,192,189,243,249,79,188,8,196,174,188,56,181,208,189,104,167,160,189,188,172,31,59,151,56,134,187,165,6,69,60,150,36,132,189,30,246,216,189,120,233,201,188,8,51,180,188,110,151,151,189,7,55,149,61,11,168,104,58,251,116,35,60],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+71680);allocate([132,188,10,60,96,203,24,61,232,252,237,188,39,93,18,61,43,247,51,189,111,14,246,189,149,28,2,61,197,227,52,187,231,175,221,61,50,132,80,61,228,98,88,187,43,223,81,189,107,104,165,59,165,0,104,189,167,106,196,187,228,205,90,189,239,28,72,188,205,145,83,60,117,125,34,60,184,12,248,187,157,171,125,189,24,41,19,187,50,210,162,60,37,98,165,188,235,219,142,189,254,50,135,189,252,45,9,189,174,122,182,189,15,24,10,189,115,177,151,189,246,40,184,188,197,79,124,189,250,6,54,59,138,109,106,189,171,76,68,189,216,250,153,61,188,183,53,59,95,133,44,61,61,254,253,60,138,52,88,61,209,251,33,61,34,82,246,188,111,196,29,189,239,192,228,188,27,140,235,188,138,226,122,60,187,39,179,60,189,1,163,188,9,73,36,59,72,25,210,189,39,6,68,189,79,133,236,188,238,90,124,59,143,58,54,60,246,219,7,60,159,140,69,189,163,119,56,189,173,22,24,189,74,29,143,189,182,83,225,189,208,109,48,187,112,252,242,58,179,134,114,189,31,16,122,189,139,56,173,189,89,115,57,189,253,100,105,58,21,164,112,189,22,8,48,187,199,89,130,188,205,194,20,61,5,0,97,61,193,130,149,61,246,80,181,59,145,20,131,61,235,93,151,60,233,213,188,187,124,132,3,189,14,81,139,59,101,31,63,60,93,224,189,186,112,160,184,60,101,234,9,189,14,4,143,61,17,99,138,187,47,184,17,188,66,174,162,189,26,251,84,61,62,110,120,61,206,78,41,61,103,201,188,58,61,78,196,189,56,101,34,189,239,88,45,61,233,101,143,60,16,211,55,189,19,243,248,187,80,193,164,60,123,110,63,61,128,140,184,61,53,41,161,189,98,203,63,189,30,21,80,189,188,222,130,187,88,252,90,189,134,226,49,60,190,109,19,189,123,93,145,189,177,120,17,61,202,147,219,60,159,49,14,61,67,171,146,60,117,26,96,61,59,159,29,60,249,66,2,189,4,53,112,61,133,236,190,60,131,201,133,60,43,15,102,189,142,211,209,189,97,7,170,189,135,83,149,61,54,152,161,188,176,153,214,188,22,153,203,188,210,139,61,189,234,26,195,58,108,220,97,61,187,55,80,188,101,167,159,188,242,135,130,61,213,228,76,61,10,144,246,188,45,143,15,60,136,176,202,188,247,122,97,189,76,28,228,58,8,140,8,189,151,218,121,60,180,223,238,61,156,119,173,186,83,87,135,189,66,242,104,61,66,193,52,186,2,82,52,189,81,138,193,61,13,246,44,189,251,149,91,189,120,199,145,60,51,212,209,60,12,211,226,189,57,209,15,188,138,36,52,188,125,150,212,189,54,60,254,60,151,128,172,188,7,249,150,189,42,207,82,61,46,181,216,61,249,126,176,189,225,235,236,188,37,242,50,60,255,1,21,62,205,2,19,187,127,78,110,189,198,92,151,189,14,134,105,61,159,121,4,62,211,64,76,189,46,137,208,61,56,249,77,61,246,40,0,62,164,231,187,61,143,44,131,61,199,151,121,60,151,192,193,61,171,32,122,61,20,24,18,190,105,193,239,188,237,70,226,60,137,73,177,60,15,67,123,186,12,81,45,189,236,16,202,189,3,10,49,61,189,132,112,61,253,50,70,189,22,107,129,61,41,50,200,60,214,188,19,189,126,205,25,60,209,183,47,61,190,84,40,188,146,13,167,61,92,57,179,61,88,20,7,190,209,179,5,60,12,236,109,188,32,226,241,60,238,27,20,61,2,14,9,187,145,12,184,60,189,21,197,61,162,194,192,61,159,152,239,188,21,14,160,189,234,121,180,188,26,193,4,187,110,92,51,60,202,79,108,188,240,136,232,60,216,89,243,61,9,208,238,59,167,226,211,189,142,218,154,61,130,232,167,188,78,140,145,59,116,214,131,60,123,108,72,189,107,94,179,189,234,119,251,187,98,128,181,61,111,199,121,61,40,120,134,61,250,46,240,59,154,192,17,61,134,177,30,189,61,252,203,188,239,171,138,189,39,142,203,61,131,170,46,188,4,151,98,60,198,71,149,189,93,214,244,59,227,134,217,61,219,209,235,188,36,66,195,60,39,33,6,189,78,16,175,60,231,44,29,61,7,201,200,60,103,255,47,189,141,43,237,188,134,53,90,61,117,153,117,60,129,191,76,61,234,125,4,62,115,88,192,61,249,208,47,61,180,151,9,189,89,117,139,189,79,115,56,60,228,13,49,62,216,133,12,189,112,27,128,189,194,135,148,188,129,42,240,61,136,252,122,189,60,185,177,189,209,124,12,189,35,229,63,61,88,37,167,61,188,242,16,61,86,59,150,60,33,223,231,61,236,154,5,61,106,175,69,189,163,142,143,60,136,41,147,188,96,80,214,189,215,75,88,187,13,124,112,57,66,195,110,60,224,187,174,188,64,59,213,188,132,196,33,188,204,14,47,61,188,77,172,188,236,183,163,189,165,55,214,60,217,252,172,188,52,164,142,189,132,195,9,190,1,136,140,189,64,171,199,187,87,253,168,61,59,223,31,62,27,145,33,59,59,143,17,60,90,27,42,189,100,85,168,60,89,47,88,61,156,243,252,188,234,208,230,60,116,188,14,62,22,125,156,61,109,150,20,189,48,255,246,188,158,138,37,189,122,239,94,188,250,16,127,189,179,80,224,188,228,8,11,62,166,3,28,62,227,228,92,189,48,226,228,189,70,182,176,60,230,214,59,60,222,166,87,189,181,17,135,189,97,54,225,188,59,234,241,61,239,55,50,62,122,95,123,189,234,89,225,189,24,115,93,188,131,6,143,188,126,170,175,189,101,22,55,189,66,27,122,189,139,67,216,61,208,15,85,62,39,231,187,189,236,5,58,58,117,156,18,61,251,195,147,61,79,1,182,60,135,186,149,60,238,143,1,188,108,12,116,60,52,175,20,62,220,153,131,189,54,249,244,60,210,42,236,186,88,160,101,188,131,217,42,189,163,212,114,187,77,44,186,189,245,251,194,61,251,39,181,61,75,59,217,188,106,33,247,188,110,234,209,60,82,249,17,61,98,97,28,189,134,216,106,60,93,228,184,60,185,72,235,60,40,40,36,60,72,175,129,189,124,179,49,61,162,101,143,61,18,191,64,189,39,228,149,189,174,124,215,60,141,121,254,60,118,40,136,61,126,128,223,61,171,152,133,188,149,105,238,60,214,42,237,60,22,170,164,61,66,187,142,61,180,55,139,61,108,112,199,59,1,130,136,59,193,209,182,61,166,227,255,188,42,50,221,60,66,124,63,60,2,169,133,188,207,16,151,59,155,124,11,60,226,43,17,189,18,79,18,61,100,211,140,59,130,99,161,188,52,37,16,188,135,197,196,61,93,1,125,60,13,183,32,189,10,174,149,61,240,68,120,61,106,20,10,57,220,199,2,188,38,140,196,60,113,55,121,189,224,189,224,188,5,71,96,189,240,55,41,189,191,206,17,61,42,75,250,60,47,61,244,60,243,43,24,62,53,188,144,60,132,70,241,60,192,161,72,61,59,64,40,60,190,84,230,60,94,79,169,61,108,209,223,60,155,200,74,188,22,217,240,61,133,187,27,61,73,145,7,189,163,4,172,59,162,144,201,188,210,123,220,60,250,46,93,61,194,136,207,189,20,198,130,61,84,238,148,188,54,25,185,60,9,91,18,61,55,220,42,60,148,31,42,189,59,154,37,189,68,164,134,60,197,135,170,61,200,229,241,57,105,107,89,189,101,210,174,189,139,10,211,186,127,64,177,188,154,23,146,188,58,23,30,61,162,14,174,61,103,84,141,188,135,164,176,61,236,45,225,61,73,245,187,61,208,11,174,61,161,153,156,61,206,147,100,61,32,167,220,60,157,188,204,61,163,194,185,61,84,139,136,61,244,142,112,61,170,36,184,188,89,45,159,61,241,31,254,61,212,82,1,62,134,185,92,186,182,30,114,60,48,184,187,61,128,143,67,187,206,110,132,189,150,136,144,189,199,177,91,57,113,15,181,60,130,217,176,188,232,45,176,189,124,44,187,188,213,175,131,59,62,189,28,60,121,230,169,188,242,218,61,189,11,217,248,187,13,172,97,188,88,192,58,189,38,9,8,190,36,151,177,189,28,175,21,189,102,63,59,60,9,172,6,61,196,239,51,189,152,157,123,61,9,92,53,62,168,176,212,61,12,196,89,60,100,47,206,61,52,254,254,61,178,93,55,189,147,83,185,61,109,250,59,61,255,183,228,61,110,223,175,61,187,71,67,61,8,35,219,58,163,80,193,60,181,2,28,189,86,13,0,61,244,52,157,188,125,109,105,189,254,191,193,188,129,130,133,189,134,89,101,189,86,90,145,189,2,62,7,189,95,75,65,189,38,59,210,188,176,239,88,60,78,11,189,189,219,6,98,189,246,9,65,189,86,123,10,189,108,157,137,189,179,248,65,60,248,2,191,189,96,149,134,60,163,59,27,61,85,200,216,187,132,171,159,61,235,104,148,61,160,197,64,61,79,184,206,188,27,1,139,188,25,64,165,189,114,6,119,61,29,152,215,61,165,104,135,189,121,231,243,60,195,199,214,60,115,200,156,60,76,168,173,189,174,123,129,189,142,246,10,190,37,143,156,189,187,174,24,60,229,201,165,189,98,218,208,189,40,40,85,189,217,135,103,60,158,192,159,189,224,109,154,188,201,202,153,189,138,151,207,189,129,127,85,189,138,167,203,189,240,30,175,186,148,229,129,189,70,39,43,189,242,105,253,189,200,14,232,188,128,29,120,189,183,204,110,61,87,188,155,61,145,90,132,189,22,121,3,60,53,41,237,61,79,144,252,61,91,19,162,60,121,129,50,187,149,165,111,61,124,119,63,189,88,221,82,61,97,15,44,187,253,119,230,61,145,159,202,61,18,102,200,61,218,215,62,189,57,159,52,188,67,104,143,189,51,11,253,60,118,43,210,188,125,28,157,189,62,10,80,59,171,216,220,189,194,149,189,188,53,29,227,189,227,229,39,188,178,67,255,60,247,91,75,189,87,237,186,60,210,57,180,59,61,154,172,189,37,97,22,190,192,25,158,189,1,161,8,190,108,93,57,189,3,11,203,189,79,20,212,60,7,26,14,61,203,9,63,61,199,95,239,61,129,147,197,61,57,94,222,61,249,91,109,188,59,30,48,61,100,130,138,189,212,169,174,58,94,193,18,62,91,31,155,61,80,185,187,61,233,113,104,61,132,242,231,61,185,73,53,188,167,238,168,60,163,53,235,189,96,112,153,189,148,164,234,188,35,0,81,188,54,65,142,189,192,225,206,189,39,125,40,189,94,111,181,188,0,185,80,188,206,50,153,189,14,48,216,189,210,25,156,189,242,143,204,189,190,147,234,189,6,70,247,189,40,198,192,189,180,92,146,189,231,18,38,189,31,247,122,189,172,229,44,61,219,115,157,61,209,231,39,61,56,173,1,62,181,92,22,62,47,215,94,62,101,66,0,62,214,189,60,62,95,27,218,186,103,212,27,59,158,211,108,60,229,190,15,61,8,121,217,60,160,162,140,60,151,30,92,61,206,47,241,60,254,233,231,61,138,96,115,188,10,0,132,188,166,53,243,186,223,246,139,188,0,166,94,189,143,44,89,189,16,119,87,61,231,193,18,189,243,194,179,185,194,91,178,58,153,179,53,189,83,50,45,189,212,102,6,61,187,126,96,189,178,217,208,189,168,149,147,189,21,250,219,189,117,230,193,188,208,128,210,61,2,21,52,187,214,207,4,189,76,38,189,60,124,80,232,60,131,241,211,61,188,128,72,62,38,246,209,61,98,168,164,61,162,83,98,61,89,176,7,190,141,104,19,190,38,131,77,59,3,188,10,189,40,149,18,60,170,111,93,61,155,246,162,187,14,211,66,188,205,84,148,57,202,206,31,189,165,166,72,189,70,81,177,60,72,147,98,188,9,150,151,188,12,35,153,60,123,181,200,188,249,187,187,60,18,221,167,61,252,138,7,61,174,179,217,189,242,169,202,60,8,232,90,61,203,0,197,188,16,220,4,189,75,241,181,187,115,11,164,189,63,82,230,60,249,126,45,61,36,74,152,60,124,202,72,61,169,164,107,188,219,40,122,188,224,117,167,60,155,39,77,189,192,214,45,61,214,227,155,61,113,197,74,61,8,154,118,189,167,153,139,187,183,124,6,62,12,185,107,188,41,119,160,188,2,166,37,189,5,119,254,189,146,90,58,59,87,141,78,189,217,206,186,189,99,161,240,59,153,72,192,61,161,171,241,61,252,194,154,59,39,157,145,59,246,135,163,189,199,4,20,189,168,242,55,61,42,8,184,188,150,188,63,61,132,170,86,61,228,183,176,60,121,142,60,189,201,68,68,188,19,46,225,188,195,122,11,62,18,121,180,61,52,201,159,189,26,103,159,59,5,250,130,188,140,216,39,60,156,221,13,189,101,195,188,188,153,6,178,189,10,76,136,61,139,252,108,61,254,112,1,190,50,7,189,60,30,69,150,61,243,30,154,61,29,127,74,61,228,149,183,188,180,90,204,189,104,91,20,62,116,144,134,189,89,225,160,189,15,218,231,60,23,213,10,186,102,71,63,189,112,33,242,189,174,206,250,189,40,88,29,190,27,59,243,188,10,113,165,61,119,94,10,62,237,162,235,61,143,45,66,61,140,114,97,60,236,188,111,189,98,244,123,188,216,246,98,189,107,17,204,60,191,44,235,188,232,45,226,60,27,21,116,62,114,214,100,62,145,19,211,61,219,179,141,189,17,129,207,189,190,212,78,190,26,118,78,189,48,19,139,62,156,95,189,62,225,216,176,62,108,248,148,62,118,105,103,61,125,253,40,61,114,184,153,61,149,72,224,188,19,48,10,188,144,230,150,61,75,124,135,60,145,146,192,189,55,21,196,189,45,142,113,60,49,254,145,189,117,192,13,189,255,68,234,61,158,211,12,62,41,198,130,189,88,60,129,189,89,70,6,60,55,7,238,61,163,133,165,59,84,180,155,189,139,32,137,61,222,180,131,62,160,24,185,61,42,151,147,62,65,208,6,62,204,154,89,189,74,20,175,188,107,254,12,189,198,29,128,189,249,186,31,61,250,82,60,62,139,52,133,62,204,55,10,61,199,104,152,60,191,90,67,62,198,246,57,62,73,52,97,59,239,197,248,188,231,141,73,62,231,34,181,62,97,173,127,62,237,255,3,189,174,86,148,62,17,161,220,62,207,149,157,62,20,78,191,60,5,74,202,189,137,138,224,187,210,50,183,61,18,237,166,189,211,194,228,60,166,5,126,62,205,139,49,62,43,65,127,61,187,167,213,189,175,135,42,190,128,37,7,190,7,186,174,189,39,87,69,190,197,156,10,190,89,189,99,62,230,205,200,62,41,46,136,62,26,203,73,188,163,125,38,60,138,2,9,62,175,34,246,61,231,198,70,189,208,26,162,189,247,24,144,61,37,25,126,59,53,244,122,189,94,193,25,190,253,154,233,189,222,60,175,189,26,39,152,189,203,5,37,190,223,79,7,62,49,138,131,62,61,97,105,61,46,136,140,61,59,143,197,187,94,46,2,188,38,151,68,61,242,29,137,61,206,216,157,188,219,53,126,61,242,188,9,62,106,177,130,189,53,138,67,187,153,169,14,189,104,17,247,59,113,144,31,61,191,201,234,61,213,205,136,60,59,161,7,60,29,124,245,187,143,223,239,189,238,31,218,189,38,12,212,189,255,142,76,189,207,179,72,186,253,180,247,60,144,240,66,189,27,143,149,189,174,151,110,189,148,184,6,190,235,230,217,189,97,151,70,190,211,66,204,189,226,45,162,189,166,214,242,57,153,96,45,186,247,87,34,62,87,85,175,61,243,224,156,189,19,39,164,189,253,122,124,189,128,56,154,60,83,87,63,186,250,25,140,61,201,112,29,61,129,157,79,62,55,147,97,62,146,100,172,187,138,247,109,60,241,171,129,189,191,180,234,60,122,101,104,61,13,70,249,61,235,43,29,61,198,161,17,61,91,37,218,188,116,137,210,189,135,168,133,189,141,163,226,189,58,21,184,189,95,236,206,189,243,203,4,60,62,12,195,59,151,113,214,60,1,188,139,188,173,48,223,189,53,241,163,189,181,217,230,189,54,93,125,189,15,2,122,189,97,212,130,60,131,161,114,189,79,187,192,61,93,18,106,62,5,171,5,61,249,181,138,61,91,100,184,189,144,196,38,60,111,62,158,60,113,181,176,61,237,74,106,188,118,91,224,61,140,28,42,62,23,112,199,188,148,148,7,189,65,136,45,189,104,163,70,60,213,137,201,187,1,108,142,61,17,3,247,60,45,120,146,60,201,223,227,60,234,200,99,189,53,215,18,188,215,161,75,189,133,207,153,61,93,110,145,60,12,64,113,61,170,117,163,189,79,104,21,61,211,254,116,187,48,41,182,189,194,172,131,189,1,61,165,189,23,34,18,61,226,15,146,189,52,142,236,187,228,236,195,189,80,39,55,62,49,178,24,62,184,147,169,60,81,128,77,189,112,127,76,189,73,160,128,60,180,228,202,189,12,57,132,61,98,249,28,62,131,185,64,62,138,104,239,61,107,22,65,188,13,73,182,188,106,21,156,188,203,90,210,61,158,59,238,187,45,226,238,61,49,133,23,62,26,43,159,61,236,155,196,60,132,158,91,189,118,158,161,188,12,121,97,60,57,9,138,61,221,163,133,189,84,139,106,61,27,4,197,188,213,140,15,190,162,251,169,188,222,80,61,189,209,11,64,189,199,230,150,188,85,41,158,61,43,198,70,189,19,131,122,60,194,27,73,190,158,136,221,61,122,122,27,61,167,59,193,189,35,133,163,189,241,149,10,189,25,242,226,61,247,72,183,60,211,20,2,62,134,83,93,62,118,27,239,60,136,218,152,59,190,106,210,189,65,211,70,189,117,244,98,187,206,50,177,61,88,114,184,60,170,88,197,61,81,238,47,62,5,230,189,189,85,189,240,57,137,22,240,189,38,16,250,189,240,52,31,190,21,212,147,61,241,255,88,189,139,211,26,61,215,250,82,61,28,190,27,189,168,138,30,61,203,42,28,190,179,26,178,189,48,155,165,188,18,182,40,61,38,108,27,190,168,61,129,60,219,231,209,61,19,198,245,59,228,12,141,60,138,219,139,189,60,105,196,188,165,37,135,189,62,217,48,189,185,43,165,189,49,113,218,59,29,138,8,61,0,71,145,61,123,146,168,61,40,183,134,189,60,49,137,189,96,8,143,189,201,72,133,189,129,216,16,190,220,13,196,188,170,209,132,61,193,182,16,60,77,118,189,61,123,199,154,189,173,146,79,189,169,173,200,189,97,72,137,189,187,239,15,190,183,244,4,61,239,141,0,62,223,79,144,60,38,235,4,62,89,50,39,189,127,218,243,189,110,175,23,190,227,142,171,189,181,222,249,189,104,80,76,61,90,45,94,61,124,27,128,187,214,90,5,61,12,59,2,190,182,207,152,189,102,162,105,189,134,58,142,188,160,97,164,189,130,146,94,189,146,217,140,188,147,113,236,60,58,55,145,60,58,171,187,189,34,123,106,59,86,118,207,189,119,101,217,188,8,136,166,189,15,157,29,189,135,203,71,186,184,216,132,61,150,122,73,62,23,125,73,189,43,146,144,189,145,249,70,189,182,200,42,188,33,146,170,189,12,237,21,61,61,108,23,189,117,138,75,61,108,199,168,61,243,38,0,190,233,200,122,189,184,155,25,189,189,248,213,59,232,220,209,189,31,102,210,60,44,10,148,59,59,244,24,189,167,88,57,188,182,173,93,189,247,34,105,58,235,185,253,189,33,23,116,189,70,85,254,189,167,248,123,189,209,182,149,189,138,3,200,60,132,215,143,61,198,150,154,189,87,123,70,186,143,147,185,189,92,39,166,189,85,186,141,189,50,94,28,60,102,222,71,188,138,244,158,58,238,166,17,188,171,44,170,189,28,122,58,189,234,243,219,189,209,26,105,189,127,159,14,190,104,227,184,61,75,220,26,62,134,22,2,61,39,230,53,62,53,248,172,57,118,5,83,61,76,155,201,189,203,13,194,189,5,138,175,189,82,80,38,62,54,0,70,62,64,124,12,60,165,0,235,61,34,196,116,188,62,80,9,61,236,160,183,189,95,62,190,188,18,51,218,60,73,46,95,61,232,222,16,189,152,171,147,189,189,105,139,189,35,185,255,188,206,253,114,189,251,249,48,190,108,139,34,190,100,3,75,189,65,89,131,60,7,170,253,189,226,29,14,62,65,213,91,62,218,87,10,62,106,246,86,62,224,41,181,61,94,248,165,61,99,197,25,61,45,78,249,61,75,100,227,61,157,248,217,61,191,194,14,62,35,101,238,61,213,106,23,62,155,152,71,60,130,45,62,60,217,82,17,61,132,27,180,61,200,226,138,188,154,137,157,189,48,173,168,189,238,142,222,59,115,100,201,188,188,90,5,62,63,82,224,61,31,227,201,61,211,251,65,61,188,81,50,189,30,96,27,190,108,87,55,190,1,6,214,189,235,102,9,190,137,216,135,189,219,219,1,189,14,16,140,189,89,115,232,189,209,7,143,189,93,106,67,62,42,68,52,62,199,82,158,61,142,67,205,61,13,131,186,62,202,218,144,62,120,238,1,62,23,63,35,62,170,5,16,62,249,105,229,189,46,11,15,190,178,31,186,189,199,116,16,190,142,155,81,61,122,150,44,187,216,18,221,189,247,248,198,189,0,121,88,189,112,66,128,60,245,19,78,61,218,202,143,61,51,187,242,188,214,191,144,60,76,172,170,61,200,137,3,189,76,152,160,59,56,114,84,61,99,172,78,189,128,29,197,189,255,237,206,188,68,167,141,61,84,227,70,60,252,121,90,61,104,9,13,189,236,239,205,189,144,215,128,189,180,225,177,59,115,142,206,187,189,250,185,60,58,251,144,188,27,23,6,61,194,163,158,61,209,163,254,59,88,126,78,61,58,3,135,60,25,46,190,188,198,94,203,189,150,233,187,188,213,180,166,60,205,122,170,189,63,73,174,61,159,229,24,189,88,105,132,189,65,82,121,189,159,22,12,62,160,228,234,189,199,152,31,189,229,72,146,189,175,92,47,59,79,20,21,189,113,181,201,189,213,146,225,189,192,22,51,62,241,85,52,62,20,199,36,190,21,117,148,189,84,97,128,60,215,32,115,62,137,171,154,61,176,106,128,189,189,146,149,189,149,67,130,62,129,22,45,62,187,75,167,189,178,59,114,189,180,245,33,189,151,103,223,59,227,0,102,189,242,144,149,189,79,95,249,189,163,165,253,61,25,37,98,62,186,12,99,189,99,152,7,189,28,196,106,61,155,126,71,62,82,131,36,61,214,185,132,189,181,255,252,189,152,212,63,62,77,63,197,189,182,54,229,189,195,11,254,61,140,122,32,62,201,46,69,62,106,36,223,61,55,234,10,61,158,114,5,190,101,122,102,189,45,216,184,189,9,125,112,62,46,102,142,62,163,213,136,62,60,154,148,61,131,160,41,62,8,66,101,62,158,100,152,61,116,18,87,190,9,98,165,189,81,237,25,190,30,217,143,61,206,168,222,61,57,236,57,62,117,46,77,62,25,250,10,62,126,8,244,189,167,251,227,189,147,79,65,190,2,209,120,61,83,186,82,62,113,56,254,61,53,251,32,61,150,97,149,62,212,13,151,62,183,159,142,62,65,192,147,188,128,117,42,62,190,78,69,62,49,180,155,60,51,214,118,61,40,148,26,59,154,75,127,60,186,198,221,60,199,31,233,61,199,227,247,61,137,11,32,61,44,242,61,61,255,191,184,61,177,29,244,61,129,230,109,187,6,224,181,60,196,178,211,61,235,174,49,62,76,20,251,61,185,99,66,62,63,37,33,62,86,44,62,60,8,129,138,188,147,43,126,186,40,189,147,61,149,81,62,60,168,239,54,62,247,188,122,62,199,117,58,62,24,158,78,62,127,162,116,61,86,118,18,188,17,206,189,188,181,212,19,62,79,136,16,62,91,35,98,61,28,31,130,61,213,214,67,190,205,96,208,61,185,154,150,62,23,106,135,62,129,98,191,61,47,130,28,62,250,185,74,62,117,218,232,61,239,71,2,190,75,25,91,190,190,131,164,188,101,124,134,189,208,41,136,188,120,66,33,189,143,184,67,61,238,129,77,61,211,86,188,188,92,239,78,190,237,252,130,189,208,130,12,62,52,219,102,62,239,116,24,62,151,233,177,61,232,176,138,62,218,229,164,62,231,86,200,61,146,173,61,190,33,117,48,190,250,164,42,188,201,49,36,61,17,5,44,61,72,129,165,189,113,210,25,189,203,0,69,189,125,229,85,189,94,77,94,190,72,163,135,189,5,71,241,60,15,111,60,189,246,73,87,189,231,180,172,189,252,80,233,60,55,249,14,61,233,194,7,60,91,84,226,189,209,151,229,189,40,179,163,188,75,238,91,189,164,164,181,189,199,129,64,190,221,174,94,189,203,70,77,189,215,253,93,189,229,250,123,189,226,192,221,189,210,10,50,61,175,127,36,61,208,43,121,60,60,79,249,189,127,229,71,189,81,116,52,188,154,39,5,61,182,38,118,189,197,141,252,188,115,4,188,188,143,109,140,189,148,183,179,189,241,164,115,190,4,229,187,189,132,217,98,189,75,253,48,189,240,49,243,189,62,237,44,189,120,165,120,189,128,180,67,60,147,177,213,60,12,108,31,189,96,155,134,188,156,40,213,188,119,227,85,188,58,145,32,61,125,105,133,189,94,162,56,60,50,176,205,187,133,211,222,188,79,4,228,189,120,46,7,61,155,123,196,60,99,26,39,61,34,92,216,189,182,95,116,61,52,211,67,60,219,58,2,189,47,168,138,188,92,11,125,189,166,220,150,60,202,147,180,187,178,181,139,189,95,189,2,189,201,125,195,189,61,67,248,60,224,139,72,189,24,196,238,188,125,5,8,190,201,237,67,189,14,45,199,59,8,126,109,188,192,201,8,190,214,103,198,189,132,129,230,188,204,209,70,60,54,49,136,61,86,10,167,188,121,196,8,62,28,52,117,61,245,139,21,188,16,79,64,190,231,156,245,189,150,227,129,189,101,114,73,60,26,75,146,61,5,103,219,61,86,9,227,61,122,137,134,61,46,48,242,188,222,202,38,190,64,75,15,190,2,196,83,188,14,0,29,61,130,253,186,61,69,85,80,189,247,21,102,61,132,155,31,189,103,169,128,189,190,80,235,189,130,16,18,190,186,145,57,189,116,236,130,60,169,193,187,61,156,108,177,61,216,25,72,61,11,41,107,189,107,242,154,189,54,122,47,190,67,149,214,188,153,246,202,188,3,131,219,60,128,4,238,61,123,252,179,61,109,238,30,62,51,231,64,61,237,128,56,61,42,47,209,189,173,196,251,189,23,115,69,189,167,168,96,189,121,52,96,61,136,116,150,61,253,113,100,61,220,35,168,189,237,215,13,61,61,167,86,190,192,247,190,189,118,178,120,59,162,45,20,61,56,113,43,62,207,140,144,61,97,255,208,61,47,43,139,189,20,142,83,59,30,234,0,190,59,43,51,190,103,65,170,60,107,148,157,189,155,138,249,61,13,67,184,61,118,87,68,61,177,33,233,189,24,202,164,189,146,171,131,190,132,127,165,189,57,14,223,59,109,12,240,188,40,216,71,187,237,116,227,189,29,153,61,189,248,47,160,189,250,90,252,59,126,223,209,189,50,167,158,58,35,173,82,62,103,192,4,189,210,28,10,60,79,116,159,60,161,70,68,188,136,76,21,190,169,104,45,61,243,176,135,187,230,159,140,189,216,55,199,188,211,137,10,190,58,2,165,58,124,252,233,189,13,71,48,189,217,214,138,188,192,76,106,61,113,64,36,190,216,39,227,60,83,54,97,61,77,181,25,190,187,181,109,60,109,137,192,60,76,43,48,189,104,211,74,189,26,59,94,62,36,102,1,189,115,213,160,188,202,179,58,62,54,176,5,189,100,14,61,187,151,13,130,60,146,173,254,186,98,135,159,189,20,116,63,61,38,253,204,187,191,205,182,61,145,169,90,62,248,144,77,60,9,92,143,189,123,242,114,189,52,93,154,188,137,98,48,189,61,139,241,61,236,101,29,61,46,8,32,189,240,218,102,61,3,2,200,189,20,92,172,188,43,252,14,60,121,52,224,188,20,102,81,189,33,12,46,62,78,35,242,60,168,138,171,60,48,83,172,61,0,162,8,189,201,43,20,189,229,231,109,189,92,179,181,189,109,214,239,60,119,163,138,62,32,214,120,61,160,39,153,61,6,127,28,62,28,23,32,189,16,248,80,189,177,249,27,188,197,9,6,189,213,231,178,189,54,85,156,61,187,39,147,189,26,188,13,62,196,0,160,61,97,28,4,190,7,208,96,189,177,51,103,189,134,201,6,189,87,16,229,189,16,170,25,61,122,221,116,189,3,128,187,189,63,185,103,61,82,72,49,189,202,175,249,188,46,135,103,188,249,129,208,189,182,193,98,188,59,40,78,62,32,205,123,188,187,125,156,189,14,241,113,61,61,108,160,189,217,168,121,188,71,167,153,189,135,199,193,189,74,188,25,190,219,91,36,62,5,194,184,61,41,136,173,61,149,179,10,61,103,86,187,189,115,208,187,189,155,12,174,189,145,174,81,189,177,160,213,189,160,168,42,60,226,19,251,188,156,73,191,61,212,16,132,61,205,247,30,189,22,52,76,189,161,125,23,190,32,255,84,189,82,173,175,188,166,223,35,61,201,96,254,61,240,175,151,188,16,159,40,189,88,197,244,189,94,216,71,189,25,163,178,189,39,39,173,189,2,12,216,189,195,112,230,61,168,126,220,61,217,160,68,62,80,10,123,61,8,5,224,188,113,240,180,189,6,20,46,190,32,87,17,189,175,170,175,187,45,241,169,61,8,255,147,61,211,206,43,61,150,58,63,61,31,46,15,60,8,244,142,61,140,134,103,61,115,210,112,61,13,236,202,60,17,210,200,60,65,164,254,61,163,98,101,61,105,8,141,61,74,59,30,61,239,194,152,61,112,122,185,60,132,4,117,60,252,237,129,61,228,60,142,61,97,46,240,60,65,3,240,61,131,113,57,61,195,11,5,61,40,126,8,59,234,126,167,60,234,138,233,61,148,73,48,61,150,252,131,61,35,31,75,61,203,103,167,61,130,61,189,61,3,124,72,61,131,143,184,60,17,96,135,188,204,97,155,61,66,100,120,61,156,228,14,62,128,38,227,60,244,67,145,61,248,26,174,61,222,94,139,60,16,118,185,61,37,30,171,62,37,122,78,62,123,34,201,61,19,216,162,61,121,19,178,61,160,163,2,190,212,252,13,190,203,95,135,189,177,251,224,189,14,139,11,61,135,230,54,188,112,33,149,189,218,128,10,190,168,135,3,190,139,108,183,61,167,213,187,61,207,176,206,61,88,119,111,62,25,150,176,62,173,201,202,61,82,20,164,60,30,164,252,61,87,198,155,61,179,145,24,190,57,25,32,190,129,2,133,189,89,57,144,188,110,112,11,61,50,66,7,190,250,212,247,189,33,86,59,190,232,148,41,190,110,231,178,60,123,126,225,188,191,146,148,60,234,230,163,60,160,65,88,60,152,117,164,61,243,248,71,60,66,115,67,59,125,38,86,188,26,139,116,61,93,241,90,189,167,134,10,189,150,204,33,188,95,175,140,189,82,17,34,61,45,159,254,188,220,208,106,189,61,246,177,60,76,98,42,61,212,55,44,59,93,38,69,61,6,172,191,61,185,21,6,188,240,70,141,60,103,176,208,188,202,117,75,189,209,209,195,188,94,255,135,61,146,40,129,189,247,94,58,60,224,240,100,61,187,181,168,189,26,29,201,60,187,160,250,188,162,96,183,189,148,81,140,61,182,65,147,61,130,222,155,189,39,251,0,60,34,192,0,188,117,11,118,61,102,154,56,188,187,67,59,187,110,127,67,189,36,106,154,60,244,168,25,62,173,98,128,189,221,241,162,188,234,131,58,60,254,105,179,61,86,226,30,61,218,107,30,188,254,26,164,189,190,94,131,61,68,78,95,188,115,24,187,189,90,200,143,60,249,168,54,61,154,166,197,61,31,207,85,61,16,208,15,187,18,35,144,189,152,254,130,188,143,45,6,62,172,49,204,188,222,43,41,188,195,214,237,188,65,224,55,61,152,221,82,61,182,56,152,60,166,36,239,188,55,248,169,61,103,5,60,189,59,60,33,190,121,183,185,189,220,128,243,188,114,247,4,62,208,143,100,62,39,113,120,62,244,51,21,61,5,139,97,189,119,64,47,59,189,10,29,189,142,21,132,61,124,19,29,61,13,88,28,61,121,51,128,62,96,42,175,62,189,15,166,62,125,195,64,62,237,31,176,189,203,55,52,190,163,216,28,190,123,5,203,189,44,248,233,188,205,71,89,189,157,130,139,186,59,6,136,189,89,202,153,189,207,193,111,60,205,169,154,189,176,190,56,189,239,97,10,188,57,45,145,60,137,162,38,61,238,210,79,62,150,247,32,62,190,247,105,61,0,164,134,62,108,24,22,62,46,131,125,60,50,246,78,189,210,250,30,189,47,149,107,188,167,240,73,189,74,4,240,61,142,196,118,62,236,132,135,62,246,75,162,62,1,236,206,61,77,161,51,188,174,248,95,188,184,37,47,62,4,120,77,62,154,99,47,59,165,249,66,188,145,104,59,62,112,188,193,61,60,52,130,189,93,149,132,189,145,193,97,60,163,120,205,189,102,215,130,189,93,75,121,59,114,51,126,61,50,243,211,61,251,60,137,62,255,1,6,60,117,151,189,188,130,24,25,60,2,98,188,61,128,201,22,61,75,190,15,188,230,226,197,189,134,120,222,188,169,70,10,62,130,142,183,61,39,79,215,187,1,31,3,189,181,249,145,62,127,84,164,62,235,145,61,62,87,185,17,190,111,219,15,190,176,18,147,189,214,159,175,189,38,100,177,189,53,87,50,190,1,190,69,58,215,113,101,61,74,29,11,62,244,45,75,189,45,222,157,189,188,166,218,61,120,136,52,189,85,164,147,189,74,16,22,61,115,56,148,62,36,146,210,62,149,114,140,62,151,81,141,189,77,229,91,190,115,134,31,190,135,63,72,190,28,191,27,190,244,202,230,189,55,225,151,61,162,120,66,62,139,131,137,62,215,237,159,60,190,198,38,60,49,239,176,60,124,65,162,187,144,235,50,189,25,69,2,190,193,174,136,189,200,234,230,189,243,197,52,61,215,124,100,61,155,156,31,61,152,20,18,61,116,130,112,189,223,78,151,189,165,247,55,190,227,132,175,189,220,101,28,190,149,172,118,189,92,91,143,189,64,81,223,187,15,232,128,61,177,173,43,186,46,235,56,188,150,145,187,188,126,160,70,61,122,155,41,61,200,128,114,62,196,242,20,62,151,4,163,60,206,109,246,61,133,237,125,59,142,117,197,187,87,121,114,189,89,68,251,188,97,126,159,189,44,229,221,61,254,110,176,60,221,143,226,60,151,214,34,61,132,129,249,189,105,181,72,189,192,146,203,189,130,43,132,189,183,223,12,190,133,109,24,189,95,158,231,60,39,58,50,189,124,57,156,60,104,158,210,189,108,74,104,189,200,96,220,189,134,25,197,189,70,231,195,189,54,151,85,188,150,91,252,60,199,20,104,60,62,117,111,61,193,235,177,187,231,212,126,61,34,0,8,189,148,24,139,189,159,54,109,189,24,153,3,62,75,128,25,62,44,221,20,61,76,13,18,62,113,95,49,61,80,34,78,61,230,174,102,189,34,147,131,60,94,179,51,61,16,208,100,62,242,255,32,62,66,64,64,189,136,76,246,60,171,186,37,187,154,49,106,61,112,53,154,189,56,91,233,188,18,172,140,189,205,5,148,187,175,108,132,61,243,28,115,189,0,182,64,189,90,208,150,189,35,97,70,61,84,111,9,190,86,124,200,189,38,7,210,189,119,195,15,61,138,159,66,61,246,143,28,189,26,124,199,61,203,22,67,61,109,99,33,61,34,164,169,189,13,165,195,61,2,99,78,61,52,176,89,62,5,146,197,61,95,194,4,61,70,171,83,61,70,3,61,61,73,92,49,61,140,224,218,188,244,51,128,189,77,146,188,188,138,207,64,62,180,129,215,61,19,171,48,61,82,226,136,60,36,123,172,189,179,33,114,61,80,187,216,189,113,225,70,189,88,127,171,189,48,64,159,61,19,132,24,61,199,186,246,189,159,93,159,59,212,119,215,189,16,151,134,61,30,45,154,189,30,241,4,189,84,30,202,189,237,255,238,188,182,82,59,190,1,170,23,62,201,100,23,60,149,96,50,189,6,180,185,60,75,39,243,189,253,132,36,189,52,218,231,60,195,204,102,62,154,151,82,62,194,6,43,62,97,186,184,61,77,25,85,60,168,229,199,61,226,143,22,189,73,141,158,188,203,52,141,189,50,108,165,61,250,11,67,62,165,172,231,61,251,46,40,61,14,29,229,189,12,167,48,61,253,239,61,190,76,41,231,189,199,28,180,189,182,64,170,60,51,160,28,190,119,203,241,61,81,192,52,188,83,139,35,190,247,106,176,60,10,79,86,189,68,232,221,189,49,113,14,190,150,131,114,61,150,79,207,189,150,149,78,62,153,124,186,61,186,30,154,188,190,196,195,61,69,155,24,189,39,100,193,189,38,243,199,189,102,204,111,61,179,184,169,61,156,76,4,62,40,3,176,61,151,182,35,187,239,122,196,60,28,27,186,59,244,242,128,189,20,13,5,190,138,239,29,61,6,113,84,61,86,0,222,61,185,118,10,189,226,149,1,190,44,40,93,189,28,183,152,189,254,254,65,189,216,41,208,189,91,133,153,61,134,103,166,61,107,204,156,61,163,200,76,189,237,78,3,190,78,138,157,189,108,200,231,189,4,192,186,189,107,75,105,189,192,146,214,61,224,244,152,61,150,136,133,60,196,58,3,188,79,205,134,189,68,159,36,189,215,207,63,189,89,74,156,188,186,59,225,189,211,43,73,61,39,28,240,60,113,240,43,61,146,128,108,189,3,14,198,189,203,63,19,189,211,89,11,189,235,106,146,189,82,101,216,189,69,29,217,61,121,219,129,61,11,208,120,188,218,109,195,187,192,56,156,189,133,50,103,187,127,220,219,188,193,60,210,189,196,156,219,188,22,78,39,62,109,61,254,60,20,43,188,60,12,17,133,60,226,212,221,189,252,148,189,188,119,50,68,189,152,137,98,189,229,83,132,189,112,237,214,61,224,43,62,61,244,128,155,189,191,221,125,189,238,46,185,189,140,213,108,188,227,9,48,189,101,165,230,189,206,24,234,189,122,7,2,61,63,161,22,189,128,207,242,188,83,96,135,189,79,28,8,190,215,145,144,189,118,239,172,189,14,80,216,188,129,38,146,189,184,198,58,61,0,52,111,60,190,53,56,62,201,171,53,61,21,71,255,189,165,51,235,188,139,52,220,189,247,1,11,189,203,75,27,189,178,192,208,60,87,61,160,60,82,19,69,62,213,251,14,62,58,219,113,189,108,14,152,189,66,60,213,189,237,20,202,58,209,62,147,60,120,98,5,62,124,69,58,61,89,229,105,189,238,19,219,189,192,33,10,190,82,113,133,189,137,54,131,189,149,225,133,187,41,248,90,188,135,241,50,61,92,153,230,189,250,137,105,189,72,129,132,189,60,240,170,189,192,171,42,189,172,98,109,189,182,232,168,189,210,55,107,189,39,26,173,61,165,57,9,189,252,41,15,62,11,180,7,62,116,111,155,61,65,107,154,61,99,243,248,61,47,116,67,62,164,30,26,62,62,154,89,62,70,122,17,62,147,190,84,60,190,148,152,61,143,84,134,61,68,79,139,60,238,217,56,61,62,147,45,62,56,40,210,61,91,213,39,62,186,124,97,61,35,112,13,189,137,150,176,61,65,135,162,61,28,222,34,61,236,203,166,60,125,173,129,59,169,209,5,61,12,4,28,62,216,148,84,60,136,19,166,189,67,157,102,60,11,104,144,59,67,54,27,190,233,70,233,189,147,88,153,189,10,3,0,188,35,62,225,188,230,131,208,189,201,219,12,62,16,111,15,62,186,15,10,62,100,227,140,62,157,93,175,62,206,117,156,61,111,220,148,61,30,255,74,62,2,59,37,62,63,122,43,189,197,232,2,190,231,166,201,189,206,205,1,61,204,191,224,61,182,33,26,190,83,157,182,189,179,51,146,189,5,31,42,189,231,239,204,59,82,135,79,60,143,184,215,61,30,141,2,62,182,29,27,62,49,132,117,60,85,37,129,61,33,84,76,188,26,200,179,189,123,36,175,189,101,215,244,189,199,242,173,189,98,179,237,188,213,47,196,188,229,126,9,190,154,94,226,189,127,151,19,190,128,174,27,190,104,185,34,61,21,26,195,185,212,17,44,189,168,16,122,61,57,14,156,60,3,61,53,188,147,94,238,187,185,23,121,188,141,122,144,58,253,183,74,189,183,27,164,189,204,116,187,59,55,89,172,61,26,152,133,189,173,20,22,61,193,249,218,188,102,29,247,189,15,163,23,189,142,7,118,61,240,107,133,60,134,110,202,187,115,199,167,61,249,227,95,187,0,39,235,60,73,220,109,61,57,41,75,61,223,41,61,61,78,197,72,189,112,171,216,189,130,82,186,60,154,54,247,61,111,137,18,59,196,90,201,61,205,98,247,188,186,1,229,189,164,52,75,189,82,182,204,60,129,42,24,189,150,174,132,188,235,141,216,60,22,2,250,187,1,30,236,188,88,178,127,189,46,217,172,189,71,226,147,61,7,196,148,61,41,217,127,60,69,75,253,60,74,250,139,60,4,136,27,189,176,197,80,187,48,10,133,60,122,183,231,188,252,26,231,61,11,98,173,186,22,111,159,189,114,164,147,189,133,32,10,61,189,236,248,61,78,159,186,60,160,21,88,189,135,41,157,188,167,2,5,62,248,46,94,61,92,32,191,60,92,7,37,61,149,206,253,61,182,119,194,61,218,55,188,61,234,134,162,61,93,168,15,60,159,153,47,62,57,122,11,188,4,18,164,189,25,48,139,189,80,21,72,61,18,60,54,60,146,119,160,189,84,124,150,186,252,238,12,189,18,21,233,60,206,154,157,61,183,200,144,189,83,181,60,188,129,230,11,188,38,55,136,188,71,141,42,189,102,52,93,61,254,56,234,60,173,91,239,60,172,237,76,61,51,178,224,187,86,190,133,188,190,86,159,61,239,151,37,61,49,77,71,188,108,135,108,59,197,123,129,189,13,231,194,61,93,220,3,62,159,201,30,188,200,242,40,60,159,53,84,61,115,34,25,188,91,184,134,188,23,161,70,189,33,230,49,189,191,87,215,61,139,203,164,61,239,9,61,189,254,213,34,189,111,99,115,188,142,28,6,62,112,179,120,188,172,151,134,189,182,130,36,189,211,136,151,60,151,219,199,60,170,55,165,61,113,37,229,58,243,117,144,61,173,159,180,61,180,147,166,187,99,41,134,189,138,74,169,189,199,88,159,189,29,34,110,60,83,87,179,189,150,166,51,60,198,193,14,188,243,15,207,61,53,79,198,60,63,99,137,189,217,122,164,60,155,91,194,59,208,35,93,61,142,97,154,61,104,223,167,60,128,182,183,60,30,75,36,61,66,228,189,186,238,85,137,187,217,104,130,61,55,94,205,60,236,111,199,60,8,210,112,61,37,213,6,188,193,143,75,188,143,13,45,61,103,195,143,188,217,11,116,61,236,107,28,61,127,241,149,188,69,126,48,189,25,34,53,189,219,73,199,188,175,137,185,60,209,135,5,59,30,31,68,60,107,212,53,61,231,57,249,61,47,145,19,61,63,238,212,188,227,232,1,187,199,162,167,60,15,49,216,188,90,170,250,186,141,44,191,189,233,65,19,189,68,231,33,188,147,65,140,189,188,33,63,189,187,228,203,189,158,75,44,189,69,188,213,60,114,238,20,60,145,50,146,189,236,105,221,185,59,185,144,60,251,205,225,60,19,89,86,60,164,1,38,61,210,149,195,60,160,157,90,61,8,218,204,60,44,155,75,189,81,85,255,189,227,68,52,62,228,2,251,61,217,217,153,189,93,157,14,60,31,95,105,189,86,138,20,189,63,160,15,188,180,100,70,188,50,145,193,189,2,105,153,61,213,126,164,188,122,166,219,188,219,94,132,189,219,160,120,188,16,112,240,59,66,243,198,59,185,207,190,189,203,103,59,189,123,204,7,62,95,243,29,62,30,167,135,188,59,29,227,188,152,199,86,189,119,10,193,188,214,167,192,188,70,34,209,189,228,209,3,190,101,253,20,62,13,52,0,62,21,198,143,59,52,12,229,60,193,198,83,61,53,230,188,61,73,65,113,61,8,179,194,60,43,133,227,188,148,179,194,61,84,201,190,60,107,12,190,188,121,214,3,189,76,82,122,188,61,147,38,188,236,28,219,188,58,107,82,61,148,65,162,60,192,7,134,61,220,11,143,188,127,41,40,60,228,226,127,60,18,238,80,58,97,175,155,61,238,61,156,60,238,143,252,188,91,62,117,189,205,74,189,61,32,11,21,62,188,181,41,60,89,84,253,60,35,216,195,189,146,190,27,189,240,89,207,60,186,68,252,60,50,108,145,189,36,109,8,61,81,94,48,187,138,189,1,61,174,80,107,61,122,134,5,61,137,178,250,58,148,217,2,61,181,87,151,61,169,16,180,60,141,84,156,61,181,226,6,61,86,113,186,189,78,65,65,61,39,247,121,61,131,87,36,188,189,217,191,59,98,117,121,188,223,87,190,60,115,196,216,61,56,212,142,59,177,45,122,61,195,96,112,61,108,57,255,188,84,3,71,60,7,116,175,61,246,20,129,59,112,143,206,188,0,249,246,186],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+81920);allocate([18,245,166,60,132,83,36,186,92,153,72,61,48,85,47,189,26,106,69,189,145,34,69,189,39,195,109,188,200,244,80,61,241,163,19,188,12,142,8,189,188,122,32,61,242,226,43,61,76,206,47,61,24,40,230,60,149,188,245,60,9,44,39,61,206,25,21,60,226,184,198,61,189,147,212,61,85,104,192,60,179,233,154,187,34,81,40,60,227,11,213,61,31,59,247,61,236,14,201,61,77,250,213,188,137,7,21,61,74,132,113,61,124,69,71,61,202,91,68,61,22,5,31,189,25,168,242,188,163,65,72,188,202,197,38,61,142,131,157,60,7,108,187,188,155,84,8,61,252,75,152,60,246,212,184,61,154,212,27,61,72,100,105,188,224,12,160,60,124,150,205,60,79,228,10,189,186,254,103,189,204,130,134,188,236,142,111,61,119,10,62,61,218,98,171,60,124,55,4,62,53,246,75,62,34,131,158,61,6,213,237,187,198,231,38,61,150,106,2,61,253,132,182,58,224,16,106,188,243,209,152,60,92,175,174,61,252,185,10,62,13,42,229,61,132,203,35,61,126,29,196,61,53,138,215,188,105,166,13,189,52,143,66,189,18,168,120,189,128,160,154,59,128,2,132,61,5,181,200,188,143,157,96,189,171,194,62,189,57,91,166,188,122,146,14,189,45,119,192,189,244,16,131,189,228,212,147,188,50,69,184,59,110,216,217,187,104,124,133,189,89,34,228,59,34,98,152,188,193,232,45,189,139,161,111,189,41,156,84,187,214,181,157,61,80,61,231,61,65,57,203,61,250,89,243,188,174,16,101,61,58,46,69,61,235,238,200,189,218,166,191,189,140,48,6,189,61,190,85,61,119,161,41,61,94,197,128,59,170,190,78,189,103,110,35,62,183,240,60,61,94,27,255,188,63,119,62,189,146,28,5,189,97,181,198,188,213,151,48,189,20,113,48,61,242,140,192,189,181,67,66,189,128,137,77,188,104,36,135,189,79,184,95,59,163,54,102,189,197,151,238,187,96,177,117,189,25,31,6,189,9,20,151,189,230,17,81,59,142,95,158,189,193,55,110,61,29,110,202,188,165,184,29,61,139,181,13,62,208,177,29,62,111,212,141,60,115,22,114,188,10,219,212,61,197,88,83,61,63,97,159,188,249,99,12,189,197,93,71,189,0,47,189,61,92,206,219,61,196,175,120,61,204,3,94,188,243,22,151,60,221,146,14,189,251,130,27,189,94,26,98,57,124,212,94,189,34,209,154,60,33,125,108,188,171,163,213,188,89,174,240,188,252,224,222,60,122,29,127,189,11,97,243,188,106,86,12,189,102,141,210,189,93,5,138,189,251,33,86,189,55,163,9,61,131,251,230,189,217,170,142,189,37,184,14,190,69,63,21,60,167,33,132,57,206,123,133,187,52,31,252,61,139,88,191,61,48,142,149,61,24,250,3,61,251,69,154,61,15,86,27,61,103,49,76,189,63,213,147,60,93,181,220,60,240,12,10,62,87,119,60,61,212,56,40,61,115,78,174,61,74,52,252,61,160,103,88,60,113,155,78,61,76,48,181,187,64,43,184,189,67,67,184,188,19,144,167,189,242,134,124,61,245,99,5,189,193,33,47,188,123,214,88,188,125,38,245,189,232,21,61,189,129,147,247,189,136,127,138,189,153,179,177,189,180,199,131,189,161,52,145,60,141,29,14,61,242,198,223,189,127,229,246,60,216,171,15,62,28,44,37,62,36,44,56,62,203,13,231,61,224,170,215,61,209,100,182,61,50,99,158,61,84,30,137,61,215,122,175,60,66,222,131,61,36,151,200,61,114,81,107,61,71,112,228,60,114,174,215,60,161,140,163,61,114,59,139,59,25,235,10,60,122,128,219,188,6,72,173,187,151,40,177,188,235,104,153,189,197,252,168,189,134,121,168,188,178,33,40,188,2,97,151,186,250,235,22,186,67,172,147,189,6,239,149,189,61,5,72,189,116,44,223,189,94,34,153,189,82,153,181,189,33,224,188,189,182,188,223,189,175,156,213,189,62,227,162,61,79,192,226,60,4,86,233,61,114,77,64,62,189,183,7,61,166,156,175,60,214,178,111,61,10,251,10,187,108,15,119,187,128,66,227,60,210,247,255,188,120,12,112,60,15,98,132,60,16,13,100,188,91,100,52,189,220,254,94,189,36,95,22,190,21,197,25,190,51,181,56,61,33,210,169,58,13,27,101,60,90,205,101,61,34,109,71,189,127,167,67,189,43,214,5,188,205,208,22,187,117,75,187,188,133,107,245,61,68,165,64,189,14,133,180,189,141,88,155,189,11,45,221,189,227,98,4,189,4,93,119,60,103,99,70,189,226,133,34,189,40,100,196,61,122,154,93,60,242,229,110,188,246,42,44,60,81,243,248,188,87,194,131,60,195,196,146,58,81,232,76,188,79,146,59,59,11,130,49,61,49,138,21,190,247,117,159,188,189,171,190,188,155,180,161,188,137,179,162,61,18,60,182,188,198,64,137,189,21,102,14,61,115,162,235,61,143,59,222,188,243,103,136,188,139,88,129,61,87,14,168,189,20,53,152,61,171,89,73,61,67,10,55,189,254,47,116,188,207,143,151,61,71,156,238,189,219,254,80,61,209,189,58,61,42,82,114,189,11,15,181,61,184,20,130,188,192,121,24,190,107,237,160,61,152,238,64,61,47,114,92,189,130,40,150,189,108,165,19,189,216,221,31,62,188,171,156,61,75,24,116,189,171,117,227,188,23,77,227,61,169,246,25,61,221,36,54,189,55,16,74,61,212,115,92,60,131,190,141,61,175,212,150,61,115,14,98,61,180,136,237,60,103,4,192,61,227,106,215,61,150,13,53,189,96,230,156,60,201,143,105,187,160,94,21,62,203,168,210,61,122,156,50,189,52,73,2,190,103,226,185,61,255,187,227,61,179,49,119,189,232,35,198,61,35,14,183,61,203,181,144,61,164,64,213,60,227,161,191,59,90,145,114,189,158,35,253,61,248,186,107,59,122,129,68,59,171,119,23,61,83,94,167,60,64,192,42,61,131,24,40,60,178,209,94,188,186,37,131,188,171,112,211,60,234,207,190,60,255,92,67,59,150,130,133,60,62,60,136,61,179,216,111,61,246,190,74,60,201,133,84,188,40,79,144,60,151,133,80,61,106,33,134,61,102,73,53,189,184,98,31,59,12,105,73,59,65,199,136,61,254,72,48,189,218,86,49,60,31,161,132,189,175,6,39,61,206,207,254,61,174,181,168,61,2,12,152,61,242,137,38,61,239,108,141,61,200,182,195,61,127,77,2,62,0,169,174,188,176,94,174,61,125,5,43,189,20,122,218,188,129,120,155,60,69,225,7,61,181,231,26,60,86,254,74,188,214,197,45,189,68,145,104,188,65,54,17,189,215,244,199,188,203,217,177,61,254,143,44,61,224,193,201,60,184,3,53,188,57,102,164,187,17,56,243,60,5,201,212,60,9,135,128,188,19,238,56,61,185,214,142,61,58,145,177,61,243,214,139,61,45,177,209,61,145,109,93,61,216,28,134,61,243,43,26,189,248,209,95,60,19,201,144,61,249,178,91,61,239,135,68,61,94,191,239,61,242,231,95,61,52,33,153,188,213,238,129,61,238,124,254,60,158,178,172,61,81,216,168,188,3,131,28,61,46,209,226,187,69,222,209,59,71,94,80,188,50,127,144,56,48,4,58,61,56,156,155,188,5,161,77,189,127,213,245,60,157,167,50,60,125,66,148,59,250,212,210,60,131,169,195,188,252,12,44,189,168,120,226,58,193,223,116,189,82,222,222,188,51,161,134,61,144,31,61,60,190,91,79,60,116,15,151,61,102,180,22,188,72,72,73,189,240,16,174,60,123,52,132,61,73,29,51,61,81,148,7,189,109,177,19,61,114,47,222,187,44,99,25,60,191,41,143,60,137,51,131,189,103,135,139,189,192,126,165,61,186,148,227,188,143,18,224,60,81,240,130,61,215,60,136,61,150,135,104,61,148,242,176,61,80,197,248,187,118,228,164,188,168,50,66,189,65,191,135,188,30,18,133,188,171,60,99,61,226,230,24,187,151,129,55,60,176,138,123,61,134,183,128,189,158,214,178,189,7,189,190,189,118,207,46,189,202,169,182,59,15,3,69,61,243,75,145,60,28,21,176,59,132,252,23,62,185,251,128,189,126,114,240,188,200,92,234,61,127,51,78,189,25,77,185,59,232,27,170,60,164,131,59,189,216,249,65,189,41,146,242,60,38,156,190,189,66,245,52,189,58,100,76,189,48,98,33,189,72,250,85,60,217,93,128,61,55,245,25,61,97,67,173,61,252,233,13,62,213,41,71,61,0,110,129,189,98,166,103,189,110,124,154,60,22,148,6,189,113,25,10,61,190,50,144,189,60,229,56,189,173,23,100,60,241,157,167,61,174,19,148,189,80,136,195,60,50,246,178,60,213,118,213,60,45,103,41,188,236,89,24,60,21,114,251,59,176,137,27,62,144,127,169,60,184,112,199,189,186,38,182,189,157,26,159,189,52,15,191,60,59,188,145,188,235,123,5,189,17,139,167,189,182,239,173,189,13,156,187,60,243,209,232,189,68,151,17,189,205,180,57,189,175,107,234,188,111,231,138,61,195,95,54,60,165,0,201,60,209,69,2,62,182,147,165,61,121,198,19,189,243,183,53,60,218,192,68,61,143,242,14,189,184,62,11,61,60,188,104,189,119,211,12,60,61,55,140,187,78,86,4,61,66,6,85,188,159,22,42,188,161,104,162,189,164,126,8,60,117,43,188,60,149,14,86,188,143,36,154,188,135,197,52,61,38,178,106,61,190,18,26,189,135,29,159,60,188,170,215,58,148,28,28,189,38,166,43,61,46,96,25,190,212,233,56,189,255,43,70,60,113,16,179,187,47,240,134,188,117,10,250,59,56,125,153,189,88,88,172,61,102,54,205,61,149,73,73,188,236,56,134,61,52,136,58,61,130,152,161,61,73,33,249,60,64,134,143,60,200,149,188,61,181,77,196,185,231,13,216,61,216,249,63,61,135,57,155,60,36,52,217,188,205,111,142,187,30,145,178,59,13,170,108,60,224,238,112,61,51,170,8,189,76,147,60,61,150,168,213,189,178,155,157,60,67,247,150,60,196,66,140,188,200,22,182,188,18,61,64,61,181,18,126,189,172,1,105,188,251,213,178,61,50,210,157,189,62,254,217,60,67,35,48,189,202,84,253,188,89,127,17,189,34,130,154,188,101,250,75,189,149,1,32,61,35,197,60,61,115,105,75,61,125,31,47,61,195,78,61,189,227,89,217,188,168,105,12,60,1,70,29,61,42,86,110,61,24,245,30,61,155,193,144,185,29,7,252,60,60,208,5,189,81,36,92,189,134,63,76,61,44,230,26,188,58,189,18,61,150,98,45,187,26,218,140,186,53,172,242,60,193,8,115,188,19,191,250,60,35,145,200,60,230,49,151,60,101,120,6,61,69,197,16,189,187,156,49,188,247,91,55,188,146,244,242,186,122,226,27,186,175,88,54,189,23,131,67,59,226,117,128,61,78,76,176,188,121,133,72,187,124,179,79,189,193,246,122,60,41,45,82,60,127,165,83,61,80,9,27,60,147,65,91,187,139,86,234,61,187,4,32,189,184,49,47,187,116,109,251,60,84,210,57,188,180,158,241,60,150,235,235,60,138,236,29,61,16,88,13,189,251,62,187,61,80,172,176,188,164,213,120,61,252,205,126,189,229,78,159,60,35,3,219,59,200,84,136,189,84,171,14,60,236,142,13,61,100,107,199,60,81,138,7,190,99,23,43,189,57,139,169,188,221,255,46,60,101,166,118,60,199,244,153,189,164,96,123,187,82,254,128,189,103,8,236,188,155,39,6,190,200,229,147,189,86,9,190,187,198,117,12,188,16,238,26,61,199,70,226,60,104,113,74,61,176,140,240,188,7,141,196,61,233,102,157,60,160,231,121,61,166,24,68,189,178,7,98,188,135,142,242,187,160,223,181,188,236,62,87,188,76,202,254,59,135,215,251,61,58,216,240,60,121,54,19,61,210,130,159,189,129,167,57,188,97,91,209,57,235,117,121,189,220,214,55,188,241,147,153,187,109,83,156,61,202,55,138,189,208,6,103,189,171,174,87,189,61,162,58,188,7,17,133,188,216,39,65,189,66,19,52,188,214,203,43,60,39,73,87,59,4,252,109,189,182,177,157,189,190,108,8,189,109,108,43,61,24,123,14,61,171,97,186,60,114,206,188,60,142,63,218,59,175,160,224,61,154,81,194,187,88,255,70,189,226,41,44,189,202,206,190,189,115,228,200,187,167,116,208,188,160,214,95,60,6,127,22,60,140,69,151,188,38,75,102,189,166,103,35,189,114,244,159,189,105,132,226,59,239,5,116,61,116,204,31,189,69,199,128,60,236,155,67,188,35,231,225,187,97,104,253,188,34,106,41,189,189,7,128,188,133,154,60,189,80,184,234,60,14,188,177,189,13,103,4,189,214,187,91,189,93,192,108,188,102,112,143,189,112,142,177,189,195,43,57,189,107,17,47,61,7,99,255,60,59,112,167,61,255,32,49,60,55,168,130,61,99,235,125,61,32,200,234,60,11,92,193,60,133,188,137,61,237,17,5,189,28,162,25,188,28,73,169,61,168,250,183,188,133,243,81,61,65,145,152,188,79,170,161,60,146,99,163,188,94,150,220,189,166,68,2,61,77,75,84,59,172,122,175,188,99,85,46,189,168,1,67,61,19,109,47,61,64,217,102,61,140,66,153,188,162,241,98,61,85,65,249,188,190,110,110,60,60,201,135,189,194,92,111,189,102,45,25,189,57,117,199,189,151,230,3,189,225,51,102,189,113,156,212,189,107,142,151,61,240,216,137,59,55,120,5,61,20,115,12,59,181,203,81,61,145,201,80,188,16,92,195,60,173,192,129,61,17,232,161,189,102,136,171,61,0,197,161,189,110,75,133,189,43,172,204,188,120,218,133,61,20,162,34,61,180,132,72,61,39,159,63,188,160,11,35,189,41,191,104,61,252,180,114,61,136,1,63,188,41,139,162,189,21,102,44,189,120,143,90,60,86,94,185,61,31,210,206,61,24,201,34,189,210,245,74,60,186,162,153,189,17,186,21,189,202,48,48,189,228,194,188,61,136,12,243,57,55,144,233,60,105,136,175,60,65,121,6,57,106,231,235,60,66,52,175,189,37,51,70,189,195,156,166,61,160,201,107,189,68,167,103,60,150,99,13,61,46,145,135,189,199,28,250,188,217,158,242,60,193,60,151,189,96,18,58,60,208,109,88,61,77,75,159,189,26,165,172,188,136,194,97,189,162,248,9,190,0,59,248,60,191,170,137,61,6,185,126,189,182,170,110,189,102,24,128,61,190,56,237,60,156,80,136,188,99,73,20,189,236,19,132,188,37,126,191,186,81,127,15,62,151,212,18,188,77,33,5,189,184,236,93,59,160,134,45,59,88,157,9,61,30,151,197,188,236,63,45,189,120,113,218,61,42,78,213,192,11,181,150,62,143,85,202,189,106,161,4,190,65,73,161,61,240,105,198,62,33,231,133,62,9,113,21,62,101,252,123,61,60,75,168,62,124,153,104,62,218,31,136,189,212,155,177,189,58,205,66,61,223,140,218,61,226,57,27,61,170,69,228,61,23,239,199,188,175,10,156,62,229,100,130,62,20,203,141,189,93,24,169,61,83,203,22,62,123,104,167,62,25,118,24,62,204,98,98,61,123,49,180,189,42,0,134,62,118,226,18,62,215,164,219,60,217,237,115,62,46,173,70,62,210,197,102,61,197,203,211,188,39,21,13,189,224,99,32,190,34,25,82,62,212,73,182,61,157,42,15,190,223,25,205,189,161,243,26,189,193,115,239,188,209,231,99,189,14,47,8,61,44,68,135,188,72,248,30,62,37,64,125,62,145,95,255,189,194,77,70,189,90,217,126,189,214,84,70,62,126,225,149,59,1,165,97,61,2,159,191,61,178,188,43,62,91,154,43,62,176,201,154,60,152,108,92,62,109,26,251,61,141,98,185,61,29,170,137,189,162,210,72,189,243,2,204,189,120,155,119,62,67,87,194,189,91,122,52,190,129,92,226,58,74,179,9,190,176,229,213,61,143,168,80,61,214,57,166,61,134,198,147,61,138,33,249,61,73,16,46,59,12,144,152,190,8,203,8,190,112,65,118,189,129,120,189,189,246,152,72,189,129,147,173,189,5,111,56,190,140,16,30,189,36,181,176,61,5,222,9,190,93,165,219,189,81,20,8,62,14,244,16,62,68,105,127,62,73,102,5,62,146,3,246,188,44,240,149,61,141,156,5,188,86,70,163,60,40,209,146,61,82,73,157,57,229,242,159,188,161,248,177,188,71,232,39,189,178,217,177,189,44,157,143,61,54,203,117,62,245,219,135,62,223,250,48,61,144,193,42,62,182,75,187,61,14,131,121,61,244,111,23,189,193,116,186,189,117,148,163,61,69,14,97,62,126,229,33,62,42,254,15,190,140,49,48,189,49,152,255,61,2,213,191,61,183,94,211,61,64,76,194,61,174,242,164,61,29,4,13,62,106,107,36,62,228,74,45,190,244,24,101,60,213,119,158,62,195,46,138,187,140,74,106,189,207,18,132,189,20,117,102,60,44,214,184,62,16,174,128,62,106,218,165,189,60,249,52,189,81,164,123,61,210,28,25,189,142,90,161,189,8,229,253,60,162,207,135,61,125,89,26,61,22,251,27,62,76,196,187,189,151,198,143,61,165,21,95,62,222,60,21,61,28,152,156,189,91,238,204,59,10,101,193,189,126,139,30,62,48,186,188,188,37,176,73,190,91,121,201,188,135,191,54,62,141,94,77,189,49,35,60,189,14,248,124,186,29,118,223,61,131,23,61,61,173,50,35,190,249,192,14,188,135,49,41,61,146,235,198,61,21,86,106,189,123,76,132,189,175,8,158,61,31,101,52,62,72,164,13,62,130,169,134,61,7,240,214,189,58,232,146,60,110,134,11,62,138,5,62,188,105,138,64,61,102,247,164,61,30,136,140,61,191,98,173,61,28,97,17,189,214,2,187,189,149,158,41,189,186,188,121,61,61,183,208,189,226,146,163,189,182,20,176,189,254,215,185,188,228,103,163,61,199,213,200,189,101,167,95,189,165,104,37,61,172,1,154,62,129,176,3,62,146,61,194,61,216,45,66,61,160,137,208,61,141,67,125,61,69,13,38,190,87,118,81,190,45,9,16,189,5,197,207,61,181,82,136,188,181,84,222,188,14,158,9,190,205,62,15,188,234,146,209,61,13,56,235,61,222,1,30,60,88,169,128,61,255,8,115,62,9,223,43,62,188,91,89,61,173,78,78,188,113,198,48,61,124,15,23,59,63,31,133,61,4,116,31,189,160,193,166,188,206,255,27,62,141,12,50,61,91,125,245,188,62,234,47,189,204,10,5,61,112,67,140,61,21,0,227,189,124,127,227,189,197,85,229,61,100,202,7,187,112,65,182,187,27,213,169,61,106,106,217,59,82,127,221,189,41,151,198,60,10,20,177,189,244,112,66,190,98,75,143,188,11,13,68,62,173,193,251,187,5,220,3,190,183,183,27,189,159,142,7,190,179,67,188,61,168,55,163,61,54,148,218,189,47,223,250,187,206,227,48,62,67,169,61,60,78,236,33,60,44,131,170,61,21,56,217,188,221,6,21,62,65,158,29,62,190,106,5,190,142,30,223,189,157,244,254,61,54,204,80,187,20,203,205,189,57,39,118,60,110,219,119,189,239,89,215,60,150,150,177,189,123,17,45,190,242,180,156,61,232,244,92,62,210,255,50,61,41,205,6,190,81,49,78,188,182,15,57,189,238,9,242,189,79,87,119,190,219,78,43,190,111,183,164,188,250,40,163,188,173,138,208,189,38,85,219,189,198,20,44,188,233,16,56,61,121,59,66,62,113,84,94,62,172,196,60,189,5,78,54,61,90,130,76,62,238,120,19,189,82,128,24,190,238,206,90,60,190,80,160,189,96,116,249,60,225,155,102,61,208,152,201,188,88,113,170,61,245,215,203,61,115,131,33,189,143,54,14,190,89,162,179,59,78,151,197,188,216,214,15,190,195,242,135,189,31,187,139,188,65,183,23,60,154,149,109,189,121,91,233,188,196,90,124,189,244,51,245,59,193,27,34,190,177,77,26,190,63,169,54,189,174,73,215,189,252,113,59,189,207,219,216,187,91,10,200,188,131,19,241,189,41,118,244,189,225,41,52,190,157,132,146,189,110,196,243,61,195,17,228,61,167,116,48,61,197,231,14,61,91,120,190,61,187,123,0,60,181,250,106,61,92,228,222,189,67,198,163,189,132,128,108,62,245,132,165,60,171,236,59,60,6,128,202,61,158,123,207,61,115,133,247,188,124,154,147,188,204,236,115,189,215,104,217,189,83,32,179,60,158,98,21,189,199,241,163,61,162,156,40,61,146,36,168,189,84,26,241,61,236,161,253,60,43,79,96,189,171,61,172,189,151,60,62,190,244,26,123,189,54,3,28,189,93,197,226,189,82,44,135,190,200,7,157,61,95,236,157,189,140,242,12,190,1,104,20,61,92,85,142,62,40,153,156,60,190,165,220,61,134,117,19,62,108,118,164,61,102,50,92,62,250,99,106,62,142,234,148,61,115,71,159,61,164,26,246,61,120,67,154,61,150,120,128,61,191,213,250,61,157,188,72,189,177,222,40,62,75,89,38,62,145,241,40,61,220,13,34,60,134,89,200,189,228,131,30,189,30,163,188,188,12,205,245,189,167,62,80,62,248,111,126,62,203,103,25,62,37,150,20,189,99,154,169,189,192,5,185,189,255,90,222,188,214,2,155,189,172,255,163,190,111,18,3,186,38,198,18,190,23,71,133,189,39,108,63,190,24,122,4,62,96,115,238,61,77,15,58,62,198,134,46,62,8,116,214,62,5,139,235,62,55,221,170,62,32,12,108,62,0,225,67,61,175,33,56,189,172,112,139,189,21,139,15,62,58,150,55,189,215,52,175,61,186,103,189,61,1,190,219,189,91,206,5,190,141,150,83,190,238,179,234,61,186,191,162,190,126,1,157,189,235,110,30,61,236,219,89,62,42,142,131,188,8,144,1,190,72,135,39,190,156,50,87,62,142,145,204,61,23,102,1,190,125,151,242,61,232,45,158,60,141,9,177,188,69,161,197,189,30,252,228,189,253,76,77,190,82,72,18,62,8,85,106,62,196,233,180,190,92,115,55,190,170,70,239,61,34,57,129,62,56,245,1,189,118,166,64,190,95,208,34,190,88,230,197,62,73,128,250,61,143,251,86,62,98,189,201,62,200,210,183,62,179,124,133,62,76,108,46,62,169,46,96,60,176,4,18,190,92,31,214,188,241,155,66,188,167,33,26,190,204,41,65,61,82,67,219,189,34,226,22,190,140,49,64,190,221,125,62,190,137,10,85,190,36,124,111,61,168,142,149,189,188,59,114,190,228,103,163,189,166,185,21,190,194,223,111,189,91,150,207,189,151,2,146,189,53,153,145,189,59,115,239,61,99,237,111,62,102,18,157,62,159,203,164,62,143,194,117,62,221,9,150,61,67,113,71,188,125,234,216,60,52,130,77,61,50,29,42,62,46,115,106,62,25,144,125,61,13,55,32,62,11,239,82,62,226,34,247,61,80,252,24,61,201,233,43,62,219,135,148,62,52,128,215,62,109,116,78,188,40,101,66,62,148,221,156,62,201,114,242,61,226,200,195,189,123,49,148,189,8,173,7,190,39,164,101,190,166,11,1,190,182,18,186,60,143,109,145,62,77,104,82,61,235,1,115,186,29,148,112,189,128,181,170,189,227,164,16,190,114,20,64,190,118,136,79,190,119,77,72,61,237,131,124,62,222,59,226,62,166,94,175,62,73,44,137,61,239,115,92,62,36,181,64,62,145,242,147,189,45,35,85,190,154,93,247,188,152,106,54,62,204,69,12,62,239,168,49,189,193,113,57,190,129,9,188,61,53,238,237,61,6,187,1,190,182,243,197,190,31,128,188,62,230,205,137,62,93,79,180,189,54,30,236,188,86,98,190,61,68,107,197,60,240,223,60,61,134,255,52,62,0,28,11,62,104,232,255,61,128,40,72,62,231,113,24,189,239,58,43,62,247,120,65,62,45,64,91,61,34,81,136,189,40,238,8,62,98,132,144,189,238,91,237,61,236,23,28,62,7,154,239,189,15,126,226,189,22,77,55,190,217,118,218,60,234,236,164,61,164,197,153,61,102,46,144,189,56,192,76,60,173,252,178,60,75,30,15,190,73,99,180,188,117,57,197,189,154,6,133,189,52,129,2,190,144,50,98,188,65,212,221,189,45,9,32,62,188,118,25,62,145,123,58,188,90,41,132,61,187,241,238,60,73,103,224,60,67,199,142,61,181,108,29,62,47,135,29,61,74,64,108,62,81,247,129,62,87,205,115,61,127,137,56,189,98,188,102,60,115,158,145,61,58,203,140,61,103,96,196,61,93,26,191,59,66,93,20,62,163,234,215,60,132,243,137,189,174,215,52,189,204,123,252,189,101,28,163,188,158,66,174,59,114,168,223,61,222,199,81,187,128,11,178,188,0,111,17,62,138,6,137,189,67,231,245,189,149,42,65,190,92,87,76,60,216,125,71,189,195,154,74,188,141,67,61,190,30,163,44,62,251,201,136,62,131,107,110,61,64,163,52,189,76,55,9,61,233,215,54,62,79,30,214,61,74,182,250,61,215,51,164,61,102,103,49,62,215,217,152,62,34,109,131,61,208,182,90,61,114,134,50,62,18,135,108,62,206,170,239,61,88,59,42,62,108,63,105,62,49,9,247,61,232,50,53,62,181,169,58,188,0,30,177,189,229,126,7,188,97,195,83,61,195,12,29,190,17,255,112,189,223,22,108,189,37,59,118,189,220,217,215,60,86,154,36,190,189,54,27,189,148,246,70,189,36,38,40,61,58,36,181,188,74,65,119,61,99,155,84,61,142,143,38,62,237,215,13,62,201,142,77,189,142,147,194,187,66,6,146,61,30,192,2,62,83,90,127,61,152,221,19,62,79,175,148,61,207,50,75,62,213,32,124,62,117,31,160,189,242,37,20,189,73,131,155,61,1,219,65,61,187,214,94,188,137,152,178,61,83,5,163,60,56,48,185,60,123,189,123,188,201,115,189,189,199,41,154,61,4,86,238,189,23,217,78,61,167,205,56,61,138,144,42,62,2,155,147,61,149,71,119,61,176,232,6,62,145,240,45,190,144,47,33,189,174,128,66,189,46,2,35,189,42,55,81,190,43,217,177,60,181,140,4,62,0,115,173,188,247,147,49,62,114,252,144,189,24,11,131,189,27,185,142,61,86,70,131,189,206,80,252,189,185,79,142,188,187,213,83,190,46,227,134,61,8,227,231,61,86,102,202,60,59,27,146,189,108,36,137,189,250,69,201,189,223,223,128,189,0,82,155,61,97,27,113,60,157,190,158,60,63,226,7,62,115,241,151,189,169,105,183,189,76,168,160,189,75,58,74,190,61,213,49,190,70,97,87,61,225,179,53,61,97,140,232,61,44,182,201,61,226,120,158,61,182,157,54,188,25,55,69,190,166,97,40,190,131,165,58,61,194,162,82,62,79,120,73,61,241,130,168,189,105,28,10,62,115,243,61,62,155,58,15,61,102,220,244,189,75,35,230,189,213,180,235,189,37,91,93,189,67,58,60,190,229,242,159,189,141,69,67,62,178,161,187,61,78,126,139,59,44,125,40,189,36,182,123,189,126,253,16,190,3,124,71,190,14,17,247,189,93,55,165,60,183,155,224,61,246,7,138,61,206,168,121,188,109,226,116,190,245,130,135,190,199,158,61,190,186,187,78,61,21,86,170,60,24,35,18,61,219,24,187,60,160,55,85,189,11,10,3,190,60,134,231,189,226,229,105,190,104,61,132,190,193,224,90,189,48,132,156,61,255,178,123,61,111,45,115,62,248,27,109,59,179,210,100,189,184,92,221,189,74,13,237,188,86,183,58,61,57,99,88,61,146,206,192,186,151,253,186,60,110,250,115,61,101,223,213,189,163,61,158,189,152,247,88,190,250,42,89,190,114,251,229,60,38,85,155,61,45,62,133,60,156,195,37,62,87,180,9,62,27,100,18,60,164,198,68,189,31,248,152,61,15,123,161,59,245,19,206,188,195,128,69,62,69,100,152,61,31,18,158,62,167,232,136,62,32,240,192,61,149,16,172,187,47,51,44,61,159,173,3,189,208,100,127,60,12,120,129,62,94,130,51,62,1,136,187,60,44,68,167,61,50,115,129,61,110,135,38,62,156,23,71,62,220,128,111,62,35,75,134,62,148,106,63,62,156,49,172,61,115,161,146,190,150,37,90,190,195,40,72,189,47,167,84,190,150,33,46,190,28,64,63,60,196,96,190,189,177,105,69,190,233,12,140,190,25,114,108,62,25,145,136,62,17,27,164,62,179,36,152,62,206,84,12,63,189,30,156,62,26,223,7,62,221,68,125,62,116,150,89,62,97,254,138,190,249,131,17,190,191,41,44,187,254,38,244,189,213,118,3,62,56,246,204,61,162,122,107,189,193,167,249,189,170,98,106,190,162,37,79,62,238,177,204,190,113,30,190,190,170,69,196,189,89,78,130,189,125,63,37,190,252,82,159,190,162,239,150,190,212,238,119,62,117,34,65,60,199,187,195,61,188,33,165,62,242,7,3,63,135,80,165,62,124,99,160,62,175,125,49,62,175,151,38,59,83,35,244,188,187,71,166,62,193,255,166,190,45,92,174,190,95,155,13,190,228,46,66,187,74,152,233,189,10,47,193,190,137,152,226,190,114,139,89,62,54,63,254,187,67,169,61,188,184,200,45,62,124,12,158,62,112,123,162,62,119,21,10,63,169,106,170,62,233,211,106,61,245,161,139,189,59,226,208,61,146,179,136,62,133,153,86,62,62,34,182,62,34,171,187,61,223,82,46,62,92,56,0,62,234,93,140,62,20,209,143,61,213,4,209,60,45,148,76,61,224,45,16,186,128,14,51,61,75,63,17,190,9,193,170,60,231,252,4,62,129,95,131,62,27,18,215,61,46,230,23,62,67,199,46,62,51,221,235,60,182,160,151,61,13,226,35,62,30,110,207,62,114,24,124,62,81,78,180,62,126,1,45,62,233,152,99,62,140,100,135,62,44,14,135,61,192,235,179,60,164,197,153,189,214,173,190,61,0,202,223,60,53,121,202,61,83,202,107,61,228,106,164,189,7,121,61,62,135,251,160,62,68,222,170,62,49,209,0,62,160,255,150,62,14,162,197,62,132,215,94,62,225,235,59,190,139,167,142,190,61,124,25,187,222,232,227,188,7,125,9,190,83,231,169,190,242,235,7,188,105,27,255,61,29,1,92,61,170,239,188,190,60,162,194,189,249,103,86,62,18,247,216,62,84,87,190,62,172,230,217,61,12,35,189,62,157,161,248,62,244,191,108,62,113,3,14,190,100,203,178,190,173,135,143,189,137,126,237,60,161,45,167,189,119,191,202,190,97,80,22,190,127,21,224,188,195,213,129,61,6,131,139,190,239,202,110,61,120,41,173,62,207,217,226,61,35,159,87,189,218,117,111,190,161,218,224,188,109,114,248,60,68,78,31,62,217,39,192,189,12,92,158,60,14,17,247,61,31,45,206,59,11,66,217,189,1,246,113,190,190,80,16,190,121,92,180,189,53,238,205,188,128,101,85,190,146,233,208,188,17,167,19,62,204,13,70,189,7,98,217,189,210,56,156,190,231,197,233,189,207,74,186,61,213,203,167,62,153,215,17,61,52,15,192,189,102,188,45,59,220,47,47,190,106,165,64,190,202,196,93,190,147,30,86,190,162,212,94,189,37,235,32,62,0,254,105,189,49,93,136,61,104,66,19,60,229,183,40,61,188,33,13,61,40,68,160,189,195,101,85,61,144,46,182,188,86,45,137,61,83,174,240,189,181,194,148,189,75,6,128,61,0,227,25,61,66,179,107,189,133,237,159,190,237,185,12,61,134,57,1,189,86,42,40,59,29,90,84,190,11,179,144,189,25,229,153,188,239,143,55,189,208,241,81,188,169,77,156,189,105,30,160,61,179,153,195,60,151,198,239,61,182,157,182,60,171,90,82,190,115,133,119,189,87,176,141,188,208,43,158,187,213,94,164,190,195,187,188,189,140,19,31,61,164,228,149,61,65,68,138,189,145,66,217,60,90,18,48,62,200,211,178,61,161,74,13,61,232,160,11,189,168,29,30,62,18,159,123,189,77,161,243,59,64,133,227,189,17,143,196,189,60,132,113,60,241,127,7,190,163,205,241,188,151,197,68,190,237,17,202,61,18,21,170,60,152,76,53,62,210,29,132,189,85,249,94,189,88,88,112,189,34,136,243,186,220,159,43,62,176,230,128,60,134,145,94,61,198,250,134,60,169,218,62,62,164,196,46,188,184,4,96,61,168,200,1,62,40,73,87,60,254,10,185,61,137,208,8,190,99,152,147,188,40,72,28,190,101,25,226,60,95,7,14,190,28,236,77,189,197,229,56,61,61,41,243,189,238,36,194,61,165,160,43,190,162,153,199,61,49,154,21,188,212,183,76,62,93,253,88,189,156,253,33,62,136,218,54,62,100,93,220,189,29,115,30,60,241,45,172,189,147,229,36,189,241,155,82,190,132,184,210,61,17,224,100,62,38,229,46,61,75,201,242,61,208,70,174,188,101,82,227,61,10,216,30,190,185,226,226,60,54,145,25,190,49,40,83,61,252,81,4,190,71,176,49,62,162,126,151,61,3,149,65,190,253,103,13,189,240,109,218,189,36,9,66,188,63,30,74,190,205,173,96,62,255,151,59,62,203,243,96,189,21,111,20,62,218,146,21,61,125,236,174,189,83,145,106,190,183,40,19,190,213,177,74,189,170,100,32,62,51,25,14,188,84,170,132,189,249,163,168,61,78,43,21,62,65,215,62,59,246,41,87,190,27,185,238,189,73,157,160,61,181,53,98,62,185,110,138,189,72,27,71,61,88,230,173,61,234,148,135,189,68,110,230,189,80,254,94,190,41,63,169,189,206,167,142,188,151,202,107,62,131,221,144,189,72,81,135,61,18,108,92,62,195,186,145,61,102,160,178,189,177,22,79,190,183,67,67,188,41,231,203,61,192,232,50,62,43,193,130,189,175,235,247,189,145,99,107,60,222,228,7,62,91,206,165,187,255,121,122,190,113,1,56,190,45,236,9,190,183,95,190,60,51,192,69,190,18,165,157,189,32,96,173,188,125,4,254,186,237,186,39,190,21,57,228,189,35,105,87,190,120,94,42,190,54,90,14,61,9,110,36,60,72,139,179,188,237,74,139,61,245,244,177,189,218,228,128,190,163,202,136,190,235,30,25,61,56,245,129,59,191,129,9,61,100,36,27,190,65,97,208,60,219,247,168,188,175,237,157,190,112,176,175,190,98,244,188,189,79,33,215,188,198,51,232,188,124,154,19,61,95,13,16,61,201,147,4,62,157,70,250,61,127,75,128,60,6,157,144,189,169,49,193,189,216,71,135,189,166,70,40,189,43,247,34,62,126,225,149,61,192,94,225,61,135,168,50,62,164,226,159,61,112,207,115,188,249,248,4,60,144,106,88,60,234,90,155,61,173,76,72,62,51,112,128,61,254,43,139,61,174,154,103,61,15,154,29,190,166,38,17,190,24,149,148,189,106,79,9,61,65,14,202,188,246,182,9,62,153,242,161,61,122,196,8,62,196,148,104,62,251,229,147,60,15,123,161,59,206,56,45,62,105,110,133,61,159,200,147,61,71,202,6,62,130,58,197,61,24,93,94,61,191,156,217,61,47,196,234,61,50,202,243,61,38,228,3,63,7,94,125,62,201,233,75,62,65,11,89,62,144,158,2,62,210,224,150,190,63,145,71,190,56,192,76,189,193,225,229,189,35,18,5,188,11,96,202,187,3,178,23,61,148,21,227,189,30,253,127,190,169,23,28,62,125,64,112,62,41,5,29,62,57,213,178,62,77,220,46,63,57,242,32,62,54,174,255,61,209,7,203,61,209,231,131,61,146,92,126,190,254,12,31,190,85,18,217,188,55,26,192,188,180,233,72,61,224,218,233,189,9,196,235,59,157,17,53,190,114,252,192,190,49,121,187,62,171,65,56,190,123,18,24,190,92,4,198,59,16,33,46,62,248,109,200,61,92,62,210,189,21,87,133,190,65,215,126,62,60,161,23,61,46,228,241,189,189,26,160,61,195,212,70,62,94,102,88,62,182,186,188,62,233,240,184,62,33,34,5,62,220,215,193,61,127,218,104,62,214,84,54,190,211,18,235,189,129,152,4,188,60,160,108,62,36,9,66,188,181,136,200,189,175,205,166,190,187,72,17,62,50,57,245,61,14,245,107,190,95,121,240,189,12,201,233,189,45,64,27,61,54,90,238,61,8,6,96,62,143,168,208,189,159,146,115,61,247,59,244,61,221,40,50,60,171,208,0,189,77,102,60,61,98,158,245,61,69,42,140,62,36,151,159,62,221,9,134,62,3,124,71,62,17,254,173,62,30,50,117,62,213,91,131,61,45,235,158,61,106,190,202,61,148,250,18,62,79,8,61,62,241,160,25,61,230,231,102,62,25,230,196,61,41,232,22,190,45,210,84,190,145,239,50,190,196,237,176,189,166,129,31,189,39,104,35,62,75,59,181,189,85,161,129,186,216,127,221,61,68,23,212,188,142,234,148,189,169,247,212,60,179,235,222,187,158,237,177,189,177,249,56,188,149,212,137,190,152,221,211,189,208,208,255,189,170,67,238,189,161,218,16,62,171,207,85,62,54,33,45,61,137,178,135,62,164,55,4,63,45,208,94,62,163,92,154,188,135,108,160,190,90,103,44,190,87,10,65,61,148,77,185,61,22,250,224,189,171,176,153,188,157,185,87,62,126,2,144,62,122,140,50,189,186,221,11,189,129,122,115,190,73,20,10,190,235,112,148,189,89,165,212,189,34,26,29,61,79,3,158,62,87,147,23,62,9,223,59,189,127,217,253,189,175,235,87,190,144,16,133,189,179,183,20,189,1,105,63,189,246,8,181,188,53,38,196,61,228,159,209,62,104,92,120,61,123,133,133,189,153,73,84,61,105,56,229,60,17,111,29,188,64,252,12,190,33,149,194,189,67,4,156,188,93,136,53,62,54,228,31,60,227,168,188,189,129,235,138,188,153,18,9,190,182,134,242,189,84,59,3,189,207,158,203,187,213,35,173,189,58,3,131,61,158,209,150,189,248,166,41,62,241,47,226,61,181,194,52,61,22,190,62,61,182,72,90,61,81,48,99,189,11,38,126,60,214,111,190,62,38,172,109,62,26,162,138,188,241,242,212,61,158,235,187,189,130,143,193,59,79,30,86,62,30,54,33,62,226,0,250,60,249,47,128,62,90,69,127,61,182,103,22,61,126,229,193,61,80,197,141,60,198,54,41,188,11,209,161,189,79,120,137,60,82,68,230,189,193,28,125,61,146,65,46,61,153,215,1,190,47,110,35,188,44,125,104,189,24,39,62,61,149,98,71,190,157,190,14,190,210,139,26,189,222,199,33,62,202,53,133,188,78,156,252,61,181,24,108,62,49,153,170,61,132,72,134,188,135,252,115,61,213,91,131,188,144,164,132,189,253,130,109,62,90,99,32,62,212,186,13,61,130,31,21,62,235,57,41,61,146,116,13,61,213,145,163,60,51,168,182,189,84,25,70,188,111,159,157,62,141,122,88,62,164,139,205,188,150,206,23,190,61,125,4,190,42,31,130,61,187,127,140,189,167,36,139,189,54,201,15,189,88,228,87,62,209,174,130,61,105,138,128,61,185,23,184,189,98,76,250,188,243,85,114,60,29,146,90,189,12,231,26,189,255,91,73,190,210,109,9,60,128,70,169,189,70,125,18,62,77,134,131,61,174,240,142,61,253,159,67,62,60,80,199,61,57,240,234,188,226,57,155,61,185,85,160,62,153,158,176,61,94,160,84,62,46,228,145,60,178,161,251,61,223,249,101,62,177,107,43,62,97,168,195,188,39,74,66,61,178,44,176,62,58,64,64,62,252,113,11,62,196,35,17,62,13,169,130,61,61,70,57,61,124,101,158,189,176,3,103,187,130,0,41,190,165,216,209,188,158,7,151,189,178,98,40,62,52,128,55,60,195,101,21,190,201,255,228,188,21,230,125,189,235,82,35,189,156,51,18,190,193,170,26,62,115,159,28,189,233,181,89,61,231,0,161,61,192,64,176,61,180,3,206,61,126,30,3,62,152,107,145,189,246,181,238,189,155,114,85,62,142,63,81,61,221,95,157,61,13,251,189,60,169,161,173,189,216,42,65,188,184,90,23,62,143,224,70,189,46,85,233,189,149,15,145,62,52,132,67,62,41,8,190,61,226,61,7,61,165,216,17,190,71,230,17,190,146,204,202,189,150,4,40,189,28,37,47,189,145,44,80,62,154,8,91,189,202,196,45,61,232,47,100,62,29,4,157,188,74,95,8,190,47,108,141,190,86,16,3,189,189,53,240,61,72,24,54,62,64,166,117,189,129,152,132,189,171,178,239,189,172,54,31,190,233,214,203,189,86,15,40,62,54,148,218,188,117,31,192,189,149,186,116,62,73,48,213,187,102,73,0,60,29,204,134,61,202,135,80,190,196,177,206,189,51,194,91,189,146,232,5,190,221,66,215,60,136,245,6,62,122,28,6,61,12,61,2,62,68,253,238,61,42,253,36,190,104,62,143,190,165,73,129,190,76,226,44,187,163,91,47,61,127,50,198,61,58,122,252,189,69,212,132,61,115,75,43,188,196,8,97,190,48,19,117,190,69,188,213,189,122,168,109,189,229,122,91,189,41,206,209,60,44,17,168,59,244,167,205,189,130,60,59,189,131,21,71,190,23,102,1,190,13,26,250,188,137,149,81,61,91,36,93,62,38,138,48,62,27,13,96,189,121,117,62,190,52,133,142,190,117,87,70,190,13,27,37,189,231,198,116,59,124,155,254,187,238,10,253,61,73,190,66,62,84,87,158,189,252,112,240,61,120,13,90,62,189,58,71,60,106,250,236,56,67,229,223,60,218,170,36,61,62,94,8,61,91,180,96,62,28,152,60,62,100,201,132,62,101,86,159,62,103,14,169,61,147,24,68,189,24,153,160,189,254,15,48,60,173,52,169,61,108,181,159,62,103,126,157,62,99,42,125,59,138,89,175,60,166,43,216,188,117,85,160,188,149,155,168,60,34,28,115,189,34,110,206,60,155,203,133,62,113,198,176,61,140,15,19,62,195,187,220,61,36,151,127,59,37,235,64,190,60,244,29,189,31,46,217,189,95,40,0,190,241,45,44,188,32,69,93,61,237,240,119,62,3,237,142,62,23,184,92,62,84,169,177,62,225,183,225,62,158,38,115,62,17,198,111,62,88,113,154,62,185,251,44,62,205,91,85,190,113,228,1,190,143,25,40,60,73,216,247,61,9,249,128,189,37,119,88,189,93,50,78,61,36,71,122,189,84,112,136,190,85,132,219,61,24,150,15,62,174,100,143,62,48,102,147,62,207,19,191,62,251,59,27,62,45,181,94,60,21,200,236,61,242,119,111,60,75,60,144,190,161,76,115,190,155,61,240,189,57,155,14,184,79,5,12,190,80,252,72,190,83,5,195,189,68,81,0,190,95,67,128,190,191,124,114,62,128,14,147,189,195,70,25,189,210,140,69,61,59,168,164,62,126,81,130,61,112,237,196,60,84,168,238,188,207,134,108,62,126,114,36,62,61,15,30,190,170,102,86,188,209,177,163,189,225,237,193,61,138,61,36,62,147,144,56,62,1,193,92,61,188,90,206,61,113,199,147,62,43,110,28,61,120,13,58,62,194,49,107,62,112,93,225,62,98,216,129,61,189,141,205,59,20,237,170,60,110,105,173,62,106,50,131,62,204,236,51,189,155,200,236,61,180,1,88,59,226,35,50,62,22,163,174,60,130,172,39,189,159,146,243,189,211,193,58,62,137,149,113,62,217,10,90,189,220,160,118,188,249,246,206,189,36,66,195,61,197,89,81,61,7,183,37,62,66,150,5,61,235,82,35,62,88,57,148,61,114,135,205,60,42,139,194,60,20,206,238,60,162,39,37,62,156,21,241,189,4,61,20,189,212,16,53,190,231,228,37,190,160,250,103,62,244,106,160,189,155,115,48,61,115,16,244,189,238,178,95,61,116,152,207,189,18,46,132,189,129,36,236,189,1,106,10,62,192,5,153,62,174,211,200,61,7,38,183,61,101,169,245,187,173,20,226,61,79,32,236,188,41,174,170,60,203,191,22,189,190,107,0,62,44,183,68,62,223,107,72,189,125,62,74,59,92,255,46,188,68,251,152,61,252,57,133,188,174,188,196,61,136,218,118,61,231,115,238,187,116,122,14,62,246,35,165,189,62,7,22,61,45,63,176,61,129,37,7,62,39,135,175,61,11,68,207,60,47,133,103,62,231,110,71,62,145,210,44,61,98,162,33,190,89,22,140,189,69,216,16,190,195,185,230,189,204,69,156,189,112,124,141,189,229,38,234,189,255,231,208,189,154,93,7,62,81,77,137,189,165,103,218,61,56,189,75,62,27,188,47,62,45,64,43,62,120,40,10,189,77,45,219,188,125,65,171,61,200,11,25,62,109,111,55,187,61,185,166,185,168,143,64,60,208,240,134,61,61,10,183,189,219,51,75,189,10,248,101,62,194,190,93,62,177,251,14,189,67,60,146,188,215,132,180,189,56,190,246,59,209,8,118,62,149,14,150,61,14,77,89,60,223,135,51,62,149,243,69,60,103,127,192,61,91,97,122,60,251,201,216,61,220,41,221,61,143,84,159,61,174,242,196,189,255,8,163,189,114,22,54,62,53,207,17,62,97,140,8,61,229,242,159,189],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+92160);allocate([74,38,167,189,187,123,64,189,87,206,14,62,119,17,166,60,214,59,252,189,183,121,51,62,3,124,215,61,196,208,106,61,158,179,165,61,144,162,78,188,103,210,198,189,19,15,168,61,10,19,198,189,3,233,130,189,174,186,78,62,243,61,3,62,163,145,15,189,117,0,4,189,118,140,139,189,216,100,237,189,78,185,194,61,112,36,176,189,252,83,138,189,243,29,252,60,5,253,5,61,154,36,182,61,109,143,94,61,114,23,33,189,94,132,233,189,201,202,47,62,141,8,230,189,152,222,94,190,61,128,133,61,100,172,118,61,67,201,68,62,219,167,99,61,234,64,6,190,87,205,19,190,183,93,104,61,237,40,14,189,74,38,167,189,143,139,10,190,216,244,32,186,37,144,178,61,143,111,111,60,4,171,138,61,13,140,220,61,223,50,103,62,118,197,172,61,34,252,11,188,231,141,83,61,147,30,70,189,54,148,26,189,13,171,120,189,187,238,45,59,69,187,138,60,167,59,175,61,165,192,130,188,162,209,157,188,27,241,228,61,250,125,127,61,18,222,78,62,181,110,67,61,223,25,45,61,67,199,142,61,47,190,120,62,62,117,172,60,117,30,149,189,126,169,31,190,79,144,216,188,83,231,17,61,10,104,162,189,183,210,235,188,161,244,69,189,161,128,173,61,1,19,120,189,31,133,171,189,71,3,40,190,21,225,38,189,150,147,176,189,55,51,122,60,81,134,170,187,32,98,131,188,143,169,59,61,213,146,78,189,3,8,159,189,216,214,239,61,117,119,29,60,123,49,20,188,159,117,13,188,205,206,98,189,254,15,176,189,117,177,233,60,219,50,96,189,134,31,44,190,36,15,52,62,237,211,145,61,20,91,193,188,95,68,27,61,113,116,149,187,240,106,185,188,27,155,253,61,247,120,193,61,21,87,149,189,115,217,8,190,121,230,101,188,27,46,18,190,2,45,221,188,223,49,76,190,7,98,89,60,206,111,104,62,57,69,71,61,122,23,47,190,166,96,77,189,30,27,1,60,226,117,125,61,119,73,156,60,216,126,50,189,164,55,28,189,174,12,10,62,209,148,93,61,154,66,167,189,5,21,53,62,195,71,68,61,112,94,28,189,134,118,78,61,182,129,219,189,74,153,20,189,239,172,221,60,193,26,167,61,192,207,56,187,188,91,185,61,109,141,8,189,185,0,116,189,115,156,91,60,102,131,204,189,137,67,150,61,35,132,175,62,34,84,201,61,39,136,26,190,230,146,170,188,228,78,105,189,57,125,61,61,212,209,49,189,160,253,24,190,26,52,4,190,184,145,50,188,192,32,105,188,141,68,56,190,157,131,231,189,245,158,74,189,174,43,134,189,244,222,184,61,233,71,67,188,155,232,179,61,177,48,196,61,81,162,21,62,35,19,208,61,17,225,159,61,165,190,172,189,217,205,204,189,15,240,164,188,2,126,77,189,163,115,126,61,156,220,111,60,200,209,156,60,29,174,21,61,36,68,57,62,152,251,100,188,169,189,136,189,85,222,142,186,214,55,144,189,121,144,158,187,222,33,197,186,12,62,13,61,175,33,56,189,31,45,78,189,215,135,181,189,13,250,50,190,102,188,237,189,109,112,82,190,158,96,127,60,242,119,47,189,127,104,198,189,42,142,19,190,210,229,77,189,228,132,73,190,105,138,224,61,98,246,138,62,205,230,49,62,206,83,221,61,5,49,32,62,104,121,254,61,208,38,199,61,240,107,116,62,66,233,171,61,113,114,223,61,135,80,101,62,222,204,136,62,130,86,224,60,94,130,211,60,90,18,0,62,181,249,191,61,48,73,37,61,56,74,30,61,125,145,80,188,64,133,19,62,45,206,88,61,141,183,21,188,97,109,172,61,88,30,36,62,101,111,41,189,33,206,67,60,174,184,248,189,88,140,218,189,145,212,66,189,223,138,68,61,184,172,130,190,181,226,155,189,92,27,202,61,29,119,26,190,27,161,47,190,33,89,32,190,125,236,110,61,42,254,63,62,24,119,211,62,80,228,13,63,129,150,190,62,84,167,115,62,21,31,255,61,81,250,226,61,155,29,41,60,25,170,50,190,6,128,138,189,28,178,1,187,201,87,18,62,10,73,38,61,1,20,163,60,91,176,212,60,47,134,50,189,87,66,247,189,197,171,204,61,36,125,186,61,12,62,125,62,159,32,81,62,197,29,47,189,172,115,140,189,82,183,243,189,25,232,218,60,5,194,14,61,238,149,121,189,12,62,205,188,106,132,190,189,59,226,16,189,87,206,110,190,112,67,76,189,205,92,32,189,115,130,182,188,243,229,133,189,67,5,17,193,0,0,0,0,192,67,0,0,145,2,0,0,146,2,0,0,5,0,0,0,154,0,0,0,11,0,0,0,6,0,0,0,7,0,0,0,155,0,0,0,147,2,0,0,1,0,0,0,20,0,0,0,37,0,0,0,148,2,0,0,8,254,12,0,45,90,5,0,129,90,5,0,230,1,0,0,1,0,0,0,0,0,0,0,200,67,0,0,5,0,0,0,149,2,0,0,150,2,0,0,0,0,0,0,216,67,0,0,151,2,0,0,152,2,0,0,8,0,0,0,156,0,0,0,12,0,0,0,6,0,0,0,9,0,0,0,155,0,0,0,147,2,0,0,2,0,0,0,20,0,0,0,38,0,0,0,153,2,0,0,12,254,12,0,233,90,5,0,129,90,5,0,167,2,0,0,1,0,0,0,16,254,12,0,103,91,5,0,129,90,5,0,123,2,0,0,1,0,0,0,0,0,0,0,232,67,0,0,5,0,0,0,154,2,0,0,155,2,0,0,0,0,0,0,8,68,0,0,5,0,0,0,156,2,0,0,157,2,0,0,0,0,0,0,248,67,0,0,5,0,0,0,158,2,0,0,159,2,0,0,0,0,0,0,24,68,0,0,160,2,0,0,161,2,0,0,10,0,0,0,157,0,0,0,13,0,0,0,6,0,0,0,11,0,0,0,155,0,0,0,147,2,0,0,1,0,0,0,21,0,0,0,39,0,0,0,162,2,0,0,0,0,0,0,40,68,0,0,5,0,0,0,163,2,0,0,164,2,0,0,0,0,0,0,72,68,0,0,5,0,0,0,165,2,0,0,166,2,0,0,0,0,0,0,56,68,0,0,5,0,0,0,167,2,0,0,168,2,0,0,0,0,0,0,88,68,0,0,169,2,0,0,170,2,0,0,59,0,0,0,9,0,0,0,158,0,0,0,14,0,0,0,11,0,0,0,12,0,0,0,22,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,15,0,0,0,159,0,0,0,16,0,0,0,17,0,0,0,160,0,0,0,161,0,0,0,60,254,12,0,64,100,5,0,129,90,5,0,94,5,0,0,1,0,0,0,28,254,12,0,190,95,5,0,129,90,5,0,123,1,0,0,1,0,0,0,20,254,12,0,29,95,5,0,129,90,5,0,108,1,0,0,1,0,0,0,24,254,12,0,88,95,5,0,129,90,5,0,63,0,0,0,1,0,0,0,56,254,12,0,32,99,5,0,129,90,5,0,223,4,0,0,1,0,0,0,0,0,0,0,104,68,0,0,171,2,0,0,172,2,0,0,162,0,0,0,52,254,12,0,177,98,5,0,129,90,5,0,234,3,0,0,1,0,0,0,48,254,12,0,89,98,5,0,129,90,5,0,164,3,0,0,1,0,0,0,32,254,12,0,36,96,5,0,232,91,5,0,17,2,0,0,1,0,0,0,36,254,12,0,158,96,5,0,232,91,5,0,231,1,0,0,1,0,0,0,40,254,12,0,74,97,5,0,232,91,5,0,100,2,0,0,1,0,0,0,44,254,12,0,221,97,5,0,232,91,5,0,61,2,0,0,1,0,0,0,68,254,12,0,94,101,5,0,129,90,5,0,141,5,0,0,1,0,0,0,64,254,12,0,15,101,5,0,129,90,5,0,115,1,0,0,1,0,0,0,72,254,12,0,234,101,5,0,129,90,5,0,128,5,0,0,1,0,0,0,0,0,0,0,120,68,0,0,5,0,0,0,173,2,0,0,174,2,0,0,76,254,12,0,195,103,5,0,129,90,5,0,131,1,0,0,1,0,0,0,0,0,0,0,152,68,0,0,5,0,0,0,175,2,0,0,176,2,0,0,80,254,12,0,178,104,5,0,129,90,5,0,160,6,0,0,1,0,0,0,84,254,12,0,30,105,5,0,129,90,5,0,174,6,0,0,1,0,0,0,88,254,12,0,158,105,5,0,129,90,5,0,191,6,0,0,1,0,0,0,96,254,12,0,73,117,5,0,149,106,5,0,157,3,0,0,1,0,0,0,108,254,12,0,44,119,5,0,149,106,5,0,195,4,0,0,1,0,0,0,0,0,0,0,168,68,0,0,14,0,0,0,177,2,0,0,163,0,0,0,100,254,12,0,26,118,5,0,149,106,5,0,118,4,0,0,1,0,0,0,0,0,0,0,184,68,0,0,178,2,0,0,179,2,0,0,164,0,0,0,104,254,12,0,165,118,5,0,149,106,5,0,194,3,0,0,1,0,0,0,116,254,12,0,15,122,5,0,171,120,5,0,165,4,0,0,1,0,0,0,0,0,0,0,216,68,0,0,57,0,0,0,180,2,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,38,0,0,0,181,2,0,0,18,0,0,0,165,0,0,0,2,0,0,0,2,0,0,0,19,0,0,0,166,0,0,0,20,0,0,0,167,0,0,0,21,0,0,0,168,0,0,0,22,0,0,0,169,0,0,0,3,0,0,0,3,0,0,0,23,0,0,0,170,0,0,0,0,0,0,0,200,68,0,0,5,0,0,0,182,2,0,0,183,2,0,0,112,254,12,0,60,121,5,0,171,120,5,0,75,4,0,0,1,0,0,0,41,92,15,62,41,92,15,62,102,247,228,62,102,247,228,62,102,247,228,62,120,254,12,0,1,123,5,0,150,122,5,0,46,0,0,0,1,0,0,0,124,254,12,0,57,123,5,0,150,122,5,0,113,0,0,0,1,0,0,0,0,0,0,0,8,69,0,0,14,0,0,0,184,2,0,0,171,0,0,0,128,254,12,0,209,123,5,0,137,123,5,0,183,0,0,0,1,0,0,0,132,254,12,0,173,124,5,0,137,123,5,0,191,2,0,0,1,0,0,0,0,0,0,0,40,69,0,0,57,0,0,0,185,2,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,52,0,0,0,172,0,0,0,173,0,0,0,24,0,0,0,174,0,0,0,175,0,0,0,176,0,0,0,25,0,0,0,177,0,0,0,4,0,0,0,4,0,0,0,0,0,0,0,24,69,0,0,5,0,0,0,186,2,0,0,187,2,0,0,136,254,12,0,94,128,5,0,137,123,5,0,203,4,0,0,1,0,0,0,140,254,12,0,15,130,5,0,137,123,5,0,212,5,0,0,1,0,0,0,0,0,0,0,88,69,0,0,188,2,0,0,189,2,0,0,59,0,0,0,178,0,0,0,179,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,180,0,0,0,26,0,0,0,181,0,0,0,27,0,0,0,182,0,0,0,5,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,11,0,0,0,28,0,0,0,183,0,0,0,29,0,0,0,184,0,0,0,12,0,0,0,12,0,0,0,144,254,12,0,95,138,5,0,18,138,5,0,114,3,0,0,1,0,0,0,148,254,12,0,199,138,5,0,18,138,5,0,114,3,0,0,1,0,0,0,152,254,12,0,47,139,5,0,18,138,5,0,114,3,0,0,1,0,0,0,156,254,12,0,159,139,5,0,18,138,5,0,114,3,0,0,1,0,0,0,160,254,12,0,97,140,5,0,18,138,5,0,74,3,0,0,1,0,0,0,0,0,0,0,104,69,0,0,14,0,0,0,190,2,0,0,185,0,0,0,0,0,0,0,120,69,0,0,5,0,0,0,191,2,0,0,192,2,0,0,168,254,12,0,86,143,5,0,135,142,5,0,71,0,0,0,1,0,0,0,164,254,12,0,220,142,5,0,135,142,5,0,93,0,0,0,1,0,0,0,0,0,0,0,136,69,0,0,193,2,0,0,194,2,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,1,0,0,0,1,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,29,0,0,0,12,0,0,0,176,254,12,0,118,145,5,0,200,143,5,0,90,0,0,0,1,0,0,0,172,254,12,0,253,144,5,0,200,143,5,0,98,0,0,0,1,0,0,0,0,0,0,0,152,69,0,0,5,0,0,0,196,2,0,0,197,2,0,0,0,0,0,0,184,69,0,0,198,2,0,0,199,2,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,43,0,0,0,39,0,0,0,40,0,0,0,23,0,0,0,29,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,30,0,0,0,12,0,0,0,0,0,0,0,168,69,0,0,5,0,0,0,200,2,0,0,201,2,0,0,184,254,12,0,230,147,5,0,200,143,5,0,174,6,0,0,1,0,0,0,180,254,12,0,89,147,5,0,200,143,5,0,213,0,0,0,1,0,0,0,188,254,12,0,237,148,5,0,200,143,5,0,207,6,0,0,1,0,0,0,224,254,12,0,25,150,5,0,200,143,5,0,248,0,0,0,1,0,0,0,220,254,12,0,99,149,5,0,0,0,0,0,216,254,12,0,104,149,5,0,200,143,5,0,1,10,0,0,1,0,0,0,212,254,12,0,99,149,5,0,0,0,0,0,20,255,12,0,203,160,5,0,200,143,5,0,226,6,0,0,1,0,0,0,228,254,12,0,25,151,5,0,200,143,5,0,106,6,0,0,1,0,0,0,236,254,12,0,16,152,5,0,200,143,5,0,12,6,0,0,1,0,0,0,232,254,12,0,170,151,5,0,200,143,5,0,217,5,0,0,1,0,0,0,16,255,12,0,117,160,5,0,200,143,5,0,29,3,0,0,1,0,0,0,240,254,12,0,7,153,5,0,200,143,5,0,222,3,0,0,1,0,0,0,244,254,12,0,67,153,5,0,200,143,5,0,199,3,0,0,1,0,0,0,8,255,12,0,202,159,5,0,200,143,5,0,171,5,0,0,1,0,0,0,248,254,12,0,242,155,5,0,200,143,5,0,150,4,0,0,1,0,0,0,0,255,12,0,56,159,5,0,200,143,5,0,32,4,0,0,1,0,0,0,252,254,12,0,94,158,5,0,200,143,5,0,208,1,0,0,1,0,0,0,4,255,12,0,146,159,5,0,200,143,5,0,61,2,0,0,1,0,0,0,12,255,12,0,63,160,5,0,200,143,5,0,248,2,0,0,1,0,0,0,28,255,12,0,132,161,5,0,200,143,5,0,241,6,0,0,1,0,0,0,24,255,12,0,18,161,5,0,200,143,5,0,135,6,0,0,1,0,0,0,32,255,12,0,221,161,5,0,200,143,5,0,35,7,0,0,1,0,0,0,36,255,12,0,63,162,5,0,200,143,5,0,118,7,0,0,1,0,0,0,44,255,12,0,173,162,5,0,200,143,5,0,125,7,0,0,1,0,0,0,40,255,12,0,109,194,6,0,0,0,0,0,52,255,12,0,115,163,5,0,200,143,5,0,147,9,0,0,1,0,0,0,48,255,12,0,109,194,6,0,0,0,0,0,60,255,12,0,19,164,5,0,200,143,5,0,230,9,0,0,1,0,0,0,56,255,12,0,99,149,5,0,0,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,1,0,0,0,64,0,0,0,0,0,0,0,16,71,0,0,202,2,0,0,203,2,0,0,56,0,0,0,248,255,255,255,16,71,0,0,204,2,0,0,205,2,0,0,192,255,255,255,192,255,255,255,16,71,0,0,206,2,0,0,207,2,0,0,92,158,1,0,140,70,0,0,204,70,0,0,224,70,0,0,244,70,0,0,8,71,0,0,180,70,0,0,160,70,0,0,132,158,1,0,112,158,1,0,0,0,0,0,32,71,0,0,5,0,0,0,218,2,0,0,219,2,0,0,96,187,5,0,100,187,5,0,106,187,5,0,113,187,5,0,0,0,0,0,64,255,12,0,243,188,5,0,230,177,5,0,121,0,0,0,1,0,0,0,0,0,0,0,48,71,0,0,5,0,0,0,220,2,0,0,221,2,0,0,72,255,12,0,99,190,5,0,230,177,5,0,178,4,0,0,1,0,0,0,68,255,12,0,2,190,5,0,230,177,5,0,148,4,0,0,1,0,0,0,92,255,12,0,177,192,5,0,7,191,5,0,87,0,0,0,1,0,0,0,88,255,12,0,57,192,5,0,7,191,5,0,41,1,0,0,1,0,0,0,108,0,0,0,0,0,0,0,120,71,0,0,222,2,0,0,223,2,0,0,148,255,255,255,148,255,255,255,120,71,0,0,224,2,0,0,225,2,0,0,96,159,1,0,76,71,0,0,96,71,0,0,116,159,1,0,0,0,0,0,104,71,0,0,226,2,0,0,227,2,0,0,186,0,0,0,13,0,0,0,76,0,0,0,41,0,0,0,30,0,0,0,6,0,0,0,2,0,0,0,31,0,0,0,8,0,0,0,30,0,0,0,3,0,0,0,31,0,0,0,0,0,0,0,136,71,0,0,228,2,0,0,229,2,0,0,187,0,0,0,32,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,230,2,0,0,35,0,0,0,188,0,0,0,189,0,0,0,33,0,0,0,36,0,0,0,37,0,0,0,190,0,0,0,34,0,0,0,38,0,0,0,14,0,0,0,191,0,0,0,192,0,0,0,231,2,0,0,39,0,0,0,193,0,0,0,40,0,0,0,194,0,0,0,8,0,0,0,24,0,0,0,16,0,0,0,8,0,0,0,0,0,0,0,152,71,0,0,232,2,0,0,233,2,0,0,187,0,0,0,41,0,0,0,35,0,0,0,42,0,0,0,43,0,0,0,234,2,0,0,44,0,0,0,188,0,0,0,189,0,0,0,36,0,0,0,36,0,0,0,45,0,0,0,195,0,0,0,37,0,0,0,46,0,0,0,15,0,0,0,196,0,0,0,197,0,0,0,231,2,0,0,39,0,0,0,198,0,0,0,40,0,0,0,199,0,0,0,0,0,0,0,176,71,0,0,235,2,0,0,236,2,0,0,187,0,0,0,47,0,0,0,38,0,0,0,48,0,0,0,49,0,0,0,237,2,0,0,50,0,0,0,188,0,0,0,189,0,0,0,39,0,0,0,36,0,0,0,51,0,0,0,200,0,0,0,40,0,0,0,52,0,0,0,16,0,0,0,201,0,0,0,202,0,0,0,231,2,0,0,39,0,0,0,203,0,0,0,40,0,0,0,204,0,0,0,8,0,0,0,24,0,0,0,32,0,0,0,28,0,0,0,68,0,0,0,72,0,0,0,8,0,0,0,76,0,0,0,24,0,0,0,0,0,0,0,208,71,0,0,238,2,0,0,239,2,0,0,187,0,0,0,53,0,0,0,41,0,0,0,54,0,0,0,55,0,0,0,240,2,0,0,56,0,0,0,188,0,0,0,189,0,0,0,42,0,0,0,36,0,0,0,57,0,0,0,205,0,0,0,43,0,0,0,58,0,0,0,17,0,0,0,206,0,0,0,207,0,0,0,231,2,0,0,59,0,0,0,208,0,0,0,40,0,0,0,209,0,0,0,60,0,0,0,61,0,0,0,0,0,0,0,192,71,0,0,241,2,0,0,242,2,0,0,210,0,0,0,62,0,0,0,44,0,0,0,63,0,0,0,55,0,0,0,243,2,0,0,64,0,0,0,211,0,0,0,212,0,0,0,45,0,0,0,36,0,0,0,65,0,0,0,213,0,0,0,46,0,0,0,66,0,0,0,18,0,0,0,67,0,0,0,68,0,0,0,32,0,0,0,36,0,0,0,0,0,0,0,64,72,0,0,244,2,0,0,245,2,0,0,187,0,0,0,69,0,0,0,47,0,0,0,70,0,0,0,71,0,0,0,246,2,0,0,72,0,0,0,188,0,0,0,189,0,0,0,48,0,0,0,36,0,0,0,73,0,0,0,214,0,0,0,49,0,0,0,74,0,0,0,19,0,0,0,215,0,0,0,216,0,0,0,231,2,0,0,39,0,0,0,217,0,0,0,40,0,0,0,218,0,0,0,0,0,0,0,240,71,0,0,247,2,0,0,248,2,0,0,75,0,0,0,76,0,0,0,77,0,0,0,249,2,0,0,219,0,0,0,220,0,0,0,78,0,0,0,79,0,0,0,0,0,0,0,48,72,0,0,250,2,0,0,251,2,0,0,1,0,0,0,1,0,0,0,1,0,0,0,20,0,0,0,221,0,0,0,222,0,0,0,1,0,0,0,80,0,0,0,252,2,0,0,253,2,0,0,223,0,0,0,224,0,0,0,44,0,0,0,225,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,248,71,0,0,254,2,0,0,255,2,0,0,50,0,0,0,21,0,0,0,51,0,0,0,20,0,0,0,221,0,0,0,222,0,0,0,81,0,0,0,82,0,0,0,0,3,0,0,1,3,0,0,223,0,0,0,224,0,0,0,44,0,0,0,225,0,0,0,83,0,0,0,84,0,0,0,226,0,0,0,2,3,0,0,227,0,0,0,228,0,0,0,85,0,0,0,86,0,0,0,228,255,255,255,248,71,0,0,3,3,0,0,4,3,0,0,87,0,0,0,88,0,0,0,89,0,0,0,5,3,0,0,229,0,0,0,230,0,0,0,90,0,0,0,91,0,0,0,0,0,0,0,80,72,0,0,241,2,0,0,6,3,0,0,210,0,0,0,62,0,0,0,44,0,0,0,63,0,0,0,55,0,0,0,243,2,0,0,64,0,0,0,211,0,0,0,212,0,0,0,45,0,0,0,36,0,0,0,65,0,0,0,213,0,0,0,46,0,0,0,66,0,0,0,18,0,0,0,92,0,0,0,93,0,0,0,0,0,0,0,104,72,0,0,7,3,0,0,8,3,0,0,187,0,0,0,94,0,0,0,52,0,0,0,95,0,0,0,96,0,0,0,9,3,0,0,97,0,0,0,188,0,0,0,189,0,0,0,53,0,0,0,36,0,0,0,98,0,0,0,231,0,0,0,54,0,0,0,99,0,0,0,22,0,0,0,232,0,0,0,233,0,0,0,231,2,0,0,39,0,0,0,234,0,0,0,40,0,0,0,235,0,0,0,24,0,0,0,28,0,0,0,8,0,0,0,0,0,0,0,120,72,0,0,10,3,0,0,11,3,0,0,187,0,0,0,100,0,0,0,55,0,0,0,101,0,0,0,102,0,0,0,12,3,0,0,103,0,0,0,188,0,0,0,189,0,0,0,56,0,0,0,36,0,0,0,104,0,0,0,236,0,0,0,57,0,0,0,105,0,0,0,23,0,0,0,237,0,0,0,238,0,0,0,231,2,0,0,39,0,0,0,239,0,0,0,40,0,0,0,240,0,0,0,160,0,0,0,156,0,0,0,164,0,0,0,152,0,0,0,8,0,0,0,24,0,0,0,40,0,0,0,56,0,0,0,72,0,0,0,88,0,0,0,104,0,0,0,120,0,0,0,136,0,0,0,0,0,0,0,136,72,0,0,13,3,0,0,14,3,0,0,187,0,0,0,106,0,0,0,58,0,0,0,107,0,0,0,108,0,0,0,15,3,0,0,109,0,0,0,188,0,0,0,189,0,0,0,59,0,0,0,36,0,0,0,110,0,0,0,241,0,0,0,60,0,0,0,111,0,0,0,24,0,0,0,242,0,0,0,243,0,0,0,231,2,0,0,39,0,0,0,244,0,0,0,40,0,0,0,245,0,0,0,8,0,0,0,24,0,0,0,40,0,0,0,56,0,0,0,72,0,0,0,88,0,0,0,104,0,0,0,52,0,0,0,8,0,0,0,0,0,0,0,168,72,0,0,16,3,0,0,17,3,0,0,187,0,0,0,112,0,0,0,61,0,0,0,113,0,0,0,114,0,0,0,18,3,0,0,115,0,0,0,188,0,0,0,189,0,0,0,62,0,0,0,36,0,0,0,116,0,0,0,246,0,0,0,63,0,0,0,117,0,0,0,25,0,0,0,247,0,0,0,248,0,0,0,231,2,0,0,39,0,0,0,249,0,0,0,40,0,0,0,250,0,0,0,0,0,0,0,152,72,0,0,19,3,0,0,20,3,0,0,187,0,0,0,118,0,0,0,64,0,0,0,119,0,0,0,120,0,0,0,21,3,0,0,121,0,0,0,188,0,0,0,189,0,0,0,65,0,0,0,36,0,0,0,122,0,0,0,251,0,0,0,66,0,0,0,123,0,0,0,26,0,0,0,252,0,0,0,253,0,0,0,231,2,0,0,39,0,0,0,254,0,0,0,40,0,0,0,255,0,0,0,0,0,0,0,184,72,0,0,22,3,0,0,23,3,0,0,187,0,0,0,124,0,0,0,67,0,0,0,125,0,0,0,126,0,0,0,24,3,0,0,127,0,0,0,188,0,0,0,189,0,0,0,68,0,0,0,36,0,0,0,128,0,0,0,0,1,0,0,69,0,0,0,129,0,0,0,27,0,0,0,1,1,0,0,2,1,0,0,231,2,0,0,39,0,0,0,3,1,0,0,40,0,0,0,4,1,0,0,8,0,0,0,24,0,0,0,24,0,0,0,8,0,0,0,8,0,0,0,100,0,0,0,24,0,0,0,40,0,0,0,56,0,0,0,8,0,0,0,12,0,0,0,0,0,0,0,232,72,0,0,25,3,0,0,26,3,0,0,187,0,0,0,130,0,0,0,70,0,0,0,131,0,0,0,132,0,0,0,27,3,0,0,133,0,0,0,188,0,0,0,189,0,0,0,71,0,0,0,36,0,0,0,134,0,0,0,5,1,0,0,72,0,0,0,135,0,0,0,28,0,0,0,6,1,0,0,7,1,0,0,231,2,0,0,39,0,0,0,8,1,0,0,40,0,0,0,9,1,0,0,0,0,0,0,200,72,0,0,28,3,0,0,29,3,0,0,187,0,0,0,136,0,0,0,73,0,0,0,137,0,0,0,138,0,0,0,30,3,0,0,139,0,0,0,188,0,0,0,189,0,0,0,74,0,0,0,36,0,0,0,140,0,0,0,10,1,0,0,75,0,0,0,141,0,0,0,29,0,0,0,11,1,0,0,12,1,0,0,231,2,0,0,39,0,0,0,13,1,0,0,40,0,0,0,14,1,0,0,0,0,0,0,216,72,0,0,31,3,0,0,32,3,0,0,187,0,0,0,142,0,0,0,76,0,0,0,143,0,0,0,144,0,0,0,33,3,0,0,145,0,0,0,188,0,0,0,189,0,0,0,77,0,0,0,36,0,0,0,146,0,0,0,15,1,0,0,78,0,0,0,147,0,0,0,30,0,0,0,16,1,0,0,17,1,0,0,231,2,0,0,39,0,0,0,18,1,0,0,40,0,0,0,19,1,0,0,0,0,0,0,248,72,0,0,34,3,0,0,35,3,0,0,187,0,0,0,148,0,0,0,79,0,0,0,149,0,0,0,150,0,0,0,36,3,0,0,151,0,0,0,188,0,0,0,189,0,0,0,80,0,0,0,36,0,0,0,152,0,0,0,20,1,0,0,81,0,0,0,153,0,0,0,31,0,0,0,21,1,0,0,22,1,0,0,231,2,0,0,39,0,0,0,23,1,0,0,40,0,0,0,24,1,0,0,56,0,0,0,8,0,0,0,24,0,0,0,40,0,0,0,68,0,0,0,60,0,0,0,64,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,8,0,0,0,12,0,0,0,28,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,32,0,0,0,8,0,0,0,12,0,0,0,20,0,0,0,16,0,0,0,40,0,0,0,32,0,0,0,24,0,0,0,12,0,0,0,8,0,0,0,8,0,0,0,0,0,0,0,24,73,0,0,37,3,0,0,38,3,0,0,187,0,0,0,154,0,0,0,82,0,0,0,155,0,0,0,156,0,0,0,39,3,0,0,157,0,0,0,188,0,0,0,189,0,0,0,83,0,0,0,36,0,0,0,158,0,0,0,25,1,0,0,84,0,0,0,159,0,0,0,32,0,0,0,26,1,0,0,27,1,0,0,231,2,0,0,39,0,0,0,28,1,0,0,40,0,0,0,29,1,0,0,0,0,0,0,56,73,0,0,40,3,0,0,41,3,0,0,187,0,0,0,160,0,0,0,85,0,0,0,161,0,0,0,162,0,0,0,42,3,0,0,163,0,0,0,188,0,0,0,189,0,0,0,86,0,0,0,36,0,0,0,164,0,0,0,30,1,0,0,87,0,0,0,165,0,0,0,33,0,0,0,31,1,0,0,32,1,0,0,231,2,0,0,39,0,0,0,33,1,0,0,40,0,0,0,34,1,0,0,0,0,0,0,40,73,0,0,43,3,0,0,44,3,0,0,187,0,0,0,166,0,0,0,88,0,0,0,167,0,0,0,168,0,0,0,45,3,0,0,169,0,0,0,188,0,0,0,189,0,0,0,89,0,0,0,36,0,0,0,170,0,0,0,35,1,0,0,90,0,0,0,171,0,0,0,34,0,0,0,36,1,0,0,37,1,0,0,231,2,0,0,39,0,0,0,38,1,0,0,40,0,0,0,39,1,0,0,0,0,0,0,8,73,0,0,46,3,0,0,47,3,0,0,187,0,0,0,172,0,0,0,91,0,0,0,173,0,0,0,174,0,0,0,48,3,0,0,175,0,0,0,188,0,0,0,189,0,0,0,92,0,0,0,36,0,0,0,176,0,0,0,40,1,0,0,93,0,0,0,177,0,0,0,35,0,0,0,41,1,0,0,42,1,0,0,231,2,0,0,39,0,0,0,43,1,0,0,40,0,0,0,44,1,0,0,0,0,0,0,72,73,0,0,49,3,0,0,50,3,0,0,187,0,0,0,178,0,0,0,94,0,0,0,179,0,0,0,55,0,0,0,51,3,0,0,180,0,0,0,188,0,0,0,189,0,0,0,95,0,0,0,36,0,0,0,181,0,0,0,45,1,0,0,96,0,0,0,182,0,0,0,36,0,0,0,46,1,0,0,47,1,0,0,231,2,0,0,39,0,0,0,48,1,0,0,40,0,0,0,49,1,0,0,16,0,0,0,84,0,0,0,16,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,88,0,0,0,80,0,0,0,92,0,0,0,96,0,0,0,100,0,0,0,104,0,0,0,16,0,0,0,16,0,0,0,20,0,0,0,16,0,0,0,21,0,0,0,24,0,0,0,88,0,0,0,92,0,0,0,16,0,0,0,120,0,0,0,121,0,0,0,28,0,0,0,96,0,0,0,100,0,0,0,104,0,0,0,108,0,0,0,112,0,0,0,116,0,0,0,124,0,0,0,40,0,0,0,52,0,0,0,64,0,0,0,76,0,0,0,24,0,0,0,48,0,0,0,28,0,0,0,16,0,0,0,20,0,0,0,44,0,0,0,32,0,0,0,40,0,0,0,36,0,0,0,49,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,28,0,0,0,44,0,0,0,16,0,0,0,48,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,40,0,0,0,28,0,0,0,44,0,0,0,36,0,0,0,32,0,0,0,92,0,0,0,16,0,0,0,32,0,0,0,48,0,0,0,100,0,0,0,96,0,0,0,101,0,0,0,60,0,0,0,76,0,0,0,88,0,0,0,112,0,0,0,92,0,0,0,16,0,0,0,116,0,0,0,32,0,0,0,120,0,0,0,48,0,0,0,64,0,0,0,124,0,0,0,160,0,0,0,188,0,0,0,128,0,0,0,132,0,0,0,180,0,0,0,136,0,0,0,184,0,0,0,96,0,0,0,140,0,0,0,144,0,0,0,148,0,0,0,152,0,0,0,100,0,0,0,156,0,0,0,76,0,0,0,192,0,0,0,164,0,0,0,104,0,0,0,161,0,0,0,196,0,0,0,200,0,0,0,168,0,0,0,208,0,0,0,108,0,0,0,216,0,0,0,220,0,0,0,176,0,0,0,162,0,0,0,189,0,0,0,172,0,0,0,36,0,0,0,32,0,0,0,16,0,0,0,40,0,0,0,36,0,0,0,32,0,0,0,16,0,0,0,48,0,0,0,52,0,0,0,56,0,0,0,16,0,0,0,32,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,144,0,0,0,148,0,0,0,24,0,0,0,40,0,0,0,112,1,0,0,56,0,0,0,68,0,0,0,84,0,0,0,100,0,0,0,112,0,0,0,128,0,0,0,152,0,0,0,156,0,0,0,160,0,0,0,164,0,0,0,168,0,0,0,172,0,0,0,176,0,0,0,180,0,0,0,184,0,0,0,188,0,0,0,192,0,0,0,196,0,0,0,200,0,0,0,204,0,0,0,208,0,0,0,212,0,0,0,216,0,0,0,220,0,0,0,224,0,0,0,228,0,0,0,232,0,0,0,236,0,0,0,240,0,0,0,244,0,0,0,248,0,0,0,252,0,0,0,0,1,0,0,4,1,0,0,8,1,0,0,12,1,0,0,16,1,0,0,20,1,0,0,24,1,0,0,28,1,0,0,32,1,0,0,36,1,0,0,40,1,0,0,44,1,0,0,48,1,0,0,52,1,0,0,56,1,0,0,60,1,0,0,64,1,0,0,68,1,0,0,72,1,0,0,76,1,0,0,80,1,0,0,84,1,0,0,88,1,0,0,92,1,0,0,96,1,0,0,100,1,0,0,104,1,0,0,108,1,0,0,40,0,0,0,36,0,0,0,32,0,0,0,28,0,0,0,16,0,0,0,37,0,0,0,38,0,0,0,16,0,0,0,24,0,0,0,20,0,0,0,20,0,0,0,24,0,0,0,16,0,0,0,16,0,0,0,24,0,0,0,20,0,0,0,16,0,0,0,20,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,20,0,0,0,24,0,0,0,16,0,0,0,20,0,0,0,16,0,0,0,72,0,0,0,112,0,0,0,16,0,0,0,28,0,0,0,40,0,0,0,52,0,0,0,76,0,0,0,80,0,0,0,84,0,0,0,88,0,0,0,92,0,0,0,96,0,0,0,116,0,0,0,64,0,0,0,68,0,0,0,100,0,0,0,108,0,0,0,104,0,0,0,28,0,0,0,16,0,0,0,16,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,44,0,0,0,20,0,0,0,36,0,0,0,40,0,0,0,41,0,0,0,48,0,0,0,20,0,0,0,16,0,0,0,24,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,36,0,0,0,16,0,0,0,20,0,0,0,16,0,0,0,32,0,0,0,48,0,0,0,60,0,0,0,72,0,0,0,84,0,0,0,28,0,0,0,16,0,0,0,32,0,0,0,16,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,16,0,0,0,20,0,0,0,20,0,0,0,24,0,0,0,16,0,0,0,16,0,0,0,20,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,16,0,0,0,16,0,0,0,16,0,0,0,52,0,0,0,28,0,0,0,40,0,0,0,32,0,0,0,36,0,0,0,56,0,0,0,48,0,0,0,20,0,0,0,44,0,0,0,41,0,0,0,24,0,0,0,16,0,0,0,24,0,0,0,29,0,0,0,16,0,0,0,20,0,0,0,32,0,0,0,28,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,16,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,16,0,0,0,36,0,0,0,20,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,17,0,0,0,16,0,0,0,20,0,0,0,16,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,60,0,0,0,44,0,0,0,48,0,0,0,52,0,0,0,56,0,0,0,64,0,0,0,20,0,0,0,24,0,0,0,16,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,24,0,0,0,16,0,0,0,20,0,0,0,28,0,0,0,29,0,0,0,20,0,0,0,16,0,0,0,24,0,0,0,16,0,0,0,20,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,16,0,0,0,24,0,0,0,20,0,0,0,16,0,0,0,28,0,0,0,16,0,0,0,32,0,0,0,16,0,0,0,20,0,0,0,16,0,0,0,20,0,0,0,16,0,0,0,16,0,0,0,16,0,0,0,48,0,0,0,20,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,52,0,0,0,56,0,0,0,60,0,0,0,44,0,0,0,24,0,0,0,41,0,0,0,28,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,16,0,0,0,32,0,0,0,160,0,0,0,48,0,0,0,64,0,0,0,32,1,0,0,80,0,0,0,96,0,0,0,112,0,0,0,124,0,0,0,136,0,0,0,148,0,0,0,164,0,0,0,168,0,0,0,172,0,0,0,176,0,0,0,180,0,0,0,184,0,0,0,188,0,0,0,192,0,0,0,196,0,0,0,200,0,0,0,204,0,0,0,208,0,0,0,212,0,0,0,216,0,0,0,220,0,0,0,224,0,0,0,228,0,0,0,232,0,0,0,236,0,0,0,240,0,0,0,244,0,0,0,248,0,0,0,252,0,0,0,0,1,0,0,4,1,0,0,8,1,0,0,12,1,0,0,16,1,0,0,20,1,0,0,24,1,0,0,28,1,0,0,56,0,0,0,60,0,0,0,88,0,0,0,144,0,0,0,76,0,0,0,80,0,0,0,92,0,0,0,96,0,0,0,148,0,0,0,152,0,0,0,100,0,0,0,156,0,0,0,160,0,0,0,164,0,0,0,168,0,0,0,172,0,0,0,64,0,0,0,176,0,0,0,68,0,0,0,104,0,0,0,108,0,0,0,116,0,0,0,16,0,0,0,32,0,0,0,44,0,0,0,112,0,0,0,180,0,0,0,184,0,0,0,188,0,0,0,120,0,0,0,72,0,0,0,124,0,0,0,128,0,0,0,132,0,0,0,136,0,0,0,117,0,0,0,140,0,0,0,84,0,0,0,16,0,0,0,20,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,44,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,40,0,0,0,44,0,0,0,48,0,0,0,16,0,0,0,28,0,0,0,52,0,0,0,56,0,0,0,60,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,0,0,0,0,168,77,0,0,52,3,0,0,53,3,0,0,187,0,0,0,183,0,0,0,97,0,0,0,179,0,0,0,55,0,0,0,54,3,0,0,184,0,0,0,188,0,0,0,189,0,0,0,98,0,0,0,36,0,0,0,185,0,0,0,50,1,0,0,99,0,0,0,186,0,0,0,37,0,0,0,51,1,0,0,52,1,0,0,231,2,0,0,39,0,0,0,53,1,0,0,40,0,0,0,54,1,0,0,0,0,0,0,152,77,0,0,55,3,0,0,56,3,0,0,187,0,0,0,187,0,0,0,100,0,0,0,179,0,0,0,55,0,0,0,57,3,0,0,188,0,0,0,188,0,0,0,189,0,0,0,101,0,0,0,36,0,0,0,189,0,0,0,55,1,0,0,102,0,0,0,190,0,0,0,38,0,0,0,56,1,0,0,57,1,0,0,231,2,0,0,39,0,0,0,58,1,0,0,40,0,0,0,59,1,0,0,0,0,0,0,136,77,0,0,58,3,0,0,59,3,0,0,187,0,0,0,191,0,0,0,103,0,0,0,179,0,0,0,55,0,0,0,60,3,0,0,192,0,0,0,188,0,0,0,189,0,0,0,104,0,0,0,36,0,0,0,193,0,0,0,60,1,0,0,105,0,0,0,194,0,0,0,39,0,0,0,61,1,0,0,62,1,0,0,231,2,0,0,39,0,0,0,63,1,0,0,40,0,0,0,64,1,0,0,0,0,0,0,120,77,0,0,61,3,0,0,62,3,0,0,187,0,0,0,195,0,0,0,106,0,0,0,179,0,0,0,55,0,0,0,63,3,0,0,196,0,0,0,188,0,0,0,189,0,0,0,107,0,0,0,36,0,0,0,197,0,0,0,65,1,0,0,108,0,0,0,198,0,0,0,40,0,0,0,66,1,0,0,67,1,0,0,231,2,0,0,39,0,0,0,68,1,0,0,40,0,0,0,69,1,0,0,0,0,0,0,104,77,0,0,64,3,0,0,65,3,0,0,187,0,0,0,199,0,0,0,109,0,0,0,179,0,0,0,55,0,0,0,66,3,0,0,200,0,0,0,188,0,0,0,189,0,0,0,110,0,0,0,36,0,0,0,201,0,0,0,70,1,0,0,111,0,0,0,202,0,0,0,41,0,0,0,71,1,0,0,72,1,0,0,231,2,0,0,39,0,0,0,73,1,0,0,40,0,0,0,74,1,0,0,0,0,0,0,88,77,0,0,67,3,0,0,68,3,0,0,187,0,0,0,203,0,0,0,112,0,0,0,179,0,0,0,55,0,0,0,69,3,0,0,204,0,0,0,188,0,0,0,189,0,0,0,113,0,0,0,36,0,0,0,205,0,0,0,75,1,0,0,114,0,0,0,206,0,0,0,42,0,0,0,76,1,0,0,77,1,0,0,231,2,0,0,39,0,0,0,78,1,0,0,40,0,0,0,79,1,0,0,0,0,0,0,72,77,0,0,70,3,0,0,71,3,0,0,187,0,0,0,207,0,0,0,115,0,0,0,179,0,0,0,55,0,0,0,72,3,0,0,208,0,0,0,188,0,0,0,189,0,0,0,116,0,0,0,36,0,0,0,209,0,0,0,80,1,0,0,117,0,0,0,210,0,0,0,43,0,0,0,81,1,0,0,82,1,0,0,231,2,0,0,39,0,0,0,83,1,0,0,40,0,0,0,84,1,0,0,0,0,0,0,200,73,0,0,73,3,0,0,74,3,0,0,187,0,0,0,211,0,0,0,118,0,0,0,179,0,0,0,55,0,0,0,75,3,0,0,212,0,0,0,188,0,0,0,189,0,0,0,119,0,0,0,36,0,0,0,213,0,0,0,85,1,0,0,120,0,0,0,214,0,0,0,44,0,0,0,86,1,0,0,87,1,0,0,231,2,0,0,39,0,0,0,88,1,0,0,40,0,0,0,89,1,0,0,0,0,0,0,56,77,0,0,76,3,0,0,77,3,0,0,187,0,0,0,215,0,0,0,121,0,0,0,179,0,0,0,55,0,0,0,78,3,0,0,216,0,0,0,188,0,0,0,189,0,0,0,122,0,0,0,36,0,0,0,217,0,0,0,90,1,0,0,123,0,0,0,218,0,0,0,45,0,0,0,91,1,0,0,92,1,0,0,231,2,0,0,39,0,0,0,93,1,0,0,40,0,0,0,94,1,0,0,0,0,0,0,40,77,0,0,79,3,0,0,80,3,0,0,187,0,0,0,219,0,0,0,124,0,0,0,179,0,0,0,55,0,0,0,81,3,0,0,220,0,0,0,188,0,0,0,189,0,0,0,125,0,0,0,36,0,0,0,221,0,0,0,95,1,0,0,126,0,0,0,222,0,0,0,46,0,0,0,96,1,0,0,97,1,0,0,231,2,0,0,39,0,0,0,98,1,0,0,40,0,0,0,99,1,0,0,0,0,0,0,24,77,0,0,82,3,0,0,83,3,0,0,187,0,0,0,223,0,0,0,127,0,0,0,179,0,0,0,55,0,0,0,84,3,0,0,224,0,0,0,188,0,0,0,189,0,0,0,128,0,0,0,36,0,0,0,225,0,0,0,100,1,0,0,129,0,0,0,226,0,0,0,47,0,0,0,101,1,0,0,102,1,0,0,231,2,0,0,39,0,0,0,103,1,0,0,40,0,0,0,104,1,0,0,0,0,0,0,8,77,0,0,85,3,0,0,86,3,0,0,187,0,0,0,227,0,0,0,130,0,0,0,179,0,0,0,55,0,0,0,87,3,0,0,228,0,0,0,188,0,0,0,189,0,0,0,131,0,0,0,36,0,0,0,229,0,0,0,105,1,0,0,132,0,0,0,230,0,0,0,48,0,0,0,106,1,0,0,107,1,0,0,231,2,0,0,39,0,0,0,108,1,0,0,40,0,0,0,109,1,0,0,0,0,0,0,248,76,0,0,88,3],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+102400);allocate([89,3,0,0,187,0,0,0,231,0,0,0,133,0,0,0,179,0,0,0,55,0,0,0,90,3,0,0,232,0,0,0,188,0,0,0,189,0,0,0,134,0,0,0,36,0,0,0,233,0,0,0,110,1,0,0,135,0,0,0,234,0,0,0,49,0,0,0,111,1,0,0,112,1,0,0,231,2,0,0,39,0,0,0,113,1,0,0,40,0,0,0,114,1,0,0,0,0,0,0,232,76,0,0,91,3,0,0,92,3,0,0,187,0,0,0,235,0,0,0,136,0,0,0,179,0,0,0,55,0,0,0,93,3,0,0,236,0,0,0,188,0,0,0,189,0,0,0,137,0,0,0,36,0,0,0,237,0,0,0,115,1,0,0,138,0,0,0,238,0,0,0,50,0,0,0,116,1,0,0,117,1,0,0,231,2,0,0,39,0,0,0,118,1,0,0,40,0,0,0,119,1,0,0,0,0,0,0,216,76,0,0,94,3,0,0,95,3,0,0,187,0,0,0,239,0,0,0,139,0,0,0,179,0,0,0,55,0,0,0,96,3,0,0,240,0,0,0,188,0,0,0,189,0,0,0,140,0,0,0,36,0,0,0,241,0,0,0,120,1,0,0,141,0,0,0,242,0,0,0,51,0,0,0,121,1,0,0,122,1,0,0,231,2,0,0,39,0,0,0,123,1,0,0,40,0,0,0,124,1,0,0,0,0,0,0,200,76,0,0,97,3,0,0,98,3,0,0,187,0,0,0,243,0,0,0,142,0,0,0,179,0,0,0,55,0,0,0,99,3,0,0,244,0,0,0,188,0,0,0,189,0,0,0,143,0,0,0,36,0,0,0,245,0,0,0,125,1,0,0,144,0,0,0,246,0,0,0,52,0,0,0,126,1,0,0,127,1,0,0,231,2,0,0,39,0,0,0,128,1,0,0,40,0,0,0,129,1,0,0,0,0,0,0,184,76,0,0,100,3,0,0,101,3,0,0,187,0,0,0,247,0,0,0,145,0,0,0,179,0,0,0,55,0,0,0,102,3,0,0,248,0,0,0,188,0,0,0,189,0,0,0,146,0,0,0,36,0,0,0,249,0,0,0,130,1,0,0,147,0,0,0,250,0,0,0,53,0,0,0,131,1,0,0,132,1,0,0,231,2,0,0,39,0,0,0,133,1,0,0,40,0,0,0,134,1,0,0,0,0,0,0,168,76,0,0,103,3,0,0,104,3,0,0,187,0,0,0,251,0,0,0,148,0,0,0,179,0,0,0,55,0,0,0,105,3,0,0,252,0,0,0,188,0,0,0,189,0,0,0,149,0,0,0,36,0,0,0,253,0,0,0,135,1,0,0,150,0,0,0,254,0,0,0,54,0,0,0,136,1,0,0,137,1,0,0,231,2,0,0,39,0,0,0,138,1,0,0,40,0,0,0,139,1,0,0,0,0,0,0,152,76,0,0,106,3,0,0,107,3,0,0,187,0,0,0,255,0,0,0,151,0,0,0,179,0,0,0,55,0,0,0,108,3,0,0,0,1,0,0,188,0,0,0,189,0,0,0,152,0,0,0,36,0,0,0,1,1,0,0,140,1,0,0,153,0,0,0,2,1,0,0,55,0,0,0,141,1,0,0,142,1,0,0,231,2,0,0,39,0,0,0,143,1,0,0,40,0,0,0,144,1,0,0,0,0,0,0,136,76,0,0,109,3,0,0,110,3,0,0,187,0,0,0,3,1,0,0,154,0,0,0,179,0,0,0,55,0,0,0,111,3,0,0,4,1,0,0,188,0,0,0,189,0,0,0,155,0,0,0,36,0,0,0,5,1,0,0,145,1,0,0,156,0,0,0,6,1,0,0,56,0,0,0,146,1,0,0,147,1,0,0,231,2,0,0,39,0,0,0,148,1,0,0,40,0,0,0,149,1,0,0,0,0,0,0,120,76,0,0,112,3,0,0,113,3,0,0,187,0,0,0,7,1,0,0,157,0,0,0,179,0,0,0,55,0,0,0,114,3,0,0,8,1,0,0,188,0,0,0,189,0,0,0,158,0,0,0,36,0,0,0,9,1,0,0,150,1,0,0,159,0,0,0,10,1,0,0,57,0,0,0,151,1,0,0,152,1,0,0,231,2,0,0,39,0,0,0,153,1,0,0,40,0,0,0,154,1,0,0,0,0,0,0,104,76,0,0,115,3,0,0,116,3,0,0,187,0,0,0,11,1,0,0,160,0,0,0,179,0,0,0,55,0,0,0,117,3,0,0,12,1,0,0,188,0,0,0,189,0,0,0,161,0,0,0,36,0,0,0,13,1,0,0,155,1,0,0,162,0,0,0,14,1,0,0,58,0,0,0,156,1,0,0,157,1,0,0,231,2,0,0,39,0,0,0,158,1,0,0,40,0,0,0,159,1,0,0,0,0,0,0,88,76,0,0,118,3,0,0,119,3,0,0,187,0,0,0,15,1,0,0,163,0,0,0,179,0,0,0,55,0,0,0,120,3,0,0,16,1,0,0,188,0,0,0,189,0,0,0,164,0,0,0,36,0,0,0,17,1,0,0,160,1,0,0,165,0,0,0,18,1,0,0,59,0,0,0,161,1,0,0,162,1,0,0,231,2,0,0,39,0,0,0,163,1,0,0,40,0,0,0,164,1,0,0,0,0,0,0,72,76,0,0,121,3,0,0,122,3,0,0,187,0,0,0,19,1,0,0,166,0,0,0,179,0,0,0,55,0,0,0,123,3,0,0,20,1,0,0,188,0,0,0,189,0,0,0,167,0,0,0,36,0,0,0,21,1,0,0,165,1,0,0,168,0,0,0,22,1,0,0,60,0,0,0,166,1,0,0,167,1,0,0,231,2,0,0,39,0,0,0,168,1,0,0,40,0,0,0,169,1,0,0,0,0,0,0,56,76,0,0,124,3,0,0,125,3,0,0,187,0,0,0,23,1,0,0,169,0,0,0,179,0,0,0,55,0,0,0,126,3,0,0,24,1,0,0,188,0,0,0,189,0,0,0,170,0,0,0,36,0,0,0,25,1,0,0,170,1,0,0,171,0,0,0,26,1,0,0,61,0,0,0,171,1,0,0,172,1,0,0,231,2,0,0,39,0,0,0,173,1,0,0,40,0,0,0,174,1,0,0,0,0,0,0,40,76,0,0,127,3,0,0,128,3,0,0,187,0,0,0,27,1,0,0,172,0,0,0,179,0,0,0,55,0,0,0,129,3,0,0,28,1,0,0,188,0,0,0,189,0,0,0,173,0,0,0,36,0,0,0,29,1,0,0,175,1,0,0,174,0,0,0,30,1,0,0,62,0,0,0,176,1,0,0,177,1,0,0,231,2,0,0,39,0,0,0,178,1,0,0,40,0,0,0,179,1,0,0,0,0,0,0,24,76,0,0,130,3,0,0,131,3,0,0,187,0,0,0,31,1,0,0,175,0,0,0,179,0,0,0,55,0,0,0,132,3,0,0,32,1,0,0,188,0,0,0,189,0,0,0,176,0,0,0,36,0,0,0,33,1,0,0,180,1,0,0,177,0,0,0,34,1,0,0,63,0,0,0,181,1,0,0,182,1,0,0,231,2,0,0,39,0,0,0,183,1,0,0,40,0,0,0,184,1,0,0,0,0,0,0,8,76,0,0,133,3,0,0,134,3,0,0,187,0,0,0,35,1,0,0,178,0,0,0,179,0,0,0,55,0,0,0,135,3,0,0,36,1,0,0,188,0,0,0,189,0,0,0,179,0,0,0,36,0,0,0,37,1,0,0,185,1,0,0,180,0,0,0,38,1,0,0,64,0,0,0,186,1,0,0,187,1,0,0,231,2,0,0,39,0,0,0,188,1,0,0,40,0,0,0,189,1,0,0,0,0,0,0,248,75,0,0,136,3,0,0,137,3,0,0,187,0,0,0,39,1,0,0,181,0,0,0,179,0,0,0,55,0,0,0,138,3,0,0,40,1,0,0,188,0,0,0,189,0,0,0,182,0,0,0,36,0,0,0,41,1,0,0,190,1,0,0,183,0,0,0,42,1,0,0,65,0,0,0,191,1,0,0,192,1,0,0,231,2,0,0,39,0,0,0,193,1,0,0,40,0,0,0,194,1,0,0,0,0,0,0,232,75,0,0,139,3,0,0,140,3,0,0,187,0,0,0,43,1,0,0,184,0,0,0,179,0,0,0,55,0,0,0,141,3,0,0,44,1,0,0,188,0,0,0,189,0,0,0,185,0,0,0,36,0,0,0,45,1,0,0,195,1,0,0,186,0,0,0,46,1,0,0,66,0,0,0,196,1,0,0,197,1,0,0,231,2,0,0,39,0,0,0,198,1,0,0,40,0,0,0,199,1,0,0,0,0,0,0,216,75,0,0,142,3,0,0,143,3,0,0,187,0,0,0,47,1,0,0,187,0,0,0,179,0,0,0,55,0,0,0,144,3,0,0,48,1,0,0,188,0,0,0,189,0,0,0,188,0,0,0,36,0,0,0,49,1,0,0,200,1,0,0,189,0,0,0,50,1,0,0,67,0,0,0,201,1,0,0,202,1,0,0,231,2,0,0,39,0,0,0,203,1,0,0,40,0,0,0,204,1,0,0,0,0,0,0,200,75,0,0,145,3,0,0,146,3,0,0,187,0,0,0,51,1,0,0,190,0,0,0,179,0,0,0,55,0,0,0,147,3,0,0,52,1,0,0,188,0,0,0,189,0,0,0,191,0,0,0,36,0,0,0,53,1,0,0,205,1,0,0,192,0,0,0,54,1,0,0,68,0,0,0,206,1,0,0,207,1,0,0,231,2,0,0,39,0,0,0,208,1,0,0,40,0,0,0,209,1,0,0,0,0,0,0,184,75,0,0,148,3,0,0,149,3,0,0,187,0,0,0,55,1,0,0,193,0,0,0,179,0,0,0,55,0,0,0,150,3,0,0,56,1,0,0,188,0,0,0,189,0,0,0,194,0,0,0,36,0,0,0,57,1,0,0,210,1,0,0,195,0,0,0,58,1,0,0,69,0,0,0,211,1,0,0,212,1,0,0,231,2,0,0,39,0,0,0,213,1,0,0,40,0,0,0,214,1,0,0,0,0,0,0,168,75,0,0,151,3,0,0,152,3,0,0,187,0,0,0,59,1,0,0,196,0,0,0,179,0,0,0,55,0,0,0,153,3,0,0,60,1,0,0,188,0,0,0,189,0,0,0,197,0,0,0,36,0,0,0,61,1,0,0,215,1,0,0,198,0,0,0,62,1,0,0,70,0,0,0,216,1,0,0,217,1,0,0,231,2,0,0,39,0,0,0,218,1,0,0,40,0,0,0,219,1,0,0,0,0,0,0,152,75,0,0,154,3,0,0,155,3,0,0,187,0,0,0,63,1,0,0,199,0,0,0,179,0,0,0,55,0,0,0,156,3,0,0,64,1,0,0,188,0,0,0,189,0,0,0,200,0,0,0,36,0,0,0,65,1,0,0,220,1,0,0,201,0,0,0,66,1,0,0,71,0,0,0,221,1,0,0,222,1,0,0,231,2,0,0,39,0,0,0,223,1,0,0,40,0,0,0,224,1,0,0,0,0,0,0,136,75,0,0,157,3,0,0,158,3,0,0,187,0,0,0,67,1,0,0,202,0,0,0,179,0,0,0,55,0,0,0,159,3,0,0,68,1,0,0,188,0,0,0,189,0,0,0,203,0,0,0,36,0,0,0,69,1,0,0,225,1,0,0,204,0,0,0,70,1,0,0,72,0,0,0,226,1,0,0,227,1,0,0,231,2,0,0,39,0,0,0,228,1,0,0,40,0,0,0,229,1,0,0,0,0,0,0,120,75,0,0,160,3,0,0,161,3,0,0,187,0,0,0,71,1,0,0,205,0,0,0,179,0,0,0,55,0,0,0,162,3,0,0,72,1,0,0,188,0,0,0,189,0,0,0,206,0,0,0,36,0,0,0,73,1,0,0,230,1,0,0,207,0,0,0,74,1,0,0,73,0,0,0,231,1,0,0,232,1,0,0,231,2,0,0,39,0,0,0,233,1,0,0,40,0,0,0,234,1,0,0,0,0,0,0,104,75,0,0,163,3,0,0,164,3,0,0,187,0,0,0,75,1,0,0,208,0,0,0,179,0,0,0,55,0,0,0,165,3,0,0,76,1,0,0,188,0,0,0,189,0,0,0,209,0,0,0,36,0,0,0,77,1,0,0,235,1,0,0,210,0,0,0,78,1,0,0,74,0,0,0,236,1,0,0,237,1,0,0,231,2,0,0,39,0,0,0,238,1,0,0,40,0,0,0,239,1,0,0,0,0,0,0,88,75,0,0,166,3,0,0,167,3,0,0,187,0,0,0,79,1,0,0,211,0,0,0,179,0,0,0,55,0,0,0,168,3,0,0,80,1,0,0,188,0,0,0,189,0,0,0,212,0,0,0,36,0,0,0,81,1,0,0,240,1,0,0,213,0,0,0,82,1,0,0,75,0,0,0,241,1,0,0,242,1,0,0,231,2,0,0,39,0,0,0,243,1,0,0,40,0,0,0,244,1,0,0,0,0,0,0,72,75,0,0,169,3,0,0,170,3,0,0,187,0,0,0,83,1,0,0,214,0,0,0,179,0,0,0,55,0,0,0,171,3,0,0,84,1,0,0,188,0,0,0,189,0,0,0,215,0,0,0,36,0,0,0,85,1,0,0,245,1,0,0,216,0,0,0,86,1,0,0,76,0,0,0,246,1,0,0,247,1,0,0,231,2,0,0,39,0,0,0,248,1,0,0,40,0,0,0,249,1,0,0,0,0,0,0,56,75,0,0,172,3,0,0,173,3,0,0,187,0,0,0,87,1,0,0,217,0,0,0,179,0,0,0,55,0,0,0,174,3,0,0,88,1,0,0,188,0,0,0,189,0,0,0,218,0,0,0,36,0,0,0,89,1,0,0,250,1,0,0,219,0,0,0,90,1,0,0,77,0,0,0,251,1,0,0,252,1,0,0,231,2,0,0,39,0,0,0,253,1,0,0,40,0,0,0,254,1,0,0,0,0,0,0,40,75,0,0,175,3,0,0,176,3,0,0,187,0,0,0,91,1,0,0,220,0,0,0,179,0,0,0,55,0,0,0,177,3,0,0,92,1,0,0,188,0,0,0,189,0,0,0,221,0,0,0,36,0,0,0,93,1,0,0,255,1,0,0,222,0,0,0,94,1,0,0,78,0,0,0,0,2,0,0,1,2,0,0,231,2,0,0,39,0,0,0,2,2,0,0,40,0,0,0,3,2,0,0,0,0,0,0,24,75,0,0,178,3,0,0,179,3,0,0,187,0,0,0,95,1,0,0,223,0,0,0,179,0,0,0,55,0,0,0,180,3,0,0,96,1,0,0,188,0,0,0,189,0,0,0,224,0,0,0,36,0,0,0,97,1,0,0,4,2,0,0,225,0,0,0,98,1,0,0,79,0,0,0,5,2,0,0,6,2,0,0,231,2,0,0,39,0,0,0,7,2,0,0,40,0,0,0,8,2,0,0,0,0,0,0,8,75,0,0,181,3,0,0,182,3,0,0,187,0,0,0,99,1,0,0,226,0,0,0,179,0,0,0,55,0,0,0,183,3,0,0,100,1,0,0,188,0,0,0,189,0,0,0,227,0,0,0,36,0,0,0,101,1,0,0,9,2,0,0,228,0,0,0,102,1,0,0,80,0,0,0,10,2,0,0,11,2,0,0,231,2,0,0,39,0,0,0,12,2,0,0,40,0,0,0,13,2,0,0,0,0,0,0,248,74,0,0,184,3,0,0,185,3,0,0,187,0,0,0,103,1,0,0,229,0,0,0,179,0,0,0,55,0,0,0,186,3,0,0,104,1,0,0,188,0,0,0,189,0,0,0,230,0,0,0,36,0,0,0,105,1,0,0,14,2,0,0,231,0,0,0,106,1,0,0,81,0,0,0,15,2,0,0,16,2,0,0,231,2,0,0,39,0,0,0,17,2,0,0,40,0,0,0,18,2,0,0,0,0,0,0,232,74,0,0,187,3,0,0,188,3,0,0,187,0,0,0,107,1,0,0,232,0,0,0,179,0,0,0,55,0,0,0,189,3,0,0,108,1,0,0,188,0,0,0,189,0,0,0,233,0,0,0,36,0,0,0,109,1,0,0,19,2,0,0,234,0,0,0,110,1,0,0,82,0,0,0,20,2,0,0,21,2,0,0,231,2,0,0,39,0,0,0,22,2,0,0,40,0,0,0,23,2,0,0,0,0,0,0,216,74,0,0,190,3,0,0,191,3,0,0,187,0,0,0,111,1,0,0,235,0,0,0,179,0,0,0,55,0,0,0,192,3,0,0,112,1,0,0,188,0,0,0,189,0,0,0,236,0,0,0,36,0,0,0,113,1,0,0,24,2,0,0,237,0,0,0,114,1,0,0,83,0,0,0,25,2,0,0,26,2,0,0,231,2,0,0,39,0,0,0,27,2,0,0,40,0,0,0,28,2,0,0,0,0,0,0,200,74,0,0,193,3,0,0,194,3,0,0,187,0,0,0,115,1,0,0,238,0,0,0,179,0,0,0,55,0,0,0,195,3,0,0,116,1,0,0,188,0,0,0,189,0,0,0,239,0,0,0,36,0,0,0,117,1,0,0,29,2,0,0,240,0,0,0,118,1,0,0,84,0,0,0,30,2,0,0,31,2,0,0,231,2,0,0,39,0,0,0,32,2,0,0,40,0,0,0,33,2,0,0,0,0,0,0,184,74,0,0,196,3,0,0,197,3,0,0,187,0,0,0,119,1,0,0,241,0,0,0,179,0,0,0,55,0,0,0,198,3,0,0,120,1,0,0,188,0,0,0,189,0,0,0,242,0,0,0,36,0,0,0,121,1,0,0,34,2,0,0,243,0,0,0,122,1,0,0,85,0,0,0,35,2,0,0,36,2,0,0,231,2,0,0,39,0,0,0,37,2,0,0,40,0,0,0,38,2,0,0,0,0,0,0,168,74,0,0,199,3,0,0,200,3,0,0,187,0,0,0,123,1,0,0,244,0,0,0,179,0,0,0,55,0,0,0,201,3,0,0,124,1,0,0,188,0,0,0,189,0,0,0,245,0,0,0,36,0,0,0,125,1,0,0,39,2,0,0,246,0,0,0,126,1,0,0,86,0,0,0,40,2,0,0,41,2,0,0,231,2,0,0,39,0,0,0,42,2,0,0,40,0,0,0,43,2,0,0,0,0,0,0,152,74,0,0,202,3,0,0,203,3,0,0,187,0,0,0,127,1,0,0,247,0,0,0,179,0,0,0,55,0,0,0,204,3,0,0,128,1,0,0,188,0,0,0,189,0,0,0,248,0,0,0,36,0,0,0,129,1,0,0,44,2,0,0,249,0,0,0,130,1,0,0,87,0,0,0,45,2,0,0,46,2,0,0,231,2,0,0,39,0,0,0,47,2,0,0,40,0,0,0,48,2,0,0,0,0,0,0,136,74,0,0,205,3,0,0,206,3,0,0,187,0,0,0,131,1,0,0,250,0,0,0,179,0,0,0,55,0,0,0,207,3,0,0,132,1,0,0,188,0,0,0,189,0,0,0,251,0,0,0,36,0,0,0,133,1,0,0,49,2,0,0,252,0,0,0,134,1,0,0,88,0,0,0,50,2,0,0,51,2,0,0,231,2,0,0,39,0,0,0,52,2,0,0,40,0,0,0,53,2,0,0,0,0,0,0,120,74,0,0,208,3,0,0,209,3,0,0,187,0,0,0,135,1,0,0,253,0,0,0,179,0,0,0,55,0,0,0,210,3,0,0,136,1,0,0,188,0,0,0,189,0,0,0,254,0,0,0,36,0,0,0,137,1,0,0,54,2,0,0,255,0,0,0,138,1,0,0,89,0,0,0,55,2,0,0,56,2,0,0,231,2,0,0,39,0,0,0,57,2,0,0,40,0,0,0,58,2,0,0,0,0,0,0,104,74,0,0,211,3,0,0,212,3,0,0,187,0,0,0,139,1,0,0,0,1,0,0,179,0,0,0,55,0,0,0,213,3,0,0,140,1,0,0,188,0,0,0,189,0,0,0,1,1,0,0,36,0,0,0,141,1,0,0,59,2,0,0,2,1,0,0,142,1,0,0,90,0,0,0,60,2,0,0,61,2,0,0,231,2,0,0,39,0,0,0,62,2,0,0,40,0,0,0,63,2,0,0,0,0,0,0,88,74,0,0,214,3,0,0,215,3,0,0,187,0,0,0,143,1,0,0,3,1,0,0,179,0,0,0,55,0,0,0,216,3,0,0,144,1,0,0,188,0,0,0,189,0,0,0,4,1,0,0,36,0,0,0,145,1,0,0,64,2,0,0,5,1,0,0,146,1,0,0,91,0,0,0,65,2,0,0,66,2,0,0,231,2,0,0,39,0,0,0,67,2,0,0,40,0,0,0,68,2,0,0,0,0,0,0,72,74,0,0,217,3,0,0,218,3,0,0,187,0,0,0,147,1,0,0,6,1,0,0,179,0,0,0,55,0,0,0,219,3,0,0,148,1,0,0,188,0,0,0,189,0,0,0,7,1,0,0,36,0,0,0,149,1,0,0,69,2,0,0,8,1,0,0,150,1,0,0,92,0,0,0,70,2,0,0,71,2,0,0,231,2,0,0,39,0,0,0,72,2,0,0,40,0,0,0,73,2,0,0,0,0,0,0,56,74,0,0,220,3,0,0,221,3,0,0,187,0,0,0,151,1,0,0,9,1,0,0,179,0,0,0,55,0,0,0,222,3,0,0,152,1,0,0,188,0,0,0,189,0,0,0,10,1,0,0,36,0,0,0,153,1,0,0,74,2,0,0,11,1,0,0,154,1,0,0,93,0,0,0,75,2,0,0,76,2,0,0,231,2,0,0,39,0,0,0,77,2,0,0,40,0,0,0,78,2,0,0,0,0,0,0,40,74,0,0,223,3,0,0,224,3,0,0,187,0,0,0,155,1,0,0,12,1,0,0,179,0,0,0,55,0,0,0,225,3,0,0,156,1,0,0,188,0,0,0,189,0,0,0,13,1,0,0,36,0,0,0,157,1,0,0,79,2,0,0,14,1,0,0,158,1,0,0,94,0,0,0,80,2,0,0,81,2,0,0,231,2,0,0,39,0,0,0,82,2,0,0,40,0,0,0,83,2,0,0,0,0,0,0,24,74,0,0,226,3,0,0,227,3,0,0,187,0,0,0,159,1,0,0,15,1,0,0,179,0,0,0,55,0,0,0,228,3,0,0,160,1,0,0,188,0,0,0,189,0,0,0,16,1,0,0,36,0,0,0,161,1,0,0,84,2,0,0,17,1,0,0,162,1,0,0,95,0,0,0,85,2,0,0,86,2,0,0,231,2,0,0,39,0,0,0,87,2,0,0,40,0,0,0,88,2,0,0,0,0,0,0,8,74,0,0,229,3,0,0,230,3,0,0,187,0,0,0,163,1,0,0,18,1,0,0,179,0,0,0,55,0,0,0,231,3,0,0,164,1,0,0,188,0,0,0,189,0,0,0,19,1,0,0,36,0,0,0,165,1,0,0,89,2,0,0,20,1,0,0,166,1,0,0,96,0,0,0,90,2,0,0,91,2,0,0,231,2,0,0,39,0,0,0,92,2,0,0,40,0,0,0,93,2,0,0,0,0,0,0,248,73,0,0,232,3,0,0,233,3,0,0,187,0,0,0,167,1,0,0,21,1,0,0,179,0,0,0,55,0,0,0,234,3,0,0,168,1,0,0,188,0,0,0,189,0,0,0,22,1,0,0,36,0,0,0,169,1,0,0,94,2,0,0,23,1,0,0,170,1,0,0,97,0,0,0,95,2,0,0,96,2,0,0,231,2,0,0,39,0,0,0,97,2,0,0,40,0,0,0,98,2,0,0,0,0,0,0,232,73,0,0,235,3,0,0,236,3,0,0,187,0,0,0,171,1,0,0,24,1,0,0,179,0,0,0,55,0,0,0,237,3,0,0,172,1,0,0,188,0,0,0,189,0,0,0,25,1,0,0,36,0,0,0,173,1,0,0,99,2,0,0,26,1,0,0,174,1,0,0,98,0,0,0,100,2,0,0,101,2,0,0,231,2,0,0,39,0,0,0,102,2,0,0,40,0,0,0,103,2,0,0,0,0,0,0,216,73,0,0,238,3,0,0,239,3,0,0,187,0,0,0,175,1,0,0,27,1,0,0,179,0,0,0,55,0,0,0,240,3,0,0,176,1,0,0,188,0,0,0,189,0,0,0,28,1,0,0,36,0,0,0,177,1,0,0,104,2,0,0,29,1,0,0,178,1,0,0,99,0,0,0,105,2,0,0,106,2,0,0,231,2,0,0,39,0,0,0,107,2,0,0,40,0,0,0,108,2,0,0,0,0,0,0,184,73,0,0,241,3,0,0,242,3,0,0,187,0,0,0,179,1,0,0,30,1,0,0,179,0,0,0,55,0,0,0,243,3,0,0,180,1,0,0,188,0,0,0,189,0,0,0,31,1,0,0,36,0,0,0,181,1,0,0,109,2,0,0,32,1,0,0,182,1,0,0,100,0,0,0,110,2,0,0,111,2,0,0,231,2,0,0,39,0,0,0,112,2,0,0,40,0,0,0,113,2,0,0,0,0,0,0,168,73,0,0,244,3,0,0,245,3,0,0,187,0,0,0,183,1,0,0,33,1,0,0,179,0,0,0,55,0,0,0,246,3,0,0,184,1,0,0,188,0,0,0,189,0,0,0,34,1,0,0,36,0,0,0,185,1,0,0,114,2,0,0,35,1,0,0,186,1,0,0,101,0,0,0,115,2,0,0,116,2,0,0,231,2,0,0,39,0,0,0,117,2,0,0,40,0,0,0,118,2,0,0,0,0,0,0,152,73,0,0,247,3,0,0,248,3,0,0,187,0,0,0,187,1,0,0,36,1,0,0,179,0,0,0,55,0,0,0,249,3,0,0,188,1,0,0,188,0,0,0,189,0,0,0,37,1,0,0,36,0,0,0,189,1,0,0,119,2,0,0,38,1,0,0,190,1,0,0,102,0,0,0,120,2,0,0,121,2,0,0,231,2,0,0,39,0,0,0,122,2,0,0,40,0,0,0,123,2,0,0,0,0,0,0,136,73,0,0,250,3,0,0,251,3,0,0,187,0,0,0,191,1,0,0,39,1,0,0,179,0,0,0,55,0,0,0,252,3,0,0,192,1,0,0,188,0,0,0,189,0,0,0,40,1,0,0,36,0,0,0,193,1,0,0,124,2,0,0,41,1,0,0,194,1,0,0,103,0,0,0,125,2,0,0,126,2,0,0,231,2,0,0,39,0,0,0,127,2,0,0,40,0,0,0,128,2,0,0,0,0,0,0,120,73,0,0,253,3,0,0,254,3,0,0,187,0,0,0,195,1,0,0,42,1,0,0,179,0,0,0,55,0,0,0,255,3,0,0,196,1,0,0,188,0,0,0,189,0,0,0,43,1,0,0,36,0,0,0,197,1,0,0,129,2,0,0,44,1,0,0,198,1,0,0,104,0,0,0,130,2,0,0,131,2,0,0,231,2,0,0,39,0,0,0,132,2,0,0,40,0,0,0,133,2,0,0,0,0,0,0,104,73,0,0,0,4,0,0,1,4,0,0,187,0,0,0,199,1,0,0,45,1,0,0,179,0,0,0,55,0,0,0,2,4,0,0,200,1,0,0,188,0,0,0,189,0,0,0,46,1,0,0,36,0,0,0,201,1,0,0,134,2,0,0,47,1,0,0,202,1,0,0,105,0,0,0,135,2,0,0,136,2,0,0,231,2,0,0,39,0,0,0,137,2,0,0,40,0,0,0,138,2,0,0,0,0,0,0,88,73,0,0,3,4,0,0,4,4,0,0,187,0,0,0,203,1,0,0,48,1,0,0,179,0,0,0,55,0,0,0,5,4,0,0,204,1,0,0,188,0,0,0,189,0,0,0,49,1,0,0,36,0,0,0,205,1,0,0,139,2,0,0,50,1,0,0,206,1,0,0,106,0,0,0,140,2,0,0,141,2,0,0,231,2,0,0,39,0,0,0,142,2,0,0,40,0,0,0,143,2,0,0,92,3,13,0,127,69,6,0,187,69,6,0,77,0,0,0,1,0,0,0,0,0,0,0,184,77,0,0,5,0,0,0,6,4,0,0,7,4,0,0,0,0,0,0,200,77,0,0,193,2,0,0,8,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,42,0,0,0,43,0,0,0,23,0,0,0,24,0,0,0,51,1,0,0,45,0,0,0,76,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,29,0,0,0,107,0,0,0,100,3,13,0,156,75,6,0,204,74,6,0,137,0,0,0,1,0,0,0,96,3,13,0,109,194,6,0,0,0,0,0,108,3,13,0,95,76,6,0,204,74,6,0,151,0,0,0,1,0,0,0,104,3,13,0,109,194,6,0,0,0,0,0,0,0,0,0,216,77,0,0,14,0,0,0,9,4,0,0,144,2,0,0,0,0,0,0,248,77,0,0,5,0,0,0,10,4,0,0,11,4,0,0,0,0,0,0,8,78,0,0,193,2,0,0,12,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,44,0,0,0,45,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,31,0,0,0,12,0,0,0,116,3,13,0,209,77,6,0,130,77,6,0,83,0,0,0,1,0,0,0,112,3,13,0,109,194,6,0,0,0,0,0,124,3,13,0,102,78,6,0,130,77,6,0,91,0,0,0,1,0,0,0,120,3,13,0,109,194,6,0,0,0,0,0,0,0,0,0,40,78,0,0,5,0,0,0,13,4,0,0,14,4,0,0,0,0,0,0,56,78,0,0,193,2,0,0,15,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,46,0,0,0,47,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,32,0,0,0,12,0,0,0,132,3,13,0,245,79,6,0,157,79,6,0,74,0,0,0,1,0,0,0,128,3,13,0,109,194,6,0,0,0,0,0,140,3,13,0,214,80,6,0,157,79,6,0,82,0,0,0,1,0,0,0,136,3,13,0,109,194,6,0,0,0,0,0,0,0,0,0,88,78,0,0,5,0,0,0,16,4,0,0,17,4,0,0,0,0,0,0,104,78,0,0,193,2,0,0,18,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,48,0,0,0,49,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,33,0,0,0,108,0,0,0,148,3,13,0,75,82,6,0,252,81,6,0,41,0,0,0,1,0,0,0,144,3,13,0,109,194,6,0,0,0,0,0,156,3,13,0,200,82,6,0,252,81,6,0,49,0,0,0,1,0,0,0,152,3,13,0,109,194,6,0,0,0,0,0,0,0,0,0,152,78,0,0,19,4,0,0,20,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,46,0,0,0,50,0,0,0,51,0,0,0,23,0,0,0,24,0,0,0,52,1,0,0,47,0,0,0,77,0,0,0,42,0,0,0,53,1,0,0,54,1,0,0,55,1,0,0,195,2,0,0,34,0,0,0,109,0,0,0,52,0,0,0,0,0,0,0,136,78,0,0,5,0,0,0,21,4,0,0,22,4,0,0,164,3,13,0,122,85,6,0,190,83,6,0,120,3,0,0,1,0,0,0,160,3,13,0,109,194,6,0,0,0,0,0,172,3,13,0,141,89,6,0,190,83,6,0,132,3,0,0,1,0,0,0,168,3,13,0,109,194,6,0,0,0,0,0,0,0,0,0,200,78,0,0,23,4,0,0,24,4,0,0,145,2,0,0,0,0,0,0,56,70,0,0,25,4,0,0,26,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,1,0,0,0,1,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,29,0,0,0,12,0,0,0,0,0,0,0,248,78,0,0,27,4,0,0,28,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,46,0,0,0,53,0,0,0,54,0,0,0,23,0,0,0,24,0,0,0,52,1,0,0,48,0,0,0,77,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,35,0,0,0,110,0,0,0,55,0,0,0,0,0,0,0,232,78,0,0,5,0,0,0,29,4,0,0,30,4,0,0,180,3,13,0,154,92,6,0,190,83,6,0,42,5,0,0,1,0,0,0,176,3,13,0,109,194,6,0,0,0,0,0,188,3,13,0,112,93,6,0,190,83,6,0,50,5,0,0,1,0,0,0,184,3,13,0,109,194,6,0,0,0,0,0,0,0,0,0,24,79,0,0,14,0,0,0,31,4,0,0,146,2,0,0,0,0,0,0,8,79,0,0,14,0,0,0,32,4,0,0,147,2,0,0,0,0,0,0,40,79,0,0,5,0,0,0,33,4,0,0,34,4,0,0,0,0,0,0,72,79,0,0,35,4,0,0,36,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,49,0,0,0,56,0,0,0,57,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,36,0,0,0,12,0,0,0,0,0,0,0,56,79,0,0,37,4,0,0,38,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,1,0,0,0,1,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,29,0,0,0,12,0,0,0,196,3,13,0,202,94,6,0,124,94,6,0,138,0,0,0,1,0,0,0,192,3,13,0,109,194,6,0,0,0,0,0,204,3,13,0,53,95,6,0,124,94,6,0,146,0,0,0,1,0,0,0,200,3,13,0,109,194,6,0,0,0,0,0,0,0,0,0,88,79,0,0,5,0,0,0,39,4,0,0,40,4,0,0,0,0,0,0,104,79,0,0,41,4,0,0,42,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,50,0,0,0,58,0,0,0,59,0,0,0,23,0,0,0,24,0,0,0,56,1,0,0,51,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,37,0,0,0,12,0,0,0,212,3,13,0,69,100,6,0,45,99,6,0,96,0,0,0,1,0,0,0,208,3,13,0,109,194,6,0,0,0,0,0,220,3,13,0,131,101,6,0,45,99,6,0,104,0,0,0,1,0,0,0,216,3,13,0,109,194,6,0,0,0,0,0,0,0,0,0,136,79,0,0,5,0,0,0,43,4,0,0,44,4,0,0,0,0,0,0,152,79,0,0,193,2,0,0,45,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,60,0,0,0,61,0,0,0,23,0,0,0,24,0,0,0,57,1,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,38,0,0,0,111,0,0,0,228,3,13,0,122,103,6,0,180,102,6,0,131,0,0,0,1,0,0,0,224,3,13,0,109,194,6,0,0,0,0,0,236,3,13,0,230,103,6,0,180,102,6,0,143,0,0,0,1,0,0,0,232,3,13,0,109,194,6,0,0,0,0,0,0,0,0,0,184,79,0,0,5,0,0,0,46,4,0,0,47,4,0,0,0,0,0,0,200,79,0,0,48,4,0,0,49,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,52,0,0,0,62,0,0,0,63,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,39,0,0,0,12,0,0,0,244,3,13,0,174,106,6,0,45,105,6,0,47,1,0,0,1,0,0,0,240,3,13,0,109,194,6,0,0,0,0,0,252,3,13,0,180,108,6,0,45,105,6,0,59,1,0,0,1,0,0,0,248,3,13,0,109,194,6,0,0,0,0,0,0,0,0,0,216,79,0,0,14,0,0,0,50,4,0,0,148,2,0,0,0,0,0,0,248,79,0,0,5,0,0,0,51,4,0,0,52,4,0,0,0,0,0,0,8,80,0,0,193,2,0,0,53,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,64,0,0,0,65,0,0,0,23,0,0,0,24,0,0,0,58,1,0,0,53,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,40,0,0,0,12,0,0,0,4,4,13,0,134,110,6,0,10,110,6,0,62,0,0,0,1,0,0,0,0,4,13,0,109,194,6,0,0,0,0,0,12,4,13,0,217,111,6,0,10,110,6,0,70,0,0,0,1,0,0,0,8,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,40,80,0,0,5,0,0,0,54,4,0,0,55,4,0,0,0,0,0,0,56,80,0,0,56,4,0,0,57,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,66,0,0,0,67,0,0,0,23,0,0,0,24,0,0,0,59,1,0,0,54,0,0,0,75,0,0,0,55,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,41,0,0,0,112,0,0,0,56,0,0,0,20,4,13,0,176,114,6,0,251,112,6,0,107,0,0,0,1,0,0,0,16,4,13,0,109,194,6,0,0,0,0,0,28,4,13,0,89,115,6,0,251,112,6,0,115,0,0,0,1,0,0,0,24,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,88,80,0,0,5,0,0,0,58,4,0,0,59,4,0,0,0,0,0,0,104,80,0,0,60,4,0,0,61,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,57,0,0,0,68,0,0,0,69,0,0,0,60,1,0,0,61,1,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,42,0,0,0,12,0,0,0,70,0,0,0,149,2,0,0,150,2,0,0,151,2,0,0,36,4,13,0,111,119,6,0,131,116,6,0,1,1,0,0,1,0,0,0,32,4,13,0,109,194,6,0,0,0,0,0,44,4,13,0,11,120,6,0,131,116,6,0,9,1,0,0,1,0,0,0,40,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,120,80,0,0,5,0,0,0,62,4,0,0,63,4,0,0,0,0,0,0,136,80,0,0,64,4,0,0,65,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,71,0,0,0,72,0,0,0,23,0,0,0,24,0,0,0,62,1,0,0,58,0,0,0,75,0,0,0,42,0,0,0,63,1,0,0,27,0,0,0,28,0,0,0,195,2,0,0,43,0,0,0,113,0,0,0,52,4,13,0,233,122,6,0,179,121,6,0,83,1,0,0,1,0,0,0,48,4,13,0,109,194,6,0,0,0,0,0,60,4,13,0,213,124,6,0,179,121,6,0,95,1,0,0,1,0,0,0,56,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,152,80,0,0,14,0,0,0,66,4,0,0,152,2,0,0,0,0,0,0,184,80,0,0,5,0,0,0,67,4,0,0,68,4,0,0,0,0,0,0,200,80,0,0,69,4,0,0,70,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,73,0,0,0,74,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,44,0,0,0,114,0,0,0,68,4,13,0,249,127,6,0,43,126,6,0,113,1,0,0,1,0,0,0,64,4,13,0,109,194,6,0,0,0,0,0,76,4,13,0,53,129,6,0,43,126,6,0,125,1,0,0,1,0,0,0,72,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,232,80,0,0,5,0,0,0,71,4,0,0,72,4,0,0,0,0,0,0,8,81,0,0,73,4,0,0,74,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,59,0,0,0,75,0,0,0,76,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,45,0,0,0,12,0,0,0,0,0,0,0,248,80,0,0,73,4,0,0,75,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,1,0,0,0,1,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,29,0,0,0,12,0,0,0,84,4,13,0,102,132,6,0,164,130,6,0,176,0,0,0,1,0,0,0,80,4,13,0,109,194,6,0,0,0,0,0,92,4,13,0,247,132,6,0,164,130,6,0,184,0,0,0,1,0,0,0,88,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,24,81,0,0,5,0,0,0,76,4,0,0,77,4,0,0,0,0,0,0,40,81,0,0,78,4,0,0,79,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,77,0,0,0,78,0,0,0,23,0,0,0,24,0,0,0,64,1,0,0,60,0,0,0,75,0,0,0,42,0,0,0,65,1,0,0,27,0,0,0,28,0,0,0,195,2,0,0,46,0,0,0,115,0,0,0,100,4,13,0,30,135,6,0,49,134,6,0,8,1,0,0,1,0,0,0,96,4,13,0,109,194,6,0,0,0,0,0,108,4,13,0,194,136,6,0,49,134,6,0,16,1,0,0,1,0,0,0,104,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,56,81,0,0,14,0,0,0,80,4,0,0,153,2,0,0,0,0,0,0,72,81,0,0,5,0,0,0,81,4,0,0,82,4,0,0,0,0,0,0,88,81,0,0,83,4,0,0,84,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,61,0,0,0,79,0,0,0,80,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,47,0,0,0,12,0,0,0,116,4,13,0,162,138,6,0,248,137,6,0,153,0,0,0,1,0,0,0,112,4,13,0,109,194,6,0,0,0,0,0,124,4,13,0,149,139,6,0,248,137,6,0,161,0,0,0,1,0,0,0,120,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,120,81,0,0,5,0,0,0,85,4,0,0,86,4,0,0,0,0,0,0,152,81,0,0,87,4,0,0,88,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,81,0,0,0,82,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,48,0,0,0,12,0,0,0,0,0,0,0,136,81,0,0,87,4,0,0,89,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,1,0,0,0,1,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+112640);allocate([75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,29,0,0,0,12,0,0,0,132,4,13,0,26,143,6,0,212,140,6,0,212,0,0,0,1,0,0,0,128,4,13,0,109,194,6,0,0,0,0,0,140,4,13,0,136,143,6,0,212,140,6,0,224,0,0,0,1,0,0,0,136,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,168,81,0,0,5,0,0,0,90,4,0,0,91,4,0,0,0,0,0,0,184,81,0,0,193,2,0,0,92,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,83,0,0,0,84,0,0,0,23,0,0,0,24,0,0,0,66,1,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,49,0,0,0,116,0,0,0,148,4,13,0,139,145,6,0,131,144,6,0,187,0,0,0,1,0,0,0,144,4,13,0,109,194,6,0,0,0,0,0,156,4,13,0,107,146,6,0,131,144,6,0,199,0,0,0,1,0,0,0,152,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,216,81,0,0,5,0,0,0,93,4,0,0,94,4,0,0,0,0,0,0,232,81,0,0,193,2,0,0,95,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,85,0,0,0,86,0,0,0,23,0,0,0,24,0,0,0,67,1,0,0,62,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,50,0,0,0,117,0,0,0,164,4,13,0,123,147,6,0,233,147,6,0,187,0,0,0,1,0,0,0,160,4,13,0,109,194,6,0,0,0,0,0,172,4,13,0,221,148,6,0,233,147,6,0,199,0,0,0,1,0,0,0,168,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,8,82,0,0,5,0,0,0,96,4,0,0,97,4,0,0,0,0,0,0,24,82,0,0,98,4,0,0,99,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,87,0,0,0,88,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,51,0,0,0,12,0,0,0,192,4,13,0,23,152,6,0,202,150,6,0,105,1,0,0,1,0,0,0,188,4,13,0,109,194,6,0,0,0,0,0,200,4,13,0,11,155,6,0,202,150,6,0,117,1,0,0,1,0,0,0,196,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,72,82,0,0,193,2,0,0,100,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,89,0,0,0,90,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,52,0,0,0,12,0,0,0,0,0,0,0,56,82,0,0,5,0,0,0,101,4,0,0,102,4,0,0,208,4,13,0,161,156,6,0,254,155,6,0,74,0,0,0,1,0,0,0,204,4,13,0,109,194,6,0,0,0,0,0,216,4,13,0,13,157,6,0,254,155,6,0,86,0,0,0,1,0,0,0,212,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,104,82,0,0,5,0,0,0,103,4,0,0,104,4,0,0,0,0,0,0,120,82,0,0,193,2,0,0,105,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,91,0,0,0,92,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,29,0,0,0,118,0,0,0,224,4,13,0,49,158,6,0,155,158,6,0,65,0,0,0,1,0,0,0,220,4,13,0,109,194,6,0,0,0,0,0,232,4,13,0,232,158,6,0,155,158,6,0,73,0,0,0,1,0,0,0,228,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,152,82,0,0,5,0,0,0,106,4,0,0,107,4,0,0,0,0,0,0,168,82,0,0,193,2,0,0,108,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,93,0,0,0,94,0,0,0,23,0,0,0,24,0,0,0,68,1,0,0,63,0,0,0,75,0,0,0,64,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,53,0,0,0,119,0,0,0,240,4,13,0,85,160,6,0,6,160,6,0,49,0,0,0,1,0,0,0,236,4,13,0,109,194,6,0,0,0,0,0,248,4,13,0,70,161,6,0,6,160,6,0,57,0,0,0,1,0,0,0,244,4,13,0,109,194,6,0,0,0,0,0,0,0,0,0,184,82,0,0,5,0,0,0,109,4,0,0,110,4,0,0,0,0,0,0,200,82,0,0,193,2,0,0,111,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,95,0,0,0,96,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,54,0,0,0,12,0,0,0,0,5,13,0,75,163,6,0,99,162,6,0,42,0,0,0,1,0,0,0,252,4,13,0,109,194,6,0,0,0,0,0,8,5,13,0,219,163,6,0,99,162,6,0,50,0,0,0,1,0,0,0,4,5,13,0,109,194,6,0,0,0,0,0,0,0,0,0,248,82,0,0,193,2,0,0,112,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,97,0,0,0,98,0,0,0,23,0,0,0,24,0,0,0,69,1,0,0,65,0,0,0,75,0,0,0,66,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,55,0,0,0,120,0,0,0,53,0,0,0,0,0,0,0,232,82,0,0,5,0,0,0,113,4,0,0,114,4,0,0,12,5,13,0,47,165,6,0,209,165,6,0,161,0,0,0,1,0,0,0,16,5,13,0,205,166,6,0,209,165,6,0,172,0,0,0,1,0,0,0,0,0,0,0,8,83,0,0,14,0,0,0,115,4,0,0,154,2,0,0,0,0,0,0,40,83,0,0,193,2,0,0,116,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,99,0,0,0,100,0,0,0,23,0,0,0,24,0,0,0,70,1,0,0,67,0,0,0,75,0,0,0,68,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,56,0,0,0,121,0,0,0,54,0,0,0,0,0,0,0,24,83,0,0,5,0,0,0,117,4,0,0,118,4,0,0,20,5,13,0,58,168,6,0,209,165,6,0,161,0,0,0,1,0,0,0,24,5,13,0,21,169,6,0,209,165,6,0,172,0,0,0,1,0,0,0,0,0,0,0,56,83,0,0,14,0,0,0,119,4,0,0,155,2,0,0,0,0,0,0,104,83,0,0,193,2,0,0,120,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,101,0,0,0,102,0,0,0,23,0,0,0,24,0,0,0,71,1,0,0,69,0,0,0,75,0,0,0,70,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,57,0,0,0,122,0,0,0,55,0,0,0,0,0,0,0,88,83,0,0,5,0,0,0,121,4,0,0,122,4,0,0,28,5,13,0,121,170,6,0,209,165,6,0,161,0,0,0,1,0,0,0,32,5,13,0,81,171,6,0,209,165,6,0,172,0,0,0,1,0,0,0,0,0,0,0,120,83,0,0,14,0,0,0,123,4,0,0,156,2,0,0,0,0,0,0,168,83,0,0,193,2,0,0,124,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,103,0,0,0,104,0,0,0,23,0,0,0,24,0,0,0,72,1,0,0,71,0,0,0,75,0,0,0,72,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,58,0,0,0,123,0,0,0,56,0,0,0,0,0,0,0,152,83,0,0,5,0,0,0,125,4,0,0,126,4,0,0,36,5,13,0,179,172,6,0,209,165,6,0,161,0,0,0,1,0,0,0,40,5,13,0,148,173,6,0,209,165,6,0,172,0,0,0,1,0,0,0,0,0,0,0,184,83,0,0,14,0,0,0,127,4,0,0,157,2,0,0,0,0,0,0,232,83,0,0,193,2,0,0,128,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,105,0,0,0,106,0,0,0,23,0,0,0,24,0,0,0,73,1,0,0,73,0,0,0,75,0,0,0,74,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,59,0,0,0,124,0,0,0,57,0,0,0,0,0,0,0,216,83,0,0,5,0,0,0,129,4,0,0,130,4,0,0,44,5,13,0,255,174,6,0,209,165,6,0,161,0,0,0,1,0,0,0,48,5,13,0,212,175,6,0,209,165,6,0,172,0,0,0,1,0,0,0,0,0,0,0,248,83,0,0,14,0,0,0,131,4,0,0,158,2,0,0,0,0,0,0,40,84,0,0,193,2,0,0,132,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,107,0,0,0,108,0,0,0,23,0,0,0,24,0,0,0,74,1,0,0,75,0,0,0,75,0,0,0,76,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,60,0,0,0,125,0,0,0,58,0,0,0,0,0,0,0,24,84,0,0,5,0,0,0,133,4,0,0,134,4,0,0,52,5,13,0,49,177,6,0,209,165,6,0,161,0,0,0,1,0,0,0,56,5,13,0,15,178,6,0,209,165,6,0,172,0,0,0,1,0,0,0,0,0,0,0,56,84,0,0,14,0,0,0,135,4,0,0,159,2,0,0,0,0,0,0,104,84,0,0,193,2,0,0,136,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,109,0,0,0,110,0,0,0,23,0,0,0,24,0,0,0,75,1,0,0,77,0,0,0,75,0,0,0,78,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,61,0,0,0,126,0,0,0,59,0,0,0,0,0,0,0,88,84,0,0,5,0,0,0,137,4,0,0,138,4,0,0,60,5,13,0,115,179,6,0,209,165,6,0,161,0,0,0,1,0,0,0,64,5,13,0,75,180,6,0,209,165,6,0,172,0,0,0,1,0,0,0,0,0,0,0,120,84,0,0,14,0,0,0,139,4,0,0,160,2,0,0,0,0,0,0,168,84,0,0,193,2,0,0,140,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,111,0,0,0,112,0,0,0,23,0,0,0,24,0,0,0,76,1,0,0,79,0,0,0,75,0,0,0,80,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,62,0,0,0,127,0,0,0,60,0,0,0,0,0,0,0,152,84,0,0,5,0,0,0,141,4,0,0,142,4,0,0,68,5,13,0,189,181,6,0,209,165,6,0,161,0,0,0,1,0,0,0,72,5,13,0,152,182,6,0,209,165,6,0,172,0,0,0,1,0,0,0,0,0,0,0,184,84,0,0,14,0,0,0,143,4,0,0,161,2,0,0,0,0,0,0,216,84,0,0,5,0,0,0,144,4,0,0,145,4,0,0,0,0,0,0,232,84,0,0,146,4,0,0,147,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,113,0,0,0,114,0,0,0,23,0,0,0,24,0,0,0,77,1,0,0,81,0,0,0,75,0,0,0,82,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,63,0,0,0,128,0,0,0,61,0,0,0,76,5,13,0,136,184,6,0,209,165,6,0,161,0,0,0,1,0,0,0,80,5,13,0,123,185,6,0,209,165,6,0,172,0,0,0,1,0,0,0,0,0,0,0,248,84,0,0,14,0,0,0,148,4,0,0,162,2,0,0,0,0,0,0,8,85,0,0,5,0,0,0,149,4,0,0,150,4,0,0,0,0,0,0,24,85,0,0,193,2,0,0,151,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,115,0,0,0,116,0,0,0,23,0,0,0,24,0,0,0,78,1,0,0,83,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,64,0,0,0,12,0,0,0,88,5,13,0,86,187,6,0,191,186,6,0,230,0,0,0,1,0,0,0,84,5,13,0,109,194,6,0,0,0,0,0,96,5,13,0,214,188,6,0,191,186,6,0,242,0,0,0,1,0,0,0,92,5,13,0,109,194,6,0,0,0,0,0,0,0,0,0,40,85,0,0,152,4,0,0,153,4,0,0,163,2,0,0,0,0,0,0,56,85,0,0,5,0,0,0,154,4,0,0,155,4,0,0,0,0,0,0,72,85,0,0,193,2,0,0,156,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,117,0,0,0,118,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,65,0,0,0,12,0,0,0,104,5,13,0,129,190,6,0,192,189,6,0,133,0,0,0,1,0,0,0,100,5,13,0,109,194,6,0,0,0,0,0,112,5,13,0,239,190,6,0,192,189,6,0,146,0,0,0,1,0,0,0,108,5,13,0,109,194,6,0,0,0,0,0,0,0,0,0,104,85,0,0,5,0,0,0,157,4,0,0,158,4,0,0,0,0,0,0,120,85,0,0,159,4,0,0,160,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,84,0,0,0,119,0,0,0,120,0,0,0,23,0,0,0,24,0,0,0,79,1,0,0,85,0,0,0,78,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,66,0,0,0,129,0,0,0,86,0,0,0,87,0,0,0,0,0,0,0,24,70,0,0,159,4,0,0,161,4,0,0,59,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,40,0,0,0,1,0,0,0,1,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,41,0,0,0,75,0,0,0,42,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,195,2,0,0,29,0,0,0,12,0,0,0,120,5,13,0,114,194,6,0,61,192,6,0,180,0,0,0,1,0,0,0,116,5,13,0,109,194,6,0,0,0,0,0,128,5,13,0,206,196,6,0,61,192,6,0,192,0,0,0,1,0,0,0,124,5,13,0,109,194,6,0,0,0,0,0,0,0,0,0,136,85,0,0,162,4,0,0,163,4,0,0,164,2,0,0,207,1,0,0,130,0,0,0,131,0,0,0,132,0,0,0,133,0,0,0,134,0,0,0,135,0,0,0,136,0,0,0,137,0,0,0,165,2,0,0,164,4,0,0,208,1,0,0,165,4,0,0,166,4,0,0,83,204,6,0,99,204,6,0,178,40,17,0,110,204,6,0,121,204,6,0,134,204,6,0,145,204,6,0,165,204,6,0,178,204,6,0,178,40,17,0,0,0,0,0,150,48,7,119,44,97,14,238,186,81,9,153,25,196,109,7,143,244,106,112,53,165,99,233,163,149,100,158,50,136,219,14,164,184,220,121,30,233,213,224,136,217,210,151,43,76,182,9,189,124,177,126,7,45,184,231,145,29,191,144,100,16,183,29,242,32,176,106,72,113,185,243,222,65,190,132,125,212,218,26,235,228,221,109,81,181,212,244,199,133,211,131,86,152,108,19,192,168,107,100,122,249,98,253,236,201,101,138,79,92,1,20,217,108,6,99,99,61,15,250,245,13,8,141,200,32,110,59,94,16,105,76,228,65,96,213,114,113,103,162,209,228,3,60,71,212,4,75,253,133,13,210,107,181,10,165,250,168,181,53,108,152,178,66,214,201,187,219,64,249,188,172,227,108,216,50,117,92,223,69,207,13,214,220,89,61,209,171,172,48,217,38,58,0,222,81,128,81,215,200,22,97,208,191,181,244,180,33,35,196,179,86,153,149,186,207,15,165,189,184,158,184,2,40,8,136,5,95,178,217,12,198,36,233,11,177,135,124,111,47,17,76,104,88,171,29,97,193,61,45,102,182,144,65,220,118,6,113,219,1,188,32,210,152,42,16,213,239,137,133,177,113,31,181,182,6,165,228,191,159,51,212,184,232,162,201,7,120,52,249,0,15,142,168,9,150,24,152,14,225,187,13,106,127,45,61,109,8,151,108,100,145,1,92,99,230,244,81,107,107,98,97,108,28,216,48,101,133,78,0,98,242,237,149,6,108,123,165,1,27,193,244,8,130,87,196,15,245,198,217,176,101,80,233,183,18,234,184,190,139,124,136,185,252,223,29,221,98,73,45,218,21,243,124,211,140,101,76,212,251,88,97,178,77,206,81,181,58,116,0,188,163,226,48,187,212,65,165,223,74,215,149,216,61,109,196,209,164,251,244,214,211,106,233,105,67,252,217,110,52,70,136,103,173,208,184,96,218,115,45,4,68,229,29,3,51,95,76,10,170,201,124,13,221,60,113,5,80,170,65,2,39,16,16,11,190,134,32,12,201,37,181,104,87,179,133,111,32,9,212,102,185,159,228,97,206,14,249,222,94,152,201,217,41,34,152,208,176,180,168,215,199,23,61,179,89,129,13,180,46,59,92,189,183,173,108,186,192,32,131,184,237,182,179,191,154,12,226,182,3,154,210,177,116,57,71,213,234,175,119,210,157,21,38,219,4,131,22,220,115,18,11,99,227,132,59,100,148,62,106,109,13,168,90,106,122,11,207,14,228,157,255,9,147,39,174,0,10,177,158,7,125,68,147,15,240,210,163,8,135,104,242,1,30,254,194,6,105,93,87,98,247,203,103,101,128,113,54,108,25,231,6,107,110,118,27,212,254,224,43,211,137,90,122,218,16,204,74,221,103,111,223,185,249,249,239,190,142,67,190,183,23,213,142,176,96,232,163,214,214,126,147,209,161,196,194,216,56,82,242,223,79,241,103,187,209,103,87,188,166,221,6,181,63,75,54,178,72,218,43,13,216,76,27,10,175,246,74,3,54,96,122,4,65,195,239,96,223,85,223,103,168,239,142,110,49,121,190,105,70,140,179,97,203,26,131,102,188,160,210,111,37,54,226,104,82,149,119,12,204,3,71,11,187,185,22,2,34,47,38,5,85,190,59,186,197,40,11,189,178,146,90,180,43,4,106,179,92,167,255,215,194,49,207,208,181,139,158,217,44,29,174,222,91,176,194,100,155,38,242,99,236,156,163,106,117,10,147,109,2,169,6,9,156,63,54,14,235,133,103,7,114,19,87,0,5,130,74,191,149,20,122,184,226,174,43,177,123,56,27,182,12,155,142,210,146,13,190,213,229,183,239,220,124,33,223,219,11,212,210,211,134,66,226,212,241,248,179,221,104,110,131,218,31,205,22,190,129,91,38,185,246,225,119,176,111,119,71,183,24,230,90,8,136,112,106,15,255,202,59,6,102,92,11,1,17,255,158,101,143,105,174,98,248,211,255,107,97,69,207,108,22,120,226,10,160,238,210,13,215,84,131,4,78,194,179,3,57,97,38,103,167,247,22,96,208,77,71,105,73,219,119,110,62,74,106,209,174,220,90,214,217,102,11,223,64,240,59,216,55,83,174,188,169,197,158,187,222,127,207,178,71,233,255,181,48,28,242,189,189,138,194,186,202,48,147,179,83,166,163,180,36,5,54,208,186,147,6,215,205,41,87,222,84,191,103,217,35,46,122,102,179,184,74,97,196,2,27,104,93,148,43,111,42,55,190,11,180,161,142,12,195,27,223,5,90,141,239,2,45,0,0,0,0,65,49,27,25,130,98,54,50,195,83,45,43,4,197,108,100,69,244,119,125,134,167,90,86,199,150,65,79,8,138,217,200,73,187,194,209,138,232,239,250,203,217,244,227,12,79,181,172,77,126,174,181,142,45,131,158,207,28,152,135,81,18,194,74,16,35,217,83,211,112,244,120,146,65,239,97,85,215,174,46,20,230,181,55,215,181,152,28,150,132,131,5,89,152,27,130,24,169,0,155,219,250,45,176,154,203,54,169,93,93,119,230,28,108,108,255,223,63,65,212,158,14,90,205,162,36,132,149,227,21,159,140,32,70,178,167,97,119,169,190,166,225,232,241,231,208,243,232,36,131,222,195,101,178,197,218,170,174,93,93,235,159,70,68,40,204,107,111,105,253,112,118,174,107,49,57,239,90,42,32,44,9,7,11,109,56,28,18,243,54,70,223,178,7,93,198,113,84,112,237,48,101,107,244,247,243,42,187,182,194,49,162,117,145,28,137,52,160,7,144,251,188,159,23,186,141,132,14,121,222,169,37,56,239,178,60,255,121,243,115,190,72,232,106,125,27,197,65,60,42,222,88,5,79,121,240,68,126,98,233,135,45,79,194,198,28,84,219,1,138,21,148,64,187,14,141,131,232,35,166,194,217,56,191,13,197,160,56,76,244,187,33,143,167,150,10,206,150,141,19,9,0,204,92,72,49,215,69,139,98,250,110,202,83,225,119,84,93,187,186,21,108,160,163,214,63,141,136,151,14,150,145,80,152,215,222,17,169,204,199,210,250,225,236,147,203,250,245,92,215,98,114,29,230,121,107,222,181,84,64,159,132,79,89,88,18,14,22,25,35,21,15,218,112,56,36,155,65,35,61,167,107,253,101,230,90,230,124,37,9,203,87,100,56,208,78,163,174,145,1,226,159,138,24,33,204,167,51,96,253,188,42,175,225,36,173,238,208,63,180,45,131,18,159,108,178,9,134,171,36,72,201,234,21,83,208,41,70,126,251,104,119,101,226,246,121,63,47,183,72,36,54,116,27,9,29,53,42,18,4,242,188,83,75,179,141,72,82,112,222,101,121,49,239,126,96,254,243,230,231,191,194,253,254,124,145,208,213,61,160,203,204,250,54,138,131,187,7,145,154,120,84,188,177,57,101,167,168,75,152,131,59,10,169,152,34,201,250,181,9,136,203,174,16,79,93,239,95,14,108,244,70,205,63,217,109,140,14,194,116,67,18,90,243,2,35,65,234,193,112,108,193,128,65,119,216,71,215,54,151,6,230,45,142,197,181,0,165,132,132,27,188,26,138,65,113,91,187,90,104,152,232,119,67,217,217,108,90,30,79,45,21,95,126,54,12,156,45,27,39,221,28,0,62,18,0,152,185,83,49,131,160,144,98,174,139,209,83,181,146,22,197,244,221,87,244,239,196,148,167,194,239,213,150,217,246,233,188,7,174,168,141,28,183,107,222,49,156,42,239,42,133,237,121,107,202,172,72,112,211,111,27,93,248,46,42,70,225,225,54,222,102,160,7,197,127,99,84,232,84,34,101,243,77,229,243,178,2,164,194,169,27,103,145,132,48,38,160,159,41,184,174,197,228,249,159,222,253,58,204,243,214,123,253,232,207,188,107,169,128,253,90,178,153,62,9,159,178,127,56,132,171,176,36,28,44,241,21,7,53,50,70,42,30,115,119,49,7,180,225,112,72,245,208,107,81,54,131,70,122,119,178,93,99,78,215,250,203,15,230,225,210,204,181,204,249,141,132,215,224,74,18,150,175,11,35,141,182,200,112,160,157,137,65,187,132,70,93,35,3,7,108,56,26,196,63,21,49,133,14,14,40,66,152,79,103,3,169,84,126,192,250,121,85,129,203,98,76,31,197,56,129,94,244,35,152,157,167,14,179,220,150,21,170,27,0,84,229,90,49,79,252,153,98,98,215,216,83,121,206,23,79,225,73,86,126,250,80,149,45,215,123,212,28,204,98,19,138,141,45,82,187,150,52,145,232,187,31,208,217,160,6,236,243,126,94,173,194,101,71,110,145,72,108,47,160,83,117,232,54,18,58,169,7,9,35,106,84,36,8,43,101,63,17,228,121,167,150,165,72,188,143,102,27,145,164,39,42,138,189,224,188,203,242,161,141,208,235,98,222,253,192,35,239,230,217,189,225,188,20,252,208,167,13,63,131,138,38,126,178,145,63,185,36,208,112,248,21,203,105,59,70,230,66,122,119,253,91,181,107,101,220,244,90,126,197,55,9,83,238,118,56,72,247,177,174,9,184,240,159,18,161,51,204,63,138,114,253,36,147,0,0,0,0,55,106,194,1,110,212,132,3,89,190,70,2,220,168,9,7,235,194,203,6,178,124,141,4,133,22,79,5,184,81,19,14,143,59,209,15,214,133,151,13,225,239,85,12,100,249,26,9,83,147,216,8,10,45,158,10,61,71,92,11,112,163,38,28,71,201,228,29,30,119,162,31,41,29,96,30,172,11,47,27,155,97,237,26,194,223,171,24,245,181,105,25,200,242,53,18,255,152,247,19,166,38,177,17,145,76,115,16,20,90,60,21,35,48,254,20,122,142,184,22,77,228,122,23,224,70,77,56,215,44,143,57,142,146,201,59,185,248,11,58,60,238,68,63,11,132,134,62,82,58,192,60,101,80,2,61,88,23,94,54,111,125,156,55,54,195,218,53,1,169,24,52,132,191,87,49,179,213,149,48,234,107,211,50,221,1,17,51,144,229,107,36,167,143,169,37,254,49,239,39,201,91,45,38,76,77,98,35,123,39,160,34,34,153,230,32,21,243,36,33,40,180,120,42,31,222,186,43,70,96,252,41,113,10,62,40,244,28,113,45,195,118,179,44,154,200,245,46,173,162,55,47,192,141,154,112,247,231,88,113,174,89,30,115,153,51,220,114,28,37,147,119,43,79,81,118,114,241,23,116,69,155,213,117,120,220,137,126,79,182,75,127,22,8,13,125,33,98,207,124,164,116,128,121,147,30,66,120,202,160,4,122,253,202,198,123,176,46,188,108,135,68,126,109,222,250,56,111,233,144,250,110,108,134,181,107,91,236,119,106,2,82,49,104,53,56,243,105,8,127,175,98,63,21,109,99,102,171,43,97,81,193,233,96,212,215,166,101,227,189,100,100,186,3,34,102,141,105,224,103,32,203,215,72,23,161,21,73,78,31,83,75,121,117,145,74,252,99,222,79,203,9,28,78,146,183,90,76,165,221,152,77,152,154,196,70,175,240,6,71,246,78,64,69,193,36,130,68,68,50,205,65,115,88,15,64,42,230,73,66,29,140,139,67,80,104,241,84,103,2,51,85,62,188,117,87,9,214,183,86,140,192,248,83,187,170,58,82,226,20,124,80,213,126,190,81,232,57,226,90,223,83,32,91,134,237,102,89,177,135,164,88,52,145,235,93,3,251,41,92,90,69,111,94,109,47,173,95,128,27,53,225,183,113,247,224,238,207,177,226,217,165,115,227,92,179,60,230,107,217,254,231,50,103,184,229,5,13,122,228,56,74,38,239,15,32,228,238,86,158,162,236,97,244,96,237,228,226,47,232,211,136,237,233,138,54,171,235,189,92,105,234,240,184,19,253,199,210,209,252,158,108,151,254,169,6,85,255,44,16,26,250,27,122,216,251,66,196,158,249,117,174,92,248,72,233,0,243,127,131,194,242,38,61,132,240,17,87,70,241,148,65,9,244,163,43,203,245,250,149,141,247,205,255,79,246,96,93,120,217,87,55,186,216,14,137,252,218,57,227,62,219,188,245,113,222,139,159,179,223,210,33,245,221,229,75,55,220,216,12,107,215,239,102,169,214,182,216,239,212,129,178,45,213,4,164,98,208,51,206,160,209,106,112,230,211,93,26,36,210,16,254,94,197,39,148,156,196,126,42,218,198,73,64,24,199,204,86,87,194,251,60,149,195,162,130,211,193,149,232,17,192,168,175,77,203,159,197,143,202,198,123,201,200,241,17,11,201,116,7,68,204,67,109,134,205,26,211,192,207,45,185,2,206,64,150,175,145,119,252,109,144,46,66,43,146,25,40,233,147,156,62,166,150,171,84,100,151,242,234,34,149,197,128,224,148,248,199,188,159,207,173,126,158,150,19,56,156,161,121,250,157,36,111,181,152,19,5,119,153,74,187,49,155,125,209,243,154,48,53,137,141,7,95,75,140,94,225,13,142,105,139,207,143,236,157,128,138,219,247,66,139,130,73,4,137,181,35,198,136,136,100,154,131,191,14,88,130,230,176,30,128,209,218,220,129,84,204,147,132,99,166,81,133,58,24,23,135,13,114,213,134,160,208,226,169,151,186,32,168,206,4,102,170,249,110,164,171,124,120,235,174,75,18,41,175,18,172,111,173,37,198,173,172,24,129,241,167,47,235,51,166,118,85,117,164,65,63,183,165,196,41,248,160,243,67,58,161,170,253,124,163,157,151,190,162,208,115,196,181,231,25,6,180,190,167,64,182,137,205,130,183,12,219,205,178,59,177,15,179,98,15,73,177,85,101,139,176,104,34,215,187,95,72,21,186,6,246,83,184,49,156,145,185,180,138,222,188,131,224,28,189,218,94,90,191,237,52,152,190,0,0,0,0,101,103,188,184,139,200,9,170,238,175,181,18,87,151,98,143,50,240,222,55,220,95,107,37,185,56,215,157,239,40,180,197,138,79,8,125,100,224,189,111,1,135,1,215,184,191,214,74,221,216,106,242,51,119,223,224,86,16,99,88,159,87,25,80,250,48,165,232,20,159,16,250,113,248,172,66,200,192,123,223,173,167,199,103,67,8,114,117,38,111,206,205,112,127,173,149,21,24,17,45,251,183,164,63,158,208,24,135,39,232,207,26,66,143,115,162,172,32,198,176,201,71,122,8,62,175,50,160,91,200,142,24,181,103,59,10,208,0,135,178,105,56,80,47,12,95,236,151,226,240,89,133,135,151,229,61,209,135,134,101,180,224,58,221,90,79,143,207,63,40,51,119,134,16,228,234,227,119,88,82,13,216,237,64,104,191,81,248,161,248,43,240,196,159,151,72,42,48,34,90,79,87,158,226,246,111,73,127,147,8,245,199,125,167,64,213,24,192,252,109,78,208,159,53,43,183,35,141,197,24,150,159,160,127,42,39,25,71,253,186,124,32,65,2,146,143,244,16,247,232,72,168,61,88,20,155,88,63,168,35,182,144,29,49,211,247,161,137,106,207,118,20,15,168,202,172,225,7,127,190,132,96,195,6,210,112,160,94,183,23,28,230,89,184,169,244,60,223,21,76,133,231,194,209,224,128,126,105,14,47,203,123,107,72,119,195,162,15,13,203,199,104,177,115,41,199,4,97,76,160,184,217,245,152,111,68,144,255,211,252,126,80,102,238,27,55,218,86,77,39,185,14,40,64,5,182,198,239,176,164,163,136,12,28,26,176,219,129,127,215,103,57,145,120,210,43,244,31,110,147,3,247,38,59,102,144,154,131,136,63,47,145,237,88,147,41,84,96,68,180,49,7,248,12,223,168,77,30,186,207,241,166,236,223,146,254,137,184,46,70,103,23,155,84,2,112,39,236,187,72,240,113,222,47,76,201,48,128,249,219,85,231,69,99,156,160,63,107,249,199,131,211,23,104,54,193,114,15,138,121,203,55,93,228,174,80,225,92,64,255,84,78,37,152,232,246,115,136,139,174,22,239,55,22,248,64,130,4,157,39,62,188,36,31,233,33,65,120,85,153,175,215,224,139,202,176,92,51,59,182,89,237,94,209,229,85,176,126,80,71,213,25,236,255,108,33,59,98,9,70,135,218,231,233,50,200,130,142,142,112,212,158,237,40,177,249,81,144,95,86,228,130,58,49,88,58,131,9,143,167,230,110,51,31,8,193,134,13,109,166,58,181,164,225,64,189,193,134,252,5,47,41,73,23,74,78,245,175,243,118,34,50,150,17,158,138,120,190,43,152,29,217,151,32,75,201,244,120,46,174,72,192,192,1,253,210,165,102,65,106,28,94,150,247,121,57,42,79,151,150,159,93,242,241,35,229,5,25,107,77,96,126,215,245,142,209,98,231,235,182,222,95,82,142,9,194,55,233,181,122,217,70,0,104,188,33,188,208,234,49,223,136,143,86,99,48,97,249,214,34,4,158,106,154,189,166,189,7,216,193,1,191,54,110,180,173,83,9,8,21,154,78,114,29,255,41,206,165,17,134,123,183,116,225,199,15,205,217,16,146,168,190,172,42,70,17,25,56,35,118,165,128,117,102,198,216,16,1,122,96,254,174,207,114,155,201,115,202,34,241,164,87,71,150,24,239,169,57,173,253,204,94,17,69,6,238,77,118,99,137,241,206,141,38,68,220,232,65,248,100,81,121,47,249,52,30,147,65,218,177,38,83,191,214,154,235,233,198,249,179,140,161,69,11,98,14,240,25,7,105,76,161,190,81,155,60,219,54,39,132,53,153,146,150,80,254,46,46,153,185,84,38,252,222,232,158,18,113,93,140,119,22,225,52,206,46,54,169,171,73,138,17,69,230,63,3,32,129,131,187,118,145,224,227,19,246,92,91,253,89,233,73,152,62,85,241,33,6,130,108,68,97,62,212,170,206,139,198,207,169,55,126,56,65,127,214,93,38,195,110,179,137,118,124,214,238,202,196,111,214,29,89,10,177,161,225,228,30,20,243,129,121,168,75,215,105,203,19,178,14,119,171,92,161,194,185,57,198,126,1,128,254,169,156,229,153,21,36,11,54,160,54,110,81,28,142,167,22,102,134,194,113,218,62,44,222,111,44,73,185,211,148,240,129,4,9,149,230,184,177,123,73,13,163,30,46,177,27,72,62,210,67,45,89,110,251,195,246,219,233,166,145,103,81,31,169,176,204,122,206,12,116,148,97,185,102,241,6,5,222,0,0,0,0,119,7,48,150,238,14,97,44,153,9,81,186,7,109,196,25,112,106,244,143,233,99,165,53,158,100,149,163,14,219,136,50,121,220,184,164,224,213,233,30,151,210,217,136,9,182,76,43,126,177,124,189,231,184,45,7,144,191,29,145,29,183,16,100,106,176,32,242,243,185,113,72,132,190,65,222,26,218,212,125,109,221,228,235,244,212,181,81,131,211,133,199,19,108,152,86,100,107,168,192,253,98,249,122,138,101,201,236,20,1,92,79,99,6,108,217,250,15,61,99,141,8,13,245,59,110,32,200,76,105,16,94,213,96,65,228,162,103,113,114,60,3,228,209,75,4,212,71,210,13,133,253,165,10,181,107,53,181,168,250,66,178,152,108,219,187,201,214,172,188,249,64,50,216,108,227,69,223,92,117,220,214,13,207,171,209,61,89,38,217,48,172,81,222,0,58,200,215,81,128,191,208,97,22,33,180,244,181,86,179,196,35,207,186,149,153,184,189,165,15,40,2,184,158,95,5,136,8,198,12,217,178,177,11,233,36,47,111,124,135,88,104,76,17,193,97,29,171,182,102,45,61,118,220,65,144,1,219,113,6,152,210,32,188,239,213,16,42,113,177,133,137,6,182,181,31,159,191,228,165,232,184,212,51,120,7,201,162,15,0,249,52,150,9,168,142,225,14,152,24,127,106,13,187,8,109,61,45,145,100,108,151,230,99,92,1,107,107,81,244,28,108,97,98,133,101,48,216,242,98,0,78,108,6,149,237,27,1,165,123,130,8,244,193,245,15,196,87,101,176,217,198,18,183,233,80,139,190,184,234,252,185,136,124,98,221,29,223,21,218,45,73,140,211,124,243,251,212,76,101,77,178,97,88,58,181,81,206,163,188,0,116,212,187,48,226,74,223,165,65,61,216,149,215,164,209,196,109,211,214,244,251,67,105,233,106,52,110,217,252,173,103,136,70,218,96,184,208,68,4,45,115,51,3,29,229,170,10,76,95,221,13,124,201,80,5,113,60,39,2,65,170,190,11,16,16,201,12,32,134,87,104,181,37,32,111,133,179,185,102,212,9,206,97,228,159,94,222,249,14,41,217,201,152,176,208,152,34,199,215,168,180,89,179,61,23,46,180,13,129,183,189,92,59,192,186,108,173,237,184,131,32,154,191,179,182,3,182,226,12,116,177,210,154,234,213,71,57,157,210,119,175,4,219,38,21,115,220,22,131,227,99,11,18,148,100,59,132,13,109,106,62,122,106,90,168,228,14,207,11,147,9,255,157,10,0,174,39,125,7,158,177,240,15,147,68,135,8,163,210,30,1,242,104,105,6,194,254,247,98,87,93,128,101,103,203,25,108,54,113,110,107,6,231,254,212,27,118,137,211,43,224,16,218,122,90,103,221,74,204,249,185,223,111,142,190,239,249,23,183,190,67,96,176,142,213,214,214,163,232,161,209,147,126,56,216,194,196,79,223,242,82,209,187,103,241,166,188,87,103,63,181,6,221,72,178,54,75,216,13,43,218,175,10,27,76,54,3,74,246,65,4,122,96,223,96,239,195,168,103,223,85,49,110,142,239,70,105,190,121,203,97,179,140,188,102,131,26,37,111,210,160,82,104,226,54,204,12,119,149,187,11,71,3,34,2,22,185,85,5,38,47,197,186,59,190,178,189,11,40,43,180,90,146,92,179,106,4,194,215,255,167,181,208,207,49,44,217,158,139,91,222,174,29,155,100,194,176,236,99,242,38,117,106,163,156,2,109,147,10,156,9,6,169,235,14,54,63,114,7,103,133,5,0,87,19,149,191,74,130,226,184,122,20,123,177,43,174,12,182,27,56,146,210,142,155,229,213,190,13,124,220,239,183,11,219,223,33,134,211,210,212,241,212,226,66,104,221,179,248,31,218,131,110,129,190,22,205,246,185,38,91,111,176,119,225,24,183,71,119,136,8,90,230,255,15,106,112,102,6,59,202,17,1,11,92,143,101,158,255,248,98,174,105,97,107,255,211,22,108,207,69,160,10,226,120,215,13,210,238,78,4,131,84,57,3,179,194,167,103,38,97,208,96,22,247,73,105,71,77,62,110,119,219,174,209,106,74,217,214,90,220,64,223,11,102,55,216,59,240,169,188,174,83,222,187,158,197,71,178,207,127,48,181,255,233,189,189,242,28,202,186,194,138,83,179,147,48,36,180,163,166,186,208,54,5,205,215,6,147,84,222,87,41,35,217,103,191,179,102,122,46,196,97,74,184,93,104,27,2,42,111,43,148,180,11,190,55,195,12,142,161,90,5,223,27,45,2,239,141,0,0,0,0,25,27,49,65,50,54,98,130,43,45,83,195,100,108,197,4,125,119,244,69,86,90,167,134,79,65,150,199,200,217,138,8,209,194,187,73,250,239,232,138,227,244,217,203,172,181,79,12,181,174,126,77,158,131,45,142,135,152,28,207,74,194,18,81,83,217,35,16,120,244,112,211,97,239,65,146,46,174,215,85,55,181,230,20,28,152,181,215,5,131,132,150,130,27,152,89,155,0,169,24,176,45,250,219,169,54,203,154,230,119,93,93,255,108,108,28,212,65,63,223,205,90,14,158,149,132,36,162,140,159,21,227,167,178,70,32,190,169,119,97,241,232,225,166,232,243,208,231,195,222,131,36,218,197,178,101,93,93,174,170,68,70,159,235,111,107,204,40,118,112,253,105,57,49,107,174,32,42,90,239,11,7,9,44,18,28,56,109,223,70,54,243,198,93,7,178,237,112,84,113,244,107,101,48,187,42,243,247,162,49,194,182,137,28,145,117,144,7,160,52,23,159,188,251,14,132,141,186,37,169,222,121,60,178,239,56,115,243,121,255,106,232,72,190,65,197,27,125,88,222,42,60,240,121,79,5,233,98,126,68,194,79,45,135,219,84,28,198,148,21,138,1,141,14,187,64,166,35,232,131,191,56,217,194,56,160,197,13,33,187,244,76,10,150,167,143,19,141,150,206,92,204,0,9,69,215,49,72,110,250,98,139,119,225,83,202,186,187,93,84,163,160,108,21,136,141,63,214,145,150,14,151,222,215,152,80,199,204,169,17,236,225,250,210,245,250,203,147,114,98,215,92,107,121,230,29,64,84,181,222,89,79,132,159,22,14,18,88,15,21,35,25,36,56,112,218,61,35,65,155,101,253,107,167,124,230,90,230,87,203,9,37,78,208,56,100,1,145,174,163,24,138,159,226,51,167,204,33,42,188,253,96,173,36,225,175,180,63,208,238,159,18,131,45,134,9,178,108,201,72,36,171,208,83,21,234,251,126,70,41,226,101,119,104,47,63,121,246,54,36,72,183,29,9,27,116,4,18,42,53,75,83,188,242,82,72,141,179,121,101,222,112,96,126,239,49,231,230,243,254,254,253,194,191,213,208,145,124,204,203,160,61,131,138,54,250,154,145,7,187,177,188,84,120,168,167,101,57,59,131,152,75,34,152,169,10,9,181,250,201,16,174,203,136,95,239,93,79,70,244,108,14,109,217,63,205,116,194,14,140,243,90,18,67,234,65,35,2,193,108,112,193,216,119,65,128,151,54,215,71,142,45,230,6,165,0,181,197,188,27,132,132,113,65,138,26,104,90,187,91,67,119,232,152,90,108,217,217,21,45,79,30,12,54,126,95,39,27,45,156,62,0,28,221,185,152,0,18,160,131,49,83,139,174,98,144,146,181,83,209,221,244,197,22,196,239,244,87,239,194,167,148,246,217,150,213,174,7,188,233,183,28,141,168,156,49,222,107,133,42,239,42,202,107,121,237,211,112,72,172,248,93,27,111,225,70,42,46,102,222,54,225,127,197,7,160,84,232,84,99,77,243,101,34,2,178,243,229,27,169,194,164,48,132,145,103,41,159,160,38,228,197,174,184,253,222,159,249,214,243,204,58,207,232,253,123,128,169,107,188,153,178,90,253,178,159,9,62,171,132,56,127,44,28,36,176,53,7,21,241,30,42,70,50,7,49,119,115,72,112,225,180,81,107,208,245,122,70,131,54,99,93,178,119,203,250,215,78,210,225,230,15,249,204,181,204,224,215,132,141,175,150,18,74,182,141,35,11,157,160,112,200,132,187,65,137,3,35,93,70,26,56,108,7,49,21,63,196,40,14,14,133,103,79,152,66,126,84,169,3,85,121,250,192,76,98,203,129,129,56,197,31,152,35,244,94,179,14,167,157,170,21,150,220,229,84,0,27,252,79,49,90,215,98,98,153,206,121,83,216,73,225,79,23,80,250,126,86,123,215,45,149,98,204,28,212,45,141,138,19,52,150,187,82,31,187,232,145,6,160,217,208,94,126,243,236,71,101,194,173,108,72,145,110,117,83,160,47,58,18,54,232,35,9,7,169,8,36,84,106,17,63,101,43,150,167,121,228,143,188,72,165,164,145,27,102,189,138,42,39,242,203,188,224,235,208,141,161,192,253,222,98,217,230,239,35,20,188,225,189,13,167,208,252,38,138,131,63,63,145,178,126,112,208,36,185,105,203,21,248,66,230,70,59,91,253,119,122,220,101,107,181,197,126,90,244,238,83,9,55,247,72,56,118,184,9,174,177,161,18,159,240,138,63,204,51,147,36,253,114,0,0,0,0,1,194,106,55,3,132,212,110,2,70,190,89,7,9,168,220,6,203,194,235,4,141,124,178,5,79,22,133,14,19,81,184,15,209,59,143,13,151,133,214,12,85,239,225,9,26,249,100,8,216,147,83,10,158,45,10,11,92,71,61,28,38,163,112,29,228,201,71,31,162,119,30,30,96,29,41,27,47,11,172,26,237,97,155,24,171,223,194,25,105,181,245,18,53,242,200,19,247,152,255,17,177,38,166,16,115,76,145,21,60,90,20,20,254,48,35,22,184,142,122,23,122,228,77,56,77,70,224,57,143,44,215,59,201,146,142,58,11,248,185,63,68,238,60,62,134,132,11,60,192,58,82,61,2,80,101,54,94,23,88,55,156,125,111,53,218,195,54,52,24,169,1,49,87,191,132,48,149,213,179,50,211,107,234,51,17,1,221,36,107,229,144,37,169,143,167,39,239,49,254,38,45,91,201,35,98,77,76,34,160,39,123,32,230,153,34,33,36,243,21,42,120,180,40,43,186,222,31,41,252,96,70,40,62,10,113,45,113,28,244,44,179,118,195,46,245,200,154,47,55,162,173,112,154,141,192],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+122880);allocate([113,88,231,247,115,30,89,174,114,220,51,153,119,147,37,28,118,81,79,43,116,23,241,114,117,213,155,69,126,137,220,120,127,75,182,79,125,13,8,22,124,207,98,33,121,128,116,164,120,66,30,147,122,4,160,202,123,198,202,253,108,188,46,176,109,126,68,135,111,56,250,222,110,250,144,233,107,181,134,108,106,119,236,91,104,49,82,2,105,243,56,53,98,175,127,8,99,109,21,63,97,43,171,102,96,233,193,81,101,166,215,212,100,100,189,227,102,34,3,186,103,224,105,141,72,215,203,32,73,21,161,23,75,83,31,78,74,145,117,121,79,222,99,252,78,28,9,203,76,90,183,146,77,152,221,165,70,196,154,152,71,6,240,175,69,64,78,246,68,130,36,193,65,205,50,68,64,15,88,115,66,73,230,42,67,139,140,29,84,241,104,80,85,51,2,103,87,117,188,62,86,183,214,9,83,248,192,140,82,58,170,187,80,124,20,226,81,190,126,213,90,226,57,232,91,32,83,223,89,102,237,134,88,164,135,177,93,235,145,52,92,41,251,3,94,111,69,90,95,173,47,109,225,53,27,128,224,247,113,183,226,177,207,238,227,115,165,217,230,60,179,92,231,254,217,107,229,184,103,50,228,122,13,5,239,38,74,56,238,228,32,15,236,162,158,86,237,96,244,97,232,47,226,228,233,237,136,211,235,171,54,138,234,105,92,189,253,19,184,240,252,209,210,199,254,151,108,158,255,85,6,169,250,26,16,44,251,216,122,27,249,158,196,66,248,92,174,117,243,0,233,72,242,194,131,127,240,132,61,38,241,70,87,17,244,9,65,148,245,203,43,163,247,141,149,250,246,79,255,205,217,120,93,96,216,186,55,87,218,252,137,14,219,62,227,57,222,113,245,188,223,179,159,139,221,245,33,210,220,55,75,229,215,107,12,216,214,169,102,239,212,239,216,182,213,45,178,129,208,98,164,4,209,160,206,51,211,230,112,106,210,36,26,93,197,94,254,16,196,156,148,39,198,218,42,126,199,24,64,73,194,87,86,204,195,149,60,251,193,211,130,162,192,17,232,149,203,77,175,168,202,143,197,159,200,201,123,198,201,11,17,241,204,68,7,116,205,134,109,67,207,192,211,26,206,2,185,45,145,175,150,64,144,109,252,119,146,43,66,46,147,233,40,25,150,166,62,156,151,100,84,171,149,34,234,242,148,224,128,197,159,188,199,248,158,126,173,207,156,56,19,150,157,250,121,161,152,181,111,36,153,119,5,19,155,49,187,74,154,243,209,125,141,137,53,48,140,75,95,7,142,13,225,94,143,207,139,105,138,128,157,236,139,66,247,219,137,4,73,130,136,198,35,181,131,154,100,136,130,88,14,191,128,30,176,230,129,220,218,209,132,147,204,84,133,81,166,99,135,23,24,58,134,213,114,13,169,226,208,160,168,32,186,151,170,102,4,206,171,164,110,249,174,235,120,124,175,41,18,75,173,111,172,18,172,173,198,37,167,241,129,24,166,51,235,47,164,117,85,118,165,183,63,65,160,248,41,196,161,58,67,243,163,124,253,170,162,190,151,157,181,196,115,208,180,6,25,231,182,64,167,190,183,130,205,137,178,205,219,12,179,15,177,59,177,73,15,98,176,139,101,85,187,215,34,104,186,21,72,95,184,83,246,6,185,145,156,49,188,222,138,180,189,28,224,131,191,90,94,218,190,152,52,237,0,0,0,0,184,188,103,101,170,9,200,139,18,181,175,238,143,98,151,87,55,222,240,50,37,107,95,220,157,215,56,185,197,180,40,239,125,8,79,138,111,189,224,100,215,1,135,1,74,214,191,184,242,106,216,221,224,223,119,51,88,99,16,86,80,25,87,159,232,165,48,250,250,16,159,20,66,172,248,113,223,123,192,200,103,199,167,173,117,114,8,67,205,206,111,38,149,173,127,112,45,17,24,21,63,164,183,251,135,24,208,158,26,207,232,39,162,115,143,66,176,198,32,172,8,122,71,201,160,50,175,62,24,142,200,91,10,59,103,181,178,135,0,208,47,80,56,105,151,236,95,12,133,89,240,226,61,229,151,135,101,134,135,209,221,58,224,180,207,143,79,90,119,51,40,63,234,228,16,134,82,88,119,227,64,237,216,13,248,81,191,104,240,43,248,161,72,151,159,196,90,34,48,42,226,158,87,79,127,73,111,246,199,245,8,147,213,64,167,125,109,252,192,24,53,159,208,78,141,35,183,43,159,150,24,197,39,42,127,160,186,253,71,25,2,65,32,124,16,244,143,146,168,72,232,247,155,20,88,61,35,168,63,88,49,29,144,182,137,161,247,211,20,118,207,106,172,202,168,15,190,127,7,225,6,195,96,132,94,160,112,210,230,28,23,183,244,169,184,89,76,21,223,60,209,194,231,133,105,126,128,224,123,203,47,14,195,119,72,107,203,13,15,162,115,177,104,199,97,4,199,41,217,184,160,76,68,111,152,245,252,211,255,144,238,102,80,126,86,218,55,27,14,185,39,77,182,5,64,40,164,176,239,198,28,12,136,163,129,219,176,26,57,103,215,127,43,210,120,145,147,110,31,244,59,38,247,3,131,154,144,102,145,47,63,136,41,147,88,237,180,68,96,84,12,248,7,49,30,77,168,223,166,241,207,186,254,146,223,236,70,46,184,137,84,155,23,103,236,39,112,2,113,240,72,187,201,76,47,222,219,249,128,48,99,69,231,85,107,63,160,156,211,131,199,249,193,54,104,23,121,138,15,114,228,93,55,203,92,225,80,174,78,84,255,64,246,232,152,37,174,139,136,115,22,55,239,22,4,130,64,248,188,62,39,157,33,233,31,36,153,85,120,65,139,224,215,175,51,92,176,202,237,89,182,59,85,229,209,94,71,80,126,176,255,236,25,213,98,59,33,108,218,135,70,9,200,50,233,231,112,142,142,130,40,237,158,212,144,81,249,177,130,228,86,95,58,88,49,58,167,143,9,131,31,51,110,230,13,134,193,8,181,58,166,109,189,64,225,164,5,252,134,193,23,73,41,47,175,245,78,74,50,34,118,243,138,158,17,150,152,43,190,120,32,151,217,29,120,244,201,75,192,72,174,46,210,253,1,192,106,65,102,165,247,150,94,28,79,42,57,121,93,159,150,151,229,35,241,242,77,107,25,5,245,215,126,96,231,98,209,142,95,222,182,235,194,9,142,82,122,181,233,55,104,0,70,217,208,188,33,188,136,223,49,234,48,99,86,143,34,214,249,97,154,106,158,4,7,189,166,189,191,1,193,216,173,180,110,54,21,8,9,83,29,114,78,154,165,206,41,255,183,123,134,17,15,199,225,116,146,16,217,205,42,172,190,168,56,25,17,70,128,165,118,35,216,198,102,117,96,122,1,16,114,207,174,254,202,115,201,155,87,164,241,34,239,24,150,71,253,173,57,169,69,17,94,204,118,77,238,6,206,241,137,99,220,68,38,141,100,248,65,232,249,47,121,81,65,147,30,52,83,38,177,218,235,154,214,191,179,249,198,233,11,69,161,140,25,240,14,98,161,76,105,7,60,155,81,190,132,39,54,219,150,146,153,53,46,46,254,80,38,84,185,153,158,232,222,252,140,93,113,18,52,225,22,119,169,54,46,206,17,138,73,171,3,63,230,69,187,131,129,32,227,224,145,118,91,92,246,19,73,233,89,253,241,85,62,152,108,130,6,33,212,62,97,68,198,139,206,170,126,55,169,207,214,127,65,56,110,195,38,93,124,118,137,179,196,202,238,214,89,29,214,111,225,161,177,10,243,20,30,228,75,168,121,129,19,203,105,215,171,119,14,178,185,194,161,92,1,126,198,57,156,169,254,128,36,21,153,229,54,160,54,11,142,28,81,110,134,102,22,167,62,218,113,194,44,111,222,44,148,211,185,73,9,4,129,240,177,184,230,149,163,13,73,123,27,177,46,30,67,210,62,72,251,110,89,45,233,219,246,195,81,103,145,166,204,176,169,31,116,12,206,122,102,185,97,148,222,5,6,241,0,0,0,0,0,0,0,0,80,1,0,0,4,0,4,0,8,0,4,0,81,1,0,0,4,0,5,0,16,0,8,0,81,1,0,0,4,0,6,0,32,0,32,0,81,1,0,0,4,0,4,0,16,0,16,0,82,1,0,0,8,0,16,0,32,0,32,0,82,1,0,0,8,0,16,0,128,0,128,0,82,1,0,0,8,0,32,0,128,0,0,1,82,1,0,0,32,0,128,0,2,1,0,4,82,1,0,0,32,0,2,1,2,1,0,16,82,1,0,0,198,82,2,0,124,16,2,0,1,1,0,0,30,1,0,0,15,0,0,0,78,82,2,0,4,16,2,0,0,0,0,0,30,0,0,0,15,0,0,0,0,0,0,0,184,15,2,0,0,0,0,0,19,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,5,0,0,0,6,0,0,0,6,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,11,0,0,0,11,0,0,0,12,0,0,0,12,0,0,0,13,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,3,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,10,0,0,0,12,0,0,0,14,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,40,0,0,0,48,0,0,0,56,0,0,0,64,0,0,0,80,0,0,0,96,0,0,0,112,0,0,0,128,0,0,0,160,0,0,0,192,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,6,0,0,0,8,0,0,0,12,0,0,0,16,0,0,0,24,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,96,0,0,0,128,0,0,0,192,0,0,0,0,1,0,0,128,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,6,0,0,0,8,0,0,0,12,0,0,0,16,0,0,0,24,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,96,0,0,100,0,0,0,0,0,0,0,200,87,0,0,167,4,0,0,168,4,0,0,138,0,0,0,166,2,0,0,83,1,0,0,209,1,0,0,0,0,0,0,216,87,0,0,169,4,0,0,170,4,0,0,139,0,0,0,167,2,0,0,210,1,0,0,140,0,0,0,211,1,0,0,0,0,0,0,232,87,0,0,171,4,0,0,172,4,0,0,141,0,0,0,168,2,0,0,212,1,0,0,140,0,0,0,211,1,0,0,0,0,0,0,248,87,0,0,173,4,0,0,174,4,0,0,142,0,0,0,169,2,0,0,84,1,0,0,213,1,0,0,0,0,0,0,24,88,0,0,175,4,0,0,176,4,0,0,214,1,0,0,0,0,0,0,48,88,0,0,177,4,0,0,178,4,0,0,179,4,0,0,121,0,0,0,156,222,6,0,161,222,6,0,45,224,6,0,169,222,6,0,4,0,0,0,0,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,4,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,7,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,9,0,0,0,3,0,0,0,8,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,255,255,255,255,1,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,4,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,7,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,9,0,0,0,3,0,0,0,8,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,45,224,6,0,212,124,7,0,100,124,7,0,51,224,6,0,57,224,6,0,64,224,6,0,70,224,6,0,78,224,6,0,49,124,7,0,86,224,6,0,93,224,6,0,99,224,6,0,107,224,6,0,113,224,6,0,120,224,6,0,125,224,6,0,134,224,6,0,143,224,6,0,150,224,6,0,45,224,6,0,64,224,6,0,51,224,6,0,113,224,6,0,57,224,6,0,212,124,7,0,100,124,7,0,49,124,7,0,120,224,6,0,86,224,6,0,99,224,6,0,45,224,6,0,157,224,6,0,166,224,6,0,175,224,6,0,0,0,0,0,72,88,0,0,177,4,0,0,180,4,0,0,181,4,0,0,153,233,6,0,165,233,6,0,180,233,6,0,193,233,6,0,205,233,6,0,222,233,6,0,237,233,6,0,0,0,0,0,104,88,0,0,182,4,0,0,183,4,0,0,122,0,0,0,123,0,0,0,0,0,0,0,88,88,0,0,184,4,0,0,185,4,0,0,143,0,0,0,0,0,0,0,120,88,0,0,186,4,0,0,187,4,0,0,187,0,0,0,215,1,0,0,85,1,0,0,179,0,0,0,55,0,0,0,188,4,0,0,216,1,0,0,188,0,0,0,189,0,0,0,86,1,0,0,36,0,0,0,217,1,0,0,170,2,0,0,87,1,0,0,218,1,0,0,144,0,0,0,171,2,0,0,172,2,0,0,231,2,0,0,39,0,0,0,173,2,0,0,40,0,0,0,174,2,0,0,16,0,0,0,120,0,0,0,124,0,0,0,16,0,0,0,32,0,0,0,44,0,0,0,56,0,0,0,72,0,0,0,88,0,0,0,104,0,0,0,132,0,0,0,136,0,0,0,128,0,0,0,144,0,0,0,16,0,0,0,32,0,0,0,48,0,0,0,64,0,0,0,80,0,0,0,96,0,0,0,148,0,0,0,112,0,0,0,128,0,0,0,16,0,0,0,20,0,0,0,16,0,0,0,20,0,0,0,16,0,0,0,40,0,0,0,48,0,0,0,52,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,44,0,0,0,32,0,0,0,36,0,0,0,16,0,0,0,20,0,0,0,32,0,0,0,16,0,0,0,36,0,0,0,16,0,0,0,24,0,0,0,20,0,0,0,32,0,0,0,16,0,0,0,36,0,0,0,16,0,0,0,20,0,0,0,24,0,0,0,28,0,0,0,32,0,0,0,33,0,0,0,48,0,0,0,52,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,76,0,0,0,56,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,60,0,0,0,64,0,0,0,32,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,32,0,0,0,48,0,0,0,56,0,0,0,52,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,32,0,0,0,32,0,0,0,48,0,0,0,49,0,0,0,32,0,0,0,48,0,0,0,32,0,0,0,48,0,0,0,32,0,0,0,48,0,0,0,32,0,0,0,16,0,0,0,32,0,0,0,48,0,0,0,56,0,0,0,64,0,0,0,36,0,0,0,40,0,0,0,16,0,0,0,20,0,0,0,16,0,0,0,16,0,0,0,32,0,0,0,64,0,0,0,68,0,0,0,48,0,0,0,16,0,0,0,16,0,0,0,32,0,0,0,36,0,0,0,40,0,0,0,0,0,0,0,248,89,0,0,189,4,0,0,190,4,0,0,187,0,0,0,219,1,0,0,88,1,0,0,179,0,0,0,55,0,0,0,191,4,0,0,220,1,0,0,188,0,0,0,189,0,0,0,89,1,0,0,36,0,0,0,221,1,0,0,175,2,0,0,90,1,0,0,222,1,0,0,145,0,0,0,176,2,0,0,177,2,0,0,231,2,0,0,39,0,0,0,178,2,0,0,40,0,0,0,179,2,0,0,0,0,0,0,232,89,0,0,192,4,0,0,193,4,0,0,187,0,0,0,223,1,0,0,91,1,0,0,179,0,0,0,55,0,0,0,194,4,0,0,224,1,0,0,188,0,0,0,189,0,0,0,92,1,0,0,36,0,0,0,225,1,0,0,180,2,0,0,93,1,0,0,226,1,0,0,146,0,0,0,181,2,0,0,182,2,0,0,231,2,0,0,39,0,0,0,183,2,0,0,40,0,0,0,184,2,0,0,0,0,0,0,216,89,0,0,195,4,0,0,196,4,0,0,187,0,0,0,227,1,0,0,94,1,0,0,179,0,0,0,55,0,0,0,197,4,0,0,228,1,0,0,188,0,0,0,189,0,0,0,95,1,0,0,36,0,0,0,229,1,0,0,185,2,0,0,96,1,0,0,230,1,0,0,147,0,0,0,186,2,0,0,187,2,0,0,231,2,0,0,39,0,0,0,188,2,0,0,40,0,0,0,189,2,0,0,0,0,0,0,200,89,0,0,198,4,0,0,199,4,0,0,187,0,0,0,231,1,0,0,97,1,0,0,179,0,0,0,55,0,0,0,200,4,0,0,232,1,0,0,188,0,0,0,189,0,0,0,98,1,0,0,36,0,0,0,233,1,0,0,190,2,0,0,99,1,0,0,234,1,0,0,148,0,0,0,191,2,0,0,192,2,0,0,231,2,0,0,39,0,0,0,193,2,0,0,40,0,0,0,194,2,0,0,0,0,0,0,184,89,0,0,201,4,0,0,202,4,0,0,187,0,0,0,235,1,0,0,100,1,0,0,179,0,0,0,55,0,0,0,203,4,0,0,236,1,0,0,188,0,0,0,189,0,0,0,101,1,0,0,36,0,0,0,237,1,0,0,195,2,0,0,102,1,0,0,238,1,0,0,149,0,0,0,196,2,0,0,197,2,0,0,231,2,0,0,39,0,0,0,198,2,0,0,40,0,0,0,199,2,0,0,0,0,0,0,168,89,0,0,204,4,0,0,205,4,0,0,187,0,0,0,239,1,0,0,103,1,0,0,179,0,0,0,55,0,0,0,206,4,0,0,240,1,0,0,188,0,0,0,189,0,0,0,104,1,0,0,36,0,0,0,241,1,0,0,200,2,0,0,105,1,0,0,242,1,0,0,150,0,0,0,201,2,0,0,202,2,0,0,231,2,0,0,39,0,0,0,203,2,0,0,40,0,0,0,204,2,0,0,0,0,0,0,152,89,0,0,207,4,0,0,208,4,0,0,187,0,0,0,243,1,0,0,106,1,0,0,179,0,0,0,55,0,0,0,209,4,0,0,244,1,0,0,188,0,0,0,189,0,0,0,107,1,0,0,36,0,0,0,245,1,0,0,205,2,0,0,108,1,0,0,246,1,0,0,151,0,0,0,206,2,0,0,207,2,0,0,231,2,0,0,39,0,0,0,208,2,0,0,40,0,0,0,209,2,0,0,0,0,0,0,136,89,0,0,210,4,0,0,211,4,0,0,187,0,0,0,247,1,0,0,109,1,0,0,179,0,0,0,55,0,0,0,212,4,0,0,248,1,0,0,188,0,0,0,189,0,0,0,110,1,0,0,36,0,0,0,249,1,0,0,210,2,0,0,111,1,0,0,250,1,0,0,152,0,0,0,211,2,0,0,212,2,0,0,231,2,0,0,39,0,0,0,213,2,0,0,40,0,0,0,214,2,0,0,0,0,0,0,120,89,0,0,213,4,0,0,214,4,0,0,187,0,0,0,251,1,0,0,112,1,0,0,179,0,0,0,55,0,0,0,215,4,0,0,252,1,0,0,188,0,0,0,189,0,0,0,113,1,0,0,36,0,0,0,253,1,0,0,215,2,0,0,114,1,0,0,254,1,0,0,153,0,0,0,216,2,0,0,217,2,0,0,231,2,0,0,39,0,0,0,218,2,0,0,40,0,0,0,219,2,0,0,0,0,0,0,104,89,0,0,216,4,0,0,217,4,0,0,187,0,0,0,255,1,0,0,115,1,0,0,179,0,0,0,55,0,0,0,218,4,0,0,0,2,0,0,188,0,0,0,189,0,0,0,116,1,0,0,36,0,0,0,1,2,0,0,220,2,0,0,117,1,0,0,2,2,0,0,154,0,0,0,221,2,0,0,222,2,0,0,231,2,0,0,39,0,0,0,223,2,0,0,40,0,0,0,224,2,0,0,0,0,0,0,88,89,0,0,219,4,0,0,220,4,0,0,187,0,0,0,3,2,0,0,118,1,0,0,179,0,0,0,55,0,0,0,221,4,0,0,4,2,0,0,188,0,0,0,189,0,0,0,119,1,0,0,36,0,0,0,5,2,0,0,225,2,0,0,120,1,0,0,6,2,0,0,155,0,0,0,226,2,0,0,227,2,0,0,231,2,0,0,39,0,0,0,228,2,0,0,40,0,0,0,229,2,0,0,0,0,0,0,72,89,0,0,222,4,0,0,223,4,0,0,187,0,0,0,7,2,0,0,121,1,0,0,179,0,0,0,55,0,0,0,224,4,0,0,8,2,0,0,188,0,0,0,189,0,0,0,122,1,0,0,36,0,0,0,9,2,0,0,230,2,0,0,123,1,0,0,10,2,0,0,156,0,0,0,231,2,0,0,232,2,0,0,231,2,0,0,39,0,0,0,233,2,0,0,40,0,0,0,234,2,0,0,0,0,0,0,56,89,0,0,225,4,0,0,226,4,0,0,187,0,0,0,11,2,0,0,124,1,0,0,179,0,0,0,55,0,0,0,227,4,0,0,12,2,0,0,188,0,0,0,189,0,0,0,125,1,0,0,36,0,0,0,13,2,0,0,235,2,0,0,126,1,0,0,14,2,0,0,157,0,0,0,236,2,0,0,237,2,0,0,231,2,0,0,39,0,0,0,238,2,0,0,40,0,0,0,239,2,0,0,0,0,0,0,40,89,0,0,228,4,0,0,229,4,0,0,187,0,0,0,15,2,0,0,127,1,0,0,179,0,0,0,55,0,0,0,230,4,0,0,16,2,0,0,188,0,0,0,189,0,0,0,128,1,0,0,36,0,0,0,17,2,0,0,240,2,0,0,129,1,0,0,18,2,0,0,158,0,0,0,241,2,0,0,242,2,0,0,231,2,0,0,39,0,0,0,243,2,0,0,40,0,0,0,244,2,0,0,0,0,0,0,24,89,0,0,231,4,0,0,232,4,0,0,187,0,0,0,19,2,0,0,130,1,0,0,179,0,0,0,55,0,0,0,233,4,0,0,20,2,0,0,188,0,0,0,189,0,0,0,131,1,0,0,36,0,0,0,21,2,0,0,245,2,0,0,132,1,0,0,22,2,0,0,159,0,0,0,246,2,0,0,247,2,0,0,231,2,0,0,39,0,0,0,248,2,0,0,40,0,0,0,249,2,0,0,0,0,0,0,8,89,0,0,234,4,0,0,235,4,0,0,187,0,0,0,23,2,0,0,133,1,0,0,179,0,0,0,55,0,0,0,236,4,0,0,24,2,0,0,188,0,0,0,189,0,0,0,134,1,0,0,36,0,0,0,25,2,0,0,250,2,0,0,135,1,0,0,26,2,0,0,160,0,0,0,251,2,0,0,252,2,0,0,231,2,0,0,39,0,0,0,253,2,0,0,40,0,0,0,254,2,0,0,0,0,0,0,248,88,0,0,237,4,0,0,238,4,0,0,187,0,0,0,27,2,0,0,136,1,0,0,179,0,0,0,55,0,0,0,239,4,0,0,28,2,0,0,188,0,0,0,189,0,0,0,137,1,0,0,36,0,0,0,29,2,0,0,255,2,0,0,138,1,0,0,30,2,0,0,161,0,0,0,0,3,0,0,1,3,0,0,231,2,0,0,39,0,0,0,2,3,0,0,40,0,0,0,3,3,0,0,0,0,0,0,232,88,0,0,240,4,0,0,241,4,0,0,187,0,0,0,31,2,0,0,139,1,0,0,179,0,0,0,55,0,0,0,242,4,0,0,32,2,0,0,188,0,0,0,189,0,0,0,140,1,0,0,36,0,0,0,33,2,0,0,4,3,0,0,141,1,0,0,34,2,0,0,162,0,0,0,5,3,0,0,6,3,0,0,231,2,0,0,39,0,0,0,7,3,0,0,40,0,0,0,8,3,0,0,0,0,0,0,216,88,0,0,243,4,0,0,244,4,0,0,187,0,0,0,35,2,0,0,142,1,0,0,179,0,0,0,55,0,0,0,245,4,0,0,36,2,0,0,188,0,0,0,189,0,0,0,143,1,0,0,36,0,0,0,37,2,0,0,9,3,0,0,144,1,0,0,38,2,0,0,163,0,0,0,10,3,0,0,11,3,0,0,231,2,0,0,39,0,0,0,12,3,0,0,40,0,0,0,13,3,0,0,0,0,0,0,200,88,0,0,246,4,0,0,247,4,0,0,187,0,0,0,39,2,0,0,145,1,0,0,179,0,0,0,55,0,0,0,248,4,0,0,40,2,0,0,188,0,0,0,189,0,0,0,146,1,0,0,36,0,0,0,41,2,0,0,14,3,0,0,147,1,0,0,42,2,0,0,164,0,0,0,15,3,0,0,16,3,0,0,231,2,0,0,39,0,0,0,17,3,0,0,40,0,0,0,18,3,0,0,0,0,0,0,184,88,0,0,249,4,0,0,250,4,0,0,187,0,0,0,43,2,0,0,148,1,0,0,179,0,0,0,55,0,0,0,251,4,0,0,44,2,0,0,188,0,0,0,189,0,0,0,149,1,0,0,36,0,0,0,45,2,0,0,19,3,0,0,150,1,0,0,46,2,0,0,165,0,0,0,20,3,0,0,21,3,0,0,231,2,0,0,39,0,0,0,22,3,0,0,40,0,0,0,23,3,0,0,0,0,0,0,168,88,0,0,252,4,0,0,253,4,0,0,187,0,0,0,47,2,0,0,151,1,0,0,179,0,0,0,55,0,0,0,254,4,0,0,48,2,0,0,188,0,0,0,189,0,0,0,152,1,0,0,36,0,0,0,49,2,0,0,24,3,0,0,153,1,0,0,50,2,0,0,166,0,0,0,25,3,0,0,26,3,0,0,231,2,0,0,39,0,0,0,27,3,0,0,40,0,0,0,28,3,0,0,0,0,0,0,152,88,0,0,255,4,0,0,0,5,0,0,187,0,0,0,51,2,0,0,154,1,0,0,179,0,0,0,55,0,0,0,1,5,0,0,52,2,0,0,188,0,0,0,189,0,0,0,155,1,0,0,36,0,0,0,53,2,0,0,29,3,0,0,156,1,0,0,54,2,0,0,167,0,0,0,30,3,0,0,31,3,0,0,231,2,0,0,39,0,0,0,32,3,0,0,40,0,0,0,33,3,0,0,0,0,0,0,136,88,0,0,2,5,0,0,3,5,0,0,187,0,0,0,55,2,0,0,157,1,0,0,179,0,0,0,55,0,0,0,4,5,0,0,56,2,0,0,188,0,0,0,189,0,0,0,158,1,0,0,36,0,0,0,57,2,0,0,34,3,0,0,159,1,0,0,58,2,0,0,168,0,0,0,35,3,0,0,36,3,0,0,231,2,0,0,39,0,0,0,37,3,0,0,40,0,0,0,38,3,0,0,4,0,0,0,5,0,0,0,7,0,0,0,2,0,0,0,6,0,0,0,3,0,0,0,4,0,0,0,8,0,0,0,2,0,0,0,0,0,0,0,16,90,0,0,5,5,0,0,6,5,0,0,169,0,0,0,170,0,0,0,5,0,0,0,171,0,0,0,0,0,0,0,32,90,0,0,7,5,0,0,8,5,0,0,187,0,0,0,59,2,0,0,160,1,0,0,60,2,0,0,55,0,0,0,9,5,0,0,61,2,0,0,188,0,0,0,189,0,0,0,161,1,0,0,36,0,0,0,62,2,0,0,39,3,0,0,43,0,0,0,63,2,0,0,172,0,0,0,40,3,0,0,41,3,0,0,231,2,0,0,39,0,0,0,42,3,0,0,40,0,0,0,43,3,0,0,0,0,0,0,48,90,0,0,10,5,0,0,11,5,0,0,162,1,0,0,0,0,0,0,64,90,0,0,12,5,0,0,13,5,0,0,173,0,0,0,0,0,0,0,96,90,0,0,14,5,0,0,15,5,0,0,163,1,0,0,164,1,0,0,165,1,0,0,174,0,0,0,175,0,0,0,88,0,0,0,176,0,0,0,89,0,0,0,177,0,0,0,90,0,0,0,178,0,0,0,91,0,0,0,124,0,0,0,79,0,0,0,92,0,0,0,179,0,0,0,180,0,0,0,181,0,0,0,182,0,0,0,8,0,0,0,9,0,0,0,183,0,0,0,125,0,0,0,184,0,0,0,185,0,0,0,6,0,0,0,7,0,0,0,126,0,0,0,80,0,0,0,127,0,0,0,81,0,0,0,2,0,0,0,3,0,0,0,128,0,0,0,129,0,0,0,130,0,0,0,131,0,0,0,8,0,0,0,132,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,1,0,0,0,2,0,0,0,14,0,0,0,82,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,67,0,0,0,83,0,0,0,77,0,0,0,84,0,0,0,78,0,0,0,3,0,0,0,4,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,18,0,0,0,133,0,0,0,89,0,0,0,134,0,0,0,90,0,0,0,4,0,0,0,5,0,0,0,135,0,0,0,136,0,0,0,137,0,0,0,138,0,0,0,19,0,0,0,139,0,0,0,166,1,0,0,167,1,0,0,64,2,0,0,65,2,0,0,30,0,0,0,31,0,0,0,68,0,0,0,168,1,0,0,20,0,0,0,69,0,0,0,21,0,0,0,140,0,0,0,141,0,0,0,186,0,0,0,187,0,0,0,220,35,7,0,236,35,7,0,250,35,7,0,8,36,7,0,23,36,7,0,38,36,7,0,53,36,7,0,67,36,7,0,80,36,7,0,93,36,7,0,108,36,7,0,0,0,0,0,120,90,0,0,16,5,0,0,17,5,0,0,188,0,0,0,44,3,0,0,169,1,0,0,66,2,0,0,0,0,0,0,136,90,0,0,18,5,0,0,19,5,0,0,189,0,0,0,170,1,0,0,0,0,0,0,152,90,0,0,250,2,0,0,20,5,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,80,0,0,0,252,2,0,0,253,2,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,160,90,0,0,21,5,0,0,22,5,0,0,171,1,0,0,190,0,0,0,172,1,0,0,191,0,0,0,45,3,0,0,46,3,0,0,67,2,0,0,68,2,0,0,23,5,0,0,24,5,0,0,47,3,0,0,48,3,0,0,93,0,0,0,49,3,0,0,69,2,0,0,70,2,0,0,50,3,0,0,0,0,0,0,16,91,0,0,25,5,0,0,26,5,0,0,173,1,0,0,174,1,0,0,22,0,0,0,51,3,0,0,142,0,0,0,94,0,0,0,52,3,0,0,143,0,0,0,144,0,0,0,175,1,0,0,176,1,0,0,192,0,0,0,193,0,0,0,23,0,0,0,95,0,0,0,24,0,0,0,177,1,0,0,96,0,0,0,194,0,0,0,0,0,0,0,72,91,0,0,25,5,0,0,27,5,0,0,178,1,0,0,179,1,0,0,25,0,0,0,53,3,0,0,145,0,0,0,97,0,0,0,54,3,0,0,146,0,0,0,147,0,0,0,175,1,0,0,176,1,0,0,192,0,0,0,193,0,0,0,23,0,0,0,95,0,0,0,24,0,0,0,180,1,0,0,98,0,0,0,195,0,0,0,0,0,0,0,88,91,0,0,25,5,0,0,28,5,0,0,181,1,0,0,182,1,0,0,26,0,0,0,55,3,0,0,148,0,0,0,99,0,0,0,56,3,0,0,149,0,0,0,150,0,0,0,175,1,0,0,176,1,0,0,192,0,0,0,193,0,0,0,23,0,0,0,95,0,0,0,24,0,0,0,183,1,0,0,100,0,0,0,196,0,0,0,0,0,0,0,120,91,0,0,25,5,0,0,29,5,0,0,184,1,0,0,185,1,0,0,27,0,0,0,57,3,0,0,151,0,0,0,101,0,0,0,58,3,0,0,152,0,0,0,153,0,0,0,175,1,0,0,176,1,0,0,192,0,0,0,193,0,0,0,23,0,0,0,95,0,0,0,24,0,0,0,186,1,0,0,197,0,0,0,0,0,0,0,152,91,0,0,25,5,0,0,30,5,0,0,187,1,0,0,188,1,0,0,28,0,0,0,59,3,0,0,154,0,0,0,102,0,0,0,60,3,0,0,155,0,0,0,156,0,0,0,175,1,0,0,176,1,0,0,192,0,0,0,193,0,0,0,23,0,0,0,95,0,0,0,24,0,0,0,3,0,0,0,198,0,0,0,0,0,0,0,184,91,0,0,25,5,0,0,31,5,0,0,189,1,0,0,190,1,0,0,29,0,0,0,61,3,0,0,157,0,0,0,103,0,0,0,62,3,0,0,158,0,0,0,159,0,0,0,175,1,0,0,176,1,0,0,192,0,0,0,193,0,0,0,23,0,0,0,95,0,0,0,24,0,0,0,4,0,0,0,199,0,0,0,0,0,0,0,216,91,0,0,25,5,0,0,32,5,0,0,191,1,0,0,192,1,0,0,30,0,0,0,63,3,0,0,160,0,0,0,104,0,0,0,64,3,0,0,161,0,0,0,162,0,0,0,175,1,0,0,176,1,0,0,192,0,0,0,193,0,0,0,23,0,0,0,95,0,0,0,24,0,0,0,193,1,0,0,200,0,0,0,0,0,0,0,248,91,0,0,25,5,0,0,33,5,0,0,194,1,0,0,195,1,0,0,31,0,0,0,65,3,0,0,163,0,0,0,105,0,0,0,66,3,0,0,164,0,0,0,165,0,0,0,175,1,0,0,176,1,0,0,192,0,0,0,193,0,0,0,23,0,0,0,95,0,0,0,24,0,0,0,196,1,0,0,201,0,0,0,0,0,0,0,24,92,0,0,25,5,0,0,34,5,0,0,197,1,0,0,198,1,0,0,32,0,0,0,67,3,0,0,166,0,0,0,106,0,0,0,68,3,0,0,167,0,0,0,168,0,0,0,175,1,0,0,176,1,0,0,192,0,0,0,193,0,0,0,23,0,0,0,95,0,0,0,24,0,0,0,199,1,0,0,202,0,0,0,0,0,0,0,56,92,0,0,25,5,0,0,35,5,0,0,200,1,0,0,201,1,0,0,33,0,0,0,69,3,0,0,169,0,0,0,107,0,0,0,70,3,0,0,170,0,0,0,171,0,0,0,175,1,0,0,176,1,0,0,192,0,0,0,193,0,0,0,23,0,0,0,95,0,0,0,24,0,0,0,202,1,0,0,203,0,0,0,0,0,0,0,96,92,0,0,36,5,0,0,37,5,0,0,203,1,0,0,0,0,0,0,112,92,0,0,38,5,0,0,39,5,0,0,108,0,0,0,109,0,0,0,110,0,0,0,172,0,0,0,173,0,0,0,1,0,0,0,2,0,0,0,111,0,0,0,112,0,0,0,174,0,0,0,91,0,0,0,79,0,0,0,80,0,0,0,0,0,0,0,128,92,0,0,40,5,0,0,41,5,0,0,175,0,0,0,176,0,0,0,0,0,0,0,144,92,0,0,42,5,0,0,43,5,0,0,204,0,0,0,204,1,0,0,113,0,0,0,0,0,0,0,168,92,0,0,12,5,0,0,44,5,0,0,205,0,0,0,0,0,0,0,0,1,0,0,0,9,0,0,0,0,0,0,8,0,0,0,1,0,0,0,32,32,32,32,0,0,0,0,213,77,7,0,116,21,17,0,178,40,17,0,213,86,7,0,88,40,2,0,5,0,0,0,0,0,0,0,0,0,0,0,71,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,206,0,0,0,207,0,0,0,160,32,17,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,9,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,204,41,2,0,9,0,0,0,0,0,0,0,0,0,0,0,71,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,0,0,0,0,0,0,0,207,0,0,0,168,32,17,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,42,2,0,5,0,0,0,0,0,0,0,0,0,0,0,71,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,209,0,0,0,207,0,0,0,176,36,17,0,0,4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,42,2,0,232,42,2,0,20,0,0,0,67,46,85,84,70,45,56,0,0,0,0,0,0,0,0,0,0,0,0,0,222,18,4,149,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,204,42,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,95,112,137,0,255,9,47,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,210,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,70,88,2,0,140,46,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+133120);allocate([95,0,0,0,96,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,52,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,3,0,0,0,5,0,0,0,7,0,0,0,11,0,0,0,13,0,0,0,17,0,0,0,19,0,0,0,23,0,0,0,29,0,0,0,31,0,0,0,37,0,0,0,41,0,0,0,43,0,0,0,47,0,0,0,53,0,0,0,59,0,0,0,61,0,0,0,67,0,0,0,71,0,0,0,73,0,0,0,79,0,0,0,83,0,0,0,89,0,0,0,97,0,0,0,101,0,0,0,103,0,0,0,107,0,0,0,109,0,0,0,113,0,0,0,127,0,0,0,131,0,0,0,137,0,0,0,139,0,0,0,149,0,0,0,151,0,0,0,157,0,0,0,163,0,0,0,167,0,0,0,173,0,0,0,179,0,0,0,181,0,0,0,191,0,0,0,193,0,0,0,197,0,0,0,199,0,0,0,211,0,0,0,1,0,0,0,11,0,0,0,13,0,0,0,17,0,0,0,19,0,0,0,23,0,0,0,29,0,0,0,31,0,0,0,37,0,0,0,41,0,0,0,43,0,0,0,47,0,0,0,53,0,0,0,59,0,0,0,61,0,0,0,67,0,0,0,71,0,0,0,73,0,0,0,79,0,0,0,83,0,0,0,89,0,0,0,97,0,0,0,101,0,0,0,103,0,0,0,107,0,0,0,109,0,0,0,113,0,0,0,121,0,0,0,127,0,0,0,131,0,0,0,137,0,0,0,139,0,0,0,143,0,0,0,149,0,0,0,151,0,0,0,157,0,0,0,163,0,0,0,167,0,0,0,169,0,0,0,173,0,0,0,179,0,0,0,181,0,0,0,187,0,0,0,191,0,0,0,193,0,0,0,197,0,0,0,199,0,0,0,209,0,0,0,0,0,0,0,120,93,0,0,45,5,0,0,46,5,0,0,0,0,0,0,144,93,0,0,47,5,0,0,48,5,0,0,7,0,0,0,1,0,0,0,81,0,0,0,177,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,72,2,0,0,8,0,0,0,205,1,0,0,3,0,0,0,206,1,0,0,0,0,0,0,152,93,0,0,49,5,0,0,50,5,0,0,71,3,0,0,211,0,0,0,82,0,0,0,178,0,0,0,73,2,0,0,74,2,0,0,212,0,0,0,75,2,0,0,76,2,0,0,207,1,0,0,213,0,0,0,208,1,0,0,8,0,0,0,0,0,0,0,160,93,0,0,49,0,0,0,50,0,0,0,248,255,255,255,248,255,255,255,160,93,0,0,51,0,0,0,52,0,0,0,172,58,2,0,192,58,2,0,8,0,0,0,0,0,0,0,184,93,0,0,51,5,0,0,52,5,0,0,248,255,255,255,248,255,255,255,184,93,0,0,53,5,0,0,54,5,0,0,220,58,2,0,240,58,2,0,28,32,0,0,48,32,0,0,4,0,0,0,0,0,0,0,232,93,0,0,55,5,0,0,56,5,0,0,252,255,255,255,252,255,255,255,232,93,0,0,57,5,0,0,58,5,0,0,20,59,2,0,40,59,2,0,12,0,0,0,0,0,0,0,0,94,0,0,208,2,0,0,209,2,0,0,4,0,0,0,248,255,255,255,0,94,0,0,210,2,0,0,211,2,0,0,244,255,255,255,244,255,255,255,0,94,0,0,212,2,0,0,213,2,0,0,68,59,2,0,44,94,0,0,64,94,0,0,28,32,0,0,48,32,0,0,108,59,2,0,88,59,2,0,0,0,0,0,72,94,0,0,59,5,0,0,60,5,0,0,72,3,0,0,211,0,0,0,82,0,0,0,178,0,0,0,77,2,0,0,74,2,0,0,212,0,0,0,75,2,0,0,76,2,0,0,207,1,0,0,214,0,0,0,209,1,0,0,0,0,0,0,88,94,0,0,61,5,0,0,62,5,0,0,73,3,0,0,1,0,0,0,81,0,0,0,177,0,0,0,78,2,0,0,6,0,0,0,2,0,0,0,72,2,0,0,8,0,0,0,205,1,0,0,215,0,0,0,210,1,0,0,0,0,0,0,104,94,0,0,63,5,0,0,64,5,0,0,74,3,0,0,211,0,0,0,82,0,0,0,178,0,0,0,73,2,0,0,74,2,0,0,212,0,0,0,79,2,0,0,80,2,0,0,211,1,0,0,213,0,0,0,208,1,0,0,0,0,0,0,120,94,0,0,65,5,0,0,66,5,0,0,75,3,0,0,1,0,0,0,81,0,0,0,177,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,81,2,0,0,82,2,0,0,212,1,0,0,3,0,0,0,206,1,0,0,0,0,0,0,136,94,0,0,67,5,0,0,68,5,0,0,69,5,0,0,70,0,0,0,179,0,0,0,216,0,0,0,0,0,0,0,168,94,0,0,70,5,0,0,71,5,0,0,69,5,0,0,71,0,0,0,180,0,0,0,217,0,0,0,0,0,0,0,184,94,0,0,72,5,0,0,73,5,0,0,69,5,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,0,0,0,0,248,94,0,0,74,5,0,0,75,5,0,0,69,5,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,0,0,0,0,48,95,0,0,76,5,0,0,77,5,0,0,69,5,0,0,72,0,0,0,73,0,0,0,54,0,0,0,74,0,0,0,55,0,0,0,1,0,0,0,2,0,0,0,75,0,0,0,0,0,0,0,112,95,0,0,78,5,0,0,79,5,0,0,69,5,0,0,76,0,0,0,77,0,0,0,56,0,0,0,78,0,0,0,57,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,0,0,0,0,168,95,0,0,80,5,0,0,81,5,0,0,69,5,0,0,83,2,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,2,0,0,0,248,255,255,255,168,95,0,0,84,2,0,0,85,2,0,0,86,2,0,0,87,2,0,0,88,2,0,0,89,2,0,0,90,2,0,0,0,0,0,0,224,95,0,0,82,5,0,0,83,5,0,0,69,5,0,0,91,2,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,3,0,0,0,248,255,255,255,224,95,0,0,92,2,0,0,93,2,0,0,94,2,0,0,95,2,0,0,96,2,0,0,97,2,0,0,98,2,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,16,96,0,0,84,5,0,0,85,5,0,0,69,5,0,0,1,0,0,0,0,0,0,0,56,96,0,0,86,5,0,0,87,5,0,0,69,5,0,0,2,0,0,0,0,0,0,0,88,96,0,0,88,5,0,0,89,5,0,0,69,5,0,0,99,2,0,0,100,2,0,0,76,3,0,0,77,3,0,0,78,3,0,0,79,3,0,0,101,2,0,0,80,3,0,0,81,3,0,0,0,0,0,0,128,96,0,0,90,5,0,0,91,5,0,0,69,5,0,0,102,2,0,0,103,2,0,0,82,3,0,0,83,3,0,0,84,3,0,0,85,3,0,0,104,2,0,0,86,3,0,0,87,3,0,0,0,0,0,0,160,96,0,0,92,5,0,0,93,5,0,0,69,5,0,0,105,2,0,0,106,2,0,0,88,3,0,0,89,3,0,0,90,3,0,0,91,3,0,0,107,2,0,0,92,3,0,0,93,3,0,0,0,0,0,0,192,96,0,0,94,5,0,0,95,5,0,0,69,5,0,0,108,2,0,0,109,2,0,0,94,3,0,0,95,3,0,0,96,3,0,0,97,3,0,0,110,2,0,0,98,3,0,0,99,3,0,0,0,0,0,0,224,96,0,0,96,5,0,0,97,5,0,0,69,5,0,0,3,0,0,0,4,0,0,0,0,0,0,0,8,97,0,0,98,5,0,0,99,5,0,0,69,5,0,0,5,0,0,0,6,0,0,0,0,0,0,0,48,97,0,0,100,5,0,0,101,5,0,0,69,5,0,0,1,0,0,0,68,0,0,0,0,0,0,0,88,97,0,0,102,5,0,0,103,5,0,0,69,5,0,0,2,0,0,0,69,0,0,0,0,0,0,0,128,97,0,0,104,5,0,0,105,5,0,0,69,5,0,0,218,0,0,0,83,0,0,0,100,3,0,0,0,0,0,0,168,97,0,0,106,5,0,0,107,5,0,0,69,5,0,0,219,0,0,0,84,0,0,0,101,3,0,0,0,0,0,0,0,98,0,0,108,5,0,0,109,5,0,0,69,5,0,0,4,0,0,0,5,0,0,0,80,0,0,0,111,2,0,0,112,2,0,0,81,0,0,0,113,2,0,0,0,0,0,0,200,97,0,0,108,5,0,0,110,5,0,0,69,5,0,0,4,0,0,0,5,0,0,0,80,0,0,0,111,2,0,0,112,2,0,0,81,0,0,0,113,2,0,0,0,0,0,0,48,98,0,0,111,5,0,0,112,5,0,0,69,5,0,0,6,0,0,0,7,0,0,0,82,0,0,0,114,2,0,0,115,2,0,0,83,0,0,0,116,2,0,0,0,0,0,0,112,98,0,0,113,5,0,0,114,5,0,0,69,5,0,0,0,0,0,0,128,98,0,0,115,5,0,0,116,5,0,0,69,5,0,0,213,1,0,0,220,0,0,0,214,1,0,0,221,0,0,0,215,1,0,0,34,0,0,0,222,0,0,0,84,0,0,0,0,0,0,0,200,98,0,0,117,5,0,0,118,5,0,0,69,5,0,0,117,2,0,0,118,2,0,0,102,3,0,0,103,3,0,0,104,3,0,0,0,0,0,0,216,98,0,0,119,5,0,0,120,5,0,0,69,5,0,0,119,2,0,0,120,2,0,0,105,3,0,0,106,3,0,0,107,3,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,152,94,0,0,108,5,0,0,121,5,0,0,69,5,0,0,0,0,0,0,168,98,0,0,108,5,0,0,122,5,0,0,69,5,0,0,223,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,216,1,0,0,224,0,0,0,217,1,0,0,225,0,0,0,218,1,0,0,38,0,0,0,226,0,0,0,85,0,0,0,0,0,0,0,16,98,0,0,108,5,0,0,123,5,0,0,69,5,0,0,8,0,0,0,9,0,0,0,86,0,0,0,121,2,0,0,122,2,0,0,87,0,0,0,123,2,0,0,0,0,0,0,80,98,0,0,108,5,0,0,124,5,0,0,69,5,0,0,10,0,0,0,11,0,0,0,88,0,0,0,124,2,0,0,125,2,0,0,89,0,0,0,126,2,0,0,0,0,0,0,216,97,0,0,108,5,0,0,125,5,0,0,69,5,0,0,4,0,0,0,5,0,0,0,80,0,0,0,111,2,0,0,112,2,0,0,81,0,0,0,113,2,0,0,0,0,0,0,216,95,0,0,84,2,0,0,85,2,0,0,86,2,0,0,87,2,0,0,88,2,0,0,89,2,0,0,90,2,0,0,0,0,0,0,8,96,0,0,92,2,0,0,93,2,0,0,94,2,0,0,95,2,0,0,96,2,0,0,97,2,0,0,98,2,0,0,2,0,0,0,26,116,7,0,0,0,0,0,248,98,0,0,126,5,0,0,127,5,0,0,128,5,0,0,129,5,0,0,227,0,0,0,85,0,0,0,92,0,0,0,181,0,0,0,0,0,0,0,32,99,0,0,126,5,0,0,130,5,0,0,128,5,0,0,129,5,0,0,227,0,0,0,86,0,0,0,93,0,0,0,182,0,0,0,0,0,0,0,48,99,0,0,131,5,0,0,132,5,0,0,127,2,0,0,0,0,0,0,64,99,0,0,131,5,0,0,133,5,0,0,127,2,0,0,0,0,0,0,80,99,0,0,131,5,0,0,134,5,0,0,127,2,0,0,0,0,0,0,96,99,0,0,135,5,0,0,136,5,0,0,128,2,0,0,0,0,0,0,144,99,0,0,126,5,0,0,137,5,0,0,128,5,0,0,129,5,0,0,228,0,0,0,0,0,0,0,128,99,0,0,126,5,0,0,138,5,0,0,128,5,0,0,129,5,0,0,229,0,0,0,0,0,0,0,16,100,0,0,126,5,0,0,139,5,0,0,128,5,0,0,129,5,0,0,227,0,0,0,87,0,0,0,94,0,0,0,183,0,0,0,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,192,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,160,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,224,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,144,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,208,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,176,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,240,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,200,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,168,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,232,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,152,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,216,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,184,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,248,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,196,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,164,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,228,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,148,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,212,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,180,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,244,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,204,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,172,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,236,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,156,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,220,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,188,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,252,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,194,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,162,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,226,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,146,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,210,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,178,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,242,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,202,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,170,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,234,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,154,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,218,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,186,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,250,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,198,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,166,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,230,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,150,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,214,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,182,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,246,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,206,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,174,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,238,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,158,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,222,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,190,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,254,0,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,193,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,161,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,225,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,145,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,209,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,177,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,241,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,201,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,169,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,233,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,153,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,217,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,185,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,249,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,197,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,165,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,229,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,149,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,213,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,181,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,245,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,205,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,173,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,237,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,157,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,221,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,189,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,253,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,195,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,163,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,227,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,147,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,211,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,179,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,243,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,203,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,171,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,235,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,155,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,219,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,187,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,251,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,199,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,167,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,231,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,151,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,215,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,183,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,247,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,207,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,175,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,239,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,159,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,223,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,191,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,255,0,16,5,1,0,23,5,1,1,19,5,17,0,27,5,1,16,17,5,5,0,25,5,1,4,21,5,65,0,29,5,1,64,16,5,3,0,24,5,1,2,20,5,33,0,28,5,1,32,18,5,9,0,26,5,1,8,22,5,129,0,64,5,0,0,16,5,2,0,23,5,129,1,19,5,25,0,27,5,1,24,17,5,7,0,25,5,1,6,21,5,97,0,29,5,1,96,16,5,4,0,24,5,1,3,20,5,49,0,28,5,1,48,18,5,13,0,26,5,1,12,22,5,193,0,64,5,0,0,16,0,17,0,18,0,0,0,8,0,7,0,9,0,6,0,10,0,5,0,11,0,4,0,12,0,3,0,13,0,2,0,14,0,1,0,15,0,1,0,2,0,3,0,4,0,5,0,7,0,9,0,13,0,17,0,25,0,33,0,49,0,65,0,97,0,129,0,193,0,1,1,129,1,1,2,1,3,1,4,1,6,1,8,1,12,1,16,1,24,1,32,1,48,1,64,1,96,0,0,0,0,3,0,4,0,5,0,6,0,7,0,8,0,9,0,10,0,11,0,13,0,15,0,17,0,19,0,23,0,27,0,31,0,35,0,43,0,51,0,59,0,67,0,83,0,99,0,115,0,131,0,163,0,195,0,227,0,2,1,0,0,0,0,16,0,16,0,16,0,16,0,17,0,17,0,18,0,18,0,19,0,19,0,20,0,20,0,21,0,21,0,22,0,22,0,23,0,23,0,24,0,24,0,25,0,25,0,26,0,26,0,27,0,27,0,28,0,28,0,29,0,29,0,64,0,64,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,17,0,17,0,17,0,17,0,18,0,18,0,18,0,18,0,19,0,19,0,19,0,19,0,20,0,20,0,20,0,20,0,21,0,21,0,21,0,21,0,16,0,77,0,202,0,0,0,5,0,16,0,5,0,8,0,5,0,24,0,5,0,4,0,5,0,20,0,5,0,12,0,5,0,28,0,5,0,2,0,5,0,18,0,5,0,10,0,5,0,26,0,5,0,6,0,5,0,22,0,5,0,14,0,5,0,30,0,5,0,1,0,5,0,17,0,5,0,9,0,5,0,25,0,5,0,5,0,5,0,21,0,5,0,13,0,5,0,29,0,5,0,3,0,5,0,19,0,5,0,11,0,5,0,27,0,5,0,7,0,5,0,23,0,5,0,12,0,8,0,140,0,8,0,76,0,8,0,204,0,8,0,44,0,8,0,172,0,8,0,108,0,8,0,236,0,8,0,28,0,8,0,156,0,8,0,92,0,8,0,220,0,8,0,60,0,8,0,188,0,8,0,124,0,8,0,252,0,8,0,2,0,8,0,130,0,8,0,66,0,8,0,194,0,8,0,34,0,8,0,162,0,8,0,98,0,8,0,226,0,8,0,18,0,8,0,146,0,8,0,82,0,8,0,210,0,8,0,50,0,8,0,178,0,8,0,114,0,8,0,242,0,8,0,10,0,8,0,138,0,8,0,74,0,8,0,202,0,8,0,42,0,8,0,170,0,8,0,106,0,8,0,234,0,8,0,26,0,8,0,154,0,8,0,90,0,8,0,218,0,8,0,58,0,8,0,186,0,8,0,122,0,8,0,250,0,8,0,6,0,8,0,134,0,8,0,70,0,8,0,198,0,8,0,38,0,8,0,166,0,8,0,102,0,8,0,230,0,8,0,22,0,8,0,150,0,8,0,86,0,8,0,214,0,8,0,54,0,8,0,182,0,8,0,118,0,8,0,246,0,8,0,14,0,8,0,142,0,8,0,78,0,8,0,206,0,8,0,46,0,8,0,174,0,8,0,110,0,8,0,238,0,8,0,30,0,8,0,158,0,8,0,94,0,8,0,222,0,8,0,62,0,8,0,190,0,8,0,126,0,8,0,254,0,8,0,1,0,8,0,129,0,8,0,65,0,8,0,193,0,8,0,33,0,8,0,161,0,8,0,97,0,8,0,225,0,8,0,17,0,8,0,145,0,8,0,81,0,8,0,209,0,8,0,49,0,8,0,177,0,8,0,113,0,8,0,241,0,8,0,9,0,8,0,137,0,8,0,73,0,8,0,201,0,8,0,41,0,8,0,169,0,8,0,105,0,8,0,233,0,8,0,25,0,8,0,153,0,8,0,89,0,8,0,217,0,8,0,57,0,8,0,185,0,8,0,121,0,8,0,249,0,8,0,5,0,8,0,133,0,8,0,69,0,8,0,197,0,8,0,37,0,8,0,165,0,8,0,101,0,8,0,229,0,8,0,21,0,8,0,149,0,8,0,85,0,8,0,213,0,8,0,53,0,8,0,181,0,8,0,117,0,8,0,245,0,8,0,13,0,8,0,141,0,8,0,77,0,8,0,205,0,8,0,45,0,8,0,173,0,8,0,109,0,8,0,237,0,8,0,29,0,8,0,157,0,8,0,93,0,8,0,221,0,8,0,61,0,8,0,189,0,8,0,125,0,8,0,253,0,8,0,19,0,9,0,19,1,9,0,147,0,9,0,147,1,9,0,83,0,9,0,83,1,9,0,211,0,9,0,211,1,9,0,51,0,9,0,51,1,9,0,179,0,9,0,179,1,9,0,115,0,9,0,115,1,9,0,243,0,9,0,243,1,9,0,11,0,9,0,11,1,9,0,139,0,9,0,139,1,9,0,75,0,9,0,75,1,9,0,203,0,9,0,203,1,9,0,43,0,9,0,43,1,9,0,171,0,9,0,171,1,9,0,107,0,9,0,107,1,9,0,235,0,9,0,235,1,9,0,27,0,9,0,27,1,9,0,155,0,9,0,155,1,9,0,91,0,9,0,91,1,9,0,219,0,9,0,219,1,9,0,59,0,9,0,59,1,9,0,187,0,9,0,187,1,9,0,123,0,9,0,123,1,9,0,251,0,9,0,251,1,9,0,7,0,9,0,7,1,9,0,135,0,9,0,135,1,9,0,71,0,9,0,71,1,9,0,199,0,9,0,199,1,9,0,39,0,9,0,39,1,9,0,167,0,9,0,167,1,9,0,103,0,9,0,103,1,9,0,231,0,9,0,231,1,9,0,23,0,9,0,23,1,9,0,151,0,9,0,151,1,9,0,87,0,9,0,87,1,9,0,215,0,9,0,215,1,9,0,55,0,9,0,55,1,9,0,183,0,9,0,183,1,9,0,119,0,9,0,119,1,9,0,247,0,9,0,247,1,9,0,15,0,9,0,15,1,9,0,143,0,9,0,143,1,9,0,79,0,9,0,79,1,9,0,207,0,9,0,207,1,9,0,47,0,9,0,47,1,9,0,175,0,9,0,175,1,9,0,111,0,9,0,111,1,9,0,239,0,9,0,239,1,9,0,31,0,9,0,31,1,9,0,159,0,9,0,159,1,9,0,95,0,9,0,95,1,9,0,223,0,9,0,223,1,9,0,63,0,9,0,63,1,9,0,191,0,9,0,191,1,9,0,127,0,9,0,127,1,9,0,255,0,9,0,255,1,9,0,0,0,7,0,64,0,7,0,32,0,7,0,96,0,7,0,16,0,7,0,80,0,7,0,48,0,7,0,112,0,7,0,8,0,7,0,72,0,7,0,40,0,7,0,104,0,7,0,24,0,7,0,88,0,7,0,56,0,7,0,120,0,7,0,4,0,7,0,68,0,7,0,36,0,7,0,100,0,7,0,20,0,7,0,84,0,7,0,52,0,7,0,116,0,7,0,3,0,8,0,131,0,8,0,67,0,8,0,195,0,8,0,35,0,8,0,163,0,8,0,99,0,8,0,227,0,8],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+143360);allocate([2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,3,32,2,32,2,32,2,32,2,32,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,1,96,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,213,8,213,8,213,8,213,8,213,8,213,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,4,192,4,192,4,192,4,192,4,192,4,192,8,214,8,214,8,214,8,214,8,214,8,214,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,4,192,4,192,4,192,4,192,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,117,115,104,0,73,110,116,86,101,99,116,111,114,0,70,108,111,97,116,86,101,99,116,111,114,0,68,111,117,98,108,101,86,101,99,116,111,114,0,80,111,105,110,116,86,101,99,116,111,114,0,77,97,116,86,101,99,116,111,114,0,82,101,99,116,86,101,99,116,111,114,0,101,121,101,0,111,110,101,115,0,122,101,114,111,115,0,109,97,116,83,105,122,101,0,115,116,101,112,0,100,97,116,97,56,83,0,100,97,116,97,49,54,85,0,100,97,116,97,49,54,83,0,100,97,116,97,51,50,83,0,100,97,116,97,51,50,70,0,100,97,116,97,54,52,70,0,101,108,101,109,83,105,122,101,0,101,108,101,109,83,105,122,101,49,0,99,104,97,110,110,101,108,115,0,114,111,119,0,114,111,119,82,97,110,103,101,0,99,111,108,82,97,110,103,101,0,115,116,101,112,49,0,99,108,111,110,101,0,100,101,112,116,104,0,99,111,108,0,109,117,108,0,105,110,118,0,112,116,114,0,117,99,104,97,114,80,116,114,0,99,104,97,114,80,116,114,0,115,104,111,114,116,80,116,114,0,117,115,104,111,114,116,80,116,114,0,105,110,116,80,116,114,0,102,108,111,97,116,80,116,114,0,100,111,117,98,108,101,80,116,114,0,99,104,97,114,65,116,0,117,99,104,97,114,65,116,0,115,104,111,114,116,65,116,0,117,115,104,111,114,116,65,116,0,105,110,116,65,116,0,102,108,111,97,116,65,116,0,100,111,117,98,108,101,65,116,0,82,97,110,103,101,0,84,101,114,109,67,114,105,116,101,114,105,97,0,109,97,120,67,111,117,110,116,0,35,116,121,112,101,0,82,101,99,116,0,82,101,99,116,50,102,0,82,111,116,97,116,101,100,82,101,99,116,0,99,101,110,116,101,114,0,97,110,103,108,101,0,114,111,116,97,116,101,100,82,101,99,116,80,111,105,110,116,115,0,114,111,116,97,116,101,100,82,101,99,116,66,111,117,110,100,105,110,103,82,101,99,116,0,114,111,116,97,116,101,100,82,101,99,116,66,111,117,110,100,105,110,103,82,101,99,116,50,102,0,83,99,97,108,97,114,0,77,105,110,77,97,120,76,111,99,0,109,105,110,86,97,108,0,109,97,120,86,97,108,0,109,105,110,76,111,99,0,109,97,120,76,111,99,0,67,105,114,99,108,101,0,114,97,100,105,117,115,0,77,111,109,101,110,116,115,0,109,48,48,0,109,49,48,0,109,48,49,0,109,50,48,0,109,49,49,0,109,48,50,0,109,51,48,0,109,50,49,0,109,49,50,0,109,48,51,0,109,117,50,48,0,109,117,49,49,0,109,117,48,50,0,109,117,51,48,0,109,117,50,49,0,109,117,49,50,0,109,117,48,51,0,110,117,50,48,0,110,117,49,49,0,110,117,48,50,0,110,117,51,48,0,110,117,50,49,0,110,117,49,50,0,110,117,48,51,0,69,120,99,101,112,116,105,111,110,0,99,111,100,101,0,109,115,103,0,101,120,99,101,112,116,105,111,110,70,114,111,109,80,116,114,0,109,111,114,112,104,111,108,111,103,121,68,101,102,97,117,108,116,66,111,114,100,101,114,86,97,108,117,101,0,67,86,95,77,65,84,95,68,69,80,84,72,0,67,97,109,83,104,105,102,116,0,103,101,116,66,117,105,108,100,73,110,102,111,114,109,97,116,105,111,110,0,67,86,95,56,85,67,49,0,67,86,95,56,85,67,50,0,67,86,95,56,85,67,51,0,67,86,95,56,85,67,52,0,67,86,95,56,83,67,49,0,67,86,95,56,83,67,50,0,67,86,95,56,83,67,51,0,67,86,95,56,83,67,52,0,67,86,95,49,54,85,67,49,0,67,86,95,49,54,85,67,50,0,67,86,95,49,54,85,67,51,0,67,86,95,49,54,85,67,52,0,67,86,95,49,54,83,67,49,0,67,86,95,49,54,83,67,50,0,67,86,95,49,54,83,67,51,0,67,86,95,49,54,83,67,52,0,67,86,95,51,50,83,67,49,0,67,86,95,51,50,83,67,50,0,67,86,95,51,50,83,67,51,0,67,86,95,51,50,83,67,52,0,67,86,95,51,50,70,67,49,0,67,86,95,51,50,70,67,50,0,67,86,95,51,50,70,67,51,0,67,86,95,51,50,70,67,52,0,67,86,95,54,52,70,67,49,0,67,86,95,54,52,70,67,50,0,67,86,95,54,52,70,67,51,0,67,86,95,54,52,70,67,52,0,67,86,95,56,85,0,67,86,95,56,83,0,67,86,95,49,54,85,0,67,86,95,49,54,83,0,67,86,95,51,50,83,0,67,86,95,51,50,70,0,67,86,95,54,52,70,0,73,78,84,95,77,73,78,0,73,78,84,95,77,65,88,0,67,97,110,110,121,49,0,71,97,117,115,115,105,97,110,66,108,117,114,0,72,111,117,103,104,76,105,110,101,115,0,72,111,117,103,104,76,105,110,101,115,80,0,76,97,112,108,97,99,105,97,110,0,83,99,104,97,114,114,0,83,111,98,101,108,0,97,98,115,100,105,102,102,0,97,100,100,0,97,100,100,87,101,105,103,104,116,101,100,0,98,105,116,119,105,115,101,95,97,110,100,0,98,105,116,119,105,115,101,95,110,111,116,0,98,105,116,119,105,115,101,95,111,114,0,98,105,116,119,105,115,101,95,120,111,114,0,98,108,117,114,0,98,111,117,110,100,105,110,103,82,101,99,116,0,98,111,120,70,105,108,116,101,114,0,99,97,108,99,79,112,116,105,99,97,108,70,108,111,119,70,97,114,110,101,98,97,99,107,0,99,97,108,99,79,112,116,105,99,97,108,70,108,111,119,80,121,114,76,75,0,99,111,114,110,101,114,72,97,114,114,105,115,0,99,111,114,110,101,114,77,105,110,69,105,103,101,110,86,97,108,0,100,105,108,97,116,101,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,87,105,116,104,76,97,98,101,108,115,0,100,105,118,105,100,101,0,100,105,118,105,100,101,49,0,101,108,108,105,112,115,101,49,0,101,108,108,105,112,115,101,50,80,111,108,121,0,101,114,111,100,101,0,102,105,108,116,101,114,50,68,0,103,101,116,79,112,116,105,109,97,108,68,70,84,83,105,122,101,0,103,101,116,82,111,116,97,116,105,111,110,77,97,116,114,105,120,50,68,0,103,111,111,100,70,101,97,116,117,114,101,115,84,111,84,114,97,99,107,49,0,105,110,116,101,103,114,97,108,50,0,109,105,110,0,109,105,110,65,114,101,97,82,101,99,116,0,109,117,108,116,105,112,108,121,0,110,111,114,109,49,0,112,117,116,84,101,120,116,0,114,97,110,100,110,0,114,97,110,100,117,0,115,101,116,82,78,71,83,101,101,100,0,115,113,114,116,0,115,117,98,116,114,97,99,116,0,98,108,111,98,70,114,111,109,73,109,97,103,101,0,114,101,97,100,78,101,116,70,114,111,109,67,97,102,102,101,0,114,101,97,100,78,101,116,70,114,111,109,68,97,114,107,110,101,116,0,114,101,97,100,78,101,116,70,114,111,109,84,101,110,115,111,114,102,108,111,119,0,114,101,97,100,78,101,116,70,114,111,109,84,111,114,99,104,0,72,79,71,68,101,115,99,114,105,112,116,111,114,0,108,111,97,100,0,103,101,116,68,101,102,97,117,108,116,80,101,111,112,108,101,68,101,116,101,99,116,111,114,0,103,101,116,68,97,105,109,108,101,114,80,101,111,112,108,101,68,101,116,101,99,116,111,114,0,115,118,109,68,101,116,101,99,116,111,114,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,0,80,116,114,60,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,62,0,67,76,65,72,69,0,115,101,116,84,105,108,101,115,71,114,105,100,83,105,122,101,0,99,111,108,108,101,99,116,71,97,114,98,97,103,101,0,115,101,116,67,108,105,112,76,105,109,105,116,0,103,101,116,84,105,108,101,115,71,114,105,100,83,105,122,101,0,103,101,116,67,108,105,112,76,105,109,105,116,0,80,116,114,60,67,76,65,72,69,62,0,65,108,103,111,114,105,116,104,109,0,100,110,110,95,78,101,116,0,102,111,114,119,97,114,100,49,0,102,111,114,119,97,114,100,50,0,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,50,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,51,0,65,67,67,69,83,83,95,70,65,83,84,0,65,67,67,69,83,83,95,77,65,83,75,0,65,67,67,69,83,83,95,82,69,65,68,0,65,67,67,69,83,83,95,82,87,0,65,67,67,69,83,83,95,87,82,73,84,69,0,65,68,65,80,84,73,86,69,95,84,72,82,69,83,72,95,71,65,85,83,83,73,65,78,95,67,0,65,68,65,80,84,73,86,69,95,84,72,82,69,83,72,95,77,69,65,78,95,67,0,66,79,82,68,69,82,95,67,79,78,83,84,65,78,84,0,66,79,82,68,69,82,95,68,69,70,65,85,76,84,0,66,79,82,68,69,82,95,73,83,79,76,65,84,69,68,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,49,48,49,0,66,79,82,68,69,82,95,82,69,70,76,69,67,84,95,49,48,49,0,66,79,82,68,69,82,95,82,69,80,76,73,67,65,84,69,0,66,79,82,68,69,82,95,84,82,65,78,83,80,65,82,69,78,84,0,66,79,82,68,69,82,95,87,82,65,80,0,67,65,83,67,65,68,69,95,68,79,95,67,65,78,78,89,95,80,82,85,78,73,78,71,0,67,65,83,67,65,68,69,95,68,79,95,82,79,85,71,72,95,83,69,65,82,67,72,0,67,65,83,67,65,68,69,95,70,73,78,68,95,66,73,71,71,69,83,84,95,79,66,74,69,67,84,0,67,65,83,67,65,68,69,95,83,67,65,76,69,95,73,77,65,71,69,0,67,67,76,95,68,69,70,65,85,76,84,0,67,67,76,95,71,82,65,78,65,0,67,67,76,95,87,85,0,67,67,95,83,84,65,84,95,65,82,69,65,0,67,67,95,83,84,65,84,95,72,69,73,71,72,84,0,67,67,95,83,84,65,84,95,76,69,70,84,0,67,67,95,83,84,65,84,95,77,65,88,0,67,67,95,83,84,65,84,95,84,79,80,0,67,67,95,83,84,65,84,95,87,73,68,84,72,0,67,72,65,73,78,95,65,80,80,82,79,88,95,78,79,78,69,0,67,72,65,73,78,95,65,80,80,82,79,88,95,83,73,77,80,76,69,0,67,72,65,73,78,95,65,80,80,82,79,88,95,84,67,56,57,95,75,67,79,83,0,67,72,65,73,78,95,65,80,80,82,79,88,95,84,67,56,57,95,76,49,0,67,77,80,95,69,81,0,67,77,80,95,71,69,0,67,77,80,95,71,84,0,67,77,80,95,76,69,0,67,77,80,95,76,84,0,67,77,80,95,78,69,0,67,79,76,79,82,77,65,80,95,65,85,84,85,77,78,0,67,79,76,79,82,77,65,80,95,66,79,78,69,0,67,79,76,79,82,77,65,80,95,67,79,79,76,0,67,79,76,79,82,77,65,80,95,72,79,84,0,67,79,76,79,82,77,65,80,95,72,83,86,0,67,79,76,79,82,77,65,80,95,74,69,84,0,67,79,76,79,82,77,65,80,95,79,67,69,65,78,0,67,79,76,79,82,77,65,80,95,80,65,82,85,76,65,0,67,79,76,79,82,77,65,80,95,80,73,78,75,0,67,79,76,79,82,77,65,80,95,82,65,73,78,66,79,87,0,67,79,76,79,82,77,65,80,95,83,80,82,73,78,71,0,67,79,76,79,82,77,65,80,95,83,85,77,77,69,82,0,67,79,76,79,82,77,65,80,95,87,73,78,84,69,82,0,67,79,76,79,82,95,66,71,82,50,66,71,82,53,53,53,0,67,79,76,79,82,95,66,71,82,50,66,71,82,53,54,53,0,67,79,76,79,82,95,66,71,82,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,50,72,76,83,0,67,79,76,79,82,95,66,71,82,50,72,76,83,95,70,85,76,76,0,67,79,76,79,82,95,66,71,82,50,72,83,86,0,67,79,76,79,82,95,66,71,82,50,72,83,86,95,70,85,76,76,0,67,79,76,79,82,95,66,71,82,50,76,97,98,0,67,79,76,79,82,95,66,71,82,50,76,117,118,0,67,79,76,79,82,95,66,71,82,50,82,71,66,0,67,79,76,79,82,95,66,71,82,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,50,88,89,90,0,67,79,76,79,82,95,66,71,82,50,89,67,114,67,98,0,67,79,76,79,82,95,66,71,82,50,89,85,86,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,66,71,82,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,66,71,82,53,53,53,50,66,71,82,0,67,79,76,79,82,95,66,71,82,53,53,53,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,53,53,53,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,53,53,53,50,82,71,66,0,67,79,76,79,82,95,66,71,82,53,53,53,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,53,54,53,50,66,71,82,0,67,79,76,79,82,95,66,71,82,53,54,53,50,66,71,82,65,0,67,79,76,79,82,95,66,71,82,53,54,53,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,53,54,53,50,82,71,66,0,67,79,76,79,82,95,66,71,82,53,54,53,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,53,53,53,0,67,79,76,79,82,95,66,71,82,65,50,66,71,82,53,54,53,0,67,79,76,79,82,95,66,71,82,65,50,71,82,65,89,0,67,79,76,79,82,95,66,71,82,65,50,82,71,66,0,67,79,76,79,82,95,66,71,82,65,50,82,71,66,65,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,66,71,82,65,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,66,71,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,66,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,71,82,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,66,71,82,95,86,78,71,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,71,82,65,89,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,95,69,65,0,67,79,76,79,82,95,66,97,121,101,114,82,71,50,82,71,66,95,86,78,71,0,67,79,76,79,82,95,67,79,76,79,82,67,86,84,95,77,65,88,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,53,53,53,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,53,54,53,0,67,79,76,79,82,95,71,82,65,89,50,66,71,82,65,0,67,79,76,79,82,95,71,82,65,89,50,82,71,66,0,67,79,76,79,82,95,71,82,65,89,50,82,71,66,65,0,67,79,76,79,82,95,72,76,83,50,66,71,82,0,67,79,76,79,82,95,72,76,83,50,66,71,82,95,70,85,76,76,0,67,79,76,79,82,95,72,76,83,50,82,71,66,0,67,79,76,79,82,95,72,76,83,50,82,71,66,95,70,85,76,76,0,67,79,76,79,82,95,72,83,86,50,66,71,82,0,67,79,76,79,82,95,72,83,86,50,66,71,82,95,70,85,76,76,0,67,79,76,79,82,95,72,83,86,50,82,71,66,0,67,79,76,79,82,95,72,83,86,50,82,71,66,95,70,85,76,76,0,67,79,76,79,82,95,76,66,71,82,50,76,97,98,0,67,79,76,79,82,95,76,66,71,82,50,76,117,118,0,67,79,76,79,82,95,76,82,71,66,50,76,97,98,0,67,79,76,79,82,95,76,82,71,66,50,76,117,118,0,67,79,76,79,82,95,76,97,98,50,66,71,82,0,67,79,76,79,82,95,76,97,98,50,76,66,71,82,0,67,79,76,79,82,95,76,97,98,50,76,82,71,66,0,67,79,76,79,82,95,76,97,98,50,82,71,66,0,67,79,76,79,82,95,76,117,118,50,66,71,82,0,67,79,76,79,82,95,76,117,118,50,76,66,71,82,0,67,79,76,79,82,95,76,117,118,50,76,82,71,66,0,67,79,76,79,82,95,76,117,118,50,82,71,66,0,67,79,76,79,82,95,82,71,66,50,66,71,82,0,67,79,76,79,82,95,82,71,66,50,66,71,82,53,53,53,0,67,79,76,79,82,95,82,71,66,50,66,71,82,53,54,53,0,67,79,76,79,82,95,82,71,66,50,66,71,82,65,0,67,79,76,79,82,95,82,71,66,50,71,82,65,89,0,67,79,76,79,82,95,82,71,66,50,72,76,83,0,67,79,76,79,82,95,82,71,66,50,72,76,83,95,70,85,76,76,0,67,79,76,79,82,95,82,71,66,50,72,83,86,0,67,79,76,79,82,95,82,71,66,50,72,83,86,95,70,85,76,76,0,67,79,76,79,82,95,82,71,66,50,76,97,98,0,67,79,76,79,82,95,82,71,66,50,76,117,118,0,67,79,76,79,82,95,82,71,66,50,82,71,66,65,0,67,79,76,79,82,95,82,71,66,50,88,89,90,0,67,79,76,79,82,95,82,71,66,50,89,67,114,67,98,0,67,79,76,79,82,95,82,71,66,50,89,85,86,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,82,71,66,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,53,53,53,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,53,54,53,0,67,79,76,79,82,95,82,71,66,65,50,66,71,82,65,0,67,79,76,79,82,95,82,71,66,65,50,71,82,65,89,0,67,79,76,79,82,95,82,71,66,65,50,82,71,66,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,73,52,50,48,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,73,89,85,86,0,67,79,76,79,82,95,82,71,66,65,50,89,85,86,95,89,86,49,50,0,67,79,76,79,82,95,82,71,66,65,50,109,82,71,66,65,0,67,79,76,79,82,95,88,89,90,50,66,71,82,0,67,79,76,79,82,95,88,89,90,50,82,71,66,0,67,79,76,79,82,95,89,67,114,67,98,50,66,71,82,0,67,79,76,79,82,95,89,67,114,67,98,50,82,71,66,0,67,79,76,79,82,95,89,85,86,50,66,71,82,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,65,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,66,71,82,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,52,50,48,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,71,82,65,89,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,82,71,66,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,65,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,73,52,50,48,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,73,89,85,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,78,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,78,86,50,49,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,85,89,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,85,89,86,89,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,52,50,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,78,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,89,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,85,89,86,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,86,49,50,0,67,79,76,79,82,95,89,85,86,50,82,71,66,95,89,86,89,85,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,66,71,82,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,66,71,82,65,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,71,82,65,89,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,82,71,66,0,67,79,76,79,82,95,89,85,86,52,50,48,112,50,82,71,66,65,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,66,71,82,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,66,71,82,65,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,71,82,65,89,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,82,71,66,0,67,79,76,79,82,95,89,85,86,52,50,48,115,112,50,82,71,66,65,0,67,79,76,79,82,95,109,82,71,66,65,50,82,71,66,65,0,67,79,78,84,79,85,82,83,95,77,65,84,67,72,95,73,49,0,67,79,78,84,79,85,82,83,95,77,65,84,67,72,95,73,50,0,67,79,78,84,79,85,82,83,95,77,65,84,67,72,95,73,51,0,67,79,86,65,82,95,67,79,76,83,0,67,79,86,65,82,95,78,79,82,77,65,76,0,67,79,86,65,82,95,82,79,87,83,0,67,79,86,65,82,95,83,67,65,76,69,0,67,79,86,65,82,95,83,67,82,65,77,66,76,69,68,0,67,79,86,65,82,95,85,83,69,95,65,86,71,0,68,67,84,95,73,78,86,69,82,83,69,0,68,67,84,95,82,79,87,83,0,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,0,68,69,67,79,77,80,95,69,73,71,0,68,69,67,79,77,80,95,76,85,0,68,69,67,79,77,80,95,78,79,82,77,65,76,0,68,69,67,79,77,80,95,81,82,0,68,69,67,79,77,80,95,83,86,68,0,68,70,84,95,67,79,77,80,76,69,88,95,73,78,80,85,84,0,68,70,84,95,67,79,77,80,76,69,88,95,79,85,84,80,85,84,0,68,70,84,95,73,78,86,69,82,83,69,0,68,70,84,95,82,69,65,76,95,79,85,84,80,85,84,0,68,70,84,95,82,79,87,83,0,68,70,84,95,83,67,65,76,69,0,68,73,83,84,95,67,0,68,73,83,84,95,70,65,73,82,0,68,73,83,84,95,72,85,66,69,82,0,68,73,83,84,95,76,49,0,68,73,83,84,95,76,49,50,0,68,73,83,84,95,76,50,0,68,73,83,84,95,76,65,66,69,76,95,67,67,79,77,80,0,68,73,83,84,95,76,65,66,69,76,95,80,73,88,69,76,0,68,73,83,84,95,77,65,83,75,95,51,0,68,73,83,84,95,77,65,83,75,95,53,0,68,73,83,84,95,77,65,83,75,95,80,82,69,67,73,83,69,0,68,73,83,84,95,85,83,69,82,0,68,73,83,84,95,87,69,76,83,67,72,0,70,73,76,76,69,68,0,70,76,79,79,68,70,73,76,76,95,70,73,88,69,68,95,82,65,78,71,69,0,70,76,79,79,68,70,73,76,76,95,77,65,83,75,95,79,78,76,89,0,70,79,78,84,95,72,69,82,83,72,69,89,95,67,79,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,67,79,77,80,76,69,88,95,83,77,65,76,76,0,70,79,78,84,95,72,69,82,83,72,69,89,95,68,85,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,80,76,65,73,78,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,67,82,73,80,84,95,67,79,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,67,82,73,80,84,95,83,73,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,83,73,77,80,76,69,88,0,70,79,78,84,95,72,69,82,83,72,69,89,95,84,82,73,80,76,69,88,0,70,79,78,84,95,73,84,65,76,73,67,0,70,105,108,101,78,111,100,101,95,69,77,80,84,89,0,70,105,108,101,78,111,100,101,95,70,76,79,65,84,0,70,105,108,101,78,111,100,101,95,70,76,79,87,0,70,105,108,101,78,111,100,101,95,73,78,84,0,70,105,108,101,78,111,100,101,95,77,65,80,0,70,105,108,101,78,111,100,101,95,78,65,77,69,68,0,70,105,108,101,78,111,100,101,95,78,79,78,69,0,70,105,108,101,78,111,100,101,95,82,69,65,76,0,70,105,108,101,78,111,100,101,95,82,69,70,0,70,105,108,101,78,111,100,101,95,83,69,81,0,70,105,108,101,78,111,100,101,95,83,84,82,0,70,105,108,101,78,111,100,101,95,83,84,82,73,78,71,0,70,105,108,101,78,111,100,101,95,84,89,80,69,95,77,65,83,75,0,70,105,108,101,78,111,100,101,95,85,83,69,82,0,70,105,108,101,83,116,111,114,97,103,101,95,65,80,80,69,78,68,0,70,105,108,101,83,116,111,114,97,103,101,95,66,65,83,69,54,52,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,65,85,84,79,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,74,83,79,78,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,77,65,83,75,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,88,77,76,0,70,105,108,101,83,116,111,114,97,103,101,95,70,79,82,77,65,84,95,89,65,77,76,0,70,105,108,101,83,116,111,114,97,103,101,95,73,78,83,73,68,69,95,77,65,80,0,70,105,108,101,83,116,111,114,97,103,101,95,77,69,77,79,82,89,0,70,105,108,101,83,116,111,114,97,103,101,95,78,65,77,69,95,69,88,80,69,67,84,69,68,0,70,105,108,101,83,116,111,114,97,103,101,95,82,69,65,68,0,70,105,108,101,83,116,111,114,97,103,101,95,85,78,68,69,70,73,78,69,68,0,70,105,108,101,83,116,111,114,97,103,101,95,86,65,76,85,69,95,69,88,80,69,67,84,69,68,0,70,105,108,101,83,116,111,114,97,103,101,95,87,82,73,84,69,0,70,105,108,101,83,116,111,114,97,103,101,95,87,82,73,84,69,95,66,65,83,69,54,52,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,67,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,67,83,86,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,68,69,70,65,85,76,84,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,77,65,84,76,65,66,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,78,85,77,80,89,0,70,111,114,109,97,116,116,101,114,95,70,77,84,95,80,89,84,72,79,78,0,71,67,95,66,71,68,0,71,67,95,69,86,65,76,0,71,67,95,70,71,68,0,71,67,95,73,78,73,84,95,87,73,84,72,95,77,65,83,75,0,71,67,95,73,78,73,84,95,87,73,84,72,95,82,69,67,84,0,71,67,95,80,82,95,66,71,68,0,71,67,95,80,82,95,70,71,68,0,71,69,77,77,95,49,95,84,0,71,69,77,77,95,50,95,84,0,71,69,77,77,95,51,95,84,0,72,73,83,84,67,77,80,95,66,72,65,84,84,65,67,72,65,82,89,89,65,0,72,73,83,84,67,77,80,95,67,72,73,83,81,82,0,72,73,83,84,67,77,80,95,67,72,73,83,81,82,95,65,76,84,0,72,73,83,84,67,77,80,95,67,79,82,82,69,76,0,72,73,83,84,67,77,80,95,72,69,76,76,73,78,71,69,82,0,72,73,83,84,67,77,80,95,73,78,84,69,82,83,69,67,84,0,72,73,83,84,67,77,80,95,75,76,95,68,73,86,0,72,79,71,68,101,115,99,114,105,112,116,111,114,95,68,69,70,65,85,76,84,95,78,76,69,86,69,76,83,0,72,79,71,68,101,115,99,114,105,112,116,111,114,95,76,50,72,121,115,0,72,79,85,71,72,95,71,82,65,68,73,69,78,84,0,72,79,85,71,72,95,77,85,76,84,73,95,83,67,65,76,69,0,72,79,85,71,72,95,80,82,79,66,65,66,73,76,73,83,84,73,67,0,72,79,85,71,72,95,83,84,65,78,68,65,82,68,0,72,97,109,109,105,110,103,95,110,111,114,109,84,121,112,101,0,73,78,84,69,82,83,69,67,84,95,70,85,76,76,0,73,78,84,69,82,83,69,67,84,95,78,79,78,69,0,73,78,84,69,82,83,69,67,84,95,80,65,82,84,73,65,76,0,73,78,84,69,82,95,65,82,69,65,0,73,78,84,69,82,95,66,73,84,83,0,73,78,84,69,82,95,66,73,84,83,50,0,73,78,84,69,82,95,67,85,66,73,67,0,73,78,84,69,82,95,76,65,78,67,90,79,83,52,0,73,78,84,69,82,95,76,73,78,69,65,82,0,73,78,84,69,82,95,76,73,78,69,65,82,95,69,88,65,67,84,0,73,78,84,69,82,95,77,65,88,0,73,78,84,69,82,95,78,69,65,82,69,83,84,0,73,78,84,69,82,95,84,65,66,95,83,73,90,69,0,73,78,84,69,82,95,84,65,66,95,83,73,90,69,50,0,75,77,69,65,78,83,95,80,80,95,67,69,78,84,69,82,83,0,75,77,69,65,78,83,95,82,65,78,68,79,77,95,67,69,78,84,69,82,83,0,75,77,69,65,78,83,95,85,83,69,95,73,78,73,84,73,65,76,95,76,65,66,69,76,83,0,76,73,78,69,95,52,0,76,73,78,69,95,56,0,76,73,78,69,95,65,65,0,76,83,68,95,82,69,70,73,78,69,95,65,68,86,0,76,83,68,95,82,69,70,73,78,69,95,78,79,78,69,0,76,83,68,95,82,69,70,73,78,69,95,83,84,68,0,77,65,82,75,69,82,95,67,82,79,83,83,0,77,65,82,75,69,82,95,68,73,65,77,79,78,68,0,77,65,82,75,69,82,95,83,81,85,65,82,69,0,77,65,82,75,69,82,95,83,84,65,82,0,77,65,82,75,69,82,95,84,73,76,84,69,68,95,67,82,79,83,83,0,77,65,82,75,69,82,95,84,82,73,65,78,71,76,69,95,68,79,87,78,0,77,65,82,75,69,82,95,84,82,73,65,78,71,76,69,95,85,80,0,77,79,82,80,72,95,66,76,65,67,75,72,65,84,0,77,79,82,80,72,95,67,76,79,83,69,0,77,79,82,80,72,95,67,82,79,83,83,0,77,79,82,80,72,95,68,73,76,65,84,69,0,77,79,82,80,72,95,69,76,76,73,80,83,69,0,77,79,82,80,72,95,69,82,79,68,69,0,77,79,82,80,72,95,71,82,65,68,73,69,78,84,0,77,79,82,80,72,95,72,73,84,77,73,83,83,0,77,79,82,80,72,95,79,80,69,78,0,77,79,82,80,72,95,82,69,67,84,0,77,79,82,80,72,95,84,79,80,72,65,84,0,77,79,84,73,79,78,95,65,70,70,73,78,69,0,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,0,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,0,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,0,77,97,116,95,65,85,84,79,95,83,84,69,80,0,77,97,116,95,67,79,78,84,73,78,85,79,85,83,95,70,76,65,71,0,77,97,116,95,68,69,80,84,72,95,77,65,83,75,0,77,97,116,95,77,65,71,73,67,95,77,65,83,75,0,77,97,116,95,77,65,71,73,67,95,86,65,76,0,77,97,116,95,83,85,66,77,65,84,82,73,88,95,70,76,65,71,0,77,97,116,95,84,89,80,69,95,77,65,83,75,0,78,79,82,77,95,72,65,77,77,73,78,71,0,78,79,82,77,95,72,65,77,77,73,78,71,50,0,78,79,82,77,95,73,78,70,0,78,79,82,77,95,76,49,0,78,79,82,77,95,76,50,0,78,79,82,77,95,76,50,83,81,82,0,78,79,82,77,95,77,73,78,77,65,88,0,78,79,82,77,95,82,69,76,65,84,73,86,69,0,78,79,82,77,95,84,89,80,69,95,77,65,83,75,0,79,80,84,70,76,79,87,95,70,65,82,78,69,66,65,67,75,95,71,65,85,83,83,73,65,78,0,79,80,84,70,76,79,87,95,76,75,95,71,69,84,95,77,73,78,95,69,73,71,69,78,86,65,76,83,0,79,80,84,70,76,79,87,95,85,83,69,95,73,78,73,84,73,65,76,95,70,76,79,87,0,80,67,65,95,68,65,84,65,95,65,83,95,67,79,76,0,80,67,65,95,68,65,84,65,95,65,83,95,82,79,87,0,80,67,65,95,85,83,69,95,65,86,71,0,80,82,79,74,95,83,80,72,69,82,73,67,65,76,95,69,81,82,69,67,84,0,80,82,79,74,95,83,80,72,69,82,73,67,65,76,95,79,82,84,72,79,0,80,97,114,97,109,95,65,76,71,79,82,73,84,72,77,0,80,97,114,97,109,95,66,79,79,76,69,65,78,0,80,97,114,97,109,95,70,76,79,65,84,0,80,97,114,97,109,95,73,78,84,0,80,97,114,97,109,95,77,65,84,0,80,97,114,97,109,95,77,65,84,95,86,69,67,84,79,82,0,80,97,114,97,109,95,82,69,65,76,0,80,97,114,97,109,95,83,84,82,73,78,71,0,80,97,114,97,109,95,85,67,72,65,82,0,80,97,114,97,109,95,85,73,78,84,54,52,0,80,97,114,97,109,95,85,78,83,73,71,78,69,68,95,73,78,84,0,82,69,68,85,67,69,95,65,86,71,0,82,69,68,85,67,69,95,77,65,88,0,82,69,68,85,67,69,95,77,73,78,0,82,69,68,85,67,69,95,83,85,77,0,82,69,84,82,95,67,67,79,77,80,0,82,69,84,82,95,69,88,84,69,82,78,65,76,0,82,69,84,82,95,70,76,79,79,68,70,73,76,76,0,82,69,84,82,95,76,73,83,84,0,82,69,84,82,95,84,82,69,69,0,82,78,71,95,78,79,82,77,65,76,0,82,78,71,95,85,78,73,70,79,82,77,0,82,79,84,65,84,69,95,49,56,48,0,82,79,84,65,84,69,95,57,48,95,67,76,79,67,75,87,73,83,69,0,82,79,84,65,84,69,95,57,48,95,67,79,85,78,84,69,82,67,76,79,67,75,87,73,83,69,0,83,79,76,86,69,76,80,95,77,85,76,84,73,0,83,79,76,86,69,76,80,95,83,73,78,71,76,69,0,83,79,76,86,69,76,80,95,85,78,66,79,85,78,68,69,68,0,83,79,76,86,69,76,80,95,85,78,70,69,65,83,73,66,76,69,0,83,79,82,84,95,65,83,67,69,78,68,73,78,71,0,83,79,82,84,95,68,69,83,67,69,78,68,73,78,71,0,83,79,82,84,95,69,86,69,82,89,95,67,79,76,85,77,78,0,83,79,82,84,95,69,86,69,82,89,95,82,79,87,0,83,86,68,95,70,85,76,76,95,85,86,0,83,86,68,95,77,79,68,73,70,89,95,65,0,83,86,68,95,78,79,95,85],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+153662);allocate([86,0,83,112,97,114,115,101,77,97,116,95,72,65,83,72,95,66,73,84,0,83,112,97,114,115,101,77,97,116,95,72,65,83,72,95,83,67,65,76,69,0,83,112,97,114,115,101,77,97,116,95,77,65,71,73,67,95,86,65,76,0,83,112,97,114,115,101,77,97,116,95,77,65,88,95,68,73,77,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,68,83,84,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,76,69,70,84,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,79,82,71,0,83,117,98,100,105,118,50,68,95,78,69,88,84,95,65,82,79,85,78,68,95,82,73,71,72,84,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,68,83,84,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,76,69,70,84,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,79,82,71,0,83,117,98,100,105,118,50,68,95,80,82,69,86,95,65,82,79,85,78,68,95,82,73,71,72,84,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,69,82,82,79,82,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,73,78,83,73,68,69,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,79,78,95,69,68,71,69,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,79,85,84,83,73,68,69,95,82,69,67,84,0,83,117,98,100,105,118,50,68,95,80,84,76,79,67,95,86,69,82,84,69,88,0,84,72,82,69,83,72,95,66,73,78,65,82,89,0,84,72,82,69,83,72,95,66,73,78,65,82,89,95,73,78,86,0,84,72,82,69,83,72,95,77,65,83,75,0,84,72,82,69,83,72,95,79,84,83,85,0,84,72,82,69,83,72,95,84,79,90,69,82,79,0,84,72,82,69,83,72,95,84,79,90,69,82,79,95,73,78,86,0,84,72,82,69,83,72,95,84,82,73,65,78,71,76,69,0,84,72,82,69,83,72,95,84,82,85,78,67,0,84,77,95,67,67,79,69,70,70,0,84,77,95,67,67,79,69,70,70,95,78,79,82,77,69,68,0,84,77,95,67,67,79,82,82,0,84,77,95,67,67,79,82,82,95,78,79,82,77,69,68,0,84,77,95,83,81,68,73,70,70,0,84,77,95,83,81,68,73,70,70,95,78,79,82,77,69,68,0,84,101,114,109,67,114,105,116,101,114,105,97,95,67,79,85,78,84,0,84,101,114,109,67,114,105,116,101,114,105,97,95,69,80,83,0,84,101,114,109,67,114,105,116,101,114,105,97,95,77,65,88,95,73,84,69,82,0,85,77,97,116,68,97,116,97,95,65,83,89,78,67,95,67,76,69,65,78,85,80,0,85,77,97,116,68,97,116,97,95,67,79,80,89,95,79,78,95,77,65,80,0,85,77,97,116,68,97,116,97,95,68,69,86,73,67,69,95,67,79,80,89,95,79,66,83,79,76,69,84,69,0,85,77,97,116,68,97,116,97,95,68,69,86,73,67,69,95,77,69,77,95,77,65,80,80,69,68,0,85,77,97,116,68,97,116,97,95,72,79,83,84,95,67,79,80,89,95,79,66,83,79,76,69,84,69,0,85,77,97,116,68,97,116,97,95,84,69,77,80,95,67,79,80,73,69,68,95,85,77,65,84,0,85,77,97,116,68,97,116,97,95,84,69,77,80,95,85,77,65,84,0,85,77,97,116,68,97,116,97,95,85,83,69,82,95,65,76,76,79,67,65,84,69,68,0,85,77,97,116,95,65,85,84,79,95,83,84,69,80,0,85,77,97,116,95,67,79,78,84,73,78,85,79,85,83,95,70,76,65,71,0,85,77,97,116,95,68,69,80,84,72,95,77,65,83,75,0,85,77,97,116,95,77,65,71,73,67,95,77,65,83,75,0,85,77,97,116,95,77,65,71,73,67,95,86,65,76,0,85,77,97,116,95,83,85,66,77,65,84,82,73,88,95,70,76,65,71,0,85,77,97,116,95,84,89,80,69,95,77,65,83,75,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,68,69,86,73,67,69,95,77,69,77,79,82,89,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,72,79,83,84,95,77,69,77,79,82,89,0,85,83,65,71,69,95,65,76,76,79,67,65,84,69,95,83,72,65,82,69,68,95,77,69,77,79,82,89,0,85,83,65,71,69,95,68,69,70,65,85,76,84,0,87,65,82,80,95,70,73,76,76,95,79,85,84,76,73,69,82,83,0,87,65,82,80,95,73,78,86,69,82,83,69,95,77,65,80,0,95,73,110,112,117,116,65,114,114,97,121,95,67,85,68,65,95,71,80,85,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,67,85,68,65,95,72,79,83,84,95,77,69,77,0,95,73,110,112,117,116,65,114,114,97,121,95,69,88,80,82,0,95,73,110,112,117,116,65,114,114,97,121,95,70,73,88,69,68,95,83,73,90,69,0,95,73,110,112,117,116,65,114,114,97,121,95,70,73,88,69,68,95,84,89,80,69,0,95,73,110,112,117,116,65,114,114,97,121,95,75,73,78,68,95,77,65,83,75,0,95,73,110,112,117,116,65,114,114,97,121,95,75,73,78,68,95,83,72,73,70,84,0,95,73,110,112,117,116,65,114,114,97,121,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,77,65,84,88,0,95,73,110,112,117,116,65,114,114,97,121,95,78,79,78,69,0,95,73,110,112,117,116,65,114,114,97,121,95,79,80,69,78,71,76,95,66,85,70,70,69,82,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,65,82,82,65,89,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,65,82,82,65,89,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,66,79,79,76,95,86,69,67,84,79,82,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,67,85,68,65,95,71,80,85,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,85,77,65,84,0,95,73,110,112,117,116,65,114,114,97,121,95,83,84,68,95,86,69,67,84,79,82,95,86,69,67,84,79,82,0,95,73,110,112,117,116,65,114,114,97,121,95,85,77,65,84,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,49,54,83,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,49,54,85,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,51,50,70,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,51,50,83,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,54,52,70,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,56,83,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,56,85,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,65,76,76,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,65,76,76,95,66,85,84,95,56,83,0,95,79,117,116,112,117,116,65,114,114,97,121,95,68,69,80,84,72,95,77,65,83,75,95,70,76,84,0,95,95,85,77,65,84,95,85,83,65,71,69,95,70,76,65,71,83,95,51,50,66,73,84,0,66,97,100,65,108,105,103,110,0,66,97,100,65,108,112,104,97,67,104,97,110,110,101,108,0,66,97,100,67,79,73,0,66,97,100,67,97,108,108,66,97,99,107,0,66,97,100,68,97,116,97,80,116,114,0,66,97,100,68,101,112,116,104,0,66,97,100,73,109,97,103,101,83,105,122,101,0,66,97,100,77,111,100,101,108,79,114,67,104,83,101,113,0,66,97,100,78,117,109,67,104,97,110,110,101,108,49,85,0,66,97,100,78,117,109,67,104,97,110,110,101,108,115,0,66,97,100,79,102,102,115,101,116,0,66,97,100,79,114,100,101,114,0,66,97,100,79,114,105,103,105,110,0,66,97,100,82,79,73,83,105,122,101,0,66,97,100,83,116,101,112,0,66,97,100,84,105,108,101,83,105,122,101,0,71,112,117,65,112,105,67,97,108,108,69,114,114,111,114,0,71,112,117,78,111,116,83,117,112,112,111,114,116,101,100,0,72,101,97,100,101,114,73,115,78,117,108,108,0,77,97,115,107,73,115,84,105,108,101,100,0,79,112,101,110,67,76,65,112,105,67,97,108,108,69,114,114,111,114,0,79,112,101,110,67,76,68,111,117,98,108,101,78,111,116,83,117,112,112,111,114,116,101,100,0,79,112,101,110,67,76,73,110,105,116,69,114,114,111,114,0,79,112,101,110,67,76,78,111,65,77,68,66,108,97,115,70,102,116,0,79,112,101,110,71,108,65,112,105,67,97,108,108,69,114,114,111,114,0,79,112,101,110,71,108,78,111,116,83,117,112,112,111,114,116,101,100,0,83,116,115,65,115,115,101,114,116,0,83,116,115,65,117,116,111,84,114,97,99,101,0,83,116,115,66,97,99,107,84,114,97,99,101,0,83,116,115,66,97,100,65,114,103,0,83,116,115,66,97,100,70,108,97,103,0,83,116,115,66,97,100,70,117,110,99,0,83,116,115,66,97,100,77,97,115,107,0,83,116,115,66,97,100,77,101,109,66,108,111,99,107,0,83,116,115,66,97,100,80,111,105,110,116,0,83,116,115,66,97,100,83,105,122,101,0,83,116,115,68,105,118,66,121,90,101,114,111,0,83,116,115,69,114,114,111,114,0,83,116,115,70,105,108,116,101,114,79,102,102,115,101,116,69,114,114,0,83,116,115,70,105,108,116,101,114,83,116,114,117,99,116,67,111,110,116,101,110,116,69,114,114,0,83,116,115,73,110,112,108,97,99,101,78,111,116,83,117,112,112,111,114,116,101,100,0,83,116,115,73,110,116,101,114,110,97,108,0,83,116,115,75,101,114,110,101,108,83,116,114,117,99,116,67,111,110,116,101,110,116,69,114,114,0,83,116,115,78,111,67,111,110,118,0,83,116,115,78,111,77,101,109,0,83,116,115,78,111,116,73,109,112,108,101,109,101,110,116,101,100,0,83,116,115,78,117,108,108,80,116,114,0,83,116,115,79,98,106,101,99,116,78,111,116,70,111,117,110,100,0,83,116,115,79,107,0,83,116,115,79,117,116,79,102,82,97,110,103,101,0,83,116,115,80,97,114,115,101,69,114,114,111,114,0,83,116,115,85,110,109,97,116,99,104,101,100,70,111,114,109,97,116,115,0,83,116,115,85,110,109,97,116,99,104,101,100,83,105,122,101,115,0,83,116,115,85,110,115,117,112,112,111,114,116,101,100,70,111,114,109,97,116,0,83,116,115,86,101,99,76,101,110,103,116,104,69,114,114,0,68,78,78,95,66,65,67,75,69,78,68,95,68,69,70,65,85,76,84,0,68,78,78,95,66,65,67,75,69,78,68,95,72,65,76,73,68,69,0,68,78,78,95,84,65,82,71,69,84,95,67,80,85,0,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,0,70,76,65,71,83,95,69,88,80,65,78,68,95,83,65,77,69,95,78,65,77,69,83,0,70,76,65,71,83,95,77,65,80,80,73,78,71,0,70,76,65,71,83,95,78,79,78,69,0,73,77,80,76,95,73,80,80,0,73,77,80,76,95,79,80,69,78,67,76,0,73,77,80,76,95,80,76,65,73,78,0,84,89,80,69,95,70,85,78,0,84,89,80,69,95,71,69,78,69,82,65,76,0,84,89,80,69,95,77,65,82,75,69,82,0,84,89,80,69,95,87,82,65,80,80,69,82,0,78,50,99,118,54,80,111,105,110,116,95,73,102,69,69,0,78,50,99,118,49,49,82,111,116,97,116,101,100,82,101,99,116,69,0,78,50,99,118,53,82,101,99,116,95,73,105,69,69,0,112,117,115,104,95,98,97,99,107,0,115,101,116,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,118,101,99,116,111,114,95,98,97,115,101,95,99,111,109,109,111,110,73,76,98,49,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,105,78,83,95,57,97,108,108,111,99,97,116,111,114,73,105,69,69,69,69,0,105,105,0,118,0,118,105,0,118,105,105,105,0,118,105,105,105,105,0,105,105,105,0,78,49,48,101,109,115,99,114,105,112,116,101,110,51,118,97,108,69,0,105,105,105,105,0,105,105,105,105,105,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,102,78,83,95,57,97,108,108,111,99,97,116,111,114,73,102,69,69,69,69,0,118,105,105,102,0,118,105,105,105,102,0,105,105,105,105,102,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,100,78,83,95,57,97,108,108,111,99,97,116,111,114,73,100,69,69,69,69,0,118,105,105,100,0,118,105,105,105,100,0,105,105,105,105,100,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,80,111,105,110,116,95,73,105,69,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,51,77,97,116,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,50,95,69,69,69,69,0,78,50,99,118,51,77,97,116,69,0,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,78,83,116,51,95,95,50,49,51,95,95,118,101,99,116,111,114,95,98,97,115,101,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,75,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,50,99,118,53,82,101,99,116,95,73,105,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,83,51,95,69,69,69,69,0,80,78,50,99,118,51,77,97,116,69,0,80,75,78,50,99,118,51,77,97,116,69,0,78,50,99,118,53,83,105,122,101,95,73,105,69,69,0,78,50,99,118,55,83,99,97,108,97,114,95,73,100,69,69,0,78,50,99,118,51,86,101,99,73,100,76,105,52,69,69,69,0,78,50,99,118,52,77,97,116,120,73,100,76,105,52,69,76,105,49,69,69,69,0,105,105,105,105,105,105,0,105,105,105,105,105,105,105,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,104,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,99,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,116,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,115,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,105,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,102,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,100,69,69,0,118,105,105,105,105,100,100,0,118,105,105,105,105,100,0,118,105,105,105,105,105,0,78,50,99,118,53,82,97,110,103,101,69,0,100,105,105,105,0,102,105,105,105,0,102,105,105,105,105,0,102,105,105,105,105,105,0,100,105,105,105,105,105,0,100,105,105,105,105,0,78,50,99,118,49,50,84,101,114,109,67,114,105,116,101,114,105,97,69,0,100,105,105,0,78,50,99,118,53,83,105,122,101,95,73,102,69,69,0,102,105,105,0,78,50,99,118,53,82,101,99,116,95,73,102,69,69,0,78,49,51,98,105,110,100,105,110,103,95,117,116,105,108,115,57,77,105,110,77,97,120,76,111,99,69,0,78,49,51,98,105,110,100,105,110,103,95,117,116,105,108,115,54,67,105,114,99,108,101,69,0,78,50,99,118,55,77,111,109,101,110,116,115,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,83,116,51,95,95,50,50,49,95,95,98,97,115,105,99,95,115,116,114,105,110,103,95,99,111,109,109,111,110,73,76,98,49,69,69,69,0,108,101,110,103,116,104,0,78,50,99,118,54,83,116,114,105,110,103,69,0,118,105,105,105,100,100,105,105,0,118,105,105,105,100,100,105,0,118,105,105,105,100,100,0,118,105,105,105,105,100,100,105,0,118,105,105,105,105,100,100,100,100,105,105,0,118,105,105,105,105,100,100,100,100,105,0,118,105,105,105,105,100,100,100,100,0,118,105,105,105,105,100,100,100,0,118,105,105,105,100,100,105,100,100,100,100,0,118,105,105,105,100,100,105,100,100,100,0,118,105,105,105,100,100,105,100,100,0,118,105,105,105,100,100,105,100,0,118,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,100,100,0,118,105,105,105,105,105,100,0,118,105,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,105,100,100,0,118,105,105,105,105,105,105,100,0,118,105,105,105,105,105,105,0,118,105,105,105,105,105,105,105,100,100,105,0,118,105,105,105,105,105,105,105,100,100,0,118,105,105,105,105,105,105,105,100,0,118,105,105,105,105,105,105,105,0,118,105,105,105,100,105,105,105,100,0,118,105,105,100,105,100,100,105,105,0,118,105,105,100,105,100,100,105,0,118,105,105,105,100,105,0,118,105,105,105,105,105,105,105,105,0,118,105,105,105,105,100,105,105,105,105,100,105,0,118,105,105,105,105,105,105,105,105,105,105,105,100,0,118,105,105,105,105,105,105,105,105,105,105,105,0,118,105,105,105,105,105,105,105,105,105,105,0,118,105,105,105,105,105,105,105,105,105,0,105,105,105,105,105,105,105,105,0,118,105,105,105,105,105,100,105,0,118,105,105,105,105,100,105,0,118,105,100,105,105,105,0,118,105,100,105,105,0,118,105,105,105,105,100,100,100,105,105,105,105,0,118,105,105,105,105,100,100,100,105,105,105,0,118,105,105,105,105,100,100,100,105,105,0,118,105,105,105,105,100,100,100,105,0,118,105,105,105,105,105,105,100,105,0,100,105,105,105,105,105,105,105,0,100,105,105,105,105,105,105,0,118,105,105,105,100,105,100,105,105,0,118,105,105,105,100,105,100,105,0,105,105,105,100,100,0,118,105,105,105,105,100,100,105,105,105,100,0,118,105,105,105,105,100,100,105,105,105,0,118,105,105,105,105,100,100,105,105,0,118,105,105,105,105,100,100,105,105,105,105,100,0,118,105,105,105,105,100,100,105,105,105,105,0,100,105,105,105,105,105,105,105,105,0,100,105,105,105,105,100,0,118,105,105,105,100,100,105,105,105,0,118,105,105,100,105,0,118,105,105,105,105,105,100,105,105,105,105,0,118,105,105,105,105,105,100,105,105,105,0,118,105,105,105,105,105,100,105,105,0,118,105,105,105,105,105,105,105,100,105,0,118,105,105,0,100,105,105,105,100,100,105,0,105,105,105,100,105,105,105,105,0,105,105,105,100,105,105,105,0,105,105,105,100,105,105,0,105,105,105,100,105,0,105,105,105,100,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,51,78,101,116,69,0,80,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,80,75,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,105,105,105,105,105,105,105,105,100,105,100,105,105,105,0,118,105,105,105,105,105,100,105,105,100,100,105,0,118,105,105,105,105,105,100,105,105,100,100,0,118,105,105,105,105,105,100,105,105,100,0,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,80,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,80,75,78,50,99,118,50,48,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,69,0,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,80,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,80,75,78,50,99,118,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,0,78,50,99,118,51,80,116,114,73,78,83,95,50,52,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,69,69,69,0,78,50,99,118,53,67,76,65,72,69,69,0,80,78,50,99,118,53,67,76,65,72,69,69,0,80,75,78,50,99,118,53,67,76,65,72,69,69,0,78,50,99,118,51,80,116,114,73,78,83,95,53,67,76,65,72,69,69,69,69,0,105,105,100,105,0,105,105,100,0,80,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,80,75,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,80,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,51,78,101,116,69,0,80,75,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,51,78,101,116,69,0,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,80,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,80,75,78,50,99,118,49,55,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,118,105,105,105,105,105,105,100,105,105,105,105,105,0,118,105,105,105,105,105,105,100,105,105,105,105,0,118,105,105,105,105,105,105,100,105,105,105,0,118,105,105,105,105,105,105,100,105,105,0,118,105,105,105,105,100,105,105,105,105,0,118,105,105,105,105,100,105,105,105,0,118,105,105,105,105,100,105,105,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,53,79,99,118,68,102,116,66,97,115,105,99,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,56,80,116,114,79,119,110,101,114,69,0,99,46,102,97,99,116,111,114,115,91,48,93,32,61,61,32,99,46,102,97,99,116,111,114,115,91,99,46,110,102,45,49,93,0,68,70,84,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,100,120,116,46,99,112,112,0,0,128,64,192,32,160,96,224,16,144,80,208,48,176,112,240,8,136,72,200,40,168,104,232,24,152,88,216,56,184,120,248,4,132,68,196,36,164,100,228,20,148,84,212,52,180,116,244,12,140,76,204,44,172,108,236,28,156,92,220,60,188,124,252,2,130,66,194,34,162,98,226,18,146,82,210,50,178,114,242,10,138,74,202,42,170,106,234,26,154,90,218,58,186,122,250,6,134,70,198,38,166,102,230,22,150,86,214,54,182,118,246,14,142,78,206,46,174,110,238,30,158,94,222,62,190,126,254,1,129,65,193,33,161,97,225,17,145,81,209,49,177,113,241,9,137,73,201,41,169,105,233,25,153,89,217,57,185,121,249,5,133,69,197,37,165,101,229,21,149,85,213,53,181,117,245,13,141,77,205,45,173,109,237,29,157,93,221,61,189,125,253,3,131,67,195,35,163,99,227,19,147,83,211,51,179,115,243,11,139,75,203,43,171,107,235,27,155,91,219,59,187,123,251,7,135,71,199,39,167,103,231,23,151,87,215,55,183,119,247,15,143,79,207,47,175,111,239,31,159,95,223,63,191,127,255,78,50,99,118,49,53,79,99,118,68,102,116,66,97,115,105,99,73,109,112,108,69,0,78,50,99,118,51,104,97,108,53,68,70,84,49,68,69,0,78,50,99,118,49,54,82,101,112,108,97,99,101,109,101,110,116,68,70,84,49,68,69,0,84,104,105,115,32,109,111,100,101,32,40,117,115,105,110,103,32,110,111,110,122,101,114,111,95,114,111,119,115,32,119,105,116,104,32,97,32,115,105,110,103,108,101,45,99,111,108,117,109,110,32,109,97,116,114,105,120,41,32,98,114,101,97,107,115,32,116,104,101,32,102,117,110,99,116,105,111,110,39,115,32,108,111,103,105,99,44,32,115,111,32,105,116,32,105,115,32,112,114,111,104,105,98,105,116,101,100,46,10,70,111,114,32,102,97,115,116,32,99,111,110,118,111,108,117,116,105,111,110,47,99,111,114,114,101,108,97,116,105,111,110,32,117,115,101,32,50,45,99,111,108,117,109,110,32,109,97,116,114,105,120,32,111,114,32,115,105,110,103,108,101,45,114,111,119,32,109,97,116,114,105,120,32,105,110,115,116,101,97,100,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,48,79,99,118,68,102,116,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,49,48,79,99,118,68,102,116,73,109,112,108,69,0,78,50,99,118,51,104,97,108,53,68,70,84,50,68,69,0,78,50,99,118,49,54,82,101,112,108,97,99,101,109,101,110,116,68,70,84,50,68,69,0,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,0,100,102,116,0,33,40,40,102,108,97,103,115,32,38,32,68,70,84,95,67,79,77,80,76,69,88,95,73,78,80,85,84,41,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,33,61,32,50,41,0,118,111,105,100,32,99,118,58,58,100,102,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,41,0,116,121,112,101,32,61,61,32,115,114,99,66,46,116,121,112,101,40,41,32,38,38,32,115,114,99,65,46,115,105,122,101,40,41,32,61,61,32,115,114,99,66,46,115,105,122,101,40,41,0,109,117,108,83,112,101,99,116,114,117,109,115,0,118,111,105,100,32,99,118,58,58,109,117,108,83,112,101,99,116,114,117,109,115,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,98,111,111,108,41,0,70,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,37,108,108,117,32,98,121,116,101,115,0,79,117,116,79,102,77,101,109,111,114,121,69,114,114,111,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,108,108,111,99,46,99,112,112,0,100,97,116,97,48,46,100,105,109,115,32,60,61,32,50,32,38,38,32,116,121,112,101,32,61,61,32,53,32,38,38,32,75,32,62,32,48,0,107,109,101,97,110,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,107,109,101,97,110,115,46,99,112,112,0,78,32,62,61,32,75,0,40,98,101,115,116,95,108,97,98,101,108,115,46,99,111,108,115,32,61,61,32,49,32,124,124,32,98,101,115,116,95,108,97,98,101,108,115,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,99,111,108,115,42,98,101,115,116,95,108,97,98,101,108,115,46,114,111,119,115,32,61,61,32,78,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,116,121,112,101,40,41,32,61,61,32,52,32,38,38,32,98,101,115,116,95,108,97,98,101,108,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,40,117,110,115,105,103,110,101,100,41,108,97,98,101,108,115,91,105,93,32,60,32,40,117,110,115,105,103,110,101,100,41,75,0,99,111,117,110,116,101,114,115,91,107,93,32,33,61,32,48,0,78,50,99,118,50,50,75,77,101,97,110,115,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,75,77,101,97,110,115,80,80,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,0,78,50,99,118,50,52,75,77,101,97,110,115,80,80,68,105,115,116,97,110,99,101,67,111,109,112,117,116,101,114,69,0,118,111,105,100,32,99,118,58,58,103,101,110,101,114,97,116,101,67,101,110,116,101,114,115,80,80,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,105,110,116,44,32,99,118,58,58,82,78,71,32,38,44,32,105,110,116,41,0,100,111,117,98,108,101,32,99,118,58,58,107,109,101,97,110,115,40,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,99,118,58,58,84,101,114,109,67,114,105,116,101,114,105,97,44,32,105,110,116,44,32,105,110,116,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,99,111,110,118,101,114,116,65,110,100,85,110,114,111,108,108,83,99,97,108,97,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,114,105,116,104,109,46,99,112,112,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,121,112,101,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,98,105,110,97,114,121,95,111,112,0,112,115,114,99,49,45,62,115,97,109,101,83,105,122,101,40,42,112,115,114,99,50,41,32,38,38,32,116,121,112,101,49,32,61,61,32,116,121,112,101,50,0,40,109,116,121,112,101,32,61,61,32,48,32,124,124,32,109,116,121,112,101,32,61,61,32,49,41,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,42,112,115,114,99,49,41,0,118,111,105,100,32,99,118,58,58,98,105,116,119,105,115,101,95,97,110,100,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,98,105,116,119,105,115,101,95,111,114,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,98,105,116,119,105,115,101,95,120,111,114,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,98,105,116,119,105,115,101,95,110,111,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,109,97,120,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,109,105,110,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,109,97,120,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,41,0,118,111,105,100,32,99,118,58,58,109,105,110,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,41,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,104,101,32,115,97,109,101,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,97,114,105,116,104,109,95,111,112,0,116,121,112,101,50,32,61,61,32,54,32,38,38,32,40,115,122,50,46,104,101,105,103,104,116,32,61,61,32,49,32,124,124,32,115,122,50,46,104,101,105,103,104,116,32,61,61,32,52,41,0,87,104,101,110,32,116,104,101,32,105,110,112,117,116,32,97,114,114,97,121,115,32,105,110,32,97,100,100,47,115,117,98,116,114,97,99,116,47,109,117,108,116,105,112,108,121,47,100,105,118,105,100,101,32,102,117,110,99,116,105,111,110,115,32,104,97,118,101,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,115,44,32,116,104,101,32,111,117,116,112,117,116,32,97,114,114,97,121,32,116,121,112,101,32,109,117,115,116,32,98,101,32,101,120,112,108,105,99,105,116,108,121,32,115,112,101,99,105,102,105,101,100,0,40,109,116,121,112,101,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,109,116,121,112,101,32,61,61,32,40,40,40,49,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,41,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,42,112,115,114,99,49,41,0,118,111,105,100,32,99,118,58,58,97,100,100,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,115,117,98,116,114,97,99,116,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,97,98,115,100,105,102,102,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,109,117,108,116,105,112,108,121,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,100,105,118,105,100,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,100,105,118,105,100,101,40,100,111,117,98,108,101,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,97,100,100,87,101,105,103,104,116,101,100,40,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,111,112,32,61,61,32,67,77,80,95,76,84,32,124,124,32,111,112,32,61,61,32,67,77,80,95,76,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,69,81,32,124,124,32,111,112,32,61,61,32,67,77,80,95,78,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,71,69,32,124,124,32,111,112,32,61,61,32,67,77,80,95,71,84,0,99,111,109,112,97,114,101,0,84,104,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,101,105,116,104,101,114,32,39,97,114,114,97,121,32,111,112,32,97,114,114,97,121,39,32,40,119,104,101,114,101,32,97,114,114,97,121,115,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,116,104,101,32,115,97,109,101,32,116,121,112,101,41,44,32,110,111,114,32,39,97,114,114,97,121,32,111,112,32,115,99,97,108,97,114,39,44,32,110,111,114,32,39,115,99,97,108,97,114,32,111,112,32,97,114,114,97,121,39,0,118,111,105,100,32,99,118,58,58,99,111,109,112,97,114,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+163902);allocate([117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,84,104,101,32,108,111,119,101,114,32,98,111,117,110,100,97,114,121,32,105,115,32,110,101,105,116,104,101,114,32,97,110,32,97,114,114,97,121,32,111,102,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,115,97,109,101,32,116,121,112,101,32,97,115,32,115,114,99,44,32,110,111,114,32,97,32,115,99,97,108,97,114,0,105,110,82,97,110,103,101,0,84,104,101,32,117,112,112,101,114,32,98,111,117,110,100,97,114,121,32,105,115,32,110,101,105,116,104,101,114,32,97,110,32,97,114,114,97,121,32,111,102,32,116,104,101,32,115,97,109,101,32,115,105,122,101,32,97,110,100,32,115,97,109,101,32,116,121,112,101,32,97,115,32,115,114,99,44,32,110,111,114,32,97,32,115,99,97,108,97,114,0,108,98,83,99,97,108,97,114,32,61,61,32,117,98,83,99,97,108,97,114,0,108,98,46,116,121,112,101,40,41,32,61,61,32,117,98,46,116,121,112,101,40,41,0,118,111,105,100,32,99,118,58,58,105,110,82,97,110,103,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,95,112,97,114,97,109,49,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,40,95,112,97,114,97,109,49,46,114,111,119,115,32,61,61,32,49,32,124,124,32,95,112,97,114,97,109,49,46,99,111,108,115,32,61,61,32,49,41,32,38,38,32,40,95,112,97,114,97,109,49,46,114,111,119,115,32,43,32,95,112,97,114,97,109,49,46,99,111,108,115,32,45,32,49,32,61,61,32,99,110,32,124,124,32,95,112,97,114,97,109,49,46,114,111,119,115,32,43,32,95,112,97,114,97,109,49,46,99,111,108,115,32,45,32,49,32,61,61,32,49,32,124,124,32,40,95,112,97,114,97,109,49,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,38,38,32,95,112,97,114,97,109,49,46,116,121,112,101,40,41,32,61,61,32,54,32,38,38,32,99,110,32,60,61,32,52,41,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,114,97,110,100,46,99,112,112,0,95,112,97,114,97,109,50,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,40,40,40,95,112,97,114,97,109,50,46,114,111,119,115,32,61,61,32,49,32,124,124,32,95,112,97,114,97,109,50,46,99,111,108,115,32,61,61,32,49,41,32,38,38,32,40,95,112,97,114,97,109,50,46,114,111,119,115,32,43,32,95,112,97,114,97,109,50,46,99,111,108,115,32,45,32,49,32,61,61,32,99,110,32,124,124,32,95,112,97,114,97,109,50,46,114,111,119,115,32,43,32,95,112,97,114,97,109,50,46,99,111,108,115,32,45,32,49,32,61,61,32,49,32,124,124,32,40,95,112,97,114,97,109,49,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,38,38,32,95,112,97,114,97,109,49,46,116,121,112,101,40,41,32,61,61,32,54,32,38,38,32,99,110,32,60,61,32,52,41,41,41,32,124,124,32,40,95,112,97,114,97,109,50,46,114,111,119,115,32,61,61,32,99,110,32,38,38,32,95,112,97,114,97,109,50,46,99,111,108,115,32,61,61,32,99,110,32,38,38,32,100,105,115,116,116,121,112,101,32,61,61,32,78,79,82,77,65,76,41,41,0,115,99,97,108,101,70,117,110,99,32,33,61,32,48,0,85,110,107,110,111,119,110,32,100,105,115,116,114,105,98,117,116,105,111,110,32,116,121,112,101,0,118,111,105,100,32,99,118,58,58,114,97,110,100,117,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,114,97,110,100,110,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,4,5,5,6,5,6,6,7,5,6,6,7,6,7,7,8,99,110,32,60,61,32,52,32,38,38,32,102,117,110,99,32,33,61,32,48,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,116,97,116,46,99,112,112,0,99,118,58,58,83,99,97,108,97,114,32,99,118,58,58,115,117,109,40,73,110,112,117,116,65,114,114,97,121,41,0,99,111,117,110,116,78,111,110,90,101,114,111,0,105,110,116,32,99,118,58,58,99,111,117,110,116,78,111,110,90,101,114,111,40,73,110,112,117,116,65,114,114,97,121,41,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,48,0,109,101,97,110,0,99,118,58,58,83,99,97,108,97,114,32,99,118,58,58,109,101,97,110,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,109,101,97,110,83,116,100,68,101,118,0,100,115,116,46,116,121,112,101,40,41,32,61,61,32,54,32,38,38,32,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,100,115,116,46,99,111,108,115,32,61,61,32,49,32,124,124,32,100,115,116,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,100,99,110,32,62,61,32,99,110,0,118,111,105,100,32,99,118,58,58,109,101,97,110,83,116,100,68,101,118,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,40,99,110,32,61,61,32,49,32,38,38,32,40,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,48,41,41,32,124,124,32,40,99,110,32,62,32,49,32,38,38,32,95,109,97,115,107,46,101,109,112,116,121,40,41,32,38,38,32,33,109,105,110,73,100,120,32,38,38,32,33,109,97,120,73,100,120,41,0,109,105,110,77,97,120,73,100,120,0,118,111,105,100,32,99,118,58,58,109,105,110,77,97,120,73,100,120,40,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,32,42,44,32,105,110,116,32,42,44,32,73,110,112,117,116,65,114,114,97,121,41,0,95,105,109,103,46,100,105,109,115,40,41,32,60,61,32,50,0,109,105,110,77,97,120,76,111,99,0,118,111,105,100,32,99,118,58,58,109,105,110,77,97,120,76,111,99,40,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,80,111,105,110,116,32,42,44,32,80,111,105,110,116,32,42,44,32,73,110,112,117,116,65,114,114,97,121,41,0,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,73,78,70,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,49,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,83,81,82,32,124,124,32,40,40,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,50,41,32,38,38,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,48,41,0,110,111,114,109,0,0,1,1,1,1,2,2,2,1,2,2,2,1,2,2,2,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,1,2,2,2,2,3,3,3,2,3,3,3,2,3,3,3,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,2,3,3,3,3,4,4,4,3,4,4,4,3,4,4,4,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,100,111,117,98,108,101,32,99,118,58,58,110,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,41,0,95,115,114,99,49,46,115,97,109,101,83,105,122,101,40,95,115,114,99,50,41,32,38,38,32,95,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,0,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,73,78,70,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,49,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,76,50,83,81,82,32,124,124,32,40,40,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,32,124,124,32,110,111,114,109,84,121,112,101,32,61,61,32,78,79,82,77,95,72,65,77,77,73,78,71,50,41,32,38,38,32,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,48,41,0,100,111,117,98,108,101,32,99,118,58,58,110,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,41,0,109,97,112,99,111,117,110,116,32,61,61,32,48,0,126,85,77,97,116,68,97,116,97,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,117,109,97,116,114,105,120,46,99,112,112,0,100,97,116,97,32,61,61,32,100,97,116,97,115,116,97,114,116,0,97,108,108,111,99,97,116,101,100,0,85,77,97,116,0,100,115,116,46,117,0,117,45,62,100,97,116,97,32,33,61,32,48,32,38,38,32,34,69,114,114,111,114,32,109,97,112,112,105,110,103,32,111,102,32,85,77,97,116,32,116,111,32,104,111,115,116,32,109,101,109,111,114,121,46,34,0,103,101,116,77,97,116,0,118,111,105,100,32,99,118,58,58,85,77,97,116,58,58,99,111,110,118,101,114,116,84,111,40,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,32,99,111,110,115,116,0,118,111,105,100,32,99,118,58,58,85,77,97,116,58,58,99,111,112,121,84,111,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,0,99,118,58,58,85,77,97,116,32,38,99,118,58,58,85,77,97,116,58,58,115,101,116,84,111,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,105,110,116,32,99,118,58,58,104,97,108,58,58,110,111,114,109,72,97,109,109,105,110,103,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,105,110,116,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,116,97,116,46,100,105,115,112,97,116,99,104,46,99,112,112,0,105,110,116,32,99,118,58,58,104,97,108,58,58,110,111,114,109,72,97,109,109,105,110,103,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,105,110,116,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,110,118,101,114,116,46,99,112,112,0,118,111,105,100,32,99,118,58,58,115,112,108,105,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,42,41,0,33,95,109,118,46,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,95,109,118,46,101,109,112,116,121,40,41,32,124,124,32,95,109,118,46,116,121,112,101,40,41,32,61,61,32,109,46,100,101,112,116,104,40,41,0,118,111,105,100,32,99,118,58,58,115,112,108,105,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,109,118,32,38,38,32,110,32,62,32,48,0,109,101,114,103,101,0,109,118,91,105,93,46,115,105,122,101,32,61,61,32,109,118,91,48,93,46,115,105,122,101,32,38,38,32,109,118,91,105,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,48,32,60,32,99,110,32,38,38,32,99,110,32,60,61,32,53,49,50,0,115,114,99,32,38,38,32,110,115,114,99,115,32,62,32,48,32,38,38,32,100,115,116,32,38,38,32,110,100,115,116,115,32,62,32,48,32,38,38,32,102,114,111,109,84,111,32,38,38,32,110,112,97,105,114,115,32,62,32,48,0,109,105,120,67,104,97,110,110,101,108,115,0,106,32,60,32,110,115,114,99,115,32,38,38,32,115,114,99,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,105,49,32,62,61,32,48,32,38,38,32,106,32,60,32,110,100,115,116,115,32,38,38,32,100,115,116,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,118,111,105,100,32,99,118,58,58,109,105,120,67,104,97,110,110,101,108,115,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,115,105,122,101,95,116,44,32,99,118,58,58,77,97,116,32,42,44,32,115,105,122,101,95,116,44,32,99,111,110,115,116,32,105,110,116,32,42,44,32,115,105,122,101,95,116,41,0,118,111,105,100,32,99,118,58,58,109,101,114,103,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,115,105,122,101,95,116,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,109,101,114,103,101,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,102,114,111,109,84,111,46,115,105,122,101,40,41,37,50,32,61,61,32,48,32,38,38,32,110,115,114,99,32,62,32,48,32,38,38,32,110,100,115,116,32,62,32,48,0,118,111,105,100,32,99,118,58,58,109,105,120,67,104,97,110,110,101,108,115,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,41,0,48,32,60,61,32,99,111,105,32,38,38,32,99,111,105,32,60,32,99,110,0,101,120,116,114,97,99,116,67,104,97,110,110,101,108,0,118,111,105,100,32,99,118,58,58,101,120,116,114,97,99,116,67,104,97,110,110,101,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,99,111,110,118,101,114,116,83,99,97,108,101,65,98,115,0,118,111,105,100,32,99,118,58,58,99,111,110,118,101,114,116,83,99,97,108,101,65,98,115,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,85,110,115,117,112,112,111,114,116,101,100,32,105,110,112,117,116,32,100,101,112,116,104,0,99,111,110,118,101,114,116,70,112,49,54,0,118,111,105,100,32,99,118,58,58,99,111,110,118,101,114,116,70,112,49,54,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,99,111,110,118,101,114,116,84,111,0,118,111,105,100,32,99,118,58,58,77,97,116,58,58,99,111,110,118,101,114,116,84,111,40,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,32,99,111,110,115,116,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,110,111,114,109,32,116,121,112,101,0,110,111,114,109,97,108,105,122,101,0,118,111,105,100,32,99,118,58,58,110,111,114,109,97,108,105,122,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,41,0,78,50,99,118,50,53,68,117,109,109,121,66,117,102,102,101,114,80,111,111,108,67,111,110,116,114,111,108,108,101,114,69,0,78,50,99,118,50,48,66,117,102,102,101,114,80,111,111,108,67,111,110,116,114,111,108,108,101,114,69,0,115,122,91,105,93,32,60,61,32,40,115,105,122,101,95,116,41,48,120,55,102,102,102,102,102,102,102,0,99,111,112,121,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,46,99,112,112,0,117,45,62,117,114,101,102,99,111,117,110,116,32,61,61,32,48,0,100,101,97,108,108,111,99,97,116,101,0,117,45,62,114,101,102,99,111,117,110,116,32,61,61,32,48,0,116,111,116,97,108,32,60,61,32,115,116,101,112,91,105,93,0,97,108,108,111,99,97,116,101,0,78,50,99,118,49,53,83,116,100,77,97,116,65,108,108,111,99,97,116,111,114,69,0,95,97,114,114,97,121,115,32,38,38,32,40,95,112,116,114,115,32,124,124,32,95,112,108,97,110,101,115,41,0,110,97,114,114,97,121,115,32,60,61,32,49,48,48,48,0,97,114,114,97,121,115,91,105,93,32,33,61,32,48,0,65,46,115,105,122,101,32,61,61,32,97,114,114,97,121,115,91,105,48,93,45,62,115,105,122,101,0,65,46,115,116,101,112,91,100,45,49,93,32,61,61,32,65,46,101,108,101,109,83,105,122,101,40,41,0,48,32,60,61,32,95,100,105,109,115,32,38,38,32,95,100,105,109,115,32,60,61,32,51,50,0,115,101,116,83,105,122,101,0,115,32,62,61,32,48,0,84,104,101,32,116,111,116,97,108,32,109,97,116,114,105,120,32,115,105,122,101,32,100,111,101,115,32,110,111,116,32,102,105,116,32,116,111,32,34,115,105,122,101,95,116,34,32,116,121,112,101,0,83,116,101,112,32,109,117,115,116,32,98,101,32,97,32,109,117,108,116,105,112,108,101,32,111,102,32,101,115,122,49,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,65,108,108,111,99,97,116,111,114,58,58,99,111,112,121,40,99,118,58,58,85,77,97,116,68,97,116,97,32,42,44,32,99,118,58,58,85,77,97,116,68,97,116,97,32,42,44,32,105,110,116,44,32,99,111,110,115,116,32,115,105,122,101,95,116,32,42,44,32,99,111,110,115,116,32,115,105,122,101,95,116,32,42,44,32,99,111,110,115,116,32,115,105,122,101,95,116,32,42,44,32,99,111,110,115,116,32,115,105,122,101,95,116,32,42,44,32,99,111,110,115,116,32,115,105,122,101,95,116,32,42,44,32,98,111,111,108,41,32,99,111,110,115,116,0,117,112,108,111,97,100,0,100,111,119,110,108,111,97,100,0,78,50,99,118,49,50,77,97,116,65,108,108,111,99,97,116,111,114,69,0,48,32,60,61,32,100,32,38,38,32,100,32,60,61,32,51,50,32,38,38,32,95,115,105,122,101,115,0,117,32,33,61,32,48,0,115,116,101,112,91,100,105,109,115,45,49,93,32,61,61,32,40,115,105,122,101,95,116,41,40,40,40,40,40,102,108,97,103,115,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,60,60,32,40,40,40,40,115,105,122,101,111,102,40,115,105,122,101,95,116,41,47,52,43,49,41,42,49,54,51,56,52,124,48,120,51,97,53,48,41,32,62,62,32,40,40,102,108,97,103,115,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,42,50,41,32,38,32,51,41,41,0,48,32,60,61,32,95,114,111,119,82,97,110,103,101,46,115,116,97,114,116,32,38,38,32,95,114,111,119,82,97,110,103,101,46,115,116,97,114,116,32,60,61,32,95,114,111,119,82,97,110,103,101,46,101,110,100,32,38,38,32,95,114,111,119,82,97,110,103,101,46,101,110,100,32,60,61,32,109,46,114,111,119,115,0,48,32,60,61,32,95,99,111,108,82,97,110,103,101,46,115,116,97,114,116,32,38,38,32,95,99,111,108,82,97,110,103,101,46,115,116,97,114,116,32,60,61,32,95,99,111,108,82,97,110,103,101,46,101,110,100,32,38,38,32,95,99,111,108,82,97,110,103,101,46,101,110,100,32,60,61,32,109,46,99,111,108,115,0,114,97,110,103,101,115,0,114,32,61,61,32,82,97,110,103,101,58,58,97,108,108,40,41,32,124,124,32,40,48,32,60,61,32,114,46,115,116,97,114,116,32,38,38,32,114,46,115,116,97,114,116,32,60,32,114,46,101,110,100,32,38,38,32,114,46,101,110,100,32,60,61,32,109,46,115,105,122,101,91,105,93,41,0,109,46,100,105,109,115,32,60,61,32,50,0,48,32,60,61,32,114,111,105,46,120,32,38,38,32,48,32,60,61,32,114,111,105,46,119,105,100,116,104,32,38,38,32,114,111,105,46,120,32,43,32,114,111,105,46,119,105,100,116,104,32,60,61,32,109,46,99,111,108,115,32,38,38,32,48,32,60,61,32,114,111,105,46,121,32,38,38,32,48,32,60,61,32,114,111,105,46,104,101,105,103,104,116,32,38,38,32,114,111,105,46,121,32,43,32,114,111,105,46,104,101,105,103,104,116,32,60,61,32,109,46,114,111,119,115,0,40,105,110,116,41,114,97,110,103,101,115,46,115,105,122,101,40,41,32,61,61,32,100,0,100,105,109,115,32,60,61,32,50,0,100,105,97,103,0,40,105,110,116,41,110,101,108,101,109,115,32,62,61,32,48,0,114,101,115,101,114,118,101,0,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,101,32,102,117,110,99,116,105,111,110,0,99,118,97,114,114,84,111,77,97,116,0,105,109,103,45,62,100,97,116,97,79,114,100,101,114,32,61,61,32,48,0,105,112,108,73,109,97,103,101,84,111,77,97,116,0,105,109,103,45,62,100,97,116,97,79,114,100,101,114,32,61,61,32,48,32,124,124,32,105,109,103,45,62,114,111,105,45,62,99,111,105,32,33,61,32,48,0,116,111,116,97,108,32,62,32,48,32,38,38,32,40,40,40,40,40,115,101,113,45,62,102,108,97,103,115,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,60,60,32,40,40,40,40,115,105,122,101,111,102,40,115,105,122,101,95,116,41,47,52,43,49,41,42,49,54,51,56,52,124,48,120,51,97,53,48,41,32,62,62,32,40,40,115,101,113,45,62,102,108,97,103,115,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,42,50,41,32,38,32,51,41,41,32,61,61,32,101,115,122,0,85,110,107,110,111,119,110,32,97,114,114,97,121,32,116,121,112,101,0,100,105,109,115,32,60,61,32,50,32,38,38,32,115,116,101,112,91,48,93,32,62,32,48,0,108,111,99,97,116,101,82,79,73,0,97,100,106,117,115,116,82,79,73,0,105,32,60,32,48,0,103,101,116,77,97,116,95,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,40,105,110,116,41,118,118,46,115,105,122,101,40,41,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,40,105,110,116,41,118,46,115,105,122,101,40,41,0,48,32,60,61,32,105,32,38,38,32,105,32,60,32,115,122,46,104,101,105,103,104,116,0,89,111,117,32,115,104,111,117,108,100,32,101,120,112,108,105,99,105,116,108,121,32,99,97,108,108,32,109,97,112,72,111,115,116,47,117,110,109,97,112,72,111,115,116,32,109,101,116,104,111,100,115,32,102,111,114,32,111,103,108,58,58,66,117,102,102,101,114,32,111,98,106,101,99,116,0,89,111,117,32,115,104,111,117,108,100,32,101,120,112,108,105,99,105,116,108,121,32,99,97,108,108,32,100,111,119,110,108,111,97,100,32,109,101,116,104,111,100,32,102,111,114,32,99,117,100,97,58,58,71,112,117,77,97,116,32,111,98,106,101,99,116,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,40,102,108,97,103,115,32,38,32,70,73,88,69,68,95,84,89,80,69,41,32,33,61,32,48,0,105,32,60,32,40,105,110,116,41,118,118,46,115,105,122,101,40,41,0,105,32,60,32,115,122,46,104,101,105,103,104,116,0,33,102,105,120,101,100,84,121,112,101,40,41,32,38,38,32,33,102,105,120,101,100,83,105,122,101,40,41,0,40,40,109,116,121,112,101,41,32,38,32,40,40,49,32,60,60,32,51,41,42,53,49,50,32,45,32,49,41,41,32,61,61,32,109,46,116,121,112,101,40,41,0,109,46,100,105,109,115,32,61,61,32,100,0,109,46,115,105,122,101,91,106,93,32,61,61,32,115,105,122,101,115,91,106,93,0,109,116,121,112,101,32,61,61,32,116,121,112,101,48,32,124,124,32,40,40,40,40,40,109,116,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,61,61,32,49,32,38,38,32,40,40,49,32,60,60,32,116,121,112,101,48,41,32,38,32,102,105,120,101,100,68,101,112,116,104,77,97,115,107,41,32,33,61,32,48,41,0,100,32,61,61,32,50,32,38,38,32,40,40,115,105,122,101,115,91,48,93,32,61,61,32,115,122,46,104,101,105,103,104,116,32,38,38,32,115,105,122,101,115,91,49,93,32,61,61,32,115,122,46,119,105,100,116,104,41,32,124,124,32,40,97,108,108,111,119,84,114,97,110,115,112,111,115,101,100,32,38,38,32,115,105,122,101,115,91,48,93,32,61,61,32,115,122,46,119,105,100,116,104,32,38,38,32,115,105,122,101,115,91,49,93,32,61,61,32,115,122,46,104,101,105,103,104,116,41,41,0,100,32,61,61,32,50,32,38,38,32,115,122,46,97,114,101,97,40,41,32,61,61,32,115,105,122,101,115,91,48,93,42,115,105,122,101,115,91,49,93,0,100,32,61,61,32,50,32,38,38,32,40,115,105,122,101,115,91,48,93,32,61,61,32,49,32,124,124,32,115,105,122,101,115,91,49,93,32,61,61,32,49,32,124,124,32,115,105,122,101,115,91,48,93,42,115,105,122,101,115,91,49,93,32,61,61,32,48,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,118,118,46,115,105,122,101,40,41,0,109,116,121,112,101,32,61,61,32,116,121,112,101,48,32,124,124,32,40,40,40,40,40,109,116,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,61,61,32,40,40,40,40,116,121,112,101,48,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,38,38,32,40,40,49,32,60,60,32,116,121,112,101,48,41,32,38,32,102,105,120,101,100,68,101,112,116,104,77,97,115,107,41,32,33,61,32,48,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,40,40,115,116,100,58,58,118,101,99,116,111,114,60,117,99,104,97,114,62,42,41,118,41,45,62,115,105,122,101,40,41,32,47,32,101,115,122,0,86,101,99,116,111,114,115,32,119,105,116,104,32,101,108,101,109,101,110,116,32,115,105,122,101,32,37,100,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,46,32,80,108,101,97,115,101,44,32,109,111,100,105,102,121,32,79,117,116,112,117,116,65,114,114,97,121,58,58,99,114,101,97,116,101,40,41,10,0,99,114,101,97,116,101,40,41,32,99,97,108,108,101,100,32,102,111,114,32,116,104,101,32,109,105,115,115,105,110,103,32,111,117,116,112,117,116,32,97,114,114,97,121,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,108,101,110,32,61,61,32,108,101,110,48,0,118,91,106,93,46,101,109,112,116,121,40,41,0,105,32,60,32,40,105,110,116,41,118,46,115,105,122,101,40,41,0,108,101,110,32,61,61,32,108,101,110,48,0,114,101,115,104,97,112,101,0,95,99,110,32,62,61,32,48,32,38,38,32,95,110,101,119,110,100,105,109,115,32,62,32,48,32,38,38,32,95,110,101,119,110,100,105,109,115,32,60,61,32,51,50,32,38,38,32,95,110,101,119,115,122,0,95,99,110,32,60,61,32,53,49,50,0,95,110,101,119,115,122,91,105,93,32,62,61,32,48,0,67,111,112,121,32,100,105,109,101,110,115,105,111,110,32,40,119,104,105,99,104,32,104,97,115,32,122,101,114,111,32,115,105,122,101,41,32,105,115,32,110,111,116,32,112,114,101,115,101,110,116,32,105,110,32,115,111,117,114,99,101,32,109,97,116,114,105,120,0,82,101,113,117,101,115,116,101,100,32,97,110,100,32,115,111,117,114,99,101,32,109,97,116,114,105,99,101,115,32,104,97,118,101,32,100,105,102,102,101,114,101,110,116,32,99,111,117,110,116,32,111,102,32,101,108,101,109,101,110,116,115,0,82,101,115,104,97,112,105,110,103,32,111,102,32,110,45,100,105,109,101,110,115,105,111,110,97,108,32,110,111,110,45,99,111,110,116,105,110,117,111,117,115,32,109,97,116,114,105,99,101,115,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,121,101,116,0,100,46,99,111,108,115,32,61,61,32,49,32,124,124,32,100,46,114,111,119,115,32,61,61,32,49,0,95,115,114,99,46,100,105,109,115,40,41,32,60,61,32,50,32,38,38,32,101,115,122,32,60,61,32,51,50,0,116,114,97,110,115,112,111,115,101,0,115,114,99,46,115,105,122,101,40,41,32,61,61,32,100,115,116,46,115,105,122,101,40,41,32,38,38,32,40,115,114,99,46,99,111,108,115,32,61,61,32,49,32,124,124,32,115,114,99,46,114,111,119,115,32,61,61,32,49,41,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,95,99,111,108,115,44,32,95,114,111,119,115,41,0,33,102,105,120,101,100,84,121,112,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,116,121,112,101,40,41,32,61,61,32,109,116,121,112,101,0,33,102,105,120,101,100,83,105,122,101,40,41,0,114,101,108,101,97,115,101,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,85,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,46,111,112,101,114,97,116,111,114,40,41,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,71,112,117,77,97,116,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,111,103,108,58,58,66,117,102,102,101,114,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,33,102,105,120,101,100,83,105,122,101,40,41,32,124,124,32,40,40,99,117,100,97,58,58,72,111,115,116,77,101,109,42,41,111,98,106,41,45,62,115,105,122,101,40,41,32,61,61,32,95,115,122,0,100,105,109,115,0,118,111,105,100,32,99,118,58,58,116,114,97,110,115,112,111,115,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,99,110,32,60,61,32,52,0,115,99,97,108,97,114,84,111,82,97,119,68,97,116,97,0,118,111,105,100,32,99,118,58,58,115,99,97,108,97,114,84,111,82,97,119,68,97,116,97,40,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,118,111,105,100,32,42,44,32,105,110,116,44,32,105,110,116,41,0,103,101,116,85,77,97,116,0,103,101,116,77,97,116,86,101,99,116,111,114,0,101,109,112,116,121,0,40,115,105,122,101,95,116,41,105,32,60,32,118,118,46,115,105,122,101,40,41,0,105,115,67,111,110,116,105,110,117,111,117,115,0,105,32,62,32,48,32,38,38,32,105,32,60,32,115,122,46,104,101,105,103,104,116,0,103,101,116,77,97,116,82,101,102,0,107,32,61,61,32,83,84,68,95,86,69,67,84,79,82,95,77,65,84,32,124,124,32,107,32,61,61,32,83,84,68,95,65,82,82,65,89,95,77,65,84,0,99,104,101,99,107,83,99,97,108,97,114,40,118,97,108,117,101,44,32,116,121,112,101,40,41,44,32,97,114,114,46,107,105,110,100,40,41,44,32,95,73,110,112,117,116,65,114,114,97,121,58,58,67,85,68,65,95,71,80,85,95,77,65,84,41,0,116,104,105,115,95,118,46,115,105,122,101,40,41,32,61,61,32,118,46,115,105,122,101,40,41,0,115,114,99,91,105,93,46,100,105,109,115,32,60,61,32,50,32,38,38,32,115,114,99,91,105,93,46,114,111,119,115,32,61,61,32,115,114,99,91,48,93,46,114,111,119,115,32,38,38,32,115,114,99,91,105,93,46,116,121,112,101,40,41,32,61,61,32,115,114,99,91,48,93,46,116,121,112,101,40,41,0,104,99,111,110,99,97,116,0,118,111,105,100,32,99,118,58,58,104,99,111,110,99,97,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,115,105,122,101,95,116,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,104,99,111,110,99,97,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,115,114,99,91,105,93,46,100,105,109,115,32,60,61,32,50,32,38,38,32,115,114,99,91,105,93,46,99,111,108,115,32,61,61,32,115,114,99,91,48,93,46,99,111,108,115,32,38,38,32,115,114,99,91,105,93,46,116,121,112,101,40,41,32,61,61,32,115,114,99,91,48,93,46,116,121,112,101,40,41,0,118,99,111,110,99,97,116,0,118,111,105,100,32,99,118,58,58,118,99,111,110,99,97,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,115,105,122,101,95,116,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,118,99,111,110,99,97,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,95,109,46,100,105,109,115,40,41,32,60,61,32,50,0,115,101,116,73,100,101,110,116,105,116,121,0,118,111,105,100,32,99,118,58,58,115,101,116,73,100,101,110,116,105,116,121,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,116,114,97,99,101,0,99,118,58,58,83,99,97,108,97,114,32,99,118,58,58,116,114,97,99,101,40,73,110,112,117,116,65,114,114,97,121,41,0,109,46,100,105,109,115,32,60,61,32,50,32,38,38,32,109,46,114,111,119,115,32,61,61,32,109,46,99,111,108,115,0,99,111,109,112,108,101,116,101,83,121,109,109,0,118,111,105,100,32,99,118,58,58,99,111,109,112,108,101,116,101,83,121,109,109,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,114,101,100,117,99,101,0,111,112,32,61,61,32,48,32,124,124,32,111,112,32,61,61,32,50,32,124,124,32,111,112,32,61,61,32,51,32,124,124,32,111,112,32,61,61,32,49,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,105,110,112,117,116,32,97,110,100,32,111,117,116,112,117,116,32,97,114,114,97,121,32,102,111,114,109,97,116,115,0,118,111,105,100,32,99,118,58,58,114,101,100,117,99,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,101,109,112,116,121,40,41,0,78,50,99,118,57,69,120,99,101,112,116,105,111,110,69,0,107,101,121,95,32,61,61,32,45,49,0,126,84,76,83,68,97,116,97,67,111,110,116,97,105,110,101,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,115,121,115,116,101,109,46,99,112,112],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+174142);allocate([115,116,97,116,117,115,0,101,114,114,111,114,0,85,110,107,110,111,119,110,32,37,115,32,99,111,100,101,32,37,100,0,79,112,101,110,71,76,32,65,80,73,32,99,97,108,108,0,78,111,32,79,112,101,110,71,76,32,115,117,112,112,111,114,116,0,71,112,117,32,65,80,73,32,99,97,108,108,0,78,111,32,67,85,68,65,32,115,117,112,112,111,114,116,0,65,115,115,101,114,116,105,111,110,32,102,97,105,108,101,100,0,77,101,109,111,114,121,32,98,108,111,99,107,32,104,97,115,32,98,101,101,110,32,99,111,114,114,117,112,116,101,100,0,84,104,101,32,102,117,110,99,116,105,111,110,47,102,101,97,116,117,114,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,80,97,114,115,105,110,103,32,101,114,114,111,114,0,66,97,100,32,116,121,112,101,32,111,102,32,109,97,115,107,32,97,114,103,117,109,101,110,116,0,66,97,100,32,112,97,114,97,109,101,116,101,114,32,111,102,32,116,121,112,101,32,67,118,80,111,105,110,116,0,66,97,100,32,102,108,97,103,32,40,112,97,114,97,109,101,116,101,114,32,111,114,32,115,116,114,117,99,116,117,114,101,32,102,105,101,108,100,41,0,66,97,100,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,0,73,110,112,117,116,32,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,85,110,115,117,112,112,111,114,116,101,100,32,102,111,114,109,97,116,32,111,114,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,102,111,114,109,97,116,115,0,79,110,101,32,111,102,32,97,114,103,117,109,101,110,116,115,39,32,118,97,108,117,101,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,83,105,122,101,115,32,111,102,32,105,110,112,117,116,32,97,114,103,117,109,101,110,116,115,32,100,111,32,110,111,116,32,109,97,116,99,104,0,70,111,114,109,97,116,115,32,111,102,32,105,110,112,117,116,32,97,114,103,117,109,101,110,116,115,32,100,111,32,110,111,116,32,109,97,116,99,104,0,73,110,112,117,116,32,105,109,97,103,101,32,100,101,112,116,104,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,102,117,110,99,116,105,111,110,0,82,101,113,117,101,115,116,101,100,32,111,98,106,101,99,116,32,119,97,115,32,110,111,116,32,102,111,117,110,100,0,73,110,112,108,97,99,101,32,111,112,101,114,97,116,105,111,110,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,73,109,97,103,101,32,115,116,101,112,32,105,115,32,119,114,111,110,103,0,68,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,111,99,99,117,114,114,101,100,0,78,117,108,108,32,112,111,105,110,116,101,114,0,73,110,99,111,114,114,101,99,116,32,115,105,122,101,32,111,102,32,105,110,112,117,116,32,97,114,114,97,121,0,65,117,116,111,116,114,97,99,101,32,99,97,108,108,0,73,116,101,114,97,116,105,111,110,115,32,100,111,32,110,111,116,32,99,111,110,118,101,114,103,101,0,66,97,100,32,97,114,103,117,109,101,110,116,0,73,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,0,73,110,116,101,114,110,97,108,32,101,114,114,111,114,0,85,110,115,112,101,99,105,102,105,101,100,32,101,114,114,111,114,0,66,97,99,107,116,114,97,99,101,0,78,111,32,69,114,114,111,114,0,117,110,107,110,111,119,110,32,102,117,110,99,116,105,111,110,0,79,112,101,110,67,86,32,69,114,114,111,114,58,32,37,115,32,40,37,115,41,32,105,110,32,37,115,44,32,102,105,108,101,32,37,115,44,32,108,105,110,101,32,37,100,0,37,115,10,0,37,115,58,37,100,58,32,101,114,114,111,114,58,32,40,37,100,41,32,37,115,32,105,110,32,102,117,110,99,116,105,111,110,32,37,115,10,0,37,115,58,37,100,58,32,101,114,114,111,114,58,32,40,37,100,41,32,37,115,10,0,108,101,110,32,62,61,32,48,32,38,38,32,34,67,104,101,99,107,32,102,111,114,109,97,116,32,115,116,114,105,110,103,32,102,111,114,32,101,114,114,111,114,115,34,0,78,50,99,118,49,54,84,76,83,68,97,116,97,67,111,110,116,97,105,110,101,114,69,0,79,80,69,78,67,86,95,68,85,77,80,95,67,79,78,70,73,71,0,10,71,101,110,101,114,97,108,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,102,111,114,32,79,112,101,110,67,86,32,51,46,52,46,48,32,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,10,32,32,86,101,114,115,105,111,110,32,99,111,110,116,114,111,108,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,51,46,52,46,48,10,10,32,32,80,108,97,116,102,111,114,109,58,10,32,32,32,32,84,105,109,101,115,116,97,109,112,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,50,48,49,55,45,49,50,45,50,50,84,50,50,58,49,51,58,51,48,90,10,32,32,32,32,72,111,115,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,76,105,110,117,120,32,52,46,56,46,48,45,53,56,45,103,101,110,101,114,105,99,32,120,56,54,95,54,52,10,32,32,32,32,84,97,114,103,101,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,69,109,115,99,114,105,112,116,101,110,32,49,32,120,56,54,10,32,32,32,32,67,77,97,107,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,51,46,53,46,49,10,32,32,32,32,67,77,97,107,101,32,103,101,110,101,114,97,116,111,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,85,110,105,120,32,77,97,107,101,102,105,108,101,115,10,32,32,32,32,67,77,97,107,101,32,98,117,105,108,100,32,116,111,111,108,58,32,32,32,32,32,32,32,32,32,32,32,32,47,117,115,114,47,98,105,110,47,109,97,107,101,10,32,32,32,32,67,111,110,102,105,103,117,114,97,116,105,111,110,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,82,101,108,101,97,115,101,10,10,32,32,67,80,85,47,72,87,32,102,101,97,116,117,114,101,115,58,10,32,32,32,32,66,97,115,101,108,105,110,101,58,10,10,32,32,67,47,67,43,43,58,10,32,32,32,32,66,117,105,108,116,32,97,115,32,100,121,110,97,109,105,99,32,108,105,98,115,63,58,32,32,32,32,32,32,78,79,10,32,32,32,32,67,43,43,32,67,111,109,112,105,108,101,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,111,112,116,47,101,109,115,100,107,45,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,49,46,51,55,46,50,49,47,101,109,43,43,32,32,40,118,101,114,32,52,46,48,46,48,41,10,32,32,32,32,67,43,43,32,102,108,97,103,115,32,40,82,101,108,101,97,115,101,41,58,32,32,32,32,32,32,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,87,110,111,45,105,109,112,108,105,99,105,116,45,102,97,108,108,116,104,114,111,117,103,104,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,109,97,114,99,104,61,105,54,56,54,32,45,102,111,109,105,116,45,102,114,97,109,101,45,112,111,105,110,116,101,114,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,45,102,100,97,116,97,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,68,78,68,69,66,85,71,32,45,79,50,32,32,45,68,78,68,69,66,85,71,10,32,32,32,32,67,43,43,32,102,108,97,103,115,32,40,68,101,98,117,103,41,58,32,32,32,32,32,32,32,32,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,87,110,111,45,105,109,112,108,105,99,105,116,45,102,97,108,108,116,104,114,111,117,103,104,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,109,97,114,99,104,61,105,54,56,54,32,45,102,111,109,105,116,45,102,114,97,109,101,45,112,111,105,110,116,101,114,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,45,102,100,97,116,97,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,103,32,32,45,79,48,32,45,68,68,69,66,85,71,32,45,68,95,68,69,66,85,71,10,32,32,32,32,67,32,67,111,109,112,105,108,101,114,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,111,112,116,47,101,109,115,100,107,45,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,49,46,51,55,46,50,49,47,101,109,99,99,10,32,32,32,32,67,32,102,108,97,103,115,32,40,82,101,108,101,97,115,101,41,58,32,32,32,32,32,32,32,32,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,87,110,111,45,105,109,112,108,105,99,105,116,45,102,97,108,108,116,104,114,111,117,103,104,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,109,97,114,99,104,61,105,54,56,54,32,45,102,111,109,105,116,45,102,114,97,109,101,45,112,111,105,110,116,101,114,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,45,102,100,97,116,97,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,68,78,68,69,66,85,71,32,45,79,50,32,32,45,68,78,68,69,66,85,71,10,32,32,32,32,67,32,102,108,97,103,115,32,40,68,101,98,117,103,41,58,32,32,32,32,32,32,32,32,32,32,32,32,32,45,102,115,105,103,110,101,100,45,99,104,97,114,32,45,87,32,45,87,97,108,108,32,45,87,101,114,114,111,114,61,114,101,116,117,114,110,45,116,121,112,101,32,45,87,101,114,114,111,114,61,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,101,114,114,111,114,61,97,100,100,114,101,115,115,32,45,87,101,114,114,111,114,61,115,101,113,117,101,110,99,101,45,112,111,105,110,116,32,45,87,102,111,114,109,97,116,32,45,87,101,114,114,111,114,61,102,111,114,109,97,116,45,115,101,99,117,114,105,116,121,32,45,87,109,105,115,115,105,110,103,45,100,101,99,108,97,114,97,116,105,111,110,115,32,45,87,109,105,115,115,105,110,103,45,112,114,111,116,111,116,121,112,101,115,32,45,87,115,116,114,105,99,116,45,112,114,111,116,111,116,121,112,101,115,32,45,87,117,110,100,101,102,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,112,111,105,110,116,101,114,45,97,114,105,116,104,32,45,87,115,104,97,100,111,119,32,45,87,115,105,103,110,45,112,114,111,109,111,32,45,87,117,110,105,110,105,116,105,97,108,105,122,101,100,32,45,87,105,110,105,116,45,115,101,108,102,32,45,87,110,111,45,110,97,114,114,111,119,105,110,103,32,45,87,110,111,45,100,101,108,101,116,101,45,110,111,110,45,118,105,114,116,117,97,108,45,100,116,111,114,32,45,87,110,111,45,117,110,110,97,109,101,100,45,116,121,112,101,45,116,101,109,112,108,97,116,101,45,97,114,103,115,32,45,87,110,111,45,99,111,109,109,101,110,116,32,45,87,110,111,45,105,109,112,108,105,99,105,116,45,102,97,108,108,116,104,114,111,117,103,104,32,45,102,100,105,97,103,110,111,115,116,105,99,115,45,115,104,111,119,45,111,112,116,105,111,110,32,45,112,116,104,114,101,97,100,32,45,81,117,110,117,115,101,100,45,97,114,103,117,109,101,110,116,115,32,45,109,97,114,99,104,61,105,54,56,54,32,45,102,111,109,105,116,45,102,114,97,109,101,45,112,111,105,110,116,101,114,32,45,102,102,117,110,99,116,105,111,110,45,115,101,99,116,105,111,110,115,32,45,102,100,97,116,97,45,115,101,99,116,105,111,110,115,32,32,45,102,118,105,115,105,98,105,108,105,116,121,61,104,105,100,100,101,110,32,45,102,118,105,115,105,98,105,108,105,116,121,45,105,110,108,105,110,101,115,45,104,105,100,100,101,110,32,45,103,32,32,45,79,48,32,45,68,68,69,66,85,71,32,45,68,95,68,69,66,85,71,10,32,32,32,32,76,105,110,107,101,114,32,102,108,97,103,115,32,40,82,101,108,101,97,115,101,41,58,32,32,32,32,32,32,45,79,50,10,32,32,32,32,76,105,110,107,101,114,32,102,108,97,103,115,32,40,68,101,98,117,103,41,58,10,32,32,32,32,99,99,97,99,104,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,80,114,101,99,111,109,112,105,108,101,100,32,104,101,97,100,101,114,115,58,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,69,120,116,114,97,32,100,101,112,101,110,100,101,110,99,105,101,115,58,10,32,32,32,32,51,114,100,112,97,114,116,121,32,100,101,112,101,110,100,101,110,99,105,101,115,58,32,32,32,32,32,32,32,122,108,105,98,32,108,105,98,112,114,111,116,111,98,117,102,10,10,32,32,79,112,101,110,67,86,32,109,111,100,117,108,101,115,58,10,32,32,32,32,84,111,32,98,101,32,98,117,105,108,116,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,99,111,114,101,32,100,110,110,32,105,109,103,112,114,111,99,32,106,115,32,111,98,106,100,101,116,101,99,116,32,112,121,116,104,111,110,95,98,105,110,100,105,110,103,115,95,103,101,110,101,114,97,116,111,114,32,118,105,100,101,111,10,32,32,32,32,68,105,115,97,98,108,101,100,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,99,97,108,105,98,51,100,32,102,101,97,116,117,114,101,115,50,100,32,102,108,97,110,110,32,104,105,103,104,103,117,105,32,105,109,103,99,111,100,101,99,115,32,109,108,32,112,104,111,116,111,32,115,104,97,112,101,32,115,116,105,116,99,104,105,110,103,32,115,117,112,101,114,114,101,115,32,118,105,100,101,111,105,111,32,118,105,100,101,111,115,116,97,98,32,119,111,114,108,100,10,32,32,32,32,68,105,115,97,98,108,101,100,32,98,121,32,100,101,112,101,110,100,101,110,99,121,58,32,32,32,32,32,32,45,10,32,32,32,32,85,110,97,118,97,105,108,97,98,108,101,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,99,117,100,97,97,114,105,116,104,109,32,99,117,100,97,98,103,115,101,103,109,32,99,117,100,97,99,111,100,101,99,32,99,117,100,97,102,101,97,116,117,114,101,115,50,100,32,99,117,100,97,102,105,108,116,101,114,115,32,99,117,100,97,105,109,103,112,114,111,99,32,99,117,100,97,108,101,103,97,99,121,32,99,117,100,97,111,98,106,100,101,116,101,99,116,32,99,117,100,97,111,112,116,102,108,111,119,32,99,117,100,97,115,116,101,114,101,111,32,99,117,100,97,119,97,114,112,105,110,103,32,99,117,100,101,118,32,106,97,118,97,32,112,121,116,104,111,110,50,32,112,121,116,104,111,110,51,32,116,115,32,118,105,122,10,32,32,32,32,65,112,112,108,105,99,97,116,105,111,110,115,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,45,10,32,32,32,32,68,111,99,117,109,101,110,116,97,116,105,111,110,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,32,32,32,32,78,111,110,45,102,114,101,101,32,97,108,103,111,114,105,116,104,109,115,58,32,32,32,32,32,32,32,32,32,78,79,10,10,32,32,71,85,73,58,32,10,10,32,32,77,101,100,105,97,32,73,47,79,58,32,10,32,32,32,32,90,76,105,98,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,98,117,105,108,100,32,40,118,101,114,32,49,46,50,46,49,49,41,10,10,32,32,86,105,100,101,111,32,73,47,79,58,10,10,32,32,80,97,114,97,108,108,101,108,32,102,114,97,109,101,119,111,114,107,58,32,32,32,32,32,32,32,32,32,32,32,32,110,111,110,101,10,10,32,32,79,116,104,101,114,32,116,104,105,114,100,45,112,97,114,116,121,32,108,105,98,114,97,114,105,101,115,58,10,32,32,32,32,67,117,115,116,111,109,32,72,65,76,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,78,79,10,10,32,32,80,121,116,104,111,110,32,40,102,111,114,32,98,117,105,108,100,41,58,32,32,32,32,32,32,32,32,32,32,32,32,47,117,115,114,47,98,105,110,47,112,121,116,104,111,110,50,46,55,10,10,32,32,73,110,115,116,97,108,108,32,116,111,58,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,98,117,105,108,100,47,106,115,47,105,110,115,116,97,108,108,10,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,10,10,0,10,79,112,101,110,67,86,32,98,117,105,108,100,32,99,111,110,102,105,103,117,114,97,116,105,111,110,32,105,115,58,10,37,115,10,0,77,77,88,0,83,83,69,0,83,83,69,50,0,83,83,69,51,0,83,83,83,69,51,0,83,83,69,52,46,49,0,83,83,69,52,46,50,0,80,79,80,67,78,84,0,70,80,49,54,0,65,86,88,0,65,86,88,50,0,70,77,65,51,0,65,86,88,53,49,50,70,0,65,86,88,53,49,50,66,87,0,65,86,88,53,49,50,67,68,0,65,86,88,53,49,50,68,81,0,65,86,88,53,49,50,69,82,0,65,86,88,53,49,50,73,70,77,65,0,65,86,88,53,49,50,80,70,0,65,86,88,53,49,50,86,66,77,73,0,65,86,88,53,49,50,86,76,0,78,69,79,78,0,86,83,88,0,79,80,69,78,67,86,95,67,80,85,95,68,73,83,65,66,76,69,0,102,101,97,116,117,114,101,46,115,105,122,101,40,41,32,62,32,48,0,114,101,97,100,83,101,116,116,105,110,103,115,0,79,80,69,78,67,86,58,32,84,114,121,105,110,103,32,116,111,32,100,105,115,97,98,108,101,32,98,97,115,101,108,105,110,101,32,67,80,85,32,102,101,97,116,117,114,101,58,32,39,37,115,39,46,32,84,104,105,115,32,104,97,115,32,118,101,114,121,32,108,105,109,105,116,101,100,32,101,102,102,101,99,116,44,32,98,101,99,97,117,115,101,32,99,111,100,101,32,111,112,116,105,109,105,122,97,116,105,111,110,115,32,102,111,114,32,116,104,105,115,32,102,101,97,116,117,114,101,32,97,114,101,32,101,120,101,99,117,116,101,100,32,117,110,99,111,110,100,105,116,105,111,110,97,108,108,121,32,105,110,32,116,104,101,32,109,111,115,116,32,99,97,115,101,115,46,10,0,85,110,107,110,111,119,110,32,102,101,97,116,117,114,101,0,79,80,69,78,67,86,58,32,84,114,121,105,110,103,32,116,111,32,100,105,115,97,98,108,101,32,117,110,97,118,97,105,108,97,98,108,101,32,67,80,85,32,102,101,97,116,117,114,101,32,111,110,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,58,32,39,37,115,39,46,10,0,79,80,69,78,67,86,58,32,84,114,121,105,110,103,32,116,111,32,100,105,115,97,98,108,101,32,117,110,107,110,111,119,110,32,67,80,85,32,102,101,97,116,117,114,101,58,32,39,37,115,39,46,10,0,107,101,121,95,32,33,61,32,45,49,32,38,38,32,34,67,97,110,39,116,32,102,101,116,99,104,32,100,97,116,97,32,102,114,111,109,32,116,101,114,109,105,110,97,116,101,100,32,84,76,83,32,99,111,110,116,97,105,110,101,114,46,34,0,103,101,116,68,97,116,97,0,116,108,115,83,108,111,116,115,83,105,122,101,32,62,32,115,108,111,116,73,100,120,0,115,101,116,68,97,116,97,0,112,116,104,114,101,97,100,95,115,101,116,115,112,101,99,105,102,105,99,40,116,108,115,75,101,121,44,32,112,68,97,116,97,41,32,61,61,32,48,0,83,101,116,68,97,116,97,0,112,116,104,114,101,97,100,95,107,101,121,95,100,101,108,101,116,101,40,116,108,115,75,101,121,41,32,61,61,32,48,0,126,84,108,115,65,98,115,116,114,97,99,116,105,111,110,0,112,116,104,114,101,97,100,95,107,101,121,95,99,114,101,97,116,101,40,38,116,108,115,75,101,121,44,32,48,76,41,32,61,61,32,48,0,84,108,115,65,98,115,116,114,97,99,116,105,111,110,0,116,108,115,83,108,111,116,115,83,105,122,101,32,61,61,32,116,108,115,83,108,111,116,115,46,115,105,122,101,40,41,0,114,101,108,101,97,115,101,83,108,111,116,0,78,50,99,118,55,84,76,83,68,97,116,97,73,78,83,95,49,49,67,111,114,101,84,76,83,68,97,116,97,69,69,69,0,114,101,115,101,114,118,101,83,108,111,116,0,102,108,111,97,116,32,99,118,58,58,99,117,98,101,82,111,111,116,40,102,108,111,97,116,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,104,102,117,110,99,115,46,99,112,112,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,50,46,115,105,122,101,40,41,32,38,38,32,116,121,112,101,32,61,61,32,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,54,41,0,118,111,105,100,32,99,118,58,58,109,97,103,110,105,116,117,100,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,88,46,115,105,122,101,32,61,61,32,89,46,115,105,122,101,32,38,38,32,116,121,112,101,32,61,61,32,89,46,116,121,112,101,40,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,54,41,0,99,97,114,116,84,111,80,111,108,97,114,0,118,111,105,100,32,99,118,58,58,99,97,114,116,84,111,80,111,108,97,114,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,54,41,32,38,38,32,40,115,114,99,49,46,101,109,112,116,121,40,41,32,124,124,32,115,114,99,49,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,41,0,112,111,108,97,114,84,111,67,97,114,116,0,77,97,103,46,101,109,112,116,121,40,41,32,124,124,32,65,110,103,108,101,46,115,105,122,101,32,61,61,32,77,97,103,46,115,105,122,101,0,118,111,105,100,32,99,118,58,58,112,111,108,97,114,84,111,67,97,114,116,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,101,120,112,0,118,111,105,100,32,99,118,58,58,101,120,112,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,108,111,103,0,118,111,105,100,32,99,118,58,58,108,111,103,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,112,111,119,40,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,115,113,114,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,95,97,46,100,101,112,116,104,40,41,32,61,61,32,53,0,112,97,116,99,104,78,97,78,115,0,118,111,105,100,32,99,118,58,58,112,97,116,99,104,78,97,78,115,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,41,0,99,116,121,112,101,32,61,61,32,53,32,124,124,32,99,116,121,112,101,32,61,61,32,54,0,115,111,108,118,101,67,117,98,105,99,0,40,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,48,44,32,49,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,48,43,49,44,32,49,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,48,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,48,43,49,41,41,0,105,110,116,32,99,118,58,58,115,111,108,118,101,67,117,98,105,99,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,40,40,99,116,121,112,101,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,62,61,32,53,32,38,38,32,40,40,40,40,99,116,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,60,61,32,50,0,115,111,108,118,101,80,111,108,121,0,99,111,101,102,102,115,48,46,114,111,119,115,32,61,61,32,49,32,124,124,32,99,111,101,102,102,115,48,46,99,111,108,115,32,61,61,32,49,0,100,111,117,98,108,101,32,99,118,58,58,115,111,108,118,101,80,111,108,121,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,98,111,111,108,32,99,118,58,58,111,99,108,58,58,104,97,118,101,79,112,101,110,67,76,40,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,111,99,108,46,99,112,112,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,99,104,97,110,110,101,108,115,40,41,32,61,61,32,40,40,40,40,100,116,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,0,99,111,112,121,84,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,99,111,112,121,46,99,112,112,0,100,115,116,46,117,32,33,61,32,48,76,0,100,105,109,115,32,62,61,32,48,32,38,38,32,100,105,109,115,32,60,32,51,50,0,118,111,105,100,32,99,118,58,58,77,97,116,58,58,99,111,112,121,84,111,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,0,109,97,115,107,46,100,101,112,116,104,40,41,32,61,61,32,48,32,38,38,32,40,109,99,110,32,61,61,32,49,32,124,124,32,109,99,110,32,61,61,32,99,110,41,0,115,105,122,101,40,41,32,61,61,32,109,97,115,107,46,115,105,122,101,40,41,0,115,122,32,60,61,32,115,105,122,101,111,102,40,115,99,97,108,97,114,41,0,99,118,58,58,77,97,116,32,38,99,118,58,58,77,97,116,58,58,111,112,101,114,97,116,111,114,61,40,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,118,111,105,100,32,99,118,58,58,77,97,116,58,58,99,111,112,121,84,111,40,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,0,99,104,101,99,107,83,99,97,108,97,114,40,118,97,108,117,101,44,32,116,121,112,101,40,41,44,32,95,118,97,108,117,101,46,107,105,110,100,40,41,44,32,95,73,110,112,117,116,65,114,114,97,121,58,58,77,65,84,32,41,0,115,101,116,84,111,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,109,97,115,107,46,100,101,112,116,104,40,41,32,61,61,32,48,32,38,38,32,40,109,99,110,32,61,61,32,49,32,124,124,32,109,99,110,32,61,61,32,99,110,41,32,38,38,32,115,105,122,101,32,61,61,32,109,97,115,107,46,115,105,122,101,41,0,99,118,58,58,77,97,116,32,38,99,118,58,58,77,97,116,58,58,115,101,116,84,111,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,95,115,114,99,46,100,105,109,115,40,41,32,60,61,32,50,0,102,108,105,112,0,118,111,105,100,32,99,118,58,58,102,108,105,112,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,95,115,114,99,46,103,101,116,79,98,106,40,41,32,33,61,32,95,100,115,116,46,103,101,116,79,98,106,40,41,0,114,101,112,101,97,116,0,110,121,32,62,32,48,32,38,38,32,110,120,32,62,32,48,0,118,111,105,100,32,99,118,58,58,114,101,112,101,97,116,40,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,98,111,114,100,101,114,73,110,116,101,114,112,111,108,97,116,101,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,98,111,114,100,101,114,32,116,121,112,101,0,116,111,112,32,62,61,32,48,32,38,38,32,98,111,116,116,111,109,32,62,61,32,48,32,38,38,32,108,101,102,116,32,62,61,32,48,32,38,38,32,114,105,103,104,116,32,62,61,32,48,0,99,111,112,121,77,97,107,101,66,111,114,100,101,114,0,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,49,93,32,38,38,32,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,50,93,32,38,38,32,118,97,108,117,101,91,48,93,32,61,61,32,118,97,108,117,101,91,51,93,0,118,111,105,100,32,99,118,58,58,99,111,112,121,77,97,107,101,66,111,114,100,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,109,97,115,107,97,114,114,32,61,61,32,48,0,99,118,67,111,112,121,0,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,100,115,116,46,100,101,112,116,104,40,41,32,38,38,32,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,0,40,99,111,105,49,32,33,61,32,48,32,124,124,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,41,32,38,38,32,40,99,111,105,50,32,33,61,32,48,32,124,124,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,41,0,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,114,114,97,121,46,99,112,112,0,68,97,116,97,32,105,115,32,97,108,114,101,97,100,121,32,97,108,108,111,99,97,116,101,100,0,99,118,67,114,101,97,116,101,68,97,116,97,0,84,111,111,32,98,105,103,32,98,117,102,102,101,114,32,105,115,32,97,108,108,111,99,97,116,101,100,0,79,118,101,114,102,108,111,119,32,102,111,114,32,105,109,97,103,101,83,105,122,101,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,78,111,110,45,112,111,115,105,116,105,118,101,32,119,105,100,116,104,32,111,114,32,104,101,105,103,104,116,0,99,118,67,114,101,97,116,101,77,97,116,72,101,97,100,101,114,0,73,110,118,97,108,105,100,32,109,97,116,114,105,120,32,116,121,112,101,0,99,118,73,110,105,116,77,97,116,72,101,97,100,101,114,0,78,111,110,45,112,111,115,105,116,105,118,101,32,99,111,108,115,32,111,114,32,114,111,119,115,0,99,118,82,101,108,101,97,115,101,77,97,116,0,66,97,100,32,67,118,77,97,116,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,77,97,116,0,78,85,76,76,32,109,97,116,114,105,120,32,104,101,97,100,101,114,32,112,111,105,110,116,101,114,0,99,118,73,110,105,116,77,97,116,78,68,72,101,97,100,101,114,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,100,97,116,97,32,116,121,112,101,0,78,85,76,76,32,60,115,105,122,101,115,62,32,112,111,105,110,116,101,114,0,110,111,110,45,112,111,115,105,116,105,118,101,32,111,114,32,116,111,111,32,108,97,114,103,101,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,0,111,110,101,32,111,102,32,100,105,109,101,115,105,111,110,32,115,105,122,101,115,32,105,115,32,110,111,110,45,112,111,115,105,116,105,118,101,0,84,104,101,32,97,114,114,97,121,32,105,115,32,116,111,111,32,98,105,103,0,99,118,67,114,101,97,116,101,77,97,116,78,68,72,101,97,100,101,114,0,66,97,100,32,67,118,77,97,116,78,68,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,77,97,116,78,68,0,115,114,99,45,62,100,105,109,115,32,60,61,32,51,50,0,95,100,115,116,46,100,97,116,97,32,61,61,32,100,97,116,97,48,0,73,110,99,111,114,114,101,99,116,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,115,0,99,118,73,110,105,116,78,65,114,114,97,121,73,116,101,114,97,116,111,114,0,83,111,109,101,32,111,102,32,114,101,113,117,105,114,101,100,32,97,114,114,97,121,32,112,111,105,110,116,101,114,115,32,105,115,32,78,85,76,76,0,73,116,101,114,97,116,111,114,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,73,116,101,114,97,116,111,114,32,119,105,116,104,32,109,97,115,107,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,67,79,73,32,115,101,116,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,78,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,105,115,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,68,97,116,97,32,116,121,112,101,32,105,115,32,110,111,116,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,78,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,32,105,115,32,110,111,116,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,68,101,112,116,104,32,105,115,32,110,111,116,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,68,105,109,101,110,115,105,111,110,32,115,105,122,101,115,32,97,114,101,32,116,104,101,32,115,97,109,101,32,102,111,114,32,97,108,108,32,97,114,114,97,121,115,0,78,85,76,76,32,97,114,114,97,121,32,112,111,105,110,116,101,114,32,105,115,32,112,97,115,115,101,100,0,99,118,71,101,116,77,97,116,78,68,0,84,104,101,32,109,97,116,114,105,120,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,85,110,114,101,99,111,103,110,105,122,101,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,97,114,114,97,121,32,116,121,112,101,0,73,110,112,117,116,32,97,114,114,97,121,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+184382);allocate([112,111,105,110,116,101,114,0,99,118,71,101,116,77,97,116,0,84,104,101,32,105,109,97,103,101,32,104,97,115,32,78,85,76,76,32,100,97,116,97,32,112,111,105,110,116,101,114,0,73,109,97,103,101,115,32,119,105,116,104,32,112,108,97,110,97,114,32,100,97,116,97,32,108,97,121,111,117,116,32,115,104,111,117,108,100,32,98,101,32,117,115,101,100,32,119,105,116,104,32,67,79,73,32,115,101,108,101,99,116,101,100,0,84,104,101,32,105,109,97,103,101,32,105,115,32,105,110,116,101,114,108,101,97,118,101,100,32,97,110,100,32,104,97,115,32,111,118,101,114,32,67,86,95,67,78,95,77,65,88,32,99,104,97,110,110,101,108,115,0,80,105,120,101,108,32,111,114,100,101,114,32,115,104,111,117,108,100,32,98,101,32,117,115,101,100,32,119,105,116,104,32,99,111,105,32,61,61,32,48,0,79,110,108,121,32,99,111,110,116,105,110,117,111,117,115,32,110,68,32,97,114,114,97,121,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,32,104,101,114,101,0,99,118,67,114,101,97,116,101,83,112,97,114,115,101,77,97,116,0,98,97,100,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,0,99,118,82,101,108,101,97,115,101,83,112,97,114,115,101,77,97,116,0,73,110,118,97,108,105,100,32,115,112,97,114,115,101,32,97,114,114,97,121,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,83,112,97,114,115,101,77,97,116,0,73,110,118,97,108,105,100,32,115,112,97,114,115,101,32,109,97,116,114,105,120,32,104,101,97,100,101,114,0,99,118,73,110,105,116,83,112,97,114,115,101,77,97,116,73,116,101,114,97,116,111,114,0,99,118,82,101,108,101,97,115,101,68,97,116,97,0,105,110,100,101,120,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,99,118,80,116,114,50,68,0,67,79,73,32,109,117,115,116,32,98,101,32,110,111,110,45,110,117,108,108,32,105,110,32,99,97,115,101,32,111,102,32,112,108,97,110,97,114,32,105,109,97,103,101,115,0,40,40,67,118,83,112,97,114,115,101,77,97,116,42,41,97,114,114,41,45,62,100,105,109,115,32,61,61,32,50,0,79,110,101,32,111,102,32,105,110,100,105,99,101,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,105,99,118,71,101,116,78,111,100,101,80,116,114,0,99,118,71,101,116,69,108,101,109,84,121,112,101,0,99,118,71,101,116,68,105,109,115,0,65,114,114,97,121,32,115,104,111,117,108,100,32,98,101,32,67,118,77,97,116,32,111,114,32,73,112,108,73,109,97,103,101,0,99,118,71,101,116,83,105,122,101,0,78,85,76,76,32,112,111,105,110,116,101,114,32,116,111,32,105,110,100,105,99,101,115,0,99,118,80,116,114,78,68,0,84,104,101,32,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,32,105,115,32,110,111,116,32,100,105,118,105,115,105,98,108,101,32,98,121,32,116,104,101,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,0,99,118,82,101,115,104,97,112,101,0,84,104,101,32,109,97,116,114,105,120,32,105,115,32,110,111,116,32,99,111,110,116,105,110,117,111,117,115,44,32,116,104,117,115,32,105,116,115,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,32,99,97,110,32,110,111,116,32,98,101,32,99,104,97,110,103,101,100,0,66,97,100,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,114,111,119,115,0,84,104,101,32,116,111,116,97,108,32,119,105,100,116,104,32,105,115,32,110,111,116,32,100,105,118,105,115,105,98,108,101,32,98,121,32,116,104,101,32,110,101,119,32,110,117,109,98,101,114,32,111,102,32,99,104,97,110,110,101,108,115,0,110,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,104,101,97,100,101,114,0,99,118,73,110,105,116,73,109,97,103,101,72,101,97,100,101,114,0,66,97,100,32,105,110,112,117,116,32,114,111,105,0,85,110,115,117,112,112,111,114,116,101,100,32,102,111,114,109,97,116,0,66,97,100,32,105,110,112,117,116,32,111,114,105,103,105,110,0,66,97,100,32,105,110,112,117,116,32,97,108,105,103,110,0,71,82,65,89,0,82,71,66,0,66,71,82,0,66,71,82,65,0,99,118,82,101,108,101,97,115,101,73,109,97,103,101,0,99,118,83,101,116,73,109,97,103,101,82,79,73,0,114,101,99,116,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,114,101,99,116,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,114,101,99,116,46,120,32,60,32,105,109,97,103,101,45,62,119,105,100,116,104,32,38,38,32,114,101,99,116,46,121,32,60,32,105,109,97,103,101,45,62,104,101,105,103,104,116,32,38,38,32,114,101,99,116,46,120,32,43,32,114,101,99,116,46,119,105,100,116,104,32,62,61,32,40,105,110,116,41,40,114,101,99,116,46,119,105,100,116,104,32,62,32,48,41,32,38,38,32,114,101,99,116,46,121,32,43,32,114,101,99,116,46,104,101,105,103,104,116,32,62,61,32,40,105,110,116,41,40,114,101,99,116,46,104,101,105,103,104,116,32,62,32,48,41,0,99,118,83,101,116,73,109,97,103,101,67,79,73,0,99,118,71,101,116,73,109,97,103,101,67,79,73,0,66,97,100,32,105,109,97,103,101,32,104,101,97,100,101,114,0,99,118,67,108,111,110,101,73,109,97,103,101,0,78,50,99,118,49,54,80,97,114,97,108,108,101,108,76,111,111,112,66,111,100,121,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,118,105,114,116,117,97,108,32,105,110,116,32,99,118,58,58,77,97,116,79,112,58,58,116,121,112,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,111,112,46,99,112,112,0,78,50,99,118,49,49,77,97,116,79,112,95,83,111,108,118,101,69,0,40,40,40,40,95,116,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,61,61,32,101,46,97,46,99,104,97,110,110,101,108,115,40,41,0,97,115,115,105,103,110,0,78,50,99,118,49,52,77,97,116,79,112,95,73,100,101,110,116,105,116,121,69,0,78,50,99,118,49,50,77,97,116,79,112,95,73,110,118,101,114,116,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,71,69,77,77,58,58,116,114,97,110,115,112,111,115,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,71,69,77,77,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,71,69,77,77,58,58,115,117,98,116,114,97,99,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,71,69,77,77,58,58,97,100,100,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,78,50,99,118,49,48,77,97,116,79,112,95,71,69,77,77,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,65,100,100,69,120,58,58,116,114,97,110,115,112,111,115,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,66,105,110,58,58,100,105,118,105,100,101,40,100,111,117,98,108,101,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,66,105,110,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,85,110,107,110,111,119,110,32,111,112,101,114,97,116,105,111,110,0,78,50,99,118,57,77,97,116,79,112,95,66,105,110,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,65,100,100,69,120,58,58,97,98,115,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,65,100,100,69,120,58,58,100,105,118,105,100,101,40,100,111,117,98,108,101,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,65,100,100,69,120,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,65,100,100,69,120,58,58,115,117,98,116,114,97,99,116,40,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,65,100,100,69,120,58,58,97,100,100,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,78,50,99,118,49,49,77,97,116,79,112,95,65,100,100,69,120,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,84,58,58,116,114,97,110,115,112,111,115,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,84,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,78,50,99,118,55,77,97,116,79,112,95,84,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,116,114,97,110,115,112,111,115,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,97,98,115,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,100,105,118,105,100,101,40,100,111,117,98,108,101,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,100,105,118,105,100,101,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,115,117,98,116,114,97,99,116,40,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,115,117,98,116,114,97,99,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,97,100,100,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,58,58,97,100,100,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,78,50,99,118,53,77,97,116,79,112,69,0,78,50,99,118,57,77,97,116,79,112,95,67,109,112,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,77,97,116,79,112,95,73,110,105,116,105,97,108,105,122,101,114,58,58,109,117,108,116,105,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,69,120,112,114,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,69,120,112,114,32,38,41,32,99,111,110,115,116,0,73,110,118,97,108,105,100,32,109,97,116,114,105,120,32,105,110,105,116,105,97,108,105,122,101,114,32,116,121,112,101,0,78,50,99,118,49,55,77,97,116,79,112,95,73,110,105,116,105,97,108,105,122,101,114,69,0,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,97,98,115,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,41,0,105,110,116,32,99,118,58,58,77,97,116,69,120,112,114,58,58,116,121,112,101,40,41,32,99,111,110,115,116,0,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,116,40,41,32,99,111,110,115,116,0,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,105,110,118,40,105,110,116,41,32,99,111,110,115,116,0,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,109,117,108,40,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,41,32,99,111,110,115,116,0,115,116,97,116,105,99,32,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,122,101,114,111,115,40,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,115,116,97,116,105,99,32,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,122,101,114,111,115,40,83,105,122,101,44,32,105,110,116,41,0,115,116,97,116,105,99,32,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,111,110,101,115,40,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,115,116,97,116,105,99,32,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,111,110,101,115,40,83,105,122,101,44,32,105,110,116,41,0,115,116,97,116,105,99,32,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,101,121,101,40,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,115,116,97,116,105,99,32,99,118,58,58,77,97,116,69,120,112,114,32,99,118,58,58,77,97,116,58,58,101,121,101,40,83,105,122,101,44,32,105,110,116,41,0,84,104,101,32,108,105,98,114,97,114,121,32,105,115,32,99,111,109,112,105,108,101,100,32,119,105,116,104,111,117,116,32,79,112,101,110,71,76,32,115,117,112,112,111,114,116,0,116,104,114,111,119,95,110,111,95,111,103,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,111,112,101,110,103,108,46,99,112,112,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,108,97,112,97,99,107,46,99,112,112,0,33,109,97,116,46,101,109,112,116,121,40,41,0,100,101,116,101,114,109,105,110,97,110,116,0,109,97,116,46,114,111,119,115,32,61,61,32,109,97,116,46,99,111,108,115,32,38,38,32,40,116,121,112,101,32,61,61,32,53,32,124,124,32,116,121,112,101,32,61,61,32,54,41,0,100,111,117,98,108,101,32,99,118,58,58,100,101,116,101,114,109,105,110,97,110,116,40,73,110,112,117,116,65,114,114,97,121,41,0,116,121,112,101,32,61,61,32,53,32,124,124,32,116,121,112,101,32,61,61,32,54,0,105,110,118,101,114,116,0,109,32,61,61,32,110,0,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,76,85,32,124,124,32,109,101,116,104,111,100,32,61,61,32,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,0,115,114,99,46,114,111,119,115,32,61,61,32,115,114,99,46,99,111,108,115,0,101,105,103,101,110,0,98,111,111,108,32,99,118,58,58,101,105,103,101,110,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,119,46,116,121,112,101,40,41,32,61,61,32,117,46,116,121,112,101,40,41,32,38,38,32,117,46,116,121,112,101,40,41,32,61,61,32,118,116,46,116,121,112,101,40,41,32,38,38,32,117,46,100,97,116,97,32,38,38,32,118,116,46,100,97,116,97,32,38,38,32,119,46,100,97,116,97,0,98,97,99,107,83,117,98,115,116,0,117,46,99,111,108,115,32,62,61,32,110,109,32,38,38,32,118,116,46,114,111,119,115,32,62,61,32,110,109,32,38,38,32,40,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,110,109,44,32,49,41,32,124,124,32,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,110,109,41,32,124,124,32,119,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,118,116,46,114,111,119,115,44,32,117,46,99,111,108,115,41,41,0,114,104,115,46,100,97,116,97,32,61,61,32,48,32,124,124,32,40,114,104,115,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,32,38,38,32,114,104,115,46,114,111,119,115,32,61,61,32,109,41,0,95,83,86,68,99,111,109,112,117,116,101,0,115,116,97,116,105,99,32,118,111,105,100,32,99,118,58,58,83,86,68,58,58,99,111,109,112,117,116,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,100,111,117,98,108,101,32,99,118,58,58,105,110,118,101,114,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,116,121,112,101,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,32,38,38,32,40,116,121,112,101,32,61,61,32,53,32,124,124,32,116,121,112,101,32,61,61,32,54,41,0,115,111,108,118,101,0,40,109,101,116,104,111,100,32,33,61,32,68,69,67,79,77,80,95,76,85,32,38,38,32,109,101,116,104,111,100,32,33,61,32,68,69,67,79,77,80,95,67,72,79,76,69,83,75,89,41,32,124,124,32,105,115,95,110,111,114,109,97,108,32,124,124,32,115,114,99,46,114,111,119,115,32,61,61,32,115,114,99,46,99,111,108,115,0,84,104,101,32,102,117,110,99,116,105,111,110,32,99,97,110,32,110,111,116,32,115,111,108,118,101,32,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,98,111,111,108,32,99,118,58,58,115,111,108,118,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,78,85,76,76,32,100,111,117,98,108,101,32,112,111,105,110,116,101,114,32,116,111,32,102,105,108,101,32,115,116,111,114,97,103,101,0,105,99,118,67,108,111,115,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,112,101,114,115,105,115,116,101,110,99,101,46,99,112,112,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,10,0,84,104,101,32,115,116,111,114,97,103,101,32,105,115,32,110,111,116,32,111,112,101,110,101,100,0,105,99,118,80,117,116,115,0,73,110,118,97,108,105,100,32,112,111,105,110,116,101,114,32,116,111,32,102,105,108,101,32,115,116,111,114,97,103,101,0,99,118,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,84,104,101,32,102,105,108,101,32,115,116,111,114,97,103,101,32,105,115,32,111,112,101,110,101,100,32,102,111,114,32,114,101,97,100,105,110,103,0,85,110,101,120,112,101,99,116,101,100,32,101,114,114,111,114,44,32,117,110,97,98,108,101,32,116,111,32,100,101,116,101,114,109,105,110,101,32,116,104,101,32,66,97,115,101,54,52,32,115,116,97,116,101,46,0,115,119,105,116,99,104,95,116,111,95,66,97,115,101,54,52,95,115,116,97,116,101,0,85,110,101,120,112,101,99,116,101,100,32,101,114,114,111,114,44,32,117,110,97,98,108,101,32,116,111,32,115,119,105,116,99,104,32,116,111,32,116,104,105,115,32,115,116,97,116,101,46,0,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,48,49,50,51,52,53,54,55,56,57,43,47,0,66,97,115,101,54,52,87,114,105,116,101,114,0,66,97,115,101,54,52,67,111,110,116,101,120,116,69,109,105,116,116,101,114,0,34,36,98,97,115,101,54,52,36,0,98,105,110,97,114,121,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,49,51,67,118,70,105,108,101,83,116,111,114,97,103,101,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,98,97,115,101,54,52,0,78,85,76,76,32,111,114,32,101,109,112,116,121,32,102,105,108,101,110,97,109,101,0,78,85,76,76,32,111,114,32,101,109,112,116,121,32,98,117,102,102,101,114,0,99,118,79,112,101,110,70,105,108,101,83,116,111,114,97,103,101,0,67,86,95,83,84,79,82,65,71,69,95,65,80,80,69,78,68,32,97,110,100,32,67,86,95,83,84,79,82,65,71,69,95,77,69,77,79,82,89,32,97,114,101,32,110,111,116,32,99,117,114,114,101,110,116,108,121,32,99,111,109,112,97,116,105,98,108,101,0,65,112,112,101,110,100,105,110,103,32,100,97,116,97,32,116,111,32,99,111,109,112,114,101,115,115,101,100,32,102,105,108,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,97,43,116,0,119,116,0,114,116,0,85,84,70,45,49,54,0,117,116,102,45,49,54,0,85,116,102,45,49,54,0,85,84,70,45,49,54,32,88,77,76,32,101,110,99,111,100,105,110,103,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,33,32,85,115,101,32,56,45,98,105,116,32,101,110,99,111,100,105,110,103,10,0,115,116,114,108,101,110,40,101,110,99,111,100,105,110,103,41,32,60,32,49,48,48,48,0,60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,32,101,110,99,111,100,105,110,103,61,34,37,115,34,63,62,10,0,60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,63,62,10,0,60,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,10,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,105,110,32,116,104,101,32,101,110,100,32,111,102,32,102,105,108,101,46,10,0,114,43,116,0,32,60,33,45,45,32,114,101,115,117,109,101,100,32,45,45,62,0,37,89,65,77,76,58,49,46,48,10,45,45,45,10,0,46,46,46,10,45,45,45,10,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,39,125,39,32,105,110,32,116,104,101,32,101,110,100,32,111,102,32,102,105,108,101,46,10,0,37,89,65,77,76,0,60,63,120,109,108,0,73,110,112,117,116,32,102,105,108,101,32,105,115,32,101,109,112,116,121,0,85,110,115,117,112,112,111,114,116,101,100,32,102,105,108,101,32,115,116,111,114,97,103,101,32,102,111,114,109,97,116,0,37,115,40,37,100,41,58,32,37,115,0,86,97,108,105,100,32,88,77,76,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,39,60,63,120,109,108,32,46,46,46,63,62,39,0,105,99,118,88,77,76,80,97,114,115,101,0,111,112,101,110,99,118,95,115,116,111,114,97,103,101,0,60,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,116,97,103,32,105,115,32,109,105,115,115,105,110,103,0,60,47,111,112,101,110,99,118,95,115,116,111,114,97,103,101,62,32,116,97,103,32,105,115,32,109,105,115,115,105,110,103,0,45,45,45,0,37,89,65,77,76,58,49,46,0,37,89,65,77,76,32,49,46,0,85,110,115,117,112,112,111,114,116,101,100,32,89,65,77,76,32,118,101,114,115,105,111,110,32,40,105,116,32,109,117,115,116,32,98,101,32,49,46,120,41,0,105,99,118,89,77,76,80,97,114,115,101,0,73,110,118,97,108,105,100,32,111,114,32,117,110,115,117,112,112,111,114,116,101,100,32,115,121,110,116,97,120,0,84,104,101,32,89,65,77,76,32,115,116,114,101,97,109,115,32,109,117,115,116,32,115,116,97,114,116,32,119,105,116,104,32,39,45,45,45,39,44,32,101,120,99,101,112,116,32,116,104,101,32,102,105,114,115,116,32,111,110,101,0,79,110,108,121,32,99,111,108,108,101,99,116,105,111,110,115,32,97,115,32,89,65,77,76,32,115,116,114,101,97,109,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,105,115,32,112,97,114,115,101,114,0,108,101,102,116,45,98,114,97,99,101,32,111,102,32,116,111,112,32,108,101,118,101,108,32,105,115,32,109,105,115,115,105,110,103,0,105,99,118,74,83,79,78,80,97,114,115,101,0,85,110,101,120,112,101,99,116,101,100,32,69,110,100,45,79,102,45,70,105,108,101,0,112,116,114,32,105,115,32,78,85,76,76,0,105,99,118,74,83,79,78,80,97,114,115,101,83,101,113,0,39,91,39,32,45,32,108,101,102,116,45,98,114,97,99,101,32,111,102,32,115,101,113,32,105,115,32,109,105,115,115,105,110,103,0,85,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,39,93,39,32,45,32,114,105,103,104,116,45,98,114,97,99,101,32,111,102,32,115,101,113,32,105,115,32,109,105,115,115,105,110,103,0,105,99,118,74,83,79,78,80,97,114,115,101,86,97,108,117,101,0,36,98,97,115,101,54,52,36,0,39,34,39,32,45,32,114,105,103,104,116,45,113,117,111,116,101,32,111,102,32,115,116,114,105,110,103,32,105,115,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,62,0,0,0,63,52,53,54,55,56,57,58,59,60,61,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,0,0,0,0,0,0,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,0,0,0,0,73,110,118,97,108,105,100,32,96,100,116,96,32,105,110,32,66,97,115,101,54,52,32,104,101,97,100,101,114,0,73,110,118,97,108,105,100,32,66,97,115,101,54,52,32,100,97,116,97,46,0,66,121,116,101,32,115,105,122,101,32,110,111,116,32,109,97,116,99,104,32,101,108,101,109,101,109,116,32,115,105,122,101,0,85,110,114,101,99,111,103,110,105,122,101,100,32,66,97,115,101,54,52,32,104,101,97,100,101,114,0,39,92,117,88,88,88,88,39,32,99,117,114,114,101,110,116,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,73,110,118,97,108,105,100,32,101,115,99,97,112,101,32,99,104,97,114,97,99,116,101,114,0,73,110,118,97,108,105,100,32,110,117,109,101,114,105,99,32,118,97,108,117,101,32,40,105,110,99,111,110,115,105,115,116,101,110,116,32,101,120,112,108,105,99,105,116,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,63,41,0,110,117,108,108,0,86,97,108,117,101,32,39,110,117,108,108,39,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,105,115,32,112,97,114,115,101,114,0,85,110,114,101,99,111,103,110,105,122,101,100,32,118,97,108,117,101,0,66,97,100,32,102,111,114,109,97,116,32,111,102,32,102,108,111,97,116,105,110,103,45,112,111,105,110,116,32,99,111,110,115,116,97,110,116,0,105,99,118,80,114,111,99,101,115,115,83,112,101,99,105,97,108,68,111,117,98,108,101,0,115,114,99,0,66,105,110,97,114,121,84,111,67,118,83,101,113,67,111,110,118,101,114,116,111,114,0,109,97,107,101,95,102,117,110,99,115,0,33,34,116,121,112,101,32,110,111,116,32,115,117,112,112,111,114,116,34,0,33,34,116,121,112,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,34,0,105,115,115,46,101,111,102,40,41,0,98,105,110,97,114,121,95,116,111,95,102,117,110,99,115,46,115,105,122,101,40,41,0,78,83,116,51,95,95,50,49,57,98,97,115,105,99,95,105,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,73,110,118,97,108,105,100,32,100,97,116,97,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,0,105,99,118,68,101,99,111,100,101,70,111,114,109,97,116,0,117,99,119,115,105,102,100,114,0,84,111,111,32,108,111,110,103,32,100,97,116,97,32,116,121,112,101,32,115,112,101,99,105,102,105,99,97,116,105,111,110,0,102,108,117,115,104,0,100,115,116,95,99,117,114,32,43,32,108,101,110,32,60,32,100,115,116,95,101,110,100,0,102,108,117,115,104,40,41,0,105,99,118,74,83,79,78,80,97,114,115,101,77,97,112,0,39,123,39,32,45,32,108,101,102,116,45,98,114,97,99,101,32,111,102,32,109,97,112,32,105,115,32,109,105,115,115,105,110,103,0,75,101,121,32,109,117,115,116,32,101,110,100,32,119,105,116,104,32,39,34,39,0,105,99,118,74,83,79,78,80,97,114,115,101,75,101,121,0,77,105,115,115,105,110,103,32,39,58,39,32,98,101,116,119,101,101,110,32,107,101,121,32,97,110,100,32,118,97,108,117,101,0,75,101,121,32,105,115,32,101,109,112,116,121,0,116,121,112,101,95,105,100,0,34,116,121,112,101,95,105,100,34,32,115,104,111,117,108,100,32,98,101,32,111,102,32,116,121,112,101,32,115,116,114,105,110,103,0,39,125,39,32,45,32,114,105,103,104,116,45,98,114,97,99,101,32,111,102,32,109,97,112,32,105,115,32,109,105,115,115,105,110,103,0,99,118,71,101,116,70,105,108,101,78,111,100,101,0,78,117,108,108,32,107,101,121,32,101,108,101,109,101,110,116,0,109,97,112,95,110,111,100,101,32,33,61,32,48,76,0,84,104,101,32,110,111,100,101,32,105,115,32,110,101,105,116,104,101,114,32,97,32,109,97,112,32,110,111,114,32,97,110,32,101,109,112,116,121,32,99,111,108,108,101,99,116,105,111,110,0,68,117,112,108,105,99,97,116,101,100,32,107,101,121,0,83,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,115,104,111,117,108,100,32,110,111,116,32,104,97,118,101,32,110,97,109,101,32,40,117,115,101,32,60,95,62,60,47,95,62,41,0,105,99,118,70,83,67,114,101,97,116,101,67,111,108,108,101,99,116,105,111,110,0,78,111,116,32,115,117,112,112,111,114,116,101,100,32,101,115,99,97,112,101,32,99,104,97,114,97,99,116,101,114,0,105,99,118,74,83,79,78,83,107,105,112,83,112,97,99,101,115,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,105,110,32,116,104,101,32,115,116,114,101,97,109,0,60,116,97,103,58,121,97,109,108,46,111,114,103,44,50,48,48,50,58,0,69,109,112,116,121,32,116,121,112,101,32,110,97,109,101,0,105,99,118,89,77,76,80,97,114,115,101,86,97,108,117,101,0,115,116,114,0,115,101,113,0,109,97,112,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,0,84,111,111,32,108,111,110,103,32,115,116,114,105,110,103,32,108,105,116,101,114,97,108,0,84,104,101,32,119,114,111,110,103,32,99,108,111,115,105,110,103,32,98,114,97,99,107,101,116,0,77,105,115,115,105,110,103,32,44,32,98,101,116,119,101,101,110,32,116,104,101,32,101,108,101,109,101,110,116,115,0,67,111,109,112,108,101,120,32,107,101,121,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,77,117,108,116,105,45,108,105,110,101,32,116,101,120,116,32,108,105,116,101,114,97,108,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,66,108,111,99,107,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,115,32,109,117,115,116,32,98,101,32,112,114,101,99,101,100,101,100,32,119,105,116,104,32,39,45,39,0,73,110,99,111,114,114,101,99,116,32,105,110,100,101,110,116,97,116,105,111,110,0,75,101,121,32,109,97,121,32,110,111,116,32,115,116,97,114,116,32,119,105,116,104,32,39,45,39,0,105,99,118,89,77,76,80,97,114,115,101,75,101,121,0,77,105,115,115,105,110,103,32,39,58,39,0,65,110,32,101,109,112,116,121,32,107,101,121,0,85,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,108,105,110,101,0,105,99,118,89,77,76,71,101,116,77,117,108,116,105,108,105,110,101,83,116,114,105,110,103,67,111,110,116,101,110,116,0,105,99,118,89,77,76,80,97,114,115,101,66,97,115,101,54,52,0,105,99,118,89,77,76,83,107,105,112,83,112,97,99,101,115,0,84,111,111,32,108,111,110,103,32,115,116,114,105,110,103,32,111,114,32,97,32,108,97,115,116,32,115,116,114,105,110,103,32,119,47,111,32,110,101,119,108,105,110,101,0,84,97,98,115,32,97,114,101,32,112,114,111,104,105,98,105,116,101,100,32,105,110,32,89,65,77,76,33,0,68,105,114,101,99,116,105,118,101,32,116,97,103,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,105,99,118,88,77,76,80,97,114,115,101,86,97,108,117,101,0,69,109,112,116,121,32,116,97,103,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,77,97,112,32,101,108,101,109,101,110,116,32,115,104,111,117,108,100,32,104,97,118,101,32,97,32,110,97,109,101,0,77,105,115,109,97,116,99,104,101,100,32,99,108,111,115,105,110,103,32,116,97,103,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,108,105,116,101,114,97,108,115,0,76,105,116,101,114,97,108,32,34,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,119,105,116,104,105,110,32,97,32,115,116,114,105,110,103,46,32,85,115,101,32,38,113,117,111,116,59,0,67,108,111,115,105,110,103,32,34,32,105,115,32,101,120,112,101,99,116,101,100,0,76,105,116,101,114,97,108,32,39,32,111,114,32,62,32],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+194622);allocate([97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,46,32,85,115,101,32,38,97,112,111,115,59,32,111,114,32,38,103,116,59,0,73,110,118,97,108,105,100,32,110,117,109,101,114,105,99,32,118,97,108,117,101,32,105,110,32,116,104,101,32,115,116,114,105,110,103,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,105,110,32,116,104,101,32,115,121,109,98,111,108,32,101,110,116,105,116,121,32,110,97,109,101,0,108,116,0,103,116,0,97,109,112,0,97,112,111,115,0,113,117,111,116,0,84,104,101,32,97,99,116,117,97,108,32,116,121,112,101,32,105,115,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,116,121,112,101,0,105,99,118,88,77,76,71,101,116,77,117,108,116,105,108,105,110,101,83,116,114,105,110,103,67,111,110,116,101,110,116,0,105,99,118,88,77,76,80,97,114,115,101,66,97,115,101,54,52,0,100,97,116,97,32,115,105,122,101,32,110,111,116,32,109,97,116,99,104,101,115,32,101,108,101,109,101,109,116,32,115,105,122,101,0,80,114,101,108,105,109,105,110,97,114,121,32,101,110,100,32,111,102,32,116,104,101,32,115,116,114,101,97,109,0,105,99,118,88,77,76,80,97,114,115,101,84,97,103,0,84,97,103,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,39,60,39,0,85,110,107,110,111,119,110,32,116,97,103,32,116,121,112,101,0,78,97,109,101,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,117,110,100,101,114,115,99,111,114,101,0,67,108,111,115,105,110,103,32,116,97,103,32,115,104,111,117,108,100,32,110,111,116,32,99,111,110,116,97,105,110,32,97,110,121,32,97,116,116,114,105,98,117,116,101,115,0,65,116,116,114,105,98,117,116,101,32,110,97,109,101,32,115,104,111,117,108,100,32,98,101,32,102,111,108,108,111,119,101,100,32,98,121,32,39,61,39,0,65,116,116,114,105,98,117,116,101,32,118,97,108,117,101,32,115,104,111,117,108,100,32,98,101,32,112,117,116,32,105,110,116,111,32,115,105,110,103,108,101,32,111,114,32,100,111,117,98,108,101,32,113,117,111,116,101,115,0,73,110,118,97,108,105,100,32,99,108,111,115,105,110,103,32,116,97,103,32,102,111,114,32,60,63,120,109,108,32,46,46,46,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,97,116,116,114,105,98,117,116,101,115,0,67,111,109,109,101,110,116,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,104,101,114,101,0,105,99,118,88,77,76,83,107,105,112,83,112,97,99,101,115,0,46,46,46,10,0,45,45,45,10,0,10,60,33,45,45,32,110,101,120,116,32,115,116,114,101,97,109,32,45,45,62,10,0,78,117,108,108,32,99,111,109,109,101,110,116,0,105,99,118,89,77,76,87,114,105,116,101,67,111,109,109,101,110,116,0,105,99,118,74,83,79,78,87,114,105,116,101,67,111,109,109,101,110,116,0,105,99,118,88,77,76,87,114,105,116,101,67,111,109,109,101,110,116,0,68,111,117,98,108,101,32,104,121,112,104,101,110,32,39,45,45,39,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,116,104,101,32,99,111,109,109,101,110,116,115,0,60,33,45,45,32,37,115,32,45,45,62,0,60,33,45,45,0,78,117,108,108,32,115,116,114,105,110,103,32,112,111,105,110,116,101,114,0,105,99,118,89,77,76,87,114,105,116,101,83,116,114,105,110,103,0,84,104,101,32,119,114,105,116,116,101,110,32,115,116,114,105,110,103,32,105,115,32,116,111,111,32,108,111,110,103,0,120,37,48,50,120,0,65,116,32,112,114,101,115,101,110,116,44,32,111,117,116,112,117,116,32,66,97,115,101,54,52,32,100,97,116,97,32,111,110,108,121,46,0,105,99,118,89,77,76,87,114,105,116,101,0,65,110,32,97,116,116,101,109,112,116,32,116,111,32,97,100,100,32,101,108,101,109,101,110,116,32,119,105,116,104,111,117,116,32,97,32,107,101,121,32,116,111,32,97,32,109,97,112,44,32,111,114,32,97,100,100,32,101,108,101,109,101,110,116,32,119,105,116,104,32,107,101,121,32,116,111,32,115,101,113,117,101,110,99,101,0,84,104,101,32,107,101,121,32,105,115,32,97,110,32,101,109,112,116,121,0,84,104,101,32,107,101,121,32,105,115,32,116,111,111,32,108,111,110,103,0,75,101,121,32,109,117,115,116,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,75,101,121,32,110,97,109,101,115,32,109,97,121,32,111,110,108,121,32,99,111,110,116,97,105,110,32,97,108,112,104,97,110,117,109,101,114,105,99,32,99,104,97,114,97,99,116,101,114,115,32,91,97,45,122,65,45,90,48,45,57,93,44,32,39,45,39,44,32,39,95,39,32,97,110,100,32,39,32,39,0,105,99,118,74,83,79,78,87,114,105,116,101,83,116,114,105,110,103,0,105,99,118,74,83,79,78,87,114,105,116,101,0,105,99,118,88,77,76,87,114,105,116,101,83,116,114,105,110,103,0,35,120,37,48,50,120,0,67,117,114,114,101,110,116,108,121,32,111,110,108,121,32,66,97,115,101,54,52,32,100,97,116,97,32,105,115,32,97,108,108,111,119,101,100,46,0,105,99,118,88,77,76,87,114,105,116,101,83,99,97,108,97,114,0,101,108,101,109,101,110,116,115,32,119,105,116,104,32,107,101,121,115,32,99,97,110,32,110,111,116,32,98,101,32,119,114,105,116,116,101,110,32,116,111,32,115,101,113,117,101,110,99,101,0,105,99,118,88,77,76,87,114,105,116,101,84,97,103,0,65,32,115,105,110,103,108,101,32,95,32,105,115,32,97,32,114,101,115,101,114,118,101,100,32,116,97,103,32,110,97,109,101,0,95,0,67,108,111,115,105,110,103,32,116,97,103,32,115,104,111,117,108,100,32,110,111,116,32,105,110,99,108,117,100,101,32,97,110,121,32,97,116,116,114,105,98,117,116,101,115,0,75,101,121,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,75,101,121,32,110,97,109,101,32,109,97,121,32,111,110,108,121,32,99,111,110,116,97,105,110,32,97,108,112,104,97,110,117,109,101,114,105,99,32,99,104,97,114,97,99,116,101,114,115,32,91,97,45,122,65,45,90,48,45,57,93,44,32,39,45,39,32,97,110,100,32,39,95,39,0,37,100,46,0,37,46,49,54,101,0,46,78,97,110,0,45,46,73,110,102,0,46,73,110,102,0,69,110,100,87,114,105,116,101,83,116,114,117,99,116,32,119,47,111,32,109,97,116,99,104,105,110,103,32,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,105,99,118,89,77,76,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,105,99,118,74,83,79,78,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,65,110,32,101,120,116,114,97,32,99,108,111,115,105,110,103,32,116,97,103,0,105,99,118,88,77,76,69,110,100,87,114,105,116,101,83,116,114,117,99,116,0,83,111,109,101,32,99,111,108,108,101,99,116,105,111,110,32,116,121,112,101,32,45,32,67,86,95,78,79,68,69,95,83,69,81,32,111,114,32,67,86,95,78,79,68,69,95,77,65,80,44,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,0,105,99,118,89,77,76,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,33,33,98,105,110,97,114,121,32,124,0,33,33,37,115,32,37,99,0,33,33,37,115,0,105,99,118,74,83,79,78,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,83,111,109,101,32,99,111,108,108,101,99,116,105,111,110,32,116,121,112,101,58,32,67,86,95,78,79,68,69,95,83,69,81,32,111,114,32,67,86,95,78,79,68,69,95,77,65,80,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,0,105,99,118,88,77,76,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,105,99,118,71,101,116,115,0,99,118,82,101,108,101,97,115,101,70,105,108,101,83,116,111,114,97,103,101,0,118,105,114,116,117,97,108,32,98,111,111,108,32,99,118,58,58,70,105,108,101,83,116,111,114,97,103,101,58,58,111,112,101,110,40,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,44,32,105,110,116,44,32,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,41,0,78,50,99,118,49,49,70,105,108,101,83,116,111,114,97,103,101,69,0,111,112,101,110,99,118,45,115,101,113,117,101,110,99,101,0,111,112,101,110,99,118,45,115,101,113,117,101,110,99,101,45,116,114,101,101,0,111,112,101,110,99,118,45,103,114,97,112,104,0,111,112,101,110,99,118,45,115,112,97,114,115,101,45,109,97,116,114,105,120,0,111,112,101,110,99,118,45,105,109,97,103,101,0,111,112,101,110,99,118,45,109,97,116,114,105,120,0,111,112,101,110,99,118,45,110,100,45,109,97,116,114,105,120,0,115,105,122,101,115,0,105,0,37,100,37,99,0,100,116,0,99,118,87,114,105,116,101,83,116,114,105,110,103,0,99,118,87,114,105,116,101,82,97,119,68,97,116,97,0,78,101,103,97,116,105,118,101,32,110,117,109,98,101,114,32,111,102,32,101,108,101,109,101,110,116,115,0,78,117,108,108,32,100,97,116,97,32,112,111,105,110,116,101,114,0,37,46,56,101,0,99,118,87,114,105,116,101,82,97,119,68,97,116,97,66,97,115,101,54,52,0,66,97,115,101,54,52,32,115,104,111,117,108,100,32,110,111,116,32,98,101,32,117,115,101,100,32,97,116,32,112,114,101,115,101,110,116,46,0,82,97,119,68,97,116,97,84,111,66,105,110,97,114,121,67,111,110,118,101,114,116,111,114,0,33,100,116,46,101,109,112,116,121,40,41,0,108,101,110,32,62,32,48,0,109,97,107,101,95,116,111,95,98,105,110,97,114,121,95,102,117,110,99,115,0,73,110,118,97,108,105,100,32,39,100,116,39,46,0,99,104,101,99,107,95,100,116,0,39,100,116,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,46,0,98,117,102,102,101,114,46,115,105,122,101,40,41,32,60,32,72,69,65,68,69,82,95,83,73,90,69,0,109,97,107,101,95,98,97,115,101,54,52,95,104,101,97,100,101,114,0,99,118,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,0,102,115,45,62,105,115,95,119,114,105,116,101,95,115,116,114,117,99,116,95,100,101,108,97,121,101,100,32,61,61,32,102,97,108,115,101,0,109,97,107,101,95,119,114,105,116,101,95,115,116,114,117,99,116,95,100,101,108,97,121,101,100,0,109,117,115,116,32,115,101,116,32,39,115,116,114,117,99,116,95,102,108,97,103,115,32,124,61,32,67,86,95,78,79,68,69,95,83,69,81,39,32,105,102,32,117,115,105,110,103,32,66,97,115,101,54,52,46,0,102,117,110,99,116,105,111,110,32,39,99,118,83,116,97,114,116,87,114,105,116,101,83,116,114,117,99,116,39,32,99,97,108,108,115,32,99,97,110,110,111,116,32,98,101,32,110,101,115,116,101,100,32,105,102,32,117,115,105,110,103,32,66,97,115,101,54,52,46,0,65,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,111,117,116,112,117,116,32,66,97,115,101,54,52,44,32,96,99,118,69,110,100,87,114,105,116,101,83,116,114,117,99,116,96,32,105,115,32,110,101,101,100,101,100,46,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,109,97,116,114,105,120,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,77,97,116,78,68,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,116,104,101,32,109,97,116,114,105,120,32,100,105,109,101,110,115,105,111,110,97,108,105,116,121,0,84,104,101,32,109,97,116,114,105,120,32,100,97,116,97,32,105,115,32,110,111,116,32,102,111,117,110,100,32,105,110,32,102,105,108,101,32,115,116,111,114,97,103,101,0,84,104,101,32,109,97,116,114,105,120,32,115,105,122,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,111,114,101,100,32,101,108,101,109,101,110,116,115,0,84,111,111,32,99,111,109,112,108,101,120,32,102,111,114,109,97,116,32,102,111,114,32,116,104,101,32,109,97,116,114,105,120,0,105,99,118,68,101,99,111,100,101,83,105,109,112,108,101,70,111,114,109,97,116,0,78,117,108,108,32,112,111,105,110,116,101,114,115,32,116,111,32,115,111,117,114,99,101,32,102,105,108,101,32,110,111,100,101,32,111,114,32,100,101,115,116,105,110,97,116,105,111,110,32,97,114,114,97,121,0,99,118,82,101,97,100,82,97,119,68,97,116,97,0,99,118,82,101,97,100,82,97,119,68,97,116,97,83,108,105,99,101,0,78,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,114,101,97,100,101,114,32,111,114,32,100,101,115,116,105,110,97,116,105,111,110,32,97,114,114,97,121,0,84,104,101,32,114,101,97,100,101,100,32,115,101,113,117,101,110,99,101,32,105,115,32,97,32,115,99,97,108,97,114,44,32,116,104,117,115,32,108,101,110,32,109,117,115,116,32,98,101,32,49,0,84,104,101,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,105,115,32,110,111,116,32,97,32,110,117,109,101,114,105,99,97,108,32,115,99,97,108,97,114,0,84,104,101,32,115,101,113,117,101,110,99,101,32,115,108,105,99,101,32,100,111,101,115,32,110,111,116,32,102,105,116,32,97,110,32,105,110,116,101,103,101,114,32,110,117,109,98,101,114,32,111,102,32,114,101,99,111,114,100,115,0,99,118,83,116,97,114,116,82,101,97,100,82,97,119,68,97,116,97,0,78,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,115,111,117,114,99,101,32,102,105,108,101,32,110,111,100,101,32,111,114,32,114,101,97,100,101,114,0,84,104,101,32,102,105,108,101,32,110,111,100,101,32,115,104,111,117,108,100,32,98,101,32,97,32,110,117,109,101,114,105,99,97,108,32,115,99,97,108,97,114,32,111,114,32,97,32,115,101,113,117,101,110,99,101,0,99,118,71,101,116,70,105,108,101,78,111,100,101,66,121,78,97,109,101,0,78,117,108,108,32,101,108,101,109,101,110,116,32,110,97,109,101,0,114,111,119,115,0,99,111,108,115,0,99,118,87,114,105,116,101,73,110,116,0,105,99,118,82,101,97,100,77,97,116,0,73,109,97,103,101,115,32,119,105,116,104,32,112,108,97,110,97,114,32,100,97,116,97,32,108,97,121,111,117,116,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,105,99,118,87,114,105,116,101,73,109,97,103,101,0,116,111,112,45,108,101,102,116,0,98,111,116,116,111,109,45,108,101,102,116,0,111,114,105,103,105,110,0,112,108,97,110,97,114,0,105,110,116,101,114,108,101,97,118,101,100,0,108,97,121,111,117,116,0,114,111,105,0,121,0,99,111,105,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,105,109,97,103,101,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,73,109,97,103,101,0,79,110,108,121,32,105,110,116,101,114,108,101,97,118,101,100,32,105,109,97,103,101,115,32,99,97,110,32,98,101,32,114,101,97,100,0,84,104,101,32,105,109,97,103,101,32,100,97,116,97,32,105,115,32,110,111,116,32,102,111,117,110,100,32,105,110,32,102,105,108,101,32,115,116,111,114,97,103,101,0,105,99,118,82,101,97,100,83,112,97,114,115,101,77,97,116,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,112,97,114,115,101,32,109,97,116,114,105,120,32,100,105,109,101,110,115,105,111,110,97,108,105,116,121,0,83,112,97,114,115,101,32,109,97,116,114,105,120,32,100,97,116,97,32,105,115,32,99,111,114,114,117,112,116,101,100,0,111,114,105,101,110,116,101,100,0,102,108,97,103,115,0,118,101,114,116,101,120,95,99,111,117,110,116,0,118,101,114,116,101,120,95,100,116,0,101,100,103,101,95,99,111,117,110,116,0,101,100,103,101,95,100,116,0,50,105,102,37,115,0,118,101,114,116,105,99,101,115,0,101,100,103,101,115,0,104,101,97,100,101,114,95,100,116,0,84,104,101,32,115,105,122,101,32,111,102,32,104,101,97,100,101,114,32,99,97,108,99,117,108,97,116,101,100,32,102,114,111,109,32,34,104,101,97,100,101,114,95,100,116,34,32,105,115,32,103,114,101,97,116,101,114,32,116,104,97,110,32,104,101,97,100,101,114,95,115,105,122,101,0,105,99,118,87,114,105,116,101,72,101,97,100,101,114,68,97,116,97,0,99,111,108,111,114,0,37,117,105,0,37,117,117,0,104,101,97,100,101,114,95,117,115,101,114,95,100,97,116,97,0,84,104,101,32,115,105,122,101,32,111,102,32,101,108,101,109,101,110,116,32,99,97,108,99,117,108,97,116,101,100,32,102,114,111,109,32,34,100,116,34,32,97,110,100,32,116,104,101,32,101,108,101,109,95,115,105,122,101,32,100,111,32,110,111,116,32,109,97,116,99,104,0,105,99,118,71,101,116,70,111,114,109,97,116,0,83,105,122,101,32,111,102,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,40,101,108,101,109,95,115,105,122,101,41,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,32,119,105,116,104,32,115,101,113,45,62,102,108,97,103,115,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,103,114,97,112,104,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,71,114,97,112,104,0,84,104,101,32,115,101,113,117,101,110,99,101,32,102,108,97,103,115,32,97,114,101,32,105,110,118,97,108,105,100,0,79,110,101,32,111,102,32,34,104,101,97,100,101,114,95,100,116,34,32,97,110,100,32,34,104,101,97,100,101,114,95,117,115,101,114,95,100,97,116,97,34,32,105,115,32,116,104,101,114,101,44,32,119,104,105,108,101,32,116,104,101,32,111,116,104,101,114,32,105,115,32,110,111,116,0,71,114,97,112,104,32,101,100,103,101,115,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,50,32,105,110,116,101,103,101,114,115,32,97,110,100,32,97,32,102,108,111,97,116,0,37,100,102,37,115,0,78,111,32,101,100,103,101,115,32,100,97,116,97,0,78,111,32,118,101,114,116,105,99,101,115,32,100,97,116,97,0,83,111,109,101,32,111,102,32,115,116,111,114,101,100,32,118,101,114,116,101,120,32,105,110,100,105,99,101,115,32,97,114,101,32,111,117,116,32,111,102,32,114,97,110,103,101,0,68,117,112,108,105,99,97,116,101,100,32,101,100,103,101,32,104,97,115,32,111,99,99,117,114,101,100,0,78,85,76,76,32,100,111,117,98,108,101,32,112,111,105,110,116,101,114,0,105,99,118,82,101,108,101,97,115,101,71,114,97,112,104,0,115,101,113,117,101,110,99,101,115,0,111,112,101,110,99,118,45,115,101,113,117,101,110,99,101,45,116,114,101,101,32,105,110,115,116,97,110,99,101,32,115,104,111,117,108,100,32,99,111,110,116,97,105,110,32,97,32,102,105,101,108,100,32,34,115,101,113,117,101,110,99,101,115,34,32,116,104,97,116,32,115,104,111,117,108,100,32,98,101,32,97,32,115,101,113,117,101,110,99,101,0,105,99,118,82,101,97,100,83,101,113,84,114,101,101,0,108,101,118,101,108,0,65,108,108,32,116,104,101,32,115,101,113,117,101,110,99,101,32,116,114,101,101,32,110,111,100,101,115,32,115,104,111,117,108,100,32,99,111,110,116,97,105,110,32,34,108,101,118,101,108,34,32,102,105,101,108,100,0,99,118,82,101,97,100,0,84,104,101,32,110,111,100,101,32,100,111,101,115,32,110,111,116,32,114,101,112,114,101,115,101,110,116,32,97,32,117,115,101,114,32,111,98,106,101,99,116,32,40,117,110,107,110,111,119,110,32,116,121,112,101,63,41,0,73,110,118,97,108,105,100,32,116,121,112,101,32,105,110,102,111,0,99,118,82,101,103,105,115,116,101,114,84,121,112,101,0,83,111,109,101,32,111,102,32,114,101,113,117,105,114,101,100,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,115,32,40,105,115,95,105,110,115,116,97,110,99,101,44,32,114,101,108,101,97,115,101,44,32,114,101,97,100,32,111,114,32,119,114,105,116,101,41,32,97,114,101,32,78,85,76,76,0,84,121,112,101,32,110,97,109,101,32,115,104,111,117,108,100,32,115,116,97,114,116,32,119,105,116,104,32,97,32,108,101,116,116,101,114,32,111,114,32,95,0,84,121,112,101,32,110,97,109,101,32,115,104,111,117,108,100,32,99,111,110,116,97,105,110,32,111,110,108,121,32,108,101,116,116,101,114,115,44,32,100,105,103,105,116,115,44,32,45,32,97,110,100,32,95,0,114,101,99,117,114,115,105,118,101,0,48,0,70,65,76,83,69,0,32,104,111,108,101,0,32,99,117,114,118,101,0,32,117,110,116,121,112,101,100,0,99,111,117,110,116,0,83,111,109,101,32,111,102,32,101,115,115,101,110,116,105,97,108,32,115,101,113,117,101,110,99,101,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,97,98,115,101,110,116,0,105,99,118,82,101,97,100,83,101,113,0,99,117,114,118,101,0,99,108,111,115,101,100,0,104,111,108,101,0,117,110,116,121,112,101,100,0,79,110,108,121,32,111,110,101,32,111,102,32,34,104,101,97,100,101,114,95,117,115,101,114,95,100,97,116,97,34,44,32,34,114,101,99,116,34,32,97,110,100,32,34,111,114,105,103,105,110,34,32,116,97,103,115,32,109,97,121,32,111,99,99,117,114,0,84,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,111,114,101,100,32,101,108,101,109,101,110,116,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,111,32,34,99,111,117,110,116,34,0,105,99,118,82,101,108,101,97,115,101,83,101,113,0,46,103,122,0,73,110,118,97,108,105,100,32,102,105,108,101,110,97,109,101,0,103,101,116,68,101,102,97,117,108,116,79,98,106,101,99,116,78,97,109,101,0,99,118,71,101,116,82,111,111,116,70,105,108,101,78,111,100,101,0,99,118,87,114,105,116,101,82,101,97,108,0,99,118,87,114,105,116,101,67,111,109,109,101,110,116,0,99,118,82,101,108,101,97,115,101,0,85,110,107,110,111,119,110,32,111,98,106,101,99,116,32,116,121,112,101,0,114,101,108,101,97,115,101,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,99,118,87,114,105,116,101,0,78,117,108,108,32,112,111,105,110,116,101,114,32,116,111,32,116,104,101,32,119,114,105,116,116,101,110,32,111,98,106,101,99,116,0,85,110,107,110,111,119,110,32,111,98,106,101,99,116,0,84,104,101,32,111,98,106,101,99,116,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,119,114,105,116,101,32,102,117,110,99,116,105,111,110,0,110,111,100,101,32,33,61,32,48,76,0,99,118,76,111,97,100,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,116,104,101,47,97,110,32,111,98,106,101,99,116,32,105,110,32,102,105,108,101,32,115,116,111,114,97,103,101,0,78,85,76,76,32,109,101,109,111,114,121,32,115,116,111,114,97,103,101,32,105,115,32,112,97,115,115,101,100,32,45,32,116,104,101,32,108,111,97,100,101,100,32,100,121,110,97,109,105,99,32,115,116,114,117,99,116,117,114,101,32,99,97,110,32,110,111,116,32,98,101,32,115,116,111,114,101,100,0,69,120,116,114,97,32,99,108,111,115,105,110,103,32,39,37,99,39,0,84,104,101,32,99,108,111,115,105,110,103,32,39,37,99,39,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,111,112,101,110,105,110,103,32,39,37,99,39,0,73,110,99,111,114,114,101,99,116,32,101,108,101,109,101,110,116,32,110,97,109,101,32,37,115,0,73,110,118,97,108,105,100,32,102,115,46,115,116,97,116,101,0,108,101,110,32,37,32,101,108,101,109,83,105,122,101,32,61,61,32,48,0,119,114,105,116,101,82,97,119,0,101,108,101,109,95,115,105,122,101,32,62,32,48,0,114,101,97,100,82,97,119,0,105,99,118,73,110,105,116,77,101,109,83,116,111,114,97,103,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,100,97,116,97,115,116,114,117,99,116,115,46,99,112,112,0,99,118,67,114,101,97,116,101,67,104,105,108,100,77,101,109,83,116,111,114,97,103,101,0,99,118,82,101,108,101,97,115,101,77,101,109,83,116,111,114,97,103,101,0,99,118,67,108,101,97,114,77,101,109,83,116,111,114,97,103,101,0,99,118,83,97,118,101,77,101,109,83,116,111,114,97,103,101,80,111,115,0,99,118,82,101,115,116,111,114,101,77,101,109,83,116,111,114,97,103,101,80,111,115,0,99,118,77,101,109,83,116,111,114,97,103,101,65,108,108,111,99,0,84,111,111,32,108,97,114,103,101,32,109,101,109,111,114,121,32,98,108,111,99,107,32,105,115,32,114,101,113,117,101,115,116,101,100,0,114,101,113,117,101,115,116,101,100,32,115,105,122,101,32,105,115,32,110,101,103,97,116,105,118,101,32,111,114,32,116,111,111,32,98,105,103,0,105,99,118,71,111,78,101,120,116,77,101,109,66,108,111,99,107,0,99,118,67,114,101,97,116,101,83,101,113,0,83,112,101,99,105,102,105,101,100,32,101,108,101,109,101,110,116,32,115,105,122,101,32,100,111,101,115,110,39,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,115,105,122,101,32,111,102,32,116,104,101,32,115,112,101,99,105,102,105,101,100,32,101,108,101,109,101,110,116,32,116,121,112,101,32,40,116,114,121,32,116,111,32,117,115,101,32,48,32,102,111,114,32,101,108,101,109,101,110,116,32,116,121,112,101,41,0,99,118,83,101,116,83,101,113,66,108,111,99,107,83,105,122,101,0,83,116,111,114,97,103,101,32,98,108,111,99,107,32,115,105,122,101,32,105,115,32,116,111,111,32,115,109,97,108,108,32,116,111,32,102,105,116,32,116,104,101,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,115,0,0,1,255,2,255,255,255,3,255,255,255,255,255,255,255,4,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,5,99,118,67,118,116,83,101,113,84,111,65,114,114,97,121,0,99,118,83,101,116,83,101,113,82,101,97,100,101,114,80,111,115,0,99,118,83,116,97,114,116,82,101,97,100,83,101,113,0,99,118,77,97,107,101,83,101,113,72,101,97,100,101,114,70,111,114,65,114,114,97,121,0,69,108,101,109,101,110,116,32,115,105,122,101,32,100,111,101,115,110,39,116,32,109,97,116,99,104,32,116,111,32,116,104,101,32,115,105,122,101,32,111,102,32,112,114,101,100,101,102,105,110,101,100,32,101,108,101,109,101,110,116,32,116,121,112,101,32,40,116,114,121,32,116,111,32,117,115,101,32,48,32,102,111,114,32,115,101,113,117,101,110,99,101,32,101,108,101,109,101,110,116,32,116,121,112,101,41,0,99,118,83,116,97,114,116,65,112,112,101,110,100,84,111,83,101,113,0,99,118,83,116,97,114,116,87,114,105,116,101,83,101,113,0,99,118,70,108,117,115,104,83,101,113,87,114,105,116,101,114,0,99,118,69,110,100,87,114,105,116,101,83,101,113,0,99,118,67,114,101,97,116,101,83,101,113,66,108,111,99,107,0,105,99,118,71,114,111,119,83,101,113,0,84,104,101,32,115,101,113,117,101,110,99,101,32,104,97,115,32,78,85,76,76,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,99,118,67,104,97,110,103,101,83,101,113,66,108,111,99,107,0,99,118,71,101,116,83,101,113,82,101,97,100,101,114,80,111,115,0,99,118,83,101,113,80,117,115,104,0,99,118,83,101,113,80,111,112,0,78,85,76,76,32,115,101,113,117,101,110,99,101,32,112,111,105,110,116,101,114,0,99,118,83,101,113,80,117,115,104,77,117,108,116,105,0,110,117,109,98,101,114,32,111,102,32,114,101,109,111,118,101,100,32,101,108,101,109,101,110,116,115,32,105,115,32,110,101,103,97,116,105,118,101,0,99,118,83,101,113,80,111,112,77,117,108,116,105,0,99,118,67,108,101,97,114,83,101,113,0,73,110,118,97,108,105,100,32,115,101,113,117,101,110,99,101,32,104,101,97,100,101,114,0,99,118,83,101,113,83,108,105,99,101,0,66,97,100,32,115,101,113,117,101,110,99,101,32,115,108,105,99,101,0,66,97,100,32,105,110,112,117,116,32,115,101,113,117,101,110,99,101,0,99,118,83,101,113,83,111,114,116,0,78,117,108,108,32,99,111,109,112,97,114,101,32,102,117,110,99,116,105,111,110,0,99,118,67,114,101,97,116,101,83,101,116,0,99,118,83,101,116,65,100,100,0,99,118,67,114,101,97,116,101,71,114,97,112,104,0,99,118,71,114,97,112,104,65,100,100,86,116,120,0,99,118,70,105,110,100,71,114,97,112,104,69,100,103,101,66,121,80,116,114,0,103,114,97,112,104,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,99,118,71,114,97,112,104,65,100,100,69,100,103,101,66,121,80,116,114,0,118,101,114,116,101,120,32,112,111,105,110,116,101,114,115,32,99,111,105,110,115,105,100,101,32,40,111,114,32,115,101,116,32,116,111,32,78,85,76,76,41,0,73,110,118,97,108,105,100,32,103,114,97,112,104,32,112,111,105,110,116,101,114,0,99,118,67,108,111,110,101,71,114,97,112,104,0,99,118,84,114,101,101,84,111,78,111,100,101,83,101,113,0,99,118,73,110,105,116,84,114,101,101,78,111,100,101,73,116,101,114,97,116,111,114,0,78,85,76,76,32,105,116,101,114,97,116,111,114,32,112,111,105,110,116,101,114,0,99,118,78,101,120,116,84,114,101,101,78,111,100,101,0,99,118,73,110,115,101,114,116,78,111,100,101,73,110,116,111,84,114,101,101,0,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,0,103,101,109,109,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,109,117,108,46,99,112,112,0,118,111,105,100,32,99,118,58,58,103,101,109,109,73,109,112,108,40,99,118,58,58,77,97,116,44,32,99,118,58,58,77,97,116,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,44,32,100,111,117,98,108,101,44,32,99,118,58,58,77,97,116,44,32,105,110,116,41,0,116,121,112,101,32,61,61,32,66,46,116,121,112,101,40,41,0,103,101,109,109,0,40,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,116,121,112,101,32,61,61,32,40,40,40,54,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,41,0,97,95,115,105,122,101,46,119,105,100,116,104,32,61,61,32,108,101,110,0,97,95,115,105,122,101,46,104,101,105,103,104,116,32,61,61,32,108,101,110,0,67,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,0,40,40,40,102,108,97,103,115,38,71,69,77,77,95,51,95,84,41,32,61,61,32,48,32,38,38,32,67,46,114,111,119,115,32,61,61,32,100,95,115,105,122,101,46,104,101,105,103,104,116,32,38,38,32,67,46,99,111,108,115,32,61,61,32,100,95,115,105,122,101,46,119,105,100,116,104,41,32,124,124,32,40,40,102,108,97,103,115,38,71,69,77,77,95,51,95,84,41,32,33,61,32,48,32,38,38,32,67,46,114,111,119,115,32,61,61,32,100,95,115,105,122,101,46,119,105,100,116,104,32,38,38,32,67,46,99,111,108,115,32,61,61,32,100,95,115,105,122,101,46,104,101,105,103,104,116,41,41,0,115,99,110,32,61,61,32,109,46,99,111,108,115,32,124,124,32,115,99,110,32,43,32,49,32,61,61,32,109,46,99,111,108,115,0,116,114,97,110,115,102,111,114,109,0,118,111,105,100,32,99,118,58,58,116,114,97,110,115,102,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,115,99,110,32,43,32,49,32,61,61,32,109,46,99,111,108,115,0,112,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,0,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,54,0,118,111,105,100,32,99,118,58,58,112,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,116,121,112,101,32,61,61,32,95,115,114,99,50,46,116,121,112,101,40,41,0,115,99,97,108,101,65,100,100,0,115,114,99,49,46,115,105,122,101,32,61,61,32,115,114,99,50,46,115,105,122,101,0,118,111,105,100,32,99,118,58,58,115,99,97,108,101,65,100,100,40,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,109,117,108,84,114,97,110,115,112,111,115,101,100,0,100,101,108,116,97,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,40,100,101,108,116,97,46,114,111,119,115,32,61,61,32,115,114,99,46,114,111,119,115,32,124,124,32,100,101,108,116,97,46,114,111,119,115,32,61,61,32,49,41,0,40,100,101,108,116,97,46,99,111,108,115,32,61,61,32,115,114,99,46,99,111,108,115,32,124,124,32,100,101,108,116,97,46,99,111,108,115,32,61,61,32,49,41,0,118,111,105,100,32,99,118,58,58,109,117,108,84,114,97,110,115,112,111,115,101,100,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,98,111,111,108,44,32,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,109,97,116,46,116,121,112,101,40,41,32,61,61,32,116,121,112,101,40,41,0,100,111,116,0,109,97,116,46,115,105,122,101,32,61,61,32,115,105,122,101,0,100,111,117,98,108,101,32,99,118,58,58,77,97,116,58,58,100,111,116,40,73,110,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,0,109,121,95,111,98,106,101,99,116,0,118,105,114,116,117,97,108,32,99,118,58,58,83,116,114,105,110,103,32,99,118,58,58,65,108,103,111,114,105,116,104,109,58,58,103,101,116,68,101,102,97,117,108,116,78,97,109,101,40,41,32,99,111,110,115,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,97,108,103,111,114,105,116,104,109,46,99,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,65,108,103,111,114,105,116,104,109,58,58,115,97,118,101,40,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,99,118,58,58,65,108,103,111,114,105,116,104,109,58,58,126,65,108,103,111,114,105,116,104,109,40,41,0,78,50,99,118,57,65,108,103,111,114,105,116,104,109,69,0,99,118,58,58,65,108,103,111,114,105,116,104,109,58,58,65,108,103,111,114,105,116,104,109,40,41,0,102,111,114,109,97,116,0,118,111,105,100,32,99,118,58,58,65,108,103,111,114,105,116,104,109,58,58,119,114,105,116,101,70,111,114,109,97,116,40,99,118,58,58,70,105,108,101,83,116,111,114,97,103,101,32,38,41,32,99,111,110,115,116,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,102,97,115,116,65,116,97,110,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,44,32,98,111,111,108,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,104,102,117,110,99,115,95,99,111,114,101,46,115,105,109,100,46,104,112,112,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,102,97,115,116,65,116,97,110,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,44,32,98,111,111,108,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,109,97,103,110,105,116,117,100,101,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,109,97,103,110,105,116,117,100,101,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,105,110,118,83,113,114,116,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,105,110,118,83,113,114,116,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,115,113,114,116,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,115,113,114,116,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,101,120,112,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,101,120,112,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,108,111,103,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,112,117,95,98,97,115,101,108,105,110,101,58,58,108,111,103,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,102,97,115,116,65,116,97,110,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,44,32,98,111,111,108,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,104,102,117,110,99,115,95,99,111,114,101,46,100,105,115,112,97,116,99,104,46,99,112,112,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,102,97,115,116,65,116,97,110,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,44,32,98,111,111,108,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,109,97,103,110,105,116,117,100,101,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+204862);allocate([0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,109,97,103,110,105,116,117,100,101,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,105,110,118,83,113,114,116,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,105,110,118,83,113,114,116,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,115,113,114,116,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,115,113,114,116,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,101,120,112,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,101,120,112,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,108,111,103,51,50,102,40,99,111,110,115,116,32,102,108,111,97,116,32,42,44,32,102,108,111,97,116,32,42,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,108,111,103,54,52,102,40,99,111,110,115,116,32,100,111,117,98,108,101,32,42,44,32,100,111,117,98,108,101,32,42,44,32,105,110,116,41,0,84,104,101,32,108,105,98,114,97,114,121,32,105,115,32,99,111,109,112,105,108,101,100,32,119,105,116,104,111,117,116,32,67,85,68,65,32,115,117,112,112,111,114,116,0,116,104,114,111,119,95,110,111,95,99,117,100,97,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,112,114,105,118,97,116,101,46,99,117,100,97,46,104,112,112,0,105,110,116,32,99,118,58,58,104,97,108,58,58,76,85,51,50,102,40,102,108,111,97,116,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,102,108,111,97,116,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,115,114,99,47,109,97,116,114,105,120,95,100,101,99,111,109,112,46,99,112,112,0,105,110,116,32,99,118,58,58,104,97,108,58,58,76,85,54,52,102,40,100,111,117,98,108,101,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,100,111,117,98,108,101,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,41,0,98,111,111,108,32,99,118,58,58,104,97,108,58,58,67,104,111,108,101,115,107,121,51,50,102,40,102,108,111,97,116,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,102,108,111,97,116,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,41,0,98,111,111,108,32,99,118,58,58,104,97,108,58,58,67,104,111,108,101,115,107,121,54,52,102,40,100,111,117,98,108,101,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,100,111,117,98,108,101,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,41,0,105,110,116,32,99,118,58,58,104,97,108,58,58,81,82,51,50,102,40,102,108,111,97,116,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,102,108,111,97,116,32,42,44,32,115,105,122,101,95,116,44,32,102,108,111,97,116,32,42,41,0,105,110,116,32,99,118,58,58,104,97,108,58,58,81,82,54,52,102,40,100,111,117,98,108,101,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,32,42,44,32,115,105,122,101,95,116,44,32,100,111,117,98,108,101,32,42,41,0,95,112,111,105,110,116,115,46,103,101,116,79,98,106,40,41,32,33,61,32,95,104,117,108,108,46,103,101,116,79,98,106,40,41,0,99,111,110,118,101,120,72,117,108,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,118,104,117,108,108,46,99,112,112,0,116,111,116,97,108,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,52,41,0,112,111,105,110,116,115,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,118,111,105,100,32,99,118,58,58,99,111,110,118,101,120,72,117,108,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,98,111,111,108,44,32,98,111,111,108,41,0,110,112,111,105,110,116,115,32,62,61,32,48,0,99,111,110,118,101,120,105,116,121,68,101,102,101,99,116,115,0,104,112,111,105,110,116,115,32,62,32,48,0,48,32,60,61,32,104,99,117,114,114,32,38,38,32,104,99,117,114,114,32,60,32,110,112,111,105,110,116,115,0,48,32,60,61,32,104,110,101,120,116,32,38,38,32,104,110,101,120,116,32,60,32,110,112,111,105,110,116,115,0,118,111,105,100,32,99,118,58,58,99,111,110,118,101,120,105,116,121,68,101,102,101,99,116,115,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,105,115,67,111,110,116,111,117,114,67,111,110,118,101,120,0,109,49,116,121,112,101,32,61,61,32,40,40,40,51,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,109,49,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,109,49,116,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,0,105,110,105,116,85,110,100,105,115,116,111,114,116,82,101,99,116,105,102,121,77,97,112,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,117,110,100,105,115,116,111,114,116,46,99,112,112,0,65,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,51,44,51,41,32,38,38,32,65,46,115,105,122,101,40,41,32,61,61,32,82,46,115,105,122,101,40,41,0,65,114,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,51,44,51,41,32,124,124,32,65,114,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,52,44,32,51,41,0,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,52,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,52,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,53,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,53,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,56,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,56,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,49,50,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,50,44,32,49,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,44,32,49,52,41,32,124,124,32,100,105,115,116,67,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,83,105,122,101,40,49,52,44,32,49,41,0,109,49,32,33,61,32,48,76,32,38,38,32,109,50,32,33,61,32,48,76,0,109,49,102,32,33,61,32,48,76,32,38,38,32,109,50,102,32,33,61,32,48,76,0,100,115,116,46,100,97,116,97,32,33,61,32,115,114,99,46,100,97,116,97,0,117,110,100,105,115,116,111,114,116,0,118,111,105,100,32,99,118,58,58,117,110,100,105,115,116,111,114,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,82,71,66,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,82,71,66,60,102,108,111,97,116,62,93,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,108,111,114,46,99,112,112,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,82,71,66,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,82,71,66,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,82,71,66,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,82,71,66,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,55,82,71,66,50,82,71,66,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,82,71,66,53,120,53,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,82,71,66,53,120,53,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,50,82,71,66,53,120,53,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,66,71,82,53,120,53,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,53,120,53,50,82,71,66,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,53,120,53,50,82,71,66,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,53,120,53,50,82,71,66,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,53,120,53,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,71,114,97,121,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,71,114,97,121,60,102,108,111,97,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,71,114,97,121,60,117,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,71,114,97,121,60,117,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,71,114,97,121,60,117,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,71,114,97,121,60,117,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,82,71,66,50,71,114,97,121,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,71,114,97,121,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,71,114,97,121,50,82,71,66,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,71,114,97,121,50,82,71,66,60,102,108,111,97,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,71,114,97,121,50,82,71,66,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,71,114,97,121,50,82,71,66,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,71,114,97,121,50,82,71,66,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,71,114,97,121,50,82,71,66,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,56,71,114,97,121,50,82,71,66,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,71,114,97,121,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,53,120,53,50,71,114,97,121,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,53,120,53,50,71,114,97,121,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,53,120,53,50,71,114,97,121,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,53,120,53,116,111,71,114,97,121,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,71,114,97,121,50,82,71,66,53,120,53,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,71,114,97,121,50,82,71,66,53,120,53,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,71,114,97,121,50,82,71,66,53,120,53,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,71,114,97,121,116,111,66,71,82,53,120,53,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,89,67,114,67,98,95,102,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,89,67,114,67,98,95,102,60,102,108,111,97,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,102,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,89,67,114,67,98,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,89,67,114,67,98,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,105,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,89,67,114,67,98,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,89,67,114,67,98,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,82,71,66,50,89,67,114,67,98,95,105,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,89,85,86,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,89,67,114,67,98,50,82,71,66,95,102,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,89,67,114,67,98,50,82,71,66,95,102,60,102,108,111,97,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,102,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,89,67,114,67,98,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,89,67,114,67,98,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,105,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,89,67,114,67,98,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,89,67,114,67,98,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,49,89,67,114,67,98,50,82,71,66,95,105,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,89,85,86,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,88,89,90,95,102,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,88,89,90,95,102,60,102,108,111,97,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,102,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,88,89,90,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,88,89,90,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,105,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,88,89,90,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,88,89,90,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,88,89,90,95,105,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,88,89,90,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,88,89,90,50,82,71,66,95,102,60,102,108,111,97,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,88,89,90,50,82,71,66,95,102,60,102,108,111,97,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,102,73,102,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,88,89,90,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,88,89,90,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,105,73,116,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,88,89,90,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,88,89,90,50,82,71,66,95,105,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,88,89,90,50,82,71,66,95,105,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,88,89,90,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,41,0,104,114,97,110,103,101,32,61,61,32,49,56,48,32,124,124,32,104,114,97,110,103,101,32,61,61,32,50,53,54,0,82,71,66,50,72,83,86,95,98,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,72,76,83,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,72,76,83,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,76,83,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,72,76,83,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,72,76,83,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,76,83,95,98,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,72,83,86,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,72,83,86,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,83,86,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,72,83,86,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,72,83,86,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,72,83,86,95,98,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,72,83,86,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,98,111,111,108,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,72,76,83,50,82,71,66,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,72,76,83,50,82,71,66,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,76,83,50,82,71,66,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,72,76,83,50,82,71,66,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,72,76,83,50,82,71,66,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,76,83,50,82,71,66,95,98,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,72,83,86,50,82,71,66,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,72,83,86,50,82,71,66,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,83,86,50,82,71,66,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,72,83,86,50,82,71,66,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,72,83,86,50,82,71,66,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,72,83,86,50,82,71,66,95,98,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,72,83,86,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,98,111,111,108,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,76,117,118,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,76,117,118,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,117,118,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,76,117,118,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,76,117,118,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,117,118,95,98,69,69,69,0,99,111,101,102,102,115,91,105,42,51,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,62,61,32,48,32,38,38,32,115,111,102,116,102,108,111,97,116,40,99,111,101,102,102,115,91,105,42,51,93,41,32,43,32,115,111,102,116,102,108,111,97,116,40,99,111,101,102,102,115,91,105,42,51,43,49,93,41,32,43,32,115,111,102,116,102,108,111,97,116,40,99,111,101,102,102,115,91,105,42,51,43,50,93,41,32,60,32,115,111,102,116,102,108,111,97,116,40,49,46,53,102,41,0,82,71,66,50,76,117,118,102,108,111,97,116,0,119,104,105,116,101,80,116,91,49,93,32,61,61,32,115,111,102,116,100,111,117,98,108,101,58,58,111,110,101,40,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,76,97,98,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,76,97,98,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,97,98,95,102,69,69,69,0,99,91,48,93,32,62,61,32,48,32,38,38,32,99,91,49,93,32,62,61,32,48,32,38,38,32,99,91,50,93,32,62,61,32,48,32,38,38,32,99,91,48,93,32,43],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+215102);allocate([32,99,91,49,93,32,43,32,99,91,50,93,32,60,32,115,111,102,116,102,108,111,97,116,40,40,105,110,116,41,76,65,66,95,67,66,82,84,95,84,65,66,95,83,73,90,69,41,0,82,71,66,50,76,97,98,95,102,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,50,76,97,98,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,50,76,97,98,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,82,71,66,50,76,97,98,95,98,69,69,69,0,99,111,101,102,102,115,91,105,42,51,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,62,61,32,48,32,38,38,32,99,111,101,102,102,115,91,105,42,51,93,32,43,32,99,111,101,102,102,115,91,105,42,51,43,49,93,32,43,32,99,111,101,102,102,115,91,105,42,51,43,50,93,32,60,32,50,42,40,49,32,60,60,32,120,121,122,95,115,104,105,102,116,41,0,82,71,66,50,76,97,98,95,98,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,76,97,98,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,98,111,111,108,44,32,98,111,111,108,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,76,117,118,50,82,71,66,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,76,117,118,50,82,71,66,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,117,118,50,82,71,66,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,76,117,118,50,82,71,66,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,76,117,118,50,82,71,66,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,117,118,50,82,71,66,95,98,69,69,69,0,76,117,118,50,82,71,66,102,108,111,97,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,76,97,98,50,82,71,66,95,102,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,76,97,98,50,82,71,66,95,102,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,97,98,50,82,71,66,95,102,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,76,97,98,50,82,71,66,95,98,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,76,97,98,50,82,71,66,95,98,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,57,76,97,98,50,82,71,66,95,98,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,76,97,98,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,98,111,111,108,44,32,98,111,111,108,41,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,99,111,108,111,114,32,99,111,110,118,101,114,115,105,111,110,32,99,111,100,101,0,99,118,116,84,119,111,80,108,97,110,101,89,85,86,116,111,66,71,82,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,52,89,85,86,52,50,48,115,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,50,89,85,86,52,50,48,115,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,84,119,111,80,108,97,110,101,89,85,86,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,84,119,111,80,108,97,110,101,89,85,86,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,99,118,116,84,104,114,101,101,80,108,97,110,101,89,85,86,116,111,66,71,82,0,78,50,99,118,50,51,89,85,86,52,50,48,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,48,112,50,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,48,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,48,112,50,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,84,104,114,101,101,80,108,97,110,101,89,85,86,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,78,50,99,118,50,50,82,71,66,56,56,56,116,111,89,85,86,52,50,48,112,73,110,118,111,107,101,114,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,66,71,82,116,111,84,104,114,101,101,80,108,97,110,101,89,85,86,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,99,118,116,79,110,101,80,108,97,110,101,89,85,86,116,111,66,71,82,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,51,89,85,86,52,50,50,116,111,82,71,66,65,56,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,50,69,76,105,48,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,49,69,76,105,48,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,49,69,69,69,0,78,50,99,118,50,49,89,85,86,52,50,50,116,111,82,71,66,56,56,56,73,110,118,111,107,101,114,73,76,105,48,69,76,105,48,69,76,105,48,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,79,110,101,80,108,97,110,101,89,85,86,116,111,66,71,82,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,82,71,66,65,50,109,82,71,66,65,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,82,71,66,65,50,109,82,71,66,65,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,82,71,66,65,50,109,82,71,66,65,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,82,71,66,65,116,111,77,117,108,116,105,112,108,105,101,100,82,71,66,65,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,60,99,118,58,58,109,82,71,66,65,50,82,71,66,65,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,32,62,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,32,91,67,118,116,32,61,32,99,118,58,58,109,82,71,66,65,50,82,71,66,65,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,93,0,78,50,99,118,50,48,67,118,116,67,111,108,111,114,76,111,111,112,95,73,110,118,111,107,101,114,73,78,83,95,49,48,109,82,71,66,65,50,82,71,66,65,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,99,118,116,77,117,108,116,105,112,108,105,101,100,82,71,66,65,116,111,82,71,66,65,40,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,41,0,100,101,112,116,104,32,61,61,32,48,32,124,124,32,100,101,112,116,104,32,61,61,32,50,32,124,124,32,100,101,112,116,104,32,61,61,32,53,0,99,118,116,67,111,108,111,114,0,115,99,110,32,61,61,32,51,32,124,124,32,115,99,110,32,61,61,32,52,0,40,115,99,110,32,61,61,32,51,32,124,124,32,115,99,110,32,61,61,32,52,41,32,38,38,32,100,101,112,116,104,32,61,61,32,48,0,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,32,38,38,32,115,99,110,32,61,61,32,50,32,38,38,32,100,101,112,116,104,32,61,61,32,48,0,115,99,110,32,61,61,32,50,32,38,38,32,100,101,112,116,104,32,61,61,32,48,0,115,99,110,32,61,61,32,49,32,38,38,32,100,101,112,116,104,32,61,61,32,48,0,115,99,110,32,61,61,32,51,32,38,38,32,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,0,40,115,99,110,32,61,61,32,51,32,124,124,32,115,99,110,32,61,61,32,52,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,48,32,124,124,32,100,101,112,116,104,32,61,61,32,53,41,0,115,99,110,32,61,61,32,51,32,38,38,32,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,32,38,38,32,40,100,101,112,116,104,32,61,61,32,48,32,124,124,32,100,101,112,116,104,32,61,61,32,53,41,0,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,0,115,122,46,119,105,100,116,104,32,37,32,50,32,61,61,32,48,32,38,38,32,115,122,46,104,101,105,103,104,116,32,37,32,51,32,61,61,32,48,32,38,38,32,100,101,112,116,104,32,61,61,32,48,0,115,122,46,119,105,100,116,104,32,37,32,50,32,61,61,32,48,32,38,38,32,115,122,46,104,101,105,103,104,116,32,37,32,50,32,61,61,32,48,0,115,99,110,32,61,61,32,52,32,38,38,32,100,99,110,32,61,61,32,52,32,38,38,32,100,101,112,116,104,32,61,61,32,48,0,118,111,105,100,32,99,118,58,58,99,118,116,67,111,108,111,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,41,0,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,100,115,116,46,100,101,112,116,104,40,41,0,99,118,67,118,116,67,111,108,111,114,0,100,115,116,46,100,97,116,97,32,61,61,32,100,115,116,48,46,100,97,116,97,0,98,111,114,100,101,114,84,121,112,101,32,33,61,32,66,79,82,68,69,82,95,67,79,78,83,84,65,78,84,0,112,121,114,68,111,119,110,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,112,121,114,97,109,105,100,115,46,99,112,112,0,33,95,115,114,99,46,101,109,112,116,121,40,41,0,112,121,114,68,111,119,110,95,0,115,115,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,115,115,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,119,105,100,116,104,42,50,32,45,32,115,115,105,122,101,46,119,105,100,116,104,41,32,60,61,32,50,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,104,101,105,103,104,116,42,50,32,45,32,115,115,105,122,101,46,104,101,105,103,104,116,41,32,60,61,32,50,0,118,111,105,100,32,99,118,58,58,112,121,114,68,111,119,110,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,83,105,122,101,32,38,44,32,105,110,116,41,0,98,111,114,100,101,114,84,121,112,101,32,61,61,32,66,79,82,68,69,82,95,68,69,70,65,85,76,84,0,112,121,114,85,112,0,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,119,105,100,116,104,32,45,32,115,115,105,122,101,46,119,105,100,116,104,42,50,41,32,61,61,32,100,115,105,122,101,46,119,105,100,116,104,32,37,32,50,32,38,38,32,115,116,100,58,58,97,98,115,40,100,115,105,122,101,46,104,101,105,103,104,116,32,45,32,115,115,105,122,101,46,104,101,105,103,104,116,42,50,41,32,61,61,32,100,115,105,122,101,46,104,101,105,103,104,116,32,37,32,50,0,112,121,114,85,112,95,0,118,111,105,100,32,99,118,58,58,112,121,114,85,112,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,83,105,122,101,32,38,44,32,105,110,116,41,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,72,111,117,103,104,76,105,110,101,115,83,68,105,118,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,104,111,117,103,104,46,99,112,112,0,108,105,110,101,115,77,97,120,32,62,32,48,0,72,111,117,103,104,76,105,110,101,115,83,116,97,110,100,97,114,100,0,109,97,120,95,116,104,101,116,97,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,109,105,110,95,116,104,101,116,97,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,76,105,110,101,115,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,105,109,97,103,101,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,72,111,117,103,104,76,105,110,101,115,80,114,111,98,97,98,105,108,105,115,116,105,99,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,76,105,110,101,115,80,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,33,95,105,109,97,103,101,46,101,109,112,116,121,40,41,32,38,38,32,95,105,109,97,103,101,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,38,38,32,40,95,105,109,97,103,101,46,105,115,77,97,116,40,41,32,124,124,32,95,105,109,97,103,101,46,105,115,85,77,97,116,40,41,41,0,72,111,117,103,104,67,105,114,99,108,101,115,0,95,99,105,114,99,108,101,115,46,105,115,77,97,116,40,41,32,124,124,32,95,99,105,114,99,108,101,115,46,105,115,86,101,99,116,111,114,40,41,0,100,112,44,32,109,105,110,95,100,105,115,116,44,32,99,97,110,110,121,95,116,104,114,101,115,104,111,108,100,32,97,110,100,32,97,99,99,95,116,104,114,101,115,104,111,108,100,32,109,117,115,116,32,98,101,32,97,108,108,32,112,111,115,105,116,105,118,101,32,110,117,109,98,101,114,115,0,107,101,114,110,101,108,83,105,122,101,32,61,61,32,45,49,32,124,124,32,107,101,114,110,101,108,83,105,122,101,32,61,61,32,51,32,124,124,32,107,101,114,110,101,108,83,105,122,101,32,61,61,32,53,32,124,124,32,107,101,114,110,101,108,83,105,122,101,32,61,61,32,55,0,72,111,117,103,104,67,105,114,99,108,101,115,71,114,97,100,105,101,110,116,0,85,110,114,101,99,111,103,110,105,122,101,100,32,109,101,116,104,111,100,32,105,100,46,32,65,99,116,117,97,108,108,121,32,111,110,108,121,32,67,86,95,72,79,85,71,72,95,71,82,65,68,73,69,78,84,32,105,115,32,115,117,112,112,111,114,116,101,100,46,0,78,50,99,118,51,50,72,111,117,103,104,67,105,114,99,108,101,69,115,116,105,109,97,116,101,82,97,100,105,117,115,73,110,118,111,107,101,114,69,0,78,50,99,118,51,48,72,111,117,103,104,67,105,114,99,108,101,115,70,105,110,100,67,101,110,116,101,114,115,73,110,118,111,107,101,114,69,0,78,50,99,118,50,52,72,111,117,103,104,67,105,114,99,108,101,115,65,99,99,117,109,73,110,118,111,107,101,114,69,0,118,111,105,100,32,99,118,58,58,72,111,117,103,104,67,105,114,99,108,101,115,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,41,0,103,101,116,83,111,98,101,108,75,101,114,110,101,108,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,101,114,105,118,46,99,112,112,0,84,104,101,32,107,101,114,110,101,108,32,115,105,122,101,32,109,117,115,116,32,98,101,32,111,100,100,32,97,110,100,32,110,111,116,32,108,97,114,103,101,114,32,116,104,97,110,32,51,49,0,100,120,32,62,61,32,48,32,38,38,32,100,121,32,62,61,32,48,32,38,38,32,100,120,43,100,121,32,62,32,48,0,107,115,105,122,101,32,62,32,111,114,100,101,114,0,103,101,116,83,99,104,97,114,114,75,101,114,110,101,108,115,0,100,120,32,62,61,32,48,32,38,38,32,100,121,32,62,61,32,48,32,38,38,32,100,120,43,100,121,32,61,61,32,49,0,118,111,105,100,32,99,118,58,58,83,111,98,101,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,83,99,104,97,114,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,76,97,112,108,97,99,105,97,110,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,113,117,97,108,105,116,121,76,101,118,101,108,32,62,32,48,32,38,38,32,109,105,110,68,105,115,116,97,110,99,101,32,62,61,32,48,32,38,38,32,109,97,120,67,111,114,110,101,114,115,32,62,61,32,48,0,103,111,111,100,70,101,97,116,117,114,101,115,84,111,84,114,97,99,107,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,101,97,116,117,114,101,115,101,108,101,99,116,46,99,112,112,0,95,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,95,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,38,38,32,95,109,97,115,107,46,115,97,109,101,83,105,122,101,40,95,105,109,97,103,101,41,41,0,118,111,105,100,32,99,118,58,58,103,111,111,100,70,101,97,116,117,114,101,115,84,111,84,114,97,99,107,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,44,32,100,111,117,98,108,101,41,0,111,112,101,110,99,118,45,104,105,115,116,0,68,101,115,116,105,110,97,116,105,111,110,32,100,111,117,98,108,101,32,112,111,105,110,116,101,114,32,105,115,32,78,85,76,76,0,99,118,67,111,112,121,72,105,115,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,104,105,115,116,111,103,114,97,109,46,99,112,112,0,73,110,118,97,108,105,100,32,104,105,115,116,111,103,114,97,109,32,104,101,97,100,101,114,91,115,93,0,78,85,76,76,32,114,97,110,103,101,115,32,112,111,105,110,116,101,114,0,99,118,83,101,116,72,105,115,116,66,105,110,82,97,110,103,101,115,0,73,110,118,97,108,105,100,32,104,105,115,116,111,103,114,97,109,32,104,101,97,100,101,114,0,79,110,101,32,111,102,32,60,114,97,110,103,101,115,62,32,101,108,101,109,101,110,116,115,32,105,115,32,78,85,76,76,0,66,105,110,32,114,97,110,103,101,115,32,115,104,111,117,108,100,32,103,111,32,105,110,32,97,115,99,101,110,116,105,110,103,32,111,114,100,101,114,0,78,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,0,99,118,67,114,101,97,116,101,72,105,115,116,0,78,117,108,108,32,60,115,105,122,101,115,62,32,112,111,105,110,116,101,114,0,73,110,118,97,108,105,100,32,104,105,115,116,111,103,114,97,109,32,116,121,112,101,0,105,115,95,117,110,105,102,111,114,109,0,104,97,118,101,95,114,97,110,103,101,115,0,109,97,116,0,98,105,110,115,0,69,120,112,101,99,116,101,100,32,67,118,77,97,116,78,68,0,105,99,118,82,101,97,100,72,105,115,116,0,85,110,107,110,111,119,110,32,72,105,115,116,111,103,114,97,109,32,116,121,112,101,0,39,116,104,114,101,115,104,39,32,110,111,100,101,32,105,115,32,109,105,115,115,105,110,103,0,99,118,82,101,108,101,97,115,101,72,105,115,116,0,100,105,109,115,32,62,32,48,32,38,38,32,104,105,115,116,83,105,122,101,0,99,97,108,99,72,105,115,116,0,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,69,105,116,104,101,114,32,114,97,110,103,101,115,44,32,101,105,116,104,101,114,32,117,110,105,102,111,114,109,32,114,97,110,103,101,115,32,115,104,111,117,108,100,32,98,101,32,112,114,111,118,105,100,101,100,0,99,97,108,99,72,105,115,116,95,0,99,97,108,99,72,105,115,116,76,111,111,107,117,112,84,97,98,108,101,115,95,56,117,0,99,104,97,110,110,101,108,115,32,33,61,32,48,32,124,124,32,110,105,109,97,103,101,115,32,61,61,32,100,105,109,115,0,104,105,115,116,80,114,101,112,97,114,101,73,109,97,103,101,115,0,105,109,97,103,101,115,91,106,93,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,99,32,62,61,32,48,0,106,32,60,32,110,105,109,97,103,101,115,0,105,109,97,103,101,115,91,106,93,46,115,105,122,101,40,41,32,61,61,32,105,109,115,105,122,101,32,38,38,32,105,109,97,103,101,115,91,106,93,46,100,101,112,116,104,40,41,32,61,61,32,100,101,112,116,104,0,109,97,115,107,46,115,105,122,101,40,41,32,61,61,32,105,109,115,105,122,101,32,38,38,32,109,97,115,107,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,114,97,110,103,101,115,91,105,93,32,38,38,32,114,97,110,103,101,115,91,105,93,91,48,93,32,60,32,114,97,110,103,101,115,91,105,93,91,49,93,0,114,97,110,103,101,115,91,105,93,91,107,93,32,60,32,114,97,110,103,101,115,91,105,93,91,107,43,49,93,0,118,111,105,100,32,99,118,58,58,99,97,108,99,72,105,115,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,105,110,116,44,32,99,111,110,115,116,32,105,110,116,32,42,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,99,111,110,115,116,32,105,110,116,32,42,44,32,99,111,110,115,116,32,102,108,111,97,116,32,42,42,44,32,98,111,111,108,44,32,98,111,111,108,41,0,110,105,109,97,103,101,115,32,62,32,48,32,38,38,32,100,105,109,115,32,62,32,48,0,114,115,122,32,61,61,32,100,105,109,115,42,50,32,124,124,32,40,114,115,122,32,61,61,32,48,32,38,38,32,105,109,97,103,101,115,46,100,101,112,116,104,40,48,41,32,61,61,32,48,41,0,99,115,122,32,61,61,32,48,32,124,124,32,99,115,122,32,61,61,32,100,105,109,115,0,118,111,105,100,32,99,118,58,58,99,97,108,99,72,105,115,116,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,102,108,111,97,116,62,32,38,44,32,98,111,111,108,41,0,100,105,109,115,32,62,32,48,32,38,38,32,33,104,105,115,116,46,101,109,112,116,121,40,41,0,99,97,108,99,66,97,99,107,80,114,111,106,101,99,116,0,99,97,108,99,66,97,99,107,80,114,111,106,95,0,118,111,105,100,32,99,118,58,58,99,97,108,99,66,97,99,107,80,114,111,106,101,99,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,42,44,32,105,110,116,44,32,99,111,110,115,116,32,105,110,116,32,42,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,102,108,111,97,116,32,42,42,44,32,100,111,117,98,108,101,44,32,98,111,111,108,41,0,72,48,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,110,105,109,97,103,101,115,32,62,32,48,0,114,115,122,32,61,61,32,100,105,109,115,42,50,32,124,124,32,40,114,115,122,32,61,61,32,50,32,38,38,32,95,49,100,41,32,124,124,32,40,114,115,122,32,61,61,32,48,32,38,38,32,105,109,97,103,101,115,46,100,101,112,116,104,40,48,41,32,61,61,32,48,41,0,99,115,122,32,61,61,32,48,32,124,124,32,99,115,122,32,61,61,32,100,105,109,115,32,124,124,32,40,99,115,122,32,61,61,32,49,32,38,38,32,95,49,100,41,0,118,111,105,100,32,99,118,58,58,99,97,108,99,66,97,99,107,80,114,111,106,101,99,116,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,102,108,111,97,116,62,32,38,44,32,100,111,117,98,108,101,41,0,72,49,46,116,121,112,101,40,41,32,61,61,32,72,50,46,116,121,112,101,40,41,32,38,38,32,72,49,46,100,101,112,116,104,40,41,32,61,61,32,53,0,99,111,109,112,97,114,101,72,105,115,116,0,105,116,46,112,108,97,110,101,115,91,48,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,105,116,46,112,108,97,110,101,115,91,49,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,100,111,117,98,108,101,32,99,118,58,58,99,111,109,112,97,114,101,72,105,115,116,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,101,113,117,97,108,105,122,101,72,105,115,116,0,50,51,69,113,117,97,108,105,122,101,72,105,115,116,76,117,116,95,73,110,118,111,107,101,114,0,50,56,69,113,117,97,108,105,122,101,72,105,115,116,67,97,108,99,72,105,115,116,95,73,110,118,111,107,101,114,0,118,111,105,100,32,99,118,58,58,101,113,117,97,108,105,122,101,72,105,115,116,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,110,112,111,105,110,116,115,50,32,62,61,32,48,32,124,124,32,110,112,111,105,110,116,115,51,32,62,61,32,48,0,102,105,116,76,105,110,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,108,105,110,101,102,105,116,46,99,112,112,0,85,110,107,110,111,119,110,32,100,105,115,116,97,110,99,101,32,116,121,112,101,0,102,105,116,76,105,110,101,50,68,0,85,110,107,110,111,119,110,32,100,105,115,116,97,110,99,101,0,102,105,116,76,105,110,101,51,68,0,118,111,105,100,32,99,118,58,58,102,105,116,76,105,110,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,105,110,116,101,103,114,97,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,117,109,112,105,120,101,108,115,46,99,112,112,0,118,111,105,100,32,99,118,58,58,105,110,116,101,103,114,97,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,105,110,116,101,103,114,97,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,105,110,116,101,103,114,97,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,41,0,115,117,109,46,100,97,116,97,32,61,61,32,115,117,109,48,46,100,97,116,97,32,38,38,32,115,113,115,117,109,46,100,97,116,97,32,61,61,32,115,113,115,117,109,48,46,100,97,116,97,32,38,38,32,116,105,108,116,101,100,46,100,97,116,97,32,61,61,32,116,105,108,116,101,100,48,46,100,97,116,97,0,99,118,73,110,116,101,103,114,97,108,0,97,114,114,32,33,61,32,48,32,38,38,32,99,111,110,116,111,117,114,95,104,101,97,100,101,114,32,33,61,32,48,32,38,38,32,98,108,111,99,107,32,33,61,32,48,0,99,118,80,111,105,110,116,83,101,113,70,114,111,109,77,97,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,117,116,105,108,115,46,99,112,112,0,73,110,112,117,116,32,97,114,114,97,121,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,109,97,116,114,105,120,0,84,104,101,32,109,97,116,114,105,120,32,99,97,110,32,110,111,116,32,98,101,32,99,111,110,118,101,114,116,101,100,32,116,111,32,112,111,105,110,116,32,115,101,113,117,101,110,99,101,32,98,101,99,97,117,115,101,32,111,102,32,105,110,97,112,112,114,111,112,114,105,97,116,101,32,101,108,101,109,101,110,116,32,116,121,112,101,0,84,104,101,32,109,97,116,114,105,120,32,99,111,110,118,101,114,116,101,100,32,116,111,32,112,111,105,110,116,32,115,101,113,117,101,110,99,101,32,109,117,115,116,32,98,101,32,49,45,100,105,109,101,110,115,105,111,110,97,108,32,97,110,100,32,99,111,110,116,105,110,117,111,117,115,0,116,104,101,32,116,121,112,101,32,111,102,32,108,97,98,101,108,115,32,109,117,115,116,32,98,101,32,49,54,117,32,111,114,32,51,50,115,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,46,99,112,112,0,76,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,73,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,95,115,117,98,49,0,99,99,108,116,121,112,101,32,61,61,32,67,67,76,95,71,82,65,78,65,32,124,124,32,99,99,108,116,121,112,101,32,61,61,32,67,67,76,95,87,85,32,124,124,32,99,99,108,116,121,112,101,32,61,61,32,67,67,76,95,68,69,70,65,85,76,84,0,105,68,101,112,116,104,32,61,61,32,48,32,124,124,32,105,68,101,112,116,104,32,61,61,32,49,0,117,110,115,117,112,112,111,114,116,101,100,32,108,97,98,101,108,47,105,109,97,103,101,32,116,121,112,101,0,105,109,103,46,114,111,119,115,32,61,61,32,105,109,103,76,97,98,101,108,115,46,114,111,119,115,0,105,109,103,46,99,111,108,115,32,61,61,32,105,109,103,76,97,98,101,108,115,46,99,111,108,115,0,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,56,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,57,70,105,114,115,116,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+225342);allocate([110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,52,67,111,110,110,101,99,116,105,118,105,116,121,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,52,78,111,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,56,67,111,110,110,101,99,116,105,118,105,116,121,69,0,105,109,103,76,97,98,101,108,115,46,114,111,119,115,32,61,61,32,105,109,103,46,114,111,119,115,0,105,109,103,76,97,98,101,108,115,46,99,111,108,115,32,61,61,32,105,109,103,46,99,111,108,115,0,99,111,110,110,101,99,116,101,100,67,111,109,112,111,110,101,110,116,115,87,105,116,104,83,116,97,116,115,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,50,49,76,97,98,101,108,105,110,103,71,114,97,110,97,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,57,70,105,114,115,116,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,49,48,83,101,99,111,110,100,83,99,97,110,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,52,67,111,110,110,101,99,116,105,118,105,116,121,69,0,78,50,99,118,49,57,99,111,110,110,101,99,116,101,100,99,111,109,112,111,110,101,110,116,115,49,56,76,97,98,101,108,105,110,103,87,117,80,97,114,97,108,108,101,108,73,105,104,78,83,48,95,57,67,67,83,116,97,116,115,79,112,69,69,50,50,70,105,114,115,116,83,99,97,110,56,67,111,110,110,101,99,116,105,118,105,116,121,69,0,40,40,40,40,99,104,97,105,110,41,45,62,102,108,97,103,115,32,38,32,40,40,40,49,32,60,60,32,50,41,32,45,32,49,41,60,60,49,50,41,32,41,32,61,61,32,40,49,32,60,60,32,49,50,41,32,38,38,32,40,99,104,97,105,110,41,45,62,101,108,101,109,95,115,105,122,101,32,61,61,32,49,41,32,38,38,32,40,40,40,99,104,97,105,110,41,45,62,102,108,97,103,115,32,38,32,40,49,32,60,60,32,40,50,32,43,32,49,50,41,41,41,32,33,61,32,48,41,41,0,105,99,118,65,112,112,114,111,120,105,109,97,116,101,67,104,97,105,110,84,67,56,57,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,97,112,112,114,111,120,46,99,112,112,0,104,101,97,100,101,114,95,115,105,122,101,32,62,61,32,40,105,110,116,41,115,105,122,101,111,102,40,67,118,67,111,110,116,111,117,114,41,0,110,112,111,105,110,116,115,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,52,32,124,124,32,100,101,112,116,104,32,61,61,32,53,41,0,97,112,112,114,111,120,80,111,108,121,68,80,0,118,111,105,100,32,99,118,58,58,97,112,112,114,111,120,80,111,108,121,68,80,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,98,111,111,108,41,0,95,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,48,0,67,97,110,110,121,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,97,110,110,121,46,99,112,112,0,40,95,100,115,116,46,103,101,116,79,98,106,40,41,32,33,61,32,95,115,114,99,46,103,101,116,79,98,106,40,41,32,124,124,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,41,32,38,38,32,34,73,110,112,108,97,99,101,32,112,97,114,97,109,101,116,101,114,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,34,0,65,112,101,114,116,117,114,101,32,115,105,122,101,32,115,104,111,117,108,100,32,98,101,32,111,100,100,32,98,101,116,119,101,101,110,32,51,32,97,110,100,32,55,0,78,50,99,118,57,102,105,110,97,108,80,97,115,115,69,0,102,105,110,97,108,80,97,115,115,0,103,108,111,98,97,108,95,104,121,115,116,101,114,101,115,105,115,0,104,121,115,116,101,114,101,115,105,115,0,109,97,103,110,105,116,117,100,101,0,103,114,97,100,105,101,110,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,112,97,114,97,108,108,101,108,67,97,110,110,121,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,0,78,50,99,118,49,51,112,97,114,97,108,108,101,108,67,97,110,110,121,69,0,118,111,105,100,32,99,118,58,58,67,97,110,110,121,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,98,111,111,108,41,0,95,100,120,46,100,105,109,115,40,41,32,61,61,32,50,0,95,100,120,46,116,121,112,101,40,41,32,61,61,32,40,40,40,51,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,95,100,120,46,116,121,112,101,40,41,32,61,61,32,40,40,40,51,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,0,95,100,121,46,116,121,112,101,40,41,32,61,61,32,95,100,120,46,116,121,112,101,40,41,0,95,100,120,46,115,97,109,101,83,105,122,101,40,95,100,121,41,0,118,111,105,100,32,99,118,58,58,67,97,110,110,121,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,98,111,111,108,41,0,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,48,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,48,0,99,118,67,97,110,110,121,0,40,40,40,40,115,117,109,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,61,61,32,40,40,40,40,115,114,99,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,0,103,101,116,82,111,119,83,117,109,70,105,108,116,101,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,109,111,111,116,104,46,99,112,112,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,100,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,100,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,102,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,102,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,115,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,115,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,105,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,105,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,115,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,115,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,116,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,116,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,116,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,116,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,104,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,104,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,104,116,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,104,116,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,54,82,111,119,83,117,109,73,104,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,54,82,111,119,83,117,109,73,104,105,69,69,0,40,40,40,40,115,117,109,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,61,61,32,40,40,40,40,100,115,116,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,0,103,101,116,67,111,108,117,109,110,83,117,109,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,117,109,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,115,117,109,67,111,117,110,116,32,61,61,32,107,115,105,122,101,45,49,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,102,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,102,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,102,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,102,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,105,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,115,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,115,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,115,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,115,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,116,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,116,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,116,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,116,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,100,104,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,100,104,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,116,104,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,116,104,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,67,111,108,117,109,110,83,117,109,73,105,104,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,67,111,108,117,109,110,83,117,109,73,105,104,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,70,105,108,116,101,114,69,110,103,105,110,101,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,118,111,105,100,32,99,118,58,58,98,111,120,70,105,108,116,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,83,105,122,101,44,32,80,111,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,98,108,117,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,83,105,122,101,44,32,80,111,105,110,116,44,32,105,110,116,41,0,103,101,116,83,113,114,82,111,119,83,117,109,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,100,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,100,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,102,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,102,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,115,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,115,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,116,100,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,116,100,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,83,113,114,82,111,119,83,117,109,73,104,105,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,57,83,113,114,82,111,119,83,117,109,73,104,105,69,69,0,118,111,105,100,32,99,118,58,58,115,113,114,66,111,120,70,105,108,116,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,83,105,122,101,44,32,80,111,105,110,116,44,32,98,111,111,108,44,32,105,110,116,41,0,107,116,121,112,101,32,61,61,32,53,32,124,124,32,107,116,121,112,101,32,61,61,32,54,0,103,101,116,71,97,117,115,115,105,97,110,75,101,114,110,101,108,0,107,115,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,107,115,105,122,101,46,119,105,100,116,104,32,37,32,50,32,61,61,32,49,32,38,38,32,107,115,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,107,115,105,122,101,46,104,101,105,103,104,116,32,37,32,50,32,61,61,32,49,0,99,114,101,97,116,101,71,97,117,115,115,105,97,110,75,101,114,110,101,108,115,0,118,111,105,100,32,99,118,58,58,71,97,117,115,115,105,97,110,66,108,117,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,83,105,122,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,40,107,115,105,122,101,32,37,32,50,32,61,61,32,49,41,32,38,38,32,40,95,115,114,99,48,46,100,105,109,115,40,41,32,60,61,32,50,32,41,0,109,101,100,105,97,110,66,108,117,114,0,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,48,32,38,38,32,40,99,110,32,61,61,32,49,32,124,124,32,99,110,32,61,61,32,51,32,124,124,32,99,110,32,61,61,32,52,41,0,99,110,32,62,32,48,32,38,38,32,99,110,32,60,61,32,52,0,109,101,100,105,97,110,66,108,117,114,95,56,117,95,79,109,0,109,101,100,105,97,110,66,108,117,114,95,56,117,95,79,49,0,107,32,60,32,49,54,0,98,32,60,32,49,54,0,118,111,105,100,32,99,118,58,58,109,101,100,105,97,110,66,108,117,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,41,0,40,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,41,32,38,38,32,115,114,99,46,100,97,116,97,32,33,61,32,100,115,116,46,100,97,116,97,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,56,117,0,40,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,41,32,38,38,32,115,114,99,46,100,97,116,97,32,33,61,32,100,115,116,46,100,97,116,97,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,51,50,102,0,66,105,108,97,116,101,114,97,108,32,102,105,108,116,101,114,105,110,103,32,105,115,32,111,110,108,121,32,105,109,112,108,101,109,101,110,116,101,100,32,102,111,114,32,56,117,32,97,110,100,32,51,50,102,32,105,109,97,103,101,115,0,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,0,99,110,32,61,61,32,51,0,78,50,99,118,50,55,66,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,51,50,102,95,73,110,118,111,107,101,114,69,0,78,50,99,118,50,54,66,105,108,97,116,101,114,97,108,70,105,108,116,101,114,95,56,117,95,73,110,118,111,107,101,114,69,0,118,111,105,100,32,99,118,58,58,98,105,108,97,116,101,114,97,108,70,105,108,116,101,114,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,85,110,107,110,111,119,110,32,99,111,109,112,97,114,105,115,111,110,32,109,101,116,104,111,100,0,109,97,116,99,104,83,104,97,112,101,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,97,116,99,104,99,111,110,116,111,117,114,115,46,99,112,112,0,100,111,117,98,108,101,32,99,118,58,58,109,97,116,99,104,83,104,97,112,101,115,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,100,111,117,98,108,101,41,0,78,50,99,118,49,51,66,97,115,101,82,111,119,70,105,108,116,101,114,69,0,78,50,99,118,49,54,66,97,115,101,67,111,108,117,109,110,70,105,108,116,101,114,69,0,78,50,99,118,49,48,66,97,115,101,70,105,108,116,101,114,69,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,115,114,99,84,121,112,101,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,100,115,116,84,121,112,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,105,108,116,101,114,46,99,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,70,105,108,116,101,114,69,110,103,105,110,101,58,58,97,112,112,108,121,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,99,111,110,115,116,32,83,105,122,101,32,38,44,32,99,111,110,115,116,32,80,111,105,110,116,32,38,41,0,119,104,111,108,101,83,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,119,104,111,108,101,83,105,122,101,46,104,101,105,103,104,116,32,62,32,48,0,112,114,111,99,101,101,100,0,115,114,99,32,38,38,32,100,115,116,32,38,38,32,99,111,117,110,116,32,62,32,48,0,115,114,99,89,32,62,61,32,115,116,97,114,116,89,0,100,115,116,89,32,60,61,32,114,111,105,46,104,101,105,103,104,116,0,114,111,105,46,120,32,62,61,32,48,32,38,38,32,114,111,105,46,121,32,62,61,32,48,32,38,38,32,114,111,105,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,114,111,105,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,114,111,105,46,120,32,43,32,114,111,105,46,119,105,100,116,104,32,60,61,32,119,104,111,108,101,83,105,122,101,46,119,105,100,116,104,32,38,38,32,114,111,105,46,121,32,43,32,114,111,105,46,104,101,105,103,104,116,32,60,61,32,119,104,111,108,101,83,105,122,101,46,104,101,105,103,104,116,0,115,116,97,114,116,0,99,111,110,115,116,86,97,108,32,33,61,32,48,76,0,78,50,99,118,49,50,70,105,108,116,101,114,69,110,103,105,110,101,69,0,99,111,108,117,109,110,66,111,114,100,101,114,84,121,112,101,32,33,61,32,66,79,82,68,69,82,95,87,82,65,80,0,105,110,105,116,0,114,111,119,70,105,108,116,101,114,32,38,38,32,99,111,108,117,109,110,70,105,108,116,101,114,0,98,117,102,84,121,112,101,32,61,61,32,115,114,99,84,121,112,101,0,48,32,60,61,32,97,110,99,104,111,114,46,120,32,38,38,32,97,110,99,104,111,114,46,120,32,60,32,107,115,105,122,101,46,119,105,100,116,104,32,38,38,32,48,32,60,61,32,97,110,99,104,111,114,46,121,32,38,38,32,97,110,99,104,111,114,46,121,32,60,32,107,115,105,122,101,46,104,101,105,103,104,116,0,95,107,101,114,110,101,108,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,103,101,116,75,101,114,110,101,108,84,121,112,101,0,99,110,32,61,61,32,40,40,40,40,98,117,102,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,38,38,32,100,100,101,112,116,104,32,62,61,32,115,116,100,58,58,109,97,120,40,115,100,101,112,116,104,44,32,52,41,32,38,38,32,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,100,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,82,111,119,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,111,117,114,99,101,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,98,117,102,102,101,114,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,100,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,68,84,62,58,58,116,121,112,101,32,38,38,32,40,107,101,114,110,101,108,46,114,111,119,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,46,99,111,108,115,32,61,61,32,49,41,0,82,111,119,70,105,108,116,101,114,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,100,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,102,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,115,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,115,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,115,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,115,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,116,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,116,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,116,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,116,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,104,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,100,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,104,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,102,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,56,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,40,115,121,109,109,101,116,114,121,84,121,112,101,32,38,32,40,75,69,82,78,69,76,95,83,89,77,77,69,84,82,73,67,65,76,32,124,32,75,69,82,78,69,76,95,65,83,89,77,77,69,84,82,73,67,65,76,41,41,32,33,61,32,48,32,38,38,32,116,104,105,115,45,62,107,115,105,122,101,32,60,61,32,53,0,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,102,102,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,50,99,118,57,82,111,119,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,56,83,121,109,109,82,111,119,83,109,97,108,108,70,105,108,116,101,114,73,104,105,78,83,95,49,55,83,121,109,109,82,111,119,83,109,97,108,108,78,111,86,101,99,69,69,69,0,99,110,32,61,61,32,40,40,40,40,98,117,102,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,38,38,32,115,100,101,112,116,104,32,62,61,32,115,116,100,58,58,109,97,120,40,100,100,101,112,116,104,44,32,52,41,32,38,38,32,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,115,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,67,111,108,117,109,110,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,98,117,102,102,101,114,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,40,115,121,109,109,101,116,114,121,84,121,112,101,32,38,32,40,75,69,82,78,69,76,95,83,89,77,77,69,84,82,73,67,65,76,32,124,32,75,69,82,78,69,76,95,65,83,89,77,77,69,84,82,73,67,65,76,41,41,32,33,61,32,48,0,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,49],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+235582);allocate([49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,83,84,62,58,58,116,121,112,101,32,38,38,32,40,107,101,114,110,101,108,46,114,111,119,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,46,99,111,108,115,32,61,61,32,49,41,0,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,116,104,105,115,45,62,107,115,105,122,101,32,61,61,32,51,0,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,49,54,83,121,109,109,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,105,115,69,69,78,83,95,50,48,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,50,49,83,121,109,109,67,111,108,117,109,110,83,109,97,108,108,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,100,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,49,51,70,105,120,101,100,80,116,67,97,115,116,69,120,73,105,104,69,69,78,83,95,49,49,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,99,110,32,61,61,32,40,40,40,40,95,100,115,116,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,0,99,114,101,97,116,101,83,101,112,97,114,97,98,108,101,76,105,110,101,97,114,70,105,108,116,101,114,0,107,116,121,112,101,32,61,61,32,48,32,124,124,32,107,116,121,112,101,32,61,61,32,52,32,124,124,32,107,116,121,112,101,32,61,61,32,53,32,124,124,32,107,116,121,112,101,32,61,61,32,54,0,112,114,101,112,114,111,99,101,115,115,50,68,75,101,114,110,101,108,0,99,110,32,61,61,32,40,40,40,40,100,115,116,84,121,112,101,41,32,38,32,40,40,53,49,50,32,45,32,49,41,32,60,60,32,51,41,41,32,62,62,32,51,41,32,43,32,49,41,32,38,38,32,100,100,101,112,116,104,32,62,61,32,115,100,101,112,116,104,0,103,101,116,76,105,110,101,97,114,70,105,108,116,101,114,0,85,110,115,117,112,112,111,114,116,101,100,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,115,111,117,114,99,101,32,102,111,114,109,97,116,32,40,61,37,100,41,44,32,97,110,100,32,100,101,115,116,105,110,97,116,105,111,110,32,102,111,114,109,97,116,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,100,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,95,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,68,97,116,97,84,121,112,101,60,75,84,62,58,58,116,121,112,101,0,70,105,108,116,101,114,50,68,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,100,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,115,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,116,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,56,70,105,108,116,101,114,50,68,73,104,78,83,95,52,67,97,115,116,73,102,104,69,69,78,83,95,49,49,70,105,108,116,101,114,78,111,86,101,99,69,69,69,0,99,114,101,97,116,101,76,105,110,101,97,114,70,105,108,116,101,114,0,118,111,105,100,32,99,118,58,58,102,105,108,116,101,114,50,68,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,107,101,114,110,101,108,88,46,116,121,112,101,40,41,32,61,61,32,107,101,114,110,101,108,89,46,116,121,112,101,40,41,32,38,38,32,40,107,101,114,110,101,108,88,46,99,111,108,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,88,46,114,111,119,115,32,61,61,32,49,41,32,38,38,32,40,107,101,114,110,101,108,89,46,99,111,108,115,32,61,61,32,49,32,124,124,32,107,101,114,110,101,108,89,46,114,111,119,115,32,61,61,32,49,41,0,115,101,112,70,105,108,116,101,114,50,68,0,118,111,105,100,32,99,118,58,58,115,101,112,70,105,108,116,101,114,50,68,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,105,109,103,46,100,105,109,115,32,60,61,32,50,32,38,38,32,116,101,109,112,108,46,100,105,109,115,32,60,61,32,50,32,38,38,32,99,111,114,114,46,100,105,109,115,32,60,61,32,50,0,99,114,111,115,115,67,111,114,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,116,101,109,112,108,109,97,116,99,104,46,99,112,112,0,100,101,112,116,104,32,61,61,32,116,100,101,112,116,104,32,124,124,32,116,100,101,112,116,104,32,61,61,32,53,0,99,111,114,114,115,105,122,101,46,104,101,105,103,104,116,32,60,61,32,105,109,103,46,114,111,119,115,32,43,32,116,101,109,112,108,46,114,111,119,115,32,45,32,49,32,38,38,32,99,111,114,114,115,105,122,101,46,119,105,100,116,104,32,60,61,32,105,109,103,46,99,111,108,115,32,43,32,116,101,109,112,108,46,99,111,108,115,32,45,32,49,0,99,99,110,32,61,61,32,49,32,124,124,32,100,101,108,116,97,32,61,61,32,48,0,116,104,101,32,105,110,112,117,116,32,97,114,114,97,121,115,32,97,114,101,32,116,111,111,32,98,105,103,0,67,86,95,84,77,95,83,81,68,73,70,70,32,60,61,32,109,101,116,104,111,100,32,38,38,32,109,101,116,104,111,100,32,60,61,32,67,86,95,84,77,95,67,67,79,69,70,70,95,78,79,82,77,69,68,0,109,97,116,99,104,84,101,109,112,108,97,116,101,77,97,115,107,0,40,100,101,112,116,104,32,61,61,32,48,32,124,124,32,100,101,112,116,104,32,61,61,32,53,41,32,38,38,32,116,121,112,101,32,61,61,32,95,116,101,109,112,108,46,116,121,112,101,40,41,32,38,38,32,95,105,109,103,46,100,105,109,115,40,41,32,60,61,32,50,0,109,97,116,99,104,84,101,109,112,108,97,116,101,0,95,105,109,103,46,115,105,122,101,40,41,46,104,101,105,103,104,116,32,60,61,32,95,116,101,109,112,108,46,115,105,122,101,40,41,46,104,101,105,103,104,116,32,38,38,32,95,105,109,103,46,115,105,122,101,40,41,46,119,105,100,116,104,32,60,61,32,95,116,101,109,112,108,46,115,105,122,101,40,41,46,119,105,100,116,104,0,115,113,115,117,109,46,100,97,116,97,32,33,61,32,48,76,0,99,111,109,109,111,110,95,109,97,116,99,104,84,101,109,112,108,97,116,101,0,115,117,109,46,100,97,116,97,32,33,61,32,48,76,0,118,111,105,100,32,99,118,58,58,109,97,116,99,104,84,101,109,112,108,97,116,101,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,41,0,95,109,111,100,101,108,32,109,117,115,116,32,104,97,118,101,32,67,86,95,54,52,70,67,49,32,116,121,112,101,44,32,114,111,119,115,32,61,61,32,49,32,97,110,100,32,99,111,108,115,32,61,61,32,49,51,42,99,111,109,112,111,110,101,110,116,115,67,111,117,110,116,0,71,77,77,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,114,97,98,99,117,116,46,99,112,112,0,100,116,114,109,32,62,32,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,100,111,117,98,108,101,62,58,58,101,112,115,105,108,111,110,40,41,0,99,97,108,99,73,110,118,101,114,115,101,67,111,118,65,110,100,68,101,116,101,114,109,0,99,111,118,68,101,116,101,114,109,115,91,99,105,93,32,62,32,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,100,111,117,98,108,101,62,58,58,101,112,115,105,108,111,110,40,41,0,105,109,97,103,101,32,105,115,32,101,109,112,116,121,0,103,114,97,98,67,117,116,0,105,109,97,103,101,32,109,117,115,116,32,104,97,118,101,32,67,86,95,56,85,67,51,32,116,121,112,101,0,33,98,103,100,83,97,109,112,108,101,115,46,101,109,112,116,121,40,41,32,38,38,32,33,102,103,100,83,97,109,112,108,101,115,46,101,109,112,116,121,40,41,0,105,110,105,116,71,77,77,115,0,105,62,61,48,32,38,38,32,105,60,40,105,110,116,41,118,116,99,115,46,115,105,122,101,40,41,0,105,110,83,111,117,114,99,101,83,101,103,109,101,110,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,99,103,114,97,112,104,46,104,112,112,0,109,105,110,87,101,105,103,104,116,32,62,32,48,0,109,97,120,70,108,111,119,0,97,100,100,69,100,103,101,115,0,106,62,61,48,32,38,38,32,106,60,40,105,110,116,41,118,116,99,115,46,115,105,122,101,40,41,0,119,62,61,48,32,38,38,32,114,101,118,119,62,61,48,0,105,32,33,61,32,106,0,97,100,100,84,101,114,109,87,101,105,103,104,116,115,0,109,97,115,107,32,105,115,32,101,109,112,116,121,0,99,104,101,99,107,77,97,115,107,0,109,97,115,107,32,109,117,115,116,32,104,97,118,101,32,67,86,95,56,85,67,49,32,116,121,112,101,0,109,97,115,107,32,109,117,115,116,32,104,97,118,101,32,97,115,32,109,97,110,121,32,114,111,119,115,32,97,110,100,32,99,111,108,115,32,97,115,32,105,109,103,0,109,97,115,107,32,101,108,101,109,101,110,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,101,113,117,97,108,32,71,67,95,66,71,68,32,111,114,32,71,67,95,70,71,68,32,111,114,32,71,67,95,80,82,95,66,71,68,32,111,114,32,71,67,95,80,82,95,70,71,68,0,118,111,105,100,32,99,118,58,58,103,114,97,98,67,117,116,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,82,101,99,116,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,41,0,99,111,117,110,116,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,52,41,0,109,105,110,69,110,99,108,111,115,105,110,103,67,105,114,99,108,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,104,97,112,101,100,101,115,99,114,46,99,112,112,0,118,111,105,100,32,99,118,58,58,109,105,110,69,110,99,108,111,115,105,110,103,67,105,114,99,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,50,102,32,38,44,32,102,108,111,97,116,32,38,41,0,97,114,99,76,101,110,103,116,104,0,100,111,117,98,108,101,32,99,118,58,58,97,114,99,76,101,110,103,116,104,40,73,110,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,110,112,111,105,110,116,115,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,52,41,0,99,111,110,116,111,117,114,65,114,101,97,0,100,111,117,98,108,101,32,99,118,58,58,99,111,110,116,111,117,114,65,114,101,97,40,73,110,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,110,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,52,41,0,102,105,116,69,108,108,105,112,115,101,0,84,104,101,114,101,32,115,104,111,117,108,100,32,98,101,32,97,116,32,108,101,97,115,116,32,53,32,112,111,105,110,116,115,32,116,111,32,102,105,116,32,116,104,101,32,101,108,108,105,112,115,101,0,99,118,58,58,82,111,116,97,116,101,100,82,101,99,116,32,99,118,58,58,102,105,116,69,108,108,105,112,115,101,40,73,110,112,117,116,65,114,114,97,121,41,0,112,111,105,110,116,83,101,116,66,111,117,110,100,105,110,103,82,101,99,116,0,105,109,103,46,100,101,112,116,104,40,41,32,60,61,32,49,32,38,38,32,105,109,103,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,0,109,97,115,107,66,111,117,110,100,105,110,103,82,101,99,116,0,99,118,58,58,82,101,99,116,32,99,118,58,58,98,111,117,110,100,105,110,103,82,101,99,116,40,73,110,112,117,116,65,114,114,97,121,41,0,85,110,115,117,112,112,111,114,116,101,100,32,115,101,113,117,101,110,99,101,32,116,121,112,101,0,99,118,66,111,117,110,100,105,110,103,82,101,99,116,0,84,104,101,32,105,109,97,103,101,47,109,97,116,114,105,120,32,102,111,114,109,97,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,116,104,101,32,102,117,110,99,116,105,111,110,0,97,117,116,111,109,97,116,105,99,95,116,104,114,101,115,104,32,33,61,32,40,67,86,95,84,72,82,69,83,72,95,79,84,83,85,32,124,32,67,86,95,84,72,82,69,83,72,95,84,82,73,65,78,71,76,69,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,116,104,114,101,115,104,46,99,112,112,0,116,104,114,101,115,104,71,101,110,101,114,105,99,0,78,50,99,118,49,53,84,104,114,101,115,104,111,108,100,82,117,110,110,101,114,69,0,100,111,117,98,108,101,32,99,118,58,58,116,104,114,101,115,104,111,108,100,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,97,100,97,112,116,105,118,101,84,104,114,101,115,104,111,108,100,0,98,108,111,99,107,83,105,122,101,32,37,32,50,32,61,61,32,49,32,38,38,32,98,108,111,99,107,83,105,122,101,32,62,32,49,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,97,100,97,112,116,105,118,101,32,116,104,114,101,115,104,111,108,100,32,109,101,116,104,111,100,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,116,104,114,101,115,104,111,108,100,32,116,121,112,101,0,118,111,105,100,32,99,118,58,58,97,100,97,112,116,105,118,101,84,104,114,101,115,104,111,108,100,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,41,0,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,100,115,116,46,99,104,97,110,110,101,108,115,40,41,32,38,38,32,40,115,114,99,46,100,101,112,116,104,40,41,32,61,61,32,100,115,116,46,100,101,112,116,104,40,41,32,124,124,32,100,115,116,46,100,101,112,116,104,40,41,32,61,61,32,48,41,0,99,118,84,104,114,101,115,104,111,108,100,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,99,111,114,110,101,114,69,105,103,101,110,86,97,108,115,86,101,99,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,114,110,101,114,46,99,112,112,0,118,111,105,100,32,99,118,58,58,99,111,114,110,101,114,77,105,110,69,105,103,101,110,86,97,108,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,118,111,105,100,32,99,118,58,58,99,111,114,110,101,114,72,97,114,114,105,115,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,99,118,83,116,97,114,116,82,101,97,100,67,104,97,105,110,80,111,105,110,116,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,111,110,116,111,117,114,115,46,99,112,112,0,99,118,83,116,97,114,116,70,105,110,100,67,111,110,116,111,117,114,115,95,73,109,112,108,0,91,83,116,97,114,116,93,70,105,110,100,67,111,110,116,111,117,114,115,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,67,86,95,56,85,67,49,32,105,109,97,103,101,115,32,119,104,101,110,32,109,111,100,101,32,33,61,32,67,86,95,82,69,84,82,95,70,76,79,79,68,70,73,76,76,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,111,114,116,115,32,67,86,95,51,50,83,67,49,32,105,109,97,103,101,115,32,111,110,108,121,0,115,116,101,112,32,62,61,32,48,0,115,105,122,101,46,104,101,105,103,104,116,32,62,61,32,49,0,99,118,70,105,110,100,78,101,120,116,67,111,110,116,111,117,114,0,115,99,97,110,110,101,114,45,62,105,109,103,95,115,116,101,112,32,62,61,32,48,0,112,116,114,32,33,61,32,48,76,0,105,99,118,84,114,97,99,101,67,111,110,116,111,117,114,95,51,50,115,0,105,99,118,84,114,97,99,101,67,111,110,116,111,117,114,0,112,97,114,95,105,110,102,111,32,33,61,32,48,0,105,99,118,70,101,116,99,104,67,111,110,116,111,117,114,0,105,99,118,70,101,116,99,104,67,111,110,116,111,117,114,69,120,95,51,50,115,0,105,99,118,70,101,116,99,104,67,111,110,116,111,117,114,69,120,0,99,118,69,110,100,70,105,110,100,67,111,110,116,111,117,114,115,0,78,85,76,76,32,100,111,117,98,108,101,32,67,118,83,101,113,32,112,111,105,110,116,101,114,0,99,118,70,105,110,100,67,111,110,116,111,117,114,115,95,73,109,112,108,0,78,111,110,122,101,114,111,32,111,102,102,115,101,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,67,86,95,76,73,78,75,95,82,85,78,83,32,121,101,116,0,78,85,76,76,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,105,99,118,70,105,110,100,67,111,110,116,111,117,114,115,73,110,73,110,116,101,114,118,97,108,0,67,111,110,116,111,117,114,32,104,101,97,100,101,114,32,115,105,122,101,32,109,117,115,116,32,98,101,32,62,61,32,115,105,122,101,111,102,40,67,118,67,111,110,116,111,117,114,41,0,73,110,112,117,116,32,97,114,114,97,121,32,109,117,115,116,32,98,101,32,56,117,67,49,32,111,114,32,56,115,67,49,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,49,50,67,118,77,101,109,83,116,111,114,97,103,101,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,40,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,86,69,67,84,79,82,32,124,124,32,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,77,65,84,32,124,124,32,95,99,111,110,116,111,117,114,115,46,107,105,110,100,40,41,32,61,61,32,95,73,110,112,117,116,65,114,114,97,121,58,58,83,84,68,95,86,69,67,84,79,82,95,85,77,65,84,41,0,102,105,110,100,67,111,110,116,111,117,114,115,0,95,99,111,110,116,111,117,114,115,46,101,109,112,116,121,40,41,32,124,124,32,40,95,99,111,110,116,111,117,114,115,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,50,32,38,38,32,95,99,111,110,116,111,117,114,115,46,100,101,112,116,104,40,41,32,61,61,32,52,41,0,99,105,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,118,111,105,100,32,99,118,58,58,102,105,110,100,67,111,110,116,111,117,114,115,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,80,111,105,110,116,41,0,40,100,115,116,95,119,105,100,116,104,32,42,32,100,115,116,95,104,101,105,103,104,116,32,62,32,48,41,32,124,124,32,40,105,110,118,95,115,99,97,108,101,95,120,32,62,32,48,32,38,38,32,105,110,118,95,115,99,97,108,101,95,121,32,62,32,48,41,0,114,101,115,105,122,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,114,101,115,105,122,101,46,99,112,112,0,100,115,105,122,101,46,97,114,101,97,40,41,32,62,32,48,0,102,117,110,99,32,33,61,32,48,0,102,117,110,99,32,33,61,32,48,32,38,38,32,99,110,32,60,61,32,52,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,100,100,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,107,115,105,122,101,32,60,61,32,77,65,88,95,69,83,73,90,69,0,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+245822);allocate([78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,102,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,115,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,116,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,50,72,82,101,115,105,122,101,67,117,98,105,99,73,104,105,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,67,117,98,105,99,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,100,100,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,102,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,115,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,116,102,102,76,105,49,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,51,72,82,101,115,105,122,101,76,105,110,101,97,114,73,104,105,115,76,105,50,48,52,56,69,78,83,95,49,50,72,82,101,115,105,122,101,78,111,86,101,99,69,69,69,78,83,95,49,51,86,82,101,115,105,122,101,76,105,110,101,97,114,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,100,100,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,100,100,102,78,83,95,52,67,97,115,116,73,100,100,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,102,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,102,102,102,78,83,95,52,67,97,115,116,73,102,102,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,115,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,115,102,102,78,83,95,52,67,97,115,116,73,102,115,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,116,102,102,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,116,102,102,78,83,95,52,67,97,115,116,73,102,116,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,50,49,114,101,115,105,122,101,71,101,110,101,114,105,99,95,73,110,118,111,107,101,114,73,78,83,95,49,53,72,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,104,105,115,69,69,78,83,95,49,53,86,82,101,115,105,122,101,76,97,110,99,122,111,115,52,73,104,105,115,78,83,95,49,49,70,105,120,101,100,80,116,67,97,115,116,73,105,104,76,105,50,50,69,69,69,78,83,95,49,50,86,82,101,115,105,122,101,78,111,86,101,99,69,69,69,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,100,100,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,102,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,115,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,116,102,69,69,0,78,50,99,118,49,56,82,101,115,105,122,101,65,114,101,97,95,73,110,118,111,107,101,114,73,104,102,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,100,100,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,100,100,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,102,102,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,102,102,69,69,69,69,0,99,110,32,61,61,32,52,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,115,102,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,115,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,115,115,69,69,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,116,102,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,116,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,116,116,69,69,69,69,69,69,0,78,50,99,118,50,50,114,101,115,105,122,101,65,114,101,97,70,97,115,116,95,73,110,118,111,107,101,114,73,104,105,78,83,95,49,55,82,101,115,105,122,101,65,114,101,97,70,97,115,116,86,101,99,73,104,78,83,95,49,57,82,101,115,105,122,101,65,114,101,97,70,97,115,116,78,111,86,101,99,73,104,104,69,69,69,69,69,69,0,78,50,99,118,49,53,114,101,115,105,122,101,78,78,73,110,118,111,107,101,114,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,105,78,83,95,49,50,102,105,120,101,100,112,111,105,110,116,54,52,69,76,105,50,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,115,78,83,95,49,50,102,105,120,101,100,112,111,105,110,116,51,50,69,76,105,50,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,116,78,83,95,49,51,117,102,105,120,101,100,112,111,105,110,116,51,50,69,76,105,50,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,97,78,83,95,49,50,102,105,120,101,100,112,111,105,110,116,51,50,69,76,105,50,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,50,114,101,115,105,122,101,95,98,105,116,69,120,97,99,116,73,110,118,111,107,101,114,73,104,78,83,95,49,51,117,102,105,120,101,100,112,111,105,110,116,49,54,69,76,105,50,69,69,69,0,118,111,105,100,32,99,118,58,58,104,97,108,58,58,114,101,115,105,122,101,40,105,110,116,44,32,99,111,110,115,116,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,117,99,104,97,114,32,42,44,32,115,105,122,101,95,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,115,115,105,122,101,46,119,105,100,116,104,32,62,32,48,32,38,38,32,115,115,105,122,101,46,104,101,105,103,104,116,32,62,32,48,0,100,115,105,122,101,46,97,114,101,97,40,41,32,62,32,48,32,124,124,32,40,105,110,118,95,115,99,97,108,101,95,120,32,62,32,48,32,38,38,32,105,110,118,95,115,99,97,108,101,95,121,32,62,32,48,41,0,118,111,105,100,32,99,118,58,58,114,101,115,105,122,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,83,105,122,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,99,118,82,101,115,105,122,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,103,101,111,109,101,116,114,121,46,99,112,112,0,116,111,116,97,108,32,62,61,32,48,32,38,38,32,40,100,101,112,116,104,32,61,61,32,52,32,124,124,32,100,101,112,116,104,32,61,61,32,53,41,0,112,111,105,110,116,80,111,108,121,103,111,110,84,101,115,116,0,100,111,117,98,108,101,32,99,118,58,58,112,111,105,110,116,80,111,108,121,103,111,110,84,101,115,116,40,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,50,102,44,32,98,111,111,108,41,0,111,114,105,101,110,116,97,116,105,111,110,32,33,61,32,48,0,114,111,116,97,116,105,110,103,67,97,108,105,112,101,114,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,114,111,116,99,97,108,105,112,101,114,115,46,99,112,112,0,99,118,58,58,82,111,116,97,116,101,100,82,101,99,116,32,99,118,58,58,109,105,110,65,114,101,97,82,101,99,116,40,73,110,112,117,116,65,114,114,97,121,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,111,112,32,61,61,32,77,79,82,80,72,95,69,82,79,68,69,32,124,124,32,111,112,32,61,61,32,77,79,82,80,72,95,68,73,76,65,84,69,0,103,101,116,77,111,114,112,104,111,108,111,103,121,82,111,119,70,105,108,116,101,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,111,114,112,104,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,100,97,116,97,32,116,121,112,101,32,40,61,37,100,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,52,77,111,114,112,104,82,111,119,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,51,77,111,114,112,104,82,111,119,78,111,86,101,99,69,69,69,0,103,101,116,77,111,114,112,104,111,108,111,103,121,67,111,108,117,109,110,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,55,77,111,114,112,104,67,111,108,117,109,110,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,54,77,111,114,112,104,67,111,108,117,109,110,78,111,86,101,99,69,69,69,0,97,110,99,104,111,114,46,105,110,115,105,100,101,40,82,101,99,116,40,48,44,32,48,44,32,107,115,105,122,101,46,119,105,100,116,104,44,32,107,115,105,122,101,46,104,101,105,103,104,116,41,41,0,110,111,114,109,97,108,105,122,101,65,110,99,104,111,114,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,102,105,108,116,101,114,101,110,103,105,110,101,46,104,112,112,0,103,101,116,77,111,114,112,104,111,108,111,103,121,70,105,108,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,95,107,101,114,110,101,108,46,116,121,112,101,40,41,32,61,61,32,48,0,77,111,114,112,104,70,105,108,116,101,114,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,97,120,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,100,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,102,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,115,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,116,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,54,95,69,69,69,69,0,78,50,99,118,49,49,77,111,114,112,104,70,105,108,116,101,114,73,78,83,95,53,77,105,110,79,112,73,104,69,69,78,83,95,49,48,77,111,114,112,104,78,111,86,101,99,69,69,69,0,100,101,112,116,104,32,61,61,32,48,32,124,124,32,100,101,112,116,104,32,61,61,32,50,32,124,124,32,100,101,112,116,104,32,61,61,32,51,32,124,124,32,100,101,112,116,104,32,61,61,32,53,32,124,124,32,100,101,112,116,104,32,61,61,32,54,0,99,114,101,97,116,101,77,111,114,112,104,111,108,111,103,121,70,105,108,116,101,114,0,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,82,69,67,84,32,124,124,32,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,67,82,79,83,83,32,124,124,32,115,104,97,112,101,32,61,61,32,77,79,82,80,72,95,69,76,76,73,80,83,69,0,103,101,116,83,116,114,117,99,116,117,114,105,110,103,69,108,101,109,101,110,116,0,118,111,105,100,32,99,118,58,58,109,111,114,112,104,79,112,40,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,118,111,105,100,32,99,118,58,58,101,114,111,100,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,118,111,105,100,32,99,118,58,58,100,105,108,97,116,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,109,111,114,112,104,111,108,111,103,121,69,120,0,117,110,107,110,111,119,110,32,109,111,114,112,104,111,108,111,103,105,99,97,108,32,111,112,101,114,97,116,105,111,110,0,118,111,105,100,32,99,118,58,58,109,111,114,112,104,111,108,111,103,121,69,120,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,40,40,40,52,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,119,97,116,101,114,115,104,101,100,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,115,101,103,109,101,110,116,97,116,105,111,110,46,99,112,112,0,118,111,105,100,32,99,118,58,58,119,97,116,101,114,115,104,101,100,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,41,0,100,101,112,116,104,32,61,61,32,48,32,124,124,32,100,101,112,116,104,32,61,61,32,50,0,100,101,109,111,115,97,105,99,105,110,103,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,101,109,111],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+256062);allocate([115,97,105,99,105,110,103,46,99,112,112,0,115,99,110,32,61,61,32,49,32,38,38,32,100,99,110,32,61,61,32,49,0,66,97,121,101,114,45,62,71,114,97,121,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,115,99,110,32,61,61,32,49,32,38,38,32,40,100,99,110,32,61,61,32,51,32,124,124,32,100,99,110,32,61,61,32,52,41,0,66,97,121,101,114,45,62,82,71,66,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,115,99,110,32,61,61,32,49,32,38,38,32,100,99,110,32,61,61,32,51,0,66,97,121,101,114,45,62,82,71,66,32,69,100,103,101,45,65,119,97,114,101,32,100,101,109,111,115,97,105,99,105,110,103,32,111,110,108,121,32,99,117,114,114,101,110,116,108,121,32,115,117,112,112,111,114,116,115,32,56,117,32,97,110,100,32,49,54,117,32,116,121,112,101,115,0,85,110,107,110,111,119,110,32,47,32,117,110,115,117,112,112,111,114,116,101,100,32,99,111,108,111,114,32,99,111,110,118,101,114,115,105,111,110,32,99,111,100,101,0,78,50,99,118,50,57,66,97,121,101,114,50,82,71,66,95,69,100,103,101,65,119,97,114,101,95,84,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,50,57,66,97,121,101,114,50,82,71,66,95,69,100,103,101,65,119,97,114,101,95,84,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,78,50,99,118,49,55,66,97,121,101,114,50,82,71,66,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,49,55,66,97,121,101,114,50,82,71,66,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,78,50,99,118,49,56,66,97,121,101,114,50,71,114,97,121,95,73,110,118,111,107,101,114,73,116,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,116,69,69,69,69,0,78,50,99,118,49,56,66,97,121,101,114,50,71,114,97,121,95,73,110,118,111,107,101,114,73,104,78,83,95,50,54,83,73,77,68,66,97,121,101,114,83,116,117,98,73,110,116,101,114,112,111,108,97,116,111,114,95,73,104,69,69,69,69,0,118,111,105,100,32,99,118,58,58,100,101,109,111,115,97,105,99,105,110,103,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,41,0,98,111,111,108,32,99,118,58,58,99,108,105,112,76,105,110,101,40,83,105,122,101,50,108,44,32,80,111,105,110,116,50,108,32,38,44,32,80,111,105,110,116,50,108,32,38,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,114,97,119,105,110,103,46,99,112,112,0,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,56,32,124,124,32,99,111,110,110,101,99,116,105,118,105,116,121,32,61,61,32,52,0,76,105,110,101,73,116,101,114,97,116,111,114,0,118,111,105,100,32,99,118,58,58,101,108,108,105,112,115,101,50,80,111,108,121,40,80,111,105,110,116,50,100,44,32,83,105,122,101,50,100,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,115,116,100,58,58,118,101,99,116,111,114,60,80,111,105,110,116,50,100,62,32,38,41,0,48,32,60,61,32,116,104,105,99,107,110,101,115,115,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,108,105,110,101,0,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,32,38,38,32,116,104,105,99,107,110,101,115,115,32,62,61,32,48,0,80,111,108,121,76,105,110,101,0,181,181,181,182,182,183,184,185,187,188,190,192,194,196,198,201,203,206,209,211,214,218,221,224,227,231,235,238,242,246,250,254,118,111,105,100,32,99,118,58,58,108,105,110,101,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,80,111,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,114,101,99,116,97,110,103,108,101,0,118,111,105,100,32,99,118,58,58,114,101,99,116,97,110,103,108,101,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,80,111,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,114,97,100,105,117,115,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,32,38,38,32,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,99,105,114,99,108,101,0,118,111,105,100,32,99,118,58,58,99,105,114,99,108,101,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,97,120,101,115,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,97,120,101,115,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,32,38,38,32,48,32,60,61,32,115,104,105,102,116,32,38,38,32,115,104,105,102,116,32,60,61,32,88,89,95,83,72,73,70,84,0,101,108,108,105,112,115,101,0,118,111,105,100,32,99,118,58,58,101,108,108,105,112,115,101,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,80,111,105,110,116,44,32,83,105,122,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,98,111,120,46,115,105,122,101,46,119,105,100,116,104,32,62,61,32,48,32,38,38,32,98,111,120,46,115,105,122,101,46,104,101,105,103,104,116,32,62,61,32,48,32,38,38,32,116,104,105,99,107,110,101,115,115,32,60,61,32,77,65,88,95,84,72,73,67,75,78,69,83,83,0,118,111,105,100,32,99,118,58,58,101,108,108,105,112,115,101,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,99,118,58,58,82,111,116,97,116,101,100,82,101,99,116,32,38,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,105,110,116,44,32,105,110,116,41,0,85,110,107,110,111,119,110,32,102,111,110,116,32,116,121,112,101,0,103,101,116,70,111,110,116,68,97,116,97,0,118,111,105,100,32,99,118,58,58,112,117,116,84,101,120,116,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,44,32,80,111,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,83,99,97,108,97,114,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,41,0,48,32,60,61,32,99,111,110,116,111,117,114,73,100,120,32,38,38,32,99,111,110,116,111,117,114,73,100,120,32,60,32,40,105,110,116,41,108,97,115,116,0,100,114,97,119,67,111,110,116,111,117,114,115,0,110,112,111,105,110,116,115,32,62,32,48,0,104,105,101,114,97,114,99,104,121,46,116,111,116,97,108,40,41,32,61,61,32,110,99,111,110,116,111,117,114,115,32,38,38,32,104,105,101,114,97,114,99,104,121,46,116,121,112,101,40,41,32,61,61,32,40,40,40,52,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,52,41,45,49,41,32,60,60,32,51,41,41,0,99,118,68,114,97,119,67,111,110,116,111,117,114,115,0,114,101,97,100,101,114,46,112,116,114,32,33,61,32,48,76,0,101,108,101,109,95,116,121,112,101,32,61,61,32,40,40,40,52,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,0,118,111,105,100,32,99,118,58,58,100,114,97,119,67,111,110,116,111,117,114,115,40,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,105,110,116,44,32,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,80,111,105,110,116,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,48,67,76,65,72,69,95,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,95,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,50,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,99,108,97,104,101,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,116,121,112,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,116,76,105,48,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,116,76,105,48,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,104,76,105,48,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,67,76,65,72,69,95,73,110,116,101,114,112,111,108,97,116,105,111,110,95,66,111,100,121,73,104,76,105,48,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,116,76,105,54,53,53,51,54,69,76,105,48,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,116,76,105,54,53,53,51,54,69,76,105,48,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,104,76,105,50,53,54,69,76,105,48,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,56,67,76,65,72,69,95,67,97,108,99,76,117,116,95,66,111,100,121,73,104,76,105,50,53,54,69,76,105,48,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,58,58,67,76,65,72,69,95,73,109,112,108,58,58,97,112,112,108,121,40,99,118,58,58,73,110,112,117,116,65,114,114,97,121,44,32,99,118,58,58,79,117,116,112,117,116,65,114,114,97,121,41,0,78,49,50,95,71,76,79,66,65,76,95,95,78,95,49,49,48,67,76,65,72,69,95,73,109,112,108,69,0,85,110,107,110,111,119,110,47,117,110,115,117,112,112,111,114,116,101,100,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,116,121,112,101,0,105,110,105,116,73,110,116,101,114,84,97,98,50,68,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,105,109,103,119,97,114,112,46,99,112,112,0,85,110,107,110,111,119,110,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,109,101,116,104,111,100,0,105,110,105,116,73,110,116,101,114,84,97,98,49,68,0,95,109,97,112,49,46,115,105,122,101,40,41,46,97,114,101,97,40,41,32,62,32,48,0,114,101,109,97,112,0,95,109,97,112,50,46,101,109,112,116,121,40,41,32,124,124,32,40,95,109,97,112,50,46,115,105,122,101,40,41,32,61,61,32,95,109,97,112,49,46,115,105,122,101,40,41,41,0,100,115,116,46,99,111,108,115,32,60,32,48,120,55,102,102,102,32,38,38,32,100,115,116,46,114,111,119,115,32,60,32,48,120,55,102,102,102,32,38,38,32,115,114,99,46,99,111,108,115,32,60,32,48,120,55,102,102,102,32,38,38,32,115,114,99,46,114,111,119,115,32,60,32,48,120,55,102,102,102,0,110,110,102,117,110,99,32,33,61,32,48,0,95,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,60,61,32,52,0,105,102,117,110,99,32,33,61,32,48,0,40,40,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,40,40,40,51,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,50,41,45,49,41,32,60,60,32,51,41,41,41,32,38,38,32,109,97,112,50,46,101,109,112,116,121,40,41,41,32,124,124,32,40,109,97,112,49,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,38,38,32,109,97,112,50,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,41,0,78,50,99,118,49,50,82,101,109,97,112,73,110,118,111,107,101,114,69,0,115,115,105,122,101,46,97,114,101,97,40,41,32,62,32,48,0,114,101,109,97,112,66,105,108,105,110,101,97,114,0,118,111,105,100,32,99,118,58,58,114,101,109,97,112,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,78,50,99,118,49,55,87,97,114,112,65,102,102,105,110,101,73,110,118,111,107,101,114,69,0,95,115,114,99,46,99,104,97,110,110,101,108,115,40,41,32,60,61,32,52,32,124,124,32,40,105,110,116,101,114,112,111,108,97,116,105,111,110,32,33,61,32,73,78,84,69,82,95,76,65,78,67,90,79,83,52,32,38,38,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,33,61,32,73,78,84,69,82,95,67,85,66,73,67,41,0,119,97,114,112,65,102,102,105,110,101,0,115,114,99,46,99,111,108,115,32,62,32,48,32,38,38,32,115,114,99,46,114,111,119,115,32,62,32,48,0,40,77,48,46,116,121,112,101,40,41,32,61,61,32,53,32,124,124,32,77,48,46,116,121,112,101,40,41,32,61,61,32,54,41,32,38,38,32,77,48,46,114,111,119,115,32,61,61,32,50,32,38,38,32,77,48,46,99,111,108,115,32,61,61,32,51,0,118,111,105,100,32,99,118,58,58,119,97,114,112,65,102,102,105,110,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,83,105,122,101,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,78,50,99,118,50,50,87,97,114,112,80,101,114,115,112,101,99,116,105,118,101,73,110,118,111,107,101,114,69,0,95,115,114,99,46,116,111,116,97,108,40,41,32,62,32,48,0,119,97,114,112,80,101,114,115,112,101,99,116,105,118,101,0,40,77,48,46,116,121,112,101,40,41,32,61,61,32,53,32,124,124,32,77,48,46,116,121,112,101,40,41,32,61,61,32,54,41,32,38,38,32,77,48,46,114,111,119,115,32,61,61,32,51,32,38,38,32,77,48,46,99,111,108,115,32,61,61,32,51,0,118,111,105,100,32,99,118,58,58,119,97,114,112,80,101,114,115,112,101,99,116,105,118,101,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,83,105,122,101,44,32,105,110,116,44,32,105,110,116,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,41,0,99,118,58,58,77,97,116,32,99,118,58,58,103,101,116,82,111,116,97,116,105,111,110,77,97,116,114,105,120,50,68,40,80,111,105,110,116,50,102,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,41,0,99,118,58,58,77,97,116,32,99,118,58,58,103,101,116,80,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,40,99,111,110,115,116,32,80,111,105,110,116,50,102,32,42,44,32,99,111,110,115,116,32,80,111,105,110,116,50,102,32,42,41,0,115,114,99,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,53,41,32,61,61,32,52,32,38,38,32,100,115,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,53,41,32,61,61,32,52,0,103,101,116,80,101,114,115,112,101,99,116,105,118,101,84,114,97,110,115,102,111,114,109,0,115,114,99,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,53,41,32,61,61,32,51,32,38,38,32,100,115,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,53,41,32,61,61,32,51,0,103,101,116,65,102,102,105,110,101,84,114,97,110,115,102,111,114,109,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,53,67,118,77,97,116,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,99,111,110,116,111,117,114,46,100,101,112,116,104,40,41,32,61,61,32,52,32,124,124,32,99,111,110,116,111,117,114,46,100,101,112,116,104,40,41,32,61,61,32,53,0,99,111,110,116,111,117,114,77,111,109,101,110,116,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,109,111,109,101,110,116,115,46,99,112,112,0,73,110,118,97,108,105,100,32,105,109,97,103,101,32,116,121,112,101,32,40,109,117,115,116,32,98,101,32,115,105,110,103,108,101,45,99,104,97,110,110,101,108,41,0,109,111,109,101,110,116,115,0,99,118,58,58,77,111,109,101,110,116,115,32,99,118,58,58,109,111,109,101,110,116,115,40,73,110,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,118,111,105,100,32,99,118,58,58,72,117,77,111,109,101,110,116,115,40,99,111,110,115,116,32,99,118,58,58,77,111,109,101,110,116,115,32,38,44,32,100,111,117,98,108,101,32,42,41,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,105,109,103,112,114,111,99,47,115,114,99,47,100,105,115,116,114,97,110,115,102,111,114,109,46,99,112,112,0,108,97,98,101,108,84,121,112,101,32,61,61,32,68,73,83,84,95,76,65,66,69,76,95,80,73,88,69,76,32,124,124,32,108,97,98,101,108,84,121,112,101,32,61,61,32,68,73,83,84,95,76,65,66,69,76,95,67,67,79,77,80,0,77,97,115,107,32,115,105,122,101,32,115,104,111,117,108,100,32,98,101,32,51,32,111,114,32,53,32,111,114,32,48,32,40,112,114,101,99,105,115,101,41,0,115,114,99,46,115,105,122,101,40,41,32,61,61,32,100,115,116,46,115,105,122,101,40,41,0,116,114,117,101,68,105,115,116,84,114,97,110,115,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,67,32,124,124,32,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,76,49,32,124,124,32,100,105,115,116,84,121,112,101,32,61,61,32,67,86,95,68,73,83,84,95,76,50,0,85,110,107,110,111,119,110,32,109,101,116,114,105,99,32,116,121,112,101,0,103,101,116,68,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,77,97,115,107,0,78,50,99,118,49,50,68,84,82,111,119,73,110,118,111,107,101,114,69,0,78,50,99,118,49,53,68,84,67,111,108,117,109,110,73,110,118,111,107,101,114,69,0,118,111,105,100,32,99,118,58,58,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,95,76,49,95,56,85,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,38,38,32,100,115,116,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,100,105,115,116,97,110,99,101,65,84,83,95,76,49,95,56,117,0,118,111,105,100,32,99,118,58,58,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,95,76,49,95,56,85,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,118,111,105,100,32,99,118,58,58,100,105,115,116,97,110,99,101,84,114,97,110,115,102,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,77,87,82,77,78,86,32,82,77,86,86,32,80,83,84,83,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,80,83,81,32,79,81,83,81,85,82,85,85,83,86,79,86,0,77,88,86,78,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,86,86,85,0,77,87,79,77,79,86,32,79,77,82,77,84,78,85,80,85,83,84,85,82,86,79,86,0,77,87,79,77,79,86,32,79,77,85,77,32,79,81,83,81,32,79,86,85,86,0,77,86,79,77,79,86,32,79,77,85,77,32,79,81,83,81,0,77,88,86,78,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,86,86,85,86,82,32,83,82,86,82,0,77,87,79,77,79,86,32,85,77,85,86,32,79,81,85,81,0,80,84,82,77,82,86,0,78,85,83,77,83,84,82,86,80,86,79,84,79,83,0,77,87,79,77,79,86,32,85,77,79,83,32,81,81,85,86,0,77,86,79,77,79,86,32,79,86,85,86,0,76,88,78,77,78,86,32,78,77,82,86,32,86,77,82,86,32,86,77,86,86,0,77,87,79,77,79,86,32,79,77,85,86,32,85,77,85,86,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,81,83,82,79,82,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,32,83,84,86,87,0,77,87,79,77,79,86,32,79,77,83,77,85,78,85,81,83,82,79,82,32,82,82,85,86,0,77,87,85,78,83,77,81,77,79,78,79,79,80,80,84,82,85,83,85,85,83,86,81,86,79,85,0,77,87,82,77,82,86,32,78,77,86,77,0,77,88,79,77,79,83,80,85,82,86,83,86,85,85,86,83,86,77,0,77,87,78,77,82,86,32,86,77,82,86,0,76,88,78,77,80,86,32,82,77,80,86,32,82,77,84,86,32,86,77,84,86,0,77,87,79,77,85,86,32,85,77,79,86,0,77,87,78,77,82,81,82,86,32,86,77,82,81,0,77,87,85,77,79,86,32,79,77,85,77,32,79,86,85,86,0,77,86,79,77,79,86,32,79,77,85,77,0,77,87,82,77,78,86,32,82,77,86,86,32,78,86,86,86,0,77,88,82,77,80,78,79,80,79,83,80,85,82,86,83,86,85,85,86,83,86,80,85,78,83,77,82,77,32,81,81,84,82,32,84,81,81,82,0,77,87,82,77,78,86,32,82,77,86,86,0,77,87,79,77,85,77,32,80,81,84,82,32,84,81,80,82,32,79,86,85,86,0,77,87,79,77,79,86,32,85,77,85,86,32,79,77,85,77,0,77,87,79,77,82,81,79,86,32,79,77,85,77,32,79,86,85,86,0,77,87,78,79,78,78,79,77,80,77,81,78,82,80,82,86,32,86,79,86,78,85,77,84,77,83,78,82,80,0,76,88,82,77,82,86,32,80,79,78,80,78,83,80,84,84,84,86,83,86,80,84,79,80,79,0,76,88,82,77,82,86,32,78,79,79,80,79,83,81,84,83,84,85,83,85,80,86,79,0,77,88,79,86,81,86,79,82,79,80,80,78,82,77,83,77,85,78,86,80,86,82,84,86,86,86,0,77,87,83,77,77,86,32,83,77,85,86,32,79,83,84,83,0,77,87,81,77,78,86,32,81,77,84,77,86,78,86,80,83,81,80,81,32,83,81,85,82,85,84,84,85,82,86,78,86,0,76,88,86,80,85,78,84,77,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,0,77,88,81,77,78,86,32,81,77,85,77,86,79,86,81,85,84,84,85,82,86,78,86,0,77,86,81,77,78,86,32,81,77,86,77,32,80,81,83,81,32,78,86,83,86,0,77,86,81,77,78,86,32,81,77,86,77,32,80,81,83,81,0,76,88,86,80,85,78,84,77,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,83,82,83,0,77,88,81,77,78,86,32,87,77,84,86,32,80,81,85,81,0,80,85,84,77,81,86,0,79,86,85,77,83,83,82,85,81,86,80,86,79,85,79,84,0,77,86,81,77,78,86,32,86,77,79,83,32,82,81,84,86,0,78,86,82,77,79,86,32,79,86,84,86,0,76,89,80,77,77,86,32,80,77,81,86,32,88,77,81,86,32,88,77,85,86,0,77,88,81,77,78,86,32,81,77,84,86,32,87,77,84,86,0,76,88,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,86,82,86,80,85,78,84,77,82,77,0,77,87,81,77,78,86,32,81,77,85,77,86,78,86,80,85,81,83,82,80,82,0,76,88,82,77,80,78,79,79,78,81,78,83,79,85,80,86,82,86,84,85,85,84,86,82,86,80,85,78,84,77,82,77,32,81,86,80,85,80,84,81,83,82,83,83,84,84,86,85,87,86,87,0,77,87,81,77,78,86,32,81,77,85,77,86,78,86,80,85,81,83,82,80,82,32,81,82,82,85,83,86,84,86,85,85,0,77,87,86,78,84,77,82,77,80,78,80,80,81,81,84,82,85,83,85,85,83,86,80,86,78,85,0,77,86,83,77,80,86,32,80,77,86,77,0,76,88,80,77,78,83,78,85,79,86,82,86,84,85,85,83,87,77,0,77,87,79,77,81,86,32,87,77,81,86,0,75,88,78,77,78,86,32,83,77,78,86,32,83,77,83,86,32,88,77,83,86,0,78,87,81,77,84,86,32,87,77,78,86,0,78,87,81,77,83,81,81,86,32,87,77,83,81,0,77,87,81,77,87,77,78,86,84,86,0,76,88,78,77,82,86,32,86,77,82,86,32,78,77,86,77,0,77,87,78,76,86,88,0,76,88,82,79,78,85,32,82,79,86,85,0,77,87,78,86,86,86,0,80,86,82,77,85,81,0,77,87,77,77,79,75,81,75,84,77,86,77,87,75,0,78,87,81,80,84,80,85,81,85,86,32,85,82,81,83,80,84,80,85,81,86,83,86,85,85,0,77,87,79,77,79,86,32,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,83,86,85,85,0,77,87,85,77,85,86,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,77,87,79,83,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,86,0,78,86,85,78,84,77,83,77,82,78,82,86,32,80,80,84,80,0,77,87,85,80,85,86,84,88,82,89,80,89,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,77,87,79,77,79,86,32,79,83,80,81,82,80,84,81,85,83,85,86,0,80,84,82,76,81,77,82,78,83,77,82,76,32,82,80,82,86,0,80,85,83,76,82,77,83,78,84,77,83,76,32,83,80,83,88,82,89,81,89,80,88,0,78,87,80,77,80,86,32,85,80,80,84,32,82,83,85,86,0,75,89,77,80,77,86,32,77,83,78,81,79,80,80,80,81,81,82,83,82,86,32,82,83,83,81,84,80,85,80,86,81,87,83,87,86,0,77,87,79,80,79,86,32,79,83,80,81,82,80,84,81,85,83,85,86,0,77,87,82,80,80,81,79,83,80,85,82,86,84,85,85,83,84,81,82,80,0,77,87,79,80,79,89,32,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,80,85,89,32,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,0,78,86,80,80,80,86,32,80,83,81,81,83,80,84,80,0,78,87,85,81,84,80,81,80,80,81,80,82,81,83,84,83,85,84,85,85,84,86,81,86,80,85,0,78,86,82,77,82,85,83,86,84,86,85,85,32,80,80,84,80,0,77,87,85,80,85,86,32,79,80,79,83,80,85,82,86,84,85,85,83,0,78,86,79,80,82,86,32,85,80,82,86,0,76,88,78,80,80,86,32,82,80,80,86,32,82,80,84,86,32,86,80,84,86,0,77,87,79,80,85,86,32,85,80,79,86,0,77,87,79,80,82,86,32,85,80,82,86,81,88,80,89,79,89,0,77,87,79,80,85,80,79,86,85,86,0,77,88,86,80,85,83,84,85,82,86,80,85,79,83,80,81,82,80,84,81,85,85,86,86,0,77,87,79,84,81,86,83,86,84,85,84,83,83,82,80,81,82,81,84,80,85,79,85,78,84,77,82,77,81,78,80,80,79,84,78,89,0,77,88,78,81,79,80,81,80,82,81,82,83,81,87,32,86,80,85,82,83,84,81,87,80,89,0,77,87,84,78,83,77,82,77,81,78,81,79,82,80,84,81,85,83,84,85,82,86,80,85,79,83,80,81,82,80,0,78,87,85,81,83,80,81,80,80,81,80,82,81,83,32,83,83,81,83,80,84,80,85,81,86,83,86,85,85,0,78,87,84,77,83,78,83,79,84,80,32,85,80,83,80,81,81,80,83,80,85,81,86,83,87,83,88,82,89,81,89,0,76,88,78,81,79,80,80,80,81,81,81,83,80,86,32,81,83,82,81,84,80,85,80,86,81,86,83,85,86,84,89,0,76,88,78,81,79,80,80,80,81,81,81,85,82,86,83,86,84,85,85,83,86,80,86,78,85,77,84,77,83,78,83,80,84,82,85,83,87,84,0,79,86,82,80,81,83,81,85,82,86,83,86,84,85,0,77,87,81,80,79,86,32,85,80,84,80,82,81,80,83,32,80,83,81,85,83,86,84,86,0,77,87,79,77,80,77,81,78,82,80,85,86,32,82,80,79,86,0,76,89,80,80,77,89,32,85,80,84,83,83,85,81,86,80,86,79,85,79,83,32,84,83,84,85,85,86,86,86,87,85,0,77,87,78,80,79,80,79,86,32,85,80,84,83,82,85,79,86,0,78,87,84,77,83,78,83,79,84,80,32,85,80,83,80,81,81,81,82,82,83,84,83,32,83,83,81,84,80,85,80,86,81,87,83,88,83,89,82,90,81,90,0,77,88,79,81,81,80,86,80,32,81,80,81,82,80,86,32,84,80,84,82,85,86,0,77,87,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,78,89,0,77,88,86,80,82,80,80,81,79,83,80,85,82,86,84,85,85,83,84,81,82,80,0,77,88,79,81,81,80,86,80,32,83,80,82,86,0,75,88,77,81,78,80,79,80,80,81,80,85,81,86,83,86,84,85,85,83,86,80,0,77,88,80,80,79,81,79,83,80,85,82,86,83,86,85,85,86,83,86,81,85,80,84,80,83,81,82,83,81,89,0,77,87,79,80,80,80,81,81,83,88,84,89,85,89,32,85,80,84,82,80,87,79,89,0,75,89,84,77,82,89,32,77,81,78,80,79,80,80,81,80,85,81,86,84,86,85,85,86,83,87,80,0,76,88,79,80,78,82,78,84,79,86,81,86,82,84,82,82,32,85,80,86,82,86,84,85,86,83,86,82,84,0,76,87,84,83,83,81,81,80,79,81,78,83,79,85,81,86,83,85,84,83,32,85,80,84,83,84,85,85,86,86,86,0,77,87,81,77,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,84,86,0,76,87,84,83,83,81,81,80,79,81,78,83,79,85,81,86,83,85,84,83,32,86,77,84,83,84,85,85,86,86,86,0,77,87,79,83,84,83,85,82,85,81,83,80,82,80,80,81,79,83,80,85,82,86,84,86,0,79,86,86,77,85,77,84,78,83,80,81,86,80,88,79,89,78,89,32,81,80,85,80,0,77,88,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,32,86,80,84,86,83,88,82,89,80,89,79,88,0,77,86,81,77,78,86,32,79,83,80,81,81,80,83,80,84,81,84,82,83,84,83,85,84,86,85,86,0,80,85,83,77,83,78,84,78,84,77,83,77,32,81,80,82,80,83,81,83,82,82,84,82,85,83,86,84,86,0,79,85,83,77,83,78,84,78,84,77,83,77,32,81,80,82,80,83,81,83,82,82,86,81,88,80,89,79,89,78,88,0,78,86,82,77,79,86,32,85,80,84,80,82,81,80,83,32,80,83,81,85,83,86,84,86,0,79,84,83,77,81,83,81,85,82,86,83,86,0,74,89,75,80,76,80,77,81,77,83,76,86,32,77,83,78,81,79,80,81,80,82,81,82,83,81,86,32,82,83,83,81,84,80,86,80,87,81,87,82,86,84,86,85,87,86,88,86,0,77,87,78,80,79,80,80,81,80,83,79,86,32,80,83,81,81,82,80,84,80,85,81,85,82,84,84,84,85,85,86,86,86,0,77,88,78,80,79,80,80,81,80,83,78,89,32,80,83,81,85,83,86,85,85,86,83,85,81,83,80,81,81,80,83,0,77,88,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,32,86,80,83,89,0,77,86,79,80,80,80,81,81,81,83,80,86,32,85,81,84,80,83,80,82,81,81,83,0,78,86,84,81,83,80,81,80,80,81,80,82,81,83,82,83,83,84,83,85,82,86,80,86,79,85,0,78,85,83,77,81,83,81,85,82,86,83,86,32,80,80,84,80,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,83,85,84,83,32,85,80,84,83,84,85,85,86,86,86,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,84,85,85,82,85,80,0,75,89,76,80,77,80,78,81,78,82,77,84,77,85,78,86,80,86,81,85,82,83,83,80,32,82,83,82,85,83,86,85,86,86,85,87,82,87,80,0,77,87,79,81,80,80,81,80,82,81,82,85,83,86,84,86,85,85,32,86,81,85,80,84,80,83,81,81,85,80,86,79,86,78,85,0,77,87,78,80,79,80,80,81,80,82,79,84,79,85,80,86,82,86,83,85,84,83,32,85,80,83,86,82,88,81,89,79,89,78,88,0,78,86,85,80,79,86,32,80,81,81,80,83,80,84,81,32,80,85,81,86,83,86,84,85,0,77,87,85,83,84,81,82,80,80,81,79,83,80,85,82,86,84,85,85,83,85,80,84,78,82,77,81,77,0,77,87,85,81,83,80,82,80,80,81,79,83,80,85,82,86,83,86,85,85,32,79,83,83,83,0,77,87,82,77,81,78,80,80,79,83,79,86,80,87,82,87,83,86,84,84,85,81,85,78,84,77,82,77,32,80,82,84,82,0,77,87,84,77,81,89,32,82,80,80,81,79,83,80,85,82,86,83,86,85,85,86,83,85,81,83,80,82,80,0,77,87,85,81,83,80,81,80,79,81,79,83,80,84,82,85,83,86,83,87,82,88,81,88,0,75,89,84,80,84,83,85,84,86,84,87,83,87,81,86,79,85,78,83,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,32,84,81,83,80,81,80,80,81,80,83,81,84,83,84,84,83,0,77,87,85,78,79,82,85,86,0,77,87,79,78,85,82,79,86,0,79,85,84,75,81,75,81,89,84,89,0,79,85,80,75,83,75,83,89,80,89,0,79,85,84,75,83,76,82,78,82,79,83,81,81,82,83,83,82,85,82,86,83,88,84,89,0,79,85,80,75,81,76,82,78,82,79,81,81,83,82,81,83,82,85,82,86,81,88,80,89,0,76,89,80,77,81,78,81,79,80,80,79,80,78,79,78,78,79,77,80,77,83,78,85,78,87,77,78,86,32,85,83,84,84,84,85,85,86,86,86,87,85,87,84,86,83,85,83,0,80,84,0,78,86,0,77,87,82,77,80,78,79,80,79,83,80,85,82,86,84,85,85,83,85,80,84,78,82,77,0,77,87,80,79,82,77,82,86,0,77,87,79,78,81,77,83,77,85,78,85,80,84,82,79,86,85,86,0,77,87,79,78,81,77,83,77,85,78,85,80,83,81,32,82,81,83,81,85,82,85,85,83,86,81,86,79,85,0,77,87,83,77,83,86,32,83,77,78,83,86,83,0,77,87,80,77,79,81,81,80,82,80,84,81,85,83,84,85,82,86,81,86,79,85,32,80,77,84,77,0,77,87,84,77,82,77,80,78,79,80,79,83,80,85,82,86,84,85,85,83,84,81,82,80,80,81,79,83,0,77,87,85,77,81,86,32,79,77,85,77,0,77,87,81,77,79,78,79,80,81,81,83,81,85,80,85,78,83,77,81,77,32,81,81,79,82,79,85,81,86,83,86,85,85,85,82,83,81,0,77,87,85,80,84,82,82,83,80,82,79,80,80,78,82,77,84,78,85,80,85,83,84,85,82,86,80,86,0,80,85,82,85,82,86,83,86,83,85,82,85,0,80,85,83,86,82,86,82,85,83,85,83,87,82,89,0,80,85,82,80,82,81,83,81,83,80,82,80,32,82,85,82,86,83,86,83,85,82,85,0,80,85,82,80,82,81,83,81,83,80,82,80,32,83,86,82,86,82,85,83,85,83,87,82,89,0,80,85,82,77,82,82,32,83,77,83,82,32,82,85,82,86,83,86,83],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+266302);allocate([85,82,85,0,78,87,80,78,82,77,83,77,85,78,85,80,82,81,82,82,83,82,83,81,85,80,32,82,85,82,86,83,86,83,85,82,85,0,80,84,82,77,82,81,0,78,86,80,77,80,81,32,84,77,84,81,0,78,86,81,77,80,78,80,80,81,81,83,81,84,80,84,78,83,77,81,77,0,77,87,82,75,82,88,32,85,78,83,77,81,77,79,78,79,80,81,81,84,82,85,83,85,85,83,86,81,86,79,85,0,77,87,86,76,78,88,0,79,85,84,75,82,78,81,81,81,83,82,86,84,89,0,79,85,80,75,82,78,83,81,83,83,82,86,80,89,0,80,84,82,75,82,89,0,76,88,78,82,86,82,0,76,88,82,78,82,86,32,78,82,86,82,0,76,88,78,80,86,80,32,78,84,86,84,0,77,87,79,79,85,85,32,85,79,79,85,0,77,87,82,79,82,85,32,79,80,85,84,32,85,80,79,84,0,80,85,82,81,82,82,83,82,83,81,82,81,0,80,85,83,77,82,79,82,81,83,81,83,80,82,80,0,80,85,83,78,82,78,82,77,83,77,83,79,82,81,0,76,88,83,79,86,82,83,85,32,78,82,86,82,0,77,88,81,76,81,89,32,84,76,84,89,32,79,81,86,81,32,79,84,86,84,0,76,88,86,82,85,82,84,83,83,85,82,86,79,86,78,85,78,83,79,82,82,81,83,80,83,78,82,77,80,77,79,78,79,80,81,83,83,85,85,86,86,86,0,76,88,78,78,79,81,79,83,78,86,32,86,78,85,81,85,83,86,86,32,78,78,81,79,83,79,86,78,32,78,86,81,85,83,85,86,86,0,76,89,82,81,81,80,79,80,78,81,78,83,79,84,81,84,82,83,83,81,84,80,86,80,87,81,87,83,86,84,84,84,83,83,82,81,0,72,92,78,82,77,81,76,82,77,83,78,82,32,86,82,87,81,88,82,87,83,86,82,0,72,92,77,80,76,81,76,82,77,83,78,83,79,82,79,81,78,80,77,80,32,77,81,77,82,78,82,78,81,77,81,32,87,80,86,81,86,82,87,83,88,83,89,82,89,81,88,80,87,80,32,87,81,87,82,88,82,88,81,87,81,0,73,91,75,82,89,82,0,72,92,82,85,74,80,82,84,90,80,82,85,0,70,94,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,32,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,89,74,87,76,86,78,86,80,87,84,90,86,91,88,91,90,90,91,87,32,73,89,74,86,76,85,78,85,80,86,84,89,86,90,88,90,90,89,91,87,0,70,94,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,32,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,87,91,87,32,73,91,91,91,0,67,97,71,79,93,79,88,73,32,76,91,71,85,93,85,0,68,96,70,94,94,94,94,70,70,70,70,94,0,75,89,81,86,79,85,78,83,78,81,79,79,81,78,83,78,85,79,86,81,86,83,85,85,83,86,81,86,32,83,86,86,83,32,81,86,86,81,32,79,85,85,79,32,78,83,83,78,32,78,81,81,78,0,72,92,73,82,91,82,0,72,92,73,82,91,82,32,73,81,91,81,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,81,91,79,92,78,94,78,97,32,84,84,85,85,86,87,85,89,84,90,32,78,96,79,95,80,95,83,96,86,96,87,95,32,80,95,83,97,86,97,87,95,87,94,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,32,84,84,85,85,86,87,85,89,84,90,32,82,90,84,90,86,91,87,93,87,94,86,96,84,97,81,97,79,96,78,95,78,94,79,94,79,95,32,84,90,85,91,86,93,86,94,85,96,84,97,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,86,86,86,87,87,87,87,86,86,85,84,84,82,84,80,85,79,86,78,89,78,94,79,96,81,97,84,97,86,96,87,94,87,92,86,90,84,89,81,89,78,91,32,82,84,80,86,79,89,79,94,80,96,81,97,32,84,97,85,96,86,94,86,92,85,90,84,89,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,81,74,79,75,78,77,78,80,32,84,67,85,68,86,70,85,72,84,73,32,78,79,79,78,80,78,83,79,86,79,87,78,32,80,78,83,80,86,80,87,78,87,77,32,77,82,88,82,32,79,86,79,87,78,87,78,86,79,85,81,84,84,84,86,85,87,87,86,89,84,90,32,84,84,85,85,86,87,85,89,84,90,32,82,90,84,90,86,91,87,93,87,94,86,96,84,97,81,97,79,96,78,95,78,94,79,94,79,95,32,84,90,85,91,86,93,86,94,85,96,84,97,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,32,84,67,85,68,86,70,85,72,84,73,32,82,73,84,73,86,74,87,76,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,73,85,74,86,76,86,77,85,79,84,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,67,78,73,32,79,67,86,67,32,79,68,83,68,86,67,32,78,73,79,72,81,71,84,71,86,72,87,74,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,71,85,72,86,74,86,77,85,79,84,80,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,78,67,78,71,32,86,69,82,76,80,80,32,87,67,84,73,81,80,32,78,69,80,67,82,67,85,69,32,78,69,80,68,82,68,85,69,86,69,32,77,82,88,82,32,81,84,79,85,78,87,79,89,81,90,84,90,86,89,87,87,86,85,84,84,81,84,32,81,84,80,85,79,87,80,89,81,90,32,84,90,85,89,86,87,85,85,84,84,32,81,90,79,91,78,93,78,94,79,96,81,97,84,97,86,96,87,94,87,93,86,91,84,90,32,81,90,80,91,79,93,79,94,80,96,81,97,32,84,97,85,96,86,94,86,93,85,91,84,90,0,76,89,79,67,78,73,32,79,67,86,67,32,79,68,83,68,86,67,32,78,73,79,72,81,71,84,71,86,72,87,74,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,71,85,72,86,74,86,77,85,79,84,80,32,77,82,88,82,32,86,86,86,87,87,87,87,86,86,85,84,84,82,84,80,85,79,86,78,89,78,94,79,96,81,97,84,97,86,96,87,94,87,92,86,90,84,89,81,89,78,91,32,82,84,80,86,79,89,79,94,80,96,81,97,32,84,97,85,96,86,94,86,92,85,90,84,89,0,76,89,80,70,83,67,83,80,32,82,68,82,80,32,79,80,86,80,32,77,82,88,82,32,83,86,83,97,32,84,84,84,97,32,84,84,77,93,88,93,32,81,97,86,97,0,76,89,79,69,79,70,78,70,78,69,79,68,81,67,84,67,86,68,87,70,86,72,84,73,32,84,67,85,68,86,70,85,72,84,73,32,82,73,84,73,86,74,87,76,87,77,86,79,84,80,81,80,79,79,78,78,78,77,79,77,79,78,32,84,73,85,74,86,76,86,77,85,79,84,80,32,77,82,88,82,32,83,86,83,97,32,84,84,84,97,32,84,84,77,93,88,93,32,81,97,86,97,0,70,94,89,88,87,90,85,91,82,91,80,90,77,88,75,87,73,87,72,88,72,90,73,91,75,91,77,90,79,87,80,85,82,81,84,75,87,71,89,70,90,70,91,71,92,72,91,73,90,72,91,71,91,70,90,70,89,70,87,71,86,72,84,76,82,80,80,86,78,90,77,90,32,79,80,85,80,0,69,94,80,91,77,90,74,88,72,85,71,82,71,79,72,76,74,73,77,71,80,70,84,70,87,71,89,73,91,76,92,79,92,82,91,85,89,88,86,90,83,91,80,91,32,78,74,78,87,32,79,74,79,87,32,76,74,83,74,86,75,87,77,87,78,86,80,83,81,79,81,32,83,74,85,75,86,77,86,78,85,80,83,81,32,76,87,81,87,32,83,81,84,82,85,86,86,87,87,87,88,86,32,83,81,85,82,86,86,87,87,0,69,94,80,91,77,90,74,88,72,85,71,82,71,79,72,76,74,73,77,71,80,70,84,70,87,71,89,73,91,76,92,79,92,82,91,85,89,88,86,90,83,91,80,91,32,85,75,86,74,86,78,85,75,83,74,80,74,78,75,77,76,76,79,76,82,77,85,78,86,80,87,83,87,85,86,86,84,32,80,74,78,76,77,79,77,82,78,85,80,87,0,69,95,73,77,91,77,32,73,82,91,82,32,73,87,91,87,32,75,91,89,73,0,67,97,72,81,71,82,72,83,73,82,72,81,32,82,81,81,82,82,83,83,82,82,81,32,92,81,91,82,92,83,93,82,92,81,0,69,95,78,87,76,84,73,82,76,80,78,77,32,76,80,74,82,76,84,32,74,82,90,82,32,86,87,88,84,91,82,88,80,86,77,32,88,80,90,82,88,84,0,74,90,87,78,84,76,82,73,80,76,77,78,32,80,76,82,74,84,76,32,82,74,82,90,32,87,86,84,88,82,91,80,88,77,86,32,80,88,82,90,84,88,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,32,83,70,83,94,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,32,81,70,81,94,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,32,79,82,90,82,0,72,92,76,66,76,91,32,82,66,82,91,32,88,66,88,91,0,73,91,82,70,74,91,32,82,70,90,91,32,77,84,87,84,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,84,80,32,75,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,75,91,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,0,71,92,75,70,75,91,32,75,70,82,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,82,91,75,91,0,72,91,76,70,76,91,32,76,70,89,70,32,76,80,84,80,32,76,91,89,91,0,72,90,76,70,76,91,32,76,70,89,70,32,76,80,84,80,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,90,83,32,85,83,90,83,0,71,93,75,70,75,91,32,89,70,89,91,32,75,80,89,80,0,78,86,82,70,82,91,0,74,90,86,70,86,86,85,89,84,90,82,91,80,91,78,90,77,89,76,86,76,84,0,71,92,75,70,75,91,32,89,70,75,84,32,80,79,89,91,0,72,89,76,70,76,91,32,76,91,88,91,0,70,94,74,70,74,91,32,74,70,82,91,32,90,70,82,91,32,90,70,90,91,0,71,93,75,70,75,91,32,75,70,89,91,32,89,70,89,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,75,81,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,83,87,89,93,0,71,92,75,70,75,91,32,75,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,84,80,75,80,32,82,80,89,91,0,72,92,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,74,90,82,70,82,91,32,75,70,89,70,0,71,93,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,0,73,91,74,70,82,91,32,90,70,82,91,0,70,94,72,70,77,91,32,82,70,77,91,32,82,70,87,91,32,92,70,87,91,0,72,92,75,70,89,91,32,89,70,75,91,0,73,91,74,70,82,80,82,91,32,90,70,82,80,0,72,92,89,70,75,91,32,75,70,89,70,32,75,91,89,91,0,72,89,76,70,76,91,32,76,70,88,70,0,73,91,82,70,74,91,32,82,70,90,91,32,74,91,90,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,79,80,85,80,0,73,91,82,70,74,91,32,82,70,90,91,0,73,91,75,70,89,70,32,79,80,85,80,32,75,91,89,91,0,71,93,75,70,75,91,32,89,70,89,91,32,75,70,89,70,0,73,91,75,70,82,80,75,91,32,75,70,89,70,32,75,91,89,91,0,73,91,75,75,75,73,76,71,77,70,79,70,80,71,81,73,82,77,82,91,32,89,75,89,73,88,71,87,70,85,70,84,71,83,73,82,77,0,72,92,82,70,82,91,32,80,75,77,76,76,77,75,79,75,82,76,84,77,85,80,86,84,86,87,85,88,84,89,82,89,79,88,77,87,76,84,75,80,75,0,72,92,75,70,89,91,32,75,91,89,70,0,71,93,82,70,82,91,32,73,76,74,76,75,77,76,81,77,83,78,84,81,85,83,85,86,84,87,83,88,81,89,77,90,76,91,76,0,72,92,75,91,79,91,76,84,75,80,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,80,88,84,85,91,89,91,0,71,91,71,91,73,90,76,87,79,83,83,76,86,70,86,91,85,88,83,85,81,83,78,81,76,81,75,82,75,84,76,86,78,88,81,90,84,91,89,91,0,70,93,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,88,70,90,71,91,73,91,75,90,77,89,78,87,79,84,80,32,83,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,82,91,80,90,79,88,0,72,92,84,76,84,77,85,78,87,78,89,77,90,75,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,87,86,0,71,94,84,70,82,71,81,73,80,77,79,83,78,86,77,88,75,90,73,91,71,91,70,90,70,88,71,87,73,87,75,88,77,90,80,91,83,91,86,90,88,88,90,84,91,79,91,75,90,72,89,71,87,70,84,70,82,72,82,74,83,77,85,80,87,82,90,84,92,85,0,72,92,86,74,86,75,87,76,89,76,90,75,90,73,89,71,86,70,82,70,79,71,78,73,78,76,79,78,80,79,83,80,80,80,77,81,76,82,75,84,75,87,76,89,77,90,80,91,83,91,86,90,88,88,89,86,0,72,92,82,76,80,76,78,75,77,73,78,71,81,70,84,70,88,71,91,71,93,70,32,88,71,86,78,84,84,82,88,80,90,78,91,76,91,74,90,73,88,73,86,74,85,76,85,78,86,32,81,80,90,80,0,71,94,71,91,73,90,77,86,80,81,81,78,82,74,82,71,81,70,80,70,79,71,78,73,78,76,79,78,81,79,85,79,88,78,89,77,90,75,90,81,89,86,88,88,86,90,83,91,79,91,76,90,74,88,73,86,73,84,0,70,94,77,77,75,76,74,74,74,73,75,71,77,70,78,70,80,71,81,73,81,75,80,79,78,85,76,89,74,91,72,91,71,90,71,88,32,77,82,86,79,88,78,91,76,93,74,94,72,94,71,93,70,92,70,90,72,88,76,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,73,90,87,86,85,84,83,81,82,79,81,76,81,73,82,71,83,70,85,70,86,71,87,73,87,76,86,81,84,86,83,88,81,90,79,91,77,91,75,90,74,88,74,86,75,85,77,85,79,86,0,74,89,84,94,82,91,80,86,79,80,79,74,80,71,82,70,84,70,85,71,86,74,86,77,85,82,82,91,80,97,79,100,78,102,76,103,75,102,75,100,76,97,78,94,80,92,83,90,87,88,0,70,94,77,77,75,76,74,74,74,73,75,71,77,70,78,70,80,71,81,73,81,75,80,79,78,85,76,89,74,91,72,91,71,90,71,88,32,94,73,94,71,93,70,92,70,90,71,88,73,86,76,84,78,82,79,80,79,32,82,79,83,81,83,88,84,90,85,91,86,91,88,90,89,89,91,86,0,73,92,77,82,79,82,83,81,86,79,88,77,89,75,89,72,88,70,86,70,85,71,84,73,83,78,82,83,81,86,80,88,78,90,76,91,74,91,73,90,73,88,74,87,76,87,78,88,81,90,84,91,86,91,89,90,91,88,0,64,97,69,77,67,76,66,74,66,73,67,71,69,70,70,70,72,71,73,73,73,75,72,80,71,84,69,91,32,71,84,74,76,76,72,77,71,79,70,80,70,82,71,83,73,83,75,82,80,81,84,79,91,32,81,84,84,76,86,72,87,71,89,70,90,70,92,71,93,73,93,75,92,80,90,87,90,90,91,91,92,91,94,90,95,89,97,86,0,69,93,74,77,72,76,71,74,71,73,72,71,74,70,75,70,77,71,78,73,78,75,77,80,76,84,74,91,32,76,84,79,76,81,72,82,71,84,70,86,70,88,71,89,73,89,75,88,80,86,87,86,90,87,91,88,91,90,90,91,89,93,86,0,72,93,84,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,83,90,79,90,75,89,72,88,71,86,70,84,70,82,72,82,75,83,78,85,81,87,83,90,85,92,86,0,70,95,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,90,70,92,71,93,72,94,74,94,77,93,79,92,80,90,81,87,81,85,80,84,79,0,72,94,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,83,83,87,80,89,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,83,91,86,91,89,90,91,88,0,70,95,83,72,84,73,84,76,83,80,82,83,81,85,79,88,77,90,75,91,74,91,73,90,73,87,74,82,75,79,76,77,78,74,80,72,82,71,85,70,89,70,91,71,92,72,93,74,93,77,92,79,91,80,89,81,86,81,83,80,84,81,85,83,85,88,86,90,88,91,90,90,91,89,93,86,0,72,92,72,91,74,90,76,88,79,84,81,81,83,77,84,74,84,71,83,70,82,70,81,71,80,73,80,75,81,77,83,79,86,81,88,83,89,85,89,87,88,89,87,90,84,91,80,91,77,90,75,88,74,86,74,84,0,72,91,82,76,80,76,78,75,77,73,78,71,81,70,84,70,88,71,91,71,93,70,32,88,71,86,78,84,84,82,88,80,90,78,91,76,91,74,90,73,88,73,86,74,85,76,85,78,86,0,69,93,74,77,72,76,71,74,71,73,72,71,74,70,75,70,77,71,78,73,78,75,77,79,76,82,75,86,75,88,76,90,78,91,80,91,82,90,83,89,85,85,88,77,90,70,32,88,77,87,81,86,87,86,90,87,91,88,91,90,90,91,89,93,86,0,70,93,75,77,73,76,72,74,72,73,73,71,75,70,76,70,78,71,79,73,79,75,78,79,77,82,76,86,76,89,77,91,79,91,81,90,84,87,86,84,88,80,89,77,90,73,90,71,89,70,88,70,87,71,86,73,86,75,87,78,89,80,91,81,0,67,95,72,77,70,76,69,74,69,73,70,71,72,70,73,70,75,71,76,73,76,76,75,91,32,85,70,75,91,32,85,70,83,91,32,97,70,95,71,92,74,89,78,86,84,83,91,0,70,94,78,76,76,76,75,75,75,73,76,71,78,70,80,70,82,71,83,73,83,76,81,85,81,88,82,90,84,91,86,91,88,90,89,88,89,86,88,85,86,85,32,93,73,93,71,92,70,90,70,88,71,86,73,84,76,80,85,78,88,76,90,74,91,72,91,71,90,71,88,0,70,93,75,77,73,76,72,74,72,73,73,71,75,70,76,70,78,71,79,73,79,75,78,79,77,82,76,86,76,88,77,90,78,91,80,91,82,90,84,88,86,85,87,83,89,77,32,91,70,89,77,86,87,84,93,82,98,80,102,78,103,77,102,77,100,78,97,80,94,83,91,86,89,91,86,0,72,93,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,84,84,87,80,90,78,91,75,91,74,90,74,88,75,87,78,87,80,88,81,89,82,91,82,94,81,97,80,99,78,102,76,103,75,102,75,100,76,97,78,94,81,91,84,89,90,86,0,73,91,74,70,82,91,32,90,70,82,91,32,74,70,90,70,0,71,93,73,76,91,98,0,69,95,82,74,73,90,32,82,74,91,90,0,73,91,74,91,90,91,0,73,91,74,91,90,91,90,90,74,90,74,91,0,73,92,88,77,88,91,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,72,91,76,70,76,91,32,76,80,78,78,80,77,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,80,91,78,90,76,88,0,73,91,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,92,88,70,88,91,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,91,76,83,88,83,88,81,87,79,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,77,89,87,70,85,70,83,71,82,74,82,91,32,79,77,86,77,0,73,92,88,77,88,93,87,96,86,97,84,98,81,98,79,97,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,73,92,77,70,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,0,78,86,81,70,82,71,83,70,82,69,81,70,32,82,77,82,91,0,77,87,82,70,83,71,84,70,83,69,82,70,32,83,77,83,94,82,97,80,98,78,98,0,73,90,77,70,77,91,32,87,77,77,87,32,81,83,88,91,0,67,97,71,77,71,91,32,71,81,74,78,76,77,79,77,81,78,82,81,82,91,32,82,81,85,78,87,77,90,77,92,78,93,81,93,91,0,73,92,77,77,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,0,73,92,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,89,85,89,83,88,80,86,78,84,77,81,77,0,72,91,76,77,76,98,32,76,80,78,78,80,77,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,80,91,78,90,76,88,0,73,92,88,77,88,98,32,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,0,75,88,79,77,79,91,32,79,83,80,80,82,78,84,77,87,77,0,74,91,88,80,87,78,84,77,81,77,78,78,77,80,78,82,80,83,85,84,87,85,88,87,88,88,87,90,84,91,81,91,78,90,77,88,0,77,89,82,70,82,87,83,90,85,91,87,91,32,79,77,86,77,0,73,92,77,77,77,87,78,90,80,91,83,91,85,90,88,87,32,88,77,88,91,0,74,90,76,77,82,91,32,88,77,82,91,0,71,93,74,77,78,91,32,82,77,78,91,32,82,77,86,91,32,90,77,86,91,0,74,91,77,77,88,91,32,88,77,77,91,0,74,90,76,77,82,91,32,88,77,82,91,80,95,78,97,76,98,75,98,0,74,91,88,77,77,91,32,77,77,88,77,32,77,91,88,91,0,72,93,81,77,79,78,77,80,76,82,75,85,75,88,76,90,78,91,80,91,82,90,85,87,87,84,89,80,90,77,32,81,77,83,77,84,78,85,80,87,88,88,90,89,91,90,91,0,73,92,85,70,83,71,81,73,79,77,78,80,77,84,76,90,75,98,32,85,70,87,70,89,72,89,75,88,77,87,78,85,79,82,79,32,82,79,84,80,86,82,87,84,87,87,86,89,85,90,83,91,81,91,79,90,78,89,77,86,0,73,92,74,80,76,78,78,77,79,77,81,78,82,79,83,82,83,86,82,91,32,90,77,89,80,88,82,82,91,80,95,79,98,0,73,91,84,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,87,82,86,79,84,77,82,75,81,73,81,71,82,70,84,70,86,71,88,73,0,74,90,87,79,86,78,84,77,81,77,79,78,79,80,80,82,83,83,32,83,83,79,84,77,86,77,88,78,90,80,91,83,91,85,90,87,88,0,74,89,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,88,75,84,77,81,79,78,82,77,85,77,87,78,89,80,91,83,93,84,95,84,97,83,98,81,98,80,96,0,72,92,73,81,74,79,76,77,78,77,79,78,79,80,78,84,76,91,32,78,84,80,80,82,78,84,77,86,77,88,79,88,82,87,87,84,98,0,71,92,72,81,73,79,75,77,77,77,78,78,78,80,77,85,77,88,78,90,79,91,81,91,83,90,85,87,86,85,87,82,88,77,88,74,87,71,85,70,83,70,82,72,82,74,83,77,85,80,87,82,90,84,0,76,87,82,77,80,84,79,88,79,90,80,91,82,91,84,89,85,87,0,73,91,79,77,75,91,32,89,78,88,77,87,77,85,78,81,82,79,83,78,83,32,78,83,80,84,81,85,83,90,84,91,85,91,86,90,0,74,90,75,70,77,70,79,71,80,72,88,91,32,82,77,76,91,0,72,93,79,77,73,98,32,78,81,77,86,77,89,79,91,81,91,83,90,85,88,87,84,32,89,77,87,84,86,88,86,90,87,91,89,91,91,89,92,87,0,73,91,76,77,79,77,78,83,77,88,76,91,32,89,77,88,80,87,82,85,85,82,88,79,90,76,91,0,74,90,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,85,75,82,76,80,77,79,79,79,81,81,83,84,84,86,84,32,84,84,80,85,78,86,77,88,77,90,79,92,83,94,84,95,84,97,82,98,80,98,0,74,91,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,83,91,85,90,87,88,88,85,88,82,87,79,86,78,84,77,82,77,0,71,93,80,77,76,91,32,85,77,86,83,87,88,88,91,32,73,80,75,78,78,77,91,77,0,73,91,77,83,77,86,78,89,79,90,81,91,83,91,85,90,87,88,88,85,88,82,87,79,86,78,84,77,82,77,80,78,78,80,77,83,73,98,0,73,93,91,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,87,82,86,79,85,78,83,77,0,72,92,83,77,80,91,32,74,80,76,78,79,77,90,77,0,72,92,73,81,74,79,76,77,78,77,79,78,79,80,77,86,77,89,79,91,81,91,84,90,86,88,88,84,89,80,89,77,0,71,93,79,78,77,79,75,81,74,84,74,87,75,89,76,90,78,91,81,91,84,90,87,88,89,85,90,82,90,79,88,77,86,77,84,79,82,83,80,88,77,98,0,73,91,75,77,77,77,79,79,85,96,87,98,89,98,32,90,77,89,79,87,82,77,93,75,96,74,98,0,70,93,86,70,78,98,32,71,81,72,79,74,77,76,77,77,78,77,80,76,85,76,88,77,90,79,91,81,91,84,90,86,88,88,85,90,80,91,77,0,70,93,78,77,76,78,74,81,73,84,73,87,74,90,75,91,77,91,79,90,81,87,32,82,83,81,87,82,90,83,91,85,91,87,90,89,87,90,84,90,81,89,78,88,77,0,76,92,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,77,91,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,84,78,90,79,91,80,91,82,90,84,88,85,85,85,82,86,86,87,87,89,87,91,86,0,77,88,84,84,84,83,83,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,0,76,92,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,90,70,32,86,82,85,87,85,90,86,91,87,91,89,90,90,89,92,86,0,78,88,79,89,81,88,82,87,83,85,83,83,82,82,81,82,79,83,78,85,78,88,79,90,81,91,83,91,85,90,86,89,88,86,0,79,87,79,86,83,81,85,78,86,76,87,73,87,71,86,70,84,71,83,73,81,81,78,90,75,97,74,100,74,102,75,103,77,102,78,99,79,90,80,91,82,91,84,90,85,89,87,86,0,76,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,32,86,82,84,89,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,85,91,88,89,91,86,0,77,92,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,83,77,91,32,77,91,78,88,79,86,81,83,83,82,85,82,86,83,86,85,85,88,85,90,86,91,87,91,89,90,90,89,92,86,0,80,87,83,77,83,78,84,78,84,77,83,77,32,80,86,82,82,80,88,80,90,81,91,82,91,84,90,85,89,87,86,0,80,87,83,77,83,78,84,78,84,77,83,77,32,80,86,82,82,76,100,75,102,73,103,72,102,72,100,73,97,76,94,79,92,81,91,84,89,87,86,0,77,91,77,86,79,83,82,78,83,76,84,73,84,71,83,70,81,71,80,73,79,77,78,83,77,91,32,77,91,78,88,79,86,81,83,83,82,85,82,86,83,86,85,84,86,81,86,32,81,86,83,87,84,90,85,91,86,91,88,90,89,89,91,86,0,79,87,79,86,81,83,84,78,85,76,86,73,86,71,85,70,83,71,82,73,81,77,80,84,80,90,81,91,82,91,84,90,85,89,87,86,0,69,94,69,86,71,83,73,82,74,83,74,84,73,88,72,91,32,73,88,74,86,76,83,78,82,80,82,81,83,81,84,80,88,79,91,32,80,88,81,86,83,83,85,82,87,82,88,83,88,85,87,88,87,90,88,91,89,91,91,90,92,89,94,86,0,74,92,74,86,76,83,78,82,79,83,79,84,78,88,77,91,32,78,88,79,86,81,83,83,82,85,82,86,83,86,85,85,88,85,90,86,91,87,91,89,90,90,89,92,86,0,76,90,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,85,87,85,85,84,83,82,82,81,83,81,85,82,87,84,88,87,88,89,87,90,86,0,75,90,75,86,77,83,78,81,77,85,71,103,32,77,85,78,83,80,82,82,82,84,83,85,85,85,87,84,89,83,90,81,91,32,77,90,79,91,82,91,85,90,87,89,90,86,0,76,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,32,86,82,85,85,83,90,80,97,79,100,79,102,80,103,82,102,83,99,83,92,85,91,88,89,91,86,0,77,90,77,86,79,83,80,81,80,83,83,83,84,84,84,86,83,89,83,90,84,91,85,91,87,90,88,89,90,86,0,78,89,78,86,80,83,81,81,81,83,83,86,84,88,84,90,82,91,32,78,90,80,91,84,91,86,90,87,89,89,86,0,79,88,79,86,81,83,83,79,32,86,70,80,88,80,90,81,91,83,91,85,90,86,89,88,86,32,80,78,87,78,0,76,91,76,86,78,82,76,88,76,90,77,91,79,91,81,90,83,88,85,85,32,86,82,84,88,84,90,85,91,86,91,88,90,89,89,91,86,0,76,91,76,86,78,82,77,87,77,90,78,91,79,91,82,90,84,88,85,85,85,82,32,85,82,86,86,87,87,89,87,91,86,0,73,94,76,82,74,84,73,87,73,89,74,91,76,91,78,90,80,88,32,82,82,80,88,80,90,81,91,83,91,85,90,87,88,88,85,88,82,32,88,82,89,86,90,87,92,87,94,86,0,74,90,74,86,76,83,78,82,80,82,81,83,81,90,82,91,85,91,88,89,90,86,32,87,83,86,82,84,82,83,83,79,90,78,91,76,91,75,90,0,76,91,76,86,78,82,76,88,76,90,77,91,79,91,81,90,83,88,85,85,32,86,82,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,85,91,88,89,91,86,0,76,90,76,86,78,83,80,82,82,82,84,84,84,86,83,88,81,90,78,91,80,92,81,94,81,97,80,100,79,102,77,103,76,102,76,100,77,97,80,94,83,92,87,89,90,86,0,74,92,75,91,78,90,81,88,83,86,85,83,87,79,88,75,88,73,87,71,85,70,83,71,82,72,81,74,80,79,80,84,81,88,82,90,84,91,86,91,88,90,89,89,0,73,91,87,85,87,82,86,79,85,78,83,77,81,77,79,78,77,80,76,83,76,86,77,89,78,90,80,91,82,91,84,90,86,88,87,85,88,80,88,75,87,72,86,71,84,70,82,70,80,71,78,73,0,74,90,87,78,85,77,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,84,91,86,90,32,77,84,85,84,0,74,91,84,70,82,71,80,74,79,76,78,79,77,84,77,88,78,90,79,91,81,91,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,84,70,32,78,80,87,80,0,72,92,86,70,78,98,32,81,77,78,78,76,80,75,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,82,88,80,86,78,83,77,81,77,0,73,91,88,79,87,78,84,77,81,77,78,78,77,79,76,81,76,83,77,85,79,87,83,90,84,92,84,94,83,95,81,95,0,68,97,87,78,86,76,84,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,84,86,86,85,87,83,32,87,75,87,83,88,85,89,86,91,86,92,85,93,83,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,0,70,94,90,73,74,82,90,91,0,70,94,74,73,90,82,74,91,0,75,89,79,66,79,98,32,79,66,86,66,32,79,98,86,98,0,75,89,85,66,85,98,32,78,66,85,66,32,78,98,85,98,0,75,89,84,66,81,69,80,72,80,74,81,77,83,79,83,80,79,82,83,84,83,85,81,87,80,90,80,92,81,95,84,98,0,75,89,80,66,83,69,84,72,84,74,83,77,81,79,81,80,85,82,81,84,81,85,83,87,84,90,84,92,83,95,80,98,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,73,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,0,74,90,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,0,72,92,78,74,80,73,83,70,83,91,0,72,92,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,85,81,75,91,89,91,0,72,92,77,70,88,70,82,78,85,78,87,79,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,0,72,92,85,70,75,84,90,84,32,85,70,85,91,0,72,92,87,70,77,70,76,79,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,0,72,92,88,73,87,71,84,70,82,70,79,71,77,74,76,79,76,84,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,76,84,0,72,92,89,70,79,91,32,75,70,89,70,0,72,92,80,70,77,71,76,73,76,75,77,77,79,78,83,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,84,76,82,78,80,81,79,85,78,87,77,88,75,88,73,87,71,84,70,80,70,0,72,92,88,77,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,82,70,85,71,87,73,88,77,88,82,87,87,85,90,82,91,80,91,77,90,76,88,0,77,87,82,89,81,90,82,91,83,90,82,89,0,77,87,83,90,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,77,81,78,82,79,83,78,82,77,32,82,89,81,90,82,91,83,90,82,89,0,77,87,82,77,81,78,82,79,83,78,82,77,32,83,90,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,70,82,84,32,82,89,81,90,82,91,83,90,82,89,0,73,91,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,86,79,82,81,82,84,32,82,89,81,90,82,91,83,90,82,89,0,78,86,82,70,82,77,0,74,90,78,70,78,77,32,86,70,86,77,0,75,89,81,70,79,71,78,73,78,75,79,77,81,78,83,78,85,77,86,75,86,73,85,71,83,70,81,70,0,72,92,80,66,80,95,32,84,66,84,95,32,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,71,93,91,66,73,98,0,75,89,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,0,78,86,82,66,82,98,0,69,95,73,82,91,82,0,69,95,82,73,82,91,32,73,82,91,82,0,69,95,73,79,91,79,32,73,85,91,85,0,71,93,75,75,89,89,32,89,75,75,89,0,74,90,82,76,82,88,32,77,79,87,85,32,87,79,77,85,0,77,87,82,81,81,82,82,83,83,82,82,81,0,77,87,83,70,82,71,81,73,81,75,82,76,83,75,82,74,0,77,87,82,72,81,71,82,70,83,71,83,73,82,75,81,76,0,69,95,85,77,88,80,91,82,88,84,85,87,32,73,82,91,82,0,71,93,79,70,79,98,32,85,70,85,98,32,74,81,90,81,32,74,87,90,87,0,69,95,92,79,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,76,91,74,90,73,89,72,87,72,85,73,83,74,82,81,78,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,75,78,78,80,81,85,88,87,90,89,91,91,91,92,90,92,89,0,71,93,73,73,74,75,75,79,75,85,74,89,73,91,32,91,73,90,75,89,79,89,85,90,89,91,91,32,73,73,75,74,79,75,85,75,89,74,91,73,32,73,91,75,90,79,89,85,89,89,90,91,91,0,70,95,92,81,91,79,89,78,87,78,85,79,84,80,81,84,80,85,78,86,76,86,74,85,73,83,73,81,74,79,76,78,78,78,80,79,81,80,84,84,85,85,87,86,89,86,91,85,92,83,92,81,0,75,89,79,66,79,91,32,85,66,85,91,0,70,94,82,66,82,91,32,73,91,91,91,0,70,94,91,66,73,91,91,91,0,69,95,82,73,81,74,82,75,83,74,82,73,32,73,89,72,90,73,91,74,90,73,89,32,91,89,90,90,91,91,92,90,91,89,0,70,94,82,72,78,76,75,80,74,83,74,85,75,87,77,88,79,88,81,87,82,85,32,82,72,86,76,89,80,90,83,90,85,89,87,87,88,85,88,83,87,82,85,32,82,85,81,89,80,92,32,82,85,83,89,84,92,32,80,92,84,92,0,70,94,82,78,81,75,80,73,78,72,77,72,75,73,74,75,74,79,75,82,76,84,78,87,82,92,32,82,78,83,75,84,73,86,72,87,72,89,73,90,75,90,79,89,82,88,84,86,87,82,92,0,70,94,82,71,80,74,76,79,73,82,32,82,71,84,74,88,79,91,82,32,73,82,76,85,80,90,82,93,32,91,82,88,85,84,90,82,93,0,70,94,82,84,84,87,86,88,88,88,90,87,91,85,91,83,90,81,88,80,86,80,83,81,32,83,81,85,79,86,77,86,75,85,73,83,72,81,72,79,73,78,75,78,77,79,79,81,81,32,81,81,78,80,76,80,74,81,73,83,73,85,74,87,76,88,78,88,80,87,82,84,32,82,84,81,89,80,92,32,82,84,83,89,84,92,32,80,92,84,92,0,70,94,82,82,82,91,81,92,32,82,86,81,92,32,82,73,81,72,79,72,78,73,78,75,79,78,82,82,32,82,73,83,72,85,72,86,73,86,75,85,78,82,82,32,82,82,78,79,76,78,74,78,73,79,73,81,74,82,32,82,82,86,79,88,78,90,78,91,79,91,81,90,82,32,82,82,78,85,76,86,74,86,73,85,73,83,74,82,32,82,82,86,85,88,86,90,86,91,85,91,83,90,82,0,70,94,73,83,74,83,76,84,77,86,77,88,76,90,32,73,83,73,82,74,81,76,81,77,82,78,84,78,87,77,89,76,90,32,82,71,80,73,79,76,79,79,81,85,81,88,80,90,82,92,32,82,71,84,73,85,76,85,79,83,85,83,88,84,90,82,92,32,91,83,91,82,90,81,88,81,87,82,86,84,86,87,87,89,88,90,32,91,83,90,83,88,84,87,86,87,88,88,90,32,75,86,89,86,0,80,83,83,82,82,83,81,83,80,82,80,81,81,80,82,80,83,81,83,83,82,85,81,86,32,81,81,81,82,82,82,82,81,81,81,0,80,84,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,32,82,81,81,82,82,83,83,82,82,81,0,78,86,80,79,84,85,32,84,79,80,85,32,78,82,86,82,0,77,87,82,75,81,77,79,80,77,82,32,82,75,83,77,85,80,87,82,32,82,77,79,81,32,82,77,85,81,32,82,79,80,81,32,82,79,84,81,32,81,81,83,81,32,77,82,87,82,0,77,87,77,82,77,81,78,79,79,78,81,77,83,77,85,78,86,79,87,81,87,82,32,80,78,84,78,32,79,79,85,79,32,78,80,86,80,32,78,81,86,81,32,77,82,87,82,0,76,82,76,70,76,82,82,82,76,70,32,76,73,80,81,32,76,76,79,82,32,76,79,77,81,0,77,87,82,75,81,77,79,80,77,82],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+276542);allocate([32,82,75,83,77,85,80,87,82,0,77,87,87,82,87,81,86,79,85,78,83,77,81,77,79,78,78,79,77,81,77,82,0,71,93,93,82,93,80,92,77,90,74,87,72,84,71,80,71,77,72,74,74,72,77,71,80,71,82,0,77,87,77,82,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,82,0,76,88,76,80,78,82,81,83,83,83,86,82,88,80,0,82,85,82,85,84,84,85,82,84,80,82,79,0,82,86,82,82,85,80,86,78,86,76,85,75,84,75,0,78,82,82,82,79,80,78,78,78,76,79,75,80,75,0,77,87,87,72,86,71,84,70,81,70,79,71,78,72,77,74,77,76,78,78,79,79,85,83,86,84,87,86,87,88,86,90,85,91,83,92,80,92,78,91,77,90,0,71,93,73,87,72,86,71,84,71,81,72,79,73,78,75,77,77,77,79,78,80,79,84,85,85,86,87,87,89,87,91,86,92,85,93,83,93,80,92,78,91,77,0,71,93,82,82,84,85,85,86,87,87,89,87,91,86,92,85,93,83,93,81,92,79,91,78,89,77,87,77,85,78,84,79,80,85,79,86,77,87,75,87,73,86,72,85,71,83,71,81,72,79,73,78,75,77,77,77,79,78,80,79,82,82,0,72,92,75,70,75,91,32,72,70,91,70,81,80,91,90,32,90,86,91,89,92,91,32,90,86,90,89,32,87,89,90,89,32,87,89,90,90,92,91,0,75,89,85,65,82,66,80,67,78,69,76,72,75,76,75,82,76,85,78,87,81,88,83,88,86,87,88,85,89,82,32,75,80,76,77,78,75,81,74,83,74,86,75,88,77,89,80,89,86,88,90,86,93,84,95,82,96,79,97,0,62,102,62,82,102,82,0,68,96,68,96,96,68,0,82,82,82,62,82,102,0,68,96,68,68,96,96,0,68,96,68,82,96,82,0,70,94,70,89,94,75,0,75,89,75,94,89,70,0,75,89,75,70,89,94,0,70,94,70,75,94,89,0,75,89,75,82,89,82,0,77,87,77,87,87,77,0,77,87,77,77,87,87,0,68,96,68,79,71,81,75,83,80,84,84,84,89,83,93,81,96,79,0,80,85,85,68,83,71,81,75,80,80,80,84,81,89,83,93,85,96,0,79,84,79,68,81,71,83,75,84,80,84,84,83,89,81,93,79,96,0,68,96,68,85,71,83,75,81,80,80,84,80,89,81,93,83,96,85,0,75,89,82,74,89,78,75,86,82,90,0,74,90,74,82,78,75,86,89,90,82,0,75,89,75,86,75,78,89,86,89,78,0,74,90,76,88,74,80,90,84,88,76,0,74,90,74,93,76,93,79,92,81,91,84,88,85,86,86,83,86,79,85,76,84,74,83,73,81,73,80,74,79,76,78,79,78,83,79,86,80,88,83,91,85,92,88,93,90,93,0,73,93,93,90,93,88,92,85,91,83,88,80,86,79,83,78,79,78,76,79,74,80,73,81,73,83,74,84,76,85,79,86,83,86,86,85,88,84,91,81,92,79,93,76,93,74,0,74,90,90,71,88,71,85,72,83,73,80,76,79,78,78,81,78,85,79,88,80,90,81,91,83,91,84,90,85,88,86,85,86,81,85,78,84,76,81,73,79,72,76,71,74,71,0,71,91,71,74,71,76,72,79,73,81,76,84,78,85,81,86,85,86,88,85,90,84,91,83,91,81,90,80,88,79,85,78,81,78,78,79,76,80,73,83,72,85,71,88,71,90,0,69,91,69,80,70,82,72,84,74,85,77,86,81,86,85,85,88,83,90,80,91,78,90,76,87,76,83,77,81,78,78,80,76,83,75,86,75,89,76,92,77,94,0,69,89,69,84,72,86,75,87,80,87,83,86,86,84,88,81,89,78,89,76,88,75,86,75,83,76,80,78,78,81,77,84,77,89,78,92,80,95,0,79,85,81,79,79,81,79,83,81,85,83,85,85,83,85,81,83,79,81,79,32,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,32,82,81,81,82,82,83,83,82,82,81,0,68,96,68,82,74,82,32,79,82,85,82,32,90,82,96,82,0,68,96,68,85,68,79,96,79,96,85,0,74,90,82,68,74,82,32,82,68,90,82,0,68,96,68,82,96,82,32,74,89,90,89,32,80,96,84,96,0,68,96,68,82,96,82,32,68,82,82,98,32,96,82,82,98,0,75,89,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,0,76,88,76,76,76,88,88,88,88,76,76,76,0,75,89,82,74,75,86,89,86,82,74,0,76,88,82,72,76,82,82,92,88,82,82,72,0,74,90,82,73,80,79,74,79,79,83,77,89,82,85,87,89,85,83,90,79,84,79,82,73,0,75,89,82,75,82,89,32,75,82,89,82,0,77,87,77,77,87,87,32,87,77,77,87,0,77,87,82,76,82,88,32,77,79,87,85,32,87,79,77,85,0,78,86,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,32,79,81,79,83,32,80,80,80,84,32,81,79,81,85,32,82,79,82,85,32,83,79,83,85,32,84,80,84,84,32,85,81,85,83,0,78,86,78,78,78,86,86,86,86,78,78,78,32,79,79,79,85,32,80,79,80,85,32,81,79,81,85,32,82,79,82,85,32,83,79,83,85,32,84,79,84,85,32,85,79,85,85,0,77,87,82,76,77,85,87,85,82,76,32,82,79,79,84,32,82,79,85,84,32,82,82,81,84,32,82,82,83,84,0,76,85,76,82,85,87,85,77,76,82,32,79,82,84,85,32,79,82,84,79,32,82,82,84,83,32,82,82,84,81,0,77,87,82,88,87,79,77,79,82,88,32,82,85,85,80,32,82,85,79,80,32,82,82,83,80,32,82,82,81,80,0,79,88,88,82,79,77,79,87,88,82,32,85,82,80,79,32,85,82,80,85,32,82,82,80,81,32,82,82,80,83,0,76,88,82,76,78,87,88,80,76,80,86,87,82,76,32,82,82,82,76,32,82,82,76,80,32,82,82,78,87,32,82,82,86,87,32,82,82,88,80,0,77,87,82,76,82,88,32,79,79,85,79,32,77,85,79,87,81,88,83,88,85,87,87,85,0,76,88,82,76,82,88,32,76,81,77,79,87,79,88,81,32,80,87,84,87,0,75,89,77,78,87,88,32,87,78,77,88,32,79,76,76,79,75,81,32,85,76,88,79,89,81,0,73,91,78,73,73,91,32,86,73,91,91,32,77,77,91,91,32,87,77,73,91,32,78,73,86,73,32,77,77,87,77,0,73,91,82,71,82,86,32,77,74,87,80,32,87,74,77,80,32,73,86,76,92,32,91,86,88,92,32,73,86,91,86,32,76,92,88,92,0,71,91,77,74,83,86,32,75,80,83,76,32,71,92,91,92,91,82,71,92,0,76,88,80,76,80,80,76,80,76,84,80,84,80,88,84,88,84,84,88,84,88,80,84,80,84,76,80,76,0,75,89,89,80,88,78,86,76,83,75,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,84,32,89,80,87,78,85,77,83,77,81,78,80,79,79,81,79,83,80,85,81,86,83,87,85,87,87,86,89,84,0,75,89,82,74,75,86,89,86,82,74,32,82,90,89,78,75,78,82,90,0,71,93,80,73,80,71,81,70,83,70,84,71,84,73,32,71,90,72,88,74,86,75,84,76,80,76,75,77,74,79,73,85,73,87,74,88,75,88,80,89,84,90,86,92,88,93,90,32,71,90,93,90,32,81,90,80,91,81,92,83,92,84,91,83,90,0,74,90,82,77,82,83,32,82,83,81,92,32,82,83,83,92,32,81,92,83,92,32,82,77,81,74,80,72,78,71,32,81,74,78,71,32,82,77,83,74,84,72,86,71,32,83,74,86,71,32,82,77,78,75,76,75,74,77,32,80,76,76,76,74,77,32,82,77,86,75,88,75,90,77,32,84,76,88,76,90,77,32,82,77,80,78,79,79,79,82,32,82,77,80,79,79,82,32,82,77,84,78,85,79,85,82,32,82,77,84,79,85,82,0,74,90,82,73,82,75,32,82,78,82,80,32,82,83,82,85,32,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,71,81,73,80,74,32,82,71,83,73,84,74,32,80,74,82,73,84,74,32,82,75,80,78,78,79,77,78,32,82,75,84,78,86,79,87,78,32,78,79,80,79,82,78,84,79,86,79,32,82,80,80,83,78,84,76,84,75,82,75,83,76,84,32,82,80,84,83,86,84,88,84,89,82,89,83,88,84,32,78,84,80,84,82,83,84,84,86,84,32,82,85,80,88,79,89,77,90,76,90,75,89,74,87,74,89,76,90,32,82,85,84,88,85,89,87,90,88,90,89,89,90,87,90,89,88,90,32,77,90,79,90,82,89,85,90,87,90,0,74,90,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,89,85,90,88,90,90,88,90,85,89,84,87,84,89,82,90,79,89,77,87,76,85,77,86,74,85,72,83,71,81,71,79,72,78,74,79,77,77,76,75,77,74,79,75,82,77,84,75,84,74,85,74,88,76,90,79,90,82,89,0,74,90,82,89,81,92,32,82,89,83,92,32,81,92,83,92,32,82,89,86,88,86,86,88,85,88,82,90,81,90,76,89,73,88,72,86,72,84,71,80,71,78,72,76,72,75,73,74,76,74,81,76,82,76,85,78,86,78,88,82,89,0,73,91,73,80,75,82,32,76,75,78,80,32,82,71,82,79,32,88,75,86,80,32,91,80,89,82,0,81,83,82,81,81,82,82,83,83,82,82,81,0,80,84,81,80,80,81,80,83,81,84,83,84,84,83,84,81,83,80,81,80,0,78,86,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,0,77,87,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,0,71,93,80,71,77,72,74,74,72,77,71,80,71,84,72,87,74,90,77,92,80,93,84,93,87,92,90,90,92,87,93,84,93,80,92,77,90,74,87,72,84,71,80,71,0,65,99,80,65,76,66,74,67,71,69,69,71,67,74,66,76,65,80,65,84,66,88,67,90,69,93,71,95,74,97,76,98,80,99,84,99,88,98,90,97,93,95,95,93,97,90,98,88,99,84,99,80,98,76,97,74,95,71,93,69,90,67,88,66,84,65,80,65,0,60,104,80,60,75,61,71,63,68,65,65,68,63,71,61,75,60,80,60,84,61,89,63,93,65,96,68,99,71,101,75,103,80,104,84,104,89,103,93,101,96,99,99,96,101,93,103,89,104,84,104,80,103,75,101,71,99,68,96,65,93,63,89,61,84,60,80,60,0,41,123,79,41,73,42,69,43,64,45,59,48,55,51,51,55,48,59,45,64,43,69,42,73,41,79,41,85,42,91,43,95,45,100,48,105,51,109,55,113,59,116,64,119,69,121,73,122,79,123,85,123,91,122,95,121,100,119,105,116,109,113,113,109,116,105,119,100,121,95,122,91,123,85,123,79,122,73,121,69,119,64,116,59,113,55,109,51,105,48,100,45,95,43,91,42,85,41,79,41,0,62,102,82,65,80,67,77,68,74,68,71,67,69,65,62,72,64,74,65,77,65,90,66,93,68,95,71,96,77,96,80,97,82,99,32,82,65,84,67,87,68,90,68,93,67,95,65,102,72,100,74,99,77,99,90,98,93,96,95,93,96,87,96,84,97,82,99,0,65,99,82,65,80,67,77,68,74,68,71,67,69,65,66,71,65,75,65,80,66,84,68,88,71,92,76,96,82,99,32,82,65,84,67,87,68,90,68,93,67,95,65,98,71,99,75,99,80,98,84,96,88,93,92,88,96,82,99,32,66,72,98,72,0,72,91,87,80,86,81,87,82,88,81,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,76,98,88,70,0,75,89,82,75,77,88,32,82,78,86,88,32,82,75,87,88,32,79,84,84,84,32,75,88,80,88,32,84,88,89,88,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,86,80,83,81,32,83,75,85,76,86,78,85,80,83,81,32,79,81,83,81,86,82,87,84,87,85,86,87,83,88,76,88,32,83,81,85,82,86,84,86,85,85,87,83,88,0,75,89,86,76,87,75,87,79,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,85,32,81,75,79,77,78,80,78,83,79,86,81,88,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,77,88,80,88,83,87,86,86,87,83,88,76,88,32,83,75,85,76,86,77,87,80,87,83,86,86,85,87,83,88,0,74,89,78,75,78,88,32,79,75,79,88,32,83,79,83,83,32,76,75,86,75,86,79,85,75,32,79,81,83,81,32,76,88,86,88,86,84,85,88,0,74,88,78,75,78,88,32,79,75,79,88,32,83,79,83,83,32,76,75,86,75,86,79,85,75,32,79,81,83,81,32,76,88,81,88,0,75,91,86,76,87,75,87,79,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,85,87,86,85,32,86,83,86,88,32,87,83,87,88,32,84,83,89,83,0,74,91,78,75,78,88,32,79,75,79,88,32,86,75,86,88,32,87,75,87,88,32,76,75,81,75,32,84,75,89,75,32,79,81,86,81,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,88,32,83,75,83,88,32,80,75,85,75,32,80,88,85,88,0,76,88,83,75,83,85,82,87,81,88,32,84,75,84,85,83,87,81,88,80,88,78,87,77,85,78,84,79,85,78,86,32,81,75,86,75,0,74,90,78,75,78,88,32,79,75,79,88,32,87,75,79,83,32,81,81,86,88,32,82,81,87,88,32,76,75,81,75,32,84,75,89,75,32,76,88,81,88,32,84,88,89,88,0,75,88,79,75,79,88,32,80,75,80,88,32,77,75,82,75,32,77,88,87,88,87,84,86,88,0,73,92,77,75,77,88,32,78,78,82,88,32,78,75,82,85,32,87,75,82,88,32,87,75,87,88,32,88,75,88,88,32,75,75,78,75,32,87,75,90,75,32,75,88,79,88,32,85,88,90,88,0,74,90,78,75,78,88,32,79,77,86,88,32,79,75,86,86,32,86,75,86,88,32,76,75,79,75,32,84,75,88,75,32,76,88,80,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,0,74,89,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,81,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,32,80,87,80,85,81,84,83,84,84,85,85,90,86,91,87,91,88,90,32,84,85,85,88,86,90,87,91,0,74,90,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,81,88,32,83,82,84,83,85,87,86,88,87,88,88,87,32,83,82,85,83,86,87,87,88,0,75,90,86,77,87,75,87,79,86,77,85,76,83,75,81,75,79,76,78,77,78,79,79,80,81,81,84,82,86,83,87,84,32,78,78,79,79,81,80,84,81,86,82,87,83,87,86,86,87,84,88,82,88,80,87,79,86,78,84,78,88,79,86,0,75,90,82,75,82,88,32,83,75,83,88,32,78,75,77,79,77,75,88,75,88,79,87,75,32,80,88,85,88,0,74,91,78,75,78,85,79,87,81,88,84,88,86,87,87,85,87,75,32,79,75,79,85,80,87,81,88,32,76,75,81,75,32,85,75,89,75,0,75,89,77,75,82,88,32,78,75,82,85,32,87,75,82,88,32,75,75,80,75,32,84,75,89,75,0,73,91,76,75,79,88,32,77,75,79,84,32,82,75,79,88,32,82,75,85,88,32,83,75,85,84,32,88,75,85,88,32,74,75,79,75,32,86,75,90,75,0,75,90,78,75,86,88,32,79,75,87,88,32,87,75,78,88,32,76,75,81,75,32,84,75,89,75,32,76,88,81,88,32,84,88,89,88,0,76,89,78,75,82,82,82,88,32,79,75,83,82,32,87,75,83,82,83,88,32,76,75,81,75,32,84,75,89,75,32,80,88,85,88,0,76,89,86,75,78,88,32,87,75,79,88,32,79,75,78,79,78,75,87,75,32,78,88,87,88,87,84,86,88,0,75,88,79,75,79,88,32,80,75,80,88,32,77,75,87,75,87,79,86,75,32,77,88,82,88,0,75,89,82,75,76,88,32,82,77,87,88,32,82,75,88,88,32,77,87,86,87,32,76,88,88,88,0,75,90,81,75,79,76,78,77,77,80,77,83,78,86,79,87,81,88,84,88,86,87,87,86,88,83,88,80,87,77,86,76,84,75,81,75,32,81,75,79,77,78,80,78,83,79,86,81,88,32,84,88,86,86,87,83,87,80,86,77,84,75,32,81,79,81,84,32,84,79,84,84,32,81,81,84,81,32,81,82,84,82,0,75,89,82,75,77,88,32,82,78,86,88,32,82,75,87,88,32,75,88,80,88,32,84,88,89,88,0,74,90,77,74,76,77,32,88,74,87,77,32,80,80,79,83,32,85,80,84,83,32,77,86,76,89,32,88,86,87,89,32,77,75,87,75,32,77,76,87,76,32,80,81,84,81,32,80,82,84,82,32,77,87,87,87,32,77,88,87,88,0,74,91,78,75,78,88,32,79,75,79,88,32,86,75,86,88,32,87,75,87,88,32,76,75,89,75,32,76,88,81,88,32,84,88,89,88,0,75,91,77,75,82,81,32,78,75,83,81,77,88,32,77,75,87,75,88,79,86,75,32,78,87,87,87,32,77,88,87,88,88,84,86,88,0,75,90,77,79,78,76,79,75,80,75,81,76,82,79,82,88,32,88,79,87,76,86,75,85,75,84,76,83,79,83,88,32,77,79,78,77,79,76,80,76,81,77,82,79,32,88,79,87,77,86,76,85,76,84,77,83,79,32,80,88,85,88,0,75,90,82,75,82,88,32,83,75,83,88,32,81,78,78,79,77,81,77,82,78,84,81,85,84,85,87,84,88,82,88,81,87,79,84,78,81,78,32,81,78,79,79,78,81,78,82,79,84,81,85,32,84,85,86,84,87,82,87,81,86,79,84,78,32,80,75,85,75,32,80,88,85,88,0,74,91,82,75,82,88,32,83,75,83,88,32,76,80,77,79,78,79,79,83,81,85,32,84,85,86,83,87,79,88,79,89,80,32,77,79,78,82,79,84,81,85,84,85,86,84,87,82,88,79,32,80,75,85,75,32,80,88,85,88,0,75,90,77,86,78,88,81,88,77,82,77,79,78,77,79,76,81,75,84,75,86,76,87,77,88,79,88,82,84,88,87,88,88,86,32,79,85,78,82,78,79,79,77,81,75,32,84,75,86,77,87,79,87,82,86,85,32,78,87,80,87,32,85,87,87,87,0,75,89,84,75,75,88,32,83,77,84,88,32,84,75,85,88,32,78,84,84,84,32,73,88,78,88,32,82,88,87,88,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,87,78,86,80,83,81,32,85,75,86,76,86,78,85,80,83,81,32,79,81,82,81,84,82,85,83,85,85,84,87,81,88,74,88,32,82,81,84,83,84,85,83,87,81,88,0,75,88,86,76,87,76,88,75,87,78,86,76,84,75,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,85,32,82,75,80,77,79,79,78,82,78,86,80,88,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,84,75,86,76,87,78,87,81,86,84,85,86,84,87,81,88,74,88,32,84,75,85,76,86,78,86,81,85,84,84,86,83,87,81,88,0,74,89,80,75,76,88,32,81,75,77,88,32,83,79,82,83,32,78,75,88,75,87,78,87,75,32,79,81,82,81,32,74,88,84,88,85,85,83,88,0,74,88,80,75,76,88,32,81,75,77,88,32,83,79,82,83,32,78,75,88,75,87,78,87,75,32,79,81,82,81,32,74,88,79,88,0,75,89,86,76,87,76,88,75,87,78,86,76,84,75,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,83,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,83,32,83,83,88,83,0,74,91,80,75,76,88,32,81,75,77,88,32,88,75,84,88,32,89,75,85,88,32,78,75,83,75,32,86,75,91,75,32,79,81,86,81,32,74,88,79,88,32,82,88,87,88,0,78,87,84,75,80,88,32,85,75,81,88,32,82,75,87,75,32,78,88,83,88,0,76,88,85,75,82,85,81,87,80,88,32,86,75,83,85,82,87,80,88,79,88,77,87,76,85,77,84,78,85,77,86,32,83,75,88,75,0,74,90,80,75,76,88,32,81,75,77,88,32,89,75,79,82,32,82,80,84,88,32,83,80,85,88,32,78,75,83,75,32,86,75,91,75,32,74,88,79,88,32,82,88,87,88,0,75,88,81,75,77,88,32,82,75,78,88,32,79,75,84,75,32,75,88,85,88,86,85,84,88,0,73,92,79,75,75,88,32,79,77,80,88,32,80,75,81,86,32,89,75,80,88,32,89,75,85,88,32,90,75,86,88,32,77,75,80,75,32,89,75,92,75,32,73,88,77,88,32,83,88,88,88,0,74,90,80,75,76,88,32,80,75,84,88,32,81,75,84,85,32,88,75,84,88,32,78,75,81,75,32,86,75,90,75,32,74,88,78,88,0,75,89,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,82,75,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,84,86,81,86,77,84,75,0,74,89,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,88,77,88,79,87,81,84,82,79,82,32,85,75,87,77,87,79,86,81,84,82,32,74,88,79,88,0,75,89,82,75,80,76,79,77,78,79,77,82,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,82,75,32,82,75,80,77,79,79,78,82,78,86,80,88,32,82,88,84,86,85,84,86,81,86,77,84,75,32,79,87,79,86,80,85,81,85,82,86,82,90,83,91,84,91,85,90,32,82,86,83,90,84,91,0,74,90,80,75,76,88,32,81,75,77,88,32,78,75,85,75,87,76,88,77,88,79,87,81,84,82,79,82,32,85,75,87,77,87,79,86,81,84,82,32,83,82,84,87,85,88,86,88,87,87,32,83,82,84,83,85,87,86,88,32,74,88,79,88,0,75,90,87,76,88,76,89,75,88,78,87,76,85,75,82,75,80,76,79,77,79,79,80,80,85,83,86,84,32,79,78,80,79,85,82,86,83,86,86,85,87,83,88,80,88,78,87,77,85,76,88,77,87,78,87,0,75,90,84,75,80,88,32,85,75,81,88,32,80,75,78,78,79,75,90,75,89,78,89,75,32,78,88,83,88,0,74,91,80,75,77,85,77,87,79,88,83,88,85,87,86,85,89,75,32,81,75,78,85,78,87,79,88,32,78,75,83,75,32,87,75,91,75,0,75,89,79,75,80,88,32,80,75,81,86,32,89,75,80,88,32,77,75,82,75,32,86,75,91,75,0,73,91,78,75,77,88,32,79,75,78,86,32,84,75,77,88,32,84,75,83,88,32,85,75,84,86,32,90,75,83,88,32,76,75,81,75,32,88,75,92,75,0,75,90,80,75,84,88,32,81,75,85,88,32,89,75,76,88,32,78,75,83,75,32,86,75,91,75,32,74,88,79,88,32,82,88,87,88,0,76,89,80,75,82,81,80,88,32,81,75,83,81,32,89,75,83,81,81,88,32,78,75,83,75,32,86,75,91,75,32,78,88,83,88,0,76,89,88,75,76,88,32,89,75,77,88,32,81,75,79,78,80,75,89,75,32,76,88,85,88,86,85,84,88,0,75,90,77,72,88,92,0,74,90,82,77,76,87,32,82,77,88,87,0,76,90,81,79,80,80,80,81,79,81,79,80,81,79,84,79,86,81,86,87,87,88,88,88,32,84,79,85,81,85,87,87,88,32,85,82,82,83,80,84,79,85,79,87,80,88,83,88,84,87,85,85,32,82,83,80,85,80,87,81,88,0,74,89,78,75,78,88,32,79,75,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,85,86,87,84,88,82,88,80,87,79,85,32,84,79,85,80,86,82,86,85,85,87,84,88,32,76,75,79,75,0,76,88,86,81,85,81,85,82,86,82,86,81,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,86,32,81,79,80,80,79,82,79,85,80,87,81,88,0,76,91,86,75,86,88,32,87,75,87,88,32,86,82,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,85,32,81,79,80,80,79,82,79,85,80,87,81,88,32,84,75,87,75,32,86,88,89,88,0,76,88,79,83,86,83,86,82,85,80,83,79,81,79,79,80,78,82,78,85,79,87,81,88,83,88,85,87,86,86,32,85,83,85,81,83,79,32,81,79,80,80,79,82,79,85,80,87,81,88,0,76,87,84,75,85,76,85,77,86,77,86,76,84,75,82,75,80,77,80,88,32,82,75,81,77,81,88,32,78,79,83,79,32,78,88,83,88,0,76,89,81,79,79,81,79,83,81,85,83,85,85,83,85,81,83,79,81,79,32,81,79,80,81,80,83,81,85,32,83,85,84,83,84,81,83,79,32,84,80,85,79,86,79,32,80,84,79,85,79,88,80,89,84,89,86,90,32,79,87,80,88,84,88,86,89,86,91,84,92,80,92,78,91,78,89,80,88,0,74,91,78,75,78,88,32,79,75,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,88,32,84,79,85,80,86,82,86,88,32,76,75,79,75,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,76,83,76,83,75,82,75,32,82,79,82,88,32,83,79,83,88,32,80,79,83,79,32,80,88,85,88,0,78,87,83,75,83,76,84,76,84,75,83,75,32,83,79,83,90,82,92,32,84,79,84,90,82,92,80,92,79,91,79,90,80,90,80,91,79,91,32,81,79,84,79,0,74,90,78,75,78,88,32,79,75,79,88,32,87,79,79,85,32,82,83,86,88,32,83,83,87,88,32,76,75,79,75,32,84,79,89,79,32,76,88,81,88,32,84,88,89,88,0,78,87,82,75,82,88,32,83,75,83,88,32,80,75,83,75,32,80,88,85,88,0,70,95,74,79,74,88,32,75,79,75,88,32,75,82,76,80,78,79,80,79,82,80,83,82,83,88,32,80,79,81,80,82,82,82,88,32,83,82,84,80,86,79,88,79,90,80,91,82,91,88,32,88,79,89,80,90,82,90,88,32,72,79,75,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,74,91,78,79,78,88,32,79,79,79,88,32,79,82,80,80,82,79,84,79,86,80,87,82,87,88,32,84,79,85,80,86,82,86,88,32,76,79,79,79,32,76,88,81,88,32,84,88,89,88,0,76,89,81,79,79,80,78,82,78,85,79,87,81,88,84,88,86,87,87,85,87,82,86,80,84,79,81,79,32,81,79,80,80,79,82,79,85,80,87,81,88,32,84,88,85,87,86,85,86,82,85,80,84,79,0,74,89,78,79,78,92,32,79,79,79,92,32,79,82,80,80,82,79,84,79,86,80,87,82,87,85,86,87,84,88,82,88,80,87,79,85,32,84,79,85,80,86,82,86,85,85,87,84,88,32,76,79,79,79,32,76,92,81,92,0,75,89,85,79,85,92,32,86,79,86,92,32,85,82,84,80,82,79,80,79,78,80,77,82,77,85,78,87,80,88,82,88,84,87,85,85,32,80,79,79,80,78,82,78,85,79,87,80,88,32,83,92,88,92,0,75,88,79,79,79,88,32,80,79,80,88,32,80,82,81,80,83,79,85,79,86,80,86,81,85,81,85,80,86,80,32,77,79,80,79,32,77,88,82,88,0,76,89,84,79,85,80,85,81,86,81,86,80,84,79,81,79,79,80,79,82,81,83,84,84,86,85,32,79,81,81,82,84,83,86,84,86,87,84,88,81,88,79,87,79,86,80,86,80,87,81,88,0,76,87,80,75,80,86,82,88,84,88,85,87,85,86,32,81,75,81,86,82,88,32,78,79,84,79,0,74,91,78,79,78,85,79,87,81,88,83,88,85,87,86,85,32,79,79,79,85,80,87,81,88,32,86,79,86,88,32,87,79,87,88,32,76,79,79,79,32,84,79,87,79,32,86,88,89,88,0,75,89,78,79,82,88,32,79,79,82,86,32,86,79,82,88,32,76,79,81,79,32,84,79,88,79,0,73,91,76,79,79,88,32,77,79,79,85,32,82,79,79,88,32,82,79,85,88,32,83,79,85,85,32,88,79,85,88,32,74,79,79,79,32,86,79,90,79,0,75,89,78,79,85,88,32,79,79,86,88,32,86,79,78,88,32,76,79,81,79,32,84,79,88,79,32,76,88,80,88,32,83,88,88,88,0,75,89,78,79,82,88,32,79,79,82,86,32,86,79,82,88,80,91,78,92,77,92,76,91,76,90,77,90,77,91,76,91,32,76,79,81,79,32,84,79,88,79,0,76,88,85,79,78,88,32,86,79,79,88,32,79,79,78,81,78,79,86,79,32,78,88,86,88,86,86,85,88,0,75,91,81,79,79,80,78,81,77,83,77,85,78,87,80,88,81,88,83,87,85,85,87,82,88,79,32,81,79,79,81,78,83,78,85,79,87,80,88,32,81,79,83,79,85,80,87,87,88,88,32,83,79,84,80,86,87,88,88,89,88,0,75,88,82,75,80,77,79,79,77,85,75,92,32,81,76,80,78,78,84,76,92,32,82,75,84,75,86,76,86,78,85,80,82,81,32,84,75,85,76,85,78,84,80,82,81,32,82,81,84,82,85,84,85,86,84,87,82,88,81,88,79,87,78,84,32,82,81,83,82,84,84,84,86,82,88,0,75,89,76,81,78,79,80,79,82,80,83,83,83,88,82,92,32,76,81,78,80,80,80,82,81,83,83,32,87,79,86,82,83,88,81,92,0,75,89,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,82,78,81,76,81,75,82,74,84,74,85,75,86,77,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,32,81,76,82,75,84,75,86,77,0,76,88,86,80,84,79,81,79,79,80,79,81,80,82,82,83,32,81,79,80,80,80,81,82,83,32,82,83,79,84,78,85,78,87,80,88,83,88,85,87,32,82,83,80,84,79,85,79,87,80,88,0,76,87,82,75,81,76,81,77,83,78,86,78,86,77,83,78,80,79,79,80,78,82,78,84,79,86,80,87,82,88,83,89,83,91,82,92,80,92,79,91,32,83,78,81,79,80,80,79,82,79,84,80,86,82,88,0,73,89,74,82,75,80,76,79,78,79,79,80,79,81,77,88,32,77,79,78,80,78,81,76,88,32,79,81,80,80,82,79,84,79,86,80,86,82,83,92,32,84,79,85,80,85,82,82,92,0,73,89,74,83,75,81,76,80,78,80,79,81,79,86,80,88,32,77,80,78,81,78,85,79,87,80,88,81,88,83,87,84,86,85,84,86,81,86,78,85,76,84,75,82,75,81,76,81,78,82,80,85,82,87,83,32,81,88,83,86,84,84,85,81,85,78,84,75,0,78,87,82,79,80,86,80,87,81,88,83,88,85,87,86,85,32,83,79,81,86,81,87,82,88,0,75,89,79,79,76,88,32,80,79,77,88,32,85,79,86,80,87,80,86,79,84,79,82,81,79,82,32,79,82,80,83,82,87,84,88,86,87,87,85,32,79,82,81,83,83,87,84,88,0,76,88,76,75,78,75,80,76,87,88,32,78,75,79,76,86,88,32,82,80,77,88,32,82,80,78,88,0,75,90,79,79,75,92,32,80,79,76,92,32,78,85,78,87,79,88,81,88,83,87,84,86,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,0,74,89,78,79,77,88,32,79,79,78,85,77,88,32,86,82,86,79,87,79,86,82,84,85,81,87,78,88,77,88,32,76,79,79,79,0,77,88,82,75,81,76,81,77,83,78,86,78,32,84,78,81,79,80,80,80,82,82,83,85,83,32,84,78,82,79,81,80,81,82,82,83,32,83,83,80,84,79,85,79,87,81,88,83,89,84,90,84,91,83,92,81,92,32,83,83,81,84,80,85,80,87,81,88,0,75,88,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,83,79,81,79,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,0,73,90,80,80,77,88,32,80,80,78,88,32,84,80,83,88,32,84,80,84,88,32,75,81,77,79,88,79,32,75,81,77,80,88,80,0,74,88,83,79,81,79,79,80,78,81,77,83,74,92,32,81,79,79,81,78,83,75,92,32,83,79,85,80,86,82,86,84,85,86,84,87,82,88,80,88,78,87,77,85,32,83,79,85,81,85,84,84,86,82,88,0,75,91,89,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,86,82,85,80,89,80,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,85,81,83,79,0,75,90,83,80,81,88,32,83,80,82,88,32,77,81,79,79,88,79,32,77,81,79,80,88,80,0,74,88,75,82,76,80,77,79,79,79,80,80,80,82,79,85,79,87,80,88,32,78,79,79,80,79,82,78,85,78,87,80,88,81,88,83,87,85,85,86,82,86,79,85,79,86,80,0,75,90,79,80,78,81,77,83,77,85,78,87,80,88,82,88,85,87,87,85,88,82,88,80,87,79,85,79,84,80,83,82,82,85,79,92,32,77,85,78,86,80,87,82,87,85,86,87,84,88,82,32,88,81,87,80,85,80,83,82,32,82,85,81,88,80,92,0,75,88,77,79,78,79,80,80,83,91,84,92,32,78,79,79,80,82,91,84,92,85,92,32,86,79,84,82,78,89,76,92,0,73,91,84,75,81,92,32,85,75,80,92,32,74,82,75,80,76,79,78,79,79,80,79,86,80,87,83,87,85,86,87,84,32,77,79,78,80,78,84,79,87,80,88,83,88,85,87,87,84,88,82,89,79,0,74,90,78,80,80,80,80,79,78,80,77,81,76,83,76,85,77,87,78,88,80,88,81,87,82,85,83,82,32,76,85,78,87,80,87,82,85,32,82,82,82,87,83,88,85,88,87,86,88,84,88,82,87,80,86,79,86,80,87,80,32,82,85,83,87,85,87,87,86,0,75,90,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,0,74,88,79,75,77,82,32,80,75,78,82,78,86,80,88,32,78,82,79,80,81,79,83,79,85,80,86,82,86,84,85,86,84,87,82,88,80,88,78,87,77,85,77,82,32,83,79,85,81,85,84,84,86,82,88,32,77,75,80,75,0,75,88,85,80,85,81,86,81,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,32,81,79,79,81,78,83,78,86,80,88,0,75,90,87,75,84,86,84,87,85,88,87,88,88,87,89,85,32,88,75,85,86,85,87,86,88,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,32,85,75,88,75,0,75,87,78,85,82,84,84,83,85,82,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,32,81,79,79,81,78,83,78,86,80,88,0,77,88,87,75,88,76,88,75,86,75,84,76,83,78,80,89,79,91,78,92,32,86,75,85,76,84,78,81,89,80,91,78,92,76,92,76,91,77,92,32,80,79,86,79,0,75,89,86,79,84,86,83,89,82,91,32,87,79,85,86,84,89,82,91,80,92,77,92,76,91,77,91,78,92,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,0,75,90,80,75,76,88,32,81,75,77,88,32,79,81,80,80,82,79,84,79,86,80,86,82,85,85,85,87,86,88,32,84,79,85,80,85,82,84,85,84,87,85,88,87,88,88,87,89,85,32,78,75,81,75,0,77,87,83,75,83,76,84,76,84,75,83,75,32,78,82,79,80,80,79,82,79,83,80,83,82,82,85,82,87,83,88,32,81,79,82,80,82,82,81,85,81,87,82,88,84,88,85,87,86,85,0,77,87,84,75,84,76,85,76,85,75,84,75,32,79,82,80,80,81,79,83,79,84,80,84,82,82,89,81,91,79,92,77,92,77,91,78,92,32,82,79,83,80,83,82,81,89,80,91,79,92,0,75,88,80,75,76,88,32,81,75,77,88,32,86,80,85,81,86,81,86,80,85,79,84,79,82,81,80,82,79,82,32,79,82,80,83,81,87,82,88,84,88,85,87,86,85,32,79,82,81,83,82,87,83,88,32,78,75,81,75,0,78,86,83,75,80,86,80,87,81,88,83,88,84,87,85,85,32,84,75,81,86,81,87,82,88,32,81,75,84,75,0,70,94,71,82,72,80,73,79,75,79,76,80,76,81,74,88,32,74,79,75,80,75,81,73,88,32,76,81,77,80,79,79,81,79,83,80,83,81,81,88,32,81,79,82,80,82,81,80,88,32,83,81,84,80,86,79,88,79,90,80,90,82,89,85,89,87,90,88,32,88,79,89,80,89,82,88,85,88,87,89,88,91,88,92,87,93,85,0,74,91,75,82,76,80,77,79,79,79,80,80,80,81,78,88,32,78,79,79,80,79,81,77,88,32,80,81,81,80,83,79,85,79,87,80,87,82,86,85,86,87,87,88,32,85,79,86,80,86,82,85,85,85,87,86,88,88,88,89,87,90,85,0,74,89,75,82,76,80,77,79,79,79,80,80,80,81,77,92,32,78,79,79,80,79,81,76,92,32,80,81,82,79,84,79,86,80,87,82,87,84,86,86,85,87,83,88,81,88,79,86,79,84,32,84,79,86,81,86,84,85,86,83,88,32,74,92,79,92,0,75,89,86,79,82,92,32,87,79,83,92,32,85,83,85,81,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,86,32,81,79,79,81,78,83,78,86,80,88,32,80,92,85,92,0,76,88,77,82,78,80,79,79,81,79,82,80,82,81,80,88,32,80,79,81,80,81,81,79,88,32,82,81,83,80,85,79,86,79,87,80,87,81,86,81,87,80,0,76,89,86,80,86,81,87,81,86,80,84,79,81,79,79,80,79,82,81,83,84,84,86,85,32,79,81,81,82,84,83,86,84,86,87,84,88,81,88,79,87,78,86,79,86,79,87,0,78,87,83,75,80,86,80,87,81,88,83,88,84,87,85,85,32,84,75,81,86,81,87,82,88,32,80,79,85,79,0,73,90,74,82,75,80,76,79,78,79,79,80,79,82,78,85,78,87,79,88,32,77,79,78,80,78,82,77,85,77,87,79,88,81,88,83,87,84,86,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,0,72,92,73,82,74,80,75,79,77,79,78,80,78,82,77,85,77,87,78,88,32,76,79,77,80,77,82,76,85,76,87,78,88,79,88,81,87,82,86,32,84,79,82,86,82,87,84,88,32,85,79,83,86,83,87,84,88,85,88,87,87,89,85,90,82,90,79,89,79,90,80,0,74,90,77,82,78,80,80,79,82,79,83,80,83,82,32,81,79,82,80,82,82,81,85,80,87,78,88,77,88,76,87,76,86,77,86,76,87,32,88,80,87,81,88,81,88,80,87,79,86,79,84,80,83,82,82,85,82,87,83,88,32,81,85,81,87,82,88,84,88,86,87,87,85,0,73,89,74,82,75,80,76,79,78,79,79,80,79,82,78,85,78,87,79,88,32,77,79,78,80,78,82,77,85,77,87,79,88,81,88,83,87,84,86,32,86,79,84,86,83,89,82,91,32,87,79,85,86,84,89,82,91,80,92,77,92,76,91,77,91,78,92,0,75,89,87,79,87,80,86,81,78,86,77,87,77,88,32,78,81,79,79,82,79,85,81,32,79,80,82,80,85,81,86,81,32,78,86,79,86,82,87,85,87,32,79,86,82,88,85,88,86,86,0,72,91,82,75,83,76,83,77,84,77,84,76,82,75,79,75,77,76,76,78,76,88,32,79,75,78,76,77,78,77,88,32,88,75,89,76,89,77,90,77,90,76,88,75,86,75,84,77,84,88,32,86,75,85,77,85,88,32,74,79,87,79,32,74,88,79,88,32,82,88,87,88,0,74,91,85,75,86,76,87,76,87,75,81,75,79,76,78,78,78,88,32,81,75,80,76,79,78,79,88,32,86,79,86,88,32,87,79,87,88,32,76,79,87,79,32,76,88,81,88,32,84,88,89,88,0,74,91,87,75,81,75,79,76,78,78,78,88,32,81,75,80,76,79,78,79,88,32,85,75,86,76,86,88,32,87,75,87,88,32,76,79,86,79,32,76,88,81,88,32,84,88,89,88,0,70,95,80,75,81,76,81,77,82,77,82,76,80,75,77,75,75,76,74,78,74,88,32,77,75,76,76,75,78,75,88,32,89,75,90,76,91,76,91,75,85,75,83,76,82,78,82,88,32,85,75,84,76,83,78,83,88,32,90,79,90,88,32,91,79,91,88,32,72,79,91,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,70,95,80,75,81,76,81,77,82,77,82,76,80,75,77,75,75,76,74,78,74,88,32,77,75,76,76,75,78,75,88,32,91,75,85,75,83,76,82,78,82,88,32,85,75,84,76,83,78,83,88,32,89,75,90,76,90,88,32,91,75,91,88,32,72,79,90,79,32,72,88,77,88,32,80,88,85,88,32,88,88,93,88,0,78,87,82,79,82,88,32,83,79,83,88,32,80,79,83,79,32,80,88,85,88,0,76,88,86,80,84,79,82,79,80,80,79,81,78,83,78,85,79,87,81,88,83,88,85,87,32,82,79,80,81,79,83,79,86,81,88,32,79,83,83,83,0,76,89,83,75,81,76,80,77,79,79,78,82,78,85,79,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,85,75,83,75,32,83,75,81,77,80,79,79,83,79,86,80,88,32,82,88,84,86,85,84,86,80,86,77,85,75,32,79,81,86,81,0,75,90,84,75,81,92,32,85,75,80,92,32,81,79,78,80,77,82,77,85,78,87,81,88,84,88,87,87,88,85,88,82,87,80,84,79,81,79,32,81,79,79,80,78,82,78,85,79,87,81,88,32,84,88,86,87,87,85,87,82,86,80,84,79,0,76,88,85,80,86,82,86,81,85,80,83,79,81,79,79,80,78,82,78,84,79,86,82,88,32,81,79,79,81,79,84,80,86,82,88,83,89,83,91,82,92,80,92,0,73,91,86,75,87,76,88,76,86,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,90,75,91,76,91,75,89,75,87,76,86,78,83,89,82,91,81,92,32,89,75,88,76,87,78,84,89,83,91,81,92,79,92,79,91,80,92,32,76,79,89,79,0,73,90,86,75,87,76,88,76,88,75,83,75,81,76,80,77,79,79,76,89,75],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+286782);allocate([91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,86,79,84,86,84,87,85,88,87,88,88,87,89,85,32,87,79,85,86,85,87,86,88,32,76,79,87,79,0,73,90,86,75,87,76,32,88,75,83,75,81,76,80,77,79,79,76,89,75,91,74,92,32,83,75,81,77,80,79,77,89,76,91,74,92,72,92,72,91,73,92,32,87,75,84,86,84,87,85,88,87,88,88,87,89,85,32,88,75,85,86,85,87,86,88,32,76,79,86,79,0,70,94,83,75,84,76,84,77,32,85,76,83,75,80,75,78,76,77,77,76,79,73,89,72,91,71,92,32,80,75,78,77,77,79,74,89,73,91,71,92,69,92,69,91,70,92,32,90,75,91,76,92,76,92,75,87,75,85,76,32,84,77,83,79,80,89,79,91,78,92,32,87,75,85,77,84,79,81,89,80,91,78,92,76,92,76,91,77,92,32,90,79,88,86,88,87,89,88,91,88,92,87,93,85,32,91,79,89,86,89,87,90,88,32,73,79,91,79,0,70,94,83,75,84,76,84,77,32,85,76,83,75,80,75,78,76,77,77,76,79,73,89,72,91,71,92,32,80,75,78,77,77,79,74,89,73,91,71,92,69,92,69,91,70,92,32,90,75,91,76,32,92,75,87,75,85,76,32,84,77,83,79,80,89,79,91,78,92,32,87,75,85,77,84,79,81,89,80,91,78,92,76,92,76,91,77,92,32,91,75,88,86,88,87,89,88,91,88,92,87,93,85,32,92,75,89,86,89,87,90,88,32,73,79,90,79,0,77,87,78,82,79,80,80,79,82,79,83,80,83,82,82,85,82,87,83,88,32,81,79,82,80,82,82,81,85,81,87,82,88,84,88,85,87,86,85,0,79,85,0,76,88,0,76,89,81,75,79,76,78,79,78,84,79,87,81,88,84,88,86,87,87,84,87,79,86,76,84,75,81,75,32,81,75,80,76,79,79,79,84,80,87,81,88,32,84,88,85,87,86,84,86,79,85,76,84,75,0,76,89,80,78,83,75,83,88,32,82,76,82,88,32,79,88,86,88,0,76,89,79,77,79,78,78,78,78,77,79,76,81,75,84,75,86,76,87,78,86,80,84,81,81,82,79,83,78,85,78,88,32,84,75,85,76,86,78,85,80,84,81,32,78,87,79,86,80,86,83,87,86,87,87,86,32,80,86,83,88,86,88,87,86,87,85,0,76,89,79,77,79,78,78,78,78,77,79,76,81,75,84,75,86,76,87,78,86,80,84,81,32,84,75,85,76,86,78,85,80,84,81,32,82,81,84,81,86,82,87,84,87,85,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,32,84,81,85,82,86,84,86,85,85,87,84,88,0,76,89,83,77,83,88,32,84,75,84,88,32,84,75,77,84,88,84,32,81,88,86,88,0,76,89,79,75,78,81,32,79,75,86,75,32,79,76,83,76,86,75,32,78,81,79,80,81,79,84,79,86,80,87,82,87,85,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,32,84,79,85,80,86,82,86,85,85,87,84,88,0,76,89,86,77,86,78,87,78,87,77,86,76,84,75,82,75,80,76,79,77,78,80,78,85,79,87,81,88,84,88,86,87,87,85,87,83,86,81,84,80,81,80,78,82,32,82,75,80,77,79,80,79,85,80,87,81,88,32,84,88,85,87,86,85,86,83,85,81,84,80,0,76,89,78,75,78,79,32,86,77,82,84,80,88,32,87,75,84,81,81,88,32,78,77,80,75,82,75,85,77,32,78,77,80,76,82,76,85,77,86,77,0,76,89,81,75,79,76,78,78,79,80,81,81,84,81,86,80,87,78,86,76,84,75,81,75,32,81,75,80,76,79,78,80,80,81,81,32,84,81,85,80,86,78,85,76,84,75,32,81,81,79,82,78,84,78,85,79,87,81,88,84,88,86,87,87,85,87,84,86,82,84,81,32,81,81,80,82,79,84,79,85,80,87,81,88,32,84,88,85,87,86,85,86,84,85,82,84,81,0,76,89,79,86,79,85,78,85,78,86,79,87,81,88,83,88,85,87,86,86,87,83,87,78,86,76,84,75,81,75,79,76,78,78,78,80,79,82,81,83,84,83,87,81,32,83,88,85,86,86,83,86,78,85,76,84,75,32,81,75,80,76,79,78,79,80,80,82,81,83,0,78,86,82,86,81,87,82,88,83,87,82,86,0,78,86,83,87,82,88,81,87,82,86,83,87,83,89,81,91,0,78,86,82,79,81,80,82,81,83,80,82,79,32,82,86,81,87,82,88,83,87,82,86,0,78,86,82,79,81,80,82,81,83,80,82,79,32,83,87,82,88,81,87,82,86,83,87,83,89,81,91,0,78,86,82,75,81,76,82,83,83,76,82,75,32,82,76,82,79,32,82,86,81,87,82,88,83,87,82,86,0,76,89,78,78,79,78,79,79,78,79,78,78,79,76,81,75,84,75,86,76,87,78,87,79,86,81,83,82,82,83,82,84,83,84,32,84,75,86,77,86,80,85,81,83,82,32,82,87,82,88,83,88,83,87,82,87,0,79,86,82,75,82,80,32,83,75,82,80,0,76,88,79,75,79,80,32,80,75,79,80,32,85,75,85,80,32,86,75,85,80,0,77,87,81,75,80,76,80,78,81,79,83,79,84,78,84,76,83,75,81,75,0,77,87,82,74,82,80,32,79,75,85,79,32,85,75,79,79,0,75,90,88,72,77,92,0,77,87,85,72,83,74,81,77,80,80,80,84,81,87,83,90,85,92,32,83,74,82,76,81,80,81,84,82,88,83,90,0,77,87,79,72,81,74,83,77,84,80,84,84,83,87,81,90,79,92,32,81,74,82,76,83,80,83,84,82,88,81,90,0,77,87,80,72,80,92,32,81,72,81,92,32,80,72,85,72,32,80,92,85,92,0,77,87,83,72,83,92,32,84,72,84,92,32,79,72,84,72,32,79,92,84,92,0,76,87,83,72,82,73,81,75,81,77,82,79,82,80,80,82,82,84,82,85,81,87,81,89,82,91,83,92,32,82,73,81,77,32,81,75,82,79,32,82,85,81,89,32,81,87,82,91,0,77,88,81,72,82,73,83,75,83,77,82,79,82,80,84,82,82,84,82,85,83,87,83,89,82,91,81,92,32,82,73,83,77,32,83,75,82,79,32,82,85,83,89,32,83,87,82,91,0,77,87,84,72,80,82,84,92,0,77,87,80,72,84,82,80,92,0,79,85,82,72,82,92,0,77,87,80,72,80,92,32,84,72,84,92,0,73,91,76,82,88,82,0,73,91,82,76,82,88,32,76,82,88,82,0,74,90,82,77,82,88,32,77,82,87,82,32,77,88,87,88,0,74,90,82,77,82,88,32,77,77,87,77,32,77,82,87,82,0,74,90,77,77,87,87,32,87,77,77,87,0,78,86,82,81,81,82,82,83,83,82,82,81,0,73,91,82,76,81,77,82,78,83,77,82,76,32,76,82,88,82,32,82,86,81,87,82,88,83,87,82,86,0,73,91,76,80,88,80,32,76,84,88,84,0,73,91,87,76,77,88,32,76,80,88,80,32,76,84,88,84,0,73,91,76,78,88,78,32,76,82,88,82,32,76,86,88,86,0,74,90,87,76,77,82,87,88,0,74,90,77,76,87,82,77,88,0,74,90,87,75,77,79,87,83,32,77,84,87,84,32,77,88,87,88,0,74,90,77,75,87,79,77,83,32,77,84,87,84,32,77,88,87,88,0,72,91,89,85,87,85,85,84,84,83,82,80,81,79,79,78,78,78,76,79,75,81,75,82,76,84,78,85,79,85,81,84,82,83,84,80,85,79,87,78,89,78,0,74,90,76,84,76,82,77,80,79,80,85,83,87,83,88,82,32,76,82,77,81,79,81,85,84,87,84,88,82,88,80,0,74,90,77,83,82,80,87,83,32,77,83,82,81,87,83,0,78,86,83,75,80,79,32,83,75,84,76,80,79,0,78,86,81,75,84,79,32,81,75,80,76,84,79,0,76,88,78,75,79,77,81,78,83,78,85,77,86,75,32,78,75,79,78,81,79,83,79,85,78,86,75,0,78,86,83,76,82,77,81,76,82,75,83,76,83,78,81,80,0,78,86,83,75,81,77,81,79,82,80,83,79,82,78,81,79,0,78,86,81,76,82,77,83,76,82,75,81,76,81,78,83,80,0,78,86,81,75,83,77,83,79,82,80,81,79,82,78,83,79,0,74,90,87,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,87,87,0,74,90,77,77,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,77,0,74,90,77,77,83,77,85,78,86,79,87,81,87,83,86,85,85,86,83,87,77,87,0,74,90,77,87,77,81,78,79,79,78,81,77,83,77,85,78,86,79,87,81,87,87,0,74,90,87,77,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,87,87,32,77,82,85,82,0,73,91,84,79,85,80,88,82,85,84,84,85,32,85,80,87,82,85,84,32,76,82,87,82,0,77,87,82,77,82,88,32,79,80,80,79,82,76,84,79,85,80,32,80,79,82,77,84,79,0,73,91,80,79,79,80,76,82,79,84,80,85,32,79,80,77,82,79,84,32,77,82,88,82,0,77,87,82,76,82,87,32,79,84,80,85,82,88,84,85,85,84,32,80,85,82,87,84,85,0,75,89,86,83,85,80,83,79,81,79,79,80,78,81,77,83,77,85,78,87,80,88,82,88,84,87,85,86,86,84,87,81,87,78,86,76,84,75,81,75,80,76,81,76,82,75,32,81,79,79,81,78,83,78,86,80,88,32,82,88,84,86,85,84,86,81,86,78,85,76,84,75,0,74,90,76,75,82,88,32,77,75,82,86,32,88,75,82,88,32,76,75,88,75,32,78,76,87,76,0,71,91,73,79,76,79,82,87,32,75,79,82,88,32,91,70,82,88,0,73,91,88,73,88,74,89,74,89,73,88,72,86,72,84,74,83,76,82,79,81,85,80,89,79,91,32,85,73,84,75,83,79,82,85,81,88,80,90,78,92,76,92,75,91,75,90,76,90,76,91,0,73,91,88,73,88,74,89,74,89,73,88,72,86,72,84,74,83,76,82,79,81,85,80,89,79,91,32,85,73,84,75,83,79,82,85,81,88,80,90,78,92,76,92,75,91,75,90,76,90,76,91,32,81,78,79,79,78,81,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,0,72,92,90,82,89,84,87,85,86,85,84,84,83,83,81,80,80,79,78,78,77,78,75,79,74,81,74,82,75,84,77,85,78,85,80,84,81,83,83,80,84,79,86,78,87,78,89,79,90,81,90,82,0,74,90,88,75,76,88,32,79,75,80,76,80,78,79,79,77,79,76,78,76,76,77,75,79,75,83,76,86,76,88,75,32,85,84,84,85,84,87,85,88,87,88,88,87,88,85,87,84,85,84,0,74,91,89,80,88,80,88,81,89,81,89,80,88,79,87,79,86,80,85,84,84,86,83,87,81,88,79,88,77,87,76,86,76,84,77,83,79,82,82,80,83,78,83,76,82,75,80,75,79,76,79,78,80,81,85,87,87,88,88,88,89,87,32,79,88,77,86,77,84,79,82,32,79,78,80,80,86,87,87,88,0,74,91,85,80,83,79,81,79,80,81,80,82,81,84,83,84,85,83,32,85,79,85,83,86,84,88,84,89,82,89,81,88,78,86,76,83,75,82,75,79,76,77,78,76,81,76,82,77,85,79,87,82,88,83,88,86,87,0,75,90,81,72,81,92,32,84,72,84,92,32,87,76,86,76,86,77,87,77,87,76,85,75,80,75,78,76,78,78,79,80,86,83,87,84,32,78,78,79,79,86,82,87,84,87,86,86,87,84,88,81,88,79,87,78,86,78,85,79,85,79,86,78,86,0,75,89,80,75,80,91,32,84,75,84,91,32,77,81,87,81,32,77,85,87,85,0,76,88,84,76,83,76,83,77,84,77,84,76,83,75,81,75,80,76,80,78,81,80,84,82,85,83,32,80,78,81,79,84,81,85,83,85,85,83,87,32,81,80,79,82,79,84,80,86,83,88,84,89,32,79,84,80,85,83,87,84,89,84,91,83,92,81,92,80,91,80,90,81,90,81,91,80,91,0,76,88,82,75,81,76,82,77,83,76,82,75,32,82,77,82,81,32,82,81,81,83,82,86,83,83,82,81,32,82,86,82,92,32,80,79,79,78,78,79,79,80,80,79,84,79,85,78,86,79,85,80,84,79,0,76,88,82,77,83,76,82,75,81,76,82,77,82,81,81,82,83,85,82,86,32,82,81,83,82,81,85,82,86,82,90,81,91,82,92,83,91,82,90,32,80,79,79,78,78,79,79,80,80,79,84,79,85,78,86,79,85,80,84,79,32,80,88,79,87,78,88,79,89,80,88,84,88,85,87,86,88,85,89,84,88,0,76,89,86,75,86,88,32,78,75,86,75,32,81,81,86,81,32,78,88,86,88,0,72,92,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,32,82,81,81,82,82,83,83,82,82,81,0,76,89,81,75,80,76,80,77,81,78,32,84,75,85,76,85,77,84,78,32,82,78,80,79,79,81,79,82,80,84,82,85,83,85,85,84,86,82,86,81,85,79,83,78,82,78,32,82,85,82,89,32,83,85,83,89,32,79,87,86,87,0,76,89,82,75,80,76,79,78,79,79,80,81,82,82,83,82,85,81,86,79,86,78,85,76,83,75,82,75,32,82,82,82,88,32,83,82,83,88,32,79,85,86,85,0,72,92,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,32,82,75,82,89,32,75,82,89,82,0,74,89,82,82,80,81,79,81,77,82,76,84,76,85,77,87,79,88,80,88,82,87,83,85,83,84,82,82,32,87,77,82,82,32,82,77,87,77,87,82,32,82,77,86,78,87,82,0,74,90,76,76,77,75,79,75,81,76,82,78,82,80,81,82,80,83,78,84,32,79,75,80,76,81,78,81,81,80,83,32,86,75,85,88,32,87,75,84,88,32,78,84,88,84,0,74,89,78,75,78,85,32,79,75,78,82,32,78,82,79,80,81,79,83,79,85,80,86,81,86,84,84,86,84,88,85,89,86,89,87,88,32,83,79,85,81,85,84,84,86,32,76,75,79,75,0,76,89,79,78,82,75,82,81,32,86,78,83,75,83,81,32,82,81,80,82,79,84,79,85,80,87,82,88,83,88,85,87,86,85,86,84,85,82,83,81,32,82,84,82,85,83,85,83,84,82,84,0,74,90,82,75,82,89,32,77,75,77,80,78,82,80,83,84,83,86,82,87,80,87,75,32,76,77,77,75,78,77,32,81,77,82,75,83,77,32,86,77,87,75,88,77,32,79,86,85,86,0,74,89,78,75,78,88,32,79,75,79,88,32,76,75,83,75,86,76,87,78,87,79,86,81,83,82,79,82,32,83,75,85,76,86,78,86,79,85,81,83,82,32,76,88,86,88,86,85,85,88,0,76,89,87,75,84,75,81,76,79,78,78,81,78,83,79,86,81,88,84,89,87,89,32,87,75,84,76,82,78,81,81,81,83,82,86,84,88,87,89,0,74,90,82,82,80,81,79,81,77,82,76,84,76,85,77,87,79,88,80,88,82,87,83,85,83,84,82,82,32,83,76,81,81,32,87,77,82,82,32,88,81,83,83,0,75,89,80,77,84,87,32,84,77,80,87,32,77,80,87,84,32,87,80,77,84,0,74,91,79,85,77,85,76,86,76,88,77,89,79,89,80,88,80,86,78,84,77,82,77,79,78,77,79,76,81,75,84,75,86,76,87,77,88,79,88,82,87,84,85,86,85,88,86,89,88,89,89,88,89,86,88,85,86,85,32,78,77,80,76,85,76,87,77,0,74,91,79,79,77,79,76,78,76,76,77,75,79,75,80,76,80,78,78,80,77,82,77,85,78,87,79,88,81,89,84,89,86,88,87,87,88,85,88,82,87,80,85,78,85,76,86,75,88,75,89,76,89,78,88,79,86,79,32,78,87,80,88,85,88,87,87,0,70,94,75,72,75,92,32,76,72,76,92,32,88,72,88,92,32,89,72,89,92,32,72,72,92,72,32,72,92,79,92,32,85,92,92,92,0,72,93,75,72,82,81,74,92,32,74,72,81,81,32,74,72,89,72,90,77,88,72,32,75,91,88,91,32,74,92,89,92,90,87,88,92,0,75,89,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,32,84,68,82,72,81,75,80,80,80,84,81,89,82,92,84,96,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,32,80,68,82,72,83,75,84,80,84,84,83,89,82,92,80,96,0,75,89,79,66,79,98,32,80,66,80,98,32,79,66,86,66,32,79,98,86,98,0,75,89,84,66,84,98,32,85,66,85,98,32,78,66,85,66,32,78,98,85,98,0,74,89,84,66,81,69,80,72,80,74,81,77,83,79,83,80,79,82,83,84,83,85,81,87,80,90,80,92,81,95,84,98,32,82,68,81,71,81,75,82,78,32,82,86,81,89,81,93,82,96,0,75,90,80,66,83,69,84,72,84,74,83,77,81,79,81,80,85,82,81,84,81,85,83,87,84,90,84,92,83,95,80,98,32,82,68,83,71,83,75,82,78,32,82,86,83,89,83,93,82,96,0,75,89,85,64,82,67,80,70,79,73,79,76,80,79,83,86,84,89,84,92,83,95,82,97,32,82,67,81,69,80,72,80,75,81,78,84,85,85,88,85,91,84,94,82,97,79,100,0,75,89,79,64,82,67,84,70,85,73,85,76,84,79,81,86,80,89,80,92,81,95,82,97,32,82,67,83,69,84,72,84,75,83,78,80,85,79,88,79,91,80,94,82,97,85,100,0,65,88,67,82,71,82,82,96,32,71,83,82,97,32,70,83,82,98,32,88,58,82,98,0,70,94,91,67,90,68,91,69,92,68,92,67,91,66,89,66,87,67,85,69,84,71,83,74,82,78,80,90,79,94,78,96,32,86,68,85,70,84,74,82,86,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,96,73,95,74,96,73,97,0,72,92,82,70,75,91,32,82,70,89,91,32,82,73,88,91,32,77,85,86,85,32,73,91,79,91,32,85,91,91,91,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,32,85,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,32,77,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,71,92,88,73,89,76,89,70,88,73,86,71,83,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,32,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,73,91,32,83,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,83,91,0,71,92,76,70,76,91,32,77,70,77,91,32,83,76,83,84,32,73,70,89,70,89,76,88,70,32,77,80,83,80,32,73,91,89,91,89,85,88,91,0,71,91,76,70,76,91,32,77,70,77,91,32,83,76,83,84,32,73,70,89,70,89,76,88,70,32,77,80,83,80,32,73,91,80,91,0,71,94,88,73,89,76,89,70,88,73,86,71,83,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,83,91,86,90,88,88,32,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,32,88,83,88,91,32,89,83,89,91,32,85,83,92,83,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,76,80,88,80,32,72,91,79,91,32,85,91,92,91,0,77,88,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,79,91,86,91,0,75,90,85,70,85,87,84,90,82,91,80,91,78,90,77,88,77,86,78,85,79,86,78,87,32,84,70,84,87,83,90,82,91,32,81,70,88,70,0,70,92,75,70,75,91,32,76,70,76,91,32,89,70,76,83,32,81,79,89,91,32,80,79,88,91,32,72,70,79,70,32,85,70,91,70,32,72,91,79,91,32,85,91,91,91,0,73,91,78,70,78,91,32,79,70,79,91,32,75,70,82,70,32,75,91,90,91,90,85,89,91,0,70,95,75,70,75,91,32,76,70,82,88,32,75,70,82,91,32,89,70,82,91,32,89,70,89,91,32,90,70,90,91,32,72,70,76,70,32,89,70,93,70,32,72,91,78,91,32,86,91,93,91,0,71,94,76,70,76,91,32,77,70,89,89,32,77,72,89,91,32,89,70,89,91,32,73,70,77,70,32,86,70,92,70,32,73,91,79,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,77,81,32,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,32,73,91,80,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,32,78,89,78,88,79,86,81,85,82,85,84,86,85,88,86,95,87,96,89,96,90,94,90,93,32,85,88,86,92,87,94,88,95,89,95,90,94,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,77,80,32,85,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,32,73,91,80,91,32,82,80,84,81,85,82,88,89,89,90,90,90,91,89,32,84,81,85,83,87,90,88,91,90,91,91,89,91,88,0,72,92,88,73,89,70,89,76,88,73,86,71,83,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,89,84,32,75,75,77,77,79,78,85,80,87,81,88,82,89,84,89,88,87,90,84,91,81,91,78,90,76,88,75,85,75,91,76,88,0,73,92,82,70,82,91,32,83,70,83,91,32,76,70,75,76,75,70,90,70,90,76,89,70,32,79,91,86,91,0,70,94,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,32,76,70,76,85,77,88,79,90,81,91,32,72,70,79,70,32,86,70,92,70,0,72,92,75,70,82,91,32,76,70,82,88,32,89,70,82,91,32,73,70,79,70,32,85,70,91,70,0,70,94,74,70,78,91,32,75,70,78,86,32,82,70,78,91,32,82,70,86,91,32,83,70,86,86,32,90,70,86,91,32,71,70,78,70,32,87,70,93,70,0,72,92,75,70,88,91,32,76,70,89,91,32,89,70,75,91,32,73,70,79,70,32,85,70,91,70,32,73,91,79,91,32,85,91,91,91,0,72,93,75,70,82,81,82,91,32,76,70,83,81,83,91,32,90,70,83,81,32,73,70,79,70,32,86,70,92,70,32,79,91,86,91,0,72,92,88,70,75,91,32,89,70,76,91,32,76,70,75,76,75,70,89,70,32,75,91,89,91,89,85,88,91,0,73,91,78,70,78,91,32,79,70,79,91,32,75,70,90,70,90,76,89,70,32,75,91,82,91,0,72,92,82,70,74,91,32,82,70,90,91,32,82,73,89,91,32,75,90,89,90,32,74,91,90,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,81,70,79,71,77,73,76,75,75,79,75,82,76,86,77,88,79,90,81,91,32,83,91,85,90,87,88,88,86,89,82,89,79,88,75,87,73,85,71,83,70,32,79,77,79,84,32,85,77,85,84,32,79,80,85,80,32,79,81,85,81,0,72,92,82,70,75,91,32,82,70,89,91,32,82,73,88,91,32,73,91,79,91,32,85,91,91,91,0,71,93,75,69,74,74,32,90,69,89,74,32,79,78,78,83,32,86,78,85,83,32,75,87,74,92,32,90,87,89,92,32,75,71,89,71,32,75,72,89,72,32,79,80,85,80,32,79,81,85,81,32,75,89,89,89,32,75,90,89,90,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,92,70,32,72,91,79,91,32,85,91,92,91,0,72,93,75,70,82,80,74,91,32,74,70,81,80,32,74,70,89,70,90,76,88,70,32,75,90,88,90,32,74,91,89,91,90,85,88,91,0,73,92,75,75,75,73,76,71,77,70,79,70,80,71,81,73,82,77,82,91,32,75,73,77,71,79,71,81,73,32,90,75,90,73,89,71,88,70,86,70,85,71,84,73,83,77,83,91,32,90,73,88,71,86,71,84,73,32,79,91,86,91,0,72,93,82,70,82,91,32,83,70,83,91,32,80,75,77,76,76,77,75,79,75,82,76,84,77,85,80,86,85,86,88,85,89,84,90,82,90,79,89,77,88,76,85,75,80,75,32,80,75,78,76,77,77,76,79,76,82,77,84,78,85,80,86,32,85,86,87,85,88,84,89,82,89,79,88,77,87,76,85,75,32,79,70,86,70,32,79,91,86,91,0,71,94,82,70,82,91,32,83,70,83,91,32,73,77,74,76,76,77,77,81,78,83,79,84,81,85,32,74,76,75,77,76,81,77,83,78,84,81,85,84,85,87,84,88,83,89,81,90,77,91,76,32,84,85,86,84,87,83,88,81,89,77,91,76,92,77,32,79,70,86,70,32,79,91,86,91,0,71,93,74,88,75,91,79,91,77,87,75,83,74,80,74,76,75,73,77,71,80,70,84,70,87,71,89,73,90,76,90,80,89,83,87,87,85,91,89,91,90,88,32,77,87,76,84,75,80,75,76,76,73,78,71,80,70,32,84,70,86,71,88,73,89,76,89,80,88,84,87,87,32,75,90,78,90,32,86,90,89,90,0,72,92,85,70,72,91,32,85,70,86,91,32,84,72,85,91,32,76,85,85,85,32,70,91,76,91,32,82,91,88,91,0,70,94,79,70,73,91,32,80,70,74,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,32,87,70,89,71,90,73,90,75,89,78,88,79,86,80,32,77,80,86,80,88,81,89,83,89,85,88,88,86,90,82,91,70,91,32,86,80,87,81,88,83,88,85,87,88,85,90,82,91,0,72,93,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,83,91,85,90,87,88,88,86,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,78,90,80,91,0,70,93,79,70,73,91,32,80,70,74,91,32,76,70,85,70,88,71,89,72,90,75,90,79,89,83,87,87,85,89,83,90,79,91,70,91,32,85,70,87,71,88,72,89,75,89,79,88,83,86,87,84,89,82,90,79,91,0,70,93,79,70,73,91,32,80,70,74,91,32,84,76,82,84,32,76,70,91,70,90,76,90,70,32,77,80,83,80,32,70,91,85,91,87,86,84,91,0,70,92,79,70,73,91,32,80,70,74,91,32,84,76,82,84,32,76,70,91,70,90,76,90,70,32,77,80,83,80,32,70,91,77,91,0,72,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,82,91,85,90,87,88,89,84,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,78,90,80,91,32,82,91,84,90,86,88,88,84,32,85,84,92,84,0,69,95,78,70,72,91,32,79,70,73,91,32,91,70,85,91,32,92,70,86,91,32,75,70,82,70,32,88,70,95,70,32,76,80,88,80,32,69,91,76,91,32,82,91,89,91,0,76,89,85,70,79,91,32,86,70,80,91,32,82,70,89,70,32,76,91,83,91,0,73,91,88,70,83,87,82,89,81,90,79,91,77,91,75,90,74,88,74,86,75,85,76,86,75,87,32,87,70,82,87,81,89,79,91,32,84,70,91,70,0,70,93,79,70,73,91,32,80,70,74,91,32,93,70,76,83,32,83,79,87,91,32,82,79,86,91,32,76,70,83,70,32,89,70,95,70,32,70,91,77,91,32,83,91,89,91,0,72,92,81,70,75,91,32,82,70,76,91,32,78,70,85,70,32,72,91,87,91,89,85,86,91,0,69,96,78,70,72,91,32,78,70,79,91,32,79,70,80,89,32,92,70,79,91,32,92,70,86,91,32,93,70,87,91,32,75,70,79,70,32,92,70,96,70,32,69,91,75,91,32,83,91,90,91,0,70,95,79,70,73,91,32,79,70,86,88,32,79,73,86,91,32,92,70,86,91,32,76,70,79,70,32,89,70,95,70,32,70,91,76,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,83,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,78,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,0,70,93,79,70,73,91,32,80,70,74,91,32,76,70,88,70,91,71,92,73,92,75,91,78,89,80,85,81,77,81,32,88,70,90,71,91,73,91,75,90,78,88,80,85,81,32,70,91,77,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,83,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,78,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,32,76,89,76,88,77,86,79,85,80,85,82,86,83,88,83,95,84,96,86,96,87,94,87,93,32,83,88,84,94,85,95,86,95,87,94,0,70,94,79,70,73,91,32,80,70,74,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,77,80,32,87,70,89,71,90,73,90,75,89,78,88,79,86,80,32,82,80,84,81,85,82,86,90,87,91,89,91,90,89,90,88,32,85,82,87,89,88,90,89,90,90,89,32,70,91,77,91,0,71,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,75,78,77,79,78,86,82,88,84,32,77,75,79,77,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,73,91,74,89,75,89,0,72,93,85,70,79,91,32,86,70,80,91,32,79,70,76,76,78,70,93,70,92,76,92,70,32,76,91,83,91,0,70,95,78,70,75,81,74,85,74,88,75,90,78,91,82,91,85,90,87,88,88,85,92,70,32,79,70,76,81,75,85,75,88,76,90,78,91,32,75,70,82,70,32,89,70,95,70,0,72,92,78,70,79,91,32,79,70,80,89,32,92,70,79,91,32,76,70,82,70,32,88,70,94,70,0,69,95,77,70,75,91,32,78,70,76,89,32,85,70,75,91,32,85,70,83,91,32,86,70,84,89,32,93,70,83,91,32,74,70,81,70,32,90,70,96,70,0,71,93,78,70,85,91,32,79,70,86,91,32,92,70,72,91,32,76,70,82,70,32,88,70,94,70,32,70,91,76,91,32,82,91,88,91,0,72,93,78,70,82,80,79,91,32,79,70,83,80,80,91,32,93,70,83,80,32,76,70,82,70,32,89,70,95,70,32,76,91,83,91,0,71,93,91,70,72,91,32,92,70,73,91,32,79,70,76,76,78,70,92,70,32,72,91,86,91,88,85,85,91,0,72,92,75,73,76,75,88,87,89,89,89,91,32,76,76,88,88,32,75,73,75,75,76,77,88,89,89,91,32,80,80,76,84,75,86,75,88,76,90,75,91,32,75,86,77,90,32,76,84,76,86,77,88,77,90,75,91,32,83,83,88,78,32,86,73,86,76,87,78,89,78,89,76,87,75,86,73,32,86,73,87,76,89,78,0,72,92,81,73,75,91,32,83,73,89,91,32,82,73,88,91,32,77,85,86,85,32,73,91,79,91,32,85,91,91,91,32,81,66,79,67,78,69,78,71,79,73,81,74,83,74,85,73,86,71,86,69,85,67,83,66,81,66,0,71,93,73,66,91,98,0,70,94,82,74,73,90,32,82,74,91,90,0,73,93,78,79,78,80,77,80,77,79,78,78,80,77,84,77,86,78,87,79,88,81,88,88,89,90,90,91,32,87,79,87,88,88,90,90,91,91,91,32,87,81,86,82,80,83,77,84,76,86,76,88,77,90,80,91,83,91,85,90,87,88,32,80,83,78,84,77,86,77,88,78,90,80,91,0,71,92,76,70,76,91,32,77,70,77,91,32,77,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,73,70,77,70,0,72,91,87,80,86,81,87,82,88,81,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,0,72,93,87,70,87,91,32,88,70,88,91,32,87,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,87,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,84,70,88,70,32,87,91,91,91,0,72,91,76,83,88,83,88,81,87,79,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,87,83,87,80,86,78,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,0,75,88,85,71,84,72,85,73,86,72,86,71,85,70,83,70,81,71,80,73,80,91,32,83,70,82,71,81,73,81,91,32,77,77,85,77,32,77,91,84,91,0,73,92,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,32,79,78,78,80,78,84,79,86,32,85,86,86,84,86,80,85,78,32,86,79,87,78,89,77,89,78,87,78,32,78,85,77,86,76,88,76,89,77,91,80,92,85,92,88,93,89,94,32,76,89,77,90,80,91,85,91,88,92,89,94,89,95,88,97,85,98,79,98,76,97,75,95,75,94,76,92,79,91,0,71,93,76,70,76,91,32,77,70,77,91,32,77,80,79,78,82,77,84,77,87,78,88,80,88,91,32,84,77,86,78,87,80,87,91,32,73,70,77,70,32,73,91,80,91,32,84,91,91,91,0,77,88,82,70,81,71,82,72,83,71,82,70,32,82,77,82,91,32,83,77,83,91,32,79,77,83,77,32,79,91,86,91,0,77,88,83,70,82,71,83,72,84,71,83,70,32,84,77,84,95,83,97,81,98,79,98,78,97,78,96,79,95,80,96,79,97,32,83,77,83,95,82,97,81,98,32,80,77,84,77,0,71,92,76,70,76,91,32,77,70,77,91,32,87,77,77,87,32,82,83,88,91,32,81,83,87,91,32,73,70,77,70,32,84,77,90,77,32,73,91,80,91,32,84,91,90,91,0,77,88,82,70,82,91,32,83,70,83,91,32,79,70,83,70,32,79,91,86,91,0,66,99,71,77,71,91,32,72,77,72,91,32,72,80,74,78,77,77,79,77,82,78,83,80,83,91,32,79,77,81,78,82,80,82,91,32,83,80,85,78,88,77,90,77,93,78,94,80,94,91,32,90,77,92,78,93,80,93,91,32,68,77,72,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,71,93,76,77,76,91,32,77,77,77,91,32,77,80,79,78,82,77,84,77,87,78,88,80,88,91,32,84,77,86,78,87,80,87,91,32,73,77,77,77,32,73,91,80,91,32,84,91,91,91,0,72,92,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,83,87,80,85,78,83,77,0,71,92,76,77,76,98,32,77,77,77,98,32,77,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,73,77,77,77,32,73,98,80,98,0,72,92,87,77,87,98,32,88,77,88,98,32,87,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,87,88,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,84,98,91,98,0,73,90,78,77,78,91,32,79,77,79,91,32,79,83,80,80,82,78,84,77,87,77,88,78,88,79,87,80,86,79,87,78,32,75,77,79,77,32,75,91,82,91,0,74,91,87,79,88,77,88,81,87,79,86,78,84,77,80,77,78,78,77,79,77,81,78,82,80,83,85,85,87,86,88,87,32,77,80,78,81,80,82,85,84,87,85,88,86,88,89,87,90,85,91,81,91,79,90,78,89,77,87,77,91,78,89,0,75,90,80,70,80,87,81,90,83,91,85,91,87,90,88,88,32,81,70,81,87,82,90,83,91,32,77,77,85,77,0,71,93,76,77,76,88,77,90,80,91,82,91,85,90,87,88,32,77,77,77,88,78,90,80,91,32,87,77,87,91,32,88,77,88,91,32,73,77,77,77,32,84,77,88,77,32,87,91,91,91,0,73,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,32,74,77,80,77,32,84,77,90,77,0,70,94,74,77,78,91,32,75,77,78,88,32,82,77,78,91,32,82,77,86,91,32,83,77,86,88,32,90,77,86,91,32,71,77,78,77,32,87,77,93,77,0,72,92,76,77,87,91,32,77,77,88,91,32,88,77,76,91,32,74,77,80,77,32,84,77,90,77,32,74,91,80,91,32,84,91,90,91,0,72,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,80,95,78,97,76,98,75,98,74,97,75,96,76,97,32,74,77,80,77,32,84,77,90,77,0,73,91,87,77,76,91,32,88,77,77,91,32,77,77,76,81,76,77,88,77,32,76,91,88,91,88,87,87,91,0,71,94,81,77,78,78,76,80,75,82,74,85,74,88,75,90,78,91,80,91,82,90,85,87,87,84,89,80,90,77,32,81,77,79,78,77,80,76,82,75,85,75,88,76,90,78,91,32,81,77,83,77,85,78,86,80,88,88,89,90,90,91,32,83,77,84,78,85,80,87,88,88,90,90,91,91,91,0,71,92,84,70,81,71,79,73,77,77,76,80,75,84,74,90,73,98,32,84,70,82,71,80,73,78,77,77,80,76,84,75,90,74,98,32,84,70,86,70,88,71,89,72,89,75,88,77,87,78,84,79,80,79,32,86,70,88,72,88,75,87,77,86,78,84,79,32,80,79,84,80,86,82,87,84,87,87,86,89,85,90,82,91,80,91,78,90,77,89,76,86,32,80,79,83,80,85,82,86,84,86,87,85,89,84,90,82,91,0,72,92,73,80,75,78,77,77,79,77,81,78,82,79,83,82,83,86,82,90,79,98,32,74,79,76,78,80,78,82,79,32,90,77,89,80,88,82,83,89,80,94,78,98,32,89,77,88,80,87,82,83,89,0,73,92,86,78,84,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,83,74,82,72,82,70,83,69,85,69,87,70,89,72,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,87,87,84,87,80,86,78,84,75,83,73,83,71,84,70,86,70,89,72,0,73,91,88,80,86,78,84,77,80,77,78,78,78,80,80,82,83,83,32,80,77,79,78,79,80,81,82,83,83,32,83,83,78,84,76,86,76,88,77,90,80,91,83,91,85,90,87,88,32,83,83,79,84,77,86,77,88,78,90,80,91,0,73,91,84,70,82,71,81,72,81,73,82,74,85,75,90,75,90,74,87,75,83,77,80,79,77,82,76,85,76,87,77,89,80,91,83,93,84,95,84,97,83,98,81,98,80,97,32,85,76,81,79,78,82,77,85,77,87,78,89,80,91,0,71,93,72,81,73,79,75,77,78,77,79,78,79,80,78,84,76,91,32,77,77,78,78,78,80,77,84,75,91,32,78,84,80,80,82,78,84,77,86,77,88,78,89,79,89,82,88,87,85,98,32,86,77,88,79,88,82,87,87,84,98,0,70,93,71,81,72,79,74,77,77,77,78,78,78,80,77,85,77,88,78,90,79,91,32,76,77,77,78,77,80,76,85,76,88,77,90,79,91,81,91,83,90,85,88,87,85,88,82,89,77,89,73,88,71,86,70,84,70,82,72,82,74,83,77,85,80,87,82,90,84,32,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,0,76,88,82,77,80,84,79,88,79,90,80,91,83,91,85,89,86,87,32,83,77,81,84,80,88,80,90,81,91,0,72,92,78,77,74,91,32,79,77,75,91,32,88,77,89,78,90,78,89,77,87,77,85,78,81,82,79,83,77,83,32,79,83,81,84,83,90,84,91,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,0,72,92,75,70,77,70,79,71,80,72,81,74,87,88,88,90,89,91,32,77,70,79,72,80,74,86,88,87,90,89,91,90,91,32,82,77,74,91,32,82,77,75,91,0,70,93,77,77,71,98,32,78,77,72,98,32,77,80,76,86,76,89,78,91,80,91,82,90,84,88,86,85,32,88,77,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,86,88,86,90,87,91,0,72,92,78,77,76,91,32,79,77,78,83,77,88,76,91,32,89,77,88,81,86,85,32,90,77,89,80,88,82,86,85,84,87,81,89,79,90,76,91,32,75,77,79,77,0,73,90,84,70,82,71,81,72,81,73,82,74,85,75,88,75,32,85,75,81,76,79,77,78,79,78,81,80,83,83,84,86,84,32,85,75,82,76,80,77,79,79,79,81,81,83,83,84,32,83,84,79,85,77,86,76,88,76,90,78,92,83,94,84,95,84,97,82,98,80,98,32,83,84,80,85,78,86,77,88,77,90,79,92,83,94,0,73,91,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,86,78,84,77,82,77,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,87,87,84,87,80,86,78,0,71,93,80,78,76,91,32,80,78,77,91,32,86,78,86,91,32,86,78,87,91,32,73,80,75,78,78,77,91,77,32,73,80,75,79,78,78,91,78,0,72,91,76,86,77,89,78,90,80,91,82,91,85,90,87,87,88,84,88,81,87,79,86,78,84,77,82,77,79,78,77,81,76,84,72,98,32,82,91,84,90,86,87,87,84,87,80,86,78,32,82,77,80,78,78,81,77,84,73,98,0,72,93,91,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,84,90,86,87,87,84,87,81,86,79,85,78,83,77,32,81,77,79,78,77,81,76,84,76,88,77,90,32,81,91,83,90,85,87,86,84,86,80,85,78,32,85,78,91,78,0,72,92,83,78,80,91,32,83,78,81,91,32,74,80,76,78,79,77,90,77,32,74,80,76,79,79,78,90,78,0,72,92,73,81,74,79,76,77,79,77,80,78,80,80,78,86,78,89,80,91,32,78,77,79,78,79,80,77,86,77,89,78,90,80,91,81,91,84,90,86,88,88,85,89,82,89,79,88,77,87,78,88,79,89,82,32,88,85,89,79,0,71],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+297022);allocate([93,79,78,77,79,75,81,74,84,74,87,75,89,76,90,78,91,81,91,84,90,87,88,89,85,90,82,90,79,88,77,86,77,84,79,82,83,80,88,77,98,32,74,87,76,89,78,90,81,90,84,89,87,87,89,85,32,90,79,88,78,86,78,84,80,82,83,80,89,78,98,0,73,91,75,77,77,77,79,78,80,80,85,95,86,97,87,98,32,77,77,78,78,79,80,84,95,85,97,87,98,89,98,32,90,77,89,79,87,82,77,93,75,96,74,98,0,70,93,85,70,79,98,32,86,70,78,98,32,71,81,72,79,74,77,77,77,78,78,78,80,77,85,77,88,79,90,82,90,84,89,87,86,89,83,32,76,77,77,78,77,80,76,85,76,88,77,90,79,91,82,91,84,90,86,88,88,85,89,83,91,77,0,70,93,74,81,76,79,79,78,78,77,76,78,74,81,73,84,73,87,74,90,75,91,77,91,79,90,81,87,82,84,32,73,87,74,89,75,90,77,90,79,89,81,87,32,81,84,81,87,82,90,83,91,85,91,87,90,89,87,90,84,90,81,89,78,88,77,87,78,89,79,90,81,32,81,87,82,89,83,90,85,90,87,89,89,87,0,72,93,88,77,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,87,84,86,88,86,90,87,91,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,0,72,91,80,70,76,83,76,86,77,89,78,90,32,81,70,77,83,32,77,83,78,80,80,78,82,77,84,77,86,78,87,79,88,81,88,84,87,87,85,90,82,91,80,91,78,90,77,87,77,83,32,86,78,87,80,87,84,86,87,84,90,82,91,32,77,70,81,70,0,73,91,87,80,87,81,88,81,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,87,32,82,77,80,78,78,81,77,84,77,88,78,90,0,72,93,90,70,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,91,70,87,84,86,88,86,90,87,91,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,32,87,70,91,70,0,73,91,77,86,81,85,84,84,87,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,88,32,82,77,80,78,78,81,77,84,77,88,78,90,0,75,90,90,71,89,72,90,73,91,72,91,71,90,70,88,70,86,71,85,72,84,74,83,77,80,91,79,95,78,97,32,88,70,86,72,85,74,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,79,77,89,77,0,72,92,89,77,85,91,84,94,82,97,79,98,76,98,74,97,73,96,73,95,74,94,75,95,74,96,32,88,77,84,91,83,94,81,97,79,98,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,0,72,93,80,70,74,91,32,81,70,75,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,79,88,81,86,87,86,90,87,91,32,85,77,87,79,87,81,85,87,85,90,86,91,89,91,91,89,92,87,32,77,70,81,70,0,76,89,85,70,84,71,85,72,86,71,85,70,32,77,81,78,79,80,77,83,77,84,78,84,81,82,87,82,90,83,91,32,82,77,83,78,83,81,81,87,81,90,82,91,85,91,87,89,88,87,0,76,89,86,70,85,71,86,72,87,71,86,70,32,78,81,79,79,81,77,84,77,85,78,85,81,82,91,81,94,80,96,79,97,77,98,75,98,74,97,74,96,75,95,76,96,75,97,32,83,77,84,78,84,81,81,91,80,94,79,96,77,98,0,72,92,80,70,74,91,32,81,70,75,91,32,88,78,87,79,88,80,89,79,89,78,88,77,87,77,85,78,81,82,79,83,77,83,32,79,83,81,84,83,90,84,91,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,32,77,70,81,70,0,77,89,85,70,81,84,80,88,80,90,81,91,84,91,86,89,87,87,32,86,70,82,84,81,88,81,90,82,91,32,82,70,86,70,0,65,98,66,81,67,79,69,77,72,77,73,78,73,80,72,84,70,91,32,71,77,72,78,72,80,71,84,69,91,32,72,84,74,80,76,78,78,77,80,77,82,78,83,79,83,81,80,91,32,80,77,82,79,82,81,79,91,32,82,84,84,80,86,78,88,77,90,77,92,78,93,79,93,81,91,87,91,90,92,91,32,90,77,92,79,92,81,90,87,90,90,91,91,94,91,96,89,97,87,0,70,93,71,81,72,79,74,77,77,77,78,78,78,80,77,84,75,91,32,76,77,77,78,77,80,76,84,74,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,79,88,81,86,87,86,90,87,91,32,85,77,87,79,87,81,85,87,85,90,86,91,89,91,91,89,92,87,0,71,92,72,81,73,79,75,77,78,77,79,78,79,80,78,84,74,98,32,77,77,78,78,78,80,77,84,73,98,32,78,84,79,81,81,78,83,77,85,77,87,78,88,79,89,81,89,84,88,87,86,90,83,91,81,91,79,90,78,87,78,84,32,87,78,88,80,88,84,87,87,85,90,83,91,32,70,98,77,98,0,72,92,88,77,82,98,32,89,77,83,98,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,87,76,89,77,90,79,91,81,91,83,90,85,87,86,84,32,81,77,79,78,77,81,76,84,76,88,77,90,32,79,98,86,98,0,73,90,74,81,75,79,77,77,80,77,81,78,81,80,80,84,78,91,32,79,77,80,78,80,80,79,84,77,91,32,80,84,82,80,84,78,86,77,88,77,89,78,89,79,88,80,87,79,88,78,0,74,91,88,79,88,80,89,80,89,79,88,78,85,77,82,77,79,78,78,79,78,81,79,82,86,86,87,87,32,78,80,79,81,86,85,87,86,87,89,86,90,83,91,80,91,77,90,76,89,76,88,77,88,77,89,0,75,89,84,70,80,84,79,88,79,90,80,91,83,91,85,89,86,87,32,85,70,81,84,80,88,80,90,81,91,32,78,77,87,77,0,70,93,71,81,72,79,74,77,77,77,78,78,78,81,76,87,76,89,78,91,32,76,77,77,78,77,81,75,87,75,89,76,90,78,91,80,91,82,90,84,88,86,84,32,88,77,86,84,85,88,85,90,86,91,89,91,91,89,92,87,32,89,77,87,84,86,88,86,90,87,91,0,72,92,73,81,74,79,76,77,79,77,80,78,80,81,78,87,78,89,80,91,32,78,77,79,78,79,81,77,87,77,89,78,90,80,91,81,91,84,90,86,88,88,85,89,81,89,77,88,77,89,79,0,67,96,68,81,69,79,71,77,74,77,75,78,75,81,73,87,73,89,75,91,32,73,77,74,78,74,81,72,87,72,89,73,90,75,91,77,91,79,90,81,88,82,86,32,84,77,82,86,82,89,83,90,85,91,87,91,89,90,91,88,92,86,93,82,93,77,92,77,93,79,32,85,77,83,86,83,89,85,91,0,72,92,75,81,77,78,79,77,82,77,83,79,83,82,32,81,77,82,79,82,82,81,86,80,88,78,90,76,91,75,91,74,90,74,89,75,88,76,89,75,90,32,81,86,81,89,82,91,85,91,87,90,89,87,32,89,78,88,79,89,80,90,79,90,78,89,77,88,77,86,78,84,80,83,82,82,86,82,89,83,91,0,71,92,72,81,73,79,75,77,78,77,79,78,79,81,77,87,77,89,79,91,32,77,77,78,78,78,81,76,87,76,89,77,90,79,91,81,91,83,90,85,88,87,84,32,90,77,86,91,85,94,83,97,80,98,77,98,75,97,74,96,74,95,75,94,76,95,75,96,32,89,77,85,91,84,94,82,97,80,98,0,72,92,89,77,88,79,86,81,78,87,76,89,75,91,32,76,81,77,79,79,77,82,77,86,79,32,77,79,79,78,82,78,86,79,88,79,32,76,89,78,89,82,90,85,90,87,89,32,78,89,82,91,85,91,87,89,88,87,0,71,94,86,71,85,72,86,73,87,72,87,71,85,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,92,71,91,72,92,73,93,72,93,71,92,70,90,70,88,71,87,73,87,91,32,90,70,89,71,88,73,88,91,32,73,77,91,77,32,73,91,80,91,32,84,91,91,91,0,71,93,87,71,86,72,87,73,88,72,87,71,85,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,88,77,32,73,91,80,91,32,84,91,91,91,0,71,93,86,71,85,72,86,73,87,72,87,71,85,70,32,88,70,82,70,79,71,77,73,76,76,76,91,32,82,70,80,71,78,73,77,76,77,91,32,87,72,87,91,32,88,70,88,91,32,73,77,87,77,32,73,91,80,91,32,84,91,91,91,0,66,99,82,71,81,72,82,73,83,72,82,71,80,70,77,70,74,71,72,73,71,76,71,91,32,77,70,75,71,73,73,72,76,72,91,32,93,71,92,72,93,73,94,72,93,71,91,70,88,70,85,71,83,73,82,76,82,91,32,88,70,86,71,84,73,83,76,83,91,32,93,77,93,91,32,94,77,94,91,32,68,77,94,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,66,99,82,71,81,72,82,73,83,72,82,71,80,70,77,70,74,71,72,73,71,76,71,91,32,77,70,75,71,73,73,72,76,72,91,32,92,71,91,72,92,73,93,72,93,71,91,70,32,94,70,88,70,85,71,83,73,82,76,82,91,32,88,70,86,71,84,73,83,76,83,91,32,93,72,93,91,32,94,70,94,91,32,68,77,93,77,32,68,91,75,91,32,79,91,86,91,32,90,91,97,91,0,77,88,82,77,82,91,32,83,77,83,91,32,79,77,83,77,32,79,91,86,91,0,73,90,87,78,85,77,82,77,79,78,77,80,76,83,76,86,77,89,78,90,81,91,84,91,86,90,32,82,77,80,78,78,80,77,83,77,86,78,89,79,90,81,91,32,77,84,85,84,0,73,92,84,70,81,71,79,74,78,76,77,79,76,84,76,88,77,90,79,91,81,91,84,90,86,87,87,85,88,82,89,77,89,73,88,71,86,70,84,70,32,84,70,82,71,80,74,79,76,78,79,77,84,77,88,78,90,79,91,32,81,91,83,90,85,87,86,85,87,82,88,77,88,73,87,71,86,70,32,78,80,87,80,0,71,93,85,70,79,98,32,86,70,78,98,32,81,77,77,78,75,80,74,83,74,86,75,88,77,90,80,91,83,91,87,90,89,88,90,85,90,82,89,80,87,78,84,77,81,77,32,81,77,78,78,76,80,75,83,75,86,76,88,78,90,80,91,32,83,91,86,90,88,88,89,85,89,82,88,80,86,78,84,77,0,73,91,84,77,86,78,88,80,88,79,87,78,84,77,81,77,78,78,77,79,76,81,76,83,77,85,79,87,83,90,32,81,77,79,78,78,79,77,81,77,83,78,85,83,90,84,92,84,94,83,95,81,95,0,71,93,76,77,75,78,74,80,74,82,75,85,79,89,80,91,32,74,82,75,84,79,88,80,91,80,93,79,96,77,98,76,98,75,97,74,95,74,92,75,88,77,84,79,81,82,78,84,77,86,77,89,78,90,80,90,84,89,88,87,90,85,91,84,91,83,90,83,88,84,87,85,88,84,89,32,86,77,88,78,89,80,89,84,88,88,87,90,0,69,95,89,71,88,72,89,73,90,72,89,71,87,70,84,70,81,71,79,73,78,75,77,78,76,82,74,91,73,95,72,97,32,84,70,82,71,80,73,79,75,78,78,76,87,75,91,74,94,73,96,72,97,70,98,68,98,67,97,67,96,68,95,69,96,68,97,32,95,71,94,72,95,73,96,72,96,71,95,70,93,70,91,71,90,72,89,74,88,77,85,91,84,95,83,97,32,93,70,91,72,90,74,89,78,87,87,86,91,85,94,84,96,83,97,81,98,79,98,78,97,78,96,79,95,80,96,79,97,32,73,77,94,77,0,70,94,91,71,90,72,91,73,92,72,91,71,88,70,85,70,82,71,80,73,79,75,78,78,77,82,75,91,74,95,73,97,32,85,70,83,71,81,73,80,75,79,78,77,87,76,91,75,94,74,96,73,97,71,98,69,98,68,97,68,96,69,95,70,96,69,97,32,89,77,87,84,86,88,86,90,87,91,90,91,92,89,93,87,32,90,77,88,84,87,88,87,90,88,91,32,74,77,90,77,0,70,94,89,71,88,72,89,73,90,72,90,71,88,70,32,92,70,85,70,82,71,80,73,79,75,78,78,77,82,75,91,74,95,73,97,32,85,70,83,71,81,73,80,75,79,78,77,87,76,91,75,94,74,96,73,97,71,98,69,98,68,97,68,96,69,95,70,96,69,97,32,91,70,87,84,86,88,86,90,87,91,90,91,92,89,93,87,32,92,70,88,84,87,88,87,90,88,91,32,74,77,89,77,0,64,99,84,71,83,72,84,73,85,72,84,71,82,70,79,70,76,71,74,73,73,75,72,78,71,82,69,91,68,95,67,97,32,79,70,77,71,75,73,74,75,73,78,71,87,70,91,69,94,68,96,67,97,65,98,63,98,62,97,62,96,63,95,64,96,63,97,32,96,71,95,72,96,73,97,72,96,71,93,70,90,70,87,71,85,73,84,75,83,78,82,82,80,91,79,95,78,97,32,90,70,88,71,86,73,85,75,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,94,77,92,84,91,88,91,90,92,91,95,91,97,89,98,87,32,95,77,93,84,92,88,92,90,93,91,32,68,77,95,77,0,64,99,84,71,83,72,84,73,85,72,84,71,82,70,79,70,76,71,74,73,73,75,72,78,71,82,69,91,68,95,67,97,32,79,70,77,71,75,73,74,75,73,78,71,87,70,91,69,94,68,96,67,97,65,98,63,98,62,97,62,96,63,95,64,96,63,97,32,94,71,93,72,94,73,95,72,95,71,93,70,32,97,70,90,70,87,71,85,73,84,75,83,78,82,82,80,91,79,95,78,97,32,90,70,88,71,86,73,85,75,84,78,82,87,81,91,80,94,79,96,78,97,76,98,74,98,73,97,73,96,74,95,75,96,74,97,32,96,70,92,84,91,88,91,90,92,91,95,91,97,89,98,87,32,97,70,93,84,92,88,92,90,93,91,32,68,77,94,77,0,76,89,77,81,78,79,80,77,83,77,84,78,84,81,82,87,82,90,83,91,32,82,77,83,78,83,81,81,87,81,90,82,91,85,91,87,89,88,87,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,81,70,79,71,78,72,77,74,76,79,76,82,77,87,78,89,79,90,81,91,32,83,91,85,90,86,89,87,87,88,82,88,79,87,74,86,72,85,71,83,70,0,72,92,78,74,80,73,83,70,83,91,32,82,71,82,91,32,78,91,87,91,0,72,92,76,74,77,75,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,85,80,80,82,78,83,76,85,75,88,75,91,32,84,70,86,71,87,72,88,74,88,76,87,78,84,80,80,82,32,75,89,76,88,78,88,83,90,86,90,88,89,89,88,32,78,88,83,91,87,91,88,90,89,88,89,86,0,72,92,76,74,77,75,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,81,79,32,84,70,86,71,87,73,87,76,86,78,84,79,32,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,87,81,88,84,88,87,87,89,86,90,84,91,0,72,92,84,72,84,91,32,85,70,85,91,32,85,70,74,85,90,85,32,81,91,88,91,0,72,92,77,70,75,80,32,75,80,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,77,70,87,70,32,77,71,82,71,87,70,0,72,92,87,73,86,74,87,75,88,74,88,73,87,71,85,70,82,70,79,71,77,73,76,75,75,79,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,76,84,32,82,70,80,71,78,73,77,75,76,79,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,84,87,81,85,79,83,78,0,72,92,75,70,75,76,32,75,74,76,72,78,70,80,70,85,73,87,73,88,72,89,70,32,76,72,78,71,80,71,85,73,32,89,70,89,73,88,76,84,81,83,83,82,86,82,91,32,88,76,83,81,82,83,81,86,81,91,0,72,92,80,70,77,71,76,73,76,76,77,78,80,79,84,79,87,78,88,76,88,73,87,71,84,70,80,70,32,80,70,78,71,77,73,77,76,78,78,80,79,32,84,79,86,78,87,76,87,73,86,71,84,70,32,80,79,77,80,76,81,75,83,75,87,76,89,77,90,80,91,84,91,87,90,88,89,89,87,89,83,88,81,87,80,84,79,32,80,79,78,80,77,81,76,83,76,87,77,89,78,90,80,91,32,84,91,86,90,87,89,88,87,88,83,87,81,86,80,84,79,0,72,92,88,77,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,82,88,86,87,88,85,90,82,91,79,91,77,90,76,88,76,87,77,86,78,87,77,88,32,81,83,79,82,77,80,76,77,76,76,77,73,79,71,81,70,32,83,70,85,71,87,73,88,76,88,82,87,86,86,88,84,90,82,91,0,77,87,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,77,81,78,82,79,83,78,82,77,32,82,91,81,90,82,89,83,90,83,92,82,94,81,95,0,77,87,82,70,81,72,82,84,83,72,82,70,32,82,72,82,78,32,82,89,81,90,82,91,83,90,82,89,0,73,91,77,74,78,75,77,76,76,75,76,74,77,72,78,71,80,70,83,70,86,71,87,72,88,74,88,76,87,78,86,79,82,81,82,84,32,83,70,85,71,86,72,87,74,87,76,86,78,84,80,32,82,89,81,90,82,91,83,90,82,89,0,78,86,82,70,81,77,32,83,70,81,77,0,74,90,78,70,77,77,32,79,70,77,77,32,86,70,85,77,32,87,70,85,77,0,74,90,82,70,82,82,32,77,73,87,79,32,87,73,77,79,0,75,89,85,66,78,82,85,98,0,75,89,79,66,86,82,79,98,0,75,89,79,66,79,98,32,85,66,85,98,0,70,94,82,74,82,91,32,74,82,90,82,32,74,91,90,91,0,70,94,82,74,82,91,32,74,74,90,74,32,74,82,90,82,0,77,87,81,81,81,83,83,83,83,81,81,81,32,82,81,82,83,32,81,82,83,82,0,69,95,82,73,81,74,82,75,83,74,82,73,32,73,82,91,82,32,82,89,81,90,82,91,83,90,82,89,0,69,95,89,73,75,91,32,73,79,91,79,32,73,85,91,85,0,69,95,73,77,91,77,32,73,82,91,82,32,73,87,91,87,0,70,94,90,70,74,77,90,84,32,74,86,90,86,32,74,91,90,91,0,70,94,74,70,90,77,74,84,32,74,86,90,86,32,74,91,90,91,0,70,95,91,87,89,87,87,86,85,84,82,80,81,79,79,78,77,78,75,79,74,81,74,83,75,85,77,86,79,86,81,85,82,84,85,80,87,78,89,77,91,77,0,70,94,73,85,73,83,74,80,76,79,78,79,80,80,84,83,86,84,88,84,90,83,91,81,32,73,83,74,81,76,80,78,80,80,81,84,84,86,85,88,85,90,84,91,81,91,79,0,71,93,74,84,82,79,90,84,32,74,84,82,80,90,84,0,76,88,84,70,79,76,32,84,70,85,71,79,76,0,76,88,80,70,85,76,32,80,70,79,71,85,76,0,72,92,75,70,76,72,78,74,81,75,83,75,86,74,88,72,89,70,32,75,70,76,73,78,75,81,76,83,76,86,75,88,73,89,70,0,77,87,82,72,83,71,82,70,81,71,81,73,82,75,83,76,0,77,87,81,70,82,71,83,73,83,75,82,76,81,75,82,74,0,69,91,72,77,76,77,82,89,32,75,77,82,91,32,91,66,82,91,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,0,70,94,74,74,74,81,75,85,76,87,78,89,81,90,83,90,86,89,88,87,89,85,90,81,90,74,0,70,94,74,74,81,74,85,75,87,76,89,78,90,81,90,83,89,86,87,88,85,89,81,90,74,90,0,70,94,74,90,74,83,75,79,76,77,78,75,81,74,83,74,86,75,88,77,89,79,90,83,90,90,0,70,94,90,74,83,74,79,75,77,76,75,78,74,81,74,83,75,86,77,88,79,89,83,90,90,90,32,74,82,86,82,0,69,95,88,80,91,82,88,84,32,85,77,90,82,85,87,32,73,82,90,82,0,74,90,80,76,82,73,84,76,32,77,79,82,74,87,79,32,82,74,82,91,0,69,95,76,80,73,82,76,84,32,79,77,74,82,79,87,32,74,82,91,82,0,74,90,80,88,82,91,84,88,32,77,85,82,90,87,85,32,82,73,82,90,0,73,92,88,82,87,79,86,78,84,77,82,77,79,78,77,81,76,84,76,87,77,89,78,90,80,91,82,91,85,90,87,88,88,85,89,80,89,75,88,72,87,71,85,70,82,70,80,71,79,72,79,73,80,73,80,72,32,82,77,80,78,78,81,77,84,77,88,78,90,32,82,91,84,90,86,88,87,85,88,80,88,75,87,72,85,70,0,72,92,74,70,82,91,32,75,70,82,89,32,90,70,82,91,32,74,70,90,70,32,75,71,89,71,0,65,98,68,77,73,77,82,89,32,72,78,82,91,32,98,58,82,91,0,70,94,91,67,90,68,91,69,92,68,92,67,91,66,89,66,87,67,85,69,84,71,83,74,82,78,80,90,79,94,78,96,32,86,68,85,70,84,74,82,86,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,96,73,95,74,96,73,97,32,81,75,78,76,76,78,75,81,75,83,76,86,78,88,81,89,83,89,86,88,88,86,89,83,89,81,88,78,86,76,83,75,81,75,0,70,95,92,83,91,85,89,86,87,86,85,85,84,84,81,80,80,79,78,78,76,78,74,79,73,81,73,83,74,85,76,86,78,86,80,85,81,84,84,80,85,79,87,78,89,78,91,79,92,81,92,83,0,70,94,91,70,73,91,32,78,70,80,72,80,74,79,76,77,77,75,77,73,75,73,73,74,71,76,70,78,70,80,71,83,72,86,72,89,71,91,70,32,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,87,84,0,70,95,91,78,90,79,91,80,92,79,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,77,91,74,90,73,88,73,85,74,83,80,79,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,75,78,78,80,81,85,88,87,90,90,91,91,91,92,90,92,89,32,77,91,75,90,74,88,74,85,75,83,77,81,32,77,75,78,77,86,88,88,90,90,91,0,69,96,87,78,86,76,84,75,81,75,79,76,78,77,77,80,77,83,78,85,80,86,83,86,85,85,86,83,32,81,75,79,77,78,80,78,83,79,85,80,86,32,87,75,86,83,86,85,88,86,90,86,92,84,93,81,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,90,88,32,88,75,87,83,87,85,88,86,0,72,92,80,66,80,95,32,84,66,84,95,32,88,73,87,74,88,75,89,74,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,85,81,87,82,89,84,32,75,75,77,77,79,78,85,80,87,81,88,82,89,84,89,88,87,90,84,91,80,91,77,90,75,88,75,87,76,86,77,87,76,88,0,74,90,85,73,84,74,85,75,86,74,86,73,85,71,83,70,81,70,79,71,78,73,78,75,79,77,81,79,86,82,32,79,77,84,80,86,82,87,84,87,86,86,88,84,90,32,80,78,78,80,77,82,77,84,78,86,80,88,85,91,32,78,86,83,89,85,91,86,93,86,95,85,97,83,98,81,98,79,97,78,95,78,94,79,93,80,94,79,95,0,74,90,82,70,81,72,82,74,83,72,82,70,32,82,70,82,98,32,82,81,81,84,82,98,83,84,82,81,32,76,77,78,78,80,77,78,76,76,77,32,76,77,88,77,32,84,77,86,78,88,77,86,76,84,77,0,74,90,82,70,81,72,82,74,83,72,82,70,32,82,70,82,84,32,82,80,81,82,83,86,82,88,81,86,83,82,82,80,32,82,84,82,98,32,82,94,81,96,82,98,83,96,82,94,32,76,77,78,78,80,77,78,76,76,77,32,76,77,88,77,32,84,77,86,78,88,77,86,76,84,77,32,76,91,78,92,80,91,78,90,76,91,32,76,91,88,91,32,84,91,86,92,88,91,86,90,84,91,0,73,92,88,70,88,91,32,75,70,88,70,32,80,80,88,80,32,75,91,88,91,0,69,96,81,70,78,71,75,73,73,76,72,79,72,82,73,85,75,88,78,90,81,91,84,91,87,90,90,88,92,85,93,82,93,79,92,76,90,73,87,71,84,70,81,70,32,82,79,81,80,81,81,82,82,83,82,84,81,84,80,83,79,82,79,32,82,80,82,81,83,81,83,80,82,80,0,74,91,80,70,78,71,79,73,81,74,32,80,70,79,71,79,73,32,85,70,87,71,86,73,84,74,32,85,70,86,71,86,73,32,81,74,79,75,78,76,77,78,77,81,78,83,79,84,81,85,84,85,86,84,87,83,88,81,88,78,87,76,86,75,84,74,81,74,32,82,85,82,91,32,83,85,83,91,32,78,88,87,88,0,73,92,82,70,79,71,77,73,76,76,76,77,77,80,79,82,82,83,83,83,86,82,88,80,89,77,89,76,88,73,86,71,83,70,82,70,32,82,83,82,91,32,83,83,83,91,32,78,87,87,87,0,68,96,80,70,77,71,74,73,72,76,71,79,71,83,72,86,74,89,77,91,80,92,84,92,87,91,90,89,92,86,93,83,93,79,92,76,90,73,87,71,84,70,80,70,32,82,70,82,92,32,71,81,93,81,0,71,96,80,77,77,78,75,80,74,83,74,84,75,87,77,89,80,90,81,90,84,89,86,87,87,84,87,83,86,80,84,78,81,77,80,77,32,93,71,87,71,91,72,85,78,32,93,71,93,77,92,73,86,79,32,92,72,86,78,0,70,92,73,73,74,71,76,70,79,70,81,71,82,73,82,76,81,79,80,81,78,83,75,85,32,79,70,80,71,81,73,81,77,80,80,78,83,32,86,70,84,91,32,87,70,83,91,32,75,85,89,85,0,73,92,77,70,77,85,32,78,70,77,81,32,77,81,78,79,79,78,81,77,84,77,87,78,88,80,88,82,87,84,85,86,32,84,77,86,78,87,80,87,82,84,88,84,90,85,91,87,91,89,89,32,75,70,78,70,0,73,92,82,78,79,79,77,81,76,84,76,85,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,32,82,72,78,74,82,70,82,78,32,83,72,87,74,83,70,83,78,32,82,83,81,84,81,85,82,86,83,86,84,85,84,84,83,83,82,83,32,82,84,82,85,83,85,83,84,82,84,0,71,94,81,72,82,70,82,91,32,84,72,83,70,83,91,32,74,72,75,70,75,77,76,80,78,82,81,83,82,83,32,77,72,76,70,76,78,77,81,32,91,72,90,70,90,77,89,80,87,82,84,83,83,83,32,88,72,89,70,89,78,88,81,32,78,87,87,87,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,77,81,32,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,32,73,91,89,91,89,86,88,91,0,72,91,89,71,85,71,81,72,78,74,76,77,75,80,75,83,76,86,78,89,81,91,85,92,89,92,32,89,71,86,72,83,74,81,77,80,80,80,83,81,86,83,89,86,91,89,92,0,70,95,79,81,77,81,75,82,74,83,73,85,73,87,74,89,75,90,77,91,79,91,81,90,82,89,83,87,83,85,82,83,81,82,79,81,32,83,72,80,81,32,90,74,82,82,32,92,81,83,84,0,72,92,79,75,85,89,32,85,75,79,89,32,75,79,89,85,32,89,79,75,85,0,70,94,78,86,76,85,75,85,73,86,72,88,72,89,73,91,75,92,76,92,78,91,79,89,79,88,78,86,75,82,74,79,74,77,75,74,77,72,80,71,84,71,87,72,89,74,90,77,90,79,89,82,86,86,85,88,85,89,86,91,88,92,89,92,91,91,92,89,92,88,91,86,89,85,88,85,86,86,32,74,77,75,75,77,73,80,72,84,72,87,73,89,75,90,77,0,70,94,78,77,76,78,75,78,73,77,72,75,72,74,73,72,75,71,76,71,78,72,79,74,79,75,78,77,75,81,74,84,74,86,75,89,77,91,80,92,84,92,87,91,89,89,90,86,90,84,89,81,86,77,85,75,85,74,86,72,88,71,89,71,91,72,92,74,92,75,91,77,89,78,88,78,86,77,32,74,86,75,88,77,90,80,91,84,91,87,90,89,88,90,86,0,73,91,75,89,89,75,32,81,76,85,76,89,75,88,79,88,83,32,85,76,88,76,88,79,0,73,91,89,75,75,89,32,76,81,76,85,75,89,79,88,83,88,32,76,85,76,88,79,88,0,73,91,89,89,75,75,32,83,76,79,76,75,75,76,79,76,83,32,79,76,76,76,76,79,0,73,91,75,75,89,89,32,81,88,85,88,89,89,88,85,88,81,32,85,88,88,88,88,85,0,70,95,74,77,73,76,73,74,74,72,76,71,78,71,80,72,81,73,82,75,83,80,32,73,74,75,72,77,72,79,73,80,74,81,76,82,80,82,91,32,91,77,92,76,92,74,91,72,89,71,87,71,85,72,84,73,83,75,82,80,32,92,74,90,72,88,72,86,73,85,74,84,76,83,80,83,91,0,70,94,73,71,74,75,75,77,77,79,80,80,84,80,87,79,89,77,90,75,91,71,32,73,71,74,74,75,76,77,78,80,79,84,79,87,78,89,76,90,74,91,71,32,80,79,78,80,77,81,76,83,76,86,77,88,79,90,81,91,83,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,32,80,80,78,81,77,83,77,86,78,89,32,86,89,87,86,87,83,86,81,84,80,0,70,94,77,74,77,86,32,78,75,78,85,32,86,75,86,85,32,87,74,87,86,32,73,71,75,73,77,74,80,75,84,75,87,74,89,73,91,71,32,73,89,75,87,77,86,80,85,84,85,87,86,89,87,91,89,0,70,94,91,73,76,73,74,74,73,76,73,78,74,80,76,81,78,81,80,80,81,78,81,76,80,74,91,74,32,73,77,74,79,75,80,77,81,32,81,77,80,75,79,74,77,73,32,73,88,88,88,90,87,91,85,91,83,90,81,88,80,86,80,84,81,83,83,83,85,84,87,73,87,32,91,84,90,82,89,81,87,80,32,83,84,84,86,85,87,87,88,0,70,93,79,85,77,84,76,84,74,85,73,87,73,88,74,90,76,91,77,91,79,90,80,88,80,87,79,85,74,80,73,78,73,75,74,73,76,72,79,71,83,71,87,72,89,74,90,76,90,79,89,82,86,85,85,87,85,89,86,91,88,91,89,90,90,88,32,77,83,75,80,74,78,74,75,75,73,76,72,32,83,71,86,72,88,74,89,76,89,79,88,82,86,85,0,71,95,72,75,75,72,77,75,77,86,32,74,73,76,76,76,86,32,77,75,80,72,82,75,82,85,32,79,73,81,76,81,85,32,82,75,85,72,87,75,87,91,32,84,73,86,76,86,91,32,87,75,90,72,91,74,92,77,92,80,91,83,90,85,88,87,85,89,80,91,32,89,73,90,74,91,77,91,80,90,83,89,85,87,87,84,89,80,91,0,70,94,73,83,77,83,76,82,75,79,75,77,76,74,78,72,81,71,83,71,86,72,88,74,89,77,89,79,88,82,87,83,91,83,32,73,84,79,84,77,82,76,79,76,77,77,74,79,72,81,71,32,83,71,85,72,87,74,88,77,88,79,87,82,85,84,91,84,32,75,88,89,88,32,75,89,89,89,0,70,95,71,76,74,73,77,76,77,88,32,73,74,76,77,76,88,32,77,76,80,73,83,76,83,88,32,79,74,82,77,82,88,32,83,76,86,73,89,76,89,87,91,89,32,85,74,88,77,88,88,90,90,93,87,0,71,93,90,73,74,89,32,90,73,87,74,81,74,32,88,75,85,75,81,74,32,90,73,89,76,89,82,32,88,75,88,78,89,82,32,81,82,74,82,32,80,83,77,83,74,82,32,81,82,81,89,32,80,83,80,86,81,89,0,70,94,72,79,74,75,79,85,32,74,77,79,87,82,80,87,80,90,79,91,77,91,75,90,73,88,72,87,72,85,73,84,75,84,77,85,80,86,82,87,85,87,88,85,90,32,87,72,86,73,85,75,85,77,87,81,88,84,88,87,87,89,85,90,0,70,94,73,79,76,76,80,78,32,75,77,79,79,82,76,85,78,32,81,77,84,79,87,76,89,78,32,86,77,88,79,91,76,32,73,85,76,82,80,84,32,75,83,79,85,82,82,85,84,32,81,83,84,85,87,82,89,84,32,86,83,88,85,91,82,0,70,94,74,72,78,74,80,76,81,79,81,82,80,85,78,87,74,89,32,74,72,77,73,79,74,81,76,82,79,32,82,82,81,85,79,87,77,88,74,89,32,90,72,87,73,85,74,83,76,82,79,32,82,82,83,85,85,87,87,88,90,89,32,90,72,86,74,84,76,83,79,83,82,84,85,86,87,90,89,32,73,80,91,80,32,73,81,91,81,0,78,86,81,81,81,83,83,83,83,81,81,81,32,81,81,83,83,32,83,81,81,83,0,74,90,77,80,81,82,84,84,86,86,87,89,87,91,86,93,85,94,32,77,81,83,84,32,77,82,80,83,84,85,86,87,87,89,0,74,90,87,75,86,77,84,79,80,81,77,82,32,83,80,77,83,32,85,70,86,71,87,73,87,75,86,78,84,80,81,82,77,84,0,72,92,83,77,79,78,76,80,75,82,75,84,76,86,78,87,81,87,85,86,88,84,89,82,89,80,88,78,86,77,83,77,32,88,78,83,77,32,86,77,81,78,76,80,32,79,78,75,82,32,76,86,81,87,32,78,87,83,86,88,84,32,85,86,89,82,0,74,91,83,77,80,78,78,80,77,82,77,84,78,86,80,87,82,87,85,86,87,84,88,82,88,80,87,78,85,77,83,77,32,79,80,85,77,32,78,82,86,78,32,77,84,87,79,32,78,85,88,80,32,79,86,87,82,32,80,87,86,84,0,74,90,79,71,79,94,32,85,70,85,93,32,77,78,87,76,32,77,79,87,77,32,77,87,87,85,32,77,88,87,86,0,74,90,78,70,78,88,32,86,76,86,94,32,78,78,86,76,32,78,79,86,77,32,78,87,86,85,32,78,88,86,86,0,74,90,78,66,78,87,32,78,78,81,76,84,76,86,77,87,79,87,81,86,83,83,85,81,86,78,87,32,78,78,81,77,84,77,86,78,32,85,77,86,79,86,81,85,83,83,85,0,69,95,72,73,72,76,32,92,73,92,76,32,72,73,92,73,32,72,74,92,74,32,72,75,92,75,32,72,76,92,76,0,74,90,77,78,77,81,32,87,78,87,81,32,77,78,87,78,32,77,79,87,79,32,77,80,87,80,32,77,81,87,81,0,74,90,77,76,87,88,32,77,76,79,78,81,79,84,79,86,78,87,77,87,75,85,75,85,77,84,79,32,79,78,84,79,32,81,79,87,77,32,86,75,86,78,32,85,76,87,76,32,87,88,85,86,83,85,80,85,78,86,77,87,77,89,79,89,79,87,80,85,32,85,86,80,85,32,83,85,77,87,32,78,86,78,89,32,77,88,79,88,0,74,90,80,79,79,77,79,75,77,75,77,77,78,78,80,79,83,79,85,78,87,76,32,78,75,78,78,32,77,76,79,76,32,77,77,83,79,32,80,79,85,78,32,87,76,87,89,0,65,94,71,102,72,102,73,101,73,100,72,99,71,99,70,100,70,102,71,104,73,105,75,105,78,104,80,102,81,100,82,96,82,85,81,59,81,52,82,47,83,45,85,44,86,44,88,45,89,47,89,51,88,54,87,56,85,59,80,63,74,67,72,69,70,72,69,74,68,78,68,82,69,86,71,89,74,91,78,92,82,92,86,91,88,90,90,87,91,84,91,80,90,77,89,75,87,73,84,72,80,72,77,73,75,75,74,78,74,82,75,85,77,87,32,71,100,71,101,72,101,72,100,71,100,32,85,59,81,63,76,67,73,70,71,73,70,75,69,78,69,82,70,86,71,88,74,91,32,82,92,85,91,87,90,89,87,90,84,90,80,89,77,88,75,86,73,84,72,0,69,102,78,83,79,85,81,86,83,86,85,85,86,83,86,81,85,79,83,78,81,78,79,79,78,80,77,83,77,86,78,89,80,91,83,92,86,92,89,91,91,89,92,87,93,84,93,80,92,77,90,74,88,73,85,72,82,72,79,73,77,74,75,76,73,79,72,83,72,88,73,93,75,97,77,99,80,101,84,102,89,102,93,101,96,99,98,97,32,75,76,74,78,73,82,73,88,74,92,76,96,78,98,81,100,85,101,89,101,93,100,95,99,98,97,32,80,79,84,79,32,79,80,85,80,32,78,81,86,81,32,78,82,86,82,32,78,83,86,83,32,79,84,85,84,32,80,85,84,85,32,97,76,97,78,99,78,99,76,97,76,32,98,76,98,78,32,97,77,99,77,32,97,86,97,88,99,88,99,86,97,86,32,98,86,98,88,32,97,87,99,87,0,68,96,72,64,72,100,32,77,64,77,100,32,87,64,87,100,32,92,64,92,100,32,77,77,87,75,32,77,78,87,76,32,77,79,87,77,32,77,87,87,85,32,77,88,87,86,32,77,89,87,87,0,72,92,80,77,77,78,76,79,75,81,75,83,76,85,77,86,80,87,84,87,87,86,88,85,89,83,89,81,88,79,87,78,84,77,80,77,32,77,78,76,80,76,83,77,85,78,86,80,87,32,87,86,88,84,88,81,87,79,86,78,84,77,0,74,90,81,67,86,77,82,84,82,85,32,85,76,81,83,32,84,73,84,75,80,82,82,85,85,89,32,87,92,85,89,83,88,81,88,79,89,78,91,78,93,79,95,82,97,32,87,92,85,90,83,89,79,89,79,93,80,95,82,97,32,83,88,80,90,78,93,0,74,90,80,79,79,77,79,75,77,75,77,77,78,78,80,79,83,79,85,78,87,76,32,78,75,78,78,32,77,76,79,76,32,77,77,83,79,32,80,79,85,78,32,87,76,83,89,0,73,106,78,81,79,79,81,78,83,78,85,79,86,81,86,83,85,85,83,86,81,86,79,85,78,84,77,81,77,78,78,75,80,73,83,72,87,72,91,73,94,75,96,78,97,82,97,87,96,91,95,93,93,96,90,99,86,102,81,105,77,107,32,87,72,90,73,93,75,95,78,96,82,96,87,95,91,94,93,92,96,89,99,84,103,81,105,32,80,79,84,79,32,79,80,85,80,32,78,81,86,81,32,78,82,86,82,32,78,83,86,83,32,79,84,85,84,32,80,85,84,85,32,101,76,101,78,103,78,103,76,101,76,32,102,76,102,78,32,101,77,103,77,32,101,86,101,88,103,88,103,86,101,86,32,102,86,102,88,32,101,87,103,87,0,68,96,72,62,72,102,32,73,62,73,102,32,77,62,77,102,32,81,66,83,66,83,68,81,68,81,65,82,63,84,62,87,62,89,63,91,65,92,68,92,73,91,76,89,78,87,79,85,79,83,78,82,76,81,78,79,81,78,82,79,83,81,86,82,88,83,86,85,85,87,85,89,86,91,88,92,91,92,96,91,99,89,101,87,102,84,102,82,101,81,99,81,96,83,96,83,98,81,98,32,82,66,82,68,32,81,67,83,67,32,89,63,90,65,91,68,91,73,90,76,89,78,32,82,76,82,78,80,81,78,82,80,83,82,86,82,88,32,89,86,90,88,91,91,91,96,90,99,89,101,32,82,96,82,98,32,81,97,83,97,0,65,99,72,66,72,98,32,73,66,73,98,32,91,66,91,98,32,92,66,92,98,32,68,66,96,66,32,68,98,77,98,32,87,98,96,98,0,66,97,71,66,81,80,70,98,32,70,66,80,80,32,69,66,80,81,32,69,66,92,66,94,73,91,66,32,71,97,92,97,32,70,98,92,98,94,91,91,98,0,73,91,88,43,85,49,82,56,80,61,79,65,78,70,77,78,77,86,78,94,79,99,80,103,82,108,85,115,88,121,32,85,49,83,54,81,60,80,64,79,70,78,78,78,86,79,94,80,100,81,104,83,110,85,115,0,73,91,76,43,79,49,82,56,84,61,85,65,86,70,87,78,87,86,86,94,85,99,84,103,82,108,79,115,76,121,32,79,49,81,54,83,60,84,64,85,70,86,78,86,86,85,94,84,100,83,104,81,110,79,115,0,73,91,77,43,77,82,77,121,32,78,43,78,82,78,121,32,77,43,88,43,32,77,121,88,121,0,73,91,86,43,86,82,86,121,32,87,43,87,82,87,121,32,76,43,87,43,32,76,121,87,121,0,72,91,86,43,82,49,80,53,79,58,79,62,80,66,84,74,84,76,83,78,82,79,77,82,82,85,83,86,84,88,84,90,80,98,79,102,79,106,80,111,82,115,86,121,32,84,46,82,50,81,53,80,58,80,62,81,67,82,70,32,82,94,81,97,80,102,80,106,81,111,82,114,84,118,0,73,92,78,43,82,49,84,53,85,58,85,62,84,66,80,74,80,76,81,78,82,79,87,82,82,85,81,86,80,88,80,90,84,98,85,102,85,106,84,111,82,115,78,121,32,80,46,82,50,83,53,84,58,84,62,83,67,82,70,32,82,94,83,97,84,102,84,106,83,111,82,114,80,118,0,73,91,86,46,83,49,81,52,79,56,78,61,78,67,79,73,80,77,83,88,84,92,85,98,85,103,84,108,83,111,81,115,32,83,49,81,53,80,56,79,61,79,66,80,72,81,76,84,87,85,91,86,97,86,103,85,108,83,112,81,115,78,118,0,73,91,78,46,81,49,83,52,85,56,86,61,86,67,85,73,84,77,81,88,80,92,79,98,79,103,80,108,81,111,83,115,32,81,49,83,53,84,56,85,61,85,66,84,72,83,76,80,87,79,91,78,97,78,103,79,108,81,112,83,115,86,118,0,55,90,58,82,65,82,82,111,32,64,82,81,111,32,63,82,82,114,32,90,34,86,74,82,114,0,67,97,93,46,92,46,91,47,91,48,92,49,93,49,94,48,94,46,93,44,91,43,89,43,87,44,85,46,84,48,83,51,82,58,81,74,81,106,80,115,79,118,32,92,47,92,48,93,48,93,47,92,47,32,82,58,82,106,32,85,46,84,49,83,58,83,90,82,106,81,113,80,116,79,118,77,120,75,121,73,121,71,120,70,118,70,116,71,115,72,115,73,116,73,117,72,118,71,118,32,71,116,71,117,72,117,72,116,71,116,0,72,92,82,70,74,91,32,82,73,75,91,74,91,32,82,73,89,91,90,91,32,82,70,90,91,32,77,85,87,85,32,76,86,88,86,0,72,92,76,70,76,91,32,77,71,77,90,32,76,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,32,77,71,84,71,87,72,88,74,88,77,87,79,84,80,32,77,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,76,91,32,77,81,84,81,87,82,88,84,88,87,87,89,84,90,77,90,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,32,90,75,89,75,88,73,87,72,85,71,81,71,79,72,77,75,76,78,76,83,77,86,79,89,81,90,85,90,87,89,88,88,89,86,90,86,0,72,93,76,70,76,91,32,77,71,77,90,32,76,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,76,91,32,77,71,83,71,86,72,87,73,88,75,89,78,89],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+307262);allocate([83,88,86,87,88,86,89,83,90,77,90,0,73,92,77,70,77,91,32,78,71,78,90,32,77,70,89,70,32,78,71,89,71,89,70,32,78,80,84,80,84,81,32,78,81,84,81,32,78,90,89,90,89,91,32,77,91,89,91,0,73,91,77,70,77,91,32,78,71,78,91,77,91,32,77,70,89,70,32,78,71,89,71,89,70,32,78,80,84,80,84,81,32,78,81,84,81,0,72,93,90,75,89,73,87,71,85,70,81,70,79,71,77,73,76,75,75,78,75,83,76,86,77,88,79,90,81,91,85,91,87,90,89,88,90,86,90,82,85,82,32,90,75,89,75,88,73,87,72,85,71,81,71,79,72,78,73,77,75,76,78,76,83,77,86,78,88,79,89,81,90,85,90,87,89,88,88,89,86,89,83,85,83,85,82,0,71,93,75,70,75,91,32,75,70,76,70,76,91,75,91,32,89,70,88,70,88,91,89,91,32,89,70,89,91,32,76,80,88,80,32,76,81,88,81,0,78,87,82,70,82,91,83,91,32,82,70,83,70,83,91,0,74,91,86,70,86,86,85,89,83,90,81,90,79,89,78,86,77,86,32,86,70,87,70,87,86,86,89,85,90,83,91,81,91,79,90,78,89,77,86,0,72,93,76,70,76,91,77,91,32,76,70,77,70,77,91,32,90,70,89,70,77,82,32,90,70,77,83,32,80,79,89,91,90,91,32,81,79,90,91,0,73,90,77,70,77,91,32,77,70,78,70,78,90,32,78,90,89,90,89,91,32,77,91,89,91,0,70,94,74,70,74,91,32,75,75,75,91,74,91,32,75,75,82,91,32,74,70,82,88,32,90,70,82,88,32,89,75,82,91,32,89,75,89,91,90,91,32,90,70,90,91,0,71,93,75,70,75,91,32,76,73,76,91,75,91,32,76,73,89,91,32,75,70,88,88,32,88,70,88,88,32,88,70,89,70,89,91,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,81,71,78,72,76,75,75,78,75,83,76,86,78,89,81,90,83,90,86,89,88,86,89,83,89,78,88,75,86,72,83,71,81,71,0,72,92,76,70,76,91,32,77,71,77,91,76,91,32,76,70,85,70,87,71,88,72,89,74,89,77,88,79,87,80,85,81,77,81,32,77,71,85,71,87,72,88,74,88,77,87,79,85,80,77,80,0,71,93,80,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,80,91,84,91,86,90,88,88,89,86,90,83,90,78,89,75,88,73,86,71,84,70,80,70,32,81,71,78,72,76,75,75,78,75,83,76,86,78,89,81,90,83,90,86,89,88,86,89,83,89,78,88,75,86,72,83,71,81,71,32,83,88,88,93,89,93,32,83,88,84,88,89,93,0,72,92,76,70,76,91,32,77,71,77,91,76,91,32,76,70,84,70,87,71,88,72,89,74,89,77,88,79,87,80,84,81,77,81,32,77,71,84,71,87,72,88,74,88,77,87,79,84,80,77,80,32,82,81,88,91,89,91,32,83,81,89,91,0,72,92,89,73,87,71,84,70,80,70,77,71,75,73,75,75,76,77,77,78,79,79,84,81,86,82,87,83,88,85,88,88,87,89,84,90,80,90,78,89,77,88,75,88,32,89,73,87,73,86,72,84,71,80,71,77,72,76,73,76,75,77,77,79,78,84,80,86,81,88,83,89,85,89,88,87,90,84,91,80,91,77,90,75,88,0,74,91,82,71,82,91,32,83,71,83,91,82,91,32,76,70,89,70,89,71,32,76,70,76,71,89,71,0,71,93,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,70,32,75,70,76,70,76,85,77,88,78,89,81,90,83,90,86,89,87,88,88,85,88,70,89,70,0,72,92,74,70,82,91,32,74,70,75,70,82,88,32,90,70,89,70,82,88,32,90,70,82,91,0,69,95,71,70,77,91,32,71,70,72,70,77,88,32,82,70,77,88,32,82,73,77,91,32,82,73,87,91,32,82,70,87,88,32,93,70,92,70,87,88,32,93,70,87,91,0,72,92,75,70,88,91,89,91,32,75,70,76,70,89,91,32,89,70,88,70,75,91,32,89,70,76,91,75,91,0,73,92,75,70,82,80,82,91,83,91,32,75,70,76,70,83,80,32,90,70,89,70,82,80,32,90,70,83,80,83,91,0,72,92,88,70,75,91,32,89,70,76,91,32,75,70,89,70,32,75,70,75,71,88,71,32,76,90,89,90,89,91,32,75,91,89,91,0,69,92,88,70,86,72,84,75,81,80,79,83,76,87,73,90,71,91,69,91,68,90,68,88,69,87,70,88,69,89,32,88,70,87,74,85,84,84,91,32,88,70,85,91,32,84,91,84,89,83,86,82,84,80,82,78,81,76,81,75,82,75,84,76,87,79,90,82,91,86,91,88,90,0,70,94,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,88,70,90,71,91,73,91,75,90,77,88,78,84,79,82,79,32,88,70,89,71,90,73,90,75,89,77,88,78,32,84,79,87,80,88,81,89,83,89,86,88,89,87,90,85,91,83,91,82,90,82,88,83,85,32,84,79,86,80,87,81,88,83,88,86,87,89,85,91,0,72,93,75,72,74,74,74,76,75,78,78,79,81,79,85,78,87,77,89,75,90,73,90,71,89,70,87,70,84,71,81,74,79,77,77,81,76,85,76,88,77,90,80,91,82,91,85,90,87,88,88,86,88,84,87,82,85,82,83,83,82,85,32,87,70,85,71,82,74,80,77,78,81,77,85,77,88,78,90,80,91,0,70,93,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,74,87,76,88,78,90,80,91,83,91,85,90,87,88,89,84,90,79,90,76,89,73,87,71,85,70,80,70,77,71,75,73,74,75,74,77,75,78,77,78,78,77,79,75,0,73,92,87,73,86,74,86,76,87,77,89,77,90,75,90,73,89,71,87,70,84,70,82,71,81,72,80,74,80,76,81,78,83,79,32,84,70,82,72,81,74,81,77,83,79,32,83,79,81,79,78,80,76,82,75,84,75,87,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,84,87,82,85,82,83,83,82,85,32,81,79,79,80,77,82,76,84,76,88,77,90,0,71,92,87,72,86,74,84,79,82,85,81,87,79,90,77,91,32,81,76,80,78,78,79,76,79,75,77,75,75,76,73,78,71,81,70,91,70,88,71,87,72,86,75,84,83,83,86,82,88,80,90,77,91,75,91,73,90,72,89,72,88,73,87,74,88,73,89,32,83,70,87,71,88,71,32,79,83,80,82,82,81,86,81,88,80,90,77,88,84,0,71,93,74,73,73,75,73,77,74,79,76,80,79,80,82,79,84,78,87,75,88,72,88,71,87,70,86,70,84,71,82,73,81,75,80,78,80,81,81,83,83,84,85,84,87,83,89,81,90,79,32,87,70,85,71,83,73,82,75,81,78,81,82,83,84,32,90,79,89,83,87,87,85,89,83,90,79,91,76,91,74,90,73,88,73,87,74,86,75,87,74,88,32,89,83,87,86,85,88,82,90,79,91,0,70,94,76,76,75,75,75,73,76,71,79,70,82,70,79,81,77,87,76,89,75,90,73,91,71,91,70,90,70,88,71,87,72,88,71,89,32,82,70,79,79,78,82,76,87,75,89,73,91,32,74,84,75,83,77,82,86,79,88,78,91,76,93,74,94,72,94,71,93,70,92,70,90,71,88,74,87,76,85,82,84,86,84,89,86,91,87,91,89,90,91,88,32,92,70,90,72,88,76,86,82,85,86,85,89,86,91,0,73,89,87,72,85,75,83,80,81,85,80,87,78,90,76,91,32,89,76,87,78,84,79,81,79,79,78,78,76,78,74,79,72,81,71,85,70,89,70,87,72,86,74,84,80,82,86,81,88,79,90,76,91,74,91,73,90,73,88,74,87,75,88,74,89,0,73,90,89,70,87,72,85,75,83,80,80,89,78,93,32,89,77,87,79,84,80,81,80,79,79,78,77,78,75,79,73,81,71,85,70,89,70,87,73,86,75,83,84,81,88,80,90,78,93,77,94,75,95,74,94,74,92,75,90,77,88,79,87,82,86,86,85,0,70,94,76,76,75,75,75,73,77,71,80,70,82,70,79,81,77,87,76,89,75,90,73,91,71,91,70,90,70,88,71,87,72,88,71,89,32,82,70,79,79,78,82,76,87,75,89,73,91,32,90,71,87,75,85,77,83,78,80,79,32,93,71,92,72,93,73,94,72,94,71,93,70,92,70,90,71,87,76,86,77,84,78,80,79,32,80,79,83,80,84,82,85,89,86,91,32,80,79,82,80,83,82,84,89,86,91,87,91,89,90,91,88,0,73,91,77,73,76,75,76,77,77,79,79,80,82,80,85,79,87,78,90,75,91,72,91,71,90,70,89,70,87,71,86,72,84,75,80,85,79,87,77,90,75,91,32,86,72,84,76,82,83,81,86,80,88,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,82,91,85,91,87,90,89,88,0,68,96,82,70,78,79,75,85,73,88,71,90,69,91,67,91,66,90,66,88,67,87,68,88,67,89,32,82,70,80,77,79,81,78,86,78,90,80,91,32,82,70,81,74,80,79,79,86,79,90,80,91,32,91,70,87,79,82,88,80,91,32,91,70,89,77,88,81,87,86,87,90,89,91,90,91,92,90,94,88,32,91,70,90,74,89,79,88,86,88,90,89,91,0,71,94,82,70,81,74,79,80,77,85,76,87,74,90,72,91,70,91,69,90,69,88,70,87,71,88,70,89,32,82,70,82,75,83,86,84,91,32,82,70,83,75,84,86,84,91,32,96,71,95,72,96,73,97,72,97,71,96,70,94,70,92,71,90,74,89,76,87,81,85,87,84,91,0,72,93,83,70,81,71,79,73,77,76,76,78,75,82,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,83,90,79,90,75,89,72,88,71,87,71,85,72,83,74,81,78,80,83,80,86,32,81,71,79,74,77,78,76,82,76,86,77,89,79,91,0,70,93,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,86,70,89,71,90,72,91,74,91,77,90,79,89,80,86,81,84,81,82,80,32,86,70,88,71,89,72,90,74,90,77,89,79,88,80,86,81,0,72,93,85,74,85,76,84,78,83,79,81,80,79,80,78,78,78,76,79,73,81,71,84,70,87,70,89,71,90,73,90,77,89,80,87,83,83,87,80,89,78,90,75,91,73,91,72,90,72,88,73,87,75,87,77,88,80,90,83,91,86,91,88,90,90,88,32,87,70,88,71,89,73,89,77,88,80,86,83,83,86,79,89,75,91,0,70,94,85,71,84,72,83,74,81,79,79,85,78,87,76,90,74,91,32,84,72,83,75,81,83,80,86,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,79,76,78,78,77,79,75,79,74,78,74,76,75,74,77,72,79,71,82,70,87,70,90,71,91,73,91,75,90,77,89,78,86,79,82,79,32,87,70,89,71,90,73,90,75,89,77,88,78,86,79,32,82,79,85,80,86,82,87,89,88,91,32,82,79,84,80,85,82,86,89,88,91,89,91,91,90,93,88,0,72,92,78,73,77,75,77,77,78,79,80,80,83,80,86,79,88,78,91,75,92,72,92,71,91,70,90,70,88,71,87,72,86,74,85,77,83,84,82,87,80,90,78,91,32,86,74,85,78,84,85,83,88,81,90,78,91,75,91,73,90,72,88,72,87,73,86,74,87,73,88,0,73,91,89,72,88,74,86,79,84,85,83,87,81,90,79,91,32,83,76,82,78,80,79,78,79,77,77,77,75,78,73,80,71,83,70,92,70,90,71,89,72,88,75,86,83,85,86,84,88,82,90,79,91,77,91,75,90,74,89,74,88,75,87,76,88,75,89,32,85,70,89,71,90,71,0,71,93,72,74,74,71,76,70,77,70,79,72,79,75,78,78,75,86,75,89,76,91,32,77,70,78,72,78,75,75,83,74,86,74,89,76,91,78,91,80,90,83,87,85,84,86,82,32,90,70,86,82,85,86,85,89,87,91,88,91,90,90,92,88,32,91,70,87,82,86,86,86,89,87,91,0,71,92,72,74,74,71,76,70,77,70,79,72,79,75,78,79,76,86,76,89,77,91,32,77,70,78,72,78,75,76,82,75,86,75,89,77,91,78,91,81,90,84,87,86,84,88,80,89,77,90,73,90,71,89,70,88,70,87,71,86,73,86,76,87,78,89,80,91,81,93,81,0,70,93,73,76,72,76,71,75,71,73,72,71,74,70,78,70,77,72,76,76,75,85,74,91,32,76,76,76,85,75,91,32,86,70,84,72,82,76,79,85,77,89,75,91,32,86,70,85,72,84,76,83,85,82,91,32,84,76,84,85,83,91,32,96,70,94,71,92,73,90,76,87,85,85,89,83,91,0,72,92,80,75,79,76,77,76,76,75,76,73,77,71,79,70,81,70,83,71,84,73,84,76,83,80,81,85,79,88,77,90,74,91,72,91,71,90,71,88,72,87,73,88,72,89,32,81,70,82,71,83,73,83,76,82,80,80,85,78,88,76,90,74,91,32,93,71,92,72,93,73,94,72,94,71,93,70,91,70,89,71,87,73,85,76,83,80,82,85,82,88,83,90,84,91,85,91,87,90,89,88,0,71,93,74,74,76,71,78,70,79,70,81,71,81,73,79,79,79,82,80,84,32,79,70,80,71,80,73,78,79,78,82,80,84,82,84,85,83,87,81,89,78,90,76,32,92,70,90,76,87,84,85,88,32,93,70,91,76,89,81,87,85,85,88,83,90,80,91,76,91,74,90,73,88,73,87,74,86,75,87,74,88,0,71,92,90,72,89,74,87,79,86,82,85,84,83,87,81,89,79,90,76,91,32,83,76,82,78,80,79,78,79,77,77,77,75,78,73,80,71,83,70,93,70,91,71,90,72,89,75,88,79,86,85,84,88,81,90,76,91,72,91,71,90,71,88,72,87,74,87,76,88,79,90,81,91,84,91,87,90,89,88,32,86,70,90,71,91,71,0,72,92,87,77,87,91,88,91,32,87,77,88,77,88,91,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,72,92,76,70,76,91,77,91,32,76,70,77,70,77,91,32,77,80,79,78,81,77,84,77,86,78,88,80,89,83,89,85,88,88,86,90,84,91,81,91,79,90,77,88,32,77,80,81,78,84,78,86,79,87,80,88,83,88,85,87,88,86,89,84,90,81,90,77,88,0,73,91,88,80,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,32,88,80,87,81,86,79,84,78,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,87,88,88,0,72,92,87,70,87,91,88,91,32,87,70,88,70,88,91,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,73,91,77,84,88,84,88,81,87,79,86,78,84,77,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,32,77,83,87,83,87,81,86,79,84,78,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,87,88,88,0,76,90,87,70,85,70,83,71,82,74,82,91,83,91,32,87,70,87,71,85,71,83,72,32,84,71,83,74,83,91,32,79,77,86,77,86,78,32,79,77,79,78,86,78,0,72,92,88,77,87,77,87,92,86,95,85,96,83,97,81,97,79,96,78,95,76,95,32,88,77,88,92,87,95,85,97,83,98,80,98,78,97,76,95,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,72,92,76,70,76,91,77,91,32,76,70,77,70,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,32,77,81,80,79,82,78,84,78,86,79,87,81,87,91,88,91,0,78,87,82,70,81,71,81,72,82,73,83,73,84,72,84,71,83,70,82,70,32,82,71,82,72,83,72,83,71,82,71,32,82,77,82,91,83,91,32,82,77,83,77,83,91,0,78,87,82,70,81,71,81,72,82,73,83,73,84,72,84,71,83,70,82,70,32,82,71,82,72,83,72,83,71,82,71,32,82,77,82,98,83,98,32,82,77,83,77,83,98,0,72,91,76,70,76,91,77,91,32,76,70,77,70,77,91,32,88,77,87,77,77,87,32,88,77,77,88,32,80,84,86,91,88,91,32,81,83,88,91,0,67,98,71,77,71,91,72,91,32,71,77,72,77,72,91,32,72,81,75,78,77,77,80,77,82,78,83,81,83,91,32,72,81,75,79,77,78,79,78,81,79,82,81,82,91,83,91,32,83,81,86,78,88,77,91,77,93,78,94,81,94,91,32,83,81,86,79,88,78,90,78,92,79,93,81,93,91,94,91,0,72,92,76,77,76,91,77,91,32,76,77,77,77,77,91,32,77,81,80,78,82,77,85,77,87,78,88,81,88,91,32,77,81,80,79,82,78,84,78,86,79,87,81,87,91,88,91,0,73,92,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,84,91,86,90,88,88,89,85,89,83,88,80,86,78,84,77,81,77,32,81,78,79,79,78,80,77,83,77,85,78,88,79,89,81,90,84,90,86,89,87,88,88,85,88,83,87,80,86,79,84,78,81,78,0,72,92,76,77,76,98,77,98,32,76,77,77,77,77,98,32,77,80,79,78,81,77,84,77,86,78,88,80,89,83,89,85,88,88,86,90,84,91,81,91,79,90,77,88,32,77,80,81,78,84,78,86,79,87,80,88,83,88,85,87,88,86,89,84,90,81,90,77,88,0,72,92,87,77,87,98,88,98,32,87,77,88,77,88,98,32,87,80,85,78,83,77,80,77,78,78,76,80,75,83,75,85,76,88,78,90,80,91,83,91,85,90,87,88,32,87,80,83,78,80,78,78,79,77,80,76,83,76,85,77,88,78,89,80,90,83,90,87,88,0,75,89,79,77,79,91,80,91,32,79,77,80,77,80,91,32,80,83,81,80,83,78,85,77,88,77,32,80,83,81,81,83,79,85,78,88,78,88,77,0,74,91,88,80,87,78,84,77,81,77,78,78,77,80,78,82,80,83,85,85,87,86,32,86,85,87,87,87,88,86,90,32,87,89,84,90,81,90,78,89,32,79,90,78,88,77,88,32,88,80,87,80,86,78,32,87,79,84,78,81,78,78,79,32,79,78,78,80,79,82,32,78,81,80,82,85,84,87,85,88,87,88,88,87,90,84,91,81,91,78,90,77,88,0,77,88,82,70,82,91,83,91,32,82,70,83,70,83,91,32,79,77,86,77,86,78,32,79,77,79,78,86,78,0,72,92,76,77,76,87,77,90,79,91,82,91,84,90,87,87,32,76,77,77,77,77,87,78,89,80,90,82,90,84,89,87,87,32,87,77,87,91,88,91,32,87,77,88,77,88,91,0,74,90,76,77,82,91,32,76,77,77,77,82,89,32,88,77,87,77,82,89,32,88,77,82,91,0,70,94,73,77,78,91,32,73,77,74,77,78,88,32,82,77,78,88,32,82,80,78,91,32,82,80,86,91,32,82,77,86,88,32,91,77,90,77,86,88,32,91,77,86,91,0,73,91,76,77,87,91,88,91,32,76,77,77,77,88,91,32,88,77,87,77,76,91,32,88,77,77,91,76,91,0,74,90,76,77,82,91,32,76,77,77,77,82,89,32,88,77,87,77,82,89,78,98,32,88,77,82,91,79,98,78,98,0,73,91,86,78,76,91,32,88,77,78,90,32,76,77,88,77,32,76,77,76,78,86,78,32,78,90,88,90,88,91,32,76,91,88,91,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,86,82,84,88,84,90,86,91,88,90,89,89,91,86,32,87,82,85,88,85,90,86,91,0,76,90,76,86,78,83,80,79,32,83,70,77,88,77,90,79,91,80,91,82,90,84,88,85,85,85,82,86,86,87,87,88,87,90,86,32,84,70,78,88,78,90,79,91,0,76,88,84,83,83,84,84,84,84,83,83,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,32,81,82,79,84,78,86,78,89,80,91,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,90,70,84,88,84,90,86,91,88,90,89,89,91,86,32,91,70,85,88,85,90,86,91,0,76,88,79,89,81,88,82,87,83,85,83,83,82,82,81,82,79,83,78,84,77,86,77,88,78,90,80,91,83,91,86,89,88,86,32,81,82,79,84,78,86,78,89,80,91,0,79,88,82,82,85,79,87,76,88,73,88,71,87,70,85,71,84,73,75,100,75,102,76,103,78,102,79,99,80,90,81,91,83,91,85,90,86,89,88,86,32,84,73,83,78,82,82,79,91,77,96,75,100,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,88,32,80,82,78,84,77,86,77,89,79,91,32,86,82,80,100,32,87,82,84,91,82,96,80,100,79,102,77,103,76,102,76,100,77,97,79,95,82,93,86,91,89,89,91,86,0,76,91,76,86,78,83,80,79,32,83,70,76,91,32,84,70,77,91,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,78,86,83,76,82,77,83,78,84,77,83,76,32,81,82,79,88,79,90,81,91,83,90,84,89,86,86,32,82,82,80,88,80,90,81,91,0,78,86,83,76,82,77,83,78,84,77,83,76,32,81,82,75,100,32,82,82,79,91,77,96,75,100,74,102,72,103,71,102,71,100,72,97,74,95,77,93,81,91,84,89,86,86,0,76,90,76,86,78,83,80,79,32,83,70,76,91,32,84,70,77,91,32,85,82,85,83,86,83,85,82,84,82,82,84,79,85,32,79,85,82,86,83,90,84,91,32,79,85,81,86,82,90,84,91,85,91,88,89,90,86,0,78,86,78,86,80,83,82,79,32,85,70,79,88,79,90,81,91,83,90,84,89,86,86,32,86,70,80,88,80,90,81,91,0,69,94,69,86,71,83,73,82,75,83,75,85,73,91,32,73,82,74,83,74,85,72,91,32,75,85,77,83,79,82,80,82,82,83,82,85,80,91,32,80,82,81,83,81,85,79,91,32,82,85,84,83,86,82,87,82,89,83,89,85,88,88,88,90,89,91,32,87,82,88,83,88,85,87,88,87,90,89,91,91,90,92,89,94,86,0,73,91,73,86,75,83,77,82,79,83,79,85,77,91,32,77,82,78,83,78,85,76,91,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,75,89,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,84,89,85,87,85,85,84,83,82,82,81,83,81,85,82,87,84,88,86,88,88,87,89,86,32,80,82,78,84,77,86,77,89,79,91,0,76,91,76,86,78,83,80,79,32,81,76,72,103,32,82,76,73,103,32,79,85,81,83,83,82,84,82,86,83,86,85,85,88,85,90,86,91,32,84,82,85,83,85,85,84,88,84,90,86,91,88,90,89,89,91,86,0,75,91,85,85,84,83,82,82,80,82,78,83,77,84,76,86,76,88,77,90,79,91,81,91,83,90,32,80,82,78,84,77,86,77,89,79,91,32,86,82,80,100,80,102,81,103,83,102,84,99,84,91,86,91,89,89,91,86,32,87,82,84,91,82,96,80,100,0,76,90,76,86,78,83,80,82,82,83,82,85,80,91,32,80,82,81,83,81,85,79,91,32,82,85,84,83,86,82,87,82,86,85,32,86,82,86,85,87,87,88,87,90,86,0,78,90,78,86,80,83,81,81,81,83,84,85,85,87,85,89,84,90,82,91,32,81,83,83,85,84,87,84,89,82,91,32,78,90,80,91,85,91,88,89,90,86,0,78,86,78,86,80,83,82,79,32,85,70,79,88,79,90,81,91,83,90,84,89,86,86,32,86,70,80,88,80,90,81,91,32,80,78,86,78,0,75,91,78,82,76,88,76,90,78,91,79,91,81,90,83,88,85,85,32,79,82,77,88,77,90,78,91,32,86,82,84,88,84,90,86,91,88,90,89,89,91,86,32,87,82,85,88,85,90,86,91,0,75,90,78,82,77,84,76,87,76,90,78,91,79,91,82,90,84,88,85,85,85,82,32,79,82,78,84,77,87,77,90,78,91,32,85,82,86,86,87,87,88,87,90,86,0,72,93,76,82,74,84,73,87,73,90,75,91,76,91,78,90,80,88,32,77,82,75,84,74,87,74,90,75,91,32,82,82,80,88,80,90,82,91,83,91,85,90,87,88,88,85,88,82,32,83,82,81,88,81,90,82,91,32,88,82,89,86,90,87,91,87,93,86,0,74,90,74,86,76,83,78,82,80,82,81,83,81,85,80,88,79,90,77,91,76,91,75,90,75,89,76,89,75,90,32,87,83,86,84,87,84,87,83,86,82,85,82,83,83,82,85,81,88,81,90,82,91,85,91,88,89,90,86,32,81,83,82,85,32,83,83,81,85,32,80,88,81,90,32,81,88,79,90,0,75,91,78,82,76,88,76,90,78,91,79,91,81,90,83,88,85,85,32,79,82,77,88,77,90,78,91,32,86,82,80,100,32,87,82,84,91,82,96,80,100,79,102,77,103,76,102,76,100,77,97,79,95,82,93,86,91,89,89,91,86,0,76,89,76,86,78,83,80,82,82,82,84,83,84,86,83,88,80,90,78,91,32,82,82,83,83,83,86,82,88,80,90,32,78,91,80,92,81,94,81,97,80,100,78,102,76,103,75,102,75,100,76,97,79,94,82,92,86,89,89,86,32,78,91,79,92,80,94,80,97,79,100,78,102,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,79,71,77,74,76,79,76,82,77,87,79,90,32,78,89,81,90,83,90,86,89,32,85,90,87,87,88,82,88,79,87,74,85,71,32,86,72,83,71,81,71,78,72,0,72,92,78,74,80,73,83,70,83,91,32,78,74,78,75,80,74,82,72,82,91,83,91,0,72,92,76,75,76,74,77,72,78,71,80,70,84,70,86,71,87,72,88,74,88,76,87,78,85,81,76,91,32,76,75,77,75,77,74,78,72,80,71,84,71,86,72,87,74,87,76,86,78,84,81,75,91,32,76,90,89,90,89,91,32,75,91,89,91,0,72,92,77,70,88,70,81,79,32,77,70,77,71,87,71,32,87,70,80,79,32,81,78,83,78,86,79,88,81,89,84,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,76,87,32,80,79,83,79,86,80,88,83,32,84,79,87,81,88,84,88,85,87,88,84,90,32,88,86,86,89,83,90,80,90,77,89,76,87,32,79,90,76,88,0,72,92,85,73,85,91,86,91,32,86,70,86,91,32,86,70,75,86,90,86,32,85,73,76,86,32,76,85,90,85,90,86,0,72,92,77,70,76,79,32,78,71,77,78,32,77,70,87,70,87,71,32,78,71,87,71,32,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,76,87,32,76,79,77,79,79,78,83,78,86,79,88,82,32,84,78,87,80,88,83,88,85,87,88,84,90,32,88,86,86,89,83,90,80,90,77,89,76,87,32,79,90,76,88,0,72,92,86,71,87,73,88,73,87,71,84,70,82,70,79,71,77,74,76,79,76,84,77,88,79,90,82,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,82,78,79,79,77,81,32,87,72,84,71,82,71,79,72,32,80,71,78,74,77,79,77,84,78,88,81,90,32,77,86,79,89,82,90,83,90,86,89,88,86,32,84,90,87,88,88,85,88,84,87,81,84,79,32,88,83,86,80,83,79,82,79,79,80,77,83,32,81,79,78,81,77,84,0,72,92,75,70,89,70,79,91,32,75,70,75,71,88,71,32,88,70,78,91,79,91,0,72,92,80,70,77,71,76,73,76,75,77,77,78,78,80,79,84,80,86,81,87,82,88,84,88,87,87,89,84,90,80,90,77,89,76,87,76,84,77,82,78,81,80,80,84,79,86,78,87,77,88,75,88,73,87,71,84,70,80,70,32,78,71,77,73,77,75,78,77,80,78,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,84,76,82,78,80,80,79,84,78,86,77,87,75,87,73,86,71,32,87,72,84,71,80,71,77,72,32,76,88,79,90,32,85,90,88,88,0,72,92,87,80,85,82,82,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,82,70,85,71,87,73,88,77,88,82,87,87,85,90,82,91,80,91,77,90,76,88,77,88,78,90,32,87,77,86,80,83,82,32,87,78,85,81,82,82,81,82,78,81,76,78,32,80,82,77,80,76,77,76,76,77,73,80,71,32,76,75,78,72,81,71,82,71,85,72,87,75,32,83,71,86,73,87,77,87,82,86,87,84,90,32,85,89,82,90,80,90,77,89,0,77,88,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,84,90,83,91,82,91,81,90,81,89,82,88,83,88,84,89,84,92,83,94,81,95,32,82,89,82,90,83,90,83,89,82,89,32,83,91,84,92,32,84,90,83,94,0,77,88,82,77,81,78,81,79,82,80,83,80,84,79,84,78,83,77,82,77,32,82,78,82,79,83,79,83,78,82,78,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,82,77,81,78,81,79,82,80,83,80,84,79,84,78,83,77,82,77,32,82,78,82,79,83,79,83,78,82,78,32,84,90,83,91,82,91,81,90,81,89,82,88,83,88,84,89,84,92,83,94,81,95,32,82,89,82,90,83,90,83,89,82,89,32,83,91,84,92,32,84,90,83,94,0,77,88,82,70,82,84,83,84,32,82,70,83,70,83,84,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,73,92,76,75,76,74,77,72,78,71,81,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,85,80,82,81,32,76,75,77,75,77,74,78,72,81,71,84,71,87,72,88,74,88,76,87,78,85,79,82,80,32,77,73,80,71,32,85,71,88,73,32,88,77,84,80,32,82,80,82,84,83,84,83,80,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,77,88,84,70,82,71,81,73,81,76,82,77,83,77,84,76,84,75,83,74,82,74,81,75,32,82,75,82,76,83,76,83,75,82,75,32,82,71,81,75,32,81,73,82,74,0,77,88,84,72,83,73,82,73,81,72,81,71,82,70,83,70,84,71,84,74,83,76,81,77,32,82,71,82,72,83,72,83,71,82,71,32,83,73,84,74,32,84,72,83,76,0,70,95,92,77,90,77,88,78,87,80,85,86,84,88,83,89,81,90,77,90,75,89,74,87,74,85,75,83,76,82,81,79,83,77,84,75,84,73,83,71,81,70,80,70,78,71,77,73,77,75,78,78,80,81,85,87,88,90,90,91,92,91,32,92,77,92,78,90,78,87,80,32,90,77,88,80,86,86,85,88,83,90,81,91,77,91,75,90,74,89,73,87,73,85,74,83,76,81,81,78,82,77,83,75,83,73,82,71,32,83,72,81,71,80,71,78,72,32,79,71,78,73,78,75,79,78,81,81,86,87,88,89,90,90,92,90,92,91,0,73,92,82,66,82,95,83,95,32,82,66,83,66,83,95,32,87,73,89,73,87,71,84,70,81,70,78,71,76,73,76,75,77,77,78,78,86,82,87,83,88,85,88,87,87,89,84,90,81,90,79,89,78,88,32,87,73,86,72,84,71,81,71,78,72,77,73,77,75,78,77,86,81,88,83,89,85,89,87,88,89,87,90,84,91,81,91,78,90,76,88,78,88,32,88,88,85,90,0,71,94,91,66,73,98,74,98,32,91,66,92,66,74,98,0,75,89,85,66,83,68,81,71,79,75,78,80,78,84,79,89,81,93,83,96,85,98,86,98,32,85,66,86,66,84,68,82,71,80,75,79,80,79,84,80,89,82,93,84,96,86,98,0,75,89,78,66,80,68,82,71,84,75,85,80,85,84,84,89,82,93,80,96,78,98,79,98,32,78,66,79,66,81,68,83,71,85,75,86,80,86,84,85,89,83,93,81,96,79,98,0,74,90,82,70,81,71,83,81,82,82,32,82,70,82,82,32,82,70,83,71,81,81,82,82,32,77,73,78,73,86,79,87,79,32,77,73,87,79,32,77,73,77,74,87,78,87,79,32,87,73,86,73,78,79,77,79,32,87,73,77,79,32,87,73,87,74,77,78,77,79,0,70,95,74,81,91,81,91,82,32,74,81,74,82,91,82,0,70,95,82,73,82,90,83,90,32,82,73,83,73,83,90,32,74,81,91,81,91,82,32,74,81,74,82,91,82,0,70,95,74,77,91,77,91,78,32,74,77,74,78,91,78,32,74,85,91,85,91,86,32,74,85,74,86,91,86,0,78,87,83,70,82,71,82,77,32,83,71,82,77,32,83,70,84,71,82,77,0,73,91,78,70,77,71,77,77,32,78,71,77,77,32,78,70,79,71,77,77,32,87,70,86,71,86,77,32,87,71,86,77,32,87,70,88,71,86,77,0,75,89,81,70,79,71,78,73,78,75,79,77,81,78,83,78,85,77,86,75,86,73,85,71,83,70,81,70,32,81,70,78,73,79,77,83,78,86,75,85,71,81,70,32,83,70,79,71,78,75,81,78,85,77,86,73,83,70,0,70,94,90,73,74,82,90,91,32,90,73,90,74,76,82,90,90,90,91,0,70,94,74,73,90,82,74,91,32,74,73,74,74,88,82,74,90,74,91,0,71,94,79,70,79,98,80,98,32,79,70,80,70,80,98,32,85,70,85,98,86,98,32,85,70,86,70,86,98,32,74,80,91,80,91,81,32,74,80,74,81,91,81,32,74,87,91,87,91,88,32,74,87,74,88,91,88,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,72,91,73,91,32,91,70,92,70,73,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,32,78,70,74,71,73,75,77,77,80,74,78,70,32,76,70,73,73,75,77,79,76,80,72,76,70,32,89,84,85,85,84,89,88,91,91,88,89,84,32,87,84,84,87,86,91,90,90,91,86,87,84,0,69,96,87,77,84,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,84,86,87,84,32,87,77,84,76,81,76,79,77,78,79,78,82,79,84,81,85,84,85,87,84,32,86,75,86,83,87,85,89,86,90,86,92,85,93,83,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,85,91,89,90,32,86,75,87,75,87,83,88,85,90,86,32,89,86,91,85,92,83,92,79,91,76,90,74,89,73,87,72,84,71,81,71,78,72,76,73,75,74,74,76,73,79,73,82,74,85,75,87,76,88,78,89,81,90,85,90,89,89,89,90,0,69,95,74,80,76,79,78,79,80,80,83,84,84,85,86,86,88,86,90,85,91,83,91,81,90,79,88,78,86,78,84,79,83,80,80,84,78,85,76,85,74,84,32,90,80,88,79,86,79,84,80,81,84,80,85,78,86,76,86,74,85,73,83,73,81,74,79,76,78,78,78,80,79,81,80,84,84,86,85,88,85,90,84,32,75,79,74,81,74,83,75,85,32,89,85,90,83,90,81,89,79,0,72,93,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,84,70,32,84,70,82,71,80,73,78,76,77,79,76,83,76,86,77,89,79,91,32,81,91,83,90,85,88,87,85,88,82,89,78,89,75,88,72,86,70,0,72,93,84,74,79,91,32,86,70,80,91,32,86,70,83,73,80,75,78,76,32,85,73,81,75,78,76,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,87,79,84,81,80,83,77,85,75,87,73,91,32,86,70,88,71,89,73,89,75,88,77,86,79,80,83,32,74,89,75,88,77,88,82,90,85,90,87,89,88,87,32,77,88,82,91,85,91,87,90,88,87,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,86,79,83,80,32,86,70,88,71,89,73,89,75,88,77,86,79,32,81,80,83,80,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,32,83,80,85,81,86,82,87,84,87,87,86,89,85,90,83,91,0,72,93,88,71,82,91,32,89,70,83,91,32,89,70,74,85,90,85,0,72,93,81,70,76,80,32,81,70,91,70,32,81,71,86,71,91,70,32,76,80,77,79,80,78,83,78,86,79,87,80,88,82,88,85,87,88,85,90,82,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,32,83,78,85,79,86,80,87,82,87,85,86,88,84,90,82,91,0,72,93,89,73,88,74,89,75,90,74,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,87,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,81,79,79,80,77,82,76,84,32,84,70,82,71,80,73,78,76,77,79,76,83,76,88,77,90,32,82,91,84,90,86,88,87,86,87,82,86,80,0,72,93,78,70,76,76,32,91,70,90,73,88,76,83,82,81,85,80,87,79,91,32,88,76,82,82,80,85,79,87,78,91,32,77,73,80,70,82,70,87,73,32,78,72,80,71,82,71,87,73,89,73,90,72,91,70,0,72,93,83,70,80,71,79,72,78,74,78,77,79,79,81,80,84,80,88,79,89,78,90,76,90,73,89,71,86,70,83,70,32,83,70,81,71,80,72,79,74,79,77,80,79,81,80,32,84,80,87,79,88,78,89,76,89,73,88,71,86,70,32,81,80,77,81,75,83,74,85,74,88,75,90,78,91,82,91,86,90,87,89,88,87,88,84,87,82,86,81,84,80,32,81,80,78,81,76,83,75,85,75,88,76,90,78,91,32,82,91,85,90,86,89,87,87,87,83,86,81,0,72,93,89,77,88,79,86,81,84,82,81,82,79,81,78,80,77,78,77,75,78,73,80,71,83,70,86,70,88,71,89,72,90,74,90,78,89,82,88,85,86,88,84,90,81,91,78,91,76,90,75,88,75,87,76,86,77,87,76,88,32,79,81,78,79,78,75,79,73,81,71,83,70,32,88,71,89,73,89,78,88,82,87,85,85,88,83,90,81,91,0,77,88,80,89,79,90,80,91,81,90,80,89,0,77,88,80,91,79,90,80,89,81,90,81,91,80,93,78,95,0,77,88,83,77,82,78,83,79,84,78,83,77,32,80,89,79,90,80,91,81,90,0,77,88,83,77,82,78,83,79,84,78,83,77,32,80,91,79,90,80,89,81,90,81,91,80,93,78,95,0,77,88,85,70,84,71,82,83,32,85,71,82,83,32,85,70,86,71,82,83,32,80,89,79,90,80,91,81,90,80,89,0,72,93,79,74,80,75,79,76,78,75,78,74,79,72,80,71,83,70,87,70,90,71,91,73,91,75,90,77,89,78,83,80,81,81,81,83,82,84,84,84,32,87,70,89,71,90,73,90,75,89,77,88,78,86,79,32,80,89,79,90,80,91,81,90,80,89,0,77,88,86,70,84,72,83,74,83,75,84,76,85,75,84,74,0,77,88,85,72,84,71,85,70,86,71,86,72,85,74,83,76,0,69,95,92,78,91,79,92,80,93,79,93,78,92,77,91,77,89,78,87,80,82,88,80,90,78,91,75,91,72,90,71,88,71,86,72,84,73,83,75,82,80,80,82,79,84,77,85,75,85,73,84,71,82,70,80,71,79,73,79,76,80,82,81,85,83,88,85,90,87,91,89,91,90,89,90,88,32,75,91,73,90,72,88,72,86,73,84,74,83,80,80,32,79,76,80,81,81,84,83,87,85,89,87,90,89,90,90,89,0,72,93,84,66,76,95,32,89,66,81,95,32,90,74,89,75,90,76,91,75,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,75,78,77,79,78,86,82,88,84,32,77,75,79,77,86,81,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,86,75,85,76,86,75,87,0,71,93,95,66,69,98,0,75,90,90,66,86,69,83,72,81,75,79,79,78,84,78,88,79,93,80,96,81,98,32,86,69,83,73,81,77,80,80,79,85,79,90,80,95,81,98,0,74,89,83,66,84,68,85,71,86,76,86,80,85,85,83,89,81,92,78,95,74,98,32,83,66,84,69,85,74,85,79,84,84,83,87,81,91,78,95,0,74,91,84,70,84,82,32,79,73,89,79,32,89,73,79,79,0,78,87,85,70,83,77,32,86,70,83,77,0,73,91,80,70,78,77,32,81,70,78,77,32,89,70,87,77,32,90,70,87,77,0,75,90,83,70,81,71,80,73,80,75,81,77,83,78,85,78,87,77,88,75,88,73,87,71,85,70,83,70,0,72,93,83,70,76,98,32,89,70,82,98,32,76,81,90,81,32,75,87,89,87,0,69,95,94,70,92,71,88,72,85,72,81,71,79,70,77,70,75,71,74,73,74,75,76,77,78,77,80,76,81,74,81,72,79,70,32,94,70,70,91,32,88,84,86,84,84,85,83,87,83,89,85,91,87,91,89,90,90,88,90,86,88,84,0,71,93,76,70,76,91,32,77,70,77,91,32,73,70,89,70,89,76,88,70,32,77,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,70,94,78,70,78,76,77,84,76,88,75,90,74,91,32,88,70,88,91,32,89,70,89,91,32,75,70,92,70,32,71,91,92,91,32,71,91,71,98,32,72,91,71,98,32,91,91,92,98,32,92,91,92,98,0,67,98,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,71,71,72,72,71,73,70,72,70,71,71,70,72,70,73,71,74,73,75,77,76,79,78,80,87,80,89,79,90,77,91,73,92,71,93,70,94,70,95,71,95,72,94,73,93,72,94,71,32,78,80,76,81,75,83,74,88,73,90,72,91,32,78,80,77,81,76,83,75,88,74,90,73,91,71,91,70,90,69,88,32,87,80,89,81,90,83,91,88,92,90,93,91,32,87,80,88,81,89,83,90,88,91,90,92,91,94,91,95,90,96,88,32,79,91,86,91,0,72,92,76,73,75,70,75,76,76,73,78,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,81,79,32,84,70,86,71],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+317502);allocate([87,73,87,76,86,78,84,79,32,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,79,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,87,81,88,84,88,87,87,89,86,90,84,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,88,72,76,89,32,72,91,79,91,32,85,91,92,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,88,72,76,89,32,72,91,79,91,32,85,91,92,91,32,78,64,78,63,77,63,77,64,78,66,80,67,84,67,86,66,87,64,0,70,94,75,70,75,91,32,76,70,76,91,32,72,70,79,70,32,76,80,83,80,85,79,86,77,87,73,88,71,89,70,90,70,91,71,91,72,90,73,89,72,90,71,32,83,80,85,81,86,83,87,88,88,90,89,91,32,83,80,84,81,85,83,86,88,87,90,88,91,90,91,91,90,92,88,32,72,91,79,91,0,69,94,77,70,77,76,76,84,75,88,74,90,73,91,72,91,71,90,71,89,72,88,73,89,72,90,32,88,70,88,91,32,89,70,89,91,32,74,70,92,70,32,85,91,92,91,0,72,93,75,70,82,86,32,76,70,83,86,32,90,70,83,86,81,89,80,90,78,91,77,91,76,90,76,89,77,88,78,89,77,90,32,73,70,79,70,32,86,70,92,70,0,70,95,82,70,82,91,32,83,70,83,91,32,79,70,86,70,32,80,73,76,74,74,76,73,79,73,82,74,85,76,87,80,88,85,88,89,87,91,85,92,82,92,79,91,76,89,74,85,73,80,73,32,80,73,77,74,75,76,74,79,74,82,75,85,77,87,80,88,32,85,88,88,87,90,85,91,82,91,79,90,76,88,74,85,73,32,79,91,86,91,0,70,94,75,70,75,91,32,76,70,76,91,32,88,70,88,91,32,89,70,89,91,32,72,70,79,70,32,85,70,92,70,32,72,91,92,91,32,91,91,92,98,32,92,91,92,98,0,70,93,75,70,75,81,76,83,79,84,82,84,85,83,87,81,32,76,70,76,81,77,83,79,84,32,87,70,87,91,32,88,70,88,91,32,72,70,79,70,32,84,70,91,70,32,84,91,91,91,0,66,99,71,70,71,91,32,72,70,72,91,32,82,70,82,91,32,83,70,83,91,32,93,70,93,91,32,94,70,94,91,32,68,70,75,70,32,79,70,86,70,32,90,70,97,70,32,68,91,97,91,0,66,99,71,70,71,91,32,72,70,72,91,32,82,70,82,91,32,83,70,83,91,32,93,70,93,91,32,94,70,94,91,32,68,70,75,70,32,79,70,86,70,32,90,70,97,70,32,68,91,97,91,32,96,91,97,98,32,97,91,97,98,0,70,96,80,70,80,91,32,81,70,81,91,32,73,70,72,76,72,70,84,70,32,81,80,88,80,91,81,92,82,93,84,93,87,92,89,91,90,88,91,77,91,32,88,80,90,81,91,82,92,84,92,87,91,89,90,90,88,91,0,67,97,72,70,72,91,32,73,70,73,91,32,69,70,76,70,32,73,80,80,80,83,81,84,82,85,84,85,87,84,89,83,90,80,91,69,91,32,80,80,82,81,83,82,84,84,84,87,83,89,82,90,80,91,32,91,70,91,91,32,92,70,92,91,32,88,70,95,70,32,88,91,95,91,0,72,93,77,70,77,91,32,78,70,78,91,32,74,70,81,70,32,78,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,74,91,32,85,80,87,81,88,82,89,84,89,87,88,89,87,90,85,91,0,72,93,76,73,75,70,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,86,76,87,32,83,70,85,71,87,73,88,75,89,78,89,83,88,86,87,88,85,90,83,91,32,80,80,89,80,0,67,98,72,70,72,91,32,73,70,73,91,32,69,70,76,70,32,69,91,76,91,32,86,70,83,71,81,73,80,75,79,79,79,82,80,86,81,88,83,90,86,91,88,91,91,90,93,88,94,86,95,82,95,79,94,75,93,73,91,71,88,70,86,70,32,86,70,84,71,82,73,81,75,80,79,80,82,81,86,82,88,84,90,86,91,32,88,91,90,90,92,88,93,86,94,82,94,79,93,75,92,73,90,71,88,70,32,73,80,79,80,0,71,93,87,70,87,91,32,88,70,88,91,32,91,70,79,70,76,71,75,72,74,74,74,76,75,78,76,79,79,80,87,80,32,79,70,77,71,76,72,75,74,75,76,76,78,77,79,79,80,32,82,80,80,81,79,82,76,89,75,90,74,90,73,89,32,80,81,79,83,77,90,76,91,74,91,73,89,73,88,32,84,91,91,91,0,72,92,88,70,87,71,81,73,78,75,76,78,75,81,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,78,78,76,80,75,83,32,88,70,87,72,85,73,81,74,78,76,76,78,32,81,77,79,78,77,80,76,83,76,85,77,88,79,90,81,91,32,83,91,85,90,87,88,88,85,88,83,87,80,85,78,83,77,0,72,92,77,77,77,91,32,78,77,78,91,32,74,77,85,77,88,78,89,80,89,81,88,83,85,84,32,85,77,87,78,88,80,88,81,87,83,85,84,32,78,84,85,84,88,85,89,87,89,88,88,90,85,91,74,91,32,85,84,87,85,88,87,88,88,87,90,85,91,0,72,90,77,77,77,91,32,78,77,78,91,32,74,77,88,77,88,82,87,77,32,74,91,81,91,0,70,93,78,77,78,81,77,87,76,90,75,91,32,87,77,87,91,32,88,77,88,91,32,75,77,91,77,32,73,91,72,96,72,91,91,91,91,96,90,91,0,69,96,82,77,82,91,32,83,77,83,91,32,79,77,86,77,32,74,78,73,79,72,78,73,77,74,77,75,78,77,82,78,83,80,84,85,84,87,83,88,82,90,78,91,77,92,77,93,78,92,79,91,78,32,80,84,78,85,77,86,75,90,74,91,32,80,84,78,86,76,90,75,91,73,91,72,90,71,88,32,85,84,87,85,88,86,90,90,91,91,32,85,84,87,86,89,90,90,91,92,91,93,90,94,88,32,79,91,86,91,0,73,91,77,79,76,77,76,81,77,79,78,78,80,77,84,77,87,78,88,80,88,81,87,83,84,84,32,84,77,86,78,87,80,87,81,86,83,84,84,32,81,84,84,84,87,85,88,87,88,88,87,90,84,91,80,91,77,90,76,88,76,87,77,86,78,87,77,88,32,84,84,86,85,87,87,87,88,86,90,84,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,80,91,32,84,91,91,91,32,87,78,77,90,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,80,91,32,84,91,91,91,32,87,78,77,90,32,79,71,79,70,78,70,78,71,79,73,81,74,83,74,85,73,86,71,0,72,92,77,77,77,91,32,78,77,78,91,32,74,77,81,77,32,78,84,80,84,83,83,84,82,86,78,87,77,88,77,89,78,88,79,87,78,32,80,84,83,85,84,86,86,90,87,91,32,80,84,82,85,83,86,85,90,86,91,88,91,89,90,90,88,32,74,91,81,91,0,71,93,78,77,78,81,77,87,76,90,75,91,74,91,73,90,74,89,75,90,32,87,77,87,91,32,88,77,88,91,32,75,77,91,77,32,84,91,91,91,0,71,94,76,77,76,91,32,76,77,82,91,32,77,77,82,89,32,88,77,82,91,32,88,77,88,91,32,89,77,89,91,32,73,77,77,77,32,88,77,92,77,32,73,91,79,91,32,85,91,92,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,77,84,87,84,32,73,91,80,91,32,84,91,91,91,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,91,77,32,73,91,80,91,32,84,91,91,91,0,73,92,82,77,82,91,32,83,77,83,91,32,77,77,76,82,76,77,89,77,89,82,88,77,32,79,91,86,91,0,73,91,76,77,82,91,32,77,77,82,89,32,88,77,82,91,80,95,78,97,76,98,75,98,74,97,75,96,76,97,32,74,77,80,77,32,84,77,90,77,0,72,93,82,70,82,98,32,83,70,83,98,32,79,70,83,70,32,82,80,81,78,80,77,78,77,76,78,75,81,75,87,76,90,78,91,80,91,81,90,82,88,32,78,77,77,78,76,81,76,87,77,90,78,91,32,87,77,88,78,89,81,89,87,88,90,87,91,32,83,80,84,78,85,77,87,77,89,78,90,81,90,87,89,90,87,91,85,91,84,90,83,88,32,79,98,86,98,0,71,93,76,77,76,91,32,77,77,77,91,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,73,91,91,91,91,96,90,91,0,71,93,76,77,76,84,77,86,80,87,82,87,85,86,87,84,32,77,77,77,84,78,86,80,87,32,87,77,87,91,32,88,77,88,91,32,73,77,80,77,32,84,77,91,77,32,84,91,91,91,0,67,98,72,77,72,91,32,73,77,73,91,32,82,77,82,91,32,83,77,83,91,32,92,77,92,91,32,93,77,93,91,32,69,77,76,77,32,79,77,86,77,32,89,77,96,77,32,69,91,96,91,0,67,98,72,77,72,91,32,73,77,73,91,32,82,77,82,91,32,83,77,83,91,32,92,77,92,91,32,93,77,93,91,32,69,77,76,77,32,79,77,86,77,32,89,77,96,77,32,69,91,96,91,96,96,95,91,0,72,93,81,77,81,91,32,82,77,82,91,32,76,77,75,82,75,77,85,77,32,82,84,86,84,89,85,90,87,90,88,89,90,86,91,78,91,32,86,84,88,85,89,87,89,88,88,90,86,91,0,69,95,74,77,74,91,32,75,77,75,91,32,71,77,78,77,32,75,84,79,84,82,85,83,87,83,88,82,90,79,91,71,91,32,79,84,81,85,82,87,82,88,81,90,79,91,32,89,77,89,91,32,90,77,90,91,32,86,77,93,77,32,86,91,93,91,0,74,91,79,77,79,91,32,80,77,80,91,32,76,77,83,77,32,80,84,84,84,87,85,88,87,88,88,87,90,84,91,76,91,32,84,84,86,85,87,87,87,88,86,90,84,91,0,73,92,77,79,76,77,76,81,77,79,78,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,78,90,76,88,76,87,77,86,78,87,77,88,32,83,77,85,78,87,80,88,83,88,85,87,88,85,90,83,91,32,82,84,88,84,0,68,97,73,77,73,91,32,74,77,74,91,32,70,77,77,77,32,70,91,77,91,32,86,77,83,78,81,80,80,83,80,85,81,88,83,90,86,91,88,91,91,90,93,88,94,85,94,83,93,80,91,78,88,77,86,77,32,86,77,84,78,82,80,81,83,81,85,82,88,84,90,86,91,32,88,91,90,90,92,88,93,85,93,83,92,80,90,78,88,77,32,74,84,80,84,0,71,92,86,77,86,91,32,87,77,87,91,32,90,77,79,77,76,78,75,80,75,81,76,83,79,84,86,84,32,79,77,77,78,76,80,76,81,77,83,79,84,32,84,84,81,85,80,86,78,90,77,91,32,84,84,82,85,81,86,79,90,78,91,76,91,75,90,74,88,32,83,91,90,91,0,72,92,82,70,75,90,32,81,73,87,91,32,82,73,88,91,32,82,70,89,91,32,77,85,86,85,32,73,91,79,91,32,84,91,91,91,32,75,90,74,91,32,75,90,77,91,32,87,90,85,91,32,87,89,86,91,32,88,89,90,91,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,32,88,72,89,74,89,76,88,78,32,85,70,87,71,88,73,88,77,87,79,85,80,32,78,80,85,80,88,81,89,82,90,84,90,87,89,89,88,90,85,91,73,91,32,88,82,89,84,89,87,88,89,32,85,80,87,81,88,83,88,88,87,90,85,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,92,88,73,89,70,89,76,88,73,86,71,84,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,84,91,86,90,88,88,89,86,32,77,73,76,75,75,78,75,83,76,86,77,88,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,83,70,86,71,88,73,89,75,90,78,90,83,89,86,88,88,86,90,83,91,73,91,32,87,73,88,75,89,78,89,83,88,86,87,88,32,83,70,85,71,87,74,88,78,88,83,87,87,85,90,83,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,92,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,89,70,89,76,32,78,80,84,80,32,84,76,84,84,32,73,91,89,91,89,85,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,84,70,89,71,32,86,70,89,72,32,87,70,89,73,32,88,70,89,76,32,84,76,83,80,84,84,32,84,78,82,80,84,82,32,84,79,80,80,84,81,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,84,91,89,90,32,86,91,89,89,32,87,91,89,88,32,88,91,89,85,0,71,91,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,89,70,89,76,32,78,80,84,80,32,84,76,84,84,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,84,70,89,71,32,86,70,89,72,32,87,70,89,73,32,88,70,89,76,32,84,76,83,80,84,84,32,84,78,82,80,84,82,32,84,79,80,80,84,81,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,94,88,73,89,70,89,76,88,73,86,71,84,70,81,70,78,71,76,73,75,75,74,78,74,83,75,86,76,88,78,90,81,91,84,91,86,90,88,90,89,91,89,83,32,77,73,76,75,75,78,75,83,76,86,77,88,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,88,84,88,89,32,87,83,87,89,86,90,32,84,83,92,83,32,85,83,87,84,32,86,83,87,85,32,90,83,89,85,32,91,83,89,84,0,70,94,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,87,70,87,91,32,88,71,88,90,32,89,70,89,91,32,72,70,80,70,32,84,70,92,70,32,77,80,87,80,32,72,91,80,91,32,84,91,92,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,85,70,87,71,32,86,70,87,72,32,90,70,89,72,32,91,70,89,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,76,88,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,74,90,83,70,83,87,82,90,81,91,32,84,71,84,87,83,90,32,85,70,85,87,84,90,81,91,79,91,77,90,76,88,76,86,77,85,78,85,79,86,79,87,78,88,77,88,32,77,86,77,87,78,87,78,86,77,86,32,80,70,88,70,32,81,70,83,71,32,82,70,83,72,32,86,70,85,72,32,87,70,85,71,0,70,92,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,88,71,77,82,32,80,80,87,91,32,81,80,88,91,32,81,78,89,91,32,72,70,80,70,32,85,70,91,70,32,72,91,80,91,32,84,91,91,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,87,70,88,71,32,90,70,88,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,89,85,91,32,87,89,90,91,0,73,91,78,70,78,91,32,79,71,79,90,32,80,70,80,91,32,75,70,83,70,32,75,91,90,91,90,85,32,76,70,78,71,32,77,70,78,72,32,81,70,80,72,32,82,70,80,71,32,78,90,76,91,32,78,89,77,91,32,80,89,81,91,32,80,90,82,91,32,85,91,90,90,32,87,91,90,89,32,88,91,90,88,32,89,91,90,85,0,69,95,74,70,74,90,32,74,70,81,91,32,75,70,81,88,32,76,70,82,88,32,88,70,81,91,32,88,70,88,91,32,89,71,89,90,32,90,70,90,91,32,71,70,76,70,32,88,70,93,70,32,71,91,77,91,32,85,91,93,91,32,72,70,74,71,32,91,70,90,72,32,92,70,90,71,32,74,90,72,91,32,74,90,76,91,32,88,90,86,91,32,88,89,87,91,32,90,89,91,91,32,90,90,92,91,0,70,94,75,70,75,90,32,75,70,89,91,32,76,70,88,88,32,77,70,89,88,32,89,71,89,91,32,72,70,77,70,32,86,70,92,70,32,72,91,78,91,32,73,70,75,71,32,87,70,89,71,32,91,70,89,71,32,75,90,73,91,32,75,90,77,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,77,89,79,88,80,85,81,78,81,32,88,72,89,74,89,77,88,79,32,85,70,87,71,88,73,88,78,87,80,85,81,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,32,78,88,79,86,81,85,82,85,84,86,85,88,86,94,87,96,89,96,90,94,90,92,32,86,92,87,94,88,95,89,95,32,85,88,87,93,88,94,89,94,90,93,0,71,93,76,70,76,91,32,77,71,77,90,32,78,70,78,91,32,73,70,85,70,88,71,89,72,90,74,90,76,89,78,88,79,85,80,78,80,32,88,72,89,74,89,76,88,78,32,85,70,87,71,88,73,88,77,87,79,85,80,32,82,80,84,81,85,83,87,89,88,91,90,91,91,89,91,87,32,87,87,88,89,89,90,90,90,32,84,81,85,82,88,88,89,89,90,89,91,88,32,73,91,81,91,32,74,70,76,71,32,75,70,76,72,32,79,70,78,72,32,80,70,78,71,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,0,72,92,88,73,89,70,89,76,88,73,86,71,83,70,80,70,77,71,75,73,75,76,76,78,79,80,85,82,87,83,88,85,88,88,87,90,32,76,76,77,78,79,79,85,81,87,82,88,84,32,77,71,76,73,76,75,77,77,79,78,85,80,88,82,89,84,89,87,88,89,87,90,84,91,81,91,78,90,76,88,75,85,75,91,76,88,0,72,92,74,70,74,76,32,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,90,70,90,76,32,74,70,90,70,32,78,91,86,91,32,75,70,74,76,32,76,70,74,73,32,77,70,74,72,32,79,70,74,71,32,85,70,90,71,32,87,70,90,72,32,88,70,90,73,32,89,70,90,76,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,70,94,75,70,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,71,32,76,71,76,86,77,88,32,77,70,77,86,78,89,79,90,81,91,32,72,70,80,70,32,86,70,92,70,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,87,70,89,71,32,91,70,89,71,0,72,92,75,70,82,91,32,76,70,82,88,82,91,32,77,70,83,88,32,89,71,82,91,32,73,70,80,70,32,85,70,91,70,32,74,70,76,72,32,78,70,77,72,32,79,70,77,71,32,87,70,89,71,32,90,70,89,71,0,70,94,74,70,78,91,32,75,70,78,86,78,91,32,76,70,79,86,32,82,70,79,86,78,91,32,82,70,86,91,32,83,70,86,86,86,91,32,84,70,87,86,32,90,71,87,86,86,91,32,71,70,79,70,32,82,70,84,70,32,87,70,93,70,32,72,70,75,71,32,73,70,75,72,32,77,70,76,72,32,78,70,76,71,32,88,70,90,71,32,92,70,90,71,0,72,92,75,70,87,91,32,76,70,88,91,32,77,70,89,91,32,88,71,76,90,32,73,70,80,70,32,85,70,91,70,32,73,91,79,91,32,84,91,91,91,32,74,70,77,72,32,78,70,77,72,32,79,70,77,71,32,86,70,88,71,32,90,70,88,71,32,76,90,74,91,32,76,90,78,91,32,87,90,85,91,32,87,89,86,91,32,87,89,90,91,0,71,93,74,70,81,81,81,91,32,75,70,82,81,82,90,32,76,70,83,81,83,91,32,89,71,83,81,32,72,70,79,70,32,86,70,92,70,32,78,91,86,91,32,73,70,75,71,32,78,70,76,71,32,87,70,89,71,32,91,70,89,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,72,92,89,70,75,70,75,76,32,87,70,75,91,32,88,70,76,91,32,89,70,77,91,32,75,91,89,91,89,85,32,76,70,75,76,32,77,70,75,73,32,78,70,75,72,32,80,70,75,71,32,84,91,89,90,32,86,91,89,89,32,87,91,89,88,32,88,91,89,85,0,73,91,78,70,78,91,32,79,71,79,90,32,80,70,80,91,32,75,70,90,70,90,76,32,75,91,83,91,32,76,70,78,71,32,77,70,78,72,32,81,70,80,72,32,82,70,80,71,32,85,70,90,71,32,87,70,90,72,32,88,70,90,73,32,89,70,90,76,32,78,89,77,91,32,78,90,76,91,32,80,89,81,91,32,80,90,82,91,0,72,92,82,70,74,91,32,81,73,88,91,32,82,73,89,91,32,82,70,90,91,32,75,89,88,89,32,75,90,88,90,32,74,91,90,91,0,71,93,81,70,78,71,76,73,75,75,74,79,74,82,75,86,76,88,78,90,81,91,83,91,86,90,88,88,89,86,90,82,90,79,89,75,88,73,86,71,83,70,81,70,32,77,73,76,75,75,78,75,83,76,86,77,88,32,87,88,88,86,89,83,89,78,88,75,87,73,32,81,70,79,71,77,74,76,78,76,83,77,87,79,90,81,91,32,83,91,85,90,87,87,88,83,88,78,87,74,85,71,83,70,32,79,77,79,84,32,85,77,85,84,32,79,80,85,80,32,79,81,85,81,32,79,78,80,80,32,79,79,81,80,32,85,78,84,80,32,85,79,83,80,32,80,81,79,83,32,81,81,79,82,32,83,81,85,82,32,84,81,85,83,0,72,92,82,70,75,90,32,81,73,87,91,32,82,73,88,91,32,82,70,89,91,32,73,91,79,91,32,84,91,91,91,32,75,90,74,91,32,75,90,77,91,32,87,90,85,91,32,87,89,86,91,32,88,89,90,91,0,71,93,74,69,74,76,32,90,69,90,76,32,79,77,79,84,32,85,77,85,84,32,74,85,74,92,32,90,85,90,92,32,74,71,90,71,32,74,72,90,72,32,74,73,90,73,32,79,80,85,80,32,79,81,85,81,32,74,88,90,88,32,74,89,90,89,32,74,90,90,90,32,74,70,77,72,32,90,70,87,72,32,75,73,74,75,32,76,73,74,74,32,88,73,90,74,32,89,73,90,75,32,79,78,80,80,32,79,79,81,80,32,85,78,84,80,32,85,79,83,80,32,80,81,79,83,32,81,81,79,82,32,83,81,85,82,32,84,81,85,83,32,74,86,75,88,32,74,87,76,88,32,90,87,88,88,32,90,86,89,88,32,77,89,74,91,32,87,89,90,91,0,70,94,75,70,75,91,32,76,71,76,90,32,77,70,77,91,32,87,70,87,91,32,88,71,88,90,32,89,70,89,91,32,72,70,92,70,32,72,91,80,91,32,84,91,92,91,32,73,70,75,71,32,74,70,75,72,32,78,70,77,72,32,79,70,77,71,32,85,70,87,71,32,86,70,87,72,32,90,70,89,72,32,91,70,89,71,32,75,90,73,91,32,75,89,74,91,32,77,89,78,91,32,77,90,79,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,71,93,73,70,80,80,81,81,32,74,70,81,80,32,75,70,82,80,73,91,32,73,70,89,70,90,76,89,73,87,70,32,86,70,89,72,32,84,70,89,71,32,75,89,89,89,32,74,90,89,90,32,73,91,89,91,90,85,89,88,87,89,0,72,92,74,77,75,73,76,71,77,70,79,70,80,71,81,73,82,77,32,76,72,77,71,79,71,80,72,32,74,77,75,74,77,72,79,72,80,73,81,77,81,91,32,82,77,82,91,32,90,77,89,74,87,72,85,72,84,73,83,77,83,91,32,88,72,87,71,85,71,84,72,32,90,77,89,73,88,71,87,70,85,70,84,71,83,73,82,77,32,78,91,86,91,32,81,89,80,91,32,81,90,79,91,32,83,90,85,91,32,83,89,84,91,0,71,93,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,79,75,76,76,75,77,74,79,74,82,75,84,76,85,79,86,85,86,88,85,89,84,90,82,90,79,89,77,88,76,85,75,79,75,32,76,77,75,79,75,82,76,84,32,88,84,89,82,89,79,88,77,32,79,75,77,76,76,79,76,82,77,85,79,86,32,85,86,87,85,88,82,88,79,87,76,85,75,0,70,94,81,70,81,91,32,82,71,82,90,32,83,70,83,91,32,78,70,86,70,32,78,91,86,91,32,79,70,81,71,32,80,70,81,72,32,84,70,83,72,32,85,70,83,71,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,72,77,73,77,74,78,75,81,76,83,77,84,80,85,84,85,87,84,88,83,89,81,90,78,91,77,92,77,32,76,82,75,78,74,76,73,76,75,78,32,72,77,73,75,74,75,75,76,76,80,77,83,78,84,80,85,32,89,78,91,76,90,76,89,78,88,82,32,84,85,86,84,87,83,88,80,89,76,90,75,91,75,92,77,0,71,93,78,89,75,89,74,87,75,91,79,91,77,86,75,82,74,79,74,76,75,73,77,71,80,70,84,70,87,71,89,73,90,76,90,79,89,82,87,86,85,91,89,91,90,87,89,89,86,89,32,76,83,75,79,75,76,76,73,32,88,73,89,76,89,79,88,83,32,79,91,77,85,76,80,76,75,77,72,78,71,80,70,32,84,70,86,71,87,72,88,75,88,80,87,85,85,91,32,75,90,78,90,32,86,90,89,90,0,72,92,85,70,73,90,32,83,74,84,91,32,84,72,85,90,32,85,70,85,72,86,89,86,91,32,76,85,84,85,32,70,91,76,91,32,81,91,88,91,32,73,90,71,91,32,73,90,75,91,32,84,90,82,91,32,84,89,83,91,32,86,89,87,91,0,70,94,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,32,89,71,90,73,90,75,89,78,88,79,32,87,70,88,71,89,73,89,75,88,78,86,80,32,78,80,86,80,88,81,89,83,89,85,88,88,86,90,82,91,70,91,32,87,81,88,83,88,85,87,88,85,90,32,86,80,87,82,87,85,86,88,84,90,82,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,72,93,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,83,91,85,90,87,88,88,86,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,80,91,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,85,70,88,71,89,72,90,75,90,79,89,83,87,87,85,89,83,90,79,91,70,91,32,87,71,88,72,89,75,89,79,88,83,86,87,84,89,32,85,70,87,72,88,75,88,79,87,83,85,87,82,90,79,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,85,76,83,84,32,76,70,91,70,90,76,32,78,80,84,80,32,70,91,85,91,87,86,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,87,70,90,71,32,88,70,90,72,32,89,70,90,73,32,90,70,90,76,32,85,76,83,80,83,84,32,84,78,82,80,83,82,32,84,79,81,80,83,81,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,32,80,91,85,90,32,82,91,85,89,32,85,89,87,86,0,70,92,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,85,76,83,84,32,76,70,91,70,90,76,32,78,80,84,80,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,87,70,90,71,32,88,70,90,72,32,89,70,90,73,32,90,70,90,76,32,85,76,83,80,83,84,32,84,78,82,80,83,82,32,84,79,81,80,83,81,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,72,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,80,91,82,91,85,90,87,88,89,84,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,86,88,87,87,88,84,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,80,91,32,82,91,84,90,86,87,87,84,32,84,84,92,84,32,85,84,87,85,32,86,84,87,87,32,90,84,88,86,32,91,84,88,85,0,69,95,78,70,72,91,32,79,70,73,91,32,80,70,74,91,32,90,70,84,91,32,91,70,85,91,32,92,70,86,91,32,75,70,83,70,32,87,70,95,70,32,76,80,88,80,32,69,91,77,91,32,81,91,89,91,32,76,70,79,71,32,77,70,78,72,32,81,70,79,72,32,82,70,79,71,32,88,70,91,71,32,89,70,90,72,32,93,70,91,72,32,94,70,91,71,32,73,90,70,91,32,73,89,71,91,32,74,89,75,91,32,73,90,76,91,32,85,90,82,91,32,85,89,83,91,32,86,89,87,91,32,85,90,88,91,0,75,89,84,70,78,91,32,85,70,79,91,32,86,70,80,91,32,81,70,89,70,32,75,91,83,91,32,82,70,85,71,32,83,70,84,72,32,87,70,85,72,32,88,70,85,71,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,73,92,87,70,82,87,81,89,79,91,32,88,70,84,83,83,86,82,88,32,89,70,85,83,83,88,81,90,79,91,77,91,75,90,74,88,74,86,75,85,76,85,77,86,77,87,76,88,75,88,32,75,86,75,87,76,87,76,86,75,86,32,84,70,92,70,32,85,70,88,71,32,86,70,87,72,32,90,70,88,72,32,91,70,88,71,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,92,71,77,82,32,81,79,85,91,32,82,79,86,91,32,83,78,87,90,32,76,70,84,70,32,89,70,95,70,32,70,91,78,91,32,82,91,89,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,90,70,92,71,32,94,70,92,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,32,85,90,83,91,32,85,89,84,91,32,86,89,88,91,0,72,92,81,70,75,91,32,82,70,76,91,32,83,70,77,91,32,78,70,86,70,32,72,91,87,91,89,85,32,79,70,82,71,32,80,70,81,72,32,84,70,82,72,32,85,70,82,71,32,76,90,73,91,32,76,89,74,91,32,77,89,78,91,32,76,90,79,91,32,82,91,87,90,32,84,91,88,88,32,86,91,89,85,0,68,96,77,70,71,90,32,77,71,78,89,78,91,32,78,70,79,89,32,79,70,80,88,32,91,70,80,88,78,91,32,91,70,85,91,32,92,70,86,91,32,93,70,87,91,32,74,70,79,70,32,91,70,96,70,32,68,91,74,91,32,82,91,90,91,32,75,70,77,71,32,76,70,77,72,32,94,70,92,72,32,95,70,92,71,32,71,90,69,91,32,71,90,73,91,32,86,90,83,91,32,86,89,84,91,32,87,89,88,91,32,86,90,89,91,0,70,95,79,70,73,90,32,79,70,86,91,32,80,70,86,88,32,81,70,87,88,32,92,71,87,88,86,91,32,76,70,81,70,32,89,70,95,70,32,70,91,76,91,32,77,70,80,71,32,78,70,80,72,32,90,70,92,71,32,94,70,92,71,32,73,90,71,91,32,73,90,75,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,79,73,77,76,76,79,75,83,75,87,76,89,32,85,88,87,85,88,82,89,78,89,74,88,72,32,83,70,81,71,79,74,78,76,77,79,76,83,76,88,77,90,78,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,0,70,93,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,88,70,91,71,92,73,92,75,91,78,89,80,85,81,77,81,32,90,71,91,73,91,75,90,78,88,80,32,88,70,89,71,90,73,90,75,89,78,87,80,85,81,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,71,93,83,70,80,71,78,73,76,76,75,79,74,83,74,86,75,89,76,90,78,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,83,70,32,79,73,77,76,76,79,75,83,75,87,76,89,32,85,88,87,85,88,82,89,78,89,74,88,72,32,83,70,81,71,79,74,78,76,77,79,76,83,76,88,77,90,78,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,32,76,88,77,86,79,85,80,85,82,86,83,88,84,93,85,94,86,94,87,93,32,84,94,85,95,86,95,32,83,88,83,95,84,96,86,96,87,93,87,92,0,70,94,79,70,73,91,32,80,70,74,91,32,81,70,75,91,32,76,70,87,70,90,71,91,73,91,75,90,78,89,79,86,80,78,80,32,89,71,90,73,90,75,89,78,88,79,32,87,70,88,71,89,73,89,75,88,78,86,80,32,82,80,84,81,85,82,87,88,88,89,89,89,90,88,32,87,89,88,90,89,90,32,85,82,86,90,87,91,89,91,90,88,90,87,32,70,91,78,91,32,77,70,80,71,32,78,70,79,72,32,82,70,80,72,32,83,70,80,71,32,74,90,71,91,32,74,89,72,91,32,75,89,76,91,32,74,90,77,91,0,71,94,90,72,91,72,92,70,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,76,78,78,80,80,86,83,87,85,87,88,86,90,32,78,76,79,78,86,82,87,84,32,79,71,78,73,78,75,79,77,85,80,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,73,91,74,89,75,89,0,71,93,84,70,78,91,32,85,70,79,91,32,86,70,80,91,32,77,70,75,76,32,93,70,92,76,32,77,70,93,70,32,75,91,83,91,32,78,70,75,76,32,80,70,76,73,32,82,70,77,71,32,89,70,92,71,32,90,70,92,72,32,91,70,92,73,32,92,70,92,76,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,70,95,78,70,75,81,74,85,74,88,75,90,78,91,82,91,85,90,87,88,88,85,92,71,32,79,70,76,81,75,85,75,89,76,90,32,80,70,77,81,76,85,76,89,78,91,32,75,70,83,70,32,89,70,95,70,32,76,70,79,71,32,77,70,78,72,32,81,70,79,72,32,82,70,79,71,32,90,70,92,71,32,94,70,92,71,0,72,92,78,70,78,72,79,89,79,91,32,79,71,80,88,32,80,70,81,87,32,91,71,79,91,32,76,70,83,70,32,88,70,94,70,32,77,70,78,72,32,81,70,80,72,32,82,70,79,71,32,89,70,91,71,32,93,70,91,71,0,69,95,77,70,77,72,75,89,75,91,32,78,71,76,88,32,79,70,77,87,32,85,70,77,87,75,91,32,85,70,85,72,83,89,83,91,32,86,71,84,88,32,87,70,85,87,32,93,71,85,87,83,91,32,74,70,82,70,32,85,70,87,70,32,90,70,96,70,32,75,70,78,71,32,76,70,77,72,32,80,70,78,73,32,81,70,78,71,32,91,70,93,71,32,95,70,93,71,0,71,93,78,70,84,91,32,79,70,85,91,32,80,70,86,91,32,91,71,73,90,32,76,70,83,70,32,88,70,94,70,32,70,91,76,91,32,81,91,88,91,32,77,70,79,72,32,81,70,80,72,32,82,70,80,71,32,89,70,91,71,32,93,70,91,71,32,73,90,71,91,32,73,90,75,91,32,84,90,82,91,32,84,89,83,91,32,85,89,87,91,0,71,93,77,70,81,80,78,91,32,78,70,82,80,79,91,32,79,70,83,80,80,91,32,92,71,83,80,32,75,70,82,70,32,89,70,95,70,32,75,91,83,91,32,76,70,78,71,32,80,70,79,72,32,81,70,78,71,32,90,70,92,71,32,94,70,92,71,32,79,90,76,91,32,79,89,77,91,32,80,89,81,91,32,79,90,82,91,0,71,93,90,70,72,91,32,91,70,73,91,32,92,70,74,91,32,92,70,78,70,76,76,32,72,91,86,91,88,85,32,79,70,76,76,32,80,70,77,73,32,82,70,78,71,32,82,91,86,90,32,84,91,87,88,32,85,91,88,85,0,72,92,74,70,82,91,32,75,70,82,88,32,76,70,83,88,32,74,70,90,70,82,91,32,76,71,89,71,32,76,72,89,72,0,73,93,78,80,78,79,79,79,79,81,77,81,77,79,78,78,80,77,84,77,86,78,87,79,88,81,88,88,89,90,90,91,32,86,79,87,81,87,88,88,90,32,84,77,85,78,86,80,86,88,87,90,90,91,91,91,32,86,82,85,83,80,84,77,85,76,87,76,88,77,90,80,91,83,91,85,90,86,88,32,78,85,77,87,77,88,78,90,32,85,83,81,84,79,85,78,87,78,88,79,90,80,91,0,71,92,76,70,76,91,77,90,79,90,32,77,71,77,89,32,73,70,78,70,78,90,32,78,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,78,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,74,70,76,71,32,75,70,76,72,0,72,91,87,81,87,80,86,80,86,82,88,82,88,80,86,78,84,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,0,72,93,86,70,86,91,91,91,32,87,71,87,90,32,83,70,88,70,88,91,32,86,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,86,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,84,70,86,71,32,85,70,86,72,32,88,89,89,91,32,88,90,90,91,0,72,91,77,83,88,83,88,81,87,79,86,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,32,87,82,87,81,86,79,32,77,80,76,82,76,86,77,88,32,86,83,86,80,85,78,83,77,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,0,75,89,87,72,87,71,86,71,86,73,88,73,88,71,87,70,84,70,82,71,81,72,80,75,80,91,32,82,72,81,75,81,90,32,84,70,83,71,82,73,82,91,32,77,77,86,77,32,77,91,85,91,32,80,90,78,91,32,80,89,79,91,32,82,89,83,91,32,82,90,84,91,0,73,92,88,78,89,79,90,78,89,77,88,77,86,78,85,79,32,81,77,79,78,78,79,77,81,77,83,78,85,79,86,81,87,83,87,85,86,86,85,87,83,87,81,86,79,85,78,83,77,81,77,32,79,79,78,81,78,83,79,85,32,85,85,86,83,86,81,85,79,32,81,77,80,78,79,80,79,84,80,86,81,87,32,83,87,84,86,85,84,85,80,84,78,83,77,32,78,85,77,86,76,88,76,89,77,91,78,92,81,93,85,93,88,94,89,95,32,78,91,81,92,85,92,88,93,32,76,89,77,90,80,91,85,91,88,92,89,94,89,95,88,97,85,98,79,98,76,97,75,95,75,94,76,92,79,91,32,79,98,77,97,76,95,76,94,77,92,79,91,0,71,94,76,70,76,91,32,77,71,77,90,32,73,70,78,70,78,91,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,91,32,87,79,88,82,88,90,32,85,77,86,78,87,81,87,91,32,73,91,81,91,32,84,91,92,91,32,74,70,76,71,32,75,70,76,72,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,76,88,81,70,81,72,83,72,83,70,81,70,32,82,70,82,72,32,81,71,83,71,32,81,77,81,91,32,82,78,82,90,32,78,77,83,77,83,91,32,78,91,86,91,32,79,77,81,78,32,80,77,81,79,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,75,88,82,70,82,72,84,72,84,70,82,70,32,83,70,83,72,32,82,71,84,71,32,82,77,82,94,81,97,80,98,32,83,78,83,93,82,96,32,79,77,84,77,84,93,83,96,82,97,80,98,77,98,76,97,76,95,78,95,78,97,77,97,77,96,32,80,77,82,78,32,81,77,82,79,0,71,93,76,70,76,91,32,77,71,77,90,32,73,70,78,70,78,91,32,87,78,78,87,32,82,83,89,91,32,82,84,88,91,32,81,84,87,91,32,84,77,91,77,32,73,91,81,91,32,84,91,91,91,32,74,70,76,71,32,75,70,76,72,32,85,77,87,78,32,90,77,87,78,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,89,85,91,32,86,89,90,91,0,76,88,81,70,81,91,32,82,71,82,90,32,78,70,83,70,83,91,32,78,91,86,91,32,79,70,81,71],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+327742);allocate([32,80,70,81,72,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,65,99,70,77,70,91,32,71,78,71,90,32,67,77,72,77,72,91,32,72,81,73,79,74,78,76,77,79,77,81,78,82,79,83,82,83,91,32,81,79,82,82,82,90,32,79,77,80,78,81,81,81,91,32,83,81,84,79,85,78,87,77,90,77,92,78,93,79,94,82,94,91,32,92,79,93,82,93,90,32,90,77,91,78,92,81,92,91,32,67,91,75,91,32,78,91,86,91,32,89,91,97,91,32,68,77,70,78,32,69,77,70,79,32,70,90,68,91,32,70,89,69,91,32,72,89,73,91,32,72,90,74,91,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,32,92,90,90,91,32,92,89,91,91,32,94,89,95,91,32,94,90,96,91,0,71,94,76,77,76,91,32,77,78,77,90,32,73,77,78,77,78,91,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,91,32,87,79,88,82,88,90,32,85,77,86,78,87,81,87,91,32,73,91,81,91,32,84,91,92,91,32,74,77,76,78,32,75,77,76,79,32,76,90,74,91,32,76,89,75,91,32,78,89,79,91,32,78,90,80,91,32,87,90,85,91,32,87,89,86,91,32,89,89,90,91,32,89,90,91,91,0,72,92,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,77,80,76,82,76,86,77,88,32,87,88,88,86,88,82,87,80,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,83,77,0,71,92,76,77,76,98,32,77,78,77,97,32,73,77,78,77,78,98,32,78,80,79,78,81,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,81,91,79,90,78,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,73,98,81,98,32,74,77,76,78,32,75,77,76,79,32,76,97,74,98,32,76,96,75,98,32,78,96,79,98,32,78,97,80,98,0,72,92,86,78,86,98,32,87,79,87,97,32,85,78,87,78,88,77,88,98,32,86,80,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,85,90,86,88,32,77,80,76,82,76,86,77,88,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,98,91,98,32,86,97,84,98,32,86,96,85,98,32,88,96,89,98,32,88,97,90,98,0,73,90,78,77,78,91,32,79,78,79,90,32,75,77,80,77,80,91,32,87,79,87,78,86,78,86,80,88,80,88,78,87,77,85,77,83,78,81,80,80,83,32,75,91,83,91,32,76,77,78,78,32,77,77,78,79,32,78,90,76,91,32,78,89,77,91,32,80,89,81,91,32,80,90,82,91,0,74,91,87,79,88,77,88,81,87,79,86,78,84,77,80,77,78,78,77,79,77,81,78,83,80,84,85,85,87,86,88,89,32,78,78,77,81,32,78,82,80,83,85,84,87,85,32,88,86,87,90,32,77,79,78,81,80,82,85,83,87,84,88,86,88,89,87,90,85,91,81,91,79,90,78,89,77,87,77,91,78,89,0,75,90,80,72,80,86,81,89,82,90,84,91,86,91,88,90,89,88,32,81,72,81,87,82,89,32,80,72,82,70,82,87,83,90,84,91,32,77,77,86,77,0,71,94,76,77,76,86,77,89,78,90,80,91,83,91,85,90,86,89,87,87,32,77,78,77,87,78,89,32,73,77,78,77,78,87,79,90,80,91,32,87,77,87,91,92,91,32,88,78,88,90,32,84,77,89,77,89,91,32,74,77,76,78,32,75,77,76,79,32,89,89,90,91,32,89,90,91,91,0,73,91,76,77,82,91,32,77,77,82,89,32,78,77,83,89,32,88,78,83,89,82,91,32,74,77,81,77,32,84,77,90,77,32,75,77,78,79,32,80,77,78,78,32,86,77,88,78,32,89,77,88,78,0,70,94,74,77,78,91,32,75,77,78,88,32,76,77,79,88,32,82,77,79,88,78,91,32,82,77,86,91,32,83,77,86,88,32,82,77,84,77,87,88,32,90,78,87,88,86,91,32,71,77,79,77,32,87,77,93,77,32,72,77,75,78,32,78,77,76,78,32,88,77,90,78,32,92,77,90,78,0,72,92,76,77,86,91,32,77,77,87,91,32,78,77,88,91,32,87,78,77,90,32,74,77,81,77,32,84,77,90,77,32,74,91,80,91,32,83,91,90,91,32,75,77,77,78,32,80,77,78,78,32,85,77,87,78,32,89,77,87,78,32,77,90,75,91,32,77,90,79,91,32,86,90,84,91,32,87,90,89,91,0,72,91,76,77,82,91,32,77,77,82,89,32,78,77,83,89,32,88,78,83,89,80,95,78,97,76,98,74,98,73,97,73,95,75,95,75,97,74,97,74,96,32,74,77,81,77,32,84,77,90,77,32,75,77,78,79,32,80,77,78,78,32,86,77,88,78,32,89,77,88,78,0,73,91,86,77,76,91,32,87,77,77,91,32,88,77,78,91,32,88,77,76,77,76,81,32,76,91,88,91,88,87,32,77,77,76,81,32,78,77,76,80,32,79,77,76,79,32,81,77,76,78,32,83,91,88,90,32,85,91,88,89,32,86,91,88,88,32,87,91,88,87,0,71,94,91,77,90,81,89,84,87,88,85,90,82,91,80,91,77,90,75,88,74,85,74,83,75,80,77,78,80,77,82,77,85,78,86,79,87,81,89,88,90,90,91,91,92,91,32,90,77,89,81,88,84,87,86,85,89,84,90,82,91,32,76,88,75,86,75,82,76,80,32,80,91,78,90,77,89,76,86,76,82,77,79,78,78,80,77,32,82,77,84,78,85,79,86,81,88,88,89,90,91,91,0,71,92,81,70,78,71,77,72,76,74,75,78,75,98,32,78,72,77,74,76,78,76,97,32,81,70,79,71,78,73,77,78,77,98,32,81,70,83,70,86,71,87,72,88,74,88,76,87,78,86,79,83,80,32,80,80,84,80,87,81,88,82,89,84,89,87,88,89,87,90,84,91,81,91,79,90,78,89,77,87,32,86,72,87,74,87,76,86,78,32,87,82,88,84,88,87,87,89,32,83,70,85,71,86,73,86,77,85,79,83,80,32,84,80,86,81,87,83,87,88,86,90,84,91,32,75,98,77,98,0,70,92,72,82,73,78,75,77,77,77,79,78,80,79,81,82,82,89,83,98,32,73,79,75,78,77,78,79,79,80,80,32,72,82,73,80,75,79,77,79,79,80,80,81,81,84,82,89,82,97,32,88,77,87,80,86,82,84,85,83,87,82,91,81,98,32,89,77,87,81,32,90,77,89,79,87,82,84,86,83,88,82,91,32,88,77,90,77,32,81,98,83,98,0,72,92,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,80,76,78,75,77,74,77,72,78,71,80,70,83,70,87,72,32,77,80,76,83,76,85,77,88,32,87,88,88,85,88,83,87,80,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,79,75,78,74,78,73,79,72,81,71,84,71,87,72,0,73,91,83,77,85,78,86,79,87,79,86,78,83,77,81,77,77,78,76,79,76,81,77,82,81,83,32,83,83,81,83,77,84,75,86,75,88,77,90,80,91,83,91,86,90,88,88,87,88,86,90,32,78,78,77,79,77,81,78,82,32,77,85,76,86,76,88,77,89,32,81,77,79,78,78,79,78,81,79,82,81,83,32,81,83,78,84,77,86,77,88,78,90,80,91,0,73,91,81,72,82,71,82,70,81,70,80,71,80,73,81,74,84,75,88,75,89,75,89,74,88,74,85,75,83,76,80,78,78,80,77,82,76,85,76,87,77,89,78,90,80,91,83,92,85,93,86,95,86,97,85,98,83,98,82,97,82,96,83,96,83,97,32,80,79,79,80,78,82,77,85,77,87,78,89,79,90,32,85,75,82,77,81,78,79,81,78,84,78,87,79,89,81,91,83,92,0,71,93,74,77,75,78,76,80,76,91,32,75,77,76,78,77,80,77,90,32,72,80,73,78,74,77,76,77,77,78,78,80,78,91,32,85,77,86,78,87,81,87,98,32,87,79,88,82,88,97,32,78,81,79,79,80,78,82,77,85,77,87,78,88,79,89,82,89,98,32,76,91,78,91,32,87,98,89,98,0,70,93,73,77,74,78,75,80,75,84,76,87,77,89,78,90,81,91,83,91,86,90,87,89,88,87,89,82,89,79,88,74,86,71,84,70,82,70,80,71,79,73,79,75,80,77,83,79,86,80,91,81,32,74,77,75,78,76,80,76,84,77,87,78,89,32,86,89,87,87,88,82,88,79,87,74,86,72,84,71,32,71,80,72,78,73,77,75,77,76,78,77,80,77,84,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,74,85,72,83,71,81,71,79,73,0,75,90,78,77,79,78,80,80,80,88,81,90,83,91,85,91,87,90,88,88,32,79,77,80,78,81,80,81,88,82,90,32,76,80,77,78,78,77,80,77,81,78,82,80,82,88,83,90,84,91,0,71,93,74,77,75,78,76,80,76,91,32,75,77,76,78,77,80,77,90,32,72,80,73,78,74,77,76,77,77,78,78,80,78,91,32,83,79,85,78,87,78,88,79,88,80,90,80,90,78,88,77,86,77,84,78,81,81,79,84,78,87,32,88,78,89,79,89,80,32,80,83,81,83,87,89,89,89,90,88,32,84,87,87,90,89,90,32,82,84,85,90,86,91,88,91,89,90,90,88,32,76,91,78,91,0,72,92,74,71,75,70,77,70,79,71,81,73,88,88,89,90,90,91,32,79,72,80,73,87,88,88,89,32,77,70,78,71,79,73,86,88,88,90,90,91,91,91,32,82,77,74,90,74,91,75,91,82,77,0,71,93,75,77,75,98,32,76,78,76,97,32,77,77,77,98,32,86,77,86,88,87,90,88,91,90,91,91,90,92,88,32,87,78,87,88,88,90,89,91,32,88,77,88,88,89,90,90,91,32,77,88,78,90,80,91,82,91,84,90,85,89,86,87,32,75,77,77,77,32,86,77,88,77,32,75,98,77,98,0,71,93,74,77,75,78,76,80,77,84,78,91,32,75,77,76,78,77,80,78,84,79,90,32,72,80,73,78,74,77,76,77,77,78,78,80,79,84,80,90,32,86,86,87,84,88,81,88,77,89,77,90,78,89,81,88,83,86,86,84,88,81,90,78,91,32,88,82,89,79,89,77,0,74,90,80,71,83,70,82,70,80,71,79,72,79,73,80,74,83,75,86,76,87,75,86,74,83,75,80,76,78,77,77,79,77,81,78,82,80,83,83,84,86,85,87,84,86,83,83,84,79,85,77,86,76,88,76,90,77,91,79,92,83,93,85,94,86,95,86,97,84,98,82,98,79,97,80,97,82,98,32,79,77,78,79,78,81,79,82,32,78,86,77,88,77,90,78,91,32,86,75,83,75,81,76,80,77,79,79,79,81,81,83,83,84,32,86,84,83,84,80,85,79,86,78,88,78,90,80,92,83,93,0,71,93,73,81,74,79,75,78,77,77,91,77,32,75,79,77,78,90,78,32,73,81,74,80,76,79,91,79,32,79,79,78,90,77,91,76,90,77,87,79,79,32,85,79,86,90,87,91,88,90,87,87,85,79,32,91,77,91,79,32,79,79,77,90,32,85,79,87,90,0,71,92,81,77,78,78,76,80,75,84,75,98,32,77,80,76,84,76,97,32,81,77,79,78,78,79,77,83,77,98,32,77,87,78,89,79,90,81,91,83,91,86,90,88,88,89,85,89,83,88,80,86,78,83,77,81,77,32,87,88,88,86,88,82,87,80,32,83,91,85,90,86,89,87,86,87,82,86,79,85,78,83,77,32,75,98,77,98,0,71,93,80,77,77,78,75,80,74,83,74,85,75,88,77,90,80,91,82,91,85,90,87,88,88,85,88,83,87,80,85,78,82,77,32,76,80,75,82,75,86,76,88,32,86,88,87,86,87,82,86,80,32,80,77,78,78,77,79,76,82,76,86,77,89,78,90,80,91,32,82,91,84,90,85,89,86,86,86,82,85,79,84,78,82,77,32,82,77,90,79,91,78,91,77,80,77,32,82,77,90,78,0,72,92,74,81,75,79,76,78,78,77,90,77,32,76,79,78,78,89,78,32,74,81,75,80,77,79,90,79,32,82,79,81,90,82,91,83,90,82,79,32,90,77,90,79,32,82,79,82,90,0,71,92,74,77,75,78,76,80,76,85,77,88,79,90,81,91,83,91,85,90,87,88,88,86,89,82,89,78,88,77,87,77,88,80,88,83,87,87,85,90,32,75,77,76,78,77,80,77,85,78,88,32,87,77,88,78,88,79,32,72,80,73,78,74,77,76,77,77,78,78,80,78,86,79,89,81,91,0,71,93,82,81,81,78,80,77,78,77,76,78,75,79,74,82,74,85,75,88,77,90,80,91,84,91,87,90,89,88,90,85,90,82,89,79,88,78,86,77,84,77,83,78,82,81,32,76,79,75,82,75,85,76,88,32,88,88,89,85,89,82,88,79,32,78,77,77,78,76,81,76,86,77,89,78,90,80,91,32,84,91,86,90,87,89,88,86,88,81,87,78,86,77,32,82,81,81,98,32,82,81,82,97,32,82,81,83,98,32,81,98,83,98,0,72,92,76,77,77,78,78,80,84,95,86,97,88,98,90,98,91,97,32,78,79,79,80,85,95,86,96,32,73,78,74,77,76,77,78,78,80,80,86,95,87,97,88,98,32,86,83,88,80,89,77,90,77,89,79,86,83,78,92,75,96,74,98,75,98,76,95,78,92,0,70,93,72,78,73,78,74,80,74,85,75,88,77,90,80,91,84,91,86,90,88,88,89,86,90,82,90,78,89,77,88,77,89,80,89,83,88,87,86,90,32,74,78,75,80,75,85,76,88,32,88,77,89,78,89,79,32,71,80,72,78,73,77,74,77,75,78,76,80,76,86,77,89,78,90,80,91,32,81,70,83,98,32,82,71,82,97,32,83,70,81,98,32,81,70,83,70,32,81,98,83,98,0,70,94,78,77,76,78,74,80,73,83,73,87,74,89,75,90,77,91,79,91,81,90,82,89,83,87,83,84,82,83,81,84,81,87,82,89,83,90,85,91,87,91,89,90,90,89,91,87,91,83,90,80,88,78,86,77,32,75,80,74,83,74,87,75,89,32,82,84,82,88,32,89,89,90,87,90,83,89,80,32,78,77,76,79,75,82,75,87,76,90,77,91,32,87,91,88,90,89,87,89,82,88,79,86,77,0,71,93,87,77,85,84,85,88,86,90,87,91,89,91,91,89,92,87,32,88,77,86,84,86,90,32,87,77,89,77,87,84,86,88,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,78,78,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,0,73,92,80,70,78,77,77,83,77,87,78,89,79,90,81,91,83,91,86,90,88,87,89,84,89,82,88,79,87,78,85,77,83,77,81,78,80,79,79,81,78,84,32,81,70,79,77,78,81,78,87,79,90,32,86,89,87,87,88,84,88,81,87,79,32,77,70,82,70,80,77,78,84,32,83,91,85,89,86,87,87,84,87,81,86,78,85,77,32,78,70,81,71,32,79,70,80,72,0,73,91,87,81,87,80,86,80,86,82,88,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,86,77,89,78,90,80,91,82,91,85,90,87,87,32,79,79,78,81,77,84,77,87,78,89,32,82,77,80,79,79,81,78,84,78,87,79,90,80,91,0,71,93,89,70,86,81,85,85,85,88,86,90,87,91,89,91,91,89,92,87,32,90,70,87,81,86,85,86,90,32,86,70,91,70,87,84,86,88,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,77,79,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,32,87,70,90,71,32,88,70,89,72,0,73,91,77,86,81,85,84,84,87,82,88,80,87,78,85,77,82,77,79,78,77,81,76,84,76,86,77,89,78,90,80,91,82,91,85,90,87,88,32,79,79,78,81,77,84,77,87,78,89,32,82,77,80,79,79,81,78,84,78,87,79,90,80,91,0,74,90,90,72,90,71,89,71,89,73,91,73,91,71,90,70,88,70,86,71,84,73,83,75,82,78,81,82,79,91,78,94,77,96,75,98,32,84,74,83,77,82,82,80,91,79,94,32,88,70,86,72,85,74,84,77,83,82,81,90,80,93,79,95,77,97,75,98,73,98,72,97,72,95,74,95,74,97,73,97,73,96,32,78,77,89,77,0,72,93,88,77,84,91,83,94,81,97,79,98,32,89,77,85,91,83,95,32,88,77,90,77,86,91,84,95,82,97,79,98,76,98,74,97,73,96,73,94,75,94,75,96,74,96,74,95,32,86,84,86,81,85,78,83,77,81,77,78,78,76,81,75,84,75,86,76,89,77,90,79,91,81,91,83,90,84,89,85,87,86,84,32,78,79,77,81,76,84,76,87,77,89,32,81,77,79,79,78,81,77,84,77,87,78,90,79,91,0,71,93,79,70,73,91,75,91,32,80,70,74,91,32,76,70,81,70,75,91,32,77,84,79,80,81,78,83,77,85,77,87,78,88,80,88,83,86,88,32,87,78,87,82,86,86,86,90,32,87,80,85,85,85,88,86,90,87,91,89,91,91,89,92,87,32,77,70,80,71,32,78,70,79,72,0,75,88,84,70,84,72,86,72,86,70,84,70,32,85,70,85,72,32,84,71,86,71,32,76,81,77,79,79,77,81,77,82,78,83,80,83,83,81,88,32,82,78,82,82,81,86,81,90,32,82,80,80,85,80,88,81,90,82,91,84,91,86,89,87,87,0,75,88,85,70,85,72,87,72,87,70,85,70,32,86,70,86,72,32,85,71,87,71,32,77,81,78,79,80,77,82,77,83,78,84,80,84,83,82,90,81,93,80,95,78,97,76,98,74,98,73,97,73,95,75,95,75,97,74,97,74,96,32,83,78,83,83,81,90,80,93,79,95,32,83,80,82,84,80,91,79,94,78,96,76,98,0,71,93,79,70,73,91,75,91,32,80,70,74,91,32,76,70,81,70,75,91,32,89,79,89,78,88,78,88,80,90,80,90,78,89,77,87,77,85,78,81,82,79,83,32,77,83,79,83,81,84,82,85,84,89,85,90,87,90,32,81,85,83,89,84,90,32,79,83,80,84,82,90,83,91,85,91,87,90,89,87,32,77,70,80,71,32,78,70,79,72,0,76,88,84,70,81,81,80,85,80,88,81,90,82,91,84,91,86,89,87,87,32,85,70,82,81,81,85,81,90,32,81,70,86,70,82,84,81,88,32,82,70,85,71,32,83,70,84,72,0,64,99,65,81,66,79,68,77,70,77,71,78,72,80,72,83,70,91,32,71,78,71,83,69,91,32,71,80,70,84,68,91,70,91,32,72,83,74,80,76,78,78,77,80,77,82,78,83,80,83,83,81,91,32,82,78,82,83,80,91,32,82,80,81,84,79,91,81,91,32,83,83,85,80,87,78,89,77,91,77,93,78,94,80,94,83,92,88,32,93,78,93,82,92,86,92,90,32,93,80,91,85,91,88,92,90,93,91,95,91,97,89,98,87,0,70,94,71,81,72,79,74,77,76,77,77,78,78,80,78,83,76,91,32,77,78,77,83,75,91,32,77,80,76,84,74,91,76,91,32,78,83,80,80,82,78,84,77,86,77,88,78,89,80,89,83,87,88,32,88,78,88,82,87,86,87,90,32,88,80,86,85,86,88,87,90,88,91,90,91,92,89,93,87,0,72,92,81,77,78,78,76,81,75,84,75,86,76,89,77,90,80,91,83,91,86,90,88,87,89,84,89,82,88,79,87,78,84,77,81,77,32,78,79,77,81,76,84,76,87,77,89,32,86,89,87,87,88,84,88,81,87,79,32,81,77,79,79,78,81,77,84,77,87,78,90,80,91,32,83,91,85,89,86,87,87,84,87,81,86,78,84,77,0,71,93,72,81,73,79,75,77,77,77,78,78,79,80,79,83,78,87,75,98,32,78,78,78,83,77,87,74,98,32,78,80,77,84,73,98,32,79,84,80,81,81,79,82,78,84,77,86,77,88,78,89,79,90,82,90,84,89,87,87,90,84,91,82,91,80,90,79,87,79,84,32,88,79,89,81,89,84,88,87,87,89,32,86,77,87,78,88,81,88,84,87,87,86,89,84,91,32,70,98,78,98,32,74,97,71,98,32,74,96,72,98,32,75,96,76,98,32,74,97,77,98,0,71,92,87,77,81,98,32,88,77,82,98,32,87,77,89,77,83,98,32,85,84,85,81,84,78,82,77,80,77,77,78,75,81,74,84,74,86,75,89,76,90,78,91,80,91,82,90,83,89,84,87,85,84,32,77,79,76,81,75,84,75,87,76,89,32,80,77,78,79,77,81,76,84,76,87,77,90,78,91,32,78,98,86,98,32,82,97,79,98,32,82,96,80,98,32,83,96,84,98,32,82,97,85,98,0,73,91,74,81,75,79,77,77,79,77,80,78,81,80,81,84,79,91,32,80,78,80,84,78,91,32,80,80,79,84,77,91,79,91,32,89,79,89,78,88,78,88,80,90,80,90,78,89,77,87,77,85,78,83,80,81,84,0,74,91,88,80,88,79,87,79,87,81,89,81,89,79,88,78,85,77,82,77,79,78,78,79,78,81,79,83,81,84,84,85,86,86,87,88,32,79,78,78,81,32,79,82,81,83,84,84,86,85,32,87,86,86,90,32,78,79,79,81,81,82,84,83,86,84,87,86,87,88,86,90,83,91,80,91,77,90,76,89,76,87,78,87,78,89,77,89,77,88,0,75,89,84,70,81,81,80,85,80,88,81,90,82,91,84,91,86,89,87,87,32,85,70,82,81,81,85,81,90,32,84,70,86,70,82,84,81,88,32,78,77,88,77,0,70,94,71,81,72,79,74,77,76,77,77,78,78,80,78,83,76,88,32,77,78,77,82,76,86,76,90,32,77,80,75,85,75,88,76,90,78,91,80,91,82,90,84,88,86,85,32,88,77,86,85,86,88,87,90,88,91,90,91,92,89,93,87,32,89,77,87,85,87,90,32,88,77,90,77,88,84,87,88,0,72,92,73,81,74,79,76,77,78,77,79,78,80,80,80,83,78,88,32,79,78,79,82,78,86,78,90,32,79,80,77,85,77,88,78,90,80,91,82,91,84,90,86,88,88,85,89,81,89,77,88,77,88,78,89,80,0,67,97,68,81,69,79,71,77,73,77,74,78,75,80,75,83,73,88,32,74,78,74,82,73,86,73,90,32,74,80,72,85,72,88,73,90,75,91,77,91,79,90,81,88,82,85,32,84,77,82,85,82,88,83,90,85,91,87,91,89,90,91,88,93,85,94,81,94,77,93,77,93,78,94,80,32,85,77,83,85,83,90,32,84,77,86,77,84,84,83,88,0,71,93,74,81,76,78,78,77,80,77,82,78,83,80,83,82,32,80,77,81,78,81,82,80,86,79,88,77,90,75,91,73,91,72,90,72,88,74,88,74,90,73,90,73,89,32,82,79,82,82,81,86,81,89,32,90,79,90,78,89,78,89,80,91,80,91,78,90,77,88,77,86,78,84,80,83,82,82,86,82,90,83,91,32,80,86,80,88,81,90,83,91,85,91,87,90,89,87,0,71,93,72,81,73,79,75,77,77,77,78,78,79,80,79,83,77,88,32,78,78,78,82,77,86,77,90,32,78,80,76,85,76,88,77,90,79,91,81,91,83,90,85,88,87,84,32,89,77,85,91,84,94,82,97,80,98,32,90,77,86,91,84,95,32,89,77,91,77,87,91,85,95,83,97,80,98,77,98,75,97,74,96,74,94,76,94,76,96,75,96,75,95,0,72,92,89,77,88,79,86,81,78,87,76,89,75,91,32,88,79,79,79,77,80,76,82,32,86,79,82,78,79,78,78,79,32,86,79,82,77,79,77,77,79,76,82,32,76,89,85,89,87,88,88,86,32,78,89,82,90,85,90,86,89,32,78,89,82,91,85,91,87,89,88,86,0,72,92,87,81,86,79,85,78,83,77,81,77,78,78,76,80,75,83,75,85,76,88,78,90,81,91,83,91,86,90,87,89,88,87,89,83,89,78,88,74,87,72,86,71,83,70,81,70,78,71,77,72,78,72,79,71,81,70,32,77,80,76,82,76,86,77,88,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,77,79,78,78,79,77,82,77,86,78,89,79,90,81,91,32,83,91,85,90,86,88,87,84,87,77,86,73,85,71,83,70,0,73,91,85,77,87,78,88,79,89,79,88,78,85,77,82,77,79,78,77,80,76,83,76,85,77,88,79,90,82,91,85,91,88,90,89,89,88,89,87,90,85,91,32,78,80,77,83,77,85,78,88,32,82,77,80,78,79,79,78,82,78,86,79,89,80,90,82,91,32,78,84,84,85,85,84,84,83,78,84,32,78,84,84,84,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,78,72,77,74,76,78,76,83,77,87,78,89,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,70,79,71,78,73,77,78,77,83,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,73,85,71,83,70,32,76,80,88,81,32,76,81,88,80,0,71,93,80,77,77,78,75,80,74,83,74,85,75,88,77,90,80,91,84,91,87,90,89,88,90,85,90,83,89,80,87,78,84,77,80,77,32,76,80,75,83,75,85,76,88,32,88,88,89,85,89,83,88,80,32,80,77,78,78,77,79,76,82,76,86,77,89,78,90,80,91,84,91,86,90,87,89,88,86,88,82,87,79,86,78,84,77,32,81,70,83,98,32,82,71,82,97,32,83,70,81,98,32,81,70,83,70,32,81,98,83,98,0,72,92,84,77,86,78,88,80,89,80,89,79,87,78,84,77,80,77,77,78,76,79,75,81,75,83,76,85,78,87,80,88,82,89,83,90,84,92,84,94,83,95,81,95,79,94,80,94,81,95,32,77,79,76,81,76,83,77,85,79,87,32,80,77,78,78,77,80,77,83,78,85,82,89,32,89,80,88,79,0,72,92,81,70,78,71,76,74,75,79,75,82,76,87,78,90,81,91,83,91,86,90,88,87,89,82,89,79,88,74,86,71,83,70,81,70,32,78,72,77,74,76,78,76,83,77,87,78,89,32,86,89,87,87,88,83,88,78,87,74,86,72,32,81,70,79,71,78,73,77,78,77,83,78,88,79,90,81,91,32,83,91,85,90,86,88,87,83,87,78,86,73,85,71,83,70,0,72,92,81,72,81,91,32,82,72,82,90,32,83,70,83,91,32,83,70,80,73,78,74,32,77,91,87,91,32,81,90,79,91,32,81,89,80,91,32,83,89,84,91,32,83,90,85,91,0,72,92,76,74,76,75,77,75,77,74,76,74,32,76,73,77,73,78,74,78,75,77,76,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,85,80,80,82,78,83,76,85,75,88,75,91,32,87,72,88,74,88,76,87,78,32,84,70,86,71,87,74,87,76,86,78,84,80,80,82,32,75,89,76,88,78,88,83,89,87,89,89,88,32,78,88,83,90,87,90,88,89,32,78,88,83,91,87,91,88,90,89,88,89,86,0,72,92,76,74,76,75,77,75,77,74,76,74,32,76,73,77,73,78,74,78,75,77,76,76,76,75,75,75,74,76,72,77,71,80,70,84,70,87,71,88,73,88,76,87,78,84,79,32,86,71,87,73,87,76,86,78,32,83,70,85,71,86,73,86,76,85,78,83,79,32,81,79,84,79,86,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,86,76,85,77,85,78,86,78,87,77,88,76,88,32,87,82,88,84,88,87,87,89,32,83,79,85,80,86,81,87,84,87,87,86,90,84,91,32,76,86,76,87,77,87,77,86,76,86,0,72,92,83,73,83,91,32,84,72,84,90,32,85,70,85,91,32,85,70,74,85,90,85,32,80,91,88,91,32,83,90,81,91,32,83,89,82,91,32,85,89,86,91,32,85,90,87,91,0,72,92,77,70,75,80,77,78,80,77,83,77,86,78,88,80,89,83,89,85,88,88,86,90,83,91,80,91,77,90,76,89,75,87,75,86,76,85,77,85,78,86,78,87,77,88,76,88,32,87,80,88,82,88,86,87,88,32,83,77,85,78,86,79,87,82,87,86,86,89,85,90,83,91,32,76,86,76,87,77,87,77,86,76,86,32,77,70,87,70,32,77,71,85,71,32,77,72,81,72,85,71,87,70,0,72,92,86,73,86,74,87,74,87,73,86,73,32,87,72,86,72,85,73,85,74,86,75,87,75,88,74,88,73,87,71,85,70,82,70,79,71,77,73,76,75,75,79,75,85,76,88,78,90,81,91,83,91,86,90,88,88,89,85,89,84,88,81,86,79,83,78,81,78,79,79,78,80,77,82,32,78,73,77,75,76,79,76,85,77,88,78,89,32,87,88,88,86,88,83,87,81,32,82,70,80,71,79,72,78,74,77,78,77,85,78,88,79,90,81,91,32,83,91,85,90,86,89,87,86,87,83,86,80,85,79,83,78,0,72,92,75,70,75,76,32,89,70,89,73,88,76,84,81,83,83,82,87,82,91,32,83,82,82,84,81,87,81,91,32,88,76,83,81,81,84,80,87,80,91,82,91,32,75,74,76,72,78,70,80,70,85,73,87,73,88,72,89,70,32,77,72,78,71,80,71,82,72,32,75,74,76,73,78,72,80,72,85,73,0,72,92,80,70,77,71,76,73,76,76,77,78,80,79,84,79,87,78,88,76,88,73,87,71,84,70,80,70,32,78,71,77,73,77,76,78,78,32,86,78,87,76,87,73,86,71,32,80,70,79,71,78,73,78,76,79,78,80,79,32,84,79,85,78,86,76,86,73,85,71,84,70,32,80,79,77,80,76,81,75,83,75,87,76,89,77,90,80,91,84,91,87,90,88,89,89,87,89,83,88,81,87,80,84,79,32,77,81,76,83,76,87,77,89,32,87,89,88,87,88,83,87,81,32,80,79,78,80,77,83,77,87,78,90,80,91,32,84,91,86,90,87,87,87,83,86,80,84,79,0,72,92,77,87,77,88,78,88,78,87,77,87,32,87,79,86,81,85,82,83,83,81,83,78,82,76,80,75,77,75,76,76,73,78,71,81,70,83,70,86,71,88,73,89,76,89,82,88,86,87,88,85,90,82,91,79,91,77,90,76,88,76,87,77,86,78,86,79,87,79,88,78,89,77,89,32,77,80,76,78,76,75,77,73,32,86,72,87,73,88,76,88,82,87,86,86,88,32,81,83,79,82,78,81,77,78,77,75,78,72,79,71,81,70,32,83,70,85,71,86,73,87,76,87,83,86,87,85,89,84,90,82,91,0,77,88,82,70,81,71,81,73,82,81,32,82,70,82,84,83,84,32,82,70,83,70,83,84,32,83,70,84,71,84,73,83,81,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,73,92,77,75,77,74,78,74,78,76,76,76,76,74,77,72,78,71,80,70,84,70,87,71,88,72,89,74,89,76,88,78,87,79,83,81,32,87,72,88,73,88,77,87,78,32,84,70,86,71,87,73,87,77,86,79,85,80,32,82,81,82,84,83,84,83,81,82,81,32,82,88,81,89,81,90,82,91,83,91,84,90,84,89,83,88,82,88,32,82,89,82,90,83,90,83,89,82,89,0,69,95,91,79,91,78,90,78,90,80,92,80,92,78,91,77,90,77,89,78,88,80,86,85,84,88,82,90,80,91,76,91,74,90,73,88,73,85,74,83,80,79,82,77,83,75,83,73,82,71,80,70,78,71,77,73,77,76,78,79,80,82,84,87,87,90,89,91,91,91,92,89,92,88,32,75,90,74,88,74,85,75,83,76,82,32,82,77,83,73,32,83,75,82,71,32,78,71,77,75,32,78,78,80,81,84,86,87,89,89,90,32,78,91,76,90,75,88,75,85,76,83,80,79,32,77,73,78,77,81,81,85,86,88,89,90,90,91,90,92,89,0,72,92,80,66,80,95,32,84,66,84,95,32,88,75,88,74,87,74,87,76,89,76,89,74,88,72,87,71,84,70,80,70,77,71,75,73,75,76,76,78,79,80,85,82,87,83,88,85,88,88,87,90,32,76,76,77,78,79,79,85,81,87,82,88,84,32,77,71,76,73,76,75,77,77,79,78,85,80,88,82,89,84,89,87,88,89,87,90,84,91,80,91,77,90,76,89,75,87,75,85,77,85,77,87,76,87,76,86,0,75,89,85,66,83,68,81,71,79,75,78,80,78,84,79,89,81,93,83,96,85,98,32,81,72,80,75,79,79,79,85,80,89,81,92,32,83,68,82,70,81,73,80,79,80,85,81,91,82,94,83,96,0,75,89,79,66,81,68,83,71,85,75,86,80,86,84,85,89,83,93,81,96,79,98,32,83,72,84,75,85,79,85,85,84,89,83,92,32,81,68,82,70,83,73,84,79,84,85,83,91,82,94,81,96,0,70,94,91,70,89,71,86,72,83,72,80,71,78,70,76,70,74,71,73,73,73,75,75,77,77,77,79,76,80,74,80,72,78,70,32,91,70,72,91,32,91,70,73,91,32,91,70,74,91,32,89,84,87,84,85,85,84,87,84,89,86,91,88,91,90,90,91,88,91,86,89,84,32,79,71,76,70,73,73,74,76,77,77,80,74,79,71,32,78,70,74,71,73,75,32,75,77,79,76,80,72,32,90,85,87,84,84,87,85,90,88,91,91,88,90,85,32,89,84,85,85,84,89,32,86,91,90,90,91,86,32,72,91,74,91,0,69,96,86,78,85,76,83,75,81,75,79,76,78,77,77,79,77,82,78,84,79,85,81,86,83,86,85,85,86,83,32,79,77,78,79,78,82,79,84,32,81,75,80,76,79,79,79,82,80,85,81,86,32,86,75,86,83,87,85,89,86,90,86,92,85,93,82,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,88,89,87,90,32,87,76,87,83,88,85,32,86,75,88,75,88,83,89,85,90,86,0,72,93,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,81,91,84,90,86,88,88,85,89,82,90,78,90,75,89,72,88,71,86,70,84,70,32,81,72,79,74,78,76,77,79,76,83,76,87,77,89,32,84,89,86,87,87,85,88,82,89,78,89,74,88,72,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,79,91,32,81,91,83,90,85,87,86,85,87,82,88,78,88,73,87,71,86,70,0,72,93,84,74,79,91,81,91,32,87,70,85,74,80,91,32,87,70,81,91,32,87,70,84,73,81,75,79,76,32,84,74,82,75,79,76,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,87,79,77,85,75,87,73,91,32,88,71,89,73,89,75,88,77,86,79,83,81,32,86,70,87,71,88,73,88,75,87,77,85,79,77,85,32,74,89,75,88,77,88,82,89,87,89,88,88,32,77,88,82,90,87,90,32,77,88,82,91,85,91,87,90,88,88,88,87,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,86,70,89,71,90,73,90,75,89,77,88,78,86,79,83,80,32,88,71,89,73,89,75,88,77,87,78,32,86,70,87,71,88,73,88,75,87,77,85,79,83,80,32,81,80,83,80,86,81,87,82,88,84,88,87,87,89,85,90,82,91,79,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,32,86,82,87,84,87,87,86,89,32,83,80,85,81,86,83,86,87,85,89,84,90,82,91,0,72,93,87,74,82,91,84,91,32,90,70,88,74,83,91,32,90,70,84,91,32,90,70,74,85,90,85,0,72,93,81,70,76,80,32,81,70,91,70,32,81,71,89,71,32,80,72,85,72,89,71,91,70,32,76,80,77,79,80,78,83,78,86,79,87,80,88,82,88,85,87,88,85,90,81,91,78,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,32,86,80,87,82,87,85,86,88,84,90,32,83,78,85,79,86,81,86,85,85,88,83,90,81,91,0,72,93,89,74,89,73,88,73,88,75,90,75,90,73,89,71,87,70,84,70,81,71,79,73,77,76,76,79,75,83,75,86,76,89,77,90,79,91,82,91,85,90,87,88,88,86,88,83,87,81,86,80,84,79,81,79,79,80,78,81,77,83,32,80,73,78,76,77,79,76,83,76,87,77,89,32,86,88,87,86,87,83,86,81,32,84,70,82,71,80,74,79,76,78,79,77,83,77,88,78,90,79,91,32,82,91,84,90,85,89,86,86,86,82,85,80,84,79,0,72,93,78,70,76,76,32,91,70,90,73,88,76,84,81,82,84,81,87,80,91,32,82,83,80,87,79,91,32,88,76,82,82,80,85,79,87,78,91,80,91,32,77,73,80,70,82,70,87,73,32,79,71,82,71,87,73,32,77,73,79,72,82,72,87,73,89,73,90,72,91,70,0,72,93,83,70,80,71,79,72,78,74,78,77,79,79,81,80,84,80,87,79,89,78,90,76,90,73,89,71,87,70,83,70,32,85,70,80,71,32,80,72,79,74,79,78,80,79,32,79,79,82,80,32,83,80,87,79,32,88,78,89,76,89,73,88,71,32,89,71,85,70,32,83,70,81,72,80,74,80,78,81,80,32,84,80,86,79,87,78,88,76,88,72,87,70,32,81,80,77,81,75,83,74,85,74,88,75,90,78,91,82,91,86,90,87,89,88,87,88,84,87,82,86,81,84,80,32,82,80,77,81,32,78,81,76,83,75,85,75,88,76,90,32,75,90,80,91,86,90,32,86,89,87,87,87,84,86,82,32,86,81,83,80,32,81,80,79,81,77,83,76,85,76,88,77,90,78,91,32,82,91,84,90,85,89,86,87,86,83,85,81,84,80,0,72,93,88,78,87,80,86,81,84,82,81,82,79,81,78,80,77,78,77,75,78,73,80,71,83,70,86,70,88,71,89,72,90,75,90,78,89,82,88,85,86,88,84,90,81,91,78,91,76,90,75,88,75,86,77,86,77,88,76,88,76,87,32,79,80,78,78,78,75,79,73,32,88,72,89,74,89,78,88,82,87,85,85,88,32,81,82,80,81,79,79,79,75,80,72,81,71,83,70,32,86,70,87,71,88,73,88,78,87,82,86,85,85,87,83,90,81,91,0,77,88,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,81,91,80,91,79,90,79,89,80,88,81,88,82,89,82,91,81,93,80,94,78,95,32,80,89,80,90,81,90,81,89,80,89,32,81,91,81,92,80,94,0,77,88,83,77,82,78,82,79,83,80,84,80,85,79,85,78,84,77,83,77,32,83,78,83,79,84,79,84,78,83,78,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,83,77,82,78,82,79,83,80,84,80,85,79,85,78,84,77,83,77,32,83,78,83,79,84,79,84,78,83,78,32,81,91,80,91,79,90,79,89,80,88,81,88,82,89,82,91,81,93,80,94,78,95,32,80,89,80,90,81,90,81,89,80,89,32,81,91,81,92,80,94,0,77,88,86,70,85,70,84,71,82,84,32,86,71,85,71,82,84,32,86,71,86,72,82,84,32,86,70,87,71,87,72,82,84,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,72,93,79,75,79,74,80,74,80,76,78,76,78,74,79,72,80,71,83,70,87,70,90,71,91,73,91,75,90,77,89,78,87,79,83,80,81,81,81,83,83,84,84,84,32,85,70,90,71,32,89,71,90,73,90,75,89,77,88,78,86,79,32,87,70,88,71,89,73,89,75,88,77,87,78,83,80,82,81,82,83,83,84,32,80,88,79,89,79,90,80,91,81,91,82,90,82,89,81,88,80,88,32,80,89,80,90,81,90,81,89,80,89,0,77,88,87,70,85,71,84,72,83,74,83,76,84,77,85,77,86,76,86,75,85,74,84,74,32,85,71,84,73,84,74,32,84,75,84,76,85,76,85,75,84,75,0,77,88,86,73,85,73,84,72,84,71,85,70,86,70,87,71,87,73,86,75,85,76,83,77,32,85,71,85,72,86,72,86,71,85,71,32,86,73,86,74,85,76,0,69,95,92,79,92,78,91,78,91,80,93,80,93,78,92,77,91,77,89,78,87,80,82,88,80,90,78,91,75,91,72,90,71,88,71,86,72,84,73,83,75,82,80,80,82,79,84,77,85,75,85,73,84,71,82,70,80,71,79,73,79,76,80,82,81,85,82,87,84,90,86,91,88,91,89,89,89,88,32,76,91,72,90,32,73,90,72,88,72,86,73,84,74,83,76,82,32,80,80,81,83,84,89,86,90,32,75,91,74,90,73,88,73,86,74,84,75,83,77,82,82,79,32,79,76,80,79,81,82,83,86,85,89,87,90,88,90,89,89,0,72,93,84,66,76,95,32,89,66,81,95,32,90,75,90,74,89,74,89,76,91,76,91,74,90,72,89,71,86,70,82,70,79,71,77,73,77,76,78,78,80,80,86,83,87,85,87,88,86,90,32,78,76,79,78,86,82,87,84,32,79,71,78,73,78,75,79,77,85,80,87,82,88,84,88,87,87,89,86,90,83,91,79,91,76,90,75,89,74,87,74,85,76,85,76,87,75,87,75,86,0,71,94,95,66,69,98,70,98,32,95,66,96,66,70,98,0,74,90,90,66,88,67,85,69,82,72,80,75,78,79,77,83,77,88,78,92,79,95,81,98,32,83,72,81,75,79,79,78,84,78,92,32,90,66,87,68,84,71,82,74,81,76,80,79,79,83,78,92,32,78,84,79,93,80,96,81,98,0,74,90,83,66,85,69,86,72,87,76,87,81,86,85,84,89,82,92,79,95,76,97,74,98,32,86,72,86,80,85,85,83,89,81,92,32,83,66,84,68,85,71,86,80,32,86,72,85,81,84,85,83,88,82,90,80,93,77,96,74,98,0,74,91,84,70,83,71,85,81,84,82,32,84,70,84,82,32,84,70,85,71,83,81,84,82,32,79,73,80,73,88,79,89,79,32,79,73,89,79,32,79,73,79,74,89,78,89,79,32,89,73,88,73,80,79,79,79,32,89,73,79,79,32,89,73,89,74,79,78,79,79,0,77,87,85,70,84,71,82,77,32,85,71,82,77,32,85,70,86,71,82,77,0,72,92,80,70,79,71,77,77,32,80,71,77,77,32,80,70,81,71,77,77,32,90,70,89,71,87,77,32,90,71,87,77,32,90,70,91,71,87,77,0,75,90,83,70,81,71,80,73,80,75,81,77,83,78,85,78,87,77,88,75,88,73,87,71,85,70,83,70,32,83,70,80,73,81,77,85,78,88,75,87,71,83,70,32,85,70,81,71,80,75,83,78,87,77,88,73,85,70,0,71,94,83,70,75,98,76,98,32,83,70,84,70,76,98,32,89,70,81,98,82,98,32,89,70,90,70,82,98,32,75,80,92,80,92,81,32,75,80,75,81,92,81,32,73,87,90,87,90,88,32,73,87,73,88,90,88,0,69,94,94,70,92,71,88,72,85,72,81,71,79,70,77,70,75,71,74,73,74,75,76,77,78,77,80,76,81,74,81,72,79,70,32,94,70,69,91,32,94,70,70,91,32,94,70,71,91,32,88,84,86,84,84,85,83,87,83,89,85,91,87,91,89,90,90,88,90,86,88,84,32,80,71,77,70,74,73,75,76,78,77,81,74,80,71,32,79,70,75,71,74,75,32,76,77,80,76,81,72,32,89,85,86,84,83,87,84,90,87,91,90,88,89,85,32,88,84,84,85,83,89,32,85,91,89,90,90,86,32,69,91,71,91,0,69,96,85,81,85,78,84,76,82,75,80,75,78,76,77,77,76,80,76,83,77,85,79,86,81,86,83,85,84,84,85,81,32,79,76,78,77,77,80,77,83,78,85,32,82,75,80,76,79,77,78,80,78,83,79,85,80,86,32,86,75,85,81,85,83,86,85,88,86,90,86,92,85],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+337982);allocate([93,82,93,79,92,76,91,74,89,72,87,71,84,70,81,70,78,71,76,72,74,74,73,76,72,79,72,82,73,85,74,87,76,89,78,90,81,91,84,91,87,90,89,89,88,89,87,90,32,87,75,86,81,86,83,87,85,32,86,75,88,75,87,81,87,83,88,85,90,86,0,78,50,99,118,56,72,79,71,67,97,99,104,101,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,67,111,110,102,73,110,118,111,107,101,114,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,104,111,103,46,99,112,112,0,78,50,99,118,49,52,72,79,71,67,111,110,102,73,110,118,111,107,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,82,79,73,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,99,118,58,58,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,68,101,116,101,99,116,105,111,110,82,79,73,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,41,32,99,111,110,115,116,0,112,116,46,120,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,112,116,46,121,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,103,101,116,66,108,111,99,107,0,98,108,111,99,107,83,105,122,101,46,119,105,100,116,104,32,37,32,99,101,108,108,83,105,122,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,98,108,111,99,107,83,105,122,101,46,104,101,105,103,104,116,32,37,32,99,101,108,108,83,105,122,101,46,104,101,105,103,104,116,32,61,61,32,48,0,103,101,116,68,101,115,99,114,105,112,116,111,114,83,105,122,101,0,40,119,105,110,83,105,122,101,46,119,105,100,116,104,32,45,32,98,108,111,99,107,83,105,122,101,46,119,105,100,116,104,41,32,37,32,98,108,111,99,107,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,40,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,45,32,98,108,111,99,107,83,105,122,101,46,104,101,105,103,104,116,41,32,37,32,98,108,111,99,107,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,100,101,116,101,99,116,82,79,73,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,99,118,58,58,80,111,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,99,118,58,58,80,111,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,99,118,58,58,83,105,122,101,44,32,99,118,58,58,83,105,122,101,41,32,99,111,110,115,116,0,105,109,103,46,116,121,112,101,40,41,32,61,61,32,48,32,124,124,32,105,109,103,46,116,121,112,101,40,41,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,0,99,111,109,112,117,116,101,71,114,97,100,105,101,110,116,0,40,117,110,115,105,103,110,101,100,41,104,105,100,120,32,60,32,40,117,110,115,105,103,110,101,100,41,110,98,105,110,115,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,99,111,109,112,117,116,101,71,114,97,100,105,101,110,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,99,118,58,58,77,97,116,32,38,44,32,83,105,122,101,44,32,83,105,122,101,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,100,111,117,98,108,101,44,32,83,105,122,101,44,32,83,105,122,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,98,111,111,108,41,32,99,111,110,115,116,0,114,101,99,116,76,105,115,116,46,115,105,122,101,40,41,32,61,61,32,119,101,105,103,104,116,115,46,115,105,122,101,40,41,0,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,0,110,111,100,101,115,91,114,111,111,116,93,91,80,65,82,69,78,84,93,32,60,32,48,0,112,97,114,116,105,116,105,111,110,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,111,112,101,114,97,116,105,111,110,115,46,104,112,112,0,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,40,115,116,100,58,58,118,101,99,116,111,114,60,99,118,58,58,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,105,110,116,44,32,100,111,117,98,108,101,41,32,99,111,110,115,116,0,78,50,99,118,49,48,72,79,71,73,110,118,111,107,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,83,105,122,101,44,32,83,105,122,101,44,32,100,111,117,98,108,101,44,32,100,111,117,98,108,101,44,32,98,111,111,108,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,100,101,116,101,99,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,80,111,105,110,116,62,32,38,44,32,100,111,117,98,108,101,44,32,83,105,122,101,44,32,83,105,122,101,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,80,111,105,110,116,62,32,38,41,32,99,111,110,115,116,0,112,116,48,46,120,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,119,105,100,116,104,32,61,61,32,48,32,38,38,32,112,116,48,46,121,32,37,32,99,97,99,104,101,83,116,114,105,100,101,46,104,101,105,103,104,116,32,61,61,32,48,0,100,101,116,101,99,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,100,101,116,101,99,116,40,99,111,110,115,116,32,99,118,58,58,77,97,116,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,80,111,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,83,105,122,101,44,32,83,105,122,101,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,80,111,105,110,116,62,32,38,41,32,99,111,110,115,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,79,71,68,101,115,99,114,105,112,116,111,114,58,58,99,111,109,112,117,116,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,102,108,111,97,116,62,32,38,44,32,83,105,122,101,44,32,83,105,122,101,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,80,111,105,110,116,62,32,38,41,32,99,111,110,115,116,0,123,111,112,101,110,99,118,45,111,98,106,101,99,116,45,100,101,116,101,99,116,111,114,45,104,111,103,0,119,105,110,83,105,122,101,0,98,108,111,99,107,83,105,122,101,0,98,108,111,99,107,83,116,114,105,100,101,0,110,98,105,110,115,0,100,101,114,105,118,65,112,101,114,116,117,114,101,0,104,105,115,116,111,103,114,97,109,78,111,114,109,84,121,112,101,0,76,50,72,121,115,84,104,114,101,115,104,111,108,100,0,103,97,109,109,97,67,111,114,114,101,99,116,105,111,110,0,110,108,101,118,101,108,115,0,115,105,103,110,101,100,71,114,97,100,105,101,110,116,0,83,86,77,68,101,116,101,99,116,111,114,0,99,101,108,108,83,105,122,101,0,119,105,110,83,105,103,109,97,0,99,104,101,99,107,68,101,116,101,99,116,111,114,83,105,122,101,40,41,0,115,101,116,83,86,77,68,101,116,101,99,116,111,114,0,78,50,99,118,49,51,72,79,71,68,101,115,99,114,105,112,116,111,114,69,0,111,112,101,110,99,118,45,111,98,106,101,99,116,45,100,101,116,101,99,116,111,114,45,104,111,103,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,54,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,57,83,99,97,108,101,68,97,116,97,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,118,105,114,116,117,97,108,32,98,111,111,108,32,99,118,58,58,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,58,58,115,101,116,73,109,97,103,101,40,73,110,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,102,108,111,97,116,62,32,38,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,99,97,115,99,97,100,101,100,101,116,101,99,116,46,99,112,112,0,78,50,99,118,49,54,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,97,97,114,69,118,97,108,117,97,116,111,114,58,58,99,111,109,112,117,116,101,79,112,116,70,101,97,116,117,114,101,115,40,41,0,115,113,115,117,109,46,117,32,61,61,32,117,32,38,38,32,115,113,115,117,109,46,115,105,122,101,40,41,32,61,61,32,115,46,115,122,105,32,38,38,32,115,113,115,117,109,46,116,121,112,101,40,41,61,61,52,0,99,111,109,112,117,116,101,67,104,97,110,110,101,108,115,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,97,97,114,69,118,97,108,117,97,116,111,114,58,58,99,111,109,112,117,116,101,67,104,97,110,110,101,108,115,40,105,110,116,44,32,73,110,112,117,116,65,114,114,97,121,41,0,48,32,60,61,32,115,99,97,108,101,73,100,120,32,38,38,32,115,99,97,108,101,73,100,120,32,60,32,40,105,110,116,41,115,99,97,108,101,68,97,116,97,45,62,115,105,122,101,40,41,0,103,101,116,83,99,97,108,101,68,97,116,97,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,99,97,115,99,97,100,101,100,101,116,101,99,116,46,104,112,112,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,110,32,62,32,48,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,49,48,79,112,116,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,55,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,49,51,72,97,97,114,69,118,97,108,117,97,116,111,114,69,0,115,101,116,87,105,110,100,111,119,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,76,66,80,69,118,97,108,117,97,116,111,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,50,76,66,80,69,118,97,108,117,97,116,111,114,49,48,79,112,116,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,116,51,95,95,50,54,118,101,99,116,111,114,73,78,83,95,49,50,76,66,80,69,118,97,108,117,97,116,111,114,55,70,101,97,116,117,114,101,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,83,53,95,69,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,56,95,69,69,69,69,0,114,101,99,116,0,78,50,99,118,49,50,76,66,80,69,118,97,108,117,97,116,111,114,69,0,115,99,97,108,101,70,97,99,116,111,114,32,62,32,49,32,38,38,32,95,105,109,97,103,101,46,100,101,112,116,104,40,41,32,61,61,32,48,0,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,0,118,111,105,100,32,99,118,58,58,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,40,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,105,110,116,44,32,100,111,117,98,108,101,41,0,118,111,105,100,32,99,118,58,58,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,40,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,42,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,42,41,0,118,111,105,100,32,99,118,58,58,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,40,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,105,110,116,44,32,100,111,117,98,108,101,41,0,105,110,116,32,99,118,58,58,112,114,101,100,105,99,116,67,97,116,101,103,111,114,105,99,97,108,40,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,32,38,44,32,80,116,114,60,99,118,58,58,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,62,32,38,44,32,100,111,117,98,108,101,32,38,41,32,91,70,69,118,97,108,32,61,32,99,118,58,58,76,66,80,69,118,97,108,117,97,116,111,114,93,0,105,110,116,32,99,118,58,58,112,114,101,100,105,99,116,79,114,100,101,114,101,100,40,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,32,38,44,32,80,116,114,60,99,118,58,58,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,62,32,38,44,32,100,111,117,98,108,101,32,38,41,32,91,70,69,118,97,108,32,61,32,99,118,58,58,72,97,97,114,69,118,97,108,117,97,116,111,114,93,0,33,99,97,115,99,97,100,101,46,100,97,116,97,46,115,116,117,109,112,115,46,101,109,112,116,121,40,41,0,112,114,101,100,105,99,116,67,97,116,101,103,111,114,105,99,97,108,83,116,117,109,112,0,105,110,116,32,99,118,58,58,112,114,101,100,105,99,116,67,97,116,101,103,111,114,105,99,97,108,83,116,117,109,112,40,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,32,38,44,32,80,116,114,60,99,118,58,58,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,62,32,38,44,32,100,111,117,98,108,101,32,38,41,32,91,70,69,118,97,108,32,61,32,99,118,58,58,76,66,80,69,118,97,108,117,97,116,111,114,93,0,112,114,101,100,105,99,116,79,114,100,101,114,101,100,83,116,117,109,112,0,105,110,116,32,99,118,58,58,112,114,101,100,105,99,116,79,114,100,101,114,101,100,83,116,117,109,112,40,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,32,38,44,32,80,116,114,60,99,118,58,58,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,62,32,38,44,32,100,111,117,98,108,101,32,38,41,32,91,70,69,118,97,108,32,61,32,99,118,58,58,72,97,97,114,69,118,97,108,117,97,116,111,114,93,0,105,110,116,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,58,58,114,117,110,65,116,40,80,116,114,60,99,118,58,58,70,101,97,116,117,114,101,69,118,97,108,117,97,116,111,114,62,32,38,44,32,80,111,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,32,38,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,110,118,111,107,101,114,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,0,78,50,99,118,50,52,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,110,118,111,107,101,114,69,0,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,78,111,71,114,111,117,112,105,110,103,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,83,105,122,101,44,32,83,105,122,101,44,32,98,111,111,108,41,0,33,95,115,101,113,32,124,124,32,95,115,101,113,45,62,101,108,101,109,95,115,105,122,101,32,61,61,32,115,105,122,101,111,102,40,95,84,112,41,0,83,101,113,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,99,111,114,101,95,99,46,104,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,83,105,122,101,44,32,83,105,122,101,44,32,98,111,111,108,41,0,115,99,97,108,101,70,97,99,116,111,114,32,62,32,49,32,38,38,32,105,109,97,103,101,46,100,101,112,116,104,40,41,32,61,61,32,48,0,118,111,105,100,32,99,118,58,58,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,40,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,105,110,116,44,32,100,111,117,98,108,101,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,83,105,122,101,44,32,83,105,122,101,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,83,105,122,101,44,32,83,105,122,101,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,50,51,67,118,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,102,101,97,116,117,114,101,115,0,115,116,97,103,101,84,121,112,101,0,66,79,79,83,84,0,102,101,97,116,117,114,101,84,121,112,101,0,72,65,65,82,0,76,66,80,0,72,79,71,0,72,79,71,32,99,97,115,99,97,100,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,51,46,48,0,111,114,105,103,87,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,48,32,38,38,32,111,114,105,103,87,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,48,0,102,101,97,116,117,114,101,80,97,114,97,109,115,0,109,97,120,67,97,116,67,111,117,110,116,0,115,116,97,103,101,84,104,114,101,115,104,111,108,100,0,119,101,97,107,67,108,97,115,115,105,102,105,101,114,115,0,105,110,116,101,114,110,97,108,78,111,100,101,115,0,108,101,97,102,86,97,108,117,101,115,0,78,50,99,118,50,49,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,69,0,78,50,99,118,50,49,66,97,115,101,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,69,0,118,111,105,100,32,99,118,58,58,103,114,111,117,112,82,101,99,116,97,110,103,108,101,115,95,109,101,97,110,115,104,105,102,116,40,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,83,105,122,101,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,49,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,97,45,62,115,105,122,101,40,41,32,61,61,32,110,0,99,108,105,112,79,98,106,101,99,116,115,0,98,45,62,115,105,122,101,40,41,32,61,61,32,110,0,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,83,105,122,101,44,32,83,105,122,101,41,0,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,83,105,122,101,44,32,83,105,122,101,41,0,118,111,105,100,32,99,118,58,58,67,97,115,99,97,100,101,67,108,97,115,115,105,102,105,101,114,58,58,100,101,116,101,99,116,77,117,108,116,105,83,99,97,108,101,40,73,110,112,117,116,65,114,114,97,121,44,32,115,116,100,58,58,118,101,99,116,111,114,60,82,101,99,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,83,105,122,101,44,32,83,105,122,101,44,32,98,111,111,108,41,0,111,112,101,110,99,118,45,104,97,97,114,45,99,108,97,115,115,105,102,105,101,114,0,78,117,109,98,101,114,32,111,102,32,115,116,97,103,101,115,32,115,104,111,117,108,100,32,98,101,32,112,111,115,105,116,105,118,101,0,105,99,118,67,114,101,97,116,101,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,111,98,106,100,101,116,101,99,116,47,115,114,99,47,104,97,97,114,46,99,112,112,0,115,116,97,103,101,115,0,115,116,97,103,101,32,37,100,0,116,114,101,101,115,0,116,114,101,101,32,37,100,0,110,111,100,101,32,37,100,0,114,111,111,116,32,110,111,100,101,0,102,101,97,116,117,114,101,0,114,101,99,116,115,0,116,105,108,116,101,100,0,116,104,114,101,115,104,111,108,100,0,108,101,102,116,95,110,111,100,101,0,108,101,102,116,95,118,97,108,0,114,105,103,104,116,95,110,111,100,101,0,114,105,103,104,116,95,118,97,108,0,115,116,97,103,101,95,116,104,114,101,115,104,111,108,100,0,112,97,114,101,110,116,0,110,101,120,116,0,73,110,118,97,108,105,100,32,115,116,97,103,101,115,32,110,111,100,101,0,105,99,118,82,101,97,100,72,97,97,114,67,108,97,115,115,105,102,105,101,114,0,115,105,122,101,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,0,73,110,118,97,108,105,100,32,115,105,122,101,32,110,111,100,101,58,32,119,105,100,116,104,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,0,73,110,118,97,108,105,100,32,115,105,122,101,32,110,111,100,101,58,32,104,101,105,103,104,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,0,73,110,118,97,108,105,100,32,115,116,97,103,101,32,37,100,0,84,114,101,101,115,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,41,0,84,114,101,101,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,41,0,84,114,101,101,32,110,111,100,101,32,37,100,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,109,97,112,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,41,0,70,101,97,116,117,114,101,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,109,97,112,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,82,101,99,116,115,32,110,111,100,101,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,82,101,99,116,32,37,100,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,115,101,113,117,101,110,99,101,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,120,32,99,111,111,114,100,105,110,97,116,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,121,32,99,111,111,114,100,105,110,97,116,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,119,105,100,116,104,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,32,97,110,100,32,40,120,32,43,32,119,105,100,116,104,41,32,109,117,115,116,32,110,111,116,32,101,120,99,101,101,100,32,119,105,110,100,111,119,32,119,105,100,116,104,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,104,101,105,103,104,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,32,97,110,100,32,40,121,32,43,32,104,101,105,103,104,116,41,32,109,117,115,116,32,110,111,116,32,101,120,99,101,101,100,32,119,105,110,100,111,119,32,104,101,105,103,104,116,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,119,101,105,103,104,116,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,44,32,114,101,99,116,32,37,100,41,0,116,105,108,116,101,100,32,109,117,115,116,32,98,101,32,48,32,111,114,32,49,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,116,104,114,101,115,104,111,108,100,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,108,101,102,116,32,110,111,100,101,32,109,117,115,116,32,98,101,32,118,97,108,105,100,32,110,111,100,101,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,108,101,102,116,32,110,111,100,101,32,111,114,32,108,101,102,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,108,101,102,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,84,114,101,101,32,115,116,114,117,99,116,117,114,101,32,105,115,32,98,114,111,107,101,110,58,32,116,111,111,32,109,97,110,121,32,118,97,108,117,101,115,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,114,105,103,104,116,32,110,111,100,101,32,109,117,115,116,32,98,101,32,118,97,108,105,100,32,110,111,100,101,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,114,105,103,104,116,32,110,111,100,101,32,111,114,32,114,105,103,104,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,115,112,101,99,105,102,105,101,100,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,114,105,103,104,116,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,44,32,110,111,100,101,32,37,100,41,0,84,114,101,101,32,115,116,114,117,99,116,117,114,101,32,105,115,32,98,114,111,107,101,110,58,32,116,111,111,32,102,101,119,32,118,97,108,117,101,115,46,32,40,115,116,97,103,101,32,37,100,44,32,116,114,101,101,32,37,100,41,0,115,116,97,103,101,32,116,104,114,101,115,104,111,108,100,32,109,117,115,116,32,98,101,32,114,101,97,108,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,41,0,112,97,114,101,110,116,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,41,0,110,101,120,116,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,110,117,109,98,101,114,46,32,40,115,116,97,103,101,32,37,100,41,0,73,110,118,97,108,105,100,32,99,108,97,115,115,105,102,105,101,114,32,112,111,105,110,116,101,114,0,99,118,83,101,116,73,109,97,103,101,115,70,111,114,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,83,99,97,108,101,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,0,67,79,73,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,108,108,32,105,110,116,101,103,114,97,108,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,0,79,110,108,121,32,40,51,50,115,44,32,54,52,102,44,32,51,50,115,41,32,99,111,109,98,105,110,97,116,105,111,110,32,111,102,32,40,115,117,109,44,115,113,115,117,109,44,116,105,108,116,101,100,95,115,117,109,41,32,102,111,114,109,97,116,115,32,105,115,32,97,108,108,111,119,101,100,0,83,117,109,32,97,110,100,32,116,105,108,116,101,100,95,115,117,109,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,116,114,105,100,101,32,40,115,116,101,112,44,32,119,105,100,116,104,83,116,101,112,41,0,105,99,118,67,114,101,97,116,101,72,105,100,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,104,105,100,95,99,97,115,99,97,100,101,32,104,97,115,32,98,101,101,110,32,97,108,114,101,97,100,121,32,99,114,101,97,116,101,100,0,78,101,103,97,116,105,118,101,32,110,117,109,98,101,114,32,111,102,32,99,97,115,99,97,100,101,32,115,116,97,103,101,115,0,104,101,97,100,101,114,32,111,102,32,116,104,101,32,115,116,97,103,101,32,99,108,97,115,115,105,102,105,101,114,32,35,37,100,32,105,115,32,105,110,118,97,108,105,100,32,40,104,97,115,32,110,117,108,108,32,112,111,105,110,116,101,114,115,32,111,114,32,110,111,110,45,112,111,115,105,116,105,118,101,32,99,108,97,115,115,102,105,101,114,32,99,111,117,110,116,41,0,114,101,99,116,97,110,103,108,101,32,35,37,100,32,111,102,32,116,104,101,32,99,108,97,115,115,105,102,105,101,114,32,35,37,100,32,111,102,32,116,104,101,32,115,116,97,103,101,32,99,108,97,115,115,105,102,105,101,114,32,35,37,100,32,105,115,32,110,111,116,32,105,110,115,105,100,101,32,116,104,101,32,114,101,102,101,114,101,110,99,101,32,40,111,114,105,103,105,110,97,108,41,32,99,97,115,99,97,100,101,32,119,105,110,100,111,119,0,73,110,118,97,108,105,100,32,99,97,115,99,97,100,101,32,112,111,105,110,116,101,114,0,99,118,82,117,110,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,83,117,109,0,72,105,100,100,101,110,32,99,97,115,99,97,100,101,32,104,97,115,32,110,111,116,32,98,101,101,110,32,99,114,101,97,116,101,100,46,10,85,115,101,32,99,118,83,101,116,73,109,97,103,101,115,70,111,114,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,0,105,110,116,32,99,118,82,117,110,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,40,99,111,110,115,116,32,67,118,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,32,42,44,32,67,118,80,111,105,110,116,44,32,105,110,116,41,0,73,110,118,97,108,105,100,32,99,108,97,115,115,105,102,105,101,114,32,99,97,115,99,97,100,101,0,99,118,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,70,111,114,82,79,67,0,78,117,108,108,32,115,116,111,114,97,103,101,32,112,111,105,110,116,101,114,0,79,110,108,121,32,56,45,98,105,116,32,105,109,97,103,101,115,32,97,114,101,32,115,117,112,112,111,114,116,101,100,0,115,99,97,108,101,32,102,97,99,116,111,114,32,109,117,115,116,32,98,101,32,62,32,49,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,95,83,99,97,108,101,67,97,115,99,97,100,101,95,73,110,118,111,107,101,114,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,0,78,50,99,118,51,56,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,95,83,99,97,108,101,67,97,115,99,97,100,101,95,73,110,118,111,107,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,95,83,99,97,108,101,73,109,97,103,101,95,73,110,118,111,107,101,114,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,0,78,50,99,118,51,54,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,95,83,99,97,108,101,73,109,97,103,101,95,73,110,118,111,107,101,114,69,0,67,118,83,101,113,32,42,99,118,72,97,97,114,68,101,116,101,99,116,79,98,106,101,99,116,115,70,111,114,82,79,67,40,99,111,110,115,116,32,67,118,65,114,114,32,42,44,32,67,118,72,97,97,114,67,108,97,115,115,105,102,105,101,114,67,97,115,99,97,100,101,32,42,44,32,67,118,77,101,109,83,116,111,114,97,103,101,32,42,44,32,115,116,100,58,58,118,101,99,116,111,114,60,105,110,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,100,111,117,98,108,101,62,32,38,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,67,118,83,105,122,101,44,32,67,118,83,105,122,101,44,32,98,111,111,108,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,112,114,101,118,48,46,115,105,122,101],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+348222);allocate([40,41,32,61,61,32,110,101,120,116,48,46,115,105,122,101,40,41,32,38,38,32,112,114,101,118,48,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,110,101,120,116,48,46,99,104,97,110,110,101,108,115,40,41,32,38,38,32,112,114,101,118,48,46,99,104,97,110,110,101,108,115,40,41,32,61,61,32,49,32,38,38,32,112,121,114,83,99,97,108,101,95,32,60,32,49,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,111,112,116,102,108,111,119,103,102,46,99,112,112,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,70,97,114,110,101,98,97,99,107,80,111,108,121,69,120,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,58,58,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,58,58,99,97,108,99,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,41,0,78,50,99,118,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,52,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,0,78,50,99,118,50,48,70,97,114,110,101,98,97,99,107,79,112,116,105,99,97,108,70,108,111,119,69,0,78,50,99,118,49,54,68,101,110,115,101,79,112,116,105,99,97,108,70,108,111,119,69,0,118,111,105,100,32,99,118,58,58,99,97,108,99,79,112,116,105,99,97,108,70,108,111,119,70,97,114,110,101,98,97,99,107,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,100,111,117,98,108,101,44,32,105,110,116,41,0,99,110,32,61,61,32,49,0,109,101,97,110,83,104,105,102,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,99,97,109,115,104,105,102,116,46,99,112,112,0,73,110,112,117,116,32,119,105,110,100,111,119,32,104,97,115,32,110,111,110,45,112,111,115,105,116,105,118,101,32,115,105,122,101,115,0,105,110,116,32,99,118,58,58,109,101,97,110,83,104,105,102,116,40,73,110,112,117,116,65,114,114,97,121,44,32,82,101,99,116,32,38,44,32,99,118,58,58,84,101,114,109,67,114,105,116,101,114,105,97,41,0,99,118,58,58,82,111,116,97,116,101,100,82,101,99,116,32,99,118,58,58,67,97,109,83,104,105,102,116,40,73,110,112,117,116,65,114,114,97,121,44,32,82,101,99,116,32,38,44,32,99,118,58,58,84,101,114,109,67,114,105,116,101,114,105,97,41,0,115,116,97,116,117,115,32,33,61,32,48,76,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,108,107,112,121,114,97,109,105,100,46,99,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,101,116,97,105,108,58,58,76,75,84,114,97,99,107,101,114,73,110,118,111,107,101,114,58,58,111,112,101,114,97,116,111,114,40,41,40,99,111,110,115,116,32,99,118,58,58,82,97,110,103,101,32,38,41,32,99,111,110,115,116,0,78,50,99,118,54,100,101,116,97,105,108,49,54,76,75,84,114,97,99,107,101,114,73,110,118,111,107,101,114,69,0,105,109,103,46,100,101,112,116,104,40,41,32,61,61,32,48,32,38,38,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,50,32,38,38,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,50,0,98,117,105,108,100,79,112,116,105,99,97,108,70,108,111,119,80,121,114,97,109,105,100,0,100,101,112,116,104,32,61,61,32,48,0,99,97,108,99,83,104,97,114,114,68,101,114,105,118,0,105,110,116,32,99,118,58,58,98,117,105,108,100,79,112,116,105,99,97,108,70,108,111,119,80,121,114,97,109,105,100,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,83,105,122,101,44,32,105,110,116,44,32,98,111,111,108,44,32,105,110,116,44,32,105,110,116,44,32,98,111,111,108,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,54,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,109,97,120,76,101,118,101,108,32,62,61,32,48,32,38,38,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,62,32,50,32,38,38,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,62,32,50,0,99,97,108,99,0,40,110,112,111,105,110,116,115,32,61,32,112,114,101,118,80,116,115,77,97,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,53,44,32,116,114,117,101,41,41,32,62,61,32,48,0,110,101,120,116,80,116,115,77,97,116,46,99,104,101,99,107,86,101,99,116,111,114,40,50,44,32,53,44,32,116,114,117,101,41,32,61,61,32,110,112,111,105,110,116,115,0,115,116,97,116,117,115,77,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,101,114,114,77,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,108,101,118,101,108,115,49,32,62,61,32,48,0,111,102,115,46,120,32,62,61,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,62,61,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,38,38,32,111,102,115,46,120,32,43,32,112,114,101,118,80,121,114,91,108,118,108,83,116,101,112,49,93,46,99,111,108,115,32,43,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,60,61,32,102,117,108,108,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,43,32,112,114,101,118,80,121,114,91,108,118,108,83,116,101,112,49,93,46,114,111,119,115,32,43,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,60,61,32,102,117,108,108,83,105,122,101,46,104,101,105,103,104,116,0,108,101,118,101,108,115,50,32,62,61,32,48,0,111,102,115,46,120,32,62,61,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,62,61,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,38,38,32,111,102,115,46,120,32,43,32,110,101,120,116,80,121,114,91,108,118,108,83,116,101,112,50,93,46,99,111,108,115,32,43,32,119,105,110,83,105,122,101,46,119,105,100,116,104,32,60,61,32,102,117,108,108,83,105,122,101,46,119,105,100,116,104,32,38,38,32,111,102,115,46,121,32,43,32,110,101,120,116,80,121,114,91,108,118,108,83,116,101,112,50,93,46,114,111,119,115,32,43,32,119,105,110,83,105,122,101,46,104,101,105,103,104,116,32,60,61,32,102,117,108,108,83,105,122,101,46,104,101,105,103,104,116,0,112,114,101,118,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,49,93,46,115,105,122,101,40,41,32,61,61,32,110,101,120,116,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,50,93,46,115,105,122,101,40,41,0,112,114,101,118,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,49,93,46,116,121,112,101,40,41,32,61,61,32,110,101,120,116,80,121,114,91,108,101,118,101,108,32,42,32,108,118,108,83,116,101,112,50,93,46,116,121,112,101,40,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,58,58,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,58,58,99,97,108,99,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,41,0,78,50,99,118,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,54,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,73,109,112,108,69,0,78,50,99,118,50,50,83,112,97,114,115,101,80,121,114,76,75,79,112,116,105,99,97,108,70,108,111,119,69,0,78,50,99,118,49,55,83,112,97,114,115,101,79,112,116,105,99,97,108,70,108,111,119,69,0,66,111,116,104,32,105,110,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,115,105,122,101,0,101,115,116,105,109,97,116,101,82,105,103,105,100,84,114,97,110,115,102,111,114,109,0,99,110,32,61,61,32,49,32,124,124,32,99,110,32,61,61,32,51,32,124,124,32,99,110,32,61,61,32,52,0,66,111,116,104,32,105,110,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,101,105,116,104,101,114,32,56,117,67,49,32,111,114,32,56,117,67,51,32,116,121,112,101,0,77,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,103,101,116,82,84,77,97,116,114,105,120,0,99,118,58,58,77,97,116,32,99,118,58,58,101,115,116,105,109,97,116,101,82,105,103,105,100,84,114,97,110,115,102,111,114,109,40,73,110,112,117,116,65,114,114,97,121,44,32,73,110,112,117,116,65,114,114,97,121,44,32,98,111,111,108,41,0,33,115,114,99,46,101,109,112,116,121,40,41,0,102,105,110,100,84,114,97,110,115,102,111,114,109,69,67,67,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,101,99,99,46,99,112,112,0,33,100,115,116,46,101,109,112,116,121,40,41,0,66,111,116,104,32,105,110,112,117,116,32,105,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,116,104,101,32,115,97,109,101,32,100,97,116,97,32,116,121,112,101,0,73,109,97,103,101,115,32,109,117,115,116,32,104,97,118,101,32,56,117,67,49,32,111,114,32,51,50,102,67,49,32,116,121,112,101,0,119,97,114,112,77,97,116,114,105,120,32,109,117,115,116,32,98,101,32,115,105,110,103,108,101,45,99,104,97,110,110,101,108,32,102,108,111,97,116,105,110,103,45,112,111,105,110,116,32,109,97,116,114,105,120,0,109,97,112,46,99,111,108,115,32,61,61,32,51,0,109,97,112,46,114,111,119,115,32,61,61,32,50,32,124,124,32,109,97,112,46,114,111,119,115,32,61,61,51,0,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,65,70,70,73,78,69,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,0,109,97,112,46,114,111,119,115,32,61,61,51,0,99,114,105,116,101,114,105,97,46,116,121,112,101,32,38,32,84,101,114,109,67,114,105,116,101,114,105,97,58,58,67,79,85,78,84,32,124,124,32,99,114,105,116,101,114,105,97,46,116,121,112,101,32,38,32,84,101,114,109,67,114,105,116,101,114,105,97,58,58,69,80,83,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,50,46,115,105,122,101,40,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,97,102,102,105,110,101,95,69,67,67,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,51,46,115,105,122,101,40,41,0,115,114,99,49,46,115,105,122,101,40,41,32,61,61,32,115,114,99,52,46,115,105,122,101,40,41,0,115,114,99,49,46,114,111,119,115,32,61,61,32,100,115,116,46,114,111,119,115,0,100,115,116,46,99,111,108,115,32,61,61,32,40,54,42,115,114,99,49,46,99,111,108,115,41,0,100,115,116,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,104,111,109,111,95,69,67,67,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,56,41,0,115,114,99,53,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,50,46,115,105,122,101,40,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,116,114,97,110,115,108,97,116,105,111,110,95,69,67,67,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,50,41,0,105,109,97,103,101,95,106,97,99,111,98,105,97,110,95,101,117,99,108,105,100,101,97,110,95,69,67,67,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,51,46,115,105,122,101,40,41,0,115,114,99,49,46,115,105,122,101,40,41,61,61,115,114,99,52,46,115,105,122,101,40,41,0,100,115,116,46,99,111,108,115,32,61,61,32,40,115,114,99,49,46,99,111,108,115,42,51,41,0,78,97,78,32,101,110,99,111,117,110,116,101,114,101,100,46,0,84,104,101,32,97,108,103,111,114,105,116,104,109,32,115,116,111,112,112,101,100,32,98,101,102,111,114,101,32,105,116,115,32,99,111,110,118,101,114,103,101,110,99,101,46,32,84,104,101,32,99,111,114,114,101,108,97,116,105,111,110,32,105,115,32,103,111,105,110,103,32,116,111,32,98,101,32,109,105,110,105,109,105,122,101,100,46,32,73,109,97,103,101,115,32,109,97,121,32,98,101,32,117,110,99,111,114,114,101,108,97,116,101,100,32,111,114,32,110,111,110,45,111,118,101,114,108,97,112,112,101,100,0,109,97,112,95,109,97,116,114,105,120,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,117,112,100,97,116,101,95,119,97,114,112,105,110,103,95,109,97,116,114,105,120,95,69,67,67,0,117,112,100,97,116,101,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,84,82,65,78,83,76,65,84,73,79,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,69,85,67,76,73,68,69,65,78,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,65,70,70,73,78,69,32,124,124,32,109,111,116,105,111,110,84,121,112,101,32,61,61,32,77,79,84,73,79,78,95,72,79,77,79,71,82,65,80,72,89,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,51,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,56,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,54,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,51,0,109,97,112,95,109,97,116,114,105,120,46,114,111,119,115,32,61,61,32,50,32,38,38,32,117,112,100,97,116,101,46,114,111,119,115,32,61,61,32,50,0,117,112,100,97,116,101,46,99,111,108,115,32,61,61,32,49,0,109,97,112,95,109,97,116,114,105,120,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,117,112,100,97,116,101,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,49,46,114,111,119,115,32,61,61,32,115,114,99,50,46,114,111,119,115,0,112,114,111,106,101,99,116,95,111,110,116,111,95,106,97,99,111,98,105,97,110,95,69,67,67,0,40,115,114,99,49,46,99,111,108,115,32,37,32,115,114,99,50,46,99,111,108,115,41,32,61,61,32,48,0,100,115,116,46,99,111,108,115,32,61,61,32,100,115,116,46,114,111,119,115,0,102,114,97,109,101,84,121,112,101,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,102,114,97,109,101,84,121,112,101,32,61,61,32,40,40,40,48,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,102,114,97,109,101,84,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,32,124,124,32,102,114,97,109,101,84,121,112,101,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,51,41,45,49,41,32,60,60,32,51,41,41,0,103,101,116,66,97,99,107,103,114,111,117,110,100,73,109,97,103,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,118,105,100,101,111,47,115,114,99,47,98,103,102,103,95,103,97,117,115,115,109,105,120,50,46,99,112,112,0,118,111,105,100,32,99,118,58,58,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,58,58,103,101,116,66,97,99,107,103,114,111,117,110,100,73,109,97,103,101,95,105,110,116,101,114,110,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,32,91,84,32,61,32,102,108,111,97,116,44,32,67,78,32,61,32,51,93,0,118,111,105,100,32,99,118,58,58,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,58,58,103,101,116,66,97,99,107,103,114,111,117,110,100,73,109,97,103,101,95,105,110,116,101,114,110,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,32,91,84,32,61,32,102,108,111,97,116,44,32,67,78,32,61,32,49,93,0,118,111,105,100,32,99,118,58,58,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,58,58,103,101,116,66,97,99,107,103,114,111,117,110,100,73,109,97,103,101,95,105,110,116,101,114,110,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,32,91,84,32,61,32,117,110,115,105,103,110,101,100,32,99,104,97,114,44,32,67,78,32,61,32,51,93,0,118,111,105,100,32,99,118,58,58,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,58,58,103,101,116,66,97,99,107,103,114,111,117,110,100,73,109,97,103,101,95,105,110,116,101,114,110,40,79,117,116,112,117,116,65,114,114,97,121,41,32,99,111,110,115,116,32,91,84,32,61,32,117,110,115,105,103,110,101,100,32,99,104,97,114,44,32,67,78,32,61,32,49,93,0,108,101,97,114,110,105,110,103,82,97,116,101,32,62,61,32,48,0,78,50,99,118,49,49,77,79,71,50,73,110,118,111,107,101,114,69,0,110,99,104,97,110,110,101,108,115,32,60,61,32,53,49,50,0,105,110,105,116,105,97,108,105,122,101,0,110,109,105,120,116,117,114,101,115,32,60,61,32,50,53,53,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,58,58,97,112,112,108,121,40,73,110,112,117,116,65,114,114,97,121,44,32,79,117,116,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,41,0,40,83,116,114,105,110,103,41,102,110,91,34,110,97,109,101,34,93,32,61,61,32,110,97,109,101,95,0,114,101,97,100,0,104,105,115,116,111,114,121,0,110,109,105,120,116,117,114,101,115,0,98,97,99,107,103,114,111,117,110,100,82,97,116,105,111,0,118,97,114,84,104,114,101,115,104,111,108,100,0,118,97,114,84,104,114,101,115,104,111,108,100,71,101,110,0,118,97,114,73,110,105,116,0,118,97,114,77,105,110,0,118,97,114,77,97,120,0,99,111,109,112,108,101,120,105,116,121,82,101,100,117,99,116,105,111,110,84,104,114,101,115,104,111,108,100,0,100,101,116,101,99,116,83,104,97,100,111,119,115,0,115,104,97,100,111,119,86,97,108,117,101,0,115,104,97,100,111,119,84,104,114,101,115,104,111,108,100,0,78,111,32,101,108,101,109,101,110,116,32,110,97,109,101,32,104,97,115,32,98,101,101,110,32,103,105,118,101,110,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,112,101,114,115,105,115,116,101,110,99,101,46,104,112,112,0,78,50,99,118,50,56,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,50,56,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,77,79,71,50,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,50,95,69,69,69,69,0,66,97,99,107,103,114,111,117,110,100,83,117,98,116,114,97,99,116,111,114,46,77,79,71,50,0,95,37,100,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,100,97,114,107,110,101,116,47,100,97,114,107,110,101,116,95,105,109,112,111,114,116,101,114,46,99,112,112,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,58,58,68,97,114,107,110,101,116,73,109,112,111,114,116,101,114,58,58,112,111,112,117,108,97,116,101,78,101,116,40,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,41,0,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,58,58,68,97,114,107,110,101,116,73,109,112,111,114,116,101,114,58,58,68,97,114,107,110,101,116,73,109,112,111,114,116,101,114,40,99,111,110,115,116,32,99,104,97,114,32,42,44,32,99,111,110,115,116,32,99,104,97,114,32,42,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,100,110,110,46,99,112,112,0,72,97,108,105,100,101,32,112,105,112,101,108,105,110,101,32,111,102,32,0,32,108,97,121,101,114,115,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,46,0,105,110,105,116,72,97,108,105,100,101,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,53,76,97,121,101,114,69,0,105,109,97,103,101,48,46,100,105,109,115,32,61,61,32,50,0,98,108,111,98,70,114,111,109,73,109,97,103,101,115,0,105,109,97,103,101,46,100,101,112,116,104,40,41,32,61,61,32,53,0,105,109,97,103,101,46,100,105,109,115,32,61,61,32,50,32,38,38,32,40,110,99,104,32,61,61,32,51,32,124,124,32,110,99,104,32,61,61,32,52,41,0,105,109,97,103,101,46,115,105,122,101,40,41,32,61,61,32,105,109,97,103,101,48,46,115,105,122,101,40,41,0,105,109,97,103,101,46,100,105,109,115,32,61,61,32,50,32,38,38,32,40,110,99,104,32,61,61,32,49,41,0,99,118,58,58,77,97,116,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,98,108,111,98,70,114,111,109,73,109,97,103,101,115,40,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,100,111,117,98,108,101,44,32,83,105,122,101,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,98,111,111,108,44,32,98,111,111,108,41,0,99,118,58,58,77,97,116,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,98,108,111,98,70,114,111,109,73,109,97,103,101,40,73,110,112,117,116,65,114,114,97,121,44,32,100,111,117,98,108,101,44,32,99,111,110,115,116,32,83,105,122,101,32,38,44,32,99,111,110,115,116,32,83,99,97,108,97,114,32,38,44,32,98,111,111,108,44,32,98,111,111,108,41,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,51,78,101,116,52,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,95,105,110,112,117,116,0,95,95,78,101,116,73,110,112,117,116,76,97,121,101,114,95,95,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,57,68,97,116,97,76,97,121,101,114,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,52,95,69,69,69,69,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,114,101,113,117,105,114,101,100,79,117,116,112,117,116,115,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,57,68,97,116,97,76,97,121,101,114,69,0,65,100,100,101,100,32,108,97,121,101,114,32,110,97,109,101,32,34,0,34,32,109,117,115,116,32,110,111,116,32,99,111,110,116,97,105,110,32,100,111,116,32,115,121,109,98,111,108,0,97,100,100,76,97,121,101,114,0,76,97,121,101,114,32,34,0,34,32,97,108,114,101,97,100,121,32,105,110,116,111,32,110,101,116,0,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,68,97,116,97,58,58,76,97,121,101,114,68,97,116,97,40,105,110,116,44,32,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,44,32,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,44,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,80,97,114,97,109,115,32,38,41,0,105,110,116,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,97,100,100,76,97,121,101,114,40,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,44,32,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,44,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,80,97,114,97,109,115,32,38,41,0,111,117,116,76,97,121,101,114,73,100,32,60,32,105,110,76,97,121,101,114,73,100,0,73,110,112,117,116,32,35,0,111,102,32,108,97,121,101,114,32,34,0,34,32,97,108,114,101,97,100,121,32,119,97,115,32,99,111,110,110,101,99,116,101,100,0,97,100,100,76,97,121,101,114,73,110,112,117,116,0,76,97,121,101,114,32,119,105,116,104,32,114,101,113,117,101,115,116,101,100,32,105,100,61,37,100,32,110,111,116,32,102,111,117,110,100,0,103,101,116,76,97,121,101,114,68,97,116,97,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,99,111,110,110,101,99,116,40,105,110,116,44,32,105,110,116,44,32,105,110,116,44,32,105,110,116,41,0,67,97,110,39,116,32,99,114,101,97,116,101,32,108,97,121,101,114,32,34,0,34,32,111,102,32,116,121,112,101,32,34,0,103,101,116,76,97,121,101,114,73,110,115,116,97,110,99,101,0,116,121,112,101,0,115,116,97,116,105,99,32,80,116,114,60,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,62,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,70,97,99,116,111,114,121,58,58,99,114,101,97,116,101,76,97,121,101,114,73,110,115,116,97,110,99,101,40,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,44,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,80,97,114,97,109,115,32,38,41,0,80,116,114,60,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,62,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,68,97,116,97,58,58,103,101,116,76,97,121,101,114,73,110,115,116,97,110,99,101,40,41,0,82,101,113,117,101,115,116,101,100,32,98,108,111,98,32,110,111,116,32,102,111,117,110,100,0,103,101,116,66,108,111,98,0,34,32,112,114,111,100,117,99,101,32,111,110,108,121,32,0,32,111,117,116,112,117,116,115,44,32,116,104,101,32,35,0,32,119,97,115,32,114,101,113,117,115,116,101,100,0,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,67,80,85,32,124,124,32,112,114,101,102,101,114,97,98,108,101,84,97,114,103,101,116,32,61,61,32,68,78,78,95,84,65,82,71,69,84,95,79,80,69,78,67,76,0,99,118,58,58,77,97,116,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,73,109,112,108,58,58,103,101,116,66,108,111,98,40,99,111,110,115,116,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,80,105,110,32,38,41,0,85,110,107,110,111,119,110,32,98,97,99,107,101,110,100,32,105,100,101,110,116,105,102,105,101,114,0,102,111,114,119,97,114,100,76,97,121,101,114,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,73,109,112,108,58,58,102,111,114,119,97,114,100,76,97,121,101,114,40,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,68,97,116,97,32,38,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,73,109,112,108,58,58,102,111,114,119,97,114,100,84,111,76,97,121,101,114,40,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,68,97,116,97,32,38,44,32,98,111,111,108,41,0,82,101,113,117,115,116,101,100,32,108,97,121,101,114,32,34,0,34,32,110,111,116,32,102,111,117,110,100,0,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,32,33,61,32,68,78,78,95,66,65,67,75,69,78,68,95,72,65,76,73,68,69,0,115,101,116,85,112,78,101,116,0,105,110,105,116,66,97,99,107,101,110,100,0,33,108,100,66,111,116,46,98,97,99,107,101,110,100,78,111,100,101,115,91,112,114,101,102,101,114,97,98,108,101,66,97,99,107,101,110,100,93,46,101,109,112,116,121,40,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,73,109,112,108,58,58,105,110,105,116,66,97,99,107,101,110,100,40,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,73,109,112,108,58,58,99,111,109,112,117,116,101,78,101,116,79,117,116,112,117,116,76,97,121,101,114,115,40,41,0,33,108,97,121,101,114,115,91,48,93,46,111,117,116,112,117,116,66,108,111,98,115,46,101,109,112,116,121,40,41,0,97,108,108,111,99,97,116,101,76,97,121,101,114,115,0,108,97,121,101,114,115,91,48,93,46,111,117,116,112,117,116,66,108,111,98,115,91,105,93,46,116,111,116,97,108,40,41,0,102,105,114,115,116,67,111,110,118,76,97,121,101,114,68,97,116,97,45,62,117,109,97,116,95,111,117,116,112,117,116,66,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,49,32,38,38,32,108,100,46,117,109,97,116,95,105,110,112,117,116,66,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,49,0,102,117,115,101,76,97,121,101,114,115,0,111,117,116,112,117,116,95,115,108,105,99,101,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,111,117,116,112,117,116,95,115,108,105,99,101,46,115,105,122,101,32,61,61,32,99,117,114,114,95,111,117,116,112,117,116,46,115,105,122,101,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,49,67,111,110,99,97,116,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,50,80,111,111,108,105,110,103,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,54,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,50,48,66,97,115,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,50,69,108,116,119,105,115,101,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,53,65,99,116,105,118,97,116,105,111,110,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,48,83,99,97,108,101,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,52,66,97,116,99,104,78,111,114,109,76,97,121,101,114,69,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,73,109,112,108,58,58,102,117,115,101,76,97,121,101,114,115,40,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,76,97,121,101,114,80,105,110,62,32,38,41,0,102,114,111,109,46,118,97,108,105,100,40,41,0,97,108,108,111,99,97,116,101,76,97,121,101,114,0,108,97,121,101,114,83,104,97,112,101,115,73,116,32,33,61,32,108,97,121,101,114,115,83,104,97,112,101,115,46,101,110,100,40,41,0,108,100,46,114,101,113,117,105,114,101,100,79,117,116,112,117,116,115,46,115,105,122,101,40,41,32,60,61,32,111,117,116,83,104,97,112,101,115,46,115,105,122,101,40,41,0,97,108,108,111,99,97,116,101,66,108,111,98,115,70,111,114,76,97,121,101,114,0,108,100,46,117,109,97,116,95,105,110,112,117,116,66,108,111,98,115,91,48,93,46,116,111,116,97,108,40,41,32,61,61,32,116,111,116,97,108,40,115,104,97,112,101,115,91,105,110,100,101,120,93,41,0,108,100,46,105,110,112,117,116,66,108,111,98,115,91,48,93,45,62,116,111,116,97,108,40,41,32,61,61,32,116,111,116,97,108,40,115,104,97,112,101,115,91,105,110,100,101,120,93,41,0,109,97,112,73,116,32,33,61,32,114,101,117,115,101,77,97,112,46,101,110,100,40,41,0,114,101,108,101,97,115,101,82,101,102,101,114,101,110,99,101,0,114,101,102,73,116,32,33,61,32,114,101,102,67,111,117,110,116,101,114,46,101,110,100,40,41,0,114,101,102,73,116,45,62,115,101,99,111,110,100,32,62,32,48,0,104,97,118,101,72,97,108,105,100,101,40,41,0,119,114,97,112,0,119,114,97,112,77,97,116,0,109,101,109,72,111,115,116,115,46,102,105,110,100,40,108,112,41,32,61,61,32,109,101,109,72,111,115,116,115,46,101,110,100,40,41,0,97,100,100,72,111,115,116,0,117,109,97,116,95,109,101,109,72,111,115,116,115,46,102,105,110,100,40,108,112,41,32,61,61,32,117,109,97,116,95,109,101,109,72,111,115,116,115,46,101,110,100,40,41,0,114,101,117,115,101,77,97,112,46,102,105,110,100,40,117,115,101,114,41,32,61,61,32,114,101,117,115,101,77,97,112,46,101,110,100,40,41,0,114,101,117,115,101,0,114,101,117,115,101,77,97,112,46,102,105,110,100,40,104,111,115,116,41,32,33,61,32,114,101,117,115,101,77,97,112,46,101,110,100,40,41,0,110,117,109,82,101,102,101,114,101,110,99,101,115,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,66,108,111,98,77,97,110,97,103,101,114,58,58,97,108,108,111,99,97,116,101,66,108,111,98,115,70,111,114,76,97,121,101,114,40,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,68,97,116,97,32,38,44,32,99,111,110,115,116,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,58,58,76,97,121,101,114,83,104,97,112,101,115,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,76,97,121,101,114,80,105,110,62,32,38,44,32,98,111,111,108,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,73,109,112,108,58,58,97,108,108,111,99,97,116,101,76,97,121,101,114,40,105,110,116,44,32,99,111,110,115,116,32,76,97,121,101,114,115,83,104,97,112,101,115,77,97,112,32,38,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,66,108,111,98,77,97,110,97,103,101,114,58,58,114,101,115,101,116,40,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,73,109,112,108,58,58,97,108,108,111,99,97,116,101,76,97,121,101,114,115,40,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,76,97,121,101,114,80,105,110,62,32,38,41,0,105,116,32,33,61,32,108,97,121,101,114,115,46,101,110,100,40,41,0,99,108,101,97,114,0,118,111,105,100,32,99,118],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+358462);allocate([58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,73,109,112,108,58,58,99,108,101,97,114,40,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,73,109,112,108,58,58,115,101,116,85,112,78,101,116,40,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,76,97,121,101,114,80,105,110,62,32,38,41,0,99,118,58,58,77,97,116,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,102,111,114,119,97,114,100,40,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,73,109,112,108,58,58,103,101,116,66,108,111,98,40,99,118,58,58,85,77,97,116,32,38,44,32,99,111,110,115,116,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,80,105,110,32,38,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,102,111,114,119,97,114,100,40,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,102,111,114,119,97,114,100,40,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,83,116,114,105,110,103,62,32,38,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,115,101,116,73,110,112,117,116,115,78,97,109,101,115,40,99,111,110,115,116,32,115,116,100,58,58,118,101,99,116,111,114,60,83,116,114,105,110,103,62,32,38,41,0,82,101,113,117,101,115,116,101,100,32,98,108,111,98,32,34,0,115,101,116,73,110,112,117,116,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,58,58,115,101,116,73,110,112,117,116,40,73,110,112,117,116,65,114,114,97,121,44,32,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,41,0,105,115,83,116,114,105,110,103,40,41,0,40,105,100,120,32,61,61,32,45,49,32,38,38,32,112,115,45,62,115,105,122,101,40,41,32,61,61,32,49,41,32,124,124,32,40,105,100,120,32,62,61,32,48,32,38,38,32,105,100,120,32,60,32,40,105,110,116,41,112,115,45,62,115,105,122,101,40,41,41,0,102,114,97,99,112,97,114,116,32,61,61,32,48,46,48,0,105,115,73,110,116,40,41,32,124,124,32,105,115,82,101,97,108,40,41,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,58,58,102,111,114,119,97,114,100,95,102,97,108,108,98,97,99,107,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,34,32,97,108,114,101,97,100,121,32,119,97,115,32,114,101,103,105,115,116,101,114,101,100,0,114,101,103,105,115,116,101,114,76,97,121,101,114,0,115,116,97,116,105,99,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,76,97,121,101,114,70,97,99,116,111,114,121,58,58,114,101,103,105,115,116,101,114,76,97,121,101,114,40,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,44,32,67,111,110,115,116,117,99,116,111,114,41,0,67,111,110,118,50,68,0,83,112,97,99,101,84,111,66,97,116,99,104,78,68,0,68,101,112,116,104,119,105,115,101,67,111,110,118,50,100,78,97,116,105,118,101,0,108,97,121,101,114,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,51,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,101,110,115,111,114,102,108,111,119,47,116,102,95,105,109,112,111,114,116,101,114,46,99,112,112,0,100,105,108,97,116,105,111,110,46,115,105,122,101,40,41,32,61,61,32,50,32,38,38,32,100,105,108,97,116,105,111,110,46,103,101,116,60,105,110,116,62,40,48,41,32,61,61,32,100,105,108,97,116,105,111,110,46,103,101,116,60,105,110,116,62,40,49,41,0,115,105,122,101,32,61,61,32,40,105,110,116,41,100,115,116,66,108,111,98,46,116,111,116,97,108,40,41,0,112,97,114,115,101,84,101,110,115,111,114,0,100,115,116,95,105,32,60,32,116,111,116,97,108,0,115,114,99,95,105,32,60,32,116,111,116,97,108,0,110,101,120,116,95,108,97,121,101,114,115,46,115,105,122,101,40,41,32,61,61,32,49,0,66,105,97,115,65,100,100,0,66,97,116,99,104,84,111,83,112,97,99,101,78,68,0,100,97,116,97,95,102,111,114,109,97,116,0,78,72,87,67,0,78,67,72,87,0,85,110,107,110,111,119,110,32,100,97,116,97,95,102,111,114,109,97,116,32,118,97,108,117,101,58,32,0,65,100,100,0,33,104,97,118,101,67,111,110,115,116,32,124,124,32,108,97,121,101,114,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,0,73,110,112,117,116,32,108,97,121,101,114,32,110,111,116,32,102,111,117,110,100,58,32,0,77,97,116,77,117,108,0,108,97,121,101,114,46,105,110,112,117,116,95,115,105,122,101,40,41,32,61,61,32,50,0,47,110,99,104,119,0,108,97,121,101,114,95,105,100,46,102,105,110,100,40,112,101,114,109,78,97,109,101,41,32,61,61,32,108,97,121,101,114,95,105,100,46,101,110,100,40,41,0,84,114,97,110,115,112,111,115,101,0,112,101,114,109,46,116,121,112,101,40,41,32,61,61,32,40,40,40,52,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,79,110,108,121,32,78,72,87,67,32,60,45,62,32,78,67,72,87,32,112,101,114,109,117,116,97,116,105,111,110,115,32,97,114,101,32,97,108,108,111,119,101,100,46,0,67,111,110,115,116,0,100,101,112,116,104,95,114,97,100,105,117,115,0,67,111,110,99,97,116,86,50,0,77,97,120,80,111,111,108,0,65,118,103,80,111,111,108,0,80,108,97,99,101,104,111,108,100,101,114,0,98,101,103,105,110,115,46,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,73,78,84,51,50,0,115,105,122,101,115,46,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,73,78,84,51,50,0,33,98,101,103,105,110,115,68,97,116,97,46,101,109,112,116,121,40,41,0,33,115,105,122,101,115,68,97,116,97,46,101,109,112,116,121,40,41,0,98,101,103,105,110,115,68,97,116,97,46,115,105,122,101,40,41,32,61,61,32,115,105,122,101,115,68,97,116,97,46,115,105,122,101,40,41,0,77,117,108,0,115,99,97,108,101,77,97,116,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,80,97,100,0,112,97,100,100,105,110,103,115,46,116,121,112,101,40,41,32,61,61,32,40,40,40,52,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,70,117,115,101,100,66,97,116,99,104,78,111,114,109,0,69,120,112,101,99,116,101,100,32,103,97,109,109,97,44,32,98,101,116,97,44,32,109,101,97,110,32,97,110,100,32,115,116,100,0,101,112,115,105,108,111,110,0,67,111,110,118,50,68,66,97,99,107,112,114,111,112,73,110,112,117,116,0,69,120,112,101,99,116,101,100,32,111,117,116,112,117,116,32,115,104,97,112,101,44,32,119,101,105,103,104,116,115,32,97,110,100,32,105,110,112,117,116,32,110,111,100,101,115,0,66,108,111,99,107,76,83,84,77,0,85,110,101,120,112,101,99,116,101,100,32,110,117,109,98,101,114,32,111,102,32,105,110,112,117,116,32,110,111,100,101,115,0,111,117,116,83,105,122,101,46,116,121,112,101,40,41,32,61,61,32,40,40,40,52,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,111,117,116,83,105,122,101,46,116,111,116,97,108,40,41,32,61,61,32,50,0,80,114,105,111,114,66,111,120,0,65,98,115,0,82,101,108,117,0,69,108,117,0,82,101,108,117,54,0,100,116,121,112,101,0,84,0,116,114,97,110,115,112,111,115,101,95,97,0,116,114,97,110,115,112,111,115,101,95,98,0,115,116,114,105,100,101,115,0,107,115,105,122,101,0,32,41,0,91,32,0,32,46,46,46,32,0,32,109,111,114,101,0,84,101,110,115,111,114,32,116,121,112,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,112,114,105,110,116,84,101,110,115,111,114,0,85,110,107,110,111,119,110,32,108,97,121,101,114,32,116,121,112,101,32,37,115,32,105,110,32,111,112,32,37,115,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,51,77,97,112,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,50,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,49,48,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,69,56,73,110,110,101,114,77,97,112,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,52,104,97,115,104,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,50,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,104,97,115,104,95,109,97,112,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,50,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,80,78,83,48,95,55,77,97,112,80,97,105,114,73,83,56,95,78,49,48,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,69,69,78,83,48,95,52,104,97,115,104,73,83,56,95,69,69,78,83,50,95,56,101,113,117,97,108,95,116,111,73,83,56,95,69,69,78,83,48,95,51,77,97,112,73,83,56,95,83,66,95,69,49,50,77,97,112,65,108,108,111,99,97,116,111,114,73,78,83,50,95,52,112,97,105,114,73,75,83,56,95,83,68,95,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,51,117,110,111,114,100,101,114,101,100,95,109,97,112,73,78,83,95,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,80,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,55,77,97,112,80,97,105,114,73,83,54,95,78,49,48,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,69,69,78,83,56,95,52,104,97,115,104,73,83,54,95,69,69,78,83,95,56,101,113,117,97,108,95,116,111,73,83,54,95,69,69,78,83,56,95,51,77,97,112,73,83,54,95,83,66,95,69,49,50,77,97,112,65,108,108,111,99,97,116,111,114,73,78,83,95,52,112,97,105,114,73,75,83,54,95,83,68,95,69,69,69,69,69,69,0,85,110,115,117,112,112,111,114,116,101,100,32,107,115,105,122,101,0,115,101,116,75,83,105,122,101,0,109,97,112,58,58,97,116,58,32,32,107,101,121,32,110,111,116,32,102,111,117,110,100,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,105,116,32,33,61,32,101,110,100,40,41,58,32,0,99,111,110,110,101,99,116,0,85,110,115,117,112,112,111,114,116,101,100,32,115,116,114,105,100,101,115,0,115,101,116,83,116,114,105,100,101,115,0,116,101,110,115,111,114,46,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,70,76,79,65,84,32,124,124,32,116,101,110,115,111,114,46,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,72,65,76,70,0,107,101,114,110,101,108,70,114,111,109,84,101,110,115,111,114,0,100,105,109,115,32,61,61,32,52,0,84,101,110,115,111,114,39,115,32,100,97,116,97,32,116,121,112,101,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,98,108,111,98,70,114,111,109,84,101,110,115,111,114,0,33,102,105,101,108,100,46,101,109,112,116,121,40,41,0,103,101,116,84,101,110,115,111,114,67,111,110,116,101,110,116,0,33,99,111,110,116,101,110,116,46,101,109,112,116,121,40,41,0,85,110,107,110,111,119,110,32,115,104,97,112,101,32,111,102,32,105,110,112,117,116,32,116,101,110,115,111,114,0,98,108,111,98,83,104,97,112,101,70,114,111,109,84,101,110,115,111,114,0,116,101,110,115,111,114,46,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,73,78,84,51,50,0,112,97,114,115,101,68,105,109,115,0,100,105,109,115,32,61,61,32,49,0,118,97,108,117,101,115,46,116,121,112,101,40,41,32,61,61,32,40,40,40,52,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,77,111,114,101,32,116,104,97,110,32,111,110,101,32,105,110,112,117,116,32,105,115,32,67,111,110,115,116,32,111,112,0,103,101,116,67,111,110,115,116,66,108,111,98,0,67,111,110,115,116,32,105,110,112,117,116,32,98,108,111,98,32,102,111,114,32,119,101,105,103,104,116,115,32,110,111,116,32,102,111,117,110,100,0,67,111,110,115,116,32,107,101,114,110,101,108,32,105,110,112,117,116,32,110,111,116,32,102,111,117,110,100,0,85,110,115,117,112,112,111,114,116,101,100,32,107,101,114,110,101,108,32,105,110,112,117,116,0,110,111,100,101,73,100,120,32,60,32,110,101,116,84,120,116,46,110,111,100,101,95,115,105,122,101,40,41,0,110,101,116,84,120,116,46,110,111,100,101,40,110,111,100,101,73,100,120,41,46,110,97,109,101,40,41,32,61,61,32,107,101,114,110,101,108,95,105,110,112,46,110,97,109,101,0,68,101,113,117,97,110,116,105,122,101,0,97,100,100,67,111,110,115,116,78,111,100,101,115,0,99,111,110,115,116,95,108,97,121,101,114,115,46,102,105,110,100,40,108,97,121,101,114,46,105,110,112,117,116,40,105,41,41,32,33,61,32,99,111,110,115,116,95,108,97,121,101,114,115,46,101,110,100,40,41,0,77,73,78,95,70,73,82,83,84,0,104,97,115,76,97,121,101,114,65,116,116,114,40,108,97,121,101,114,44,32,34,109,111,100,101,34,41,32,38,38,32,103,101,116,76,97,121,101,114,65,116,116,114,40,108,97,121,101,114,44,32,34,109,111,100,101,34,41,46,115,40,41,32,61,61,32,34,77,73,78,95,70,73,82,83,84,34,0,116,101,110,115,111,114,45,62,100,116,121,112,101,40,41,32,61,61,32,116,101,110,115,111,114,102,108,111,119,58,58,68,84,95,81,85,73,78,84,56,0,113,77,105,110,46,116,111,116,97,108,40,41,32,61,61,32,49,0,113,77,105,110,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,113,77,97,120,46,116,111,116,97,108,40,41,32,61,61,32,49,0,113,77,97,120,46,116,121,112,101,40,41,32,61,61,32,40,40,40,53,41,32,38,32,40,40,49,32,60,60,32,51,41,32,45,32,49,41,41,32,43,32,40,40,40,49,41,45,49,41,32,60,60,32,51,41,41,0,114,97,110,103,101,83,99,97,108,101,32,62,61,32,48,0,99,111,110,115,116,95,108,97,121,101,114,115,46,105,110,115,101,114,116,40,115,116,100,58,58,109,97,107,101,95,112,97,105,114,40,110,97,109,101,44,32,108,105,41,41,46,115,101,99,111,110,100,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,101,110,115,111,114,102,108,111,119,47,116,102,95,105,111,46,99,112,112,0,82,101,97,100,84,70,78,101,116,80,97,114,97,109,115,70,114,111,109,66,105,110,97,114,121,70,105,108,101,79,114,68,105,101,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,71,114,97,112,104,68,101,102,32,102,105,108,101,58,32,0,78,83,116,51,95,95,50,49,56,98,97,115,105,99,95,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,82,101,97,100,84,70,78,101,116,80,97,114,97,109,115,70,114,111,109,84,101,120,116,70,105,108,101,79,114,68,105,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,111,114,99,104,47,116,111,114,99,104,95,105,109,112,111,114,116,101,114,46,99,112,112,0,85,110,115,117,112,112,111,114,116,101,100,32,76,117,97,32,116,121,112,101,0,114,101,97,100,79,98,106,101,99,116,0,84,101,110,115,111,114,0,116,111,114,99,104,46,0,83,116,111,114,97,103,101,0,116,111,114,99,104,95,105,110,100,101,120,0,83,101,113,117,101,110,116,105,97,108,0,80,97,114,97,108,108,101,108,0,67,111,110,99,97,116,84,97,98,108,101,0,74,111,105,110,84,97,98,108,101,0,68,101,112,116,104,67,111,110,99,97,116,0,73,110,99,101,112,116,105,111,110,0,105,110,112,117,116,68,105,109,101,110,115,105,111,110,0,111,117,116,112,117,116,68,105,109,101,110,115,105,111,110,0,100,105,109,101,110,115,105,111,110,0,83,112,97,116,105,97,108,67,111,110,118,111,108,117,116,105,111,110,0,83,112,97,116,105,97,108,67,111,110,118,111,108,117,116,105,111,110,77,77,0,119,101,105,103,104,116,0,116,101,110,115,111,114,80,97,114,97,109,115,46,99,111,117,110,116,40,34,119,101,105,103,104,116,34,41,0,114,101,97,100,84,111,114,99,104,79,98,106,101,99,116,0,110,79,117,116,112,117,116,80,108,97,110,101,0,108,97,121,101,114,80,97,114,97,109,115,46,98,108,111,98,115,91,48,93,46,100,105,109,115,32,61,61,32,50,0,83,112,97,116,105,97,108,76,80,80,111,111,108,105,110,103,0,83,112,97,116,105,97,108,77,97,120,80,111,111,108,105,110,103,0,83,112,97,116,105,97,108,65,118,101,114,97,103,101,80,111,111,108,105,110,103,0,77,65,88,0,105,110,100,105,99,101,115,95,98,108,111,98,95,105,100,0,105,110,100,105,99,101,115,0,65,86,69,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,99,101,105,108,95,109,111,100,101,34,41,0,76,105,110,101,97,114,0,86,105,101,119,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,115,105,122,101,34,41,0,98,97,116,99,104,77,111,100,101,0,84,97,110,104,0,83,112,97,116,105,97,108,66,97,116,99,104,78,111,114,109,97,108,105,122,97,116,105,111,110,0,73,110,115,116,97,110,99,101,78,111,114,109,97,108,105,122,97,116,105,111,110,0,66,97,116,99,104,78,111,114,109,97,108,105,122,97,116,105,111,110,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,101,112,115,34,41,0,114,117,110,110,105,110,103,95,109,101,97,110,0,110,79,117,116,112,117,116,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,110,79,117,116,112,117,116,34,41,0,114,117,110,110,105,110,103,95,118,97,114,0,114,117,110,110,105,110,103,95,115,116,100,0,116,101,110,115,111,114,80,97,114,97,109,115,91,34,119,101,105,103,104,116,34,93,46,115,101,99,111,110,100,46,116,111,116,97,108,40,41,32,61,61,32,111,117,116,112,117,116,67,104,97,110,110,101,108,115,0,116,101,110,115,111,114,80,97,114,97,109,115,91,34,119,101,105,103,104,116,34,93,46,115,101,99,111,110,100,46,116,111,116,97,108,40,41,32,61,61,32,49,0,83,112,97,116,105,97,108,68,114,111,112,111,117,116,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,34,41,0,73,100,101,110,116,105,116,121,0,84,111,116,97,108,86,97,114,105,97,116,105,111,110,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,34,41,32,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,105,109,34,41,0,105,110,100,101,120,0,80,97,100,100,105,110,103,32,119,105,116,104,32,111,102,102,115,101,116,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,110,73,110,112,117,116,68,105,109,0,67,65,100,100,84,97,98,108,101,0,83,112,97,116,105,97,108,68,105,108,97,116,101,100,67,111,110,118,111,108,117,116,105,111,110,0,100,105,108,97,116,105,111,110,87,0,100,105,108,97,116,105,111,110,72,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,87,34,41,32,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,105,108,97,116,105,111,110,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,105,108,97,116,105,111,110,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,110,79,117,116,112,117,116,80,108,97,110,101,34,41,0,112,97,100,95,119,0,112,97,100,95,104,0,100,105,108,97,116,105,111,110,95,119,0,100,105,108,97,116,105,111,110,95,104,0,83,112,97,116,105,97,108,70,117,108,108,67,111,110,118,111,108,117,116,105,111,110,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,87,34,41,32,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,100,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,97,100,106,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,97,100,106,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,87,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,72,34,41,38,38,32,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,110,79,117,116,112,117,116,80,108,97,110,101,34,41,0,83,112,97,116,105,97,108,77,97,120,85,110,112,111,111,108,105,110,103,0,116,101,110,115,111,114,80,97,114,97,109,115,46,99,111,117,110,116,40,34,105,110,100,105,99,101,115,34,41,0,83,111,102,116,77,97,120,0,76,111,103,83,111,102,116,77,97,120,0,83,112,97,116,105,97,108,67,114,111,115,115,77,97,112,76,82,78,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,97,108,112,104,97,34,41,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,98,101,116,97,34,41,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,107,34,41,0,83,113,117,97,114,101,0,83,113,114,116,0,112,111,119,0,77,117,108,67,111,110,115,116,97,110,116,0,99,111,110,115,116,97,110,116,95,115,99,97,108,97,114,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,99,111,110,115,116,97,110,116,95,115,99,97,108,97,114,34,41,0,83,112,97,116,105,97,108,90,101,114,111,80,97,100,100,105,110,103,0,83,112,97,116,105,97,108,82,101,102,108,101,99,116,105,111,110,80,97,100,100,105,110,103,0,112,97,100,95,108,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,95,108,34,41,0,112,97,100,95,114,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,95,114,34,41,0,112,97,100,95,116,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,95,116,34,41,0,112,97,100,95,98,0,115,99,97,108,97,114,80,97,114,97,109,115,46,104,97,115,40,34,112,97,100,95,98,34,41,0,83,112,97,116,105,97,108,90,101,114,111,80,97,100,100,105,110,103,32,105,110,32,99,114,111,112,112,105,110,103,32,109,111,100,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,83,104,97,118,101,73,109,97,103,101,0,85,110,107,110,111,119,110,32,110,110,32,99,108,97,115,115,32,34,0,85,110,115,117,112,112,111,114,116,101,100,32,84,111,114,99,104,32,99,108,97,115,115,32,34,0,40,105,100,120,32,61,61,32,45,49,32,38,38,32,115,105,122,101,40,41,32,61,61,32,49,41,32,124,124,32,40,105,100,120,32,62,61,32,48,32,38,38,32,105,100,120,32,60,32,115,105,122,101,40,41,41,0,103,101,116,0,105,115,82,101,97,108,40,41,32,124,124,32,105,115,73,110,116,40,41,0,82,101,113,117,105,114,101,100,32,97,114,103,117,109,101,110,116,32,34,0,34,32,110,111,116,32,102,111,117,110,100,32,105,110,116,111,32,100,105,99,116,105,111,110,97,114,121,0,108,117,97,84,121,112,101,32,61,61,32,84,89,80,69,95,84,65,66,76,69,32,38,38,32,114,101,97,100,101,100,73,110,100,101,120,101,115,46,99,111,117,110,116,40,105,110,100,101,120,41,32,61,61,32,48,0,114,101,97,100,84,111,114,99,104,84,97,98,108,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,51,84,111,114,99,104,73,109,112,111,114,116,101,114,54,77,111,100,117,108,101,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,110,110,46,0,99,117,110,110,46,0,99,117,100,110,110,46,0,102,98,99,117,110,110,46,0,114,101,97,100,84,111,114,99,104,83,116,111,114,97,103,101,0,116,121,112,101,105,100,120,32,61,61,32,84,89,80,69,95,84,79,82,67,72,32,124,124,32,40,116,121,112,101,105,100,120,32,61,61,32,84,89,80,69,95,78,73,76,32,38,38,32,110,100,105,109,115,32,61,61,32,48,41,0,114,101,97,100,84,111,114,99,104,84,101,110,115,111,114,0,116,121,112,101,83,116,111,114,97,103,101,32,62,61,32,48,32,38,38,32,116,121,112,101,84,101,110,115,111,114,32,61,61,32,116,121,112,101,83,116,111,114,97,103,101,0,83,116,111,114,97,103,101,32,104,97,115,32,105,110,115,117,102,102,105,99,101,110,116,32,110,117,109,98,101,114,32,111,102,32,101,108,101,109,101,109,101,110,116,115,32,102,111,114,32,114,101,113,117,101,115,116,101,100,32,84,101,110,115,111,114,0,68,111,117,98,108,101,0,70,108,111,97,116,0,67,117,100,97,0,66,121,116,101,0,67,104,97,114,0,83,104,111,114,116,0,73,110,116,0,76,111,110,103,0,34,32,111,102,32,116,111,114,99,104,32,99,108,97,115,115,32,34,0,112,97,114,115,101,84,111,114,99,104,84,121,112,101,0,102,105,108,101,32,38,38,32,84,72,70,105,108,101,95,105,115,79,112,101,110,101,100,40,102,105,108,101,41,0,84,111,114,99,104,73,109,112,111,114,116,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,50,84,72,56,84,72,70,105,108,101,95,95,69,80,70,118,80,83,51,95,69,69,69,0,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,84,111,114,99,104,73,109,112,111,114,116,101,114,58,58,84,111,114,99,104,73,109,112,111,114,116,101,114,40,99,118,58,58,83,116,114,105,110,103,44,32,98,111,111,108,41,0,114,111,111,116,77,111,100,117,108,101,32,61,61,32,48,76,0,112,111,112,117,108,97,116,101,78,101,116,0,116,111,114,99,104,77,101,114,103,101,0,116,111,114,99,104,83,112,108,105,116,0,116,111,114,99,104,82,101,115,104,97,112,101,0,116,111,114,99,104,67,65,100,100,84,97,98,108,101,0,109,111,100,117,108,101,45,62,112,97,114,97,109,115,46,104,97,115,40,34,105,110,100,105,99,101,115,95,98,108,111,98,95,105,100,34,41,0,102,105,108,108,0,116,111,114,99,104,77,97,120,85,110,112,111,111,108,105,110,103,0,112,111,111,108,105,110,103,76,97,121,101,114,46,102,105,114,115,116,32,33,61,32,45,49,0,85,110,101,120,112,101,99,116,101,100,32,116,111,114,99,104,32,99,111,110,116,97,105,110,101,114,58,32,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,84,111,114,99,104,73,109,112,111,114,116,101,114,58,58,112,111,112,117,108,97,116,101,78,101,116,40,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,41,0,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,114,101,97,100,78,101,116,70,114,111,109,84,111,114,99,104,40,99,111,110,115,116,32,99,118,58,58,83,116,114,105,110,103,32,38,44,32,98,111,111,108,41,0,112,98,66,108,111,98,46,100,97,116,97,95,115,105,122,101,40,41,32,61,61,32,40,105,110,116,41,100,115,116,66,108,111,98,46,116,111,116,97,108,40,41,0,98,108,111,98,70,114,111,109,80,114,111,116,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,99,97,102,102,101,47,99,97,102,102,101,95,105,109,112,111,114,116,101,114,46,99,112,112,0,112,98,66,108,111,98,46,114,97,119,95,100,97,116,97,95,116,121,112,101,40,41,32,61,61,32,99,97,102,102,101,58,58,70,76,79,65,84,49,54,0,114,97,119,95,100,97,116,97,46,115,105,122,101,40,41,32,47,32,50,32,61,61,32,40,105,110,116,41,100,115,116,66,108,111,98,46,116,111,116,97,108,40,41,0,73,110,112,117,116,0,67,97,110,39,116,32,102,105,110,100,32,111,117,116,112,117,116,32,98,108,111,98,32,34,0,97,100,100,73,110,112,117,116,0,68,117,112,108,105,99,97,116,101,32,98,108,111,98,115,32,112,114,111,100,117,99,101,100,32,98,121,32,109,117,108,116,105,112,108,101,32,115,111,117,114,99,101,115,0,97,100,100,79,117,116,112,117,116,0,95,112,97,114,97,109,0,85,110,107,110,111,119,110,32,116,121,112,101,32,34,0,34,32,105,110,32,112,114,111,116,111,116,120,116,0,97,100,100,80,97,114,97,109,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,58,58,67,97,102,102,101,73,109,112,111,114,116,101,114,58,58,112,111,112,117,108,97,116,101,78,101,116,40,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,78,101,116,41,0,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,58,58,67,97,102,102,101,73,109,112,111,114,116,101,114,58,58,67,97,102,102,101,73,109,112,111,114,116,101,114,40,99,111,110,115,116,32,99,104,97,114,32,42,44,32,99,111,110,115,116,32,99,104,97,114,32,42,41,0,99,111,110,118,0,105,110,110,101,114,112,114,111,100,117,99,116,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,99,97,102,102,101,47,99,97,102,102,101,95,105,111,46,99,112,112,0,85,112,103,114,97,100,101,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,110,117,109,95,111,117,116,112,117,116,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,98,105,97,115,116,101,114,109,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,119,101,105,103,104,116,95,102,105,108,108,101,114,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,98,105,97,115,95,102,105,108,108,101,114,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,112,111,111,108,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,112,97,100,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,107,101,114,110,101,108,115,105,122,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,103,114,111,117,112,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,115,116,114,105,100,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,111,111,108,32,109,101,116,104,111,100,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,112,111,111,108,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,100,114,111,112,111,117,116,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,114,111,112,111,117,116,95,114,97,116,105,111,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,108,114,110,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,108,111,99,97,108,95,115,105,122,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,97,108,112,104,97,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,98,101,116,97,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,107,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,100,97,116,97,0,104,100,102,53,95,100,97,116,97,0,105,109,97,103,101,115,0,119,105,110,100,111,119,95,100,97,116,97,0,105,110,102,111,103,97,105,110,95,108,111,115,115,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,115,111,117,114,99,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,98,97,116,99,104,115,105,122,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,114,97,110,100,95,115,107,105,112,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,115,104,117,102,102,108,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,110,101,119,95,104,101,105,103,104,116,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,110,101,119,95,119,105,100,116,104,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,99,111,110,99,97,116,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,99,111,110,99,97,116,95,100,105,109,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,102,103,95,116,104,114,101,115,104,111,108,100,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,98,103,95,116,104,114,101,115,104,111,108,100,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,102,103,95,102,114,97,99,116,105,111,110,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,99,111,110,116,101,120,116,95,112,97,100,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,100,101,116,95,99,114,111,112,95,109,111,100,101,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,104,100,102,53,95,111,117,116,112,117,116,0,85,110,107,110,111,119,110,32,112,97,114,97,109,101,116,101,114,32,104,100,102,53,95,111,117,116,112,117,116,95,112,97,114,97,109,32,102,111,114,32,108,97,121,101,114,32,116,121,112,101,32,0,97,99,99,117,114,97,99,121,0,98,110,108,108,0,101,117,99,108,105,100,101,97,110,95,108,111,115,115,0,102,108,97,116,116,101,110,0,105,109,50,99,111,108,0,109,117,108,116,105,110,111,109,105,97,108,95,108,111,103,105,115,116,105,99,95,108,111,115,115,0,114,101,108,117,0,115,105,103,109,111,105,100,0,115,111,102,116,109,97,120,95,108,111,115,115,0,115,112,108,105,116,0,85,112,103,114,97,100,101,86,48,76,97,121,101,114,84,121,112,101,0,85,110,107,110,111,119,110,32,108,97,121,101,114,32,110,97,109,101,58,32,0,85,112,103,114,97,100,101,86,48,80,97,100,100,105,110,103,76,97,121,101,114,115,0,85,110,107,110,111,119,110,32,98,108,111,98,32,105,110,112,117,116,32,0,32,116,111,32,108,97,121,101,114,32,0,67,72,69,67,75,0,40,108,97,121,101,114,95,112,97,114,97,109,46,116,121,112,101,40,41,32,61,61,32,34,99,111,110,118,34,41,32,124,124,32,40,108,97,121,101,114,95,112,97,114,97,109,46,116,121,112,101,40,41,32,61,61,32,34,112,111,111,108,34,41,0,80,97,100,100,105,110,103,32,108,97,121,101,114,32,105,110,112,117,116,32,116,111,32,110,111,110,45,99,111,110,118,111,108,117,116,105,111,110,97,108,32,47,32,110,111,110,45,112,111,111,108,105,110,103,32,108,97,121,101,114,32,116,121,112,101,32,0,108,97,121,101,114,95,99,111,110,110,101,99,116,105,111,110,46,98,111,116,116,111,109,95,115,105,122,101,40,41,61,49,0,67,111,110,118,32,76,97,121,101,114,32,116,97,107,101,115,32,97,32,115,105,110,103,108,101,32,98,108,111,98,32,97,115,32,105,110,112,117,116,46,0,115],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+368702);allocate([111,117,114,99,101,95,108,97,121,101,114,46,98,111,116,116,111,109,95,115,105,122,101,40,41,61,49,0,80,97,100,100,105,110,103,32,76,97,121,101,114,32,116,97,107,101,115,32,97,32,115,105,110,103,108,101,32,98,108,111,98,32,97,115,32,105,110,112,117,116,46,0,115,111,117,114,99,101,95,108,97,121,101,114,46,116,111,112,95,115,105,122,101,40,41,61,49,0,80,97,100,100,105,110,103,32,76,97,121,101,114,32,112,114,111,100,117,99,101,115,32,97,32,115,105,110,103,108,101,32,98,108,111,98,32,97,115,32,111,117,116,112,117,116,46,0,85,112,103,114,97,100,101,78,101,116,65,115,78,101,101,100,101,100,0,65,116,116,101,109,112,116,105,110,103,32,116,111,32,117,112,103,114,97,100,101,32,105,110,112,117,116,32,102,105,108,101,32,115,112,101,99,105,102,105,101,100,32,117,115,105,110,103,32,100,101,112,114,101,99,97,116,101,100,32,0,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,58,32,0,87,97,114,110,105,110,103,58,32,104,97,100,32,111,110,101,32,111,114,32,109,111,114,101,32,112,114,111,98,108,101,109,115,32,117,112,103,114,97,100,105,110,103,32,0,86,48,78,101,116,80,97,114,97,109,101,116,101,114,32,116,111,32,78,101,116,80,97,114,97,109,101,116,101,114,32,40,115,101,101,32,97,98,111,118,101,41,59,32,99,111,110,116,105,110,117,105,110,103,32,97,110,121,119,97,121,46,0,83,117,99,99,101,115,115,102,117,108,108,121,32,117,112,103,114,97,100,101,100,32,102,105,108,101,32,115,112,101,99,105,102,105,101,100,32,117,115,105,110,103,32,100,101,112,114,101,99,97,116,101,100,32,0,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,0,78,111,116,101,32,116,104,97,116,32,102,117,116,117,114,101,32,67,97,102,102,101,32,114,101,108,101,97,115,101,115,32,119,105,108,108,32,110,111,116,32,115,117,112,112,111,114,116,32,0,86,48,78,101,116,80,97,114,97,109,101,116,101,114,59,32,117,115,101,32,46,47,98,117,105,108,100,47,116,111,111,108,115,47,117,112,103,114,97,100,101,95,110,101,116,95,112,114,111,116,111,95,116,101,120,116,32,102,111,114,32,0,112,114,111,116,111,116,120,116,32,97,110,100,32,46,47,98,117,105,108,100,47,116,111,111,108,115,47,117,112,103,114,97,100,101,95,110,101,116,95,112,114,111,116,111,95,98,105,110,97,114,121,32,102,111,114,32,109,111,100,101,108,32,0,119,101,105,103,104,116,115,32,117,112,103,114,97,100,101,32,116,104,105,115,32,97,110,100,32,97,110,121,32,111,116,104,101,114,32,110,101,116,32,112,114,111,116,111,115,32,116,111,32,116,104,101,32,110,101,119,32,102,111,114,109,97,116,46,0,116,114,97,110,115,102,111,114,109,97,116,105,111,110,32,112,97,114,97,109,101,116,101,114,115,58,32,0,100,97,116,97,32,116,114,97,110,115,102,111,114,109,97,116,105,111,110,32,112,97,114,97,109,101,116,101,114,115,46,0,78,111,116,101,32,116,104,97,116,32,102,117,116,117,114,101,32,67,97,102,102,101,32,114,101,108,101,97,115,101,115,32,119,105,108,108,32,111,110,108,121,32,115,117,112,112,111,114,116,32,0,116,114,97,110,115,102,111,114,109,95,112,97,114,97,109,32,109,101,115,115,97,103,101,115,32,102,111,114,32,116,114,97,110,115,102,111,114,109,97,116,105,111,110,32,102,105,101,108,100,115,46,0,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,58,32,0,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,32,40,115,101,101,32,97,98,111,118,101,41,59,32,99,111,110,116,105,110,117,105,110,103,32,97,110,121,119,97,121,46,0,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,0,65,116,116,101,109,112,116,105,110,103,32,116,111,32,117,112,103,114,97,100,101,32,98,97,116,99,104,32,110,111,114,109,32,108,97,121,101,114,115,32,117,115,105,110,103,32,100,101,112,114,101,99,97,116,101,100,32,0,112,97,114,97,109,115,58,32,0,83,117,99,99,101,115,115,102,117,108,108,121,32,117,112,103,114,97,100,101,100,32,98,97,116,99,104,32,110,111,114,109,32,108,97,121,101,114,115,32,117,115,105,110,103,32,100,101,112,114,101,99,97,116,101,100,32,0,112,97,114,97,109,115,46,0,85,112,103,114,97,100,101,86,49,78,101,116,0,73,110,112,117,116,32,78,101,116,80,97,114,97,109,101,116,101,114,32,116,111,32,98,101,32,117,112,103,114,97,100,101,100,32,97,108,114,101,97,100,121,32,115,112,101,99,105,102,105,101,115,32,39,108,97,121,101,114,39,32,0,102,105,101,108,100,115,59,32,116,104,101,115,101,32,119,105,108,108,32,98,101,32,105,103,110,111,114,101,100,32,102,111,114,32,116,104,101,32,117,112,103,114,97,100,101,46,0,85,112,103,114,97,100,101,32,111,102,32,105,110,112,117,116,32,108,97,121,101,114,32,0,32,102,97,105,108,101,100,46,0,85,112,103,114,97,100,101,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,0,85,110,107,110,111,119,110,32,98,108,111,98,95,115,104,97,114,101,95,109,111,100,101,58,32,0,73,110,112,117,116,32,78,101,116,80,97,114,97,109,101,116,101,114,32,104,97,115,32,86,48,32,108,97,121,101,114,32,45,45,32,105,103,110,111,114,105,110,103,46,0,85,112,103,114,97,100,101,86,49,76,97,121,101,114,84,121,112,101,0,85,110,107,110,111,119,110,32,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,32,108,97,121,101,114,32,116,121,112,101,58,32,0,84,104,114,101,115,104,111,108,100,0,87,105,110,100,111,119,68,97,116,97,0,84,97,110,72,0,83,111,102,116,109,97,120,87,105,116,104,76,111,115,115,0,83,105,103,109,111,105,100,67,114,111,115,115,69,110,116,114,111,112,121,76,111,115,115,0,82,101,76,85,0,77,117,108,116,105,110,111,109,105,97,108,76,111,103,105,115,116,105,99,76,111,115,115,0,77,101,109,111,114,121,68,97,116,97,0,73,110,102,111,103,97,105,110,76,111,115,115,0,73,109,97,103,101,68,97,116,97,0,73,109,50,99,111,108,0,72,105,110,103,101,76,111,115,115,0,72,68,70,53,79,117,116,112,117,116,0,72,68,70,53,68,97,116,97,0,69,120,112,0,69,117,99,108,105,100,101,97,110,76,111,115,115,0,68,117,109,109,121,68,97,116,97,0,68,97,116,97,0,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,0,66,78,76,76,0,65,114,103,77,97,120,0,65,99,99,117,114,97,99,121,0,82,101,97,100,80,114,111,116,111,70,114,111,109,84,101,120,116,70,105,108,101,0,102,115,46,105,115,95,111,112,101,110,40,41,0,67,97,110,39,116,32,111,112,101,110,32,34,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,82,101,97,100,80,114,111,116,111,70,114,111,109,66,105,110,97,114,121,70,105,108,101,0,82,101,97,100,78,101,116,80,97,114,97,109,115,70,114,111,109,84,101,120,116,70,105,108,101,79,114,68,105,101,0,82,101,97,100,80,114,111,116,111,70,114,111,109,84,101,120,116,70,105,108,101,40,112,97,114,97,109,95,102,105,108,101,44,32,112,97,114,97,109,41,0,82,101,97,100,78,101,116,80,97,114,97,109,115,70,114,111,109,66,105,110,97,114,121,70,105,108,101,79,114,68,105,101,0,82,101,97,100,80,114,111,116,111,70,114,111,109,66,105,110,97,114,121,70,105,108,101,40,112,97,114,97,109,95,102,105,108,101,44,32,112,97,114,97,109,41,0,116,101,110,115,111,114,95,115,104,97,112,101,46,112,114,111,116,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,116,101,110,115,111,114,95,115,104,97,112,101,46,112,98,46,99,99,0,10,18,116,101,110,115,111,114,95,115,104,97,112,101,46,112,114,111,116,111,18,10,116,101,110,115,111,114,102,108,111,119,34,122,10,16,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,18,45,10,3,100,105,109,24,2,32,3,40,11,50,32,46,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,46,68,105,109,18,20,10,12,117,110,107,110,111,119,110,95,114,97,110,107,24,3,32,1,40,8,26,33,10,3,68,105,109,18,12,10,4,115,105,122,101,24,1,32,1,40,3,18,12,10,4,110,97,109,101,24,2,32,1,40,9,66,50,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,17,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,78,49,48,116,101,110,115,111,114,102,108,111,119,49,54,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,69,0,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,46,68,105,109,46,110,97,109,101,0,78,49,48,116,101,110,115,111,114,102,108,111,119,50,48,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,95,68,105,109,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,53,73,110,116,101,114,110,97,108,77,101,116,97,100,97,116,97,87,105,116,104,65,114,101,110,97,57,67,111,110,116,97,105,110,101,114,69,0,103,114,97,112,104,46,112,114,111,116,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,103,114,97,112,104,46,112,98,46,99,99,0,10,11,103,114,97,112,104,46,112,114,111,116,111,18,10,116,101,110,115,111,114,102,108,111,119,26,16,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,26,14,102,117,110,99,116,105,111,110,46,112,114,111,116,111,26,14,118,101,114,115,105,111,110,115,46,112,114,111,116,111,34,157,1,10,8,71,114,97,112,104,68,101,102,18,33,10,4,110,111,100,101,24,1,32,3,40,11,50,19,46,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,18,40,10,8,118,101,114,115,105,111,110,115,24,4,32,1,40,11,50,22,46,116,101,110,115,111,114,102,108,111,119,46,86,101,114,115,105,111,110,68,101,102,18,19,10,7,118,101,114,115,105,111,110,24,3,32,1,40,5,66,2,24,1,18,47,10,7,108,105,98,114,97,114,121,24,2,32,1,40,11,50,30,46,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,76,105,98,114,97,114,121,34,179,1,10,7,78,111,100,101,68,101,102,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,10,10,2,111,112,24,2,32,1,40,9,18,13,10,5,105,110,112,117,116,24,3,32,3,40,9,18,14,10,6,100,101,118,105,99,101,24,4,32,1,40,9,18,43,10,4,97,116,116,114,24,5,32,3,40,11,50,29,46,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,65,116,116,114,69,110,116,114,121,26,66,10,9,65,116,116,114,69,110,116,114,121,18,11,10,3,107,101,121,24,1,32,1,40,9,18,36,10,5,118,97,108,117,101,24,2,32,1,40,11,50,21,46,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,58,2,56,1,66,44,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,11,71,114,97,112,104,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,97,112,95,101,110,116,114,121,95,108,105,116,101,46,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,100,101,102,97,117,108,116,95,105,110,115,116,97,110,99,101,95,32,33,61,32,78,85,76,76,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,76,105,116,101,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,51,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,51,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,49,48,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,68,95,49,49,69,76,105,48,69,69,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,97,112,95,101,110,116,114,121,46,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,38,102,114,111,109,41,32,33,61,32,40,116,104,105,115,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,69,110,116,114,121,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,51,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,51,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,49,48,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,68,95,49,49,69,76,105,48,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,66,97,115,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,70,105,101,108,100,76,105,116,101,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,51,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,51,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,49,48,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,68,95,49,49,69,76,105,48,69,69,69,0,77,97,112,75,101,121,58,58,116,121,112,101,32,77,97,112,75,101,121,32,105,115,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,100,46,32,0,67,97,108,108,32,115,101,116,32,109,101,116,104,111,100,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,32,77,97,112,75,101,121,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,97,112,95,102,105,101,108,100,95,105,110,108,46,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,77,97,112,70,105,101,108,100,66,97,115,101,58,58,114,101,112,101,97,116,101,100,95,102,105,101,108,100,95,32,33,61,32,78,85,76,76,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,100,101,102,97,117,108,116,95,101,110,116,114,121,95,32,33,61,32,78,85,76,76,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,42,77,97,112,70,105,101,108,100,66,97,115,101,58,58,101,110,116,114,121,95,100,101,115,99,114,105,112,116,111,114,95,32,33,61,32,78,85,76,76,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,54,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,73,78,83,48,95,55,77,101,115,115,97,103,101,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,66,97,115,101,69,0,77,97,112,75,101,121,58,58,71,101,116,83,116,114,105,110,103,86,97,108,117,101,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,56,77,97,112,70,105,101,108,100,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,51,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,51,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,49,48,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,68,95,49,49,69,76,105,48,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,51,84,121,112,101,68,101,102,105,110,101,100,77,97,112,70,105,101,108,100,66,97,115,101,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,51,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,51,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,49,48,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,69,69,0,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,110,97,109,101,0,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,111,112,0,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,105,110,112,117,116,0,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,100,101,118,105,99,101,0,116,101,110,115,111,114,102,108,111,119,46,78,111,100,101,68,101,102,46,65,116,116,114,69,110,116,114,121,46,107,101,121,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,69,110,116,114,121,76,105,116,101,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,51,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,51,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,49,48,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,76,78,83,49,95,49,52,87,105,114,101,70,111,114,109,97,116,76,105,116,101,57,70,105,101,108,100,84,121,112,101,69,57,69,76,83,68,95,49,49,69,76,105,48,69,69,49,53,77,97,112,69,110,116,114,121,87,114,97,112,112,101,114,73,83,57,95,83,66,95,76,83,68,95,57,69,76,83,68,95,49,49,69,76,105,48,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,51,77,97,112,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,50,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,78,49,48,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,69,69,0,78,49,48,116,101,110,115,111,114,102,108,111,119,55,78,111,100,101,68,101,102,69,0,78,49,48,116,101,110,115,111,114,102,108,111,119,56,71,114,97,112,104,68,101,102,69,0,118,101,114,115,105,111,110,115,46,112,114,111,116,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,118,101,114,115,105,111,110,115,46,112,98,46,99,99,0,10,14,118,101,114,115,105,111,110,115,46,112,114,111,116,111,18,10,116,101,110,115,111,114,102,108,111,119,34,75,10,10,86,101,114,115,105,111,110,68,101,102,18,16,10,8,112,114,111,100,117,99,101,114,24,1,32,1,40,5,18,20,10,12,109,105,110,95,99,111,110,115,117,109,101,114,24,2,32,1,40,5,18,21,10,13,98,97,100,95,99,111,110,115,117,109,101,114,115,24,3,32,3,40,5,66,47,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,14,86,101,114,115,105,111,110,115,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,78,49,48,116,101,110,115,111,114,102,108,111,119,49,48,86,101,114,115,105,111,110,68,101,102,69,0,116,101,110,115,111,114,46,112,114,111,116,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,116,101,110,115,111,114,46,112,98,46,99,99,0,10,12,116,101,110,115,111,114,46,112,114,111,116,111,18,10,116,101,110,115,111,114,102,108,111,119,26,18,116,101,110,115,111,114,95,115,104,97,112,101,46,112,114,111,116,111,26,11,116,121,112,101,115,46,112,114,111,116,111,34,229,2,10,11,84,101,110,115,111,114,80,114,111,116,111,18,35,10,5,100,116,121,112,101,24,1,32,1,40,14,50,20,46,116,101,110,115,111,114,102,108,111,119,46,68,97,116,97,84,121,112,101,18,50,10,12,116,101,110,115,111,114,95,115,104,97,112,101,24,2,32,1,40,11,50,28,46,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,18,22,10,14,118,101,114,115,105,111,110,95,110,117,109,98,101,114,24,3,32,1,40,5,18,22,10,14,116,101,110,115,111,114,95,99,111,110,116,101,110,116,24,4,32,1,40,12,18,20,10,8,104,97,108,102,95,118,97,108,24,13,32,3,40,5,66,2,16,1,18,21,10,9,102,108,111,97,116,95,118,97,108,24,5,32,3,40,2,66,2,16,1,18,22,10,10,100,111,117,98,108,101,95,118,97,108,24,6,32,3,40,1,66,2,16,1,18,19,10,7,105,110,116,95,118,97,108,24,7,32,3,40,5,66,2,16,1,18,18,10,10,115,116,114,105,110,103,95,118,97,108,24,8,32,3,40,12,18,24,10,12,115,99,111,109,112,108,101,120,95,118,97,108,24,9,32,3,40,2,66,2,16,1,18,21,10,9,105,110,116,54,52,95,118,97,108,24,10,32,3,40,3,66,2,16,1,18,20,10,8,98,111,111,108,95,118,97,108,24,11,32,3,40,8,66,2,16,1,18,24,10,12,100,99,111,109,112,108,101,120,95,118,97,108,24,12,32,3,40,1,66,2,16,1,66,45,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,12,84,101,110,115,111,114,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,78,49,48,116,101,110,115,111,114,102,108,111,119,49,49,84,101,110,115,111,114,80,114,111,116,111,69,0,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,97,116,116,114,95,118,97,108,117,101,46,112,98,46,99,99,0,10,16,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,18,10,116,101,110,115,111,114,102,108,111,119,26,12,116,101,110,115,111,114,46,112,114,111,116,111,26,18,116,101,110,115,111,114,95,115,104,97,112,101,46,112,114,111,116,111,26,11,116,121,112,101,115,46,112,114,111,116,111,34,254,3,10,9,65,116,116,114,86,97,108,117,101,18,11,10,1,115,24,2,32,1,40,12,72,0,18,11,10,1,105,24,3,32,1,40,3,72,0,18,11,10,1,102,24,4,32,1,40,2,72,0,18,11,10,1,98,24,5,32,1,40,8,72,0,18,36,10,4,116,121,112,101,24,6,32,1,40,14,50,20,46,116,101,110,115,111,114,102,108,111,119,46,68,97,116,97,84,121,112,101,72,0,18,45,10,5,115,104,97,112,101,24,7,32,1,40,11,50,28,46,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,72,0,18,41,10,6,116,101,110,115,111,114,24,8,32,1,40,11,50,23,46,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,80,114,111,116,111,72,0,18,47,10,4,108,105,115,116,24,1,32,1,40,11,50,31,46,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,46,76,105,115,116,86,97,108,117,101,72,0,18,40,10,4,102,117,110,99,24,10,32,1,40,11,50,24,46,116,101,110,115,111,114,102,108,111,119,46,78,97,109,101,65,116,116,114,76,105,115,116,72,0,18,21,10,11,112,108,97,99,101,104,111,108,100,101,114,24,9,32,1,40,9,72,0,26,193,1,10,9,76,105,115,116,86,97,108,117,101,18,9,10,1,115,24,2,32,3,40,12,18,13,10,1,105,24,3,32,3,40,3,66,2,16,1,18,13,10,1,102,24,4,32,3,40,2,66,2,16,1,18,13,10,1,98,24,5,32,3,40,8,66,2,16,1,18,38,10,4,116,121,112,101,24,6,32,3,40,14,50,20,46,116,101,110,115,111,114,102,108,111,119,46,68,97,116,97,84,121,112,101,66,2,16,1,18,43,10,5,115,104,97,112,101,24,7,32,3,40,11,50,28,46,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,83,104,97,112,101,80,114,111,116,111,18,39,10,6,116,101,110,115,111,114,24,8,32,3,40,11,50,23,46,116,101,110,115,111,114,102,108,111,119,46,84,101,110,115,111,114,80,114,111,116,111,66,7,10,5,118,97,108,117,101,34,146,1,10,12,78,97,109,101,65,116,116,114,76,105,115,116,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,48,10,4,97,116,116,114,24,2,32,3,40,11,50,34,46,116,101,110,115,111,114,102,108,111,119,46,78,97,109,101,65,116,116,114,76,105,115,116,46,65,116,116,114,69,110,116,114,121,26,66,10,9,65,116,116,114,69,110,116,114,121,18,11,10,3,107,101,121,24,1,32,1,40,9,18,36,10,5,118,97,108,117,101,24,2,32,1,40,11,50,21,46,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,58,2,56,1,66,48,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,15,65,116,116,114,86,97,108,117,101,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,116,101,110,115,111,114,102,108,111,119,46,78,97,109,101,65,116,116,114,76,105,115,116,46,110,97,109,101,0,116,101,110,115,111,114,102,108,111,119,46,78,97,109,101,65,116,116,114,76,105,115,116,46,65,116,116,114,69,110,116,114,121,46,107,101,121,0,78,49,48,116,101,110,115,111,114,102,108,111,119,49,50,78,97,109,101,65,116,116,114,76,105,115,116,69,0,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,46,112,108,97,99,101,104,111,108,100,101,114,0,78,49,48,116,101,110,115,111,114,102,108,111,119,57,65,116,116,114,86,97,108,117,101,69,0,78,49,48,116,101,110,115,111,114,102,108,111,119,49,57,65,116,116,114,86,97,108,117,101,95,76,105,115,116,86,97,108,117,101,69,0,102,117,110,99,116,105,111,110,46,112,114,111,116,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,102,117,110,99,116,105,111,110,46,112,98,46,99,99,0,10,14,102,117,110,99,116,105,111,110,46,112,114,111,116,111,18,10,116,101,110,115,111,114,102,108,111,119,26,16,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,26,12,111,112,95,100,101,102,46,112,114,111,116,111,34,106,10,18,70,117,110,99,116,105,111,110,68,101,102,76,105,98,114,97,114,121,18,41,10,8,102,117,110,99,116,105,111,110,24,1,32,3,40,11,50,23,46,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,18,41,10,8,103,114,97,100,105,101,110,116,24,2,32,3,40,11,50,23,46,116,101,110,115,111,114,102,108,111,119,46,71,114,97,100,105,101,110,116,68,101,102,34,149,2,10,11,70,117,110,99,116,105,111,110,68,101,102,18,36,10,9,115,105,103,110,97,116,117,114,101,24,1,32,1,40,11,50,17,46,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,18,42,10,4,110,111,100,101,24,2,32,3,40,11,50,28,46,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,26,179,1,10,4,78,111,100,101,18,11,10,3,114,101,116,24,1,32,3,40,9,18,10,10,2,111,112,24,2,32,1,40,9,18,11,10,3,97,114,103,24,3,32,3,40,9,18,11,10,3,100,101,112,24,4,32,3,40,9,18,52,10,4,97,116,116,114,24,5,32,3,40,11,50,38,46,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,65,116,116,114,69,110,116,114,121,26,66,10,9,65,116,116,114,69,110,116,114,121,18,11,10,3,107,101,121,24,1,32,1,40,9,18,36,10,5,118,97,108,117,101,24,2,32,1,40,11,50,21,46,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,58,2,56,1,34,59,10,11,71,114,97,100,105,101,110,116,68,101,102,18,21,10,13,102,117,110,99,116,105,111,110,95,110,97,109,101,24,1,32,1,40,9,18,21,10,13,103,114,97,100,105,101,110,116,95,102,117,110,99,24,2,32,1,40,9,66,47,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,14,70,117,110,99,116,105,111,110,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,116,101,110,115,111,114,102,108,111,119,46,71,114,97,100,105,101,110,116,68,101,102,46,102,117,110,99,116,105,111,110,95,110,97,109,101,0,116,101,110,115,111,114,102,108,111,119,46,71,114,97,100,105,101,110,116,68,101,102,46,103,114,97,100,105,101,110,116,95,102,117,110,99,0,78,49,48,116,101,110,115,111,114,102,108,111,119,49,49,71,114,97,100,105,101,110,116,68,101,102,69,0,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,114,101,116,0,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,111,112,0,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,97,114,103,0,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,100,101,112,0,116,101,110,115,111,114,102,108,111,119,46,70,117,110,99,116,105,111,110,68,101,102,46,78,111,100,101,46,65,116,116,114,69,110,116,114,121,46,107,101,121,0,78,49,48,116,101,110,115,111,114,102,108,111,119,49,54,70,117,110,99,116,105,111,110,68,101,102,95,78,111,100,101,69,0,78,49,48,116,101,110,115,111,114,102,108,111,119,49,49,70,117,110,99,116,105,111,110,68,101,102,69,0,78,49,48,116,101,110,115,111,114,102,108,111,119,49,56,70,117,110,99,116,105,111,110,68,101,102,76,105,98,114,97,114,121,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,116,121,112,101,115,46,112,98,46,99,99,0,10,11,116,121,112,101,115,46,112,114,111,116,111,18,10,116,101,110,115,111,114,102,108,111,119,42,156,5,10,8,68,97,116,97,84,121,112,101,18,14,10,10,68,84,95,73,78,86,65,76,73,68,16,0,18,12,10,8,68,84,95,70,76,79,65,84,16,1,18,13,10,9,68,84,95,68,79,85,66,76,69,16,2,18,12,10,8,68,84,95,73,78,84,51,50,16,3,18,12,10,8,68,84,95,85,73,78,84,56,16,4,18,12,10,8,68,84,95,73,78,84,49,54,16,5,18,11,10,7,68,84,95,73,78,84,56,16,6,18,13,10,9,68,84,95,83,84,82,73,78,71,16,7,18,16,10,12,68,84,95,67,79,77,80,76,69,88,54,52,16,8,18,12,10,8,68,84,95,73,78,84,54,52,16,9,18,11,10,7,68,84,95,66,79,79,76,16,10,18,12,10,8,68,84,95,81,73,78,84,56,16,11,18,13,10,9,68,84,95,81,85,73,78,84,56,16,12,18,13,10,9,68,84,95,81,73,78,84,51,50,16,13,18,15,10,11,68,84,95,66,70,76,79,65,84,49,54,16,14,18,13,10,9,68,84,95,81,73,78,84,49,54,16,15,18,14,10,10,68,84,95,81,85,73,78,84,49,54,16,16,18,13,10,9,68,84,95,85,73,78,84,49,54,16,17,18,17,10,13,68,84,95,67,79,77,80,76,69,88,49,50,56,16,18,18,11,10,7,68,84,95,72,65,76,70,16,19,18,16,10,12,68,84,95,70,76,79,65,84,95,82,69,70,16,101,18,17,10,13,68,84,95,68,79,85,66,76,69,95,82,69,70,16,102,18,16,10,12,68,84,95,73,78,84,51,50,95,82,69,70,16,103,18,16,10,12,68,84,95,85,73,78,84,56,95,82,69,70,16,104,18,16,10,12,68,84,95,73,78,84,49,54,95,82,69,70,16,105,18,15,10,11,68,84,95,73,78,84,56,95,82,69,70,16,106,18,17,10,13,68,84,95,83,84,82,73,78,71,95,82,69,70,16,107,18,20,10,16,68,84,95,67,79,77,80,76,69,88,54,52,95,82,69,70,16,108,18,16,10,12,68,84,95,73,78,84,54,52,95,82,69,70,16,109,18,15,10,11,68,84,95,66,79,79,76,95,82,69,70,16,110,18,16,10,12,68,84,95,81,73,78,84,56,95,82,69,70,16,111,18,17,10,13,68,84,95,81,85,73,78,84,56,95,82,69,70,16,112,18,17,10,13,68,84,95,81,73,78,84,51,50,95,82,69,70,16,113,18,19,10,15,68,84,95,66,70,76,79,65,84,49,54,95,82,69,70,16,114,18,17,10,13,68,84,95,81,73,78,84,49,54,95,82,69,70,16,115,18,18,10,14,68,84,95,81,85,73,78,84,49,54,95,82,69,70,16,116,18,17,10,13,68,84,95,85,73,78,84,49,54,95,82,69,70,16,117,18,21,10,17,68,84,95,67,79,77,80,76,69,88,49,50,56,95,82,69,70,16,118,18,15,10,11,68,84,95,72,65,76,70,95,82,69,70,16,119,66,44,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,11,84,121,112,101,115,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,116,121,112,101,115,46,112,114,111,116,111,0,111,112,95,100,101,102,46,112,114,111,116,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,116,101,110,115,111,114,102,108,111,119,47,111,112,95,100,101,102,46,112,98,46,99,99,0,10,12,111,112,95,100,101,102,46,112,114,111,116,111,18,10,116,101,110,115,111,114,102,108,111,119,26,16,97,116,116,114,95,118,97,108,117,101,46,112,114,111,116,111,26,11,116,121,112,101,115,46,112,114,111,116,111,34,184,5,10,5,79,112,68,101,102,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,43,10,9,105,110,112,117,116,95,97,114,103,24,2,32,3,40,11,50,24,46,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,18,44,10,10,111,117,116,112,117,116,95,97,114,103,24,3,32,3,40,11,50,24,46,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,18,39,10,4,97,116,116,114,24,4,32,3,40,11,50,25,46,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,116,116,114,68,101,102,18,46,10,11,100,101,112,114,101,99,97,116,105,111,110,24,8,32,1,40,11,50,25,46,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,112,114,101,99,97,116,105,111,110,18,15,10,7,115,117,109,109,97,114,121,24,5,32,1,40,9,18,19,10,11,100,101,115,99,114,105,112,116,105,111,110,24,6,32,1,40,9,18,22,10,14,105,115,95,99,111,109,109,117,116,97,116,105,118,101,24,18,32,1,40,8,18,20,10,12,105,115,95,97,103,103,114,101,103,97,116,101,24,16,32,1,40,8,18,19,10,11,105,115,95,115,116,97,116,101,102,117,108,24,17,32,1,40,8,18,34,10,26,97,108,108,111,119,115,95,117,110,105,110,105,116,105,97,108,105,122,101,100,95,105,110,112,117,116,24,19,32,1,40,8,26,159,1,10,6,65,114,103,68,101,102,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,19,10,11,100,101,115,99,114,105,112,116,105,111,110,24,2,32,1,40,9,18,34,10,4,116,121,112,101,24,3,32,1,40,14,50,20,46,116,101,110,115,111,114,102,108,111,119,46,68,97,116,97,84,121,112,101,18,17,10,9,116,121,112,101,95,97,116,116,114,24,4,32,1,40,9,18,19,10,11,110,117,109,98,101,114,95,97,116,116,114,24,5,32,1,40,9,18,22,10,14,116,121,112,101,95,108,105,115,116,95,97,116,116,114,24,6,32,1,40,9,18,14,10,6,105,115,95,114,101,102,24,16,32,1,40,8,26,189,1,10,7,65,116,116,114,68,101,102,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,12,10,4,116,121,112,101,24,2,32,1,40,9,18,44,10,13,100,101,102,97,117,108,116,95,118,97,108,117,101,24,3,32,1,40,11,50,21,46,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,18,19,10,11,100,101,115,99,114,105,112,116,105,111,110,24,4,32,1,40,9,18,19,10,11,104,97,115,95,109,105,110,105,109,117,109,24,5,32,1,40,8,18,15,10,7,109,105,110,105,109,117,109,24,6,32,1,40,3,18,45,10,14,97,108,108,111,119,101,100,95,118,97,108,117,101,115,24,7,32,1,40,11,50,21,46,116,101,110,115,111,114,102,108,111,119,46,65,116,116,114,86,97,108,117,101,34,53,10,13,79,112,68,101,112,114,101,99,97,116,105,111,110,18,15,10,7,118,101,114,115,105,111,110,24,1,32,1,40,5,18,19,10,11,101,120,112,108,97,110,97,116,105,111,110,24,2,32,1,40,9,34,39,10,6,79,112,76,105,115,116,18,29,10,2,111,112,24,1,32,3,40,11,50,17,46,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,66,44,10,24,111,114,103,46,116,101,110,115,111,114,102,108,111,119,46,102,114,97,109,101,119,111,114,107,66,11,79,112,68,101,102,80,114,111,116,111,115,80,1,248,1,1,98,6,112,114,111,116,111,51,0,78,49,48,116,101,110,115,111,114,102,108,111,119,53,79,112,68,101,102,69,0,78,49,48,116,101,110,115,111,114,102,108,111,119,49,51,79,112,68,101,112,114,101,99,97,116,105,111,110,69,0,78,49,48,116,101,110,115,111,114,102,108,111,119,49,51,79,112,68,101,102,95,65,116,116,114,68,101,102,69,0,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,110,97,109,101,0,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,115,117,109,109,97,114,121,0,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,100,101,115,99,114,105,112,116,105,111,110,0,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,112,114,101,99,97,116,105,111,110,46,101,120,112,108,97,110,97,116,105,111,110,0,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,116,116,114,68,101,102,46,110,97,109,101,0,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,116,116,114,68,101,102,46,116,121,112,101,0,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,116,116,114,68,101,102,46,100,101,115,99,114,105,112,116,105,111,110,0,78,49,48,116,101,110,115,111,114,102,108,111,119,54,79,112,76,105,115,116,69,0,116,101,110,115,111,114,102,108,111,119,46,79],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+378942);allocate([112,68,101,102,46,65,114,103,68,101,102,46,110,97,109,101,0,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,100,101,115,99,114,105,112,116,105,111,110,0,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,116,121,112,101,95,97,116,116,114,0,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,110,117,109,98,101,114,95,97,116,116,114,0,116,101,110,115,111,114,102,108,111,119,46,79,112,68,101,102,46,65,114,103,68,101,102,46,116,121,112,101,95,108,105,115,116,95,97,116,116,114,0,78,49,48,116,101,110,115,111,114,102,108,111,119,49,50,79,112,68,101,102,95,65,114,103,68,101,102,69,0,111,112,101,110,99,118,45,99,97,102,102,101,46,112,114,111,116,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,109,105,115,99,47,99,97,102,102,101,47,111,112,101,110,99,118,45,99,97,102,102,101,46,112,98,46,99,99,0,10,18,111,112,101,110,99,118,45,99,97,102,102,101,46,112,114,111,116,111,18,12,111,112,101,110,99,118,95,99,97,102,102,101,34,28,10,9,66,108,111,98,83,104,97,112,101,18,15,10,3,100,105,109,24,1,32,3,40,3,66,2,16,1,34,148,2,10,9,66,108,111,98,80,114,111,116,111,18,38,10,5,115,104,97,112,101,24,7,32,1,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,18,16,10,4,100,97,116,97,24,5,32,3,40,2,66,2,16,1,18,16,10,4,100,105,102,102,24,6,32,3,40,2,66,2,16,1,18,23,10,11,100,111,117,98,108,101,95,100,97,116,97,24,8,32,3,40,1,66,2,16,1,18,23,10,11,100,111,117,98,108,101,95,100,105,102,102,24,9,32,3,40,1,66,2,16,1,18,41,10,13,114,97,119,95,100,97,116,97,95,116,121,112,101,24,10,32,1,40,14,50,18,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,121,112,101,18,20,10,8,114,97,119,95,100,97,116,97,24,12,32,1,40,12,66,2,16,0,18,14,10,3,110,117,109,24,1,32,1,40,5,58,1,48,18,19,10,8,99,104,97,110,110,101,108,115,24,2,32,1,40,5,58,1,48,18,17,10,6,104,101,105,103,104,116,24,3,32,1,40,5,58,1,48,18,16,10,5,119,105,100,116,104,24,4,32,1,40,5,58,1,48,34,57,10,15,66,108,111,98,80,114,111,116,111,86,101,99,116,111,114,18,38,10,5,98,108,111,98,115,24,1,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,34,33,10,16,80,101,114,109,117,116,101,80,97,114,97,109,101,116,101,114,18,13,10,5,111,114,100,101,114,24,1,32,3,40,13,34,157,1,10,22,78,111,114,109,97,108,105,122,101,66,66,111,120,80,97,114,97,109,101,116,101,114,18,28,10,14,97,99,114,111,115,115,95,115,112,97,116,105,97,108,24,1,32,1,40,8,58,4,116,114,117,101,18,51,10,12,115,99,97,108,101,95,102,105,108,108,101,114,24,2,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,28,10,14,99,104,97,110,110,101,108,95,115,104,97,114,101,100,24,3,32,1,40,8,58,4,116,114,117,101,18,18,10,3,101,112,115,24,4,32,1,40,2,58,5,49,101,45,49,48,34,230,2,10,17,80,114,105,111,114,66,111,120,80,97,114,97,109,101,116,101,114,18,16,10,8,109,105,110,95,115,105,122,101,24,1,32,1,40,2,18,16,10,8,109,97,120,95,115,105,122,101,24,2,32,1,40,2,18,20,10,12,97,115,112,101,99,116,95,114,97,116,105,111,24,3,32,3,40,2,18,18,10,4,102,108,105,112,24,4,32,1,40,8,58,4,116,114,117,101,18,18,10,4,99,108,105,112,24,5,32,1,40,8,58,4,116,114,117,101,18,16,10,8,118,97,114,105,97,110,99,101,24,6,32,3,40,2,18,16,10,8,105,109,103,95,115,105,122,101,24,7,32,1,40,13,18,13,10,5,105,109,103,95,104,24,8,32,1,40,13,18,13,10,5,105,109,103,95,119,24,9,32,1,40,13,18,12,10,4,115,116,101,112,24,10,32,1,40,2,18,14,10,6,115,116,101,112,95,104,24,11,32,1,40,2,18,14,10,6,115,116,101,112,95,119,24,12,32,1,40,2,18,19,10,6,111,102,102,115,101,116,24,13,32,1,40,2,58,3,48,46,53,18,16,10,8,111,102,102,115,101,116,95,104,24,14,32,3,40,2,18,16,10,8,111,102,102,115,101,116,95,119,24,15,32,3,40,2,18,13,10,5,119,105,100,116,104,24,16,32,3,40,2,18,14,10,6,104,101,105,103,104,116,24,17,32,3,40,2,34,39,10,8,67,111,100,101,84,121,112,101,18,10,10,6,67,79,82,78,69,82,16,1,18,15,10,11,67,69,78,84,69,82,95,83,73,90,69,16,2,34,177,3,10,24,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,19,10,11,110,117,109,95,99,108,97,115,115,101,115,24,1,32,1,40,13,18,28,10,14,115,104,97,114,101,95,108,111,99,97,116,105,111,110,24,2,32,1,40,8,58,4,116,114,117,101,18,30,10,19,98,97,99,107,103,114,111,117,110,100,95,108,97,98,101,108,95,105,100,24,3,32,1,40,5,58,1,48,18,63,10,9,110,109,115,95,112,97,114,97,109,24,4,32,1,40,11,50,44,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,111,110,77,97,120,105,109,117,109,83,117,112,112,114,101,115,115,105,111,110,80,97,114,97,109,101,116,101,114,18,60,10,17,115,97,118,101,95,111,117,116,112,117,116,95,112,97,114,97,109,24,5,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,97,118,101,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,67,10,9,99,111,100,101,95,116,121,112,101,24,6,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,114,105,111,114,66,111,120,80,97,114,97,109,101,116,101,114,46,67,111,100,101,84,121,112,101,58,6,67,79,82,78,69,82,18,41,10,26,118,97,114,105,97,110,99,101,95,101,110,99,111,100,101,100,95,105,110,95,116,97,114,103,101,116,24,8,32,1,40,8,58,5,102,97,108,115,101,18,22,10,10,107,101,101,112,95,116,111,112,95,107,24,7,32,1,40,5,58,2,45,49,18,28,10,20,99,111,110,102,105,100,101,110,99,101,95,116,104,114,101,115,104,111,108,100,24,9,32,1,40,2,18,29,10,15,110,111,114,109,97,108,105,122,101,100,95,98,98,111,120,24,10,32,1,40,8,58,4,116,114,117,101,34,129,1,10,5,68,97,116,117,109,18,16,10,8,99,104,97,110,110,101,108,115,24,1,32,1,40,5,18,14,10,6,104,101,105,103,104,116,24,2,32,1,40,5,18,13,10,5,119,105,100,116,104,24,3,32,1,40,5,18,12,10,4,100,97,116,97,24,4,32,1,40,12,18,13,10,5,108,97,98,101,108,24,5,32,1,40,5,18,18,10,10,102,108,111,97,116,95,100,97,116,97,24,6,32,3,40,2,18,22,10,7,101,110,99,111,100,101,100,24,7,32,1,40,8,58,5,102,97,108,115,101,34,145,2,10,15,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,22,10,4,116,121,112,101,24,1,32,1,40,9,58,8,99,111,110,115,116,97,110,116,18,16,10,5,118,97,108,117,101,24,2,32,1,40,2,58,1,48,18,14,10,3,109,105,110,24,3,32,1,40,2,58,1,48,18,14,10,3,109,97,120,24,4,32,1,40,2,58,1,49,18,15,10,4,109,101,97,110,24,5,32,1,40,2,58,1,48,18,14,10,3,115,116,100,24,6,32,1,40,2,58,1,49,18,18,10,6,115,112,97,114,115,101,24,7,32,1,40,5,58,2,45,49,18,73,10,13,118,97,114,105,97,110,99,101,95,110,111,114,109,24,8,32,1,40,14,50,42,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,46,86,97,114,105,97,110,99,101,78,111,114,109,58,6,70,65,78,95,73,78,34,52,10,12,86,97,114,105,97,110,99,101,78,111,114,109,18,10,10,6,70,65,78,95,73,78,16,0,18,11,10,7,70,65,78,95,79,85,84,16,1,18,11,10,7,65,86,69,82,65,71,69,16,2,34,170,2,10,12,78,101,116,80,97,114,97,109,101,116,101,114,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,13,10,5,105,110,112,117,116,24,3,32,3,40,9,18,44,10,11,105,110,112,117,116,95,115,104,97,112,101,24,8,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,18,17,10,9,105,110,112,117,116,95,100,105,109,24,4,32,3,40,5,18,29,10,14,102,111,114,99,101,95,98,97,99,107,119,97,114,100,24,5,32,1,40,8,58,5,102,97,108,115,101,18,37,10,5,115,116,97,116,101,24,6,32,1,40,11,50,22,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,18,25,10,10,100,101,98,117,103,95,105,110,102,111,24,7,32,1,40,8,58,5,102,97,108,115,101,18,43,10,5,108,97,121,101,114,24,100,32,3,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,97,121,101,114,80,97,114,97,109,101,116,101,114,18,46,10,6,108,97,121,101,114,115,24,2,32,3,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,34,218,10,10,15,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,18,11,10,3,110,101,116,24,24,32,1,40,9,18,45,10,9,110,101,116,95,112,97,114,97,109,24,25,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,80,97,114,97,109,101,116,101,114,18,17,10,9,116,114,97,105,110,95,110,101,116,24,1,32,1,40,9,18,16,10,8,116,101,115,116,95,110,101,116,24,2,32,3,40,9,18,51,10,15,116,114,97,105,110,95,110,101,116,95,112,97,114,97,109,24,21,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,80,97,114,97,109,101,116,101,114,18,50,10,14,116,101,115,116,95,110,101,116,95,112,97,114,97,109,24,22,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,80,97,114,97,109,101,116,101,114,18,43,10,11,116,114,97,105,110,95,115,116,97,116,101,24,26,32,1,40,11,50,22,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,18,42,10,10,116,101,115,116,95,115,116,97,116,101,24,27,32,3,40,11,50,22,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,18,17,10,9,116,101,115,116,95,105,116,101,114,24,3,32,3,40,5,18,24,10,13,116,101,115,116,95,105,110,116,101,114,118,97,108,24,4,32,1,40,5,58,1,48,18,32,10,17,116,101,115,116,95,99,111,109,112,117,116,101,95,108,111,115,115,24,19,32,1,40,8,58,5,102,97,108,115,101,18,33,10,19,116,101,115,116,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,24,32,32,1,40,8,58,4,116,114,117,101,18,15,10,7,98,97,115,101,95,108,114,24,5,32,1,40,2,18,15,10,7,100,105,115,112,108,97,121,24,6,32,1,40,5,18,23,10,12,97,118,101,114,97,103,101,95,108,111,115,115,24,33,32,1,40,5,58,1,49,18,16,10,8,109,97,120,95,105,116,101,114,24,7,32,1,40,5,18,20,10,9,105,116,101,114,95,115,105,122,101,24,36,32,1,40,5,58,1,49,18,17,10,9,108,114,95,112,111,108,105,99,121,24,8,32,1,40,9,18,13,10,5,103,97,109,109,97,24,9,32,1,40,2,18,13,10,5,112,111,119,101,114,24,10,32,1,40,2,18,16,10,8,109,111,109,101,110,116,117,109,24,11,32,1,40,2,18,20,10,12,119,101,105,103,104,116,95,100,101,99,97,121,24,12,32,1,40,2,18,31,10,19,114,101,103,117,108,97,114,105,122,97,116,105,111,110,95,116,121,112,101,24,29,32,1,40,9,58,2,76,50,18,16,10,8,115,116,101,112,115,105,122,101,24,13,32,1,40,5,18,17,10,9,115,116,101,112,118,97,108,117,101,24,34,32,3,40,5,18,26,10,14,99,108,105,112,95,103,114,97,100,105,101,110,116,115,24,35,32,1,40,2,58,2,45,49,18,19,10,8,115,110,97,112,115,104,111,116,24,14,32,1,40,5,58,1,48,18,23,10,15,115,110,97,112,115,104,111,116,95,112,114,101,102,105,120,24,15,32,1,40,9,18,28,10,13,115,110,97,112,115,104,111,116,95,100,105,102,102,24,16,32,1,40,8,58,5,102,97,108,115,101,18,82,10,15,115,110,97,112,115,104,111,116,95,102,111,114,109,97,116,24,37,32,1,40,14,50,44,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,46,83,110,97,112,115,104,111,116,70,111,114,109,97,116,58,11,66,73,78,65,82,89,80,82,79,84,79,18,66,10,11,115,111,108,118,101,114,95,109,111,100,101,24,17,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,46,83,111,108,118,101,114,77,111,100,101,58,3,71,80,85,18,20,10,9,100,101,118,105,99,101,95,105,100,24,18,32,1,40,5,58,1,48,18,23,10,11,114,97,110,100,111,109,95,115,101,101,100,24,20,32,1,40,3,58,2,45,49,18,17,10,4,116,121,112,101,24,40,32,1,40,9,58,3,83,71,68,18,20,10,5,100,101,108,116,97,24,31,32,1,40,2,58,5,49,101,45,48,56,18,24,10,9,109,111,109,101,110,116,117,109,50,24,39,32,1,40,2,58,5,48,46,57,57,57,18,23,10,9,114,109,115,95,100,101,99,97,121,24,38,32,1,40,2,58,4,48,46,57,57,18,25,10,10,100,101,98,117,103,95,105,110,102,111,24,23,32,1,40,8,58,5,102,97,108,115,101,18,34,10,20,115,110,97,112,115,104,111,116,95,97,102,116,101,114,95,116,114,97,105,110,24,28,32,1,40,8,58,4,116,114,117,101,18,66,10,11,115,111,108,118,101,114,95,116,121,112,101,24,30,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,46,83,111,108,118,101,114,84,121,112,101,58,3,83,71,68,34,43,10,14,83,110,97,112,115,104,111,116,70,111,114,109,97,116,18,8,10,4,72,68,70,53,16,0,18,15,10,11,66,73,78,65,82,89,80,82,79,84,79,16,1,34,30,10,10,83,111,108,118,101,114,77,111,100,101,18,7,10,3,67,80,85,16,0,18,7,10,3,71,80,85,16,1,34,85,10,10,83,111,108,118,101,114,84,121,112,101,18,7,10,3,83,71,68,16,0,18,12,10,8,78,69,83,84,69,82,79,86,16,1,18,11,10,7,65,68,65,71,82,65,68,16,2,18,11,10,7,82,77,83,80,82,79,80,16,3,18,12,10,8,65,68,65,68,69,76,84,65,16,4,18,8,10,4,65,68,65,77,16,5,34,115,10,11,83,111,108,118,101,114,83,116,97,116,101,18,12,10,4,105,116,101,114,24,1,32,1,40,5,18,19,10,11,108,101,97,114,110,101,100,95,110,101,116,24,2,32,1,40,9,18,40,10,7,104,105,115,116,111,114,121,24,3,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,18,23,10,12,99,117,114,114,101,110,116,95,115,116,101,112,24,4,32,1,40,5,58,1,48,34,85,10,8,78,101,116,83,116,97,116,101,18,40,10,5,112,104,97,115,101,24,1,32,1,40,14,50,19,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,104,97,115,101,58,4,84,69,83,84,18,16,10,5,108,101,118,101,108,24,2,32,1,40,5,58,1,48,18,13,10,5,115,116,97,103,101,24,3,32,3,40,9,34,122,10,12,78,101,116,83,116,97,116,101,82,117,108,101,18,34,10,5,112,104,97,115,101,24,1,32,1,40,14,50,19,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,104,97,115,101,18,17,10,9,109,105,110,95,108,101,118,101,108,24,2,32,1,40,5,18,17,10,9,109,97,120,95,108,101,118,101,108,24,3,32,1,40,5,18,13,10,5,115,116,97,103,101,24,4,32,3,40,9,18,17,10,9,110,111,116,95,115,116,97,103,101,24,5,32,3,40,9,34,170,1,10,9,80,97,114,97,109,83,112,101,99,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,56,10,10,115,104,97,114,101,95,109,111,100,101,24,2,32,1,40,14,50,36,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,97,114,97,109,83,112,101,99,46,68,105,109,67,104,101,99,107,77,111,100,101,18,18,10,7,108,114,95,109,117,108,116,24,3,32,1,40,2,58,1,49,18,21,10,10,100,101,99,97,121,95,109,117,108,116,24,4,32,1,40,2,58,1,49,34,42,10,12,68,105,109,67,104,101,99,107,77,111,100,101,18,10,10,6,83,84,82,73,67,84,16,0,18,14,10,10,80,69,82,77,73,83,83,73,86,69,16,1,34,163,26,10,14,76,97,121,101,114,80,97,114,97,109,101,116,101,114,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,12,10,4,116,121,112,101,24,2,32,1,40,9,18,14,10,6,98,111,116,116,111,109,24,3,32,3,40,9,18,11,10,3,116,111,112,24,4,32,3,40,9,18,34,10,5,112,104,97,115,101,24,10,32,1,40,14,50,19,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,104,97,115,101,18,19,10,11,108,111,115,115,95,119,101,105,103,104,116,24,5,32,3,40,2,18,38,10,5,112,97,114,97,109,24,6,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,97,114,97,109,83,112,101,99,18,38,10,5,98,108,111,98,115,24,7,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,18,22,10,14,112,114,111,112,97,103,97,116,101,95,100,111,119,110,24,11,32,3,40,8,18,43,10,7,105,110,99,108,117,100,101,24,8,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,82,117,108,101,18,43,10,7,101,120,99,108,117,100,101,24,9,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,82,117,108,101,18,62,10,15,116,114,97,110,115,102,111,114,109,95,112,97,114,97,109,24,100,32,1,40,11,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,114,97,110,115,102,111,114,109,97,116,105,111,110,80,97,114,97,109,101,116,101,114,18,47,10,10,108,111,115,115,95,112,97,114,97,109,24,101,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,111,115,115,80,97,114,97,109,101,116,101,114,18,55,10,14,97,99,99,117,114,97,99,121,95,112,97,114,97,109,24,102,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,65,99,99,117,114,97,99,121,80,97,114,97,109,101,116,101,114,18,51,10,12,97,114,103,109,97,120,95,112,97,114,97,109,24,103,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,65,114,103,77,97,120,80,97,114,97,109,101,116,101,114,18,59,10,16,98,97,116,99,104,95,110,111,114,109,95,112,97,114,97,109,24,139,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,97,116,99,104,78,111,114,109,80,97,114,97,109,101,116,101,114,18,48,10,10,98,105,97,115,95,112,97,114,97,109,24,141,1,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,105,97,115,80,97,114,97,109,101,116,101,114,18,51,10,12,99,111,110,99,97,116,95,112,97,114,97,109,24,104,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,99,97,116,80,97,114,97,109,101,116,101,114,18,70,10,22,99,111,110,116,114,97,115,116,105,118,101,95,108,111,115,115,95,112,97,114,97,109,24,105,32,1,40,11,50,38,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,61,10,17,99,111,110,118,111,108,117,116,105,111,110,95,112,97,114,97,109,24,106,32,1,40,11,50,34,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,18,48,10,10,99,114,111,112,95,112,97,114,97,109,24,144,1,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,114,111,112,80,97,114,97,109,101,116,101,114,18,47,10,10,100,97,116,97,95,112,97,114,97,109,24,107,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,97,116,97,80,97,114,97,109,101,116,101,114,18,71,10,22,100,101,116,101,99,116,105,111,110,95,111,117,116,112,117,116,95,112,97,114,97,109,24,147,1,32,1,40,11,50,38,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,53,10,13,100,114,111,112,111,117,116,95,112,97,114,97,109,24,108,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,114,111,112,111,117,116,80,97,114,97,109,101,116,101,114,18,58,10,16,100,117,109,109,121,95,100,97,116,97,95,112,97,114,97,109,24,109,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,117,109,109,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,53,10,13,101,108,116,119,105,115,101,95,112,97,114,97,109,24,110,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,18,46,10,9,101,108,117,95,112,97,114,97,109,24,140,1,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,76,85,80,97,114,97,109,101,116,101,114,18,50,10,11,101,109,98,101,100,95,112,97,114,97,109,24,137,1,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,109,98,101,100,80,97,114,97,109,101,116,101,114,18,45,10,9,101,120,112,95,112,97,114,97,109,24,111,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,120,112,80,97,114,97,109,101,116,101,114,18,54,10,13,102,108,97,116,116,101,110,95,112,97,114,97,109,24,135,1,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,108,97,116,116,101,110,80,97,114,97,109,101,116,101,114,18,56,10,15,104,100,102,53,95,100,97,116,97,95,112,97,114,97,109,24,112,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,68,97,116,97,80,97,114,97,109,101,116,101,114,18,60,10,17,104,100,102,53,95,111,117,116,112,117,116,95,112,97,114,97,109,24,113,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,58,10,16,104,105,110,103,101,95,108,111,115,115,95,112,97,114,97,109,24,114,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,58,10,16,105,109,97,103,101,95,100,97,116,97,95,112,97,114,97,109,24,115,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,109,97,103,101,68,97,116,97,80,97,114,97,109,101,116,101,114,18,64,10,19,105,110,102,111,103,97,105,110,95,108,111,115,115,95,112,97,114,97,109,24,116,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,102,111,103,97,105,110,76,111,115,115,80,97,114,97,109,101,116,101,114,18,64,10,19,105,110,110,101,114,95,112,114,111,100,117,99,116,95,112,97,114,97,109,24,117,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,110,101,114,80,114,111,100,117,99,116,80,97,114,97,109,101,116,101,114,18,50,10,11,105,110,112,117,116,95,112,97,114,97,109,24,143,1,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,112,117,116,80,97,114,97,109,101,116,101,114,18,46,10,9,108,111,103,95,112,97,114,97,109,24,134,1,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,111,103,80,97,114,97,109,101,116,101,114,18,45,10,9,108,114,110,95,112,97,114,97,109,24,118,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,82,78,80,97,114,97,109,101,116,101,114,18,60,10,17,109,101,109,111,114,121,95,100,97,116,97,95,112,97,114,97,109,24,119,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,77,101,109,111,114,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,45,10,9,109,118,110,95,112,97,114,97,109,24,120,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,77,86,78,80,97,114,97,109,101,116,101,114,18,57,10,10,110,111,114,109,95,112,97,114,97,109,24,149,1,32,1,40,11,50,36,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,111,114,109,97,108,105,122,101,66,66,111,120,80,97,114,97,109,101,116,101,114,18,54,10,13,112,101,114,109,117,116,101,95,112,97,114,97,109,24,148,1,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,101,114,109,117,116,101,80,97,114,97,109,101,116,101,114,18,58,10,15,112,97,114,97,109,101,116,101,114,95,112,97,114,97,109,24,145,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,97,114,97,109,101,116,101,114,80,97,114,97,109,101,116,101,114,18,53,10,13,112,111,111,108,105,110,103,95,112,97,114,97,109,24,121,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,49,10,11,112,111,119,101,114,95,112,97,114,97,109,24,122,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,119,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,112,114,101,108,117,95,112,97,114,97,109,24,131,1,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,82,101,76,85,80,97,114,97,109,101,116,101,114,18,57,10,15,112,114,105,111,114,95,98,111,120,95,112,97,114,97,109,24,150,1,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,114,105,111,114,66,111,120,80,97,114,97,109,101,116,101,114,18,56,10,14,112,114,111,112,111,115,97,108,95,112,97,114,97,109,24,201,1,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,114,111,112,111,115,97,108,80,97,114,97,109,101,116,101,114,18,65,10,19,112,115,114,111,105,95,112,111,111,108,105,110,103,95,112,97,114,97,109,24,145,78,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,83,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,52,10,12,112,121,116,104,111,110,95,112,97,114,97,109,24,130,1,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,121,116,104,111,110,80,97,114,97,109,101,116,101,114,18,58,10,15,114,101,99,117,114,114,101,110,116,95,112,97,114,97,109,24,146,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,99,117,114,114,101,110,116,80,97,114,97,109,101,116,101,114,18,58,10,15,114,101,100,117,99,116,105,111,110,95,112,97,114,97,109,24,136,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,100,117,99,116,105,111,110,80,97,114,97,109,101,116,101,114,18,47,10,10,114,101,108,117,95,112,97,114,97,109,24,123,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,76,85,80,97,114,97,109,101,116,101,114,18,54,10,13,114,101,115,104,97,112,101,95,112,97,114,97,109,24,133,1,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,115,104,97,112,101,80,97,114,97,109,101,116,101,114,18,63,10,17,114,111,105,95,112,111,111,108,105,110,103,95,112,97,114,97,109,24,215,199,248,3,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,50,10,11,115,99,97,108,101,95,112,97,114,97,109,24,142,1,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,99,97,108,101,80,97,114,97,109,101,116,101,114,18,53,10,13,115,105,103,109,111,105,100,95,112,97,114,97,109,24,124,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,18,53,10,13,115,111,102,116,109,97,120,95,112,97,114,97,109,24,125,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,18,46,10,9,115,112,112,95,112,97,114,97,109,24,132,1,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,80,80,80,97,114,97,109,101,116,101,114,18,49,10,11,115,108,105,99,101,95,112,97,114,97,109,24,126,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,108,105,99,101,80,97,114,97,109,101,116,101,114,18,47,10,10,116,97,110,104,95,112,97,114,97,109,24,127,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,97,110,72,80,97,114,97,109,101,116,101,114,18,58,10,15,116,104,114,101,115,104,111,108,100,95,112,97,114,97,109,24,128,1,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,104,114,101,115,104,111,108,100,80,97,114,97,109,101,116,101,114,18,48,10,10,116,105,108,101,95,112,97,114,97,109,24,138,1,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,105,108,101,80,97,114,97,109,101,116,101,114,18,61,10,17,119,105,110,100,111,119,95,100,97,116,97,95,112,97,114,97,109,24,129,1,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,87,105,110,100,111,119,68,97,116,97,80,97,114,97,109,101,116,101,114,34,182,1,10,23,84,114,97,110,115,102,111,114,109,97,116,105,111,110,80,97,114,97,109,101,116,101,114,18,16,10,5,115,99,97,108,101,24,1,32,1,40,2,58,1,49,18,21,10,6,109,105,114,114,111,114,24,2,32,1,40,8,58,5,102,97,108,115,101,18,20,10,9,99,114,111,112,95,115,105,122,101,24,3,32,1,40,13,58,1,48,18,17,10,9,109,101,97,110,95,102,105,108,101,24,4,32,1,40,9,18,18,10,10,109,101,97,110,95,118,97,108,117,101,24,5,32,3,40,2,18,26,10,11,102,111,114,99,101,95,99,111,108,111,114,24,6,32,1,40,8,58,5,102,97,108,115,101,18,25,10,10,102,111,114,99,101,95,103,114,97,121,24,7,32,1,40,8,58,5,102,97,108,115,101,34,201,1,10,13,76,111,115,115,80,97,114,97,109,101,116,101,114,18,20,10,12,105,103,110,111,114,101,95,108,97,98,101,108,24,1,32,1,40,5,18,75,10,13,110,111,114,109,97,108,105,122,97,116,105,111,110,24,3,32,1,40,14,50,45,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,111,115,115,80,97,114,97,109,101,116,101,114,46,78,111,114,109,97,108,105,122,97,116,105,111,110,77,111,100,101,58,5,86,65,76,73,68,18,17,10,9,110,111,114,109,97,108,105,122,101,24,2,32,1,40,8,34,66,10,17,78,111,114,109,97,108,105,122,97,116,105,111,110,77,111,100,101,18,8,10,4,70,85,76,76,16,0,18,9,10,5,86,65,76,73,68,16,1,18,14,10,10,66,65,84,67,72,95,83,73,90,69,16,2,18,8,10,4,78,79,78,69,16,3,34,76,10,17,65,99,99,117,114,97,99,121,80,97,114,97,109,101,116,101,114,18,16,10,5,116,111,112,95,107,24,1,32,1,40,13,58,1,49,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,49,18,20,10,12,105,103,110,111,114,101,95,108,97,98,101,108,24,3,32,1,40,5,34,77,10,15,65,114,103,77,97,120,80,97,114,97,109,101,116,101,114,18,26,10,11,111,117,116,95,109,97,120,95,118,97,108,24,1,32,1,40,8,58,5,102,97,108,115,101,18,16,10,5,116,111,112,95,107,24,2,32,1,40,13,58,1,49,18,12,10,4,97,120,105,115,24,3,32,1,40,5,34,57,10,15,67,111,110,99,97,116,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,49,18,21,10,10,99,111,110,99,97,116,95,100,105,109,24,1,32,1,40,13,58,1,49,34,106,10,18,66,97,116,99,104,78,111,114,109,80,97,114,97,109,101,116,101,114,18,24,10,16,117,115,101,95,103,108,111,98,97,108,95,115,116,97,116,115,24,1,32,1,40,8,18,38,10,23,109,111,118,105,110,103,95,97,118,101,114,97,103,101,95,102,114,97,99,116,105,111,110,24,2,32,1,40,2,58,5,48,46,57,57,57,18,18,10,3,101,112,115,24,3,32,1,40,2,58,5,49,101,45,48,53,34,100,10,13,66,105,97,115,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,49,18,19,10,8,110,117,109,95,97,120,101,115,24,2,32,1,40,5,58,1,49,18,45,10,6,102,105,108,108,101,114,24,3,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,34,76,10,24,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,17,10,6,109,97,114,103,105,110,24,1,32,1,40,2,58,1,49,18,29,10,14,108,101,103,97,99,121,95,118,101,114,115,105,111,110,24,2,32,1,40,8,58,5,102,97,108,115,101,34,145,4,10,20,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,18,18,10,10,110,117,109,95,111,117,116,112,117,116,24,1,32,1,40,13,18,23,10,9,98,105,97,115,95,116,101,114,109,24,2,32,1,40,8,58,4,116,114,117,101,18,11,10,3,112,97,100,24,3,32,3,40,13,18,19,10,11,107,101,114,110,101,108,95,115,105,122,101,24,4,32,3,40,13,18,14,10,6,115,116,114,105,100,101,24,6,32,3,40,13,18,16,10,8,100,105,108,97,116,105,111,110,24,18,32,3,40,13,18,16,10,5,112,97,100,95,104,24,9,32,1,40,13,58,1,48,18,16,10,5,112,97,100,95,119,24,10,32,1,40,13,58,1,48,18,16,10,8,107,101,114,110,101,108,95,104,24,11,32,1,40,13,18,16,10,8,107,101,114,110,101,108,95,119,24,12,32,1,40,13,18,16,10,8,115,116,114,105,100,101,95,104,24,13,32,1,40,13,18,16,10,8,115,116,114,105,100,101,95,119,24,14,32,1,40,13,18,16,10,5,103,114,111,117,112,24,5,32,1,40,13,58,1,49,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,7,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,8,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,66,10,6,101,110,103,105,110,101,24,15,32,1,40,14,50,41,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,18,15,10,4,97,120,105,115,24,16,32,1,40,5,58,1,49,18,30,10,15,102,111,114,99,101,95,110,100,95,105,109,50,99,111,108,24,17,32,1,40,8,58,5,102,97,108,115,101,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,48,10,13,67,114,111,112,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,50,18,14,10,6,111,102,102,115,101,116,24,2,32,3,40,13,34,171,2,10,13,68,97,116,97,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,18,18,10,10,98,97,116,99,104,95,115,105,122,101,24,4,32,1,40,13,18,20,10,9,114,97,110,100,95,115,107,105,112,24,7,32,1,40,13,58,1,48,18,56,10,7,98,97,99,107,101,110,100,24,8,32,1,40,14,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,97,116,97,80,97,114,97,109,101,116,101,114,46,68,66,58,7,76,69,86,69,76,68,66,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,17,10,9,109,101,97,110,95,102,105,108,101,24,3,32,1,40,9,18,20,10,9,99,114,111,112,95,115,105,122,101,24,5,32,1,40,13,58,1,48,18,21,10,6,109,105,114,114,111,114,24,6,32,1,40,8,58,5,102,97,108,115,101,18,34,10,19,102,111,114,99,101,95,101,110,99,111,100,101,100,95,99,111,108,111,114,24,9,32,1,40,8,58,5,102,97,108,115,101,18,19,10,8,112,114,101,102,101,116,99,104,24,10,32,1,40,13,58,1,52,34,27,10,2,68,66,18,11,10,7,76,69,86,69,76,68,66,16,0,18,8,10,4,76,77,68,66,16,1,34,91,10,30,78,111,110,77,97,120,105,109,117,109,83,117,112,112,114,101,115,115,105,111,110,80,97,114,97,109,101,116,101,114,18,26,10,13,110,109,115,95,116,104,114,101,115,104,111,108,100,24,1,32,1,40,2,58,3,48,46,51,18,13,10,5,116,111,112,95,107,24,2,32,1,40,5,18,14,10,3,101,116,97,24,3,32,1,40,2,58,1,49,34,170,1,10,19,83,97,118,101,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,24,10,16,111,117,116,112,117,116,95,100,105,114,101,99,116,111,114,121,24,1,32,1,40,9,18,26,10,18,111,117,116,112,117,116,95,110,97,109,101,95,112,114,101,102,105,120,24,2,32,1,40,9,18,21,10,13,111,117,116,112,117,116,95,102,111,114,109,97,116,24,3,32,1,40,9,18,22,10,14,108,97,98,101,108,95,109,97,112,95,102,105,108,101,24,4,32,1,40,9,18,22,10,14,110,97,109,101,95,115,105,122,101,95,102,105,108,101,24,5,32,1,40,9,18,22,10,14,110,117,109,95,116,101,115,116,95,105,109,97,103,101,24,6,32,1,40,13,34,73,10,16,68,114,111,112,111,117,116,80,97,114,97,109,101,116,101,114,18,26,10,13,100,114,111,112,111,117,116,95,114,97,116,105,111,24,1,32,1,40,2,58,3,48,46,53,18,25,10,11,115,99,97,108,101,95,116,114,97,105,110,24,2,32,1,40,8,58,4,116,114,117,101,34,174,1,10,18,68,117,109,109,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,50,10,11,100,97,116,97,95,102,105,108,108,101,114,24,1,32,3,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,38,10,5,115,104,97,112,101,24,6,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,18,11,10,3,110,117,109,24,2,32,3,40,13,18,16,10,8,99,104,97,110,110,101,108,115,24,3,32,3,40,13,18,14,10,6,104,101,105,103,104,116,24,4,32,3,40,13,18,13,10,5,119,105,100,116,104,24,5,32,3,40,13,34,172,1,10,16,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,18,64,10,9,111,112,101,114,97,116,105,111,110,24,1,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,46,69,108,116,119,105,115,101,79,112,58,3,83,85,77,18,13,10,5,99,111,101,102,102,24,2,32,3,40,2,18,30,10,16,115,116,97,98,108,101,95,112,114,111,100,95,103,114,97,100,24,3,32,1,40,8,58,4,116,114,117,101,34,39,10,9,69,108,116,119,105,115,101,79,112,18,8,10,4,80,82,79,68,16,0,18,7,10,3,83,85,77,16,1,18,7,10,3,77,65,88,16,2,34,32,10,12,69,76,85,80,97,114,97,109,101,116,101,114,18,16,10,5,97,108,112,104,97,24,1,32,1,40,2,58,1,49,34,186,1,10,14,69,109,98,101,100,80,97,114,97,109,101,116,101,114,18,18,10,10,110,117,109,95,111,117,116,112,117,116,24,1,32,1,40,13,18,17,10,9,105,110,112,117,116,95,100,105,109,24,2,32,1,40,13,18,23,10,9,98,105,97,115,95,116,101,114,109,24,3,32,1,40,8,58,4,116,114,117,101,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+389182);allocate([4,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,5,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,34,68,10,12,69,120,112,80,97,114,97,109,101,116,101,114,18,16,10,4,98,97,115,101,24,1,32,1,40,2,58,2,45,49,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,16,10,5,115,104,105,102,116,24,3,32,1,40,2,58,1,48,34,57,10,16,70,108,97,116,116,101,110,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,49,18,20,10,8,101,110,100,95,97,120,105,115,24,2,32,1,40,5,58,2,45,49,34,79,10,17,72,68,70,53,68,97,116,97,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,18,18,10,10,98,97,116,99,104,95,115,105,122,101,24,2,32,1,40,13,18,22,10,7,115,104,117,102,102,108,101,24,3,32,1,40,8,58,5,102,97,108,115,101,34,40,10,19,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,17,10,9,102,105,108,101,95,110,97,109,101,24,1,32,1,40,9,34,101,10,18,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,55,10,4,110,111,114,109,24,1,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,46,78,111,114,109,58,2,76,49,34,22,10,4,78,111,114,109,18,6,10,2,76,49,16,1,18,6,10,2,76,50,16,2,34,151,2,10,18,73,109,97,103,101,68,97,116,97,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,18,21,10,10,98,97,116,99,104,95,115,105,122,101,24,4,32,1,40,13,58,1,49,18,20,10,9,114,97,110,100,95,115,107,105,112,24,7,32,1,40,13,58,1,48,18,22,10,7,115,104,117,102,102,108,101,24,8,32,1,40,8,58,5,102,97,108,115,101,18,21,10,10,110,101,119,95,104,101,105,103,104,116,24,9,32,1,40,13,58,1,48,18,20,10,9,110,101,119,95,119,105,100,116,104,24,10,32,1,40,13,58,1,48,18,22,10,8,105,115,95,99,111,108,111,114,24,11,32,1,40,8,58,4,116,114,117,101,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,17,10,9,109,101,97,110,95,102,105,108,101,24,3,32,1,40,9,18,20,10,9,99,114,111,112,95,115,105,122,101,24,5,32,1,40,13,58,1,48,18,21,10,6,109,105,114,114,111,114,24,6,32,1,40,8,58,5,102,97,108,115,101,18,21,10,11,114,111,111,116,95,102,111,108,100,101,114,24,12,32,1,40,9,58,0,34,39,10,21,73,110,102,111,103,97,105,110,76,111,115,115,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,34,217,1,10,21,73,110,110,101,114,80,114,111,100,117,99,116,80,97,114,97,109,101,116,101,114,18,18,10,10,110,117,109,95,111,117,116,112,117,116,24,1,32,1,40,13,18,23,10,9,98,105,97,115,95,116,101,114,109,24,2,32,1,40,8,58,4,116,114,117,101,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,3,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,4,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,5,32,1,40,5,58,1,49,18,24,10,9,116,114,97,110,115,112,111,115,101,24,6,32,1,40,8,58,5,102,97,108,115,101,34,56,10,14,73,110,112,117,116,80,97,114,97,109,101,116,101,114,18,38,10,5,115,104,97,112,101,24,1,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,34,68,10,12,76,111,103,80,97,114,97,109,101,116,101,114,18,16,10,4,98,97,115,101,24,1,32,1,40,2,58,2,45,49,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,16,10,5,115,104,105,102,116,24,3,32,1,40,2,58,1,48,34,198,2,10,12,76,82,78,80,97,114,97,109,101,116,101,114,18,21,10,10,108,111,99,97,108,95,115,105,122,101,24,1,32,1,40,13,58,1,53,18,16,10,5,97,108,112,104,97,24,2,32,1,40,2,58,1,49,18,18,10,4,98,101,116,97,24,3,32,1,40,2,58,4,48,46,55,53,18,75,10,11,110,111,114,109,95,114,101,103,105,111,110,24,4,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,82,78,80,97,114,97,109,101,116,101,114,46,78,111,114,109,82,101,103,105,111,110,58,15,65,67,82,79,83,83,95,67,72,65,78,78,69,76,83,18,12,10,1,107,24,5,32,1,40,2,58,1,49,18,58,10,6,101,110,103,105,110,101,24,6,32,1,40,14,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,82,78,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,53,10,10,78,111,114,109,82,101,103,105,111,110,18,19,10,15,65,67,82,79,83,83,95,67,72,65,78,78,69,76,83,16,0,18,18,10,14,87,73,84,72,73,78,95,67,72,65,78,78,69,76,16,1,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,90,10,19,77,101,109,111,114,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,18,10,10,98,97,116,99,104,95,115,105,122,101,24,1,32,1,40,13,18,16,10,8,99,104,97,110,110,101,108,115,24,2,32,1,40,13,18,14,10,6,104,101,105,103,104,116,24,3,32,1,40,13,18,13,10,5,119,105,100,116,104,24,4,32,1,40,13,34,100,10,12,77,86,78,80,97,114,97,109,101,116,101,114,18,32,10,18,110,111,114,109,97,108,105,122,101,95,118,97,114,105,97,110,99,101,24,1,32,1,40,8,58,4,116,114,117,101,18,30,10,15,97,99,114,111,115,115,95,99,104,97,110,110,101,108,115,24,2,32,1,40,8,58,5,102,97,108,115,101,18,18,10,3,101,112,115,24,3,32,1,40,2,58,5,49,101,45,48,57,34,60,10,18,80,97,114,97,109,101,116,101,114,80,97,114,97,109,101,116,101,114,18,38,10,5,115,104,97,112,101,24,1,32,1,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,34,201,3,10,16,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,60,10,4,112,111,111,108,24,1,32,1,40,14,50,41,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,46,80,111,111,108,77,101,116,104,111,100,58,3,77,65,88,18,14,10,3,112,97,100,24,4,32,1,40,13,58,1,48,18,16,10,5,112,97,100,95,104,24,9,32,1,40,13,58,1,48,18,16,10,5,112,97,100,95,119,24,10,32,1,40,13,58,1,48,18,19,10,11,107,101,114,110,101,108,95,115,105,122,101,24,2,32,1,40,13,18,16,10,8,107,101,114,110,101,108,95,104,24,5,32,1,40,13,18,16,10,8,107,101,114,110,101,108,95,119,24,6,32,1,40,13,18,17,10,6,115,116,114,105,100,101,24,3,32,1,40,13,58,1,49,18,16,10,8,115,116,114,105,100,101,95,104,24,7,32,1,40,13,18,16,10,8,115,116,114,105,100,101,95,119,24,8,32,1,40,13,18,62,10,6,101,110,103,105,110,101,24,11,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,18,29,10,14,103,108,111,98,97,108,95,112,111,111,108,105,110,103,24,12,32,1,40,8,58,5,102,97,108,115,101,18,23,10,9,99,101,105,108,95,109,111,100,101,24,13,32,1,40,8,58,4,116,114,117,101,34,46,10,10,80,111,111,108,77,101,116,104,111,100,18,7,10,3,77,65,88,16,0,18,7,10,3,65,86,69,16,1,18,14,10,10,83,84,79,67,72,65,83,84,73,67,16,2,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,70,10,14,80,111,119,101,114,80,97,114,97,109,101,116,101,114,18,16,10,5,112,111,119,101,114,24,1,32,1,40,2,58,1,49,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,16,10,5,115,104,105,102,116,24,3,32,1,40,2,58,1,48,34,103,10,15,80,121,116,104,111,110,80,97,114,97,109,101,116,101,114,18,14,10,6,109,111,100,117,108,101,24,1,32,1,40,9,18,13,10,5,108,97,121,101,114,24,2,32,1,40,9,18,19,10,9,112,97,114,97,109,95,115,116,114,24,3,32,1,40,9,58,0,18,32,10,17,115,104,97,114,101,95,105,110,95,112,97,114,97,108,108,101,108,24,4,32,1,40,8,58,5,102,97,108,115,101,34,206,1,10,18,82,101,99,117,114,114,101,110,116,80,97,114,97,109,101,116,101,114,18,21,10,10,110,117,109,95,111,117,116,112,117,116,24,1,32,1,40,13,58,1,48,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,2,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,3,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,25,10,10,100,101,98,117,103,95,105,110,102,111,24,4,32,1,40,8,58,5,102,97,108,115,101,18,28,10,13,101,120,112,111,115,101,95,104,105,100,100,101,110,24,5,32,1,40,8,58,5,102,97,108,115,101,34,180,1,10,18,82,101,100,117,99,116,105,111,110,80,97,114,97,109,101,116,101,114,18,68,10,9,111,112,101,114,97,116,105,111,110,24,1,32,1,40,14,50,44,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,100,117,99,116,105,111,110,80,97,114,97,109,101,116,101,114,46,82,101,100,117,99,116,105,111,110,79,112,58,3,83,85,77,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,48,18,16,10,5,99,111,101,102,102,24,3,32,1,40,2,58,1,49,34,53,10,11,82,101,100,117,99,116,105,111,110,79,112,18,7,10,3,83,85,77,16,1,18,8,10,4,65,83,85,77,16,2,18,9,10,5,83,85,77,83,81,16,3,18,8,10,4,77,69,65,78,16,4,34,148,1,10,13,82,101,76,85,80,97,114,97,109,101,116,101,114,18,25,10,14,110,101,103,97,116,105,118,101,95,115,108,111,112,101,24,1,32,1,40,2,58,1,48,18,59,10,6,101,110,103,105,110,101,24,2,32,1,40,14,50,34,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,76,85,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,97,10,16,82,101,115,104,97,112,101,80,97,114,97,109,101,116,101,114,18,38,10,5,115,104,97,112,101,24,1,32,1,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,83,104,97,112,101,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,48,18,20,10,8,110,117,109,95,97,120,101,115,24,3,32,1,40,5,58,2,45,49,34,179,1,10,14,83,99,97,108,101,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,49,18,19,10,8,110,117,109,95,97,120,101,115,24,2,32,1,40,5,58,1,49,18,45,10,6,102,105,108,108,101,114,24,3,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,24,10,9,98,105,97,115,95,116,101,114,109,24,4,32,1,40,8,58,5,102,97,108,115,101,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,5,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,34,127,10,16,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,18,62,10,6,101,110,103,105,110,101,24,1,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,76,10,14,83,108,105,99,101,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,3,32,1,40,5,58,1,49,18,19,10,11,115,108,105,99,101,95,112,111,105,110,116,24,2,32,3,40,13,18,20,10,9,115,108,105,99,101,95,100,105,109,24,1,32,1,40,13,58,1,49,34,144,1,10,16,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,18,62,10,6,101,110,103,105,110,101,24,1,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,18,15,10,4,97,120,105,115,24,2,32,1,40,5,58,1,49,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,121,10,13,84,97,110,72,80,97,114,97,109,101,116,101,114,18,59,10,6,101,110,103,105,110,101,24,1,32,1,40,14,50,34,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,97,110,72,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,47,10,13,84,105,108,101,80,97,114,97,109,101,116,101,114,18,15,10,4,97,120,105,115,24,1,32,1,40,5,58,1,49,18,13,10,5,116,105,108,101,115,24,2,32,1,40,5,34,42,10,18,84,104,114,101,115,104,111,108,100,80,97,114,97,109,101,116,101,114,18,20,10,9,116,104,114,101,115,104,111,108,100,24,1,32,1,40,2,58,1,48,34,193,2,10,19,87,105,110,100,111,119,68,97,116,97,80,97,114,97,109,101,116,101,114,18,14,10,6,115,111,117,114,99,101,24,1,32,1,40,9,18,16,10,5,115,99,97,108,101,24,2,32,1,40,2,58,1,49,18,17,10,9,109,101,97,110,95,102,105,108,101,24,3,32,1,40,9,18,18,10,10,98,97,116,99,104,95,115,105,122,101,24,4,32,1,40,13,18,20,10,9,99,114,111,112,95,115,105,122,101,24,5,32,1,40,13,58,1,48,18,21,10,6,109,105,114,114,111,114,24,6,32,1,40,8,58,5,102,97,108,115,101,18,25,10,12,102,103,95,116,104,114,101,115,104,111,108,100,24,7,32,1,40,2,58,3,48,46,53,18,25,10,12,98,103,95,116,104,114,101,115,104,111,108,100,24,8,32,1,40,2,58,3,48,46,53,18,25,10,11,102,103,95,102,114,97,99,116,105,111,110,24,9,32,1,40,2,58,4,48,46,50,53,18,22,10,11,99,111,110,116,101,120,116,95,112,97,100,24,10,32,1,40,13,58,1,48,18,23,10,9,99,114,111,112,95,109,111,100,101,24,11,32,1,40,9,58,4,119,97,114,112,18,27,10,12,99,97,99,104,101,95,105,109,97,103,101,115,24,12,32,1,40,8,58,5,102,97,108,115,101,18,21,10,11,114,111,111,116,95,102,111,108,100,101,114,24,13,32,1,40,9,58,0,34,249,1,10,12,83,80,80,80,97,114,97,109,101,116,101,114,18,22,10,14,112,121,114,97,109,105,100,95,104,101,105,103,104,116,24,1,32,1,40,13,18,56,10,4,112,111,111,108,24,2,32,1,40,14,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,80,80,80,97,114,97,109,101,116,101,114,46,80,111,111,108,77,101,116,104,111,100,58,3,77,65,88,18,58,10,6,101,110,103,105,110,101,24,6,32,1,40,14,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,80,80,80,97,114,97,109,101,116,101,114,46,69,110,103,105,110,101,58,7,68,69,70,65,85,76,84,34,46,10,10,80,111,111,108,77,101,116,104,111,100,18,7,10,3,77,65,88,16,0,18,7,10,3,65,86,69,16,1,18,14,10,10,83,84,79,67,72,65,83,84,73,67,16,2,34,43,10,6,69,110,103,105,110,101,18,11,10,7,68,69,70,65,85,76,84,16,0,18,9,10,5,67,65,70,70,69,16,1,18,9,10,5,67,85,68,78,78,16,2,34,220,21,10,16,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,18,14,10,6,98,111,116,116,111,109,24,2,32,3,40,9,18,11,10,3,116,111,112,24,3,32,3,40,9,18,12,10,4,110,97,109,101,24,4,32,1,40,9,18,43,10,7,105,110,99,108,117,100,101,24,32,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,82,117,108,101,18,43,10,7,101,120,99,108,117,100,101,24,33,32,3,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,78,101,116,83,116,97,116,101,82,117,108,101,18,54,10,4,116,121,112,101,24,5,32,1,40,14,50,40,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,46,76,97,121,101,114,84,121,112,101,18,38,10,5,98,108,111,98,115,24,6,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,18,14,10,5,112,97,114,97,109,24,233,7,32,3,40,9,18,69,10,15,98,108,111,98,95,115,104,97,114,101,95,109,111,100,101,24,234,7,32,3,40,14,50,43,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,46,68,105,109,67,104,101,99,107,77,111,100,101,18,16,10,8,98,108,111,98,115,95,108,114,24,7,32,3,40,2,18,20,10,12,119,101,105,103,104,116,95,100,101,99,97,121,24,8,32,3,40,2,18,19,10,11,108,111,115,115,95,119,101,105,103,104,116,24,35,32,3,40,2,18,55,10,14,97,99,99,117,114,97,99,121,95,112,97,114,97,109,24,27,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,65,99,99,117,114,97,99,121,80,97,114,97,109,101,116,101,114,18,51,10,12,97,114,103,109,97,120,95,112,97,114,97,109,24,23,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,65,114,103,77,97,120,80,97,114,97,109,101,116,101,114,18,51,10,12,99,111,110,99,97,116,95,112,97,114,97,109,24,9,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,99,97,116,80,97,114,97,109,101,116,101,114,18,70,10,22,99,111,110,116,114,97,115,116,105,118,101,95,108,111,115,115,95,112,97,114,97,109,24,40,32,1,40,11,50,38,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,61,10,17,99,111,110,118,111,108,117,116,105,111,110,95,112,97,114,97,109,24,10,32,1,40,11,50,34,46,111,112,101,110,99,118,95,99,97,102,102,101,46,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,18,47,10,10,100,97,116,97,95,112,97,114,97,109,24,11,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,97,116,97,80,97,114,97,109,101,116,101,114,18,53,10,13,100,114,111,112,111,117,116,95,112,97,114,97,109,24,12,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,114,111,112,111,117,116,80,97,114,97,109,101,116,101,114,18,58,10,16,100,117,109,109,121,95,100,97,116,97,95,112,97,114,97,109,24,26,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,68,117,109,109,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,53,10,13,101,108,116,119,105,115,101,95,112,97,114,97,109,24,24,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,18,45,10,9,101,120,112,95,112,97,114,97,109,24,41,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,69,120,112,80,97,114,97,109,101,116,101,114,18,56,10,15,104,100,102,53,95,100,97,116,97,95,112,97,114,97,109,24,13,32,1,40,11,50,31,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,68,97,116,97,80,97,114,97,109,101,116,101,114,18,60,10,17,104,100,102,53,95,111,117,116,112,117,116,95,112,97,114,97,109,24,14,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,18,58,10,16,104,105,110,103,101,95,108,111,115,115,95,112,97,114,97,109,24,29,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,18,58,10,16,105,109,97,103,101,95,100,97,116,97,95,112,97,114,97,109,24,15,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,109,97,103,101,68,97,116,97,80,97,114,97,109,101,116,101,114,18,64,10,19,105,110,102,111,103,97,105,110,95,108,111,115,115,95,112,97,114,97,109,24,16,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,102,111,103,97,105,110,76,111,115,115,80,97,114,97,109,101,116,101,114,18,64,10,19,105,110,110,101,114,95,112,114,111,100,117,99,116,95,112,97,114,97,109,24,17,32,1,40,11,50,35,46,111,112,101,110,99,118,95,99,97,102,102,101,46,73,110,110,101,114,80,114,111,100,117,99,116,80,97,114,97,109,101,116,101,114,18,45,10,9,108,114,110,95,112,97,114,97,109,24,18,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,82,78,80,97,114,97,109,101,116,101,114,18,60,10,17,109,101,109,111,114,121,95,100,97,116,97,95,112,97,114,97,109,24,22,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,77,101,109,111,114,121,68,97,116,97,80,97,114,97,109,101,116,101,114,18,45,10,9,109,118,110,95,112,97,114,97,109,24,34,32,1,40,11,50,26,46,111,112,101,110,99,118,95,99,97,102,102,101,46,77,86,78,80,97,114,97,109,101,116,101,114,18,53,10,13,112,111,111,108,105,110,103,95,112,97,114,97,109,24,19,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,49,10,11,112,111,119,101,114,95,112,97,114,97,109,24,21,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,80,111,119,101,114,80,97,114,97,109,101,116,101,114,18,47,10,10,114,101,108,117,95,112,97,114,97,109,24,30,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,82,101,76,85,80,97,114,97,109,101,116,101,114,18,53,10,13,115,105,103,109,111,105,100,95,112,97,114,97,109,24,38,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,18,53,10,13,115,111,102,116,109,97,120,95,112,97,114,97,109,24,39,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,18,49,10,11,115,108,105,99,101,95,112,97,114,97,109,24,31,32,1,40,11,50,28,46,111,112,101,110,99,118,95,99,97,102,102,101,46,83,108,105,99,101,80,97,114,97,109,101,116,101,114,18,47,10,10,116,97,110,104,95,112,97,114,97,109,24,37,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,97,110,72,80,97,114,97,109,101,116,101,114,18,57,10,15,116,104,114,101,115,104,111,108,100,95,112,97,114,97,109,24,25,32,1,40,11,50,32,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,104,114,101,115,104,111,108,100,80,97,114,97,109,101,116,101,114,18,60,10,17,119,105,110,100,111,119,95,100,97,116,97,95,112,97,114,97,109,24,20,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,87,105,110,100,111,119,68,97,116,97,80,97,114,97,109,101,116,101,114,18,62,10,15,116,114,97,110,115,102,111,114,109,95,112,97,114,97,109,24,36,32,1,40,11,50,37,46,111,112,101,110,99,118,95,99,97,102,102,101,46,84,114,97,110,115,102,111,114,109,97,116,105,111,110,80,97,114,97,109,101,116,101,114,18,47,10,10,108,111,115,115,95,112,97,114,97,109,24,42,32,1,40,11,50,27,46,111,112,101,110,99,118,95,99,97,102,102,101,46,76,111,115,115,80,97,114,97,109,101,116,101,114,18,45,10,5,108,97,121,101,114,24,1,32,1,40,11,50,30,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,34,216,4,10,9,76,97,121,101,114,84,121,112,101,18,8,10,4,78,79,78,69,16,0,18,10,10,6,65,66,83,86,65,76,16,35,18,12,10,8,65,67,67,85,82,65,67,89,16,1,18,10,10,6,65,82,71,77,65,88,16,30,18,8,10,4,66,78,76,76,16,2,18,10,10,6,67,79,78,67,65,84,16,3,18,20,10,16,67,79,78,84,82,65,83,84,73,86,69,95,76,79,83,83,16,37,18,15,10,11,67,79,78,86,79,76,85,84,73,79,78,16,4,18,8,10,4,68,65,84,65,16,5,18,17,10,13,68,69,67,79,78,86,79,76,85,84,73,79,78,16,39,18,11,10,7,68,82,79,80,79,85,84,16,6,18,14,10,10,68,85,77,77,89,95,68,65,84,65,16,32,18,18,10,14,69,85,67,76,73,68,69,65,78,95,76,79,83,83,16,7,18,11,10,7,69,76,84,87,73,83,69,16,25,18,7,10,3,69,88,80,16,38,18,11,10,7,70,76,65,84,84,69,78,16,8,18,13,10,9,72,68,70,53,95,68,65,84,65,16,9,18,15,10,11,72,68,70,53,95,79,85,84,80,85,84,16,10,18,14,10,10,72,73,78,71,69,95,76,79,83,83,16,28,18,10,10,6,73,77,50,67,79,76,16,11,18,14,10,10,73,77,65,71,69,95,68,65,84,65,16,12,18,17,10,13,73,78,70,79,71,65,73,78,95,76,79,83,83,16,13,18,17,10,13,73,78,78,69,82,95,80,82,79,68,85,67,84,16,14,18,7,10,3,76,82,78,16,15,18,15,10,11,77,69,77,79,82,89,95,68,65,84,65,16,29,18,29,10,25,77,85,76,84,73,78,79,77,73,65,76,95,76,79,71,73,83,84,73,67,95,76,79,83,83,16,16,18,7,10,3,77,86,78,16,34,18,11,10,7,80,79,79,76,73,78,71,16,17,18,9,10,5,80,79,87,69,82,16,26,18,8,10,4,82,69,76,85,16,18,18,11,10,7,83,73,71,77,79,73,68,16,19,18,30,10,26,83,73,71,77,79,73,68,95,67,82,79,83,83,95,69,78,84,82,79,80,89,95,76,79,83,83,16,27,18,11,10,7,83,73,76,69,78,67,69,16,36,18,11,10,7,83,79,70,84,77,65,88,16,20,18,16,10,12,83,79,70,84,77,65,88,95,76,79,83,83,16,21,18,9,10,5,83,80,76,73,84,16,22,18,9,10,5,83,76,73,67,69,16,33,18,8,10,4,84,65,78,72,16,23,18,15,10,11,87,73,78,68,79,87,95,68,65,84,65,16,24,18,13,10,9,84,72,82,69,83,72,79,76,68,16,31,34,42,10,12,68,105,109,67,104,101,99,107,77,111,100,101,18,10,10,6,83,84,82,73,67,84,16,0,18,14,10,10,80,69,82,77,73,83,83,73,86,69,16,1,34,160,8,10,16,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,12,10,4,116,121,112,101,24,2,32,1,40,9,18,18,10,10,110,117,109,95,111,117,116,112,117,116,24,3,32,1,40,13,18,22,10,8,98,105,97,115,116,101,114,109,24,4,32,1,40,8,58,4,116,114,117,101,18,52,10,13,119,101,105,103,104,116,95,102,105,108,108,101,114,24,5,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,50,10,11,98,105,97,115,95,102,105,108,108,101,114,24,6,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,14,10,3,112,97,100,24,7,32,1,40,13,58,1,48,18,18,10,10,107,101,114,110,101,108,115,105,122,101,24,8,32,1,40,13,18,16,10,5,103,114,111,117,112,24,9,32,1,40,13,58,1,49,18,17,10,6,115,116,114,105,100,101,24,10,32,1,40,13,58,1,49,18,60,10,4,112,111,111,108,24,11,32,1,40,14,50,41,46,111,112,101,110,99,118,95,99,97,102,102,101,46,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,46,80,111,111,108,77,101,116,104,111,100,58,3,77,65,88,18,26,10,13,100,114,111,112,111,117,116,95,114,97,116,105,111,24,12,32,1,40,2,58,3,48,46,53,18,21,10,10,108,111,99,97,108,95,115,105,122,101,24,13,32,1,40,13,58,1,53,18,16,10,5,97,108,112,104,97,24,14,32,1,40,2,58,1,49,18,18,10,4,98,101,116,97,24,15,32,1,40,2,58,4,48,46,55,53,18,12,10,1,107,24,22,32,1,40,2,58,1,49,18,14,10,6,115,111,117,114,99,101,24,16,32,1,40,9,18,16,10,5,115,99,97,108,101,24,17,32,1,40,2,58,1,49,18,16,10,8,109,101,97,110,102,105,108,101,24,18,32,1,40,9,18,17,10,9,98,97,116,99,104,115,105,122,101,24,19,32,1,40,13,18,19,10,8,99,114,111,112,115,105,122,101,24,20,32,1,40,13,58,1,48,18,21,10,6,109,105,114,114,111,114,24,21,32,1,40,8,58,5,102,97,108,115,101,18,38,10,5,98,108,111,98,115,24,50,32,3,40,11,50,23,46,111,112,101,110,99,118,95,99,97,102,102,101,46,66,108,111,98,80,114,111,116,111,18,16,10,8,98,108,111,98,115,95,108,114,24,51,32,3,40,2,18,20,10,12,119,101,105,103,104,116,95,100,101,99,97,121,24,52,32,3,40,2,18,20,10,9,114,97,110,100,95,115,107,105,112,24,53,32,1,40,13,58,1,48,18,29,10,16,100,101,116,95,102,103,95,116,104,114,101,115,104,111,108,100,24,54,32,1,40,2,58,3,48,46,53,18,29,10,16,100,101,116,95,98,103,95,116,104,114,101,115,104,111,108,100,24,55,32,1,40,2,58,3,48,46,53,18,29,10,15,100,101,116,95,102,103,95,102,114,97,99,116,105,111,110,24,56,32,1,40,2,58,4,48,46,50,53,18,26,10,15,100,101,116,95,99,111,110,116,101,120,116,95,112,97,100,24,58,32,1,40,13,58,1,48,18,27,10,13,100,101,116,95,99,114,111,112,95,109,111,100,101,24,59,32,1,40,9,58,4,119,97,114,112,18,18,10,7,110,101,119,95,110,117,109,24,60,32,1,40,5,58,1,48,18,23,10,12,110,101,119,95,99,104,97,110,110,101,108,115,24,61,32,1,40,5,58,1,48,18,21,10,10,110,101,119,95,104,101,105,103,104,116,24,62,32,1,40,5,58,1,48,18,20,10,9,110,101,119,95,119,105,100,116,104,24,63,32,1,40,5,58,1,48,18,29,10,14,115,104,117,102,102,108,101,95,105,109,97,103,101,115,24,64,32,1,40,8,58,5,102,97,108,115,101,18,21,10,10,99,111,110,99,97,116,95,100,105,109,24,65,32,1,40,13,58,1,49,18,61,10,17,104,100,102,53,95,111,117,116,112,117,116,95,112,97,114,97,109,24,233,7,32,1,40,11,50,33,46,111,112,101,110,99,118,95,99,97,102,102,101,46,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,34,46,10,10,80,111,111,108,77,101,116,104,111,100,18,7,10,3,77,65,88,16,0,18,7,10,3,65,86,69,16,1,18,14,10,10,83,84,79,67,72,65,83,84,73,67,16,2,34,94,10,14,80,82,101,76,85,80,97,114,97,109,101,116,101,114,18,45,10,6,102,105,108,108,101,114,24,1,32,1,40,11,50,29,46,111,112,101,110,99,118,95,99,97,102,102,101,46,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,18,29,10,14,99,104,97,110,110,101,108,95,115,104,97,114,101,100,24,2,32,1,40,8,58,5,102,97,108,115,101,34,135,1,10,14,78,111,114,109,97,108,105,122,101,100,66,66,111,120,18,12,10,4,120,109,105,110,24,1,32,1,40,2,18,12,10,4,121,109,105,110,24,2,32,1,40,2,18,12,10,4,120,109,97,120,24,3,32,1,40,2,18,12,10,4,121,109,97,120,24,4,32,1,40,2,18,13,10,5,108,97,98,101,108,24,5,32,1,40,5,18,17,10,9,100,105,102,102,105,99,117,108,116,24,6,32,1,40,8,18,13,10,5,115,99,111,114,101,24,7,32,1,40,2,18,12,10,4,115,105,122,101,24,8,32,1,40,2,34,89,10,19,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,19,10,8,112,111,111,108,101,100,95,104,24,1,32,1,40,13,58,1,48,18,19,10,8,112,111,111,108,101,100,95,119,24,2,32,1,40,13,58,1,48,18,24,10,13,115,112,97,116,105,97,108,95,115,99,97,108,101,24,3,32,1,40,2,58,1,49,34,200,1,10,17,80,114,111,112,111,115,97,108,80,97,114,97,109,101,116,101,114,18,23,10,11,102,101,97,116,95,115,116,114,105,100,101,24,1,32,1,40,13,58,2,49,54,18,21,10,9,98,97,115,101,95,115,105,122,101,24,2,32,1,40,13,58,2,49,54,18,20,10,8,109,105,110,95,115,105,122,101,24,3,32,1,40,13,58,2,49,54,18,13,10,5,114,97,116,105,111,24,4,32,3,40,2,18,13,10,5,115,99,97,108,101,24,5,32,3,40,2,18,26,10,12,112,114,101,95,110,109,115,95,116,111,112,110,24,6,32,1,40,13,58,4,54,48,48,48,18,26,10,13,112,111,115,116,95,110,109,115,95,116,111,112,110,24,7,32,1,40,13,58,3,51,48,48,18,23,10,10,110,109,115,95,116,104,114,101,115,104,24,8,32,1,40,2,58,3,48,46,55,34,86,10,21,80,83,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,18,21,10,13,115,112,97,116,105,97,108,95,115,99,97,108,101,24,1,32,2,40,2,18,18,10,10,111,117,116,112,117,116,95,100,105,109,24,2,32,2,40,5,18,18,10,10,103,114,111,117,112,95,115,105,122,101,24,3,32,2,40,5,42,61,10,4,84,121,112,101,18,10,10,6,68,79,85,66,76,69,16,0,18,9,10,5,70,76,79,65,84,16,1,18,11,10,7,70,76,79,65,84,49,54,16,2,18,7,10,3,73,78,84,16,3,18,8,10,4,85,73,78,84,16,4,42,28,10,5,80,104,97,115,101,18,9,10,5,84,82,65,73,78,16,0,18,8,10,4,84,69,83,84,16,1,0,83,71,68,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,49,80,83,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,55,80,114,111,112,111,115,97,108,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,82,79,73,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,78,111,114,109,97,108,105,122,101,100,66,66,111,120,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,80,82,101,76,85,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,86,48,76,97,121,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,70,105,108,108,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,86,49,76,97,121,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,83,80,80,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,87,105,110,100,111,119,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,84,104,114,101,115,104,111,108,100,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,84,105,108,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,84,97,110,72,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,83,111,102,116,109,97,120,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,83,108,105,99,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,83,105,103,109,111,105,100,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,83,99,97,108,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,82,101,115,104,97,112,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,82,101,76,85,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,82,101,100,117,99,116,105,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,82,101,99,117,114,114,101,110,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,80,121,116,104,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,80,111,119,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,80,111,111,108,105,110,103,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,80,97,114,97,109,101,116,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,77,86,78,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,77,101,109,111,114,121,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,76,82,78,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,76,111,103,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,73,110,112,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,49,73,110,110,101,114,80,114,111,100,117,99,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,49,73,110,102,111,103,97,105,110,76,111,115,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,73,109,97,103,101,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,72,105,110,103,101,76,111,115,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,72,68,70,53,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,55,72,68,70,53,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,70,108,97,116,116,101,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,69,120,112,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,69,109,98,101,100,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+399422);allocate([69,76,85,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,69,108,116,119,105,115,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,68,117,109,109,121,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,68,114,111,112,111,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,57,83,97,118,101,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,51,48,78,111,110,77,97,120,105,109,117,109,83,117,112,112,114,101,115,115,105,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,68,97,116,97,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,67,114,111,112,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,48,67,111,110,118,111,108,117,116,105,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,52,67,111,110,116,114,97,115,116,105,118,101,76,111,115,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,66,105,97,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,56,66,97,116,99,104,78,111,114,109,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,67,111,110,99,97,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,65,114,103,77,97,120,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,55,65,99,99,117,114,97,99,121,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,51,76,111,115,115,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,51,84,114,97,110,115,102,111,114,109,97,116,105,111,110,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,52,76,97,121,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,57,80,97,114,97,109,83,112,101,99,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,78,101,116,83,116,97,116,101,82,117,108,101,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,56,78,101,116,83,116,97,116,101,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,49,83,111,108,118,101,114,83,116,97,116,101,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,50,78,101,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,83,111,108,118,101,114,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,53,68,97,116,117,109,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,52,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,55,80,114,105,111,114,66,111,120,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,50,50,78,111,114,109,97,108,105,122,101,66,66,111,120,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,54,80,101,114,109,117,116,101,80,97,114,97,109,101,116,101,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,49,53,66,108,111,98,80,114,111,116,111,86,101,99,116,111,114,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,57,66,108,111,98,80,114,111,116,111,69,0,78,49,50,111,112,101,110,99,118,95,99,97,102,102,101,57,66,108,111,98,83,104,97,112,101,69,0,83,108,105,99,101,0,83,112,108,105,116,0,82,101,115,104,97,112,101,0,70,108,97,116,116,101,110,0,82,101,115,105,122,101,78,101,97,114,101,115,116,78,101,105,103,104,98,111,114,0,68,101,99,111,110,118,111,108,117,116,105,111,110,0,82,79,73,80,111,111,108,105,110,103,0,80,83,82,79,73,80,111,111,108,105,110,103,0,76,82,78,0,73,110,110,101,114,80,114,111,100,117,99,116,0,83,111,102,116,109,97,120,0,77,86,78,0,82,101,76,85,54,0,67,104,97,110,110,101,108,115,80,82,101,76,85,0,80,82,101,76,85,0,83,105,103,109,111,105,100,0,69,76,85,0,65,98,115,86,97,108,0,77,97,120,85,110,112,111,111,108,0,68,114,111,112,111,117,116,0,83,105,108,101,110,99,101,0,69,108,116,119,105,115,101,0,80,114,105,111,114,66,111,120,67,108,117,115,116,101,114,101,100,0,78,111,114,109,97,108,105,122,101,66,66,111,120,0,78,111,114,109,97,108,105,122,101,0,83,104,105,102,116,0,80,97,100,100,105,110,103,0,83,99,97,108,101,0,118,111,105,100,32,99,118,58,58,100,110,110,58,58,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,58,58,105,110,105,116,105,97,108,105,122,101,76,97,121,101,114,70,97,99,116,111,114,121,40,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,105,110,105,116,46,99,112,112,0,114,0,91,110,101,116,93,0,108,97,121,101,114,95,116,121,112,101,95,115,105,122,101,32,60,32,108,105,110,101,46,115,105,122,101,40,41,0,82,101,97,100,68,97,114,107,110,101,116,70,114,111,109,67,102,103,70,105,108,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,100,97,114,107,110,101,116,47,100,97,114,107,110,101,116,95,105,111,46,99,112,112,0,115,101,112,97,114,97,116,111,114,95,105,110,100,101,120,32,60,32,108,105,110,101,46,115,105,122,101,40,41,0,110,101,116,45,62,119,105,100,116,104,32,62,32,48,32,38,38,32,110,101,116,45,62,104,101,105,103,104,116,32,62,32,48,32,38,38,32,110,101,116,45,62,99,104,97,110,110,101,108,115,32,62,32,48,0,99,111,110,118,111,108,117,116,105,111,110,97,108,0,102,105,108,116,101,114,115,0,97,99,116,105,118,97,116,105,111,110,0,108,105,110,101,97,114,0,98,97,116,99,104,95,110,111,114,109,97,108,105,122,101,0,108,101,97,107,121,0,85,110,115,117,112,112,111,114,116,101,100,32,97,99,116,105,118,97,116,105,111,110,58,32,0,102,108,105,112,112,101,100,0,84,114,97,110,115,112,111,115,101,32,116,104,101,32,99,111,110,118,111,108,117,116,105,111,110,97,108,32,119,101,105,103,104,116,115,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,107,101,114,110,101,108,95,115,105,122,101,32,62,32,48,32,38,38,32,102,105,108,116,101,114,115,32,62,32,48,0,99,117,114,114,101,110,116,95,99,104,97,110,110,101,108,115,32,62,32,48,0,109,97,120,112,111,111,108,0,114,111,117,116,101,0,108,97,121,101,114,115,0,33,98,111,116,116,111,109,95,108,97,121,101,114,115,46,101,109,112,116,121,40,41,0,114,101,111,114,103,0,114,101,103,105,111,110,0,110,117,109,0,33,97,110,99,104,111,114,115,95,118,97,108,117,101,115,46,101,109,112,116,121,40,41,0,99,108,97,115,115,101,115,32,62,32,48,32,38,38,32,110,117,109,95,111,102,95,97,110,99,104,111,114,115,32,62,32,48,32,38,38,32,40,110,117,109,95,111,102,95,97,110,99,104,111,114,115,32,42,32,50,41,32,61,61,32,97,110,99,104,111,114,115,95,118,101,99,46,115,105,122,101,40,41,0,85,110,107,110,111,119,110,32,108,97,121,101,114,32,116,121,112,101,58,32,0,82,101,103,105,111,110,45,110,97,109,101,0,82,101,103,105,111,110,0,100,101,116,101,99,116,105,111,110,95,111,117,116,0,80,101,114,109,117,116,101,45,110,97,109,101,0,80,101,114,109,117,116,101,0,112,114,101,109,117,116,101,95,37,100,0,82,101,111,114,103,45,110,97,109,101,0,82,101,111,114,103,0,114,101,111,114,103,95,37,100,0,67,111,110,99,97,116,45,110,97,109,101,0,67,111,110,99,97,116,0,99,111,110,99,97,116,95,37,100,0,73,100,101,110,116,105,116,121,45,110,97,109,101,0,105,100,101,110,116,105,116,121,95,37,100,0,80,111,111,108,105,110,103,45,110,97,109,101,0,80,111,111,108,105,110,103,0,112,111,111,108,95,37,100,0,99,111,110,118,95,37,100,0,66,97,116,99,104,78,111,114,109,45,110,97,109,101,0,66,97,116,99,104,78,111,114,109,0,98,110,95,37,100,0,82,101,76,85,45,110,97,109,101,0,114,101,108,117,95,37,100,0,67,111,110,118,111,108,117,116,105,111,110,45,110,97,109,101,0,67,111,110,118,111,108,117,116,105,111,110,0,105,102,105,108,101,46,105,115,95,111,112,101,110,40,41,0,82,101,97,100,68,97,114,107,110,101,116,70,114,111,109,87,101,105,103,104,116,115,70,105,108,101,0,84,114,97,110,115,112,111,115,101,32,116,104,101,32,119,101,105,103,104,116,115,32,40,101,120,99,101,112,116,32,102,111,114,32,99,111,110,118,111,108,117,116,105,111,110,97,108,41,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,119,101,105,103,104,116,115,66,108,111,98,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,70,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,78,101,116,80,97,114,97,109,101,116,101,114,32,102,105,108,101,58,32,0,82,101,97,100,78,101,116,80,97,114,97,109,115,70,114,111,109,67,102,103,70,105,108,101,79,114,68,105,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,50,76,82,78,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,110,111,114,109,95,114,101,103,105,111,110,0,65,67,82,79,83,83,95,67,72,65,78,78,69,76,83,0,87,73,84,72,73,78,95,67,72,65,78,78,69,76,0,85,110,107,110,111,119,110,32,114,101,103,105,111,110,32,116,121,112,101,32,34,0,76,82,78,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,108,114,110,95,108,97,121,101,114,46,99,112,112,0,108,111,99,97,108,95,115,105,122,101,0,76,82,78,32,108,97,121,101,114,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,112,111,115,105,116,105,118,101,32,111,100,100,32,118,97,108,117,101,115,32,102,111,114,32,108,111,99,97,108,95,115,105,122,101,0,97,108,112,104,97,0,110,111,114,109,95,98,121,95,115,105,122,101,0,105,110,112,117,116,115,95,97,114,114,46,116,111,116,97,108,40,41,32,61,61,32,111,117,116,112,117,116,115,95,97,114,114,46,116,111,116,97,108,40,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,76,82,78,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,105,110,112,117,116,115,91,105,93,45,62,100,105,109,115,32,61,61,32,52,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,109,111,100,101,32,111,102,32,76,82,78,32,108,97,121,101,114,0,78,50,99,118,51,100,110,110,49,50,76,82,78,76,97,121,101,114,73,109,112,108,49,48,67,104,97,110,110,101,108,76,82,78,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,76,82,78,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,50,76,82,78,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,56,76,82,78,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,52,83,112,108,105,116,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,116,111,112,95,99,111,117,110,116,0,111,117,116,112,117,116,115,67,111,117,110,116,32,62,61,32,48,0,83,112,108,105,116,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,112,108,105,116,95,108,97,121,101,114,46,99,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,83,112,108,105,116,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,105,110,112,117,116,115,91,48,93,45,62,116,111,116,97,108,40,41,32,61,61,32,111,117,116,112,117,116,115,91,105,93,46,116,111,116,97,108,40,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,83,112,108,105,116,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,52,83,112,108,105,116,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,48,83,112,108,105,116,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,50,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,97,99,114,111,115,115,95,115,112,97,116,105,97,108,0,112,110,111,114,109,32,62,32,48,0,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,110,111,114,109,97,108,105,122,101,95,98,98,111,120,95,108,97,121,101,114,46,99,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,32,38,38,32,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,0,105,110,112,117,116,115,91,48,93,45,62,116,111,116,97,108,40,41,32,61,61,32,111,117,116,112,117,116,115,91,48,93,46,116,111,116,97,108,40,41,0,115,99,97,108,101,46,116,111,116,97,108,40,41,32,61,61,32,99,104,97,110,110,101,108,115,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,50,50,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,56,78,111,114,109,97,108,105,122,101,66,66,111,120,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,52,83,104,105,102,116,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,83,104,105,102,116,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,104,105,102,116,95,108,97,121,101,114,46,99,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,83,104,105,102,116,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,98,108,111,98,115,46,115,105,122,101,40,41,32,62,32,48,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,83,104,105,102,116,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,52,83,104,105,102,116,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,48,83,104,105,102,116,76,97,121,101,114,69,0,97,100,106,95,104,0,97,100,106,95,119,0,108,45,62,110,117,109,79,117,116,112,117,116,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,0,105,110,105,116,67,111,110,118,68,101,99,111,110,118,76,97,121,101,114,70,114,111,109,67,97,102,102,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,99,111,110,118,111,108,117,116,105,111,110,95,108,97,121,101,114,46,99,112,112,0,108,45,62,97,100,106,117,115,116,80,97,100,46,119,105,100,116,104,32,60,32,108,45,62,115,116,114,105,100,101,46,119,105,100,116,104,32,38,38,32,108,45,62,97,100,106,117,115,116,80,97,100,46,104,101,105,103,104,116,32,60,32,108,45,62,115,116,114,105,100,101,46,104,101,105,103,104,116,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,48,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,111,117,116,112,117,116,115,46,115,105,122,101,40,41,0,98,108,111,98,115,46,115,105,122,101,40,41,32,33,61,32,48,0,33,104,97,115,66,105,97,115,40,41,32,124,124,32,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,98,108,111,98,115,91,48,93,46,115,105,122,101,91,48,93,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,49,0,110,103,114,111,117,112,115,32,62,32,48,32,38,38,32,105,110,112,67,110,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,32,38,38,32,111,117,116,67,110,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,49,32,38,38,32,105,110,112,117,116,115,91,48,93,45,62,115,105,122,101,91,49,93,32,37,32,98,108,111,98,115,91,48,93,46,115,105,122,101,91,49,93,32,61,61,32,48,0,111,117,116,112,117,116,115,91,48,93,46,115,105,122,101,91,49,93,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,0,115,99,97,108,101,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,115,104,105,102,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,115,99,97,108,101,46,116,121,112,101,40,41,32,61,61,32,53,32,38,38,32,115,104,105,102,116,46,116,121,112,101,40,41,32,61,61,32,53,32,38,38,32,115,99,97,108,101,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,111,117,116,67,110,32,38,38,32,115,104,105,102,116,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,111,117,116,67,110,0,115,99,97,108,101,50,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,115,99,97,108,101,50,46,116,121,112,101,40,41,32,61,61,32,53,32,38,38,32,115,99,97,108,101,50,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,111,117,116,67,110,0,115,104,105,102,116,50,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,115,104,105,102,116,50,46,116,121,112,101,40,41,32,61,61,32,53,32,38,38,32,115,104,105,102,116,50,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,111,117,116,67,110,0,109,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,109,46,116,121,112,101,40,41,32,61,61,32,53,32,38,38,32,40,105,110,116,41,109,46,116,111,116,97,108,40,41,32,61,61,32,111,117,116,67,110,0,105,110,112,117,116,46,100,105,109,115,32,61,61,32,52,32,38,38,32,111,117,116,112,117,116,46,100,105,109,115,32,61,61,32,52,0,105,110,112,117,116,46,115,105,122,101,91,48,93,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,48,93,0,119,101,105,103,104,116,115,46,114,111,119,115,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,49,93,0,119,101,105,103,104,116,115,46,99,111,108,115,32,61,61,32,40,105,110,112,117,116,46,115,105,122,101,91,49,93,47,110,103,114,111,117,112,115,41,42,107,101,114,110,101,108,46,119,105,100,116,104,42,107,101,114,110,101,108,46,104,101,105,103,104,116,0,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,111,117,116,112,117,116,46,116,121,112,101,40,41,0,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,119,101,105,103,104,116,115,46,116,121,112,101,40,41,0,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,53,0,111,117,116,112,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,98,105,97,115,118,101,99,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,111,117,116,112,117,116,46,115,105,122,101,91,49,93,43,50,0,78,50,99,118,51,100,110,110,50,48,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,49,50,80,97,114,97,108,108,101,108,67,111,110,118,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,56,67,104,97,110,110,101,108,115,80,82,101,76,85,76,97,121,101,114,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,57,82,101,76,85,76,97,121,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,98,108,111,98,115,46,115,105,122,101,40,41,32,62,61,32,49,32,38,38,32,98,108,111,98,115,46,115,105,122,101,40,41,32,60,61,32,50,0,98,108,111,98,115,91,48,93,46,100,105,109,115,32,61,61,32,52,32,38,38,32,98,108,111,98,115,91,48,93,46,115,105,122,101,91,51,93,32,61,61,32,107,101,114,110,101,108,46,119,105,100,116,104,32,38,38,32,98,108,111,98,115,91,48,93,46,115,105,122,101,91,50,93,32,61,61,32,107,101,114,110,101,108,46,104,101,105,103,104,116,0,105,110,112,117,116,46,100,105,109,115,32,61,61,32,52,32,38,38,32,40,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,53,32,124,124,32,105,110,112,117,116,46,116,121,112,101,40,41,32,61,61,32,54,41,0,105,110,112,117,116,115,91,105,93,45,62,116,121,112,101,40,41,32,61,61,32,105,110,112,117,116,46,116,121,112,101,40,41,0,105,110,112,117,116,115,91,105,93,45,62,100,105,109,115,32,61,61,32,52,32,38,38,32,105,110,112,117,116,115,91,105,93,45,62,115,105,122,101,91,49,93,32,61,61,32,105,110,112,117,116,46,115,105,122,101,91,49,93,0,105,110,112,117,116,115,91,105,93,45,62,115,105,122,101,91,50,93,32,61,61,32,105,110,112,117,116,46,115,105,122,101,91,50,93,32,38,38,32,105,110,112,117,116,115,91,105,93,45,62,115,105,122,101,91,51,93,32,61,61,32,105,110,112,117,116,46,115,105,122,101,91,51,93,0,78,50,99,118,51,100,110,110,50,48,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,50,52,66,97,115,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,50,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,33,104,97,115,66,105,97,115,40,41,32,124,124,32,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,117,109,79,117,116,112,117,116,0,111,117,116,67,110,32,37,32,98,108,111,98,115,91,48,93,46,115,105,122,101,91,49,93,32,61,61,32,48,0,105,110,112,67,110,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,32,38,38,32,111,117,116,67,110,32,37,32,110,103,114,111,117,112,115,32,61,61,32,48,0,98,108,111,98,115,91,48,93,46,115,105,122,101,91,48,93,32,61,61,32,105,110,112,67,110,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,78,50,99,118,51,100,110,110,50,50,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,49,51,67,111,108,50,73,109,73,110,118,111,107,101,114,69,0,78,50,99,118,51,100,110,110,50,50,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,49,51,77,97,116,77,117,108,73,110,118,111,107,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,50,50,68,101,67,111,110,118,111,108,117,116,105,111,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,51,67,114,111,112,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,57,67,114,111,112,76,97,121,101,114,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,99,114,111,112,95,108,97,121,101,114,46,99,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,67,114,111,112,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,67,114,111,112,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,50,32,61,61,32,105,110,112,117,116,115,46,115,105,122,101,40,41,0,110,117,109,98,101,114,32,111,102,32,111,102,102,115,101,116,32,118,97,108,117,101,115,32,115,112,101,99,105,102,105,101,100,32,109,117,115,116,32,98,101,32,101,113,117,97,108,32,116,111,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,102,111,108,108,111,119,105,110,103,32,97,120,105,115,46,0,105,110,118,97,108,105,100,32,99,114,111,112,32,112,97,114,97,109,101,116,101,114,115,0,105,110,118,97,108,105,100,32,111,117,116,112,117,116,32,98,108,111,98,32,115,105,122,101,0,78,50,99,118,51,100,110,110,49,51,67,114,111,112,76,97,121,101,114,73,109,112,108,69,0,107,101,114,110,101,108,0,107,101,114,110,101,108,95,115,105,122,101,32,40,111,114,32,107,101,114,110,101,108,95,104,32,97,110,100,32,107,101,114,110,101,108,95,119,41,32,110,111,116,32,115,112,101,99,105,102,105,101,100,0,103,101,116,75,101,114,110,101,108,83,105,122,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,108,97,121,101,114,115,95,99,111,109,109,111,110,46,99,112,112,0,107,101,114,110,101,108,72,32,62,32,48,32,38,38,32,107,101,114,110,101,108,87,32,62,32,48,0,112,97,100,0,115,116,114,105,100,101,0,112,97,100,72,32,62,61,32,48,32,38,38,32,112,97,100,87,32,62,61,32,48,32,38,38,32,115,116,114,105,100,101,72,32,62,32,48,32,38,38,32,115,116,114,105,100,101,87,32,62,32,48,0,103,101,116,83,116,114,105,100,101,65,110,100,80,97,100,100,105,110,103,0,103,108,111,98,97,108,95,112,111,111,108,105,110,103,0,73,110,32,103,108,111,98,97,108,95,112,111,111,108,105,110,103,32,109,111,100,101,44,32,107,101,114,110,101,108,95,115,105,122,101,32,40,111,114,32,107,101,114,110,101,108,95,104,32,97,110,100,32,107,101,114,110,101,108,95,119,41,32,99,97,110,110,111,116,32,98,101,32,115,112,101,99,105,102,105,101,100,0,103,101,116,80,111,111,108,105,110,103,75,101,114,110,101,108,80,97,114,97,109,115,0,73,110,32,103,108,111,98,97,108,95,112,111,111,108,105,110,103,32,109,111,100,101,44,32,112,97,100,95,104,32,97,110,100,32,112,97,100,95,119,32,109,117,115,116,32,98,101,32,61,32,48,44,32,97,110,100,32,115,116,114,105,100,101,95,104,32,97,110,100,32,115,116,114,105,100,101,95,119,32,109,117,115,116,32,98,101,32,61,32,49,0,100,105,108,97,116,105,111,110,72,32,62,32,48,32,38,38,32,100,105,108,97,116,105,111,110,87,32,62,32,48,0,103,101,116,67,111,110,118,111,108,117,116,105,111,110,75,101,114,110,101,108,80,97,114,97,109,115,0,86,65,76,73,68,0,83,65,77,69,0,85,110,115,117,112,112,111,114,116,101,100,32,112,97,100,100,105,110,103,32,109,111,100,101,0,103,101,116,67,111,110,118,80,111,111,108,79,117,116,80,97,114,97,109,115,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,105,110,112,117,116,95,100,105,109,115,0,112,97,114,97,109,115,46,104,97,115,40,34,112,97,100,100,105,110,103,115,34,41,0,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,97,100,100,105,110,103,95,108,97,121,101,114,46,99,112,112,0,40,112,97,100,100,105,110,103,115,80,97,114,97,109,46,115,105,122,101,40,41,32,38,32,49,41,32,61,61,32,48,0,112,97,100,100,105,110,103,115,91,105,93,46,102,105,114,115,116,32,62,61,32,48,0,112,97,100,100,105,110,103,115,91,105,93,46,115,101,99,111,110,100,32,62,61,32,48,0,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,32,62,61,32,112,97,100,100,105,110,103,115,46,115,105,122,101,40,41,0,105,110,112,117,116,68,105,109,115,32,61,61,32,45,49,32,124,124,32,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,32,61,61,32,105,110,112,117,116,68,105,109,115,32,124,124,32,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,32,62,32,112,97,100,100,105,110,103,115,46,115,105,122,101,40,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,99,111,110,115,116,97,110,116,0,114,101,102,108,101,99,116,0,105,110,112,117,116,115,91,48,93,45,62,100,105,109,115,32,61,61,32,52,0,111,117,116,112,117,116,115,91,48,93,46,100,105,109,115,32,61,61,32,52,0,79,110,108,121,32,115,112,97,116,105,97,108,32,114,101,102,108,101,99,116,105,111,110,32,112,97,100,100,105,110,103,32,105,115,32,115,117,112,112,111,114,116,101,100,46,0,112,97,100,84,111,112,32,60,32,105,110,112,72,101,105,103,104,116,0,112,97,100,66,111,116,116,111,109,32,60,32,105,110,112,72,101,105,103,104,116,0,112,97,100,76,101,102,116,32,60,32,105,110,112,87,105,100,116,104,0,112,97,100,82,105,103,104,116,32,60,32,105,110,112,87,105,100,116,104,0,85,110,107,110,111,119,110,32,112,97,100,100,105,110,103,32,116,121,112,101,58,32,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,54,80,97,100,100,105,110,103,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,50,80,97,100,100,105,110,103,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,52,82,101,111,114,103,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,114,101,111,114,103,95,115,116,114,105,100,101,0,114,101,111,114,103,83,116,114,105,100,101,32,62,32,48,0,82,101,111,114,103,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,111,114,103,95,108,97,121,101,114,46,99,112,112,0,111,117,116,112,117,116,115,91,48,93,91,48,93,32,62,32,48,32,38,38,32,111,117,116,112,117,116,115,91,48,93,91,49,93,32,62,32,48,32,38,38,32,111,117,116,112,117,116,115,91,48,93,91,50,93,32,62,32,48,32,38,38,32,111,117,116,112,117,116,115,91,48,93,91,51,93,32,62,32,48,0,116,111,116,97,108,40,111,117,116,112,117,116,115,91,48,93,41,32,61,61,32,116,111,116,97,108,40,105,110,112,117,116,115,91,48,93,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,82,101,111,114,103,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,82,101,111,114,103,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+409662);allocate([116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,52,82,101,111,114,103,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,48,82,101,111,114,103,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,84,111,111,32,109,97,110,121,32,40,62,32,52,41,32,111,114,100,101,114,115,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,105,110,32,80,101,114,109,117,116,101,32,108,97,121,101,114,0,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,101,114,109,117,116,101,95,108,97,121,101,114,46,99,112,112,0,79,114,100,101,114,115,32,111,102,32,100,105,109,101,110,115,105,111,110,115,32,105,110,32,80,101,114,109,117,116,101,32,108,97,121,101,114,32,112,97,114,97,109,101,116,101,114,109,117,115,116,32,98,101,32,105,110,32,91,48,46,46,46,51,93,32,105,110,116,101,114,118,97,108,0,99,104,101,99,107,67,117,114,114,101,110,116,79,114,100,101,114,0,80,101,114,109,117,116,101,32,108,97,121,101,114,32,112,97,114,97,109,101,116,101,114,32,99,111,110,116,97,105,110,115,32,100,117,112,108,105,99,97,116,101,100,32,111,114,100,101,114,115,46,0,40,105,110,116,41,95,110,117,109,65,120,101,115,32,61,61,32,105,110,112,117,116,115,91,48,93,46,115,105,122,101,40,41,0,105,110,112,117,116,115,91,105,93,46,115,105,122,101,40,41,32,61,61,32,52,0,105,110,112,117,116,115,91,105,93,91,50,93,32,61,61,32,115,104,97,112,101,66,101,102,111,114,101,91,50,93,32,38,38,32,105,110,112,117,116,115,91,105,93,91,51,93,32,61,61,32,115,104,97,112,101,66,101,102,111,114,101,91,51,93,0,116,111,116,97,108,40,105,110,112,117,116,115,91,105,93,41,32,61,61,32,116,111,116,97,108,40,115,104,97,112,101,65,102,116,101,114,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,111,117,116,112,117,116,115,91,107,93,46,116,111,116,97,108,40,41,32,61,61,32,105,110,112,117,116,115,91,107,93,45,62,116,111,116,97,108,40,41,0,105,110,112,46,100,105,109,115,32,61,61,32,110,117,109,65,120,101,115,32,38,38,32,105,110,112,46,115,105,122,101,32,61,61,32,105,110,112,117,116,115,91,48,93,45,62,115,105,122,101,0,111,117,116,46,100,105,109,115,32,61,61,32,110,117,109,65,120,101,115,32,38,38,32,111,117,116,46,115,105,122,101,32,61,61,32,111,117,116,112,117,116,115,91,48,93,46,115,105,122,101,0,105,110,112,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,111,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,105,110,112,46,116,121,112,101,40,41,32,61,61,32,53,32,38,38,32,111,117,116,46,116,121,112,101,40,41,32,61,61,32,53,0,111,117,116,46,115,105,122,101,91,48,93,32,61,61,32,105,110,112,46,115,105,122,101,91,111,114,100,101,114,91,48,93,93,32,38,38,32,111,117,116,46,115,105,122,101,91,49,93,32,61,61,32,105,110,112,46,115,105,122,101,91,111,114,100,101,114,91,49,93,93,32,38,38,32,111,117,116,46,115,105,122,101,91,50,93,32,61,61,32,105,110,112,46,115,105,122,101,91,111,114,100,101,114,91,50,93,93,32,38,38,32,111,117,116,46,115,105,122,101,91,51,93,32,61,61,32,105,110,112,46,115,105,122,101,91,111,114,100,101,114,91,51,93,93,0,78,50,99,118,51,100,110,110,49,54,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,49,52,80,101,114,109,117,116,101,73,110,118,111,107,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,40,105,110,116,41,95,110,117,109,65,120,101,115,32,61,61,32,105,110,112,48,46,100,105,109,115,0,78,50,99,118,51,100,110,110,49,54,80,101,114,109,117,116,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,50,80,101,114,109,117,116,101,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,56,77,97,120,85,110,112,111,111,108,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,112,111,111,108,95,112,97,100,95,119,0,112,111,111,108,95,112,97,100,95,104,0,112,111,111,108,95,115,116,114,105,100,101,95,119,0,112,111,111,108,95,115,116,114,105,100,101,95,104,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,109,97,120,95,117,110,112,111,111,108,105,110,103,95,108,97,121,101,114,46,99,112,112,0,116,111,116,97,108,40,105,110,112,117,116,115,91,48,93,41,32,61,61,32,116,111,116,97,108,40,105,110,112,117,116,115,91,49,93,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,77,97,120,85,110,112,111,111,108,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,105,110,112,117,116,46,116,111,116,97,108,40,41,32,61,61,32,105,110,100,105,99,101,115,46,116,111,116,97,108,40,41,0,105,110,112,117,116,46,115,105,122,101,91,48,93,32,61,61,32,49,0,105,110,112,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,105,110,112,117,116,46,115,105,122,101,91,49,93,32,61,61,32,111,117,116,66,108,111,98,46,115,105,122,101,91,49,93,0,105,95,110,61,0,105,95,99,61,0,105,95,119,104,61,0,105,110,100,101,120,61,0,109,97,120,118,97,108,61,0,111,117,116,80,108,97,110,101,84,111,116,97,108,61,0,105,110,112,117,116,46,115,105,122,101,61,0,32,120,32,0,105,110,100,105,99,101,115,46,115,105,122,101,61,0,111,117,116,66,108,111,98,61,0,48,32,60,61,32,105,110,100,101,120,32,38,38,32,105,110,100,101,120,32,60,32,111,117,116,80,108,97,110,101,84,111,116,97,108,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,77,97,120,85,110,112,111,111,108,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,56,77,97,120,85,110,112,111,111,108,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,52,77,97,120,85,110,112,111,111,108,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,56,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,98,97,116,99,104,95,110,111,114,109,95,108,97,121,101,114,46,99,112,112,0,104,97,115,95,119,101,105,103,104,116,0,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,32,61,61,32,110,32,38,38,32,98,108,111,98,115,91,48,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,98,108,111,98,115,91,49,93,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,98,108,111,98,115,91,48,93,46,116,121,112,101,40,41,32,61,61,32,53,32,38,38,32,98,108,111,98,115,91,49,93,46,116,121,112,101,40,41,32,61,61,32,53,0,98,108,111,98,115,91,50,93,46,116,121,112,101,40,41,32,61,61,32,53,0,40,115,105,122,101,95,116,41,119,101,105,103,104,116,115,66,108,111,98,73,110,100,101,120,32,60,32,98,108,111,98,115,46,115,105,122,101,40,41,0,119,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,119,46,116,121,112,101,40,41,32,61,61,32,53,32,38,38,32,119,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,0,40,115,105,122,101,95,116,41,98,105,97,115,66,108,111,98,73,110,100,101,120,32,60,32,98,108,111,98,115,46,115,105,122,101,40,41,0,98,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,98,46,116,121,112,101,40,41,32,61,61,32,53,32,38,38,32,98,46,116,111,116,97,108,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,98,108,111,98,115,46,115,105,122,101,40,41,32,62,61,32,50,0,105,110,112,66,108,111,98,46,100,105,109,115,32,61,61,32,50,32,124,124,32,105,110,112,66,108,111,98,46,100,105,109,115,32,61,61,32,52,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,56,66,97,116,99,104,78,111,114,109,76,97,121,101,114,73,109,112,108,69,0,104,0,99,0,120,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,57,76,83,84,77,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,51,76,83,84,77,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,98,108,111,98,115,46,115,105,122,101,40,41,32,62,61,32,51,0,76,83,84,77,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,99,117,114,114,101,110,116,95,108,97,121,101,114,115,46,99,112,112,0,87,104,46,100,105,109,115,32,61,61,32,50,32,38,38,32,87,120,46,100,105,109,115,32,61,61,32,50,0,87,104,46,114,111,119,115,32,61,61,32,87,120,46,114,111,119,115,0,87,104,46,114,111,119,115,32,61,61,32,52,42,87,104,46,99,111,108,115,0,87,104,46,114,111,119,115,32,61,61,32,40,105,110,116,41,98,105,97,115,46,116,111,116,97,108,40,41,0,87,104,46,116,121,112,101,40,41,32,61,61,32,87,120,46,116,121,112,101,40,41,32,38,38,32,87,120,46,116,121,112,101,40,41,32,61,61,32,98,105,97,115,46,116,121,112,101,40,41,0,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,54,0,98,108,111,98,115,91,105,93,46,114,111,119,115,32,61,61,32,87,104,46,99,111,108,115,32,38,38,32,98,108,111,98,115,91,105,93,46,99,111,108,115,32,61,61,32,87,104,46,99,111,108,115,0,98,108,111,98,115,91,105,93,46,116,121,112,101,40,41,32,61,61,32,98,105,97,115,46,116,121,112,101,40,41,0,117,115,101,95,116,105,109,101,115,116,97,109,112,95,100,105,109,0,112,114,111,100,117,99,101,95,99,101,108,108,95,111,117,116,112,117,116,0,102,111,114,103,101,116,95,98,105,97,115,0,99,101,108,108,95,99,108,105,112,0,117,115,101,95,99,101,108,108,95,99,108,105,112,0,117,115,101,95,112,101,101,112,104,111,108,101,0,33,97,108,108,111,99,97,116,101,100,0,115,101,116,80,114,111,100,117,99,101,67,101,108,108,79,117,116,112,117,116,0,115,101,116,85,115,101,84,105,109,115,116,97,109,112,115,68,105,109,0,33,97,108,108,111,99,97,116,101,100,32,124,124,32,116,111,116,97,108,40,111,117,116,84,97,105,108,83,104,97,112,101,41,32,61,61,32,116,111,116,97,108,40,111,117,116,84,97,105,108,83,104,97,112,101,95,41,0,115,101,116,79,117,116,83,104,97,112,101,0,115,101,116,87,101,105,103,104,116,115,0,33,117,115,101,80,101,101,112,104,111,108,101,32,38,38,32,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,51,32,124,124,32,117,115,101,80,101,101,112,104,111,108,101,32,38,38,32,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,54,0,116,111,116,97,108,40,111,117,116,84,97,105,108,83,104,97,112,101,95,41,32,61,61,32,95,110,117,109,79,117,116,0,105,110,112,48,46,115,105,122,101,40,41,32,62,61,32,50,32,38,38,32,116,111,116,97,108,40,105,110,112,48,44,32,50,41,32,61,61,32,95,110,117,109,73,110,112,0,105,110,112,48,46,115,105,122,101,40,41,32,62,61,32,50,32,38,38,32,116,111,116,97,108,40,105,110,112,48,44,32,49,41,32,61,61,32,95,110,117,109,73,110,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,76,83,84,77,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,70,117,110,99,116,105,111,110,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,102,108,111,97,116,105,110,103,32,112,111,105,110,116,32,116,121,112,101,115,0,116,97,110,104,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,76,83,84,77,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,105,110,112,117,116,46,115,105,122,101,40,41,32,61,61,32,49,0,116,111,116,97,108,40,111,117,116,84,97,105,108,83,104,97,112,101,41,32,61,61,32,110,117,109,79,117,116,0,105,110,112,48,46,100,105,109,115,32,62,61,32,50,32,38,38,32,40,105,110,116,41,105,110,112,48,46,116,111,116,97,108,40,50,41,32,61,61,32,110,117,109,73,110,112,0,105,110,112,48,46,100,105,109,115,32,62,61,32,50,32,38,38,32,40,105,110,116,41,105,110,112,48,46,116,111,116,97,108,40,49,41,32,61,61,32,110,117,109,73,110,112,0,78,50,99,118,51,100,110,110,49,51,76,83,84,77,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,51,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,49,32,60,61,32,98,108,111,98,115,46,115,105,122,101,40,41,32,38,38,32,98,108,111,98,115,46,115,105,122,101,40,41,32,60,61,32,50,0,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,102,117,108,108,121,95,99,111,110,110,101,99,116,101,100,95,108,97,121,101,114,46,99,112,112,0,110,117,109,95,111,117,116,112,117,116,0,98,108,111,98,115,91,48,93,46,100,105,109,115,32,62,61,32,50,32,38,38,32,40,115,105,122,101,95,116,41,40,105,110,110,101,114,83,105,122,101,32,42,32,110,117,109,79,117,116,112,117,116,41,32,61,61,32,98,108,111,98,115,91,48,93,46,116,111,116,97,108,40,41,0,33,98,105,97,115,32,124,124,32,40,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,50,32,38,38,32,40,115,105,122,101,95,116,41,110,117,109,79,117,116,112,117,116,32,61,61,32,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,41,0,98,108,111,98,115,91,48,93,46,100,105,109,115,32,61,61,32,50,0,33,98,105,97,115,32,124,124,32,40,115,105,122,101,95,116,41,110,117,109,79,117,116,112,117,116,32,61,61,32,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,115,114,99,77,97,116,46,100,105,109,115,32,61,61,32,50,32,38,38,32,115,114,99,77,97,116,46,99,111,108,115,32,61,61,32,119,101,105,103,104,116,115,46,99,111,108,115,32,38,38,32,100,115,116,77,97,116,46,114,111,119,115,32,61,61,32,115,114,99,77,97,116,46,114,111,119,115,32,38,38,32,100,115,116,77,97,116,46,99,111,108,115,32,61,61,32,119,101,105,103,104,116,115,46,114,111,119,115,32,38,38,32,115,114,99,77,97,116,46,116,121,112,101,40,41,32,61,61,32,119,101,105,103,104,116,115,46,116,121,112,101,40,41,32,38,38,32,119,101,105,103,104,116,115,46,116,121,112,101,40,41,32,61,61,32,100,115,116,77,97,116,46,116,121,112,101,40,41,32,38,38,32,115,114,99,77,97,116,46,116,121,112,101,40,41,32,61,61,32,53,32,38,38,32,40,98,105,97,115,77,97,116,46,101,109,112,116,121,40,41,32,124,124,32,40,98,105,97,115,77,97,116,46,116,121,112,101,40,41,32,61,61,32,115,114,99,77,97,116,46,116,121,112,101,40,41,32,38,38,32,98,105,97,115,77,97,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,40,105,110,116,41,98,105,97,115,77,97,116,46,116,111,116,97,108,40,41,32,61,61,32,100,115,116,77,97,116,46,99,111,108,115,41,41,0,78,50,99,118,51,100,110,110,50,51,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,49,52,70,117,108,108,121,67,111,110,110,101,99,116,101,100,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,50,51,70,117,108,108,121,67,111,110,110,101,99,116,101,100,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,55,73,110,110,101,114,80,114,111,100,117,99,116,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,55,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,115,99,97,108,101,115,0,95,119,105,100,116,104,115,46,115,105,122,101,40,41,32,61,61,32,95,104,101,105,103,104,116,115,46,115,105,122,101,40,41,0,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,114,105,111,114,95,98,111,120,95,108,97,121,101,114,46,99,112,112,0,95,97,115,112,101,99,116,82,97,116,105,111,115,46,101,109,112,116,121,40,41,0,33,112,97,114,97,109,115,46,104,97,115,40,34,109,105,110,95,115,105,122,101,34,41,0,33,112,97,114,97,109,115,46,104,97,115,40,34,109,97,120,95,115,105,122,101,34,41,0,33,95,97,115,112,101,99,116,82,97,116,105,111,115,46,101,109,112,116,121,40,41,0,95,109,105,110,83,105,122,101,32,62,32,48,0,95,109,97,120,83,105,122,101,32,62,32,95,109,105,110,83,105,122,101,0,115,116,101,112,95,104,0,115,116,101,112,95,119,0,33,112,97,114,97,109,115,46,104,97,115,40,34,115,116,101,112,34,41,0,95,115,116,101,112,89,32,62,32,48,46,0,95,115,116,101,112,88,32,62,32,48,46,0,111,102,102,115,101,116,0,33,112,97,114,97,109,115,46,104,97,115,40,34,111,102,102,115,101,116,34,41,0,112,97,114,97,109,115,46,104,97,115,40,34,111,102,102,115,101,116,95,104,34,41,0,112,97,114,97,109,115,46,104,97,115,40,34,111,102,102,115,101,116,95,119,34,41,0,95,111,102,102,115,101,116,115,88,46,115,105,122,101,40,41,32,61,61,32,95,111,102,102,115,101,116,115,89,46,115,105,122,101,40,41,0,118,97,114,105,97,110,99,101,80,97,114,97,109,101,116,101,114,82,101,116,114,105,101,118,101,100,0,103,101,116,86,97,114,105,97,110,99,101,0,118,97,114,105,97,110,99,101,83,105,122,101,32,61,61,32,52,0,118,97,114,105,97,110,99,101,32,62,32,48,0,97,115,112,101,99,116,95,114,97,116,105,111,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,95,115,99,97,108,101,115,46,115,105,122,101,40,41,32,61,61,32,114,101,97,108,95,110,117,109,80,114,105,111,114,115,0,95,97,115,112,101,99,116,82,97,116,105,111,115,46,101,109,112,116,121,40,41,32,124,124,32,40,95,109,97,120,83,105,122,101,32,62,32,48,32,63,32,50,32,58,32,49,41,32,43,32,95,97,115,112,101,99,116,82,97,116,105,111,115,46,115,105,122,101,40,41,32,61,61,32,95,115,99,97,108,101,115,46,115,105,122,101,40,41,0,95,119,105,100,116,104,115,46,101,109,112,116,121,40,41,32,124,124,32,95,119,105,100,116,104,115,46,115,105,122,101,40,41,32,61,61,32,95,115,99,97,108,101,115,46,115,105,122,101,40,41,0,116,111,116,97,108,40,41,32,61,61,32,48,32,124,124,32,100,97,116,97,32,33,61,32,48,76,0,77,97,116,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,55,80,114,105,111,114,66,111,120,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,51,80,114,105,111,114,66,111,120,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,52,83,108,105,99,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,115,108,105,99,101,95,112,111,105,110,116,0,98,101,103,105,110,0,101,110,100,0,33,112,97,114,97,109,115,46,104,97,115,40,34,98,101,103,105,110,34,41,32,38,38,32,33,112,97,114,97,109,115,46,104,97,115,40,34,115,105,122,101,34,41,32,38,38,32,33,112,97,114,97,109,115,46,104,97,115,40,34,101,110,100,34,41,0,83,108,105,99,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,108,105,99,101,95,108,97,121,101,114,46,99,112,112,0,112,97,114,97,109,115,46,104,97,115,40,34,115,105,122,101,34,41,32,94,32,112,97,114,97,109,115,46,104,97,115,40,34,101,110,100,34,41,0,98,101,103,105,110,115,46,115,105,122,101,40,41,32,61,61,32,115,105,122,101,115,79,114,69,110,100,115,46,115,105,122,101,40,41,0,115,116,97,114,116,32,62,61,32,48,0,115,105,122,101,32,61,61,32,45,49,32,124,124,32,115,105,122,101,32,62,32,48,0,101,110,100,32,60,32,48,32,124,124,32,101,110,100,32,62,32,115,116,97,114,116,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,48,83,108,105,99,101,76,97,121,101,114,69,0,115,108,105,99,101,82,97,110,103,101,115,91,105,93,46,115,105,122,101,40,41,32,60,61,32,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,0,48,32,60,61,32,97,120,105,115,32,38,38,32,97,120,105,115,32,60,32,105,110,112,83,104,97,112,101,46,115,105,122,101,40,41,0,114,101,113,117,105,114,101,100,79,117,116,112,117,116,115,32,62,32,48,32,38,38,32,105,110,112,83,104,97,112,101,91,97,120,105,115,93,32,37,32,114,101,113,117,105,114,101,100,79,117,116,112,117,116,115,32,61,61,32,48,0,99,108,97,109,112,101,100,46,115,116,97,114,116,32,60,32,99,108,97,109,112,101,100,46,101,110,100,0,99,108,97,109,112,0,99,108,97,109,112,101,100,46,101,110,100,32,60,61,32,97,120,105,115,83,105,122,101,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,83,108,105,99,101,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,115,108,105,99,101,82,97,110,103,101,115,46,115,105,122,101,40,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,83,108,105,99,101,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,115,108,105,99,101,82,97,110,103,101,115,91,105,93,46,115,105,122,101,40,41,32,60,61,32,105,110,112,83,104,97,112,101,91,45,49,93,0,78,50,99,118,51,100,110,110,49,52,83,108,105,99,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,111,112,101,114,97,116,105,111,110,0,112,114,111,100,0,115,117,109,0,85,110,107,110,111,119,110,32,111,112,101,114,97,116,105,99,111,110,32,116,121,112,101,32,34,0,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,101,108,116,119,105,115,101,95,108,97,121,101,114,46,99,112,112,0,99,111,101,102,102,0,105,110,112,117,116,115,46,115,105,122,101,40,41,0,103,101,116,70,76,79,80,83,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,61,32,50,0,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,48,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,105,110,112,117,116,115,46,115,105,122,101,40,41,0,111,112,32,61,61,32,83,85,77,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,48,0,105,110,112,117,116,115,91,48,93,32,61,61,32,105,110,112,117,116,115,91,105,93,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,49,32,60,32,100,115,116,46,100,105,109,115,32,38,38,32,100,115,116,46,100,105,109,115,32,60,61,32,52,0,100,115,116,46,116,121,112,101,40,41,32,61,61,32,53,0,99,111,101,102,102,115,46,101,109,112,116,121,40,41,32,124,124,32,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,115,114,99,115,0,115,114,99,115,91,105,93,45,62,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,115,91,105,93,45,62,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,32,38,38,32,115,114,99,115,91,105,93,45,62,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,100,115,116,46,116,111,116,97,108,40,41,32,61,61,32,100,115,116,46,115,105,122,101,91,48,93,32,42,32,112,46,99,104,97,110,110,101,108,115,32,42,32,112,46,112,108,97,110,101,83,105,122,101,0,99,111,101,102,102,115,46,115,105,122,101,40,41,32,61,61,32,40,115,105,122,101,95,116,41,110,115,114,99,115,0,78,50,99,118,51,100,110,110,49,54,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,49,52,69,108,116,119,105,115,101,73,110,118,111,107,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,54,69,108,116,119,105,115,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,55,80,114,111,112,111,115,97,108,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,102,101,97,116,95,115,116,114,105,100,101,0,98,97,115,101,95,115,105,122,101,0,112,114,101,95,110,109,115,95,116,111,112,110,0,112,111,115,116,95,110,109,115,95,116,111,112,110,0,110,109,115,95,116,104,114,101,115,104,0,114,97,116,105,111,0,111,114,100,101,114,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,51,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,114,111,112,111,115,97,108,95,108,97,121,101,114,46,99,112,112,0,108,97,121,101,114,79,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,0,108,97,121,101,114,73,110,116,101,114,110,97,108,115,46,101,109,112,116,121,40,41,0,115,99,111,114,101,115,46,115,105,122,101,40,41,32,61,61,32,52,0,40,115,99,111,114,101,115,91,49,93,32,38,32,49,41,32,61,61,32,48,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,114,111,112,111,115,97,108,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,105,110,116,101,114,110,97,108,115,46,115,105,122,101,40,41,32,61,61,32,51,0,105,109,73,110,102,111,46,116,111,116,97,108,40,41,32,62,61,32,50,0,110,117,109,68,101,116,115,32,60,61,32,107,101,101,112,84,111,112,65,102,116,101,114,78,77,83,0,109,46,100,105,109,115,32,61,61,32,52,0,103,101,116,79,98,106,101,99,116,83,99,111,114,101,115,0,109,46,115,105,122,101,91,48,93,32,61,61,32,49,0,40,99,104,97,110,110,101,108,115,32,38,32,49,41,32,61,61,32,48,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,114,111,112,111,115,97,108,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,98,98,111,120,68,101,108,116,97,115,45,62,100,105,109,115,32,61,61,32,52,0,78,50,99,118,51,100,110,110,49,55,80,114,111,112,111,115,97,108,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,51,80,114,111,112,111,115,97,108,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,82,101,115,104,97,112,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,110,117,109,65,120,101,115,32,62,61,32,45,49,0,82,101,115,104,97,112,101,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,115,104,97,112,101,95,108,97,121,101,114,46,99,112,112,0,100,105,109,0,115,105,122,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,100,110,110,47,100,110,110,46,105,110,108,46,104,112,112,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,50,82,101,115,104,97,112,101,76,97,121,101,114,69,0,116,111,116,97,108,40,115,114,99,83,104,97,112,101,44,32,115,114,99,82,97,110,103,101,46,115,116,97,114,116,44,32,115,114,99,82,97,110,103,101,46,101,110,100,41,32,61,61,32,109,97,115,107,84,111,116,97,108,0,99,111,109,112,117,116,101,83,104,97,112,101,66,121,82,101,115,104,97,112,101,77,97,115,107,0,48,32,60,61,32,115,114,99,82,97,110,103,101,46,115,116,97,114,116,32,38,38,32,115,114,99,82,97,110,103,101,46,115,116,97,114,116,32,60,61,32,115,114,99,82,97,110,103,101,46,101,110,100,32,38,38,32,115,114,99,82,97,110,103,101,46,101,110,100,32,60,61,32,115,114,99,83,104,97,112,101,83,105,122,101,0,67,111,112,121,32,100,105,109,91,37,100,93,32,40,119,104,105,99,104,32,104,97,115,32,122,101,114,111,32,115,105,122,101,41,32,105,115,32,111,117,116,32,111,102,32,116,104,101,32,115,111,117,114,99,101,32,115,104,97,112,101,32,98,111,117,110,100,115,0,68,117,112,108,105,99,97,116,101,32,111,102,32,105,110,102,101,114,114,101,100,32,100,105,109,32,40,119,104,105,99,104,32,105,115,32,100,101,110,111,116,101,100,32,98,121,32,45,49,41,0,109,97,115,107,83,104,97,112,101,91,105,93,32,62,61,32,45,49,0,67,97,110,39,116,32,105,110,102,101,114,32,97,32,100,105,109,32,100,101,110,111,116,101,100,32,98,121,32,45,49,0,115,114,99,84,111,116,97,108,32,61,61,32,100,115,116,84,111,116,97,108,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,82,101,115,104,97,112,101,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,82,101,115,104,97,112,101,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,54,82,101,115,104,97,112,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,53,82,101,103,105,111,110,76,97,121,101,114,73,109,112,108,69,78],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+419902);allocate([83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,49,0,82,101,103,105,111,110,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,103,105,111,110,95,108,97,121,101,114,46,99,112,112,0,116,104,114,101,115,104,0,99,111,111,114,100,115,0,99,108,97,115,115,101,115,0,97,110,99,104,111,114,115,0,115,111,102,116,109,97,120,95,116,114,101,101,0,115,111,102,116,109,97,120,0,110,109,115,84,104,114,101,115,104,111,108,100,32,62,61,32,48,46,0,99,111,111,114,100,115,32,61,61,32,52,0,99,108,97,115,115,101,115,32,62,61,32,49,0,97,110,99,104,111,114,115,32,62,61,32,49,0,117,115,101,83,111,102,116,109,97,120,84,114,101,101,32,124,124,32,117,115,101,83,111,102,116,109,97,120,0,105,110,112,117,116,115,91,48,93,91,51,93,32,61,61,32,40,49,32,43,32,99,111,111,114,100,115,32,43,32,99,108,97,115,115,101,115,41,42,97,110,99,104,111,114,115,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,82,101,103,105,111,110,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,61,32,49,0,89,111,108,111,57,48,48,48,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,110,109,115,46,105,110,108,46,104,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,82,101,103,105,111,110,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,53,82,101,103,105,111,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,49,82,101,103,105,111,110,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,83,111,102,116,77,97,120,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,108,111,103,95,115,111,102,116,109,97,120,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,83,111,102,116,77,97,120,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,111,102,116,109,97,120,95,108,97,121,101,114,46,99,112,112,0,48,32,60,61,32,115,116,97,114,116,68,105,109,32,38,38,32,115,116,97,114,116,68,105,109,32,60,61,32,101,110,100,68,105,109,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,99,111,114,101,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,99,111,114,101,47,109,97,116,46,105,110,108,46,104,112,112,0,115,114,99,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,83,111,102,116,77,97,120,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,54,83,111,102,116,77,97,120,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,50,83,111,102,116,109,97,120,76,97,121,101,114,69,0,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,50,52,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,110,117,109,95,99,108,97,115,115,101,115,0,115,104,97,114,101,95,108,111,99,97,116,105,111,110,0,98,97,99,107,103,114,111,117,110,100,95,108,97,98,101,108,95,105,100,0,118,97,114,105,97,110,99,101,95,101,110,99,111,100,101,100,95,105,110,95,116,97,114,103,101,116,0,107,101,101,112,95,116,111,112,95,107,0,99,111,110,102,105,100,101,110,99,101,95,116,104,114,101,115,104,111,108,100,0,116,111,112,95,107,0,108,111,99,95,112,114,101,100,95,116,114,97,110,115,112,111,115,101,100,0,110,111,114,109,97,108,105,122,101,100,95,98,98,111,120,0,110,109,115,95,116,104,114,101,115,104,111,108,100,0,95,110,109,115,84,104,114,101,115,104,111,108,100,32,62,32,48,46,0,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,100,101,116,101,99,116,105,111,110,95,111,117,116,112,117,116,95,108,97,121,101,114,46,99,112,112,0,99,111,100,101,95,116,121,112,101,0,99,101,110,116,101,114,95,115,105,122,101,0,67,69,78,84,69,82,95,83,73,90,69,0,67,79,82,78,69,82,0,32,108,97,121,101,114,32,112,97,114,97,109,101,116,101,114,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,0,32,112,97,114,97,109,101,116,101,114,46,0,103,101,116,80,97,114,97,109,101,116,101,114,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,61,32,51,0,105,110,112,117,116,115,91,48,93,91,48,93,32,61,61,32,105,110,112,117,116,115,91,49,93,91,48,93,0,40,110,117,109,80,114,105,111,114,115,32,42,32,95,110,117,109,76,111,99,67,108,97,115,115,101,115,32,42,32,52,41,32,61,61,32,105,110,112,117,116,115,91,48,93,91,49,93,0,105,110,116,40,110,117,109,80,114,105,111,114,115,32,42,32,95,110,117,109,67,108,97,115,115,101,115,41,32,61,61,32,105,110,112,117,116,115,91,49,93,91,49,93,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,95,98,98,111,120,101,115,78,111,114,109,97,108,105,122,101,100,32,124,124,32,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,61,32,52,0,105,110,112,117,116,115,91,51,93,45,62,100,105,109,115,32,61,61,32,52,0,99,111,117,110,116,32,61,61,32,110,117,109,75,101,112,116,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,99,111,110,102,105,100,101,110,99,101,32,112,114,101,100,105,99,116,105,111,110,115,32,102,111,114,32,108,97,98,101,108,32,37,100,0,111,117,116,112,117,116,68,101,116,101,99,116,105,111,110,115,95,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,108,111,99,97,116,105,111,110,32,112,114,101,100,105,99,116,105,111,110,115,32,102,111,114,32,108,97,98,101,108,32,37,100,0,112,114,111,99,101,115,115,68,101,116,101,99,116,105,111,110,115,95,0,105,100,120,32,60,32,115,99,111,114,101,115,46,115,105,122,101,40,41,0,98,98,111,120,101,115,46,115,105,122,101,40,41,32,61,61,32,115,99,111,114,101,115,46,115,105,122,101,40,41,0,78,77,83,70,97,115,116,95,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,46,46,47,110,109,115,46,105,110,108,46,104,112,112,0,97,108,108,95,108,111,99,95,112,114,101,100,115,46,115,105,122,101,40,41,32,61,61,32,110,117,109,0,68,101,99,111,100,101,66,66,111,120,101,115,65,108,108,0,112,114,105,111,114,95,98,98,111,120,101,115,46,115,105,122,101,40,41,32,61,61,32,112,114,105,111,114,95,118,97,114,105,97,110,99,101,115,46,115,105,122,101,40,41,0,68,101,99,111,100,101,66,66,111,120,101,115,0,112,114,105,111,114,95,98,98,111,120,101,115,46,115,105,122,101,40,41,32,61,61,32,98,98,111,120,101,115,46,115,105,122,101,40,41,0,110,117,109,95,98,98,111,120,101,115,32,61,61,32,48,32,124,124,32,112,114,105,111,114,95,118,97,114,105,97,110,99,101,115,91,48,93,46,115,105,122,101,40,41,32,61,61,32,52,0,112,114,105,111,114,95,119,105,100,116,104,32,62,32,48,0,68,101,99,111,100,101,66,66,111,120,0,112,114,105,111,114,95,104,101,105,103,104,116,32,62,32,48,0,85,110,107,110,111,119,110,32,116,121,112,101,46,0,110,117,109,76,111,99,67,108,97,115,115,101,115,32,61,61,32,49,0,71,101,116,76,111,99,80,114,101,100,105,99,116,105,111,110,115,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,50,52,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,50,48,68,101,116,101,99,116,105,111,110,79,117,116,112,117,116,76,97,121,101,114,69,0,115,99,97,108,101,95,116,114,97,105,110,0,100,114,111,112,111,117,116,95,114,97,116,105,111,0,115,99,97,108,101,32,62,32,48,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,98,108,97,110,107,95,108,97,121,101,114,46,99,112,112,0,80,111,119,101,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,52,66,108,97,110,107,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,66,108,97,110,107,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,66,108,97,110,107,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,52,66,108,97,110,107,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,48,66,108,97,110,107,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,50,77,86,78,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,110,111,114,109,97,108,105,122,101,95,118,97,114,105,97,110,99,101,0,97,99,114,111,115,115,95,99,104,97,110,110,101,108,115,0,101,112,115,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,77,86,78,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,109,118,110,95,108,97,121,101,114,46,99,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,77,86,78,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,50,77,86,78,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,56,77,86,78,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,52,83,99,97,108,101,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,98,105,97,115,95,116,101,114,109,0,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,49,32,43,32,104,97,115,66,105,97,115,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,115,99,97,108,101,95,108,97,121,101,114,46,99,112,112,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,83,99,97,108,101,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,105,110,112,66,108,111,98,46,115,105,122,101,91,49,93,32,61,61,32,98,108,111,98,115,91,48,93,46,116,111,116,97,108,40,41,0,105,110,112,66,108,111,98,46,115,105,122,101,91,49,93,32,61,61,32,98,108,111,98,115,91,49,93,46,116,111,116,97,108,40,41,0,105,110,112,66,108,111,98,46,116,121,112,101,40,41,32,61,61,32,53,32,38,38,32,111,117,116,66,108,111,98,46,116,121,112,101,40,41,32,61,61,32,53,0,109,46,100,105,109,115,32,62,61,32,50,0,115,108,105,99,101,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,83,99,97,108,101,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,52,83,99,97,108,101,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,51,48,82,101,115,105,122,101,78,101,97,114,101,115,116,78,101,105,103,104,98,111,114,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,119,105,100,116,104,0,112,97,114,97,109,115,46,104,97,115,40,34,119,105,100,116,104,34,41,0,82,101,115,105,122,101,78,101,97,114,101,115,116,78,101,105,103,104,98,111,114,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,114,101,115,105,122,101,95,110,101,97,114,101,115,116,95,110,101,105,103,104,98,111,114,95,108,97,121,101,114,46,99,112,112,0,104,101,105,103,104,116,0,112,97,114,97,109,115,46,104,97,115,40,34,104,101,105,103,104,116,34,41,0,97,108,105,103,110,95,99,111,114,110,101,114,115,0,78,101,97,114,101,115,116,32,110,101,105,103,104,98,111,114,104,111,111,100,32,114,101,115,105,122,101,32,119,105,116,104,32,97,108,105,103,110,95,99,111,114,110,101,114,115,61,116,114,117,101,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,105,110,112,117,116,115,91,48,93,46,115,105,122,101,40,41,32,61,61,32,52,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,82,101,115,105,122,101,78,101,97,114,101,115,116,78,101,105,103,104,98,111,114,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,109,46,100,105,109,115,32,62,32,50,0,103,101,116,80,108,97,110,101,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,82,101,115,105,122,101,78,101,97,114,101,115,116,78,101,105,103,104,98,111,114,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,51,48,82,101,115,105,122,101,78,101,97,114,101,115,116,78,101,105,103,104,98,111,114,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,50,54,82,101,115,105,122,101,78,101,97,114,101,115,116,78,101,105,103,104,98,111,114,76,97,121,101,114,69,0,110,101,103,97,116,105,118,101,95,115,108,111,112,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,49,82,101,76,85,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,82,101,76,85,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,82,101,76,85,70,117,110,99,116,111,114,93,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,101,108,101,109,101,110,116,119,105,115,101,95,108,97,121,101,114,115,46,99,112,112,0,115,114,99,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,32,38,38,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,32,38,38,32,115,114,99,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,115,114,99,46,116,121,112,101,40,41,32,61,61,32,53,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,82,101,76,85,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,82,101,76,85,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,82,101,76,85,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,82,101,76,85,70,117,110,99,116,111,114,69,69,69,0,109,105,110,95,118,97,108,117,101,0,109,97,120,95,118,97,108,117,101,0,109,105,110,86,97,108,117,101,32,60,61,32,109,97,120,86,97,108,117,101,0,82,101,76,85,54,70,117,110,99,116,111,114,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,50,82,101,76,85,54,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,82,101,76,85,54,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,82,101,76,85,54,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,50,82,101,76,85,54,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,82,101,76,85,54,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,82,101,76,85,54,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,50,82,101,76,85,54,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,48,82,101,76,85,54,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,49,84,97,110,72,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,84,97,110,72,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,84,97,110,72,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,84,97,110,72,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,84,97,110,72,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,84,97,110,72,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,84,97,110,72,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,57,84,97,110,72,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,52,83,105,103,109,111,105,100,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,83,105,103,109,111,105,100,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,83,105,103,109,111,105,100,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,52,83,105,103,109,111,105,100,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,83,105,103,109,111,105,100,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,83,105,103,109,111,105,100,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,52,83,105,103,109,111,105,100,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,50,83,105,103,109,111,105,100,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,48,69,76,85,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,69,76,85,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,69,76,85,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,48,69,76,85,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,69,76,85,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,69,76,85,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,48,69,76,85,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,56,69,76,85,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,51,65,98,115,86,97,108,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,65,98,115,86,97,108,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,65,98,115,86,97,108,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,51,65,98,115,86,97,108,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,65,98,115,86,97,108,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,65,98,115,86,97,108,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,51,65,98,115,86,97,108,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,56,65,98,115,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,49,66,78,76,76,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,66,78,76,76,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,66,78,76,76,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,66,78,76,76,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,66,78,76,76,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,66,78,76,76,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,49,66,78,76,76,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,57,66,78,76,76,76,97,121,101,114,69,0,112,111,119,101,114,0,115,99,97,108,101,0,115,104,105,102,116,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,49,50,80,111,119,101,114,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,80,111,119,101,114,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,80,111,119,101,114,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,50,80,111,119,101,114,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,80,111,119,101,114,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,80,111,119,101,114,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,49,50,80,111,119,101,114,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,48,80,111,119,101,114,76,97,121,101,114,69,0,112,97,114,97,109,115,46,98,108,111,98,115,46,115,105,122,101,40,41,32,61,61,32,49,0,99,114,101,97,116,101,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,50,95,50,48,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,69,69,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,53,95,69,69,69,69,0,115,99,97,108,101,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,115,99,97,108,101,46,116,121,112],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+430142);allocate([101,40,41,32,61,61,32,53,0,97,112,112,108,121,0,48,32,60,61,32,99,110,48,32,38,38,32,99,110,48,32,60,32,99,110,49,32,38,38,32,99,110,49,32,60,61,32,40,105,110,116,41,115,99,97,108,101,46,116,111,116,97,108,40,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,50,48,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,69,69,53,80,66,111,100,121,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,60,99,118,58,58,100,110,110,58,58,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,62,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,32,91,70,117,110,99,32,61,32,99,118,58,58,100,110,110,58,58,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,93,0,78,50,99,118,51,100,110,110,49,54,69,108,101,109,101,110,116,87,105,115,101,76,97,121,101,114,73,78,83,48,95,50,48,67,104,97,110,110,101,108,115,80,82,101,76,85,70,117,110,99,116,111,114,69,69,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,53,67,111,110,99,97,116,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,112,97,100,100,105,110,103,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,99,111,110,99,97,116,95,108,97,121,101,114,46,99,112,112,0,99,117,114,83,104,97,112,101,46,115,105,122,101,40,41,32,61,61,32,111,117,116,112,117,116,115,91,48,93,46,115,105,122,101,40,41,0,73,110,99,111,110,115,105,116,101,110,116,32,115,104,97,112,101,32,102,111,114,32,67,111,110,99,97,116,76,97,121,101,114,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,67,111,110,99,97,116,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,105,110,112,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,105,110,112,46,116,121,112,101,40,41,32,61,61,32,53,32,38,38,32,105,110,112,46,100,105,109,115,32,61,61,32,52,32,38,38,32,105,110,112,46,115,105,122,101,91,48,93,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,48,93,32,38,38,32,105,110,112,46,115,105,122,101,91,50,93,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,50,93,32,38,38,32,105,110,112,46,115,105,122,101,91,51,93,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,51,93,0,110,99,104,97,110,110,101,108,115,32,61,61,32,111,117,116,112,117,116,46,115,105,122,101,91,49,93,0,111,117,116,112,117,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,32,38,38,32,111,117,116,112,117,116,46,116,121,112,101,40,41,32,61,61,32,53,0,78,50,99,118,51,100,110,110,49,53,67,111,110,99,97,116,76,97,121,101,114,73,109,112,108,50,48,67,104,97,110,110,101,108,67,111,110,99,97,116,73,110,118,111,107,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,67,111,110,99,97,116,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,53,67,111,110,99,97,116,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,70,108,97,116,116,101,110,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,62,32,48,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,102,108,97,116,116,101,110,95,108,97,121,101,114,46,99,112,112,0,105,110,112,117,116,115,91,105,93,32,61,61,32,105,110,112,117,116,115,91,48,93,0,115,116,97,114,116,65,120,105,115,32,62,61,32,48,0,101,110,100,65,120,105,115,32,62,61,32,115,116,97,114,116,65,120,105,115,32,38,38,32,101,110,100,65,120,105,115,32,60,32,40,105,110,116,41,110,117,109,65,120,101,115,0,111,117,116,112,117,116,83,104,97,112,101,86,101,99,46,115,105,122,101,40,41,32,60,61,32,52,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,70,108,97,116,116,101,110,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,70,108,97,116,116,101,110,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,78,50,99,118,51,100,110,110,49,54,70,108,97,116,116,101,110,76,97,121,101,114,73,109,112,108,69,0,78,50,99,118,51,100,110,110,49,57,101,120,112,101,114,105,109,101,110,116,97,108,95,100,110,110,95,118,51,49,50,70,108,97,116,116,101,110,76,97,121,101,114,69,0,78,50,99,118,54,100,101,116,97,105,108,49,50,80,116,114,79,119,110,101,114,73,109,112,108,73,78,83,95,51,100,110,110,49,54,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,69,78,83,95,49,52,68,101,102,97,117,108,116,68,101,108,101,116,101,114,73,83,51,95,69,69,69,69,0,107,101,114,110,101,108,95,115,105,122,101,0,109,97,120,0,97,118,101,0,115,116,111,99,104,97,115,116,105,99,0,85,110,107,110,111,119,110,32,112,111,111,108,105,110,103,32,116,121,112,101,32,34,0,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,108,97,121,101,114,115,47,112,111,111,108,105,110,103,95,108,97,121,101,114,46,99,112,112,0,111,117,116,112,117,116,95,100,105,109,0,103,114,111,117,112,95,115,105,122,101,0,67,97,110,110,111,116,32,100,101,116,101,114,109,105,110,101,32,112,111,111,108,105,110,103,32,116,121,112,101,0,99,101,105,108,95,109,111,100,101,0,115,112,97,116,105,97,108,95,115,99,97,108,101,0,115,116,97,114,116,32,60,61,32,40,105,110,116,41,115,104,97,112,101,46,115,105,122,101,40,41,32,38,38,32,101,110,100,32,60,61,32,40,105,110,116,41,115,104,97,112,101,46,115,105,122,101,40,41,32,38,38,32,115,116,97,114,116,32,60,61,32,101,110,100,0,116,111,116,97,108,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,105,110,99,108,117,100,101,47,111,112,101,110,99,118,50,47,100,110,110,47,115,104,97,112,101,95,117,116,105,108,115,46,104,112,112,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,33,61,32,48,0,103,101,116,77,101,109,111,114,121,83,104,97,112,101,115,0,40,111,117,116,46,104,101,105,103,104,116,32,45,32,49,41,32,42,32,115,116,114,105,100,101,46,104,101,105,103,104,116,32,60,32,105,110,46,104,101,105,103,104,116,32,43,32,112,97,100,46,104,101,105,103,104,116,0,40,111,117,116,46,119,105,100,116,104,32,45,32,49,41,32,42,32,115,116,114,105,100,101,46,119,105,100,116,104,32,60,32,105,110,46,119,105,100,116,104,32,43,32,112,97,100,46,119,105,100,116,104,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,50,0,112,115,82,111,105,79,117,116,67,104,97,110,110,101,108,115,32,42,32,112,111,111,108,101,100,83,105,122,101,46,119,105,100,116,104,32,42,32,112,111,111,108,101,100,83,105,122,101,46,104,101,105,103,104,116,32,61,61,32,105,110,112,117,116,115,91,48,93,91,49,93,0,110,97,109,101,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,73,110,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,44,32,79,117,116,112,117,116,65,114,114,97,121,79,102,65,114,114,97,121,115,41,0,105,110,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,0,102,111,114,119,97,114,100,0,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,50,0,111,117,116,112,117,116,115,46,115,105,122,101,40,41,32,61,61,32,49,0,78,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,115,114,99,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,114,117,110,0,100,115,116,46,105,115,67,111,110,116,105,110,117,111,117,115,40,41,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,53,0,115,114,99,46,116,121,112,101,40,41,32,61,61,32,100,115,116,46,116,121,112,101,40,41,0,115,114,99,46,100,105,109,115,32,61,61,32,52,0,100,115,116,46,100,105,109,115,32,61,61,32,52,0,40,40,112,111,111,108,105,110,103,84,121,112,101,32,61,61,32,82,79,73,32,124,124,32,112,111,111,108,105,110,103,84,121,112,101,32,61,61,32,80,83,82,79,73,41,32,38,38,32,100,115,116,46,115,105,122,101,91,48,93,32,61,61,114,111,105,115,46,115,105,122,101,91,48,93,32,124,124,32,115,114,99,46,115,105,122,101,91,48,93,32,61,61,32,100,115,116,46,115,105,122,101,91,48,93,41,0,112,111,111,108,105,110,103,84,121,112,101,32,61,61,32,80,83,82,79,73,32,124,124,32,115,114,99,46,115,105,122,101,91,49,93,32,61,61,32,100,115,116,46,115,105,122,101,91,49,93,0,40,109,97,115,107,46,101,109,112,116,121,40,41,32,124,124,32,40,109,97,115,107,46,116,121,112,101,40,41,32,61,61,32,115,114,99,46,116,121,112,101,40,41,32,38,38,32,109,97,115,107,46,115,105,122,101,32,61,61,32,100,115,116,46,115,105,122,101,41,41,0,114,111,105,115,68,97,116,97,91,48,93,32,60,32,115,114,99,45,62,115,105,122,101,91,48,93,0,78,50,99,118,51,100,110,110,49,54,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,49,52,80,111,111,108,105,110,103,73,110,118,111,107,101,114,69,0,118,105,114,116,117,97,108,32,118,111,105,100,32,99,118,58,58,100,110,110,58,58,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,58,58,102,111,114,119,97,114,100,40,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,32,42,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,44,32,115,116,100,58,58,118,101,99,116,111,114,60,77,97,116,62,32,38,41,0,33,105,110,112,117,116,115,46,101,109,112,116,121,40,41,0,102,105,110,97,108,105,122,101,0,78,50,99,118,51,100,110,110,49,54,80,111,111,108,105,110,103,76,97,121,101,114,73,109,112,108,69,0,100,102,115,101,108,102,45,62,104,97,110,100,108,101,32,33,61,32,48,76,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,109,111,100,117,108,101,115,47,100,110,110,47,115,114,99,47,116,111,114,99,104,47,84,72,68,105,115,107,70,105,108,101,46,99,112,112,0,84,72,68,105,115,107,70,105,108,101,95,109,111,100,101,40,109,111,100,101,44,32,38,105,115,82,101,97,100,97,98,108,101,44,32,38,105,115,87,114,105,116,97,98,108,101,41,0,84,72,68,105,115,107,70,105,108,101,95,110,101,119,0,105,115,82,101,97,100,97,98,108,101,32,38,38,32,33,105,115,87,114,105,116,97,98,108,101,0,114,98,0,99,97,110,110,111,116,32,111,112,101,110,32,60,37,115,62,32,105,110,32,109,111,100,101,32,37,99,37,99,0,99,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,115,101,108,102,0,84,72,68,105,115,107,70,105,108,101,95,99,108,111,115,101,0,84,72,68,105,115,107,70,105,108,101,95,112,111,115,105,116,105,111,110,0,117,110,97,98,108,101,32,116,111,32,111,98,116,97,105,110,32,100,105,115,107,32,102,105,108,101,32,111,102,102,115,101,116,32,40,109,97,121,98,101,32,97,32,108,111,110,103,32,111,118,101,114,102,108,111,119,32,111,99,99,117,114,114,101,100,41,0,84,72,68,105,115,107,70,105,108,101,95,115,101,101,107,69,110,100,0,117,110,97,98,108,101,32,116,111,32,115,101,101,107,32,97,116,32,101,110,100,32,111,102,32,102,105,108,101,0,84,72,68,105,115,107,70,105,108,101,95,115,101,101,107,0,117,110,97,98,108,101,32,116,111,32,115,101,101,107,32,97,116,32,112,111,115,105,116,105,111,110,32,37,100,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,83,116,114,105,110,103,0,100,102,115,101,108,102,45,62,102,105,108,101,46,105,115,82,101,97,100,97,98,108,101,0,40,115,116,114,108,101,110,40,102,111,114,109,97,116,41,32,62,61,32,50,32,63,32,40,102,111,114,109,97,116,91,48,93,32,61,61,32,39,42,39,41,32,38,38,32,40,102,111,114,109,97,116,91,49,93,32,61,61,32,39,97,39,32,124,124,32,102,111,114,109,97,116,91,49,93,32,61,61,32,39,108,39,41,32,58,32,48,41,0,114,101,97,100,32,101,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,98,117,102,102,101,114,0,114,101,97,100,32,101,114,114,111,114,58,32,114,101,97,100,32,48,32,98,108,111,99,107,115,32,105,110,115,116,101,97,100,32,111,102,32,49,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,68,111,117,98,108,101,0,37,108,103,0,114,101,97,100,32,101,114,114,111,114,58,32,114,101,97,100,32,37,100,32,98,108,111,99,107,115,32,105,110,115,116,101,97,100,32,111,102,32,37,100,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,70,108,111,97,116,0,37,103,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,76,111,110,103,0,99,97,110,32,110,111,116,32,97,108,108,111,99,97,116,101,32,98,117,102,102,101,114,0,37,108,100,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,73,110,116,0,37,100,10,13,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,83,104,111,114,116,0,37,104,100,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,67,104,97,114,0,84,72,68,105,115,107,70,105,108,101,95,114,101,97,100,66,121,116,101,0,8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,115,0,37,115,37,115,37,115,0,117,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,102,105,108,101,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,105,110,102,108,97,116,101,32,115,116,114,101,97,109,32,99,111,114,114,117,112,116,0,99,111,109,112,114,101,115,115,101,100,32,100,97,116,97,32,101,114,114,111,114,0,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,100,101,102,108,97,116,101,32,115,116,114,101,97,109,32,99,111,114,114,117,112,116,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,49,46,50,46,49,49,0,105,110,99,111,114,114,101,99,116,32,104,101,97,100,101,114,32,99,104,101,99,107,0,117,110,107,110,111,119,110,32,99,111,109,112,114,101,115,115,105,111,110,32,109,101,116,104,111,100,0,105,110,118,97,108,105,100,32,119,105,110,100,111,119,32,115,105,122,101,0,117,110,107,110,111,119,110,32,104,101,97,100,101,114,32,102,108,97,103,115,32,115,101,116,0,104,101,97,100,101,114,32,99,114,99,32,109,105,115,109,97,116,99,104,0,105,110,118,97,108,105,100,32,98,108,111,99,107,32,116,121,112,101,0,105,110,118,97,108,105,100,32,115,116,111,114,101,100,32,98,108,111,99,107,32,108,101,110,103,116,104,115,0,116,111,111,32,109,97,110,121,32,108,101,110,103,116,104,32,111,114,32,100,105,115,116,97,110,99,101,32,115,121,109,98,111,108,115,0,105,110,118,97,108,105,100,32,99,111,100,101,32,108,101,110,103,116,104,115,32,115,101,116,0,105,110,118,97,108,105,100,32,98,105,116,32,108,101,110,103,116,104,32,114,101,112,101,97,116,0,105,110,118,97,108,105,100,32,99,111,100,101,32,45,45,32,109,105,115,115,105,110,103,32,101,110,100,45,111,102,45,98,108,111,99,107,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,115,32,115,101,116,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,115,32,115,101,116,0,105,110,99,111,114,114,101,99,116,32,100,97,116,97,32,99,104,101,99,107,0,105,110,99,111,114,114,101,99,116,32,108,101,110,103,116,104,32,99,104,101,99,107,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,32,99,111,100,101,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,99,111,100,101,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,116,111,111,32,102,97,114,32,98,97,99,107,0,110,101,101,100,32,100,105,99,116,105,111,110,97,114,121,0,115,116,114,101,97,109,32,101,110,100,0,102,105,108,101,32,101,114,114,111,114,0,115,116,114,101,97,109,32,101,114,114,111,114,0,100,97,116,97,32,101,114,114,111,114,0,105,110,115,117,102,102,105,99,105,101,110,116,32,109,101,109,111,114,121,0,98,117,102,102,101,114,32,101,114,114,111,114,0,105,110,99,111,109,112,97,116,105,98,108,101,32,118,101,114,115,105,111,110,0,0,1,2,3,4,4,5,5,6,6,6,6,7,7,7,7,8,8,8,8,8,8,8,8,9,9,9,9,9,9,9,9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,0,0,16,17,18,18,19,19,20,20,20,20,21,21,21,21,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,29,0,1,2,3,4,5,6,7,8,8,9,9,10,10,11,11,12,12,12,12,13,13,13,13,14,14,14,14,15,15,15,15,16,16,16,16,16,16,16,16,17,17,17,17,17,17,17,17,18,18,18,18,18,18,18,18,19,19,19,19,19,19,19,19,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,26,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,27,28,16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,97,114,101,110,97,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,110,41,32,60,61,32,40,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,115,105,122,101,95,116,62,58,58,109,97,120,40,41,32,45,32,107,72,101,97,100,101,114,83,105,122,101,41,58,32,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,103,101,110,101,114,97,116,101,100,95,109,101,115,115,97,103,101,95,117,116,105,108,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,97,108,115,101,58,32,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,99,111,100,101,100,95,115,116,114,101,97,109,46,99,99,0,84,104,101,32,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,98,121,116,101,115,32,114,101,97,100,32,119,97,115,32,0,82,101,97,100,105,110,103,32,100,97,110,103,101,114,111,117,115,108,121,32,108,97,114,103,101,32,112,114,111,116,111,99,111,108,32,109,101,115,115,97,103,101,46,32,32,73,102,32,116,104,101,32,109,101,115,115,97,103,101,32,116,117,114,110,115,32,111,117,116,32,116,111,32,98,101,32,108,97,114,103,101,114,32,116,104,97,110,32,0,32,98,121,116,101,115,44,32,112,97,114,115,105,110,103,32,119,105,108,108,32,98,101,32,104,97,108,116,101,100,32,102,111,114,32,115,101,99,117,114,105,116,121,32,114,101,97,115,111,110,115,46,32,32,84,111,32,105,110,99,114,101,97,115,101,32,116,104,101,32,108,105,109,105,116,32,40,111,114,32,116,111,32,100,105,115,97,98,108,101,32,116,104,101,115,101,32,119,97,114,110,105,110,103,115,41,44,32,115,101,101,32,67,111,100,101,100,73,110,112,117,116,83,116,114,101,97,109,58,58,83,101,116,84,111,116,97,108,66,121,116,101,115,76,105,109,105,116,40,41,32,105,110,32,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,99,111,100,101,100,95,115,116,114,101,97,109,46,104,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,98,117,102,102,101,114,95,115,105,122,101,41,32,62,61,32,40,48,41,58,32,0,65,32,112,114,111,116,111,99,111,108,32,109,101,115,115,97,103,101,32,119,97,115,32,114,101,106,101,99,116,101,100,32,98,101,99,97,117,115,101,32,105,116,32,119,97,115,32,116,111,111,32,98,105,103,32,40,109,111,114,101,32,116,104,97,110,32,0,32,98,121,116,101,115,41,46,32,32,84,111,32,105,110,99,114,101,97,115,101,32,116,104,101,32,108,105,109,105,116,32,40,111,114,32,116,111,32,100,105,115,97,98,108,101,32,116,104,101,115,101,32,119,97,114,110,105,110,103,115,41,44,32,115,101,101,32,67,111,100,101,100,73,110,112,117,116,83,116,114,101,97,109,58,58,83,101,116,84,111,116,97,108,66,121,116,101,115,76,105,109,105,116,40,41,32,105,110,32,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,99,111,100,101,100,95,115,116,114,101,97,109,46,104,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,122,101,114,111,95,99,111,112,121,95,115,116,114,101,97,109,95,105,109,112,108,95,108,105,116,101,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,99,111,117,110,116,41,32,62,61,32,40,48,41,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,108,97,115,116,95,114,101,116,117,114,110,101,100,95,115,105,122,101,95,41,32,62,32,40,48,41,58,32,0,66,97,99,107,85,112,40,41,32,99,97,110,32,111,110,108,121,32,98,101,32,99,97,108,108,101,100,32,97,102,116,101,114,32,97,32,115,117,99,99,101,115,115,102,117,108,32,78,101,120,116,40,41,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,99,111,117,110,116,41,32,60,61,32,40,108,97,115,116,95,114,101,116,117,114,110,101,100,95,115,105,122,101,95,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,54,65,114,114,97,121,73,110,112,117,116,83,116,114,101,97,109,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,55,65,114,114,97,121,79,117,116,112,117,116,83,116,114,101,97,109,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,116,97,114,103,101,116,95,32,33,61,32,78,85,76,76,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,99,111,117,110,116,41,32,60,61,32,40,116,97,114,103,101,116,95,45,62,115,105,122,101,40,41,41,58,32,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,98,117,102,102,101,114,32,108,97,114,103,101,114,32,116,104,97,110,32,107,105,110,116,51,50,109,97,120,32,102,111,114,32,0,83,116,114,105,110,103,79,117,116,112,117,116,83,116,114,101,97,109,46,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,56,83,116,114,105,110,103,79,117,116,112,117,116,83,116,114,101,97,109,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,98,97,99,107,117,112,95,98,121,116,101,115,95,32,61,61,32,48,32,38,38,32,98,117,102,102,101,114,95,46,103,101,116,40,41,32,33,61,32,78,85,76,76,58,32,0,32,66,97,99,107,85,112,40,41,32,99,97,110,32,111,110,108,121,32,98,101,32,99,97,108,108,101,100,32,97,102,116,101,114,32,78,101,120,116,40,41,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,99,111,117,110,116,41,32,60,61,32,40,98,117,102,102,101,114,95,117,115,101,100,95,41,58,32,0,32,67,97,110,39,116,32,98,97,99,107,32,117,112,32,111,118,101,114,32,109,111,114,101,32,98,121,116,101,115,32,116,104,97,110,32,119,101,114,101,32,114,101,116,117,114,110,101,100,32,98,121,32,116,104,101,32,108,97,115,116,32,99,97,108,108,32,116,111,32,78,101,120,116,40,41,46,0,32,80,97,114,97,109,101,116,101,114,32,116,111,32,66,97,99,107,85,112,40,41,32,99,97,110,39,116,32,98,101,32,110,101,103,97,116,105,118,101,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,98,97,99,107,117,112,95,98,121,116,101,115,95,41,32,61,61,32,40,48,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,50,53,67,111,112,121,105,110,103,73,110,112,117,116,83,116,114,101,97,109,65,100,97,112,116,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,56,67,111,112,121,105,110,103,73,110,112,117,116,83,116,114,101,97,109,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,101,115,115,97,103,101,95,108,105,116,101,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,99,111,100,101,100,95,111,117,116,46,72,97,100,69,114,114,111,114,40,41,58,32,0,40,99,97,110,110,111,116,32,100,101,116,101,114,109,105,110,101,32,109,105,115,115,105,110,103,32,102,105,101,108,100,115,32,102,111,114,32,108,105,116,101,32,109,101,115,115,97,103,101,41,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,49,77,101,115,115,97,103,101,76,105,116,101,69,0,67,97,110,39,116,32,0,112,97,114,115,101,0,32,109,101,115,115,97,103,101,32,111,102,32,116,121,112,101,32,34,0,34,32,98,101,99,97,117,115,101,32,105,116,32,105,115,32,109,105,115,115,105,110,103,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,58,32,0,69,120,99,101,101,100,101,100,32,109,97,120,105,109,117,109,32,112,114,111,116,111,98,117,102,32,115,105,122,101,32,111,102,32,50,71,66,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,98,121,116,101,95,115,105,122,101,95,98,101,102,111,114,101,95,115,101,114,105,97,108,105,122,97,116,105,111,110,41,32,61,61,32,40,98,121,116,101,95,115,105,122,101,95,97,102,116,101,114,95,115,101,114,105,97,108,105,122,97,116,105,111,110,41,58,32,0,32,119,97,115,32,109,111,100,105,102,105,101,100,32,99,111,110,99,117,114,114,101,110,116,108,121,32,100,117,114,105,110,103,32,115,101,114,105,97,108,105,122,97,116,105,111,110,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,98,121,116,101,115,95,112,114,111,100,117,99,101,100,95,98,121,95,115,101,114,105,97,108,105,122,97,116,105,111,110,41,32,61,61,32,40,98,121,116,101,95,115,105,122,101,95,98,101,102,111,114,101,95,115,101,114,105,97,108,105,122,97,116,105,111,110,41,58,32,0,66,121,116,101,32,115,105,122,101,32,99,97,108,99,117,108,97,116,105,111,110,32,97,110,100,32,115,101,114,105,97,108,105,122,97,116,105,111,110,32,119,101,114,101,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,32,84,104,105,115,32,109,97,121,32,105,110,100,105,99,97,116,101,32,97,32,98,117,103,32,105,110,32,112,114,111,116,111,99,111,108,32,98,117,102,102,101,114,115,32,111,114,32,105,116,32,109,97,121,32,98,101,32,99,97,117,115,101,100,32,98,121,32,99,111,110,99,117,114,114,101,110,116,32,109,111,100,105,102,105,99,97,116,105,111,110,32,111,102,32,0,84,104,105,115,32,115,104,111,117,108,100,110,39,116,32,98,101,32,99,97,108,108,101,100,32,105,102,32,97,108,108,32,116,104,101,32,115,105,122,101,115,32,97,114,101,32,101,113,117,97,108,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,114,101,112,101,97,116,101,100,95,102,105,101,108,100,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,110,101,119,95,115,105,122,101,41,32,60,61,32,40,40,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,115,105,122,101,95,116,62,58,58,109,97,120,40,41,32,45,32,107,82,101,112,72,101,97,100,101,114,83,105,122,101,41,32,47,32,115,105,122,101,111,102,40,111,108,100,95,114,101,112,45,62,101,108,101,109,101,110,116,115,91,48,93,41,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,70,97,116,97,108,69,120,99,101,112,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,55,67,108,111,115,117,114,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,48,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,115,116,117,98,115,47,99,111,109,109,111,110,46,99,99,0,84,104,105,115,32,112,114,111,103,114,97,109,32,114,101,113,117,105,114,101,115,32,118,101,114,115,105,111,110,32,0,37,100,46,37,100,46,37,100,0,32,111,102,32,116,104,101,32,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,32,114,117,110,116,105,109,101,32,108,105,98,114,97,114,121,44,32,98,117,116,32,116,104,101,32,105,110,115,116,97,108,108,101,100,32,118,101,114,115,105,111,110,32,105,115,32,0,46,32,32,80,108,101,97,115,101,32,117,112,100,97,116,101,32,121,111,117,114,32,108,105,98,114,97,114,121,46,32,32,73,102,32,121,111,117,32,99,111,109,112,105,108,101,100,32,116,104,101,32,112,114,111,103,114,97,109,32,121,111,117,114,115,101,108,102,44,32,109,97,107,101,32,115,117,114,101,32,116,104,97,116,32,121,111,117,114,32,104,101,97,100,101,114,115,32,97,114,101,32,102,114,111,109,32,116,104,101,32,115,97,109,101,32,118,101,114,115,105,111,110,32,111,102,32,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,115,32,97,115,32,121,111,117,114,32,108,105,110,107,45,116,105,109,101,32,108,105,98,114,97,114,121,46,32,32,40,86,101,114,115,105,111,110,32,118,101,114,105,102,105,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,34,0,34,46,41,0,84,104,105,115,32,112,114,111,103,114,97,109,32,119,97,115,32,99,111,109,112,105,108,101,100,32,97,103,97,105,110,115,116,32,118,101,114,115,105,111,110,32,0,32,111,102,32,116,104,101,32,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,32,114,117,110,116,105,109,101,32,108,105,98,114,97,114,121,44,32,119,104,105,99,104,32,105,115,32,110,111,116,32,99,111,109,112,97,116,105,98,108,101,32,119,105,116,104,32,116,104,101,32,105,110,115,116,97,108,108,101,100,32,118,101,114,115,105,111,110,32,40,0,41,46,32,32,67,111,110,116,97,99,116,32,116,104,101,32,112,114,111,103,114,97,109,32,97,117,116,104,111,114,32,102,111,114,32,97,110,32,117,112,100,97,116,101,46,32,32,73,102,32,121,111,117,32,99,111,109,112,105,108,101,100,32,116,104,101,32,112,114,111,103,114,97,109,32,121,111,117,114,115,101,108,102,44,32,109,97,107,101,32,115,117,114,101,32,116,104,97,116,32,121,111,117,114,32,104,101,97,100,101,114,115,32,97,114,101,32,102,114,111,109,32,116,104,101,32,115,97,109,101,32,118,101,114,115,105,111,110,32,111,102,32,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,115,32,97,115,32,121,111,117,114,32,108,105,110,107,45,116,105,109,101,32,108,105,98,114,97,114,121,46,32,32,40,86,101,114,115,105,111,110,32,118,101,114,105,102,105,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,34,0,91,108,105,98,112,114,111,116,111,98,117,102,32,37,115,32,37,115,58,37,100,93,32,37,115,10,0,73,78,70,79,0,87,65,82,78,73,78,71,0,70,65,84,65,76,0,112,116,104,114,101,97,100,95,109,117,116,101,120,95,117,110,108,111,99,107,58,32,0,112,116,104,114,101,97,100,95,109,117,116,101,120,95,108,111,99,107,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,70,105,101,108,100,83,107,105,112,112,101,114,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,119,105,114,101,95,102,111,114,109,97,116,95,108,105,116,101,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,118,97,108,117,101,46,115,105,122,101,40,41,41,32,60,61,32,40,107,105,110,116,51,50,109,97,120,41,58,32,0,115,101,114,105,97,108,105,122,105,110,103,0,112,97,114,115,105,110,103,0,32,39,37,115,39,0,83,116,114,105,110,103,32,102,105,101,108,100,0,32,99,111,110,116,97,105,110,115,32,105,110,118,97,108,105,100,32,0,85,84,70,45,56,32,100,97,116,97,32,119,104,101,110,32,0,32,97,32,112,114,111,116,111,99,111,108,32,0,98,117,102,102,101,114,46,32,85,115,101,32,116,104,101,32,39,98,121,116,101,115,39,32,116,121,112,101,32,105,102,32,121,111,117,32,105,110,116,101,110,100,32,116,111,32,115,101,110,100,32,114,97,119,32,0,98,121,116,101,115,46,32,0,69,82,82,79,82,0,105,110,116,54,52,0,117,105,110,116,54,52,0,105,110,116,51,50],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+440382);allocate([102,105,120,101,100,54,52,0,102,105,120,101,100,51,50,0,115,116,114,105,110,103,0,103,114,111,117,112,0,109,101,115,115,97,103,101,0,98,121,116,101,115,0,117,105,110,116,51,50,0,101,110,117,109,0,115,102,105,120,101,100,51,50,0,115,102,105,120,101,100,54,52,0,115,105,110,116,51,50,0,115,105,110,116,54,52,0,111,112,116,105,111,110,97,108,0,114,101,113,117,105,114,101,100,0,114,101,112,101,97,116,101,100,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,46,99,99,0,117,110,107,110,111,119,110,0,112,114,111,116,111,51,0,112,114,111,116,111,50,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,70,117,110,99,116,105,111,110,67,108,111,115,117,114,101,49,73,80,78,83,116,51,95,95,50,52,112,97,105,114,73,80,75,78,83,48,95,50,48,70,105,108,101,68,101,115,99,114,105,112,116,111,114,84,97,98,108,101,115,69,80,75,78,83,48,95,49,52,83,111,117,114,99,101,67,111,100,101,73,110,102,111,69,69,69,69,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,103,101,110,101,114,97,116,101,100,95,100,97,116,97,98,97,115,101,95,45,62,65,100,100,40,101,110,99,111,100,101,100,95,102,105,108,101,95,100,101,115,99,114,105,112,116,111,114,44,32,115,105,122,101,41,58,32,0,77,105,115,115,105,110,103,32,102,105,101,108,100,58,32,70,105,108,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,110,97,109,101,46,0,85,110,114,101,99,111,103,110,105,122,101,100,32,115,121,110,116,97,120,58,32,0,65,32,102,105,108,101,32,119,105,116,104,32,116,104,105,115,32,110,97,109,101,32,105,115,32,97,108,114,101,97,100,121,32,105,110,32,116,104,101,32,112,111,111,108,46,0,73,110,118,97,108,105,100,32,112,117,98,108,105,99,32,100,101,112,101,110,100,101,110,99,121,32,105,110,100,101,120,46,0,73,110,118,97,108,105,100,32,119,101,97,107,32,100,101,112,101,110,100,101,110,99,121,32,105,110,100,101,120,46,0,46,100,117,109,109,121,0,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,115,95,102,105,101,108,100,32,33,61,32,78,85,76,76,58,32,0,78,111,32,102,105,101,108,100,32,110,97,109,101,100,32,34,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,34,32,105,110,32,116,104,101,32,79,112,116,105,111,110,115,32,112,114,111,116,111,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,114,105,103,105,110,97,108,95,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,115,95,102,105,101,108,100,32,33,61,32,78,85,76,76,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,112,116,105,111,110,115,45,62,65,112,112,101,110,100,80,97,114,116,105,97,108,84,111,83,116,114,105,110,103,40,38,98,117,102,41,58,32,0,80,114,111,116,111,99,111,108,32,109,101,115,115,97,103,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,115,101,114,105,97,108,105,122,101,100,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,112,116,105,111,110,115,45,62,80,97,114,115,101,80,97,114,116,105,97,108,70,114,111,109,83,116,114,105,110,103,40,98,117,102,41,58,32,0,80,114,111,116,111,99,111,108,32,109,101,115,115,97,103,101,32,115,101,114,105,97,108,105,122,101,100,32,105,116,115,101,108,102,32,105,110,32,105,110,118,97,108,105,100,32,102,97,115,104,105,111,110,46,0,79,112,116,105,111,110,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,102,117,108,108,121,32,112,97,114,115,101,100,32,117,115,105,110,103,32,116,104,101,32,112,114,111,116,111,32,100,101,115,99,114,105,112,116,111,114,115,32,99,111,109,112,105,108,101,100,32,105,110,116,111,32,116,104,105,115,32,98,105,110,97,114,121,46,32,77,105,115,115,105,110,103,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,58,32,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,115,115,97,103,101,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,108,101,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,101,114,118,105,99,101,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,116,104,111,100,79,112,116,105,111,110,115,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,116,114,101,97,109,79,112,116,105,111,110,115,0,73,109,112,111,114,116,32,0,32,98,117,116,32,110,111,116,32,117,115,101,100,46,0,69,120,112,97,110,100,101,100,32,109,97,112,32,101,110,116,114,121,32,116,121,112,101,32,0,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,97,110,32,101,120,105,115,116,105,110,103,32,110,101,115,116,101,100,32,109,101,115,115,97,103,101,32,116,121,112,101,46,0,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,97,110,32,101,120,105,115,116,105,110,103,32,102,105,101,108,100,46,0,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,97,110,32,101,120,105,115,116,105,110,103,32,101,110,117,109,32,116,121,112,101,46,0,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,97,110,32,101,120,105,115,116,105,110,103,32,111,110,101,111,102,32,116,121,112,101,46,0,70,105,108,101,115,32,119,105,116,104,32,111,112,116,105,109,105,122,101,95,102,111,114,32,61,32,76,73,84,69,95,82,85,78,84,73,77,69,32,99,97,110,110,111,116,32,100,101,102,105,110,101,32,115,101,114,118,105,99,101,115,32,117,110,108,101,115,115,32,121,111,117,32,115,101,116,32,98,111,116,104,32,111,112,116,105,111,110,115,32,99,99,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,32,97,110,100,32,106,97,118,97,95,103,101,110,101,114,105,99,95,115,101,118,105,99,101,115,32,116,111,32,102,97,108,115,101,46,0,70,105,108,101,115,32,116,104,97,116,32,100,111,32,110,111,116,32,117,115,101,32,111,112,116,105,109,105,122,101,95,102,111,114,32,61,32,76,73,84,69,95,82,85,78,84,73,77,69,32,99,97,110,110,111,116,32,105,109,112,111,114,116,32,102,105,108,101,115,32,119,104,105,99,104,32,100,111,32,117,115,101,32,116,104,105,115,32,111,112,116,105,111,110,46,32,32,84,104,105,115,32,102,105,108,101,32,105,115,32,110,111,116,32,108,105,116,101,44,32,98,117,116,32,105,116,32,105,109,112,111,114,116,115,32,34,0,34,32,119,104,105,99,104,32,105,115,46,0,84,104,101,32,102,105,114,115,116,32,101,110,117,109,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,122,101,114,111,32,105,110,32,112,114,111,116,111,51,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,112,114,111,116,111,51,46,0,77,101,115,115,97,103,101,83,101,116,32,105,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,112,114,111,116,111,51,46,0,84,104,101,32,74,83,79,78,32,99,97,109,101,108,45,99,97,115,101,32,110,97,109,101,32,111,102,32,102,105,101,108,100,32,34,0,34,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,102,105,101,108,100,32,34,0,34,46,32,84,104,105,115,32,105,115,32,110,111,116,32,0,97,108,108,111,119,101,100,32,105,110,32,112,114,111,116,111,51,46,0,69,120,116,101,110,115,105,111,110,115,32,105,110,32,112,114,111,116,111,51,32,97,114,101,32,111,110,108,121,32,97,108,108,111,119,101,100,32,102,111,114,32,100,101,102,105,110,105,110,103,32,111,112,116,105,111,110,115,46,0,82,101,113,117,105,114,101,100,32,102,105,101,108,100,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,112,114,111,116,111,51,46,0,69,120,112,108,105,99,105,116,32,100,101,102,97,117,108,116,32,118,97,108,117,101,115,32,97,114,101,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,112,114,111,116,111,51,46,0,69,110,117,109,32,116,121,112,101,32,34,0,34,32,105,115,32,110,111,116,32,97,32,112,114,111,116,111,51,32,101,110,117,109,44,32,98,117,116,32,105,115,32,117,115,101,100,32,105,110,32,34,0,34,32,119,104,105,99,104,32,105,115,32,97,32,112,114,111,116,111,51,32,109,101,115,115,97,103,101,32,116,121,112,101,46,0,71,114,111,117,112,115,32,97,114,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,112,114,111,116,111,51,32,115,121,110,116,97,120,46,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,0,112,114,111,116,111,0,50,46,0,70,105,108,101,79,112,116,105,111,110,115,0,77,101,115,115,97,103,101,79,112,116,105,111,110,115,0,70,105,101,108,100,79,112,116,105,111,110,115,0,69,110,117,109,79,112,116,105,111,110,115,0,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,0,83,101,114,118,105,99,101,79,112,116,105,111,110,115,0,77,101,116,104,111,100,79,112,116,105,111,110,115,0,91,108,97,122,121,32,61,32,116,114,117,101,93,32,99,97,110,32,111,110,108,121,32,98,101,32,115,112,101,99,105,102,105,101,100,32,102,111,114,32,115,117,98,109,101,115,115,97,103,101,32,102,105,101,108,100,115,46,0,91,112,97,99,107,101,100,32,61,32,116,114,117,101,93,32,99,97,110,32,111,110,108,121,32,98,101,32,115,112,101,99,105,102,105,101,100,32,102,111,114,32,114,101,112,101,97,116,101,100,32,112,114,105,109,105,116,105,118,101,32,102,105,101,108,100,115,46,0,77,101,115,115,97,103,101,83,101,116,115,32,99,97,110,110,111,116,32,104,97,118,101,32,102,105,101,108,100,115,44,32,111,110,108,121,32,101,120,116,101,110,115,105,111,110,115,46,0,69,120,116,101,110,115,105,111,110,115,32,116,111,32,110,111,110,45,108,105,116,101,32,116,121,112,101,115,32,99,97,110,32,111,110,108,121,32,98,101,32,100,101,99,108,97,114,101,100,32,105,110,32,110,111,110,45,108,105,116,101,32,102,105,108,101,115,46,32,32,78,111,116,101,32,116,104,97,116,32,121,111,117,32,99,97,110,110,111,116,32,101,120,116,101,110,100,32,97,32,110,111,110,45,108,105,116,101,32,116,121,112,101,32,116,111,32,99,111,110,116,97,105,110,32,97,32,108,105,116,101,32,116,121,112,101,44,32,98,117,116,32,116,104,101,32,114,101,118,101,114,115,101,32,105,115,32,97,108,108,111,119,101,100,46,0,109,97,112,95,101,110,116,114,121,32,115,104,111,117,108,100,32,110,111,116,32,98,101,32,115,101,116,32,101,120,112,108,105,99,105,116,108,121,46,32,85,115,101,32,109,97,112,60,75,101,121,84,121,112,101,44,32,86,97,108,117,101,84,121,112,101,62,32,105,110,115,116,101,97,100,46,0,69,110,116,114,121,0,75,101,121,32,105,110,32,109,97,112,32,102,105,101,108,100,115,32,99,97,110,110,111,116,32,98,101,32,101,110,117,109,32,116,121,112,101,115,46,0,75,101,121,32,105,110,32,109,97,112,32,102,105,101,108,100,115,32,99,97,110,110,111,116,32,98,101,32,102,108,111,97,116,47,100,111,117,98,108,101,44,32,98,121,116,101,115,32,111,114,32,109,101,115,115,97,103,101,32,116,121,112,101,115,46,0,69,110,117,109,32,118,97,108,117,101,32,105,110,32,109,97,112,32,109,117,115,116,32,100,101,102,105,110,101,32,48,32,97,115,32,116,104,101,32,102,105,114,115,116,32,118,97,108,117,101,46,0,34,32,117,115,101,115,32,116,104,101,32,115,97,109,101,32,101,110,117,109,32,118,97,108,117,101,32,97,115,32,34,0,34,46,32,73,102,32,116,104,105,115,32,105,115,32,105,110,116,101,110,100,101,100,44,32,115,101,116,32,39,111,112,116,105,111,110,32,97,108,108,111,119,95,97,108,105,97,115,32,61,32,116,114,117,101,59,39,32,116,111,32,116,104,101,32,101,110,117,109,32,100,101,102,105,110,105,116,105,111,110,46,0,69,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,115,32,99,97,110,110,111,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,36,48,46,0,79,112,116,105,111,110,32,109,117,115,116,32,104,97,118,101,32,97,32,110,97,109,101,46,0,79,112,116,105,111,110,32,109,117,115,116,32,110,111,116,32,117,115,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,32,34,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,34,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,112,116,105,111,110,115,95,100,101,115,99,114,105,112,116,111,114,58,32,0,79,112,116,105,111,110,32,34,0,34,32,105,115,32,114,101,115,111,108,118,101,100,32,116,111,32,34,40,0,41,34,44,32,119,104,105,99,104,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,46,32,84,104,101,32,105,110,110,101,114,109,111,115,116,32,115,99,111,112,101,32,105,115,32,115,101,97,114,99,104,101,100,32,102,105,114,115,116,32,105,110,32,110,97,109,101,32,114,101,115,111,108,117,116,105,111,110,46,32,67,111,110,115,105,100,101,114,32,117,115,105,110,103,32,97,32,108,101,97,100,105,110,103,32,39,46,39,40,105,46,101,46,44,32,34,40,46,0,34,41,32,116,111,32,115,116,97,114,116,32,102,114,111,109,32,116,104,101,32,111,117,116,101,114,109,111,115,116,32,115,99,111,112,101,46,0,34,32,117,110,107,110,111,119,110,46,0,79,112,116,105,111,110,32,102,105,101,108,100,32,34,0,34,32,105,115,32,110,111,116,32,97,32,102,105,101,108,100,32,111,114,32,101,120,116,101,110,115,105,111,110,32,111,102,32,109,101,115,115,97,103,101,32,34,0,34,32,105,115,32,97,110,32,97,116,111,109,105,99,32,116,121,112,101,44,32,110,111,116,32,97,32,109,101,115,115,97,103,101,46,0,34,32,105,115,32,97,32,114,101,112,101,97,116,101,100,32,109,101,115,115,97,103,101,46,32,82,101,112,101,97,116,101,100,32,109,101,115,115,97,103,101,32,111,112,116,105,111,110,115,32,109,117,115,116,32,98,101,32,105,110,105,116,105,97,108,105,122,101,100,32,117,115,105,110,103,32,97,110,32,97,103,103,114,101,103,97,116,101,32,118,97,108,117,101,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,33,111,117,116,46,72,97,100,69,114,114,111,114,40,41,58,32,0,85,110,101,120,112,101,99,116,101,100,32,102,97,105,108,117,114,101,32,119,104,105,108,101,32,115,101,114,105,97,108,105,122,105,110,103,32,111,112,116,105,111,110,32,115,117,98,109,101,115,115,97,103,101,32,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,77,69,83,83,65,71,69,58,32,0,86,97,108,117,101,32,111,117,116,32,111,102,32,114,97,110,103,101,32,102,111,114,32,105,110,116,51,50,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,102,111,114,32,105,110,116,51,50,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,111,117,116,32,111,102,32,114,97,110,103,101,32,102,111,114,32,105,110,116,54,52,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,32,102,111,114,32,105,110,116,54,52,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,111,117,116,32,111,102,32,114,97,110,103,101,32,102,111,114,32,117,105,110,116,51,50,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,32,102,111,114,32,117,105,110,116,51,50,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,110,111,110,45,110,101,103,97,116,105,118,101,32,105,110,116,101,103,101,114,32,102,111,114,32,117,105,110,116,54,52,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,110,117,109,98,101,114,32,102,111,114,32,102,108,111,97,116,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,110,117,109,98,101,114,32,102,111,114,32,100,111,117,98,108,101,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,105,100,101,110,116,105,102,105,101,114,32,102,111,114,32,98,111,111,108,101,97,110,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,34,116,114,117,101,34,32,111,114,32,34,102,97,108,115,101,34,32,102,111,114,32,98,111,111,108,101,97,110,32,111,112,116,105,111,110,32,34,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,105,100,101,110,116,105,102,105,101,114,32,102,111,114,32,101,110,117,109,45,118,97,108,117,101,100,32,111,112,116,105,111,110,32,34,0,34,32,104,97,115,32,110,111,32,118,97,108,117,101,32,110,97,109,101,100,32,34,0,34,32,102,111,114,32,111,112,116,105,111,110,32,34,0,34,46,32,84,104,105,115,32,97,112,112,101,97,114,115,32,116,111,32,98,101,32,97,32,118,97,108,117,101,32,102,114,111,109,32,97,32,115,105,98,108,105,110,103,32,116,121,112,101,46,0,86,97,108,117,101,32,109,117,115,116,32,98,101,32,113,117,111,116,101,100,32,115,116,114,105,110,103,32,102,111,114,32,115,116,114,105,110,103,32,111,112,116,105,111,110,32,34,0,34,32,105,115,32,97,32,109,101,115,115,97,103,101,46,32,84,111,32,115,101,116,32,116,104,101,32,101,110,116,105,114,101,32,109,101,115,115,97,103,101,44,32,117,115,101,32,115,121,110,116,97,120,32,108,105,107,101,32,34,0,32,61,32,123,32,60,112,114,111,116,111,32,116,101,120,116,32,102,111,114,109,97,116,62,32,125,34,46,32,84,111,32,115,101,116,32,102,105,101,108,100,115,32,119,105,116,104,105,110,32,105,116,44,32,117,115,101,32,115,121,110,116,97,120,32,108,105,107,101,32,34,0,46,102,111,111,32,61,32,118,97,108,117,101,34,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,100,121,110,97,109,105,99,46,103,101,116,40,41,32,33,61,32,78,85,76,76,58,32,0,67,111,117,108,100,32,110,111,116,32,99,114,101,97,116,101,32,97,110,32,105,110,115,116,97,110,99,101,32,111,102,32,0,69,114,114,111,114,32,119,104,105,108,101,32,112,97,114,115,105,110,103,32,111,112,116,105,111,110,32,118,97,108,117,101,32,102,111,114,32,34,0,34,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,111,112,116,105,111,110,95,102,105,101,108,100,45,62,116,121,112,101,40,41,41,32,61,61,32,40,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,58,58,84,89,80,69,95,71,82,79,85,80,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,55,68,101,115,99,114,105,112,116,111,114,66,117,105,108,100,101,114,49,55,79,112,116,105,111,110,73,110,116,101,114,112,114,101,116,101,114,50,49,65,103,103,114,101,103,97,116,101,79,112,116,105,111,110,70,105,110,100,101,114,69,0,59,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,51,65,103,103,114,101,103,97,116,101,69,114,114,111,114,67,111,108,108,101,99,116,111,114,69,0,101,120,116,101,110,100,32,46,36,48,32,123,10,0,109,97,112,60,36,48,44,32,36,49,62,0,36,48,36,49,36,50,32,36,51,32,61,32,36,52,0,32,91,100,101,102,97,117,108,116,32,61,32,36,48,0,106,115,111,110,95,110,97,109,101,32,61,32,34,0,32,123,32,46,46,46,32,125,59,10,0,59,10,0,36,48,47,47,32,36,49,10,0,36,48,109,101,115,115,97,103,101,32,36,49,0,36,48,32,32,101,120,116,101,110,115,105,111,110,115,32,36,49,32,116,111,32,36,50,59,10,0,36,48,32,32,125,10,0,36,48,32,32,101,120,116,101,110,100,32,46,36,49,32,123,10,0,36,48,32,32,114,101,115,101,114,118,101,100,32,0,36,48,44,32,0,36,48,32,116,111,32,36,49,44,32,0,34,36,48,34,44,32,0,36,48,125,10,0,36,48,32,111,110,101,111,102,32,36,49,32,123,0,32,46,46,46,32,125,10,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,115,116,117,98,115,47,108,111,103,103,105,110,103,46,104,0,39,111,117,116,95,108,111,99,97,116,105,111,110,39,32,109,117,115,116,32,110,111,116,32,98,101,32,78,85,76,76,0,36,48,101,110,117,109,32,36,49,32,123,10,0,36,48,36,49,32,61,32,36,50,0,32,91,36,48,93,0,36,48,111,112,116,105,111,110,32,36,49,59,10,0,123,10,0,40,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,104,97,115,95,100,101,102,97,117,108,116,95,118,97,108,117,101,40,41,58,32,0,78,111,32,100,101,102,97,117,108,116,32,118,97,108,117,101,0,77,101,115,115,97,103,101,115,32,99,97,110,39,116,32,104,97,118,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,115,33,0,67,97,110,39,116,32,103,101,116,32,104,101,114,101,58,32,102,97,105,108,101,100,32,116,111,32,103,101,116,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,97,115,32,115,116,114,105,110,103,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,85,73,78,84,54,52,58,32,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,85,73,78,84,51,50,58,32,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,73,78,84,54,52,58,32,0,73,110,118,97,108,105,100,32,119,105,114,101,32,116,121,112,101,32,102,111,114,32,67,80,80,84,89,80,69,95,73,78,84,51,50,58,32,0,34,32,119,97,115,32,97,108,114,101,97,100,121,32,115,101,116,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,101,108,100,32,33,61,32,78,85,76,76,58,32,0,46,112,108,97,99,101,104,111,108,100,101,114,46,112,114,111,116,111,0,80,76,65,67,69,72,79,76,68,69,82,95,86,65,76,85,69,0,46,80,76,65,67,69,72,79,76,68,69,82,95,86,65,76,85,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,98,117,105,108,100,101,114,95,58,32,0,34,32,105,115,32,110,111,116,32,97,32,109,101,115,115,97,103,101,32,116,121,112,101,46,0,34,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,46,0,34,32,115,101,101,109,115,32,116,111,32,98,101,32,100,101,102,105,110,101,100,32,105,110,32,34,0,34,44,32,119,104,105,99,104,32,105,115,32,110,111,116,32,105,109,112,111,114,116,101,100,32,98,121,32,34,0,34,46,32,32,84,111,32,117,115,101,32,105,116,32,104,101,114,101,44,32,112,108,101,97,115,101,32,97,100,100,32,116,104,101,32,110,101,99,101,115,115,97,114,121,32,105,109,112,111,114,116,46,0,34,32,105,115,32,114,101,115,111,108,118,101,100,32,116,111,32,34,0,34,44,32,119,104,105,99,104,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,46,32,84,104,101,32,105,110,110,101,114,109,111,115,116,32,115,99,111,112,101,32,105,115,32,115,101,97,114,99,104,101,100,32,102,105,114,115,116,32,105,110,32,110,97,109,101,32,114,101,115,111,108,117,116,105,111,110,46,32,67,111,110,115,105,100,101,114,32,117,115,105,110,103,32,97,32,108,101,97,100,105,110,103,32,39,46,39,40,105,46,101,46,44,32,34,46,0,34,36,48,34,32,100,111,101,115,32,110,111,116,32,100,101,99,108,97,114,101,32,36,49,32,97,115,32,97,110,32,101,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,46,0,70,105,101,108,100,115,32,111,102,32,111,110,101,111,102,115,32,109,117,115,116,32,116,104,101,109,115,101,108,118,101,115,32,104,97,118,101,32,108,97,98,101,108,32,76,65,66,69,76,95,79,80,84,73,79,78,65,76,46,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,109,112,116,121,0,34,32,105,115,32,110,111,116,32,97,32,116,121,112,101,46,0,77,101,115,115,97,103,101,115,32,99,97,110,39,116,32,104,97,118,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,115,46,0,34,32,105,115,32,110,111,116,32,97,110,32,101,110,117,109,32,116,121,112,101,46,0,68,101,102,97,117,108,116,32,118,97,108,117,101,32,102,111,114,32,97,110,32,101,110,117,109,32,102,105,101,108,100,32,109,117,115,116,32,98,101,32,97,110,32,105,100,101,110,116,105,102,105,101,114,46,0,70,105,101,108,100,32,119,105,116,104,32,112,114,105,109,105,116,105,118,101,32,116,121,112,101,32,104,97,115,32,116,121,112,101,95,110,97,109,101,46,0,70,105,101,108,100,32,119,105,116,104,32,109,101,115,115,97,103,101,32,111,114,32,101,110,117,109,32,116,121,112,101,32,109,105,115,115,105,110,103,32,116,121,112,101,95,110,97,109,101,46,0,69,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,32,36,48,32,104,97,115,32,97,108,114,101,97,100,121,32,98,101,101,110,32,117,115,101,100,32,105,110,32,34,36,49,34,32,98,121,32,101,120,116,101,110,115,105,111,110,32,34,36,50,34,46,0,70,105,101,108,100,32,110,117,109,98,101,114,32,36,48,32,104,97,115,32,97,108,114,101,97,100,121,32,98,101,101,110,32,117,115,101,100,32,105,110,32,34,36,49,34,32,98,121,32,102,105,101,108,100,32,34,36,50,34,46,0,69,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,32,36,48,32,104,97,115,32,97,108,114,101,97,100,121,32,98,101,101,110,32,117,115,101,100,32,105,110,32,34,36,49,34,32,98,121,32,101,120,116,101,110,115,105,111,110,32,34,36,50,34,32,100,101,102,105,110,101,100,32,105,110,32,36,51,46,0,70,105,101,108,100,115,32,105,110,32,116,104,101,32,115,97,109,101,32,111,110,101,111,102,32,109,117,115,116,32,98,101,32,100,101,102,105,110,101,100,32,99,111,110,115,101,99,117,116,105,118,101,108,121,46,32,34,36,48,34,32,99,97,110,110,111,116,32,98,101,32,100,101,102,105,110,101,100,32,98,101,102,111,114,101,32,116,104,101,32,99,111,109,112,108,101,116,105,111,110,32,111,102,32,116,104,101,32,34,36,49,34,32,111,110,101,111,102,32,100,101,102,105,110,105,116,105,111,110,46,0,79,110,101,111,102,32,109,117,115,116,32,104,97,118,101,32,97,116,32,108,101,97,115,116,32,111,110,101,32,102,105,101,108,100,46,0,77,101,115,115,97,103,101,32,101,120,116,101,110,115,105,111,110,115,32,99,97,110,110,111,116,32,104,97,118,101,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,46,0,82,101,112,101,97,116,101,100,32,102,105,101,108,100,115,32,99,97,110,39,116,32,104,97,118,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,115,46,0,66,111,111,108,101,97,110,32,100,101,102,97,117,108,116,32,109,117,115,116,32,98,101,32,116,114,117,101,32,111,114,32,102,97,108,115,101,46,0,67,111,117,108,100,110,39,116,32,112,97,114,115,101,32,100,101,102,97,117,108,116,32,118,97,108,117,101,32,34,0,70,105,101,108,100,32,110,117,109,98,101,114,115,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,115,46,0,70,105,101,108,100,32,110,117,109,98,101,114,115,32,99,97,110,110,111,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,36,48,46,0,70,105,101,108,100,32,110,117,109,98,101,114,115,32,36,48,32,116,104,114,111,117,103,104,32,36,49,32,97,114,101,32,114,101,115,101,114,118,101,100,32,102,111,114,32,116,104,101,32,112,114,111,116,111,99,111,108,32,98,117,102,102,101,114,32,108,105,98,114,97,114,121,32,105,109,112,108,101,109,101,110,116,97,116,105,111,110,46,0,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,101,120,116,101,110,100,101,101,32,110,111,116,32,115,101,116,32,102,111,114,32,101,120,116,101,110,115,105,111,110,32,102,105,101,108,100,46,0,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,111,110,101,111,102,95,105,110,100,101,120,32,115,104,111,117,108,100,32,110,111,116,32,98,101,32,115,101,116,32,102,111,114,32,101,120,116,101,110,115,105,111,110,115,46,0,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,101,120,116,101,110,100,101,101,32,115,101,116,32,102,111,114,32,110,111,110,45,101,120,116,101,110,115,105,111,110,32,102,105,101,108,100,46,0,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,111,110,101,111,102,95,105,110,100,101,120,32,36,48,32,105,115,32,111,117,116,32,111,102,32,114,97,110,103,101,32,102,111,114,32,116,121,112,101,32,34,36,49,34,46,0,34,32,110,111,116,32,112,114,101,118,105,111,117,115,108,121,32,100,101,102,105,110,101,100,32,105,110,32,115,121,109,98,111,108,115,95,98,121,95,110,97,109,101,95,44,32,98,117,116,32,119,97,115,32,100,101,102,105,110,101,100,32,105,110,32,115,121,109,98,111,108,115,95,98,121,95,112,97,114,101,110,116,95,59,32,116,104,105,115,32,115,104,111,117,108,100,110,39,116,32,98,101,32,112,111,115,115,105,98,108,101,46,0,34,32,105,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,46,0,34,32,105,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,32,105,110,32,34,0,34,32,105,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,32,105,110,32,102,105,108,101,32,34,0,77,105,115,115,105,110,103,32,110,97,109,101,46,0,34,32,105,115,32,110,111,116,32,97,32,118,97,108,105,100,32,105,100,101,110,116,105,102,105,101,114,46,0,69,110,117,109,115,32,109,117,115,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,111,110,101,32,118,97,108,117,101,46,0,87,104,101,110,32,101,110,117,109,32,110,97,109,101,32,105,115,32,115,116,114,105,112,112,101,100,32,97,110,100,32,108,97,98,101,108,32,105,115,32,80,97,115,99,97,108,67,97,115,101,100,32,40,0,41,44,32,116,104,105,115,32,118,97,108,117,101,32,108,97,98,101,108,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,0,116,104,101,32,103,108,111,98,97,108,32,115,99,111,112,101,0,78,111,116,101,32,116,104,97,116,32,101,110,117,109,32,118,97,108,117,101,115,32,117,115,101,32,67,43,43,32,115,99,111,112,105,110,103,32,114,117,108,101,115,44,32,109,101,97,110,105,110,103,32,116,104,97,116,32,101,110,117,109,32,118,97,108,117,101,115,32,97,114,101,32,115,105,98,108,105,110,103,115,32,111,102,32,116,104,101,105,114,32,116,121,112,101,44,32,110,111,116,32,99,104,105,108,100,114,101,110,32,111,102,32,105,116,46,32,32,84,104,101,114,101,102,111,114,101,44,32,34,0,34,32,109,117,115,116,32,98,101,32,117,110,105,113,117,101,32,119,105,116,104,105,110,32,0,44,32,110,111,116,32,106,117,115,116,32,119,105,116,104,105,110,32,34,0,69,120,116,101,110,115,105,111,110,32,110,117,109,98,101,114,115,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,115,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,32,101,110,100,32,110,117,109,98,101,114,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,116,104,97,110,32,115,116,97,114,116,32,110,117,109,98,101,114,46,0,82,101,115,101,114,118,101,100,32,110,117,109,98,101,114,115,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,32,105,110,116,101,103,101,114,115,46,0,82,101,115,101,114,118,101,100,32,114,97,110,103,101,32,36,48,32,116,111,32,36,49,32,111,118,101,114,108,97,112,115,32,119,105,116,104,32,97,108,114,101,97,100,121,45,100,101,102,105,110,101,100,32,114,97,110,103,101,32,36,50,32,116,111,32,36,51,46,0,70,105,101,108,100,32,110,97,109,101,32,34,36,48,34,32,105,115,32,114,101,115,101,114,118,101,100,32,109,117,108,116,105,112,108,101,32,116,105,109,101,115,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,32,36,48,32,116,111,32,36,49,32,105,110,99,108,117,100,101,115,32,102,105,101,108,100,32,34,36,50,34,32,40,36,51,41,46,0,70,105,101,108,100,32,34,36,48,34,32,117,115,101,115,32,114,101,115,101,114,118,101,100,32,110,117,109,98,101,114,32,36,49,46,0,70,105,101,108,100,32,110,97,109,101,32,34,36,48,34,32,105,115,32,114,101,115,101,114,118,101,100,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,32,36,48,32,116,111,32,36,49,32,111,118,101,114,108,97,112,115,32,119,105,116,104,32,114,101,115,101,114,118,101,100,32,114,97,110,103,101,32,36,50,32,116,111,32,36,51,46,0,69,120,116,101,110,115,105,111,110,32,114,97,110,103,101,32,36,48,32,116,111,32,36,49,32,111,118,101,114,108,97,112,115,32,119,105,116,104,32,97,108,114,101,97,100,121,45,100,101,102,105,110,101,100,32,114,97,110,103,101,32,36,50,32,116,111,32,36,51,46,0,73,109,112,111,114,116,32,34,0,34,32,104,97,115,32,110,111,116,32,98,101,101,110,32,108,111,97,100,101,100,46,0,34,32,119,97,115,32,110,111,116,32,102,111,117,110,100,32,111,114,32,104,97,100,32,101,114,114,111,114,115,46,0,34,32,119,97,115,32,108,105,115,116,101,100,32,116,119,105,99,101,46,0,34,32,105,115,32,97,108,114,101,97,100,121,32,100,101,102,105,110,101,100,32,40,97,115,32,115,111,109,101,116,104,105,110,103,32,111,116,104,101,114,32,116,104,97,110,32,97,32,112,97,99,107,97,103,101,41,32,105,110,32,102,105,108,101,32,34,0,73,110,118,97,108,105,100,32,112,114,111,116,111,32,100,101,115,99,114,105,112,116,111,114,32,102,111,114,32,102,105,108,101,32,34,0,34,58,0,70,105,108,101,32,114,101,99,117,114,115,105,118,101,108,121,32,105,109,112,111,114,116,115,32,105,116,115,101,108,102,58,32,0,32,45,62,32,0,85,78,75,78,79,87,78,95,69,78,85,77,95,86,65,76,85,69,95,37,115,95,37,100,0,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,46,112,114,111,116,111,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,46,112,98,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,108,101,32,33,61,32,78,85,76,76,58,32,0,10,32,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,46,112,114,111,116,111,18,15,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,34,71,10,17,70,105,108,101,68,101,115,99,114,105,112,116,111,114,83,101,116,18,50,10,4,102,105,108,101,24,1,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,108,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,34,219,3,10,19,70,105,108,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,15,10,7,112,97,99,107,97,103,101,24,2,32,1,40,9,18,18,10,10,100,101,112,101,110,100,101,110,99,121,24,3,32,3,40,9,18,25,10,17,112,117,98,108,105,99,95,100,101,112,101,110,100,101,110,99,121,24,10,32,3,40,5,18,23,10,15,119,101,97,107,95,100,101,112,101,110,100,101,110,99,121,24,11,32,3,40,5,18,54,10,12,109,101,115,115,97,103,101,95,116,121,112,101,24,4,32,3,40,11,50,32,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,55,10,9,101,110,117,109,95,116,121,112,101,24,5,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,56,10,7,115,101,114,118,105,99,101,24,6,32,3,40,11,50,39,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,101,114,118,105,99,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,56,10,9,101,120,116,101,110,115,105,111,110,24,7,32,3,40,11,50,37,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,45,10,7,111,112,116,105,111,110,115,24,8,32,1,40,11,50,28,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,108,101,79,112,116,105,111,110,115,18,57,10,16,115,111,117,114,99,101,95,99,111,100,101,95,105,110,102,111,24,9,32,1,40,11,50,31,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,111,117,114,99,101,67,111,100,101,73,110,102,111,18,14,10,6,115,121,110,116,97,120,24,12,32,1,40,9,34,240,4,10,15,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,52,10,5,102,105,101,108,100,24,2,32,3,40,11,50,37,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,56,10,9,101,120,116,101,110,115,105,111,110,24,6,32,3,40,11,50,37,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,53,10,11,110,101,115,116,101,100,95,116,121,112,101,24,3,32,3,40,11,50,32,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,55,10,9,101,110,117,109,95,116,121,112,101,24,4,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,72,10,15,101,120,116,101,110,115,105,111,110,95,114,97,110,103,101,24,5,32,3,40,11,50,47,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,69,120,116,101,110,115,105,111,110,82,97,110,103,101,18,57,10,10,111,110,101,111,102,95,100,101,99,108,24,8,32,3,40,11,50,37,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,79,110,101,111,102,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,48,10,7,111,112,116,105,111,110,115,24,7,32,1,40,11,50,31,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,115,115,97,103,101,79,112,116,105,111,110,115,18,70,10,14,114,101,115,101,114,118,101,100,95,114,97,110,103,101,24,9,32,3,40,11,50,46,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,82,101,115,101,114,118,101,100,82,97,110,103,101,18,21,10,13,114,101,115,101,114,118,101,100,95,110,97,109,101,24,10,32,3,40,9,26,44,10,14,69,120,116,101,110,115,105,111,110,82,97,110,103,101,18,13,10,5,115,116,97,114,116,24,1,32,1,40,5,18,11,10,3,101,110,100,24,2,32,1,40,5,26,43,10,13,82,101,115,101,114,118,101,100,82,97,110,103,101,18,13,10,5,115,116,97,114,116,24,1,32,1,40,5,18,11,10,3,101,110,100,24,2,32,1,40,5,34,188,5,10,20,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,14,10,6,110,117,109,98,101,114,24,3,32,1,40,5,18,58,10,5,108,97,98,101,108,24,4,32,1,40,14,50,43,46,103,111,111,103,108,101,46],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+450622);allocate([112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,76,97,98,101,108,18,56,10,4,116,121,112,101,24,5,32,1,40,14,50,42,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,46,84,121,112,101,18,17,10,9,116,121,112,101,95,110,97,109,101,24,6,32,1,40,9,18,16,10,8,101,120,116,101,110,100,101,101,24,2,32,1,40,9,18,21,10,13,100,101,102,97,117,108,116,95,118,97,108,117,101,24,7,32,1,40,9,18,19,10,11,111,110,101,111,102,95,105,110,100,101,120,24,9,32,1,40,5,18,17,10,9,106,115,111,110,95,110,97,109,101,24,10,32,1,40,9,18,46,10,7,111,112,116,105,111,110,115,24,8,32,1,40,11,50,29,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,79,112,116,105,111,110,115,34,182,2,10,4,84,121,112,101,18,15,10,11,84,89,80,69,95,68,79,85,66,76,69,16,1,18,14,10,10,84,89,80,69,95,70,76,79,65,84,16,2,18,14,10,10,84,89,80,69,95,73,78,84,54,52,16,3,18,15,10,11,84,89,80,69,95,85,73,78,84,54,52,16,4,18,14,10,10,84,89,80,69,95,73,78,84,51,50,16,5,18,16,10,12,84,89,80,69,95,70,73,88,69,68,54,52,16,6,18,16,10,12,84,89,80,69,95,70,73,88,69,68,51,50,16,7,18,13,10,9,84,89,80,69,95,66,79,79,76,16,8,18,15,10,11,84,89,80,69,95,83,84,82,73,78,71,16,9,18,14,10,10,84,89,80,69,95,71,82,79,85,80,16,10,18,16,10,12,84,89,80,69,95,77,69,83,83,65,71,69,16,11,18,14,10,10,84,89,80,69,95,66,89,84,69,83,16,12,18,15,10,11,84,89,80,69,95,85,73,78,84,51,50,16,13,18,13,10,9,84,89,80,69,95,69,78,85,77,16,14,18,17,10,13,84,89,80,69,95,83,70,73,88,69,68,51,50,16,15,18,17,10,13,84,89,80,69,95,83,70,73,88,69,68,54,52,16,16,18,15,10,11,84,89,80,69,95,83,73,78,84,51,50,16,17,18,15,10,11,84,89,80,69,95,83,73,78,84,54,52,16,18,34,67,10,5,76,97,98,101,108,18,18,10,14,76,65,66,69,76,95,79,80,84,73,79,78,65,76,16,1,18,18,10,14,76,65,66,69,76,95,82,69,81,85,73,82,69,68,16,2,18,18,10,14,76,65,66,69,76,95,82,69,80,69,65,84,69,68,16,3,34,84,10,20,79,110,101,111,102,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,46,10,7,111,112,116,105,111,110,115,24,2,32,1,40,11,50,29,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,79,110,101,111,102,79,112,116,105,111,110,115,34,140,1,10,19,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,56,10,5,118,97,108,117,101,24,2,32,3,40,11,50,41,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,86,97,108,117,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,45,10,7,111,112,116,105,111,110,115,24,3,32,1,40,11,50,28,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,79,112,116,105,111,110,115,34,108,10,24,69,110,117,109,86,97,108,117,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,14,10,6,110,117,109,98,101,114,24,2,32,1,40,5,18,50,10,7,111,112,116,105,111,110,115,24,3,32,1,40,11,50,33,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,34,144,1,10,22,83,101,114,118,105,99,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,54,10,6,109,101,116,104,111,100,24,2,32,3,40,11,50,38,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,116,104,111,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,48,10,7,111,112,116,105,111,110,115,24,3,32,1,40,11,50,31,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,101,114,118,105,99,101,79,112,116,105,111,110,115,34,193,1,10,21,77,101,116,104,111,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,18,12,10,4,110,97,109,101,24,1,32,1,40,9,18,18,10,10,105,110,112,117,116,95,116,121,112,101,24,2,32,1,40,9,18,19,10,11,111,117,116,112,117,116,95,116,121,112,101,24,3,32,1,40,9,18,47,10,7,111,112,116,105,111,110,115,24,4,32,1,40,11,50,30,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,77,101,116,104,111,100,79,112,116,105,111,110,115,18,31,10,16,99,108,105,101,110,116,95,115,116,114,101,97,109,105,110,103,24,5,32,1,40,8,58,5,102,97,108,115,101,18,31,10,16,115,101,114,118,101,114,95,115,116,114,101,97,109,105,110,103,24,6,32,1,40,8,58,5,102,97,108,115,101,34,132,5,10,11,70,105,108,101,79,112,116,105,111,110,115,18,20,10,12,106,97,118,97,95,112,97,99,107,97,103,101,24,1,32,1,40,9,18,28,10,20,106,97,118,97,95,111,117,116,101,114,95,99,108,97,115,115,110,97,109,101,24,8,32,1,40,9,18,34,10,19,106,97,118,97,95,109,117,108,116,105,112,108,101,95,102,105,108,101,115,24,10,32,1,40,8,58,5,102,97,108,115,101,18,41,10,29,106,97,118,97,95,103,101,110,101,114,97,116,101,95,101,113,117,97,108,115,95,97,110,100,95,104,97,115,104,24,20,32,1,40,8,66,2,24,1,18,37,10,22,106,97,118,97,95,115,116,114,105,110,103,95,99,104,101,99,107,95,117,116,102,56,24,27,32,1,40,8,58,5,102,97,108,115,101,18,70,10,12,111,112,116,105,109,105,122,101,95,102,111,114,24,9,32,1,40,14,50,41,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,108,101,79,112,116,105,111,110,115,46,79,112,116,105,109,105,122,101,77,111,100,101,58,5,83,80,69,69,68,18,18,10,10,103,111,95,112,97,99,107,97,103,101,24,11,32,1,40,9,18,34,10,19,99,99,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,24,16,32,1,40,8,58,5,102,97,108,115,101,18,36,10,21,106,97,118,97,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,24,17,32,1,40,8,58,5,102,97,108,115,101,18,34,10,19,112,121,95,103,101,110,101,114,105,99,95,115,101,114,118,105,99,101,115,24,18,32,1,40,8,58,5,102,97,108,115,101,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,23,32,1,40,8,58,5,102,97,108,115,101,18,31,10,16,99,99,95,101,110,97,98,108,101,95,97,114,101,110,97,115,24,31,32,1,40,8,58,5,102,97,108,115,101,18,25,10,17,111,98,106,99,95,99,108,97,115,115,95,112,114,101,102,105,120,24,36,32,1,40,9,18,24,10,16,99,115,104,97,114,112,95,110,97,109,101,115,112,97,99,101,24,37,32,1,40,9,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,34,58,10,12,79,112,116,105,109,105,122,101,77,111,100,101,18,9,10,5,83,80,69,69,68,16,1,18,13,10,9,67,79,68,69,95,83,73,90,69,16,2,18,16,10,12,76,73,84,69,95,82,85,78,84,73,77,69,16,3,42,9,8,232,7,16,128,128,128,128,2,74,4,8,38,16,39,34,236,1,10,14,77,101,115,115,97,103,101,79,112,116,105,111,110,115,18,38,10,23,109,101,115,115,97,103,101,95,115,101,116,95,119,105,114,101,95,102,111,114,109,97,116,24,1,32,1,40,8,58,5,102,97,108,115,101,18,46,10,31,110,111,95,115,116,97,110,100,97,114,100,95,100,101,115,99,114,105,112,116,111,114,95,97,99,99,101,115,115,111,114,24,2,32,1,40,8,58,5,102,97,108,115,101,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,3,32,1,40,8,58,5,102,97,108,115,101,18,17,10,9,109,97,112,95,101,110,116,114,121,24,7,32,1,40,8,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,74,4,8,8,16,9,34,158,3,10,12,70,105,101,108,100,79,112,116,105,111,110,115,18,58,10,5,99,116,121,112,101,24,1,32,1,40,14,50,35,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,79,112,116,105,111,110,115,46,67,84,121,112,101,58,6,83,84,82,73,78,71,18,14,10,6,112,97,99,107,101,100,24,2,32,1,40,8,18,63,10,6,106,115,116,121,112,101,24,6,32,1,40,14,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,70,105,101,108,100,79,112,116,105,111,110,115,46,74,83,84,121,112,101,58,9,74,83,95,78,79,82,77,65,76,18,19,10,4,108,97,122,121,24,5,32,1,40,8,58,5,102,97,108,115,101,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,3,32,1,40,8,58,5,102,97,108,115,101,18,19,10,4,119,101,97,107,24,10,32,1,40,8,58,5,102,97,108,115,101,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,34,47,10,5,67,84,121,112,101,18,10,10,6,83,84,82,73,78,71,16,0,18,8,10,4,67,79,82,68,16,1,18,16,10,12,83,84,82,73,78,71,95,80,73,69,67,69,16,2,34,53,10,6,74,83,84,121,112,101,18,13,10,9,74,83,95,78,79,82,77,65,76,16,0,18,13,10,9,74,83,95,83,84,82,73,78,71,16,1,18,13,10,9,74,83,95,78,85,77,66,69,82,16,2,42,9,8,232,7,16,128,128,128,128,2,74,4,8,4,16,5,34,94,10,12,79,110,101,111,102,79,112,116,105,111,110,115,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,34,141,1,10,11,69,110,117,109,79,112,116,105,111,110,115,18,19,10,11,97,108,108,111,119,95,97,108,105,97,115,24,2,32,1,40,8,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,3,32,1,40,8,58,5,102,97,108,115,101,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,34,125,10,16,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,1,32,1,40,8,58,5,102,97,108,115,101,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,34,123,10,14,83,101,114,118,105,99,101,79,112,116,105,111,110,115,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,33,32,1,40,8,58,5,102,97,108,115,101,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,34,122,10,13,77,101,116,104,111,100,79,112,116,105,111,110,115,18,25,10,10,100,101,112,114,101,99,97,116,101,100,24,33,32,1,40,8,58,5,102,97,108,115,101,18,67,10,20,117,110,105,110,116,101,114,112,114,101,116,101,100,95,111,112,116,105,111,110,24,231,7,32,3,40,11,50,36,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,42,9,8,232,7,16,128,128,128,128,2,34,158,2,10,19,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,18,59,10,4,110,97,109,101,24,2,32,3,40,11,50,45,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,46,78,97,109,101,80,97,114,116,18,24,10,16,105,100,101,110,116,105,102,105,101,114,95,118,97,108,117,101,24,3,32,1,40,9,18,26,10,18,112,111,115,105,116,105,118,101,95,105,110,116,95,118,97,108,117,101,24,4,32,1,40,4,18,26,10,18,110,101,103,97,116,105,118,101,95,105,110,116,95,118,97,108,117,101,24,5,32,1,40,3,18,20,10,12,100,111,117,98,108,101,95,118,97,108,117,101,24,6,32,1,40,1,18,20,10,12,115,116,114,105,110,103,95,118,97,108,117,101,24,7,32,1,40,12,18,23,10,15,97,103,103,114,101,103,97,116,101,95,118,97,108,117,101,24,8,32,1,40,9,26,51,10,8,78,97,109,101,80,97,114,116,18,17,10,9,110,97,109,101,95,112,97,114,116,24,1,32,2,40,9,18,20,10,12,105,115,95,101,120,116,101,110,115,105,111,110,24,2,32,2,40,8,34,213,1,10,14,83,111,117,114,99,101,67,111,100,101,73,110,102,111,18,58,10,8,108,111,99,97,116,105,111,110,24,1,32,3,40,11,50,40,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,83,111,117,114,99,101,67,111,100,101,73,110,102,111,46,76,111,99,97,116,105,111,110,26,134,1,10,8,76,111,99,97,116,105,111,110,18,16,10,4,112,97,116,104,24,1,32,3,40,5,66,2,16,1,18,16,10,4,115,112,97,110,24,2,32,3,40,5,66,2,16,1,18,24,10,16,108,101,97,100,105,110,103,95,99,111,109,109,101,110,116,115,24,3,32,1,40,9,18,25,10,17,116,114,97,105,108,105,110,103,95,99,111,109,109,101,110,116,115,24,4,32,1,40,9,18,33,10,25,108,101,97,100,105,110,103,95,100,101,116,97,99,104,101,100,95,99,111,109,109,101,110,116,115,24,6,32,3,40,9,34,167,1,10,17,71,101,110,101,114,97,116,101,100,67,111,100,101,73,110,102,111,18,65,10,10,97,110,110,111,116,97,116,105,111,110,24,1,32,3,40,11,50,45,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,71,101,110,101,114,97,116,101,100,67,111,100,101,73,110,102,111,46,65,110,110,111,116,97,116,105,111,110,26,79,10,10,65,110,110,111,116,97,116,105,111,110,18,16,10,4,112,97,116,104,24,1,32,3,40,5,66,2,16,1,18,19,10,11,115,111,117,114,99,101,95,102,105,108,101,24,2,32,1,40,9,18,13,10,5,98,101,103,105,110,24,3,32,1,40,5,18,11,10,3,101,110,100,24,4,32,1,40,5,66,88,10,19,99,111,109,46,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,66,16,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,115,72,1,90,10,100,101,115,99,114,105,112,116,111,114,162,2,3,71,80,66,170,2,26,71,111,111,103,108,101,46,80,114,111,116,111,98,117,102,46,82,101,102,108,101,99,116,105,111,110,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,56,71,101,110,101,114,97,116,101,100,67,111,100,101,73,110,102,111,95,65,110,110,111,116,97,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,55,71,101,110,101,114,97,116,101,100,67,111,100,101,73,110,102,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,51,83,111,117,114,99,101,67,111,100,101,73,110,102,111,95,76,111,99,97,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,83,111,117,114,99,101,67,111,100,101,73,110,102,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,56,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,95,78,97,109,101,80,97,114,116,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,57,85,110,105,110,116,101,114,112,114,101,116,101,100,79,112,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,77,101,116,104,111,100,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,83,101,114,118,105,99,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,54,69,110,117,109,86,97,108,117,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,49,69,110,117,109,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,50,79,110,101,111,102,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,50,70,105,101,108,100,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,77,101,115,115,97,103,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,49,70,105,108,101,79,112,116,105,111,110,115,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,49,77,101,116,104,111,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,50,83,101,114,118,105,99,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,52,69,110,117,109,86,97,108,117,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,57,69,110,117,109,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,48,79,110,101,111,102,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,48,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,57,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,95,82,101,115,101,114,118,101,100,82,97,110,103,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,51,48,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,95,69,120,116,101,110,115,105,111,110,82,97,110,103,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,53,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,57,70,105,108,101,68,101,115,99,114,105,112,116,111,114,80,114,111,116,111,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,55,70,105,108,101,68,101,115,99,114,105,112,116,111,114,83,101,116,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,56,68,101,115,99,114,105,112,116,111,114,68,97,116,97,98,97,115,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,53,69,110,99,111,100,101,100,68,101,115,99,114,105,112,116,111,114,68,97,116,97,98,97,115,101,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,101,115,99,114,105,112,116,111,114,95,100,97,116,97,98,97,115,101,46,99,99,0,70,105,108,101,32,97,108,114,101,97,100,121,32,101,120,105,115,116,115,32,105,110,32,100,97,116,97,98,97,115,101,58,32,0,69,120,116,101,110,115,105,111,110,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,101,120,116,101,110,115,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,100,97,116,97,98,97,115,101,58,32,101,120,116,101,110,100,32,0,32,61,32,0,32,125,0,73,110,118,97,108,105,100,32,115,121,109,98,111,108,32,110,97,109,101,58,32,0,83,121,109,98,111,108,32,110,97,109,101,32,34,0,34,32,99,111,110,102,108,105,99,116,115,32,119,105,116,104,32,116,104,101,32,101,120,105,115,116,105,110,103,32,115,121,109,98,111,108,32,34,0,73,110,118,97,108,105,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,100,97,116,97,32,112,97,115,115,101,100,32,116,111,32,69,110,99,111,100,101,100,68,101,115,99,114,105,112,116,111,114,68,97,116,97,98,97,115,101,58,58,65,100,100,40,41,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,100,121,110,97,109,105,99,95,109,101,115,115,97,103,101,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,105,115,95,112,114,111,116,111,116,121,112,101,40,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,68,121,110,97,109,105,99,77,101,115,115,97,103,101,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,49,68,121,110,97,109,105,99,77,101,115,115,97,103,101,70,97,99,116,111,114,121,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,101,120,116,101,110,115,105,111,110,95,115,101,116,95,104,101,97,118,121,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,111,117,116,112,117,116,45,62,109,101,115,115,97,103,101,95,112,114,111,116,111,116,121,112,101,32,33,61,32,78,85,76,76,58,32,0,69,120,116,101,110,115,105,111,110,32,102,97,99,116,111,114,121,39,115,32,71,101,116,80,114,111,116,111,116,121,112,101,40,41,32,114,101,116,117,114,110,101,100,32,78,85,76,76,32,102,111,114,32,101,120,116,101,110,115,105,111,110,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,57,68,101,115,99,114,105,112,116,111,114,80,111,111,108,69,120,116,101,110,115,105,111,110,70,105,110,100,101,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,54,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,73,78,83,48,95,49,49,77,101,115,115,97,103,101,76,105,116,101,69,69,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,112,114,111,116,111,116,121,112,101,32,33,61,32,78,85,76,76,58,32,0,34,71,101,116,77,97,112,68,97,116,97,34,0,70,105,101,108,100,32,105,115,32,110,111,116,32,97,32,109,97,112,32,102,105,101,108,100,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,103,101,110,101,114,97,116,101,100,95,109,101,115,115,97,103,101,95,114,101,102,108,101,99,116,105,111,110,46,99,99,0,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,32,114,101,102,108,101,99,116,105,111,110,32,117,115,97,103,101,32,101,114,114,111,114,58,10,32,32,77,101,116,104,111,100,32,32,32,32,32,32,58,32,103,111,111,103,108,101,58,58,112,114,111,116,111,98,117,102,58,58,82,101,102,108,101,99,116,105,111,110,58,58,0,10,32,32,77,101,115,115,97,103,101,32,116,121,112,101,58,32,0,10,32,32,70,105,101,108,100,32,32,32,32,32,32,32,58,32,0,10,32,32,80,114,111,98,108,101,109,32,32,32,32,32,58,32,0,34,77,97,112,83,105,122,101,34,0,34,77,97,112,69,110,100,34,0,34,77,97,112,66,101,103,105,110,34,0,34,68,101,108,101,116,101,77,97,112,86,97,108,117,101,34,0,34,73,110,115,101,114,116,79,114,76,111,111,107,117,112,77,97,112,86,97,108,117,101,34,0,34,76,111,111,107,117,112,77,97,112,86,97,108,117,101,34,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,101,108,100,45,62,99,112,112,95,116,121,112,101,40,41,32,61,61,32,99,112,112,95,116,121,112,101,32,124,124,32,40,102,105,101,108,100,45,62,99,112,112,95,116,121,112,101,40,41,32,61,61,32,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,58,58,67,80,80,84,89,80,69,95,69,78,85,77,32,38,38,32,99,112,112,95,116,121,112,101,32,61,61,32,70,105,101,108,100,68,101,115,99,114,105,112,116,111,114,58,58,67,80,80,84,89,80,69,95,73,78,84,51,50,41,58,32,0,84,104,101,32,116,121,112,101,32,112,97,114,97,109,101,116,101,114,32,84,32,105,110,32,82,101,112,101,97,116,101,100,70,105,101,108,100,82,101,102,60,84,62,32,65,80,73,32,100,111,101,115,110,39,116,32,109,97,116,99,104,32,0,116,104,101,32,97,99,116,117,97,108,32,102,105,101,108,100,32,116,121,112,101,32,40,102,111,114,32,101,110,117,109,115,32,84,32,115,104,111,117,108,100,32,98,101,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,101,110,117,109,32,0,116,121,112,101,32,111,114,32,105,110,116,51,50,41,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,109,101,115,115,97,103,101,95,116,121,112,101,41,32,61,61,32,40,102,105,101,108,100,45,62,109,101,115,115,97,103,101,95,116,121,112,101,40,41,41,58,32,0,34,71,101,116,82,97,119,82,101,112,101,97,116,101,100,70,105,101,108,100,34,0,70,105,101,108,100,32,105,115,32,115,105,110,103,117,108,97,114,59,32,116,104,101,32,109,101,116,104,111,100,32,114,101,113,117,105,114,101,115,32,97,32,114,101,112,101,97,116,101,100,32,102,105,101,108,100,46,0,71,101,116,82,97,119,82,101,112,101,97,116,101,100,70,105,101,108,100,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,102,105,101,108,100,45,62,111,112,116,105,111,110,115,40,41,46,99,116,121,112,101,40,41,41,32,61,61,32,40,99,116,121,112,101,41,58,32,0,115,117,98,116,121,112,101,32,109,105,115,109,97,116,99,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,102,105,101,108,100,45,62,109,101,115,115,97,103,101,95,116,121,112,101,40,41,41,32,61,61,32,40,100,101,115,99,41,58,32,0,119,114,111,110,103,32,115,117,98,109,101,115,115,97,103,101,32,116,121,112,101,0,10,32,32,80,114,111,98,108,101,109,32,32,32,32,32,58,32,70,105,101,108,100,32,105,115,32,110,111,116,32,116,104,101,32,114,105,103,104,116,32,116,121,112,101,32,102,111,114,32,116,104,105,115,32,109,101,115,115,97,103,101,58,10,32,32,32,32,69,120,112,101,99,116,101,100,32,32,58,32,0,10,32,32,32,32,70,105,101,108,100,32,116,121,112,101,58,32,0,73,78,86,65,76,73,68,95,67,80,80,84,89,80,69,0,67,80,80,84,89,80,69,95,73,78,84,51,50,0,67,80,80,84,89,80,69,95,73,78,84,54,52,0,67,80,80,84,89,80,69,95,85,73,78,84,51,50,0,67,80,80,84,89,80,69,95,85,73,78,84,54,52,0,67,80,80,84,89,80,69,95,68,79,85,66,76,69,0,67,80,80,84,89,80,69,95,70,76,79,65,84,0,67,80,80,84,89,80,69,95,66,79,79,76,0,67,80,80,84,89,80,69,95,69,78,85,77,0,67,80,80,84,89,80,69,95,83,84,82,73,78,71,0,67,80,80,84,89,80,69,95,77,69,83,83,65,71,69,0,34,77,117,116,97,98,108,101,82,97,119,82,101,112,101,97,116,101,100,70,105,101,108,100,34,0,77,117,116,97,98,108,101,82,97,119,82,101,112,101,97,116,101,100,70,105,101,108,100,0,65,100,100,65,108,108,111,99,97,116,101,100,77,101,115,115,97,103,101,0,70,105,101,108,100,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,101,115,115,97,103,101,32,116,121,112,101,46,0,65,100,100,77,101,115,115,97,103,101,0,65,100,100,69,110,117,109,0,65,100,100,69,110,117,109,86,97,108,117,101,32,97,99,99,101,112,116,115,32,111,110,108,121,32,118,97,108,105,100,32,105,110,116,101,103,101,114,32,118,97,108,117,101,115,58,32,118,97,108,117,101,32,0,32,117,110,101,120,112,101,99,116,101,100,32,102,111,114,32,102,105,101,108,100,32,0,10,32,32,80,114,111,98,108,101,109,32,32,32,32,32,58,32,69,110,117,109,32,118,97,108,117,101,32,100,105,100,32,110,111,116,32,109,97,116,99,104,32,102,105,101,108,100,32,116,121,112,101,58,10,32,32,32,32,69,120,112,101,99,116,101,100,32,32,58,32,0,10,32,32,32,32,65,99,116,117,97,108,32,32,32,32,58,32,0,65,100,100,83,116,114,105,110,103,0,65,100,100,66,111,111,108,0,65,100,100,68,111,117,98,108,101,0,65,100,100,70,108,111,97,116,0,65,100,100,85,73,110,116,54,52,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,114,101,112,101,97,116,101,100,95,102,105,101,108,100,46,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,115,116,97,116,105,99,95,99,97,115,116,60,115,105,122,101,95,116,62,40,110,101,119,95,115,105,122,101,41,41,32,60,61,32,40,40,115,116,100,58,58,110,117,109,101,114,105,99,95,108,105,109,105,116,115,60,115,105,122,101,95,116,62,58,58,109,97,120,40,41,32,45,32,107,82,101,112,72,101,97,100,101,114,83,105,122,101,41,32,47,32,115,105,122,101,111,102,40,69,108,101,109,101,110,116,41,41,58,32,0,82,101,113,117,101,115,116,101,100,32,115,105,122,101,32,105,115,32,116,111,111,32,108,97,114,103,101,32,116,111,32,102,105,116,32,105,110,116,111,32,115,105,122,101,95,116,46,0,65,100,100,85,73,110,116,51,50,0,65,100,100,73,110,116,54,52,0,65,100,100,73,110,116,51,50,0,77,117,116,97,98,108,101,82,101,112,101,97,116,101,100,77,101,115,115,97,103,101,0,83,101,116,82,101,112,101,97,116,101,100,69,110,117,109,0,83,101,116,82,101,112,101,97,116,101,100,69,110,117,109,86,97,108,117,101,32,97,99,99,101,112,116,115,32,111,110,108,121,32,118,97,108,105,100,32,105,110,116,101,103,101,114,32,118,97,108,117,101,115,58,32,0,118,97,108,117,101,32,0,83,101,116,82,101,112,101,97,116,101,100,83,116,114,105,110,103,0,83,101,116,82,101,112,101,97,116,101,100,66,111,111,108,0,83,101,116,82,101,112,101,97,116,101,100,68,111,117,98,108,101,0,83,101,116,82,101,112,101,97,116,101,100,70,108,111,97,116,0,83,101,116,82,101,112,101,97,116,101,100,85,73,110,116,54,52,0,83,101,116,82,101,112,101,97,116,101,100,85,73,110,116,51,50,0,83,101,116,82,101,112,101,97,116,101,100,73,110,116,54,52,0,83,101,116,82,101,112,101,97,116,101,100,73,110,116,51,50,0,71,101,116,82,101,112,101,97,116,101,100,83,116,114,105,110,103,82,101,102,101,114,101,110,99,101,0,71,101,116,82,101,112,101,97,116,101,100,77,101,115,115,97,103,101,0,71,101,116,82,101,112,101,97,116,101,100,69,110,117,109,86,97,108,117,101,0,71,101,116,82,101,112,101,97,116,101,100,83,116,114,105,110,103,0,71,101,116,82,101,112,101,97,116,101,100,66,111,111,108,0,71,101,116,82,101,112,101,97,116,101,100,68,111,117,98,108,101,0,71,101,116,82,101,112,101,97,116,101,100,70,108,111,97,116,0,71,101,116,82,101,112,101,97,116,101,100,85,73,110,116,54,52,0,71,101,116,82,101,112,101,97,116,101,100,85,73,110,116,51,50,0,71,101,116,82,101,112,101,97,116,101,100,73,110,116,54,52,0,71,101,116,82,101,112,101,97,116,101,100,73,110,116,51,50,0,82,101,108,101,97,115,101,77,101,115,115,97,103,101,0,70,105,101,108,100,32,105,115,32,114,101,112,101,97,116,101,100,59,32,116,104,101,32,109,101,116,104,111,100,32,114,101,113,117,105,114,101,115,32,97,32,115,105,110,103,117,108,97,114,32,102,105,101,108,100,46,0,83,101,116,65,108,108,111,99,97,116,101,100,77,101,115,115,97,103,101,0,77,117,116,97,98,108,101,77,101,115,115,97,103,101,0,83,101,116,69,110,117,109,86,97,108,117,101,0,83,101,116,69,110,117,109,86,97,108,117,101,32,97,99,99,101,112,116,115,32,111,110,108,121,32,118,97,108,105,100,32,105,110,116,101,103,101,114,32,118,97,108,117,101,115,58,32,118,97,108,117,101,32,0,83,101,116,69,110,117,109,0,83,101,116,83,116,114,105,110,103,0,83,101,116,66,111,111,108,0,83,101,116,68,111,117,98,108,101,0,83,101,116,70,108,111,97,116,0,83,101,116,85,73,110,116,54,52,0,83,101,116,85,73,110,116,51,50,0,83,101,116,73,110,116,54,52,0,83,101,116,73,110,116,51,50,0,71,101,116,83,116,114,105,110,103,82,101,102,101,114,101,110,99,101,0,71,101,116,77,101,115,115,97,103,101,0,71,101,116,69,110,117,109,86,97,108,117,101,0,71,101,116,83,116,114,105,110,103,0,71,101,116,66,111,111,108,0,71,101,116,68,111,117,98,108,101,0,71,101,116,70,108,111,97,116,0,71,101,116,85,73,110,116,54,52,0,71,101,116,85,73,110,116,51,50,0,71,101,116,73,110,116,54,52,0,71,101,116,73,110,116,51,50,0,83,119,97,112,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,109,101,115,115,97,103,101,49,45,62,71,101,116,82,101,102,108,101,99,116,105,111,110,40,41,41,32,61,61,32,40,116,104,105,115,41,58,32,0,70,105,114,115,116,32,97,114,103,117,109,101,110,116,32,116,111,32,83,119,97,112,70,105,101,108,100,115,40,41,32,40,111,102,32,116,121,112,101,32,34,0,34,41,32,105,115,32,110,111,116,32,99,111,109,112,97,116,105,98,108,101,32,119,105,116,104,32,116,104,105,115,32,114,101,102,108,101,99,116,105,111,110,32,111,98,106,101,99,116,32,40,119,104,105,99,104,32,105,115,32,102,111,114,32,116,121,112,101,32,34,0,34,41,46,32,32,78,111,116,101,32,116,104,97,116,32,116,104,101,32,101,120,97,99,116,32,115,97,109,101,32,99,108,97,115,115,32,105,115,32,114,101,113,117,105,114,101,100,59,32,110,111,116,32,106,117,115,116,32,116,104,101,32,115,97,109,101,32,100,101,115,99,114,105,112,116,111,114,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,109,101,115,115,97,103,101,50,45,62,71,101,116,82,101,102,108,101,99,116,105,111,110,40,41,41,32,61,61,32,40,116,104,105,115,41,58,32,0,83,101,99,111,110,100,32,97,114,103,117,109,101,110,116,32,116,111,32,83,119,97,112,70,105,101,108,100,115,40,41,32,40,111,102,32,116,121,112,101,32,34,0,85,110,105,109,112,108,101,109,101,110,116,101,100,32,116,121,112,101,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,38,111,116,104,101,114,41,32,33,61,32,40,116,104,105,115,41,58,32,0,70,105,114,115,116,32,97,114,103,117,109,101,110,116,32,116,111,32,83,119,97,112,40,41,32,40,111,102,32,116,121,112,101,32,34,0,83,101,99,111,110,100,32,97,114,103,117,109,101,110,116,32,116,111,32,83,119,97,112,40,41,32,40,111,102,32,116,121,112,101,32,34,0,82,101,108,101,97,115,101,76,97,115,116,0,82,101,109,111,118,101,76,97,115,116,0,67,108,101,97,114,70,105,101,108,100,0,70,105,101,108,100,83,105,122,101,0,72,97,115,70,105,101,108,100,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,54,71,101,110,101,114,97,116,101,100,77,101,115,115,97,103,101,82,101,102,108,101,99,116,105,111,110,69,0,37,46,49,102,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,115,116,114,116,111,100,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,116,101,109,112,91,48,93,41,32,61,61,32,40,39,49,39,41,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,116,101,109,112,91,115,105,122,101,45,49,93,41,32,61,61,32,40,39,53,39,41,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,115,105,122,101,41,32,60,61,32,40,54,41,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,52,69,114,114,111,114,67,111,108,108,101,99,116,111,114,69,0,85,110,101,120,112,101,99,116,101,100,32,101,110,100,32,111,102,32,115,116,114,105,110,103,46,0,83,116,114,105,110,103,32,108,105,116,101,114,97,108,115,32,99,97,110,110,111,116,32,99,114,111,115,115,32,108,105,110,101,32,98,111,117,110,100,97,114,105,101,115,46,0,69,120,112,101,99,116,101,100,32,104,101,120,32,100,105,103,105,116,115,32,102,111,114,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,46,0,69,120,112,101,99,116,101,100,32,102,111,117,114,32,104,101,120,32,100,105,103,105,116,115,32,102,111,114,32,92,117,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,46,0,69,120,112,101,99,116,101,100,32,101,105,103,104,116,32,104,101,120,32,100,105,103,105,116,115,32,117,112,32,116,111,32,49,48,102,102,102,102,32,102,111,114,32,92,85,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,0,73,110,118,97,108,105,100,32,101,115,99,97,112,101,32,115,101,113,117,101,110,99,101,32,105,110,32,115,116,114,105,110,103,32,108,105,116,101,114,97,108,46,0,34,48,120,34,32,109,117,115,116,32,98,101,32,102,111,108,108,111,119,101,100,32,98,121,32,104,101,120,32,100,105,103,105,116,115,46,0,78,117,109,98,101,114,115,32,115,116,97,114,116,105,110,103,32,119,105,116,104,32,108,101,97,100,105,110,103,32,122,101,114,111,32,109,117,115,116,32,98,101,32,105,110,32,111,99,116,97,108,46,0,34,101,34,32,109,117,115,116,32,98,101,32,102,111,108,108,111,119,101,100,32,98,121,32,101,120,112,111,110,101,110,116,46,0,78,101,101,100,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,110,117,109,98,101,114,32,97,110,100,32,105,100,101,110,116,105,102,105,101,114,46,0,65,108,114,101,97,100,121,32,115,97,119,32,100,101,99,105,109,97,108,32,112,111,105,110,116,32,111,114,32,101,120,112,111,110,101,110,116,59,32,99,97,110,39,116,32,104,97,118,101,32,97,110,111,116,104,101,114,32,111,110,101,46,0,72,101,120,32,97,110,100,32,111,99,116,97,108,32,110,117,109,98,101,114,115,32,109,117,115,116,32,98,101,32,105,110,116,101,103,101,114,115,46,0,34,47,42,34,32,105,110,115,105,100,101,32,98,108,111,99,107,32,99,111,109,109,101,110,116,46,32,32,66,108,111,99,107,32,99,111,109,109,101,110,116,115,32,99,97,110,110,111,116,32,98,101,32,110,101,115,116,101,100,46,0,69,110,100,45,111,102,45,102,105,108,101,32,105,110,115,105,100,101,32,98,108,111,99,107,32,99,111,109,109,101,110,116,46,0,32,32,67,111,109,109,101,110,116,32,115,116,97,114,116,101,100,32,104,101,114,101,46,0,73,110,118,97,108,105,100,32,99,111,110,116,114,111,108,32,99,104,97,114,97,99,116,101,114,115,32,101,110,99,111,117,110,116,101,114,101,100,32,105,110,32,116,101,120,116,46,0,78,101,101,100,32,115,112,97,99,101,32,98,101,116,119,101,101,110,32,105,100,101,110,116,105,102,105,101,114,32,97,110,100],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+460862);allocate([32,100,101,99,105,109,97,108,32,112,111,105,110,116,46,0,73,110,116,101,114,112,114,101,116,105,110,103,32,110,111,110,32,97,115,99,105,105,32,99,111,100,101,112,111,105,110,116,32,37,100,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,116,111,107,101,110,105,122,101,114,46,99,99,0,32,84,111,107,101,110,105,122,101,114,58,58,80,97,114,115,101,70,108,111,97,116,40,41,32,112,97,115,115,101,100,32,116,101,120,116,32,116,104,97,116,32,99,111,117,108,100,32,110,111,116,32,104,97,118,101,32,98,101,101,110,32,116,111,107,101,110,105,122,101,100,32,97,115,32,97,32,102,108,111,97,116,58,32,0,32,84,111,107,101,110,105,122,101,114,58,58,80,97,114,115,101,83,116,114,105,110,103,65,112,112,101,110,100,40,41,32,112,97,115,115,101,100,32,116,101,120,116,32,116,104,97,116,32,99,111,117,108,100,32,110,111,116,32,104,97,118,101,32,98,101,101,110,32,116,111,107,101,110,105,122,101,100,32,97,115,32,97,32,115,116,114,105,110,103,58,32,0,92,85,37,48,56,120,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,56,73,115,116,114,101,97,109,73,110,112,117,116,83,116,114,101,97,109,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,56,73,115,116,114,101,97,109,73,110,112,117,116,83,116,114,101,97,109,50,53,67,111,112,121,105,110,103,73,115,116,114,101,97,109,73,110,112,117,116,83,116,114,101,97,109,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,50,77,97,112,70,105,101,108,100,66,97,115,101,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,97,112,46,104,0,85,110,115,117,112,112,111,114,116,101,100,0,85,110,115,117,112,112,111,114,116,101,100,58,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,80,114,111,116,111,99,111,108,32,66,117,102,102,101,114,32,109,97,112,32,117,115,97,103,101,32,101,114,114,111,114,58,10,0,77,97,112,75,101,121,58,58,71,101,116,66,111,111,108,86,97,108,117,101,0,32,116,121,112,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,10,0,32,32,69,120,112,101,99,116,101,100,32,58,32,0,32,32,65,99,116,117,97,108,32,32,32,58,32,0,77,97,112,75,101,121,58,58,71,101,116,85,73,110,116,51,50,86,97,108,117,101,0,77,97,112,75,101,121,58,58,71,101,116,85,73,110,116,54,52,86,97,108,117,101,0,77,97,112,75,101,121,58,58,71,101,116,73,110,116,51,50,86,97,108,117,101,0,77,97,112,75,101,121,58,58,71,101,116,73,110,116,54,52,86,97,108,117,101,0,107,101,121,0,118,97,108,117,101,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,97,112,95,102,105,101,108,100,46,99,99,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,77,101,115,115,97,103,101,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,116,121,112,101,32,77,97,112,86,97,108,117,101,82,101,102,32,105,115,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,100,46,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,69,110,117,109,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,70,108,111,97,116,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,68,111,117,98,108,101,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,66,111,111,108,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,85,73,110,116,51,50,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,85,73,110,116,54,52,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,73,110,116,51,50,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,73,110,116,54,52,86,97,108,117,101,0,77,97,112,86,97,108,117,101,82,101,102,58,58,71,101,116,83,116,114,105,110,103,86,97,108,117,101,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,53,68,121,110,97,109,105,99,77,97,112,70,105,101,108,100,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,51,84,121,112,101,68,101,102,105,110,101,100,77,97,112,70,105,101,108,100,66,97,115,101,73,78,83,48,95,54,77,97,112,75,101,121,69,78,83,48,95,49,49,77,97,112,86,97,108,117,101,82,101,102,69,69,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,101,110,116,114,121,95,100,101,115,99,114,105,112,116,111,114,95,32,33,61,32,78,85,76,76,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,97,115,115,105,103,110,95,100,101,115,99,114,105,112,116,111,114,95,99,97,108,108,98,97,99,107,95,32,33,61,32,78,85,76,76,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,51,77,97,112,73,78,83,48,95,54,77,97,112,75,101,121,69,78,83,48,95,49,49,77,97,112,86,97,108,117,101,82,101,102,69,69,56,73,110,110,101,114,77,97,112,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,52,104,97,115,104,73,78,83,48,95,54,77,97,112,75,101,121,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,104,97,115,104,95,109,97,112,73,78,83,48,95,54,77,97,112,75,101,121,69,80,78,83,48,95,55,77,97,112,80,97,105,114,73,83,50,95,78,83,48,95,49,49,77,97,112,86,97,108,117,101,82,101,102,69,69,69,78,83,48,95,52,104,97,115,104,73,83,50,95,69,69,78,83,116,51,95,95,50,56,101,113,117,97,108,95,116,111,73,83,50,95,69,69,78,83,48,95,51,77,97,112,73,83,50,95,83,52,95,69,49,50,77,97,112,65,108,108,111,99,97,116,111,114,73,78,83,57,95,52,112,97,105,114,73,75,83,50,95,83,54,95,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,51,117,110,111,114,100,101,114,101,100,95,109,97,112,73,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,54,77,97,112,75,101,121,69,80,78,83,50,95,55,77,97,112,80,97,105,114,73,83,51,95,78,83,50,95,49,49,77,97,112,86,97,108,117,101,82,101,102,69,69,69,78,83,50,95,52,104,97,115,104,73,83,51,95,69,69,78,83,95,56,101,113,117,97,108,95,116,111,73,83,51,95,69,69,78,83,50,95,51,77,97,112,73,83,51,95,83,53,95,69,49,50,77,97,112,65,108,108,111,99,97,116,111,114,73,78,83,95,52,112,97,105,114,73,75,83,51,95,83,55,95,69,69,69,69,69,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,109,101,115,115,97,103,101,46,99,99,0,77,101,115,115,97,103,101,32,99,108,97,115,115,32,34,0,34,32,105,109,112,108,101,109,101,110,116,115,32,110,101,105,116,104,101,114,32,83,101,116,67,97,99,104,101,100,83,105,122,101,40,41,32,110,111,114,32,66,121,116,101,83,105,122,101,40,41,46,32,32,77,117,115,116,32,105,109,112,108,101,109,101,110,116,32,111,110,101,32,111,114,32,116,104,101,32,111,116,104,101,114,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,102,114,111,109,46,71,101,116,68,101,115,99,114,105,112,116,111,114,40,41,41,32,61,61,32,40,100,101,115,99,114,105,112,116,111,114,41,58,32,0,58,32,84,114,105,101,100,32,116,111,32,109,101,114,103,101,32,102,114,111,109,32,97,32,109,101,115,115,97,103,101,32,119,105,116,104,32,97,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,46,32,32,116,111,58,32,0,44,32,102,114,111,109,58,32,0,58,32,84,114,105,101,100,32,116,111,32,99,111,112,121,32,102,114,111,109,32,97,32,109,101,115,115,97,103,101,32,119,105,116,104,32,97,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,46,32,116,111,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,55,77,101,115,115,97,103,101,69,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,102,105,101,108,100,45,62,105,115,95,114,101,112,101,97,116,101,100,40,41,58,32,0,83,104,111,117,108,100,32,110,111,116,32,114,101,97,99,104,32,104,101,114,101,46,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,114,101,102,108,101,99,116,105,111,110,95,105,110,116,101,114,110,97,108,46,104,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,116,104,105,115,32,61,61,32,111,116,104,101,114,95,109,117,116,97,116,111,114,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,49,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,77,101,115,115,97,103,101,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,51,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,87,114,97,112,112,101,114,73,78,83,48,95,55,77,101,115,115,97,103,101,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,51,82,97,110,100,111,109,65,99,99,101,115,115,82,101,112,101,97,116,101,100,70,105,101,108,100,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,49,82,101,112,101,97,116,101,100,70,105,101,108,100,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,54,77,97,112,70,105,101,108,100,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,83,116,114,105,110,103,65,99,99,101,115,115,111,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,51,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,87,114,97,112,112,101,114,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,51,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,51,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,98,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,98,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,100,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,100,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,102,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,102,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,121,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,121,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,120,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,120,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,106,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,106,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,51,48,82,101,112,101,97,116,101,100,70,105,101,108,100,80,114,105,109,105,116,105,118,101,65,99,99,101,115,115,111,114,73,105,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,48,82,101,112,101,97,116,101,100,70,105,101,108,100,87,114,97,112,112,101,114,73,105,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,82,101,102,108,101,99,116,105,111,110,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,52,77,101,115,115,97,103,101,70,97,99,116,111,114,121,69,0,70,105,108,101,32,97,112,112,101,97,114,115,32,116,111,32,98,101,32,105,110,32,103,101,110,101,114,97,116,101,100,32,112,111,111,108,32,98,117,116,32,119,97,115,110,39,116,32,114,101,103,105,115,116,101,114,101,100,58,32,0,84,121,112,101,32,97,112,112,101,97,114,115,32,116,111,32,98,101,32,105,110,32,103,101,110,101,114,97,116,101,100,32,112,111,111,108,32,98,117,116,32,119,97,115,110,39,116,32,0,114,101,103,105,115,116,101,114,101,100,58,32,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,50,95,71,76,79,66,65,76,95,95,78,95,49,50,51,71,101,110,101,114,97,116,101,100,77,101,115,115,97,103,101,70,97,99,116,111,114,121,69,0,70,105,108,101,32,105,115,32,97,108,114,101,97,100,121,32,114,101,103,105,115,116,101,114,101,100,58,32,0,84,121,112,101,32,105,115,32,97,108,114,101,97,100,121,32,114,101,103,105,115,116,101,114,101,100,58,32,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,114,101,102,108,101,99,116,105,111,110,95,111,112,115,46,99,99,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,38,102,114,111,109,41,32,33,61,32,40,116,111,41,58,32,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,116,111,45,62,71,101,116,68,101,115,99,114,105,112,116,111,114,40,41,41,32,61,61,32,40,100,101,115,99,114,105,112,116,111,114,41,58,32,0,84,114,105,101,100,32,116,111,32,109,101,114,103,101,32,109,101,115,115,97,103,101,115,32,111,102,32,100,105,102,102,101,114,101,110,116,32,116,121,112,101,115,32,0,40,109,101,114,103,101,32,0,32,116,111,32,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,115,116,117,98,115,47,115,117,98,115,116,105,116,117,116,101,46,99,99,0,115,116,114,105,110,103,115,58,58,83,117,98,115,116,105,116,117,116,101,32,102,111,114,109,97,116,32,115,116,114,105,110,103,32,105,110,118,97,108,105,100,58,32,97,115,107,101,100,32,102,111,114,32,34,36,0,34,44,32,98,117,116,32,111,110,108,121,32,0,32,97,114,103,115,32,119,101,114,101,32,103,105,118,101,110,46,32,32,70,117,108,108,32,102,111,114,109,97,116,32,115,116,114,105,110,103,32,119,97,115,58,32,34,0,73,110,118,97,108,105,100,32,115,116,114,105,110,103,115,58,58,83,117,98,115,116,105,116,117,116,101,40,41,32,102,111,114,109,97,116,32,115,116,114,105,110,103,58,32,34,0,32,123,32,0,32,123,10,0,91,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,84,101,120,116,70,111,114,109,97,116,49,55,70,105,101,108,100,86,97,108,117,101,80,114,105,110,116,101,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,84,101,120,116,70,111,114,109,97,116,54,70,105,110,100,101,114,69,0,58,32,0,10,0,58,32,48,120,0,32,32,0,125,32,0,58,32,34,0,34,32,0,34,10,0,125,10,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,116,101,120,116,95,102,111,114,109,97,116,46,99,99,0,32,79,117,116,100,101,110,116,40,41,32,119,105,116,104,111,117,116,32,109,97,116,99,104,105,110,103,32,73,110,100,101,110,116,40,41,46,0,46,46,46,60,116,114,117,110,99,97,116,101,100,62,46,46,46,0,37,100,0,73,110,118,97,108,105,100,32,107,101,121,32,102,111,114,32,109,97,112,32,102,105,101,108,100,46,0,58,32,91,0,93,32,0,93,10,0,80,114,111,116,111,32,116,121,112,101,32,0,32,110,111,116,32,102,111,117,110,100,0,58,32,102,97,105,108,101,100,32,116,111,32,112,97,114,115,101,32,99,111,110,116,101,110,116,115,0,34,0,77,101,115,115,97,103,101,32,109,105,115,115,105,110,103,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,58,32,0,69,114,114,111,114,32,112,97,114,115,105,110,103,32,116,101,120,116,45,102,111,114,109,97,116,32,0,58,0,78,111,110,45,114,101,112,101,97,116,101,100,32,65,110,121,32,115,112,101,99,105,102,105,101,100,32,109,117,108,116,105,112,108,101,32,116,105,109,101,115,46,0,69,120,116,101,110,115,105,111,110,32,34,0,34,32,105,115,32,110,111,116,32,100,101,102,105,110,101,100,32,111,114,32,105,115,32,110,111,116,32,97,110,32,101,120,116,101,110,115,105,111,110,32,111,102,32,34,0,34,46,0,77,101,115,115,97,103,101,32,116,121,112,101,32,34,0,34,32,104,97,115,32,110,111,32,102,105,101,108,100,32,110,97,109,101,100,32,34,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,97,108,108,111,119,95,117,110,107,110,111,119,110,95,102,105,101,108,100,95,58,32,0,78,111,110,45,114,101,112,101,97,116,101,100,32,102,105,101,108,100,32,34,0,34,32,105,115,32,115,112,101,99,105,102,105,101,100,32,109,117,108,116,105,112,108,101,32,116,105,109,101,115,46,0,70,105,101,108,100,32,34,0,34,32,105,115,32,115,112,101,99,105,102,105,101,100,32,97,108,111,110,103,32,119,105,116,104,32,102,105,101,108,100,32,34,0,34,44,32,97,110,111,116,104,101,114,32,109,101,109,98,101,114,32,111,102,32,111,110,101,111,102,32,34,0,116,101,120,116,32,102,111,114,109,97,116,32,99,111,110,116,97,105,110,115,32,100,101,112,114,101,99,97,116,101,100,32,102,105,101,108,100,32,34,0,84,114,117,101,0,116,0,70,97,108,115,101,0,102,0,73,110,118,97,108,105,100,32,118,97,108,117,101,32,102,111,114,32,98,111,111,108,101,97,110,32,102,105,101,108,100,32,34,0,34,46,32,86,97,108,117,101,58,32,34,0,69,120,112,101,99,116,101,100,32,105,110,116,101,103,101,114,32,111,114,32,105,100,101,110,116,105,102,105,101,114,44,32,103,111,116,58,32,0,85,110,107,110,111,119,110,32,101,110,117,109,101,114,97,116,105,111,110,32,118,97,108,117,101,32,111,102,32,34,0,34,32,102,111,114,32,102,105,101,108,100,32,34,0,82,101,97,99,104,101,100,32,97,110,32,117,110,105,110,116,101,110,100,101,100,32,115,116,97,116,101,58,32,67,80,80,84,89,80,69,95,77,69,83,83,65,71,69,0,69,120,112,101,99,116,101,100,32,115,116,114,105,110,103,44,32,103,111,116,58,32,0,69,120,112,101,99,116,101,100,32,100,111,117,98,108,101,44,32,103,111,116,58,32,0,69,120,112,101,99,116,101,100,32,105,110,116,101,103,101,114,44,32,103,111,116,58,32,0,69,120,112,101,99,116,32,97,32,100,101,99,105,109,97,108,32,110,117,109,98,101,114,44,32,103,111,116,58,32,0,73,110,116,101,103,101,114,32,111,117,116,32,111,102,32,114,97,110,103,101,32,40,0,125,0,73,110,118,97,108,105,100,32,102,108,111,97,116,32,110,117,109,98,101,114,58,32,0,69,120,112,101,99,116,101,100,32,105,100,101,110,116,105,102,105,101,114,44,32,103,111,116,58,32,0,87,97,114,110,105,110,103,32,112,97,114,115,105,110,103,32,116,101,120,116,45,102,111,114,109,97,116,32,0,67,111,117,108,100,32,110,111,116,32,102,105,110,100,32,116,121,112,101,32,34,0,34,32,115,116,111,114,101,100,32,105,110,32,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,65,110,121,46,0,86,97,108,117,101,32,111,102,32,116,121,112,101,32,34,0,34,32,115,116,111,114,101,100,32,105,110,32,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,65,110,121,32,104,97,115,32,109,105,115,115,105,110,103,32,114,101,113,117,105,114,101,100,32,102,105,101,108,100,115,0,69,120,112,101,99,116,101,100,32,34,0,34,44,32,102,111,117,110,100,32,34,0,84,101,120,116,70,111,114,109,97,116,58,58,80,97,114,115,101,114,32,102,111,114,32,65,110,121,32,115,117,112,112,111,114,116,115,32,111,110,108,121,32,116,121,112,101,46,103,111,111,103,108,101,97,112,105,115,46,99,111,109,32,97,110,100,32,116,121,112,101,46,103,111,111,103,108,101,112,114,111,100,46,99,111,109,44,32,98,117,116,32,102,111,117,110,100,32,34,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,48,84,101,120,116,70,111,114,109,97,116,54,80,97,114,115,101,114,49,48,80,97,114,115,101,114,73,109,112,108,50,48,80,97,114,115,101,114,69,114,114,111,114,67,111,108,108,101,99,116,111,114,69,0,97,108,108,111,99,97,116,111,114,60,84,62,58,58,97,108,108,111,99,97,116,101,40,115,105,122,101,95,116,32,110,41,32,39,110,39,32,101,120,99,101,101,100,115,32,109,97,120,105,109,117,109,32,115,117,112,112,111,114,116,101,100,32,115,105,122,101,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,55,85,110,107,110,111,119,110,70,105,101,108,100,83,101,116,70,105,101,108,100,83,107,105,112,112,101,114,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,119,105,114,101,95,102,111,114,109,97,116,46,99,99,0,69,120,116,101,110,115,105,111,110,115,32,111,102,32,77,101,115,115,97,103,101,83,101,116,115,32,109,117,115,116,32,98,101,32,111,112,116,105,111,110,97,108,32,109,101,115,115,97,103,101,115,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,40,111,117,116,112,117,116,45,62,66,121,116,101,67,111,117,110,116,40,41,41,32,61,61,32,40,101,120,112,101,99,116,101,100,95,101,110,100,112,111,105,110,116,41,58,32,0,58,32,80,114,111,116,111,99,111,108,32,109,101,115,115,97,103,101,32,115,101,114,105,97,108,105,122,101,100,32,116,111,32,97,32,115,105,122,101,32,100,105,102,102,101,114,101,110,116,32,102,114,111,109,32,119,104,97,116,32,119,97,115,32,111,114,105,103,105,110,97,108,108,121,32,101,120,112,101,99,116,101,100,46,32,32,80,101,114,104,97,112,115,32,105,116,32,119,97,115,32,109,111,100,105,102,105,101,100,32,98,121,32,97,110,111,116,104,101,114,32,116,104,114,101,97,100,32,100,117,114,105,110,103,32,115,101,114,105,97,108,105,122,97,116,105,111,110,63,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,49,53,69,120,116,101,110,115,105,111,110,70,105,110,100,101,114,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,56,105,110,116,101,114,110,97,108,50,52,71,101,110,101,114,97,116,101,100,69,120,116,101,110,115,105,111,110,70,105,110,100,101,114,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,101,120,116,101,110,115,105,111,110,95,115,101,116,46,99,99,0,67,97,110,39,116,32,103,101,116,32,104,101,114,101,46,0,67,72,69,67,75,32,102,97,105,108,101,100,58,32,105,116,101,114,32,33,61,32,101,120,116,101,110,115,105,111,110,115,95,46,101,110,100,40,41,58,32,0,73,110,100,101,120,32,111,117,116,45,111,102,45,98,111,117,110,100,115,32,40,102,105,101,108,100,32,105,115,32,101,109,112,116,121,41,46,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,105,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,120,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,106,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,121,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,102,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,100,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,51,82,101,112,101,97,116,101,100,70,105,101,108,100,73,98,69,69,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,49,54,82,101,112,101,97,116,101,100,80,116,114,70,105,101,108,100,73,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,99,78,83,50,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,50,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,69,69,0,99,97,110,39,116,32,114,101,97,99,104,32,104,101,114,101,46,0,78,111,110,45,112,114,105,109,105,116,105,118,101,32,116,121,112,101,115,32,99,97,110,39,116,32,98,101,32,112,97,99,107,101,100,46,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,49,57,90,101,114,111,67,111,112,121,73,110,112,117,116,83,116,114,101,97,109,69,0,47,98,117,105,108,100,47,109,97,115,116,101,114,45,99,111,110,116,114,105,98,95,100,111,99,115,45,108,105,110,54,52,47,111,112,101,110,99,118,47,51,114,100,112,97,114,116,121,47,112,114,111,116,111,98,117,102,47,115,114,99,47,103,111,111,103,108,101,47,112,114,111,116,111,98,117,102,47,105,111,47,122,101,114,111,95,99,111,112,121,95,115,116,114,101,97,109,46,99,99,0,84,104,105,115,32,90,101,114,111,67,111,112,121,79,117,116,112,117,116,83,116,114,101,97,109,32,100,111,101,115,110,39,116,32,115,117,112,112,111,114,116,32,97,108,105,97,115,105,110,103,46,32,82,101,97,99,104,105,110,103,32,104,101,114,101,32,117,115,117,97,108,108,121,32,109,101,97,110,115,32,97,32,90,101,114,111,67,111,112,121,79,117,116,112,117,116,83,116,114,101,97,109,32,105,109,112,108,101,109,101,110,116,97,116,105,111,110,32,98,117,103,46,0,78,54,103,111,111,103,108,101,56,112,114,111,116,111,98,117,102,50,105,111,50,48,90,101,114,111,67,111,112,121,79,117,116,112,117,116,83,116,114,101,97,109,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,3,3,3,3,3,3,3,3,3,3,3,3,7,3,3,4,5,5,5,6,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,242,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,4,4,4,4,4,4,4,4,4,2,2,4,4,2,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,1,1,2,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+471102);allocate([1,1,1,1,1,1,1,1,1,1,1,1,1,1,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,0,48,48,48,49,48,50,48,51,48,52,48,53,48,54,48,55,48,56,48,57,49,48,49,49,49,50,49,51,49,52,49,53,49,54,49,55,49,56,49,57,50,48,50,49,50,50,50,51,50,52,50,53,50,54,50,55,50,56,50,57,51,48,51,49,51,50,51,51,51,52,51,53,51,54,51,55,51,56,51,57,52,48,52,49,52,50,52,51,52,52,52,53,52,54,52,55,52,56,52,57,53,48,53,49,53,50,53,51,53,52,53,53,53,54,53,55,53,56,53,57,54,48,54,49,54,50,54,51,54,52,54,53,54,54,54,55,54,56,54,57,55,48,55,49,55,50,55,51,55,52,55,53,55,54,55,55,55,56,55,57,56,48,56,49,56,50,56,51,56,52,56,53,56,54,56,55,56,56,56,57,57,48,57,49,57,50,57,51,57,52,57,53,57,54,57,55,57,56,57,57,45,105,110,102,0,37,46,42,103,0,103,111,111,103,108,101,46,112,114,111,116,111,98,117,102,46,65,110,121,0,116,121,112,101,46,103,111,111,103,108,101,97,112,105,115,46,99,111,109,47,0,116,121,112,101,46,103,111,111,103,108,101,112,114,111,100,46,99,111,109,47,0,115,116,100,58,58,98,97,115,105,99,95,115,116,114,105,110,103,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,0,115,116,100,58,58,119,115,116,114,105,110,103,0,101,109,115,99,114,105,112,116,101,110,58,58,118,97,108,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,115,105,103,110,101,100,32,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,99,104,97,114,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,115,104,111,114,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,115,104,111,114,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,105,110,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,108,111,110,103,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,110,115,105,103,110,101,100,32,108,111,110,103,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,56,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,56,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,49,54,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,49,54,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,105,110,116,51,50,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,117,105,110,116,51,50,95,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,102,108,111,97,116,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,100,111,117,98,108,101,62,0,101,109,115,99,114,105,112,116,101,110,58,58,109,101,109,111,114,121,95,118,105,101,119,60,108,111,110,103,32,100,111,117,98,108,101,62,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,101,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,109,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,108,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,106,69,69,0,78,49,48,101,109,115,99,114,105,112,116,101,110,49,49,109,101,109,111,114,121,95,118,105,101,119,73,97,69,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,50,98,97,115,105,99,95,115,116,114,105,110,103,73,104,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,104,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,104,69,69,69,69,0,17,0,10,0,17,17,17,0,0,0,0,5,0,0,0,0,0,0,9,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,15,10,17,17,17,3,10,7,0,1,19,9,11,11,0,0,9,6,11,0,0,11,0,6,17,0,0,0,17,17,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,10,10,17,17,17,0,10,0,0,2,0,9,11,0,0,0,9,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,4,13,0,0,0,0,9,14,0,0,0,0,0,14,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,15,0,0,0,0,9,16,0,0,0,0,0,16,0,0,16,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,10,0,0,0,0,9,11,0,0,0,0,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,45,43,32,32,32,48,88,48,120,0,40,110,117,108,108,41,0,45,48,88,43,48,88,32,48,88,45,48,120,43,48,120,32,48,120,0,105,110,102,0,73,78,70,0,78,65,78,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,84,33,34,25,13,1,2,3,17,75,28,12,16,4,11,29,18,30,39,104,110,111,112,113,98,32,5,6,15,19,20,21,26,8,22,7,40,36,23,24,9,10,14,27,31,37,35,131,130,125,38,42,43,60,61,62,63,67,71,74,77,88,89,90,91,92,93,94,95,96,97,99,100,101,102,103,105,106,107,108,114,115,116,121,122,123,124,0,73,108,108,101,103,97,108,32,98,121,116,101,32,115,101,113,117,101,110,99,101,0,68,111,109,97,105,110,32,101,114,114,111,114,0,82,101,115,117,108,116,32,110,111,116,32,114,101,112,114,101,115,101,110,116,97,98,108,101,0,78,111,116,32,97,32,116,116,121,0,80,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,79,112,101,114,97,116,105,111,110,32,110,111,116,32,112,101,114,109,105,116,116,101,100,0,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,0,78,111,32,115,117,99,104,32,112,114,111,99,101,115,115,0,70,105,108,101,32,101,120,105,115,116,115,0,86,97,108,117,101,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,100,97,116,97,32,116,121,112,101,0,78,111,32,115,112,97,99,101,32,108,101,102,116,32,111,110,32,100,101,118,105,99,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,115,111,117,114,99,101,32,98,117,115,121,0,73,110,116,101,114,114,117,112,116,101,100,32,115,121,115,116,101,109,32,99,97,108,108,0,82,101,115,111,117,114,99,101,32,116,101,109,112,111,114,97,114,105,108,121,32,117,110,97,118,97,105,108,97,98,108,101,0,73,110,118,97,108,105,100,32,115,101,101,107,0,67,114,111,115,115,45,100,101,118,105,99,101,32,108,105,110,107,0,82,101,97,100,45,111,110,108,121,32,102,105,108,101,32,115,121,115,116,101,109,0,68,105,114,101,99,116,111,114,121,32,110,111,116,32,101,109,112,116,121,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,112,101,101,114,0,79,112,101,114,97,116,105,111,110,32,116,105,109,101,100,32,111,117,116,0,67,111,110,110,101,99,116,105,111,110,32,114,101,102,117,115,101,100,0,72,111,115,116,32,105,115,32,100,111,119,110,0,72,111,115,116,32,105,115,32,117,110,114,101,97,99,104,97,98,108,101,0,65,100,100,114,101,115,115,32,105,110,32,117,115,101,0,66,114,111,107,101,110,32,112,105,112,101,0,73,47,79,32,101,114,114,111,114,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,32,111,114,32,97,100,100,114,101,115,115,0,66,108,111,99,107,32,100,101,118,105,99,101,32,114,101,113,117,105,114,101,100,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,0,78,111,116,32,97,32,100,105,114,101,99,116,111,114,121,0,73,115,32,97,32,100,105,114,101,99,116,111,114,121,0,84,101,120,116,32,102,105,108,101,32,98,117,115,121,0,69,120,101,99,32,102,111,114,109,97,116,32,101,114,114,111,114,0,73,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,0,65,114,103,117,109,101,110,116,32,108,105,115,116,32,116,111,111,32,108,111,110,103,0,83,121,109,98,111,108,105,99,32,108,105,110,107,32,108,111,111,112,0,70,105,108,101,110,97,109,101,32,116,111,111,32,108,111,110,103,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,32,105,110,32,115,121,115,116,101,109,0,78,111,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,115,32,97,118,97,105,108,97,98,108,101,0,66,97,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,0,78,111,32,99,104,105,108,100,32,112,114,111,99,101,115,115,0,66,97,100,32,97,100,100,114,101,115,115,0,70,105,108,101,32,116,111,111,32,108,97,114,103,101,0,84,111,111,32,109,97,110,121,32,108,105,110,107,115,0,78,111,32,108,111,99,107,115,32,97,118,97,105,108,97,98,108,101,0,82,101,115,111,117,114,99,101,32,100,101,97,100,108,111,99,107,32,119,111,117,108,100,32,111,99,99,117,114,0,83,116,97,116,101,32,110,111,116,32,114,101,99,111,118,101,114,97,98,108,101,0,80,114,101,118,105,111,117,115,32,111,119,110,101,114,32,100,105,101,100,0,79,112,101,114,97,116,105,111,110,32,99,97,110,99,101,108,101,100,0,70,117,110,99,116,105,111,110,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,78,111,32,109,101,115,115,97,103,101,32,111,102,32,100,101,115,105,114,101,100,32,116,121,112,101,0,73,100,101,110,116,105,102,105,101,114,32,114,101,109,111,118,101,100,0,68,101,118,105,99,101,32,110,111,116,32,97,32,115,116,114,101,97,109,0,78,111,32,100,97,116,97,32,97,118,97,105,108,97,98,108,101,0,68,101,118,105,99,101,32,116,105,109,101,111,117,116,0,79,117,116,32,111,102,32,115,116,114,101,97,109,115,32,114,101,115,111,117,114,99,101,115,0,76,105,110,107,32,104,97,115,32,98,101,101,110,32,115,101,118,101,114,101,100,0,80,114,111,116,111,99,111,108,32,101,114,114,111,114,0,66,97,100,32,109,101,115,115,97,103,101,0,70,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,105,110,32,98,97,100,32,115,116,97,116,101,0,78,111,116,32,97,32,115,111,99,107,101,116,0,68,101,115,116,105,110,97,116,105,111,110,32,97,100,100,114,101,115,115,32,114,101,113,117,105,114,101,100,0,77,101,115,115,97,103,101,32,116,111,111,32,108,97,114,103,101,0,80,114,111,116,111,99,111,108,32,119,114,111,110,103,32,116,121,112,101,32,102,111,114,32,115,111,99,107,101,116,0,80,114,111,116,111,99,111,108,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,80,114,111,116,111,99,111,108,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,83,111,99,107,101,116,32,116,121,112,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,111,116,32,115,117,112,112,111,114,116,101,100,0,80,114,111,116,111,99,111,108,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,100,100,114,101,115,115,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,112,114,111,116,111,99,111,108,0,65,100,100,114,101,115,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,78,101,116,119,111,114,107,32,105,115,32,100,111,119,110,0,78,101,116,119,111,114,107,32,117,110,114,101,97,99,104,97,98,108,101,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,110,101,116,119,111,114,107,0,67,111,110,110,101,99,116,105,111,110,32,97,98,111,114,116,101,100,0,78,111,32,98,117,102,102,101,114,32,115,112,97,99,101,32,97,118,97,105,108,97,98,108,101,0,83,111,99,107,101,116,32,105,115,32,99,111,110,110,101,99,116,101,100,0,83,111,99,107,101,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,67,97,110,110,111,116,32,115,101,110,100,32,97,102,116,101,114,32,115,111,99,107,101,116,32,115,104,117,116,100,111,119,110,0,79,112,101,114,97,116,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,112,114,111,103,114,101,115,115,0,79,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0,83,116,97,108,101,32,102,105,108,101,32,104,97,110,100,108,101,0,82,101,109,111,116,101,32,73,47,79,32,101,114,114,111,114,0,81,117,111,116,97,32,101,120,99,101,101,100,101,100,0,78,111,32,109,101,100,105,117,109,32,102,111,117,110,100,0,87,114,111,110,103,32,109,101,100,105,117,109,32,116,121,112,101,0,78,111,32,101,114,114,111,114,32,105,110,102,111,114,109,97,116,105,111,110,0,0,105,110,102,105,110,105,116,121,0,110,97,110,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,4,7,3,6,5,0,114,119,97,0,76,67,95,65,76,76,0,76,67,95,67,84,89,80,69,0,0,0,0,76,67,95,78,85,77,69,82,73,67,0,0,76,67,95,84,73,77,69,0,0,0,0,0,76,67,95,67,79,76,76,65,84,69,0,0,76,67,95,77,79,78,69,84,65,82,89,0,76,67,95,77,69,83,83,65,71,69,83,0,76,65,78,71,0,67,46,85,84,70,45,56,0,80,79,83,73,88,0,77,85,83,76,95,76,79,67,80,65,84,72,0,78,83,116,51,95,95,50,56,105,111,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,52,98,97,115,105,99,95,105,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,99,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,119,69,69,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,37,112,0,67,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,37,112,0,0,0,0,76,0,37,0,0,0,0,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,37,72,58,37,77,58,37,83,0,37,109,47,37,100,47,37,121,0,37,73,58,37,77,58,37,83,32,37,112,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,65,77,0,80,77,0,74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,77,97,114,99,104,0,65,112,114,105,108,0,77,97,121,0,74,117,110,101,0,74,117,108,121,0,65,117,103,117,115,116,0,83,101,112,116,101,109,98,101,114,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,68,101,99,101,109,98,101,114,0,74,97,110,0,70,101,98,0,77,97,114,0,65,112,114,0,74,117,110,0,74,117,108,0,65,117,103,0,83,101,112,0,79,99,116,0,78,111,118,0,68,101,99,0,83,117,110,100,97,121,0,77,111,110,100,97,121,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,84,104,117,114,115,100,97,121,0,70,114,105,100,97,121,0,83,97,116,117,114,100,97,121,0,83,117,110,0,77,111,110,0,84,117,101,0,87,101,100,0,84,104,117,0,70,114,105,0,83,97,116,0,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,37,72,58,37,77,37,72,58,37,77,58,37,83,37,72,58,37,77,58,37,83,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,78,83,116,51,95,95,50,57,116,105,109,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,95,95,116,105,109,101,95,112,117,116,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,48,49,50,51,52,53,54,55,56,57,0,37,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,48,49,50,51,52,53,54,55,56,57,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,37,46,48,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,99,69,69,0,78,83,116,51,95,95,50,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,119,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,99,69,69,0,78,83,116,51,95,95,50,49,48,99,116,121,112,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,119,69,69,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,99,69,69,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,119,69,69,0,78,83,116,51,95,95,50,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,58,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,101,120,99,101,112,116,105,111,110,32,111,102,32,116,121,112,101,32,37,115,0,116,101,114,109,105,110,97,116,105,110,103,32,119,105,116,104,32,37,115,32,102,111,114,101,105,103,110,32,101,120,99,101,112,116,105,111,110,0,116,101,114,109,105,110,97,116,105,110,103,0,117,110,99,97,117,103,104,116,0,83,116,57,101,120,99,101,112,116,105,111,110,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,83,116,57,116,121,112,101,95,105,110,102,111,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,112,116,104,114,101,97,100,95,111,110,99,101,32,102,97,105,108,117,114,101,32,105,110,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,95,102,97,115,116,40,41,0,99,97,110,110,111,116,32,99,114,101,97,116,101,32,112,116,104,114,101,97,100,32,107,101,121,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,99,97,110,110,111,116,32,122,101,114,111,32,111,117,116,32,116,104,114,101,97,100,32,118,97,108,117,101,32,102,111,114,32,95,95,99,120,97,95,103,101,116,95,103,108,111,98,97,108,115,40,41,0,116,101,114,109,105,110,97,116,101,95,104,97,110,100,108,101,114,32,117,110,101,120,112,101,99,116,101,100,108,121,32,114,101,116,117,114,110,101,100,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,83,116,56,98,97,100,95,99,97,115,116,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,57,95,95,112,111,105,110,116,101,114,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,112,98,97,115,101,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,51,95,95,102,117,110,100,97,109,101,110,116,97,108,95,116,121,112,101,95,105,110,102,111,69,0,118,0,68,110,0,98,0,97,0,115,0,105,0,106,0,109,0,100,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,32,99,111,110,115,116,0,32,118,111,108,97,116,105,108,101,0,32,114,101,115,116,114,105,99,116,0,32,99,111,109,112,108,101,120,0,32,105,109,97,103,105,110,97,114,121,0,32,91,0,32,40,0,41,0,40,0,38,38,0,111,98,106,99,95,111,98,106,101,99,116,60,0,42,0,38,0,111,98,106,99,112,114,111,116,111,0,32,0,60,0,62,0,32,118,101,99,116,111,114,91,0,93,0,112,105,120,101,108,32,118,101,99,116,111,114,91,0,38,61,0,61,0,44,0,126,0,58,58,0,100,101,108,101,116,101,91,93,32,0,100,101,108,101,116,101,32,0,47,0,47,61,0,94,0,94,61,0,61,61,0,62,61,0,41,91,0,60,61,0,60,60,0,60,60,61,0,45,0,45,61,0,42,61,0,45,45,0,41,45,45,0,33,61,0,33,0,124,124,0,124,0,124,61,0,45,62,42,0,43,0,43,61,0,43,43,0,41,43,43,0,41,32,63,32,40,0,41,32,58,32,40,0,37,0,37,61,0,62,62,0,62,62,61,0,116,104,114,111,119,0,116,104,114,111,119,32,0,116,121,112,101,105,100,40,0,115,105,122,101,111,102,46,46,46,40,0,44,32,0,115,105,122,101,111,102,32,40,0,115,116,97,116,105,99,95,99,97,115,116,60,0,62,40,0,114,101,105,110,116,101,114,112,114,101,116,95,99,97,115,116,60,0,45,62,0,110,111,101,120,99,101,112,116,32,40,0,91,93,32,0,41,32,0,46,0,46,42,0,115,116,100,58,58,0,111,112,101,114,97,116,111,114,38,38,0,111,112,101,114,97,116,111,114,38,0,111,112,101,114,97,116,111,114,38,61,0,111,112,101,114,97,116,111,114,61,0,111,112,101,114,97,116,111,114,40,41,0,111,112,101,114,97,116,111,114,44,0,111,112,101,114,97,116,111,114,126,0,111,112,101,114,97,116,111,114,32,0,111,112,101,114,97,116,111,114,32,100,101,108,101,116,101,91,93,0,111,112,101,114,97,116,111,114,42,0,111,112,101,114,97,116,111,114,47,0,111,112,101,114,97,116,111,114,47,61,0,111,112,101,114,97,116,111,114,94,0,111,112,101,114,97,116,111,114,94,61,0,111,112,101,114,97,116,111,114,61,61,0,111,112,101,114,97,116,111,114,62,61,0,111,112,101,114,97,116,111,114,62,0,111,112,101,114,97,116,111,114,91,93,0,111,112,101,114,97,116,111,114,60,61,0,111,112,101,114,97,116,111,114,34,34,32,0,111,112,101,114,97,116,111,114,60,60,0,111,112,101,114,97,116,111,114,60,60,61,0,111,112,101,114,97,116,111,114,60,0,111,112,101,114,97,116,111,114,45,0,111,112,101,114,97,116,111,114,45,61,0,111,112,101,114,97,116,111,114,42,61,0,111,112,101,114,97,116,111,114,45,45,0,111,112,101,114,97,116,111,114,32,110,101,119,91,93,0,111,112,101,114,97,116,111,114,33,61,0,111,112,101,114,97,116,111,114,33,0,111,112,101,114,97,116,111,114,32,110,101,119,0,111,112,101,114,97,116,111,114,124,124,0,111,112,101,114,97,116,111,114,124,0,111,112,101,114,97,116,111,114,124,61,0,111,112,101,114,97,116,111,114,45,62,42,0,111,112,101,114,97,116,111,114,43,0,111,112,101,114,97,116,111,114,43,61,0,111,112,101,114,97,116,111,114,43,43,0,111,112,101,114,97,116,111,114,45,62,0,111,112,101,114,97,116,111,114,63,0,111,112,101,114,97,116,111,114,37,0,111,112,101,114,97,116,111,114,37,61,0,111,112,101,114,97,116,111,114,62,62,0,111,112,101,114,97,116,111,114,62,62,61,0,111,112,101,114,97,116,111,114,32,100,101,108,101,116,101,0,39,117,110,110,97,109,101,100,0,39,108,97,109,98,100,97,39,40,0,115,116,100,58,58,115,116,114,105,110,103,0,115,116,100,58,58,98,97,115,105,99,95,115,116,114,105,110,103,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,44,32,115,116,100,58,58,97,108,108,111,99,97,116,111,114,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,115,116,114,105,110,103,0,115,116,100,58,58,105,115,116,114,101,97,109,0,115,116,100,58,58,98,97,115,105,99,95,105,115,116,114,101,97,109,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,105,115,116,114,101,97,109,0,115,116,100,58,58,111,115,116,114,101,97,109,0,115,116,100,58,58,98,97,115,105,99,95,111,115,116,114,101,97,109,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,111,115,116,114,101,97,109,0,115,116,100,58,58,105,111,115,116,114,101,97,109,0,115,116,100,58,58,98,97,115,105,99,95,105,111,115,116,114,101,97,109,60,99,104,97,114,44,32,115,116,100,58,58,99,104,97,114,95,116,114,97,105,116,115,60,99,104,97,114,62,32,62,0,98,97,115,105,99,95,105,111,115,116,114,101,97,109,0,100,121,110,97,109,105,99,95,99,97,115,116,60,0,41,40,0,99,111,110,115,116,95,99,97,115,116,60,0,97,108,105,103,110,111,102,32,40,0,102,112,0,119,99,104,97,114,95,116,0,102,97,108,115,101,0,116,114,117,101,0,99,104,97,114,0,115,105,103,110,101,100,32,99,104,97,114,0,117,110,115,105,103,110,101,100,32,99,104,97,114,0,115,104,111,114,116,0,117,110,115,105,103,110,101,100,32,115,104,111,114,116,0,117,0,108,0,117,108,0,108,108,0,117,108,108,0,95,95,105,110,116,49,50,56,0,117,110,115,105,103,110,101,100,32,95,95,105,110,116,49,50,56,0,37,76,97,76,0,37,97,0,37,97,102,0,100,101,99,108,116,121,112,101,40,0,115,116,100,58,58,97,108,108,111,99,97,116,111,114,0,115,116,100,58,58,98,97,115,105,99,95,115,116,114,105,110,103,0,58,58,115,116,114,105,110,103,32,108,105,116,101,114,97,108,0,115,116,100,0,95,71,76,79,66,65,76,95,95,78,0,40,97,110,111,110,121,109,111,117,115,32,110,97,109,101,115,112,97,99,101,41,0,32,62,0,84,95,0,105,100,0,58,58,42,0,32,38,0,32,38,38,0,32,91,93,0,118,111,105,100,0,98,111,111,108,0,105,110,116,0,117,110,115,105,103,110,101,100,32,105,110,116,0,108,111,110,103,0,117,110,115,105,103,110,101,100,32,108,111,110,103,0,108,111,110,103,32,108,111,110,103,0,102,108,111,97,116,0,108,111,110,103,32,100,111,117,98,108,101,0,95,95,102,108,111,97,116,49,50,56,0,46,46,46,0,100,101,99,105,109,97,108,54,52,0,100,101,99,105,109,97,108,49,50,56,0,100,101,99,105,109,97,108,51,50,0,100,101,99,105,109,97,108,49,54,0,99,104,97,114,51,50,95,116,0,99,104,97,114,49,54,95,116,0,97,117,116,111,0,115,116,100,58,58,110,117,108,108,112,116,114,95,116,0,100,111,117,98,108,101,0,117,110,115,105,103,110,101,100,32,108,111,110,103,32,108,111,110,103,0,95,98,108,111,99,107,95,105,110,118,111,107,101,0,105,110,118,111,99,97,116,105,111,110,32,102,117,110,99,116,105,111,110,32,102,111,114,32,98,108,111,99,107,32,105,110,32,0,118,116,97,98,108,101,32,102,111,114,32,0,86,84,84,32,102,111,114,32,0,116,121,112,101,105,110,102,111,32,102,111,114,32,0,116,121,112,101,105,110,102,111,32,110,97,109,101,32,102,111,114,32,0,99,111,118,97,114,105,97,110,116,32,114,101,116,117,114,110,32,116,104,117,110,107,32,116,111,32,0,99,111,110,115,116,114,117,99,116,105,111,110,32,118,116,97,98,108,101,32,102,111,114,32,0,45,105,110,45,0,118,105,114,116,117,97,108,32,116,104,117,110,107,32,116,111,32,0,110,111,110,45,118,105,114,116,117,97,108,32,116,104,117,110,107,32,116,111,32,0,103,117,97,114,100,32,118,97,114,105,97,98,108,101,32,102,111,114,32,0,114,101,102,101,114,101,110,99,101,32,116,101,109,112,111,114,97,114,121,32,102,111,114,32,0],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+481342);var tempDoublePtr=STATICTOP;STATICTOP+=16;function _atexit(func,arg){__ATEXIT__.unshift({func:func,arg:arg})}function ___cxa_atexit(){return _atexit.apply(null,arguments)}var emval_symbols={};function embind_init_charCodes(){var codes=new Array(256);for(var i=0;i<256;++i){codes[i]=String.fromCharCode(i)}embind_charCodes=codes}var embind_charCodes=undefined;function readLatin1String(ptr){var ret="";var c=ptr;while(HEAPU8[c]){ret+=embind_charCodes[HEAPU8[c++]]}return ret}function getStringOrSymbol(address){var symbol=emval_symbols[address];if(symbol===undefined){return readLatin1String(address)}else{return symbol}}var emval_free_list=[];var emval_handle_array=[{},{value:undefined},{value:null},{value:true},{value:false}];function count_emval_handles(){var count=0;for(var i=5;i<emval_handle_array.length;++i){if(emval_handle_array[i]!==undefined){++count}}return count}function get_first_emval(){for(var i=5;i<emval_handle_array.length;++i){if(emval_handle_array[i]!==undefined){return emval_handle_array[i]}}return null}function init_emval(){Module["count_emval_handles"]=count_emval_handles;Module["get_first_emval"]=get_first_emval}function __emval_register(value){switch(value){case undefined:{return 1};case null:{return 2};case true:{return 3};case false:{return 4};default:{var handle=emval_free_list.length?emval_free_list.pop():emval_handle_array.length;emval_handle_array[handle]={refcount:1,value:value};return handle}}}function __emval_new_cstring(v){return __emval_register(getStringOrSymbol(v))}var emval_methodCallers=[];function __emval_addMethodCaller(caller){var id=emval_methodCallers.length;emval_methodCallers.push(caller);return id}var registeredTypes={};function getTypeName(type){var ptr=___getTypeName(type);var rv=readLatin1String(ptr);_free(ptr);return rv}var char_0=48;var char_9=57;function makeLegalFunctionName(name){if(undefined===name){return"_unknown"}name=name.replace(/[^a-zA-Z0-9_]/g,"$");var f=name.charCodeAt(0);if(f>=char_0&&f<=char_9){return"_"+name}else{return name}}function createNamedFunction(name,body){name=makeLegalFunctionName(name);return(new Function("body","return function "+name+"() {\n"+'    "use strict";'+"    return body.apply(this, arguments);\n"+"};\n"))(body)}function extendError(baseErrorType,errorName){var errorClass=createNamedFunction(errorName,(function(message){this.name=errorName;this.message=message;var stack=(new Error(message)).stack;if(stack!==undefined){this.stack=this.toString()+"\n"+stack.replace(/^Error(:[^\n]*)?\n/,"")}}));errorClass.prototype=Object.create(baseErrorType.prototype);errorClass.prototype.constructor=errorClass;errorClass.prototype.toString=(function(){if(this.message===undefined){return this.name}else{return this.name+": "+this.message}});return errorClass}var BindingError=undefined;function throwBindingError(message){throw new BindingError(message)}function requireRegisteredType(rawType,humanName){var impl=registeredTypes[rawType];if(undefined===impl){throwBindingError(humanName+" has unknown type "+getTypeName(rawType))}return impl}function __emval_lookupTypes(argCount,argTypes,argWireTypes){var a=new Array(argCount);for(var i=0;i<argCount;++i){a[i]=requireRegisteredType(HEAP32[(argTypes>>2)+i],"parameter "+i)}return a}function new_(constructor,argumentList){if(!(constructor instanceof Function)){throw new TypeError("new_ called with constructor type "+typeof constructor+" which is not a function")}var dummy=createNamedFunction(constructor.name||"unknownFunctionName",(function(){}));dummy.prototype=constructor.prototype;var obj=new dummy;var r=constructor.apply(obj,argumentList);return r instanceof Object?r:obj}function __emval_get_method_caller(argCount,argTypes){var types=__emval_lookupTypes(argCount,argTypes);var retType=types[0];var signatureName=retType.name+"_$"+types.slice(1).map((function(t){return t.name})).join("_")+"$";var params=["retType"];var args=[retType];var argsList="";for(var i=0;i<argCount-1;++i){argsList+=(i!==0?", ":"")+"arg"+i;params.push("argType"+i);args.push(types[1+i])}var functionName=makeLegalFunctionName("methodCaller_"+signatureName);var functionBody="return function "+functionName+"(handle, name, destructors, args) {\n";var offset=0;for(var i=0;i<argCount-1;++i){functionBody+="    var arg"+i+" = argType"+i+".readValueFromPointer(args"+(offset?"+"+offset:"")+");\n";offset+=types[i+1]["argPackAdvance"]}functionBody+="    var rv = handle[name]("+argsList+");\n";for(var i=0;i<argCount-1;++i){if(types[i+1]["deleteObject"]){functionBody+="    argType"+i+".deleteObject(arg"+i+");\n"}}if(!retType.isVoid){functionBody+="    return retType.toWireType(destructors, rv);\n"}functionBody+="};\n";params.push(functionBody);var invokerFunction=new_(Function,params).apply(null,args);return __emval_addMethodCaller(invokerFunction)}function __ZSt18uncaught_exceptionv(){return!!__ZSt18uncaught_exceptionv.uncaught_exception}var EXCEPTIONS={last:0,caught:[],infos:{},deAdjust:(function(adjusted){if(!adjusted||EXCEPTIONS.infos[adjusted])return adjusted;for(var ptr in EXCEPTIONS.infos){var info=EXCEPTIONS.infos[ptr];if(info.adjusted===adjusted){return ptr}}return adjusted}),addRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount++}),decRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];assert(info.refcount>0);info.refcount--;if(info.refcount===0&&!info.rethrown){if(info.destructor){Module["dynCall_vi"](info.destructor,ptr)}delete EXCEPTIONS.infos[ptr];___cxa_free_exception(ptr)}}),clearRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount=0})};function ___resumeException(ptr){if(!EXCEPTIONS.last){EXCEPTIONS.last=ptr}throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}function ___cxa_find_matching_catch(){var thrown=EXCEPTIONS.last;if(!thrown){return(Runtime.setTempRet0(0),0)|0}var info=EXCEPTIONS.infos[thrown];var throwntype=info.type;if(!throwntype){return(Runtime.setTempRet0(0),thrown)|0}var typeArray=Array.prototype.slice.call(arguments);var pointer=Module["___cxa_is_pointer_type"](throwntype);if(!___cxa_find_matching_catch.buffer)___cxa_find_matching_catch.buffer=_malloc(4);HEAP32[___cxa_find_matching_catch.buffer>>2]=thrown;thrown=___cxa_find_matching_catch.buffer;for(var i=0;i<typeArray.length;i++){if(typeArray[i]&&Module["___cxa_can_catch"](typeArray[i],throwntype,thrown)){thrown=HEAP32[thrown>>2];info.adjusted=thrown;return(Runtime.setTempRet0(typeArray[i]),thrown)|0}}thrown=HEAP32[thrown>>2];return(Runtime.setTempRet0(throwntype),thrown)|0}function ___cxa_throw(ptr,type,destructor){EXCEPTIONS.infos[ptr]={ptr:ptr,adjusted:ptr,type:type,destructor:destructor,refcount:0,caught:false,rethrown:false};EXCEPTIONS.last=ptr;if(!("uncaught_exception"in __ZSt18uncaught_exceptionv)){__ZSt18uncaught_exceptionv.uncaught_exception=1}else{__ZSt18uncaught_exceptionv.uncaught_exception++}throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}var awaitingDependencies={};var typeDependencies={};var InternalError=undefined;function throwInternalError(message){throw new InternalError(message)}function whenDependentTypesAreResolved(myTypes,dependentTypes,getTypeConverters){myTypes.forEach((function(type){typeDependencies[type]=dependentTypes}));function onComplete(typeConverters){var myTypeConverters=getTypeConverters(typeConverters);if(myTypeConverters.length!==myTypes.length){throwInternalError("Mismatched type converter count")}for(var i=0;i<myTypes.length;++i){registerType(myTypes[i],myTypeConverters[i])}}var typeConverters=new Array(dependentTypes.length);var unregisteredTypes=[];var registered=0;dependentTypes.forEach((function(dt,i){if(registeredTypes.hasOwnProperty(dt)){typeConverters[i]=registeredTypes[dt]}else{unregisteredTypes.push(dt);if(!awaitingDependencies.hasOwnProperty(dt)){awaitingDependencies[dt]=[]}awaitingDependencies[dt].push((function(){typeConverters[i]=registeredTypes[dt];++registered;if(registered===unregisteredTypes.length){onComplete(typeConverters)}}))}}));if(0===unregisteredTypes.length){onComplete(typeConverters)}}function registerType(rawType,registeredInstance,options){options=options||{};if(!("argPackAdvance"in registeredInstance)){throw new TypeError("registerType registeredInstance requires argPackAdvance")}var name=registeredInstance.name;if(!rawType){throwBindingError('type "'+name+'" must have a positive integer typeid pointer')}if(registeredTypes.hasOwnProperty(rawType)){if(options.ignoreDuplicateRegistrations){return}else{throwBindingError("Cannot register type '"+name+"' twice")}}registeredTypes[rawType]=registeredInstance;delete typeDependencies[rawType];if(awaitingDependencies.hasOwnProperty(rawType)){var callbacks=awaitingDependencies[rawType];delete awaitingDependencies[rawType];callbacks.forEach((function(cb){cb()}))}}function simpleReadValueFromPointer(pointer){return this["fromWireType"](HEAPU32[pointer>>2])}function __embind_register_std_string(rawType,name){name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(value){var length=HEAPU32[value>>2];var a=new Array(length);for(var i=0;i<length;++i){a[i]=String.fromCharCode(HEAPU8[value+4+i])}_free(value);return a.join("")}),"toWireType":(function(destructors,value){if(value instanceof ArrayBuffer){value=new Uint8Array(value)}function getTAElement(ta,index){return ta[index]}function getStringElement(string,index){return string.charCodeAt(index)}var getElement;if(value instanceof Uint8Array){getElement=getTAElement}else if(value instanceof Uint8ClampedArray){getElement=getTAElement}else if(value instanceof Int8Array){getElement=getTAElement}else if(typeof value==="string"){getElement=getStringElement}else{throwBindingError("Cannot pass non-string to std::string")}var length=value.length;var ptr=_malloc(4+length);HEAPU32[ptr>>2]=length;for(var i=0;i<length;++i){var charCode=getElement(value,i);if(charCode>255){_free(ptr);throwBindingError("String has UTF-16 code units that do not fit in 8 bits")}HEAPU8[ptr+4+i]=charCode}if(destructors!==null){destructors.push(_free,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:(function(ptr){_free(ptr)})})}function __embind_register_std_wstring(rawType,charSize,name){name=readLatin1String(name);var getHeap,shift;if(charSize===2){getHeap=(function(){return HEAPU16});shift=1}else if(charSize===4){getHeap=(function(){return HEAPU32});shift=2}registerType(rawType,{name:name,"fromWireType":(function(value){var HEAP=getHeap();var length=HEAPU32[value>>2];var a=new Array(length);var start=value+4>>shift;for(var i=0;i<length;++i){a[i]=String.fromCharCode(HEAP[start+i])}_free(value);return a.join("")}),"toWireType":(function(destructors,value){var HEAP=getHeap();var length=value.length;var ptr=_malloc(4+length*charSize);HEAPU32[ptr>>2]=length;var start=ptr+4>>shift;for(var i=0;i<length;++i){HEAP[start+i]=value.charCodeAt(i)}if(destructors!==null){destructors.push(_free,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:(function(ptr){_free(ptr)})})}function _pthread_mutex_init(){}var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_STATIC);function __emval_decref(handle){if(handle>4&&0===--emval_handle_array[handle].refcount){emval_handle_array[handle]=undefined;emval_free_list.push(handle)}}function _embind_repr(v){if(v===null){return"null"}var t=typeof v;if(t==="object"||t==="array"||t==="function"){return v.toString()}else{return""+v}}function getShiftFromSize(size){switch(size){case 1:return 0;case 2:return 1;case 4:return 2;case 8:return 3;default:throw new TypeError("Unknown type size: "+size)}}function integerReadValueFromPointer(name,shift,signed){switch(shift){case 0:return signed?function readS8FromPointer(pointer){return HEAP8[pointer]}:function readU8FromPointer(pointer){return HEAPU8[pointer]};case 1:return signed?function readS16FromPointer(pointer){return HEAP16[pointer>>1]}:function readU16FromPointer(pointer){return HEAPU16[pointer>>1]};case 2:return signed?function readS32FromPointer(pointer){return HEAP32[pointer>>2]}:function readU32FromPointer(pointer){return HEAPU32[pointer>>2]};default:throw new TypeError("Unknown integer type: "+name)}}function __embind_register_integer(primitiveType,name,size,minRange,maxRange){name=readLatin1String(name);if(maxRange===-1){maxRange=4294967295}var shift=getShiftFromSize(size);var fromWireType=(function(value){return value});if(minRange===0){var bitshift=32-8*size;fromWireType=(function(value){return value<<bitshift>>>bitshift})}var isUnsignedType=name.indexOf("unsigned")!=-1;registerType(primitiveType,{name:name,"fromWireType":fromWireType,"toWireType":(function(destructors,value){if(typeof value!=="number"&&typeof value!=="boolean"){throw new TypeError('Cannot convert "'+_embind_repr(value)+'" to '+this.name)}if(value<minRange||value>maxRange){throw new TypeError('Passing a number "'+_embind_repr(value)+'" from JS side to C/C++ side to an argument of type "'+name+'", which is outside the valid range ['+minRange+", "+maxRange+"]!")}return isUnsignedType?value>>>0:value|0}),"argPackAdvance":8,"readValueFromPointer":integerReadValueFromPointer(name,shift,minRange!==0),destructorFunction:null})}var structRegistrations={};function runDestructors(destructors){while(destructors.length){var ptr=destructors.pop();var del=destructors.pop();del(ptr)}}function __embind_finalize_value_object(structType){var reg=structRegistrations[structType];delete structRegistrations[structType];var rawConstructor=reg.rawConstructor;var rawDestructor=reg.rawDestructor;var fieldRecords=reg.fields;var fieldTypes=fieldRecords.map((function(field){return field.getterReturnType})).concat(fieldRecords.map((function(field){return field.setterArgumentType})));whenDependentTypesAreResolved([structType],fieldTypes,(function(fieldTypes){var fields={};fieldRecords.forEach((function(field,i){var fieldName=field.fieldName;var getterReturnType=fieldTypes[i];var getter=field.getter;var getterContext=field.getterContext;var setterArgumentType=fieldTypes[i+fieldRecords.length];var setter=field.setter;var setterContext=field.setterContext;fields[fieldName]={read:(function(ptr){return getterReturnType["fromWireType"](getter(getterContext,ptr))}),write:(function(ptr,o){var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,o));runDestructors(destructors)})}}));return[{name:reg.name,"fromWireType":(function(ptr){var rv={};for(var i in fields){rv[i]=fields[i].read(ptr)}rawDestructor(ptr);return rv}),"toWireType":(function(destructors,o){for(var fieldName in fields){if(!(fieldName in o)){throw new TypeError("Missing field")}}var ptr=rawConstructor();for(fieldName in fields){fields[fieldName].write(ptr,o[fieldName])}if(destructors!==null){destructors.push(rawDestructor,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:rawDestructor}]}))}var PTHREAD_SPECIFIC={};var PTHREAD_SPECIFIC_NEXT_KEY=1;var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};function _pthread_key_create(key,destructor){if(key==0){return ERRNO_CODES.EINVAL}HEAP32[key>>2]=PTHREAD_SPECIFIC_NEXT_KEY;PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY]=0;PTHREAD_SPECIFIC_NEXT_KEY++;return 0}function __emval_take_value(type,argv){type=requireRegisteredType(type,"_emval_take_value");var v=type["readValueFromPointer"](argv);return __emval_register(v)}var _llvm_pow_f32=Math_pow;var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};function ___setErrNo(value){if(Module["___errno_location"])HEAP32[Module["___errno_location"]()>>2]=value;return value}var PATH={splitPath:(function(filename){var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;return splitPathRe.exec(filename).slice(1)}),normalizeArray:(function(parts,allowAboveRoot){var up=0;for(var i=parts.length-1;i>=0;i--){var last=parts[i];if(last==="."){parts.splice(i,1)}else if(last===".."){parts.splice(i,1);up++}else if(up){parts.splice(i,1);up--}}if(allowAboveRoot){for(;up;up--){parts.unshift("..")}}return parts}),normalize:(function(path){var isAbsolute=path.charAt(0)==="/",trailingSlash=path.substr(-1)==="/";path=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),!isAbsolute).join("/");if(!path&&!isAbsolute){path="."}if(path&&trailingSlash){path+="/"}return(isAbsolute?"/":"")+path}),dirname:(function(path){var result=PATH.splitPath(path),root=result[0],dir=result[1];if(!root&&!dir){return"."}if(dir){dir=dir.substr(0,dir.length-1)}return root+dir}),basename:(function(path){if(path==="/")return"/";var lastSlash=path.lastIndexOf("/");if(lastSlash===-1)return path;return path.substr(lastSlash+1)}),extname:(function(path){return PATH.splitPath(path)[3]}),join:(function(){var paths=Array.prototype.slice.call(arguments,0);return PATH.normalize(paths.join("/"))}),join2:(function(l,r){return PATH.normalize(l+"/"+r)}),resolve:(function(){var resolvedPath="",resolvedAbsolute=false;for(var i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:FS.cwd();if(typeof path!=="string"){throw new TypeError("Arguments to path.resolve must be strings")}else if(!path){return""}resolvedPath=path+"/"+resolvedPath;resolvedAbsolute=path.charAt(0)==="/"}resolvedPath=PATH.normalizeArray(resolvedPath.split("/").filter((function(p){return!!p})),!resolvedAbsolute).join("/");return(resolvedAbsolute?"/":"")+resolvedPath||"."}),relative:(function(from,to){from=PATH.resolve(from).substr(1);to=PATH.resolve(to).substr(1);function trim(arr){var start=0;for(;start<arr.length;start++){if(arr[start]!=="")break}var end=arr.length-1;for(;end>=0;end--){if(arr[end]!=="")break}if(start>end)return[];return arr.slice(start,end-start+1)}var fromParts=trim(from.split("/"));var toParts=trim(to.split("/"));var length=Math.min(fromParts.length,toParts.length);var samePartsLength=length;for(var i=0;i<length;i++){if(fromParts[i]!==toParts[i]){samePartsLength=i;break}}var outputParts=[];for(var i=samePartsLength;i<fromParts.length;i++){outputParts.push("..")}outputParts=outputParts.concat(toParts.slice(samePartsLength));return outputParts.join("/")})};var TTY={ttys:[],init:(function(){}),shutdown:(function(){}),register:(function(dev,ops){TTY.ttys[dev]={input:[],output:[],ops:ops};FS.registerDevice(dev,TTY.stream_ops)}),stream_ops:{open:(function(stream){var tty=TTY.ttys[stream.node.rdev];if(!tty){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}stream.tty=tty;stream.seekable=false}),close:(function(stream){stream.tty.ops.flush(stream.tty)}),flush:(function(stream){stream.tty.ops.flush(stream.tty)}),read:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.get_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=stream.tty.ops.get_char(stream.tty)}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.put_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}for(var i=0;i<length;i++){try{stream.tty.ops.put_char(stream.tty,buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})},default_tty_ops:{get_char:(function(tty){if(!tty.input.length){var result=null;if(ENVIRONMENT_IS_NODE){var BUFSIZE=256;var buf=new Buffer(BUFSIZE);var bytesRead=0;var isPosixPlatform=process.platform!="win32";var fd=process.stdin.fd;if(isPosixPlatform){var usingDevice=false;try{fd=fs.openSync("/dev/stdin","r");usingDevice=true}catch(e){}}try{bytesRead=fs.readSync(fd,buf,0,BUFSIZE,null)}catch(e){if(e.toString().indexOf("EOF")!=-1)bytesRead=0;else throw e}if(usingDevice){fs.closeSync(fd)}if(bytesRead>0){result=buf.slice(0,bytesRead).toString("utf-8")}else{result=null}}else if(typeof window!="undefined"&&typeof window.prompt=="function"){result=window.prompt("Input: ");if(result!==null){result+="\n"}}else if(typeof readline=="function"){result=readline();if(result!==null){result+="\n"}}if(!result){return null}tty.input=intArrayFromString(result,true)}return tty.input.shift()}),put_char:(function(tty,val){if(val===null||val===10){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}})},default_tty1_ops:{put_char:(function(tty,val){if(val===null||val===10){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}})}};var MEMFS={ops_table:null,mount:(function(mount){return MEMFS.createNode(null,"/",16384|511,0)}),createNode:(function(parent,name,mode,dev){if(FS.isBlkdev(mode)||FS.isFIFO(mode)){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(!MEMFS.ops_table){MEMFS.ops_table={dir:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,lookup:MEMFS.node_ops.lookup,mknod:MEMFS.node_ops.mknod,rename:MEMFS.node_ops.rename,unlink:MEMFS.node_ops.unlink,rmdir:MEMFS.node_ops.rmdir,readdir:MEMFS.node_ops.readdir,symlink:MEMFS.node_ops.symlink},stream:{llseek:MEMFS.stream_ops.llseek}},file:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:{llseek:MEMFS.stream_ops.llseek,read:MEMFS.stream_ops.read,write:MEMFS.stream_ops.write,allocate:MEMFS.stream_ops.allocate,mmap:MEMFS.stream_ops.mmap,msync:MEMFS.stream_ops.msync}},link:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,readlink:MEMFS.node_ops.readlink},stream:{}},chrdev:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:FS.chrdev_stream_ops}}}var node=FS.createNode(parent,name,mode,dev);if(FS.isDir(node.mode)){node.node_ops=MEMFS.ops_table.dir.node;node.stream_ops=MEMFS.ops_table.dir.stream;node.contents={}}else if(FS.isFile(node.mode)){node.node_ops=MEMFS.ops_table.file.node;node.stream_ops=MEMFS.ops_table.file.stream;node.usedBytes=0;node.contents=null}else if(FS.isLink(node.mode)){node.node_ops=MEMFS.ops_table.link.node;node.stream_ops=MEMFS.ops_table.link.stream}else if(FS.isChrdev(node.mode)){node.node_ops=MEMFS.ops_table.chrdev.node;node.stream_ops=MEMFS.ops_table.chrdev.stream}node.timestamp=Date.now();if(parent){parent.contents[name]=node}return node}),getFileDataAsRegularArray:(function(node){if(node.contents&&node.contents.subarray){var arr=[];for(var i=0;i<node.usedBytes;++i)arr.push(node.contents[i]);return arr}return node.contents}),getFileDataAsTypedArray:(function(node){if(!node.contents)return new Uint8Array;if(node.contents.subarray)return node.contents.subarray(0,node.usedBytes);return new Uint8Array(node.contents)}),expandFileStorage:(function(node,newCapacity){if(node.contents&&node.contents.subarray&&newCapacity>node.contents.length){node.contents=MEMFS.getFileDataAsRegularArray(node);node.usedBytes=node.contents.length}if(!node.contents||node.contents.subarray){var prevCapacity=node.contents?node.contents.length:0;if(prevCapacity>=newCapacity)return;var CAPACITY_DOUBLING_MAX=1024*1024;newCapacity=Math.max(newCapacity,prevCapacity*(prevCapacity<CAPACITY_DOUBLING_MAX?2:1.125)|0);if(prevCapacity!=0)newCapacity=Math.max(newCapacity,256);var oldContents=node.contents;node.contents=new Uint8Array(newCapacity);if(node.usedBytes>0)node.contents.set(oldContents.subarray(0,node.usedBytes),0);return}if(!node.contents&&newCapacity>0)node.contents=[];while(node.contents.length<newCapacity)node.contents.push(0)}),resizeFileStorage:(function(node,newSize){if(node.usedBytes==newSize)return;if(newSize==0){node.contents=null;node.usedBytes=0;return}if(!node.contents||node.contents.subarray){var oldContents=node.contents;node.contents=new Uint8Array(new ArrayBuffer(newSize));if(oldContents){node.contents.set(oldContents.subarray(0,Math.min(newSize,node.usedBytes)))}node.usedBytes=newSize;return}if(!node.contents)node.contents=[];if(node.contents.length>newSize)node.contents.length=newSize;else while(node.contents.length<newSize)node.contents.push(0);node.usedBytes=newSize}),node_ops:{getattr:(function(node){var attr={};attr.dev=FS.isChrdev(node.mode)?node.id:1;attr.ino=node.id;attr.mode=node.mode;attr.nlink=1;attr.uid=0;attr.gid=0;attr.rdev=node.rdev;if(FS.isDir(node.mode)){attr.size=4096}else if(FS.isFile(node.mode)){attr.size=node.usedBytes}else if(FS.isLink(node.mode)){attr.size=node.link.length}else{attr.size=0}attr.atime=new Date(node.timestamp);attr.mtime=new Date(node.timestamp);attr.ctime=new Date(node.timestamp);attr.blksize=4096;attr.blocks=Math.ceil(attr.size/attr.blksize);return attr}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}if(attr.size!==undefined){MEMFS.resizeFileStorage(node,attr.size)}}),lookup:(function(parent,name){throw FS.genericErrors[ERRNO_CODES.ENOENT]}),mknod:(function(parent,name,mode,dev){return MEMFS.createNode(parent,name,mode,dev)}),rename:(function(old_node,new_dir,new_name){if(FS.isDir(old_node.mode)){var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(new_node){for(var i in new_node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}}}delete old_node.parent.contents[old_node.name];old_node.name=new_name;new_dir.contents[new_name]=old_node;old_node.parent=new_dir}),unlink:(function(parent,name){delete parent.contents[name]}),rmdir:(function(parent,name){var node=FS.lookupNode(parent,name);for(var i in node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}delete parent.contents[name]}),readdir:(function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries}),symlink:(function(parent,newname,oldpath){var node=MEMFS.createNode(parent,newname,511|40960,0);node.link=oldpath;return node}),readlink:(function(node){if(!FS.isLink(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return node.link})},stream_ops:{read:(function(stream,buffer,offset,length,position){var contents=stream.node.contents;if(position>=stream.node.usedBytes)return 0;var size=Math.min(stream.node.usedBytes-position,length);assert(size>=0);if(size>8&&contents.subarray){buffer.set(contents.subarray(position,position+size),offset)}else{for(var i=0;i<size;i++)buffer[offset+i]=contents[position+i]}return size}),write:(function(stream,buffer,offset,length,position,canOwn){if(!length)return 0;var node=stream.node;node.timestamp=Date.now();if(buffer.subarray&&(!node.contents||node.contents.subarray)){if(canOwn){node.contents=buffer.subarray(offset,offset+length);node.usedBytes=length;return length}else if(node.usedBytes===0&&position===0){node.contents=new Uint8Array(buffer.subarray(offset,offset+length));node.usedBytes=length;return length}else if(position+length<=node.usedBytes){node.contents.set(buffer.subarray(offset,offset+length),position);return length}}MEMFS.expandFileStorage(node,position+length);if(node.contents.subarray&&buffer.subarray)node.contents.set(buffer.subarray(offset,offset+length),position);else{for(var i=0;i<length;i++){node.contents[position+i]=buffer[offset+i]}}node.usedBytes=Math.max(node.usedBytes,position+length);return length}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.usedBytes}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position}),allocate:(function(stream,offset,length){MEMFS.expandFileStorage(stream.node,offset+length);stream.node.usedBytes=Math.max(stream.node.usedBytes,offset+length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}var ptr;var allocated;var contents=stream.node.contents;if(!(flags&2)&&(contents.buffer===buffer||contents.buffer===buffer.buffer)){allocated=false;ptr=contents.byteOffset}else{if(position>0||position+length<stream.node.usedBytes){if(contents.subarray){contents=contents.subarray(position,position+length)}else{contents=Array.prototype.slice.call(contents,position,position+length)}}allocated=true;ptr=_malloc(length);if(!ptr){throw new FS.ErrnoError(ERRNO_CODES.ENOMEM)}buffer.set(contents,ptr)}return{ptr:ptr,allocated:allocated}}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(mmapFlags&2){return 0}var bytesWritten=MEMFS.stream_ops.write(stream,buffer,0,length,offset,false);return 0})}};var IDBFS={dbs:{},indexedDB:(function(){if(typeof indexedDB!=="undefined")return indexedDB;var ret=null;if(typeof window==="object")ret=window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB;assert(ret,"IDBFS used, but indexedDB not supported");return ret}),DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:(function(mount){return MEMFS.mount.apply(null,arguments)}),syncfs:(function(mount,populate,callback){IDBFS.getLocalSet(mount,(function(err,local){if(err)return callback(err);IDBFS.getRemoteSet(mount,(function(err,remote){if(err)return callback(err);var src=populate?remote:local;var dst=populate?local:remote;IDBFS.reconcile(src,dst,callback)}))}))}),getDB:(function(name,callback){var db=IDBFS.dbs[name];if(db){return callback(null,db)}var req;try{req=IDBFS.indexedDB().open(name,IDBFS.DB_VERSION)}catch(e){return callback(e)}if(!req){return callback("Unable to connect to IndexedDB")}req.onupgradeneeded=(function(e){var db=e.target.result;var transaction=e.target.transaction;var fileStore;if(db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)){fileStore=transaction.objectStore(IDBFS.DB_STORE_NAME)}else{fileStore=db.createObjectStore(IDBFS.DB_STORE_NAME)}if(!fileStore.indexNames.contains("timestamp")){fileStore.createIndex("timestamp","timestamp",{unique:false})}});req.onsuccess=(function(){db=req.result;IDBFS.dbs[name]=db;callback(null,db)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),getLocalSet:(function(mount,callback){var entries={};function isRealDir(p){return p!=="."&&p!==".."}function toAbsolute(root){return(function(p){return PATH.join2(root,p)})}var check=FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));while(check.length){var path=check.pop();var stat;try{stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){check.push.apply(check,FS.readdir(path).filter(isRealDir).map(toAbsolute(path)))}entries[path]={timestamp:stat.mtime}}return callback(null,{type:"local",entries:entries})}),getRemoteSet:(function(mount,callback){var entries={};IDBFS.getDB(mount.mountpoint,(function(err,db){if(err)return callback(err);var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readonly");transaction.onerror=(function(e){callback(this.error);e.preventDefault()});var store=transaction.objectStore(IDBFS.DB_STORE_NAME);var index=store.index("timestamp");index.openKeyCursor().onsuccess=(function(event){var cursor=event.target.result;if(!cursor){return callback(null,{type:"remote",db:db,entries:entries})}entries[cursor.primaryKey]={timestamp:cursor.key};cursor.continue()})}))}),loadLocalEntry:(function(path,callback){var stat,node;try{var lookup=FS.lookupPath(path);node=lookup.node;stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){return callback(null,{timestamp:stat.mtime,mode:stat.mode})}else if(FS.isFile(stat.mode)){node.contents=MEMFS.getFileDataAsTypedArray(node);return callback(null,{timestamp:stat.mtime,mode:stat.mode,contents:node.contents})}else{return callback(new Error("node type not supported"))}}),storeLocalEntry:(function(path,entry,callback){try{if(FS.isDir(entry.mode)){FS.mkdir(path,entry.mode)}else if(FS.isFile(entry.mode)){FS.writeFile(path,entry.contents,{encoding:"binary",canOwn:true})}else{return callback(new Error("node type not supported"))}FS.chmod(path,entry.mode);FS.utime(path,entry.timestamp,entry.timestamp)}catch(e){return callback(e)}callback(null)}),removeLocalEntry:(function(path,callback){try{var lookup=FS.lookupPath(path);var stat=FS.stat(path);if(FS.isDir(stat.mode)){FS.rmdir(path)}else if(FS.isFile(stat.mode)){FS.unlink(path)}}catch(e){return callback(e)}callback(null)}),loadRemoteEntry:(function(store,path,callback){var req=store.get(path);req.onsuccess=(function(event){callback(null,event.target.result)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),storeRemoteEntry:(function(store,path,entry,callback){var req=store.put(entry,path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),removeRemoteEntry:(function(store,path,callback){var req=store.delete(path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),reconcile:(function(src,dst,callback){var total=0;var create=[];Object.keys(src.entries).forEach((function(key){var e=src.entries[key];var e2=dst.entries[key];if(!e2||e.timestamp>e2.timestamp){create.push(key);total++}}));var remove=[];Object.keys(dst.entries).forEach((function(key){var e=dst.entries[key];var e2=src.entries[key];if(!e2){remove.push(key);total++}}));if(!total){return callback(null)}var completed=0;var db=src.type==="remote"?src.db:dst.db;var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readwrite");var store=transaction.objectStore(IDBFS.DB_STORE_NAME);function done(err){if(err){if(!done.errored){done.errored=true;return callback(err)}return}if(++completed>=total){return callback(null)}}transaction.onerror=(function(e){done(this.error);e.preventDefault()});create.sort().forEach((function(path){if(dst.type==="local"){IDBFS.loadRemoteEntry(store,path,(function(err,entry){if(err)return done(err);IDBFS.storeLocalEntry(path,entry,done)}))}else{IDBFS.loadLocalEntry(path,(function(err,entry){if(err)return done(err);IDBFS.storeRemoteEntry(store,path,entry,done)}))}}));remove.sort().reverse().forEach((function(path){if(dst.type==="local"){IDBFS.removeLocalEntry(path,done)}else{IDBFS.removeRemoteEntry(store,path,done)}}))})};var NODEFS={isWindows:false,staticInit:(function(){NODEFS.isWindows=!!process.platform.match(/^win/)}),mount:(function(mount){assert(ENVIRONMENT_IS_NODE);return NODEFS.createNode(null,"/",NODEFS.getMode(mount.opts.root),0)}),createNode:(function(parent,name,mode,dev){if(!FS.isDir(mode)&&!FS.isFile(mode)&&!FS.isLink(mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=FS.createNode(parent,name,mode);node.node_ops=NODEFS.node_ops;node.stream_ops=NODEFS.stream_ops;return node}),getMode:(function(path){var stat;try{stat=fs.lstatSync(path);if(NODEFS.isWindows){stat.mode=stat.mode|(stat.mode&146)>>1}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return stat.mode}),realPath:(function(node){var parts=[];while(node.parent!==node){parts.push(node.name);node=node.parent}parts.push(node.mount.opts.root);parts.reverse();return PATH.join.apply(null,parts)}),flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:(function(flags){flags&=~2097152;flags&=~2048;flags&=~32768;flags&=~524288;if(flags in NODEFS.flagsToPermissionStringMap){return NODEFS.flagsToPermissionStringMap[flags]}else{throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}}),node_ops:{getattr:(function(node){var path=NODEFS.realPath(node);var stat;try{stat=fs.lstatSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(NODEFS.isWindows&&!stat.blksize){stat.blksize=4096}if(NODEFS.isWindows&&!stat.blocks){stat.blocks=(stat.size+stat.blksize-1)/stat.blksize|0}return{dev:stat.dev,ino:stat.ino,mode:stat.mode,nlink:stat.nlink,uid:stat.uid,gid:stat.gid,rdev:stat.rdev,size:stat.size,atime:stat.atime,mtime:stat.mtime,ctime:stat.ctime,blksize:stat.blksize,blocks:stat.blocks}}),setattr:(function(node,attr){var path=NODEFS.realPath(node);try{if(attr.mode!==undefined){fs.chmodSync(path,attr.mode);node.mode=attr.mode}if(attr.timestamp!==undefined){var date=new Date(attr.timestamp);fs.utimesSync(path,date,date)}if(attr.size!==undefined){fs.truncateSync(path,attr.size)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),lookup:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);var mode=NODEFS.getMode(path);return NODEFS.createNode(parent,name,mode)}),mknod:(function(parent,name,mode,dev){var node=NODEFS.createNode(parent,name,mode,dev);var path=NODEFS.realPath(node);try{if(FS.isDir(node.mode)){fs.mkdirSync(path,node.mode)}else{fs.writeFileSync(path,"",{mode:node.mode})}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return node}),rename:(function(oldNode,newDir,newName){var oldPath=NODEFS.realPath(oldNode);var newPath=PATH.join2(NODEFS.realPath(newDir),newName);try{fs.renameSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),unlink:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.unlinkSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),rmdir:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.rmdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readdir:(function(node){var path=NODEFS.realPath(node);try{return fs.readdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),symlink:(function(parent,newName,oldPath){var newPath=PATH.join2(NODEFS.realPath(parent),newName);try{fs.symlinkSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readlink:(function(node){var path=NODEFS.realPath(node);try{path=fs.readlinkSync(path);path=NODEJS_PATH.relative(NODEJS_PATH.resolve(node.mount.opts.root),path);return path}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}})},stream_ops:{open:(function(stream){var path=NODEFS.realPath(stream.node);try{if(FS.isFile(stream.node.mode)){stream.nfd=fs.openSync(path,NODEFS.flagsToPermissionString(stream.flags))}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),close:(function(stream){try{if(FS.isFile(stream.node.mode)&&stream.nfd){fs.closeSync(stream.nfd)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),read:(function(stream,buffer,offset,length,position){if(length===0)return 0;var nbuffer=new Buffer(length);var res;try{res=fs.readSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(res>0){for(var i=0;i<res;i++){buffer[offset+i]=nbuffer[i]}}return res}),write:(function(stream,buffer,offset,length,position){var nbuffer=new Buffer(buffer.subarray(offset,offset+length));var res;try{res=fs.writeSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}return res}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){try{var stat=fs.fstatSync(stream.nfd);position+=stat.size}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};var WORKERFS={DIR_MODE:16895,FILE_MODE:33279,reader:null,mount:(function(mount){assert(ENVIRONMENT_IS_WORKER);if(!WORKERFS.reader)WORKERFS.reader=new FileReaderSync;var root=WORKERFS.createNode(null,"/",WORKERFS.DIR_MODE,0);var createdParents={};function ensureParent(path){var parts=path.split("/");var parent=root;for(var i=0;i<parts.length-1;i++){var curr=parts.slice(0,i+1).join("/");if(!createdParents[curr]){createdParents[curr]=WORKERFS.createNode(parent,parts[i],WORKERFS.DIR_MODE,0)}parent=createdParents[curr]}return parent}function base(path){var parts=path.split("/");return parts[parts.length-1]}Array.prototype.forEach.call(mount.opts["files"]||[],(function(file){WORKERFS.createNode(ensureParent(file.name),base(file.name),WORKERFS.FILE_MODE,0,file,file.lastModifiedDate)}));(mount.opts["blobs"]||[]).forEach((function(obj){WORKERFS.createNode(ensureParent(obj["name"]),base(obj["name"]),WORKERFS.FILE_MODE,0,obj["data"])}));(mount.opts["packages"]||[]).forEach((function(pack){pack["metadata"].files.forEach((function(file){var name=file.filename.substr(1);WORKERFS.createNode(ensureParent(name),base(name),WORKERFS.FILE_MODE,0,pack["blob"].slice(file.start,file.end))}))}));return root}),createNode:(function(parent,name,mode,dev,contents,mtime){var node=FS.createNode(parent,name,mode);node.mode=mode;node.node_ops=WORKERFS.node_ops;node.stream_ops=WORKERFS.stream_ops;node.timestamp=(mtime||new Date).getTime();assert(WORKERFS.FILE_MODE!==WORKERFS.DIR_MODE);if(mode===WORKERFS.FILE_MODE){node.size=contents.size;node.contents=contents}else{node.size=4096;node.contents={}}if(parent){parent.contents[name]=node}return node}),node_ops:{getattr:(function(node){return{dev:1,ino:undefined,mode:node.mode,nlink:1,uid:0,gid:0,rdev:undefined,size:node.size,atime:new Date(node.timestamp),mtime:new Date(node.timestamp),ctime:new Date(node.timestamp),blksize:4096,blocks:Math.ceil(node.size/4096)}}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}}),lookup:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}),mknod:(function(parent,name,mode,dev){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rename:(function(oldNode,newDir,newName){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),unlink:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rmdir:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readdir:(function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries}),symlink:(function(parent,newName,oldPath){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readlink:(function(node){throw new FS.ErrnoError(ERRNO_CODES.EPERM)})},stream_ops:{read:(function(stream,buffer,offset,length,position){if(position>=stream.node.size)return 0;var chunk=stream.node.contents.slice(position,position+length);var ab=WORKERFS.reader.readAsArrayBuffer(chunk);buffer.set(new Uint8Array(ab),offset);return chunk.size}),write:(function(stream,buffer,offset,length,position){throw new FS.ErrnoError(ERRNO_CODES.EIO)}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.size}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};STATICTOP+=16;STATICTOP+=16;STATICTOP+=16;var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,trackingDelegate:{},tracking:{openFlags:{READ:1,WRITE:2}},ErrnoError:null,genericErrors:{},filesystems:null,syncFSRequests:0,handleFSError:(function(e){if(!(e instanceof FS.ErrnoError))throw e+" : "+stackTrace();return ___setErrNo(e.errno)}),lookupPath:(function(path,opts){path=PATH.resolve(FS.cwd(),path);opts=opts||{};if(!path)return{path:"",node:null};var defaults={follow_mount:true,recurse_count:0};for(var key in defaults){if(opts[key]===undefined){opts[key]=defaults[key]}}if(opts.recurse_count>8){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}var parts=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),false);var current=FS.root;var current_path="/";for(var i=0;i<parts.length;i++){var islast=i===parts.length-1;if(islast&&opts.parent){break}current=FS.lookupNode(current,parts[i]);current_path=PATH.join2(current_path,parts[i]);if(FS.isMountpoint(current)){if(!islast||islast&&opts.follow_mount){current=current.mounted.root}}if(!islast||opts.follow){var count=0;while(FS.isLink(current.mode)){var link=FS.readlink(current_path);current_path=PATH.resolve(PATH.dirname(current_path),link);var lookup=FS.lookupPath(current_path,{recurse_count:opts.recurse_count});current=lookup.node;if(count++>40){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}}}}return{path:current_path,node:current}}),getPath:(function(node){var path;while(true){if(FS.isRoot(node)){var mount=node.mount.mountpoint;if(!path)return mount;return mount[mount.length-1]!=="/"?mount+"/"+path:mount+path}path=path?node.name+"/"+path:node.name;node=node.parent}}),hashName:(function(parentid,name){var hash=0;for(var i=0;i<name.length;i++){hash=(hash<<5)-hash+name.charCodeAt(i)|0}return(parentid+hash>>>0)%FS.nameTable.length}),hashAddNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);node.name_next=FS.nameTable[hash];FS.nameTable[hash]=node}),hashRemoveNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);if(FS.nameTable[hash]===node){FS.nameTable[hash]=node.name_next}else{var current=FS.nameTable[hash];while(current){if(current.name_next===node){current.name_next=node.name_next;break}current=current.name_next}}}),lookupNode:(function(parent,name){var err=FS.mayLookup(parent);if(err){throw new FS.ErrnoError(err,parent)}var hash=FS.hashName(parent.id,name);for(var node=FS.nameTable[hash];node;node=node.name_next){var nodeName=node.name;if(node.parent.id===parent.id&&nodeName===name){return node}}return FS.lookup(parent,name)}),createNode:(function(parent,name,mode,rdev){if(!FS.FSNode){FS.FSNode=(function(parent,name,mode,rdev){if(!parent){parent=this}this.parent=parent;this.mount=parent.mount;this.mounted=null;this.id=FS.nextInode++;this.name=name;this.mode=mode;this.node_ops={};this.stream_ops={};this.rdev=rdev});FS.FSNode.prototype={};var readMode=292|73;var writeMode=146;Object.defineProperties(FS.FSNode.prototype,{read:{get:(function(){return(this.mode&readMode)===readMode}),set:(function(val){val?this.mode|=readMode:this.mode&=~readMode})},write:{get:(function(){return(this.mode&writeMode)===writeMode}),set:(function(val){val?this.mode|=writeMode:this.mode&=~writeMode})},isFolder:{get:(function(){return FS.isDir(this.mode)})},isDevice:{get:(function(){return FS.isChrdev(this.mode)})}})}var node=new FS.FSNode(parent,name,mode,rdev);FS.hashAddNode(node);return node}),destroyNode:(function(node){FS.hashRemoveNode(node)}),isRoot:(function(node){return node===node.parent}),isMountpoint:(function(node){return!!node.mounted}),isFile:(function(mode){return(mode&61440)===32768}),isDir:(function(mode){return(mode&61440)===16384}),isLink:(function(mode){return(mode&61440)===40960}),isChrdev:(function(mode){return(mode&61440)===8192}),isBlkdev:(function(mode){return(mode&61440)===24576}),isFIFO:(function(mode){return(mode&61440)===4096}),isSocket:(function(mode){return(mode&49152)===49152}),flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:(function(str){var flags=FS.flagModes[str];if(typeof flags==="undefined"){throw new Error("Unknown file open mode: "+str)}return flags}),flagsToPermissionString:(function(flag){var perms=["r","w","rw"][flag&3];if(flag&512){perms+="w"}return perms}),nodePermissions:(function(node,perms){if(FS.ignorePermissions){return 0}if(perms.indexOf("r")!==-1&&!(node.mode&292)){return ERRNO_CODES.EACCES}else if(perms.indexOf("w")!==-1&&!(node.mode&146)){return ERRNO_CODES.EACCES}else if(perms.indexOf("x")!==-1&&!(node.mode&73)){return ERRNO_CODES.EACCES}return 0}),mayLookup:(function(dir){var err=FS.nodePermissions(dir,"x");if(err)return err;if(!dir.node_ops.lookup)return ERRNO_CODES.EACCES;return 0}),mayCreate:(function(dir,name){try{var node=FS.lookupNode(dir,name);return ERRNO_CODES.EEXIST}catch(e){}return FS.nodePermissions(dir,"wx")}),mayDelete:(function(dir,name,isdir){var node;try{node=FS.lookupNode(dir,name)}catch(e){return e.errno}var err=FS.nodePermissions(dir,"wx");if(err){return err}if(isdir){if(!FS.isDir(node.mode)){return ERRNO_CODES.ENOTDIR}if(FS.isRoot(node)||FS.getPath(node)===FS.cwd()){return ERRNO_CODES.EBUSY}}else{if(FS.isDir(node.mode)){return ERRNO_CODES.EISDIR}}return 0}),mayOpen:(function(node,flags){if(!node){return ERRNO_CODES.ENOENT}if(FS.isLink(node.mode)){return ERRNO_CODES.ELOOP}else if(FS.isDir(node.mode)){if(FS.flagsToPermissionString(flags)!=="r"||flags&512){return ERRNO_CODES.EISDIR}}return FS.nodePermissions(node,FS.flagsToPermissionString(flags))}),MAX_OPEN_FDS:4096,nextfd:(function(fd_start,fd_end){fd_start=fd_start||0;fd_end=fd_end||FS.MAX_OPEN_FDS;for(var fd=fd_start;fd<=fd_end;fd++){if(!FS.streams[fd]){return fd}}throw new FS.ErrnoError(ERRNO_CODES.EMFILE)}),getStream:(function(fd){return FS.streams[fd]}),createStream:(function(stream,fd_start,fd_end){if(!FS.FSStream){FS.FSStream=(function(){});FS.FSStream.prototype={};Object.defineProperties(FS.FSStream.prototype,{object:{get:(function(){return this.node}),set:(function(val){this.node=val})},isRead:{get:(function(){return(this.flags&2097155)!==1})},isWrite:{get:(function(){return(this.flags&2097155)!==0})},isAppend:{get:(function(){return this.flags&1024})}})}var newStream=new FS.FSStream;for(var p in stream){newStream[p]=stream[p]}stream=newStream;var fd=FS.nextfd(fd_start,fd_end);stream.fd=fd;FS.streams[fd]=stream;return stream}),closeStream:(function(fd){FS.streams[fd]=null}),chrdev_stream_ops:{open:(function(stream){var device=FS.getDevice(stream.node.rdev);stream.stream_ops=device.stream_ops;if(stream.stream_ops.open){stream.stream_ops.open(stream)}}),llseek:(function(){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)})},major:(function(dev){return dev>>8}),minor:(function(dev){return dev&255}),makedev:(function(ma,mi){return ma<<8|mi}),registerDevice:(function(dev,ops){FS.devices[dev]={stream_ops:ops}}),getDevice:(function(dev){return FS.devices[dev]}),getMounts:(function(mount){var mounts=[];var check=[mount];while(check.length){var m=check.pop();mounts.push(m);check.push.apply(check,m.mounts)}return mounts}),syncfs:(function(populate,callback){if(typeof populate==="function"){callback=populate;populate=false}FS.syncFSRequests++;if(FS.syncFSRequests>1){console.log("warning: "+FS.syncFSRequests+" FS.syncfs operations in flight at once, probably just doing extra work")}var mounts=FS.getMounts(FS.root.mount);var completed=0;function doCallback(err){assert(FS.syncFSRequests>0);FS.syncFSRequests--;return callback(err)}function done(err){if(err){if(!done.errored){done.errored=true;return doCallback(err)}return}if(++completed>=mounts.length){doCallback(null)}}mounts.forEach((function(mount){if(!mount.type.syncfs){return done(null)}mount.type.syncfs(mount,populate,done)}))}),mount:(function(type,opts,mountpoint){var root=mountpoint==="/";var pseudo=!mountpoint;var node;if(root&&FS.root){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}else if(!root&&!pseudo){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});mountpoint=lookup.path;node=lookup.node;if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}}var mount={type:type,opts:opts,mountpoint:mountpoint,mounts:[]};var mountRoot=type.mount(mount);mountRoot.mount=mount;mount.root=mountRoot;if(root){FS.root=mountRoot}else if(node){node.mounted=mount;if(node.mount){node.mount.mounts.push(mount)}}return mountRoot}),unmount:(function(mountpoint){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});if(!FS.isMountpoint(lookup.node)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=lookup.node;var mount=node.mounted;var mounts=FS.getMounts(mount);Object.keys(FS.nameTable).forEach((function(hash){var current=FS.nameTable[hash];while(current){var next=current.name_next;if(mounts.indexOf(current.mount)!==-1){FS.destroyNode(current)}current=next}}));node.mounted=null;var idx=node.mount.mounts.indexOf(mount);assert(idx!==-1);node.mount.mounts.splice(idx,1)}),lookup:(function(parent,name){return parent.node_ops.lookup(parent,name)}),mknod:(function(path,mode,dev){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);if(!name||name==="."||name===".."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.mayCreate(parent,name);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.mknod){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.mknod(parent,name,mode,dev)}),create:(function(path,mode){mode=mode!==undefined?mode:438;mode&=4095;mode|=32768;return FS.mknod(path,mode,0)}),mkdir:(function(path,mode){mode=mode!==undefined?mode:511;mode&=511|512;mode|=16384;return FS.mknod(path,mode,0)}),mkdirTree:(function(path,mode){var dirs=path.split("/");var d="";for(var i=0;i<dirs.length;++i){if(!dirs[i])continue;d+="/"+dirs[i];try{FS.mkdir(d,mode)}catch(e){if(e.errno!=ERRNO_CODES.EEXIST)throw e}}}),mkdev:(function(path,mode,dev){if(typeof dev==="undefined"){dev=mode;mode=438}mode|=8192;return FS.mknod(path,mode,dev)}),symlink:(function(oldpath,newpath){if(!PATH.resolve(oldpath)){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var lookup=FS.lookupPath(newpath,{parent:true});var parent=lookup.node;if(!parent){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var newname=PATH.basename(newpath);var err=FS.mayCreate(parent,newname);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.symlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.symlink(parent,newname,oldpath)}),rename:(function(old_path,new_path){var old_dirname=PATH.dirname(old_path);var new_dirname=PATH.dirname(new_path);var old_name=PATH.basename(old_path);var new_name=PATH.basename(new_path);var lookup,old_dir,new_dir;try{lookup=FS.lookupPath(old_path,{parent:true});old_dir=lookup.node;lookup=FS.lookupPath(new_path,{parent:true});new_dir=lookup.node}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!old_dir||!new_dir)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(old_dir.mount!==new_dir.mount){throw new FS.ErrnoError(ERRNO_CODES.EXDEV)}var old_node=FS.lookupNode(old_dir,old_name);var relative=PATH.relative(old_path,new_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}relative=PATH.relative(new_path,old_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(old_node===new_node){return}var isdir=FS.isDir(old_node.mode);var err=FS.mayDelete(old_dir,old_name,isdir);if(err){throw new FS.ErrnoError(err)}err=new_node?FS.mayDelete(new_dir,new_name,isdir):FS.mayCreate(new_dir,new_name);if(err){throw new FS.ErrnoError(err)}if(!old_dir.node_ops.rename){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(old_node)||new_node&&FS.isMountpoint(new_node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(new_dir!==old_dir){err=FS.nodePermissions(old_dir,"w");if(err){throw new FS.ErrnoError(err)}}try{if(FS.trackingDelegate["willMovePath"]){FS.trackingDelegate["willMovePath"](old_path,new_path)}}catch(e){console.log("FS.trackingDelegate['willMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}FS.hashRemoveNode(old_node);try{old_dir.node_ops.rename(old_node,new_dir,new_name)}catch(e){throw e}finally{FS.hashAddNode(old_node)}try{if(FS.trackingDelegate["onMovePath"])FS.trackingDelegate["onMovePath"](old_path,new_path)}catch(e){console.log("FS.trackingDelegate['onMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}}),rmdir:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,true);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.rmdir){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.rmdir(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;if(!node.node_ops.readdir){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}return node.node_ops.readdir(node)}),unlink:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,false);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.unlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.unlink(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readlink:(function(path){var lookup=FS.lookupPath(path);var link=lookup.node;if(!link){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!link.node_ops.readlink){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return PATH.resolve(FS.getPath(link.parent),link.node_ops.readlink(link))}),stat:(function(path,dontFollow){var lookup=FS.lookupPath(path,{follow:!dontFollow});var node=lookup.node;if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!node.node_ops.getattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return node.node_ops.getattr(node)}),lstat:(function(path){return FS.stat(path,true)}),chmod:(function(path,mode,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{mode:mode&4095|node.mode&~4095,timestamp:Date.now()})}),lchmod:(function(path,mode){FS.chmod(path,mode,true)}),fchmod:(function(fd,mode){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chmod(stream.node,mode)}),chown:(function(path,uid,gid,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{timestamp:Date.now()})}),lchown:(function(path,uid,gid){FS.chown(path,uid,gid,true)}),fchown:(function(fd,uid,gid){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chown(stream.node,uid,gid)}),truncate:(function(path,len){if(len<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:true});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!FS.isFile(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.nodePermissions(node,"w");if(err){throw new FS.ErrnoError(err)}node.node_ops.setattr(node,{size:len,timestamp:Date.now()})}),ftruncate:(function(fd,len){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}FS.truncate(stream.node,len)}),utime:(function(path,atime,mtime){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;node.node_ops.setattr(node,{timestamp:Math.max(atime,mtime)})}),open:(function(path,flags,mode,fd_start,fd_end){if(path===""){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}flags=typeof flags==="string"?FS.modeStringToFlags(flags):flags;mode=typeof mode==="undefined"?438:mode;if(flags&64){mode=mode&4095|32768}else{mode=0}var node;if(typeof path==="object"){node=path}else{path=PATH.normalize(path);try{var lookup=FS.lookupPath(path,{follow:!(flags&131072)});node=lookup.node}catch(e){}}var created=false;if(flags&64){if(node){if(flags&128){throw new FS.ErrnoError(ERRNO_CODES.EEXIST)}}else{node=FS.mknod(path,mode,0);created=true}}if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(FS.isChrdev(node.mode)){flags&=~512}if(flags&65536&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}if(!created){var err=FS.mayOpen(node,flags);if(err){throw new FS.ErrnoError(err)}}if(flags&512){FS.truncate(node,0)}flags&=~(128|512);var stream=FS.createStream({node:node,path:FS.getPath(node),flags:flags,seekable:true,position:0,stream_ops:node.stream_ops,ungotten:[],error:false},fd_start,fd_end);if(stream.stream_ops.open){stream.stream_ops.open(stream)}if(Module["logReadFiles"]&&!(flags&1)){if(!FS.readFiles)FS.readFiles={};if(!(path in FS.readFiles)){FS.readFiles[path]=1;Module["printErr"]("read file: "+path)}}try{if(FS.trackingDelegate["onOpenFile"]){var trackingFlags=0;if((flags&2097155)!==1){trackingFlags|=FS.tracking.openFlags.READ}if((flags&2097155)!==0){trackingFlags|=FS.tracking.openFlags.WRITE}FS.trackingDelegate["onOpenFile"](path,trackingFlags)}}catch(e){console.log("FS.trackingDelegate['onOpenFile']('"+path+"', flags) threw an exception: "+e.message)}return stream}),close:(function(stream){if(stream.getdents)stream.getdents=null;try{if(stream.stream_ops.close){stream.stream_ops.close(stream)}}catch(e){throw e}finally{FS.closeStream(stream.fd)}}),llseek:(function(stream,offset,whence){if(!stream.seekable||!stream.stream_ops.llseek){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}stream.position=stream.stream_ops.llseek(stream,offset,whence);stream.ungotten=[];return stream.position}),read:(function(stream,buffer,offset,length,position){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.read){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesRead=stream.stream_ops.read(stream,buffer,offset,length,position);if(!seeking)stream.position+=bytesRead;return bytesRead}),write:(function(stream,buffer,offset,length,position,canOwn){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.write){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if(stream.flags&1024){FS.llseek(stream,0,2)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesWritten=stream.stream_ops.write(stream,buffer,offset,length,position,canOwn);if(!seeking)stream.position+=bytesWritten;try{if(stream.path&&FS.trackingDelegate["onWriteToFile"])FS.trackingDelegate["onWriteToFile"](stream.path)}catch(e){console.log("FS.trackingDelegate['onWriteToFile']('"+path+"') threw an exception: "+e.message)}return bytesWritten}),allocate:(function(stream,offset,length){if(offset<0||length<=0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(!FS.isFile(stream.node.mode)&&!FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(!stream.stream_ops.allocate){throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)}stream.stream_ops.allocate(stream,offset,length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EACCES)}if(!stream.stream_ops.mmap){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}return stream.stream_ops.mmap(stream,buffer,offset,length,position,prot,flags)}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!stream||!stream.stream_ops.msync){return 0}return stream.stream_ops.msync(stream,buffer,offset,length,mmapFlags)}),munmap:(function(stream){return 0}),ioctl:(function(stream,cmd,arg){if(!stream.stream_ops.ioctl){throw new FS.ErrnoError(ERRNO_CODES.ENOTTY)}return stream.stream_ops.ioctl(stream,cmd,arg)}),readFile:(function(path,opts){opts=opts||{};opts.flags=opts.flags||"r";opts.encoding=opts.encoding||"binary";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var ret;var stream=FS.open(path,opts.flags);var stat=FS.stat(path);var length=stat.size;var buf=new Uint8Array(length);FS.read(stream,buf,0,length,0);if(opts.encoding==="utf8"){ret=UTF8ArrayToString(buf,0)}else if(opts.encoding==="binary"){ret=buf}FS.close(stream);return ret}),writeFile:(function(path,data,opts){opts=opts||{};opts.flags=opts.flags||"w";opts.encoding=opts.encoding||"utf8";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var stream=FS.open(path,opts.flags,opts.mode);if(opts.encoding==="utf8"){var buf=new Uint8Array(lengthBytesUTF8(data)+1);var actualNumBytes=stringToUTF8Array(data,buf,0,buf.length);FS.write(stream,buf,0,actualNumBytes,0,opts.canOwn)}else if(opts.encoding==="binary"){FS.write(stream,data,0,data.length,0,opts.canOwn)}FS.close(stream)}),cwd:(function(){return FS.currentPath}),chdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});if(lookup.node===null){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!FS.isDir(lookup.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}var err=FS.nodePermissions(lookup.node,"x");if(err){throw new FS.ErrnoError(err)}FS.currentPath=lookup.path}),createDefaultDirectories:(function(){FS.mkdir("/tmp");FS.mkdir("/home");FS.mkdir("/home/web_user")}),createDefaultDevices:(function(){FS.mkdir("/dev");FS.registerDevice(FS.makedev(1,3),{read:(function(){return 0}),write:(function(stream,buffer,offset,length,pos){return length})});FS.mkdev("/dev/null",FS.makedev(1,3));TTY.register(FS.makedev(5,0),TTY.default_tty_ops);TTY.register(FS.makedev(6,0),TTY.default_tty1_ops);FS.mkdev("/dev/tty",FS.makedev(5,0));FS.mkdev("/dev/tty1",FS.makedev(6,0));var random_device;if(typeof crypto!=="undefined"){var randomBuffer=new Uint8Array(1);random_device=(function(){crypto.getRandomValues(randomBuffer);return randomBuffer[0]})}else if(ENVIRONMENT_IS_NODE){random_device=(function(){return require("crypto").randomBytes(1)[0]})}else{random_device=(function(){return Math.random()*256|0})}FS.createDevice("/dev","random",random_device);FS.createDevice("/dev","urandom",random_device);FS.mkdir("/dev/shm");FS.mkdir("/dev/shm/tmp")}),createSpecialDirectories:(function(){FS.mkdir("/proc");FS.mkdir("/proc/self");FS.mkdir("/proc/self/fd");FS.mount({mount:(function(){var node=FS.createNode("/proc/self","fd",16384|511,73);node.node_ops={lookup:(function(parent,name){var fd=+name;var stream=FS.getStream(fd);if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);var ret={parent:null,mount:{mountpoint:"fake"},node_ops:{readlink:(function(){return stream.path})}};ret.parent=ret;return ret})};return node})},{},"/proc/self/fd")}),createStandardStreams:(function(){if(Module["stdin"]){FS.createDevice("/dev","stdin",Module["stdin"])}else{FS.symlink("/dev/tty","/dev/stdin")}if(Module["stdout"]){FS.createDevice("/dev","stdout",null,Module["stdout"])}else{FS.symlink("/dev/tty","/dev/stdout")}if(Module["stderr"]){FS.createDevice("/dev","stderr",null,Module["stderr"])}else{FS.symlink("/dev/tty1","/dev/stderr")}var stdin=FS.open("/dev/stdin","r");assert(stdin.fd===0,"invalid handle for stdin ("+stdin.fd+")");var stdout=FS.open("/dev/stdout","w");assert(stdout.fd===1,"invalid handle for stdout ("+stdout.fd+")");var stderr=FS.open("/dev/stderr","w");assert(stderr.fd===2,"invalid handle for stderr ("+stderr.fd+")")}),ensureErrnoError:(function(){if(FS.ErrnoError)return;FS.ErrnoError=function ErrnoError(errno,node){this.node=node;this.setErrno=(function(errno){this.errno=errno;for(var key in ERRNO_CODES){if(ERRNO_CODES[key]===errno){this.code=key;break}}});this.setErrno(errno);this.message=ERRNO_MESSAGES[errno]};FS.ErrnoError.prototype=new Error;FS.ErrnoError.prototype.constructor=FS.ErrnoError;[ERRNO_CODES.ENOENT].forEach((function(code){FS.genericErrors[code]=new FS.ErrnoError(code);FS.genericErrors[code].stack="<generic error, no stack>"}))}),staticInit:(function(){FS.ensureErrnoError();FS.nameTable=new Array(4096);FS.mount(MEMFS,{},"/");FS.createDefaultDirectories();FS.createDefaultDevices();FS.createSpecialDirectories();FS.filesystems={"MEMFS":MEMFS,"IDBFS":IDBFS,"NODEFS":NODEFS,"WORKERFS":WORKERFS}}),init:(function(input,output,error){assert(!FS.init.initialized,"FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)");FS.init.initialized=true;FS.ensureErrnoError();Module["stdin"]=input||Module["stdin"];Module["stdout"]=output||Module["stdout"];Module["stderr"]=error||Module["stderr"];FS.createStandardStreams()}),quit:(function(){FS.init.initialized=false;var fflush=Module["_fflush"];if(fflush)fflush(0);for(var i=0;i<FS.streams.length;i++){var stream=FS.streams[i];if(!stream){continue}FS.close(stream)}}),getMode:(function(canRead,canWrite){var mode=0;if(canRead)mode|=292|73;if(canWrite)mode|=146;return mode}),joinPath:(function(parts,forceRelative){var path=PATH.join.apply(null,parts);if(forceRelative&&path[0]=="/")path=path.substr(1);return path}),absolutePath:(function(relative,base){return PATH.resolve(base,relative)}),standardizePath:(function(path){return PATH.normalize(path)}),findObject:(function(path,dontResolveLastLink){var ret=FS.analyzePath(path,dontResolveLastLink);if(ret.exists){return ret.object}else{___setErrNo(ret.error);return null}}),analyzePath:(function(path,dontResolveLastLink){try{var lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});path=lookup.path}catch(e){}var ret={isRoot:false,exists:false,error:0,name:null,path:null,object:null,parentExists:false,parentPath:null,parentObject:null};try{var lookup=FS.lookupPath(path,{parent:true});ret.parentExists=true;ret.parentPath=lookup.path;ret.parentObject=lookup.node;ret.name=PATH.basename(path);lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});ret.exists=true;ret.path=lookup.path;ret.object=lookup.node;ret.name=lookup.node.name;ret.isRoot=lookup.path==="/"}catch(e){ret.error=e.errno}return ret}),createFolder:(function(parent,name,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.mkdir(path,mode)}),createPath:(function(parent,path,canRead,canWrite){parent=typeof parent==="string"?parent:FS.getPath(parent);var parts=path.split("/").reverse();while(parts.length){var part=parts.pop();if(!part)continue;var current=PATH.join2(parent,part);try{FS.mkdir(current)}catch(e){}parent=current}return current}),createFile:(function(parent,name,properties,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.create(path,mode)}),createDataFile:(function(parent,name,data,canRead,canWrite,canOwn){var path=name?PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name):parent;var mode=FS.getMode(canRead,canWrite);var node=FS.create(path,mode);if(data){if(typeof data==="string"){var arr=new Array(data.length);for(var i=0,len=data.length;i<len;++i)arr[i]=data.charCodeAt(i);data=arr}FS.chmod(node,mode|146);var stream=FS.open(node,"w");FS.write(stream,data,0,data.length,0,canOwn);FS.close(stream);FS.chmod(node,mode)}return node}),createDevice:(function(parent,name,input,output){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(!!input,!!output);if(!FS.createDevice.major)FS.createDevice.major=64;var dev=FS.makedev(FS.createDevice.major++,0);FS.registerDevice(dev,{open:(function(stream){stream.seekable=false}),close:(function(stream){if(output&&output.buffer&&output.buffer.length){output(10)}}),read:(function(stream,buffer,offset,length,pos){var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=input()}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){for(var i=0;i<length;i++){try{output(buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})});return FS.mkdev(path,mode,dev)}),createLink:(function(parent,name,target,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);return FS.symlink(target,path)}),forceLoadFile:(function(obj){if(obj.isDevice||obj.isFolder||obj.link||obj.contents)return true;var success=true;if(typeof XMLHttpRequest!=="undefined"){throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.")}else if(Module["read"]){try{obj.contents=intArrayFromString(Module["read"](obj.url),true);obj.usedBytes=obj.contents.length}catch(e){success=false}}else{throw new Error("Cannot load without read() or XMLHttpRequest.")}if(!success)___setErrNo(ERRNO_CODES.EIO);return success}),createLazyFile:(function(parent,name,url,canRead,canWrite){function LazyUint8Array(){this.lengthKnown=false;this.chunks=[]}LazyUint8Array.prototype.get=function LazyUint8Array_get(idx){if(idx>this.length-1||idx<0){return undefined}var chunkOffset=idx%this.chunkSize;var chunkNum=idx/this.chunkSize|0;return this.getter(chunkNum)[chunkOffset]};LazyUint8Array.prototype.setDataGetter=function LazyUint8Array_setDataGetter(getter){this.getter=getter};LazyUint8Array.prototype.cacheLength=function LazyUint8Array_cacheLength(){var xhr=new XMLHttpRequest;xhr.open("HEAD",url,false);xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);var datalength=Number(xhr.getResponseHeader("Content-length"));var header;var hasByteServing=(header=xhr.getResponseHeader("Accept-Ranges"))&&header==="bytes";var usesGzip=(header=xhr.getResponseHeader("Content-Encoding"))&&header==="gzip";var chunkSize=1024*1024;if(!hasByteServing)chunkSize=datalength;var doXHR=(function(from,to){if(from>to)throw new Error("invalid range ("+from+", "+to+") or no bytes requested!");if(to>datalength-1)throw new Error("only "+datalength+" bytes available! programmer error!");var xhr=new XMLHttpRequest;xhr.open("GET",url,false);if(datalength!==chunkSize)xhr.setRequestHeader("Range","bytes="+from+"-"+to);if(typeof Uint8Array!="undefined")xhr.responseType="arraybuffer";if(xhr.overrideMimeType){xhr.overrideMimeType("text/plain; charset=x-user-defined")}xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);if(xhr.response!==undefined){return new Uint8Array(xhr.response||[])}else{return intArrayFromString(xhr.responseText||"",true)}});var lazyArray=this;lazyArray.setDataGetter((function(chunkNum){var start=chunkNum*chunkSize;var end=(chunkNum+1)*chunkSize-1;end=Math.min(end,datalength-1);if(typeof lazyArray.chunks[chunkNum]==="undefined"){lazyArray.chunks[chunkNum]=doXHR(start,end)}if(typeof lazyArray.chunks[chunkNum]==="undefined")throw new Error("doXHR failed!");return lazyArray.chunks[chunkNum]}));if(usesGzip||!datalength){chunkSize=datalength=1;datalength=this.getter(0).length;chunkSize=datalength;console.log("LazyFiles on gzip forces download of the whole file when length is accessed")}this._length=datalength;this._chunkSize=chunkSize;this.lengthKnown=true};if(typeof XMLHttpRequest!=="undefined"){if(!ENVIRONMENT_IS_WORKER)throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";var lazyArray=new LazyUint8Array;Object.defineProperties(lazyArray,{length:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._length})},chunkSize:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._chunkSize})}});var properties={isDevice:false,contents:lazyArray}}else{var properties={isDevice:false,url:url}}var node=FS.createFile(parent,name,properties,canRead,canWrite);if(properties.contents){node.contents=properties.contents}else if(properties.url){node.contents=null;node.url=properties.url}Object.defineProperties(node,{usedBytes:{get:(function(){return this.contents.length})}});var stream_ops={};var keys=Object.keys(node.stream_ops);keys.forEach((function(key){var fn=node.stream_ops[key];stream_ops[key]=function forceLoadLazyFile(){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}return fn.apply(null,arguments)}}));stream_ops.read=function stream_ops_read(stream,buffer,offset,length,position){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}var contents=stream.node.contents;if(position>=contents.length)return 0;var size=Math.min(contents.length-position,length);assert(size>=0);if(contents.slice){for(var i=0;i<size;i++){buffer[offset+i]=contents[position+i]}}else{for(var i=0;i<size;i++){buffer[offset+i]=contents.get(position+i)}}return size};node.stream_ops=stream_ops;return node}),createPreloadedFile:(function(parent,name,url,canRead,canWrite,onload,onerror,dontCreateFile,canOwn,preFinish){Browser.init();var fullname=name?PATH.resolve(PATH.join2(parent,name)):parent;var dep=getUniqueRunDependency("cp "+fullname);function processData(byteArray){function finish(byteArray){if(preFinish)preFinish();if(!dontCreateFile){FS.createDataFile(parent,name,byteArray,canRead,canWrite,canOwn)}if(onload)onload();removeRunDependency(dep)}var handled=false;Module["preloadPlugins"].forEach((function(plugin){if(handled)return;if(plugin["canHandle"](fullname)){plugin["handle"](byteArray,fullname,finish,(function(){if(onerror)onerror();removeRunDependency(dep)}));handled=true}}));if(!handled)finish(byteArray)}addRunDependency(dep);if(typeof url=="string"){Browser.asyncLoad(url,(function(byteArray){processData(byteArray)}),onerror)}else{processData(url)}}),indexedDB:(function(){return window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB}),DB_NAME:(function(){return"EM_FS_"+window.location.pathname}),DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=function openRequest_onupgradeneeded(){console.log("creating db");var db=openRequest.result;db.createObjectStore(FS.DB_STORE_NAME)};openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;var transaction=db.transaction([FS.DB_STORE_NAME],"readwrite");var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var putRequest=files.put(FS.analyzePath(path).object.contents,path);putRequest.onsuccess=function putRequest_onsuccess(){ok++;if(ok+fail==total)finish()};putRequest.onerror=function putRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror}),loadFilesFromDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=onerror;openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;try{var transaction=db.transaction([FS.DB_STORE_NAME],"readonly")}catch(e){onerror(e);return}var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var getRequest=files.get(path);getRequest.onsuccess=function getRequest_onsuccess(){if(FS.analyzePath(path).exists){FS.unlink(path)}FS.createDataFile(PATH.dirname(path),PATH.basename(path),getRequest.result,true,true,true);ok++;if(ok+fail==total)finish()};getRequest.onerror=function getRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror})};var SYSCALLS={DEFAULT_POLLMASK:5,mappings:{},umask:511,calculateAt:(function(dirfd,path){if(path[0]!=="/"){var dir;if(dirfd===-100){dir=FS.cwd()}else{var dirstream=FS.getStream(dirfd);if(!dirstream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);dir=dirstream.path}path=PATH.join2(dir,path)}return path}),doStat:(function(func,path,buf){try{var stat=func(path)}catch(e){if(e&&e.node&&PATH.normalize(path)!==PATH.normalize(FS.getPath(e.node))){return-ERRNO_CODES.ENOTDIR}throw e}HEAP32[buf>>2]=stat.dev;HEAP32[buf+4>>2]=0;HEAP32[buf+8>>2]=stat.ino;HEAP32[buf+12>>2]=stat.mode;HEAP32[buf+16>>2]=stat.nlink;HEAP32[buf+20>>2]=stat.uid;HEAP32[buf+24>>2]=stat.gid;HEAP32[buf+28>>2]=stat.rdev;HEAP32[buf+32>>2]=0;HEAP32[buf+36>>2]=stat.size;HEAP32[buf+40>>2]=4096;HEAP32[buf+44>>2]=stat.blocks;HEAP32[buf+48>>2]=stat.atime.getTime()/1e3|0;HEAP32[buf+52>>2]=0;HEAP32[buf+56>>2]=stat.mtime.getTime()/1e3|0;HEAP32[buf+60>>2]=0;HEAP32[buf+64>>2]=stat.ctime.getTime()/1e3|0;HEAP32[buf+68>>2]=0;HEAP32[buf+72>>2]=stat.ino;return 0}),doMsync:(function(addr,stream,len,flags){var buffer=new Uint8Array(HEAPU8.subarray(addr,addr+len));FS.msync(stream,buffer,0,len,flags)}),doMkdir:(function(path,mode){path=PATH.normalize(path);if(path[path.length-1]==="/")path=path.substr(0,path.length-1);FS.mkdir(path,mode,0);return 0}),doMknod:(function(path,mode,dev){switch(mode&61440){case 32768:case 8192:case 24576:case 4096:case 49152:break;default:return-ERRNO_CODES.EINVAL}FS.mknod(path,mode,dev);return 0}),doReadlink:(function(path,buf,bufsize){if(bufsize<=0)return-ERRNO_CODES.EINVAL;var ret=FS.readlink(path);var len=Math.min(bufsize,lengthBytesUTF8(ret));var endChar=HEAP8[buf+len];stringToUTF8(ret,buf,bufsize+1);HEAP8[buf+len]=endChar;return len}),doAccess:(function(path,amode){if(amode&~7){return-ERRNO_CODES.EINVAL}var node;var lookup=FS.lookupPath(path,{follow:true});node=lookup.node;var perms="";if(amode&4)perms+="r";if(amode&2)perms+="w";if(amode&1)perms+="x";if(perms&&FS.nodePermissions(node,perms)){return-ERRNO_CODES.EACCES}return 0}),doDup:(function(path,flags,suggestFD){var suggest=FS.getStream(suggestFD);if(suggest)FS.close(suggest);return FS.open(path,flags,0,suggestFD,suggestFD).fd}),doReadv:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.read(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr;if(curr<len)break}return ret}),doWritev:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.write(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr}return ret}),varargs:0,get:(function(varargs){SYSCALLS.varargs+=4;var ret=HEAP32[SYSCALLS.varargs-4>>2];return ret}),getStr:(function(){var ret=Pointer_stringify(SYSCALLS.get());return ret}),getStreamFromFD:(function(){var stream=FS.getStream(SYSCALLS.get());if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return stream}),getSocketFromFD:(function(){var socket=SOCKFS.getSocket(SYSCALLS.get());if(!socket)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return socket}),getSocketAddress:(function(allowNull){var addrp=SYSCALLS.get(),addrlen=SYSCALLS.get();if(allowNull&&addrp===0)return null;var info=__read_sockaddr(addrp,addrlen);if(info.errno)throw new FS.ErrnoError(info.errno);info.addr=DNS.lookup_addr(info.addr)||info.addr;return info}),get64:(function(){var low=SYSCALLS.get(),high=SYSCALLS.get();if(low>=0)assert(high===0);else assert(high===-1);return low}),getZero:(function(){assert(SYSCALLS.get()===0)})};function ___syscall91(which,varargs){SYSCALLS.varargs=varargs;try{var addr=SYSCALLS.get(),len=SYSCALLS.get();var info=SYSCALLS.mappings[addr];if(!info)return 0;if(len===info.len){var stream=FS.getStream(info.fd);SYSCALLS.doMsync(addr,stream,len,info.flags);FS.munmap(stream);SYSCALLS.mappings[addr]=null;if(info.allocated){_free(info.malloc)}}return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _pthread_mutexattr_destroy(){}function _emscripten_set_main_loop_timing(mode,value){Browser.mainLoop.timingMode=mode;Browser.mainLoop.timingValue=value;if(!Browser.mainLoop.func){return 1}if(mode==0){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_setTimeout(){var timeUntilNextTick=Math.max(0,Browser.mainLoop.tickStartTime+value-_emscripten_get_now())|0;setTimeout(Browser.mainLoop.runner,timeUntilNextTick)};Browser.mainLoop.method="timeout"}else if(mode==1){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_rAF(){Browser.requestAnimationFrame(Browser.mainLoop.runner)};Browser.mainLoop.method="rAF"}else if(mode==2){if(!window["setImmediate"]){var setImmediates=[];var emscriptenMainLoopMessageId="setimmediate";function Browser_setImmediate_messageHandler(event){if(event.source===window&&event.data===emscriptenMainLoopMessageId){event.stopPropagation();setImmediates.shift()()}}window.addEventListener("message",Browser_setImmediate_messageHandler,true);window["setImmediate"]=function Browser_emulated_setImmediate(func){setImmediates.push(func);if(ENVIRONMENT_IS_WORKER){if(Module["setImmediates"]===undefined)Module["setImmediates"]=[];Module["setImmediates"].push(func);window.postMessage({target:emscriptenMainLoopMessageId})}else window.postMessage(emscriptenMainLoopMessageId,"*")}}Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_setImmediate(){window["setImmediate"](Browser.mainLoop.runner)};Browser.mainLoop.method="immediate"}return 0}function _emscripten_get_now(){abort()}function _emscripten_set_main_loop(func,fps,simulateInfiniteLoop,arg,noSetTiming){Module["noExitRuntime"]=true;assert(!Browser.mainLoop.func,"emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters.");Browser.mainLoop.func=func;Browser.mainLoop.arg=arg;var browserIterationFunc;if(typeof arg!=="undefined"){browserIterationFunc=(function(){Module["dynCall_vi"](func,arg)})}else{browserIterationFunc=(function(){Module["dynCall_v"](func)})}var thisMainLoopId=Browser.mainLoop.currentlyRunningMainloop;Browser.mainLoop.runner=function Browser_mainLoop_runner(){if(ABORT)return;if(Browser.mainLoop.queue.length>0){var start=Date.now();var blocker=Browser.mainLoop.queue.shift();blocker.func(blocker.arg);if(Browser.mainLoop.remainingBlockers){var remaining=Browser.mainLoop.remainingBlockers;var next=remaining%1==0?remaining-1:Math.floor(remaining);if(blocker.counted){Browser.mainLoop.remainingBlockers=next}else{next=next+.5;Browser.mainLoop.remainingBlockers=(8*remaining+next)/9}}console.log('main loop blocker "'+blocker.name+'" took '+(Date.now()-start)+" ms");Browser.mainLoop.updateStatus();if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;setTimeout(Browser.mainLoop.runner,0);return}if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;Browser.mainLoop.currentFrameNumber=Browser.mainLoop.currentFrameNumber+1|0;if(Browser.mainLoop.timingMode==1&&Browser.mainLoop.timingValue>1&&Browser.mainLoop.currentFrameNumber%Browser.mainLoop.timingValue!=0){Browser.mainLoop.scheduler();return}else if(Browser.mainLoop.timingMode==0){Browser.mainLoop.tickStartTime=_emscripten_get_now()}if(Browser.mainLoop.method==="timeout"&&Module.ctx){Module.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!");Browser.mainLoop.method=""}Browser.mainLoop.runIter(browserIterationFunc);if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;if(typeof SDL==="object"&&SDL.audio&&SDL.audio.queueNewAudioData)SDL.audio.queueNewAudioData();Browser.mainLoop.scheduler()};if(!noSetTiming){if(fps&&fps>0)_emscripten_set_main_loop_timing(0,1e3/fps);else _emscripten_set_main_loop_timing(1,1);Browser.mainLoop.scheduler()}if(simulateInfiniteLoop){throw"SimulateInfiniteLoop"}}var Browser={mainLoop:{scheduler:null,method:"",currentlyRunningMainloop:0,func:null,arg:0,timingMode:0,timingValue:0,currentFrameNumber:0,queue:[],pause:(function(){Browser.mainLoop.scheduler=null;Browser.mainLoop.currentlyRunningMainloop++}),resume:(function(){Browser.mainLoop.currentlyRunningMainloop++;var timingMode=Browser.mainLoop.timingMode;var timingValue=Browser.mainLoop.timingValue;var func=Browser.mainLoop.func;Browser.mainLoop.func=null;_emscripten_set_main_loop(func,0,false,Browser.mainLoop.arg,true);_emscripten_set_main_loop_timing(timingMode,timingValue);Browser.mainLoop.scheduler()}),updateStatus:(function(){if(Module["setStatus"]){var message=Module["statusMessage"]||"Please wait...";var remaining=Browser.mainLoop.remainingBlockers;var expected=Browser.mainLoop.expectedBlockers;if(remaining){if(remaining<expected){Module["setStatus"](message+" ("+(expected-remaining)+"/"+expected+")")}else{Module["setStatus"](message)}}else{Module["setStatus"]("")}}}),runIter:(function(func){if(ABORT)return;if(Module["preMainLoop"]){var preRet=Module["preMainLoop"]();if(preRet===false){return}}try{func()}catch(e){if(e instanceof ExitStatus){return}else{if(e&&typeof e==="object"&&e.stack)Module.printErr("exception thrown: "+[e,e.stack]);throw e}}if(Module["postMainLoop"])Module["postMainLoop"]()})},isFullscreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:(function(){if(!Module["preloadPlugins"])Module["preloadPlugins"]=[];if(Browser.initted)return;Browser.initted=true;try{new Blob;Browser.hasBlobConstructor=true}catch(e){Browser.hasBlobConstructor=false;console.log("warning: no blob constructor, cannot create blobs with mimetypes")}Browser.BlobBuilder=typeof MozBlobBuilder!="undefined"?MozBlobBuilder:typeof WebKitBlobBuilder!="undefined"?WebKitBlobBuilder:!Browser.hasBlobConstructor?console.log("warning: no BlobBuilder"):null;Browser.URLObject=typeof window!="undefined"?window.URL?window.URL:window.webkitURL:undefined;if(!Module.noImageDecoding&&typeof Browser.URLObject==="undefined"){console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");Module.noImageDecoding=true}var imagePlugin={};imagePlugin["canHandle"]=function imagePlugin_canHandle(name){return!Module.noImageDecoding&&/\.(jpg|jpeg|png|bmp)$/i.test(name)};imagePlugin["handle"]=function imagePlugin_handle(byteArray,name,onload,onerror){var b=null;if(Browser.hasBlobConstructor){try{b=new Blob([byteArray],{type:Browser.getMimetype(name)});if(b.size!==byteArray.length){b=new Blob([(new Uint8Array(byteArray)).buffer],{type:Browser.getMimetype(name)})}}catch(e){Runtime.warnOnce("Blob constructor present but fails: "+e+"; falling back to blob builder")}}if(!b){var bb=new Browser.BlobBuilder;bb.append((new Uint8Array(byteArray)).buffer);b=bb.getBlob()}var url=Browser.URLObject.createObjectURL(b);var img=new Image;img.onload=function img_onload(){assert(img.complete,"Image "+name+" could not be decoded");var canvas=document.createElement("canvas");canvas.width=img.width;canvas.height=img.height;var ctx=canvas.getContext("2d");ctx.drawImage(img,0,0);Module["preloadedImages"][name]=canvas;Browser.URLObject.revokeObjectURL(url);if(onload)onload(byteArray)};img.onerror=function img_onerror(event){console.log("Image "+url+" could not be decoded");if(onerror)onerror()};img.src=url};Module["preloadPlugins"].push(imagePlugin);var audioPlugin={};audioPlugin["canHandle"]=function audioPlugin_canHandle(name){return!Module.noAudioDecoding&&name.substr(-4)in{".ogg":1,".wav":1,".mp3":1}};audioPlugin["handle"]=function audioPlugin_handle(byteArray,name,onload,onerror){var done=false;function finish(audio){if(done)return;done=true;Module["preloadedAudios"][name]=audio;if(onload)onload(byteArray)}function fail(){if(done)return;done=true;Module["preloadedAudios"][name]=new Audio;if(onerror)onerror()}if(Browser.hasBlobConstructor){try{var b=new Blob([byteArray],{type:Browser.getMimetype(name)})}catch(e){return fail()}var url=Browser.URLObject.createObjectURL(b);var audio=new Audio;audio.addEventListener("canplaythrough",(function(){finish(audio)}),false);audio.onerror=function audio_onerror(event){if(done)return;console.log("warning: browser could not fully decode audio "+name+", trying slower base64 approach");function encode64(data){var BASE="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";var PAD="=";var ret="";var leftchar=0;var leftbits=0;for(var i=0;i<data.length;i++){leftchar=leftchar<<8|data[i];leftbits+=8;while(leftbits>=6){var curr=leftchar>>leftbits-6&63;leftbits-=6;ret+=BASE[curr]}}if(leftbits==2){ret+=BASE[(leftchar&3)<<4];ret+=PAD+PAD}else if(leftbits==4){ret+=BASE[(leftchar&15)<<2];ret+=PAD}return ret}audio.src="data:audio/x-"+name.substr(-3)+";base64,"+encode64(byteArray);finish(audio)};audio.src=url;Browser.safeSetTimeout((function(){finish(audio)}),1e4)}else{return fail()}};Module["preloadPlugins"].push(audioPlugin);function pointerLockChange(){Browser.pointerLock=document["pointerLockElement"]===Module["canvas"]||document["mozPointerLockElement"]===Module["canvas"]||document["webkitPointerLockElement"]===Module["canvas"]||document["msPointerLockElement"]===Module["canvas"]}var canvas=Module["canvas"];if(canvas){canvas.requestPointerLock=canvas["requestPointerLock"]||canvas["mozRequestPointerLock"]||canvas["webkitRequestPointerLock"]||canvas["msRequestPointerLock"]||(function(){});canvas.exitPointerLock=document["exitPointerLock"]||document["mozExitPointerLock"]||document["webkitExitPointerLock"]||document["msExitPointerLock"]||(function(){});canvas.exitPointerLock=canvas.exitPointerLock.bind(document);document.addEventListener("pointerlockchange",pointerLockChange,false);document.addEventListener("mozpointerlockchange",pointerLockChange,false);document.addEventListener("webkitpointerlockchange",pointerLockChange,false);document.addEventListener("mspointerlockchange",pointerLockChange,false);if(Module["elementPointerLock"]){canvas.addEventListener("click",(function(ev){if(!Browser.pointerLock&&Module["canvas"].requestPointerLock){Module["canvas"].requestPointerLock();ev.preventDefault()}}),false)}}}),createContext:(function(canvas,useWebGL,setInModule,webGLContextAttributes){if(useWebGL&&Module.ctx&&canvas==Module.canvas)return Module.ctx;var ctx;var contextHandle;if(useWebGL){var contextAttributes={antialias:false,alpha:false};if(webGLContextAttributes){for(var attribute in webGLContextAttributes){contextAttributes[attribute]=webGLContextAttributes[attribute]}}contextHandle=GL.createContext(canvas,contextAttributes);if(contextHandle){ctx=GL.getContext(contextHandle).GLctx}}else{ctx=canvas.getContext("2d")}if(!ctx)return null;if(setInModule){if(!useWebGL)assert(typeof GLctx==="undefined","cannot set in module if GLctx is used, but we are a non-GL context that would replace it");Module.ctx=ctx;if(useWebGL)GL.makeContextCurrent(contextHandle);Module.useWebGL=useWebGL;Browser.moduleContextCreatedCallbacks.forEach((function(callback){callback()}));Browser.init()}return ctx}),destroyContext:(function(canvas,useWebGL,setInModule){}),fullscreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullscreen:(function(lockPointer,resizeCanvas,vrDevice){Browser.lockPointer=lockPointer;Browser.resizeCanvas=resizeCanvas;Browser.vrDevice=vrDevice;if(typeof Browser.lockPointer==="undefined")Browser.lockPointer=true;if(typeof Browser.resizeCanvas==="undefined")Browser.resizeCanvas=false;if(typeof Browser.vrDevice==="undefined")Browser.vrDevice=null;var canvas=Module["canvas"];function fullscreenChange(){Browser.isFullscreen=false;var canvasContainer=canvas.parentNode;if((document["fullscreenElement"]||document["mozFullScreenElement"]||document["msFullscreenElement"]||document["webkitFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvasContainer){canvas.exitFullscreen=document["exitFullscreen"]||document["cancelFullScreen"]||document["mozCancelFullScreen"]||document["msExitFullscreen"]||document["webkitCancelFullScreen"]||(function(){});canvas.exitFullscreen=canvas.exitFullscreen.bind(document);if(Browser.lockPointer)canvas.requestPointerLock();Browser.isFullscreen=true;if(Browser.resizeCanvas)Browser.setFullscreenCanvasSize()}else{canvasContainer.parentNode.insertBefore(canvas,canvasContainer);canvasContainer.parentNode.removeChild(canvasContainer);if(Browser.resizeCanvas)Browser.setWindowedCanvasSize()}if(Module["onFullScreen"])Module["onFullScreen"](Browser.isFullscreen);if(Module["onFullscreen"])Module["onFullscreen"](Browser.isFullscreen);Browser.updateCanvasDimensions(canvas)}if(!Browser.fullscreenHandlersInstalled){Browser.fullscreenHandlersInstalled=true;document.addEventListener("fullscreenchange",fullscreenChange,false);document.addEventListener("mozfullscreenchange",fullscreenChange,false);document.addEventListener("webkitfullscreenchange",fullscreenChange,false);document.addEventListener("MSFullscreenChange",fullscreenChange,false)}var canvasContainer=document.createElement("div");canvas.parentNode.insertBefore(canvasContainer,canvas);canvasContainer.appendChild(canvas);canvasContainer.requestFullscreen=canvasContainer["requestFullscreen"]||canvasContainer["mozRequestFullScreen"]||canvasContainer["msRequestFullscreen"]||(canvasContainer["webkitRequestFullscreen"]?(function(){canvasContainer["webkitRequestFullscreen"](Element["ALLOW_KEYBOARD_INPUT"])}):null)||(canvasContainer["webkitRequestFullScreen"]?(function(){canvasContainer["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"])}):null);if(vrDevice){canvasContainer.requestFullscreen({vrDisplay:vrDevice})}else{canvasContainer.requestFullscreen()}}),requestFullScreen:(function(lockPointer,resizeCanvas,vrDevice){Module.printErr("Browser.requestFullScreen() is deprecated. Please call Browser.requestFullscreen instead.");Browser.requestFullScreen=(function(lockPointer,resizeCanvas,vrDevice){return Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)});return Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)}),nextRAF:0,fakeRequestAnimationFrame:(function(func){var now=Date.now();if(Browser.nextRAF===0){Browser.nextRAF=now+1e3/60}else{while(now+2>=Browser.nextRAF){Browser.nextRAF+=1e3/60}}var delay=Math.max(Browser.nextRAF-now,0);setTimeout(func,delay)}),requestAnimationFrame:function requestAnimationFrame(func){if(typeof window==="undefined"){Browser.fakeRequestAnimationFrame(func)}else{if(!window.requestAnimationFrame){window.requestAnimationFrame=window["requestAnimationFrame"]||window["mozRequestAnimationFrame"]||window["webkitRequestAnimationFrame"]||window["msRequestAnimationFrame"]||window["oRequestAnimationFrame"]||Browser.fakeRequestAnimationFrame}window.requestAnimationFrame(func)}},safeCallback:(function(func){return(function(){if(!ABORT)return func.apply(null,arguments)})}),allowAsyncCallbacks:true,queuedAsyncCallbacks:[],pauseAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=false}),resumeAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=true;if(Browser.queuedAsyncCallbacks.length>0){var callbacks=Browser.queuedAsyncCallbacks;Browser.queuedAsyncCallbacks=[];callbacks.forEach((function(func){func()}))}}),safeRequestAnimationFrame:(function(func){return Browser.requestAnimationFrame((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}))}),safeSetTimeout:(function(func,timeout){Module["noExitRuntime"]=true;return setTimeout((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}),timeout)}),safeSetInterval:(function(func,timeout){Module["noExitRuntime"]=true;return setInterval((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}}),timeout)}),getMimetype:(function(name){return{"jpg":"image/jpeg","jpeg":"image/jpeg","png":"image/png","bmp":"image/bmp","ogg":"audio/ogg","wav":"audio/wav","mp3":"audio/mpeg"}[name.substr(name.lastIndexOf(".")+1)]}),getUserMedia:(function(func){if(!window.getUserMedia){window.getUserMedia=navigator["getUserMedia"]||navigator["mozGetUserMedia"]}window.getUserMedia(func)}),getMovementX:(function(event){return event["movementX"]||event["mozMovementX"]||event["webkitMovementX"]||0}),getMovementY:(function(event){return event["movementY"]||event["mozMovementY"]||event["webkitMovementY"]||0}),getMouseWheelDelta:(function(event){var delta=0;switch(event.type){case"DOMMouseScroll":delta=event.detail;break;case"mousewheel":delta=event.wheelDelta;break;case"wheel":delta=event["deltaY"];break;default:throw"unrecognized mouse wheel event: "+event.type}return delta}),mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,touches:{},lastTouches:{},calculateMouseEvent:(function(event){if(Browser.pointerLock){if(event.type!="mousemove"&&"mozMovementX"in event){Browser.mouseMovementX=Browser.mouseMovementY=0}else{Browser.mouseMovementX=Browser.getMovementX(event);Browser.mouseMovementY=Browser.getMovementY(event)}if(typeof SDL!="undefined"){Browser.mouseX=SDL.mouseX+Browser.mouseMovementX;Browser.mouseY=SDL.mouseY+Browser.mouseMovementY}else{Browser.mouseX+=Browser.mouseMovementX;Browser.mouseY+=Browser.mouseMovementY}}else{var rect=Module["canvas"].getBoundingClientRect();var cw=Module["canvas"].width;var ch=Module["canvas"].height;var scrollX=typeof window.scrollX!=="undefined"?window.scrollX:window.pageXOffset;var scrollY=typeof window.scrollY!=="undefined"?window.scrollY:window.pageYOffset;if(event.type==="touchstart"||event.type==="touchend"||event.type==="touchmove"){var touch=event.touch;if(touch===undefined){return}var adjustedX=touch.pageX-(scrollX+rect.left);var adjustedY=touch.pageY-(scrollY+rect.top);adjustedX=adjustedX*(cw/rect.width);adjustedY=adjustedY*(ch/rect.height);var coords={x:adjustedX,y:adjustedY};if(event.type==="touchstart"){Browser.lastTouches[touch.identifier]=coords;Browser.touches[touch.identifier]=coords}else if(event.type==="touchend"||event.type==="touchmove"){var last=Browser.touches[touch.identifier];if(!last)last=coords;Browser.lastTouches[touch.identifier]=last;Browser.touches[touch.identifier]=coords}return}var x=event.pageX-(scrollX+rect.left);var y=event.pageY-(scrollY+rect.top);x=x*(cw/rect.width);y=y*(ch/rect.height);Browser.mouseMovementX=x-Browser.mouseX;Browser.mouseMovementY=y-Browser.mouseY;Browser.mouseX=x;Browser.mouseY=y}}),asyncLoad:(function(url,onload,onerror,noRunDep){var dep=!noRunDep?getUniqueRunDependency("al "+url):"";Module["readAsync"](url,(function(arrayBuffer){assert(arrayBuffer,'Loading data file "'+url+'" failed (no arrayBuffer).');onload(new Uint8Array(arrayBuffer));if(dep)removeRunDependency(dep)}),(function(event){if(onerror){onerror()}else{throw'Loading data file "'+url+'" failed.'}}));if(dep)addRunDependency(dep)}),resizeListeners:[],updateResizeListeners:(function(){var canvas=Module["canvas"];Browser.resizeListeners.forEach((function(listener){listener(canvas.width,canvas.height)}))}),setCanvasSize:(function(width,height,noUpdates){var canvas=Module["canvas"];Browser.updateCanvasDimensions(canvas,width,height);if(!noUpdates)Browser.updateResizeListeners()}),windowedWidth:0,windowedHeight:0,setFullscreenCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags|8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),setWindowedCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags&~8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),updateCanvasDimensions:(function(canvas,wNative,hNative){if(wNative&&hNative){canvas.widthNative=wNative;canvas.heightNative=hNative}else{wNative=canvas.widthNative;hNative=canvas.heightNative}var w=wNative;var h=hNative;if(Module["forcedAspectRatio"]&&Module["forcedAspectRatio"]>0){if(w/h<Module["forcedAspectRatio"]){w=Math.round(h*Module["forcedAspectRatio"])}else{h=Math.round(w/Module["forcedAspectRatio"])}}if((document["fullscreenElement"]||document["mozFullScreenElement"]||document["msFullscreenElement"]||document["webkitFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvas.parentNode&&typeof screen!="undefined"){var factor=Math.min(screen.width/w,screen.height/h);w=Math.round(w*factor);h=Math.round(h*factor)}if(Browser.resizeCanvas){if(canvas.width!=w)canvas.width=w;if(canvas.height!=h)canvas.height=h;if(typeof canvas.style!="undefined"){canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}else{if(canvas.width!=wNative)canvas.width=wNative;if(canvas.height!=hNative)canvas.height=hNative;if(typeof canvas.style!="undefined"){if(w!=wNative||h!=hNative){canvas.style.setProperty("width",w+"px","important");canvas.style.setProperty("height",h+"px","important")}else{canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}}}),wgetRequests:{},nextWgetRequestHandle:0,getNextWgetRequestHandle:(function(){var handle=Browser.nextWgetRequestHandle;Browser.nextWgetRequestHandle++;return handle})};function ___syscall54(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),op=SYSCALLS.get();switch(op){case 21505:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21506:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21519:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;var argp=SYSCALLS.get();HEAP32[argp>>2]=0;return 0};case 21520:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return-ERRNO_CODES.EINVAL};case 21531:{var argp=SYSCALLS.get();return FS.ioctl(stream,op,argp)};case 21523:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};default:abort("bad ioctl syscall "+op)}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var tupleRegistrations={};function requireFunction(signature,rawFunction){signature=readLatin1String(signature);function makeDynCaller(dynCall){var args=[];for(var i=1;i<signature.length;++i){args.push("a"+i)}var name="dynCall_"+signature+"_"+rawFunction;var body="return function "+name+"("+args.join(", ")+") {\n";body+="    return dynCall(rawFunction"+(args.length?", ":"")+args.join(", ")+");\n";body+="};\n";return(new Function("dynCall","rawFunction",body))(dynCall,rawFunction)}var fp;if(Module["FUNCTION_TABLE_"+signature]!==undefined){fp=Module["FUNCTION_TABLE_"+signature][rawFunction]}else if(typeof FUNCTION_TABLE!=="undefined"){fp=FUNCTION_TABLE[rawFunction]}else{var dc=Module["asm"]["dynCall_"+signature];if(dc===undefined){dc=Module["asm"]["dynCall_"+signature.replace(/f/g,"d")];if(dc===undefined){throwBindingError("No dynCall invoker for signature: "+signature)}}fp=makeDynCaller(dc)}if(typeof fp!=="function"){throwBindingError("unknown function pointer with signature "+signature+": "+rawFunction)}return fp}function __embind_register_value_array(rawType,name,constructorSignature,rawConstructor,destructorSignature,rawDestructor){tupleRegistrations[rawType]={name:readLatin1String(name),rawConstructor:requireFunction(constructorSignature,rawConstructor),rawDestructor:requireFunction(destructorSignature,rawDestructor),elements:[]}}function upcastPointer(ptr,ptrClass,desiredClass){while(ptrClass!==desiredClass){if(!ptrClass.upcast){throwBindingError("Expected null or instance of "+desiredClass.name+", got an instance of "+ptrClass.name)}ptr=ptrClass.upcast(ptr);ptrClass=ptrClass.baseClass}return ptr}function constNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}return 0}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}function genericPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}if(this.isSmartPointer){var ptr=this.rawConstructor();if(destructors!==null){destructors.push(this.rawDestructor,ptr)}return ptr}else{return 0}}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}if(!this.isConst&&handle.$$.ptrType.isConst){throwBindingError("Cannot convert argument of type "+(handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name)+" to parameter type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);if(this.isSmartPointer){if(undefined===handle.$$.smartPtr){throwBindingError("Passing raw pointer to smart pointer is illegal")}switch(this.sharingPolicy){case 0:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{throwBindingError("Cannot convert argument of type "+(handle.$$.smartPtrType?handle.$$.smartPtrType.name:handle.$$.ptrType.name)+" to parameter type "+this.name)}break;case 1:ptr=handle.$$.smartPtr;break;case 2:if(handle.$$.smartPtrType===this){ptr=handle.$$.smartPtr}else{var clonedHandle=handle["clone"]();ptr=this.rawShare(ptr,__emval_register((function(){clonedHandle["delete"]()})));if(destructors!==null){destructors.push(this.rawDestructor,ptr)}}break;default:throwBindingError("Unsupporting sharing policy")}}return ptr}function nonConstNoSmartPtrRawPointerToWireType(destructors,handle){if(handle===null){if(this.isReference){throwBindingError("null is not a valid "+this.name)}return 0}if(!handle.$$){throwBindingError('Cannot pass "'+_embind_repr(handle)+'" as a '+this.name)}if(!handle.$$.ptr){throwBindingError("Cannot pass deleted object as a pointer of type "+this.name)}if(handle.$$.ptrType.isConst){throwBindingError("Cannot convert argument of type "+handle.$$.ptrType.name+" to parameter type "+this.name)}var handleClass=handle.$$.ptrType.registeredClass;var ptr=upcastPointer(handle.$$.ptr,handleClass,this.registeredClass);return ptr}function RegisteredPointer_getPointee(ptr){if(this.rawGetPointee){ptr=this.rawGetPointee(ptr)}return ptr}function RegisteredPointer_destructor(ptr){if(this.rawDestructor){this.rawDestructor(ptr)}}function RegisteredPointer_deleteObject(handle){if(handle!==null){handle["delete"]()}}function downcastPointer(ptr,ptrClass,desiredClass){if(ptrClass===desiredClass){return ptr}if(undefined===desiredClass.baseClass){return null}var rv=downcastPointer(ptr,ptrClass,desiredClass.baseClass);if(rv===null){return null}return desiredClass.downcast(rv)}var registeredPointers={};function getInheritedInstanceCount(){return Object.keys(registeredInstances).length}function getLiveInheritedInstances(){var rv=[];for(var k in registeredInstances){if(registeredInstances.hasOwnProperty(k)){rv.push(registeredInstances[k])}}return rv}var deletionQueue=[];function flushPendingDeletes(){while(deletionQueue.length){var obj=deletionQueue.pop();obj.$$.deleteScheduled=false;obj["delete"]()}}var delayFunction=undefined;function setDelayFunction(fn){delayFunction=fn;if(deletionQueue.length&&delayFunction){delayFunction(flushPendingDeletes)}}function init_embind(){Module["getInheritedInstanceCount"]=getInheritedInstanceCount;Module["getLiveInheritedInstances"]=getLiveInheritedInstances;Module["flushPendingDeletes"]=flushPendingDeletes;Module["setDelayFunction"]=setDelayFunction}var registeredInstances={};function getBasestPointer(class_,ptr){if(ptr===undefined){throwBindingError("ptr should not be undefined")}while(class_.baseClass){ptr=class_.upcast(ptr);class_=class_.baseClass}return ptr}function getInheritedInstance(class_,ptr){ptr=getBasestPointer(class_,ptr);return registeredInstances[ptr]}function makeClassHandle(prototype,record){if(!record.ptrType||!record.ptr){throwInternalError("makeClassHandle requires ptr and ptrType")}var hasSmartPtrType=!!record.smartPtrType;var hasSmartPtr=!!record.smartPtr;if(hasSmartPtrType!==hasSmartPtr){throwInternalError("Both smartPtrType and smartPtr must be specified")}record.count={value:1};return Object.create(prototype,{$$:{value:record}})}function RegisteredPointer_fromWireType(ptr){var rawPointer=this.getPointee(ptr);if(!rawPointer){this.destructor(ptr);return null}var registeredInstance=getInheritedInstance(this.registeredClass,rawPointer);if(undefined!==registeredInstance){if(0===registeredInstance.$$.count.value){registeredInstance.$$.ptr=rawPointer;registeredInstance.$$.smartPtr=ptr;return registeredInstance["clone"]()}else{var rv=registeredInstance["clone"]();this.destructor(ptr);return rv}}function makeDefaultHandle(){if(this.isSmartPointer){return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this.pointeeType,ptr:rawPointer,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(this.registeredClass.instancePrototype,{ptrType:this,ptr:ptr})}}var actualType=this.registeredClass.getActualType(rawPointer);var registeredPointerRecord=registeredPointers[actualType];if(!registeredPointerRecord){return makeDefaultHandle.call(this)}var toType;if(this.isConst){toType=registeredPointerRecord.constPointerType}else{toType=registeredPointerRecord.pointerType}var dp=downcastPointer(rawPointer,this.registeredClass,toType.registeredClass);if(dp===null){return makeDefaultHandle.call(this)}if(this.isSmartPointer){return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp,smartPtrType:this,smartPtr:ptr})}else{return makeClassHandle(toType.registeredClass.instancePrototype,{ptrType:toType,ptr:dp})}}function init_RegisteredPointer(){RegisteredPointer.prototype.getPointee=RegisteredPointer_getPointee;RegisteredPointer.prototype.destructor=RegisteredPointer_destructor;RegisteredPointer.prototype["argPackAdvance"]=8;RegisteredPointer.prototype["readValueFromPointer"]=simpleReadValueFromPointer;RegisteredPointer.prototype["deleteObject"]=RegisteredPointer_deleteObject;RegisteredPointer.prototype["fromWireType"]=RegisteredPointer_fromWireType}function RegisteredPointer(name,registeredClass,isReference,isConst,isSmartPointer,pointeeType,sharingPolicy,rawGetPointee,rawConstructor,rawShare,rawDestructor){this.name=name;this.registeredClass=registeredClass;this.isReference=isReference;this.isConst=isConst;this.isSmartPointer=isSmartPointer;this.pointeeType=pointeeType;this.sharingPolicy=sharingPolicy;this.rawGetPointee=rawGetPointee;this.rawConstructor=rawConstructor;this.rawShare=rawShare;this.rawDestructor=rawDestructor;if(!isSmartPointer&&registeredClass.baseClass===undefined){if(isConst){this["toWireType"]=constNoSmartPtrRawPointerToWireType;this.destructorFunction=null}else{this["toWireType"]=nonConstNoSmartPtrRawPointerToWireType;this.destructorFunction=null}}else{this["toWireType"]=genericPointerToWireType}}function __embind_register_smart_ptr(rawType,rawPointeeType,name,sharingPolicy,getPointeeSignature,rawGetPointee,constructorSignature,rawConstructor,shareSignature,rawShare,destructorSignature,rawDestructor){name=readLatin1String(name);rawGetPointee=requireFunction(getPointeeSignature,rawGetPointee);rawConstructor=requireFunction(constructorSignature,rawConstructor);rawShare=requireFunction(shareSignature,rawShare);rawDestructor=requireFunction(destructorSignature,rawDestructor);whenDependentTypesAreResolved([rawType],[rawPointeeType],(function(pointeeType){pointeeType=pointeeType[0];var registeredPointer=new RegisteredPointer(name,pointeeType.registeredClass,false,false,true,pointeeType,sharingPolicy,rawGetPointee,rawConstructor,rawShare,rawDestructor);return[registeredPointer]}))}function _llvm_exp2_f32(x){return Math.pow(2,x)}function _llvm_exp2_f64(){return _llvm_exp2_f32.apply(null,arguments)}function _sched_yield(){return 0}function craftInvokerFunction(humanName,argTypes,classType,cppInvokerFunc,cppTargetFunc){var argCount=argTypes.length;if(argCount<2){throwBindingError("argTypes array size mismatch! Must at least get return value and 'this' types!")}var isClassMethodFunc=argTypes[1]!==null&&classType!==null;var argsList="";var argsListWired="";for(var i=0;i<argCount-2;++i){argsList+=(i!==0?", ":"")+"arg"+i;argsListWired+=(i!==0?", ":"")+"arg"+i+"Wired"}var invokerFnBody="return function "+makeLegalFunctionName(humanName)+"("+argsList+") {\n"+"if (arguments.length !== "+(argCount-2)+") {\n"+"throwBindingError('function "+humanName+" called with ' + arguments.length + ' arguments, expected "+(argCount-2)+" args!');\n"+"}\n";var needsDestructorStack=false;for(var i=1;i<argTypes.length;++i){if(argTypes[i]!==null&&argTypes[i].destructorFunction===undefined){needsDestructorStack=true;break}}if(needsDestructorStack){invokerFnBody+="var destructors = [];\n"}var dtorStack=needsDestructorStack?"destructors":"null";var args1=["throwBindingError","invoker","fn","runDestructors","retType","classParam"];var args2=[throwBindingError,cppInvokerFunc,cppTargetFunc,runDestructors,argTypes[0],argTypes[1]];if(isClassMethodFunc){invokerFnBody+="var thisWired = classParam.toWireType("+dtorStack+", this);\n"}for(var i=0;i<argCount-2;++i){invokerFnBody+="var arg"+i+"Wired = argType"+i+".toWireType("+dtorStack+", arg"+i+"); // "+argTypes[i+2].name+"\n";args1.push("argType"+i);args2.push(argTypes[i+2])}if(isClassMethodFunc){argsListWired="thisWired"+(argsListWired.length>0?", ":"")+argsListWired}var returns=argTypes[0].name!=="void";invokerFnBody+=(returns?"var rv = ":"")+"invoker(fn"+(argsListWired.length>0?", ":"")+argsListWired+");\n";if(needsDestructorStack){invokerFnBody+="runDestructors(destructors);\n"}else{for(var i=isClassMethodFunc?1:2;i<argTypes.length;++i){var paramName=i===1?"thisWired":"arg"+(i-2)+"Wired";if(argTypes[i].destructorFunction!==null){invokerFnBody+=paramName+"_dtor("+paramName+"); // "+argTypes[i].name+"\n";args1.push(paramName+"_dtor");args2.push(argTypes[i].destructorFunction)}}}if(returns){invokerFnBody+="var ret = retType.fromWireType(rv);\n"+"return ret;\n"}else{}invokerFnBody+="}\n";args1.push(invokerFnBody);var invokerFunction=new_(Function,args1).apply(null,args2);return invokerFunction}function ensureOverloadTable(proto,methodName,humanName){if(undefined===proto[methodName].overloadTable){var prevFunc=proto[methodName];proto[methodName]=(function(){if(!proto[methodName].overloadTable.hasOwnProperty(arguments.length)){throwBindingError("Function '"+humanName+"' called with an invalid number of arguments ("+arguments.length+") - expects one of ("+proto[methodName].overloadTable+")!")}return proto[methodName].overloadTable[arguments.length].apply(this,arguments)});proto[methodName].overloadTable=[];proto[methodName].overloadTable[prevFunc.argCount]=prevFunc}}function heap32VectorToArray(count,firstElement){var array=[];for(var i=0;i<count;i++){array.push(HEAP32[(firstElement>>2)+i])}return array}var UnboundTypeError=undefined;function throwUnboundTypeError(message,types){var unboundTypes=[];var seen={};function visit(type){if(seen[type]){return}if(registeredTypes[type]){return}if(typeDependencies[type]){typeDependencies[type].forEach(visit);return}unboundTypes.push(type);seen[type]=true}types.forEach(visit);throw new UnboundTypeError(message+": "+unboundTypes.map(getTypeName).join([", "]))}function __embind_register_class_class_function(rawClassType,methodName,argCount,rawArgTypesAddr,invokerSignature,rawInvoker,fn){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);methodName=readLatin1String(methodName);rawInvoker=requireFunction(invokerSignature,rawInvoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName=classType.name+"."+methodName;function unboundTypesHandler(){throwUnboundTypeError("Cannot call "+humanName+" due to unbound types",rawArgTypes)}var proto=classType.registeredClass.constructor;if(undefined===proto[methodName]){unboundTypesHandler.argCount=argCount-1;proto[methodName]=unboundTypesHandler}else{ensureOverloadTable(proto,methodName,humanName);proto[methodName].overloadTable[argCount-1]=unboundTypesHandler}whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){var invokerArgsArray=[argTypes[0],null].concat(argTypes.slice(1));var func=craftInvokerFunction(humanName,invokerArgsArray,null,rawInvoker,fn);if(undefined===proto[methodName].overloadTable){proto[methodName]=func}else{proto[methodName].overloadTable[argCount-1]=func}return[]}));return[]}))}var _environ=STATICTOP;STATICTOP+=16;function ___buildEnvironment(env){var MAX_ENV_VALUES=64;var TOTAL_ENV_SIZE=1024;var poolPtr;var envPtr;if(!___buildEnvironment.called){___buildEnvironment.called=true;ENV["USER"]=ENV["LOGNAME"]="web_user";ENV["PATH"]="/";ENV["PWD"]="/";ENV["HOME"]="/home/web_user";ENV["LANG"]="C";ENV["_"]=Module["thisProgram"];poolPtr=allocate(TOTAL_ENV_SIZE,"i8",ALLOC_STATIC);envPtr=allocate(MAX_ENV_VALUES*4,"i8*",ALLOC_STATIC);HEAP32[envPtr>>2]=poolPtr;HEAP32[_environ>>2]=envPtr}else{envPtr=HEAP32[_environ>>2];poolPtr=HEAP32[envPtr>>2]}var strings=[];var totalSize=0;for(var key in env){if(typeof env[key]==="string"){var line=key+"="+env[key];strings.push(line);totalSize+=line.length}}if(totalSize>TOTAL_ENV_SIZE){throw new Error("Environment size exceeded TOTAL_ENV_SIZE!")}var ptrSize=4;for(var i=0;i<strings.length;i++){var line=strings[i];writeAsciiToMemory(line,poolPtr);HEAP32[envPtr+i*ptrSize>>2]=poolPtr;poolPtr+=line.length+1}HEAP32[envPtr+strings.length*ptrSize>>2]=0}var ENV={};function _getenv(name){if(name===0)return 0;name=Pointer_stringify(name);if(!ENV.hasOwnProperty(name))return 0;if(_getenv.ret)_free(_getenv.ret);_getenv.ret=allocate(intArrayFromString(ENV[name]),"i8",ALLOC_NORMAL);return _getenv.ret}function __isLeapYear(year){return year%4===0&&(year%100!==0||year%400===0)}function __arraySum(array,index){var sum=0;for(var i=0;i<=index;sum+=array[i++]);return sum}var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date,days){var newDate=new Date(date.getTime());while(days>0){var leap=__isLeapYear(newDate.getFullYear());var currentMonth=newDate.getMonth();var daysInCurrentMonth=(leap?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR)[currentMonth];if(days>daysInCurrentMonth-newDate.getDate()){days-=daysInCurrentMonth-newDate.getDate()+1;newDate.setDate(1);if(currentMonth<11){newDate.setMonth(currentMonth+1)}else{newDate.setMonth(0);newDate.setFullYear(newDate.getFullYear()+1)}}else{newDate.setDate(newDate.getDate()+days);return newDate}}return newDate}function _strftime(s,maxsize,format,tm){var tm_zone=HEAP32[tm+40>>2];var date={tm_sec:HEAP32[tm>>2],tm_min:HEAP32[tm+4>>2],tm_hour:HEAP32[tm+8>>2],tm_mday:HEAP32[tm+12>>2],tm_mon:HEAP32[tm+16>>2],tm_year:HEAP32[tm+20>>2],tm_wday:HEAP32[tm+24>>2],tm_yday:HEAP32[tm+28>>2],tm_isdst:HEAP32[tm+32>>2],tm_gmtoff:HEAP32[tm+36>>2],tm_zone:tm_zone?Pointer_stringify(tm_zone):""};var pattern=Pointer_stringify(format);var EXPANSION_RULES_1={"%c":"%a %b %d %H:%M:%S %Y","%D":"%m/%d/%y","%F":"%Y-%m-%d","%h":"%b","%r":"%I:%M:%S %p","%R":"%H:%M","%T":"%H:%M:%S","%x":"%m/%d/%y","%X":"%H:%M:%S"};for(var rule in EXPANSION_RULES_1){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_1[rule])}var WEEKDAYS=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];var MONTHS=["January","February","March","April","May","June","July","August","September","October","November","December"];function leadingSomething(value,digits,character){var str=typeof value==="number"?value.toString():value||"";while(str.length<digits){str=character[0]+str}return str}function leadingNulls(value,digits){return leadingSomething(value,digits,"0")}function compareByDay(date1,date2){function sgn(value){return value<0?-1:value>0?1:0}var compare;if((compare=sgn(date1.getFullYear()-date2.getFullYear()))===0){if((compare=sgn(date1.getMonth()-date2.getMonth()))===0){compare=sgn(date1.getDate()-date2.getDate())}}return compare}function getFirstWeekStartDate(janFourth){switch(janFourth.getDay()){case 0:return new Date(janFourth.getFullYear()-1,11,29);case 1:return janFourth;case 2:return new Date(janFourth.getFullYear(),0,3);case 3:return new Date(janFourth.getFullYear(),0,2);case 4:return new Date(janFourth.getFullYear(),0,1);case 5:return new Date(janFourth.getFullYear()-1,11,31);case 6:return new Date(janFourth.getFullYear()-1,11,30)}}function getWeekBasedYear(date){var thisDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);var janFourthThisYear=new Date(thisDate.getFullYear(),0,4);var janFourthNextYear=new Date(thisDate.getFullYear()+1,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);if(compareByDay(firstWeekStartThisYear,thisDate)<=0){if(compareByDay(firstWeekStartNextYear,thisDate)<=0){return thisDate.getFullYear()+1}else{return thisDate.getFullYear()}}else{return thisDate.getFullYear()-1}}var EXPANSION_RULES_2={"%a":(function(date){return WEEKDAYS[date.tm_wday].substring(0,3)}),"%A":(function(date){return WEEKDAYS[date.tm_wday]}),"%b":(function(date){return MONTHS[date.tm_mon].substring(0,3)}),"%B":(function(date){return MONTHS[date.tm_mon]}),"%C":(function(date){var year=date.tm_year+1900;return leadingNulls(year/100|0,2)}),"%d":(function(date){return leadingNulls(date.tm_mday,2)}),"%e":(function(date){return leadingSomething(date.tm_mday,2," ")}),"%g":(function(date){return getWeekBasedYear(date).toString().substring(2)}),"%G":(function(date){return getWeekBasedYear(date)}),"%H":(function(date){return leadingNulls(date.tm_hour,2)}),"%I":(function(date){var twelveHour=date.tm_hour;if(twelveHour==0)twelveHour=12;else if(twelveHour>12)twelveHour-=12;return leadingNulls(twelveHour,2)}),"%j":(function(date){return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900)?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,date.tm_mon-1),3)}),"%m":(function(date){return leadingNulls(date.tm_mon+1,2)}),"%M":(function(date){return leadingNulls(date.tm_min,2)}),"%n":(function(){return"\n"}),"%p":(function(date){if(date.tm_hour>=0&&date.tm_hour<12){return"AM"}else{return"PM"}}),"%S":(function(date){return leadingNulls(date.tm_sec,2)}),"%t":(function(){return"\t"}),"%u":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()||7}),"%U":(function(date){var janFirst=new Date(date.tm_year+1900,0,1);var firstSunday=janFirst.getDay()===0?janFirst:__addDays(janFirst,7-janFirst.getDay());var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstSunday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstSundayUntilEndJanuary=31-firstSunday.getDate();var days=firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstSunday,janFirst)===0?"01":"00"}),"%V":(function(date){var janFourthThisYear=new Date(date.tm_year+1900,0,4);var janFourthNextYear=new Date(date.tm_year+1901,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);var endDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);if(compareByDay(endDate,firstWeekStartThisYear)<0){return"53"}if(compareByDay(firstWeekStartNextYear,endDate)<=0){return"01"}var daysDifference;if(firstWeekStartThisYear.getFullYear()<date.tm_year+1900){daysDifference=date.tm_yday+32-firstWeekStartThisYear.getDate()}else{daysDifference=date.tm_yday+1-firstWeekStartThisYear.getDate()}return leadingNulls(Math.ceil(daysDifference/7),2)}),"%w":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()}),"%W":(function(date){var janFirst=new Date(date.tm_year,0,1);var firstMonday=janFirst.getDay()===1?janFirst:__addDays(janFirst,janFirst.getDay()===0?1:7-janFirst.getDay()+1);var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstMonday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstMondayUntilEndJanuary=31-firstMonday.getDate();var days=firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstMonday,janFirst)===0?"01":"00"}),"%y":(function(date){return(date.tm_year+1900).toString().substring(2)}),"%Y":(function(date){return date.tm_year+1900}),"%z":(function(date){var off=date.tm_gmtoff;var ahead=off>=0;off=Math.abs(off)/60;off=off/60*100+off%60;return(ahead?"+":"-")+String("0000"+off).slice(-4)}),"%Z":(function(date){return date.tm_zone}),"%%":(function(){return"%"})};for(var rule in EXPANSION_RULES_2){if(pattern.indexOf(rule)>=0){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_2[rule](date))}}var bytes=intArrayFromString(pattern,false);if(bytes.length>maxsize){return 0}writeArrayToMemory(bytes,s);return bytes.length-1}function _strftime_l(s,maxsize,format,tm){return _strftime(s,maxsize,format,tm)}function __emval_allocateDestructors(destructorsRef){var destructors=[];HEAP32[destructorsRef>>2]=__emval_register(destructors);return destructors}function requireHandle(handle){if(!handle){throwBindingError("Cannot use deleted val. handle = "+handle)}return emval_handle_array[handle].value}function __emval_call_void_method(caller,handle,methodName,args){caller=emval_methodCallers[caller];handle=requireHandle(handle);methodName=getStringOrSymbol(methodName);caller(handle,methodName,null,args)}function _gettimeofday(ptr){var now=Date.now();HEAP32[ptr>>2]=now/1e3|0;HEAP32[ptr+4>>2]=now%1e3*1e3|0;return 0}function ___map_file(pathname,size){___setErrNo(ERRNO_CODES.EPERM);return-1}function __emval_run_destructors(handle){var destructors=emval_handle_array[handle].value;runDestructors(destructors);__emval_decref(handle)}function _emscripten_memcpy_big(dest,src,num){HEAPU8.set(HEAPU8.subarray(src,src+num),dest);return dest}var _llvm_pow_f64=Math_pow;function __embind_finalize_value_array(rawTupleType){var reg=tupleRegistrations[rawTupleType];delete tupleRegistrations[rawTupleType];var elements=reg.elements;var elementsLength=elements.length;var elementTypes=elements.map((function(elt){return elt.getterReturnType})).concat(elements.map((function(elt){return elt.setterArgumentType})));var rawConstructor=reg.rawConstructor;var rawDestructor=reg.rawDestructor;whenDependentTypesAreResolved([rawTupleType],elementTypes,(function(elementTypes){elements.forEach((function(elt,i){var getterReturnType=elementTypes[i];var getter=elt.getter;var getterContext=elt.getterContext;var setterArgumentType=elementTypes[i+elementsLength];var setter=elt.setter;var setterContext=elt.setterContext;elt.read=(function(ptr){return getterReturnType["fromWireType"](getter(getterContext,ptr))});elt.write=(function(ptr,o){var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,o));runDestructors(destructors)})}));return[{name:reg.name,"fromWireType":(function(ptr){var rv=new Array(elementsLength);for(var i=0;i<elementsLength;++i){rv[i]=elements[i].read(ptr)}rawDestructor(ptr);return rv}),"toWireType":(function(destructors,o){if(elementsLength!==o.length){throw new TypeError("Incorrect number of tuple elements for "+reg.name+": expected="+elementsLength+", actual="+o.length)}var ptr=rawConstructor();for(var i=0;i<elementsLength;++i){elements[i].write(ptr,o[i])}if(destructors!==null){destructors.push(rawDestructor,ptr)}return ptr}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:rawDestructor}]}))}function ___gxx_personality_v0(){}function _pthread_cond_wait(){return 0}function __embind_register_memory_view(rawType,dataTypeIndex,name){var typeMapping=[Int8Array,Uint8Array,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array];var TA=typeMapping[dataTypeIndex];function decodeMemoryView(handle){handle=handle>>2;var heap=HEAPU32;var size=heap[handle];var data=heap[handle+1];return new TA(heap["buffer"],data,size)}name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":decodeMemoryView,"argPackAdvance":8,"readValueFromPointer":decodeMemoryView},{ignoreDuplicateRegistrations:true})}function validateThis(this_,classType,humanName){if(!(this_ instanceof Object)){throwBindingError(humanName+' with invalid "this": '+this_)}if(!(this_ instanceof classType.registeredClass.constructor)){throwBindingError(humanName+' incompatible with "this" of type '+this_.constructor.name)}if(!this_.$$.ptr){throwBindingError("cannot call emscripten binding method "+humanName+" on deleted object")}return upcastPointer(this_.$$.ptr,this_.$$.ptrType.registeredClass,classType.registeredClass)}function __embind_register_class_property(classType,fieldName,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){fieldName=readLatin1String(fieldName);getter=requireFunction(getterSignature,getter);whenDependentTypesAreResolved([],[classType],(function(classType){classType=classType[0];var humanName=classType.name+"."+fieldName;var desc={get:(function(){throwUnboundTypeError("Cannot access "+humanName+" due to unbound types",[getterReturnType,setterArgumentType])}),enumerable:true,configurable:true};if(setter){desc.set=(function(){throwUnboundTypeError("Cannot access "+humanName+" due to unbound types",[getterReturnType,setterArgumentType])})}else{desc.set=(function(v){throwBindingError(humanName+" is a read-only property")})}Object.defineProperty(classType.registeredClass.instancePrototype,fieldName,desc);whenDependentTypesAreResolved([],setter?[getterReturnType,setterArgumentType]:[getterReturnType],(function(types){var getterReturnType=types[0];var desc={get:(function(){var ptr=validateThis(this,classType,humanName+" getter");return getterReturnType["fromWireType"](getter(getterContext,ptr))}),enumerable:true};if(setter){setter=requireFunction(setterSignature,setter);var setterArgumentType=types[1];desc.set=(function(v){var ptr=validateThis(this,classType,humanName+" setter");var destructors=[];setter(setterContext,ptr,setterArgumentType["toWireType"](destructors,v));runDestructors(destructors)})}Object.defineProperty(classType.registeredClass.instancePrototype,fieldName,desc);return[]}));return[]}))}function __emval_incref(handle){if(handle>4){emval_handle_array[handle].refcount+=1}}function _pthread_mutexattr_settype(){}function __embind_register_value_object(rawType,name,constructorSignature,rawConstructor,destructorSignature,rawDestructor){structRegistrations[rawType]={name:readLatin1String(name),rawConstructor:requireFunction(constructorSignature,rawConstructor),rawDestructor:requireFunction(destructorSignature,rawDestructor),fields:[]}}function __embind_register_bool(rawType,name,size,trueValue,falseValue){var shift=getShiftFromSize(size);name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(wt){return!!wt}),"toWireType":(function(destructors,o){return o?trueValue:falseValue}),"argPackAdvance":8,"readValueFromPointer":(function(pointer){var heap;if(size===1){heap=HEAP8}else if(size===2){heap=HEAP16}else if(size===4){heap=HEAP32}else{throw new TypeError("Unknown boolean type size: "+name)}return this["fromWireType"](heap[pointer>>shift])}),destructorFunction:null})}function __embind_register_void(rawType,name){name=readLatin1String(name);registerType(rawType,{isVoid:true,name:name,"argPackAdvance":0,"fromWireType":(function(){return undefined}),"toWireType":(function(destructors,o){return undefined})})}function __emval_new_array(){return __emval_register([])}function _abort(){Module["abort"]()}function __emval_as(handle,returnType,destructorsRef){handle=requireHandle(handle);returnType=requireRegisteredType(returnType,"emval::as");var destructors=[];var rd=__emval_register(destructors);HEAP32[destructorsRef>>2]=rd;return returnType["toWireType"](destructors,handle)}function _pthread_mutex_destroy(){}function _pthread_once(ptr,func){if(!_pthread_once.seen)_pthread_once.seen={};if(ptr in _pthread_once.seen)return;Module["dynCall_v"](func);_pthread_once.seen[ptr]=1}function __embind_register_value_object_field(structType,fieldName,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){structRegistrations[structType].fields.push({fieldName:readLatin1String(fieldName),getterReturnType:getterReturnType,getter:requireFunction(getterSignature,getter),getterContext:getterContext,setterArgumentType:setterArgumentType,setter:requireFunction(setterSignature,setter),setterContext:setterContext})}function ClassHandle_isAliasOf(other){if(!(this instanceof ClassHandle)){return false}if(!(other instanceof ClassHandle)){return false}var leftClass=this.$$.ptrType.registeredClass;var left=this.$$.ptr;var rightClass=other.$$.ptrType.registeredClass;var right=other.$$.ptr;while(leftClass.baseClass){left=leftClass.upcast(left);leftClass=leftClass.baseClass}while(rightClass.baseClass){right=rightClass.upcast(right);rightClass=rightClass.baseClass}return leftClass===rightClass&&left===right}function shallowCopyInternalPointer(o){return{count:o.count,deleteScheduled:o.deleteScheduled,preservePointerOnDelete:o.preservePointerOnDelete,ptr:o.ptr,ptrType:o.ptrType,smartPtr:o.smartPtr,smartPtrType:o.smartPtrType}}function throwInstanceAlreadyDeleted(obj){function getInstanceTypeName(handle){return handle.$$.ptrType.registeredClass.name}throwBindingError(getInstanceTypeName(obj)+" instance already deleted")}function ClassHandle_clone(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.preservePointerOnDelete){this.$$.count.value+=1;return this}else{var clone=Object.create(Object.getPrototypeOf(this),{$$:{value:shallowCopyInternalPointer(this.$$)}});clone.$$.count.value+=1;clone.$$.deleteScheduled=false;return clone}}function runDestructor(handle){var $$=handle.$$;if($$.smartPtr){$$.smartPtrType.rawDestructor($$.smartPtr)}else{$$.ptrType.registeredClass.rawDestructor($$.ptr)}}function ClassHandle_delete(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}this.$$.count.value-=1;var toDelete=0===this.$$.count.value;if(toDelete){runDestructor(this)}if(!this.$$.preservePointerOnDelete){this.$$.smartPtr=undefined;this.$$.ptr=undefined}}function ClassHandle_isDeleted(){return!this.$$.ptr}function ClassHandle_deleteLater(){if(!this.$$.ptr){throwInstanceAlreadyDeleted(this)}if(this.$$.deleteScheduled&&!this.$$.preservePointerOnDelete){throwBindingError("Object already scheduled for deletion")}deletionQueue.push(this);if(deletionQueue.length===1&&delayFunction){delayFunction(flushPendingDeletes)}this.$$.deleteScheduled=true;return this}function init_ClassHandle(){ClassHandle.prototype["isAliasOf"]=ClassHandle_isAliasOf;ClassHandle.prototype["clone"]=ClassHandle_clone;ClassHandle.prototype["delete"]=ClassHandle_delete;ClassHandle.prototype["isDeleted"]=ClassHandle_isDeleted;ClassHandle.prototype["deleteLater"]=ClassHandle_deleteLater}function ClassHandle(){}function exposePublicSymbol(name,value,numArguments){if(Module.hasOwnProperty(name)){if(undefined===numArguments||undefined!==Module[name].overloadTable&&undefined!==Module[name].overloadTable[numArguments]){throwBindingError("Cannot register public name '"+name+"' twice")}ensureOverloadTable(Module,name,name);if(Module.hasOwnProperty(numArguments)){throwBindingError("Cannot register multiple overloads of a function with the same number of arguments ("+numArguments+")!")}Module[name].overloadTable[numArguments]=value}else{Module[name]=value;if(undefined!==numArguments){Module[name].numArguments=numArguments}}}function RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast){this.name=name;this.constructor=constructor;this.instancePrototype=instancePrototype;this.rawDestructor=rawDestructor;this.baseClass=baseClass;this.getActualType=getActualType;this.upcast=upcast;this.downcast=downcast;this.pureVirtualFunctions=[]}function replacePublicSymbol(name,value,numArguments){if(!Module.hasOwnProperty(name)){throwInternalError("Replacing nonexistant public symbol")}if(undefined!==Module[name].overloadTable&&undefined!==numArguments){Module[name].overloadTable[numArguments]=value}else{Module[name]=value;Module[name].argCount=numArguments}}function __embind_register_class(rawType,rawPointerType,rawConstPointerType,baseClassRawType,getActualTypeSignature,getActualType,upcastSignature,upcast,downcastSignature,downcast,name,destructorSignature,rawDestructor){name=readLatin1String(name);getActualType=requireFunction(getActualTypeSignature,getActualType);if(upcast){upcast=requireFunction(upcastSignature,upcast)}if(downcast){downcast=requireFunction(downcastSignature,downcast)}rawDestructor=requireFunction(destructorSignature,rawDestructor);var legalFunctionName=makeLegalFunctionName(name);exposePublicSymbol(legalFunctionName,(function(){throwUnboundTypeError("Cannot construct "+name+" due to unbound types",[baseClassRawType])}));whenDependentTypesAreResolved([rawType,rawPointerType,rawConstPointerType],baseClassRawType?[baseClassRawType]:[],(function(base){base=base[0];var baseClass;var basePrototype;if(baseClassRawType){baseClass=base.registeredClass;basePrototype=baseClass.instancePrototype}else{basePrototype=ClassHandle.prototype}var constructor=createNamedFunction(legalFunctionName,(function(){if(Object.getPrototypeOf(this)!==instancePrototype){throw new BindingError("Use 'new' to construct "+name)}if(undefined===registeredClass.constructor_body){throw new BindingError(name+" has no accessible constructor")}var body=registeredClass.constructor_body[arguments.length];if(undefined===body){throw new BindingError("Tried to invoke ctor of "+name+" with invalid number of parameters ("+arguments.length+") - expected ("+Object.keys(registeredClass.constructor_body).toString()+") parameters instead!")}return body.apply(this,arguments)}));var instancePrototype=Object.create(basePrototype,{constructor:{value:constructor}});constructor.prototype=instancePrototype;var registeredClass=new RegisteredClass(name,constructor,instancePrototype,rawDestructor,baseClass,getActualType,upcast,downcast);var referenceConverter=new RegisteredPointer(name,registeredClass,true,false,false);var pointerConverter=new RegisteredPointer(name+"*",registeredClass,false,false,false);var constPointerConverter=new RegisteredPointer(name+" const*",registeredClass,false,true,false);registeredPointers[rawType]={pointerType:pointerConverter,constPointerType:constPointerConverter};replacePublicSymbol(legalFunctionName,constructor);return[referenceConverter,pointerConverter,constPointerConverter]}))}function ___lock(){}function ___unlock(){}function _pthread_mutexattr_init(){}function _pthread_getspecific(key){return PTHREAD_SPECIFIC[key]||0}function _pthread_key_delete(key){if(key in PTHREAD_SPECIFIC){delete PTHREAD_SPECIFIC[key];return 0}return ERRNO_CODES.EINVAL}function __emval_get_property(handle,key){handle=requireHandle(handle);key=requireHandle(key);return __emval_register(handle[key])}function __exit(status){Module["exit"](status)}function _exit(status){__exit(status)}function _pthread_setspecific(key,value){if(!(key in PTHREAD_SPECIFIC)){return ERRNO_CODES.EINVAL}PTHREAD_SPECIFIC[key]=value;return 0}function __embind_register_value_array_element(rawTupleType,getterReturnType,getterSignature,getter,getterContext,setterArgumentType,setterSignature,setter,setterContext){tupleRegistrations[rawTupleType].elements.push({getterReturnType:getterReturnType,getter:requireFunction(getterSignature,getter),getterContext:getterContext,setterArgumentType:setterArgumentType,setter:requireFunction(setterSignature,setter),setterContext:setterContext})}function ___cxa_allocate_exception(size){return _malloc(size)}function ___cxa_pure_virtual(){ABORT=true;throw"Pure virtual function called!"}function floatReadValueFromPointer(name,shift){switch(shift){case 2:return(function(pointer){return this["fromWireType"](HEAPF32[pointer>>2])});case 3:return(function(pointer){return this["fromWireType"](HEAPF64[pointer>>3])});default:throw new TypeError("Unknown float type: "+name)}}function __embind_register_float(rawType,name,size){var shift=getShiftFromSize(size);name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(value){return value}),"toWireType":(function(destructors,value){if(typeof value!=="number"&&typeof value!=="boolean"){throw new TypeError('Cannot convert "'+_embind_repr(value)+'" to '+this.name)}return value}),"argPackAdvance":8,"readValueFromPointer":floatReadValueFromPointer(name,shift),destructorFunction:null})}function __embind_register_function(name,argCount,rawArgTypesAddr,signature,rawInvoker,fn){var argTypes=heap32VectorToArray(argCount,rawArgTypesAddr);name=readLatin1String(name);rawInvoker=requireFunction(signature,rawInvoker);exposePublicSymbol(name,(function(){throwUnboundTypeError("Cannot call "+name+" due to unbound types",argTypes)}),argCount-1);whenDependentTypesAreResolved([],argTypes,(function(argTypes){var invokerArgsArray=[argTypes[0],null].concat(argTypes.slice(1));replacePublicSymbol(name,craftInvokerFunction(name,invokerArgsArray,null,rawInvoker,fn),argCount-1);return[]}))}function __embind_register_emval(rawType,name){name=readLatin1String(name);registerType(rawType,{name:name,"fromWireType":(function(handle){var rv=emval_handle_array[handle].value;__emval_decref(handle);return rv}),"toWireType":(function(destructors,value){return __emval_register(value)}),"argPackAdvance":8,"readValueFromPointer":simpleReadValueFromPointer,destructorFunction:null})}function __embind_register_constant(name,type,value){name=readLatin1String(name);whenDependentTypesAreResolved([],[type],(function(type){type=type[0];Module[name]=type["fromWireType"](value);return[]}))}function ___cxa_begin_catch(ptr){var info=EXCEPTIONS.infos[ptr];if(info&&!info.caught){info.caught=true;__ZSt18uncaught_exceptionv.uncaught_exception--}if(info)info.rethrown=false;EXCEPTIONS.caught.push(ptr);EXCEPTIONS.addRef(EXCEPTIONS.deAdjust(ptr));return ptr}function ___syscall3(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),buf=SYSCALLS.get(),count=SYSCALLS.get();return FS.read(stream,HEAP8,buf,count)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall5(which,varargs){SYSCALLS.varargs=varargs;try{var pathname=SYSCALLS.getStr(),flags=SYSCALLS.get(),mode=SYSCALLS.get();var stream=FS.open(pathname,flags,mode);return stream.fd}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall4(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),buf=SYSCALLS.get(),count=SYSCALLS.get();return FS.write(stream,HEAP8,buf,count)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall6(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD();FS.close(stream);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function __embind_register_class_constructor(rawClassType,argCount,rawArgTypesAddr,invokerSignature,invoker,rawConstructor){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);invoker=requireFunction(invokerSignature,invoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName="constructor "+classType.name;if(undefined===classType.registeredClass.constructor_body){classType.registeredClass.constructor_body=[]}if(undefined!==classType.registeredClass.constructor_body[argCount-1]){throw new BindingError("Cannot register multiple constructors with identical number of parameters ("+(argCount-1)+") for class '"+classType.name+"'! Overload resolution is currently only performed using the parameter count, not actual type info!")}classType.registeredClass.constructor_body[argCount-1]=function unboundTypeHandler(){throwUnboundTypeError("Cannot construct "+classType.name+" due to unbound types",rawArgTypes)};whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){classType.registeredClass.constructor_body[argCount-1]=function constructor_body(){if(arguments.length!==argCount-1){throwBindingError(humanName+" called with "+arguments.length+" arguments, expected "+(argCount-1))}var destructors=[];var args=new Array(argCount);args[0]=rawConstructor;for(var i=1;i<argCount;++i){args[i]=argTypes[i]["toWireType"](destructors,arguments[i-1])}var ptr=invoker.apply(null,args);runDestructors(destructors);return argTypes[0]["fromWireType"](ptr)};return[]}));return[]}))}function ___syscall140(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),offset_high=SYSCALLS.get(),offset_low=SYSCALLS.get(),result=SYSCALLS.get(),whence=SYSCALLS.get();var offset=offset_low;FS.llseek(stream,offset,whence);HEAP32[result>>2]=stream.position;if(stream.getdents&&offset===0&&whence===0)stream.getdents=null;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function __embind_register_class_function(rawClassType,methodName,argCount,rawArgTypesAddr,invokerSignature,rawInvoker,context,isPureVirtual){var rawArgTypes=heap32VectorToArray(argCount,rawArgTypesAddr);methodName=readLatin1String(methodName);rawInvoker=requireFunction(invokerSignature,rawInvoker);whenDependentTypesAreResolved([],[rawClassType],(function(classType){classType=classType[0];var humanName=classType.name+"."+methodName;if(isPureVirtual){classType.registeredClass.pureVirtualFunctions.push(methodName)}function unboundTypesHandler(){throwUnboundTypeError("Cannot call "+humanName+" due to unbound types",rawArgTypes)}var proto=classType.registeredClass.instancePrototype;var method=proto[methodName];if(undefined===method||undefined===method.overloadTable&&method.className!==classType.name&&method.argCount===argCount-2){unboundTypesHandler.argCount=argCount-2;unboundTypesHandler.className=classType.name;proto[methodName]=unboundTypesHandler}else{ensureOverloadTable(proto,methodName,humanName);proto[methodName].overloadTable[argCount-2]=unboundTypesHandler}whenDependentTypesAreResolved([],rawArgTypes,(function(argTypes){var memberFunction=craftInvokerFunction(humanName,argTypes,classType,rawInvoker,context);if(undefined===proto[methodName].overloadTable){memberFunction.argCount=argCount-2;proto[methodName]=memberFunction}else{proto[methodName].overloadTable[argCount-2]=memberFunction}return[]}));return[]}))}function ___syscall146(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doWritev(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall221(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),cmd=SYSCALLS.get();switch(cmd){case 0:{var arg=SYSCALLS.get();if(arg<0){return-ERRNO_CODES.EINVAL}var newStream;newStream=FS.open(stream.path,stream.flags,0,arg);return newStream.fd};case 1:case 2:return 0;case 3:return stream.flags;case 4:{var arg=SYSCALLS.get();stream.flags|=arg;return 0};case 12:case 12:{var arg=SYSCALLS.get();var offset=0;HEAP16[arg+offset>>1]=2;return 0};case 13:case 14:case 13:case 14:return 0;case 16:case 8:return-ERRNO_CODES.EINVAL;case 9:___setErrNo(ERRNO_CODES.EINVAL);return-1;default:{return-ERRNO_CODES.EINVAL}}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall145(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doReadv(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var ___dso_handle=STATICTOP;STATICTOP+=16;embind_init_charCodes();init_emval();BindingError=Module["BindingError"]=extendError(Error,"BindingError");InternalError=Module["InternalError"]=extendError(Error,"InternalError");FS.staticInit();__ATINIT__.unshift((function(){if(!Module["noFSInit"]&&!FS.init.initialized)FS.init()}));__ATMAIN__.push((function(){FS.ignorePermissions=false}));__ATEXIT__.push((function(){FS.quit()}));Module["FS_createFolder"]=FS.createFolder;Module["FS_createPath"]=FS.createPath;Module["FS_createDataFile"]=FS.createDataFile;Module["FS_createPreloadedFile"]=FS.createPreloadedFile;Module["FS_createLazyFile"]=FS.createLazyFile;Module["FS_createLink"]=FS.createLink;Module["FS_createDevice"]=FS.createDevice;Module["FS_unlink"]=FS.unlink;__ATINIT__.unshift((function(){TTY.init()}));__ATEXIT__.push((function(){TTY.shutdown()}));if(ENVIRONMENT_IS_NODE){var fs=require("fs");var NODEJS_PATH=require("path");NODEFS.staticInit()}Module["requestFullScreen"]=function Module_requestFullScreen(lockPointer,resizeCanvas,vrDevice){Module.printErr("Module.requestFullScreen is deprecated. Please call Module.requestFullscreen instead.");Module["requestFullScreen"]=Module["requestFullscreen"];Browser.requestFullScreen(lockPointer,resizeCanvas,vrDevice)};Module["requestFullscreen"]=function Module_requestFullscreen(lockPointer,resizeCanvas,vrDevice){Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)};Module["requestAnimationFrame"]=function Module_requestAnimationFrame(func){Browser.requestAnimationFrame(func)};Module["setCanvasSize"]=function Module_setCanvasSize(width,height,noUpdates){Browser.setCanvasSize(width,height,noUpdates)};Module["pauseMainLoop"]=function Module_pauseMainLoop(){Browser.mainLoop.pause()};Module["resumeMainLoop"]=function Module_resumeMainLoop(){Browser.mainLoop.resume()};Module["getUserMedia"]=function Module_getUserMedia(){Browser.getUserMedia()};Module["createContext"]=function Module_createContext(canvas,useWebGL,setInModule,webGLContextAttributes){return Browser.createContext(canvas,useWebGL,setInModule,webGLContextAttributes)};if(ENVIRONMENT_IS_NODE){_emscripten_get_now=function _emscripten_get_now_actual(){var t=process["hrtime"]();return t[0]*1e3+t[1]/1e6}}else if(typeof dateNow!=="undefined"){_emscripten_get_now=dateNow}else if(typeof self==="object"&&self["performance"]&&typeof self["performance"]["now"]==="function"){_emscripten_get_now=(function(){return self["performance"]["now"]()})}else if(typeof performance==="object"&&typeof performance["now"]==="function"){_emscripten_get_now=(function(){return performance["now"]()})}else{_emscripten_get_now=Date.now}init_RegisteredPointer();init_embind();UnboundTypeError=Module["UnboundTypeError"]=extendError(Error,"UnboundTypeError");___buildEnvironment(ENV);init_ClassHandle();DYNAMICTOP_PTR=allocate(1,"i32",ALLOC_STATIC);STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP);STACK_MAX=STACK_BASE+TOTAL_STACK;DYNAMIC_BASE=Runtime.alignMemory(STACK_MAX);HEAP32[DYNAMICTOP_PTR>>2]=DYNAMIC_BASE;staticSealed=true;function invoke_iiiiiid(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiddd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiidiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiidiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiidddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiddi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viidiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiidddd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iidi(index,a1,a2,a3){try{return Module["dynCall_iidi"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddidd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiddidd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vidi(index,a1,a2,a3){try{Module["dynCall_vidi"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiddii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddid(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiddid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiidi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiddidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddi(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiddi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiidii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidd(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiidd"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_di(index,a1){try{return Module["dynCall_di"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiddiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vdii(index,a1,a2,a3){try{Module["dynCall_vdii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_diiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_dii(index,a1,a2){try{return Module["dynCall_dii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiidiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){try{Module["dynCall_viiiiiiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiii(index,a1,a2,a3,a4){try{return Module["dynCall_iiiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiidddi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiidiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiid(index,a1,a2,a3,a4){try{return Module["dynCall_iiiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiddiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiididiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13){try{return Module["dynCall_iiiiiiiididiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiidddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiiid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viidiiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidiiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viidiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiddi(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_diiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiididii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiididii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_diiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiidiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiddddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiidddii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidd(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiidd"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidi(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiidi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiidiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiddiddd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiddiddd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiddi(index,a1,a2,a3,a4,a5){try{return Module["dynCall_diiddi"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diii(index,a1,a2,a3){try{return Module["dynCall_diii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddd(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiddd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddidddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiddidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{Module["dynCall_viiiiiiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddidd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiddidd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiidiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiddiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiid(index,a1,a2,a3,a4){try{Module["dynCall_viiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiidddd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viidii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiid(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddi(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiidddi"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiii(index,a1,a2,a3,a4){try{Module["dynCall_viiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiidiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vid(index,a1,a2){try{Module["dynCall_vid"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidi(index,a1,a2,a3,a4){try{return Module["dynCall_iiidi"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidd(index,a1,a2,a3,a4){try{return Module["dynCall_iiidd"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vii(index,a1,a2){try{Module["dynCall_vii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiid(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiddddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidd(index,a1,a2,a3,a4){try{Module["dynCall_viidd"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viidi(index,a1,a2,a3,a4){try{Module["dynCall_viidi"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiid(index,a1,a2,a3,a4){try{return Module["dynCall_diiid"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiidddii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiidddiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiidddiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiid(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiiid"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiii(index,a1,a2,a3,a4){try{return Module["dynCall_diiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiidiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiidii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiddd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiddiddd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iid(index,a1,a2){try{return Module["dynCall_iid"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiddid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viididdi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viididdi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iii(index,a1,a2){try{return Module["dynCall_iii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiddii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiididi(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiididi"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vdiii(index,a1,a2,a3,a4){try{Module["dynCall_vdiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiidii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidddiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiidddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viii(index,a1,a2,a3){try{Module["dynCall_viii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_v(index){try{Module["dynCall_v"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viid(index,a1,a2,a3){try{Module["dynCall_viid"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vi(index,a1){try{Module["dynCall_vi"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidiiiidi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiidiiiidi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_ii(index,a1){try{return Module["dynCall_ii"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{Module["dynCall_viiiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vididdi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_vididdi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vidii(index,a1,a2,a3,a4){try{Module["dynCall_vidii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiidi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiddiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiddiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiidiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{Module["dynCall_viiiiiidiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiii(index,a1,a2,a3){try{return Module["dynCall_iiii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viididii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viididii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiddii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viiiiddii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiid(index,a1,a2,a3){try{return Module["dynCall_iiid"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiiiidd(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11){try{Module["dynCall_viiiiiiiiidd"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiidii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_diiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiid(index,a1,a2,a3,a4,a5){try{return Module["dynCall_diiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12){try{return Module["dynCall_iiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14){try{return Module["dynCall_iiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiiiddi(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiddi"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiidiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_i(index){try{return Module["dynCall_i"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiidii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiidii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_diiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_diiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vididdii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_vididdii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viididi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viididi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viididdii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{Module["dynCall_viididdii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiidiid(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiidiid"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiidd(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiidd"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vidiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_vidiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}Module.asmGlobalArg={"Math":Math,"Int8Array":Int8Array,"Int16Array":Int16Array,"Int32Array":Int32Array,"Uint8Array":Uint8Array,"Uint16Array":Uint16Array,"Uint32Array":Uint32Array,"Float32Array":Float32Array,"Float64Array":Float64Array,"NaN":NaN,"Infinity":Infinity,"byteLength":byteLength};Module.asmLibraryArg={"abort":abort,"assert":assert,"enlargeMemory":enlargeMemory,"getTotalMemory":getTotalMemory,"abortOnCannotGrowMemory":abortOnCannotGrowMemory,"invoke_iiiiiid":invoke_iiiiiid,"invoke_viiiiddd":invoke_viiiiddd,"invoke_viiiidiii":invoke_viiiidiii,"invoke_viiiiiddi":invoke_viiiiiddi,"invoke_viiidiii":invoke_viiidiii,"invoke_viiiidiid":invoke_viiiidiid,"invoke_iiiiiii":invoke_iiiiiii,"invoke_viiiidddiiii":invoke_viiiidddiiii,"invoke_viiiiddi":invoke_viiiiddi,"invoke_viiiddddi":invoke_viiiddddi,"invoke_viidiii":invoke_viidiii,"invoke_viiiiiiiiiii":invoke_viiiiiiiiiii,"invoke_viiiiiiiiiid":invoke_viiiiiiiiiid,"invoke_viiidddd":invoke_viiidddd,"invoke_iidi":invoke_iidi,"invoke_viiddidd":invoke_viiddidd,"invoke_vidi":invoke_vidi,"invoke_viiddii":invoke_viiddii,"invoke_viiddid":invoke_viiddid,"invoke_viiiiidi":invoke_viiiiidi,"invoke_viiddidddd":invoke_viiddidddd,"invoke_viiiiddiiii":invoke_viiiiddiiii,"invoke_viiiiiiidd":invoke_viiiiiiidd,"invoke_viiiiddiiid":invoke_viiiiddiiid,"invoke_viiiiiiidi":invoke_viiiiiiidi,"invoke_viiddi":invoke_viiddi,"invoke_viiidii":invoke_viiidii,"invoke_viiiiidd":invoke_viiiiidd,"invoke_di":invoke_di,"invoke_viiiiiidiiii":invoke_viiiiiidiiii,"invoke_viiiidiiddi":invoke_viiiidiiddi,"invoke_viiiiddiiiid":invoke_viiiiddiiiid,"invoke_viiiiddiii":invoke_viiiiddiii,"invoke_vdii":invoke_vdii,"invoke_diiiiiii":invoke_diiiiiii,"invoke_dii":invoke_dii,"invoke_viiiddiiii":invoke_viiiddiiii,"invoke_viiiddiiid":invoke_viiiddiiid,"invoke_viiiidiidd":invoke_viiiidiidd,"invoke_viiiiiiiiiiddi":invoke_viiiiiiiiiiddi,"invoke_iiiii":invoke_iiiii,"invoke_viiiiidiiiii":invoke_viiiiidiiiii,"invoke_viiidddi":invoke_viiidddi,"invoke_viiiiidiidd":invoke_viiiiidiidd,"invoke_iiiid":invoke_iiiid,"invoke_iiiiiiii":invoke_iiiiiiii,"invoke_viiddiii":invoke_viiddiii,"invoke_iiiiiiiididiii":invoke_iiiiiiiididiii,"invoke_viiidddiii":invoke_viiidddiii,"invoke_viidiiid":invoke_viidiiid,"invoke_viiiiidiiii":invoke_viiiiidiiii,"invoke_viidiiii":invoke_viidiiii,"invoke_diiiddi":invoke_diiiddi,"invoke_viiididii":invoke_viiididii,"invoke_diiiiiiii":invoke_diiiiiiii,"invoke_viiidiiid":invoke_viiidiiid,"invoke_viiiddddii":invoke_viiiddddii,"invoke_viiiiid":invoke_viiiiid,"invoke_viiiiddddii":invoke_viiiiddddii,"invoke_viiiiii":invoke_viiiiii,"invoke_viiidiiii":invoke_viiidiiii,"invoke_viiiiiidi":invoke_viiiiiidi,"invoke_viiiiiidiii":invoke_viiiiiidiii,"invoke_viiiidddii":invoke_viiiidddii,"invoke_viiidd":invoke_viiidd,"invoke_viiidi":invoke_viiidi,"invoke_iiidiiii":invoke_iiidiiii,"invoke_viiddiddd":invoke_viiddiddd,"invoke_viiiiiiiiii":invoke_viiiiiiiiii,"invoke_diiddi":invoke_diiddi,"invoke_diii":invoke_diii,"invoke_viiiddd":invoke_viiiddd,"invoke_viiiddidddd":invoke_viiiddidddd,"invoke_viiiiiiiiiiid":invoke_viiiiiiiiiiid,"invoke_viiiddidd":invoke_viiiddidd,"invoke_viiidiiiidi":invoke_viiidiiiidi,"invoke_viiiddiiiid":invoke_viiiddiiiid,"invoke_viiiddi":invoke_viiiddi,"invoke_iiiiii":invoke_iiiiii,"invoke_viiid":invoke_viiid,"invoke_viiiidddd":invoke_viiiidddd,"invoke_viidii":invoke_viidii,"invoke_iiiiid":invoke_iiiiid,"invoke_viiiidddi":invoke_viiiidddi,"invoke_viiii":invoke_viiii,"invoke_viiiii":invoke_viiiii,"invoke_viiiidiiii":invoke_viiiidiiii,"invoke_vid":invoke_vid,"invoke_iiidi":invoke_iiidi,"invoke_iiidd":invoke_iiidd,"invoke_vii":invoke_vii,"invoke_viiiid":invoke_viiiid,"invoke_viiiiddddi":invoke_viiiiddddi,"invoke_viidd":invoke_viidd,"invoke_viidi":invoke_viidi,"invoke_viiidiiddi":invoke_viiidiiddi,"invoke_diiid":invoke_diiid,"invoke_viiidddii":invoke_viiidddii,"invoke_viiiiiiii":invoke_viiiiiiii,"invoke_viiidddiiii":invoke_viiidddiiii,"invoke_viiiiiiid":invoke_viiiiiiid,"invoke_diiii":invoke_diiii,"invoke_viiiiidiiddi":invoke_viiiiidiiddi,"invoke_viiiiidii":invoke_viiiiidii,"invoke_viiiddiddd":invoke_viiiddiddd,"invoke_iid":invoke_iid,"invoke_viiiddid":invoke_viiiddid,"invoke_viiiiiii":invoke_viiiiiii,"invoke_viididdi":invoke_viididdi,"invoke_viiiiiid":invoke_viiiiiid,"invoke_viiiiiiiii":invoke_viiiiiiiii,"invoke_iii":invoke_iii,"invoke_viiiddii":invoke_viiiddii,"invoke_viiididi":invoke_viiididi,"invoke_vdiii":invoke_vdiii,"invoke_viiiiiidii":invoke_viiiiiidii,"invoke_viiiidddiii":invoke_viiiidddiii,"invoke_viii":invoke_viii,"invoke_v":invoke_v,"invoke_viid":invoke_viid,"invoke_vi":invoke_vi,"invoke_viiiidiiiidi":invoke_viiiidiiiidi,"invoke_ii":invoke_ii,"invoke_viiiiiiiddi":invoke_viiiiiiiddi,"invoke_vididdi":invoke_vididdi,"invoke_viiiiiidd":invoke_viiiiiidd,"invoke_vidii":invoke_vidii,"invoke_viiiidi":invoke_viiiidi,"invoke_viiiddiii":invoke_viiiddiii,"invoke_viiiiiidiiiii":invoke_viiiiiidiiiii,"invoke_iiii":invoke_iiii,"invoke_viididii":invoke_viididii,"invoke_viiiiddii":invoke_viiiiddii,"invoke_iiid":invoke_iiid,"invoke_viiiiiiiiidd":invoke_viiiiiiiiidd,"invoke_viiiidii":invoke_viiiidii,"invoke_diiiii":invoke_diiiii,"invoke_diiiid":invoke_diiiid,"invoke_iiiiiiiiiiiii":invoke_iiiiiiiiiiiii,"invoke_iiiiiiiiiiiiiii":invoke_iiiiiiiiiiiiiii,"invoke_viiiiiiddi":invoke_viiiiiiddi,"invoke_iiidiii":invoke_iiidiii,"invoke_i":invoke_i,"invoke_iiidii":invoke_iiidii,"invoke_diiiiii":invoke_diiiiii,"invoke_vididdii":invoke_vididdii,"invoke_viiiiidiii":invoke_viiiiidiii,"invoke_viididi":invoke_viididi,"invoke_iiiiiiiii":invoke_iiiiiiiii,"invoke_viididdii":invoke_viididdii,"invoke_viiiiidiid":invoke_viiiiidiid,"invoke_viiiidd":invoke_viiiidd,"invoke_vidiii":invoke_vidiii,"___syscall221":___syscall221,"floatReadValueFromPointer":floatReadValueFromPointer,"simpleReadValueFromPointer":simpleReadValueFromPointer,"__emval_call_void_method":__emval_call_void_method,"throwInternalError":throwInternalError,"get_first_emval":get_first_emval,"whenDependentTypesAreResolved":whenDependentTypesAreResolved,"constNoSmartPtrRawPointerToWireType":constNoSmartPtrRawPointerToWireType,"getLiveInheritedInstances":getLiveInheritedInstances,"__ZSt18uncaught_exceptionv":__ZSt18uncaught_exceptionv,"ClassHandle":ClassHandle,"getShiftFromSize":getShiftFromSize,"__emval_get_property":__emval_get_property,"_llvm_exp2_f64":_llvm_exp2_f64,"__addDays":__addDays,"_emscripten_set_main_loop_timing":_emscripten_set_main_loop_timing,"_pthread_key_delete":_pthread_key_delete,"___cxa_begin_catch":___cxa_begin_catch,"_emscripten_memcpy_big":_emscripten_memcpy_big,"runDestructor":runDestructor,"throwInstanceAlreadyDeleted":throwInstanceAlreadyDeleted,"__embind_register_std_string":__embind_register_std_string,"init_RegisteredPointer":init_RegisteredPointer,"getStringOrSymbol":getStringOrSymbol,"flushPendingDeletes":flushPendingDeletes,"_pthread_mutexattr_settype":_pthread_mutexattr_settype,"makeClassHandle":makeClassHandle,"__isLeapYear":__isLeapYear,"__embind_register_class_constructor":__embind_register_class_constructor,"___cxa_atexit":___cxa_atexit,"__embind_finalize_value_array":__embind_finalize_value_array,"__emval_allocateDestructors":__emval_allocateDestructors,"init_ClassHandle":init_ClassHandle,"__embind_register_constant":__embind_register_constant,"___syscall140":___syscall140,"ClassHandle_clone":ClassHandle_clone,"___syscall145":___syscall145,"___syscall146":___syscall146,"throwBindingError":throwBindingError,"__emval_incref":__emval_incref,"___cxa_find_matching_catch":___cxa_find_matching_catch,"__embind_register_value_object_field":__embind_register_value_object_field,"embind_init_charCodes":embind_init_charCodes,"__emval_as":__emval_as,"___setErrNo":___setErrNo,"readLatin1String":readLatin1String,"_llvm_pow_f32":_llvm_pow_f32,"__embind_register_bool":__embind_register_bool,"___resumeException":___resumeException,"createNamedFunction":createNamedFunction,"__embind_register_class_property":__embind_register_class_property,"__embind_register_emval":__embind_register_emval,"___buildEnvironment":___buildEnvironment,"__embind_finalize_value_object":__embind_finalize_value_object,"__emval_decref":__emval_decref,"_pthread_once":_pthread_once,"__embind_register_class":__embind_register_class,"___syscall91":___syscall91,"__emval_addMethodCaller":__emval_addMethodCaller,"heap32VectorToArray":heap32VectorToArray,"__emval_lookupTypes":__emval_lookupTypes,"_emscripten_get_now":_emscripten_get_now,"__emval_run_destructors":__emval_run_destructors,"ClassHandle_delete":ClassHandle_delete,"___syscall3":___syscall3,"RegisteredPointer_destructor":RegisteredPointer_destructor,"_llvm_exp2_f32":_llvm_exp2_f32,"___syscall6":___syscall6,"___syscall5":___syscall5,"ensureOverloadTable":ensureOverloadTable,"_gettimeofday":_gettimeofday,"new_":new_,"downcastPointer":downcastPointer,"_exit":_exit,"replacePublicSymbol":replacePublicSymbol,"init_embind":init_embind,"_llvm_pow_f64":_llvm_pow_f64,"ClassHandle_deleteLater":ClassHandle_deleteLater,"___syscall54":___syscall54,"_sched_yield":_sched_yield,"RegisteredPointer_deleteObject":RegisteredPointer_deleteObject,"ClassHandle_isDeleted":ClassHandle_isDeleted,"__embind_register_integer":__embind_register_integer,"___cxa_allocate_exception":___cxa_allocate_exception,"__emval_take_value":__emval_take_value,"__embind_register_value_object":__embind_register_value_object,"getTypeName":getTypeName,"_strftime":_strftime,"__embind_register_class_function":__embind_register_class_function,"RegisteredPointer":RegisteredPointer,"craftInvokerFunction":craftInvokerFunction,"_getenv":_getenv,"runDestructors":runDestructors,"requireRegisteredType":requireRegisteredType,"makeLegalFunctionName":makeLegalFunctionName,"_pthread_key_create":_pthread_key_create,"upcastPointer":upcastPointer,"init_emval":init_emval,"shallowCopyInternalPointer":shallowCopyInternalPointer,"nonConstNoSmartPtrRawPointerToWireType":nonConstNoSmartPtrRawPointerToWireType,"__embind_register_value_array":__embind_register_value_array,"_abort":_abort,"requireHandle":requireHandle,"_embind_repr":_embind_repr,"validateThis":validateThis,"exposePublicSymbol":exposePublicSymbol,"RegisteredPointer_fromWireType":RegisteredPointer_fromWireType,"___cxa_pure_virtual":___cxa_pure_virtual,"__emval_get_method_caller":__emval_get_method_caller,"_pthread_getspecific":_pthread_getspecific,"_pthread_cond_wait":_pthread_cond_wait,"___lock":___lock,"RegisteredClass":RegisteredClass,"__embind_register_memory_view":__embind_register_memory_view,"getInheritedInstance":getInheritedInstance,"setDelayFunction":setDelayFunction,"___gxx_personality_v0":___gxx_personality_v0,"extendError":extendError,"___syscall4":___syscall4,"__embind_register_value_array_element":__embind_register_value_array_element,"__emval_new_array":__emval_new_array,"__embind_register_void":__embind_register_void,"__embind_register_smart_ptr":__embind_register_smart_ptr,"__embind_register_function":__embind_register_function,"_pthread_mutexattr_destroy":_pthread_mutexattr_destroy,"_strftime_l":_strftime_l,"RegisteredPointer_getPointee":RegisteredPointer_getPointee,"__emval_register":__emval_register,"__embind_register_std_wstring":__embind_register_std_wstring,"ClassHandle_isAliasOf":ClassHandle_isAliasOf,"__exit":__exit,"throwUnboundTypeError":throwUnboundTypeError,"__arraySum":__arraySum,"__embind_register_class_class_function":__embind_register_class_class_function,"_pthread_mutex_destroy":_pthread_mutex_destroy,"getBasestPointer":getBasestPointer,"getInheritedInstanceCount":getInheritedInstanceCount,"__embind_register_float":__embind_register_float,"integerReadValueFromPointer":integerReadValueFromPointer,"___unlock":___unlock,"_emscripten_set_main_loop":_emscripten_set_main_loop,"_pthread_mutexattr_init":_pthread_mutexattr_init,"_pthread_setspecific":_pthread_setspecific,"genericPointerToWireType":genericPointerToWireType,"registerType":registerType,"___cxa_throw":___cxa_throw,"__emval_new_cstring":__emval_new_cstring,"count_emval_handles":count_emval_handles,"requireFunction":requireFunction,"_atexit":_atexit,"_pthread_mutex_init":_pthread_mutex_init,"___map_file":___map_file,"DYNAMICTOP_PTR":DYNAMICTOP_PTR,"tempDoublePtr":tempDoublePtr,"ABORT":ABORT,"STACKTOP":STACKTOP,"STACK_MAX":STACK_MAX,"cttz_i8":cttz_i8,"___dso_handle":___dso_handle};// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer) {
"almost asm";var a=global.Int8Array;var b=new a(buffer);var c=global.Int16Array;var d=new c(buffer);var e=global.Int32Array;var f=new e(buffer);var g=global.Uint8Array;var h=new g(buffer);var i=global.Uint16Array;var j=new i(buffer);var k=global.Uint32Array;var l=new k(buffer);var m=global.Float32Array;var n=new m(buffer);var o=global.Float64Array;var p=new o(buffer);var q=global.byteLength;var r=env.DYNAMICTOP_PTR|0;var s=env.tempDoublePtr|0;var t=env.ABORT|0;var u=env.STACKTOP|0;var v=env.STACK_MAX|0;var w=env.cttz_i8|0;var x=env.___dso_handle|0;var y=0;var z=0;var A=0;var B=0;var C=global.NaN,D=global.Infinity;var E=0,F=0,G=0,H=0,I=0.0;var J=0;var K=global.Math.floor;var L=global.Math.abs;var M=global.Math.sqrt;var N=global.Math.pow;var O=global.Math.cos;var P=global.Math.sin;var Q=global.Math.tan;var R=global.Math.acos;var S=global.Math.asin;var T=global.Math.atan;var U=global.Math.atan2;var V=global.Math.exp;var W=global.Math.log;var X=global.Math.ceil;var Y=global.Math.imul;var Z=global.Math.min;var _=global.Math.max;var $=global.Math.clz32;var aa=env.abort;var ba=env.assert;var ca=env.enlargeMemory;var da=env.getTotalMemory;var ea=env.abortOnCannotGrowMemory;var fa=env.invoke_iiiiiid;var ga=env.invoke_viiiiddd;var ha=env.invoke_viiiidiii;var ia=env.invoke_viiiiiddi;var ja=env.invoke_viiidiii;var ka=env.invoke_viiiidiid;var la=env.invoke_iiiiiii;var ma=env.invoke_viiiidddiiii;var na=env.invoke_viiiiddi;var oa=env.invoke_viiiddddi;var pa=env.invoke_viidiii;var qa=env.invoke_viiiiiiiiiii;var ra=env.invoke_viiiiiiiiiid;var sa=env.invoke_viiidddd;var ta=env.invoke_iidi;var ua=env.invoke_viiddidd;var va=env.invoke_vidi;var wa=env.invoke_viiddii;var xa=env.invoke_viiddid;var ya=env.invoke_viiiiidi;var za=env.invoke_viiddidddd;var Aa=env.invoke_viiiiddiiii;var Ba=env.invoke_viiiiiiidd;var Ca=env.invoke_viiiiddiiid;var Da=env.invoke_viiiiiiidi;var Ea=env.invoke_viiddi;var Fa=env.invoke_viiidii;var Ga=env.invoke_viiiiidd;var Ha=env.invoke_di;var Ia=env.invoke_viiiiiidiiii;var Ja=env.invoke_viiiidiiddi;var Ka=env.invoke_viiiiddiiiid;var La=env.invoke_viiiiddiii;var Ma=env.invoke_vdii;var Na=env.invoke_diiiiiii;var Oa=env.invoke_dii;var Pa=env.invoke_viiiddiiii;var Qa=env.invoke_viiiddiiid;var Ra=env.invoke_viiiidiidd;var Sa=env.invoke_viiiiiiiiiiddi;var Ta=env.invoke_iiiii;var Ua=env.invoke_viiiiidiiiii;var Va=env.invoke_viiidddi;var Wa=env.invoke_viiiiidiidd;var Xa=env.invoke_iiiid;var Ya=env.invoke_iiiiiiii;var Za=env.invoke_viiddiii;var _a=env.invoke_iiiiiiiididiii;var $a=env.invoke_viiidddiii;var ab=env.invoke_viidiiid;var bb=env.invoke_viiiiidiiii;var cb=env.invoke_viidiiii;var db=env.invoke_diiiddi;var eb=env.invoke_viiididii;var fb=env.invoke_diiiiiiii;var gb=env.invoke_viiidiiid;var hb=env.invoke_viiiddddii;var ib=env.invoke_viiiiid;var jb=env.invoke_viiiiddddii;var kb=env.invoke_viiiiii;var lb=env.invoke_viiidiiii;var mb=env.invoke_viiiiiidi;var nb=env.invoke_viiiiiidiii;var ob=env.invoke_viiiidddii;var pb=env.invoke_viiidd;var qb=env.invoke_viiidi;var rb=env.invoke_iiidiiii;var sb=env.invoke_viiddiddd;var tb=env.invoke_viiiiiiiiii;var ub=env.invoke_diiddi;var vb=env.invoke_diii;var wb=env.invoke_viiiddd;var xb=env.invoke_viiiddidddd;var yb=env.invoke_viiiiiiiiiiid;var zb=env.invoke_viiiddidd;var Ab=env.invoke_viiidiiiidi;var Bb=env.invoke_viiiddiiiid;var Cb=env.invoke_viiiddi;var Db=env.invoke_iiiiii;var Eb=env.invoke_viiid;var Fb=env.invoke_viiiidddd;var Gb=env.invoke_viidii;var Hb=env.invoke_iiiiid;var Ib=env.invoke_viiiidddi;var Jb=env.invoke_viiii;var Kb=env.invoke_viiiii;var Lb=env.invoke_viiiidiiii;var Mb=env.invoke_vid;var Nb=env.invoke_iiidi;var Ob=env.invoke_iiidd;var Pb=env.invoke_vii;var Qb=env.invoke_viiiid;var Rb=env.invoke_viiiiddddi;var Sb=env.invoke_viidd;var Tb=env.invoke_viidi;var Ub=env.invoke_viiidiiddi;var Vb=env.invoke_diiid;var Wb=env.invoke_viiidddii;var Xb=env.invoke_viiiiiiii;var Yb=env.invoke_viiidddiiii;var Zb=env.invoke_viiiiiiid;var _b=env.invoke_diiii;var $b=env.invoke_viiiiidiiddi;var ac=env.invoke_viiiiidii;var bc=env.invoke_viiiddiddd;var cc=env.invoke_iid;var dc=env.invoke_viiiddid;var ec=env.invoke_viiiiiii;var fc=env.invoke_viididdi;var gc=env.invoke_viiiiiid;var hc=env.invoke_viiiiiiiii;var ic=env.invoke_iii;var jc=env.invoke_viiiddii;var kc=env.invoke_viiididi;var lc=env.invoke_vdiii;var mc=env.invoke_viiiiiidii;var nc=env.invoke_viiiidddiii;var oc=env.invoke_viii;var pc=env.invoke_v;var qc=env.invoke_viid;var rc=env.invoke_vi;var sc=env.invoke_viiiidiiiidi;var tc=env.invoke_ii;var uc=env.invoke_viiiiiiiddi;var vc=env.invoke_vididdi;var wc=env.invoke_viiiiiidd;var xc=env.invoke_vidii;var yc=env.invoke_viiiidi;var zc=env.invoke_viiiddiii;var Ac=env.invoke_viiiiiidiiiii;var Bc=env.invoke_iiii;var Cc=env.invoke_viididii;var Dc=env.invoke_viiiiddii;var Ec=env.invoke_iiid;var Fc=env.invoke_viiiiiiiiidd;var Gc=env.invoke_viiiidii;var Hc=env.invoke_diiiii;var Ic=env.invoke_diiiid;var Jc=env.invoke_iiiiiiiiiiiii;var Kc=env.invoke_iiiiiiiiiiiiiii;var Lc=env.invoke_viiiiiiddi;var Mc=env.invoke_iiidiii;var Nc=env.invoke_i;var Oc=env.invoke_iiidii;var Pc=env.invoke_diiiiii;var Qc=env.invoke_vididdii;var Rc=env.invoke_viiiiidiii;var Sc=env.invoke_viididi;var Tc=env.invoke_iiiiiiiii;var Uc=env.invoke_viididdii;var Vc=env.invoke_viiiiidiid;var Wc=env.invoke_viiiidd;var Xc=env.invoke_vidiii;var Yc=env.___syscall221;var Zc=env.floatReadValueFromPointer;var _c=env.simpleReadValueFromPointer;var $c=env.__emval_call_void_method;var ad=env.throwInternalError;var bd=env.get_first_emval;var cd=env.whenDependentTypesAreResolved;var dd=env.constNoSmartPtrRawPointerToWireType;var ed=env.getLiveInheritedInstances;var fd=env.__ZSt18uncaught_exceptionv;var gd=env.ClassHandle;var hd=env.getShiftFromSize;var id=env.__emval_get_property;var jd=env._llvm_exp2_f64;var kd=env.__addDays;var ld=env._emscripten_set_main_loop_timing;var md=env._pthread_key_delete;var nd=env.___cxa_begin_catch;var od=env._emscripten_memcpy_big;var pd=env.runDestructor;var qd=env.throwInstanceAlreadyDeleted;var rd=env.__embind_register_std_string;var sd=env.init_RegisteredPointer;var td=env.getStringOrSymbol;var ud=env.flushPendingDeletes;var vd=env._pthread_mutexattr_settype;var wd=env.makeClassHandle;var xd=env.__isLeapYear;var yd=env.__embind_register_class_constructor;var zd=env.___cxa_atexit;var Ad=env.__embind_finalize_value_array;var Bd=env.__emval_allocateDestructors;var Cd=env.init_ClassHandle;var Dd=env.__embind_register_constant;var Ed=env.___syscall140;var Fd=env.ClassHandle_clone;var Gd=env.___syscall145;var Hd=env.___syscall146;var Id=env.throwBindingError;var Jd=env.__emval_incref;var Kd=env.___cxa_find_matching_catch;var Ld=env.__embind_register_value_object_field;var Md=env.embind_init_charCodes;var Nd=env.__emval_as;var Od=env.___setErrNo;var Pd=env.readLatin1String;var Qd=env._llvm_pow_f32;var Rd=env.__embind_register_bool;var Sd=env.___resumeException;var Td=env.createNamedFunction;var Ud=env.__embind_register_class_property;var Vd=env.__embind_register_emval;var Wd=env.___buildEnvironment;var Xd=env.__embind_finalize_value_object;var Yd=env.__emval_decref;var Zd=env._pthread_once;var _d=env.__embind_register_class;var $d=env.___syscall91;var ae=env.__emval_addMethodCaller;var be=env.heap32VectorToArray;var ce=env.__emval_lookupTypes;var de=env._emscripten_get_now;var ee=env.__emval_run_destructors;var fe=env.ClassHandle_delete;var ge=env.___syscall3;var he=env.RegisteredPointer_destructor;var ie=env._llvm_exp2_f32;var je=env.___syscall6;var ke=env.___syscall5;var le=env.ensureOverloadTable;var me=env._gettimeofday;var ne=env.new_;var oe=env.downcastPointer;var pe=env._exit;var qe=env.replacePublicSymbol;var re=env.init_embind;var se=env._llvm_pow_f64;var te=env.ClassHandle_deleteLater;var ue=env.___syscall54;var ve=env._sched_yield;var we=env.RegisteredPointer_deleteObject;var xe=env.ClassHandle_isDeleted;var ye=env.__embind_register_integer;var ze=env.___cxa_allocate_exception;var Ae=env.__emval_take_value;var Be=env.__embind_register_value_object;var Ce=env.getTypeName;var De=env._strftime;var Ee=env.__embind_register_class_function;var Fe=env.RegisteredPointer;var Ge=env.craftInvokerFunction;var He=env._getenv;var Ie=env.runDestructors;var Je=env.requireRegisteredType;var Ke=env.makeLegalFunctionName;var Le=env._pthread_key_create;var Me=env.upcastPointer;var Ne=env.init_emval;var Oe=env.shallowCopyInternalPointer;var Pe=env.nonConstNoSmartPtrRawPointerToWireType;var Qe=env.__embind_register_value_array;var Re=env._abort;var Se=env.requireHandle;var Te=env._embind_repr;var Ue=env.validateThis;var Ve=env.exposePublicSymbol;var We=env.RegisteredPointer_fromWireType;var Xe=env.___cxa_pure_virtual;var Ye=env.__emval_get_method_caller;var Ze=env._pthread_getspecific;var _e=env._pthread_cond_wait;var $e=env.___lock;var af=env.RegisteredClass;var bf=env.__embind_register_memory_view;var cf=env.getInheritedInstance;var df=env.setDelayFunction;var ef=env.___gxx_personality_v0;var ff=env.extendError;var gf=env.___syscall4;var hf=env.__embind_register_value_array_element;var jf=env.__emval_new_array;var kf=env.__embind_register_void;var lf=env.__embind_register_smart_ptr;var mf=env.__embind_register_function;var nf=env._pthread_mutexattr_destroy;var of=env._strftime_l;var pf=env.RegisteredPointer_getPointee;var qf=env.__emval_register;var rf=env.__embind_register_std_wstring;var sf=env.ClassHandle_isAliasOf;var tf=env.__exit;var uf=env.throwUnboundTypeError;var vf=env.__arraySum;var wf=env.__embind_register_class_class_function;var xf=env._pthread_mutex_destroy;var yf=env.getBasestPointer;var zf=env.getInheritedInstanceCount;var Af=env.__embind_register_float;var Bf=env.integerReadValueFromPointer;var Cf=env.___unlock;var Df=env._emscripten_set_main_loop;var Ef=env._pthread_mutexattr_init;var Ff=env._pthread_setspecific;var Gf=env.genericPointerToWireType;var Hf=env.registerType;var If=env.___cxa_throw;var Jf=env.__emval_new_cstring;var Kf=env.count_emval_handles;var Lf=env.requireFunction;var Mf=env._atexit;var Nf=env._pthread_mutex_init;var Of=env.___map_file;var Pf=0.0;function Qf(newBuffer){if(q(newBuffer)&16777215||q(newBuffer)<=16777215||q(newBuffer)>2147483648)return false;b=new a(newBuffer);d=new c(newBuffer);f=new e(newBuffer);h=new g(newBuffer);j=new i(newBuffer);l=new k(newBuffer);n=new m(newBuffer);p=new o(newBuffer);buffer=newBuffer;return true}
// EMSCRIPTEN_START_FUNCS
function Ii(a){a=a|0;var b=0;b=u;u=u+a|0;u=u+15&-16;return b|0}function Ji(){return u|0}function Ki(a){a=a|0;u=a}function Li(a,b){a=a|0;b=b|0;u=a;v=b}function Mi(a,b){a=a|0;b=b|0;if(!y){y=a;z=b}}function Ni(a){a=a|0;J=a}function Oi(){return J|0}function Pi(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;f=L5b(56)|0;Qi(f,a,b,c,d,e);return f|0}function Qi(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;i=u;u=u+16|0;j=i;f[a>>2]=e&4095|1124007936;f[a+4>>2]=2;k=a+8|0;f[k>>2]=c;l=a+12|0;f[l>>2]=d;f[a+16>>2]=g;m=a+20|0;f[m>>2]=g;n=a+24|0;o=a+28|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[a+40>>2]=k;p=a+48|0;q=a+44|0;f[q>>2]=p;f[a+52>>2]=0;f[p>>2]=0;if((Y(d,c)|0)!=0&(g|0)==0){f[j>>2]=0;f[j+4>>2]=0;r=aD(j,26)|0;s=426262;t=r+26|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,j,426289,431198,500);bD(j);v=f[l>>2]|0}else v=d;d=e&7;l=(e>>>3&511)+1<<(47696>>>(d<<1)&3);e=Y(v,l)|0;if(h){if((h>>>0)%((1212424721>>>(d<<2)&15)>>>0)|0|0){f[j>>2]=0;f[j+4>>2]=0;r=aD(j,31)|0;s=179428;t=r+31|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-13,j,426289,431198,515);bD(j)}if((e|0)!=(h|0)?(f[k>>2]|0)!=1:0){w=h;x=f[q>>2]|0;f[x>>2]=w;y=x+4|0;f[y>>2]=l;z=f[m>>2]|0;A=f[k>>2]|0;B=Y(A,w)|0;C=z+B|0;f[o>>2]=C;D=0-w|0;E=C+D|0;F=E+e|0;f[n>>2]=F;u=i;return}else G=h}else G=e;f[a>>2]=f[a>>2]|16384;w=G;x=f[q>>2]|0;f[x>>2]=w;y=x+4|0;f[y>>2]=l;z=f[m>>2]|0;A=f[k>>2]|0;B=Y(A,w)|0;C=z+B|0;f[o>>2]=C;D=0-w|0;E=C+D|0;F=E+e|0;f[n>>2]=F;u=i;return}function Ri(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;i=h+8|0;f[i>>2]=0;f[i+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;OJ(a,h,c,d,e);u=g;return}function Si(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;OJ(a,e,c,1.0,0.0);u=d;return}function Ti(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=g+8|0;f[h>>2]=0;f[h+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;OJ(a,g,c,d,0.0);u=e;return}function Ui(a,b){a=a|0;b=b|0;var c=0;c=f[b+40>>2]|0;b=f[c>>2]|0;f[a>>2]=f[c+4>>2];f[a+4>>2]=b;return}function Vi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+224|0;g=e;QS(g,b,c,d);f[a>>2]=1124007936;d=a+8|0;c=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[c>>2]=d;d=a+48|0;f[a+44>>2]=d;f[d>>2]=0;f[a+52>>2]=0;d=f[g>>2]|0;th[f[(f[d>>2]|0)+12>>2]&511](d,g,a,-1);Wi(g);u=e;return}function Wi(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+120|0;c=a+156|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+136|0;b=a+124|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+160>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+164>>2]|0;if((b|0)!=(a+168|0))UC(b);b=a+64|0;d=a+100|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+80|0;b=a+68|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+104>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+108>>2]|0;if((b|0)!=(a+112|0))UC(b);b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0))return;UC(b);return}function Xi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+240|0;e=d;g=d+224|0;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];SS(e,g,c);f[a>>2]=1124007936;c=a+8|0;g=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[g>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;th[f[(f[c>>2]|0)+12>>2]&511](c,e,a,-1);Wi(e);u=d;return}function Yi(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+224|0;g=e;TS(g,b,c,d);f[a>>2]=1124007936;d=a+8|0;c=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[c>>2]=d;d=a+48|0;f[a+44>>2]=d;f[d>>2]=0;f[a+52>>2]=0;d=f[g>>2]|0;th[f[(f[d>>2]|0)+12>>2]&511](d,g,a,-1);Wi(g);u=e;return}function Zi(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+240|0;e=d;g=d+224|0;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];US(e,g,c);f[a>>2]=1124007936;c=a+8|0;g=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[g>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;th[f[(f[c>>2]|0)+12>>2]&511](c,e,a,-1);Wi(e);u=d;return}function _i(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;e=+pY(a,d);u=c;return +e}function $i(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+240|0;g=e;h=e+224|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;PS(g,b,h,d);f[a>>2]=1124007936;h=a+8|0;b=a+40|0;c=a+4|0;i=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(i|0));f[b>>2]=h;h=a+48|0;f[a+44>>2]=h;f[h>>2]=0;f[a+52>>2]=0;h=f[g>>2]|0;th[f[(f[h>>2]|0)+12>>2]&511](h,g,a,-1);Wi(g);u=e;return}function aj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+224|0;d=c;NS(d,b);f[a>>2]=1124007936;b=a+8|0;e=a+40|0;g=a+4|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=b;b=a+48|0;f[a+44>>2]=b;f[b>>2]=0;f[a+52>>2]=0;b=f[d>>2]|0;th[f[(f[b>>2]|0)+12>>2]&511](b,d,a,-1);Wi(d);u=c;return}function bj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+224|0;e=d;OS(e,b,c);f[a>>2]=1124007936;c=a+8|0;b=a+40|0;g=a+4|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[b>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;th[f[(f[c>>2]|0)+12>>2]&511](c,e,a,-1);Wi(e);u=d;return}function cj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=b;SP(a,d);u=c;return}function dj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=e+8|0;f[h>>2]=0;f[h+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;TP(a,e,g);u=d;return}function ej(a,b,c){a=a|0;b=b|0;c=c|0;rL(a,b,c);return}function fj(a,b){a=a|0;b=b|0;rL(a,b,0);return}function gj(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=-1056833530;f[d+4>>2]=b;f[d+8>>2]=1;f[d+12>>2]=4;VP(a,d,UM()|0)|0;u=c;return}function hj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e>>2]=-1056833530;f[e+4>>2]=b;f[e+8>>2]=1;f[e+12>>2]=4;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;VP(a,e,g)|0;u=d;return}function ij(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;VN(b,d);b=jf()|0;f[a>>2]=b;Ir(b,154182,d);Ir(b,154182,d+8|0);Ir(b,154182,d+16|0);Ir(b,154182,d+24|0);u=c;return}function jj(a,b){a=a|0;b=b|0;WN(a,b);return}function kj(a,b){a=a|0;b=b|0;XN(a,b);return}function lj(a){a=a|0;return a&7|0}function mj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=a+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;KG(e,a,a+8|0,a+16|0,a+24|0,g);u=d;return}function nj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;KG(d,a,a+8|0,a+16|0,a+24|0,UM()|0);u=c;return}function oj(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;n[a>>2]=0.0;n[a+4>>2]=0.0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;dea(d,a,a+8|0);u=c;return}function pj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+64|0;g=e;h=e+32|0;i=e+16|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];Jsa(h,i,c,g);g=jf()|0;f[a>>2]=g;Jr(g,154182,h);Kr(g,154182,c);u=e;return}function qj(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g;i=g+16|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];e=Isa(i,d,h)|0;i=jf()|0;f[a>>2]=i;if((b[491032]|0)==0?Cac(491032)|0:0){c=Ye(2,25672)|0;f[125005]=c}c=f[125005]|0;f[h>>2]=e;$c(c|0,i|0,154182,h|0);Kr(f[a>>2]|0,154182,d);u=g;return}function rj(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=f[c+4>>2]|0;e=f[c+8>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(e>>>0>4294967279)V5b(a);if(e>>>0<11){b[a+11>>0]=e;if(!e){g=a;h=g+e|0;b[h>>0]=0;return}else i=a}else{c=e+16&-16;j=L5b(c)|0;f[a>>2]=j;f[a+8>>2]=c|-2147483648;f[a+4>>2]=e;i=j}Vac(i|0,d|0,e|0)|0;g=i;h=g+e|0;b[h>>0]=0;return}function sj(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=a+4|0;bD(d);a=c+11|0;e=b[a>>0]|0;g=e<<24>>24<0?f[c+4>>2]|0:e&255;if(!g)return;e=aD(d,g)|0;Vac(e|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,g|0)|0;return}function tj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=b;f[a>>2]=42900;b=f[c+4>>2]|0;f[a+4>>2]=b;f[a+8>>2]=f[c+8>>2];if(b|0){d=b+-4|0;f[d>>2]=(f[d>>2]|0)+1}f[a+12>>2]=f[c+12>>2];d=f[c+16>>2]|0;f[a+16>>2]=d;f[a+20>>2]=f[c+20>>2];if(d|0){b=d+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c+24>>2]|0;f[a+24>>2]=b;f[a+28>>2]=f[c+28>>2];if(b|0){d=b+-4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[c+32>>2]|0;f[a+32>>2]=d;f[a+36>>2]=f[c+36>>2];if(!d){e=a+40|0;g=c+40|0;h=f[g>>2]|0;f[e>>2]=h;return}b=d+-4|0;f[b>>2]=(f[b>>2]|0)+1;e=a+40|0;g=c+40|0;h=f[g>>2]|0;f[e>>2]=h;return}function uj(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=KO()|0;d=f[c>>2]|0;e=f[c+4>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(e>>>0>4294967279)V5b(a);if(e>>>0<11){b[a+11>>0]=e;if(!e){g=a;h=g+e|0;b[h>>0]=0;return}else i=a}else{c=e+16&-16;j=L5b(c)|0;f[a>>2]=j;f[a+8>>2]=c|-2147483648;f[a+4>>2]=e;i=j}Vac(i|0,d|0,e|0)|0;g=i;h=g+e|0;b[h>>0]=0;return}function vj(a){a=a|0;var b=0;wj(154187);xj(154197);yj(154209);zj(154222);Aj(154234);Bj(154244);_d(8704,8792,8808,0,167033,641,167036,0,167036,0,426289,167038,1420);yd(8704,1,26088,167033,642,1);yd(8704,2,26092,167052,475,643);yd(8704,3,26100,167075,230,476);yd(8704,4,26112,167080,39,231);yd(8704,5,26128,168179,90,40);yd(8704,6,26148,168186,70,91);wf(8704,154255,3,26172,167075,232,114);wf(8704,154255,4,26184,167080,41,184);wf(8704,154259,3,26172,167075,232,115);wf(8704,154259,4,26184,167080,41,185);wf(8704,154264,3,26172,167075,232,116);wf(8704,154264,4,26184,167080,41,186);a=L5b(4)|0;f[a>>2]=8;b=L5b(4)|0;f[b>>2]=8;Ud(8704,208386,25568,167052,477,a|0,25568,167041,117,b|0);b=L5b(4)|0;f[b>>2]=12;a=L5b(4)|0;f[a>>2]=12;Ud(8704,208391,25568,167052,477,b|0,25568,167041,117,a|0);a=L5b(4)|0;f[a>>2]=876;Ud(8704,154270,8368,167052,478,a|0,0,0,0,0);a=L5b(4)|0;f[a>>2]=877;Ud(8704,154278,8368,167052,478,a|0,0,0,0,0);a=L5b(4)|0;f[a>>2]=878;Ud(8704,377867,8368,167052,478,a|0,0,0,0,0);a=L5b(4)|0;f[a>>2]=879;Ud(8704,154283,8368,167052,478,a|0,0,0,0,0);a=L5b(4)|0;f[a>>2]=880;Ud(8704,154290,8368,167052,478,a|0,0,0,0,0);a=L5b(4)|0;f[a>>2]=881;Ud(8704,154298,8368,167052,478,a|0,0,0,0,0);a=L5b(4)|0;f[a>>2]=882;Ud(8704,154306,8368,167052,478,a|0,0,0,0,0);a=L5b(4)|0;f[a>>2]=883;Ud(8704,154314,8368,167052,478,a|0,0,0,0,0);a=L5b(4)|0;f[a>>2]=884;Ud(8704,154322,8368,167052,478,a|0,0,0,0,0);a=L5b(8)|0;f[a>>2]=644;f[a+4>>2]=0;Ee(8704,154330,2,26200,167052,479,a|0,0);a=L5b(8)|0;f[a>>2]=645;f[a+4>>2]=0;Ee(8704,154339,2,26200,167052,479,a|0,0);a=L5b(8)|0;f[a>>2]=646;f[a+4>>2]=0;Ee(8704,154349,2,26208,167052,480,a|0,0);a=L5b(4)|0;f[a>>2]=1;Ee(8704,178761,6,26216,168411,1,a|0,0);a=L5b(4)|0;f[a>>2]=118;Ee(8704,178761,4,26240,167046,187,a|0,0);a=L5b(4)|0;f[a>>2]=6;Ee(8704,178761,5,26256,168419,5,a|0,0);a=L5b(8)|0;f[a>>2]=647;f[a+4>>2]=0;Ee(8704,442657,2,26200,167052,479,a|0,0);a=L5b(8)|0;f[a>>2]=119;f[a+4>>2]=0;Ee(8704,154358,3,26276,167075,233,a|0,0);a=L5b(8)|0;f[a>>2]=188;f[a+4>>2]=0;Ee(8704,440241,5,26288,168426,95,a|0,0);a=L5b(8)|0;f[a>>2]=120;f[a+4>>2]=0;Ee(8704,440241,4,26308,167046,189,a|0,0);a=L5b(8)|0;f[a>>2]=190;f[a+4>>2]=0;Ee(8704,154362,4,26324,167080,42,a|0,0);a=L5b(8)|0;f[a>>2]=121;f[a+4>>2]=0;Ee(8704,154362,3,26340,167075,234,a|0,0);a=L5b(4)|0;f[a>>2]=885;Ee(8704,192311,3,26352,167041,122,a|0,0);a=L5b(4)|0;f[a>>2]=123;Ee(8704,192311,4,26364,167046,191,a|0,0);a=L5b(8)|0;f[a>>2]=648;f[a+4>>2]=0;Ee(8704,365923,2,26208,167052,480,a|0,0);a=L5b(8)|0;f[a>>2]=649;f[a+4>>2]=0;Ee(8704,183315,2,26380,167052,481,a|0,0);a=L5b(8)|0;f[a>>2]=192;f[a+4>>2]=0;Ee(8704,154371,4,26324,167080,42,a|0,0);a=L5b(8)|0;f[a>>2]=124;f[a+4>>2]=0;Ee(8704,154371,3,26340,167075,234,a|0,0);a=L5b(8)|0;f[a>>2]=482;f[a+4>>2]=0;Ee(8704,154380,3,26388,167075,235,a|0,0);a=L5b(8)|0;f[a>>2]=886;f[a+4>>2]=0;Ee(8704,154386,2,26400,167052,483,a|0,0);a=L5b(8)|0;f[a>>2]=650;f[a+4>>2]=0;Ee(8704,154392,2,26208,167052,480,a|0,0);a=L5b(8)|0;f[a>>2]=125;f[a+4>>2]=0;Ee(8704,154398,3,26276,167075,233,a|0,0);a=L5b(4)|0;f[a>>2]=5;Ee(8704,213434,3,26408,168445,10,a|0,0);a=L5b(4)|0;f[a>>2]=7;Ee(8704,154402,4,26420,167424,1,a|0,0);a=L5b(4)|0;f[a>>2]=126;Ee(8704,154406,3,26436,167075,236,a|0,0);a=L5b(4)|0;f[a>>2]=887;Ee(8704,476465,2,26448,167052,484,a|0,0);a=L5b(8)|0;f[a>>2]=127;f[a+4>>2]=0;Ee(8704,208535,3,26456,167075,237,a|0,0);a=L5b(4)|0;f[a>>2]=128;Ee(8704,180266,3,26436,167075,236,a|0,0);a=L5b(4)|0;f[a>>2]=888;Ee(8704,180266,2,26448,167052,484,a|0,0);a=L5b(8)|0;f[a>>2]=651;f[a+4>>2]=0;Ee(8704,183343,2,26380,167052,481,a|0,0);a=L5b(4)|0;f[a>>2]=889;Ee(8704,192704,3,26468,167041,129,a|0,0);a=L5b(4)|0;f[a>>2]=130;Ee(8704,192704,4,26480,167046,193,a|0,0);a=L5b(4)|0;f[a>>2]=890;Ee(8704,429353,2,26496,167052,485,a|0,0);a=L5b(4)|0;f[a>>2]=131;Ee(8704,154410,3,26504,167075,238,a|0,0);a=L5b(4)|0;f[a>>2]=194;Ee(8704,154410,4,26516,167080,43,a|0,0);a=L5b(4)|0;f[a>>2]=131;Ee(8704,154414,3,26504,167075,238,a|0,0);a=L5b(4)|0;f[a>>2]=194;Ee(8704,154414,4,26516,167080,43,a|0,0);a=L5b(4)|0;f[a>>2]=132;Ee(8704,154423,3,26504,167075,238,a|0,0);a=L5b(4)|0;f[a>>2]=195;Ee(8704,154423,4,26516,167080,43,a|0,0);a=L5b(4)|0;f[a>>2]=133;Ee(8704,154431,3,26504,167075,238,a|0,0);a=L5b(4)|0;f[a>>2]=196;Ee(8704,154431,4,26516,167080,43,a|0,0);a=L5b(4)|0;f[a>>2]=134;Ee(8704,154440,3,26504,167075,238,a|0,0);a=L5b(4)|0;f[a>>2]=197;Ee(8704,154440,4,26516,167080,43,a|0,0);a=L5b(4)|0;f[a>>2]=135;Ee(8704,154450,3,26504,167075,238,a|0,0);a=L5b(4)|0;f[a>>2]=198;Ee(8704,154450,4,26516,167080,43,a|0,0);a=L5b(4)|0;f[a>>2]=136;Ee(8704,154457,3,26504,167075,238,a|0,0);a=L5b(4)|0;f[a>>2]=199;Ee(8704,154457,4,26516,167080,43,a|0,0);a=L5b(4)|0;f[a>>2]=137;Ee(8704,154466,3,26504,167075,238,a|0,0);a=L5b(4)|0;f[a>>2]=200;Ee(8704,154466,4,26516,167080,43,a|0,0);a=L5b(8)|0;f[a>>2]=486;f[a+4>>2]=0;Ee(8704,154476,3,26532,167075,239,a|0,0);a=L5b(8)|0;f[a>>2]=240;f[a+4>>2]=0;Ee(8704,154476,4,26544,167080,44,a|0,0);a=L5b(8)|0;f[a>>2]=45;f[a+4>>2]=0;Ee(8704,154476,5,26560,168179,92,a|0,0);a=L5b(8)|0;f[a>>2]=487;f[a+4>>2]=0;Ee(8704,154483,3,26580,167075,241,a|0,0);a=L5b(8)|0;f[a>>2]=242;f[a+4>>2]=0;Ee(8704,154483,4,26592,167080,46,a|0,0);a=L5b(8)|0;f[a>>2]=47;f[a+4>>2]=0;Ee(8704,154483,5,26608,168179,93,a|0,0);a=L5b(8)|0;f[a>>2]=488;f[a+4>>2]=0;Ee(8704,154491,3,26628,167075,243,a|0,0);a=L5b(8)|0;f[a>>2]=244;f[a+4>>2]=0;Ee(8704,154491,4,26640,167080,48,a|0,0);a=L5b(8)|0;f[a>>2]=49;f[a+4>>2]=0;Ee(8704,154491,5,26656,168179,94,a|0,0);a=L5b(8)|0;f[a>>2]=489;f[a+4>>2]=0;Ee(8704,154499,3,26676,167075,245,a|0,0);a=L5b(8)|0;f[a>>2]=246;f[a+4>>2]=0;Ee(8704,154499,4,26688,167080,50,a|0,0);a=L5b(8)|0;f[a>>2]=51;f[a+4>>2]=0;Ee(8704,154499,5,26704,168179,95,a|0,0);a=L5b(8)|0;f[a>>2]=490;f[a+4>>2]=0;Ee(8704,154508,3,26724,167075,247,a|0,0);a=L5b(8)|0;f[a>>2]=248;f[a+4>>2]=0;Ee(8704,154508,4,26736,167080,52,a|0,0);a=L5b(8)|0;f[a>>2]=53;f[a+4>>2]=0;Ee(8704,154508,5,26752,168179,96,a|0,0);a=L5b(8)|0;f[a>>2]=491;f[a+4>>2]=0;Ee(8704,154514,3,26772,168450,11,a|0,0);a=L5b(8)|0;f[a>>2]=249;f[a+4>>2]=0;Ee(8704,154514,4,26784,168455,3,a|0,0);a=L5b(8)|0;f[a>>2]=54;f[a+4>>2]=0;Ee(8704,154514,5,26800,168461,1,a|0,0);a=L5b(8)|0;f[a>>2]=55;f[a+4>>2]=0;Ee(8704,154522,5,26820,168468,2,a|0,0);a=L5b(8)|0;f[a>>2]=492;f[a+4>>2]=0;Ee(8704,154522,3,26840,168445,12,a|0,0);a=L5b(8)|0;f[a>>2]=250;f[a+4>>2]=0;Ee(8704,154522,4,26852,168475,4,a|0,0);Be(8928,154531,207089,2,167038,1421);a=L5b(4)|0;f[a>>2]=0;b=L5b(4)|0;f[b>>2]=0;Ld(8928,242255,25568,167052,493,a|0,25568,167041,138,b|0);b=L5b(4)|0;f[b>>2]=4;a=L5b(4)|0;f[a>>2]=4;Ld(8928,426575,25568,167052,493,b|0,25568,167041,138,a|0);Xd(8928);Be(8936,154537,207089,3,167038,1422);a=L5b(4)|0;f[a>>2]=0;b=L5b(4)|0;f[b>>2]=0;Ld(8936,365923,25568,167052,494,a|0,25568,167041,139,b|0);b=L5b(4)|0;f[b>>2]=4;a=L5b(4)|0;f[a>>2]=4;Ld(8936,154550,25568,167052,494,b|0,25568,167041,139,a|0);a=L5b(4)|0;f[a>>2]=8;b=L5b(4)|0;f[b>>2]=8;Ld(8936,370818,25608,168501,6,a|0,25608,167413,3,b|0);Xd(8936);Be(8824,154559,207089,4,167038,1423);b=L5b(4)|0;f[b>>2]=0;a=L5b(4)|0;f[a>>2]=0;Ld(8824,434730,25568,167052,495,b|0,25568,167041,140,a|0);a=L5b(4)|0;f[a>>2]=4;b=L5b(4)|0;f[b>>2]=4;Ld(8824,434884,25568,167052,495,a|0,25568,167041,140,b|0);Xd(8824);Be(8944,154559,207089,5,167038,1424);b=L5b(4)|0;f[b>>2]=0;a=L5b(4)|0;f[a>>2]=0;Ld(8944,434730,25600,168520,7,b|0,25600,167241,4,a|0);a=L5b(4)|0;f[a>>2]=4;b=L5b(4)|0;f[b>>2]=4;Ld(8944,434884,25600,168520,7,a|0,25600,167241,4,b|0);Xd(8944);Be(8616,154559,207089,6,167038,1425);b=L5b(4)|0;f[b>>2]=0;a=L5b(4)|0;f[a>>2]=0;Ld(8616,422891,25568,167052,496,b|0,25568,167041,141,a|0);a=L5b(4)|0;f[a>>2]=4;b=L5b(4)|0;f[b>>2]=4;Ld(8616,208539,25568,167052,496,a|0,25568,167041,141,b|0);Xd(8616);Be(8256,154559,207089,7,167038,1426);b=L5b(4)|0;f[b>>2]=0;a=L5b(4)|0;f[a>>2]=0;Ld(8256,422891,25600,168520,8,b|0,25600,167241,5,a|0);a=L5b(4)|0;f[a>>2]=4;b=L5b(4)|0;f[b>>2]=4;Ld(8256,208539,25600,168520,8,a|0,25600,167241,5,b|0);Xd(8256);Be(8272,154565,207089,8,167038,1427);b=L5b(4)|0;f[b>>2]=0;a=L5b(4)|0;f[a>>2]=0;Ld(8272,422891,25568,167052,497,b|0,25568,167041,142,a|0);a=L5b(4)|0;f[a>>2]=4;b=L5b(4)|0;f[b>>2]=4;Ld(8272,208539,25568,167052,497,a|0,25568,167041,142,b|0);b=L5b(4)|0;f[b>>2]=8;a=L5b(4)|0;f[a>>2]=8;Ld(8272,434730,25568,167052,497,b|0,25568,167041,142,a|0);a=L5b(4)|0;f[a>>2]=12;b=L5b(4)|0;f[b>>2]=12;Ld(8272,434884,25568,167052,497,a|0,25568,167041,142,b|0);Xd(8272);Be(8952,154570,207089,9,167038,1428);b=L5b(4)|0;f[b>>2]=0;a=L5b(4)|0;f[a>>2]=0;Ld(8952,422891,25600,168520,9,b|0,25600,167241,6,a|0);a=L5b(4)|0;f[a>>2]=4;b=L5b(4)|0;f[b>>2]=4;Ld(8952,208539,25600,168520,9,a|0,25600,167241,6,b|0);b=L5b(4)|0;f[b>>2]=8;a=L5b(4)|0;f[a>>2]=8;Ld(8952,434730,25600,168520,9,b|0,25600,167241,6,a|0);a=L5b(4)|0;f[a>>2]=12;b=L5b(4)|0;f[b>>2]=12;Ld(8952,434884,25600,168520,9,a|0,25600,167241,6,b|0);Xd(8952);Be(8264,154577,207089,10,167038,1429);b=L5b(4)|0;f[b>>2]=0;a=L5b(4)|0;f[a>>2]=0;Ld(8264,154589,8256,167052,498,b|0,8256,167041,143,a|0);a=L5b(4)|0;f[a>>2]=8;b=L5b(4)|0;f[b>>2]=8;Ld(8264,429353,8944,167052,499,a|0,8944,167041,144,b|0);b=L5b(4)|0;f[b>>2]=16;a=L5b(4)|0;f[a>>2]=16;Ld(8264,154596,25600,168520,10,b|0,25600,167241,7,a|0);Xd(8264);mf(154602,2,26868,167052,500,891);mf(154620,2,26876,167052,501,892);mf(154644,2,26884,167052,502,893);Qe(8856,154670,207089,11,167038,1430);hf(8856,25608,168501,11,0,25608,167413,8,0);hf(8856,25608,168501,11,1,25608,167413,8,1);hf(8856,25608,168501,11,2,25608,167413,8,2);hf(8856,25608,168501,11,3,25608,167413,8,3);Ad(8856);Be(8960,154677,207089,12,167038,1431);a=L5b(4)|0;f[a>>2]=0;b=L5b(4)|0;f[b>>2]=0;Ld(8960,154687,25608,168501,12,a|0,25608,167413,9,b|0);b=L5b(4)|0;f[b>>2]=8;a=L5b(4)|0;f[a>>2]=8;Ld(8960,154694,25608,168501,12,b|0,25608,167413,9,a|0);a=L5b(4)|0;f[a>>2]=16;b=L5b(4)|0;f[b>>2]=16;Ld(8960,154701,8616,167052,503,a|0,8616,167041,145,b|0);b=L5b(4)|0;f[b>>2]=24;a=L5b(4)|0;f[a>>2]=24;Ld(8960,154708,8616,167052,503,b|0,8616,167041,145,a|0);Xd(8960);Be(8968,154715,207089,13,167038,1432);a=L5b(4)|0;f[a>>2]=0;b=L5b(4)|0;f[b>>2]=0;Ld(8968,154589,8256,167052,504,a|0,8256,167041,146,b|0);b=L5b(4)|0;f[b>>2]=8;a=L5b(4)|0;f[a>>2]=8;Ld(8968,154722,25600,168520,13,b|0,25600,167241,10,a|0);Xd(8968);Be(8976,154729,207089,14,167038,1433);a=L5b(4)|0;f[a>>2]=0;b=L5b(4)|0;f[b>>2]=0;Ld(8976,154737,25608,168501,14,a|0,25608,167413,11,b|0);b=L5b(4)|0;f[b>>2]=8;a=L5b(4)|0;f[a>>2]=8;Ld(8976,154741,25608,168501,14,b|0,25608,167413,11,a|0);a=L5b(4)|0;f[a>>2]=16;b=L5b(4)|0;f[b>>2]=16;Ld(8976,154745,25608,168501,14,a|0,25608,167413,11,b|0);b=L5b(4)|0;f[b>>2]=24;a=L5b(4)|0;f[a>>2]=24;Ld(8976,154749,25608,168501,14,b|0,25608,167413,11,a|0);a=L5b(4)|0;f[a>>2]=32;b=L5b(4)|0;f[b>>2]=32;Ld(8976,154753,25608,168501,14,a|0,25608,167413,11,b|0);b=L5b(4)|0;f[b>>2]=40;a=L5b(4)|0;f[a>>2]=40;Ld(8976,154757,25608,168501,14,b|0,25608,167413,11,a|0);a=L5b(4)|0;f[a>>2]=48;b=L5b(4)|0;f[b>>2]=48;Ld(8976,154761,25608,168501,14,a|0,25608,167413,11,b|0);b=L5b(4)|0;f[b>>2]=56;a=L5b(4)|0;f[a>>2]=56;Ld(8976,154765,25608,168501,14,b|0,25608,167413,11,a|0);a=L5b(4)|0;f[a>>2]=64;b=L5b(4)|0;f[b>>2]=64;Ld(8976,154769,25608,168501,14,a|0,25608,167413,11,b|0);b=L5b(4)|0;f[b>>2]=72;a=L5b(4)|0;f[a>>2]=72;Ld(8976,154773,25608,168501,14,b|0,25608,167413,11,a|0);a=L5b(4)|0;f[a>>2]=80;b=L5b(4)|0;f[b>>2]=80;Ld(8976,154777,25608,168501,14,a|0,25608,167413,11,b|0);b=L5b(4)|0;f[b>>2]=88;a=L5b(4)|0;f[a>>2]=88;Ld(8976,154782,25608,168501,14,b|0,25608,167413,11,a|0);a=L5b(4)|0;f[a>>2]=96;b=L5b(4)|0;f[b>>2]=96;Ld(8976,154787,25608,168501,14,a|0,25608,167413,11,b|0);b=L5b(4)|0;f[b>>2]=104;a=L5b(4)|0;f[a>>2]=104;Ld(8976,154792,25608,168501,14,b|0,25608,167413,11,a|0);a=L5b(4)|0;f[a>>2]=112;b=L5b(4)|0;f[b>>2]=112;Ld(8976,154797,25608,168501,14,a|0,25608,167413,11,b|0);b=L5b(4)|0;f[b>>2]=120;a=L5b(4)|0;f[a>>2]=120;Ld(8976,154802,25608,168501,14,b|0,25608,167413,11,a|0);a=L5b(4)|0;f[a>>2]=128;b=L5b(4)|0;f[b>>2]=128;Ld(8976,154807,25608,168501,14,a|0,25608,167413,11,b|0);b=L5b(4)|0;f[b>>2]=136;a=L5b(4)|0;f[a>>2]=136;Ld(8976,154812,25608,168501,14,b|0,25608,167413,11,a|0);a=L5b(4)|0;f[a>>2]=144;b=L5b(4)|0;f[b>>2]=144;Ld(8976,154817,25608,168501,14,a|0,25608,167413,11,b|0);b=L5b(4)|0;f[b>>2]=152;a=L5b(4)|0;f[a>>2]=152;Ld(8976,154822,25608,168501,14,b|0,25608,167413,11,a|0);a=L5b(4)|0;f[a>>2]=160;b=L5b(4)|0;f[b>>2]=160;Ld(8976,154827,25608,168501,14,a|0,25608,167413,11,b|0);b=L5b(4)|0;f[b>>2]=168;a=L5b(4)|0;f[a>>2]=168;Ld(8976,154832,25608,168501,14,b|0,25608,167413,11,a|0);a=L5b(4)|0;f[a>>2]=176;b=L5b(4)|0;f[b>>2]=176;Ld(8976,154837,25608,168501,14,a|0,25608,167413,11,b|0);b=L5b(4)|0;f[b>>2]=184;a=L5b(4)|0;f[a>>2]=184;Ld(8976,154842,25608,168501,14,b|0,25608,167413,11,a|0);Xd(8976);Be(10168,154847,207089,15,167038,1434);a=L5b(4)|0;f[a>>2]=12;b=L5b(4)|0;f[b>>2]=12;Ld(10168,154857,25568,167052,505,a|0,25568,167041,147,b|0);b=L5b(4)|0;f[b>>2]=894;a=L5b(4)|0;f[a>>2]=895;Ld(10168,154862,8992,167052,506,b|0,8992,167041,148,a|0);Xd(10168);mf(154866,2,26892,167052,507,896);mf(253063,2,26900,167052,508,897);mf(176073,3,26908,167075,251,149);mf(176073,2,26920,167052,509,898);mf(154883,1,26928,167033,652,1435);mf(154912,2,26932,167052,510,653);mf(154925,4,26940,167080,56,201);mf(359052,4,26940,167080,56,202);mf(154934,1,26956,167033,654,1436);Dd(154954,25568,0);Dd(154962,25568,8);Dd(154970,25568,16);Dd(154978,25568,24);Dd(154986,25568,1);Dd(154994,25568,9);Dd(155002,25568,17);Dd(155010,25568,25);Dd(155018,25568,2);Dd(155027,25568,10);Dd(155036,25568,18);Dd(155045,25568,26);Dd(155054,25568,3);Dd(155063,25568,11);Dd(155072,25568,19);Dd(155081,25568,27);Dd(155090,25568,4);Dd(155099,25568,12);Dd(155108,25568,20);Dd(155117,25568,28);Dd(155126,25568,5);Dd(155135,25568,13);Dd(155144,25568,21);Dd(155153,25568,29);Dd(155162,25568,6);Dd(155171,25568,14);Dd(155180,25568,22);Dd(155189,25568,30);Dd(155198,25568,0);Dd(155204,25568,1);Dd(155210,25568,2);Dd(155217,25568,3);Dd(155224,25568,4);Dd(155231,25568,5);Dd(155238,25568,6);Dd(155245,25568,-2147483648);Dd(155253,25568,2147483647);return}function wj(a){a=a|0;_d(8312,8336,8352,0,167033,655,167036,0,167036,0,a|0,167038,1437);yd(8312,1,25680,167033,656,16);a=L5b(8)|0;f[a>>2]=899;f[a+4>>2]=0;Ee(8312,166827,3,25684,167041,150,a|0,0);a=L5b(8)|0;f[a>>2]=151;f[a+4>>2]=0;Ee(8312,255795,4,25696,167046,203,a|0,0);a=L5b(8)|0;f[a>>2]=657;f[a+4>>2]=0;Ee(8312,429353,2,25712,167052,511,a|0,0);a=L5b(4)|0;f[a>>2]=152;Ee(8312,375399,3,25720,167075,252,a|0,0);a=L5b(4)|0;f[a>>2]=253;Ee(8312,166837,4,25732,167080,57,a|0,0);return}function xj(a){a=a|0;_d(8400,8424,8440,0,167033,658,167036,0,167036,0,a|0,167038,1438);yd(8400,1,25748,167033,659,17);a=L5b(8)|0;f[a>>2]=900;f[a+4>>2]=0;Ee(8400,166827,3,25752,167241,12,a|0,0);a=L5b(8)|0;f[a>>2]=153;f[a+4>>2]=0;Ee(8400,255795,4,25764,167246,8,a|0,0);a=L5b(8)|0;f[a>>2]=660;f[a+4>>2]=0;Ee(8400,429353,2,25780,167052,512,a|0,0);a=L5b(4)|0;f[a>>2]=154;Ee(8400,375399,3,25788,167075,254,a|0,0);a=L5b(4)|0;f[a>>2]=255;Ee(8400,166837,4,25800,167252,2,a|0,0);return}function yj(a){a=a|0;_d(8480,8504,8520,0,167033,661,167036,0,167036,0,a|0,167038,1439);yd(8480,1,25816,167033,662,18);a=L5b(8)|0;f[a>>2]=901;f[a+4>>2]=0;Ee(8480,166827,3,25820,167413,13,a|0,0);a=L5b(8)|0;f[a>>2]=155;f[a+4>>2]=0;Ee(8480,255795,4,25832,167418,9,a|0,0);a=L5b(8)|0;f[a>>2]=663;f[a+4>>2]=0;Ee(8480,429353,2,25848,167052,513,a|0,0);a=L5b(4)|0;f[a>>2]=156;Ee(8480,375399,3,25856,167075,256,a|0,0);a=L5b(4)|0;f[a>>2]=257;Ee(8480,166837,4,25868,167424,3,a|0,0);return}function zj(a){a=a|0;_d(8560,8584,8600,0,167033,664,167036,0,167036,0,a|0,167038,1440);yd(8560,1,25884,167033,665,19);a=L5b(8)|0;f[a>>2]=902;f[a+4>>2]=0;Ee(8560,166827,3,25888,167041,157,a|0,0);a=L5b(8)|0;f[a>>2]=158;f[a+4>>2]=0;Ee(8560,255795,4,25900,167046,204,a|0,0);a=L5b(8)|0;f[a>>2]=666;f[a+4>>2]=0;Ee(8560,429353,2,25916,167052,514,a|0,0);a=L5b(4)|0;f[a>>2]=159;Ee(8560,375399,3,25924,167075,258,a|0,0);a=L5b(4)|0;f[a>>2]=259;Ee(8560,166837,4,25936,167080,58,a|0,0);return}function Aj(a){a=a|0;_d(8648,8672,8688,0,167033,667,167036,0,167036,0,a|0,167038,1441);yd(8648,1,25952,167033,668,20);a=L5b(8)|0;f[a>>2]=903;f[a+4>>2]=0;Ee(8648,166827,3,25956,167041,160,a|0,0);a=L5b(8)|0;f[a>>2]=161;f[a+4>>2]=0;Ee(8648,255795,4,25968,167046,205,a|0,0);a=L5b(8)|0;f[a>>2]=669;f[a+4>>2]=0;Ee(8648,429353,2,25984,167052,515,a|0,0);a=L5b(4)|0;f[a>>2]=162;Ee(8648,375399,3,25992,167075,260,a|0,0);a=L5b(4)|0;f[a>>2]=261;Ee(8648,166837,4,26004,167080,59,a|0,0);return}function Bj(a){a=a|0;_d(8736,8760,8776,0,167033,670,167036,0,167036,0,a|0,167038,1442);yd(8736,1,26020,167033,671,21);a=L5b(8)|0;f[a>>2]=904;f[a+4>>2]=0;Ee(8736,166827,3,26024,167041,163,a|0,0);a=L5b(8)|0;f[a>>2]=164;f[a+4>>2]=0;Ee(8736,255795,4,26036,167046,206,a|0,0);a=L5b(8)|0;f[a>>2]=672;f[a+4>>2]=0;Ee(8736,429353,2,26052,167052,516,a|0,0);a=L5b(4)|0;f[a>>2]=165;Ee(8736,375399,3,26060,167075,262,a|0,0);a=L5b(4)|0;f[a>>2]=263;Ee(8736,166837,4,26072,167080,60,a|0,0);return}function Cj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+240|0;e=d;g=d+224|0;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];WS(e,g,c);f[a>>2]=1124007936;c=a+8|0;g=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[g>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[e>>2]|0;th[f[(f[c>>2]|0)+12>>2]&511](c,e,a,-1);Wi(e);u=d;return}function Dj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+224|0;g=e;VS(g,b,c,d);f[a>>2]=1124007936;d=a+8|0;c=a+40|0;b=a+4|0;h=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[c>>2]=d;d=a+48|0;f[a+44>>2]=d;f[d>>2]=0;f[a+52>>2]=0;d=f[g>>2]|0;th[f[(f[d>>2]|0)+12>>2]&511](d,g,a,-1);Wi(g);u=e;return}function Ej(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=jf()|0;f[a>>2]=g;h=c+4|0;if((f[h>>2]|0)<=0){u=d;return}i=c+40|0;c=0;j=g;while(1){g=(f[i>>2]|0)+(c<<2)|0;if((b[490992]|0)==0?Cac(490992)|0:0){k=Ye(2,25632)|0;f[125e3]=k}k=f[125e3]|0;f[e>>2]=f[g>>2];$c(k|0,j|0,154182,e|0);k=c+1|0;if((k|0)>=(f[h>>2]|0))break;c=k;j=f[a>>2]|0}u=d;return}function Fj(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=jf()|0;f[a>>2]=g;h=c+4|0;if((f[h>>2]|0)<=0){u=d;return}i=c+44|0;c=0;j=g;while(1){g=(f[i>>2]|0)+(c<<2)|0;if((b[491e3]|0)==0?Cac(491e3)|0:0){k=Ye(2,25640)|0;f[125001]=k}k=f[125001]|0;f[e>>2]=f[g>>2];$c(k|0,j|0,154182,e|0);k=c+1|0;if((k|0)>=(f[h>>2]|0))break;c=k;j=f[a>>2]|0}u=d;return}function Gj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=Y(l,g)|0;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ae(8872,d|0)|0;f[a>>2]=g;u=c;return}function Hj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=Y(l,g)|0;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ae(8880,d|0)|0;f[a>>2]=g;u=c;return}function Ij(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>1;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ae(8888,d|0)|0;f[a>>2]=g;u=c;return}function Jj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>1;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ae(8896,d|0)|0;f[a>>2]=g;u=c;return}function Kj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>2;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ae(8904,d|0)|0;f[a>>2]=g;u=c;return}function Lj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>2;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ae(8912,d|0)|0;f[a>>2]=g;u=c;return}function Mj(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[b+4>>2]|0;if((e|0)<3)g=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{h=f[b+40>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if((e|0)>0)l=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else l=0;e=(Y(l,g)|0)>>>3;g=f[b+16>>2]|0;f[d>>2]=e;f[d+4>>2]=g;g=Ae(8920,d|0)|0;f[a>>2]=g;u=c;return}function Nj(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if((b|0)<=0){c=0;return c|0}c=f[(f[a+44>>2]|0)+(b+-1<<2)>>2]|0;return c|0}function Oj(a){a=a|0;return 1212424721>>>(f[a>>2]<<2&28)&15|0}function Pj(a){a=a|0;return ((f[a>>2]|0)>>>3&511)+1|0}function Qj(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=f[a+4>>2]|0;if((b|0)<3){c=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;return c|0}d=f[a+40>>2]|0;a=0;e=1;while(1){g=Y(f[d+(a<<2)>>2]|0,e)|0;a=a+1|0;if((a|0)>=(b|0)){c=g;break}else e=g}return c|0}function Rj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=c;f[e+4>>2]=c+1;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;lL(a,b,e,g);u=d;return}function Sj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=d&4095;if(((((f[a+4>>2]|0)<3?(f[a+8>>2]|0)==(b|0):0)?(f[a+12>>2]|0)==(c|0):0)?(f[a>>2]&4095|0)==(h|0):0)?f[a+16>>2]|0:0){u=e;return}f[g>>2]=b;f[g+4>>2]=c;hL(a,2,g,h);u=e;return}function Tj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b+4>>2]|0;h=f[b>>2]|0;b=c&4095;if(((((f[a+4>>2]|0)<3?(f[a+8>>2]|0)==(g|0):0)?(f[a+12>>2]|0)==(h|0):0)?(f[a>>2]&4095|0)==(b|0):0)?f[a+16>>2]|0:0){u=d;return}f[e>>2]=g;f[e+4>>2]=h;hL(a,2,e,b);u=d;return}function Uj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=c;f[g+4>>2]=d;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;lL(a,b,g,h);u=e;return}function Vj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;lL(a,b,c,e);u=d;return}function Wj(a){a=a|0;return f[a>>2]&4095|0}function Xj(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;if(!(f[a+16>>2]|0))return 1;b=f[a+4>>2]|0;if((b|0)<3){c=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;d=(c|0)==0;e=(b|0)==0;g=d|e;return g|0}h=f[a+40>>2]|0;a=0;i=1;while(1){j=Y(f[h+(a<<2)>>2]|0,i)|0;a=a+1|0;if((a|0)==(b|0)){c=j;break}else i=j}d=(c|0)==0;e=(b|0)==0;g=d|e;return g|0}function Yj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=c;f[h+4>>2]=d;lL(a,b,g,h);u=e;return}function Zj(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;lL(a,b,e,c);u=d;return}function _j(a,b){a=a|0;b=b|0;return ((f[(f[a+44>>2]|0)+(b<<2)>>2]|0)>>>0)/((1212424721>>>(f[a>>2]<<2&28)&15)>>>0)|0|0}function $j(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=1124007936;e=a+8|0;g=a+40|0;h=a+4|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+48|0;f[a+44>>2]=e;f[e>>2]=0;f[a+52>>2]=0;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=a;SP(b,d);u=c;return}function ak(a){a=a|0;return f[a>>2]&7|0}function bk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;f[g>>2]=c;f[g+4>>2]=c+1;lL(a,b,e,g);u=d;return}function ck(a,b,c){a=a|0;b=b|0;c=c|0;nL(a,b,c);return}function dk(a){a=a|0;return (f[a>>2]&16384|0)!=0|0}function ek(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ae(8872,e|0)|0;f[a>>2]=h;u=d;return}function fk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ae(8872,g|0)|0;f[a>>2]=j;u=e;return}function gk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ae(8880,e|0)|0;f[a>>2]=h;u=d;return}function hk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ae(8880,g|0)|0;f[a>>2]=j;u=e;return}function ik(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ae(8896,e|0)|0;f[a>>2]=h;u=d;return}function jk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ae(8896,g|0)|0;f[a>>2]=j;u=e;return}function kk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ae(8888,e|0)|0;f[a>>2]=h;u=d;return}function lk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ae(8888,g|0)|0;f[a>>2]=j;u=e;return}function mk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ae(8904,e|0)|0;f[a>>2]=h;u=d;return}function nk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ae(8904,g|0)|0;f[a>>2]=j;u=e;return}function ok(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ae(8912,e|0)|0;f[a>>2]=h;u=d;return}function pk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ae(8912,g|0)|0;f[a>>2]=j;u=e;return}function qk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[f[b+44>>2]>>2]|0;h=(f[b+16>>2]|0)+(Y(g,c)|0)|0;f[e>>2]=(g>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[e+4>>2]=h;h=Ae(8920,e|0)|0;f[a>>2]=h;u=d;return}function rk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[b+44>>2]|0;i=f[h+4>>2]|0;j=(f[b+16>>2]|0)+(Y(f[h>>2]|0,c)|0)+(Y(i,d)|0)|0;f[g>>2]=(i>>>0)/((1212424721>>>(f[b>>2]<<2&28)&15)>>>0)|0;f[g+4>>2]=j;j=Ae(8920,g|0)|0;f[a>>2]=j;u=e;return}function sk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0))|0;return g|0}}g=c+b|0;return g|0}function tk(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+c|0}function uk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function vk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0))|0;return g|0}}g=c+b|0;return g|0}function wk(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+c|0}function xk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function yk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<1)|0;return g|0}}g=c+(b<<1)|0;return g|0}function zk(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<1)|0}function Ak(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Bk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<1)|0;return g|0}}g=c+(b<<1)|0;return g|0}function Ck(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<1)|0}function Dk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Ek(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<2)|0;return g|0}}g=c+(b<<2)|0;return g|0}function Fk(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<2)|0}function Gk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Hk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<2)|0;return g|0}}g=c+(b<<2)|0;return g|0}function Ik(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<2)|0}function Jk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Kk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[a+44>>2]|0;g=(f[a+16>>2]|0)+(Y(f[e>>2]|0,b)|0)|0;b=g+(Y(f[e+4>>2]|0,c)|0)|0;return b+(Y(f[e+8>>2]|0,d)|0)|0}function Lk(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a+16>>2]|0;if((f[a>>2]&16384|0)==0?(d=f[a+40>>2]|0,(f[d>>2]|0)!=1):0){e=f[f[a+44>>2]>>2]|0;if((f[d+4>>2]|0)==1){g=c+(Y(e,b)|0)|0;return g|0}else{d=f[a+12>>2]|0;a=(b|0)/(d|0)|0;g=c+(Y(a,e)|0)+(b-(Y(a,d)|0)<<3)|0;return g|0}}g=c+(b<<3)|0;return g|0}function Mk(a,b,c){a=a|0;b=b|0;c=c|0;return (f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,b)|0)+(c<<3)|0}function Nk(a){a=a|0;p[a>>3]=1797693134862315708145274.0e284;p[a+8>>3]=1797693134862315708145274.0e284;p[a+16>>3]=1797693134862315708145274.0e284;p[a+24>>3]=1797693134862315708145274.0e284;return}function Ok(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;D4(i,j,c,d,e,g);u=h;return}function Pk(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;D4(h,i,c,d,e,0);u=g;return}function Qk(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;D4(g,h,c,d,3,0);u=e;return}function Rk(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;V4(i,j,k,d,e,g);u=h;return}function Sk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;V4(h,i,j,d,e,0);u=g;return}function Tk(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+24|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];F7(i,j,k,d,e,g);u=h;return}function Uk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];F7(h,i,j,d,e,4);u=g;return}function Vk(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+24|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];F7(g,h,i,d,0.0,4);u=e;return}function Wk(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=+h;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+32|0;l=k+16|0;m=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;c2(l,m,c,d,e,g,h,i,j);u=k;return}function Xk(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=+h;i=i|0;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;c2(k,l,c,d,e,g,h,i,0);u=j;return}function Yk(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;c2(j,k,c,d,e,g,h,0,0);u=i;return}function Zk(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;c2(i,j,c,d,e,g,100.0,0,0);u=h;return}function _k(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;c2(h,i,c,d,e,100.0,100.0,0,0);u=g;return}function $k(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;i=+i;j=+j;var k=0,l=0,m=0;k=u;u=u+32|0;l=k+16|0;m=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;R1(l,m,c,d,e,g,h,i,j);u=k;return}function al(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;i=+i;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;R1(k,l,c,d,e,g,h,i,3.141592653589793);u=j;return}function bl(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;R1(j,k,c,d,e,g,h,0.0,3.141592653589793);u=i;return}function cl(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;R1(i,j,c,d,e,g,0.0,0.0,3.141592653589793);u=h;return}function dl(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;R1(h,i,c,d,e,0.0,0.0,0.0,3.141592653589793);u=g;return}function el(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;$1(j,k,c,d,e,g,h);u=i;return}function fl(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;$1(i,j,c,d,e,g,0.0);u=h;return}function gl(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;$1(h,i,c,d,e,0.0,0.0);u=g;return}function hl(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;B2(j,k,c,d,e,g,h);u=i;return}function il(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;B2(i,j,c,d,e,g,4);u=h;return}function jl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;B2(h,i,c,d,e,0.0,4);u=g;return}function kl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;B2(g,h,c,d,1.0,0.0,4);u=e;return}function ll(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;B2(e,g,c,1,1.0,0.0,4);u=d;return}function ml(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;A2(k,l,c,d,e,g,h,i);u=j;return}function nl(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;A2(j,k,c,d,e,g,h,4);u=i;return}function ol(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;A2(i,j,c,d,e,g,0.0,4);u=h;return}function pl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;A2(h,i,c,d,e,1.0,0.0,4);u=g;return}function ql(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0;k=u;u=u+32|0;l=k+16|0;m=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;z2(l,m,c,d,e,g,h,i,j);u=k;return}function rl(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;z2(k,l,c,d,e,g,h,i,4);u=j;return}function sl(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;z2(j,k,c,d,e,g,h,0.0,4);u=i;return}function tl(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;z2(i,j,c,d,e,g,1.0,0.0,4);u=h;return}function ul(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;z2(h,i,c,d,e,3,1.0,0.0,4);u=g;return}function vl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;yE(e,g,h);u=d;return}function wl(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+16|0;k=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;sea(j,k,c,d,e,g,h);u=i;return}function xl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;VD(h,i,j,k,e);u=g;return}function yl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;VD(g,h,i,j,-1);u=e;return}function zl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;VD(e,g,h,UM()|0,-1);u=d;return}function Al(a,b,c,d,e,g,h){a=a|0;b=+b;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=g;jF(j,b,k,d,e,l,h);u=i;return}function Bl(a,b,c,d,e,g){a=a|0;b=+b;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=g;jF(i,b,j,d,e,k,-1);u=h;return}function Cl(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;A4(g,h,c,d);u=e;return}function Dl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;e=+gea(d,b);u=c;return +e}function El(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;I7(i,j,c,d,e,g);u=h;return}function Fl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;I7(h,i,c,d,e,4);u=g;return}function Gl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;dD(g,h,i,j);u=e;return}function Hl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;dD(e,g,h,UM()|0);u=d;return}function Il(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;nD(e,g,h);u=d;return}function Jl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;nD(d,e,UM()|0);u=c;return}function Kl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;hD(g,h,i,j);u=e;return}function Ll(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;hD(e,g,h,UM()|0);u=d;return}function Ml(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;kD(g,h,i,j);u=e;return}function Nl(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;kD(e,g,h,UM()|0);u=d;return}function Ol(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g+8|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];h7(h,i,j,k,e);u=g;return}function Pl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e+8|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];h7(g,h,i,j,4);u=e;return}function Ql(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d+8|0;i=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=-1;f[i+4>>2]=-1;h7(e,g,h,i,4);u=d;return}function Rl(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;jea(a,d);u=c;return}function Sl(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];g7(j,k,c,l,m,g,h);u=i;return}function Tl(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h+8|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];g7(i,j,c,k,l,g,4);u=h;return}function Ul(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g+8|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];g7(h,i,c,j,k,1,4);u=g;return}function Vl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e+8|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[j>>2]=-1;f[j+4>>2]=-1;g7(g,h,c,i,j,1,4);u=e;return}function Wl(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+32|0;l=h+40|0;m=h+16|0;n=h+4|0;o=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=a;a=f[b>>2]|0;f[k>>2]=a;Jd(a|0);Xl(j,k);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=d;d=f[e>>2]|0;f[o>>2]=d;Jd(d|0);Yl(n,o);a3(i,j,l,m,n,g);m=f[n>>2]|0;if(m|0){l=n+4|0;n=f[l>>2]|0;if((n|0)!=(m|0))f[l>>2]=n+(~((n+-4-m|0)>>>2)<<2);O5b(m)}Yd(f[o>>2]|0);o=f[j>>2]|0;if(!o){p=f[k>>2]|0;Yd(p|0);u=h;return}m=j+4|0;j=f[m>>2]|0;if((j|0)!=(o|0))f[m>>2]=j+(~((j+-4-o|0)>>>2)<<2);O5b(o);p=f[k>>2]|0;Yd(p|0);u=h;return}function Xl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;e=c+8|0;g=f[b>>2]|0;h=Jf(168707)|0;i=id(g|0,h|0)|0;Yd(h|0);j=+Nd(i|0,25576,d|0);ee(f[d>>2]|0);h=~~j>>>0;Yd(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=a+8|0;k=0;do{l=f[b>>2]|0;f[d>>2]=k;m=Ae(25576,d|0)|0;n=id(l|0,m|0)|0;Yd(m|0);j=+Nd(n|0,25568,d|0);ee(f[d>>2]|0);m=~~j;f[e>>2]=m;l=f[i>>2]|0;if(l>>>0<(f[g>>2]|0)>>>0){f[l>>2]=m;f[i>>2]=l+4}else kw(a,e);Yd(n|0);k=k+1|0}while(k>>>0<h>>>0);u=c;return}function Yl(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,o=0,p=0.0;c=u;u=u+16|0;d=c;e=c+8|0;g=f[b>>2]|0;h=Jf(168707)|0;i=id(g|0,h|0)|0;Yd(h|0);j=+Nd(i|0,25576,d|0);ee(f[d>>2]|0);h=~~j>>>0;Yd(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=a+8|0;k=0;do{l=f[b>>2]|0;f[d>>2]=k;m=Ae(25576,d|0)|0;o=id(l|0,m|0)|0;Yd(m|0);j=+Nd(o|0,25600,d|0);ee(f[d>>2]|0);p=j;n[e>>2]=p;m=f[i>>2]|0;if(m>>>0<(f[g>>2]|0)>>>0){n[m>>2]=p;f[i>>2]=m+4}else lw(a,e);Yd(o|0);k=k+1|0}while(k>>>0<h>>>0);u=c;return}function Zl(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+112|0;j=i+88|0;k=i+72|0;l=i+48|0;m=i+56|0;n=i+32|0;o=i+20|0;p=i+4|0;q=i+8|0;r=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17104896;f[j+4>>2]=a;a=f[b>>2]|0;f[l>>2]=a;Jd(a|0);Xl(k,l);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=d;d=f[e>>2]|0;f[p>>2]=d;Jd(d|0);Xl(o,p);d=f[g>>2]|0;f[r>>2]=d;Jd(d|0);Yl(q,r);_2(j,k,m,n,o,q,h);h=f[q>>2]|0;if(h|0){n=q+4|0;q=f[n>>2]|0;if((q|0)!=(h|0))f[n>>2]=q+(~((q+-4-h|0)>>>2)<<2);O5b(h)}Yd(f[r>>2]|0);r=f[o>>2]|0;if(r|0){h=o+4|0;o=f[h>>2]|0;if((o|0)!=(r|0))f[h>>2]=o+(~((o+-4-r|0)>>>2)<<2);O5b(r)}Yd(f[p>>2]|0);p=f[k>>2]|0;if(!p){s=f[l>>2]|0;Yd(s|0);u=i;return}r=k+4|0;k=f[r>>2]|0;if((k|0)!=(p|0))f[r>>2]=k+(~((k+-4-p|0)>>>2)<<2);O5b(p);s=f[l>>2]|0;Yd(s|0);u=i;return}function _l(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=u;u=u+112|0;i=h+88|0;j=h+72|0;k=h+48|0;l=h+56|0;m=h+32|0;n=h+20|0;o=h+4|0;p=h+8|0;q=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=a;a=f[b>>2]|0;f[k>>2]=a;Jd(a|0);Xl(j,k);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=d;d=f[e>>2]|0;f[o>>2]=d;Jd(d|0);Xl(n,o);d=f[g>>2]|0;f[q>>2]=d;Jd(d|0);Yl(p,q);_2(i,j,l,m,n,p,0);m=f[p>>2]|0;if(m|0){l=p+4|0;p=f[l>>2]|0;if((p|0)!=(m|0))f[l>>2]=p+(~((p+-4-m|0)>>>2)<<2);O5b(m)}Yd(f[q>>2]|0);q=f[n>>2]|0;if(q|0){m=n+4|0;n=f[m>>2]|0;if((n|0)!=(q|0))f[m>>2]=n+(~((n+-4-q|0)>>>2)<<2);O5b(q)}Yd(f[o>>2]|0);o=f[j>>2]|0;if(!o){r=f[k>>2]|0;Yd(r|0);u=h;return}q=j+4|0;j=f[q>>2]|0;if((j|0)!=(o|0))f[q>>2]=j+(~((j+-4-o|0)>>>2)<<2);O5b(o);r=f[k>>2]|0;Yd(r|0);u=h;return}function $l(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+48|0;m=l+32|0;n=l+16|0;o=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=b;b=o+8|0;f[b>>2]=0;f[b+4>>2]=0;f[o>>2]=50397184;f[o+4>>2]=c;lsa(m,n,o,d,e,g,h,i,j,k);u=l;return}function am(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;m=u;u=u+128|0;n=m;o=m+104|0;p=m+88|0;q=m+72|0;r=m+56|0;s=m+40|0;t=m+24|0;v=m+16|0;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=a;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=b;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=c;c=r+8|0;f[c>>2]=0;f[c+4>>2]=0;f[r>>2]=50397184;f[r+4>>2]=d;d=s+8|0;f[d>>2]=0;f[d+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=e;e=t+8|0;f[e>>2]=0;f[e+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=g;f[v>>2]=f[h>>2];f[v+4>>2]=f[h+4>>2];f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];f[n+8>>2]=f[j+8>>2];f[n+12>>2]=f[j+12>>2];ata(o,p,q,r,s,t,v,i,n,k,l);u=m;return}function bm(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;l=u;u=u+128|0;m=l;n=l+104|0;o=l+88|0;p=l+72|0;q=l+56|0;r=l+40|0;s=l+24|0;t=l+16|0;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=a;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=b;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=c;c=q+8|0;f[c>>2]=0;f[c+4>>2]=0;f[q>>2]=50397184;f[q+4>>2]=d;d=r+8|0;f[d>>2]=0;f[d+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=e;e=s+8|0;f[e>>2]=0;f[e+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=g;f[t>>2]=f[h>>2];f[t+4>>2]=f[h+4>>2];f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[m+8>>2]=f[j+8>>2];f[m+12>>2]=f[j+12>>2];ata(n,o,p,q,r,s,t,i,m,k,.0001);u=l;return}function cm(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=u;u=u+128|0;l=k;m=k+104|0;n=k+88|0;o=k+72|0;p=k+56|0;q=k+40|0;r=k+24|0;s=k+16|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=b;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=c;c=p+8|0;f[c>>2]=0;f[c+4>>2]=0;f[p>>2]=50397184;f[p+4>>2]=d;d=q+8|0;f[d>>2]=0;f[d+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=e;e=r+8|0;f[e>>2]=0;f[e+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=g;f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];f[l+8>>2]=f[j+8>>2];f[l+12>>2]=f[j+12>>2];ata(m,n,o,p,q,r,s,i,l,0,.0001);u=k;return}function dm(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;j=u;u=u+144|0;k=j+16|0;l=j+120|0;m=j+104|0;n=j+88|0;o=j+72|0;q=j+56|0;r=j+40|0;s=j+32|0;t=j;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=c;c=o+8|0;f[c>>2]=0;f[c+4>>2]=0;f[o>>2]=50397184;f[o+4>>2]=d;d=q+8|0;f[d>>2]=0;f[d+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=e;e=r+8|0;f[e>>2]=0;f[e+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=g;f[s>>2]=f[h>>2];f[s+4>>2]=f[h+4>>2];f[t>>2]=3;f[t+4>>2]=30;p[t+8>>3]=.01;f[k>>2]=f[t>>2];f[k+4>>2]=f[t+4>>2];f[k+8>>2]=f[t+8>>2];f[k+12>>2]=f[t+12>>2];ata(l,m,n,o,q,r,s,i,k,0,.0001);u=j;return}function em(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;i=u;u=u+144|0;j=i+16|0;k=i+120|0;l=i+104|0;m=i+88|0;n=i+72|0;o=i+56|0;q=i+40|0;r=i+32|0;s=i;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=50397184;f[n+4>>2]=d;d=o+8|0;f[d>>2]=0;f[d+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=e;e=q+8|0;f[e>>2]=0;f[e+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=g;f[r>>2]=f[h>>2];f[r+4>>2]=f[h+4>>2];f[s>>2]=3;f[s+4>>2]=30;p[s+8>>3]=.01;f[j>>2]=f[s>>2];f[j+4>>2]=f[s+4>>2];f[j+8>>2]=f[s+8>>2];f[j+12>>2]=f[s+12>>2];ata(k,l,m,n,o,q,r,3,j,0,.0001);u=i;return}function fm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+144|0;i=h+16|0;j=h+120|0;k=h+104|0;l=h+88|0;m=h+72|0;n=h+56|0;o=h+40|0;q=h+32|0;r=h;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=d;d=n+8|0;f[d>>2]=0;f[d+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=e;e=o+8|0;f[e>>2]=0;f[e+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=g;f[q>>2]=21;f[q+4>>2]=21;f[r>>2]=3;f[r+4>>2]=30;p[r+8>>3]=.01;f[i>>2]=f[r>>2];f[i+4>>2]=f[r+4>>2];f[i+8>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];ata(j,k,l,m,n,o,q,3,i,0,.0001);u=h;return}function gm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=d;TO(h,i,j,k,e);u=g;return}function hm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;TO(g,h,i,j,0);u=e;return}function im(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+8|0;k=i;l=j+8|0;f[l>>2]=0;f[l+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];Fma(j,k,c,d,e,g,h);u=i;return}function jm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+8|0;j=h;k=i+8|0;f[k>>2]=0;f[k+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[b>>2];f[j+4>>2]=f[b+4>>2];Fma(i,j,c,d,e,g,0);u=h;return}function km(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+8|0;i=g;j=h+8|0;f[j>>2]=0;f[j+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];Fma(h,i,c,d,e,8,0);u=g;return}function lm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+8|0;h=e;i=g+8|0;f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];Fma(g,h,c,d,1,8,0);u=e;return}function mm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;rF(g,h,i,d);u=e;return}function nm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;h=+b3(e,g,c);u=d;return +h}function om(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=H3(g,h,c,d)|0;u=e;return b|0}function pm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=H3(e,g,c,4)|0;u=d;return b|0}function qm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;b=H3(d,e,8,4)|0;u=c;return b|0}function rm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+48|0;j=h+32|0;k=h+16|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=d;d=a4(i,j,k,l,e,g)|0;u=h;return d|0}function sm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=d;d=a4(h,i,j,k,e,4)|0;u=g;return d|0}function tm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;d=a4(g,h,i,j,8,4)|0;u=e;return d|0}function um(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;e=+hea(d,b);u=c;return +e}function vm(a){a=a|0;var b=0,c=0,d=0.0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;d=+hea(c,0);u=b;return +d}function wm(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;DJ(g,h,c,d);u=e;return}function xm(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;DJ(e,g,c,0.0);u=d;return}function ym(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;DJ(d,e,1.0,0.0);u=c;return}function zm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;tZ(g,h,c,d);u=e;return}function Am(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;tZ(e,g,c,1);u=d;return}function Bm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;tZ(d,e,0,1);u=c;return}function Cm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;GZ(e,g,h);u=d;return}function Dm(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+32|0;k=j+16|0;l=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;_P(k,l,c,d,e,g,h,i);u=j;return}function Em(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+64|0;j=i+48|0;k=i+32|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;_P(j,k,c,d,e,g,h,l);u=i;return}function Fm(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;wea(i,j,c,d,e,g);u=h;return}function Gm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;wea(h,i,c,d,e,4);u=g;return}function Hm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;uea(h,i,c,d,e);u=g;return}function Im(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;uea(g,h,c,d,4);u=e;return}function Jm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;uea(e,g,c,3,4);u=d;return}function Km(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;a=nG(c)|0;u=b;return a|0}function Lm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;D1(g,h,c,d);u=e;return}function Mm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;D1(e,g,c,0);u=d;return}function Nm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;Fla(g,h,c,d);u=e;return}function Om(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;Fla(e,g,c,0);u=d;return}function Pm(a){a=a|0;var b=0,c=0,d=0.0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;d=+$S(c);u=b;return +d}function Qm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;QC(g,h,c,d);u=e;return}function Rm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;QC(e,g,c,0);u=d;return}function Sm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;QC(d,e,0,0);u=c;return}function Tm(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];Bla(j,k,l,m,e,g,h);u=i;return}function Um(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];p[m>>3]=1797693134862315708145274.0e284;p[m+8>>3]=1797693134862315708145274.0e284;p[m+16>>3]=1797693134862315708145274.0e284;p[m+24>>3]=1797693134862315708145274.0e284;Bla(i,j,k,l,e,g,m);u=h;return}function Vm(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];p[l>>3]=1797693134862315708145274.0e284;p[l+8>>3]=1797693134862315708145274.0e284;p[l+16>>3]=1797693134862315708145274.0e284;p[l+24>>3]=1797693134862315708145274.0e284;Bla(h,i,j,k,e,0,l);u=g;return}function Wm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];p[k>>3]=1797693134862315708145274.0e284;p[k+8>>3]=1797693134862315708145274.0e284;p[k+16>>3]=1797693134862315708145274.0e284;p[k+24>>3]=1797693134862315708145274.0e284;Bla(g,h,i,j,1,0,k);u=e;return}function Xm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+96|0;e=d+72|0;g=d+56|0;h=d+40|0;i=d+32|0;j=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;f[i>>2]=-1;f[i+4>>2]=-1;p[j>>3]=1797693134862315708145274.0e284;p[j+8>>3]=1797693134862315708145274.0e284;p[j+16>>3]=1797693134862315708145274.0e284;p[j+24>>3]=1797693134862315708145274.0e284;Bla(e,g,h,i,1,0,j);u=d;return}function Ym(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;xoa(h,i,c,d,e);u=g;return}function Zm(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;xoa(g,h,c,d,5);u=e;return}function _m(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;soa(i,j,k,d,e,g);u=h;return}function $m(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;soa(h,i,j,d,e,0);u=g;return}function an(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;VE(h,i,j,d,e);u=g;return}function bn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;VE(g,h,i,d,-1);u=e;return}function cn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;VE(e,g,h,1.0,-1);u=d;return}function dn(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;bF(a,g,h,d);u=e;return}function en(a,b,c){a=+a;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;bF(a,e,g,-1);u=d;return}function fn(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+64|0;l=k+40|0;m=k+24|0;n=k+8|0;o=k;p=l+8|0;f[p>>2]=0;f[p+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=a;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=17104896;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=h;f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];Kma(l,m,c,d,e,g,n,i,o);u=k;return}function gn(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=u;u=u+64|0;k=j+40|0;l=j+24|0;m=j+8|0;n=j;o=k+8|0;f[o>>2]=0;f[o+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=a;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=17104896;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=h;f[n>>2]=0;f[n+4>>2]=0;Kma(k,l,c,d,e,g,m,i,n);u=j;return}function hn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;n=j+8|0;f[n>>2]=0;f[n+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=17104896;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=h;f[m>>2]=0;f[m+4>>2]=0;Kma(j,k,c,d,e,g,l,2147483647,m);u=i;return}function jn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+48|0;i=h+24|0;j=h+8|0;k=h;l=i+8|0;f[l>>2]=0;f[l+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=17104896;f[j+4>>2]=b;b=UM()|0;f[k>>2]=0;f[k+4>>2]=0;Kma(i,j,c,d,e,g,b,2147483647,k);u=h;return}function kn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;k=h+8|0;f[k>>2]=0;f[k+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=17104896;f[i+4>>2]=b;b=UM()|0;f[j>>2]=0;f[j+4>>2]=0;Kma(h,i,c,d,e,8,b,2147483647,j);u=g;return}function ln(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+48|0;g=e+24|0;h=e+8|0;i=e;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=b;b=UM()|0;f[i>>2]=0;f[i+4>>2]=0;Kma(g,h,c,d,1,8,b,2147483647,i);u=e;return}function mn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;c=dT(e,g,h)|0;u=d;return c|0}function nn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;b=dT(d,e,UM()|0)|0;u=c;return b|0}function on(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+32|0;m=l+16|0;n=l+8|0;o=l;p=m+8|0;f[p>>2]=0;f[p+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=a;f[n>>2]=f[b>>2];f[n+4>>2]=f[b+4>>2];f[o>>2]=f[c>>2];f[o+4>>2]=f[c+4>>2];Gma(m,n,o,d,e,g,h,i,j,k);u=l;return}function pn(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;o=l+8|0;f[o>>2]=0;f[o+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=a;f[m>>2]=f[b>>2];f[m+4>>2]=f[b+4>>2];f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];Gma(l,m,n,d,e,g,h,i,j,0);u=k;return}function qn(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;n=k+8|0;f[n>>2]=0;f[n+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=a;f[l>>2]=f[b>>2];f[l+4>>2]=f[b+4>>2];f[m>>2]=f[c>>2];f[m+4>>2]=f[c+4>>2];Gma(k,l,m,d,e,g,h,i,8,0);u=j;return}function rn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];Gma(j,k,l,d,e,g,h,1,8,0);u=i;return}function sn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;i=h+8|0;f[i>>2]=0;f[i+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;Hma(h,b,c,d,e);u=g;return}function tn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=g+8|0;f[h>>2]=0;f[h+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;Hma(g,b,c,d,8);u=e;return}function un(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=a;Hma(e,b,c,1,8);u=d;return}function vn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;f[j>>2]=f[a>>2];f[j+4>>2]=f[a+4>>2];f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];fma(j,k,c,d,e,g,h);u=i;return}function wn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;c3(d,e);u=c;return}function xn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];zla(j,k,l,m,e,g,h);u=i;return}function yn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];p[m>>3]=1797693134862315708145274.0e284;p[m+8>>3]=1797693134862315708145274.0e284;p[m+16>>3]=1797693134862315708145274.0e284;p[m+24>>3]=1797693134862315708145274.0e284;zla(i,j,k,l,e,g,m);u=h;return}function zn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];p[l>>3]=1797693134862315708145274.0e284;p[l+8>>3]=1797693134862315708145274.0e284;p[l+16>>3]=1797693134862315708145274.0e284;p[l+24>>3]=1797693134862315708145274.0e284;zla(h,i,j,k,e,0,l);u=g;return}function An(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];p[k>>3]=1797693134862315708145274.0e284;p[k+8>>3]=1797693134862315708145274.0e284;p[k+16>>3]=1797693134862315708145274.0e284;p[k+24>>3]=1797693134862315708145274.0e284;zla(g,h,i,j,1,0,k);u=e;return}function Bn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+96|0;e=d+72|0;g=d+56|0;h=d+40|0;i=d+32|0;j=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;f[i>>2]=-1;f[i+4>>2]=-1;p[j>>3]=1797693134862315708145274.0e284;p[j+8>>3]=1797693134862315708145274.0e284;p[j+16>>3]=1797693134862315708145274.0e284;p[j+24>>3]=1797693134862315708145274.0e284;zla(e,g,h,i,1,0,j);u=d;return}function Cn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;bta(a,g,h,d);u=e;return}function Dn(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;VO(d,e);u=c;return}function En(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];Mda(j,k,c,l,m,g,h);u=i;return}function Fn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+40|0;j=h+24|0;k=h+8|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];Mda(i,j,c,k,l,g,4);u=h;return}function Gn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+40|0;i=g+24|0;j=g+8|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];Mda(h,i,c,j,k,0.0,4);u=g;return}function Hn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e+8|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=d;f[j>>2]=-1;f[j+4>>2]=-1;Mda(g,h,c,i,j,0.0,4);u=e;return}function In(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+64|0;i=h+40|0;j=h+24|0;k=h+8|0;l=h;m=i+8|0;f[m>>2]=0;f[m+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33882112;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=c;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];Eea(i,j,k,d,e,l);u=h;return}function Jn(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+64|0;h=g+40|0;i=g+24|0;j=g+8|0;k=g;l=h+8|0;f[l>>2]=0;f[l+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k>>2]=0;f[k+4>>2]=0;Eea(h,i,j,d,e,k);u=g;return}function Kn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0.0;h=u;u=u+80|0;i=h;j=h+64|0;k=h+48|0;l=h+32|0;m=h+16|0;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;b=l+8|0;f[b>>2]=0;f[b+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=c;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=g;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[i+8>>2]=f[e+8>>2];f[i+12>>2]=f[e+12>>2];n=+eta(j,k,l,d,i,m);u=h;return +n}function Ln(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0;g=u;u=u+80|0;h=g+16|0;i=g+64|0;j=g+48|0;k=g+32|0;l=g;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;b=k+8|0;f[b>>2]=0;f[b+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=c;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[l+8>>2]=f[e+8>>2];f[l+12>>2]=f[e+12>>2];e=UM()|0;f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];f[h+8>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];m=+eta(i,j,k,d,h,e);u=g;return +m}function Mn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0;e=u;u=u+80|0;g=e+16|0;h=e+64|0;i=e+48|0;j=e+32|0;k=e;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=c;f[k>>2]=3;f[k+4>>2]=50;p[k+8>>3]=.001;c=UM()|0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];l=+eta(h,i,j,d,g,c);u=e;return +l}function Nn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0.0;d=u;u=u+80|0;e=d+16|0;g=d+64|0;h=d+48|0;i=d+32|0;j=d;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=c;f[j>>2]=3;f[j+4>>2]=50;p[j+8>>3]=.001;c=UM()|0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];f[e+8>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];k=+eta(g,h,i,2,e,c);u=d;return +k}function On(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;iea(a,d);u=c;return}function Pn(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=+g;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;h3(i,j,c,d,e,g);u=h;return}function Qn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;WP(e,g,c);u=d;return}function Rn(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+48|0;k=i+32|0;l=i+16|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;d=m+8|0;f[d>>2]=0;f[d+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=g;CX(j,k,c,l,e,m,h);u=i;return}function Sn(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+48|0;j=h+32|0;k=h+16|0;l=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;d=l+8|0;f[d>>2]=0;f[d+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=g;CX(i,j,c,k,e,l,0);u=h;return}function Tn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;hoa(a,e,g);u=d;return}function Un(a){a=a|0;return SC(a)|0}function Vn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;goa(a,e,g);u=d;return}function Wn(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];doa(a,g,c,d);u=e;return}function Xn(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];xla(a,b,g,h);u=e;return}function Yn(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];f[g>>2]=-1;f[g+4>>2]=-1;xla(a,b,e,g);u=d;return}function Zn(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=+j;var k=0,l=0,m=0,n=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=g;L2(l,m,c,d,e,n,h,i,j);u=k;return}function _n(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+48|0;k=j+32|0;l=j+16|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=g;L2(k,l,c,d,e,m,h,i,.04);u=j;return}function $n(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=g;L2(j,k,c,d,e,l,h,0,.04);u=i;return}function ao(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+32|0;j=h+16|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=g;L2(i,j,c,d,e,k,3,0,.04);u=h;return}function bo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;L2(h,i,c,d,e,UM()|0,3,0,.04);u=g;return}function co(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;var l=0,m=0,n=0,o=0;l=u;u=u+48|0;m=l+32|0;n=l+16|0;o=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=a;a=n+8|0;f[a>>2]=0;f[a+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=b;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=g;C2(m,n,c,d,e,o,h,i,j,k);u=l;return}function eo(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=a;a=m+8|0;f[a>>2]=0;f[a+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=b;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=g;C2(l,m,c,d,e,n,h,i,j,.04);u=k;return}function fo(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+48|0;k=j+32|0;l=j+16|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=g;C2(k,l,c,d,e,m,h,i,0,.04);u=j;return}function go(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+80|0;j=i+64|0;k=i+48|0;l=i+16|0;m=i+32|0;n=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=b;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[l+8>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=d;d=n+8|0;f[d>>2]=0;f[d+4>>2]=0;f[n>>2]=50397184;f[n+4>>2]=e;Uda(j,k,l,m,n,g,h);u=i;return}function ho(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+80|0;i=h+64|0;j=h+48|0;k=h+16|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=b;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[k+8>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=d;d=m+8|0;f[d>>2]=0;f[d+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=e;Uda(i,j,k,l,m,g,2);u=h;return}function io(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;wra(a,b,c,d);return}function jo(a,b,c){a=a|0;b=b|0;c=c|0;wra(a,b,c,.2);return}function ko(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;WM(d,e);u=c;return}function lo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;zF(g,h,i,j);u=e;return}function mo(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=u;u=u+112|0;k=j+88|0;l=j+72|0;m=j+56|0;n=j+40|0;o=j+16|0;p=j+24|0;q=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=c;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=d;f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];e=p+8|0;f[e>>2]=0;f[e+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=h;h=q+8|0;f[h>>2]=0;f[h+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=i;KZ(k,l,m,n,o,g,p,q);u=j;return}function no(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;D3(e,g,c);u=d;return}function oo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;D3(d,e,-1);u=c;return}function po(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;E3(h,i,j,d,e);u=g;return}function qo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;E3(g,h,i,d,-1);u=e;return}function ro(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;E3(e,g,h,-1,-1);u=d;return}function so(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;h=+aT(e,g,c);u=d;return +h}function to(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;g=+aT(d,e,0);u=c;return +g}function uo(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;a=IZ(c)|0;u=b;return a|0}function vo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0;i=u;u=u+64|0;j=i;k=i+48|0;l=i+32|0;m=i+16|0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=c;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=h;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[j+8>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];n=+XC(k,b,l,j,e,g,m);u=i;return +n}function wo(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0;h=u;u=u+64|0;i=h+16|0;j=h+48|0;k=h+32|0;l=h;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[l+8>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];d=UM()|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2];f[i+8>>2]=f[l+8>>2];f[i+12>>2]=f[l+12>>2];m=+XC(j,b,k,i,e,g,d);u=h;return +m}function xo(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];kma(j,k,l,d,e,g,h);u=i;return}function yo(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;l=i+8|0;f[l>>2]=0;f[l+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[b>>2];f[j+4>>2]=f[b+4>>2];f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];kma(i,j,k,d,e,g,0);u=h;return}function zo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;k=h+8|0;f[k>>2]=0;f[k+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];kma(h,i,j,d,e,8,0);u=g;return}function Ao(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];kma(g,h,i,d,1,8,0);u=e;return}function Bo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;WO(d,e);u=c;return}function Co(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;SO(e,g,h);u=d;return}function Do(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0.0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;i=+N7(g,h,c,d);u=e;return +i}function Eo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=e;Pda(h,i,j,d,k);u=g;return}function Fo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;Pda(g,h,i,d,UM()|0);u=e;return}function Go(a,b,c){a=a|0;b=b|0;c=c|0;TD(a,b,c);return}function Ho(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;tG(a,e,g);u=d;return}function Io(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;tG(a,d,UM()|0);u=c;return}function Jo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;uG(g,h,i,j);u=e;return}function Ko(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;uG(e,g,h,UM()|0);u=d;return}function Lo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;G7(e,g,c);u=d;return}function Mo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;EI(d,e);u=c;return}function No(a,b,c){a=a|0;b=b|0;c=c|0;UD(a,b,c);return}function Oo(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;Oia(a,d);u=c;return}function Po(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d+4|0;i=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=17104896;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=50659328;f[g+4>>2]=b;b=f[c>>2]|0;f[i>>2]=b;Jd(b|0);Xl(h,i);II(e,g,h);g=f[h>>2]|0;if(!g){j=f[i>>2]|0;Yd(j|0);u=d;return}e=h+4|0;h=f[e>>2]|0;if((h|0)!=(g|0))f[e>>2]=h+(~((h+-4-g|0)>>>2)<<2);O5b(g);j=f[i>>2]|0;Yd(j|0);u=d;return}function Qo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;loa(a,e,c);u=d;return}function Ro(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;loa(a,d,0);u=c;return}function So(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+64|0;k=j+40|0;l=j+24|0;m=j+8|0;n=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=d;f[n>>2]=f[e>>2];f[n+4>>2]=f[e+4>>2];Cla(k,l,c,m,n,g,h,i);u=j;return}function To(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+96|0;j=i+72|0;k=i+56|0;l=i+40|0;m=i+32|0;n=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];p[n>>3]=1797693134862315708145274.0e284;p[n+8>>3]=1797693134862315708145274.0e284;p[n+16>>3]=1797693134862315708145274.0e284;p[n+24>>3]=1797693134862315708145274.0e284;Cla(j,k,c,l,m,g,h,n);u=i;return}function Uo(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];p[m>>3]=1797693134862315708145274.0e284;p[m+8>>3]=1797693134862315708145274.0e284;p[m+16>>3]=1797693134862315708145274.0e284;p[m+24>>3]=1797693134862315708145274.0e284;Cla(i,j,c,k,l,g,0,m);u=h;return}function Vo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];p[l>>3]=1797693134862315708145274.0e284;p[l+8>>3]=1797693134862315708145274.0e284;p[l+16>>3]=1797693134862315708145274.0e284;p[l+24>>3]=1797693134862315708145274.0e284;Cla(h,i,c,j,k,1,0,l);u=g;return}function Wo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=d;f[j>>2]=-1;f[j+4>>2]=-1;p[k>>3]=1797693134862315708145274.0e284;p[k+8>>3]=1797693134862315708145274.0e284;p[k+16>>3]=1797693134862315708145274.0e284;p[k+24>>3]=1797693134862315708145274.0e284;Cla(g,h,c,i,j,1,0,k);u=e;return}function Xo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;NE(h,i,j,d,e);u=g;return}function Yo(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;NE(g,h,i,d,-1);u=e;return}function Zo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;NE(e,g,h,1.0,-1);u=d;return}function _o(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;h=+LG(e,b,g);u=d;return +h}function $o(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;e=+LG(d,b,UM()|0);u=c;return +e}function ap(a){a=a|0;var b=0,c=0,d=0.0;b=u;u=u+16|0;c=b;f[c+8>>2]=0;f[c+12>>2]=0;f[c>>2]=16842752;f[c+4>>2]=a;d=+LG(c,4,UM()|0);u=b;return +d}function bp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=d;j=+qH(g,h,c,i);u=e;return +j}function cp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;h=+qH(e,g,c,UM()|0);u=d;return +h}function dp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;g=+qH(d,e,4,UM()|0);u=c;return +g}function ep(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=h;KK(j,k,c,d,e,g,l);u=i;return}function fp(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=b;KK(i,j,c,d,e,g,UM()|0);u=h;return}function gp(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=b;KK(h,i,c,d,e,-1,UM()|0);u=g;return}function hp(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=b;KK(g,h,c,d,4,-1,UM()|0);u=e;return}function ip(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=b;KK(e,g,c,0.0,4,-1,UM()|0);u=d;return}function jp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=b;KK(d,e,1.0,0.0,4,-1,UM()|0);u=c;return}function kp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;SX(e,g,h);u=d;return}function lp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+8|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];h=+Nia(e,g,c);u=d;return +h}function mp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;c=k+8|0;f[c>>2]=0;f[c+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=d;UO(h,i,j,k,e);u=g;return}function np(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=j+8|0;f[c>>2]=0;f[c+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=d;UO(g,h,i,j,0);u=e;return}function op(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;XO(e,b,g);u=d;return}function pp(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0;l=u;u=u+64|0;m=l+48|0;n=l+40|0;o=l+32|0;q=l;r=m+8|0;f[r>>2]=0;f[r+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=a;f[n>>2]=0;f[n+4>>2]=0;a=c+11|0;r=b[a>>0]|0;s=r<<24>>24<0?f[c+4>>2]|0:r&255;if(s|0){r=aD(n,s)|0;Vac(r|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,s|0)|0}f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];p[q>>3]=+p[h>>3];p[q+8>>3]=+p[h+8>>3];p[q+16>>3]=+p[h+16>>3];p[q+24>>3]=+p[h+24>>3];Ima(m,n,o,e,g,q,i,j,k);bD(n);u=l;return}function qp(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0;k=u;u=u+64|0;l=k+48|0;m=k+40|0;n=k+32|0;o=k;q=l+8|0;f[q>>2]=0;f[q+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=a;f[m>>2]=0;f[m+4>>2]=0;a=c+11|0;q=b[a>>0]|0;r=q<<24>>24<0?f[c+4>>2]|0:q&255;if(r|0){q=aD(m,r)|0;Vac(q|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,r|0)|0}f[n>>2]=f[d>>2];f[n+4>>2]=f[d+4>>2];p[o>>3]=+p[h>>3];p[o+8>>3]=+p[h+8>>3];p[o+16>>3]=+p[h+16>>3];p[o+24>>3]=+p[h+24>>3];Ima(l,m,n,e,g,o,i,j,0);bD(m);u=k;return}function rp(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0;j=u;u=u+64|0;k=j+48|0;l=j+40|0;m=j+32|0;n=j;o=k+8|0;f[o>>2]=0;f[o+4>>2]=0;f[k>>2]=50397184;f[k+4>>2]=a;f[l>>2]=0;f[l+4>>2]=0;a=c+11|0;o=b[a>>0]|0;q=o<<24>>24<0?f[c+4>>2]|0:o&255;if(q|0){o=aD(l,q)|0;Vac(o|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,q|0)|0}f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];p[n>>3]=+p[h>>3];p[n+8>>3]=+p[h+8>>3];p[n+16>>3]=+p[h+16>>3];p[n+24>>3]=+p[h+24>>3];Ima(k,l,m,e,g,n,i,8,0);bD(l);u=j;return}function sp(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+64|0;j=i+48|0;k=i+40|0;l=i+32|0;m=i;n=j+8|0;f[n>>2]=0;f[n+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=0;f[k+4>>2]=0;a=c+11|0;n=b[a>>0]|0;o=n<<24>>24<0?f[c+4>>2]|0:n&255;if(o|0){n=aD(k,o)|0;Vac(n|0,((b[a>>0]|0)<0?f[c>>2]|0:c)|0,o|0)|0}f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];p[m>>3]=+p[h>>3];p[m+8>>3]=+p[h+8>>3];p[m+16>>3]=+p[h+16>>3];p[m+24>>3]=+p[h+24>>3];Ima(j,k,l,e,g,m,1,8,0);bD(k);u=i;return}function tp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;F1(g,h,c,d);u=e;return}function up(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;F1(e,g,c,4);u=d;return}function vp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+48|0;d=c+24|0;e=c+8|0;g=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;F1(d,e,g,4);u=c;return}function wp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;L1(g,h,c,d);u=e;return}function xp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;L1(e,g,c,4);u=d;return}function yp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+48|0;d=c+24|0;e=c+8|0;g=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;L1(d,e,g,4);u=c;return}function zp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;eG(e,g,h);u=d;return}function Ap(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;dG(e,g,h);u=d;return}function Bp(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=j+8|0;f[m>>2]=0;f[m+4>>2]=0;f[j>>2]=50397184;f[j+4>>2]=a;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];Ema(j,k,l,d,e,g,h);u=i;return}function Cp(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;l=i+8|0;f[l>>2]=0;f[l+4>>2]=0;f[i>>2]=50397184;f[i+4>>2]=a;f[j>>2]=f[b>>2];f[j+4>>2]=f[b+4>>2];f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];Ema(i,j,k,d,e,g,0);u=h;return}function Dp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;k=h+8|0;f[k>>2]=0;f[k+4>>2]=0;f[h>>2]=50397184;f[h+4>>2]=a;f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];Ema(h,i,j,d,e,8,0);u=g;return}function Ep(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=a;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];Ema(g,h,i,d,1,8,0);u=e;return}function Fp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;aN(h,i,c,d,e);u=g;return}function Gp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;aN(g,h,c,d,-1);u=e;return}function Hp(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+48|0;k=i+32|0;l=i+16|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=d;una(j,k,l,m,e,g,h);u=i;return}function Ip(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+80|0;j=h+64|0;k=h+48|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;una(i,j,k,l,e,g,m);u=h;return}function Jp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+80|0;i=g+64|0;j=g+48|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;una(h,i,j,k,e,0,l);u=g;return}function Kp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e+16|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=d;YP(g,b,c,h);u=e;return}function Lp(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+48|0;i=h+24|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];Lia(i,j,k,d,e,g);u=h;return}function Mp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+24|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];Lia(h,i,j,d,e,1);u=g;return}function Np(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+24|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];Lia(g,h,i,d,0.0,1);u=e;return}function Op(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+24|0;g=d+8|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];Lia(e,g,h,0.0,0.0,1);u=d;return}function Pp(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=u;u=u+80|0;k=j+56|0;l=j+40|0;m=j+24|0;n=j+8|0;o=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;a=l+8|0;f[a>>2]=0;f[a+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=b;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=d;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=e;f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];Nda(k,l,c,m,n,o,h,i);u=j;return}function Qp(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+80|0;j=i+56|0;k=i+40|0;l=i+24|0;m=i+8|0;n=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=d;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=e;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];Nda(j,k,c,l,m,n,h,4);u=i;return}function Rp(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+80|0;i=h+56|0;j=h+40|0;k=h+24|0;l=h+8|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=e;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];Nda(i,j,c,k,l,m,0.0,4);u=h;return}function Sp(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+80|0;h=g+56|0;i=g+40|0;j=g+24|0;k=g+8|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=e;f[l>>2]=-1;f[l+4>>2]=-1;Nda(h,i,c,j,k,l,0.0,4);u=g;return}function Tp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=50397184;f[d+4>>2]=a;ZM(d,b);u=c;return}function Up(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+48|0;c=b+32|0;d=b;e=c+8|0;f[e>>2]=0;f[e+4>>2]=0;f[c>>2]=50397184;f[c+4>>2]=a;p[d>>3]=1.0;a=d+8|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;ZM(c,d);u=b;return}function Vp(a){a=a|0;cG(a);return}function Wp(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+32|0;h=e+16|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;c=jT(g,h,i,d)|0;u=e;return c|0}function Xp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;c=jT(e,g,h,0)|0;u=d;return c|0}function Yp(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+32|0;e=d+16|0;g=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;h=+iP(e,g,c);u=d;return +h}function Zp(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;g=+iP(d,e,300);u=c;return +g}function _p(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33882112;f[e+4>>2]=b;xI(d,e);u=c;return}function $p(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;dP(d,e);u=c;return}function aq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g+16|0;k=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;b=j+8|0;f[b>>2]=0;f[b+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;jE(h,i,j,k,e);u=g;return}function bq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;b=i+8|0;f[b>>2]=0;f[b+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;jE(g,h,i,j,-1);u=e;return}function cq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;jE(e,g,h,UM()|0,-1);u=d;return}function dq(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;var g=0,h=0,i=0,j=0.0;g=u;u=u+32|0;h=g+16|0;i=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;j=+nea(h,i,c,d,e);u=g;return +j}function eq(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;_M(a,d);u=c;return}function fq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=a;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;DX(e,g,h);u=d;return}function gq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;ZL(d,e);u=c;return}function hq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+80|0;h=g+64|0;i=g+48|0;j=g+32|0;k=g+16|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=d;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=e;PZ(h,i,j,k,l);u=g;return}function iq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+64|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=d;PZ(g,h,i,j,UM()|0);u=e;return}function jq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=17104896;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=b;YM(d,e);u=c;return}function kq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];Yna(j,k,l,m,e,g,h);u=i;return}function lq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Yna(i,j,k,l,e,g,m);u=h;return}function mq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;Yna(h,i,j,k,e,0,l);u=g;return}function nq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;Yna(g,h,i,j,1,0,k);u=e;return}function oq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+40|0;k=i+24|0;l=i+8|0;m=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=a;a=k+8|0;f[a>>2]=0;f[a+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=b;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=c;f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];coa(j,k,l,m,e,g,h);u=i;return}function pq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+96|0;i=h+72|0;j=h+56|0;k=h+40|0;l=h+32|0;m=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=a;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=b;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=c;f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;coa(i,j,k,l,e,g,m);u=h;return}function qq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+96|0;h=g+72|0;i=g+56|0;j=g+40|0;k=g+32|0;l=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=b;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=c;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;coa(h,i,j,k,e,0,l);u=g;return}function rq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+96|0;g=e+72|0;h=e+56|0;i=e+40|0;j=e+32|0;k=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;coa(g,h,i,j,1,0,k);u=e;return}function sq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+16|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=a;a=e+8|0;f[a>>2]=0;f[a+4>>2]=0;f[e>>2]=50397184;f[e+4>>2]=b;Dla(d,e);u=c;return}function tq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;Cua(a,j,c,d,e,g,h);u=i;return}function uq(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;Cua(a,i,c,d,e,g,1);u=h;return}function vq(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;Cua(a,h,c,d,e,1,1);u=g;return}function wq(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0;e=u;u=u+48|0;g=e+32|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;Cua(a,g,c,d,h,1,1);u=e;return}function xq(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0;d=u;u=u+64|0;e=d+40|0;g=d+32|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;Cua(a,e,c,g,h,1,1);u=d;return}function yq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+64|0;d=c+40|0;e=c+32|0;g=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;f[e>>2]=0;f[e+4>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;Cua(a,d,1.0,e,g,1,1);u=c;return}function zq(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=0;f[g+4>>2]=0;i=c+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[c+4>>2]|0:j&255;if(k|0){j=aD(g,k)|0;Vac(j|0,((b[i>>0]|0)<0?f[c>>2]|0:c)|0,k|0)|0}f[h>>2]=0;f[h+4>>2]=0;k=d+11|0;c=b[k>>0]|0;i=c<<24>>24<0?f[d+4>>2]|0:c&255;if(!i){_ya(a,g,h);bD(h);bD(g);u=e;return}c=aD(h,i)|0;Vac(c|0,((b[k>>0]|0)<0?f[d>>2]|0:d)|0,i|0)|0;_ya(a,g,h);bD(h);bD(g);u=e;return}function Aq(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=0;f[e+4>>2]=0;h=c+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[c+4>>2]|0:i&255;if(j|0){i=aD(e,j)|0;Vac(i|0,((b[h>>0]|0)<0?f[c>>2]|0:c)|0,j|0)|0}f[g>>2]=0;f[g+4>>2]=0;_ya(a,e,g);bD(g);bD(e);u=d;return}function Bq(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=0;f[g+4>>2]=0;i=c+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[c+4>>2]|0:j&255;if(k|0){j=aD(g,k)|0;Vac(j|0,((b[i>>0]|0)<0?f[c>>2]|0:c)|0,k|0)|0}f[h>>2]=0;f[h+4>>2]=0;k=d+11|0;c=b[k>>0]|0;i=c<<24>>24<0?f[d+4>>2]|0:c&255;if(!i){Vta(a,g,h);bD(h);bD(g);u=e;return}c=aD(h,i)|0;Vac(c|0,((b[k>>0]|0)<0?f[d>>2]|0:d)|0,i|0)|0;Vta(a,g,h);bD(h);bD(g);u=e;return}function Cq(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=0;f[e+4>>2]=0;h=c+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[c+4>>2]|0:i&255;if(j|0){i=aD(e,j)|0;Vac(i|0,((b[h>>0]|0)<0?f[c>>2]|0:c)|0,j|0)|0}f[g>>2]=0;f[g+4>>2]=0;Vta(a,e,g);bD(g);bD(e);u=d;return}function Dq(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=0;f[g+4>>2]=0;i=c+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[c+4>>2]|0:j&255;if(k|0){j=aD(g,k)|0;Vac(j|0,((b[i>>0]|0)<0?f[c>>2]|0:c)|0,k|0)|0}f[h>>2]=0;f[h+4>>2]=0;k=d+11|0;c=b[k>>0]|0;i=c<<24>>24<0?f[d+4>>2]|0:c&255;if(!i){Pwa(a,g,h);bD(h);bD(g);u=e;return}c=aD(h,i)|0;Vac(c|0,((b[k>>0]|0)<0?f[d>>2]|0:d)|0,i|0)|0;Pwa(a,g,h);bD(h);bD(g);u=e;return}function Eq(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=0;f[e+4>>2]=0;h=c+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[c+4>>2]|0:i&255;if(j|0){i=aD(e,j)|0;Vac(i|0,((b[h>>0]|0)<0?f[c>>2]|0:c)|0,j|0)|0}f[g>>2]=0;f[g+4>>2]=0;Pwa(a,e,g);bD(g);bD(e);u=d;return}function Fq(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;f[g>>2]=0;f[g+4>>2]=0;h=c+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[c+4>>2]|0:i&255;if(j|0){i=aD(g,j)|0;Vac(i|0,((b[h>>0]|0)<0?f[c>>2]|0:c)|0,j|0)|0}Uya(a,g,d);bD(g);u=e;return}function Gq(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=c+11|0;h=b[g>>0]|0;i=h<<24>>24<0?f[c+4>>2]|0:h&255;if(i|0){h=aD(e,i)|0;Vac(h|0,((b[g>>0]|0)<0?f[c>>2]|0:c)|0,i|0)|0}Uya(a,e,1);bD(e);u=d;return}function Hq(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e+8|0;h=e;i=f[(f[a>>2]|0)+20>>2]|0;f[g>>2]=0;f[g+4>>2]=0;j=c+11|0;k=b[j>>0]|0;l=k<<24>>24<0?f[c+4>>2]|0:k&255;if(l|0){k=aD(g,l)|0;Vac(k|0,((b[j>>0]|0)<0?f[c>>2]|0:c)|0,l|0)|0}f[h>>2]=0;f[h+4>>2]=0;l=d+11|0;c=b[l>>0]|0;j=c<<24>>24<0?f[d+4>>2]|0:c&255;if(!j){m=li[i&511](a,g,h)|0;bD(h);bD(g);u=e;return m|0}c=aD(h,j)|0;Vac(c|0,((b[l>>0]|0)<0?f[d>>2]|0:d)|0,j|0)|0;m=li[i&511](a,g,h)|0;bD(h);bD(g);u=e;return m|0}function Iq(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+8|0;g=d;h=f[(f[a>>2]|0)+20>>2]|0;f[e>>2]=0;f[e+4>>2]=0;i=c+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[c+4>>2]|0:j&255;if(k|0){j=aD(e,k)|0;Vac(j|0,((b[i>>0]|0)<0?f[c>>2]|0:c)|0,k|0)|0}f[g>>2]=0;f[g+4>>2]=0;k=li[h&511](a,e,g)|0;bD(g);bD(e);u=d;return k|0}function Jq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+8>>2]|0;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;zh[e&2047](a,d);u=c;return}function Kq(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+32|0;m=l+16|0;n=l+8|0;o=l;p=f[(f[a>>2]|0)+44>>2]|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=b;f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];tg[p&3](a,m,c,d,e,n,o,i,j,k);u=l;return}function Lq(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=+j;var k=0,l=0,m=0,n=0,o=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;o=f[(f[a>>2]|0)+44>>2]|0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];tg[o&3](a,l,c,d,e,m,n,i,j,0);u=k;return}function Mq(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;n=f[(f[a>>2]|0)+44>>2]|0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];tg[n&3](a,k,c,d,e,l,m,i,2.0,0);u=j;return}function Nq(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;m=f[(f[a>>2]|0)+44>>2]|0;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];tg[m&3](a,j,c,d,e,k,l,1.05,2.0,0);u=i;return}function Oq(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;l=f[(f[a>>2]|0)+44>>2]|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[k>>2]=0;f[k+4>>2]=0;tg[l&3](a,i,c,d,e,j,k,1.05,2.0,0);u=h;return}function Pq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;k=f[(f[a>>2]|0)+44>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;tg[k&3](a,h,c,d,e,i,j,1.05,2.0,0);u=g;return}function Qq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=f[(f[a>>2]|0)+44>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[i>>2]=0;f[i+4>>2]=0;tg[j&3](a,g,c,d,0.0,h,i,1.05,2.0,0);u=e;return}function Rq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+32>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;oh[i&63](a,g,h,d);u=e;return}function Sq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;oh[h&63](a,e,g,-1.0);u=d;return}function Tq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+36>>2]|0;g=d+8|0;f[g>>2]=0;f[g+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=b;zh[e&2047](a,d);u=c;return}function Uq(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;Rta(a,b,c,d);return}function Vq(a,b,c){a=a|0;b=b|0;c=+c;Rta(a,b,c,1);return}function Wq(a,b){a=a|0;b=b|0;Rta(a,b,16.0,1);return}function Xq(a){a=a|0;Rta(a,500,16.0,1);return}function Yq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e;i=f[(f[a>>2]|0)+32>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;oh[i&63](a,g,h,d);u=e;return}function Zq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;oh[h&63](a,e,g,-1.0);u=d;return}function _q(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;e=f[(f[a>>2]|0)+44>>2]|0;f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];zh[e&2047](a,d);u=c;return}function $q(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];Pma(a,b,e);u=d;return}function ar(a,b){a=a|0;b=+b;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=8;f[d+4>>2]=8;Pma(a,b,d);u=c;return}function br(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c>>2]=8;f[c+4>>2]=8;Pma(a,40.0,c);u=b;return}function cr(a,b){a=a|0;b=+b;wh[f[(f[a>>2]|0)+36>>2]&15](a,b);return}function dr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d;h=f[(f[a>>2]|0)+32>>2]|0;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;_h[h&255](a,e,g);u=d;return}function er(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+8|0;h=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;f[h>>2]=0;f[h+4>>2]=0;c=d+11|0;i=b[c>>0]|0;j=i<<24>>24<0?f[d+4>>2]|0:i&255;if(j|0){i=aD(h,j)|0;Vac(i|0,((b[c>>0]|0)<0?f[d>>2]|0:d)|0,j|0)|0}Fwa(a,g,h);bD(h);u=e;return}function fr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c+8|0;e=c;f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=b;f[e>>2]=0;f[e+4>>2]=0;Fwa(a,d,e);bD(e);u=c;return}function gr(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;f[g>>2]=0;f[g+4>>2]=0;h=d+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[d+4>>2]|0:i&255;if(j|0){i=aD(g,j)|0;Vac(i|0,((b[h>>0]|0)<0?f[d>>2]|0:d)|0,j|0)|0}Dva(a,c,g);bD(g);u=e;return}function hr(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=0;f[d+4>>2]=0;Dva(a,b,d);bD(d);u=c;return}function ir(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e+8|0;h=e;i=g+8|0;f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=33882112;f[g+4>>2]=c;f[h>>2]=0;f[h+4>>2]=0;c=d+11|0;i=b[c>>0]|0;j=i<<24>>24<0?f[d+4>>2]|0:i&255;if(!j){Awa(a,g,h);bD(h);u=e;return}i=aD(h,j)|0;Vac(i|0,((b[c>>0]|0)<0?f[d>>2]|0:d)|0,j|0)|0;Awa(a,g,h);bD(h);u=e;return}function jr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+32|0;d=c+8|0;e=c;g=d+8|0;f[g>>2]=0;f[g+4>>2]=0;f[d>>2]=33882112;f[d+4>>2]=b;f[e>>2]=0;f[e+4>>2]=0;Awa(a,d,e);bD(e);u=c;return}function kr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+32|0;e=d+16|0;g=d+4|0;h=d;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=33882112;f[e+4>>2]=b;b=f[c>>2]|0;f[h>>2]=b;Jd(b|0);lr(g,h);Cwa(a,e,g);e=f[g>>2]|0;if(!e){j=f[h>>2]|0;Yd(j|0);u=d;return}a=g+4|0;while(1){b=f[a>>2]|0;if((b|0)==(e|0))break;c=b+-8|0;f[a>>2]=c;bD(c)}O5b(f[g>>2]|0);j=f[h>>2]|0;Yd(j|0);u=d;return}function lr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+16|0;d=c;e=c+8|0;g=f[b>>2]|0;h=Jf(168707)|0;i=id(g|0,h|0)|0;Yd(h|0);j=+Nd(i|0,25576,d|0);ee(f[d>>2]|0);h=~~j>>>0;Yd(i|0);f[a>>2]=0;i=a+4|0;f[i>>2]=0;f[a+8>>2]=0;if(!h){u=c;return}g=e+4|0;k=a+8|0;l=0;do{m=f[b>>2]|0;f[d>>2]=l;n=Ae(25576,d|0)|0;o=id(m|0,n|0)|0;Yd(n|0);j=+Nd(o|0,9016,d|0);n=f[d>>2]|0;m=~~j>>>0;p=f[m>>2]|0;f[e>>2]=p;f[g>>2]=f[m+4>>2];if(p|0){m=p+-4|0;f[m>>2]=(f[m>>2]|0)+1}ee(n|0);n=f[i>>2]|0;if(n>>>0<(f[k>>2]|0)>>>0){m=f[e>>2]|0;f[n>>2]=m;f[n+4>>2]=f[g>>2];if(!m)q=n;else{n=m+-4|0;f[n>>2]=(f[n>>2]|0)+1;q=f[i>>2]|0}f[i>>2]=q+8}else mw(a,e);bD(e);Yd(o|0);l=l+1|0}while(l>>>0<h>>>0);u=c;return}function mr(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=c+11|0;h=b[g>>0]|0;i=h<<24>>24<0?f[c+4>>2]|0:h&255;if(i|0){h=aD(e,i)|0;Vac(h|0,((b[g>>0]|0)<0?f[c>>2]|0:c)|0,i|0)|0}i=Kra(a,e)|0;bD(e);u=d;return i|0}function nr(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];Rra(a,l,c,d,e,g,h,m,n);u=k;return}function or(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];f[m>>2]=0;f[m+4>>2]=0;Rra(a,k,c,d,e,g,h,l,m);u=j;return}function pr(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=0;f[k+4>>2]=0;f[l>>2]=0;f[l+4>>2]=0;Rra(a,j,c,d,e,g,h,k,l);u=i;return}function qr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=0;f[j+4>>2]=0;f[k>>2]=0;f[k+4>>2]=0;Rra(a,i,c,d,e,g,0,j,k);u=h;return}function rr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;Rra(a,h,c,d,e,3,0,i,j);u=g;return}function sr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[i>>2]=0;f[i+4>>2]=0;Rra(a,g,c,d,1.1,3,0,h,i);u=e;return}function tr(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+32|0;n=m+16|0;o=m+8|0;p=m;f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=b;f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];f[p>>2]=f[k>>2];f[p+4>>2]=f[k+4>>2];Sra(a,n,c,d,e,g,h,i,o,p,l);u=m;return}function ur(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+32|0;m=l+16|0;n=l+8|0;o=l;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=b;f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];Sra(a,m,c,d,e,g,h,i,n,o,0);u=l;return}function vr(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+32|0;l=k+16|0;m=k+8|0;n=k;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=b;f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[n>>2]=0;f[n+4>>2]=0;Sra(a,l,c,d,e,g,h,i,m,n,0);u=k;return}function wr(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=0;f[l+4>>2]=0;f[m>>2]=0;f[m+4>>2]=0;Sra(a,k,c,d,e,g,h,i,l,m,0);u=j;return}function xr(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=0;f[k+4>>2]=0;f[l>>2]=0;f[l+4>>2]=0;Sra(a,j,c,d,e,g,h,0,k,l,0);u=i;return}function yr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=0;f[j+4>>2]=0;f[k>>2]=0;f[k+4>>2]=0;Sra(a,i,c,d,e,g,3,0,j,k,0);u=h;return}function zr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;Sra(a,h,c,d,e,1.1,3,0,i,j,0);u=g;return}function Ar(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+32|0;k=j+16|0;l=j+8|0;m=j;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=b;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];Qra(a,k,c,d,e,g,l,m);u=j;return}function Br(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+32|0;j=i+16|0;k=i+8|0;l=i;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=b;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[l>>2]=0;f[l+4>>2]=0;Qra(a,j,c,d,e,g,k,l);u=i;return}function Cr(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+32|0;i=h+16|0;j=h+8|0;k=h;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;f[j>>2]=0;f[j+4>>2]=0;f[k>>2]=0;f[k+4>>2]=0;Qra(a,i,c,d,e,g,j,k);u=h;return}function Dr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b;f[i>>2]=0;f[i+4>>2]=0;f[j>>2]=0;f[j+4>>2]=0;Qra(a,h,c,d,e,0,i,j);u=g;return}function Er(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b;f[h>>2]=0;f[h+4>>2]=0;f[i>>2]=0;f[i+4>>2]=0;Qra(a,g,c,d,3,0,h,i);u=e;return}function Fr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=b;f[g>>2]=0;f[g+4>>2]=0;f[h>>2]=0;f[h+4>>2]=0;Qra(a,e,c,1.1,3,0,g,h);u=d;return}function Gr(a){a=a|0;var b=0;mf(236650,7,26960,168727,1,1);mf(236650,6,26988,168736,1,1);mf(236650,5,27012,168744,2,1);mf(155261,7,27032,168751,1,2);mf(155261,6,27060,168411,2,3);mf(155268,7,27084,168751,2,3);mf(155268,6,27112,168411,3,4);mf(155268,5,27136,168419,6,10);mf(230528,10,27156,168760,1,1);mf(230528,9,27196,168772,1,1);mf(230528,8,27232,168783,1,1);mf(230528,7,27264,168793,1,1);mf(230528,6,26216,168411,4,5);mf(155281,10,27292,168802,1,1);mf(155281,9,27332,168814,1,1);mf(155281,8,27368,168825,1,1);mf(155281,7,27400,168835,1,1);mf(155281,6,26988,168736,1,2);mf(155292,8,27368,168825,1,2);mf(155292,7,27400,168835,1,2);mf(155292,6,26988,168736,1,3);mf(155304,8,27428,168844,1,3);mf(155304,7,27460,168854,1,5);mf(155304,6,27488,168863,1,7);mf(155304,5,27512,168426,96,207);mf(155304,4,26240,167046,208,166);mf(155314,9,27532,168871,1,2);mf(155314,8,27568,168882,1,2);mf(155314,7,27600,168892,1,2);mf(155314,6,27628,168901,88,97);mf(155321,10,27652,168909,1,2);mf(155321,9,27692,168921,1,2);mf(155321,8,27728,168932,1,2);mf(155321,7,27760,168942,62,89);mf(155321,6,27628,168901,88,98);mf(155327,4,27788,167046,209,167);mf(253953,8,27804,168951,1,1);mf(155335,6,27836,168901,90,99);mf(155335,5,27860,168426,100,210);mf(155335,4,27788,167046,209,168);mf(155339,8,27880,168961,1,1);mf(155339,7,27912,168971,1,1);mf(236558,5,27940,168980,1,7);mf(253217,3,27960,168445,13,15);mf(241381,7,27972,168751,4,4);mf(241381,6,26216,168411,4,6);mf(155351,5,27860,168426,100,211);mf(155351,4,27788,167046,209,169);mf(155363,4,26364,167046,212,170);mf(155363,3,26352,167041,171,905);mf(155375,5,27860,168426,100,213);mf(155375,4,27788,167046,209,172);mf(155386,5,27860,168426,100,214);mf(155386,4,27788,167046,209,173);mf(155398,6,28e3,168901,91,101);mf(155398,5,28024,168426,102,215);mf(155398,4,28044,167046,216,174);mf(155403,2,28060,167052,517,906);mf(155416,8,28068,168987,122,63);mf(155416,7,28100,168942,64,92);mf(155416,6,28128,168901,93,103);mf(155416,5,28152,168426,104,217);mf(233250,7,28172,168892,3,3);mf(232409,8,28200,168987,123,65);mf(232409,7,28232,168942,66,94);mf(155426,11,28260,168997,1,1);mf(155451,12,28304,169010,1,1);mf(155451,11,28352,169024,1,2);mf(155451,10,28396,169037,3,93);mf(155451,9,28436,169049,94,124);mf(155451,8,28472,168987,125,67);mf(155451,7,28504,168942,68,95);mf(191110,6,28532,168901,96,105);mf(191110,5,28556,168426,106,218);mf(267788,8,28576,168987,126,69);mf(267788,7,28608,168942,70,97);mf(267788,6,28636,168901,98,107);mf(267788,5,28660,168426,108,219);mf(173960,5,28680,168426,109,220);mf(233717,4,28700,168475,5,14);mf(234994,5,28716,168179,97,61);mf(234994,4,28736,167080,62,264);mf(234994,3,28752,167075,265,518);mf(235805,7,28764,169060,7,71);mf(235805,6,28792,168186,72,98);mf(235805,5,28816,168179,99,63);mf(253309,3,27960,168445,13,16);mf(253309,2,28836,168501,17,13);mf(178597,5,27012,168744,2,2);mf(178597,4,28844,167418,11,14);mf(178597,3,26352,167041,171,907);mf(216290,5,28860,168426,110,221);mf(216290,4,28880,167046,222,175);mf(216290,3,26352,167041,171,908);mf(216507,4,27788,167046,209,176);mf(193115,9,28896,169049,95,127);mf(193115,8,28932,168987,128,71);mf(155472,7,28964,169069,1,2);mf(155472,6,27488,168863,1,8);mf(155485,6,27628,168901,88,111);mf(155485,5,27512,168426,96,223);mf(155485,4,26240,167046,208,177);mf(175572,2,28992,167052,519,673);mf(228810,5,27512,168426,96,224);mf(228810,4,26240,167046,208,178);mf(266234,5,27512,168426,96,225);mf(266234,4,26240,167046,208,179);mf(200039,2,28836,168501,17,14);mf(171121,5,27512,168426,96,226);mf(171121,4,26240,167046,208,180);mf(171121,3,26352,167041,171,909);mf(155503,8,29e3,168987,129,72);mf(155503,7,29032,168942,73,99);mf(155503,6,29060,168901,100,112);mf(155503,5,29084,168426,113,227);mf(155503,4,26364,167046,212,181);mf(271740,6,27628,168901,88,114);mf(271740,5,27512,168426,96,228);mf(155510,7,29104,168942,74,101);mf(155510,6,29132,168901,102,115);mf(155538,6,29156,169078,3,2);mf(155538,5,29180,168419,9,12);mf(155538,4,27788,167046,209,182);mf(155545,5,29200,169086,1,1);mf(155545,4,29220,169093,4,1);mf(268415,10,29236,169037,4,96);mf(268415,9,29276,169049,97,130);mf(268415,8,29312,168987,131,75);mf(268415,7,29344,168942,76,103);mf(268415,6,29372,168901,104,116);mf(268415,5,29396,168426,117,229);mf(200242,4,29416,167080,64,266);mf(200242,3,29432,167075,267,520);mf(267973,11,29444,169099,1,1);mf(267973,10,29488,169112,1,1);mf(267973,9,29528,169124,1,1);mf(267973,8,29564,169135,1,1);mf(155553,6,29596,168901,105,118);mf(155553,5,29620,168426,119,230);mf(155553,4,29640,167046,231,183);mf(155562,8,29656,168987,132,77);mf(233897,3,26352,167041,171,910);mf(155575,8,29e3,168987,129,78);mf(155575,7,29032,168942,73,106);mf(155575,6,29060,168901,100,120);mf(155575,5,29084,168426,113,232);mf(155575,4,26364,167046,212,184);mf(360840,4,29688,167080,65,233);mf(191394,3,26352,167041,171,911);mf(155581,8,29704,169145,1,2);mf(155581,7,29736,168892,4,4);mf(155581,6,29764,168901,107,121);mf(155581,5,29788,168426,122,234);mf(255529,7,29808,168942,79,108);mf(255529,6,29836,168901,109,123);mf(361053,7,29860,169155,1,1);mf(361053,6,29888,169164,2,3);mf(361053,5,29912,168468,4,6);mf(361053,4,29932,168475,7,15);mf(253399,2,29948,167052,521,912);mf(234045,7,27264,168793,1,2);mf(192859,4,26240,167046,208,185);mf(212409,8,29956,169172,1,1);mf(212409,7,29988,169182,1,1);mf(271329,3,30016,167075,268,186);mf(155590,2,26932,167052,510,674);mf(271248,3,30016,167075,268,187);mf(155608,4,30028,169191,1,3);mf(265531,4,30044,167080,66,235);mf(265531,3,30060,167075,269,188);mf(231562,10,30072,169197,1,1);mf(231562,9,30112,169209,1,1);mf(231562,8,30148,169220,1,2);mf(231562,7,30180,168751,5,5);mf(231562,6,26216,168411,4,7);mf(155628,11,30208,169230,1,1);mf(155628,10,30252,169243,1,1);mf(155628,9,30292,169209,2,2);mf(252451,8,30328,168987,133,80);mf(252451,7,30360,168942,81,110);mf(349482,5,30388,168419,10,13);mf(349482,4,30408,167046,236,189);mf(183604,3,30424,167041,190,913);mf(174258,5,30436,168426,124,237);mf(216837,9,30456,169049,98,134);mf(234255,4,26240,167046,208,191);mf(234255,3,26352,167041,171,914);mf(155649,6,29132,168901,102,125);mf(155649,5,30492,168426,126,238);mf(155649,4,30512,167046,239,192);mf(200158,4,30528,168475,8,16);mf(200158,3,30544,168445,17,18);mf(216659,2,30556,167052,522,675);mf(171512,8,30564,169255,1,2);mf(171512,7,30596,169155,3,3);mf(267387,8,30624,168987,135,82);mf(267387,7,30656,168942,83,111);mf(267387,6,30684,168901,112,127);mf(267387,5,30708,168426,128,240);mf(191436,3,26352,167041,171,915);mf(236960,4,27788,167046,209,193);mf(241576,5,30728,169265,1,1);mf(251930,6,30748,168901,113,129);mf(251930,5,28680,168426,109,241);mf(442370,4,27788,167046,209,194);mf(175651,3,30772,167075,270,195);mf(175651,2,30784,167052,523,916);mf(175700,5,30792,168426,130,242);mf(175700,4,30512,167046,239,196);mf(240819,4,26240,167046,208,197);mf(177947,3,30424,167041,190,917);mf(155659,4,27788,167046,209,198);mf(155663,2,29948,167052,521,918);mf(178085,4,30812,167046,243,199);mf(271584,3,30828,167075,271,200);mf(271584,2,30840,167052,524,919);mf(265816,9,30848,169049,99,136);mf(265816,8,30884,168987,137,84);mf(265816,7,30916,168942,85,114);mf(265816,6,29764,168901,107,131);mf(265816,5,29788,168426,122,244);mf(155675,6,29156,169078,3,3);mf(155675,5,29180,168419,9,14);mf(155675,4,27788,167046,209,201);mf(176338,4,30944,168475,9,18);mf(176338,3,30960,168445,19,19);mf(176338,2,28836,168501,17,15);mf(155684,5,30972,168468,5,10);mf(155684,4,28700,168475,5,20);mf(155684,3,26408,168445,21,20);mf(178865,8,30992,169272,3,1);mf(178865,7,31024,168727,3,2);mf(178865,6,26988,168736,1,4);mf(178865,5,27012,168744,2,4);mf(178865,4,28844,167418,11,15);mf(178865,3,26352,167041,171,920);mf(212961,4,26364,167046,212,202);mf(259071,4,31052,168475,11,22);mf(191267,6,28532,168901,96,132);mf(191267,5,28556,168426,106,245);mf(374991,4,31068,169282,8,1);mf(155690,10,31084,169288,1,2);mf(155690,9,31124,169300,1,2);mf(155690,8,31160,169311,2,1);mf(155690,7,31192,169069,3,4);mf(229418,5,31220,168426,133,246);mf(229418,4,31240,167046,247,203);mf(229418,3,26352,167041,171,921);mf(229742,5,31220,168426,133,248);mf(229742,4,31240,167046,247,204);mf(229742,3,26352,167041,171,922);mf(155698,4,31256,167046,249,205);mf(155704,4,31256,167046,249,206);mf(267619,8,30624,168987,135,86);mf(267619,7,30656,168942,83,115);mf(267619,6,30684,168901,112,134);mf(267619,5,30708,168426,128,250);mf(184107,6,27628,168901,88,135);mf(184107,5,27512,168426,96,251);mf(269950,8,31272,168987,138,87);mf(269950,7,31304,168942,88,116);mf(269950,6,31332,168901,117,136);mf(192939,5,31356,168426,137,252);mf(255795,7,27084,168751,2,6);mf(255795,6,27112,168411,3,8);mf(255795,5,27136,168419,6,15);mf(255795,4,28044,167046,216,207);mf(251366,9,31376,169321,1,2);mf(251366,8,31412,168932,2,5);mf(251366,7,31444,168942,89,118);mf(251366,6,31472,168901,119,138);mf(183910,3,26468,167041,208,923);mf(183910,2,31496,169332,924,1443);mf(155710,2,31504,169332,925,1444);mf(200760,5,31512,168179,100,67);mf(200760,4,31532,167080,68,272);mf(191927,4,30528,168475,8,23);mf(191927,3,30544,168445,17,21);mf(378637,3,31548,167041,209,926);mf(155721,3,26352,167041,171,927);mf(155726,6,27836,168901,90,139);mf(155726,5,27860,168426,100,253);mf(155726,4,27788,167046,209,210);mf(355105,6,31560,169336,1,1);mf(183977,2,30784,167052,523,928);mf(212877,4,26364,167046,212,211);mf(182212,3,26352,167041,171,929);mf(217447,6,31584,168901,120,140);mf(217447,5,31608,168426,141,254);mf(183790,3,30424,167041,190,930);mf(270644,8,31628,168987,139,90);mf(270644,7,31660,168942,91,121);mf(270644,6,31688,168901,122,142);mf(270644,5,31712,168426,143,255);mf(270887,8,31628,168987,139,92);mf(270887,7,31660,168942,91,123);mf(270887,6,31688,168901,122,144);mf(270887,5,31712,168426,143,256);mf(266073,3,26352,167041,171,931);mf(155735,7,31732,169344,1,1);mf(155735,6,31760,169353,1,1);mf(155735,5,31784,169361,1,1);mf(155735,4,31804,169368,1,9);mf(155735,3,31820,169374,1,16);mf(155735,2,26448,167052,525,932);mf(155749,3,31832,167075,273,212);mf(155749,2,31844,167052,526,933);mf(155766,3,31832,167075,273,213);mf(155766,2,31844,167052,526,934);mf(155785,3,31832,167075,273,214);mf(155785,2,31844,167052,526,935);mf(155807,3,31852,167075,274,215);mf(155807,2,31844,167052,526,936);_d(17304,9032,9048,0,167033,676,167036,0,167036,0,155824,167038,1445);a=L5b(4)|0;f[a>>2]=275;Ee(17304,155838,4,31864,167080,69,a|0,0);a=L5b(4)|0;f[a>>2]=527;Ee(17304,155838,3,31880,167075,276,a|0,0);yd(17304,1,31892,167033,677,22);yd(17304,13,31896,169459,1,1);yd(17304,2,31948,167052,528,678);wf(17304,155843,1,31956,167033,679,1446);wf(17304,155868,1,31956,167033,679,1447);a=L5b(4)|0;f[a>>2]=937;Ee(17304,350579,3,31960,167041,216,a|0,0);a=L5b(4)|0;f[a>>2]=2;Ee(17304,352012,11,31972,169474,1,a|0,0);a=L5b(4)|0;f[a>>2]=1;Ee(17304,352012,10,32016,169487,1,a|0,0);a=L5b(4)|0;f[a>>2]=1;Ee(17304,352012,9,32056,169499,1,a|0,0);a=L5b(4)|0;f[a>>2]=2;Ee(17304,352012,8,32092,169311,3,a|0,0);a=L5b(4)|0;f[a>>2]=5;Ee(17304,352012,7,32124,169069,4,a|0,0);a=L5b(4)|0;f[a>>2]=11;Ee(17304,352012,6,32152,168863,5,a|0,0);a=L5b(4)|0;f[a>>2]=257;Ee(17304,352012,5,32176,168426,145,a|0,0);a=L5b(4)|0;f[a>>2]=4;b=L5b(4)|0;f[b>>2]=4;Ud(17304,350407,8824,167052,529,a|0,8824,167041,217,b|0);b=L5b(4)|0;f[b>>2]=12;a=L5b(4)|0;f[a>>2]=12;Ud(17304,350415,8824,167052,529,b|0,8824,167041,217,a|0);a=L5b(4)|0;f[a>>2]=20;b=L5b(4)|0;f[b>>2]=20;Ud(17304,350425,8824,167052,529,a|0,8824,167041,217,b|0);b=L5b(4)|0;f[b>>2]=28;a=L5b(4)|0;f[a>>2]=28;Ud(17304,350541,8824,167052,529,b|0,8824,167041,217,a|0);a=L5b(4)|0;f[a>>2]=36;b=L5b(4)|0;f[b>>2]=36;Ud(17304,350437,25568,167052,530,a|0,25568,167041,218,b|0);b=L5b(4)|0;f[b>>2]=40;a=L5b(4)|0;f[a>>2]=40;Ud(17304,350443,25568,167052,530,b|0,25568,167041,218,a|0);a=L5b(4)|0;f[a>>2]=48;b=L5b(4)|0;f[b>>2]=48;Ud(17304,350550,25608,168501,22,a|0,25608,167413,17,b|0);b=L5b(4)|0;f[b>>2]=56;a=L5b(4)|0;f[a>>2]=56;Ud(17304,350457,25568,167052,530,b|0,25568,167041,218,a|0);a=L5b(4)|0;f[a>>2]=64;b=L5b(4)|0;f[b>>2]=64;Ud(17304,350475,25608,168501,22,a|0,25608,167413,17,b|0);b=L5b(4)|0;f[b>>2]=72;a=L5b(4)|0;f[a>>2]=72;Ud(17304,350490,25520,167052,531,b|0,25520,167041,219,a|0);a=L5b(4)|0;f[a>>2]=76;b=L5b(4)|0;f[b>>2]=76;Ud(17304,155893,8400,167052,532,a|0,8400,167041,220,b|0);b=L5b(4)|0;f[b>>2]=140;a=L5b(4)|0;f[a>>2]=140;Ud(17304,350506,25568,167052,530,b|0,25568,167041,218,a|0);a=L5b(4)|0;f[a>>2]=144;b=L5b(4)|0;f[b>>2]=144;Ud(17304,350514,25520,167052,531,a|0,25520,167041,219,b|0);_d(9064,9080,9096,11e3,167033,680,167033,681,167033,682,155905,167038,1448);b=L5b(4)|0;f[b>>2]=16;Ee(9064,440399,5,32196,168419,12,b|0,0);b=L5b(4)|0;f[b>>2]=221;Ee(9064,440399,4,32216,167046,258,b|0,0);b=L5b(4)|0;f[b>>2]=938;Ee(9064,363007,3,32232,167041,222,b|0,0);_d(9112,9128,9144,9064,167033,683,167033,684,167033,685,155926,167038,1449);yd(9112,4,32244,169368,2,10);yd(9112,3,32260,169374,2,18);yd(9112,2,32272,167052,533,939);yd(9112,1,32280,167033,686,1450);b=L5b(4)|0;f[b>>2]=17;Ee(9112,440399,5,32284,168419,13,b|0,0);b=L5b(4)|0;f[b>>2]=223;Ee(9112,440399,4,32304,167046,259,b|0,0);lf(9160,9112,155951,0,167033,687,207089,23,167033,688,167038,1451);_d(9168,9184,9200,11e3,167033,689,167033,690,167033,691,155981,167038,1452);b=L5b(4)|0;f[b>>2]=940;Ee(9168,155987,3,32320,167041,224,b|0,0);yd(9168,3,32332,169799,1,2);yd(9168,2,32344,169804,1,13);yd(9168,1,32352,167033,692,1453);b=L5b(8)|0;f[b>>2]=52;f[b+4>>2]=1;Ee(9168,156004,2,32356,169332,941,b|0,1);b=L5b(4)|0;f[b>>2]=14;Ee(9168,156019,3,32364,167413,19,b|0,0);b=L5b(8)|0;f[b>>2]=48;f[b+4>>2]=1;Ee(9168,156032,2,32376,167052,534,b|0,1);b=L5b(8)|0;f[b>>2]=40;f[b+4>>2]=1;Ee(9168,156049,2,32384,168501,23,b|0,1);b=L5b(4)|0;f[b>>2]=225;Ee(9168,440399,4,32392,167046,260,b|0,0);lf(9216,9168,156062,0,167033,693,207089,24,167033,694,167038,1454);_d(11e3,9224,9240,0,167033,695,167036,0,167036,0,156073,167038,1455);_d(9024,9256,9272,0,167033,696,167036,0,167036,0,156083,167038,1456);b=L5b(4)|0;f[b>>2]=226;Ee(9024,369316,4,32408,167046,261,b|0,0);b=L5b(4)|0;f[b>>2]=942;Ee(9024,369316,3,32424,167041,227,b|0,0);b=L5b(4)|0;f[b>>2]=228;Ee(9024,443123,3,32436,167075,277,b|0,0);b=L5b(4)|0;f[b>>2]=943;Ee(9024,443123,2,32448,167052,535,b|0,0);b=L5b(4)|0;f[b>>2]=229;Ee(9024,156091,4,32456,167046,262,b|0,0);b=L5b(4)|0;f[b>>2]=944;Ee(9024,156091,3,32472,167041,230,b|0,0);b=L5b(4)|0;f[b>>2]=231;Ee(9024,156100,4,32484,167046,263,b|0,0);_d(9288,9296,9312,0,167033,697,167036,0,167036,0,156109,167038,1457);b=L5b(4)|0;f[b>>2]=536;Ee(9288,155838,3,32500,167075,278,b|0,0);b=L5b(4)|0;f[b>>2]=3;Ee(9288,156127,10,32512,169288,2,b|0,0);b=L5b(4)|0;f[b>>2]=3;Ee(9288,156127,9,32552,169300,2,b|0,0);b=L5b(4)|0;f[b>>2]=3;Ee(9288,156127,8,32588,169311,4,b|0,0);b=L5b(4)|0;f[b>>2]=6;Ee(9288,156127,7,32620,169069,5,b|0,0);b=L5b(4)|0;f[b>>2]=14;Ee(9288,156127,6,32648,168863,6,b|0,0);b=L5b(4)|0;f[b>>2]=264;Ee(9288,156127,5,32672,168426,146,b|0,0);yd(9288,1,32692,167033,698,25);yd(9288,2,32696,167052,537,699);b=L5b(4)|0;f[b>>2]=2;Ee(9288,156145,12,32704,169994,1,b|0,0);b=L5b(4)|0;f[b>>2]=3;Ee(9288,156145,11,32752,170008,1,b|0,0);b=L5b(4)|0;f[b>>2]=3;Ee(9288,156145,10,32796,170021,1,b|0,0);b=L5b(4)|0;f[b>>2]=5;Ee(9288,156145,9,32836,170033,1,b|0,0);b=L5b(4)|0;f[b>>2]=6;Ee(9288,156145,8,32872,169145,3,b|0,0);b=L5b(4)|0;f[b>>2]=7;Ee(9288,156145,7,32904,168892,6,b|0,0);b=L5b(4)|0;f[b>>2]=147;Ee(9288,156145,6,32932,168901,124,b|0,0);b=L5b(8)|0;f[b>>2]=700;f[b+4>>2]=0;Ee(9288,183315,2,32956,167052,538,b|0,0);b=L5b(4)|0;f[b>>2]=2;Ee(9288,352012,9,32964,170044,4,b|0,0);b=L5b(4)|0;f[b>>2]=2;Ee(9288,352012,8,33e3,170055,4,b|0,0);b=L5b(4)|0;f[b>>2]=1;Ee(9288,352012,7,33032,170065,4,b|0,0);b=L5b(4)|0;f[b>>2]=4;Ee(9288,352012,6,33060,169078,7,b|0,0);b=L5b(4)|0;f[b>>2]=18;Ee(9288,352012,5,33084,168419,15,b|0,0);b=L5b(4)|0;f[b>>2]=232;Ee(9288,352012,4,33104,167046,265,b|0,0);Dd(156163,25568,67108864);Dd(156175,25568,50331648);Dd(156187,25568,16777216);Dd(156199,25568,50331648);Dd(156209,25568,33554432);Dd(156222,25568,1);Dd(156249,25568,0);Dd(156272,25568,0);Dd(156288,25568,4);Dd(156303,25568,16);Dd(156319,25568,2);Dd(156334,25568,4);Dd(156352,25568,4);Dd(156371,25568,1);Dd(156388,25568,5);Dd(156407,25568,3);Dd(156419,25568,1);Dd(156444,25568,8);Dd(156468,25568,4);Dd(156496,25568,2);Dd(156516,25568,-1);Dd(156528,25568,1);Dd(156538,25568,0);Dd(156545,25568,4);Dd(156558,25568,3);Dd(156573,25568,0);Dd(156586,25568,5);Dd(156598,25568,1);Dd(156610,25568,2);Dd(156624,25568,1);Dd(156642,25568,2);Dd(156662,25568,4);Dd(156685,25568,3);Dd(156706,25568,0);Dd(156713,25568,2);Dd(156720,25568,1);Dd(156727,25568,4);Dd(156734,25568,3);Dd(156741,25568,5);Dd(156748,25568,0);Dd(156764,25568,1);Dd(156778,25568,8);Dd(156792,25568,11);Dd(156805,25568,9);Dd(156818,25568,2);Dd(156831,25568,5);Dd(156846,25568,12);Dd(156862,25568,10);Dd(156876,25568,4);Dd(156893,25568,7);Dd(156909,25568,6);Dd(156925,25568,3);Dd(156941,25568,22);Dd(156958,25568,12);Dd(156975,25568,0);Dd(156990,25568,6);Dd(157005,25568,52);Dd(157019,25568,68);Dd(157038,25568,40);Dd(157052,25568,66);Dd(157071,25568,44);Dd(157085,25568,50);Dd(157099,25568,4);Dd(157113,25568,2);Dd(157128,25568,32);Dd(157142,25568,36);Dd(157158,25568,82);Dd(157172,25568,128);Dd(157191,25568,128);Dd(157210,25568,132);Dd(157229,25568,24);Dd(157246,25568,28);Dd(157264,25568,31);Dd(157282,25568,25);Dd(157299,25568,29);Dd(157317,25568,14);Dd(157334,25568,18);Dd(157352,25568,21);Dd(157370,25568,15);Dd(157387,25568,19);Dd(157405,25568,1);Dd(157420,25568,26);Dd(157438,25568,16);Dd(157456,25568,10);Dd(157472,25568,3);Dd(157487,25568,5);Dd(157503,25568,130);Dd(157523,25568,130);Dd(157543,25568,134);Dd(157563,25568,46);Dd(157581,25568,139);Dd(157600,25568,135);Dd(157621,25568,62);Dd(157643,25568,86);Dd(157662,25568,48);Dd(157680,25568,141);Dd(157699,25568,137);Dd(157720,25568,64);Dd(157742,25568,47);Dd(157760,25568,140);Dd(157779,25568,136);Dd(157800,25568,63);Dd(157822,25568,87);Dd(157841,25568,49);Dd(157859,25568,142);Dd(157878,25568,138);Dd(157899,25568,65);Dd(157921,25568,49);Dd(157939,25568,142);Dd(157958,25568,138);Dd(157979,25568,65);Dd(158001,25568,89);Dd(158020,25568,47);Dd(158038,25568,140);Dd(158057,25568,136);Dd(158078,25568,63);Dd(158100,25568,48);Dd(158118,25568,141);Dd(158137,25568,137);Dd(158158,25568,64);Dd(158180,25568,88);Dd(158199,25568,46);Dd(158217,25568,139);Dd(158236,25568,135);Dd(158257,25568,62);Dd(158279,25568,143);Dd(158298,25568,8);Dd(158313,25568,30);Dd(158331,25568,20);Dd(158349,25568,9);Dd(158365,25568,8);Dd(158380,25568,9);Dd(158396,25568,60);Dd(158410,25568,72);Dd(158429,25568,61);Dd(158443,25568,73);Dd(158462,25568,54);Dd(158476,25568,70);Dd(158495,25568,55);Dd(158509,25568,71);Dd(158528,25568,74);Dd(158543,25568,76);Dd(158558,25568,75);Dd(158573,25568,77);Dd(158588,25568,56);Dd(158602,25568,78);Dd(158617,25568,79);Dd(158632,25568,57);Dd(158646,25568,58);Dd(158660,25568,80);Dd(158675,25568,81);Dd(158690,25568,59);Dd(158704,25568,4);Dd(158718,25568,23);Dd(158735,25568,13);Dd(158752,25568,2);Dd(158767,25568,7);Dd(158782,25568,53);Dd(158796,25568,69);Dd(158815,25568,41);Dd(158829,25568,67);Dd(158848,25568,45);Dd(158862,25568,51);Dd(158876,25568,0);Dd(158891,25568,33);Dd(158905,25568,37);Dd(158921,25568,83);Dd(158935,25568,127);Dd(158954,25568,127);Dd(158973,25568,131);Dd(158992,25568,3);Dd(159007,25568,27);Dd(159025,25568,17);Dd(159043,25568,5);Dd(159059,25568,11);Dd(159075,25568,1);Dd(159090,25568,129);Dd(159110,25568,129);Dd(159130,25568,133);Dd(159150,25568,125);Dd(159167,25568,34);Dd(159181,25568,35);Dd(159195,25568,38);Dd(159211,25568,39);Dd(159227,25568,84);Dd(159241,25568,105);Dd(159261,25568,105);Dd(159281,25568,95);Dd(159301,25568,97);Dd(159321,25568,112);Dd(159341,25568,112);Dd(159361,25568,112);Dd(159381,25568,120);Dd(159401,25568,120);Dd(159421,25568,120);Dd(159441,25568,103);Dd(159461,25568,122);Dd(159481,25568,101);Dd(159500,25568,101);Dd(159519,25568,91);Dd(159538,25568,93);Dd(159557,25568,108);Dd(159576,25568,108);Dd(159595,25568,108);Dd(159614,25568,116);Dd(159633,25568,116);Dd(159652,25568,116);Dd(159671,25568,99);Dd(159690,25568,118);Dd(159709,25568,106);Dd(159728,25568,106);Dd(159748,25568,106);Dd(159768,25568,106);Dd(159788,25568,106);Dd(159808,25568,123);Dd(159828,25568,123);Dd(159848,25568,123);Dd(159868,25568,124);Dd(159888,25568,124);Dd(159908,25568,124);Dd(159928,25568,106);Dd(159948,25568,124);Dd(159968,25568,85);Dd(159982,25568,104);Dd(160002,25568,104);Dd(160022,25568,94);Dd(160042,25568,96);Dd(160062,25568,111);Dd(160082,25568,111);Dd(160102,25568,111);Dd(160122,25568,119);Dd(160142,25568,119);Dd(160162,25568,119);Dd(160182,25568,102);Dd(160202,25568,121);Dd(160222,25568,100);Dd(160241,25568,100);Dd(160260,25568,90);Dd(160279,25568,92);Dd(160298,25568,107);Dd(160317,25568,107);Dd(160336,25568,107);Dd(160355,25568,115);Dd(160374,25568,115);Dd(160393,25568,115);Dd(160412,25568,98);Dd(160431,25568,117);Dd(160450,25568,99);Dd(160468,25568,103);Dd(160487,25568,106);Dd(160506,25568,98);Dd(160524,25568,102);Dd(160543,25568,93);Dd(160562,25568,97);Dd(160582,25568,106);Dd(160602,25568,92);Dd(160621,25568,96);Dd(160641,25568,126);Dd(160658,25568,1);Dd(160676,25568,2);Dd(160694,25568,3);Dd(160712,25568,16);Dd(160723,25568,1);Dd(160736,25568,8);Dd(160747,25568,4);Dd(160759,25568,0);Dd(160775,25568,2);Dd(160789,25568,1);Dd(160801,25568,4);Dd(160810,25568,3);Dd(160826,25568,2);Dd(160837,25568,0);Dd(160847,25568,16);Dd(160861,25568,4);Dd(160871,25568,1);Dd(160882,25568,64);Dd(160900,25568,16);Dd(160919,25568,1);Dd(160931,25568,32);Dd(160947,25568,4);Dd(160956,25568,2);Dd(160966,25568,3);Dd(160973,25568,5);Dd(160983,25568,7);Dd(160994,25568,1);Dd(161002,25568,4);Dd(161011,25568,2);Dd(161019,25568,0);Dd(161036,25568,1);Dd(161053,25568,3);Dd(161065,25568,5);Dd(161077,25568,0);Dd(161095,25568,-1);Dd(161105,25568,6);Dd(161117,25568,-1);Dd(161124,25568,65536);Dd(161146,25568,131072);Dd(161166,25568,3);Dd(161187,25568,5);Dd(161214,25568,2);Dd(161234,25568,1);Dd(161253,25568,7);Dd(161281,25568,6);Dd(161309,25568,0);Dd(161330,25568,4);Dd(161351,25568,16);Dd(161363,25568,32);Dd(161378,25568,2);Dd(161393,25568,8);Dd(161407,25568,1);Dd(161420,25568,6);Dd(161433,25568,64);Dd(161448,25568,0);Dd(161462,25568,2);Dd(161476,25568,4);Dd(161489,25568,5);Dd(161502,25568,3);Dd(161515,25568,3);Dd(161531,25568,7);Dd(161550,25568,16);Dd(161564,25568,2);Dd(161583,25568,64);Dd(161602,25568,0);Dd(161626,25568,24);Dd(161650,25568,56);Dd(161674,25568,8);Dd(161697,25568,16);Dd(161721,25568,4);Dd(161744,25568,4);Dd(161763,25568,2);Dd(161789,25568,0);Dd(161806,25568,0);Dd(161828,25568,1);Dd(161855,25568,1);Dd(161873,25568,65);Dd(161898,25568,5);Dd(161914,25568,2);Dd(161932,25568,0);Dd(161954,25568,1);Dd(161975,25568,4);Dd(161995,25568,3);Dd(162016,25568,0);Dd(162023,25568,2);Dd(162031,25568,1);Dd(162038,25568,1);Dd(162056,25568,0);Dd(162074,25568,2);Dd(162084,25568,3);Dd(162094,25568,1);Dd(162103,25568,2);Dd(162112,25568,4);Dd(162121,25568,3);Dd(162143,25568,1);Dd(162158,25568,4);Dd(162177,25568,0);Dd(162192,25568,3);Dd(162210,25568,2);Dd(162228,25568,5);Dd(162243,25568,64);Dd(162273,25568,0);Dd(162293,25568,3);Dd(162308,25568,2);Dd(162326,25568,1);Dd(162346,25568,0);Dd(162361,25568,6);Dd(162378,25568,2);Dd(162393,25568,0);Dd(162408,25568,1);Dd(162426,25568,3);Dd(162437,25568,5);Dd(162448,25568,10);Dd(162460,25568,2);Dd(162472,25568,4);Dd(162487,25568,1);Dd(162500,25568,5);Dd(162519,25568,7);Dd(162529,25568,0);Dd(162543,25568,32);Dd(162558,25568,1024);Dd(162574,25568,2);Dd(162592,25568,0);Dd(162614,25568,1);Dd(162640,25568,4);Dd(162647,25568,8);Dd(162654,25568,16);Dd(162662,25568,2);Dd(162677,25568,0);Dd(162693,25568,1);Dd(162708,25568,0);Dd(162721,25568,3);Dd(162736,25568,4);Dd(162750,25568,2);Dd(162762,25568,1);Dd(162782,25568,6);Dd(162803,25568,5);Dd(162822,25568,6);Dd(162837,25568,3);Dd(162849,25568,1);Dd(162861,25568,1);Dd(162874,25568,2);Dd(162888,25568,0);Dd(162900,25568,4);Dd(162915,25568,7);Dd(162929,25568,2);Dd(162940,25568,0);Dd(162951,25568,5);Dd(162964,25568,2);Dd(162978,25568,1);Dd(162995,25568,3);Dd(163013,25568,0);Dd(163032,25568,0);Dd(163046,25568,16384);Dd(163066,25576,7);Dd(163081,25576,-65536);Dd(163096,25568,1124007936);Dd(163110,25568,32768);Dd(163129,25576,4095);Dd(163143,25568,6);Dd(163156,25568,7);Dd(163170,25568,1);Dd(163179,25568,2);Dd(163187,25568,4);Dd(163195,25568,5);Dd(163206,25568,32);Dd(163218,25568,8);Dd(163232,25568,7);Dd(163247,25568,256);Dd(163274,25568,8);Dd(163303,25568,4);Dd(163328,25568,1);Dd(163344,25568,0);Dd(163360,25568,2);Dd(163372,25568,1);Dd(163394,25568,0);Dd(163415,25568,6);Dd(163431,25568,1);Dd(163445,25568,7);Dd(163457,25568,0);Dd(163467,25568,4);Dd(163477,25568,5);Dd(163494,25568,2);Dd(163505,25568,3);Dd(163518,25568,11);Dd(163530,25568,9);Dd(163543,25568,8);Dd(163562,25568,1);Dd(163573,25568,2);Dd(163584,25568,3);Dd(163595,25568,0);Dd(163606,25568,2);Dd(163617,25568,0);Dd(163631,25568,4);Dd(163646,25568,1);Dd(163656,25568,3);Dd(163666,25568,1);Dd(163677,25568,0);Dd(163689,25568,1);Dd(163700,25568,0);Dd(163720,25568,2);Dd(163747,25568,1);Dd(163761,25568,0);Dd(163776,25568,-2);Dd(163794,25568,-1);Dd(163813,25568,0);Dd(163828,25568,16);Dd(163844,25568,1);Dd(163862,25568,0);Dd(163877,25568,4);Dd(163889,25568,1);Dd(163902,25568,2);Dd(163912,25576,-2147483648);Dd(163931,25576,1540483477);Dd(163952,25576,1123876864);Dd(163972,25576,32);Dd(163990,25568,34);Dd(164015,25568,19);Dd(164041,25568,0);Dd(164066,25568,49);Dd(164093,25568,51);Dd(164118,25568,32);Dd(164144,25568,17);Dd(164169,25568,2);Dd(164196,25568,-2);Dd(164217,25568,0);Dd(164239,25568,2);Dd(164262,25568,-1);Dd(164290,25568,1);Dd(164312,25568,0);Dd(164326,25568,1);Dd(164344,25568,7);Dd(164356,25568,8);Dd(164368,25568,3);Dd(164382,25568,4);Dd(164400,25568,16);Dd(164416,25568,2);Dd(164429,25568,4);Dd(164439,25568,5);Dd(164456,25568,2);Dd(164465,25568,3);Dd(164481,25568,0);Dd(164491,25568,1);Dd(164508,25568,1);Dd(164527,25568,2);Dd(164544,25568,1);Dd(164566,25568,128);Dd(164589,25568,1);Dd(164610,25568,4);Dd(164640,25568,64);Dd(164667,25568,2);Dd(164695,25568,24);Dd(164721,25568,8);Dd(164740,25568,32);Dd(164764,25568,0);Dd(164779,25568,16384);Dd(164800,25576,7);Dd(164816,25576,-65536);Dd(164832,25568,1124007936);Dd(164847,25568,32768);Dd(164867,25576,4095);Dd(164882,25568,2);Dd(164911,25568,1);Dd(164938,25568,4);Dd(164967,25568,0);Dd(164981,25568,8);Dd(165e3,25568,16);Dd(165017,25568,589824);Dd(165042,25568,524288);Dd(165068,25568,393216);Dd(165085,25568,1073741824);Dd(165108,25568,-2147483648);Dd(165131,25568,2031616);Dd(165153,25568,16);Dd(165176,25568,65536);Dd(165192,25568,131072);Dd(165209,25568,0);Dd(165226,25568,458752);Dd(165252,25568,917504);Dd(165274,25568,983040);Dd(165300,25568,786432);Dd(165328,25568,196608);Dd(165351,25568,851968);Dd(165387,25568,327680);Dd(165414,25568,720896);Dd(165442,25568,262144);Dd(165472,25568,655360);Dd(165489,25568,8);Dd(165517,25568,4);Dd(165545,25568,32);Dd(165573,25568,16);Dd(165601,25568,64);Dd(165629,25568,2);Dd(165656,25568,1);Dd(165683,25568,127);Dd(165711,25568,125);Dd(165746,25568,96);Dd(165774,25568,2147483647);Dd(165799,25568,-21);Dd(165808,25568,-18);Dd(165824,25568,-24);Dd(165831,25568,-22);Dd(165843,25568,-12);Dd(165854,25568,-17);Dd(165863,25568,-10);Dd(165876,25568,-14);Dd(165892,25568,-16);Dd(165908,25568,-15);Dd(165923,25568,-11);Dd(165933,25568,-19);Dd(165942,25568,-20);Dd(165952,25568,-25);Dd(165963,25568,-13);Dd(165971,25568,-23);Dd(165983,25568,-217);Dd(165999,25568,-216);Dd(166015,25568,-9);Dd(166028,25568,-26);Dd(166040,25568,-220);Dd(166059,25568,-221);Dd(166084,25568,-222);Dd(166100,25568,-223);Dd(166119,25568,-219);Dd(166138,25568,-218);Dd(166157,25568,-215);Dd(166167,25568,-8);Dd(166180,25568,-1);Dd(166193,25568,-5);Dd(166203,25568,-206);Dd(166214,25568,-6);Dd(166225,25568,-208);Dd(166236,25568,-214);Dd(166251,25568,-207);Dd(166263,25568,-201);Dd(166274,25568,-202);Dd(166287,25568,-2);Dd(166296,25568,-31);Dd(166315,25568,-29);Dd(166341,25568,-203);Dd(166364,25568,-3);Dd(166376,25568,-30);Dd(166402,25568,-7);Dd(166412,25568,-4);Dd(166421,25568,-213);Dd(166439,25568,-27);Dd(166450,25568,-204);Dd(166468,25568,0);Dd(166474,25568,-211);Dd(166488,25568,-212);Dd(166502,25568,-205);Dd(166522,25568,-209);Dd(166540,25568,-210);Dd(166561,25568,-28);Dd(166577,25568,0);Dd(166597,25568,1);Dd(166616,25568,0);Dd(166631,25568,1);Dd(166649,25568,2);Dd(166673,25568,1);Dd(166687,25568,0);Dd(166698,25568,1);Dd(166707,25568,2);Dd(166719,25568,0);Dd(166730,25568,3);Dd(166739,25568,0);Dd(166752,25568,1);Dd(166764,25568,2);return}function Hr(a){a=a|0;nd(a|0)|0;$6b()}function Ir(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;if((b[491008]|0)==0?Cac(491008)|0:0){h=Ye(2,25648)|0;f[125002]=h}h=f[125002]|0;i=L5b(8)|0;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[g>>2]=i;$c(h|0,a|0,c|0,g|0);u=e;return}function Jr(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;if((b[491016]|0)==0?Cac(491016)|0:0){h=Ye(2,25656)|0;f[125003]=h}h=f[125003]|0;i=L5b(20)|0;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[i+16>>2]=f[d+16>>2];f[g>>2]=i;$c(h|0,a|0,c|0,g|0);u=e;return}function Kr(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;if((b[491024]|0)==0?Cac(491024)|0:0){h=Ye(2,25664)|0;f[125004]=h}h=f[125004]|0;i=L5b(16)|0;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[g>>2]=i;$c(h|0,a|0,c|0,g|0);u=e;return}function Lr(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Qr(a,b);return}else{f[d>>2]=f[b>>2];f[c>>2]=d+4;return}}function Mr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>2;i=e;if(h>>>0<b>>>0){Rr(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<2)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-4-h|0)>>>2)<<2);return}function Nr(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>2|0}function Or(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((f[b+4>>2]|0)-g>>2>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}f[e>>2]=f[g+(c<<2)>>2];h=Ae(25568,e|0)|0;f[a>>2]=h;u=d;return}function Pr(a,b,c){a=a|0;b=b|0;c=c|0;f[(f[a>>2]|0)+(b<<2)>>2]=f[c>>2];return 1}function Qr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function Rr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>2>>>0>=b>>>0){j=b;k=i;while(1){f[k>>2]=f[c>>2];j=j+-1|0;if(!j)break;else k=k+4|0}f[g>>2]=i+(b<<2);return}i=f[a>>2]|0;k=h-i|0;h=k>>2;j=h+b|0;if(j>>>0>1073741823)c4b(a);l=e-i|0;e=l>>1;m=l>>2>>>0<536870911?(e>>>0<j>>>0?j:e):1073741823;do if(m)if(m>>>0>1073741823){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{n=L5b(m<<2)|0;break}else n=0;while(0);e=n+(h<<2)|0;j=n+(m<<2)|0;m=b;n=e;while(1){f[n>>2]=f[c>>2];m=m+-1|0;if(!m)break;else n=n+4|0}n=e+(0-h<<2)|0;if((k|0)>0)Vac(n|0,i|0,k|0)|0;f[a>>2]=n;f[g>>2]=e+(b<<2);f[d>>2]=j;if(!i)return;O5b(i);return}function Sr(a){a=a|0;return 8312}function Tr(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}O5b(a);return}function Ur(){var a=0;a=L5b(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Vr(a){a=a|0;return xi[a&31]()|0}function Wr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;f[e>>2]=c;zh[i&2047](a,e);u=d;return}function Xr(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;f[g>>2]=d;_h[j&255](a,c,g);u=e;return}function Yr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return di[e&1023](a)|0}function Zr(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_h[f[a>>2]&255](e,b,c);Jd(f[e>>2]|0);c=f[e>>2]|0;Yd(c|0);u=d;return c|0}function _r(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;f[g>>2]=d;d=li[h&511](b,c,g)|0;u=e;return d|0}function $r(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){es(a,b);return}else{f[d>>2]=f[b>>2];f[c>>2]=d+4;return}}function as(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>2;i=e;if(h>>>0<b>>>0){fs(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<2)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-4-h|0)>>>2)<<2);return}function bs(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>2|0}function cs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((f[b+4>>2]|0)-g>>2>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}f[e>>2]=f[g+(c<<2)>>2];h=Ae(25600,e|0)|0;f[a>>2]=h;u=d;return}function ds(a,b,c){a=a|0;b=b|0;c=c|0;f[(f[a>>2]|0)+(b<<2)>>2]=f[c>>2];return 1}function es(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function fs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>2>>>0>=b>>>0){i=h+(b<<2)|0;j=b;k=h;while(1){f[k>>2]=f[c>>2];j=j+-1|0;if(!j)break;else k=k+4|0}f[g>>2]=i;return}i=f[a>>2]|0;k=h-i|0;h=k>>2;j=h+b|0;if(j>>>0>1073741823)c4b(a);l=e-i|0;e=l>>1;m=l>>2>>>0<536870911?(e>>>0<j>>>0?j:e):1073741823;do if(m)if(m>>>0>1073741823){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{n=L5b(m<<2)|0;break}else n=0;while(0);e=n+(h<<2)|0;l=n+(m<<2)|0;m=b;b=e;while(1){f[b>>2]=f[c>>2];m=m+-1|0;if(!m)break;else b=b+4|0}b=e+(0-h<<2)|0;if((k|0)>0)Vac(b|0,i|0,k|0)|0;f[a>>2]=b;f[g>>2]=n+(j<<2);f[d>>2]=l;if(!i)return;O5b(i);return}function gs(a){a=a|0;return 8400}function hs(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}O5b(a);return}function is(){var a=0;a=L5b(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function js(a){a=a|0;return xi[a&31]()|0}function ks(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;n[e>>2]=c;zh[i&2047](a,e);u=d;return}function ls(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;n[g>>2]=d;_h[j&255](a,c,g);u=e;return}function ms(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return di[e&1023](a)|0}function ns(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_h[f[a>>2]&255](e,b,c);Jd(f[e>>2]|0);c=f[e>>2]|0;Yd(c|0);u=d;return c|0}function os(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;n[g>>2]=d;a=li[h&511](b,c,g)|0;u=e;return a|0}function ps(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){us(a,b);return}else{p[d>>3]=+p[b>>3];f[c>>2]=d+8;return}}function qs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>3;i=e;if(h>>>0<b>>>0){vs(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<3)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-8-h|0)>>>3)<<3);return}function rs(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>3|0}function ss(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((f[b+4>>2]|0)-g>>3>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}p[e>>3]=+p[g+(c<<3)>>3];h=Ae(25608,e|0)|0;f[a>>2]=h;u=d;return}function ts(a,b,c){a=a|0;b=b|0;c=c|0;p[(f[a>>2]|0)+(b<<3)>>3]=+p[c>>3];return 1}function us(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;p[k>>3]=+p[b>>3];b=k+(0-g<<3)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;O5b(d);return}function vs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>3>>>0>=b>>>0){j=b;k=i;while(1){p[k>>3]=+p[c>>3];j=j+-1|0;if(!j)break;else k=k+8|0}f[g>>2]=i+(b<<3);return}i=f[a>>2]|0;k=h-i|0;h=k>>3;j=h+b|0;if(j>>>0>536870911)c4b(a);l=e-i|0;e=l>>2;m=l>>3>>>0<268435455?(e>>>0<j>>>0?j:e):536870911;do if(m)if(m>>>0>536870911){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{n=L5b(m<<3)|0;break}else n=0;while(0);e=n+(h<<3)|0;j=n+(m<<3)|0;m=b;n=e;while(1){p[n>>3]=+p[c>>3];m=m+-1|0;if(!m)break;else n=n+8|0}n=e+(0-h<<3)|0;if((k|0)>0)Vac(n|0,i|0,k|0)|0;f[a>>2]=n;f[g>>2]=e+(b<<3);f[d>>2]=j;if(!i)return;O5b(i);return}function ws(a){a=a|0;return 8480}function xs(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);O5b(b)}O5b(a);return}function ys(){var a=0;a=L5b(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function zs(a){a=a|0;return xi[a&31]()|0}function As(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;p[e>>3]=c;zh[i&2047](a,e);u=d;return}function Bs(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;p[g>>3]=d;_h[j&255](a,c,g);u=e;return}function Cs(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return di[e&1023](a)|0}function Ds(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_h[f[a>>2]&255](e,b,c);Jd(f[e>>2]|0);c=f[e>>2]|0;Yd(c|0);u=d;return c|0}function Es(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;p[g>>3]=d;a=li[h&511](b,c,g)|0;u=e;return a|0}function Fs(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){Ks(a,b);return}else{f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];f[c>>2]=d+8;return}}function Gs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>3;i=e;if(h>>>0<b>>>0){Ls(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<3)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-8-h|0)>>>3)<<3);return}function Hs(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>3|0}function Is(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;h=g;if((f[b+4>>2]|0)-g>>3>>>0<=c>>>0){i=1;f[a>>2]=i;u=d;return}g=L5b(8)|0;f[g>>2]=f[h+(c<<3)>>2];f[g+4>>2]=f[h+(c<<3)+4>>2];f[e>>2]=g;i=Ae(8616,e|0)|0;f[a>>2]=i;u=d;return}function Js(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[a>>2]|0;f[d+(b<<3)>>2]=f[c>>2];f[d+(b<<3)+4>>2]=f[c+4>>2];return 1}function Ks(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)c4b(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=ze(8)|0;T5b(l,477177);f[l>>2]=149528;If(l|0,25408,1411)}else{n=L5b(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=j;j=l;while(1){m=n;n=n+-8|0;f[j+-8>>2]=f[n>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-8|0}o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;O5b(e);return}function Ls(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>3>>>0>=b>>>0){j=c+4|0;k=b;l=i;while(1){f[l>>2]=f[c>>2];f[l+4>>2]=f[j>>2];k=k+-1|0;if(!k)break;else l=l+8|0}f[g>>2]=i+(b<<3);return}l=f[a>>2]|0;k=h-l>>3;h=k+b|0;j=l;if(h>>>0>536870911)c4b(a);m=e-l|0;e=m>>2;n=m>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(n)if(n>>>0>536870911){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{o=L5b(n<<3)|0;break}else o=0;while(0);e=o+(k<<3)|0;k=o+(n<<3)|0;n=c+4|0;o=b;h=e;while(1){f[h>>2]=f[c>>2];f[h+4>>2]=f[n>>2];o=o+-1|0;if(!o)break;else h=h+8|0}h=k;k=e+(b<<3)|0;if((i|0)==(j|0)){p=e;q=l}else{b=i+-8-l|0;l=i;i=e;while(1){o=l;l=l+-8|0;f[i+-8>>2]=f[l>>2];f[i+-4>>2]=f[o+-4>>2];if((l|0)==(j|0))break;else i=i+-8|0}p=e+(~(b>>>3)<<3)|0;q=f[a>>2]|0}f[a>>2]=p;f[g>>2]=k;f[d>>2]=h;if(!q)return;O5b(q);return}function Ms(a){a=a|0;return 8560}function Ns(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);O5b(b)}O5b(a);return}function Os(){var a=0;a=L5b(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Ps(a){a=a|0;return xi[a&31]()|0}function Qs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;zh[g&2047](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;zh[g&2047](a,c);return}}function Rs(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;_h[h&255](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;_h[h&255](a,c,d);return}}function Ss(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return di[e&1023](a)|0}function Ts(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_h[f[a>>2]&255](e,b,c);Jd(f[e>>2]|0);c=f[e>>2]|0;Yd(c|0);u=d;return c|0}function Us(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[f[a>>2]&511](b,c,d)|0}function Vs(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){_s(a,b);return}f[d>>2]=f[b>>2];a=d+4|0;e=b+4|0;f[a>>2]=f[e>>2];g=d+8|0;f[g>>2]=f[b+8>>2];f[d+12>>2]=f[b+12>>2];f[d+16>>2]=f[b+16>>2];f[d+20>>2]=f[b+20>>2];f[d+24>>2]=f[b+24>>2];f[d+28>>2]=f[b+28>>2];f[d+32>>2]=f[b+32>>2];h=f[b+36>>2]|0;f[d+36>>2]=h;f[d+40>>2]=g;g=d+48|0;i=d+44|0;f[i>>2]=g;f[g>>2]=0;f[d+52>>2]=0;if(h|0){g=h+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[e>>2]|0)<3){e=f[b+44>>2]|0;g=f[i>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2]}else{f[a>>2]=0;jL(d,b)}f[c>>2]=(f[c>>2]|0)+56;return}function Ws(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=(e-g|0)/56|0;i=e;if(h>>>0<b>>>0){bt(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b*56|0)|0;if((i|0)==(h|0))return;else j=i;do{i=j+-56|0;f[d>>2]=i;b=j+-20|0;g=f[b>>2]|0;if(g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)kL(i);f[b>>2]=0;b=j+-40|0;i=j+-52|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[i>>2]|0)>0){b=f[j+-16>>2]|0;g=0;do{f[b+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[i>>2]|0))}i=f[j+-12>>2]|0;if((i|0)!=(j+-8|0))UC(i);j=f[d>>2]|0}while((j|0)!=(h|0));return}function Xs(a){a=a|0;return ((f[a+4>>2]|0)-(f[a>>2]|0)|0)/56|0|0}function Ys(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;if((((f[b+4>>2]|0)-g|0)/56|0)>>>0<=c>>>0){h=1;f[a>>2]=h;u=d;return}b=lt(g+(c*56|0)|0)|0;f[e>>2]=b;h=Ae(8704,e|0)|0;f[a>>2]=h;u=d;return}function Zs(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=f[a>>2]|0;a=d+(b*56|0)|0;if((a|0)==(c|0))return 1;e=c+36|0;g=f[e>>2]|0;if(g|0){h=g+12|0;f[h>>2]=(f[h>>2]|0)+1}h=d+(b*56|0)+36|0;g=f[h>>2]|0;if(g|0?(i=g+12|0,g=f[i>>2]|0,f[i>>2]=g+-1,(g|0)==1):0)kL(a);f[h>>2]=0;g=d+(b*56|0)+16|0;i=d+(b*56|0)+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){j=f[d+(b*56|0)+40>>2]|0;k=0;do{f[j+(k<<2)>>2]=0;k=k+1|0;l=f[i>>2]|0}while((k|0)<(l|0));f[a>>2]=f[c>>2];if((l|0)<3)m=12;else m=14}else{f[a>>2]=f[c>>2];m=12}if((m|0)==12){l=f[c+4>>2]|0;if((l|0)<3){f[i>>2]=l;f[d+(b*56|0)+8>>2]=f[c+8>>2];f[d+(b*56|0)+12>>2]=f[c+12>>2];l=f[c+44>>2]|0;i=f[d+(b*56|0)+44>>2]|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2]}else m=14}if((m|0)==14)jL(a,c);f[g>>2]=f[c+16>>2];f[d+(b*56|0)+20>>2]=f[c+20>>2];f[d+(b*56|0)+24>>2]=f[c+24>>2];f[d+(b*56|0)+28>>2]=f[c+28>>2];f[d+(b*56|0)+32>>2]=f[c+32>>2];f[h>>2]=f[e>>2];return 1}function _s(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+32|0;d=c;e=f[a>>2]|0;g=((f[a+4>>2]|0)-e|0)/56|0;h=g+1|0;if(h>>>0>76695844)c4b(a);i=((f[a+8>>2]|0)-e|0)/56|0;e=i<<1;j=i>>>0<38347922?(e>>>0<h>>>0?h:e):76695844;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(j)if(j>>>0>76695844){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{k=L5b(j*56|0)|0;break}else k=0;while(0);f[d>>2]=k;e=k+(g*56|0)|0;h=d+8|0;f[h>>2]=e;f[d+4>>2]=e;f[d+12>>2]=k+(j*56|0);f[e>>2]=f[b>>2];j=k+(g*56|0)+4|0;i=b+4|0;l=f[i>>2]|0;f[j>>2]=l;m=k+(g*56|0)+8|0;f[m>>2]=f[b+8>>2];f[k+(g*56|0)+12>>2]=f[b+12>>2];f[k+(g*56|0)+16>>2]=f[b+16>>2];f[k+(g*56|0)+20>>2]=f[b+20>>2];f[k+(g*56|0)+24>>2]=f[b+24>>2];f[k+(g*56|0)+28>>2]=f[b+28>>2];f[k+(g*56|0)+32>>2]=f[b+32>>2];n=f[b+36>>2]|0;f[k+(g*56|0)+36>>2]=n;f[k+(g*56|0)+40>>2]=m;m=k+(g*56|0)+48|0;o=k+(g*56|0)+44|0;f[o>>2]=m;f[m>>2]=0;f[k+(g*56|0)+52>>2]=0;if(!n)p=l;else{l=n+12|0;f[l>>2]=(f[l>>2]|0)+1;p=f[i>>2]|0}if((p|0)<3){p=f[b+44>>2]|0;i=f[o>>2]|0;f[i>>2]=f[p>>2];f[i+4>>2]=f[p+4>>2];q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;$s(a,d);at(d);u=c;return}else{f[j>>2]=0;jL(e,b);q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;$s(a,d);at(d);u=c;return}}function $s(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a>>2]|0;d=a+4|0;e=f[d>>2]|0;g=b+4|0;if((e|0)==(c|0)){h=g;i=a;j=f[g>>2]|0;k=c;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}t=e;e=f[g>>2]|0;do{u=e+-56|0;v=t;t=t+-56|0;f[u>>2]=f[t>>2];w=e+-52|0;x=v+-52|0;f[w>>2]=f[x>>2];y=e+-48|0;f[y>>2]=f[v+-48>>2];f[e+-44>>2]=f[v+-44>>2];f[e+-40>>2]=f[v+-40>>2];f[e+-36>>2]=f[v+-36>>2];f[e+-32>>2]=f[v+-32>>2];f[e+-28>>2]=f[v+-28>>2];f[e+-24>>2]=f[v+-24>>2];z=f[v+-20>>2]|0;f[e+-20>>2]=z;f[e+-16>>2]=y;y=e+-8|0;A=e+-12|0;f[A>>2]=y;f[y>>2]=0;f[e+-4>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+-12>>2]|0;v=f[A>>2]|0;f[v>>2]=f[x>>2];f[v+4>>2]=f[x+4>>2]}else{f[w>>2]=0;jL(u,t)}e=(f[g>>2]|0)+-56|0;f[g>>2]=e}while((t|0)!=(c|0));h=g;i=a;j=e;k=f[a>>2]|0;f[i>>2]=j;f[h>>2]=k;l=b+8|0;m=f[d>>2]|0;n=f[l>>2]|0;f[d>>2]=n;f[l>>2]=m;o=a+8|0;p=b+12|0;q=f[o>>2]|0;r=f[p>>2]|0;f[o>>2]=r;f[p>>2]=q;s=f[h>>2]|0;f[b>>2]=s;return}function at(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=f[a+4>>2]|0;c=a+8|0;d=f[c>>2]|0;if((d|0)!=(b|0)){e=d;do{d=e+-56|0;f[c>>2]=d;g=e+-20|0;h=f[g>>2]|0;if(h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)kL(d);f[g>>2]=0;g=e+-40|0;d=e+-52|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[d>>2]|0)>0){g=f[e+-16>>2]|0;h=0;do{f[g+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[d>>2]|0))}d=f[e+-12>>2]|0;if((d|0)!=(e+-8|0))UC(d);e=f[c>>2]|0}while((e|0)!=(b|0))}b=f[a>>2]|0;if(!b)return;O5b(b);return}function bt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d;g=f[a+8>>2]|0;h=a+4|0;i=f[h>>2]|0;if(((g-i|0)/56|0)>>>0>=b>>>0){j=c+4|0;k=c+8|0;l=c+12|0;m=c+16|0;n=c+20|0;o=c+24|0;p=c+28|0;q=c+32|0;r=c+36|0;s=c+44|0;t=b;v=i;do{f[v>>2]=f[c>>2];w=v+4|0;f[w>>2]=f[j>>2];x=v+8|0;f[x>>2]=f[k>>2];f[v+12>>2]=f[l>>2];f[v+16>>2]=f[m>>2];f[v+20>>2]=f[n>>2];f[v+24>>2]=f[o>>2];f[v+28>>2]=f[p>>2];f[v+32>>2]=f[q>>2];y=f[r>>2]|0;f[v+36>>2]=y;f[v+40>>2]=x;x=v+48|0;z=v+44|0;f[z>>2]=x;f[x>>2]=0;f[v+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[j>>2]|0)<3){x=f[s>>2]|0;y=f[z>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2]}else{f[w>>2]=0;jL(v,c)}v=(f[h>>2]|0)+56|0;f[h>>2]=v;t=t+-1|0}while((t|0)!=0);u=d;return}t=f[a>>2]|0;v=(i-t|0)/56|0;i=v+b|0;if(i>>>0>76695844)c4b(a);h=(g-t|0)/56|0;t=h<<1;g=h>>>0<38347922?(t>>>0<i>>>0?i:t):76695844;f[e+12>>2]=0;f[e+16>>2]=a+8;do if(g)if(g>>>0>76695844){t=ze(8)|0;T5b(t,477177);f[t>>2]=149528;If(t|0,25408,1411)}else{A=L5b(g*56|0)|0;break}else A=0;while(0);f[e>>2]=A;t=A+(v*56|0)|0;v=e+8|0;f[v>>2]=t;f[e+4>>2]=t;f[e+12>>2]=A+(g*56|0);g=c+4|0;A=c+8|0;i=c+12|0;h=c+16|0;s=c+20|0;j=c+24|0;r=c+28|0;q=c+32|0;p=c+36|0;o=c+44|0;n=b;b=t;do{f[b>>2]=f[c>>2];t=b+4|0;f[t>>2]=f[g>>2];m=b+8|0;f[m>>2]=f[A>>2];f[b+12>>2]=f[i>>2];f[b+16>>2]=f[h>>2];f[b+20>>2]=f[s>>2];f[b+24>>2]=f[j>>2];f[b+28>>2]=f[r>>2];f[b+32>>2]=f[q>>2];l=f[p>>2]|0;f[b+36>>2]=l;f[b+40>>2]=m;m=b+48|0;k=b+44|0;f[k>>2]=m;f[m>>2]=0;f[b+52>>2]=0;if(l|0){m=l+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[g>>2]|0)<3){m=f[o>>2]|0;l=f[k>>2]|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2]}else{f[t>>2]=0;jL(b,c)}b=(f[v>>2]|0)+56|0;f[v>>2]=b;n=n+-1|0}while((n|0)!=0);$s(a,e);at(e);u=d;return}function ct(a){a=a|0;return 8648}function dt(a){a=a|0;if(!a)return;et(a);O5b(a);return}function et(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;d=f[c>>2]|0;if((d|0)==(b|0))e=b;else{g=d;do{d=g+-56|0;f[c>>2]=d;h=g+-20|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)kL(d);f[h>>2]=0;h=g+-40|0;d=g+-52|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[d>>2]|0)>0){h=f[g+-16>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[d>>2]|0))}d=f[g+-12>>2]|0;if((d|0)!=(g+-8|0))UC(d);g=f[c>>2]|0}while((g|0)!=(b|0));e=f[a>>2]|0}O5b(e);return}function ft(){var a=0;a=L5b(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function gt(a){a=a|0;return xi[a&31]()|0}function ht(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;zh[g&2047](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;zh[g&2047](a,c);return}}function it(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;_h[h&255](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;_h[h&255](a,c,d);return}}function jt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return di[e&1023](a)|0}function kt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_h[f[a>>2]&255](e,b,c);Jd(f[e>>2]|0);c=f[e>>2]|0;Yd(c|0);u=d;return c|0}function lt(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=L5b(56)|0;f[b>>2]=f[a>>2];c=b+4|0;d=a+4|0;e=f[d>>2]|0;f[c>>2]=e;g=b+8|0;f[g>>2]=f[a+8>>2];f[b+12>>2]=f[a+12>>2];f[b+16>>2]=f[a+16>>2];f[b+20>>2]=f[a+20>>2];f[b+24>>2]=f[a+24>>2];f[b+28>>2]=f[a+28>>2];f[b+32>>2]=f[a+32>>2];h=f[a+36>>2]|0;f[b+36>>2]=h;f[b+40>>2]=g;g=b+48|0;i=b+44|0;f[i>>2]=g;f[g>>2]=0;f[b+52>>2]=0;if(!h)j=e;else{e=h+12|0;f[e>>2]=(f[e>>2]|0)+1;j=f[d>>2]|0}if((j|0)<3){j=f[a+44>>2]|0;d=f[i>>2]|0;f[d>>2]=f[j>>2];f[d+4>>2]=f[j+4>>2];return b|0}else{f[c>>2]=0;jL(b,a);return b|0}return 0}function mt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[f[a>>2]&511](b,c,d)|0}function nt(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+4|0;d=f[c>>2]|0;if((d|0)==(f[a+8>>2]|0)){st(a,b);return}else{f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];f[d+8>>2]=f[b+8>>2];f[d+12>>2]=f[b+12>>2];f[c>>2]=d+16;return}}function ot(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e-g>>4;i=e;if(h>>>0<b>>>0){tt(a,b-h|0,c);return}if(h>>>0<=b>>>0)return;h=g+(b<<4)|0;if((i|0)==(h|0))return;f[d>>2]=i+(~((i+-16-h|0)>>>4)<<4);return}function pt(a){a=a|0;return (f[a+4>>2]|0)-(f[a>>2]|0)>>4|0}function qt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[b>>2]|0;h=g;if((f[b+4>>2]|0)-g>>4>>>0<=c>>>0){i=1;f[a>>2]=i;u=d;return}g=L5b(16)|0;f[g>>2]=f[h+(c<<4)>>2];f[g+4>>2]=f[h+(c<<4)+4>>2];f[g+8>>2]=f[h+(c<<4)+8>>2];f[g+12>>2]=f[h+(c<<4)+12>>2];f[e>>2]=g;i=Ae(8272,e|0)|0;f[a>>2]=i;u=d;return}function rt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[a>>2]|0;f[d+(b<<4)>>2]=f[c>>2];f[d+(b<<4)+4>>2]=f[c+4>>2];f[d+(b<<4)+8>>2]=f[c+8>>2];f[d+(b<<4)+12>>2]=f[c+12>>2];return 1}function st(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)c4b(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=ze(8)|0;T5b(l,477177);f[l>>2]=149528;If(l|0,25408,1411)}else{n=L5b(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;while(1){m=n;n=n+-16|0;f[j+-16>>2]=f[n>>2];f[j+-12>>2]=f[m+-12>>2];f[j+-8>>2]=f[m+-8>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;O5b(e);return}function tt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>4>>>0>=b>>>0){j=c+4|0;k=c+8|0;l=c+12|0;m=b;n=i;while(1){f[n>>2]=f[c>>2];f[n+4>>2]=f[j>>2];f[n+8>>2]=f[k>>2];f[n+12>>2]=f[l>>2];m=m+-1|0;if(!m)break;else n=n+16|0}f[g>>2]=i+(b<<4);return}n=f[a>>2]|0;m=h-n>>4;h=m+b|0;l=n;if(h>>>0>268435455)c4b(a);k=e-n|0;e=k>>3;j=k>>4>>>0<134217727?(e>>>0<h>>>0?h:e):268435455;do if(j)if(j>>>0>268435455){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{o=L5b(j<<4)|0;break}else o=0;while(0);e=o+(m<<4)|0;m=o+(j<<4)|0;j=c+4|0;o=c+8|0;h=c+12|0;k=b;p=e;while(1){f[p>>2]=f[c>>2];f[p+4>>2]=f[j>>2];f[p+8>>2]=f[o>>2];f[p+12>>2]=f[h>>2];k=k+-1|0;if(!k)break;else p=p+16|0}p=m;m=e+(b<<4)|0;if((i|0)==(l|0)){q=e;r=n}else{b=i+-16-n|0;n=i;i=e;while(1){k=n;n=n+-16|0;f[i+-16>>2]=f[n>>2];f[i+-12>>2]=f[k+-12>>2];f[i+-8>>2]=f[k+-8>>2];f[i+-4>>2]=f[k+-4>>2];if((n|0)==(l|0))break;else i=i+-16|0}q=e+(~(b>>>4)<<4)|0;r=f[a>>2]|0}f[a>>2]=q;f[g>>2]=m;f[d>>2]=p;if(!r)return;O5b(r);return}function ut(a){a=a|0;return 8736}function vt(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0){c=a+4|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);O5b(b)}O5b(a);return}function wt(){var a=0;a=L5b(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function xt(a){a=a|0;return xi[a&31]()|0}function yt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1)){g=d;zh[g&2047](a,c);return}else{g=f[(f[a>>2]|0)+d>>2]|0;zh[g&2047](a,c);return}}function zt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1)){h=e;_h[h&255](a,c,d);return}else{h=f[(f[a>>2]|0)+e>>2]|0;_h[h&255](a,c,d);return}}function At(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return di[e&1023](a)|0}function Bt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_h[f[a>>2]&255](e,b,c);Jd(f[e>>2]|0);c=f[e>>2]|0;Yd(c|0);u=d;return c|0}function Ct(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[f[a>>2]&511](b,c,d)|0}function Dt(a){a=a|0;return 8704}function Et(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=a+36|0;c=f[b>>2]|0;if(c|0?(d=c+12|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0)kL(a);f[b>>2]=0;b=a+16|0;c=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[c>>2]|0)>0){b=f[a+40>>2]|0;d=0;do{f[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[c>>2]|0))}c=f[a+44>>2]|0;if((c|0)!=(a+48|0))UC(c);O5b(a);return}function Ft(){var a=0,b=0,c=0,d=0,e=0;a=L5b(56)|0;f[a>>2]=1124007936;b=a+8|0;c=a+40|0;d=a+4|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+48|0;f[a+44>>2]=b;f[b>>2]=0;f[a+52>>2]=0;return a|0}function Gt(a){a=a|0;return xi[a&31]()|0}function Ht(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=L5b(56)|0;f[b>>2]=f[a>>2];c=b+4|0;d=a+4|0;e=f[d>>2]|0;f[c>>2]=e;g=b+8|0;f[g>>2]=f[a+8>>2];f[b+12>>2]=f[a+12>>2];f[b+16>>2]=f[a+16>>2];f[b+20>>2]=f[a+20>>2];f[b+24>>2]=f[a+24>>2];f[b+28>>2]=f[a+28>>2];f[b+32>>2]=f[a+32>>2];h=f[a+36>>2]|0;f[b+36>>2]=h;f[b+40>>2]=g;g=b+48|0;i=b+44|0;f[i>>2]=g;f[g>>2]=0;f[b+52>>2]=0;if(!h)j=e;else{e=h+12|0;f[e>>2]=(f[e>>2]|0)+1;j=f[d>>2]|0}if((j|0)<3){j=f[a+44>>2]|0;d=f[i>>2]|0;f[d>>2]=f[j>>2];f[d+4>>2]=f[j+4>>2];return b|0}else{f[c>>2]=0;jL(b,a);return b|0}return 0}function It(a,b){a=a|0;b=b|0;return di[a&1023](b)|0}function Jt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=L5b(56)|0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=f[b>>2]|0;f[e>>2]=1124007936;b=e+8|0;i=e+40|0;j=e+4|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=b;b=e+48|0;f[e+44>>2]=b;f[b>>2]=0;f[e+52>>2]=0;f[d>>2]=h;f[d+4>>2]=g;hL(e,2,d,a&4095);u=c;return e|0}function Kt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];f[g>>2]=c;c=Uh[a&1023](e,g)|0;u=d;return c|0}function Lt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=L5b(56)|0;h=f[a>>2]|0;a=f[b>>2]|0;b=f[c>>2]|0;f[g>>2]=1124007936;c=g+8|0;i=g+40|0;j=g+4|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=c;c=g+48|0;f[g+44>>2]=c;f[c>>2]=0;f[g+52>>2]=0;f[e>>2]=h;f[e+4>>2]=a;hL(g,2,e,b&4095);u=d;return g|0}function Mt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e+8|0;h=e+4|0;i=e;f[g>>2]=b;f[h>>2]=c;f[i>>2]=d;d=li[a&511](g,h,i)|0;u=e;return d|0}function Nt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=L5b(56)|0;i=f[a>>2]|0;a=f[b>>2]|0;b=f[c>>2]|0;f[h>>2]=1124007936;c=h+8|0;j=h+40|0;k=h+4|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=c;c=h+48|0;f[h+44>>2]=c;f[c>>2]=0;f[h+52>>2]=0;f[g>>2]=i;f[g+4>>2]=a;hL(h,2,g,b&4095);UP(h,d)|0;u=e;return h|0}function Ot(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g+8|0;i=g+4|0;j=g;f[h>>2]=b;f[i>>2]=c;f[j>>2]=d;d=Dg[a&127](h,i,j,e)|0;u=g;return d|0}function Pt(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nh[a&127](b,c,d,e,f)|0}function Qt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d+8|0;g=d;f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];_h[a&255](e,g,c);c=L5b(56)|0;f[c>>2]=f[e>>2];g=e+4|0;a=f[g>>2]|0;f[c+4>>2]=a;b=c+8|0;h=e+8|0;f[b>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];i=e+16|0;f[c+16>>2]=f[i>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=b;b=c+44|0;l=c+48|0;f[b>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[b>>2]=f[n>>2];b=e+40|0;f[k>>2]=f[b>>2];k=e+48|0;f[n>>2]=k;f[b>>2]=h;o=k}f[e>>2]=1124007936;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}UC(o);u=d;return c|0}function Rt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e;th[a&511](g,b,c,d);d=L5b(56)|0;f[d>>2]=f[g>>2];c=g+4|0;b=f[c>>2]|0;f[d+4>>2]=b;a=d+8|0;h=g+8|0;f[a>>2]=f[h>>2];f[d+12>>2]=f[g+12>>2];i=g+16|0;f[d+16>>2]=f[i>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];j=g+36|0;f[d+36>>2]=f[j>>2];k=d+40|0;f[k>>2]=a;a=d+44|0;l=d+48|0;f[a>>2]=l;m=d+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((b|0)<3){b=f[n>>2]|0;f[l>>2]=f[b>>2];f[m>>2]=f[b+4>>2];o=b}else{f[a>>2]=f[n>>2];a=g+40|0;f[k>>2]=f[a>>2];k=g+48|0;f[n>>2]=k;f[a>>2]=h;o=k}f[g>>2]=1124007936;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(g+48|0)){u=e;return d|0}UC(o);u=e;return d|0}function St(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function Tt(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function Ut(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;zh[f[a>>2]&2047](d,b);Jd(f[d>>2]|0);b=f[d>>2]|0;Yd(b|0);u=c;return b|0}function Vt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return di[e&1023](a)|0}function Wt(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return di[e&1023](a)|0}function Xt(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;$g[f[a>>2]&15](b,c,d,e,g);return}function Yt(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[f[a>>2]&255](b,c,d);return}function Zt(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;oh[f[a>>2]&63](b,c,d,e);return}function _t(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;_h[i&255](e,a,c);c=L5b(56)|0;f[c>>2]=f[e>>2];a=e+4|0;i=f[a>>2]|0;f[c+4>>2]=i;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];b=e+16|0;f[c+16>>2]=f[b>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((i|0)<3){i=f[n>>2]|0;f[l>>2]=f[i>>2];f[m>>2]=f[i+4>>2];o=i}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}UC(o);u=d;return c|0}function $t(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1)){i=g;th[i&511](a,c,d,e);return}else{i=f[(f[a>>2]|0)+g>>2]|0;th[i&511](a,c,d,e);return}}function au(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];_h[j&255](a,g,d);u=e;return}function bu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;th[j&511](g,a,c,d);d=L5b(56)|0;f[d>>2]=f[g>>2];c=g+4|0;a=f[c>>2]|0;f[d+4>>2]=a;j=d+8|0;h=g+8|0;f[j>>2]=f[h>>2];f[d+12>>2]=f[g+12>>2];i=g+16|0;f[d+16>>2]=f[i>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];b=g+36|0;f[d+36>>2]=f[b>>2];k=d+40|0;f[k>>2]=j;j=d+44|0;l=d+48|0;f[j>>2]=l;m=d+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[j>>2]=f[n>>2];j=g+40|0;f[k>>2]=f[j>>2];k=g+48|0;f[n>>2]=k;f[j>>2]=h;o=k}f[g>>2]=1124007936;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0;f[b>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(g+48|0)){u=e;return d|0}UC(o);u=e;return d|0}function cu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;_h[i&255](e,a,c);c=L5b(56)|0;f[c>>2]=f[e>>2];a=e+4|0;i=f[a>>2]|0;f[c+4>>2]=i;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];b=e+16|0;f[c+16>>2]=f[b>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((i|0)<3){i=f[n>>2]|0;f[l>>2]=f[i>>2];f[m>>2]=f[i+4>>2];o=i}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}UC(o);u=d;return c|0}function du(a,b,c){a=a|0;b=b|0;c=c|0;zh[f[a>>2]&2047](b,c);return}function eu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[f[a>>2]&255](b,c,d);return}function fu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return di[e&1023](a)|0}function gu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;return Uh[g&1023](a,c)|0}function hu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;zh[h&2047](d,a);a=L5b(56)|0;f[a>>2]=f[d>>2];h=d+4|0;e=f[h>>2]|0;f[a+4>>2]=e;g=a+8|0;b=d+8|0;f[g>>2]=f[b>>2];f[a+12>>2]=f[d+12>>2];i=d+16|0;f[a+16>>2]=f[i>>2];f[a+20>>2]=f[d+20>>2];f[a+24>>2]=f[d+24>>2];f[a+28>>2]=f[d+28>>2];f[a+32>>2]=f[d+32>>2];j=d+36|0;f[a+36>>2]=f[j>>2];k=a+40|0;f[k>>2]=g;g=a+44|0;l=a+48|0;f[g>>2]=l;m=a+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=b;o=k}f[d>>2]=1124007936;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return a|0}UC(o);u=c;return a|0}function iu(a,b,c){a=a|0;b=b|0;c=c|0;return +(+yg[f[a>>2]&31](b,c))}function ju(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+64|0;g=e;oh[f[a>>2]&63](g,b,c,d);c=L5b(56)|0;f[c>>2]=f[g>>2];b=g+4|0;a=f[b>>2]|0;f[c+4>>2]=a;h=c+8|0;i=g+8|0;f[h>>2]=f[i>>2];f[c+12>>2]=f[g+12>>2];j=g+16|0;f[c+16>>2]=f[j>>2];f[c+20>>2]=f[g+20>>2];f[c+24>>2]=f[g+24>>2];f[c+28>>2]=f[g+28>>2];f[c+32>>2]=f[g+32>>2];k=g+36|0;f[c+36>>2]=f[k>>2];l=c+40|0;f[l>>2]=h;h=c+44|0;m=c+48|0;f[h>>2]=m;n=c+52|0;f[n>>2]=0;f[m>>2]=0;o=g+44|0;if((a|0)<3){a=f[o>>2]|0;f[m>>2]=f[a>>2];f[n>>2]=f[a+4>>2];p=a}else{f[h>>2]=f[o>>2];h=g+40|0;f[l>>2]=f[h>>2];l=g+48|0;f[o>>2]=l;f[h>>2]=i;p=l}f[g>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(g+48|0)){u=e;return c|0}UC(p);u=e;return c|0}function ku(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;_h[f[a>>2]&255](e,b,c);c=L5b(56)|0;f[c>>2]=f[e>>2];b=e+4|0;a=f[b>>2]|0;f[c+4>>2]=a;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];i=e+16|0;f[c+16>>2]=f[i>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}UC(o);u=d;return c|0}function lu(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;zh[f[a>>2]&2047](d,b);b=L5b(56)|0;f[b>>2]=f[d>>2];a=d+4|0;e=f[a>>2]|0;f[b+4>>2]=e;g=b+8|0;h=d+8|0;f[g>>2]=f[h>>2];f[b+12>>2]=f[d+12>>2];i=d+16|0;f[b+16>>2]=f[i>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];f[b+32>>2]=f[d+32>>2];j=d+36|0;f[b+36>>2]=f[j>>2];k=b+40|0;f[k>>2]=g;g=b+44|0;l=b+48|0;f[g>>2]=l;m=b+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[d>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return b|0}UC(o);u=c;return b|0}function mu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;_h[i&255](e,a,c);c=L5b(56)|0;f[c>>2]=f[e>>2];a=e+4|0;i=f[a>>2]|0;f[c+4>>2]=i;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];b=e+16|0;f[c+16>>2]=f[b>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((i|0)<3){i=f[n>>2]|0;f[l>>2]=f[i>>2];f[m>>2]=f[i+4>>2];o=i}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}UC(o);u=d;return c|0}function nu(a,b,c){a=a|0;b=b|0;c=c|0;zh[f[a>>2]&2047](b,c);return}function ou(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[f[a>>2]&255](b,c,d);return}function pu(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;zh[f[a>>2]&2047](d,b);b=L5b(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function qu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;_h[f[a>>2]&255](e,b,c);Jd(f[e>>2]|0);c=f[e>>2]|0;Yd(c|0);u=d;return c|0}function ru(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;th[f[a>>2]&511](g,b,c,d);Jd(f[g>>2]|0);d=f[g>>2]|0;Yd(d|0);u=e;return d|0}function su(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=c+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=Uh[h&1023](a,d)|0;return b[e>>0]|0}function tu(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=c+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=li[i&511](a,d,e)|0;return b[g>>0]|0}function uu(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=c+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=Dg[j&127](a,d,e,g)|0;return b[h>>0]|0}function vu(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=c+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=Uh[h&1023](a,d)|0;return b[e>>0]|0}function wu(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=c+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=li[i&511](a,d,e)|0;return b[g>>0]|0}function xu(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=c+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=Dg[j&127](a,d,e,g)|0;return b[h>>0]|0}function yu(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=Uh[h&1023](a,c)|0;return d[e>>1]|0}function zu(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=li[i&511](a,c,e)|0;return d[g>>1]|0}function Au(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=Dg[j&127](a,c,e,g)|0;return d[h>>1]|0}function Bu(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=Uh[h&1023](a,c)|0;return d[e>>1]|0}function Cu(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=li[i&511](a,c,e)|0;return d[g>>1]|0}function Du(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a>>2]|0;i=f[a+4>>2]|0;a=b+(i>>1)|0;if(!(i&1))j=h;else j=f[(f[a>>2]|0)+h>>2]|0;h=Dg[j&127](a,c,e,g)|0;return d[h>>1]|0}function Eu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;d=Uh[g&1023](a,c)|0;return f[d>>2]|0}function Fu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=li[h&511](a,c,d)|0;return f[e>>2]|0}function Gu(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=Dg[i&127](a,c,d,e)|0;return f[g>>2]|0}function Hu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;d=Uh[g&1023](a,c)|0;return +(+n[d>>2])}function Iu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=li[h&511](a,c,d)|0;return +(+n[e>>2])}function Ju(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=Dg[i&127](a,c,d,e)|0;return +(+n[g>>2])}function Ku(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a>>2]|0;h=f[a+4>>2]|0;a=b+(h>>1)|0;if(!(h&1))i=g;else i=f[(f[a>>2]|0)+g>>2]|0;g=Dg[i&127](a,c,d,e)|0;return +(+p[g>>3])}function Lu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=f[a>>2]|0;e=f[a+4>>2]|0;a=b+(e>>1)|0;if(!(e&1))g=d;else g=f[(f[a>>2]|0)+d>>2]|0;d=Uh[g&1023](a,c)|0;return +(+p[d>>3])}function Mu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;e=li[h&511](a,c,d)|0;return +(+p[e>>3])}function Nu(){var a=0;a=L5b(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function Ou(a){a=a|0;if(!a)return;O5b(a);return}function Pu(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function Qu(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function Ru(){var a=0;a=L5b(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;return a|0}function Su(a){a=a|0;if(!a)return;O5b(a);return}function Tu(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function Uu(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function Vu(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function Wu(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function Xu(){var a=0;a=L5b(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function Yu(a){a=a|0;if(!a)return;O5b(a);return}function Zu(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function _u(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function $u(){var a=0;a=L5b(8)|0;n[a>>2]=0.0;n[a+4>>2]=0.0;return a|0}function av(a){a=a|0;if(!a)return;O5b(a);return}function bv(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function cv(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function dv(){var a=0;a=L5b(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function ev(a){a=a|0;if(!a)return;O5b(a);return}function fv(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function gv(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function hv(){var a=0;a=L5b(8)|0;n[a>>2]=0.0;n[a+4>>2]=0.0;return a|0}function iv(a){a=a|0;if(!a)return;O5b(a);return}function jv(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function kv(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function lv(){var a=0;a=L5b(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;return a|0}function mv(a){a=a|0;if(!a)return;O5b(a);return}function nv(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function ov(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function pv(){var a=0;a=L5b(16)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;return a|0}function qv(a){a=a|0;if(!a)return;O5b(a);return}function rv(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function sv(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function tv(){var a=0;a=L5b(20)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;return a|0}function uv(a){a=a|0;if(!a)return;O5b(a);return}function vv(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=L5b(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function wv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function xv(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=L5b(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function yv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function zv(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function Av(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function Bv(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;zh[a&2047](d,b);Jd(f[d>>2]|0);b=f[d>>2]|0;Yd(b|0);u=c;return b|0}function Cv(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;zh[a&2047](d,b);b=L5b(16)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];u=c;return b|0}function Dv(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;zh[a&2047](d,b);b=L5b(16)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];u=c;return b|0}function Ev(){var a=0;a=L5b(32)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;return a|0}function Fv(a){a=a|0;if(!a)return;O5b(a);return}function Gv(a,b){a=a|0;b=b|0;return +(+p[b+(a<<3)>>3])}function Hv(a,b,c){a=a|0;b=b|0;c=+c;p[b+(a<<3)>>3]=c;return}function Iv(){var a=0;a=L5b(32)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;return a|0}function Jv(a){a=a|0;if(!a)return;O5b(a);return}function Kv(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function Lv(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function Mv(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=L5b(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function Nv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function Ov(){var a=0;a=L5b(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return a|0}function Pv(a){a=a|0;if(!a)return;O5b(a);return}function Qv(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=L5b(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function Rv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function Sv(a,b){a=a|0;b=b|0;return +(+n[b+(f[a>>2]|0)>>2])}function Tv(a,b,c){a=a|0;b=b|0;c=+c;n[b+(f[a>>2]|0)>>2]=c;return}function Uv(){var a=0;a=L5b(192)|0;koa(a);return a|0}function Vv(a){a=a|0;if(!a)return;O5b(a);return}function Wv(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function Xv(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function Yv(){var a=0;a=L5b(44)|0;nO(a);return a|0}function Zv(a){a=a|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _v(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function $v(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function aw(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;zh[f[a>>2]&2047](e,c);c=b[e+11>>0]|0;a=c<<24>>24<0;g=a?f[e+4>>2]|0:c&255;c=OSb(g+4|0)|0;f[c>>2]=g;h=f[e>>2]|0;Vac(c+4|0,(a?h:e)|0,g|0)|0;if(!a){u=d;return c|0}O5b(h);u=d;return c|0}function bw(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;a=d+4|0;i=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)V5b(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{d=i+16&-16;m=L5b(d)|0;f[g>>2]=m;f[g+8>>2]=d|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){Vac(k|0,a|0,i|0)|0;j=k}b[j+i>>0]=0;zh[h&2047](c,g);if((b[g+11>>0]|0)>=0){u=e;return}O5b(f[g>>2]|0);u=e;return}function cw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+48|0;d=c;zh[a&2047](d,b);b=L5b(44)|0;f[b>>2]=42900;a=f[d+4>>2]|0;f[b+4>>2]=a;f[b+8>>2]=f[d+8>>2];if(a|0){e=a+-4|0;f[e>>2]=(f[e>>2]|0)+1}f[b+12>>2]=f[d+12>>2];e=f[d+16>>2]|0;f[b+16>>2]=e;f[b+20>>2]=f[d+20>>2];if(e|0){a=e+-4|0;f[a>>2]=(f[a>>2]|0)+1}a=f[d+24>>2]|0;f[b+24>>2]=a;f[b+28>>2]=f[d+28>>2];if(a|0){e=a+-4|0;f[e>>2]=(f[e>>2]|0)+1}e=f[d+32>>2]|0;f[b+32>>2]=e;f[b+36>>2]=f[d+36>>2];if(!e){g=b+40|0;h=d+40|0;i=f[h>>2]|0;f[g>>2]=i;YN(d);u=c;return b|0}a=e+-4|0;f[a>>2]=(f[a>>2]|0)+1;g=b+40|0;h=d+40|0;i=f[h>>2]|0;f[g>>2]=i;YN(d);u=c;return b|0}function dw(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;zh[a&2047](d,b);b=L5b(12)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];u=c;return b|0}function ew(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+32|0;e=d;_h[a&255](e,b,c);c=L5b(32)|0;f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];u=d;return c|0}function fw(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;zh[a&2047](d,b);b=L5b(32)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];f[b+16>>2]=f[d+16>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];u=c;return b|0}function gw(a){a=a|0;var b=0,c=0;b=u;u=u+32|0;c=b;bi[a&2047](c);a=L5b(32)|0;p[a>>3]=+p[c>>3];p[a+8>>3]=+p[c+8>>3];p[a+16>>3]=+p[c+16>>3];p[a+24>>3]=+p[c+24>>3];u=b;return a|0}function hw(a,b){a=a|0;b=b|0;return di[a&1023](b)|0}function iw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;h=e+16|0;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];th[a&511](h,b,c,g);Jd(f[h>>2]|0);g=f[h>>2]|0;Yd(g|0);u=e;return g|0}function jw(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;bi[a&2047](d);a=b[d+11>>0]|0;e=a<<24>>24<0;g=e?f[d+4>>2]|0:a&255;a=OSb(g+4|0)|0;f[a>>2]=g;h=f[d>>2]|0;Vac(a+4|0,(e?h:d)|0,g|0)|0;if(!e){u=c;return a|0}O5b(h);u=c;return a|0}function kw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function lw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function mw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)c4b(a);k=a+8|0;l=(f[k>>2]|0)-e|0;e=l>>2;m=l>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(m)if(m>>>0>536870911){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{n=L5b(m<<3)|0;break}else n=0;while(0);e=n+(g<<3)|0;h=e;l=n+(m<<3)|0;m=f[b>>2]|0;f[e>>2]=m;f[n+(g<<3)+4>>2]=f[b+4>>2];if(!m){o=j;p=i;q=d}else{d=m+-4|0;f[d>>2]=(f[d>>2]|0)+1;d=f[c>>2]|0;o=d;p=f[a>>2]|0;q=d}d=e+8|0;if((o|0)==(p|0)){r=h;s=o;t=q}else{q=o;o=h;h=e;do{e=q;q=q+-8|0;m=f[q>>2]|0;f[h+-8>>2]=m;f[h+-4>>2]=f[e+-4>>2];if(m|0){e=m+-4|0;f[e>>2]=(f[e>>2]|0)+1}h=o+-8|0;o=h}while((q|0)!=(p|0));r=o;s=f[a>>2]|0;t=f[c>>2]|0}f[a>>2]=r;f[c>>2]=d;f[k>>2]=l;l=s;k=t;while(1){t=k;if((t|0)==(l|0))break;d=t+-8|0;bD(d);k=d}if(!s)return;O5b(s);return}function nw(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;gg[a&3](b,c,d,e,f,g);return}function ow(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;og[a&7](b,c,d,e,f);return}function pw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;Ch[a&7](b,c,d,e);return}function qw(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;mh[a&7](b,c,d,e,f,g);return}function rw(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;$g[a&15](b,c,d,e,f);return}function sw(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];mh[a&7](b,c,j,e,g,h);u=i;return}function tw(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];$g[a&15](b,c,i,e,g);u=h;return}function uw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];oh[a&63](b,c,h,e);u=g;return}function vw(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;Tg[a&1](b,c,d,e,f,g,h,i,j);return}function ww(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;_f[a&1](b,c,d,e,f,g,h,i);return}function xw(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;cg[a&1](b,c,d,e,f,g,h);return}function yw(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;gh[a&3](b,c,d,e,f,g);return}function zw(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;$g[a&15](b,c,d,e,f);return}function Aw(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;jg[a&1](b,c,d,e,f,g,h,i,j);return}function Bw(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;ch[a&1](b,c,d,e,f,g,h,i);return}function Cw(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;eg[a&3](b,c,d,e,f,g,h);return}function Dw(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;hg[a&3](b,c,d,e,f,g);return}function Ew(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;Zf[a&7](b,c,d,e,f,g,h);return}function Fw(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;Gi[a&7](b,c,d,e,f,g);return}function Gw(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;Ah[a&15](b,c,d,e,f);return}function Hw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function Iw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[a&255](b,c,d);return}function Jw(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;Uf[a&3](b,c,d,e,f,g,h,i);return}function Kw(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;qg[a&3](b,c,d,e,f,g,h);return}function Lw(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;Ug[a&7](b,c,d,e,f,g);return}function Mw(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uh[a&255](b,c,d,e,f);return}function Nw(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;vi[a&3](b,c,d,e,f,g,h,i,j);return}function Ow(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;gi[a&3](b,c,d,e,f,g,h,i);return}function Pw(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Sh[a&7](b,c,d,e,f,g,h);return}function Qw(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Wg[a&127](b,c,d,e,f,g);return}function Rw(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[a&255](b,c,d);return}function Sw(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;Mg[a&1](b,c,d,e,f,g,h);return}function Tw(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uh[a&255](b,c,d,e,f);return}function Uw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function Vw(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Ai[a&1](b,c,d,e,f,g,h);return}function Ww(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;fi[a&1](b,c,d,e,f,g);return}function Xw(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;Dh[a&15](b,c,d,e);return}function Yw(a,b,c){a=a|0;b=b|0;c=c|0;return +(+yg[a&31](b,c))}function Zw(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;mh[a&7](b,c,d,e,f,g);return}function _w(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[a&255](b,c,d);return}function $w(a,b,c){a=a|0;b=b|0;c=c|0;zh[a&2047](b,c);return}function ax(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+8|0;j=h;f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];uh[a&255](b,c,i,j,g);u=h;return}function bx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g+8|0;i=g;f[h>>2]=f[d>>2];f[h+4>>2]=f[d+4>>2];f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];th[a&511](b,c,h,i);u=g;return}function cx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];_h[a&255](b,c,g);u=e;return}function dx(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;zh[a&2047](d,b);b=L5b(16)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];u=c;return b|0}function ex(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];Qh[a&127](b,c,d,k,l,h,i);u=j;return}function fx(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];Wg[a&127](b,c,d,j,k,h);u=i;return}function gx(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+8|0;j=h;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];uh[a&255](b,c,d,i,j);u=h;return}function hx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];th[a&511](b,c,d,h);u=g;return}function ix(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+4|0;k=i;f[j>>2]=c;f[k>>2]=g;Ug[a&7](b,j,d,e,k,h);Yd(f[k>>2]|0);Yd(f[j>>2]|0);u=i;return}function jx(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+16|0;k=j+8|0;l=j+4|0;m=j;f[k>>2]=c;f[l>>2]=g;f[m>>2]=h;Qh[a&127](b,k,d,e,l,m,i);Yd(f[m>>2]|0);Yd(f[l>>2]|0);Yd(f[k>>2]|0);u=j;return}function kx(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i+8|0;k=i+4|0;l=i;f[j>>2]=c;f[k>>2]=g;f[l>>2]=h;Wg[a&127](b,j,d,e,k,l);Yd(f[l>>2]|0);Yd(f[k>>2]|0);Yd(f[j>>2]|0);u=i;return}function lx(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;kh[a&1](b,c,d,e,f,g,h,i,j,k);return}function mx(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;var n=0,o=0,p=0;n=u;u=u+32|0;o=n;p=n+16|0;f[p>>2]=f[i>>2];f[p+4>>2]=f[i+4>>2];f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[o+8>>2]=f[k+8>>2];f[o+12>>2]=f[k+12>>2];bg[a&1](b,c,d,e,g,h,p,j,o,l,m);u=n;return}function nx(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=u;u=u+32|0;n=m;o=m+16|0;f[o>>2]=f[i>>2];f[o+4>>2]=f[i+4>>2];f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];f[n+8>>2]=f[k+8>>2];f[n+12>>2]=f[k+12>>2];dh[a&7](b,c,d,e,g,h,o,j,n,l);u=m;return}function ox(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;l=u;u=u+32|0;m=l;n=l+16|0;f[n>>2]=f[i>>2];f[n+4>>2]=f[i+4>>2];f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];f[m+8>>2]=f[k+8>>2];f[m+12>>2]=f[k+12>>2];Th[a&127](b,c,d,e,g,h,n,j,m);u=l;return}function px(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];Hh[a&255](b,c,d,e,g,h,l,j);u=k;return}function qx(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];Qh[a&127](b,c,d,e,g,h,k);u=j;return}function rx(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Wg[a&127](b,c,d,e,f,g);return}function sx(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uh[a&255](b,c,d,e,f);return}function tx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function ux(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];Qh[a&127](b,k,d,e,g,h,i);u=j;return}function vx(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];Wg[a&127](b,j,d,e,g,h);u=i;return}function wx(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];uh[a&255](b,i,d,e,g);u=h;return}function xx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];th[a&511](b,h,d,e);u=g;return}function yx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function zx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+fh[a&31](b,c,d))}function Ax(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Dg[a&127](b,c,d,e)|0}function Bx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[a&511](b,c,d)|0}function Cx(a,b,c){a=a|0;b=b|0;c=c|0;return Uh[a&1023](b,c)|0}function Dx(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Xf[a&127](b,c,d,e,f,g)|0}function Ex(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nh[a&127](b,c,d,e,f)|0}function Fx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Dg[a&127](b,c,d,e)|0}function Gx(a,b){a=a|0;b=b|0;return +(+rg[a&15](b))}function Hx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;ai[a&31](b,c,d);return}function Ix(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function Jx(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[a&255](b,c,d);return}function Kx(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Hh[a&255](b,c,d,e,f,g,h,i);return}function Lx(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Qh[a&127](b,c,d,e,f,g,h);return}function Mx(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;ii[a&7](b,c,d,e,f,g);return}function Nx(a,b){a=a|0;b=b|0;return di[a&1023](b)|0}function Ox(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];Qh[a&127](b,c,d,k,g,h,i);u=j;return}function Px(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];Wg[a&127](b,c,d,j,g,h);u=i;return}function Qx(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];uh[a&255](b,c,d,i,g);u=h;return}function Rx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];th[a&511](b,c,d,h);u=g;return}function Sx(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Wg[a&127](b,c,d,e,f,g);return}function Tx(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uh[a&255](b,c,d,e,f);return}function Ux(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ah[a&7](b,c,d,e,f);return}function Vx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;oh[a&63](b,c,d,e);return}function Wx(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;Xh[a&1](b,c,d,e);return}function Xx(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;wg[a&1](b,c,d);return}function Yx(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0;l=u;u=u+16|0;m=l;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];Th[a&127](b,c,d,e,g,h,i,j,m);u=l;return}function Zx(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Hh[a&255](b,c,d,e,f,g,h,i);return}function _x(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Qh[a&127](b,c,d,e,f,g,h);return}function $x(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Wg[a&127](b,c,d,e,f,g);return}function ay(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uh[a&255](b,c,d,e,f);return}function by(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function cy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[a&511](b,c,d)|0}function dy(a,b,c){a=a|0;b=b|0;c=c|0;return Uh[a&1023](b,c)|0}function ey(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0;m=u;u=u+16|0;n=m+8|0;o=m;f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];Ih[a&1](b,n,o,e,g,h,i,j,k,l);u=m;return}function fy(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;l=u;u=u+16|0;m=l+8|0;n=l;f[m>>2]=f[c>>2];f[m+4>>2]=f[c+4>>2];f[n>>2]=f[d>>2];f[n+4>>2]=f[d+4>>2];Lg[a&1](b,m,n,e,g,h,i,j,k);u=l;return}function gy(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+16|0;l=k+8|0;m=k;f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];Gh[a&1](b,l,m,e,g,h,i,j);u=k;return}function hy(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];Fg[a&1](b,k,l,e,g,h,i);u=j;return}function iy(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uh[a&255](b,c,d,e,f);return}function jy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function ky(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[a&255](b,c,d);return}function ly(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[l>>2]=f[c>>2];f[l+4>>2]=f[c+4>>2];Qh[a&127](k,l,d,e,g,h,i);u=j;return}function my(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e;th[a&511](g,b,c,d);d=L5b(56)|0;f[d>>2]=f[g>>2];c=g+4|0;b=f[c>>2]|0;f[d+4>>2]=b;a=d+8|0;h=g+8|0;f[a>>2]=f[h>>2];f[d+12>>2]=f[g+12>>2];i=g+16|0;f[d+16>>2]=f[i>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];j=g+36|0;f[d+36>>2]=f[j>>2];k=d+40|0;f[k>>2]=a;a=d+44|0;l=d+48|0;f[a>>2]=l;m=d+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((b|0)<3){b=f[n>>2]|0;f[l>>2]=f[b>>2];f[m>>2]=f[b+4>>2];o=b}else{f[a>>2]=f[n>>2];a=g+40|0;f[k>>2]=f[a>>2];k=g+48|0;f[n>>2]=k;f[a>>2]=h;o=k}f[g>>2]=1124007936;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[c+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(g+48|0)){u=e;return d|0}UC(o);u=e;return d|0}function ny(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];ig[a&7](b,c,d,e,k,h,i);u=j;return}function oy(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];Ug[a&7](b,c,d,e,j,h);u=i;return}function py(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];uh[a&255](b,c,d,e,i);u=h;return}function qy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function ry(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];Wg[a&127](b,c,d,e,g,j);u=i;return}function sy(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uh[a&255](b,c,d,e,f);return}function ty(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0;i=u;u=u+16|0;j=i;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[j+8>>2]=f[g+8>>2];f[j+12>>2]=f[g+12>>2];k=+zi[a&3](b,c,d,e,j,h);u=i;return +k}function uy(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0.0;h=u;u=u+16|0;i=h;f[i>>2]=f[g>>2];f[i+4>>2]=f[g+4>>2];f[i+8>>2]=f[g+8>>2];f[i+12>>2]=f[g+12>>2];j=+ri[a&7](b,c,d,e,i);u=h;return +j}function vy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+Kh[a&15](b,c,d,e))}function wy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+fh[a&31](b,c,d))}function xy(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;zh[a&2047](d,b);b=L5b(20)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];f[b+8>>2]=f[d+8>>2];f[b+12>>2]=f[d+12>>2];f[b+16>>2]=f[d+16>>2];u=c;return b|0}function yy(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;mi[a&1](b,c,d,e,f,g,h);return}function zy(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;Ci[a&1](b,c,d,e,f,g);return}function Ay(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d;_h[a&255](e,b,c);c=L5b(56)|0;f[c>>2]=f[e>>2];b=e+4|0;a=f[b>>2]|0;f[c+4>>2]=a;g=c+8|0;h=e+8|0;f[g>>2]=f[h>>2];f[c+12>>2]=f[e+12>>2];i=e+16|0;f[c+16>>2]=f[i>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];f[c+28>>2]=f[e+28>>2];f[c+32>>2]=f[e+32>>2];j=e+36|0;f[c+36>>2]=f[j>>2];k=c+40|0;f[k>>2]=g;g=c+44|0;l=c+48|0;f[g>>2]=l;m=c+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[g>>2]=f[n>>2];g=e+40|0;f[k>>2]=f[g>>2];k=e+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[e>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return c|0}UC(o);u=d;return c|0}function By(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+64|0;g=e+8|0;h=e;f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];Ch[a&7](g,h,c,d);h=L5b(56)|0;f[h>>2]=f[g>>2];a=g+4|0;b=f[a>>2]|0;f[h+4>>2]=b;i=h+8|0;j=g+8|0;f[i>>2]=f[j>>2];f[h+12>>2]=f[g+12>>2];k=g+16|0;f[h+16>>2]=f[k>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];f[h+32>>2]=f[g+32>>2];l=g+36|0;f[h+36>>2]=f[l>>2];m=h+40|0;f[m>>2]=i;i=h+44|0;n=h+48|0;f[i>>2]=n;o=h+52|0;f[o>>2]=0;f[n>>2]=0;p=g+44|0;if((b|0)<3){b=f[p>>2]|0;f[n>>2]=f[b>>2];f[o>>2]=f[b+4>>2];q=b}else{f[i>>2]=f[p>>2];i=g+40|0;f[m>>2]=f[i>>2];m=g+48|0;f[p>>2]=m;f[i>>2]=j;q=m}f[g>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[l>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((q|0)==(g+48|0)){u=e;return h|0}UC(q);u=e;return h|0}function Cy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+80|0;g=e+16|0;h=e+8|0;i=e;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];th[a&511](g,b,h,i);i=L5b(56)|0;f[i>>2]=f[g>>2];h=g+4|0;b=f[h>>2]|0;f[i+4>>2]=b;a=i+8|0;d=g+8|0;f[a>>2]=f[d>>2];f[i+12>>2]=f[g+12>>2];c=g+16|0;f[i+16>>2]=f[c>>2];f[i+20>>2]=f[g+20>>2];f[i+24>>2]=f[g+24>>2];f[i+28>>2]=f[g+28>>2];f[i+32>>2]=f[g+32>>2];j=g+36|0;f[i+36>>2]=f[j>>2];k=i+40|0;f[k>>2]=a;a=i+44|0;l=i+48|0;f[a>>2]=l;m=i+52|0;f[m>>2]=0;f[l>>2]=0;n=g+44|0;if((b|0)<3){b=f[n>>2]|0;f[l>>2]=f[b>>2];f[m>>2]=f[b+4>>2];o=b}else{f[a>>2]=f[n>>2];a=g+40|0;f[k>>2]=f[a>>2];k=g+48|0;f[n>>2]=k;f[a>>2]=d;o=k}f[g>>2]=1124007936;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[j>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((o|0)==(g+48|0)){u=e;return i|0}UC(o);u=e;return i|0}function Dy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+64|0;e=d+8|0;g=d;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];_h[a&255](e,b,g);g=L5b(56)|0;f[g>>2]=f[e>>2];b=e+4|0;a=f[b>>2]|0;f[g+4>>2]=a;c=g+8|0;h=e+8|0;f[c>>2]=f[h>>2];f[g+12>>2]=f[e+12>>2];i=e+16|0;f[g+16>>2]=f[i>>2];f[g+20>>2]=f[e+20>>2];f[g+24>>2]=f[e+24>>2];f[g+28>>2]=f[e+28>>2];f[g+32>>2]=f[e+32>>2];j=e+36|0;f[g+36>>2]=f[j>>2];k=g+40|0;f[k>>2]=c;c=g+44|0;l=g+48|0;f[c>>2]=l;m=g+52|0;f[m>>2]=0;f[l>>2]=0;n=e+44|0;if((a|0)<3){a=f[n>>2]|0;f[l>>2]=f[a>>2];f[m>>2]=f[a+4>>2];o=a}else{f[c>>2]=f[n>>2];c=e+40|0;f[k>>2]=f[c>>2];k=e+48|0;f[n>>2]=k;f[c>>2]=h;o=k}f[e>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(e+48|0)){u=d;return g|0}UC(o);u=d;return g|0}function Ey(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;Ag[a&1](b,c,d,e,f,g,h,i,j);return}function Fy(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;ji[a&3](b,c,d,e,f,g,h,i);return}function Gy(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Vh[a&3](b,c,d,e,f,g,h);return}function Hy(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;mh[a&7](b,c,d,e,f,g);return}function Iy(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;lh[a&1](b,c,d,e,f,g,h,i,j,k);return}function Jy(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;zg[a&1](b,c,d,e,f,g,h,i,j);return}function Ky(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;ji[a&3](b,c,d,e,f,g,h,i);return}function Ly(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];f[k+8>>2]=f[d+8>>2];f[k+12>>2]=f[d+12>>2];Qh[a&127](b,c,k,e,g,h,i);u=j;return}function My(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];f[j+8>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];Wg[a&127](b,c,j,e,g,h);u=i;return}function Ny(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;oh[a&63](b,c,d,e);return}function Oy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[a&255](b,c,d);return}function Py(a,b,c){a=a|0;b=b|0;c=c|0;zh[a&2047](b,c);return}function Qy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function Ry(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];Hh[a&255](b,c,d,e,l,h,i,j);u=k;return}function Sy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function Ty(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[a&255](b,c,d);return}function Uy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+fh[a&31](b,c,d))}function Vy(a,b,c){a=a|0;b=b|0;c=c|0;return +(+yg[a&31](b,c))}function Wy(a,b){a=a|0;b=b|0;return di[a&1023](b)|0}function Xy(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0;j=u;u=u+16|0;k=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];f[k+8>>2]=f[e+8>>2];f[k+12>>2]=f[e+12>>2];l=+xg[a&3](b,c,d,k,g,h,i);u=j;return +l}function Yy(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0;i=u;u=u+16|0;j=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];k=+zi[a&3](b,c,d,j,g,h);u=i;return +k}function Zy(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j+8|0;l=j;f[k>>2]=f[c>>2];f[k+4>>2]=f[c+4>>2];f[l>>2]=f[d>>2];f[l+4>>2]=f[d+4>>2];Qh[a&127](b,k,l,e,g,h,i);u=j;return}function _y(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];Wg[a&127](b,j,k,e,g,h);u=i;return}function $y(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+8|0;j=h;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];uh[a&255](b,i,j,e,g);u=h;return}function az(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g+8|0;i=g;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];th[a&511](b,h,i,e);u=g;return}function bz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return +(+Fh[a&1](b,c,d,e))}function cz(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uh[a&255](b,c,d,e,f);return}function dz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+32|0;e=d;_h[a&255](e,b,c);c=L5b(32)|0;p[c>>3]=+p[e>>3];p[c+8>>3]=+p[e+8>>3];p[c+16>>3]=+p[e+16>>3];p[c+24>>3]=+p[e+24>>3];u=d;return c|0}function ez(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;zh[a&2047](d,b);b=L5b(32)|0;p[b>>3]=+p[d>>3];p[b+8>>3]=+p[d+8>>3];p[b+16>>3]=+p[d+16>>3];p[b+24>>3]=+p[d+24>>3];u=c;return b|0}function fz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function gz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;_h[a&255](b,c,g);Yd(f[g>>2]|0);u=e;return}function hz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+192|0;e=d;_h[a&255](e,b,c);c=L5b(192)|0;Vac(c|0,e|0,192)|0;u=d;return c|0}function iz(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+192|0;d=c;zh[a&2047](d,b);b=L5b(192)|0;Vac(b|0,d|0,192)|0;u=c;return b|0}function jz(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[g>>2];f[l+4>>2]=f[g+4>>2];Hh[a&255](b,c,d,e,l,h,i,j);u=k;return}function kz(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];Qh[a&127](b,c,d,e,k,h,i);u=j;return}function lz(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];Wg[a&127](b,c,d,e,j,h);u=i;return}function mz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +(+fh[a&31](b,c,d))}function nz(a,b,c){a=a|0;b=b|0;c=c|0;return +(+yg[a&31](b,c))}function oz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +(+Kh[a&15](b,c,d,e))}function pz(a,b,c){a=a|0;b=b|0;c=c|0;return +(+yg[a&31](b,c))}function qz(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;Jg[a&1](b,c,d,e,f,g,h);return}function rz(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;gg[a&3](b,c,d,e,f,g);return}function sz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0.0;e=u;u=u+16|0;g=e;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];h=+fh[a&31](b,g,d);u=e;return +h}function tz(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;fg[a&3](b,c,d);return}function uz(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;m=u;u=u+64|0;n=m+40|0;o=m+32|0;q=m;r=d+4|0;s=f[d>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;if(s>>>0>4294967279)V5b(n);if(s>>>0<11){b[n+11>>0]=s;if(!s)t=n;else{v=n;w=6}}else{d=s+16&-16;x=L5b(d)|0;f[n>>2]=x;f[n+8>>2]=d|-2147483648;f[n+4>>2]=s;v=x;w=6}if((w|0)==6){Vac(v|0,r|0,s|0)|0;t=v}b[t+s>>0]=0;f[o>>2]=f[e>>2];f[o+4>>2]=f[e+4>>2];p[q>>3]=+p[i>>3];p[q+8>>3]=+p[i+8>>3];p[q+16>>3]=+p[i+16>>3];p[q+24>>3]=+p[i+24>>3];vh[a&7](c,n,o,g,h,q,j,k,l);if((b[n+11>>0]|0)>=0){u=m;return}O5b(f[n>>2]|0);u=m;return}function vz(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;l=u;u=u+64|0;m=l+40|0;n=l+32|0;o=l;q=d+4|0;r=f[d>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;if(r>>>0>4294967279)V5b(m);if(r>>>0<11){b[m+11>>0]=r;if(!r)s=m;else{t=m;v=6}}else{d=r+16&-16;w=L5b(d)|0;f[m>>2]=w;f[m+8>>2]=d|-2147483648;f[m+4>>2]=r;t=w;v=6}if((v|0)==6){Vac(t|0,q|0,r|0)|0;s=t}b[s+r>>0]=0;f[n>>2]=f[e>>2];f[n+4>>2]=f[e+4>>2];p[o>>3]=+p[i>>3];p[o+8>>3]=+p[i+8>>3];p[o+16>>3]=+p[i+16>>3];p[o+24>>3]=+p[i+24>>3];Tf[a&7](c,m,n,g,h,o,j,k);if((b[m+11>>0]|0)>=0){u=l;return}O5b(f[m>>2]|0);u=l;return}function wz(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0;k=u;u=u+64|0;l=k+40|0;m=k+32|0;n=k;o=d+4|0;q=f[d>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;if(q>>>0>4294967279)V5b(l);if(q>>>0<11){b[l+11>>0]=q;if(!q)r=l;else{s=l;t=6}}else{d=q+16&-16;v=L5b(d)|0;f[l>>2]=v;f[l+8>>2]=d|-2147483648;f[l+4>>2]=q;s=v;t=6}if((t|0)==6){Vac(s|0,o|0,q|0)|0;r=s}b[r+q>>0]=0;f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];p[n>>3]=+p[i>>3];p[n+8>>3]=+p[i+8>>3];p[n+16>>3]=+p[i+16>>3];p[n+24>>3]=+p[i+24>>3];qi[a&7](c,l,m,g,h,n,j);if((b[l+11>>0]|0)>=0){u=k;return}O5b(f[l>>2]|0);u=k;return}function xz(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;j=u;u=u+64|0;k=j+40|0;l=j+32|0;m=j;n=d+4|0;o=f[d>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(o>>>0>4294967279)V5b(k);if(o>>>0<11){b[k+11>>0]=o;if(!o)q=k;else{r=k;s=6}}else{d=o+16&-16;t=L5b(d)|0;f[k>>2]=t;f[k+8>>2]=d|-2147483648;f[k+4>>2]=o;r=t;s=6}if((s|0)==6){Vac(r|0,n|0,o|0)|0;q=r}b[q+o>>0]=0;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];p[m>>3]=+p[i>>3];p[m+8>>3]=+p[i+8>>3];p[m+16>>3]=+p[i+16>>3];p[m+24>>3]=+p[i+24>>3];ii[a&7](c,k,l,g,h,m);if((b[k+11>>0]|0)>=0){u=j;return}O5b(f[k>>2]|0);u=j;return}function yz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function zz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[a&255](b,c,d);return}function Az(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[a&255](b,c,d);return}function Bz(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Qh[a&127](b,c,d,e,f,g,h);return}function Cz(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Wg[a&127](b,c,d,e,f,g);return}function Dz(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uh[a&255](b,c,d,e,f);return}function Ez(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function Fz(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0;k=u;u=u+16|0;l=k;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];Yg[a&3](b,c,d,e,g,l,i,j);u=k;return}function Gz(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];Sh[a&7](b,c,d,e,g,k,i);u=j;return}function Hz(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];Wg[a&127](b,c,d,e,g,j);u=i;return}function Iz(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uh[a&255](b,c,d,e,f);return}function Jz(a,b,c){a=a|0;b=b|0;c=c|0;zh[a&2047](b,c);return}function Kz(a,b){a=a|0;b=b|0;bi[a&2047](b);return}function Lz(a,b){a=a|0;b=b|0;bi[a&2047](b);return}function Mz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Dg[a&127](b,c,d,e)|0}function Nz(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[a&511](b,c,d)|0}function Oz(a,b,c){a=a|0;b=b|0;c=c|0;zh[a&2047](b,c);return}function Pz(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;return +(+eh[a&1](b,c,d,e,f))}function Qz(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uh[a&255](b,c,d,e,f);return}function Rz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b,c,d,e);return}function Sz(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[k>>2]=f[e>>2];f[k+4>>2]=f[e+4>>2];Qh[a&127](b,c,d,k,g,h,i);u=j;return}function Tz(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+16|0;j=i;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];Wg[a&127](b,c,d,j,g,h);u=i;return}function Uz(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];uh[a&255](b,c,d,i,g);u=h;return}function Vz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];th[a&511](b,c,d,h);u=g;return}function Wz(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+64|0;j=i;Og[a&1](j,b,c,d,e,g,h);h=L5b(56)|0;f[h>>2]=f[j>>2];g=j+4|0;e=f[g>>2]|0;f[h+4>>2]=e;d=h+8|0;b=j+8|0;f[d>>2]=f[b>>2];f[h+12>>2]=f[j+12>>2];a=j+16|0;f[h+16>>2]=f[a>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];k=j+36|0;f[h+36>>2]=f[k>>2];l=h+40|0;f[l>>2]=d;d=h+44|0;m=h+48|0;f[d>>2]=m;n=h+52|0;f[n>>2]=0;f[m>>2]=0;o=j+44|0;if((e|0)<3){e=f[o>>2]|0;f[m>>2]=f[e>>2];f[n>>2]=f[e+4>>2];p=e}else{f[d>>2]=f[o>>2];d=j+40|0;f[l>>2]=f[d>>2];l=j+48|0;f[o>>2]=l;f[d>>2]=b;p=l}f[j>>2]=1124007936;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[k>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((p|0)==(j+48|0)){u=i;return h|0}UC(p);u=i;return h|0}function Xz(a,b,c,d,e,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+64|0;i=h;$f[a&1](i,b,c,d,e,g);g=L5b(56)|0;f[g>>2]=f[i>>2];e=i+4|0;d=f[e>>2]|0;f[g+4>>2]=d;b=g+8|0;a=i+8|0;f[b>>2]=f[a>>2];f[g+12>>2]=f[i+12>>2];j=i+16|0;f[g+16>>2]=f[j>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];k=i+36|0;f[g+36>>2]=f[k>>2];l=g+40|0;f[l>>2]=b;b=g+44|0;m=g+48|0;f[b>>2]=m;n=g+52|0;f[n>>2]=0;f[m>>2]=0;o=i+44|0;if((d|0)<3){d=f[o>>2]|0;f[m>>2]=f[d>>2];f[n>>2]=f[d+4>>2];p=d}else{f[b>>2]=f[o>>2];b=i+40|0;f[l>>2]=f[b>>2];l=i+48|0;f[o>>2]=l;f[b>>2]=a;p=l}f[i>>2]=1124007936;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(i+48|0)){u=h;return g|0}UC(p);u=h;return g|0}function Yz(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+64|0;h=g;qh[a&1](h,b,c,d,e);e=L5b(56)|0;f[e>>2]=f[h>>2];d=h+4|0;b=f[d>>2]|0;f[e+4>>2]=b;a=e+8|0;i=h+8|0;f[a>>2]=f[i>>2];f[e+12>>2]=f[h+12>>2];j=h+16|0;f[e+16>>2]=f[j>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];k=h+36|0;f[e+36>>2]=f[k>>2];l=e+40|0;f[l>>2]=a;a=e+44|0;m=e+48|0;f[a>>2]=m;n=e+52|0;f[n>>2]=0;f[m>>2]=0;o=h+44|0;if((b|0)<3){b=f[o>>2]|0;f[m>>2]=f[b>>2];f[n>>2]=f[b+4>>2];p=b}else{f[a>>2]=f[o>>2];a=h+40|0;f[l>>2]=f[a>>2];l=h+48|0;f[o>>2]=l;f[a>>2]=i;p=l}f[h>>2]=1124007936;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(h+48|0)){u=g;return e|0}UC(p);u=g;return e|0}function Zz(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+64|0;g=e;Dh[a&15](g,b,c,d);d=L5b(56)|0;f[d>>2]=f[g>>2];b=g+4|0;a=f[b>>2]|0;f[d+4>>2]=a;h=d+8|0;i=g+8|0;f[h>>2]=f[i>>2];f[d+12>>2]=f[g+12>>2];j=g+16|0;f[d+16>>2]=f[j>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];k=g+36|0;f[d+36>>2]=f[k>>2];l=d+40|0;f[l>>2]=h;h=d+44|0;m=d+48|0;f[h>>2]=m;n=d+52|0;f[n>>2]=0;f[m>>2]=0;o=g+44|0;if((a|0)<3){a=f[o>>2]|0;f[m>>2]=f[a>>2];f[n>>2]=f[a+4>>2];p=a}else{f[h>>2]=f[o>>2];h=g+40|0;f[l>>2]=f[h>>2];l=g+48|0;f[o>>2]=l;f[h>>2]=i;p=l}f[g>>2]=1124007936;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(g+48|0)){u=e;return d|0}UC(p);u=e;return d|0}function _z(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+64|0;e=d;ai[a&31](e,b,c);b=L5b(56)|0;f[b>>2]=f[e>>2];a=e+4|0;g=f[a>>2]|0;f[b+4>>2]=g;h=b+8|0;i=e+8|0;f[h>>2]=f[i>>2];f[b+12>>2]=f[e+12>>2];j=e+16|0;f[b+16>>2]=f[j>>2];f[b+20>>2]=f[e+20>>2];f[b+24>>2]=f[e+24>>2];f[b+28>>2]=f[e+28>>2];f[b+32>>2]=f[e+32>>2];k=e+36|0;f[b+36>>2]=f[k>>2];l=b+40|0;f[l>>2]=h;h=b+44|0;m=b+48|0;f[h>>2]=m;n=b+52|0;f[n>>2]=0;f[m>>2]=0;o=e+44|0;if((g|0)<3){g=f[o>>2]|0;f[m>>2]=f[g>>2];f[n>>2]=f[g+4>>2];p=g}else{f[h>>2]=f[o>>2];h=e+40|0;f[l>>2]=f[h>>2];l=e+48|0;f[o>>2]=l;f[h>>2]=i;p=l}f[e>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[k>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((p|0)==(e+48|0)){u=d;return b|0}UC(p);u=d;return b|0}function $z(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;zh[a&2047](d,b);b=L5b(56)|0;f[b>>2]=f[d>>2];a=d+4|0;e=f[a>>2]|0;f[b+4>>2]=e;g=b+8|0;h=d+8|0;f[g>>2]=f[h>>2];f[b+12>>2]=f[d+12>>2];i=d+16|0;f[b+16>>2]=f[i>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];f[b+32>>2]=f[d+32>>2];j=d+36|0;f[b+36>>2]=f[j>>2];k=b+40|0;f[k>>2]=g;g=b+44|0;l=b+48|0;f[g>>2]=l;m=b+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[d>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return b|0}UC(o);u=c;return b|0}function aA(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+32|0;g=e+24|0;h=e+12|0;i=e;j=c+4|0;k=f[c>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(k>>>0>4294967279)V5b(h);if(k>>>0<11){b[h+11>>0]=k;if(!k)l=h;else{m=h;n=6}}else{c=k+16&-16;o=L5b(c)|0;f[h>>2]=o;f[h+8>>2]=c|-2147483648;f[h+4>>2]=k;m=o;n=6}if((n|0)==6){Vac(m|0,j|0,k|0)|0;l=m}b[l+k>>0]=0;k=d+4|0;l=f[d>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(l>>>0>4294967279)V5b(i);if(l>>>0<11){b[i+11>>0]=l;if(!l)p=i;else{q=i;n=12}}else{d=l+16&-16;m=L5b(d)|0;f[i>>2]=m;f[i+8>>2]=d|-2147483648;f[i+4>>2]=l;q=m;n=12}if((n|0)==12){Vac(q|0,k|0,l|0)|0;p=q}b[p+l>>0]=0;_h[a&255](g,h,i);a=L5b(8)|0;l=f[g>>2]|0;f[a>>2]=l;f[a+4>>2]=f[g+4>>2];if(l|0){p=l+4|0;f[p>>2]=(f[p>>2]|0)+1}kva(g);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[h+11>>0]|0)>=0){u=e;return a|0}O5b(f[h>>2]|0);u=e;return a|0}function bA(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+32|0;e=d+16|0;g=d;h=c+4|0;i=f[c>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)V5b(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{c=i+16&-16;m=L5b(c)|0;f[g>>2]=m;f[g+8>>2]=c|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){Vac(k|0,h|0,i|0)|0;j=k}b[j+i>>0]=0;zh[a&2047](e,g);a=L5b(8)|0;i=f[e>>2]|0;f[a>>2]=i;f[a+4>>2]=f[e+4>>2];if(i|0){j=i+4|0;f[j>>2]=(f[j>>2]|0)+1}kva(e);if((b[g+11>>0]|0)>=0){u=d;return a|0}O5b(f[g>>2]|0);u=d;return a|0}function cA(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+16|0;h=e;i=c+4|0;j=f[c>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(j>>>0>4294967279)V5b(h);if(j>>>0<11){b[h+11>>0]=j;if(!j)k=h;else{l=h;m=6}}else{c=j+16&-16;n=L5b(c)|0;f[h>>2]=n;f[h+8>>2]=c|-2147483648;f[h+4>>2]=j;l=n;m=6}if((m|0)==6){Vac(l|0,i|0,j|0)|0;k=l}b[k+j>>0]=0;_h[a&255](g,h,d);d=L5b(8)|0;a=f[g>>2]|0;f[d>>2]=a;f[d+4>>2]=f[g+4>>2];if(a|0){j=a+4|0;f[j>>2]=(f[j>>2]|0)+1}kva(g);if((b[h+11>>0]|0)>=0){u=e;return d|0}O5b(f[h>>2]|0);u=e;return d|0}function dA(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function eA(a){a=a|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fA(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+32|0;h=g+12|0;i=g;j=f[a>>2]|0;a=d+4|0;k=f[d>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(k>>>0>4294967279)V5b(h);if(k>>>0<11){b[h+11>>0]=k;if(!k)l=h;else{m=h;n=6}}else{d=k+16&-16;o=L5b(d)|0;f[h>>2]=o;f[h+8>>2]=d|-2147483648;f[h+4>>2]=k;m=o;n=6}if((n|0)==6){Vac(m|0,a|0,k|0)|0;l=m}b[l+k>>0]=0;k=e+4|0;l=f[e>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(l>>>0>4294967279)V5b(i);if(l>>>0<11){b[i+11>>0]=l;if(!l)p=i;else{q=i;n=12}}else{e=l+16&-16;m=L5b(e)|0;f[i>>2]=m;f[i+8>>2]=e|-2147483648;f[i+4>>2]=l;q=m;n=12}if((n|0)==12){Vac(q|0,k|0,l|0)|0;p=q}b[p+l>>0]=0;l=li[j&511](c,h,i)|0;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[h+11>>0]|0)>=0){u=g;return l|0}O5b(f[h>>2]|0);u=g;return l|0}function gA(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;a=d+4|0;i=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)V5b(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{d=i+16&-16;m=L5b(d)|0;f[g>>2]=m;f[g+8>>2]=d|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){Vac(k|0,a|0,i|0)|0;j=k}b[j+i>>0]=0;i=Uh[h&1023](c,g)|0;if((b[g+11>>0]|0)>=0){u=e;return i|0}O5b(f[g>>2]|0);u=e;return i|0}function hA(){var a=0,c=0;a=L5b(152)|0;f[a>>2]=80092;f[a+4>>2]=64;f[a+8>>2]=128;f[a+12>>2]=16;f[a+16>>2]=16;f[a+20>>2]=8;f[a+24>>2]=8;f[a+28>>2]=8;f[a+32>>2]=8;f[a+36>>2]=9;f[a+40>>2]=1;p[a+48>>3]=-1.0;f[a+56>>2]=0;p[a+64>>3]=.2;b[a+72>>0]=1;f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[a+88>>2]=1124007936;c=a+92|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[a+120>>2]=a+96;c=a+128|0;f[a+124>>2]=c;f[a+132>>2]=0;f[c>>2]=0;n[a+136>>2]=-1.0;f[a+140>>2]=64;b[a+144>>0]=0;return a|0}function iA(a){a=a|0;return xi[a&31]()|0}function jA(a,c,d,e,g,h,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0;q=L5b(152)|0;r=f[a>>2]|0;s=f[a+4>>2]|0;a=f[c>>2]|0;t=f[c+4>>2]|0;c=f[d>>2]|0;u=f[d+4>>2]|0;d=f[e>>2]|0;v=f[e+4>>2]|0;e=f[g>>2]|0;g=f[h>>2]|0;w=+p[i>>3];i=f[j>>2]|0;x=+p[k>>3];k=b[l>>0]|0;l=f[m>>2]|0;m=b[o>>0]|0;f[q>>2]=80092;f[q+4>>2]=r;f[q+8>>2]=s;f[q+12>>2]=a;f[q+16>>2]=t;f[q+20>>2]=c;f[q+24>>2]=u;f[q+28>>2]=d;f[q+32>>2]=v;f[q+36>>2]=e;f[q+40>>2]=g;p[q+48>>3]=w;f[q+56>>2]=i;p[q+64>>3]=x;b[q+72>>0]=k;f[q+76>>2]=0;f[q+80>>2]=0;f[q+84>>2]=0;f[q+88>>2]=1124007936;k=q+92|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[q+120>>2]=q+96;k=q+128|0;f[q+124>>2]=k;f[q+132>>2]=0;f[k>>2]=0;n[q+136>>2]=-1.0;f[q+140>>2]=l;b[q+144>>0]=m;return q|0}function kA(a,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;l=+l;m=m|0;n=n|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;q=u;u=u+80|0;r=q+56|0;s=q+48|0;t=q+40|0;v=q+32|0;w=q+28|0;x=q+24|0;y=q+8|0;z=q+20|0;A=q;B=q+65|0;C=q+16|0;D=q+64|0;f[r>>2]=f[c>>2];f[r+4>>2]=f[c+4>>2];f[s>>2]=f[d>>2];f[s+4>>2]=f[d+4>>2];f[t>>2]=f[e>>2];f[t+4>>2]=f[e+4>>2];f[v>>2]=f[g>>2];f[v+4>>2]=f[g+4>>2];f[w>>2]=h;f[x>>2]=i;p[y>>3]=j;f[z>>2]=k;p[A>>3]=l;b[B>>0]=m&1;f[C>>2]=n;b[D>>0]=o&1;o=ti[a&1](r,s,t,v,w,x,y,z,A,B,C,D)|0;u=q;return o|0}function lA(a){a=a|0;var b=0;b=L5b(152)|0;nA(b,a);return b|0}function mA(a,b){a=a|0;b=b|0;return di[a&1023](b)|0}function nA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=80092;e=a+4|0;f[a+76>>2]=0;f[a+80>>2]=0;f[a+84>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;f[a+88>>2]=1124007936;e=a+92|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[a+120>>2]=a+96;e=a+128|0;f[a+124>>2]=e;f[a+132>>2]=0;f[e>>2]=0;e=f[20028]|0;f[d>>2]=0;f[d+4>>2]=0;li[e&511](a,b,d)|0;bD(d);u=c;return}function oA(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;bi[a&2047](c);a=L5b(12)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];u=b;return a|0}function pA(a,b,c){a=a|0;b=b|0;c=c|0;zh[f[a>>2]&2047](b,c);return}function qA(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+16|0;n=m+8|0;o=m;p=f[a>>2]|0;f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[o>>2]=f[i>>2];f[o+4>>2]=f[i+4>>2];tg[p&3](b,c,d,e,g,n,o,j,k,l);u=m;return}function rA(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,n=0,o=0;l=u;u=u+16|0;m=l+8|0;n=l;o=f[a>>2]|0;f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[n>>2]=f[i>>2];f[n+4>>2]=f[i+4>>2];Bg[o&1](b,c,d,e,g,m,n,j,k);u=l;return}function sA(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=+j;var k=0,l=0,m=0,n=0;k=u;u=u+16|0;l=k+8|0;m=k;n=f[a>>2]|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];Wf[n&1](b,c,d,e,g,l,m,j);u=k;return}function tA(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;j=u;u=u+16|0;k=j+8|0;l=j;m=f[a>>2]|0;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];qi[m&7](b,c,d,e,g,k,l);u=j;return}function uA(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];ii[k&7](b,c,d,e,g,j);u=i;return}function vA(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;Ah[f[a>>2]&15](b,c,d,e,g);return}function wA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[f[a>>2]&511](b,c,d,e);return}function xA(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=L5b(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];return a|0}function yA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];return}function zA(a,b){a=a|0;b=b|0;return f[b+(f[a>>2]|0)>>2]|0}function AA(a,b,c){a=a|0;b=b|0;c=c|0;f[b+(f[a>>2]|0)>>2]=c;return}function BA(a,b){a=a|0;b=b|0;return +(+p[b+(f[a>>2]|0)>>3])}function CA(a,b,c){a=a|0;b=b|0;c=+c;p[b+(f[a>>2]|0)>>3]=c;return}function DA(a,c){a=a|0;c=c|0;return (b[c+(f[a>>2]|0)>>0]|0)!=0|0}function EA(a,c,d){a=a|0;c=c|0;d=d|0;b[c+(f[a>>2]|0)>>0]=d&1;return}function FA(a,b){a=a|0;b=b|0;var c=0;c=b+(f[a>>2]|0)|0;a=L5b(12)|0;HA(a,c);return a|0}function GA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=b+(f[a>>2]|0)|0;if((d|0)==(c|0))return;IA(d,f[c>>2]|0,f[c+4>>2]|0);return}function HA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>2;if(!g)return;if(g>>>0>1073741823)c4b(a);h=L5b(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<2);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;Vac(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>2<<2);return}function IA(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>2;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>2>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>2;o=h>>>0>n>>>0;p=o?b+(n<<2)|0:c;c=p;n=c-e|0;e=n>>2;if(e|0)Xac(k|0,b|0,n|0)|0;n=l+(e<<2)|0;if(o){o=d-c|0;if((o|0)<=0)return;Vac(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>2<<2);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);O5b(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>1073741823)c4b(a);j=q>>1;n=q>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;if(n>>>0>1073741823)c4b(a);j=L5b(n<<2)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<2);if((g|0)<=0)return;Vac(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>2<<2);return}function JA(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function KA(a){a=a|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function LA(a){a=a|0;return a|0}function MA(a){a=a|0;return a|0}function NA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;oh[f[a>>2]&63](b,c,d,e);return}function OA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[f[a>>2]&255](b,c,d);return}function PA(a,b,c){a=a|0;b=b|0;c=c|0;zh[f[a>>2]&2047](b,c);return}function QA(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function RA(a){a=a|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function SA(a){a=a|0;return a|0}function TA(a){a=a|0;return a|0}function UA(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;Dh[a&15](g,b,c,d);d=L5b(8)|0;f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];u=e;return d|0}function VA(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+16|0;e=d;ai[a&31](e,b,c);b=L5b(8)|0;f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];u=d;return b|0}function WA(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;zh[a&2047](d,b);b=L5b(8)|0;f[b>>2]=f[d>>2];f[b+4>>2]=f[d+4>>2];u=c;return b|0}function XA(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;bi[a&2047](c);a=L5b(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function YA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;oh[f[a>>2]&63](b,c,d,e);return}function ZA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[f[a>>2]&255](b,c,d);return}function _A(a){a=a|0;return f[a+4>>2]|0}function $A(){var a=0;a=L5b(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function aB(a){a=a|0;return 0}function bB(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)bi[f[(f[b>>2]|0)+8>>2]&2047](b);O5b(a);return}function cB(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function dB(a){a=a|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function eB(a){a=a|0;return a|0}function fB(a){a=a|0;return a|0}function gB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];zh[g&2047](b,e);u=d;return}function hB(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;g=d+8|0;f[g>>2]=f[c>>2];f[g+4>>2]=f[c+4>>2];fg[a&3](e,b,g);g=L5b(8)|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];u=d;return g|0}function iB(a,b){a=a|0;b=+b;var c=0,d=0;c=u;u=u+16|0;d=c;wh[a&15](d,b);a=L5b(8)|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return a|0}function jB(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;bi[a&2047](c);a=L5b(8)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];u=b;return a|0}function kB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;bi[e&2047](a);return}else{e=f[(f[a>>2]|0)+c>>2]|0;bi[e&2047](a);return}}function lB(a,b,c){a=a|0;b=b|0;c=+c;wh[f[a>>2]&15](b,c);return}function mB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=f[a>>2]|0;g=f[a+4>>2]|0;a=b+(g>>1)|0;if(!(g&1))h=e;else h=f[(f[a>>2]|0)+e>>2]|0;zh[h&2047](d,a);a=L5b(8)|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];u=c;return a|0}function nB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1)){e=c;g=+rg[e&15](a);return +g}else{e=f[(f[a>>2]|0)+c>>2]|0;g=+rg[e&15](a);return +g}return +(0.0)}function oB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[f[a>>2]&255](b,c,d);return}function pB(a){a=a|0;return f[a+4>>2]|0}function qB(){var a=0;a=L5b(8)|0;f[a>>2]=0;f[a+4>>2]=0;return a|0}function rB(a){a=a|0;return 0}function sB(a){a=a|0;var b=0,c=0,d=0;if(!a)return;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)bi[f[(f[b>>2]|0)+8>>2]&2047](b);O5b(a);return}function tB(a){a=a|0;return f[(f[a>>2]|0)+-4>>2]|0}function uB(a){a=a|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function vB(a){a=a|0;return 9024}function wB(a){a=a|0;if(!a)return;kva(a);O5b(a);return}function xB(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=f[a>>2]|0;a=e+4|0;j=f[e>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(j>>>0>4294967279)V5b(h);if(j>>>0<11){b[h+11>>0]=j;if(!j)k=h;else{l=h;m=6}}else{e=j+16&-16;n=L5b(e)|0;f[h>>2]=n;f[h+8>>2]=e|-2147483648;f[h+4>>2]=j;l=n;m=6}if((m|0)==6){Vac(l|0,a|0,j|0)|0;k=l}b[k+j>>0]=0;_h[i&255](c,d,h);if((b[h+11>>0]|0)>=0){u=g;return}O5b(f[h>>2]|0);u=g;return}function yB(a,b,c){a=a|0;b=b|0;c=c|0;zh[f[a>>2]&2047](b,c);return}function zB(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+80|0;g=e+16|0;h=e;i=f[a>>2]|0;a=d+4|0;j=f[d>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(j>>>0>4294967279)V5b(h);if(j>>>0<11){b[h+11>>0]=j;if(!j)k=h;else{l=h;m=6}}else{d=j+16&-16;n=L5b(d)|0;f[h>>2]=n;f[h+8>>2]=d|-2147483648;f[h+4>>2]=j;l=n;m=6}if((m|0)==6){Vac(l|0,a|0,j|0)|0;k=l}b[k+j>>0]=0;_h[i&255](g,c,h);c=L5b(56)|0;f[c>>2]=f[g>>2];i=g+4|0;j=f[i>>2]|0;f[c+4>>2]=j;k=c+8|0;l=g+8|0;f[k>>2]=f[l>>2];f[c+12>>2]=f[g+12>>2];a=g+16|0;f[c+16>>2]=f[a>>2];f[c+20>>2]=f[g+20>>2];f[c+24>>2]=f[g+24>>2];f[c+28>>2]=f[g+28>>2];f[c+32>>2]=f[g+32>>2];m=g+36|0;f[c+36>>2]=f[m>>2];n=c+40|0;f[n>>2]=k;k=c+44|0;d=c+48|0;f[k>>2]=d;o=c+52|0;f[o>>2]=0;f[d>>2]=0;p=g+44|0;if((j|0)<3){j=f[p>>2]|0;f[d>>2]=f[j>>2];f[o>>2]=f[j+4>>2];q=j}else{f[k>>2]=f[p>>2];k=g+40|0;f[n>>2]=f[k>>2];n=g+48|0;f[p>>2]=n;f[k>>2]=l;q=n}f[g>>2]=1124007936;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;f[m>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((q|0)!=(g+48|0))UC(q);if((b[h+11>>0]|0)>=0){u=e;return c|0}O5b(f[h>>2]|0);u=e;return c|0}function AB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+64|0;d=c;zh[f[a>>2]&2047](d,b);b=L5b(56)|0;f[b>>2]=f[d>>2];a=d+4|0;e=f[a>>2]|0;f[b+4>>2]=e;g=b+8|0;h=d+8|0;f[g>>2]=f[h>>2];f[b+12>>2]=f[d+12>>2];i=d+16|0;f[b+16>>2]=f[i>>2];f[b+20>>2]=f[d+20>>2];f[b+24>>2]=f[d+24>>2];f[b+28>>2]=f[d+28>>2];f[b+32>>2]=f[d+32>>2];j=d+36|0;f[b+36>>2]=f[j>>2];k=b+40|0;f[k>>2]=g;g=b+44|0;l=b+48|0;f[g>>2]=l;m=b+52|0;f[m>>2]=0;f[l>>2]=0;n=d+44|0;if((e|0)<3){e=f[n>>2]|0;f[l>>2]=f[e>>2];f[m>>2]=f[e+4>>2];o=e}else{f[g>>2]=f[n>>2];g=d+40|0;f[k>>2]=f[g>>2];k=d+48|0;f[n>>2]=k;f[g>>2]=h;o=k}f[d>>2]=1124007936;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((o|0)==(d+48|0)){u=c;return b|0}UC(o);u=c;return b|0}function BB(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g;i=f[a>>2]|0;a=e+4|0;j=f[e>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(j>>>0>4294967279)V5b(h);if(j>>>0<11){b[h+11>>0]=j;if(!j)k=h;else{l=h;m=6}}else{e=j+16&-16;n=L5b(e)|0;f[h>>2]=n;f[h+8>>2]=e|-2147483648;f[h+4>>2]=j;l=n;m=6}if((m|0)==6){Vac(l|0,a|0,j|0)|0;k=l}b[k+j>>0]=0;_h[i&255](c,d,h);if((b[h+11>>0]|0)>=0){u=g;return}O5b(f[h>>2]|0);u=g;return}function CB(a,b,c){a=a|0;b=b|0;c=c|0;zh[f[a>>2]&2047](b,c);return}function DB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;f[g>>2]=d;_h[h&255](b,c,g);Yd(f[g>>2]|0);u=e;return}function EB(a){a=a|0;return 9288}function FB(a){a=a|0;if(!a)return;Nra(a);O5b(a);return}function GB(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=f[a>>2]|0;a=d+4|0;i=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(i>>>0>4294967279)V5b(g);if(i>>>0<11){b[g+11>>0]=i;if(!i)j=g;else{k=g;l=6}}else{d=i+16&-16;m=L5b(d)|0;f[g>>2]=m;f[g+8>>2]=d|-2147483648;f[g+4>>2]=i;k=m;l=6}if((l|0)==6){Vac(k|0,a|0,i|0)|0;j=k}b[j+i>>0]=0;i=Uh[h&1023](c,g)|0;if((b[g+11>>0]|0)>=0){u=e;return i|0}O5b(f[g>>2]|0);u=e;return i|0}function HB(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0;l=u;u=u+16|0;m=l+8|0;n=l;o=f[a>>2]|0;f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];vh[o&7](b,c,d,e,g,h,i,m,n);u=l;return}function IB(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+16|0;l=k;m=f[a>>2]|0;f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];Tf[m&7](b,c,d,e,g,h,i,l);u=k;return}function JB(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;qi[f[a>>2]&7](b,c,d,e,g,h,i);return}function KB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;ii[f[a>>2]&7](b,c,d,e,g,h);return}function LB(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;Ah[f[a>>2]&15](b,c,d,e,g);return}function MB(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[f[a>>2]&511](b,c,d,e);return}function NB(){var a=0;a=L5b(8)|0;Ira(a);return a|0}function OB(a){a=a|0;return xi[a&31]()|0}function PB(a){a=a|0;var b=0;b=L5b(8)|0;Jra(b,a);return b|0}function QB(a,b){a=a|0;b=b|0;return di[a&1023](b)|0}function RB(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0;n=u;u=u+16|0;o=n+8|0;p=n;q=f[a>>2]|0;f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];Eg[q&3](b,c,d,e,g,h,i,j,o,p,m);u=n;return}function SB(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+16|0;n=m+8|0;o=m;p=f[a>>2]|0;f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];Ng[p&3](b,c,d,e,g,h,i,j,n,o);u=m;return}function TB(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0;l=u;u=u+16|0;m=l;n=f[a>>2]|0;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];Bi[n&3](b,c,d,e,g,h,i,j,m);u=l;return}function UB(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;Mh[f[a>>2]&7](b,c,d,e,g,h,i,j);return}function VB(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;ig[f[a>>2]&7](b,c,d,e,g,h,i);return}function WB(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;Ug[f[a>>2]&7](b,c,d,e,g,h);return}function XB(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;uh[f[a>>2]&255](b,c,d,e,g);return}function YB(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;d=f[a+4>>2]|0;a=b+(d>>1)|0;if(!(d&1))e=c;else e=f[(f[a>>2]|0)+c>>2]|0;return di[e&1023](a)|0}function ZB(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;k=u;u=u+16|0;l=k+8|0;m=k;n=f[a>>2]|0;f[l>>2]=f[i>>2];f[l+4>>2]=f[i+4>>2];f[m>>2]=f[j>>2];f[m+4>>2]=f[j+4>>2];Xg[n&3](b,c,d,e,g,h,l,m);u=k;return}function _B(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j;l=f[a>>2]|0;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];Vf[l&3](b,c,d,e,g,h,k);u=j;return}function $B(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;pg[f[a>>2]&1](b,c,d,e,g,h);return}function aC(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;ah[f[a>>2]&7](b,c,d,e,g);return}function bC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;oh[f[a>>2]&63](b,c,d,e);return}function cC(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[f[a>>2]&255](b,c,d);return}function dC(){vj(0);Gr(0);return}function eC(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=L5b(12)|0;f[j>>2]=33128;f[j+4>>2]=0;b[j+8>>0]=0;fC(j);O5b(j);j=L5b(2296)|0;f[j>>2]=33148;k=j+8|0;b[j+48>>0]=0;f[j+44>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;d[k+32>>1]=0;b[k+34>>0]=0;k=(oO(4)|0)&1;b[j+43>>0]=k;f[j+192>>2]=j+200;f[j+196>>2]=1032;f[j+1232>>2]=j+1240;f[j+1236>>2]=264;f[j+12>>2]=j+56;gC(j,c,e,g,h,i);i=L5b(16)|0;f[i+4>>2]=1;f[i>>2]=33168;f[i+8>>2]=j;f[a>>2]=i;f[a+4>>2]=j;return}function fC(a){a=a|0;f[a>>2]=33128;return}function gC(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0;i=a+8|0;j=a+36|0;k=f[j>>2]|0;l=(g&128|0)==0;m=(e|0)==5?8:16;n=a+40|0;o=g&1;b[n>>0]=o;q=(g&32|0)!=0;b[a+42>>0]=(g&144|0)==16&1;r=a+16|0;p[r>>3]=1.0;f[a+32>>2]=c;f[j>>2]=c;b[a+48>>0]=0;s=(k|0)!=(c|0);k=a+12|0;t=f[k>>2]|0;if(s){if((c|0)>=6){u=(c+-1^c)+1>>1;if((u|0)>1){f[t>>2]=u;if((u|0)!=(c|0)?(v=(c>>>0)/(u>>>0)|0,(v|0)>1):0){w=3;x=v;y=1;z=8}else A=1}else{w=3;x=c;y=0;z=8}a:do if((z|0)==8){b:while(1){z=0;v=w;while(1){B=(x|0)/(v|0)|0;if((Y(B,v)|0)==(x|0))break;u=v+2|0;if((Y(u,u)|0)>(x|0))break b;else v=u}u=y+1|0;f[t+(y<<2)>>2]=v;if((B|0)>1){w=v;x=B;y=u;z=8}else{A=u;break a}}f[t+(y<<2)>>2]=x;A=y+1|0}while(0);y=f[t>>2]&1^1;x=(y+A|0)/2|0;if((y|0)<(x|0)){B=A+-1+y|0;w=y;do{y=t+(w<<2)|0;u=f[y>>2]|0;C=t+(B-w<<2)|0;f[y>>2]=f[C>>2];f[C>>2]=u;w=w+1|0}while((w|0)!=(x|0));D=A}else D=A}else{f[t>>2]=c;D=1}f[i>>2]=D;A=(f[t>>2]|0)==(f[t+(D+-1<<2)>>2]|0);if(!s)if(A)E=1;else{F=i;z=18}else{G=i;H=A;z=19}}else if((f[t>>2]|0)==(f[t+((f[i>>2]|0)+-1<<2)>>2]|0))E=1;else{F=i;z=18}if((z|0)==18)if(o<<24>>24==0|q^1)E=0;else{G=F;H=0;z=19}if((z|0)==19){F=a+192|0;o=Y(f[j>>2]|0,m)|0;i=a+196|0;if((f[i>>2]|0)>>>0<o>>>0){t=f[F>>2]|0;A=a+200|0;if((t|0)==(A|0))I=t;else{if(t|0)P5b(t);f[F>>2]=A;f[i>>2]=1032;I=A}f[i>>2]=o;if(o>>>0>1032){A=N5b(o)|0;f[F>>2]=A;J=A}else J=I}else{f[i>>2]=o;J=f[F>>2]|0}F=a+28|0;f[F>>2]=J;J=a+1232|0;o=f[j>>2]|0;i=a+1236|0;if((f[i>>2]|0)>>>0<o>>>0){I=f[J>>2]|0;A=a+1240|0;if((I|0)==(A|0))K=I;else{if(I|0)P5b(I);f[J>>2]=A;f[i>>2]=264;K=A}f[i>>2]=o;if(o>>>0>264){A=N5b(o>>>0>1073741823?-1:o<<2)|0;f[J>>2]=A;L=A}else L=K}else{f[i>>2]=o;L=f[J>>2]|0}f[a+24>>2]=L;if(l)M=q&(b[n>>0]|0)!=0;else M=0;kC(f[j>>2]|0,f[G>>2]|0,f[k>>2]|0,L,m,f[F>>2]|0,M&1);E=H}do if(!h)z=44;else{if(l){if(E|(b[h>>0]|0)==0?(c&1|0)==0|q^1:0){z=44;break}}else if(E){N=0;O=1;break}b[h>>0]=1;z=44}while(0);if((z|0)==44){z=l^1;if(z|q^1){N=0;O=z}else{N=(b[n>>0]|0)==0?1:2;O=0}}f[a+44>>2]=f[33180+(((e|0)==6?N+3|0:N)<<2)>>2];if((g&66|0)!=2)return;P=1.0/+(Y((g&4|0)==0|O?d:1,c)|0);p[r>>3]=P;return}function hC(a){a=a|0;return}function iC(a){a=a|0;O5b(a);return}function jC(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+8>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function kC(a,b,c,d,e,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,N=0.0,O=0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0;j=u;u=u+272|0;k=j+136|0;l=j;m=f[c>>2]|0;do if((a|0)<6){f[d>>2]=0;o=a+-1|0;f[d+(o<<2)>>2]=o;if((a|0)==4){f[d+4>>2]=2;f[d+8>>2]=1;q=2;break}if((o|0)>1)r=1;else{u=j;return}do{f[d+(r<<2)>>2]=r;r=r+1|0}while((r|0)!=(o|0));if((a|0)!=5){u=j;return}if((e|0)==16){p[g>>3]=1.0;p[g+8>>3]=0.0;u=j;return}else{f[g>>2]=1065353216;f[g+4>>2]=0;u=j;return}}else{f[l+(b<<2)>>2]=1;f[k+(b<<2)>>2]=0;if((b|0)>0){Nac(k|0,0,b<<2|0)|0;o=0;do{s=b-o|0;t=s+-1|0;v=Y(f[c+(t<<2)>>2]|0,f[l+(s<<2)>>2]|0)|0;f[l+(t<<2)>>2]=v;o=o+1|0}while((o|0)!=(b|0))}if(!i)w=d;else w=(m|0)==(f[c+(b+-1<<2)>>2]|0)?d:g;a:do if(!(m&1)){o=f[l+4>>2]|0;v=Y(o,m)|0;t=v>>1;s=0;while(1)if(1<<s>>>0<m>>>0)s=s+1|0;else break;x=v>>2;do if((m|0)>=3)if((m|0)<257){y=10-s|0;z=m+-4|0;if((m|0)<4)break;else A=0;do{B=Y((h[170274+(A>>2)>>0]|0)>>>y,o)|0;f[w+(A<<2)>>2]=B;C=B+t|0;f[w+((A|1)<<2)>>2]=C;f[w+((A|2)<<2)>>2]=B+x;f[w+((A|3)<<2)>>2]=C+x;A=A+4|0}while((A|0)<=(z|0))}else{z=34-s|0;y=0;do{C=Y(((h[170274+(y>>>10&255)>>0]|0)<<16|(h[170274+(y>>>2&255)>>0]|0)<<24|(h[170274+(y>>>18&255)>>0]|0)<<8|(h[170274+(y>>26)>>0]|0))>>>z,o)|0;f[w+(y<<2)>>2]=C;B=C+t|0;f[w+((y|1)<<2)>>2]=B;f[w+((y|2)<<2)>>2]=C+x;f[w+((y|3)<<2)>>2]=B+x;y=y+4|0}while((y|0)<(m|0))}else{f[w>>2]=0;f[w+4>>2]=t}while(0);t=k+4|0;f[t>>2]=(f[t>>2]|0)+1;if((b|0)>1?(x=f[l+8>>2]|0,(m|0)<(a|0)):0){o=c+4|0;if((m|0)>0){v=x;y=m;b:while(1){z=0;do{f[w+(z+y<<2)>>2]=(f[w+(z<<2)>>2]|0)+v;z=z+1|0}while((z|0)!=(m|0));z=y+m|0;if((z|0)>=(a|0)){D=s;break a}B=x+v|0;C=(f[t>>2]|0)+1|0;f[t>>2]=C;if((C|0)<(f[o>>2]|0)){v=B;y=z;continue}else{E=B;F=1;G=t}while(1){f[G>>2]=0;B=(f[l+(F+2<<2)>>2]|0)+E-(f[l+(F<<2)>>2]|0)|0;C=F+1|0;H=k+(C<<2)|0;I=(f[H>>2]|0)+1|0;f[H>>2]=I;if((I|0)<(f[c+(C<<2)>>2]|0)){v=B;y=z;continue b}else{E=B;F=C;G=H}}}}else{y=m<<1;if((y|0)>=(a|0)){D=s;break}v=f[o>>2]|0;x=y;do{y=(f[t>>2]|0)+1|0;f[t>>2]=y;if((y|0)>=(v|0)){y=1;z=t;do{f[z>>2]=0;y=y+1|0;z=k+(y<<2)|0;H=(f[z>>2]|0)+1|0;f[z>>2]=H}while((H|0)>=(f[c+(y<<2)>>2]|0))}x=x+m|0}while((x|0)<(a|0));D=s}}else D=s}else{f[w>>2]=0;if((a|0)>1){x=f[l+4>>2]|0;t=0;v=1;while(1){o=x+t|0;y=(f[k>>2]|0)+1|0;f[k>>2]=y;if((y|0)<(f[c>>2]|0))J=o;else{y=0;z=o;o=k;while(1){f[o>>2]=0;H=(f[l+(y+2<<2)>>2]|0)+z-(f[l+(y<<2)>>2]|0)|0;y=y+1|0;o=k+(y<<2)|0;C=(f[o>>2]|0)+1|0;f[o>>2]=C;if((C|0)<(f[c+(y<<2)>>2]|0)){J=H;break}else z=H}}f[w+(v<<2)>>2]=J;v=v+1|0;if((v|0)==(a|0)){D=0;break}else t=J}}else D=0}while(0);if((w|0)!=(d|0)?(f[d>>2]=0,t=a&1,(t|0)<(a|0)):0){v=t;do{t=v+1|0;x=f[w+(t<<2)>>2]|0;f[d+(f[w+(v<<2)>>2]<<2)>>2]=v;f[d+(x<<2)>>2]=t;v=v+2|0}while((v|0)<(a|0));q=D}else q=D}while(0);if(!(a+-1&a)){K=+p[9352+(q<<4)>>3];L=-+p[9352+(q<<4)+8>>3]}else{N=+P(+(-6.283185307179586/+(a|0)));K=+M(+(1.0-N*N));L=N}q=(a+1|0)/2|0;D=(a&1|0)==0;if((e|0)==16){p[g>>3]=1.0;p[g+8>>3]=0.0;if(D){p[g+(q<<4)>>3]=-1.0;p[g+(q<<4)+8>>3]=0.0}if((a|0)>2){O=1;Q=K;R=L}else{u=j;return}while(1){p[g+(O<<4)>>3]=Q;p[g+(O<<4)+8>>3]=R;e=a-O|0;p[g+(e<<4)>>3]=Q;p[g+(e<<4)+8>>3]=-R;N=K*R+L*Q;O=O+1|0;if((O|0)>=(q|0))break;else{Q=K*Q-L*R;R=N}}u=j;return}else{n[g>>2]=1.0;n[g+4>>2]=0.0;if(D){n[g+(q<<3)>>2]=-1.0;n[g+(q<<3)+4>>2]=0.0}if((a|0)>2){S=1;T=K;U=L}else{u=j;return}while(1){R=T;n[g+(S<<3)>>2]=R;Q=U;n[g+(S<<3)+4>>2]=Q;D=a-S|0;n[g+(D<<3)>>2]=R;n[g+(D<<3)+4>>2]=-Q;Q=K*U+L*T;S=S+1|0;if((S|0)>=(q|0))break;else{T=K*T-L*U;U=Q}}u=j;return}}function lC(a,b,c){a=a|0;b=b|0;c=c|0;vC(a,b,c);return}function mC(a,b,c){a=a|0;b=b|0;c=c|0;wC(a,b,c);return}function nC(a,b,c){a=a|0;b=b|0;c=c|0;uC(a,b,c);return}function oC(a,b,c){a=a|0;b=b|0;c=c|0;sC(a,b,c);return}function pC(a,b,c){a=a|0;b=b|0;c=c|0;tC(a,b,c);return}function qC(a,b,c){a=a|0;b=b|0;c=c|0;rC(a,b,c);return}function rC(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0,O=0.0,P=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=(b[a+34>>0]|0)!=0;j=+p[a+8>>3];if(i){k=c+8|0;l=+p[k>>3];m=+p[c>>3];p[k>>3]=m;n=k;o=l;q=m}else{n=c;o=0.0;q=+p[c>>3]}a:do switch(h|0){case 1:{p[d>>3]=j*q;break}case 2:{m=+p[n+8>>3];p[d+8>>3]=j*(q-m);p[d>>3]=j*(q+m);break}default:{c=h+1>>1;if(h&1|0){k=n+-8|0;p[d>>3]=q;p[d+8>>3]=0.0;if((c|0)>1){r=f[a+16>>2]|0;s=1;do{t=f[r+(s<<2)>>2]|0;v=f[r+(h-s<<2)>>2]|0;m=+p[k+(s<<4)>>3];l=+p[k+(s<<4)+8>>3];p[d+(t<<4)>>3]=m;p[d+(t<<4)+8>>3]=-l;p[d+(v<<4)>>3]=m;p[d+(v<<4)+8>>3]=l;s=s+1|0}while((s|0)!=(c|0))}w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;f[g+28>>2]=h;sC(g,d,d);p[d>>3]=j*+p[d>>3];if((h|0)>1){s=1;do{k=s<<1;l=j*+p[d+(k+2<<3)>>3];p[d+(s<<3)>>3]=j*+p[d+(k<<3)>>3];p[d+(s+1<<3)>>3]=l;s=s+2|0}while((s|0)<(h|0))}break a}s=(n|0)==(d|0);k=f[a+20>>2]|0;l=+p[n+8>>3];m=+p[n+(h+-1<<3)>>3];p[d>>3]=q+m;p[d+8>>3]=m-q;r=k+16|0;do if((c|0)>2){if(s){v=r;m=l;t=2;z=k;while(1){A=h-t|0;B=+p[d+(A+-1<<3)>>3];C=m+B;D=d+(t<<3)|0;E=+p[D>>3];F=d+(A<<3)|0;G=+p[F>>3];H=E-G;I=m-B;B=E+G;G=+p[v>>3];E=+p[z+24>>3];J=I*G+B*E;K=B*G-I*E;L=d+((t|1)<<3)|0;m=+p[L>>3];p[D>>3]=C-K;p[L>>3]=-H-J;p[F>>3]=C+K;p[d+(A+1<<3)>>3]=H-J;t=t+2|0;if((t|0)>=(c|0))break;else{A=v;v=v+16|0;z=A}}M=m;N=c+1&-2;break}z=f[a+16>>2]|0;v=r;J=l;t=2;A=k;while(1){F=h-t|0;H=+p[n+(F+-1<<3)>>3];K=J+H;C=+p[n+(t<<3)>>3];E=+p[n+(F<<3)>>3];I=C-E;G=J-H;H=C+E;E=+p[v>>3];C=+p[A+24>>3];B=G*E+H*C;O=H*E-G*C;J=+p[n+((t|1)<<3)>>3];F=t>>1;L=f[z+(F<<2)>>2]|0;p[d+(L<<3)>>3]=K-O;p[d+(L+1<<3)>>3]=-I-B;L=f[z+(c-F<<2)>>2]|0;p[d+(L<<3)>>3]=K+O;p[d+(L+1<<3)>>3]=I-B;t=t+2|0;if((t|0)>=(c|0))break;else{L=v;v=v+16|0;A=L}}M=J;N=c+1&-2}else{M=l;N=2}while(0);if((N|0)<=(c|0)){l=+p[n+(c<<3)>>3]*2.0;if(s)P=c;else P=f[(f[a+16>>2]|0)+(c<<2)>>2]<<1;p[d+(P<<3)>>3]=M*2.0;p[d+(P+1<<3)>>3]=l}k=a+4|0;r=f[k>>2]|0;A=f[r>>2]>>1;f[r>>2]=A;w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));r=(A|0)==1&1;v=g+4|0;f[v>>2]=(f[v>>2]|0)+(r<<2);f[g>>2]=(f[g>>2]|0)-r;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=(s^1)&1;p[g+8>>3]=1.0;f[g+28>>2]=c;sC(g,d,d);r=f[k>>2]|0;f[r>>2]=f[r>>2]<<1;if((h|0)>0){r=0;do{v=d+(r<<3)|0;t=d+((r|1)<<3)|0;l=-(j*+p[t>>3]);p[v>>3]=j*+p[v>>3];p[t>>3]=l;r=r+2|0}while((r|0)<(h|0))}}}while(0);if(!i){u=e;return}p[n>>3]=o;u=e;return}function sC(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;e=u;u=u+1168|0;g=e;h=f[a+20>>2]|0;i=f[a+16>>2]|0;j=a+28|0;k=f[j>>2]|0;l=(b[a+32>>0]|0)!=0;m=a+24|0;n=f[m>>2]|0;o=+p[a+8>>3];if((n|0)!=(k|0))if((n|0)==(k<<1|0))q=2;else q=(n|0)/(k|0)|0;else q=1;do if((d|0)==(c|0)){a:do if(!(b[a+33>>0]|0)){r=f[a+4>>2]|0;s=f[a>>2]|0;if((f[r>>2]|0)==(f[r+(s+-1<<2)>>2]|0))t=s;else{f[g>>2]=0;f[g+4>>2]=0;s=aD(g,33)|0;r=170171;v=s+33|0;do{b[s>>0]=b[r>>0]|0;s=s+1|0;r=r+1|0}while((s|0)<(v|0));bO(-215,g,170205,170209,657);bD(g);t=f[a>>2]|0}if((t|0)!=1){if((k|0)>0){w=0;x=i}else break;while(1){r=f[x>>2]|0;if((r|0)>(w|0)){s=d+(w<<4)|0;y=+p[s>>3];z=+p[d+(w<<4)+8>>3];v=d+(r<<4)|0;f[s>>2]=f[v>>2];f[s+4>>2]=f[v+4>>2];f[s+8>>2]=f[v+8>>2];f[s+12>>2]=f[v+12>>2];p[v>>3]=y;p[d+(r<<4)+8>>3]=z}w=w+1|0;if((w|0)==(k|0))break a;else x=x+(q<<2)|0}}if((k&3|0)==0?(r=(k|0)/2|0,v=d+(r<<4)|0,(k|0)>1):0){s=q<<1;A=0;B=i;while(1){C=f[B>>2]|0;D=A|1;E=d+(D<<4)|0;z=+p[E>>3];y=+p[d+(D<<4)+8>>3];F=v+(C<<4)|0;f[E>>2]=f[F>>2];f[E+4>>2]=f[F+4>>2];f[E+8>>2]=f[F+8>>2];f[E+12>>2]=f[F+12>>2];p[F>>3]=z;p[F+8>>3]=y;if((C|0)>(A|0)){F=d+(A<<4)|0;y=+p[F>>3];z=+p[d+(A<<4)+8>>3];E=d+(C<<4)|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];f[F+8>>2]=f[E+8>>2];f[F+12>>2]=f[E+12>>2];p[E>>3]=y;p[d+(C<<4)+8>>3]=z;E=v+(D<<4)|0;z=+p[E>>3];y=+p[E+8>>3];D=v+(C+1<<4)|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];f[E+8>>2]=f[D+8>>2];f[E+12>>2]=f[D+12>>2];p[D>>3]=z;p[D+8>>3]=y}A=A+2|0;if((A|0)>=(r|0))break;else B=B+(s<<2)|0}}}while(0);if(l){s=k+-2|0;if((k|0)<2)G=0;else{B=0;do{r=d+(B<<4)+8|0;A=d+((B|1)<<4)+8|0;y=-+p[A>>3];p[r>>3]=-+p[r>>3];p[A>>3]=y;B=B+2|0}while((B|0)<=(s|0));G=k&-2}s=d+(k+-1<<4)+8|0;if((G|0)<(k|0))p[s>>3]=-+p[s>>3]}}else{s=k+-2|0;B=(k|0)<2;if(l){if(B)H=0;else{A=q<<1;r=0;v=i;while(1){D=f[v>>2]|0;E=f[v+(q<<2)>>2]|0;y=-+p[c+(D<<4)+8>>3];p[d+(r<<4)>>3]=+p[c+(D<<4)>>3];p[d+(r<<4)+8>>3]=y;y=-+p[c+(E<<4)+8>>3];D=r|1;p[d+(D<<4)>>3]=+p[c+(E<<4)>>3];p[d+(D<<4)+8>>3]=y;r=r+2|0;if((r|0)>(s|0))break;else v=v+(A<<2)|0}H=k&-2}if((H|0)>=(k|0))break;A=k+-1|0;y=-+p[c+(A<<4)+8>>3];p[d+(H<<4)>>3]=+p[c+(A<<4)>>3];p[d+(H<<4)+8>>3]=y;break}else{if(B)I=0;else{A=q<<1;v=0;r=i;while(1){D=f[r+(q<<2)>>2]|0;E=c+(f[r>>2]<<4)|0;C=d+(v<<4)|0;f[C>>2]=f[E>>2];f[C+4>>2]=f[E+4>>2];f[C+8>>2]=f[E+8>>2];f[C+12>>2]=f[E+12>>2];E=c+(D<<4)|0;D=d+((v|1)<<4)|0;f[D>>2]=f[E>>2];f[D+4>>2]=f[E+4>>2];f[D+8>>2]=f[E+8>>2];f[D+12>>2]=f[E+12>>2];v=v+2|0;if((v|0)>(s|0))break;else r=r+(A<<2)|0}I=k&-2}A=k+-1|0;if((I|0)>=(k|0))break;r=c+(A<<4)|0;s=d+(A<<4)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];break}}while(0);c=a+4|0;k=f[c>>2]|0;I=f[k>>2]|0;q=I&1;if(!q){if((I|0)<4){J=1;K=n}else{i=f[j>>2]|0;H=(i|0)>0;G=1;x=n;w=4;while(1){t=(x|0)/4|0;if(H){r=G<<1;s=(G|0)>1;A=0;do{v=d+(A<<4)|0;B=v+(r<<4)|0;y=+p[B>>3];E=B+8|0;z=+p[E>>3];D=B+(G<<4)|0;L=+p[D>>3];C=D+8|0;M=+p[C>>3];N=y+L;O=z+M;P=z-M;M=L-y;y=+p[v>>3];F=d+(A<<4)+8|0;L=+p[F>>3];Q=v+(G<<4)|0;z=+p[Q>>3];R=Q+8|0;S=+p[R>>3];T=y+z;U=L+S;V=y-z;z=L-S;p[v>>3]=N+T;p[F>>3]=O+U;p[B>>3]=T-N;p[E>>3]=U-O;p[Q>>3]=P+V;p[R>>3]=M+z;p[D>>3]=V-P;p[C>>3]=z-M;if(s){C=t;D=1;while(1){R=v+(D<<4)|0;Q=R+(r<<4)|0;E=R+(G<<4)|0;M=+p[E>>3];B=C<<1;z=+p[h+(B<<4)>>3];F=E+8|0;P=+p[F>>3];V=+p[h+(B<<4)+8>>3];O=M*z-P*V;U=z*P+M*V;V=+p[Q>>3];M=+p[h+(C<<4)+8>>3];B=Q+8|0;P=+p[B>>3];z=+p[h+(C<<4)>>3];N=V*M+P*z;T=V*z-M*P;W=Q+(G<<4)|0;P=+p[W>>3];X=C*3|0;M=+p[h+(X<<4)+8>>3];Z=W+8|0;z=+p[Z>>3];V=+p[h+(X<<4)>>3];S=P*M+z*V;L=P*V-M*z;z=T+L;M=N+S;V=N-S;S=L-T;T=+p[R>>3];X=R+8|0;L=+p[X>>3];N=O+T;P=U+L;y=T-O;O=L-U;p[R>>3]=N+z;p[X>>3]=P+M;p[Q>>3]=N-z;p[B>>3]=P-M;p[E>>3]=y+V;p[F>>3]=O+S;p[W>>3]=y-V;p[Z>>3]=O-S;D=D+1|0;if((D|0)==(G|0))break;else C=C+t|0}}A=A+w|0}while((A|0)<(i|0))}A=w<<2;if((A|0)>(I|0)){J=w;K=t;break}else{r=w;x=t;w=A;G=r}}}if((J|0)<(I|0)){G=f[j>>2]|0;w=(G|0)>0;x=J;i=K;while(1){H=x<<1;r=(i|0)/2|0;b:do if(w){if((x|0)>1)_=0;else{A=0;while(1){s=d+(A<<4)|0;S=+p[s>>3];C=s+(x<<4)|0;O=+p[C>>3];D=d+(A<<4)+8|0;V=+p[D>>3];v=C+8|0;y=+p[v>>3];p[s>>3]=S+O;p[D>>3]=V+y;p[C>>3]=S-O;p[v>>3]=V-y;A=A+H|0;if((A|0)>=(G|0))break b}}do{A=d+(_<<4)|0;y=+p[A>>3];v=A+(x<<4)|0;V=+p[v>>3];C=d+(_<<4)+8|0;O=+p[C>>3];D=v+8|0;S=+p[D>>3];p[A>>3]=y+V;p[C>>3]=O+S;p[v>>3]=y-V;p[D>>3]=O-S;D=r;v=1;while(1){C=A+(v<<4)|0;s=C+(x<<4)|0;S=+p[s>>3];O=+p[h+(D<<4)>>3];Z=s+8|0;V=+p[Z>>3];y=+p[h+(D<<4)+8>>3];M=S*O-V*y;P=O*V+S*y;y=+p[C>>3];W=C+8|0;S=+p[W>>3];p[C>>3]=y+M;p[W>>3]=S+P;p[s>>3]=y-M;p[Z>>3]=S-P;v=v+1|0;if((v|0)==(x|0))break;else D=D+r|0}_=_+H|0}while((_|0)<(G|0))}while(0);if((H|0)<(I|0)){x=H;i=r}else{$=H;aa=r;break}}}else{$=J;aa=K}}else{$=1;aa=n}n=q^1;c:do if((n|0)<(f[a>>2]|0)){q=g+8|0;K=g+4|0;J=n;i=$;x=aa;I=k;while(1){G=f[I+(J<<2)>>2]|0;_=Y(G,i)|0;w=(x|0)/(G|0)|0;d:do switch(G|0){case 3:{t=f[j>>2]|0;if((t|0)>0){D=i<<1;if((i|0)>1)ba=0;else{v=0;while(1){A=d+(v<<4)|0;Z=A+(i<<4)|0;P=+p[Z>>3];s=A+(D<<4)|0;S=+p[s>>3];M=P+S;W=Z+8|0;y=+p[W>>3];C=s+8|0;V=+p[C>>3];O=y+V;z=+p[A>>3];F=d+(v<<4)+8|0;N=+p[F>>3];U=(y-V)*.8660254037844386;V=(S-P)*.8660254037844386;p[A>>3]=M+z;p[F>>3]=O+N;P=z-M*.5;M=N-O*.5;p[Z>>3]=P+U;p[W>>3]=V+M;p[s>>3]=P-U;p[C>>3]=M-V;v=v+_|0;if((v|0)>=(t|0))break d}}do{v=d+(ba<<4)|0;C=v+(i<<4)|0;V=+p[C>>3];s=v+(D<<4)|0;M=+p[s>>3];U=V+M;W=C+8|0;P=+p[W>>3];Z=s+8|0;O=+p[Z>>3];N=P+O;z=+p[v>>3];F=d+(ba<<4)+8|0;S=+p[F>>3];y=(P-O)*.8660254037844386;O=(M-V)*.8660254037844386;p[v>>3]=U+z;p[F>>3]=N+S;V=z-U*.5;U=S-N*.5;p[C>>3]=V+y;p[W>>3]=O+U;p[s>>3]=V-y;p[Z>>3]=U-O;Z=w;s=1;while(1){W=v+(s<<4)|0;C=W+(i<<4)|0;O=+p[C>>3];U=+p[h+(Z<<4)>>3];F=C+8|0;y=+p[F>>3];V=+p[h+(Z<<4)+8>>3];N=O*U-y*V;S=U*y+O*V;A=W+(D<<4)|0;V=+p[A>>3];E=Z<<1;O=+p[h+(E<<4)>>3];B=A+8|0;y=+p[B>>3];U=+p[h+(E<<4)+8>>3];z=V*O-y*U;M=O*y+V*U;U=N+z;V=S+M;y=(S-M)*.8660254037844386;M=(z-N)*.8660254037844386;N=+p[W>>3];E=W+8|0;z=+p[E>>3];p[W>>3]=N+U;p[E>>3]=z+V;S=N-U*.5;U=z-V*.5;p[C>>3]=y+S;p[F>>3]=M+U;p[A>>3]=S-y;p[B>>3]=U-M;s=s+1|0;if((s|0)==(i|0))break;else Z=Z+w|0}ba=ba+_|0}while((ba|0)<(t|0))}break}case 5:{t=f[j>>2]|0;if((t|0)>0){D=(i|0)>0;Z=i<<1;s=0;do{if(D){v=d+(s<<4)|0;B=0;A=0;while(1){F=v+(A<<4)|0;C=F+(Z<<4)|0;E=C+(Z<<4)|0;W=F+(i<<4)|0;M=+p[W>>3];U=+p[h+(B<<4)>>3];Q=W+8|0;y=+p[Q>>3];S=+p[h+(B<<4)+8>>3];V=M*U-y*S;z=U*y+M*S;S=+p[E>>3];X=B<<2;M=+p[h+(X<<4)>>3];R=E+8|0;y=+p[R>>3];U=+p[h+(X<<4)+8>>3];N=S*M-y*U;O=M*y+S*U;U=V+N;S=z+O;y=V-N;N=z-O;X=C+(i<<4)|0;O=+p[X>>3];ca=B*3|0;z=+p[h+(ca<<4)>>3];da=X+8|0;V=+p[da>>3];M=+p[h+(ca<<4)+8>>3];P=O*z-V*M;L=z*V+O*M;M=+p[C>>3];ca=B<<1;O=+p[h+(ca<<4)>>3];ea=C+8|0;V=+p[ea>>3];z=+p[h+(ca<<4)+8>>3];T=M*O-V*z;fa=O*V+M*z;z=P+T;M=L+fa;V=P-T;T=L-fa;fa=+p[F>>3];ca=F+8|0;L=+p[ca>>3];P=U+z;O=S+M;p[F>>3]=fa+P;p[ca>>3]=L+O;ga=fa-P*.25;P=L-O*.25;O=(U-z)*.5590169943749475;z=(S-M)*.5590169943749475;M=(N+T)*.9510565162951535;S=(y+V)*-.9510565162951535;U=M-N*.36327126400268045;N=y*.36327126400268045+S;y=M-T*1.5388417685876268;T=V*1.5388417685876268+S;S=O+ga;V=z+P;M=ga-O;O=P-z;p[W>>3]=y+S;p[Q>>3]=T+V;p[E>>3]=S-y;p[R>>3]=V-T;p[C>>3]=U+M;p[ea>>3]=N+O;p[X>>3]=M-U;p[da>>3]=O-N;A=A+1|0;if((A|0)==(i|0))break;else B=B+w|0}}s=s+_|0}while((s|0)<(t|0))}break}default:{t=G+-1|0;s=(t|0)/2|0;Z=(f[m>>2]|0)/(G|0)|0;D=s<<1;Nac(q|0,0,1152)|0;f[g>>2]=q;f[K>>2]=D;if(D>>>0>72){B=N5b(D>>>0>268435455?-1:D<<4)|0;Nac(B|0,0,s<<5|0)|0;f[g>>2]=B;ha=B}else ha=q;B=ha+(s<<4)|0;D=f[j>>2]|0;if((D|0)>0){A=(i|0)>0;v=(G|0)<3;da=(t|0)>1;t=0;X=D;while(1){if(A){D=d+(t<<4)|0;ea=0;C=0;while(1){R=D+(ea<<4)|0;N=+p[R>>3];E=R+8|0;O=+p[E>>3];if(!ea){if(!v){Q=i;W=1;U=N;M=O;while(1){ca=R+(Q<<4)|0;T=+p[ca>>3];F=R+(_-Q<<4)|0;V=+p[F>>3];y=T+V;S=+p[ca+8>>3];z=+p[F+8>>3];P=S+z;ga=U+y;L=M+P;F=W+-1|0;p[ha+(F<<4)>>3]=y;p[ha+(F<<4)+8>>3]=S-z;ca=B+(F<<4)|0;p[ca>>3]=T-V;p[ca+8>>3]=P;if((W|0)<(s|0)){Q=Q+i|0;W=W+1|0;U=ga;M=L}else{ia=ga;ja=L;ka=82;break}}}}else{W=h+((Y(C,G)|0)<<4)|0;if(!v){Q=C;ca=i;F=1;M=N;U=O;while(1){la=R+(ca<<4)|0;L=+p[la>>3];ga=+p[h+(Q<<4)>>3];P=+p[la+8>>3];V=+p[h+(Q<<4)+8>>3];T=L*ga-P*V;z=ga*P+L*V;la=R+(_-ca<<4)|0;V=+p[la>>3];ma=W+(0-Q<<4)|0;L=+p[ma>>3];P=+p[la+8>>3];ga=+p[ma+8>>3];S=V*L-P*ga;y=L*P+V*ga;ga=T+S;V=z+y;P=M+ga;L=U+V;ma=F+-1|0;p[ha+(ma<<4)>>3]=ga;p[ha+(ma<<4)+8>>3]=z-y;la=B+(ma<<4)|0;p[la>>3]=T-S;p[la+8>>3]=V;if((F|0)<(s|0)){Q=Q+C|0;ca=ca+i|0;F=F+1|0;M=P;U=L}else{ia=P;ja=L;ka=82;break}}}}e:do if((ka|0)==82?(ka=0,p[R>>3]=ia,p[E>>3]=ja,!v):0){if(da){na=i;oa=1}else{F=i;ca=1;while(1){Q=R+(F<<4)|0;p[Q>>3]=N;p[Q+8>>3]=O;Q=R+(_-F<<4)|0;p[Q>>3]=N;p[Q+8>>3]=O;if((ca|0)<(s|0)){F=F+i|0;ca=ca+1|0}else break e}}while(1){ca=Y(oa,Z)|0;F=f[m>>2]|0;Q=0;W=ca;U=N;M=N;L=O;P=O;while(1){V=+p[h+(W<<4)>>3];S=V*+p[ha+(Q<<4)>>3];T=+p[h+(W<<4)+8>>3];y=T*+p[ha+(Q<<4)+8>>3];la=B+(Q<<4)|0;z=V*+p[la+8>>3];V=T*+p[la>>3];U=U+(S+y);M=M+(S-y);L=L+(z-V);P=P+(z+V);la=W+ca|0;Q=Q+1|0;if((Q|0)>=(s|0))break;else W=la-((la|0)>=(F|0)?F:0)|0}F=R+(na<<4)|0;p[F>>3]=M;p[F+8>>3]=P;F=R+(_-na<<4)|0;p[F>>3]=U;p[F+8>>3]=L;if((oa|0)<(s|0)){na=na+i|0;oa=oa+1|0}else break}}while(0);ea=ea+1|0;if((ea|0)==(i|0))break;else C=C+w|0}pa=f[j>>2]|0}else pa=X;t=t+_|0;if((t|0)>=(pa|0))break;else X=pa}}if((ha|0)!=(q|0)){P5b(ha);f[g>>2]=q;f[K>>2]=72}}}while(0);G=J+1|0;if((G|0)>=(f[a>>2]|0))break c;J=G;i=_;x=w;I=f[c>>2]|0}}while(0);if(o!=1.0){ja=l?-o:o;c=f[j>>2]|0;if((c|0)>0)qa=0;else{u=e;return}do{a=d+(qa<<4)|0;g=d+(qa<<4)+8|0;ia=ja*+p[g>>3];p[a>>3]=o*+p[a>>3];p[g>>3]=ia;qa=qa+1|0}while((qa|0)<(c|0));u=e;return}if(!l){u=e;return}l=f[j>>2]|0;if((l|0)<2)ra=0;else{j=l+-2|0;c=((j|0)>1?j:1)&2147483646;qa=0;do{g=d+(qa<<4)+8|0;a=d+((qa|1)<<4)+8|0;o=-+p[a>>3];p[g>>3]=-+p[g>>3];p[a>>3]=o;qa=qa+2|0}while((qa|0)<=(j|0));ra=c+2|0}c=d+(l+-1<<4)+8|0;if((ra|0)>=(l|0)){u=e;return}p[c>>3]=-+p[c>>3];u=e;return}function tC(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=b[a+34>>0]|0;j=i<<24>>24!=0;k=i&255;l=+p[a+8>>3];i=d+(k<<3)|0;d=(h|0)==1;do if(d){p[i>>3]=l*+p[c>>3];m=i}else{if((h|0)==2){n=+p[c>>3];o=+p[c+8>>3];p[i+8>>3]=l*(n-o);p[i>>3]=l*(n+o);m=i;break}if(h&1|0){q=i+(0-k<<3)|0;p[q>>3]=l*+p[c>>3];r=q+8|0;p[r>>3]=0.0;if((h|0)>1){s=f[a+16>>2]|0;t=1;do{v=t+1|0;o=l*+p[c+(f[s+(v<<2)>>2]<<3)>>3];p[q+(t<<4)>>3]=l*+p[c+(f[s+(t<<2)>>2]<<3)>>3];p[q+(t<<4)+8>>3]=0.0;p[q+(v<<4)>>3]=o;p[q+(v<<4)+8>>3]=0.0;t=t+2|0}while((t|0)<(h|0))}w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;sC(g,q,q);if(!j)p[r>>3]=+p[q>>3];m=q;break}o=l*.5;t=h>>1;s=a+4|0;v=f[s>>2]|0;z=f[v>>2]>>1;f[v>>2]=z;w=g;x=a;y=w+48|0;do{f[w>>2]=f[x>>2];w=w+4|0;x=x+4|0}while((w|0)<(y|0));q=(z|0)==1&1;r=g+4|0;f[r>>2]=(f[r>>2]|0)+(q<<2);f[g>>2]=(f[g>>2]|0)-q;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=0;p[g+8>>3]=1.0;f[g+28>>2]=t;sC(g,c,i);q=f[s>>2]|0;f[q>>2]=f[q>>2]<<1;n=+p[i>>3];q=i+8|0;A=+p[q>>3];p[i>>3]=l*(n+A);B=l*(n-A);p[q>>3]=B;q=i+(t<<3)|0;A=+p[q>>3];r=i+(h+-1<<3)|0;n=+p[r>>3];p[r>>3]=B;if((t|0)>2){B=n;r=f[a+20>>2]|0;v=2;do{C=r;r=r+16|0;D=+p[i+((v|1)<<3)>>3];E=o*(B+D);F=h-v|0;G=i+(F<<3)|0;H=+p[G>>3];I=i+(v<<3)|0;J=+p[I>>3];K=o*(H-J);L=o*(H+J);J=o*(D-B);D=+p[r>>3];H=+p[C+24>>3];M=E*D-K*H;N=E*H+D*K;C=i+(F+-1<<3)|0;B=+p[C>>3];p[i+(v+-1<<3)>>3]=L+M;p[C>>3]=L-M;p[I>>3]=J+N;p[G>>3]=N-J;v=v+2|0}while((v|0)<(t|0));O=B;P=t+1&-2}else{O=n;P=2}if((P|0)<=(t|0)){p[i+(t+-1<<3)>>3]=l*A;p[q>>3]=-(l*O)}m=i}while(0);if(!j){u=e;return}if(!(d|(h&1|0)==0)){u=e;return}p[m+-8>>3]=+p[m>>3];p[m>>3]=0.0;if((h|0)<=1){u=e;return}p[m+(h<<3)>>3]=0.0;u=e;return}function uC(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0,o=0,q=0.0,r=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0.0,P=0,Q=0.0,R=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=(b[a+34>>0]|0)!=0;j=+p[a+8>>3];if(i){k=c+4|0;l=+n[k>>2];m=f[c>>2]|0;f[k>>2]=m;o=k;q=l;r=(f[s>>2]=m,+n[s>>2])}else{o=c;q=0.0;r=+n[c>>2]}a:do switch(h|0){case 1:{n[d>>2]=j*r;break}case 2:{l=+n[o+4>>2];n[d+4>>2]=j*(r-l);n[d>>2]=j*(r+l);break}default:{c=h+1>>1;if(h&1|0){m=o+-4|0;n[d>>2]=r;n[d+4>>2]=0.0;if((c|0)>1){k=f[a+16>>2]|0;t=1;do{v=f[k+(t<<2)>>2]|0;w=f[k+(h-t<<2)>>2]|0;x=f[m+(t<<3)>>2]|0;l=+n[m+(t<<3)+4>>2];f[d+(v<<3)>>2]=x;n[d+(v<<3)+4>>2]=-l;f[d+(w<<3)>>2]=x;n[d+(w<<3)+4>>2]=l;t=t+1|0}while((t|0)!=(c|0))}y=g;z=a;A=y+48|0;do{f[y>>2]=f[z>>2];y=y+4|0;z=z+4|0}while((y|0)<(A|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;f[g+28>>2]=h;vC(g,d,d);n[d>>2]=j*+n[d>>2];if((h|0)>1){t=1;do{m=t<<1;l=j*+n[d+(m+2<<2)>>2];n[d+(t<<2)>>2]=j*+n[d+(m<<2)>>2];n[d+(t+1<<2)>>2]=l;t=t+2|0}while((t|0)<(h|0))}break a}t=(o|0)==(d|0);m=f[a+20>>2]|0;l=+n[o+4>>2];B=+n[o+(h+-1<<2)>>2];n[d>>2]=r+B;n[d+4>>2]=B-r;k=m+8|0;do if((c|0)>2){if(t){w=k;B=l;x=2;v=m;while(1){C=h-x|0;D=+n[d+(C+-1<<2)>>2];E=B+D;F=d+(x<<2)|0;G=+n[F>>2];H=d+(C<<2)|0;I=+n[H>>2];J=G-I;K=B-D;D=G+I;I=+n[w>>2];G=+n[v+12>>2];L=K*I+D*G;M=D*I-K*G;N=d+((x|1)<<2)|0;B=+n[N>>2];n[F>>2]=E-M;n[N>>2]=-J-L;n[H>>2]=E+M;n[d+(C+1<<2)>>2]=J-L;x=x+2|0;if((x|0)>=(c|0))break;else{C=w;w=w+8|0;v=C}}O=B;P=c+1&-2;break}v=f[a+16>>2]|0;w=k;L=l;x=2;C=m;while(1){H=h-x|0;J=+n[o+(H+-1<<2)>>2];M=L+J;E=+n[o+(x<<2)>>2];G=+n[o+(H<<2)>>2];K=E-G;I=L-J;J=E+G;G=+n[w>>2];E=+n[C+12>>2];D=I*G+J*E;Q=J*G-I*E;L=+n[o+((x|1)<<2)>>2];H=x>>1;N=f[v+(H<<2)>>2]|0;n[d+(N<<2)>>2]=M-Q;n[d+(N+1<<2)>>2]=-K-D;N=f[v+(c-H<<2)>>2]|0;n[d+(N<<2)>>2]=M+Q;n[d+(N+1<<2)>>2]=K-D;x=x+2|0;if((x|0)>=(c|0))break;else{N=w;w=w+8|0;C=N}}O=L;P=c+1&-2}else{O=l;P=2}while(0);if((P|0)<=(c|0)){l=+n[o+(c<<2)>>2]*2.0;if(t)R=c;else R=f[(f[a+16>>2]|0)+(c<<2)>>2]<<1;n[d+(R<<2)>>2]=O*2.0;n[d+(R+1<<2)>>2]=l}m=a+4|0;k=f[m>>2]|0;C=f[k>>2]>>1;f[k>>2]=C;y=g;z=a;A=y+48|0;do{f[y>>2]=f[z>>2];y=y+4|0;z=z+4|0}while((y|0)<(A|0));k=(C|0)==1&1;w=g+4|0;f[w>>2]=(f[w>>2]|0)+(k<<2);f[g>>2]=(f[g>>2]|0)-k;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=(t^1)&1;p[g+8>>3]=1.0;f[g+28>>2]=c;vC(g,d,d);k=f[m>>2]|0;f[k>>2]=f[k>>2]<<1;if((h|0)>0){k=0;do{w=d+(k<<2)|0;x=d+((k|1)<<2)|0;l=-(j*+n[x>>2]);n[w>>2]=j*+n[w>>2];n[x>>2]=l;k=k+2|0}while((k|0)<(h|0))}}}while(0);if(!i){u=e;return}n[o>>2]=q;u=e;return}function vC(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;e=u;u=u+1104|0;g=e;h=f[a+20>>2]|0;i=f[a+16>>2]|0;j=a+28|0;k=f[j>>2]|0;l=(b[a+32>>0]|0)!=0;m=a+24|0;o=f[m>>2]|0;q=+p[a+8>>3];if((o|0)!=(k|0))if((o|0)==(k<<1|0))r=2;else r=(o|0)/(k|0)|0;else r=1;do if((d|0)==(c|0)){a:do if(!(b[a+33>>0]|0)){s=f[a+4>>2]|0;t=f[a>>2]|0;if((f[s>>2]|0)==(f[s+(t+-1<<2)>>2]|0))v=t;else{f[g>>2]=0;f[g+4>>2]=0;t=aD(g,33)|0;s=170171;w=t+33|0;do{b[t>>0]=b[s>>0]|0;t=t+1|0;s=s+1|0}while((t|0)<(w|0));bO(-215,g,170205,170209,657);bD(g);v=f[a>>2]|0}if((v|0)!=1){if((k|0)>0){x=0;y=i}else break;while(1){s=f[y>>2]|0;if((s|0)>(x|0)){t=d+(x<<3)|0;w=f[t>>2]|0;z=f[d+(x<<3)+4>>2]|0;A=d+(s<<3)|0;B=A;C=f[B+4>>2]|0;D=t;f[D>>2]=f[B>>2];f[D+4>>2]=C;f[A>>2]=w;f[d+(s<<3)+4>>2]=z}x=x+1|0;if((x|0)==(k|0))break a;else y=y+(r<<2)|0}}if((k&3|0)==0?(z=(k|0)/2|0,s=d+(z<<3)|0,(k|0)>1):0){w=r<<1;A=0;C=i;while(1){D=f[C>>2]|0;B=A|1;t=d+(B<<3)|0;E=f[t>>2]|0;F=f[d+(B<<3)+4>>2]|0;G=s+(D<<3)|0;H=G;I=f[H+4>>2]|0;J=t;f[J>>2]=f[H>>2];f[J+4>>2]=I;f[G>>2]=E;f[G+4>>2]=F;if((D|0)>(A|0)){F=d+(A<<3)|0;G=f[F>>2]|0;E=f[d+(A<<3)+4>>2]|0;I=d+(D<<3)|0;J=I;H=f[J+4>>2]|0;t=F;f[t>>2]=f[J>>2];f[t+4>>2]=H;f[I>>2]=G;f[d+(D<<3)+4>>2]=E;E=s+(B<<3)|0;B=f[E>>2]|0;G=f[E+4>>2]|0;I=s+(D+1<<3)|0;D=I;H=f[D+4>>2]|0;t=E;f[t>>2]=f[D>>2];f[t+4>>2]=H;f[I>>2]=B;f[I+4>>2]=G}A=A+2|0;if((A|0)>=(z|0))break;else C=C+(w<<2)|0}}}while(0);if(l){w=k+-2|0;if((k|0)<2)K=0;else{C=0;do{z=d+(C<<3)+4|0;A=d+((C|1)<<3)+4|0;L=-+n[A>>2];n[z>>2]=-+n[z>>2];n[A>>2]=L;C=C+2|0}while((C|0)<=(w|0));K=k&-2}w=d+(k+-1<<3)+4|0;if((K|0)<(k|0))n[w>>2]=-+n[w>>2]}}else{w=k+-2|0;C=(k|0)<2;if(l){if(C)M=0;else{A=r<<1;z=0;s=i;while(1){G=f[s>>2]|0;I=f[s+(r<<2)>>2]|0;L=-+n[c+(G<<3)+4>>2];f[d+(z<<3)>>2]=f[c+(G<<3)>>2];n[d+(z<<3)+4>>2]=L;L=-+n[c+(I<<3)+4>>2];G=z|1;f[d+(G<<3)>>2]=f[c+(I<<3)>>2];n[d+(G<<3)+4>>2]=L;z=z+2|0;if((z|0)>(w|0))break;else s=s+(A<<2)|0}M=k&-2}if((M|0)>=(k|0))break;A=k+-1|0;L=-+n[c+(A<<3)+4>>2];f[d+(M<<3)>>2]=f[c+(A<<3)>>2];n[d+(M<<3)+4>>2]=L;break}else{if(C)N=0;else{A=r<<1;s=0;z=i;while(1){G=f[z+(r<<2)>>2]|0;I=c+(f[z>>2]<<3)|0;B=f[I+4>>2]|0;H=d+(s<<3)|0;f[H>>2]=f[I>>2];f[H+4>>2]=B;B=c+(G<<3)|0;G=f[B+4>>2]|0;H=d+((s|1)<<3)|0;f[H>>2]=f[B>>2];f[H+4>>2]=G;s=s+2|0;if((s|0)>(w|0))break;else z=z+(A<<2)|0}N=k&-2}A=k+-1|0;if((N|0)>=(k|0))break;z=c+(A<<3)|0;w=f[z+4>>2]|0;s=d+(A<<3)|0;f[s>>2]=f[z>>2];f[s+4>>2]=w;break}}while(0);c=a+4|0;k=f[c>>2]|0;N=f[k>>2]|0;r=N&1;if(!r){if((N|0)<4){O=1;P=o}else{i=f[j>>2]|0;M=(i|0)>0;K=1;y=o;x=4;while(1){v=(y|0)/4|0;if(M){w=K<<1;s=(K|0)>1;z=0;do{A=d+(z<<3)|0;C=A+(w<<3)|0;L=+n[C>>2];G=C+4|0;Q=+n[G>>2];H=C+(K<<3)|0;R=+n[H>>2];B=H+4|0;S=+n[B>>2];T=L+R;U=Q+S;V=Q-S;S=R-L;L=+n[A>>2];I=d+(z<<3)+4|0;R=+n[I>>2];t=A+(K<<3)|0;Q=+n[t>>2];D=t+4|0;W=+n[D>>2];X=L+Q;Z=R+W;_=L-Q;Q=R-W;n[A>>2]=T+X;n[I>>2]=U+Z;n[C>>2]=X-T;n[G>>2]=Z-U;n[t>>2]=V+_;n[D>>2]=S+Q;n[H>>2]=_-V;n[B>>2]=Q-S;if(s){B=v;H=1;while(1){D=A+(H<<3)|0;t=D+(w<<3)|0;G=D+(K<<3)|0;S=+n[G>>2];C=B<<1;Q=+n[h+(C<<3)>>2];I=G+4|0;V=+n[I>>2];_=+n[h+(C<<3)+4>>2];U=S*Q-V*_;Z=Q*V+S*_;_=+n[t>>2];S=+n[h+(B<<3)+4>>2];C=t+4|0;V=+n[C>>2];Q=+n[h+(B<<3)>>2];T=_*S+V*Q;X=_*Q-S*V;E=t+(K<<3)|0;V=+n[E>>2];J=B*3|0;S=+n[h+(J<<3)+4>>2];F=E+4|0;Q=+n[F>>2];_=+n[h+(J<<3)>>2];W=V*S+Q*_;R=V*_-S*Q;Q=X+R;S=T+W;_=T-W;W=R-X;X=+n[D>>2];J=D+4|0;R=+n[J>>2];T=U+X;V=Z+R;L=X-U;U=R-Z;n[D>>2]=T+Q;n[J>>2]=V+S;n[t>>2]=T-Q;n[C>>2]=V-S;n[G>>2]=L+_;n[I>>2]=U+W;n[E>>2]=L-_;n[F>>2]=U-W;H=H+1|0;if((H|0)==(K|0))break;else B=B+v|0}}z=z+x|0}while((z|0)<(i|0))}z=x<<2;if((z|0)>(N|0)){O=x;P=v;break}else{w=x;y=v;x=z;K=w}}}if((O|0)<(N|0)){K=f[j>>2]|0;x=(K|0)>0;y=O;i=P;while(1){M=y<<1;w=(i|0)/2|0;b:do if(x){if((y|0)>1)$=0;else{z=0;while(1){s=d+(z<<3)|0;W=+n[s>>2];B=s+(y<<3)|0;U=+n[B>>2];H=d+(z<<3)+4|0;_=+n[H>>2];A=B+4|0;L=+n[A>>2];n[s>>2]=W+U;n[H>>2]=_+L;n[B>>2]=W-U;n[A>>2]=_-L;z=z+M|0;if((z|0)>=(K|0))break b}}do{z=d+($<<3)|0;L=+n[z>>2];A=z+(y<<3)|0;_=+n[A>>2];B=d+($<<3)+4|0;U=+n[B>>2];H=A+4|0;W=+n[H>>2];n[z>>2]=L+_;n[B>>2]=U+W;n[A>>2]=L-_;n[H>>2]=U-W;H=w;A=1;while(1){B=z+(A<<3)|0;s=B+(y<<3)|0;W=+n[s>>2];U=+n[h+(H<<3)>>2];F=s+4|0;_=+n[F>>2];L=+n[h+(H<<3)+4>>2];S=W*U-_*L;V=U*_+W*L;L=+n[B>>2];E=B+4|0;W=+n[E>>2];n[B>>2]=L+S;n[E>>2]=W+V;n[s>>2]=L-S;n[F>>2]=W-V;A=A+1|0;if((A|0)==(y|0))break;else H=H+w|0}$=$+M|0}while(($|0)<(K|0))}while(0);if((M|0)<(N|0)){y=M;i=w}else{aa=M;ba=w;break}}}else{aa=O;ba=P}}else{aa=1;ba=o}o=r^1;c:do if((o|0)<(f[a>>2]|0)){r=g+8|0;P=g+4|0;O=o;i=aa;y=ba;N=k;while(1){K=f[N+(O<<2)>>2]|0;$=Y(K,i)|0;x=(y|0)/(K|0)|0;d:do switch(K|0){case 3:{v=f[j>>2]|0;if((v|0)>0){H=i<<1;if((i|0)>1)ca=0;else{A=0;while(1){z=d+(A<<3)|0;F=z+(i<<3)|0;V=+n[F>>2];s=z+(H<<3)|0;W=+n[s>>2];S=V+W;E=F+4|0;L=+n[E>>2];B=s+4|0;_=+n[B>>2];U=L+_;Q=+n[z>>2];I=d+(A<<3)+4|0;T=+n[I>>2];Z=(L-_)*.8660253882408142;_=(W-V)*.8660253882408142;n[z>>2]=S+Q;n[I>>2]=U+T;V=Q-S*.5;S=T-U*.5;n[F>>2]=V+Z;n[E>>2]=_+S;n[s>>2]=V-Z;n[B>>2]=S-_;A=A+$|0;if((A|0)>=(v|0))break d}}do{A=d+(ca<<3)|0;B=A+(i<<3)|0;_=+n[B>>2];s=A+(H<<3)|0;S=+n[s>>2];Z=_+S;E=B+4|0;V=+n[E>>2];F=s+4|0;U=+n[F>>2];T=V+U;Q=+n[A>>2];I=d+(ca<<3)+4|0;W=+n[I>>2];L=(V-U)*.8660253882408142;U=(S-_)*.8660253882408142;n[A>>2]=Z+Q;n[I>>2]=T+W;_=Q-Z*.5;Z=W-T*.5;n[B>>2]=_+L;n[E>>2]=U+Z;n[s>>2]=_-L;n[F>>2]=Z-U;F=x;s=1;while(1){E=A+(s<<3)|0;B=E+(i<<3)|0;U=+n[B>>2];Z=+n[h+(F<<3)>>2];I=B+4|0;L=+n[I>>2];_=+n[h+(F<<3)+4>>2];T=U*Z-L*_;W=Z*L+U*_;z=E+(H<<3)|0;_=+n[z>>2];G=F<<1;U=+n[h+(G<<3)>>2];C=z+4|0;L=+n[C>>2];Z=+n[h+(G<<3)+4>>2];Q=_*U-L*Z;S=U*L+_*Z;Z=T+Q;_=W+S;L=(W-S)*.8660253882408142;S=(Q-T)*.8660253882408142;T=+n[E>>2];G=E+4|0;Q=+n[G>>2];n[E>>2]=T+Z;n[G>>2]=Q+_;W=T-Z*.5;Z=Q-_*.5;n[B>>2]=L+W;n[I>>2]=S+Z;n[z>>2]=W-L;n[C>>2]=Z-S;s=s+1|0;if((s|0)==(i|0))break;else F=F+x|0}ca=ca+$|0}while((ca|0)<(v|0))}break}case 5:{v=f[j>>2]|0;if((v|0)>0){H=(i|0)>0;F=i<<1;s=0;do{if(H){A=d+(s<<3)|0;C=0;z=0;while(1){I=A+(z<<3)|0;B=I+(F<<3)|0;G=B+(F<<3)|0;E=I+(i<<3)|0;S=+n[E>>2];Z=+n[h+(C<<3)>>2];t=E+4|0;L=+n[t>>2];W=+n[h+(C<<3)+4>>2];_=S*Z-L*W;Q=Z*L+S*W;W=+n[G>>2];J=C<<2;S=+n[h+(J<<3)>>2];D=G+4|0;L=+n[D>>2];Z=+n[h+(J<<3)+4>>2];T=W*S-L*Z;U=S*L+W*Z;Z=_+T;W=Q+U;L=_-T;T=Q-U;J=B+(i<<3)|0;U=+n[J>>2];da=C*3|0;Q=+n[h+(da<<3)>>2];ea=J+4|0;_=+n[ea>>2];S=+n[h+(da<<3)+4>>2];V=U*Q-_*S;R=Q*_+U*S;S=+n[B>>2];da=C<<1;U=+n[h+(da<<3)>>2];fa=B+4|0;_=+n[fa>>2];Q=+n[h+(da<<3)+4>>2];X=S*U-_*Q;ga=U*_+S*Q;Q=V+X;S=R+ga;_=V-X;X=R-ga;ga=+n[I>>2];da=I+4|0;R=+n[da>>2];V=Z+Q;U=W+S;n[I>>2]=ga+V;n[da>>2]=R+U;ha=ga-V*.25;V=R-U*.25;U=(Z-Q)*.55901700258255;Q=(W-S)*.55901700258255;S=(T+X)*.9510565400123596;W=(L+_)*-.9510565400123596;Z=S-T*.3632712662220001;T=L*.3632712662220001+W;L=S-X*1.538841724395752;X=_*1.538841724395752+W;W=U+ha;_=Q+V;S=ha-U;U=V-Q;n[E>>2]=L+W;n[t>>2]=X+_;n[G>>2]=W-L;n[D>>2]=_-X;n[B>>2]=Z+S;n[fa>>2]=T+U;n[J>>2]=S-Z;n[ea>>2]=U-T;z=z+1|0;if((z|0)==(i|0))break;else C=C+x|0}}s=s+$|0}while((s|0)<(v|0))}break}default:{v=K+-1|0;s=(v|0)/2|0;F=(f[m>>2]|0)/(K|0)|0;H=s<<1;Nac(r|0,0,1088)|0;f[g>>2]=r;f[P>>2]=H;if(H>>>0>136){C=N5b(H>>>0>536870911?-1:H<<3)|0;Nac(C|0,0,s<<4|0)|0;f[g>>2]=C;ia=C}else ia=r;C=ia+(s<<3)|0;H=f[j>>2]|0;if((H|0)>0){z=(i|0)>0;A=(K|0)<3;ea=(v|0)>1;v=0;J=H;while(1){if(z){H=d+(v<<3)|0;fa=0;B=0;while(1){D=H+(fa<<3)|0;T=+n[D>>2];G=D+4|0;U=+n[G>>2];if(!fa){if(!A){t=i;E=1;Z=T;S=U;while(1){da=D+(t<<3)|0;X=+n[da>>2];I=D+($-t<<3)|0;_=+n[I>>2];L=X+_;W=+n[da+4>>2];Q=+n[I+4>>2];V=W+Q;ha=Z+L;R=S+V;I=E+-1|0;n[ia+(I<<3)>>2]=L;n[ia+(I<<3)+4>>2]=W-Q;da=C+(I<<3)|0;n[da>>2]=X-_;n[da+4>>2]=V;if((E|0)<(s|0)){t=t+i|0;E=E+1|0;Z=ha;S=R}else{ja=ha;ka=R;la=82;break}}}}else{E=h+((Y(B,K)|0)<<3)|0;if(!A){t=B;da=i;I=1;S=T;Z=U;while(1){ma=D+(da<<3)|0;R=+n[ma>>2];ha=+n[h+(t<<3)>>2];V=+n[ma+4>>2];_=+n[h+(t<<3)+4>>2];X=R*ha-V*_;Q=ha*V+R*_;ma=D+($-da<<3)|0;_=+n[ma>>2];na=E+(0-t<<3)|0;R=+n[na>>2];V=+n[ma+4>>2];ha=+n[na+4>>2];W=_*R-V*ha;L=R*V+_*ha;ha=X+W;_=Q+L;V=S+ha;R=Z+_;na=I+-1|0;n[ia+(na<<3)>>2]=ha;n[ia+(na<<3)+4>>2]=Q-L;ma=C+(na<<3)|0;n[ma>>2]=X-W;n[ma+4>>2]=_;if((I|0)<(s|0)){t=t+B|0;da=da+i|0;I=I+1|0;S=V;Z=R}else{ja=V;ka=R;la=82;break}}}}e:do if((la|0)==82?(la=0,n[D>>2]=ja,n[G>>2]=ka,!A):0){if(ea){oa=i;pa=1}else{I=i;da=1;while(1){t=D+(I<<3)|0;n[t>>2]=T;n[t+4>>2]=U;t=D+($-I<<3)|0;n[t>>2]=T;n[t+4>>2]=U;if((da|0)<(s|0)){I=I+i|0;da=da+1|0}else break e}}while(1){da=Y(pa,F)|0;I=f[m>>2]|0;t=0;E=da;Z=T;S=T;R=U;V=U;while(1){_=+n[h+(E<<3)>>2];W=_*+n[ia+(t<<3)>>2];X=+n[h+(E<<3)+4>>2];L=X*+n[ia+(t<<3)+4>>2];ma=C+(t<<3)|0;Q=_*+n[ma+4>>2];_=X*+n[ma>>2];Z=Z+(W+L);S=S+(W-L);R=R+(Q-_);V=V+(Q+_);ma=E+da|0;t=t+1|0;if((t|0)>=(s|0))break;else E=ma-((ma|0)>=(I|0)?I:0)|0}I=D+(oa<<3)|0;n[I>>2]=S;n[I+4>>2]=V;I=D+($-oa<<3)|0;n[I>>2]=Z;n[I+4>>2]=R;if((pa|0)<(s|0)){oa=oa+i|0;pa=pa+1|0}else break}}while(0);fa=fa+1|0;if((fa|0)==(i|0))break;else B=B+x|0}qa=f[j>>2]|0}else qa=J;v=v+$|0;if((v|0)>=(qa|0))break;else J=qa}}if((ia|0)!=(r|0)){P5b(ia);f[g>>2]=r;f[P>>2]=136}}}while(0);K=O+1|0;if((K|0)>=(f[a>>2]|0))break c;O=K;i=$;y=x;N=f[c>>2]|0}}while(0);if(q!=1.0){ka=l?-q:q;c=f[j>>2]|0;if((c|0)>0)ra=0;else{u=e;return}do{a=d+(ra<<3)|0;g=d+(ra<<3)+4|0;ja=ka*+n[g>>2];n[a>>2]=q*+n[a>>2];n[g>>2]=ja;ra=ra+1|0}while((ra|0)<(c|0));u=e;return}if(!l){u=e;return}l=f[j>>2]|0;if((l|0)<2)sa=0;else{j=l+-2|0;c=((j|0)>1?j:1)&2147483646;ra=0;do{g=d+(ra<<3)+4|0;a=d+((ra|1)<<3)+4|0;q=-+n[a>>2];n[g>>2]=-+n[g>>2];n[a>>2]=q;ra=ra+2|0}while((ra|0)<=(j|0));sa=c+2|0}c=d+(l+-1<<3)+4|0;if((sa|0)>=(l|0)){u=e;return}n[c>>2]=-+n[c>>2];u=e;return}function wC(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0.0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0,H=0,I=0.0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0;e=u;u=u+48|0;g=e;h=f[a+28>>2]|0;i=b[a+34>>0]|0;j=i<<24>>24!=0;k=i&255;l=+p[a+8>>3];i=d+(k<<2)|0;d=(h|0)==1;do if(d){n[i>>2]=l*+n[c>>2];m=i}else{if((h|0)==2){o=+n[c>>2];q=+n[c+4>>2];n[i+4>>2]=l*(o-q);n[i>>2]=l*(o+q);m=i;break}if(h&1|0){r=i+(0-k<<2)|0;n[r>>2]=l*+n[c>>2];s=r+4|0;n[s>>2]=0.0;if((h|0)>1){t=f[a+16>>2]|0;v=1;do{w=v+1|0;q=l*+n[c+(f[t+(w<<2)>>2]<<2)>>2];n[r+(v<<3)>>2]=l*+n[c+(f[t+(v<<2)>>2]<<2)>>2];n[r+(v<<3)+4>>2]=0.0;n[r+(w<<3)>>2]=q;n[r+(w<<3)+4>>2]=0.0;v=v+2|0}while((v|0)<(h|0))}x=g;y=a;z=x+48|0;do{f[x>>2]=f[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=1;p[g+8>>3]=1.0;vC(g,r,r);if(!j)f[s>>2]=f[r>>2];m=r;break}q=l*.5;v=h>>1;t=a+4|0;w=f[t>>2]|0;A=f[w>>2]>>1;f[w>>2]=A;x=g;y=a;z=x+48|0;do{f[x>>2]=f[y>>2];x=x+4|0;y=y+4|0}while((x|0)<(z|0));r=(A|0)==1&1;s=g+4|0;f[s>>2]=(f[s>>2]|0)+(r<<2);f[g>>2]=(f[g>>2]|0)-r;b[g+34>>0]=0;b[g+32>>0]=0;b[g+33>>0]=0;p[g+8>>3]=1.0;f[g+28>>2]=v;vC(g,c,i);r=f[t>>2]|0;f[r>>2]=f[r>>2]<<1;o=+n[i>>2];r=i+4|0;B=+n[r>>2];n[i>>2]=l*(o+B);C=l*(o-B);n[r>>2]=C;r=i+(v<<2)|0;B=+n[r>>2];s=i+(h+-1<<2)|0;o=+n[s>>2];n[s>>2]=C;if((v|0)>2){C=o;s=f[a+20>>2]|0;w=2;do{D=s;s=s+8|0;E=+n[i+((w|1)<<2)>>2];F=q*(C+E);G=h-w|0;H=i+(G<<2)|0;I=+n[H>>2];J=i+(w<<2)|0;K=+n[J>>2];L=q*(I-K);M=q*(I+K);K=q*(E-C);E=+n[s>>2];I=+n[D+12>>2];N=F*E-L*I;O=F*I+E*L;D=i+(G+-1<<2)|0;C=+n[D>>2];n[i+(w+-1<<2)>>2]=M+N;n[D>>2]=M-N;n[J>>2]=K+O;n[H>>2]=O-K;w=w+2|0}while((w|0)<(v|0));P=C;Q=v+1&-2}else{P=o;Q=2}if((Q|0)<=(v|0)){n[i+(v+-1<<2)>>2]=l*B;n[r>>2]=-(l*P)}m=i}while(0);if(!j){u=e;return}if(!(d|(h&1|0)==0)){u=e;return}f[m+-4>>2]=f[m>>2];n[m>>2]=0.0;if((h|0)<=1){u=e;return}n[m+(h<<2)>>2]=0.0;u=e;return}function xC(a,b,c){a=a|0;b=b|0;c=c|0;_h[f[a+44>>2]&255](a+8|0,b,c);return}function yC(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=33148;b=a+1232|0;c=f[b>>2]|0;d=a+1240|0;if((c|0)!=(d|0)){if(c|0)P5b(c);f[b>>2]=d;f[a+1236>>2]=264}d=a+192|0;b=f[d>>2]|0;c=a+200|0;if((b|0)==(c|0))return;if(b|0)P5b(b);f[d>>2]=c;f[a+196>>2]=1032;return}function zC(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=33148;b=a+1232|0;c=f[b>>2]|0;d=a+1240|0;if((c|0)!=(d|0)){if(c|0)P5b(c);f[b>>2]=d;f[a+1236>>2]=264}d=f[a+192>>2]|0;if((d|0)==(a+200|0)|(d|0)==0){O5b(a);return}P5b(d);O5b(a);return}function AC(a,b,c){a=a|0;b=b|0;c=c|0;return}function BC(a){a=a|0;O5b(a);return}function CC(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;k=u;u=u+16|0;l=k;m=L5b(12)|0;f[m>>2]=33212;f[m+4>>2]=0;b[m+8>>0]=0;DC(m);O5b(m);if((c|0)==1&(j|0)>0){f[l>>2]=0;f[l+4>>2]=0;Vac(aD(l,190)|0,170593,190)|0;bO(-213,l,440241,170209,3311);bD(l)}l=L5b(4244)|0;f[l>>2]=33232;m=l+4|0;f[l+60>>2]=0;f[l+64>>2]=0;f[l+68>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[l+84>>2]=l+92;f[l+88>>2]=1032;f[l+1124>>2]=l+1132;f[l+1128>>2]=1032;f[l+2164>>2]=l+2172;f[l+2168>>2]=1032;f[l+3204>>2]=l+3212;f[l+3208>>2]=1032;b[l+20>>0]=0;b[l+21>>0]=0;b[l+22>>0]=0;m=l+24|0;f[l+52>>2]=0;b[l+56>>0]=0;b[l+57>>0]=0;b[l+72>>0]=0;f[l+76>>2]=0;f[l+80>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;b[m+24>>0]=0;EC(l,c,d,e,g,h,i,j);j=L5b(16)|0;f[j+4>>2]=1;f[j>>2]=33252;f[j+8>>2]=l;f[a>>2]=j;f[a+4>>2]=l;u=k;return}function DC(a){a=a|0;f[a>>2]=33212;return}function EC(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;l=u;u=u+16|0;m=l;n=(g|0)!=(i|0);f[a+52>>2]=k;k=a+24|0;f[k>>2]=c;o=a+28|0;f[o>>2]=d;p=a+44|0;f[p>>2]=e;f[a+76>>2]=g;f[a+80>>2]=i;q=j&1;r=q&255;s=(g|0)==1;t=(i|0)==1;v=s&t;if(!q)if(!v){q=(i|0)==2;if(!(s&q))if((g|0)==2&q)w=3;else x=8;else w=2}else w=1;else if(!v){v=(g|0)==2;if(!(v&t))if(v&(i|0)==2)w=6;else x=8;else w=5}else w=4;if((x|0)==8)w=0;i=a+32|0;f[i>>2]=w;v=a+22|0;b[v>>0]=r;r=a+56|0;t=j>>>2&1;b[r>>0]=t;g=a+57|0;b[g>>0]=j>>>1&1;q=a+20|0;b[q>>0]=0;s=a+21|0;b[s>>0]=0;y=a+48|0;b[y>>0]=(w|0)!=6&(w|0)!=3&1;z=(e|0)==5?4:8;e=a+36|0;f[e>>2]=z;A=z<<1;z=a+40|0;f[z>>2]=A;switch(w&7){case 3:case 6:{f[e>>2]=A;break}default:{}}do if(!(t<<24>>24)){A=(d|0)>1;if(A&(c|0)==1){B=2-(j>>>9&1)|0;x=15;break}if((d|0)!=1){e=a+60|0;if(A&(c|0)>1){A=a+64|0;C=f[A>>2]|0;D=f[e>>2]|0;E=C-D>>2;F=D;G=C;if(E>>>0>=2)if((E|0)!=2?(C=F+8|0,(G|0)!=(C|0)):0){f[A>>2]=G+(~((G+-4-C|0)>>>2)<<2);H=D;I=w;J=F}else{H=D;I=w;J=F}else{HC(e,2-E|0);E=f[e>>2]|0;H=E;I=f[i>>2]|0;J=E}E=(I&-2|0)==4;f[J>>2]=E&1;f[J+4>>2]=(E^1)&1;K=e;L=H}else{M=e;N=0;x=23}}else{B=1;x=15}}else{B=1;x=15}while(0);if((x|0)==15){M=a+60|0;N=B;x=23}if((x|0)==23){x=a+64|0;B=f[x>>2]|0;H=f[M>>2]|0;J=B;switch(B-H>>2|0){case 0:{HC(M,1);break}case 1:break;default:{B=H+4|0;if((J|0)!=(B|0))f[x>>2]=J+(~((J+-4-B|0)>>>2)<<2)}}f[f[a+60>>2]>>2]=(N|0)==2&1;K=M;L=f[M>>2]|0}M=K+4|0;N=(f[M>>2]|0)-L>>2;if(!N){u=l;return}L=a+4|0;B=m+4|0;J=a+8|0;x=a+88|0;H=a+84|0;I=a+92|0;i=a+12|0;w=m+4|0;c=a+16|0;d=a+2168|0;t=a+2164|0;e=a+2172|0;E=a+3208|0;F=a+3204|0;D=a+3212|0;C=a+1128|0;G=a+1124|0;A=a+1132|0;a=n;n=(j&1024|0)!=0;j=0;O=f[K>>2]|0;P=N;do{N=(j|0)==1;n=N|n;a=a&(N^1);N=j;j=j+1|0;Q=h[v>>0]|0;R=(b[g>>0]|0)==0?Q:Q|2;Q=(b[r>>0]|0)==0;S=Q?R:R|4;R=a?S|16:S;S=(b[y>>0]|0)==0?R:R|32;R=(j|0)==(P|0)?S:S|64;S=f[k>>2]|0;T=f[o>>2]|0;do if(!(f[O+(N<<2)>>2]|0)){U=(S|0)!=1|Q^1;V=U?S:T;b[q>>0]=n&1;eC(m,V,U?T:1,f[p>>2]|0,R,q);U=f[m>>2]|0;W=f[B>>2]|0;if(U|0){X=U+4|0;f[X>>2]=(f[X>>2]|0)+1}X=f[L>>2]|0;f[L>>2]=U;f[J>>2]=W;if(X|0?(W=X+4|0,U=f[W>>2]|0,f[W>>2]=U+-1,(U|0)==1):0)bi[f[(f[X>>2]|0)+8>>2]&2047](X);X=f[m>>2]|0;if(X|0?(U=X+4|0,W=f[U>>2]|0,f[U>>2]=W+-1,(W|0)==1):0)bi[f[(f[X>>2]|0)+8>>2]&2047](X);if(b[q>>0]|0){X=Y(f[z>>2]|0,V)|0;if((f[x>>2]|0)>>>0>=X>>>0){f[x>>2]=X;break}V=f[H>>2]|0;if((V|0)!=(I|0)){if(V|0)P5b(V);f[H>>2]=I;f[x>>2]=1032}f[x>>2]=X;if(X>>>0>1032){V=N5b(X)|0;f[H>>2]=V}}}else{b[s>>0]=n&1;eC(m,T,S,f[p>>2]|0,R|128,s);V=f[m>>2]|0;X=f[w>>2]|0;if(V|0){W=V+4|0;f[W>>2]=(f[W>>2]|0)+1}W=f[i>>2]|0;f[i>>2]=V;f[c>>2]=X;if(W|0?(X=W+4|0,V=f[X>>2]|0,f[X>>2]=V+-1,(V|0)==1):0)bi[f[(f[W>>2]|0)+8>>2]&2047](W);W=f[m>>2]|0;if(W|0?(V=W+4|0,X=f[V>>2]|0,f[V>>2]=X+-1,(X|0)==1):0)bi[f[(f[W>>2]|0)+8>>2]&2047](W);do if(b[s>>0]|0){W=Y(f[z>>2]|0,T)|0;if((f[C>>2]|0)>>>0>=W>>>0){f[C>>2]=W;break}X=f[G>>2]|0;if((X|0)!=(A|0)){if(X|0)P5b(X);f[G>>2]=A;f[C>>2]=1032}f[C>>2]=W;if(W>>>0>1032){X=N5b(W)|0;f[G>>2]=X}}while(0);X=Y(f[z>>2]|0,T)|0;if((f[d>>2]|0)>>>0<X>>>0){W=f[t>>2]|0;if((W|0)!=(e|0)){if(W|0)P5b(W);f[t>>2]=e;f[d>>2]=1032}f[d>>2]=X;if(X>>>0>1032){W=N5b(X)|0;f[t>>2]=W}}else f[d>>2]=X;X=Y(f[z>>2]|0,T)|0;if((f[E>>2]|0)>>>0>=X>>>0){f[E>>2]=X;break}W=f[F>>2]|0;if((W|0)!=(D|0)){if(W|0)P5b(W);f[F>>2]=D;f[E>>2]=1032}f[E>>2]=X;if(X>>>0>1032){W=N5b(X)|0;f[F>>2]=W}}while(0);O=f[K>>2]|0;P=(f[M>>2]|0)-O>>2}while(j>>>0<P>>>0);u=l;return}function FC(a){a=a|0;O5b(a);return}function GC(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+8>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function HC(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){Nac(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)c4b(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;Nac(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)Vac(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;O5b(h);return}function IC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=a+60|0;h=a+64|0;i=f[g>>2]|0;j=(f[h>>2]|0)-i>>2;if(!j)return;k=a+76|0;l=a+80|0;m=c;c=0;n=b;b=i;i=j;do{j=f[l>>2]|0;o=(c|0)==1;p=o?j:f[k>>2]|0;m=o?e:m;n=o?d:n;o=c;c=c+1|0;q=(c|0)==(i|0);if(!(f[b+(o<<2)>>2]|0))LC(a,n,m,d,e,(p|0)!=(j|0),q);else MC(a,n,m,d,e,p,j,q);b=f[g>>2]|0;i=(f[h>>2]|0)-b>>2}while(c>>>0<i>>>0);return}function JC(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=33232;b=a+3204|0;c=f[b>>2]|0;d=a+3212|0;if((c|0)!=(d|0)){if(c|0)P5b(c);f[b>>2]=d;f[a+3208>>2]=1032}d=a+2164|0;b=f[d>>2]|0;c=a+2172|0;if((b|0)!=(c|0)){if(b|0)P5b(b);f[d>>2]=c;f[a+2168>>2]=1032}c=a+1124|0;d=f[c>>2]|0;b=a+1132|0;if((d|0)!=(b|0)){if(d|0)P5b(d);f[c>>2]=b;f[a+1128>>2]=1032}b=a+84|0;c=f[b>>2]|0;d=a+92|0;if((c|0)!=(d|0)){if(c|0)P5b(c);f[b>>2]=d;f[a+88>>2]=1032}d=f[a+60>>2]|0;if(d|0){b=a+64|0;c=f[b>>2]|0;if((c|0)!=(d|0))f[b>>2]=c+(~((c+-4-d|0)>>>2)<<2);O5b(d)}d=a+12|0;c=f[d>>2]|0;if(c|0?(b=c+4|0,e=f[b>>2]|0,f[b>>2]=e+-1,(e|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[d>>2]=0;f[a+16>>2]=0;d=a+4|0;c=f[d>>2]|0;if(!c){f[d>>2]=0;g=a+8|0;f[g>>2]=0;return}e=c+4|0;b=f[e>>2]|0;f[e>>2]=b+-1;if((b|0)!=1){f[d>>2]=0;g=a+8|0;f[g>>2]=0;return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[d>>2]=0;g=a+8|0;f[g>>2]=0;return}function KC(a){a=a|0;JC(a);O5b(a);return}function LC(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=f[a+24>>2]|0;k=f[a+28>>2]|0;if((j|0)==1?(b[a+56>>0]|0)==0:0){l=k;m=1}else{l=j;m=k}k=a+36|0;j=f[k>>2]|0;o=Y(j,l)|0;q=a+20|0;r=b[q>>0]|0;if(!(r<<24>>24))s=0;else s=(l|0)>1&(l&1|0)!=0&(f[a+32>>2]|0)==1?j:0;if((b[a+22>>0]|0)!=0|h^1)t=o;else t=(f[(l&1|0?k:a+40|0)>>2]|0)+o|0;o=f[a+52>>2]|0;k=(o|0)<1|(o|0)>(m|0)?m:o;o=(k|0)>0;a:do if(o){h=a+8|0;j=a+84|0;u=0;v=r;while(1){w=c+(Y(u,d)|0)|0;x=e+(Y(u,g)|0)|0;if(!(v<<24>>24))y=x;else y=f[j>>2]|0;z=f[h>>2]|0;_h[f[f[z>>2]>>2]&255](z,w,y);if(b[q>>0]|0)Vac(x|0,y+s|0,t|0)|0;x=u+1|0;if((x|0)==(k|0)){A=k;break a}u=x;v=b[q>>0]|0}}else A=0;while(0);if((A|0)<(m|0)){q=A;do{Nac(e+(Y(q,g)|0)|0,0,t|0)|0;q=q+1|0}while((q|0)!=(m|0))}if(!i)return;if((f[a+32>>2]|0)!=2)return;if((f[a+44>>2]|0)==5){a=g>>>2;if(!o)return;i=(l+1|0)/2|0;if((l|0)>2)B=0;else return;do{m=e+((Y(B,a)|0)<<2)|0;q=1;do{t=q<<1;A=l-q<<1;f[m+(A<<2)>>2]=f[m+(t<<2)>>2];n[m+((A|1)<<2)>>2]=-+n[m+((t|1)<<2)>>2];q=q+1|0}while((q|0)<(i|0));B=B+1|0}while((B|0)!=(k|0));return}else{B=g>>>3;if(!o)return;o=(l+1|0)/2|0;if((l|0)>2)C=0;else return;do{g=e+((Y(C,B)|0)<<3)|0;i=1;do{a=i<<1;q=l-i<<1;p[g+(q<<3)>>3]=+p[g+(a<<3)>>3];p[g+((q|1)<<3)>>3]=-+p[g+((a|1)<<3)>>3];i=i+1|0}while((i|0)<(o|0));C=C+1|0}while((C|0)!=(k|0));return}}function MC(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;k=f[a+28>>2]|0;l=f[a+24>>2]|0;m=a+2164|0;o=f[m>>2]|0;q=a+3204|0;r=f[q>>2]|0;if(!(b[a+21>>0]|0)){s=r;t=o}else{s=f[a+1124>>2]|0;t=r}if(!(b[a+48>>0]|0)){u=0;v=l;w=e;x=c}else{y=(l&1|0)==0;z=(l+1|0)/2|0;A=a+22|0;a:do if(!(b[A>>0]|0)){B=a+40|0;Nac(o|0,0,Y(f[B>>2]|0,k)|0)|0;C=f[m>>2]|0;D=a+36|0;E=d>>>2;F=(f[B>>2]|0)>>>2;switch(f[D>>2]|0){case 4:{if((k|0)>0){G=c;H=0;I=C;while(1){f[I>>2]=f[G>>2];H=H+1|0;if((H|0)==(k|0))break;else{G=G+(E<<2)|0;I=I+(F<<2)|0}}}break}case 8:{if((k|0)>0){I=c;G=0;H=C;while(1){J=f[I+4>>2]|0;f[H>>2]=f[I>>2];f[H+4>>2]=J;G=G+1|0;if((G|0)==(k|0))break;else{I=I+(E<<2)|0;H=H+(F<<2)|0}}}break}case 16:{if((k|0)>0){H=c;I=0;G=C;while(1){J=f[H+4>>2]|0;f[G>>2]=f[H>>2];f[G+4>>2]=J;J=f[H+12>>2]|0;f[G+8>>2]=f[H+8>>2];f[G+12>>2]=J;I=I+1|0;if((I|0)==(k|0))break;else{H=H+(E<<2)|0;G=G+(F<<2)|0}}}break}default:{}}F=c+(Y(f[D>>2]|0,i)|0)|0;if(y){Nac(f[q>>2]|0,0,Y(f[B>>2]|0,k)|0)|0;G=f[D>>2]|0;H=F+(Y(G,l+-2|0)|0)|0;I=f[q>>2]|0;C=(f[B>>2]|0)>>>2;switch(G|0){case 4:{if((k|0)>0){K=H;L=0;M=I}else{N=F;O=I;P=56;break a}while(1){f[M>>2]=f[K>>2];L=L+1|0;if((L|0)==(k|0)){Q=F;P=54;break}else{K=K+(E<<2)|0;M=M+(C<<2)|0}}break}case 8:{if((k|0)>0){R=H;S=0;T=I}else{N=F;O=I;P=56;break a}while(1){B=f[R+4>>2]|0;f[T>>2]=f[R>>2];f[T+4>>2]=B;S=S+1|0;if((S|0)==(k|0)){Q=F;P=54;break}else{R=R+(E<<2)|0;T=T+(C<<2)|0}}break}case 16:{if((k|0)>0){U=H;V=0;W=I}else{N=F;O=I;P=56;break a}while(1){B=f[U+4>>2]|0;f[W>>2]=f[U>>2];f[W+4>>2]=B;B=f[U+12>>2]|0;f[W+8>>2]=f[U+8>>2];f[W+12>>2]=B;V=V+1|0;if((V|0)==(k|0)){Q=F;P=54;break}else{U=U+(E<<2)|0;W=W+(C<<2)|0}}break}default:{N=F;O=I;P=56;break a}}}else X=F}else{if((h|0)!=1){C=a+40|0;E=f[C>>2]|0;H=d>>>2;B=E>>>2;switch(E|0){case 4:{if((k|0)>0){E=c;D=0;G=o;while(1){f[G>>2]=f[E>>2];D=D+1|0;if((D|0)==(k|0))break;else{E=E+(H<<2)|0;G=G+(B<<2)|0}}}break}case 8:{if((k|0)>0){G=c;E=0;D=o;while(1){F=f[G+4>>2]|0;f[D>>2]=f[G>>2];f[D+4>>2]=F;E=E+1|0;if((E|0)==(k|0))break;else{G=G+(H<<2)|0;D=D+(B<<2)|0}}}break}case 16:{if((k|0)>0){D=c;G=0;E=o;while(1){F=f[D+4>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=F;F=f[D+12>>2]|0;f[E+8>>2]=f[D+8>>2];f[E+12>>2]=F;G=G+1|0;if((G|0)==(k|0))break;else{D=D+(H<<2)|0;E=E+(B<<2)|0}}}break}default:{}}b:do if(y){B=f[C>>2]|0;E=c+(Y(B,z)|0)|0;D=B>>>2;switch(B|0){case 4:{if((k|0)>0){Z=E;_=0;$=r}else break b;while(1){f[$>>2]=f[Z>>2];_=_+1|0;if((_|0)==(k|0))break;else{Z=Z+(H<<2)|0;$=$+(D<<2)|0}}break}case 8:{if((k|0)>0){aa=E;ba=0;ca=r}else break b;while(1){B=f[aa+4>>2]|0;f[ca>>2]=f[aa>>2];f[ca+4>>2]=B;ba=ba+1|0;if((ba|0)==(k|0))break;else{aa=aa+(H<<2)|0;ca=ca+(D<<2)|0}}break}case 16:{if((k|0)>0){da=E;ea=0;fa=r}else break b;while(1){B=f[da+4>>2]|0;f[fa>>2]=f[da>>2];f[fa+4>>2]=B;B=f[da+12>>2]|0;f[fa+8>>2]=f[da+8>>2];f[fa+12>>2]=B;ea=ea+1|0;if((ea|0)==(k|0))break;else{da=da+(H<<2)|0;fa=fa+(D<<2)|0}}break}default:break b}}while(0);Q=c+(f[C>>2]|0)|0;P=54;break}H=a+36|0;D=f[H>>2]|0;E=d>>>2;B=D>>>2;switch(D|0){case 4:{if((k|0)>0){D=c;G=0;F=o;while(1){f[F>>2]=f[D>>2];G=G+1|0;if((G|0)==(k|0))break;else{D=D+(E<<2)|0;F=F+(B<<2)|0}}}break}case 8:{if((k|0)>0){F=c;D=0;G=o;while(1){C=f[F+4>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=C;D=D+1|0;if((D|0)==(k|0))break;else{F=F+(E<<2)|0;G=G+(B<<2)|0}}}break}case 16:{if((k|0)>0){G=c;F=0;D=o;while(1){C=f[G+4>>2]|0;f[D>>2]=f[G>>2];f[D+4>>2]=C;C=f[G+12>>2]|0;f[D+8>>2]=f[G+8>>2];f[D+12>>2]=C;F=F+1|0;if((F|0)==(k|0))break;else{G=G+(E<<2)|0;D=D+(B<<2)|0}}}break}default:{}}NC(o,k,f[H>>2]|0);if(y){B=f[H>>2]|0;D=c+(Y(B,l+-1|0)|0)|0;G=f[q>>2]|0;F=B>>>2;switch(B|0){case 4:{if((k|0)>0){B=D;C=0;I=G;while(1){f[I>>2]=f[B>>2];C=C+1|0;if((C|0)==(k|0))break;else{B=B+(E<<2)|0;I=I+(F<<2)|0}}}break}case 8:{if((k|0)>0){I=D;B=0;C=G;while(1){J=f[I+4>>2]|0;f[C>>2]=f[I>>2];f[C+4>>2]=J;B=B+1|0;if((B|0)==(k|0))break;else{I=I+(E<<2)|0;C=C+(F<<2)|0}}}break}case 16:{if((k|0)>0){C=D;I=0;B=G;while(1){J=f[C+4>>2]|0;f[B>>2]=f[C>>2];f[B+4>>2]=J;J=f[C+12>>2]|0;f[B+8>>2]=f[C+8>>2];f[B+12>>2]=J;I=I+1|0;if((I|0)==(k|0))break;else{C=C+(E<<2)|0;B=B+(F<<2)|0}}}break}default:{}}NC(G,k,f[H>>2]|0)}Q=c+(f[H>>2]|0)|0;P=54}while(0);if((P|0)==54)if(y){N=Q;O=f[q>>2]|0;P=56}else X=Q;if((P|0)==56){P=f[a+16>>2]|0;_h[f[f[P>>2]>>2]&255](P,O,s);X=N}N=f[a+16>>2]|0;_h[f[f[N>>2]>>2]&255](N,f[m>>2]|0,t);c:do if((i|0)==1)if(!(b[A>>0]|0)){N=a+36|0;O=f[N>>2]|0;Vac(t+O|0,t|0,O|0)|0;O=f[N>>2]|0;P=t+O|0;Q=O>>>2;c=g>>>2;switch(O|0){case 4:{if((k|0)>0){O=P;o=0;fa=e;while(1){f[fa>>2]=f[O>>2];o=o+1|0;if((o|0)==(k|0))break;else{O=O+(Q<<2)|0;fa=fa+(c<<2)|0}}}break}case 8:{if((k|0)>0){fa=P;O=0;o=e;while(1){H=f[fa+4>>2]|0;f[o>>2]=f[fa>>2];f[o+4>>2]=H;O=O+1|0;if((O|0)==(k|0))break;else{fa=fa+(Q<<2)|0;o=o+(c<<2)|0}}}break}case 16:{if((k|0)>0){o=P;fa=0;O=e;while(1){H=f[o+4>>2]|0;f[O>>2]=f[o>>2];f[O+4>>2]=H;H=f[o+12>>2]|0;f[O+8>>2]=f[o+8>>2];f[O+12>>2]=H;fa=fa+1|0;if((fa|0)==(k|0))break;else{o=o+(Q<<2)|0;O=O+(c<<2)|0}}}break}default:{}}if(!y){ga=N;break}O=f[N>>2]|0;Vac(s+O|0,s|0,O|0)|0;O=f[N>>2]|0;Q=s+O|0;o=e+(Y(O,l+-1|0)|0)|0;fa=O>>>2;switch(O|0){case 4:{if((k|0)>0){ha=Q;ia=0;ja=o}else{ga=N;break c}while(1){f[ja>>2]=f[ha>>2];ia=ia+1|0;if((ia|0)==(k|0)){ga=N;break}else{ha=ha+(fa<<2)|0;ja=ja+(c<<2)|0}}break}case 8:{if((k|0)>0){ka=Q;la=0;ma=o}else{ga=N;break c}while(1){O=f[ka+4>>2]|0;f[ma>>2]=f[ka>>2];f[ma+4>>2]=O;la=la+1|0;if((la|0)==(k|0)){ga=N;break}else{ka=ka+(fa<<2)|0;ma=ma+(c<<2)|0}}break}case 16:{if((k|0)>0){na=Q;oa=0;pa=o}else{ga=N;break c}while(1){O=f[na+4>>2]|0;f[pa>>2]=f[na>>2];f[pa+4>>2]=O;O=f[na+12>>2]|0;f[pa+8>>2]=f[na+8>>2];f[pa+12>>2]=O;oa=oa+1|0;if((oa|0)==(k|0)){ga=N;break}else{na=na+(fa<<2)|0;pa=pa+(c<<2)|0}}break}default:{ga=N;break c}}}else{c=a+40|0;fa=a+36|0;o=(f[c>>2]|0)>>>2;Q=g>>>2;switch(f[fa>>2]|0){case 4:{if((k|0)>0){O=t;P=0;H=e;while(1){f[H>>2]=f[O>>2];P=P+1|0;if((P|0)==(k|0))break;else{O=O+(o<<2)|0;H=H+(Q<<2)|0}}}break}case 8:{if((k|0)>0){H=t;O=0;P=e;while(1){N=f[H+4>>2]|0;f[P>>2]=f[H>>2];f[P+4>>2]=N;O=O+1|0;if((O|0)==(k|0))break;else{H=H+(o<<2)|0;P=P+(Q<<2)|0}}}break}case 16:{if((k|0)>0){P=t;H=0;O=e;while(1){N=f[P+4>>2]|0;f[O>>2]=f[P>>2];f[O+4>>2]=N;N=f[P+12>>2]|0;f[O+8>>2]=f[P+8>>2];f[O+12>>2]=N;H=H+1|0;if((H|0)==(k|0))break;else{P=P+(o<<2)|0;O=O+(Q<<2)|0}}}break}default:{}}if(!y){ga=fa;break}O=f[fa>>2]|0;o=e+(Y(O,l+-1|0)|0)|0;P=(f[c>>2]|0)>>>2;switch(O|0){case 4:{if((k|0)>0){qa=s;ra=0;sa=o}else{ga=fa;break c}while(1){f[sa>>2]=f[qa>>2];ra=ra+1|0;if((ra|0)==(k|0)){ga=fa;break}else{qa=qa+(P<<2)|0;sa=sa+(Q<<2)|0}}break}case 8:{if((k|0)>0){ta=s;ua=0;va=o}else{ga=fa;break c}while(1){c=f[ta+4>>2]|0;f[va>>2]=f[ta>>2];f[va+4>>2]=c;ua=ua+1|0;if((ua|0)==(k|0)){ga=fa;break}else{ta=ta+(P<<2)|0;va=va+(Q<<2)|0}}break}case 16:{if((k|0)>0){wa=s;xa=0;ya=o}else{ga=fa;break c}while(1){c=f[wa+4>>2]|0;f[ya>>2]=f[wa>>2];f[ya+4>>2]=c;c=f[wa+12>>2]|0;f[ya+8>>2]=f[wa+8>>2];f[ya+12>>2]=c;xa=xa+1|0;if((xa|0)==(k|0)){ga=fa;break}else{wa=wa+(P<<2)|0;ya=ya+(Q<<2)|0}}break}default:{ga=fa;break c}}}else{Q=a+40|0;P=f[Q>>2]|0;o=P>>>2;c=g>>>2;switch(P|0){case 4:{if((k|0)>0){P=t;O=0;H=e;while(1){f[H>>2]=f[P>>2];O=O+1|0;if((O|0)==(k|0))break;else{P=P+(o<<2)|0;H=H+(c<<2)|0}}}break}case 8:{if((k|0)>0){H=t;P=0;O=e;while(1){fa=f[H+4>>2]|0;f[O>>2]=f[H>>2];f[O+4>>2]=fa;P=P+1|0;if((P|0)==(k|0))break;else{H=H+(o<<2)|0;O=O+(c<<2)|0}}}break}case 16:{if((k|0)>0){O=t;H=0;P=e;while(1){fa=f[O+4>>2]|0;f[P>>2]=f[O>>2];f[P+4>>2]=fa;fa=f[O+12>>2]|0;f[P+8>>2]=f[O+8>>2];f[P+12>>2]=fa;H=H+1|0;if((H|0)==(k|0))break;else{O=O+(o<<2)|0;P=P+(c<<2)|0}}}break}default:{}}if(y){P=f[Q>>2]|0;o=e+(Y(P,z)|0)|0;O=P>>>2;switch(P|0){case 4:{if((k|0)>0){za=s;Aa=0;Ba=o}else{ga=Q;break c}while(1){f[Ba>>2]=f[za>>2];Aa=Aa+1|0;if((Aa|0)==(k|0)){ga=Q;break}else{za=za+(O<<2)|0;Ba=Ba+(c<<2)|0}}break}case 8:{if((k|0)>0){Ca=s;Da=0;Ea=o}else{ga=Q;break c}while(1){P=f[Ca+4>>2]|0;f[Ea>>2]=f[Ca>>2];f[Ea+4>>2]=P;Da=Da+1|0;if((Da|0)==(k|0)){ga=Q;break}else{Ca=Ca+(O<<2)|0;Ea=Ea+(c<<2)|0}}break}case 16:{if((k|0)>0){Fa=s;Ga=0;Ha=o}else{ga=Q;break c}while(1){P=f[Fa+4>>2]|0;f[Ha>>2]=f[Fa>>2];f[Ha+4>>2]=P;P=f[Fa+12>>2]|0;f[Ha+8>>2]=f[Fa+8>>2];f[Ha+12>>2]=P;Ga=Ga+1|0;if((Ga|0)==(k|0)){ga=Q;break}else{Fa=Fa+(O<<2)|0;Ha=Ha+(c<<2)|0}}break}default:{ga=Q;break c}}}else ga=Q}while(0);u=1;v=z;w=e+(f[ga>>2]|0)|0;x=X}if((u|0)<(v|0)){X=a+40|0;ga=d>>>2;d=a+16|0;z=(k|0)>0;Ha=k<<1;Fa=k<<2;Ga=g>>>2;Ea=u;u=x;x=w;while(1){w=(Ea+1|0)<(v|0);Ca=f[m>>2]|0;d:do if(w){Da=f[q>>2]|0;switch(f[X>>2]|0){case 4:{if(z){Ba=u;za=0;while(1){Aa=f[Ba+4>>2]|0;f[Ca+(za<<2)>>2]=f[Ba>>2];f[Da+(za<<2)>>2]=Aa;za=za+1|0;if((za|0)==(k|0))break;else Ba=Ba+(ga<<2)|0}}break}case 8:{if(z){Ba=u;za=0;while(1){Aa=f[Ba+4>>2]|0;f[Ca+(za<<2)>>2]=f[Ba>>2];y=za|1;f[Ca+(y<<2)>>2]=Aa;Aa=f[Ba+12>>2]|0;f[Da+(za<<2)>>2]=f[Ba+8>>2];f[Da+(y<<2)>>2]=Aa;za=za+2|0;if((za|0)>=(Ha|0))break;else Ba=Ba+(ga<<2)|0}}break}case 16:{if(z){Ba=0;za=u;while(1){Aa=f[za+4>>2]|0;f[Ca+(Ba<<2)>>2]=f[za>>2];y=Ba|1;f[Ca+(y<<2)>>2]=Aa;Aa=f[za+12>>2]|0;ya=Ba|2;f[Ca+(ya<<2)>>2]=f[za+8>>2];wa=Ba|3;f[Ca+(wa<<2)>>2]=Aa;Aa=f[za+20>>2]|0;f[Da+(Ba<<2)>>2]=f[za+16>>2];f[Da+(y<<2)>>2]=Aa;Aa=f[za+28>>2]|0;f[Da+(ya<<2)>>2]=f[za+24>>2];f[Da+(wa<<2)>>2]=Aa;Ba=Ba+4|0;if((Ba|0)>=(Fa|0))break;else za=za+(ga<<2)|0}}break}default:{}}za=f[d>>2]|0;_h[f[f[za>>2]>>2]&255](za,Da,s);Ia=f[m>>2]|0}else{za=f[X>>2]|0;Ba=za>>>2;switch(za|0){case 4:{if(z){Ja=u;Ka=0;La=Ca}else{Ia=Ca;break d}while(1){f[La>>2]=f[Ja>>2];Ka=Ka+1|0;if((Ka|0)==(k|0)){Ia=Ca;break}else{Ja=Ja+(ga<<2)|0;La=La+(Ba<<2)|0}}break}case 8:{if(z){Ma=u;Na=0;Oa=Ca}else{Ia=Ca;break d}while(1){Da=f[Ma+4>>2]|0;f[Oa>>2]=f[Ma>>2];f[Oa+4>>2]=Da;Na=Na+1|0;if((Na|0)==(k|0)){Ia=Ca;break}else{Ma=Ma+(ga<<2)|0;Oa=Oa+(Ba<<2)|0}}break}case 16:{if(z){Pa=u;Qa=0;Ra=Ca}else{Ia=Ca;break d}while(1){Da=f[Pa+4>>2]|0;f[Ra>>2]=f[Pa>>2];f[Ra+4>>2]=Da;Da=f[Pa+12>>2]|0;f[Ra+8>>2]=f[Pa+8>>2];f[Ra+12>>2]=Da;Qa=Qa+1|0;if((Qa|0)==(k|0)){Ia=Ca;break}else{Pa=Pa+(ga<<2)|0;Ra=Ra+(Ba<<2)|0}}break}default:{Ia=Ca;break d}}}while(0);Ca=f[d>>2]|0;_h[f[f[Ca>>2]>>2]&255](Ca,Ia,t);Ca=f[X>>2]|0;e:do if(w)switch(Ca|0){case 4:{if(z){Sa=0;Ta=x}else break e;while(1){Q=f[s+(Sa<<2)>>2]|0;f[Ta>>2]=f[t+(Sa<<2)>>2];f[Ta+4>>2]=Q;Sa=Sa+1|0;if((Sa|0)==(k|0))break;else Ta=Ta+(Ga<<2)|0}break}case 8:{if(z){Ua=0;Va=x}else break e;while(1){Q=Ua|1;Ba=f[t+(Q<<2)>>2]|0;f[Va>>2]=f[t+(Ua<<2)>>2];f[Va+4>>2]=Ba;Ba=f[s+(Q<<2)>>2]|0;f[Va+8>>2]=f[s+(Ua<<2)>>2];f[Va+12>>2]=Ba;Ua=Ua+2|0;if((Ua|0)>=(Ha|0))break;else Va=Va+(Ga<<2)|0}break}case 16:{if(z){Wa=x;Xa=0}else break e;while(1){Ba=Xa|1;Q=f[t+(Ba<<2)>>2]|0;f[Wa>>2]=f[t+(Xa<<2)>>2];f[Wa+4>>2]=Q;Q=Xa|2;Da=Xa|3;za=f[t+(Da<<2)>>2]|0;f[Wa+8>>2]=f[t+(Q<<2)>>2];f[Wa+12>>2]=za;za=f[s+(Ba<<2)>>2]|0;f[Wa+16>>2]=f[s+(Xa<<2)>>2];f[Wa+20>>2]=za;za=f[s+(Da<<2)>>2]|0;f[Wa+24>>2]=f[s+(Q<<2)>>2];f[Wa+28>>2]=za;Xa=Xa+4|0;if((Xa|0)>=(Fa|0))break;else Wa=Wa+(Ga<<2)|0}break}default:break e}else{za=Ca>>>2;switch(Ca|0){case 4:{if(z){Ya=t;Za=0;_a=x}else break e;while(1){f[_a>>2]=f[Ya>>2];Za=Za+1|0;if((Za|0)==(k|0))break;else{Ya=Ya+(za<<2)|0;_a=_a+(Ga<<2)|0}}break}case 8:{if(z){$a=t;ab=0;bb=x}else break e;while(1){Q=f[$a+4>>2]|0;f[bb>>2]=f[$a>>2];f[bb+4>>2]=Q;ab=ab+1|0;if((ab|0)==(k|0))break;else{$a=$a+(za<<2)|0;bb=bb+(Ga<<2)|0}}break}case 16:{if(z){cb=t;db=0;eb=x}else break e;while(1){Q=f[cb+4>>2]|0;f[eb>>2]=f[cb>>2];f[eb+4>>2]=Q;Q=f[cb+12>>2]|0;f[eb+8>>2]=f[cb+8>>2];f[eb+12>>2]=Q;db=db+1|0;if((db|0)==(k|0))break;else{cb=cb+(za<<2)|0;eb=eb+(Ga<<2)|0}}break}default:break e}}while(0);Ca=f[X>>2]<<1;Ea=Ea+2|0;if((Ea|0)>=(v|0))break;else{u=u+Ca|0;x=x+Ca|0}}}if(!j)return;if((f[a+32>>2]|0)!=2)return;if((f[a+44>>2]|0)==5){a=g>>>2;if((k|0)<=0)return;j=(l+1|0)/2|0;if((l|0)>2)fb=0;else return;do{x=e+((Y(fb,a)|0)<<2)|0;u=e+((Y(k-fb|0,a)|0)<<2)|0;v=(fb|0)==0|(fb<<1|0)==(k|0)?x:u;u=1;do{Ea=u<<1;X=l-u<<1;f[x+(X<<2)>>2]=f[v+(Ea<<2)>>2];n[x+((X|1)<<2)>>2]=-+n[v+((Ea|1)<<2)>>2];u=u+1|0}while((u|0)<(j|0));fb=fb+1|0}while((fb|0)!=(k|0));return}else{fb=g>>>3;if((k|0)<=0)return;g=(l+1|0)/2|0;if((l|0)>2)gb=0;else return;do{j=e+((Y(gb,fb)|0)<<3)|0;a=e+((Y(k-gb|0,fb)|0)<<3)|0;u=(gb|0)==0|(gb<<1|0)==(k|0)?j:a;a=1;do{v=a<<1;x=l-a<<1;p[j+(x<<3)>>3]=+p[u+(v<<3)>>3];p[j+((x|1)<<3)>>3]=-+p[u+((v|1)<<3)>>3];a=a+1|0}while((a|0)<(g|0));gb=gb+1|0}while((gb|0)!=(k|0));return}}function NC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;if((c|0)==4){c=b+1|0;d=(c|0)/2|0;if((b|0)>2){e=1;do{g=e<<1;h=b-e<<1;f[a+(h<<2)>>2]=f[a+(g+-1<<2)>>2];n[a+((h|1)<<2)>>2]=-+n[a+(g<<2)>>2];e=e+1|0}while((e|0)<(d|0))}d=b+-1|0;if(!(b&1)){f[a+(b<<2)>>2]=f[a+(d<<2)>>2];n[a+(c<<2)>>2]=0.0;i=d}else i=b;if((i|0)>1){d=i;do{i=d;d=d+-1|0;f[a+(i<<2)>>2]=f[a+(d<<2)>>2]}while((d|0)>1)}n[a+4>>2]=0.0;return}else{d=b+1|0;i=(d|0)/2|0;if((b|0)>2){c=1;do{e=c<<1;g=b-c<<1;p[a+(g<<3)>>3]=+p[a+(e+-1<<3)>>3];p[a+((g|1)<<3)>>3]=-+p[a+(e<<3)>>3];c=c+1|0}while((c|0)<(i|0))}i=b+-1|0;if(!(b&1)){p[a+(b<<3)>>3]=+p[a+(i<<3)>>3];p[a+(d<<3)>>3]=0.0;j=i}else j=b;if((j|0)>1){b=j;do{j=b;b=b+-1|0;p[a+(j<<3)>>3]=+p[a+(b<<3)>>3]}while((b|0)>1)}p[a+8>>3]=0.0;return}}function OC(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function PC(a){a=a|0;O5b(a);return}function QC(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=u;u=u+208|0;h=g+200|0;i=g+144|0;j=g+88|0;k=g+32|0;l=g+24|0;m=g+16|0;n=g;o=g+8|0;dQ(h,33264);do if((yM(a)|0)==65536){p=f[a+4>>2]|0;f[i>>2]=f[p>>2];q=i+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[p+8>>2];t=i+12|0;f[t>>2]=f[p+12>>2];v=i+16|0;f[v>>2]=f[p+16>>2];w=i+20|0;f[w>>2]=f[p+20>>2];x=i+24|0;f[x>>2]=f[p+24>>2];y=i+28|0;f[y>>2]=f[p+28>>2];z=i+32|0;f[z>>2]=f[p+32>>2];A=i+36|0;B=f[p+36>>2]|0;f[A>>2]=B;f[i+40>>2]=s;C=i+48|0;D=i+44|0;f[D>>2]=C;f[C>>2]=0;f[i+52>>2]=0;if(B|0){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;C=f[D>>2]|0;f[C>>2]=f[r>>2];f[C+4>>2]=f[r+4>>2];E=i;F=q;G=s;H=t;I=v;J=v;K=w;L=x;M=y;N=z;O=A;P=A;break}else{f[q>>2]=0;jL(i,p);E=i;F=q;G=s;H=t;I=v;J=v;K=w;L=x;M=y;N=z;O=A;P=A;break}}else{yL(i,a,-1);A=i+16|0;z=i+36|0;E=i;F=i+4|0;G=i+8|0;H=i+12|0;I=A;J=A;K=i+20|0;L=i+24|0;M=i+28|0;N=i+32|0;O=z;P=z}while(0);f[j>>2]=f[E>>2];E=j+4|0;a=f[F>>2]|0;f[E>>2]=a;z=j+8|0;f[z>>2]=f[G>>2];G=j+12|0;f[G>>2]=f[H>>2];H=j+16|0;f[H>>2]=f[J>>2];f[j+20>>2]=f[K>>2];f[j+24>>2]=f[L>>2];f[j+28>>2]=f[M>>2];f[j+32>>2]=f[N>>2];N=j+36|0;M=f[P>>2]|0;f[N>>2]=M;P=j+40|0;f[P>>2]=z;L=j+48|0;K=j+44|0;f[K>>2]=L;f[L>>2]=0;f[j+52>>2]=0;if(!M)Q=a;else{a=M+12|0;f[a>>2]=(f[a>>2]|0)+1;Q=f[F>>2]|0}if((Q|0)<3){Q=f[i+44>>2]|0;a=f[K>>2]|0;f[a>>2]=f[Q>>2];f[a+4>>2]=f[Q+4>>2]}else{f[E>>2]=0;jL(j,i)}Q=(d&1|0)==0;a=f[j>>2]|0;M=a&4095;J=a&7;switch(a&4095){case 5:case 6:case 13:case 14:break;default:{f[k>>2]=0;f[k+4>>2]=0;Vac(aD(k,208)|0,170912,208)|0;bO(-215,k,171121,170209,3343);bD(k)}}if(d&64|0?(f[j>>2]&4088|0)!=8:0){f[k>>2]=0;f[k+4>>2]=0;a=aD(k,53)|0;A=171125;y=a+53|0;do{b[a>>0]=b[A>>0]|0;a=a+1|0;A=A+1|0}while((a|0)<(y|0));bO(-215,k,171121,170209,3346);bD(k)}A=(f[j>>2]|0)>>>3&511;if(Q)if((d&16|0)==0|(A|0)!=0)R=23;else{Q=f[P>>2]|0;a=f[Q>>2]|0;f[l>>2]=f[Q+4>>2];f[l+4>>2]=a;vM(c,l,J|8,-1,0,0)}else if((d&32|0)==0|(A|0)!=1)R=23;else{A=f[P>>2]|0;l=f[A>>2]|0;f[m>>2]=f[A+4>>2];f[m+4>>2]=l;vM(c,m,J,-1,0,0)}if((R|0)==23){R=f[P>>2]|0;m=f[R>>2]|0;f[n>>2]=f[R+4>>2];f[n+4>>2]=m;vM(c,n,M,-1,0,0)}do if((yM(c)|0)==65536){M=f[c+4>>2]|0;f[k>>2]=f[M>>2];n=k+4|0;m=M+4|0;f[n>>2]=f[m>>2];R=k+8|0;f[R>>2]=f[M+8>>2];f[k+12>>2]=f[M+12>>2];f[k+16>>2]=f[M+16>>2];f[k+20>>2]=f[M+20>>2];f[k+24>>2]=f[M+24>>2];f[k+28>>2]=f[M+28>>2];f[k+32>>2]=f[M+32>>2];l=f[M+36>>2]|0;f[k+36>>2]=l;f[k+40>>2]=R;R=k+48|0;A=k+44|0;f[A>>2]=R;f[R>>2]=0;f[k+52>>2]=0;if(l|0){R=l+12|0;f[R>>2]=(f[R>>2]|0)+1}if((f[m>>2]|0)<3){m=f[M+44>>2]|0;R=f[A>>2]|0;f[R>>2]=f[m>>2];f[R+4>>2]=f[m+4>>2];break}else{f[n>>2]=0;jL(k,M);break}}else yL(k,c,-1);while(0);c=f[j>>2]|0;M=f[k>>2]|0;n=d&7|((c&16384|0)==0?0:M>>>5&512);d=k+16|0;CC(o,f[G>>2]|0,f[z>>2]|0,J,(c>>>3&511)+1|0,(M>>>3&511)+1|0,(f[H>>2]|0)==(f[d>>2]|0)?n|1024:n,e);e=f[o+4>>2]|0;n=k+48|0;uh[f[f[e>>2]>>2]&255](e,f[H>>2]|0,f[L>>2]|0,f[d>>2]|0,f[n>>2]|0);e=f[o>>2]|0;if(e|0?(o=e+4|0,M=f[o>>2]|0,f[o>>2]=M+-1,(M|0)==1):0)bi[f[(f[e>>2]|0)+8>>2]&2047](e);e=k+36|0;M=f[e>>2]|0;if(M|0?(o=M+12|0,M=f[o>>2]|0,f[o>>2]=M+-1,(M|0)==1):0)kL(k);f[e>>2]=0;e=k+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){d=f[k+40>>2]|0;M=0;do{f[d+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[e>>2]|0))}e=f[k+44>>2]|0;if((e|0)!=(n|0))UC(e);e=f[N>>2]|0;if(e|0?(n=e+12|0,e=f[n>>2]|0,f[n>>2]=e+-1,(e|0)==1):0)kL(j);f[N>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[E>>2]|0)>0){H=f[P>>2]|0;P=0;do{f[H+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[E>>2]|0))}E=f[K>>2]|0;if((E|0)!=(L|0))UC(E);E=f[O>>2]|0;if(E|0?(L=E+12|0,E=f[L>>2]|0,f[L>>2]=E+-1,(E|0)==1):0)kL(i);f[O>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[F>>2]|0)>0){I=f[i+40>>2]|0;O=0;do{f[I+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[F>>2]|0))}F=f[i+44>>2]|0;if((F|0)!=(i+48|0))UC(F);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function RC(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;h=u;u=u+256|0;i=h+232|0;j=h+224|0;k=h+168|0;l=h+112|0;m=h+56|0;o=h;dQ(j,33284);do if((yM(a)|0)==65536){q=f[a+4>>2]|0;f[k>>2]=f[q>>2];r=k+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=k+8|0;f[t>>2]=f[q+8>>2];f[k+12>>2]=f[q+12>>2];f[k+16>>2]=f[q+16>>2];f[k+20>>2]=f[q+20>>2];f[k+24>>2]=f[q+24>>2];f[k+28>>2]=f[q+28>>2];f[k+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[k+36>>2]=v;f[k+40>>2]=t;t=k+48|0;w=k+44|0;f[w>>2]=t;f[t>>2]=0;f[k+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;jL(k,q);break}}else yL(k,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[l>>2]=f[a>>2];q=l+4|0;r=a+4|0;f[q>>2]=f[r>>2];s=l+8|0;f[s>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];t=f[a+36>>2]|0;f[l+36>>2]=t;f[l+40>>2]=s;s=l+48|0;w=l+44|0;f[w>>2]=s;f[s>>2]=0;f[l+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[a+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];x=l;break}else{f[q>>2]=0;jL(l,a);x=l;break}}else{yL(l,c,-1);x=l}while(0);c=f[k>>2]|0;a=c&7;q=c>>>3&511;r=q+1|0;s=c&4095;w=k+8|0;t=f[w>>2]|0;v=k+12|0;y=f[v>>2]|0;if(!((s|0)==(f[x>>2]&4095|0)?(z=f[k+40>>2]|0,A=f[l+40>>2]|0,(f[z>>2]|0)==(f[A>>2]|0)?(f[z+4>>2]|0)==(f[A+4>>2]|0):0):0)){f[i>>2]=0;f[i+4>>2]=0;B=aD(i,49)|0;A=171227;C=B+49|0;do{b[B>>0]=b[A>>0]|0;B=B+1|0;A=A+1|0}while((B|0)<(C|0));bO(-215,i,171277,170209,3549);bD(i)}switch(c&4095){case 5:case 6:case 13:case 14:break;default:{f[i>>2]=0;f[i+4>>2]=0;Vac(aD(i,208)|0,170912,208)|0;bO(-215,i,171277,170209,3550);bD(i)}}aM(d,f[w>>2]|0,f[v>>2]|0,s,-1,0,0);do if((yM(d)|0)==65536){s=f[d+4>>2]|0;f[m>>2]=f[s>>2];v=m+4|0;w=s+4|0;f[v>>2]=f[w>>2];c=m+8|0;f[c>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];A=m+16|0;f[A>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];f[m+24>>2]=f[s+24>>2];f[m+28>>2]=f[s+28>>2];f[m+32>>2]=f[s+32>>2];z=f[s+36>>2]|0;f[m+36>>2]=z;f[m+40>>2]=c;c=m+48|0;D=m+44|0;f[D>>2]=c;f[c>>2]=0;f[m+52>>2]=0;if(z|0){c=z+12|0;f[c>>2]=(f[c>>2]|0)+1}if((f[w>>2]|0)<3){w=f[s+44>>2]|0;c=f[D>>2]|0;f[c>>2]=f[w>>2];f[c+4>>2]=f[w+4>>2];E=A;break}else{f[v>>2]=0;jL(m,s);E=A;break}}else{yL(m,d,-1);E=m+16|0}while(0);d=l+16|0;if((f[E>>2]|0)==(f[d>>2]|0)){f[o>>2]=1124007936;A=o+4|0;s=o+8|0;v=o+40|0;B=A;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));f[v>>2]=s;B=o+48|0;C=o+44|0;f[C>>2]=B;f[B>>2]=0;f[o+52>>2]=0;w=i+8|0;f[w>>2]=0;f[w+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;SP(l,i);i=o+36|0;w=f[i>>2]|0;if(w|0){c=w+12|0;f[c>>2]=(f[c>>2]|0)+1}c=l+36|0;w=f[c>>2]|0;if(w|0?(D=w+12|0,w=f[D>>2]|0,f[D>>2]=w+-1,(w|0)==1):0)kL(l);f[c>>2]=0;w=l+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[w>>2]|0)>0){D=f[l+40>>2]|0;z=0;do{f[D+(z<<2)>>2]=0;z=z+1|0;F=f[w>>2]|0}while((z|0)<(F|0));f[x>>2]=f[o>>2];if((F|0)<3)G=38;else G=40}else{f[x>>2]=f[o>>2];G=38}if((G|0)==38){F=f[A>>2]|0;if((F|0)<3){f[w>>2]=F;f[l+8>>2]=f[s>>2];f[l+12>>2]=f[o+12>>2];s=f[C>>2]|0;F=f[l+44>>2]|0;f[F>>2]=f[s>>2];f[F+4>>2]=f[s+4>>2]}else G=40}if((G|0)==40)jL(l,o);s=o+16|0;f[d>>2]=f[s>>2];f[l+20>>2]=f[o+20>>2];f[l+24>>2]=f[o+24>>2];f[l+28>>2]=f[o+28>>2];f[l+32>>2]=f[o+32>>2];F=f[i>>2]|0;f[c>>2]=F;if(F|0?(c=F+12|0,F=f[c>>2]|0,f[c>>2]=F+-1,(F|0)==1):0)kL(o);f[i>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[A>>2]|0)>0){s=f[v>>2]|0;v=0;do{f[s+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[A>>2]|0))}A=f[C>>2]|0;if((A|0)!=(B|0))UC(A)}A=(e&4|0)!=0;if(!(A|(t|0)==1))if(((y|0)==1?(f[k>>2]&16384|0)!=0:0)?(f[x>>2]&16384|0)!=0:0)H=(f[m>>2]&16384|0)!=0;else H=0;else H=1;x=A|H^1;A=y+(x?0:t+-1|0)|0;y=x?t:1;t=(q|0)==0;x=t&1;e=A&1;B=(e|0)==0;C=(Y(A,r)|0)-((e|q|0)==0&1)|0;q=k+16|0;e=f[q>>2]|0;a:do if((a|0)==5){r=f[d>>2]|0;v=f[E>>2]|0;s=f[k+48>>2]|0;i=f[l+48>>2]|0;o=f[m+48>>2]|0;F=(e|0)==(v|0);c=H|t^1;if(g)if(F){do if(!c){n[e>>2]=+n[e>>2]*+n[r>>2];w=y+-2|0;z=(w|0)==0;if(!z){D=1;do{I=e+(Y(D,o)|0)|0;J=+n[I>>2];K=D+1|0;L=e+(Y(K,o)|0)|0;M=+n[L>>2];N=r+(Y(D,i)|0)|0;O=+n[N>>2];N=r+(Y(K,i)|0)|0;P=-+n[N>>2];n[I>>2]=J*O-M*P;n[L>>2]=M*O+J*P;D=D+2|0}while(D>>>0<=w>>>0);if(!(y&1)){Q=y+-1|0;G=117}}else{Q=1;G=117}if((G|0)==117){D=e+(Y(Q,o)|0)|0;L=r+(Y(Q,i)|0)|0;n[D>>2]=+n[D>>2]*+n[L>>2]}if(B){L=r+(A<<2)+-4|0;D=e+(A<<2)+-4|0;n[D>>2]=+n[D>>2]*+n[L>>2];if(!z){I=1;do{N=D+(Y(I,o)|0)|0;P=+n[N>>2];K=I+1|0;R=D+(Y(K,o)|0)|0;J=+n[R>>2];S=L+(Y(I,i)|0)|0;O=+n[S>>2];S=L+(Y(K,i)|0)|0;M=-+n[S>>2];n[N>>2]=P*O-J*M;n[R>>2]=J*O+P*M;I=I+2|0}while(I>>>0<=w>>>0);if(!(y&1))T=y+-1|0;else break}else T=1;w=D+(Y(T,o)|0)|0;I=L+(Y(T,i)|0)|0;n[w>>2]=+n[w>>2]*+n[I>>2]}}while(0);I=t&H;w=y+-1|0;if(!y)break;z=x>>>0<C>>>0;R=I&B;if(!I){if(z){U=e;V=r;W=w}else break;while(1){I=x;do{N=U+(I<<2)|0;M=+n[N>>2];S=I+1|0;K=U+(S<<2)|0;P=+n[K>>2];O=+n[V+(I<<2)>>2];J=-+n[V+(S<<2)>>2];n[N>>2]=M*O-P*J;n[K>>2]=P*O+M*J;I=I+2|0}while(I>>>0<C>>>0);if(!W)break a;else{U=U+o|0;V=V+i|0;W=W+-1|0}}}if(!z)if(R){I=e;L=r;D=e;K=w;while(1){n[D>>2]=+n[I>>2]*+n[L>>2];n[D+(C<<2)>>2]=+n[I+(C<<2)>>2]*+n[L+(C<<2)>>2];if(!K)break a;else{I=I+s|0;L=L+i|0;D=D+o|0;K=K+-1|0}}}else{K=w;D=e;L=r;I=e;while(1){n[I>>2]=+n[D>>2]*+n[L>>2];if(!K)break a;else{K=K+-1|0;D=D+s|0;L=L+i|0;I=I+o|0}}}if(R){I=e;L=r;D=e;K=w;while(1){n[D>>2]=+n[I>>2]*+n[L>>2];z=x;do{N=D+(z<<2)|0;J=+n[N>>2];S=z+1|0;X=D+(S<<2)|0;M=+n[X>>2];O=+n[L+(z<<2)>>2];P=-+n[L+(S<<2)>>2];n[N>>2]=J*O-M*P;n[X>>2]=M*O+J*P;z=z+2|0}while(z>>>0<C>>>0);n[D+(C<<2)>>2]=+n[I+(C<<2)>>2]*+n[L+(C<<2)>>2];if(!K)break;else{I=I+s|0;L=L+i|0;D=D+o|0;K=K+-1|0}}}else{K=e;D=r;L=e;I=w;while(1){n[L>>2]=+n[K>>2]*+n[D>>2];R=x;do{z=L+(R<<2)|0;P=+n[z>>2];X=R+1|0;N=L+(X<<2)|0;J=+n[N>>2];O=+n[D+(R<<2)>>2];M=-+n[D+(X<<2)>>2];n[z>>2]=P*O-J*M;n[N>>2]=J*O+P*M;R=R+2|0}while(R>>>0<C>>>0);if(!I)break;else{K=K+s|0;D=D+i|0;L=L+o|0;I=I+-1|0}}}}else{do if(!c){n[v>>2]=+n[e>>2]*+n[r>>2];I=y+-2|0;L=(I|0)==0;if(!L){D=1;do{K=e+(Y(D,s)|0)|0;M=+n[K>>2];K=D+1|0;w=e+(Y(K,s)|0)|0;P=+n[w>>2];w=r+(Y(D,i)|0)|0;O=+n[w>>2];w=r+(Y(K,i)|0)|0;J=-+n[w>>2];w=v+(Y(D,o)|0)|0;n[w>>2]=M*O-P*J;w=v+(Y(K,o)|0)|0;n[w>>2]=P*O+M*J;D=D+2|0}while(D>>>0<=I>>>0);if(!(y&1)){Z=y+-1|0;G=144}}else{Z=1;G=144}if((G|0)==144){D=v+(Y(Z,o)|0)|0;w=r+(Y(Z,i)|0)|0;K=e+(Y(Z,s)|0)|0;n[D>>2]=+n[K>>2]*+n[w>>2]}if(B){w=e+(A<<2)+-4|0;K=r+(A<<2)+-4|0;D=v+(A<<2)+-4|0;n[D>>2]=+n[w>>2]*+n[K>>2];if(!L){R=1;do{N=w+(Y(R,s)|0)|0;J=+n[N>>2];N=R+1|0;z=w+(Y(N,s)|0)|0;M=+n[z>>2];z=K+(Y(R,i)|0)|0;O=+n[z>>2];z=K+(Y(N,i)|0)|0;P=-+n[z>>2];z=D+(Y(R,o)|0)|0;n[z>>2]=J*O-M*P;z=D+(Y(N,o)|0)|0;n[z>>2]=M*O+J*P;R=R+2|0}while(R>>>0<=I>>>0);if(!(y&1))_=y+-1|0;else break}else _=1;I=D+(Y(_,o)|0)|0;R=K+(Y(_,i)|0)|0;L=w+(Y(_,s)|0)|0;n[I>>2]=+n[L>>2]*+n[R>>2]}}while(0);R=t&H;L=y+-1|0;if(!y)break;I=x>>>0<C>>>0;z=R&B;if(!R){if(I){$=e;aa=r;ba=v;ca=L}else break;while(1){R=x;do{P=+n[$+(R<<2)>>2];N=R+1|0;J=+n[$+(N<<2)>>2];O=+n[aa+(R<<2)>>2];M=-+n[aa+(N<<2)>>2];n[ba+(R<<2)>>2]=P*O-J*M;n[ba+(N<<2)>>2]=J*O+P*M;R=R+2|0}while(R>>>0<C>>>0);if(!ca)break a;else{$=$+s|0;aa=aa+i|0;ba=ba+o|0;ca=ca+-1|0}}}if(!I)if(z){R=e;w=r;K=v;D=L;while(1){n[K>>2]=+n[R>>2]*+n[w>>2];n[K+(C<<2)>>2]=+n[R+(C<<2)>>2]*+n[w+(C<<2)>>2];if(!D)break a;else{R=R+s|0;w=w+i|0;K=K+o|0;D=D+-1|0}}}else{D=e;K=r;w=v;R=L;while(1){n[w>>2]=+n[D>>2]*+n[K>>2];if(!R)break a;else{D=D+s|0;K=K+i|0;w=w+o|0;R=R+-1|0}}}if(z){R=e;w=r;K=v;D=L;while(1){n[K>>2]=+n[R>>2]*+n[w>>2];I=x;do{M=+n[R+(I<<2)>>2];N=I+1|0;P=+n[R+(N<<2)>>2];O=+n[w+(I<<2)>>2];J=-+n[w+(N<<2)>>2];n[K+(I<<2)>>2]=M*O-P*J;n[K+(N<<2)>>2]=P*O+M*J;I=I+2|0}while(I>>>0<C>>>0);n[K+(C<<2)>>2]=+n[R+(C<<2)>>2]*+n[w+(C<<2)>>2];if(!D)break;else{R=R+s|0;w=w+i|0;K=K+o|0;D=D+-1|0}}}else{D=e;K=r;w=v;R=L;while(1){n[w>>2]=+n[D>>2]*+n[K>>2];z=x;do{J=+n[D+(z<<2)>>2];I=z+1|0;M=+n[D+(I<<2)>>2];O=+n[K+(z<<2)>>2];P=-+n[K+(I<<2)>>2];n[w+(z<<2)>>2]=J*O-M*P;n[w+(I<<2)>>2]=M*O+J*P;z=z+2|0}while(z>>>0<C>>>0);if(!R)break;else{D=D+s|0;K=K+i|0;w=w+o|0;R=R+-1|0}}}}else if(F){do if(!c){n[e>>2]=+n[e>>2]*+n[r>>2];R=y+-2|0;w=(R|0)==0;if(!w){K=1;do{D=e+(Y(K,o)|0)|0;P=+n[D>>2];L=K+1|0;z=e+(Y(L,o)|0)|0;J=+n[z>>2];I=r+(Y(K,i)|0)|0;O=+n[I>>2];I=r+(Y(L,i)|0)|0;M=+n[I>>2];n[D>>2]=P*O-J*M;n[z>>2]=J*O+P*M;K=K+2|0}while(K>>>0<=R>>>0);if(!(y&1)){da=y+-1|0;G=62}}else{da=1;G=62}if((G|0)==62){K=e+(Y(da,o)|0)|0;z=r+(Y(da,i)|0)|0;n[K>>2]=+n[K>>2]*+n[z>>2]}if(B){z=r+(A<<2)+-4|0;K=e+(A<<2)+-4|0;n[K>>2]=+n[K>>2]*+n[z>>2];if(!w){D=1;do{I=K+(Y(D,o)|0)|0;M=+n[I>>2];L=D+1|0;N=K+(Y(L,o)|0)|0;P=+n[N>>2];X=z+(Y(D,i)|0)|0;O=+n[X>>2];X=z+(Y(L,i)|0)|0;J=+n[X>>2];n[I>>2]=M*O-P*J;n[N>>2]=P*O+M*J;D=D+2|0}while(D>>>0<=R>>>0);if(!(y&1))ea=y+-1|0;else break}else ea=1;R=K+(Y(ea,o)|0)|0;D=z+(Y(ea,i)|0)|0;n[R>>2]=+n[R>>2]*+n[D>>2]}}while(0);F=t&H;D=y+-1|0;if(!y)break;R=x>>>0<C>>>0;w=F&B;if(!F){if(R){fa=e;ga=r;ha=D}else break;while(1){F=x;do{N=fa+(F<<2)|0;J=+n[N>>2];I=F+1|0;X=fa+(I<<2)|0;M=+n[X>>2];O=+n[ga+(F<<2)>>2];P=+n[ga+(I<<2)>>2];n[N>>2]=J*O-M*P;n[X>>2]=M*O+J*P;F=F+2|0}while(F>>>0<C>>>0);if(!ha)break a;else{fa=fa+o|0;ga=ga+i|0;ha=ha+-1|0}}}if(!R)if(w){F=e;z=r;K=e;X=D;while(1){n[K>>2]=+n[F>>2]*+n[z>>2];n[K+(C<<2)>>2]=+n[F+(C<<2)>>2]*+n[z+(C<<2)>>2];if(!X)break a;else{F=F+s|0;z=z+i|0;K=K+o|0;X=X+-1|0}}}else{X=e;K=r;z=e;F=D;while(1){n[z>>2]=+n[X>>2]*+n[K>>2];if(!F)break a;else{X=X+s|0;K=K+i|0;z=z+o|0;F=F+-1|0}}}if(w){F=e;z=r;K=e;X=D;while(1){n[K>>2]=+n[F>>2]*+n[z>>2];R=x;do{N=K+(R<<2)|0;P=+n[N>>2];I=R+1|0;L=K+(I<<2)|0;J=+n[L>>2];O=+n[z+(R<<2)>>2];M=+n[z+(I<<2)>>2];n[N>>2]=P*O-J*M;n[L>>2]=J*O+P*M;R=R+2|0}while(R>>>0<C>>>0);n[K+(C<<2)>>2]=+n[F+(C<<2)>>2]*+n[z+(C<<2)>>2];if(!X)break;else{F=F+s|0;z=z+i|0;K=K+o|0;X=X+-1|0}}}else{X=e;K=r;z=e;F=D;while(1){n[z>>2]=+n[X>>2]*+n[K>>2];w=x;do{R=z+(w<<2)|0;M=+n[R>>2];L=w+1|0;N=z+(L<<2)|0;P=+n[N>>2];O=+n[K+(w<<2)>>2];J=+n[K+(L<<2)>>2];n[R>>2]=M*O-P*J;n[N>>2]=P*O+M*J;w=w+2|0}while(w>>>0<C>>>0);if(!F)break;else{X=X+s|0;K=K+i|0;z=z+o|0;F=F+-1|0}}}}else{do if(!c){n[v>>2]=+n[e>>2]*+n[r>>2];F=y+-2|0;z=(F|0)==0;if(!z){K=1;do{X=e+(Y(K,s)|0)|0;J=+n[X>>2];X=K+1|0;D=e+(Y(X,s)|0)|0;M=+n[D>>2];D=r+(Y(K,i)|0)|0;O=+n[D>>2];D=r+(Y(X,i)|0)|0;P=+n[D>>2];D=v+(Y(K,o)|0)|0;n[D>>2]=J*O-M*P;D=v+(Y(X,o)|0)|0;n[D>>2]=M*O+J*P;K=K+2|0}while(K>>>0<=F>>>0);if(!(y&1)){ia=y+-1|0;G=89}}else{ia=1;G=89}if((G|0)==89){K=v+(Y(ia,o)|0)|0;D=r+(Y(ia,i)|0)|0;X=e+(Y(ia,s)|0)|0;n[K>>2]=+n[X>>2]*+n[D>>2]}if(B){D=e+(A<<2)+-4|0;X=r+(A<<2)+-4|0;K=v+(A<<2)+-4|0;n[K>>2]=+n[D>>2]*+n[X>>2];if(!z){w=1;do{N=D+(Y(w,s)|0)|0;P=+n[N>>2];N=w+1|0;R=D+(Y(N,s)|0)|0;J=+n[R>>2];R=X+(Y(w,i)|0)|0;O=+n[R>>2];R=X+(Y(N,i)|0)|0;M=+n[R>>2];R=K+(Y(w,o)|0)|0;n[R>>2]=P*O-J*M;R=K+(Y(N,o)|0)|0;n[R>>2]=J*O+P*M;w=w+2|0}while(w>>>0<=F>>>0);if(!(y&1))ja=y+-1|0;else break}else ja=1;F=K+(Y(ja,o)|0)|0;w=X+(Y(ja,i)|0)|0;z=D+(Y(ja,s)|0)|0;n[F>>2]=+n[z>>2]*+n[w>>2]}}while(0);c=t&H;w=y+-1|0;if(!y)break;z=x>>>0<C>>>0;F=c&B;if(!c){if(z){ka=e;la=r;ma=v;na=w}else break;while(1){c=x;do{M=+n[ka+(c<<2)>>2];R=c+1|0;P=+n[ka+(R<<2)>>2];O=+n[la+(c<<2)>>2];J=+n[la+(R<<2)>>2];n[ma+(c<<2)>>2]=M*O-P*J;n[ma+(R<<2)>>2]=P*O+M*J;c=c+2|0}while(c>>>0<C>>>0);if(!na)break a;else{ka=ka+s|0;la=la+i|0;ma=ma+o|0;na=na+-1|0}}}if(!z)if(F){c=e;D=r;X=v;K=w;while(1){n[X>>2]=+n[c>>2]*+n[D>>2];n[X+(C<<2)>>2]=+n[c+(C<<2)>>2]*+n[D+(C<<2)>>2];if(!K)break a;else{c=c+s|0;D=D+i|0;X=X+o|0;K=K+-1|0}}}else{K=e;X=r;D=v;c=w;while(1){n[D>>2]=+n[K>>2]*+n[X>>2];if(!c)break a;else{K=K+s|0;X=X+i|0;D=D+o|0;c=c+-1|0}}}if(F){c=e;D=r;X=v;K=w;while(1){n[X>>2]=+n[c>>2]*+n[D>>2];z=x;do{J=+n[c+(z<<2)>>2];R=z+1|0;M=+n[c+(R<<2)>>2];O=+n[D+(z<<2)>>2];P=+n[D+(R<<2)>>2];n[X+(z<<2)>>2]=J*O-M*P;n[X+(R<<2)>>2]=M*O+J*P;z=z+2|0}while(z>>>0<C>>>0);n[X+(C<<2)>>2]=+n[c+(C<<2)>>2]*+n[D+(C<<2)>>2];if(!K)break;else{c=c+s|0;D=D+i|0;X=X+o|0;K=K+-1|0}}}else{K=e;X=r;D=v;c=w;while(1){n[D>>2]=+n[K>>2]*+n[X>>2];F=x;do{P=+n[K+(F<<2)>>2];z=F+1|0;J=+n[K+(z<<2)>>2];O=+n[X+(F<<2)>>2];M=+n[X+(z<<2)>>2];n[D+(F<<2)>>2]=P*O-J*M;n[D+(z<<2)>>2]=J*O+P*M;F=F+2|0}while(F>>>0<C>>>0);if(!c)break;else{K=K+s|0;X=X+i|0;D=D+o|0;c=c+-1|0}}}}}else{c=f[d>>2]|0;o=f[E>>2]|0;D=f[k+48>>2]|0;i=f[l+48>>2]|0;X=f[m+48>>2]|0;s=(e|0)==(o|0);K=H|t^1;if(g)if(s){do if(!K){p[e>>3]=+p[e>>3]*+p[c>>3];w=y+-2|0;v=(w|0)==0;if(!v){r=1;do{F=e+(Y(r,X)|0)|0;M=+p[F>>3];z=r+1|0;R=e+(Y(z,X)|0)|0;P=+p[R>>3];N=c+(Y(r,i)|0)|0;O=+p[N>>3];N=c+(Y(z,i)|0)|0;J=-+p[N>>3];p[F>>3]=M*O-P*J;p[R>>3]=P*O+M*J;r=r+2|0}while(r>>>0<=w>>>0);if(!(y&1)){oa=y+-1|0;G=228}}else{oa=1;G=228}if((G|0)==228){r=e+(Y(oa,X)|0)|0;R=c+(Y(oa,i)|0)|0;p[r>>3]=+p[r>>3]*+p[R>>3]}if(B){R=c+(A<<3)+-8|0;r=e+(A<<3)+-8|0;p[r>>3]=+p[r>>3]*+p[R>>3];if(!v){F=1;do{N=r+(Y(F,X)|0)|0;J=+p[N>>3];z=F+1|0;L=r+(Y(z,X)|0)|0;M=+p[L>>3];I=R+(Y(F,i)|0)|0;O=+p[I>>3];I=R+(Y(z,i)|0)|0;P=-+p[I>>3];p[N>>3]=J*O-M*P;p[L>>3]=M*O+J*P;F=F+2|0}while(F>>>0<=w>>>0);if(!(y&1))pa=y+-1|0;else break}else pa=1;w=r+(Y(pa,X)|0)|0;F=R+(Y(pa,i)|0)|0;p[w>>3]=+p[w>>3]*+p[F>>3]}}while(0);F=t&H;w=y+-1|0;if(!y)break;v=x>>>0<C>>>0;L=F&B;if(!F){if(v){qa=e;ra=c;sa=w}else break;while(1){F=x;do{N=qa+(F<<3)|0;P=+p[N>>3];I=F+1|0;z=qa+(I<<3)|0;J=+p[z>>3];O=+p[ra+(F<<3)>>3];M=-+p[ra+(I<<3)>>3];p[N>>3]=P*O-J*M;p[z>>3]=J*O+P*M;F=F+2|0}while(F>>>0<C>>>0);if(!sa)break a;else{qa=qa+X|0;ra=ra+i|0;sa=sa+-1|0}}}if(!v)if(L){F=e;R=c;r=e;z=w;while(1){p[r>>3]=+p[F>>3]*+p[R>>3];p[r+(C<<3)>>3]=+p[F+(C<<3)>>3]*+p[R+(C<<3)>>3];if(!z)break a;else{F=F+D|0;R=R+i|0;r=r+X|0;z=z+-1|0}}}else{z=e;r=c;R=e;F=w;while(1){p[R>>3]=+p[z>>3]*+p[r>>3];if(!F)break a;else{z=z+D|0;r=r+i|0;R=R+X|0;F=F+-1|0}}}if(L){F=e;R=c;r=e;z=w;while(1){p[r>>3]=+p[F>>3]*+p[R>>3];v=x;do{N=r+(v<<3)|0;M=+p[N>>3];I=v+1|0;S=r+(I<<3)|0;P=+p[S>>3];O=+p[R+(v<<3)>>3];J=-+p[R+(I<<3)>>3];p[N>>3]=M*O-P*J;p[S>>3]=P*O+M*J;v=v+2|0}while(v>>>0<C>>>0);p[r+(C<<3)>>3]=+p[F+(C<<3)>>3]*+p[R+(C<<3)>>3];if(!z)break;else{F=F+D|0;R=R+i|0;r=r+X|0;z=z+-1|0}}}else{z=e;r=c;R=e;F=w;while(1){p[R>>3]=+p[z>>3]*+p[r>>3];L=x;do{v=R+(L<<3)|0;J=+p[v>>3];S=L+1|0;N=R+(S<<3)|0;M=+p[N>>3];O=+p[r+(L<<3)>>3];P=-+p[r+(S<<3)>>3];p[v>>3]=J*O-M*P;p[N>>3]=M*O+J*P;L=L+2|0}while(L>>>0<C>>>0);if(!F)break;else{z=z+D|0;r=r+i|0;R=R+X|0;F=F+-1|0}}}}else{do if(!K){p[o>>3]=+p[e>>3]*+p[c>>3];F=y+-2|0;R=(F|0)==0;if(!R){r=1;do{z=e+(Y(r,D)|0)|0;P=+p[z>>3];z=r+1|0;w=e+(Y(z,D)|0)|0;J=+p[w>>3];w=c+(Y(r,i)|0)|0;O=+p[w>>3];w=c+(Y(z,i)|0)|0;M=-+p[w>>3];w=o+(Y(r,X)|0)|0;p[w>>3]=P*O-J*M;w=o+(Y(z,X)|0)|0;p[w>>3]=J*O+P*M;r=r+2|0}while(r>>>0<=F>>>0);if(!(y&1)){ta=y+-1|0;G=255}}else{ta=1;G=255}if((G|0)==255){r=o+(Y(ta,X)|0)|0;w=c+(Y(ta,i)|0)|0;z=e+(Y(ta,D)|0)|0;p[r>>3]=+p[z>>3]*+p[w>>3]}if(B){w=e+(A<<3)+-8|0;z=c+(A<<3)+-8|0;r=o+(A<<3)+-8|0;p[r>>3]=+p[w>>3]*+p[z>>3];if(!R){L=1;do{N=w+(Y(L,D)|0)|0;M=+p[N>>3];N=L+1|0;v=w+(Y(N,D)|0)|0;P=+p[v>>3];v=z+(Y(L,i)|0)|0;O=+p[v>>3];v=z+(Y(N,i)|0)|0;J=-+p[v>>3];v=r+(Y(L,X)|0)|0;p[v>>3]=M*O-P*J;v=r+(Y(N,X)|0)|0;p[v>>3]=P*O+M*J;L=L+2|0}while(L>>>0<=F>>>0);if(!(y&1))ua=y+-1|0;else break}else ua=1;F=r+(Y(ua,X)|0)|0;L=z+(Y(ua,i)|0)|0;R=w+(Y(ua,D)|0)|0;p[F>>3]=+p[R>>3]*+p[L>>3]}}while(0);L=t&H;R=y+-1|0;if(!y)break;F=x>>>0<C>>>0;v=L&B;if(!L){if(F){va=e;wa=c;xa=o;ya=R}else break;while(1){L=x;do{J=+p[va+(L<<3)>>3];N=L+1|0;M=+p[va+(N<<3)>>3];O=+p[wa+(L<<3)>>3];P=-+p[wa+(N<<3)>>3];p[xa+(L<<3)>>3]=J*O-M*P;p[xa+(N<<3)>>3]=M*O+J*P;L=L+2|0}while(L>>>0<C>>>0);if(!ya)break a;else{va=va+D|0;wa=wa+i|0;xa=xa+X|0;ya=ya+-1|0}}}if(!F)if(v){L=e;w=c;z=o;r=R;while(1){p[z>>3]=+p[L>>3]*+p[w>>3];p[z+(C<<3)>>3]=+p[L+(C<<3)>>3]*+p[w+(C<<3)>>3];if(!r)break a;else{L=L+D|0;w=w+i|0;z=z+X|0;r=r+-1|0}}}else{r=e;z=c;w=o;L=R;while(1){p[w>>3]=+p[r>>3]*+p[z>>3];if(!L)break a;else{r=r+D|0;z=z+i|0;w=w+X|0;L=L+-1|0}}}if(v){L=e;w=c;z=o;r=R;while(1){p[z>>3]=+p[L>>3]*+p[w>>3];F=x;do{P=+p[L+(F<<3)>>3];N=F+1|0;J=+p[L+(N<<3)>>3];O=+p[w+(F<<3)>>3];M=-+p[w+(N<<3)>>3];p[z+(F<<3)>>3]=P*O-J*M;p[z+(N<<3)>>3]=J*O+P*M;F=F+2|0}while(F>>>0<C>>>0);p[z+(C<<3)>>3]=+p[L+(C<<3)>>3]*+p[w+(C<<3)>>3];if(!r)break;else{L=L+D|0;w=w+i|0;z=z+X|0;r=r+-1|0}}}else{r=e;z=c;w=o;L=R;while(1){p[w>>3]=+p[r>>3]*+p[z>>3];v=x;do{M=+p[r+(v<<3)>>3];F=v+1|0;P=+p[r+(F<<3)>>3];O=+p[z+(v<<3)>>3];J=-+p[z+(F<<3)>>3];p[w+(v<<3)>>3]=M*O-P*J;p[w+(F<<3)>>3]=P*O+M*J;v=v+2|0}while(v>>>0<C>>>0);if(!L)break;else{r=r+D|0;z=z+i|0;w=w+X|0;L=L+-1|0}}}}else if(s){do if(!K){p[e>>3]=+p[e>>3]*+p[c>>3];L=y+-2|0;w=(L|0)==0;if(!w){z=1;do{r=e+(Y(z,X)|0)|0;J=+p[r>>3];R=z+1|0;v=e+(Y(R,X)|0)|0;M=+p[v>>3];F=c+(Y(z,i)|0)|0;O=+p[F>>3];F=c+(Y(R,i)|0)|0;P=+p[F>>3];p[r>>3]=J*O-M*P;p[v>>3]=M*O+J*P;z=z+2|0}while(z>>>0<=L>>>0);if(!(y&1)){za=y+-1|0;G=173}}else{za=1;G=173}if((G|0)==173){z=e+(Y(za,X)|0)|0;v=c+(Y(za,i)|0)|0;p[z>>3]=+p[z>>3]*+p[v>>3]}if(B){v=c+(A<<3)+-8|0;z=e+(A<<3)+-8|0;p[z>>3]=+p[z>>3]*+p[v>>3];if(!w){r=1;do{F=z+(Y(r,X)|0)|0;P=+p[F>>3];R=r+1|0;N=z+(Y(R,X)|0)|0;J=+p[N>>3];S=v+(Y(r,i)|0)|0;O=+p[S>>3];S=v+(Y(R,i)|0)|0;M=+p[S>>3];p[F>>3]=P*O-J*M;p[N>>3]=J*O+P*M;r=r+2|0}while(r>>>0<=L>>>0);if(!(y&1))Aa=y+-1|0;else break}else Aa=1;L=z+(Y(Aa,X)|0)|0;r=v+(Y(Aa,i)|0)|0;p[L>>3]=+p[L>>3]*+p[r>>3]}}while(0);s=t&H;r=y+-1|0;if(!y)break;L=x>>>0<C>>>0;w=s&B;if(!s){if(L){Ba=e;Ca=c;Da=r}else break;while(1){s=x;do{N=Ba+(s<<3)|0;M=+p[N>>3];F=s+1|0;S=Ba+(F<<3)|0;P=+p[S>>3];O=+p[Ca+(s<<3)>>3];J=+p[Ca+(F<<3)>>3];p[N>>3]=M*O-P*J;p[S>>3]=P*O+M*J;s=s+2|0}while(s>>>0<C>>>0);if(!Da)break a;else{Ba=Ba+X|0;Ca=Ca+i|0;Da=Da+-1|0}}}if(!L)if(w){s=e;v=c;z=e;S=r;while(1){p[z>>3]=+p[s>>3]*+p[v>>3];p[z+(C<<3)>>3]=+p[s+(C<<3)>>3]*+p[v+(C<<3)>>3];if(!S)break a;else{s=s+D|0;v=v+i|0;z=z+X|0;S=S+-1|0}}}else{S=e;z=c;v=e;s=r;while(1){p[v>>3]=+p[S>>3]*+p[z>>3];if(!s)break a;else{S=S+D|0;z=z+i|0;v=v+X|0;s=s+-1|0}}}if(w){s=e;v=c;z=e;S=r;while(1){p[z>>3]=+p[s>>3]*+p[v>>3];L=x;do{N=z+(L<<3)|0;J=+p[N>>3];F=L+1|0;R=z+(F<<3)|0;M=+p[R>>3];O=+p[v+(L<<3)>>3];P=+p[v+(F<<3)>>3];p[N>>3]=J*O-M*P;p[R>>3]=M*O+J*P;L=L+2|0}while(L>>>0<C>>>0);p[z+(C<<3)>>3]=+p[s+(C<<3)>>3]*+p[v+(C<<3)>>3];if(!S)break;else{s=s+D|0;v=v+i|0;z=z+X|0;S=S+-1|0}}}else{S=e;z=c;v=e;s=r;while(1){p[v>>3]=+p[S>>3]*+p[z>>3];w=x;do{L=v+(w<<3)|0;P=+p[L>>3];R=w+1|0;N=v+(R<<3)|0;J=+p[N>>3];O=+p[z+(w<<3)>>3];M=+p[z+(R<<3)>>3];p[L>>3]=P*O-J*M;p[N>>3]=J*O+P*M;w=w+2|0}while(w>>>0<C>>>0);if(!s)break;else{S=S+D|0;z=z+i|0;v=v+X|0;s=s+-1|0}}}}else{do if(!K){p[o>>3]=+p[e>>3]*+p[c>>3];s=y+-2|0;v=(s|0)==0;if(!v){z=1;do{S=e+(Y(z,D)|0)|0;M=+p[S>>3];S=z+1|0;r=e+(Y(S,D)|0)|0;P=+p[r>>3];r=c+(Y(z,i)|0)|0;O=+p[r>>3];r=c+(Y(S,i)|0)|0;J=+p[r>>3];r=o+(Y(z,X)|0)|0;p[r>>3]=M*O-P*J;r=o+(Y(S,X)|0)|0;p[r>>3]=P*O+M*J;z=z+2|0}while(z>>>0<=s>>>0);if(!(y&1)){Ea=y+-1|0;G=200}}else{Ea=1;G=200}if((G|0)==200){z=o+(Y(Ea,X)|0)|0;r=c+(Y(Ea,i)|0)|0;S=e+(Y(Ea,D)|0)|0;p[z>>3]=+p[S>>3]*+p[r>>3]}if(B){r=e+(A<<3)+-8|0;S=c+(A<<3)+-8|0;z=o+(A<<3)+-8|0;p[z>>3]=+p[r>>3]*+p[S>>3];if(!v){w=1;do{N=r+(Y(w,D)|0)|0;J=+p[N>>3];N=w+1|0;L=r+(Y(N,D)|0)|0;M=+p[L>>3];L=S+(Y(w,i)|0)|0;O=+p[L>>3];L=S+(Y(N,i)|0)|0;P=+p[L>>3];L=z+(Y(w,X)|0)|0;p[L>>3]=J*O-M*P;L=z+(Y(N,X)|0)|0;p[L>>3]=M*O+J*P;w=w+2|0}while(w>>>0<=s>>>0);if(!(y&1))Fa=y+-1|0;else break}else Fa=1;s=z+(Y(Fa,X)|0)|0;w=S+(Y(Fa,i)|0)|0;v=r+(Y(Fa,D)|0)|0;p[s>>3]=+p[v>>3]*+p[w>>3]}}while(0);K=t&H;w=y+-1|0;if(!y)break;v=x>>>0<C>>>0;s=K&B;if(!K){if(v){Ga=e;Ha=c;Ia=o;Ja=w}else break;while(1){K=x;do{P=+p[Ga+(K<<3)>>3];L=K+1|0;J=+p[Ga+(L<<3)>>3];O=+p[Ha+(K<<3)>>3];M=+p[Ha+(L<<3)>>3];p[Ia+(K<<3)>>3]=P*O-J*M;p[Ia+(L<<3)>>3]=J*O+P*M;K=K+2|0}while(K>>>0<C>>>0);if(!Ja)break a;else{Ga=Ga+D|0;Ha=Ha+i|0;Ia=Ia+X|0;Ja=Ja+-1|0}}}if(!v)if(s){K=e;r=c;S=o;z=w;while(1){p[S>>3]=+p[K>>3]*+p[r>>3];p[S+(C<<3)>>3]=+p[K+(C<<3)>>3]*+p[r+(C<<3)>>3];if(!z)break a;else{K=K+D|0;r=r+i|0;S=S+X|0;z=z+-1|0}}}else{z=e;S=c;r=o;K=w;while(1){p[r>>3]=+p[z>>3]*+p[S>>3];if(!K)break a;else{z=z+D|0;S=S+i|0;r=r+X|0;K=K+-1|0}}}if(s){K=e;r=c;S=o;z=w;while(1){p[S>>3]=+p[K>>3]*+p[r>>3];v=x;do{M=+p[K+(v<<3)>>3];L=v+1|0;P=+p[K+(L<<3)>>3];O=+p[r+(v<<3)>>3];J=+p[r+(L<<3)>>3];p[S+(v<<3)>>3]=M*O-P*J;p[S+(L<<3)>>3]=P*O+M*J;v=v+2|0}while(v>>>0<C>>>0);p[S+(C<<3)>>3]=+p[K+(C<<3)>>3]*+p[r+(C<<3)>>3];if(!z)break;else{K=K+D|0;r=r+i|0;S=S+X|0;z=z+-1|0}}}else{z=e;S=c;r=o;K=w;while(1){p[r>>3]=+p[z>>3]*+p[S>>3];s=x;do{J=+p[z+(s<<3)>>3];v=s+1|0;M=+p[z+(v<<3)>>3];O=+p[S+(s<<3)>>3];P=+p[S+(v<<3)>>3];p[r+(s<<3)>>3]=J*O-M*P;p[r+(v<<3)>>3]=M*O+J*P;s=s+2|0}while(s>>>0<C>>>0);if(!K)break;else{z=z+D|0;S=S+i|0;r=r+X|0;K=K+-1|0}}}}}while(0);C=m+36|0;x=f[C>>2]|0;if(x|0?(e=x+12|0,x=f[e>>2]|0,f[e>>2]=x+-1,(x|0)==1):0)kL(m);f[C>>2]=0;C=m+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[C>>2]|0)>0){E=f[m+40>>2]|0;x=0;do{f[E+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[C>>2]|0))}C=f[m+44>>2]|0;if((C|0)!=(m+48|0))UC(C);C=l+36|0;m=f[C>>2]|0;if(m|0?(x=m+12|0,m=f[x>>2]|0,f[x>>2]=m+-1,(m|0)==1):0)kL(l);f[C>>2]=0;C=l+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[C>>2]|0)>0){d=f[l+40>>2]|0;m=0;do{f[d+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[C>>2]|0))}C=f[l+44>>2]|0;if((C|0)!=(l+48|0))UC(C);C=k+36|0;l=f[C>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)kL(k);f[C>>2]=0;C=k+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[C>>2]|0)>0){q=f[k+40>>2]|0;l=0;do{f[q+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[C>>2]|0))}C=f[k+44>>2]|0;if((C|0)!=(k+48|0))UC(C);if(!(f[j+4>>2]|0)){u=h;return}u=h;return}function SC(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;if(a>>>0>2125763999){b=-1;return b|0}else{c=1650;d=0}do{e=c+d>>1;g=(f[33304+(e<<2)>>2]|0)<(a|0);d=g?e+1|0:d;c=g?c:e}while((d|0)<(c|0));b=f[33304+(c<<2)>>2]|0;return b|0}function TC(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;d=b+16|0;e=b+8|0;f[e>>2]=0;if(!(USb(e,64,a)|0)){g=f[e>>2]|0;if(g|0){h=g;u=b;return h|0}}else f[e>>2]=0;e=c;f[e>>2]=a;f[e+4>>2]=0;hO(d,171360,c);bO(-4,d,171390,171407,55);bD(d);h=0;u=b;return h|0}function UC(a){a=a|0;PSb(a);return}function VC(a){a=a|0;return TC(a)|0}function WC(a){a=a|0;PSb(a);return}function XC(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0.0,hc=0,ic=0.0,jc=0,kc=0.0,lc=0,mc=0.0,nc=0,oc=0,pc=0,qc=0,rc=0.0,sc=0,tc=0.0,uc=0,vc=0.0,wc=0,xc=0.0,yc=0,zc=0.0,Ac=0,Bc=0,Cc=0.0,Dc=0,Ec=0,Fc=0,Gc=0.0,Hc=0,Ic=0.0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0.0,Tc=0,Uc=0,Vc=0,Wc=0.0,Xc=0,Yc=0,Zc=0.0,_c=0,$c=0.0,ad=0,bd=0,cd=0.0,dd=0.0,ed=0,fd=0.0,gd=0,hd=0,id=0.0,jd=0,kd=0,ld=0.0,md=0,nd=0,od=0.0,pd=0.0;j=u;u=u+688|0;k=j+32|0;l=j+624|0;m=j+608|0;o=j+600|0;q=j+568|0;r=j+560|0;t=j+504|0;v=j+448|0;w=j+392|0;x=j+336|0;y=j+280|0;z=j+224|0;A=j+168|0;B=j+156|0;C=j+144|0;D=j+88|0;E=j;dQ(r,39908);do if((yM(a)|0)==65536){F=f[a+4>>2]|0;f[t>>2]=f[F>>2];G=t+4|0;H=F+4|0;f[G>>2]=f[H>>2];I=t+8|0;f[I>>2]=f[F+8>>2];K=t+12|0;f[K>>2]=f[F+12>>2];f[t+16>>2]=f[F+16>>2];f[t+20>>2]=f[F+20>>2];f[t+24>>2]=f[F+24>>2];f[t+28>>2]=f[F+28>>2];f[t+32>>2]=f[F+32>>2];L=f[F+36>>2]|0;f[t+36>>2]=L;f[t+40>>2]=I;M=t+48|0;N=t+44|0;f[N>>2]=M;f[M>>2]=0;f[t+52>>2]=0;if(L|0){M=L+12|0;f[M>>2]=(f[M>>2]|0)+1}if((f[H>>2]|0)<3){H=f[F+44>>2]|0;M=f[N>>2]|0;f[M>>2]=f[H>>2];f[M+4>>2]=f[H+4>>2];O=I;P=K;Q=t;R=G;break}else{f[G>>2]=0;jL(t,F);O=I;P=K;Q=t;R=G;break}}else{yL(t,a,-1);O=t+8|0;P=t+12|0;Q=t;R=t+4|0}while(0);a=f[O>>2]|0;O=(a|0)==1;G=f[P>>2]|0;P=O?G:a;a=f[Q>>2]|0;Q=Y((a>>>3&511)+1|0,O?1:G)|0;G=a&7;a=(g|0)>1?g:1;g=(c|0)>0;if(!(g&((f[R>>2]|0)<3&(G|0)==5))){f[k>>2]=0;f[k+4>>2]=0;S=aD(k,37)|0;T=171474;U=S+37|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));bO(-215,k,171512,171519,243);bD(k)}if((P|0)<(c|0)){f[k>>2]=0;f[k+4>>2]=0;K=aD(k,6)|0;b[K>>0]=b[171587]|0;b[K+1>>0]=b[171588]|0;b[K+2>>0]=b[171589]|0;b[K+3>>0]=b[171590]|0;b[K+4>>0]=b[171591]|0;b[K+5>>0]=b[171592]|0;bO(-215,k,171512,171519,244);bD(k)}K=t+16|0;I=t+44|0;F=t+48|0;Qi(v,P,Q,5,f[K>>2]|0,O?Q<<2:f[F>>2]|0);aM(d,P,1,4,-1,1,0);f[w>>2]=1124007936;O=w+4|0;H=w+8|0;M=w+40|0;S=O;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[M>>2]=H;N=w+48|0;L=w+44|0;f[L>>2]=N;f[N>>2]=0;f[w+52>>2]=0;do if((yM(d)|0)==65536){V=f[d+4>>2]|0;f[x>>2]=f[V>>2];W=x+4|0;X=V+4|0;f[W>>2]=f[X>>2];Z=x+8|0;f[Z>>2]=f[V+8>>2];_=x+12|0;f[_>>2]=f[V+12>>2];f[x+16>>2]=f[V+16>>2];f[x+20>>2]=f[V+20>>2];f[x+24>>2]=f[V+24>>2];f[x+28>>2]=f[V+28>>2];f[x+32>>2]=f[V+32>>2];$=f[V+36>>2]|0;f[x+36>>2]=$;f[x+40>>2]=Z;aa=x+48|0;ba=x+44|0;f[ba>>2]=aa;f[aa>>2]=0;f[x+52>>2]=0;if($|0){aa=$+12|0;f[aa>>2]=(f[aa>>2]|0)+1}if((f[X>>2]|0)<3){X=f[V+44>>2]|0;aa=f[ba>>2]|0;f[aa>>2]=f[X>>2];f[aa+4>>2]=f[X+4>>2];ca=_;da=Z;break}else{f[W>>2]=0;jL(x,V);ca=_;da=Z;break}}else{yL(x,d,-1);ca=x+12|0;da=x+8|0}while(0);d=(h&1|0)!=0;Z=f[ca>>2]|0;ca=(Z|0)==1;_=f[da>>2]|0;da=(ca|(_|0)==1)&(Y(_,Z)|0)==(P|0);do if(d){if(!(da?(f[x>>2]&20479|0)==16388:0)){f[k>>2]=0;f[k+4>>2]=0;Vac(aD(k,147)|0,171594,147)|0;bO(-215,k,171512,171519,256);bD(k)}Z=k+8|0;f[Z>>2]=0;f[Z+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=w;SP(x,k)}else{if(da?(Z=f[x>>2]|0,(Z&20479|0)==16388):0)ea=Z;else fa=26;do if((fa|0)==26){if((((_|0)==(P|0)?(f[x+4>>2]|0)<3:0)&ca?(Z=f[x>>2]|0,(Z&4095|0)==4):0)?f[x+16>>2]|0:0){ea=Z;break}f[k>>2]=P;f[k+4>>2]=1;hL(x,2,k,4);ea=f[x>>2]|0}while(0);Z=f[x+40>>2]|0;V=f[Z+4>>2]|0;W=f[Z>>2]|0;Z=ea&4095;if(((((f[O>>2]|0)<3?(f[H>>2]|0)==(W|0):0)?(f[w+12>>2]|0)==(V|0):0)?(f[w>>2]&4095|0)==(Z|0):0)?f[w+16>>2]|0:0)break;f[k>>2]=W;f[k+4>>2]=V;hL(w,2,k,Z)}while(0);H=w+16|0;ea=f[H>>2]|0;f[y>>2]=1124007936;ca=y+4|0;_=y+8|0;da=y+40|0;S=ca;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[da>>2]=_;Z=y+48|0;V=y+44|0;f[V>>2]=Z;f[Z>>2]=0;f[y+52>>2]=0;f[k>>2]=c;W=k+4|0;f[W>>2]=Q;hL(y,2,k,G);f[z>>2]=1124007936;X=z+4|0;aa=z+8|0;ba=z+40|0;S=X;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[ba>>2]=aa;aa=z+48|0;$=z+44|0;f[$>>2]=aa;f[aa>>2]=0;f[z+52>>2]=0;f[k>>2]=c;f[W>>2]=Q;hL(z,2,k,G);f[A>>2]=1124007936;ga=A+4|0;ha=A+8|0;ia=A+40|0;S=ga;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[ia>>2]=ha;ha=A+48|0;ja=A+44|0;f[ja>>2]=ha;f[ha>>2]=0;f[A+52>>2]=0;f[k>>2]=1;f[W>>2]=Q;hL(A,2,k,G);f[B>>2]=0;G=B+4|0;f[G>>2]=0;f[B+8>>2]=0;ka=(c|0)==0;do if(!ka)if(c>>>0>1073741823)c4b(B);else{la=c<<2;ma=L5b(la)|0;f[B>>2]=ma;na=ma+(c<<2)|0;f[B+8>>2]=na;Nac(ma|0,0,la|0)|0;f[G>>2]=na;break}while(0);f[C>>2]=0;na=C+4|0;f[na>>2]=0;f[C+8>>2]=0;if(Q|0){if(Q>>>0>536870911)c4b(C);la=L5b(Q<<3)|0;f[na>>2]=la;f[C>>2]=la;f[C+8>>2]=la+(Q<<3);ma=Q;oa=la;pa=la;while(1){qa=oa;f[qa>>2]=0;f[qa+4>>2]=0;qa=pa+8|0;ra=ma+-1|0;if(!ra)break;else{ma=ra;oa=qa;pa=qa}}f[na>>2]=la+(Q<<3)}f[D>>2]=1124007936;la=D+4|0;pa=D+8|0;oa=D+40|0;S=la;U=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(U|0));f[oa>>2]=pa;pa=D+48|0;ma=D+44|0;f[ma>>2]=pa;f[pa>>2]=0;f[D+52>>2]=0;f[k>>2]=1;f[W>>2]=P;hL(D,2,k,6);W=f[C>>2]|0;qa=bG()|0;ra=f[e>>2]|0;sa=e+8|0;if(!(ra&2))ta=1.1920928955078125e-07;else{ua=+p[sa>>3];ta=ua<0.0?0.0:ua}p[sa>>3]=ta*ta;va=e+4|0;if(!(ra&1))wa=100;else{ra=f[va>>2]|0;e=(ra|0)>2?ra:2;wa=(e|0)<100?e:100}e=(c|0)==1;ra=e?1:a;f[va>>2]=e?2:wa;wa=v+16|0;e=f[wa>>2]|0;a=v+44|0;xa=(Q|0)>0;if(xa){ya=0;do{za=f[e+(ya<<2)>>2]|0;f[W+(ya<<3)>>2]=za;f[W+(ya<<3)+4>>2]=za;ya=ya+1|0}while((ya|0)!=(Q|0))}if((P|0)>1?(ya=f[wa>>2]|0,e=f[f[a>>2]>>2]|0,xa):0){za=1;do{Aa=ya+(Y(e,za)|0)|0;Ba=0;do{Ca=f[Aa+(Ba<<2)>>2]|0;f[k>>2]=Ca;Da=W+(Ba<<3)|0;ta=(f[s>>2]=Ca,+n[s>>2]);f[Da>>2]=f[(ta<+n[Da>>2]?k:Da)>>2];Da=W+(Ba<<3)+4|0;f[Da>>2]=f[(+n[Da>>2]<ta?k:Da)>>2];Ba=Ba+1|0}while((Ba|0)!=(Q|0));za=za+1|0}while((za|0)!=(P|0))}a:do if((ra|0)>0){za=(h&2|0)==0;W=y+16|0;e=v+12|0;ya=v+8|0;Ba=v+48|0;Aa=l+4|0;Da=l+8|0;Ca=m+4|0;Ea=m+8|0;Fa=(c|0)>1;Ga=o+4|0;Ha=q+4|0;Ia=q+8|0;Ja=q+12|0;Ka=q+16|0;La=q+20|0;Ma=q+24|0;Na=k+4|0;Na=m+8|0;Oa=c>>>0>1073741823;Pa=c<<2;Qa=l+8|0;Ra=D+16|0;Sa=k+4|0;Ta=l+4|0;Ua=l+8|0;Va=l+12|0;Wa=l+16|0;Xa=l+20|0;Ya=k+8|0;Za=k+12|0;_a=k+4|0;$a=d^1;ab=(P|0)>0;bb=Q+-4|0;cb=(Q|0)<4;db=A+16|0;eb=k+4|0;fb=z+16|0;gb=k+4|0;hb=k+4|0;ib=k+8|0;jb=k+12|0;kb=y+12|0;lb=k+16|0;mb=k+20|0;nb=y+20|0;ob=k+24|0;pb=y+24|0;qb=k+28|0;rb=y+28|0;sb=k+32|0;tb=y+32|0;ub=k+36|0;vb=y+36|0;wb=k+40|0;xb=k+48|0;yb=k+44|0;zb=k+52|0;Ab=l+36|0;Bb=l+4|0;Cb=l+8|0;Db=l+12|0;Eb=l+44|0;Fb=l+16|0;Gb=l+20|0;Hb=l+24|0;Ib=l+28|0;Jb=l+32|0;Kb=l+40|0;Lb=l+48|0;Mb=k+8|0;Nb=k+4|0;Ob=Q&-4;Pb=(P|0)<1;Qb=(Ob|0)<(Q|0);ta=1797693134862315708145274.0e284;Rb=0;b:while(1){Sb=d&(Rb|0)<1;Tb=0;ua=1797693134862315708145274.0e284;while(1){gL(y,z);c:do if((Tb|0)!=0|Sb){if(!((Tb|Rb|0)!=0|$a|Pb)){Ub=0;do{if((f[ea+(Ub<<2)>>2]|0)>>>0>=c>>>0){f[k>>2]=0;f[gb>>2]=0;S=aD(k,33)|0;T=171742;U=S+33|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));bO(-215,k,171512,171519,333);bD(k)}Ub=Ub+1|0}while((Ub|0)<(P|0))};f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;UP(y,k)|0;if(g)Nac(f[B>>2]|0,0,Pa|0)|0;d:do if(ab){Ub=f[wa>>2]|0;Vb=f[a>>2]|0;Wb=f[W>>2]|0;Xb=f[V>>2]|0;Yb=f[B>>2]|0;if(cb){Zb=0;while(1){_b=Ub+(Y(f[Vb>>2]|0,Zb)|0)|0;$b=f[ea+(Zb<<2)>>2]|0;ac=Wb+(Y(f[Xb>>2]|0,$b)|0)|0;if(xa){bc=0;do{cc=ac+(bc<<2)|0;n[cc>>2]=+n[_b+(bc<<2)>>2]+ +n[cc>>2];bc=bc+1|0}while((bc|0)!=(Q|0))}bc=Yb+($b<<2)|0;f[bc>>2]=(f[bc>>2]|0)+1;Zb=Zb+1|0;if((Zb|0)==(P|0))break d}}else dc=0;do{Zb=Ub+(Y(f[Vb>>2]|0,dc)|0)|0;bc=f[ea+(dc<<2)>>2]|0;_b=Wb+(Y(f[Xb>>2]|0,bc)|0)|0;ac=0;do{cc=_b+(ac<<2)|0;ec=ac|1;fc=_b+(ec<<2)|0;gc=+n[fc>>2]+ +n[Zb+(ec<<2)>>2];n[cc>>2]=+n[cc>>2]+ +n[Zb+(ac<<2)>>2];n[fc>>2]=gc;fc=ac|2;cc=_b+(fc<<2)|0;ec=ac|3;hc=_b+(ec<<2)|0;gc=+n[hc>>2]+ +n[Zb+(ec<<2)>>2];n[cc>>2]=+n[cc>>2]+ +n[Zb+(fc<<2)>>2];n[hc>>2]=gc;ac=ac+4|0}while((ac|0)<=(bb|0));if(Qb){ac=Ob;do{$b=_b+(ac<<2)|0;n[$b>>2]=+n[Zb+(ac<<2)>>2]+ +n[$b>>2];ac=ac+1|0}while((ac|0)!=(Q|0))}ac=Yb+(bc<<2)|0;f[ac>>2]=(f[ac>>2]|0)+1;dc=dc+1|0}while((dc|0)!=(P|0))}while(0);Yb=(Tb|0)>0;gc=Yb?0.0:ua;if(!g){ic=gc;break}Xb=f[B>>2]|0;Wb=f[W>>2]|0;Vb=f[V>>2]|0;Ub=f[db>>2]|0;ac=f[wa>>2]|0;Zb=f[a>>2]|0;_b=0;do{$b=Xb+(_b<<2)|0;do if(!(f[$b>>2]|0)){if(Fa){hc=0;fc=1;while(1){cc=(f[Xb+(hc<<2)>>2]|0)<(f[Xb+(fc<<2)>>2]|0)?fc:hc;fc=fc+1|0;if((fc|0)==(c|0)){jc=cc;break}else hc=cc}}else jc=0;hc=f[Vb>>2]|0;fc=Wb+(Y(hc,_b)|0)|0;bc=Wb+(Y(hc,jc)|0)|0;hc=Xb+(jc<<2)|0;cc=f[hc>>2]|0;kc=1.0/+(cc|0);if(xa){ec=0;do{n[Ub+(ec<<2)>>2]=kc*+n[bc+(ec<<2)>>2];ec=ec+1|0}while((ec|0)!=(Q|0))}e:do if(ab){if(xa){lc=-1;mc=0.0;nc=0}else{ec=-1;oc=0;while(1){pc=(f[ea+(oc<<2)>>2]|0)==(jc|0)?oc:ec;oc=oc+1|0;if((oc|0)==(P|0)){qc=pc;break e}else ec=pc}}while(1){if((f[ea+(nc<<2)>>2]|0)==(jc|0)){ec=ac+(Y(f[Zb>>2]|0,nc)|0)|0;oc=0;kc=0.0;do{rc=+n[ec+(oc<<2)>>2]-+n[Ub+(oc<<2)>>2];kc=kc+rc*rc;oc=oc+1|0}while((oc|0)!=(Q|0));rc=kc;oc=!(mc<=rc);sc=oc?lc:nc;tc=oc?mc:rc}else{sc=lc;tc=mc}nc=nc+1|0;if((nc|0)==(P|0)){qc=sc;break}else{lc=sc;mc=tc}}}else qc=-1;while(0);f[hc>>2]=cc+-1;f[$b>>2]=(f[$b>>2]|0)+1;f[ea+(qc<<2)>>2]=_b;oc=ac+(Y(f[Zb>>2]|0,qc)|0)|0;if(xa)uc=0;else break;do{ec=oc+(uc<<2)|0;pc=bc+(uc<<2)|0;n[pc>>2]=+n[pc>>2]-+n[ec>>2];pc=fc+(uc<<2)|0;n[pc>>2]=+n[ec>>2]+ +n[pc>>2];uc=uc+1|0}while((uc|0)!=(Q|0))}while(0);_b=_b+1|0}while((_b|0)!=(c|0));if(!g){ic=gc;break}if(xa){vc=gc;wc=0}else{rc=gc;_b=0;while(1){if(!(f[(f[B>>2]|0)+(_b<<2)>>2]|0)){f[k>>2]=0;f[eb>>2]=0;S=aD(k,16)|0;T=171776;U=S+16|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));bO(-215,k,171512,171519,425);bD(k)}xc=Yb&rc<0.0?0.0:rc;_b=_b+1|0;if((_b|0)>=(c|0)){ic=xc;break c}else rc=xc}}while(1){_b=(f[W>>2]|0)+(Y(f[f[V>>2]>>2]|0,wc)|0)|0;Zb=f[(f[B>>2]|0)+(wc<<2)>>2]|0;if(!Zb){f[k>>2]=0;f[eb>>2]=0;S=aD(k,16)|0;T=171776;U=S+16|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));bO(-215,k,171512,171519,425);bD(k);yc=f[(f[B>>2]|0)+(wc<<2)>>2]|0}else yc=Zb;rc=1.0/+(yc|0);ac=0;do{Ub=_b+(ac<<2)|0;n[Ub>>2]=rc*+n[Ub>>2];ac=ac+1|0}while((ac|0)!=(Q|0));if(Yb){ac=(f[fb>>2]|0)+(Y(f[f[$>>2]>>2]|0,wc)|0)|0;rc=0.0;Zb=0;do{gc=+n[_b+(Zb<<2)>>2]-+n[ac+(Zb<<2)>>2];rc=rc+gc*gc;Zb=Zb+1|0}while((Zb|0)!=(Q|0));zc=vc<rc?rc:vc}else zc=vc;wc=wc+1|0;if((wc|0)>=(c|0)){ic=zc;break}else vc=zc}}else{if(za){if(!g){ic=ua;break}Yb=f[W>>2]|0;Zb=f[f[V>>2]>>2]|0;ac=f[C>>2]|0;_b=(f[na>>2]|0)-ac>>3;gc=1.0/+(_b>>>0);Ub=ac;xc=gc*2.0+1.0;if(!_b){ic=ua;break}ac=qa;Xb=0;Wb=f[ac>>2]|0;Vb=f[ac+4>>2]|0;while(1){ac=Yb+(Y(Zb,Xb)|0)|0;$b=0;Ac=Wb;Bc=Vb;do{fc=cbc(Ac|0,0,-130063606,0)|0;Ac=Kac(fc|0,J|0,Bc|0,0)|0;Bc=J;Cc=+n[Ub+($b<<3)>>2];n[ac+($b<<2)>>2]=Cc+(+n[Ub+($b<<3)+4>>2]-Cc)*(xc*(+(Ac>>>0)*2.3283064365386963e-10)-gc);$b=$b+1|0}while(($b|0)!=(_b|0));Xb=Xb+1|0;if((Xb|0)==(c|0))break;else{Wb=Ac;Vb=Bc}}Vb=qa;f[Vb>>2]=Ac;f[Vb+4>>2]=Bc;ic=ua;break}dQ(k,39928);Vb=f[e>>2]|0;Wb=f[ya>>2]|0;Xb=f[wa>>2]|0;_b=(f[Ba>>2]|0)>>>2;f[l>>2]=0;f[Aa>>2]=0;f[Da>>2]=0;if(ka)Dc=0;else{if(Oa){fa=66;break b}Ub=L5b(Pa)|0;f[l>>2]=Ub;Zb=Ub+(c<<2)|0;f[Qa>>2]=Zb;Nac(Ub|0,0,Pa|0)|0;f[Aa>>2]=Zb;Dc=Ub}Ub=Wb*3|0;f[m>>2]=0;f[Ca>>2]=0;f[Ea>>2]=0;if(!Wb){Ec=0;Fc=0}else{if(Ub>>>0>1073741823){fa=70;break b}Zb=Wb*12|0;Yb=L5b(Zb)|0;f[m>>2]=Yb;$b=Yb+(Ub<<2)|0;f[Na>>2]=$b;Nac(Yb|0,0,Zb|0)|0;f[Ca>>2]=$b;Ec=Yb;Fc=Yb}Yb=Ec;$b=Ec+(Wb<<2)|0;Zb=$b;Ub=$b+(Wb<<2)|0;$b=qa;ac=f[$b+4>>2]|0;fc=cbc(f[$b>>2]|0,0,-130063606,0)|0;$b=Kac(fc|0,J|0,ac|0,0)|0;ac=qa;f[ac>>2]=$b;f[ac+4>>2]=J;ac=($b>>>0)%(Wb>>>0)|0;f[Dc>>2]=ac;$b=(Wb|0)>0;do if($b){fc=Xb+((Y(ac,_b)|0)<<2)|0;if((Vb|0)>0){Gc=0.0;Hc=0}else{Nac(Fc|0,0,Wb<<2|0)|0;Ic=0.0;break}while(1){bc=Xb+((Y(Hc,_b)|0)<<2)|0;oc=0;gc=0.0;do{xc=+n[bc+(oc<<2)>>2]-+n[fc+(oc<<2)>>2];gc=gc+xc*xc;oc=oc+1|0}while((oc|0)!=(Vb|0));n[Ec+(Hc<<2)>>2]=gc;xc=Gc+gc;Hc=Hc+1|0;if((Hc|0)==(Wb|0)){Ic=xc;break}else Gc=xc}}else Ic=0.0;while(0);if(Fa){ac=Wb+-1|0;fc=(Wb|0)>1;oc=1;xc=Ic;bc=Ub;cc=Zb;hc=Yb;while(1){pc=hc;do if(fc){ec=0;Jc=-1;rc=1797693134862315708145274.0e284;Kc=bc;Lc=cc;while(1){Mc=qa;Nc=f[Mc+4>>2]|0;Oc=cbc(f[Mc>>2]|0,0,-130063606,0)|0;Mc=Kac(Oc|0,J|0,Nc|0,0)|0;Nc=J;Oc=cbc(Mc|0,0,-130063606,0)|0;Pc=Kac(Oc|0,J|0,Nc|0,0)|0;Nc=qa;f[Nc>>2]=Pc;f[Nc+4>>2]=J;Cc=xc*((+(Pc>>>0)+4294967296.0*+(Mc>>>0))*5.421010862427522e-20);Mc=0;while(1){Cc=Cc-+n[pc+(Mc<<2)>>2];if(Cc<=0.0){Qc=Mc;break}Pc=Mc+1|0;if((Pc|0)>=(ac|0)){Qc=Pc;break}else Mc=Pc}f[o>>2]=0;f[Ga>>2]=Wb;Mc=Kc;Pc=Y(Qc,_b)|0;f[q>>2]=39956;f[Ha>>2]=Mc;f[Ia>>2]=Xb;f[Ja>>2]=pc;f[Ka>>2]=Vb;f[La>>2]=_b;f[Ma>>2]=Pc;RQ(o,q,-1.0);Cc=0.0;Pc=0;do{Cc=Cc+ +n[Mc+(Pc<<2)>>2];Pc=Pc+1|0}while((Pc|0)!=(Wb|0));if(Cc<rc){Rc=Qc;Sc=Cc;Tc=Lc;Uc=Kc}else{Rc=Jc;Sc=rc;Tc=Kc;Uc=Lc}ec=ec+1|0;if((ec|0)>=3){Vc=Rc;Wc=Sc;Xc=Tc;Yc=Uc;break}else{Jc=Rc;rc=Sc;Kc=Tc;Lc=Uc}}}else{Lc=qa;Kc=f[Lc+4>>2]|0;Jc=cbc(f[Lc>>2]|0,0,-130063606,0)|0;Lc=Kac(Jc|0,J|0,Kc|0,0)|0;Kc=J;Jc=cbc(Lc|0,0,-130063606,0)|0;Lc=Kac(Jc|0,J|0,Kc|0,0)|0;Kc=qa;f[Kc>>2]=Lc;f[Kc+4>>2]=J;f[o>>2]=0;f[Ga>>2]=Wb;Kc=bc;f[q>>2]=39956;f[Ha>>2]=Kc;f[Ia>>2]=Xb;f[Ja>>2]=pc;f[Ka>>2]=Vb;f[La>>2]=_b;f[Ma>>2]=0;RQ(o,q,-1.0);if($b){rc=0.0;Lc=0;do{rc=rc+ +n[Kc+(Lc<<2)>>2];Lc=Lc+1|0}while((Lc|0)!=(Wb|0));if(rc<1797693134862315708145274.0e284){Zc=rc;fa=97}else{_c=-1;$c=1797693134862315708145274.0e284;ad=bc;bd=cc}}else{Zc=0.0;fa=97}if((fa|0)==97){fa=0;_c=0;$c=Zc;ad=cc;bd=bc}Lc=qa;Kc=f[Lc+4>>2]|0;Jc=cbc(f[Lc>>2]|0,0,-130063606,0)|0;Lc=Kac(Jc|0,J|0,Kc|0,0)|0;Kc=J;Jc=cbc(Lc|0,0,-130063606,0)|0;Lc=Kac(Jc|0,J|0,Kc|0,0)|0;Kc=qa;f[Kc>>2]=Lc;f[Kc+4>>2]=J;f[o>>2]=0;f[Ga>>2]=Wb;Kc=ad;f[q>>2]=39956;f[Ha>>2]=Kc;f[Ia>>2]=Xb;f[Ja>>2]=pc;f[Ka>>2]=Vb;f[La>>2]=_b;f[Ma>>2]=0;RQ(o,q,-1.0);if($b){gc=0.0;Lc=0;while(1){cd=gc+ +n[Kc+(Lc<<2)>>2];Lc=Lc+1|0;if((Lc|0)==(Wb|0)){dd=cd;break}else gc=cd}}else dd=0.0;if(dd<$c){ed=0;fd=dd;gd=bd;hd=ad}else{ed=_c;fd=$c;gd=ad;hd=bd}Lc=qa;Kc=f[Lc+4>>2]|0;Jc=cbc(f[Lc>>2]|0,0,-130063606,0)|0;Lc=Kac(Jc|0,J|0,Kc|0,0)|0;Kc=J;Jc=cbc(Lc|0,0,-130063606,0)|0;Lc=Kac(Jc|0,J|0,Kc|0,0)|0;Kc=qa;f[Kc>>2]=Lc;f[Kc+4>>2]=J;f[o>>2]=0;f[Ga>>2]=Wb;Kc=gd;f[q>>2]=39956;f[Ha>>2]=Kc;f[Ia>>2]=Xb;f[Ja>>2]=pc;f[Ka>>2]=Vb;f[La>>2]=_b;f[Ma>>2]=0;RQ(o,q,-1.0);if($b){gc=0.0;Lc=0;while(1){rc=gc+ +n[Kc+(Lc<<2)>>2];Lc=Lc+1|0;if((Lc|0)==(Wb|0)){id=rc;break}else gc=rc}}else id=0.0;if(!(id<fd)){Vc=ed;Wc=fd;Xc=gd;Yc=hd;break}Vc=0;Wc=id;Xc=hd;Yc=gd}while(0);f[Dc+(oc<<2)>>2]=Vc;oc=oc+1|0;if((oc|0)>=(c|0))break;else{pc=hc;xc=Wc;bc=Xc;hc=Yc;cc=pc}}}do if(g){cc=f[W>>2]|0;hc=f[f[V>>2]>>2]|0;if((Vb|0)>0)jd=0;else break;do{bc=Xb+((Y(f[Dc+(jd<<2)>>2]|0,_b)|0)<<2)|0;oc=cc+(Y(jd,hc)|0)|0;Wb=0;do{f[oc+(Wb<<2)>>2]=f[bc+(Wb<<2)>>2];Wb=Wb+1|0}while((Wb|0)!=(Vb|0));jd=jd+1|0}while((jd|0)!=(c|0))}while(0);Vb=f[m>>2]|0;if(Vb|0){_b=f[Ca>>2]|0;if((_b|0)!=(Vb|0))f[Ca>>2]=_b+(~((_b+-4-Vb|0)>>>2)<<2);O5b(Vb)}Vb=f[l>>2]|0;if(Vb|0){_b=f[Aa>>2]|0;if((_b|0)!=(Vb|0))f[Aa>>2]=_b+(~((_b+-4-Vb|0)>>>2)<<2);O5b(Vb)}ic=ua}while(0);Tb=Tb+1|0;Vb=f[va>>2]|0;if((Tb|0)==(((Vb|0)>2?Vb:2)|0))kd=1;else kd=ic<=+p[sa>>3];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;UP(D,k)|0;Vb=f[Ra>>2]|0;f[k>>2]=0;f[Sa>>2]=P;f[l>>2]=39976;f[Ta>>2]=Vb;f[Ua>>2]=ea;f[Va>>2]=v;f[Wa>>2]=y;b[Xa>>0]=kd&1;RQ(k,l,-1.0);f[Ya>>2]=0;f[Za>>2]=0;f[k>>2]=16842752;f[_a>>2]=D;fG(E,k);ld=+p[E>>3];if(kd)break;else ua=ic}if(ld<ta){if(PM(i)|0){f[k>>2]=f[y>>2];Tb=f[ca>>2]|0;f[hb>>2]=Tb;f[ib>>2]=f[_>>2];f[jb>>2]=f[kb>>2];f[lb>>2]=f[W>>2];f[mb>>2]=f[nb>>2];f[ob>>2]=f[pb>>2];f[qb>>2]=f[rb>>2];f[sb>>2]=f[tb>>2];Sb=f[vb>>2]|0;f[ub>>2]=Sb;f[wb>>2]=ib;f[yb>>2]=xb;f[xb>>2]=0;f[zb>>2]=0;if(!Sb)md=Tb;else{Tb=Sb+12|0;f[Tb>>2]=(f[Tb>>2]|0)+1;md=f[ca>>2]|0}if((md|0)<3){Tb=f[V>>2]|0;Sb=f[yb>>2]|0;f[Sb>>2]=f[Tb>>2];f[Sb+4>>2]=f[Tb+4>>2]}else{f[hb>>2]=0;jL(k,y)}do if(MM(i)|0){if((GM(i,-1)|0)!=(Q|0))break;WL(l,y,Q,0);Tb=f[Ab>>2]|0;if(Tb|0){Sb=Tb+12|0;f[Sb>>2]=(f[Sb>>2]|0)+1}Sb=f[ub>>2]|0;do if(Sb|0){Tb=Sb+12|0;Vb=f[Tb>>2]|0;f[Tb>>2]=Vb+-1;if((Vb|0)!=1)break;kL(k)}while(0);f[ub>>2]=0;f[lb>>2]=0;f[lb+4>>2]=0;f[lb+8>>2]=0;f[lb+12>>2]=0;if((f[hb>>2]|0)>0){Sb=f[wb>>2]|0;Vb=0;do{f[Sb+(Vb<<2)>>2]=0;Vb=Vb+1|0;nd=f[hb>>2]|0}while((Vb|0)<(nd|0));f[k>>2]=f[l>>2];if((nd|0)<3)fa=192;else fa=194}else{f[k>>2]=f[l>>2];fa=192}do if((fa|0)==192){fa=0;Vb=f[Bb>>2]|0;if((Vb|0)>=3){fa=194;break}f[hb>>2]=Vb;f[ib>>2]=f[Cb>>2];f[jb>>2]=f[Db>>2];Vb=f[Eb>>2]|0;Sb=f[yb>>2]|0;f[Sb>>2]=f[Vb>>2];f[Sb+4>>2]=f[Vb+4>>2]}while(0);if((fa|0)==194){fa=0;jL(k,l)}f[lb>>2]=f[Fb>>2];f[mb>>2]=f[Gb>>2];f[ob>>2]=f[Hb>>2];f[qb>>2]=f[Ib>>2];f[sb>>2]=f[Jb>>2];Vb=f[Ab>>2]|0;f[ub>>2]=Vb;do if(Vb|0){Sb=Vb+12|0;Tb=f[Sb>>2]|0;f[Sb>>2]=Tb+-1;if((Tb|0)!=1)break;kL(l)}while(0);f[Ab>>2]=0;f[Fb>>2]=0;f[Fb+4>>2]=0;f[Fb+8>>2]=0;f[Fb+12>>2]=0;if((f[Bb>>2]|0)>0){Vb=f[Kb>>2]|0;Tb=0;do{f[Vb+(Tb<<2)>>2]=0;Tb=Tb+1|0}while((Tb|0)<(f[Bb>>2]|0))}Tb=f[Eb>>2]|0;if((Tb|0)!=(Lb|0))UC(Tb)}while(0);SP(k,i);Tb=f[ub>>2]|0;do if(Tb|0){Vb=Tb+12|0;Sb=f[Vb>>2]|0;f[Vb>>2]=Sb+-1;if((Sb|0)!=1)break;kL(k)}while(0);f[ub>>2]=0;f[lb>>2]=0;f[lb+4>>2]=0;f[lb+8>>2]=0;f[lb+12>>2]=0;if((f[hb>>2]|0)>0){Tb=f[wb>>2]|0;Sb=0;do{f[Tb+(Sb<<2)>>2]=0;Sb=Sb+1|0}while((Sb|0)<(f[hb>>2]|0))}Sb=f[yb>>2]|0;if((Sb|0)!=(xb|0))UC(Sb)}Sb=Mb;f[Sb>>2]=0;f[Sb+4>>2]=0;f[k>>2]=33619968;f[Nb>>2]=x;SP(w,k);od=ld}else od=ta;Rb=Rb+1|0;if((Rb|0)>=(ra|0)){pd=od;break a}else ta=od}if((fa|0)==66)c4b(l);else if((fa|0)==70)c4b(m)}else pd=1797693134862315708145274.0e284;while(0);m=D+36|0;fa=f[m>>2]|0;if(fa|0?(l=fa+12|0,fa=f[l>>2]|0,f[l>>2]=fa+-1,(fa|0)==1):0)kL(D);f[m>>2]=0;m=D+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[la>>2]|0)>0){m=f[oa>>2]|0;oa=0;do{f[m+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[la>>2]|0))}la=f[ma>>2]|0;if((la|0)!=(pa|0))UC(la);la=f[C>>2]|0;if(la|0){C=f[na>>2]|0;if((C|0)!=(la|0))f[na>>2]=C+(~((C+-8-la|0)>>>3)<<3);O5b(la)}la=f[B>>2]|0;if(la|0){B=f[G>>2]|0;if((B|0)!=(la|0))f[G>>2]=B+(~((B+-4-la|0)>>>2)<<2);O5b(la)}la=A+36|0;B=f[la>>2]|0;if(B|0?(G=B+12|0,B=f[G>>2]|0,f[G>>2]=B+-1,(B|0)==1):0)kL(A);f[la>>2]=0;la=A+16|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[ga>>2]|0)>0){la=f[ia>>2]|0;ia=0;do{f[la+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[ga>>2]|0))}ga=f[ja>>2]|0;if((ga|0)!=(ha|0))UC(ga);ga=z+36|0;ha=f[ga>>2]|0;do if(ha|0){ja=ha+12|0;ia=f[ja>>2]|0;f[ja>>2]=ia+-1;if((ia|0)!=1)break;kL(z)}while(0);f[ga>>2]=0;ga=z+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[X>>2]|0)>0){ga=f[ba>>2]|0;ba=0;do{f[ga+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[X>>2]|0))}X=f[$>>2]|0;if((X|0)!=(aa|0))UC(X);X=y+36|0;aa=f[X>>2]|0;do if(aa|0){$=aa+12|0;ba=f[$>>2]|0;f[$>>2]=ba+-1;if((ba|0)!=1)break;kL(y)}while(0);f[X>>2]=0;X=y+16|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[ca>>2]|0)>0){X=f[da>>2]|0;da=0;do{f[X+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[ca>>2]|0))}ca=f[V>>2]|0;if((ca|0)!=(Z|0))UC(ca);ca=x+36|0;Z=f[ca>>2]|0;do if(Z|0){V=Z+12|0;da=f[V>>2]|0;f[V>>2]=da+-1;if((da|0)!=1)break;kL(x)}while(0);f[ca>>2]=0;ca=x+16|0;Z=x+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[Z>>2]|0)>0){ca=f[x+40>>2]|0;da=0;do{f[ca+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[Z>>2]|0))}Z=f[x+44>>2]|0;if((Z|0)!=(x+48|0))UC(Z);Z=w+36|0;x=f[Z>>2]|0;do if(x|0){da=x+12|0;ca=f[da>>2]|0;f[da>>2]=ca+-1;if((ca|0)!=1)break;kL(w)}while(0);f[Z>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[O>>2]|0)>0){H=f[M>>2]|0;M=0;do{f[H+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[O>>2]|0))}O=f[L>>2]|0;if((O|0)!=(N|0))UC(O);O=v+36|0;N=f[O>>2]|0;do if(N|0){L=N+12|0;M=f[L>>2]|0;f[L>>2]=M+-1;if((M|0)!=1)break;kL(v)}while(0);f[O>>2]=0;O=v+4|0;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;if((f[O>>2]|0)>0){wa=f[v+40>>2]|0;N=0;do{f[wa+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[O>>2]|0))}O=f[a>>2]|0;if((O|0)!=(v+48|0))UC(O);O=t+36|0;v=f[O>>2]|0;do if(v|0){a=v+12|0;N=f[a>>2]|0;f[a>>2]=N+-1;if((N|0)!=1)break;kL(t)}while(0);f[O>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[R>>2]|0)>0){K=f[t+40>>2]|0;t=0;do{f[K+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[R>>2]|0))}R=f[I>>2]|0;if((R|0)!=(F|0))UC(R);if(!(f[r+4>>2]|0)){u=j;return +pd}u=j;return +pd}function YC(a){a=a|0;O5b(a);return}function ZC(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0.0,B=0,C=0.0,D=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;g=f[c>>2]|0;h=f[g+8>>2]|0;i=f[g+12>>2]|0;if((d|0)>=(e|0))return;j=a+12|0;k=(h|0)>0;l=(i|0)>0;m=a+4|0;o=a+8|0;if(b[a+20>>0]|0){a=f[o>>2]|0;q=f[m>>2]|0;r=d;s=g;while(1){g=f[j>>2]|0;t=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,r)|0)|0;g=(f[s+16>>2]|0)+(Y(f[f[s+44>>2]>>2]|0,f[a+(r<<2)>>2]|0)|0)|0;if(l){u=0;v=0.0;while(1){w=+n[t+(u<<2)>>2]-+n[g+(u<<2)>>2];x=v+w*w;u=u+1|0;if((u|0)==(i|0)){y=x;break}else v=x}}else y=0.0;p[q+(r<<3)>>3]=y;u=r+1|0;if((u|0)==(e|0))break;r=u;s=f[c>>2]|0}return}s=f[m>>2]|0;m=f[o>>2]|0;o=d;do{d=f[j>>2]|0;r=(f[d+16>>2]|0)+(Y(f[f[d+44>>2]>>2]|0,o)|0)|0;a:do if(k){d=f[c>>2]|0;q=f[d+16>>2]|0;a=f[f[d+44>>2]>>2]|0;if(l){z=0;A=1797693134862315708145274.0e284;B=0}else{d=0;y=1797693134862315708145274.0e284;u=0;while(1){g=y>0.0;t=g?d:u;v=g?0.0:y;d=d+1|0;if((d|0)==(h|0)){C=v;D=t;break a}else{y=v;u=t}}}while(1){u=q+(Y(a,z)|0)|0;d=0;y=0.0;do{v=+n[r+(d<<2)>>2]-+n[u+(d<<2)>>2];y=y+v*v;d=d+1|0}while((d|0)!=(i|0));v=y;d=A>v;u=d?z:B;x=d?v:A;z=z+1|0;if((z|0)==(h|0)){C=x;D=u;break}else{A=x;B=u}}}else{C=1797693134862315708145274.0e284;D=0}while(0);p[s+(o<<3)>>3]=C;f[m+(o<<2)>>2]=D;o=o+1|0}while((o|0)!=(e|0));return}function _C(a){a=a|0;O5b(a);return}function $C(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0;c=u;u=u+16|0;d=c+8|0;e=c;dQ(d,39988);g=f[b>>2]|0;h=f[b+4>>2]|0;a:do if((g|0)<(h|0)){b=f[a+8>>2]|0;i=f[a+20>>2]|0;j=b+(f[a+24>>2]<<2)|0;k=f[a+16>>2]|0;l=f[a+12>>2]|0;m=f[a+4>>2]|0;if((k|0)>0)o=g;else{p=g;while(1){n[e>>2]=0.0;q=l+(p<<2)|0;f[m+(p<<2)>>2]=f[(+n[q>>2]<0.0?q:e)>>2];p=p+1|0;if((p|0)==(h|0))break a}}do{p=b+((Y(i,o)|0)<<2)|0;q=0;r=0.0;do{s=+n[p+(q<<2)>>2]-+n[j+(q<<2)>>2];r=r+s*s;q=q+1|0}while((q|0)!=(k|0));n[e>>2]=r;q=l+(o<<2)|0;f[m+(o<<2)>>2]=f[(+n[q>>2]<r?q:e)>>2];o=o+1|0}while((o|0)!=(h|0))}while(0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function aD(a,c){a=a|0;c=c|0;var d=0,e=0;d=TC(c+8&-4)|0;f[d>>2]=1;e=d+4|0;f[a>>2]=e;f[a+4>>2]=c;b[e+c>>0]=0;return f[a>>2]|0}function bD(a){a=a|0;var b=0;b=f[a>>2]|0;f[a+4>>2]=0;f[a>>2]=0;if(!b)return;a=b+-4|0;b=f[a>>2]|0;f[a>>2]=b+-1;if((b|0)!=1)return;UC(a);return}function cD(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=g+8|0;j=f[a+4>>2]|0;if((j|0)<3)k=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{l=f[a+40>>2]|0;m=0;n=1;while(1){o=Y(f[l+(m<<2)>>2]|0,n)|0;m=m+1|0;if((m|0)==(j|0)){k=o;break}else n=o}}n=c>>>3&511;j=n+1|0;m=c&7;l=j<<(47696>>>(m<<1)&3);o=KI(f[a>>2]&7,c)|0;c=f[a+16>>2]|0;a=(k|0)<=(n|0);f[h>>2]=a?k:j;f[h+4>>2]=1;Hh[o&255](c,1,0,1,d,1,h,0);if(a){if((k|0)!=1){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,8)|0;a=k;b[a>>0]=115;b[a+1>>0]=99;b[a+2>>0]=110;b[a+3>>0]=32;a=k+4|0;b[a>>0]=61;b[a+1>>0]=61;b[a+2>>0]=32;b[a+3>>0]=49;bO(-215,i,172104,172127,68);bD(i)}i=1212424721>>>(m<<2)&15;if(i>>>0<l>>>0){m=i;do{b[d+m>>0]=b[d+(m-i)>>0]|0;m=m+1|0}while((m|0)!=(l|0))}}m=Y(l,e)|0;if(l>>>0<m>>>0)p=l;else{u=g;return}do{b[d+p>>0]=b[d+(p-l)>>0]|0;p=p+1|0}while((p|0)!=(m|0));u=g;return}function dD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(g,40008);f[h>>2]=100;fD(a,b,c,d,h,1,9);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function eD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;gD(a,b,c,d,e,f,g,h);return}function fD(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;j=u;u=u+1440|0;k=j+1376|0;l=j+1368|0;m=j+1352|0;n=j+1360|0;o=j+312|0;q=j+256|0;r=j;s=j+184|0;t=j+128|0;v=j+104|0;w=j+88|0;x=j+56|0;y=j+248|0;z=j+240|0;A=a;B=c;C=yM(a)|0;D=yM(c)|0;E=BL(a,-1)|0;F=E&7;G=(E>>>3&511)+1|0;H=BL(c,-1)|0;I=H&7;K=(H>>>3&511)+1|0;L=_L(a,-1)|0;M=_L(c,-1)|0;N=(L|0)<3;if(N)AL(l,a,-1);else{f[l>>2]=0;f[l+4>>2]=0}L=(M|0)<3;if(L)AL(m,c,-1);else{f[m>>2]=0;f[m+4>>2]=0}M=HM(e)|0;if(((C|0)==(D|0)&(N&L)?(L=f[l>>2]|0,N=f[l+4>>2]|0,(L|0)==(f[m>>2]|0)?(N|0)==(f[m+4>>2]|0):0):0)?!((E|0)!=(H|0)|M^1):0){f[n>>2]=L;f[n+4>>2]=N;vM(d,n,E,-1,0,0);if(h){O=g;P=G<<(47696>>>(E<<1&14)&3)}else{O=g+(F<<2)|0;P=G}n=f[O>>2]|0;do if((yM(a)|0)==65536){O=f[a+4>>2]|0;f[k>>2]=f[O>>2];N=k+4|0;L=O+4|0;f[N>>2]=f[L>>2];Q=k+8|0;f[Q>>2]=f[O+8>>2];f[k+12>>2]=f[O+12>>2];f[k+16>>2]=f[O+16>>2];f[k+20>>2]=f[O+20>>2];f[k+24>>2]=f[O+24>>2];f[k+28>>2]=f[O+28>>2];f[k+32>>2]=f[O+32>>2];R=f[O+36>>2]|0;f[k+36>>2]=R;f[k+40>>2]=Q;Q=k+48|0;S=k+44|0;f[S>>2]=Q;f[Q>>2]=0;f[k+52>>2]=0;if(R|0){Q=R+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[L>>2]|0)<3){L=f[O+44>>2]|0;Q=f[S>>2]|0;f[Q>>2]=f[L>>2];f[Q+4>>2]=f[L+4>>2];break}else{f[N>>2]=0;jL(k,O);break}}else yL(k,a,-1);while(0);do if((yM(c)|0)==65536){O=f[c+4>>2]|0;f[o>>2]=f[O>>2];N=o+4|0;L=O+4|0;f[N>>2]=f[L>>2];Q=o+8|0;f[Q>>2]=f[O+8>>2];f[o+12>>2]=f[O+12>>2];f[o+16>>2]=f[O+16>>2];f[o+20>>2]=f[O+20>>2];f[o+24>>2]=f[O+24>>2];f[o+28>>2]=f[O+28>>2];f[o+32>>2]=f[O+32>>2];S=f[O+36>>2]|0;f[o+36>>2]=S;f[o+40>>2]=Q;Q=o+48|0;R=o+44|0;f[R>>2]=Q;f[Q>>2]=0;f[o+52>>2]=0;if(S|0){Q=S+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[L>>2]|0)<3){L=f[O+44>>2]|0;Q=f[R>>2]|0;f[Q>>2]=f[L>>2];f[Q+4>>2]=f[L+4>>2];break}else{f[N>>2]=0;jL(o,O);break}}else yL(o,c,-1);while(0);do if((yM(d)|0)==65536){O=f[d+4>>2]|0;f[q>>2]=f[O>>2];N=q+4|0;L=O+4|0;f[N>>2]=f[L>>2];Q=q+8|0;f[Q>>2]=f[O+8>>2];f[q+12>>2]=f[O+12>>2];f[q+16>>2]=f[O+16>>2];f[q+20>>2]=f[O+20>>2];f[q+24>>2]=f[O+24>>2];f[q+28>>2]=f[O+28>>2];f[q+32>>2]=f[O+32>>2];R=f[O+36>>2]|0;f[q+36>>2]=R;f[q+40>>2]=Q;Q=q+48|0;S=q+44|0;f[S>>2]=Q;f[Q>>2]=0;f[q+52>>2]=0;if(R|0){Q=R+12|0;f[Q>>2]=(f[Q>>2]|0)+1}if((f[L>>2]|0)<3){L=f[O+44>>2]|0;Q=f[S>>2]|0;f[Q>>2]=f[L>>2];f[Q+4>>2]=f[L+4>>2];T=q;break}else{f[N>>2]=0;jL(q,O);T=q;break}}else{yL(q,d,-1);T=q}while(0);O=f[k>>2]|0;N=f[o>>2]|0;L=f[T>>2]|0;T=f[k+12>>2]|0;Q=f[k+8>>2]|0;S=cbc(Q|0,((Q|0)<0)<<31>>31|0,T|0,((T|0)<0)<<31>>31|0)|0;if((O&16384&N&L|0)!=0?(S|0)==(S|0)&(((S|0)<0)<<31>>31|0)==(J|0):0){U=1;V=S}else{U=Q;V=T}T=Y(V,P)|0;P=k+16|0;V=k+44|0;Q=k+48|0;S=o+16|0;L=o+44|0;N=o+48|0;O=q+16|0;R=q+44|0;W=q+48|0;Th[n&127](f[P>>2]|0,f[Q>>2]|0,f[S>>2]|0,f[N>>2]|0,f[O>>2]|0,f[W>>2]|0,T,U,0);U=q+36|0;T=f[U>>2]|0;if(T|0?(n=T+12|0,T=f[n>>2]|0,f[n>>2]=T+-1,(T|0)==1):0)kL(q);f[U>>2]=0;U=q+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[U>>2]|0)>0){O=f[q+40>>2]|0;T=0;do{f[O+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[U>>2]|0))}U=f[R>>2]|0;if((U|0)!=(W|0))UC(U);U=o+36|0;W=f[U>>2]|0;if(W|0?(R=W+12|0,W=f[R>>2]|0,f[R>>2]=W+-1,(W|0)==1):0)kL(o);f[U>>2]=0;U=o+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[U>>2]|0)>0){S=f[o+40>>2]|0;W=0;do{f[S+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[U>>2]|0))}U=f[L>>2]|0;if((U|0)!=(N|0))UC(U);U=k+36|0;N=f[U>>2]|0;if(N|0?(L=N+12|0,N=f[L>>2]|0,f[L>>2]=N+-1,(N|0)==1):0)kL(k);f[U>>2]=0;U=k+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[U>>2]|0)>0){P=f[k+40>>2]|0;N=0;do{f[P+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[U>>2]|0))}U=f[V>>2]|0;if((U|0)!=(Q|0))UC(U);u=j;return}a:do if((i|0)==12){X=1;Z=E;_=F;$=G;aa=B;ba=A}else{U=(C|0)==131072;Q=(D|0)==131072;if(((Q&1)+(U&1)|0)!=1?(E|0)==(H|0)&(DM(a,c)|0):0){if(DM(a,c)|0){X=0;Z=E;_=F;$=G;aa=B;ba=A;break}f[k>>2]=0;f[k+4>>2]=0;ca=aD(k,41)|0;da=172336;ea=ca+41|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));bO(-215,k,172326,172127,230);bD(k);X=0;Z=E;_=F;$=G;aa=B;ba=A;break}b:do if((_L(a,-1)|0)<=2?IM(a,-1)|0:0){AL(k,a,-1);V=f[k>>2]|0;N=(V|0)==1;if(N){if(!((C|0)!=131072&Q)){fa=f[k+4>>2]|0;ga=71}}else if(!((C|0)!=131072&Q|(f[k+4>>2]|0)!=1)){fa=1;ga=71}do if((ga|0)==71){P=(fa|0)==1;if(!((V|0)==(K|0)&P|N&(P|(fa|0)==(K|0)))){if(!(N&(fa|0)==4))break;if(!(K>>>0<5&(BL(a,-1)|0)==6))break b}P=f[l>>2]|0;L=l+4|0;W=f[L>>2]|0;f[l>>2]=f[m>>2];S=m+4|0;f[L>>2]=f[S>>2];f[m>>2]=P;f[S>>2]=W;X=1;Z=H;_=I;$=K;aa=A;ba=B;break a}while(0)}while(0);do if((_L(c,-1)|0)<=2?IM(c,-1)|0:0){AL(k,c,-1);Q=f[k>>2]|0;N=(Q|0)==1;if(N){if(!(U&(D|0)!=131072)){ha=f[k+4>>2]|0;ga=83}}else if(!(U&(D|0)!=131072|(f[k+4>>2]|0)!=1)){ha=1;ga=83}if((ga|0)==83){V=(ha|0)==1;if((Q|0)==(G|0)&V|N&(V|(ha|0)==(G|0))){X=1;Z=E;_=F;$=G;aa=B;ba=A;break a}if(N&(ha|0)==4)if(G>>>0<5&(BL(c,-1)|0)==6){X=1;Z=E;_=F;$=G;aa=B;ba=A;break a}else break}}while(0);f[k>>2]=0;f[k+4>>2]=0;Vac(aD(k,130)|0,172195,130)|0;bO(-209,k,172326,172127,225);bD(k);X=1;Z=E;_=F;$=G;aa=B;ba=A}while(0);A=(Z>>>3&511)+1<<(47696>>>(Z<<1&14)&3);f[k>>2]=A;B=((A+1023|0)>>>0)/(A>>>0)|0;if(!M){if((BL(e,-1)|0|1|0)==1?(A=ba,DM(e,A)|0):0)ia=A;else{f[o>>2]=0;f[o+4>>2]=0;ca=aD(o,52)|0;da=172378;ea=ca+52|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));bO(-215,o,172326,172127,241);bD(o);ia=ba}da=QP(f[k>>2]|0)|0;if(DM(d,ia)|0){ja=(BL(d,-1)|0)!=(Z|0);ka=da;la=ia}else{ja=1;ka=da;la=ia}}else{ja=0;ka=0;la=ba}ba=o+8|0;f[o>>2]=ba;ia=o+4|0;f[ia>>2]=1032;NM(d,la,Z);if(!(M|ja^1)){p[r>>3]=0.0;f[q>>2]=-1056833530;f[q+4>>2]=r;f[q+8>>2]=1;f[q+12>>2]=1;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;QM(d,q,s)}do if((yM(la)|0)==65536){ja=f[la+4>>2]|0;f[q>>2]=f[ja>>2];Z=q+4|0;da=ja+4|0;f[Z>>2]=f[da>>2];ca=q+8|0;f[ca>>2]=f[ja+8>>2];f[q+12>>2]=f[ja+12>>2];f[q+16>>2]=f[ja+16>>2];f[q+20>>2]=f[ja+20>>2];f[q+24>>2]=f[ja+24>>2];f[q+28>>2]=f[ja+28>>2];f[q+32>>2]=f[ja+32>>2];ea=f[ja+36>>2]|0;f[q+36>>2]=ea;f[q+40>>2]=ca;ca=q+48|0;A=q+44|0;f[A>>2]=ca;f[ca>>2]=0;f[q+52>>2]=0;if(ea|0){ca=ea+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[da>>2]|0)<3){da=f[ja+44>>2]|0;ca=f[A>>2]|0;f[ca>>2]=f[da>>2];f[ca+4>>2]=f[da+4>>2];break}else{f[Z>>2]=0;jL(q,ja);break}}else yL(q,la,-1);while(0);la=aa;do if((yM(la)|0)==65536){aa=f[la+4>>2]|0;f[r>>2]=f[aa>>2];ja=r+4|0;Z=aa+4|0;f[ja>>2]=f[Z>>2];da=r+8|0;f[da>>2]=f[aa+8>>2];f[r+12>>2]=f[aa+12>>2];f[r+16>>2]=f[aa+16>>2];f[r+20>>2]=f[aa+20>>2];f[r+24>>2]=f[aa+24>>2];f[r+28>>2]=f[aa+28>>2];f[r+32>>2]=f[aa+32>>2];ca=f[aa+36>>2]|0;f[r+36>>2]=ca;f[r+40>>2]=da;da=r+48|0;A=r+44|0;f[A>>2]=da;f[da>>2]=0;f[r+52>>2]=0;if(ca|0){da=ca+12|0;f[da>>2]=(f[da>>2]|0)+1}if((f[Z>>2]|0)<3){Z=f[aa+44>>2]|0;da=f[A>>2]|0;f[da>>2]=f[Z>>2];f[da+4>>2]=f[Z+4>>2];break}else{f[ja>>2]=0;jL(r,aa);break}}else yL(r,la,-1);while(0);do if((yM(d)|0)==65536){la=f[d+4>>2]|0;f[s>>2]=f[la>>2];aa=s+4|0;ja=la+4|0;f[aa>>2]=f[ja>>2];Z=s+8|0;f[Z>>2]=f[la+8>>2];f[s+12>>2]=f[la+12>>2];f[s+16>>2]=f[la+16>>2];f[s+20>>2]=f[la+20>>2];f[s+24>>2]=f[la+24>>2];f[s+28>>2]=f[la+28>>2];f[s+32>>2]=f[la+32>>2];da=f[la+36>>2]|0;f[s+36>>2]=da;f[s+40>>2]=Z;Z=s+48|0;A=s+44|0;f[A>>2]=Z;f[Z>>2]=0;f[s+52>>2]=0;if(da|0){Z=da+12|0;f[Z>>2]=(f[Z>>2]|0)+1}if((f[ja>>2]|0)<3){ja=f[la+44>>2]|0;Z=f[A>>2]|0;f[Z>>2]=f[ja>>2];f[Z+4>>2]=f[ja+4>>2];break}else{f[aa>>2]=0;jL(s,la);break}}else yL(s,d,-1);while(0);do if((yM(e)|0)==65536){d=f[e+4>>2]|0;f[t>>2]=f[d>>2];la=t+4|0;aa=d+4|0;f[la>>2]=f[aa>>2];ja=t+8|0;f[ja>>2]=f[d+8>>2];f[t+12>>2]=f[d+12>>2];f[t+16>>2]=f[d+16>>2];f[t+20>>2]=f[d+20>>2];f[t+24>>2]=f[d+24>>2];f[t+28>>2]=f[d+28>>2];f[t+32>>2]=f[d+32>>2];Z=f[d+36>>2]|0;f[t+36>>2]=Z;f[t+40>>2]=ja;ja=t+48|0;A=t+44|0;f[A>>2]=ja;f[ja>>2]=0;f[t+52>>2]=0;if(Z|0){ja=Z+12|0;f[ja>>2]=(f[ja>>2]|0)+1}if((f[aa>>2]|0)<3){aa=f[d+44>>2]|0;ja=f[A>>2]|0;f[ja>>2]=f[aa>>2];f[ja+4>>2]=f[aa+4>>2];break}else{f[la>>2]=0;jL(t,d);break}}else yL(t,e,-1);while(0);e=h?f[k>>2]|0:$;$=f[(h?g:g+(_<<2)|0)>>2]|0;if(X){f[v>>2]=q;f[v+4>>2]=s;f[v+8>>2]=t;f[v+12>>2]=0;RN(x,v,w,-1);X=f[x+20>>2]|0;_=B>>>0<X>>>0?B:X;g=(Y(Y(f[k>>2]|0,M?1:2)|0,_)|0)+32|0;if((f[ia>>2]|0)>>>0<g>>>0){h=f[o>>2]|0;if((h|0)!=(ba|0)){if(h|0)P5b(h);f[o>>2]=ba;f[ia>>2]=1032}f[ia>>2]=g;if(g>>>0>1032){h=N5b(g)|0;f[o>>2]=h;ma=h}else ma=ba}else{f[ia>>2]=g;ma=f[o>>2]|0}g=ma+(Y(f[k>>2]|0,_)|0)+15&-16;cD(r,f[q>>2]&4095,ma,_);h=x+16|0;d=w+4|0;la=w+8|0;aa=z+4|0;c:do if(!X){ja=0;while(1){if(ja>>>0>=(f[h>>2]|0)>>>0)break c;aL(x)|0;ja=ja+1|0}}else{ja=0;while(1){if(ja>>>0>=(f[h>>2]|0)>>>0)break c;A=f[w>>2]|0;if(M){Z=0;da=A;ca=f[d>>2]|0;do{ea=X-Z|0;G=ea>>>0>_>>>0?_:ea;ea=Y(G,e)|0;Th[$&127](da,0,ma,0,ca,0,ea,1,0);ea=Y(f[k>>2]|0,G)|0;da=(f[w>>2]|0)+ea|0;f[w>>2]=da;ca=(f[d>>2]|0)+ea|0;f[d>>2]=ca;Z=Z+_|0}while(X>>>0>Z>>>0)}else{Z=0;ca=A;do{da=X-Z|0;ea=da>>>0>_>>>0?_:da;da=Y(ea,e)|0;Th[$&127](ca,0,ma,0,g,0,da,1,0);da=f[la>>2]|0;G=f[d>>2]|0;f[z>>2]=ea;f[aa>>2]=1;Hh[ka&255](g,0,da,0,G,0,z,k);f[la>>2]=(f[la>>2]|0)+ea;G=Y(f[k>>2]|0,ea)|0;ca=(f[w>>2]|0)+G|0;f[w>>2]=ca;f[d>>2]=(f[d>>2]|0)+G;Z=Z+_|0}while(X>>>0>Z>>>0)}aL(x)|0;ja=ja+1|0}}while(0)}else{f[v>>2]=q;f[v+4>>2]=r;f[v+8>>2]=s;f[v+12>>2]=t;f[v+16>>2]=0;RN(x,v,w,-1);v=f[x+20>>2]|0;if((Y(v,e)|0)<0)na=2147483647/(e|0)|0;else na=v;do if(!M){X=B>>>0<na>>>0?B:na;_=Y(f[k>>2]|0,X)|0;if((f[ia>>2]|0)>>>0>=_>>>0){f[ia>>2]=_;oa=f[o>>2]|0;pa=X;break}d=f[o>>2]|0;if((d|0)!=(ba|0)){if(d|0)P5b(d);f[o>>2]=ba;f[ia>>2]=1032}f[ia>>2]=_;if(_>>>0>1032){d=N5b(_)|0;f[o>>2]=d;oa=d;pa=X}else{oa=ba;pa=X}}else{oa=0;pa=na}while(0);na=x+16|0;B=(v|0)==0;X=w+4|0;d=w+8|0;_=w+12|0;la=y+4|0;z=0;while(1){if(z>>>0>=(f[na>>2]|0)>>>0)break;d:do if(!B){g=f[w>>2]|0;aa=f[X>>2]|0;if(!M){ma=0;h=g;ja=aa;while(1){Z=v-ma|0;ca=Z>>>0>pa>>>0?pa:Z;Z=Y(ca,e)|0;Th[$&127](h,0,ja,0,oa,0,Z,1,0);Z=f[_>>2]|0;A=f[d>>2]|0;f[y>>2]=ca;f[la>>2]=1;Hh[ka&255](oa,0,Z,0,A,0,y,k);f[_>>2]=(f[_>>2]|0)+ca;A=Y(f[k>>2]|0,ca)|0;h=(f[w>>2]|0)+A|0;f[w>>2]=h;ja=(f[X>>2]|0)+A|0;f[X>>2]=ja;f[d>>2]=(f[d>>2]|0)+A;ma=ma+pa|0;if(v>>>0<=ma>>>0)break d}}ma=0;ja=g;h=aa;A=f[d>>2]|0;do{ca=v-ma|0;Z=ca>>>0>pa>>>0?pa:ca;ca=Y(Z,e)|0;Th[$&127](ja,0,h,0,A,0,ca,1,0);ca=Y(f[k>>2]|0,Z)|0;ja=(f[w>>2]|0)+ca|0;f[w>>2]=ja;h=(f[X>>2]|0)+ca|0;f[X>>2]=h;A=(f[d>>2]|0)+ca|0;f[d>>2]=A;ma=ma+pa|0}while(v>>>0>ma>>>0)}while(0);aL(x)|0;z=z+1|0}}z=t+36|0;x=f[z>>2]|0;if(x|0?(v=x+12|0,x=f[v>>2]|0,f[v>>2]=x+-1,(x|0)==1):0)kL(t);f[z>>2]=0;z=t+16|0;x=t+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[x>>2]|0)>0){z=f[t+40>>2]|0;v=0;do{f[z+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[x>>2]|0))}x=f[t+44>>2]|0;if((x|0)!=(t+48|0))UC(x);x=s+36|0;t=f[x>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)kL(s);f[x>>2]=0;x=s+16|0;t=s+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[t>>2]|0)>0){x=f[s+40>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))UC(t);t=r+36|0;s=f[t>>2]|0;if(s|0?(v=s+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0)kL(r);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))UC(s);s=q+36|0;r=f[s>>2]|0;do if(r|0){v=r+12|0;t=f[v>>2]|0;f[v>>2]=t+-1;if((t|0)!=1)break;kL(q)}while(0);f[s>>2]=0;s=q+16|0;r=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[q+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))UC(r);r=f[o>>2]|0;if((r|0)!=(ba|0)){if(r|0)P5b(r);f[o>>2]=ba;f[ia>>2]=1032}u=j;return}function gD(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=j;while(1){if(k){p=0;do{b[m+p>>0]=b[l+p>>0]&b[n+p>>0];p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=j;while(1){j=0;do{l=j|1;k=b[m+l>>0]&b[f+l>>0];b[d+j>>0]=b[m+j>>0]&b[f+j>>0];b[d+l>>0]=k;k=j|2;l=j|3;p=b[m+l>>0]&b[f+l>>0];b[d+k>>0]=b[m+k>>0]&b[f+k>>0];b[d+l>>0]=p;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{b[d+j>>0]=b[m+j>>0]&b[f+j>>0];j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function hD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(g,40028);f[h>>2]=101;fD(a,b,c,d,h,1,10);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function iD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;jD(a,b,c,d,e,f,g,h);return}function jD(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=j;while(1){if(k){p=0;do{b[m+p>>0]=b[l+p>>0]|b[n+p>>0];p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=j;while(1){j=0;do{l=j|1;k=b[m+l>>0]|b[f+l>>0];b[d+j>>0]=b[m+j>>0]|b[f+j>>0];b[d+l>>0]=k;k=j|2;l=j|3;p=b[m+l>>0]|b[f+l>>0];b[d+k>>0]=b[m+k>>0]|b[f+k>>0];b[d+l>>0]=p;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{b[d+j>>0]=b[m+j>>0]|b[f+j>>0];j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function kD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(g,40048);f[h>>2]=102;fD(a,b,c,d,h,1,11);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function lD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;mD(a,b,c,d,e,f,g,h);return}function mD(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=j;while(1){if(k){p=0;do{b[m+p>>0]=b[l+p>>0]^b[n+p>>0];p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=j;while(1){j=0;do{l=j|1;k=b[m+l>>0]^b[f+l>>0];b[d+j>>0]=b[m+j>>0]^b[f+j>>0];b[d+l>>0]=k;k=j|2;l=j|3;p=b[m+l>>0]^b[f+l>>0];b[d+k>>0]=b[m+k>>0]^b[f+k>>0];b[d+l>>0]=p;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{b[d+j>>0]=b[m+j>>0]^b[f+j>>0];j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function nD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d+8|0;g=d;dQ(e,40068);f[g>>2]=103;fD(a,a,b,c,g,1,12);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function oD(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){k=f;l=a;m=j}else return;while(1){e=0;do{b[k+e>>0]=~b[l+e>>0];e=e+1|0}while((e|0)!=(h|0));if(!m)break;else{k=k+g|0;l=l+c|0;m=m+-1|0}}return}m=h&-4;if((m|0)<(h|0)){n=f;o=a;p=j}else{l=f;f=a;a=j;while(1){j=0;do{k=j|1;e=~b[f+k>>0];b[l+j>>0]=~b[f+j>>0];b[l+k>>0]=e;e=j|2;k=j|3;d=~b[f+k>>0];b[l+e>>0]=~b[f+e>>0];b[l+k>>0]=d;j=j+4|0}while((j|0)<=(i|0));if(!a)break;else{l=l+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=a|1;l=~b[o+f>>0];b[n+a>>0]=~b[o+a>>0];b[n+f>>0]=l;l=a|2;f=a|3;j=~b[o+f>>0];b[n+l>>0]=~b[o+l>>0];b[n+f>>0]=j;a=a+4|0}while((a|0)<=(i|0));q=m;do{b[n+q>>0]=~b[o+q>>0];q=q+1|0}while((q|0)!=(h|0));if(!p)break;else{n=n+g|0;o=o+c|0;p=p+-1|0}}return}function pD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;dQ(e,40088);fD(a,b,c,UM()|0,40108,0,14);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function qD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;DD(a,b,c,d,e,f,g,h);return}function rD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;CD(a,b,c,d,e,f,g,h);return}function sD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;BD(a,b,c,d,e,f,g,h);return}function tD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;AD(a,b,c,d,e,f,g,h);return}function uD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;zD(a,b,c,d,e,f,g,h);return}function vD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;yD(a,b,c,d,e,f,g,h);return}function wD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;xD(a,b,c,d,e,f,g,h);return}function xD(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0.0,t=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=c;l=e;m=a;n=i;while(1){if(j){o=0;do{q=+p[m+(o<<3)>>3];r=+p[k+(o<<3)>>3];p[l+(o<<3)>>3]=q<r?r:q;o=o+1|0}while((o|0)!=(g|0))}if(!n)break;else{k=k+d|0;l=l+f|0;m=m+b|0;n=n+-1|0}}return}n=g&-4;m=(n|0)<(g|0);l=c;c=e;e=a;a=i;while(1){i=0;do{q=+p[e+(i<<3)>>3];r=+p[l+(i<<3)>>3];k=i|1;s=+p[e+(k<<3)>>3];t=+p[l+(k<<3)>>3];p[c+(i<<3)>>3]=q<r?r:q;p[c+(k<<3)>>3]=s<t?t:s;k=i|2;s=+p[e+(k<<3)>>3];t=+p[l+(k<<3)>>3];j=i|3;q=+p[e+(j<<3)>>3];r=+p[l+(j<<3)>>3];p[c+(k<<3)>>3]=s<t?t:s;p[c+(j<<3)>>3]=q<r?r:q;i=i+4|0}while((i|0)<=(h|0));if(m){i=n;do{q=+p[e+(i<<3)>>3];r=+p[l+(i<<3)>>3];p[c+(i<<3)>>3]=q<r?r:q;i=i+1|0}while((i|0)!=(g|0))}if(!a)break;else{l=l+d|0;c=c+f|0;e=e+b|0;a=a+-1|0}}return}function yD(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=c;l=e;m=a;o=i;while(1){if(j){p=0;do{q=+n[m+(p<<2)>>2];r=+n[k+(p<<2)>>2];n[l+(p<<2)>>2]=q<r?r:q;p=p+1|0}while((p|0)!=(g|0))}if(!o)break;else{k=k+d|0;l=l+f|0;m=m+b|0;o=o+-1|0}}return}o=g&-4;m=(o|0)<(g|0);l=c;c=e;e=a;a=i;while(1){i=0;do{q=+n[e+(i<<2)>>2];r=+n[l+(i<<2)>>2];k=i|1;s=+n[e+(k<<2)>>2];t=+n[l+(k<<2)>>2];n[c+(i<<2)>>2]=q<r?r:q;n[c+(k<<2)>>2]=s<t?t:s;k=i|2;s=+n[e+(k<<2)>>2];t=+n[l+(k<<2)>>2];j=i|3;q=+n[e+(j<<2)>>2];r=+n[l+(j<<2)>>2];n[c+(k<<2)>>2]=s<t?t:s;n[c+(j<<2)>>2]=q<r?r:q;i=i+4|0}while((i|0)<=(h|0));if(m){i=o;do{q=+n[e+(i<<2)>>2];r=+n[l+(i<<2)>>2];n[c+(i<<2)>>2]=q<r?r:q;i=i+1|0}while((i|0)!=(g|0))}if(!a)break;else{l=l+d|0;c=c+f|0;e=e+b|0;a=a+-1|0}}return}function zD(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=c;m=e;n=a;o=j;while(1){if(k){p=0;do{q=f[n+(p<<2)>>2]|0;r=f[l+(p<<2)>>2]|0;f[m+(p<<2)>>2]=(q|0)<(r|0)?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+d|0;m=m+g|0;n=n+b|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=e;e=a;a=j;while(1){j=0;do{l=f[e+(j<<2)>>2]|0;k=f[m+(j<<2)>>2]|0;p=j|1;q=f[e+(p<<2)>>2]|0;r=f[m+(p<<2)>>2]|0;f[c+(j<<2)>>2]=(l|0)<(k|0)?k:l;f[c+(p<<2)>>2]=(q|0)<(r|0)?r:q;q=j|2;r=f[e+(q<<2)>>2]|0;p=f[m+(q<<2)>>2]|0;l=j|3;k=f[e+(l<<2)>>2]|0;s=f[m+(l<<2)>>2]|0;f[c+(q<<2)>>2]=(r|0)<(p|0)?p:r;f[c+(l<<2)>>2]=(k|0)<(s|0)?s:k;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{k=f[e+(j<<2)>>2]|0;s=f[m+(j<<2)>>2]|0;f[c+(j<<2)>>2]=(k|0)<(s|0)?s:k;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+d|0;c=c+g|0;e=e+b|0;a=a+-1|0}}return}function AD(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=c;m=f;n=a;o=j;while(1){if(k){p=0;do{q=d[n+(p<<1)>>1]|0;r=d[l+(p<<1)>>1]|0;d[m+(p<<1)>>1]=q<<16>>16<r<<16>>16?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+b|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=f;f=a;a=j;while(1){j=0;do{l=d[f+(j<<1)>>1]|0;k=d[m+(j<<1)>>1]|0;p=j|1;q=d[f+(p<<1)>>1]|0;r=d[m+(p<<1)>>1]|0;d[c+(j<<1)>>1]=l<<16>>16<k<<16>>16?k:l;d[c+(p<<1)>>1]=q<<16>>16<r<<16>>16?r:q;q=j|2;r=d[f+(q<<1)>>1]|0;p=d[m+(q<<1)>>1]|0;l=j|3;k=d[f+(l<<1)>>1]|0;s=d[m+(l<<1)>>1]|0;d[c+(q<<1)>>1]=r<<16>>16<p<<16>>16?p:r;d[c+(l<<1)>>1]=k<<16>>16<s<<16>>16?s:k;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{k=d[f+(j<<1)>>1]|0;s=d[m+(j<<1)>>1]|0;d[c+(j<<1)>>1]=k<<16>>16<s<<16>>16?s:k;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;c=c+g|0;f=f+b|0;a=a+-1|0}}return}function BD(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=c;m=f;n=a;o=j;while(1){if(k){p=0;do{q=d[n+(p<<1)>>1]|0;r=d[l+(p<<1)>>1]|0;d[m+(p<<1)>>1]=(q&65535)<(r&65535)?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+b|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=f;f=a;a=j;while(1){j=0;do{l=d[f+(j<<1)>>1]|0;k=d[m+(j<<1)>>1]|0;p=j|1;q=d[f+(p<<1)>>1]|0;r=d[m+(p<<1)>>1]|0;d[c+(j<<1)>>1]=(l&65535)<(k&65535)?k:l;d[c+(p<<1)>>1]=(q&65535)<(r&65535)?r:q;q=j|2;r=d[f+(q<<1)>>1]|0;p=d[m+(q<<1)>>1]|0;l=j|3;k=d[f+(l<<1)>>1]|0;s=d[m+(l<<1)>>1]|0;d[c+(q<<1)>>1]=(r&65535)<(p&65535)?p:r;d[c+(l<<1)>>1]=(k&65535)<(s&65535)?s:k;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{k=d[f+(j<<1)>>1]|0;s=d[m+(j<<1)>>1]|0;d[c+(j<<1)>>1]=(k&65535)<(s&65535)?s:k;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;c=c+g|0;f=f+b|0;a=a+-1|0}}return}function CD(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=j;while(1){if(k){p=0;do{q=b[n+p>>0]|0;r=b[l+p>>0]|0;b[m+p>>0]=q<<24>>24<r<<24>>24?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=j;while(1){j=0;do{l=b[f+j>>0]|0;k=b[m+j>>0]|0;p=j|1;q=b[f+p>>0]|0;r=b[m+p>>0]|0;b[d+j>>0]=l<<24>>24<k<<24>>24?k:l;b[d+p>>0]=q<<24>>24<r<<24>>24?r:q;q=j|2;r=b[f+q>>0]|0;p=b[m+q>>0]|0;l=j|3;k=b[f+l>>0]|0;s=b[m+l>>0]|0;b[d+q>>0]=r<<24>>24<p<<24>>24?p:r;b[d+l>>0]=k<<24>>24<s<<24>>24?s:k;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{k=b[f+j>>0]|0;s=b[m+j>>0]|0;b[d+j>>0]=k<<24>>24<s<<24>>24?s:k;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function DD(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=d;n=f;o=a;p=k;while(1){if(l){q=0;do{r=h[o+q>>0]|0;b[n+q>>0]=(h[195981+(256-r+(h[m+q>>0]|0))>>0]|0)+r;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+e|0;n=n+g|0;o=o+c|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=d;d=f;f=a;a=k;while(1){k=0;do{m=h[f+k>>0]|0;l=k|1;q=h[f+l>>0]|0;r=(h[195981+(256-q+(h[n+l>>0]|0))>>0]|0)+q&255;b[d+k>>0]=(h[195981+(256-m+(h[n+k>>0]|0))>>0]|0)+m;b[d+l>>0]=r;r=k|2;l=h[f+r>>0]|0;m=k|3;q=h[f+m>>0]|0;s=(h[195981+(256-q+(h[n+m>>0]|0))>>0]|0)+q&255;b[d+r>>0]=(h[195981+(256-l+(h[n+r>>0]|0))>>0]|0)+l;b[d+m>>0]=s;k=k+4|0}while((k|0)<=(j|0));if(o){k=p;do{s=h[f+k>>0]|0;b[d+k>>0]=(h[195981+(256-s+(h[n+k>>0]|0))>>0]|0)+s;k=k+1|0}while((k|0)!=(i|0))}if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function ED(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;dQ(e,40140);fD(a,b,c,UM()|0,40160,0,13);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function FD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;SD(a,b,c,d,e,f,g,h);return}function GD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;RD(a,b,c,d,e,f,g,h);return}function HD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;QD(a,b,c,d,e,f,g,h);return}function ID(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;PD(a,b,c,d,e,f,g,h);return}function JD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;OD(a,b,c,d,e,f,g,h);return}function KD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ND(a,b,c,d,e,f,g,h);return}function LD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;MD(a,b,c,d,e,f,g,h);return}function MD(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0.0,t=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=c;l=e;m=a;n=i;while(1){if(j){o=0;do{q=+p[m+(o<<3)>>3];r=+p[k+(o<<3)>>3];p[l+(o<<3)>>3]=r<q?r:q;o=o+1|0}while((o|0)!=(g|0))}if(!n)break;else{k=k+d|0;l=l+f|0;m=m+b|0;n=n+-1|0}}return}n=g&-4;m=(n|0)<(g|0);l=c;c=e;e=a;a=i;while(1){i=0;do{q=+p[e+(i<<3)>>3];r=+p[l+(i<<3)>>3];k=i|1;s=+p[e+(k<<3)>>3];t=+p[l+(k<<3)>>3];p[c+(i<<3)>>3]=r<q?r:q;p[c+(k<<3)>>3]=t<s?t:s;k=i|2;s=+p[e+(k<<3)>>3];t=+p[l+(k<<3)>>3];j=i|3;q=+p[e+(j<<3)>>3];r=+p[l+(j<<3)>>3];p[c+(k<<3)>>3]=t<s?t:s;p[c+(j<<3)>>3]=r<q?r:q;i=i+4|0}while((i|0)<=(h|0));if(m){i=n;do{q=+p[e+(i<<3)>>3];r=+p[l+(i<<3)>>3];p[c+(i<<3)>>3]=r<q?r:q;i=i+1|0}while((i|0)!=(g|0))}if(!a)break;else{l=l+d|0;c=c+f|0;e=e+b|0;a=a+-1|0}}return}function ND(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=c;l=e;m=a;o=i;while(1){if(j){p=0;do{q=+n[m+(p<<2)>>2];r=+n[k+(p<<2)>>2];n[l+(p<<2)>>2]=r<q?r:q;p=p+1|0}while((p|0)!=(g|0))}if(!o)break;else{k=k+d|0;l=l+f|0;m=m+b|0;o=o+-1|0}}return}o=g&-4;m=(o|0)<(g|0);l=c;c=e;e=a;a=i;while(1){i=0;do{q=+n[e+(i<<2)>>2];r=+n[l+(i<<2)>>2];k=i|1;s=+n[e+(k<<2)>>2];t=+n[l+(k<<2)>>2];n[c+(i<<2)>>2]=r<q?r:q;n[c+(k<<2)>>2]=t<s?t:s;k=i|2;s=+n[e+(k<<2)>>2];t=+n[l+(k<<2)>>2];j=i|3;q=+n[e+(j<<2)>>2];r=+n[l+(j<<2)>>2];n[c+(k<<2)>>2]=t<s?t:s;n[c+(j<<2)>>2]=r<q?r:q;i=i+4|0}while((i|0)<=(h|0));if(m){i=o;do{q=+n[e+(i<<2)>>2];r=+n[l+(i<<2)>>2];n[c+(i<<2)>>2]=r<q?r:q;i=i+1|0}while((i|0)!=(g|0))}if(!a)break;else{l=l+d|0;c=c+f|0;e=e+b|0;a=a+-1|0}}return}function OD(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=c;m=e;n=a;o=j;while(1){if(k){p=0;do{q=f[n+(p<<2)>>2]|0;r=f[l+(p<<2)>>2]|0;f[m+(p<<2)>>2]=(r|0)<(q|0)?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+d|0;m=m+g|0;n=n+b|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=e;e=a;a=j;while(1){j=0;do{l=f[e+(j<<2)>>2]|0;k=f[m+(j<<2)>>2]|0;p=j|1;q=f[e+(p<<2)>>2]|0;r=f[m+(p<<2)>>2]|0;f[c+(j<<2)>>2]=(k|0)<(l|0)?k:l;f[c+(p<<2)>>2]=(r|0)<(q|0)?r:q;q=j|2;r=f[e+(q<<2)>>2]|0;p=f[m+(q<<2)>>2]|0;l=j|3;k=f[e+(l<<2)>>2]|0;s=f[m+(l<<2)>>2]|0;f[c+(q<<2)>>2]=(p|0)<(r|0)?p:r;f[c+(l<<2)>>2]=(s|0)<(k|0)?s:k;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{k=f[e+(j<<2)>>2]|0;s=f[m+(j<<2)>>2]|0;f[c+(j<<2)>>2]=(s|0)<(k|0)?s:k;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+d|0;c=c+g|0;e=e+b|0;a=a+-1|0}}return}function PD(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=c;m=f;n=a;o=j;while(1){if(k){p=0;do{q=d[n+(p<<1)>>1]|0;r=d[l+(p<<1)>>1]|0;d[m+(p<<1)>>1]=r<<16>>16<q<<16>>16?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+b|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=f;f=a;a=j;while(1){j=0;do{l=d[f+(j<<1)>>1]|0;k=d[m+(j<<1)>>1]|0;p=j|1;q=d[f+(p<<1)>>1]|0;r=d[m+(p<<1)>>1]|0;d[c+(j<<1)>>1]=k<<16>>16<l<<16>>16?k:l;d[c+(p<<1)>>1]=r<<16>>16<q<<16>>16?r:q;q=j|2;r=d[f+(q<<1)>>1]|0;p=d[m+(q<<1)>>1]|0;l=j|3;k=d[f+(l<<1)>>1]|0;s=d[m+(l<<1)>>1]|0;d[c+(q<<1)>>1]=p<<16>>16<r<<16>>16?p:r;d[c+(l<<1)>>1]=s<<16>>16<k<<16>>16?s:k;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{k=d[f+(j<<1)>>1]|0;s=d[m+(j<<1)>>1]|0;d[c+(j<<1)>>1]=s<<16>>16<k<<16>>16?s:k;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;c=c+g|0;f=f+b|0;a=a+-1|0}}return}function QD(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=c;m=f;n=a;o=j;while(1){if(k){p=0;do{q=d[n+(p<<1)>>1]|0;r=d[l+(p<<1)>>1]|0;d[m+(p<<1)>>1]=(r&65535)<(q&65535)?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+b|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=f;f=a;a=j;while(1){j=0;do{l=d[f+(j<<1)>>1]|0;k=d[m+(j<<1)>>1]|0;p=j|1;q=d[f+(p<<1)>>1]|0;r=d[m+(p<<1)>>1]|0;d[c+(j<<1)>>1]=(k&65535)<(l&65535)?k:l;d[c+(p<<1)>>1]=(r&65535)<(q&65535)?r:q;q=j|2;r=d[f+(q<<1)>>1]|0;p=d[m+(q<<1)>>1]|0;l=j|3;k=d[f+(l<<1)>>1]|0;s=d[m+(l<<1)>>1]|0;d[c+(q<<1)>>1]=(p&65535)<(r&65535)?p:r;d[c+(l<<1)>>1]=(s&65535)<(k&65535)?s:k;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{k=d[f+(j<<1)>>1]|0;s=d[m+(j<<1)>>1]|0;d[c+(j<<1)>>1]=(s&65535)<(k&65535)?s:k;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;c=c+g|0;f=f+b|0;a=a+-1|0}}return}function RD(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=j;while(1){if(k){p=0;do{q=b[n+p>>0]|0;r=b[l+p>>0]|0;b[m+p>>0]=r<<24>>24<q<<24>>24?r:q;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=j;while(1){j=0;do{l=b[f+j>>0]|0;k=b[m+j>>0]|0;p=j|1;q=b[f+p>>0]|0;r=b[m+p>>0]|0;b[d+j>>0]=k<<24>>24<l<<24>>24?k:l;b[d+p>>0]=r<<24>>24<q<<24>>24?r:q;q=j|2;r=b[f+q>>0]|0;p=b[m+q>>0]|0;l=j|3;k=b[f+l>>0]|0;s=b[m+l>>0]|0;b[d+q>>0]=p<<24>>24<r<<24>>24?p:r;b[d+l>>0]=s<<24>>24<k<<24>>24?s:k;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{k=b[f+j>>0]|0;s=b[m+j>>0]|0;b[d+j>>0]=s<<24>>24<k<<24>>24?s:k;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function SD(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=d;n=f;o=a;p=k;while(1){if(l){q=0;do{r=h[o+q>>0]|0;b[n+q>>0]=r-(h[195981+((r|256)-(h[m+q>>0]|0))>>0]|0);q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+e|0;n=n+g|0;o=o+c|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=d;d=f;f=a;a=k;while(1){k=0;do{m=h[f+k>>0]|0;l=k|1;q=h[f+l>>0]|0;r=q-(h[195981+((q|256)-(h[n+l>>0]|0))>>0]|0)&255;b[d+k>>0]=m-(h[195981+((m|256)-(h[n+k>>0]|0))>>0]|0);b[d+l>>0]=r;r=k|2;l=h[f+r>>0]|0;m=k|3;q=h[f+m>>0]|0;s=q-(h[195981+((q|256)-(h[n+m>>0]|0))>>0]|0)&255;b[d+r>>0]=l-(h[195981+((l|256)-(h[n+r>>0]|0))>>0]|0);b[d+m>>0]=s;k=k+4|0}while((k|0)<=(j|0));if(o){k=p;do{s=h[f+k>>0]|0;b[d+k>>0]=s-(h[195981+((s|256)-(h[n+k>>0]|0))>>0]|0);k=k+1|0}while((k|0)!=(i|0))}if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function TD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d+48|0;g=d+32|0;h=d+16|0;i=d;dQ(e,40192);j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;fD(h,i,g,UM()|0,40108,0,14);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function UD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d+48|0;g=d+32|0;h=d+16|0;i=d;dQ(e,40212);j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=a;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b;fD(h,i,g,UM()|0,40160,0,13);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function VD(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;dQ(h,40232);WD(a,b,c,d,e,40252,0,0,0);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function WD(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;k=u;u=u+1504|0;l=k+1448|0;m=k+1440|0;n=k+1432|0;o=k+1424|0;q=k;r=k+1368|0;s=k+1232|0;t=k+1168|0;v=k+128|0;w=k+104|0;x=k+88|0;y=k+56|0;z=k+1360|0;A=k+1352|0;B=k+1344|0;C=k+1336|0;D=k+1328|0;E=k+1320|0;F=k+1312|0;G=k+1304|0;H=k+1296|0;I=k+1288|0;K=k+1224|0;L=a;M=c;N=yM(a)|0;O=yM(c)|0;P=HM(e)|0;Q=P^1;R=BL(a,-1)|0;S=R&7;T=R>>>3&511;U=T+1|0;V=BL(c,-1)|0;W=V&7;f[m>>2]=W;X=(V>>>3&511)+1|0;Z=_L(a,-1)|0;_=_L(c,-1)|0;$=(Z|0)<3;if($)AL(n,a,-1);else{f[n>>2]=0;f[n+4>>2]=0}aa=(_|0)<3;if(aa)AL(o,c,-1);else{f[o>>2]=0;f[o+4>>2]=0}if((_L(a,-1)|0)<=2?IM(a,-1)|0:0){AL(l,a,-1);ba=f[l>>2]|0;ca=(ba|0)==1;if(!ca?(f[l+4>>2]|0)!=1:0)da=0;else if(!((N|0)!=131072&(O|0)==131072)){ea=f[l+4>>2]|0;fa=(ea|0)==1;if(!((ba|0)==(X|0)&fa|ca&(fa|(ea|0)==(X|0))))if(ca&(ea|0)==4)da=X>>>0<5&(BL(a,-1)|0)==6;else da=0;else da=1}else da=0;ga=da}else ga=0;if((_L(c,-1)|0)<=2?IM(c,-1)|0:0){AL(l,c,-1);da=f[l>>2]|0;ea=(da|0)==1;if(!ea?(f[l+4>>2]|0)!=1:0)ha=0;else if(!((N|0)==131072&(O|0)!=131072)){ca=f[l+4>>2]|0;fa=(ca|0)==1;if(!((da|0)==(U|0)&fa|ea&(fa|(ca|0)==(U|0))))if(ea&(ca|0)==4)ha=U>>>0<5&(BL(c,-1)|0)==6;else ha=0;else ha=1}else ha=0;ia=ha}else ia=0;do if((N|0)==(O|0)|(T|0)==0?!((R|0)!=(V|0)|Q|aa&($&((f[n>>2]|0)==(f[o>>2]|0)?(f[n+4>>2]|0)==(f[o+4>>2]|0):0))^1):0){if(!(MM(d)|0)?(g|0)<0|(g&7|0)==(S|0):0){if(ga^ia)break}else{if(!(MM(d)|0))break;if(ga^ia|(BL(d,-1)|0)!=(R|0))break}NM(d,a,R);do if((yM(a)|0)==65536){ha=f[a+4>>2]|0;f[l>>2]=f[ha>>2];ca=l+4|0;ea=ha+4|0;f[ca>>2]=f[ea>>2];fa=l+8|0;f[fa>>2]=f[ha+8>>2];f[l+12>>2]=f[ha+12>>2];f[l+16>>2]=f[ha+16>>2];f[l+20>>2]=f[ha+20>>2];f[l+24>>2]=f[ha+24>>2];f[l+28>>2]=f[ha+28>>2];f[l+32>>2]=f[ha+32>>2];da=f[ha+36>>2]|0;f[l+36>>2]=da;f[l+40>>2]=fa;fa=l+48|0;ba=l+44|0;f[ba>>2]=fa;f[fa>>2]=0;f[l+52>>2]=0;if(da|0){fa=da+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[ha+44>>2]|0;fa=f[ba>>2]|0;f[fa>>2]=f[ea>>2];f[fa+4>>2]=f[ea+4>>2];break}else{f[ca>>2]=0;jL(l,ha);break}}else yL(l,a,-1);while(0);do if((yM(c)|0)==65536){ha=f[c+4>>2]|0;f[q>>2]=f[ha>>2];ca=q+4|0;ea=ha+4|0;f[ca>>2]=f[ea>>2];fa=q+8|0;f[fa>>2]=f[ha+8>>2];f[q+12>>2]=f[ha+12>>2];f[q+16>>2]=f[ha+16>>2];f[q+20>>2]=f[ha+20>>2];f[q+24>>2]=f[ha+24>>2];f[q+28>>2]=f[ha+28>>2];f[q+32>>2]=f[ha+32>>2];ba=f[ha+36>>2]|0;f[q+36>>2]=ba;f[q+40>>2]=fa;fa=q+48|0;da=q+44|0;f[da>>2]=fa;f[fa>>2]=0;f[q+52>>2]=0;if(ba|0){fa=ba+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[ha+44>>2]|0;fa=f[da>>2]|0;f[fa>>2]=f[ea>>2];f[fa+4>>2]=f[ea+4>>2];break}else{f[ca>>2]=0;jL(q,ha);break}}else yL(q,c,-1);while(0);do if((yM(d)|0)==65536){ha=f[d+4>>2]|0;f[r>>2]=f[ha>>2];ca=r+4|0;ea=ha+4|0;f[ca>>2]=f[ea>>2];fa=r+8|0;f[fa>>2]=f[ha+8>>2];f[r+12>>2]=f[ha+12>>2];f[r+16>>2]=f[ha+16>>2];f[r+20>>2]=f[ha+20>>2];f[r+24>>2]=f[ha+24>>2];f[r+28>>2]=f[ha+28>>2];f[r+32>>2]=f[ha+32>>2];da=f[ha+36>>2]|0;f[r+36>>2]=da;f[r+40>>2]=fa;fa=r+48|0;ba=r+44|0;f[ba>>2]=fa;f[fa>>2]=0;f[r+52>>2]=0;if(da|0){fa=da+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[ha+44>>2]|0;fa=f[ba>>2]|0;f[fa>>2]=f[ea>>2];f[fa+4>>2]=f[ea+4>>2];ja=r;break}else{f[ca>>2]=0;jL(r,ha);ja=r;break}}else{yL(r,d,-1);ja=r}while(0);ha=f[l>>2]|0;ca=(ha>>>3&511)+1|0;ea=f[q>>2]|0;fa=f[ja>>2]|0;ba=f[l+12>>2]|0;da=f[l+8>>2]|0;ka=cbc(ba|0,((ba|0)<0)<<31>>31|0,ca|0,0)|0;la=cbc(ka|0,J|0,da|0,((da|0)<0)<<31>>31|0)|0;if((ha&16384&ea&fa|0)!=0?(la|0)==(la|0)&(((la|0)<0)<<31>>31|0)==(J|0):0){ma=1;na=la}else{ma=da;na=Y(ba,ca)|0}ca=l+16|0;ba=l+44|0;da=l+48|0;la=q+16|0;fa=q+44|0;ea=q+48|0;ha=r+16|0;ka=r+44|0;oa=r+48|0;Th[f[h+(S<<2)>>2]&127](f[ca>>2]|0,f[da>>2]|0,f[la>>2]|0,f[ea>>2]|0,f[ha>>2]|0,f[oa>>2]|0,na,ma,j);pa=r+36|0;qa=f[pa>>2]|0;if(qa|0?(ra=qa+12|0,qa=f[ra>>2]|0,f[ra>>2]=qa+-1,(qa|0)==1):0)kL(r);f[pa>>2]=0;pa=r+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[pa>>2]|0)>0){ha=f[r+40>>2]|0;qa=0;do{f[ha+(qa<<2)>>2]=0;qa=qa+1|0}while((qa|0)<(f[pa>>2]|0))}pa=f[ka>>2]|0;if((pa|0)!=(oa|0))UC(pa);pa=q+36|0;qa=f[pa>>2]|0;if(qa|0?(ha=qa+12|0,qa=f[ha>>2]|0,f[ha>>2]=qa+-1,(qa|0)==1):0)kL(q);f[pa>>2]=0;pa=q+4|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[pa>>2]|0)>0){qa=f[q+40>>2]|0;ha=0;do{f[qa+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[pa>>2]|0))}pa=f[fa>>2]|0;if((pa|0)!=(ea|0))UC(pa);pa=l+36|0;ha=f[pa>>2]|0;do if(ha|0){qa=ha+12|0;la=f[qa>>2]|0;f[qa>>2]=la+-1;if((la|0)!=1)break;kL(l)}while(0);f[pa>>2]=0;ha=l+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[ha>>2]|0)>0){ea=f[l+40>>2]|0;fa=0;do{f[ea+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[ha>>2]|0))}ha=f[ba>>2]|0;if((ha|0)!=(da|0))UC(ha);u=k;return}while(0);do if((Z|0)==(_|0)?(ma=f[n>>2]|0,na=f[n+4>>2]|0,(U|0)==(X|0)&((ma|0)==(f[o>>2]|0)?(na|0)==(f[o+4>>2]|0):0)):0){if((N|0)==131072?(ma|0)==1&((na|0)==4|(na|0)==1):0){sa=87;break}if((O|0)==131072?(ma|0)==1&((na|0)==4|(na|0)==1):0)sa=87;else{ta=0;ua=0;va=R;wa=S;xa=U;ya=V;za=M;Aa=L}}else sa=87;while(0);do if((sa|0)==87){a:do if((_L(a,-1)|0)<=2?IM(a,-1)|0:0){AL(l,a,-1);_=f[l>>2]|0;Z=(_|0)==1;if(!(!Z?(f[l+4>>2]|0)!=1:0))sa=91;do if((sa|0)==91?!((N|0)!=131072&(O|0)==131072):0){na=f[l+4>>2]|0;ma=(na|0)==1;if(!((_|0)==(X|0)&ma|Z&(ma|(na|0)==(X|0)))){if(!(Z&(na|0)==4))break;if(!(X>>>0<5&(BL(a,-1)|0)==6)){sa=98;break a}}na=f[n>>2]|0;ma=n+4|0;ja=f[ma>>2]|0;f[n>>2]=f[o>>2];ia=o+4|0;f[ma>>2]=f[ia>>2];f[o>>2]=na;f[ia>>2]=ja;f[m>>2]=S;Ba=1;Ca=V;Da=W;Ea=X;Fa=R;Ga=U;Ha=L;Ia=M;break a}while(0);sa=98}else sa=98;while(0);b:do if((sa|0)==98){do if((_L(c,-1)|0)<=2?IM(c,-1)|0:0){AL(l,c,-1);da=f[l>>2]|0;ba=(da|0)==1;if(!(!ba?(f[l+4>>2]|0)!=1:0))sa=102;if((sa|0)==102?!((N|0)==131072&(O|0)!=131072):0){Z=f[l+4>>2]|0;_=(Z|0)==1;if((da|0)==(U|0)&_|ba&(_|(Z|0)==(U|0))){Ba=0;Ca=R;Da=S;Ea=U;Fa=V;Ga=X;Ha=M;Ia=L;break b}if(ba&(Z|0)==4)if(U>>>0<5&(BL(c,-1)|0)==6){Ba=0;Ca=R;Da=S;Ea=U;Fa=V;Ga=X;Ha=M;Ia=L;break b}else break}}while(0);f[l>>2]=0;f[l+4>>2]=0;Vac(aD(l,153)|0,172914,153)|0;bO(-209,l,173068,172127,659);bD(l);Ba=0;Ca=R;Da=S;Ea=U;Fa=V;Ga=X;Ha=M;Ia=L}while(0);if((Fa|0)==6)switch(f[o+4>>2]|0){case 4:case 1:break;default:sa=111}else sa=111;if((sa|0)==111){f[l>>2]=0;f[l+4>>2]=0;Z=aD(l,50)|0;ba=173078;_=Z+50|0;do{b[Z>>0]=b[ba>>0]|0;Z=Z+1|0;ba=ba+1|0}while((Z|0)<(_|0));bO(-215,l,173068,172127,661);bD(l)}if(i){f[m>>2]=6;ta=1;ua=Ba<<24>>24!=0;va=Ca;wa=Da;xa=Ea;ya=Fa;za=Ha;Aa=Ia;break}ba=Ha;do if((yM(ba)|0)==65536){Z=f[ba+4>>2]|0;f[l>>2]=f[Z>>2];_=l+4|0;da=Z+4|0;f[_>>2]=f[da>>2];ja=l+8|0;f[ja>>2]=f[Z+8>>2];f[l+12>>2]=f[Z+12>>2];ia=l+16|0;f[ia>>2]=f[Z+16>>2];f[l+20>>2]=f[Z+20>>2];f[l+24>>2]=f[Z+24>>2];f[l+28>>2]=f[Z+28>>2];f[l+32>>2]=f[Z+32>>2];na=f[Z+36>>2]|0;f[l+36>>2]=na;f[l+40>>2]=ja;ja=l+48|0;ma=l+44|0;f[ma>>2]=ja;f[ja>>2]=0;f[l+52>>2]=0;if(na|0){ja=na+12|0;f[ja>>2]=(f[ja>>2]|0)+1}if((f[da>>2]|0)<3){da=f[Z+44>>2]|0;ja=f[ma>>2]|0;f[ja>>2]=f[da>>2];f[ja+4>>2]=f[da+4>>2];Ja=ia;Ka=ma;break}else{f[_>>2]=0;jL(l,Z);Ja=ia;Ka=ma;break}}else{yL(l,ba,-1);Ja=l+16|0;Ka=l+44|0}while(0);ba=f[Ja>>2]|0;ma=((f[o>>2]|0)==1?(f[o+4>>2]|0)==1:0)?Ga:Ea;ia=0;Z=-2147483648;_=2147483647;while(1){La=+p[ba+(ia<<3)>>3];da=MVb(La)|0;if(+(da|0)!=La){sa=126;break}Z=(Z|0)<(da|0)?da:Z;_=(_|0)>(da|0)?da:_;ia=ia+1|0;if((ia|0)>=(ma|0)){sa=123;break}}if((sa|0)==123){ma=(_|0)>-1;if(!(ma&(Z|0)<256))if((_|0)>-129&(Z|0)<128)Ma=1;else Ma=ma&(Z|0)<65536?2:(_|0)>-32769&(Z|0)<32768?3:4;else Ma=0}else if((sa|0)==126){f[m>>2]=6;Ma=Da>>>0<4|(Da|0)==5?5:6}f[m>>2]=Ma;ma=l+36|0;ia=f[ma>>2]|0;if(ia|0?(ba=ia+12|0,ia=f[ba>>2]|0,f[ba>>2]=ia+-1,(ia|0)==1):0)kL(l);f[ma>>2]=0;ma=l+4|0;f[Ja>>2]=0;f[Ja+4>>2]=0;f[Ja+8>>2]=0;f[Ja+12>>2]=0;if((f[ma>>2]|0)>0){ia=f[l+40>>2]|0;ba=0;do{f[ia+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[ma>>2]|0))}ma=f[Ka>>2]|0;if((ma|0)!=(l+48|0))UC(ma);ta=1;ua=Ba<<24>>24!=0;va=Ca;wa=Da;xa=Ea;ya=Fa;za=Ha;Aa=Ia}while(0);do if((g|0)<0){if(MM(d)|0){Na=BL(d,-1)|0;break}if((va|0)==(ya|0)|ta)Na=va;else{f[l>>2]=0;f[l+4>>2]=0;Vac(aD(l,136)|0,173129,136)|0;bO(-5,l,173068,172127,683);bD(l);Na=va}}else Na=g;while(0);g=Na&7;Ia=f[m>>2]|0;do if(!((wa|0)==(Ia|0)&(g|0)==(wa|0))){if(i){m=(Ia|0)>5?Ia:5;Ha=(wa|0)<(m|0)?m:wa;Oa=(Ha|0)<(g|0)?g:Ha;break}if((wa|0)<2&(Ia|0)<2)Pa=3;else Pa=(wa|0)<5&(Ia|0)<5?4:(wa|0)<(Ia|0)?Ia:wa;Ha=(Pa|0)<(g|0)?g:Pa;if(g>>>0<5)Oa=(wa|0)<5|(Ia|0)<5?4:Ha;else Oa=Ha}else Oa=wa;while(0);wa=(xa<<3)+-8|0;Ia=g|wa;g=Oa&7;Pa=g|wa;do if(P)NM(d,Aa,Ia);else{if((BL(e,-1)|0|1|0)==1?(i=Aa,DM(e,i)|0):0)Qa=i;else{f[l>>2]=0;f[l+4>>2]=0;Vac(aD(l,132)|0,173266,132)|0;bO(-215,l,173068,172127,715);bD(l);Qa=Aa}if(DM(d,Qa)|0){i=(BL(d,-1)|0)==(Ia|0);NM(d,Qa,Ia);if(i)break}else NM(d,Qa,Ia);p[q>>3]=0.0;f[l>>2]=-1056833530;f[l+4>>2]=q;f[l+8>>2]=1;f[l+12>>2]=1;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;QM(d,l,r)}while(0);if((va|0)==(Pa|0))Ra=0;else Ra=KI(va,Pa)|0;if((ya|0)!=(va|0))if((ya|0)==(Pa|0))Sa=0;else Sa=KI(ya,Pa)|0;else Sa=Ra;if((Ia|0)==(Pa|0))Ta=0;else Ta=KI(Pa,Ia)|0;Ia=(va>>>3&511)+1<<(47696>>>(va<<1&14)&3);va=(ya>>>3&511)+1<<(47696>>>(ya<<1&14)&3);ya=(wa>>>3&511)+1|0;wa=ya<<(47696>>>(Na<<1&14)&3);f[l>>2]=wa;Na=ya<<(47696>>>(Oa<<1&14)&3);Oa=((Na+1023|0)>>>0)/(Na>>>0)|0;ya=QP(wa)|0;wa=Aa;do if((yM(wa)|0)==65536){Aa=f[wa+4>>2]|0;f[q>>2]=f[Aa>>2];Qa=q+4|0;i=Aa+4|0;f[Qa>>2]=f[i>>2];Ha=q+8|0;f[Ha>>2]=f[Aa+8>>2];f[q+12>>2]=f[Aa+12>>2];f[q+16>>2]=f[Aa+16>>2];f[q+20>>2]=f[Aa+20>>2];f[q+24>>2]=f[Aa+24>>2];f[q+28>>2]=f[Aa+28>>2];f[q+32>>2]=f[Aa+32>>2];m=f[Aa+36>>2]|0;f[q+36>>2]=m;f[q+40>>2]=Ha;Ha=q+48|0;Fa=q+44|0;f[Fa>>2]=Ha;f[Ha>>2]=0;f[q+52>>2]=0;if(m|0){Ha=m+12|0;f[Ha>>2]=(f[Ha>>2]|0)+1}if((f[i>>2]|0)<3){i=f[Aa+44>>2]|0;Ha=f[Fa>>2]|0;f[Ha>>2]=f[i>>2];f[Ha+4>>2]=f[i+4>>2];break}else{f[Qa>>2]=0;jL(q,Aa);break}}else yL(q,wa,-1);while(0);wa=za;do if((yM(wa)|0)==65536){za=f[wa+4>>2]|0;f[r>>2]=f[za>>2];Aa=r+4|0;Qa=za+4|0;f[Aa>>2]=f[Qa>>2];i=r+8|0;f[i>>2]=f[za+8>>2];f[r+12>>2]=f[za+12>>2];f[r+16>>2]=f[za+16>>2];f[r+20>>2]=f[za+20>>2];f[r+24>>2]=f[za+24>>2];f[r+28>>2]=f[za+28>>2];f[r+32>>2]=f[za+32>>2];Ha=f[za+36>>2]|0;f[r+36>>2]=Ha;f[r+40>>2]=i;i=r+48|0;Fa=r+44|0;f[Fa>>2]=i;f[i>>2]=0;f[r+52>>2]=0;if(Ha|0){i=Ha+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[Qa>>2]|0)<3){Qa=f[za+44>>2]|0;i=f[Fa>>2]|0;f[i>>2]=f[Qa>>2];f[i+4>>2]=f[Qa+4>>2];break}else{f[Aa>>2]=0;jL(r,za);break}}else yL(r,wa,-1);while(0);do if((yM(d)|0)==65536){wa=f[d+4>>2]|0;f[s>>2]=f[wa>>2];za=s+4|0;Aa=wa+4|0;f[za>>2]=f[Aa>>2];Qa=s+8|0;f[Qa>>2]=f[wa+8>>2];f[s+12>>2]=f[wa+12>>2];f[s+16>>2]=f[wa+16>>2];f[s+20>>2]=f[wa+20>>2];f[s+24>>2]=f[wa+24>>2];f[s+28>>2]=f[wa+28>>2];f[s+32>>2]=f[wa+32>>2];i=f[wa+36>>2]|0;f[s+36>>2]=i;f[s+40>>2]=Qa;Qa=s+48|0;Fa=s+44|0;f[Fa>>2]=Qa;f[Qa>>2]=0;f[s+52>>2]=0;if(i|0){Qa=i+12|0;f[Qa>>2]=(f[Qa>>2]|0)+1}if((f[Aa>>2]|0)<3){Aa=f[wa+44>>2]|0;Qa=f[Fa>>2]|0;f[Qa>>2]=f[Aa>>2];f[Qa+4>>2]=f[Aa+4>>2];break}else{f[za>>2]=0;jL(s,wa);break}}else yL(s,d,-1);while(0);do if((yM(e)|0)==65536){d=f[e+4>>2]|0;f[t>>2]=f[d>>2];wa=t+4|0;za=d+4|0;f[wa>>2]=f[za>>2];Aa=t+8|0;f[Aa>>2]=f[d+8>>2];f[t+12>>2]=f[d+12>>2];f[t+16>>2]=f[d+16>>2];f[t+20>>2]=f[d+20>>2];f[t+24>>2]=f[d+24>>2];f[t+28>>2]=f[d+28>>2];f[t+32>>2]=f[d+32>>2];Qa=f[d+36>>2]|0;f[t+36>>2]=Qa;f[t+40>>2]=Aa;Aa=t+48|0;Fa=t+44|0;f[Fa>>2]=Aa;f[Aa>>2]=0;f[t+52>>2]=0;if(Qa|0){Aa=Qa+12|0;f[Aa>>2]=(f[Aa>>2]|0)+1}if((f[za>>2]|0)<3){za=f[d+44>>2]|0;Aa=f[Fa>>2]|0;f[Aa>>2]=f[za>>2];f[Aa+4>>2]=f[za+4>>2];break}else{f[wa>>2]=0;jL(t,d);break}}else yL(t,e,-1);while(0);e=v+8|0;f[v>>2]=e;d=v+4|0;f[d>>2]=1032;wa=(Ra|0)!=0;za=(Sa|0)!=0;Aa=(Ta|0)!=0;Fa=(ta|za?Na:0)+(wa?Na:0)+(Aa?Na:0)+(P?0:f[l>>2]|0)|0;Qa=f[h+(g<<2)>>2]|0;if(ta){f[w>>2]=q;f[w+4>>2]=s;f[w+8>>2]=t;f[w+12>>2]=0;RN(y,w,x,-1);ta=f[y+20>>2]|0;g=Oa>>>0<ta>>>0?Oa:ta;h=(Y(g,Fa)|0)+64|0;do if((f[d>>2]|0)>>>0<h>>>0){i=f[v>>2]|0;if((i|0)!=(e|0)){if(i|0)P5b(i);f[v>>2]=e;f[d>>2]=1032}f[d>>2]=h;if(h>>>0<=1032){Ua=e;break}i=N5b(h)|0;f[v>>2]=i;Ua=i}else{f[d>>2]=h;Ua=f[v>>2]|0}while(0);h=Y(g,Na)|0;i=wa?Ua+h+15&-16:Ua;Ha=wa?Ua:0;Ua=i+h+15&-16;m=P?Ua:Aa?Ua+h+15&-16:Ua;cD(r,Pa,i,g);Pa=y+16|0;h=(ta|0)==0;Ea=i;i=x+4|0;Da=F+4|0;Ca=Ha;Ba=Aa|Q;Ka=G+4|0;Ja=I+4|0;Ma=x+8|0;sa=K+4|0;Ga=H+4|0;o=0;while(1){if(o>>>0>=(f[Pa>>2]|0)>>>0)break;if(!h){L=0;M=f[x>>2]|0;X=f[i>>2]|0;do{V=ta-L|0;U=V>>>0>g>>>0?g:V;V=Y(U,xa)|0;if(wa){f[F>>2]=V;f[Da>>2]=1;Hh[Ra&255](M,1,0,1,Ha,1,F,0);Va=Ca}else Va=M;S=ua?Ea:Va;R=ua?Va:Ea;do if(Ba){Th[Qa&127](S,1,R,1,Ua,1,V,1,j);if(P){f[G>>2]=V;f[Ka>>2]=1;Hh[Ta&255](Ua,1,0,1,X,1,G,0);break}if(Aa){f[I>>2]=V;f[Ja>>2]=1;Hh[Ta&255](Ua,1,0,1,m,1,I,0);c=f[Ma>>2]|0;f[K>>2]=U;f[sa>>2]=1;Hh[ya&255](m,1,c,1,X,1,K,l)}else{c=f[Ma>>2]|0;f[H>>2]=U;f[Ga>>2]=1;Hh[ya&255](Ua,1,c,1,X,1,H,l)}f[Ma>>2]=(f[Ma>>2]|0)+U}else Th[Qa&127](S,1,R,1,X,1,V,1,j);while(0);V=Y(U,Ia)|0;M=(f[x>>2]|0)+V|0;f[x>>2]=M;V=Y(f[l>>2]|0,U)|0;X=(f[i>>2]|0)+V|0;f[i>>2]=X;L=L+g|0}while(ta>>>0>L>>>0)}aL(y)|0;o=o+1|0}}else{f[w>>2]=q;f[w+4>>2]=r;f[w+8>>2]=s;f[w+12>>2]=t;f[w+16>>2]=0;RN(y,w,x,-1);w=f[y+20>>2]|0;o=(wa|Q|za|Aa)&Oa>>>0<w>>>0?Oa:w;Oa=(Y(o,Fa)|0)+64|0;do if((f[d>>2]|0)>>>0<Oa>>>0){Fa=f[v>>2]|0;if((Fa|0)!=(e|0)){if(Fa|0)P5b(Fa);f[v>>2]=e;f[d>>2]=1032}f[d>>2]=Oa;if(Oa>>>0<=1032){Wa=e;break}Fa=N5b(Oa)|0;f[v>>2]=Fa;Wa=Fa}else{f[d>>2]=Oa;Wa=f[v>>2]|0}while(0);Oa=Y(o,Na)|0;Na=wa?Wa+Oa+15&-16:Wa;Fa=wa?Wa:0;ta=za?Na+Oa+15&-16:Na;g=za?Na:0;Na=P?ta:Aa?ta+Oa+15&-16:ta;Oa=y+16|0;i=(w|0)==0;Ma=x+4|0;H=x+8|0;Ua=z+4|0;Ga=za^1;za=Aa|Q;Q=B+4|0;K=D+4|0;m=x+12|0;sa=E+4|0;I=C+4|0;Ja=A+4|0;G=0;while(1){if(G>>>0>=(f[Oa>>2]|0)>>>0)break;if(!i){Ka=0;Ba=f[x>>2]|0;Ea=f[Ma>>2]|0;Va=f[H>>2]|0;do{ua=w-Ka|0;Ca=ua>>>0>o>>>0?o:ua;ua=Y(Ca,xa)|0;if(wa){f[z>>2]=ua;f[Ua>>2]=1;Hh[Ra&255](Ba,1,0,1,Fa,1,z,0);Xa=Wa;Ya=f[x>>2]|0;Za=f[Ma>>2]|0}else{Xa=Ba;Ya=Ba;Za=Ea}F=(Ya|0)==(Za|0);if(F|Ga)_a=F?Xa:Ea;else{f[A>>2]=ua;f[Ja>>2]=1;Hh[Sa&255](Ea,1,0,1,g,1,A,0);_a=g}do if(za){Th[Qa&127](Xa,1,_a,1,ta,0,ua,1,j);if(P){f[B>>2]=ua;f[Q>>2]=1;Hh[Ta&255](ta,1,0,1,Va,1,B,0);break}if(Aa){f[D>>2]=ua;f[K>>2]=1;Hh[Ta&255](ta,1,0,1,Na,1,D,0);F=f[m>>2]|0;f[E>>2]=Ca;f[sa>>2]=1;Hh[ya&255](Na,1,F,1,Va,1,E,l)}else{F=f[m>>2]|0;f[C>>2]=Ca;f[I>>2]=1;Hh[ya&255](ta,1,F,1,Va,1,C,l)}f[m>>2]=(f[m>>2]|0)+Ca}else Th[Qa&127](Xa,1,_a,1,Va,1,ua,1,j);while(0);ua=Y(Ca,Ia)|0;Ba=(f[x>>2]|0)+ua|0;f[x>>2]=Ba;ua=Y(Ca,va)|0;Ea=(f[Ma>>2]|0)+ua|0;f[Ma>>2]=Ea;ua=Y(f[l>>2]|0,Ca)|0;Va=(f[H>>2]|0)+ua|0;f[H>>2]=Va;Ka=Ka+o|0}while(w>>>0>Ka>>>0)}aL(y)|0;G=G+1|0}}G=f[v>>2]|0;if((G|0)!=(e|0)){if(G|0)P5b(G);f[v>>2]=e;f[d>>2]=1032}d=t+36|0;e=f[d>>2]|0;do if(e|0){v=e+12|0;G=f[v>>2]|0;f[v>>2]=G+-1;if((G|0)!=1)break;kL(t)}while(0);f[d>>2]=0;d=t+16|0;e=t+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){d=f[t+40>>2]|0;G=0;do{f[d+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[e>>2]|0))}e=f[t+44>>2]|0;if((e|0)!=(t+48|0))UC(e);e=s+36|0;t=f[e>>2]|0;do if(t|0){G=t+12|0;d=f[G>>2]|0;f[G>>2]=d+-1;if((d|0)!=1)break;kL(s)}while(0);f[e>>2]=0;e=s+16|0;t=s+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[t>>2]|0)>0){e=f[s+40>>2]|0;d=0;do{f[e+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[t>>2]|0))}t=f[s+44>>2]|0;if((t|0)!=(s+48|0))UC(t);t=r+36|0;s=f[t>>2]|0;do if(s|0){d=s+12|0;e=f[d>>2]|0;f[d>>2]=e+-1;if((e|0)!=1)break;kL(r)}while(0);f[t>>2]=0;t=r+16|0;s=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[r+40>>2]|0;e=0;do{f[t+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))UC(s);s=q+36|0;r=f[s>>2]|0;do if(r|0){e=r+12|0;t=f[e>>2]|0;f[e>>2]=t+-1;if((t|0)!=1)break;kL(q)}while(0);f[s>>2]=0;s=q+16|0;r=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[q+40>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))UC(r);u=k;return}function XD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;iE(a,b,c,d,e,f,g,h);return}function YD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;hE(a,b,c,d,e,f,g,h);return}function ZD(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;gE(a,b,c,d,e,f,g,h);return}function _D(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;fE(a,b,c,d,e,f,g,h);return}function $D(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;eE(a,b,c,d,e,f,g,h);return}function aE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;dE(a,b,c,d,e,f,g,h);return}function bE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;cE(a,b,c,d,e,f,g,h);return}function cE(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=c;l=e;m=a;n=i;while(1){if(j){o=0;do{p[l+(o<<3)>>3]=+p[m+(o<<3)>>3]+ +p[k+(o<<3)>>3];o=o+1|0}while((o|0)!=(g|0))}if(!n)break;else{k=k+d|0;l=l+f|0;m=m+b|0;n=n+-1|0}}return}n=g&-4;m=(n|0)<(g|0);l=c;c=e;e=a;a=i;while(1){i=0;do{k=i|1;q=+p[e+(k<<3)>>3]+ +p[l+(k<<3)>>3];p[c+(i<<3)>>3]=+p[e+(i<<3)>>3]+ +p[l+(i<<3)>>3];p[c+(k<<3)>>3]=q;k=i|2;j=i|3;q=+p[e+(j<<3)>>3]+ +p[l+(j<<3)>>3];p[c+(k<<3)>>3]=+p[e+(k<<3)>>3]+ +p[l+(k<<3)>>3];p[c+(j<<3)>>3]=q;i=i+4|0}while((i|0)<=(h|0));if(m){i=n;do{p[c+(i<<3)>>3]=+p[e+(i<<3)>>3]+ +p[l+(i<<3)>>3];i=i+1|0}while((i|0)!=(g|0))}if(!a)break;else{l=l+d|0;c=c+f|0;e=e+b|0;a=a+-1|0}}return}function dE(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=c;l=e;m=a;o=i;while(1){if(j){p=0;do{n[l+(p<<2)>>2]=+n[m+(p<<2)>>2]+ +n[k+(p<<2)>>2];p=p+1|0}while((p|0)!=(g|0))}if(!o)break;else{k=k+d|0;l=l+f|0;m=m+b|0;o=o+-1|0}}return}o=g&-4;m=(o|0)<(g|0);l=c;c=e;e=a;a=i;while(1){i=0;do{k=i|1;q=+n[e+(k<<2)>>2]+ +n[l+(k<<2)>>2];n[c+(i<<2)>>2]=+n[e+(i<<2)>>2]+ +n[l+(i<<2)>>2];n[c+(k<<2)>>2]=q;k=i|2;j=i|3;q=+n[e+(j<<2)>>2]+ +n[l+(j<<2)>>2];n[c+(k<<2)>>2]=+n[e+(k<<2)>>2]+ +n[l+(k<<2)>>2];n[c+(j<<2)>>2]=q;i=i+4|0}while((i|0)<=(h|0));if(m){i=o;do{n[c+(i<<2)>>2]=+n[e+(i<<2)>>2]+ +n[l+(i<<2)>>2];i=i+1|0}while((i|0)!=(g|0))}if(!a)break;else{l=l+d|0;c=c+f|0;e=e+b|0;a=a+-1|0}}return}function eE(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=c;m=e;n=a;o=j;while(1){if(k){p=0;do{f[m+(p<<2)>>2]=(f[l+(p<<2)>>2]|0)+(f[n+(p<<2)>>2]|0);p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+d|0;m=m+g|0;n=n+b|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=e;e=a;a=j;while(1){j=0;do{l=j|1;k=(f[m+(l<<2)>>2]|0)+(f[e+(l<<2)>>2]|0)|0;f[c+(j<<2)>>2]=(f[m+(j<<2)>>2]|0)+(f[e+(j<<2)>>2]|0);f[c+(l<<2)>>2]=k;k=j|2;l=j|3;p=(f[m+(l<<2)>>2]|0)+(f[e+(l<<2)>>2]|0)|0;f[c+(k<<2)>>2]=(f[m+(k<<2)>>2]|0)+(f[e+(k<<2)>>2]|0);f[c+(l<<2)>>2]=p;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{f[c+(j<<2)>>2]=(f[m+(j<<2)>>2]|0)+(f[e+(j<<2)>>2]|0);j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+d|0;c=c+g|0;e=e+b|0;a=a+-1|0}}return}function fE(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=c;m=f;n=a;o=j;while(1){if(k){p=0;do{q=(d[l+(p<<1)>>1]|0)+(d[n+(p<<1)>>1]|0)|0;d[m+(p<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+b|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=f;f=a;a=j;while(1){j=0;do{l=(d[m+(j<<1)>>1]|0)+(d[f+(j<<1)>>1]|0)|0;k=j|1;p=(d[m+(k<<1)>>1]|0)+(d[f+(k<<1)>>1]|0)|0;d[c+(j<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;d[c+(k<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;p=j|2;k=(d[m+(p<<1)>>1]|0)+(d[f+(p<<1)>>1]|0)|0;l=j|3;q=(d[m+(l<<1)>>1]|0)+(d[f+(l<<1)>>1]|0)|0;d[c+(p<<1)>>1]=(k+32768|0)>>>0<65536?k:(k|0)>0?32767:32768;d[c+(l<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{q=(d[m+(j<<1)>>1]|0)+(d[f+(j<<1)>>1]|0)|0;d[c+(j<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;c=c+g|0;f=f+b|0;a=a+-1|0}}return}function gE(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){l=(h|0)>0;m=c;n=f;o=a;p=k;while(1){if(l){q=0;do{r=(j[m+(q<<1)>>1]|0)+(j[o+(q<<1)>>1]|0)|0;d[n+(q<<1)>>1]=r>>>0<65536?r:r|0?65535:0;q=q+1|0}while((q|0)!=(h|0))}if(!p)break;else{m=m+e|0;n=n+g|0;o=o+b|0;p=p+-1|0}}return}p=h&-4;o=(p|0)<(h|0);n=c;c=f;f=a;a=k;while(1){k=0;do{m=(j[n+(k<<1)>>1]|0)+(j[f+(k<<1)>>1]|0)|0;l=k|1;q=(j[n+(l<<1)>>1]|0)+(j[f+(l<<1)>>1]|0)|0;d[c+(k<<1)>>1]=m>>>0<65536?m:m|0?65535:0;d[c+(l<<1)>>1]=q>>>0<65536?q:q|0?65535:0;q=k|2;l=(j[n+(q<<1)>>1]|0)+(j[f+(q<<1)>>1]|0)|0;m=k|3;r=(j[n+(m<<1)>>1]|0)+(j[f+(m<<1)>>1]|0)|0;d[c+(q<<1)>>1]=l>>>0<65536?l:l|0?65535:0;d[c+(m<<1)>>1]=r>>>0<65536?r:r|0?65535:0;k=k+4|0}while((k|0)<=(i|0));if(o){k=p;do{r=(j[n+(k<<1)>>1]|0)+(j[f+(k<<1)>>1]|0)|0;d[c+(k<<1)>>1]=r>>>0<65536?r:r|0?65535:0;k=k+1|0}while((k|0)!=(h|0))}if(!a)break;else{n=n+e|0;c=c+g|0;f=f+b|0;a=a+-1|0}}return}function hE(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=j;while(1){if(k){p=0;do{q=(b[l+p>>0]|0)+(b[n+p>>0]|0)|0;b[m+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=j;while(1){j=0;do{l=(b[m+j>>0]|0)+(b[f+j>>0]|0)|0;k=j|1;p=(b[m+k>>0]|0)+(b[f+k>>0]|0)|0;b[d+j>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[d+k>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;p=j|2;k=(b[m+p>>0]|0)+(b[f+p>>0]|0)|0;l=j|3;q=(b[m+l>>0]|0)+(b[f+l>>0]|0)|0;b[d+p>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;b[d+l>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{q=(b[m+j>>0]|0)+(b[f+j>>0]|0)|0;b[d+j>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function iE(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=d;n=f;o=a;p=k;while(1){if(l){q=0;do{b[n+q>>0]=b[195981+((h[o+q>>0]|0|256)+(h[m+q>>0]|0))>>0]|0;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+e|0;n=n+g|0;o=o+c|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=d;d=f;f=a;a=k;while(1){k=0;do{m=k|1;l=b[195981+((h[f+m>>0]|0|256)+(h[n+m>>0]|0))>>0]|0;b[d+k>>0]=b[195981+((h[f+k>>0]|0|256)+(h[n+k>>0]|0))>>0]|0;b[d+m>>0]=l;l=k|2;m=k|3;q=b[195981+((h[f+m>>0]|0|256)+(h[n+m>>0]|0))>>0]|0;b[d+l>>0]=b[195981+((h[f+l>>0]|0|256)+(h[n+l>>0]|0))>>0]|0;b[d+m>>0]=q;k=k+4|0}while((k|0)<=(j|0));if(o){k=p;do{b[d+k>>0]=b[195981+((h[f+k>>0]|0|256)+(h[n+k>>0]|0))>>0]|0;k=k+1|0}while((k|0)!=(i|0))}if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function jE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;dQ(h,40284);WD(a,b,c,d,e,40304,0,0,1);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function kE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;xE(a,b,c,d,e,f,g,h);return}function lE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;wE(a,b,c,d,e,f,g,h);return}function mE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;vE(a,b,c,d,e,f,g,h);return}function nE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;uE(a,b,c,d,e,f,g,h);return}function oE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;tE(a,b,c,d,e,f,g,h);return}function pE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;sE(a,b,c,d,e,f,g,h);return}function qE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;rE(a,b,c,d,e,f,g,h);return}function rE(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=c;l=e;m=a;n=i;while(1){if(j){o=0;do{p[l+(o<<3)>>3]=+p[m+(o<<3)>>3]-+p[k+(o<<3)>>3];o=o+1|0}while((o|0)!=(g|0))}if(!n)break;else{k=k+d|0;l=l+f|0;m=m+b|0;n=n+-1|0}}return}n=g&-4;m=(n|0)<(g|0);l=c;c=e;e=a;a=i;while(1){i=0;do{k=i|1;q=+p[e+(k<<3)>>3]-+p[l+(k<<3)>>3];p[c+(i<<3)>>3]=+p[e+(i<<3)>>3]-+p[l+(i<<3)>>3];p[c+(k<<3)>>3]=q;k=i|2;j=i|3;q=+p[e+(j<<3)>>3]-+p[l+(j<<3)>>3];p[c+(k<<3)>>3]=+p[e+(k<<3)>>3]-+p[l+(k<<3)>>3];p[c+(j<<3)>>3]=q;i=i+4|0}while((i|0)<=(h|0));if(m){i=n;do{p[c+(i<<3)>>3]=+p[e+(i<<3)>>3]-+p[l+(i<<3)>>3];i=i+1|0}while((i|0)!=(g|0))}if(!a)break;else{l=l+d|0;c=c+f|0;e=e+b|0;a=a+-1|0}}return}function sE(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=c;l=e;m=a;o=i;while(1){if(j){p=0;do{n[l+(p<<2)>>2]=+n[m+(p<<2)>>2]-+n[k+(p<<2)>>2];p=p+1|0}while((p|0)!=(g|0))}if(!o)break;else{k=k+d|0;l=l+f|0;m=m+b|0;o=o+-1|0}}return}o=g&-4;m=(o|0)<(g|0);l=c;c=e;e=a;a=i;while(1){i=0;do{k=i|1;q=+n[e+(k<<2)>>2]-+n[l+(k<<2)>>2];n[c+(i<<2)>>2]=+n[e+(i<<2)>>2]-+n[l+(i<<2)>>2];n[c+(k<<2)>>2]=q;k=i|2;j=i|3;q=+n[e+(j<<2)>>2]-+n[l+(j<<2)>>2];n[c+(k<<2)>>2]=+n[e+(k<<2)>>2]-+n[l+(k<<2)>>2];n[c+(j<<2)>>2]=q;i=i+4|0}while((i|0)<=(h|0));if(m){i=o;do{n[c+(i<<2)>>2]=+n[e+(i<<2)>>2]-+n[l+(i<<2)>>2];i=i+1|0}while((i|0)!=(g|0))}if(!a)break;else{l=l+d|0;c=c+f|0;e=e+b|0;a=a+-1|0}}return}function tE(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=c;m=e;n=a;o=j;while(1){if(k){p=0;do{f[m+(p<<2)>>2]=(f[n+(p<<2)>>2]|0)-(f[l+(p<<2)>>2]|0);p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+d|0;m=m+g|0;n=n+b|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=e;e=a;a=j;while(1){j=0;do{l=j|1;k=(f[e+(l<<2)>>2]|0)-(f[m+(l<<2)>>2]|0)|0;f[c+(j<<2)>>2]=(f[e+(j<<2)>>2]|0)-(f[m+(j<<2)>>2]|0);f[c+(l<<2)>>2]=k;k=j|2;l=j|3;p=(f[e+(l<<2)>>2]|0)-(f[m+(l<<2)>>2]|0)|0;f[c+(k<<2)>>2]=(f[e+(k<<2)>>2]|0)-(f[m+(k<<2)>>2]|0);f[c+(l<<2)>>2]=p;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{f[c+(j<<2)>>2]=(f[e+(j<<2)>>2]|0)-(f[m+(j<<2)>>2]|0);j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+d|0;c=c+g|0;e=e+b|0;a=a+-1|0}}return}function uE(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=c;m=f;n=a;o=j;while(1){if(k){p=0;do{q=(d[n+(p<<1)>>1]|0)-(d[l+(p<<1)>>1]|0)|0;d[m+(p<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+b|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=f;f=a;a=j;while(1){j=0;do{l=(d[f+(j<<1)>>1]|0)-(d[m+(j<<1)>>1]|0)|0;k=j|1;p=(d[f+(k<<1)>>1]|0)-(d[m+(k<<1)>>1]|0)|0;d[c+(j<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;d[c+(k<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;p=j|2;k=(d[f+(p<<1)>>1]|0)-(d[m+(p<<1)>>1]|0)|0;l=j|3;q=(d[f+(l<<1)>>1]|0)-(d[m+(l<<1)>>1]|0)|0;d[c+(p<<1)>>1]=(k+32768|0)>>>0<65536?k:(k|0)>0?32767:32768;d[c+(l<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{q=(d[f+(j<<1)>>1]|0)-(d[m+(j<<1)>>1]|0)|0;d[c+(j<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;c=c+g|0;f=f+b|0;a=a+-1|0}}return}function vE(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){l=(h|0)>0;m=c;n=f;o=a;p=k;while(1){if(l){q=0;do{r=(j[o+(q<<1)>>1]|0)-(j[m+(q<<1)>>1]|0)|0;d[n+(q<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;q=q+1|0}while((q|0)!=(h|0))}if(!p)break;else{m=m+e|0;n=n+g|0;o=o+b|0;p=p+-1|0}}return}p=h&-4;o=(p|0)<(h|0);n=c;c=f;f=a;a=k;while(1){k=0;do{m=(j[f+(k<<1)>>1]|0)-(j[n+(k<<1)>>1]|0)|0;l=k|1;q=(j[f+(l<<1)>>1]|0)-(j[n+(l<<1)>>1]|0)|0;d[c+(k<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;d[c+(l<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;q=k|2;l=(j[f+(q<<1)>>1]|0)-(j[n+(q<<1)>>1]|0)|0;m=k|3;r=(j[f+(m<<1)>>1]|0)-(j[n+(m<<1)>>1]|0)|0;d[c+(q<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;d[c+(m<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;k=k+4|0}while((k|0)<=(i|0));if(o){k=p;do{r=(j[f+(k<<1)>>1]|0)-(j[n+(k<<1)>>1]|0)|0;d[c+(k<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;k=k+1|0}while((k|0)!=(h|0))}if(!a)break;else{n=n+e|0;c=c+g|0;f=f+b|0;a=a+-1|0}}return}function wE(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=j;while(1){if(k){p=0;do{q=(b[n+p>>0]|0)-(b[l+p>>0]|0)|0;b[m+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=j;while(1){j=0;do{l=(b[f+j>>0]|0)-(b[m+j>>0]|0)|0;k=j|1;p=(b[f+k>>0]|0)-(b[m+k>>0]|0)|0;b[d+j>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[d+k>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;p=j|2;k=(b[f+p>>0]|0)-(b[m+p>>0]|0)|0;l=j|3;q=(b[f+l>>0]|0)-(b[m+l>>0]|0)|0;b[d+p>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;b[d+l>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{q=(b[f+j>>0]|0)-(b[m+j>>0]|0)|0;b[d+j>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function xE(a,c,d,e,f,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){l=(i|0)>0;m=d;n=f;o=a;p=k;while(1){if(l){q=0;do{b[n+q>>0]=b[195981+((h[o+q>>0]|0|256)-(h[m+q>>0]|0))>>0]|0;q=q+1|0}while((q|0)!=(i|0))}if(!p)break;else{m=m+e|0;n=n+g|0;o=o+c|0;p=p+-1|0}}return}p=i&-4;o=(p|0)<(i|0);n=d;d=f;f=a;a=k;while(1){k=0;do{m=k|1;l=b[195981+((h[f+m>>0]|0|256)-(h[n+m>>0]|0))>>0]|0;b[d+k>>0]=b[195981+((h[f+k>>0]|0|256)-(h[n+k>>0]|0))>>0]|0;b[d+m>>0]=l;l=k|2;m=k|3;q=b[195981+((h[f+m>>0]|0|256)-(h[n+m>>0]|0))>>0]|0;b[d+l>>0]=b[195981+((h[f+l>>0]|0|256)-(h[n+l>>0]|0))>>0]|0;b[d+m>>0]=q;k=k+4|0}while((k|0)<=(j|0));if(o){k=p;do{b[d+k>>0]=b[195981+((h[f+k>>0]|0|256)-(h[n+k>>0]|0))>>0]|0;k=k+1|0}while((k|0)!=(i|0))}if(!a)break;else{n=n+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function yE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;dQ(e,40336);WD(a,b,c,UM()|0,-1,40356,0,0,3);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function zE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ME(a,b,c,d,e,f,g,h);return}function AE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;LE(a,b,c,d,e,f,g,h);return}function BE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;KE(a,b,c,d,e,f,g,h);return}function CE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;JE(a,b,c,d,e,f,g,h);return}function DE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;IE(a,b,c,d,e,f,g,h);return}function EE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;HE(a,b,c,d,e,f,g,h);return}function FE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;GE(a,b,c,d,e,f,g,h);return}function GE(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=c;l=e;m=a;n=i;while(1){if(j){o=0;do{q=+L(+(+p[m+(o<<3)>>3]-+p[k+(o<<3)>>3]));p[l+(o<<3)>>3]=q;o=o+1|0}while((o|0)!=(g|0))}if(!n)break;else{k=k+d|0;l=l+f|0;m=m+b|0;n=n+-1|0}}return}n=g&-4;m=(n|0)<(g|0);l=c;c=e;e=a;a=i;while(1){i=0;do{q=+L(+(+p[e+(i<<3)>>3]-+p[l+(i<<3)>>3]));k=i|1;r=+L(+(+p[e+(k<<3)>>3]-+p[l+(k<<3)>>3]));p[c+(i<<3)>>3]=q;p[c+(k<<3)>>3]=r;k=i|2;r=+L(+(+p[e+(k<<3)>>3]-+p[l+(k<<3)>>3]));j=i|3;q=+L(+(+p[e+(j<<3)>>3]-+p[l+(j<<3)>>3]));p[c+(k<<3)>>3]=r;p[c+(j<<3)>>3]=q;i=i+4|0}while((i|0)<=(h|0));if(m){i=n;do{q=+L(+(+p[e+(i<<3)>>3]-+p[l+(i<<3)>>3]));p[c+(i<<3)>>3]=q;i=i+1|0}while((i|0)!=(g|0))}if(!a)break;else{l=l+d|0;c=c+f|0;e=e+b|0;a=a+-1|0}}return}function HE(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0;i=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){j=(g|0)>0;k=c;l=e;m=a;o=i;while(1){if(j){p=0;do{q=+L(+(+n[m+(p<<2)>>2]-+n[k+(p<<2)>>2]));n[l+(p<<2)>>2]=q;p=p+1|0}while((p|0)!=(g|0))}if(!o)break;else{k=k+d|0;l=l+f|0;m=m+b|0;o=o+-1|0}}return}o=g&-4;m=(o|0)<(g|0);l=c;c=e;e=a;a=i;while(1){i=0;do{q=+L(+(+n[e+(i<<2)>>2]-+n[l+(i<<2)>>2]));k=i|1;r=+L(+(+n[e+(k<<2)>>2]-+n[l+(k<<2)>>2]));n[c+(i<<2)>>2]=q;n[c+(k<<2)>>2]=r;k=i|2;r=+L(+(+n[e+(k<<2)>>2]-+n[l+(k<<2)>>2]));j=i|3;q=+L(+(+n[e+(j<<2)>>2]-+n[l+(j<<2)>>2]));n[c+(k<<2)>>2]=r;n[c+(j<<2)>>2]=q;i=i+4|0}while((i|0)<=(h|0));if(m){i=o;do{q=+L(+(+n[e+(i<<2)>>2]-+n[l+(i<<2)>>2]));n[c+(i<<2)>>2]=q;i=i+1|0}while((i|0)!=(g|0))}if(!a)break;else{l=l+d|0;c=c+f|0;e=e+b|0;a=a+-1|0}}return}function IE(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=c;m=e;n=a;o=j;while(1){if(k){p=0;do{q=f[n+(p<<2)>>2]|0;r=f[l+(p<<2)>>2]|0;f[m+(p<<2)>>2]=(q|0)>(r|0)?q-r|0:r-q|0;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+d|0;m=m+g|0;n=n+b|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=e;e=a;a=j;while(1){j=0;do{l=f[e+(j<<2)>>2]|0;k=f[m+(j<<2)>>2]|0;p=j|1;q=f[e+(p<<2)>>2]|0;r=f[m+(p<<2)>>2]|0;f[c+(j<<2)>>2]=(l|0)>(k|0)?l-k|0:k-l|0;f[c+(p<<2)>>2]=(q|0)>(r|0)?q-r|0:r-q|0;q=j|2;r=f[e+(q<<2)>>2]|0;p=f[m+(q<<2)>>2]|0;l=j|3;k=f[e+(l<<2)>>2]|0;s=f[m+(l<<2)>>2]|0;f[c+(q<<2)>>2]=(r|0)>(p|0)?r-p|0:p-r|0;f[c+(l<<2)>>2]=(k|0)>(s|0)?k-s|0:s-k|0;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{k=f[e+(j<<2)>>2]|0;s=f[m+(j<<2)>>2]|0;f[c+(j<<2)>>2]=(k|0)>(s|0)?k-s|0:s-k|0;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+d|0;c=c+g|0;e=e+b|0;a=a+-1|0}}return}function JE(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if(!i)return;j=h+-4|0;k=(h|0)<4;l=h&-4;m=c;c=f;f=a;a=i;while(1){a=a+-1|0;if(k)n=0;else{i=0;do{o=(d[f+(i<<1)>>1]|0)-(d[m+(i<<1)>>1]|0)|0;p=(o|0)>-1?o:0-o|0;o=i|1;q=(d[f+(o<<1)>>1]|0)-(d[m+(o<<1)>>1]|0)|0;r=(q|0)>-1?q:0-q|0;d[c+(i<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[c+(o<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=i|2;o=(d[f+(r<<1)>>1]|0)-(d[m+(r<<1)>>1]|0)|0;p=(o|0)>-1?o:0-o|0;o=i|3;q=(d[f+(o<<1)>>1]|0)-(d[m+(o<<1)>>1]|0)|0;s=(q|0)>-1?q:0-q|0;d[c+(r<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[c+(o<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;i=i+4|0}while((i|0)<=(j|0));n=l}if((n|0)<(h|0)){i=n;do{s=(d[f+(i<<1)>>1]|0)-(d[m+(i<<1)>>1]|0)|0;o=(s|0)>-1?s:0-s|0;d[c+(i<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{m=m+e|0;c=c+g|0;f=f+b|0}}return}function KE(a,b,c,e,f,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=c;m=f;n=a;o=j;while(1){if(k){p=0;do{q=d[n+(p<<1)>>1]|0;r=d[l+(p<<1)>>1]|0;s=(q&65535)>(r&65535);d[m+(p<<1)>>1]=((s?q:r)&65535)-((s?r:q)&65535);p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+b|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=c;c=f;f=a;a=j;while(1){j=0;do{l=d[f+(j<<1)>>1]|0;k=d[m+(j<<1)>>1]|0;p=(l&65535)>(k&65535);q=j|1;r=d[f+(q<<1)>>1]|0;s=d[m+(q<<1)>>1]|0;t=(r&65535)>(s&65535);d[c+(j<<1)>>1]=((p?l:k)&65535)-((p?k:l)&65535);d[c+(q<<1)>>1]=((t?r:s)&65535)-((t?s:r)&65535);r=j|2;s=d[f+(r<<1)>>1]|0;t=d[m+(r<<1)>>1]|0;q=(s&65535)>(t&65535);l=j|3;k=d[f+(l<<1)>>1]|0;p=d[m+(l<<1)>>1]|0;u=(k&65535)>(p&65535);d[c+(r<<1)>>1]=((q?s:t)&65535)-((q?t:s)&65535);d[c+(l<<1)>>1]=((u?k:p)&65535)-((u?p:k)&65535);j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{k=d[f+(j<<1)>>1]|0;p=d[m+(j<<1)>>1]|0;u=(k&65535)>(p&65535);d[c+(j<<1)>>1]=((u?k:p)&65535)-((u?p:k)&65535);j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;c=c+g|0;f=f+b|0;a=a+-1|0}}return}function LE(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=j;while(1){if(k){p=0;do{q=(b[n+p>>0]|0)-(b[l+p>>0]|0)|0;r=(q|0)>-1?q:0-q|0;b[m+p>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=j;while(1){j=0;do{l=(b[f+j>>0]|0)-(b[m+j>>0]|0)|0;k=(l|0)>-1?l:0-l|0;l=j|1;p=(b[f+l>>0]|0)-(b[m+l>>0]|0)|0;r=(p|0)>-1?p:0-p|0;b[d+j>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;b[d+l>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;r=j|2;l=(b[f+r>>0]|0)-(b[m+r>>0]|0)|0;k=(l|0)>-1?l:0-l|0;l=j|3;p=(b[f+l>>0]|0)-(b[m+l>>0]|0)|0;q=(p|0)>-1?p:0-p|0;b[d+r>>0]=(k+128|0)>>>0<256?k:(k|0)>0?127:128;b[d+l>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{q=(b[f+j>>0]|0)-(b[m+j>>0]|0)|0;l=(q|0)>-1?q:0-q|0;b[d+j>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}
function CQ(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;a:do if(a|0){g=f[a>>2]|0;h=g&-65536;if(((h|0)==1111621632?(i=a+24|0,(f[i>>2]|0)>0):0)?(j=f[a+20>>2]|0,(j|0)>0):0){if(!c){k=2;u=d;return k|0}f[c>>2]=j;f[c+4>>2]=f[i>>2];k=2;u=d;return k|0}if((g|0)==112?f[a+68>>2]|0:0){if(!c){k=2;u=d;return k|0}f[c>>2]=f[a+44>>2];f[c+4>>2]=f[a+40>>2];k=2;u=d;return k|0}if((h|0)>=1111752704){switch(h|0){case 1111752704:break;default:break a}g=f[a+4>>2]|0;if(!c){k=g;u=d;return k|0}Vac(c|0,a+36|0,g<<2|0)|0;k=g;u=d;return k|0}switch(h|0){case 1111687168:break;default:break a}h=f[a+4>>2]|0;if(!((c|0)!=0&(h|0)>0)){k=h;u=d;return k|0}g=a+20|0;i=0;do{f[c+(i<<2)>>2]=f[g+(i<<3)>>2];i=i+1|0}while((i|0)!=(h|0));k=h;u=d;return k|0}while(0);f[e>>2]=0;f[e+4>>2]=0;c=aD(e,38)|0;a=193623;h=c+38|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(h|0));bO(-5,e,195226,193466,1148);bD(e);k=-1;u=d;return k|0}function DQ(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=0;g=a+4|0;f[g>>2]=0;if(c|0){h=f[c>>2]|0;if(((h&-65536|0)==1111621632?(i=f[c+24>>2]|0,(i|0)>-1):0)?(j=f[c+20>>2]|0,(j|0)>-1):0){f[a>>2]=i;f[g>>2]=j;u=d;return}if((h|0)==112){h=f[c+48>>2]|0;if(!h){f[a>>2]=f[c+40>>2];k=c+44|0}else{f[a>>2]=f[h+12>>2];k=h+16|0}f[g>>2]=f[k>>2];u=d;return}}f[e>>2]=0;f[e+4>>2]=0;k=aD(e,33)|0;g=195236;h=k+33|0;do{b[k>>0]=b[g>>0]|0;k=k+1|0;g=g+1|0}while((k|0)<(h|0));bO(-5,e,195270,193466,1246);bD(e);u=d;return}function EQ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+16|0;i=h;if(!c){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,23)|0;k=195280;l=j+23|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-27,i,195304,193466,1888);bD(i)}a:do if(a|0){m=f[a>>2]|0;n=m&-65536;b:do if((n|0)<1111687168){switch(n|0){case 1111621632:break;default:{o=16;break b}}if((f[a+24>>2]|0)>0){if(!((f[a+20>>2]|0)>0|(m|0)==112))break a}else o=16}else{if((n|0)>=1111752704){switch(n|0){case 1111752704:break;default:{o=16;break b}}p=AQ(a,c,d,e,g)|0;u=h;return p|0}switch(n|0){case 1111687168:break;default:{o=16;break b}}q=f[a+16>>2]|0;if(!q)o=16;else{r=a+4|0;s=f[r>>2]|0;if((s|0)>0){t=a+20|0;v=i+4|0;w=q;x=0;y=s;while(1){s=c+(x<<2)|0;z=f[s>>2]|0;if(z>>>0<(f[t+(x<<3)>>2]|0)>>>0){A=z;B=y}else{f[i>>2]=0;f[v>>2]=0;j=aD(i,21)|0;k=195060;l=j+21|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-211,i,195304,193466,1902);bD(i);A=f[s>>2]|0;B=f[r>>2]|0}z=w+(Y(f[t+(x<<3)+4>>2]|0,A)|0)|0;x=x+1|0;if((x|0)>=(B|0)){C=z;break}else{w=z;y=B}}}else C=q;if(!d){p=C;u=h;return p|0}f[d>>2]=f[a>>2]&4095;p=C;u=h;return p|0}}while(0);if((o|0)==16?(m|0)!=112:0)break;p=zQ(a,f[c>>2]|0,f[c+4>>2]|0,d)|0;u=h;return p|0}while(0);f[i>>2]=0;f[i+4>>2]=0;j=aD(i,38)|0;k=193623;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-5,i,195304,193466,1912);bD(i);p=0;u=h;return p|0}function FQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+16|0;h=g+8|0;i=g;if(!c){f[h>>2]=0;f[h+4>>2]=0;bO(-27,h,195391,193466,2719);bD(h)}if(((((a|0)!=0?(f[a>>2]&-65536|0)==1111621632:0)?(f[a+24>>2]|0)>0:0)?(f[a+20>>2]|0)>0:0)?(f[a+16>>2]|0)!=0:0)j=a;else{f[h>>2]=0;k=sQ(a,c,h,1)|0;if(f[h>>2]|0){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,20)|0;m=357047;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-24,i,195391,193466,2726);bD(i)}j=k}if(d)if((d+-1|0)>>>0>3){f[h>>2]=0;f[h+4>>2]=0;bO(-15,h,195391,193466,2732);bD(h);o=d}else o=d;else o=((f[j>>2]|0)>>>3&511)+1|0;if((j|0)!=(c|0)){d=c+12|0;k=f[d>>2]|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[c+8>>2]=0;f[d>>2]=k}k=f[j>>2]|0;d=Y((k>>>3&511)+1|0,f[j+24>>2]|0)|0;i=(e|0)==0;if((o|0)>(d|0))if(i)p=20;else{q=e;p=23}else if(i&((d|0)%(o|0)|0|0)!=0)p=20;else{r=e;p=21}if((p|0)==20){r=(Y(f[j+20>>2]|0,d)|0)/(o|0)|0;p=21}if((p|0)==21)if(!r){s=f[j+20>>2]|0;p=24}else{q=r;p=23}if((p|0)==23){r=f[j+20>>2]|0;if((q|0)==(r|0)){s=q;p=24}else{e=Y(r,d)|0;if(!(k&16384)){f[h>>2]=0;f[h+4>>2]=0;l=aD(h,72)|0;m=195401;n=l+72|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-13,h,195391,193466,2757);bD(h)}if(q>>>0>e>>>0){f[h>>2]=0;f[h+4>>2]=0;l=aD(h,22)|0;m=195474;n=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-211,h,195391,193466,2760);bD(h)}k=(e|0)/(q|0)|0;if((Y(k,q)|0)!=(e|0)){f[h>>2]=0;f[h+4>>2]=0;l=aD(h,78)|0;m=195312;n=l+78|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-5,h,195391,193466,2766);bD(h)}f[c+20>>2]=q;t=k;v=Y(1212424721>>>(f[j>>2]<<2&28)&15,k)|0}}if((p|0)==24){f[c+20>>2]=s;t=d;v=f[j+4>>2]|0}f[c+4>>2]=v;v=(t|0)/(o|0)|0;if((Y(v,o)|0)==(t|0)){w=c+24|0;f[w>>2]=v;x=f[j>>2]|0;y=x&-4096;z=x&7;A=o<<3;B=A+-8|0;C=z|B;D=C|y;f[c>>2]=D;u=g;return c|0}f[h>>2]=0;f[h+4>>2]=0;l=aD(h,62)|0;m=195497;n=l+62|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-15,h,195391,193466,2776);bD(h);w=c+24|0;f[w>>2]=v;x=f[j>>2]|0;y=x&-4096;z=x&7;A=o<<3;B=A+-8|0;C=z|B;D=C|y;f[c>>2]=D;u=g;return c|0}function GQ(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i;if(!a){f[j>>2]=0;f[j+4>>2]=0;k=aD(j,22)|0;l=195560;m=k+22|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-9,j,195583,193466,2918);bD(j)}k=a+4|0;m=k+108|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(m|0));f[a>>2]=112;n=e+-1|0;if(n>>>0<4){o=f[43628+(n<<3)+4>>2]|0;p=f[43628+(n<<3)>>2]|0}else{o=1124530;p=1124530}XVb(a+20|0,p,4)|0;XVb(a+24|0,o,4)|0;o=f[c>>2]|0;if(!((o|0)>=0?(f[c+4>>2]|0)>=0:0)){f[j>>2]=0;f[j+4>>2]=0;k=aD(j,13)|0;l=195601;m=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-25,j,195583,193466,2928);bD(j)}if((e|0)<0|(d|0)!=64&((d|0)!=32&((d|0)!=-2147483616&((d|0)!=-2147483632&((d|0)!=16&((d|0)!=-2147483640&((d|0)!=1&(d|0)!=8))))))){f[j>>2]=0;f[j+4>>2]=0;k=aD(j,18)|0;l=195615;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-17,j,195583,193466,2935);bD(j)}if(g>>>0>1){f[j>>2]=0;f[j+4>>2]=0;k=aD(j,16)|0;l=195634;m=k+16|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-20,j,195583,193466,2937);bD(j)}switch(h|0){case 4:case 8:break;default:{f[j>>2]=0;f[j+4>>2]=0;k=aD(j,15)|0;l=195651;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-21,j,195583,193466,2940);bD(j)}}f[a+40>>2]=o;p=f[c+4>>2]|0;f[a+44>>2]=p;c=f[a+48>>2]|0;if(c|0){f[c>>2]=0;f[c+8>>2]=0;f[c+4>>2]=0;f[c+12>>2]=o;f[c+16>>2]=p}c=(e|0)>1?e:1;f[a+8>>2]=c;f[a+16>>2]=d;f[a+36>>2]=h;e=h+-1+(((Y(Y(c,d&2147483647)|0,o)|0)+7|0)>>>3)&0-h;f[a+72>>2]=e;f[a+32>>2]=g;g=cbc(e|0,((e|0)<0)<<31>>31|0,p|0,((p|0)<0)<<31>>31|0)|0;f[a+64>>2]=g;if((g|0)==(g|0)&(((g|0)<0)<<31>>31|0)==(J|0)){u=i;return a|0}f[j>>2]=0;f[j+4>>2]=0;k=aD(j,22)|0;l=193600;m=k+22|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-4,j,195583,193466,2962);bD(j);u=i;return a|0}function HQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d+8|0;g=d;h=a;a=f[h>>2]|0;i=f[h+4>>2]|0;h=f[125765]|0;if(!h){j=VC(112)|0;k=g;f[k>>2]=a;f[k+4>>2]=i;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];GQ(j,e,b,c,0,4)|0;l=j;iQ(l);u=d;return l|0}j=c+-1|0;if(j>>>0<4){m=f[43628+(j<<3)+4>>2]|0;n=f[43628+(j<<3)>>2]|0}else{m=1124530;n=1124530}l=ui[h&0](c,0,b,n,m,0,0,4,a,i,0,0,0,0)|0;iQ(l);u=d;return l|0}function IQ(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;bO(-27,c,195685,193466,2996);bD(c)}c=f[a>>2]|0;if(!c){u=b;return}f[a>>2]=0;yQ(c);a=f[125767]|0;if(!a){d=c+48|0;WC(f[d>>2]|0);f[d>>2]=0;WC(c);u=b;return}else{zh[a&2047](c,5);u=b;return}}function JQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;bO(-9,d,195700,193466,3013);bD(d)}e=b+8|0;g=f[e>>2]|0;if((((((g|0)>-1?(h=b+12|0,i=f[h>>2]|0,(i|0)>-1):0)?(j=f[b>>2]|0,k=f[a+40>>2]|0,(j|0)<(k|0)):0)?(l=b+4|0,m=f[l>>2]|0,n=f[a+44>>2]|0,(m|0)<(n|0)):0)?(j+g|0)>=((g|0)>0|0):0)?(m+i|0)>=((i|0)>0|0):0){o=l;p=h;q=b;r=j;s=m;t=i;v=k;w=n}else{f[d>>2]=0;f[d+4>>2]=0;Vac(aD(d,184)|0,195714,184)|0;bO(-215,d,195700,193466,3019);bD(d);d=b+4|0;n=b+12|0;o=d;p=n;q=b;r=f[b>>2]|0;s=f[d>>2]|0;t=f[n>>2]|0;v=f[a+40>>2]|0;w=f[a+44>>2]|0}n=g+r|0;g=t+s|0;t=(r|0)>0?r:0;f[q>>2]=t;q=(s|0)>0?s:0;f[o>>2]=q;o=((v|0)<(n|0)?v:n)-t|0;f[e>>2]=o;e=((w|0)<(g|0)?w:g)-q|0;f[p>>2]=e;p=a+48|0;a=f[p>>2]|0;if(a|0){f[a+4>>2]=t;f[a+8>>2]=q;f[a+12>>2]=o;f[a+16>>2]=e;u=c;return}a=f[125768]|0;if(!a){g=VC(20)|0;f[g>>2]=0;f[g+4>>2]=t;f[g+8>>2]=q;f[g+12>>2]=o;f[g+16>>2]=e;x=g}else x=nh[a&127](0,t,q,o,e)|0;f[p>>2]=x;u=c;return}function KQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;bO(-9,d,195899,193466,3086);bD(d)}do if((f[a+8>>2]|0)>>>0<b>>>0){f[d>>2]=0;f[d+4>>2]=0;bO(-24,d,195899,193466,3089);bD(d);e=a+48|0;g=f[e>>2]|0;if(!g)h=e;else{i=g;j=7}}else{g=a+48|0;e=f[g>>2]|0;k=(e|0)!=0;if((b|0)!=0|k)if(k){i=e;j=7;break}else{h=g;break}else{u=c;return}}while(0);if((j|0)==7){f[i>>2]=b;u=c;return}i=f[a+40>>2]|0;j=f[a+44>>2]|0;a=f[125768]|0;if(!a){d=VC(20)|0;f[d>>2]=b;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=i;f[d+16>>2]=j;l=d}else l=nh[a&127](b,0,0,i,j)|0;f[h>>2]=l;u=c;return}function LQ(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;bO(-9,c,195913,193466,3109);bD(c)}c=f[a+48>>2]|0;if(!c){d=0;u=b;return d|0}d=f[c>>2]|0;u=b;return d|0}function MQ(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0?(f[a>>2]|0)==112:0)){f[d>>2]=0;f[d+4>>2]=0;e=aD(d,16)|0;g=195927;h=e+16|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-5,d,195944,193466,3121);bD(d)}d=f[125769]|0;if(d|0){i=di[d&1023](a)|0;u=c;return i|0}d=VC(112)|0;e=d;g=a;h=e+108|0;do{f[e>>2]=f[g>>2];e=e+4|0;g=g+4|0}while((e|0)<(h|0));f[d+108>>2]=0;g=d+68|0;f[g>>2]=0;e=d+48|0;f[e>>2]=0;h=f[a+48>>2]|0;if(h|0){j=f[h>>2]|0;k=f[h+4>>2]|0;l=f[h+8>>2]|0;m=f[h+12>>2]|0;n=f[h+16>>2]|0;h=f[125768]|0;if(!h){o=VC(20)|0;f[o>>2]=j;f[o+4>>2]=k;f[o+8>>2]=l;f[o+12>>2]=m;f[o+16>>2]=n;p=o}else p=nh[h&127](j,k,l,m,n)|0;f[e>>2]=p}p=a+68|0;if(!(f[p>>2]|0)){i=d;u=c;return i|0}e=f[a+64>>2]|0;iQ(d);Vac(f[g>>2]|0,f[p>>2]|0,e|0)|0;i=d;u=c;return i|0}function NQ(a,b){a=a|0;b=b|0;var c=0;a=u;u=u+16|0;c=a;f[c>>2]=b;kQ(c);u=a;return}function OQ(a,b){a=a|0;b=b|0;var c=0;a=u;u=u+16|0;c=a;f[c>>2]=b;BW(c);u=a;return}function PQ(a,b){a=a|0;b=b|0;var c=0;a=u;u=u+16|0;c=a;f[c>>2]=b;LT(c);u=a;return}function QQ(a){a=a|0;return}function RQ(a,b,c){a=a|0;b=b|0;c=+c;if((f[a>>2]|0)==(f[a+4>>2]|0))return;zh[f[(f[b>>2]|0)+8>>2]&2047](b,a);return}function SQ(){return 1}function TQ(a){a=a|0;return}function UQ(){return 1}function VQ(){return 0}function WQ(a){a=a|0;return}function XQ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+656|0;h=g+312|0;i=g+256|0;j=g+592|0;k=g+32|0;l=g+536|0;m=g;if(!(Uh[f[(f[a>>2]|0)+8>>2]&1023](a,b)|0)){f[j>>2]=1124007936;a=j+4|0;n=j+8|0;o=j+40|0;q=a;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=n;n=j+48|0;s=j+44|0;f[s>>2]=n;f[n>>2]=0;f[j+52>>2]=0;t=f[b>>2]|0;th[f[(f[t>>2]|0)+12>>2]&511](t,b,j,-1);t=c;v=f[t>>2]|0;w=f[t+4>>2]|0;t=d;x=f[t+4>>2]|0;y=h;f[y>>2]=f[t>>2];f[y+4>>2]=x;x=i;f[x>>2]=v;f[x+4>>2]=w;lL(l,j,i,h);f[h>>2]=1124007936;w=h+4|0;x=h+8|0;v=h+40|0;q=w;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[v>>2]=x;x=h+48|0;y=h+44|0;f[y>>2]=x;f[x>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;t=i+4|0;z=i+8|0;A=i+40|0;q=t;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[A>>2]=z;z=i+48|0;B=i+44|0;f[B>>2]=z;f[z>>2]=0;f[i+52>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;tR(k,45336,0,l,h,i,1.0,1.0,m);uR(e,k)|0;Wi(k);m=i+36|0;C=f[m>>2]|0;if(C|0?(D=C+12|0,C=f[D>>2]|0,f[D>>2]=C+-1,(C|0)==1):0)kL(i);f[m>>2]=0;m=i+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[t>>2]|0)>0){m=f[A>>2]|0;A=0;do{f[m+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[t>>2]|0))}t=f[B>>2]|0;if((t|0)!=(z|0))UC(t);t=h+36|0;z=f[t>>2]|0;if(z|0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0)kL(h);f[t>>2]=0;t=h+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[w>>2]|0)>0){t=f[v>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[w>>2]|0))}w=f[y>>2]|0;if((w|0)!=(x|0))UC(w);w=l+36|0;x=f[w>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)kL(l);f[w>>2]=0;w=l+16|0;x=l+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[l+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[l+44>>2]|0;if((x|0)!=(l+48|0))UC(x);x=j+36|0;l=f[x>>2]|0;if(l|0?(y=l+12|0,l=f[y>>2]|0,f[y>>2]=l+-1,(l|0)==1):0)kL(j);f[x>>2]=0;x=j+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[a>>2]|0)>0){x=f[o>>2]|0;o=0;do{f[x+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[a>>2]|0))}a=f[s>>2]|0;if((a|0)!=(n|0))UC(a);u=g;return}a=f[b>>2]|0;n=f[b+4>>2]|0;f[i>>2]=1124007936;s=i+4|0;o=i+8|0;x=i+40|0;q=s;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[x>>2]=o;o=i+48|0;l=i+44|0;f[l>>2]=o;f[o>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;y=j+4|0;w=j+8|0;v=j+40|0;q=y;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[v>>2]=w;w=j+48|0;t=j+44|0;f[t>>2]=w;f[w>>2]=0;f[j+52>>2]=0;f[k>>2]=1124007936;z=k+4|0;B=k+8|0;A=k+40|0;q=z;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[A>>2]=B;B=k+48|0;q=k+44|0;f[q>>2]=B;f[B>>2]=0;f[k+52>>2]=0;tR(h,a,n,i,j,k,+p[b+176>>3],+p[b+184>>3],b+192|0);uR(e,h)|0;Wi(h);n=k+36|0;a=f[n>>2]|0;if(a|0?(r=a+12|0,a=f[r>>2]|0,f[r>>2]=a+-1,(a|0)==1):0)kL(k);f[n>>2]=0;n=k+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[z>>2]|0)>0){n=f[A>>2]|0;A=0;do{f[n+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[z>>2]|0))}z=f[q>>2]|0;if((z|0)!=(B|0))UC(z);z=j+36|0;B=f[z>>2]|0;if(B|0?(q=B+12|0,B=f[q>>2]|0,f[q>>2]=B+-1,(B|0)==1):0)kL(j);f[z>>2]=0;z=j+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[y>>2]|0)>0){z=f[v>>2]|0;v=0;do{f[z+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[y>>2]|0))}y=f[t>>2]|0;if((y|0)!=(w|0))UC(y);y=i+36|0;w=f[y>>2]|0;if(w|0?(t=w+12|0,w=f[t>>2]|0,f[t>>2]=w+-1,(w|0)==1):0)kL(i);f[y>>2]=0;y=i+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[s>>2]|0)>0){y=f[x>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[s>>2]|0))}s=f[l>>2]|0;if((s|0)!=(o|0))UC(s);if(f[b+24>>2]|0){s=c;o=f[s>>2]|0;l=f[s+4>>2]|0;s=d;x=f[s+4>>2]|0;y=h;f[y>>2]=f[s>>2];f[y+4>>2]=x;x=i;f[x>>2]=o;f[x+4>>2]=l;lL(j,b+8|0,i,h);l=e+8|0;x=j+36|0;o=f[x>>2]|0;if((l|0)==(j|0))E=o;else{if(o|0){y=o+12|0;f[y>>2]=(f[y>>2]|0)+1}y=e+44|0;o=f[y>>2]|0;if(o|0?(s=o+12|0,o=f[s>>2]|0,f[s>>2]=o+-1,(o|0)==1):0)kL(l);f[y>>2]=0;o=e+24|0;s=e+12|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[s>>2]|0)>0){w=f[e+48>>2]|0;t=0;do{f[w+(t<<2)>>2]=0;t=t+1|0;F=f[s>>2]|0}while((t|0)<(F|0));f[l>>2]=f[j>>2];if((F|0)<3)G=38;else G=40}else{f[l>>2]=f[j>>2];G=38}if((G|0)==38){F=f[j+4>>2]|0;if((F|0)<3){f[s>>2]=F;f[e+16>>2]=f[j+8>>2];f[e+20>>2]=f[j+12>>2];F=f[j+44>>2]|0;s=f[e+52>>2]|0;f[s>>2]=f[F>>2];f[s+4>>2]=f[F+4>>2]}else G=40}if((G|0)==40)jL(l,j);f[o>>2]=f[j+16>>2];f[e+28>>2]=f[j+20>>2];f[e+32>>2]=f[j+24>>2];f[e+36>>2]=f[j+28>>2];f[e+40>>2]=f[j+32>>2];o=f[x>>2]|0;f[y>>2]=o;E=o}if(E|0?(o=E+12|0,E=f[o>>2]|0,f[o>>2]=E+-1,(E|0)==1):0)kL(j);f[x>>2]=0;x=j+16|0;E=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[E>>2]|0)>0){x=f[j+40>>2]|0;o=0;do{f[x+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[E>>2]|0))}E=f[j+44>>2]|0;if((E|0)!=(j+48|0))UC(E)}if(f[b+80>>2]|0){E=c;o=f[E>>2]|0;x=f[E+4>>2]|0;E=d;y=f[E+4>>2]|0;l=h;f[l>>2]=f[E>>2];f[l+4>>2]=y;y=i;f[y>>2]=o;f[y+4>>2]=x;lL(j,b+64|0,i,h);x=e+64|0;y=j+36|0;o=f[y>>2]|0;if((x|0)==(j|0))H=o;else{if(o|0){l=o+12|0;f[l>>2]=(f[l>>2]|0)+1}l=e+100|0;o=f[l>>2]|0;if(o|0?(E=o+12|0,o=f[E>>2]|0,f[E>>2]=o+-1,(o|0)==1):0)kL(x);f[l>>2]=0;o=e+80|0;E=e+68|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[E>>2]|0)>0){F=f[e+104>>2]|0;s=0;do{f[F+(s<<2)>>2]=0;s=s+1|0;I=f[E>>2]|0}while((s|0)<(I|0));f[x>>2]=f[j>>2];if((I|0)<3)G=63;else G=65}else{f[x>>2]=f[j>>2];G=63}if((G|0)==63){I=f[j+4>>2]|0;if((I|0)<3){f[E>>2]=I;f[e+72>>2]=f[j+8>>2];f[e+76>>2]=f[j+12>>2];I=f[j+44>>2]|0;E=f[e+108>>2]|0;f[E>>2]=f[I>>2];f[E+4>>2]=f[I+4>>2]}else G=65}if((G|0)==65)jL(x,j);f[o>>2]=f[j+16>>2];f[e+84>>2]=f[j+20>>2];f[e+88>>2]=f[j+24>>2];f[e+92>>2]=f[j+28>>2];f[e+96>>2]=f[j+32>>2];o=f[y>>2]|0;f[l>>2]=o;H=o}if(H|0?(o=H+12|0,H=f[o>>2]|0,f[o>>2]=H+-1,(H|0)==1):0)kL(j);f[y>>2]=0;y=j+16|0;H=j+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[H>>2]|0)>0){y=f[j+40>>2]|0;o=0;do{f[y+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[H>>2]|0))}H=f[j+44>>2]|0;if((H|0)!=(j+48|0))UC(H)}if(!(f[b+136>>2]|0)){u=g;return}H=c;c=f[H>>2]|0;o=f[H+4>>2]|0;H=d;d=f[H+4>>2]|0;y=h;f[y>>2]=f[H>>2];f[y+4>>2]=d;d=i;f[d>>2]=c;f[d+4>>2]=o;lL(j,b+120|0,i,h);h=e+120|0;i=j+36|0;b=f[i>>2]|0;if((h|0)==(j|0))J=b;else{if(b|0){o=b+12|0;f[o>>2]=(f[o>>2]|0)+1}o=e+156|0;b=f[o>>2]|0;if(b|0?(d=b+12|0,b=f[d>>2]|0,f[d>>2]=b+-1,(b|0)==1):0)kL(h);f[o>>2]=0;b=e+136|0;d=e+124|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){c=f[e+160>>2]|0;y=0;do{f[c+(y<<2)>>2]=0;y=y+1|0;K=f[d>>2]|0}while((y|0)<(K|0));f[h>>2]=f[j>>2];if((K|0)<3)G=88;else G=90}else{f[h>>2]=f[j>>2];G=88}if((G|0)==88){K=f[j+4>>2]|0;if((K|0)<3){f[d>>2]=K;f[e+128>>2]=f[j+8>>2];f[e+132>>2]=f[j+12>>2];K=f[j+44>>2]|0;d=f[e+164>>2]|0;f[d>>2]=f[K>>2];f[d+4>>2]=f[K+4>>2]}else G=90}if((G|0)==90)jL(h,j);f[b>>2]=f[j+16>>2];f[e+140>>2]=f[j+20>>2];f[e+144>>2]=f[j+24>>2];f[e+148>>2]=f[j+28>>2];f[e+152>>2]=f[j+32>>2];e=f[i>>2]|0;f[o>>2]=e;J=e}if(J|0?(e=J+12|0,J=f[e>>2]|0,f[e>>2]=J+-1,(J|0)==1):0)kL(j);f[i>>2]=0;i=j+16|0;J=j+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[J>>2]|0)>0){i=f[j+40>>2]|0;e=0;do{f[i+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[J>>2]|0))}J=f[j+44>>2]|0;if((J|0)!=(j+48|0))UC(J);u=g;return}function YQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=u;u=u+656|0;g=e+256|0;h=e+32|0;i=e+592|0;j=e+536|0;k=e+480|0;l=e;if(!(Uh[f[(f[a>>2]|0)+8>>2]&1023](a,b)|0)){f[g>>2]=1124007936;a=g+4|0;m=g+8|0;n=g+40|0;o=a;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;m=g+48|0;r=g+44|0;f[r>>2]=m;f[m>>2]=0;f[g+52>>2]=0;s=f[b>>2]|0;th[f[(f[s>>2]|0)+12>>2]&511](s,b,g,-1);rL(i,g,c);f[j>>2]=1124007936;s=j+4|0;t=j+8|0;v=j+40|0;o=s;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[v>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;f[k>>2]=1124007936;x=k+4|0;y=k+8|0;z=k+40|0;o=x;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[z>>2]=y;y=k+48|0;A=k+44|0;f[A>>2]=y;f[y>>2]=0;f[k+52>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;tR(h,45336,0,i,j,k,1.0,1.0,l);uR(d,h)|0;Wi(h);l=k+36|0;B=f[l>>2]|0;if(B|0?(C=B+12|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)kL(k);f[l>>2]=0;l=k+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[x>>2]|0)>0){l=f[z>>2]|0;z=0;do{f[l+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[x>>2]|0))}x=f[A>>2]|0;if((x|0)!=(y|0))UC(x);x=j+36|0;y=f[x>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)kL(j);f[x>>2]=0;x=j+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[v>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[w>>2]|0;if((s|0)!=(t|0))UC(s);s=i+36|0;t=f[s>>2]|0;if(t|0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0)kL(i);f[s>>2]=0;s=i+16|0;t=i+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[t>>2]|0)>0){s=f[i+40>>2]|0;w=0;do{f[s+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[t>>2]|0))}t=f[i+44>>2]|0;if((t|0)!=(i+48|0))UC(t);t=g+36|0;w=f[t>>2]|0;if(w|0?(s=w+12|0,w=f[s>>2]|0,f[s>>2]=w+-1,(w|0)==1):0)kL(g);f[t>>2]=0;t=g+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[a>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[a>>2]|0))}a=f[r>>2]|0;if((a|0)!=(m|0))UC(a);u=e;return}a=f[b>>2]|0;m=f[b+4>>2]|0;f[h>>2]=1124007936;r=h+4|0;n=h+8|0;t=h+40|0;o=r;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[t>>2]=n;n=h+48|0;w=h+44|0;f[w>>2]=n;f[n>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;s=i+4|0;v=i+8|0;x=i+40|0;o=s;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[x>>2]=v;v=i+48|0;y=i+44|0;f[y>>2]=v;f[v>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;A=j+4|0;z=j+8|0;l=j+40|0;o=A;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[l>>2]=z;z=j+48|0;o=j+44|0;f[o>>2]=z;f[z>>2]=0;f[j+52>>2]=0;tR(g,a,m,h,i,j,+p[b+176>>3],+p[b+184>>3],b+192|0);uR(d,g)|0;Wi(g);m=j+36|0;a=f[m>>2]|0;if(a|0?(q=a+12|0,a=f[q>>2]|0,f[q>>2]=a+-1,(a|0)==1):0)kL(j);f[m>>2]=0;m=j+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[A>>2]|0)>0){m=f[l>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[A>>2]|0))}A=f[o>>2]|0;if((A|0)!=(z|0))UC(A);A=i+36|0;z=f[A>>2]|0;if(z|0?(o=z+12|0,z=f[o>>2]|0,f[o>>2]=z+-1,(z|0)==1):0)kL(i);f[A>>2]=0;A=i+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[s>>2]|0)>0){A=f[x>>2]|0;x=0;do{f[A+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[s>>2]|0))}s=f[y>>2]|0;if((s|0)!=(v|0))UC(s);s=h+36|0;v=f[s>>2]|0;if(v|0?(y=v+12|0,v=f[y>>2]|0,f[y>>2]=v+-1,(v|0)==1):0)kL(h);f[s>>2]=0;s=h+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[t>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[w>>2]|0;if((r|0)!=(n|0))UC(r);if(f[b+24>>2]|0){rL(g,b+8|0,c);r=d+8|0;n=g+36|0;w=f[n>>2]|0;if((r|0)==(g|0))D=w;else{if(w|0){t=w+12|0;f[t>>2]=(f[t>>2]|0)+1}t=d+44|0;w=f[t>>2]|0;if(w|0?(s=w+12|0,w=f[s>>2]|0,f[s>>2]=w+-1,(w|0)==1):0)kL(r);f[t>>2]=0;w=d+24|0;s=d+12|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[s>>2]|0)>0){h=f[d+48>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0;E=f[s>>2]|0}while((v|0)<(E|0));f[r>>2]=f[g>>2];if((E|0)<3)F=38;else F=40}else{f[r>>2]=f[g>>2];F=38}if((F|0)==38){E=f[g+4>>2]|0;if((E|0)<3){f[s>>2]=E;f[d+16>>2]=f[g+8>>2];f[d+20>>2]=f[g+12>>2];E=f[g+44>>2]|0;s=f[d+52>>2]|0;f[s>>2]=f[E>>2];f[s+4>>2]=f[E+4>>2]}else F=40}if((F|0)==40)jL(r,g);f[w>>2]=f[g+16>>2];f[d+28>>2]=f[g+20>>2];f[d+32>>2]=f[g+24>>2];f[d+36>>2]=f[g+28>>2];f[d+40>>2]=f[g+32>>2];w=f[n>>2]|0;f[t>>2]=w;D=w}if(D|0?(w=D+12|0,D=f[w>>2]|0,f[w>>2]=D+-1,(D|0)==1):0)kL(g);f[n>>2]=0;n=g+16|0;D=g+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[D>>2]|0)>0){n=f[g+40>>2]|0;w=0;do{f[n+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[D>>2]|0))}D=f[g+44>>2]|0;if((D|0)!=(g+48|0))UC(D)}if(f[b+80>>2]|0){rL(g,b+64|0,c);D=d+64|0;w=g+36|0;n=f[w>>2]|0;if((D|0)==(g|0))G=n;else{if(n|0){t=n+12|0;f[t>>2]=(f[t>>2]|0)+1}t=d+100|0;n=f[t>>2]|0;if(n|0?(r=n+12|0,n=f[r>>2]|0,f[r>>2]=n+-1,(n|0)==1):0)kL(D);f[t>>2]=0;n=d+80|0;r=d+68|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[r>>2]|0)>0){E=f[d+104>>2]|0;s=0;do{f[E+(s<<2)>>2]=0;s=s+1|0;H=f[r>>2]|0}while((s|0)<(H|0));f[D>>2]=f[g>>2];if((H|0)<3)F=63;else F=65}else{f[D>>2]=f[g>>2];F=63}if((F|0)==63){H=f[g+4>>2]|0;if((H|0)<3){f[r>>2]=H;f[d+72>>2]=f[g+8>>2];f[d+76>>2]=f[g+12>>2];H=f[g+44>>2]|0;r=f[d+108>>2]|0;f[r>>2]=f[H>>2];f[r+4>>2]=f[H+4>>2]}else F=65}if((F|0)==65)jL(D,g);f[n>>2]=f[g+16>>2];f[d+84>>2]=f[g+20>>2];f[d+88>>2]=f[g+24>>2];f[d+92>>2]=f[g+28>>2];f[d+96>>2]=f[g+32>>2];n=f[w>>2]|0;f[t>>2]=n;G=n}if(G|0?(n=G+12|0,G=f[n>>2]|0,f[n>>2]=G+-1,(G|0)==1):0)kL(g);f[w>>2]=0;w=g+16|0;G=g+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[G>>2]|0)>0){w=f[g+40>>2]|0;n=0;do{f[w+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[G>>2]|0))}G=f[g+44>>2]|0;if((G|0)!=(g+48|0))UC(G)}if(!(f[b+136>>2]|0)){u=e;return}rL(g,b+120|0,c);c=d+120|0;b=g+36|0;G=f[b>>2]|0;if((c|0)==(g|0))I=G;else{if(G|0){n=G+12|0;f[n>>2]=(f[n>>2]|0)+1}n=d+156|0;G=f[n>>2]|0;if(G|0?(w=G+12|0,G=f[w>>2]|0,f[w>>2]=G+-1,(G|0)==1):0)kL(c);f[n>>2]=0;G=d+136|0;w=d+124|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[w>>2]|0)>0){t=f[d+160>>2]|0;D=0;do{f[t+(D<<2)>>2]=0;D=D+1|0;J=f[w>>2]|0}while((D|0)<(J|0));f[c>>2]=f[g>>2];if((J|0)<3)F=88;else F=90}else{f[c>>2]=f[g>>2];F=88}if((F|0)==88){J=f[g+4>>2]|0;if((J|0)<3){f[w>>2]=J;f[d+128>>2]=f[g+8>>2];f[d+132>>2]=f[g+12>>2];J=f[g+44>>2]|0;w=f[d+164>>2]|0;f[w>>2]=f[J>>2];f[w+4>>2]=f[J+4>>2]}else F=90}if((F|0)==90)jL(c,g);f[G>>2]=f[g+16>>2];f[d+140>>2]=f[g+20>>2];f[d+144>>2]=f[g+24>>2];f[d+148>>2]=f[g+28>>2];f[d+152>>2]=f[g+32>>2];d=f[b>>2]|0;f[n>>2]=d;I=d}if(I|0?(d=I+12|0,I=f[d>>2]|0,f[d>>2]=I+-1,(I|0)==1):0)kL(g);f[b>>2]=0;b=g+16|0;I=g+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[I>>2]|0)>0){b=f[g+40>>2]|0;d=0;do{f[b+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[I>>2]|0))}I=f[g+44>>2]|0;if((I|0)!=(g+48|0))UC(I);u=e;return}function ZQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;th[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;VD(d,e,g,UM()|0,-1);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)kL(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}UC(i);u=a;return}function _Q(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;th[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;jE(d,e,g,UM()|0,-1);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)kL(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}UC(i);u=a;return}function $Q(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=u;u=u+176|0;d=a+160|0;e=a+144|0;g=a+128|0;h=a+72|0;i=a+56|0;j=a;f[j>>2]=1124007936;k=j+4|0;l=j+8|0;m=j+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=j+48|0;p=j+44|0;f[p>>2]=l;f[l>>2]=0;f[j+52>>2]=0;q=f[b>>2]|0;th[f[(f[q>>2]|0)+12>>2]&511](q,b,j,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=j;f[h>>2]=1124007936;b=h+4|0;q=h+8|0;r=h+40|0;n=b;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[r>>2]=q;q=h+48|0;n=h+44|0;f[n>>2]=q;f[q>>2]=0;f[h+52>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=h;o=i+8|0;f[o>>2]=0;f[o+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=c;CX(d,e,1.0,g,0.0,i,0);i=h+36|0;g=f[i>>2]|0;if(g|0?(e=g+12|0,g=f[e>>2]|0,f[e>>2]=g+-1,(g|0)==1):0)kL(h);f[i>>2]=0;i=h+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[b>>2]|0)>0){i=f[r>>2]|0;r=0;do{f[i+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[b>>2]|0))}b=f[n>>2]|0;if((b|0)!=(q|0))UC(b);b=j+36|0;q=f[b>>2]|0;if(q|0?(n=q+12|0,q=f[n>>2]|0,f[n>>2]=q+-1,(q|0)==1):0)kL(j);f[b>>2]=0;b=j+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[k>>2]|0)>0){b=f[m>>2]|0;m=0;do{f[b+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[p>>2]|0;if((k|0)==(l|0)){u=a;return}UC(k);u=a;return}function aR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;th[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;VE(d,e,g,1.0,-1);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)kL(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}UC(i);u=a;return}function bR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;th[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;dD(d,e,g,UM()|0);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)kL(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}UC(i);u=a;return}function cR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;th[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;hD(d,e,g,UM()|0);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)kL(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}UC(i);u=a;return}function dR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+112|0;d=a+88|0;e=a+72|0;g=a+56|0;h=a;f[h>>2]=1124007936;i=h+4|0;j=h+8|0;k=h+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=h+48|0;l=h+44|0;f[l>>2]=j;f[j>>2]=0;f[h+52>>2]=0;m=f[b>>2]|0;th[f[(f[m>>2]|0)+12>>2]&511](m,b,h,-1);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=16842752;f[d+4>>2]=c;f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=h;b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;kD(d,e,g,UM()|0);g=h+36|0;e=f[g>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)kL(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}UC(i);u=a;return}function eR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0.0;e=u;u=u+160|0;g=e+144|0;h=e;i=e+88|0;j=e+32|0;dQ(g,46516);k=f[c>>2]|0;if((k|0)==(a|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[i>>2]=1124007936;a=i+4|0;l=i+8|0;m=i+40|0;n=a;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;q=i+48|0;r=i+44|0;f[r>>2]=q;f[q>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;s=j+4|0;t=j+8|0;v=j+40|0;n=s;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[v>>2]=t;n=j+48|0;o=j+44|0;f[o>>2]=n;f[n>>2]=0;f[j+52>>2]=0;w=f[b>>2]|0;do if((w|0)==45580){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){x=21;break}y=b+8|0;if((i|0)!=(y|0)){z=b+44|0;A=f[z>>2]|0;if(A){B=A+12|0;f[B>>2]=(f[B>>2]|0)+1;B=i+36|0;A=f[B>>2]|0;if((A|0)!=0?(C=A+12|0,A=f[C>>2]|0,f[C>>2]=A+-1,(A|0)==1):0){kL(i);D=B}else D=B}else D=i+36|0;f[D>>2]=0;B=i+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[a>>2]|0)>0){A=f[m>>2]|0;C=0;do{f[A+(C<<2)>>2]=0;C=C+1|0;E=f[a>>2]|0}while((C|0)<(E|0));f[i>>2]=f[y>>2];if((E|0)<3)x=16;else x=18}else{f[i>>2]=f[y>>2];x=16}if((x|0)==16){C=f[b+12>>2]|0;if((C|0)<3){f[a>>2]=C;f[l>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];C=f[b+52>>2]|0;A=f[r>>2]|0;f[A>>2]=f[C>>2];f[A+4>>2]=f[C+4>>2]}else x=18}if((x|0)==18)jL(i,y);f[B>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[D>>2]=f[z>>2]}F=+p[b+176>>3];C=b+192|0;f[h>>2]=f[C>>2];f[h+4>>2]=f[C+4>>2];f[h+8>>2]=f[C+8>>2];f[h+12>>2]=f[C+12>>2];f[h+16>>2]=f[C+16>>2];f[h+20>>2]=f[C+20>>2];f[h+24>>2]=f[C+24>>2];f[h+28>>2]=f[C+28>>2];G=F}else x=21;while(0);if((x|0)==21){th[f[(f[w>>2]|0)+12>>2]&511](w,b,i,-1);G=1.0}w=f[c>>2]|0;do if((w|0)==45580){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){x=41;break}D=c+8|0;if((j|0)!=(D|0)){l=c+44|0;E=f[l>>2]|0;if(E|0){C=E+12|0;f[C>>2]=(f[C>>2]|0)+1}C=j+36|0;E=f[C>>2]|0;if(E|0?(A=E+12|0,E=f[A>>2]|0,f[A>>2]=E+-1,(E|0)==1):0)kL(j);f[C>>2]=0;E=j+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[s>>2]|0)>0){A=f[v>>2]|0;H=0;do{f[A+(H<<2)>>2]=0;H=H+1|0;I=f[s>>2]|0}while((H|0)<(I|0));f[j>>2]=f[D>>2];if((I|0)<3)x=36;else x=38}else{f[j>>2]=f[D>>2];x=36}if((x|0)==36){H=f[c+12>>2]|0;if((H|0)<3){f[s>>2]=H;f[t>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];H=f[c+52>>2]|0;A=f[o>>2]|0;f[A>>2]=f[H>>2];f[A+4>>2]=f[H+4>>2]}else x=38}if((x|0)==38)jL(j,D);f[E>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[C>>2]=f[l>>2]}F=+p[c+176>>3];p[h>>3]=+p[c+192>>3]+ +p[h>>3];H=h+8|0;p[H>>3]=+p[c+200>>3]+ +p[H>>3];H=h+16|0;p[H>>3]=+p[c+208>>3]+ +p[H>>3];H=h+24|0;p[H>>3]=+p[c+216>>3]+ +p[H>>3];J=F}else x=41;while(0);if((x|0)==41){th[f[(f[w>>2]|0)+12>>2]&511](w,c,j,-1);J=1.0}cS(d,i,j,G,J,h);h=j+36|0;w=f[h>>2]|0;if(w|0?(x=w+12|0,w=f[x>>2]|0,f[x>>2]=w+-1,(w|0)==1):0)kL(j);f[h>>2]=0;h=j+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[s>>2]|0)>0){h=f[v>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[o>>2]|0;if((s|0)!=(n|0))UC(s);s=i+36|0;n=f[s>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)kL(i);f[s>>2]=0;s=i+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[a>>2]|0)>0){s=f[m>>2]|0;m=0;do{f[s+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[a>>2]|0))}a=f[r>>2]|0;if((a|0)!=(q|0))UC(a)}else th[f[(f[k>>2]|0)+52>>2]&511](k,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function fR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+128|0;e=a+112|0;g=a+56|0;h=a;dQ(e,46496);f[g>>2]=1124007936;i=g+4|0;j=g+8|0;k=g+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=g+48|0;n=g+44|0;f[n>>2]=j;f[j>>2]=0;f[g+52>>2]=0;o=f[b>>2]|0;th[f[(f[o>>2]|0)+12>>2]&511](o,b,g,-1);f[h>>2]=1124007936;b=h+4|0;o=h+8|0;p=h+40|0;l=b;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[p>>2]=o;o=h+48|0;l=h+44|0;f[l>>2]=o;f[o>>2]=0;f[h+52>>2]=0;cS(d,g,h,1.0,0.0,c);c=h+36|0;d=f[c>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)kL(h);f[c>>2]=0;c=h+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[p>>2]|0;p=0;do{f[c+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[b>>2]|0))}b=f[l>>2]|0;if((b|0)!=(o|0))UC(b);b=g+36|0;o=f[b>>2]|0;if(o|0?(l=o+12|0,o=f[l>>2]|0,f[l>>2]=o+-1,(o|0)==1):0)kL(g);f[b>>2]=0;b=g+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[i>>2]|0)>0){b=f[k>>2]|0;k=0;do{f[b+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[n>>2]|0;if((i|0)!=(j|0))UC(i);if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function gR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0.0;e=u;u=u+160|0;g=e+144|0;h=e;i=e+88|0;j=e+32|0;dQ(g,46476);k=f[c>>2]|0;if((k|0)==(a|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[i>>2]=1124007936;a=i+4|0;l=i+8|0;m=i+40|0;n=a;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;q=i+48|0;r=i+44|0;f[r>>2]=q;f[q>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;s=j+4|0;t=j+8|0;v=j+40|0;n=s;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[v>>2]=t;n=j+48|0;o=j+44|0;f[o>>2]=n;f[n>>2]=0;f[j+52>>2]=0;w=f[b>>2]|0;do if((w|0)==45580){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){x=21;break}y=b+8|0;if((i|0)!=(y|0)){z=b+44|0;A=f[z>>2]|0;if(A){B=A+12|0;f[B>>2]=(f[B>>2]|0)+1;B=i+36|0;A=f[B>>2]|0;if((A|0)!=0?(C=A+12|0,A=f[C>>2]|0,f[C>>2]=A+-1,(A|0)==1):0){kL(i);D=B}else D=B}else D=i+36|0;f[D>>2]=0;B=i+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[a>>2]|0)>0){A=f[m>>2]|0;C=0;do{f[A+(C<<2)>>2]=0;C=C+1|0;E=f[a>>2]|0}while((C|0)<(E|0));f[i>>2]=f[y>>2];if((E|0)<3)x=16;else x=18}else{f[i>>2]=f[y>>2];x=16}if((x|0)==16){C=f[b+12>>2]|0;if((C|0)<3){f[a>>2]=C;f[l>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];C=f[b+52>>2]|0;A=f[r>>2]|0;f[A>>2]=f[C>>2];f[A+4>>2]=f[C+4>>2]}else x=18}if((x|0)==18)jL(i,y);f[B>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[D>>2]=f[z>>2]}F=+p[b+176>>3];C=b+192|0;f[h>>2]=f[C>>2];f[h+4>>2]=f[C+4>>2];f[h+8>>2]=f[C+8>>2];f[h+12>>2]=f[C+12>>2];f[h+16>>2]=f[C+16>>2];f[h+20>>2]=f[C+20>>2];f[h+24>>2]=f[C+24>>2];f[h+28>>2]=f[C+28>>2];G=F}else x=21;while(0);if((x|0)==21){th[f[(f[w>>2]|0)+12>>2]&511](w,b,i,-1);G=1.0}w=f[c>>2]|0;do if((w|0)==45580){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){x=41;break}D=c+8|0;if((j|0)!=(D|0)){l=c+44|0;E=f[l>>2]|0;if(E|0){C=E+12|0;f[C>>2]=(f[C>>2]|0)+1}C=j+36|0;E=f[C>>2]|0;if(E|0?(A=E+12|0,E=f[A>>2]|0,f[A>>2]=E+-1,(E|0)==1):0)kL(j);f[C>>2]=0;E=j+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[s>>2]|0)>0){A=f[v>>2]|0;H=0;do{f[A+(H<<2)>>2]=0;H=H+1|0;I=f[s>>2]|0}while((H|0)<(I|0));f[j>>2]=f[D>>2];if((I|0)<3)x=36;else x=38}else{f[j>>2]=f[D>>2];x=36}if((x|0)==36){H=f[c+12>>2]|0;if((H|0)<3){f[s>>2]=H;f[t>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];H=f[c+52>>2]|0;A=f[o>>2]|0;f[A>>2]=f[H>>2];f[A+4>>2]=f[H+4>>2]}else x=38}if((x|0)==38)jL(j,D);f[E>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[C>>2]=f[l>>2]}F=-+p[c+176>>3];p[h>>3]=+p[h>>3]-+p[c+192>>3];H=h+8|0;p[H>>3]=+p[H>>3]-+p[c+200>>3];H=h+16|0;p[H>>3]=+p[H>>3]-+p[c+208>>3];H=h+24|0;p[H>>3]=+p[H>>3]-+p[c+216>>3];J=F}else x=41;while(0);if((x|0)==41){th[f[(f[w>>2]|0)+12>>2]&511](w,c,j,-1);J=-1.0}cS(d,i,j,G,J,h);h=j+36|0;w=f[h>>2]|0;if(w|0?(x=w+12|0,w=f[x>>2]|0,f[x>>2]=w+-1,(w|0)==1):0)kL(j);f[h>>2]=0;h=j+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[s>>2]|0)>0){h=f[v>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[o>>2]|0;if((s|0)!=(n|0))UC(s);s=i+36|0;n=f[s>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)kL(i);f[s>>2]=0;s=i+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[a>>2]|0)>0){s=f[m>>2]|0;m=0;do{f[s+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[a>>2]|0))}a=f[r>>2]|0;if((a|0)!=(q|0))UC(a)}else th[f[(f[k>>2]|0)+60>>2]&511](k,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function hR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+128|0;e=a+112|0;g=a+56|0;h=a;dQ(e,46456);f[g>>2]=1124007936;i=g+4|0;j=g+8|0;k=g+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=g+48|0;n=g+44|0;f[n>>2]=j;f[j>>2]=0;f[g+52>>2]=0;o=f[c>>2]|0;th[f[(f[o>>2]|0)+12>>2]&511](o,c,g,-1);f[h>>2]=1124007936;c=h+4|0;o=h+8|0;p=h+40|0;l=c;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[p>>2]=o;o=h+48|0;l=h+44|0;f[l>>2]=o;f[o>>2]=0;f[h+52>>2]=0;cS(d,g,h,-1.0,0.0,b);b=h+36|0;d=f[b>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)kL(h);f[b>>2]=0;b=h+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[c>>2]|0)>0){b=f[p>>2]|0;p=0;do{f[b+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[c>>2]|0))}c=f[l>>2]|0;if((c|0)!=(o|0))UC(c);c=g+36|0;o=f[c>>2]|0;if(o|0?(l=o+12|0,o=f[l>>2]|0,f[l>>2]=o+-1,(o|0)==1):0)kL(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[i>>2]|0)>0){c=f[k>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[n>>2]|0;if((i|0)!=(j|0))UC(i);if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function iR(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0;g=u;u=u+128|0;h=g+112|0;i=g+56|0;j=g;dQ(h,46436);k=f[c>>2]|0;if((k|0)==(a|0)){f[i>>2]=1124007936;l=i+4|0;m=i+8|0;n=i+40|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=i+48|0;s=i+44|0;f[s>>2]=r;f[r>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;t=j+4|0;v=j+8|0;w=j+40|0;o=t;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[w>>2]=v;o=j+48|0;q=j+44|0;f[q>>2]=o;f[o>>2]=0;f[j+52>>2]=0;x=f[b>>2]|0;do if(!((x|0)==45940?(f[b+4>>2]|0)==47:0))if((x|0)==45580){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){y=52;break}if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){z=b+8|0;if((i|0)!=(z|0)){A=b+44|0;B=f[A>>2]|0;if(B){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1;C=i+36|0;B=f[C>>2]|0;if((B|0)!=0?(D=B+12|0,B=f[D>>2]|0,f[D>>2]=B+-1,(B|0)==1):0){kL(i);E=C}else E=C}else E=i+36|0;f[E>>2]=0;C=i+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[l>>2]|0)>0){B=f[n>>2]|0;D=0;do{f[B+(D<<2)>>2]=0;D=D+1|0;F=f[l>>2]|0}while((D|0)<(F|0));f[i>>2]=f[z>>2];if((F|0)<3)y=47;else y=49}else{f[i>>2]=f[z>>2];y=47}if((y|0)==47){D=f[b+12>>2]|0;if((D|0)<3){f[l>>2]=D;f[m>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];D=f[b+52>>2]|0;B=f[s>>2]|0;f[B>>2]=f[D>>2];f[B+4>>2]=f[D+4>>2]}else y=49}if((y|0)==49)jL(i,z);f[C>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[E>>2]=f[A>>2]}G=+p[b+176>>3]*e;y=53}else y=52}else y=52;else{if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){y=52;break}do if((a|0)==45580){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){y=27;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){H=+p[c+176>>3]*e;D=c+8|0;if((j|0)==(D|0))I=H;else{B=c+44|0;J=f[B>>2]|0;if(J){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1;K=j+36|0;J=f[K>>2]|0;if((J|0)!=0?(L=J+12|0,J=f[L>>2]|0,f[L>>2]=J+-1,(J|0)==1):0){kL(j);M=K}else M=K}else M=j+36|0;f[M>>2]=0;K=j+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[t>>2]|0)>0){J=f[w>>2]|0;L=0;do{f[J+(L<<2)>>2]=0;L=L+1|0;N=f[t>>2]|0}while((L|0)<(N|0));f[j>>2]=f[D>>2];if((N|0)<3)y=23;else y=25}else{f[j>>2]=f[D>>2];y=23}if((y|0)==23){L=f[c+12>>2]|0;if((L|0)<3){f[t>>2]=L;f[v>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];L=f[c+52>>2]|0;J=f[q>>2]|0;f[J>>2]=f[L>>2];f[J+4>>2]=f[L+4>>2]}else y=25}if((y|0)==25)jL(j,D);f[K>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[M>>2]=f[B>>2];I=H}}else y=27}else y=27;while(0);if((y|0)==27){th[f[(f[a>>2]|0)+12>>2]&511](a,c,j,-1);I=e}YR(d,47,j,b+8|0,I/+p[b+176>>3])}while(0);if((y|0)==52){th[f[(f[x>>2]|0)+12>>2]&511](x,b,i,-1);G=e;y=53}if((y|0)==53){x=f[c>>2]|0;do if((x|0)==45580){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){y=95;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){a=c+8|0;if((j|0)!=(a|0)){M=c+44|0;N=f[M>>2]|0;if(N|0){E=N+12|0;f[E>>2]=(f[E>>2]|0)+1}E=j+36|0;N=f[E>>2]|0;if(N|0?(m=N+12|0,N=f[m>>2]|0,f[m>>2]=N+-1,(N|0)==1):0)kL(j);f[E>>2]=0;N=j+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[t>>2]|0)>0){m=f[w>>2]|0;F=0;do{f[m+(F<<2)>>2]=0;F=F+1|0;O=f[t>>2]|0}while((F|0)<(O|0));f[j>>2]=f[a>>2];if((O|0)<3)y=71;else y=73}else{f[j>>2]=f[a>>2];y=71}if((y|0)==71){F=f[c+12>>2]|0;if((F|0)<3){f[t>>2]=F;f[v>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];F=f[c+52>>2]|0;m=f[q>>2]|0;f[m>>2]=f[F>>2];f[m+4>>2]=f[F+4>>2]}else y=73}if((y|0)==73)jL(j,a);f[N>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[E>>2]=f[M>>2]}P=42;Q=G*+p[c+176>>3]}else y=95}else if((x|0)==45940?(f[c+4>>2]|0)==47:0){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){y=95;break}F=c+8|0;if((j|0)!=(F|0)){m=c+44|0;A=f[m>>2]|0;if(A|0){C=A+12|0;f[C>>2]=(f[C>>2]|0)+1}C=j+36|0;A=f[C>>2]|0;if(A|0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)kL(j);f[C>>2]=0;A=j+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[t>>2]|0)>0){z=f[w>>2]|0;L=0;do{f[z+(L<<2)>>2]=0;L=L+1|0;R=f[t>>2]|0}while((L|0)<(R|0));f[j>>2]=f[F>>2];if((R|0)<3)y=90;else y=92}else{f[j>>2]=f[F>>2];y=90}if((y|0)==90){L=f[c+12>>2]|0;if((L|0)<3){f[t>>2]=L;f[v>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];L=f[c+52>>2]|0;z=f[q>>2]|0;f[z>>2]=f[L>>2];f[z+4>>2]=f[L+4>>2]}else y=92}if((y|0)==92)jL(j,F);f[A>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[C>>2]=f[m>>2]}P=47;Q=G/+p[c+176>>3]}else y=95;while(0);if((y|0)==95){th[f[(f[x>>2]|0)+12>>2]&511](x,c,j,-1);P=42;Q=G}YR(d,P,i,j,Q)}P=j+36|0;x=f[P>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)kL(j);f[P>>2]=0;P=j+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[t>>2]|0)>0){P=f[w>>2]|0;w=0;do{f[P+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[t>>2]|0))}t=f[q>>2]|0;if((t|0)!=(o|0))UC(t);t=i+36|0;o=f[t>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)kL(i);f[t>>2]=0;t=i+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}l=f[s>>2]|0;if((l|0)!=(r|0))UC(l)}else Ah[f[(f[k>>2]|0)+68>>2]&15](k,b,c,d,e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function jR(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=u;u=u+160|0;e=a+144|0;g=a+88|0;h=a+32|0;i=a;dQ(e,46416);f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=g+48|0;o=g+44|0;f[o>>2]=k;f[k>>2]=0;f[g+52>>2]=0;p=f[b>>2]|0;th[f[(f[p>>2]|0)+12>>2]&511](p,b,g,-1);f[h>>2]=1124007936;b=h+4|0;p=h+8|0;q=h+40|0;m=b;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[q>>2]=p;p=h+48|0;m=h+44|0;f[m>>2]=p;f[p>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;cS(d,g,h,c,0.0,i);i=h+36|0;d=f[i>>2]|0;if(d|0?(n=d+12|0,d=f[n>>2]|0,f[n>>2]=d+-1,(d|0)==1):0)kL(h);f[i>>2]=0;i=h+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[b>>2]|0)>0){i=f[q>>2]|0;q=0;do{f[i+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[b>>2]|0))}b=f[m>>2]|0;if((b|0)!=(p|0))UC(b);b=g+36|0;p=f[b>>2]|0;if(p|0?(m=p+12|0,p=f[m>>2]|0,f[m>>2]=p+-1,(p|0)==1):0)kL(g);f[b>>2]=0;b=g+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[j>>2]|0)>0){b=f[l>>2]|0;l=0;do{f[b+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)!=(k|0))UC(j);if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function kR(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0;g=u;u=u+128|0;h=g+112|0;i=g+56|0;j=g;dQ(h,46396);k=f[c>>2]|0;a:do if((k|0)==(a|0)){l=f[b>>2]|0;do if((l|0)==45940?(f[b+4>>2]|0)==47:0){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break;if((a|0)==45940?(f[c+4>>2]|0)==47:0){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;YR(d,47,c+8|0,b+8|0,+p[b+176>>3]/+p[c+176>>3]);break a}}while(0);f[i>>2]=1124007936;m=i+4|0;n=i+8|0;o=i+40|0;q=m;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[o>>2]=n;s=i+48|0;t=i+44|0;f[t>>2]=s;f[s>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;v=j+4|0;w=j+8|0;x=j+40|0;q=v;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[x>>2]=w;q=j+48|0;r=j+44|0;f[r>>2]=q;f[q>>2]=0;f[j+52>>2]=0;do if((l|0)==45580){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){y=32;break}if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){z=b+8|0;if((i|0)!=(z|0)){A=b+44|0;B=f[A>>2]|0;if(B){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1;C=i+36|0;B=f[C>>2]|0;if((B|0)!=0?(D=B+12|0,B=f[D>>2]|0,f[D>>2]=B+-1,(B|0)==1):0){kL(i);E=C}else E=C}else E=i+36|0;f[E>>2]=0;C=i+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[m>>2]|0)>0){B=f[o>>2]|0;D=0;do{f[B+(D<<2)>>2]=0;D=D+1|0;F=f[m>>2]|0}while((D|0)<(F|0));f[i>>2]=f[z>>2];if((F|0)<3)y=27;else y=29}else{f[i>>2]=f[z>>2];y=27}if((y|0)==27){D=f[b+12>>2]|0;if((D|0)<3){f[m>>2]=D;f[n>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];D=f[b+52>>2]|0;B=f[t>>2]|0;f[B>>2]=f[D>>2];f[B+4>>2]=f[D+4>>2]}else y=29}if((y|0)==29)jL(i,z);f[C>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[E>>2]=f[A>>2]}G=+p[b+176>>3]*e}else y=32}else y=32;while(0);if((y|0)==32){th[f[(f[l>>2]|0)+12>>2]&511](l,b,i,-1);G=e}n=f[c>>2]|0;do if((n|0)==45580){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){y=75;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){D=c+8|0;if((j|0)!=(D|0)){B=c+44|0;H=f[B>>2]|0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}I=j+36|0;H=f[I>>2]|0;if(H|0?(J=H+12|0,H=f[J>>2]|0,f[J>>2]=H+-1,(H|0)==1):0)kL(j);f[I>>2]=0;H=j+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[v>>2]|0)>0){J=f[x>>2]|0;K=0;do{f[J+(K<<2)>>2]=0;K=K+1|0;L=f[v>>2]|0}while((K|0)<(L|0));f[j>>2]=f[D>>2];if((L|0)<3)y=51;else y=53}else{f[j>>2]=f[D>>2];y=51}if((y|0)==51){K=f[c+12>>2]|0;if((K|0)<3){f[v>>2]=K;f[w>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];K=f[c+52>>2]|0;J=f[r>>2]|0;f[J>>2]=f[K>>2];f[J+4>>2]=f[K+4>>2]}else y=53}if((y|0)==53)jL(j,D);f[H>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[I>>2]=f[B>>2]}M=47;N=G/+p[c+176>>3]}else y=75}else if((n|0)==45940?(f[c+4>>2]|0)==47:0){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){y=75;break}K=c+8|0;if((j|0)!=(K|0)){J=c+44|0;A=f[J>>2]|0;if(A|0){C=A+12|0;f[C>>2]=(f[C>>2]|0)+1}C=j+36|0;A=f[C>>2]|0;if(A|0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)kL(j);f[C>>2]=0;A=j+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[v>>2]|0)>0){z=f[x>>2]|0;O=0;do{f[z+(O<<2)>>2]=0;O=O+1|0;P=f[v>>2]|0}while((O|0)<(P|0));f[j>>2]=f[K>>2];if((P|0)<3)y=70;else y=72}else{f[j>>2]=f[K>>2];y=70}if((y|0)==70){O=f[c+12>>2]|0;if((O|0)<3){f[v>>2]=O;f[w>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];O=f[c+52>>2]|0;z=f[r>>2]|0;f[z>>2]=f[O>>2];f[z+4>>2]=f[O+4>>2]}else y=72}if((y|0)==72)jL(j,K);f[A>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[C>>2]=f[J>>2]}M=42;N=G/+p[c+176>>3]}else y=75;while(0);if((y|0)==75){th[f[(f[n>>2]|0)+12>>2]&511](n,c,j,-1);M=47;N=G}YR(d,M,i,j,N);w=j+36|0;l=f[w>>2]|0;if(l|0?(O=l+12|0,l=f[O>>2]|0,f[O>>2]=l+-1,(l|0)==1):0)kL(j);f[w>>2]=0;w=j+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[v>>2]|0)>0){w=f[x>>2]|0;l=0;do{f[w+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[v>>2]|0))}v=f[r>>2]|0;if((v|0)!=(q|0))UC(v);v=i+36|0;l=f[v>>2]|0;if(l|0?(w=l+12|0,l=f[w>>2]|0,f[w>>2]=l+-1,(l|0)==1):0)kL(i);f[v>>2]=0;v=i+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[m>>2]|0)>0){v=f[o>>2]|0;l=0;do{f[v+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[t>>2]|0;if((m|0)!=(s|0))UC(m)}else Ah[f[(f[k>>2]|0)+76>>2]&15](k,b,c,d,e);while(0);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function lR(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=u;u=u+128|0;e=a+112|0;g=a+56|0;h=a;dQ(e,46376);f[g>>2]=1124007936;i=g+4|0;j=g+8|0;k=g+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=g+48|0;n=g+44|0;f[n>>2]=j;f[j>>2]=0;f[g+52>>2]=0;o=f[c>>2]|0;th[f[(f[o>>2]|0)+12>>2]&511](o,c,g,-1);f[h>>2]=1124007936;c=h+4|0;o=h+8|0;p=h+40|0;l=c;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[p>>2]=o;o=h+48|0;l=h+44|0;f[l>>2]=o;f[o>>2]=0;f[h+52>>2]=0;YR(d,47,g,h,b);d=h+36|0;m=f[d>>2]|0;if(m|0?(q=m+12|0,m=f[q>>2]|0,f[q>>2]=m+-1,(m|0)==1):0)kL(h);f[d>>2]=0;d=h+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[p>>2]|0;p=0;do{f[d+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[c>>2]|0))}c=f[l>>2]|0;if((c|0)!=(o|0))UC(c);c=g+36|0;o=f[c>>2]|0;if(o|0?(l=o+12|0,o=f[l>>2]|0,f[l>>2]=o+-1,(o|0)==1):0)kL(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[i>>2]|0)>0){c=f[k>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[n>>2]|0;if((i|0)!=(j|0))UC(i);if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function mR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+128|0;d=a+112|0;e=a+56|0;g=a;dQ(d,46356);f[e>>2]=1124007936;h=e+4|0;i=e+8|0;j=e+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=e+48|0;m=e+44|0;f[m>>2]=i;f[i>>2]=0;f[e+52>>2]=0;n=f[b>>2]|0;th[f[(f[n>>2]|0)+12>>2]&511](n,b,e,-1);f[g>>2]=1124007936;b=g+4|0;n=g+8|0;o=g+40|0;k=b;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[o>>2]=n;n=g+48|0;k=g+44|0;f[k>>2]=n;f[n>>2]=0;f[g+52>>2]=0;YR(c,97,e,g,1.0);c=g+36|0;l=f[c>>2]|0;if(l|0?(p=l+12|0,l=f[p>>2]|0,f[p>>2]=l+-1,(l|0)==1):0)kL(g);f[c>>2]=0;c=g+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[o>>2]|0;o=0;do{f[c+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[b>>2]|0))}b=f[k>>2]|0;if((b|0)!=(n|0))UC(b);b=e+36|0;n=f[b>>2]|0;if(n|0?(k=n+12|0,n=f[k>>2]|0,f[k>>2]=n+-1,(n|0)==1):0)kL(e);f[b>>2]=0;b=e+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[h>>2]|0)>0){b=f[j>>2]|0;j=0;do{f[b+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[m>>2]|0;if((h|0)!=(i|0))UC(h);if(!(f[d+4>>2]|0)){u=a;return}u=a;return}function nR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+64|0;d=a+56|0;e=a;dQ(d,46336);f[e>>2]=1124007936;g=e+4|0;h=e+8|0;i=e+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=e+48|0;j=e+44|0;f[j>>2]=h;f[h>>2]=0;f[e+52>>2]=0;k=f[b>>2]|0;th[f[(f[k>>2]|0)+12>>2]&511](k,b,e,-1);WR(c,e,1.0);c=e+36|0;b=f[c>>2]|0;if(b|0?(k=b+12|0,b=f[k>>2]|0,f[k>>2]=b+-1,(b|0)==1):0)kL(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[g>>2]|0)>0){c=f[i>>2]|0;i=0;do{f[c+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[j>>2]|0;if((g|0)!=(h|0))UC(g);if(!(f[d+4>>2]|0)){u=a;return}u=a;return}function oR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0;e=u;u=u+432|0;g=e+32|0;h=e;i=e+368|0;j=e+312|0;k=e+256|0;l=f[c>>2]|0;if((l|0)!=(a|0)){th[f[(f[l>>2]|0)+92>>2]&511](l,b,c,d);u=e;return}f[i>>2]=1124007936;l=i+4|0;a=i+8|0;m=i+40|0;n=l;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=a;q=i+48|0;r=i+44|0;f[r>>2]=q;f[q>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;s=j+4|0;t=j+8|0;v=j+40|0;n=s;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[v>>2]=t;w=j+48|0;x=j+44|0;f[x>>2]=w;f[w>>2]=0;f[j+52>>2]=0;y=f[b>>2]|0;a:do if((y|0)==45576){z=+p[b+176>>3];A=b+8|0;if((i|0)==(A|0)){B=1;C=z}else{D=b+44|0;E=f[D>>2]|0;if(E){F=E+12|0;f[F>>2]=(f[F>>2]|0)+1;F=i+36|0;E=f[F>>2]|0;if((E|0)!=0?(G=E+12|0,E=f[G>>2]|0,f[G>>2]=E+-1,(E|0)==1):0){kL(i);H=F}else H=F}else H=i+36|0;f[H>>2]=0;F=i+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[l>>2]|0)>0){E=f[m>>2]|0;G=0;do{f[E+(G<<2)>>2]=0;G=G+1|0;I=f[l>>2]|0}while((G|0)<(I|0));f[i>>2]=f[A>>2];if((I|0)<3)J=14;else J=16}else{f[i>>2]=f[A>>2];J=14}if((J|0)==14){G=f[b+12>>2]|0;if((G|0)<3){f[l>>2]=G;f[a>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];G=f[b+52>>2]|0;E=f[r>>2]|0;f[E>>2]=f[G>>2];f[E+4>>2]=f[G+4>>2]}else J=16}if((J|0)==16)jL(i,A);f[F>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[H>>2]=f[D>>2];B=1;C=z}}else{do if((y|0)==45580){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0)break;if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){K=+p[b+176>>3];G=b+8|0;if((i|0)==(G|0)){B=0;C=K;break a}E=b+44|0;L=f[E>>2]|0;if(L){M=L+12|0;f[M>>2]=(f[M>>2]|0)+1;M=i+36|0;L=f[M>>2]|0;if((L|0)!=0?(N=L+12|0,L=f[N>>2]|0,f[N>>2]=L+-1,(L|0)==1):0){kL(i);O=M}else O=M}else O=i+36|0;f[O>>2]=0;M=i+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[l>>2]|0)>0){L=f[m>>2]|0;N=0;do{f[L+(N<<2)>>2]=0;N=N+1|0;P=f[l>>2]|0}while((N|0)<(P|0));f[i>>2]=f[G>>2];if((P|0)<3)J=36;else J=38}else{f[i>>2]=f[G>>2];J=36}if((J|0)==36){N=f[b+12>>2]|0;if((N|0)<3){f[l>>2]=N;f[a>>2]=f[b+16>>2];f[i+12>>2]=f[b+20>>2];N=f[b+52>>2]|0;L=f[r>>2]|0;f[L>>2]=f[N>>2];f[L+4>>2]=f[N+4>>2]}else J=38}if((J|0)==38)jL(i,G);f[M>>2]=f[b+24>>2];f[i+20>>2]=f[b+28>>2];f[i+24>>2]=f[b+32>>2];f[i+28>>2]=f[b+36>>2];f[i+32>>2]=f[b+40>>2];f[O>>2]=f[E>>2];B=0;C=K;break a}}while(0);th[f[(f[y>>2]|0)+12>>2]&511](y,b,i,-1);B=0;C=1.0}while(0);b=f[c>>2]|0;b:do if((b|0)==45576){y=B|2;z=C*+p[c+176>>3];O=c+8|0;if((j|0)==(O|0)){Q=y;R=z}else{a=c+44|0;P=f[a>>2]|0;if(P|0){H=P+12|0;f[H>>2]=(f[H>>2]|0)+1}H=j+36|0;P=f[H>>2]|0;if(P|0?(I=P+12|0,P=f[I>>2]|0,f[I>>2]=P+-1,(P|0)==1):0)kL(j);f[H>>2]=0;P=j+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[s>>2]|0)>0){I=f[v>>2]|0;D=0;do{f[I+(D<<2)>>2]=0;D=D+1|0;S=f[s>>2]|0}while((D|0)<(S|0));f[j>>2]=f[O>>2];if((S|0)<3)J=53;else J=55}else{f[j>>2]=f[O>>2];J=53}if((J|0)==53){D=f[c+12>>2]|0;if((D|0)<3){f[s>>2]=D;f[t>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];D=f[c+52>>2]|0;I=f[x>>2]|0;f[I>>2]=f[D>>2];f[I+4>>2]=f[D+4>>2]}else J=55}if((J|0)==55)jL(j,O);f[P>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[H>>2]=f[a>>2];Q=y;R=z}}else{do if((b|0)==45580){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0)break;if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){T=C*+p[c+176>>3];D=c+8|0;if((j|0)==(D|0)){Q=B;R=T;break b}I=c+44|0;F=f[I>>2]|0;if(F|0){A=F+12|0;f[A>>2]=(f[A>>2]|0)+1}A=j+36|0;F=f[A>>2]|0;if(F|0?(N=F+12|0,F=f[N>>2]|0,f[N>>2]=F+-1,(F|0)==1):0)kL(j);f[A>>2]=0;F=j+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[s>>2]|0)>0){N=f[v>>2]|0;L=0;do{f[N+(L<<2)>>2]=0;L=L+1|0;U=f[s>>2]|0}while((L|0)<(U|0));f[j>>2]=f[D>>2];if((U|0)<3)J=75;else J=77}else{f[j>>2]=f[D>>2];J=75}if((J|0)==75){L=f[c+12>>2]|0;if((L|0)<3){f[s>>2]=L;f[t>>2]=f[c+16>>2];f[j+12>>2]=f[c+20>>2];L=f[c+52>>2]|0;N=f[x>>2]|0;f[N>>2]=f[L>>2];f[N+4>>2]=f[L+4>>2]}else J=77}if((J|0)==77)jL(j,D);f[F>>2]=f[c+24>>2];f[j+20>>2]=f[c+28>>2];f[j+24>>2]=f[c+32>>2];f[j+28>>2]=f[c+36>>2];f[j+32>>2]=f[c+40>>2];f[A>>2]=f[I>>2];Q=B;R=T;break b}}while(0);th[f[(f[b>>2]|0)+12>>2]&511](b,c,j,-1);Q=B;R=C}while(0);f[k>>2]=1124007936;B=k+4|0;c=k+8|0;b=k+40|0;n=B;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[b>>2]=c;c=k+48|0;n=k+44|0;f[n>>2]=c;f[c>>2]=0;f[k+52>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;tR(g,45584,Q,i,j,k,R,1.0,h);uR(d,g)|0;Wi(g);g=k+36|0;d=f[g>>2]|0;if(d|0?(h=d+12|0,d=f[h>>2]|0,f[h>>2]=d+-1,(d|0)==1):0)kL(k);f[g>>2]=0;g=k+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[B>>2]|0)>0){g=f[b>>2]|0;b=0;do{f[g+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[B>>2]|0))}B=f[n>>2]|0;if((B|0)!=(c|0))UC(B);B=j+36|0;c=f[B>>2]|0;if(c|0?(n=c+12|0,c=f[n>>2]|0,f[n>>2]=c+-1,(c|0)==1):0)kL(j);f[B>>2]=0;B=j+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[s>>2]|0)>0){B=f[v>>2]|0;v=0;do{f[B+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[s>>2]|0))}s=f[x>>2]|0;if((s|0)!=(w|0))UC(s);s=i+36|0;w=f[s>>2]|0;if(w|0?(x=w+12|0,w=f[x>>2]|0,f[x>>2]=w+-1,(w|0)==1):0)kL(i);f[s>>2]=0;s=i+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[l>>2]|0)>0){s=f[m>>2]|0;m=0;do{f[s+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}l=f[r>>2]|0;if((l|0)!=(q|0))UC(l);u=e;return}function pR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+64|0;e=a;f[e>>2]=1124007936;g=e+4|0;h=e+8|0;i=e+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=e+48|0;j=e+44|0;f[j>>2]=h;f[h>>2]=0;f[e+52>>2]=0;k=f[b>>2]|0;th[f[(f[k>>2]|0)+12>>2]&511](k,b,e,-1);sR(d,c,e);c=e+36|0;d=f[c>>2]|0;if(d|0?(b=d+12|0,d=f[b>>2]|0,f[b>>2]=d+-1,(d|0)==1):0)kL(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[g>>2]|0)>0){c=f[i>>2]|0;i=0;do{f[c+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[j>>2]|0;if((g|0)==(h|0)){u=a;return}UC(g);u=a;return}function qR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if(f[c+24>>2]|0){b=f[c+12>>2]|0;if((b|0)<3)d=Y(f[c+20>>2]|0,f[c+16>>2]|0)|0;else{e=f[c+48>>2]|0;g=0;h=1;while(1){i=Y(f[e+(g<<2)>>2]|0,h)|0;g=g+1|0;if((g|0)==(b|0)){d=i;break}else h=i}}if(!((b|0)==0|(d|0)==0))j=c+48|0;else k=8}else k=8;do if((k|0)==8){if(f[c+80>>2]|0){d=f[c+68>>2]|0;if((d|0)<3)l=Y(f[c+76>>2]|0,f[c+72>>2]|0)|0;else{b=f[c+104>>2]|0;h=0;g=1;while(1){e=Y(f[b+(h<<2)>>2]|0,g)|0;h=h+1|0;if((h|0)==(d|0)){l=e;break}else g=e}}if(!((d|0)==0|(l|0)==0)){j=c+160|0;break}}j=c+104|0}while(0);c=f[j>>2]|0;j=f[c>>2]|0;f[a>>2]=f[c+4>>2];f[a+4>>2]=j;return}function rR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+16|0;c=a;dQ(c,45196);d=b+8|0;if(f[b+24>>2]|0){e=f[b+12>>2]|0;if((e|0)<3)g=Y(f[b+20>>2]|0,f[b+16>>2]|0)|0;else{h=f[b+48>>2]|0;i=0;j=1;while(1){k=Y(f[h+(i<<2)>>2]|0,j)|0;i=i+1|0;if((i|0)==(e|0)){g=k;break}else j=k}}if(!((e|0)==0|(g|0)==0))l=d;else m=7}else m=7;do if((m|0)==7){d=b+64|0;if(f[b+80>>2]|0){g=f[b+68>>2]|0;if((g|0)<3)n=Y(f[b+76>>2]|0,f[b+72>>2]|0)|0;else{e=f[b+104>>2]|0;j=0;i=1;while(1){h=Y(f[e+(j<<2)>>2]|0,i)|0;j=j+1|0;if((j|0)==(g|0)){n=h;break}else i=h}}if(!((g|0)==0|(n|0)==0)){l=b+120|0;break}}l=d}while(0);b=f[l>>2]&4095;if(!(f[c+4>>2]|0)){u=a;return b|0}u=a;return b|0}function sR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+368|0;e=d+32|0;g=d+312|0;h=d+256|0;i=d;f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=g+48|0;o=g+44|0;f[o>>2]=k;f[k>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[r>>2]=q;q=h+48|0;m=h+44|0;f[m>>2]=q;f[q>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;tR(e,45216,b,c,g,h,1.0,0.0,i);uR(a,e)|0;Wi(e);e=h+36|0;a=f[e>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)kL(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[p>>2]|0)>0){e=f[r>>2]|0;r=0;do{f[e+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[m>>2]|0;if((p|0)!=(q|0))UC(p);p=g+36|0;q=f[p>>2]|0;if(q|0?(m=q+12|0,q=f[m>>2]|0,f[m>>2]=q+-1,(q|0)==1):0)kL(g);f[p>>2]=0;p=g+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[j>>2]|0)>0){p=f[l>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=d;return}UC(j);u=d;return}function tR(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0.0,B=0;f[a>>2]=b;f[a+4>>2]=c;c=a+8|0;f[c>>2]=f[d>>2];b=a+12|0;k=d+4|0;f[b>>2]=f[k>>2];l=a+16|0;f[l>>2]=f[d+8>>2];f[a+20>>2]=f[d+12>>2];f[a+24>>2]=f[d+16>>2];f[a+28>>2]=f[d+20>>2];f[a+32>>2]=f[d+24>>2];f[a+36>>2]=f[d+28>>2];f[a+40>>2]=f[d+32>>2];m=f[d+36>>2]|0;f[a+44>>2]=m;f[a+48>>2]=l;l=a+56|0;n=a+52|0;f[n>>2]=l;f[l>>2]=0;f[a+60>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[d+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[b>>2]=0;jL(c,d)}d=a+64|0;f[d>>2]=f[e>>2];c=a+68|0;b=e+4|0;f[c>>2]=f[b>>2];k=a+72|0;f[k>>2]=f[e+8>>2];f[a+76>>2]=f[e+12>>2];f[a+80>>2]=f[e+16>>2];f[a+84>>2]=f[e+20>>2];f[a+88>>2]=f[e+24>>2];f[a+92>>2]=f[e+28>>2];f[a+96>>2]=f[e+32>>2];l=f[e+36>>2]|0;f[a+100>>2]=l;f[a+104>>2]=k;k=a+112|0;n=a+108|0;f[n>>2]=k;f[k>>2]=0;f[a+116>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[b>>2]|0)<3){b=f[e+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2]}else{f[c>>2]=0;jL(d,e)}e=a+120|0;f[e>>2]=f[g>>2];d=a+124|0;c=g+4|0;f[d>>2]=f[c>>2];b=a+128|0;f[b>>2]=f[g+8>>2];f[a+132>>2]=f[g+12>>2];f[a+136>>2]=f[g+16>>2];f[a+140>>2]=f[g+20>>2];f[a+144>>2]=f[g+24>>2];f[a+148>>2]=f[g+28>>2];f[a+152>>2]=f[g+32>>2];k=f[g+36>>2]|0;f[a+156>>2]=k;f[a+160>>2]=b;b=a+168|0;n=a+164|0;f[n>>2]=b;f[b>>2]=0;f[a+172>>2]=0;if(k|0){b=k+12|0;f[b>>2]=(f[b>>2]|0)+1}if((f[c>>2]|0)<3){c=f[g+44>>2]|0;b=f[n>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];o=a+176|0;p[o>>3]=h;q=a+184|0;p[q>>3]=i;r=+p[j>>3];s=a+192|0;p[s>>3]=r;t=j+8|0;u=+p[t>>3];v=a+200|0;p[v>>3]=u;w=j+16|0;x=+p[w>>3];y=a+208|0;p[y>>3]=x;z=j+24|0;A=+p[z>>3];B=a+216|0;p[B>>3]=A;return}else{f[d>>2]=0;jL(e,g);o=a+176|0;p[o>>3]=h;q=a+184|0;p[q>>3]=i;r=+p[j>>3];s=a+192|0;p[s>>3]=r;t=j+8|0;u=+p[t>>3];v=a+200|0;p[v>>3]=u;w=j+16|0;x=+p[w>>3];y=a+208|0;p[y>>3]=x;z=j+24|0;A=+p[z>>3];B=a+216|0;p[B>>3]=A;return}}function uR(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=b;d=f[c+4>>2]|0;e=a;f[e>>2]=f[c>>2];f[e+4>>2]=d;d=a+8|0;e=b+8|0;c=(a|0)==(b|0);if(c){g=a+176|0;h=b+176|0;i=g;j=h;k=i+48|0;do{f[i>>2]=f[j>>2];i=i+4|0;j=j+4|0}while((i|0)<(k|0));return a|0}l=b+44|0;m=f[l>>2]|0;if(m|0){n=m+12|0;f[n>>2]=(f[n>>2]|0)+1}n=a+44|0;m=f[n>>2]|0;if(m|0?(o=m+12|0,m=f[o>>2]|0,f[o>>2]=m+-1,(m|0)==1):0)kL(d);f[n>>2]=0;m=a+24|0;o=a+12|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[o>>2]|0)>0){p=f[a+48>>2]|0;q=0;do{f[p+(q<<2)>>2]=0;q=q+1|0;r=f[o>>2]|0}while((q|0)<(r|0));f[d>>2]=f[e>>2];if((r|0)<3)s=12;else s=14}else{f[d>>2]=f[e>>2];s=12}if((s|0)==12){r=f[b+12>>2]|0;if((r|0)<3){f[o>>2]=r;f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];r=f[b+52>>2]|0;o=f[a+52>>2]|0;f[o>>2]=f[r>>2];f[o+4>>2]=f[r+4>>2]}else s=14}if((s|0)==14)jL(d,e);f[m>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[a+36>>2]=f[b+36>>2];f[a+40>>2]=f[b+40>>2];f[n>>2]=f[l>>2];l=a+64|0;n=b+64|0;if(c){g=a+176|0;h=b+176|0;i=g;j=h;k=i+48|0;do{f[i>>2]=f[j>>2];i=i+4|0;j=j+4|0}while((i|0)<(k|0));return a|0}m=b+100|0;e=f[m>>2]|0;if(e|0){d=e+12|0;f[d>>2]=(f[d>>2]|0)+1}d=a+100|0;e=f[d>>2]|0;if(e|0?(r=e+12|0,e=f[r>>2]|0,f[r>>2]=e+-1,(e|0)==1):0)kL(l);f[d>>2]=0;e=a+80|0;r=a+68|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[r>>2]|0)>0){o=f[a+104>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0;t=f[r>>2]|0}while((q|0)<(t|0));f[l>>2]=f[n>>2];if((t|0)<3)s=26;else s=28}else{f[l>>2]=f[n>>2];s=26}if((s|0)==26){t=f[b+68>>2]|0;if((t|0)<3){f[r>>2]=t;f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];t=f[b+108>>2]|0;r=f[a+108>>2]|0;f[r>>2]=f[t>>2];f[r+4>>2]=f[t+4>>2]}else s=28}if((s|0)==28)jL(l,n);f[e>>2]=f[b+80>>2];f[a+84>>2]=f[b+84>>2];f[a+88>>2]=f[b+88>>2];f[a+92>>2]=f[b+92>>2];f[a+96>>2]=f[b+96>>2];f[d>>2]=f[m>>2];m=a+120|0;d=b+120|0;if(c){g=a+176|0;h=b+176|0;i=g;j=h;k=i+48|0;do{f[i>>2]=f[j>>2];i=i+4|0;j=j+4|0}while((i|0)<(k|0));return a|0}c=b+156|0;e=f[c>>2]|0;if(e|0){n=e+12|0;f[n>>2]=(f[n>>2]|0)+1}n=a+156|0;e=f[n>>2]|0;if(e|0?(l=e+12|0,e=f[l>>2]|0,f[l>>2]=e+-1,(e|0)==1):0)kL(m);f[n>>2]=0;e=a+136|0;l=a+124|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[l>>2]|0)>0){t=f[a+160>>2]|0;r=0;do{f[t+(r<<2)>>2]=0;r=r+1|0;u=f[l>>2]|0}while((r|0)<(u|0));f[m>>2]=f[d>>2];if((u|0)<3)s=40;else s=42}else{f[m>>2]=f[d>>2];s=40}if((s|0)==40){u=f[b+124>>2]|0;if((u|0)<3){f[l>>2]=u;f[a+128>>2]=f[b+128>>2];f[a+132>>2]=f[b+132>>2];u=f[b+164>>2]|0;l=f[a+164>>2]|0;f[l>>2]=f[u>>2];f[l+4>>2]=f[u+4>>2]}else s=42}if((s|0)==42)jL(m,d);f[e>>2]=f[b+136>>2];f[a+140>>2]=f[b+140>>2];f[a+144>>2]=f[b+144>>2];f[a+148>>2]=f[b+148>>2];f[a+152>>2]=f[b+152>>2];f[n>>2]=f[c>>2];g=a+176|0;h=b+176|0;i=g;j=h;k=i+48|0;do{f[i>>2]=f[j>>2];i=i+4|0;j=j+4|0}while((i|0)<(k|0));return a|0}function vR(a){a=a|0;O5b(a);return}function wR(a,b){a=a|0;b=b|0;return 0}function xR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+96|0;e=a+32|0;g=a+16|0;h=a;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;l=e+44|0;f[l>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)n=e;else n=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;m=h+8|0;f[m>>2]=0;f[m+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=n;+aT(g,h,f[b+4>>2]|0);if((f[n+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;OJ(n,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(n=g+12|0,g=f[n>>2]|0,f[n>>2]=g+-1,(g|0)==1):0)kL(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[i>>2]|0)>0){d=f[k>>2]|0;k=0;do{f[d+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}UC(i);u=a;return}function yR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[c>>2]|0;if((f[b>>2]|0)==45216&(e|0)==45336){zR(d,f[b+4>>2]|0,b+8|0,c+8|0);return}if((a|0)==(e|0)){oR(e,b,c,d);return}else{th[f[(f[e>>2]|0)+92>>2]&511](e,b,c,d);return}}function zR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+320|0;g=e+32|0;h=e+256|0;i=e;f[h>>2]=1124007936;j=h+4|0;k=h+8|0;l=h+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=h+48|0;m=h+44|0;f[m>>2]=k;f[k>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;tR(g,45340,b,c,d,h,1.0,1.0,i);uR(a,g)|0;Wi(g);g=h+36|0;a=f[g>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)kL(h);f[g>>2]=0;g=h+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[j>>2]|0)>0){g=f[l>>2]|0;l=0;do{f[g+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=e;return}UC(j);u=e;return}function AR(a){a=a|0;O5b(a);return}function BR(a,b){a=a|0;b=b|0;return 0}function CR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;e=a+48|0;g=a+32|0;h=a+16|0;i=a;f[e>>2]=1124007936;j=e+4|0;k=e+8|0;l=e+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)o=e;else o=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+64;n=i+8|0;f[n>>2]=0;f[n+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;jT(g,h,i,f[b+4>>2]|0)|0;if((f[o+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;OJ(o,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(o=g+12|0,g=f[o>>2]|0,f[o>>2]=g+-1,(g|0)==1):0)kL(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[l>>2]|0;l=0;do{f[d+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=a;return}UC(j);u=a;return}function DR(a){a=a|0;O5b(a);return}function ER(a,b){a=a|0;b=b|0;return 1}function FR(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+16|0;g=a;h=c+8|0;if((e|0)!=-1?(i=f[h>>2]|0,(i&4095|0)!=(e|0)):0){if((i^e)&4088|0){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,59)|0;j=196891;k=i+59|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,g,196951,196805,1238);bD(g)}j=g+8|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=d;OJ(h,g,e,1.0,0.0);u=a;return}if((h|0)==(d|0)){u=a;return}e=c+44|0;g=f[e>>2]|0;if(g|0){j=g+12|0;f[j>>2]=(f[j>>2]|0)+1}j=d+36|0;g=f[j>>2]|0;if(g|0?(i=g+12|0,g=f[i>>2]|0,f[i>>2]=g+-1,(g|0)==1):0)kL(d);f[j>>2]=0;g=d+16|0;i=d+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){k=f[d+40>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0;m=f[i>>2]|0}while((l|0)<(m|0));f[d>>2]=f[c+8>>2];if((m|0)<3)n=14;else n=16}else{f[d>>2]=f[c+8>>2];n=14}if((n|0)==14){m=f[c+12>>2]|0;if((m|0)<3){f[i>>2]=m;f[d+8>>2]=f[c+16>>2];f[d+12>>2]=f[c+20>>2];m=f[c+52>>2]|0;i=f[d+44>>2]|0;f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2]}else n=16}if((n|0)==16)jL(d,h);f[g>>2]=f[c+24>>2];f[d+20>>2]=f[c+28>>2];f[d+24>>2]=f[c+32>>2];f[d+28>>2]=f[c+36>>2];f[d+32>>2]=f[c+40>>2];f[j>>2]=f[e>>2];u=a;return}function GR(a){a=a|0;O5b(a);return}function HR(a,b){a=a|0;b=b|0;return 0}function IR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0;a=u;u=u+128|0;e=a+64|0;g=a+48|0;h=a+32|0;i=a+16|0;j=a;f[e>>2]=1124007936;k=e+4|0;l=e+8|0;m=e+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=e+48|0;n=e+44|0;f[n>>2]=l;f[l>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)q=e;else q=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+64;r=+p[b+176>>3];f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=b+120;s=+p[b+184>>3];o=j+8|0;f[o>>2]=0;f[o+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=q;CX(g,h,r,i,s,j,f[b+4>>2]|0);if((f[q+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;OJ(q,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(q=g+12|0,g=f[q>>2]|0,f[q>>2]=g+-1,(g|0)==1):0)kL(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[m>>2]|0;m=0;do{f[d+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[n>>2]|0;if((k|0)==(l|0)){u=a;return}UC(k);u=a;return}function JR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0,s=0;e=u;u=u+272|0;g=e+32|0;h=e;i=e+256|0;dQ(i,45764);j=f[b>>2]|0;k=(j|0)==45336;l=f[c>>2]|0;m=(l|0)==45336;n=k?1.0:+p[b+176>>3];o=m?1.0:+p[c+176>>3];q=+p[b+184>>3];a:do if((j|0)!=45584|(f[b+136>>2]|0)!=0&q!=0.0)r=12;else{do if(!m){if((l|0)!=45580)if((l|0)==45576)break;else{r=12;break a}if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){r=12;break a}if(!(+p[c+192>>3]==0.0)){r=12;break a}if(!(+p[c+200>>3]==0.0)){r=12;break a}if(!(+p[c+208>>3]==0.0)){r=12;break a}if(!(+p[c+216>>3]==0.0)){r=12;break a}}while(0);s=((l|0)==45576?4:0)|f[b+4>>2]&-5;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;tR(g,45584,s,b+8|0,b+64|0,c+8|0,n,o,h);uR(d,g)|0;Wi(g)}while(0);b:do if((r|0)==12){c:do if(!((l|0)!=45584|(f[c+136>>2]|0?+p[c+184>>3]!=0.0:0))){do if(!k){if((j|0)!=45580)if((j|0)==45576)break;else break c;if(!((f[b+80>>2]|0)==0|q==0.0))break c;if(!(+p[b+192>>3]==0.0))break c;if(!(+p[b+200>>3]==0.0))break c;if(!(+p[b+208>>3]==0.0))break c;if(!(+p[b+216>>3]==0.0))break c}while(0);m=((j|0)==45576?4:0)|f[c+4>>2]&-5;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;tR(g,45584,m,c+8|0,c+64|0,b+8|0,o,n,h);uR(d,g)|0;Wi(g);break b}while(0);if((a|0)==(l|0)){eR(l,b,c,d);break}else{th[f[(f[l>>2]|0)+52>>2]&511](l,b,c,d);break}}while(0);if(!(f[i+4>>2]|0)){u=e;return}u=e;return}function KR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0,s=0;e=u;u=u+272|0;g=e+32|0;h=e;i=e+256|0;dQ(i,45744);j=f[b>>2]|0;k=(j|0)==45336;l=f[c>>2]|0;m=(l|0)==45336;n=k?1.0:+p[b+176>>3];o=m?1.0:+p[c+176>>3];q=+p[b+184>>3];a:do if((j|0)!=45584|(f[b+136>>2]|0)!=0&q!=0.0)r=12;else{do if(!m){if((l|0)!=45580)if((l|0)==45576)break;else{r=12;break a}if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){r=12;break a}if(!(+p[c+192>>3]==0.0)){r=12;break a}if(!(+p[c+200>>3]==0.0)){r=12;break a}if(!(+p[c+208>>3]==0.0)){r=12;break a}if(!(+p[c+216>>3]==0.0)){r=12;break a}}while(0);s=((l|0)==45576?4:0)|f[b+4>>2]&-5;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;tR(g,45584,s,b+8|0,b+64|0,c+8|0,n,-o,h);uR(d,g)|0;Wi(g)}while(0);b:do if((r|0)==12){c:do if(!((l|0)!=45584|(f[c+136>>2]|0?+p[c+184>>3]!=0.0:0))){do if(!k){if((j|0)!=45580)if((j|0)==45576)break;else break c;if(!((f[b+80>>2]|0)==0|q==0.0))break c;if(!(+p[b+192>>3]==0.0))break c;if(!(+p[b+200>>3]==0.0))break c;if(!(+p[b+208>>3]==0.0))break c;if(!(+p[b+216>>3]==0.0))break c}while(0);m=((j|0)==45576?4:0)|f[c+4>>2]&-5;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;tR(g,45584,m,c+8|0,c+64|0,b+8|0,-o,n,h);uR(d,g)|0;Wi(g);break b}while(0);if((a|0)==(l|0)){gR(l,b,c,d);break}else{th[f[(f[l>>2]|0)+60>>2]&511](l,b,c,d);break}}while(0);if(!(f[i+4>>2]|0)){u=e;return}u=e;return}function LR(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0;a=u;u=u+16|0;e=a;dQ(e,45724);uR(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;b=d+184|0;p[b>>3]=+p[b>>3]*c;if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function MR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=u;u=u+16|0;d=a;dQ(d,45704);uR(c,b)|0;e=f[b+4>>2]|0;f[c+4>>2]=(e<<1&2|e&4|e>>>1&1)^7;gL(c+8|0,c+64|0);if(!(f[d+4>>2]|0)){u=a;return}u=a;return}function NR(a){a=a|0;O5b(a);return}function OR(a,b){a=a|0;b=b|0;return 1}function PR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,v=0,w=0.0,x=0.0;a=u;u=u+112|0;e=a+48|0;g=a+32|0;h=a+16|0;i=a;f[e>>2]=1124007936;j=e+4|0;k=e+8|0;l=e+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)o=e;else o=c;n=b+64|0;q=b+192|0;a:do if(!(f[b+80>>2]|0)){do if((+p[b+200>>3]==0.0?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){r=+p[b+176>>3];if((f[o+16>>2]|0)==(f[c+16>>2]|0)?!(+L(+r)!=1.0):0)break;s=g+8|0;f[s>>2]=0;f[s+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;OJ(b+8|0,g,d,r,+p[q>>3]);break a}while(0);r=+p[b+176>>3];if(r==1.0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h>>2]=-1056833530;f[h+4>>2]=q;f[h+8>>2]=1;f[h+12>>2]=4;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;VD(g,h,i,UM()|0,-1);t=38;break}if(r==-1.0){f[g>>2]=-1056833530;f[g+4>>2]=q;f[g+8>>2]=1;f[g+12>>2]=4;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+8;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;jE(g,h,i,UM()|0,-1);t=38;break}else{s=b+8|0;v=g+8|0;f[v>>2]=0;f[v+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=o;OJ(s,g,f[s>>2]&4095,r,0.0);f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=o;f[h>>2]=-1056833530;f[h+4>>2]=q;f[h+8>>2]=1;f[h+12>>2]=4;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;VD(g,h,i,UM()|0,-1);t=38;break}}else{r=+p[q>>3];w=+p[b+200>>3];if(r==0.0&w==0.0?+p[b+208>>3]==0.0:0){if(w==0.0?+p[b+216>>3]!=0.0:0)t=9}else t=8;if((t|0)==8?w==0.0:0)t=9;if(((t|0)==9?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;w=+p[b+176>>3];f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;x=+p[b+184>>3];s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;jF(g,w,h,x,r,i,-1);t=38;break}r=+p[b+176>>3];x=+p[b+184>>3];s=x==1.0;do if(r==1.0){if(s){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;VD(g,h,i,UM()|0,-1);break}if(x==-1.0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;jE(g,h,i,UM()|0,-1);break}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=n;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+8;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;VX(g,x,h,i);break}}else{if(!s){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;jF(g,r,h,x,0.0,i,-1);break}if(r==-1.0){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=n;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+8;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;jE(g,h,i,UM()|0,-1);break}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=n;v=i+8|0;f[v>>2]=0;f[v+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;VX(g,r,h,i);break}}while(0);if((+p[b+200>>3]==0.0?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0){t=38;break}f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=o;f[h>>2]=-1056833530;f[h+4>>2]=q;f[h+8>>2]=1;f[h+12>>2]=4;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;VD(g,h,i,UM()|0,-1);t=38}while(0);if((t|0)==38?(f[o+16>>2]|0)!=(f[c+16>>2]|0):0){t=g+8|0;f[t>>2]=0;f[t+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;OJ(o,g,f[c>>2]&4095,1.0,0.0)}c=e+36|0;g=f[c>>2]|0;if(g|0?(o=g+12|0,g=f[o>>2]|0,f[o>>2]=g+-1,(g|0)==1):0)kL(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[j>>2]|0)>0){c=f[l>>2]|0;l=0;do{f[c+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=a;return}UC(j);u=a;return}function QR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;a=u;u=u+16|0;e=a;dQ(e,46160);uR(d,b)|0;b=d+192|0;p[b>>3]=+p[c>>3]+ +p[b>>3];b=d+200|0;p[b>>3]=+p[c+8>>3]+ +p[b>>3];b=d+208|0;p[b>>3]=+p[c+16>>3]+ +p[b>>3];b=d+216|0;p[b>>3]=+p[c+24>>3]+ +p[b>>3];if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function RR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0,j=0.0,k=0,l=0.0;a=u;u=u+16|0;e=a;dQ(e,46140);uR(d,c)|0;c=d+176|0;p[c>>3]=-+p[c>>3];c=d+184|0;p[c>>3]=-+p[c>>3];c=d+192|0;g=d+200|0;h=+p[b+8>>3]-+p[g>>3];i=d+208|0;j=+p[b+16>>3]-+p[i>>3];k=d+216|0;l=+p[b+24>>3]-+p[k>>3];p[c>>3]=+p[b>>3]-+p[c>>3];p[g>>3]=h;p[i>>3]=j;p[k>>3]=l;if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function SR(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0;a=u;u=u+16|0;e=a;dQ(e,46120);uR(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;b=d+184|0;p[b>>3]=+p[b>>3]*c;b=d+192|0;p[b>>3]=+p[b>>3]*c;b=d+200|0;p[b>>3]=+p[b>>3]*c;b=d+208|0;p[b>>3]=+p[b>>3]*c;b=d+216|0;p[b>>3]=+p[b>>3]*c;if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function TR(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;a=u;u=u+64|0;e=a+56|0;g=a;dQ(e,46100);do if((f[c>>2]|0)==45580){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){h=17;break}if(((+p[c+192>>3]==0.0?+p[c+200>>3]==0.0:0)?+p[c+208>>3]==0.0:0)?+p[c+216>>3]==0.0:0){f[g>>2]=1124007936;i=g+4|0;j=g+8|0;k=g+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;l=g+48|0;m=g+44|0;f[m>>2]=l;f[l>>2]=0;f[g+52>>2]=0;YR(d,47,c+8|0,g,b/+p[c+176>>3]);n=g+36|0;o=f[n>>2]|0;if(o|0?(q=o+12|0,o=f[q>>2]|0,f[q>>2]=o+-1,(o|0)==1):0)kL(g);f[n>>2]=0;n=g+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[i>>2]|0)>0){n=f[k>>2]|0;o=0;do{f[n+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[i>>2]|0))}i=f[m>>2]|0;if((i|0)!=(l|0))UC(i)}else h=17}else h=17;while(0);if((h|0)==17)lR(0,b,c,d);if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function UR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0;a=u;u=u+48|0;d=a+32|0;e=a;dQ(d,45920);g=b+64|0;h=(f[b+80>>2]|0)==0;if(!h?!(+p[b+184>>3]==0.0):0)i=6;else i=3;do if((i|0)==3){j=+p[b+176>>3];if(!(+L(+j)==1.0))if(h){i=8;break}else{i=6;break}else{k=-(+p[b+200>>3]*j);l=-(+p[b+208>>3]*j);m=-(+p[b+216>>3]*j);p[e>>3]=-(+p[b+192>>3]*j);p[e+8>>3]=k;p[e+16>>3]=l;p[e+24>>3]=m;XR(c,97,b+8|0,e);break}}while(0);if((i|0)==6){m=+p[b+176>>3];l=+p[b+184>>3];if(m+l==0.0&m*l==-1.0)YR(c,97,b+8|0,g,1.0);else i=8}if((i|0)==8)mR(0,b,c);if(!(f[d+4>>2]|0)){u=a;return}u=a;return}function VR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=u;u=u+16|0;d=a;dQ(d,45900);do if((f[b>>2]|0)==45580){if(f[b+80>>2]|0?!(+p[b+184>>3]==0.0):0){e=9;break}if(((+p[b+192>>3]==0.0?+p[b+200>>3]==0.0:0)?+p[b+208>>3]==0.0:0)?+p[b+216>>3]==0.0:0)WR(c,b+8|0,+p[b+176>>3]);else e=9}else e=9;while(0);if((e|0)==9)nR(0,b,c);if(!(f[d+4>>2]|0)){u=a;return}u=a;return}function WR(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+368|0;e=d+32|0;g=d+312|0;h=d+256|0;i=d;f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=g+48|0;o=g+44|0;f[o>>2]=k;f[k>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[r>>2]=q;q=h+48|0;m=h+44|0;f[m>>2]=q;f[q>>2]=0;f[h+52>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;tR(e,45576,0,b,g,h,c,0.0,i);uR(a,e)|0;Wi(e);e=h+36|0;a=f[e>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)kL(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[p>>2]|0)>0){e=f[r>>2]|0;r=0;do{f[e+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[m>>2]|0;if((p|0)!=(q|0))UC(p);p=g+36|0;q=f[p>>2]|0;if(q|0?(m=q+12|0,q=f[m>>2]|0,f[m>>2]=q+-1,(q|0)==1):0)kL(g);f[p>>2]=0;p=g+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[j>>2]|0)>0){p=f[l>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=d;return}UC(j);u=d;return}function XR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+336|0;g=e;h=e+280|0;i=e+224|0;f[h>>2]=1124007936;j=h+4|0;k=h+8|0;l=h+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=h+48|0;o=h+44|0;f[o>>2]=k;f[k>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;p=i+4|0;q=i+8|0;r=i+40|0;m=p;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[r>>2]=q;q=i+48|0;m=i+44|0;f[m>>2]=q;f[q>>2]=0;f[i+52>>2]=0;tR(g,45940,b<<24>>24,c,h,i,1.0,0.0,d);uR(a,g)|0;Wi(g);g=i+36|0;a=f[g>>2]|0;if(a|0?(d=a+12|0,a=f[d>>2]|0,f[d>>2]=a+-1,(a|0)==1):0)kL(i);f[g>>2]=0;g=i+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[p>>2]|0)>0){g=f[r>>2]|0;r=0;do{f[g+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[m>>2]|0;if((p|0)!=(q|0))UC(p);p=h+36|0;q=f[p>>2]|0;if(q|0?(m=q+12|0,q=f[m>>2]|0,f[m>>2]=q+-1,(q|0)==1):0)kL(h);f[p>>2]=0;p=h+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[j>>2]|0)>0){p=f[l>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[o>>2]|0;if((j|0)==(k|0)){u=e;return}UC(j);u=e;return}function YR(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+320|0;h=g+32|0;i=g+256|0;j=g;f[i>>2]=1124007936;k=i+4|0;l=i+8|0;m=i+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=i+48|0;n=i+44|0;f[n>>2]=l;f[l>>2]=0;f[i+52>>2]=0;o=f[d+16>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;tR(h,45940,b<<24>>24,c,d,i,e,+((o|0)!=0&1),j);uR(a,h)|0;Wi(h);h=i+36|0;a=f[h>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)kL(i);f[h>>2]=0;h=i+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[k>>2]|0)>0){h=f[m>>2]|0;m=0;do{f[h+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[n>>2]|0;if((k|0)==(l|0)){u=g;return}UC(k);u=g;return}function ZR(a){a=a|0;O5b(a);return}function _R(a,b){a=a|0;b=b|0;return 1}function $R(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0;a=u;u=u+112|0;g=a+48|0;h=a+32|0;i=a+16|0;j=a;f[g>>2]=1124007936;k=g+4|0;l=g+8|0;m=g+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=g+48|0;q=g+44|0;f[q>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if((e|0)!=-1?(f[c+8>>2]&4095|0)!=(e|0):0)r=g;else r=d;a:do switch(f[c+4>>2]|0){case 42:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;NE(h,i,j,+p[c+176>>3],-1);break}case 47:{if(!(f[c+80>>2]|0)){t=+p[c+176>>3];f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=r;bF(t,h,i,-1);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;VE(h,i,j,+p[c+176>>3],-1);break a}break}case 38:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;dD(h,i,j,UM()|0);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;dD(h,i,j,UM()|0);break a}break}case 124:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;hD(h,i,j,UM()|0);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;hD(h,i,j,UM()|0);break a}break}case 94:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;kD(h,i,j,UM()|0);break a}else{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;kD(h,i,j,UM()|0);break a}break}case 126:{if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;s=i+8|0;f[s>>2]=0;f[s+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=r;nD(h,i,UM()|0)}else v=28;break}case 109:{UD(c+8|0,c+64|0,r);break}case 110:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=1;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;ED(h,i,j);break}case 77:{TD(c+8|0,c+64|0,r);break}case 78:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=1;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;pD(h,i,j);break}case 97:{if(f[c+80>>2]|0){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=c+64;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;yE(h,i,j);break a}if(!(f[c+80>>2]|0)){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c+8;f[i>>2]=-1056833530;f[i+4>>2]=c+192;f[i+8>>2]=1;f[i+12>>2]=4;s=j+8|0;f[s>>2]=0;f[s+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=r;yE(h,i,j)}else v=28;break}default:v=28}while(0);if((v|0)==28){f[h>>2]=0;f[h+4>>2]=0;n=aD(h,17)|0;v=197638;o=n+17|0;do{b[n>>0]=b[v>>0]|0;n=n+1|0;v=v+1|0}while((n|0)<(o|0));bO(-2,h,196951,196805,1408);bD(h)}if((f[r+16>>2]|0)!=(f[d+16>>2]|0)){v=h+8|0;f[v>>2]=0;f[v+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=d;OJ(r,h,e,1.0,0.0)}e=g+36|0;h=f[e>>2]|0;if(h|0?(r=h+12|0,h=f[r>>2]|0,f[r>>2]=h+-1,(h|0)==1):0)kL(g);f[e>>2]=0;e=g+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[k>>2]|0)>0){e=f[m>>2]|0;m=0;do{f[e+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[q>>2]|0;if((k|0)==(l|0)){u=a;return}UC(k);u=a;return}function aS(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0,g=0;a=u;u=u+16|0;e=a;dQ(e,46080);switch(f[b+4>>2]|0){case 47:case 42:{uR(d,b)|0;g=d+176|0;p[g>>3]=+p[g>>3]*c;break}default:jR(0,b,c,d)}if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function bS(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0;a=u;u=u+96|0;e=a+88|0;g=a+32|0;h=a;dQ(e,46060);do if((f[c+4>>2]|0)==47){if(f[c+80>>2]|0?!(+p[c+184>>3]==0.0):0){i=13;break}j=c+8|0;f[g>>2]=1124007936;k=g+4|0;l=g+8|0;m=g+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;n=g+48|0;o=g+44|0;f[o>>2]=n;f[n>>2]=0;f[g+52>>2]=0;q=+p[c+176>>3];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;cS(d,j,g,b/q,0.0,h);r=g+36|0;s=f[r>>2]|0;if(s|0?(t=s+12|0,s=f[t>>2]|0,f[t>>2]=s+-1,(s|0)==1):0)kL(g);f[r>>2]=0;r=g+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;s=0;do{f[r+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[k>>2]|0))}k=f[o>>2]|0;if((k|0)!=(n|0))UC(k)}else i=13;while(0);if((i|0)==13)lR(0,b,c,d);if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function cS(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+288|0;i=h;j=h+224|0;f[j>>2]=1124007936;k=j+4|0;l=j+8|0;m=j+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=j+48|0;n=j+44|0;f[n>>2]=l;f[l>>2]=0;f[j+52>>2]=0;tR(i,45580,0,b,c,j,d,e,g);uR(a,i)|0;Wi(i);i=j+36|0;a=f[i>>2]|0;if(a|0?(g=a+12|0,a=f[g>>2]|0,f[g>>2]=a+-1,(a|0)==1):0)kL(j);f[i>>2]=0;i=j+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[k>>2]|0)>0){i=f[m>>2]|0;m=0;do{f[i+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[n>>2]|0;if((k|0)==(l|0)){u=h;return}UC(k);u=h;return}function dS(a){a=a|0;O5b(a);return}function eS(a,b){a=a|0;b=b|0;return 0}function fS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0;a=u;u=u+96|0;e=a+32|0;g=a+16|0;h=a;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;l=e+44|0;f[l>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if((d|0)!=-1?(f[b+8>>2]&4095|0)!=(d|0):0)n=e;else n=c;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;m=h+8|0;f[m>>2]=0;f[m+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=n;ZL(g,h);o=+p[b+176>>3];if(o!=1.0?1:(f[n+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;OJ(n,g,d,o,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(n=g+12|0,g=f[n>>2]|0,f[n>>2]=g+-1,(g|0)==1):0)kL(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[i>>2]|0)>0){d=f[k>>2]|0;k=0;do{f[d+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[l>>2]|0;if((i|0)==(j|0)){u=a;return}UC(i);u=a;return}function gS(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0;a=u;u=u+16|0;e=a;dQ(e,46316);uR(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function hS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+96|0;d=a+88|0;e=a+32|0;g=a;dQ(d,46296);h=+p[b+176>>3];i=b+8|0;if(!(h==1.0)){f[e>>2]=1124007936;b=e+4|0;j=e+8|0;k=e+40|0;l=b;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;l=e+44|0;f[l>>2]=j;f[j>>2]=0;f[e+52>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;cS(c,i,e,h,0.0,g);g=e+36|0;m=f[g>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)kL(e);f[g>>2]=0;g=e+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[b>>2]|0)>0){g=f[k>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[b>>2]|0))}b=f[l>>2]|0;if((b|0)!=(j|0))UC(b)}else iS(c,i);if(!(f[d+4>>2]|0)){u=a;return}u=a;return}function iS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+368|0;d=c+32|0;e=c+312|0;g=c+256|0;h=c;f[e>>2]=1124007936;i=e+4|0;j=e+8|0;k=e+40|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=e+48|0;n=e+44|0;f[n>>2]=j;f[j>>2]=0;f[e+52>>2]=0;f[g>>2]=1124007936;o=g+4|0;p=g+8|0;q=g+40|0;l=o;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[q>>2]=p;p=g+48|0;l=g+44|0;f[l>>2]=p;f[p>>2]=0;f[g+52>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;tR(d,45336,0,b,e,g,1.0,0.0,h);uR(a,d)|0;Wi(d);d=g+36|0;a=f[d>>2]|0;if(a|0?(h=a+12|0,a=f[h>>2]|0,f[h>>2]=a+-1,(a|0)==1):0)kL(g);f[d>>2]=0;d=g+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[o>>2]|0)>0){d=f[q>>2]|0;q=0;do{f[d+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[o>>2]|0))}o=f[l>>2]|0;if((o|0)!=(p|0))UC(o);o=e+36|0;p=f[o>>2]|0;if(p|0?(l=p+12|0,p=f[l>>2]|0,f[l>>2]=p+-1,(p|0)==1):0)kL(e);f[o>>2]=0;o=e+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[i>>2]|0)>0){o=f[k>>2]|0;k=0;do{f[o+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[i>>2]|0))}i=f[n>>2]|0;if((i|0)==(j|0)){u=c;return}UC(i);u=c;return}function jS(a){a=a|0;O5b(a);return}function kS(a,b){a=a|0;b=b|0;return 1}function lS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+112|0;e=a+48|0;g=a+32|0;h=a+16|0;i=a;f[e>>2]=1124007936;j=e+4|0;k=e+8|0;l=e+40|0;m=j;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;n=(d|0)==-1|(d|0)==0?c:e;if(!(f[b+80>>2]|0)){f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h>>2]=-1056833530;f[h+4>>2]=b+176;f[h+8>>2]=1;f[h+12>>2]=1;o=i+8|0;f[o>>2]=0;f[o+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=n;rF(g,h,i,f[b+4>>2]|0)}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=b+8;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=b+64;o=i+8|0;f[o>>2]=0;f[o+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=n;rF(g,h,i,f[b+4>>2]|0)}if((f[n+16>>2]|0)!=(f[c+16>>2]|0)){b=g+8|0;f[b>>2]=0;f[b+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;OJ(n,g,d,1.0,0.0)}d=e+36|0;g=f[d>>2]|0;if(g|0?(n=g+12|0,g=f[n>>2]|0,f[n>>2]=g+-1,(g|0)==1):0)kL(e);f[d>>2]=0;d=e+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[l>>2]|0;l=0;do{f[d+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)==(k|0)){u=a;return}UC(j);u=a;return}function mS(a){a=a|0;O5b(a);return}function nS(a,b){a=a|0;b=b|0;return 0}function oS(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+64|0;g=a+32|0;h=a;i=(e|0)==-1?f[c+8>>2]&4095:e;e=c+12|0;j=f[e>>2]|0;k=f[c+48>>2]|0;do if((j|0)<3){l=f[k+4>>2]|0;m=f[k>>2]|0;n=i&4095;if(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(m|0):0)?(f[d+12>>2]|0)==(l|0):0)?(f[d>>2]&4095|0)==(n|0):0)?f[d+16>>2]|0:0)break;f[g>>2]=m;f[g+4>>2]=l;hL(d,2,g,n)}else hL(d,j,k,i);while(0);i=f[c+4>>2]|0;if((i|0)==73&(f[e>>2]|0)<3){e=g+8|0;f[e>>2]=0;f[e+4>>2]=0;f[g>>2]=50397184;f[g+4>>2]=d;p[h>>3]=+p[c+176>>3];e=h+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;ZM(g,h);u=a;return}switch(i|0){case 48:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;UP(d,g)|0;u=a;return}case 49:{p[g>>3]=+p[c+176>>3];c=g+8|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;UP(d,g)|0;u=a;return}default:{f[g>>2]=0;f[g+4>>2]=0;d=aD(g,31)|0;c=199312;i=d+31|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(i|0));bO(-2,g,196951,196805,1643);bD(g);u=a;return}}}function pS(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0;a=u;u=u+16|0;e=a;dQ(e,46768);uR(d,b)|0;b=d+176|0;p[b>>3]=+p[b>>3]*c;if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function qS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=45336;f[a+4>>2]=0;c=a+8|0;f[c>>2]=f[b>>2];d=a+12|0;e=b+4|0;f[d>>2]=f[e>>2];g=a+16|0;f[g>>2]=f[b+8>>2];f[a+20>>2]=f[b+12>>2];f[a+24>>2]=f[b+16>>2];f[a+28>>2]=f[b+20>>2];f[a+32>>2]=f[b+24>>2];f[a+36>>2]=f[b+28>>2];f[a+40>>2]=f[b+32>>2];h=f[b+36>>2]|0;f[a+44>>2]=h;f[a+48>>2]=g;g=a+56|0;i=a+52|0;f[i>>2]=g;f[g>>2]=0;f[a+60>>2]=0;if(h|0){g=h+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[e>>2]|0)<3){e=f[b+44>>2]|0;g=f[i>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2]}else{f[d>>2]=0;jL(c,b)}f[a+64>>2]=1124007936;b=a+72|0;c=a+104|0;d=a+68|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+112|0;f[a+108>>2]=b;f[b>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;b=a+128|0;c=a+160|0;d=a+124|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+168|0;f[a+164>>2]=b;f[b>>2]=0;f[a+172>>2]=0;p[a+176>>3]=1.0;d=a+184|0;e=d+40|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));return}function rS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;th[f[(f[g>>2]|0)+96>>2]&511](g,b,c,a);return}function sS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+32|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;cS(a,b,c,1.0,1.0,e);u=d;return}function tS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=1124007936;g=e+4|0;h=e+8|0;k=e+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=e+48|0;i=e+44|0;f[i>>2]=h;f[h>>2]=0;f[e+52>>2]=0;cS(a,c,e,1.0,0.0,b);b=e+36|0;c=f[b>>2]|0;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)kL(e);f[b>>2]=0;b=e+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[g>>2]|0)>0){b=f[k>>2]|0;k=0;do{f[b+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=d;return}UC(g);u=d;return}function uS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;th[f[(f[g>>2]|0)+56>>2]&511](g,b,c,a);return}function vS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;th[f[(f[g>>2]|0)+52>>2]&511](g,b,c,a);return}function wS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+32|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;cS(a,b,c,1.0,-1.0,e);u=d;return}function xS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+224|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));i=f[b>>2]|0;j=f[(f[i>>2]|0)+60>>2]|0;qS(e,c);th[j&511](i,b,e,a);Wi(e);u=d;return}function yS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0.0,l=0.0,m=0.0;d=u;u=u+32|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));i=f[b>>2]|0;j=f[(f[i>>2]|0)+56>>2]|0;k=-+p[c+8>>3];l=-+p[c+16>>3];m=-+p[c+24>>3];p[e>>3]=-+p[c>>3];p[e+8>>3]=k;p[e+16>>3]=l;p[e+24>>3]=m;th[j&511](i,b,e,a);u=d;return}function zS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;th[f[(f[g>>2]|0)+60>>2]&511](g,b,c,a);return}function AS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+96|0;d=c+32|0;e=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[d>>2]=1124007936;g=d+4|0;h=d+8|0;k=d+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=d+48|0;i=d+44|0;f[i>>2]=h;f[h>>2]=0;f[d+52>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;cS(a,b,d,-1.0,0.0,e);e=d+36|0;b=f[e>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)kL(d);f[e>>2]=0;e=d+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){e=f[k>>2]|0;k=0;do{f[e+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=c;return}UC(g);u=c;return}function BS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;e=a+16|0;g=a+48|0;h=a+12|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+56|0;f[a+52>>2]=e;f[e>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;e=a+72|0;g=a+104|0;h=a+68|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+112|0;f[a+108>>2]=e;f[e>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;e=a+128|0;g=a+160|0;h=a+124|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+168|0;f[a+164>>2]=e;h=e;i=h+56|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));h=f[b>>2]|0;i=f[(f[h>>2]|0)+64>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;th[i&511](h,d,b,a);u=c;return}function CS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+320|0;e=d+32|0;g=d;h=d+256|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;i=a+16|0;j=a+48|0;k=a+12|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+56|0;f[a+52>>2]=i;f[i>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;i=a+72|0;j=a+104|0;k=a+68|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+112|0;f[a+108>>2]=i;f[i>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;i=a+128|0;j=a+160|0;k=a+124|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+168|0;f[a+164>>2]=i;k=i;l=k+56|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[h>>2]=1124007936;i=h+4|0;j=h+8|0;m=h+40|0;k=i;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[m>>2]=j;j=h+48|0;k=h+44|0;f[k>>2]=j;f[j>>2]=0;f[h+52>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;tR(e,45584,0,b,c,h,1.0,1.0,g);uR(a,e)|0;Wi(e);e=h+36|0;a=f[e>>2]|0;if(a|0?(g=a+12|0,a=f[g>>2]|0,f[g>>2]=a+-1,(a|0)==1):0)kL(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[i>>2]|0)>0){e=f[m>>2]|0;m=0;do{f[e+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[i>>2]|0))}i=f[k>>2]|0;if((i|0)==(j|0)){u=d;return}UC(i);u=d;return}function DS(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+96|0;e=d+32|0;g=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[e>>2]=1124007936;h=e+4|0;i=e+8|0;l=e+40|0;j=h;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[l>>2]=i;i=e+48|0;j=e+44|0;f[j>>2]=i;f[i>>2]=0;f[e+52>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;cS(a,b,e,c,0.0,g);g=e+36|0;b=f[g>>2]|0;if(b|0?(a=b+12|0,b=f[a>>2]|0,f[a>>2]=b+-1,(b|0)==1):0)kL(e);f[g>>2]=0;g=e+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){g=f[l>>2]|0;l=0;do{f[g+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[j>>2]|0;if((h|0)==(i|0)){u=d;return}UC(h);u=d;return}function ES(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+96|0;e=d+32|0;g=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[e>>2]=1124007936;h=e+4|0;i=e+8|0;l=e+40|0;j=h;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[l>>2]=i;i=e+48|0;j=e+44|0;f[j>>2]=i;f[i>>2]=0;f[e+52>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;cS(a,c,e,b,0.0,g);g=e+36|0;c=f[g>>2]|0;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)kL(e);f[g>>2]=0;g=e+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){g=f[l>>2]|0;l=0;do{f[g+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[h>>2]|0))}h=f[j>>2]|0;if((h|0)==(i|0)){u=d;return}UC(h);u=d;return}function FS(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f[b>>2]|0;Dh[f[(f[g>>2]|0)+72>>2]&15](g,b,c,a);return}function GS(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=1124007936;g=e+4|0;h=e+8|0;k=e+40|0;i=g;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[k>>2]=h;h=e+48|0;i=e+44|0;f[i>>2]=h;f[h>>2]=0;f[e+52>>2]=0;YR(a,47,c,e,b);c=e+36|0;a=f[c>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)kL(e);f[c>>2]=0;c=e+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[g>>2]|0)>0){c=f[k>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[g>>2]|0))}g=f[i>>2]|0;if((g|0)==(h|0)){u=d;return}UC(g);u=d;return}function HS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+368|0;g=e+32|0;h=e+312|0;i=e+256|0;j=e;f[h>>2]=1124007936;k=h+4|0;l=h+8|0;m=h+40|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=h+48|0;p=h+44|0;f[p>>2]=l;f[l>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;q=i+4|0;r=i+8|0;s=i+40|0;n=q;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[s>>2]=r;r=i+48|0;n=i+44|0;f[n>>2]=r;f[r>>2]=0;f[i+52>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;tR(g,46788,b,c,h,i,d,1.0,j);uR(a,g)|0;Wi(g);g=i+36|0;a=f[g>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)kL(i);f[g>>2]=0;g=i+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[q>>2]|0)>0){g=f[s>>2]|0;s=0;do{f[g+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[q>>2]|0))}q=f[n>>2]|0;if((q|0)!=(r|0))UC(q);q=h+36|0;r=f[q>>2]|0;if(r|0?(n=r+12|0,r=f[n>>2]|0,f[n>>2]=r+-1,(r|0)==1):0)kL(h);f[q>>2]=0;q=h+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[k>>2]|0)>0){q=f[m>>2]|0;m=0;do{f[q+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[p>>2]|0;if((k|0)==(l|0)){u=e;return}UC(k);u=e;return}function IS(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));HS(a,0,b,c);return}function JS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;d=a+16|0;e=a+48|0;g=a+12|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+56|0;f[a+52>>2]=d;f[d>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;d=a+72|0;e=a+104|0;g=a+68|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+112|0;f[a+108>>2]=d;f[d>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;d=a+128|0;e=a+160|0;g=a+124|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=a+168|0;f[a+164>>2]=d;g=d;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));YR(a,38,b,c,1.0);return}function KS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+48|0;d=c+32|0;e=c;dQ(d,46792);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;XR(a,97,b,e);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function LS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[b>>2]|0;if((c|0)==45576|(c|0)==45216){d=f[b+20>>2]|0;f[a>>2]=f[b+16>>2];f[a+4>>2]=d;return}if((c|0)==45584){d=f[b+16>>2]|0;f[a>>2]=f[b+76>>2];f[a+4>>2]=d;return}if((c|0)==45340){d=f[b+20>>2]|0;f[a>>2]=f[b+76>>2];f[a+4>>2]=d;return}if(!(f[125797]|0)){d=jO()|0;PO(d);if(!(f[125797]|0)){e=L5b(4)|0;f[e>>2]=46660;f[125797]=e}QO(d)}if((f[125797]|0)==(c|0)){c=f[b+48>>2]|0;d=f[c>>2]|0;f[a>>2]=f[c+4>>2];f[a+4>>2]=d;return}d=f[b>>2]|0;if(!d){f[a>>2]=0;f[a+4>>2]=0;return}else{_h[f[(f[d>>2]|0)+100>>2]&255](a,d,b);return}}function MS(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+16|0;c=b;dQ(c,46812);d=f[a>>2]|0;if(!(f[125797]|0)){e=jO()|0;PO(e);if(!(f[125797]|0)){g=L5b(4)|0;f[g>>2]=46660;f[125797]=g}QO(e)}if((f[125797]|0)!=(d|0)){d=f[a>>2]|0;if((d|0)!=46788)if(!d)h=-1;else h=Uh[f[(f[d>>2]|0)+104>>2]&1023](d,a)|0;else h=0}else h=f[a+8>>2]&4095;if(!(f[c+4>>2]|0)){u=b;return h|0}u=b;return h|0}function NS(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;dQ(d,46832);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;e=a+16|0;g=a+48|0;h=a+12|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+56|0;f[a+52>>2]=e;f[e>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;e=a+72|0;g=a+104|0;h=a+68|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+112|0;f[a+108>>2]=e;f[e>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;e=a+128|0;g=a+160|0;h=a+124|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=a+168|0;f[a+164>>2]=e;h=e;i=h+56|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));WR(a,b,1.0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function OS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;dQ(e,46852);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;g=a+16|0;h=a+48|0;i=a+12|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+56|0;f[a+52>>2]=g;f[g>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;g=a+72|0;h=a+104|0;i=a+68|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+112|0;f[a+108>>2]=g;f[g>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;g=a+128|0;h=a+160|0;i=a+124|0;j=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));f[h>>2]=g;g=a+168|0;f[a+164>>2]=g;i=g;j=i+56|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(j|0));sR(a,c,b);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function PS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+240|0;g=e+224|0;h=e;dQ(g,46872);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;i=a+16|0;j=a+48|0;k=a+12|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+56|0;f[a+52>>2]=i;f[i>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;i=a+72|0;j=a+104|0;k=a+68|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+112|0;f[a+108>>2]=i;f[i>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;i=a+128|0;j=a+160|0;k=a+124|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+168|0;f[a+164>>2]=i;k=i;l=k+56|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));if((yM(c)|0)!=393216){do if((yM(c)|0)==65536){k=f[c+4>>2]|0;f[h>>2]=f[k>>2];l=h+4|0;i=k+4|0;f[l>>2]=f[i>>2];j=h+8|0;f[j>>2]=f[k+8>>2];f[h+12>>2]=f[k+12>>2];f[h+16>>2]=f[k+16>>2];f[h+20>>2]=f[k+20>>2];f[h+24>>2]=f[k+24>>2];f[h+28>>2]=f[k+28>>2];f[h+32>>2]=f[k+32>>2];m=f[k+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=j;j=h+48|0;n=h+44|0;f[n>>2]=j;f[j>>2]=0;f[h+52>>2]=0;if(m|0){j=m+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[k+44>>2]|0;j=f[n>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];break}else{f[l>>2]=0;jL(h,k);break}}else yL(h,c,-1);while(0);YR(a,42,b,h,d);k=h+36|0;l=f[k>>2]|0;if(l|0?(i=l+12|0,l=f[i>>2]|0,f[i>>2]=l+-1,(l|0)==1):0)kL(h);f[k>>2]=0;k=h+16|0;l=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[l>>2]|0)>0){k=f[h+40>>2]|0;i=0;do{f[k+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[l>>2]|0))}l=f[h+44>>2]|0;if((l|0)!=(h+48|0))UC(l)}else{l=f[c+4>>2]|0;c=f[l>>2]|0;i=f[(f[c>>2]|0)+68>>2]|0;qS(h,b);Ah[i&15](c,h,l,a,d);Wi(h)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function QS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(g,46892);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;i=a+16|0;j=a+48|0;k=a+12|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+56|0;f[a+52>>2]=i;f[i>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;i=a+72|0;j=a+104|0;k=a+68|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+112|0;f[a+108>>2]=i;f[i>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;i=a+128|0;j=a+160|0;k=a+124|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+168|0;f[a+164>>2]=i;k=i;l=k+56|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[h>>2]=c;f[h+4>>2]=b;RS(a,48,h,d,1.0);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function RS(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+432|0;h=g+32|0;i=g+376|0;j=g+312|0;k=g+320|0;l=g+256|0;m=g;if(!(f[125797]|0)){n=jO()|0;PO(n);if(!(f[125797]|0)){o=L5b(4)|0;f[o>>2]=46660;f[125797]=o}QO(n)}n=f[125797]|0;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];JF(i,j,d,-286331154,0);f[k>>2]=1124007936;d=k+4|0;j=k+8|0;c=k+40|0;o=d;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[c>>2]=j;j=k+48|0;q=k+44|0;f[q>>2]=j;f[j>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;r=l+4|0;s=l+8|0;t=l+40|0;o=r;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[t>>2]=s;s=l+48|0;o=l+44|0;f[o>>2]=s;f[s>>2]=0;f[l+52>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;tR(h,n,b,i,k,l,e,0.0,m);uR(a,h)|0;Wi(h);h=l+36|0;a=f[h>>2]|0;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)kL(l);f[h>>2]=0;h=l+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[r>>2]|0)>0){h=f[t>>2]|0;t=0;do{f[h+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[o>>2]|0;if((r|0)!=(s|0))UC(r);r=k+36|0;s=f[r>>2]|0;if(s|0?(o=s+12|0,s=f[o>>2]|0,f[o>>2]=s+-1,(s|0)==1):0)kL(k);f[r>>2]=0;r=k+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[d>>2]|0)>0){r=f[c>>2]|0;c=0;do{f[r+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[q>>2]|0;if((d|0)!=(j|0))UC(d);d=i+36|0;j=f[d>>2]|0;if(j|0?(q=j+12|0,j=f[q>>2]|0,f[q>>2]=j+-1,(j|0)==1):0)kL(i);f[d>>2]=0;d=i+16|0;j=i+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[j>>2]|0)>0){d=f[i+40>>2]|0;q=0;do{f[d+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=g;return}UC(j);u=g;return}function SS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+8|0;g=d;dQ(e,46912);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];RS(a,48,g,c,1.0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function TS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(g,46932);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;i=a+16|0;j=a+48|0;k=a+12|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+56|0;f[a+52>>2]=i;f[i>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;i=a+72|0;j=a+104|0;k=a+68|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+112|0;f[a+108>>2]=i;f[i>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;i=a+128|0;j=a+160|0;k=a+124|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+168|0;f[a+164>>2]=i;k=i;l=k+56|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[h>>2]=c;f[h+4>>2]=b;RS(a,49,h,d,1.0);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function US(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+8|0;g=d;dQ(e,46952);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];RS(a,49,g,c,1.0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function VS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(g,46972);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;i=a+16|0;j=a+48|0;k=a+12|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+56|0;f[a+52>>2]=i;f[i>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;i=a+72|0;j=a+104|0;k=a+68|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+112|0;f[a+108>>2]=i;f[i>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;i=a+128|0;j=a+160|0;k=a+124|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+168|0;f[a+164>>2]=i;k=i;l=k+56|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[h>>2]=c;f[h+4>>2]=b;RS(a,73,h,d,1.0);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function WS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+8|0;g=d;dQ(e,46992);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=1124007936;h=a+16|0;i=a+48|0;j=a+12|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+56|0;f[a+52>>2]=h;f[h>>2]=0;f[a+60>>2]=0;f[a+64>>2]=1124007936;h=a+72|0;i=a+104|0;j=a+68|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+112|0;f[a+108>>2]=h;f[h>>2]=0;f[a+116>>2]=0;f[a+120>>2]=1124007936;h=a+128|0;i=a+160|0;j=a+124|0;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;h=a+168|0;f[a+164>>2]=h;j=h;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[g>>2]=f[b>>2];f[g+4>>2]=f[b+4>>2];RS(a,73,g,c,1.0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function XS(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;h=u;u=u+16|0;g=h;f[g>>2]=0;f[g+4>>2]=0;e=aD(g,46)|0;d=199830;c=e+46|0;do{b[e>>0]=b[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(c|0));bO(-218,g,199877,199890,60);bD(g);u=h;return}function YS(a){a=a|0;return}function ZS(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,K=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0.0,ya=0,za=0.0;l=u;u=u+1104|0;m=l;o=m+8|0;f[m>>2]=o;q=m+4|0;f[q>>2]=h;if(h>>>0>136){r=N5b(h>>>0>536870911?-1:h<<3)|0;f[m>>2]=r;s=r}else s=o;r=(g|0)>30?g:30;t=b>>>2;b=e>>>2;e=(h|0)>0;a:do if(e){v=(d|0)==0;w=h<<2;if((g|0)>0)x=0;else{y=0;while(1){z=Y(b,y)|0;p[s+(y<<3)>>3]=0.0;if(!v){Nac(d+(z<<2)|0,0,w|0)|0;n[d+(z+y<<2)>>2]=1.0}y=y+1|0;if((y|0)==(h|0))break a}}do{y=Y(b,x)|0;z=d+(y<<2)|0;A=Y(x,t)|0;B=0;C=0.0;do{D=+n[a+(B+A<<2)>>2];C=C+D*D;B=B+1|0}while((B|0)!=(g|0));p[s+(x<<3)>>3]=C;if(!v){Nac(z|0,0,w|0)|0;n[d+(y+x<<2)>>2]=1.0}x=x+1|0}while((x|0)!=(h|0))}while(0);b:do if((r|0)>0){x=h+-1|0;w=(h|0)>1;v=(g|0)>0;D=k;B=(d|0)==0;A=0;do{if(w){E=0;F=0}else break b;while(1){G=F;F=F+1|0;if((F|0)<(h|0)){H=a+((Y(G,t)|0)<<2)|0;I=s+(G<<3)|0;K=d+((Y(G,b)|0)<<2)|0;G=F;N=E;while(1){O=a+((Y(G,t)|0)<<2)|0;P=+p[I>>3];Q=s+(G<<3)|0;R=+p[Q>>3];if(v){S=0.0;T=0;while(1){U=S+ +n[H+(T<<2)>>2]*+n[O+(T<<2)>>2];T=T+1|0;if((T|0)==(g|0)){V=U;break}else S=U}}else V=0.0;if(!(+L(+V)<=D*+M(+(P*R)))){S=V*2.0;U=P-R;W=+L(+S);X=+L(+U);if(!(W>X))if(U!=U|0.0!=0.0|U==0.0)Z=0.0;else{_=W/X;$=X;aa=_*_;ba=32}else{_=X/W;$=W;aa=_*_;ba=32}if((ba|0)==32){ba=0;Z=$*+M(+(aa+1.0))}if(U<0.0){_=+M(+((Z-U)*.5/Z));ca=S/(Z*_*2.0);da=_}else{_=+M(+((U+Z)/(Z*2.0)));ca=_;da=S/(Z*_*2.0)}if(v){_=0.0;S=0.0;T=0;while(1){ea=H+(T<<2)|0;U=+n[ea>>2];fa=O+(T<<2)|0;W=+n[fa>>2];X=ca*U+da*W;ga=ca*W-da*U;n[ea>>2]=X;n[fa>>2]=ga;U=X;X=_+U*U;U=ga;ga=S+U*U;T=T+1|0;if((T|0)==(g|0)){ha=X;ia=ga;break}else{_=X;S=ga}}}else{ha=0.0;ia=0.0}p[I>>3]=ha;p[Q>>3]=ia;if(!B?(T=d+((Y(G,b)|0)<<2)|0,e):0){O=0;do{fa=K+(O<<2)|0;S=+n[fa>>2];ea=T+(O<<2)|0;_=+n[ea>>2];n[fa>>2]=ca*S+da*_;n[ea>>2]=ca*_-da*S;O=O+1|0}while((O|0)!=(h|0));ja=1}else ja=1}else ja=N;G=G+1|0;if((G|0)==(h|0)){ka=ja;break}else N=ja}}else ka=E;if((F|0)==(x|0))break;else E=ka}A=A+1|0}while(ka&(A|0)<(r|0))}while(0);if(e){if((g|0)>0){r=0;do{ka=Y(r,t)|0;da=0.0;E=0;do{ca=+n[a+(E+ka<<2)>>2];da=da+ca*ca;E=E+1|0}while((E|0)!=(g|0));ca=+M(+da);p[s+(r<<3)>>3]=ca;r=r+1|0}while((r|0)!=(h|0))}else Nac(s|0,0,h<<3|0)|0;r=h+-1|0;c:do if((h|0)>1){E=(g|0)>0;if(!d){ka=0;while(1){F=ka;ka=ka+1|0;if((ka|0)<(h|0)){ja=F;ba=ka;while(1){A=+p[s+(ja<<3)>>3]<+p[s+(ba<<3)>>3]?ba:ja;ba=ba+1|0;if((ba|0)==(h|0)){la=A;break}else ja=A}}else la=F;if((F|0)!=(la|0)){ja=s+(F<<3)|0;ba=s+(la<<3)|0;ca=+p[ja>>3];p[ja>>3]=+p[ba>>3];p[ba>>3]=ca}if((ka|0)==(r|0))break c}}else ma=0;do{ka=ma;ma=ma+1|0;if((ma|0)<(h|0)){ba=ka;ja=ma;while(1){A=+p[s+(ba<<3)>>3]<+p[s+(ja<<3)>>3]?ja:ba;ja=ja+1|0;if((ja|0)==(h|0)){na=A;break}else ba=A}}else na=ka;if((ka|0)!=(na|0)){ba=s+(ka<<3)|0;ja=s+(na<<3)|0;da=+p[ba>>3];p[ba>>3]=+p[ja>>3];p[ja>>3]=da;if(E){ja=Y(ka,t)|0;ba=Y(na,t)|0;F=0;do{A=a+(F+ja<<2)|0;x=a+(F+ba<<2)|0;B=f[A>>2]|0;f[A>>2]=f[x>>2];f[x>>2]=B;F=F+1|0}while((F|0)!=(g|0))}F=Y(ka,b)|0;ba=Y(na,b)|0;ja=0;do{B=d+(ja+F<<2)|0;x=d+(ja+ba<<2)|0;A=f[B>>2]|0;f[B>>2]=f[x>>2];f[x>>2]=A;ja=ja+1|0}while((ja|0)!=(h|0))}}while((ma|0)!=(r|0))}while(0);if(e){e=0;do{n[c+(e<<2)>>2]=+p[s+(e<<3)>>3];e=e+1|0}while((e|0)!=(h|0))}}if((d|0)!=0&(i|0)>0){d=(g|0)>0;da=1.0/+(g|0);ca=-da;ia=k*100.0;e=305419896;c=0;r=0;while(1){if((r|0)<(h|0))oa=+p[s+(r<<3)>>3];else oa=0.0;if(!(oa<=j)){pa=oa;qa=e;ra=c}else{ma=Y(r,t)|0;b=(r|0)>0;na=0;la=e;E=c;while(1){if(d){ja=0;ba=la;F=E;while(1){ka=cbc(ba|0,0,-130063606,0)|0;A=Kac(ka|0,J|0,F|0,0)|0;ka=J;n[a+(ja+ma<<2)>>2]=(A&256|0)!=0|0!=0?da:ca;ja=ja+1|0;if((ja|0)==(g|0)){sa=A;ta=ka;break}else{ba=A;F=ka}}}else{sa=la;ta=E}d:do if(b){if(d){F=0;do{ba=Y(F,t)|0;ja=0;k=0.0;do{k=k+ +n[a+(ja+ma<<2)>>2]*+n[a+(ja+ba<<2)>>2];ja=ja+1|0}while((ja|0)!=(g|0));ua=0.0;va=0;do{ja=a+(va+ma<<2)|0;ha=+n[ja>>2]-k*+n[a+(va+ba<<2)>>2];n[ja>>2]=ha;ua=ua+ +L(+ha);va=va+1|0}while((va|0)!=(g|0));k=ua>ia?1.0/ua:0.0;ba=0;do{ja=a+(ba+ma<<2)|0;n[ja>>2]=k*+n[ja>>2];ba=ba+1|0}while((ba|0)!=(g|0));F=F+1|0}while((F|0)!=(r|0))}else{F=0;do F=F+1|0;while((F|0)!=(r|0))}if(b){if(d)wa=0;else{F=0;while(1){F=F+1|0;if((F|0)==(r|0))break d}}do{F=Y(wa,t)|0;ba=0;k=0.0;do{k=k+ +n[a+(ba+ma<<2)>>2]*+n[a+(ba+F<<2)>>2];ba=ba+1|0}while((ba|0)!=(g|0));xa=0.0;ya=0;do{ba=a+(ya+ma<<2)|0;ha=+n[ba>>2]-k*+n[a+(ya+F<<2)>>2];n[ba>>2]=ha;xa=xa+ +L(+ha);ya=ya+1|0}while((ya|0)!=(g|0));k=xa>ia?1.0/xa:0.0;F=0;do{ba=a+(F+ma<<2)|0;n[ba>>2]=k*+n[ba>>2];F=F+1|0}while((F|0)!=(g|0));wa=wa+1|0}while((wa|0)!=(r|0))}}while(0);if(d){F=0;k=0.0;while(1){ha=+n[a+(F+ma<<2)>>2];Z=k+ha*ha;F=F+1|0;if((F|0)==(g|0)){za=Z;break}else k=Z}}else za=0.0;k=+M(+za);if(!(k<=j)|(na|0)>98){pa=k;qa=sa;ra=ta;break}else{na=na+1|0;la=sa;E=ta}}}k=pa>j?1.0/pa:0.0;if(d){E=Y(r,t)|0;la=0;do{na=a+(la+E<<2)|0;n[na>>2]=k*+n[na>>2];la=la+1|0}while((la|0)!=(g|0))}r=r+1|0;if((r|0)==(i|0))break;else{e=qa;c=ra}}}ra=f[m>>2]|0;if((ra|0)==(o|0)){u=l;return}if(ra|0)P5b(ra);f[m>>2]=o;f[q>>2]=136;u=l;return}function _S(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=+j;k=+k;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0;l=u;u=u+1104|0;m=l;n=m+8|0;f[m>>2]=n;o=m+4|0;f[o>>2]=h;if(h>>>0>136){q=N5b(h>>>0>536870911?-1:h<<3)|0;f[m>>2]=q;r=q}else r=n;q=(g|0)>30?g:30;s=b>>>3;b=e>>>3;e=(h|0)>0;a:do if(e){t=(d|0)==0;v=h<<3;if((g|0)<=0)if(t){Nac(r|0,0,v|0)|0;break}else{w=0;while(1){x=Y(b,w)|0;p[r+(w<<3)>>3]=0.0;Nac(d+(x<<3)|0,0,v|0)|0;p[d+(x+w<<3)>>3]=1.0;w=w+1|0;if((w|0)==(h|0))break a}}else y=0;do{w=Y(b,y)|0;x=d+(w<<3)|0;z=Y(y,s)|0;A=0;B=0.0;do{C=+p[a+(A+z<<3)>>3];B=B+C*C;A=A+1|0}while((A|0)!=(g|0));p[r+(y<<3)>>3]=B;if(!t){Nac(x|0,0,v|0)|0;p[d+(w+y<<3)>>3]=1.0}y=y+1|0}while((y|0)!=(h|0))}while(0);b:do if((q|0)>0){y=h+-1|0;v=(h|0)>1;t=(g|0)>0;A=(d|0)==0;z=0;do{if(v){D=0;E=0}else break b;while(1){F=E;E=E+1|0;if((E|0)<(h|0)){G=a+((Y(F,s)|0)<<3)|0;H=r+(F<<3)|0;I=d+((Y(F,b)|0)<<3)|0;F=E;K=D;while(1){N=a+((Y(F,s)|0)<<3)|0;C=+p[H>>3];O=r+(F<<3)|0;P=+p[O>>3];if(t){Q=0.0;R=0;while(1){S=Q+ +p[G+(R<<3)>>3]*+p[N+(R<<3)>>3];R=R+1|0;if((R|0)==(g|0)){T=S;break}else Q=S}}else T=0.0;if(!(+L(+T)<=+M(+(C*P))*k)){Q=T*2.0;S=C-P;U=+L(+Q);V=+L(+S);if(!(U>V))if(S!=S|0.0!=0.0|S==0.0)W=0.0;else{X=U/V;Z=V;_=X*X;$=32}else{X=V/U;Z=U;_=X*X;$=32}if(($|0)==32){$=0;W=Z*+M(+(_+1.0))}if(S<0.0){X=+M(+((W-S)*.5/W));aa=Q/(W*X*2.0);ba=X}else{X=+M(+((S+W)/(W*2.0)));aa=X;ba=Q/(W*X*2.0)}if(t){X=0.0;Q=0.0;R=0;while(1){ca=G+(R<<3)|0;S=+p[ca>>3];da=N+(R<<3)|0;U=+p[da>>3];V=aa*S+ba*U;ea=aa*U-ba*S;p[ca>>3]=V;p[da>>3]=ea;S=X+V*V;V=Q+ea*ea;R=R+1|0;if((R|0)==(g|0)){fa=S;ga=V;break}else{X=S;Q=V}}}else{fa=0.0;ga=0.0}p[H>>3]=fa;p[O>>3]=ga;if(!A?(R=d+((Y(F,b)|0)<<3)|0,e):0){N=0;do{da=I+(N<<3)|0;Q=+p[da>>3];ca=R+(N<<3)|0;X=+p[ca>>3];p[da>>3]=aa*Q+ba*X;p[ca>>3]=aa*X-ba*Q;N=N+1|0}while((N|0)!=(h|0));ha=1}else ha=1}else ha=K;F=F+1|0;if((F|0)==(h|0)){ia=ha;break}else K=ha}}else ia=D;if((E|0)==(y|0))break;else D=ia}z=z+1|0}while(ia&(z|0)<(q|0))}while(0);if(e){if((g|0)>0){q=0;do{ia=Y(q,s)|0;ba=0.0;D=0;do{aa=+p[a+(D+ia<<3)>>3];ba=ba+aa*aa;D=D+1|0}while((D|0)!=(g|0));aa=+M(+ba);p[r+(q<<3)>>3]=aa;q=q+1|0}while((q|0)!=(h|0))}else Nac(r|0,0,h<<3|0)|0;q=h+-1|0;c:do if((h|0)>1){D=(g|0)>0;if(!d){ia=0;while(1){E=ia;ia=ia+1|0;if((ia|0)<(h|0)){ha=E;$=ia;while(1){z=+p[r+(ha<<3)>>3]<+p[r+($<<3)>>3]?$:ha;$=$+1|0;if(($|0)==(h|0)){ja=z;break}else ha=z}}else ja=E;if((E|0)!=(ja|0)){ha=r+(E<<3)|0;$=r+(ja<<3)|0;aa=+p[ha>>3];p[ha>>3]=+p[$>>3];p[$>>3]=aa}if((ia|0)==(q|0))break c}}else ka=0;do{ia=ka;ka=ka+1|0;if((ka|0)<(h|0)){$=ia;ha=ka;while(1){z=+p[r+($<<3)>>3]<+p[r+(ha<<3)>>3]?ha:$;ha=ha+1|0;if((ha|0)==(h|0)){la=z;break}else $=z}}else la=ia;if((ia|0)!=(la|0)){$=r+(ia<<3)|0;ha=r+(la<<3)|0;ba=+p[$>>3];p[$>>3]=+p[ha>>3];p[ha>>3]=ba;if(D){ha=Y(ia,s)|0;$=Y(la,s)|0;E=0;do{z=a+(E+ha<<3)|0;y=a+(E+$<<3)|0;ba=+p[z>>3];p[z>>3]=+p[y>>3];p[y>>3]=ba;E=E+1|0}while((E|0)!=(g|0))}E=Y(ia,b)|0;$=Y(la,b)|0;ha=0;do{y=d+(ha+E<<3)|0;z=d+(ha+$<<3)|0;ba=+p[y>>3];p[y>>3]=+p[z>>3];p[z>>3]=ba;ha=ha+1|0}while((ha|0)!=(h|0))}}while((ka|0)!=(q|0))}while(0);if(e){e=0;do{p[c+(e<<3)>>3]=+p[r+(e<<3)>>3];e=e+1|0}while((e|0)!=(h|0))}}if((d|0)!=0&(i|0)>0){d=(g|0)>0;ba=1.0/+(g|0);aa=-ba;ga=k*100.0;e=305419896;c=0;q=0;while(1){if((q|0)<(h|0))ma=+p[r+(q<<3)>>3];else ma=0.0;if(!(ma<=j)){na=ma;oa=e;pa=c}else{ka=Y(q,s)|0;b=(q|0)>0;la=0;ja=e;D=c;while(1){if(d){ha=0;$=ja;E=D;while(1){ia=cbc($|0,0,-130063606,0)|0;z=Kac(ia|0,J|0,E|0,0)|0;ia=J;p[a+(ha+ka<<3)>>3]=(z&256|0)!=0|0!=0?ba:aa;ha=ha+1|0;if((ha|0)==(g|0)){qa=z;ra=ia;break}else{$=z;E=ia}}}else{qa=ja;ra=D}d:do if(b){if(d){E=0;do{$=Y(E,s)|0;ha=0;k=0.0;do{k=k+ +p[a+(ha+ka<<3)>>3]*+p[a+(ha+$<<3)>>3];ha=ha+1|0}while((ha|0)!=(g|0));sa=0.0;ta=0;do{ha=a+(ta+ka<<3)|0;fa=+p[ha>>3]-k*+p[a+(ta+$<<3)>>3];p[ha>>3]=fa;sa=sa+ +L(+fa);ta=ta+1|0}while((ta|0)!=(g|0));k=sa>ga?1.0/sa:0.0;$=0;do{ha=a+($+ka<<3)|0;p[ha>>3]=k*+p[ha>>3];$=$+1|0}while(($|0)!=(g|0));E=E+1|0}while((E|0)!=(q|0))}else{E=0;do E=E+1|0;while((E|0)!=(q|0))}if(b){if(d)ua=0;else{E=0;while(1){E=E+1|0;if((E|0)==(q|0))break d}}do{E=Y(ua,s)|0;$=0;k=0.0;do{k=k+ +p[a+($+ka<<3)>>3]*+p[a+($+E<<3)>>3];$=$+1|0}while(($|0)!=(g|0));va=0.0;wa=0;do{$=a+(wa+ka<<3)|0;fa=+p[$>>3]-k*+p[a+(wa+E<<3)>>3];p[$>>3]=fa;va=va+ +L(+fa);wa=wa+1|0}while((wa|0)!=(g|0));k=va>ga?1.0/va:0.0;E=0;do{$=a+(E+ka<<3)|0;p[$>>3]=k*+p[$>>3];E=E+1|0}while((E|0)!=(g|0));ua=ua+1|0}while((ua|0)!=(q|0))}}while(0);if(d){E=0;k=0.0;while(1){fa=+p[a+(E+ka<<3)>>3];W=k+fa*fa;E=E+1|0;if((E|0)==(g|0)){xa=W;break}else k=W}}else xa=0.0;k=+M(+xa);if(!(k<=j)|(la|0)>98){na=k;oa=qa;pa=ra;break}else{la=la+1|0;ja=qa;D=ra}}}k=na>j?1.0/na:0.0;if(d){D=Y(q,s)|0;ja=0;do{la=a+(ja+D<<3)|0;p[la>>3]=k*+p[la>>3];ja=ja+1|0}while((ja|0)!=(g|0))}q=q+1|0;if((q|0)==(i|0))break;else{e=oa;c=pa}}}pa=f[m>>2]|0;if((pa|0)==(n|0)){u=l;return}if(pa|0)P5b(pa);f[m>>2]=n;f[o>>2]=136;u=l;return}function $S(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0.0,P=0,Q=0,R=0,S=0.0;c=u;u=u+1184|0;d=c+1168|0;e=c+1112|0;g=c+72|0;h=c+16|0;i=c;dQ(d,47012);do if((yM(a)|0)==65536){j=f[a+4>>2]|0;f[e>>2]=f[j>>2];k=e+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=e+8|0;f[m>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];o=e+16|0;f[o>>2]=f[j+16>>2];f[e+20>>2]=f[j+20>>2];f[e+24>>2]=f[j+24>>2];f[e+28>>2]=f[j+28>>2];f[e+32>>2]=f[j+32>>2];q=f[j+36>>2]|0;f[e+36>>2]=q;f[e+40>>2]=m;r=e+48|0;s=e+44|0;f[s>>2]=r;f[r>>2]=0;f[e+52>>2]=0;if(q|0){t=q+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;t=f[s>>2]|0;f[t>>2]=f[l>>2];f[t+4>>2]=f[l+4>>2];v=m;w=r;x=o;y=s;z=e;break}else{f[k>>2]=0;jL(e,j);v=m;w=r;x=o;y=s;z=e;break}}else{yL(e,a,-1);v=e+8|0;w=e+48|0;x=e+16|0;y=e+44|0;z=e}while(0);a=f[z>>2]&4095;z=f[v>>2]|0;s=f[w>>2]|0;o=f[x>>2]|0;if(o){r=f[e+4>>2]|0;if((r|0)<3)A=Y(f[e+12>>2]|0,z)|0;else{m=f[e+40>>2]|0;j=0;k=1;while(1){l=Y(f[m+(j<<2)>>2]|0,k)|0;j=j+1|0;if((j|0)==(r|0)){A=l;break}else k=l}}if(!((r|0)==0|(A|0)==0))B=z;else C=14}else C=14;if((C|0)==14){f[g>>2]=0;f[g+4>>2]=0;D=aD(g,12)|0;E=200026;F=D+12|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));bO(-215,g,200039,199958,763);bD(g);B=f[v>>2]|0}if(!((a+-5|0)>>>0<2?(B|0)==(f[e+12>>2]|0):0)){f[g>>2]=0;f[g+4>>2]=0;D=aD(g,48)|0;E=200051;F=D+48|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));bO(-215,g,200039,199958,764);bD(g)}E=(z|0)==2;a:do if((a|0)==5){if(E){D=o+s|0;G=+n[o>>2]*+n[D+4>>2]-+n[o+4>>2]*+n[D>>2];break}switch(z|0){case 3:{D=o+s|0;H=+n[D+4>>2];F=o+(s<<1)|0;I=+n[F+8>>2];J=+n[D+8>>2];K=+n[F+4>>2];L=+n[D>>2];M=+n[F>>2];G=+n[o+8>>2]*(K*L-H*M)+(+n[o>>2]*(H*I-J*K)-+n[o+4>>2]*(I*L-J*M));break a;break}case 1:{G=+n[o>>2];break a;break}default:{F=(Y(z,z)|0)<<2;D=g+8|0;f[g>>2]=D;B=g+4|0;f[B>>2]=F;if(F>>>0>1032){v=N5b(F)|0;f[g>>2]=v;N=v}else N=D;v=h+4|0;f[v>>2]=2;F=h+8|0;f[F>>2]=z;f[h+12>>2]=z;C=h+16|0;f[C>>2]=N;f[h+20>>2]=N;A=h+24|0;r=h+40|0;k=A+8|0;f[k>>2]=0;f[k+4>>2]=0;f[r>>2]=F;k=h+48|0;j=h+44|0;f[j>>2]=k;m=z<<2;f[h>>2]=1124024325;f[k>>2]=m;f[h+52>>2]=4;l=N+(Y(f[F>>2]|0,m)|0)|0;f[h+28>>2]=l;f[A>>2]=l+(0-m)+m;m=i+8|0;f[m>>2]=0;f[m+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;SP(e,i);m=jZ(f[C>>2]|0,f[k>>2]|0,z,0,0,0)|0;M=+(m|0);if((m|0)!=0&(z|0)>0){m=f[C>>2]|0;l=f[f[j>>2]>>2]|0;A=0;J=M;while(1){F=m+(Y(l,A)|0)+(A<<2)|0;L=J*+n[F>>2];A=A+1|0;if((A|0)==(z|0)){O=L;break}else J=L}}else O=M;A=h+36|0;l=f[A>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)kL(h);f[A>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[v>>2]|0)>0){A=f[r>>2]|0;l=0;do{f[A+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[v>>2]|0))}v=f[j>>2]|0;if((v|0)!=(k|0))UC(v);v=f[g>>2]|0;if((v|0)!=(D|0)){if(v|0)P5b(v);f[g>>2]=D;f[B>>2]=1032}G=O;break a}}}else{if(E){v=o+s|0;G=+p[o>>3]*+p[v+8>>3]-+p[o+8>>3]*+p[v>>3];break}switch(z|0){case 3:{v=o+s|0;M=+p[v+8>>3];l=o+(s<<1)|0;J=+p[l+16>>3];L=+p[v+16>>3];I=+p[l+8>>3];K=+p[v>>3];H=+p[l>>3];G=+p[o+16>>3]*(I*K-M*H)+(+p[o>>3]*(M*J-L*I)-+p[o+8>>3]*(J*K-L*H));break a;break}case 1:{G=+p[o>>3];break a;break}default:{l=(Y(z,z)|0)<<3;v=g+8|0;f[g>>2]=v;A=g+4|0;f[A>>2]=l;if(l>>>0>1032){r=N5b(l)|0;f[g>>2]=r;P=r}else P=v;r=h+4|0;f[r>>2]=2;l=h+8|0;f[l>>2]=z;f[h+12>>2]=z;C=h+16|0;f[C>>2]=P;f[h+20>>2]=P;m=h+24|0;F=h+40|0;t=m+8|0;f[t>>2]=0;f[t+4>>2]=0;f[F>>2]=l;t=h+48|0;q=h+44|0;f[q>>2]=t;Q=z<<3;f[h>>2]=1124024326;f[t>>2]=Q;f[h+52>>2]=8;R=P+(Y(f[l>>2]|0,Q)|0)|0;f[h+28>>2]=R;f[m>>2]=R+(0-Q)+Q;Q=i+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;SP(e,i);Q=lZ(f[C>>2]|0,f[t>>2]|0,z,0,0,0)|0;H=+(Q|0);if((Q|0)!=0&(z|0)>0){Q=f[C>>2]|0;R=f[f[q>>2]>>2]|0;m=0;L=H;while(1){l=Q+(Y(R,m)|0)+(m<<3)|0;K=L*+p[l>>3];m=m+1|0;if((m|0)==(z|0)){S=K;break}else L=K}}else S=H;m=h+36|0;R=f[m>>2]|0;if(R|0?(Q=R+12|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)kL(h);f[m>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[r>>2]|0)>0){m=f[F>>2]|0;R=0;do{f[m+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[r>>2]|0))}r=f[q>>2]|0;if((r|0)!=(t|0))UC(r);r=f[g>>2]|0;if((r|0)!=(v|0)){if(r|0)P5b(r);f[g>>2]=v;f[A>>2]=1032}G=S;break a}}}while(0);g=e+36|0;h=f[g>>2]|0;if(h|0?(z=h+12|0,h=f[z>>2]|0,f[z>>2]=h+-1,(h|0)==1):0)kL(e);f[g>>2]=0;g=e+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[g>>2]|0)>0){x=f[e+40>>2]|0;e=0;do{f[x+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[g>>2]|0))}g=f[y>>2]|0;if((g|0)!=(w|0))UC(g);if(!(f[d+4>>2]|0)){u=c;return +G}u=c;return +G}function aT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0;e=u;u=u+2416|0;g=e+1376|0;h=e+1368|0;i=e+1312|0;j=e+112|0;k=e+1256|0;l=e+56|0;m=e;o=e+1240|0;q=e+1224|0;r=e+1208|0;s=e+1152|0;dQ(h,47032);do if((yM(a)|0)==65536){t=f[a+4>>2]|0;f[i>>2]=f[t>>2];v=i+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=i+8|0;f[x>>2]=f[t+8>>2];f[i+12>>2]=f[t+12>>2];f[i+16>>2]=f[t+16>>2];f[i+20>>2]=f[t+20>>2];f[i+24>>2]=f[t+24>>2];f[i+28>>2]=f[t+28>>2];f[i+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[i+36>>2]=y;f[i+40>>2]=x;x=i+48|0;z=i+44|0;f[z>>2]=x;f[x>>2]=0;f[i+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];A=i;break}else{f[v>>2]=0;jL(i,t);A=i;break}}else{yL(i,a,-1);A=i}while(0);a=f[A>>2]|0;A=a&4095;t=(A|0)==5;v=(A|0)==6;if((A+-5|0)>>>0>=2){f[g>>2]=0;f[g+4>>2]=0;B=aD(g,22)|0;C=200135;D=B+22|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,g,200158,199958,839);bD(g)}w=(a>>>3&511)+1<<(47696>>>(A<<1&14)&3);a=f[i+8>>2]|0;x=f[i+12>>2]|0;do if((d|0)==1){z=(x|0)<(a|0)?x:a;y=Y(z,a)|0;E=(Y(y+z+(Y(z,x)|0)|0,w)|0)+8|0;F=j+8|0;f[j>>2]=F;G=j+4|0;f[G>>2]=E;if(E>>>0>1032){H=N5b(E)|0;f[j>>2]=H;I=H}else I=F;Qi(k,a,z,A,w+-1+I&0-w,0);H=k+16|0;E=k+44|0;Qi(l,z,1,A,(f[H>>2]|0)+(Y(y,w)|0)|0,0);y=l+16|0;J=l+44|0;Qi(m,z,x,A,(f[y>>2]|0)+(Y(z,w)|0)|0,0);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=i;z=q+8|0;f[z>>2]=0;f[z+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=l;z=r+8|0;f[z>>2]=0;f[z+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=k;z=s+8|0;f[z>>2]=0;f[z+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=m;dQ(g,47052);bT(o,q,r,s,0);f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=l;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=m;f[s>>2]=1124007936;z=s+4|0;K=s+8|0;L=s+40|0;B=z;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[L>>2]=K;M=s+48|0;N=s+44|0;f[N>>2]=M;f[M>>2]=0;f[s+52>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=s;cT(g,o,q,r,c);O=s+36|0;P=f[O>>2]|0;if(P|0?(Q=P+12|0,P=f[Q>>2]|0,f[Q>>2]=P+-1,(P|0)==1):0)kL(s);f[O>>2]=0;O=s+16|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[z>>2]|0)>0){O=f[L>>2]|0;P=0;do{f[O+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[z>>2]|0))}z=f[N>>2]|0;if((z|0)!=(M|0))UC(z);z=f[y>>2]|0;if(t){R=+n[z>>2];if(!(R>=1.1920928955078125e-07))S=0.0;else S=+n[z+(x+-1<<2)>>2]/R}else{R=+p[z>>3];if(!(R>=2.220446049250313e-16))S=0.0;else S=+p[z+(x+-1<<3)>>3]/R}z=m+36|0;P=f[z>>2]|0;if(P|0?(O=P+12|0,P=f[O>>2]|0,f[O>>2]=P+-1,(P|0)==1):0)kL(m);f[z>>2]=0;z=m+16|0;P=m+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[P>>2]|0)>0){z=f[m+40>>2]|0;O=0;do{f[z+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[P>>2]|0))}P=f[m+44>>2]|0;if((P|0)!=(m+48|0))UC(P);P=l+36|0;O=f[P>>2]|0;if(O|0?(z=O+12|0,O=f[z>>2]|0,f[z>>2]=O+-1,(O|0)==1):0)kL(l);f[P>>2]=0;P=l+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[P>>2]|0)>0){O=f[l+40>>2]|0;z=0;do{f[O+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[P>>2]|0))}P=f[J>>2]|0;if((P|0)!=(l+48|0))UC(P);P=k+36|0;z=f[P>>2]|0;if(z|0?(O=z+12|0,z=f[O>>2]|0,f[O>>2]=z+-1,(z|0)==1):0)kL(k);f[P>>2]=0;P=k+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[P>>2]|0)>0){z=f[k+40>>2]|0;O=0;do{f[z+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[P>>2]|0))}P=f[E>>2]|0;if((P|0)!=(k+48|0))UC(P);P=f[j>>2]|0;if((P|0)!=(F|0)){if(P|0)P5b(P);f[j>>2]=F;f[G>>2]=1032}T=S}else{if((a|0)!=(x|0)){f[g>>2]=0;f[g+4>>2]=0;P=aD(g,6)|0;b[P>>0]=b[200165]|0;b[P+1>>0]=b[200166]|0;b[P+2>>0]=b[200167]|0;b[P+3>>0]=b[200168]|0;b[P+4>>0]=b[200169]|0;b[P+5>>0]=b[200170]|0;bO(-215,g,200158,199958,863);bD(g)}if((d|0)==2){P=Y(x,x)|0;O=(Y((P<<1)+x|0,w)|0)+8|0;z=g+8|0;f[g>>2]=z;H=g+4|0;f[H>>2]=O;if(O>>>0>1032){J=N5b(O)|0;f[g>>2]=J;U=J}else U=z;Qi(j,x,x,A,w+-1+U&0-w,0);J=j+16|0;O=j+44|0;Qi(k,x,1,A,(f[J>>2]|0)+(Y(P,w)|0)|0,0);P=k+16|0;y=k+44|0;Qi(l,x,x,A,(f[P>>2]|0)+(Y(x,w)|0)|0,0);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=i;M=o+8|0;f[M>>2]=0;f[M+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;M=q+8|0;f[M>>2]=0;f[M+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=l;dT(m,o,q)|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=l;M=o+8|0;f[M>>2]=0;f[M+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=j;ZL(m,o);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=k;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=j;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;f[s>>2]=1124007936;M=s+4|0;N=s+8|0;L=s+40|0;B=M;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[L>>2]=N;G=s+48|0;F=s+44|0;f[F>>2]=G;f[G>>2]=0;f[s+52>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=s;cT(m,o,q,r,c);E=s+36|0;K=f[E>>2]|0;if(K|0?(Q=K+12|0,K=f[Q>>2]|0,f[Q>>2]=K+-1,(K|0)==1):0)kL(s);f[E>>2]=0;E=s+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[M>>2]|0)>0){E=f[L>>2]|0;K=0;do{f[E+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[M>>2]|0))}M=f[F>>2]|0;if((M|0)!=(G|0))UC(M);M=f[P>>2]|0;if(t){R=+n[M>>2];if(!(R>=1.1920928955078125e-07))V=0.0;else V=+n[M+(x+-1<<2)>>2]/R}else{R=+p[M>>3];if(!(R>=2.220446049250313e-16))V=0.0;else V=+p[M+(x+-1<<3)>>3]/R}M=l+36|0;K=f[M>>2]|0;if(K|0?(E=K+12|0,K=f[E>>2]|0,f[E>>2]=K+-1,(K|0)==1):0)kL(l);f[M>>2]=0;M=l+16|0;K=l+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[K>>2]|0)>0){M=f[l+40>>2]|0;E=0;do{f[M+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[K>>2]|0))}K=f[l+44>>2]|0;if((K|0)!=(l+48|0))UC(K);K=k+36|0;E=f[K>>2]|0;if(E|0?(M=E+12|0,E=f[M>>2]|0,f[M>>2]=E+-1,(E|0)==1):0)kL(k);f[K>>2]=0;K=k+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[K>>2]|0)>0){E=f[k+40>>2]|0;M=0;do{f[E+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[K>>2]|0))}K=f[y>>2]|0;if((K|0)!=(k+48|0))UC(K);K=j+36|0;M=f[K>>2]|0;do if(M|0){E=M+12|0;P=f[E>>2]|0;f[E>>2]=P+-1;if((P|0)!=1)break;kL(j)}while(0);f[K>>2]=0;M=j+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[M>>2]|0)>0){y=f[j+40>>2]|0;P=0;do{f[y+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[M>>2]|0))}M=f[O>>2]|0;if((M|0)!=(j+48|0))UC(M);M=f[g>>2]|0;if((M|0)!=(z|0)){if(M|0)P5b(M);f[g>>2]=z;f[H>>2]=1032}T=V;break}M=(d|0)==0;P=(d|0)==3;switch(d|0){case 0:case 3:break;default:{f[g>>2]=0;f[g+4>>2]=0;B=aD(g,48)|0;C=200172;D=B+48|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,g,200158,199958,883);bD(g)}}aM(c,x,x,A,-1,0,0);do if((yM(c)|0)==65536){H=f[c+4>>2]|0;f[g>>2]=f[H>>2];z=g+4|0;O=H+4|0;f[z>>2]=f[O>>2];y=g+8|0;f[y>>2]=f[H+8>>2];f[g+12>>2]=f[H+12>>2];f[g+16>>2]=f[H+16>>2];f[g+20>>2]=f[H+20>>2];f[g+24>>2]=f[H+24>>2];f[g+28>>2]=f[H+28>>2];f[g+32>>2]=f[H+32>>2];J=f[H+36>>2]|0;f[g+36>>2]=J;f[g+40>>2]=y;y=g+48|0;K=g+44|0;f[K>>2]=y;f[y>>2]=0;f[g+52>>2]=0;if(J|0){y=J+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[O>>2]|0)<3){O=f[H+44>>2]|0;y=f[K>>2]|0;f[y>>2]=f[O>>2];f[y+4>>2]=f[O+4>>2];break}else{f[z>>2]=0;jL(g,H);break}}else yL(g,c,-1);while(0);a:do if((x|0)<4){H=f[i+16>>2]|0;z=f[g+16>>2]|0;O=f[i+48>>2]|0;y=f[g+48>>2]|0;b:do switch(x|0){case 2:{if(t){R=+n[H>>2];K=H+O|0;W=+n[K+4>>2];J=H+4|0;X=R*W-+n[J>>2]*+n[K>>2];if(!(X!=0.0))break b;Z=1.0/X;E=z+y|0;n[E+4>>2]=R*Z;n[z>>2]=W*Z;W=Z*-+n[K>>2];n[z+4>>2]=Z*-+n[J>>2];n[E>>2]=W;_=1;break a}else{W=+p[H>>3];E=H+O|0;Z=+p[E+8>>3];J=H+8|0;R=W*Z-+p[J>>3]*+p[E>>3];if(!(R!=0.0))break b;X=1.0/R;K=z+y|0;p[K+8>>3]=W*X;p[z>>3]=Z*X;Z=-(X*+p[E>>3]);p[z+8>>3]=-(X*+p[J>>3]);p[K>>3]=Z;_=1;break a}break}case 3:{K=O<<1;if(t){Z=+n[H>>2];J=H+O|0;X=+n[J+4>>2];E=H+K|0;W=+n[E+8>>2];R=+n[J+8>>2];$=+n[E+4>>2];aa=X*W-R*$;ba=+n[H+4>>2];ca=+n[J>>2];da=W*ca;ea=+n[E>>2];fa=R*ea;ga=+n[H+8>>2];ha=$*ca-X*ea;ia=ga*ha+(Z*aa-ba*(da-fa));if(!(ia!=0.0))break b;ja=1.0/ia;n[z>>2]=aa*ja;n[z+4>>2]=($*ga-W*ba)*ja;n[z+8>>2]=(R*ba-X*ga)*ja;E=z+y|0;n[E>>2]=(fa-da)*ja;n[E+4>>2]=(Z*W-ea*ga)*ja;n[E+8>>2]=(ca*ga-Z*R)*ja;E=z+(y<<1)|0;n[E>>2]=ha*ja;n[E+4>>2]=(ba*ea-Z*$)*ja;n[E+8>>2]=(Z*X-ba*ca)*ja;_=1;break a}else{ja=+p[H>>3];E=H+O|0;ca=+p[E+8>>3];J=H+K|0;ba=+p[J+16>>3];X=+p[E+16>>3];Z=+p[J+8>>3];$=ca*ba-X*Z;ea=+p[H+8>>3];ha=+p[E>>3];R=ba*ha;ga=+p[J>>3];W=X*ga;da=+p[H+16>>3];fa=Z*ha-ca*ga;aa=da*fa+(ja*$-ea*(R-W));if(!(aa!=0.0))break b;ia=1.0/aa;p[z>>3]=$*ia;p[z+8>>3]=(Z*da-ba*ea)*ia;p[z+16>>3]=(X*ea-ca*da)*ia;J=z+y|0;p[J>>3]=(W-R)*ia;p[J+8>>3]=(ja*ba-ga*da)*ia;p[J+16>>3]=(ha*da-ja*X)*ia;J=z+(y<<1)|0;p[J>>3]=fa*ia;p[J+8>>3]=(ea*ga-ja*Z)*ia;p[J+16>>3]=(ja*ca-ea*ha)*ia;_=1;break a}break}default:if(t){ia=+n[H>>2];if(!(ia!=0.0))break b;n[z>>2]=1.0/ia;_=1;break a}else{ia=+p[H>>3];if(!(ia!=0.0))break b;p[z>>3]=1.0/ia;_=1;break a}}while(0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;UP(g,j)|0;_=0}else{z=Y(Y(x,w)|0,x)|0;H=j+8|0;f[j>>2]=H;y=j+4|0;f[y>>2]=z;if(z>>>0>1032){O=N5b(z)|0;f[j>>2]=O;ka=O}else ka=H;Qi(k,x,x,A,ka,0);O=l+8|0;f[O>>2]=0;f[O+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;SP(i,l);O=l+8|0;f[O>>2]=0;f[O+4>>2]=0;f[l>>2]=50397184;f[l+4>>2]=g;p[m>>3]=1.0;O=m+8|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;f[O+16>>2]=0;f[O+20>>2]=0;ZM(l,m);do if(M&t)if(!(jZ(f[k+16>>2]|0,f[k+48>>2]|0,x,f[g+16>>2]|0,f[g+48>>2]|0,x)|0))la=141;else ma=1;else{if(M&v)if(!(lZ(f[k+16>>2]|0,f[k+48>>2]|0,x,f[g+16>>2]|0,f[g+48>>2]|0,x)|0)){la=141;break}else{ma=1;break}O=f[k+16>>2]|0;if(P&t)na=nZ(O,f[k+48>>2]|0,x,f[g+16>>2]|0,f[g+48>>2]|0,x)|0;else na=pZ(O,f[k+48>>2]|0,x,f[g+16>>2]|0,f[g+48>>2]|0,x)|0;if(na)ma=1;else la=141}while(0);if((la|0)==141){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;UP(g,l)|0;ma=0}O=k+36|0;z=f[O>>2]|0;if(z|0?(J=z+12|0,z=f[J>>2]|0,f[J>>2]=z+-1,(z|0)==1):0)kL(k);f[O>>2]=0;O=k+16|0;z=k+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[z>>2]|0)>0){O=f[k+40>>2]|0;J=0;do{f[O+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[z>>2]|0))}z=f[k+44>>2]|0;if((z|0)!=(k+48|0))UC(z);z=f[j>>2]|0;if((z|0)!=(H|0)){if(z|0)P5b(z);f[j>>2]=H;f[y>>2]=1032}_=ma}while(0);P=g+36|0;M=f[P>>2]|0;if(M|0?(z=M+12|0,M=f[z>>2]|0,f[z>>2]=M+-1,(M|0)==1):0)kL(g);f[P>>2]=0;P=g+16|0;M=g+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[M>>2]|0)>0){P=f[g+40>>2]|0;z=0;do{f[P+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[M>>2]|0))}M=f[g+44>>2]|0;if((M|0)!=(g+48|0))UC(M);T=+(_&1)}while(0);_=i+36|0;g=f[_>>2]|0;if(g|0?(ma=g+12|0,g=f[ma>>2]|0,f[ma>>2]=g+-1,(g|0)==1):0)kL(i);f[_>>2]=0;_=i+16|0;g=i+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[g>>2]|0)>0){_=f[i+40>>2]|0;ma=0;do{f[_+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[g>>2]|0))}g=f[i+44>>2]|0;if((g|0)!=(i+48|0))UC(g);if(!(f[h+4>>2]|0)){u=e;return +T}u=e;return +T}function bT(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;h=u;u=u+1392|0;i=h+1336|0;j=h+296|0;k=h+240|0;l=h+184|0;m=h+128|0;n=h+72|0;o=h;p=h+56|0;do if((yM(a)|0)==65536){q=f[a+4>>2]|0;f[i>>2]=f[q>>2];r=i+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=i+8|0;f[t>>2]=f[q+8>>2];v=i+12|0;f[v>>2]=f[q+12>>2];f[i+16>>2]=f[q+16>>2];f[i+20>>2]=f[q+20>>2];f[i+24>>2]=f[q+24>>2];f[i+28>>2]=f[q+28>>2];f[i+32>>2]=f[q+32>>2];w=f[q+36>>2]|0;f[i+36>>2]=w;f[i+40>>2]=t;x=i+48|0;y=i+44|0;f[y>>2]=x;f[x>>2]=0;f[i+52>>2]=0;if(w|0){x=w+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;x=f[y>>2]|0;f[x>>2]=f[s>>2];f[x+4>>2]=f[s+4>>2];z=v;A=i;B=t;break}else{f[r>>2]=0;jL(i,q);z=v;A=i;B=t;break}}else{yL(i,a,-1);z=i+12|0;A=i;B=i+8|0}while(0);a=f[B>>2]|0;B=f[z>>2]|0;z=f[A>>2]&4095;if(PM(d)|0)C=1;else C=PM(e)|0;A=(z|0)==5;if((z+-5|0)>>>0>=2){f[j>>2]=0;f[j+4>>2]=0;D=aD(j,22)|0;t=200135;E=D+22|0;do{b[D>>0]=b[t>>0]|0;D=D+1|0;t=t+1|0}while((D|0)<(E|0));bO(-215,j,200566,199958,1473);bD(j)}if(!(g&2)){t=(a|0)<(B|0);v=t?B:a;q=t?a:B;F=C;G=q;H=v;I=t;J=g&4|0?v:q}else{$L(d);$L(e);q=(a|0)<(B|0);v=q?a:B;F=0;G=v;H=q?B:a;I=q;J=v}v=i+4|0;q=f[v>>2]|0;if((q|0)>0)K=f[(f[i+44>>2]|0)+(q+-1<<2)>>2]|0;else K=0;q=(Y(K,H)|0)+15&-16;a=Y(K,G)|0;K=a+15&-16;B=Y(q,J)|0;g=a+32+(Y(K,G)|0)+B|0;t=j+8|0;f[j>>2]=t;C=j+4|0;f[C>>2]=g;if(g>>>0>1032){r=N5b(g)|0;f[j>>2]=r;L=r}else L=t;r=L+15&-16;Qi(k,G,H,z,r,q);L=r+B|0;Qi(l,G,1,z,L,0);Qi(m,J,H,z,r,q);f[n>>2]=1124007936;q=n+4|0;r=n+8|0;B=n+40|0;D=q;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[B>>2]=r;D=n+48|0;E=n+44|0;f[E>>2]=D;f[D>>2]=0;f[n+52>>2]=0;if(F){Qi(o,G,G,z,L+a+15&-16,K);K=o+36|0;a=f[K>>2]|0;if(a|0){L=a+12|0;f[L>>2]=(f[L>>2]|0)+1}L=n+36|0;a=f[L>>2]|0;if(a|0?(z=a+12|0,a=f[z>>2]|0,f[z>>2]=a+-1,(a|0)==1):0)kL(n);f[L>>2]=0;a=n+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[q>>2]|0)>0){z=f[B>>2]|0;g=0;do{f[z+(g<<2)>>2]=0;g=g+1|0;M=f[q>>2]|0}while((g|0)<(M|0));f[n>>2]=f[o>>2];if((M|0)<3)N=30;else N=32}else{f[n>>2]=f[o>>2];N=30}if((N|0)==30){M=f[o+4>>2]|0;if((M|0)<3){f[q>>2]=M;f[r>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];r=f[o+44>>2]|0;M=f[E>>2]|0;f[M>>2]=f[r>>2];f[M+4>>2]=f[r+4>>2]}else N=32}if((N|0)==32)jL(n,o);N=o+16|0;f[a>>2]=f[N>>2];f[n+20>>2]=f[o+20>>2];f[n+24>>2]=f[o+24>>2];f[n+28>>2]=f[o+28>>2];f[n+32>>2]=f[o+32>>2];a=f[K>>2]|0;f[L>>2]=a;if(a|0?(L=a+12|0,a=f[L>>2]|0,f[L>>2]=a+-1,(a|0)==1):0)kL(o);f[K>>2]=0;K=o+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[K>>2]|0)>0){N=f[o+40>>2]|0;a=0;do{f[N+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[K>>2]|0))}K=f[o+44>>2]|0;if((K|0)!=(o+48|0))UC(K)}if((J|0)>(G|0)){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;f[o+28>>2]=0;UP(m,o)|0}if(I){K=o+8|0;f[K>>2]=0;f[K+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;SP(i,o)}else{f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=i;K=p+8|0;f[K>>2]=0;f[K+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=k;ZL(o,p)}p=k+16|0;K=f[p>>2]|0;if(A){A=f[n+16>>2]|0;a=F?J:0;ZS(K,f[m+48>>2]|0,f[l+16>>2]|0,A,f[D>>2]|0,H,G,(A|0)==0?0:(a|0)<0?G:a,1.1754943508222875e-38,2.384185791015625e-07)}else{a=f[n+16>>2]|0;A=F?J:0;_S(K,f[m+48>>2]|0,f[l+16>>2]|0,a,f[D>>2]|0,H,G,(a|0)==0?0:(A|0)<0?G:A,2.2250738585072014e-308,2.220446049250313e-15)}SP(l,c);do if(F){c=PM(d)|0;if(I){if(c){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=n;ZL(o,d)}if(!(PM(e)|0))break;SP(m,e);break}else{if(c){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=m;ZL(o,d)}if(!(PM(e)|0))break;SP(n,e);break}}while(0);e=n+36|0;d=f[e>>2]|0;if(d|0?(o=d+12|0,d=f[o>>2]|0,f[o>>2]=d+-1,(d|0)==1):0)kL(n);f[e>>2]=0;e=n+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[q>>2]|0)>0){e=f[B>>2]|0;B=0;do{f[e+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[q>>2]|0))}q=f[E>>2]|0;if((q|0)!=(D|0))UC(q);q=m+36|0;D=f[q>>2]|0;if(D|0?(E=D+12|0,D=f[E>>2]|0,f[E>>2]=D+-1,(D|0)==1):0)kL(m);f[q>>2]=0;q=m+16|0;D=m+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[D>>2]|0)>0){q=f[m+40>>2]|0;E=0;do{f[q+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[D>>2]|0))}D=f[m+44>>2]|0;if((D|0)!=(m+48|0))UC(D);D=l+36|0;m=f[D>>2]|0;if(m|0?(E=m+12|0,m=f[E>>2]|0,f[E>>2]=m+-1,(m|0)==1):0)kL(l);f[D>>2]=0;D=l+16|0;m=l+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[m>>2]|0)>0){D=f[l+40>>2]|0;E=0;do{f[D+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))UC(m);m=k+36|0;l=f[m>>2]|0;do if(l|0){E=l+12|0;D=f[E>>2]|0;f[E>>2]=D+-1;if((D|0)!=1)break;kL(k)}while(0);f[m>>2]=0;m=k+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[m>>2]|0)>0){p=f[k+40>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)!=(k+48|0))UC(m);m=f[j>>2]|0;if((m|0)!=(t|0)){if(m|0)P5b(m);f[j>>2]=t;f[C>>2]=1032}C=i+36|0;t=f[C>>2]|0;do if(t|0){j=t+12|0;m=f[j>>2]|0;f[j>>2]=m+-1;if((m|0)!=1)break;kL(i)}while(0);f[C>>2]=0;C=i+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[v>>2]|0)>0){C=f[i+40>>2]|0;t=0;do{f[C+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[v>>2]|0))}v=f[i+44>>2]|0;if((v|0)==(i+48|0)){u=h;return}UC(v);u=h;return}function cT(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=u;u=u+1328|0;i=h+1272|0;j=h+1216|0;k=h+1160|0;l=h+1104|0;m=h+64|0;n=h+8|0;o=h;do if((yM(a)|0)==65536){p=f[a+4>>2]|0;f[i>>2]=f[p>>2];q=i+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];f[i+16>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=s;s=i+48|0;v=i+44|0;f[v>>2]=s;f[s>>2]=0;f[i+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;jL(i,p);break}}else yL(i,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[j>>2]=f[a>>2];p=j+4|0;q=a+4|0;f[p>>2]=f[q>>2];r=j+8|0;f[r>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[j+36>>2]=s;f[j+40>>2]=r;r=j+48|0;v=j+44|0;f[v>>2]=r;f[r>>2]=0;f[j+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[a+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;jL(j,a);break}}else yL(j,c,-1);while(0);do if((yM(d)|0)==65536){c=f[d+4>>2]|0;f[k>>2]=f[c>>2];a=k+4|0;p=c+4|0;f[a>>2]=f[p>>2];q=k+8|0;f[q>>2]=f[c+8>>2];f[k+12>>2]=f[c+12>>2];f[k+16>>2]=f[c+16>>2];f[k+20>>2]=f[c+20>>2];f[k+24>>2]=f[c+24>>2];f[k+28>>2]=f[c+28>>2];f[k+32>>2]=f[c+32>>2];r=f[c+36>>2]|0;f[k+36>>2]=r;f[k+40>>2]=q;q=k+48|0;v=k+44|0;f[v>>2]=q;f[q>>2]=0;f[k+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[c+44>>2]|0;q=f[v>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[a>>2]=0;jL(k,c);break}}else yL(k,d,-1);while(0);do if((yM(e)|0)==65536){d=f[e+4>>2]|0;f[l>>2]=f[d>>2];c=l+4|0;a=d+4|0;f[c>>2]=f[a>>2];p=l+8|0;f[p>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];f[l+16>>2]=f[d+16>>2];f[l+20>>2]=f[d+20>>2];f[l+24>>2]=f[d+24>>2];f[l+28>>2]=f[d+28>>2];f[l+32>>2]=f[d+32>>2];q=f[d+36>>2]|0;f[l+36>>2]=q;f[l+40>>2]=p;p=l+48|0;v=l+44|0;f[v>>2]=p;f[p>>2]=0;f[l+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[a>>2]|0)<3){a=f[d+44>>2]|0;p=f[v>>2]|0;f[p>>2]=f[a>>2];f[p+4>>2]=f[a+4>>2];break}else{f[c>>2]=0;jL(l,d);break}}else yL(l,e,-1);while(0);e=f[i>>2]|0;d=e&4095;c=i+4|0;a=f[c>>2]|0;if((a|0)>0)w=f[(f[i+44>>2]|0)+(a+-1<<2)>>2]|0;else w=0;a=f[j+8>>2]|0;p=f[k+12>>2]|0;v=l+16|0;q=f[v>>2]|0?f[l+12>>2]|0:a;r=(p|0)<(a|0)?p:a;if((f[i+8>>2]|0)==1)x=w;else x=((f[i+12>>2]|0)==1?0:w)+(f[i+48>>2]|0)|0;w=(q<<3)+16|0;s=m+8|0;f[m>>2]=s;t=m+4|0;f[t>>2]=w;if(w>>>0>1032){y=N5b(w)|0;f[m>>2]=y}if(!(((((d|0)==(f[j>>2]&4095|0)?(d|0)==(f[k>>2]&4095|0):0)?(f[j+16>>2]|0)!=0:0)?(f[k+16>>2]|0)!=0:0)?(f[i+16>>2]|0)!=0:0)){f[n>>2]=0;f[n+4>>2]=0;z=aD(n,76)|0;A=200301;B=z+76|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,n,200378,199958,1561);bD(n)}y=f[j+12>>2]|0;if((y|0)>=(r|0)?(w=f[k+8>>2]|0,(w|0)>=(r|0)):0){C=f[i+40>>2]|0;D=f[C+4>>2]|0;E=f[C>>2]|0;if((!((D|0)==(r|0)&(E|0)==1)?!((D|0)==1&(E|0)==(r|0)):0)?!((D|0)==(w|0)&(E|0)==(y|0)):0)F=46}else F=46;if((F|0)==46){f[n>>2]=0;f[n+4>>2]=0;z=aD(n,122)|0;A=200388;B=z+122|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,n,200378,199958,1563);bD(n)}do if(f[v>>2]|0){if((f[l>>2]&4095|0)==(d|0)?(f[l+8>>2]|0)==(a|0):0)break;f[n>>2]=0;f[n+4>>2]=0;z=aD(n,54)|0;A=200511;B=z+54|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,n,200378,199958,1564);bD(n)}while(0);aM(g,p,q,d,-1,0,0);do if((yM(g)|0)==65536){d=f[g+4>>2]|0;f[n>>2]=f[d>>2];A=n+4|0;z=d+4|0;f[A>>2]=f[z>>2];B=n+8|0;f[B>>2]=f[d+8>>2];f[n+12>>2]=f[d+12>>2];f[n+16>>2]=f[d+16>>2];f[n+20>>2]=f[d+20>>2];f[n+24>>2]=f[d+24>>2];f[n+28>>2]=f[d+28>>2];f[n+32>>2]=f[d+32>>2];F=f[d+36>>2]|0;f[n+36>>2]=F;f[n+40>>2]=B;B=n+48|0;y=n+44|0;f[y>>2]=B;f[B>>2]=0;f[n+52>>2]=0;if(F|0){B=F+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[z>>2]|0)<3){z=f[d+44>>2]|0;B=f[y>>2]|0;f[B>>2]=f[z>>2];f[B+4>>2]=f[z+4>>2];break}else{f[A>>2]=0;jL(n,d);break}}else yL(n,g,-1);while(0);switch(e&4095){case 5:{gT(a,p,f[i+16>>2]|0,x,f[j+16>>2]|0,f[j+48>>2]|0,0,f[k+16>>2]|0,f[k+48>>2]|0,f[v>>2]|0,f[l+48>>2]|0,q,f[n+16>>2]|0,f[n+48>>2]|0,f[m>>2]|0);break}case 6:{hT(a,p,f[i+16>>2]|0,x,f[j+16>>2]|0,f[j+48>>2]|0,0,f[k+16>>2]|0,f[k+48>>2]|0,f[v>>2]|0,f[l+48>>2]|0,q,f[n+16>>2]|0,f[n+48>>2]|0,f[m>>2]|0);break}default:{f[o>>2]=0;f[o+4>>2]=0;bO(-210,o,200378,199958,1577);bD(o)}}o=n+36|0;q=f[o>>2]|0;if(q|0?(x=q+12|0,q=f[x>>2]|0,f[x>>2]=q+-1,(q|0)==1):0)kL(n);f[o>>2]=0;o=n+16|0;q=n+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[q>>2]|0)>0){o=f[n+40>>2]|0;x=0;do{f[o+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[q>>2]|0))}q=f[n+44>>2]|0;if((q|0)!=(n+48|0))UC(q);q=f[m>>2]|0;if((q|0)!=(s|0)){if(q|0)P5b(q);f[m>>2]=s;f[t>>2]=1032}t=l+36|0;s=f[t>>2]|0;if(s|0?(m=s+12|0,s=f[m>>2]|0,f[m>>2]=s+-1,(s|0)==1):0)kL(l);f[t>>2]=0;t=l+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[t>>2]|0)>0){v=f[l+40>>2]|0;s=0;do{f[v+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[t>>2]|0))}t=f[l+44>>2]|0;if((t|0)!=(l+48|0))UC(t);t=k+36|0;l=f[t>>2]|0;do if(l|0){s=l+12|0;v=f[s>>2]|0;f[s>>2]=v+-1;if((v|0)!=1)break;kL(k)}while(0);f[t>>2]=0;t=k+16|0;l=k+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[l>>2]|0)>0){t=f[k+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))UC(l);l=j+36|0;k=f[l>>2]|0;do if(k|0){v=k+12|0;t=f[v>>2]|0;f[v>>2]=t+-1;if((t|0)!=1)break;kL(j)}while(0);f[l>>2]=0;l=j+16|0;k=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[k>>2]|0)>0){l=f[j+40>>2]|0;t=0;do{f[l+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))UC(k);k=i+36|0;j=f[k>>2]|0;do if(j|0){t=j+12|0;l=f[t>>2]|0;f[t>>2]=l+-1;if((l|0)!=1)break;kL(i)}while(0);f[k>>2]=0;k=i+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[c>>2]|0)>0){k=f[i+40>>2]|0;j=0;do{f[k+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[c>>2]|0))}c=f[i+44>>2]|0;if((c|0)==(i+48|0)){u=h;return}UC(c);u=h;return}function dT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+1296|0;g=e+1280|0;h=e+1224|0;i=e+1168|0;j=e+128|0;k=e+72|0;l=e+16|0;m=e;dQ(g,47072);do if((yM(a)|0)==65536){n=f[a+4>>2]|0;f[h>>2]=f[n>>2];o=h+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=h+8|0;f[q>>2]=f[n+8>>2];r=h+12|0;f[r>>2]=f[n+12>>2];f[h+16>>2]=f[n+16>>2];f[h+20>>2]=f[n+20>>2];f[h+24>>2]=f[n+24>>2];f[h+28>>2]=f[n+28>>2];f[h+32>>2]=f[n+32>>2];s=f[n+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=q;t=h+48|0;v=h+44|0;f[v>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(s|0){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;t=f[v>>2]|0;f[t>>2]=f[p>>2];f[t+4>>2]=f[p+4>>2];w=q;x=r;y=h;break}else{f[o>>2]=0;jL(h,n);w=q;x=r;y=h;break}}else{yL(h,a,-1);w=h+8|0;x=h+12|0;y=h}while(0);a=f[y>>2]&4095;y=f[w>>2]|0;if((y|0)!=(f[x>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;z=aD(i,20)|0;A=200221;B=z+20|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,i,200242,199958,1395);bD(i)}x=(a|0)==5;if((a+-5|0)>>>0>=2){f[i>>2]=0;f[i+4>>2]=0;z=aD(i,22)|0;A=200135;B=z+22|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,i,200242,199958,1396);bD(i)}f[i>>2]=1124007936;A=i+4|0;w=i+8|0;r=i+40|0;z=A;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[r>>2]=w;z=i+48|0;B=i+44|0;f[B>>2]=z;f[z>>2]=0;f[i+52>>2]=0;if(PM(d)|0){aM(d,y,y,a,-1,0,0);do if((yM(d)|0)==65536){q=f[d+4>>2]|0;f[j>>2]=f[q>>2];n=j+4|0;o=q+4|0;f[n>>2]=f[o>>2];p=j+8|0;f[p>>2]=f[q+8>>2];f[j+12>>2]=f[q+12>>2];f[j+16>>2]=f[q+16>>2];f[j+20>>2]=f[q+20>>2];f[j+24>>2]=f[q+24>>2];f[j+28>>2]=f[q+28>>2];f[j+32>>2]=f[q+32>>2];t=j+36|0;v=f[q+36>>2]|0;f[t>>2]=v;f[j+40>>2]=p;p=j+48|0;s=j+44|0;f[s>>2]=p;f[p>>2]=0;f[j+52>>2]=0;if(v|0){p=v+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[q+44>>2]|0;p=f[s>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];C=t;break}else{f[n>>2]=0;jL(j,q);C=t;break}}else{yL(j,d,-1);C=j+36|0}while(0);d=f[C>>2]|0;if(d|0){t=d+12|0;f[t>>2]=(f[t>>2]|0)+1}t=i+36|0;d=f[t>>2]|0;if(d|0?(q=d+12|0,d=f[q>>2]|0,f[q>>2]=d+-1,(d|0)==1):0)kL(i);f[t>>2]=0;d=i+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[A>>2]|0)>0){q=f[r>>2]|0;n=0;do{f[q+(n<<2)>>2]=0;n=n+1|0;D=f[A>>2]|0}while((n|0)<(D|0));f[i>>2]=f[j>>2];if((D|0)<3)E=30;else E=32}else{f[i>>2]=f[j>>2];E=30}if((E|0)==30){D=f[j+4>>2]|0;if((D|0)<3){f[A>>2]=D;f[w>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];w=f[j+44>>2]|0;D=f[B>>2]|0;f[D>>2]=f[w>>2];f[D+4>>2]=f[w+4>>2]}else E=32}if((E|0)==32)jL(i,j);E=j+16|0;f[d>>2]=f[E>>2];f[i+20>>2]=f[j+20>>2];f[i+24>>2]=f[j+24>>2];f[i+28>>2]=f[j+28>>2];f[i+32>>2]=f[j+32>>2];d=f[C>>2]|0;f[t>>2]=d;if(d|0?(t=d+12|0,d=f[t>>2]|0,f[t>>2]=d+-1,(d|0)==1):0)kL(j);f[C>>2]=0;C=j+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[C>>2]|0)>0){E=f[j+40>>2]|0;d=0;do{f[E+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[C>>2]|0))}C=f[j+44>>2]|0;if((C|0)!=(j+48|0))UC(C)}C=h+4|0;d=f[C>>2]|0;if((d|0)>0)F=f[(f[h+44>>2]|0)+(d+-1<<2)>>2]|0;else F=0;d=Y(F,y)|0;E=d+15&-16;t=Y(E,y)|0;w=(Y(y*5|0,F)|0)+32+t|0;F=j+8|0;f[j>>2]=F;D=j+4|0;f[D>>2]=w;if(w>>>0>1032){n=N5b(w)|0;f[j>>2]=n;G=n}else G=F;n=G+15&-16;Qi(k,y,y,a,n,E);Qi(l,y,1,a,n+t|0,0);a=n+(t+d)|0;d=m+8|0;f[d>>2]=0;f[d+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=k;SP(h,m);m=k+16|0;d=f[m>>2]|0;if(x)H=eT(d,f[k+48>>2]|0,f[l+16>>2]|0,f[i+16>>2]|0,f[z>>2]|0,y,a)|0;else H=fT(d,f[k+48>>2]|0,f[l+16>>2]|0,f[i+16>>2]|0,f[z>>2]|0,y,a)|0;SP(l,c);c=l+36|0;a=f[c>>2]|0;if(a|0?(y=a+12|0,a=f[y>>2]|0,f[y>>2]=a+-1,(a|0)==1):0)kL(l);f[c>>2]=0;c=l+16|0;a=l+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[l+40>>2]|0;y=0;do{f[c+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[a>>2]|0))}a=f[l+44>>2]|0;if((a|0)!=(l+48|0))UC(a);a=k+36|0;l=f[a>>2]|0;if(l|0?(y=l+12|0,l=f[y>>2]|0,f[y>>2]=l+-1,(l|0)==1):0)kL(k);f[a>>2]=0;a=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[a>>2]|0)>0){m=f[k+40>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[a>>2]|0))}a=f[k+44>>2]|0;if((a|0)!=(k+48|0))UC(a);a=f[j>>2]|0;if((a|0)!=(F|0)){if(a|0)P5b(a);f[j>>2]=F;f[D>>2]=1032}D=i+36|0;F=f[D>>2]|0;if(F|0?(j=F+12|0,F=f[j>>2]|0,f[j>>2]=F+-1,(F|0)==1):0)kL(i);f[D>>2]=0;D=i+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[A>>2]|0)>0){D=f[r>>2]|0;r=0;do{f[D+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[A>>2]|0))}A=f[B>>2]|0;if((A|0)!=(z|0))UC(A);A=h+36|0;z=f[A>>2]|0;if(z|0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0)kL(h);f[A>>2]=0;A=h+16|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[C>>2]|0)>0){A=f[h+40>>2]|0;z=0;do{f[A+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[C>>2]|0))}C=f[h+44>>2]|0;if((C|0)!=(h+48|0))UC(C);if(!(f[g+4>>2]|0)){u=e;return H|0}u=e;return H|0}function eT(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;i=b>>>2;b=(d|0)!=0;if(b){j=e>>>2;if((g|0)>0){k=g<<2;l=0;do{m=Y(j,l)|0;Nac(d+(m<<2)|0,0,k|0)|0;n[d+(m+l<<2)>>2]=1.0;l=l+1|0}while((l|0)!=(g|0));o=j}else o=j}else o=e;e=Y(g*30|0,g)|0;j=h+3&-4;h=j+(g<<2)|0;if((g|0)<=0)return 1;l=i+1|0;k=g+-1|0;m=0;do{p=a+((Y(m,l)|0)<<2)|0;f[c+(m<<2)>>2]=f[p>>2];if((m|0)<(k|0)){p=m+1|0;q=Y(m,i)|0;r=m+2|0;if((r|0)<(g|0)){s=p;t=+L(+(+n[a+(q+p<<2)>>2]));u=r;while(1){v=+L(+(+n[a+(u+q<<2)>>2]));r=t<v;w=r?u:s;u=u+1|0;if((u|0)==(g|0)){x=w;break}else{s=w;t=r?v:t}}}else x=p;f[j+(m<<2)>>2]=x}if((m|0)>0){if((m|0)==1)y=0;else{s=0;t=+L(+(+n[a+(m<<2)>>2]));u=1;while(1){q=a+((Y(u,i)|0)+m<<2)|0;v=+L(+(+n[q>>2]));q=t<v;r=q?u:s;u=u+1|0;if((u|0)>=(m|0)){y=r;break}else{s=r;t=q?v:t}}}f[h+(m<<2)>>2]=y}m=m+1|0}while((m|0)!=(g|0));m=(g|0)>1;y=g+-1|0;if(m&(e|0)>0){x=(y|0)>1;k=(g|0)<1|b^1;l=0;do{s=f[j>>2]|0;t=+L(+(+n[a+(s<<2)>>2]));if(x){u=0;p=1;v=t;do{q=Y(p,i)|0;z=+L(+(+n[a+((f[j+(p<<2)>>2]|0)+q<<2)>>2]));q=v<z;v=q?z:v;u=q?p:u;p=p+1|0}while((p|0)!=(y|0));A=f[j+(u<<2)>>2]|0;B=u;C=1;D=v}else{A=s;B=0;C=1;D=t}while(1){p=f[h+(C<<2)>>2]|0;q=a+((Y(p,i)|0)+C<<2)|0;z=+L(+(+n[q>>2]));q=D<z;A=q?C:A;B=q?p:B;C=C+1|0;if((C|0)==(g|0))break;else D=q?z:D}s=Y(B,i)|0;u=a+(s+A<<2)|0;t=+n[u>>2];v=+L(+t);if(v<=1.1920928955078125e-07)break;q=c+(A<<2)|0;p=c+(B<<2)|0;z=(+n[q>>2]-+n[p>>2])*.5;E=+L(+z);if(!(v>E))if(z!=z|0.0!=0.0|z==0.0)F=0.0;else{G=v/E;H=E;I=G*G;J=38}else{G=E/v;H=v;I=G*G;J=38}if((J|0)==38){J=0;F=H*+M(+(I+1.0))}G=E+F;E=+L(+G);if(!(v>E))if(G!=G|0.0!=0.0|G==0.0)K=0.0;else{N=v/E;O=E;P=N*N;J=43}else{N=E/v;O=v;P=N*N;J=43}if((J|0)==43){J=0;K=O*+M(+(P+1.0))}N=G/K;v=t/K;E=t*(t/G);r=z<0.0;z=r?-E:E;E=r?-v:v;n[u>>2]=0.0;n[p>>2]=+n[p>>2]-z;n[q>>2]=z+ +n[q>>2];q=(B|0)>0;if(q){p=0;do{u=Y(p,i)|0;r=a+(u+B<<2)|0;z=+n[r>>2];w=a+(u+A<<2)|0;v=+n[w>>2];n[r>>2]=N*z-E*v;n[w>>2]=E*z+N*v;p=p+1|0}while((p|0)!=(B|0))}p=B+1|0;if((p|0)<(A|0)){w=p;do{r=a+(w+s<<2)|0;v=+n[r>>2];u=a+((Y(w,i)|0)+A<<2)|0;z=+n[u>>2];n[r>>2]=N*v-E*z;n[u>>2]=E*v+N*z;w=w+1|0}while((w|0)!=(A|0))}w=A+1|0;if((w|0)<(g|0)){u=Y(A,i)|0;r=w;do{Q=a+(r+s<<2)|0;z=+n[Q>>2];R=a+(r+u<<2)|0;v=+n[R>>2];n[Q>>2]=N*z-E*v;n[R>>2]=E*z+N*v;r=r+1|0}while((r|0)!=(g|0))}if(!k){r=Y(B,o)|0;u=Y(A,o)|0;R=0;do{Q=d+(R+r<<2)|0;v=+n[Q>>2];S=d+(R+u<<2)|0;z=+n[S>>2];n[Q>>2]=N*v-E*z;n[S>>2]=E*v+N*z;R=R+1|0}while((R|0)!=(g|0))}if((B|0)<(y|0)){R=B+2|0;if((R|0)<(g|0)){u=p;N=+L(+(+n[a+(s+p<<2)>>2]));r=R;while(1){E=+L(+(+n[a+(r+s<<2)>>2]));R=N<E;S=R?r:u;r=r+1|0;if((r|0)==(g|0)){T=S;break}else{u=S;N=R?E:N}}}else T=p;f[j+(B<<2)>>2]=T}if(q){if((B|0)==1)U=0;else{N=+L(+(+n[a+(B<<2)>>2]));u=1;r=0;while(1){s=a+((Y(u,i)|0)+B<<2)|0;E=+L(+(+n[s>>2]));s=N<E;R=s?u:r;u=u+1|0;if((u|0)>=(B|0)){U=R;break}else{N=s?E:N;r=R}}}f[h+(B<<2)>>2]=U}if((A|0)<(y|0)){r=Y(A,i)|0;u=A+2|0;if((u|0)<(g|0)){q=w;N=+L(+(+n[a+(r+w<<2)>>2]));p=u;while(1){E=+L(+(+n[a+(p+r<<2)>>2]));u=N<E;R=u?p:q;p=p+1|0;if((p|0)==(g|0)){V=R;break}else{q=R;N=u?E:N}}}else V=w;f[j+(A<<2)>>2]=V}if((A|0)>0){if((A|0)==1)W=0;else{N=+L(+(+n[a+(A<<2)>>2]));q=1;p=0;while(1){r=a+((Y(q,i)|0)+A<<2)|0;E=+L(+(+n[r>>2]));r=N<E;u=r?q:p;q=q+1|0;if((q|0)>=(A|0)){W=u;break}else{N=r?E:N;p=u}}}f[h+(A<<2)>>2]=W}l=l+1|0}while((l|0)<(e|0));if(!m)return 1}else if(!m)return 1;if(b)X=0;else{b=0;do{m=b;b=b+1|0;if((b|0)<(g|0)){e=b;l=m;while(1){W=+n[c+(l<<2)>>2]<+n[c+(e<<2)>>2]?e:l;e=e+1|0;if((e|0)==(g|0)){Z=W;break}else l=W}}else Z=m;if((m|0)!=(Z|0)){l=c+(Z<<2)|0;e=c+(m<<2)|0;W=f[l>>2]|0;f[l>>2]=f[e>>2];f[e>>2]=W}}while((b|0)!=(y|0));return 1}do{b=X;X=X+1|0;if((X|0)<(g|0)){Z=X;W=b;while(1){e=+n[c+(W<<2)>>2]<+n[c+(Z<<2)>>2]?Z:W;Z=Z+1|0;if((Z|0)==(g|0)){_=e;break}else W=e}}else _=b;if((b|0)!=(_|0)){W=c+(_<<2)|0;Z=c+(b<<2)|0;m=f[W>>2]|0;f[W>>2]=f[Z>>2];f[Z>>2]=m;m=Y(_,o)|0;Z=Y(b,o)|0;W=0;do{e=d+(W+m<<2)|0;l=d+(W+Z<<2)|0;A=f[e>>2]|0;f[e>>2]=f[l>>2];f[l>>2]=A;W=W+1|0}while((W|0)!=(g|0))}}while((X|0)!=(y|0));return 1}function fT(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;i=b>>>3;b=(d|0)!=0;if(b){j=e>>>3;if((g|0)>0){k=g<<3;l=0;do{m=Y(j,l)|0;Nac(d+(m<<3)|0,0,k|0)|0;p[d+(m+l<<3)>>3]=1.0;l=l+1|0}while((l|0)!=(g|0));n=j}else n=j}else n=e;e=Y(g*30|0,g)|0;j=h+3&-4;h=j+(g<<2)|0;if((g|0)<=0)return 1;l=i+1|0;k=g+-1|0;m=0;do{o=a+((Y(m,l)|0)<<3)|0;p[c+(m<<3)>>3]=+p[o>>3];if((m|0)<(k|0)){o=m+1|0;q=Y(m,i)|0;r=m+2|0;if((r|0)<(g|0)){s=o;t=+L(+(+p[a+(q+o<<3)>>3]));u=r;while(1){v=+L(+(+p[a+(u+q<<3)>>3]));r=t<v;w=r?u:s;u=u+1|0;if((u|0)==(g|0)){x=w;break}else{s=w;t=r?v:t}}}else x=o;f[j+(m<<2)>>2]=x}if((m|0)>0){if((m|0)==1)y=0;else{s=0;t=+L(+(+p[a+(m<<3)>>3]));u=1;while(1){q=a+((Y(u,i)|0)+m<<3)|0;v=+L(+(+p[q>>3]));q=t<v;r=q?u:s;u=u+1|0;if((u|0)>=(m|0)){y=r;break}else{s=r;t=q?v:t}}}f[h+(m<<2)>>2]=y}m=m+1|0}while((m|0)!=(g|0));m=(g|0)>1;y=g+-1|0;if(m&(e|0)>0){x=(y|0)>1;k=(g|0)<1|b^1;l=0;do{s=f[j>>2]|0;t=+L(+(+p[a+(s<<3)>>3]));if(x){u=0;o=1;v=t;do{q=Y(o,i)|0;z=+L(+(+p[a+((f[j+(o<<2)>>2]|0)+q<<3)>>3]));q=v<z;v=q?z:v;u=q?o:u;o=o+1|0}while((o|0)!=(y|0));A=f[j+(u<<2)>>2]|0;B=u;C=1;D=v}else{A=s;B=0;C=1;D=t}while(1){o=f[h+(C<<2)>>2]|0;q=a+((Y(o,i)|0)+C<<3)|0;z=+L(+(+p[q>>3]));q=D<z;A=q?C:A;B=q?o:B;C=C+1|0;if((C|0)==(g|0))break;else D=q?z:D}s=Y(B,i)|0;u=a+(s+A<<3)|0;t=+p[u>>3];v=+L(+t);if(v<=2.220446049250313e-16)break;q=c+(A<<3)|0;o=c+(B<<3)|0;z=(+p[q>>3]-+p[o>>3])*.5;E=+L(+z);if(!(v>E))if(z!=z|0.0!=0.0|z==0.0)F=0.0;else{G=v/E;H=E;I=G*G;J=38}else{G=E/v;H=v;I=G*G;J=38}if((J|0)==38){J=0;F=H*+M(+(I+1.0))}G=E+F;E=+L(+G);if(!(v>E))if(G!=G|0.0!=0.0|G==0.0)K=0.0;else{N=v/E;O=E;P=N*N;J=43}else{N=E/v;O=v;P=N*N;J=43}if((J|0)==43){J=0;K=O*+M(+(P+1.0))}N=G/K;v=t/K;E=t*(t/G);r=z<0.0;z=r?-E:E;E=r?-v:v;p[u>>3]=0.0;p[o>>3]=+p[o>>3]-z;p[q>>3]=z+ +p[q>>3];q=(B|0)>0;if(q){o=0;do{u=Y(o,i)|0;r=a+(u+B<<3)|0;z=+p[r>>3];w=a+(u+A<<3)|0;v=+p[w>>3];p[r>>3]=N*z-E*v;p[w>>3]=E*z+N*v;o=o+1|0}while((o|0)!=(B|0))}o=B+1|0;if((o|0)<(A|0)){w=o;do{r=a+(w+s<<3)|0;v=+p[r>>3];u=a+((Y(w,i)|0)+A<<3)|0;z=+p[u>>3];p[r>>3]=N*v-E*z;p[u>>3]=E*v+N*z;w=w+1|0}while((w|0)!=(A|0))}w=A+1|0;if((w|0)<(g|0)){u=Y(A,i)|0;r=w;do{Q=a+(r+s<<3)|0;z=+p[Q>>3];R=a+(r+u<<3)|0;v=+p[R>>3];p[Q>>3]=N*z-E*v;p[R>>3]=E*z+N*v;r=r+1|0}while((r|0)!=(g|0))}if(!k){r=Y(B,n)|0;u=Y(A,n)|0;R=0;do{Q=d+(R+r<<3)|0;v=+p[Q>>3];S=d+(R+u<<3)|0;z=+p[S>>3];p[Q>>3]=N*v-E*z;p[S>>3]=E*v+N*z;R=R+1|0}while((R|0)!=(g|0))}if((B|0)<(y|0)){R=B+2|0;if((R|0)<(g|0)){u=o;N=+L(+(+p[a+(s+o<<3)>>3]));r=R;while(1){E=+L(+(+p[a+(r+s<<3)>>3]));R=N<E;S=R?r:u;r=r+1|0;if((r|0)==(g|0)){T=S;break}else{u=S;N=R?E:N}}}else T=o;f[j+(B<<2)>>2]=T}if(q){if((B|0)==1)U=0;else{N=+L(+(+p[a+(B<<3)>>3]));u=1;r=0;while(1){s=a+((Y(u,i)|0)+B<<3)|0;E=+L(+(+p[s>>3]));s=N<E;R=s?u:r;u=u+1|0;if((u|0)>=(B|0)){U=R;break}else{N=s?E:N;r=R}}}f[h+(B<<2)>>2]=U}if((A|0)<(y|0)){r=Y(A,i)|0;u=A+2|0;if((u|0)<(g|0)){q=w;N=+L(+(+p[a+(r+w<<3)>>3]));o=u;while(1){E=+L(+(+p[a+(o+r<<3)>>3]));u=N<E;R=u?o:q;o=o+1|0;if((o|0)==(g|0)){V=R;break}else{q=R;N=u?E:N}}}else V=w;f[j+(A<<2)>>2]=V}if((A|0)>0){if((A|0)==1)W=0;else{N=+L(+(+p[a+(A<<3)>>3]));q=1;o=0;while(1){r=a+((Y(q,i)|0)+A<<3)|0;E=+L(+(+p[r>>3]));r=N<E;u=r?q:o;q=q+1|0;if((q|0)>=(A|0)){W=u;break}else{N=r?E:N;o=u}}}f[h+(A<<2)>>2]=W}l=l+1|0}while((l|0)<(e|0));if(!m)return 1}else if(!m)return 1;if(b)X=0;else{b=0;do{m=b;b=b+1|0;if((b|0)<(g|0)){e=b;l=m;while(1){W=+p[c+(l<<3)>>3]<+p[c+(e<<3)>>3]?e:l;e=e+1|0;if((e|0)==(g|0)){Z=W;break}else l=W}}else Z=m;if((m|0)!=(Z|0)){l=c+(Z<<3)|0;e=c+(m<<3)|0;K=+p[l>>3];p[l>>3]=+p[e>>3];p[e>>3]=K}}while((b|0)!=(y|0));return 1}do{b=X;X=X+1|0;if((X|0)<(g|0)){Z=X;e=b;while(1){l=+p[c+(e<<3)>>3]<+p[c+(Z<<3)>>3]?Z:e;Z=Z+1|0;if((Z|0)==(g|0)){_=l;break}else e=l}}else _=b;if((b|0)!=(_|0)){e=c+(_<<3)|0;Z=c+(b<<3)|0;K=+p[e>>3];p[e>>3]=+p[Z>>3];p[Z>>3]=K;Z=Y(_,n)|0;e=Y(b,n)|0;m=0;do{l=d+(m+Z<<3)|0;W=d+(m+e<<3)|0;K=+p[l>>3];p[l>>3]=+p[W>>3];p[W>>3]=K;m=m+1|0}while((m|0)!=(g|0))}}while((X|0)!=(y|0));return 1}function gT(a,b,c,d,e,f,g,h,i,j,k,l,m,o,q){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;r=(d|0)==0?1:d>>>2;d=f>>>2;f=i>>>2;i=k>>>2;k=o>>>2;o=q+7&-8;q=o;s=o;o=g?d:1;t=g?1:d;d=(b|0)<(a|0)?b:a;g=(j|0)!=0;u=g?l:a;l=(b|0)>0;v=(u|0)>0;if(l&v){w=u<<2;x=0;do{Nac(m+((Y(x,k)|0)<<2)|0,0,w|0)|0;x=x+1|0}while((x|0)!=(b|0))}if((d|0)>0){y=0.0;z=0}else return;do{x=c+((Y(z,r)|0)<<2)|0;y=y+ +n[x>>2];z=z+1|0}while((z|0)<(d|0));A=y*4.440892098500626e-16;z=(u|0)==1;x=(a|0)>0;w=u+-4|0;B=(u|0)<4;C=u&-4;D=(C|0)<(u|0);E=u<<3;F=e;e=h;h=0;while(1){G=c+((Y(h,r)|0)<<2)|0;y=+n[G>>2];a:do if(!(+L(+y)<=A)){H=1.0/y;if(z){if(g)if(x){I=0.0;G=0;while(1){J=F+((Y(G,t)|0)<<2)|0;K=j+((Y(G,i)|0)<<2)|0;M=I+ +n[J>>2]*+n[K>>2];G=G+1|0;if((G|0)==(a|0)){N=M;break}else I=M}}else N=0.0;else N=+n[F>>2];I=H*N;if(l)O=0;else break;while(1){G=m+((Y(O,k)|0)<<2)|0;n[G>>2]=+n[G>>2]+I*+n[e+(O<<2)>>2];O=O+1|0;if((O|0)==(b|0))break a}}b:do if(g){if(v)Nac(q|0,0,E|0)|0;c:do if(x){if(B){if(v){P=j;Q=0}else break b;while(1){G=F+((Y(Q,t)|0)<<2)|0;I=+n[G>>2];G=0;do{K=s+(G<<3)|0;p[K>>3]=+p[K>>3]+I*+n[P+(G<<2)>>2];G=G+1|0}while((G|0)!=(u|0));Q=Q+1|0;if((Q|0)==(a|0))break c;else P=P+(i<<2)|0}}if(D){R=j;S=0}else{G=j;K=0;while(1){J=F+((Y(K,t)|0)<<2)|0;I=+n[J>>2];J=0;do{T=s+(J<<3)|0;U=J|1;V=s+(U<<3)|0;M=+p[V>>3]+I*+n[G+(U<<2)>>2];p[T>>3]=+p[T>>3]+I*+n[G+(J<<2)>>2];p[V>>3]=M;V=J|2;T=s+(V<<3)|0;U=J|3;W=s+(U<<3)|0;M=+p[W>>3]+I*+n[G+(U<<2)>>2];p[T>>3]=+p[T>>3]+I*+n[G+(V<<2)>>2];p[W>>3]=M;J=J+4|0}while((J|0)<=(w|0));K=K+1|0;if((K|0)==(a|0))break c;else G=G+(i<<2)|0}}while(1){G=F+((Y(S,t)|0)<<2)|0;I=+n[G>>2];G=0;do{K=s+(G<<3)|0;J=G|1;W=s+(J<<3)|0;M=+p[W>>3]+I*+n[R+(J<<2)>>2];p[K>>3]=+p[K>>3]+I*+n[R+(G<<2)>>2];p[W>>3]=M;W=G|2;K=s+(W<<3)|0;J=G|3;V=s+(J<<3)|0;M=+p[V>>3]+I*+n[R+(J<<2)>>2];p[K>>3]=+p[K>>3]+I*+n[R+(W<<2)>>2];p[V>>3]=M;G=G+4|0}while((G|0)<=(w|0));X=C;do{G=s+(X<<3)|0;p[G>>3]=+p[G>>3]+I*+n[R+(X<<2)>>2];X=X+1|0}while((X|0)!=(u|0));S=S+1|0;if((S|0)==(a|0))break;else R=R+(i<<2)|0}}while(0);if(v){G=0;do{V=s+(G<<3)|0;p[V>>3]=H*+p[V>>3];G=G+1|0}while((G|0)!=(u|0))}}else if(v){G=0;do{V=F+((Y(G,t)|0)<<2)|0;p[s+(G<<3)>>3]=H*+n[V>>2];G=G+1|0}while((G|0)!=(u|0))}while(0);if(l){if(B){if(v){Z=m;_=0}else break;while(1){H=+n[e+(_<<2)>>2];G=0;do{V=Z+(G<<2)|0;n[V>>2]=+n[V>>2]+H*+p[s+(G<<3)>>3];G=G+1|0}while((G|0)!=(u|0));_=_+1|0;if((_|0)==(b|0))break a;else Z=Z+(k<<2)|0}}if(D){$=m;aa=0}else{G=m;V=0;while(1){H=+n[e+(V<<2)>>2];W=0;do{K=G+(W<<2)|0;J=W|1;T=G+(J<<2)|0;I=+n[T>>2]+H*+p[s+(J<<3)>>3];n[K>>2]=+n[K>>2]+H*+p[s+(W<<3)>>3];n[T>>2]=I;T=W|2;K=G+(T<<2)|0;J=W|3;U=G+(J<<2)|0;I=+n[U>>2]+H*+p[s+(J<<3)>>3];n[K>>2]=+n[K>>2]+H*+p[s+(T<<3)>>3];n[U>>2]=I;W=W+4|0}while((W|0)<=(w|0));V=V+1|0;if((V|0)==(b|0))break a;else G=G+(k<<2)|0}}while(1){H=+n[e+(aa<<2)>>2];G=0;do{V=$+(G<<2)|0;W=G|1;U=$+(W<<2)|0;I=+n[U>>2]+H*+p[s+(W<<3)>>3];n[V>>2]=+n[V>>2]+H*+p[s+(G<<3)>>3];n[U>>2]=I;U=G|2;V=$+(U<<2)|0;W=G|3;T=$+(W<<2)|0;I=+n[T>>2]+H*+p[s+(W<<3)>>3];n[V>>2]=+n[V>>2]+H*+p[s+(U<<3)>>3];n[T>>2]=I;G=G+4|0}while((G|0)<=(w|0));ba=C;do{G=$+(ba<<2)|0;n[G>>2]=+n[G>>2]+H*+p[s+(ba<<3)>>3];ba=ba+1|0}while((ba|0)!=(u|0));aa=aa+1|0;if((aa|0)==(b|0))break;else $=$+(k<<2)|0}}}while(0);h=h+1|0;if((h|0)>=(d|0))break;else{F=F+(o<<2)|0;e=e+(f<<2)|0}}return}function hT(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0;q=(d|0)==0?1:d>>>3;d=f>>>3;f=i>>>3;i=k>>>3;k=n>>>3;n=o+7&-8;o=n;r=n;n=g?d:1;s=g?1:d;d=(b|0)<(a|0)?b:a;g=(j|0)!=0;t=g?l:a;l=(b|0)>0;u=(t|0)>0;if(l&u){v=t<<3;w=0;do{Nac(m+((Y(w,k)|0)<<3)|0,0,v|0)|0;w=w+1|0}while((w|0)!=(b|0))}if((d|0)>0){x=0.0;y=0}else return;do{w=c+((Y(y,q)|0)<<3)|0;x=x+ +p[w>>3];y=y+1|0}while((y|0)<(d|0));z=x*4.440892098500626e-16;y=(t|0)==1;w=(a|0)>0;v=t<<3;A=e;e=h;h=0;while(1){B=c+((Y(h,q)|0)<<3)|0;x=+p[B>>3];a:do if(!(+L(+x)<=z)){C=1.0/x;if(y){if(g)if(w){D=0.0;B=0;while(1){E=A+((Y(B,s)|0)<<3)|0;F=j+((Y(B,i)|0)<<3)|0;G=D+ +p[E>>3]*+p[F>>3];B=B+1|0;if((B|0)==(a|0)){H=G;break}else D=G}}else H=0.0;else H=+p[A>>3];D=C*H;if(l)I=0;else break;while(1){B=m+((Y(I,k)|0)<<3)|0;p[B>>3]=+p[B>>3]+D*+p[e+(I<<3)>>3];I=I+1|0;if((I|0)==(b|0))break a}}do if(!g){if(u){B=0;do{F=A+((Y(B,s)|0)<<3)|0;p[r+(B<<3)>>3]=C*+p[F>>3];B=B+1|0}while((B|0)!=(t|0))}}else{if(!u){iT(a,t,j,i,A,s,r,0);break}Nac(o|0,0,v|0)|0;iT(a,t,j,i,A,s,r,0);B=0;do{F=r+(B<<3)|0;p[F>>3]=C*+p[F>>3];B=B+1|0}while((B|0)!=(t|0))}while(0);iT(b,t,r,0,e,1,m,k)}while(0);h=h+1|0;if((h|0)>=(d|0))break;else{A=A+(n<<3)|0;e=e+(f<<3)|0}}return}function iT(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0.0,t=0;if((a|0)<=0)return;i=b+-4|0;if((b|0)<4){j=(b|0)>0;k=g;l=0;m=c;while(1){n=e+((Y(l,f)|0)<<3)|0;o=+p[n>>3];if(j){n=0;do{q=k+(n<<3)|0;p[q>>3]=+p[q>>3]+o*+p[m+(n<<3)>>3];n=n+1|0}while((n|0)!=(b|0))}l=l+1|0;if((l|0)==(a|0))break;else{k=k+(h<<3)|0;m=m+(d<<3)|0}}return}m=b&-4;k=(m|0)<(b|0);l=g;g=0;j=c;while(1){c=e+((Y(g,f)|0)<<3)|0;o=+p[c>>3];c=0;do{n=l+(c<<3)|0;q=c|1;r=l+(q<<3)|0;s=+p[r>>3]+o*+p[j+(q<<3)>>3];p[n>>3]=+p[n>>3]+o*+p[j+(c<<3)>>3];p[r>>3]=s;r=c|2;n=l+(r<<3)|0;q=c|3;t=l+(q<<3)|0;s=+p[t>>3]+o*+p[j+(q<<3)>>3];p[n>>3]=+p[n>>3]+o*+p[j+(r<<3)>>3];p[t>>3]=s;c=c+4|0}while((c|0)<=(i|0));if(k){c=m;do{t=l+(c<<3)|0;p[t>>3]=+p[t>>3]+o*+p[j+(c<<3)>>3];c=c+1|0}while((c|0)!=(b|0))}g=g+1|0;if((g|0)==(a|0))break;else{l=l+(h<<3)|0;j=j+(d<<3)|0}}return}function jT(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;g=u;u=u+1680|0;h=g;i=g+1624|0;j=g+1616|0;k=g+1560|0;l=g+1504|0;m=g+464|0;o=g+408|0;q=g+352|0;r=g+240|0;s=g+184|0;t=g+128|0;v=g+72|0;w=g+56|0;x=g+296|0;dQ(j,47092);do if((yM(a)|0)==65536){y=f[a+4>>2]|0;f[k>>2]=f[y>>2];z=k+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=k+8|0;f[B>>2]=f[y+8>>2];f[k+12>>2]=f[y+12>>2];f[k+16>>2]=f[y+16>>2];f[k+20>>2]=f[y+20>>2];f[k+24>>2]=f[y+24>>2];f[k+28>>2]=f[y+28>>2];f[k+32>>2]=f[y+32>>2];C=f[y+36>>2]|0;f[k+36>>2]=C;f[k+40>>2]=B;B=k+48|0;D=k+44|0;f[D>>2]=B;f[B>>2]=0;f[k+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;jL(k,y);break}}else yL(k,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[l>>2]=f[a>>2];y=l+4|0;z=a+4|0;f[y>>2]=f[z>>2];A=l+8|0;f[A>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];B=f[a+36>>2]|0;f[l+36>>2]=B;f[l+40>>2]=A;A=l+48|0;D=l+44|0;f[D>>2]=A;f[A>>2]=0;f[l+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;A=f[D>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];E=l;break}else{f[y>>2]=0;jL(l,a);E=l;break}}else{yL(l,c,-1);E=l}while(0);c=f[k>>2]|0;a=c&4095;y=(e&16|0)!=0;if(!((a+-5|0)>>>0<2?(a|0)==(f[E>>2]&4095|0):0)){f[h>>2]=0;f[h+4>>2]=0;F=aD(h,48)|0;G=200711;H=F+48|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,h,200760,199958,1100);bD(h)}z=e&-17;a:do switch(e|0){case 0:case 3:case 16:case 19:{if(!y?(f[k+8>>2]|0)!=(f[k+12>>2]|0):0){f[h>>2]=0;f[h+4>>2]=0;F=aD(h,87)|0;G=200766;H=F+87|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,h,200760,199958,1104);bD(h)}switch(e|0){case 0:case 3:case 16:case 19:break;default:{I=58;break a}}if(((!y?(A=k+8|0,D=f[A>>2]|0,(D|0)<4):0)?(D|0)==(f[k+12>>2]|0):0)?(f[l+12>>2]|0)==1:0){aM(d,D,1,f[k>>2]&4095,-1,0,0);do if((yM(d)|0)==65536){D=f[d+4>>2]|0;f[h>>2]=f[D>>2];B=h+4|0;C=D+4|0;f[B>>2]=f[C>>2];J=h+8|0;f[J>>2]=f[D+8>>2];f[h+12>>2]=f[D+12>>2];K=h+16|0;f[K>>2]=f[D+16>>2];f[h+20>>2]=f[D+20>>2];f[h+24>>2]=f[D+24>>2];f[h+28>>2]=f[D+28>>2];f[h+32>>2]=f[D+32>>2];L=f[D+36>>2]|0;f[h+36>>2]=L;f[h+40>>2]=J;J=h+48|0;M=h+44|0;f[M>>2]=J;f[J>>2]=0;f[h+52>>2]=0;if(L|0){N=L+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[C>>2]|0)<3){C=f[D+44>>2]|0;N=f[M>>2]|0;f[N>>2]=f[C>>2];f[N+4>>2]=f[C+4>>2];O=K;P=M;Q=J;break}else{f[B>>2]=0;jL(h,D);O=K;P=M;Q=J;break}}else{yL(h,d,-1);O=h+16|0;P=h+44|0;Q=h+48|0}while(0);J=f[k+16>>2]|0;M=f[l+16>>2]|0;K=f[O>>2]|0;D=f[k+48>>2]|0;B=f[l+48>>2]|0;C=f[Q>>2]|0;N=(a|0)==5;b:do switch(f[A>>2]|0){case 2:{if(N){R=+n[J>>2];L=J+D|0;S=+n[L+4>>2];T=+n[J+4>>2];U=+n[L>>2];V=R*S-T*U;if(!(V!=0.0)){W=0;break b}X=1.0/V;V=+n[M>>2];Z=+n[M+B>>2];n[K+C>>2]=X*(R*Z-U*V);n[K>>2]=X*(S*V-T*Z);W=1;break b}else{Z=+p[J>>3];L=J+D|0;T=+p[L+8>>3];V=+p[J+8>>3];S=+p[L>>3];X=Z*T-V*S;if(!(X!=0.0)){W=0;break b}U=1.0/X;X=+p[M>>3];R=+p[M+B>>3];p[K+C>>3]=U*(Z*R-S*X);p[K>>3]=U*(T*X-V*R);W=1;break b}break}case 3:{L=D<<1;if(N){R=+n[J>>2];_=J+D|0;V=+n[_+4>>2];$=J+L|0;X=+n[$+8>>2];T=X;U=+n[_+8>>2];S=+n[$+4>>2];Z=V*T-U*S;aa=+n[J+4>>2];ba=+n[_>>2];ca=+n[$>>2];da=T*ba-U*ca;ea=+n[J+8>>2];fa=S*ba-V*ca;ga=ea*fa+(R*Z-aa*da);if(!(ga!=0.0)){W=0;break b}ha=1.0/ga;ga=+n[M>>2];ia=+n[M+B>>2];ja=ia;ka=+n[M+(B<<1)>>2];la=U*ka;U=S*ja;S=V*ka;V=ba*ka-ca*ja;n[K>>2]=ha*(ea*(U-S)+(Z*ga-aa*(T*ja-la)));n[K+C>>2]=ha*(ea*V+(R*(X*ia-la)-da*ga));n[K+(C<<1)>>2]=ha*(fa*ga+(R*(S-U)-aa*V));W=1;break b}else{V=+p[J>>3];$=J+D|0;aa=+p[$+8>>3];_=J+L|0;U=+p[_+16>>3];S=+p[$+16>>3];R=+p[_+8>>3];ga=aa*U-S*R;fa=+p[J+8>>3];ha=+p[$>>3];da=U*ha;la=+p[_>>3];ia=S*la;X=+p[J+16>>3];ea=R*ha-aa*la;ja=X*ea+(V*ga-fa*(da-ia));if(!(ja!=0.0)){W=0;break b}T=1.0/ja;ja=+p[M>>3];Z=+p[M+B>>3];ca=+p[M+(B<<1)>>3];p[K>>3]=T*(ga*ja+(R*X-U*fa)*Z+(S*fa-aa*X)*ca);p[K+C>>3]=T*((ia-da)*ja+(V*U-la*X)*Z+(ha*X-V*S)*ca);p[K+(C<<1)>>3]=T*(ea*ja+(fa*la-V*R)*Z+(V*aa-fa*ha)*ca);W=1;break b}break}default:if(N){ca=+n[J>>2];if(!(ca!=0.0)){W=0;break b}n[K>>2]=+n[M>>2]/ca;W=1;break b}else{ca=+p[J>>3];if(!(ca!=0.0)){W=0;break b}p[K>>3]=+p[M>>3]/ca;W=1;break b}}while(0);M=h+36|0;K=f[M>>2]|0;if(K|0?(J=K+12|0,K=f[J>>2]|0,f[J>>2]=K+-1,(K|0)==1):0)kL(h);f[M>>2]=0;M=h+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[M>>2]|0)>0){K=f[h+40>>2]|0;J=0;do{f[K+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[M>>2]|0))}M=f[P>>2]|0;if((M|0)!=(Q|0))UC(M);ma=W;na=l+36|0}else I=58;break}default:I=58}while(0);if((I|0)==58){W=f[k+8>>2]|0;Q=k+12|0;P=f[Q>>2]|0;O=f[l+12>>2]|0;M=(c>>>3&511)+1<<(47696>>>(a<<1&14)&3);c=Y(P,M)|0;J=c+15&-16;K=(Y(W,M)|0)+15&-16;N=(e|0)!=1?J:K;K=m+8|0;f[m>>2]=K;C=m+4|0;f[C>>2]=1032;f[o>>2]=f[E>>2];E=o+4|0;B=l+4|0;D=f[B>>2]|0;f[E>>2]=D;A=o+8|0;f[A>>2]=f[l+8>>2];_=o+12|0;f[_>>2]=O;$=o+16|0;f[$>>2]=f[l+16>>2];L=o+20|0;f[L>>2]=f[l+20>>2];oa=o+24|0;f[oa>>2]=f[l+24>>2];pa=o+28|0;f[pa>>2]=f[l+28>>2];qa=o+32|0;f[qa>>2]=f[l+32>>2];ra=o+36|0;sa=l+36|0;ta=f[sa>>2]|0;f[ra>>2]=ta;ua=o+40|0;f[ua>>2]=A;va=o+48|0;wa=o+44|0;f[wa>>2]=va;f[va>>2]=0;f[o+52>>2]=0;if(!ta)xa=D;else{D=ta+12|0;f[D>>2]=(f[D>>2]|0)+1;xa=f[B>>2]|0}if((xa|0)<3){xa=f[l+44>>2]|0;B=f[wa>>2]|0;f[B>>2]=f[xa>>2];f[B+4>>2]=f[xa+4>>2]}else{f[E>>2]=0;jL(o,l)}aM(d,f[Q>>2]|0,f[_>>2]|0,f[k>>2]&4095,-1,0,0);do if((yM(d)|0)==65536){Q=f[d+4>>2]|0;f[q>>2]=f[Q>>2];xa=q+4|0;B=Q+4|0;f[xa>>2]=f[B>>2];D=q+8|0;f[D>>2]=f[Q+8>>2];f[q+12>>2]=f[Q+12>>2];f[q+16>>2]=f[Q+16>>2];f[q+20>>2]=f[Q+20>>2];f[q+24>>2]=f[Q+24>>2];f[q+28>>2]=f[Q+28>>2];f[q+32>>2]=f[Q+32>>2];ta=f[Q+36>>2]|0;f[q+36>>2]=ta;f[q+40>>2]=D;D=q+48|0;ya=q+44|0;f[ya>>2]=D;f[D>>2]=0;f[q+52>>2]=0;if(ta|0){D=ta+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[B>>2]|0)<3){B=f[Q+44>>2]|0;D=f[ya>>2]|0;f[D>>2]=f[B>>2];f[D+4>>2]=f[B+4>>2];break}else{f[xa>>2]=0;jL(q,Q);break}}else yL(q,d,-1);while(0);if((W|0)<(P|0)){f[h>>2]=0;f[h+4>>2]=0;F=aD(h,58)|0;G=200854;H=F+58|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-5,h,200760,199958,1250);bD(h)}G=(W|0)==(P|0);if(G){za=z;Aa=0;Ba=W}else{za=(e|0)==17?2:z;Aa=y;Ba=y?P:W}y=(za|0)==1;z=Y(Aa|y?P:W,N)|0;e=Y(c,O)|0;c=(Aa?e+32|0:32)+z|0;d=(za|0)==2;if((za+-1|0)>>>0<2)Ca=(O<<3)+32+(Y(J+(M*5|0)|0,P)|0)+c|0;else Ca=c;if((f[C>>2]|0)>>>0<Ca>>>0){c=f[m>>2]|0;if((c|0)==(K|0))Da=c;else{if(c|0)P5b(c);f[m>>2]=K;f[C>>2]=1032;Da=K}f[C>>2]=Ca;if(Ca>>>0>1032){c=N5b(Ca)|0;f[m>>2]=c;Ea=c}else Ea=Da}else{f[C>>2]=Ca;Ea=f[m>>2]|0}Ca=Ea+15&-16;Qi(r,Ba,P,a,Ca,N);c:do if(Aa){f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=k;Ea=i+8|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=r;YX(h,i,1,UM()|0,1.0,-1);Ea=Ca+z|0;switch(za|0){case 0:case 3:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=k;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;f[t>>2]=1124007936;Da=t+4|0;c=t+8|0;Q=t+40|0;F=Da;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[Q>>2]=c;xa=t+48|0;B=t+44|0;f[B>>2]=xa;f[xa>>2]=0;f[t+52>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s>>2]=16842752;f[s+4>>2]=t;D=v+8|0;f[D>>2]=0;f[D+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=q;CX(h,i,1.0,s,0.0,v,1);D=t+36|0;ya=f[D>>2]|0;if(ya|0?(ta=ya+12|0,ya=f[ta>>2]|0,f[ta>>2]=ya+-1,(ya|0)==1):0)kL(t);f[D>>2]=0;D=t+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[Da>>2]|0)>0){D=f[Q>>2]|0;ya=0;do{f[D+(ya<<2)>>2]=0;ya=ya+1|0}while((ya|0)<(f[Da>>2]|0))}Da=f[B>>2]|0;if((Da|0)!=(xa|0))UC(Da);Fa=Ea;break c;break}default:{}}Qi(h,P,O,a,Ea,0);Da=Ca+z+e|0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=k;f[s+8>>2]=0;f[s+12>>2]=0;f[s>>2]=16842752;f[s+4>>2]=o;f[v>>2]=1124007936;ya=v+4|0;D=v+8|0;Q=v+40|0;F=ya;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[Q>>2]=D;Ea=v+48|0;xa=v+44|0;f[xa>>2]=Ea;f[Ea>>2]=0;f[v+52>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t>>2]=16842752;f[t+4>>2]=v;B=w+8|0;f[B>>2]=0;f[B+4>>2]=0;f[w>>2]=33619968;f[w+4>>2]=h;CX(i,s,1.0,t,0.0,w,1);B=v+36|0;c=f[B>>2]|0;if(c|0?(ta=c+12|0,c=f[ta>>2]|0,f[ta>>2]=c+-1,(c|0)==1):0)kL(v);f[B>>2]=0;B=v+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[ya>>2]|0)>0){B=f[Q>>2]|0;c=0;do{f[B+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[ya>>2]|0))}ya=f[xa>>2]|0;if((ya|0)!=(Ea|0))UC(ya);ya=h+36|0;c=f[ya>>2]|0;if(c|0){B=c+12|0;f[B>>2]=(f[B>>2]|0)+1}B=f[ra>>2]|0;if(B|0?(c=B+12|0,B=f[c>>2]|0,f[c>>2]=B+-1,(B|0)==1):0)kL(o);f[ra>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[E>>2]|0)>0){B=f[ua>>2]|0;c=0;do{f[B+(c<<2)>>2]=0;c=c+1|0;Ga=f[E>>2]|0}while((c|0)<(Ga|0));f[o>>2]=f[h>>2];if((Ga|0)<3)I=139;else I=141}else{f[o>>2]=f[h>>2];I=139}do if((I|0)==139){c=f[h+4>>2]|0;if((c|0)>=3){I=141;break}f[E>>2]=c;f[A>>2]=f[h+8>>2];f[_>>2]=f[h+12>>2];c=f[h+44>>2]|0;B=f[wa>>2]|0;f[B>>2]=f[c>>2];f[B+4>>2]=f[c+4>>2]}while(0);if((I|0)==141)jL(o,h);c=h+16|0;f[$>>2]=f[c>>2];f[L>>2]=f[h+20>>2];f[oa>>2]=f[h+24>>2];f[pa>>2]=f[h+28>>2];f[qa>>2]=f[h+32>>2];B=f[ya>>2]|0;f[ra>>2]=B;do if(B|0){Ea=B+12|0;xa=f[Ea>>2]|0;f[Ea>>2]=xa+-1;if((xa|0)!=1)break;kL(h)}while(0);f[ya>>2]=0;B=h+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[B>>2]|0)>0){xa=f[h+40>>2]|0;Ea=0;do{f[xa+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[B>>2]|0))}B=f[h+44>>2]|0;if((B|0)!=(h+48|0))UC(B);Fa=Da}else{if(y){Qi(h,P,Ba,a,Ca,N);B=h+36|0;Ea=f[B>>2]|0;if(Ea|0){xa=Ea+12|0;f[xa>>2]=(f[xa>>2]|0)+1}xa=r+36|0;Ea=f[xa>>2]|0;if(Ea|0?(c=Ea+12|0,Ea=f[c>>2]|0,f[c>>2]=Ea+-1,(Ea|0)==1):0)kL(r);f[xa>>2]=0;Ea=r+16|0;c=r+4|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;if((f[c>>2]|0)>0){ya=f[r+40>>2]|0;Q=0;do{f[ya+(Q<<2)>>2]=0;Q=Q+1|0;Ha=f[c>>2]|0}while((Q|0)<(Ha|0));f[r>>2]=f[h>>2];if((Ha|0)<3)I=98;else I=100}else{f[r>>2]=f[h>>2];I=98}if((I|0)==98){Q=f[h+4>>2]|0;if((Q|0)<3){f[c>>2]=Q;f[r+8>>2]=f[h+8>>2];f[r+12>>2]=f[h+12>>2];Q=f[h+44>>2]|0;ya=f[r+44>>2]|0;f[ya>>2]=f[Q>>2];f[ya+4>>2]=f[Q+4>>2]}else I=100}if((I|0)==100)jL(r,h);Q=h+16|0;f[Ea>>2]=f[Q>>2];f[r+20>>2]=f[h+20>>2];f[r+24>>2]=f[h+24>>2];f[r+28>>2]=f[h+28>>2];f[r+32>>2]=f[h+32>>2];ya=f[B>>2]|0;f[xa>>2]=ya;do if(ya|0){Da=ya+12|0;D=f[Da>>2]|0;f[Da>>2]=D+-1;if((D|0)!=1)break;kL(h)}while(0);f[B>>2]=0;ya=h+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[ya>>2]|0)>0){xa=f[h+40>>2]|0;Ea=0;do{f[xa+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[ya>>2]|0))}ya=f[h+44>>2]|0;if((ya|0)!=(h+48|0))UC(ya);f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=k;ya=i+8|0;f[ya>>2]=0;f[ya+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=r;ZL(h,i)}else{ya=h+8|0;f[ya>>2]=0;f[ya+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=r;SP(k,h)}ya=Ca+z|0;switch(za|0){case 0:case 3:break;default:{Fa=ya;break c}}Ea=h+8|0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=q;SP(o,h);Fa=ya}while(0);d:do switch(za|0){case 0:{z=f[r+16>>2]|0;if((a|0)==5)if(!(jZ(z,f[r+48>>2]|0,P,f[q+16>>2]|0,f[q+48>>2]|0,O)|0)){I=278;break d}else{Ia=1;break d}else if(!(lZ(z,f[r+48>>2]|0,P,f[q+16>>2]|0,f[q+48>>2]|0,O)|0)){I=278;break d}else{Ia=1;break d}break}case 3:{z=f[r+16>>2]|0;if((a|0)==5)Ja=nZ(z,f[r+48>>2]|0,P,f[q+16>>2]|0,f[q+48>>2]|0,O)|0;else Ja=pZ(z,f[r+48>>2]|0,P,f[q+16>>2]|0,f[q+48>>2]|0,O)|0;if(Ja)Ia=1;else I=278;break}case 4:{f[s>>2]=1124007936;z=s+4|0;Ca=s+8|0;Ha=s+40|0;F=z;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[Ha>>2]=Ca;N=s+48|0;y=s+44|0;f[y>>2]=N;f[N>>2]=0;f[s+52>>2]=0;if(G|Aa){qa=h+8|0;f[qa>>2]=0;f[qa+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=q;SP(o,h);qa=q+36|0;pa=f[qa>>2]|0;if(pa|0){oa=pa+12|0;f[oa>>2]=(f[oa>>2]|0)+1}oa=s+36|0;pa=f[oa>>2]|0;if(pa|0?(L=pa+12|0,pa=f[L>>2]|0,f[L>>2]=pa+-1,(pa|0)==1):0)kL(s);f[oa>>2]=0;pa=s+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[z>>2]|0)>0){L=f[Ha>>2]|0;_=0;do{f[L+(_<<2)>>2]=0;_=_+1|0;Ka=f[z>>2]|0}while((_|0)<(Ka|0));f[s>>2]=f[q>>2];if((Ka|0)<3)I=169;else I=171}else{f[s>>2]=f[q>>2];I=169}if((I|0)==169){_=f[q+4>>2]|0;if((_|0)<3){f[z>>2]=_;f[Ca>>2]=f[q+8>>2];f[s+12>>2]=f[q+12>>2];_=f[q+44>>2]|0;L=f[y>>2]|0;f[L>>2]=f[_>>2];f[L+4>>2]=f[_+4>>2]}else I=171}if((I|0)==171)jL(s,q);f[pa>>2]=f[q+16>>2];f[s+20>>2]=f[q+20>>2];f[s+24>>2]=f[q+24>>2];f[s+28>>2]=f[q+28>>2];f[s+32>>2]=f[q+32>>2];f[oa>>2]=f[qa>>2]}else{f[i>>2]=1124007936;_=i+4|0;L=i+8|0;A=i+40|0;F=_;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[A>>2]=L;qa=i+48|0;oa=i+44|0;f[oa>>2]=qa;f[qa>>2]=0;f[i+52>>2]=0;f[h>>2]=W;f[h+4>>2]=O;hL(i,2,h,a);pa=i+36|0;Ga=f[pa>>2]|0;if(Ga|0){v=Ga+12|0;f[v>>2]=(f[v>>2]|0)+1}v=s+36|0;Ga=f[v>>2]|0;if(Ga|0?(w=Ga+12|0,Ga=f[w>>2]|0,f[w>>2]=Ga+-1,(Ga|0)==1):0)kL(s);f[v>>2]=0;Ga=s+16|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[z>>2]|0)>0){w=f[Ha>>2]|0;t=0;do{f[w+(t<<2)>>2]=0;t=t+1|0;La=f[z>>2]|0}while((t|0)<(La|0));f[s>>2]=f[i>>2];if((La|0)<3)I=183;else I=185}else{f[s>>2]=f[i>>2];I=183}if((I|0)==183){t=f[_>>2]|0;if((t|0)<3){f[z>>2]=t;f[Ca>>2]=f[L>>2];f[s+12>>2]=f[i+12>>2];t=f[oa>>2]|0;w=f[y>>2]|0;f[w>>2]=f[t>>2];f[w+4>>2]=f[t+4>>2]}else I=185}if((I|0)==185)jL(s,i);t=i+16|0;f[Ga>>2]=f[t>>2];f[s+20>>2]=f[i+20>>2];f[s+24>>2]=f[i+24>>2];f[s+28>>2]=f[i+28>>2];f[s+32>>2]=f[i+32>>2];w=f[pa>>2]|0;f[v>>2]=w;do if(w|0){e=w+12|0;ya=f[e>>2]|0;f[e>>2]=ya+-1;if((ya|0)!=1)break;kL(i)}while(0);f[pa>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[_>>2]|0)>0){w=f[A>>2]|0;v=0;do{f[w+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[_>>2]|0))}_=f[oa>>2]|0;if((_|0)!=(qa|0))UC(_);_=h+8|0;f[_>>2]=0;f[_+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=s;SP(o,h)}_=f[r+16>>2]|0;if((a|0)==5)Ma=rZ(_,f[r+48>>2]|0,f[r+8>>2]|0,f[r+12>>2]|0,f[s+12>>2]|0,f[s+16>>2]|0,f[N>>2]|0,0)|0;else Ma=sZ(_,f[r+48>>2]|0,f[r+8>>2]|0,f[r+12>>2]|0,f[s+12>>2]|0,f[s+16>>2]|0,f[N>>2]|0,0)|0;_=(Ma|0)==0;v=f[q+8>>2]|0;if((f[Ca>>2]|0)!=(v|0)){f[h>>2]=0;f[h+4>>2]=v;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;lL(x,s,h,i);v=h+8|0;f[v>>2]=0;f[v+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=q;SP(x,h);v=x+36|0;w=f[v>>2]|0;if(w|0?(A=w+12|0,w=f[A>>2]|0,f[A>>2]=w+-1,(w|0)==1):0)kL(x);f[v>>2]=0;v=x+16|0;w=x+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[w>>2]|0)>0){v=f[x+40>>2]|0;A=0;do{f[v+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[w>>2]|0))}w=f[x+44>>2]|0;if((w|0)!=(x+48|0))UC(w)}w=s+36|0;A=f[w>>2]|0;if(A|0?(v=A+12|0,A=f[v>>2]|0,f[v>>2]=A+-1,(A|0)==1):0)kL(s);f[w>>2]=0;w=s+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[z>>2]|0)>0){w=f[Ha>>2]|0;A=0;do{f[w+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[z>>2]|0))}z=f[y>>2]|0;if((z|0)!=(N|0))UC(z);if(_)I=278;else Ia=1;break}default:{z=Fa+15&-16;Qi(h,P,P,a,z,J);Qi(i,P,1,a,z+(Y(J,P)|0)|0,0);f[s>>2]=1124007936;A=s+4|0;w=s+8|0;Ha=s+40|0;F=A;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[Ha>>2]=w;_=s+48|0;N=s+44|0;f[N>>2]=_;f[_>>2]=0;f[s+52>>2]=0;y=z+(Y(J+M|0,P)|0)|0;v=(a|0)==5;Ca=f[r+16>>2]|0;e:do if(d){if(v)eT(Ca,f[r+48>>2]|0,f[i+16>>2]|0,f[h+16>>2]|0,f[h+48>>2]|0,P,y)|0;else fT(Ca,f[r+48>>2]|0,f[i+16>>2]|0,f[h+16>>2]|0,f[h+48>>2]|0,P,y)|0;qa=h+36|0;oa=f[qa>>2]|0;if(oa|0){t=oa+12|0;f[t>>2]=(f[t>>2]|0)+1}t=s+36|0;oa=f[t>>2]|0;if(oa|0?(pa=oa+12|0,oa=f[pa>>2]|0,f[pa>>2]=oa+-1,(oa|0)==1):0)kL(s);f[t>>2]=0;oa=s+16|0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[A>>2]|0)>0){pa=f[Ha>>2]|0;Ga=0;do{f[pa+(Ga<<2)>>2]=0;Ga=Ga+1|0;Na=f[A>>2]|0}while((Ga|0)<(Na|0));f[s>>2]=f[h>>2];if((Na|0)<3)I=230}else{f[s>>2]=f[h>>2];I=230}do if((I|0)==230){Ga=f[h+4>>2]|0;if((Ga|0)>=3)break;f[A>>2]=Ga;f[w>>2]=f[h+8>>2];f[s+12>>2]=f[h+12>>2];Ga=f[h+44>>2]|0;pa=f[N>>2]|0;f[pa>>2]=f[Ga>>2];f[pa+4>>2]=f[Ga+4>>2];Oa=qa;Pa=t;Qa=oa;Ra=h;break e}while(0);jL(s,h);Oa=qa;Pa=t;Qa=oa;Ra=h}else{if(v){Ga=f[h+16>>2]|0;ZS(Ca,f[r+48>>2]|0,f[i+16>>2]|0,Ga,f[h+48>>2]|0,Ba,P,(Ga|0)==0?0:P,1.1754943508222875e-38,2.384185791015625e-07)}else{Ga=f[h+16>>2]|0;_S(Ca,f[r+48>>2]|0,f[i+16>>2]|0,Ga,f[h+48>>2]|0,Ba,P,(Ga|0)==0?0:P,2.2250738585072014e-308,2.220446049250313e-15)}Ga=r+36|0;pa=f[Ga>>2]|0;if(pa|0){L=pa+12|0;f[L>>2]=(f[L>>2]|0)+1}L=s+36|0;pa=f[L>>2]|0;if(pa|0?(ya=pa+12|0,pa=f[ya>>2]|0,f[ya>>2]=pa+-1,(pa|0)==1):0)kL(s);f[L>>2]=0;pa=s+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[A>>2]|0)>0){ya=f[Ha>>2]|0;e=0;do{f[ya+(e<<2)>>2]=0;e=e+1|0;Sa=f[A>>2]|0}while((e|0)<(Sa|0));f[s>>2]=f[r>>2];if((Sa|0)<3)I=246}else{f[s>>2]=f[r>>2];I=246}do if((I|0)==246){e=f[r+4>>2]|0;if((e|0)>=3)break;f[A>>2]=e;f[w>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];e=f[r+44>>2]|0;ya=f[N>>2]|0;f[ya>>2]=f[e>>2];f[ya+4>>2]=f[e+4>>2];Oa=Ga;Pa=L;Qa=pa;Ra=r;break e}while(0);jL(s,r);Oa=Ga;Pa=L;Qa=pa;Ra=r}while(0);f[Qa>>2]=f[Ra+16>>2];f[s+20>>2]=f[Ra+20>>2];f[s+24>>2]=f[Ra+24>>2];f[s+28>>2]=f[Ra+28>>2];f[s+32>>2]=f[Ra+32>>2];f[Pa>>2]=f[Oa>>2];w=i+16|0;Ca=f[w>>2]|0;if(v)gT(Ba,P,Ca,0,f[s+16>>2]|0,f[_>>2]|0,1,f[h+16>>2]|0,f[h+48>>2]|0,f[$>>2]|0,f[va>>2]|0,O,f[q+16>>2]|0,f[q+48>>2]|0,y);else hT(Ba,P,Ca,0,f[s+16>>2]|0,f[_>>2]|0,1,f[h+16>>2]|0,f[h+48>>2]|0,f[$>>2]|0,f[va>>2]|0,O,f[q+16>>2]|0,f[q+48>>2]|0,y);Ca=s+36|0;z=f[Ca>>2]|0;if(z|0?(e=z+12|0,z=f[e>>2]|0,f[e>>2]=z+-1,(z|0)==1):0)kL(s);f[Ca>>2]=0;Ca=s+16|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[A>>2]|0)>0){Ca=f[Ha>>2]|0;z=0;do{f[Ca+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[A>>2]|0))}A=f[N>>2]|0;if((A|0)!=(_|0))UC(A);A=i+36|0;z=f[A>>2]|0;do if(z|0){Ca=z+12|0;Ha=f[Ca>>2]|0;f[Ca>>2]=Ha+-1;if((Ha|0)!=1)break;kL(i)}while(0);f[A>>2]=0;z=i+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[z>>2]|0)>0){_=f[i+40>>2]|0;N=0;do{f[_+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[z>>2]|0))}z=f[i+44>>2]|0;if((z|0)!=(i+48|0))UC(z);z=h+36|0;N=f[z>>2]|0;do if(N|0){_=N+12|0;w=f[_>>2]|0;f[_>>2]=w+-1;if((w|0)!=1)break;kL(h)}while(0);f[z>>2]=0;N=h+16|0;w=h+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[w>>2]|0)>0){N=f[h+40>>2]|0;_=0;do{f[N+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[w>>2]|0))}w=f[h+44>>2]|0;if((w|0)!=(h+48|0))UC(w);Ia=1}}while(0);if((I|0)==278){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;UP(q,h)|0;Ia=0}h=r+36|0;I=f[h>>2]|0;if(I|0?(i=I+12|0,I=f[i>>2]|0,f[i>>2]=I+-1,(I|0)==1):0)kL(r);f[h>>2]=0;h=r+16|0;I=r+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[I>>2]|0)>0){h=f[r+40>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[I>>2]|0))}I=f[r+44>>2]|0;if((I|0)!=(r+48|0))UC(I);I=q+36|0;r=f[I>>2]|0;if(r|0?(i=r+12|0,r=f[i>>2]|0,f[i>>2]=r+-1,(r|0)==1):0)kL(q);f[I>>2]=0;I=q+16|0;r=q+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[r>>2]|0)>0){I=f[q+40>>2]|0;i=0;do{f[I+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))UC(r);r=f[ra>>2]|0;do if(r|0){q=r+12|0;i=f[q>>2]|0;f[q>>2]=i+-1;if((i|0)!=1)break;kL(o)}while(0);f[ra>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[E>>2]|0)>0){$=f[ua>>2]|0;ua=0;do{f[$+(ua<<2)>>2]=0;ua=ua+1|0}while((ua|0)<(f[E>>2]|0))}E=f[wa>>2]|0;if((E|0)!=(va|0))UC(E);E=f[m>>2]|0;if((E|0)!=(K|0)){if(E|0)P5b(E);f[m>>2]=K;f[C>>2]=1032}ma=Ia;na=sa}sa=f[na>>2]|0;if(sa|0?(Ia=sa+12|0,sa=f[Ia>>2]|0,f[Ia>>2]=sa+-1,(sa|0)==1):0)kL(l);f[na>>2]=0;na=l+16|0;sa=l+4|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[sa>>2]|0)>0){na=f[l+40>>2]|0;Ia=0;do{f[na+(Ia<<2)>>2]=0;Ia=Ia+1|0}while((Ia|0)<(f[sa>>2]|0))}sa=f[l+44>>2]|0;if((sa|0)!=(l+48|0))UC(sa);sa=k+36|0;l=f[sa>>2]|0;if(l|0?(Ia=l+12|0,l=f[Ia>>2]|0,f[Ia>>2]=l+-1,(l|0)==1):0)kL(k);f[sa>>2]=0;sa=k+16|0;l=k+4|0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[l>>2]|0)>0){sa=f[k+40>>2]|0;Ia=0;do{f[sa+(Ia<<2)>>2]=0;Ia=Ia+1|0}while((Ia|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))UC(l);if(!(f[j+4>>2]|0)){u=g;return ma|0}u=g;return ma|0}function kT(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;e=u;u=u+16|0;d=e;f[d>>2]=0;f[d+4>>2]=0;c=aD(d,44)|0;a=215603;g=c+44|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(g|0));bO(-216,d,215648,215662,107);bD(d);u=e;return}function lT(a){a=a|0;return}function mT(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;e=u;u=u+16|0;d=e;f[d>>2]=0;f[d+4>>2]=0;c=aD(d,44)|0;g=215603;h=c+44|0;do{b[c>>0]=b[g>>0]|0;c=c+1|0;g=g+1|0}while((c|0)<(h|0));bO(-216,d,215648,215662,107);bD(d);u=e;return a|0}function nT(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=47120;b=a+20|0;c=a+24|0;d=f[c>>2]|0;e=f[b>>2]|0;if((d|0)==(e|0)){g=e;h=d}else{d=a+8|0;do{uT(f[d>>2]|0);e=(f[c>>2]|0)+-1|0;f[c>>2]=e;i=f[b>>2]|0}while((e|0)!=(i|0));g=i;h=e}b=g;if(g|0){if((h|0)!=(b|0))f[c>>2]=b;O5b(b)}bD(a+12|0);b=a+4|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;j=a+8|0;f[j>>2]=0;return}h=c+4|0;g=f[h>>2]|0;f[h>>2]=g+-1;if((g|0)!=1){f[b>>2]=0;j=a+8|0;f[j>>2]=0;return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;j=a+8|0;f[j>>2]=0;return}function oT(a){a=a|0;nT(a);O5b(a);return}function pT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;dQ(g,47144);bi[f[(f[a>>2]|0)+16>>2]&2047](a);h=a+4|0;i=f[b>>2]|0;if(!(f[d+4>>2]|0))j=0;else{b=f[d>>2]|0;j=(b|0)==0?1124530:b}b=GT((i|0)==0?1124530:i,0,c,j)|0;if(!b)k=0;else{j=L5b(16)|0;f[j+4>>2]=1;f[j>>2]=47172;f[j+8>>2]=b;k=j}j=f[h>>2]|0;f[h>>2]=k;f[a+8>>2]=b;if(j|0?(b=j+4|0,k=f[b>>2]|0,f[b>>2]=k+-1,(k|0)==1):0)bi[f[(f[j>>2]|0)+8>>2]&2047](j);j=di[f[(f[a>>2]|0)+12>>2]&1023](a)|0;f[a+32>>2]=j?6:0;if(!(f[g+4>>2]|0)){u=e;return j|0}u=e;return j|0}function qT(a){a=a|0;var c=0,d=0;c=f[a+8>>2]|0;if(!c){d=0;return d|0}d=(b[c+300>>0]|0)!=0;return d|0}function rT(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+4|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+8>>2]=0;b=f[a+20>>2]|0;c=a+24|0;if((f[c>>2]|0)==(b|0)){g=a+32|0;f[g>>2]=0;return}f[c>>2]=b;g=a+32|0;f[g>>2]=0;return}function sT(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=0;f[a+4>>2]=0;c=f[b+8>>2]|0;if(c|0?f[c+268>>2]|0:0)tT(c,a);bi[f[(f[b>>2]|0)+16>>2]&2047](b);return}function tT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=(c|0)!=0;if(g)bD(c);if(!a){f[e>>2]=0;f[e+4>>2]=0;h=aD(e,35)|0;i=200970;j=h+35|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-27,e,201006,201015,667);bD(e)}i=a+300|0;if(b[i>>0]|0){h=a+64|0;a:do if(f[a+8>>2]|0){if(((f[h>>2]|0)==0?(f[a+68>>2]|0)==0:0)?(f[a+268>>2]|0)==0:0)break;j=a+36|0;k=f[j>>2]|0;if(k|0?(f[k+24>>2]|0)>0:0)do uT(a);while((f[(f[j>>2]|0)+24>>2]|0)>0);j=a+72|0;k=f[j>>2]|0;l=a+76|0;m=f[l>>2]|0;n=a+56|0;o=f[n>>2]|0;if(k>>>0>(m+o|0)>>>0){b[k>>0]=10;b[k+1>>0]=0;vT(a,f[l>>2]|0);k=f[l>>2]|0;f[j>>2]=k;p=f[n>>2]|0;q=k}else{p=o;q=m}m=f[a+40>>2]|0;if((p|0)==(m|0)){r=q;s=p}else{Nac(q|0,32,m|0)|0;f[n>>2]=m;r=f[l>>2]|0;s=m}f[j>>2]=r+s;switch(f[a+4>>2]|0){case 8:{vT(a,201088);break a;break}case 24:{vT(a,475812);break a;break}default:break a}}while(0);s=f[h>>2]|0;if(!s){r=a+68|0;q=f[r>>2]|0;if(!q)t=r;else{Bmb(q)|0;t=r}}else{yUb(s)|0;t=a+68|0}f[h>>2]=0;f[t>>2]=0;f[a+256>>2]=0;f[a+264>>2]=0;b[i>>0]=0}i=f[a+268>>2]|0;if(!(g&(i|0)!=0)){u=d;return}g=f[i+4>>2]|0;a=f[i+16>>2]|0;t=g+(a>>>12<<2)|0;if((f[i+8>>2]|0)!=(g|0)){h=(f[t>>2]|0)+(a&4095)|0;s=a+(f[i+20>>2]|0)|0;i=g+(s>>>12<<2)|0;g=(f[i>>2]|0)+(s&4095)|0;s=h;f[e>>2]=0;a=e+4|0;f[a>>2]=0;if((g|0)!=(h|0)?(r=(i-t<<10)-s+g-(f[i>>2]|0)+(f[t>>2]|0)|0,(r|0)!=0):0){i=aD(e,r)|0;r=t;t=s;s=h;while(1){b[i>>0]=b[s>>0]|0;h=t+1|0;q=h;if((q-(f[r>>2]|0)|0)==4096){p=r+4|0;j=f[p>>2]|0;v=p;w=j;x=j}else{v=r;w=q;x=h}if((x|0)==(g|0)){y=e;z=a;break}else{i=i+1|0;r=v;t=w;s=x}}}else{y=e;z=a}}else{f[e>>2]=0;a=e+4|0;f[a>>2]=0;y=e;z=a}if((e|0)!=(c|0)){bD(c);a=f[y>>2]|0;if(!a)A=0;else{y=a+-4|0;f[y>>2]=(f[y>>2]|0)+1;A=f[e>>2]|0}f[c>>2]=A;f[c+4>>2]=f[z>>2]}bD(e);u=d;return}function uT(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=(a|0)!=0;if(!(e?(f[a>>2]|0)==1280131417:0)){g=e?-5:-27;f[d>>2]=0;f[d+4>>2]=0;h=aD(d,31)|0;i=201141;j=h+31|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(g,d,201173,201015,4613);bD(d)}if(!(f[a+8>>2]|0)){f[d>>2]=0;f[d+4>>2]=0;h=aD(d,38)|0;i=201190;j=h+38|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-2,d,201173,201015,4613);bD(d)}zT(a,0);if(!(f[a+280>>2]|0)){k=a+232|0;l=f[k>>2]|0;bi[l&2047](a);u=c;return}AT(a,0);k=a+232|0;l=f[k>>2]|0;bi[l&2047](a);u=c;return}function vT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=f[a+268>>2]|0;if(g|0){h=kUb(c)|0;i=c+h|0;if(!h){u=d;return}h=g+20|0;j=g+8|0;k=g+4|0;l=g+16|0;m=c;n=f[h>>2]|0;do{o=f[k>>2]|0;p=(f[j>>2]|0)-o|0;q=f[l>>2]|0;if((((p|0)==0?0:(p<<10)+-1|0)|0)==(q+n|0)){wT(g);r=f[l>>2]|0;s=f[h>>2]|0;t=f[k>>2]|0}else{r=q;s=n;t=o}o=s+r|0;b[(f[t+(o>>>12<<2)>>2]|0)+(o&4095)>>0]=b[m>>0]|0;n=(f[h>>2]|0)+1|0;f[h>>2]=n;m=m+1|0}while((m|0)!=(i|0));u=d;return}i=f[a+64>>2]|0;if(i|0){jUb(c,i)|0;u=d;return}i=f[a+68>>2]|0;if(!i){f[e>>2]=0;f[e+4>>2]=0;a=aD(e,25)|0;m=201107;n=a+25|0;do{b[a>>0]=b[m>>0]|0;a=a+1|0;m=m+1|0}while((a|0)<(n|0));bO(-2,e,201133,201015,405);bD(e);u=d;return}else{Pmb(i,c)|0;u=d;return}}function wT(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;b=u;u=u+32|0;c=b;d=a+16|0;e=f[d>>2]|0;if(e>>>0>4095){f[d>>2]=e+-4096;e=a+4|0;d=f[e>>2]|0;g=f[d>>2]|0;h=d+4|0;f[e>>2]=h;d=a+8|0;i=f[d>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;m=i;do if((i|0)==(k|0)){n=f[a>>2]|0;o=n;if(h>>>0>n>>>0){p=h;q=((p-o>>2)+1|0)/-2|0;r=h+(q<<2)|0;s=m-p|0;p=s>>2;if(!p)t=h;else{Xac(r|0,h|0,s|0)|0;t=f[e>>2]|0}s=r+(p<<2)|0;f[d>>2]=s;f[e>>2]=t+(q<<2);v=s;break}s=l-o>>1;o=(s|0)==0?1:s;if(o>>>0>1073741823){s=ze(8)|0;T5b(s,477177);f[s>>2]=149528;If(s|0,25408,1411)}s=L5b(o<<2)|0;q=s;p=s+(o>>>2<<2)|0;r=p;w=s+(o<<2)|0;if((h|0)==(i|0)){x=r;y=n}else{n=p;p=r;o=h;do{f[n>>2]=f[o>>2];n=p+4|0;p=n;o=o+4|0}while((o|0)!=(i|0));x=p;y=f[a>>2]|0}f[a>>2]=q;f[e>>2]=r;f[d>>2]=x;f[j>>2]=w;if(!y)v=x;else{O5b(y);v=f[d>>2]|0}}else v=i;while(0);f[v>>2]=g;f[d>>2]=(f[d>>2]|0)+4;u=b;return}d=a+8|0;g=f[d>>2]|0;v=a+4|0;i=f[v>>2]|0;y=g-i|0;x=a+12|0;j=f[x>>2]|0;e=f[a>>2]|0;h=j-e|0;l=g;t=j;m=i;k=e;if(y>>>0>=h>>>0){o=h>>1;n=(o|0)==0?1:o;f[c+12>>2]=0;f[c+16>>2]=a+12;if(n>>>0>1073741823){o=ze(8)|0;T5b(o,477177);f[o>>2]=149528;If(o|0,25408,1411)}o=y>>2;s=L5b(n<<2)|0;f[c>>2]=s;z=s+(o<<2)|0;A=c+8|0;f[A>>2]=z;B=c+4|0;f[B>>2]=z;C=s+(n<<2)|0;D=c+12|0;f[D>>2]=C;E=s;F=L5b(4096)|0;G=C;C=z;do if((o|0)==(n|0)){if(z>>>0>s>>>0){H=z+((((C-E>>2)+1|0)/-2|0)<<2)|0;f[A>>2]=H;f[B>>2]=H;I=H;break}H=G-E>>1;J=(H|0)==0?1:H;if(J>>>0>1073741823){H=ze(8)|0;T5b(H,477177);f[H>>2]=149528;If(H|0,25408,1411)}else{H=L5b(J<<2)|0;K=H+(J>>>2<<2)|0;L=K;f[c>>2]=H;f[B>>2]=L;f[A>>2]=L;f[D>>2]=H+(J<<2);O5b(s);I=K;break}}else I=z;while(0);f[I>>2]=F;f[A>>2]=(f[A>>2]|0)+4;F=f[d>>2]|0;while(1){M=f[v>>2]|0;if((F|0)==(M|0))break;I=F+-4|0;yT(c,I);F=I}I=M;M=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=M;f[v>>2]=f[B>>2];f[B>>2]=I;B=f[d>>2]|0;f[d>>2]=f[A>>2];f[A>>2]=B;z=f[x>>2]|0;f[x>>2]=f[D>>2];f[D>>2]=z;z=B;if((z|0)!=(F|0))f[A>>2]=z+(~((z+-4-I|0)>>>2)<<2);if(M|0)O5b(M);u=b;return}if((j|0)==(g|0)){j=L5b(4096)|0;f[c>>2]=j;xT(a,c);c=f[v>>2]|0;j=f[c>>2]|0;M=c+4|0;f[v>>2]=M;c=f[d>>2]|0;I=f[x>>2]|0;z=I;A=c;do if((c|0)==(I|0)){F=f[a>>2]|0;B=F;if(M>>>0>F>>>0){D=M;s=((D-B>>2)+1|0)/-2|0;E=M+(s<<2)|0;G=A-D|0;D=G>>2;if(!D)N=M;else{Xac(E|0,M|0,G|0)|0;N=f[v>>2]|0}G=E+(D<<2)|0;f[d>>2]=G;f[v>>2]=N+(s<<2);O=G;break}G=z-B>>1;B=(G|0)==0?1:G;if(B>>>0>1073741823){G=ze(8)|0;T5b(G,477177);f[G>>2]=149528;If(G|0,25408,1411)}G=L5b(B<<2)|0;s=G;D=G+(B>>>2<<2)|0;E=D;C=G+(B<<2)|0;if((M|0)==(c|0)){P=E;Q=F}else{F=D;D=E;B=M;do{f[F>>2]=f[B>>2];F=D+4|0;D=F;B=B+4|0}while((B|0)!=(c|0));P=D;Q=f[a>>2]|0}f[a>>2]=s;f[v>>2]=E;f[d>>2]=P;f[x>>2]=C;if(!Q)O=P;else{O5b(Q);O=f[d>>2]|0}}else O=c;while(0);f[O>>2]=j;f[d>>2]=(f[d>>2]|0)+4;u=b;return}else{j=L5b(4096)|0;O=g;do if((l|0)==(t|0)){if(m>>>0>k>>>0){g=((i-e>>2)+1|0)/-2|0;c=m+(g<<2)|0;Q=y>>2;if(!Q)R=m;else{Xac(c|0,i|0,y|0)|0;R=f[v>>2]|0}P=c+(Q<<2)|0;f[d>>2]=P;f[v>>2]=R+(g<<2);S=P;break}P=h>>1;g=(P|0)==0?1:P;if(g>>>0>1073741823){P=ze(8)|0;T5b(P,477177);f[P>>2]=149528;If(P|0,25408,1411)}P=L5b(g<<2)|0;Q=P;c=P+(g>>>2<<2)|0;M=c;z=P+(g<<2)|0;if((m|0)==(l|0)){T=M;U=k}else{g=c;c=M;P=m;do{f[g>>2]=f[P>>2];g=c+4|0;c=g;P=P+4|0}while((P|0)!=(l|0));T=c;U=f[a>>2]|0}f[a>>2]=Q;f[v>>2]=M;f[d>>2]=T;f[x>>2]=z;if(!U)S=T;else{O5b(U);S=f[d>>2]|0}}else S=O;while(0);f[S>>2]=j;f[d>>2]=(f[d>>2]|0)+4;u=b;return}}function xT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{Xac(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=ze(8)|0;T5b(m,477177);f[m>>2]=149528;If(m|0,25408,1411)}m=L5b(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{O5b(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function yT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{Xac(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=ze(8)|0;T5b(m,477177);f[m>>2]=149528;If(m|0,25408,1411)}m=L5b(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{O5b(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function zT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+12|0;g=d;h=a+284|0;if(!(b[h>>0]|0)){u=d;return};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=a+292|0;j=f[i>>2]|0;k=a+288|0;l=f[k>>2]|0;if(l|0?b[l>>0]|0:0)d6b(e,l)|0;l=a+296|0;m=f[l>>2]|0;if(m|0?b[m>>0]|0:0)d6b(g,m)|0;m=f[k>>2]|0;if(m|0)P5b(m);m=f[l>>2]|0;if(m|0)P5b(m);f[k>>2]=0;f[i>>2]=0;f[l>>2]=0;b[h>>0]=0;h=f[a+228>>2]|0;l=e+11|0;i=(b[l>>0]|0)<0?f[e>>2]|0:e;if(c){th[h&511](a,i,j,201467);if(f[a+280>>2]|0)AT(a,0);AT(a,2);n=g+11|0}else{c=g+11|0;th[h&511](a,i,j,(b[c>>0]|0)<0?f[g>>2]|0:g);if(f[a+280>>2]|0)AT(a,0);AT(a,1);n=c}if((b[n>>0]|0)<0)O5b(f[g>>2]|0);if((b[l>>0]|0)<0)O5b(f[e>>2]|0);u=d;return}function AT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=a+280|0;switch(f[g>>2]|0){case 0:{switch(c|0){case 2:{h=L5b(16)|0;BT(h,a);f[a+272>>2]=h;f[g>>2]=c;u=d;return}case 1:case 0:{f[g>>2]=c;u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;i=aD(e,55)|0;j=201229;k=i+55|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-2,e,201285,201015,1157);bD(e);f[g>>2]=c;u=d;return}}break}case 2:{switch(c|0){case 1:case 2:{f[e>>2]=0;f[e+4>>2]=0;i=aD(e,49)|0;j=201308;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-2,e,201285,201015,1166);bD(e);f[g>>2]=c;u=d;return}case 0:{h=a+272|0;a=f[h>>2]|0;if(a|0){l=f[a>>2]|0;if(l|0){CT(l);O5b(l)}l=a+4|0;if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);O5b(a)}f[h>>2]=0;f[g>>2]=c;u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;i=aD(e,55)|0;j=201229;k=i+55|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-2,e,201285,201015,1173);bD(e);f[g>>2]=c;u=d;return}}break}case 1:{switch(c|0){case 1:case 2:{f[e>>2]=0;f[e+4>>2]=0;i=aD(e,49)|0;j=201308;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-2,e,201285,201015,1182);bD(e);f[g>>2]=c;u=d;return}case 0:{f[g>>2]=c;u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;i=aD(e,55)|0;j=201229;k=i+55|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-2,e,201285,201015,1187);bD(e);f[g>>2]=c;u=d;return}}break}default:{f[e>>2]=0;f[e+4>>2]=0;i=aD(e,55)|0;j=201229;k=i+55|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-2,e,201285,201015,1192);bD(e);f[g>>2]=c;u=d;return}}}function BT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;g=L5b(40)|0;FT(g,c);f[a>>2]=g;g=a+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;g=(c|0)!=0;if(!(g?(f[c>>2]|0)==1280131417:0)){f[e>>2]=0;f[e+4>>2]=0;h=aD(e,31)|0;i=201141;j=h+31|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(g?-5:-27,e,201423,201015,8334);bD(e)}if(f[c+8>>2]|0){u=d;return}f[e>>2]=0;f[e+4>>2]=0;h=aD(e,38)|0;i=201190;j=h+38|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-2,e,201423,201015,8334);bD(e);u=d;return}function CT(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if((f[a+32>>2]|0)!=(f[a+28>>2]|0))DT(a)|0;c=f[a>>2]|0;if((f[c+4>>2]|0)==24){vT(c,476054);c=f[a>>2]|0;d=c+76|0;e=f[d>>2]|0;g=c+72|0;f[g>>2]=e;h=e;e=c+56|0;i=f[e>>2]|0;if((i|0)<0){b[h>>0]=10;b[h+1>>0]=0;vT(c,f[d>>2]|0);j=f[d>>2]|0;f[g>>2]=j;k=f[e>>2]|0;l=j}else{k=i;l=h}h=f[c+40>>2]|0;if((k|0)==(h|0)){m=l;n=k}else{Nac(l|0,32,h|0)|0;f[e>>2]=h;m=f[d>>2]|0;n=h}f[g>>2]=m+n;n=f[a>>2]|0;Nac(f[n+76>>2]|0,0,f[n+56>>2]|0)|0;n=f[a>>2]|0;f[n+72>>2]=f[n+76>>2]}n=f[a+16>>2]|0;if(n|0){m=a+20|0;if((f[m>>2]|0)!=(n|0))f[m>>2]=n;O5b(n)}n=f[a+4>>2]|0;if(!n)return;m=a+8|0;if((f[m>>2]|0)!=(n|0))f[m>>2]=n;O5b(n);return}function DT(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+80|0;d=c;e=a+28|0;g=f[e>>2]|0;h=a+16|0;i=a+32|0;if(!(ET(g,f[h>>2]|0,0,(f[i>>2]|0)-g|0)|0)){j=0;u=c;return j|0}f[i>>2]=f[e>>2];e=f[a>>2]|0;if((f[e+4>>2]|0)==24){vT(e,f[h>>2]|0);j=1;u=c;return j|0}i=f[e+40>>2]|0;Nac(d|0,32,i|0)|0;b[d+i>>0]=0;vT(e,d);vT(f[a>>2]|0,f[h>>2]|0);vT(f[a>>2]|0,475789);h=f[a>>2]|0;a=h+72|0;d=f[a>>2]|0;e=h+76|0;i=f[e>>2]|0;g=h+56|0;k=f[g>>2]|0;if(d>>>0>(i+k|0)>>>0){b[d>>0]=10;b[d+1>>0]=0;vT(h,f[e>>2]|0);d=f[e>>2]|0;f[a>>2]=d;l=f[g>>2]|0;m=d}else{l=k;m=i}i=f[h+40>>2]|0;if((l|0)==(i|0)){n=m;o=l}else{Nac(m|0,32,i|0)|0;f[g>>2]=i;n=f[e>>2]|0;o=i}f[a>>2]=n+o;j=1;u=c;return j|0}function ET(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;if(!((a|0)!=0&(c|0)!=0&(e|0)!=0)){f=0;return f|0}g=a+d|0;d=e-((e>>>0)%3|0)|0;a=g+d|0;if((d|0)>0){d=c;i=g;while(1){j=b[i+1>>0]|0;k=i+3|0;l=b[i+2>>0]|0;m=h[i>>0]|0;b[d>>0]=b[201358+(m>>>2)>>0]|0;n=j&255;b[d+1>>0]=b[201358+(n>>>4|m<<4&48)>>0]|0;m=l&255;b[d+2>>0]=b[201358+(m>>>6|n<<2&60)>>0]|0;n=d+4|0;b[d+3>>0]=b[201358+(m&63)>>0]|0;if(k>>>0<a>>>0){d=n;i=k}else{o=n;p=k;break}}}else{o=c;p=g}i=g+e-p|0;switch(i|0){case 1:{e=h[p>>0]|0;b[o>>0]=b[201358+(e>>>2)>>0]|0;q=o+1|0;r=2;s=e<<4;t=48;u=7;break}case 2:{e=b[p+1>>0]|0;g=h[p>>0]|0;b[o>>0]=b[201358+(g>>>2)>>0]|0;p=e&255;b[o+1>>0]=b[201358+(g<<4&48|p>>>4)>>0]|0;q=o+2|0;r=3;s=p<<2;t=60;u=7;break}default:v=o}if((u|0)==7){b[q>>0]=b[201358+(s&t)>>0]|0;v=o+r|0}switch(i|0){case 1:{b[v>>0]=61;w=v+1|0;u=10;break}case 2:{w=v;u=10;break}default:x=v}if((u|0)==10){b[w>>0]=61;x=w+1|0}b[x>>0]=0;f=x-c|0;return f|0}function FT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;f[a>>2]=c;g=a+4|0;f[g>>2]=0;h=a+8|0;f[h>>2]=0;f[a+12>>2]=0;i=L5b(48)|0;f[h>>2]=i;f[g>>2]=i;f[a+12>>2]=i+48;j=48;k=i;do{b[k>>0]=0;k=(f[h>>2]|0)+1|0;f[h>>2]=k;j=j+-1|0}while((j|0)!=0);j=a+16|0;f[j>>2]=0;k=a+20|0;f[k>>2]=0;f[a+24>>2]=0;h=L5b(65)|0;f[k>>2]=h;f[j>>2]=h;f[a+24>>2]=h+65;j=65;i=h;do{b[i>>0]=0;i=(f[k>>2]|0)+1|0;f[k>>2]=i;j=j+-1|0}while((j|0)!=0);j=f[g>>2]|0;f[a+28>>2]=j;f[a+36>>2]=j+48;f[a+32>>2]=j;j=(c|0)!=0;if(!(j?(f[c>>2]|0)==1280131417:0)){f[e>>2]=0;f[e+4>>2]=0;l=aD(e,31)|0;m=201141;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(j?-5:-27,e,201436,201015,7900);bD(e)}if(!(f[c+8>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;l=aD(e,38)|0;m=201190;n=l+38|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-2,e,201436,201015,7900);bD(e)}if((f[c+4>>2]|0)==24){e=c+72|0;m=f[e>>2]|0;f[e>>2]=m+1;b[m>>0]=0;m=c+76|0;vT(c,f[m>>2]|0);f[e>>2]=f[m>>2];m=f[a>>2]|0;Nac(f[m+76>>2]|0,0,f[m+56>>2]|0)|0;vT(c,201457);u=d;return}c=f[a>>2]|0;a=c+72|0;m=f[a>>2]|0;e=c+76|0;l=f[e>>2]|0;n=c+56|0;j=f[n>>2]|0;if(m>>>0>(l+j|0)>>>0){b[m>>0]=10;b[m+1>>0]=0;vT(c,f[e>>2]|0);m=f[e>>2]|0;f[a>>2]=m;o=f[n>>2]|0;p=m}else{o=j;p=l}l=f[c+40>>2]|0;if((o|0)==(l|0)){q=p;r=o}else{Nac(p|0,32,l|0)|0;f[n>>2]=l;q=f[e>>2]|0;r=l}f[a>>2]=q+r;u=d;return}function GT(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0;g=u;u=u+1344|0;h=g+168|0;i=g+152|0;j=g+136|0;k=g+120|0;l=g+104|0;m=g+88|0;n=g+72|0;o=g+56|0;p=g+40|0;q=g+24|0;r=g+8|0;s=g;t=g+228|0;v=g+216|0;w=g+204|0;x=g+200|0;y=g+196|0;z=g+192|0;A=g+180|0;B=g+1328|0;f[z>>2]=0;C=d&3;D=(C|0)==2;E=d&4;F=(E|0)!=0;G=(C|0)!=0;C=G&(d&64|0)!=0;f[A>>2]=0;H=A+4|0;f[H>>2]=0;f[A+8>>2]=0;if(!F){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;I=kUb(a)|0;if(I>>>0>4294967279)V5b(w);if(I>>>0<11){b[w+11>>0]=I;if(!I)J=w;else{K=w;L=7}}else{M=I+16&-16;N=L5b(M)|0;f[w>>2]=N;f[w+8>>2]=M|-2147483648;f[w+4>>2]=I;K=N;L=7}if((L|0)==7){Vac(K|0,a|0,I|0)|0;J=K}b[J+I>>0]=0;f[v>>2]=0;I=v+4|0;f[I>>2]=0;f[v+8>>2]=0;if((s6b(w,10,0)|0)==-1){J=t6b(w,63,-1)|0;K=b[w+11>>0]|0;N=K<<24>>24<0?f[w+4>>2]|0:K&255;Y5b(t,w,0,J,w);K=f[I>>2]|0;M=v+8|0;if((K|0)==(f[M>>2]|0))JT(v,t);else{X5b(K,t);f[I>>2]=(f[I>>2]|0)+12}if((b[t+11>>0]|0)<0)O5b(f[t>>2]|0);if((J|0)!=-1?(K=J+1|0,K>>>0<N>>>0):0){J=t+11|0;O=K;while(1){K=s6b(w,38,O)|0;if((O+1|0)>>>0<N>>>0&((K|0)!=(O|0)|(K|0)==-1)){Y5b(t,w,O,K-O|0,w);P=f[I>>2]|0;if((P|0)==(f[M>>2]|0))JT(v,t);else{X5b(P,t);f[I>>2]=(f[I>>2]|0)+12}if((b[J>>0]|0)<0)O5b(f[t>>2]|0)}if(K>>>0<N>>>0)O=K+1|0;else break}}}KT(A,f[v>>2]|0,f[I>>2]|0);O=f[v>>2]|0;if(O|0){N=f[I>>2]|0;if((N|0)==(O|0))Q=O;else{J=N;while(1){N=J+-12|0;f[I>>2]=N;if((b[N+11>>0]|0)<0){O5b(f[N>>2]|0);R=f[I>>2]|0}else R=N;if((R|0)==(O|0))break;else J=R}Q=f[v>>2]|0}O5b(Q)}if((b[w+11>>0]|0)<0)O5b(f[w>>2]|0);Q=f[A>>2]|0;R=f[H>>2]|0;J=(Q|0)==(R|0);O=R;I=Q;do if(!J)if((b[Q+11>>0]|0)<0){S=f[Q>>2]|0;break}else{S=Q;break}else S=a;while(0);if(C){T=1;U=S}else{f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;b[t+11>>0]=6;b[t>>0]=b[201543]|0;b[t+1>>0]=b[201544]|0;b[t+2>>0]=b[201545]|0;b[t+3>>0]=b[201546]|0;b[t+4>>0]=b[201547]|0;b[t+5>>0]=b[201548]|0;b[t+6>>0]=0;if(((O-I|0)/12|0)>>>0<2)V=0;else{a:do if(J)W=Q;else{I=f[t>>2]&255;O=Q;while(1){N=b[O+11>>0]|0;M=N<<24>>24<0;K=N&255;do if(((M?f[O+4>>2]|0:K)|0)==6){N=f[O>>2]|0;if(M)if(!(ZVb(N,t,6)|0)){W=O;break a}else break;if((N&255)<<24>>24==I<<24>>24){N=O;P=K;X=t;do{P=P+-1|0;N=N+1|0;if(!P){W=O;break a}X=X+1|0}while((b[N>>0]|0)==(b[X>>0]|0))}}while(0);O=O+12|0;if((O|0)==(R|0)){W=R;break}}}while(0);V=(W|0)!=(R|0)}T=V&G;U=S}}else{T=C;U=a}a=(U|0)!=0;if(a?(b[U>>0]|0)!=0:0){Y=F;Z=kUb(U)|0}else if(G){Y=1;Z=0}else{f[t>>2]=0;f[t+4>>2]=0;C=E>>>1|20;E=aD(t,C)|0;Vac(E|0,(F?201550:201573)|0,C|0)|0;bO(-27,t,201594,201015,4198);bD(t);Y=1;Z=0}C=D^1;if(!(C|Y^1)){f[t>>2]=0;f[t+4>>2]=0;_=aD(t,68)|0;$=201612;aa=_+68|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));bO(-206,t,201594,201015,4205);bD(t)}F=VC(304)|0;f[z>>2]=F;if(!F){f[t>>2]=0;f[t+4>>2]=0;E=aD(t,2)|0;b[E>>0]=102;b[E+1>>0]=115;bO(-215,t,201594,201015,4208);bD(t);ba=f[z>>2]|0}else ba=F;Nac(ba|0,0,304)|0;ba=zW(262144)|0;F=f[z>>2]|0;f[F+16>>2]=ba;f[F+20>>2]=(c|0)==0?ba:c;f[F>>2]=1280131417;f[F+8>>2]=G&1;b:do if(!Y){G=FW(ba,Z+1|0)|0;f[(f[z>>2]|0)+60>>2]=G;KUb(G,U)|0;G=f[z>>2]|0;c=f[G+60>>2]|0;E=$Vb(c,46)|0;do if((E|0?(b[E+1>>0]|0)==103:0)?(b[E+2>>0]|0)==122:0){S=E+3|0;V=b[S>>0]|0;if(V<<24>>24){if((V+-48&255)>=10)break;if(b[E+4>>0]|0)break}if(D){LT(z);f[t>>2]=0;f[t+4>>2]=0;_=aD(t,52)|0;$=201681;aa=_+52|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));bO(-213,t,201594,201015,4231);bD(t);ca=b[S>>0]|0}else ca=V;if(!(ca<<24>>24)){da=0;ea=Z}else{b[S>>0]=0;da=ca;ea=Z+-1|0}R=f[z>>2]|0;b[t>>0]=f[R+8>>2]|0?119:114;b[t+1>>0]=98;b[t+2>>0]=da<<24>>24?da:51;b[t+3>>0]=0;W=Cmb(f[R+60>>2]|0,t)|0;R=f[z>>2]|0;f[R+68>>2]=W;if(!W){fa=R;break b}else{ga=1;ha=ea;ia=R;L=74;break b}}while(0);E=YUb(c,(f[G+8>>2]|0)==0?201741:D?201734:201738)|0;R=f[z>>2]|0;f[R+64>>2]=E;if(!E)fa=R;else{ga=0;ha=Z;ia=R;L=74}}else{ga=0;ha=Z;ia=F;L=74}while(0);if((L|0)==74){f[ia+32>>2]=0;f[ia+40>>2]=0;f[ia+44>>2]=0;f[ia+84>>2]=71;if(!(f[ia+8>>2]|0)){if(Y){f[ia+256>>2]=U;f[ia+260>>2]=ha}MT(ia,B,14)|0;if((b[B>>0]|0)==-17?(b[B+1>>0]|0)==-69:0)ja=(b[B+2>>0]|0)==-65?B+3|0:B;else ja=B;ha=ja-B|0;do if(tVb(ja,202083,5)|0){if((b[ja>>0]|0)==123){f[(f[z>>2]|0)+4>>2]=24;break}B=(tVb(ja,202089,5)|0)==0;F=f[z>>2]|0;if(B){f[F+4>>2]=8;break}if((f[F+260>>2]|0)==(ha|0)){f[t>>2]=0;f[t+4>>2]=0;_=aD(t,19)|0;$=202095;aa=_+19|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));bO(-49,t,201594,201015,4484);bD(t);break}else{f[t>>2]=0;f[t+4>>2]=0;_=aD(t,31)|0;$=202115;aa=_+31|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));bO(-49,t,201594,201015,4486);bD(t);break}}else f[(f[z>>2]|0)+4>>2]=16;while(0);if(ga)ka=1048576;else{ga=f[z>>2]|0;if(Y)la=f[ga+260>>2]|0;else{dVb(f[ga+64>>2]|0,0,2)|0;la=rUb(f[(f[z>>2]|0)+64>>2]|0)|0}ga=la>>>0<1048576?la:1048576;ka=ga>>>0>9216?ga:9216}ga=f[z>>2]|0;la=f[ga+64>>2]|0;if(!la){ja=f[ga+68>>2]|0;if(ja|0)Emb(ja)|0}else cVb(la);f[ga+264>>2]=0;ga=f[z>>2]|0;f[ga+264>>2]=ha;ha=f[ga+16>>2]|0;ga=bX(0,72,16,ha)|0;f[ga+64>>2]=256;la=FW(ha,1024)|0;f[ga+68>>2]=la;Nac(la|0,0,1024)|0;la=f[z>>2]|0;f[la+28>>2]=ga;ga=IW(0,56,16,f[la+16>>2]|0)|0;f[(f[z>>2]|0)+32>>2]=ga;ga=VC(ka+256|0)|0;la=f[z>>2]|0;f[la+76>>2]=ga;f[la+72>>2]=ga;f[la+80>>2]=ga+ka;b[ga>>0]=10;b[(f[(f[z>>2]|0)+72>>2]|0)+1>>0]=0;ga=f[z>>2]|0;c:do switch(f[ga+4>>2]|0){case 8:{ka=f[ga+76>>2]|0;f[v>>2]=0;f[w>>2]=0;f[x>>2]=0;f[y>>2]=0;la=gU(ga,ka,2)|0;if(ZVb(la,202089,5)|0){ka=f[ga+88>>2]|0;f[r>>2]=f[ga+60>>2];f[r+4>>2]=ka;f[r+8>>2]=202158;_Ub(t,202147,r)|0;MO(-212,202200,t,201015,2825)}ka=hU(ga,la,v,x,y)|0;d:do if(b[ka>>0]|0){la=ga+32|0;ha=ga+60|0;ja=ga+88|0;G=ka;do{c=gU(ga,G,0)|0;if(!(b[c>>0]|0))break d;F=hU(ga,c,v,x,y)|0;c=f[v>>2]|0;if(!((f[y>>2]|0)==1&(c|0)!=0?!(gTb(f[c+8>>2]|0,202212)|0):0)){B=f[ja>>2]|0;f[q>>2]=f[ha>>2];f[q+4>>2]=B;f[q+8>>2]=202227;_Ub(t,202147,q)|0;MO(-212,202200,t,201015,2855)}B=hU(ga,iU(ga,F,XW(f[la>>2]|0,0)|0,0)|0,w,x,y)|0;if(!((f[y>>2]|0)==2?(c|0)==(f[w>>2]|0):0)){c=f[ja>>2]|0;f[p>>2]=f[ha>>2];f[p+4>>2]=c;f[p+8>>2]=202259;_Ub(t,202147,p)|0;MO(-212,202200,t,201015,2861)}G=gU(ga,B,0)|0}while((b[G>>0]|0)!=0)}while(0);break}case 16:{ka=jU(ga,f[ga+76>>2]|0,0)|0;if(ka|0){G=ga+92|0;ha=ga+60|0;ja=ga+88|0;la=ga+32|0;S=0;V=ka;while(1){e:do if(!S){ka=V;f:while(1){B=b[ka>>0]|0;switch(B<<24>>24){case 45:{break f;break}case 37:{do if(!(ZVb(ka,202083,5)|0)){if(!(ZVb(ka,202296,8)|0))break;if(!(ZVb(ka,202305,8)|0))break;c=f[ja>>2]|0;f[m>>2]=f[ha>>2];f[m+4>>2]=c;f[m+8>>2]=202314;_Ub(t,202147,m)|0;MO(-212,202356,t,201015,1836)}while(0);b[ka>>0]=0;break}default:{if(B<<24>>24==95|((B+-48&255)<10|((B&-33)+-65&255)<26)){ma=ka;L=210;break e}if(f[G>>2]|0){na=ka;break e}c=f[ja>>2]|0;f[k>>2]=f[ha>>2];f[k+4>>2]=c;f[k+8>>2]=202368;_Ub(t,202147,k)|0;MO(-212,202356,t,201015,1858)}}c=jU(ga,ka,0)|0;if(!c)break c;else ka=c}if(!(ZVb(ka,202292,3)|0)){oa=ka;L=208}else na=ka}else{c=V;while(1){F=b[c>>0]|0;switch(F<<24>>24){case 37:{do if(!(ZVb(c,202083,5)|0)){if(!(ZVb(c,202296,8)|0))break;if(!(ZVb(c,202305,8)|0))break;Z=f[ja>>2]|0;f[o>>2]=f[ha>>2];f[o+4>>2]=Z;f[o+8>>2]=202314;_Ub(t,202147,o)|0;MO(-212,202356,t,201015,1836)}while(0);b[c>>0]=0;break}case 45:{if(!(ZVb(c,202292,3)|0)){oa=c;L=208;break e}break}default:{if(F<<24>>24==95|((F+-48&255)<10|((F&-33)+-65&255)<26)){ma=c;L=210;break e}if(f[G>>2]|0){na=c;break e}B=f[ja>>2]|0;f[n>>2]=f[ha>>2];f[n+4>>2]=B;f[n+8>>2]=202368;_Ub(t,202147,n)|0;MO(-212,202356,t,201015,1858)}}c=jU(ga,c,0)|0;if(!c)break c}}while(0);if((L|0)==208){L=0;na=oa+3|0}else if((L|0)==210){L=0;if(S){c=f[ja>>2]|0;f[l>>2]=f[ha>>2];f[l+4>>2]=c;f[l+8>>2]=202398;_Ub(t,202147,l)|0;MO(-212,202356,t,201015,1852);na=ma}else na=ma}c=jU(ga,na,0)|0;if(ZVb(c,490625,3)|0){ka=XW(f[la>>2]|0,0)|0;B=kU(ga,c,ka,0,0)|0;if((f[ka>>2]&7)>>>0<=4){ka=f[ja>>2]|0;f[j>>2]=f[ha>>2];f[j+4>>2]=ka;f[j+8>>2]=202459;_Ub(t,202147,j)|0;MO(-212,202356,t,201015,1869)}ka=jU(ga,B,0)|0;if(!ka)break c;else pa=ka}else pa=c;if(f[G>>2]|0)break c;V=jU(ga,pa+3|0,0)|0;if(!V)break;else S=1}}break}case 24:{S=lU(ga,f[ga+76>>2]|0)|0;if(S|0?(V=ga+92|0,(f[V>>2]|0)==0):0){switch(b[S>>0]|0){case 123:{mU(ga,S,XW(f[ga+32>>2]|0,0)|0)|0;break}case 91:{nU(ga,S,XW(f[ga+32>>2]|0,0)|0)|0;break}default:{S=f[ga+88>>2]|0;f[i>>2]=f[ga+60>>2];f[i+4>>2]=S;f[i+8>>2]=202521;_Ub(t,202147,i)|0;MO(-212,202556,t,201015,3831)}}if(f[V>>2]|0){V=f[ga+88>>2]|0;f[h>>2]=f[ga+60>>2];f[h+4>>2]=V;f[h+8>>2]=202569;_Ub(t,202147,h)|0;MO(-212,202556,t,201015,3835)}}break}default:{}}while(0);WC(f[(f[z>>2]|0)+76>>2]|0);h=f[z>>2]|0;f[h+76>>2]=0;f[h+80>>2]=0;f[h+72>>2]=0;qa=h}else{h=d&56;if(Y){Y=L5b(24)|0;f[Y>>2]=0;f[Y+4>>2]=0;f[Y+8>>2]=0;f[Y+12>>2]=0;f[Y+16>>2]=0;f[Y+20>>2]=0;f[ia+268>>2]=Y}g:do if((h|0)==0&a){Y=U;ia=0;d=0;h:while(1){switch(b[Y>>0]|0){case 0:{break h;break}case 46:{ra=d;sa=Y;break}default:{ra=ia;sa=d}}Y=Y+1|0;ia=ra;d=sa}if((((d|0)!=0?(kUb(d)|0)==3:0)?(Y=gVb(b[d>>0]|0)|0,(Y|0)==(gVb(46)|0)):0)?(Y=gVb(b[d+1>>0]|0)|0,(Y|0)==(gVb(103)|0)):0){Y=gVb(b[d+2>>0]|0)|0;ga=(Y|0)==(gVb(122)|0);ta=ga?1:0}else ta=0;ga=(ia|0)!=0&ta?ia:d;if(ga){if(((((kUb(ga)|0)==4?(Y=gVb(b[ga>>0]|0)|0,(Y|0)==(gVb(46)|0)):0)?(Y=gVb(b[ga+1>>0]|0)|0,(Y|0)==(gVb(120)|0)):0)?(Y=gVb(b[ga+2>>0]|0)|0,(Y|0)==(gVb(109)|0)):0)?(Y=gVb(b[ga+3>>0]|0)|0,(Y|0)==(gVb(108)|0)):0){ua=8;break}do if(((((kUb(ga)|0)==7?(Y=gVb(b[ga>>0]|0)|0,(Y|0)==(gVb(46)|0)):0)?(Y=gVb(b[ga+1>>0]|0)|0,(Y|0)==(gVb(120)|0)):0)?(Y=gVb(b[ga+2>>0]|0)|0,(Y|0)==(gVb(109)|0)):0)?(Y=gVb(b[ga+3>>0]|0)|0,(Y|0)==(gVb(108)|0)):0){Y=gVb(b[ga+4>>0]|0)|0;if((Y|0)!=(gVb(46)|0))break;Y=gVb(b[ga+5>>0]|0)|0;if((Y|0)!=(gVb(103)|0))break;Y=gVb(b[ga+6>>0]|0)|0;if((Y|0)==(gVb(122)|0)){ua=8;break g}}while(0);do if((((kUb(ga)|0)==5?(d=gVb(b[ga>>0]|0)|0,(d|0)==(gVb(46)|0)):0)?(d=gVb(b[ga+1>>0]|0)|0,(d|0)==(gVb(106)|0)):0)?(d=gVb(b[ga+2>>0]|0)|0,(d|0)==(gVb(115)|0)):0){d=gVb(b[ga+3>>0]|0)|0;if((d|0)!=(gVb(111)|0))break;d=gVb(b[ga+4>>0]|0)|0;if((d|0)==(gVb(110)|0)){ua=24;break g}}while(0);if((((kUb(ga)|0)==8?(d=gVb(b[ga>>0]|0)|0,(d|0)==(gVb(46)|0)):0)?(d=gVb(b[ga+1>>0]|0)|0,(d|0)==(gVb(106)|0)):0)?(d=gVb(b[ga+2>>0]|0)|0,(d|0)==(gVb(115)|0)):0){d=gVb(b[ga+3>>0]|0)|0;if((d|0)!=(gVb(111)|0)){ua=16;break}d=gVb(b[ga+4>>0]|0)|0;if((d|0)!=(gVb(110)|0)){ua=16;break}d=gVb(b[ga+5>>0]|0)|0;if((d|0)!=(gVb(46)|0)){ua=16;break}d=gVb(b[ga+6>>0]|0)|0;if((d|0)!=(gVb(103)|0)){ua=16;break}d=gVb(b[ga+7>>0]|0)|0;ia=(d|0)==(gVb(122)|0);ua=ia?24:16}else ua=16}else ua=16}else ua=h|0?h:8;while(0);h=f[z>>2]|0;f[h+4>>2]=ua;ta=(ua|0)==8?25600:17408;if(D){dVb(f[h+64>>2]|0,0,2)|0;sa=f[z>>2]|0;va=f[sa+4>>2]|0;wa=sa}else{va=ua;wa=h}h=IW(0,56,(va|0)==8?24:4,f[wa+16>>2]|0)|0;wa=f[z>>2]|0;f[wa+36>>2]=h;f[wa+12>>2]=1;f[wa+40>>2]=0;f[wa+44>>2]=32;wa=VC(ta+1024|0)|0;h=f[z>>2]|0;f[h+72>>2]=wa;f[h+76>>2]=wa;f[h+80>>2]=wa+ta;f[h+272>>2]=0;b[h+276>>0]=T&1;f[h+280>>2]=0;b[h+284>>0]=0;f[h+288>>2]=0;f[h+292>>2]=0;f[h+296>>2]=0;switch(f[h+4>>2]|0){case 8:{T=f[h+64>>2]|0;if(!T){xa=h;ya=0}else{ta=rUb(T)|0;xa=f[z>>2]|0;ya=ta}ta=AW(f[xa+16>>2]|0)|0;xa=f[z>>2]|0;f[xa+24>>2]=ta;if((ya|0)==0|C){if(!e)vT(xa,201884);else{if(!(((gTb(e,201744)|0)!=0?(gTb(e,201751)|0)!=0:0)?(gTb(e,201758)|0)!=0:0)){LT(z);f[t>>2]=0;f[t+4>>2]=0;_=aD(t,57)|0;$=201765;aa=_+57|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));bO(-5,t,201594,201015,4342);bD(t)}if((kUb(e)|0)>>>0>=1e3){f[t>>2]=0;f[t+4>>2]=0;_=aD(t,23)|0;$=201823;aa=_+23|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));bO(-215,t,201594,201015,4345);bD(t)}f[s>>2]=e;_Ub(t,201847,s)|0;vT(f[z>>2]|0,t)}vT(f[z>>2]|0,201907)}else{s=(ya|0)<1024?ya:1024;dVb(f[xa+64>>2]|0,0-s|0,2)|0;xa=VC(s+2|0)|0;ya=-1;i:while(1){while(1){za=rUb(f[(f[z>>2]|0)+64>>2]|0)|0;Aa=MT(f[z>>2]|0,xa,s)|0;if(!Aa)break i;e=bWb(Aa,201925)|0;if(e|0){Ba=e;break}}while(1){ga=bWb(Ba+17|0,201925)|0;if(!ga)break;else Ba=ga}ya=za-Aa+Ba|0}WC(xa);if((ya|0)<0){LT(z);f[t>>2]=0;f[t+4>>2]=0;_=aD(t,53)|0;$=201943;aa=_+53|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));bO(-2,t,201594,201015,4383);bD(t)}xa=f[z>>2]|0;Ba=xa+64|0;Aa=f[Ba>>2]|0;if(!Aa){za=xa+68|0;s=f[za>>2]|0;if(!s)Ca=za;else{Bmb(s)|0;Ca=za}}else{yUb(Aa)|0;Ca=xa+68|0}f[Ba>>2]=0;f[Ca>>2]=0;f[xa+256>>2]=0;f[xa+264>>2]=0;b[xa+300>>0]=0;xa=YUb(f[(f[z>>2]|0)+60>>2]|0,201997)|0;f[(f[z>>2]|0)+64>>2]=xa;if(!xa){f[t>>2]=0;f[t+4>>2]=0;Ca=aD(t,8)|0;Ba=Ca;b[Ba>>0]=102;b[Ba+1>>0]=115;b[Ba+2>>0]=45;b[Ba+3>>0]=62;Ba=Ca+4|0;b[Ba>>0]=102;b[Ba+1>>0]=105;b[Ba+2>>0]=108;b[Ba+3>>0]=101;bO(-215,t,201594,201015,4387);bD(t);Da=f[(f[z>>2]|0)+64>>2]|0}else Da=xa;dVb(Da,ya,0)|0;vT(f[z>>2]|0,202001);dVb(f[(f[z>>2]|0)+64>>2]|0,0,2)|0;vT(f[z>>2]|0,475789)}Ea=f[z>>2]|0;Fa=237;Ga=20;Ha=267;Ia=238;Ja=1460;Ka=1461;La=266;break}case 16:{if(D)vT(h,202034);else vT(h,202019);Ea=f[z>>2]|0;Fa=239;Ga=21;Ha=269;Ia=240;Ja=1462;Ka=1463;La=268;break}default:{j:do if(D){k:do if(!(dVb(f[h+64>>2]|0,0,2)|0)){ya=0;while(1){if((lTb(f[(f[z>>2]|0)+64>>2]|0)|0)==125)break;Da=ya+-1|0;if(!(dVb(f[(f[z>>2]|0)+64>>2]|0,Da,2)|0))ya=Da;else break k}dVb(f[(f[z>>2]|0)+64>>2]|0,ya,2)|0;Da=f[z>>2]|0;xa=Da+64|0;Ba=f[xa>>2]|0;if(!Ba){Ca=Da+68|0;Aa=f[Ca>>2]|0;if(!Aa)Ma=Ca;else{Bmb(Aa)|0;Ma=Ca}}else{yUb(Ba)|0;Ma=Da+68|0}f[xa>>2]=0;f[Ma>>2]=0;f[Da+256>>2]=0;f[Da+264>>2]=0;b[Da+300>>0]=0;Da=YUb(f[(f[z>>2]|0)+60>>2]|0,201997)|0;f[(f[z>>2]|0)+64>>2]=Da;if(!Da){f[t>>2]=0;f[t+4>>2]=0;xa=aD(t,8)|0;Ba=xa;b[Ba>>0]=102;b[Ba+1>>0]=115;b[Ba+2>>0]=45;b[Ba+3>>0]=62;Ba=xa+4|0;b[Ba>>0]=102;b[Ba+1>>0]=105;b[Ba+2>>0]=108;b[Ba+3>>0]=101;bO(-215,t,201594,201015,4441);bD(t);Na=f[(f[z>>2]|0)+64>>2]|0}else Na=Da;dVb(Na,ya,2)|0;SUb(44,f[(f[z>>2]|0)+64>>2]|0)|0;break j}while(0);f[t>>2]=0;f[t+4>>2]=0;_=aD(t,39)|0;$=202043;aa=_+39|0;do{b[_>>0]=b[$>>0]|0;_=_+1|0;$=$+1|0}while((_|0)<(aa|0));bO(-2,t,201594,201015,4447);bD(t)}else vT(h,456033);while(0);h=f[z>>2]|0;f[h+40>>2]=4;Ea=h;Fa=241;Ga=22;Ha=271;Ia=242;Ja=1464;Ka=1465;La=270}}f[Ea+228>>2]=La;f[Ea+232>>2]=Ja;f[Ea+236>>2]=Fa;f[Ea+240>>2]=Ga;f[Ea+244>>2]=Ha;f[Ea+248>>2]=Ia;f[Ea+252>>2]=Ka;qa=Ea}b[qa+300>>0]=1;fa=qa}l:do if(!fa)Oa=0;else{do if((LO()|0)>=0){qa=f[z>>2]|0;Ea=qa+64|0;Ka=f[Ea>>2]|0;Ia=(Ka|0)==0;if(((Ia?(f[qa+68>>2]|0)==0:0)?(f[qa+268>>2]|0)==0:0)?(f[qa+256>>2]|0)==0:0)break;if(f[qa+8>>2]|0){Oa=qa;break l}if(Ia){Ia=qa+68|0;Ha=f[Ia>>2]|0;if(!Ha)Pa=Ia;else{Bmb(Ha)|0;Pa=Ia}}else{yUb(Ka)|0;Pa=qa+68|0}f[Ea>>2]=0;f[Pa>>2]=0;f[qa+256>>2]=0;f[qa+264>>2]=0;b[qa+300>>0]=0;qa=f[z>>2]|0;b[qa+300>>0]=1;Oa=qa;break l}while(0);LT(z);Oa=f[z>>2]|0}while(0);z=f[A>>2]|0;if(!z){u=g;return Oa|0}Pa=f[H>>2]|0;if((Pa|0)==(z|0))Qa=z;else{fa=Pa;while(1){Pa=fa+-12|0;f[H>>2]=Pa;if((b[Pa+11>>0]|0)<0){O5b(f[Pa>>2]|0);Ra=f[H>>2]|0}else Ra=Pa;if((Ra|0)==(z|0))break;else fa=Ra}Qa=f[A>>2]|0}O5b(Qa);u=g;return Oa|0}function HT(a){a=a|0;O5b(a);return}function IT(a){a=a|0;PQ(a+12|0,f[a+8>>2]|0);if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function JT(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=f[a>>2]|0;g=((f[d>>2]|0)-e|0)/12|0;h=g+1|0;if(h>>>0>357913941)c4b(a);i=a+8|0;j=((f[i>>2]|0)-e|0)/12|0;e=j<<1;k=j>>>0<178956970?(e>>>0<h>>>0?h:e):357913941;do if(k)if(k>>>0>357913941){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{l=L5b(k*12|0)|0;break}else l=0;while(0);e=l+(g*12|0)|0;g=e;h=l+(k*12|0)|0;X5b(e,c);c=e+12|0;k=f[a>>2]|0;l=f[d>>2]|0;if((l|0)==(k|0)){m=g;n=k;o=k}else{j=l;l=g;g=e;do{j=j+-12|0;X5b(g+-12|0,j);g=l+-12|0;l=g}while((j|0)!=(k|0));m=l;n=f[a>>2]|0;o=f[d>>2]|0}f[a>>2]=m;f[d>>2]=c;f[i>>2]=h;h=n;if((o|0)!=(h|0)){i=o;do{i=i+-12|0;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0)}while((i|0)!=(h|0))}if(!n)return;O5b(n);return}function KT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=(d-c|0)/12|0;g=a+8|0;h=f[g>>2]|0;i=f[a>>2]|0;j=i;if(e>>>0<=((h-i|0)/12|0)>>>0){k=a+4|0;l=((f[k>>2]|0)-i|0)/12|0;m=e>>>0>l>>>0;n=c+(l*12|0)|0;l=m?n:d;if((l|0)==(c|0))o=j;else{p=c;q=j;while(1){_5b(q,p)|0;p=p+12|0;r=q+12|0;if((p|0)==(l|0)){o=r;break}else q=r}}if(m){if((l|0)==(d|0))return;l=n;n=f[k>>2]|0;do{X5b(n,l);l=l+12|0;n=(f[k>>2]|0)+12|0;f[k>>2]=n}while((l|0)!=(d|0));return}l=f[k>>2]|0;if((l|0)==(o|0))return;else s=l;while(1){l=s+-12|0;f[k>>2]=l;if((b[l+11>>0]|0)<0){O5b(f[l>>2]|0);t=f[k>>2]|0}else t=l;if((t|0)==(o|0))break;else s=t}return}if(!i)u=h;else{h=a+4|0;t=f[h>>2]|0;if((t|0)==(j|0))v=i;else{i=t;while(1){t=i+-12|0;f[h>>2]=t;if((b[t+11>>0]|0)<0){O5b(f[t>>2]|0);w=f[h>>2]|0}else w=t;if((w|0)==(j|0))break;else i=w}v=f[a>>2]|0}O5b(v);f[g>>2]=0;f[h>>2]=0;f[a>>2]=0;u=0}if(e>>>0>357913941)c4b(a);h=(u|0)/12|0;u=h<<1;v=h>>>0<178956970?(u>>>0<e>>>0?e:u):357913941;if(v>>>0>357913941)c4b(a);u=L5b(v*12|0)|0;e=a+4|0;f[e>>2]=u;f[a>>2]=u;f[g>>2]=u+(v*12|0);if((c|0)==(d|0))return;v=c;c=u;do{X5b(c,v);v=v+12|0;c=(f[e>>2]|0)+12|0;f[e>>2]=c}while((v|0)!=(d|0));return}function LT(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;e=aD(d,35)|0;g=200970;h=e+35|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-27,d,206848,201015,700);bD(d)}d=f[a>>2]|0;if(!d){u=c;return}f[a>>2]=0;tT(d,0);BW(d+24|0);a=d+76|0;WC(f[a>>2]|0);f[a>>2]=0;BW(d+16|0);a=f[d+268>>2]|0;if(a|0){g=a+4|0;e=f[g>>2]|0;h=a+16|0;i=f[h>>2]|0;j=e+(i>>>12<<2)|0;k=a+8|0;l=f[k>>2]|0;m=l;n=e;if((l|0)==(e|0)){o=0;p=a+20|0;q=0}else{l=a+20|0;r=(f[l>>2]|0)+i|0;o=(f[e+(r>>>12<<2)>>2]|0)+(r&4095)|0;p=l;q=(f[j>>2]|0)+(i&4095)|0}i=j;j=q;a:while(1){q=j;do{l=q;if((l|0)==(o|0))break a;q=l+1|0}while((q-(f[i>>2]|0)|0)!=4096);q=i+4|0;i=q;j=f[q>>2]|0}f[p>>2]=0;p=m-n>>2;if(p>>>0>2){n=e;do{O5b(f[n>>2]|0);n=(f[g>>2]|0)+4|0;f[g>>2]=n;e=(f[k>>2]|0)-n>>2}while(e>>>0>2);s=e}else s=p;switch(s|0){case 1:{t=2048;v=17;break}case 2:{t=4096;v=17;break}default:{}}if((v|0)==17)f[h>>2]=t;t=f[g>>2]|0;h=f[k>>2]|0;if((t|0)!=(h|0)){v=t;do{O5b(f[v>>2]|0);v=v+4|0}while((v|0)!=(h|0));h=f[g>>2]|0;g=f[k>>2]|0;if((g|0)!=(h|0))f[k>>2]=g+(~((g+-4-h|0)>>>2)<<2)}h=f[a>>2]|0;if(h|0)O5b(h);O5b(a)}a=f[d+272>>2]|0;if(a|0){h=f[a>>2]|0;if(h|0){CT(h);O5b(h)}h=a+4|0;if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);O5b(a)}a=f[d+288>>2]|0;if(a|0)P5b(a);a=f[d+296>>2]|0;if(a|0)P5b(a);Nac(d|0,0,304)|0;WC(d);u=c;return}function MT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+16|0;g=e;h=f[a+256>>2]|0;if(h|0){i=a+264|0;j=f[a+260>>2]|0;k=d+-1|0;l=f[i>>2]|0;m=0;while(1){if(!((m|0)<(k|0)&l>>>0<j>>>0)){n=l;o=m;break}p=l+1|0;q=b[h+l>>0]|0;r=m+1|0;if(!(q<<24>>24)){n=p;o=m;break}b[c+m>>0]=q;if(q<<24>>24==10){n=p;o=r;break}else{l=p;m=r}}b[c+o>>0]=0;f[i>>2]=n;s=(o|0)>0?c:0;u=e;return s|0}o=f[a+64>>2]|0;if(o|0){s=MUb(c,d,o)|0;u=e;return s|0}o=f[a+68>>2]|0;if(!o){f[g>>2]=0;f[g+4>>2]=0;a=aD(g,25)|0;n=201107;i=a+25|0;do{b[a>>0]=b[n>>0]|0;a=a+1|0;n=n+1|0}while((a|0)<(i|0));bO(-2,g,206840,201015,434);bD(g);s=0;u=e;return s|0}else{s=Kmb(o,c,d)|0;u=e;return s|0}return 0}function NT(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+80|0;h=g+48|0;i=g+8|0;j=g;k=d&15|32;if((d&7)>>>0<=4){f[j>>2]=0;f[j+4>>2]=0;l=aD(j,66)|0;m=206750;n=l+66|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-5,j,206817,201015,2974);bD(j)}if((e|0)!=0?(b[e>>0]|0)!=0:0){f[i>>2]=203719;f[i+4>>2]=e;o=2}else o=0;f[i+(o<<2)>>2]=0;WU(a,c,1,i,0);i=a+44|0;f[h+20>>2]=f[i>>2]&-33;o=a+40|0;f[h+16>>2]=f[o>>2];e=a+48|0;m=e;l=f[m+4>>2]|0;n=h+8|0;f[n>>2]=f[m>>2];f[n+4>>2]=l;l=a+24|0;DW(f[l>>2]|0,h);XW(f[a+36>>2]|0,h)|0;h=(f[o>>2]|0)+2|0;f[o>>2]=h;if(!(d&8)){d=a+72|0;n=f[d>>2]|0;m=a+76|0;p=f[m>>2]|0;q=a+56|0;r=f[q>>2]|0;if(n>>>0>(p+r|0)>>>0){b[n>>0]=10;b[n+1>>0]=0;vT(a,f[m>>2]|0);n=f[m>>2]|0;f[d>>2]=n;s=f[q>>2]|0;t=f[o>>2]|0;v=n}else{s=r;t=h;v=p}if((s|0)==(t|0))w=v;else{Nac(v|0,32,t|0)|0;f[q>>2]=t;w=f[m>>2]|0}f[d>>2]=w+t}f[i>>2]=k;if(!c){f[a+52>>2]=0;f[e>>2]=0;u=g;return}else{HW(j,f[l>>2]|0,c,-1);c=j;j=f[c+4>>2]|0;l=e;f[l>>2]=f[c>>2];f[l+4>>2]=j;u=g;return}}function OT(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+5136|0;h=g+8|0;i=g+16|0;j=g;k=d&15|32;l=d&7;if(l>>>0<=4){f[j>>2]=0;f[j+4>>2]=0;d=aD(j,68)|0;m=206610;n=d+68|0;do{b[d>>0]=b[m>>0]|0;d=d+1|0;m=m+1|0}while((d|0)<(n|0));bO(-5,j,206726,201015,3965);bD(j)}if((e|0)!=0?(b[e>>0]|0)!=0:0)if(!(ZVb(e,201467,6)|0)){o=0;p=e;q=3;r=i}else{s=1;t=e;v=6}else{s=0;t=0;v=6}if((v|0)==6){b[i>>0]=(l|0)==6?123:91;o=s;p=t;q=k;r=i+1|0}b[r>>0]=0;UU(a,c,i);i=a+44|0;f[h>>2]=f[i>>2];XW(f[a+36>>2]|0,h)|0;f[i>>2]=q;q=a+40|0;f[q>>2]=(f[q>>2]|0)+4;if(!o){u=g;return}th[f[a+244>>2]&511](a,203719,p,1);u=g;return}function PT(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+5152|0;h=g+8|0;i=g;j=g+24|0;k=g+32|0;l=g+16|0;if(!e)m=0;else m=(b[e>>0]|0)==0?0:e;e=d&15;n=e|32;o=d&7;if(o>>>0<=4){f[l>>2]=0;f[l+4>>2]=0;p=aD(l,68)|0;q=206610;r=p+68|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-5,l,206679,201015,2011);bD(l)}l=(m|0)!=0;if(l?(ZVb(m,201467,6)|0)==0:0){p=k;q=206702;r=p+11|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));s=5;t=k}else v=8;do if((v|0)==8){if(!(d&8)){if(!l){s=n;t=0;break}f[h>>2]=m;_Ub(k,206721,h)|0;s=n;t=k;break}q=(o|0)==6?123:91;p=e|40;if(l){f[i>>2]=m;f[i+4>>2]=q&255;_Ub(k,206713,i)|0;s=p;t=k;break}else{b[k>>0]=q;b[k+1>>0]=0;s=p;t=k;break}}while(0);TU(a,c,t);t=a+44|0;f[j>>2]=f[t>>2];XW(f[a+36>>2]|0,j)|0;f[t>>2]=s;t=a+40|0;if(f[j>>2]&8|0){u=g;return}f[t>>2]=(s>>>3&1)+3+(f[t>>2]|0);u=g;return}function QT(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+32|0;d=c+8|0;e=c;g=a+36|0;if(!(f[(f[g>>2]|0)+24>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;h=aD(e,20)|0;i=206568;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-2,e,206589,201015,3017);bD(e)}WU(a,f[a+52>>2]|0,2,0,0);YW(f[g>>2]|0,d);f[a+40>>2]=f[d+16>>2];f[a+44>>2]=f[d+20>>2];g=d+8|0;e=f[g+4>>2]|0;i=a+48|0;f[i>>2]=f[g>>2];f[i+4>>2]=e;EW(f[a+24>>2]|0,d);u=c;return}function RT(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=u;u=u+16|0;d=c;e=a+36|0;g=f[e>>2]|0;if(!(f[g+24>>2]|0)){f[d>>2]=0;f[d+4>>2]=0;h=aD(d,44)|0;i=206480;j=h+44|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-2,d,206546,201015,4006);bD(d);k=f[e>>2]|0}else k=g;f[d>>2]=0;g=a+44|0;e=f[g>>2]|0;YW(k,d);k=a+40|0;i=(f[k>>2]|0)+-4|0;f[k>>2]=i;f[g>>2]=f[d>>2]&-33;d=e&7;if(d>>>0<=4){u=c;return}g=a+72|0;h=f[g>>2]|0;j=a+76|0;l=f[j>>2]|0;if(!(e&8)){m=a+56|0;n=f[m>>2]|0;if(h>>>0>(l+n|0)>>>0){o=l;p=n;q=h}else{f[g>>2]=h+1;b[h>>0]=10;n=f[g>>2]|0;f[g>>2]=n+1;b[n>>0]=0;vT(a,f[j>>2]|0);n=f[j>>2]|0;f[g>>2]=n;r=n;o=r;p=f[m>>2]|0;q=r}if(q>>>0>(o+p|0)>>>0){b[q>>0]=10;b[q+1>>0]=0;vT(a,f[j>>2]|0);a=f[j>>2]|0;f[g>>2]=a;s=f[m>>2]|0;t=a}else{s=p;t=o}o=f[k>>2]|0;if((s|0)==(o|0)){v=s;w=t;x=s}else{Nac(t|0,32,o|0)|0;f[m>>2]=o;v=f[k>>2]|0;w=f[j>>2]|0;x=o}o=w+x|0;f[g>>2]=o;y=w;z=v;A=o}else{y=l;z=i;A=h}if((e&32|0)==0&A>>>0>(y+z|0)>>>0){b[A>>0]=32;B=A+1|0}else B=A;b[B>>0]=(d|0)==6?125:93;f[g>>2]=B+1;u=c;return}function ST(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+16|0;d=c+8|0;e=c;f[d>>2]=0;g=a+44|0;h=f[g>>2]|0;i=a+36|0;j=f[i>>2]|0;if(!(f[j+24>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,44)|0;l=206480;m=k+44|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,e,206525,201015,2059);bD(e);n=f[i>>2]|0}else n=j;YW(n,d);n=h&8;if(!n){if(h&32|0){j=a+72|0;i=f[j>>2]|0;e=a+76|0;l=f[e>>2]|0;k=a+56|0;m=f[k>>2]|0;if(i>>>0>(l+m|0)>>>0){b[i>>0]=10;b[i+1>>0]=0;vT(a,f[e>>2]|0);i=f[e>>2]|0;f[j>>2]=i;o=f[k>>2]|0;p=i}else{o=m;p=l}l=f[a+40>>2]|0;if((o|0)==(l|0)){q=p;r=o}else{Nac(p|0,32,l|0)|0;f[k>>2]=l;q=f[e>>2]|0;r=l}l=q+r|0;f[j>>2]=l;r=(h&7|0)==6?32123:23899;b[l>>0]=r;b[l+1>>0]=r>>8;s=j;t=l+2|0;v=13}}else{l=a+72|0;j=f[l>>2]|0;if((h&32|0)==0?j>>>0>((f[a+76>>2]|0)+(f[a+40>>2]|0)|0)>>>0:0){b[j>>0]=32;w=j+1|0}else w=j;b[w>>0]=(h&7|0)==6?125:93;s=l;t=w+1|0;v=13}if((v|0)==13)f[s>>2]=t;t=f[d>>2]|0;d=a+40|0;if(t&8|0){f[g>>2]=t;u=c;return}f[d>>2]=-3-(n>>>3)+(f[d>>2]|0);f[g>>2]=t;u=c;return}function TT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+128|0;f=e+23|0;b[f>>0]=0;g=f;f=(d|0)>-1?d:0-d|0;while(1){h=f;f=(f>>>0)/10|0;i=h+48+(Y(f,-10)|0)&255;j=g+-1|0;b[j>>0]=i;if(h>>>0<=9)break;else g=j}if((d|0)<0){d=g+-2|0;b[d>>0]=45;k=d}else k=j;VU(a,c,k,kUb(k)|0);u=e;return}function UT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+128|0;f=e+23|0;b[f>>0]=0;g=f;f=(d|0)>-1?d:0-d|0;while(1){h=f;f=(f>>>0)/10|0;i=h+48+(Y(f,-10)|0)&255;j=g+-1|0;b[j>>0]=i;if(h>>>0<=9)break;else g=j}if((d|0)>=0){k=j;UU(a,c,k);u=e;return}j=g+-2|0;b[j>>0]=45;k=j;UU(a,c,k);u=e;return}function VT(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+128|0;f=e+23|0;b[f>>0]=0;g=f;f=(d|0)>-1?d:0-d|0;while(1){h=f;f=(f>>>0)/10|0;i=h+48+(Y(f,-10)|0)&255;j=g+-1|0;b[j>>0]=i;if(h>>>0<=9)break;else g=j}if((d|0)>=0){k=j;TU(a,c,k);u=e;return}j=g+-2|0;b[j>>0]=45;k=j;TU(a,c,k);u=e;return}function WT(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+128|0;e=d;VU(a,b,e,kUb(XU(e,c)|0)|0);u=d;return}function XT(a,c,d){a=a|0;c=c|0;d=+d;var e=0,f=0,g=0;e=u;u=u+128|0;f=e;g=kUb(XU(f,d)|0)|0;if(g|0?(b[f+(g+-1)>>0]|0)==46:0){b[f+g>>0]=48;b[f+(g+1)>>0]=0}UU(a,c,f);u=e;return}function YT(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=u;u=u+128|0;TU(a,b,XU(d,c)|0);u=d;return}function ZT(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=u;u=u+24608|0;h=g;i=g+16|0;j=g+8|0;if(!d){f[j>>2]=0;f[j+4>>2]=0;k=aD(j,19)|0;l=205717;m=k+19|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-27,j,206114,201015,3122);bD(j)}n=kUb(d)|0;if((n|0)>4096){f[j>>2]=0;f[j+4>>2]=0;k=aD(j,30)|0;l=205755;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-5,j,206114,201015,3126);bD(j)}j=(e|0)!=0|(n|0)==0;if((!j?(b[d>>0]|0)==34:0)?(b[d+(n+-1)>>0]|0)==34:0){o=n;p=d;VU(a,c,p,o);u=g;return}e=j&1;j=i+1|0;b[i>>0]=34;if((n|0)>0){l=e;k=0;m=j;while(1){q=b[d+k>>0]|0;r=q&255;a:do if(q<<24>>24<0|q<<24>>24==32){b[m>>0]=q;s=m;t=1}else{b:do if((q&255)>=32){switch(q<<24>>24){case 34:case 38:case 39:case 60:case 62:{break b;break}default:{}}b[m>>0]=q;s=m;t=l;break a}while(0);v=m+1|0;b[m>>0]=38;switch(q<<24>>24){case 60:{b[v>>0]=108;b[v+1>>0]=116;w=3;break}case 62:{b[v>>0]=103;b[v+1>>0]=116;w=3;break}case 38:{b[v>>0]=b[204992]|0;b[v+1>>0]=b[204993]|0;b[v+2>>0]=b[204994]|0;w=4;break}case 39:{b[v>>0]=97;b[v+1>>0]=112;b[v+2>>0]=111;b[v+3>>0]=115;w=5;break}case 34:{b[v>>0]=113;b[v+1>>0]=117;b[v+2>>0]=111;b[v+3>>0]=116;w=5;break}default:{f[h>>2]=r;_Ub(v,206132,h)|0;w=5}}v=m+w|0;b[v>>0]=59;s=v;t=1}while(0);r=s+1|0;k=k+1|0;if((k|0)==(n|0)){x=r;y=t;break}else{l=t;m=r}}}else{x=j;y=e}if(!y){e=b[d>>0]|0;if((e+-48&255)<10){z=1;A=26}else switch(e<<24>>24){case 46:case 45:case 43:{z=1;A=26;break}default:{B=x;C=1}}}else{z=y;A=26}if((A|0)==26){b[x>>0]=34;B=x+1|0;C=(z|0)==0}b[B>>0]=0;o=(C<<31>>31)-i+B|0;p=i+(C&1)|0;VU(a,c,p,o);u=g;return}function _T(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16416|0;h=g+8|0;i=g;if(!d){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,19)|0;k=205717;l=j+19|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-27,i,206082,201015,4086);bD(i)}m=kUb(d)|0;if((m|0)>4096){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,30)|0;k=205755;l=j+30|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-5,i,206082,201015,4090);bD(i)}a:do if(!((e|0)!=0|(m|0)==0)?(i=b[d>>0]|0,i<<24>>24==(b[d+(m+-1)>>0]|0)):0){switch(i<<24>>24){case 39:case 34:{n=d;break}default:break a}UU(a,c,n);u=g;return}while(0);e=h+1|0;b[h>>0]=34;b:do if((m|0)>0){i=0;k=e;while(1){j=b[d+i>>0]|0;switch(j<<24>>24|0){case 39:case 34:case 92:{b[k>>0]=92;b[k+1>>0]=j;o=k+2|0;break}case 10:{b[k>>0]=92;b[k+1>>0]=110;o=k+2|0;break}case 13:{b[k>>0]=92;b[k+1>>0]=114;o=k+2|0;break}case 9:{b[k>>0]=92;b[k+1>>0]=116;o=k+2|0;break}case 8:{b[k>>0]=92;b[k+1>>0]=98;o=k+2|0;break}case 12:{b[k>>0]=92;b[k+1>>0]=102;o=k+2|0;break}default:{b[k>>0]=j;o=k+1|0}}i=i+1|0;if((i|0)==(m|0)){p=o;break b}else k=o}}else p=e;while(0);b[p>>0]=34;b[p+1>>0]=0;n=h;UU(a,c,n);u=g;return}function $T(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+16416|0;h=g;i=g+16|0;j=g+8|0;if(!d){f[j>>2]=0;f[j+4>>2]=0;k=aD(j,19)|0;l=205717;m=k+19|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-27,j,205737,201015,2128);bD(j)}n=kUb(d)|0;if((n|0)>4096){f[j>>2]=0;f[j+4>>2]=0;k=aD(j,30)|0;l=205755;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-5,j,205737,201015,2132);bD(j)}if((e|0)!=0|(n|0)==0)o=1;else{e=b[d>>0]|0;a:do if(e<<24>>24==(b[d+(n+-1)>>0]|0)){switch(e<<24>>24){case 39:case 34:{p=d;break}default:break a}TU(a,c,p);u=g;return}while(0);o=e<<24>>24==32}e=o&1;j=i+1|0;b[i>>0]=34;if((n|0)>0){l=j;k=e;m=0;q=o;while(1){r=b[d+m>>0]|0;s=r+-48<<24>>24;b:do if(!q){t=(r&-33)+-65<<24>>24;if((s&255)<10|(t&255)<26){v=0;w=t}else{switch(r<<24>>24){case 32:case 40:case 41:case 43:case 45:case 47:case 59:case 95:{v=0;w=t;break b;break}default:{}}v=1;w=t}}else{v=k;w=(r&-33)+-65<<24>>24}while(0);c:do if((s&255)<10|(w&255)<26)x=24;else{if((r&255)>31){switch(r<<24>>24){case 34:case 39:case 92:break;default:{x=24;break c}}b[l>>0]=92;b[l+1>>0]=r;y=l+2|0;break}t=l+1|0;b[l>>0]=92;switch(r<<24>>24){case 10:{b[t>>0]=110;y=l+2|0;break c;break}case 13:{b[t>>0]=114;y=l+2|0;break c;break}case 9:{b[t>>0]=116;y=l+2|0;break c;break}default:{f[h>>2]=r<<24>>24;_Ub(t,205786,h)|0;y=l+4|0;break c}}}while(0);if((x|0)==24){x=0;b[l>>0]=r;y=l+1|0}m=m+1|0;s=(v|0)!=0;if((m|0)==(n|0)){z=y;A=v;B=s;break}else{l=y;k=v;q=s}}}else{z=j;A=e;B=o}if(!B){B=b[d>>0]|0;if((B+-48&255)<10){C=1;x=29}else switch(B<<24>>24){case 46:case 45:case 43:{C=1;x=29;break}default:{D=z;E=1}}}else{C=A;x=29}if((x|0)==29){b[z>>0]=34;D=z+1|0;E=(C|0)==0}b[D>>0]=0;p=i+(E&1)|0;TU(a,c,p);u=g;return}function aU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=u;u=u+16|0;g=e;h=e+8|0;i=(c|0)==0;if(i){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,12)|0;k=205579;l=j+12|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-27,h,205631,201015,3205);bD(h)}if(bWb(c,489233)|0){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,49)|0;k=205650;l=j+49|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-5,h,205631,201015,3208);bD(h)}h=kUb(c)|0;k=uUb(c,10)|0;j=(k|0)!=0;l=a+72|0;m=f[l>>2]|0;if((d|0)!=0&(j^1)?((f[a+80>>2]|0)-m|0)>=(h+5|0):0)if(m>>>0>((f[a+76>>2]|0)+(f[a+40>>2]|0)|0)>>>0){b[m>>0]=32;n=m+1|0}else n=m;else{d=a+76|0;o=f[d>>2]|0;p=a+56|0;q=f[p>>2]|0;if(m>>>0>(o+q|0)>>>0){b[m>>0]=10;b[m+1>>0]=0;vT(a,f[d>>2]|0);m=f[d>>2]|0;f[l>>2]=m;r=f[p>>2]|0;s=m}else{r=q;s=o}o=f[a+40>>2]|0;if((r|0)==(o|0)){t=s;v=r}else{Nac(s|0,32,o|0)|0;f[p>>2]=o;t=f[d>>2]|0;v=o}o=t+v|0;f[l>>2]=o;n=o}if(j){b[n>>0]=b[205712]|0;b[n+1>>0]=b[205713]|0;b[n+2>>0]=b[205714]|0;b[n+3>>0]=b[205715]|0;b[n+4>>0]=b[205716]|0;w=4;x=n}else{o=h+9|0;h=a+80|0;v=f[h>>2]|0;if((n+o|0)>>>0<v>>>0)y=n;else{t=a+76|0;d=f[t>>2]|0;p=n-d|0;n=((v-d|0)*3|0)/2|0;d=p+o|0;o=(d|0)<(n|0)?n:d;d=VC(o+256|0)|0;n=f[t>>2]|0;f[l>>2]=d+((f[l>>2]|0)-n);if((p|0)>0)Vac(d|0,n|0,p|0)|0;f[t>>2]=d;f[h>>2]=d+o;y=d+p|0}f[g>>2]=c;_Ub(y,205700,g)|0;w=kUb(y)|0;x=y}y=x+w|0;f[l>>2]=y;w=a+76|0;x=f[w>>2]|0;g=a+56|0;p=f[g>>2]|0;if(y>>>0>(x+p|0)>>>0){b[y>>0]=10;b[y+1>>0]=0;vT(a,f[w>>2]|0);y=f[w>>2]|0;f[l>>2]=y;z=y;A=f[g>>2]|0;B=y}else{z=x;A=p;B=x}x=a+40|0;p=f[x>>2]|0;if((A|0)==(p|0)){C=z;D=B;E=A}else{Nac(B|0,32,p|0)|0;f[g>>2]=p;B=f[w>>2]|0;C=B;D=B;E=p}p=D+E|0;f[l>>2]=p;if(!j){u=e;return}if(i)F=p;else{i=a+80|0;j=k;k=c;c=p;p=C;while(1){if(!j){C=kUb(k)|0;E=f[i>>2]|0;if((c+C|0)>>>0<E>>>0)G=c;else{D=c-p|0;B=((E-p|0)*3|0)/2|0;E=D+C|0;A=(E|0)<(B|0)?B:E;E=VC(A+256|0)|0;B=f[w>>2]|0;f[l>>2]=E+((f[l>>2]|0)-B);if((D|0)>0)Vac(E|0,B|0,D|0)|0;f[w>>2]=E;f[i>>2]=E+A;G=E+D|0}Vac(G|0,k|0,C|0)|0;H=0;I=0;J=G+C|0}else{C=j-k|0;D=C+1|0;E=f[i>>2]|0;if((c+D|0)>>>0<E>>>0)K=c;else{A=c-p|0;B=((E-p|0)*3|0)/2|0;E=A+D|0;z=(E|0)<(B|0)?B:E;E=VC(z+256|0)|0;B=f[w>>2]|0;f[l>>2]=E+((f[l>>2]|0)-B);if((A|0)>0)Vac(E|0,B|0,A|0)|0;f[w>>2]=E;f[i>>2]=E+z;K=E+A|0}Vac(K|0,k|0,D|0)|0;D=j+1|0;H=uUb(D,10)|0;I=D;J=K+C|0}f[l>>2]=J;C=f[w>>2]|0;D=f[g>>2]|0;if(J>>>0>(C+D|0)>>>0){b[J>>0]=10;b[J+1>>0]=0;vT(a,f[w>>2]|0);A=f[w>>2]|0;f[l>>2]=A;L=f[g>>2]|0;M=A;N=A}else{L=D;M=C;N=C}C=f[x>>2]|0;if((L|0)==(C|0)){O=M;P=L;Q=N}else{Nac(M|0,32,C|0)|0;f[g>>2]=C;D=f[w>>2]|0;O=D;P=C;Q=D}D=O+P|0;f[l>>2]=D;if(!I){F=D;break}else{j=H;k=I;c=D;p=Q}}}b[F>>0]=45;b[F+1>>0]=45;b[F+2>>0]=62;b[F+3>>0]=0;Q=F+3|0;f[l>>2]=Q;p=f[w>>2]|0;c=f[g>>2]|0;if(Q>>>0>(p+c|0)>>>0){b[Q>>0]=10;b[F+4>>0]=0;vT(a,f[w>>2]|0);a=f[w>>2]|0;f[l>>2]=a;R=f[g>>2]|0;S=a}else{R=c;S=p}p=f[x>>2]|0;if((R|0)==(p|0)){T=S;U=R}else{Nac(S|0,32,p|0)|0;f[g>>2]=p;T=f[w>>2]|0;U=p}f[l>>2]=T+U;u=e;return}function bU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=(c|0)==0;if(h){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,12)|0;j=205579;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-27,g,205611,201015,4129);bD(g)}g=a+72|0;j=f[g>>2]|0;i=uUb(c,10)|0;if(((d|0)!=0&(i|0)==0?(d=kUb(c)|0,((f[a+80>>2]|0)-j|0)>=(d|0)):0)?(j|0)!=(f[a+76>>2]|0):0){b[j>>0]=32;l=0;m=j+1|0}else{d=a+76|0;k=f[d>>2]|0;n=a+56|0;o=f[n>>2]|0;if(j>>>0>(k+o|0)>>>0){b[j>>0]=10;b[j+1>>0]=0;vT(a,f[d>>2]|0);j=f[d>>2]|0;f[g>>2]=j;p=f[n>>2]|0;q=j}else{p=o;q=k}k=f[a+40>>2]|0;if((p|0)==(k|0)){r=q;s=p}else{Nac(q|0,32,k|0)|0;f[n>>2]=k;r=f[d>>2]|0;s=k}k=r+s|0;f[g>>2]=k;l=i;m=k}if(h){u=e;return}h=a+80|0;k=a+76|0;i=a+56|0;s=a+40|0;r=l;l=m;m=c;while(1){b[l>>0]=47;b[l+1>>0]=47;c=l+3|0;b[l+2>>0]=32;if(!r){d=kUb(m)|0;n=f[h>>2]|0;if((c+d|0)>>>0<n>>>0)t=c;else{q=f[k>>2]|0;p=c-q|0;o=((n-q|0)*3|0)/2|0;q=p+d|0;n=(q|0)<(o|0)?o:q;q=VC(n+256|0)|0;o=f[k>>2]|0;f[g>>2]=q+((f[g>>2]|0)-o);if((p|0)>0)Vac(q|0,o|0,p|0)|0;f[k>>2]=q;f[h>>2]=q+n;t=q+p|0}Vac(t|0,m|0,d|0)|0;p=t+d|0;f[g>>2]=p;v=0;w=0;x=p}else{p=r-m|0;d=p+1|0;q=f[h>>2]|0;if((c+d|0)>>>0<q>>>0)y=c;else{n=f[k>>2]|0;o=c-n|0;c=((q-n|0)*3|0)/2|0;n=o+d|0;q=(n|0)<(c|0)?c:n;n=VC(q+256|0)|0;c=f[k>>2]|0;f[g>>2]=n+((f[g>>2]|0)-c);if((o|0)>0)Vac(n|0,c|0,o|0)|0;f[k>>2]=n;f[h>>2]=n+q;y=n+o|0}Vac(y|0,m|0,d|0)|0;d=y+p|0;f[g>>2]=d;p=r+1|0;v=p;w=uUb(p,10)|0;x=d}d=f[k>>2]|0;p=f[i>>2]|0;if(x>>>0>(d+p|0)>>>0){b[x>>0]=10;b[x+1>>0]=0;vT(a,f[k>>2]|0);o=f[k>>2]|0;f[g>>2]=o;z=f[i>>2]|0;A=o}else{z=p;A=d}d=f[s>>2]|0;if((z|0)==(d|0)){B=A;C=z}else{Nac(A|0,32,d|0)|0;f[i>>2]=d;B=f[k>>2]|0;C=d}l=B+C|0;f[g>>2]=l;if(!v)break;else{r=w;m=v}}u=e;return}function cU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+16|0;g=e;h=(c|0)==0;if(h){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,12)|0;j=205579;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-27,g,205592,201015,2190);bD(g)}g=uUb(c,10)|0;j=a+72|0;i=f[j>>2]|0;if((!((d|0)==0|(g|0)!=0)?(d=kUb(c)|0,((f[a+80>>2]|0)-i|0)>=(d|0)):0)?(i|0)!=(f[a+76>>2]|0):0){b[i>>0]=32;l=i+1|0}else{d=a+76|0;k=f[d>>2]|0;m=a+56|0;n=f[m>>2]|0;if(i>>>0>(k+n|0)>>>0){b[i>>0]=10;b[i+1>>0]=0;vT(a,f[d>>2]|0);i=f[d>>2]|0;f[j>>2]=i;o=f[m>>2]|0;p=i}else{o=n;p=k}k=f[a+40>>2]|0;if((o|0)==(k|0)){q=p;r=o}else{Nac(p|0,32,k|0)|0;f[m>>2]=k;q=f[d>>2]|0;r=k}k=q+r|0;f[j>>2]=k;l=k}if(h){u=e;return}h=a+80|0;k=a+76|0;r=a+56|0;q=a+40|0;d=l;l=g;g=c;while(1){b[d>>0]=35;c=d+2|0;b[d+1>>0]=32;if(!l){m=kUb(g)|0;p=f[h>>2]|0;if((c+m|0)>>>0<p>>>0)s=c;else{o=f[k>>2]|0;n=c-o|0;i=((p-o|0)*3|0)/2|0;o=n+m|0;p=(o|0)<(i|0)?i:o;o=VC(p+256|0)|0;i=f[k>>2]|0;f[j>>2]=o+((f[j>>2]|0)-i);if((n|0)>0)Vac(o|0,i|0,n|0)|0;f[k>>2]=o;f[h>>2]=o+p;s=o+n|0}Vac(s|0,g|0,m|0)|0;n=s+m|0;f[j>>2]=n;t=0;v=0;w=n}else{n=l-g|0;m=n+1|0;o=f[h>>2]|0;if((c+m|0)>>>0<o>>>0)x=c;else{p=f[k>>2]|0;i=c-p|0;c=((o-p|0)*3|0)/2|0;p=i+m|0;o=(p|0)<(c|0)?c:p;p=VC(o+256|0)|0;c=f[k>>2]|0;f[j>>2]=p+((f[j>>2]|0)-c);if((i|0)>0)Vac(p|0,c|0,i|0)|0;f[k>>2]=p;f[h>>2]=p+o;x=p+i|0}Vac(x|0,g|0,m|0)|0;m=x+n|0;f[j>>2]=m;n=l+1|0;t=n;v=uUb(n,10)|0;w=m}m=f[k>>2]|0;n=f[r>>2]|0;if(w>>>0>(m+n|0)>>>0){b[w>>0]=10;b[w+1>>0]=0;vT(a,f[k>>2]|0);i=f[k>>2]|0;f[j>>2]=i;y=f[r>>2]|0;z=i}else{y=n;z=m}m=f[q>>2]|0;if((y|0)==(m|0)){A=z;B=y}else{Nac(z|0,32,m|0)|0;f[r>>2]=m;A=f[k>>2]|0;B=m}d=A+B|0;f[j>>2]=d;if(!t)break;else{l=v;g=t}}u=e;return}function dU(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(f[a+12>>2]|0)return;c=a+36|0;if((f[(f[c>>2]|0)+24>>2]|0)>0)do QT(a);while((f[(f[c>>2]|0)+24>>2]|0)>0);c=a+40|0;f[c>>2]=0;d=a+72|0;e=f[d>>2]|0;g=a+76|0;h=f[g>>2]|0;i=a+56|0;j=f[i>>2]|0;if(e>>>0>(h+j|0)>>>0){b[e>>0]=10;b[e+1>>0]=0;vT(a,f[g>>2]|0);e=f[g>>2]|0;f[d>>2]=e;k=f[i>>2]|0;l=f[c>>2]|0;m=e}else{k=j;l=0;m=h}if((k|0)==(l|0))n=m;else{Nac(m|0,32,l|0)|0;f[i>>2]=l;n=f[g>>2]|0}f[d>>2]=n+l;vT(a,205556);f[d>>2]=f[g>>2];return}function eU(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if(f[a+12>>2]|0)return;c=a+36|0;if((f[(f[c>>2]|0)+24>>2]|0)>0)do RT(a);while((f[(f[c>>2]|0)+24>>2]|0)>0);c=a+40|0;f[c>>2]=4;d=a+72|0;e=f[d>>2]|0;g=a+76|0;h=f[g>>2]|0;i=a+56|0;j=f[i>>2]|0;if(e>>>0>(h+j|0)>>>0){b[e>>0]=10;b[e+1>>0]=0;vT(a,f[g>>2]|0);a=f[g>>2]|0;f[d>>2]=a;k=f[i>>2]|0;l=f[c>>2]|0;m=a;n=a}else{k=j;l=4;m=h;n=h}if((k|0)==(l|0))o=n;else{Nac(m|0,32,l|0)|0;f[i>>2]=l;o=f[g>>2]|0}f[d>>2]=o;return}function fU(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(f[a+12>>2]|0)return;c=a+36|0;if((f[(f[c>>2]|0)+24>>2]|0)>0)do ST(a);while((f[(f[c>>2]|0)+24>>2]|0)>0);c=a+40|0;f[c>>2]=0;d=a+72|0;e=f[d>>2]|0;g=a+76|0;h=f[g>>2]|0;i=a+56|0;j=f[i>>2]|0;if(e>>>0>(h+j|0)>>>0){b[e>>0]=10;b[e+1>>0]=0;vT(a,f[g>>2]|0);e=f[g>>2]|0;f[d>>2]=e;k=f[i>>2]|0;l=f[c>>2]|0;m=e}else{k=j;l=0;m=h}if((k|0)==(l|0))n=m;else{Nac(m|0,32,l|0)|0;f[i>>2]=l;n=f[g>>2]|0}f[d>>2]=n+l;vT(a,205546);vT(a,205551);f[d>>2]=f[g>>2];return}function gU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+1072|0;g=e+32|0;h=e+16|0;i=e;j=e+48|0;k=a+80|0;l=a+76|0;m=a+60|0;n=a+88|0;o=a+256|0;p=a+64|0;q=a+68|0;r=a+264|0;s=a+260|0;t=c;c=0;v=d;a:while(1){d=t+-1|0;b:do switch(v|0){case 1:{w=b[t>>0]|0;c:do if((w&255)>31|w<<24>>24==9){x=d;y=w;z=t;while(1){if((y<<24>>24==45?(b[x+2>>0]|0)==45:0)?(b[x+3>>0]|0)==62:0){A=x;B=45;C=z;break c}D=z+1|0;E=b[D>>0]|0;if((E&255)>31|E<<24>>24==9){F=z;y=E;z=D;x=F}else{A=z;B=E;C=D;break}}}else{A=d;B=w;C=t}while(0);w=B<<24>>24==45;G=(w^1)&1;H=c;I=w?A+4|0:C;break}case 3:{w=c;z=d;while(1){x=z+1|0;y=b[x>>0]|0;D=(y<<24>>24==60&1)+w+((y<<24>>24==62)<<31>>31)|0;if((D|0)<0){J=x;K=34;break a}if((y&255)>31|y<<24>>24==9){w=D;z=x}else{G=3;H=D;I=x;break}}break}default:{z=d;d:while(1){L=z+1|0;M=b[L>>0]|0;switch(M<<24>>24){case 9:case 32:{z=L;break}case 60:{break d;break}default:{K=18;break d}}}if((K|0)==18){K=0;if((M&255)>31){J=L;K=34;break a}else{G=v;H=c;I=L;break b}}if((b[z+2>>0]|0)!=33){J=L;K=34;break a}if((b[z+3>>0]|0)!=45){J=L;K=34;break a}if((b[z+4>>0]|0)!=45){J=L;K=34;break a}if(v|0){w=f[n>>2]|0;f[i>>2]=f[m>>2];f[i+4>>2]=w;f[i+8>>2]=205499;_Ub(j,202147,i)|0;MO(-212,205529,j,201015,2278)}G=1;H=c;I=z+5|0}}while(0);d=b[I>>0]|0;if((d&255)>31){t=I;c=H;v=G;continue}w=f[l>>2]|0;x=(f[k>>2]|0)-w|0;switch(d<<24>>24){case 13:case 10:case 0:{N=w;break}default:{w=f[n>>2]|0;f[h>>2]=f[m>>2];f[h+4>>2]=w;f[h+8>>2]=204032;_Ub(j,202147,h)|0;MO(-212,205529,j,201015,2290);N=f[l>>2]|0}}w=MT(a,N,x)|0;if(!w){K=33;break}x=w+((kUb(w)|0)+-1)|0;e:do switch(b[x>>0]|0){case 13:case 10:break;default:{do if(!(f[o>>2]|0)){d=f[p>>2]|0;if(d|0){O=iTb(d)|0;K=30;break}d=f[q>>2]|0;if(d|0){O=Gmb(d)|0;K=30}}else{O=(f[r>>2]|0)>>>0>=(f[s>>2]|0)>>>0&1;K=30}while(0);if((K|0)==30?(K=0,O|0):0)break e;z=f[n>>2]|0;f[g>>2]=f[m>>2];f[g+4>>2]=z;f[g+8>>2]=204531;_Ub(j,202147,g)|0;MO(-212,205529,j,201015,2303)}}while(0);f[n>>2]=(f[n>>2]|0)+1;t=w;c=H;v=G}if((K|0)==33){G=f[l>>2]|0;b[G>>0]=0;f[a+92>>2]=1;J=G;u=e;return J|0}else if((K|0)==34){u=e;return J|0}return 0}function hU(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;h=u;u=u+1200|0;i=h+160|0;j=h+144|0;k=h+128|0;l=h+112|0;m=h+96|0;n=h+80|0;o=h+64|0;p=h+48|0;q=h+32|0;r=h+16|0;s=h+176|0;t=h;v=b[c>>0]|0;if(!(v<<24>>24)){w=f[a+88>>2]|0;f[r>>2]=f[a+60>>2];f[r+4>>2]=w;f[r+8>>2]=205144;_Ub(s,202147,r)|0;MO(-212,205174,s,201015,2681);x=b[c>>0]|0}else x=v;if(x<<24>>24!=60){x=f[a+88>>2]|0;f[q>>2]=f[a+60>>2];f[q+4>>2]=x;f[q+8>>2]=205189;_Ub(s,202147,q)|0;MO(-212,205174,s,201015,2684)}q=c+1|0;x=b[q>>0]|0;a:do if(((x&-33)+-65&255)<26|(x+-48&255)<10){y=q;z=1}else switch(x<<24>>24){case 95:{y=q;z=1;break a;break}case 47:{y=c+2|0;z=2;break a;break}case 63:{y=c+2|0;z=4;break a;break}case 33:{y=c+2|0;z=5;break a;break}default:{v=f[a+88>>2]|0;f[p>>2]=f[a+60>>2];f[p+4>>2]=v;f[p+8>>2]=205215;_Ub(s,202147,p)|0;MO(-212,205174,s,201015,2706);y=q;z=0;break a}}while(0);q=s+4|0;p=(z|0)==4;c=(z|0)==1;x=a+60|0;v=a+88|0;r=t+8+4|0;w=(z|0)==2;A=a+16|0;B=y;y=0;C=0;D=0;E=0;b:while(1){F=b[B>>0]|0;if(!(((F&-33)+-65&255)<26|F<<24>>24==95)){F=f[v>>2]|0;f[o>>2]=f[x>>2];f[o+4>>2]=F;f[o+8>>2]=205232;_Ub(s,202147,o)|0;MO(-212,205174,s,201015,2713)}F=B+-1|0;c:while(1){G=F+1|0;H=b[G>>0]|0;if((H+-48&255)<10|((H&-33)+-65&255)<26){F=G;continue}switch(H<<24>>24){case 45:case 95:{F=G;break}default:break c}}F=OU(a,B,G-B|0,1)|0;if(!F){f[s>>2]=0;f[q>>2]=0;H=aD(s,8)|0;I=H;b[I>>0]=97;b[I+1>>0]=116;b[I+2>>0]=116;b[I+3>>0]=114;I=H+4|0;b[I>>0]=110;b[I+1>>0]=97;b[I+2>>0]=109;b[I+3>>0]=101;bO(-215,s,205174,201015,2720);bD(s)}if(!y){J=F;K=E;L=C;M=D}else{if(w){I=f[v>>2]|0;f[n>>2]=f[x>>2];f[n+4>>2]=I;f[n+8>>2]=205278;_Ub(s,202147,n)|0;MO(-212,205174,s,201015,2728)}I=(D|0)!=0;if((E|0)>3|I^1){H=FW(f[A>>2]|0,44)|0;N=H+4|0;O=N+40|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[H>>2]=H+8;if(I){f[D+4>>2]=H;P=0;Q=C;R=H}else{P=0;Q=H;R=H}}else{P=E;Q=C;R=D}f[(f[R>>2]|0)+(P<<1<<2)>>2]=f[F+8>>2];J=y;K=P;L=Q;M=R}if(!M){S=G;T=K}else{if((b[G>>0]|0)!=61){N=gU(a,G,2)|0;if((b[N>>0]|0)==61)U=N;else{O=f[v>>2]|0;f[m>>2]=f[x>>2];f[m+4>>2]=O;f[m+8>>2]=205324;_Ub(s,202147,m)|0;MO(-212,205174,s,201015,2754);U=N}}else U=G;N=U+1|0;d:do switch(b[N>>0]|0){case 39:case 34:{V=N;break}default:{O=gU(a,N,2)|0;switch(b[O>>0]|0){case 39:case 34:{V=O;break d;break}default:{}}W=f[v>>2]|0;f[l>>2]=f[x>>2];f[l+4>>2]=W;f[l+8>>2]=205365;_Ub(s,202147,l)|0;MO(-212,205174,s,201015,2762);V=O}}while(0);N=iU(a,V,t,3)|0;f[(f[M>>2]|0)+((K<<1|1)<<2)>>2]=f[r>>2];S=N;T=K+1|0}N=b[S>>0]|0;if(N<<24>>24==62){X=35;break}Y=gU(a,S,2)|0;F=b[Y>>0]|0;if(F<<24>>24==62){X=37;break}if(p&F<<24>>24==63){X=41;break}if(F<<24>>24==47?c&(b[Y+1>>0]|0)==62:0){X=46;break}switch(N<<24>>24){case 0:case 9:case 10:case 11:case 12:case 13:case 32:{B=Y;y=J;C=L;D=M;E=T;continue b;break}default:{}}N=f[v>>2]|0;f[i>>2]=f[x>>2];f[i+4>>2]=N;f[i+8>>2]=205458;_Ub(s,202147,i)|0;MO(-212,205174,s,201015,2802);B=Y;y=J;C=L;D=M;E=T}if((X|0)==35)if(p){Z=S;X=38}else _=S;else if((X|0)==37)if(p){Z=Y;X=38}else _=Y;else if((X|0)==41){if((b[Y+1>>0]|0)!=62){p=f[v>>2]|0;f[j>>2]=f[x>>2];f[j+4>>2]=p;f[j+8>>2]=205424;_Ub(s,202147,j)|0;MO(-212,205174,s,201015,2790)}$=4;aa=Y+2|0;f[d>>2]=J;f[g>>2]=$;f[e>>2]=L;u=h;return aa|0}else if((X|0)==46){$=3;aa=Y+2|0;f[d>>2]=J;f[g>>2]=$;f[e>>2]=L;u=h;return aa|0}if((X|0)==38){X=f[v>>2]|0;f[k>>2]=f[x>>2];f[k+4>>2]=X;f[k+8>>2]=205424;_Ub(s,202147,k)|0;MO(-212,205174,s,201015,2783);_=Z}$=z;aa=_+1|0;f[d>>2]=J;f[g>>2]=$;f[e>>2]=L;u=h;return aa|0}function iU(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;g=u;u=u+5360|0;h=g+1216|0;i=g+1200|0;j=g+1184|0;k=g+1168|0;l=g+1152|0;m=g+1136|0;n=g+1120|0;o=g+1104|0;q=g+1088|0;r=g+1072|0;t=g+1056|0;v=g+1040|0;w=g+1024|0;x=g;y=g+5352|0;z=g+1240|0;A=g+1236|0;B=g+1232|0;C=g+1228|0;D=e&16;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;E=e&7;e=(E|0)==3;F=a+60|0;G=a+88|0;H=a+16|0;I=(E+-1|0)>>>0<4;J=d+8|0;K=x+4|0;L=c;c=1;M=1;a:while(1){N=b[L>>0]|0;switch(N<<24>>24){case 0:case 9:case 10:case 11:case 12:case 13:case 32:{O=5;break}case 60:{P=b[L+1>>0]|0;if(P<<24>>24==33)if((b[L+2>>0]|0)==45)O=5;else{Q=60;R=c;S=L;T=33;O=7}else{Q=60;R=c;S=L;T=P;O=7}break}default:{U=N;V=L;W=c;O=6}}if((O|0)==5){O=0;N=gU(a,L,0)|0;U=b[N>>0]|0;V=N;W=1;O=6}b:do if((O|0)==6){O=0;N=b[V+1>>0]|0;switch(U<<24>>24){case 0:case 60:{Q=U;R=W;S=V;T=N;O=7;break b;break}default:{}}if(!W){P=f[G>>2]|0;f[q>>2]=f[F>>2];f[q+4>>2]=P;f[q+8>>2]=204741;_Ub(x,202147,q)|0;MO(-212,204641,x,201015,2515)}P=f[d>>2]|0;if(!P)X=d;else{if((P&7)>>>0<=4){P=IW(0,56,16,f[H>>2]|0)|0;if(f[d>>2]&7|0)XW(P,d)|0;f[J>>2]=P;f[d>>2]=5;JW(P,8)}P=XW(f[J>>2]|0,0)|0;f[P+4>>2]=0;X=P}c:do if(!e){d:do if((U+-48&255)<10)Y=U;else switch(U<<24>>24){case 43:case 45:{if(N<<24>>24==46|(N+-48&255)<10){Y=U;break d}else{O=67;break c}break}case 46:{if((N+-48&255)<10|((N&-33)+-65&255)<26){Y=46;break d}else{O=67;break c}break}default:{O=67;break c}}while(0);P=V+((U<<24>>24==43|Y<<24>>24==45)&1)|0;while(1){f[y>>2]=P;Z=b[P>>0]|0;if((Z+-48&255)<10)P=P+1|0;else break}switch(Z<<24>>24){case 101:case 46:{_=+wU(a,V,y);f[X>>2]=2;p[X+8>>3]=_;break}default:{P=WVb(V,y,0)|0;f[X>>2]=1;f[X+8>>2]=P}}P=f[y>>2]|0;if((P|0)==(V|0)){$=f[G>>2]|0;f[o>>2]=f[F>>2];f[o+4>>2]=$;f[o+8>>2]=203074;_Ub(x,202147,o)|0;MO(-212,204641,x,201015,2552);aa=P}else aa=P}else O=67;while(0);if((O|0)==67){O=0;Nac(z|0,0,4112)|0;f[X>>2]=3;N=U<<24>>24==34;P=0;$=N?V:V+-1|0;e:while(1){ba=$+1|0;ca=b[ba>>0]|0;f:do if((ca+-48&255)<10|((ca&-33)+-65&255)<26){da=P;ea=ca;fa=ba}else{if(ca<<24>>24==34){O=70;break e}if((ca&255)<32|ca<<24>>24==60){O=76;break e}if(N)switch(ca<<24>>24){case 62:case 39:{O=79;break}case 38:break;default:{da=P;ea=ca;fa=ba;break f}}else switch(ca<<24>>24){case 9:case 10:case 11:case 12:case 13:case 32:{ga=ba;break e;break}case 62:case 39:{O=79;break}case 38:break;default:{da=P;ea=ca;fa=ba;break f}}if((O|0)==79){O=0;ha=f[G>>2]|0;f[l>>2]=f[F>>2];f[l+4>>2]=ha;f[l+8>>2]=204855;_Ub(x,202147,l)|0;MO(-212,204641,x,201015,2587);da=P;ea=ca;fa=ba;break}ha=$+2|0;if((b[ha>>0]|0)==35){ia=$+3|0;ja=(b[ia>>0]|0)==120;ka=WVb(ja?$+4|0:ia,y,ja?16:10)|0;ja=f[y>>2]|0;if(!(ka>>>0<256&(ja|0)!=0?(b[ja>>0]|0)==59:0)){ia=f[G>>2]|0;f[k>>2]=f[F>>2];f[k+4>>2]=ia;f[k+8>>2]=204906;_Ub(x,202147,k)|0;MO(-212,204641,x,201015,2603)}da=P;ea=ka&255;fa=ja;break}f[y>>2]=ha;ja=ha;do{ja=ja+1|0;la=b[ja>>0]|0}while((la+-48&255)<10|((la&-33)+-65&255)<26);f[y>>2]=ja;if(la<<24>>24!=59){ka=f[G>>2]|0;f[j>>2]=f[F>>2];f[j+4>>2]=ka;f[j+8>>2]=204942;_Ub(x,202147,j)|0;MO(-212,204641,x,201015,2612)}ka=ja-ha|0;switch(ka|0){case 2:{if(!(ZVb(ha,204986,2)|0)){da=P;ea=60;fa=ja;break f}if(!(ZVb(ha,204989,2)|0)){da=P;ea=62;fa=ja;break f}break}case 3:{if(!(ZVb(ha,204992,3)|0)){da=P;ea=38;fa=ja;break f}break}case 4:{if(!(ZVb(ha,204996,4)|0)){da=P;ea=39;fa=ja;break f}if(!(ZVb(ha,205001,4)|0)){da=P;ea=34;fa=ja;break f}break}default:{}}ia=ka+2|0;Vac(z+P|0,ba|0,ia|0)|0;da=ia+P|0;ea=la;fa=ja}while(0);ca=da+1|0;b[z+da>>0]=ea;if((da|0)<=4094){P=ca;$=fa;continue}ia=f[G>>2]|0;f[i>>2]=f[F>>2];f[i+4>>2]=ia;f[i+8>>2]=204147;_Ub(x,202147,i)|0;MO(-212,204641,x,201015,2635);P=ca;$=fa}if((O|0)==70){O=0;if(!N){ca=f[G>>2]|0;f[n>>2]=f[F>>2];f[n+4>>2]=ca;f[n+8>>2]=204780;_Ub(x,202147,n)|0;MO(-212,204641,x,201015,2575)}ga=$+2|0}else if((O|0)==76){O=0;if(N){ca=f[G>>2]|0;f[m>>2]=f[F>>2];f[m+4>>2]=ca;f[m+8>>2]=204833;_Ub(x,202147,m)|0;MO(-212,204641,x,201015,2582);ga=ba}else ga=ba}HW(x,f[H>>2]|0,z,P);ca=X+8|0;p[s>>3]=+p[x>>3];f[ca>>2]=f[s>>2];f[ca+4>>2]=f[s+4>>2];aa=ga}if(I){ma=aa;na=M;break a}else{oa=M;pa=0;qa=aa}}while(0);if((O|0)==7){O=0;f[z>>2]=0;f[A>>2]=0;f[B>>2]=0;f[C>>2]=0;if(!(T<<24>>24==47|Q<<24>>24==0)){ca=hU(a,S,z,B,C)|0;switch(f[C>>2]|0){case 5:{ia=f[G>>2]|0;f[w>>2]=f[F>>2];f[w+4>>2]=ia;f[w+8>>2]=204605;_Ub(x,202147,w)|0;MO(-212,204641,x,201015,2450);break}case 3:{ia=f[G>>2]|0;f[v>>2]=f[F>>2];f[v+4>>2]=ia;f[v+8>>2]=204658;_Ub(x,202147,v)|0;MO(-212,204641,x,201015,2452);break}default:{}}ia=f[B>>2]|0;g:do if(ia){ka=ia;h:while(1){ra=f[ka>>2]|0;if(!ra){sa=0;ta=0;ua=0;break g}va=f[ra>>2]|0;if(va|0){wa=0;xa=va;ya=0;while(1){wa=wa+1|0;if(!(gTb(203719,xa)|0))break h;va=wa<<1;xa=f[ra+(va<<2)>>2]|0;if(!xa)break;else ya=va}}ka=f[ka+4>>2]|0;if(!ka){sa=0;ta=0;ua=0;break g}}ka=f[ra+((ya|1)<<2)>>2]|0;if(ka)if(gTb(ka,204117)|0)if(gTb(ka,204125)|0)if(gTb(ka,204121)|0)if(!(gTb(ka,201467)|0)){sa=1;ta=0;ua=0}else{P=f[125813]|0;i:do if(!P)za=0;else{N=P;while(1){if(!(gTb(f[N+16>>2]|0,ka)|0)){za=N;break i}N=f[N+12>>2]|0;if(!N){za=0;break}}}while(0);sa=0;ta=(za|0)==0?0:16;ua=za}else{sa=0;ta=5;ua=0}else{sa=0;ta=6;ua=0}else{sa=0;ta=3;ua=0}else{sa=0;ta=0;ua=0}}else{sa=0;ta=0;ua=0}while(0);ia=f[z>>2]|0;if((f[ia+4>>2]|0)==1)Aa=(b[f[ia+8>>2]>>0]|0)==95;else Aa=0;ka=f[d>>2]&7;if(ka>>>0>4){if(Aa^(ka|0)==5){ka=f[G>>2]|0;f[t>>2]=f[F>>2];f[t+4>>2]=ka;f[t+8>>2]=Aa?204687:203909;_Ub(x,202147,t)|0;MO(-212,204641,x,201015,2488)}}else NU(a,Aa?5:6,d);if(Aa)Ba=XW(f[J>>2]|0,0)|0;else Ba=PU(a,d,ia,1)|0;if(!Ba){f[x>>2]=0;f[K>>2]=0;ka=aD(x,4)|0;b[ka>>0]=101;b[ka+1>>0]=108;b[ka+2>>0]=101;b[ka+3>>0]=109;bO(-215,x,204641,201015,2494);bD(x)}if(sa)Ca=gU(a,SU(a,ca,Ba)|0,0)|0;else Ca=iU(a,ca,Ba,ta)|0;if(!Aa)f[Ba>>2]=f[Ba>>2]|64;if(M)Da=(f[Ba>>2]&7)>>>0<5;else Da=0;f[Ba+4>>2]=ua;ka=hU(a,Ca,A,B,C)|0;if((f[C>>2]|0)==2?(f[A>>2]|0)==(ia|0):0){Ea=1;Fa=Da;Ga=1;Ha=ka}else{ia=f[G>>2]|0;f[r>>2]=f[F>>2];f[r+4>>2]=ia;f[r+8>>2]=204718;_Ub(x,202147,r)|0;MO(-212,204641,x,201015,2509);Ea=1;Fa=Da;Ga=1;Ha=ka}}else{Ea=0;Fa=M;Ga=R;Ha=S}if(Ea){oa=Fa;pa=Ga;qa=Ha}else{ma=Ha;na=Fa;break}}L=qa;c=pa;M=oa}oa=f[d>>2]|0;M=oa&7;if(!M)if(E>>>0>4)O=104;else O=105;else if(E>>>0>4&(M>>>0<5&(M|0)!=(E|0)))O=104;else O=105;if((O|0)==104){NU(a,(E|0)==6?6:5,d);Ia=f[d>>2]|0;O=106}else if((O|0)==105)if(!E)Ja=oa;else{Ia=oa;O=106}if((O|0)==106)if((E|0)==(Ia&7|0))Ja=Ia;else{Ia=f[G>>2]|0;f[h>>2]=f[F>>2];f[h+4>>2]=Ia;f[h+8>>2]=205006;_Ub(x,202147,h)|0;MO(-212,204641,x,201015,2657);Ja=f[d>>2]|0}if((Ja&7)>>>0<5|na^1){Ka=Ja|D;f[d>>2]=Ka;u=g;return ma|0}na=f[J>>2]|0;f[na>>2]=f[na>>2]|256;Ka=Ja|D;f[d>>2]=Ka;u=g;return ma|0}function jU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+1072|0;g=e+32|0;h=e+16|0;i=e;j=e+48|0;k=a+60|0;l=a+88|0;m=a+80|0;n=a+76|0;o=a+256|0;p=a+64|0;q=a+68|0;r=a+264|0;s=a+260|0;t=c;a:while(1){v=t;b:while(1){w=b[v>>0]|0;switch(w<<24>>24){case 35:{x=5;break b;break}case 32:break;default:break b}v=v+1|0}if((x|0)==5){x=0;b[v>>0]=0;t=v;continue}if((w&255)>31)break;switch(w<<24>>24){case 13:case 10:case 0:break;default:{c=f[l>>2]|0;f[g>>2]=f[k>>2];f[g+4>>2]=c;f[g+8>>2]=w<<24>>24==9?204576:204129;_Ub(j,202147,g)|0;MO(-212,204514,j,201015,1322);t=v;continue a}}c=f[n>>2]|0;y=MT(a,c,(f[m>>2]|0)-c|0)|0;if(!y){x=21;break}c=y+((kUb(y)|0)+-1)|0;c:do switch(b[c>>0]|0){case 13:case 10:break;default:{do if(!(f[o>>2]|0)){z=f[p>>2]|0;if(z|0){A=iTb(z)|0;x=18;break}z=f[q>>2]|0;if(z|0){A=Gmb(z)|0;x=18}}else{A=(f[r>>2]|0)>>>0>=(f[s>>2]|0)>>>0&1;x=18}while(0);if((x|0)==18?(x=0,A|0):0)break c;z=f[l>>2]|0;f[h>>2]=f[k>>2];f[h+4>>2]=z;f[h+8>>2]=204531;_Ub(j,202147,h)|0;MO(-212,204514,j,201015,1316)}}while(0);f[l>>2]=(f[l>>2]|0)+1;t=y}if((x|0)==21){x=f[n>>2]|0;b[x+2>>0]=46;b[x+1>>0]=46;b[x>>0]=46;b[x+3>>0]=0;f[a+92>>2]=1;B=x;u=e;return B|0}if((v-(f[n>>2]|0)|0)>=(d|0)){B=v;u=e;return B|0}d=f[l>>2]|0;f[i>>2]=f[k>>2];f[i+4>>2]=d;f[i+8>>2]=204352;_Ub(j,202147,i)|0;MO(-212,204514,j,201015,1296);B=v;u=e;return B|0}function kU(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;h=u;u=u+6352|0;i=h+1200|0;j=h+1184|0;k=h+1168|0;l=h+1152|0;m=h+1136|0;n=h+1120|0;o=h+1104|0;q=h+1088|0;r=h+1072|0;t=h+1056|0;v=h+1040|0;w=h+1024|0;x=h;y=h+1224|0;z=h+1216|0;A=h+1212|0;Nac(y|0,0,5120)|0;f[z>>2]=0;B=b[c>>0]|0;C=c+1|0;D=b[C>>0]|0;E=(e&8|0)!=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;a:do if(B<<24>>24==33){switch(D<<24>>24){case 94:case 33:{F=C;G=16;break}default:{F=c;G=0}}b:do if(D<<24>>24==60){e=F+1|0;H=e;c:while(1){I=H+1|0;J=b[I>>0]|0;if((J&255)<32){K=e;L=G;break b}switch(J<<24>>24){case 32:{K=e;L=G;break b;break}case 62:{break c;break}default:H=I}}if((I-e|0)>>>0>19?(ZVb(e,204064,19)|0)==0:0){b[I>>0]=32;K=F+19|0;L=16}else{K=e;L=G}}else{K=F;L=G}while(0);f[z>>2]=K;H=K;do{H=H+1|0;f[z>>2]=H;M=b[H>>0]|0}while((M&255)>=33);J=K+1|0;N=H-J|0;do if(!N){O=f[a+88>>2]|0;f[w>>2]=f[a+60>>2];f[w+4>>2]=O;f[w+8>>2]=204084;_Ub(x,202147,w)|0;MO(-212,204100,x,201015,1503);O=f[z>>2]|0;P=b[O>>0]|0;b[O>>0]=0;if(!(L&16)){Q=P;R=0;S=L}else{T=P;U=28}}else{b[H>>0]=0;P=(L&16|0)!=0;if(!(P|(N|0)!=3)){if(!(ZVb(J,204117,3)|0)){Q=M;R=0;S=3;break}if(!(ZVb(J,490550,3)|0)){Q=M;R=0;S=1;break}if(!(ZVb(J,204121,3)|0)){Q=M;R=0;S=5;break}O=(ZVb(J,204125,3)|0)==0;Q=M;R=0;S=O?6:L;break}if(!(P|(N|0)!=5)){O=(ZVb(J,490596,5)|0)==0;Q=M;R=0;S=O?2:L;break}if((N|0)!=6|P^1)if(P){T=M;U=28;break}else{Q=M;R=0;S=L;break}if(!(ZVb(J,201467,6)|0)){b[f[z>>2]>>0]=M;P=f[z>>2]|0;while(1){O=P+1|0;f[z>>2]=O;if((b[O>>0]|0)==32)P=O;else break}e=P+2|0;f[z>>2]=e;O=b[e>>0]|0;b[e>>0]=0;Q=O;R=1;S=5}else{Q=M;R=0;S=L}}while(0);d:do if((U|0)==28){N=f[125813]|0;e:do if(N|0){H=N;while(1){if(!(gTb(f[H+16>>2]|0,J)|0))break;O=f[H+12>>2]|0;if(!O)break e;else H=O}f[d+4>>2]=H;Q=T;R=0;S=L;break d}while(0);f[d+4>>2]=0;f[d>>2]=f[d>>2]&-17;Q=T;R=0;S=L}while(0);b[f[z>>2]>>0]=Q;J=jU(a,f[z>>2]|0,g)|0;N=b[J>>0]|0;f:do if(!(S&16)){switch(S|0){case 1:{V=J;U=47;break a;break}case 2:{W=J;U=46;break a;break}case 3:break;default:{U=37;break f}}switch(N<<24>>24){case 34:case 39:break;default:{X=J;Y=3;U=104;break a}}if(!R){Z=N;_=Q;$=J;aa=3;U=39;break a}}else U=37;while(0);if((U|0)==37?!R:0){Z=N;_=Q;$=J;aa=S;U=39;break}ba=QU(a,J,J-(f[a+76>>2]|0)|0,d)|0;u=h;return ba|0}else{Z=B;_=D;$=c;aa=0;U=39}while(0);g:do if((U|0)==39){h:do if((Z+-48&255)<10)ca=Z;else{switch(Z<<24>>24){case 43:case 45:{if(_<<24>>24==46|(_+-48&255)<10){ca=Z;break h}else U=77;break}case 46:{if((_+-48&255)<10|((_&-33)+-65&255)<26){ca=46;break h}else da=46;break}case 34:case 39:{f[d>>2]=3;c=a+60|0;D=a+88|0;i:do if(Z<<24>>24==39){B=0;S=$;while(1){Q=S+1|0;R=b[Q>>0]|0;j:do if(!((R+-48&255)<10|((R&-33)+-65&255)<26)){L=S;T=R;M=Q;while(1){if(T<<24>>24!=39&(T&255)>31){ea=M;fa=T;break j}if(T<<24>>24==39)break;w=f[D>>2]|0;f[t>>2]=f[c>>2];f[t+4>>2]=w;f[t+8>>2]=204129;_Ub(x,202147,t)|0;MO(-212,204100,x,201015,1622);w=M+1|0;K=b[w>>0]|0;if((K+-48&255)<10|((K&-33)+-65&255)<26){ea=w;fa=K;break j}else{G=M;T=K;M=w;L=G}}M=L+2|0;if((b[M>>0]|0)==39){ea=M;fa=39}else{ga=M;ha=B;break i}}else{ea=Q;fa=R}while(0);R=B+1|0;b[y+B>>0]=fa;if((R|0)<4096){B=R;S=ea}else{ia=ea;ja=R;U=75;break}}}else{S=0;B=$;k:while(1){H=B+1|0;R=b[H>>0]|0;l:do if((R+-48&255)<10|((R&-33)+-65&255)<26)U=60;else{switch(R<<24>>24){case 34:{break k;break}case 92:break;default:{if((R&255)>31){U=60;break l}Q=f[D>>2]|0;f[r>>2]=f[c>>2];f[r+4>>2]=Q;f[r+8>>2]=204129;_Ub(x,202147,r)|0;MO(-212,204100,x,201015,1665);ka=S;la=H;break l}}Q=B+2|0;M=b[Q>>0]|0;switch(M<<24>>24){case 39:{b[y+S>>0]=39;ka=S+1|0;la=Q;break l;break}case 92:case 34:{b[y+S>>0]=M;ka=S+1|0;la=Q;break l;break}case 110:{b[y+S>>0]=10;ka=S+1|0;la=Q;break l;break}case 114:{b[y+S>>0]=13;ka=S+1|0;la=Q;break l;break}case 116:{b[y+S>>0]=9;ka=S+1|0;la=Q;break l;break}default:{T=M<<24>>24==120;if(!T?!(M<<24>>24<56&(M+-48&255)<10):0){ka=S;la=Q;break l}M=B+5|0;G=b[M>>0]|0;b[M>>0]=0;w=Q+(T&1)|0;K=WVb(w,z,T?8:16)|0;b[M>>0]=G;G=f[z>>2]|0;M=S+1|0;if((G|0)==(w|0)){b[y+S>>0]=120;ka=M;la=Q;break l}else{b[y+S>>0]=K;ka=M;la=G;break l}}}}while(0);if((U|0)==60){U=0;b[y+S>>0]=R;ka=S+1|0;la=H}if((ka|0)<4096){S=ka;B=la}else{ia=la;ja=ka;U=75;break i}}ga=B+2|0;ha=S}while(0);if((U|0)==75){G=f[D>>2]|0;f[q>>2]=f[c>>2];f[q+4>>2]=G;f[q+8>>2]=204147;_Ub(x,202147,q)|0;MO(-212,204100,x,201015,1669);ga=ia;ha=ja}HW(x,f[a+16>>2]|0,y,ha);G=d+8|0;p[s>>3]=+p[x>>3];f[G>>2]=f[s>>2];f[G+4>>2]=f[s+4>>2];ba=ga;u=h;return ba|0}default:U=77}m:do if((U|0)==77){G=Z<<24>>24==91;switch(Z<<24>>24){case 91:case 123:break;default:if(Z<<24>>24==45&(E^1)){ma=5;na=$;break g}else{da=Z;break m}}M=((E^1)&1)+g|0;K=Z<<24>>24==123?14:13;Q=K&7;NU(a,(f[d+4>>2]|0?16:0)|Q,d);w=d+8|0;T=(Q|0)==6;Q=x+4|0;F=a+60|0;I=a+88|0;C=1;P=$+1|0;n:while(1){f[A>>2]=0;oa=jU(a,P,M)|0;pa=b[oa>>0]|0;switch(pa<<24>>24){case 93:case 125:{U=80;break n;break}default:{}}if(!(f[(f[w>>2]|0)+24>>2]|0))qa=oa;else{if(pa<<24>>24!=44){O=f[I>>2]|0;f[n>>2]=f[F>>2];f[n+4>>2]=O;f[n+8>>2]=204197;_Ub(x,202147,n)|0;MO(-212,204100,x,201015,1700)}qa=jU(a,oa+1|0,M)|0}if(T){O=jU(a,RU(a,qa,d,A)|0,M)|0;e=f[A>>2]|0;ra=O;sa=e;ta=e}else{if((b[qa>>0]|0)==93){ua=qa;break}e=XW(f[w>>2]|0,0)|0;f[A>>2]=e;ra=qa;sa=e;ta=e}if(!sa){f[x>>2]=0;f[Q>>2]=0;e=aD(x,4)|0;b[e>>0]=101;b[e+1>>0]=108;b[e+2>>0]=101;b[e+3>>0]=109;bO(-215,x,204100,201015,1715);bD(x)}e=kU(a,ra,ta,K,M)|0;if(T)f[ta>>2]=f[ta>>2]|64;if(C)va=(f[ta>>2]&7)>>>0<5;else va=0;C=va;P=e}if((U|0)==80){if((pa<<24>>24|0)!=((G?93:125)|0)){P=f[I>>2]|0;f[o>>2]=f[F>>2];f[o+4>>2]=P;f[o+8>>2]=204171;_Ub(x,202147,o)|0;MO(-212,204100,x,201015,1692)}ua=oa+1|0}P=f[w>>2]|0;f[P>>2]=f[P>>2]|(C?256:0);ba=ua;u=h;return ba|0}while(0);if(E){X=$;Y=aa;U=104;break g}switch(da<<24>>24){case 63:{c=f[a+88>>2]|0;f[m>>2]=f[a+60>>2];f[m+4>>2]=c;f[m+8>>2]=204228;_Ub(x,202147,m)|0;MO(-212,204100,x,201015,1734);X=$;Y=aa;U=104;break g;break}case 62:case 124:{c=f[a+88>>2]|0;f[l>>2]=f[a+60>>2];f[l+4>>2]=c;f[l+8>>2]=204259;_Ub(x,202147,l)|0;MO(-212,204100,x,201015,1736);X=$;Y=aa;U=104;break g;break}default:{X=$;Y=aa;U=104;break g}}}while(0);J=$+((ca<<24>>24==45|ca<<24>>24==43)&1)|0;while(1){f[z>>2]=J;wa=b[J>>0]|0;if((wa+-48&255)<10)J=J+1|0;else break}switch(wa<<24>>24){case 101:case 46:{W=$;U=46;break}default:{V=$;U=47}}}while(0);if((U|0)==46){xa=+wU(a,W,z);f[d>>2]=2;p[d+8>>3]=xa;ya=W;U=48}else if((U|0)==47){W=WVb(V,z,0)|0;f[d>>2]=1;f[d+8>>2]=W;ya=V;U=48}else if((U|0)==104){f[z>>2]=X;V=b[X>>0]|0;if((V&255)>31){o:do if(E){W=V;$=X;while(1){switch(W<<24>>24){case 93:case 125:case 44:{za=W;Aa=$;break o;break}default:{}}wa=$+1|0;f[z>>2]=wa;ca=b[wa>>0]|0;if((ca&255)>31){W=ca;$=wa}else{za=ca;Aa=wa;break o}}}else{if((Y|0)==3){$=X;while(1){W=$+1|0;f[z>>2]=W;wa=b[W>>0]|0;if((wa&255)>31)$=W;else{za=wa;Aa=W;break o}}}else{Ba=V;Ca=X}while(1){if(Ba<<24>>24==58){za=58;Aa=Ca;break o}$=Ca+1|0;f[z>>2]=$;W=b[$>>0]|0;if((W&255)>31){Ba=W;Ca=$}else{za=W;Aa=$;break}}}while(0);if((Aa|0)==(X|0)){Da=za;U=113}else Ea=za}else{Da=V;U=113}if((U|0)==113){V=f[a+88>>2]|0;f[k>>2]=f[a+60>>2];f[k+4>>2]=V;f[k+8>>2]=204129;_Ub(x,202147,k)|0;MO(-212,204100,x,201015,1748);Ea=Da}if(Ea<<24>>24==58&(E^1)){ma=6;na=X}else{E=f[z>>2]|0;f[d>>2]=3;Ea=E;while(1){E=Ea+-1|0;if(E>>>0<=X>>>0)break;if((b[E>>0]|0)==32)Ea=E;else break}HW(x,f[a+16>>2]|0,X,Ea-X|0);X=d+8|0;p[s>>3]=+p[x>>3];f[X>>2]=f[s>>2];f[X+4>>2]=f[s+4>>2];ba=f[z>>2]|0;u=h;return ba|0}}if((U|0)==48){X=f[z>>2]|0;if(!((X|0)==0|(X|0)==(ya|0))){ba=X;u=h;return ba|0}X=f[a+88>>2]|0;f[v>>2]=f[a+60>>2];f[v+4>>2]=X;f[v+8>>2]=203074;_Ub(x,202147,v)|0;MO(-212,204100,x,201015,1601);ba=f[z>>2]|0;u=h;return ba|0}NU(a,(f[d+4>>2]|0?16:0)|ma,d);z=a+76|0;v=na-(f[z>>2]|0)|0;X=(ma|0)==6;ya=x+4|0;Ea=v+1|0;E=a+60|0;Da=a+88|0;k=d+8|0;V=1;za=na;while(1){f[A>>2]=0;if(X){na=RU(a,za,d,A)|0;Aa=f[A>>2]|0;Fa=na;Ga=Aa;Ha=Aa}else{if((b[za>>0]|0)!=45){Aa=f[Da>>2]|0;f[j>>2]=f[E>>2];f[j+4>>2]=Aa;f[j+8>>2]=204302;_Ub(x,202147,j)|0;MO(-212,204100,x,201015,1785)}Aa=XW(f[k>>2]|0,0)|0;f[A>>2]=Aa;Fa=za+1|0;Ga=Aa;Ha=Aa}if(!Ga){f[x>>2]=0;f[ya>>2]=0;Aa=aD(x,4)|0;b[Aa>>0]=101;b[Aa+1>>0]=108;b[Aa+2>>0]=101;b[Aa+3>>0]=109;bO(-215,x,204100,201015,1789);bD(x)}Aa=kU(a,jU(a,Fa,Ea)|0,Ha,ma,Ea)|0;if(X)f[Ha>>2]=f[Ha>>2]|64;if(V)Ia=(f[Ha>>2]&7)>>>0<5;else Ia=0;za=jU(a,Aa,0)|0;Aa=za-(f[z>>2]|0)|0;if((Aa|0)!=(v|0)){if((Aa|0)<(v|0)){U=135;break}Aa=f[Da>>2]|0;f[i>>2]=f[E>>2];f[i+4>>2]=Aa;f[i+8>>2]=204352;_Ub(x,202147,i)|0;MO(-212,204100,x,201015,1802)}if(!(ZVb(za,490625,3)|0))break;else V=Ia}V=f[k>>2]|0;f[V>>2]=f[V>>2]|(Ia?256:0);ba=za;u=h;return ba|0}function lU(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+1056|0;e=d+16|0;g=d;h=d+32|0;i=a+60|0;j=a+88|0;k=a+76|0;l=a+80|0;m=c;a:while(1){n=b[m>>0]|0;b:do switch(n<<24>>24|0){case 47:{c=m+1|0;o=b[c>>0]|0;if(!(o<<24>>24)){p=f[k>>2]|0;q=MT(a,p,(f[l>>2]|0)-p|0)|0;if(!q){r=26;break a}s=q;t=b[q>>0]|0}else{s=c;t=o}switch(t<<24>>24){case 47:{o=s;c=47;while(1){switch(c<<24>>24){case 13:case 10:{v=0;w=o;break b;break}case 0:{q=f[k>>2]|0;p=MT(a,q,(f[l>>2]|0)-q|0)|0;if(!p){r=26;break a}else x=p;break}default:x=o+1|0}o=x;c=b[x>>0]|0}break}case 42:{c=s+1|0;while(1){o=b[c>>0]|0;if(!(o<<24>>24)){p=f[k>>2]|0;q=MT(a,p,(f[l>>2]|0)-p|0)|0;if(!q){r=26;break a}else{c=q;continue}}q=c+1|0;if(o<<24>>24!=42){c=q;continue}o=b[q>>0]|0;if(!(o<<24>>24)){p=f[k>>2]|0;y=MT(a,p,(f[l>>2]|0)-p|0)|0;if(!y){r=26;break a}z=y;A=b[y>>0]|0}else{z=q;A=o}if(A<<24>>24==47)break;else c=z}v=0;w=z+1|0;break b;break}default:{c=f[j>>2]|0;f[g>>2]=f[i>>2];f[g+4>>2]=c;f[g+8>>2]=203983;_Ub(h,202147,g)|0;MO(-212,204014,h,201015,3335);v=0;w=s;break b}}break}case 32:case 9:{v=0;w=m+1|0;break}case 13:case 10:case 0:{c=f[k>>2]|0;o=MT(a,c,(f[l>>2]|0)-c|0)|0;v=(o|0)==0;w=o;break}default:break a}while(0);if(v){r=26;break}else m=w}if((r|0)==26){r=f[k>>2]|0;b[r>>0]=0;f[a+92>>2]=1;B=r;u=d;return B|0}if((n&255)>31){B=m;u=d;return B|0}n=f[j>>2]|0;f[e>>2]=f[i>>2];f[e+4>>2]=n;f[e+8>>2]=204032;_Ub(h,202147,e)|0;MO(-212,204014,h,201015,3353);B=m;u=d;return B|0}function mU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=u;u=u+1184|0;g=e+144|0;h=e+128|0;i=e+112|0;j=e+96|0;k=e+80|0;l=e+64|0;m=e+48|0;n=e+32|0;o=e+16|0;p=e+160|0;q=e;if(!c){r=f[a+88>>2]|0;f[o>>2]=f[a+60>>2];f[o+4>>2]=r;f[o+8>>2]=202592;_Ub(p,202147,o)|0;MO(-212,203583,p,201015,3733)}if((b[c>>0]|0)==123)s=c+1|0;else{o=f[a+88>>2]|0;f[n>>2]=f[a+60>>2];f[n+4>>2]=o;f[n+8>>2]=203599;_Ub(p,202147,n)|0;MO(-212,203583,p,201015,3736);s=c};f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;NU(a,6,d);c=lU(a,s)|0;a:do if(!c){t=a+60|0;v=a+88|0;w=p;x=47}else{s=a+92|0;n=a+60|0;o=a+88|0;r=q+8+4|0;y=d+4|0;z=c;while(1){if(f[s>>2]|0){A=z;break a}do if((b[z>>0]|0)==34){B=z;while(1){C=B+1|0;D=b[C>>0]|0;E=D<<24>>24!=34;if((D&255)<32|E^1)break;else B=C}D=z+1|0;if(E){F=f[o>>2]|0;f[m>>2]=f[n>>2];f[m+4>>2]=F;f[m+8>>2]=203634;_Ub(p,202147,m)|0;MO(-212,203656,p,201015,3388)}F=lU(a,B+2|0)|0;if(!F){t=n;v=o;w=p;x=47;break a}if(f[s>>2]|0){t=n;v=o;w=p;x=47;break a}if((b[F>>0]|0)!=58){G=f[o>>2]|0;f[l>>2]=f[n>>2];f[l+4>>2]=G;f[l+8>>2]=203672;_Ub(p,202147,l)|0;MO(-212,203656,p,201015,3397)}if(B>>>0<=z>>>0){G=f[o>>2]|0;f[k>>2]=f[n>>2];f[k+4>>2]=G;f[k+8>>2]=203706;_Ub(p,202147,k)|0;MO(-212,203656,p,201015,3401)}G=C-D|0;if((G|0)==7?(ZVb(D,203719,7)|0)==0:0)H=0;else H=PU(a,d,OU(a,D,G,1)|0,1)|0;G=F+1|0;if(f[s>>2]|0){A=G;break a}F=lU(a,G)|0;if(!F){t=n;v=o;w=p;x=47;break a}if(f[s>>2]|0){A=F;break a}if(H|0){switch(b[F>>0]|0){case 91:{I=nU(a,F,H)|0;break}case 123:{I=mU(a,F,H)|0;break}default:I=oU(a,F,H)|0}f[H>>2]=f[H>>2]|64;J=I;break}G=oU(a,F,q)|0;b:do if((f[q>>2]&7|0)==3){F=f[r>>2]|0;c:do if(F|0){D=f[125813]|0;if(!D)break;else K=D;while(1){if(!(gTb(f[K+16>>2]|0,F)|0))break;D=f[K+12>>2]|0;if(!D)break c;else K=D}f[y>>2]=K;f[d>>2]=f[d>>2]|16;break b}while(0);f[y>>2]=0}else{F=f[o>>2]|0;f[j>>2]=f[n>>2];f[j+4>>2]=F;f[j+8>>2]=203727;_Ub(p,202147,j)|0;MO(-212,203583,p,201015,3772)}while(0);J=G}else J=z;while(0);B=lU(a,J)|0;if(!B){t=n;v=o;w=p;x=47;break a}if(f[s>>2]|0){A=B;break a}switch(b[B>>0]|0){case 125:{A=B;break a;break}case 44:{L=B+1|0;break}default:{F=f[o>>2]|0;f[i>>2]=f[n>>2];f[i+4>>2]=F;f[i+8>>2]=202655;_Ub(p,202147,i)|0;MO(-212,203583,p,201015,3796);L=B}}z=lU(a,L)|0;if(!z){t=n;v=o;w=p;x=47;break a}}}while(0);if((x|0)==47){x=f[v>>2]|0;f[h>>2]=f[t>>2];f[h+4>>2]=x;f[h+8>>2]=202592;_Ub(w,202147,h)|0;MO(-212,203583,w,201015,3800);A=0}if((b[A>>0]|0)==125){M=A+1|0;u=e;return M|0}else{w=f[a+88>>2]|0;f[g>>2]=f[a+60>>2];f[g+4>>2]=w;f[g+8>>2]=203762;_Ub(p,202147,g)|0;MO(-212,203583,p,201015,3803);M=A;u=e;return M|0}return 0}function nU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+1104|0;g=e+64|0;h=e+48|0;i=e+32|0;j=e+16|0;k=e;l=e+80|0;if(!c){m=f[a+88>>2]|0;f[k>>2]=f[a+60>>2];f[k+4>>2]=m;f[k+8>>2]=202592;_Ub(l,202147,k)|0;MO(-212,202604,l,201015,3679)}if((b[c>>0]|0)==91)n=c+1|0;else{k=f[a+88>>2]|0;f[j>>2]=f[a+60>>2];f[j+4>>2]=k;f[j+8>>2]=202620;_Ub(l,202147,j)|0;MO(-212,202604,l,201015,3682);n=c};f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;c=IW(0,56,16,f[a+16>>2]|0)|0;if(f[d>>2]&7|0)XW(c,d)|0;j=d+8|0;f[j>>2]=c;f[d>>2]=5;JW(c,8);c=lU(a,n)|0;a:do if(!c){o=a+60|0;p=a+88|0;q=l;r=23}else{n=a+92|0;d=a+60|0;k=a+88|0;m=c;while(1){if(f[n>>2]|0){s=m;break a}b:do if((b[m>>0]|0)==93)t=m;else{v=XW(f[j>>2]|0,0)|0;switch(b[m>>0]|0){case 91:{t=nU(a,m,v)|0;break b;break}case 123:{t=mU(a,m,v)|0;break b;break}default:{t=oU(a,m,v)|0;break b}}}while(0);v=lU(a,t)|0;if(!v){o=d;p=k;q=l;r=23;break a}if(f[n>>2]|0){s=v;break a}switch(b[v>>0]|0){case 93:{s=v;break a;break}case 44:{w=v+1|0;break}default:{x=f[k>>2]|0;f[i>>2]=f[d>>2];f[i+4>>2]=x;f[i+8>>2]=202655;_Ub(l,202147,i)|0;MO(-212,202604,l,201015,3716);w=v}}m=lU(a,w)|0;if(!m){o=d;p=k;q=l;r=23;break a}}}while(0);if((r|0)==23){r=f[p>>2]|0;f[h>>2]=f[o>>2];f[h+4>>2]=r;f[h+8>>2]=202592;_Ub(q,202147,h)|0;MO(-212,202604,q,201015,3720);s=0}if((b[s>>0]|0)==93){y=s+1|0;u=e;return y|0}else{q=f[a+88>>2]|0;f[g>>2]=f[a+60>>2];f[g+4>>2]=q;f[g+8>>2]=202676;_Ub(l,202147,g)|0;MO(-212,202604,l,201015,3723);y=s;u=e;return y|0}return 0}function oU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=u;u=u+1328|0;g=e+1264|0;i=e+1248|0;j=e+1232|0;k=e+1216|0;l=e+1200|0;m=e+1184|0;n=e+1168|0;o=e+1152|0;q=e+1136|0;r=e+1120|0;t=e+1104|0;v=e+1088|0;w=e+1072|0;x=e+1056|0;y=e+1040|0;z=e+1024|0;A=e;B=e+1300|0;C=e+1304|0;D=e+1288|0;E=e+1276|0;F=lU(a,c)|0;f[B>>2]=F;if((F|0)!=0?(f[a+92>>2]|0)==0:0)G=F;else H=3;if((H|0)==3){F=f[a+88>>2]|0;f[z>>2]=f[a+60>>2];f[z+4>>2]=F;f[z+8>>2]=202569;_Ub(A,202147,z)|0;MO(-212,202712,A,201015,3421);G=f[B>>2]|0};f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;z=b[G>>0]|0;if(z<<24>>24!=34){a:do if((z+-48&255)<10)switch(z<<24>>24){case 45:case 43:{H=108;break}default:{I=z;J=G}}else{switch(z<<24>>24){case 45:case 43:{H=108;break a;break}case 46:{I=z;J=G;break a;break}default:{}}if(((z&-33)+-65&255)<26){F=0;c=G;do{F=F+1|0;c=c+1|0;f[B>>2]=c}while(F>>>0<7?((b[c>>0]&-33)+-65&255)<26:0);if(F>>>0>3){if(!(ZVb(G,203140,4)|0)){c=f[a+88>>2]|0;f[i>>2]=f[a+60>>2];f[i+4>>2]=c;f[i+8>>2]=203145;_Ub(A,202147,i)|0;MO(-212,202712,A,201015,3652);K=f[B>>2]|0;u=e;return K|0}if(!(ZVb(G,490309,4)|0)){f[d+8>>2]=1;f[d>>2]=1;K=f[B>>2]|0;u=e;return K|0}if(F>>>0>4?(ZVb(G,490303,5)|0)==0:0){f[d+8>>2]=0;f[d>>2]=1;K=f[B>>2]|0;u=e;return K|0}}}c=f[a+88>>2]|0;f[g>>2]=f[a+60>>2];f[g+4>>2]=c;f[g+8>>2]=203190;_Ub(A,202147,g)|0;MO(-212,202712,A,201015,3666);K=f[B>>2]|0;u=e;return K|0}while(0);if((H|0)==108){g=G+1|0;f[B>>2]=g;I=b[g>>0]|0;J=g}if((I+-48&255)<10){g=J;do{g=g+1|0;f[B>>2]=g;J=b[g>>0]|0}while((J+-48&255)<10);L=J}else L=I;switch(L<<24>>24){case 101:case 46:{M=+wU(a,G,B);p[d+8>>3]=M;N=2;break}default:{L=WVb(G,B,0)|0;f[d+8>>2]=L;N=1}}f[d>>2]=N;if(G>>>0<(f[B>>2]|0)>>>0){K=f[B>>2]|0;u=e;return K|0}N=f[a+88>>2]|0;f[j>>2]=f[a+60>>2];f[j+4>>2]=N;f[j+8>>2]=203074;_Ub(A,202147,j)|0;MO(-212,202712,A,201015,3641);K=f[B>>2]|0;u=e;return K|0}j=G+1|0;N=0;L=j;while(1){f[B>>2]=L;I=b[L>>0]|0;if((I+-48&255)<10|((I&-33)+-65&255)<26){if(N>>>0>=10){H=11;break}}else if(!(N>>>0<10&I<<24>>24==36)){H=10;break}N=N+1|0;L=L+1|0}if((H|0)==10?N>>>0>7:0)H=11;if((H|0)==11?(ZVb(j,202730,8)|0)==0:0){N=G+9|0;f[B>>2]=N;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;c6b(C,131072);G=a+60|0;L=a+88|0;I=a+76|0;g=a+80|0;J=N;N=f[B>>2]|0;b:while(1){O=N;c:while(1)switch(b[O>>0]|0){case 34:{break b;break}case 0:{break c;break}case 13:case 10:{i=f[L>>2]|0;f[x>>2]=f[G>>2];f[x+4>>2]=i;f[x+8>>2]=202739;_Ub(A,202147,x)|0;MO(-212,202712,A,201015,3466);O=f[B>>2]|0;continue c;break}default:{i=O+1|0;f[B>>2]=i;O=i;continue c}}pU(C,J,O)|0;F=f[I>>2]|0;i=MT(a,F,(f[g>>2]|0)-F|0)|0;f[B>>2]=i;if(!i){i=f[L>>2]|0;f[y>>2]=f[G>>2];f[y+4>>2]=i;f[y+8>>2]=202739;_Ub(A,202147,y)|0;MO(-212,202712,A,201015,3451)}i=f[B>>2]|0;J=i;N=i}pU(C,J,O)|0;O=f[B>>2]|0;if((b[O>>0]|0)==34)f[B>>2]=O+1;else{O=f[L>>2]|0;f[w>>2]=f[G>>2];f[w+4>>2]=O;f[w+8>>2]=202739;_Ub(A,202147,w)|0;MO(-212,202712,A,201015,3478)}w=C+11|0;O=b[w>>0]|0;J=O<<24>>24<0;N=C+4|0;y=f[N>>2]|0;g=O&255;O=J?y:g;do if(O>>>0>31){I=J?f[C>>2]|0:C;x=I+(J?y:g)|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[E>>2]=0;i=E+4|0;f[i>>2]=0;f[E+8>>2]=0;F=L5b(25)|0;f[E>>2]=F;z=F+25|0;f[E+8>>2]=z;c=F;P=c+25|0;do{b[c>>0]=32;c=c+1|0}while((c|0)<(P|0));f[i>>2]=z;if(I|0){c=I+32|0;P=I+4|0;Q=(((c>>>0>P>>>0?c:P)+~I|0)>>>2)*3|0;P=F;c=0;while(1){R=I+c|0;c=c+4|0;S=b[202778+(h[R+3>>0]|0)>>0]|0;T=h[202778+(h[R+2>>0]|0)>>0]|0;U=h[202778+(h[R+1>>0]|0)>>0]|0;b[P>>0]=U>>>4&3|h[202778+(h[R>>0]|0)>>0]<<2;b[P+1>>0]=T>>>2&15|U<<4;b[P+2>>0]=S&255|T<<6;if((c|0)>=32)break;else P=P+3|0}b[F+(Q+3)>>0]=0}if(!(qU(E,D)|0?(P=b[D+11>>0]|0,((P<<24>>24<0?f[D+4>>2]|0:P&255)|0)!=0):0)){P=f[L>>2]|0;f[v>>2]=f[G>>2];f[v+4>>2]=P;f[v+8>>2]=202905;_Ub(A,202147,v)|0;MO(-212,202712,A,201015,3493)}P=f[E>>2]|0;if(P|0){if((f[i>>2]|0)!=(P|0))f[i>>2]=P;O5b(P)}P=i6b(C,32)|0;c=b[w>>0]|0;if((c<<24>>24<0?f[N>>2]|0:c&255)>>>0>32){c=x-P|0;if(!c){I=kUb(P)|0;if(!I)H=45;else{V=I;H=38}}else{V=c;H=38}d:do if((H|0)==38)if((V|0)!=0&(V&3|0)==0){I=P+V|0;z=I+-1|0;if((b[z>>0]|0)==61){T=z+-1|0;W=(b[T>>0]|0)==61?T:z}else W=I;if(P>>>0<W>>>0){I=P;do{z=b[I>>0]|0;if((z&255)>126){H=45;break d}I=I+1|0;if(!(z<<24>>24==65|(b[202778+(z&255)>>0]|0)!=0)){H=45;break d}}while(I>>>0<W>>>0)}}else H=45;while(0);if((H|0)==45){i=f[L>>2]|0;f[t>>2]=f[G>>2];f[t+4>>2]=i;f[t+8>>2]=202935;_Ub(A,202147,t)|0;MO(-212,202712,A,201015,3502)}i=(c>>>2)*3|0;Q=i+1|0;f[E>>2]=0;F=E+4|0;f[F>>2]=0;f[E+8>>2]=0;if(!Q)X=0;else{if((Q|0)<0)c4b(E);I=L5b(Q)|0;f[F>>2]=I;f[E>>2]=I;f[E+8>>2]=I+Q;z=Q;Q=I;do{b[Q>>0]=0;Q=(f[F>>2]|0)+1|0;f[F>>2]=Q;z=z+-1|0}while((z|0)!=0);X=Q}z=0;c=x;while(1){c=c+-1|0;if((b[c>>0]|0)!=61)break;else z=z+1|0}c=i-z|0;Q=f[E>>2]|0;f[A>>2]=Q;f[A+4>>2]=Q+(X-Q);Q=A+8|0;f[Q>>2]=0;I=A+12|0;f[I>>2]=0;f[A+16>>2]=0;T=L5b(120)|0;f[I>>2]=T;f[Q>>2]=T;f[A+16>>2]=T+120;Q=120;S=T;do{b[S>>0]=0;S=(f[I>>2]|0)+1|0;f[I>>2]=S;Q=Q+-1|0}while((Q|0)!=0);Q=A+20|0;S=A+24|0;I=A+28|0;z=A+32|0;i=A+36|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;f[Q+16>>2]=0;f[Q+20>>2]=0;T=L5b(161)|0;f[i>>2]=T;f[z>>2]=T;f[A+40>>2]=T+161;U=161;R=T;do{b[R>>0]=0;R=(f[i>>2]|0)+1|0;f[i>>2]=R;U=U+-1|0}while((U|0)!=0);U=f[z>>2]|0;f[Q>>2]=U;f[S>>2]=U;f[I>>2]=U+120;rU(A,P,x)|0;sU(A)|0;tU(A);U=D+11|0;R=uU((b[U>>0]|0)<0?f[D>>2]|0:D)|0;if((c|0)%(R|0)|0|0){i=f[L>>2]|0;f[r>>2]=f[G>>2];f[r+4>>2]=i;f[r+8>>2]=202956;_Ub(A,202147,r)|0;MO(-212,202712,A,201015,3520)}i=IW(0,56,16,f[a+16>>2]|0)|0;if(f[d>>2]&7|0)XW(i,d)|0;T=d+8|0;f[T>>2]=i;f[d>>2]=13;JW(i,8);vU(f[E>>2]|0,(c|0)/(R|0)|0,(b[U>>0]|0)<0?f[D>>2]|0:D,f[T>>2]|0);T=f[E>>2]|0;if(T|0){if((f[F>>2]|0)!=(T|0))f[F>>2]=T;O5b(T)}Y=U}else{U=IW(0,56,16,f[a+16>>2]|0)|0;if(f[d>>2]&7|0)XW(U,d)|0;f[d+8>>2]=U;f[d>>2]=13;JW(U,8);Y=D+11|0}if((b[Y>>0]|0)<0)O5b(f[D>>2]|0)}else{if(O|0){U=f[L>>2]|0;f[q>>2]=f[G>>2];f[q+4>>2]=U;f[q+8>>2]=202989;_Ub(A,202147,q)|0;MO(-212,202712,A,201015,3540);break}U=IW(0,56,16,f[a+16>>2]|0)|0;if(f[d>>2]&7|0)XW(U,d)|0;f[d+8>>2]=U;f[d>>2]=13;JW(U,8)}while(0);if((b[w>>0]|0)<0)O5b(f[C>>2]|0);K=f[B>>2]|0;u=e;return K|0};f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;c6b(C,131072);f[B>>2]=j;w=a+60|0;q=a+88|0;G=a+76|0;L=a+80|0;O=j;e:while(1){Z=O;f:while(1)switch(b[Z>>0]|0){case 34:{break e;break}case 92:{break f;break}case 0:{H=94;break f;break}case 13:case 10:{j=f[q>>2]|0;f[l>>2]=f[w>>2];f[l+4>>2]=j;f[l+8>>2]=202739;_Ub(A,202147,l)|0;MO(-212,202712,A,201015,3597);Z=f[B>>2]|0;continue f;break}default:{j=Z+1|0;f[B>>2]=j;Z=j;continue f}}if((H|0)==94){H=0;pU(C,O,Z)|0;F=f[G>>2]|0;c=MT(a,F,(f[L>>2]|0)-F|0)|0;f[B>>2]=c;if(c|0){O=c;continue}c=f[q>>2]|0;f[m>>2]=f[w>>2];f[m+4>>2]=c;f[m+8>>2]=202739;_Ub(A,202147,m)|0;MO(-212,202712,A,201015,3582);O=f[B>>2]|0;continue}pU(C,O,Z)|0;c=(f[B>>2]|0)+1|0;f[B>>2]=c;F=b[c>>0]|0;switch(F<<24>>24|0){case 39:case 34:case 92:{f6b(C,1,F)|0;break}case 110:{f6b(C,1,10)|0;break}case 114:{f6b(C,1,13)|0;break}case 116:{f6b(C,1,9)|0;break}case 98:{f6b(C,1,8)|0;break}case 102:{f6b(C,1,12)|0;break}case 117:{F=f[q>>2]|0;f[o>>2]=f[w>>2];f[o+4>>2]=F;f[o+8>>2]=203016;_Ub(A,202147,o)|0;MO(-212,202712,A,201015,3568);H=92;break}default:H=92}if((H|0)==92){H=0;F=f[q>>2]|0;f[n>>2]=f[w>>2];f[n+4>>2]=F;f[n+8>>2]=203049;_Ub(A,202147,n)|0;MO(-212,202712,A,201015,3569)}F=(f[B>>2]|0)+1|0;f[B>>2]=F;O=F}pU(C,O,Z)|0;Z=f[B>>2]|0;if((b[Z>>0]|0)==34)f[B>>2]=Z+1;else{Z=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=Z;f[k+8>>2]=202739;_Ub(A,202147,k)|0;MO(-212,202712,A,201015,3609)}k=C+11|0;Z=b[k>>0]|0;w=Z<<24>>24<0;HW(A,f[a+16>>2]|0,w?f[C>>2]|0:C,w?f[C+4>>2]|0:Z&255);Z=d+8|0;p[s>>3]=+p[A>>3];f[Z>>2]=f[s>>2];f[Z+4>>2]=f[s+4>>2];f[d>>2]=3;if((b[k>>0]|0)<0)O5b(f[C>>2]|0);K=f[B>>2]|0;u=e;return K|0}function pU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=c;h=e;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k){l=f[a+4>>2]|0;m=(f[a+8>>2]&2147483647)+-1|0}else{l=j&255;m=10}n=d-g|0;if(!n){u=e;return a|0}if(k){k=f[a>>2]|0;o=k;p=f[a+4>>2]|0;q=k}else{o=a;p=j&255;q=a}if(q>>>0<=c>>>0&(o+p|0)>>>0>c>>>0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(n>>>0>4294967279)V5b(h);if(n>>>0<11){b[h+11>>0]=n;r=h}else{p=n+16&-16;o=L5b(p)|0;f[h>>2]=o;f[h+8>>2]=p|-2147483648;f[h+4>>2]=n;r=o}if((c|0)==(d|0))s=r;else{o=r;p=c;while(1){b[o>>0]=b[p>>0]|0;p=p+1|0;if((p|0)==(d|0))break;else o=o+1|0}s=r+n|0}b[s>>0]=0;s=h+11|0;r=b[s>>0]|0;o=r<<24>>24<0;j6b(a,o?f[h>>2]|0:h,o?f[h+4>>2]|0:r&255)|0;if((b[s>>0]|0)<0)O5b(f[h>>2]|0);u=e;return a|0}if((m-l|0)>>>0<n>>>0){g6b(a,m,l+n-m|0,l,l,0,0);t=b[i>>0]|0}else t=j;if(t<<24>>24<0)v=f[a>>2]|0;else v=a;t=v+l|0;if((c|0)==(d|0))w=t;else{j=d+(l-g)|0;g=c;c=t;while(1){b[c>>0]=b[g>>0]|0;g=g+1|0;if((g|0)==(d|0))break;else c=c+1|0}w=v+j|0}b[w>>0]=0;w=l+n|0;if((b[i>>0]|0)<0){f[a+4>>2]=w;u=e;return a|0}else{b[i>>0]=w;u=e;return a|0}return 0}function qU(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+160|0;e=d+12|0;g=d;h=f[a>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;a=kUb(h)|0;if(a>>>0>4294967279)V5b(g);if(a>>>0<11){b[g+11>>0]=a;if(!a)i=g;else{j=g;k=6}}else{l=a+16&-16;m=L5b(l)|0;f[g>>2]=m;f[g+8>>2]=l|-2147483648;f[g+4>>2]=a;j=m;k=6}if((k|0)==6){Vac(j|0,h|0,a|0)|0;i=j}b[i+a>>0]=0;a=e+60|0;i=e+8|0;f[e>>2]=10956;f[a>>2]=10976;f[e+4>>2]=0;RXb(e+60|0,i);f[e+132>>2]=0;f[e+136>>2]=-1;f[e>>2]=47196;f[a>>2]=47216;WXb(i);f[i>>2]=43284;a=e+40|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[e+56>>2]=8;qP(i,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);g=MU(e,c)|0;c=(f[g+(f[(f[g>>2]|0)+-12>>2]|0)+16>>2]&5|0)==0;GU(e);u=d;return c|0}function rU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e;if(c>>>0>=d>>>0){u=e;return a|0}h=d;i=a+28|0;j=a+24|0;k=g+4|0;l=c;do{c=h-l|0;m=f[j>>2]|0;n=(f[i>>2]|0)-m|0;o=(n|0)<(c|0)?n:c;Vac(m|0,l|0,o|0)|0;l=l+o|0;m=(f[j>>2]|0)+o|0;f[j>>2]=m;if(m>>>0>=(f[i>>2]|0)>>>0?!(sU(a)|0):0){f[g>>2]=0;f[k>>2]=0;m=aD(g,7)|0;b[m>>0]=b[203575]|0;b[m+1>>0]=b[203576]|0;b[m+2>>0]=b[203577]|0;b[m+3>>0]=b[203578]|0;b[m+4>>0]=b[203579]|0;b[m+5>>0]=b[203580]|0;b[m+6>>0]=b[203581]|0;bO(-215,g,363731,201015,7842);bD(g)}}while(l>>>0<d>>>0);u=e;return a|0}function sU(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;d=c;e=a+20|0;g=f[e>>2]|0;h=a+24|0;i=f[h>>2]|0;j=i-g|0;k=i;if(!g){l=0;u=c;return l|0}if(!j)m=kUb(g)|0;else m=j;if(!((m|0)!=0&(m&3|0)==0)){l=0;u=c;return l|0}i=g+m|0;m=i+-1|0;if((b[m>>0]|0)==61){n=m+-1|0;o=(b[n>>0]|0)==61?n:m}else o=i;a:do if(g>>>0<o>>>0){i=g;while(1){m=b[i>>0]|0;if((m&255)>126){l=0;p=18;break}i=i+1|0;if(!(m<<24>>24==65|(b[202778+(m&255)>>0]|0)!=0)){l=0;p=18;break}if(i>>>0>=o>>>0)break a}if((p|0)==18){u=c;return l|0}}while(0);if((k|0)==(g|0)){l=1;u=c;return l|0}k=f[a+32>>2]|0;p=LU(g,k,0,j)|0;f[h>>2]=f[e>>2];if(!p){f[d>>2]=0;f[d+4>>2]=0;e=aD(d,8)|0;h=e;b[h>>0]=108;b[h+1>>0]=101;b[h+2>>0]=110;b[h+3>>0]=32;h=e+4|0;b[h>>0]=33;b[h+1>>0]=61;b[h+2>>0]=32;b[h+3>>0]=48;bO(-215,d,203545,201015,7862);bD(d)}h=f[a>>2]|0;e=a+4|0;j=f[e>>2]|0;if((h+p|0)>>>0<j>>>0){q=h;r=j}else{f[d>>2]=0;f[d+4>>2]=0;j=aD(d,23)|0;h=203551;g=j+23|0;do{b[j>>0]=b[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(g|0));bO(-215,d,203545,201015,7865);bD(d);q=f[a>>2]|0;r=f[e>>2]|0}if((q+p|0)>>>0>=r>>>0){l=1;u=c;return l|0}Vac(q|0,k|0,p|0)|0;f[a>>2]=(f[a>>2]|0)+p;l=1;u=c;return l|0}function tU(a){a=a|0;var b=0,c=0;if((f[a+24>>2]|0)!=(f[a+20>>2]|0))sU(a)|0;b=f[a+32>>2]|0;if(b|0){c=a+36|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;O5b(b)}b=f[a+8>>2]|0;if(!b)return;c=a+12|0;if((f[c>>2]|0)!=(b|0))f[c>>2]=b;O5b(b);return}function uU(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=u;u=u+512|0;d=c;e=KU(a,d)|0;g=e<<1;if((e|0)>0){e=0;h=0;do{i=f[d+((h|1)<<2)>>2]|0;j=(i>>>3&511)+1<<(47696>>>(i<<1&14)&3);e=(e+-1+j&0-j)+(Y(j,f[d+(h<<2)>>2]|0)|0)|0;h=h+2|0}while((h|0)<(g|0));k=e+-1|0}else k=-1;e=f[d+4>>2]|0;d=(e>>>3&511)+1<<(47696>>>(e<<1&14)&3);e=k+d&0-d;d=b[a>>0]|0;if(!(d<<24>>24)){l=0;m=e+-1|0;n=m+l|0;o=0-l|0;p=n&o;u=c;return p|0}else{q=0;r=a;s=d}while(1){switch(s<<24>>24|0){case 117:{t=(q|0)==0?1:q;break}case 99:{t=(q|0)==0?1:q;break}case 119:{t=q>>>0>2?q:2;break}case 115:{t=q>>>0>2?q:2;break}case 105:{t=q>>>0>4?q:4;break}case 102:{t=q>>>0>4?q:4;break}case 100:{t=q>>>0>8?q:8;break}default:t=q}r=r+1|0;s=b[r>>0]|0;if(!(s<<24>>24)){l=t;break}else q=t}m=e+-1|0;n=m+l|0;o=0-l|0;p=n&o;u=c;return p|0}function vU(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;i=u;u=u+64|0;k=i+16|0;l=i;m=i+24|0;f[l+4>>2]=0;xU(m,a,c,e);e=m+8|0;c=m+28|0;a=m+20|0;o=m+16|0;q=m+12|0;r=l+8|0;s=l+8|0;while(1){t=f[m>>2]|0;if(t>>>0>=(f[e>>2]|0)>>>0)break;v=k;f[v>>2]=0;f[v+4>>2]=0;v=f[c>>2]|0;Uh[f[v+8>>2]&1023](t+(f[v+4>>2]|0)|0,k)|0;v=f[c>>2]|0;t=f[v>>2]|0;switch(t|0){case 0:{f[r>>2]=h[k>>0];w=11;break}case 1:{f[r>>2]=b[k>>0];w=11;break}case 2:{f[r>>2]=j[k>>1];w=11;break}case 3:{f[r>>2]=d[k>>1];w=11;break}case 4:{f[r>>2]=f[k>>2];w=11;break}case 5:{p[s>>3]=+n[k>>2];w=11;break}case 6:{p[s>>3]=+p[k>>3];w=11;break}default:x=t}if((w|0)==11){w=0;x=f[v>>2]|0}switch(x|0){case 4:case 3:case 2:case 1:case 0:{y=1;w=14;break}case 6:case 5:{y=2;w=14;break}default:{}}if((w|0)==14){w=0;f[l>>2]=y}t=v+12|0;f[c>>2]=t;if((t|0)==(f[a>>2]|0)){f[c>>2]=f[o>>2];f[m>>2]=(f[m>>2]|0)+(f[q>>2]|0)}XW(g,l)|0}l=f[o>>2]|0;if(!l){u=i;return}o=f[a>>2]|0;if((o|0)!=(l|0))f[a>>2]=o+(~(((o+-12-l|0)>>>0)/12|0)*12|0);O5b(l);u=i;return}function wU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0.0,v=0;e=u;u=u+1056|0;g=e+16|0;h=e;i=e+32|0;j=+PVb(c,d);k=f[d>>2]|0;if((b[k>>0]|0)==46){b[k>>0]=44;l=+PVb(c,d);b[k>>0]=46;m=f[d>>2]|0;if(m>>>0>k>>>0){n=l;o=m}else{f[d>>2]=k;n=j;o=k}}else{n=j;o=k}if((o|0)!=(c|0)?((b[o>>0]&-33)+-65&255)>=26:0){p=n;u=e;return +p}o=b[c>>0]|0;switch(o<<24>>24){case 43:case 45:{k=c+1|0;q=o<<24>>24==45?-D:D;r=b[k>>0]|0;s=k;break}default:{q=D;r=o;s=c}}if(r<<24>>24!=46){r=f[a+88>>2]|0;f[h>>2]=f[a+60>>2];f[h+4>>2]=r;f[h+8>>2]=203209;_Ub(i,202147,h)|0;MO(-212,203247,i,201015,1059)}h=b[s+1>>0]|0;if(((iVb(h)|0)==73?(iVb(b[s+2>>0]|0)|0)==78:0)?(iVb(b[s+3>>0]|0)|0)==70:0)t=q;else v=13;do if((v|0)==13){if(((iVb(h)|0)==78?(iVb(b[s+2>>0]|0)|0)==65:0)?(iVb(b[s+3>>0]|0)|0)==78:0){t=C;break}r=f[a+88>>2]|0;f[g>>2]=f[a+60>>2];f[g+4>>2]=r;f[g+8>>2]=203209;_Ub(i,202147,g)|0;MO(-212,203247,i,201015,1068);t=0.0}while(0);f[d>>2]=s+4;p=t;u=e;return +p}function xU(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g;f[a>>2]=c;i=a+4|0;f[i>>2]=c;j=a+8|0;f[j>>2]=c;k=a+16|0;f[k>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if(!c){f[h>>2]=0;f[h+4>>2]=0;c=aD(h,3)|0;b[c>>0]=b[203271]|0;b[c+1>>0]=b[203272]|0;b[c+2>>0]=b[203273]|0;bO(-215,h,203275,201015,8155);bD(h)}if(!e){f[h>>2]=0;f[h+4>>2]=0;c=aD(h,2)|0;b[c>>0]=100;b[c+1>>0]=116;bO(-215,h,203275,201015,8156);bD(h)}if((d|0)<=-1){f[h>>2]=0;f[h+4>>2]=0;c=aD(h,8)|0;l=c;b[l>>0]=108;b[l+1>>0]=101;b[l+2>>0]=110;b[l+3>>0]=32;l=c+4|0;b[l>>0]=62;b[l+1>>0]=61;b[l+2>>0]=32;b[l+3>>0]=48;bO(-215,h,203275,201015,8157);bD(h)}yU(a,e);f[a+28>>2]=f[k>>2];k=uU(e)|0;f[a+12>>2]=k;a=(f[i>>2]|0)+(Y(k,d)|0)|0;f[j>>2]=a;u=g;return}function yU(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+176|0;e=d+160|0;g=d+164|0;h=d+20|0;i=d+8|0;j=d;f[e>>2]=0;b[g>>0]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=kUb(c)|0;if(k>>>0>4294967279)V5b(i);if(k>>>0<11){b[i+11>>0]=k;if(!k)l=i;else{m=i;n=6}}else{o=k+16&-16;p=L5b(o)|0;f[i>>2]=p;f[i+8>>2]=o|-2147483648;f[i+4>>2]=k;m=p;n=6}if((n|0)==6){Vac(m|0,c|0,k|0)|0;l=m}b[l+k>>0]=0;k=h+60|0;l=h+8|0;f[h>>2]=10956;f[k>>2]=10976;f[h+4>>2]=0;RXb(h+60|0,l);f[h+132>>2]=0;f[h+136>>2]=-1;f[h>>2]=47196;f[k>>2]=47216;WXb(l);f[l>>2]=43284;k=h+40|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[h+56>>2]=8;qP(l,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);l=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;a:do if(!(l&2)){k=i+4|0;m=j+4|0;c=i+4|0;n=j+4|0;p=a+20|0;o=a+24|0;q=a+16|0;r=i+8|0;s=0;while(1){t=bYb(h,e)|0;if(!(f[t+(f[(f[t>>2]|0)+-12>>2]|0)+16>>2]&5)){if(!(f[e>>2]|0)){f[i>>2]=0;f[k>>2]=0;t=aD(i,8)|0;v=t;b[v>>0]=99;b[v+1>>0]=110;b[v+2>>0]=116;b[v+3>>0]=32;v=t+4|0;b[v>>0]=62;b[v+1>>0]=32;b[v+2>>0]=48;b[v+3>>0]=85;bO(-215,i,203298,201015,8248);bD(i)}}else{QXb(h+(f[(f[h>>2]|0)+-12>>2]|0)|0,0);f[e>>2]=1}v=zU(h,g)|0;if(f[v+(f[(f[v>>2]|0)+-12>>2]|0)+16>>2]&5|0)break;v=f[e>>2]|0;f[e>>2]=v+-1;b:do if(!v)w=s;else{t=s;while(1){x=b[g>>0]|0;switch(x<<24>>24|0){case 99:case 117:{f[r>>2]=539;y=1;z=x;break}case 115:case 119:{f[r>>2]=540;y=2;z=x;break}case 105:{f[r>>2]=541;y=4;z=x;break}case 102:{f[r>>2]=542;y=4;z=x;break}case 100:{f[r>>2]=543;y=8;z=x;break}default:{f[j>>2]=0;f[m>>2]=0;A=aD(j,19)|0;B=203309;C=A+19|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,j,203298,201015,8283);bD(j);y=0;z=b[g>>0]|0}}x=t+-1+y&0-y;f[c>>2]=x;D=x+y|0;switch(z<<24>>24|0){case 117:{f[i>>2]=0;break}case 99:{f[i>>2]=1;break}case 119:{f[i>>2]=2;break}case 115:{f[i>>2]=3;break}case 105:{f[i>>2]=4;break}case 102:{f[i>>2]=5;break}case 100:{f[i>>2]=6;break}default:{f[j>>2]=0;f[n>>2]=0;A=aD(j,22)|0;B=203329;C=A+22|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,j,203298,201015,8301);bD(j)}}x=f[p>>2]|0;if((x|0)==(f[o>>2]|0))FU(q,i);else{f[x>>2]=f[i>>2];f[x+4>>2]=f[i+4>>2];f[x+8>>2]=f[i+8>>2];f[p>>2]=(f[p>>2]|0)+12}x=f[e>>2]|0;f[e>>2]=x+-1;if(!x){w=D;break b}else t=D}}while(0);v=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;if(!(v&2))s=w;else{E=v;break a}}E=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0}else E=l;while(0);if(!(E&2)){f[i>>2]=0;f[i+4>>2]=0;A=aD(i,9)|0;B=203352;C=A+9|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,i,203298,201015,8308);bD(i)}if((f[a+20>>2]|0)!=(f[a+16>>2]|0)){GU(h);u=d;return}f[i>>2]=0;f[i+4>>2]=0;A=aD(i,22)|0;B=203362;C=A+22|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,i,203298,201015,8309);bD(i);GU(h);u=d;return}function zU(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;YXb(e,a,0);if(!(b[e>>0]|0)){u=d;return a|0}e=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;g=e+12|0;i=f[g>>2]|0;if((i|0)==(f[e+16>>2]|0)){j=di[f[(f[e>>2]|0)+40>>2]&1023](e)|0;if((j|0)==-1){e=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(e,f[e+16>>2]|6);u=d;return a|0}else k=j}else{f[g>>2]=i+1;k=h[i>>0]|0}b[c>>0]=k;u=d;return a|0}function AU(a,c){a=a|0;c=c|0;b[c>>0]=0;b[c>>0]=b[a>>0]|0;return 1}function BU(a,c){a=a|0;c=c|0;var e=0;d[c>>1]=0;e=b[a>>0]|0;d[c>>1]=e&255;d[c>>1]=(h[a+1>>0]|0)<<8|e&255;return 2}function CU(a,b){a=a|0;b=b|0;var c=0,d=0;f[b>>2]=0;c=h[a>>0]|0;f[b>>2]=c;d=(h[a+1>>0]|0)<<8|c;f[b>>2]=d;c=(h[a+2>>0]|0)<<16|d;f[b>>2]=c;f[b>>2]=(h[a+3>>0]|0)<<24|c;return 4}function DU(a,b){a=a|0;b=b|0;f[b>>2]=(h[a+1>>0]|0)<<8|(h[a>>0]|0)|(h[a+2>>0]|0)<<16|(h[a+3>>0]|0)<<24;return 4}function EU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0;c=h[a>>0]|0;d=$ac(h[a+1>>0]|0|0,0,8)|0;e=J;g=$ac(h[a+2>>0]|0|0,0,16)|0;i=e|J;e=$ac(h[a+3>>0]|0|0,0,24)|0;j=i|J|(h[a+4>>0]|0);i=$ac(h[a+5>>0]|0|0,0,40)|0;k=j|J;j=$ac(h[a+6>>0]|0|0,0,48)|0;l=k|J;k=$ac(h[a+7>>0]|0|0,0,56)|0;a=b;f[a>>2]=d|c|g|e|i|j|k;f[a+4>>2]=l|J;return 8}function FU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)c4b(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;O5b(d);return}function GU(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=47196;c=a+60|0;f[c>>2]=47216;d=a+8|0;f[d>>2]=43284;e=a+40|0;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);FWb(d);rXb(a,47228);AWb(c);return}function HU(a){a=a|0;GU(a);O5b(a);return}function IU(a){a=a|0;GU(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function JU(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;GU(b);O5b(b);return}function KU(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+16|0;e=d;if(!a){g=0;u=d;return g|0}h=kUb(a)|0;if(!h){g=0;u=d;return g|0}f[c>>2]=0;if((h|0)>0){i=~a;j=e+4|0;k=e+4|0;l=e+4|0;m=0;n=0;o=0;while(1){p=a+m|0;q=b[p>>0]|0;r=q<<24>>24;do if((q+-48&255)<10){if(((b[a+(m+1)>>0]|0)+-48&255)<10){f[e>>2]=0;s=WVb(p,e,10)|0;t=s;v=(f[e>>2]|0)+i|0}else{t=r+-48|0;v=m}if((t|0)<1){f[e>>2]=0;f[j>>2]=0;w=aD(e,31)|0;x=203455;y=w+31|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-5,e,203487,201015,4701);bD(e);z=n;A=v;B=t}else{z=n;A=v;B=t}}else{s=xTb(203503,r,9)|0;if(!s){f[e>>2]=0;f[k>>2]=0;w=aD(e,31)|0;x=203455;y=w+31|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-5,e,203487,201015,4709);bD(e);C=c+(n<<2)|0;D=C;E=f[C>>2]|0}else{D=c+(n<<2)|0;E=o}if(!E)f[D>>2]=1;C=s-203503|0;f[c+(n+1<<2)>>2]=C;if((n|0)>0?(C|0)==(f[c+(n+-1<<2)>>2]|0):0){C=c+(n+-2<<2)|0;f[C>>2]=(f[C>>2]|0)+(f[D>>2]|0);z=n;A=m;B=0;break}C=n+2|0;if((C|0)>255){f[e>>2]=0;f[l>>2]=0;w=aD(e,32)|0;x=203512;y=w+32|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-5,e,203487,201015,4719);bD(e);z=C;A=m;B=0}else{z=C;A=m;B=0}}while(0);f[c+(z<<2)>>2]=B;m=A+1|0;if((m|0)>=(h|0)){F=z;break}else{n=z;o=B}}}else F=0;g=(F|0)/2|0;u=d;return g|0}function LU(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0;if(!((a|0)!=0&(c|0)!=0&(e|0)!=0&(e&3|0)==0)){f=0;return f|0}g=a+d|0;i=g+e|0;if((e|0)>0){e=a+(d+4)|0;j=((((i>>>0>e>>>0?i:e)+(~a-d)|0)>>>2)*3|0)+3|0;d=c;a=g;while(1){g=b[202778+(h[a+3>>0]|0)>>0]|0;e=h[202778+(h[a+2>>0]|0)>>0]|0;k=h[202778+(h[a+1>>0]|0)>>0]|0;b[d>>0]=k>>>4&3|(h[202778+(h[a>>0]|0)>>0]|0)<<2;a=a+4|0;b[d+1>>0]=e>>>2&15|k<<4;b[d+2>>0]=g&255|e<<6;if(a>>>0>=i>>>0)break;else d=d+3|0}l=c+j|0}else l=c;b[l>>0]=0;f=l-c|0;return f|0}function MU(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e+4|0;i=e;YXb(g,a,0);if(!(b[g>>0]|0)){g=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(g,f[g+16>>2]|4);u=e;return a|0}g=c+11|0;if((b[g>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0}else{b[c>>0]=0;b[g>>0]=0}g=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;j=f[g+12>>2]|0;k=(j|0)<1?2147483647:j;TXb(i,g);g=xZb(i,855500)|0;yZb(i);a:do if((k|0)>0){i=g+8|0;j=0;while(1){l=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;m=f[l+12>>2]|0;if((m|0)==(f[l+16>>2]|0)){n=di[f[(f[l>>2]|0)+36>>2]&1023](l)|0;if((n|0)==-1){o=j;p=2;break a}else q=n}else q=h[m>>0]|0;m=q&255;if(m<<24>>24>-1?d[(f[i>>2]|0)+(q<<24>>24<<1)>>1]&8192:0){o=j;p=0;break a}l6b(c,m);m=j+1|0;n=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;l=n+12|0;r=f[l>>2]|0;if((r|0)==(f[n+16>>2]|0))di[f[(f[n>>2]|0)+40>>2]&1023](n)|0;else f[l>>2]=r+1;if((m|0)<(k|0))j=m;else{o=m;p=0;break}}}else{o=0;p=0}while(0);f[a+(f[(f[a>>2]|0)+-12>>2]|0)+12>>2]=0;k=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(k,f[k+16>>2]|((o|0)==0?p|4:p));u=e;return a|0}function NU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+1040|0;e=d;g=d+16|0;if((b&7|0)==6){if(f[c>>2]|0){h=f[a+88>>2]|0;f[e>>2]=f[a+60>>2];f[e+4>>2]=h;f[e+8>>2]=203909;_Ub(g,202147,e)|0;MO(-212,203961,g,201015,558)}g=f[a+16>>2]|0;e=bX(0,72,24,g)|0;f[e+64>>2]=16;h=FW(g,64)|0;f[e+68>>2]=h;g=h;h=g+64|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[c+8>>2]=e;i=c;j=e;f[i>>2]=b;JW(j,8);u=d;return}else{e=IW(0,56,16,f[a+16>>2]|0)|0;if(f[c>>2]&7|0)XW(e,c)|0;f[c+8>>2]=e;i=c;j=e;f[i>>2]=b;JW(j,8);u=d;return}}function OU(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+16|0;i=g;if(!a){j=0;u=g;return j|0}k=f[a+28>>2]|0;if((d|0)<0){a=b[c>>0]|0;if(!(a<<24>>24)){l=0;m=0}else{n=0;o=0;p=a;while(1){a=(p&255)+(o*33|0)|0;q=n+1|0;p=b[c+q>>0]|0;if(!(p<<24>>24)){l=q;m=a;break}else{n=q;o=a}}}}else if(!d){l=0;m=0}else{o=0;n=0;while(1){p=(h[c+n>>0]|0)+(o*33|0)|0;n=n+1|0;if((n|0)>=(d|0)){l=d;m=p;break}else o=p}}o=m&2147483647;m=f[k+64>>2]|0;d=m+-1|0;if(!(d&m))r=d&o;else r=(o>>>0)%(m>>>0)|0;m=k+68|0;d=f[(f[m>>2]|0)+(r<<2)>>2]|0;a:do if(d|0){n=d;while(1){if(((f[n>>2]|0)==(o|0)?(f[n+4>>2]|0)==(l|0):0)?(ZVb(f[n+8>>2]|0,c,l)|0)==0:0){j=n;break}n=f[n+12>>2]|0;if(!n)break a}u=g;return j|0}while(0);if(!e){j=0;u=g;return j|0}e=k+56|0;d=f[e>>2]|0;f[i>>2]=d;if(!d){cX(k,0,i)|0;s=f[i>>2]|0}else{f[e>>2]=f[d+4>>2];f[d>>2]=f[d>>2]&67108863;e=k+60|0;f[e>>2]=(f[e>>2]|0)+1;s=d}f[s>>2]=o;HW(i,f[k+44>>2]|0,c,l);l=i;i=f[l+4>>2]|0;c=s+4|0;f[c>>2]=f[l>>2];f[c+4>>2]=i;i=(f[m>>2]|0)+(r<<2)|0;f[s+12>>2]=f[i>>2];f[i>>2]=s;j=s;u=g;return j|0}function PU(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+1040|0;h=g;i=g+16|0;if(!a){j=0;u=g;return j|0}if((f[a>>2]|0)!=1280131417){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,31)|0;l=201141;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-5,i,203798,201015,786);bD(i)}if(!d){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,16)|0;l=203812;m=k+16|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-27,i,203798,201015,789);bD(i)}n=(c|0)!=0;if(n){o=f[a+32>>2]|0;if(!o){j=0;u=g;return j|0}p=f[o+24>>2]|0;if((p|0)>0)q=p;else{j=0;u=g;return j|0}}else q=1;p=q+-1|0;o=(e|0)!=0;r=(e|0)==0;e=a+60|0;s=a+88|0;t=a+32|0;a=i+4|0;v=0;w=0;a:while(1){if(!n){x=KW(f[t>>2]|0,w)|0;if(!x){f[i>>2]=0;f[a>>2]=0;k=aD(i,14)|0;l=203829;m=k+14|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,203798,201015,807);bD(i);y=x}else y=x}else y=c;switch(f[y>>2]&7){case 5:{z=14;break a;break}case 0:{j=0;z=33;break a;break}case 6:break;default:break a}A=f[y+8>>2]|0;B=f[A+64>>2]|0;C=B+-1|0;D=f[d>>2]|0;if(!(C&B))E=D&C;else E=(D>>>0)%(B>>>0)|0;B=A+68|0;D=f[(f[B>>2]|0)+(E<<2)>>2]|0;b:do if(D|0){if(r){F=D;while(1){if((f[F+16>>2]|0)==(d|0)){z=24;break a}C=f[F+20>>2]|0;if(!C)break b;else F=C}}else G=D;do{if((f[G+16>>2]|0)==(d|0)){C=f[s>>2]|0;f[h>>2]=f[e>>2];f[h+4>>2]=C;f[h+8>>2]=203894;_Ub(i,202147,h)|0;MO(-212,203798,i,201015,832)}G=f[G+20>>2]|0}while((G|0)!=0)}while(0);if(o&(w|0)==(p|0)){D=A+56|0;x=f[D>>2]|0;f[i>>2]=x;if(!x){cX(A,0,i)|0;H=f[i>>2]|0}else{f[D>>2]=f[x+4>>2];f[x>>2]=f[x>>2]&67108863;D=A+60|0;f[D>>2]=(f[D>>2]|0)+1;H=x}f[H+16>>2]=d;x=(f[B>>2]|0)+(E<<2)|0;f[H+20>>2]=f[x>>2];f[x>>2]=H;I=H}else I=v;w=w+1|0;if((w|0)>=(q|0)){j=I;z=33;break}else v=I}if((z|0)==14){if(!(f[(f[y+8>>2]|0)+24>>2]|0)){j=0;u=g;return j|0}}else if((z|0)==24){j=F;u=g;return j|0}else if((z|0)==33){u=g;return j|0}f[i>>2]=0;f[i+4>>2]=0;k=aD(i,49)|0;l=203844;m=k+49|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,i,203798,201015,812);bD(i);j=0;u=g;return j|0}function QU(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;g=u;u=u+1168|0;i=g+80|0;j=g+64|0;k=g+48|0;l=g+32|0;m=g+16|0;n=g;o=g+136|0;p=g+128|0;q=g+116|0;r=g+104|0;s=g+92|0;t=jU(a,c,0)|0;c=t;f[p>>2]=c;v=a+92|0;if((f[v>>2]|0)==0?(c-(f[a+76>>2]|0)|0)==(d|0):0){w=t;while(1){x=b[w>>0]|0;if((x&255)>31)w=w+1|0;else break}if(!(x<<24>>24)){x=f[a+88>>2]|0;f[n>>2]=f[a+60>>2];f[n+4>>2]=x;f[n+8>>2]=204441;_Ub(o,202147,n)|0;MO(-212,204464,o,201015,1345)}n=w;f[p>>2]=n;y=n;z=w}else{y=c;z=t}if(t>>>0>=z>>>0){A=z;u=g;return A|0};f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;if((y-c|0)<32){y=f[a+88>>2]|0;f[m>>2]=f[a+60>>2];f[m+4>>2]=y;f[m+8>>2]=202989;_Ub(o,202147,m)|0;MO(-212,204496,o,201015,1365)}f[r>>2]=0;m=r+4|0;f[m>>2]=0;f[r+8>>2]=0;y=L5b(25)|0;f[r>>2]=y;z=y+25|0;f[r+8>>2]=z;w=y;n=w+25|0;do{b[w>>0]=32;w=w+1|0}while((w|0)<(n|0));f[m>>2]=z;if(t|0){z=t+32|0;w=t+4|0;n=(((z>>>0>w>>>0?z:w)+~c|0)>>>2)*3|0;c=y;w=0;while(1){z=t+w|0;w=w+4|0;x=b[202778+(h[z+3>>0]|0)>>0]|0;B=h[202778+(h[z+2>>0]|0)>>0]|0;C=h[202778+(h[z+1>>0]|0)>>0]|0;b[c>>0]=C>>>4&3|h[202778+(h[z>>0]|0)>>0]<<2;b[c+1>>0]=B>>>2&15|C<<4;b[c+2>>0]=x&255|B<<6;if((w|0)>=32)break;else c=c+3|0}b[y+(n+3)>>0]=0}if(!(qU(r,q)|0?(n=b[q+11>>0]|0,((n<<24>>24<0?f[q+4>>2]|0:n&255)|0)!=0):0)){n=f[a+88>>2]|0;f[l>>2]=f[a+60>>2];f[l+4>>2]=n;f[l+8>>2]=202905;_Ub(o,202147,l)|0;MO(-212,204496,o,201015,1370)}l=t+32|0;t=f[r>>2]|0;if(t|0){if((f[m>>2]|0)!=(t|0))f[m>>2]=t;O5b(t)};f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;c6b(r,131072);t=f[p>>2]|0;if(l>>>0<t>>>0){m=a+76|0;n=a+60|0;y=a+88|0;c=t;t=l;while(1){pU(r,t,c)|0;t=jU(a,c,0)|0;l=t;f[p>>2]=l;if((f[v>>2]|0)==0?(l-(f[m>>2]|0)|0)==(d|0):0){l=t;while(1){D=b[l>>0]|0;if((D&255)>31)l=l+1|0;else break}if(!(D<<24>>24)){w=f[y>>2]|0;f[k>>2]=f[n>>2];f[k+4>>2]=w;f[k+8>>2]=204441;_Ub(o,202147,k)|0;MO(-212,204464,o,201015,1345)}f[p>>2]=l;E=l}else E=t;if(t>>>0>=E>>>0)break;else c=E}}E=r+11|0;c=b[E>>0]|0;t=c<<24>>24<0;k=r+4|0;n=f[k>>2]|0;y=c&255;a:do if((t?n:y)|0){D=t?f[r>>2]|0:r;d=t?n:y;if(!d)F=kUb(D)|0;else F=d;if(D){if(!F)G=kUb(D)|0;else G=F;if((G|0)!=0&(G&3|0)==0){d=D+G|0;m=d+-1|0;if((b[m>>0]|0)==61){w=m+-1|0;H=(b[w>>0]|0)==61?w:m}else H=d;if(D>>>0<H>>>0){d=D;while(1){D=b[d>>0]|0;if((D&255)>126){I=43;break a}d=d+1|0;if(!(D<<24>>24==65|(b[202778+(D&255)>>0]|0)!=0)){I=43;break a}if(d>>>0>=H>>>0){J=c;K=n;break}}}else{J=c;K=n}}else I=43}else I=43}else I=43;while(0);if((I|0)==43){I=f[a+88>>2]|0;f[j>>2]=f[a+60>>2];f[j+4>>2]=I;f[j+8>>2]=202935;_Ub(o,202147,j)|0;MO(-212,204496,o,201015,1386);J=b[E>>0]|0;K=f[k>>2]|0}j=(((J<<24>>24<0?K:J&255)>>>2)*3|0)+1|0;f[s>>2]=0;I=s+4|0;f[I>>2]=0;f[s+8>>2]=0;if(!j){L=J;M=K;N=0}else{if((j|0)<0)c4b(s);K=L5b(j)|0;f[I>>2]=K;f[s>>2]=K;f[s+8>>2]=K+j;J=j;j=K;do{b[j>>0]=0;j=(f[I>>2]|0)+1|0;f[I>>2]=j;J=J+-1|0}while((J|0)!=0);L=b[E>>0]|0;M=f[k>>2]|0;N=j}j=L<<24>>24<0;J=j?M:L&255;L=0;M=(j?f[r>>2]|0:r)+J|0;while(1){M=M+-1|0;if((b[M>>0]|0)!=61)break;else L=L+1|0}M=((J>>>2)*3|0)-L|0;L=f[s>>2]|0;f[o>>2]=L;f[o+4>>2]=L+(N-L);L=o+8|0;f[L>>2]=0;N=o+12|0;f[N>>2]=0;f[o+16>>2]=0;J=L5b(120)|0;f[N>>2]=J;f[L>>2]=J;f[o+16>>2]=J+120;L=120;j=J;do{b[j>>0]=0;j=(f[N>>2]|0)+1|0;f[N>>2]=j;L=L+-1|0}while((L|0)!=0);L=o+20|0;j=o+24|0;N=o+28|0;J=o+32|0;K=o+36|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;f[L+16>>2]=0;f[L+20>>2]=0;n=L5b(161)|0;f[K>>2]=n;f[J>>2]=n;f[o+40>>2]=n+161;c=161;H=n;do{b[H>>0]=0;H=(f[K>>2]|0)+1|0;f[K>>2]=H;c=c+-1|0}while((c|0)!=0);c=f[J>>2]|0;f[L>>2]=c;f[j>>2]=c;f[N>>2]=c+120;c=b[E>>0]|0;N=c<<24>>24<0;j=N?f[r>>2]|0:r;rU(o,j,j+(N?f[k>>2]|0:c&255)|0)|0;sU(o)|0;tU(o);c=q+11|0;k=uU((b[c>>0]|0)<0?f[q>>2]|0:q)|0;if((M|0)%(k|0)|0|0){N=f[a+88>>2]|0;f[i>>2]=f[a+60>>2];f[i+4>>2]=N;f[i+8>>2]=202956;_Ub(o,202147,i)|0;MO(-212,204496,o,201015,1404)}f[e>>2]=0;o=IW(0,56,16,f[a+16>>2]|0)|0;if(f[e>>2]&7|0)XW(o,e)|0;i=e+8|0;f[i>>2]=o;f[e>>2]=13;JW(o,8);vU(f[s>>2]|0,(M|0)/(k|0)|0,(b[c>>0]|0)<0?f[q>>2]|0:q,f[i>>2]|0);i=f[((f[v>>2]|0)==0?p:a+76|0)>>2]|0;a=f[s>>2]|0;if(a|0){if((f[I>>2]|0)!=(a|0))f[I>>2]=a;O5b(a)}if((b[E>>0]|0)<0)O5b(f[r>>2]|0);if((b[c>>0]|0)<0)O5b(f[q>>2]|0);A=i;u=g;return A|0}function RU(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+1072|0;h=g+32|0;i=g+16|0;j=g;k=g+48|0;l=c+-1|0;if((b[c>>0]|0)==45){m=f[a+88>>2]|0;f[j>>2]=f[a+60>>2];f[j+4>>2]=m;f[j+8>>2]=204374;_Ub(k,202147,j)|0;MO(-212,204401,k,201015,1432);n=l}else n=l;while(1){o=n+1|0;l=b[o>>0]|0;p=l<<24>>24!=58;if((l&255)<32|p^1)break;else n=o}if(p){p=f[a+88>>2]|0;f[i>>2]=f[a+60>>2];f[i+4>>2]=p;f[i+8>>2]=204416;_Ub(k,202147,i)|0;MO(-212,204401,k,201015,1438);q=o}else q=o;while(1){o=q+-1|0;if((b[o>>0]|0)==32)q=o;else break}o=n+2|0;if((q|0)!=(c|0)){r=q;s=c;t=r-s|0;v=OU(a,c,t,1)|0;w=PU(a,d,v,1)|0;f[e>>2]=w;u=g;return o|0}n=f[a+88>>2]|0;f[h>>2]=f[a+60>>2];f[h+4>>2]=n;f[h+8>>2]=204428;_Ub(k,202147,h)|0;MO(-212,204401,k,201015,1446);r=q;s=c;t=r-s|0;v=OU(a,c,t,1)|0;w=PU(a,d,v,1)|0;f[e>>2]=w;u=g;return o|0}function SU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;e=u;u=u+1168|0;g=e+80|0;i=e+64|0;j=e+48|0;k=e+32|0;l=e+16|0;m=e;n=e+136|0;o=e+128|0;p=e+116|0;q=e+104|0;r=e+92|0;s=gU(a,c,2)|0;c=s;f[o>>2]=c;t=a+92|0;if((f[t>>2]|0)==0?(v=b[s>>0]|0,v<<24>>24!=60):0){if((v&255)>31){w=s;while(1){x=w+1|0;y=b[x>>0]|0;if((y&255)>31)w=x;else{z=x;A=y;break}}}else{z=s;A=v}if(!(A<<24>>24)){A=f[a+88>>2]|0;f[m>>2]=f[a+60>>2];f[m+4>>2]=A;f[m+8>>2]=204441;_Ub(n,202147,m)|0;MO(-212,205059,n,201015,2328)}m=z;f[o>>2]=m;B=m;C=z}else{B=c;C=s}if(s>>>0>=C>>>0){D=C;u=e;return D|0};f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;if((B-c|0)<32){B=f[a+88>>2]|0;f[l>>2]=f[a+60>>2];f[l+4>>2]=B;f[l+8>>2]=202989;_Ub(n,202147,l)|0;MO(-212,205091,n,201015,2347)}f[q>>2]=0;l=q+4|0;f[l>>2]=0;f[q+8>>2]=0;B=L5b(25)|0;f[q>>2]=B;C=B+25|0;f[q+8>>2]=C;z=B;m=z+25|0;do{b[z>>0]=32;z=z+1|0}while((z|0)<(m|0));f[l>>2]=C;if(s|0){C=s+32|0;z=s+4|0;m=(((C>>>0>z>>>0?C:z)+~c|0)>>>2)*3|0;c=B;z=0;while(1){C=s+z|0;z=z+4|0;A=b[202778+(h[C+3>>0]|0)>>0]|0;v=h[202778+(h[C+2>>0]|0)>>0]|0;w=h[202778+(h[C+1>>0]|0)>>0]|0;b[c>>0]=w>>>4&3|h[202778+(h[C>>0]|0)>>0]<<2;b[c+1>>0]=v>>>2&15|w<<4;b[c+2>>0]=A&255|v<<6;if((z|0)>=32)break;else c=c+3|0}b[B+(m+3)>>0]=0}if(!(qU(q,p)|0?(m=b[p+11>>0]|0,((m<<24>>24<0?f[p+4>>2]|0:m&255)|0)!=0):0)){m=f[a+88>>2]|0;f[k>>2]=f[a+60>>2];f[k+4>>2]=m;f[k+8>>2]=202905;_Ub(n,202147,k)|0;MO(-212,205091,n,201015,2352)}k=s+32|0;s=f[q>>2]|0;if(s|0){if((f[l>>2]|0)!=(s|0))f[l>>2]=s;O5b(s)};f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;c6b(q,131072);s=f[o>>2]|0;if(k>>>0<s>>>0){l=a+60|0;m=a+88|0;B=s;s=k;while(1){pU(q,s,B)|0;s=gU(a,B,2)|0;f[o>>2]=s;if((f[t>>2]|0)==0?(k=b[s>>0]|0,k<<24>>24!=60):0){if((k&255)>31){c=s;while(1){z=c+1|0;v=b[z>>0]|0;if((v&255)>31)c=z;else{E=z;F=v;break}}}else{E=s;F=k}if(!(F<<24>>24)){c=f[m>>2]|0;f[j>>2]=f[l>>2];f[j+4>>2]=c;f[j+8>>2]=204441;_Ub(n,202147,j)|0;MO(-212,205059,n,201015,2328)}f[o>>2]=E;G=E}else G=s;if(s>>>0>=G>>>0)break;else B=G}}G=q+11|0;B=b[G>>0]|0;s=B<<24>>24<0;E=q+4|0;j=f[E>>2]|0;l=B&255;a:do if((s?j:l)|0){m=s?f[q>>2]|0:q;F=s?j:l;if(!F)H=kUb(m)|0;else H=F;if(m){if(!H)I=kUb(m)|0;else I=H;if((I|0)!=0&(I&3|0)==0){F=m+I|0;c=F+-1|0;if((b[c>>0]|0)==61){v=c+-1|0;J=(b[v>>0]|0)==61?v:c}else J=F;if(m>>>0<J>>>0){F=m;while(1){m=b[F>>0]|0;if((m&255)>126){K=45;break a}F=F+1|0;if(!(m<<24>>24==65|(b[202778+(m&255)>>0]|0)!=0)){K=45;break a}if(F>>>0>=J>>>0){L=B;M=j;break}}}else{L=B;M=j}}else K=45}else K=45}else K=45;while(0);if((K|0)==45){K=f[a+88>>2]|0;f[i>>2]=f[a+60>>2];f[i+4>>2]=K;f[i+8>>2]=202935;_Ub(n,202147,i)|0;MO(-212,205091,n,201015,2368);L=b[G>>0]|0;M=f[E>>2]|0}i=(((L<<24>>24<0?M:L&255)>>>2)*3|0)+1|0;f[r>>2]=0;K=r+4|0;f[K>>2]=0;f[r+8>>2]=0;if(!i){N=L;O=M;P=0}else{if((i|0)<0)c4b(r);M=L5b(i)|0;f[K>>2]=M;f[r>>2]=M;f[r+8>>2]=M+i;L=i;i=M;do{b[i>>0]=0;i=(f[K>>2]|0)+1|0;f[K>>2]=i;L=L+-1|0}while((L|0)!=0);N=b[G>>0]|0;O=f[E>>2]|0;P=i}i=N<<24>>24<0;L=i?O:N&255;N=0;O=(i?f[q>>2]|0:q)+L|0;while(1){O=O+-1|0;if((b[O>>0]|0)!=61)break;else N=N+1|0}O=((L>>>2)*3|0)-N|0;N=f[r>>2]|0;f[n>>2]=N;f[n+4>>2]=N+(P-N);N=n+8|0;f[N>>2]=0;P=n+12|0;f[P>>2]=0;f[n+16>>2]=0;L=L5b(120)|0;f[P>>2]=L;f[N>>2]=L;f[n+16>>2]=L+120;N=120;i=L;do{b[i>>0]=0;i=(f[P>>2]|0)+1|0;f[P>>2]=i;N=N+-1|0}while((N|0)!=0);N=n+20|0;i=n+24|0;P=n+28|0;L=n+32|0;M=n+36|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;f[N+16>>2]=0;f[N+20>>2]=0;j=L5b(161)|0;f[M>>2]=j;f[L>>2]=j;f[n+40>>2]=j+161;B=161;J=j;do{b[J>>0]=0;J=(f[M>>2]|0)+1|0;f[M>>2]=J;B=B+-1|0}while((B|0)!=0);B=f[L>>2]|0;f[N>>2]=B;f[i>>2]=B;f[P>>2]=B+120;B=b[G>>0]|0;P=B<<24>>24<0;i=P?f[q>>2]|0:q;rU(n,i,i+(P?f[E>>2]|0:B&255)|0)|0;sU(n)|0;tU(n);B=p+11|0;E=uU((b[B>>0]|0)<0?f[p>>2]|0:p)|0;if((O|0)%(E|0)|0|0){P=f[a+88>>2]|0;f[g>>2]=f[a+60>>2];f[g+4>>2]=P;f[g+8>>2]=205109;_Ub(n,202147,g)|0;MO(-212,205091,n,201015,2386)}f[d>>2]=0;n=IW(0,56,16,f[a+16>>2]|0)|0;if(f[d>>2]&7|0)XW(n,d)|0;g=d+8|0;f[g>>2]=n;f[d>>2]=5;JW(n,8);vU(f[r>>2]|0,(O|0)/(E|0)|0,(b[B>>0]|0)<0?f[p>>2]|0:p,f[g>>2]|0);g=f[((f[t>>2]|0)==0?o:a+76|0)>>2]|0;a=f[r>>2]|0;if(a|0){if((f[K>>2]|0)!=(a|0))f[K>>2]=a;O5b(a)}if((b[G>>0]|0)<0)O5b(f[q>>2]|0);if((b[B>>0]|0)<0)O5b(f[p>>2]|0);D=g;u=e;return D|0}function TU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=u;u=u+16|0;g=e;zT(a,0);switch(f[a+280>>2]|0){case 0:{AT(a,1);break}case 2:{f[g>>2]=0;f[g+4>>2]=0;h=aD(g,36)|0;i=205792;j=h+36|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-2,g,205829,201015,1899);bD(g);break}default:{}}k=a+44|0;l=f[k>>2]|0;if(!c)m=0;else m=(b[c>>0]|0)==0?0:c;c=l&7;if(c>>>0>4)if((c|0)==6^(m|0)!=0){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,85)|0;i=205841;j=h+85|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-5,g,205829,201015,1916);bD(g);n=l}else n=l;else{f[a+12>>2]=0;n=m|0?38:37}l=(m|0)!=0;do if(l){c=kUb(m)|0;if(!c){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,19)|0;i=205927;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-5,g,205829,201015,1928);bD(g);o=0;break}if((c|0)>4096){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,19)|0;i=205947;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-5,g,205829,201015,1931);bD(g);o=c}else o=c}else o=0;while(0);p=(d|0)!=0;if(p)q=kUb(d)|0;else q=0;r=(n&8|0)==0;s=a+72|0;t=f[s>>2]|0;do if(r){v=a+76|0;w=f[v>>2]|0;x=a+56|0;y=f[x>>2]|0;if(t>>>0>(w+y|0)>>>0){b[t>>0]=10;b[t+1>>0]=0;vT(a,f[v>>2]|0);z=f[v>>2]|0;f[s>>2]=z;A=f[x>>2]|0;B=z}else{A=y;B=w}w=f[a+40>>2]|0;if((A|0)==(w|0)){C=B;D=A}else{Nac(B|0,32,w|0)|0;f[x>>2]=w;C=f[v>>2]|0;D=w}w=C+D|0;f[s>>2]=w;if((n&7|0)!=6){v=w+1|0;b[w>>0]=45;if(p){b[v>>0]=32;E=w+2|0}else E=v}else E=w}else{if(!(n&32)){b[t>>0]=44;F=t+1|0}else F=t;w=a+76|0;v=f[w>>2]|0;x=q+o-v+F|0;y=v;if((x|0)>(f[a+84>>2]|0)?(v=a+40|0,z=f[v>>2]|0,(x-z|0)>10):0){f[s>>2]=F;x=a+56|0;G=f[x>>2]|0;if(F>>>0>(y+G|0)>>>0){b[F>>0]=10;b[F+1>>0]=0;vT(a,f[w>>2]|0);H=f[w>>2]|0;f[s>>2]=H;I=f[x>>2]|0;J=f[v>>2]|0;K=H}else{I=G;J=z;K=y}if((I|0)==(J|0))L=K;else{Nac(K|0,32,J|0)|0;f[x>>2]=J;L=f[w>>2]|0}w=L+J|0;f[s>>2]=w;E=w;break}b[F>>0]=32;E=F+1|0}while(0);if(l){l=b[m>>0]|0;if(!(((l&-33)+-65&255)<26|l<<24>>24==95)){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,33)|0;i=205967;j=h+33|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-5,g,205829,201015,1966);bD(g)}l=a+80|0;F=f[l>>2]|0;if((E+o|0)>>>0<F>>>0)M=E;else{J=a+76|0;L=f[J>>2]|0;K=E-L|0;I=((F-L|0)*3|0)/2|0;L=K+o|0;F=(L|0)<(I|0)?I:L;L=VC(F+256|0)|0;I=f[J>>2]|0;f[s>>2]=L+((f[s>>2]|0)-I);if((K|0)>0)Vac(L|0,I|0,K|0)|0;f[J>>2]=L;f[l>>2]=L+F;M=L+K|0}if((o|0)>0){K=g+4|0;L=0;do{F=b[m+L>>0]|0;b[M+L>>0]=F;a:do if(!((F+-48&255)<10|((F&-33)+-65&255)<26)){switch(F<<24>>24){case 32:case 45:case 95:{break a;break}default:{}}f[g>>2]=0;f[K>>2]=0;h=aD(g,80)|0;i=206001;j=h+80|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-5,g,205829,201015,1976);bD(g)}while(0);L=L+1|0}while((L|0)<(o|0))}L=M+o|0;o=L+1|0;b[L>>0]=58;if(p&r){b[o>>0]=32;N=o+1|0}else N=o}else N=E;if(!p){O=N;f[s>>2]=O;P=n&-33;f[k>>2]=P;u=e;return}p=a+80|0;E=f[p>>2]|0;if((N+q|0)>>>0<E>>>0)Q=N;else{o=a+76|0;a=f[o>>2]|0;r=N-a|0;N=((E-a|0)*3|0)/2|0;a=r+q|0;E=(a|0)<(N|0)?N:a;a=VC(E+256|0)|0;N=f[o>>2]|0;f[s>>2]=a+((f[s>>2]|0)-N);if((r|0)>0)Vac(a|0,N|0,r|0)|0;f[o>>2]=a;f[p>>2]=a+E;Q=a+r|0}Vac(Q|0,d|0,q|0)|0;O=Q+q|0;f[s>>2]=O;P=n&-33;f[k>>2]=P;u=e;return}function UU(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=u;u=u+16|0;g=e;zT(a,0);switch(f[a+280>>2]|0){case 0:{AT(a,1);break}case 2:{f[g>>2]=0;f[g+4>>2]=0;h=aD(g,36)|0;i=205792;j=h+36|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-2,g,206101,201015,3855);bD(g);break}default:{}}do if((c|0)!=0?(b[c>>0]|0)!=0:0){k=kUb(c)|0;if(!k){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,19)|0;i=205927;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-5,g,206101,201015,3867);bD(g);l=0;m=c;n=1;break}if((k|0)>4096){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,19)|0;i=205947;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-5,g,206101,201015,3869);bD(g);l=k;m=c;n=1}else{l=k;m=c;n=1}}else{l=0;m=0;n=0}while(0);c=(d|0)!=0;if(c)o=kUb(d)|0;else o=0;p=a+44|0;q=f[p>>2]|0;r=q&7;if(r>>>0>4)if(n^(r|0)==6){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,85)|0;i=205841;j=h+85|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-5,g,206101,201015,3881);bD(g);s=q}else s=q;else{f[a+12>>2]=0;s=n?38:37}q=(s&32|0)!=0;r=a+72|0;t=f[r>>2]|0;do if(!(s&8)){if(q){v=a+76|0;w=v;x=f[v>>2]|0;y=t}else{b[t>>0]=44;b[t+1>>0]=10;b[t+2>>0]=0;v=a+76|0;vT(a,f[v>>2]|0);z=f[v>>2]|0;f[r>>2]=z;A=z;w=v;x=A;y=A}A=a+56|0;v=f[A>>2]|0;if(y>>>0>(x+v|0)>>>0){b[y>>0]=10;b[y+1>>0]=0;vT(a,f[w>>2]|0);z=f[w>>2]|0;f[r>>2]=z;B=f[A>>2]|0;C=z}else{B=v;C=x}v=f[a+40>>2]|0;if((B|0)==(v|0)){D=C;E=B}else{Nac(C|0,32,v|0)|0;f[A>>2]=v;D=f[w>>2]|0;E=v}v=D+E|0;f[r>>2]=v;F=v}else{if(q)G=t;else{b[t>>0]=44;G=t+1|0}v=a+76|0;A=f[v>>2]|0;z=o+l-A+G|0;H=A;if((z|0)>(f[a+84>>2]|0)?(A=a+40|0,I=f[A>>2]|0,(z-I|0)>10):0){f[r>>2]=G;z=a+56|0;J=f[z>>2]|0;if(G>>>0>(H+J|0)>>>0){b[G>>0]=10;b[G+1>>0]=0;vT(a,f[v>>2]|0);K=f[v>>2]|0;f[r>>2]=K;L=f[z>>2]|0;M=f[A>>2]|0;N=K}else{L=J;M=I;N=H}if((L|0)==(M|0))O=N;else{Nac(N|0,32,M|0)|0;f[z>>2]=M;O=f[v>>2]|0}v=O+M|0;f[r>>2]=v;F=v;break}b[G>>0]=32;F=G+1|0}while(0);if(n){n=b[m>>0]|0;if(!(((n&-33)+-65&255)<26|n<<24>>24==95)){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,33)|0;i=205967;j=h+33|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-5,g,206101,201015,3923);bD(g)}n=a+80|0;G=f[n>>2]|0;if((F+l|0)>>>0<G>>>0)P=F;else{r=a+76|0;M=f[r>>2]|0;O=F-M|0;N=((G-M|0)*3|0)/2|0;M=O+l|0;G=(M|0)<(N|0)?N:M;M=VC(G+256|0)|0;N=a+72|0;L=f[r>>2]|0;f[N>>2]=M+((f[N>>2]|0)-L);if((O|0)>0)Vac(M|0,L|0,O|0)|0;f[r>>2]=M;f[n>>2]=M+G;P=M+O|0}O=P+1|0;b[P>>0]=34;if(l|0){P=g+4|0;M=0;do{G=b[m+M>>0]|0;b[O+M>>0]=G;a:do if(!((G+-48&255)<10|((G&-33)+-65&255)<26)){switch(G<<24>>24){case 32:case 45:case 95:{break a;break}default:{}}f[g>>2]=0;f[P>>2]=0;h=aD(g,80)|0;i=206001;j=h+80|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-5,g,206101,201015,3934);bD(g)}while(0);M=M+1|0}while(M>>>0<l>>>0)}M=O+l|0;l=M+1|0;b[M>>0]=34;M=l+1|0;b[l>>0]=58;b[M>>0]=32;Q=M+1|0}else Q=F;if(!c){R=Q;S=a+72|0;f[S>>2]=R;T=s&-33;f[p>>2]=T;u=e;return}c=a+80|0;F=f[c>>2]|0;if((Q+o|0)>>>0<F>>>0)U=Q;else{M=a+76|0;l=f[M>>2]|0;O=Q-l|0;Q=((F-l|0)*3|0)/2|0;l=O+o|0;F=(l|0)<(Q|0)?Q:l;l=VC(F+256|0)|0;Q=a+72|0;g=f[M>>2]|0;f[Q>>2]=l+((f[Q>>2]|0)-g);if((O|0)>0)Vac(l|0,g|0,O|0)|0;f[M>>2]=l;f[c>>2]=l+F;U=l+O|0}Vac(U|0,d|0,o|0)|0;R=U+o|0;S=a+72|0;f[S>>2]=R;T=s&-33;f[p>>2]=T;u=e;return}function VU(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+16|0;h=g;zT(a,0);switch(f[a+280>>2]|0){case 0:{AT(a,1);break}case 2:{f[h>>2]=0;f[h+4>>2]=0;i=aD(h,38)|0;j=206139;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-2,h,206178,201015,3060);bD(h);break}default:{}}l=a+44|0;m=f[l>>2]&7;if((m|0)!=6?(n=(c|0)!=0,!(n&m>>>0<5)):0){m=a+72|0;o=f[m>>2]|0;p=a+76|0;q=o-(f[p>>2]|0)+e|0;if(n){f[h>>2]=0;f[h+4>>2]=0;i=aD(h,49)|0;j=206196;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-5,h,206178,201015,3078);bD(h)}f[l>>2]=5;if((q|0)>(f[a+84>>2]|0)?(q-(f[a+40>>2]|0)|0)>10:0){r=f[p>>2]|0;s=18}else s=16;do if((s|0)==16){q=f[p>>2]|0;if(o>>>0>q>>>0?(b[o+-1>>0]|0)==62:0){r=q;s=18;break}if(o>>>0>(q+(f[a+40>>2]|0)|0)>>>0?(b[o+-1>>0]|0)!=62:0){b[o>>0]=32;t=o+1|0}else t=o}while(0);if((s|0)==18){s=f[m>>2]|0;o=a+56|0;q=f[o>>2]|0;if(s>>>0>(r+q|0)>>>0){b[s>>0]=10;b[s+1>>0]=0;vT(a,f[p>>2]|0);s=f[p>>2]|0;f[m>>2]=s;v=f[o>>2]|0;w=s}else{v=q;w=r}r=f[a+40>>2]|0;if((v|0)==(r|0)){x=w;y=v}else{Nac(w|0,32,r|0)|0;f[o>>2]=r;x=f[p>>2]|0;y=r}r=x+y|0;f[m>>2]=r;t=r}Vac(t|0,d|0,e|0)|0;f[m>>2]=t+e;u=g;return}WU(a,c,1,0,0);t=a+72|0;m=f[t>>2]|0;r=a+80|0;y=f[r>>2]|0;if((m+e|0)>>>0<y>>>0)z=m;else{x=a+76|0;p=f[x>>2]|0;o=m-p|0;m=((y-p|0)*3|0)/2|0;p=o+e|0;y=(p|0)<(m|0)?m:p;p=VC(y+256|0)|0;m=f[x>>2]|0;f[t>>2]=p+((f[t>>2]|0)-m);if((o|0)>0)Vac(p|0,m|0,o|0)|0;f[x>>2]=p;f[r>>2]=p+y;z=p+o|0}Vac(z|0,d|0,e|0)|0;f[t>>2]=z+e;WU(a,c,2,0,0);u=g;return}function WU(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;h=u;u=u+16|0;i=e;j=g;g=h;k=a+72|0;l=f[k>>2]|0;m=a+44|0;n=f[m>>2]|0;if(!c)o=0;else o=(b[c>>0]|0)==0?0:c;c=(d|0)==3;if((d|2|0)==3){p=n&7;if(p>>>0>4)if((p|0)==6^(o|0)!=0){f[g>>2]=0;f[g+4>>2]=0;q=aD(g,85)|0;r=205841;s=q+85|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-5,g,206246,201015,2892);bD(g);t=n}else t=n;else{f[a+12>>2]=0;t=o|0?38:37}if(!(t&32)){p=f[k>>2]|0;v=a+76|0;w=f[v>>2]|0;x=a+56|0;y=f[x>>2]|0;if(p>>>0>(w+y|0)>>>0){b[p>>0]=10;b[p+1>>0]=0;vT(a,f[v>>2]|0);p=f[v>>2]|0;f[k>>2]=p;z=f[x>>2]|0;A=p}else{z=y;A=w}w=f[a+40>>2]|0;if((z|0)==(w|0)){B=A;C=z}else{Nac(A|0,32,w|0)|0;f[x>>2]=w;B=f[v>>2]|0;C=w}w=B+C|0;f[k>>2]=w;D=w;E=t}else{D=l;E=t}}else{D=l;E=n}if(o)if((b[o>>0]|0)==95?(b[o+1>>0]|0)==0:0){f[g>>2]=0;f[g+4>>2]=0;q=aD(g,33)|0;r=206261;s=q+33|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-5,g,206246,201015,2907);bD(g);F=o}else F=o;else F=206295;o=kUb(F)|0;n=D+1|0;b[D>>0]=60;if((d|0)==2){if(e|0){f[g>>2]=0;f[g+4>>2]=0;q=aD(g,45)|0;r=206297;s=q+45|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-5,g,206246,201015,2914);bD(g)}b[n>>0]=47;G=D+2|0}else G=n;n=b[F>>0]|0;if(!(((n&-33)+-65&255)<26|n<<24>>24==95)){f[g>>2]=0;f[g+4>>2]=0;q=aD(g,35)|0;r=206343;s=q+35|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-5,g,206246,201015,2919);bD(g)}n=a+80|0;D=f[n>>2]|0;if((G+o|0)>>>0<D>>>0)H=G;else{e=a+76|0;d=f[e>>2]|0;l=G-d|0;G=((D-d|0)*3|0)/2|0;d=l+o|0;D=(d|0)<(G|0)?G:d;d=VC(D+256|0)|0;G=f[e>>2]|0;f[k>>2]=d+((f[k>>2]|0)-G);if((l|0)>0)Vac(d|0,G|0,l|0)|0;f[e>>2]=d;f[n>>2]=d+D;H=d+l|0}if((o|0)>0){l=g+4|0;d=0;do{D=b[F+d>>0]|0;a:do if(!((D+-48&255)<10|((D&-33)+-65&255)<26)){switch(D<<24>>24){case 45:case 95:{break a;break}default:{}}f[g>>2]=0;f[l>>2]=0;q=aD(g,74)|0;r=206379;s=q+74|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-5,g,206246,201015,2926);bD(g)}while(0);b[H+d>>0]=D;d=d+1|0}while((d|0)<(o|0))}d=a+76|0;a=H+o|0;o=i;i=j;while(1){if((o|0)!=0?(j=o,H=f[j>>2]|0,(H|0)!=0):0){g=j;j=a;r=H;while(1){H=kUb(r)|0;q=g+4|0;s=kUb(f[q>>2]|0)|0;l=H+4+s|0;F=f[n>>2]|0;if((j+l|0)>>>0<F>>>0)I=j;else{e=f[d>>2]|0;G=j-e|0;t=((F-e|0)*3|0)/2|0;e=G+l|0;l=(e|0)<(t|0)?t:e;e=VC(l+256|0)|0;t=f[d>>2]|0;f[k>>2]=e+((f[k>>2]|0)-t);if((G|0)>0)Vac(e|0,t|0,G|0)|0;f[d>>2]=e;f[n>>2]=e+l;I=e+G|0}G=I+1|0;b[I>>0]=32;Vac(G|0,f[g>>2]|0,H|0)|0;e=G+H|0;H=e+1|0;b[e>>0]=61;e=H+1|0;b[H>>0]=34;Vac(e|0,f[q>>2]|0,s|0)|0;q=e+s|0;s=q+1|0;b[q>>0]=34;g=g+8|0;r=f[g>>2]|0;if(!r){J=s;break}else j=s}}else J=a;if(!i)break;a=J;o=f[i>>2]|0;i=f[i+4>>2]|0}if(!c){K=J;L=K+1|0;b[K>>0]=62;f[k>>2]=L;M=E&-33;f[m>>2]=M;u=h;return}b[J>>0]=47;K=J+1|0;L=K+1|0;b[K>>0]=62;f[k>>2]=L;M=E&-33;f[m>>2]=M;u=h;return}function XU(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+8|0;g=d;p[s>>3]=c;h=f[s+4>>2]|0;if((h&2146435072|0)==2146435072)if(((h&2147483647)+((f[s>>2]|0)!=0&1)|0)>>>0>2146435072){b[a>>0]=b[206464]|0;b[a+1>>0]=b[206465]|0;b[a+2>>0]=b[206466]|0;b[a+3>>0]=b[206467]|0;b[a+4>>0]=b[206468]|0;u=d;return a|0}else{KUb(a,(h|0)<0?206469:206475)|0;u=d;return a|0}h=MVb(c)|0;if(+(h|0)==c){f[g>>2]=h;_Ub(a,206454,g)|0;u=d;return a|0}p[e>>3]=c;_Ub(a,206458,e)|0;switch(b[a>>0]|0){case 45:case 43:{i=a+1|0;break}default:i=a}while(1){j=b[i>>0]|0;if((j+-48&255)<10)i=i+1|0;else break}if(j<<24>>24!=44){u=d;return a|0}b[i>>0]=46;u=d;return a|0}function YU(){var a=0,b=0;a=u;u=u+48|0;b=a;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=206968;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=701;f[b+24>>2]=1466;f[b+36>>2]=702;f[b+28>>2]=544;f[b+32>>2]=272;cV(b);f[125815]=f[125813];zd(1467,503260,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=206984;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=701;f[b+24>>2]=1466;f[b+36>>2]=702;f[b+28>>2]=545;f[b+32>>2]=272;cV(b);f[125816]=f[125813];zd(1467,503264,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=207005;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=703;f[b+24>>2]=1468;f[b+36>>2]=704;f[b+28>>2]=546;f[b+32>>2]=273;cV(b);f[125817]=f[125813];zd(1467,503268,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=207018;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=705;f[b+24>>2]=1469;f[b+36>>2]=706;f[b+28>>2]=547;f[b+32>>2]=274;cV(b);f[125818]=f[125813];zd(1467,503272,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=207039;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=707;f[b+24>>2]=1470;f[b+36>>2]=708;f[b+28>>2]=548;f[b+32>>2]=275;cV(b);f[125819]=f[125813];zd(1467,503276,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=207052;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=709;f[b+24>>2]=1471;f[b+36>>2]=710;f[b+28>>2]=549;f[b+32>>2]=276;cV(b);f[125820]=f[125813];zd(1467,503280,x|0)|0;f[b>>2]=0;f[b+4>>2]=40;f[b+16>>2]=207066;f[b+12>>2]=0;f[b+8>>2]=0;f[b+20>>2]=711;f[b+24>>2]=1472;f[b+36>>2]=712;f[b+28>>2]=550;f[b+32>>2]=277;cV(b);f[125821]=f[125813];zd(1467,503284,x|0)|0;u=a;return}function ZU(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-65536|0)==1117323264;return b&1|0}function _U(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if(a|0){f[a>>2]=0;u=c;return}f[d>>2]=0;f[d+4>>2]=0;e=aD(d,19)|0;g=209479;h=e+19|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-27,d,210226,201015,5729);bD(d);f[a>>2]=0;u=c;return}function $U(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b+8|0;d=b;e=d;f[e>>2]=0;f[e+4>>2]=0;f[d+4>>2]=1073741823;f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];d=$W(a,c,0,1)|0;u=b;return d|0}function aV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+1072|0;e=d+552|0;g=d+520|0;h=d+8|0;i=d;f[i>>2]=0;j=MV(a,c,208791)|0;if((j|0)!=0?(f[j>>2]&7|0)==3:0)k=f[j+8+4>>2]|0;else k=0;j=MV(a,c,210011)|0;a:do if(!j)l=-1;else switch(f[j>>2]&7){case 1:{l=f[j+8>>2]|0;break a;break}case 2:{l=MVb(+p[j+8>>3])|0;break a;break}default:{l=2147483647;break a}}while(0);j=MV(a,c,207096)|0;if((j|0)!=0?(f[j>>2]&7|0)==3:0){m=f[j+8+4>>2]|0;if((k|0)!=0&(l|0)!=-1&(m|0)!=0)n=m;else{o=m;q=11}}else{o=0;q=11}if((q|0)==11){f[e>>2]=0;f[e+4>>2]=0;r=aD(e,48)|0;s=210017;t=r+48|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-2,e,210066,201015,5953);bD(e);n=o}if(((b[k>>0]|0)+-48&255)>=10){o=(bWb(k,210077)|0)==0;m=o?1117323264:1117327360;o=(bWb(k,210083)|0)==0;j=o?m:m|16384;m=(bWb(k,210090)|0)==0;o=m?j:j|32768;if(!(bWb(k,210095)|0))v=OV(n)|0|o;else v=o}else{o=WVb(k,i,16)|0;if(!((o&-65536|0)==1117323264?(f[i>>2]|0)!=(k|0):0)){f[e>>2]=0;f[e+4>>2]=0;r=aD(e,30)|0;s=209208;t=r+30|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-2,e,210066,201015,5970);bD(e)}v=o&33279|o<<2&16384|((o&3584|0)==512?1117327360:1117323264)}o=MV(a,c,208860)|0;if((o|0)!=0?(f[o>>2]&7|0)==3:0)w=f[o+8+4>>2]|0;else w=0;o=MV(a,c,208978)|0;k=(w|0)!=0;i=(o|0)!=0;j=i&1;if(k^i){f[e>>2]=0;f[e+4>>2]=0;r=aD(e,74)|0;s=209239;t=r+74|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-2,e,210066,201015,6004);bD(e)}m=MV(a,c,351948)|0;x=MV(a,c,208502)|0;y=(m|0)!=0;z=(x|0)!=0;if(((y&1)+j+(z&1)|0)>>>0>1){f[e>>2]=0;f[e+4>>2]=0;r=aD(e,66)|0;s=210103;t=r+66|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-2,e,210066,201015,6010);bD(e)}if(k){j=KU(w,e)|0;A=j<<1;if((j|0)>0){j=56;B=0;while(1){C=f[e+((B|1)<<2)>>2]|0;D=(C>>>3&511)+1<<(47696>>>(C<<1&14)&3);C=(j+-1+D&0-D)+(Y(D,f[e+(B<<2)>>2]|0)|0)|0;B=B+2|0;if((B|0)>=(A|0)){E=C;break}else j=C}}else E=56;F=E;G=e;H=e}else{F=y?88:z?64:56;G=e;H=e}H=KU(n,G)|0;G=H<<1;if((H|0)>0){H=0;E=0;while(1){j=f[e+((E|1)<<2)>>2]|0;A=(j>>>3&511)+1<<(47696>>>(j<<1&14)&3);j=(H+-1+A&0-A)+(Y(A,f[e+(E<<2)>>2]|0)|0)|0;E=E+2|0;if((E|0)>=(G|0)){I=j;break}else H=j}}else I=0;H=f[e+4>>2]|0;G=(H>>>3&511)+1<<(47696>>>(H<<1&14)&3);H=IW(v,F,I+-1+G&0-G,f[a+20>>2]|0)|0;do if(i){if(!k){f[e>>2]=0;f[e+4>>2]=0;r=aD(e,9)|0;s=208860;t=r+9|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,e,210066,201015,6026);bD(e)}NV(a,o,H+56|0,w)}else{if(!y){if(!z)break;G=MV(a,x,422891)|0;b:do if(!G)J=0;else switch(f[G>>2]&7){case 1:{J=f[G+8>>2]|0;break b;break}case 2:{J=MVb(+p[G+8>>3])|0;break b;break}default:{J=2147483647;break b}}while(0);f[H+56>>2]=J;G=MV(a,x,208539)|0;c:do if(!G)K=0;else switch(f[G>>2]&7){case 1:{K=f[G+8>>2]|0;break c;break}case 2:{K=MVb(+p[G+8>>3])|0;break c;break}default:{K=2147483647;break c}}while(0);f[H+60>>2]=K;break}G=MV(a,m,422891)|0;d:do if(!G)L=0;else switch(f[G>>2]&7){case 1:{L=f[G+8>>2]|0;break d;break}case 2:{L=MVb(+p[G+8>>3])|0;break d;break}default:{L=2147483647;break d}}while(0);f[H+56>>2]=L;G=MV(a,m,208539)|0;e:do if(!G)M=0;else switch(f[G>>2]&7){case 1:{M=f[G+8>>2]|0;break e;break}case 2:{M=MVb(+p[G+8>>3])|0;break e;break}default:{M=2147483647;break e}}while(0);f[H+60>>2]=M;G=MV(a,m,434730)|0;f:do if(!G)N=0;else switch(f[G>>2]&7){case 1:{N=f[G+8>>2]|0;break f;break}case 2:{N=MVb(+p[G+8>>3])|0;break f;break}default:{N=2147483647;break f}}while(0);f[H+64>>2]=N;G=MV(a,m,434884)|0;g:do if(!G)O=0;else switch(f[G>>2]&7){case 1:{O=f[G+8>>2]|0;break g;break}case 2:{O=MVb(+p[G+8>>3])|0;break g;break}default:{O=2147483647;break g}}while(0);f[H+68>>2]=O;G=MV(a,c,208964)|0;h:do if(!G)P=0;else switch(f[G>>2]&7){case 1:{P=f[G+8>>2]|0;break h;break}case 2:{P=MVb(+p[G+8>>3])|0;break h;break}default:{P=2147483647;break h}}while(0);f[H+72>>2]=P}while(0);ZW(H,0,l,0);P=KU(n,h)|0;O=P<<1;if((P|0)>0){P=0;m=0;while(1){N=(f[h+(P<<2)>>2]|0)+m|0;P=P+2|0;if((P|0)>=(O|0)){Q=N;break}else m=N}}else Q=0;m=MV(a,c,377867)|0;if(!m){f[e>>2]=0;f[e+4>>2]=0;r=aD(e,43)|0;s=208640;t=r+43|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-2,e,210066,201015,6053);bD(e)}c=f[m>>2]&7;if(c>>>0>4)R=f[(f[m+8>>2]|0)+24>>2]|0;else R=(c|0)!=0&1;if((R|0)!=(Y(Q,l)|0)){f[e>>2]=0;f[e+4>>2]=0;r=aD(e,55)|0;s=210170;t=r+55|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-2,e,210066,201015,6056);bD(e)}PV(a,m,g);m=H+52|0;e=f[m>>2]|0;if(!e){u=d;return H|0}else S=e;while(1){e=Y(f[S+12>>2]|0,Q)|0;QV(a,g,e,f[S+16>>2]|0,n);if((S|0)==(f[f[m>>2]>>2]|0)){q=80;break}S=f[S+4>>2]|0;if(!S){q=80;break}}if((q|0)==80){u=d;return H|0}return 0}function bV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e+24|0;j=e;k=d;a:do{l=f[k>>2]|0;if(!l)break;m=f[l>>2]|0;if(m|0){n=0;o=m;p=0;while(1){n=n+1|0;if(!(gTb(209971,o)|0)){q=7;break a}m=n<<1;o=f[l+(m<<2)>>2]|0;if(!o)break;else p=m}}k=f[k+4>>2]|0}while((k|0)!=0);if((((((q|0)==7?(q=f[l+((p|1)<<2)>>2]|0,q|0):0)?gTb(q,209981)|0:0)?gTb(q,490303)|0:0)?gTb(q,476467)|0:0)?gTb(q,209983)|0:0){f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];xV(a,b,6,206984,g);f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];xV(a,209515,5,0,g);kX(h,c,2147483647);g=f[h>>2]|0;if(g|0){j=f[d>>2]|0;i=d+4|0;q=h+4|0;p=g;do{WV(a,0,p,j,f[i>>2]|0,f[q>>2]|0);lX(h)|0;p=f[h>>2]|0}while((p|0)!=0)}uT(a);uT(a);u=e;return}WV(a,b,c,f[d>>2]|0,f[d+4>>2]|0,-1);u=e;return}function cV(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0?(f[a+4>>2]|0)==40:0)){f[d>>2]=0;f[d+4>>2]=0;e=aD(d,17)|0;g=209759;h=e+17|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-201,d,209777,201015,6559);bD(d)}if(!((((f[a+20>>2]|0)!=0?(f[a+24>>2]|0)!=0:0)?(f[a+28>>2]|0)!=0:0)?(f[a+32>>2]|0)!=0:0)){f[d>>2]=0;f[d+4>>2]=0;e=aD(d,81)|0;g=209792;h=e+81|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-27,d,209777,201015,6565);bD(d)}i=a+16|0;j=f[i>>2]|0;k=b[j>>0]|0;if(k<<24>>24==95|((k&-33)+-65&255)<26)l=j;else{f[d>>2]=0;f[d+4>>2]=0;e=aD(d,41)|0;g=209874;h=e+41|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-5,d,209777,201015,6569);bD(d);l=f[i>>2]|0}j=kUb(l)|0;a:do if((j|0)>0){k=d+4|0;m=0;n=l;while(1){o=b[n+m>>0]|0;b:do if(!((o+-48&255)<10|((o&-33)+-65&255)<26)){switch(o<<24>>24){case 45:case 95:{break b;break}default:{}}f[d>>2]=0;f[k>>2]=0;e=aD(d,54)|0;g=209916;h=e+54|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-5,d,209777,201015,6578);bD(d)}while(0);o=m+1|0;if((o|0)>=(j|0))break a;m=o;n=f[i>>2]|0}}while(0);d=VC(j+41|0)|0;e=d;g=a;h=e+40|0;do{f[e>>2]=f[g>>2];e=e+4|0;g=g+4|0}while((e|0)<(h|0));g=d+40|0;f[d+16>>2]=g;Vac(g|0,f[i>>2]|0,j+1|0)|0;f[d>>2]=0;j=f[125813]|0;f[d+12>>2]=j;f[d+8>>2]=0;f[(j|0?j+8|0:503256)>>2]=d;f[125813]=d;u=c;return}function dV(a){a=a|0;var b=0,c=0,d=0;b=f[(f[a>>2]|0)+16>>2]|0;if(!b)return;a=f[125813]|0;if(!a)return;else c=a;while(1){if(!(gTb(f[c+16>>2]|0,b)|0))break;a=f[c+12>>2]|0;if(!a){d=8;break}else c=a}if((d|0)==8)return;d=c+8|0;b=f[d>>2]|0;a=c+12|0;f[((b|0)==0?503252:b+12|0)>>2]=f[a>>2];b=f[a>>2]|0;f[((b|0)==0?503256:b+8|0)>>2]=f[d>>2];if(!((f[125813]|0)!=0&(f[125814]|0)!=0)){f[125814]=0;f[125813]=0}WC(c);return}function eV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+8|0;g=d;h=MV(a,c,209515)|0;if(!((h|0)!=0?(f[h>>2]&7|0)==5:0)){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,90)|0;j=209525;k=i+90|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-212,g,209616,201015,6087);bD(g)}c=f[h+8>>2]|0;h=f[c+24>>2]|0;MW(c,e,0);if((h|0)<=0){l=0;u=d;return l|0}m=e+12|0;n=g+4|0;o=g+4|0;q=c+28|0;c=e+20|0;r=0;s=0;t=0;v=0;w=0;x=0;while(1){y=f[m>>2]|0;z=v;v=VV(a,y,0)|0;if(!v){f[g>>2]=0;f[n>>2]=0;A=aD(g,3)|0;b[A>>0]=b[204121]|0;b[A+1>>0]=b[204122]|0;b[A+2>>0]=b[204123]|0;bO(-215,g,209616,201015,6099);bD(g)}A=MV(a,y,209631)|0;a:do if(A){switch(f[A>>2]&7){case 1:{B=f[A+8>>2]|0;break}case 2:{B=MVb(+p[A+8>>3])|0;break}default:{C=2147483647;break a}}if((B|0)<0){D=B;E=13}else C=B}else{D=-1;E=13}while(0);if((E|0)==13){E=0;f[g>>2]=0;f[o>>2]=0;i=aD(g,56)|0;j=209637;k=i+56|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-212,g,209616,201015,6102);bD(g);C=D}A=(r|0)==0;y=A?v:x;r=A?v:r;if((C|0)<=(t|0)){if((C|0)<(t|0)){A=t;F=z;while(1){G=f[F+16>>2]|0;if((A|0)>(C|0)){A=A+-1|0;F=G}else{H=G;I=F;break}}}else{H=s;I=z}f[v+8>>2]=I;if(!I)J=H;else{f[I+12>>2]=v;J=H}}else{if(z|0)f[z+20>>2]=v;f[v+8>>2]=0;J=z}f[v+16>>2]=J;F=(f[m>>2]|0)+(f[q>>2]|0)|0;f[m>>2]=F;if(F>>>0>=(f[c>>2]|0)>>>0)VW(e,1);w=w+1|0;if((w|0)>=(h|0)){l=y;break}else{s=J;t=C;x=y}}u=d;return l|0}function fV(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-53248|0)==1117261824;return b&1|0}function gV(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if(a|0){f[a>>2]=0;u=c;return}f[d>>2]=0;f[d+4>>2]=0;e=aD(d,19)|0;g=209479;h=e+19|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-27,d,209499,201015,6145);bD(d);f[a>>2]=0;u=c;return}function hV(a){a=a|0;return iX(a,0)|0}function iV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;d=u;u=u+1184|0;e=d;g=d+664|0;h=d+152|0;i=d+144|0;j=d+16|0;k=d+8|0;f[i>>2]=0;l=MV(a,c,208791)|0;if((l|0)!=0?(f[l>>2]&7|0)==3:0)m=f[l+8+4>>2]|0;else m=0;l=MV(a,c,208810)|0;if((l|0)!=0?(f[l>>2]&7|0)==3:0)n=f[l+8+4>>2]|0;else n=0;l=MV(a,c,208831)|0;if((l|0)!=0?(f[l>>2]&7|0)==3:0)o=f[l+8+4>>2]|0;else o=0;l=MV(a,c,208797)|0;a:do if(!l)q=-1;else switch(f[l>>2]&7){case 1:{q=f[l+8>>2]|0;break a;break}case 2:{q=MVb(+p[l+8>>3])|0;break a;break}default:{q=2147483647;break a}}while(0);l=MV(a,c,208820)|0;b:do if(!l)r=-1;else switch(f[l>>2]&7){case 1:{r=f[l+8>>2]|0;break b;break}case 2:{r=MVb(+p[l+8>>3])|0;break b;break}default:{r=2147483647;break b}}while(0);if(!((o|0)!=0&(((m|0)==0|(q|0)==-1|(r|0)==-1)^1))){f[g>>2]=0;f[g+4>>2]=0;s=aD(g,45)|0;t=209149;v=s+45|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-2,g,209195,201015,6324);bD(g)}if(!(wVb(b[m>>0]|0)|0))w=(bWb(m,208782)|0)==0;else{l=WVb(m,i,16)|0;if(!((l&-65536|0)==1117257728?(f[i>>2]|0)!=(m|0):0)){f[g>>2]=0;f[g+4>>2]=0;s=aD(g,30)|0;t=209208;v=s+30|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-2,g,209195,201015,6337);bD(g)}w=(l&4096|0)==0}l=w?1117261824:1117278208;w=MV(a,c,208860)|0;if((w|0)!=0?(f[w>>2]&7|0)==3:0)x=f[w+8+4>>2]|0;else x=0;w=MV(a,c,208978)|0;m=(x|0)!=0;y=(w|0)!=0;if(m^y){f[g>>2]=0;f[g+4>>2]=0;s=aD(g,74)|0;t=209239;v=s+74|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-2,g,209195,201015,6352);bD(g)}if(m){z=KU(x,g)|0;A=z<<1;if((z|0)>0){z=68;B=0;while(1){C=f[g+((B|1)<<2)>>2]|0;D=(C>>>3&511)+1<<(47696>>>(C<<1&14)&3);C=(z+-1+D&0-D)+(Y(D,f[g+(B<<2)>>2]|0)|0)|0;B=B+2|0;if((B|0)>=(A|0)){E=C;break}else z=C}}else E=68;F=E}else F=68;E=(n|0)==0;if(!E){z=KU(n,g)|0;A=z<<1;if((z|0)>0){z=0;B=0;while(1){C=f[g+((B|1)<<2)>>2]|0;D=(C>>>3&511)+1<<(47696>>>(C<<1&14)&3);C=(z+-1+D&0-D)+(Y(D,f[g+(B<<2)>>2]|0)|0)|0;B=B+2|0;if((B|0)>=(A|0)){G=C;break}else z=C}}else G=0;z=f[g+4>>2]|0;A=(z>>>3&511)+1<<(47696>>>(z<<1&14)&3);z=G+-1+A&0-A;A=KU(n,g)|0;G=A<<1;if((A|0)>0){A=8;B=0;while(1){C=f[g+((B|1)<<2)>>2]|0;D=(C>>>3&511)+1<<(47696>>>(C<<1&14)&3);C=(A+-1+D&0-D)+(Y(D,f[g+(B<<2)>>2]|0)|0)|0;B=B+2|0;if((B|0)>=(G|0)){H=C;break}else A=C}}else H=8;A=KU(o,h)|0;G=A<<1;if((A|0)>0){A=0;B=0;while(1){C=(f[h+(B<<2)>>2]|0)+A|0;B=B+2|0;if((B|0)>=(G|0)){I=H;J=z;K=C;L=h;break}else A=C}}else{I=H;J=z;K=0;L=h}}else{I=8;J=0;K=0;L=h}z=KU(o,L)|0;H=f[L>>2]|0;if(!((((z|0)>1&(H|0)==2?(f[h+4>>2]|0)==4:0)?(f[h+8>>2]|0)>=1:0)?(f[h+12>>2]|0)==5:0)){f[g>>2]=0;f[g+4>>2]=0;s=aD(g,52)|0;t=209314;v=s+52|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-5,g,209195,201015,6378);bD(g)}if((z|0)<=2)if((z|0)>0){M=4;N=50}else{O=0;P=4}else{L=f[h+20>>2]|0;M=((L>>>3&511)+1<<(47696>>>(L<<1&14)&3)|0)>7?8:4;N=50}if((N|0)==50){L=z<<1;if((L|0)>2){z=2;A=H;while(1){G=(f[h+(z<<2)>>2]|0)+A|0;z=z+2|0;if((z|0)>=(L|0)){O=G;P=M;break}else A=G}}else{O=H;P=M}}M=o+2|0;H=b[M>>0]|0;switch(H<<24>>24){case 102:{N=54;break}case 49:{if((b[o+3>>0]|0)==102)N=54;else N=55;break}default:N=55}if((N|0)==54)Q=o+3+((H+-48&255)<10&1)|0;else if((N|0)==55){N=(WVb(M,i,10)|0)+-1|0;M=f[i>>2]|0;f[e>>2]=N;f[e+4>>2]=M;_Ub(j,209367,e)|0;Q=j}e=KU(Q,g)|0;Q=e<<1;if((e|0)>0){e=24;M=0;while(1){N=f[g+((M|1)<<2)>>2]|0;i=(N>>>3&511)+1<<(47696>>>(N<<1&14)&3);N=(e+-1+i&0-i)+(Y(i,f[g+(M<<2)>>2]|0)|0)|0;M=M+2|0;if((M|0)>=(Q|0)){R=N;break}else e=N}}else R=24;e=KU(o,g)|0;Q=e<<1;if((e|0)>0){e=0;M=0;do{N=f[g+((M|1)<<2)>>2]|0;i=(N>>>3&511)+1<<(47696>>>(N<<1&14)&3);e=(e+-1+i&0-i)+(Y(i,f[g+(M<<2)>>2]|0)|0)|0;M=M+2|0}while((M|0)<(Q|0));S=e+-1|0}else S=-1;e=f[g+4>>2]|0;Q=(e>>>3&511)+1<<(47696>>>(e<<1&14)&3);e=S+Q&0-Q;Q=eX(l,F,I,R,f[a+20>>2]|0)|0;if(y){if(!m){f[g>>2]=0;f[g+4>>2]=0;s=aD(g,9)|0;t=208860;v=s+9|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,g,209195,201015,6405);bD(g)}NV(a,w,Q+68|0,x)}x=J*3|0;w=(x|0)>65536?x:65536;x=e*3|0;m=(x|0)<(w|0)?w:x;x=VC(m)|0;w=VC(q<<2)|0;y=MV(a,c,208845)|0;F=MV(a,c,208854)|0;if(!F){f[g>>2]=0;f[g+4>>2]=0;s=aD(g,13)|0;t=209373;v=s+13|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-5,g,209195,201015,6417);bD(g)}if(!(E|(y|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;s=aD(g,16)|0;t=209387;v=s+16|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-5,g,209195,201015,6419);bD(g)}E=k+4|0;c=P+-1|0;l=0-P|0;P=k+4|0;S=0;do{M=(S|0)==0;i=M?n:o;N=M?I:R;H=M?J:e;A=M?K:O;L=M?q:r;z=(m>>>0)/(((H|0)>1?H:1)>>>0)|0;h=(i|0)!=0;if(h)PV(a,M?y:F,g);c:do if((L|0)>0){G=(N|0)>24;B=N+-24|0;if(h){T=0;U=x;V=0}else{C=x;D=0;while(1){if(!M){f[j>>2]=0;W=f[C>>2]|0;X=f[C+4>>2]|0;if(!(W>>>0<q>>>0&X>>>0<q>>>0)){f[k>>2]=0;f[P>>2]=0;s=aD(k,46)|0;t=209404;v=s+46|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-211,k,209195,201015,6464);bD(k)}if(!(hX(Q,f[w+(W<<2)>>2]|0,f[w+(X<<2)>>2]|0,0,j)|0)){f[k>>2]=0;f[E>>2]=0;s=aD(k,27)|0;t=209451;v=s+27|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-5,k,209195,201015,6470);bD(k)}X=f[j>>2]|0;f[X+4>>2]=f[C+8>>2];if(G)Vac(X+24|0,c+(C+12)&l|0,B|0)|0}else{fX(Q,0,j)|0;f[w+(D<<2)>>2]=f[j>>2]}D=D+1|0;if((L|0)<=(D|0))break c;else C=C+H|0}}while(1){C=L-V|0;D=Y((C|0)>(z|0)?z:C,A)|0;if(!T){QV(a,g,D,x,i);Z=D;_=x}else{Z=T;_=U}if(!M){f[j>>2]=0;D=f[_>>2]|0;C=f[_+4>>2]|0;if(!(D>>>0<q>>>0&C>>>0<q>>>0)){f[k>>2]=0;f[P>>2]=0;s=aD(k,46)|0;t=209404;v=s+46|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-211,k,209195,201015,6464);bD(k)}if(!(hX(Q,f[w+(D<<2)>>2]|0,f[w+(C<<2)>>2]|0,0,j)|0)){f[k>>2]=0;f[E>>2]=0;s=aD(k,27)|0;t=209451;v=s+27|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-5,k,209195,201015,6470);bD(k)}C=f[j>>2]|0;f[C+4>>2]=f[_+8>>2];if(G)Vac(C+24|0,c+(_+12)&l|0,B|0)|0}else{fX(Q,0,j)|0;f[w+(V<<2)>>2]=f[j>>2];Vac((f[j>>2]|0)+8|0,_|0,H|0)|0}V=V+1|0;if((L|0)<=(V|0))break;else{T=Z+-1|0;U=_+H|0}}}while(0);S=S+1|0}while((S|0)<2);WC(x);WC(w);u=d;return Q|0}function jV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;e=u;u=u+960|0;g=e+56|0;h=e;i=e+24|0;j=e+824|0;k=e+696|0;l=e+568|0;m=e+16|0;n=e+8|0;o=f[c+60>>2]|0;p=c+64|0;q=f[(f[p>>2]|0)+60>>2]|0;r=VC(o<<2)|0;MW(c,i,0);s=c+24|0;if((f[s>>2]|0)>0){t=i+12|0;v=c+28|0;w=i+20|0;x=0;y=0;while(1){z=f[t>>2]|0;A=f[z>>2]|0;if((A|0)>-1){f[r+(x<<2)>>2]=A;f[z>>2]=x;B=x+1|0}else B=x;A=z+(f[v>>2]|0)|0;f[t>>2]=A;if(A>>>0>=(f[w>>2]|0)>>>0)VW(i,1);y=y+1|0;if((y|0)>=(f[s>>2]|0))break;else x=B}}f[m>>2]=0;f[m+4>>2]=0;f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];xV(a,b,6,207005,g);zV(a,208791,f[c>>2]&16384|0?208782:1124530,1);RV(a,208797,o);o=TV(c,208810,d,8,k)|0;if(o|0)zV(a,208810,o,0);RV(a,208820,q);q=TV(f[p>>2]|0,208831,d,24,j)|0;f[h>>2]=q|0?q:1124530;_Ub(l,208839,h)|0;zV(a,208831,l,0);UV(a,c,d,68);d=c+28|0;h=(f[d>>2]|0)*3|0;q=(h|0)>65536?h:65536;h=(f[(f[p>>2]|0)+28>>2]|0)*3|0;j=(h|0)<(q|0)?q:h;h=VC(j)|0;q=g+4|0;k=g+20|0;b=n+4|0;m=i+12|0;B=i+20|0;x=0;do{y=(x|0)==0;w=y?o:l;if(w|0){if(y)C=c;else C=f[p>>2]|0;t=C+28|0;v=f[t>>2]|0;A=KU(w,g)|0;z=A<<1;if((A|0)>0){A=0;D=0;while(1){E=f[g+((D|1)<<2)>>2]|0;F=(E>>>3&511)+1<<(47696>>>(E<<1&14)&3);E=(A+-1+F&0-F)+(Y(F,f[g+(D<<2)>>2]|0)|0)|0;D=D+2|0;if((D|0)>=(z|0)){G=E;break}else A=E}}else G=0;A=f[q>>2]|0;z=(A>>>3&511)+1<<(47696>>>(A<<1&14)&3);A=G+-1+z&0-z;z=(j|0)/(A|0)|0;if((x|0)==1){if((KU(w,g)|0)>2){D=f[k>>2]|0;H=((D>>>3&511)+1<<(47696>>>(D<<1&14)&3)|0)>7?8:4}else H=4;I=H}else I=4;f[n>>2]=0;f[b>>2]=0;f[g>>2]=f[n>>2];f[g+4>>2]=f[n+4>>2];xV(a,y?208845:208854,13,0,g);MW(C,i,0);D=C+24|0;if((f[D>>2]|0)>0){E=v+-24|0;F=I+-1|0;J=0-I|0;if(!y)if((v|0)>24){K=0;L=h;M=0;while(1){N=f[m>>2]|0;if((f[N>>2]|0)>-1){O=L+3&-4;P=O;f[O>>2]=f[f[N+16>>2]>>2];f[P+4>>2]=f[f[N+20>>2]>>2];f[P+8>>2]=f[N+4>>2];Vac(F+(P+12)&J|0,N+24|0,E|0)|0;N=K+1|0;if((N|0)<(z|0)){Q=N;R=P+A|0}else{yV(a,h,N,w);Q=0;R=h}}else{Q=K;R=L}N=(f[m>>2]|0)+(f[t>>2]|0)|0;f[m>>2]=N;if(N>>>0>=(f[B>>2]|0)>>>0)VW(i,1);M=M+1|0;if((M|0)>=(f[D>>2]|0)){S=Q;break}else{K=Q;L=R}}}else{L=0;K=h;M=0;while(1){E=f[m>>2]|0;if((f[E>>2]|0)>-1){J=K+3&-4;F=J;f[J>>2]=f[f[E+16>>2]>>2];f[F+4>>2]=f[f[E+20>>2]>>2];f[F+8>>2]=f[E+4>>2];J=L+1|0;if((J|0)<(z|0)){T=J;U=F+A|0;V=E}else{yV(a,h,J,w);T=0;U=h;V=f[m>>2]|0}}else{T=L;U=K;V=E}E=V+(f[t>>2]|0)|0;f[m>>2]=E;if(E>>>0>=(f[B>>2]|0)>>>0)VW(i,1);M=M+1|0;if((M|0)>=(f[D>>2]|0)){S=T;break}else{L=T;K=U}}}else{K=0;L=h;M=0;while(1){E=f[m>>2]|0;if((f[E>>2]|0)>-1){Vac(L|0,E+8|0,A|0)|0;E=K+1|0;if((E|0)<(z|0)){W=E;X=L+A|0}else{yV(a,h,E,w);W=0;X=h}}else{W=K;X=L}E=(f[m>>2]|0)+(f[t>>2]|0)|0;f[m>>2]=E;if(E>>>0>=(f[B>>2]|0)>>>0)VW(i,1);M=M+1|0;if((M|0)>=(f[D>>2]|0)){S=W;break}else{K=W;L=X}}}if((S|0)>0)yV(a,h,S,w)}uT(a)}x=x+1|0}while((x|0)!=2);uT(a);MW(c,i,0);c=f[s>>2]|0;if((c|0)>0){Z=0;_=0;$=c}else{WC(h);WC(r);u=e;return}while(1){c=f[m>>2]|0;if((f[c>>2]|0)>-1){f[c>>2]=f[r+(Z<<2)>>2];aa=Z+1|0}else aa=Z;a=c+(f[d>>2]|0)|0;f[m>>2]=a;if(a>>>0<(f[B>>2]|0)>>>0)ba=$;else{VW(i,1);ba=f[s>>2]|0}_=_+1|0;if((_|0)>=(ba|0))break;else{Z=aa;$=ba}}WC(h);WC(r);u=e;return}function kV(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-65536|0)==1111752704;return b&1|0}function lV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+8240|0;e=d+8200|0;g=d+4104|0;h=d+8|0;i=d;j=MV(a,c,207083)|0;k=MV(a,c,207096)|0;if((k|0)!=0?(f[k>>2]&7|0)==3:0){l=f[k+8+4>>2]|0;if((j|0)!=0&(l|0)!=0)m=l;else{n=l;o=4}}else{n=0;o=4}if((o|0)==4){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,46)|0;q=207666;r=p+46|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-2,h,208684,201015,5525);bD(h);m=n}n=f[j>>2]&7;if((n|0)==5)s=f[(f[j+8>>2]|0)+24>>2]|0;else s=(n|0)==1?1:-1;n=s+-1|0;if(n>>>0>31){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,48)|0;q=208701;r=p+48|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-212,h,208684,201015,5531);bD(h)}NV(a,j,g,207089);j=OV(m)|0;o=MV(a,c,377867)|0;if(!((o|0)!=0?(f[o>>2]&7|0)==5:0)){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,44)|0;q=207772;r=p+44|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-2,h,208684,201015,5538);bD(h)}c=uQ(s,g,j)|0;g=j>>>3&511;j=g+1|0;l=f[o+8>>2]|0;PV(a,o,e);o=l+24|0;if((f[o>>2]|0)<=0){t=c;u=d;return t|0}k=e+12|0;v=h+(n<<2)|0;w=l+28|0;l=e+20|0;x=g+2|0;g=i+4|0;y=i+4|0;z=0;do{A=f[k>>2]|0;if((f[A>>2]&7|0)!=1){f[i>>2]=0;f[y>>2]=0;p=aD(i,31)|0;q=208750;r=p+31|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-212,i,208684,201015,5553);bD(i)}B=f[A+8>>2]|0;C=(z|0)>0;if(!(C&(B|0)>-1)){if(C)D=n+B|0;else{f[h>>2]=B;D=1}if((D|0)<(s|0)){C=D;E=z;while(1){F=(f[k>>2]|0)+(f[w>>2]|0)|0;f[k>>2]=F;if(F>>>0<(f[l>>2]|0)>>>0)G=F;else{VW(e,1);G=f[k>>2]|0}F=E+1|0;if((f[G>>2]&7|0)==1?(H=f[G+8>>2]|0,(H|0)>=0):0)I=H;else{f[i>>2]=0;f[g>>2]=0;p=aD(i,31)|0;q=208750;r=p+31|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-212,i,208684,201015,5569);bD(i);I=f[G+8>>2]|0}f[h+(C<<2)>>2]=I;C=C+1|0;if((C|0)>=(s|0)){J=F;break}else E=F}}else J=z}else{f[v>>2]=B;J=z}E=(f[k>>2]|0)+(f[w>>2]|0)|0;f[k>>2]=E;if(E>>>0>=(f[l>>2]|0)>>>0)VW(e,1);QV(a,e,j,EQ(c,h,0,1,0)|0,m);z=x+J|0}while((z|0)<(f[o>>2]|0));t=c;u=d;return t|0}function mV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+112|0;g=e+88|0;i=e;j=e+84|0;k=e+72|0;l=e+40|0;m=e+24|0;n=e+96|0;o=e+32|0;p=e+16|0;q=e+8|0;r=zW(0)|0;f[j>>2]=r;f[o>>2]=0;f[o+4>>2]=0;f[g>>2]=f[o>>2];f[g+4>>2]=f[o+4>>2];xV(a,c,6,207018,g);c=CQ(d,0)|0;f[m>>2]=c;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=f[p>>2];f[g+4>>2]=f[p+4>>2];xV(a,207083,13,0,g);yV(a,d+36|0,c,207089);uT(a);c=f[d>>2]|0;p=b[203503+(c&7)>>0]|0;f[i>>2]=(c>>>3&511)+1;f[i+4>>2]=p;_Ub(n,207091,i)|0;zV(a,207096,n+((b[n+2>>0]|0)==0&(b[n>>0]|0)==49&1)|0,0);f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=f[q>>2];f[g+4>>2]=f[q+4>>2];xV(a,377867,13,0,g);q=IW(7,56,4,r)|0;r=xQ(d,k)|0;if(r|0){i=d+32|0;p=k+4|0;c=k+8|0;o=r;a:while(1){f[g>>2]=o+(f[i>>2]|0);XW(q,g)|0;r=f[(f[p>>2]|0)+4>>2]|0;if(!r){s=(f[c>>2]|0)+1|0;f[c>>2]=s;t=f[k>>2]|0;v=f[t+24>>2]|0;if((s|0)>=(v|0))break;w=f[t+20>>2]|0;t=s;while(1){x=f[w+(t<<2)>>2]|0;if(x|0)break;s=t+1|0;if((s|0)<(v|0))t=s;else break a}f[c>>2]=t;y=x}else y=r;f[p>>2]=y;o=y}}aX(q,279,m);MW(q,l,0);y=q+24|0;if((f[y>>2]|0)<=0){uT(a);uT(a);BW(j);u=e;return}q=l+12|0;o=l+20|0;p=d+32|0;x=d+28|0;d=a+236|0;c=0;k=0;do{g=f[q>>2]|0;i=k;k=h[g>>0]|h[g+1>>0]<<8|h[g+2>>0]<<16|h[g+3>>0]<<24;v=g+4|0;f[q>>2]=v;if(v>>>0>=(f[o>>2]|0)>>>0)VW(l,1);if((c|0)>0){v=0;while(1){z=v+1|0;if((f[k+(v<<2)>>2]|0)==(f[i+(v<<2)>>2]|0))v=z;else break}i=f[m>>2]|0;if((v|0)<(i+-1|0)){_h[f[d>>2]&255](a,0,z-i|0);A=v}else A=v}else A=0;if((A|0)<(f[m>>2]|0)){i=A;do{_h[f[d>>2]&255](a,0,f[k+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(f[m>>2]|0))}yV(a,k+(0-(f[p>>2]|0))+(f[x>>2]|0)|0,1,n);c=c+1|0}while((c|0)<(f[y>>2]|0));uT(a);uT(a);BW(j);u=e;return}function nV(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]|0)==112;return b&1|0}function oV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+80|0;e=d+56|0;g=d+16|0;h=d+48|0;i=d;j=MV(a,c,434730)|0;a:do if(!j)k=0;else switch(f[j>>2]&7){case 1:{k=f[j+8>>2]|0;break a;break}case 2:{k=MVb(+p[j+8>>3])|0;break a;break}default:{k=2147483647;break a}}while(0);j=MV(a,c,434884)|0;b:do if(!j)l=0;else switch(f[j>>2]&7){case 1:{l=f[j+8>>2]|0;break b;break}case 2:{l=MVb(+p[j+8>>3])|0;break b;break}default:{l=2147483647;break b}}while(0);j=MV(a,c,207096)|0;if((j|0)!=0?(f[j>>2]&7|0)==3:0)m=f[j+8+4>>2]|0;else m=0;j=MV(a,c,208502)|0;if((j|0)!=0?(f[j>>2]&7|0)==3:0)n=f[j+8+4>>2]|0;else n=0;if((k|0)==0|(l|0)==0|(m|0)==0|(n|0)==0){f[e>>2]=0;f[e+4>>2]=0;o=aD(e,45)|0;q=208545;r=o+45|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));bO(-2,e,208591,201015,5666);bD(e)}n=OV(m)|0;j=MV(a,c,208528)|0;if(j)if((f[j>>2]&7|0)==3?(s=f[j+8+4>>2]|0,(s|0)!=0):0){t=s;v=20}else v=21;else{t=208516;v=20}if((v|0)==20?gTb(t,208516)|0:0)v=21;if((v|0)==21){f[e>>2]=0;f[e+4>>2]=0;o=aD(e,35)|0;q=208604;r=o+35|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));bO(-2,e,208591,201015,5671);bD(e)}v=MV(a,c,377867)|0;if(!v){f[e>>2]=0;f[e+4>>2]=0;o=aD(e,43)|0;q=208640;r=o+43|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));bO(-2,e,208591,201015,5675);bD(e)}t=f[v>>2]&7;if(t>>>0>4)w=f[(f[v+8>>2]|0)+24>>2]|0;else w=(t|0)!=0&1;t=Y(l,k)|0;s=(n>>>3&511)+1|0;if((w|0)!=(Y(s,t)|0)){f[e>>2]=0;f[e+4>>2]=0;o=aD(e,63)|0;q=207817;r=o+63|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));bO(-209,e,208591,201015,5679);bD(e)}q=n&7;f[h>>2]=k;f[h+4>>2]=l;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];h=HQ(e,1212424721>>>(q<<2)<<3&120|((q|0)==4|(q|2|0)==3?-2147483648:0),s)|0;q=MV(a,c,208535)|0;if(q|0){c=MV(a,q,422891)|0;c:do if(!c)x=0;else switch(f[c>>2]&7){case 1:{x=f[c+8>>2]|0;break c;break}case 2:{x=MVb(+p[c+8>>3])|0;break c;break}default:{x=2147483647;break c}}while(0);c=MV(a,q,208539)|0;d:do if(!c)y=0;else switch(f[c>>2]&7){case 1:{y=f[c+8>>2]|0;break d;break}case 2:{y=MVb(+p[c+8>>3])|0;break d;break}default:{y=2147483647;break d}}while(0);c=MV(a,q,434730)|0;e:do if(!c)z=0;else switch(f[c>>2]&7){case 1:{z=f[c+8>>2]|0;break e;break}case 2:{z=MVb(+p[c+8>>3])|0;break e;break}default:{z=2147483647;break e}}while(0);c=MV(a,q,434884)|0;f:do if(!c)A=0;else switch(f[c>>2]&7){case 1:{A=f[c+8>>2]|0;break f;break}case 2:{A=MVb(+p[c+8>>3])|0;break f;break}default:{A=2147483647;break f}}while(0);c=MV(a,q,208541)|0;g:do if(!c)B=0;else switch(f[c>>2]&7){case 1:{B=f[c+8>>2]|0;break g;break}case 2:{B=MVb(+p[c+8>>3])|0;break g;break}default:{B=2147483647;break g}}while(0);f[i>>2]=x;f[i+4>>2]=y;f[i+8>>2]=z;f[i+12>>2]=A;f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];JQ(h,e);KQ(h,B)}B=Y(s<<(47696>>>(n<<1&14)&3),k)|0;n=h+72|0;e=(B|0)==(f[n>>2]|0);B=e?1:l;l=Y(e?t:k,s)|0;PV(a,v,g);if((B|0)<=0){u=d;return h|0}v=h+68|0;s=0;do{QV(a,g,l,(f[v>>2]|0)+(Y(f[n>>2]|0,s)|0)|0,m);s=s+1|0}while((s|0)!=(B|0));u=d;return h|0}function pV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+64|0;g=e+32|0;h=e;i=e+40|0;j=e+24|0;k=e+16|0;l=e+8|0;m=d+28|0;if((f[m>>2]|0)==1){f[g>>2]=0;f[g+4>>2]=0;n=aD(g,48)|0;o=208418;p=n+48|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-210,g,208467,201015,5606);bD(g)}f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];xV(a,c,6,207039,g);c=d+40|0;RV(a,434730,f[c>>2]|0);j=d+44|0;RV(a,434884,f[j>>2]|0);zV(a,208502,(f[d+32>>2]|0)==0?208481:208490,0);zV(a,208528,(f[m>>2]|0)==1?208509:208516,0);m=d+48|0;if(f[m>>2]|0){f[k>>2]=0;f[k+4>>2]=0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];xV(a,208535,14,0,g);RV(a,422891,f[(f[m>>2]|0)+4>>2]|0);RV(a,208539,f[(f[m>>2]|0)+8>>2]|0);RV(a,434730,f[(f[m>>2]|0)+12>>2]|0);RV(a,434884,f[(f[m>>2]|0)+16>>2]|0);RV(a,208541,f[f[m>>2]>>2]|0);uT(a)}m=f[d+16>>2]|0;k=1125516576>>>((m>>>2&60)+(m>>31&20)|0);m=d+8|0;o=b[203503+(k&7)>>0]|0;f[h>>2]=f[m>>2];f[h+4>>2]=o;_Ub(i,207091,h)|0;h=i+((b[i+2>>0]|0)==0&(b[i>>0]|0)==49&1)|0;zV(a,207096,h,0);i=f[c>>2]|0;c=f[j>>2]|0;j=(Y(f[m>>2]|0,i)|0)<<(47696>>>(k<<1&14)&3);k=d+72|0;m=(j|0)==(f[k>>2]|0);j=Y(m?c:1,i)|0;i=m?1:c;f[l>>2]=0;f[l+4>>2]=0;f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];xV(a,377867,13,0,g);if((i|0)<=0){uT(a);uT(a);u=e;return}g=d+68|0;d=0;do{yV(a,(f[g>>2]|0)+(Y(f[k>>2]|0,d)|0)|0,j,h);d=d+1|0}while((d|0)!=(i|0));uT(a);uT(a);u=e;return}function qV(a){a=a|0;var b=0;if(((a|0)!=0?(f[a>>2]&-65536|0)==1111621632:0)?(f[a+24>>2]|0)>-1:0)b=(f[a+20>>2]|0)>-1;else b=0;return b&1|0}function rV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=MV(a,c,208386)|0;a:do if(!g)h=-1;else switch(f[g>>2]&7){case 1:{h=f[g+8>>2]|0;break a;break}case 2:{h=MVb(+p[g+8>>3])|0;break a;break}default:{h=2147483647;break a}}while(0);g=MV(a,c,208391)|0;b:do if(!g)i=-1;else switch(f[g>>2]&7){case 1:{i=f[g+8>>2]|0;break b;break}case 2:{i=MVb(+p[g+8>>3])|0;break b;break}default:{i=2147483647;break b}}while(0);g=MV(a,c,207096)|0;if((g|0)!=0?(f[g>>2]&7|0)==3:0){j=f[g+8+4>>2]|0;if((i|h|0)>-1&(j|0)!=0)k=j;else{l=j;m=12}}else{l=0;m=12}if((m|0)==12){f[e>>2]=0;f[e+4>>2]=0;n=aD(e,46)|0;o=207666;q=n+46|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));bO(-2,e,208407,201015,5286);bD(e);k=l}l=OV(k)|0;m=MV(a,c,377867)|0;if(!m){f[e>>2]=0;f[e+4>>2]=0;n=aD(e,44)|0;o=207772;q=n+44|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));bO(-2,e,208407,201015,5292);bD(e)}c=f[m>>2]&7;if(c>>>0>4)r=f[(f[m+8>>2]|0)+24>>2]|0;else r=(c|0)!=0&1;if((r|0)<=0){s=hQ(h,i,l)|0;u=d;return s|0}if((r|0)!=(Y(Y(i,h)|0,(l>>>3&511)+1|0)|0)){f[e>>2]=0;f[e+4>>2]=0;n=aD(e,63)|0;o=207817;q=n+63|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));bO(-209,e,208407,201015,5297);bD(e)}e=gQ(h,i,l)|0;NV(a,m,f[e+16>>2]|0,k);s=e;u=d;return s|0}function sV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+8|0;h=e;i=e+32|0;j=e+24|0;k=e+16|0;f[j>>2]=0;f[j+4>>2]=0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];xV(a,c,6,207052,g);RV(a,208386,f[d+20>>2]|0);RV(a,208391,f[d+24>>2]|0);c=f[d>>2]|0;j=b[203503+(c&7)>>0]|0;f[h>>2]=(c>>>3&511)+1;f[h+4>>2]=j;_Ub(i,207091,h)|0;zV(a,207096,i+((b[i+2>>0]|0)==0&(b[i>>0]|0)==49&1)|0,0);f[k>>2]=0;f[k+4>>2]=0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];xV(a,377867,13,0,g);DQ(g,d);k=g;g=f[k>>2]|0;h=f[k+4>>2]|0;if(!((g|0)>0&(h|0)>0)){uT(a);uT(a);u=e;return}k=d+16|0;j=f[k>>2]|0;if(!j){uT(a);uT(a);u=e;return}c=(f[d>>2]&16384|0)==0;l=c?h:1;m=Y(c?1:h,g)|0;if((l|0)<=0){uT(a);uT(a);u=e;return}g=d+4|0;yV(a,j,m,i);if((l|0)==1){uT(a);uT(a);u=e;return}else n=1;do{yV(a,(f[k>>2]|0)+(Y(f[g>>2]|0,n)|0)|0,m,i);n=n+1|0}while((n|0)!=(l|0));uT(a);uT(a);u=e;return}function tV(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-65536|0)==1111687168;return b&1|0}function uV(a){a=a|0;kQ(a);return}function vV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+144|0;e=d+8|0;g=d;h=e;i=h+128|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));j=MV(a,c,207083)|0;k=MV(a,c,207096)|0;if((k|0)!=0?(f[k>>2]&7|0)==3:0){l=f[k+8+4>>2]|0;if((j|0)!=0&(l|0)!=0)m=l;else{n=l;o=4}}else{n=0;o=4}if((o|0)==4){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,46)|0;p=207666;i=h+46|0;do{b[h>>0]=b[p>>0]|0;h=h+1|0;p=p+1|0}while((h|0)<(i|0));bO(-2,g,207713,201015,5369);bD(g);m=n}n=f[j>>2]&7;if((n|0)==5)q=f[(f[j+8>>2]|0)+24>>2]|0;else q=(n|0)==1?1:-1;if((q+-1|0)>>>0>31){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,45)|0;p=207726;i=h+45|0;do{b[h>>0]=b[p>>0]|0;h=h+1|0;p=p+1|0}while((h|0)<(i|0));bO(-212,g,207713,201015,5375);bD(g)}NV(a,j,e,207089);j=OV(m)|0;n=MV(a,c,377867)|0;if(!n){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,44)|0;p=207772;i=h+44|0;do{b[h>>0]=b[p>>0]|0;h=h+1|0;p=p+1|0}while((h|0)<(i|0));bO(-2,g,207713,201015,5382);bD(g)}c=(j>>>3&511)+1|0;if((q|0)>0){o=g+4|0;l=c;k=0;while(1){r=e+(k<<2)|0;s=f[r>>2]|0;if(!s){f[g>>2]=0;f[o>>2]=0;t=aD(g,8)|0;v=t;b[v>>0]=115;b[v+1>>0]=105;b[v+2>>0]=122;b[v+3>>0]=101;v=t+4|0;b[v>>0]=115;b[v+1>>0]=91;b[v+2>>0]=105;b[v+3>>0]=93;bO(-215,g,207713,201015,5388);bD(g);w=f[r>>2]|0}else w=s;s=Y(w,l)|0;k=k+1|0;if((k|0)>=(q|0)){x=s;break}else l=s}}else x=c;c=f[n>>2]&7;if(c>>>0>4)y=f[(f[n+8>>2]|0)+24>>2]|0;else y=(c|0)!=0&1;c=(y|0)>0;if(!((y|0)==(x|0)|c^1)){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,63)|0;p=207817;i=h+63|0;do{b[h>>0]=b[p>>0]|0;h=h+1|0;p=p+1|0}while((h|0)<(i|0));bO(-209,g,207713,201015,5396);bD(g)}if(c){c=nQ(q,e,j)|0;NV(a,n,f[c+16>>2]|0,m);z=c;u=d;return z|0}else{z=oQ(q,e,j)|0;u=d;return z|0}return 0}function wV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+688|0;g=e+664|0;h=e;i=e+660|0;j=e+160|0;k=e+24|0;l=e+672|0;m=e+152|0;n=e+16|0;o=e+8|0;f[i>>2]=d;p=j+8|0;f[p>>2]=0;f[j+12>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];xV(a,c,6,207066,g);c=CQ(d,k)|0;f[n>>2]=0;f[n+4>>2]=0;f[g>>2]=f[n>>2];f[g+4>>2]=f[n+4>>2];xV(a,207083,13,0,g);yV(a,k,c,207089);uT(a);c=BQ(d)|0;k=b[203503+(c&7)>>0]|0;f[h>>2]=(c>>>3&511)+1;f[h+4>>2]=k;_Ub(l,207091,h)|0;zV(a,207096,l+((b[l+2>>0]|0)==0&(b[l>>0]|0)==49&1)|0,0);f[o>>2]=0;f[o+4>>2]=0;f[g>>2]=f[o>>2];f[g+4>>2]=f[o+4>>2];xV(a,377867,13,0,g);if((f[d+20>>2]|0)<=0){uT(a);uT(a);u=e;return}if(!(f[d+16>>2]|0)){uT(a);uT(a);u=e;return}qQ(1,i,0,e+384|0,j,0)|0;i=j+16|0;do yV(a,f[i>>2]|0,f[p>>2]|0,l);while((tQ(j)|0)!=0);uT(a);uT(a);u=e;return}function xV(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=(a|0)!=0;if(!(i?(f[a>>2]|0)==1280131417:0)){j=i?-5:-27;f[h>>2]=0;f[h+4>>2]=0;k=aD(h,31)|0;l=201141;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(j,h,207395,201015,4564);bD(h)}if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,38)|0;l=201190;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,h,207395,201015,4564);bD(h)}zT(a,0);j=a+280|0;i=f[j>>2]|0;if((i|0)==1){AT(a,0);n=f[j>>2]|0}else n=i;i=(n|0)==0;o=(d&7|0)==5;if(o&i?(e|0)==0&(b[a+276>>0]|0)!=0:0){p=a+284|0;if(b[p>>0]|0){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,36)|0;l=207414;m=k+36|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,207451,201015,1252);bD(h)}f[a+292>>2]=d;if(c|0){q=N5b((kUb(c)|0)+1|0)|0;f[a+288>>2]=q;KUb(q,c)|0}b[p>>0]=1;u=g;return}if(e|0?(ZVb(e,201467,6)|0)==0:0){if(o){if(!i){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,69)|0;l=207533;m=k+69|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,h,207395,201015,4587);bD(h)}}else{f[h>>2]=0;f[h+4>>2]=0;k=aD(h,55)|0;l=207477;m=k+55|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-5,h,207395,201015,4585);bD(h)}th[f[a+228>>2]&511](a,c,d,e);if(f[j>>2]|0)AT(a,0);AT(a,2);u=g;return}if((n|0)==2){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,62)|0;l=207603;m=k+62|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,h,207395,201015,4599);bD(h)}th[f[a+228>>2]&511](a,c,d,e);if(f[j>>2]|0)AT(a,0);AT(a,1);u=g;return}function yV(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0;i=u;u=u+1312|0;k=i+8|0;l=i;m=i+24|0;o=i+1048|0;q=i+16|0;a:do if(!(b[a+276>>0]|0)){switch(f[a+280>>2]|0){case 2:{break a;break}case 0:{AT(a,1);break}default:{}}Nac(o|0,0,256)|0;if((f[a>>2]|0)!=1280131417){f[q>>2]=0;f[q+4>>2]=0;r=aD(q,31)|0;t=201141;v=r+31|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));bO(-5,q,207113,201015,4812);bD(q)}if(!(f[a+8>>2]|0)){f[q>>2]=0;f[q+4>>2]=0;r=aD(q,38)|0;t=201190;v=r+38|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));bO(-2,q,207113,201015,4812);bD(q)}if((e|0)>=0){w=KU(g,m)|0;if(e|0){x=w;y=m;z=12}}else{f[q>>2]=0;f[q+4>>2]=0;r=aD(q,27)|0;t=207128;v=r+27|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));bO(-211,q,207113,201015,4815);bD(q);x=KU(g,m)|0;y=m;z=12}b:do if((z|0)==12){if(!c){f[q>>2]=0;f[q+4>>2]=0;r=aD(q,17)|0;t=207156;v=r+17|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));bO(-27,q,207113,201015,4823);bD(q)}if((x|0)!=1)if(!e)break;else A=e;else{w=Y(f[y>>2]|0,e)|0;f[y>>2]=w;A=1}w=(x|0)>0;B=c;C=o+23|0;D=a+4|0;E=o+1|0;F=0;G=A;c:while(1){G=G+-1|0;if(w){H=0;I=F;while(1){J=H<<1;K=f[m+(J<<2)>>2]|0;L=f[m+((J|1)<<2)>>2]|0;J=(L>>>3&511)+1<<(47696>>>(L<<1&14)&3);M=c+(I+-1+J&0-J)|0;d:do if((K|0)>0){J=(L+-5|0)>>>0<2;N=M;O=0;while(1){e:do switch(L|0){case 0:{P=h[N>>0]|0;b[C>>0]=0;Q=C;R=P;while(1){P=R;R=(R>>>0)/10|0;S=P+48+(Y(R,-10)|0)&255;T=Q+-1|0;b[T>>0]=S;if(P>>>0<=9){U=T;V=1;break}else Q=T}break}case 1:{Q=b[N>>0]|0;R=Q<<24>>24;b[C>>0]=0;T=C;P=Q<<24>>24>-1?R:0-R|0;while(1){R=P;P=(P>>>0)/10|0;S=R+48+(Y(P,-10)|0)&255;W=T+-1|0;b[W>>0]=S;if(R>>>0<=9)break;else T=W}if(Q<<24>>24<0){P=T+-2|0;b[P>>0]=45;U=P;V=1}else{U=W;V=1}break}case 2:{P=j[N>>1]|0;b[C>>0]=0;R=C;S=P;while(1){P=S;S=(S>>>0)/10|0;X=P+48+(Y(S,-10)|0)&255;Z=R+-1|0;b[Z>>0]=X;if(P>>>0<=9){U=Z;V=2;break}else R=Z}break}case 3:{R=d[N>>1]|0;S=R<<16>>16;b[C>>0]=0;T=C;Q=R<<16>>16>-1?S:0-S|0;while(1){S=Q;Q=(Q>>>0)/10|0;Z=S+48+(Y(Q,-10)|0)&255;_=T+-1|0;b[_>>0]=Z;if(S>>>0<=9)break;else T=_}if(R<<16>>16<0){Q=T+-2|0;b[Q>>0]=45;U=Q;V=2}else{U=_;V=2}break}case 4:{Q=f[N>>2]|0;b[C>>0]=0;S=C;Z=(Q|0)>-1?Q:0-Q|0;while(1){P=Z;Z=(Z>>>0)/10|0;X=P+48+(Y(Z,-10)|0)&255;$=S+-1|0;b[$>>0]=X;if(P>>>0<=9)break;else S=$}if((Q|0)<0){Z=S+-2|0;b[Z>>0]=45;U=Z;V=4}else{U=$;V=4}break}case 5:{aa=+n[N>>2];Z=(n[s>>2]=aa,f[s>>2]|0);if((Z&2139095040|0)==2139095040)if((Z&2147483647|0)==2139095040){KUb(o,(Z|0)<0?206469:206475)|0;U=o;V=4;break e}else{b[o>>0]=b[206464]|0;b[o+1>>0]=b[206465]|0;b[o+2>>0]=b[206466]|0;b[o+3>>0]=b[206467]|0;b[o+4>>0]=b[206468]|0;U=o;V=4;break e}Z=LVb(aa)|0;if(+(Z|0)==aa){f[l>>2]=Z;_Ub(o,206454,l)|0;U=o;V=4;break e}p[k>>3]=aa;_Ub(o,207174,k)|0;switch(b[o>>0]|0){case 45:case 43:{ba=E;break}default:ba=o}while(1){ca=b[ba>>0]|0;if((ca+-48&255)<10)ba=ba+1|0;else break}if(ca<<24>>24==44){b[ba>>0]=46;U=o;V=4}else{U=o;V=4}break}case 6:{XU(o,+p[N>>3])|0;U=o;V=8;break}case 7:{S=f[N>>2]|0;b[C>>0]=0;Q=C;Z=(S|0)>-1?S:0-S|0;while(1){T=Z;Z=(Z>>>0)/10|0;R=T+48+(Y(Z,-10)|0)&255;da=Q+-1|0;b[da>>0]=R;if(T>>>0<=9)break;else Q=da}if((S|0)<0){Z=Q+-2|0;b[Z>>0]=45;U=Z;V=4}else{U=da;V=4}break}default:break c}while(0);Z=N+V|0;switch(f[D>>2]|0){case 8:{VU(a,0,U,kUb(U)|0);break}case 16:{TU(a,0,U);break}default:{if((J?(T=kUb(U)|0,T|0):0)?(b[U+(T+-1)>>0]|0)==46:0){b[o+T>>0]=48;b[o+(T+1)>>0]=0}UU(a,0,U)}}O=O+1|0;if((O|0)>=(K|0)){ea=Z;break d}else N=Z}}else ea=M;while(0);M=ea-B|0;H=H+1|0;if((H|0)>=(x|0)){fa=M;break}else I=M}}else fa=F;if(!G)break b;else F=fa}f[q>>2]=0;f[q+4>>2]=0;r=aD(q,16)|0;t=269007;v=r+16|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(v|0));bO(-210,q,207113,201015,4880);bD(q)}while(0);u=i;return}while(0);AV(a,c,e,g);u=i;return}function zV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;i=(a|0)!=0;if(!(i?(f[a>>2]|0)==1280131417:0)){j=i?-5:-27;f[h>>2]=0;f[h+4>>2]=0;k=aD(h,31)|0;l=201141;m=k+31|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(j,h,207099,201015,4642);bD(h)}if(f[a+8>>2]|0){n=a+244|0;o=f[n>>2]|0;th[o&511](a,c,d,e);u=g;return}f[h>>2]=0;f[h+4>>2]=0;k=aD(h,38)|0;l=201190;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,h,207099,201015,4642);bD(h);n=a+244|0;o=f[n>>2]|0;th[o&511](a,c,d,e);u=g;return}function AV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=(a|0)!=0;if(i){if((f[a>>2]|0)!=1280131417)j=4}else{f[h>>2]=0;f[h+4>>2]=0;k=aD(h,2)|0;b[k>>0]=102;b[k+1>>0]=115;bO(-215,h,207179,201015,8387);bD(h);j=4}if((j|0)==4){j=i?-5:-27;f[h>>2]=0;f[h+4>>2]=0;l=aD(h,31)|0;m=201141;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(j,h,207179,201015,8388);bD(h)}if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;l=aD(h,38)|0;m=201190;n=l+38|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-2,h,207179,201015,8388);bD(h)}zT(a,1);switch(f[a+280>>2]|0){case 0:{AT(a,2);o=a+272|0;p=f[o>>2]|0;BV(p,c,d,e);u=g;return}case 2:{o=a+272|0;p=f[o>>2]|0;BV(p,c,d,e);u=g;return}default:{f[h>>2]=0;f[h+4>>2]=0;l=aD(h,37)|0;m=207200;n=l+37|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-2,h,207179,201015,8398);bD(h);o=a+272|0;p=f[o>>2]|0;BV(p,c,d,e);u=g;return}}}function BV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+32|0;g=e;CV(a,d);DV(g,b,c,a+4|0);c=f[a>>2]|0;a=L5b(1024)|0;Nac(a|0,0,1024)|0;b=g+4|0;d=f[b>>2]|0;h=g+8|0;if(d>>>0<(f[h>>2]|0)>>>0){i=g+16|0;j=g+20|0;k=g+12|0;l=c+36|0;m=c+32|0;n=d;while(1){d=f[i>>2]|0;o=(f[j>>2]|0)-d>>3;if(!o)p=n;else{q=0;r=d;d=n;while(1){s=f[r+(q<<3)>>2]|0;Uh[f[r+(q<<3)+4>>2]&1023](d+s|0,a+s|0)|0;s=q+1|0;if((s|0)==(o|0))break;q=s;r=f[i>>2]|0;d=f[b>>2]|0}p=f[b>>2]|0}d=f[k>>2]|0;r=p+d|0;f[b>>2]=r;q=a+d|0;if((d|0)>0){d=q;o=a;do{s=d-o|0;t=f[m>>2]|0;v=(f[l>>2]|0)-t|0;w=(v|0)<(s|0)?v:s;Vac(t|0,o|0,w|0)|0;o=o+w|0;t=(f[m>>2]|0)+w|0;f[m>>2]=t;if(t>>>0>=(f[l>>2]|0)>>>0)DT(c)|0}while(o>>>0<q>>>0);x=f[b>>2]|0}else x=r;if(x>>>0<(f[h>>2]|0)>>>0)n=x;else break}}O5b(a);a=f[g+16>>2]|0;if(!a){u=e;return}x=g+20|0;g=f[x>>2]|0;if((g|0)!=(a|0))f[x>>2]=g+(~((g+-8-a|0)>>>3)<<3);O5b(a);u=e;return}function CV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;if(!c){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,13)|0;h=207304;i=g+13|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-5,e,207318,201015,8359);bD(e);u=d;return}j=a+4|0;k=b[j+11>>0]|0;l=k<<24>>24<0;if(l)m=f[a+8>>2]|0;else m=k&255;if(m|0){m=kUb(c)|0;if((m|0)==((l?f[a+8>>2]|0:k&255)|0)?(u6b(j,0,-1,c,m)|0)==0:0){u=d;return}f[e>>2]=0;f[e+4>>2]=0;g=aD(e,20)|0;h=207327;i=g+20|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-5,e,207318,201015,8370);bD(e);u=d;return}d6b(j,c)|0;LV(e,c);c=e+11|0;j=b[c>>0]|0;h=j<<24>>24<0;g=h?f[e>>2]|0:e;i=h?f[e+4>>2]|0:j&255;h=g+i|0;m=f[a>>2]|0;if((i|0)>0){i=h;a=m+36|0;k=m+32|0;l=g;do{g=i-l|0;n=f[k>>2]|0;o=(f[a>>2]|0)-n|0;p=(o|0)<(g|0)?o:g;Vac(n|0,l|0,p|0)|0;l=l+p|0;n=(f[k>>2]|0)+p|0;f[k>>2]=n;if(n>>>0>=(f[a>>2]|0)>>>0)DT(m)|0}while(l>>>0<h>>>0);q=b[c>>0]|0}else q=j;if(q<<24>>24<0)O5b(f[e>>2]|0);u=d;return}function DV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+16|0;h=g;f[a>>2]=c;i=a+4|0;f[i>>2]=0;j=a+8|0;f[j>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if(!c){f[h>>2]=0;f[h+4>>2]=0;c=aD(h,3)|0;b[c>>0]=b[203271]|0;b[c+1>>0]=b[203272]|0;b[c+2>>0]=b[203273]|0;bO(-215,h,207238,201015,8036);bD(h)}c=e+11|0;k=b[c>>0]|0;if(!((k<<24>>24<0?f[e+4>>2]|0:k&255)|0)){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,11)|0;l=207263;m=k+11|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,207238,201015,8037);bD(h)}if((d|0)<=0){f[h>>2]=0;f[h+4>>2]=0;l=aD(h,7)|0;b[l>>0]=b[207275]|0;b[l+1>>0]=b[207276]|0;b[l+2>>0]=b[207277]|0;b[l+3>>0]=b[207278]|0;b[l+4>>0]=b[207279]|0;b[l+5>>0]=b[207280]|0;b[l+6>>0]=b[207281]|0;bO(-215,h,207238,201015,8038);bD(h)}EV(a,e);h=f[a>>2]|0;f[j>>2]=h;f[i>>2]=h;h=uU((b[c>>0]|0)<0?f[e>>2]|0:e)|0;f[a+12>>2]=h;e=(f[a>>2]|0)+(Y(h,d)|0)|0;f[j>>2]=e;u=g;return}function EV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+176|0;e=d+156|0;g=d+160|0;h=d+16|0;i=d;j=d+8|0;f[e>>2]=0;b[g>>0]=0;k=h+60|0;l=h+8|0;f[h>>2]=10956;f[k>>2]=10976;f[h+4>>2]=0;RXb(h+60|0,l);f[h+132>>2]=0;f[h+136>>2]=-1;f[h>>2]=47196;f[k>>2]=47216;WXb(l);f[l>>2]=43284;k=h+40|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[h+56>>2]=8;qP(l,c);c=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;a:do if(!(c&2)){l=i+4|0;k=j+4|0;m=a+20|0;n=a+24|0;o=a+16|0;p=i+4|0;q=0;while(1){r=bYb(h,e)|0;if(!(f[r+(f[(f[r>>2]|0)+-12>>2]|0)+16>>2]&5)){if(!(f[e>>2]|0)){f[i>>2]=0;f[l>>2]=0;r=aD(i,8)|0;s=r;b[s>>0]=99;b[s+1>>0]=110;b[s+2>>0]=116;b[s+3>>0]=32;s=r+4|0;b[s>>0]=62;b[s+1>>0]=32;b[s+2>>0]=48;b[s+3>>0]=85;bO(-215,i,207283,201015,8090);bD(i)}}else{QXb(h+(f[(f[h>>2]|0)+-12>>2]|0)|0,0);f[e>>2]=1}s=zU(h,g)|0;if(f[s+(f[(f[s>>2]|0)+-12>>2]|0)+16>>2]&5|0)break;s=f[e>>2]|0;f[e>>2]=s+-1;b:do if(!s)t=q;else{r=q;while(1){switch(b[g>>0]|0){case 99:case 117:{f[p>>2]=551;v=1;break}case 115:case 119:{f[p>>2]=552;v=2;break}case 105:{f[p>>2]=553;v=4;break}case 102:{f[p>>2]=554;v=4;break}case 100:{f[p>>2]=555;v=8;break}default:{f[j>>2]=0;f[k>>2]=0;w=aD(j,19)|0;x=203309;y=w+19|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,j,207283,201015,8124);bD(j);v=0}}z=r+-1+v&0-v;f[i>>2]=z;A=f[m>>2]|0;if((A|0)==(f[n>>2]|0))KV(o,i);else{B=i;C=f[B+4>>2]|0;D=A;f[D>>2]=f[B>>2];f[D+4>>2]=C;f[m>>2]=(f[m>>2]|0)+8}C=z+v|0;z=f[e>>2]|0;f[e>>2]=z+-1;if(!z){t=C;break b}else r=C}}while(0);s=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0;if(!(s&2))q=t;else{E=s;break a}}E=f[h+(f[(f[h>>2]|0)+-12>>2]|0)+16>>2]|0}else E=c;while(0);if(E&2|0){GU(h);u=d;return}f[i>>2]=0;f[i+4>>2]=0;w=aD(i,9)|0;x=203352;y=w+9|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,i,207283,201015,8135);bD(i);GU(h);u=d;return}function FV(a,c){a=a|0;c=c|0;b[c>>0]=b[a>>0]|0;return 1}function GV(a,c){a=a|0;c=c|0;var e=0;e=d[a>>1]|0;b[c>>0]=e;b[c+1>>0]=(e&65535)>>>8;return 2}function HV(a,c){a=a|0;c=c|0;var d=0;d=f[a>>2]|0;b[c>>0]=d;b[c+1>>0]=d>>>8;b[c+2>>0]=d>>>16;b[c+3>>0]=d>>>24;return 4}function IV(a,c){a=a|0;c=c|0;var d=0;d=f[a>>2]|0;b[c>>0]=d;b[c+1>>0]=d>>>8;b[c+2>>0]=d>>>16;b[c+3>>0]=d>>>24;return 4}function JV(a,c){a=a|0;c=c|0;var d=0,e=0;d=a;a=f[d>>2]|0;e=f[d+4>>2]|0;b[c>>0]=a;d=Sac(a|0,e|0,8)|0;b[c+1>>0]=d;d=Sac(a|0,e|0,16)|0;b[c+2>>0]=d;d=Sac(a|0,e|0,24)|0;b[c+3>>0]=d;b[c+4>>0]=e;d=Sac(a|0,e|0,40)|0;b[c+5>>0]=d;d=Sac(a|0,e|0,48)|0;b[c+6>>0]=d;d=Sac(a|0,e|0,56)|0;b[c+7>>0]=d;return 8}function KV(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;O5b(d);return}function LV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+160|0;e=d+136|0;g=d;h=g+56|0;i=g+4|0;f[g>>2]=18164;f[h>>2]=18184;RXb(g+56|0,i);f[g+128>>2]=0;f[g+132>>2]=-1;f[g>>2]=43248;f[h>>2]=43268;WXb(i);f[i>>2]=43284;h=g+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[g+52>>2]=16;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;qP(i,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);h=rP(g,c,kUb(c)|0)|0;b[e>>0]=32;rP(h,e,1)|0;sP(a,i);i=a+11|0;h=b[i>>0]|0;if(h<<24>>24<0)j=f[a+4>>2]|0;else j=h&255;if(j>>>0>=24){f[e>>2]=0;f[e+4>>2]=0;j=aD(e,27)|0;h=207348;c=j+27|0;do{b[j>>0]=b[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(c|0));bO(-215,e,207376,201015,7785);bD(e)}c6b(a,24);e=a+4|0;while(1){h=b[i>>0]|0;if(h<<24>>24<0)k=f[e>>2]|0;else k=h&255;if(k>>>0>=24)break;l6b(a,32)}tP(g);u=d;return}function MV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+16|0;g=e;if(!a){h=0;u=e;return h|0}if((f[a>>2]|0)!=1280131417){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,31)|0;j=201141;k=i+31|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-5,g,208348,201015,861);bD(g)}if(!d){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,17)|0;j=208368;k=i+17|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-27,g,208348,201015,864);bD(g)}l=b[d>>0]|0;if(!(l<<24>>24)){m=0;n=0}else{o=0;p=0;q=l;while(1){l=(q&255)+(o*33|0)|0;r=p+1|0;q=b[d+r>>0]|0;if(!(q<<24>>24)){m=l;n=r;break}else{o=l;p=r}}}p=m&2147483647;a:do if(!c){m=f[a+32>>2]|0;if(!m){h=0;u=e;return h|0}o=f[m+24>>2]|0;if((o|0)<=0){h=0;u=e;return h|0}m=a+32|0;q=0;b:while(1){s=KW(f[m>>2]|0,q)|0;switch(f[s>>2]&7){case 5:{t=22;break b;break}case 0:{h=0;t=35;break b;break}case 6:break;default:break a}r=f[s+8>>2]|0;l=f[r+64>>2]|0;v=l+-1|0;if(!(v&l))w=v&p;else w=(p>>>0)%(l>>>0)|0;l=f[(f[r+68>>2]|0)+(w<<2)>>2]|0;if(l|0){r=l;do{l=f[r+16>>2]|0;if(((f[l>>2]|0)==(p|0)?(f[l+4>>2]|0)==(n|0):0)?(ZVb(f[l+8>>2]|0,d,n)|0)==0:0){x=r;t=34;break a}r=f[r+20>>2]|0}while((r|0)!=0)}q=q+1|0;if((q|0)>=(o|0)){h=0;t=35;break}}if((t|0)==22){y=s;t=23;break}else if((t|0)==35){u=e;return h|0}}else{o=c+8|0;switch(f[c>>2]&7){case 5:{y=c;t=23;break a;break}case 6:break;case 0:{h=0;u=e;return h|0}default:break a}q=f[o>>2]|0;o=f[q+64>>2]|0;m=o+-1|0;if(!(m&o))z=m&p;else z=(p>>>0)%(o>>>0)|0;o=f[(f[q+68>>2]|0)+(z<<2)>>2]|0;if(!o){h=0;u=e;return h|0}else A=o;while(1){o=f[A+16>>2]|0;if(((f[o>>2]|0)==(p|0)?(f[o+4>>2]|0)==(n|0):0)?(ZVb(f[o+8>>2]|0,d,n)|0)==0:0){x=A;t=34;break a}A=f[A+20>>2]|0;if(!A){h=0;break}}u=e;return h|0}while(0);if((t|0)==23){if(!(f[(f[y+8>>2]|0)+24>>2]|0)){h=0;u=e;return h|0}}else if((t|0)==34){h=x;u=e;return h|0}f[g>>2]=0;f[g+4>>2]=0;i=aD(g,49)|0;j=203844;k=i+49|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-2,g,208348,201015,891);bD(g);h=0;u=e;return h|0}function NV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+48|0;h=g+8|0;i=g;if(!((c|0)!=0&(d|0)!=0)){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,54)|0;k=207937;l=j+54|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-27,i,207992,201015,5106);bD(i)}PV(a,c,h);if((f[c>>2]&7|0)!=5){m=1;QV(a,h,m,d,e);u=g;return}m=f[(f[c+8>>2]|0)+24>>2]|0;QV(a,h,m,d,e);u=g;return}function OV(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+528|0;d=c+8|0;e=c;g=(KU(a,d)|0)!=1;a=f[d>>2]|0;if(g|(a|0)>4){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,33)|0;h=207881;i=g+33|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-2,e,207915,201015,4785);bD(e)}u=c;return (a<<3)+-8|f[d+4>>2]&7|0}function PV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(!(h?(f[a>>2]|0)==1280131417:0)){a=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;i=aD(g,31)|0;j=201141;k=i+31|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(a,g,208229,201015,4920);bD(g)}if(!((c|0)!=0&(d|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,42)|0;j=208248;k=i+42|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-27,g,208229,201015,4923);bD(g)}a=f[c>>2]|0;if(((a&7)+-1|0)>>>0<2){f[d+12>>2]=c;f[d+20>>2]=c+32;f[d+16>>2]=c;f[d+4>>2]=0;u=e;return}switch(a&7){case 5:{MW(f[c+8>>2]|0,d,0);u=e;return}case 0:{f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;u=e;return}default:{f[g>>2]=0;f[g+4>>2]=0;i=aD(g,56)|0;j=208291;k=i+56|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-5,g,208229,201015,4943);bD(g);u=e;return}}}function QV(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0;i=u;u=u+1040|0;j=i+8|0;k=i;l=(a|0)!=0;if(!(l?(f[a>>2]|0)==1280131417:0)){a=l?-5:-27;f[k>>2]=0;f[k+4>>2]=0;m=aD(k,31)|0;o=201141;q=m+31|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));bO(a,k,208006,201015,4955);bD(k)}if(!((c|0)!=0&(g|0)!=0)){f[k>>2]=0;f[k+4>>2]=0;m=aD(k,43)|0;o=208025;q=m+43|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));bO(-27,k,208006,201015,4958);bD(k)}a=c+4|0;if((e|0)!=1&(f[a>>2]|0)==0){f[k>>2]=0;f[k+4>>2]=0;m=aD(k,51)|0;o=208069;q=m+51|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));bO(-201,k,208006,201015,4961);bD(k)}l=KU(h,j)|0;r=uU(h)|0;h=(l|0)>0;s=c+12|0;t=k+4|0;v=c+20|0;w=e;e=g;a:while(1){if(h){g=e;x=0;y=0;z=w;while(1){A=x<<1;B=f[j+((A|1)<<2)>>2]|0;C=(B>>>3&511)+1<<(47696>>>(B<<1&14)&3);D=f[j+(A<<2)>>2]|0;A=e+(y+-1+C&0-C)|0;b:do if((D|0)>0){C=A;E=0;F=z;while(1){G=f[s>>2]|0;switch(f[G>>2]&7){case 1:{H=f[G+8>>2]|0;switch(B|0){case 0:{b[C>>0]=H>>>0<256?H:(H|0)>0?255:0;I=1;break}case 1:{b[C>>0]=(H+128|0)>>>0<256?H:(H|0)>0?127:128;I=1;break}case 2:{d[C>>1]=H>>>0<65536?H:(H|0)>0?65535:0;I=2;break}case 3:{d[C>>1]=(H+32768|0)>>>0<65536?H:(H|0)>0?32767:32768;I=2;break}case 4:{f[C>>2]=H;I=4;break}case 5:{n[C>>2]=+(H|0);I=4;break}case 6:{p[C>>3]=+(H|0);I=8;break}case 7:{f[C>>2]=H;I=4;break}default:{J=22;break a}}K=C+I|0;break}case 2:{L=+p[G+8>>3];switch(B|0){case 0:{G=MVb(L)|0;b[C>>0]=G>>>0<256?G:(G|0)>0?255:0;M=1;break}case 1:{G=MVb(L)|0;b[C>>0]=(G+128|0)>>>0<256?G:(G|0)>0?127:128;M=1;break}case 2:{G=MVb(L)|0;d[C>>1]=G>>>0<65536?G:(G|0)>0?65535:0;M=2;break}case 3:{G=MVb(L)|0;d[C>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;M=2;break}case 4:{G=MVb(L)|0;f[C>>2]=G;M=4;break}case 5:{n[C>>2]=L;M=4;break}case 6:{p[C>>3]=L;M=8;break}case 7:{G=MVb(L)|0;f[C>>2]=G;M=4;break}default:{J=33;break a}}K=C+M|0;break}default:{f[k>>2]=0;f[t>>2]=0;m=aD(k,46)|0;o=208121;q=m+46|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));bO(-2,k,208006,201015,5077);bD(k);K=C}}G=(f[s>>2]|0)+16|0;f[s>>2]=G;if(G>>>0>=(f[v>>2]|0)>>>0)VW(c,1);G=F+-1|0;if(!G){J=42;break a}H=E+1|0;if((H|0)<(D|0)){C=K;E=H;F=G}else{N=K;O=G;break b}}}else{N=A;O=z}while(0);A=x+1|0;if((A|0)<(l|0)){x=A;y=N-g|0;z=O}else{P=O;break}}}else P=w;w=P;e=e+r|0}if((J|0)==22){f[k>>2]=0;f[k+4>>2]=0;m=aD(k,16)|0;o=269007;q=m+16|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));bO(-210,k,208006,201015,5021);bD(k);u=i;return}else if((J|0)==33){f[k>>2]=0;f[k+4>>2]=0;m=aD(k,16)|0;o=269007;q=m+16|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));bO(-210,k,208006,201015,5071);bD(k);u=i;return}else if((J|0)==42){if(!((x|0)==(l+-1|0)&(E|0)==(D+-1|0))){f[k>>2]=0;f[k+4>>2]=0;m=aD(k,60)|0;o=208168;q=m+60|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(q|0));bO(-201,k,208006,201015,5092);bD(k)}if(f[a>>2]|0){u=i;return}f[s>>2]=(f[s>>2]|0)+-16;u=i;return}}function RV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(!(h?(f[a>>2]|0)==1280131417:0)){i=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;j=aD(g,31)|0;k=201141;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(i,g,208396,201015,4626);bD(g)}if(f[a+8>>2]|0){m=a+236|0;n=f[m>>2]|0;_h[n&255](a,c,d);u=e;return}f[g>>2]=0;f[g+4>>2]=0;j=aD(g,38)|0;k=201190;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-2,g,208396,201015,4626);bD(g);m=a+236|0;n=f[m>>2]|0;_h[n&255](a,c,d);u=e;return}function SV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=f[c>>2]|0;c=f[a>>2]|0;a=f[b>>2]|0;if((d|0)>0)e=0;else{g=0;return g|0}while(1){b=(f[c+(e<<2)>>2]|0)-(f[a+(e<<2)>>2]|0)|0;e=e+1|0;if(b|0){g=b;h=4;break}if((e|0)>=(d|0)){g=0;h=4;break}}if((h|0)==4)return g|0;return 0}function TV(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+544|0;i=h+16|0;j=h+8|0;k=h;l=h+24|0;a:do if(d|0){m=d;b:while(1){n=f[m>>2]|0;if(!n)break a;o=f[n>>2]|0;if(o|0){p=0;q=o;r=0;while(1){p=p+1|0;if(!(gTb(c,q)|0))break b;o=p<<1;q=f[n+(o<<2)>>2]|0;if(!q)break;else r=o}}m=f[m+4>>2]|0;if(!m)break a}m=f[n+((r|1)<<2)>>2]|0;if(m|0){q=KU(m,l)|0;p=q<<1;if((q|0)>0){q=e;o=0;while(1){s=f[l+((o|1)<<2)>>2]|0;t=(s>>>3&511)+1<<(47696>>>(s<<1&14)&3);s=(q+-1+t&0-t)+(Y(t,f[l+(o<<2)>>2]|0)|0)|0;o=o+2|0;if((o|0)>=(p|0)){v=s;break}else q=s}}else v=e;if(!e){q=f[l+4>>2]|0;p=(q>>>3&511)+1<<(47696>>>(q<<1&14)&3);w=v+-1+p&0-p}else w=v;if((w|0)==(f[a+28>>2]|0)){x=m;u=h;return x|0}f[l>>2]=0;f[l+4>>2]=0;y=aD(l,71)|0;z=208995;A=y+71|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-209,l,209067,201015,5819);bD(l);x=m;u=h;return x|0}}while(0);w=f[a>>2]|0;v=f[a+28>>2]|0;if((w&4095|0)!=0|(v|0)==1){if(((w>>>3&511)+1<<(47696>>>(w<<1&14)&3)|0)==(v|0))B=w;else{f[l>>2]=0;f[l+4>>2]=0;y=aD(l,68)|0;z=209080;A=y+68|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-209,l,209067,201015,5825);bD(l);B=f[a>>2]|0}a=b[203503+(B&7)>>0]|0;f[k>>2]=(B>>>3&511)+1;f[k+4>>2]=a;_Ub(g,207091,k)|0;if(!(b[g+2>>0]|0))C=(b[g>>0]|0)==49;else C=0;x=g+(C&1)|0;u=h;return x|0}if((v|0)<=(e|0)){x=0;u=h;return x|0}C=v-e|0;if(!(C&3)){f[j>>2]=C>>>2;_Ub(g,208970,j)|0;x=g;u=h;return x|0}else{f[i>>2]=C;_Ub(g,208974,i)|0;x=g;u=h;return x|0}return 0}function UV(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+688|0;h=g+40|0;i=g+8|0;j=g;k=g+552|0;l=g+32|0;m=g+24|0;n=g+16|0;a:do if(d){o=d;b:while(1){p=f[o>>2]|0;if(!p){q=14;break a}r=f[p>>2]|0;if(r|0){s=0;t=r;v=0;while(1){s=s+1|0;if(!(gTb(208860,t)|0))break b;r=s<<1;t=f[p+(r<<2)>>2]|0;if(!t)break;else v=r}}o=f[o+4>>2]|0;if(!o){q=14;break a}}o=f[p+((v|1)<<2)>>2]|0;if(o){t=KU(o,h)|0;s=t<<1;if((t|0)>0){t=e;r=0;while(1){w=f[h+((r|1)<<2)>>2]|0;x=(w>>>3&511)+1<<(47696>>>(w<<1&14)&3);w=(t+-1+x&0-x)+(Y(x,f[h+(r<<2)>>2]|0)|0)|0;r=r+2|0;if((r|0)>=(s|0)){y=w;break}else t=w}}else y=e;if(!e){t=f[h+4>>2]|0;s=(t>>>3&511)+1<<(47696>>>(t<<1&14)&3);z=y+-1+s&0-s}else z=y;if((z|0)>(f[c+4>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;s=aD(h,74)|0;t=208870;r=s+74|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(r|0));bO(-209,h,208945,201015,5755);bD(h);A=o}else A=o}else q=14}else q=14;while(0);do if((q|0)==14){z=f[c+4>>2]|0;if((z|0)<=(e|0)){u=g;return}y=f[c>>2]|0;if(((y&-65536|0)==1117323264?(z|0)==88&(y&4094|0)==12:0)?(f[c+28>>2]|0)==8:0){f[l>>2]=0;f[l+4>>2]=0;f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];xV(a,351948,14,0,h);RV(a,422891,f[c+56>>2]|0);RV(a,208539,f[c+60>>2]|0);RV(a,434730,f[c+64>>2]|0);RV(a,434884,f[c+68>>2]|0);uT(a);RV(a,208964,f[c+72>>2]|0);u=g;return}if((y&-53248|0)==1117327360?((y&4095|0)==0?(f[c+28>>2]|0)==1:0):0){f[m>>2]=0;f[m+4>>2]=0;f[h>>2]=f[m>>2];f[h+4>>2]=f[m+4>>2];xV(a,208502,14,0,h);RV(a,422891,f[c+56>>2]|0);RV(a,208539,f[c+60>>2]|0);uT(a);u=g;return}y=z-e|0;if(!(y&3)){f[j>>2]=y>>>2;_Ub(k,208970,j)|0;A=k;break}else{f[i>>2]=y;_Ub(k,208974,i)|0;A=k;break}}while(0);zV(a,208860,A,0);f[n>>2]=0;f[n+4>>2]=0;f[h>>2]=f[n>>2];f[h+4>>2]=f[n+4>>2];xV(a,208978,13,0,h);yV(a,c+56|0,1,A);uT(a);u=g;return}function VV(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(!(h?(f[a>>2]|0)==1280131417:0)){i=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;j=aD(g,31)|0;k=201141;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(i,g,209694,201015,6708);bD(g)}if(!c){m=0;u=e;return m|0}if((f[c>>2]&16|0)!=0?(i=f[c+4>>2]|0,(i|0)!=0):0)n=i;else{f[g>>2]=0;f[g+4>>2]=0;j=aD(g,57)|0;k=209701;l=j+57|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-2,g,209694,201015,6714);bD(g);n=f[c+4>>2]|0}g=Uh[f[n+28>>2]&1023](a,c)|0;if(!d){m=g;u=e;return m|0}f[d>>2]=0;f[d+4>>2]=0;m=g;u=e;return m|0}function WV(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+288|0;j=i+24|0;k=i;f[k>>2]=e;f[k+4>>2]=g;g=i+160|0;e=i+16|0;l=i+8|0;f[e>>2]=0;f[e+4>>2]=0;f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];xV(a,c,6,206968,j);if((h|0)>-1)RV(a,209631,h);h=TV(d,207096,k,0,i+32|0)|0;b[g>>0]=0;c=f[d>>2]|0;if(c&16384|0){e=g+(kUb(g)|0)|0;m=e;b[m>>0]=32;b[m+1>>0]=99;b[m+2>>0]=108;b[m+3>>0]=111;m=e+4|0;b[m>>0]=115;b[m+1>>0]=101;b[m+2>>0]=100;b[m+3>>0]=0}if(c&32768|0){m=g+(kUb(g)|0)|0;b[m>>0]=b[209989]|0;b[m+1>>0]=b[209990]|0;b[m+2>>0]=b[209991]|0;b[m+3>>0]=b[209992]|0;b[m+4>>0]=b[209993]|0;b[m+5>>0]=b[209994]|0}if((c&12288|0)==4096){m=g+(kUb(g)|0)|0;b[m>>0]=b[209995]|0;b[m+1>>0]=b[209996]|0;b[m+2>>0]=b[209997]|0;b[m+3>>0]=b[209998]|0;b[m+4>>0]=b[209999]|0;b[m+5>>0]=b[21e4]|0;b[m+6>>0]=b[210001]|0}if((c&4095|0)==0?(f[d+28>>2]|0)!=1:0){c=g+(kUb(g)|0)|0;m=210002;e=c+9|0;do{b[c>>0]=b[m>>0]|0;c=c+1|0;m=m+1|0}while((c|0)<(e|0))}zV(a,208791,g+((b[g>>0]|0)!=0&1)|0,1);RV(a,210011,f[d+24>>2]|0);zV(a,207096,h,0);UV(a,d,k,56);f[l>>2]=0;f[l+4>>2]=0;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];xV(a,377867,13,0,j);j=d+52|0;d=f[j>>2]|0;if(!d){uT(a);uT(a);u=i;return}else n=d;while(1){yV(a,f[n+16>>2]|0,f[n+12>>2]|0,h);if((n|0)==(f[f[j>>2]>>2]|0)){o=15;break}n=f[n+4>>2]|0;if(!n){o=15;break}}if((o|0)==15){uT(a);uT(a);u=i;return}}function XV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+1056|0;e=d+8|0;g=d;h=f[c>>2]|0;i=(h|0)==0?1124530:h;h=f[c+4>>2]|0;c=i+h|0;j=h+1|0;h=e+8|0;f[e>>2]=h;k=e+4|0;f[k>>2]=j;if(j>>>0>1032){l=N5b(j)|0;f[e>>2]=l;m=l}else m=h;l=c+-1|0;a:do if(l>>>0>=i>>>0){j=l;n=c;b:while(1){o=j;p=n;c:while(1){switch(b[o>>0]|0){case 58:case 47:case 92:{q=p;break b;break}case 46:{if(!(b[n>>0]|0))break c;if(!(tVb(n,210240,3)|0))break c;break}default:{}}r=o+-1|0;if(r>>>0<i>>>0){q=o;break b}else{s=o;o=r;p=s}}j=o+-1|0;if(j>>>0<i>>>0){t=o;v=o;w=11;break a}else n=o}if((q|0)==(n|0)){t=n;v=q;w=11}else{x=n;y=q;z=m}}else{t=c;v=c;w=11}while(0);if((w|0)==11){f[g>>2]=0;f[g+4>>2]=0;c=aD(g,16)|0;m=210244;q=c+16|0;do{b[c>>0]=b[m>>0]|0;c=c+1|0;m=m+1|0}while((c|0)<(q|0));bO(-5,g,210261,201015,157);bD(g);x=t;y=v;z=f[e>>2]|0}v=b[y>>0]|0;if(((v&-33)+-65&255)<26|v<<24>>24==95)A=z;else{b[z>>0]=95;A=z+1|0}if(y>>>0<x>>>0){z=A;v=y;while(1){y=b[v>>0]|0;v=v+1|0;t=z+1|0;b[z>>0]=y<<24>>24==95|(y<<24>>24==45|((y+-48&255)<10|((y&-33)+-65&255)<26))?y:95;if((v|0)==(x|0)){B=t;break}else z=t}}else B=A;b[B>>0]=0;B=f[e>>2]|0;if(gTb(B,206295)|0){f[a>>2]=0;f[a+4>>2]=0;if(B|0)w=19}else{A=B;z=A;b[z>>0]=117;b[z+1>>0]=110;b[z+2>>0]=110;b[z+3>>0]=97;z=A+4|0;b[z>>0]=109;b[z+1>>0]=101;b[z+2>>0]=100;b[z+3>>0]=0;f[a>>2]=0;f[a+4>>2]=0;w=19}if((w|0)==19?(w=kUb(B)|0,w|0):0)Vac(aD(a,w)|0,B|0,w|0)|0;w=f[e>>2]|0;if((w|0)==(h|0)){u=d;return}if(w|0)P5b(w);f[e>>2]=h;f[k>>2]=1032;u=d;return}function YV(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;g=(a|0)!=0;if(!(g?(f[a>>2]|0)==1280131417:0)){h=g?-5:-27;f[e>>2]=0;f[e+4>>2]=0;g=aD(e,31)|0;i=201141;j=g+31|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));bO(h,e,210282,201015,924);bD(e)}e=f[a+32>>2]|0;if(!e){k=0;u=d;return k|0}if((f[e+24>>2]|0)>>>0<=c>>>0){k=0;u=d;return k|0}k=KW(e,c)|0;u=d;return k|0}function ZV(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(!(h?(f[a>>2]|0)==1280131417:0)){i=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;j=aD(g,31)|0;k=201141;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(i,g,210300,201015,4634);bD(g)}if(f[a+8>>2]|0){m=a+240|0;n=f[m>>2]|0;ai[n&31](a,c,d);u=e;return}f[g>>2]=0;f[g+4>>2]=0;j=aD(g,38)|0;k=201190;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-2,g,210300,201015,4634);bD(g);m=a+240|0;n=f[m>>2]|0;ai[n&31](a,c,d);u=e;return}function _V(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=(a|0)!=0;if(!(h?(f[a>>2]|0)==1280131417:0)){i=h?-5:-27;f[g>>2]=0;f[g+4>>2]=0;j=aD(g,31)|0;k=201141;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(i,g,210312,201015,4650);bD(g)}if(f[a+8>>2]|0){m=a+248|0;n=f[m>>2]|0;_h[n&255](a,c,d);u=e;return}f[g>>2]=0;f[g+4>>2]=0;j=aD(g,38)|0;k=201190;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-2,g,210312,201015,4650);bD(g);m=a+248|0;n=f[m>>2]|0;_h[n&255](a,c,d);u=e;return}function $V(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0;i=u;u=u+48|0;j=i;f[j>>2]=0;f[j+4>>2]=40;f[j+16>>2]=b;f[j+12>>2]=0;f[j+8>>2]=0;f[j+20>>2]=c;f[j+24>>2]=d;f[j+36>>2]=h;f[j+28>>2]=e;f[j+32>>2]=g;cV(j);f[a>>2]=f[125813];u=i;return}function aW(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;e=aD(d,19)|0;g=209479;h=e+19|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-27,d,210327,201015,6668);bD(d)}i=f[a>>2]|0;if(!i){u=c;return}j=f[125813]|0;a:do if(!j)k=7;else{l=j;while(1){if(di[f[l+20>>2]&1023](i)|0){m=l;break a}l=f[l+12>>2]|0;if(!l){k=7;break}}}while(0);if((k|0)==7){f[d>>2]=0;f[d+4>>2]=0;e=aD(d,19)|0;g=210337;h=e+19|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-2,d,210327,201015,6674);bD(d);m=0}k=m+24|0;m=f[k>>2]|0;if(!m){f[d>>2]=0;f[d+4>>2]=0;e=aD(d,32)|0;g=210357;h=e+32|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-2,d,210327,201015,6676);bD(d);n=f[k>>2]|0}else n=m;bi[n&2047](a);f[a>>2]=0;u=c;return}function bW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+16|0;h=g+8|0;i=g;j=(a|0)!=0;if(!(j?(f[a>>2]|0)==1280131417:0)){k=j?-5:-27;f[h>>2]=0;f[h+4>>2]=0;l=aD(h,31)|0;m=201141;n=l+31|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(k,h,210390,201015,6731);bD(h)}if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;l=aD(h,38)|0;m=201190;n=l+38|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-2,h,210390,201015,6731);bD(h)}a:do if(d){k=f[125813]|0;if(!k)o=11;else{j=k;while(1){if(di[f[j+20>>2]&1023](d)|0){p=j;break a}j=f[j+12>>2]|0;if(!j){o=11;break}}}}else{f[h>>2]=0;f[h+4>>2]=0;l=aD(h,34)|0;m=210398;n=l+34|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-27,h,210390,201015,6734);bD(h);o=11}while(0);if((o|0)==11){f[h>>2]=0;f[h+4>>2]=0;l=aD(h,14)|0;m=210433;n=l+14|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-5,h,210390,201015,6738);bD(h);p=0}o=p+32|0;p=f[o>>2]|0;if(p|0){q=p;r=e;s=r;t=f[s>>2]|0;v=r+4|0;w=v;x=f[w>>2]|0;y=i;z=y;f[z>>2]=t;A=y+4|0;B=A;f[B>>2]=x;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];th[q&511](a,c,d,h);u=g;return}f[h>>2]=0;f[h+4>>2]=0;l=aD(h,39)|0;m=210448;n=l+39|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-5,h,210390,201015,6741);bD(h);q=f[o>>2]|0;r=e;s=r;t=f[s>>2]|0;v=r+4|0;w=v;x=f[w>>2]|0;y=i;z=y;f[z>>2]=t;A=y+4|0;B=A;f[B>>2]=x;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];th[q&511](a,c,d,h);u=g;return}function cW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+80|0;h=g+76|0;i=g+40|0;j=g+8|0;k=g;f[h>>2]=0;l=GT(a,c,0,0)|0;f[i>>2]=47120;a=i+4|0;m=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if(!l){f[a>>2]=0;f[m>>2]=l;f[i+32>>2]=0;n=0;nT(i);u=g;return n|0}o=L5b(16)|0;f[o+4>>2]=1;f[o>>2]=47172;f[o+8>>2]=l;f[a>>2]=o;f[m>>2]=l;f[i+32>>2]=l|0?6:0;if(!(b[l+300>>0]|0)){n=0;nT(i);u=g;return n|0}a:do if(!d){o=f[l+32>>2]|0;if((f[o+24>>2]|0)>0){a=k+4|0;p=j+12|0;q=j+20|0;r=0;s=o;b:while(1){o=KW(s,r)|0;if(!o){f[k>>2]=0;f[a>>2]=0;t=aD(k,10)|0;v=210488;w=t+10|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,k,210499,201015,6795);bD(k)}c:do if((f[o>>2]&7|0)==6){x=f[o+8>>2]|0;MW(x,j,0);y=x+24|0;z=f[y>>2]|0;if((z|0)>0){A=x+28|0;x=0;B=z;while(1){C=f[p>>2]|0;if((f[C>>2]|0)>-1)break;z=C+(f[A>>2]|0)|0;f[p>>2]=z;if(z>>>0<(f[q>>2]|0)>>>0)D=B;else{VW(j,1);D=f[y>>2]|0}x=x+1|0;if((x|0)>=(D|0)){E=0;F=0;break c}else B=D}E=8;F=C}else{E=0;F=0}}else{E=1;F=o}while(0);switch(E&15){case 8:{G=F;H=20;break a;break}case 0:break;default:break b}r=r+1|0;s=f[(f[m>>2]|0)+32>>2]|0;if((r|0)>=(f[s+24>>2]|0)){G=F;H=20;break a}}if(!E){G=F;H=20}else{n=0;nT(i);u=g;return n|0}}else H=21}else{G=MV(l,0,d)|0;H=20}while(0);if((H|0)==20)if(G)if(!(f[G>>2]&64)){I=G;J=0}else{I=G;J=f[(f[G+16>>2]|0)+8>>2]|0}else H=21;if((H|0)==21){f[j>>2]=0;f[j+4>>2]=0;t=aD(j,44)|0;v=210506;w=t+44|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-204,j,210499,201015,6820);bD(j);I=0;J=0}H=VV(f[m>>2]|0,I,0)|0;f[h>>2]=H;do if(!((c|0)!=0|(H|0)==0)){if((f[H>>2]&-65536|0)!=1117323264?(f[H>>2]&-65536|0)!=1117257728:0)break;f[j>>2]=0;f[j+4>>2]=0;t=aD(j,78)|0;v=210551;w=t+78|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-27,j,210499,201015,6828);bD(j)}while(0);if((LO()|0)<0){aW(h);K=0}else K=J;do if(e|0)if(!K){f[e>>2]=0;break}else{J=VC(kUb(K)|0)|0;f[e>>2]=J;Vac(J|0,K|0,kUb(K)|0)|0;break}while(0);n=f[h>>2]|0;nT(i);u=g;return n|0}function dW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a>>2]=47120;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;pT(a,b,c,d)|0;return}function eW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;f[a>>2]=47120;d=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;if((b|0)==0|c^1)e=0;else{c=L5b(16)|0;f[c+4>>2]=1;f[c>>2]=47172;f[c+8>>2]=b;e=c}f[d>>2]=e;f[a+8>>2]=b;f[a+32>>2]=b|0?6:0;return}function fW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if(di[f[(f[b>>2]|0)+12>>2]&1023](b)|0){d=f[b+8>>2]|0;e=YV(d,c)|0;g=d}else{e=0;g=0}f[a>>2]=g;f[a+4>>2]=e;return}function gW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d+8|0;i=d;j=d+24|0;k=f[c>>2]|0;l=(k|0)==0?1124530:k;if(!((di[f[(f[a>>2]|0)+12>>2]&1023](a)|0)&(l|0)!=0)){u=d;return a|0}k=b[l>>0]|0;switch(k<<24>>24){case 93:case 125:{m=a+20|0;n=a+24|0;o=f[n>>2]|0;if((f[m>>2]|0)==(o|0)){f[i>>2]=k<<24>>24;hO(e,210630,i);bO(-2,e,489622,201015,6957);bD(e);p=b[l>>0]|0;q=f[n>>2]|0}else{p=k;q=o}o=b[q+-1>>0]|0;if(((p<<24>>24==93?91:123)|0)==(o|0))r=q;else{f[h>>2]=p<<24>>24;f[h+4>>2]=o;hO(e,210649,h);bO(-2,e,489622,201015,6960);bD(e);r=f[n>>2]|0}h=r+-1|0;f[n>>2]=h;if((f[m>>2]|0)==(h|0))s=6;else s=(b[r+-2>>0]|0)==123?6:1;f[a+32>>2]=s;uT(f[a+8>>2]|0);f[e>>2]=0;s=e+4|0;f[s>>2]=0;r=a+12|0;if((e|0)!=(r|0)){bD(r);h=f[e>>2]|0;if(!h)t=0;else{m=h+-4|0;f[m>>2]=(f[m>>2]|0)+1;t=f[e>>2]|0}f[r>>2]=t;f[a+16>>2]=f[s>>2]}bD(e);u=d;return a|0}default:{}}s=a+32|0;t=f[s>>2]|0;if((t|0)==6){if(!(((k&-33)+-65&255)<26|k<<24>>24==95)){f[g>>2]=l;hO(e,210698,g);bO(-2,e,489622,201015,6970);bD(e)}g=a+12|0;if((g|0)!=(c|0)){bD(g);r=f[c>>2]|0;if(!r)v=0;else{m=r+-4|0;f[m>>2]=(f[m>>2]|0)+1;v=f[c>>2]|0}f[g>>2]=v;f[a+16>>2]=f[c+4>>2]}f[s>>2]=5;u=d;return a|0}if((t&3|0)!=1){f[e>>2]=0;f[e+4>>2]=0;t=aD(e,16)|0;v=210724;g=t+16|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(g|0));bO(-2,e,489622,201015,7e3);bD(e);u=d;return a|0}switch(k<<24>>24){case 91:case 123:break;default:{a:do if(k<<24>>24==92){v=l+1|0;switch(b[v>>0]|0){case 93:case 91:case 125:case 123:break;default:{w=45;break a}}f[e>>2]=0;f[e+4>>2]=0;t=kUb(v)|0;if(t|0)Vac(aD(e,t)|0,v|0,t|0)|0}else w=45;while(0);if((w|0)==45?(w=f[c>>2]|0,f[e>>2]=w,f[e+4>>2]=f[c+4>>2],w|0):0){c=w+-4|0;f[c>>2]=(f[c>>2]|0)+1}if(!(f[a+16>>2]|0))x=0;else{c=f[a+12>>2]|0;x=(c|0)==0?1124530:c}c=f[e>>2]|0;zV(f[a+8>>2]|0,x,(c|0)==0?1124530:c,0);bD(e);if((f[s>>2]|0)!=5){u=d;return a|0}f[s>>2]=6;u=d;return a|0}}c=a+20|0;x=a+24|0;w=f[x>>2]|0;t=a+28|0;v=f[t>>2]|0;g=v;if((w|0)==(v|0)){v=f[c>>2]|0;m=w-v|0;r=m+1|0;h=v;if((r|0)<0)c4b(c);n=g-v|0;g=n<<1;o=n>>>0<1073741823?(g>>>0<r>>>0?r:g):2147483647;if(!o){y=0;z=k}else{g=L5b(o)|0;y=g;z=b[l>>0]|0}g=y+m|0;b[g>>0]=z;z=g+(0-m)|0;if((m|0)>0)Vac(z|0,h|0,m|0)|0;f[c>>2]=z;f[x>>2]=g+1;f[t>>2]=y+o;if(v|0)O5b(h)}else{b[w>>0]=k;f[x>>2]=(f[x>>2]|0)+1}x=l+1|0;k=(b[l>>0]|0)==123;w=k?6:5;f[s>>2]=k?6:1;k=(b[x>>0]|0)==58;s=k?l+2|0:x;x=f[a+8>>2]|0;l=a+12|0;h=a+16|0;if(!(f[h>>2]|0))A=0;else{v=f[l>>2]|0;A=(v|0)==0?1124530:v}v=b[s>>0]|0?s:0;f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];xV(x,A,k?w|8:w,v,e);f[e>>2]=0;v=e+4|0;f[v>>2]=0;if((e|0)!=(l|0)){bD(l);w=f[e>>2]|0;if(!w)B=0;else{k=w+-4|0;f[k>>2]=(f[k>>2]|0)+1;B=f[e>>2]|0}f[l>>2]=B;f[h>>2]=f[v>>2]}bD(e);u=d;return a|0}function hW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;if(!(di[f[(f[a>>2]|0)+12>>2]&1023](a)|0)){u=g;return}i=f[c>>2]|0;j=(i|0)==0?1124530:i;k=b[j>>0]|0;if((k+-48&255)<10){l=b[j+1>>0]|0;m=(k<<24>>24)+-48|0}else{l=k;m=1}switch(l<<24>>24){case 99:case 117:{n=1;break}case 119:{n=2;break}case 115:{n=2;break}case 105:{n=4;break}case 102:{n=4;break}case 100:{n=8;break}default:n=l<<24>>24==114?4:0}l=Y(n,m)|0;if(!((e>>>0)%(l>>>0)|0))o=i;else{f[h>>2]=0;f[h+4>>2]=0;i=aD(h,19)|0;m=210741;n=i+19|0;do{b[i>>0]=b[m>>0]|0;i=i+1|0;m=m+1|0}while((i|0)<(n|0));bO(-215,h,210761,201015,7011);bD(h);o=f[c>>2]|0}yV(f[a+8>>2]|0,d,(e>>>0)/(l>>>0)|0,(o|0)==0?1124530:o);u=g;return}function iW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b+8>>2]|0;b=f[c>>2]|0;c=MV(d,0,(b|0)==0?1124530:b)|0;f[a>>2]=d;f[a+4>>2]=c;return}function jW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[b>>2]|0;e=MV(d,f[b+4>>2]|0,c)|0;f[a>>2]=d;f[a+4>>2]=e;return}function kW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=a+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;if((b|0)!=0&(c|0)!=0?(g=f[c>>2]|0,h=g&7,h|0):0){f[a>>2]=b;b=a+4|0;f[b>>2]=c;a:do if((g&16|0)==0&(h+-5|0)>>>0<2){i=c+8|0;MW(f[i>>2]|0,e,0);j=f[c>>2]|0;switch(j&7){case 6:{k=f[(f[i>>2]|0)+60>>2]|0;break a;break}case 5:{k=f[(f[i>>2]|0)+24>>2]|0;break a;break}default:{k=(j&7|0)!=0&1;break a}}}else{f[a+20>>2]=c;f[a+12>>2]=0;k=1}while(0);c=a+40|0;f[c>>2]=k;if(!d)return;if((d|0)>0)l=(k|0)<(d|0)?k:d;else{h=f[b>>2]|0;b:do if(!h){m=0;n=17}else{b=f[h>>2]|0;switch(b&7){case 6:{o=f[(f[h+8>>2]|0)+60>>2]|0;break b;break}case 5:{o=f[(f[h+8>>2]|0)+24>>2]|0;break b;break}default:{m=(b&7|0)!=0;n=17;break b}}}while(0);if((n|0)==17)o=m&1;m=k-d|0;l=k-(o>>>0<m>>>0?o:m)|0}f[c>>2]=k-l;if(!(f[a+12>>2]|0))return;NW(e,l,1);return}f[a>>2]=0;f[a+4>>2]=0;f[a+40>>2]=0;return}function lW(a){a=a|0;var b=0,c=0,d=0;b=f[a+4>>2]|0;a:do if(!b)c=0;else{a=f[b>>2]|0;switch(a&7){case 6:{d=f[(f[b+8>>2]|0)+60>>2]|0;return d|0}case 5:{d=f[(f[b+8>>2]|0)+24>>2]|0;return d|0}default:{c=(a&7|0)!=0;break a}}}while(0);d=c&1;return d|0}function mW(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+40|0;c=f[b>>2]|0;if(!c)return a|0;d=a+8|0;e=f[a+12>>2]|0;if((e|0)!=0?(g=a+20|0,h=(f[g>>2]|0)+(f[e+28>>2]|0)|0,f[g>>2]=h,h>>>0>=(f[a+28>>2]|0)>>>0):0){VW(d,1);i=f[b>>2]|0}else i=c;f[b>>2]=i+-1;return a|0}function nW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+16|0;h=g;i=f[a>>2]|0;if(!i){u=g;return a|0}j=a+4|0;if(!(f[j>>2]|0)){u=g;return a|0}k=a+40|0;l=f[k>>2]|0;if(!l){u=g;return a|0}m=f[c>>2]|0;n=(m|0)==0?1124530:m;o=b[n>>0]|0;if((o+-48&255)<10){p=(o<<24>>24)+-48|0;q=b[n+1>>0]|0}else{p=1;q=o}switch(q<<24>>24){case 99:case 117:{r=1;break}case 119:{r=2;break}case 115:{r=2;break}case 105:{r=4;break}case 102:{r=4;break}case 100:{r=8;break}default:r=q<<24>>24==114?4:0}if(!(Y(r,p)|0)){f[h>>2]=0;f[h+4>>2]=0;r=aD(h,13)|0;q=210770;o=r+13|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(o|0));bO(-215,h,210784,201015,7205);bD(h);s=f[k>>2]|0;t=f[c>>2]|0;v=f[a>>2]|0}else{s=l;t=m;v=i}i=s>>>0>e>>>0?e:s;if(!(f[a+12>>2]|0)){NV(v,f[j>>2]|0,d,(t|0)==0?1124530:t);w=0}else{QV(v,a+8|0,i,d,(t|0)==0?1124530:t);t=Y(i,p)|0;w=(f[k>>2]|0)-t|0}f[k>>2]=w;u=g;return a|0}function oW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[a+8>>2]|0;if(!(f[b+4>>2]|0)){e=0;RV(d,e,c);return}a=f[b>>2]|0;e=(a|0)==0?1124530:a;RV(d,e,c);return}function pW(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;if(!(f[b+4>>2]|0))d=0;else{e=f[b>>2]|0;d=(e|0)==0?1124530:e}ZV(f[a+8>>2]|0,d,c);return}function qW(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=f[a+8>>2]|0;if(!(f[b+4>>2]|0)){e=0;ZV(d,e,c);return}a=f[b>>2]|0;e=(a|0)==0?1124530:a;ZV(d,e,c);return}function rW(a,b){a=a|0;b=b|0;RV(f[a+8>>2]|0,0,b);return}function sW(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;i=h+8|0;j=h;f[a>>2]=c;k=f[c+8>>2]|0;if(!(f[d+4>>2]|0))l=0;else{c=f[d>>2]|0;l=(c|0)==0?1124530:c}if(!(f[g+4>>2]|0))m=0;else{c=f[g>>2]|0;m=(c|0)==0?1124530:c}f[j>>2]=0;f[j+4>>2]=0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];xV(k,l,e,m,i);f[i>>2]=0;m=i+4|0;f[m>>2]=0;l=f[a>>2]|0;k=l+12|0;if((i|0)!=(k|0)){bD(k);j=f[i>>2]|0;if(!j)n=0;else{c=j+-4|0;f[c>>2]=(f[c>>2]|0)+1;n=f[i>>2]|0}f[k>>2]=n;f[l+16>>2]=f[m>>2]}bD(i);i=f[a>>2]|0;a=i+32|0;if((e&7|0)==5){f[a>>2]=1;e=i+20|0;m=i+24|0;l=f[m>>2]|0;n=i+28|0;k=f[n>>2]|0;if((l|0)!=(k|0)){b[l>>0]=91;f[m>>2]=(f[m>>2]|0)+1;u=h;return}c=f[e>>2]|0;j=l-c|0;l=j+1|0;g=c;if((l|0)<0)c4b(e);d=k-c|0;k=d<<1;o=d>>>0<1073741823?(k>>>0<l>>>0?l:k):2147483647;if(!o)p=0;else p=L5b(o)|0;k=p+j|0;b[k>>0]=91;l=k+(0-j)|0;if((j|0)>0)Vac(l|0,g|0,j|0)|0;f[e>>2]=l;f[m>>2]=k+1;f[n>>2]=p+o;if(!c){u=h;return}O5b(g);u=h;return}else{f[a>>2]=6;a=i+20|0;g=i+24|0;c=f[g>>2]|0;o=i+28|0;i=f[o>>2]|0;if((c|0)!=(i|0)){b[c>>0]=123;f[g>>2]=(f[g>>2]|0)+1;u=h;return}p=f[a>>2]|0;n=c-p|0;c=n+1|0;k=p;if((c|0)<0)c4b(a);m=i-p|0;i=m<<1;l=m>>>0<1073741823?(i>>>0<c>>>0?c:i):2147483647;if(!l)q=0;else q=L5b(l)|0;i=q+n|0;b[i>>0]=123;c=i+(0-n)|0;if((n|0)>0)Vac(c|0,k|0,n|0)|0;f[a>>2]=c;f[g>>2]=i+1;f[o>>2]=q+l;if(!p){u=h;return}O5b(k);u=h;return}}function tW(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;uT(f[(f[a>>2]|0)+8>>2]|0);e=f[a>>2]|0;a=e+24|0;g=f[a>>2]|0;h=g+-1|0;f[a>>2]=h;if((f[e+20>>2]|0)==(h|0))i=6;else i=(b[g+-2>>0]|0)==123?6:1;f[e+32>>2]=i;f[d>>2]=0;i=d+4|0;f[i>>2]=0;g=e+12|0;if((d|0)==(g|0)){bD(d);u=c;return}bD(g);h=f[d>>2]|0;if(!h)j=0;else{a=h+-4|0;f[a>>2]=(f[a>>2]|0)+1;j=f[d>>2]|0}f[g>>2]=j;f[e+16>>2]=f[i>>2];bD(d);u=c;return}function uW(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if(!b){c=0;return c|0}c=f[b>>2]&7;return c|0}function vW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[a+4>>2]|0;if(d)if((f[d>>2]&7|0)==1)e=f[d+8>>2]|0;else e=2147483647;else e=c;f[b>>2]=e;return}function wW(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0.0;d=f[a+4>>2]|0;a:do if(!d)e=c;else switch(f[d>>2]&7){case 1:{e=+(f[d+8>>2]|0);break a;break}case 2:{e=+p[d+8>>3];break a;break}default:{e=3402823466385288598117041.0e14;break a}}while(0);n[b>>2]=e;return}function xW(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0.0;d=f[a+4>>2]|0;a:do if(!d)e=c;else switch(f[d>>2]&7){case 1:{e=+(f[d+8>>2]|0);break a;break}case 2:{e=+p[d+8>>3];break a;break}default:{e=1797693134862315708145274.0e284;break a}}while(0);p[b>>3]=e;return}function yW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a+4>>2]|0;do if(!g){a=f[c>>2]|0;f[e>>2]=a;f[e+4>>2]=f[c+4>>2];if(a|0){h=a+-4|0;f[h>>2]=(f[h>>2]|0)+1}}else{if((f[g>>2]&7|0)!=3){f[e>>2]=0;f[e+4>>2]=0;break}h=f[g+8+4>>2]|0;f[e>>2]=0;f[e+4>>2]=0;if(h|0?(a=kUb(h)|0,a|0):0)Vac(aD(e,a)|0,h|0,a|0)|0}while(0);if((e|0)==(b|0)){bD(e);u=d;return}bD(b);g=f[e>>2]|0;if(!g)i=0;else{c=g+-4|0;f[c>>2]=(f[c>>2]|0)+1;i=f[e>>2]|0}f[b>>2]=i;f[b+4>>2]=f[e+4>>2];bD(e);u=d;return}function zW(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=VC(24)|0;if(!d){f[c>>2]=0;f[c+4>>2]=0;bO(-27,c,210792,210810,92);bD(c)}c=d+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[d>>2]=1116274688;f[d+16>>2]=(a|0)<1?65408:a+7&-8;u=b;return d|0}function AW(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;bO(-27,c,210883,210810,121);bD(c)}d=f[a+16>>2]|0;e=VC(24)|0;if(!e){f[c>>2]=0;f[c+4>>2]=0;bO(-27,c,210792,210810,92);bD(c)}c=e+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[e>>2]=1116274688;f[e+16>>2]=(d|0)<1?65408:d+7&-8;f[e+12>>2]=a;u=b;return e|0}function BW(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;bO(-27,c,210907,210810,183);bD(c)}c=f[a>>2]|0;f[a>>2]=0;if(!c){u=b;return}a=c+12|0;d=f[a>>2]|0;if(!d)e=0;else e=f[d+8>>2]|0;g=c+4|0;h=f[g>>2]|0;a:do if(!h)i=c+20|0;else{j=c+16|0;k=c+20|0;l=e;m=h;n=d;while(1){o=m+4|0;p=f[o>>2]|0;if(!n){q=m;r=p;while(1){WC(q);if(!r){i=k;break a}s=f[a>>2]|0;t=r+4|0;v=f[t>>2]|0;if(!s){w=r;r=v;q=w}else{x=r;y=v;z=t;A=s;break}}}else{x=m;y=p;z=o;A=n}if(!l){f[A+8>>2]=x;f[A+4>>2]=x;f[z>>2]=0;f[x>>2]=0;f[k>>2]=(f[j>>2]|0)+-8}else{f[x>>2]=l;r=l+4|0;q=f[r>>2]|0;f[z>>2]=q;if(q|0)f[q>>2]=x;f[r>>2]=x}if(!y){i=k;break}else{l=x;m=y;n=A}}}while(0);f[g>>2]=0;f[c+8>>2]=0;f[i>>2]=0;WC(c);u=b;return}function CW(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;bO(-27,c,210927,210810,200);bD(c)}c=f[a+12>>2]|0;d=a+4|0;e=f[d>>2]|0;if(!c){f[a+8>>2]=e;if(!e)g=0;else g=(f[a+16>>2]|0)+-8|0;f[a+20>>2]=g;u=b;return}if(!e)h=a+20|0;else{g=a+16|0;i=a+20|0;j=c+8|0;k=c+4|0;l=f[c+8>>2]|0;c=e;while(1){e=c+4|0;m=f[e>>2]|0;if(!l){f[j>>2]=c;f[k>>2]=c;f[e>>2]=0;f[c>>2]=0;f[i>>2]=(f[g>>2]|0)+-8}else{f[c>>2]=l;n=l+4|0;o=f[n>>2]|0;f[e>>2]=o;if(o|0)f[o>>2]=c;f[n>>2]=c}if(!m){h=i;break}else{n=c;c=m;l=n}}}f[d>>2]=0;f[a+8>>2]=0;f[h>>2]=0;u=b;return}function DW(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0&(b|0)!=0)){f[d>>2]=0;f[d+4>>2]=0;bO(-27,d,210945,210810,276);bD(d)}f[b>>2]=f[a+8>>2];f[b+4>>2]=f[a+20>>2];u=c;return}function EW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0&(b|0)!=0)){f[d>>2]=0;f[d+4>>2]=0;bO(-27,d,210965,210810,288);bD(d)}e=b+4|0;g=f[e>>2]|0;h=a+16|0;if((g|0)>(f[h>>2]|0)){f[d>>2]=0;f[d+4>>2]=0;bO(-201,d,210965,210810,290);bD(d);i=f[e>>2]|0}else i=g;g=f[b>>2]|0;b=a+8|0;f[b>>2]=g;e=a+20|0;f[e>>2]=i;if(g|0){u=c;return}g=f[a+4>>2]|0;f[b>>2]=g;if(!g)j=0;else j=(f[h>>2]|0)+-8|0;f[e>>2]=j;u=c;return}function FW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,20)|0;h=255176;i=g+20|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-27,e,210988,210810,327);bD(e)}if((c|0)<0){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,35)|0;h=211006;i=g+35|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-211,e,210988,210810,330);bD(e)}j=a+20|0;k=f[j>>2]|0;l=a+16|0;if(k>>>0>=c>>>0){m=k;n=a+8|0;o=f[n>>2]|0;p=f[l>>2]|0;q=o+p|0;r=0-m|0;s=q+r|0;t=m-c|0;v=t&-8;f[j>>2]=v;u=d;return s|0}if(((f[l>>2]|0)+-8&-8)>>>0<c>>>0){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,37)|0;h=211042;i=g+37|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-211,e,210988,210810,338);bD(e)}GW(a);m=f[j>>2]|0;n=a+8|0;o=f[n>>2]|0;p=f[l>>2]|0;q=o+p|0;r=0-m|0;s=q+r|0;t=m-c|0;v=t&-8;f[j>>2]=v;u=d;return s|0}function GW(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;bO(-27,c,211080,210810,218);bD(c)}d=a+8|0;e=f[d>>2]|0;if((e|0)!=0?(g=f[e+4>>2]|0,(g|0)!=0):0)h=g;else{g=f[a+12>>2]|0;if(!g)i=VC(f[a+16>>2]|0)|0;else{e=g+8|0;f[c>>2]=f[e>>2];j=g+20|0;f[c+4>>2]=f[j>>2];GW(g);k=f[e>>2]|0;EW(g,c);c=f[e>>2]|0;l=c;if((k|0)!=(c|0)){m=k+4|0;f[c+4>>2]=f[m>>2];c=f[m>>2]|0;if(c|0)f[c>>2]=l}else{f[g+4>>2]=0;f[e>>2]=0;f[j>>2]=0}i=k}f[i+4>>2]=0;k=f[d>>2]|0;f[i>>2]=k;if(!k){f[a+4>>2]=i;n=d}else n=k+4|0;f[n>>2]=i;i=f[(f[d>>2]|0)+4>>2]|0;if(!i){o=a+16|0;p=f[o>>2]|0;q=p+-8|0;r=a+20|0;f[r>>2]=q;u=b;return}else h=i}f[d>>2]=h;o=a+16|0;p=f[o>>2]|0;q=p+-8|0;r=a+20|0;f[r>>2]=q;u=b;return}function HW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=a;f[g>>2]=0;f[g+4>>2]=0;if((e|0)>-1)h=e;else h=kUb(d)|0;f[a>>2]=h;e=FW(c,h+1|0)|0;f[a+4>>2]=e;Vac(e|0,d|0,h|0)|0;b[e+h>>0]=0;return}function IW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g;if(!e){f[h>>2]=0;f[h+4>>2]=0;bO(-27,h,211098,210810,377);bD(h)}if(c>>>0<56|(d|0)==0){f[h>>2]=0;f[h+4>>2]=0;bO(-201,h,211098,210810,379);bD(h)}i=FW(e,c)|0;Nac(i|0,0,c|0)|0;f[i+4>>2]=c;f[i>>2]=a&65535|1117323264;c=(a>>>3&511)+1<<(47696>>>(a<<1&14)&3);a:do if(c|0){switch(a&4095){case 0:case 7:{break a;break}default:{}}if((c|0)!=(d|0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,110)|0;k=211110;l=j+110|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-201,h,211098,210810,395);bD(h)}}while(0);f[i+28>>2]=d;f[i+44>>2]=e;JW(i,1024/(d>>>0)|0);u=g;return i|0}function JW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0?(f[a+44>>2]|0)!=0:0)){f[e>>2]=0;f[e+4>>2]=0;bO(-27,e,211221,210810,415);bD(e)}if((c|0)<0){f[e>>2]=0;f[e+4>>2]=0;bO(-211,e,211221,210810,417);bD(e)}g=(f[(f[a+44>>2]|0)+16>>2]|0)+-28&-8;h=f[a+28>>2]|0;if(!c){i=1024/(h|0)|0;j=(i|0)>1?i:1}else j=c;if((Y(j,h)|0)<=(g|0)){k=j;l=a+40|0;f[l>>2]=k;u=d;return}j=(g|0)/(h|0)|0;if(j|0){k=j;l=a+40|0;f[l>>2]=k;u=d;return}f[e>>2]=0;f[e+4>>2]=0;j=aD(e,60)|0;h=211239;g=j+60|0;do{b[j>>0]=b[h>>0]|0;j=j+1|0;h=h+1|0}while((j|0)<(g|0));bO(-211,e,211221,210810,433);bD(e);k=0;l=a+40|0;f[l>>2]=k;u=d;return}function KW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[a+24>>2]|0;if(c>>>0<=b>>>0){d=((b|0)<0?c:0)+b|0;e=d-((d|0)>=(c|0)?c:0)|0;if(e>>>0<c>>>0)g=e;else{h=0;return h|0}}else g=b;b=f[a+52>>2]|0;if((g<<1|0)<=(c|0)){e=f[b+12>>2]|0;if((g|0)<(e|0)){i=b;j=g}else{d=b;k=g;l=e;while(1){e=f[d+4>>2]|0;m=k-l|0;l=f[e+12>>2]|0;if((m|0)<(l|0)){i=e;j=m;break}else{d=e;k=m}}}}else{k=c;c=b;do{c=f[c>>2]|0;k=k-(f[c+12>>2]|0)|0}while((g|0)<(k|0));i=c;j=g-k|0}h=(f[i+16>>2]|0)+(Y(f[a+28>>2]|0,j)|0)|0;return h|0}function LW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+48|0;e=d+8|0;g=d;if(!((a|0)!=0&(b|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;bO(-27,g,211332,210810,551);bD(g)}g=f[a+28>>2]|0;h=c;c=f[h>>2]|0;i=f[h+4>>2]|0;h=f[a+24>>2]|0;if((i|0)==(c|0))j=0;else j=i-c+((c|0)<0?0-h|0:0)+((i|0)<1?h:0)|0;while(1)if((j|0)<0)j=j+h|0;else break;i=Y((j|0)>(h|0)?h:j,g)|0;if(!i){k=0;u=d;return k|0}MW(a,e,0);NW(e,c,0);c=e+20|0;a=e+12|0;j=e+8|0;e=i;i=b;h=f[a>>2]|0;l=f[c>>2]|0;while(1){m=l-h|0;n=(m|0)>(e|0)?e:m;Vac(i|0,h|0,n|0)|0;m=f[(f[j>>2]|0)+4>>2]|0;f[j>>2]=m;h=f[m+16>>2]|0;f[a>>2]=h;l=h+(Y(f[m+12>>2]|0,g)|0)|0;f[c>>2]=l;e=e-n|0;if((e|0)<=0){k=b;break}else i=i+n|0}u=d;return k|0}function MW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;if((b|0)!=0?(g=b+4|0,f[g>>2]=0,f[g+4>>2]=0,f[g+8>>2]=0,f[g+12>>2]=0,f[g+16>>2]=0,(a|0)!=0):0)h=g;else{f[e>>2]=0;f[e+4>>2]=0;bO(-27,e,211366,210810,945);bD(e);h=b+4|0}f[b>>2]=32;f[h>>2]=a;h=f[a+52>>2]|0;if(!h){e=b+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;u=d;return}e=f[h>>2]|0;g=f[h+16>>2]|0;i=b+12|0;f[i>>2]=g;j=f[e+16>>2]|0;k=f[a+28>>2]|0;a=j+(Y((f[e+12>>2]|0)+-1|0,k)|0)|0;l=b+28|0;f[l>>2]=a;f[b+24>>2]=f[h+8>>2];if(!c){m=h;n=g}else{f[i>>2]=a;f[l>>2]=g;m=e;n=j}f[b+8>>2]=m;f[b+16>>2]=n;j=n+(Y(f[m+12>>2]|0,k)|0)|0;f[b+20>>2]=j;u=d;return}function NW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+16|0;e=d;if((a|0)!=0?(g=a+4|0,h=f[g>>2]|0,(h|0)!=0):0){i=g;j=h}else{f[e>>2]=0;f[e+4>>2]=0;bO(-27,e,211348,210810,1045);bD(e);h=a+4|0;i=h;j=f[h>>2]|0}h=f[j+24>>2]|0;g=f[j+28>>2]|0;if(c|0){c=a+12|0;j=f[c>>2]|0;k=Y(g,b)|0;l=a+8|0;m=f[l>>2]|0;n=j+k|0;if((k|0)>0){o=a+20|0;p=f[o>>2]|0;if(n>>>0<p>>>0)q=n;else{r=j;s=m;t=k;v=p;do{t=t+r-v|0;s=f[s+4>>2]|0;r=f[s+16>>2]|0;p=Y(f[s+12>>2]|0,g)|0;v=r+p|0}while((t|0)>=(p|0));f[l>>2]=s;f[a+16>>2]=r;f[o>>2]=v;q=r+t|0}}else{t=a+16|0;r=f[t>>2]|0;if(n>>>0<r>>>0){v=j;j=m;m=k;k=r;do{m=m+v-k|0;j=f[j>>2]|0;k=f[j+16>>2]|0;v=k+(Y(f[j+12>>2]|0,g)|0)|0;w=v+m|0}while(w>>>0<k>>>0);f[l>>2]=j;f[t>>2]=k;f[a+20>>2]=v;q=w}else q=n}f[c>>2]=q;u=d;return}if((b|0)>=0)if((h|0)<=(b|0)){q=b-h|0;if((q|0)<(h|0))x=q;else{f[e>>2]=0;f[e+4>>2]=0;bO(-211,e,211348,210810,1062);bD(e);x=q}}else x=b;else{if((b|0)<(0-h|0)){f[e>>2]=0;f[e+4>>2]=0;bO(-211,e,211348,210810,1055);bD(e)}x=h+b|0}b=f[(f[i>>2]|0)+52>>2]|0;i=f[b+12>>2]|0;a:do if((x|0)<(i|0)){y=x;z=b;A=i}else{if((x<<1|0)>(h|0)){B=h;C=b}else{e=b;q=i;c=x;while(1){n=f[e+4>>2]|0;w=c-q|0;v=f[n+12>>2]|0;if((w|0)<(v|0)){y=w;z=n;A=v;break a}else{e=n;q=v;c=w}}}do{C=f[C>>2]|0;D=f[C+12>>2]|0;B=B-D|0}while((x|0)<(B|0));y=x-B|0;z=C;A=D}while(0);D=f[z+16>>2]|0;C=D+(Y(y,g)|0)|0;f[a+12>>2]=C;C=a+8|0;if((f[C>>2]|0)==(z|0)){u=d;return}f[C>>2]=z;f[a+16>>2]=D;z=D+(Y(A,g)|0)|0;f[a+20>>2]=z;u=d;return}function OW(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;j=u;u=u+16|0;k=j;if((c|0)<56|(d|0)<1|(g|0)<0){f[k>>2]=0;f[k+4>>2]=0;bO(-201,k,211381,210810,590);bD(k)}if(!((h|0)!=0?!((g|0)>0&((e|0)==0|(i|0)==0)):0)){f[k>>2]=0;f[k+4>>2]=0;bO(-27,k,211381,210810,593);bD(k)}Nac(h|0,0,c|0)|0;f[h+4>>2]=c;f[h>>2]=a&65535|1117323264;c=(a>>>3&511)+1<<(47696>>>(a<<1&14)&3);if(!((c|0)==(d|0)|((a&4095|0)==0|(c|0)==0))){f[k>>2]=0;f[k+4>>2]=0;c=aD(k,106)|0;a=211405;l=c+106|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(l|0));bO(-201,k,211381,210810,607);bD(k)}f[h+28>>2]=d;f[h+24>>2]=g;k=e+(Y(g,d)|0)|0;f[h+36>>2]=k;f[h+32>>2]=k;if((g|0)<=0){u=j;return h|0}f[h+52>>2]=i;f[i+4>>2]=i;f[i>>2]=i;f[i+8>>2]=0;f[i+12>>2]=g;f[i+16>>2]=e;u=j;return h|0}function PW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;if(!((a|0)!=0&(b|0)!=0)){f[d>>2]=0;f[d+4>>2]=0;bO(-27,d,211512,210810,820);bD(d)}d=b+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[b>>2]=24;f[b+4>>2]=a;d=f[a+52>>2]|0;if(!d)e=0;else e=f[d>>2]|0;f[b+8>>2]=e;f[b+12>>2]=f[a+36>>2];f[b+20>>2]=f[a+32>>2];u=c;return}function QW(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;i=(e|0)!=0;if(!((d|0)!=0&i)){f[h>>2]=0;f[h+4>>2]=0;bO(-27,h,211531,210810,838);bD(h)}j=IW(a,b,c,d)|0;if(!(i&(j|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;bO(-27,h,211512,210810,820);bD(h)}h=e+8|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[e>>2]=24;f[e+4>>2]=j;i=f[j+52>>2]|0;if(!i)k=0;else k=f[i>>2]|0;f[h>>2]=k;f[e+12>>2]=f[j+36>>2];f[e+20>>2]=f[j+32>>2];u=g;return}function RW(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;bO(-27,c,211547,210810,850);bD(c)}c=f[a+4>>2]|0;d=f[a+12>>2]|0;f[c+36>>2]=d;e=f[a+8>>2]|0;if(!e){u=b;return}a=f[c+52>>2]|0;f[e+12>>2]=(d-(f[e+16>>2]|0)|0)/(f[c+28>>2]|0)|0;e=a;d=0;do{d=(f[e+12>>2]|0)+d|0;e=f[e+4>>2]|0}while((e|0)!=(a|0));f[c+24>>2]=d;u=b;return}function SW(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;bO(-27,c,211564,210810,881);bD(c)}RW(a);c=f[a+4>>2]|0;if((f[a+8>>2]|0?(d=f[c+44>>2]|0,d|0):0)?(e=(f[d+8>>2]|0)+(f[d+16>>2]|0)|0,g=d+20|0,d=c+32|0,(e+(0-(f[g>>2]|0))-(f[d>>2]|0)|0)>>>0<8):0){h=f[c+36>>2]|0;f[g>>2]=e-h&-8;f[d>>2]=h}f[a+12>>2]=0;u=b;return c|0}function TW(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;if((a|0)!=0?(d=f[a+4>>2]|0,(d|0)!=0):0)e=d;else{f[c>>2]=0;f[c+4>>2]=0;bO(-27,c,211578,210810,912);bD(c);e=f[a+4>>2]|0}RW(a);UW(e,0);f[a+8>>2]=f[f[e+52>>2]>>2];f[a+12>>2]=f[e+36>>2];f[a+20>>2]=f[e+32>>2];u=b;return}function UW(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;bO(-27,e,211595,210810,637);bD(e)}g=a+48|0;h=f[g>>2]|0;if(!h){i=a+28|0;j=f[i>>2]|0;k=f[a+40>>2]|0;l=f[a+44>>2]|0;if((f[a+24>>2]|0)>=(k<<2|0))JW(a,k<<1);if(!l){f[e>>2]=0;f[e+4>>2]=0;m=aD(e,37)|0;n=211606;o=m+37|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-27,e,211595,210810,650);bD(e)}e=(f[l+8>>2]|0)+(f[l+16>>2]|0)|0;n=l+20|0;m=f[n>>2]|0;o=a+32|0;p=f[o>>2]|0;if((e+(0-m)-p|0)>>>0<8?!(c|0?1:(m|0)<(f[i>>2]|0)):0){q=(m|0)/(j|0)|0;r=p+(Y((q|0)>(k|0)?k:q,j)|0)|0;f[o>>2]=r;f[n>>2]=e-r&-8;u=d;return}r=(Y(k,j)|0)+24|0;do if((m|0)<(r|0))if((m|0)<((Y((k|0)>5?(k|0)/3|0:1,j)|0)+32|0)){GW(l);s=r;break}else{s=m-((m+-24|0)%(f[i>>2]|0)|0)|0;break}else s=r;while(0);r=FW(l,s)|0;f[r+16>>2]=r+20+7&-8;f[r+12>>2]=s+-24;f[r+4>>2]=0;f[r>>2]=0;t=r}else{f[g>>2]=f[h+4>>2];t=h}h=a+52|0;g=f[h>>2]|0;if(!g){f[h>>2]=t;v=t;w=t;x=t}else{f[t>>2]=f[g>>2];f[g>>2]=t;v=g;w=t;x=(f[t>>2]|0)+4|0}f[t+4>>2]=v;f[x>>2]=t;x=f[t+12>>2]|0;v=t+16|0;g=f[v>>2]|0;r=f[w>>2]|0;if(c){c=(x|0)/(f[a+28>>2]|0)|0;w=g+x|0;f[v>>2]=w;if((t|0)==(r|0)){f[a+36>>2]=w;f[a+32>>2]=w;y=f[h>>2]|0}else{f[h>>2]=t;y=t}f[t+8>>2]=c;h=f[t+4>>2]|0;if((h|0)==(y|0))z=y;else{w=h;do{f[w+8>>2]=(f[w+8>>2]|0)+c;w=f[w+4>>2]|0}while((w|0)!=(y|0));z=y}}else{f[a+36>>2]=g;f[a+32>>2]=g+x;if((t|0)==(r|0))A=0;else A=(f[r+12>>2]|0)+(f[r+8>>2]|0)|0;f[t+8>>2]=A;z=t}f[z+12>>2]=0;u=d;return}function VW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;bO(-27,d,211644,210810,995);bD(d)}d=a+8|0;e=f[d>>2]|0;g=f[(f[a+4>>2]|0)+28>>2]|0;if((b|0)>0){b=f[e+4>>2]|0;f[d>>2]=b;h=f[b+16>>2]|0;i=h;j=h;k=f[b+12>>2]|0}else{b=f[e>>2]|0;f[d>>2]=b;d=f[b+16>>2]|0;e=f[b+12>>2]|0;i=d+(Y(e+-1|0,g)|0)|0;j=d;k=e}f[a+12>>2]=i;f[a+16>>2]=j;i=j+(Y(k,g)|0)|0;f[a+20>>2]=i;u=c;return}function WW(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if((a|0)!=0?(e=f[a+12>>2]|0,(e|0)!=0):0)g=e;else{f[d>>2]=0;f[d+4>>2]=0;bO(-27,d,211661,210810,1020);bD(d);g=f[a+12>>2]|0}d=f[(f[a+4>>2]|0)+28>>2]|0;e=g-(f[a+16>>2]|0)|0;if((d|0)<33?(g=d+-1|0,(-2147450741>>>g&1|0)!=0):0)h=e>>b[211300+g>>0];else h=(e|0)/(d|0)|0;u=c;return (f[(f[a+8>>2]|0)+8>>2]|0)+h-(f[a+24>>2]|0)|0}function XW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;bO(-27,d,211679,210810,1138);bD(d)}d=f[a+28>>2]|0;e=a+36|0;g=f[e>>2]|0;if(g>>>0<(f[a+32>>2]|0)>>>0)h=g;else{UW(a,0);h=f[e>>2]|0}if(b|0)Vac(h|0,b|0,d|0)|0;b=(f[f[a+52>>2]>>2]|0)+12|0;f[b>>2]=(f[b>>2]|0)+1;b=a+24|0;f[b>>2]=(f[b>>2]|0)+1;f[e>>2]=h+d;u=c;return h|0}function YW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;bO(-27,d,211689,210810,1169);bD(d)}e=a+24|0;if((f[e>>2]|0)<1){f[d>>2]=0;f[d+4>>2]=0;bO(-201,d,211689,210810,1171);bD(d)}d=a+28|0;g=f[d>>2]|0;h=a+36|0;i=(f[h>>2]|0)+(0-g)|0;f[h>>2]=i;if(b|0)Vac(b|0,i|0,g|0)|0;f[h>>2]=i;f[e>>2]=(f[e>>2]|0)+-1;g=a+52|0;b=f[g>>2]|0;j=f[b>>2]|0;k=j+12|0;l=(f[k>>2]|0)+-1|0;f[k>>2]=l;if(l|0){u=c;return}l=f[d>>2]|0;d=a+32|0;if((b|0)==(j|0)){m=f[d>>2]|0;n=b+16|0;o=(Y(f[b+8>>2]|0,l)|0)+(m-(f[n>>2]|0))|0;f[b+12>>2]=o;f[n>>2]=m+(0-o);f[g>>2]=0;f[d>>2]=0;f[h>>2]=0;f[e>>2]=0;p=b}else{f[k>>2]=(f[d>>2]|0)-i;i=f[j>>2]|0;k=(f[i+16>>2]|0)+(Y(f[i+12>>2]|0,l)|0)|0;f[h>>2]=k;f[d>>2]=k;k=j+4|0;f[i+4>>2]=f[k>>2];f[f[k>>2]>>2]=i;p=j}j=a+48|0;f[p+4>>2]=f[j>>2];f[j>>2]=p;u=c;return}function ZW(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+16|0;h=g;if(!a){f[h>>2]=0;f[h+4>>2]=0;i=aD(h,21)|0;j=211698;k=i+21|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-27,h,211720,210810,1459);bD(h)}if((d|0)<0){f[h>>2]=0;f[h+4>>2]=0;i=aD(h,38)|0;j=211735;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-201,h,211720,210810,1461);bD(h)}h=f[a+28>>2]|0;if(!e){if((d|0)<=0){u=g;return}e=a+32|0;j=a+36|0;i=a+52|0;k=a+24|0;l=d;m=c;while(1){n=f[j>>2]|0;o=((f[e>>2]|0)-n|0)/(h|0)|0;p=(o|0)>(l|0)?l:o;if((p|0)>0){o=(f[f[i>>2]>>2]|0)+12|0;f[o>>2]=(f[o>>2]|0)+p;f[k>>2]=(f[k>>2]|0)+p;o=l-p|0;q=Y(p,h)|0;if(!m){r=0;s=n}else{Vac(n|0,m|0,q|0)|0;r=m+q|0;s=f[j>>2]|0}f[j>>2]=s+q;if((o|0)>0){t=o;v=r}else break}else{t=l;v=m}UW(a,0);l=t;m=v}u=g;return}v=a+52|0;m=f[v>>2]|0;if((d|0)<=0){u=g;return}t=a+24|0;if(!c){l=m;r=d;while(1){if((l|0)!=0?(s=f[l+8>>2]|0,(s|0)!=0):0){w=l;x=s}else{UW(a,1);s=f[v>>2]|0;w=s;x=f[s+8>>2]|0}s=(x|0)>(r|0)?r:x;r=r-s|0;f[w+8>>2]=x-s;j=w+12|0;f[j>>2]=(f[j>>2]|0)+s;f[t>>2]=(f[t>>2]|0)+s;j=Y(s,h)|0;s=w+16|0;f[s>>2]=(f[s>>2]|0)+(0-j);if((r|0)<=0)break;else l=w}u=g;return}else{w=m;m=d;while(1){if((w|0)!=0?(d=f[w+8>>2]|0,(d|0)!=0):0){y=w;z=d}else{UW(a,1);d=f[v>>2]|0;y=d;z=f[d+8>>2]|0}d=(z|0)>(m|0)?m:z;m=m-d|0;f[y+8>>2]=z-d;l=y+12|0;f[l>>2]=(f[l>>2]|0)+d;f[t>>2]=(f[t>>2]|0)+d;l=Y(d,h)|0;d=y+16|0;r=(f[d>>2]|0)+(0-l)|0;f[d>>2]=r;Vac(r|0,c+(Y(m,h)|0)|0,l|0)|0;if((m|0)<=0)break;else w=y}u=g;return}}function _W(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=u;u=u+16|0;h=g;if(!a){f[h>>2]=0;f[h+4>>2]=0;i=aD(h,21)|0;j=211698;k=i+21|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-27,h,211774,210810,1528);bD(h)}if((d|0)<0){f[h>>2]=0;f[h+4>>2]=0;i=aD(h,38)|0;j=211735;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-201,h,211774,210810,1530);bD(h)}h=a+24|0;j=f[h>>2]|0;i=(j|0)<(d|0)?j:d;if(!e){if(!c)l=0;else l=c+(Y(f[a+28>>2]|0,i)|0)|0;if((i|0)<=0){u=g;return}e=a+52|0;d=a+28|0;k=a+36|0;m=a+32|0;n=a+48|0;o=l;l=i;p=f[e>>2]|0;q=j;while(1){r=f[p>>2]|0;s=r+12|0;t=f[s>>2]|0;v=(t|0)>(l|0)?l:t;w=t-v|0;f[s>>2]=w;f[h>>2]=q-v;s=l-v|0;t=Y(f[d>>2]|0,v)|0;v=0-t|0;x=(f[k>>2]|0)+v|0;f[k>>2]=x;if(!o){y=0;z=r;A=w;B=p}else{w=o+v|0;Vac(w|0,x|0,t|0)|0;t=f[e>>2]|0;x=f[t>>2]|0;y=w;z=x;A=f[x+12>>2]|0;B=t}t=z+12|0;if(!A){x=f[d>>2]|0;if((B|0)==(z|0)){w=f[m>>2]|0;v=z+16|0;r=(Y(f[z+8>>2]|0,x)|0)+(w-(f[v>>2]|0))|0;f[t>>2]=r;f[v>>2]=w+(0-r);f[e>>2]=0;f[m>>2]=0;f[k>>2]=0;f[h>>2]=0;C=z+4|0;D=0}else{f[t>>2]=(f[m>>2]|0)-(f[k>>2]|0);t=f[z>>2]|0;r=(f[t+16>>2]|0)+(Y(f[t+12>>2]|0,x)|0)|0;f[k>>2]=r;f[m>>2]=r;r=z+4|0;f[t+4>>2]=f[r>>2];f[f[r>>2]>>2]=t;C=r;D=B}f[C>>2]=f[n>>2];f[n>>2]=z;E=D}else E=B;if((s|0)<=0)break;o=y;l=s;p=E;q=f[h>>2]|0}u=g;return}else{if((i|0)<=0){u=g;return}q=a+52|0;E=a+28|0;p=a+32|0;l=a+36|0;y=a+48|0;a=f[q>>2]|0;o=i;i=c;c=a;B=a;a=j;while(1){j=B+12|0;D=f[j>>2]|0;z=(D|0)>(o|0)?o:D;f[j>>2]=D-z;f[h>>2]=a-z;D=o-z|0;j=B+8|0;f[j>>2]=(f[j>>2]|0)+z;j=Y(f[E>>2]|0,z)|0;if(!i){F=0;G=B;H=c}else{Vac(i|0,f[B+16>>2]|0,j|0)|0;z=f[q>>2]|0;F=i+j|0;G=z;H=z}z=G+16|0;f[z>>2]=(f[z>>2]|0)+j;if(!(f[G+12>>2]|0)){j=f[H>>2]|0;z=f[E>>2]|0;if((H|0)==(j|0)){n=f[p>>2]|0;C=H+16|0;m=(Y(f[H+8>>2]|0,z)|0)+(n-(f[C>>2]|0))|0;f[H+12>>2]=m;f[C>>2]=n+(0-m);f[q>>2]=0;f[p>>2]=0;f[l>>2]=0;f[h>>2]=0;I=H+4|0;J=0}else{m=H+8|0;n=f[m>>2]|0;C=Y(n,z)|0;f[H+12>>2]=C;z=H+16|0;f[z>>2]=(f[z>>2]|0)+(0-C);f[m>>2]=0;m=H+4|0;C=f[m>>2]|0;z=C;if((C|0)!=(H|0)){k=C;do{e=k+8|0;f[e>>2]=(f[e>>2]|0)-n;k=f[k+4>>2]|0}while((k|0)!=(H|0))}f[q>>2]=z;f[j+4>>2]=z;f[f[m>>2]>>2]=j;I=m;J=C}f[I>>2]=f[y>>2];f[y>>2]=H;K=J;L=J}else{K=H;L=G}if((D|0)<=0)break;o=D;i=F;c=K;B=L;a=f[h>>2]|0}u=g;return}}function $W(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+48|0;h=g+8|0;i=g;if(!((a|0)!=0?(f[a>>2]&-65536|0)==1117323264:0)){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,23)|0;k=211799;l=j+23|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-5,i,211823,210810,1610);bD(i)}if(!d){m=f[a+44>>2]|0;if(!m){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,20)|0;k=255176;l=j+20|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-27,i,211823,210810,1616);bD(i);n=0}else n=m}else n=d;d=f[a+28>>2]|0;m=c;o=f[m>>2]|0;p=f[m+4>>2]|0;m=f[a+24>>2]|0;if((p|0)==(o|0))q=0;else q=p-o+((o|0)<0?0-m|0:0)+((p|0)<1?m:0)|0;while(1)if((q|0)<0)q=q+m|0;else break;p=(q|0)>(m|0)?m:q;if((o|0)>=0)if((o|0)<(m|0))r=o;else{s=o-m|0;t=14}else{s=m+o|0;t=14}if((t|0)==14){f[c>>2]=s;r=s}if(!(p>>>0<=m>>>0?!((p|0)!=0&r>>>0>=m>>>0):0)){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,18)|0;k=211834;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-211,i,211823,210810,1627);bD(i)}i=IW(f[a>>2]|0,f[a+4>>2]|0,d,n)|0;if((p|0)<=0){u=g;return i|0}MW(a,h,0);NW(h,r,0);r=h+12|0;a=f[r>>2]|0;k=((f[h+20>>2]|0)-a|0)/(d|0)|0;d=i+52|0;j=i+24|0;l=h+8|0;if(!e){v=0;w=0;x=p;y=k}else{e=p;p=k;k=a;while(1){a=(p|0)>(e|0)?e:p;ZW(i,k,a,0);e=e-a|0;a=f[(f[l>>2]|0)+4>>2]|0;f[l>>2]=a;k=f[a+16>>2]|0;f[r>>2]=k;if((e|0)<=0)break;else p=f[a+12>>2]|0}u=g;return i|0}while(1){p=(y|0)>(x|0)?x:y;e=v;v=FW(n,20)|0;if(!w){f[v+4>>2]=v;f[v>>2]=v;f[d>>2]=v;z=v;A=0}else{f[v>>2]=e;f[v+4>>2]=w;f[w>>2]=v;f[e+4>>2]=v;z=w;A=(f[e+12>>2]|0)+(f[e+8>>2]|0)|0}f[v+8>>2]=A;f[v+16>>2]=f[r>>2];f[v+12>>2]=p;f[j>>2]=(f[j>>2]|0)+p;x=x-p|0;p=f[(f[l>>2]|0)+4>>2]|0;f[l>>2]=p;f[r>>2]=f[p+16>>2];if((x|0)<=0)break;else{w=z;y=f[p+12>>2]|0}}u=g;return i|0}function aX(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0;e=u;u=u+1792|0;g=e+1760|0;h=e+1728|0;i=e+192|0;j=e+160|0;k=e+128|0;l=e+96|0;m=e+64|0;n=e+32|0;o=e;p=(a|0)!=0;if(!(p?(f[a>>2]&-65536|0)==1117323264:0)){q=p?-5:-27;f[j>>2]=0;f[j+4>>2]=0;r=aD(j,18)|0;s=211853;t=r+18|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(q,j,211872,210810,1921);bD(j)}if(!c){f[j>>2]=0;f[j+4>>2]=0;r=aD(j,21)|0;s=211882;t=r+21|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-27,j,211872,210810,1924);bD(j)}s=a+24|0;if((f[s>>2]|0)<2){u=e;return}r=f[a+28>>2]|0;t=r*7|0;MW(a,g,0);f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];f[h+12>>2]=f[g+12>>2];f[h+16>>2]=f[g+16>>2];f[h+20>>2]=f[g+20>>2];f[h+24>>2]=f[g+24>>2];f[h+28>>2]=f[g+28>>2];a=g+8|0;f[i>>2]=f[a>>2];q=g+12|0;p=f[q>>2]|0;f[i+4>>2]=p;v=g+16|0;w=f[v>>2]|0;f[i+8>>2]=w;x=g+20|0;y=f[x>>2]|0;f[i+12>>2]=y;z=h+12|0;A=0-r|0;B=(f[z>>2]|0)+A|0;f[z>>2]=B;C=h+16|0;D=f[C>>2]|0;E=h+8|0;if(B>>>0<D>>>0){F=h+4|0;G=f[(f[F>>2]|0)+28>>2]|0;H=f[f[E>>2]>>2]|0;f[E>>2]=H;I=f[H+16>>2]|0;J=f[H+12>>2]|0;K=I+(Y(J+-1|0,G)|0)|0;f[z>>2]=K;f[C>>2]=I;L=I+(Y(J,G)|0)|0;G=h+20|0;f[G>>2]=L;M=I;N=K;O=E;P=G;Q=G;R=F;S=H;T=L}else{L=h+20|0;M=D;N=B;O=E;P=L;Q=L;R=h+4|0;S=f[E>>2]|0;T=f[L>>2]|0}L=N;N=M;f[i+16>>2]=S;f[i+20>>2]=L;f[i+24>>2]=N;f[i+28>>2]=T;M=n+12|0;B=(r|0)>0;D=g+4|0;H=m+12|0;F=m+16|0;G=m+8|0;K=m+4|0;I=m+20|0;J=k+12|0;U=k+20|0;V=k+8|0;W=k+4|0;X=k+16|0;Z=n+20|0;_=o+12|0;$=o+20|0;aa=o+8|0;ba=o+4|0;ca=o+16|0;da=n+8|0;ea=n+4|0;fa=n+16|0;ga=j+8|0;ha=j+12|0;ia=j+16|0;ja=j+20|0;ka=l+8|0;la=l+12|0;ma=l+16|0;na=l+20|0;oa=(r|0)<1;pa=B^1;qa=(r|0)==1;ra=(r|0)==1;sa=(r|0)==1;ta=(r|0)==1;ua=0;va=p;p=w;w=y;y=S;S=L;L=N;N=T;while(1){T=f[i+(ua<<5)>>2]|0;f[a>>2]=T;f[q>>2]=va;f[v>>2]=p;f[x>>2]=w;f[O>>2]=y;f[z>>2]=S;f[C>>2]=L;f[Q>>2]=N;wa=ua+-1|0;xa=T;T=y;a:while(1){if((xa|0)==(T|0))ya=(f[z>>2]|0)+r-(f[q>>2]|0)|0;else{za=WW(h)|0;ya=Y(za+1-(WW(g)|0)|0,r)|0}if((ya|0)<=(t|0)){Aa=wa;Ba=18;break};f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[n+8>>2]=f[g+8>>2];f[n+12>>2]=f[g+12>>2];f[n+16>>2]=f[g+16>>2];f[n+20>>2]=f[g+20>>2];f[n+24>>2]=f[g+24>>2];f[n+28>>2]=f[g+28>>2];f[j>>2]=f[g>>2];f[j+4>>2]=f[g+4>>2];f[j+8>>2]=f[g+8>>2];f[j+12>>2]=f[g+12>>2];f[j+16>>2]=f[g+16>>2];f[j+20>>2]=f[g+20>>2];f[j+24>>2]=f[g+24>>2];f[j+28>>2]=f[g+28>>2];f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[m+8>>2]=f[h+8>>2];f[m+12>>2]=f[h+12>>2];f[m+16>>2]=f[h+16>>2];f[m+20>>2]=f[h+20>>2];f[m+24>>2]=f[h+24>>2];f[m+28>>2]=f[h+28>>2];f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[l+16>>2]=f[h+16>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];za=(ya|0)/(r|0)|0;do if((za|0)>40){Ca=za>>>3;Da=f[M>>2]|0;NW(n,Ca,1);Ea=f[M>>2]|0;NW(n,Ca,1);Fa=f[M>>2]|0;Ga=(li[c&511](Da,Ea,d)|0)<0;Ha=li[c&511](Ea,Fa,d)|0;if(Ga)if((Ha|0)<0)Ia=Ea;else{Ga=(li[c&511](Da,Fa,d)|0)<0;Ia=Ga?Fa:Da}else if((Ha|0)>0)Ia=Ea;else{Ea=(li[c&511](Da,Fa,d)|0)<0;Ia=Ea?Da:Fa}Fa=za>>>1;Da=Ca*3|0;NW(n,Fa-Da|0,1);Ea=f[M>>2]|0;NW(n,Ca,1);Ha=f[M>>2]|0;NW(n,Ca,1);Ga=f[M>>2]|0;Ja=(li[c&511](Ea,Ha,d)|0)<0;Ka=li[c&511](Ha,Ga,d)|0;if(Ja)if((Ka|0)<0)La=Ha;else{Ja=(li[c&511](Ea,Ga,d)|0)<0;La=Ja?Ga:Ea}else if((Ka|0)>0)La=Ha;else{Ha=(li[c&511](Ea,Ga,d)|0)<0;La=Ha?Ea:Ga}NW(n,za+-1-Fa-Da|0,1);Da=f[M>>2]|0;NW(n,Ca,1);Fa=f[M>>2]|0;NW(n,Ca,1);Ca=f[M>>2]|0;Ga=(li[c&511](Da,Fa,d)|0)<0;Ea=li[c&511](Fa,Ca,d)|0;if(Ga){if((Ea|0)<0){Ma=Ia;Na=La;Oa=Fa;break}Ga=(li[c&511](Da,Ca,d)|0)<0;Ma=Ia;Na=La;Oa=Ga?Ca:Da;break}else{if((Ea|0)>0){Ma=Ia;Na=La;Oa=Fa;break}Fa=(li[c&511](Da,Ca,d)|0)<0;Ma=Ia;Na=La;Oa=Fa?Da:Ca;break}}else{Ca=f[M>>2]|0;Da=(za|0)/2|0;NW(n,Da,1);Fa=f[M>>2]|0;NW(n,za+-1-Da|0,1);Ma=Ca;Na=Fa;Oa=f[M>>2]|0}while(0);za=(li[c&511](Ma,Na,d)|0)<0;Fa=li[c&511](Na,Oa,d)|0;if(za)if((Fa|0)<0)Pa=Na;else{za=(li[c&511](Ma,Oa,d)|0)<0;Pa=za?Oa:Ma}else if((Fa|0)>0)Pa=Na;else{Fa=(li[c&511](Ma,Oa,d)|0)<0;Pa=Fa?Ma:Oa};f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];f[g+8>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];Fa=f[q>>2]|0;if((Pa|0)==(Fa|0)|pa)Qa=Fa;else{za=0;Ca=Fa;while(1){Fa=Pa+za|0;Da=b[Fa>>0]|0;b[Fa>>0]=b[Ca+za>>0]|0;b[(f[q>>2]|0)+za>>0]=Da;za=za+1|0;Da=f[q>>2]|0;if((za|0)==(r|0)){Qa=Da;break}else Ca=Da}}Ca=Qa+r|0;f[q>>2]=Ca;if(Ca>>>0<(f[x>>2]|0)>>>0)Ra=Ca;else{Ca=f[(f[D>>2]|0)+28>>2]|0;za=f[(f[a>>2]|0)+4>>2]|0;f[a>>2]=za;Da=f[za+16>>2]|0;Fa=f[za+12>>2]|0;f[q>>2]=Da;f[v>>2]=Da;za=Da+(Y(Fa,Ca)|0)|0;f[x>>2]=za;Ra=Da};f[k>>2]=f[g>>2];f[k+4>>2]=f[g+4>>2];f[k+8>>2]=f[g+8>>2];f[k+12>>2]=f[g+12>>2];f[k+16>>2]=f[g+16>>2];f[k+20>>2]=f[g+20>>2];f[k+24>>2]=f[g+24>>2];f[k+28>>2]=f[g+28>>2];Da=0;za=Ra;Ca=f[z>>2]|0;while(1){b:do if((za|0)==(Ca|0))Sa=Da;else{if(B){Ta=Da;Ua=za}else{Fa=Da;Ea=za;while(1){Ga=li[c&511](Ea,Qa,d)|0;if((Ga|0)>=1){Sa=Fa;break b}do if(!Ga){Ha=(f[J>>2]|0)+r|0;f[J>>2]=Ha;if(Ha>>>0<(f[U>>2]|0)>>>0){Va=1;break}Ha=f[(f[W>>2]|0)+28>>2]|0;Ka=f[(f[V>>2]|0)+4>>2]|0;f[V>>2]=Ka;Ja=f[Ka+16>>2]|0;Wa=f[Ka+12>>2]|0;f[J>>2]=Ja;f[X>>2]=Ja;Ka=Ja+(Y(Wa,Ha)|0)|0;f[U>>2]=Ka;Va=1}else Va=Fa;while(0);Ga=(f[q>>2]|0)+r|0;f[q>>2]=Ga;if(Ga>>>0<(f[x>>2]|0)>>>0)Xa=Ga;else{Ga=f[(f[D>>2]|0)+28>>2]|0;Ka=f[(f[a>>2]|0)+4>>2]|0;f[a>>2]=Ka;Ha=f[Ka+16>>2]|0;Wa=f[Ka+12>>2]|0;f[q>>2]=Ha;f[v>>2]=Ha;Ka=Ha+(Y(Wa,Ga)|0)|0;f[x>>2]=Ka;Xa=Ha}if((Xa|0)==(f[z>>2]|0)){Sa=Va;break b}else{Fa=Va;Ea=Xa}}}while(1){Ea=li[c&511](Ua,Qa,d)|0;if((Ea|0)>=1){Sa=Ta;break b}do if(!Ea){Fa=f[J>>2]|0;Ha=f[q>>2]|0;do if((Fa|0)==(Ha|0))Ya=Fa;else{Ka=b[Fa>>0]|0;b[Fa>>0]=b[Ha>>0]|0;b[f[q>>2]>>0]=Ka;Ka=f[J>>2]|0;if(sa){Ya=Ka;break}else{Za=Ka;_a=1}while(1){Ka=Za+_a|0;Ga=b[Ka>>0]|0;b[Ka>>0]=b[(f[q>>2]|0)+_a>>0]|0;b[(f[q>>2]|0)+_a>>0]=Ga;_a=_a+1|0;Ga=f[J>>2]|0;if((_a|0)==(r|0)){Ya=Ga;break}else Za=Ga}}while(0);Ha=Ya+r|0;f[J>>2]=Ha;if(Ha>>>0<(f[U>>2]|0)>>>0){$a=1;break}Ha=f[(f[W>>2]|0)+28>>2]|0;Fa=f[(f[V>>2]|0)+4>>2]|0;f[V>>2]=Fa;Ga=f[Fa+16>>2]|0;Ka=f[Fa+12>>2]|0;f[J>>2]=Ga;f[X>>2]=Ga;Fa=Ga+(Y(Ka,Ha)|0)|0;f[U>>2]=Fa;$a=1}else $a=Ta;while(0);Ea=(f[q>>2]|0)+r|0;f[q>>2]=Ea;if(Ea>>>0<(f[x>>2]|0)>>>0)ab=Ea;else{Ea=f[(f[D>>2]|0)+28>>2]|0;Fa=f[(f[a>>2]|0)+4>>2]|0;f[a>>2]=Fa;Ha=f[Fa+16>>2]|0;Ka=f[Fa+12>>2]|0;f[q>>2]=Ha;f[v>>2]=Ha;Fa=Ha+(Y(Ka,Ea)|0)|0;f[x>>2]=Fa;ab=Ha}if((ab|0)==(f[z>>2]|0)){Sa=$a;break}else{Ta=$a;Ua=ab}}}while(0);Ha=f[z>>2]|0;c:do if((f[q>>2]|0)==(Ha|0))bb=Sa;else{if(B){cb=Sa;db=Ha}else{Fa=Sa;Ea=Ha;while(1){Ka=li[c&511](Ea,Qa,d)|0;if((Ka|0)<=-1){bb=Fa;break c}do if(!Ka){Ga=(f[H>>2]|0)+A|0;f[H>>2]=Ga;if(Ga>>>0>=(f[F>>2]|0)>>>0){eb=1;break}Ga=f[(f[K>>2]|0)+28>>2]|0;Wa=f[f[G>>2]>>2]|0;f[G>>2]=Wa;Ja=f[Wa+16>>2]|0;fb=f[Wa+12>>2]|0;Wa=Ja+(Y(fb+-1|0,Ga)|0)|0;f[H>>2]=Wa;f[F>>2]=Ja;Wa=Ja+(Y(fb,Ga)|0)|0;f[I>>2]=Wa;eb=1}else eb=Fa;while(0);Ka=(f[z>>2]|0)+A|0;f[z>>2]=Ka;if(Ka>>>0<(f[C>>2]|0)>>>0){Wa=f[(f[R>>2]|0)+28>>2]|0;Ga=f[f[E>>2]>>2]|0;f[E>>2]=Ga;fb=f[Ga+16>>2]|0;Ja=f[Ga+12>>2]|0;Ga=fb+(Y(Ja+-1|0,Wa)|0)|0;f[z>>2]=Ga;f[C>>2]=fb;gb=fb+(Y(Ja,Wa)|0)|0;f[P>>2]=gb;hb=Ga}else hb=Ka;if((f[q>>2]|0)==(hb|0)){bb=eb;break c}else{Fa=eb;Ea=hb}}}while(1){Ea=li[c&511](db,Qa,d)|0;if((Ea|0)<=-1){bb=cb;break c}do if(!Ea){Fa=f[H>>2]|0;Ka=f[z>>2]|0;do if((Fa|0)==(Ka|0))ib=Fa;else{Ga=b[Fa>>0]|0;b[Fa>>0]=b[Ka>>0]|0;b[f[z>>2]>>0]=Ga;Ga=f[H>>2]|0;if(ra){ib=Ga;break}else{jb=Ga;kb=1}while(1){Ga=jb+kb|0;gb=b[Ga>>0]|0;b[Ga>>0]=b[(f[z>>2]|0)+kb>>0]|0;b[(f[z>>2]|0)+kb>>0]=gb;kb=kb+1|0;gb=f[H>>2]|0;if((kb|0)==(r|0)){ib=gb;break}else jb=gb}}while(0);Ka=ib+A|0;f[H>>2]=Ka;if(Ka>>>0>=(f[F>>2]|0)>>>0){lb=1;break}Ka=f[(f[K>>2]|0)+28>>2]|0;Fa=f[f[G>>2]>>2]|0;f[G>>2]=Fa;gb=f[Fa+16>>2]|0;Ga=f[Fa+12>>2]|0;Fa=gb+(Y(Ga+-1|0,Ka)|0)|0;f[H>>2]=Fa;f[F>>2]=gb;Fa=gb+(Y(Ga,Ka)|0)|0;f[I>>2]=Fa;lb=1}else lb=cb;while(0);Ea=(f[z>>2]|0)+A|0;f[z>>2]=Ea;if(Ea>>>0<(f[C>>2]|0)>>>0){Fa=f[(f[R>>2]|0)+28>>2]|0;Ka=f[f[E>>2]>>2]|0;f[E>>2]=Ka;Ga=f[Ka+16>>2]|0;gb=f[Ka+12>>2]|0;Ka=Ga+(Y(gb+-1|0,Fa)|0)|0;f[z>>2]=Ka;f[C>>2]=Ga;Wa=Ga+(Y(gb,Fa)|0)|0;f[P>>2]=Wa;mb=Ka}else mb=Ea;if((f[q>>2]|0)==(mb|0)){bb=lb;break}else{cb=lb;db=mb}}}while(0);nb=f[q>>2]|0;Ha=f[z>>2]|0;if((nb|0)==(Ha|0)){Ba=107;break}if(B){Ea=b[nb>>0]|0;b[nb>>0]=b[Ha>>0]|0;b[f[z>>2]>>0]=Ea;Ea=f[q>>2]|0;if(qa)ob=Ea;else{Ha=Ea;Ea=1;while(1){Ka=Ha+Ea|0;Wa=b[Ka>>0]|0;b[Ka>>0]=b[(f[z>>2]|0)+Ea>>0]|0;b[(f[z>>2]|0)+Ea>>0]=Wa;Ea=Ea+1|0;Wa=f[q>>2]|0;if((Ea|0)==(r|0)){ob=Wa;break}else Ha=Wa}}}else ob=nb;Ha=ob+r|0;f[q>>2]=Ha;if(Ha>>>0<(f[x>>2]|0)>>>0)pb=Ha;else{Ha=f[(f[D>>2]|0)+28>>2]|0;Ea=f[(f[a>>2]|0)+4>>2]|0;f[a>>2]=Ea;Wa=f[Ea+16>>2]|0;Ka=f[Ea+12>>2]|0;f[q>>2]=Wa;f[v>>2]=Wa;Ea=Wa+(Y(Ka,Ha)|0)|0;f[x>>2]=Ea;pb=Wa}Wa=f[z>>2]|0;Ea=Wa+A|0;f[z>>2]=Ea;if(Ea>>>0<(f[C>>2]|0)>>>0){Ha=f[(f[R>>2]|0)+28>>2]|0;Ka=f[f[E>>2]>>2]|0;f[E>>2]=Ka;Fa=f[Ka+16>>2]|0;gb=f[Ka+12>>2]|0;Ka=Fa+(Y(gb+-1|0,Ha)|0)|0;f[z>>2]=Ka;f[C>>2]=Fa;Ga=Fa+(Y(gb,Ha)|0)|0;f[P>>2]=Ga;qb=Ka}else qb=Ea;if((pb|0)==(Wa|0)){Ba=126;break}else{Da=1;za=pb;Ca=qb}}if((Ba|0)==107){Ba=0;Ca=li[c&511](nb,Qa,d)|0;if(!Ca){za=f[J>>2]|0;Da=f[q>>2]|0;if(!((za|0)==(Da|0)|oa)){Wa=b[za>>0]|0;b[za>>0]=b[Da>>0]|0;b[f[q>>2]>>0]=Wa;Wa=f[J>>2]|0;if(ta)rb=Wa;else{Da=Wa;Wa=1;while(1){Ea=Da+Wa|0;Ka=b[Ea>>0]|0;b[Ea>>0]=b[(f[q>>2]|0)+Wa>>0]|0;b[(f[q>>2]|0)+Wa>>0]=Ka;Wa=Wa+1|0;Ka=f[J>>2]|0;if((Wa|0)==(r|0)){rb=Ka;break}else Da=Ka}}}else rb=za;Da=rb+r|0;f[J>>2]=Da;if(Da>>>0<(f[U>>2]|0)>>>0)sb=1;else{Da=f[(f[W>>2]|0)+28>>2]|0;Wa=f[(f[V>>2]|0)+4>>2]|0;f[V>>2]=Wa;Ka=f[Wa+16>>2]|0;Ea=f[Wa+12>>2]|0;f[J>>2]=Ka;f[X>>2]=Ka;Wa=Ka+(Y(Ea,Da)|0)|0;f[U>>2]=Wa;sb=1}}else sb=bb;if((Ca|0)<1){Wa=(f[q>>2]|0)+r|0;f[q>>2]=Wa;if(Wa>>>0>=(f[x>>2]|0)>>>0){Wa=f[(f[D>>2]|0)+28>>2]|0;Da=f[(f[a>>2]|0)+4>>2]|0;f[a>>2]=Da;Ea=f[Da+16>>2]|0;Ka=f[Da+12>>2]|0;f[q>>2]=Ea;f[v>>2]=Ea;Da=Ea+(Y(Ka,Wa)|0)|0;f[x>>2]=Da}}else{Da=(f[z>>2]|0)+A|0;f[z>>2]=Da;if(Da>>>0<(f[C>>2]|0)>>>0){Da=f[(f[R>>2]|0)+28>>2]|0;Wa=f[f[E>>2]>>2]|0;f[E>>2]=Wa;Ka=f[Wa+16>>2]|0;Ea=f[Wa+12>>2]|0;Wa=Ka+(Y(Ea+-1|0,Da)|0)|0;f[z>>2]=Wa;f[C>>2]=Ka;Wa=Ka+(Y(Ea,Da)|0)|0;f[P>>2]=Wa}}if(!sb){f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];f[g+8>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];f[h+8>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];tb=6;ub=wa}else Ba=126}do if((Ba|0)==126){Ba=0;Wa=WW(g)|0;if(!Wa)vb=f[s>>2]|0;else vb=Wa;Wa=WW(j)|0;Da=WW(k)|0;if(!Da)wb=f[s>>2]|0;else wb=Da;Da=vb-wb|0;Ea=wb-Wa|0;Wa=(Da|0)>(Ea|0)?Ea:Da;do if((Wa|0)>0){f[n>>2]=f[j>>2];f[n+4>>2]=f[j+4>>2];f[n+8>>2]=f[j+8>>2];f[n+12>>2]=f[j+12>>2];f[n+16>>2]=f[j+16>>2];f[n+20>>2]=f[j+20>>2];f[n+24>>2]=f[j+24>>2];f[n+28>>2]=f[j+28>>2];f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];f[o+8>>2]=f[g+8>>2];f[o+12>>2]=f[g+12>>2];f[o+16>>2]=f[g+16>>2];f[o+20>>2]=f[g+20>>2];f[o+24>>2]=f[g+24>>2];f[o+28>>2]=f[g+28>>2];NW(o,0-Wa|0,1);Ea=f[M>>2]|0;if(B){Ka=0;Ga=Ea;while(1){Ha=0;gb=Ga;do{Fa=gb+Ha|0;Ja=b[Fa>>0]|0;b[Fa>>0]=b[(f[_>>2]|0)+Ha>>0]|0;b[(f[_>>2]|0)+Ha>>0]=Ja;Ha=Ha+1|0;gb=f[M>>2]|0}while((Ha|0)!=(r|0));Ha=gb+r|0;f[M>>2]=Ha;if(Ha>>>0<(f[Z>>2]|0)>>>0)xb=Ha;else{Ha=f[(f[ea>>2]|0)+28>>2]|0;Ja=f[(f[da>>2]|0)+4>>2]|0;f[da>>2]=Ja;Fa=f[Ja+16>>2]|0;fb=f[Ja+12>>2]|0;f[M>>2]=Fa;f[fa>>2]=Fa;Ja=Fa+(Y(fb,Ha)|0)|0;f[Z>>2]=Ja;xb=Fa}Fa=(f[_>>2]|0)+r|0;f[_>>2]=Fa;if(Fa>>>0>=(f[$>>2]|0)>>>0){Fa=f[(f[ba>>2]|0)+28>>2]|0;Ja=f[(f[aa>>2]|0)+4>>2]|0;f[aa>>2]=Ja;Ha=f[Ja+16>>2]|0;fb=f[Ja+12>>2]|0;f[_>>2]=Ha;f[ca>>2]=Ha;Ja=Ha+(Y(fb,Fa)|0)|0;f[$>>2]=Ja}Ka=Ka+1|0;if((Ka|0)>=(Wa|0))break;else Ga=xb}}else{Ga=(f[ba>>2]|0)+28|0;Ka=(f[ea>>2]|0)+28|0;Ja=0;Fa=Ea;fb=f[Z>>2]|0;Ha=f[_>>2]|0;while(1){yb=Fa+r|0;if(yb>>>0<fb>>>0){zb=yb;Ab=fb}else{yb=f[Ka>>2]|0;Bb=f[(f[da>>2]|0)+4>>2]|0;f[da>>2]=Bb;Cb=f[Bb+16>>2]|0;Db=f[Bb+12>>2]|0;f[fa>>2]=Cb;Bb=Cb+(Y(Db,yb)|0)|0;f[Z>>2]=Bb;zb=Cb;Ab=Bb}Bb=Ha+r|0;if(Bb>>>0<(f[$>>2]|0)>>>0)Eb=Bb;else{Bb=f[Ga>>2]|0;Cb=f[(f[aa>>2]|0)+4>>2]|0;f[aa>>2]=Cb;yb=f[Cb+16>>2]|0;Db=f[Cb+12>>2]|0;f[ca>>2]=yb;Cb=yb+(Y(Db,Bb)|0)|0;f[$>>2]=Cb;Eb=yb}Ja=Ja+1|0;if((Ja|0)>=(Wa|0))break;else{Fa=zb;fb=Ab;Ha=Eb}}f[M>>2]=zb;f[_>>2]=Eb;break}}while(0);Wa=WW(h)|0;Ha=WW(l)|0;fb=WW(m)|0;Fa=Ha-fb|0;Ha=fb-Wa|0;Wa=(Fa|0)>(Ha|0)?Ha:Fa;do if((Wa|0)>0){f[n>>2]=f[g>>2];f[n+4>>2]=f[g+4>>2];f[n+8>>2]=f[g+8>>2];f[n+12>>2]=f[g+12>>2];f[n+16>>2]=f[g+16>>2];f[n+20>>2]=f[g+20>>2];f[n+24>>2]=f[g+24>>2];f[n+28>>2]=f[g+28>>2];f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2];f[o+16>>2]=f[l+16>>2];f[o+20>>2]=f[l+20>>2];f[o+24>>2]=f[l+24>>2];f[o+28>>2]=f[l+28>>2];NW(o,1-Wa|0,1);Fa=f[M>>2]|0;if(B){fb=0;Ja=Fa;while(1){Ga=0;Ka=Ja;do{Ea=Ka+Ga|0;yb=b[Ea>>0]|0;b[Ea>>0]=b[(f[_>>2]|0)+Ga>>0]|0;b[(f[_>>2]|0)+Ga>>0]=yb;Ga=Ga+1|0;Ka=f[M>>2]|0}while((Ga|0)!=(r|0));Ga=Ka+r|0;f[M>>2]=Ga;if(Ga>>>0<(f[Z>>2]|0)>>>0)Fb=Ga;else{Ga=f[(f[ea>>2]|0)+28>>2]|0;gb=f[(f[da>>2]|0)+4>>2]|0;f[da>>2]=gb;yb=f[gb+16>>2]|0;Ea=f[gb+12>>2]|0;f[M>>2]=yb;f[fa>>2]=yb;gb=yb+(Y(Ea,Ga)|0)|0;f[Z>>2]=gb;Fb=yb}yb=(f[_>>2]|0)+r|0;f[_>>2]=yb;if(yb>>>0>=(f[$>>2]|0)>>>0){yb=f[(f[ba>>2]|0)+28>>2]|0;gb=f[(f[aa>>2]|0)+4>>2]|0;f[aa>>2]=gb;Ga=f[gb+16>>2]|0;Ea=f[gb+12>>2]|0;f[_>>2]=Ga;f[ca>>2]=Ga;gb=Ga+(Y(Ea,yb)|0)|0;f[$>>2]=gb}fb=fb+1|0;if((fb|0)>=(Wa|0))break;else Ja=Fb}}else{Ja=(f[ba>>2]|0)+28|0;fb=(f[ea>>2]|0)+28|0;gb=0;yb=Fa;Ea=f[Z>>2]|0;Ga=f[_>>2]|0;while(1){Cb=yb+r|0;if(Cb>>>0<Ea>>>0){Gb=Cb;Hb=Ea}else{Cb=f[fb>>2]|0;Bb=f[(f[da>>2]|0)+4>>2]|0;f[da>>2]=Bb;Db=f[Bb+16>>2]|0;Ib=f[Bb+12>>2]|0;f[fa>>2]=Db;Bb=Db+(Y(Ib,Cb)|0)|0;f[Z>>2]=Bb;Gb=Db;Hb=Bb}Bb=Ga+r|0;if(Bb>>>0<(f[$>>2]|0)>>>0)Jb=Bb;else{Bb=f[Ja>>2]|0;Db=f[(f[aa>>2]|0)+4>>2]|0;f[aa>>2]=Db;Cb=f[Db+16>>2]|0;Ib=f[Db+12>>2]|0;f[ca>>2]=Cb;Db=Cb+(Y(Ib,Bb)|0)|0;f[$>>2]=Db;Jb=Cb}gb=gb+1|0;if((gb|0)>=(Wa|0))break;else{yb=Gb;Ea=Hb;Ga=Jb}}f[M>>2]=Gb;f[_>>2]=Jb;break}}while(0);Wa=(Ha|0)>1;if((Da|0)<=1){if(!Wa){tb=4;ub=wa;break}f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];f[h+8>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];f[g+8>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];f[g+16>>2]=f[l+16>>2];f[g+20>>2]=f[l+20>>2];f[g+24>>2]=f[l+24>>2];f[g+28>>2]=f[l+28>>2];NW(g,1-Ha|0,1);tb=0;ub=wa;break}if(!Wa){f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];f[h+8>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];f[h+16>>2]=f[j+16>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];f[g+8>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];NW(h,Da+-1|0,1);tb=0;ub=wa;break}Wa=wa+1|0;if((Da|0)>(Ha|0)){f[i+(Wa<<5)>>2]=f[ga>>2];f[i+(Wa<<5)+4>>2]=f[ha>>2];f[i+(Wa<<5)+8>>2]=f[ia>>2];f[i+(Wa<<5)+12>>2]=f[ja>>2];NW(j,Da+-1|0,1);f[i+(Wa<<5)+16>>2]=f[ga>>2];f[i+(Wa<<5)+20>>2]=f[ha>>2];f[i+(Wa<<5)+24>>2]=f[ia>>2];f[i+(Wa<<5)+28>>2]=f[ja>>2];f[h>>2]=f[l>>2];f[h+4>>2]=f[l+4>>2];f[h+8>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];f[g+8>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];f[g+16>>2]=f[l+16>>2];f[g+20>>2]=f[l+20>>2];f[g+24>>2]=f[l+24>>2];f[g+28>>2]=f[l+28>>2];NW(g,1-Ha|0,1);tb=0;ub=Wa;break}else{f[i+(Wa<<5)+16>>2]=f[ka>>2];f[i+(Wa<<5)+20>>2]=f[la>>2];f[i+(Wa<<5)+24>>2]=f[ma>>2];f[i+(Wa<<5)+28>>2]=f[na>>2];NW(l,1-Ha|0,1);f[i+(Wa<<5)>>2]=f[ka>>2];f[i+(Wa<<5)+4>>2]=f[la>>2];f[i+(Wa<<5)+8>>2]=f[ma>>2];f[i+(Wa<<5)+12>>2]=f[na>>2];f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];f[h+8>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];f[h+16>>2]=f[j+16>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];f[g+8>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];NW(h,Da+-1|0,1);tb=0;ub=Wa;break}}while(0);switch(tb&7){case 6:{Aa=ub;Ba=18;break a;break}case 0:break;default:if(tb|0){Kb=ub;break a}}wa=ub;xa=f[a>>2]|0;T=f[E>>2]|0}d:do if((Ba|0)==18){Ba=0;T=f[D>>2]|0;xa=f[a>>2]|0;wa=f[v>>2]|0;Ca=f[x>>2]|0;za=(f[q>>2]|0)+r|0;if(za>>>0<Ca>>>0){Lb=za;Mb=wa;Nb=Ca;Ob=xa}else{Ca=f[xa+4>>2]|0;za=f[Ca+16>>2]|0;Lb=za;Mb=za;Nb=za+(Y(f[Ca+12>>2]|0,f[T+28>>2]|0)|0)|0;Ob=Ca}Ca=(f[z>>2]|0)+r|0;f[z>>2]=Ca;if(Ca>>>0>=(f[P>>2]|0)>>>0){Ca=f[(f[R>>2]|0)+28>>2]|0;za=f[(f[E>>2]|0)+4>>2]|0;f[E>>2]=za;Wa=f[za+16>>2]|0;Ga=f[za+12>>2]|0;f[z>>2]=Wa;f[C>>2]=Wa;za=Wa+(Y(Ga,Ca)|0)|0;f[P>>2]=za}za=T+28|0;T=Lb;Ca=wa;wa=Mb;Ga=Nb;Wa=xa;xa=Ob;while(1){Ea=Ga;if(B){yb=T;gb=Ca;Ja=Wa;while(1){if((yb|0)==(f[z>>2]|0)){Kb=Aa;break d}fb=(Ja|0)==(xa|0)?gb:wa;e:do if((yb|0)==(f[q>>2]|0)){Pb=fb;Qb=xa}else{Fa=fb;Cb=xa;Db=yb;while(1){Bb=Db+A|0;if(Bb>>>0<Fa>>>0){Ib=f[Cb>>2]|0;Rb=f[Ib+16>>2]|0;Sb=Rb;Tb=Ib;Ub=Rb+(Y((f[Ib+12>>2]|0)+-1|0,f[za>>2]|0)|0)|0}else{Sb=Fa;Tb=Cb;Ub=Bb}if((li[c&511](Ub,Db,d)|0)<1){Pb=Sb;Qb=Tb;break e}else Vb=0;do{Bb=Ub+Vb|0;Ib=b[Bb>>0]|0;Rb=Db+Vb|0;b[Bb>>0]=b[Rb>>0]|0;b[Rb>>0]=Ib;Vb=Vb+1|0}while((Vb|0)!=(r|0));if((Ub|0)==(f[q>>2]|0)){Pb=Sb;Qb=Tb;break}else{Fa=Sb;Cb=Tb;Db=Ub}}}while(0);yb=yb+r|0;if(yb>>>0>=Ea>>>0){Wb=Pb;Xb=Qb;break}else{gb=Pb;Ja=Qb}}}else{Ja=T;gb=Ca;yb=Wa;while(1){if((Ja|0)==(f[z>>2]|0)){Kb=Aa;break d}Da=(yb|0)==(xa|0)?gb:wa;if((Ja|0)==(f[q>>2]|0)){Yb=Da;Zb=xa}else{Ha=Da;Da=xa;fb=Ja;while(1){Db=fb+A|0;if(Db>>>0<Ha>>>0){Cb=f[Da>>2]|0;Fa=f[Cb+16>>2]|0;_b=Fa;$b=Cb;ac=Fa+(Y((f[Cb+12>>2]|0)+-1|0,f[za>>2]|0)|0)|0}else{_b=Ha;$b=Da;ac=Db}Db=(li[c&511](ac,fb,d)|0)<1;if(Db|(ac|0)==(f[q>>2]|0)){Yb=_b;Zb=$b;break}else{Ha=_b;Da=$b;fb=ac}}}Ja=Ja+r|0;if(Ja>>>0>=Ea>>>0){Wb=Yb;Xb=Zb;break}else{gb=Yb;yb=Zb}}}yb=f[xa+4>>2]|0;gb=f[yb+16>>2]|0;T=gb;Ca=Wb;wa=gb;Ga=gb+(Y(f[yb+12>>2]|0,f[za>>2]|0)|0)|0;Wa=Xb;xa=yb}}while(0);if((Kb|0)<=-1)break;ua=Kb;va=f[i+(Kb<<5)+4>>2]|0;p=f[i+(Kb<<5)+8>>2]|0;w=f[i+(Kb<<5)+12>>2]|0;y=f[i+(Kb<<5)+16>>2]|0;S=f[i+(Kb<<5)+20>>2]|0;L=f[i+(Kb<<5)+24>>2]|0;N=f[i+(Kb<<5)+28>>2]|0}u=e;return}function bX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;if(!d){f[g>>2]=0;f[g+4>>2]=0;bO(-27,g,211904,210810,2486);bD(g)}if(!((b|0)>63&(c|0)>7&(c&3|0)==0)){f[g>>2]=0;f[g+4>>2]=0;bO(-201,g,211904,210810,2490);bD(g)}g=IW(a,b,c,d)|0;f[g>>2]=f[g>>2]&65535|1117257728;u=e;return g|0}function cX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;bO(-27,e,211916,210810,2507);bD(e)}e=a+56|0;g=f[e>>2]|0;if(!g){h=a+24|0;i=f[h>>2]|0;j=f[a+28>>2]|0;UW(a,0);k=a+36|0;l=f[k>>2]|0;f[e>>2]=l;m=l+j|0;n=f[a+32>>2]|0;if(m>>>0>n>>>0){o=l;p=i}else{q=i;i=l;r=m;while(1){f[i>>2]=q|-2147483648;f[i+4>>2]=r;m=q+1|0;s=r+j|0;if(s>>>0>n>>>0){o=r;p=m;break}else{t=r;q=m;r=s;i=t}}}f[o+(0-j)+4>>2]=0;j=(f[f[a+52>>2]>>2]|0)+12|0;f[j>>2]=p-(f[h>>2]|0)+(f[j>>2]|0);f[h>>2]=p;f[k>>2]=n;v=l}else v=g;f[e>>2]=f[v+4>>2];e=f[v>>2]&67108863;if(b|0)Vac(v|0,b|0,f[a+28>>2]|0)|0;f[v>>2]=e;b=a+60|0;f[b>>2]=(f[b>>2]|0)+1;if(!c){u=d;return e|0}f[c>>2]=v;u=d;return e|0}function dX(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;bO(-27,c,211788,210810,1596);bD(c)}_W(a,0,f[a+24>>2]|0,0);f[a+56>>2]=0;f[a+60>>2]=0;u=b;return}function eX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;if((c|0)<8|((b|0)<68|(d|0)<24)){f[h>>2]=0;f[h+4>>2]=0;bO(-201,h,211925,210810,2586);bD(h)}h=bX(a,b,c,e)|0;c=bX(0,64,d,e)|0;f[h+64>>2]=c;u=g;return h|0}function fX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;if(!a){f[e>>2]=0;f[e+4>>2]=0;bO(-27,e,211939,210810,2620);bD(e)}e=a+56|0;g=f[e>>2]|0;if(!g){h=a+24|0;i=f[h>>2]|0;j=f[a+28>>2]|0;UW(a,0);k=a+36|0;l=f[k>>2]|0;f[e>>2]=l;m=l+j|0;n=f[a+32>>2]|0;if(m>>>0>n>>>0){o=l;p=i}else{q=i;i=l;r=m;while(1){f[i>>2]=q|-2147483648;f[i+4>>2]=r;m=q+1|0;s=r+j|0;if(s>>>0>n>>>0){o=r;p=m;break}else{t=r;q=m;r=s;i=t}}}f[o+(0-j)+4>>2]=0;j=(f[f[a+52>>2]>>2]|0)+12|0;f[j>>2]=p-(f[h>>2]|0)+(f[j>>2]|0);f[h>>2]=p;f[k>>2]=n;f[e>>2]=f[l+4>>2];f[l>>2]=f[l>>2]&67108863;n=a+60|0;f[n>>2]=(f[n>>2]|0)+1;if(!l){v=-1;w=0}else{x=l;y=8}}else{f[e>>2]=f[g+4>>2];f[g>>2]=f[g>>2]&67108863;e=a+60|0;f[e>>2]=(f[e>>2]|0)+1;x=g;y=8}if((y|0)==8){if(b|0)Vac(x+8|0,b+8|0,(f[a+28>>2]|0)+-8|0)|0;f[x+4>>2]=0;v=f[x>>2]|0;w=x}if(!c){u=d;return v|0}f[c>>2]=w;u=d;return v|0}function gX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(b|0)!=0&(c|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;bO(-27,e,211953,210810,2705);bD(e)}if((b|0)==(c|0)){g=0;u=d;return g|0}if(!(f[a>>2]&16384)){a=(f[b>>2]&67108863)>>>0>(f[c>>2]&67108863)>>>0;h=a?c:b;i=a?b:c}else{h=b;i=c}c=f[h+4>>2]|0;if(!c){g=0;u=d;return g|0}else j=c;while(1){c=f[j+20>>2]|0;if((c|0)==(i|0)){g=j;k=9;break}j=f[j+8+(((h|0)==(c|0)&1)<<2)>>2]|0;if(!j){g=0;k=9;break}}if((k|0)==9){u=d;return g|0}return 0}function hX(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0;h=u;u=u+16|0;i=h;if(!a){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,21)|0;k=211974;l=j+21|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-27,i,211996,210810,2762);bD(i)}if(!(f[a>>2]&16384)){m=(f[c>>2]&67108863)>>>0>(f[d>>2]&67108863)>>>0;o=m?d:c;p=m?c:d}else{o=c;p=d}d=gX(a,o,p)|0;if(d|0){if(!g){q=0;u=h;return q|0}f[g>>2]=d;q=0;u=h;return q|0}if((o|0)==(p|0)){d=p|0?-5:-27;f[i>>2]=0;f[i+4>>2]=0;j=aD(i,41)|0;k=212016;l=j+41|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(d,i,211996,210810,2782);bD(i)}d=a+64|0;a=f[d>>2]|0;k=a+56|0;j=f[k>>2]|0;do if(!j){if((a|0)==0?(f[i>>2]=0,f[i+4>>2]=0,bO(-27,i,211916,210810,2507),bD(i),l=f[k>>2]|0,l|0):0){r=l;break}l=a+24|0;c=f[l>>2]|0;m=f[a+28>>2]|0;UW(a,0);s=a+36|0;t=f[s>>2]|0;f[k>>2]=t;v=t+m|0;w=f[a+32>>2]|0;if(v>>>0>w>>>0){x=t;y=c}else{z=c;c=t;A=v;while(1){f[c>>2]=z|-2147483648;f[c+4>>2]=A;v=z+1|0;B=A+m|0;if(B>>>0>w>>>0){x=A;y=v;break}else{C=A;z=v;A=B;c=C}}}f[x+(0-m)+4>>2]=0;c=(f[f[a+52>>2]>>2]|0)+12|0;f[c>>2]=y-(f[l>>2]|0)+(f[c>>2]|0);f[l>>2]=y;f[s>>2]=w;r=t}else r=j;while(0);j=r+4|0;f[k>>2]=f[j>>2];f[r>>2]=f[r>>2]&67108863;k=a+60|0;f[k>>2]=(f[k>>2]|0)+1;f[r+16>>2]=o;f[r+20>>2]=p;k=o+4|0;f[r+8>>2]=f[k>>2];o=p+4|0;f[r+12>>2]=f[o>>2];f[o>>2]=r;f[k>>2]=r;k=(f[(f[d>>2]|0)+28>>2]|0)+-24|0;d=(k|0)>0;if(!e)if(d){Nac(r+24|0,0,k|0)|0;D=1.0}else D=1.0;else{if(d)Vac(r+24|0,e+24|0,k|0)|0;D=+n[e+4>>2]}n[j>>2]=D;if(!g){q=1;u=h;return q|0}f[g>>2]=r;q=1;u=h;return q|0}function iX(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+8|0;g=d;if(!((a|0)!=0?(f[a>>2]&-53248|0)==1117261824:0)){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,21)|0;i=212058;j=h+21|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-5,g,212080,210810,3262);bD(g)}if(!c){k=f[a+44>>2]|0;if(!k){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,20)|0;i=255176;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-27,g,212080,210810,3268);bD(g);l=0}else l=k}else l=c;c=f[a+28>>2]|0;k=a+64|0;i=f[(f[k>>2]|0)+28>>2]|0;h=a+24|0;j=VC(f[h>>2]<<2)|0;m=VC(f[h>>2]<<2)|0;n=a+4|0;o=eX(f[a>>2]|0,f[n>>2]|0,c,i,l)|0;Vac(o+4624|0,a+4624|0,(f[n>>2]|0)+-68|0)|0;MW(a,e,0);if((f[h>>2]|0)>0){n=e+12|0;l=e+20|0;p=e+8|0;q=e+4|0;r=e+16|0;s=0;t=0;v=f[n>>2]|0;while(1){if((f[v>>2]|0)>-1){f[g>>2]=0;fX(o,v,g)|0;w=f[v>>2]|0;x=f[g>>2]|0;f[x>>2]=w;f[j+(t<<2)>>2]=w;f[v>>2]=t;f[m+(t<<2)>>2]=x;y=t+1|0;z=f[n>>2]|0}else{y=t;z=v}x=z+c|0;f[n>>2]=x;if(x>>>0<(f[l>>2]|0)>>>0)A=x;else{x=f[(f[q>>2]|0)+28>>2]|0;w=f[(f[p>>2]|0)+4>>2]|0;f[p>>2]=w;B=f[w+16>>2]|0;C=f[w+12>>2]|0;f[n>>2]=B;f[r>>2]=B;w=B+(Y(C,x)|0)|0;f[l>>2]=w;A=B}s=s+1|0;if((s|0)>=(f[h>>2]|0))break;else{t=y;v=A}}}MW(f[k>>2]|0,e,0);if((f[(f[k>>2]|0)+24>>2]|0)>0){A=e+12|0;v=e+20|0;y=e+8|0;t=e+4|0;h=e+16|0;s=0;l=f[A>>2]|0;while(1){if((f[l>>2]|0)>-1){f[g>>2]=0;hX(o,f[m+(f[f[l+16>>2]>>2]<<2)>>2]|0,f[m+(f[f[l+20>>2]>>2]<<2)>>2]|0,l,g)|0;f[f[g>>2]>>2]=f[l>>2];D=f[A>>2]|0}else D=l;r=D+i|0;f[A>>2]=r;if(r>>>0<(f[v>>2]|0)>>>0)E=r;else{r=f[(f[t>>2]|0)+28>>2]|0;n=f[(f[y>>2]|0)+4>>2]|0;f[y>>2]=n;p=f[n+16>>2]|0;q=f[n+12>>2]|0;f[A>>2]=p;f[h>>2]=p;n=p+(Y(q,r)|0)|0;f[v>>2]=n;E=p}s=s+1|0;if((s|0)>=(f[(f[k>>2]|0)+24>>2]|0))break;else l=E}}MW(a,e,0);a=f[(f[k>>2]|0)+24>>2]|0;if((a|0)<=0){WC(j);WC(m);F=LO()|0;G=(F|0)<0;H=G?0:o;u=d;return H|0}k=e+12|0;E=e+20|0;l=e+8|0;s=e+4|0;v=e+16|0;e=0;h=0;A=f[k>>2]|0;while(1){if((f[A>>2]|0)>-1){f[A>>2]=f[j+(h<<2)>>2];I=h+1|0}else I=h;y=A+c|0;f[k>>2]=y;if(y>>>0<(f[E>>2]|0)>>>0)J=y;else{y=f[(f[s>>2]|0)+28>>2]|0;t=f[(f[l>>2]|0)+4>>2]|0;f[l>>2]=t;i=f[t+16>>2]|0;D=f[t+12>>2]|0;f[k>>2]=i;f[v>>2]=i;t=i+(Y(D,y)|0)|0;f[E>>2]=t;J=i}e=e+1|0;if((e|0)>=(a|0))break;else{h=I;A=J}}WC(j);WC(m);F=LO()|0;G=(F|0)<0;H=G?0:o;u=d;return H|0}function jX(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e;if(!d){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,20)|0;i=255176;j=h+20|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-27,g,212093,210810,3346);bD(g)}i=IW(0,c,4,d)|0;if(!a){u=e;return i|0}d=a;a=0;while(1){c=f[d+20>>2]|0;if(c){h=a+1|0;if((h|0)==2147483647){k=d;l=2147483646;m=7}else{n=h;o=c}}else{k=d;l=a;m=7}a:do if((m|0)==7){while(1){m=0;p=f[k+12>>2]|0;if(p|0)break;c=l+-1|0;if((l|0)<1){n=c;o=0;break a}else{k=f[k+16>>2]|0;l=c;m=7}}n=l;o=(k|0)==0?0:p}while(0);f[g>>2]=d;XW(i,g)|0;if(!o)break;else{d=o;a=n}}u=e;return i|0}function kX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(b|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;bO(-27,e,212109,210810,3443);bD(e)}if((c|0)<0){f[e>>2]=0;f[e+4>>2]=0;bO(-211,e,212109,210810,3446);bD(e)}f[a>>2]=b;f[a+4>>2]=0;f[a+8>>2]=c;u=d;return}function lX(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;e=aD(d,21)|0;g=212132;h=e+21|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-27,d,212154,210810,3462);bD(d)}d=f[a>>2]|0;g=a+4|0;e=f[g>>2]|0;a:do if(d){h=f[d+20>>2]|0;if((h|0)!=0?(i=e+1|0,(i|0)<(f[a+8>>2]|0)):0){j=h;k=i;break}else{l=d;m=e}while(1){n=f[l+12>>2]|0;if(n|0)break;i=m+-1|0;if((m|0)<1){j=0;k=i;break a}else{l=f[l+16>>2]|0;m=i}}if(!l){j=0;k=m}else{j=(f[a+8>>2]|0)==0?0:n;k=m}}else{j=d;k=e}while(0);f[a>>2]=j;f[g>>2]=k;u=c;return d|0}function mX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(b|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;bO(-27,e,212169,210810,3392);bD(e)}f[a+16>>2]=(b|0)!=(c|0)?b:0;c=b+20|0;b=f[c>>2]|0;f[a+12>>2]=b;if(!b){f[c>>2]=a;u=d;return}f[b+8>>2]=a;f[c>>2]=a;u=d;return}
function uK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if(!c)return;g=d+-4|0;if((d|0)<4){h=(d|0)>0;l=e;m=a;o=c;while(1){o=o+-1|0;if(h){q=0;do{r=LVb(k+j*+n[m+(q<<2)>>2])|0;f[l+(q<<2)>>2]=r;q=q+1|0}while((q|0)!=(d|0))}if(!o)break;else{l=l+(b<<2)|0;m=m+(i<<2)|0}}return}m=d&-4;l=(m|0)<(d|0);o=e;e=a;a=c;while(1){c=0;do{h=LVb(k+j*+n[e+(c<<2)>>2])|0;q=c|1;r=LVb(k+j*+n[e+(q<<2)>>2])|0;f[o+(c<<2)>>2]=h;f[o+(q<<2)>>2]=r;r=c|2;q=LVb(k+j*+n[e+(r<<2)>>2])|0;h=c|3;s=LVb(k+j*+n[e+(h<<2)>>2])|0;f[o+(r<<2)>>2]=q;f[o+(h<<2)>>2]=s;c=c+4|0}while((c|0)<=(g|0));a=a+-1|0;if(l){c=m;do{s=LVb(k+j*+n[e+(c<<2)>>2])|0;f[o+(c<<2)>>2]=s;c=c+1|0}while((c|0)!=(d|0))}if(!a)break;else{o=o+(b<<2)|0;e=e+(i<<2)|0}}return}function vK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>3;b=g>>>2;if(!c)return;g=d+-4|0;if((d|0)<4){h=(d|0)>0;l=e;m=a;n=c;while(1){n=n+-1|0;if(h){o=0;do{q=MVb(k+j*+p[m+(o<<3)>>3])|0;f[l+(o<<2)>>2]=q;o=o+1|0}while((o|0)!=(d|0))}if(!n)break;else{l=l+(b<<2)|0;m=m+(i<<3)|0}}return}m=d&-4;l=(m|0)<(d|0);n=e;e=a;a=c;while(1){c=0;do{h=MVb(k+j*+p[e+(c<<3)>>3])|0;o=c|1;q=MVb(k+j*+p[e+(o<<3)>>3])|0;f[n+(c<<2)>>2]=h;f[n+(o<<2)>>2]=q;q=c|2;o=MVb(k+j*+p[e+(q<<3)>>3])|0;h=c|3;r=MVb(k+j*+p[e+(h<<3)>>3])|0;f[n+(q<<2)>>2]=o;f[n+(h<<2)>>2]=r;c=c+4|0}while((c|0)<=(g|0));a=a+-1|0;if(l){c=m;do{r=MVb(k+j*+p[e+(c<<3)>>3])|0;f[n+(c<<2)>>2]=r;c=c+1|0}while((c|0)!=(d|0))}if(!a)break;else{n=n+(b<<2)|0;e=e+(i<<3)|0}}return}function wK(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0.0;d=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=g>>>2;if(!c)return;g=d+-4|0;if((d|0)<4){i=(d|0)>0;m=e;o=a;q=c;while(1){q=q+-1|0;if(i){r=0;do{n[m+(r<<2)>>2]=l+k*+(h[o+r>>0]|0);r=r+1|0}while((r|0)!=(d|0))}if(!q)break;else{m=m+(j<<2)|0;o=o+b|0}}return}o=d&-4;m=(o|0)<(d|0);q=e;e=a;a=c;while(1){c=0;do{i=c|1;s=l+k*+(h[e+i>>0]|0);n[q+(c<<2)>>2]=l+k*+(h[e+c>>0]|0);n[q+(i<<2)>>2]=s;i=c|2;r=c|3;s=l+k*+(h[e+r>>0]|0);n[q+(i<<2)>>2]=l+k*+(h[e+i>>0]|0);n[q+(r<<2)>>2]=s;c=c+4|0}while((c|0)<=(g|0));a=a+-1|0;if(m){c=o;do{n[q+(c<<2)>>2]=l+k*+(h[e+c>>0]|0);c=c+1|0}while((c|0)!=(d|0))}if(!a)break;else{q=q+(j<<2)|0;e=e+b|0}}return}function xK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0.0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=h>>>2;if(!d)return;h=e+-4|0;if((e|0)<4){i=(e|0)>0;m=g;o=a;q=d;while(1){q=q+-1|0;if(i){r=0;do{n[m+(r<<2)>>2]=l+k*+(b[o+r>>0]|0);r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{m=m+(j<<2)|0;o=o+c|0}}return}o=e&-4;m=(o|0)<(e|0);q=g;g=a;a=d;while(1){d=0;do{i=d|1;s=l+k*+(b[g+i>>0]|0);n[q+(d<<2)>>2]=l+k*+(b[g+d>>0]|0);n[q+(i<<2)>>2]=s;i=d|2;r=d|3;s=l+k*+(b[g+r>>0]|0);n[q+(i<<2)>>2]=l+k*+(b[g+i>>0]|0);n[q+(r<<2)>>2]=s;d=d+4|0}while((d|0)<=(h|0));a=a+-1|0;if(m){d=o;do{n[q+(d<<2)>>2]=l+k*+(b[g+d>>0]|0);d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{q=q+(j<<2)|0;g=g+c|0}}return}function yK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>2;g=c+-1|0;if(!c)return;if((d|0)<4){if((d|0)>0){m=e;o=a;q=g}else return;while(1){c=0;do{n[m+(c<<2)>>2]=l+k*+(j[o+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(d|0));if(!q)break;else{m=m+(b<<2)|0;o=o+(i<<1)|0;q=q+-1|0}}return}q=d+-4|0;o=(((q|0)>3?q:3)&2147483644)+4|0;if((o|0)<(d|0)){r=e;s=a;t=g}else{m=e;e=a;a=g;while(1){g=0;do{c=g|1;u=l+k*+(j[e+(c<<1)>>1]|0);n[m+(g<<2)>>2]=l+k*+(j[e+(g<<1)>>1]|0);n[m+(c<<2)>>2]=u;c=g|2;h=g|3;u=l+k*+(j[e+(h<<1)>>1]|0);n[m+(c<<2)>>2]=l+k*+(j[e+(c<<1)>>1]|0);n[m+(h<<2)>>2]=u;g=g+4|0}while((g|0)<=(q|0));if(!a)break;else{m=m+(b<<2)|0;e=e+(i<<1)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;u=l+k*+(j[s+(e<<1)>>1]|0);n[r+(a<<2)>>2]=l+k*+(j[s+(a<<1)>>1]|0);n[r+(e<<2)>>2]=u;e=a|2;m=a|3;u=l+k*+(j[s+(m<<1)>>1]|0);n[r+(e<<2)>>2]=l+k*+(j[s+(e<<1)>>1]|0);n[r+(m<<2)>>2]=u;a=a+4|0}while((a|0)<=(q|0));v=o;do{n[r+(v<<2)>>2]=l+k*+(j[s+(v<<1)>>1]|0);v=v+1|0}while((v|0)!=(d|0));if(!t)break;else{r=r+(b<<2)|0;s=s+(i<<1)|0;t=t+-1|0}}return}function zK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>2;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){m=g;o=a;q=h}else return;while(1){c=0;do{n[m+(c<<2)>>2]=l+k*+(d[o+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(e|0));if(!q)break;else{m=m+(b<<2)|0;o=o+(j<<1)|0;q=q+-1|0}}return}q=e+-4|0;o=(((q|0)>3?q:3)&2147483644)+4|0;if((o|0)<(e|0)){r=g;s=a;t=h}else{m=g;g=a;a=h;while(1){h=0;do{c=h|1;u=l+k*+(d[g+(c<<1)>>1]|0);n[m+(h<<2)>>2]=l+k*+(d[g+(h<<1)>>1]|0);n[m+(c<<2)>>2]=u;c=h|2;i=h|3;u=l+k*+(d[g+(i<<1)>>1]|0);n[m+(c<<2)>>2]=l+k*+(d[g+(c<<1)>>1]|0);n[m+(i<<2)>>2]=u;h=h+4|0}while((h|0)<=(q|0));if(!a)break;else{m=m+(b<<2)|0;g=g+(j<<1)|0;a=a+-1|0}}return}while(1){a=0;do{g=a|1;u=l+k*+(d[s+(g<<1)>>1]|0);n[r+(a<<2)>>2]=l+k*+(d[s+(a<<1)>>1]|0);n[r+(g<<2)>>2]=u;g=a|2;m=a|3;u=l+k*+(d[s+(m<<1)>>1]|0);n[r+(g<<2)>>2]=l+k*+(d[s+(g<<1)>>1]|0);n[r+(m<<2)>>2]=u;a=a+4|0}while((a|0)<=(q|0));v=o;do{n[r+(v<<2)>>2]=l+k*+(d[s+(v<<1)>>1]|0);v=v+1|0}while((v|0)!=(e|0));if(!t)break;else{r=r+(b<<2)|0;s=s+(j<<1)|0;t=t+-1|0}}return}function AK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0.0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if(!c)return;g=d+-4|0;h=(((g|0)>3?g:3)&2147483644)+4|0;if((d|0)<4){l=(d|0)>0;m=e;o=a;q=c;while(1){q=q+-1|0;if(l){r=0;do{n[m+(r<<2)>>2]=k+j*+(f[o+(r<<2)>>2]|0);r=r+1|0}while((r|0)!=(d|0))}if(!q)break;else{m=m+(b<<2)|0;o=o+(i<<2)|0}}return}o=(h|0)<(d|0);m=e;e=a;a=c;while(1){c=0;do{q=c|1;s=k+j*+(f[e+(q<<2)>>2]|0);n[m+(c<<2)>>2]=k+j*+(f[e+(c<<2)>>2]|0);n[m+(q<<2)>>2]=s;q=c|2;l=c|3;s=k+j*+(f[e+(l<<2)>>2]|0);n[m+(q<<2)>>2]=k+j*+(f[e+(q<<2)>>2]|0);n[m+(l<<2)>>2]=s;c=c+4|0}while((c|0)<=(g|0));a=a+-1|0;if(o){c=h;do{n[m+(c<<2)>>2]=k+j*+(f[e+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(d|0))}if(!a)break;else{m=m+(b<<2)|0;e=e+(i<<2)|0}}return}function BK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,u=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;g=c+-1|0;if(!c)return;if((d|0)<4){if((d|0)>0){l=e;m=a;o=g}else return;while(1){c=0;do{n[l+(c<<2)>>2]=k+j*+n[m+(c<<2)>>2];c=c+1|0}while((c|0)!=(d|0));if(!o)break;else{l=l+(b<<2)|0;m=m+(i<<2)|0;o=o+-1|0}}return}o=d+-4|0;m=(((o|0)>3?o:3)&2147483644)+4|0;if((m|0)<(d|0)){q=e;r=a;s=g}else{l=e;e=a;a=g;while(1){g=0;do{c=g|1;t=k+j*+n[e+(c<<2)>>2];n[l+(g<<2)>>2]=k+j*+n[e+(g<<2)>>2];n[l+(c<<2)>>2]=t;c=g|2;h=g|3;t=k+j*+n[e+(h<<2)>>2];n[l+(c<<2)>>2]=k+j*+n[e+(c<<2)>>2];n[l+(h<<2)>>2]=t;g=g+4|0}while((g|0)<=(o|0));if(!a)break;else{l=l+(b<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;t=k+j*+n[r+(e<<2)>>2];n[q+(a<<2)>>2]=k+j*+n[r+(a<<2)>>2];n[q+(e<<2)>>2]=t;e=a|2;l=a|3;t=k+j*+n[r+(l<<2)>>2];n[q+(e<<2)>>2]=k+j*+n[r+(e<<2)>>2];n[q+(l<<2)>>2]=t;a=a+4|0}while((a|0)<=(o|0));u=m;do{n[q+(u<<2)>>2]=k+j*+n[r+(u<<2)>>2];u=u+1|0}while((u|0)!=(d|0));if(!s)break;else{q=q+(b<<2)|0;r=r+(i<<2)|0;s=s+-1|0}}return}function CK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,u=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>3;b=g>>>2;g=c+-1|0;if(!c)return;if((d|0)<4){if((d|0)>0){l=e;m=a;o=g}else return;while(1){c=0;do{n[l+(c<<2)>>2]=k+j*+p[m+(c<<3)>>3];c=c+1|0}while((c|0)!=(d|0));if(!o)break;else{l=l+(b<<2)|0;m=m+(i<<3)|0;o=o+-1|0}}return}o=d+-4|0;m=(((o|0)>3?o:3)&2147483644)+4|0;if((m|0)<(d|0)){q=e;r=a;s=g}else{l=e;e=a;a=g;while(1){g=0;do{c=g|1;t=k+j*+p[e+(c<<3)>>3];n[l+(g<<2)>>2]=k+j*+p[e+(g<<3)>>3];n[l+(c<<2)>>2]=t;c=g|2;h=g|3;t=k+j*+p[e+(h<<3)>>3];n[l+(c<<2)>>2]=k+j*+p[e+(c<<3)>>3];n[l+(h<<2)>>2]=t;g=g+4|0}while((g|0)<=(o|0));if(!a)break;else{l=l+(b<<2)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;t=k+j*+p[r+(e<<3)>>3];n[q+(a<<2)>>2]=k+j*+p[r+(a<<3)>>3];n[q+(e<<2)>>2]=t;e=a|2;l=a|3;t=k+j*+p[r+(l<<3)>>3];n[q+(e<<2)>>2]=k+j*+p[r+(e<<3)>>3];n[q+(l<<2)>>2]=t;a=a+4|0}while((a|0)<=(o|0));u=m;do{n[q+(u<<2)>>2]=k+j*+p[r+(u<<3)>>3];u=u+1|0}while((u|0)!=(d|0));if(!s)break;else{q=q+(b<<2)|0;r=r+(i<<3)|0;s=s+-1|0}}return}function DK(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0.0;d=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=g>>>3;if(!c)return;g=d+-4|0;if((d|0)<4){i=(d|0)>0;m=e;n=a;o=c;while(1){o=o+-1|0;if(i){q=0;do{p[m+(q<<3)>>3]=l+k*+(h[n+q>>0]|0);q=q+1|0}while((q|0)!=(d|0))}if(!o)break;else{m=m+(j<<3)|0;n=n+b|0}}return}n=d&-4;m=(n|0)<(d|0);o=e;e=a;a=c;while(1){c=0;do{i=c|1;r=l+k*+(h[e+i>>0]|0);p[o+(c<<3)>>3]=l+k*+(h[e+c>>0]|0);p[o+(i<<3)>>3]=r;i=c|2;q=c|3;r=l+k*+(h[e+q>>0]|0);p[o+(i<<3)>>3]=l+k*+(h[e+i>>0]|0);p[o+(q<<3)>>3]=r;c=c+4|0}while((c|0)<=(g|0));a=a+-1|0;if(m){c=n;do{p[o+(c<<3)>>3]=l+k*+(h[e+c>>0]|0);c=c+1|0}while((c|0)!=(d|0))}if(!a)break;else{o=o+(j<<3)|0;e=e+b|0}}return}function EK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0.0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=h>>>3;if(!d)return;h=e+-4|0;if((e|0)<4){i=(e|0)>0;m=g;n=a;o=d;while(1){o=o+-1|0;if(i){q=0;do{p[m+(q<<3)>>3]=l+k*+(b[n+q>>0]|0);q=q+1|0}while((q|0)!=(e|0))}if(!o)break;else{m=m+(j<<3)|0;n=n+c|0}}return}n=e&-4;m=(n|0)<(e|0);o=g;g=a;a=d;while(1){d=0;do{i=d|1;r=l+k*+(b[g+i>>0]|0);p[o+(d<<3)>>3]=l+k*+(b[g+d>>0]|0);p[o+(i<<3)>>3]=r;i=d|2;q=d|3;r=l+k*+(b[g+q>>0]|0);p[o+(i<<3)>>3]=l+k*+(b[g+i>>0]|0);p[o+(q<<3)>>3]=r;d=d+4|0}while((d|0)<=(h|0));a=a+-1|0;if(m){d=n;do{p[o+(d<<3)>>3]=l+k*+(b[g+d>>0]|0);d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{o=o+(j<<3)|0;g=g+c|0}}return}function FK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>3;g=c+-1|0;if(!c)return;if((d|0)<4){if((d|0)>0){m=e;n=a;o=g}else return;while(1){c=0;do{p[m+(c<<3)>>3]=l+k*+(j[n+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(d|0));if(!o)break;else{m=m+(b<<3)|0;n=n+(i<<1)|0;o=o+-1|0}}return}o=d+-4|0;n=(((o|0)>3?o:3)&2147483644)+4|0;if((n|0)<(d|0)){q=e;r=a;s=g}else{m=e;e=a;a=g;while(1){g=0;do{c=g|1;t=l+k*+(j[e+(c<<1)>>1]|0);p[m+(g<<3)>>3]=l+k*+(j[e+(g<<1)>>1]|0);p[m+(c<<3)>>3]=t;c=g|2;h=g|3;t=l+k*+(j[e+(h<<1)>>1]|0);p[m+(c<<3)>>3]=l+k*+(j[e+(c<<1)>>1]|0);p[m+(h<<3)>>3]=t;g=g+4|0}while((g|0)<=(o|0));if(!a)break;else{m=m+(b<<3)|0;e=e+(i<<1)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;t=l+k*+(j[r+(e<<1)>>1]|0);p[q+(a<<3)>>3]=l+k*+(j[r+(a<<1)>>1]|0);p[q+(e<<3)>>3]=t;e=a|2;m=a|3;t=l+k*+(j[r+(m<<1)>>1]|0);p[q+(e<<3)>>3]=l+k*+(j[r+(e<<1)>>1]|0);p[q+(m<<3)>>3]=t;a=a+4|0}while((a|0)<=(o|0));u=n;do{p[q+(u<<3)>>3]=l+k*+(j[r+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(d|0));if(!s)break;else{q=q+(b<<3)|0;r=r+(i<<1)|0;s=s+-1|0}}return}function GK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>3;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){m=g;n=a;o=h}else return;while(1){c=0;do{p[m+(c<<3)>>3]=l+k*+(d[n+(c<<1)>>1]|0);c=c+1|0}while((c|0)!=(e|0));if(!o)break;else{m=m+(b<<3)|0;n=n+(j<<1)|0;o=o+-1|0}}return}o=e+-4|0;n=(((o|0)>3?o:3)&2147483644)+4|0;if((n|0)<(e|0)){q=g;r=a;s=h}else{m=g;g=a;a=h;while(1){h=0;do{c=h|1;t=l+k*+(d[g+(c<<1)>>1]|0);p[m+(h<<3)>>3]=l+k*+(d[g+(h<<1)>>1]|0);p[m+(c<<3)>>3]=t;c=h|2;i=h|3;t=l+k*+(d[g+(i<<1)>>1]|0);p[m+(c<<3)>>3]=l+k*+(d[g+(c<<1)>>1]|0);p[m+(i<<3)>>3]=t;h=h+4|0}while((h|0)<=(o|0));if(!a)break;else{m=m+(b<<3)|0;g=g+(j<<1)|0;a=a+-1|0}}return}while(1){a=0;do{g=a|1;t=l+k*+(d[r+(g<<1)>>1]|0);p[q+(a<<3)>>3]=l+k*+(d[r+(a<<1)>>1]|0);p[q+(g<<3)>>3]=t;g=a|2;m=a|3;t=l+k*+(d[r+(m<<1)>>1]|0);p[q+(g<<3)>>3]=l+k*+(d[r+(g<<1)>>1]|0);p[q+(m<<3)>>3]=t;a=a+4|0}while((a|0)<=(o|0));u=n;do{p[q+(u<<3)>>3]=l+k*+(d[r+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(e|0));if(!s)break;else{q=q+(b<<3)|0;r=r+(j<<1)|0;s=s+-1|0}}return}function HK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0.0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>3;if(!c)return;g=d+-4|0;h=(((g|0)>3?g:3)&2147483644)+4|0;if((d|0)<4){l=(d|0)>0;m=e;n=a;o=c;while(1){o=o+-1|0;if(l){q=0;do{p[m+(q<<3)>>3]=k+j*+(f[n+(q<<2)>>2]|0);q=q+1|0}while((q|0)!=(d|0))}if(!o)break;else{m=m+(b<<3)|0;n=n+(i<<2)|0}}return}n=(h|0)<(d|0);m=e;e=a;a=c;while(1){c=0;do{o=c|1;r=k+j*+(f[e+(o<<2)>>2]|0);p[m+(c<<3)>>3]=k+j*+(f[e+(c<<2)>>2]|0);p[m+(o<<3)>>3]=r;o=c|2;l=c|3;r=k+j*+(f[e+(l<<2)>>2]|0);p[m+(o<<3)>>3]=k+j*+(f[e+(o<<2)>>2]|0);p[m+(l<<3)>>3]=r;c=c+4|0}while((c|0)<=(g|0));a=a+-1|0;if(n){c=h;do{p[m+(c<<3)>>3]=k+j*+(f[e+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(d|0))}if(!a)break;else{m=m+(b<<3)|0;e=e+(i<<2)|0}}return}function IK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,u=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>3;g=c+-1|0;if(!c)return;if((d|0)<4){if((d|0)>0){l=e;m=a;o=g}else return;while(1){c=0;do{p[l+(c<<3)>>3]=k+j*+n[m+(c<<2)>>2];c=c+1|0}while((c|0)!=(d|0));if(!o)break;else{l=l+(b<<3)|0;m=m+(i<<2)|0;o=o+-1|0}}return}o=d+-4|0;m=(((o|0)>3?o:3)&2147483644)+4|0;if((m|0)<(d|0)){q=e;r=a;s=g}else{l=e;e=a;a=g;while(1){g=0;do{c=g|1;t=k+j*+n[e+(c<<2)>>2];p[l+(g<<3)>>3]=k+j*+n[e+(g<<2)>>2];p[l+(c<<3)>>3]=t;c=g|2;h=g|3;t=k+j*+n[e+(h<<2)>>2];p[l+(c<<3)>>3]=k+j*+n[e+(c<<2)>>2];p[l+(h<<3)>>3]=t;g=g+4|0}while((g|0)<=(o|0));if(!a)break;else{l=l+(b<<3)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;t=k+j*+n[r+(e<<2)>>2];p[q+(a<<3)>>3]=k+j*+n[r+(a<<2)>>2];p[q+(e<<3)>>3]=t;e=a|2;l=a|3;t=k+j*+n[r+(l<<2)>>2];p[q+(e<<3)>>3]=k+j*+n[r+(e<<2)>>2];p[q+(l<<3)>>3]=t;a=a+4|0}while((a|0)<=(o|0));u=m;do{p[q+(u<<3)>>3]=k+j*+n[r+(u<<2)>>2];u=u+1|0}while((u|0)!=(d|0));if(!s)break;else{q=q+(b<<3)|0;r=r+(i<<2)|0;s=s+-1|0}}return}function JK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>3;b=g>>>3;g=c+-1|0;if(!c)return;if((d|0)<4){if((d|0)>0){l=e;m=a;n=g}else return;while(1){c=0;do{p[l+(c<<3)>>3]=k+j*+p[m+(c<<3)>>3];c=c+1|0}while((c|0)!=(d|0));if(!n)break;else{l=l+(b<<3)|0;m=m+(i<<3)|0;n=n+-1|0}}return}n=d+-4|0;m=(((n|0)>3?n:3)&2147483644)+4|0;if((m|0)<(d|0)){o=e;q=a;r=g}else{l=e;e=a;a=g;while(1){g=0;do{c=g|1;s=k+j*+p[e+(c<<3)>>3];p[l+(g<<3)>>3]=k+j*+p[e+(g<<3)>>3];p[l+(c<<3)>>3]=s;c=g|2;h=g|3;s=k+j*+p[e+(h<<3)>>3];p[l+(c<<3)>>3]=k+j*+p[e+(c<<3)>>3];p[l+(h<<3)>>3]=s;g=g+4|0}while((g|0)<=(n|0));if(!a)break;else{l=l+(b<<3)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;s=k+j*+p[q+(e<<3)>>3];p[o+(a<<3)>>3]=k+j*+p[q+(a<<3)>>3];p[o+(e<<3)>>3]=s;e=a|2;l=a|3;s=k+j*+p[q+(l<<3)>>3];p[o+(e<<3)>>3]=k+j*+p[q+(e<<3)>>3];p[o+(l<<3)>>3]=s;a=a+4|0}while((a|0)<=(n|0));t=m;do{p[o+(t<<3)>>3]=k+j*+p[q+(t<<3)>>3];t=t+1|0}while((t|0)!=(d|0));if(!r)break;else{o=o+(b<<3)|0;q=q+(i<<3)|0;r=r+-1|0}}return}function KK(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=u;u=u+144|0;k=j+128|0;l=j+56|0;m=j;n=j+112|0;dQ(k,42288);switch(g|0){case 32:{p[l>>3]=0.0;p[m>>3]=0.0;o=d>e?e:d;CG(a,l,m,0,0,i);q=+p[l>>3];r=+p[m>>3]-q;s=((d<e?e:d)-o)*(r>2.220446049250313e-16?1.0/r:0.0);t=s;v=o-q*s;break}case 1:case 2:case 4:{s=+LG(a,g,i);t=s>2.220446049250313e-16?d/s:0.0;v=0.0;break}default:{f[l>>2]=0;f[l+4>>2]=0;w=aD(l,29)|0;g=178835;x=w+29|0;do{b[w>>0]=b[g>>0]|0;w=w+1|0;g=g+1|0}while((w|0)<(x|0));bO(-5,l,178865,177716,4717);bD(l);t=1.0;v=0.0}}g=(BL(a,-1)|0)&7;if((h|0)<0)if(MM(c)|0)y=FM(c,-1)|0;else y=g;else y=h;do if((yM(a)|0)==65536){h=f[a+4>>2]|0;f[l>>2]=f[h>>2];g=l+4|0;z=h+4|0;f[g>>2]=f[z>>2];A=l+8|0;f[A>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[l+16>>2]=f[h+16>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];B=f[h+36>>2]|0;f[l+36>>2]=B;f[l+40>>2]=A;A=l+48|0;C=l+44|0;f[C>>2]=A;f[A>>2]=0;f[l+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[h+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[g>>2]=0;jL(l,h);break}}else yL(l,a,-1);while(0);if(!(HM(i)|0)){f[m>>2]=1124007936;a=m+4|0;h=m+8|0;g=m+40|0;w=a;x=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(x|0));f[g>>2]=h;h=m+48|0;w=m+44|0;f[w>>2]=h;f[h>>2]=0;f[m+52>>2]=0;x=n+8|0;f[x>>2]=0;f[x+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=m;OJ(l,n,y,t,v);TP(m,c,i);i=m+36|0;n=f[i>>2]|0;if(n|0?(x=n+12|0,n=f[x>>2]|0,f[x>>2]=n+-1,(n|0)==1):0)kL(m);f[i>>2]=0;i=m+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[g>>2]|0;g=0;do{f[i+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[a>>2]|0))}a=f[w>>2]|0;if((a|0)!=(h|0))UC(a)}else OJ(l,c,y,t,v);y=l+36|0;c=f[y>>2]|0;if(c|0?(a=c+12|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c|0)==1):0)kL(l);f[y>>2]=0;y=l+16|0;c=l+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[l+40>>2]|0;a=0;do{f[y+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[c>>2]|0))}c=f[l+44>>2]|0;if((c|0)!=(l+48|0))UC(c);if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function LK(a){a=a|0;return}function MK(a,b,c){a=a|0;b=b|0;c=c|0;return}function NK(a,b){a=a|0;b=b|0;if(f[b+8>>2]|0)return;if(f[b+12>>2]|0)return;zh[f[(f[a>>2]|0)+16>>2]&2047](a,b);return}function OK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;a=u;u=u+288|0;k=a+160|0;l=a+104|0;m=a+48|0;n=a+40|0;o=a+32|0;p=a;if(!c){u=a;return}q=f[c+16>>2]|0;a:do if((e|0)>0){c=e+-2|0;r=l+4|0;if(!h){s=0;while(1){t=g+(s<<2)|0;v=f[t>>2]|0;if((v|0)>-1)w=v;else{f[l>>2]=0;f[r>>2]=0;x=aD(l,27)|0;y=179023;z=x+27|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,l,179632,179056,77);bD(l);w=f[t>>2]|0}if(!w)break a;f[k+(s<<2)>>2]=w;s=s+1|0;if((s|0)>=(e|0)){A=q;B=14;break a}}}else{C=q;D=0}while(1){s=g+(D<<2)|0;v=f[s>>2]|0;if((v|0)>-1)E=v;else{f[l>>2]=0;f[r>>2]=0;x=aD(l,27)|0;y=179023;z=x+27|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,l,179632,179056,77);bD(l);E=f[s>>2]|0}if(!E)break a;if((D|0)>(c|0))F=1;else F=f[i+(D<<2)>>2]|0;t=C+(Y(F,f[h+(D<<2)>>2]|0)|0)|0;f[k+(D<<2)>>2]=E;D=D+1|0;if((D|0)>=(e|0)){A=t;B=14;break}else C=t}}else{A=q;B=14}while(0);if((B|0)==14){B=l+4|0;q=l+8|0;C=l+16|0;D=l+20|0;E=l+40|0;x=B;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[E>>2]=q;q=l+48|0;h=l+44|0;f[h>>2]=q;f[l+52>>2]=0;f[q>>2]=0;f[l>>2]=1124007936;f[C>>2]=A;f[D>>2]=A;YK(l,e,k,i,1);ZK(l);i=m+4|0;A=m+8|0;D=m+16|0;F=m+20|0;y=m+40|0;x=i;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[y>>2]=A;A=m+48|0;x=m+44|0;f[x>>2]=A;f[m+52>>2]=0;f[A>>2]=0;f[m>>2]=1124007936;f[D>>2]=d;f[F>>2]=d;YK(m,e,k,j,1);ZK(m);f[n>>2]=l;f[n+4>>2]=m;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[p+28>>2]=0;_K(p,n,0,o,2);n=f[p+20>>2]|0;j=p+16|0;if(f[j>>2]|0){k=o+4|0;e=0;do{Vac(f[k>>2]|0,f[o>>2]|0,n|0)|0;e=e+1|0;aL(p)|0}while(e>>>0<(f[j>>2]|0)>>>0)}j=m+36|0;e=f[j>>2]|0;if((e|0?(p=e+12|0,e=f[p>>2]|0,f[p>>2]=e+-1,(e|0)==1):0)?(e=f[j>>2]|0,e|0):0){f[j>>2]=0;p=f[e+4>>2]|0;if(!p){n=f[m+32>>2]|0;if(!n)G=$K()|0;else G=n}else G=p;zh[f[(f[G>>2]|0)+24>>2]&2047](G,e)}f[j>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[i>>2]|0)>0){D=f[y>>2]|0;y=0;do{f[D+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[i>>2]|0))}i=f[x>>2]|0;if((i|0)!=(A|0))UC(i);i=l+36|0;A=f[i>>2]|0;if((A|0?(x=A+12|0,A=f[x>>2]|0,f[x>>2]=A+-1,(A|0)==1):0)?(A=f[i>>2]|0,A|0):0){f[i>>2]=0;x=f[A+4>>2]|0;if(!x){y=f[l+32>>2]|0;if(!y)H=$K()|0;else H=y}else H=x;zh[f[(f[H>>2]|0)+24>>2]&2047](H,A)}f[i>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[B>>2]|0)>0){C=f[E>>2]|0;E=0;do{f[C+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[B>>2]|0))}B=f[h>>2]|0;if((B|0)!=(q|0))UC(B)}u=a;return}function PK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;a=u;u=u+288|0;k=a+160|0;l=a+104|0;m=a+48|0;n=a+40|0;o=a+32|0;p=a;if(!c){u=a;return}q=f[c+16>>2]|0;a:do if((e|0)>0){c=e+-2|0;r=l+4|0;if(!h){s=0;while(1){t=g+(s<<2)|0;v=f[t>>2]|0;if((v|0)>-1)w=v;else{f[l>>2]=0;f[r>>2]=0;x=aD(l,27)|0;y=179023;z=x+27|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,l,179625,179056,108);bD(l);w=f[t>>2]|0}if(!w)break a;f[k+(s<<2)>>2]=w;s=s+1|0;if((s|0)>=(e|0)){A=q;B=14;break a}}}else{C=q;D=0}while(1){s=g+(D<<2)|0;v=f[s>>2]|0;if((v|0)>-1)E=v;else{f[l>>2]=0;f[r>>2]=0;x=aD(l,27)|0;y=179023;z=x+27|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,l,179625,179056,108);bD(l);E=f[s>>2]|0}if(!E)break a;if((D|0)>(c|0))F=1;else F=f[i+(D<<2)>>2]|0;t=C+(Y(F,f[h+(D<<2)>>2]|0)|0)|0;f[k+(D<<2)>>2]=E;D=D+1|0;if((D|0)>=(e|0)){A=t;B=14;break}else C=t}}else{A=q;B=14}while(0);if((B|0)==14){B=l+4|0;q=l+8|0;C=l+16|0;D=l+20|0;E=l+40|0;x=B;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[E>>2]=q;q=l+48|0;h=l+44|0;f[h>>2]=q;f[l+52>>2]=0;f[q>>2]=0;f[l>>2]=1124007936;f[C>>2]=d;f[D>>2]=d;YK(l,e,k,j,1);ZK(l);j=m+4|0;d=m+8|0;D=m+16|0;F=m+20|0;y=m+40|0;x=j;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[y>>2]=d;d=m+48|0;x=m+44|0;f[x>>2]=d;f[m+52>>2]=0;f[d>>2]=0;f[m>>2]=1124007936;f[D>>2]=A;f[F>>2]=A;YK(m,e,k,i,1);ZK(m);f[n>>2]=l;f[n+4>>2]=m;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[p+28>>2]=0;_K(p,n,0,o,2);n=f[p+20>>2]|0;i=p+16|0;if(f[i>>2]|0){k=o+4|0;e=0;do{Vac(f[k>>2]|0,f[o>>2]|0,n|0)|0;e=e+1|0;aL(p)|0}while(e>>>0<(f[i>>2]|0)>>>0)}i=m+36|0;e=f[i>>2]|0;if((e|0?(p=e+12|0,e=f[p>>2]|0,f[p>>2]=e+-1,(e|0)==1):0)?(e=f[i>>2]|0,e|0):0){f[i>>2]=0;p=f[e+4>>2]|0;if(!p){n=f[m+32>>2]|0;if(!n)G=$K()|0;else G=n}else G=p;zh[f[(f[G>>2]|0)+24>>2]&2047](G,e)}f[i>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[j>>2]|0)>0){D=f[y>>2]|0;y=0;do{f[D+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[j>>2]|0))}j=f[x>>2]|0;if((j|0)!=(d|0))UC(j);j=l+36|0;d=f[j>>2]|0;if((d|0?(x=d+12|0,d=f[x>>2]|0,f[x>>2]=d+-1,(d|0)==1):0)?(d=f[j>>2]|0,d|0):0){f[j>>2]=0;x=f[d+4>>2]|0;if(!x){y=f[l+32>>2]|0;if(!y)H=$K()|0;else H=y}else H=x;zh[f[(f[H>>2]|0)+24>>2]&2047](H,d)}f[j>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[B>>2]|0)>0){C=f[E>>2]|0;E=0;do{f[C+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[B>>2]|0))}B=f[h>>2]|0;if((B|0)!=(q|0))UC(B)}u=a;return}function QK(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;l=u;u=u+304|0;a=l+288|0;m=l+160|0;n=l+104|0;o=l+48|0;p=l+40|0;q=l+32|0;r=l;dQ(a,42340);if((c|0)!=0&(d|0)!=0){s=f[c+16>>2]|0;c=f[d+16>>2]|0;a:do if((e|0)>0){d=(j|0)==0;t=e+-2|0;v=n+4|0;if(!h){w=0;x=c;while(1){y=g+(w<<2)|0;z=f[y>>2]|0;if((z|0)>-1)A=z;else{f[n>>2]=0;f[v>>2]=0;B=aD(n,27)|0;C=179023;D=B+27|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,n,179051,179056,141);bD(n);A=f[y>>2]|0}if(!A)break a;if(d)E=x;else{if((w|0)>(t|0))F=1;else F=f[k+(w<<2)>>2]|0;E=x+(Y(F,f[j+(w<<2)>>2]|0)|0)|0}f[m+(w<<2)>>2]=A;w=w+1|0;if((w|0)>=(e|0)){G=E;H=s;I=22;break a}else x=E}}else{J=0;K=c;L=s}while(1){x=g+(J<<2)|0;w=f[x>>2]|0;if((w|0)>-1)M=w;else{f[n>>2]=0;f[v>>2]=0;B=aD(n,27)|0;C=179023;D=B+27|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,n,179051,179056,141);bD(n);M=f[x>>2]|0}if(!M)break a;y=(J|0)>(t|0);if(y)N=1;else N=f[i+(J<<2)>>2]|0;w=L+(Y(N,f[h+(J<<2)>>2]|0)|0)|0;if(d)O=K;else{if(y)P=1;else P=f[k+(J<<2)>>2]|0;O=K+(Y(P,f[j+(J<<2)>>2]|0)|0)|0}f[m+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(e|0)){G=O;H=w;I=22;break}else{K=O;L=w}}}else{G=c;H=s;I=22}while(0);if((I|0)==22){I=n+4|0;s=n+8|0;c=n+16|0;L=n+20|0;O=n+40|0;B=I;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[O>>2]=s;s=n+48|0;K=n+44|0;f[K>>2]=s;f[n+52>>2]=0;f[s>>2]=0;f[n>>2]=1124007936;f[c>>2]=H;f[L>>2]=H;YK(n,e,m,i,1);ZK(n);i=o+4|0;H=o+8|0;L=o+16|0;J=o+20|0;M=o+40|0;B=i;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[M>>2]=H;H=o+48|0;B=o+44|0;f[B>>2]=H;f[o+52>>2]=0;f[H>>2]=0;f[o>>2]=1124007936;f[L>>2]=G;f[J>>2]=G;YK(o,e,m,k,1);ZK(o);f[p>>2]=n;f[p+4>>2]=o;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[r+28>>2]=0;_K(r,p,0,q,2);p=f[r+20>>2]|0;k=r+16|0;if(f[k>>2]|0){m=q+4|0;e=0;do{Vac(f[m>>2]|0,f[q>>2]|0,p|0)|0;e=e+1|0;aL(r)|0}while(e>>>0<(f[k>>2]|0)>>>0)}k=o+36|0;e=f[k>>2]|0;if((e|0?(r=e+12|0,e=f[r>>2]|0,f[r>>2]=e+-1,(e|0)==1):0)?(e=f[k>>2]|0,e|0):0){f[k>>2]=0;r=f[e+4>>2]|0;if(!r){p=f[o+32>>2]|0;if(!p)Q=$K()|0;else Q=p}else Q=r;zh[f[(f[Q>>2]|0)+24>>2]&2047](Q,e)}f[k>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[i>>2]|0)>0){L=f[M>>2]|0;M=0;do{f[L+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[i>>2]|0))}i=f[B>>2]|0;if((i|0)!=(H|0))UC(i);i=n+36|0;H=f[i>>2]|0;if((H|0?(B=H+12|0,H=f[B>>2]|0,f[B>>2]=H+-1,(H|0)==1):0)?(H=f[i>>2]|0,H|0):0){f[i>>2]=0;B=f[H+4>>2]|0;if(!B){M=f[n+32>>2]|0;if(!M)R=$K()|0;else R=M}else R=B;zh[f[(f[R>>2]|0)+24>>2]&2047](R,H)}f[i>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[I>>2]|0)>0){c=f[O>>2]|0;O=0;do{f[c+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[I>>2]|0))}I=f[K>>2]|0;if((I|0)!=(s|0))UC(I)}}if(!(f[a+4>>2]|0)){u=l;return}u=l;return}function RK(a,c){a=a|0;c=c|0;if((b[491040]|0)==0?Cac(491040)|0:0)f[125469]=42316;return 501876}function SK(a){a=a|0;return -1}function TK(a){a=a|0;return -1}function UK(a,b){a=a|0;b=b|0;return}function VK(a){a=a|0;return}function WK(a){a=a|0;return}function XK(a){a=a|0;O5b(a);return}function YK(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+16|0;i=h;if(c>>>0>=33){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,25)|0;k=179335;l=j+25|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,i,179361,179056,284);bD(i)}m=a+4|0;if((f[m>>2]|0)!=(c|0)){n=a+44|0;o=f[n>>2]|0;p=a+48|0;if((o|0)!=(p|0)){UC(o);f[n>>2]=p;f[a+40>>2]=a+8}if((c|0)>2){p=TC(c<<3|4)|0;f[n>>2]=p;n=p+(c<<2)+4|0;f[a+40>>2]=n;f[n+-4>>2]=c;f[a+12>>2]=-1;f[a+8>>2]=-1}}f[m>>2]=c;if(!d){u=h;return}n=f[a>>2]|0;p=n&7;o=(n>>>3&511)+1<<(47696>>>(p<<1)&3);n=1212424721>>>(p<<2)&15;p=c+-1|0;if((c|0)<=0){u=h;return}q=a+40|0;r=a+44|0;s=i+4|0;t=i+4|0;v=i+4|0;if(!e){w=p;x=o;while(1){y=f[d+(w<<2)>>2]|0;if((y|0)<=-1){f[i>>2]=0;f[v>>2]=0;z=aD(i,6)|0;b[z>>0]=b[179369]|0;b[z+1>>0]=b[179370]|0;b[z+2>>0]=b[179371]|0;b[z+3>>0]=b[179372]|0;b[z+4>>0]=b[179373]|0;b[z+5>>0]=b[179374]|0;bO(-215,i,179361,179056,310);bD(i)}f[(f[q>>2]|0)+(w<<2)>>2]=y;if(g){f[(f[r>>2]|0)+(w<<2)>>2]=x;z=cbc(y|0,((y|0)<0)<<31>>31|0,x|0,0)|0;if((z|0)==(z|0)&(J|0)==0)A=z;else{f[i>>2]=0;f[s>>2]=0;j=aD(i,51)|0;k=179376;l=j+51|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-211,i,179361,179056,327);bD(i);A=z}}else A=x;if((w|0)>0){w=w+-1|0;x=A}else break}}else{A=p;while(1){x=f[d+(A<<2)>>2]|0;if((x|0)<=-1){f[i>>2]=0;f[v>>2]=0;w=aD(i,6)|0;b[w>>0]=b[179369]|0;b[w+1>>0]=b[179370]|0;b[w+2>>0]=b[179371]|0;b[w+3>>0]=b[179372]|0;b[w+4>>0]=b[179373]|0;b[w+5>>0]=b[179374]|0;bO(-215,i,179361,179056,310);bD(i)}f[(f[q>>2]|0)+(A<<2)>>2]=x;x=e+(A<<2)|0;if(((f[x>>2]|0)>>>0)%(n>>>0)|0|0){f[i>>2]=0;f[t>>2]=0;j=aD(i,31)|0;k=179428;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-13,i,179361,179056,317);bD(i)}if((A|0)<(p|0))B=f[x>>2]|0;else B=o;f[(f[r>>2]|0)+(A<<2)>>2]=B;if((A|0)>0)A=A+-1|0;else break}}if((c|0)!=1){u=h;return}f[m>>2]=2;f[a+12>>2]=1;f[(f[a+44>>2]|0)+4>>2]=o;u=h;return}function ZK(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a+4>>2]|0;c=f[a+40>>2]|0;a:do if((b|0)>0){d=0;while(1){if((f[c+(d<<2)>>2]|0)>1){e=d;break a}g=d+1|0;if((g|0)<(b|0))d=g;else{e=g;break}}}else e=0;while(0);d=f[a+44>>2]|0;g=b;do{h=g;g=g+-1|0;if((g|0)<=(e|0))break;i=Y(f[c+(g<<2)>>2]|0,f[d+(g<<2)>>2]|0)|0}while(i>>>0>=(f[d+(h+-2<<2)>>2]|0)>>>0);h=f[c>>2]|0;i=cbc(h|0,((h|0)<0)<<31>>31|0,f[d>>2]|0,0)|0;h=f[a>>2]|0;f[a>>2]=(g|0)<=(e|0)&((i|0)==(i|0)&(J|0)==0)?h|16384:h&-16385;if((b|0)>2){f[a+12>>2]=-1;f[a+8>>2]=-1}h=f[a+36>>2]|0;if(!h)j=a+16|0;else{i=f[h+16>>2]|0;h=a+16|0;f[h>>2]=i;f[a+20>>2]=i;j=h}h=f[j>>2]|0;if(!h){f[a+28>>2]=0;f[a+24>>2]=0;return}j=f[c>>2]|0;i=f[d>>2]|0;e=(f[a+20>>2]|0)+(Y(i,j)|0)|0;f[a+28>>2]=e;if((j|0)<=0){f[a+24>>2]=e;return}e=b+-1|0;g=h+(Y(f[d+(e<<2)>>2]|0,f[c+(e<<2)>>2]|0)|0)|0;h=a+24|0;f[h>>2]=g;if((b|0)<=1)return;b=g+(Y(i,j+-1|0)|0)|0;if((e|0)==1)k=b;else{j=1;i=b;while(1){b=i+(Y(f[d+(j<<2)>>2]|0,(f[c+(j<<2)>>2]|0)+-1|0)|0)|0;j=j+1|0;if((j|0)==(e|0)){k=b;break}else i=b}}f[h>>2]=k;return}function _K(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;h=u;u=u+64|0;i=h;if(!((c|0)!=0?(d|0)!=0|(e|0)!=0:0)){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,29)|0;k=179219;l=j+29|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,i,242328,179056,4803);bD(i)}f[a>>2]=c;m=a+8|0;f[m>>2]=e;e=a+4|0;f[e>>2]=d;d=a+12|0;f[d>>2]=g;n=a+16|0;f[n>>2]=0;o=a+20|0;f[o>>2]=0;if((g|0)<0){p=0;while(1)if(!(f[c+(p<<2)>>2]|0))break;else p=p+1|0;f[d>>2]=p;if((p|0)<1001)q=p;else{f[i>>2]=0;f[i+4>>2]=0;j=aD(i,15)|0;k=179249;l=j+15|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,i,242328,179056,4818);bD(i);q=f[d>>2]|0}}else q=g;g=a+24|0;f[g>>2]=0;if((q|0)>0){p=i+4|0;c=i+4|0;r=i+4|0;s=-1;t=-1;v=0;w=0;while(1){x=f[(f[a>>2]|0)+(w<<2)>>2]|0;if(!x){f[i>>2]=0;f[p>>2]=0;j=aD(i,14)|0;k=179265;l=j+14|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,i,242328,179056,4825);bD(i);y=f[(f[a>>2]|0)+(w<<2)>>2]|0}else y=x;z=f[m>>2]|0;if(!z)A=y+16|0;else{B=y+16|0;f[z+(w<<2)>>2]=f[B>>2];A=B}if(f[A>>2]|0){a:do if((t|0)<0){B=f[y+4>>2]|0;if((B|0)>0){z=f[y+40>>2]|0;C=0;while(1){if((f[z+(C<<2)>>2]|0)>1){D=B;E=w;F=C;break a}G=C+1|0;if((G|0)<(B|0))C=G;else{D=B;E=w;F=G;break}}}else{D=B;E=w;F=0}}else{C=f[y+40>>2]|0;z=f[C+-4>>2]|0;G=f[(f[(f[a>>2]|0)+(t<<2)>>2]|0)+40>>2]|0;b:do if((z|0)==(f[G+-4>>2]|0)){if((z|0)==2){if((f[C>>2]|0)!=(f[G>>2]|0))break;if((f[C+4>>2]|0)==(f[G+4>>2]|0)){D=s;E=t;F=v;break a}else break}if((z|0)>0)H=0;else{D=s;E=t;F=v;break a}while(1){if((f[C+(H<<2)>>2]|0)!=(f[G+(H<<2)>>2]|0))break b;H=H+1|0;if((H|0)>=(z|0)){D=s;E=t;F=v;break a}}}while(0);f[i>>2]=0;f[r>>2]=0;j=aD(i,26)|0;k=179280;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,i,242328,179056,4845);bD(i);D=s;E=t;F=v}while(0);if(!(f[y>>2]&16384)){x=D+-1|0;z=y+44|0;G=f[z>>2]|0;C=f[y+4>>2]|0;if((C|0)>0)I=f[G+(C+-1<<2)>>2]|0;else I=0;if((f[G+(x<<2)>>2]|0)!=(I|0)){f[i>>2]=0;f[c>>2]=0;j=aD(i,27)|0;k=179307;l=j+27|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,i,242328,179056,4849);bD(i)}G=y+40|0;C=x;while(1){if((C|0)<=(F|0))break;B=f[z>>2]|0;K=Y(f[(f[G>>2]|0)+(C<<2)>>2]|0,f[B+(C<<2)>>2]|0)|0;L=C+-1|0;if(K>>>0<(f[B+(L<<2)>>2]|0)>>>0)break;else C=L}G=f[g>>2]|0;f[g>>2]=(G|0)<(C|0)?C:G;M=D;N=E;O=F}else{M=D;N=E;O=F}}else{M=s;N=t;O=v}w=w+1|0;P=f[d>>2]|0;if((w|0)>=(P|0))break;else{s=M;t=N;v=O}}if((N|0)>-1){v=M+-1|0;M=f[(f[(f[a>>2]|0)+(N<<2)>>2]|0)+40>>2]|0;N=f[g>>2]|0;t=f[M+(v<<2)>>2]|0;s=v;while(1){f[o>>2]=t;if((s|0)<=(N|0))break;v=s+-1|0;w=f[M+(v<<2)>>2]|0;t=cbc(w|0,((w|0)<0)<<31>>31|0,t|0,0)|0;if(!((t|0)==(t|0)&(J|0)==(((t|0)<0)<<31>>31|0)))break;else s=v}t=(s|0)==(O|0)?0:s;f[g>>2]=t;f[n>>2]=1;if((t|0)>0){s=1;O=t;do{t=O;O=O+-1|0;s=Y(s,f[M+(O<<2)>>2]|0)|0;f[n>>2]=s}while((t|0)>1);Q=P}else Q=P}else{R=P;S=45}}else{R=q;S=45}if((S|0)==45){f[g>>2]=0;Q=R}f[a+28>>2]=0;if(!((f[e>>2]|0)!=0&(Q|0)>0)){u=h;return}Q=i+4|0;R=i+4|0;g=i+8|0;S=i+40|0;q=i+48|0;P=i+44|0;s=i+52|0;n=i+36|0;O=i+16|0;M=i+32|0;t=i+36|0;N=i+16|0;v=i+4|0;w=i+40|0;F=i+44|0;E=i+48|0;D=i+32|0;y=0;do{c=f[(f[a>>2]|0)+(y<<2)>>2]|0;if(!c){f[i>>2]=0;f[Q>>2]=0;j=aD(i,14)|0;k=179265;l=j+14|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,i,242328,179056,4886);bD(i);T=f[(f[a>>2]|0)+(y<<2)>>2]|0}else T=c;C=f[T+16>>2]|0;if(!C){f[i>>2]=1124007936;j=R;l=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(l|0));f[S>>2]=g;f[P>>2]=q;f[q>>2]=0;f[s>>2]=0;fL((f[e>>2]|0)+(y*56|0)|0,i)|0;c=f[n>>2]|0;if((c|0?(I=c+12|0,c=f[I>>2]|0,f[I>>2]=c+-1,(c|0)==1):0)?(c=f[n>>2]|0,c|0):0){f[n>>2]=0;I=f[c+4>>2]|0;if(!I){r=f[M>>2]|0;if(!r)U=$K()|0;else U=r}else U=I;zh[f[(f[U>>2]|0)+24>>2]&2047](U,c)}f[n>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[R>>2]|0)>0){c=f[S>>2]|0;I=0;do{f[c+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[R>>2]|0))}I=f[P>>2]|0;if((I|0)!=(q|0))UC(I)}else{Qi(i,1,f[o>>2]|0,f[T>>2]&4095,C,0);fL((f[e>>2]|0)+(y*56|0)|0,i)|0;I=f[t>>2]|0;if((I|0?(c=I+12|0,I=f[c>>2]|0,f[c>>2]=I+-1,(I|0)==1):0)?(I=f[t>>2]|0,I|0):0){f[t>>2]=0;c=f[I+4>>2]|0;if(!c){r=f[D>>2]|0;if(!r)V=$K()|0;else V=r}else V=c;zh[f[(f[V>>2]|0)+24>>2]&2047](V,I)}f[t>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[v>>2]|0)>0){I=f[w>>2]|0;c=0;do{f[I+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[v>>2]|0))}c=f[F>>2]|0;if((c|0)!=(E|0))UC(c)}y=y+1|0}while((y|0)<(f[d>>2]|0));u=h;return}function $K(){var a=0,b=0,c=0,d=0;if(f[125470]|0){a=f[125470]|0;return a|0}b=jO()|0;PO(b);if(!(f[125470]|0)){if(!(f[125471]|0)){c=jO()|0;PO(c);if(!(f[125471]|0)){d=L5b(4)|0;f[d>>2]=42368;f[125471]=d}QO(c)}f[125470]=f[125471]}QO(b);a=f[125470]|0;return a|0}function aL(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=a+28|0;c=f[b>>2]|0;if(c>>>0>=((f[a+16>>2]|0)+-1|0)>>>0)return a|0;d=c+1|0;f[b>>2]=d;b=f[a+24>>2]|0;if((b|0)!=1){c=f[a+12>>2]|0;if((c|0)<=0)return a|0;e=a+8|0;g=a+4|0;h=(d|0)>0&(b|0)>0;i=0;do{j=f[(f[a>>2]|0)+(i<<2)>>2]|0;k=f[j+16>>2]|0;if(k|0){if(h){l=f[j+40>>2]|0;m=f[j+44>>2]|0;j=b;n=k;o=d;while(1){p=j;j=j+-1|0;q=f[l+(j<<2)>>2]|0;r=o;o=(o|0)/(q|0)|0;s=r-(Y(o,q)|0)|0;q=n+(Y(s,f[m+(j<<2)>>2]|0)|0)|0;if(!((o|0)>0&(p|0)>1)){t=q;break}else n=q}}else t=k;n=f[e>>2]|0;if(n|0)f[n+(i<<2)>>2]=t;n=f[g>>2]|0;if(n|0)f[n+(i*56|0)+16>>2]=t}i=i+1|0}while((i|0)<(c|0));return a|0}c=a+8|0;i=f[c>>2]|0;a:do if(i|0?(t=f[a+12>>2]|0,(t|0)>0):0){g=0;e=i;while(1){b=e+(g<<2)|0;if(f[b>>2]|0){h=f[(f[a>>2]|0)+(g<<2)>>2]|0;n=(f[h+16>>2]|0)+(Y(d,f[f[h+44>>2]>>2]|0)|0)|0;f[b>>2]=n}n=g+1|0;if((n|0)>=(t|0))break a;g=n;e=f[c>>2]|0}}while(0);c=f[a+4>>2]|0;if(!c)return a|0;i=f[a+12>>2]|0;if((i|0)<=0)return a|0;e=0;do{g=c+(e*56|0)+16|0;if(f[g>>2]|0){t=f[(f[a>>2]|0)+(e<<2)>>2]|0;k=(f[t+16>>2]|0)+(Y(d,f[f[t+44>>2]>>2]|0)|0)|0;f[g>>2]=k}e=e+1|0}while((e|0)<(i|0));return a|0}function bL(a){a=a|0;O5b(a);return}function cL(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;j=u;u=u+16|0;i=j;k=(e>>>3&511)+1<<(47696>>>(e<<1&14)&3);e=c+-1|0;a:do if((c|0)>0){l=i+4|0;if(!h){m=e;n=k;while(1){o=Y(f[d+(m<<2)>>2]|0,n)|0;if((m|0)>0){m=m+-1|0;n=o}else{p=o;break a}}}if(!g){n=e;m=k;while(1){f[h+(n<<2)>>2]=m;o=Y(f[d+(n<<2)>>2]|0,m)|0;if((n|0)>0){n=n+-1|0;m=o}else{p=o;break a}}}else{q=e;r=k}while(1){m=h+(q<<2)|0;n=f[m>>2]|0;if((n|0)!=2147483647)if(r>>>0>n>>>0){f[i>>2]=0;f[l>>2]=0;o=aD(i,16)|0;s=179170;t=o+16|0;do{b[o>>0]=b[s>>0]|0;o=o+1|0;s=s+1|0}while((o|0)<(t|0));bO(-215,i,179187,179056,183);bD(i);v=f[m>>2]|0}else v=n;else{f[m>>2]=r;v=r}s=Y(f[d+(q<<2)>>2]|0,v)|0;if((q|0)>0){q=q+-1|0;r=s}else{p=s;break}}}else p=k;while(0);k=(g|0)!=0;if(k)w=g;else w=TC(p)|0;g=L5b(52)|0;$H(g,a);f[g+20>>2]=w;f[g+16>>2]=w;f[g+24>>2]=p;if(!k){u=j;return g|0}k=g+28|0;f[k>>2]=f[k>>2]|32;u=j;return g|0}function dL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return (b|0)!=0|0}function eL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;a=u;u=u+16|0;d=a;if(!c){u=a;return}if(f[c+8>>2]|0){f[d>>2]=0;f[d+4>>2]=0;e=aD(d,17)|0;g=179124;h=e+17|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-215,d,179142,179056,212);bD(d)}if(f[c+12>>2]|0){f[d>>2]=0;f[d+4>>2]=0;e=aD(d,16)|0;g=179153;h=e+16|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-215,d,179142,179056,213);bD(d)}if(!(f[c+28>>2]&32)){d=c+20|0;UC(f[d>>2]|0);f[d>>2]=0}aI(c);O5b(c);u=a;return}function fL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if((a|0)==(b|0))return a|0;c=b+36|0;d=f[c>>2]|0;if(d|0){e=d+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+36|0;d=f[e>>2]|0;if((d|0?(g=d+12|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)?(d=f[e>>2]|0,d|0):0){f[e>>2]=0;g=f[d+4>>2]|0;if(!g){h=f[a+32>>2]|0;if(!h)i=$K()|0;else i=h}else i=g;zh[f[(f[i>>2]|0)+24>>2]&2047](i,d)}f[e>>2]=0;d=a+16|0;i=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[i>>2]|0)>0){g=f[a+40>>2]|0;h=0;do{f[g+(h<<2)>>2]=0;h=h+1|0;j=f[i>>2]|0}while((h|0)<(j|0));f[a>>2]=f[b>>2];if((j|0)<3)k=17;else{l=f[b+4>>2]|0;k=19}}else{f[a>>2]=f[b>>2];k=17}if((k|0)==17){j=f[b+4>>2]|0;if((j|0)<3){f[i>>2]=j;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];h=f[b+44>>2]|0;g=f[a+44>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{l=j;k=19}}if((k|0)==19?(YK(a,l,0,0,0),(f[i>>2]|0)>0):0){l=f[b+40>>2]|0;k=f[a+40>>2]|0;j=f[b+44>>2]|0;h=f[a+44>>2]|0;g=0;do{f[k+(g<<2)>>2]=f[l+(g<<2)>>2];f[h+(g<<2)>>2]=f[j+(g<<2)>>2];g=g+1|0}while((g|0)<(f[i>>2]|0))}f[d>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[e>>2]=f[c>>2];return a|0}function gL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=c;c=a+4|0;d=b+4|0;e=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=e;e=a+8|0;d=b+8|0;c=f[e>>2]|0;f[e>>2]=f[d>>2];f[d>>2]=c;c=a+12|0;g=b+12|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+16|0;g=b+16|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+20|0;g=b+20|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+24|0;g=b+24|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+28|0;g=b+28|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+32|0;g=b+32|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+36|0;g=b+36|0;h=f[c>>2]|0;f[c>>2]=f[g>>2];f[g>>2]=h;h=a+40|0;g=b+40|0;c=f[h>>2]|0;f[h>>2]=f[g>>2];f[g>>2]=c;c=a+44|0;i=b+44|0;j=f[c>>2]|0;f[c>>2]=f[i>>2];f[i>>2]=j;k=a+48|0;l=b+48|0;m=f[k>>2]|0;f[k>>2]=f[l>>2];f[l>>2]=m;m=a+52|0;a=b+52|0;b=f[m>>2]|0;f[m>>2]=f[a>>2];f[a>>2]=b;if((f[c>>2]|0)==(l|0)){f[c>>2]=k;f[h>>2]=e;n=f[i>>2]|0}else n=j;if((n|0)!=(k|0))return;f[i>>2]=l;f[g>>2]=d;return}function hL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+144|0;h=g+8|0;i=g;if(!(c>>>0<33&(d|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,27)|0;k=179661;l=j+27|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,440241,179056,390);bD(h)}k=e&4095;e=a+16|0;do if(f[e>>2]|0){j=f[a+4>>2]|0;if((j|0)!=(c|0)?!((c|0)==1&(j|0)<3):0)break;if((k|0)==(f[a>>2]&4095|0)){if((c|0)==2)if((f[a+8>>2]|0)==(f[d>>2]|0)?(f[a+12>>2]|0)==(f[d+4>>2]|0):0){u=g;return}else m=11;else if((c|0)>0)m=11;else n=0;a:do if((m|0)==11){j=f[a+40>>2]|0;l=0;while(1){if((f[j+(l<<2)>>2]|0)!=(f[d+(l<<2)>>2]|0)){n=l;break a}o=l+1|0;if((o|0)<(c|0))l=o;else{n=o;break}}}while(0);if((n|0)==(c|0)){if((c|0)>1){u=g;return}if((f[(f[a+40>>2]|0)+4>>2]|0)==1){u=g;return}}}}while(0);n=a+40|0;if((f[n>>2]|0)==(d|0)){if((c|0)>0)Vac(h|0,d|0,c<<2|0)|0;p=h}else p=d;d=a+36|0;h=f[d>>2]|0;if((h|0?(m=h+12|0,h=f[m>>2]|0,f[m>>2]=h+-1,(h|0)==1):0)?(h=f[d>>2]|0,h|0):0){f[d>>2]=0;m=f[h+4>>2]|0;if(!m){l=f[a+32>>2]|0;if(!l)q=$K()|0;else q=l}else q=m;zh[f[(f[q>>2]|0)+24>>2]&2047](q,h)}f[d>>2]=0;h=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[h>>2]|0)>0){e=f[n>>2]|0;q=0;do{f[e+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[h>>2]|0))}if(c|0){f[a>>2]=k|1124007936;YK(a,c,p,0,1);p=f[h>>2]|0;if((p|0)<3)r=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{c=f[n>>2]|0;q=0;e=1;while(1){m=Y(f[c+(q<<2)>>2]|0,e)|0;q=q+1|0;if((q|0)==(p|0)){r=m;break}else e=m}}if(r|0){r=f[a+32>>2]|0;e=$K()|0;p=(r|0)==0?e:r;r=a+44|0;e=Di[f[(f[p>>2]|0)+8>>2]&15](p,f[h>>2]|0,f[n>>2]|0,k,0,f[r>>2]|0,0,0)|0;f[d>>2]=e;if(!e){f[i>>2]=0;f[i+4>>2]=0;e=aD(i,6)|0;b[e>>0]=b[179689]|0;b[e+1>>0]=b[179690]|0;b[e+2>>0]=b[179691]|0;b[e+3>>0]=b[179692]|0;b[e+4>>0]=b[179693]|0;b[e+5>>0]=b[179694]|0;bO(-215,i,440241,179056,430);bD(i)}e=f[a>>2]|0;if((f[(f[r>>2]|0)+((f[h>>2]|0)+-1<<2)>>2]|0)!=((e>>>3&511)+1<<(47696>>>(e<<1&14)&3)|0)){f[i>>2]=0;f[i+4>>2]=0;Vac(aD(i,146)|0,179696,146)|0;bO(-215,i,440241,179056,438);bD(i)}}i=f[d>>2]|0;if(i|0){d=i+12|0;f[d>>2]=(f[d>>2]|0)+1}ZK(a)}u=g;return}function iL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b>>2]|0;hL(a,(f[b+4>>2]|0)-d>>2,d,c);return}function jL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;YK(a,f[b+4>>2]|0,0,0,0);c=a+4|0;if((f[c>>2]|0)<=0)return;d=f[b+40>>2]|0;e=f[a+40>>2]|0;g=f[b+44>>2]|0;b=f[a+44>>2]|0;a=0;do{f[e+(a<<2)>>2]=f[d+(a<<2)>>2];f[b+(a<<2)>>2]=f[g+(a<<2)>>2];a=a+1|0}while((a|0)<(f[c>>2]|0));return}function kL(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+36|0;c=f[b>>2]|0;if(!c)return;f[b>>2]=0;b=f[c+4>>2]|0;if(!b){d=f[a+32>>2]|0;if(!d)e=$K()|0;else e=d}else e=b;zh[f[(f[e>>2]|0)+24>>2]&2047](e,c);return}function lL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=u;u=u+1152|0;h=g+56|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+12|0;m=a+16|0;n=a+32|0;o=a+36|0;p=a+40|0;q=j;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=k;s=a+48|0;t=a+44|0;f[t>>2]=s;f[a+52>>2]=0;f[s>>2]=0;v=c+4|0;w=f[v>>2]|0;if((w|0)>1)x=w;else{f[h>>2]=0;f[h+4>>2]=0;q=aD(h,11)|0;y=434484;r=q+11|0;do{b[q>>0]=b[y>>0]|0;q=q+1|0;y=y+1|0}while((q|0)<(r|0));bO(-215,h,426289,179056,474);bD(h);x=f[v>>2]|0}if((x|0)>2){w=h+8|0;Nac(w|0,0,1088)|0;f[h>>2]=w;z=h+4|0;f[z>>2]=x;if(x>>>0>136){A=N5b(x>>>0>536870911?-1:x<<3)|0;Nac(A|0,0,x<<3|0)|0;f[h>>2]=A;B=A}else B=w;A=d;x=f[A+4>>2]|0;C=B;f[C>>2]=f[A>>2];f[C+4>>2]=x;x=f[h>>2]|0;C=e;A=f[C+4>>2]|0;B=x+8|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;if((f[v>>2]|0)>2){A=2;B=x;while(1){C=B+(A<<3)|0;f[C>>2]=-2147483648;f[C+4>>2]=2147483647;A=A+1|0;C=f[h>>2]|0;if((A|0)>=(f[v>>2]|0)){D=C;break}else B=C}}else D=x;mL(i,c,D);fL(a,i)|0;D=i+36|0;x=f[D>>2]|0;if((x|0?(B=x+12|0,x=f[B>>2]|0,f[B>>2]=x+-1,(x|0)==1):0)?(x=f[D>>2]|0,x|0):0){f[D>>2]=0;B=f[x+4>>2]|0;if(!B){v=f[i+32>>2]|0;if(!v)E=$K()|0;else E=v}else E=B;zh[f[(f[E>>2]|0)+24>>2]&2047](E,x)}f[D>>2]=0;D=i+16|0;x=i+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[x>>2]|0)>0){D=f[i+40>>2]|0;E=0;do{f[D+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[x>>2]|0))}x=f[i+44>>2]|0;if((x|0)!=(i+48|0))UC(x);x=f[h>>2]|0;if((x|0)!=(w|0)){if(x|0)P5b(x);f[h>>2]=w;f[z>>2]=136}u=g;return}fL(a,c)|0;z=f[d>>2]|0;w=d+4|0;x=f[w>>2]|0;if((z|0)!=-2147483648|(x|0)!=2147483647?(z|0?1:(x|0)!=(f[k>>2]|0)):0){if(!((z|0)<0|(z|0)>(x|0))?(x|0)<=(f[c+8>>2]|0):0){F=z;G=x}else{f[h>>2]=0;f[h+4>>2]=0;q=aD(h,83)|0;y=179843;r=q+83|0;do{b[q>>0]=b[y>>0]|0;q=q+1|0;y=y+1|0}while((q|0)<(r|0));bO(-215,h,426289,179056,492);bD(h);F=f[d>>2]|0;G=f[w>>2]|0}f[k>>2]=G-F;G=Y(F,f[s>>2]|0)|0;f[m>>2]=(f[m>>2]|0)+G;f[a>>2]=f[a>>2]|32768}G=f[e>>2]|0;s=e+4|0;F=f[s>>2]|0;if((G|0)!=-2147483648|(F|0)!=2147483647?(G|0?1:(F|0)!=(f[l>>2]|0)):0){if(!((G|0)<0|(G|0)>(F|0))?(F|0)<=(f[c+12>>2]|0):0){H=G;I=F}else{f[h>>2]=0;f[h+4>>2]=0;q=aD(h,83)|0;y=179927;r=q+83|0;do{b[q>>0]=b[y>>0]|0;q=q+1|0;y=y+1|0}while((q|0)<(r|0));bO(-215,h,426289,179056,501);bD(h);H=f[e>>2]|0;I=f[s>>2]|0}s=I-H|0;f[l>>2]=s;I=f[j>>2]|0;if((I|0)>0)J=f[(f[t>>2]|0)+(I+-1<<2)>>2]|0;else J=0;I=Y(J,H)|0;f[m>>2]=(f[m>>2]|0)+I;f[a>>2]=((s|0)<(f[c+12>>2]|0)?-49153:-32769)&f[a>>2]|32768}c=f[k>>2]|0;if((c|0)!=1){if((c|0)>=1)K=42}else{f[a>>2]=f[a>>2]|16384;K=42}if((K|0)==42?(f[l>>2]|0)>=1:0){u=g;return}K=f[o>>2]|0;if((K|0?(a=K+12|0,K=f[a>>2]|0,f[a>>2]=K+-1,(K|0)==1):0)?(K=f[o>>2]|0,K|0):0){f[o>>2]=0;a=f[K+4>>2]|0;if(!a){c=f[n>>2]|0;if(!c)L=$K()|0;else L=c}else L=a;zh[f[(f[L>>2]|0)+24>>2]&2047](L,K)}f[o>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[j>>2]|0)>0){m=f[p>>2]|0;p=0;do{f[m+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[j>>2]|0))}f[l>>2]=0;f[k>>2]=0;u=g;return}function mL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;f[a>>2]=1124007936;h=a+4|0;i=a+8|0;j=a+16|0;k=a+40|0;l=h;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=i;i=a+48|0;n=a+44|0;f[n>>2]=i;f[a+52>>2]=0;f[i>>2]=0;i=f[c+4>>2]|0;if(!d){f[g>>2]=0;f[g+4>>2]=0;o=aD(g,6)|0;b[o>>0]=b[180011]|0;b[o+1>>0]=b[180012]|0;b[o+2>>0]=b[180013]|0;b[o+3>>0]=b[180014]|0;b[o+4>>0]=b[180015]|0;b[o+5>>0]=b[180016]|0;bO(-215,g,426289,179056,582);bD(g)}o=(i|0)>0;if(o){p=c+40|0;q=g+4|0;r=0;do{s=d+(r<<3)|0;t=f[s>>2]|0;v=f[s+4>>2]|0;do if(!((t|0)==-2147483648&(v|0)==2147483647)){if((t|0)>-1&(t|0)<(v|0)?(v|0)<=(f[(f[p>>2]|0)+(r<<2)>>2]|0):0)break;f[g>>2]=0;f[q>>2]=0;l=aD(g,76)|0;s=180018;m=l+76|0;do{b[l>>0]=b[s>>0]|0;l=l+1|0;s=s+1|0}while((l|0)<(m|0));bO(-215,g,426289,179056,586);bD(g)}while(0);r=r+1|0}while((r|0)<(i|0));fL(a,c)|0;if(o){o=0;do{r=d+(o<<3)|0;g=f[r>>2]|0;l=f[r+4>>2]|0;if((g|0)!=-2147483648|(l|0)!=2147483647?(r=(f[k>>2]|0)+(o<<2)|0,g|0?1:(l|0)!=(f[r>>2]|0)):0){f[r>>2]=l-g;l=Y(f[(f[n>>2]|0)+(o<<2)>>2]|0,g)|0;f[j>>2]=(f[j>>2]|0)+l;f[a>>2]=f[a>>2]|32768}o=o+1|0}while((o|0)!=(i|0))}}else fL(a,c)|0;c=f[h>>2]|0;h=f[k>>2]|0;a:do if((c|0)>0){k=0;while(1){if((f[h+(k<<2)>>2]|0)>1){w=k;break a}i=k+1|0;if((i|0)<(c|0))k=i;else{w=i;break}}}else w=0;while(0);k=f[n>>2]|0;n=c;while(1){c=n;n=n+-1|0;if((n|0)<=(w|0)){x=18;break}i=Y(f[h+(n<<2)>>2]|0,f[k+(n<<2)>>2]|0)|0;if(i>>>0<(f[k+(c+-2<<2)>>2]|0)>>>0){x=18;break}}if((x|0)==18){x=f[h>>2]|0;h=cbc(x|0,((x|0)<0)<<31>>31|0,f[k>>2]|0,0)|0;k=f[a>>2]|0;f[a>>2]=(n|0)<=(w|0)&((h|0)==(h|0)&(J|0)==0)?k|16384:k&-16385;u=e;return}}function nL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;f[a>>2]=h;i=a+4|0;f[i>>2]=2;j=a+8|0;k=d+12|0;f[j>>2]=f[k>>2];l=a+12|0;m=d+8|0;f[l>>2]=f[m>>2];n=a+16|0;o=d+4|0;p=c+44|0;q=(f[c+16>>2]|0)+(Y(f[f[p>>2]>>2]|0,f[o>>2]|0)|0)|0;f[n>>2]=q;f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];r=a+32|0;f[r>>2]=f[c+32>>2];s=a+36|0;f[s>>2]=f[c+36>>2];t=a+40|0;f[t>>2]=j;v=a+48|0;w=a+44|0;f[w>>2]=v;f[a+52>>2]=0;f[v>>2]=0;if((f[c+4>>2]|0)<3){x=h;y=q}else{f[g>>2]=0;f[g+4>>2]=0;z=aD(g,11)|0;A=180095;B=z+11|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,g,426289,179056,531);bD(g);x=f[a>>2]|0;y=f[n>>2]|0}q=f[m>>2]|0;h=c+12|0;v=f[h>>2]|0;C=f[k>>2]|0;f[a>>2]=((C|0)==1?16384:0)|((q|0)<(v|0)?-16385:-1)&x;D=(x>>>3&511)+1<<(47696>>>(x<<1&14)&3);x=f[d>>2]|0;d=y+(Y(D,x)|0)|0;f[n>>2]=d;if(!((!((x|q|0)<0|(x+q|0)>(v|0))?(v=f[o>>2]|0,(v|C|0)>-1):0)?(v+C|0)<=(f[c+8>>2]|0):0)){f[g>>2]=0;f[g+4>>2]=0;z=aD(g,124)|0;A=180107;B=z+124|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,g,426289,179056,538);bD(g)}g=f[s>>2]|0;if(g|0){A=g+12|0;f[A>>2]=(f[A>>2]|0)+1}if(!((f[m>>2]|0)>=(f[h>>2]|0)?(f[k>>2]|0)>=(f[c+8>>2]|0):0))f[a>>2]=f[a>>2]|32768;a=f[w>>2]|0;f[a>>2]=f[f[p>>2]>>2];f[a+4>>2]=D;if((f[j>>2]|0)>=1?(f[l>>2]|0)>=1:0){u=e;return}D=f[s>>2]|0;if((D|0?(a=D+12|0,D=f[a>>2]|0,f[a>>2]=D+-1,(D|0)==1):0)?(D=f[s>>2]|0,D|0):0){f[s>>2]=0;a=f[D+4>>2]|0;if(!a){p=f[r>>2]|0;if(!p)E=$K()|0;else E=p}else E=a;zh[f[(f[E>>2]|0)+24>>2]&2047](E,D)}f[s>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[i>>2]|0)>0){n=f[t>>2]|0;t=0;do{f[n+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[i>>2]|0))}f[l>>2]=0;f[j>>2]=0;u=e;return}function oL(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=a+8|0;i=a+16|0;j=a+20|0;k=a+40|0;l=a+4|0;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=h;h=a+48|0;f[a+44>>2]=h;f[a+52>>2]=0;f[h>>2]=0;f[a>>2]=d&4095|1124007936;f[i>>2]=e;f[j>>2]=e;YK(a,b,c,g,1);ZK(a);return}function pL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=a+8|0;h=a+16|0;i=a+20|0;j=a+40|0;k=a+4|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=g;g=a+48|0;f[a+44>>2]=g;f[a+52>>2]=0;f[g>>2]=0;f[a>>2]=c&4095|1124007936;f[h>>2]=d;f[i>>2]=d;d=f[b>>2]|0;YK(a,(f[b+4>>2]|0)-d>>2,d,e,1);ZK(a);return}function qL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=e;f[a>>2]=1124007936;h=a+4|0;i=a+8|0;j=a+16|0;k=a+40|0;l=h;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=i;i=a+48|0;n=a+44|0;f[n>>2]=i;f[a+52>>2]=0;f[i>>2]=0;i=f[c+4>>2]|0;if(((f[d+4>>2]|0)-(f[d>>2]|0)>>3|0)!=(i|0)){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,23)|0;o=180232;m=l+23|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(m|0));bO(-215,g,426289,179056,608);bD(g)}p=(i|0)>0;if(p){q=c+40|0;r=g+4|0;s=0;do{t=(f[d>>2]|0)+(s<<3)|0;v=f[t>>2]|0;w=f[t+4>>2]|0;do if(!((v|0)==-2147483648&(w|0)==2147483647)){if((v|0)>-1&(v|0)<(w|0)?(w|0)<=(f[(f[q>>2]|0)+(s<<2)>>2]|0):0)break;f[g>>2]=0;f[r>>2]=0;l=aD(g,76)|0;o=180018;m=l+76|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(m|0));bO(-215,g,426289,179056,612);bD(g)}while(0);s=s+1|0}while((s|0)<(i|0));fL(a,c)|0;if(p){p=f[d>>2]|0;d=0;do{s=p+(d<<3)|0;g=f[s>>2]|0;o=f[s+4>>2]|0;if((g|0)!=-2147483648|(o|0)!=2147483647?(s=(f[k>>2]|0)+(d<<2)|0,g|0?1:(o|0)!=(f[s>>2]|0)):0){f[s>>2]=o-g;o=Y(f[(f[n>>2]|0)+(d<<2)>>2]|0,g)|0;f[j>>2]=(f[j>>2]|0)+o;f[a>>2]=f[a>>2]|32768}d=d+1|0}while((d|0)!=(i|0))}}else fL(a,c)|0;c=f[h>>2]|0;h=f[k>>2]|0;a:do if((c|0)>0){k=0;while(1){if((f[h+(k<<2)>>2]|0)>1){x=k;break a}i=k+1|0;if((i|0)<(c|0))k=i;else{x=i;break}}}else x=0;while(0);k=f[n>>2]|0;n=c;while(1){c=n;n=n+-1|0;if((n|0)<=(x|0)){y=19;break}i=Y(f[h+(n<<2)>>2]|0,f[k+(n<<2)>>2]|0)|0;if(i>>>0<(f[k+(c+-2<<2)>>2]|0)>>>0){y=19;break}}if((y|0)==19){y=f[h>>2]|0;h=cbc(y|0,((y|0)<0)<<31>>31|0,f[k>>2]|0,0)|0;k=f[a>>2]|0;f[a>>2]=(n|0)<=(x|0)&((h|0)==(h|0)&(J|0)==0)?k|16384:k&-16385;u=e;return}}function rL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=c+4|0;i=f[h>>2]|0;if((i|0)<3)j=i;else{f[g>>2]=0;f[g+4>>2]=0;i=aD(g,9)|0;k=180256;l=i+9|0;do{b[i>>0]=b[k>>0]|0;i=i+1|0;k=k+1|0}while((i|0)<(l|0));bO(-215,g,180266,179056,750);bD(g);j=f[h>>2]|0}f[a>>2]=f[c>>2];g=a+4|0;f[g>>2]=j;k=a+8|0;i=c+8|0;f[k>>2]=f[i>>2];l=a+12|0;m=c+12|0;f[l>>2]=f[m>>2];n=a+16|0;f[n>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];o=f[c+36>>2]|0;f[a+36>>2]=o;p=a+40|0;f[p>>2]=k;q=a+48|0;r=a+44|0;f[r>>2]=q;f[q>>2]=0;f[a+52>>2]=0;if(!o)s=j;else{j=o+12|0;f[j>>2]=(f[j>>2]|0)+1;s=f[h>>2]|0}if((s|0)>=3){f[g>>2]=0;YK(a,s,0,0,0);if((f[g>>2]|0)>0){s=f[c+40>>2]|0;j=f[p>>2]|0;o=f[c+44>>2]|0;q=f[r>>2]|0;t=0;do{f[j+(t<<2)>>2]=f[s+(t<<2)>>2];f[q+(t<<2)>>2]=f[o+(t<<2)>>2];t=t+1|0}while((t|0)<(f[g>>2]|0))}}else{g=f[c+44>>2]|0;t=f[r>>2]|0;f[t>>2]=f[g>>2];f[t+4>>2]=f[g+4>>2]}g=f[h>>2]|0;if((g|0)>0)v=f[(f[c+44>>2]|0)+(g+-1<<2)>>2]|0;else v=0;if((d|0)>-1){g=(f[m>>2]|0)-d|0;h=f[i>>2]|0;t=Y(v,d)|0;w=(h|0)<(g|0)?h:g;x=(f[n>>2]|0)+t|0}else{t=(f[i>>2]|0)+d|0;i=f[m>>2]|0;w=(i|0)<(t|0)?i:t;x=(f[n>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,0-d|0)|0)|0}f[n>>2]=x;f[k>>2]=w;x=f[p>>2]|0;f[x>>2]=w;f[l>>2]=1;f[x+4>>2]=1;x=f[r>>2]|0;f[x>>2]=(f[x>>2]|0)+((w|0)>1?v:0);v=f[a>>2]|0;w=(f[k>>2]|0)>1?v&-16385:v|16384;f[a>>2]=w;v=f[c+40>>2]|0;if(!((f[v>>2]|0)!=1?1:(f[v+4>>2]|0)!=1)){u=e;return}f[a>>2]=w|32768;u=e;return}function sL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+144|0;e=d+120|0;g=d+112|0;h=d+56|0;i=d;if((c|0)<=-1){f[e>>2]=0;f[e+4>>2]=0;j=aD(e,16)|0;k=180271;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,e,180288,179056,821);bD(e)}if((f[a>>2]&32768|0)==0?(k=(f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,c)|0)|0,k>>>0<=(f[a+28>>2]|0)>>>0):0){u=d;return}k=a+40|0;m=f[k>>2]|0;n=f[m>>2]|0;if(n>>>0>=c>>>0){u=d;return}f[m>>2]=(c|0)>1?c:1;m=a+4|0;o=f[m>>2]|0;if((o|0)<3)p=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{q=f[k>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(o|0)){p=t;break}else s=t}}if((o|0)>0)v=f[(f[a+44>>2]|0)+(o+-1<<2)>>2]|0;else v=0;s=Y(v,p)|0;if(s>>>0<64){p=((Y(s+63|0,c)|0)>>>0)/(s>>>0)|0;f[f[k>>2]>>2]=p;w=f[m>>2]|0}else w=o;o=f[k>>2]|0;m=f[a>>2]&4095;f[h>>2]=1124007936;p=h+4|0;s=h+8|0;c=h+40|0;j=p;l=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(l|0));f[c>>2]=s;s=h+48|0;j=h+44|0;f[j>>2]=s;f[s>>2]=0;f[h+52>>2]=0;hL(h,w,o,m);f[f[k>>2]>>2]=n;if((n|0)>0){f[e>>2]=0;f[e+4>>2]=n;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;lL(i,h,e,g);g=e+8|0;f[g>>2]=0;f[g+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=i;SP(a,e);e=i+36|0;g=f[e>>2]|0;if((g|0?(m=g+12|0,g=f[m>>2]|0,f[m>>2]=g+-1,(g|0)==1):0)?(g=f[e>>2]|0,g|0):0){f[e>>2]=0;m=f[g+4>>2]|0;if(!m){o=f[i+32>>2]|0;if(!o)x=$K()|0;else x=o}else x=m;zh[f[(f[x>>2]|0)+24>>2]&2047](x,g)}f[e>>2]=0;e=i+16|0;g=i+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){e=f[i+40>>2]|0;x=0;do{f[e+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[g>>2]|0))}g=f[i+44>>2]|0;if((g|0)!=(i+48|0))UC(g)}fL(a,h)|0;f[f[k>>2]>>2]=n;k=(f[a+16>>2]|0)+(Y(f[f[a+44>>2]>>2]|0,n)|0)|0;f[a+24>>2]=k;k=h+36|0;a=f[k>>2]|0;if((a|0?(n=a+12|0,a=f[n>>2]|0,f[n>>2]=a+-1,(a|0)==1):0)?(a=f[k>>2]|0,a|0):0){f[k>>2]=0;n=f[a+4>>2]|0;if(!n){g=f[h+32>>2]|0;if(!g)y=$K()|0;else y=g}else y=n;zh[f[(f[y>>2]|0)+24>>2]&2047](y,a)}f[k>>2]=0;k=h+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[p>>2]|0)>0){k=f[c>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[p>>2]|0))}p=f[j>>2]|0;if((p|0)!=(s|0))UC(p);u=d;return}function tL(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;e=u;u=u+352|0;i=e+216|0;j=e+88|0;k=e+32|0;l=e+16|0;m=e+8|0;n=e;if(!c){f[a>>2]=1124007936;o=a+8|0;p=a+40|0;q=a+4|0;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=o;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=e;return}o=f[c>>2]|0;p=o&-65536;if((p|0)==1111621632){s=f[c+24>>2]|0;if((s|0)>-1?(t=f[c+20>>2]|0,(t|0)>-1):0){f[a>>2]=1124007936;v=a+4|0;w=a+8|0;x=a+40|0;q=v;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[x>>2]=w;x=a+48|0;f[a+44>>2]=x;f[x>>2]=0;y=a+52|0;f[y>>2]=0;z=f[c+4>>2]|0;if(d){f[a+16>>2]=0;f[a+24>>2]=0;f[a+20>>2]=0;Qi(i,t,s,o,f[c+16>>2]|0,z);A=j+8|0;f[A>>2]=0;f[A+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=a;SP(i,j);A=i+36|0;B=f[A>>2]|0;if((B|0?(C=B+12|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)?(B=f[A>>2]|0,B|0):0){f[A>>2]=0;C=f[B+4>>2]|0;if(!C){D=f[i+32>>2]|0;if(!D)E=$K()|0;else E=D}else E=C;zh[f[(f[E>>2]|0)+24>>2]&2047](E,B)}f[A>>2]=0;A=i+16|0;B=i+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){A=f[i+40>>2]|0;E=0;do{f[A+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[B>>2]|0))}B=f[i+44>>2]|0;if((B|0)!=(i+48|0))UC(B)}else{f[a>>2]=o&20479|1124007936;f[v>>2]=2;f[w>>2]=t;f[a+12>>2]=s;w=f[c+16>>2]|0;f[a+16>>2]=w;f[a+20>>2]=w;v=(o>>>3&511)+1<<(47696>>>(o<<1&14)&3);B=Y(s,v)|0;s=(z|0)==0?B:z;z=w+(Y(s,t)|0)|0;f[a+28>>2]=z;f[a+24>>2]=z+(0-s)+B;f[x>>2]=s;f[y>>2]=v}u=e;return}}else if((p|0)==1111687168?(v=f[c+16>>2]|0,y=v,v|0):0){v=a+4|0;s=a+8|0;x=a+40|0;q=v;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[x>>2]=s;B=a+48|0;z=a+44|0;f[z>>2]=B;f[B>>2]=0;f[a+52>>2]=0;B=a+16|0;f[B>>2]=y;t=a+20|0;f[t>>2]=y;f[a>>2]=o&4095|1124007936;y=f[c+4>>2]|0;if((y|0)>0){w=0;do{f[i+(w<<2)>>2]=f[c+20+(w<<3)>>2];f[j+(w<<2)>>2]=f[c+20+(w<<3)+4>>2];w=w+1|0}while((w|0)!=(y|0))}YK(a,y,i,j,0);ZK(a);if(d){f[k>>2]=f[a>>2];y=k+4|0;w=f[v>>2]|0;f[y>>2]=w;E=k+8|0;f[E>>2]=f[s>>2];f[k+12>>2]=f[a+12>>2];s=k+16|0;f[s>>2]=f[B>>2];f[k+20>>2]=f[t>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];t=k+32|0;A=a+32|0;f[t>>2]=f[A>>2];C=k+36|0;D=a+36|0;F=f[D>>2]|0;f[C>>2]=F;G=k+40|0;f[G>>2]=E;E=k+48|0;H=k+44|0;f[H>>2]=E;f[E>>2]=0;f[k+52>>2]=0;if(!F)I=w;else{w=F+12|0;f[w>>2]=(f[w>>2]|0)+1;I=f[v>>2]|0}if((I|0)>=3){f[y>>2]=0;YK(k,I,0,0,0);if((f[y>>2]|0)>0){I=f[x>>2]|0;w=f[G>>2]|0;F=f[z>>2]|0;J=f[H>>2]|0;K=0;do{f[w+(K<<2)>>2]=f[I+(K<<2)>>2];f[J+(K<<2)>>2]=f[F+(K<<2)>>2];K=K+1|0}while((K|0)<(f[y>>2]|0))}}else{K=f[z>>2]|0;z=f[H>>2]|0;f[z>>2]=f[K>>2];f[z+4>>2]=f[K+4>>2]}K=f[D>>2]|0;if((K|0?(z=K+12|0,K=f[z>>2]|0,f[z>>2]=K+-1,(K|0)==1):0)?(K=f[D>>2]|0,K|0):0){f[D>>2]=0;z=f[K+4>>2]|0;if(!z){F=f[A>>2]|0;if(!F)L=$K()|0;else L=F}else L=z;zh[f[(f[L>>2]|0)+24>>2]&2047](L,K)}f[D>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[v>>2]|0)>0){B=f[x>>2]|0;x=0;do{f[B+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[v>>2]|0))}v=l+8|0;f[v>>2]=0;f[v+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=a;SP(k,l);l=f[C>>2]|0;if((l|0?(v=l+12|0,l=f[v>>2]|0,f[v>>2]=l+-1,(l|0)==1):0)?(l=f[C>>2]|0,l|0):0){f[C>>2]=0;v=f[l+4>>2]|0;if(!v){x=f[t>>2]|0;if(!x)M=$K()|0;else M=x}else M=v;zh[f[(f[M>>2]|0)+24>>2]&2047](M,l)}f[C>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[y>>2]|0)>0){s=f[G>>2]|0;G=0;do{f[s+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[y>>2]|0))}y=f[H>>2]|0;if((y|0)!=(E|0))UC(y)}u=e;return}if((o|0)==112?(y=c+68|0,f[y>>2]|0):0){if(((g|0)==0?(g=f[c+48>>2]|0,g|0):0)?(f[g>>2]|0)>0:0){f[i>>2]=0;f[i+4>>2]=0;q=aD(i,36)|0;N=180296;r=q+36|0;do{b[q>>0]=b[N>>0]|0;q=q+1|0;N=N+1|0}while((q|0)<(r|0));bO(-24,i,180333,179056,961);bD(i)}f[a>>2]=1124007936;g=a+4|0;E=a+8|0;H=a+40|0;G=g+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;f[G+16>>2]=0;f[G+20>>2]=0;f[G+24>>2]=0;f[G+28>>2]=0;f[H>>2]=E;G=a+48|0;s=a+44|0;f[s>>2]=G;f[a+52>>2]=0;f[g>>2]=2;C=f[c+16>>2]|0;l=1125516576>>>((C>>>2&60)+(C>>31&20)|0);f[G>>2]=f[c+72>>2];C=c+48|0;M=f[C>>2]|0;v=c+28|0;x=(f[v>>2]|0)==0;if(!M){if(x)O=G;else{f[i>>2]=0;f[i+4>>2]=0;q=aD(i,19)|0;N=180344;r=q+19|0;do{b[q>>0]=b[N>>0]|0;q=q+1|0;N=N+1|0}while((q|0)<(r|0));bO(-215,i,180364,179056,706);bD(i);O=f[s>>2]|0}t=((f[c+8>>2]<<3)+-8|l&7)+1124007936|0;f[a>>2]=t;B=f[c+44>>2]|0;f[E>>2]=B;D=f[c+40>>2]|0;K=a+12|0;f[K>>2]=D;L=f[y>>2]|0;f[a+16>>2]=L;f[a+20>>2]=L;P=(t>>>3&511)+1<<(47696>>>(t<<1&14)&3);Q=K;R=B;S=f[O>>2]|0;T=L;U=D;V=t;W=O;X=L}else{if(!x?(f[M>>2]|0)==0:0){f[i>>2]=0;f[i+4>>2]=0;q=aD(i,41)|0;N=180378;r=q+41|0;do{b[q>>0]=b[N>>0]|0;q=q+1|0;N=N+1|0}while((q|0)<(r|0));bO(-215,i,180364,179056,715);bD(i);Z=f[C>>2]|0}else Z=M;M=f[Z>>2]|0;if(M){x=l&7;if((f[v>>2]|0)==1){_=1;$=x;aa=1}else{ba=x;ca=73}}else{ba=l&7;ca=73}if((ca|0)==73){_=f[c+8>>2]|0;$=ba;aa=0}ba=((_<<3)+-8|$)+1124007936|0;f[a>>2]=ba;$=f[Z+16>>2]|0;f[E>>2]=$;_=f[Z+12>>2]|0;ca=a+12|0;f[ca>>2]=_;l=(ba>>>3&511)+1<<(47696>>>(ba<<1&14)&3);if(aa){aa=Y(f[G>>2]|0,M+-1|0)|0;da=Y(aa,f[c+44>>2]|0)|0}else da=0;aa=f[s>>2]|0;M=f[aa>>2]|0;G=(f[y>>2]|0)+da+(Y(M,f[Z+8>>2]|0)|0)|0;da=G+(Y(f[Z+4>>2]|0,l)|0)|0;f[a+16>>2]=da;f[a+20>>2]=da;P=l;Q=ca;R=$;S=M;T=da;U=_;V=ba;W=aa;X=da}da=T+(Y(S,R)|0)|0;f[a+28>>2]=da;aa=Y(P,U)|0;U=T+(Y(R+-1|0,S)|0)+aa|0;f[a+24>>2]=U;f[a>>2]=((R|0)==1|(aa|0)==(S|0)?16384:0)|V;f[W+4>>2]=P;if(!d){u=e;return}f[j>>2]=f[a>>2];P=j+4|0;W=f[g>>2]|0;f[P>>2]=W;V=j+8|0;f[V>>2]=f[E>>2];E=j+12|0;f[E>>2]=f[Q>>2];Q=j+16|0;S=a+16|0;f[Q>>2]=X;f[j+20>>2]=X;f[j+24>>2]=U;f[j+28>>2]=da;da=j+32|0;U=a+32|0;f[da>>2]=f[U>>2];X=j+36|0;aa=a+36|0;R=f[aa>>2]|0;f[X>>2]=R;T=j+40|0;f[T>>2]=V;ba=j+48|0;_=j+44|0;f[_>>2]=ba;f[ba>>2]=0;f[j+52>>2]=0;if(!R)ea=W;else{W=R+12|0;f[W>>2]=(f[W>>2]|0)+1;ea=f[g>>2]|0}if((ea|0)>=3){f[P>>2]=0;YK(j,ea,0,0,0);if((f[P>>2]|0)>0){ea=f[H>>2]|0;W=f[T>>2]|0;R=f[s>>2]|0;M=f[_>>2]|0;$=0;do{f[W+($<<2)>>2]=f[ea+($<<2)>>2];f[M+($<<2)>>2]=f[R+($<<2)>>2];$=$+1|0}while(($|0)<(f[P>>2]|0))}}else{$=f[s>>2]|0;s=f[_>>2]|0;f[s>>2]=f[$>>2];f[s+4>>2]=f[$+4>>2]}$=f[aa>>2]|0;if(($|0?(s=$+12|0,$=f[s>>2]|0,f[s>>2]=$+-1,($|0)==1):0)?($=f[aa>>2]|0,$|0):0){f[aa>>2]=0;s=f[$+4>>2]|0;if(!s){R=f[U>>2]|0;if(!R)fa=$K()|0;else fa=R}else fa=s;zh[f[(f[fa>>2]|0)+24>>2]&2047](fa,$)}f[aa>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[g>>2]|0)>0){S=f[H>>2]|0;H=0;do{f[S+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[g>>2]|0))}g=f[C>>2]|0;if(((g|0)!=0?(C=f[g>>2]|0,(C|0)!=0):0)?(f[v>>2]|0)!=1:0){f[k>>2]=C+-1;f[k+4>>2]=0;C=f[E>>2]|0;E=f[j>>2]&4095;f[i>>2]=f[V>>2];f[i+4>>2]=C;hL(a,2,i,E);zI(j,1,a,1,k,1)}else{k=i+8|0;f[k>>2]=0;f[k+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=a;SP(j,i)}k=f[X>>2]|0;if((k|0?(E=k+12|0,k=f[E>>2]|0,f[E>>2]=k+-1,(k|0)==1):0)?(k=f[X>>2]|0,k|0):0){f[X>>2]=0;E=f[k+4>>2]|0;if(!E){C=f[da>>2]|0;if(!C)ga=$K()|0;else ga=C}else ga=E;zh[f[(f[ga>>2]|0)+24>>2]&2047](ga,k)}f[X>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[P>>2]|0)>0){Q=f[T>>2]|0;T=0;do{f[Q+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[P>>2]|0))}P=f[_>>2]|0;if((P|0)!=(ba|0))UC(P);u=e;return}if((p|0)!=1117323264){f[i>>2]=0;f[i+4>>2]=0;q=aD(i,18)|0;N=180573;r=q+18|0;do{b[q>>0]=b[N>>0]|0;q=q+1|0;N=N+1|0}while((q|0)<(r|0));bO(-5,i,180333,179056,985);bD(i);f[a>>2]=1124007936;N=a+8|0;p=a+40|0;q=a+4|0;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=N;N=a+48|0;f[a+44>>2]=N;f[N>>2]=0;f[a+52>>2]=0;u=e;return}N=f[c+24>>2]|0;p=o&4095;P=f[c+28>>2]|0;if(!N){f[a>>2]=1124007936;ba=a+8|0;_=a+40|0;q=a+4|0;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[_>>2]=ba;ba=a+48|0;f[a+44>>2]=ba;f[ba>>2]=0;f[a+52>>2]=0;u=e;return}if(!((N|0)>0?((o>>>3&511)+1<<(47696>>>(o<<1&14)&3)|0)==(P|0):0)){f[i>>2]=0;f[i+4>>2]=0;Vac(aD(i,152)|0,180420,152)|0;bO(-215,i,180333,179056,970);bD(i)}if(!d?(d=f[c+52>>2]|0,(f[d+4>>2]|0)==(d|0)):0){Qi(a,N,1,p,f[d+16>>2]|0,0);u=e;return}if(h|0){d=(Y(P,N)|0)+7|0;P=d>>>3;o=h+4|0;do if((f[o>>2]|0)>>>0<P>>>0){ba=f[h>>2]|0;_=h+8|0;if((ba|0)==(_|0))ha=ba;else{if(ba|0)P5b(ba);f[h>>2]=_;f[o>>2]=136;ha=_}f[o>>2]=P;if(d>>>0>1095){_=N5b(P<<3)|0;f[h>>2]=_;ia=_;break}else{ia=ha;break}}else{f[o>>2]=P;ia=f[h>>2]|0}while(0);h=m;f[h>>2]=0;f[h+4>>2]=0;f[m+4>>2]=1073741823;f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2];LW(c,ia,i)|0;Qi(a,N,1,p,ia,0);u=e;return}f[j>>2]=1124007936;ia=j+4|0;m=j+8|0;h=j+40|0;q=ia;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[h>>2]=m;q=j+48|0;r=j+44|0;f[r>>2]=q;f[q>>2]=0;f[j+52>>2]=0;f[i>>2]=N;f[i+4>>2]=1;hL(j,2,i,p);p=j+16|0;N=f[p>>2]|0;P=n;f[P>>2]=0;f[P+4>>2]=0;f[n+4>>2]=1073741823;f[i>>2]=f[n>>2];f[i+4>>2]=f[n+4>>2];LW(c,N,i)|0;f[a>>2]=f[j>>2];i=a+4|0;N=f[ia>>2]|0;f[i>>2]=N;c=a+8|0;f[c>>2]=f[m>>2];f[a+12>>2]=f[j+12>>2];f[a+16>>2]=f[p>>2];f[a+20>>2]=f[j+20>>2];f[a+24>>2]=f[j+24>>2];f[a+28>>2]=f[j+28>>2];m=j+32|0;f[a+32>>2]=f[m>>2];n=j+36|0;j=f[n>>2]|0;f[a+36>>2]=j;P=a+40|0;f[P>>2]=c;c=a+48|0;o=a+44|0;f[o>>2]=c;f[c>>2]=0;f[a+52>>2]=0;if(!j)ja=N;else{N=j+12|0;f[N>>2]=(f[N>>2]|0)+1;ja=f[ia>>2]|0}if((ja|0)>=3){f[i>>2]=0;YK(a,ja,0,0,0);if((f[i>>2]|0)>0){ja=f[h>>2]|0;a=f[P>>2]|0;P=f[r>>2]|0;N=f[o>>2]|0;j=0;do{f[a+(j<<2)>>2]=f[ja+(j<<2)>>2];f[N+(j<<2)>>2]=f[P+(j<<2)>>2];j=j+1|0}while((j|0)<(f[i>>2]|0))}}else{i=f[r>>2]|0;j=f[o>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2]}i=f[n>>2]|0;if((i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)?(i=f[n>>2]|0,i|0):0){f[n>>2]=0;j=f[i+4>>2]|0;if(!j){o=f[m>>2]|0;if(!o)ka=$K()|0;else ka=o}else ka=j;zh[f[(f[ka>>2]|0)+24>>2]&2047](ka,i)}f[n>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[ia>>2]|0)>0){p=f[h>>2]|0;h=0;do{f[p+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[ia>>2]|0))}ia=f[r>>2]|0;if((ia|0)!=(q|0))UC(ia);u=e;return}function uL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e;h=a+4|0;i=f[h>>2]|0;if((i|0)<3?(f[f[a+44>>2]>>2]|0)!=0:0)j=i;else{f[g>>2]=0;f[g+4>>2]=0;i=aD(g,24)|0;k=180592;l=i+24|0;do{b[i>>0]=b[k>>0]|0;i=i+1|0;k=k+1|0}while((i|0)<(l|0));bO(-215,g,180617,179056,991);bD(g);j=f[h>>2]|0}if((j|0)>0)m=f[(f[a+44>>2]|0)+(j+-1<<2)>>2]|0;else m=0;j=f[a+20>>2]|0;h=(f[a+16>>2]|0)-j|0;g=(f[a+24>>2]|0)-j|0;if(!h){f[d+4>>2]=0;n=0;o=f[a+44>>2]|0;p=0}else{j=f[a+44>>2]|0;k=(h>>>0)/((f[j>>2]|0)>>>0)|0;f[d+4>>2]=k;n=((h-(Y(f[j>>2]|0,k)|0)|0)>>>0)/(m>>>0)|0;o=j;p=k}f[d>>2]=n;d=(f[a+12>>2]|0)+n|0;n=g-(Y(d,m)|0)|0;k=((n>>>0)/((f[o>>2]|0)>>>0)|0)+1|0;o=(f[a+8>>2]|0)+p|0;p=(k|0)<(o|0)?o:k;f[c+4>>2]=p;k=((g-(Y(p+-1|0,f[a+48>>2]|0)|0)|0)>>>0)/(m>>>0)|0;f[c>>2]=(k|0)<(d|0)?d:k;u=e;return}function vL(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=u;u=u+16|0;i=h+8|0;j=h;k=a+4|0;l=f[k>>2]|0;if((l|0)<3?(f[f[a+44>>2]>>2]|0)!=0:0)m=l;else{f[i>>2]=0;f[i+4>>2]=0;l=aD(i,24)|0;n=180592;o=l+24|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(o|0));bO(-215,i,180627,179056,1012);bD(i);m=f[k>>2]|0}f[i>>2]=0;k=i+4|0;f[k>>2]=0;f[j>>2]=0;n=j+4|0;f[n>>2]=0;l=a+44|0;if((m|0)>0)p=f[(f[l>>2]|0)+(m+-1<<2)>>2]|0;else p=0;uL(a,i,j);m=f[n>>2]|0;n=m-c|0;c=f[k>>2]|0;k=(n|0)>0?n:0;n=(c|0)<(k|0)?c:k;k=a+8|0;o=m+d+(f[k>>2]|0)|0;d=(c|0)<(o|0)?c:o;o=(d|0)>0?d:0;d=f[j>>2]|0;j=d-e|0;e=f[i>>2]|0;i=(j|0)>0?j:0;j=(e|0)<(i|0)?e:i;i=a+12|0;c=d+g+(f[i>>2]|0)|0;g=(e|0)<(c|0)?e:c;c=(g|0)>0?g:0;g=(n|0)>(o|0);e=g?o:n;q=(j|0)>(c|0);r=q?c:j;s=(Y(r-d|0,p)|0)+(Y(e-m|0,f[a+48>>2]|0)|0)|0;m=a+16|0;f[m>>2]=(f[m>>2]|0)+s;s=(g?n:o)-e|0;f[k>>2]=s;f[i>>2]=(q?j:c)-r;r=f[a+40>>2]|0;f[r>>2]=s;f[r+4>>2]=f[i>>2];r=Y(f[i>>2]|0,p)|0;p=f[a>>2]|0;if((r|0)!=(f[f[l>>2]>>2]|0)?(f[k>>2]|0)!=1:0){t=p&-16385;f[a>>2]=t;u=h;return a|0}t=p|16384;f[a>>2]=t;u=h;return a|0}function wL(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;j=u;u=u+16|0;k=j;l=j+8|0;m=f[a>>2]|0;n=m&2031616;o=e&4095;p=n&2097151;a:do if((p|0)<655360){if((p|0)>=131072){switch(p|0){case 131072:break;default:break a}if((g|0)<0)q=m;else{f[l>>2]=0;f[l+4>>2]=0;r=aD(l,5)|0;b[r>>0]=b[180637]|0;b[r+1>>0]=b[180638]|0;b[r+2>>0]=b[180639]|0;b[r+3>>0]=b[180640]|0;b[r+4>>0]=b[180641]|0;bO(-215,l,440241,179056,2540);bD(l);q=f[a>>2]|0}r=q&4095;do if((o|0)!=(r|0)){if((e&4088|0)==0?1<<r&i|0:0)break;f[l>>2]=0;f[l+4>>2]=0;s=aD(l,106)|0;t=181071;v=s+106|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2542);bD(l)}while(0);if((c|0)==2){r=f[d>>2]|0;w=a+8|0;x=f[a+12>>2]|0;if((r|0)==(x|0)?(f[d+4>>2]|0)==(f[w>>2]|0):0){u=j;return}if((h?(r|0)==(f[w>>2]|0):0)?(f[d+4>>2]|0)==(x|0):0){u=j;return}}f[l>>2]=0;f[l+4>>2]=0;Vac(aD(l,129)|0,181178,129)|0;bO(-215,l,440241,179056,2544);bD(l);u=j;return}switch(p|0){case 65536:break;default:break a}if((g|0)>=0){f[l>>2]=0;f[l+4>>2]=0;x=aD(l,5)|0;b[x>>0]=b[180637]|0;b[x+1>>0]=b[180638]|0;b[x+2>>0]=b[180639]|0;b[x+3>>0]=b[180640]|0;b[x+4>>0]=b[180641]|0;bO(-215,l,440241,179056,2472);bD(l)}x=f[a+4>>2]|0;if(h){if(!(f[x>>2]&16384)){if((f[a>>2]|0)>>>0>1073741823){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,28)|0;t=180965;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2478);bD(l)}w=x+36|0;r=f[w>>2]|0;if((r|0?(y=r+12|0,r=f[y>>2]|0,f[y>>2]=r+-1,(r|0)==1):0)?(r=f[w>>2]|0,r|0):0){f[w>>2]=0;y=f[r+4>>2]|0;if(!y){z=f[x+32>>2]|0;if(!z)A=$K()|0;else A=z}else A=y;zh[f[(f[A>>2]|0)+24>>2]&2047](A,r)}f[w>>2]=0;w=x+16|0;r=x+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[r>>2]|0)>0){w=f[x+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[r>>2]|0))}}if((((((c|0)==2?(f[x+4>>2]|0)==2:0)?f[x+16>>2]|0:0)?(f[x>>2]&4095|0)==(o|0):0)?(f[x+8>>2]|0)==(f[d+4>>2]|0):0)?(f[x+12>>2]|0)==(f[d>>2]|0):0){u=j;return}}r=f[a>>2]|0;do if((r|0)<0){y=f[x>>2]|0;if(((y^e)&4088|0)==0?1<<(r&4095)&i|0:0){B=y&4095;C=r;break}if((o|0)!=(y&4095|0)){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,42)|0;t=180994;v=s+42|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2492);bD(l);B=o;C=f[a>>2]|0}else{B=o;C=r}}else{B=o;C=r}while(0);if(C&1073741824|0){if((f[x+4>>2]|0)!=(c|0)){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,11)|0;t=181037;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2496);bD(l)}if((c|0)>0){r=x+40|0;y=l+4|0;w=0;do{if((f[(f[r>>2]|0)+(w<<2)>>2]|0)!=(f[d+(w<<2)>>2]|0)){f[l>>2]=0;f[y>>2]=0;s=aD(l,21)|0;t=181049;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2498);bD(l)}w=w+1|0}while((w|0)<(c|0))}}hL(x,c,d,B);u=j;return}else{if((p|0)>=917504){switch(p|0){case 917504:break;default:break a}w=m&4095;do if((o|0)!=(w|0)){if((e&4088|0)==0?1<<w&i|0:0)break;f[l>>2]=0;f[l+4>>2]=0;s=aD(l,106)|0;t=181071;v=s+106|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2551);bD(l)}while(0);if((c|0)==2?(w=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0,(w|0)==(Y(f[d+4>>2]|0,f[d>>2]|0)|0)):0){u=j;return}f[l>>2]=0;f[l+4>>2]=0;s=aD(l,40)|0;t=181308;v=s+40|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2552);bD(l);u=j;return}switch(p|0){case 655360:break;default:break a}if((g|0)>=0){f[l>>2]=0;f[l+4>>2]=0;w=aD(l,5)|0;b[w>>0]=b[180637]|0;b[w+1>>0]=b[180638]|0;b[w+2>>0]=b[180639]|0;b[w+3>>0]=b[180640]|0;b[w+4>>0]=b[180641]|0;bO(-215,l,440241,179056,2506);bD(l)}w=f[a+4>>2]|0;if(h){if(!(f[w>>2]&16384)){if((f[a>>2]|0)>>>0>1073741823){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,28)|0;t=180965;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2512);bD(l)}x=w+24|0;y=f[x>>2]|0;if(y|0?(r=y+8|0,y=f[r>>2]|0,f[r>>2]=y+-1,(y|0)==1):0)iI(w);y=w+4|0;if((f[y>>2]|0)>0){r=f[w+32>>2]|0;z=0;do{f[r+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[y>>2]|0))}f[x>>2]=0}if(((((((c|0)==2?(f[w+4>>2]|0)==2:0)?f[w+24>>2]|0:0)?(y=f[w+8>>2]|0,z=f[w+12>>2]|0,Y(z,y)|0):0)?(f[w>>2]&4095|0)==(o|0):0)?(y|0)==(f[d+4>>2]|0):0)?(z|0)==(f[d>>2]|0):0){u=j;return}}z=f[a>>2]|0;do if((z|0)<0){y=f[w>>2]|0;if(((y^e)&4088|0)==0?1<<(z&4095)&i|0:0){D=y&4095;E=z;break}if((o|0)!=(y&4095|0)){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,42)|0;t=180994;v=s+42|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2526);bD(l);D=o;E=f[a>>2]|0}else{D=o;E=z}}else{D=o;E=z}while(0);if(E&1073741824|0){if((f[w+4>>2]|0)!=(c|0)){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,11)|0;t=181037;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2530);bD(l)}if((c|0)>0){z=w+32|0;x=l+4|0;y=0;do{if((f[(f[z>>2]|0)+(y<<2)>>2]|0)!=(f[d+(y<<2)>>2]|0)){f[l>>2]=0;f[x>>2]=0;s=aD(l,21)|0;t=181049;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2532);bD(l)}y=y+1|0}while((y|0)<(c|0))}}eI(w,c,d,D,0);u=j;return}while(0);D=(n|0)==262144;E=n&2097151;b:do if((E|0)<327680){if((E|0)<196608){switch(E|0){case 0:break;default:break b}f[l>>2]=0;f[l+4>>2]=0;s=aD(l,44)|0;t=181746;v=s+44|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-27,l,440241,179056,2640);bD(l);u=j;return}if((E|0)<262144)switch(E|0){case 196608:break;default:break b}else switch(E|0){case 262144:break;default:break b}if((c|0)==2){w=f[d>>2]|0;if((w|0)!=1){n=f[d+4>>2]|0;if((n|0)==1|(Y(n,w)|0)==0)F=w;else G=98}else F=1}else G=98;if((G|0)==98){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,68)|0;t=181349;v=s+68|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2558);bD(l);F=f[d>>2]|0}w=f[d+4>>2]|0;n=(Y(w,F)|0)>0;p=n?F+-1+w|0:0;w=f[a+4>>2]|0;n=(g|0)<0;do if(!D)if(n)H=w;else{f[l>>2]=0;f[l+4>>2]=0;B=aD(l,5)|0;b[B>>0]=b[180637]|0;b[B+1>>0]=b[180638]|0;b[B+2>>0]=b[180639]|0;b[B+3>>0]=b[180640]|0;b[B+4>>0]=b[180641]|0;bO(-215,l,440241,179056,2575);bD(l);H=w}else{if(!n){B=f[w>>2]|0;if((((f[w+4>>2]|0)-B|0)/12|0|0)>(g|0))I=B;else{f[l>>2]=0;f[l+4>>2]=0;s=aD(l,18)|0;t=180932;v=s+18|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2571);bD(l);I=f[w>>2]|0}H=I+(g*12|0)|0;break}B=w+4|0;if((f[a>>2]&1073741824|0)!=0?(p|0)!=(((f[B>>2]|0)-(f[w>>2]|0)|0)/12|0|0):0){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,32)|0;t=181418;v=s+32|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2567);bD(l);J=w}else J=w;C=f[B>>2]|0;A=f[J>>2]|0;q=(C-A|0)/12|0;y=C;if(p>>>0>q>>>0){CL(w,p-q|0);u=j;return}if(p>>>0>=q>>>0){u=j;return}q=A+(p*12|0)|0;if((y|0)==(q|0)){u=j;return}else K=y;while(1){y=K+-12|0;f[B>>2]=y;A=f[y>>2]|0;if(!A)L=y;else{y=K+-8|0;if((f[y>>2]|0)!=(A|0))f[y>>2]=A;O5b(A);L=f[B>>2]|0}if((L|0)==(q|0))break;else K=L}u=j;return}while(0);w=f[a>>2]|0;n=w&4095;do if((o|0)==(n|0))M=w;else{if(((w^e)&4088|0)==0?1<<n&i|0:0){M=w;break}f[l>>2]=0;f[l+4>>2]=0;Vac(aD(l,146)|0,181451,146)|0;bO(-215,l,440241,179056,2578);bD(l);M=f[a>>2]|0}while(0);n=(w>>>3&511)+1<<(47696>>>(w<<1&14)&3);if(M&1073741824|0?(p|0)!=((((f[H+4>>2]|0)-(f[H>>2]|0)|0)>>>0)/(n>>>0)|0|0):0){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,61)|0;t=181598;v=s+61|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2581);bD(l)}do switch(n&8191){case 1:{w=H+4|0;q=f[w>>2]|0;B=f[H>>2]|0;A=q-B|0;if(p>>>0>A>>>0){DL(H,p-A|0);u=j;return}if(p>>>0>=A>>>0){u=j;return}A=B+p|0;if((q|0)==(A|0)){u=j;return}f[w>>2]=A;u=j;return}case 2:{A=H+4|0;w=f[A>>2]|0;q=f[H>>2]|0;B=w-q>>1;y=w;if(p>>>0>B>>>0){EL(H,p-B|0);u=j;return}if(p>>>0>=B>>>0){u=j;return}B=q+(p<<1)|0;if((y|0)==(B|0)){u=j;return}f[A>>2]=y+(~((0-B+(y+-2)|0)>>>1)<<1);u=j;return}case 3:{y=H+4|0;B=f[y>>2]|0;A=f[H>>2]|0;q=(B-A|0)/3|0;w=B;if(p>>>0>q>>>0){FL(H,p-q|0);u=j;return}if(p>>>0>=q>>>0){u=j;return}q=A+(p*3|0)|0;if((w|0)==(q|0)){u=j;return}f[y>>2]=w+(~(((0-q+(w+-3)|0)>>>0)/3|0)*3|0);u=j;return}case 4:{w=H+4|0;q=f[w>>2]|0;y=f[H>>2]|0;A=q-y>>2;B=q;if(p>>>0>A>>>0){HC(H,p-A|0);u=j;return}if(p>>>0>=A>>>0){u=j;return}A=y+(p<<2)|0;if((B|0)==(A|0)){u=j;return}f[w>>2]=B+(~((B+-4-A|0)>>>2)<<2);u=j;return}case 6:{A=H+4|0;B=f[A>>2]|0;w=f[H>>2]|0;y=(B-w|0)/6|0;q=B;if(p>>>0>y>>>0){GL(H,p-y|0);u=j;return}if(p>>>0>=y>>>0){u=j;return}y=w+(p*6|0)|0;if((q|0)==(y|0)){u=j;return}f[A>>2]=q+(~(((q+-6-y|0)>>>0)/6|0)*6|0);u=j;return}case 8:{y=H+4|0;q=f[y>>2]|0;A=f[H>>2]|0;w=q-A>>3;B=q;if(p>>>0>w>>>0){HL(H,p-w|0);u=j;return}if(p>>>0>=w>>>0){u=j;return}w=A+(p<<3)|0;if((B|0)==(w|0)){u=j;return}f[y>>2]=B+(~((B+-8-w|0)>>>3)<<3);u=j;return}case 12:{w=H+4|0;B=f[w>>2]|0;y=f[H>>2]|0;A=(B-y|0)/12|0;q=B;if(p>>>0>A>>>0){IL(H,p-A|0);u=j;return}if(p>>>0>=A>>>0){u=j;return}A=y+(p*12|0)|0;if((q|0)==(A|0)){u=j;return}f[w>>2]=q+(~(((q+-12-A|0)>>>0)/12|0)*12|0);u=j;return}case 16:{A=H+4|0;q=f[A>>2]|0;w=f[H>>2]|0;y=q-w>>4;B=q;if(p>>>0>y>>>0){JL(H,p-y|0);u=j;return}if(p>>>0>=y>>>0){u=j;return}y=w+(p<<4)|0;if((B|0)==(y|0)){u=j;return}f[A>>2]=B+(~((B+-16-y|0)>>>4)<<4);u=j;return}case 24:{y=H+4|0;B=f[y>>2]|0;A=f[H>>2]|0;w=(B-A|0)/24|0;q=B;if(p>>>0>w>>>0){KL(H,p-w|0);u=j;return}if(p>>>0>=w>>>0){u=j;return}w=A+(p*24|0)|0;if((q|0)==(w|0)){u=j;return}f[y>>2]=q+(~(((q+-24-w|0)>>>0)/24|0)*24|0);u=j;return}case 32:{w=H+4|0;q=f[w>>2]|0;y=f[H>>2]|0;A=q-y>>5;B=q;if(p>>>0>A>>>0){LL(H,p-A|0);u=j;return}if(p>>>0>=A>>>0){u=j;return}A=y+(p<<5)|0;if((B|0)==(A|0)){u=j;return}f[w>>2]=B+(~((B+-32-A|0)>>>5)<<5);u=j;return}case 36:{A=H+4|0;B=f[A>>2]|0;w=f[H>>2]|0;y=(B-w|0)/36|0;q=B;if(p>>>0>y>>>0){ML(H,p-y|0);u=j;return}if(p>>>0>=y>>>0){u=j;return}y=w+(p*36|0)|0;if((q|0)==(y|0)){u=j;return}f[A>>2]=q+(~(((q+-36-y|0)>>>0)/36|0)*36|0);u=j;return}case 48:{y=H+4|0;q=f[y>>2]|0;A=f[H>>2]|0;w=(q-A|0)/48|0;B=q;if(p>>>0>w>>>0){NL(H,p-w|0);u=j;return}if(p>>>0>=w>>>0){u=j;return}w=A+(p*48|0)|0;if((B|0)==(w|0)){u=j;return}f[y>>2]=B+(~(((B+-48-w|0)>>>0)/48|0)*48|0);u=j;return}case 64:{w=H+4|0;B=f[w>>2]|0;y=f[H>>2]|0;A=B-y>>6;q=B;if(p>>>0>A>>>0){OL(H,p-A|0);u=j;return}if(p>>>0>=A>>>0){u=j;return}A=y+(p<<6)|0;if((q|0)==(A|0)){u=j;return}f[w>>2]=q+(~((q+-64-A|0)>>>6)<<6);u=j;return}case 128:{A=H+4|0;q=f[A>>2]|0;w=f[H>>2]|0;y=q-w>>7;B=q;if(p>>>0>y>>>0){PL(H,p-y|0);u=j;return}if(p>>>0>=y>>>0){u=j;return}y=w+(p<<7)|0;if((B|0)==(y|0)){u=j;return}f[A>>2]=B+(~((B+-128-y|0)>>>7)<<7);u=j;return}case 256:{y=H+4|0;B=f[y>>2]|0;A=f[H>>2]|0;w=B-A>>8;q=B;if(p>>>0>w>>>0){QL(H,p-w|0);u=j;return}if(p>>>0>=w>>>0){u=j;return}w=A+(p<<8)|0;if((q|0)==(w|0)){u=j;return}f[y>>2]=q+(~((q+-256-w|0)>>>8)<<8);u=j;return}case 512:{w=H+4|0;q=f[w>>2]|0;y=f[H>>2]|0;A=q-y>>9;B=q;if(p>>>0>A>>>0){RL(H,p-A|0);u=j;return}if(p>>>0>=A>>>0){u=j;return}A=y+(p<<9)|0;if((B|0)==(A|0)){u=j;return}f[w>>2]=B+(~((B+-512-A|0)>>>9)<<9);u=j;return}default:{f[k>>2]=n;hO(l,181660,k);bO(-5,l,440241,179056,2633);bD(l);u=j;return}}while(0)}else{if((E|0)<720896){switch(E|0){case 327680:break;default:break b}n=f[a+4>>2]|0;if((g|0)<0){if((c|0)==2){p=f[d>>2]|0;if((p|0)!=1){A=f[d+4>>2]|0;if((A|0)==1|(Y(A,p)|0)==0){N=p;O=m}else G=214}else{N=1;O=m}}else G=214;if((G|0)==214){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,68)|0;t=181349;v=s+68|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2650);bD(l);N=f[d>>2]|0;O=f[a>>2]|0}p=f[d+4>>2]|0;A=(Y(p,N)|0)>0;B=A?N+-1+p|0:0;p=((f[n+4>>2]|0)-(f[n>>2]|0)|0)/56|0;if(!((O&1073741824|0)==0|(B|0)==(p|0))){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,27)|0;t=181791;v=s+27|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2653);bD(l)}SL(n,B);A=f[a>>2]|0;if((A|0)>=0){u=j;return}w=A&4095;if(p>>>0>=B>>>0){u=j;return}A=l+4|0;y=p;q=f[n>>2]|0;while(1){C=f[q+(y*56|0)>>2]|0;if((C&4095|0)==(w|0))P=q;else{if(f[q+(y*56|0)+16>>2]|0){x=f[q+(y*56|0)+4>>2]|0;if((x|0)<3)Q=Y(f[q+(y*56|0)+12>>2]|0,f[q+(y*56|0)+8>>2]|0)|0;else{z=f[q+(y*56|0)+40>>2]|0;r=0;R=1;while(1){S=Y(f[z+(r<<2)>>2]|0,R)|0;r=r+1|0;if((r|0)==(x|0)){Q=S;break}else R=S}}if(!((x|0)==0|(Q|0)==0)){f[l>>2]=0;f[A>>2]=0;s=aD(l,12)|0;t=181819;v=s+12|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2662);bD(l);x=f[n>>2]|0;T=x;U=f[x+(y*56|0)>>2]|0}else{T=q;U=C}}else{T=q;U=C}f[T+(y*56|0)>>2]=U&-4096|w;P=T}y=y+1|0;if(y>>>0>=B>>>0)break;else q=P}u=j;return}q=f[n>>2]|0;if((((f[n+4>>2]|0)-q|0)/56|0|0)>(g|0))V=q;else{f[l>>2]=0;f[l+4>>2]=0;s=aD(l,17)|0;t=181832;v=s+17|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2669);bD(l);V=f[n>>2]|0}q=V+(g*56|0)|0;if(h){if(!(f[q>>2]&16384)){if((f[a>>2]|0)>>>0>1073741823){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,28)|0;t=180965;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2676);bD(l)}n=V+(g*56|0)+36|0;B=f[n>>2]|0;if((B|0?(y=B+12|0,B=f[y>>2]|0,f[y>>2]=B+-1,(B|0)==1):0)?(B=f[n>>2]|0,B|0):0){f[n>>2]=0;y=f[B+4>>2]|0;if(!y){w=f[V+(g*56|0)+32>>2]|0;if(!w)W=$K()|0;else W=w}else W=y;zh[f[(f[W>>2]|0)+24>>2]&2047](W,B)}f[n>>2]=0;n=V+(g*56|0)+16|0;B=V+(g*56|0)+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[B>>2]|0)>0){n=f[V+(g*56|0)+40>>2]|0;y=0;do{f[n+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[B>>2]|0))}}if((((((c|0)==2?(f[V+(g*56|0)+4>>2]|0)==2:0)?f[V+(g*56|0)+16>>2]|0:0)?(f[q>>2]&4095|0)==(o|0):0)?(f[V+(g*56|0)+8>>2]|0)==(f[d+4>>2]|0):0)?(f[V+(g*56|0)+12>>2]|0)==(f[d>>2]|0):0){u=j;return}}B=f[a>>2]|0;do if((B|0)<0){y=f[q>>2]|0;if(((y^e)&4088|0)==0?1<<(B&4095)&i|0:0){X=y&4095;Z=B;break}if((o|0)!=(y&4095|0)){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,42)|0;t=180994;v=s+42|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2690);bD(l);X=o;Z=f[a>>2]|0}else{X=o;Z=B}}else{X=o;Z=B}while(0);if(Z&1073741824|0){if((f[V+(g*56|0)+4>>2]|0)!=(c|0)){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,11)|0;t=181037;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2694);bD(l)}if((c|0)>0){B=V+(g*56|0)+40|0;C=l+4|0;y=0;do{if((f[(f[B>>2]|0)+(y<<2)>>2]|0)!=(f[d+(y<<2)>>2]|0)){f[l>>2]=0;f[C>>2]=0;s=aD(l,21)|0;t=181049;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2696);bD(l)}y=y+1|0}while((y|0)<(c|0))}}hL(q,c,d,X);u=j;return}if((E|0)>=983040){switch(E|0){case 983040:break;default:break b}y=f[a+4>>2]|0;if((g|0)<0){if((c|0)==2){C=f[d>>2]|0;if((C|0)!=1){B=f[d+4>>2]|0;if((B|0)==1|(Y(B,C)|0)==0)_=C;else G=272}else _=1}else G=272;if((G|0)==272){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,68)|0;t=181349;v=s+68|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2709);bD(l);_=f[d>>2]|0}q=f[d+4>>2]|0;C=(Y(q,_)|0)>0;B=C?_+-1+q|0:0;q=f[a+12>>2]|0;if((B|0)!=(q|0)){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,11)|0;t=181850;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2712);bD(l)}C=f[a>>2]|0;if((C|0)>=0){u=j;return}n=C&4095;if(q>>>0>=B>>>0){u=j;return}C=l+4|0;w=q;do{A=y+(w*56|0)|0;p=f[A>>2]|0;if((p&4095|0)!=(n|0)){if(f[y+(w*56|0)+16>>2]|0){x=f[y+(w*56|0)+4>>2]|0;if((x|0)<3)$=Y(f[y+(w*56|0)+12>>2]|0,f[y+(w*56|0)+8>>2]|0)|0;else{R=f[y+(w*56|0)+40>>2]|0;r=0;z=1;while(1){S=Y(f[R+(r<<2)>>2]|0,z)|0;r=r+1|0;if((r|0)==(x|0)){$=S;break}else z=S}}if(!((x|0)==0|($|0)==0)){f[l>>2]=0;f[C>>2]=0;s=aD(l,12)|0;t=181819;v=s+12|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2720);bD(l);aa=f[A>>2]|0}else aa=p}else aa=p;f[A>>2]=aa&-4096|n}w=w+1|0}while(w>>>0<B>>>0);u=j;return}if((f[a+12>>2]|0)<=(g|0)){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,13)|0;t=180951;v=s+13|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2727);bD(l)}B=y+(g*56|0)|0;if(h){if(!(f[B>>2]&16384)){if((f[a>>2]|0)>>>0>1073741823){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,28)|0;t=180965;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2734);bD(l)}w=y+(g*56|0)+36|0;n=f[w>>2]|0;if((n|0?(C=n+12|0,n=f[C>>2]|0,f[C>>2]=n+-1,(n|0)==1):0)?(n=f[w>>2]|0,n|0):0){f[w>>2]=0;C=f[n+4>>2]|0;if(!C){q=f[y+(g*56|0)+32>>2]|0;if(!q)ba=$K()|0;else ba=q}else ba=C;zh[f[(f[ba>>2]|0)+24>>2]&2047](ba,n)}f[w>>2]=0;w=y+(g*56|0)+16|0;n=y+(g*56|0)+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[n>>2]|0)>0){w=f[y+(g*56|0)+40>>2]|0;C=0;do{f[w+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[n>>2]|0))}}if((((((c|0)==2?(f[y+(g*56|0)+4>>2]|0)==2:0)?f[y+(g*56|0)+16>>2]|0:0)?(f[B>>2]&4095|0)==(o|0):0)?(f[y+(g*56|0)+8>>2]|0)==(f[d+4>>2]|0):0)?(f[y+(g*56|0)+12>>2]|0)==(f[d>>2]|0):0){u=j;return}}n=f[a>>2]|0;do if((n|0)<0){C=f[B>>2]|0;if(((C^e)&4088|0)==0?1<<(n&4095)&i|0:0){ca=C&4095;da=n;break}if((o|0)!=(C&4095|0)){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,42)|0;t=180994;v=s+42|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2748);bD(l);ca=o;da=f[a>>2]|0}else{ca=o;da=n}}else{ca=o;da=n}while(0);if(da&1073741824|0){if((f[y+(g*56|0)+4>>2]|0)!=(c|0)){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,11)|0;t=181037;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2753);bD(l)}if((c|0)>0){n=y+(g*56|0)+40|0;A=l+4|0;p=0;do{if((f[(f[n>>2]|0)+(p<<2)>>2]|0)!=(f[d+(p<<2)>>2]|0)){f[l>>2]=0;f[A>>2]=0;s=aD(l,21)|0;t=181049;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2755);bD(l)}p=p+1|0}while((p|0)<(c|0))}}hL(B,c,d,ca);u=j;return}switch(E|0){case 720896:break;default:break b}p=f[a+4>>2]|0;if((g|0)<0){if((c|0)==2){A=f[d>>2]|0;if((A|0)!=1){n=f[d+4>>2]|0;if((n|0)==1|(Y(n,A)|0)==0){ea=A;fa=m}else G=329}else{ea=1;fa=m}}else G=329;if((G|0)==329){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,68)|0;t=181349;v=s+68|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2768);bD(l);ea=f[d>>2]|0;fa=f[a>>2]|0}B=f[d+4>>2]|0;A=(Y(B,ea)|0)>0;n=A?ea+-1+B|0:0;B=p+4|0;A=f[B>>2]|0;y=f[p>>2]|0;C=(A-y|0)/48|0;if((fa&1073741824|0)==0|(n|0)==(C|0)){ga=y;ha=A}else{f[l>>2]=0;f[l+4>>2]=0;s=aD(l,27)|0;t=181791;v=s+27|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2771);bD(l);ga=f[p>>2]|0;ha=f[B>>2]|0}A=(ha-ga|0)/48|0;y=ga;w=ha;if(n>>>0<=A>>>0){if(n>>>0<A>>>0?(q=y+(n*48|0)|0,(w|0)!=(q|0)):0){y=w;do{w=y+-48|0;f[B>>2]=w;hI(w);y=f[B>>2]|0}while((y|0)!=(q|0))}}else TL(p,n-A|0);q=f[a>>2]|0;if((q|0)>=0){u=j;return}y=q&4095;if(C>>>0>=n>>>0){u=j;return}q=l+4|0;B=C;w=f[p>>2]|0;while(1){x=f[w+(B*48|0)>>2]|0;if((x&4095|0)==(y|0))ia=w;else{if(f[w+(B*48|0)+24>>2]|0){z=f[w+(B*48|0)+4>>2]|0;if((z|0)<3)ja=Y(f[w+(B*48|0)+12>>2]|0,f[w+(B*48|0)+8>>2]|0)|0;else{r=f[w+(B*48|0)+32>>2]|0;R=0;S=1;while(1){ka=Y(f[r+(R<<2)>>2]|0,S)|0;R=R+1|0;if((R|0)==(z|0)){ja=ka;break}else S=ka}}if(!((z|0)==0|(ja|0)==0)){f[l>>2]=0;f[q>>2]=0;s=aD(l,12)|0;t=181819;v=s+12|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2780);bD(l);z=f[p>>2]|0;la=z;ma=f[z+(B*48|0)>>2]|0}else{la=w;ma=x}}else{la=w;ma=x}f[la+(B*48|0)>>2]=ma&-4096|y;ia=la}B=B+1|0;if(B>>>0>=n>>>0)break;else w=ia}u=j;return}w=f[p>>2]|0;if((((f[p+4>>2]|0)-w|0)/48|0|0)>(g|0))na=w;else{f[l>>2]=0;f[l+4>>2]=0;s=aD(l,17)|0;t=181832;v=s+17|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2787);bD(l);na=f[p>>2]|0}w=na+(g*48|0)|0;if(h){if(!(f[w>>2]&16384)){if((f[a>>2]|0)>>>0>1073741823){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,28)|0;t=180965;v=s+28|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2794);bD(l)}p=na+(g*48|0)+24|0;n=f[p>>2]|0;if(n|0?(B=n+8|0,n=f[B>>2]|0,f[B>>2]=n+-1,(n|0)==1):0)iI(w);n=na+(g*48|0)+4|0;if((f[n>>2]|0)>0){B=f[na+(g*48|0)+32>>2]|0;y=0;do{f[B+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[n>>2]|0))}f[p>>2]=0}if((((((c|0)==2?(f[na+(g*48|0)+4>>2]|0)==2:0)?f[na+(g*48|0)+24>>2]|0:0)?(f[w>>2]&4095|0)==(o|0):0)?(f[na+(g*48|0)+8>>2]|0)==(f[d+4>>2]|0):0)?(f[na+(g*48|0)+12>>2]|0)==(f[d>>2]|0):0){u=j;return}}n=f[a>>2]|0;do if((n|0)<0){y=f[w>>2]|0;if(((y^e)&4088|0)==0?1<<(n&4095)&i|0:0){oa=y&4095;pa=n;break}if((o|0)!=(y&4095|0)){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,42)|0;t=180994;v=s+42|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2808);bD(l);oa=o;pa=f[a>>2]|0}else{oa=o;pa=n}}else{oa=o;pa=n}while(0);if(pa&1073741824|0){if((f[na+(g*48|0)+4>>2]|0)!=(c|0)){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,11)|0;t=181037;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2812);bD(l)}if((c|0)>0){n=na+(g*48|0)+32|0;p=l+4|0;x=0;do{if((f[(f[n>>2]|0)+(x<<2)>>2]|0)!=(f[d+(x<<2)>>2]|0)){f[l>>2]=0;f[p>>2]=0;s=aD(l,21)|0;t=181049;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,440241,179056,2814);bD(l)}x=x+1|0}while((x|0)<(c|0))}}eI(w,c,d,oa,0);u=j;return}while(0);f[l>>2]=0;f[l+4>>2]=0;s=aD(l,30)|0;t=180875;v=s+30|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-213,l,440241,179056,2821);bD(l);u=j;return}function xL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if(!((c|0)<0?(f[b>>2]&2031616|0)==65536:0)){yL(a,b,c);return}c=f[b+4>>2]|0;f[a>>2]=f[c>>2];b=a+4|0;d=c+4|0;f[b>>2]=f[d>>2];e=a+8|0;f[e>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];g=f[c+36>>2]|0;f[a+36>>2]=g;h=a+40|0;f[h>>2]=e;e=a+48|0;i=a+44|0;f[i>>2]=e;f[e>>2]=0;f[a+52>>2]=0;if(g|0){e=g+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[d>>2]|0)<3){e=f[c+44>>2]|0;g=f[i>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];return}f[b>>2]=0;YK(a,f[d>>2]|0,0,0,0);if((f[b>>2]|0)<=0)return;d=f[c+40>>2]|0;a=f[h>>2]|0;h=f[c+44>>2]|0;c=f[i>>2]|0;i=0;do{f[a+(i<<2)>>2]=f[d+(i<<2)>>2];f[c+(i<<2)>>2]=f[h+(i<<2)>>2];i=i+1|0}while((i|0)<(f[b>>2]|0));return}function yL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=u;u=u+144|0;g=e+136|0;h=e;i=e+80|0;j=e+72|0;k=e+64|0;l=e+56|0;m=f[c>>2]|0;n=m&50331648;do switch(m>>>16&31){case 1:{o=f[c+4>>2]|0;if((d|0)>=0){f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;lL(a,o,g,h);u=e;return}f[a>>2]=f[o>>2];p=a+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=a+8|0;f[r>>2]=f[o+8>>2];f[a+12>>2]=f[o+12>>2];f[a+16>>2]=f[o+16>>2];f[a+20>>2]=f[o+20>>2];f[a+24>>2]=f[o+24>>2];f[a+28>>2]=f[o+28>>2];f[a+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[a+36>>2]=s;t=a+40|0;f[t>>2]=r;r=a+48|0;v=a+44|0;f[v>>2]=r;f[r>>2]=0;f[a+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){r=f[o+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];u=e;return}f[p>>2]=0;YK(a,f[q>>2]|0,0,0,0);if((f[p>>2]|0)<=0){u=e;return}q=f[o+40>>2]|0;r=f[t>>2]|0;t=f[o+44>>2]|0;o=f[v>>2]|0;v=0;do{f[r+(v<<2)>>2]=f[q+(v<<2)>>2];f[o+(v<<2)>>2]=f[t+(v<<2)>>2];v=v+1|0}while((v|0)<(f[p>>2]|0));u=e;return}case 10:{p=f[c+4>>2]|0;if((d|0)<0){qI(a,p,n);u=e;return}qI(i,p,n);f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;lL(a,i,g,h);p=i+36|0;v=f[p>>2]|0;if((v|0?(t=v+12|0,v=f[t>>2]|0,f[t>>2]=v+-1,(v|0)==1):0)?(v=f[p>>2]|0,v|0):0){f[p>>2]=0;t=f[v+4>>2]|0;if(!t){o=f[i+32>>2]|0;if(!o)w=$K()|0;else w=o}else w=t;zh[f[(f[w>>2]|0)+24>>2]&2047](w,v)}f[p>>2]=0;p=i+16|0;v=i+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[v>>2]|0)>0){p=f[i+40>>2]|0;t=0;do{f[p+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[v>>2]|0))}v=f[i+44>>2]|0;if((v|0)==(i+48|0)){u=e;return}UC(v);u=e;return}case 6:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;v=aD(g,5)|0;b[v>>0]=b[180637]|0;b[v+1>>0]=b[180638]|0;b[v+2>>0]=b[180639]|0;b[v+3>>0]=b[180640]|0;b[v+4>>0]=b[180641]|0;bO(-215,g,180643,179056,1225);bD(g)}zL(a,f[c+4>>2]|0);u=e;return}case 2:case 14:{if((d|0)<0)x=m;else{f[g>>2]=0;f[g+4>>2]=0;v=aD(g,5)|0;b[v>>0]=b[180637]|0;b[v+1>>0]=b[180638]|0;b[v+2>>0]=b[180639]|0;b[v+3>>0]=b[180640]|0;b[v+4>>0]=b[180641]|0;bO(-215,g,180643,179056,1231);bD(g);x=f[c>>2]|0}f[j>>2]=f[c+8>>2];f[j+4>>2]=f[c+12>>2];JF(a,j,x,f[c+4>>2]|0,0);u=e;return}case 3:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;v=aD(g,5)|0;b[v>>0]=b[180637]|0;b[v+1>>0]=b[180638]|0;b[v+2>>0]=b[180639]|0;b[v+3>>0]=b[180640]|0;b[v+4>>0]=b[180641]|0;bO(-215,g,180643,179056,1237);bD(g)}v=f[c+4>>2]|0;if((f[v>>2]|0)==(f[v+4>>2]|0)){f[a>>2]=1124007936;t=a+8|0;p=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[p>>2]=t;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=e;return}o=f[c>>2]|0;AL(k,c,-1);q=f[v>>2]|0;r=o&4095|1124007936;f[a>>2]=r;f[a+4>>2]=2;s=a+8|0;A=f[k+4>>2]|0;f[s>>2]=A;B=a+12|0;C=f[k>>2]|0;f[B>>2]=C;f[a+16>>2]=q;D=a+20|0;f[D>>2]=q;E=a+24|0;F=a+28|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[a+40>>2]=s;G=a+48|0;H=a+44|0;f[H>>2]=G;f[a+52>>2]=0;f[G>>2]=0;if((q|0)==0&(Y(C,A)|0)!=0){f[g>>2]=0;f[g+4>>2]=0;y=aD(g,26)|0;I=426262;z=y+26|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));bO(-215,g,426289,431198,533);bD(g);J=f[B>>2]|0;K=f[a>>2]|0;L=f[H>>2]|0;M=f[D>>2]|0}else{J=C;K=r;L=G;M=q}v=(o>>>3&511)+1<<(47696>>>(o<<1&14)&3);t=Y(J,v)|0;f[a>>2]=K|16384;f[L>>2]=t;f[L+4>>2]=v;v=M+(Y(f[s>>2]|0,t)|0)|0;f[F>>2]=v;f[E>>2]=v+(0-t)+t;u=e;return}case 12:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;t=aD(g,5)|0;b[t>>0]=b[180637]|0;b[t+1>>0]=b[180638]|0;b[t+2>>0]=b[180639]|0;b[t+3>>0]=b[180640]|0;b[t+4>>0]=b[180641]|0;bO(-215,g,180643,179056,1246);bD(g)}t=f[c+4>>2]|0;v=f[t+4>>2]|0;if(!v){f[a>>2]=1124007936;p=a+8|0;A=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[A>>2]=p;E=a+48|0;f[a+44>>2]=E;f[E>>2]=0;f[a+52>>2]=0;u=e;return}f[h>>2]=1124007936;E=h+4|0;F=h+8|0;s=h+40|0;y=E;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[s>>2]=F;p=h+48|0;A=h+44|0;f[A>>2]=p;f[p>>2]=0;f[h+52>>2]=0;f[g>>2]=1;f[g+4>>2]=v;hL(h,2,g,0);o=h+16|0;q=f[o>>2]|0;if((v|0)>0){G=0;do{b[q+G>>0]=(f[(f[t>>2]|0)+(G>>>5<<2)>>2]&1<<(G&31)|0)!=0&1;G=G+1|0}while((G|0)!=(v|0));N=f[o>>2]|0}else N=q;f[a>>2]=f[h>>2];v=a+4|0;G=f[E>>2]|0;f[v>>2]=G;t=a+8|0;f[t>>2]=f[F>>2];f[a+12>>2]=f[h+12>>2];f[a+16>>2]=N;f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];r=h+32|0;f[a+32>>2]=f[r>>2];C=h+36|0;D=f[C>>2]|0;f[a+36>>2]=D;H=a+40|0;f[H>>2]=t;t=a+48|0;B=a+44|0;f[B>>2]=t;f[t>>2]=0;f[a+52>>2]=0;if(!D)O=G;else{G=D+12|0;f[G>>2]=(f[G>>2]|0)+1;O=f[E>>2]|0}if((O|0)>=3){f[v>>2]=0;YK(a,O,0,0,0);if((f[v>>2]|0)>0){G=f[s>>2]|0;D=f[H>>2]|0;H=f[A>>2]|0;t=f[B>>2]|0;P=0;do{f[D+(P<<2)>>2]=f[G+(P<<2)>>2];f[t+(P<<2)>>2]=f[H+(P<<2)>>2];P=P+1|0}while((P|0)<(f[v>>2]|0))}}else{v=f[A>>2]|0;P=f[B>>2]|0;f[P>>2]=f[v>>2];f[P+4>>2]=f[v+4>>2]}v=f[C>>2]|0;if((v|0?(P=v+12|0,v=f[P>>2]|0,f[P>>2]=v+-1,(v|0)==1):0)?(v=f[C>>2]|0,v|0):0){f[C>>2]=0;P=f[v+4>>2]|0;if(!P){H=f[r>>2]|0;if(!H)Q=$K()|0;else Q=H}else Q=P;zh[f[(f[Q>>2]|0)+24>>2]&2047](Q,v)}f[C>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[E>>2]|0)>0){v=f[s>>2]|0;P=0;do{f[v+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[E>>2]|0))}E=f[A>>2]|0;if((E|0)!=(p|0))UC(E);u=e;return}case 0:{f[a>>2]=1124007936;E=a+8|0;P=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[P>>2]=E;p=a+48|0;f[a+44>>2]=p;f[p>>2]=0;f[a+52>>2]=0;u=e;return}case 4:{p=BL(c,d)|0;A=f[c+4>>2]|0;if((d|0)>-1?(v=f[A>>2]|0,(((f[A+4>>2]|0)-v|0)/12|0|0)>(d|0)):0)R=v;else{f[g>>2]=0;f[g+4>>2]=0;y=aD(g,28)|0;I=180651;z=y+28|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));bO(-215,g,180643,179056,1266);bD(g);R=f[A>>2]|0}E=R+(d*12|0)|0;if((f[E>>2]|0)==(f[R+(d*12|0)+4>>2]|0)){f[a>>2]=1124007936;P=a+8|0;v=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[v>>2]=P;A=a+48|0;f[a+44>>2]=A;f[A>>2]=0;f[a+52>>2]=0;u=e;return}AL(l,c,d);A=f[E>>2]|0;s=p&4095|1124007936;f[a>>2]=s;f[a+4>>2]=2;o=a+8|0;C=f[l+4>>2]|0;f[o>>2]=C;r=a+12|0;B=f[l>>2]|0;f[r>>2]=B;f[a+16>>2]=A;H=a+20|0;f[H>>2]=A;t=a+24|0;G=a+28|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[a+40>>2]=o;D=a+48|0;F=a+44|0;f[F>>2]=D;f[a+52>>2]=0;f[D>>2]=0;if((A|0)==0&(Y(B,C)|0)!=0){f[g>>2]=0;f[g+4>>2]=0;y=aD(g,26)|0;I=426262;z=y+26|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));bO(-215,g,426289,431198,533);bD(g);S=f[r>>2]|0;T=f[a>>2]|0;U=f[F>>2]|0;V=f[H>>2]|0}else{S=B;T=s;U=D;V=A}E=(p>>>3&511)+1<<(47696>>>(p<<1&14)&3);P=Y(S,E)|0;f[a>>2]=T|16384;f[U>>2]=P;f[U+4>>2]=E;E=V+(Y(f[o>>2]|0,P)|0)|0;f[G>>2]=E;f[t>>2]=E+(0-P)+P;u=e;return}case 5:{P=f[c+4>>2]|0;if((d|0)>-1?(E=f[P>>2]|0,(((f[P+4>>2]|0)-E|0)/56|0|0)>(d|0)):0)W=E;else{f[g>>2]=0;f[g+4>>2]=0;y=aD(g,27)|0;I=180680;z=y+27|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));bO(-215,g,180643,179056,1275);bD(g);W=f[P>>2]|0}f[a>>2]=f[W+(d*56|0)>>2];t=a+4|0;G=W+(d*56|0)+4|0;f[t>>2]=f[G>>2];o=a+8|0;f[o>>2]=f[W+(d*56|0)+8>>2];f[a+12>>2]=f[W+(d*56|0)+12>>2];f[a+16>>2]=f[W+(d*56|0)+16>>2];f[a+20>>2]=f[W+(d*56|0)+20>>2];f[a+24>>2]=f[W+(d*56|0)+24>>2];f[a+28>>2]=f[W+(d*56|0)+28>>2];f[a+32>>2]=f[W+(d*56|0)+32>>2];p=f[W+(d*56|0)+36>>2]|0;f[a+36>>2]=p;A=a+40|0;f[A>>2]=o;o=a+48|0;D=a+44|0;f[D>>2]=o;f[o>>2]=0;f[a+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[G>>2]|0)<3){o=f[W+(d*56|0)+44>>2]|0;p=f[D>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];u=e;return}f[t>>2]=0;YK(a,f[G>>2]|0,0,0,0);if((f[t>>2]|0)<=0){u=e;return}G=f[W+(d*56|0)+40>>2]|0;o=f[A>>2]|0;A=f[W+(d*56|0)+44>>2]|0;p=f[D>>2]|0;D=0;do{f[o+(D<<2)>>2]=f[G+(D<<2)>>2];f[p+(D<<2)>>2]=f[A+(D<<2)>>2];D=D+1|0}while((D|0)<(f[t>>2]|0));u=e;return}case 15:{t=f[c+4>>2]|0;if(!((d|0)>-1?(f[c+12>>2]|0)>(d|0):0)){f[g>>2]=0;f[g+4>>2]=0;y=aD(g,23)|0;I=180708;z=y+23|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));bO(-215,g,180643,179056,1283);bD(g)}f[a>>2]=f[t+(d*56|0)>>2];D=a+4|0;A=t+(d*56|0)+4|0;f[D>>2]=f[A>>2];p=a+8|0;f[p>>2]=f[t+(d*56|0)+8>>2];f[a+12>>2]=f[t+(d*56|0)+12>>2];f[a+16>>2]=f[t+(d*56|0)+16>>2];f[a+20>>2]=f[t+(d*56|0)+20>>2];f[a+24>>2]=f[t+(d*56|0)+24>>2];f[a+28>>2]=f[t+(d*56|0)+28>>2];f[a+32>>2]=f[t+(d*56|0)+32>>2];G=f[t+(d*56|0)+36>>2]|0;f[a+36>>2]=G;o=a+40|0;f[o>>2]=p;p=a+48|0;P=a+44|0;f[P>>2]=p;f[p>>2]=0;f[a+52>>2]=0;if(G|0){p=G+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[A>>2]|0)<3){p=f[t+(d*56|0)+44>>2]|0;G=f[P>>2]|0;f[G>>2]=f[p>>2];f[G+4>>2]=f[p+4>>2];u=e;return}f[D>>2]=0;YK(a,f[A>>2]|0,0,0,0);if((f[D>>2]|0)<=0){u=e;return}A=f[t+(d*56|0)+40>>2]|0;p=f[o>>2]|0;o=f[t+(d*56|0)+44>>2]|0;G=f[P>>2]|0;P=0;do{f[p+(P<<2)>>2]=f[A+(P<<2)>>2];f[G+(P<<2)>>2]=f[o+(P<<2)>>2];P=P+1|0}while((P|0)<(f[D>>2]|0));u=e;return}case 11:{D=f[c+4>>2]|0;if((d|0)>-1?(P=f[D>>2]|0,(((f[D+4>>2]|0)-P|0)/48|0|0)>(d|0)):0)X=P;else{f[g>>2]=0;f[g+4>>2]=0;y=aD(g,27)|0;I=180680;z=y+27|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));bO(-215,g,180643,179056,1291);bD(g);X=f[D>>2]|0}qI(a,X+(d*48|0)|0,n);u=e;return}case 7:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;P=aD(g,5)|0;b[P>>0]=b[180637]|0;b[P+1>>0]=b[180638]|0;b[P+2>>0]=b[180639]|0;b[P+3>>0]=b[180640]|0;b[P+4>>0]=b[180641]|0;bO(-215,g,180643,179056,1298);bD(g)}f[g>>2]=0;f[g+4>>2]=0;y=aD(g,75)|0;I=180732;z=y+75|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));bO(-213,g,180643,179056,1299);bD(g);f[a>>2]=1124007936;D=a+8|0;P=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[P>>2]=D;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=e;return}case 9:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;o=aD(g,5)|0;b[o>>0]=b[180637]|0;b[o+1>>0]=b[180638]|0;b[o+2>>0]=b[180639]|0;b[o+3>>0]=b[180640]|0;b[o+4>>0]=b[180641]|0;bO(-215,g,180643,179056,1305);bD(g)}f[g>>2]=0;f[g+4>>2]=0;y=aD(g,66)|0;I=180808;z=y+66|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));bO(-213,g,180643,179056,1306);bD(g);f[a>>2]=1124007936;D=a+8|0;P=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[P>>2]=D;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=e;return}case 8:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;o=aD(g,5)|0;b[o>>0]=b[180637]|0;b[o+1>>0]=b[180638]|0;b[o+2>>0]=b[180639]|0;b[o+3>>0]=b[180640]|0;b[o+4>>0]=b[180641]|0;bO(-215,g,180643,179056,1312);bD(g)}o=f[c+4>>2]|0;G=f[o+4>>2]|0;f[g>>2]=f[o+8>>2];f[g+4>>2]=G;JF(a,g,f[o>>2]&4095,f[o+16>>2]|0,f[o+12>>2]|0);u=e;return}default:{f[g>>2]=0;f[g+4>>2]=0;y=aD(g,30)|0;I=180875;z=y+30|0;do{b[y>>0]=b[I>>0]|0;y=y+1|0;I=I+1|0}while((y|0)<(z|0));bO(-213,g,180643,179056,1319);bD(g);f[a>>2]=1124007936;D=a+8|0;P=a+40|0;y=a+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[P>>2]=D;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=e;return}}while(0)}function zL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=1124007936;c=a+8|0;d=a+40|0;e=a+4|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;c=f[b>>2]|0;th[f[(f[c>>2]|0)+12>>2]&511](c,b,a,-1);return}function AL(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+16|0;g=e;do switch((f[c>>2]|0)>>>16&31){case 1:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,5)|0;b[h>>0]=b[180637]|0;b[h+1>>0]=b[180638]|0;b[h+2>>0]=b[180639]|0;b[h+3>>0]=b[180640]|0;b[h+4>>0]=b[180641]|0;bO(-215,g,429353,179056,1592);bD(g)}h=f[(f[c+4>>2]|0)+40>>2]|0;i=f[h>>2]|0;f[a>>2]=f[h+4>>2];f[a+4>>2]=i;u=e;return}case 6:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,5)|0;b[i>>0]=b[180637]|0;b[i+1>>0]=b[180638]|0;b[i+2>>0]=b[180639]|0;b[i+3>>0]=b[180640]|0;b[i+4>>0]=b[180641]|0;bO(-215,g,429353,179056,1598);bD(g)}LS(a,f[c+4>>2]|0);u=e;return}case 10:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,5)|0;b[i>>0]=b[180637]|0;b[i+1>>0]=b[180638]|0;b[i+2>>0]=b[180639]|0;b[i+3>>0]=b[180640]|0;b[i+4>>0]=b[180641]|0;bO(-215,g,429353,179056,1604);bD(g)}i=f[(f[c+4>>2]|0)+32>>2]|0;h=f[i>>2]|0;f[a>>2]=f[i+4>>2];f[a+4>>2]=h;u=e;return}case 2:case 14:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,5)|0;b[h>>0]=b[180637]|0;b[h+1>>0]=b[180638]|0;b[h+2>>0]=b[180639]|0;b[h+3>>0]=b[180640]|0;b[h+4>>0]=b[180641]|0;bO(-215,g,429353,179056,1610);bD(g)}f[a>>2]=f[c+8>>2];f[a+4>>2]=f[c+12>>2];u=e;return}case 3:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,5)|0;b[h>>0]=b[180637]|0;b[h+1>>0]=b[180638]|0;b[h+2>>0]=b[180639]|0;b[h+3>>0]=b[180640]|0;b[h+4>>0]=b[180641]|0;bO(-215,g,429353,179056,1616);bD(g)}h=f[c+4>>2]|0;i=(f[h+4>>2]|0)-(f[h>>2]|0)|0;if((i|0)==(i>>2|0)){f[a>>2]=i;f[a+4>>2]=1;u=e;return}else{h=f[c>>2]|0;f[a>>2]=(i>>>0)/((h>>>3&511)+1<<(47696>>>(h<<1&14)&3)>>>0)|0;f[a+4>>2]=1;u=e;return}break}case 12:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,5)|0;b[h>>0]=b[180637]|0;b[h+1>>0]=b[180638]|0;b[h+2>>0]=b[180639]|0;b[h+3>>0]=b[180640]|0;b[h+4>>0]=b[180641]|0;bO(-215,g,429353,179056,1625);bD(g)}f[a>>2]=f[(f[c+4>>2]|0)+4>>2];f[a+4>>2]=1;u=e;return}case 0:{f[a>>2]=0;f[a+4>>2]=0;u=e;return}case 4:{h=c+4|0;i=f[h>>2]|0;if((d|0)<0){j=f[i>>2]|0;k=f[i+4>>2]|0;if((j|0)==(k|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(k-j|0)/12|0;f[a+4>>2]=1;u=e;return}}j=f[i>>2]|0;if((((f[i+4>>2]|0)-j|0)/12|0|0)>(d|0)){l=i;m=j}else{f[g>>2]=0;f[g+4>>2]=0;n=aD(g,18)|0;o=180932;p=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,g,429353,179056,1638);bD(g);l=f[h>>2]|0;m=f[i>>2]|0}j=(f[m+(d*12|0)+4>>2]|0)-(f[m+(d*12|0)>>2]|0)|0;k=f[l>>2]|0;if((j|0)==((f[k+(d*12|0)+4>>2]|0)-(f[k+(d*12|0)>>2]|0)>>2|0)){f[a>>2]=j;f[a+4>>2]=1;u=e;return}else{k=f[c>>2]|0;f[a>>2]=(j>>>0)/((k>>>3&511)+1<<(47696>>>(k<<1&14)&3)>>>0)|0;f[a+4>>2]=1;u=e;return}break}case 5:{k=f[c+4>>2]|0;if((d|0)<0){j=f[k>>2]|0;q=f[k+4>>2]|0;if((j|0)==(q|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(q-j|0)/56|0;f[a+4>>2]=1;u=e;return}}else{j=f[k>>2]|0;if((((f[k+4>>2]|0)-j|0)/56|0|0)>(d|0))r=j;else{f[g>>2]=0;f[g+4>>2]=0;n=aD(g,18)|0;o=180932;p=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,g,429353,179056,1650);bD(g);r=f[k>>2]|0}i=f[r+(d*56|0)+40>>2]|0;h=f[i>>2]|0;f[a>>2]=f[i+4>>2];f[a+4>>2]=h;u=e;return}break}case 15:{h=f[c+4>>2]|0;i=f[c+12>>2]|0;if((d|0)>=0){if((i|0)<=(d|0)){f[g>>2]=0;f[g+4>>2]=0;n=aD(g,13)|0;o=180951;p=n+13|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,g,429353,179056,1660);bD(g)}k=f[h+(d*56|0)+40>>2]|0;j=f[k>>2]|0;f[a>>2]=f[k+4>>2];f[a+4>>2]=j;u=e;return}if(!i){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=i;f[a+4>>2]=1;u=e;return}break}case 13:{j=f[c+4>>2]|0;if((d|0)<0){k=f[j>>2]|0;q=f[j+4>>2]|0;if((k|0)==(q|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(q-k|0)/36|0;f[a+4>>2]=1;u=e;return}}else{k=f[j>>2]|0;if((((f[j+4>>2]|0)-k|0)/36|0|0)>(d|0))s=k;else{f[g>>2]=0;f[g+4>>2]=0;n=aD(g,18)|0;o=180932;p=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,g,429353,179056,1670);bD(g);s=f[j>>2]|0}i=f[s+(d*36|0)+4>>2]|0;f[a>>2]=f[s+(d*36|0)+8>>2];f[a+4>>2]=i;u=e;return}break}case 11:{i=f[c+4>>2]|0;if((d|0)<0){h=f[i>>2]|0;k=f[i+4>>2]|0;if((h|0)==(k|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}else{f[a>>2]=(k-h|0)/48|0;f[a+4>>2]=1;u=e;return}}else{h=f[i>>2]|0;if((((f[i+4>>2]|0)-h|0)/48|0|0)>(d|0))t=h;else{f[g>>2]=0;f[g+4>>2]=0;n=aD(g,18)|0;o=180932;p=n+18|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,g,429353,179056,1679);bD(g);t=f[i>>2]|0}j=f[t+(d*48|0)+32>>2]|0;h=f[j>>2]|0;f[a>>2]=f[j+4>>2];f[a+4>>2]=h;u=e;return}break}case 7:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,5)|0;b[h>>0]=b[180637]|0;b[h+1>>0]=b[180638]|0;b[h+2>>0]=b[180639]|0;b[h+3>>0]=b[180640]|0;b[h+4>>0]=b[180641]|0;bO(-215,g,429353,179056,1686);bD(g)}h=f[c+4>>2]|0;j=f[h+8>>2]|0;f[a>>2]=f[h+12>>2];f[a+4>>2]=j;u=e;return}case 9:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,5)|0;b[j>>0]=b[180637]|0;b[j+1>>0]=b[180638]|0;b[j+2>>0]=b[180639]|0;b[j+3>>0]=b[180640]|0;b[j+4>>0]=b[180641]|0;bO(-215,g,429353,179056,1693);bD(g)}j=f[c+4>>2]|0;h=f[j+4>>2]|0;f[a>>2]=f[j+8>>2];f[a+4>>2]=h;u=e;return}case 8:{if((d|0)>=0){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,5)|0;b[h>>0]=b[180637]|0;b[h+1>>0]=b[180638]|0;b[h+2>>0]=b[180639]|0;b[h+3>>0]=b[180640]|0;b[h+4>>0]=b[180641]|0;bO(-215,g,429353,179056,1700);bD(g)}h=f[c+4>>2]|0;j=f[h+4>>2]|0;f[a>>2]=f[h+8>>2];f[a+4>>2]=j;u=e;return}default:{f[g>>2]=0;f[g+4>>2]=0;n=aD(g,30)|0;o=180875;p=n+30|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-213,g,429353,179056,1705);bD(g);f[a>>2]=0;f[a+4>>2]=0;u=e;return}}while(0)}function BL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;do switch(g>>>16&31){case 1:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 10:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 6:{h=MS(f[a+4>>2]|0)|0;u=d;return h|0}case 2:case 3:case 4:case 12:case 14:{h=g&4095;u=d;return h|0}case 11:{i=f[a+4>>2]|0;j=f[i>>2]|0;k=f[i+4>>2]|0;if((j|0)==(k|0)){if((g|0)<0)l=g;else{f[e>>2]=0;f[e+4>>2]=0;m=aD(e,25)|0;n=180906;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,e,365923,179056,1982);bD(e);l=f[a>>2]|0}h=l&4095;u=d;return h|0}else{if(((k-j|0)/48|0|0)>(c|0))p=j;else{f[e>>2]=0;f[e+4>>2]=0;m=aD(e,18)|0;n=180932;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,e,365923,179056,1985);bD(e);p=f[i>>2]|0}h=f[p+(((c|0)>0?c:0)*48|0)>>2]&4095;u=d;return h|0}break}case 5:{j=f[a+4>>2]|0;k=f[j>>2]|0;q=f[j+4>>2]|0;if((k|0)==(q|0)){if((g|0)<0)r=g;else{f[e>>2]=0;f[e+4>>2]=0;m=aD(e,25)|0;n=180906;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,e,365923,179056,1994);bD(e);r=f[a>>2]|0}h=r&4095;u=d;return h|0}else{if(((q-k|0)/56|0|0)>(c|0))s=k;else{f[e>>2]=0;f[e+4>>2]=0;m=aD(e,18)|0;n=180932;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,e,365923,179056,1997);bD(e);s=f[j>>2]|0}h=f[s+(((c|0)>0?c:0)*56|0)>>2]&4095;u=d;return h|0}break}case 15:{k=f[a+4>>2]|0;q=f[a+12>>2]|0;if(!q){if((g|0)<0)t=g;else{f[e>>2]=0;f[e+4>>2]=0;m=aD(e,25)|0;n=180906;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,e,365923,179056,2006);bD(e);t=f[a>>2]|0}h=t&4095;u=d;return h|0}else{if((q|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;m=aD(e,13)|0;n=180951;o=m+13|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,e,365923,179056,2009);bD(e)}h=f[k+(((c|0)>0?c:0)*56|0)>>2]&4095;u=d;return h|0}break}case 13:{q=f[a+4>>2]|0;j=f[q>>2]|0;i=f[q+4>>2]|0;if((j|0)==(i|0)){if((g|0)<0)v=g;else{f[e>>2]=0;f[e+4>>2]=0;m=aD(e,25)|0;n=180906;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,e,365923,179056,2018);bD(e);v=f[a>>2]|0}h=v&4095;u=d;return h|0}else{if(((i-j|0)/36|0|0)>(c|0))w=j;else{f[e>>2]=0;f[e+4>>2]=0;m=aD(e,18)|0;n=180932;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,e,365923,179056,2021);bD(e);w=f[q>>2]|0}h=f[w+(((c|0)>0?c:0)*36|0)>>2]&4095;u=d;return h|0}break}case 7:{h=f[(f[a+4>>2]|0)+16>>2]|0;u=d;return h|0}case 9:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 8:{h=f[f[a+4>>2]>>2]&4095;u=d;return h|0}case 0:{h=-1;u=d;return h|0}default:{f[e>>2]=0;f[e+4>>2]=0;m=aD(e,30)|0;n=180875;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-213,e,365923,179056,2034);bD(e);h=0;u=d;return h|0}}while(0);return 0}function CL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c;e=f[a+8>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/12|0)>>>0>=b>>>0){Nac(h|0,0,b*12|0)|0;f[g>>2]=h+(b*12|0);u=c;return}g=f[a>>2]|0;i=(h-g|0)/12|0;h=i+b|0;if(h>>>0>357913941)c4b(a);j=(e-g|0)/12|0;g=j<<1;e=j>>>0<178956970?(g>>>0<h>>>0?h:g):357913941;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(e)if(e>>>0>357913941){g=ze(8)|0;T5b(g,477177);f[g>>2]=149528;If(g|0,25408,1411)}else{k=L5b(e*12|0)|0;break}else k=0;while(0);f[d>>2]=k;g=k+(i*12|0)|0;i=d+8|0;h=d+4|0;f[h>>2]=g;f[d+12>>2]=k+(e*12|0);Nac(g|0,0,b*12|0)|0;f[i>>2]=g+(b*12|0);VL(a,d);a=f[h>>2]|0;h=f[i>>2]|0;if((h|0)!=(a|0)){b=h;while(1){h=b+-12|0;f[i>>2]=h;g=f[h>>2]|0;if(!g)l=h;else{h=b+-8|0;if((f[h>>2]|0)!=(g|0))f[h>>2]=g;O5b(g);l=f[i>>2]|0}if((l|0)==(a|0))break;else b=l}}l=f[d>>2]|0;if(l|0)O5b(l);u=c;return}function DL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if((e-h|0)>>>0>=c>>>0){i=c;j=h;do{b[j>>0]=0;j=(f[g>>2]|0)+1|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i|0;h=j+c|0;if((h|0)<0)c4b(a);k=e-i|0;i=k<<1;e=k>>>0<1073741823?(i>>>0<h>>>0?h:i):2147483647;if(!e)l=0;else l=L5b(e)|0;i=l+j|0;j=l+e|0;e=c;c=i;l=i;do{b[l>>0]=0;l=c+1|0;c=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=(f[g>>2]|0)-e|0;h=i+(0-l)|0;if((l|0)>0)Vac(h|0,e|0,l|0)|0;f[a>>2]=h;f[g>>2]=c;f[d>>2]=j;if(!e)return;O5b(e);return}function EL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>1>>>0>=c>>>0){i=c;j=h;do{b[j>>0]=0;b[j+1>>0]=0;j=(f[g>>2]|0)+2|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>1;h=j+c|0;if((h|0)<0)c4b(a);k=e-i|0;i=k>>1>>>0<1073741823?(k>>>0<h>>>0?h:k):2147483647;do if(i)if((i|0)<0){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{l=L5b(i<<1)|0;break}else l=0;while(0);k=l+(j<<1)|0;j=k;h=l+(i<<1)|0;i=c;c=k;l=j;do{b[c>>0]=0;b[c+1>>0]=0;c=l+2|0;l=c;i=i+-1|0}while((i|0)!=0);i=h;h=f[a>>2]|0;c=f[g>>2]|0;if((c|0)==(h|0)){m=j;n=h}else{e=c;c=j;j=k;do{k=e;e=e+-2|0;b[j+-2>>0]=b[e>>0]|0;b[j+-1>>0]=b[k+-1>>0]|0;j=c+-2|0;c=j}while((e|0)!=(h|0));m=c;n=f[a>>2]|0}f[a>>2]=m;f[g>>2]=l;f[d>>2]=i;if(!n)return;O5b(n);return}function FL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/3|0)>>>0>=c>>>0){i=c;j=h;do{b[j>>0]=0;b[j+1>>0]=0;b[j+2>>0]=0;j=(f[g>>2]|0)+3|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/3|0;h=j+c|0;if(h>>>0>1431655765)c4b(a);k=(e-i|0)/3|0;i=k<<1;e=k>>>0<715827882?(i>>>0<h>>>0?h:i):1431655765;do if(e)if(e>>>0>1431655765){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{l=L5b(e*3|0)|0;break}else l=0;while(0);i=l+(j*3|0)|0;j=i;h=l+(e*3|0)|0;e=c;c=j;l=i;do{b[l>>0]=0;b[l+1>>0]=0;b[l+2>>0]=0;l=c+3|0;c=l;e=e+-1|0}while((e|0)!=0);e=h;h=f[a>>2]|0;l=f[g>>2]|0;if((l|0)==(h|0)){m=j;n=h}else{k=l;l=j;j=i;do{i=k;k=k+-3|0;b[j+-3>>0]=b[k>>0]|0;b[j+-2>>0]=b[i+-2>>0]|0;b[j+-1>>0]=b[i+-1>>0]|0;j=l+-3|0;l=j}while((k|0)!=(h|0));m=l;n=f[a>>2]|0}f[a>>2]=m;f[g>>2]=c;f[d>>2]=e;if(!n)return;O5b(n);return}function GL(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;e=f[c>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/6|0)>>>0>=b>>>0){i=b;j=h;do{d[j>>1]=0;d[j+2>>1]=0;d[j+4>>1]=0;j=(f[g>>2]|0)+6|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/6|0;h=j+b|0;if(h>>>0>715827882)c4b(a);k=(e-i|0)/6|0;i=k<<1;e=k>>>0<357913941?(i>>>0<h>>>0?h:i):715827882;do if(e)if(e>>>0>715827882){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{l=L5b(e*6|0)|0;break}else l=0;while(0);i=l+(j*6|0)|0;j=i;h=l+(e*6|0)|0;e=b;b=i;l=j;do{d[b>>1]=0;d[b+2>>1]=0;d[b+4>>1]=0;b=l+6|0;l=b;e=e+-1|0}while((e|0)!=0);e=h;h=f[a>>2]|0;b=f[g>>2]|0;if((b|0)==(h|0)){m=j;n=h}else{j=b;b=i;do{i=j;j=j+-6|0;d[b+-6>>1]=d[j>>1]|0;d[b+-4>>1]=d[i+-4>>1]|0;d[b+-2>>1]=d[i+-2>>1]|0;b=b+-6|0}while((j|0)!=(h|0));m=b;n=f[a>>2]|0}f[a>>2]=m;f[g>>2]=l;f[c>>2]=e;if(!n)return;O5b(n);return}function HL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){h=b;i=g;do{j=i;f[j>>2]=0;f[j+4>>2]=0;i=(f[e>>2]|0)+8|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>3;g=i+b|0;if(g>>>0>536870911)c4b(a);j=d-h|0;h=j>>2;d=j>>3>>>0<268435455?(h>>>0<g>>>0?g:h):536870911;do if(d)if(d>>>0>536870911){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<3)|0;break}else k=0;while(0);h=k+(i<<3)|0;i=h;g=k+(d<<3)|0;d=b;b=h;k=i;do{j=b;f[j>>2]=0;f[j+4>>2]=0;b=k+8|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-8-j|0;j=b;b=h;while(1){n=j;j=j+-8|0;f[b+-8>>2]=f[j>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-8|0}l=h+(~(i>>>3)<<3)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;O5b(m);return}function IL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;i=(f[e>>2]|0)+12|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/12|0;g=i+b|0;if(g>>>0>357913941)c4b(a);j=(d-h|0)/12|0;h=j<<1;d=j>>>0<178956970?(h>>>0<g>>>0?g:h):357913941;do if(d)if(d>>>0>357913941){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d*12|0)|0;break}else k=0;while(0);h=k+(i*12|0)|0;i=h;g=k+(d*12|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=k+12|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=i;i=i+-12|0;f[b+-12>>2]=f[i>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-12|0}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;O5b(m);return}function JL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)c4b(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=h;g=k+(d<<4)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-16-j|0;j=b;b=h;while(1){n=j;j=j+-16|0;f[b+-16>>2]=f[j>>2];f[b+-12>>2]=f[n+-12>>2];f[b+-8>>2]=f[n+-8>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-16|0}l=h+(~(i>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;O5b(m);return}function KL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/24|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=(f[e>>2]|0)+24|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/24|0;g=i+b|0;if(g>>>0>178956970)c4b(a);j=(d-h|0)/24|0;h=j<<1;d=j>>>0<89478485?(h>>>0<g>>>0?g:h):178956970;do if(d)if(d>>>0>178956970){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d*24|0)|0;break}else k=0;while(0);h=k+(i*24|0)|0;i=h;g=k+(d*24|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;b=k+24|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=i;i=i+-24|0;f[b+-24>>2]=f[i>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-24|0}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;O5b(m);return}function LL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>5>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;i=(f[e>>2]|0)+32|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>5;g=i+b|0;if(g>>>0>134217727)c4b(a);j=d-h|0;h=j>>4;d=j>>5>>>0<67108863?(h>>>0<g>>>0?g:h):134217727;do if(d)if(d>>>0>134217727){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<5)|0;break}else k=0;while(0);h=k+(i<<5)|0;i=h;g=k+(d<<5)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;b=k+32|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-32-j|0;j=b;b=h;while(1){n=j;j=j+-32|0;f[b+-32>>2]=f[j>>2];f[b+-28>>2]=f[n+-28>>2];f[b+-24>>2]=f[n+-24>>2];f[b+-20>>2]=f[n+-20>>2];f[b+-16>>2]=f[n+-16>>2];f[b+-12>>2]=f[n+-12>>2];f[b+-8>>2]=f[n+-8>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-32|0}l=h+(~(i>>>5)<<5)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;O5b(m);return}function ML(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/36|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+36|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/36|0;g=i+b|0;if(g>>>0>119304647)c4b(a);l=(d-h|0)/36|0;h=l<<1;d=l>>>0<59652323?(h>>>0<g>>>0?g:h):119304647;do if(d)if(d>>>0>119304647){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{m=L5b(d*36|0)|0;break}else m=0;while(0);h=m+(i*36|0)|0;i=h;g=m+(d*36|0)|0;d=b;b=h;m=i;do{j=b;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+36|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-36|0;f[b+-36>>2]=f[i>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-36|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;O5b(o);return}function NL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/48|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+48|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+48|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/48|0;g=i+b|0;if(g>>>0>89478485)c4b(a);l=(d-h|0)/48|0;h=l<<1;d=l>>>0<44739242?(h>>>0<g>>>0?g:h):89478485;do if(d)if(d>>>0>89478485){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{m=L5b(d*48|0)|0;break}else m=0;while(0);h=m+(i*48|0)|0;i=h;g=m+(d*48|0)|0;d=b;b=h;m=i;do{j=b;k=j+48|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+48|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){n=i;o=g}else{i=b;b=h;do{h=i;i=i+-48|0;f[b+-48>>2]=f[i>>2];f[b+-44>>2]=f[h+-44>>2];f[b+-40>>2]=f[h+-40>>2];f[b+-36>>2]=f[h+-36>>2];f[b+-32>>2]=f[h+-32>>2];f[b+-28>>2]=f[h+-28>>2];f[b+-24>>2]=f[h+-24>>2];f[b+-20>>2]=f[h+-20>>2];f[b+-16>>2]=f[h+-16>>2];f[b+-12>>2]=f[h+-12>>2];f[b+-8>>2]=f[h+-8>>2];f[b+-4>>2]=f[h+-4>>2];b=b+-48|0}while((i|0)!=(g|0));n=b;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;O5b(o);return}function OL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>6>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+64|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>6;g=i+b|0;if(g>>>0>67108863)c4b(a);l=d-h|0;h=l>>5;d=l>>6>>>0<33554431?(h>>>0<g>>>0?g:h):67108863;do if(d)if(d>>>0>67108863){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{m=L5b(d<<6)|0;break}else m=0;while(0);h=m+(i<<6)|0;i=h;g=m+(d<<6)|0;d=b;b=h;m=i;do{j=b;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+64|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){n=i;o=j}else{i=b+-64-j|0;j=b;b=h;while(1){k=j;j=j+-64|0;f[b+-64>>2]=f[j>>2];f[b+-60>>2]=f[k+-60>>2];f[b+-56>>2]=f[k+-56>>2];f[b+-52>>2]=f[k+-52>>2];f[b+-48>>2]=f[k+-48>>2];f[b+-44>>2]=f[k+-44>>2];f[b+-40>>2]=f[k+-40>>2];f[b+-36>>2]=f[k+-36>>2];f[b+-32>>2]=f[k+-32>>2];f[b+-28>>2]=f[k+-28>>2];f[b+-24>>2]=f[k+-24>>2];f[b+-20>>2]=f[k+-20>>2];f[b+-16>>2]=f[k+-16>>2];f[b+-12>>2]=f[k+-12>>2];f[b+-8>>2]=f[k+-8>>2];f[b+-4>>2]=f[k+-4>>2];if((j|0)==(g|0))break;else b=b+-64|0}n=h+(~(i>>>6)<<6)|0;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;O5b(o);return}function PL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>7>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+128|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+128|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>7;g=i+b|0;if(g>>>0>33554431)c4b(a);l=d-h|0;h=l>>6;d=l>>7>>>0<16777215?(h>>>0<g>>>0?g:h):33554431;do if(d)if(d>>>0>33554431){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{m=L5b(d<<7)|0;break}else m=0;while(0);h=m+(i<<7)|0;i=h;g=m+(d<<7)|0;d=b;b=h;m=i;do{j=b;k=j+128|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+128|0;m=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){n=i;o=j}else{i=b+-128-j|0;j=b;b=h;while(1){k=0;do{f[b+-128+(k<<2)>>2]=f[j+-128+(k<<2)>>2];k=k+1|0}while((k|0)!=32);j=j+-128|0;if((j|0)==(g|0))break;else b=b+-128|0}n=h+(~(i>>>7)<<7)|0;o=f[a>>2]|0}f[a>>2]=n;f[e>>2]=m;f[c>>2]=d;if(!o)return;O5b(o);return}function QL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>8>>>0>=b>>>0){h=b;i=g;do{Nac(i|0,0,256)|0;i=(f[e>>2]|0)+256|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>8;g=i+b|0;if(g>>>0>16777215)c4b(a);j=d-h|0;h=j>>7;d=j>>8>>>0<8388607?(h>>>0<g>>>0?g:h):16777215;do if(d)if(d>>>0>16777215){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<8)|0;break}else k=0;while(0);h=k+(i<<8)|0;i=h;g=k+(d<<8)|0;d=b;b=h;k=i;do{Nac(b|0,0,256)|0;b=k+256|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-256-j|0;j=b;b=h;while(1){n=0;do{f[b+-256+(n<<2)>>2]=f[j+-256+(n<<2)>>2];n=n+1|0}while((n|0)!=64);j=j+-256|0;if((j|0)==(g|0))break;else b=b+-256|0}l=h+(~(i>>>8)<<8)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;O5b(m);return}function RL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>9>>>0>=b>>>0){h=b;i=g;do{Nac(i|0,0,512)|0;i=(f[e>>2]|0)+512|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>9;g=i+b|0;if(g>>>0>8388607)c4b(a);j=d-h|0;h=j>>8;d=j>>9>>>0<4194303?(h>>>0<g>>>0?g:h):8388607;do if(d)if(d>>>0>8388607){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<9)|0;break}else k=0;while(0);h=k+(i<<9)|0;i=h;g=k+(d<<9)|0;d=b;b=h;k=i;do{Nac(b|0,0,512)|0;b=k+512|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-512-j|0;j=b;b=h;while(1){n=0;do{f[b+-512+(n<<2)>>2]=f[j+-512+(n<<2)>>2];n=n+1|0}while((n|0)!=128);j=j+-512|0;if((j|0)==(g|0))break;else b=b+-512|0}l=h+(~(i>>>9)<<9)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;O5b(m);return}function SL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/56|0;h=d;if(g>>>0<b>>>0){UL(a,b-g|0);return}if(g>>>0<=b>>>0)return;g=e+(b*56|0)|0;if((h|0)==(g|0))return;else i=h;do{f[c>>2]=i+-56;h=i+-20|0;b=f[h>>2]|0;if((b|0?(e=b+12|0,b=f[e>>2]|0,f[e>>2]=b+-1,(b|0)==1):0)?(b=f[h>>2]|0,b|0):0){f[h>>2]=0;e=f[b+4>>2]|0;if(!e){a=f[i+-24>>2]|0;if(!a)j=$K()|0;else j=a}else j=e;zh[f[(f[j>>2]|0)+24>>2]&2047](j,b)}f[h>>2]=0;h=i+-40|0;b=i+-52|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[b>>2]|0)>0){h=f[i+-16>>2]|0;e=0;do{f[h+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[b>>2]|0))}b=f[i+-12>>2]|0;if((b|0)!=(i+-8|0))UC(b);i=f[c>>2]|0}while((i|0)!=(g|0));return}function TL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/48|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=1124007936;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[i+32>>2]=i+8;j=i+40|0;f[i+36>>2]=j;f[i+44>>2]=0;f[j>>2]=0;i=(f[e>>2]|0)+48|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/48|0;g=i+b|0;if(g>>>0>89478485)c4b(a);j=(d-h|0)/48|0;h=j<<1;d=j>>>0<44739242?(h>>>0<g>>>0?g:h):89478485;do if(d)if(d>>>0>89478485){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d*48|0)|0;break}else k=0;while(0);h=k+(i*48|0)|0;i=h;g=k+(d*48|0)|0;d=b;b=i;k=h;do{f[k>>2]=1124007936;j=k+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[k+32>>2]=k+8;j=k+40|0;f[k+36>>2]=j;f[k+44>>2]=0;f[j>>2]=0;k=b+48|0;b=k;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;k=f[e>>2]|0;if((k|0)==(g|0)){l=i;m=g;n=k}else{j=k;k=i;i=h;do{h=i+-48|0;o=j;j=j+-48|0;f[h>>2]=f[j>>2];p=i+-44|0;q=o+-44|0;f[p>>2]=f[q>>2];r=i+-40|0;f[r>>2]=f[o+-40>>2];f[i+-36>>2]=f[o+-36>>2];f[i+-32>>2]=f[o+-32>>2];f[i+-28>>2]=f[o+-28>>2];s=f[o+-24>>2]|0;f[i+-24>>2]=s;f[i+-20>>2]=f[o+-20>>2];f[i+-16>>2]=r;r=i+-8|0;t=i+-12|0;f[t>>2]=r;f[i+-4>>2]=0;f[r>>2]=0;if(s|0){r=s+8|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+-12>>2]|0;o=f[t>>2]|0;f[o>>2]=f[q>>2];f[o+4>>2]=f[q+4>>2]}else{f[p>>2]=0;gI(h,j)}i=k+-48|0;k=i}while((j|0)!=(g|0));l=k;m=f[a>>2]|0;n=f[e>>2]|0}f[a>>2]=l;f[e>>2]=b;f[c>>2]=d;d=m;c=n;while(1){n=c;if((n|0)==(d|0))break;b=n+-48|0;hI(b);c=b}if(!m)return;O5b(m);return}function UL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+32|0;d=c;e=f[a+8>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/56|0)>>>0>=b>>>0){i=b;j=h;do{f[j>>2]=1124007936;k=j+8|0;l=j+40|0;m=j+4|0;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[l>>2]=k;o=j+48|0;f[j+44>>2]=o;f[o>>2]=0;f[j+52>>2]=0;j=(f[g>>2]|0)+56|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);u=c;return}i=f[a>>2]|0;j=(h-i|0)/56|0;h=j+b|0;if(h>>>0>76695844)c4b(a);g=(e-i|0)/56|0;i=g<<1;e=g>>>0<38347922?(i>>>0<h>>>0?h:i):76695844;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(e)if(e>>>0>76695844){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{p=L5b(e*56|0)|0;break}else p=0;while(0);f[d>>2]=p;i=p+(j*56|0)|0;j=d+8|0;f[j>>2]=i;f[d+4>>2]=i;f[d+12>>2]=p+(e*56|0);e=b;b=i;while(1){f[b>>2]=1124007936;i=b+8|0;g=b+40|0;m=b+4|0;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[g>>2]=i;k=b+48|0;f[b+44>>2]=k;f[k>>2]=0;f[b+52>>2]=0;e=e+-1|0;if(!e)break;else b=b+56|0}f[j>>2]=p+(h*56|0);$s(a,d);at(d);u=c;return}function VL(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a>>2]|0;d=a+4|0;e=f[d>>2]|0;g=b+4|0;do if((e|0)!=(c|0)){h=e;i=f[g>>2]|0;while(1){j=i+-12|0;f[j>>2]=0;k=i+-8|0;f[k>>2]=0;f[i+-4>>2]=0;l=h+-8|0;h=h+-12|0;m=(f[l>>2]|0)-(f[h>>2]|0)|0;if(m|0){if((m|0)<0){n=6;break}o=L5b(m)|0;f[k>>2]=o;f[j>>2]=o;f[i+-4>>2]=o+m;m=f[h>>2]|0;p=(f[l>>2]|0)-m|0;if((p|0)>0){Vac(o|0,m|0,p|0)|0;f[k>>2]=o+p}}i=(f[g>>2]|0)+-12|0;f[g>>2]=i;if((h|0)==(c|0)){n=10;break}}if((n|0)==6)c4b(j);else if((n|0)==10){q=g;r=a;s=i;t=f[a>>2]|0;break}}else{q=g;r=a;s=f[g>>2]|0;t=c}while(0);f[r>>2]=s;f[q>>2]=t;t=b+8|0;s=f[d>>2]|0;f[d>>2]=f[t>>2];f[t>>2]=s;s=a+8|0;a=b+12|0;t=f[s>>2]|0;f[s>>2]=f[a>>2];f[a>>2]=t;f[b>>2]=f[q>>2];return}function WL(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;g=u;u=u+64|0;h=g+8|0;i=g;j=f[c>>2]|0;k=(j>>>3&511)+1|0;f[h>>2]=j;j=h+4|0;l=c+4|0;m=f[l>>2]|0;f[j>>2]=m;n=h+8|0;o=c+8|0;f[n>>2]=f[o>>2];p=h+12|0;q=c+12|0;f[p>>2]=f[q>>2];r=h+16|0;f[r>>2]=f[c+16>>2];s=h+20|0;f[s>>2]=f[c+20>>2];t=h+24|0;f[t>>2]=f[c+24>>2];v=h+28|0;f[v>>2]=f[c+28>>2];w=h+32|0;f[w>>2]=f[c+32>>2];x=h+36|0;y=f[c+36>>2]|0;f[x>>2]=y;z=h+40|0;f[z>>2]=n;A=h+48|0;B=h+44|0;f[B>>2]=A;f[A>>2]=0;f[h+52>>2]=0;if(!y)C=m;else{m=y+12|0;f[m>>2]=(f[m>>2]|0)+1;C=f[l>>2]|0}if((C|0)>=3){f[j>>2]=0;YK(h,C,0,0,0);if((f[j>>2]|0)>0){C=f[c+40>>2]|0;m=f[z>>2]|0;y=f[c+44>>2]|0;D=f[B>>2]|0;E=0;do{f[m+(E<<2)>>2]=f[C+(E<<2)>>2];f[D+(E<<2)>>2]=f[y+(E<<2)>>2];E=E+1|0}while((E|0)<(f[j>>2]|0))}}else{E=f[c+44>>2]|0;y=f[B>>2]|0;f[y>>2]=f[E>>2];f[y+4>>2]=f[E+4>>2]}E=f[l>>2]|0;a:do if((E|0)>2){if((d|0)!=0&(e|0)==0){y=E+-1|0;if(!((Y(f[(f[c+40>>2]|0)+(y<<2)>>2]|0,k)|0)%(d|0)|0)){D=f[h>>2]|0;C=(d<<3)+-8|0;f[h>>2]=D&-4089|C;f[(f[B>>2]|0)+(y<<2)>>2]=(C>>>3&511)+1<<(47696>>>(D<<1&14)&3);D=(f[z>>2]|0)+((f[l>>2]|0)+-1<<2)|0;C=(Y(f[D>>2]|0,k)|0)/(d|0)|0;f[D>>2]=C;f[a>>2]=f[h>>2];C=a+4|0;D=f[j>>2]|0;f[C>>2]=D;y=a+8|0;f[y>>2]=f[n>>2];f[a+12>>2]=f[p>>2];f[a+16>>2]=f[r>>2];f[a+20>>2]=f[s>>2];f[a+24>>2]=f[t>>2];f[a+28>>2]=f[v>>2];f[a+32>>2]=f[w>>2];m=f[x>>2]|0;f[a+36>>2]=m;F=a+40|0;f[F>>2]=y;y=a+48|0;G=a+44|0;f[G>>2]=y;f[y>>2]=0;f[a+52>>2]=0;if(!m)H=D;else{D=m+12|0;f[D>>2]=(f[D>>2]|0)+1;H=f[j>>2]|0}if((H|0)<3){D=f[B>>2]|0;m=f[G>>2]|0;f[m>>2]=f[D>>2];f[m+4>>2]=f[D+4>>2];break}f[C>>2]=0;YK(a,H,0,0,0);if((f[C>>2]|0)<=0)break;D=f[z>>2]|0;m=f[F>>2]|0;F=f[B>>2]|0;y=f[G>>2]|0;G=0;while(1){f[m+(G<<2)>>2]=f[D+(G<<2)>>2];f[y+(G<<2)>>2]=f[F+(G<<2)>>2];G=G+1|0;if((G|0)>=(f[C>>2]|0))break a}}}else if((e|0)>0){f[i>>2]=e;C=f[c+40>>2]|0;G=0;F=1;do{F=Y(f[C+(G<<2)>>2]|0,F)|0;G=G+1|0}while((G|0)!=(E|0));f[i+4>>2]=(F>>>0)/(e>>>0)|0;XL(a,c,d,2,i);break}f[i>>2]=0;f[i+4>>2]=0;I=aD(i,9)|0;J=180256;K=I+9|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));bO(-215,i,181862,179056,1087);bD(i);L=23}else L=23;while(0);do if((L|0)==23){E=(d|0)==0?k:d;H=Y(f[q>>2]|0,k)|0;l=(e|0)==0;if((E|0)>(H|0))if(l)L=26;else{M=e;L=28}else if(l&((H|0)%(E|0)|0|0)!=0)L=26;else{N=e;L=27}if((L|0)==26){N=(Y(f[o>>2]|0,H)|0)/(E|0)|0;L=27}if((L|0)==27)if(!N)O=H;else{M=N;L=28}if((L|0)==28){l=f[o>>2]|0;if((M|0)==(l|0))O=H;else{F=Y(l,H)|0;if(!(f[c>>2]&16384)){f[i>>2]=0;f[i+4>>2]=0;I=aD(i,72)|0;J=195401;K=I+72|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));bO(-13,i,181862,179056,1102);bD(i)}if(M>>>0>F>>>0){f[i>>2]=0;f[i+4>>2]=0;I=aD(i,22)|0;J=195474;K=I+22|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));bO(-211,i,181862,179056,1105);bD(i)}H=(F|0)/(M|0)|0;if((Y(H,M)|0)!=(F|0)){f[i>>2]=0;f[i+4>>2]=0;I=aD(i,78)|0;J=195312;K=I+78|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));bO(-5,i,181862,179056,1111);bD(i)}f[n>>2]=M;F=Y(1212424721>>>(f[c>>2]<<2&28)&15,H)|0;f[f[B>>2]>>2]=F;O=H}}F=(O|0)/(E|0)|0;if((Y(F,E)|0)!=(O|0)){f[i>>2]=0;f[i+4>>2]=0;I=aD(i,62)|0;J=195497;K=I+62|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));bO(-15,i,181862,179056,1121);bD(i)}f[p>>2]=F;H=f[h>>2]|0;l=(E<<3)+-8|0;G=H&-4089|l;f[h>>2]=G;f[(f[B>>2]|0)+4>>2]=(l>>>3&511)+1<<(47696>>>(H<<1&14)&3);f[a>>2]=G;G=a+4|0;H=f[j>>2]|0;f[G>>2]=H;l=a+8|0;f[l>>2]=f[n>>2];f[a+12>>2]=f[p>>2];f[a+16>>2]=f[r>>2];f[a+20>>2]=f[s>>2];f[a+24>>2]=f[t>>2];f[a+28>>2]=f[v>>2];f[a+32>>2]=f[w>>2];C=f[x>>2]|0;f[a+36>>2]=C;y=a+40|0;f[y>>2]=l;l=a+48|0;D=a+44|0;f[D>>2]=l;f[l>>2]=0;f[a+52>>2]=0;if(!C)P=H;else{H=C+12|0;f[H>>2]=(f[H>>2]|0)+1;P=f[j>>2]|0}if((P|0)<3){H=f[B>>2]|0;C=f[D>>2]|0;f[C>>2]=f[H>>2];f[C+4>>2]=f[H+4>>2];break}f[G>>2]=0;YK(a,P,0,0,0);if((f[G>>2]|0)>0){H=f[z>>2]|0;C=f[y>>2]|0;y=f[B>>2]|0;l=f[D>>2]|0;D=0;do{f[C+(D<<2)>>2]=f[H+(D<<2)>>2];f[l+(D<<2)>>2]=f[y+(D<<2)>>2];D=D+1|0}while((D|0)<(f[G>>2]|0))}}while(0);P=f[x>>2]|0;if((P|0?(a=P+12|0,P=f[a>>2]|0,f[a>>2]=P+-1,(P|0)==1):0)?(P=f[x>>2]|0,P|0):0){f[x>>2]=0;a=f[P+4>>2]|0;if(!a){v=f[w>>2]|0;if(!v)Q=$K()|0;else Q=v}else Q=a;zh[f[(f[Q>>2]|0)+24>>2]&2047](Q,P)}f[x>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[j>>2]|0)>0){r=f[z>>2]|0;z=0;do{f[r+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[j>>2]|0))}j=f[B>>2]|0;if((j|0)==(A|0)){u=g;return}UC(j);u=g;return}function XL(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+32|0;i=h+8|0;j=h;k=c+4|0;if((f[k>>2]|0)==(e|0)){if(!g){WL(a,c,d,0);u=h;return}if((e|0)==2){WL(a,c,d,f[g>>2]|0);u=h;return}}if(!(f[c>>2]&16384)){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,71)|0;m=182083;n=l+71|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-213,i,181862,179056,4767);bD(i);f[a>>2]=1124007936;o=a+8|0;p=a+40|0;l=a+4|0;n=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(n|0));f[p>>2]=o;o=a+48|0;f[a+44>>2]=o;f[o>>2]=0;f[a+52>>2]=0;u=h;return}if(!((g|0)!=0&((d|0)>-1&(e+-1|0)>>>0<32))){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,54)|0;m=181870;n=l+54|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,i,181862,179056,4731);bD(i)}if(d)if((d|0)<513)q=d;else{f[i>>2]=0;f[i+4>>2]=0;l=aD(i,10)|0;m=181925;n=l+10|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,i,181862,179056,4736);bD(i);q=d}else q=((f[c>>2]|0)>>>3&511)+1|0;d=f[k>>2]|0;if((d|0)<3)r=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{o=f[c+40>>2]|0;p=0;s=1;while(1){t=Y(f[o+(p<<2)>>2]|0,s)|0;p=p+1|0;if((p|0)==(d|0)){r=t;break}else s=t}}s=Y(((f[c>>2]|0)>>>3&511)+1|0,r)|0;r=i+8|0;f[i>>2]=r;d=i+4|0;f[d>>2]=e;if(e>>>0>4){p=N5b(e>>>0>1073741823?-1:e<<2)|0;f[i>>2]=p}if((e|0)>0){p=c+40|0;o=j+4|0;t=j+4|0;v=q;w=0;while(1){x=g+(w<<2)|0;y=f[x>>2]|0;if((y|0)>-1)z=y;else{f[j>>2]=0;f[t>>2]=0;l=aD(j,14)|0;m=181936;n=l+14|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,j,181862,179056,4745);bD(j);z=f[x>>2]|0}do if((z|0)<=0)if((w|0)<(f[k>>2]|0)){y=f[(f[p>>2]|0)+(w<<2)>>2]|0;f[(f[i>>2]|0)+(w<<2)>>2]=y;A=y;break}else{f[j>>2]=0;f[o>>2]=0;l=aD(j,68)|0;m=181951;n=l+68|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-211,j,181862,179056,4752);bD(j);A=f[(f[i>>2]|0)+(w<<2)>>2]|0;break}else{f[(f[i>>2]|0)+(w<<2)>>2]=z;A=z}while(0);x=Y(A,v)|0;w=w+1|0;if((w|0)>=(e|0)){B=x;break}else v=x}}else B=q;if((B|0)!=(s|0)){f[j>>2]=0;f[j+4>>2]=0;l=aD(j,62)|0;m=182020;n=l+62|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-209,j,181862,179056,4758);bD(j)}f[a>>2]=f[c>>2];j=a+4|0;m=f[k>>2]|0;f[j>>2]=m;l=a+8|0;f[l>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];n=f[c+36>>2]|0;f[a+36>>2]=n;s=a+40|0;f[s>>2]=l;l=a+48|0;B=a+44|0;f[B>>2]=l;f[l>>2]=0;f[a+52>>2]=0;if(!n)C=m;else{m=n+12|0;f[m>>2]=(f[m>>2]|0)+1;C=f[k>>2]|0}if((C|0)>=3){f[j>>2]=0;YK(a,C,0,0,0);if((f[j>>2]|0)>0){C=f[c+40>>2]|0;k=f[s>>2]|0;s=f[c+44>>2]|0;m=f[B>>2]|0;n=0;do{f[k+(n<<2)>>2]=f[C+(n<<2)>>2];f[m+(n<<2)>>2]=f[s+(n<<2)>>2];n=n+1|0}while((n|0)<(f[j>>2]|0))}}else{j=f[c+44>>2]|0;c=f[B>>2]|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2]}f[a>>2]=f[a>>2]&-4089|(q<<3)+-8;YK(a,e,f[i>>2]|0,0,1);e=f[i>>2]|0;if((e|0)!=(r|0)){if(e|0)P5b(e);f[i>>2]=r;f[d>>2]=4}u=h;return}function YL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+112|0;e=d+48|0;g=d;h=d+32|0;i=c+12|0;j=f[i>>2]|0;k=c+8|0;if((j|0)!=1)if((f[k>>2]|0)==1)l=j;else{f[e>>2]=0;f[e+4>>2]=0;m=aD(e,26)|0;j=182155;n=m+26|0;do{b[m>>0]=b[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(n|0));bO(-215,e,180266,179056,1131);bD(e);l=f[i>>2]|0}else l=1;j=(f[k>>2]|0)+-1+l|0;l=f[c>>2]&4095;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[a>>2]=1124007936;k=a+8|0;o=a+40|0;m=a+4|0;n=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));f[o>>2]=k;k=a+48|0;f[a+44>>2]=k;f[k>>2]=0;f[a+52>>2]=0;f[e>>2]=j;f[e+4>>2]=j;hL(a,2,e,l);UP(a,g)|0;rL(e,a,0);if((f[i>>2]|0)==1){i=g+8|0;f[i>>2]=0;f[i+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=e;SP(c,g)}else{f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=c;c=h+8|0;f[c>>2]=0;f[c+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=e;ZL(g,h)}h=e+36|0;g=f[h>>2]|0;if((g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)?(g=f[h>>2]|0,g|0):0){f[h>>2]=0;c=f[g+4>>2]|0;if(!c){i=f[e+32>>2]|0;if(!i)p=$K()|0;else p=i}else p=c;zh[f[(f[p>>2]|0)+24>>2]&2047](p,g)}f[h>>2]=0;h=e+16|0;g=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[g>>2]|0)>0){h=f[e+40>>2]|0;p=0;do{f[h+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)==(e+48|0)){u=d;return}UC(g);u=d;return}function ZL(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+144|0;e=d+136|0;g=d+80|0;h=d+24|0;i=d;j=d+16|0;dQ(e,42412);k=BL(a,-1)|0;l=(k>>>3&511)+1<<(47696>>>(k<<1&14)&3);if(!((l|0)<33&(_L(a,-1)|0)<3)){f[g>>2]=0;f[g+4>>2]=0;m=aD(g,29)|0;n=182182;o=m+29|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,g,182212,179056,3591);bD(g)}xL(g,a,-1);a=g+16|0;if(f[a>>2]|0){k=f[g+4>>2]|0;if((k|0)<3)p=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{q=f[g+40>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(k|0)){p=t;break}else s=t}}if(!((k|0)==0|(p|0)==0)){p=g+12|0;k=g+8|0;aM(c,f[p>>2]|0,f[k>>2]|0,f[g>>2]&4095,-1,0,0);xL(h,c,-1);s=f[k>>2]|0;k=h+12|0;do if((s|0)==(f[k>>2]|0)?(r=f[p>>2]|0,q=h+8|0,(r|0)==(f[q>>2]|0)):0){t=h+16|0;v=f[t>>2]|0;w=f[a>>2]|0;if((v|0)!=(w|0)){x=f[42564+(l<<2)>>2]|0;if(!x){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,9)|0;n=255890;o=m+9|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,182212,179056,3626);bD(i);y=f[a>>2]|0;z=f[t>>2]|0}else{y=w;z=v}A=f[g+48>>2]|0;B=f[h+48>>2]|0;C=f[g+40>>2]|0;D=f[C>>2]|0;f[j>>2]=f[C+4>>2];f[j+4>>2]=D;uh[x&255](y,A,z,B,j);break}B=f[42432+(l<<2)>>2]|0;if(!B){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,9)|0;n=255890;o=m+9|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,182212,179056,3619);bD(i);E=f[k>>2]|0;F=f[q>>2]|0}else{E=s;F=r}if((E|0)==(F|0))G=F;else{f[i>>2]=0;f[i+4>>2]=0;m=aD(i,20)|0;n=362757;o=m+20|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,182212,179056,3620);bD(i);G=f[q>>2]|0}_h[B&255](f[t>>2]|0,f[h+48>>2]|0,G)}else H=12;while(0);if((H|0)==12){G=f[g+40>>2]|0;F=f[h+40>>2]|0;if(!(((f[F>>2]|0)==(f[G>>2]|0)?(f[F+4>>2]|0)==(f[G+4>>2]|0):0)?(f[p>>2]|0)==1|(s|0)==1:0)){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,60)|0;n=182222;o=m+60|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,182212,179056,3609);bD(i)}n=i+8|0;f[n>>2]=0;f[n+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;SP(g,i)}i=h+36|0;n=f[i>>2]|0;if((n|0?(m=n+12|0,n=f[m>>2]|0,f[m>>2]=n+-1,(n|0)==1):0)?(n=f[i>>2]|0,n|0):0){f[i>>2]=0;m=f[n+4>>2]|0;if(!m){o=f[h+32>>2]|0;if(!o)I=$K()|0;else I=o}else I=m;zh[f[(f[I>>2]|0)+24>>2]&2047](I,n)}f[i>>2]=0;i=h+16|0;n=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[n>>2]|0)>0){i=f[h+40>>2]|0;I=0;do{f[i+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[n>>2]|0))}n=f[h+44>>2]|0;if((n|0)!=(h+48|0))UC(n)}else H=9}else H=9;if((H|0)==9)$L(c);c=g+36|0;H=f[c>>2]|0;if((H|0?(n=H+12|0,H=f[n>>2]|0,f[n>>2]=H+-1,(H|0)==1):0)?(H=f[c>>2]|0,H|0):0){f[c>>2]=0;n=f[H+4>>2]|0;if(!n){h=f[g+32>>2]|0;if(!h)J=$K()|0;else J=h}else J=n;zh[f[(f[J>>2]|0)+24>>2]&2047](J,H)}f[c>>2]=0;c=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[c>>2]|0)>0){a=f[g+40>>2]|0;H=0;do{f[a+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)!=(g+48|0))UC(c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function _L(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;do switch((f[a>>2]|0)>>>16&31){case 1:{if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,5)|0;b[g>>0]=b[180637]|0;b[g+1>>0]=b[180638]|0;b[g+2>>0]=b[180639]|0;b[g+3>>0]=b[180640]|0;b[g+4>>0]=b[180641]|0;bO(-215,e,183162,179056,1817);bD(e)}h=f[(f[a+4>>2]|0)+4>>2]|0;u=d;return h|0}case 6:{if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,5)|0;b[g>>0]=b[180637]|0;b[g+1>>0]=b[180638]|0;b[g+2>>0]=b[180639]|0;b[g+3>>0]=b[180640]|0;b[g+4>>0]=b[180641]|0;bO(-215,e,183162,179056,1823);bD(e)}h=f[(f[a+4>>2]|0)+12>>2]|0;u=d;return h|0}case 10:{if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,5)|0;b[g>>0]=b[180637]|0;b[g+1>>0]=b[180638]|0;b[g+2>>0]=b[180639]|0;b[g+3>>0]=b[180640]|0;b[g+4>>0]=b[180641]|0;bO(-215,e,183162,179056,1829);bD(e)}h=f[(f[a+4>>2]|0)+4>>2]|0;u=d;return h|0}case 2:case 14:{if((c|0)<0){h=2;u=d;return h|0}f[e>>2]=0;f[e+4>>2]=0;g=aD(e,5)|0;b[g>>0]=b[180637]|0;b[g+1>>0]=b[180638]|0;b[g+2>>0]=b[180639]|0;b[g+3>>0]=b[180640]|0;b[g+4>>0]=b[180641]|0;bO(-215,e,183162,179056,1835);bD(e);h=2;u=d;return h|0}case 3:case 12:{if((c|0)<0){h=2;u=d;return h|0}f[e>>2]=0;f[e+4>>2]=0;g=aD(e,5)|0;b[g>>0]=b[180637]|0;b[g+1>>0]=b[180638]|0;b[g+2>>0]=b[180639]|0;b[g+3>>0]=b[180640]|0;b[g+4>>0]=b[180641]|0;bO(-215,e,183162,179056,1841);bD(e);h=2;u=d;return h|0}case 4:{if((c|0)<0){h=1;u=d;return h|0}g=f[a+4>>2]|0;if((((f[g+4>>2]|0)-(f[g>>2]|0)|0)/12|0|0)>(c|0)){h=2;u=d;return h|0}f[e>>2]=0;f[e+4>>2]=0;i=aD(e,18)|0;j=180932;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,e,183162,179056,1853);bD(e);h=2;u=d;return h|0}case 5:{g=f[a+4>>2]|0;if((c|0)<0){h=1;u=d;return h|0}l=f[g>>2]|0;if((((f[g+4>>2]|0)-l|0)/56|0|0)>(c|0))m=l;else{f[e>>2]=0;f[e+4>>2]=0;i=aD(e,18)|0;j=180932;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,e,183162,179056,1862);bD(e);m=f[g>>2]|0}h=f[m+(c*56|0)+4>>2]|0;u=d;return h|0}case 15:{l=f[a+4>>2]|0;if((c|0)<0){h=1;u=d;return h|0}if((f[a+12>>2]|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;i=aD(e,13)|0;j=180951;k=i+13|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,e,183162,179056,1872);bD(e)}h=f[l+(c*56|0)+4>>2]|0;u=d;return h|0}case 11:{g=f[a+4>>2]|0;if((c|0)<0){h=1;u=d;return h|0}n=f[g>>2]|0;if((((f[g+4>>2]|0)-n|0)/48|0|0)>(c|0))o=n;else{f[e>>2]=0;f[e+4>>2]=0;i=aD(e,18)|0;j=180932;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,e,183162,179056,1882);bD(e);o=f[g>>2]|0}h=f[o+(c*48|0)+4>>2]|0;u=d;return h|0}case 7:{if((c|0)<0){h=2;u=d;return h|0}f[e>>2]=0;f[e+4>>2]=0;l=aD(e,5)|0;b[l>>0]=b[180637]|0;b[l+1>>0]=b[180638]|0;b[l+2>>0]=b[180639]|0;b[l+3>>0]=b[180640]|0;b[l+4>>0]=b[180641]|0;bO(-215,e,183162,179056,1889);bD(e);h=2;u=d;return h|0}case 9:{if((c|0)<0){h=2;u=d;return h|0}f[e>>2]=0;f[e+4>>2]=0;l=aD(e,5)|0;b[l>>0]=b[180637]|0;b[l+1>>0]=b[180638]|0;b[l+2>>0]=b[180639]|0;b[l+3>>0]=b[180640]|0;b[l+4>>0]=b[180641]|0;bO(-215,e,183162,179056,1895);bD(e);h=2;u=d;return h|0}case 8:{if((c|0)<0){h=2;u=d;return h|0}f[e>>2]=0;f[e+4>>2]=0;l=aD(e,5)|0;b[l>>0]=b[180637]|0;b[l+1>>0]=b[180638]|0;b[l+2>>0]=b[180639]|0;b[l+3>>0]=b[180640]|0;b[l+4>>0]=b[180641]|0;bO(-215,e,183162,179056,1901);bD(e);h=2;u=d;return h|0}case 0:{h=0;u=d;return h|0}default:{f[e>>2]=0;f[e+4>>2]=0;i=aD(e,30)|0;j=180875;k=i+30|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-213,e,183162,179056,1905);bD(e);h=0;u=d;return h|0}}while(0);return 0}function $L(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c+8|0;e=c;g=f[a>>2]|0;if(!(g&1073741824))h=g;else{f[d>>2]=0;f[d+4>>2]=0;i=aD(d,12)|0;j=182876;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,d,182889,179056,2832);bD(d);h=f[a>>2]|0}do switch(h>>>16&31){case 1:{g=f[a+4>>2]|0;l=g+36|0;m=f[l>>2]|0;if((m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)?(m=f[l>>2]|0,m|0):0){f[l>>2]=0;n=f[m+4>>2]|0;if(!n){o=f[g+32>>2]|0;if(!o)p=$K()|0;else p=o}else p=n;zh[f[(f[p>>2]|0)+24>>2]&2047](p,m)}f[l>>2]=0;l=g+16|0;m=g+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)<=0){u=c;return}l=f[g+40>>2]|0;g=0;do{f[l+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[m>>2]|0));u=c;return}case 10:{m=f[a+4>>2]|0;g=m+24|0;l=f[g>>2]|0;if(l|0?(n=l+8|0,l=f[n>>2]|0,f[n>>2]=l+-1,(l|0)==1):0)iI(m);l=m+4|0;if((f[l>>2]|0)>0){n=f[m+32>>2]|0;m=0;do{f[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}f[g>>2]=0;u=c;return}case 9:{u=c;return}case 8:{u=c;return}case 7:{YS(f[a+4>>2]|0);u=c;return}case 3:{f[e>>2]=0;f[e+4>>2]=0;vM(a,e,h&4095,-1,0,0);u=c;return}case 4:{l=f[a+4>>2]|0;m=f[l>>2]|0;n=l+4|0;l=f[n>>2]|0;if((l|0)==(m|0)){u=c;return}else q=l;while(1){l=q+-12|0;f[n>>2]=l;o=f[l>>2]|0;if(!o)r=l;else{l=q+-8|0;if((f[l>>2]|0)!=(o|0))f[l>>2]=o;O5b(o);r=f[n>>2]|0}if((r|0)==(m|0))break;else q=r}u=c;return}case 5:{m=f[a+4>>2]|0;n=f[m>>2]|0;g=m+4|0;m=f[g>>2]|0;if((m|0)==(n|0)){u=c;return}else s=m;do{f[g>>2]=s+-56;m=s+-20|0;o=f[m>>2]|0;if((o|0?(l=o+12|0,o=f[l>>2]|0,f[l>>2]=o+-1,(o|0)==1):0)?(o=f[m>>2]|0,o|0):0){f[m>>2]=0;l=f[o+4>>2]|0;if(!l){t=f[s+-24>>2]|0;if(!t)v=$K()|0;else v=t}else v=l;zh[f[(f[v>>2]|0)+24>>2]&2047](v,o)}f[m>>2]=0;m=s+-40|0;o=s+-52|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[o>>2]|0)>0){m=f[s+-16>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[o>>2]|0))}o=f[s+-12>>2]|0;if((o|0)!=(s+-8|0))UC(o);s=f[g>>2]|0}while((s|0)!=(n|0));u=c;return}case 11:{n=f[a+4>>2]|0;g=f[n>>2]|0;o=n+4|0;while(1){n=f[o>>2]|0;if((n|0)==(g|0))break;l=n+-48|0;f[o>>2]=l;hI(l)}u=c;return}case 13:{o=f[a+4>>2]|0;g=f[o>>2]|0;l=o+4|0;while(1){o=f[l>>2]|0;if((o|0)==(g|0))break;f[l>>2]=o+-36}u=c;return}case 0:{u=c;return}default:{f[d>>2]=0;f[d+4>>2]=0;i=aD(d,30)|0;j=180875;k=i+30|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-213,d,182889,179056,2897);bD(d);u=c;return}}while(0)}function aM(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;j=u;u=u+16|0;k=j;l=f[a>>2]|0;m=l&2031616;n=(g|0)<0;do if(n&(m|0)==65536){if((i|0)==0&(h^1)){if((l&1073741824|0)!=0?(o=f[(f[a+4>>2]|0)+40>>2]|0,!((f[o>>2]|0)==(c|0)?(f[o+4>>2]|0)==(d|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=aD(k,68)|0;q=182283;r=p+68|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,k,440241,179056,2427);bD(k);s=f[a>>2]|0}else s=l;o=a+4|0;if((s|0)<0?(f[f[o>>2]>>2]&4095|0)!=(e|0):0){f[k>>2]=0;f[k+4>>2]=0;p=aD(k,44)|0;q=182352;r=p+44|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,k,440241,179056,2428);bD(k)}t=f[o>>2]|0;v=e&4095;if(((((f[t+4>>2]|0)<3?(f[t+8>>2]|0)==(c|0):0)?(f[t+12>>2]|0)==(d|0):0)?(f[t>>2]&4095|0)==(v|0):0)?f[t+16>>2]|0:0){u=j;return}f[k>>2]=c;f[k+4>>2]=d;hL(t,2,k,v);u=j;return}}else{if(n&(m|0)==655360){if(!((i|0)==0&(h^1)))break;if((l&1073741824|0)!=0?(v=f[(f[a+4>>2]|0)+32>>2]|0,!((f[v>>2]|0)==(c|0)?(f[v+4>>2]|0)==(d|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=aD(k,69)|0;q=182397;r=p+69|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,k,440241,179056,2434);bD(k);w=f[a>>2]|0}else w=l;o=a+4|0;if((w|0)<0?(f[f[o>>2]>>2]&4095|0)!=(e|0):0){f[k>>2]=0;f[k+4>>2]=0;p=aD(k,45)|0;q=182467;r=p+45|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,k,440241,179056,2435);bD(k)}v=f[o>>2]|0;t=e&4095;if(((((f[v+4>>2]|0)<3?(f[v+8>>2]|0)==(c|0):0)?(f[v+12>>2]|0)==(d|0):0)?(f[v>>2]&4095|0)==(t|0):0)?f[v+24>>2]|0:0){u=j;return}f[k>>2]=c;f[k+4>>2]=d;eI(v,2,k,t,0);u=j;return}if(n&(m|0)==589824){if(!((i|0)==0&(h^1)))break;if((l&1073741824|0)!=0?(t=f[a+4>>2]|0,!((f[t+8>>2]|0)==(d|0)?(f[t+4>>2]|0)==(c|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=aD(k,66)|0;q=182513;r=p+66|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,k,440241,179056,2441);bD(k);x=f[a>>2]|0}else x=l;o=a+4|0;if((x|0)<0?(f[f[o>>2]>>2]&4095|0)!=(e|0):0){f[k>>2]=0;f[k+4>>2]=0;p=aD(k,53)|0;q=182580;r=p+53|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,k,440241,179056,2442);bD(k)}kT(f[o>>2]|0,c,d,e);u=j;return}if(n&(m|0)==458752){if(!((i|0)==0&(h^1)))break;if((l&1073741824|0)!=0?(t=f[a+4>>2]|0,!((f[t+12>>2]|0)==(d|0)?(f[t+8>>2]|0)==(c|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=aD(k,65)|0;q=182634;r=p+65|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,k,440241,179056,2448);bD(k);y=f[a>>2]|0}else y=l;o=a+4|0;if((y|0)<0?(f[(f[o>>2]|0)+16>>2]|0)!=(e|0):0){f[k>>2]=0;f[k+4>>2]=0;p=aD(k,52)|0;q=182700;r=p+52|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,k,440241,179056,2449);bD(k)}XS(f[o>>2]|0,c,d,e,34962,0);u=j;return}if(n&(m|0)==524288?(i|0)==0&(h^1):0){if((l&1073741824|0)!=0?(t=f[a+4>>2]|0,!((f[t+8>>2]|0)==(d|0)?(f[t+4>>2]|0)==(c|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;p=aD(k,67)|0;q=182753;r=p+67|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,k,440241,179056,2455);bD(k);z=f[a>>2]|0}else z=l;o=a+4|0;if((z|0)<0?(f[f[o>>2]>>2]&4095|0)!=(e|0):0){f[k>>2]=0;f[k+4>>2]=0;p=aD(k,54)|0;q=182821;r=p+54|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,k,440241,179056,2456);bD(k)}bQ(f[o>>2]|0,c,d,e);u=j;return}}while(0);f[k>>2]=c;f[k+4>>2]=d;wL(a,2,k,e,g,h,i);u=j;return}function bM(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=d+(Y(l,e)|0)|0;n=d+(Y(l|1,e)|0)|0;o=d+(Y(l|2,e)|0)|0;p=d+(Y(l|3,e)|0)|0;q=a+l|0;r=0;do{s=q+(Y(r,c)|0)|0;b[m+r>>0]=b[s>>0]|0;b[n+r>>0]=b[s+1>>0]|0;b[o+r>>0]=b[s+2>>0]|0;b[p+r>>0]=b[s+3>>0]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=d+(Y(p,e)|0)|0;n=d+(Y(p|1,e)|0)|0;m=d+(Y(p|2,e)|0)|0;q=d+(Y(p|3,e)|0)|0;s=a+p|0;t=0;do{u=s+(Y(t,c)|0)|0;v=t|1;w=s+(Y(v,c)|0)|0;x=t|2;y=s+(Y(x,c)|0)|0;z=t|3;A=s+(Y(z,c)|0)|0;b[o+t>>0]=b[u>>0]|0;b[o+v>>0]=b[w>>0]|0;b[o+x>>0]=b[y>>0]|0;b[o+z>>0]=b[A>>0]|0;b[n+t>>0]=b[u+1>>0]|0;b[n+v>>0]=b[w+1>>0]|0;b[n+x>>0]=b[y+1>>0]|0;b[n+z>>0]=b[A+1>>0]|0;b[m+t>>0]=b[u+2>>0]|0;b[m+v>>0]=b[w+2>>0]|0;b[m+x>>0]=b[y+2>>0]|0;b[m+z>>0]=b[A+2>>0]|0;b[q+t>>0]=b[u+3>>0]|0;b[q+v>>0]=b[w+3>>0]|0;b[q+x>>0]=b[y+3>>0]|0;b[q+z>>0]=b[A+3>>0]|0;t=t+4|0}while((t|0)<=(k|0));if(r){t=l;do{A=s+(Y(t,c)|0)|0;b[o+t>>0]=b[A>>0]|0;b[n+t>>0]=b[A+1>>0]|0;b[m+t>>0]=b[A+2>>0]|0;b[q+t>>0]=b[A+3>>0]|0;t=t+1|0}while((t|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)B=j;else return;do{p=d+(Y(B,e)|0)|0;l=a+B|0;r=0;do{k=l+(Y(r,c)|0)|0;b[p+r>>0]=b[k>>0]|0;r=r+1|0}while((r|0)!=(i|0));B=B+1|0}while((B|0)!=(h|0));return}B=i&-4;if((B|0)<(i|0))C=j;else{r=j;do{j=d+(Y(r,e)|0)|0;p=a+r|0;l=0;do{k=p+(Y(l,c)|0)|0;t=l|1;q=p+(Y(t,c)|0)|0;m=l|2;n=p+(Y(m,c)|0)|0;o=l|3;s=p+(Y(o,c)|0)|0;b[j+l>>0]=b[k>>0]|0;b[j+t>>0]=b[q>>0]|0;b[j+m>>0]=b[n>>0]|0;b[j+o>>0]=b[s>>0]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=d+(Y(C,e)|0)|0;l=a+C|0;j=0;do{p=l+(Y(j,c)|0)|0;s=j|1;o=l+(Y(s,c)|0)|0;n=j|2;m=l+(Y(n,c)|0)|0;q=j|3;t=l+(Y(q,c)|0)|0;b[r+j>>0]=b[p>>0]|0;b[r+s>>0]=b[o>>0]|0;b[r+n>>0]=b[m>>0]|0;b[r+q>>0]=b[t>>0]|0;j=j+4|0}while((j|0)<=(g|0));D=B;do{j=l+(Y(D,c)|0)|0;b[r+D>>0]=b[j>>0]|0;D=D+1|0}while((D|0)!=(i|0));C=C+1|0}while((C|0)!=(h|0));return}function cM(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=c+(Y(l,e)|0)|0;n=c+(Y(l|1,e)|0)|0;o=c+(Y(l|2,e)|0)|0;p=c+(Y(l|3,e)|0)|0;q=a+(l<<1)|0;r=0;do{s=q+(Y(r,b)|0)|0;d[m+(r<<1)>>1]=d[s>>1]|0;d[n+(r<<1)>>1]=d[s+2>>1]|0;d[o+(r<<1)>>1]=d[s+4>>1]|0;d[p+(r<<1)>>1]=d[s+6>>1]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=c+(Y(p,e)|0)|0;n=c+(Y(p|1,e)|0)|0;m=c+(Y(p|2,e)|0)|0;q=c+(Y(p|3,e)|0)|0;s=a+(p<<1)|0;t=0;do{u=s+(Y(t,b)|0)|0;v=t|1;w=s+(Y(v,b)|0)|0;x=t|2;y=s+(Y(x,b)|0)|0;z=t|3;A=s+(Y(z,b)|0)|0;d[o+(t<<1)>>1]=d[u>>1]|0;d[o+(v<<1)>>1]=d[w>>1]|0;d[o+(x<<1)>>1]=d[y>>1]|0;d[o+(z<<1)>>1]=d[A>>1]|0;d[n+(t<<1)>>1]=d[u+2>>1]|0;d[n+(v<<1)>>1]=d[w+2>>1]|0;d[n+(x<<1)>>1]=d[y+2>>1]|0;d[n+(z<<1)>>1]=d[A+2>>1]|0;d[m+(t<<1)>>1]=d[u+4>>1]|0;d[m+(v<<1)>>1]=d[w+4>>1]|0;d[m+(x<<1)>>1]=d[y+4>>1]|0;d[m+(z<<1)>>1]=d[A+4>>1]|0;d[q+(t<<1)>>1]=d[u+6>>1]|0;d[q+(v<<1)>>1]=d[w+6>>1]|0;d[q+(x<<1)>>1]=d[y+6>>1]|0;d[q+(z<<1)>>1]=d[A+6>>1]|0;t=t+4|0}while((t|0)<=(k|0));if(r){t=l;do{A=s+(Y(t,b)|0)|0;d[o+(t<<1)>>1]=d[A>>1]|0;d[n+(t<<1)>>1]=d[A+2>>1]|0;d[m+(t<<1)>>1]=d[A+4>>1]|0;d[q+(t<<1)>>1]=d[A+6>>1]|0;t=t+1|0}while((t|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)B=j;else return;do{p=c+(Y(B,e)|0)|0;l=a+(B<<1)|0;r=0;do{k=l+(Y(r,b)|0)|0;d[p+(r<<1)>>1]=d[k>>1]|0;r=r+1|0}while((r|0)!=(i|0));B=B+1|0}while((B|0)!=(h|0));return}B=i&-4;if((B|0)<(i|0))C=j;else{r=j;do{j=c+(Y(r,e)|0)|0;p=a+(r<<1)|0;l=0;do{k=p+(Y(l,b)|0)|0;t=l|1;q=p+(Y(t,b)|0)|0;m=l|2;n=p+(Y(m,b)|0)|0;o=l|3;s=p+(Y(o,b)|0)|0;d[j+(l<<1)>>1]=d[k>>1]|0;d[j+(t<<1)>>1]=d[q>>1]|0;d[j+(m<<1)>>1]=d[n>>1]|0;d[j+(o<<1)>>1]=d[s>>1]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=c+(Y(C,e)|0)|0;l=a+(C<<1)|0;j=0;do{p=l+(Y(j,b)|0)|0;s=j|1;o=l+(Y(s,b)|0)|0;n=j|2;m=l+(Y(n,b)|0)|0;q=j|3;t=l+(Y(q,b)|0)|0;d[r+(j<<1)>>1]=d[p>>1]|0;d[r+(s<<1)>>1]=d[o>>1]|0;d[r+(n<<1)>>1]=d[m>>1]|0;d[r+(q<<1)>>1]=d[t>>1]|0;j=j+4|0}while((j|0)<=(g|0));D=B;do{j=l+(Y(D,b)|0)|0;d[r+(D<<1)>>1]=d[j>>1]|0;D=D+1|0}while((D|0)!=(i|0));C=C+1|0}while((C|0)!=(h|0));return}function dM(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=d+(Y(l,e)|0)|0;n=d+(Y(l|1,e)|0)|0;o=d+(Y(l|2,e)|0)|0;p=d+(Y(l|3,e)|0)|0;q=a+(l*3|0)|0;r=0;do{s=q+(Y(r,c)|0)|0;t=m+(r*3|0)|0;b[t>>0]=b[s>>0]|0;b[t+1>>0]=b[s+1>>0]|0;b[t+2>>0]=b[s+2>>0]|0;t=s+3|0;u=n+(r*3|0)|0;b[u>>0]=b[t>>0]|0;b[u+1>>0]=b[t+1>>0]|0;b[u+2>>0]=b[t+2>>0]|0;t=s+6|0;u=o+(r*3|0)|0;b[u>>0]=b[t>>0]|0;b[u+1>>0]=b[t+1>>0]|0;b[u+2>>0]=b[t+2>>0]|0;t=s+9|0;s=p+(r*3|0)|0;b[s>>0]=b[t>>0]|0;b[s+1>>0]=b[t+1>>0]|0;b[s+2>>0]=b[t+2>>0]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=d+(Y(p,e)|0)|0;n=d+(Y(p|1,e)|0)|0;m=d+(Y(p|2,e)|0)|0;q=d+(Y(p|3,e)|0)|0;t=a+(p*3|0)|0;s=0;do{u=t+(Y(s,c)|0)|0;v=s|1;w=t+(Y(v,c)|0)|0;x=s|2;y=t+(Y(x,c)|0)|0;z=s|3;A=t+(Y(z,c)|0)|0;B=o+(s*3|0)|0;b[B>>0]=b[u>>0]|0;b[B+1>>0]=b[u+1>>0]|0;b[B+2>>0]=b[u+2>>0]|0;B=o+(v*3|0)|0;b[B>>0]=b[w>>0]|0;b[B+1>>0]=b[w+1>>0]|0;b[B+2>>0]=b[w+2>>0]|0;B=o+(x*3|0)|0;b[B>>0]=b[y>>0]|0;b[B+1>>0]=b[y+1>>0]|0;b[B+2>>0]=b[y+2>>0]|0;B=o+(z*3|0)|0;b[B>>0]=b[A>>0]|0;b[B+1>>0]=b[A+1>>0]|0;b[B+2>>0]=b[A+2>>0]|0;B=u+3|0;C=n+(s*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=w+3|0;C=n+(v*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=y+3|0;C=n+(x*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=A+3|0;C=n+(z*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=u+6|0;C=m+(s*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=w+6|0;C=m+(v*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=y+6|0;C=m+(x*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=A+6|0;C=m+(z*3|0)|0;b[C>>0]=b[B>>0]|0;b[C+1>>0]=b[B+1>>0]|0;b[C+2>>0]=b[B+2>>0]|0;B=u+9|0;u=q+(s*3|0)|0;b[u>>0]=b[B>>0]|0;b[u+1>>0]=b[B+1>>0]|0;b[u+2>>0]=b[B+2>>0]|0;B=w+9|0;w=q+(v*3|0)|0;b[w>>0]=b[B>>0]|0;b[w+1>>0]=b[B+1>>0]|0;b[w+2>>0]=b[B+2>>0]|0;B=y+9|0;y=q+(x*3|0)|0;b[y>>0]=b[B>>0]|0;b[y+1>>0]=b[B+1>>0]|0;b[y+2>>0]=b[B+2>>0]|0;B=A+9|0;A=q+(z*3|0)|0;b[A>>0]=b[B>>0]|0;b[A+1>>0]=b[B+1>>0]|0;b[A+2>>0]=b[B+2>>0]|0;s=s+4|0}while((s|0)<=(k|0));if(r){s=l;do{B=t+(Y(s,c)|0)|0;A=o+(s*3|0)|0;b[A>>0]=b[B>>0]|0;b[A+1>>0]=b[B+1>>0]|0;b[A+2>>0]=b[B+2>>0]|0;A=B+3|0;z=n+(s*3|0)|0;b[z>>0]=b[A>>0]|0;b[z+1>>0]=b[A+1>>0]|0;b[z+2>>0]=b[A+2>>0]|0;A=B+6|0;z=m+(s*3|0)|0;b[z>>0]=b[A>>0]|0;b[z+1>>0]=b[A+1>>0]|0;b[z+2>>0]=b[A+2>>0]|0;A=B+9|0;B=q+(s*3|0)|0;b[B>>0]=b[A>>0]|0;b[B+1>>0]=b[A+1>>0]|0;b[B+2>>0]=b[A+2>>0]|0;s=s+1|0}while((s|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)D=j;else return;do{p=d+(Y(D,e)|0)|0;l=a+(D*3|0)|0;r=0;do{k=l+(Y(r,c)|0)|0;s=p+(r*3|0)|0;b[s>>0]=b[k>>0]|0;b[s+1>>0]=b[k+1>>0]|0;b[s+2>>0]=b[k+2>>0]|0;r=r+1|0}while((r|0)!=(i|0));D=D+1|0}while((D|0)!=(h|0));return}D=i&-4;if((D|0)<(i|0))E=j;else{r=j;do{j=d+(Y(r,e)|0)|0;p=a+(r*3|0)|0;l=0;do{k=p+(Y(l,c)|0)|0;s=l|1;q=p+(Y(s,c)|0)|0;m=l|2;n=p+(Y(m,c)|0)|0;o=l|3;t=p+(Y(o,c)|0)|0;A=j+(l*3|0)|0;b[A>>0]=b[k>>0]|0;b[A+1>>0]=b[k+1>>0]|0;b[A+2>>0]=b[k+2>>0]|0;k=j+(s*3|0)|0;b[k>>0]=b[q>>0]|0;b[k+1>>0]=b[q+1>>0]|0;b[k+2>>0]=b[q+2>>0]|0;q=j+(m*3|0)|0;b[q>>0]=b[n>>0]|0;b[q+1>>0]=b[n+1>>0]|0;b[q+2>>0]=b[n+2>>0]|0;n=j+(o*3|0)|0;b[n>>0]=b[t>>0]|0;b[n+1>>0]=b[t+1>>0]|0;b[n+2>>0]=b[t+2>>0]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=d+(Y(E,e)|0)|0;l=a+(E*3|0)|0;j=0;do{p=l+(Y(j,c)|0)|0;t=j|1;n=l+(Y(t,c)|0)|0;o=j|2;q=l+(Y(o,c)|0)|0;m=j|3;k=l+(Y(m,c)|0)|0;s=r+(j*3|0)|0;b[s>>0]=b[p>>0]|0;b[s+1>>0]=b[p+1>>0]|0;b[s+2>>0]=b[p+2>>0]|0;p=r+(t*3|0)|0;b[p>>0]=b[n>>0]|0;b[p+1>>0]=b[n+1>>0]|0;b[p+2>>0]=b[n+2>>0]|0;n=r+(o*3|0)|0;b[n>>0]=b[q>>0]|0;b[n+1>>0]=b[q+1>>0]|0;b[n+2>>0]=b[q+2>>0]|0;q=r+(m*3|0)|0;b[q>>0]=b[k>>0]|0;b[q+1>>0]=b[k+1>>0]|0;b[q+2>>0]=b[k+2>>0]|0;j=j+4|0}while((j|0)<=(g|0));F=D;do{j=l+(Y(F,c)|0)|0;k=r+(F*3|0)|0;b[k>>0]=b[j>>0]|0;b[k+1>>0]=b[j+1>>0]|0;b[k+2>>0]=b[j+2>>0]|0;F=F+1|0}while((F|0)!=(i|0));E=E+1|0}while((E|0)!=(h|0));return}function eM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<2)|0;q=0;do{r=p+(Y(q,b)|0)|0;f[l+(q<<2)>>2]=f[r>>2];f[m+(q<<2)>>2]=f[r+4>>2];f[n+(q<<2)>>2]=f[r+8>>2];f[o+(q<<2)>>2]=f[r+12>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;r=a+(o<<2)|0;s=0;do{t=r+(Y(s,b)|0)|0;u=s|1;v=r+(Y(u,b)|0)|0;w=s|2;x=r+(Y(w,b)|0)|0;y=s|3;z=r+(Y(y,b)|0)|0;f[n+(s<<2)>>2]=f[t>>2];f[n+(u<<2)>>2]=f[v>>2];f[n+(w<<2)>>2]=f[x>>2];f[n+(y<<2)>>2]=f[z>>2];f[m+(s<<2)>>2]=f[t+4>>2];f[m+(u<<2)>>2]=f[v+4>>2];f[m+(w<<2)>>2]=f[x+4>>2];f[m+(y<<2)>>2]=f[z+4>>2];f[l+(s<<2)>>2]=f[t+8>>2];f[l+(u<<2)>>2]=f[v+8>>2];f[l+(w<<2)>>2]=f[x+8>>2];f[l+(y<<2)>>2]=f[z+8>>2];f[p+(s<<2)>>2]=f[t+12>>2];f[p+(u<<2)>>2]=f[v+12>>2];f[p+(w<<2)>>2]=f[x+12>>2];f[p+(y<<2)>>2]=f[z+12>>2];s=s+4|0}while((s|0)<=(j|0));if(q){s=k;do{z=r+(Y(s,b)|0)|0;f[n+(s<<2)>>2]=f[z>>2];f[m+(s<<2)>>2]=f[z+4>>2];f[l+(s<<2)>>2]=f[z+8>>2];f[p+(s<<2)>>2]=f[z+12>>2];s=s+1|0}while((s|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)A=i;else return;do{o=c+(Y(A,d)|0)|0;k=a+(A<<2)|0;q=0;do{j=k+(Y(q,b)|0)|0;f[o+(q<<2)>>2]=f[j>>2];q=q+1|0}while((q|0)!=(h|0));A=A+1|0}while((A|0)!=(g|0));return}A=h&-4;if((A|0)<(h|0))B=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<2)|0;k=0;do{j=o+(Y(k,b)|0)|0;s=k|1;p=o+(Y(s,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;r=o+(Y(n,b)|0)|0;f[i+(k<<2)>>2]=f[j>>2];f[i+(s<<2)>>2]=f[p>>2];f[i+(l<<2)>>2]=f[m>>2];f[i+(n<<2)>>2]=f[r>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(B,d)|0)|0;k=a+(B<<2)|0;i=0;do{o=k+(Y(i,b)|0)|0;r=i|1;n=k+(Y(r,b)|0)|0;m=i|2;l=k+(Y(m,b)|0)|0;p=i|3;s=k+(Y(p,b)|0)|0;f[q+(i<<2)>>2]=f[o>>2];f[q+(r<<2)>>2]=f[n>>2];f[q+(m<<2)>>2]=f[l>>2];f[q+(p<<2)>>2]=f[s>>2];i=i+4|0}while((i|0)<=(e|0));C=A;do{i=k+(Y(C,b)|0)|0;f[q+(C<<2)>>2]=f[i>>2];C=C+1|0}while((C|0)!=(h|0));B=B+1|0}while((B|0)!=(g|0));return}function fM(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=h+-4|0;do if((h|0)<4)j=0;else{k=i+-4|0;if((i|0)<4){if((i|0)>0){l=0;do{m=c+(Y(l,e)|0)|0;n=c+(Y(l|1,e)|0)|0;o=c+(Y(l|2,e)|0)|0;p=c+(Y(l|3,e)|0)|0;q=a+(l*6|0)|0;r=0;do{s=q+(Y(r,b)|0)|0;t=m+(r*6|0)|0;d[t>>1]=d[s>>1]|0;d[t+2>>1]=d[s+2>>1]|0;d[t+4>>1]=d[s+4>>1]|0;t=s+6|0;u=n+(r*6|0)|0;d[u>>1]=d[t>>1]|0;d[u+2>>1]=d[t+2>>1]|0;d[u+4>>1]=d[t+4>>1]|0;t=s+12|0;u=o+(r*6|0)|0;d[u>>1]=d[t>>1]|0;d[u+2>>1]=d[t+2>>1]|0;d[u+4>>1]=d[t+4>>1]|0;t=s+18|0;s=p+(r*6|0)|0;d[s>>1]=d[t>>1]|0;d[s+2>>1]=d[t+2>>1]|0;d[s+4>>1]=d[t+4>>1]|0;r=r+1|0}while((r|0)!=(i|0));l=l+4|0}while((l|0)<=(g|0))}j=h&-4;break}l=i&-4;r=(l|0)<(i|0);p=0;do{o=c+(Y(p,e)|0)|0;n=c+(Y(p|1,e)|0)|0;m=c+(Y(p|2,e)|0)|0;q=c+(Y(p|3,e)|0)|0;t=a+(p*6|0)|0;s=0;do{u=t+(Y(s,b)|0)|0;v=s|1;w=t+(Y(v,b)|0)|0;x=s|2;y=t+(Y(x,b)|0)|0;z=s|3;A=t+(Y(z,b)|0)|0;B=o+(s*6|0)|0;d[B>>1]=d[u>>1]|0;d[B+2>>1]=d[u+2>>1]|0;d[B+4>>1]=d[u+4>>1]|0;B=o+(v*6|0)|0;d[B>>1]=d[w>>1]|0;d[B+2>>1]=d[w+2>>1]|0;d[B+4>>1]=d[w+4>>1]|0;B=o+(x*6|0)|0;d[B>>1]=d[y>>1]|0;d[B+2>>1]=d[y+2>>1]|0;d[B+4>>1]=d[y+4>>1]|0;B=o+(z*6|0)|0;d[B>>1]=d[A>>1]|0;d[B+2>>1]=d[A+2>>1]|0;d[B+4>>1]=d[A+4>>1]|0;B=u+6|0;C=n+(s*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=w+6|0;C=n+(v*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=y+6|0;C=n+(x*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=A+6|0;C=n+(z*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=u+12|0;C=m+(s*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=w+12|0;C=m+(v*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=y+12|0;C=m+(x*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=A+12|0;C=m+(z*6|0)|0;d[C>>1]=d[B>>1]|0;d[C+2>>1]=d[B+2>>1]|0;d[C+4>>1]=d[B+4>>1]|0;B=u+18|0;u=q+(s*6|0)|0;d[u>>1]=d[B>>1]|0;d[u+2>>1]=d[B+2>>1]|0;d[u+4>>1]=d[B+4>>1]|0;B=w+18|0;w=q+(v*6|0)|0;d[w>>1]=d[B>>1]|0;d[w+2>>1]=d[B+2>>1]|0;d[w+4>>1]=d[B+4>>1]|0;B=y+18|0;y=q+(x*6|0)|0;d[y>>1]=d[B>>1]|0;d[y+2>>1]=d[B+2>>1]|0;d[y+4>>1]=d[B+4>>1]|0;B=A+18|0;A=q+(z*6|0)|0;d[A>>1]=d[B>>1]|0;d[A+2>>1]=d[B+2>>1]|0;d[A+4>>1]=d[B+4>>1]|0;s=s+4|0}while((s|0)<=(k|0));if(r){s=l;do{B=t+(Y(s,b)|0)|0;A=o+(s*6|0)|0;d[A>>1]=d[B>>1]|0;d[A+2>>1]=d[B+2>>1]|0;d[A+4>>1]=d[B+4>>1]|0;A=B+6|0;z=n+(s*6|0)|0;d[z>>1]=d[A>>1]|0;d[z+2>>1]=d[A+2>>1]|0;d[z+4>>1]=d[A+4>>1]|0;A=B+12|0;z=m+(s*6|0)|0;d[z>>1]=d[A>>1]|0;d[z+2>>1]=d[A+2>>1]|0;d[z+4>>1]=d[A+4>>1]|0;A=B+18|0;B=q+(s*6|0)|0;d[B>>1]=d[A>>1]|0;d[B+2>>1]=d[A+2>>1]|0;d[B+4>>1]=d[A+4>>1]|0;s=s+1|0}while((s|0)!=(i|0))}p=p+4|0}while((p|0)<=(g|0));j=h&-4}while(0);if((j|0)>=(h|0))return;g=i+-4|0;if((i|0)<4){if((i|0)>0)D=j;else return;do{p=c+(Y(D,e)|0)|0;l=a+(D*6|0)|0;r=0;do{k=l+(Y(r,b)|0)|0;s=p+(r*6|0)|0;d[s>>1]=d[k>>1]|0;d[s+2>>1]=d[k+2>>1]|0;d[s+4>>1]=d[k+4>>1]|0;r=r+1|0}while((r|0)!=(i|0));D=D+1|0}while((D|0)!=(h|0));return}D=i&-4;if((D|0)<(i|0))E=j;else{r=j;do{j=c+(Y(r,e)|0)|0;p=a+(r*6|0)|0;l=0;do{k=p+(Y(l,b)|0)|0;s=l|1;q=p+(Y(s,b)|0)|0;m=l|2;n=p+(Y(m,b)|0)|0;o=l|3;t=p+(Y(o,b)|0)|0;A=j+(l*6|0)|0;d[A>>1]=d[k>>1]|0;d[A+2>>1]=d[k+2>>1]|0;d[A+4>>1]=d[k+4>>1]|0;k=j+(s*6|0)|0;d[k>>1]=d[q>>1]|0;d[k+2>>1]=d[q+2>>1]|0;d[k+4>>1]=d[q+4>>1]|0;q=j+(m*6|0)|0;d[q>>1]=d[n>>1]|0;d[q+2>>1]=d[n+2>>1]|0;d[q+4>>1]=d[n+4>>1]|0;n=j+(o*6|0)|0;d[n>>1]=d[t>>1]|0;d[n+2>>1]=d[t+2>>1]|0;d[n+4>>1]=d[t+4>>1]|0;l=l+4|0}while((l|0)<=(g|0));r=r+1|0}while((r|0)!=(h|0));return}do{r=c+(Y(E,e)|0)|0;l=a+(E*6|0)|0;j=0;do{p=l+(Y(j,b)|0)|0;t=j|1;n=l+(Y(t,b)|0)|0;o=j|2;q=l+(Y(o,b)|0)|0;m=j|3;k=l+(Y(m,b)|0)|0;s=r+(j*6|0)|0;d[s>>1]=d[p>>1]|0;d[s+2>>1]=d[p+2>>1]|0;d[s+4>>1]=d[p+4>>1]|0;p=r+(t*6|0)|0;d[p>>1]=d[n>>1]|0;d[p+2>>1]=d[n+2>>1]|0;d[p+4>>1]=d[n+4>>1]|0;n=r+(o*6|0)|0;d[n>>1]=d[q>>1]|0;d[n+2>>1]=d[q+2>>1]|0;d[n+4>>1]=d[q+4>>1]|0;q=r+(m*6|0)|0;d[q>>1]=d[k>>1]|0;d[q+2>>1]=d[k+2>>1]|0;d[q+4>>1]=d[k+4>>1]|0;j=j+4|0}while((j|0)<=(g|0));F=D;do{j=l+(Y(F,b)|0)|0;k=r+(F*6|0)|0;d[k>>1]=d[j>>1]|0;d[k+2>>1]=d[j+2>>1]|0;d[k+4>>1]=d[j+4>>1]|0;F=F+1|0}while((F|0)!=(i|0));E=E+1|0}while((E|0)!=(h|0));return}function gM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<3)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=r;t=f[s+4>>2]|0;u=l+(q<<3)|0;f[u>>2]=f[s>>2];f[u+4>>2]=t;t=r+8|0;u=f[t+4>>2]|0;s=m+(q<<3)|0;f[s>>2]=f[t>>2];f[s+4>>2]=u;u=r+16|0;s=f[u+4>>2]|0;t=n+(q<<3)|0;f[t>>2]=f[u>>2];f[t+4>>2]=s;s=r+24|0;r=f[s+4>>2]|0;t=o+(q<<3)|0;f[t>>2]=f[s>>2];f[t+4>>2]=r;q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;r=a+(o<<3)|0;t=0;do{s=r+(Y(t,b)|0)|0;u=t|1;v=r+(Y(u,b)|0)|0;w=t|2;x=r+(Y(w,b)|0)|0;y=t|3;z=r+(Y(y,b)|0)|0;A=s;B=f[A+4>>2]|0;C=n+(t<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=v;C=f[B+4>>2]|0;A=n+(u<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=x;A=f[C+4>>2]|0;B=n+(w<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=z;B=f[A+4>>2]|0;C=n+(y<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=s+8|0;C=f[B+4>>2]|0;A=m+(t<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=v+8|0;A=f[C+4>>2]|0;B=m+(u<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=x+8|0;B=f[A+4>>2]|0;C=m+(w<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=z+8|0;C=f[B+4>>2]|0;A=m+(y<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=s+16|0;A=f[C+4>>2]|0;B=l+(t<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=v+16|0;B=f[A+4>>2]|0;C=l+(u<<3)|0;f[C>>2]=f[A>>2];f[C+4>>2]=B;B=x+16|0;C=f[B+4>>2]|0;A=l+(w<<3)|0;f[A>>2]=f[B>>2];f[A+4>>2]=C;C=z+16|0;A=f[C+4>>2]|0;B=l+(y<<3)|0;f[B>>2]=f[C>>2];f[B+4>>2]=A;A=s+24|0;s=f[A+4>>2]|0;B=p+(t<<3)|0;f[B>>2]=f[A>>2];f[B+4>>2]=s;s=v+24|0;v=f[s+4>>2]|0;B=p+(u<<3)|0;f[B>>2]=f[s>>2];f[B+4>>2]=v;v=x+24|0;x=f[v+4>>2]|0;B=p+(w<<3)|0;f[B>>2]=f[v>>2];f[B+4>>2]=x;x=z+24|0;z=f[x+4>>2]|0;B=p+(y<<3)|0;f[B>>2]=f[x>>2];f[B+4>>2]=z;t=t+4|0}while((t|0)<=(j|0));if(q){t=k;do{z=r+(Y(t,b)|0)|0;B=z;x=f[B+4>>2]|0;y=n+(t<<3)|0;f[y>>2]=f[B>>2];f[y+4>>2]=x;x=z+8|0;y=f[x+4>>2]|0;B=m+(t<<3)|0;f[B>>2]=f[x>>2];f[B+4>>2]=y;y=z+16|0;B=f[y+4>>2]|0;x=l+(t<<3)|0;f[x>>2]=f[y>>2];f[x+4>>2]=B;B=z+24|0;z=f[B+4>>2]|0;x=p+(t<<3)|0;f[x>>2]=f[B>>2];f[x+4>>2]=z;t=t+1|0}while((t|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)D=i;else return;do{o=c+(Y(D,d)|0)|0;k=a+(D<<3)|0;q=0;do{j=k+(Y(q,b)|0)|0;t=f[j+4>>2]|0;p=o+(q<<3)|0;f[p>>2]=f[j>>2];f[p+4>>2]=t;q=q+1|0}while((q|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}D=h&-4;if((D|0)<(h|0))E=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<3)|0;k=0;do{t=k|1;p=o+(Y(t,b)|0)|0;j=k|2;l=o+(Y(j,b)|0)|0;m=k|3;n=o+(Y(m,b)|0)|0;r=o+(Y(k,b)|0)|0;z=f[r+4>>2]|0;x=i+(k<<3)|0;f[x>>2]=f[r>>2];f[x+4>>2]=z;z=p;p=f[z+4>>2]|0;x=i+(t<<3)|0;f[x>>2]=f[z>>2];f[x+4>>2]=p;p=l;l=f[p+4>>2]|0;x=i+(j<<3)|0;f[x>>2]=f[p>>2];f[x+4>>2]=l;l=n;n=f[l+4>>2]|0;x=i+(m<<3)|0;f[x>>2]=f[l>>2];f[x+4>>2]=n;k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(E,d)|0)|0;k=a+(E<<3)|0;i=0;do{o=i|1;n=k+(Y(o,b)|0)|0;x=i|2;l=k+(Y(x,b)|0)|0;m=i|3;p=k+(Y(m,b)|0)|0;j=k+(Y(i,b)|0)|0;z=f[j+4>>2]|0;t=q+(i<<3)|0;f[t>>2]=f[j>>2];f[t+4>>2]=z;z=n;n=f[z+4>>2]|0;t=q+(o<<3)|0;f[t>>2]=f[z>>2];f[t+4>>2]=n;n=l;l=f[n+4>>2]|0;t=q+(x<<3)|0;f[t>>2]=f[n>>2];f[t+4>>2]=l;l=p;p=f[l+4>>2]|0;t=q+(m<<3)|0;f[t>>2]=f[l>>2];f[t+4>>2]=p;i=i+4|0}while((i|0)<=(e|0));F=D;do{i=k+(Y(F,b)|0)|0;p=f[i+4>>2]|0;t=q+(F<<3)|0;f[t>>2]=f[i>>2];f[t+4>>2]=p;F=F+1|0}while((F|0)!=(h|0));E=E+1|0}while((E|0)!=(g|0));return}function hM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k*12|0)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q*12|0)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];s=r+12|0;t=m+(q*12|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];s=r+24|0;t=n+(q*12|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];s=r+36|0;r=o+(q*12|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o*12|0)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r*12|0)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];A=n+(u*12|0)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];A=n+(w*12|0)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];A=n+(y*12|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];A=t+12|0;B=m+(r*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=v+12|0;B=m+(u*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=x+12|0;B=m+(w*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=z+12|0;B=m+(y*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=t+24|0;B=l+(r*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=v+24|0;B=l+(u*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=x+24|0;B=l+(w*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=z+24|0;B=l+(y*12|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];A=t+36|0;t=p+(r*12|0)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];A=v+36|0;v=p+(u*12|0)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];A=x+36|0;x=p+(w*12|0)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];A=z+36|0;z=p+(y*12|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r*12|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];z=A+12|0;y=m+(r*12|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];z=A+24|0;y=l+(r*12|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];z=A+36|0;A=p+(r*12|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C*12|0)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q*12|0)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q*12|0)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k*12|0)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];j=i+(r*12|0)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];p=i+(l*12|0)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];m=i+(n*12|0)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D*12|0)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i*12|0)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];o=q+(s*12|0)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];m=q+(n*12|0)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];p=q+(l*12|0)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E*12|0)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function iM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<4)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q<<4)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];s=r+16|0;t=m+(q<<4)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];s=r+32|0;t=n+(q<<4)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];s=r+48|0;r=o+(q<<4)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o<<4)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r<<4)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];f[A+12>>2]=f[t+12>>2];A=n+(u<<4)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];f[A+12>>2]=f[v+12>>2];A=n+(w<<4)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];f[A+12>>2]=f[x+12>>2];A=n+(y<<4)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];A=t+16|0;B=m+(r<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=v+16|0;B=m+(u<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=x+16|0;B=m+(w<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=z+16|0;B=m+(y<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=t+32|0;B=l+(r<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=v+32|0;B=l+(u<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=x+32|0;B=l+(w<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=z+32|0;B=l+(y<<4)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];A=t+48|0;t=p+(r<<4)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];f[t+12>>2]=f[A+12>>2];A=v+48|0;v=p+(u<<4)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];f[v+12>>2]=f[A+12>>2];A=x+48|0;x=p+(w<<4)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];f[x+12>>2]=f[A+12>>2];A=z+48|0;z=p+(y<<4)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r<<4)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];z=A+16|0;y=m+(r<<4)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];z=A+32|0;y=l+(r<<4)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];z=A+48|0;A=p+(r<<4)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C<<4)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q<<4)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<4)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k<<4)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];f[z+12>>2]=f[j+12>>2];j=i+(r<<4)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];p=i+(l<<4)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];f[p+12>>2]=f[m+12>>2];m=i+(n<<4)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D<<4)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i<<4)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];o=q+(s<<4)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];m=q+(n<<4)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];p=q+(l<<4)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E<<4)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function jM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k*24|0)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q*24|0)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];s=r+24|0;t=m+(q*24|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];s=r+48|0;t=n+(q*24|0)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];s=r+72|0;r=o+(q*24|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o*24|0)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r*24|0)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];f[A+12>>2]=f[t+12>>2];f[A+16>>2]=f[t+16>>2];f[A+20>>2]=f[t+20>>2];A=n+(u*24|0)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];f[A+12>>2]=f[v+12>>2];f[A+16>>2]=f[v+16>>2];f[A+20>>2]=f[v+20>>2];A=n+(w*24|0)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];f[A+12>>2]=f[x+12>>2];f[A+16>>2]=f[x+16>>2];f[A+20>>2]=f[x+20>>2];A=n+(y*24|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];A=t+24|0;B=m+(r*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=v+24|0;B=m+(u*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=x+24|0;B=m+(w*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=z+24|0;B=m+(y*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=t+48|0;B=l+(r*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=v+48|0;B=l+(u*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=x+48|0;B=l+(w*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=z+48|0;B=l+(y*24|0)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];A=t+72|0;t=p+(r*24|0)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];f[t+12>>2]=f[A+12>>2];f[t+16>>2]=f[A+16>>2];f[t+20>>2]=f[A+20>>2];A=v+72|0;v=p+(u*24|0)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];f[v+12>>2]=f[A+12>>2];f[v+16>>2]=f[A+16>>2];f[v+20>>2]=f[A+20>>2];A=x+72|0;x=p+(w*24|0)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];f[x+12>>2]=f[A+12>>2];f[x+16>>2]=f[A+16>>2];f[x+20>>2]=f[A+20>>2];A=z+72|0;z=p+(y*24|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r*24|0)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];z=A+24|0;y=m+(r*24|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];z=A+48|0;y=l+(r*24|0)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];z=A+72|0;A=p+(r*24|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C*24|0)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q*24|0)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];f[r+16>>2]=f[j+16>>2];f[r+20>>2]=f[j+20>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q*24|0)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k*24|0)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];f[z+12>>2]=f[j+12>>2];f[z+16>>2]=f[j+16>>2];f[z+20>>2]=f[j+20>>2];j=i+(r*24|0)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];f[j+16>>2]=f[p+16>>2];f[j+20>>2]=f[p+20>>2];p=i+(l*24|0)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];f[p+12>>2]=f[m+12>>2];f[p+16>>2]=f[m+16>>2];f[p+20>>2]=f[m+20>>2];m=i+(n*24|0)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];f[m+16>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D*24|0)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i*24|0)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];f[r+16>>2]=f[o+16>>2];f[r+20>>2]=f[o+20>>2];o=q+(s*24|0)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];f[o+16>>2]=f[m+16>>2];f[o+20>>2]=f[m+20>>2];m=q+(n*24|0)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];f[m+16>>2]=f[p+16>>2];f[m+20>>2]=f[p+20>>2];p=q+(l*24|0)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];f[p+16>>2]=f[j+16>>2];f[p+20>>2]=f[j+20>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E*24|0)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function kM(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[e>>2]|0;h=f[e+4>>2]|0;e=g+-4|0;do if((g|0)<4)i=0;else{j=h+-4|0;if((h|0)<4){if((h|0)>0){k=0;do{l=c+(Y(k,d)|0)|0;m=c+(Y(k|1,d)|0)|0;n=c+(Y(k|2,d)|0)|0;o=c+(Y(k|3,d)|0)|0;p=a+(k<<5)|0;q=0;do{r=p+(Y(q,b)|0)|0;s=l+(q<<5)|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];f[s+8>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];s=r+32|0;t=m+(q<<5)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];s=r+64|0;t=n+(q<<5)|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];s=r+96|0;r=o+(q<<5)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2];f[r+24>>2]=f[s+24>>2];f[r+28>>2]=f[s+28>>2];q=q+1|0}while((q|0)!=(h|0));k=k+4|0}while((k|0)<=(e|0))}i=g&-4;break}k=h&-4;q=(k|0)<(h|0);o=0;do{n=c+(Y(o,d)|0)|0;m=c+(Y(o|1,d)|0)|0;l=c+(Y(o|2,d)|0)|0;p=c+(Y(o|3,d)|0)|0;s=a+(o<<5)|0;r=0;do{t=s+(Y(r,b)|0)|0;u=r|1;v=s+(Y(u,b)|0)|0;w=r|2;x=s+(Y(w,b)|0)|0;y=r|3;z=s+(Y(y,b)|0)|0;A=n+(r<<5)|0;f[A>>2]=f[t>>2];f[A+4>>2]=f[t+4>>2];f[A+8>>2]=f[t+8>>2];f[A+12>>2]=f[t+12>>2];f[A+16>>2]=f[t+16>>2];f[A+20>>2]=f[t+20>>2];f[A+24>>2]=f[t+24>>2];f[A+28>>2]=f[t+28>>2];A=n+(u<<5)|0;f[A>>2]=f[v>>2];f[A+4>>2]=f[v+4>>2];f[A+8>>2]=f[v+8>>2];f[A+12>>2]=f[v+12>>2];f[A+16>>2]=f[v+16>>2];f[A+20>>2]=f[v+20>>2];f[A+24>>2]=f[v+24>>2];f[A+28>>2]=f[v+28>>2];A=n+(w<<5)|0;f[A>>2]=f[x>>2];f[A+4>>2]=f[x+4>>2];f[A+8>>2]=f[x+8>>2];f[A+12>>2]=f[x+12>>2];f[A+16>>2]=f[x+16>>2];f[A+20>>2]=f[x+20>>2];f[A+24>>2]=f[x+24>>2];f[A+28>>2]=f[x+28>>2];A=n+(y<<5)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];f[A+24>>2]=f[z+24>>2];f[A+28>>2]=f[z+28>>2];A=t+32|0;B=m+(r<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=v+32|0;B=m+(u<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=x+32|0;B=m+(w<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=z+32|0;B=m+(y<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=t+64|0;B=l+(r<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=v+64|0;B=l+(u<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=x+64|0;B=l+(w<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=z+64|0;B=l+(y<<5)|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];f[B+8>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];A=t+96|0;t=p+(r<<5)|0;f[t>>2]=f[A>>2];f[t+4>>2]=f[A+4>>2];f[t+8>>2]=f[A+8>>2];f[t+12>>2]=f[A+12>>2];f[t+16>>2]=f[A+16>>2];f[t+20>>2]=f[A+20>>2];f[t+24>>2]=f[A+24>>2];f[t+28>>2]=f[A+28>>2];A=v+96|0;v=p+(u<<5)|0;f[v>>2]=f[A>>2];f[v+4>>2]=f[A+4>>2];f[v+8>>2]=f[A+8>>2];f[v+12>>2]=f[A+12>>2];f[v+16>>2]=f[A+16>>2];f[v+20>>2]=f[A+20>>2];f[v+24>>2]=f[A+24>>2];f[v+28>>2]=f[A+28>>2];A=x+96|0;x=p+(w<<5)|0;f[x>>2]=f[A>>2];f[x+4>>2]=f[A+4>>2];f[x+8>>2]=f[A+8>>2];f[x+12>>2]=f[A+12>>2];f[x+16>>2]=f[A+16>>2];f[x+20>>2]=f[A+20>>2];f[x+24>>2]=f[A+24>>2];f[x+28>>2]=f[A+28>>2];A=z+96|0;z=p+(y<<5)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];f[z+24>>2]=f[A+24>>2];f[z+28>>2]=f[A+28>>2];r=r+4|0}while((r|0)<=(j|0));if(q){r=k;do{A=s+(Y(r,b)|0)|0;z=n+(r<<5)|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2];f[z+8>>2]=f[A+8>>2];f[z+12>>2]=f[A+12>>2];f[z+16>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];f[z+24>>2]=f[A+24>>2];f[z+28>>2]=f[A+28>>2];z=A+32|0;y=m+(r<<5)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];f[y+24>>2]=f[z+24>>2];f[y+28>>2]=f[z+28>>2];z=A+64|0;y=l+(r<<5)|0;f[y>>2]=f[z>>2];f[y+4>>2]=f[z+4>>2];f[y+8>>2]=f[z+8>>2];f[y+12>>2]=f[z+12>>2];f[y+16>>2]=f[z+16>>2];f[y+20>>2]=f[z+20>>2];f[y+24>>2]=f[z+24>>2];f[y+28>>2]=f[z+28>>2];z=A+96|0;A=p+(r<<5)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];f[A+8>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];f[A+24>>2]=f[z+24>>2];f[A+28>>2]=f[z+28>>2];r=r+1|0}while((r|0)!=(h|0))}o=o+4|0}while((o|0)<=(e|0));i=g&-4}while(0);if((i|0)>=(g|0))return;e=h+-4|0;if((h|0)<4){if((h|0)>0)C=i;else return;do{o=c+(Y(C,d)|0)|0;k=a+(C<<5)|0;q=0;do{j=k+(Y(q,b)|0)|0;r=o+(q<<5)|0;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];f[r+16>>2]=f[j+16>>2];f[r+20>>2]=f[j+20>>2];f[r+24>>2]=f[j+24>>2];f[r+28>>2]=f[j+28>>2];q=q+1|0}while((q|0)!=(h|0));C=C+1|0}while((C|0)!=(g|0));return}C=h&-4;if((C|0)<(h|0))D=i;else{q=i;do{i=c+(Y(q,d)|0)|0;o=a+(q<<5)|0;k=0;do{j=o+(Y(k,b)|0)|0;r=k|1;p=o+(Y(r,b)|0)|0;l=k|2;m=o+(Y(l,b)|0)|0;n=k|3;s=o+(Y(n,b)|0)|0;z=i+(k<<5)|0;f[z>>2]=f[j>>2];f[z+4>>2]=f[j+4>>2];f[z+8>>2]=f[j+8>>2];f[z+12>>2]=f[j+12>>2];f[z+16>>2]=f[j+16>>2];f[z+20>>2]=f[j+20>>2];f[z+24>>2]=f[j+24>>2];f[z+28>>2]=f[j+28>>2];j=i+(r<<5)|0;f[j>>2]=f[p>>2];f[j+4>>2]=f[p+4>>2];f[j+8>>2]=f[p+8>>2];f[j+12>>2]=f[p+12>>2];f[j+16>>2]=f[p+16>>2];f[j+20>>2]=f[p+20>>2];f[j+24>>2]=f[p+24>>2];f[j+28>>2]=f[p+28>>2];p=i+(l<<5)|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];f[p+8>>2]=f[m+8>>2];f[p+12>>2]=f[m+12>>2];f[p+16>>2]=f[m+16>>2];f[p+20>>2]=f[m+20>>2];f[p+24>>2]=f[m+24>>2];f[p+28>>2]=f[m+28>>2];m=i+(n<<5)|0;f[m>>2]=f[s>>2];f[m+4>>2]=f[s+4>>2];f[m+8>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];f[m+16>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];f[m+24>>2]=f[s+24>>2];f[m+28>>2]=f[s+28>>2];k=k+4|0}while((k|0)<=(e|0));q=q+1|0}while((q|0)!=(g|0));return}do{q=c+(Y(D,d)|0)|0;k=a+(D<<5)|0;i=0;do{o=k+(Y(i,b)|0)|0;s=i|1;m=k+(Y(s,b)|0)|0;n=i|2;p=k+(Y(n,b)|0)|0;l=i|3;j=k+(Y(l,b)|0)|0;r=q+(i<<5)|0;f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];f[r+12>>2]=f[o+12>>2];f[r+16>>2]=f[o+16>>2];f[r+20>>2]=f[o+20>>2];f[r+24>>2]=f[o+24>>2];f[r+28>>2]=f[o+28>>2];o=q+(s<<5)|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];f[o+8>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];f[o+16>>2]=f[m+16>>2];f[o+20>>2]=f[m+20>>2];f[o+24>>2]=f[m+24>>2];f[o+28>>2]=f[m+28>>2];m=q+(n<<5)|0;f[m>>2]=f[p>>2];f[m+4>>2]=f[p+4>>2];f[m+8>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];f[m+16>>2]=f[p+16>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];p=q+(l<<5)|0;f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];f[p+16>>2]=f[j+16>>2];f[p+20>>2]=f[j+20>>2];f[p+24>>2]=f[j+24>>2];f[p+28>>2]=f[j+28>>2];i=i+4|0}while((i|0)<=(e|0));E=C;do{i=k+(Y(E,b)|0)|0;j=q+(E<<5)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];f[j+16>>2]=f[i+16>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];E=E+1|0}while((E|0)!=(h|0));D=D+1|0}while((D|0)!=(g|0));return}function lM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;if((d|0)>0)e=0;else return;do{f=a+(Y(e,c)|0)|0;g=a+e|0;e=e+1|0;if((e|0)<(d|0)){h=e;do{i=f+h|0;j=g+(Y(h,c)|0)|0;k=b[i>>0]|0;b[i>>0]=b[j>>0]|0;b[j>>0]=k;h=h+1|0}while((h|0)!=(d|0))}}while((e|0)!=(d|0));return}function mM(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;if((c|0)>0)e=0;else return;do{f=a+(Y(e,b)|0)|0;g=a+(e<<1)|0;e=e+1|0;if((e|0)<(c|0)){h=e;do{i=f+(h<<1)|0;j=g+(Y(h,b)|0)|0;k=d[i>>1]|0;d[i>>1]=d[j>>1]|0;d[j>>1]=k;h=h+1|0}while((h|0)!=(c|0))}}while((e|0)!=(c|0));return}function nM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((d|0)>0)e=0;else return;do{f=a+(Y(e,c)|0)|0;g=a+(e*3|0)|0;e=e+1|0;if((e|0)<(d|0)){h=e;do{i=g+(Y(h,c)|0)|0;j=f+(h*3|0)|0;k=b[j>>0]|0;l=b[f+(h*3|0)+1>>0]|0;m=b[f+(h*3|0)+2>>0]|0;b[j>>0]=b[i>>0]|0;b[j+1>>0]=b[i+1>>0]|0;b[j+2>>0]=b[i+2>>0]|0;b[i>>0]=k;b[i+1>>0]=l;b[i+2>>0]=m;h=h+1|0}while((h|0)!=(d|0))}}while((e|0)!=(d|0));return}function oM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<2)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<2)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=k;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function pM(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((c|0)>0)e=0;else return;do{f=a+(Y(e,b)|0)|0;g=a+(e*6|0)|0;e=e+1|0;if((e|0)<(c|0)){h=e;do{i=f+(h*6|0)|0;j=g+(Y(h,b)|0)|0;k=d[i>>1]|0;l=d[f+(h*6|0)+2>>1]|0;m=d[f+(h*6|0)+4>>1]|0;d[i>>1]=d[j>>1]|0;d[i+2>>1]=d[j+2>>1]|0;d[i+4>>1]=d[j+4>>1]|0;d[j>>1]=k;d[j+2>>1]=l;d[j+4>>1]=m;h=h+1|0}while((h|0)!=(c|0))}}while((e|0)!=(c|0));return}function qM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<3)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<3)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h<<3)+4>>2]|0;m=j;n=f[m+4>>2]|0;o=i;f[o>>2]=f[m>>2];f[o+4>>2]=n;n=j;f[n>>2]=k;f[n+4>>2]=l;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function rM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d*12|0)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h*12|0)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h*12|0)+4>>2]|0;m=f[e+(h*12|0)+8>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function sM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<4)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<4)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h<<4)+4>>2]|0;m=f[e+(h<<4)+8>>2]|0;n=f[e+(h<<4)+12>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;f[j+12>>2]=n;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function tM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d*24|0)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h*24|0)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h*24|0)+4>>2]|0;m=f[e+(h*24|0)+8>>2]|0;n=f[e+(h*24|0)+12>>2]|0;o=f[e+(h*24|0)+16>>2]|0;p=f[e+(h*24|0)+20>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[i+16>>2]=f[j+16>>2];f[i+20>>2]=f[j+20>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;f[j+12>>2]=n;f[j+16>>2]=o;f[j+20>>2]=p;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function uM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((c|0)>0)d=0;else return;do{e=a+(Y(d,b)|0)|0;g=a+(d<<5)|0;d=d+1|0;if((d|0)<(c|0)){h=d;do{i=e+(h<<5)|0;j=g+(Y(h,b)|0)|0;k=f[i>>2]|0;l=f[e+(h<<5)+4>>2]|0;m=f[e+(h<<5)+8>>2]|0;n=f[e+(h<<5)+12>>2]|0;o=f[e+(h<<5)+16>>2]|0;p=f[e+(h<<5)+20>>2]|0;q=f[e+(h<<5)+24>>2]|0;r=f[e+(h<<5)+28>>2]|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[i+16>>2]=f[j+16>>2];f[i+20>>2]=f[j+20>>2];f[i+24>>2]=f[j+24>>2];f[i+28>>2]=f[j+28>>2];f[j>>2]=k;f[j+4>>2]=l;f[j+8>>2]=m;f[j+12>>2]=n;f[j+16>>2]=o;f[j+20>>2]=p;f[j+24>>2]=q;f[j+28>>2]=r;h=h+1|0}while((h|0)!=(c|0))}}while((d|0)!=(c|0));return}function vM(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;l=k&2031616;m=(e|0)<0;do if(m&(l|0)==65536){if((h|0)==0&(g^1)){if((k&1073741824|0)!=0?(n=f[(f[a+4>>2]|0)+40>>2]|0,!((f[c>>2]|0)==(f[n+4>>2]|0)?(f[c+4>>2]|0)==(f[n>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=aD(j,53)|0;p=182897;q=o+53|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,j,440241,179056,2385);bD(j);r=f[a>>2]|0}else r=k;n=a+4|0;if((r|0)<0?(f[f[n>>2]>>2]&4095|0)!=(d|0):0){f[j>>2]=0;f[j+4>>2]=0;o=aD(j,44)|0;p=182352;q=o+44|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,j,440241,179056,2386);bD(j)}s=f[n>>2]|0;t=f[c>>2]|0;v=f[c+4>>2]|0;w=d&4095;if(((((f[s+4>>2]|0)<3?(f[s+8>>2]|0)==(v|0):0)?(f[s+12>>2]|0)==(t|0):0)?(f[s>>2]&4095|0)==(w|0):0)?f[s+16>>2]|0:0){u=i;return}f[j>>2]=v;f[j+4>>2]=t;hL(s,2,j,w);u=i;return}}else{if(m&(l|0)==655360){if(!((h|0)==0&(g^1)))break;if((k&1073741824|0)!=0?(w=f[(f[a+4>>2]|0)+32>>2]|0,!((f[c>>2]|0)==(f[w+4>>2]|0)?(f[c+4>>2]|0)==(f[w>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=aD(j,54)|0;p=182951;q=o+54|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,j,440241,179056,2392);bD(j);x=f[a>>2]|0}else x=k;n=a+4|0;if((x|0)<0?(f[f[n>>2]>>2]&4095|0)!=(d|0):0){f[j>>2]=0;f[j+4>>2]=0;o=aD(j,45)|0;p=182467;q=o+45|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,j,440241,179056,2393);bD(j)}w=f[n>>2]|0;s=f[c>>2]|0;t=f[c+4>>2]|0;v=d&4095;if(((((f[w+4>>2]|0)<3?(f[w+8>>2]|0)==(t|0):0)?(f[w+12>>2]|0)==(s|0):0)?(f[w>>2]&4095|0)==(v|0):0)?f[w+24>>2]|0:0){u=i;return}f[j>>2]=t;f[j+4>>2]=s;eI(w,2,j,v,0);u=i;return}if(m&(l|0)==589824){if(!((h|0)==0&(g^1)))break;if((k&1073741824|0)!=0?(v=f[a+4>>2]|0,!((f[c>>2]|0)==(f[v+8>>2]|0)?(f[c+4>>2]|0)==(f[v+4>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=aD(j,51)|0;p=183006;q=o+51|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,j,440241,179056,2399);bD(j);y=f[a>>2]|0}else y=k;n=a+4|0;if((y|0)<0?(f[f[n>>2]>>2]&4095|0)!=(d|0):0){f[j>>2]=0;f[j+4>>2]=0;o=aD(j,53)|0;p=182580;q=o+53|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,j,440241,179056,2400);bD(j)}kT(f[n>>2]|0,f[c+4>>2]|0,f[c>>2]|0,d);u=i;return}if(m&(l|0)==458752){if(!((h|0)==0&(g^1)))break;if((k&1073741824|0)!=0?(v=f[a+4>>2]|0,!((f[c>>2]|0)==(f[v+12>>2]|0)?(f[c+4>>2]|0)==(f[v+8>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=aD(j,50)|0;p=183058;q=o+50|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,j,440241,179056,2406);bD(j);z=f[a>>2]|0}else z=k;n=a+4|0;if((z|0)<0?(f[(f[n>>2]|0)+16>>2]|0)!=(d|0):0){f[j>>2]=0;f[j+4>>2]=0;o=aD(j,52)|0;p=182700;q=o+52|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,j,440241,179056,2407);bD(j)}XS(f[n>>2]|0,f[c+4>>2]|0,f[c>>2]|0,d,34962,0);u=i;return}if(m&(l|0)==524288?(h|0)==0&(g^1):0){if((k&1073741824|0)!=0?(v=f[a+4>>2]|0,!((f[c>>2]|0)==(f[v+8>>2]|0)?(f[c+4>>2]|0)==(f[v+4>>2]|0):0)):0){f[j>>2]=0;f[j+4>>2]=0;o=aD(j,52)|0;p=183109;q=o+52|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,j,440241,179056,2413);bD(j);A=f[a>>2]|0}else A=k;n=a+4|0;if((A|0)<0?(f[f[n>>2]>>2]&4095|0)!=(d|0):0){f[j>>2]=0;f[j+4>>2]=0;o=aD(j,54)|0;p=182821;q=o+54|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,j,440241,179056,2414);bD(j)}bQ(f[n>>2]|0,f[c+4>>2]|0,f[c>>2]|0,d);u=i;return}}while(0);f[j>>2]=f[c+4>>2];f[j+4>>2]=f[c>>2];wL(a,2,j,d,e,g,h);u=i;return}function wM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;if(!(f[a+16>>2]|0)){e=-1;return e|0}g=f[a>>2]|0;if(!((c|0)<1|(g&7|0)==(c|0))){e=-1;return e|0}c=g&16384;if(!((c|0)!=0|d^1)){e=-1;return e|0}d=f[a+4>>2]|0;switch(d|0){case 2:{if((f[a+8>>2]|0)!=1?(h=f[a+12>>2]|0,(h|0)!=1):0){i=h;j=9}else j=7;if((j|0)==7?((g>>>3&511)+1|0)!=(b|0):0){i=f[a+12>>2]|0;j=9}if((j|0)==9?!((i|0)==(b|0)&(g&4088|0)==0):0){e=-1;return e|0}k=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;break}case 3:{if(g&4088|0){e=-1;return e|0}i=f[a+40>>2]|0;if((f[i+8>>2]|0)!=(b|0)){e=-1;return e|0}if((f[i>>2]|0)!=1?(f[i+4>>2]|0)!=1:0){e=-1;return e|0}if((c|0)==0?(c=f[a+44>>2]|0,(f[c+4>>2]|0)!=(Y(f[c+8>>2]|0,b)|0)):0){e=-1;return e|0}c=f[a+40>>2]|0;a=0;i=1;while(1){j=Y(f[c+(a<<2)>>2]|0,i)|0;a=a+1|0;if((a|0)==(d|0)){k=j;break}else i=j}break}default:{e=-1;return e|0}}e=((Y((g>>>3&511)+1|0,k)|0)>>>0)/(b>>>0)|0;return e|0}function xM(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+8|0;j=h;dQ(i,42696);k=(e>>>3&511)+1|0;if(k>>>0>=5){f[j>>2]=0;f[j+4>>2]=0;l=aD(j,7)|0;b[l>>0]=b[183211]|0;b[l+1>>0]=b[183212]|0;b[l+2>>0]=b[183213]|0;b[l+3>>0]=b[183214]|0;b[l+4>>0]=b[183215]|0;b[l+5>>0]=b[183216]|0;b[l+6>>0]=b[183217]|0;bO(-215,j,183219,179056,1168);bD(j)}switch(e&7){case 0:{e=0;do{l=MVb(+p[a+(e<<3)>>3])|0;b[c+e>>0]=l>>>0<256?l:(l|0)>0?255:0;e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{b[c+e>>0]=b[c+(e-k)>>0]|0;e=e+1|0}while((e|0)!=(g|0))}break}case 1:{e=0;do{l=MVb(+p[a+(e<<3)>>3])|0;b[c+e>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{b[c+e>>0]=b[c+(e-k)>>0]|0;e=e+1|0}while((e|0)!=(g|0))}break}case 2:{e=0;do{l=MVb(+p[a+(e<<3)>>3])|0;d[c+(e<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{d[c+(e<<1)>>1]=d[c+(e-k<<1)>>1]|0;e=e+1|0}while((e|0)!=(g|0))}break}case 3:{e=0;do{l=MVb(+p[a+(e<<3)>>3])|0;d[c+(e<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{d[c+(e<<1)>>1]=d[c+(e-k<<1)>>1]|0;e=e+1|0}while((e|0)!=(g|0))}break}case 4:{e=0;do{l=MVb(+p[a+(e<<3)>>3])|0;f[c+(e<<2)>>2]=l;e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{f[c+(e<<2)>>2]=f[c+(e-k<<2)>>2];e=e+1|0}while((e|0)!=(g|0))}break}case 5:{e=0;do{n[c+(e<<2)>>2]=+p[a+(e<<3)>>3];e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{f[c+(e<<2)>>2]=f[c+(e-k<<2)>>2];e=e+1|0}while((e|0)!=(g|0))}break}case 6:{e=0;do{p[c+(e<<3)>>3]=+p[a+(e<<3)>>3];e=e+1|0}while((e|0)!=(k|0));if((k|0)<(g|0)){e=k;do{p[c+(e<<3)>>3]=+p[c+(e-k<<3)>>3];e=e+1|0}while((e|0)!=(g|0))}break}default:{f[j>>2]=0;f[j+4>>2]=0;bO(-210,j,183219,179056,1193);bD(j)}}if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function yM(a){a=a|0;return f[a>>2]&2031616|0}function zM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+128|0;g=e+120|0;h=e+112|0;i=e+56|0;j=e;k=f[c>>2]|0;l=k&50331648;m=k&2031616;a:do if((m|0)>=655360){if((m|0)<720896){switch(m|0){case 655360:break;default:break a}k=f[c+4>>2]|0;if((d|0)>=0){f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;jI(a,k,g,h);u=e;return}f[a>>2]=f[k>>2];n=a+4|0;o=k+4|0;f[n>>2]=f[o>>2];p=a+8|0;f[p>>2]=f[k+8>>2];f[a+12>>2]=f[k+12>>2];f[a+16>>2]=f[k+16>>2];f[a+20>>2]=f[k+20>>2];q=f[k+24>>2]|0;f[a+24>>2]=q;f[a+28>>2]=f[k+28>>2];f[a+32>>2]=p;p=a+40|0;r=a+36|0;f[r>>2]=p;f[a+44>>2]=0;f[p>>2]=0;if(q|0){p=q+8|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[k+36>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];u=e;return}else{f[n>>2]=0;gI(a,k);u=e;return}}switch(m|0){case 720896:break;default:break a}k=f[c+4>>2]|0;if((d|0)>-1?(n=f[k>>2]|0,(((f[k+4>>2]|0)-n|0)/48|0|0)>(d|0)):0)s=n;else{f[g>>2]=0;f[g+4>>2]=0;n=aD(g,27)|0;o=180680;p=n+27|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,g,183294,179056,1339);bD(g);s=f[k>>2]|0}o=s+(d*48|0)|0;f[a>>2]=f[o>>2];n=a+4|0;p=s+(d*48|0)+4|0;f[n>>2]=f[p>>2];r=a+8|0;f[r>>2]=f[s+(d*48|0)+8>>2];f[a+12>>2]=f[s+(d*48|0)+12>>2];f[a+16>>2]=f[s+(d*48|0)+16>>2];f[a+20>>2]=f[s+(d*48|0)+20>>2];q=f[s+(d*48|0)+24>>2]|0;f[a+24>>2]=q;f[a+28>>2]=f[s+(d*48|0)+28>>2];f[a+32>>2]=r;r=a+40|0;t=a+36|0;f[t>>2]=r;f[a+44>>2]=0;f[r>>2]=0;if(q|0){r=q+8|0;f[r>>2]=(f[r>>2]|0)+1}if((f[p>>2]|0)<3){p=f[s+(d*48|0)+36>>2]|0;r=f[t>>2]|0;f[r>>2]=f[p>>2];f[r+4>>2]=f[p+4>>2];u=e;return}else{f[n>>2]=0;gI(a,o);u=e;return}}else{switch(m|0){case 65536:break;default:break a}o=f[c+4>>2]|0;if((d|0)<0){cI(a,o,l,0);u=e;return}f[g>>2]=d;f[g+4>>2]=d+1;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;lL(i,o,g,h);cI(a,i,l,0);o=i+36|0;n=f[o>>2]|0;if((n|0?(p=n+12|0,n=f[p>>2]|0,f[p>>2]=n+-1,(n|0)==1):0)?(n=f[o>>2]|0,n|0):0){f[o>>2]=0;p=f[n+4>>2]|0;if(!p){r=f[i+32>>2]|0;if(!r)v=$K()|0;else v=r}else v=p;zh[f[(f[v>>2]|0)+24>>2]&2047](v,n)}f[o>>2]=0;o=i+16|0;n=i+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[n>>2]|0)>0){o=f[i+40>>2]|0;p=0;do{f[o+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[n>>2]|0))}n=f[i+44>>2]|0;if((n|0)==(i+48|0)){u=e;return}UC(n);u=e;return}while(0);xL(j,c,d);cI(a,j,l,0);l=j+36|0;a=f[l>>2]|0;if((a|0?(d=a+12|0,a=f[d>>2]|0,f[d>>2]=a+-1,(a|0)==1):0)?(a=f[l>>2]|0,a|0):0){f[l>>2]=0;d=f[a+4>>2]|0;if(!d){c=f[j+32>>2]|0;if(!c)w=$K()|0;else w=c}else w=d;zh[f[(f[w>>2]|0)+24>>2]&2047](w,a)}f[l>>2]=0;l=j+16|0;a=j+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[a>>2]|0)>0){l=f[j+40>>2]|0;w=0;do{f[l+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[a>>2]|0))}a=f[j+44>>2]|0;if((a|0)==(j+48|0)){u=e;return}UC(a);u=e;return}function AM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;d=u;u=u+240|0;e=d+184|0;g=d+128|0;h=d+64|0;i=d;j=d+120|0;k=d+56|0;l=f[a>>2]|0;m=l&50331648;do switch(l>>>16&31){case 1:{n=f[a+4>>2]|0;o=n+40|0;p=f[f[o>>2]>>2]|0;SL(c,p);if((p|0)<=0){u=d;return}q=n+4|0;r=n+12|0;s=n+16|0;t=n+44|0;v=e+36|0;w=e+16|0;x=e+4|0;y=e+40|0;z=e+44|0;A=e+48|0;B=e+32|0;C=e+8|0;D=e+20|0;E=e+52|0;F=0;do{G=f[q>>2]|0;if((G|0)==2)Qi(e,1,f[r>>2]|0,f[n>>2]&4095,(f[s>>2]|0)+(Y(f[f[t>>2]>>2]|0,F)|0)|0,0);else{H=G+-1|0;G=(f[o>>2]|0)+4|0;I=f[n>>2]&4095;J=f[t>>2]|0;K=(f[s>>2]|0)+(Y(f[J>>2]|0,F)|0)|0;L=J+4|0;M=x;N=M+36|0;do{f[M>>2]=0;M=M+4|0}while((M|0)<(N|0));f[y>>2]=C;f[z>>2]=A;f[E>>2]=0;f[A>>2]=0;f[e>>2]=I|1124007936;f[w>>2]=K;f[D>>2]=K;YK(e,H,G,L,1);ZK(e)}fL((f[c>>2]|0)+(F*56|0)|0,e)|0;J=f[v>>2]|0;if((J|0?(O=J+12|0,J=f[O>>2]|0,f[O>>2]=J+-1,(J|0)==1):0)?(J=f[v>>2]|0,J|0):0){f[v>>2]=0;O=f[J+4>>2]|0;if(!O){P=f[B>>2]|0;if(!P)Q=$K()|0;else Q=P}else Q=O;zh[f[(f[Q>>2]|0)+24>>2]&2047](Q,J)}f[v>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){J=f[y>>2]|0;O=0;do{f[J+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[x>>2]|0))}O=f[z>>2]|0;if((O|0)!=(A|0))UC(O);F=F+1|0}while((F|0)<(p|0));u=d;return}case 6:{zL(h,f[a+4>>2]|0);p=h+40|0;F=f[f[p>>2]>>2]|0;SL(c,F);if((F|0)>0){A=e+4|0;z=g+4|0;x=i+36|0;y=i+16|0;w=i+4|0;v=i+40|0;B=i+44|0;D=i+48|0;E=i+32|0;C=0;do{s=C;C=C+1|0;f[e>>2]=s;f[A>>2]=C;f[g>>2]=-2147483648;f[z>>2]=2147483647;lL(i,h,e,g);fL((f[c>>2]|0)+(s*56|0)|0,i)|0;s=f[x>>2]|0;if((s|0?(t=s+12|0,s=f[t>>2]|0,f[t>>2]=s+-1,(s|0)==1):0)?(s=f[x>>2]|0,s|0):0){f[x>>2]=0;t=f[s+4>>2]|0;if(!t){n=f[E>>2]|0;if(!n)R=$K()|0;else R=n}else R=t;zh[f[(f[R>>2]|0)+24>>2]&2047](R,s)}f[x>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[w>>2]|0)>0){s=f[v>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[w>>2]|0))}t=f[B>>2]|0;if((t|0)!=(D|0))UC(t)}while((C|0)<(F|0))}F=h+36|0;C=f[F>>2]|0;if((C|0?(D=C+12|0,C=f[D>>2]|0,f[D>>2]=C+-1,(C|0)==1):0)?(C=f[F>>2]|0,C|0):0){f[F>>2]=0;D=f[C+4>>2]|0;if(!D){B=f[h+32>>2]|0;if(!B)S=$K()|0;else S=B}else S=D;zh[f[(f[S>>2]|0)+24>>2]&2047](S,C)}f[F>>2]=0;F=h+16|0;C=h+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[C>>2]|0)>0){F=f[p>>2]|0;D=0;do{f[F+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[C>>2]|0))}C=f[h+44>>2]|0;if((C|0)!=(h+48|0))UC(C);u=d;return}case 2:case 14:{C=f[a+12>>2]|0;D=(l>>>3&511)+1<<(47696>>>(l<<1&14)&3);SL(c,C);if(!C){u=d;return}F=a+8|0;p=a+4|0;B=e+36|0;w=e+16|0;v=e+4|0;y=e+40|0;x=e+44|0;E=e+48|0;z=e+32|0;A=0;do{t=f[F>>2]|0;Qi(e,1,t,f[a>>2]&4095,(f[p>>2]|0)+(Y(Y(A,D)|0,t)|0)|0,0);fL((f[c>>2]|0)+(A*56|0)|0,e)|0;t=f[B>>2]|0;if((t|0?(s=t+12|0,t=f[s>>2]|0,f[s>>2]=t+-1,(t|0)==1):0)?(t=f[B>>2]|0,t|0):0){f[B>>2]=0;s=f[t+4>>2]|0;if(!s){n=f[z>>2]|0;if(!n)T=$K()|0;else T=n}else T=s;zh[f[(f[T>>2]|0)+24>>2]&2047](T,t)}f[B>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[v>>2]|0)>0){t=f[y>>2]|0;s=0;do{f[t+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[v>>2]|0))}s=f[x>>2]|0;if((s|0)!=(E|0))UC(s);A=A+1|0}while(A>>>0<C>>>0);u=d;return}case 3:{C=f[a+4>>2]|0;AL(j,a,-1);A=f[j>>2]|0;E=f[a>>2]|0;x=(E>>>3&511)+1|0;v=E&7;E=x<<(47696>>>(v<<1)&3);SL(c,A);if(!A){u=d;return}y=e+36|0;w=e+16|0;B=e+4|0;z=e+40|0;D=e+44|0;p=e+48|0;F=e+32|0;s=0;do{Qi(e,1,x,v,(f[C>>2]|0)+(Y(s,E)|0)|0,0);fL((f[c>>2]|0)+(s*56|0)|0,e)|0;t=f[y>>2]|0;if((t|0?(n=t+12|0,t=f[n>>2]|0,f[n>>2]=t+-1,(t|0)==1):0)?(t=f[y>>2]|0,t|0):0){f[y>>2]=0;n=f[t+4>>2]|0;if(!n){o=f[F>>2]|0;if(!o)U=$K()|0;else U=o}else U=n;zh[f[(f[U>>2]|0)+24>>2]&2047](U,t)}f[y>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[B>>2]|0)>0){t=f[z>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[B>>2]|0))}n=f[D>>2]|0;if((n|0)!=(p|0))UC(n);s=s+1|0}while(s>>>0<A>>>0);u=d;return}case 0:{A=f[c>>2]|0;s=c+4|0;p=f[s>>2]|0;if((p|0)==(A|0)){u=d;return}else V=p;do{f[s>>2]=V+-56;p=V+-20|0;D=f[p>>2]|0;if((D|0?(B=D+12|0,D=f[B>>2]|0,f[B>>2]=D+-1,(D|0)==1):0)?(D=f[p>>2]|0,D|0):0){f[p>>2]=0;B=f[D+4>>2]|0;if(!B){z=f[V+-24>>2]|0;if(!z)W=$K()|0;else W=z}else W=B;zh[f[(f[W>>2]|0)+24>>2]&2047](W,D)}f[p>>2]=0;p=V+-40|0;D=V+-52|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[D>>2]|0)>0){p=f[V+-16>>2]|0;B=0;do{f[p+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[D>>2]|0))}D=f[V+-12>>2]|0;if((D|0)!=(V+-8|0))UC(D);V=f[s>>2]|0}while((V|0)!=(A|0));u=d;return}case 4:{A=f[a+4>>2]|0;s=(f[A+4>>2]|0)-(f[A>>2]|0)|0;D=(s|0)/12|0;SL(c,D);if((s|0)<=0){u=d;return}s=l&4095|1124007936;B=g+4|0;p=g+8|0;z=k+4|0;w=g+12|0;y=g+16|0;F=g+20|0;E=g+24|0;C=g+28|0;v=g+40|0;x=g+48|0;n=g+44|0;t=g+52|0;o=e+4|0;r=(l>>>3&511)+1<<(47696>>>(l<<1&14)&3);q=g+36|0;O=g+32|0;J=0;do{L=f[A>>2]|0;AL(k,a,J);G=f[L+(J*12|0)>>2]|0;f[g>>2]=s;f[B>>2]=2;L=f[z>>2]|0;f[p>>2]=L;H=f[k>>2]|0;f[w>>2]=H;f[y>>2]=G;f[F>>2]=G;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[v>>2]=p;f[n>>2]=x;f[t>>2]=0;f[x>>2]=0;if((G|0)==0&(Y(H,L)|0)!=0){f[e>>2]=0;f[o>>2]=0;M=aD(e,26)|0;X=426262;N=M+26|0;do{b[M>>0]=b[X>>0]|0;M=M+1|0;X=X+1|0}while((M|0)<(N|0));bO(-215,e,426289,431198,533);bD(e);Z=f[w>>2]|0;_=f[g>>2]|0;$=f[n>>2]|0;aa=f[F>>2]|0}else{Z=H;_=s;$=x;aa=G}L=Y(Z,r)|0;f[g>>2]=_|16384;f[$>>2]=L;f[$+4>>2]=r;K=aa+(Y(f[p>>2]|0,L)|0)|0;f[C>>2]=K;f[E>>2]=K+(0-L)+L;fL((f[c>>2]|0)+(J*56|0)|0,g)|0;L=f[q>>2]|0;if((L|0?(K=L+12|0,L=f[K>>2]|0,f[K>>2]=L+-1,(L|0)==1):0)?(L=f[q>>2]|0,L|0):0){f[q>>2]=0;K=f[L+4>>2]|0;if(!K){I=f[O>>2]|0;if(!I)ba=$K()|0;else ba=I}else ba=K;zh[f[(f[ba>>2]|0)+24>>2]&2047](ba,L)}f[q>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[B>>2]|0)>0){L=f[v>>2]|0;K=0;do{f[L+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[B>>2]|0))}K=f[n>>2]|0;if((K|0)!=(x|0))UC(K);J=J+1|0}while((J|0)<(D|0));u=d;return}case 5:{D=f[a+4>>2]|0;J=(f[D+4>>2]|0)-(f[D>>2]|0)|0;x=(J|0)/56|0;SL(c,x);if(!J){u=d;return}J=0;do{fL((f[c>>2]|0)+(J*56|0)|0,(f[D>>2]|0)+(J*56|0)|0)|0;J=J+1|0}while(J>>>0<x>>>0);u=d;return}case 15:{x=f[a+4>>2]|0;J=f[a+12>>2]|0;SL(c,J);if(!J){u=d;return}D=0;do{fL((f[c>>2]|0)+(D*56|0)|0,x+(D*56|0)|0)|0;D=D+1|0}while((D|0)!=(J|0));u=d;return}case 11:{J=f[a+4>>2]|0;D=(f[J+4>>2]|0)-(f[J>>2]|0)|0;x=(D|0)/48|0;SL(c,x);if(!D){u=d;return}D=e+36|0;n=e+16|0;B=e+4|0;v=e+40|0;y=e+44|0;q=e+48|0;O=e+32|0;E=0;do{qI(e,(f[J>>2]|0)+(E*48|0)|0,m);fL((f[c>>2]|0)+(E*56|0)|0,e)|0;C=f[D>>2]|0;if((C|0?(p=C+12|0,C=f[p>>2]|0,f[p>>2]=C+-1,(C|0)==1):0)?(C=f[D>>2]|0,C|0):0){f[D>>2]=0;p=f[C+4>>2]|0;if(!p){r=f[O>>2]|0;if(!r)ca=$K()|0;else ca=r}else ca=p;zh[f[(f[ca>>2]|0)+24>>2]&2047](ca,C)}f[D>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[B>>2]|0)>0){C=f[v>>2]|0;p=0;do{f[C+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[B>>2]|0))}p=f[y>>2]|0;if((p|0)!=(q|0))UC(p);E=E+1|0}while(E>>>0<x>>>0);u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;M=aD(e,30)|0;X=180875;N=M+30|0;do{b[M>>0]=b[X>>0]|0;M=M+1|0;X=X+1|0}while((M|0)<(N|0));bO(-213,e,183302,179056,1460);bD(e);u=d;return}}while(0)}function BM(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;AL(d,a,b);u=c;return f[d+4>>2]|0}function CM(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;AL(d,a,b);u=c;return f[d>>2]|0}function DM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;e=f[b>>2]&2031616;g=f[a>>2]&2031616;a:do if((g|0)<655360){switch(g|0){case 65536:break;default:{h=36;break a}}i=f[a+4>>2]|0;j=e&2097151;b:do if((j|0)<655360){switch(j|0){case 65536:break;default:break b}k=f[i+40>>2]|0;l=f[k+-4>>2]|0;m=f[(f[b+4>>2]|0)+40>>2]|0;if((l|0)!=(f[m+-4>>2]|0)){n=0;break a}if((l|0)==2){if((f[k>>2]|0)!=(f[m>>2]|0)){n=0;break a}n=(f[k+4>>2]|0)==(f[m+4>>2]|0);break a}if((l|0)>0)o=0;else{n=1;break a}while(1){if((f[k+(o<<2)>>2]|0)!=(f[m+(o<<2)>>2]|0)){n=0;break a}o=o+1|0;if((o|0)>=(l|0)){n=1;break a}}}else{switch(j|0){case 655360:break;default:break b}l=f[i+40>>2]|0;m=f[l+-4>>2]|0;k=f[(f[b+4>>2]|0)+32>>2]|0;if((m|0)!=(f[k+-4>>2]|0)){n=0;break a}if((m|0)==2){if((f[l>>2]|0)!=(f[k>>2]|0)){n=0;break a}n=(f[l+4>>2]|0)==(f[k+4>>2]|0);break a}if((m|0)>0)p=0;else{n=1;break a}while(1){if((f[l+(p<<2)>>2]|0)!=(f[k+(p<<2)>>2]|0)){n=0;break a}p=p+1|0;if((p|0)>=(m|0)){n=1;break a}}}while(0);if((f[i+4>>2]|0)>2)n=0;else{j=f[i+40>>2]|0;q=f[j+4>>2]|0;r=f[j>>2]|0;h=37}}else{switch(g|0){case 655360:break;default:{h=36;break a}}j=f[a+4>>2]|0;m=e&2097151;c:do if((m|0)<655360){switch(m|0){case 65536:break;default:break c}k=f[j+32>>2]|0;l=f[k+-4>>2]|0;s=f[(f[b+4>>2]|0)+40>>2]|0;if((l|0)!=(f[s+-4>>2]|0)){n=0;break a}if((l|0)==2){if((f[k>>2]|0)!=(f[s>>2]|0)){n=0;break a}n=(f[k+4>>2]|0)==(f[s+4>>2]|0);break a}if((l|0)>0)t=0;else{n=1;break a}while(1){if((f[k+(t<<2)>>2]|0)!=(f[s+(t<<2)>>2]|0)){n=0;break a}t=t+1|0;if((t|0)>=(l|0)){n=1;break a}}}else{switch(m|0){case 655360:break;default:break c}l=f[j+32>>2]|0;s=f[l+-4>>2]|0;k=f[(f[b+4>>2]|0)+32>>2]|0;if((s|0)!=(f[k+-4>>2]|0)){n=0;break a}if((s|0)==2){if((f[l>>2]|0)!=(f[k>>2]|0)){n=0;break a}n=(f[l+4>>2]|0)==(f[k+4>>2]|0);break a}if((s|0)>0)v=0;else{n=1;break a}while(1){if((f[l+(v<<2)>>2]|0)!=(f[k+(v<<2)>>2]|0)){n=0;break a}v=v+1|0;if((v|0)>=(s|0)){n=1;break a}}}while(0);if((f[j+4>>2]|0)>2)n=0;else{m=f[j+32>>2]|0;q=f[m+4>>2]|0;r=f[m>>2]|0;h=37}}while(0);if((h|0)==36){AL(d,a,-1);q=f[d>>2]|0;r=f[d+4>>2]|0;h=37}if((h|0)==37)if((_L(b,-1)|0)>2)n=0;else{AL(d,b,-1);n=(f[d>>2]|0)==(q|0)?(f[d+4>>2]|0)==(r|0):0}u=c;return n|0}function EM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d+8|0;g=d;h=f[a>>2]&2031616;a:do if((h|0)>=655360){if((h|0)<720896){switch(h|0){case 655360:break;default:break a}if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;i=aD(e,5)|0;b[i>>0]=b[180637]|0;b[i+1>>0]=b[180638]|0;b[i+2>>0]=b[180639]|0;b[i+3>>0]=b[180640]|0;b[i+4>>0]=b[180641]|0;bO(-215,e,442657,179056,1921);bD(e)}i=f[a+4>>2]|0;j=f[i+4>>2]|0;if((j|0)<3){k=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;u=d;return k|0}l=f[i+32>>2]|0;i=0;m=1;while(1){n=Y(f[l+(i<<2)>>2]|0,m)|0;i=i+1|0;if((i|0)==(j|0)){k=n;break}else m=n}u=d;return k|0}if((h|0)<983040){switch(h|0){case 720896:break;default:break a}m=f[a+4>>2]|0;j=f[m>>2]|0;i=((f[m+4>>2]|0)-j|0)/48|0;if((c|0)<0){k=i;u=d;return k|0}if((i|0)>(c|0))o=j;else{f[e>>2]=0;f[e+4>>2]=0;p=aD(e,18)|0;q=180932;r=p+18|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,e,442657,179056,1951);bD(e);o=f[m>>2]|0}j=f[o+(c*48|0)+4>>2]|0;if((j|0)<3){k=Y(f[o+(c*48|0)+12>>2]|0,f[o+(c*48|0)+8>>2]|0)|0;u=d;return k|0}i=f[o+(c*48|0)+32>>2]|0;l=0;n=1;while(1){s=Y(f[i+(l<<2)>>2]|0,n)|0;l=l+1|0;if((l|0)==(j|0)){k=s;break}else n=s}u=d;return k|0}else{switch(h|0){case 983040:break;default:break a}n=f[a+4>>2]|0;j=f[a+12>>2]|0;if((c|0)<0){k=j;u=d;return k|0}if((j|0)<=(c|0)){f[e>>2]=0;f[e+4>>2]=0;p=aD(e,13)|0;q=180951;r=p+13|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,e,442657,179056,1941);bD(e)}j=f[n+(c*56|0)+4>>2]|0;if((j|0)<3){k=Y(f[n+(c*56|0)+12>>2]|0,f[n+(c*56|0)+8>>2]|0)|0;u=d;return k|0}l=f[n+(c*56|0)+40>>2]|0;i=0;m=1;while(1){s=Y(f[l+(i<<2)>>2]|0,m)|0;i=i+1|0;if((i|0)==(j|0)){k=s;break}else m=s}u=d;return k|0}}else{if((h|0)<327680){switch(h|0){case 65536:break;default:break a}if((c|0)>=0){f[e>>2]=0;f[e+4>>2]=0;m=aD(e,5)|0;b[m>>0]=b[180637]|0;b[m+1>>0]=b[180638]|0;b[m+2>>0]=b[180639]|0;b[m+3>>0]=b[180640]|0;b[m+4>>0]=b[180641]|0;bO(-215,e,442657,179056,1915);bD(e)}m=f[a+4>>2]|0;j=f[m+4>>2]|0;if((j|0)<3){k=Y(f[m+12>>2]|0,f[m+8>>2]|0)|0;u=d;return k|0}i=f[m+40>>2]|0;m=0;l=1;while(1){n=Y(f[i+(m<<2)>>2]|0,l)|0;m=m+1|0;if((m|0)==(j|0)){k=n;break}else l=n}u=d;return k|0}switch(h|0){case 327680:break;default:break a}l=f[a+4>>2]|0;j=f[l>>2]|0;m=((f[l+4>>2]|0)-j|0)/56|0;if((c|0)<0){k=m;u=d;return k|0}if((m|0)>(c|0))t=j;else{f[e>>2]=0;f[e+4>>2]=0;p=aD(e,18)|0;q=180932;r=p+18|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,e,442657,179056,1931);bD(e);t=f[l>>2]|0}j=f[t+(c*56|0)+4>>2]|0;if((j|0)<3){k=Y(f[t+(c*56|0)+12>>2]|0,f[t+(c*56|0)+8>>2]|0)|0;u=d;return k|0}m=f[t+(c*56|0)+40>>2]|0;i=0;n=1;while(1){s=Y(f[m+(i<<2)>>2]|0,n)|0;i=i+1|0;if((i|0)==(j|0)){k=s;break}else n=s}u=d;return k|0}while(0);AL(g,a,c);k=Y(f[g+4>>2]|0,f[g>>2]|0)|0;u=d;return k|0}function FM(a,b){a=a|0;b=b|0;return (BL(a,b)|0)&7|0}function GM(a,b){a=a|0;b=b|0;return ((BL(a,b)|0)>>>3&511)+1|0}function HM(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;do switch((f[a>>2]|0)>>>16&31){case 1:{e=f[a+4>>2]|0;if(!(f[e+16>>2]|0)){g=1;u=c;return g|0}h=f[e+4>>2]|0;if((h|0)<3)i=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{j=f[e+40>>2]|0;e=0;k=1;while(1){l=Y(f[j+(e<<2)>>2]|0,k)|0;e=e+1|0;if((e|0)==(h|0)){i=l;break}else k=l}}g=(h|0)==0|(i|0)==0;u=c;return g|0}case 10:{k=f[a+4>>2]|0;if(!(f[k+24>>2]|0)){g=1;u=c;return g|0}e=f[k+4>>2]|0;if((e|0)<3)m=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{j=f[k+32>>2]|0;k=0;l=1;while(1){n=Y(f[j+(k<<2)>>2]|0,l)|0;k=k+1|0;if((k|0)==(e|0)){m=n;break}else l=n}}g=(e|0)==0|(m|0)==0;u=c;return g|0}case 3:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 12:{g=(f[(f[a+4>>2]|0)+4>>2]|0)==0;u=c;return g|0}case 0:{g=1;u=c;return g|0}case 4:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 5:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 15:{g=(f[a+12>>2]|0)==0;u=c;return g|0}case 11:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 7:{l=f[a+4>>2]|0;if(!(f[l+8>>2]|0)){g=1;u=c;return g|0}g=(f[l+12>>2]|0)==0;u=c;return g|0}case 9:{g=(f[(f[a+4>>2]|0)+16>>2]|0)==0;u=c;return g|0}case 13:{l=f[a+4>>2]|0;g=(f[l>>2]|0)==(f[l+4>>2]|0);u=c;return g|0}case 8:{g=(f[(f[a+4>>2]|0)+16>>2]|0)==0;u=c;return g|0}case 2:case 14:case 6:{g=0;u=c;return g|0}default:{f[d>>2]=0;f[d+4>>2]=0;l=aD(d,30)|0;k=180875;j=l+30|0;do{b[l>>0]=b[k>>0]|0;l=l+1|0;k=k+1|0}while((l|0)<(j|0));bO(-213,d,183315,179056,2117);bD(d);g=1;u=c;return g|0}}while(0);return 0}function IM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;switch((f[a>>2]|0)>>>16&31){case 1:{if((c|0)>=0){g=1;u=d;return g|0}g=(f[f[a+4>>2]>>2]&16384|0)!=0;u=d;return g|0}case 10:{if((c|0)>=0){g=1;u=d;return g|0}g=(f[f[a+4>>2]>>2]&16384|0)!=0;u=d;return g|0}case 5:{h=f[a+4>>2]|0;i=f[h>>2]|0;if((((f[h+4>>2]|0)-i|0)/56|0)>>>0>c>>>0)j=i;else{f[e>>2]=0;f[e+4>>2]=0;k=aD(e,21)|0;l=183321;m=k+21|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,e,183343,179056,2138);bD(e);j=f[h>>2]|0}g=(f[j+(c*56|0)>>2]&16384|0)!=0;u=d;return g|0}case 15:{j=f[a+4>>2]|0;if(!((c|0)>0?(f[a+12>>2]|0)>(c|0):0)){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,22)|0;l=183356;m=k+22|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,e,183343,179056,2145);bD(e)}g=(f[j+(c*56|0)>>2]&16384|0)!=0;u=d;return g|0}case 11:{j=f[a+4>>2]|0;h=f[j>>2]|0;if((((f[j+4>>2]|0)-h|0)/48|0)>>>0>c>>>0)n=h;else{f[e>>2]=0;f[e+4>>2]=0;k=aD(e,21)|0;l=183321;m=k+21|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,e,183343,179056,2152);bD(e);n=f[j>>2]|0}g=(f[n+(c*48|0)>>2]&16384|0)!=0;u=d;return g|0}case 9:{if((c|0)>=0){g=1;u=d;return g|0}g=(f[f[a+4>>2]>>2]&16384|0)!=0;u=d;return g|0}case 0:case 2:case 3:case 4:case 6:case 12:case 14:{g=1;u=d;return g|0}default:{f[e>>2]=0;f[e+4>>2]=0;k=aD(e,30)|0;l=180875;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-213,e,183343,179056,2159);bD(e);g=0;u=d;return g|0}}return 0}function JM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+112|0;d=c+56|0;e=c;switch((f[a>>2]|0)>>>16&31){case 0:{$L(b);u=c;return}case 1:case 2:case 3:case 12:case 14:{xL(d,a,-1);SP(d,b);g=d+36|0;h=f[g>>2]|0;if((h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)?(h=f[g>>2]|0,h|0):0){f[g>>2]=0;i=f[h+4>>2]|0;if(!i){j=f[d+32>>2]|0;if(!j)k=$K()|0;else k=j}else k=i;zh[f[(f[k>>2]|0)+24>>2]&2047](k,h)}f[g>>2]=0;g=d+16|0;h=d+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){g=f[d+40>>2]|0;k=0;do{f[g+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[h>>2]|0))}h=f[d+44>>2]|0;if((h|0)!=(d+48|0))UC(h);u=c;return}case 6:{h=f[a+4>>2]|0;if((f[b>>2]&2031616|0)==65536){k=KM(b,-1)|0;g=f[h>>2]|0;th[f[(f[g>>2]|0)+12>>2]&511](g,h,k,-1);u=c;return}zL(e,h);SP(e,b);h=e+36|0;k=f[h>>2]|0;if((k|0?(g=k+12|0,k=f[g>>2]|0,f[g>>2]=k+-1,(k|0)==1):0)?(k=f[h>>2]|0,k|0):0){f[h>>2]=0;g=f[k+4>>2]|0;if(!g){i=f[e+32>>2]|0;if(!i)l=$K()|0;else l=i}else l=g;zh[f[(f[l>>2]|0)+24>>2]&2047](l,k)}f[h>>2]=0;h=e+16|0;k=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[k>>2]|0)>0){h=f[e+40>>2]|0;l=0;do{f[h+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[k>>2]|0))}k=f[e+44>>2]|0;if((k|0)==(e+48|0)){u=c;return}UC(k);u=c;return}case 10:{oI(f[a+4>>2]|0,b);u=c;return}default:{f[d>>2]=0;f[d+4>>2]=0;bO(-213,d,192311,179056,2350);bD(d);u=c;return}}}function KM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=f[a>>2]&2031616;if((c|0)<0){if((g|0)!=65536){f[e>>2]=0;f[e+4>>2]=0;h=aD(e,8)|0;i=h;b[i>>0]=107;b[i+1>>0]=32;b[i+2>>0]=61;b[i+3>>0]=61;i=h+4|0;b[i>>0]=32;b[i+1>>0]=77;b[i+2>>0]=65;b[i+3>>0]=84;bO(-215,e,183379,179056,2924);bD(e)}j=f[a+4>>2]|0;u=d;return j|0}i=(g|0)==327680;h=g&2097151;if((h|0)<983040)switch(h|0){case 327680:break;default:k=6}else switch(h|0){case 983040:break;default:k=6}if((k|0)==6){f[e>>2]=0;f[e+4>>2]=0;l=aD(e,41)|0;m=183389;n=l+41|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,e,183379,179056,2928);bD(e)}k=f[a+4>>2]|0;if(i){i=f[k>>2]|0;if((((f[k+4>>2]|0)-i|0)/56|0|0)>(c|0))o=i;else{f[e>>2]=0;f[e+4>>2]=0;l=aD(e,17)|0;m=181832;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,e,183379,179056,2933);bD(e);o=f[k>>2]|0}j=o+(c*56|0)|0;u=d;return j|0}else{if(!((c|0)>-1?(f[a+12>>2]|0)>(c|0):0)){f[e>>2]=0;f[e+4>>2]=0;l=aD(e,23)|0;m=180708;n=l+23|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,e,183379,179056,2939);bD(e)}j=k+(c*56|0)|0;u=d;return j|0}return 0}function LM(a){a=a|0;return (f[a>>2]&1073741824|0)!=0|0}function MM(a){a=a|0;return (f[a>>2]|0)<0|0}function NM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+144|0;e=d+128|0;g=d;h=f[b>>2]&2031616;a:do if((h|0)>=65536)if((h|0)<655360){switch(h|0){case 65536:break;default:{i=8;break a}}j=f[b+4>>2]|0;k=f[j+4>>2]|0;if((k|0)<=0){l=k;break}m=f[j+40>>2]|0;j=0;do{f[g+(j<<2)>>2]=f[m+(j<<2)>>2];j=j+1|0}while((j|0)!=(k|0));l=k}else{switch(h|0){case 655360:break;default:{i=8;break a}}k=f[b+4>>2]|0;j=f[k+4>>2]|0;if((j|0)<=0){l=j;break}m=f[k+32>>2]|0;k=0;do{f[g+(k<<2)>>2]=f[m+(k<<2)>>2];k=k+1|0}while((k|0)!=(j|0));l=j}else switch(h|0){case 0:{l=0;break}default:i=8}while(0);if((i|0)==8){AL(e,b,-1);f[g>>2]=f[e+4>>2];f[g+4>>2]=f[e>>2];l=2}wL(a,l,g,c,-1,0,0);u=d;return}function OM(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=f[a>>2]|0;if((e&2031616|0)!=65536){$L(a);u=c;return}if(e&1073741824|0){f[d>>2]=0;f[d+4>>2]=0;e=aD(d,12)|0;g=182876;h=e+12|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-215,d,368697,179056,2906);bD(d)}d=f[a+4>>2]|0;a=d+40|0;g=f[a>>2]|0;e=f[g>>2]|0;if(!e){u=c;return}if(!(f[d>>2]&32768)){h=d+44|0;if((f[d+16>>2]|0)>>>0>(f[d+28>>2]|0)>>>0){i=h;j=8}else{k=h;l=g}}else{i=d+44|0;j=8}if((j|0)==8){sL(d,0);k=i;l=f[a>>2]|0}a=f[k>>2]|0;f[l>>2]=0;l=Y(f[a>>2]|0,0-e|0)|0;e=d+24|0;f[e>>2]=(f[e>>2]|0)+l;u=c;return}function PM(a){a=a|0;return (f[a>>2]&2031616|0)!=0|0}function QM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0,t=0.0,v=0;e=u;u=u+112|0;g=e;h=e+56|0;switch((f[a>>2]|0)>>>16&31){case 1:case 2:case 3:case 14:{xL(g,a,-1);VP(g,c,d)|0;i=g+36|0;j=f[i>>2]|0;if((j|0?(k=j+12|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)?(j=f[i>>2]|0,j|0):0){f[i>>2]=0;k=f[j+4>>2]|0;if(!k){l=f[g+32>>2]|0;if(!l)m=$K()|0;else m=l}else m=k;zh[f[(f[m>>2]|0)+24>>2]&2047](m,j)}f[i>>2]=0;i=g+16|0;j=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[j>>2]|0)>0){i=f[g+40>>2]|0;m=0;do{f[i+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[j>>2]|0))}j=f[g+44>>2]|0;if((j|0)!=(g+48|0))UC(j);u=e;return}case 10:{nI(f[a+4>>2]|0,c,d)|0;u=e;return}case 9:{xL(h,c,-1);c=BL(a,-1)|0;j=h+4|0;if(((f[j>>2]|0)<=2?(m=f[h>>2]|0,(m&16384|0)!=0):0)?(i=f[h+40>>2]|0,k=f[i+4>>2]|0,l=f[i>>2]|0,i=(k|0)==1,n=(l|0)==1,i|n):0){o=(c>>>3&511)+1|0;if(!((o|0)==(k|0)&n|i&(n|(o|0)==(l|0)))?o>>>0>4|(m&4095|0)!=6|i&(l|0)==4^1:0)q=21}else q=21;if((q|0)==21){f[g>>2]=0;f[g+4>>2]=0;q=aD(g,65)|0;l=183431;i=q+65|0;do{b[q>>0]=b[l>>0]|0;q=q+1|0;l=l+1|0}while((q|0)<(i|0));bO(-215,g,192704,179056,3004);bD(g)}l=f[a+4>>2]|0;a=h+16|0;q=f[a>>2]|0;i=h+44|0;r=+p[q+8>>3];s=+p[q+16>>3];t=+p[q+24>>3];p[g>>3]=+p[q>>3];p[g+8>>3]=r;p[g+16>>3]=s;p[g+24>>3]=t;mT(l,g,d,$Y()|0)|0;d=h+36|0;l=f[d>>2]|0;if((l|0?(q=l+12|0,l=f[q>>2]|0,f[q>>2]=l+-1,(l|0)==1):0)?(l=f[d>>2]|0,l|0):0){f[d>>2]=0;q=f[l+4>>2]|0;if(!q){m=f[h+32>>2]|0;if(!m)v=$K()|0;else v=m}else v=q;zh[f[(f[v>>2]|0)+24>>2]&2047](v,l)}f[d>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[j>>2]|0)>0){a=f[h+40>>2]|0;d=0;do{f[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[j>>2]|0))}j=f[i>>2]|0;if((j|0)!=(h+48|0))UC(j);u=e;return}case 0:{u=e;return}default:{f[g>>2]=0;f[g+4>>2]=0;bO(-213,g,192704,179056,3008);bD(g);u=e;return}}}function RM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+80|0;d=c+56|0;e=c;g=f[a>>2]&2031616;a:do if((g|0)<131072){switch(g|0){case 65536:break;default:break a}h=f[a+4>>2]|0;i=d+8|0;f[i>>2]=0;f[i+4>>2]=0;f[d>>2]=33619968;f[d+4>>2]=h;oI(b,d);u=c;return}else{if((g|0)<655360){switch(g|0){case 131072:break;default:break a}xL(e,a,-1);h=d+8|0;f[h>>2]=0;f[h+4>>2]=0;f[d>>2]=-1040121856;f[d+4>>2]=e;oI(b,d);h=e+36|0;i=f[h>>2]|0;if((i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)?(i=f[h>>2]|0,i|0):0){f[h>>2]=0;j=f[i+4>>2]|0;if(!j){k=f[e+32>>2]|0;if(!k)l=$K()|0;else l=k}else l=j;zh[f[(f[l>>2]|0)+24>>2]&2047](l,i)}f[h>>2]=0;h=e+16|0;i=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[i>>2]|0)>0){h=f[e+40>>2]|0;j=0;do{f[h+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[i>>2]|0))}i=f[e+44>>2]|0;if((i|0)!=(e+48|0))UC(i);u=c;return}switch(g|0){case 655360:break;default:break a}i=f[a+4>>2]|0;if((i|0)==(b|0)){u=c;return}j=b+24|0;h=f[j>>2]|0;if(h|0){k=h+8|0;f[k>>2]=(f[k>>2]|0)+1}k=i+24|0;h=f[k>>2]|0;if(h|0?(m=h+8|0,h=f[m>>2]|0,f[m>>2]=h+-1,(h|0)==1):0)iI(i);h=i+4|0;if((f[h>>2]|0)>0){m=f[i+32>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0;o=f[h>>2]|0}while((n|0)<(o|0));f[k>>2]=0;f[i>>2]=f[b>>2];if((o|0)<3)p=13;else p=15}else{f[k>>2]=0;f[i>>2]=f[b>>2];p=13}if((p|0)==13){n=f[b+4>>2]|0;if((n|0)<3){f[h>>2]=n;f[i+8>>2]=f[b+8>>2];f[i+12>>2]=f[b+12>>2];n=f[b+36>>2]|0;m=f[i+36>>2]|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2]}else p=15}if((p|0)==15)gI(i,b);f[i+16>>2]=f[b+16>>2];n=i+20|0;if(!(f[n>>2]|0))f[n>>2]=f[b+20>>2];f[k>>2]=f[j>>2];f[i+28>>2]=f[b+28>>2];u=c;return}while(0);f[d>>2]=0;f[d+4>>2]=0;bO(-213,d,196951,179056,3029);bD(d);u=c;return}function SM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+80|0;d=c+56|0;e=c;g=f[a>>2]&2031616;a:do if((g|0)<131072){switch(g|0){case 65536:break;default:break a}fL(f[a+4>>2]|0,b)|0;u=c;return}else{if((g|0)>=655360){switch(g|0){case 655360:break;default:break a}h=f[a+4>>2]|0;i=d+8|0;f[i>>2]=0;f[i+4>>2]=0;f[d>>2]=34209792;f[d+4>>2]=h;SP(b,d);u=c;return}switch(g|0){case 131072:break;default:break a}xL(e,a,-1);h=d+8|0;f[h>>2]=0;f[h+4>>2]=0;f[d>>2]=-1040121856;f[d+4>>2]=e;SP(b,d);h=e+36|0;i=f[h>>2]|0;if((i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)?(i=f[h>>2]|0,i|0):0){f[h>>2]=0;j=f[i+4>>2]|0;if(!j){k=f[e+32>>2]|0;if(!k)l=$K()|0;else l=k}else l=j;zh[f[(f[l>>2]|0)+24>>2]&2047](l,i)}f[h>>2]=0;h=e+16|0;i=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[i>>2]|0)>0){h=f[e+40>>2]|0;j=0;do{f[h+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[i>>2]|0))}i=f[e+44>>2]|0;if((i|0)!=(e+48|0))UC(i);u=c;return}while(0);f[d>>2]=0;f[d+4>>2]=0;bO(-213,d,196951,179056,3051);bD(d);u=c;return}function TM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+16|0;e=d;g=f[a>>2]&2031616;a:do if((g|0)<720896){switch(g|0){case 327680:break;default:break a}h=f[a+4>>2]|0;i=c+4|0;j=f[i>>2]|0;k=f[c>>2]|0;if(((f[h+4>>2]|0)-(f[h>>2]|0)|0)==(j-k|0)){l=k;m=j}else{f[e>>2]=0;f[e+4>>2]=0;n=aD(e,25)|0;o=183497;p=n+25|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,e,196951,179056,3114);bD(e);l=f[c>>2]|0;m=f[i>>2]|0}if((m|0)==(l|0)){u=d;return}j=e+8|0;k=e+4|0;q=0;r=l;s=m;while(1){t=r;v=t+(q*56|0)|0;w=f[h>>2]|0;x=w+(q*56|0)|0;y=f[w+(q*56|0)+36>>2]|0;if((y|0)!=0?(y|0)==(f[t+(q*56|0)+36>>2]|0):0){z=r;A=s}else{t=j;f[t>>2]=0;f[t+4>>2]=0;f[e>>2]=33619968;f[k>>2]=x;SP(v,e);z=f[c>>2]|0;A=f[i>>2]|0}q=q+1|0;if(q>>>0>=((A-z|0)/56|0)>>>0)break;else{r=z;s=A}}u=d;return}else{switch(g|0){case 720896:break;default:break a}s=f[a+4>>2]|0;r=c+4|0;q=f[r>>2]|0;i=f[c>>2]|0;if((((f[s+4>>2]|0)-(f[s>>2]|0)|0)/48|0|0)==((q-i|0)/56|0|0)){B=i;C=q}else{f[e>>2]=0;f[e+4>>2]=0;n=aD(e,25)|0;o=183497;p=n+25|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,e,196951,179056,3100);bD(e);B=f[c>>2]|0;C=f[r>>2]|0}if((C|0)==(B|0)){u=d;return}q=e+8|0;i=e+4|0;k=0;j=B;h=C;while(1){v=j;x=v+(k*56|0)|0;t=f[s>>2]|0;y=t+(k*48|0)|0;w=f[t+(k*48|0)+24>>2]|0;if((w|0)!=0?(w|0)==(f[v+(k*56|0)+36>>2]|0):0){D=j;E=h}else{v=q;f[v>>2]=0;f[v+4>>2]=0;f[e>>2]=34209792;f[i>>2]=y;SP(x,e);D=f[c>>2]|0;E=f[r>>2]|0}k=k+1|0;if(k>>>0>=((E-D|0)/56|0)>>>0)break;else{j=D;h=E}}u=d;return}while(0);f[e>>2]=0;f[e+4>>2]=0;bO(-213,e,196951,179056,3127);bD(e);u=d;return}function UM(){return 42716}function VM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+144|0;g=e+128|0;h=e+72|0;i=e+16|0;j=e;dQ(g,42732);if((a|0)!=0&(c|0)!=0){k=a+8|0;l=h+4|0;m=0;n=0;do{if(!(((f[a+(m*56|0)+4>>2]|0)<3?(f[a+(m*56|0)+8>>2]|0)==(f[k>>2]|0):0)?!((f[a>>2]^f[a+(m*56|0)>>2])&4095|0):0)){f[h>>2]=0;f[l>>2]=0;o=aD(h,80)|0;p=183523;q=o+80|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,h,183604,179056,3156);bD(h)}n=(f[a+(m*56|0)+12>>2]|0)+n|0;m=m+1|0}while(m>>>0<c>>>0);aM(d,f[k>>2]|0,n,f[a>>2]&4095,-1,0,0);xL(h,d,-1);n=j+4|0;k=j+8|0;m=j+12|0;l=j+8|0;p=j+4|0;o=i+36|0;q=i+16|0;r=i+4|0;s=i+40|0;t=i+44|0;v=i+48|0;w=i+32|0;x=0;y=0;while(1){z=a+(x*56|0)+12|0;A=f[z>>2]|0;B=f[a+(x*56|0)+8>>2]|0;f[j>>2]=y;f[n>>2]=0;f[k>>2]=A;f[m>>2]=B;nL(i,h,j);B=l;f[B>>2]=0;f[B+4>>2]=0;f[j>>2]=33619968;f[p>>2]=i;SP(a+(x*56|0)|0,j);B=f[z>>2]|0;z=f[o>>2]|0;if((z|0?(A=z+12|0,z=f[A>>2]|0,f[A>>2]=z+-1,(z|0)==1):0)?(z=f[o>>2]|0,z|0):0){f[o>>2]=0;A=f[z+4>>2]|0;if(!A){C=f[w>>2]|0;if(!C)D=$K()|0;else D=C}else D=A;zh[f[(f[D>>2]|0)+24>>2]&2047](D,z)}f[o>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[r>>2]|0)>0){z=f[s>>2]|0;A=0;do{f[z+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[r>>2]|0))}A=f[t>>2]|0;if((A|0)!=(v|0))UC(A);x=x+1|0;if(x>>>0>=c>>>0)break;else y=B+y|0}y=h+36|0;c=f[y>>2]|0;if((c|0?(x=c+12|0,c=f[x>>2]|0,f[x>>2]=c+-1,(c|0)==1):0)?(c=f[y>>2]|0,c|0):0){f[y>>2]=0;x=f[c+4>>2]|0;if(!x){v=f[h+32>>2]|0;if(!v)E=$K()|0;else E=v}else E=x;zh[f[(f[E>>2]|0)+24>>2]&2047](E,c)}f[y>>2]=0;y=h+16|0;c=h+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[h+40>>2]|0;E=0;do{f[y+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[c>>2]|0))}c=f[h+44>>2]|0;if((c|0)!=(h+48|0))UC(c)}else $L(d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function WM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+32|0;d=c+16|0;e=c;dQ(d,42752);f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;AM(a,e);a=f[e>>2]|0;h=f[g>>2]|0;VM((a|0)==(h|0)?0:a,(h-a|0)/56|0,b);et(e);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function XM(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+144|0;g=e+128|0;h=e+72|0;i=e+16|0;j=e;dQ(g,42772);if((a|0)!=0&(c|0)!=0){k=a+12|0;l=h+4|0;m=0;n=0;do{if(!(((f[a+(m*56|0)+4>>2]|0)<3?(f[a+(m*56|0)+12>>2]|0)==(f[k>>2]|0):0)?!((f[a>>2]^f[a+(m*56|0)>>2])&4095|0):0)){f[h>>2]=0;f[l>>2]=0;o=aD(h,80)|0;p=183709;q=o+80|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,h,183790,179056,3201);bD(h)}n=(f[a+(m*56|0)+8>>2]|0)+n|0;m=m+1|0}while(m>>>0<c>>>0);aM(d,n,f[k>>2]|0,f[a>>2]&4095,-1,0,0);xL(h,d,-1);k=j+4|0;n=j+8|0;m=j+12|0;l=j+8|0;p=j+4|0;o=i+36|0;q=i+16|0;r=i+4|0;s=i+40|0;t=i+44|0;v=i+48|0;w=i+32|0;x=0;y=0;while(1){z=f[a+(x*56|0)+12>>2]|0;A=a+(x*56|0)+8|0;B=f[A>>2]|0;f[j>>2]=0;f[k>>2]=y;f[n>>2]=z;f[m>>2]=B;nL(i,h,j);B=l;f[B>>2]=0;f[B+4>>2]=0;f[j>>2]=33619968;f[p>>2]=i;SP(a+(x*56|0)|0,j);B=f[A>>2]|0;A=f[o>>2]|0;if((A|0?(z=A+12|0,A=f[z>>2]|0,f[z>>2]=A+-1,(A|0)==1):0)?(A=f[o>>2]|0,A|0):0){f[o>>2]=0;z=f[A+4>>2]|0;if(!z){C=f[w>>2]|0;if(!C)D=$K()|0;else D=C}else D=z;zh[f[(f[D>>2]|0)+24>>2]&2047](D,A)}f[o>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[r>>2]|0)>0){A=f[s>>2]|0;z=0;do{f[A+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[r>>2]|0))}z=f[t>>2]|0;if((z|0)!=(v|0))UC(z);x=x+1|0;if(x>>>0>=c>>>0)break;else y=B+y|0}y=h+36|0;c=f[y>>2]|0;if((c|0?(x=c+12|0,c=f[x>>2]|0,f[x>>2]=c+-1,(c|0)==1):0)?(c=f[y>>2]|0,c|0):0){f[y>>2]=0;x=f[c+4>>2]|0;if(!x){v=f[h+32>>2]|0;if(!v)E=$K()|0;else E=v}else E=x;zh[f[(f[E>>2]|0)+24>>2]&2047](E,c)}f[y>>2]=0;y=h+16|0;c=h+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[h+40>>2]|0;E=0;do{f[y+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[c>>2]|0))}c=f[h+44>>2]|0;if((c|0)!=(h+48|0))UC(c)}else $L(d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function YM(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+32|0;d=c+16|0;e=c;dQ(d,42792);f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;AM(a,e);a=f[e>>2]|0;h=f[g>>2]|0;XM((a|0)==(h|0)?0:a,(h-a|0)/56|0,b);et(e);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function ZM(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,q=0,r=0,s=0,t=0;d=u;u=u+160|0;e=d+144|0;g=d+88|0;h=d;i=d+32|0;dQ(e,42812);if((_L(a,-1)|0)>=3){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,14)|0;k=183895;l=j+14|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,183910,179056,3277);bD(g)}xL(g,a,-1);a=f[g+8>>2]|0;k=f[g+12>>2]|0;a:do switch(f[g>>2]&4095){case 5:{j=f[g+16>>2]|0;m=+p[c>>3];l=(f[g+48>>2]|0)>>>2;if((a|0)>0){if((k|0)<=0){o=0;q=j;while(1){if((o|0)<(k|0))n[q+(o<<2)>>2]=m;o=o+1|0;if((o|0)==(a|0))break a;else q=q+(l<<2)|0}}q=k<<2;o=0;r=j;while(1){Nac(j+((Y(l,o)|0)<<2)|0,0,q|0)|0;if((o|0)<(k|0))n[r+(o<<2)>>2]=m;o=o+1|0;if((o|0)==(a|0))break;else r=r+(l<<2)|0}}break}case 6:{m=+p[c>>3];l=(f[g+48>>2]|0)>>>3;if((a|0)>0&(k|0)>0){r=0;o=f[g+16>>2]|0;while(1){q=0;do{p[o+(q<<3)>>3]=(q|0)==(r|0)?m:0.0;q=q+1|0}while((q|0)!=(k|0));r=r+1|0;if((r|0)==(a|0))break;else o=o+(l<<3)|0}}break}default:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;UP(g,h)|0;rL(i,g,0);UP(i,c)|0;l=i+36|0;o=f[l>>2]|0;if((o|0?(r=o+12|0,o=f[r>>2]|0,f[r>>2]=o+-1,(o|0)==1):0)?(o=f[l>>2]|0,o|0):0){f[l>>2]=0;r=f[o+4>>2]|0;if(!r){q=f[i+32>>2]|0;if(!q)s=$K()|0;else s=q}else s=r;zh[f[(f[s>>2]|0)+24>>2]&2047](s,o)}f[l>>2]=0;l=i+16|0;o=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[o>>2]|0)>0){l=f[i+40>>2]|0;r=0;do{f[l+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[o>>2]|0))}o=f[i+44>>2]|0;if((o|0)!=(i+48|0))UC(o)}}while(0);i=g+36|0;s=f[i>>2]|0;if((s|0?(c=s+12|0,s=f[c>>2]|0,f[c>>2]=s+-1,(s|0)==1):0)?(s=f[i>>2]|0,s|0):0){f[i>>2]=0;c=f[s+4>>2]|0;if(!c){h=f[g+32>>2]|0;if(!h)t=$K()|0;else t=h}else t=c;zh[f[(f[t>>2]|0)+24>>2]&2047](t,s)}f[i>>2]=0;i=g+16|0;s=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[s>>2]|0)>0){i=f[g+40>>2]|0;t=0;do{f[i+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[s>>2]|0))}s=f[g+44>>2]|0;if((s|0)!=(g+48|0))UC(s);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function _M(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,v=0,w=0;d=u;u=u+144|0;e=d+128|0;g=d+72|0;h=d+56|0;i=d;dQ(e,42832);xL(g,c,-1);c=g+4|0;if((f[c>>2]|0)>=3){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,11)|0;k=180095;l=j+11|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,183977,179056,3325);bD(h)}k=f[g+12>>2]|0;j=f[g+8>>2]|0;l=(k|0)<(j|0)?k:j;switch(f[g>>2]&4095){case 5:{j=f[g+16>>2]|0;k=((f[g+48>>2]|0)>>>2)+1|0;if((l|0)>0){m=0;o=0.0;while(1){q=j+((Y(m,k)|0)<<2)|0;r=o+ +n[q>>2];m=m+1|0;if((m|0)>=(l|0)){s=r;break}else o=r}}else s=0.0;p[a>>3]=s;m=a+8|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;break}case 6:{m=f[g+16>>2]|0;k=((f[g+48>>2]|0)>>>3)+1|0;if((l|0)>0){s=0.0;j=0;while(1){q=m+((Y(j,k)|0)<<3)|0;o=s+ +p[q>>3];j=j+1|0;if((j|0)>=(l|0)){t=o;break}else s=o}}else t=0.0;p[a>>3]=t;l=a+8|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;break}default:{rL(i,g,0);f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=i;fG(a,h);h=i+36|0;a=f[h>>2]|0;if((a|0?(l=a+12|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)?(a=f[h>>2]|0,a|0):0){f[h>>2]=0;l=f[a+4>>2]|0;if(!l){j=f[i+32>>2]|0;if(!j)v=$K()|0;else v=j}else v=l;zh[f[(f[v>>2]|0)+24>>2]&2047](v,a)}f[h>>2]=0;h=i+16|0;a=i+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[a>>2]|0)>0){h=f[i+40>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[a>>2]|0))}a=f[i+44>>2]|0;if((a|0)!=(i+48|0))UC(a)}}a=g+36|0;i=f[a>>2]|0;if((i|0?(v=i+12|0,i=f[v>>2]|0,f[v>>2]=i+-1,(i|0)==1):0)?(i=f[a>>2]|0,i|0):0){f[a>>2]=0;v=f[i+4>>2]|0;if(!v){h=f[g+32>>2]|0;if(!h)w=$K()|0;else w=h}else w=v;zh[f[(f[w>>2]|0)+24>>2]&2047](w,i)}f[a>>2]=0;a=g+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[c>>2]|0)>0){a=f[g+40>>2]|0;i=0;do{f[a+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)!=(g+48|0))UC(c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function $M(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+80|0;e=d+64|0;g=d+8|0;h=d;dQ(e,42852);xL(g,a,-1);a=g+48|0;i=f[a>>2]|0;j=g+4|0;k=f[j>>2]|0;if((k|0)>0){l=f[(f[g+44>>2]|0)+(k+-1<<2)>>2]|0;if((k|0)<3){m=l;n=3}else{o=l;n=4}}else{m=0;n=3}if((n|0)==3){l=f[g+8>>2]|0;if((l|0)==(f[g+12>>2]|0)){p=l;q=m}else{o=m;n=4}}if((n|0)==4){f[h>>2]=0;f[h+4>>2]=0;n=aD(h,31)|0;m=184016;l=n+31|0;do{b[n>>0]=b[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(l|0));bO(-215,h,184048,179056,3640);bD(h);p=f[g+8>>2]|0;q=o}o=g+16|0;h=f[o>>2]|0;m=g+44|0;if((p|0)>0)if(c){c=0;do{n=c;c=c+1|0;if((c|0)<(p|0)){l=Y(n,i)|0;k=Y(n,q)|0;n=c;do{Vac(h+((Y(n,q)|0)+l)|0,h+((Y(n,i)|0)+k)|0,q|0)|0;n=n+1|0}while((n|0)!=(p|0))}}while((c|0)!=(p|0))}else{c=0;do{if((c|0)>0){n=Y(c,i)|0;k=Y(c,q)|0;l=0;do{Vac(h+((Y(l,q)|0)+n)|0,h+((Y(l,i)|0)+k)|0,q|0)|0;l=l+1|0}while((l|0)!=(c|0))}c=c+1|0}while((c|0)!=(p|0))}p=g+36|0;c=f[p>>2]|0;if((c|0?(q=c+12|0,c=f[q>>2]|0,f[q>>2]=c+-1,(c|0)==1):0)?(c=f[p>>2]|0,c|0):0){f[p>>2]=0;q=f[c+4>>2]|0;if(!q){i=f[g+32>>2]|0;if(!i)r=$K()|0;else r=i}else r=q;zh[f[(f[r>>2]|0)+24>>2]&2047](r,c)}f[p>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[j>>2]|0)>0){o=f[g+40>>2]|0;g=0;do{f[o+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[j>>2]|0))}j=f[m>>2]|0;if((j|0)!=(a|0))UC(j);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function aN(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;h=u;u=u+272|0;i=h+224|0;j=h+216|0;k=h+168|0;l=h+112|0;m=h+56|0;n=h;dQ(j,42872);if((_L(a,-1)|0)>=3){f[i>>2]=0;f[i+4>>2]=0;o=aD(i,16)|0;p=192842;q=o+16|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,i,184107,179056,4062);bD(i)}r=BL(a,-1)|0;s=r&7;t=r&4088;if((g|0)<0)if((f[c>>2]|0)<0)v=BL(c,-1)|0;else v=r;else v=g;g=(v|0)>-1?v:r;v=g&7;w=v|t;x=(e|0)==1;if(e>>>0>=4){f[i>>2]=0;f[i+4>>2]=0;o=aD(i,40)|0;p=184114;q=o+40|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,i,184107,179056,4072);bD(i)}f[k>>2]=1124007936;y=k+4|0;z=k+8|0;A=k+20|0;B=k+24|0;C=k+28|0;D=k+32|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y+16>>2]=0;f[y+20>>2]=0;f[y+24>>2]=0;f[D>>2]=z;E=k+40|0;F=k+36|0;f[F>>2]=E;f[k+44>>2]=0;f[E>>2]=0;if((f[a>>2]&2031616|0)==655360){zM(i,a,-1);E=i+24|0;G=f[E>>2]|0;if(G|0){H=G+8|0;f[H>>2]=(f[H>>2]|0)+1}H=f[B>>2]|0;if(H|0?(G=H+8|0,H=f[G>>2]|0,f[G>>2]=H+-1,(H|0)==1):0)iI(k);if((f[y>>2]|0)>0){H=f[D>>2]|0;D=0;do{f[H+(D<<2)>>2]=0;D=D+1|0;I=f[y>>2]|0}while((D|0)<(I|0));f[B>>2]=0;f[k>>2]=f[i>>2];if((I|0)<3)J=19;else J=21}else{f[B>>2]=0;f[k>>2]=f[i>>2];J=19}if((J|0)==19){I=f[i+4>>2]|0;if((I|0)<3){f[y>>2]=I;f[z>>2]=f[i+8>>2];f[k+12>>2]=f[i+12>>2];z=f[i+36>>2]|0;I=f[F>>2]|0;f[I>>2]=f[z>>2];f[I+4>>2]=f[z+4>>2]}else J=21}if((J|0)==21)gI(k,i);f[k+16>>2]=f[i+16>>2];if(!(f[A>>2]|0))f[A>>2]=f[i+20>>2];f[B>>2]=f[E>>2];f[C>>2]=f[i+28>>2];hI(i)}xL(l,a,-1);a=(d|0)==0;d=l+8|0;C=l+12|0;aM(c,a?1:f[d>>2]|0,a?f[C>>2]|0:1,w,-1,0,0);xL(m,c,-1);f[n>>2]=f[m>>2];c=n+4|0;w=m+4|0;E=f[w>>2]|0;f[c>>2]=E;B=n+8|0;A=m+8|0;f[B>>2]=f[A>>2];z=n+12|0;I=m+12|0;f[z>>2]=f[I>>2];F=n+16|0;y=m+16|0;f[F>>2]=f[y>>2];f[n+20>>2]=f[m+20>>2];f[n+24>>2]=f[m+24>>2];f[n+28>>2]=f[m+28>>2];D=n+32|0;H=m+32|0;f[D>>2]=f[H>>2];G=n+36|0;K=m+36|0;L=f[K>>2]|0;f[G>>2]=L;M=n+40|0;f[M>>2]=B;N=n+48|0;O=n+44|0;f[O>>2]=N;f[N>>2]=0;f[n+52>>2]=0;if(!L)P=E;else{E=L+12|0;f[E>>2]=(f[E>>2]|0)+1;P=f[w>>2]|0}if((P|0)>=3){f[c>>2]=0;YK(n,P,0,0,0);if((f[c>>2]|0)>0){P=f[m+40>>2]|0;E=f[M>>2]|0;L=f[m+44>>2]|0;Q=f[O>>2]|0;R=0;do{f[E+(R<<2)>>2]=f[P+(R<<2)>>2];f[Q+(R<<2)>>2]=f[L+(R<<2)>>2];R=R+1|0}while((R|0)<(f[c>>2]|0))}}else{R=f[m+44>>2]|0;L=f[O>>2]|0;f[L>>2]=f[R>>2];f[L+4>>2]=f[R+4>>2]}do if(x)if(!((g|r)&4)){R=f[A>>2]|0;L=f[I>>2]|0;Q=t|4;if(((f[c>>2]|0)<3?(f[B>>2]|0)==(R|0):0)&(f[z>>2]|0)==(L|0)?!((f[F>>2]|0)==0?1:(f[n>>2]&4095|0)!=(Q|0)):0){S=4;T=0;break}f[i>>2]=R;f[i+4>>2]=L;hL(n,2,i,Q);S=4;T=0}else{S=v;T=0}else{S=v;T=e}while(0);e=(T|0)==0;a:do if(a){if(e){v=(s|0)==0;if(v&(S|0)==4){U=951;break}z=(S|0)==5;if(v&z){U=952;break}B=(S|0)==6;if(v&B){U=953;break}v=(s|0)==2;if(v&z){U=954;break}if(v&B){U=955;break}v=(s|0)==3;if(v&z){U=956;break}if(v&B){U=957;break}v=(s|0)==5;if(v&z){U=958;break}if(v&B){U=959;break}else{V=(s|0)==6&B?945:0;J=76;break}}switch(T|0){case 2:{if(!(S|s)){U=960;break a}if((s|0)==2&(S|0)==2){U=961;break a}if((s|0)==3&(S|0)==3){U=962;break a}if((s|0)==5&(S|0)==5){U=963;break a}else{V=(s|0)==6&(S|0)==6?946:0;J=76;break a}break}case 3:{if(!(S|s)){U=964;break a}if((s|0)==2&(S|0)==2){U=965;break a}if((s|0)==3&(S|0)==3){U=966;break a}if((s|0)==5&(S|0)==5){U=967;break a}else{V=(s|0)==6&(S|0)==6?947:0;J=76;break a}break}default:{f[i>>2]=0;W=i+4|0;f[W>>2]=0;X=aD(i,57)|0;o=X;p=184155;q=o+57|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-210,i,184107,179056,4204);bD(i)}}}else{if(e){B=(s|0)==0;if(B&(S|0)==4){U=968;break}v=(S|0)==5;if(B&v){U=969;break}z=(S|0)==6;if(B&z){U=970;break}B=(s|0)==2;if(B&v){U=971;break}if(B&z){U=972;break}B=(s|0)==3;if(B&v){U=973;break}if(B&z){U=974;break}B=(s|0)==5;if(B&v){U=975;break}if(B&z){U=976;break}else{V=(s|0)==6&z?948:0;J=76;break}}switch(T|0){case 2:{if(!(S|s)){U=977;break a}if((s|0)==2&(S|0)==2){U=978;break a}if((s|0)==3&(S|0)==3){U=979;break a}if((s|0)==5&(S|0)==5){U=980;break a}else{V=(s|0)==6&(S|0)==6?949:0;J=76;break a}break}case 3:{if(!(S|s)){U=981;break a}if((s|0)==2&(S|0)==2){U=982;break a}if((s|0)==3&(S|0)==3){U=983;break a}if((s|0)==5&(S|0)==5){U=984;break a}else{V=(s|0)==6&(S|0)==6?950:0;J=76;break a}break}default:{f[i>>2]=0;W=i+4|0;f[W>>2]=0;X=aD(i,57)|0;o=X;p=184155;q=o+57|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-210,i,184107,179056,4204);bD(i)}}}while(0);if((J|0)==76)if(!V){f[i>>2]=0;W=i+4|0;f[W>>2]=0;X=aD(i,57)|0;o=X;p=184155;q=o+57|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-210,i,184107,179056,4204);bD(i)}else U=V;zh[U&2047](l,n);if(x){x=i+8|0;f[x>>2]=0;f[x+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=m;OJ(n,i,f[m>>2]&4095,1.0/+((a?f[d>>2]|0:f[C>>2]|0)|0),0.0)}C=f[G>>2]|0;if((C|0?(d=C+12|0,C=f[d>>2]|0,f[d>>2]=C+-1,(C|0)==1):0)?(C=f[G>>2]|0,C|0):0){f[G>>2]=0;d=f[C+4>>2]|0;if(!d){a=f[D>>2]|0;if(!a)Y=$K()|0;else Y=a}else Y=d;zh[f[(f[Y>>2]|0)+24>>2]&2047](Y,C)}f[G>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[c>>2]|0)>0){F=f[M>>2]|0;M=0;do{f[F+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[c>>2]|0))}c=f[O>>2]|0;if((c|0)!=(N|0))UC(c);c=f[K>>2]|0;if((c|0?(N=c+12|0,c=f[N>>2]|0,f[N>>2]=c+-1,(c|0)==1):0)?(c=f[K>>2]|0,c|0):0){f[K>>2]=0;N=f[c+4>>2]|0;if(!N){O=f[H>>2]|0;if(!O)Z=$K()|0;else Z=O}else Z=N;zh[f[(f[Z>>2]|0)+24>>2]&2047](Z,c)}f[K>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[w>>2]|0)>0){y=f[m+40>>2]|0;K=0;do{f[y+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[w>>2]|0))}w=f[m+44>>2]|0;if((w|0)!=(m+48|0))UC(w);w=l+36|0;m=f[w>>2]|0;if((m|0?(K=m+12|0,m=f[K>>2]|0,f[K>>2]=m+-1,(m|0)==1):0)?(m=f[w>>2]|0,m|0):0){f[w>>2]=0;K=f[m+4>>2]|0;do if(!K){y=f[l+32>>2]|0;if(y|0){_=y;break}_=$K()|0}else _=K;while(0);zh[f[(f[_>>2]|0)+24>>2]&2047](_,m)}f[w>>2]=0;w=l+16|0;m=l+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[m>>2]|0)>0){w=f[l+40>>2]|0;_=0;do{f[w+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))UC(m);hI(k);if(!(f[j+4>>2]|0)){u=h;return}u=h;return}function bN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=N5b(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>3;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+p[b+(m<<3)>>3];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){n=b;o=m;while(1){n=n+(l<<3)|0;if(a){q=0;do{r=k+(q<<3)|0;p[r>>3]=+p[r>>3]+ +p[n+(q<<3)>>3];q=q+1|0}while((q|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;n=(o|0)<(h|0);q=b;r=m;do{q=q+(l<<3)|0;s=0;do{t=k+(s<<3)|0;v=s|1;w=k+(v<<3)|0;x=+p[w>>3]+ +p[q+(v<<3)>>3];p[t>>3]=+p[t>>3]+ +p[q+(s<<3)>>3];p[w>>3]=x;w=s|2;t=k+(w<<3)|0;v=s|3;y=k+(v<<3)|0;x=+p[y>>3]+ +p[q+(v<<3)>>3];p[t>>3]=+p[t>>3]+ +p[q+(w<<3)>>3];p[y>>3]=x;s=s+4|0}while((s|0)<=(g|0));if(n){s=o;do{y=k+(s<<3)|0;p[y>>3]=+p[y>>3]+ +p[q+(s<<3)>>3];s=s+1|0}while((s|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}P5b(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function cN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=N5b(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>3;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+p[b+(m<<3)>>3];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){n=b;o=m;while(1){n=n+(l<<3)|0;if(a){q=0;do{r=k+(q<<3)|0;s=+p[r>>3];t=+p[n+(q<<3)>>3];p[r>>3]=s<t?t:s;q=q+1|0}while((q|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;n=(o|0)<(h|0);q=b;r=m;do{q=q+(l<<3)|0;v=0;do{w=k+(v<<3)|0;s=+p[w>>3];t=+p[q+(v<<3)>>3];x=v|1;y=k+(x<<3)|0;z=+p[y>>3];A=+p[q+(x<<3)>>3];p[w>>3]=s<t?t:s;p[y>>3]=z<A?A:z;y=v|2;w=k+(y<<3)|0;z=+p[w>>3];A=+p[q+(y<<3)>>3];y=v|3;x=k+(y<<3)|0;s=+p[x>>3];t=+p[q+(y<<3)>>3];p[w>>3]=z<A?A:z;p[x>>3]=s<t?t:s;v=v+4|0}while((v|0)<=(g|0));if(n){v=o;do{x=k+(v<<3)|0;s=+p[x>>3];t=+p[q+(v<<3)>>3];p[x>>3]=s<t?t:s;v=v+1|0}while((v|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}P5b(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function dN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=N5b(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>3;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+p[b+(m<<3)>>3];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){n=b;o=m;while(1){n=n+(l<<3)|0;if(a){q=0;do{r=k+(q<<3)|0;s=+p[r>>3];t=+p[n+(q<<3)>>3];p[r>>3]=t<s?t:s;q=q+1|0}while((q|0)!=(h|0))}o=o+-1|0;if(!o)break a}}o=h&-4;n=(o|0)<(h|0);q=b;r=m;do{q=q+(l<<3)|0;v=0;do{w=k+(v<<3)|0;s=+p[w>>3];t=+p[q+(v<<3)>>3];x=v|1;y=k+(x<<3)|0;z=+p[y>>3];A=+p[q+(x<<3)>>3];p[w>>3]=t<s?t:s;p[y>>3]=A<z?A:z;y=v|2;w=k+(y<<3)|0;z=+p[w>>3];A=+p[q+(y<<3)>>3];y=v|3;x=k+(y<<3)|0;s=+p[x>>3];t=+p[q+(y<<3)>>3];p[w>>3]=A<z?A:z;p[x>>3]=t<s?t:s;v=v+4|0}while((v|0)<=(g|0));if(n){v=o;do{x=k+(v<<3)|0;s=+p[x>>3];t=+p[q+(v<<3)>>3];p[x>>3]=t<s?t:s;v=v+1|0}while((v|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}P5b(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function eN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);n=e*3|0;o=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{p[s+(t<<3)>>3]=+p[r+(t<<3)>>3];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+p[r+(t<<3)>>3];v=+p[r+(t+e<<3)>>3];if(o){w=u;x=j;while(1){y=w+ +p[r+(x+t<<3)>>3];x=x+e|0;if((x|0)>=(g|0)){z=y;break}else w=y}}else z=u;p[s+(t<<3)>>3]=v+z;t=t+1|0;if((t|0)==(e|0))break a}}else A=0;do{w=+p[r+(A+e<<3)>>3];y=+p[r+(A<<3)>>3];t=j;do{x=t+A|0;y=y+ +p[r+(x<<3)>>3]+ +p[r+(x+j<<3)>>3];w=w+ +p[r+(x+e<<3)>>3]+ +p[r+(x+n<<3)>>3];t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){v=y;x=t;while(1){u=v+ +p[r+(x+A<<3)>>3];x=x+e|0;if((x|0)>=(g|0)){B=u;break}else v=u}}else B=y;p[s+(A<<3)>>3]=w+B;A=A+1|0}while((A|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function fN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);n=e*3|0;o=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{p[s+(t<<3)>>3]=+p[r+(t<<3)>>3];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+p[r+(t<<3)>>3];v=+p[r+(t+e<<3)>>3];if(o){w=j;x=u;while(1){y=+p[r+(w+t<<3)>>3];z=x<y?y:x;w=w+e|0;if((w|0)>=(g|0)){A=z;break}else x=z}}else A=u;p[s+(t<<3)>>3]=A<v?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{x=+p[r+(B+e<<3)>>3];z=+p[r+(B<<3)>>3];t=j;do{w=t+B|0;y=+p[r+(w<<3)>>3];C=z<y?y:z;y=+p[r+(w+e<<3)>>3];D=x<y?y:x;y=+p[r+(w+j<<3)>>3];z=C<y?y:C;C=+p[r+(w+n<<3)>>3];x=D<C?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){w=t;v=z;while(1){u=+p[r+(w+B<<3)>>3];D=v<u?u:v;w=w+e|0;if((w|0)>=(g|0)){E=D;break}else v=D}}else E=z;p[s+(B<<3)>>3]=E<x?x:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function gN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);n=e*3|0;o=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{p[s+(t<<3)>>3]=+p[r+(t<<3)>>3];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+p[r+(t<<3)>>3];v=+p[r+(t+e<<3)>>3];if(o){w=j;x=u;while(1){y=+p[r+(w+t<<3)>>3];z=y<x?y:x;w=w+e|0;if((w|0)>=(g|0)){A=z;break}else x=z}}else A=u;p[s+(t<<3)>>3]=v<A?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{x=+p[r+(B+e<<3)>>3];z=+p[r+(B<<3)>>3];t=j;do{w=t+B|0;y=+p[r+(w<<3)>>3];C=y<z?y:z;y=+p[r+(w+e<<3)>>3];D=y<x?y:x;y=+p[r+(w+j<<3)>>3];z=y<C?y:C;C=+p[r+(w+n<<3)>>3];x=C<D?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){w=t;v=z;while(1){u=+p[r+(w+B<<3)>>3];D=u<v?u:v;w=w+e|0;if((w|0)>=(g|0)){E=D;break}else v=D}}else E=z;p[s+(B<<3)>>3]=x<E?x:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function hN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;p=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+n[r+(t<<2)>>2];v=+n[r+(t+e<<2)>>2];if(p){w=j;x=u;while(1){y=+n[r+(w+t<<2)>>2];z=y<x?y:x;w=w+e|0;if((w|0)>=(g|0)){A=z;break}else x=z}}else A=u;n[s+(t<<2)>>2]=v<A?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{x=+n[r+(B+e<<2)>>2];z=+n[r+(B<<2)>>2];t=j;do{w=t+B|0;y=+n[r+(w<<2)>>2];C=y<z?y:z;y=+n[r+(w+e<<2)>>2];D=y<x?y:x;y=+n[r+(w+j<<2)>>2];z=y<C?y:C;C=+n[r+(w+o<<2)>>2];x=C<D?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){w=t;v=z;while(1){u=+n[r+(w+B<<2)>>2];D=u<v?u:v;w=w+e|0;if((w|0)>=(g|0)){E=D;break}else v=D}}else E=z;n[s+(B<<2)>>2]=x<E?x:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function iN(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=k;x=u;while(1){y=d[r+(w+t<<1)>>1]|0;z=y<<16>>16<x<<16>>16?y:x;w=w+g|0;if((w|0)>=(h|0)){A=z;break}else x=z}}else A=u;d[s+(t<<1)>>1]=v<<16>>16<A<<16>>16?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B+g<<1)>>1]|0;x=d[r+(B<<1)>>1]|0;w=k;do{z=w+B|0;y=d[r+(z<<1)>>1]|0;C=y<<16>>16<x<<16>>16?y:x;y=d[r+(z+g<<1)>>1]|0;D=y<<16>>16<t<<16>>16?y:t;y=d[r+(z+k<<1)>>1]|0;x=y<<16>>16<C<<16>>16?y:C;C=d[r+(z+o<<1)>>1]|0;t=C<<16>>16<D<<16>>16?C:D;w=w+l|0}while((w|0)<=(m|0));if((w|0)<(h|0)){v=w;u=x;while(1){D=d[r+(v+B<<1)>>1]|0;C=D<<16>>16<u<<16>>16?D:u;v=v+g|0;if((v|0)>=(h|0)){E=C;break}else u=C}}else E=x;d[s+(B<<1)>>1]=t<<16>>16<E<<16>>16?t:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function jN(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=k;x=u;while(1){y=d[r+(w+t<<1)>>1]|0;z=(y&65535)<(x&65535)?y:x;w=w+g|0;if((w|0)>=(h|0)){A=z;break}else x=z}}else A=u;d[s+(t<<1)>>1]=(v&65535)<(A&65535)?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B+g<<1)>>1]|0;x=d[r+(B<<1)>>1]|0;w=k;do{z=w+B|0;y=d[r+(z<<1)>>1]|0;C=(y&65535)<(x&65535)?y:x;y=d[r+(z+g<<1)>>1]|0;D=(y&65535)<(t&65535)?y:t;y=d[r+(z+k<<1)>>1]|0;x=(y&65535)<(C&65535)?y:C;C=d[r+(z+o<<1)>>1]|0;t=(C&65535)<(D&65535)?C:D;w=w+l|0}while((w|0)<=(m|0));if((w|0)<(h|0)){v=w;u=x;while(1){D=d[r+(v+B<<1)>>1]|0;C=(D&65535)<(u&65535)?D:u;v=v+g|0;if((v|0)>=(h|0)){E=C;break}else u=C}}else E=x;d[s+(B<<1)>>1]=(t&65535)<(E&65535)?t:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function kN(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=f[a+40>>2]|0;e=f[d>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;i=Y(g,f[d+4>>2]|0)|0;if((e|0)<=0)return;d=a+16|0;j=a+44|0;a=c+16|0;k=c+44|0;c=(i|0)==(g|0);l=g<<1;m=g<<2;n=i-m|0;o=(l|0)>(n|0);p=g*3|0;q=(l|0)<(i|0);r=0;do{s=(f[d>>2]|0)+(Y(f[f[j>>2]>>2]|0,r)|0)|0;t=(f[a>>2]|0)+(Y(f[f[k>>2]>>2]|0,r)|0)|0;a:do if(c){u=0;do{b[t+u>>0]=b[s+u>>0]|0;u=u+1|0}while((u|0)!=(g|0))}else{if(o){u=0;while(1){v=b[s+u>>0]|0;w=b[s+(u+g)>>0]|0;if(q){x=v;y=l;while(1){z=x&255;A=z-(h[195981+((z|256)-(h[s+(y+u)>>0]|0))>>0]|0)&255;y=y+g|0;if((y|0)>=(i|0)){B=A;break}else x=A}}else B=v;x=B&255;b[t+u>>0]=x-(h[195981+((x|256)-(w&255))>>0]|0);u=u+1|0;if((u|0)==(g|0))break a}}else C=0;do{u=b[s+(C+g)>>0]|0;x=b[s+C>>0]|0;y=l;while(1){A=y+C|0;z=x&255;D=z-(h[195981+((z|256)-(h[s+A>>0]|0))>>0]|0)|0;z=u&255;E=z-(h[195981+((z|256)-(h[s+(A+g)>>0]|0))>>0]|0)|0;F=D-(h[195981+((D&255|256)-(h[s+(A+l)>>0]|0))>>0]|0)|0;G=E-(h[195981+((E&255|256)-(h[s+(A+p)>>0]|0))>>0]|0)|0;y=y+m|0;if((y|0)>(n|0))break;else{u=G&255;x=F&255}}if((y|0)<(i|0)){x=F;u=y;while(1){w=x&255;v=w-(h[195981+((w|256)-(h[s+(u+C)>>0]|0))>>0]|0)|0;u=u+g|0;if((u|0)>=(i|0)){H=v;break}else x=v}}else H=F;b[t+C>>0]=H-(h[195981+((H&255|256)-(G&255))>>0]|0);C=C+1|0}while((C|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function lN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;p=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+n[r+(t<<2)>>2];v=+n[r+(t+e<<2)>>2];if(p){w=j;x=u;while(1){y=+n[r+(w+t<<2)>>2];z=x<y?y:x;w=w+e|0;if((w|0)>=(g|0)){A=z;break}else x=z}}else A=u;n[s+(t<<2)>>2]=A<v?v:A;t=t+1|0;if((t|0)==(e|0))break a}}else B=0;do{x=+n[r+(B+e<<2)>>2];z=+n[r+(B<<2)>>2];t=j;do{w=t+B|0;y=+n[r+(w<<2)>>2];C=z<y?y:z;y=+n[r+(w+e<<2)>>2];D=x<y?y:x;y=+n[r+(w+j<<2)>>2];z=C<y?y:C;C=+n[r+(w+o<<2)>>2];x=D<C?C:D;t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){w=t;v=z;while(1){u=+n[r+(w+B<<2)>>2];D=v<u?u:v;w=w+e|0;if((w|0)>=(g|0)){E=D;break}else v=D}}else E=z;n[s+(B<<2)>>2]=E<x?x:E;B=B+1|0}while((B|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function mN(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=k;x=u;while(1){y=d[r+(w+t<<1)>>1]|0;z=x<<16>>16<y<<16>>16?y:x;w=w+g|0;if((w|0)>=(h|0)){A=z;break}else x=z}}else A=u;d[s+(t<<1)>>1]=A<<16>>16<v<<16>>16?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B+g<<1)>>1]|0;x=d[r+(B<<1)>>1]|0;w=k;do{z=w+B|0;y=d[r+(z<<1)>>1]|0;C=x<<16>>16<y<<16>>16?y:x;y=d[r+(z+g<<1)>>1]|0;D=t<<16>>16<y<<16>>16?y:t;y=d[r+(z+k<<1)>>1]|0;x=C<<16>>16<y<<16>>16?y:C;C=d[r+(z+o<<1)>>1]|0;t=D<<16>>16<C<<16>>16?C:D;w=w+l|0}while((w|0)<=(m|0));if((w|0)<(h|0)){v=w;u=x;while(1){D=d[r+(v+B<<1)>>1]|0;C=u<<16>>16<D<<16>>16?D:u;v=v+g|0;if((v|0)>=(h|0)){E=C;break}else u=C}}else E=x;d[s+(B<<1)>>1]=E<<16>>16<t<<16>>16?t:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function nN(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;p=(k|0)<(h|0);q=0;do{r=c+(Y(i,q)|0)|0;s=a+(Y(j,q)|0)|0;a:do if(b){t=0;do{d[s+(t<<1)>>1]=d[r+(t<<1)>>1]|0;t=t+1|0}while((t|0)!=(g|0))}else{if(n){t=0;while(1){u=d[r+(t<<1)>>1]|0;v=d[r+(t+g<<1)>>1]|0;if(p){w=k;x=u;while(1){y=d[r+(w+t<<1)>>1]|0;z=(x&65535)<(y&65535)?y:x;w=w+g|0;if((w|0)>=(h|0)){A=z;break}else x=z}}else A=u;d[s+(t<<1)>>1]=(A&65535)<(v&65535)?v:A;t=t+1|0;if((t|0)==(g|0))break a}}else B=0;do{t=d[r+(B+g<<1)>>1]|0;x=d[r+(B<<1)>>1]|0;w=k;do{z=w+B|0;y=d[r+(z<<1)>>1]|0;C=(x&65535)<(y&65535)?y:x;y=d[r+(z+g<<1)>>1]|0;D=(t&65535)<(y&65535)?y:t;y=d[r+(z+k<<1)>>1]|0;x=(C&65535)<(y&65535)?y:C;C=d[r+(z+o<<1)>>1]|0;t=(D&65535)<(C&65535)?C:D;w=w+l|0}while((w|0)<=(m|0));if((w|0)<(h|0)){v=w;u=x;while(1){D=d[r+(v+B<<1)>>1]|0;C=(u&65535)<(D&65535)?D:u;v=v+g|0;if((v|0)>=(h|0)){E=C;break}else u=C}}else E=x;d[s+(B<<1)>>1]=(E&65535)<(t&65535)?t:E;B=B+1|0}while((B|0)!=(g|0))}while(0);q=q+1|0}while((q|0)!=(e|0));return}function oN(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=f[a+40>>2]|0;e=f[d>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;i=Y(g,f[d+4>>2]|0)|0;if((e|0)<=0)return;d=a+16|0;j=a+44|0;a=c+16|0;k=c+44|0;c=(i|0)==(g|0);l=g<<1;m=g<<2;n=i-m|0;o=(l|0)>(n|0);p=g*3|0;q=(l|0)<(i|0);r=0;do{s=(f[d>>2]|0)+(Y(f[f[j>>2]>>2]|0,r)|0)|0;t=(f[a>>2]|0)+(Y(f[f[k>>2]>>2]|0,r)|0)|0;a:do if(c){u=0;do{b[t+u>>0]=b[s+u>>0]|0;u=u+1|0}while((u|0)!=(g|0))}else{if(o){u=0;while(1){v=b[s+u>>0]|0;w=b[s+(u+g)>>0]|0;if(q){x=v;y=l;while(1){z=x&255;A=(h[195981+(256-z+(h[s+(y+u)>>0]|0))>>0]|0)+z&255;y=y+g|0;if((y|0)>=(i|0)){B=A;break}else x=A}}else B=v;x=B&255;b[t+u>>0]=(h[195981+((w&255|256)-x)>>0]|0)+x;u=u+1|0;if((u|0)==(g|0))break a}}else C=0;do{u=b[s+(C+g)>>0]|0;x=b[s+C>>0]|0;y=l;while(1){A=y+C|0;z=x&255;D=(h[195981+(256-z+(h[s+A>>0]|0))>>0]|0)+z|0;z=u&255;E=(h[195981+(256-z+(h[s+(A+g)>>0]|0))>>0]|0)+z|0;F=(h[195981+(256-(D&255)+(h[s+(A+l)>>0]|0))>>0]|0)+D|0;G=(h[195981+(256-(E&255)+(h[s+(A+p)>>0]|0))>>0]|0)+E|0;y=y+m|0;if((y|0)>(n|0))break;else{u=G&255;x=F&255}}if((y|0)<(i|0)){x=F;u=y;while(1){w=x&255;v=(h[195981+(256-w+(h[s+(u+C)>>0]|0))>>0]|0)+w|0;u=u+g|0;if((u|0)>=(i|0)){H=v;break}else x=v}}else H=F;b[t+C>>0]=(h[195981+((G&255|256)-(H&255))>>0]|0)+H;C=C+1|0}while((C|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function pN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;q=(j|0)<(g|0);r=0;do{s=c+(Y(h,r)|0)|0;t=a+(Y(i,r)|0)|0;a:do if(b){u=0;do{p[t+(u<<3)>>3]=+n[s+(u<<2)>>2];u=u+1|0}while((u|0)!=(e|0))}else{if(m){u=0;while(1){v=+n[s+(u<<2)>>2];w=+n[s+(u+e<<2)>>2];if(q){x=v;y=j;while(1){z=x+ +n[s+(y+u<<2)>>2];y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=w+A;u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{x=+n[s+(B+e<<2)>>2];z=+n[s+(B<<2)>>2];u=j;do{y=u+B|0;z=z+ +n[s+(y<<2)>>2]+ +n[s+(y+j<<2)>>2];x=x+ +n[s+(y+e<<2)>>2]+ +n[s+(y+o<<2)>>2];u=u+k|0}while((u|0)<=(l|0));if((u|0)<(g|0)){w=z;y=u;while(1){v=w+ +n[s+(y+B<<2)>>2];y=y+e|0;if((y|0)>=(g|0)){C=v;break}else w=v}}else C=z;p[t+(B<<3)>>3]=x+C;B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function qN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);j=e<<1;k=e<<2;l=g-k|0;m=(j|0)>(l|0);o=e*3|0;p=(j|0)<(g|0);q=0;do{r=c+(Y(h,q)|0)|0;s=a+(Y(i,q)|0)|0;a:do if(b){t=0;do{f[s+(t<<2)>>2]=f[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0))}else{if(m){t=0;while(1){u=+n[r+(t<<2)>>2];v=+n[r+(t+e<<2)>>2];if(p){w=u;x=j;while(1){y=w+ +n[r+(x+t<<2)>>2];x=x+e|0;if((x|0)>=(g|0)){z=y;break}else w=y}}else z=u;n[s+(t<<2)>>2]=v+z;t=t+1|0;if((t|0)==(e|0))break a}}else A=0;do{w=+n[r+(A+e<<2)>>2];y=+n[r+(A<<2)>>2];t=j;do{x=t+A|0;y=y+ +n[r+(x<<2)>>2]+ +n[r+(x+j<<2)>>2];w=w+ +n[r+(x+e<<2)>>2]+ +n[r+(x+o<<2)>>2];t=t+k|0}while((t|0)<=(l|0));if((t|0)<(g|0)){v=y;x=t;while(1){u=v+ +n[r+(x+A<<2)>>2];x=x+e|0;if((x|0)>=(g|0)){B=u;break}else v=u}}else B=y;n[s+(A<<2)>>2]=w+B;A=A+1|0}while((A|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function rN(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;n=(k|0)>(m|0);o=g*3|0;q=(k|0)<(h|0);r=0;do{s=c+(Y(i,r)|0)|0;t=a+(Y(j,r)|0)|0;a:do if(b){u=0;do{p[t+(u<<3)>>3]=+(d[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(g|0))}else{if(n){u=0;while(1){v=+(d[s+(u<<1)>>1]|0);w=+(d[s+(u+g<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(d[s+(y+u<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=w+A;u=u+1|0;if((u|0)==(g|0))break a}}else B=0;do{x=+(d[s+(B+g<<1)>>1]|0);z=+(d[s+(B<<1)>>1]|0);u=k;do{y=u+B|0;z=z+ +(d[s+(y<<1)>>1]|0)+ +(d[s+(y+k<<1)>>1]|0);x=x+ +(d[s+(y+g<<1)>>1]|0)+ +(d[s+(y+o<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(h|0)){w=z;y=u;while(1){v=w+ +(d[s+(y+B<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){C=v;break}else w=v}}else C=z;p[t+(B<<3)>>3]=x+C;B=B+1|0}while((B|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function sN(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;e=f[c>>2]|0;g=((f[a>>2]|0)>>>3&511)+1|0;h=Y(g,f[c+4>>2]|0)|0;if((e|0)<=0)return;c=f[a+16>>2]|0;i=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;j=f[f[b+44>>2]>>2]|0;b=(h|0)==(g|0);k=g<<1;l=g<<2;m=h-l|0;o=(k|0)>(m|0);p=g*3|0;q=(k|0)<(h|0);r=0;do{s=c+(Y(i,r)|0)|0;t=a+(Y(j,r)|0)|0;a:do if(b){u=0;do{n[t+(u<<2)>>2]=+(d[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(g|0))}else{if(o){u=0;while(1){v=+(d[s+(u<<1)>>1]|0);w=+(d[s+(u+g<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(d[s+(y+u<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){A=z;break}else x=z}}else A=v;n[t+(u<<2)>>2]=w+A;u=u+1|0;if((u|0)==(g|0))break a}}else B=0;do{x=+(d[s+(B+g<<1)>>1]|0);z=+(d[s+(B<<1)>>1]|0);u=k;do{y=u+B|0;z=z+ +(d[s+(y<<1)>>1]|0)+ +(d[s+(y+k<<1)>>1]|0);x=x+ +(d[s+(y+g<<1)>>1]|0)+ +(d[s+(y+p<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(h|0)){w=z;y=u;while(1){v=w+ +(d[s+(y+B<<1)>>1]|0);y=y+g|0;if((y|0)>=(h|0)){C=v;break}else w=v}}else C=z;n[t+(B<<2)>>2]=x+C;B=B+1|0}while((B|0)!=(g|0))}while(0);r=r+1|0}while((r|0)!=(e|0));return}function tN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);k=e<<1;l=e<<2;m=g-l|0;n=(k|0)>(m|0);o=e*3|0;q=(k|0)<(g|0);r=0;do{s=c+(Y(h,r)|0)|0;t=a+(Y(i,r)|0)|0;a:do if(b){u=0;do{p[t+(u<<3)>>3]=+(j[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(n){u=0;while(1){v=+(j[s+(u<<1)>>1]|0);w=+(j[s+(u+e<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(j[s+(y+u<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=w+A;u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{x=+(j[s+(B+e<<1)>>1]|0);z=+(j[s+(B<<1)>>1]|0);u=k;do{y=u+B|0;z=z+ +(j[s+(y<<1)>>1]|0)+ +(j[s+(y+k<<1)>>1]|0);x=x+ +(j[s+(y+e<<1)>>1]|0)+ +(j[s+(y+o<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(g|0)){w=z;y=u;while(1){v=w+ +(j[s+(y+B<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){C=v;break}else w=v}}else C=z;p[t+(B<<3)>>3]=x+C;B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function uN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0.0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=f[a+16>>2]|0;h=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;i=f[f[b+44>>2]>>2]|0;b=(g|0)==(e|0);k=e<<1;l=e<<2;m=g-l|0;o=(k|0)>(m|0);p=e*3|0;q=(k|0)<(g|0);r=0;do{s=c+(Y(h,r)|0)|0;t=a+(Y(i,r)|0)|0;a:do if(b){u=0;do{n[t+(u<<2)>>2]=+(j[s+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(o){u=0;while(1){v=+(j[s+(u<<1)>>1]|0);w=+(j[s+(u+e<<1)>>1]|0);if(q){x=v;y=k;while(1){z=x+ +(j[s+(y+u<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;n[t+(u<<2)>>2]=w+A;u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{x=+(j[s+(B+e<<1)>>1]|0);z=+(j[s+(B<<1)>>1]|0);u=k;do{y=u+B|0;z=z+ +(j[s+(y<<1)>>1]|0)+ +(j[s+(y+k<<1)>>1]|0);x=x+ +(j[s+(y+e<<1)>>1]|0)+ +(j[s+(y+p<<1)>>1]|0);u=u+l|0}while((u|0)<=(m|0));if((u|0)<(g|0)){w=z;y=u;while(1){v=w+ +(j[s+(y+B<<1)>>1]|0);y=y+e|0;if((y|0)>=(g|0)){C=v;break}else w=v}}else C=z;n[t+(B<<2)>>2]=x+C;B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function vN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=(g|0)==(e|0);i=e<<1;j=e<<2;k=g-j|0;l=(i|0)>(k|0);m=e*3|0;n=f[a+16>>2]|0;o=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;q=f[f[b+44>>2]>>2]|0;b=(i|0)<(g|0);r=0;do{s=n+(Y(o,r)|0)|0;t=a+(Y(q,r)|0)|0;a:do if(c){u=0;do{p[t+(u<<3)>>3]=+(h[s+u>>0]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(l){u=0;while(1){v=h[s+u>>0]|0;w=h[s+(u+e)>>0]|0;if(b){x=v;y=i;while(1){z=(h[s+(y+u)>>0]|0)+x|0;y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;p[t+(u<<3)>>3]=+(A+w|0);u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{u=h[s+(B+e)>>0]|0;x=h[s+B>>0]|0;y=i;do{z=y+B|0;x=(h[s+z>>0]|0)+x+(h[s+(z+i)>>0]|0)|0;u=(h[s+(z+e)>>0]|0)+u+(h[s+(z+m)>>0]|0)|0;y=y+j|0}while((y|0)<=(k|0));if((y|0)<(g|0)){w=x;v=y;while(1){z=(h[s+(v+B)>>0]|0)+w|0;v=v+e|0;if((v|0)>=(g|0)){C=z;break}else w=z}}else C=x;p[t+(B<<3)>>3]=+(C+u|0);B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function wN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=(g|0)==(e|0);i=e<<1;j=e<<2;k=g-j|0;l=(i|0)>(k|0);m=e*3|0;o=f[a+16>>2]|0;p=f[f[a+44>>2]>>2]|0;a=f[b+16>>2]|0;q=f[f[b+44>>2]>>2]|0;b=(i|0)<(g|0);r=0;do{s=o+(Y(p,r)|0)|0;t=a+(Y(q,r)|0)|0;a:do if(c){u=0;do{n[t+(u<<2)>>2]=+(h[s+u>>0]|0);u=u+1|0}while((u|0)!=(e|0))}else{if(l){u=0;while(1){v=h[s+u>>0]|0;w=h[s+(u+e)>>0]|0;if(b){x=v;y=i;while(1){z=(h[s+(y+u)>>0]|0)+x|0;y=y+e|0;if((y|0)>=(g|0)){A=z;break}else x=z}}else A=v;n[t+(u<<2)>>2]=+(A+w|0);u=u+1|0;if((u|0)==(e|0))break a}}else B=0;do{u=h[s+(B+e)>>0]|0;x=h[s+B>>0]|0;y=i;do{z=y+B|0;x=(h[s+z>>0]|0)+x+(h[s+(z+i)>>0]|0)|0;u=(h[s+(z+e)>>0]|0)+u+(h[s+(z+m)>>0]|0)|0;y=y+j|0}while((y|0)<=(k|0));if((y|0)<(g|0)){w=x;v=y;while(1){z=(h[s+(v+B)>>0]|0)+w|0;v=v+e|0;if((v|0)>=(g|0)){C=z;break}else w=z}}else C=x;n[t+(B<<2)>>2]=+(C+u|0);B=B+1|0}while((B|0)!=(e|0))}while(0);r=r+1|0}while((r|0)!=(d|0));return}function xN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=f[a+40>>2]|0;d=f[c>>2]|0;e=((f[a>>2]|0)>>>3&511)+1|0;g=Y(e,f[c+4>>2]|0)|0;if((d|0)<=0)return;c=(g|0)==(e|0);i=e<<1;j=e<<2;k=g-j|0;l=(i|0)>(k|0);m=e*3|0;n=f[a+16>>2]|0;o=f[a+44>>2]|0;a=f[b+16>>2]|0;p=f[b+44>>2]|0;b=(i|0)<(g|0);q=0;do{r=n+(Y(f[o>>2]|0,q)|0)|0;s=a+(Y(f[p>>2]|0,q)|0)|0;a:do if(c){t=0;do{f[s+(t<<2)>>2]=h[r+t>>0];t=t+1|0}while((t|0)!=(e|0))}else{if(l){t=0;while(1){u=h[r+t>>0]|0;v=h[r+(t+e)>>0]|0;if(b){w=u;x=i;while(1){y=(h[r+(x+t)>>0]|0)+w|0;x=x+e|0;if((x|0)>=(g|0)){z=y;break}else w=y}}else z=u;f[s+(t<<2)>>2]=z+v;t=t+1|0;if((t|0)==(e|0))break a}}else A=0;do{t=h[r+(A+e)>>0]|0;w=h[r+A>>0]|0;x=i;do{y=x+A|0;w=(h[r+y>>0]|0)+w+(h[r+(y+i)>>0]|0)|0;t=(h[r+(y+e)>>0]|0)+t+(h[r+(y+m)>>0]|0)|0;x=x+j|0}while((x|0)<=(k|0));if((x|0)<(g|0)){v=w;u=x;while(1){y=(h[r+(u+A)>>0]|0)+v|0;u=u+e|0;if((u|0)>=(g|0)){B=y;break}else v=y}}else B=w;f[s+(A<<2)>>2]=B+t;A=A+1|0}while((A|0)!=(e|0))}while(0);q=q+1|0}while((q|0)!=(d|0));return}function yN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){j=N5b(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{f[k+(m<<2)>>2]=f[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=b;p=m;while(1){o=o+(l<<2)|0;if(a){q=0;do{r=k+(q<<2)|0;s=+n[r>>2];t=+n[o+(q<<2)>>2];n[r>>2]=t<s?t:s;q=q+1|0}while((q|0)!=(h|0))}p=p+-1|0;if(!p)break a}}p=h&-4;o=(p|0)<(h|0);q=b;r=m;do{q=q+(l<<2)|0;v=0;do{w=k+(v<<2)|0;s=+n[w>>2];t=+n[q+(v<<2)>>2];x=v|1;y=k+(x<<2)|0;z=+n[y>>2];A=+n[q+(x<<2)>>2];n[w>>2]=t<s?t:s;n[y>>2]=A<z?A:z;y=v|2;w=k+(y<<2)|0;z=+n[w>>2];A=+n[q+(y<<2)>>2];y=v|3;x=k+(y<<2)|0;s=+n[x>>2];t=+n[q+(y<<2)>>2];n[w>>2]=A<z?A:z;n[x>>2]=t<s?t:s;v=v+4|0}while((v|0)<=(g|0));if(o){v=p;do{x=k+(v<<2)|0;s=+n[x>>2];t=+n[q+(v<<2)>>2];n[x>>2]=t<s?t:s;v=v+1|0}while((v|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[j+(a<<2)>>2]=f[k+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}P5b(k);f[d>>2]=e;f[i>>2]=264;u=c;return}function zN(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=N5b(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[o+(q<<1)>>1]|0;d[r>>1]=t<<16>>16<s<<16>>16?t:s;q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;s=n;do{q=q+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[q+(x<<1)>>1]|0;d[r>>1]=w<<16>>16<v<<16>>16?w:v;d[y>>1]=A<<16>>16<z<<16>>16?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[q+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[q+(z<<1)>>1]|0;d[A>>1]=v<<16>>16<y<<16>>16?v:y;d[w>>1]=x<<16>>16<r<<16>>16?x:r;t=t+4|0}while((t|0)<=(h|0));if(o){t=p;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;d[r>>1]=w<<16>>16<x<<16>>16?w:x;t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}P5b(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function AN(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=N5b(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[o+(q<<1)>>1]|0;d[r>>1]=(t&65535)<(s&65535)?t:s;q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;s=n;do{q=q+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[q+(x<<1)>>1]|0;d[r>>1]=(w&65535)<(v&65535)?w:v;d[y>>1]=(A&65535)<(z&65535)?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[q+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[q+(z<<1)>>1]|0;d[A>>1]=(v&65535)<(y&65535)?v:y;d[w>>1]=(x&65535)<(r&65535)?x:r;t=t+4|0}while((t|0)<=(h|0));if(o){t=p;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;d[r>>1]=(w&65535)<(x&65535)?w:x;t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}P5b(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function BN(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+1040|0;e=d;g=f[a+40>>2]|0;i=f[g>>2]|0;j=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;k=e+4|0;f[k>>2]=j;if(j>>>0>1032){l=N5b(j)|0;f[e>>2]=l;m=l}else m=g;l=f[c+16>>2]|0;c=f[a+16>>2]|0;n=f[a+48>>2]|0;a=(j|0)>0;if(a){o=0;do{b[m+o>>0]=b[c+o>>0]|0;o=o+1|0}while((o|0)!=(j|0))}o=i+-1|0;a:do if(o|0){i=j+-4|0;if((j|0)<4){p=c;q=o;while(1){p=p+n|0;if(a){r=0;do{s=m+r|0;t=h[s>>0]|0;b[s>>0]=t-(h[195981+((t|256)-(h[p+r>>0]|0))>>0]|0);r=r+1|0}while((r|0)!=(j|0))}q=q+-1|0;if(!q)break a}}q=j&-4;p=(q|0)<(j|0);r=c;t=o;do{r=r+n|0;s=0;do{v=m+s|0;w=h[v>>0]|0;x=s|1;y=m+x|0;z=h[y>>0]|0;A=z-(h[195981+((z|256)-(h[r+x>>0]|0))>>0]|0)&255;b[v>>0]=w-(h[195981+((w|256)-(h[r+s>>0]|0))>>0]|0);b[y>>0]=A;A=s|2;y=m+A|0;w=h[y>>0]|0;v=s|3;x=m+v|0;z=h[x>>0]|0;B=z-(h[195981+((z|256)-(h[r+v>>0]|0))>>0]|0)&255;b[y>>0]=w-(h[195981+((w|256)-(h[r+A>>0]|0))>>0]|0);b[x>>0]=B;s=s+4|0}while((s|0)<=(i|0));if(p){s=q;do{B=m+s|0;x=h[B>>0]|0;b[B>>0]=x-(h[195981+((x|256)-(h[r+s>>0]|0))>>0]|0);s=s+1|0}while((s|0)!=(j|0))}t=t+-1|0}while((t|0)!=0)}while(0);if(a){a=0;do{b[l+a>>0]=b[m+a>>0]|0;a=a+1|0}while((a|0)!=(j|0));C=f[e>>2]|0}else C=m;if((C|0)==(g|0)){u=d;return}if(C|0)P5b(C);f[e>>2]=g;f[k>>2]=1032;u=d;return}function CN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){j=N5b(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{f[k+(m<<2)>>2]=f[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=b;p=m;while(1){o=o+(l<<2)|0;if(a){q=0;do{r=k+(q<<2)|0;s=+n[r>>2];t=+n[o+(q<<2)>>2];n[r>>2]=s<t?t:s;q=q+1|0}while((q|0)!=(h|0))}p=p+-1|0;if(!p)break a}}p=h&-4;o=(p|0)<(h|0);q=b;r=m;do{q=q+(l<<2)|0;v=0;do{w=k+(v<<2)|0;s=+n[w>>2];t=+n[q+(v<<2)>>2];x=v|1;y=k+(x<<2)|0;z=+n[y>>2];A=+n[q+(x<<2)>>2];n[w>>2]=s<t?t:s;n[y>>2]=z<A?A:z;y=v|2;w=k+(y<<2)|0;z=+n[w>>2];A=+n[q+(y<<2)>>2];y=v|3;x=k+(y<<2)|0;s=+n[x>>2];t=+n[q+(y<<2)>>2];n[w>>2]=z<A?A:z;n[x>>2]=s<t?t:s;v=v+4|0}while((v|0)<=(g|0));if(o){v=p;do{x=k+(v<<2)|0;s=+n[x>>2];t=+n[q+(v<<2)>>2];n[x>>2]=s<t?t:s;v=v+1|0}while((v|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[j+(a<<2)>>2]=f[k+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}P5b(k);f[d>>2]=e;f[i>>2]=264;u=c;return}function DN(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=N5b(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[o+(q<<1)>>1]|0;d[r>>1]=s<<16>>16<t<<16>>16?t:s;q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;s=n;do{q=q+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[q+(x<<1)>>1]|0;d[r>>1]=v<<16>>16<w<<16>>16?w:v;d[y>>1]=z<<16>>16<A<<16>>16?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[q+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[q+(z<<1)>>1]|0;d[A>>1]=y<<16>>16<v<<16>>16?v:y;d[w>>1]=r<<16>>16<x<<16>>16?x:r;t=t+4|0}while((t|0)<=(h|0));if(o){t=p;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;d[r>>1]=x<<16>>16<w<<16>>16?w:x;t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}P5b(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function EN(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+1056|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>520){k=N5b(i>>>0>2147483647?-1:i<<1)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{d[l+(n<<1)>>1]=d[b+(n<<1)>>1]|0;n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+(m<<1)|0;if(a){q=0;do{r=l+(q<<1)|0;s=d[r>>1]|0;t=d[o+(q<<1)>>1]|0;d[r>>1]=(s&65535)<(t&65535)?t:s;q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;s=n;do{q=q+(m<<1)|0;t=0;do{r=l+(t<<1)|0;v=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;x=t|1;y=l+(x<<1)|0;z=d[y>>1]|0;A=d[q+(x<<1)>>1]|0;d[r>>1]=(v&65535)<(w&65535)?w:v;d[y>>1]=(z&65535)<(A&65535)?A:z;z=t|2;A=l+(z<<1)|0;y=d[A>>1]|0;v=d[q+(z<<1)>>1]|0;z=t|3;w=l+(z<<1)|0;r=d[w>>1]|0;x=d[q+(z<<1)>>1]|0;d[A>>1]=(y&65535)<(v&65535)?v:y;d[w>>1]=(r&65535)<(x&65535)?x:r;t=t+4|0}while((t|0)<=(h|0));if(o){t=p;do{r=l+(t<<1)|0;x=d[r>>1]|0;w=d[q+(t<<1)>>1]|0;d[r>>1]=(x&65535)<(w&65535)?w:x;t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{d[k+(a<<1)>>1]=d[l+(a<<1)>>1]|0;a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}P5b(l);f[e>>2]=g;f[j>>2]=520;u=c;return}function FN(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+1040|0;e=d;g=f[a+40>>2]|0;i=f[g>>2]|0;j=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;k=e+4|0;f[k>>2]=j;if(j>>>0>1032){l=N5b(j)|0;f[e>>2]=l;m=l}else m=g;l=f[c+16>>2]|0;c=f[a+16>>2]|0;n=f[a+48>>2]|0;a=(j|0)>0;if(a){o=0;do{b[m+o>>0]=b[c+o>>0]|0;o=o+1|0}while((o|0)!=(j|0))}o=i+-1|0;a:do if(o|0){i=j+-4|0;if((j|0)<4){p=c;q=o;while(1){p=p+n|0;if(a){r=0;do{s=m+r|0;t=h[s>>0]|0;b[s>>0]=(h[195981+(256-t+(h[p+r>>0]|0))>>0]|0)+t;r=r+1|0}while((r|0)!=(j|0))}q=q+-1|0;if(!q)break a}}q=j&-4;p=(q|0)<(j|0);r=c;t=o;do{r=r+n|0;s=0;do{v=m+s|0;w=h[v>>0]|0;x=s|1;y=m+x|0;z=h[y>>0]|0;A=(h[195981+(256-z+(h[r+x>>0]|0))>>0]|0)+z&255;b[v>>0]=(h[195981+(256-w+(h[r+s>>0]|0))>>0]|0)+w;b[y>>0]=A;A=s|2;y=m+A|0;w=h[y>>0]|0;v=s|3;z=m+v|0;x=h[z>>0]|0;B=(h[195981+(256-x+(h[r+v>>0]|0))>>0]|0)+x&255;b[y>>0]=(h[195981+(256-w+(h[r+A>>0]|0))>>0]|0)+w;b[z>>0]=B;s=s+4|0}while((s|0)<=(i|0));if(p){s=q;do{B=m+s|0;z=h[B>>0]|0;b[B>>0]=(h[195981+(256-z+(h[r+s>>0]|0))>>0]|0)+z;s=s+1|0}while((s|0)!=(j|0))}t=t+-1|0}while((t|0)!=0)}while(0);if(a){a=0;do{b[l+a>>0]=b[m+a>>0]|0;a=a+1|0}while((a|0)!=(j|0));C=f[e>>2]|0}else C=m;if((C|0)==(g|0)){u=d;return}if(C|0)P5b(C);f[e>>2]=g;f[k>>2]=1032;u=d;return}function GN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){j=N5b(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{p[k+(m<<3)>>3]=+n[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=b;q=m;while(1){o=o+(l<<2)|0;if(a){r=0;do{s=k+(r<<3)|0;p[s>>3]=+p[s>>3]+ +n[o+(r<<2)>>2];r=r+1|0}while((r|0)!=(h|0))}q=q+-1|0;if(!q)break a}}q=h&-4;o=(q|0)<(h|0);r=b;s=m;do{r=r+(l<<2)|0;t=0;do{v=k+(t<<3)|0;w=t|1;x=k+(w<<3)|0;y=+p[x>>3]+ +n[r+(w<<2)>>2];p[v>>3]=+p[v>>3]+ +n[r+(t<<2)>>2];p[x>>3]=y;x=t|2;v=k+(x<<3)|0;w=t|3;z=k+(w<<3)|0;y=+p[z>>3]+ +n[r+(w<<2)>>2];p[v>>3]=+p[v>>3]+ +n[r+(x<<2)>>2];p[z>>3]=y;t=t+4|0}while((t|0)<=(g|0));if(o){t=q;do{z=k+(t<<3)|0;p[z>>3]=+p[z>>3]+ +n[r+(t<<2)>>2];t=t+1|0}while((t|0)!=(h|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{p[j+(a<<3)>>3]=+p[k+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}P5b(k);f[d>>2]=e;f[i>>2]=136;u=c;return}function HN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){j=N5b(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=j;k=j}else k=e;j=f[b+16>>2]|0;b=f[a+16>>2]|0;l=(f[a+48>>2]|0)>>>2;a=(h|0)>0;if(a){m=0;do{f[k+(m<<2)>>2]=f[b+(m<<2)>>2];m=m+1|0}while((m|0)!=(h|0))}m=g+-1|0;a:do if(m|0){g=h+-4|0;if((h|0)<4){o=b;p=m;while(1){o=o+(l<<2)|0;if(a){q=0;do{r=k+(q<<2)|0;n[r>>2]=+n[r>>2]+ +n[o+(q<<2)>>2];q=q+1|0}while((q|0)!=(h|0))}p=p+-1|0;if(!p)break a}}p=h&-4;o=(p|0)<(h|0);q=b;r=m;do{q=q+(l<<2)|0;s=0;do{t=k+(s<<2)|0;v=s|1;w=k+(v<<2)|0;x=+n[w>>2]+ +n[q+(v<<2)>>2];n[t>>2]=+n[t>>2]+ +n[q+(s<<2)>>2];n[w>>2]=x;w=s|2;t=k+(w<<2)|0;v=s|3;y=k+(v<<2)|0;x=+n[y>>2]+ +n[q+(v<<2)>>2];n[t>>2]=+n[t>>2]+ +n[q+(w<<2)>>2];n[y>>2]=x;s=s+4|0}while((s|0)<=(g|0));if(o){s=p;do{y=k+(s<<2)|0;n[y>>2]=+n[y>>2]+ +n[q+(s<<2)>>2];s=s+1|0}while((s|0)!=(h|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[j+(a<<2)>>2]=f[k+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((k|0)==(e|0)){u=c;return}P5b(k);f[d>>2]=e;f[i>>2]=264;u=c;return}function IN(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1104|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>136){k=N5b(i>>>0>536870911?-1:i<<3)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){n=0;do{p[l+(n<<3)>>3]=+(d[b+(n<<1)>>1]|0);n=n+1|0}while((n|0)!=(i|0))}n=h+-1|0;a:do if(n|0){h=i+-4|0;if((i|0)<4){o=b;q=n;while(1){o=o+(m<<1)|0;if(a){r=0;do{s=l+(r<<3)|0;p[s>>3]=+p[s>>3]+ +(d[o+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(i|0))}q=q+-1|0;if(!q)break a}}q=i&-4;o=(q|0)<(i|0);r=b;s=n;do{r=r+(m<<1)|0;t=0;do{v=l+(t<<3)|0;w=t|1;x=l+(w<<3)|0;y=+p[x>>3]+ +(d[r+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(d[r+(t<<1)>>1]|0);p[x>>3]=y;x=t|2;v=l+(x<<3)|0;w=t|3;z=l+(w<<3)|0;y=+p[z>>3]+ +(d[r+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(d[r+(x<<1)>>1]|0);p[z>>3]=y;t=t+4|0}while((t|0)<=(h|0));if(o){t=q;do{z=l+(t<<3)|0;p[z>>3]=+p[z>>3]+ +(d[r+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{p[k+(a<<3)>>3]=+p[l+(a<<3)>>3];a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}P5b(l);f[e>>2]=g;f[j>>2]=136;u=c;return}function JN(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1072|0;e=c;g=f[a+40>>2]|0;h=f[g>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[g+4>>2]|0)|0;g=e+8|0;f[e>>2]=g;j=e+4|0;f[j>>2]=i;if(i>>>0>264){k=N5b(i>>>0>1073741823?-1:i<<2)|0;f[e>>2]=k;l=k}else l=g;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(i|0)>0;if(a){o=0;do{n[l+(o<<2)>>2]=+(d[b+(o<<1)>>1]|0);o=o+1|0}while((o|0)!=(i|0))}o=h+-1|0;a:do if(o|0){h=i+-4|0;if((i|0)<4){p=b;q=o;while(1){p=p+(m<<1)|0;if(a){r=0;do{s=l+(r<<2)|0;n[s>>2]=+n[s>>2]+ +(d[p+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(i|0))}q=q+-1|0;if(!q)break a}}q=i&-4;p=(q|0)<(i|0);r=b;s=o;do{r=r+(m<<1)|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=+n[x>>2]+ +(d[r+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(d[r+(t<<1)>>1]|0);n[x>>2]=y;x=t|2;v=l+(x<<2)|0;w=t|3;z=l+(w<<2)|0;y=+n[z>>2]+ +(d[r+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(d[r+(x<<1)>>1]|0);n[z>>2]=y;t=t+4|0}while((t|0)<=(h|0));if(p){t=q;do{z=l+(t<<2)|0;n[z>>2]=+n[z>>2]+ +(d[r+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{f[k+(a<<2)>>2]=f[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(g|0)){u=c;return}P5b(l);f[e>>2]=g;f[j>>2]=264;u=c;return}function KN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1104|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>136){k=N5b(h>>>0>536870911?-1:h<<3)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(h|0)>0;if(a){n=0;do{p[l+(n<<3)>>3]=+(j[b+(n<<1)>>1]|0);n=n+1|0}while((n|0)!=(h|0))}n=g+-1|0;a:do if(n|0){g=h+-4|0;if((h|0)<4){o=b;q=n;while(1){o=o+(m<<1)|0;if(a){r=0;do{s=l+(r<<3)|0;p[s>>3]=+p[s>>3]+ +(j[o+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(h|0))}q=q+-1|0;if(!q)break a}}q=h&-4;o=(q|0)<(h|0);r=b;s=n;do{r=r+(m<<1)|0;t=0;do{v=l+(t<<3)|0;w=t|1;x=l+(w<<3)|0;y=+p[x>>3]+ +(j[r+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(j[r+(t<<1)>>1]|0);p[x>>3]=y;x=t|2;v=l+(x<<3)|0;w=t|3;z=l+(w<<3)|0;y=+p[z>>3]+ +(j[r+(w<<1)>>1]|0);p[v>>3]=+p[v>>3]+ +(j[r+(x<<1)>>1]|0);p[z>>3]=y;t=t+4|0}while((t|0)<=(g|0));if(o){t=q;do{z=l+(t<<3)|0;p[z>>3]=+p[z>>3]+ +(j[r+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(h|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{p[k+(a<<3)>>3]=+p[l+(a<<3)>>3];a=a+1|0}while((a|0)!=(h|0))}if((l|0)==(e|0)){u=c;return}P5b(l);f[d>>2]=e;f[i>>2]=136;u=c;return}function LN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;h=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;i=d+4|0;f[i>>2]=h;if(h>>>0>264){k=N5b(h>>>0>1073741823?-1:h<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=(f[a+48>>2]|0)>>>1;a=(h|0)>0;if(a){o=0;do{n[l+(o<<2)>>2]=+(j[b+(o<<1)>>1]|0);o=o+1|0}while((o|0)!=(h|0))}o=g+-1|0;a:do if(o|0){g=h+-4|0;if((h|0)<4){p=b;q=o;while(1){p=p+(m<<1)|0;if(a){r=0;do{s=l+(r<<2)|0;n[s>>2]=+n[s>>2]+ +(j[p+(r<<1)>>1]|0);r=r+1|0}while((r|0)!=(h|0))}q=q+-1|0;if(!q)break a}}q=h&-4;p=(q|0)<(h|0);r=b;s=o;do{r=r+(m<<1)|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=+n[x>>2]+ +(j[r+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(j[r+(t<<1)>>1]|0);n[x>>2]=y;x=t|2;v=l+(x<<2)|0;w=t|3;z=l+(w<<2)|0;y=+n[z>>2]+ +(j[r+(w<<1)>>1]|0);n[v>>2]=+n[v>>2]+ +(j[r+(x<<1)>>1]|0);n[z>>2]=y;t=t+4|0}while((t|0)<=(g|0));if(p){t=q;do{z=l+(t<<2)|0;n[z>>2]=+n[z>>2]+ +(j[r+(t<<1)>>1]|0);t=t+1|0}while((t|0)!=(h|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{f[k+(a<<2)>>2]=f[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(h|0))}if((l|0)==(e|0)){u=c;return}P5b(l);f[d>>2]=e;f[i>>2]=264;u=c;return}function MN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;j=d+4|0;f[j>>2]=i;if(i>>>0>264){k=N5b(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=f[a+48>>2]|0;a=(i|0)>0;if(a){n=0;do{f[l+(n<<2)>>2]=h[b+n>>0];n=n+1|0}while((n|0)!=(i|0))}n=g+-1|0;a:do if(n|0){g=i+-4|0;if((i|0)<4){o=b;q=n;while(1){o=o+m|0;if(a){r=0;do{s=l+(r<<2)|0;f[s>>2]=(h[o+r>>0]|0)+(f[s>>2]|0);r=r+1|0}while((r|0)!=(i|0))}q=q+-1|0;if(!q)break a}}q=i&-4;o=(q|0)<(i|0);r=b;s=n;do{r=r+m|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=(h[r+w>>0]|0)+(f[x>>2]|0)|0;f[v>>2]=(h[r+t>>0]|0)+(f[v>>2]|0);f[x>>2]=y;y=t|2;x=l+(y<<2)|0;v=t|3;w=l+(v<<2)|0;z=(h[r+v>>0]|0)+(f[w>>2]|0)|0;f[x>>2]=(h[r+y>>0]|0)+(f[x>>2]|0);f[w>>2]=z;t=t+4|0}while((t|0)<=(g|0));if(o){t=q;do{z=l+(t<<2)|0;f[z>>2]=(h[r+t>>0]|0)+(f[z>>2]|0);t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{p[k+(a<<3)>>3]=+(f[l+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(e|0)){u=c;return}P5b(l);f[d>>2]=e;f[j>>2]=264;u=c;return}function NN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;j=d+4|0;f[j>>2]=i;if(i>>>0>264){k=N5b(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=f[a+48>>2]|0;a=(i|0)>0;if(a){o=0;do{f[l+(o<<2)>>2]=h[b+o>>0];o=o+1|0}while((o|0)!=(i|0))}o=g+-1|0;a:do if(o|0){g=i+-4|0;if((i|0)<4){p=b;q=o;while(1){p=p+m|0;if(a){r=0;do{s=l+(r<<2)|0;f[s>>2]=(h[p+r>>0]|0)+(f[s>>2]|0);r=r+1|0}while((r|0)!=(i|0))}q=q+-1|0;if(!q)break a}}q=i&-4;p=(q|0)<(i|0);r=b;s=o;do{r=r+m|0;t=0;do{v=l+(t<<2)|0;w=t|1;x=l+(w<<2)|0;y=(h[r+w>>0]|0)+(f[x>>2]|0)|0;f[v>>2]=(h[r+t>>0]|0)+(f[v>>2]|0);f[x>>2]=y;y=t|2;x=l+(y<<2)|0;v=t|3;w=l+(v<<2)|0;z=(h[r+v>>0]|0)+(f[w>>2]|0)|0;f[x>>2]=(h[r+y>>0]|0)+(f[x>>2]|0);f[w>>2]=z;t=t+4|0}while((t|0)<=(g|0));if(p){t=q;do{z=l+(t<<2)|0;f[z>>2]=(h[r+t>>0]|0)+(f[z>>2]|0);t=t+1|0}while((t|0)!=(i|0))}s=s+-1|0}while((s|0)!=0)}while(0);if(a){a=0;do{n[k+(a<<2)>>2]=+(f[l+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(e|0)){u=c;return}P5b(l);f[d>>2]=e;f[j>>2]=264;u=c;return}function ON(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+1072|0;d=c;e=f[a+40>>2]|0;g=f[e>>2]|0;i=Y(((f[a>>2]|0)>>>3&511)+1|0,f[e+4>>2]|0)|0;e=d+8|0;f[d>>2]=e;j=d+4|0;f[j>>2]=i;if(i>>>0>264){k=N5b(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=k;l=k}else l=e;k=f[b+16>>2]|0;b=f[a+16>>2]|0;m=f[a+48>>2]|0;a=(i|0)>0;if(a){n=0;do{f[l+(n<<2)>>2]=h[b+n>>0];n=n+1|0}while((n|0)!=(i|0))}n=g+-1|0;a:do if(n|0){g=i+-4|0;if((i|0)<4){o=b;p=n;while(1){o=o+m|0;if(a){q=0;do{r=l+(q<<2)|0;f[r>>2]=(h[o+q>>0]|0)+(f[r>>2]|0);q=q+1|0}while((q|0)!=(i|0))}p=p+-1|0;if(!p)break a}}p=i&-4;o=(p|0)<(i|0);q=b;r=n;do{q=q+m|0;s=0;do{t=l+(s<<2)|0;v=s|1;w=l+(v<<2)|0;x=(h[q+v>>0]|0)+(f[w>>2]|0)|0;f[t>>2]=(h[q+s>>0]|0)+(f[t>>2]|0);f[w>>2]=x;x=s|2;w=l+(x<<2)|0;t=s|3;v=l+(t<<2)|0;y=(h[q+t>>0]|0)+(f[v>>2]|0)|0;f[w>>2]=(h[q+x>>0]|0)+(f[w>>2]|0);f[v>>2]=y;s=s+4|0}while((s|0)<=(g|0));if(o){s=p;do{y=l+(s<<2)|0;f[y>>2]=(h[q+s>>0]|0)+(f[y>>2]|0);s=s+1|0}while((s|0)!=(i|0))}r=r+-1|0}while((r|0)!=0)}while(0);if(a){a=0;do{f[k+(a<<2)>>2]=f[l+(a<<2)>>2];a=a+1|0}while((a|0)!=(i|0))}if((l|0)==(e|0)){u=c;return}P5b(l);f[d>>2]=e;f[j>>2]=264;u=c;return}function PN(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=f[e>>2]|0;j=f[e+4>>2]|0;if((i|0)!=(j|0)){XL(a,c,d,j-i>>2,i);u=g;return}i=c+16|0;j=f[i>>2]|0;d=j;e=c+4|0;if(j){j=f[e>>2]|0;if((j|0)<3)k=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{l=f[c+40>>2]|0;m=0;n=1;while(1){o=Y(f[l+(m<<2)>>2]|0,n)|0;m=m+1|0;if((m|0)==(j|0)){k=o;break}else n=o}}if(!((j|0)==0|(k|0)==0)){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,7)|0;b[k>>0]=b[184269]|0;b[k+1>>0]=b[184270]|0;b[k+2>>0]=b[184271]|0;b[k+3>>0]=b[184272]|0;b[k+4>>0]=b[184273]|0;b[k+5>>0]=b[184274]|0;b[k+6>>0]=b[184275]|0;bO(-215,h,181862,179056,4776);bD(h);p=f[i>>2]|0}else p=d}else p=d;f[a>>2]=f[c>>2];d=a+4|0;i=f[e>>2]|0;f[d>>2]=i;h=a+8|0;f[h>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=p;f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];p=f[c+36>>2]|0;f[a+36>>2]=p;k=a+40|0;f[k>>2]=h;h=a+48|0;j=a+44|0;f[j>>2]=h;f[h>>2]=0;f[a+52>>2]=0;if(!p)q=i;else{i=p+12|0;f[i>>2]=(f[i>>2]|0)+1;q=f[e>>2]|0}if((q|0)<3){e=f[c+44>>2]|0;i=f[j>>2]|0;f[i>>2]=f[e>>2];f[i+4>>2]=f[e+4>>2];u=g;return}f[d>>2]=0;YK(a,q,0,0,0);if((f[d>>2]|0)<=0){u=g;return}q=f[c+40>>2]|0;a=f[k>>2]|0;k=f[c+44>>2]|0;c=f[j>>2]|0;j=0;do{f[a+(j<<2)>>2]=f[q+(j<<2)>>2];f[c+(j<<2)>>2]=f[k+(j<<2)>>2];j=j+1|0}while((j|0)<(f[d>>2]|0));u=g;return}function QN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;_K(a,b,c,0,d);return}function RN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;_K(a,b,0,c,d);return}function SN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=f[a>>2]|0;if(f[d>>2]&16384|0){e=a+12|0;g=a+8|0;h=(f[(c?g:e)>>2]|0)+(Y(f[a+4>>2]|0,b)|0)|0;f[g>>2]=h;i=f[e>>2]|0;if(h>>>0<i>>>0){f[g>>2]=i;return}i=f[a+16>>2]|0;if(h>>>0<=i>>>0)return;f[g>>2]=i;return}i=f[d+4>>2]|0;if((i|0)==2){if(c){g=f[d+16>>2]|0;h=(f[a+8>>2]|0)-g|0;e=f[f[d+44>>2]>>2]|0;j=(h>>>0)/(e>>>0)|0;k=f[d+12>>2]|0;l=Y(k,j)|0;m=h-(Y(j,e)|0)|0;j=a+4|0;h=f[j>>2]|0;n=l+b+((m>>>0)/(h>>>0)|0)|0;o=j;p=k;q=e;r=g;s=h}else{h=a+4|0;n=b;o=h;p=f[d+12>>2]|0;q=f[f[d+44>>2]>>2]|0;r=f[d+16>>2]|0;s=f[h>>2]|0}h=(n|0)/(p|0)|0;g=(h|0)<0;e=f[d+8>>2]|0;k=e+-1|0;j=g?0:h;m=r+(Y(q,(k|0)<(j|0)?k:j)|0)|0;f[a+12>>2]=m;j=m+(Y(s,p)|0)|0;f[a+16>>2]=j;if(!g)if((h|0)<(e|0)){e=n-(Y(p,h)|0)|0;t=m+(Y(e,f[o>>2]|0)|0)|0}else t=j;else t=m;f[a+8>>2]=t;return}if(c){if((i|0)>0){c=f[d+44>>2]|0;t=f[d+40>>2]|0;m=(f[a+8>>2]|0)-(f[d+16>>2]|0)|0;j=0;o=0;while(1){e=f[c+(o<<2)>>2]|0;h=(m>>>0)/(e>>>0)|0;m=m-(Y(h,e)|0)|0;e=(Y(f[t+(o<<2)>>2]|0,j)|0)+h|0;o=o+1|0;if((o|0)==(i|0)){u=e;break}else j=e}}else u=0;v=u+b|0}else v=b;b=(v|0)>0?v:0;v=f[d+40>>2]|0;u=f[v+(i+-1<<2)>>2]|0;j=(b|0)/(u|0)|0;o=b-(Y(j,u)|0)|0;b=f[d+16>>2]|0;t=f[a+4>>2]|0;m=Y(o,t)|0;o=a+8|0;f[o>>2]=b+m;c=a+12|0;f[c>>2]=b;e=i+-2|0;if((e|0)>-1){i=f[d+44>>2]|0;d=e;e=j;h=b;while(1){p=f[v+(d<<2)>>2]|0;n=e;e=(e|0)/(p|0)|0;g=n-(Y(e,p)|0)|0;h=h+(Y(g,f[i+(d<<2)>>2]|0)|0)|0;if((d|0)<=0)break;else d=d+-1|0}f[c>>2]=h;w=e;x=h}else{w=j;x=b}b=x+(Y(t,u)|0)|0;f[a+16>>2]=b;f[o>>2]=(w|0)>0?b:x+m|0;return}function TN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=f[a>>2]|0;e=f[d+4>>2]|0;do if(b){if((e|0)==2){g=Y(f[(f[d+40>>2]|0)+4>>2]|0,f[b>>2]|0)|0;h=g+(f[b+4>>2]|0)|0;break}if((e|0)>0){g=f[d+40>>2]|0;i=0;j=0;while(1){k=Y(f[g+(j<<2)>>2]|0,i)|0;l=k+(f[b+(j<<2)>>2]|0)|0;j=j+1|0;if((j|0)==(e|0)){h=l;break}else i=l}}else h=0}else h=0;while(0);SN(a,h,c);return}function UN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){Nac(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)c4b(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;Nac(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)Vac(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;O5b(h);return}function VN(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0,k=0.0;c=+n[a+16>>2]*3.141592653589793/180.0;d=+O(+c)*.5;e=+P(+c)*.5;c=+n[a+12>>2];f=e*c;g=+n[a+8>>2];h=d*g;i=+n[a>>2]-f-h;n[b>>2]=i;j=a+4|0;k=d*c;c=e*g;g=k+ +n[j>>2]-c;n[b+4>>2]=g;e=f+ +n[a>>2]-h;n[b+8>>2]=e;h=+n[j>>2]-k-c;n[b+12>>2]=h;n[b+16>>2]=+n[a>>2]*2.0-i;n[b+20>>2]=+n[j>>2]*2.0-g;n[b+24>>2]=+n[a>>2]*2.0-e;n[b+28>>2]=+n[j>>2]*2.0-h;return}function WN(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0,p=0,q=0;c=+n[b+16>>2]*3.141592653589793/180.0;d=+O(+c)*.5;e=+P(+c)*.5;c=+n[b>>2];g=+n[b+12>>2];h=e*g;i=+n[b+8>>2];j=d*i;k=c-h-j;l=+n[b+4>>2];m=d*g;g=e*i;i=m+l-g;e=h+c-j;j=l-m-g;g=c*2.0;c=g-k;m=l*2.0;l=m-i;h=g-e;g=m-j;m=e<k?e:k;d=c<m?c:m;m=h<d?h:d;b=~~m;o=b-(+(b|0)>m&1)|0;m=j<i?j:i;d=l<m?l:m;m=g<d?g:d;b=~~m;p=b-(+(b|0)>m&1)|0;m=k<e?e:k;k=m<c?c:m;m=k<h?h:k;b=~~m;k=i<j?j:i;i=k<l?l:k;k=i<g?g:i;q=~~k;f[a>>2]=o;f[a+4>>2]=p;f[a+8>>2]=(+(b|0)<m&1)+b+1-o;f[a+12>>2]=1-p+((+(q|0)<k&1)+q);return}function XN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=u;u=u+48|0;d=c+16|0;e=c+12|0;g=c+8|0;h=c+4|0;i=c;j=+n[b+16>>2]*3.141592653589793/180.0;k=+O(+j)*.5;l=+P(+j)*.5;j=+n[b>>2];m=+n[b+12>>2];o=l*m;p=+n[b+8>>2];q=k*p;r=j-o-q;n[d>>2]=r;t=+n[b+4>>2];v=k*m;m=l*p;p=v+t-m;b=d+4|0;n[b>>2]=p;l=o+j-q;w=d+8|0;n[w>>2]=l;q=t-v-m;x=d+12|0;n[x>>2]=q;m=j*2.0;j=m-r;y=d+16|0;n[y>>2]=j;v=t*2.0;t=v-p;z=d+20|0;n[z>>2]=t;o=m-l;A=d+24|0;n[A>>2]=o;m=v-q;B=d+28|0;n[B>>2]=m;C=l<r?w:d;D=j<+n[C>>2]?y:C;C=f[(o<+n[D>>2]?A:D)>>2]|0;D=q<p?x:b;E=t<+n[D>>2]?z:D;D=f[(m<+n[E>>2]?B:E)>>2]|0;f[e>>2]=C;f[g>>2]=D;E=r<l?w:d;d=+n[E>>2]<j?y:E;E=f[(+n[d>>2]<o?A:d)>>2]|0;d=p<q?x:b;b=+n[d>>2]<t?z:d;d=f[(+n[b>>2]<m?B:b)>>2]|0;f[h>>2]=E;f[i>>2]=d;m=(f[s>>2]=E,+n[s>>2]);t=(f[s>>2]=C,+n[s>>2]);C=f[(m<t?h:e)>>2]|0;f[a>>2]=C;q=(f[s>>2]=d,+n[s>>2]);p=(f[s>>2]=D,+n[s>>2]);D=f[(q<p?i:g)>>2]|0;f[a+4>>2]=D;n[a+8>>2]=(t<m?m:t)-(f[s>>2]=C,+n[s>>2]);n[a+12>>2]=(p<q?q:p)-(f[s>>2]=D,+n[s>>2]);u=c;return}function YN(a){a=a|0;f[a>>2]=42900;bD(a+32|0);bD(a+24|0);bD(a+16|0);bD(a+4|0);return}function ZN(a){a=a|0;YN(a);O5b(a);return}function _N(a){a=a|0;var b=0;b=f[a+4>>2]|0;return ((b|0)==0?1124530:b)|0}function $N(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[a>>2]=42920;if((f[a+4>>2]|0)==-1){u=c;return}f[d>>2]=0;f[d+4>>2]=0;a=aD(d,10)|0;e=184293;g=a+10|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));bO(-215,d,184304,184322,1503);bD(d);u=c;return}function aO(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=42920;if((f[a+4>>2]|0)==-1){O5b(a);u=c;return}f[d>>2]=0;f[d+4>>2]=0;e=aD(d,10)|0;g=184293;h=e+10|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-215,d,184304,184322,1503);bD(d);O5b(a);u=c;return}function bO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+64|0;h=g+16|0;i=g+8|0;j=g;f[i>>2]=0;f[i+4>>2]=0;if(c|0?(g=kUb(c)|0,g|0):0)Vac(aD(i,g)|0,c|0,g|0)|0;f[j>>2]=0;f[j+4>>2]=0;if(d|0?(g=kUb(d)|0,g|0):0)Vac(aD(j,g)|0,d|0,g|0)|0;cO(h,a,b,i,j,e);dO(h)}function cO(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;f[a>>2]=42900;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=b;b=f[c>>2]|0;f[a+16>>2]=b;f[a+20>>2]=f[c+4>>2];if(b|0){c=b+-4|0;f[c>>2]=(f[c>>2]|0)+1}c=f[d>>2]|0;f[a+24>>2]=c;f[a+28>>2]=f[d+4>>2];if(c|0){d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[e>>2]|0;f[a+32>>2]=d;f[a+36>>2]=f[e+4>>2];if(!d){h=a+40|0;f[h>>2]=g;gO(a);return}e=d+-4|0;f[e>>2]=(f[e>>2]|0)+1;h=a+40|0;f[h>>2]=g;gO(a);return}function dO(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+4144|0;d=c+32|0;e=c+8|0;g=c;h=c+40|0;c=f[125484]|0;i=f[a+12>>2]|0;if(!c){do switch(i|0){case 0:{j=185218;break}case -1:{j=185208;break}case -2:{j=185190;break}case -3:{j=185175;break}case -4:{j=185155;break}case -5:{j=185142;break}case -7:{j=185115;break}case -8:{j=185100;break}case -201:{j=185070;break}case -27:{j=185057;break}case -202:{j=185031;break}case -13:{j=185011;break}case -203:{j=184976;break}case -204:{j=184945;break}case -17:{j=184898;break}case -205:{j=184858;break}case -209:{j=184820;break}case -211:{j=184779;break}case -210:{j=184734;break}case -24:{j=184707;break}case -15:{j=184684;break}case -206:{j=184644;break}case -207:{j=184614;break}case -208:{j=184588;break}case -212:{j=184574;break}case -213:{j=184534;break}case -214:{j=184502;break}case -215:{j=184485;break}case -216:{j=184469;break}case -217:{j=184456;break}case -218:{j=184438;break}case -219:{j=184422;break}default:{f[g>>2]=(i|0)>-1?184390:184397;f[g+4>>2]=i;_Ub(1119610,184403,g)|0;j=1119610}}while(0);g=f[a+16>>2]|0;if(!(f[a+28>>2]|0))k=185227;else{l=f[a+24>>2]|0;k=(l|0)==0?1124530:l}l=f[a+32>>2]|0;m=f[a+40>>2]|0;f[e>>2]=j;f[e+4>>2]=(g|0)==0?1124530:g;f[e+8>>2]=k;f[e+12>>2]=(l|0)==0?1124530:l;f[e+16>>2]=m;eO(h,4096,185244,e)|0;e=f[35349]|0;f[d>>2]=h;EUb(e,185290,d)|0;AUb(e)|0}else{e=f[a+24>>2]|0;d=f[a+16>>2]|0;h=f[a+32>>2]|0;Xf[c&127](i,(e|0)==0?1124530:e,(d|0)==0?1124530:d,(h|0)==0?1124530:h,f[a+40>>2]|0,f[125485]|0)|0}if(!(b[1119866]|0)){n=ze(44)|0;fO(n,a);If(n|0,10168,22)}f[0]=0;aa();n=ze(44)|0;fO(n,a);If(n|0,10168,22)}function eO(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=mUb(a,b,c,g)|0;u=e;return d|0}function fO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=42900;c=f[b+4>>2]|0;f[a+4>>2]=c;f[a+8>>2]=f[b+8>>2];if(c|0){d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1}f[a+12>>2]=f[b+12>>2];d=f[b+16>>2]|0;f[a+16>>2]=d;f[a+20>>2]=f[b+20>>2];if(d|0){c=d+-4|0;f[c>>2]=(f[c>>2]|0)+1}c=f[b+24>>2]|0;f[a+24>>2]=c;f[a+28>>2]=f[b+28>>2];if(c|0){d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[b+32>>2]|0;f[a+32>>2]=d;f[a+36>>2]=f[b+36>>2];if(!d){e=a+40|0;g=b+40|0;h=f[g>>2]|0;f[e>>2]=h;return}c=d+-4|0;f[c>>2]=(f[c>>2]|0)+1;e=a+40|0;g=b+40|0;h=f[g>>2]|0;f[e>>2]=h;return}function gO(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+48|0;c=b+24|0;d=b;e=b+40|0;if(!(f[a+28>>2]|0)){g=f[a+32>>2]|0;h=f[a+40>>2]|0;i=f[a+12>>2]|0;j=f[a+16>>2]|0;f[c>>2]=(g|0)==0?1124530:g;f[c+4>>2]=h;f[c+8>>2]=i;f[c+12>>2]=(j|0)==0?1124530:j;hO(e,185332,c);c=a+4|0;if((e|0)!=(c|0)){bD(c);j=f[e>>2]|0;if(!j)k=0;else{i=j+-4|0;f[i>>2]=(f[i>>2]|0)+1;k=f[e>>2]|0}f[c>>2]=k;f[a+8>>2]=f[e+4>>2]}bD(e);u=b;return}else{k=f[a+32>>2]|0;c=f[a+40>>2]|0;i=f[a+12>>2]|0;j=f[a+16>>2]|0;h=f[a+24>>2]|0;f[d>>2]=(k|0)==0?1124530:k;f[d+4>>2]=c;f[d+8>>2]=i;f[d+12>>2]=(j|0)==0?1124530:j;f[d+16>>2]=(h|0)==0?1124530:h;hO(e,185294,d);d=a+4|0;if((e|0)!=(d|0)){bD(d);h=f[e>>2]|0;if(!h)l=0;else{j=h+-4|0;f[j>>2]=(f[j>>2]|0)+1;l=f[e>>2]|0}f[d>>2]=l;f[a+8>>2]=f[e+4>>2]}bD(e);u=b;return}}function hO(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+1056|0;g=e+24|0;h=e+8|0;i=e;j=g+8|0;f[g>>2]=j;k=g+4|0;f[k>>2]=1024;l=i+4|0;while(1){f[h>>2]=d;m=f[k>>2]|0;n=mUb(f[g>>2]|0,m,c,h)|0;if((n|0)<=-1){f[i>>2]=0;f[l>>2]=0;o=aD(i,44)|0;p=185355;q=o+44|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,i,213769,184322,809);bD(i)}if((n|0)<(m|0))break;p=n+1|0;o=f[k>>2]|0;if(o>>>0<p>>>0){q=f[g>>2]|0;if(p>>>0>1024)r=N5b(p)|0;else r=j;f[g>>2]=r;f[k>>2]=p;if((o|0)!=0&(r|0)!=(q|0)){b[r>>0]=b[q>>0]|0;if((o|0)!=1){b[r+1>>0]=b[q+1>>0]|0;if((o|0)==2)s=o;else{t=2;do{b[(f[g>>2]|0)+t>>0]=b[q+t>>0]|0;t=t+1|0}while((t|0)!=(o|0));s=o}}else s=1}else s=o;do{b[(f[g>>2]|0)+s>>0]=0;s=s+1|0}while((s|0)!=(p|0));if(!((q|0)==(j|0)|(q|0)==0))P5b(q)}else f[k>>2]=p}b[(f[g>>2]|0)+(m+-1)>>0]=0;m=f[g>>2]|0;f[a>>2]=0;f[a+4>>2]=0;if((n|0)!=0&(m|0)!=0){Vac(aD(a,n)|0,m|0,n|0)|0;v=f[g>>2]|0}else v=m;if((v|0)==(j|0)){u=e;return}if(v|0)P5b(v);f[g>>2]=j;f[k>>2]=1024;u=e;return}function iO(){var a=0;a=jO()|0;f[125483]=a;Nac(1119867,0,255)|0;kO(1119867);Nac(1120123,0,255)|0;return}function jO(){var a=0,b=0,c=0,d=0,e=0;a=u;u=u+16|0;b=a;c=f[125743]|0;if(c|0){d=c;u=a;return d|0}c=L5b(4)|0;e=L5b(32)|0;Ef(b|0)|0;vd(b|0,1)|0;Nf(e|0,b|0)|0;nf(b|0)|0;f[e+28>>2]=1;f[c>>2]=e;f[125743]=c;d=c;u=a;return d|0}function kO(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=c+4|0;if(He(185424)|0){g=f[35349]|0;if((b[491048]|0)==0?Cac(491048)|0:0){f[125486]=0;f[125487]=0;Vac(aD(501944,4453)|0,185443,4453)|0;zd(1459,501944,x|0)|0}h=f[125486]|0;f[d>>2]=(h|0)==0?1124530:h;EUb(g,189897,d)|0}Nac(501952,0,1020)|0;f[125489]=189933;f[125490]=189937;f[125491]=189941;f[125492]=189946;f[125493]=189951;f[125494]=189957;f[125495]=189964;f[125496]=189971;f[125497]=189978;f[125498]=189983;f[125499]=189987;f[125500]=189992;f[125501]=189997;f[125502]=190005;f[125503]=190014;f[125504]=190023;f[125505]=190032;f[125506]=190041;f[125507]=190052;f[125508]=190061;f[125509]=190072;f[125588]=190081;f[125688]=190086;b[a+200>>0]=0;f[e>>2]=0;mO(a,e,1);u=c;return}function lO(a){a=a|0;bD(a);return}function mO(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+48|0;g=e+16|0;h=e+8|0;i=e;j=e+32|0;k=e+24|0;l=He(190090)|0;if(!l){u=e;return}m=b[l>>0]|0;if(!(m<<24>>24)){u=e;return}n=j+4|0;o=k+4|0;p=f[35349]|0;q=(d|0)>0;r=l;l=m;a:while(1){m=r;s=l;while(1){t=s+-44<<24>>24;if((t&255)>15|((-32765&65535)>>>(t&255)&1)==0){v=m;w=s;break}t=m+1|0;x=b[t>>0]|0;if(!(x<<24>>24)){y=29;break a}else{m=t;s=x}}while(1){x=w+-44<<24>>24;if(!((x&255)>15|((-32765&65535)>>>(x&255)&1)==0)){z=v;break}x=v+1|0;w=b[x>>0]|0;if(!(w<<24>>24)){z=x;break}else v=x}if((z|0)==(m|0)){A=m;B=s}else{f[j>>2]=0;f[n>>2]=0;x=z-m|0;if((x|0)!=0?(Vac(aD(j,x)|0,m|0,x|0)|0,x=f[n>>2]|0,(x|0)!=0):0)C=x;else{f[k>>2]=0;f[o>>2]=0;x=aD(k,18)|0;t=190109;D=x+18|0;do{b[x>>0]=b[t>>0]|0;x=x+1|0;t=t+1|0}while((x|0)<(D|0));bO(-215,k,190128,184322,606);bD(k);C=f[n>>2]|0}t=f[j>>2]|0;x=(t|0)==0?1124530:t;D=0;while(1){E=501952+(D<<2)|0;F=f[E>>2]|0;if(F|0?(kUb(F)|0)==(C|0):0){if((t|0)==(F|0)){y=19;break}if(!(gTb(x,F)|0)){y=19;break}}m=D+1|0;if((m|0)<255)D=m;else{y=27;break}}if((y|0)==19){y=0;b:do if(q){t=0;while(1){if((f[c+(t<<2)>>2]|0)==(D|0))break;t=t+1|0;if((t|0)>=(d|0))break b}f[i>>2]=F;EUb(p,190141,i)|0}while(0);t=a+D|0;if(!(b[t>>0]|0)){m=f[E>>2]|0;f[h>>2]=m|0?m:190318;EUb(p,190334,h)|0}b[t>>0]=0}else if((y|0)==27){y=0;f[g>>2]=x;EUb(p,190416,g)|0}bD(j);A=z;B=b[z>>0]|0}if(!(B<<24>>24)){y=29;break}else{r=A;l=B}}if((y|0)==29){u=e;return}}function nO(a){a=a|0;var b=0;f[a>>2]=42900;b=a+4|0;a=b+40|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(a|0));return}function oO(a){a=a|0;return (b[(f[10734]|0)+a>>0]|0)!=0|0}function pO(){var a=0,b=0,c=0,d=0;if(f[125745]|0){a=f[125745]|0;return a|0}b=jO()|0;Mac(f[b>>2]|0)|0;if(!(f[125745]|0)){c=L5b(8)|0;f[c>>2]=42920;d=AO(rO()|0)|0;f[c+4>>2]=d;f[c>>2]=42948;f[125745]=c}Lac(f[b>>2]|0)|0;a=f[125745]|0;return a|0}function qO(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=a+4|0;if((f[e>>2]|0)==-1){f[d>>2]=0;f[d+4>>2]=0;g=aD(d,63)|0;h=190470;i=g+63|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-215,d,190534,184322,1532);bD(d)}d=rO()|0;h=sO(d,f[e>>2]|0)|0;if(h|0){j=h;u=c;return j|0}h=di[f[(f[a>>2]|0)+8>>2]&1023](a)|0;a=rO()|0;tO(a,f[e>>2]|0,h);j=h;u=c;return j|0}function rO(){var a=0,b=0,c=0;if(f[125744]|0){a=f[125744]|0;return a|0}b=jO()|0;Mac(f[b>>2]|0)|0;if(!(f[125744]|0)){c=L5b(36)|0;xO(c);f[125744]=c}Lac(f[b>>2]|0)|0;a=f[125744]|0;return a|0}function sO(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;if((f[a+8>>2]|0)>>>0<=c>>>0){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,22)|0;h=190542;i=g+22|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-215,e,190534,184322,1425);bD(e)}e=Ze(f[a>>2]|0)|0;if(!e){j=0;u=d;return j|0}a=f[e>>2]|0;if((f[e+4>>2]|0)-a>>2>>>0<=c>>>0){j=0;u=d;return j|0}j=f[a+(c<<2)>>2]|0;u=d;return j|0}function tO(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e+8|0;h=e;if((f[a+8>>2]|0)>>>0<=c>>>0){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,22)|0;j=190542;k=i+22|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,g,190565,184322,1457);bD(g)}j=Ze(f[a>>2]|0)|0;f[g>>2]=j;if(!j){i=L5b(16)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;k=L5b(128)|0;l=k;f[i>>2]=l;f[i+4>>2]=l;f[i+8>>2]=k+128;f[g>>2]=i;uO(a,i);k=a+4|0;Mac(f[k>>2]|0)|0;l=a+24|0;m=a+28|0;n=f[m>>2]|0;f[i+12>>2]=n-(f[l>>2]|0)>>2;if((n|0)==(f[a+32>>2]|0))vO(l,g);else{f[n>>2]=i;f[m>>2]=(f[m>>2]|0)+4}Lac(f[k>>2]|0)|0;o=f[g>>2]|0}else o=j;if((f[o+4>>2]|0)-(f[o>>2]|0)>>2>>>0>c>>>0){p=o;q=f[p>>2]|0;r=q+(c<<2)|0;f[r>>2]=d;u=e;return}o=a+4|0;Mac(f[o>>2]|0)|0;a=f[g>>2]|0;j=c+1|0;f[h>>2]=0;k=a+4|0;m=f[k>>2]|0;i=f[a>>2]|0;n=m-i>>2;l=i;i=m;if(j>>>0<=n>>>0){if(j>>>0<n>>>0?(m=l+(j<<2)|0,(i|0)!=(m|0)):0)f[k>>2]=i+(~((i+-4-m|0)>>>2)<<2)}else wO(a,j-n|0,h);Lac(f[o>>2]|0)|0;p=f[g>>2]|0;q=f[p>>2]|0;r=q+(c<<2)|0;f[r>>2]=d;u=e;return}function uO(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;if(!(Ff(f[a>>2]|0,c|0)|0)){u=d;return}f[e>>2]=0;f[e+4>>2]=0;c=aD(e,39)|0;a=190573;g=c+39|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(g|0));bO(-215,e,190613,184322,1313);bD(e);u=d;return}function vO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function wO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>2>>>0>=b>>>0){i=b;j=h;do{f[j>>2]=f[c>>2];j=(f[g>>2]|0)+4|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>2;h=j+b|0;if(h>>>0>1073741823)c4b(a);k=e-i|0;i=k>>1;e=k>>2>>>0<536870911?(i>>>0<h>>>0?h:i):1073741823;do if(e)if(e>>>0>1073741823){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{l=L5b(e<<2)|0;break}else l=0;while(0);i=l+(j<<2)|0;j=l+(e<<2)|0;e=b;b=i;l=i;do{f[b>>2]=f[c>>2];b=l+4|0;l=b;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;b=(f[g>>2]|0)-e|0;c=i+(0-(b>>2)<<2)|0;if((b|0)>0)Vac(c|0,e|0,b|0)|0;f[a>>2]=c;f[g>>2]=l;f[d>>2]=j;if(!e)return;O5b(e);return}function xO(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;yO(a);d=L5b(32)|0;Ef(c|0)|0;vd(c|0,1)|0;Nf(d|0,c|0)|0;nf(c|0)|0;f[d+28>>2]=1;f[a+4>>2]=d;d=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;d=L5b(128)|0;c=d;f[a+12>>2]=c;f[a+16>>2]=c;f[a+20>>2]=d+128;d=L5b(128)|0;c=d;f[a+24>>2]=c;f[a+28>>2]=c;f[a+32>>2]=d+128;u=b;return}function yO(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;if(!(Le(a|0,0)|0)){u=c;return}f[d>>2]=0;f[d+4>>2]=0;a=aD(d,36)|0;e=190669;g=a+36|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));bO(-215,d,190706,184322,1301);bD(d);u=c;return}function zO(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;if(!(md(f[a>>2]|0)|0)){u=c;return}f[d>>2]=0;f[d+4>>2]=0;a=aD(d,31)|0;e=190621;g=a+31|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));bO(-215,d,190653,184322,1305);bD(d);u=c;return}function AO(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;d=c;e=a+4|0;Mac(f[e>>2]|0)|0;g=a+8|0;h=f[g>>2]|0;i=a+12|0;j=a+16|0;if((h|0)==((f[j>>2]|0)-(f[i>>2]|0)>>2|0))k=h;else{f[d>>2]=0;f[d+4>>2]=0;h=aD(d,31)|0;l=190721;m=h+31|0;do{b[h>>0]=b[l>>0]|0;h=h+1|0;l=l+1|0}while((h|0)<(m|0));bO(-215,d,190798,184322,1380);bD(d);k=f[g>>2]|0}a:do if(k|0){l=f[i>>2]|0;h=0;while(1){n=l+(h<<2)|0;if(!(f[n>>2]|0))break;m=h+1|0;if(m>>>0<k>>>0)h=m;else break a}f[n>>2]=1;o=h;p=f[e>>2]|0;Lac(p|0)|0;u=c;return o|0}while(0);f[d>>2]=1;n=f[j>>2]|0;if((n|0)==(f[a+20>>2]|0))IO(i,d);else{f[n>>2]=1;f[j>>2]=n+4}n=f[g>>2]|0;f[g>>2]=n+1;o=n;p=f[e>>2]|0;Lac(p|0)|0;u=c;return o|0}function BO(a){a=a|0;f[a>>2]=42948;FO(a);$N(a);return}function CO(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=42948;FO(a);f[a>>2]=42920;if((f[a+4>>2]|0)==-1){O5b(a);u=c;return}f[d>>2]=0;f[d+4>>2]=0;e=aD(d,10)|0;g=184293;h=e+10|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-215,d,184304,184322,1503);bD(d);O5b(a);u=c;return}function DO(a){a=a|0;var b=0;a=L5b(32)|0;b=a;f[b>>2]=-1;f[b+4>>2]=0;f[a+8>>2]=0;oP(a+12|0);f[a+16>>2]=-1;f[a+20>>2]=-1;f[a+24>>2]=-1;return a|0}function EO(a,b){a=a|0;b=b|0;if(!b)return;pP(b+12|0);O5b(b);return}function FO(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+16|0;c=b;f[c>>2]=0;d=c+4|0;f[d>>2]=0;f[c+8>>2]=0;e=L5b(128)|0;g=e;f[c>>2]=g;f[d>>2]=g;f[c+8>>2]=e+128;e=rO()|0;g=a+4|0;GO(e,f[g>>2]|0,c,0);f[g>>2]=-1;g=f[d>>2]|0;e=f[c>>2]|0;h=e;if((g|0)==(e|0)){i=g;j=h}else{g=0;e=h;while(1){zh[f[(f[a>>2]|0)+12>>2]&2047](a,f[e+(g<<2)>>2]|0);g=g+1|0;h=f[d>>2]|0;k=f[c>>2]|0;l=k;if(g>>>0>=h-k>>2>>>0){i=h;j=l;break}else e=l}}e=i;if(!j){u=b;return}if((e|0)!=(j|0))f[d>>2]=e+(~((e+-4-j|0)>>>2)<<2);O5b(j);u=b;return}function GO(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+16|0;h=g;i=a+4|0;Mac(f[i>>2]|0)|0;j=a+8|0;k=f[j>>2]|0;l=a+12|0;if((k|0)==((f[a+16>>2]|0)-(f[l>>2]|0)>>2|0))m=k;else{f[h>>2]=0;f[h+4>>2]=0;n=aD(h,31)|0;o=190721;p=n+31|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,h,190753,184322,1401);bD(h);m=f[j>>2]|0}if(m>>>0<=c>>>0){f[h>>2]=0;f[h+4>>2]=0;n=aD(h,22)|0;o=190542;p=n+22|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,h,190753,184322,1402);bD(h)}h=a+24|0;o=a+28|0;a=f[o>>2]|0;n=f[h>>2]|0;if((a|0)!=(n|0)){p=d+4|0;m=d+8|0;j=0;k=n;n=a;while(1){a=f[k+(j<<2)>>2]|0;if(((a|0)!=0?(q=f[a>>2]|0,(f[a+4>>2]|0)-q>>2>>>0>c>>>0):0)?(r=q+(c<<2)|0,q=f[r>>2]|0,s=q,(q|0)!=0):0){q=f[p>>2]|0;if((q|0)==(f[m>>2]|0))HO(d,r);else{f[q>>2]=s;f[p>>2]=(f[p>>2]|0)+4}f[(f[a>>2]|0)+(c<<2)>>2]=0;t=f[h>>2]|0;v=f[o>>2]|0}else{t=k;v=n}j=j+1|0;if(j>>>0>=v-t>>2>>>0)break;else{k=t;n=v}}}if(e){w=f[i>>2]|0;Lac(w|0)|0;u=g;return}f[(f[l>>2]|0)+(c<<2)>>2]=0;w=f[i>>2]|0;Lac(w|0)|0;u=g;return}function HO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function IO(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function JO(){var a=0,b=0,c=0,d=0;a=u;u=u+16|0;b=a+8|0;me(b|0,a|0)|0;c=f[b>>2]|0;d=cbc(c|0,((c|0)<0)<<31>>31|0,1e6,0)|0;c=f[b+4>>2]|0;b=Kac(d|0,J|0,c|0,((c|0)<0)<<31>>31|0)|0;u=a;return b|0}function KO(){if(b[491048]|0)return 501944;if(!(Cac(491048)|0))return 501944;f[125486]=0;f[125487]=0;Vac(aD(501944,4453)|0,185443,4453)|0;zd(1459,501944,x|0)|0;return 501944}function LO(){return 0}function MO(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+80|0;h=g+24|0;i=g+16|0;j=g+8|0;k=g;f[i>>2]=0;f[i+4>>2]=0;if(c|0?(g=kUb(c)|0,g|0):0)Vac(aD(i,g)|0,c|0,g|0)|0;f[j>>2]=0;f[j+4>>2]=0;if(b|0?(g=kUb(b)|0,g|0):0)Vac(aD(j,g)|0,b|0,g|0)|0;f[k>>2]=0;f[k+4>>2]=0;if(d|0?(g=kUb(d)|0,g|0):0)Vac(aD(k,g)|0,d|0,g|0)|0;cO(h,a,i,j,k,e);dO(h)}function NO(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=L5b(32)|0;Ef(c|0)|0;vd(c|0,1)|0;Nf(d|0,c|0)|0;nf(c|0)|0;f[d+28>>2]=1;f[a>>2]=d;u=b;return}function OO(a){a=a|0;var b=0,c=0;b=(f[a>>2]|0)+28|0;c=f[b>>2]|0;f[b>>2]=c+-1;if((c|0)==1?(c=f[a>>2]|0,c|0):0){xf(c|0)|0;O5b(c)}f[a>>2]=0;return}function PO(a){a=a|0;Mac(f[a>>2]|0)|0;return}function QO(a){a=a|0;Lac(f[a>>2]|0)|0;return}function RO(a){a=+a;var b=0,c=0,d=0,e=0,g=0,h=0,i=0.0;b=u;u=u+16|0;c=b;dQ(c,42964);d=(n[s>>2]=a,f[s>>2]|0);e=(d>>>23&255)+-127|0;g=(e|0)%3|0;h=g+-3-(g>>31&-3)|0;a=(f[s>>2]=(h<<23)+1065353216|d&8388607,+n[s>>2]);i=d|0?(f[s>>2]=(((e-h|0)/3|0)<<23)+(d&-2147483648)+(n[s>>2]=(a*(a*(a*(a*45.2548339756803+192.2798368355061)+119.16548242855816)+13.432501390862399)+.16361612265857542)/(a*(a*(a*(a*14.808840932191346+151.97140510444356)+168.52544141015682)+33.99059413502156)+1.0),f[s>>2]|0),+n[s>>2]):0.0;if(!(f[c+4>>2]|0)){u=b;return +i}u=b;return +i}function SO(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+240|0;g=e+232|0;h=e+176|0;i=e+120|0;j=e+64|0;k=e+48|0;l=e+32|0;m=e;dQ(g,42984);n=BL(a,-1)|0;o=FM(a,-1)|0;p=GM(a,-1)|0;AL(h,a,-1);AL(i,c,-1);do if((f[h>>2]|0)==(f[i>>2]|0)?(f[h+4>>2]|0)==(f[i+4>>2]|0):0)if((n|0)==(BL(c,-1)|0)?(o+-5|0)>>>0<2:0)break;else{q=6;break}else q=6;while(0);if((q|0)==6){f[h>>2]=0;f[h+4>>2]=0;q=aD(h,79)|0;n=190907;r=q+79|0;do{b[q>>0]=b[n>>0]|0;q=q+1|0;n=n+1|0}while((q|0)<(r|0));bO(-215,h,236960,190836,150);bD(h)}do if((yM(a)|0)==65536){n=f[a+4>>2]|0;f[h>>2]=f[n>>2];q=h+4|0;r=n+4|0;f[q>>2]=f[r>>2];s=h+8|0;f[s>>2]=f[n+8>>2];f[h+12>>2]=f[n+12>>2];f[h+16>>2]=f[n+16>>2];f[h+20>>2]=f[n+20>>2];f[h+24>>2]=f[n+24>>2];f[h+28>>2]=f[n+28>>2];f[h+32>>2]=f[n+32>>2];t=f[n+36>>2]|0;f[h+36>>2]=t;f[h+40>>2]=s;s=h+48|0;v=h+44|0;f[v>>2]=s;f[s>>2]=0;f[h+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[n+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;jL(h,n);break}}else yL(h,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[i>>2]=f[a>>2];n=i+4|0;q=a+4|0;f[n>>2]=f[q>>2];r=i+8|0;f[r>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];s=f[a+36>>2]|0;f[i+36>>2]=s;f[i+40>>2]=r;r=i+48|0;v=i+44|0;f[v>>2]=r;f[r>>2]=0;f[i+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[a+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[n>>2]=0;jL(i,a);break}}else yL(i,c,-1);while(0);c=h+4|0;a=h+40|0;wL(d,f[c>>2]|0,f[a>>2]|0,f[h>>2]&4095,-1,0,0);do if((yM(d)|0)==65536){n=f[d+4>>2]|0;f[j>>2]=f[n>>2];q=j+4|0;r=n+4|0;f[q>>2]=f[r>>2];v=j+8|0;f[v>>2]=f[n+8>>2];f[j+12>>2]=f[n+12>>2];f[j+16>>2]=f[n+16>>2];f[j+20>>2]=f[n+20>>2];f[j+24>>2]=f[n+24>>2];f[j+28>>2]=f[n+28>>2];f[j+32>>2]=f[n+32>>2];s=f[n+36>>2]|0;f[j+36>>2]=s;f[j+40>>2]=v;v=j+48|0;t=j+44|0;f[t>>2]=v;f[v>>2]=0;f[j+52>>2]=0;if(s|0){v=s+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[r>>2]|0)<3){r=f[n+44>>2]|0;v=f[t>>2]|0;f[v>>2]=f[r>>2];f[v+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;jL(j,n);break}}else yL(j,d,-1);while(0);f[k>>2]=h;f[k+4>>2]=i;f[k+8>>2]=j;f[k+12>>2]=0;RN(m,k,l,-1);k=Y(f[m+20>>2]|0,p)|0;p=m+16|0;d=l+8|0;n=l+4|0;a:do if((o|0)==5){q=0;while(1){if(q>>>0>=(f[p>>2]|0)>>>0)break a;PY(f[l>>2]|0,f[n>>2]|0,f[d>>2]|0,k);aL(m)|0;q=q+1|0}}else{q=0;while(1){if(q>>>0>=(f[p>>2]|0)>>>0)break a;QY(f[l>>2]|0,f[n>>2]|0,f[d>>2]|0,k);aL(m)|0;q=q+1|0}}while(0);m=j+36|0;k=f[m>>2]|0;if(k|0?(d=k+12|0,k=f[d>>2]|0,f[d>>2]=k+-1,(k|0)==1):0)kL(j);f[m>>2]=0;m=j+16|0;k=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[k>>2]|0)>0){m=f[j+40>>2]|0;d=0;do{f[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))UC(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(d=j+12|0,j=f[d>>2]|0,f[d>>2]=j+-1,(j|0)==1):0)kL(i);f[k>>2]=0;k=i+16|0;j=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[i+40>>2]|0;d=0;do{f[k+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))UC(j);j=h+36|0;i=f[j>>2]|0;if(i|0?(d=i+12|0,i=f[d>>2]|0,f[d>>2]=i+-1,(i|0)==1):0)kL(h);f[j>>2]=0;j=h+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[c>>2]|0)>0){j=f[a>>2]|0;a=0;do{f[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[c>>2]|0))}c=f[h+44>>2]|0;if((c|0)!=(h+48|0))UC(c);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function TO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=u;u=u+304|0;i=h+296|0;j=h+240|0;k=h+184|0;l=h+128|0;m=h+72|0;n=h+48|0;o=h+32|0;p=h;dQ(i,43004);do if((yM(a)|0)==65536){q=f[a+4>>2]|0;f[j>>2]=f[q>>2];r=j+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=j+8|0;f[t>>2]=f[q+8>>2];f[j+12>>2]=f[q+12>>2];f[j+16>>2]=f[q+16>>2];f[j+20>>2]=f[q+20>>2];f[j+24>>2]=f[q+24>>2];f[j+28>>2]=f[q+28>>2];f[j+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=t;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;jL(j,q);break}}else yL(j,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];q=k+4|0;r=a+4|0;f[q>>2]=f[r>>2];s=k+8|0;f[s>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];t=f[a+36>>2]|0;f[k+36>>2]=t;w=k+40|0;f[w>>2]=s;s=k+48|0;v=k+44|0;f[v>>2]=s;f[s>>2]=0;f[k+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[a+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];x=w;break}else{f[q>>2]=0;jL(k,a);x=w;break}}else{yL(k,c,-1);x=k+40|0}while(0);c=f[j>>2]|0;w=c&4095;a=c&7;q=c>>>3&511;c=q+1|0;r=j+40|0;s=f[r>>2]|0;v=f[s+-4>>2]|0;t=f[x>>2]|0;a:do if((v|0)==(f[t+-4>>2]|0)){if((v|0)==2){if((f[s>>2]|0)!=(f[t>>2]|0)){y=23;break}if((f[s+4>>2]|0)!=(f[t+4>>2]|0)){y=23;break}}else if((v|0)>0){z=0;do{if((f[s+(z<<2)>>2]|0)!=(f[t+(z<<2)>>2]|0)){y=23;break a}z=z+1|0}while((z|0)<(v|0))}if((a+-5|0)>>>0<2?(w|0)==(f[k>>2]&4095|0):0)A=s;else y=23}else y=23;while(0);if((y|0)==23){f[l>>2]=0;f[l+4>>2]=0;y=aD(l,66)|0;s=191043;v=y+66|0;do{b[y>>0]=b[s>>0]|0;y=y+1|0;s=s+1|0}while((y|0)<(v|0));bO(-215,l,191110,190836,276);bD(l);A=f[r>>2]|0}s=j+4|0;wL(d,f[s>>2]|0,A,w,-1,0,0);wL(e,f[s>>2]|0,f[r>>2]|0,w,-1,0,0);do if((yM(d)|0)==65536){w=f[d+4>>2]|0;f[l>>2]=f[w>>2];A=l+4|0;y=w+4|0;f[A>>2]=f[y>>2];v=l+8|0;f[v>>2]=f[w+8>>2];f[l+12>>2]=f[w+12>>2];f[l+16>>2]=f[w+16>>2];f[l+20>>2]=f[w+20>>2];f[l+24>>2]=f[w+24>>2];f[l+28>>2]=f[w+28>>2];f[l+32>>2]=f[w+32>>2];t=f[w+36>>2]|0;f[l+36>>2]=t;f[l+40>>2]=v;v=l+48|0;z=l+44|0;f[z>>2]=v;f[v>>2]=0;f[l+52>>2]=0;if(t|0){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;v=f[z>>2]|0;f[v>>2]=f[y>>2];f[v+4>>2]=f[y+4>>2];break}else{f[A>>2]=0;jL(l,w);break}}else yL(l,d,-1);while(0);do if((yM(e)|0)==65536){d=f[e+4>>2]|0;f[m>>2]=f[d>>2];w=m+4|0;A=d+4|0;f[w>>2]=f[A>>2];y=m+8|0;f[y>>2]=f[d+8>>2];f[m+12>>2]=f[d+12>>2];f[m+16>>2]=f[d+16>>2];f[m+20>>2]=f[d+20>>2];f[m+24>>2]=f[d+24>>2];f[m+28>>2]=f[d+28>>2];f[m+32>>2]=f[d+32>>2];v=f[d+36>>2]|0;f[m+36>>2]=v;f[m+40>>2]=y;y=m+48|0;z=m+44|0;f[z>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(v|0){y=v+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[A>>2]|0)<3){A=f[d+44>>2]|0;y=f[z>>2]|0;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2];break}else{f[w>>2]=0;jL(m,d);break}}else yL(m,e,-1);while(0);f[n>>2]=j;f[n+4>>2]=k;f[n+8>>2]=l;f[n+12>>2]=m;f[n+16>>2]=0;RN(p,n,o,-1);n=Y(f[p+20>>2]|0,c)|0;e=q|1024;q=e-((e>>>0)%(c>>>0)|0)|0;c=(q|0)<(n|0)?q:n;q=1212424721>>>(f[j>>2]<<2&28)&15;e=p+16|0;d=(n|0)>0;w=(a|0)==5;a=o+4|0;A=o+8|0;y=o+12|0;z=0;while(1){if(z>>>0>=(f[e>>2]|0)>>>0)break;if(d)if(w){v=0;t=f[o>>2]|0;B=f[a>>2]|0;C=f[A>>2]|0;D=f[y>>2]|0;do{E=n-v|0;F=(c|0)<(E|0)?c:E;PY(t,B,C,F);NY(B,t,D,F,g);E=Y(F,q)|0;t=(f[o>>2]|0)+E|0;f[o>>2]=t;B=(f[a>>2]|0)+E|0;f[a>>2]=B;C=(f[A>>2]|0)+E|0;f[A>>2]=C;D=(f[y>>2]|0)+E|0;f[y>>2]=D;v=v+c|0}while((n|0)>(v|0))}else{v=0;D=f[o>>2]|0;C=f[a>>2]|0;B=f[A>>2]|0;t=f[y>>2]|0;do{E=n-v|0;F=(c|0)<(E|0)?c:E;QY(D,C,B,F);OY(C,D,t,F,g);E=Y(F,q)|0;D=(f[o>>2]|0)+E|0;f[o>>2]=D;C=(f[a>>2]|0)+E|0;f[a>>2]=C;B=(f[A>>2]|0)+E|0;f[A>>2]=B;t=(f[y>>2]|0)+E|0;f[y>>2]=t;v=v+c|0}while((n|0)>(v|0))}aL(p)|0;z=z+1|0}z=m+36|0;p=f[z>>2]|0;if(p|0?(n=p+12|0,p=f[n>>2]|0,f[n>>2]=p+-1,(p|0)==1):0)kL(m);f[z>>2]=0;z=m+16|0;p=m+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[p>>2]|0)>0){z=f[m+40>>2]|0;n=0;do{f[z+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[p>>2]|0))}p=f[m+44>>2]|0;if((p|0)!=(m+48|0))UC(p);p=l+36|0;m=f[p>>2]|0;if(m|0?(n=m+12|0,m=f[n>>2]|0,f[n>>2]=m+-1,(m|0)==1):0)kL(l);f[p>>2]=0;p=l+16|0;m=l+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[m>>2]|0)>0){p=f[l+40>>2]|0;n=0;do{f[p+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))UC(m);m=k+36|0;l=f[m>>2]|0;if(l|0?(n=l+12|0,l=f[n>>2]|0,f[n>>2]=l+-1,(l|0)==1):0)kL(k);f[m>>2]=0;m=k+16|0;l=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){m=f[x>>2]|0;x=0;do{f[m+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))UC(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(x=k+12|0,k=f[x>>2]|0,f[x>>2]=k+-1,(k|0)==1):0)kL(j);f[l>>2]=0;l=j+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[s>>2]|0)>0){l=f[r>>2]|0;r=0;do{f[l+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)!=(j+48|0))UC(s);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function UO(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0.0,S=0.0,T=0.0,U=0,V=0,W=0,X=0,Z=0;h=u;u=u+1376|0;i=h+1360|0;j=h+1304|0;k=h+1248|0;l=h+1192|0;m=h+1136|0;o=h+1112|0;q=h+1096|0;r=h+1064|0;s=h;dQ(i,43024);t=BL(c,-1)|0;v=t&7;w=t>>>3&511;x=w+1|0;y=(v|0)==5;z=(v|0)==6;if((v+-5|0)>>>0<2){if(!(HM(a)|0)?(BL(a,-1)|0)!=(t|0):0)A=4}else A=4;if((A|0)==4){f[j>>2]=0;f[j+4>>2]=0;B=aD(j,67)|0;C=191199;D=B+67|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,j,191267,190836,565);bD(j)}do if((yM(a)|0)==65536){v=f[a+4>>2]|0;f[j>>2]=f[v>>2];E=j+4|0;F=v+4|0;f[E>>2]=f[F>>2];G=j+8|0;f[G>>2]=f[v+8>>2];f[j+12>>2]=f[v+12>>2];f[j+16>>2]=f[v+16>>2];f[j+20>>2]=f[v+20>>2];f[j+24>>2]=f[v+24>>2];f[j+28>>2]=f[v+28>>2];f[j+32>>2]=f[v+32>>2];H=f[v+36>>2]|0;f[j+36>>2]=H;f[j+40>>2]=G;G=j+48|0;I=j+44|0;f[I>>2]=G;f[G>>2]=0;f[j+52>>2]=0;if(H|0){G=H+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[v+44>>2]|0;G=f[I>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];break}else{f[E>>2]=0;jL(j,v);break}}else yL(j,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];v=k+4|0;E=a+4|0;f[v>>2]=f[E>>2];F=k+8|0;f[F>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];G=f[a+36>>2]|0;f[k+36>>2]=G;f[k+40>>2]=F;F=k+48|0;I=k+44|0;f[I>>2]=F;f[F>>2]=0;f[k+52>>2]=0;if(G|0){F=G+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[a+44>>2]|0;F=f[I>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];break}else{f[v>>2]=0;jL(k,a);break}}else yL(k,c,-1);while(0);c=j+16|0;a:do if(f[c>>2]|0){a=f[j+4>>2]|0;if((a|0)<3)J=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{v=f[j+40>>2]|0;E=0;F=1;while(1){I=Y(f[v+(E<<2)>>2]|0,F)|0;E=E+1|0;if((E|0)==(a|0)){J=I;break}else F=I}}if(!((a|0)==0|(J|0)==0)){F=f[k+40>>2]|0;E=f[F+-4>>2]|0;v=f[j+40>>2]|0;b:do if((E|0)==(f[v+-4>>2]|0)){if((E|0)==2){if((f[F>>2]|0)!=(f[v>>2]|0))break;if((f[F+4>>2]|0)==(f[v+4>>2]|0))break a;else break}if((E|0)>0)K=0;else break a;while(1){if((f[F+(K<<2)>>2]|0)!=(f[v+(K<<2)>>2]|0))break b;K=K+1|0;if((K|0)>=(E|0))break a}}while(0);f[l>>2]=0;f[l+4>>2]=0;B=aD(l,37)|0;C=191279;D=B+37|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,l,191267,190836,571);bD(l)}}while(0);C=k+4|0;B=k+40|0;wL(d,f[C>>2]|0,f[B>>2]|0,t,-1,0,0);wL(e,f[C>>2]|0,f[B>>2]|0,t,-1,0,0);do if((yM(d)|0)==65536){t=f[d+4>>2]|0;f[l>>2]=f[t>>2];D=l+4|0;K=t+4|0;f[D>>2]=f[K>>2];J=l+8|0;f[J>>2]=f[t+8>>2];f[l+12>>2]=f[t+12>>2];f[l+16>>2]=f[t+16>>2];f[l+20>>2]=f[t+20>>2];f[l+24>>2]=f[t+24>>2];f[l+28>>2]=f[t+28>>2];f[l+32>>2]=f[t+32>>2];E=f[t+36>>2]|0;f[l+36>>2]=E;f[l+40>>2]=J;J=l+48|0;v=l+44|0;f[v>>2]=J;f[J>>2]=0;f[l+52>>2]=0;if(E|0){J=E+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[K>>2]|0)<3){K=f[t+44>>2]|0;J=f[v>>2]|0;f[J>>2]=f[K>>2];f[J+4>>2]=f[K+4>>2];break}else{f[D>>2]=0;jL(l,t);break}}else yL(l,d,-1);while(0);do if((yM(e)|0)==65536){d=f[e+4>>2]|0;f[m>>2]=f[d>>2];t=m+4|0;D=d+4|0;f[t>>2]=f[D>>2];K=m+8|0;f[K>>2]=f[d+8>>2];f[m+12>>2]=f[d+12>>2];f[m+16>>2]=f[d+16>>2];f[m+20>>2]=f[d+20>>2];f[m+24>>2]=f[d+24>>2];f[m+28>>2]=f[d+28>>2];f[m+32>>2]=f[d+32>>2];J=f[d+36>>2]|0;f[m+36>>2]=J;f[m+40>>2]=K;K=m+48|0;v=m+44|0;f[v>>2]=K;f[K>>2]=0;f[m+52>>2]=0;if(J|0){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[D>>2]|0)<3){D=f[d+44>>2]|0;K=f[v>>2]|0;f[K>>2]=f[D>>2];f[K+4>>2]=f[D+4>>2];break}else{f[t>>2]=0;jL(m,d);break}}else yL(m,e,-1);while(0);f[o>>2]=j;f[o+4>>2]=k;f[o+8>>2]=l;f[o+12>>2]=m;f[o+16>>2]=0;RN(r,o,q,-1);o=s+8|0;f[s>>2]=o;e=s+4|0;f[e>>2]=264;d=Y(f[r+20>>2]|0,x)|0;t=w|1024;w=t-((t>>>0)%(x>>>0)|0)|0;x=(w|0)<(d|0)?w:d;w=1212424721>>>(f[k>>2]<<2&28)&15;if(z){z=x<<1;f[e>>2]=z;if(z>>>0>264){t=N5b(z>>>0>1073741823?-1:z<<2)|0;f[s>>2]=t;L=t}else L=o;M=L;N=L+(x<<2)|0}else{M=0;N=0}L=r+16|0;t=(d|0)>0;z=q+4|0;D=q+8|0;K=q+12|0;O=g?.17777777777777778:10.185916357881302;g=0;while(1){if(g>>>0>=(f[L>>2]|0)>>>0)break;if(t){v=0;do{J=d-v|0;E=(x|0)<(J|0)?x:J;do if(y){J=f[q>>2]|0;F=f[z>>2]|0;a=f[D>>2]|0;I=f[K>>2]|0;G=(E|0)>0;if(G){H=0;do{P=O*+n[F+(H<<2)>>2];Q=MVb(P)|0;R=P-+(Q|0);P=R*(R*(R*-1.5767166072981726e-04)+.09817477042468103);S=R*(R*-.004817389940423465)+1.0;R=+p[10216+((Q&63)<<3)>>3];T=+p[10216+((16-Q&63)<<3)>>3];n[I+(H<<2)>>2]=R*S+T*P;n[a+(H<<2)>>2]=T*S-R*P;H=H+1|0}while((H|0)!=(E|0));if((J|0)!=0&G){H=0;do{P=+n[J+(H<<2)>>2];F=a+(H<<2)|0;n[F>>2]=P*+n[F>>2];F=I+(H<<2)|0;n[F>>2]=P*+n[F>>2];H=H+1|0}while((H|0)<(E|0));U=J;A=71}else{V=J;A=72}}else{V=J;A=72}}else{H=f[q>>2]|0;I=f[z>>2]|0;a=f[D>>2]|0;G=f[K>>2]|0;F=(E|0)>0;if(F){Q=0;do{n[M+(Q<<2)>>2]=+p[I+(Q<<3)>>3];Q=Q+1|0}while((Q|0)<(E|0));if(F){Q=0;do{I=M+(Q<<2)|0;P=O*+n[I>>2];J=MVb(P)|0;R=P-+(J|0);P=R*(R*(R*-1.5767166072981726e-04)+.09817477042468103);S=R*(R*-.004817389940423465)+1.0;R=+p[10216+((J&63)<<3)>>3];T=+p[10216+((16-J&63)<<3)>>3];n[N+(Q<<2)>>2]=R*S+T*P;n[I>>2]=T*S-R*P;Q=Q+1|0}while((Q|0)!=(E|0))}}if(!H){Q=E<<2;Vac(a|0,M|0,Q|0)|0;Vac(G|0,N|0,Q|0)|0;V=f[q>>2]|0;A=72;break}if(F){Q=0;do{P=+p[H+(Q<<3)>>3];p[a+(Q<<3)>>3]=P*+n[M+(Q<<2)>>2];p[G+(Q<<3)>>3]=P*+n[N+(Q<<2)>>2];Q=Q+1|0}while((Q|0)<(E|0));U=H;A=71}else{V=H;A=72}}while(0);if((A|0)==71){A=0;W=U;X=Y(E,w)|0;A=73}else if((A|0)==72){A=0;Q=Y(E,w)|0;if(!V)Z=Q;else{W=V;X=Q;A=73}}if((A|0)==73){A=0;f[q>>2]=W+X;Z=X}f[z>>2]=(f[z>>2]|0)+Z;f[D>>2]=(f[D>>2]|0)+Z;f[K>>2]=(f[K>>2]|0)+Z;v=v+x|0}while((d|0)>(v|0))}aL(r)|0;g=g+1|0}g=f[s>>2]|0;if((g|0)!=(o|0)){if(g|0)P5b(g);f[s>>2]=o;f[e>>2]=264}e=m+36|0;o=f[e>>2]|0;if(o|0?(s=o+12|0,o=f[s>>2]|0,f[s>>2]=o+-1,(o|0)==1):0)kL(m);f[e>>2]=0;e=m+16|0;o=m+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[o>>2]|0)>0){e=f[m+40>>2]|0;s=0;do{f[e+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)!=(m+48|0))UC(o);o=l+36|0;m=f[o>>2]|0;if(m|0?(s=m+12|0,m=f[s>>2]|0,f[s>>2]=m+-1,(m|0)==1):0)kL(l);f[o>>2]=0;o=l+16|0;m=l+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[m>>2]|0)>0){o=f[l+40>>2]|0;s=0;do{f[o+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))UC(m);m=k+36|0;l=f[m>>2]|0;if(l|0?(s=l+12|0,l=f[s>>2]|0,f[s>>2]=l+-1,(l|0)==1):0)kL(k);f[m>>2]=0;m=k+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[C>>2]|0)>0){m=f[B>>2]|0;B=0;do{f[m+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[C>>2]|0))}C=f[k+44>>2]|0;if((C|0)!=(k+48|0))UC(C);C=j+36|0;k=f[C>>2]|0;if(k|0?(B=k+12|0,k=f[B>>2]|0,f[B>>2]=k+-1,(k|0)==1):0)kL(j);f[C>>2]=0;C=j+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[C>>2]|0)>0){c=f[j+40>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[C>>2]|0))}C=f[j+44>>2]|0;if((C|0)!=(j+48|0))UC(C);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function VO(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+176|0;e=d+168|0;g=d+112|0;h=d+56|0;i=d+40|0;j=d+32|0;k=d;dQ(e,43044);l=BL(a,-1)|0;m=FM(a,-1)|0;n=GM(a,-1)|0;o=(m|0)==5;if((m+-5|0)>>>0>=2){f[g>>2]=0;f[g+4>>2]=0;m=aD(g,24)|0;p=212982;q=m+24|0;do{b[m>>0]=b[p>>0]|0;m=m+1|0;p=p+1|0}while((m|0)<(q|0));bO(-215,g,191394,190836,668);bD(g)}do if((yM(a)|0)==65536){p=f[a+4>>2]|0;f[g>>2]=f[p>>2];m=g+4|0;q=p+4|0;f[m>>2]=f[q>>2];r=g+8|0;f[r>>2]=f[p+8>>2];f[g+12>>2]=f[p+12>>2];f[g+16>>2]=f[p+16>>2];f[g+20>>2]=f[p+20>>2];f[g+24>>2]=f[p+24>>2];f[g+28>>2]=f[p+28>>2];f[g+32>>2]=f[p+32>>2];s=f[p+36>>2]|0;f[g+36>>2]=s;t=g+40|0;f[t>>2]=r;r=g+48|0;v=g+44|0;f[v>>2]=r;f[r>>2]=0;f[g+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[p+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];w=t;x=m;break}else{f[m>>2]=0;jL(g,p);w=t;x=m;break}}else{yL(g,a,-1);w=g+40|0;x=g+4|0}while(0);wL(c,f[x>>2]|0,f[w>>2]|0,l,-1,0,0);do if((yM(c)|0)==65536){l=f[c+4>>2]|0;f[h>>2]=f[l>>2];a=h+4|0;m=l+4|0;f[a>>2]=f[m>>2];t=h+8|0;f[t>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[h+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[h+36>>2]=p;f[h+40>>2]=t;t=h+48|0;q=h+44|0;f[q>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(p|0){t=p+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[m>>2]|0)<3){m=f[l+44>>2]|0;t=f[q>>2]|0;f[t>>2]=f[m>>2];f[t+4>>2]=f[m+4>>2];break}else{f[a>>2]=0;jL(h,l);break}}else yL(h,c,-1);while(0);f[i>>2]=g;f[i+4>>2]=h;f[i+8>>2]=0;RN(k,i,j,-1);i=Y(f[k+20>>2]|0,n)|0;n=k+16|0;c=j+4|0;a:do if(o){l=0;while(1){if(l>>>0>=(f[n>>2]|0)>>>0)break a;VY(f[j>>2]|0,f[c>>2]|0,i);aL(k)|0;l=l+1|0}}else{l=0;while(1){if(l>>>0>=(f[n>>2]|0)>>>0)break a;WY(f[j>>2]|0,f[c>>2]|0,i);aL(k)|0;l=l+1|0}}while(0);k=h+36|0;i=f[k>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)kL(h);f[k>>2]=0;k=h+16|0;i=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[h+40>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))UC(i);i=g+36|0;h=f[i>>2]|0;if(h|0?(c=h+12|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)kL(g);f[i>>2]=0;i=g+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[x>>2]|0)>0){i=f[w>>2]|0;w=0;do{f[i+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[x>>2]|0))}x=f[g+44>>2]|0;if((x|0)!=(g+48|0))UC(x);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function WO(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+176|0;e=d+168|0;g=d+112|0;h=d+56|0;i=d+40|0;j=d+32|0;k=d;dQ(e,43064);l=BL(a,-1)|0;m=FM(a,-1)|0;n=GM(a,-1)|0;o=(m|0)==5;if((m+-5|0)>>>0>=2){f[g>>2]=0;f[g+4>>2]=0;m=aD(g,24)|0;p=212982;q=m+24|0;do{b[m>>0]=b[p>>0]|0;m=m+1|0;p=p+1|0}while((m|0)<(q|0));bO(-215,g,191436,190836,701);bD(g)}do if((yM(a)|0)==65536){p=f[a+4>>2]|0;f[g>>2]=f[p>>2];m=g+4|0;q=p+4|0;f[m>>2]=f[q>>2];r=g+8|0;f[r>>2]=f[p+8>>2];f[g+12>>2]=f[p+12>>2];f[g+16>>2]=f[p+16>>2];f[g+20>>2]=f[p+20>>2];f[g+24>>2]=f[p+24>>2];f[g+28>>2]=f[p+28>>2];f[g+32>>2]=f[p+32>>2];s=f[p+36>>2]|0;f[g+36>>2]=s;t=g+40|0;f[t>>2]=r;r=g+48|0;v=g+44|0;f[v>>2]=r;f[r>>2]=0;f[g+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[p+44>>2]|0;r=f[v>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];w=t;x=m;break}else{f[m>>2]=0;jL(g,p);w=t;x=m;break}}else{yL(g,a,-1);w=g+40|0;x=g+4|0}while(0);wL(c,f[x>>2]|0,f[w>>2]|0,l,-1,0,0);do if((yM(c)|0)==65536){l=f[c+4>>2]|0;f[h>>2]=f[l>>2];a=h+4|0;m=l+4|0;f[a>>2]=f[m>>2];t=h+8|0;f[t>>2]=f[l+8>>2];f[h+12>>2]=f[l+12>>2];f[h+16>>2]=f[l+16>>2];f[h+20>>2]=f[l+20>>2];f[h+24>>2]=f[l+24>>2];f[h+28>>2]=f[l+28>>2];f[h+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[h+36>>2]=p;f[h+40>>2]=t;t=h+48|0;q=h+44|0;f[q>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(p|0){t=p+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[m>>2]|0)<3){m=f[l+44>>2]|0;t=f[q>>2]|0;f[t>>2]=f[m>>2];f[t+4>>2]=f[m+4>>2];break}else{f[a>>2]=0;jL(h,l);break}}else yL(h,c,-1);while(0);f[i>>2]=g;f[i+4>>2]=h;f[i+8>>2]=0;RN(k,i,j,-1);i=Y(f[k+20>>2]|0,n)|0;n=k+16|0;c=j+4|0;a:do if(o){l=0;while(1){if(l>>>0>=(f[n>>2]|0)>>>0)break a;XY(f[j>>2]|0,f[c>>2]|0,i);aL(k)|0;l=l+1|0}}else{l=0;while(1){if(l>>>0>=(f[n>>2]|0)>>>0)break a;YY(f[j>>2]|0,f[c>>2]|0,i);aL(k)|0;l=l+1|0}}while(0);k=h+36|0;i=f[k>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)kL(h);f[k>>2]=0;k=h+16|0;i=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[h+40>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))UC(i);i=g+36|0;h=f[i>>2]|0;if(h|0?(c=h+12|0,h=f[c>>2]|0,f[c>>2]=h+-1,(h|0)==1):0)kL(g);f[i>>2]=0;i=g+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[x>>2]|0)>0){i=f[w>>2]|0;w=0;do{f[i+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[x>>2]|0))}x=f[g+44>>2]|0;if((x|0)!=(g+48|0))UC(x);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function XO(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0;e=u;u=u+1216|0;g=e+1208|0;h=e+1152|0;i=e;j=e+1136|0;k=e+1128|0;l=e+1096|0;m=e+56|0;dQ(g,43084);o=BL(a,-1)|0;q=o&7;r=o>>>3&511;s=r+1|0;t=MVb(c)|0;v=+L(+(+(t|0)-c))<2.220446049250313e-16;a:do if(!v)if((q+-5|0)>>>0<2)w=8;else{f[h>>2]=0;f[h+4>>2]=0;x=aD(h,24)|0;y=212982;z=x+24|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,h,374991,190836,1234);bD(h);w=8}else switch(t|0){case 0:{NM(d,a,o);p[i>>3]=1.0;p[i+8>>3]=1.0;p[i+16>>3]=1.0;p[i+24>>3]=1.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=4;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;QM(d,h,j);break a;break}case 1:{JM(a,d);break a;break}case 2:{NE(a,a,d,1.0,-1);break a;break}default:{w=8;break a}}while(0);if((w|0)==8){do if((yM(a)|0)==65536){w=f[a+4>>2]|0;f[h>>2]=f[w>>2];A=h+4|0;B=w+4|0;f[A>>2]=f[B>>2];E=h+8|0;f[E>>2]=f[w+8>>2];f[h+12>>2]=f[w+12>>2];f[h+16>>2]=f[w+16>>2];f[h+20>>2]=f[w+20>>2];f[h+24>>2]=f[w+24>>2];f[h+28>>2]=f[w+28>>2];f[h+32>>2]=f[w+32>>2];F=f[w+36>>2]|0;f[h+36>>2]=F;G=h+40|0;f[G>>2]=E;E=h+48|0;H=h+44|0;f[H>>2]=E;f[E>>2]=0;f[h+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[B>>2]|0)<3){B=f[w+44>>2]|0;E=f[H>>2]|0;f[E>>2]=f[B>>2];f[E+4>>2]=f[B+4>>2];I=G;J=A;break}else{f[A>>2]=0;jL(h,w);I=G;J=A;break}}else{yL(h,a,-1);I=h+40|0;J=h+4|0}while(0);wL(d,f[J>>2]|0,f[I>>2]|0,o,-1,0,0);do if((yM(d)|0)==65536){o=f[d+4>>2]|0;f[i>>2]=f[o>>2];a=i+4|0;A=o+4|0;f[a>>2]=f[A>>2];G=i+8|0;f[G>>2]=f[o+8>>2];f[i+12>>2]=f[o+12>>2];f[i+16>>2]=f[o+16>>2];f[i+20>>2]=f[o+20>>2];f[i+24>>2]=f[o+24>>2];f[i+28>>2]=f[o+28>>2];f[i+32>>2]=f[o+32>>2];w=f[o+36>>2]|0;f[i+36>>2]=w;f[i+40>>2]=G;G=i+48|0;B=i+44|0;f[B>>2]=G;f[G>>2]=0;f[i+52>>2]=0;if(w|0){G=w+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[A>>2]|0)<3){A=f[o+44>>2]|0;G=f[B>>2]|0;f[G>>2]=f[A>>2];f[G+4>>2]=f[A+4>>2];break}else{f[a>>2]=0;jL(i,o);break}}else yL(i,d,-1);while(0);f[j>>2]=h;f[j+4>>2]=i;f[j+8>>2]=0;RN(l,j,k,-1);j=Y(f[l+20>>2]|0,s)|0;b:do if(!v){if(+L(+(+L(+c)+-.5))<2.220446049250313e-16){d=(q|0)==5;o=c<0.0?(d?234:233):d?236:235;d=l+16|0;a=k+4|0;A=0;while(1){if(A>>>0>=(f[d>>2]|0)>>>0)break b;_h[o&255](f[k>>2]|0,f[a>>2]|0,j);aL(l)|0;A=A+1|0}}A=r|1024;a=A-((A>>>0)%(s>>>0)|0)|0;A=(a|0)<(j|0)?a:j;a=1212424721>>>(f[h>>2]<<2&28)&15;o=m+8|0;f[m>>2]=o;d=m+4|0;f[d>>2]=1032;if((f[h+16>>2]|0)==(f[i+16>>2]|0)){G=Y(a,A)|0;f[d>>2]=G;if(G>>>0>1032){B=N5b(G)|0;f[m>>2]=B;K=B}else K=o;M=K;N=K}else{M=0;N=0}B=l+16|0;G=(j|0)>0;w=(q|0)==5;E=(N|0)!=0;H=k+4|0;F=c<0.0;O=(M|0)!=0;P=0;while(1){if(P>>>0>=(f[B>>2]|0)>>>0)break;if(G){Q=0;R=f[k>>2]|0;do{S=j-Q|0;T=(A|0)<(S|0)?A:S;do if(w){S=E?N:R;U=f[H>>2]|0;if((S|0)!=(R|0))Vac(S|0,R|0,Y(T,a)|0)|0;XY(S,U,T);S=(T|0)>0;if(S)V=0;else{VY(U,U,T);break}do{W=U+(V<<2)|0;n[W>>2]=+n[W>>2]*c;V=V+1|0}while((V|0)<(T|0));VY(U,U,T);if(S)if(F){W=0;do{X=+n[R+(W<<2)>>2];if(X<=0.0)n[U+(W<<2)>>2]=X==0.0?D:C;W=W+1|0}while((W|0)<(T|0))}else{W=0;do{if(+n[R+(W<<2)>>2]<0.0)n[U+(W<<2)>>2]=C;W=W+1|0}while((W|0)<(T|0))}}else{W=O?M:R;U=f[H>>2]|0;if((W|0)!=(R|0))Vac(W|0,R|0,Y(T,a)|0)|0;YY(W,U,T);W=(T|0)>0;if(W)Z=0;else{WY(U,U,T);break}do{S=U+(Z<<3)|0;p[S>>3]=+p[S>>3]*c;Z=Z+1|0}while((Z|0)<(T|0));WY(U,U,T);if(W)if(F){S=0;do{X=+p[R+(S<<3)>>3];if(X<=0.0)p[U+(S<<3)>>3]=X==0.0?D:C;S=S+1|0}while((S|0)<(T|0))}else{S=0;do{if(+p[R+(S<<3)>>3]<0.0)p[U+(S<<3)>>3]=C;S=S+1|0}while((S|0)<(T|0))}}while(0);S=Y(T,a)|0;R=(f[k>>2]|0)+S|0;f[k>>2]=R;f[H>>2]=(f[H>>2]|0)+S;Q=Q+A|0}while((j|0)>(Q|0))}aL(l)|0;P=P+1|0}P=f[m>>2]|0;if((P|0)!=(o|0)){if(P|0)P5b(P);f[m>>2]=o;f[d>>2]=1032}}else{P=f[43104+(q<<2)>>2]|0;if((q|0)==7){f[m>>2]=0;f[m+4>>2]=0;x=aD(m,9)|0;y=255890;z=x+9|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,m,374991,190836,1250);bD(m)}d=l+16|0;o=k+4|0;A=0;while(1){if(A>>>0>=(f[d>>2]|0)>>>0)break b;th[P&511](f[k>>2]|0,f[o>>2]|0,j,t);aL(l)|0;A=A+1|0}}while(0);l=i+36|0;t=f[l>>2]|0;if(t|0?(j=t+12|0,t=f[j>>2]|0,f[j>>2]=t+-1,(t|0)==1):0)kL(i);f[l>>2]=0;l=i+16|0;t=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[t>>2]|0)>0){l=f[i+40>>2]|0;j=0;do{f[l+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[t>>2]|0))}t=f[i+44>>2]|0;if((t|0)!=(i+48|0))UC(t);t=h+36|0;i=f[t>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)kL(h);f[t>>2]=0;t=h+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[J>>2]|0)>0){t=f[I>>2]|0;I=0;do{f[t+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[J>>2]|0))}J=f[h+44>>2]|0;if((J|0)!=(h+48|0))UC(J)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function YO(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){b[g>>0]=0;i=e<<1&2;j=(i^2)+-1|0;b[g+1>>0]=j>>>0<256?j:(i|0)==0?255:0;b[g+2>>0]=-1;b[g+3>>0]=1;b[g+4>>0]=(e|0)==-1&1;if((d|0)>0){i=0;do{j=b[a+i>>0]|0;if((j&255)<3)k=b[g+((j&255)+2)>>0]|0;else k=0;b[c+i>>0]=k;i=i+1|0}while((i|0)!=(d|0))}u=f;return}if((d|0)<=0){u=f;return}if((e|0)>1)l=0;else{i=0;do{b[c+i>>0]=b[a+i>>0]|0;i=i+1|0}while((i|0)!=(d|0));u=f;return}do{i=h[a+l>>0]|0;k=1;g=e;while(1){k=Y((g&1|0)==0?1:i,k)|0;i=Y(i,i)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(k,i)|0;b[c+l>>0]=g>>>0<255?g:255;l=l+1|0}while((l|0)!=(d|0));u=f;return}function ZO(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){h=(e|0)==-1;b[g>>0]=((h<<31>>31)+128|0)>>>0<256?h<<31>>31:-128;b[g+1>>0]=(e<<1&2^2)+255;b[g+2>>0]=127;b[g+3>>0]=1;b[g+4>>0]=h&1;if((d|0)>0){h=0;do{i=b[a+h>>0]|0;j=i<<24>>24;if(((i<<24>>24>-1?j:0-j|0)|0)<3)k=b[g+(j+2)>>0]|0;else k=0;b[c+h>>0]=k;h=h+1|0}while((h|0)!=(d|0))}u=f;return}if((d|0)<=0){u=f;return}if((e|0)>1)l=0;else{h=0;do{k=b[a+h>>0]|0;g=k<<24>>24;b[c+h>>0]=(g+128|0)>>>0<256?g:k<<24>>24>0?127:128;h=h+1|0}while((h|0)!=(d|0));u=f;return}do{h=b[a+l>>0]|0;k=1;g=e;while(1){k=Y((g&1|0)==0?1:h,k)|0;h=Y(h,h)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(k,h)|0;b[c+l>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;l=l+1|0}while((l|0)!=(d|0));u=f;return}function _O(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){d[g>>1]=0;h=e<<1&2;i=(h^2)+-1|0;d[g+2>>1]=i>>>0<65536?i:(h|0)==0?65535:0;d[g+4>>1]=-1;d[g+6>>1]=1;d[g+8>>1]=(e|0)==-1&1;if((c|0)>0){h=0;do{i=d[a+(h<<1)>>1]|0;if((i&65535)<3)k=d[g+((i&65535)+2<<1)>>1]|0;else k=0;d[b+(h<<1)>>1]=k;h=h+1|0}while((h|0)!=(c|0))}u=f;return}if((c|0)<=0){u=f;return}if((e|0)>1)l=0;else{h=0;do{d[b+(h<<1)>>1]=d[a+(h<<1)>>1]|0;h=h+1|0}while((h|0)!=(c|0));u=f;return}do{h=j[a+(l<<1)>>1]|0;k=1;g=e;while(1){k=Y((g&1|0)==0?1:h,k)|0;h=Y(h,h)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(k,h)|0;d[b+(l<<1)>>1]=g>>>0<65535?g:65535;l=l+1|0}while((l|0)!=(c|0));u=f;return}function $O(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=u;u=u+16|0;g=f;if((e|0)<0){h=(e|0)==-1;d[g>>1]=((h<<31>>31)+32768|0)>>>0<65536?h<<31>>31:-32768;d[g+2>>1]=(e<<1&2^2)+65535;d[g+4>>1]=32767;d[g+6>>1]=1;d[g+8>>1]=h&1;if((c|0)>0){h=0;do{i=d[a+(h<<1)>>1]|0;j=i<<16>>16;if(((i<<16>>16>-1?j:0-j|0)|0)<3)k=d[g+(j+2<<1)>>1]|0;else k=0;d[b+(h<<1)>>1]=k;h=h+1|0}while((h|0)!=(c|0))}u=f;return}if((c|0)<=0){u=f;return}if((e|0)>1)l=0;else{h=0;do{k=d[a+(h<<1)>>1]|0;g=k<<16>>16;d[b+(h<<1)>>1]=(g+32768|0)>>>0<65536?g:k<<16>>16>0?32767:32768;h=h+1|0}while((h|0)!=(c|0));u=f;return}do{h=d[a+(l<<1)>>1]|0;k=1;g=e;while(1){k=Y((g&1|0)==0?1:h,k)|0;h=Y(h,h)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(k,h)|0;d[b+(l<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;l=l+1|0}while((l|0)!=(c|0));u=f;return}function aP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+32|0;g=e;if((d|0)<0){h=(d|0)==-1;f[g>>2]=h<<31>>31;f[g+4>>2]=(d<<1&2^2)+-1;f[g+8>>2]=2147483647;f[g+12>>2]=1;f[g+16>>2]=h&1;if((c|0)>0){h=0;do{i=f[a+(h<<2)>>2]|0;if((((i|0)>-1?i:0-i|0)|0)<3)j=f[g+(i+2<<2)>>2]|0;else j=0;f[b+(h<<2)>>2]=j;h=h+1|0}while((h|0)!=(c|0))}u=e;return}if((c|0)<=0){u=e;return}if((d|0)>1)k=0;else{h=0;do{f[b+(h<<2)>>2]=f[a+(h<<2)>>2];h=h+1|0}while((h|0)!=(c|0));u=e;return}do{h=f[a+(k<<2)>>2]|0;j=1;g=d;while(1){j=Y((g&1|0)==0?1:h,j)|0;h=Y(h,h)|0;if(g>>>0<=3)break;else g=g>>>1}g=Y(j,h)|0;f[b+(k<<2)>>2]=g;k=k+1|0}while((k|0)!=(c|0));u=e;return}function bP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0.0,j=0.0,k=0.0;e=(d|0)>-1?d:0-d|0;if((c|0)<=0)return;g=(d|0)<0;if((e|0)<=1)if(g){d=0;do{n[b+(d<<2)>>2]=1.0/+n[a+(d<<2)>>2];d=d+1|0}while((d|0)!=(c|0));return}else{d=0;do{f[b+(d<<2)>>2]=f[a+(d<<2)>>2];d=d+1|0}while((d|0)!=(c|0));return}if(g){g=0;do{h=1.0/+n[a+(g<<2)>>2];i=1.0;d=e;while(1){i=(d&1|0)==0?i:h*i;h=h*h;if(d>>>0<=3)break;else d=d>>>1}n[b+(g<<2)>>2]=h*i;g=g+1|0}while((g|0)!=(c|0));return}else{g=0;do{j=+n[a+(g<<2)>>2];k=1.0;d=e;while(1){k=(d&1|0)==0?k:j*k;j=j*j;if(d>>>0<=3)break;else d=d>>>1}n[b+(g<<2)>>2]=j*k;g=g+1|0}while((g|0)!=(c|0));return}}function cP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0.0,h=0.0,i=0.0,j=0.0;e=(d|0)>-1?d:0-d|0;if((c|0)<=0)return;f=(d|0)<0;if((e|0)<=1)if(f){d=0;do{p[b+(d<<3)>>3]=1.0/+p[a+(d<<3)>>3];d=d+1|0}while((d|0)!=(c|0));return}else{d=0;do{p[b+(d<<3)>>3]=+p[a+(d<<3)>>3];d=d+1|0}while((d|0)!=(c|0));return}if(f){f=0;do{g=1.0/+p[a+(f<<3)>>3];h=1.0;d=e;while(1){h=(d&1|0)==0?h:g*h;g=g*g;if(d>>>0<=3)break;else d=d>>>1}p[b+(f<<3)>>3]=g*h;f=f+1|0}while((f|0)!=(c|0));return}else{f=0;do{i=+p[a+(f<<3)>>3];j=1.0;d=e;while(1){j=(d&1|0)==0?j:i*j;i=i*i;if(d>>>0<=3)break;else d=d>>>1}p[b+(f<<3)>>3]=i*j;f=f+1|0}while((f|0)!=(c|0));return}}function dP(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;dQ(d,43136);XO(a,.5,b);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function eP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;g=a+4|0;h=b+4|0;aD(d,(f[h>>2]|0)+(f[g>>2]|0)|0)|0;i=f[g>>2]|0;if(i|0)Vac(f[d>>2]|0,f[a>>2]|0,i|0)|0;i=f[h>>2]|0;if(i|0)Vac((f[d>>2]|0)+(f[g>>2]|0)|0,f[b>>2]|0,i|0)|0;if((d|0)==(a|0)){bD(d);u=c;return a|0}bD(a);i=f[d>>2]|0;if(!i)j=0;else{b=i+-4|0;f[b>>2]=(f[b>>2]|0)+1;j=f[d>>2]|0}f[a>>2]=j;f[g>>2]=f[e>>2];bD(d);u=c;return a|0}function fP(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;d=u;u=u+112|0;e=d+104|0;g=d+48|0;h=d+40|0;i=d+32|0;j=d;dQ(e,43156);if((FM(a,-1)|0)!=5){f[g>>2]=0;f[g+4>>2]=0;k=aD(g,15)|0;l=191563;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,191579,190836,1583);bD(g)}do if((yM(a)|0)==65536){l=f[a+4>>2]|0;f[g>>2]=f[l>>2];k=g+4|0;m=l+4|0;f[k>>2]=f[m>>2];o=g+8|0;f[o>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];f[g+16>>2]=f[l+16>>2];f[g+20>>2]=f[l+20>>2];f[g+24>>2]=f[l+24>>2];f[g+28>>2]=f[l+28>>2];f[g+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[g+36>>2]=p;f[g+40>>2]=o;o=g+48|0;q=g+44|0;f[q>>2]=o;f[o>>2]=0;f[g+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[m>>2]|0)<3){m=f[l+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];break}else{f[k>>2]=0;jL(g,l);break}}else yL(g,a,-1);while(0);f[h>>2]=g;f[h+4>>2]=0;RN(j,h,i,-1);h=Y(((f[g>>2]|0)>>>3&511)+1|0,f[j+20>>2]|0)|0;r=c;a=j+16|0;a:do if(!h){l=0;while(1){if(l>>>0>=(f[a>>2]|0)>>>0)break a;aL(j)|0;l=l+1|0}}else{l=0;while(1){if(l>>>0>=(f[a>>2]|0)>>>0)break a;k=f[i>>2]|0;m=0;do{o=k+(m<<2)|0;if((f[o>>2]&2147483647)>>>0>2139095040)n[o>>2]=r;m=m+1|0}while((m|0)!=(h|0));aL(j)|0;l=l+1|0}}while(0);j=g+36|0;h=f[j>>2]|0;if(h|0?(i=h+12|0,h=f[i>>2]|0,f[i>>2]=h+-1,(h|0)==1):0)kL(g);f[j>>2]=0;j=g+16|0;h=g+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[h>>2]|0)>0){j=f[g+40>>2]|0;i=0;do{f[j+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))UC(h);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function gP(a,b){a=+a;b=+b;return +(+ZY(a,b))}function hP(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,P=0.0,Q=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0;d=u;u=u+128|0;e=d+112|0;g=d+56|0;h=d;dQ(e,43176);do if((yM(a)|0)==65536){i=f[a+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[g+36>>2]=m;f[g+40>>2]=l;l=g+48|0;o=g+44|0;f[o>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];q=g;break}else{f[j>>2]=0;jL(g,i);q=g;break}}else{yL(g,a,-1);q=g}while(0);a=f[q>>2]&4095;i=(a|0)==5;if((a+-5|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,24)|0;k=191634;l=j+24|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,191659,190836,1744);bD(h)}k=g+40|0;j=f[k>>2]|0;l=f[j+4>>2]|0;o=f[j>>2]|0;if(!((l+-3|0)>>>0<2&(o|0)==1)?!((l|0)==1&(o+-3|0)>>>0<2):0){f[h>>2]=0;f[h+4>>2]=0;Vac(aD(h,130)|0,191670,130)|0;bO(-215,h,191659,190836,1748);bD(h)}aM(c,3,1,a,-1,1,96);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[h>>2]=f[a>>2];o=h+4|0;l=a+4|0;f[o>>2]=f[l>>2];j=h+8|0;f[j>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[h+32>>2]=f[a+32>>2];m=f[a+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=j;j=h+48|0;r=h+44|0;f[r>>2]=j;f[j>>2]=0;f[h+52>>2]=0;if(m|0){j=m+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[l>>2]|0)<3){l=f[a+44>>2]|0;j=f[r>>2]|0;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];break}else{f[o>>2]=0;jL(h,a);break}}else yL(h,c,-1);while(0);c=f[g+12>>2]|0;a=(c+(f[g+8>>2]|0)|0)==5;o=g+16|0;if(i){if(a){i=f[o>>2]|0;s=0;t=+n[i>>2];v=i;w=i}else{i=f[o>>2]|0;s=-1;t=1.0;v=i;w=i}i=s+1|0;do if(!(f[q>>2]&16384)){l=f[k>>2]|0;do if((f[l>>2]|0)!=1){j=f[f[g+44>>2]>>2]|0;if((f[l+4>>2]|0)==1){x=v+(Y(j,i)|0)|0;break}else{r=(i|0)/(c|0)|0;x=v+(Y(r,j)|0)+(i-(Y(r,c)|0)<<2)|0;break}}else x=v+(i<<2)|0;while(0);y=+n[x>>2];l=s+2|0;r=f[k>>2]|0;do if((f[r>>2]|0)!=1){j=f[f[g+44>>2]>>2]|0;if((f[r+4>>2]|0)==1){z=v+(Y(j,l)|0)|0;break}else{m=(l|0)/(c|0)|0;z=v+(Y(m,j)|0)+(l-(Y(m,c)|0)<<2)|0;break}}else z=v+(l<<2)|0;while(0);A=+n[z>>2];l=s+3|0;r=f[k>>2]|0;if((f[r>>2]|0)!=1){m=f[f[g+44>>2]>>2]|0;if((f[r+4>>2]|0)==1){B=v+(Y(m,l)|0)|0;C=A;D=y;break}else{r=(l|0)/(c|0)|0;B=v+(Y(r,m)|0)+(l-(Y(r,c)|0)<<2)|0;C=A;D=y;break}}else{E=l;F=A;G=y;H=37}}else{E=s+3|0;F=+n[v+(s+2<<2)>>2];G=+n[w+(i<<2)>>2];H=37}while(0);if((H|0)==37){B=v+(E<<2)|0;C=F;D=G}I=+n[B>>2];J=C;K=D;P=t}else{if(a){a=f[o>>2]|0;Q=0;S=+p[a>>3];T=a;U=a}else{a=f[o>>2]|0;Q=-1;S=1.0;T=a;U=a}a=Q+1|0;do if(!(f[q>>2]&16384)){o=f[k>>2]|0;do if((f[o>>2]|0)!=1){B=f[f[g+44>>2]>>2]|0;if((f[o+4>>2]|0)==1){V=T+(Y(B,a)|0)|0;break}else{E=(a|0)/(c|0)|0;V=T+(Y(E,B)|0)+(a-(Y(E,c)|0)<<3)|0;break}}else V=T+(a<<3)|0;while(0);y=+p[V>>3];o=Q+2|0;E=f[k>>2]|0;do if((f[E>>2]|0)!=1){B=f[f[g+44>>2]>>2]|0;if((f[E+4>>2]|0)==1){W=T+(Y(B,o)|0)|0;break}else{v=(o|0)/(c|0)|0;W=T+(Y(v,B)|0)+(o-(Y(v,c)|0)<<3)|0;break}}else W=T+(o<<3)|0;while(0);t=+p[W>>3];o=Q+3|0;E=f[k>>2]|0;if((f[E>>2]|0)!=1){v=f[f[g+44>>2]>>2]|0;if((f[E+4>>2]|0)==1){X=T+(Y(v,o)|0)|0;Z=t;_=y;break}else{E=(o|0)/(c|0)|0;X=T+(Y(E,v)|0)+(o-(Y(E,c)|0)<<3)|0;Z=t;_=y;break}}else{$=o;aa=t;ba=y;H=58}}else{$=Q+3|0;aa=+p[T+(Q+2<<3)>>3];ba=+p[U+(a<<3)>>3];H=58}while(0);if((H|0)==58){X=T+($<<3)|0;Z=aa;_=ba}I=+p[X>>3];J=Z;K=_;P=S}do if(P==0.0){if(!(K==0.0)){S=J*J-K*4.0*I;if(!(S>=0.0)){ca=0.0;da=0;ea=0.0;fa=0.0;break}_=+M(+S);S=(_-J)*.5;Z=(J+_)*-.5;X=+L(+S)>+L(+Z);ba=X?S:Z;ca=0.0;da=_>0.0?2:1;ea=I/ba;fa=ba/K;break}if(J==0.0){ca=0.0;da=(I==0.0)<<31>>31;ea=0.0;fa=0.0;break}else{ca=0.0;da=1;ea=0.0;fa=-I/J;break}}else{ba=1.0/P;_=K*ba;Z=J*ba;S=(_*_-Z*3.0)*.1111111111111111;aa=(I*ba*27.0+(_*(_*(_*2.0))-Z*(_*9.0)))*.018518518518518517;Z=S*(S*S);ba=Z-aa*aa;if(ba>0.0){t=+M(+S)*-2.0;D=+R(+(aa/+M(+Z)))*.3333333333333333;Z=_*.3333333333333333;ca=t*+O(+(D+4.1887902047863905))-Z;da=3;ea=t*+O(+(D+2.0943951023931953))-Z;fa=t*+O(+D)-Z;break}if(!(ba==0.0)){Z=+N(+(+M(+-ba)+ +L(+aa)),.3333333333333333);ba=aa>0.0?-Z:Z;ca=0.0;da=1;ea=0.0;fa=ba+S/ba-_*.3333333333333333;break}ba=_/3.0;if(!(aa>=0.0)){_=+N(+-aa,.3333333333333333);ga=_*2.0;ha=-_}else{_=+N(+aa,.3333333333333333);ga=_*-2.0;ha=_}_=ha-ba;aa=ga-ba;X=aa==_;ca=0.0;da=X?1:2;ea=X?0.0:_;fa=aa}while(0);X=f[h>>2]|0;$=h+16|0;T=f[$>>2]|0;if((X&4095|0)==5){n[T>>2]=fa;do if(!(X&16384)){a=f[h+40>>2]|0;do if((f[a>>2]|0)!=1){U=f[f[h+44>>2]>>2]|0;if((f[a+4>>2]|0)==1){ia=T+U|0;break}else{Q=f[h+12>>2]|0;c=(Q+1|0)>>>0<3?Q:0;ia=T+(Y(c,U)|0)+(1-(Y(c,Q)|0)<<2)|0;break}}else ia=T+4|0;while(0);n[ia>>2]=ea;a=f[h+40>>2]|0;if((f[a>>2]|0)!=1){Q=f[f[h+44>>2]>>2]|0;if((f[a+4>>2]|0)==1){ja=T+(Q<<1)|0;break}else{a=f[h+12>>2]|0;c=2/(a|0)|0;ja=T+(Y(c,Q)|0)+(2-(Y(c,a)|0)<<2)|0;break}}else H=87}else{n[T+4>>2]=ea;H=87}while(0);if((H|0)==87)ja=T+8|0;n[ja>>2]=ca}else{p[T>>3]=fa;do if(!(X&16384)){ja=f[h+40>>2]|0;do if((f[ja>>2]|0)!=1){ia=f[f[h+44>>2]>>2]|0;if((f[ja+4>>2]|0)==1){ka=T+ia|0;break}else{a=f[h+12>>2]|0;c=(a+1|0)>>>0<3?a:0;ka=T+(Y(c,ia)|0)+(1-(Y(c,a)|0)<<3)|0;break}}else ka=T+8|0;while(0);p[ka>>3]=ea;ja=f[h+40>>2]|0;if((f[ja>>2]|0)!=1){a=f[f[h+44>>2]>>2]|0;if((f[ja+4>>2]|0)==1){la=T+(a<<1)|0;break}else{ja=f[h+12>>2]|0;c=2/(ja|0)|0;la=T+(Y(c,a)|0)+(2-(Y(c,ja)|0)<<3)|0;break}}else H=100}else{p[T+8>>3]=ea;H=100}while(0);if((H|0)==100)la=T+16|0;p[la>>3]=ca}la=h+36|0;T=f[la>>2]|0;if(T|0?(H=T+12|0,T=f[H>>2]|0,f[H>>2]=T+-1,(T|0)==1):0)kL(h);f[la>>2]=0;la=h+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[la>>2]|0)>0){$=f[h+40>>2]|0;T=0;do{f[$+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[la>>2]|0))}la=f[h+44>>2]|0;if((la|0)!=(h+48|0))UC(la);la=g+36|0;h=f[la>>2]|0;if(h|0?(T=h+12|0,h=f[T>>2]|0,f[T>>2]=h+-1,(h|0)==1):0)kL(g);f[la>>2]=0;la=g+16|0;h=g+4|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[h>>2]|0)>0){la=f[k>>2]|0;k=0;do{f[la+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))UC(h);if(!(f[e+4>>2]|0)){u=d;return da|0}u=d;return da|0}function iP(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0;e=u;u=u+1552|0;g=e+1528|0;h=e+1520|0;i=e+1464|0;j=e+1408|0;k=e;l=e+1344|0;m=e+1400|0;n=e+1288|0;o=e+1176|0;q=e+1160|0;r=e+1232|0;dQ(h,43196);do if((yM(a)|0)==65536){s=f[a+4>>2]|0;f[i>>2]=f[s>>2];t=i+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=i+8|0;f[w>>2]=f[s+8>>2];f[i+12>>2]=f[s+12>>2];f[i+16>>2]=f[s+16>>2];f[i+20>>2]=f[s+20>>2];f[i+24>>2]=f[s+24>>2];f[i+28>>2]=f[s+28>>2];f[i+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[i+36>>2]=x;f[i+40>>2]=w;w=i+48|0;y=i+44|0;f[y>>2]=w;f[w>>2]=0;f[i+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;jL(i,s);break}}else yL(i,a,-1);while(0);s=BL(a,-1)|0;a=s&7;if(!(a>>>0>4?((s>>>3&511)+1|0)>>>0<3:0)){f[g>>2]=0;f[g+4>>2]=0;z=aD(g,81)|0;A=191845;B=z+81|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,g,191927,190836,1895);bD(g)}s=i+8|0;t=f[s>>2]|0;v=i+12|0;if((t|0)!=1)if((f[v>>2]|0)==1)C=t;else{f[g>>2]=0;f[g+4>>2]=0;z=aD(g,38)|0;A=191937;B=z+38|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,g,191927,190836,1896);bD(g);C=f[s>>2]|0}else C=1;s=f[v>>2]|0;v=s+-2+C|0;aM(c,v,1,a|8,-1,1,96);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[j>>2]=f[a>>2];A=j+4|0;t=a+4|0;f[A>>2]=f[t>>2];w=j+8|0;f[w>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[j+36>>2]=y;f[j+40>>2]=w;w=j+48|0;x=j+44|0;f[x>>2]=w;f[w>>2]=0;f[j+52>>2]=0;if(y|0){w=y+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[t>>2]|0)<3){t=f[a+44>>2]|0;w=f[x>>2]|0;f[w>>2]=f[t>>2];f[w+4>>2]=f[t+4>>2];break}else{f[A>>2]=0;jL(j,a);break}}else yL(j,c,-1);while(0);c=(v<<1)+2|0;a=k+8|0;Nac(a|0,0,1152)|0;f[k>>2]=a;A=k+4|0;f[A>>2]=c;if(c>>>0>72){t=N5b(c>>>0>268435455?-1:c<<4)|0;Nac(t|0,0,c<<4|0)|0;f[k>>2]=t;D=t}else D=a;t=D+(v<<4)+16|0;c=i+40|0;w=f[c>>2]|0;x=f[w>>2]|0;f[m>>2]=f[w+4>>2];f[m+4>>2]=x;x=((f[i>>2]|0)>>>3&511)+1|0;JF(l,m,(x<<3)+-2|0,(x|0)==2?D:t,0);x=g+8|0;f[x>>2]=0;f[x+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=l;OJ(i,g,f[l>>2]&4095,1.0,0.0);if(!(f[i>>2]&4088))if((v|0)<0){E=v;F=0}else{x=s+C+-1|0;C=0;do{p[D+(C<<4)>>3]=+p[t+(C<<3)>>3];p[D+(C<<4)+8>>3]=0.0;C=C+1|0}while((C|0)!=(x|0));G=26}else G=26;do if((G|0)==26){if((v|0)<=1)if((v|0)==1){H=1;I=1}else{E=v;F=0;break}else{x=v;while(1){J=+L(+(+p[D+(x<<4)>>3]));if(J+ +L(+(+p[D+(x<<4)+8>>3]))>2.220446049250313e-16){K=x;break}x=x+-1|0;if((x|0)<=1){K=1;break}}H=K;I=(K|0)>0}x=0;J=1.0;O=0.0;while(1){C=t+(x<<4)|0;p[C>>3]=J;p[C+8>>3]=O;P=J+O;x=x+1|0;if((x|0)==(H|0)){E=H;F=I;break}else{J=J-O;O=P}}}while(0);I=(d|0)<1?1e3:d;a:do if((I|0)>0){d=D+(E<<4)|0;H=D+(E<<4)+8|0;K=n+4|0;x=n+8|0;C=n+40|0;s=n+48|0;m=n+44|0;w=n+52|0;y=g+4|0;Q=o+4|0;R=o+8|0;S=o+40|0;T=o+48|0;U=o+44|0;V=o+52|0;W=n+16|0;X=n+12|0;Z=g+8|0;_=g+12|0;$=g+4|0;aa=q+8|0;ba=q+4|0;ca=o+16|0;da=o+36|0;ea=n+36|0;fa=0;while(1){if(F){ga=0.0;ha=0}else{ia=0.0;break a}do{ja=t+(ha<<4)|0;O=+p[ja>>3];ka=ja+8|0;J=+p[ka>>3];P=+p[d>>3];la=+p[H>>3];ma=0;na=1;oa=P;pa=P;P=la;qa=la;while(1){ra=E-ma+-1|0;la=pa;pa=O*pa-J*P+ +p[D+(ra<<4)>>3];P=J*la+O*P+ +p[D+(ra<<4)+8>>3];do if((ma|0)!=(ha|0)){ra=t+(ma<<4)|0;la=O-+p[ra>>3];sa=J-+p[ra+8>>3];if(la!=0.0|sa!=0.0){ta=na;ua=oa*la-qa*sa;va=qa*la+oa*sa;break}else{ta=na+1|0;ua=oa;va=qa;break}}else{ta=na;ua=oa;va=qa}while(0);ma=ma+1|0;if((ma|0)==(E|0))break;else{na=ta;oa=ua;qa=va}}qa=1.0/(ua*ua+va*va);oa=qa*(ua*pa+va*P);sa=qa*(ua*P-va*pa);if((ta|0)>1){if(((ta<<31>>31)+(ta>>>1)|0)>0){qa=oa+ +M(+(oa*oa+sa*sa));la=+M(+(qa*.5));wa=+M(+((qa-oa)*.5));xa=la;ya=oa<0.0?-wa:wa}else{xa=oa;ya=sa}if(!(ta&1)){za=xa;Aa=ya}else{f[n>>2]=1124007936;z=K;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[C>>2]=x;f[m>>2]=s;f[s>>2]=0;f[w>>2]=0;f[g>>2]=4;f[y>>2]=1;hL(n,2,g,6);f[o>>2]=1124007936;z=Q;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[S>>2]=R;f[U>>2]=T;f[T>>2]=0;f[V>>2]=0;f[g>>2]=3;f[y>>2]=1;hL(o,2,g,14);pa=-+N(+oa,3.0);na=(f[n>>2]&16384|0)==0;ma=f[W>>2]|0;do if(na?(ra=f[C>>2]|0,(f[ra>>2]|0)!=1):0){Ba=f[f[m>>2]>>2]|0;if((f[ra+4>>2]|0)==1){Ca=ma+(Ba*3|0)|0;break}else{ra=f[X>>2]|0;Da=3/(ra|0)|0;Ca=ma+(Y(Da,Ba)|0)+(3-(Y(Da,ra)|0)<<3)|0;break}}else G=49;while(0);if((G|0)==49){G=0;Ca=ma+24|0}p[Ca>>3]=pa;P=-(oa*oa*15.0+sa*sa*27.0);do if(na){ra=f[C>>2]|0;do if((f[ra>>2]|0)!=1){Da=f[f[m>>2]>>2]|0;if((f[ra+4>>2]|0)==1){Ea=ma+(Da<<1)|0;break}else{Ba=f[X>>2]|0;Fa=2/(Ba|0)|0;Ea=ma+(Y(Fa,Da)|0)+(2-(Y(Fa,Ba)|0)<<3)|0;break}}else Ea=ma+16|0;while(0);p[Ea>>3]=P;wa=oa*-48.0;ra=f[C>>2]|0;if((f[ra>>2]|0)!=1){Ba=f[f[m>>2]>>2]|0;if((f[ra+4>>2]|0)==1){Ga=ma+Ba|0;Ha=wa;break}else{ra=f[X>>2]|0;Fa=(ra+1|0)>>>0<3?ra:0;Ga=ma+(Y(Fa,Ba)|0)+(1-(Y(Fa,ra)|0)<<3)|0;Ha=wa;break}}else{Ia=wa;G=61}}else{p[ma+16>>3]=P;Ia=oa*-48.0;G=61}while(0);if((G|0)==61){G=0;Ga=ma+8|0;Ha=Ia}p[Ga>>3]=Ha;p[ma>>3]=64.0;f[Z>>2]=0;f[_>>2]=0;f[g>>2]=16842752;f[$>>2]=n;na=aa;f[na>>2]=0;f[na+4>>2]=0;f[q>>2]=33619968;f[ba>>2]=o;hP(g,q)|0;P=+p[f[ca>>2]>>3];if(!(P>=0.0))Ja=-+N(+-P,.3333333333333333);else Ja=+N(+P,.3333333333333333);P=+M(+(Ja*Ja/3.0-oa/(Ja*3.0)));na=f[da>>2]|0;do if(na|0){ra=na+12|0;Fa=f[ra>>2]|0;f[ra>>2]=Fa+-1;if((Fa|0)!=1)break;kL(o)}while(0);f[da>>2]=0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[Q>>2]|0)>0){na=f[S>>2]|0;ma=0;do{f[na+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[Q>>2]|0))}ma=f[U>>2]|0;if((ma|0)!=(T|0))UC(ma);ma=f[ea>>2]|0;do if(ma|0){na=ma+12|0;Fa=f[na>>2]|0;f[na>>2]=Fa+-1;if((Fa|0)!=1)break;kL(n)}while(0);f[ea>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[K>>2]|0)>0){ma=f[C>>2]|0;Fa=0;do{f[ma+(Fa<<2)>>2]=0;Fa=Fa+1|0}while((Fa|0)<(f[K>>2]|0))}Fa=f[m>>2]|0;if((Fa|0)!=(s|0))UC(Fa);za=Ja;Aa=P}}else{za=oa;Aa=sa}p[ja>>3]=O-za;p[ka>>3]=J-Aa;pa=+M(+(za*za+Aa*Aa));ga=ga<pa?pa:ga;ha=ha+1|0}while((ha|0)<(E|0));fa=fa+1|0;if(!(!(ga<=0.0)&(fa|0)<(I|0))){Ka=ga;G=87;break}}}else{Ka=0.0;G=87}while(0);if((G|0)==87)if((f[i>>2]&4088|0)==0&F){F=0;do{G=t+(F<<4)+8|0;if(+L(+(+p[G>>3]))<1.0e-100)p[G>>3]=0.0;F=F+1|0}while((F|0)!=(E|0));ia=Ka}else ia=Ka;if((E|0)<(v|0)){F=E;do{E=t+(F<<4)|0;F=F+1|0;G=t+(F<<4)|0;f[G>>2]=f[E>>2];f[G+4>>2]=f[E+4>>2];f[G+8>>2]=f[E+8>>2];f[G+12>>2]=f[E+12>>2]}while((F|0)!=(v|0))}v=j+40|0;F=f[v>>2]|0;E=f[F+4>>2]|0;G=f[F>>2]|0;F=r+4|0;f[F>>2]=2;I=r+8|0;f[I>>2]=G;f[r+12>>2]=E;ha=r+16|0;f[ha>>2]=t;f[r+20>>2]=t;n=r+24|0;o=r+40|0;q=n+8|0;f[q>>2]=0;f[q+4>>2]=0;f[o>>2]=I;I=r+48|0;q=r+44|0;f[q>>2]=I;Ga=E<<4;f[r>>2]=1124024334;f[I>>2]=Ga;f[r+52>>2]=16;E=t+(Y(G,Ga)|0)|0;f[r+28>>2]=E;f[n>>2]=E+(0-Ga)+Ga;Ga=g+8|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;OJ(r,g,f[j>>2]&4095,1.0,0.0);g=r+36|0;Ga=f[g>>2]|0;if(Ga|0?(E=Ga+12|0,Ga=f[E>>2]|0,f[E>>2]=Ga+-1,(Ga|0)==1):0)kL(r);f[g>>2]=0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[F>>2]|0)>0){ha=f[o>>2]|0;o=0;do{f[ha+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[F>>2]|0))}F=f[q>>2]|0;if((F|0)!=(I|0))UC(F);F=l+36|0;I=f[F>>2]|0;if(I|0?(q=I+12|0,I=f[q>>2]|0,f[q>>2]=I+-1,(I|0)==1):0)kL(l);f[F>>2]=0;F=l+16|0;I=l+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[I>>2]|0)>0){F=f[l+40>>2]|0;q=0;do{f[F+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[I>>2]|0))}I=f[l+44>>2]|0;if((I|0)!=(l+48|0))UC(I);I=f[k>>2]|0;if((I|0)!=(a|0)){if(I|0)P5b(I);f[k>>2]=a;f[A>>2]=72}A=j+36|0;a=f[A>>2]|0;if(a|0?(k=a+12|0,a=f[k>>2]|0,f[k>>2]=a+-1,(a|0)==1):0)kL(j);f[A>>2]=0;A=j+16|0;a=j+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[a>>2]|0)>0){A=f[v>>2]|0;v=0;do{f[A+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[a>>2]|0))}a=f[j+44>>2]|0;if((a|0)!=(j+48|0))UC(a);a=i+36|0;j=f[a>>2]|0;do if(j|0){v=j+12|0;A=f[v>>2]|0;f[v>>2]=A+-1;if((A|0)!=1)break;kL(i)}while(0);f[a>>2]=0;a=i+16|0;j=i+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[j>>2]|0)>0){a=f[c>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))UC(j);if(!(f[h+4>>2]|0)){u=e;return +ia}u=e;return +ia}function jP(){var a=0,b=0,c=0,d=0,e=0,g=0;a=u;u=u+16|0;b=a;c=(qO(pO()|0)|0)+16|0;d=f[c>>2]|0;if((d|0)>=0){e=d;g=(e|0)>0;u=a;return g|0}dQ(b,43216);f[c>>2]=0;e=0;g=(e|0)>0;u=a;return g|0}function kP(a,c){a=a|0;c=c|0;if(!c)return;kP(a,f[c>>2]|0);kP(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(c);return}function lP(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=ZVb(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=ZVb(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function mP(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=(c|0)==(a|0);b[c+12>>0]=d&1;if(d)return;else e=c;while(1){g=f[e+8>>2]|0;c=g+12|0;if(b[c>>0]|0){h=23;break}i=g+8|0;j=f[i>>2]|0;d=f[j>>2]|0;if((d|0)==(g|0)){k=f[j+4>>2]|0;if(!k){h=7;break}l=k+12|0;if(!(b[l>>0]|0))m=l;else{h=7;break}}else{if(!d){h=16;break}l=d+12|0;if(!(b[l>>0]|0))m=l;else{h=16;break}}b[c>>0]=1;c=(j|0)==(a|0);b[j+12>>0]=c&1;b[m>>0]=1;if(c){h=23;break}else e=j}if((h|0)==7){if((f[g>>2]|0)==(e|0)){n=g;o=j}else{m=g+4|0;a=f[m>>2]|0;c=f[a>>2]|0;f[m>>2]=c;if(!c)p=j;else{f[c+8>>2]=g;p=f[i>>2]|0}f[a+8>>2]=p;p=f[i>>2]|0;f[((f[p>>2]|0)==(g|0)?p:p+4|0)>>2]=a;f[a>>2]=g;f[i>>2]=a;n=a;o=f[a+8>>2]|0}b[n+12>>0]=1;b[o+12>>0]=0;n=f[o>>2]|0;a=n+4|0;p=f[a>>2]|0;f[o>>2]=p;if(p|0)f[p+8>>2]=o;p=o+8|0;f[n+8>>2]=f[p>>2];c=f[p>>2]|0;f[((f[c>>2]|0)==(o|0)?c:c+4|0)>>2]=n;f[a>>2]=o;f[p>>2]=n;return}else if((h|0)==16){if((f[g>>2]|0)==(e|0)){e=f[g>>2]|0;n=e+4|0;p=f[n>>2]|0;f[g>>2]=p;if(!p)q=j;else{f[p+8>>2]=g;q=f[i>>2]|0}f[e+8>>2]=q;q=f[i>>2]|0;f[((f[q>>2]|0)==(g|0)?q:q+4|0)>>2]=e;f[n>>2]=g;f[i>>2]=e;r=e;s=f[e+8>>2]|0}else{r=g;s=j}b[r+12>>0]=1;b[s+12>>0]=0;r=s+4|0;j=f[r>>2]|0;g=f[j>>2]|0;f[r>>2]=g;if(g|0)f[g+8>>2]=s;g=s+8|0;f[j+8>>2]=f[g>>2];r=f[g>>2]|0;f[((f[r>>2]|0)==(s|0)?r:r+4|0)>>2]=j;f[j>>2]=s;f[g>>2]=j;return}else if((h|0)==23)return}function nP(a){a=a|0;var c=0;c=f[a>>2]|0;f[a>>2]=c+-1;if((c|0)!=1)return;if((a|0)==0|(b[1119609]|0)!=0)return;c=a+4|0;if(f[c>>2]|0)f[c>>2]=0;c=f[a+12>>2]|0;if(c|0)nP(c);O5b(a);return}function oP(a){a=a|0;f[a>>2]=0;return}function pP(a){a=a|0;var b=0;b=f[a>>2]|0;if(!b)return;nP(b);return}function qP(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+32|0;_5b(d,c)|0;c=a+44|0;f[c>>2]=0;e=a+48|0;g=f[e>>2]|0;if(g&8|0){h=b[d+11>>0]|0;if(h<<24>>24<0){i=f[d>>2]|0;j=i;k=i;l=i+(f[a+36>>2]|0)|0}else{j=d;k=d;l=d+(h&255)|0}f[c>>2]=l;f[a+8>>2]=j;f[a+12>>2]=k;f[a+16>>2]=l}if(!(g&16))return;g=d+11|0;l=b[g>>0]|0;if(l<<24>>24<0){k=f[a+36>>2]|0;f[c>>2]=(f[d>>2]|0)+k;m=(f[a+40>>2]&2147483647)+-1|0;n=k}else{k=l&255;f[c>>2]=d+k;m=10;n=k}e6b(d,m,0);m=b[g>>0]|0;if(m<<24>>24<0){g=f[d>>2]|0;o=g;p=f[a+36>>2]|0;q=g}else{o=d;p=m&255;q=d}d=a+24|0;f[d>>2]=q;f[a+20>>2]=q;f[a+28>>2]=o+p;if(!(f[e>>2]&3))return;f[d>>2]=q+n;return}function rP(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e+12|0;h=e;i=e+8|0;_Xb(h,a);if(!(b[h>>0]|0)){$Xb(h);u=e;return a|0}j=(f[a>>2]|0)+-12|0;f[i>>2]=f[a+(f[j>>2]|0)+24>>2];k=a+(f[j>>2]|0)|0;j=f[k+4>>2]|0;l=c+d|0;d=k+76|0;m=f[d>>2]|0;if((m|0)==-1){TXb(g,k);n=xZb(g,855500)|0;o=Uh[f[(f[n>>2]|0)+28>>2]&1023](n,32)|0;yZb(g);n=o<<24>>24;f[d>>2]=n;p=n}else p=m;f[g>>2]=f[i>>2];if(uP(g,c,(j&176|0)==32?l:c,l,k,p&255)|0){$Xb(h);u=e;return a|0}p=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(p,f[p+16>>2]|5);$Xb(h);u=e;return a|0}function sP(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=f[c+48>>2]|0;if(d&16|0){e=c+44|0;g=f[e>>2]|0;h=f[c+24>>2]|0;if(g>>>0<h>>>0){f[e>>2]=h;i=h}else i=g;g=f[c+20>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=i-g|0;if(h>>>0>4294967279)V5b(a);if(h>>>0<11){b[a+11>>0]=h;j=a}else{e=h+16&-16;k=L5b(e)|0;f[a>>2]=k;f[a+8>>2]=e|-2147483648;f[a+4>>2]=h;j=k}if((g|0)==(i|0))l=j;else{k=j;e=g;while(1){b[k>>0]=b[e>>0]|0;e=e+1|0;if((e|0)==(i|0))break;else k=k+1|0}l=j+h|0}b[l>>0]=0;return}if(!(d&8)){f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}d=f[c+8>>2]|0;l=f[c+16>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=l-d|0;if(c>>>0>4294967279)V5b(a);if(c>>>0<11){b[a+11>>0]=c;m=a}else{h=c+16&-16;j=L5b(h)|0;f[a>>2]=j;f[a+8>>2]=h|-2147483648;f[a+4>>2]=c;m=j}if((d|0)==(l|0))n=m;else{j=m;a=d;while(1){b[j>>0]=b[a>>0]|0;a=a+1|0;if((a|0)==(l|0))break;else j=j+1|0}n=m+c|0}b[n>>0]=0;return}function tP(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=43248;c=a+56|0;f[c>>2]=43268;d=a+4|0;f[d>>2]=43284;e=a+36|0;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);FWb(d);BXb(a,43344);AWb(c);return}function uP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;i=u;u=u+16|0;j=i;k=f[a>>2]|0;if(!k){l=0;u=i;return l|0}m=e;e=c;n=m-e|0;o=g+12|0;g=f[o>>2]|0;p=(g|0)>(n|0)?g-n|0:0;n=d;g=n-e|0;if((g|0)>0?(li[f[(f[k>>2]|0)+48>>2]&511](k,c,g)|0)!=(g|0):0){f[a>>2]=0;l=0;u=i;return l|0}if((p|0)>0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(p>>>0<11){g=j+11|0;b[g>>0]=p;q=j;r=g;s=j}else{g=p+16&-16;c=L5b(g)|0;f[j>>2]=c;f[j+8>>2]=g|-2147483648;f[j+4>>2]=p;q=c;r=j+11|0;s=j}Nac(q|0,h|0,p|0)|0;b[q+p>>0]=0;if((li[f[(f[k>>2]|0)+48>>2]&511](k,(b[r>>0]|0)<0?f[s>>2]|0:j,p)|0)==(p|0)){t=1;v=k}else{f[a>>2]=0;t=0;v=0}if((b[r>>0]|0)<0)O5b(f[s>>2]|0);if(t)w=v;else{l=0;u=i;return l|0}}else w=k;k=m-n|0;if((k|0)>0?(li[f[(f[w>>2]|0)+48>>2]&511](w,d,k)|0)!=(k|0):0){f[a>>2]=0;l=0;u=i;return l|0}f[o>>2]=0;l=w;u=i;return l|0}function vP(a){a=a|0;var c=0;f[a>>2]=43284;c=a+32|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);FWb(a);return}function wP(a){a=a|0;var c=0;f[a>>2]=43284;c=a+32|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);FWb(a);O5b(a);return}function xP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=c+44|0;j=f[i>>2]|0;k=c+24|0;l=f[k>>2]|0;m=l;if(j>>>0<l>>>0){f[i>>2]=l;n=m}else n=j;j=h&24;a:do if((j|0)!=0?!((g|0)==1&(j|0)==24):0){b:do switch(g|0){case 0:{o=0;p=0;break}case 1:{if(!(h&8)){i=m-(f[c+20>>2]|0)|0;o=i;p=((i|0)<0)<<31>>31;break b}else{i=(f[c+12>>2]|0)-(f[c+8>>2]|0)|0;o=i;p=((i|0)<0)<<31>>31;break b}break}case 2:{i=c+32|0;if((b[i+11>>0]|0)<0)q=f[i>>2]|0;else q=i;i=n-q|0;o=i;p=((i|0)<0)<<31>>31;break}default:{r=-1;s=-1;break a}}while(0);i=Kac(o|0,p|0,d|0,e|0)|0;t=J;if((t|0)>=0){u=c+32|0;if((b[u+11>>0]|0)<0)v=f[u>>2]|0;else v=u;u=n-v|0;w=((u|0)<0)<<31>>31;if(!((w|0)<(t|0)|(w|0)==(t|0)&u>>>0<i>>>0)){u=h&8;if(!((i|0)==0&(t|0)==0)){if(u|0?(f[c+12>>2]|0)==0:0){r=-1;s=-1;break}if((h&16|0)!=0&(l|0)==0){r=-1;s=-1;break}}if(u|0){f[c+12>>2]=(f[c+8>>2]|0)+i;f[c+16>>2]=n}if(!(h&16)){r=i;s=t}else{f[k>>2]=(f[c+20>>2]|0)+i;r=i;s=t}}else{r=-1;s=-1}}else{r=-1;s=-1}}else{r=-1;s=-1}while(0);c=a;f[c>>2]=0;f[c+4>>2]=0;c=a+8|0;f[c>>2]=r;f[c+4>>2]=s;return}function yP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=c+8|0;Wg[f[(f[b>>2]|0)+16>>2]&127](a,b,f[e>>2]|0,f[e+4>>2]|0,0,d);return}function zP(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,i=0;b=a+44|0;c=f[b>>2]|0;d=f[a+24>>2]|0;if(c>>>0<d>>>0){f[b>>2]=d;e=d}else e=c;if(!(f[a+48>>2]&8)){g=-1;return g|0}c=a+16|0;d=f[c>>2]|0;if(d>>>0<e>>>0){f[c>>2]=e;i=e}else i=d;d=f[a+12>>2]|0;if(d>>>0>=i>>>0){g=-1;return g|0}g=h[d>>0]|0;return g|0}function AP(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+44|0;e=f[d>>2]|0;g=f[a+24>>2]|0;if(e>>>0<g>>>0){f[d>>2]=g;h=g}else h=e;e=h;h=a+12|0;g=f[h>>2]|0;if((f[a+8>>2]|0)>>>0>=g>>>0){i=-1;return i|0}if((c|0)==-1){f[h>>2]=g+-1;f[a+16>>2]=e;i=0;return i|0}if(!(f[a+48>>2]&16)){d=c&255;j=g+-1|0;if(d<<24>>24==(b[j>>0]|0)){k=d;l=j}else{i=-1;return i|0}}else{k=c&255;l=g+-1|0}f[h>>2]=l;f[a+16>>2]=e;b[l>>0]=k;i=c;return i|0}function BP(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+16|0;e=d;if((c|0)==-1){g=0;u=d;return g|0}h=a+12|0;i=a+8|0;j=(f[h>>2]|0)-(f[i>>2]|0)|0;k=a+24|0;l=f[k>>2]|0;m=a+28|0;n=f[m>>2]|0;if((l|0)==(n|0)){o=a+48|0;if(!(f[o>>2]&16)){g=-1;u=d;return g|0}p=a+20|0;q=f[p>>2]|0;r=a+44|0;s=(f[r>>2]|0)-q|0;t=a+32|0;l6b(t,0);v=t+11|0;if((b[v>>0]|0)<0)w=(f[a+40>>2]&2147483647)+-1|0;else w=10;e6b(t,w,0);w=b[v>>0]|0;if(w<<24>>24<0){x=f[t>>2]|0;y=f[a+36>>2]|0}else{x=t;y=w&255}w=x+y|0;f[p>>2]=x;f[m>>2]=w;m=x+(l-q)|0;f[k>>2]=m;q=x+s|0;f[r>>2]=q;z=r;A=o;B=r;C=m;D=q;E=w}else{w=a+44|0;z=w;A=a+48|0;B=w;C=l;D=f[w>>2]|0;E=n}n=C+1|0;f[e>>2]=n;w=f[(n>>>0<D>>>0?B:e)>>2]|0;f[z>>2]=w;if(f[A>>2]&8|0){A=a+32|0;if((b[A+11>>0]|0)<0)F=f[A>>2]|0;else F=A;f[i>>2]=F;f[h>>2]=F+j;f[a+16>>2]=w}if((C|0)==(E|0)){g=Uh[f[(f[a>>2]|0)+52>>2]&1023](a,c&255)|0;u=d;return g|0}else{f[k>>2]=n;b[C>>0]=c;g=c&255;u=d;return g|0}return 0}function CP(a){a=a|0;tP(a);O5b(a);return}function DP(a){a=a|0;tP(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function EP(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;tP(b);O5b(b);return}function FP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function GP(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if((k|0)!=0&(j|0)>0){l=a;m=d;n=g;o=k}else return;while(1){k=0;do{if(b[m+k>>0]|0)b[n+k>>0]=b[l+k>>0]|0;k=k+1|0}while((k|0)!=(j|0));o=o+-1|0;if(!o)break;else{l=l+c|0;m=m+e|0;n=n+h|0}}return}function HP(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;k=f[j>>2]|0;l=f[j+4>>2]|0;if((l|0)!=0&(k|0)>0){m=a;n=e;o=h;p=l}else return;while(1){l=0;do{if(b[n+l>>0]|0)d[o+(l<<1)>>1]=d[m+(l<<1)>>1]|0;l=l+1|0}while((l|0)!=(k|0));p=p+-1|0;if(!p)break;else{m=m+c|0;n=n+g|0;o=o+i|0}}return}function IP(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q*3|0)|0;s=m+(q*3|0)|0;b[r>>0]=b[s>>0]|0;b[r+1>>0]=b[s+1>>0]|0;b[r+2>>0]=b[s+2>>0]|0}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k*3|0)|0;l=m+(k*3|0)|0;b[p>>0]=b[l>>0]|0;b[p+1>>0]=b[l+1>>0]|0;b[p+2>>0]=b[l+2>>0]|0}l=k|1;if(b[a+l>>0]|0){p=d+(l*3|0)|0;q=m+(l*3|0)|0;b[p>>0]=b[q>>0]|0;b[p+1>>0]=b[q+1>>0]|0;b[p+2>>0]=b[q+2>>0]|0}q=k|2;if(b[a+q>>0]|0){p=d+(q*3|0)|0;l=m+(q*3|0)|0;b[p>>0]=b[l>>0]|0;b[p+1>>0]=b[l+1>>0]|0;b[p+2>>0]=b[l+2>>0]|0}l=k|3;if(b[a+l>>0]|0){p=d+(l*3|0)|0;q=m+(l*3|0)|0;b[p>>0]=b[q>>0]|0;b[p+1>>0]=b[q+1>>0]|0;b[p+2>>0]=b[q+2>>0]|0}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k*3|0)|0;p=m+(k*3|0)|0;b[q>>0]=b[p>>0]|0;b[q+1>>0]=b[p+1>>0]|0;b[q+2>>0]=b[p+2>>0]|0}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function JP(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0)f[o+(q<<2)>>2]=f[m+(q<<2)>>2];q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0)f[d+(k<<2)>>2]=f[m+(k<<2)>>2];p=k|1;if(b[a+p>>0]|0)f[d+(p<<2)>>2]=f[m+(p<<2)>>2];p=k|2;if(b[a+p>>0]|0)f[d+(p<<2)>>2]=f[m+(p<<2)>>2];p=k|3;if(b[a+p>>0]|0)f[d+(p<<2)>>2]=f[m+(p<<2)>>2];k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0)f[d+(k<<2)>>2]=f[m+(k<<2)>>2];k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function KP(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=f[j>>2]|0;l=f[j+4>>2]|0;if(!l)return;j=k+-4|0;if((k|0)<4){m=(k|0)>0;n=a;o=e;p=h;q=l;while(1){q=q+-1|0;if(m){r=0;do{if(b[o+r>>0]|0){s=p+(r*6|0)|0;t=n+(r*6|0)|0;d[s>>1]=d[t>>1]|0;d[s+2>>1]=d[t+2>>1]|0;d[s+4>>1]=d[t+4>>1]|0}r=r+1|0}while((r|0)!=(k|0))}if(!q)break;else{n=n+c|0;o=o+g|0;p=p+i|0}}return}p=k&-4;o=(p|0)<(k|0);n=a;a=e;e=h;h=l;while(1){l=0;do{if(b[a+l>>0]|0){q=e+(l*6|0)|0;m=n+(l*6|0)|0;d[q>>1]=d[m>>1]|0;d[q+2>>1]=d[m+2>>1]|0;d[q+4>>1]=d[m+4>>1]|0}m=l|1;if(b[a+m>>0]|0){q=e+(m*6|0)|0;r=n+(m*6|0)|0;d[q>>1]=d[r>>1]|0;d[q+2>>1]=d[r+2>>1]|0;d[q+4>>1]=d[r+4>>1]|0}r=l|2;if(b[a+r>>0]|0){q=e+(r*6|0)|0;m=n+(r*6|0)|0;d[q>>1]=d[m>>1]|0;d[q+2>>1]=d[m+2>>1]|0;d[q+4>>1]=d[m+4>>1]|0}m=l|3;if(b[a+m>>0]|0){q=e+(m*6|0)|0;r=n+(m*6|0)|0;d[q>>1]=d[r>>1]|0;d[q+2>>1]=d[r+2>>1]|0;d[q+4>>1]=d[r+4>>1]|0}l=l+4|0}while((l|0)<=(j|0));h=h+-1|0;if(o){l=p;do{if(b[a+l>>0]|0){r=e+(l*6|0)|0;q=n+(l*6|0)|0;d[r>>1]=d[q>>1]|0;d[r+2>>1]=d[q+2>>1]|0;d[r+4>>1]=d[q+4>>1]|0}l=l+1|0}while((l|0)!=(k|0))}if(!h)break;else{n=n+c|0;a=a+g|0;e=e+i|0}}return}function LP(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=m+(q<<3)|0;s=f[r+4>>2]|0;t=o+(q<<3)|0;f[t>>2]=f[r>>2];f[t+4>>2]=s}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=m+(k<<3)|0;l=f[p+4>>2]|0;q=d+(k<<3)|0;f[q>>2]=f[p>>2];f[q+4>>2]=l}l=k|1;if(b[a+l>>0]|0){q=m+(l<<3)|0;p=f[q+4>>2]|0;s=d+(l<<3)|0;f[s>>2]=f[q>>2];f[s+4>>2]=p}p=k|2;if(b[a+p>>0]|0){s=m+(p<<3)|0;q=f[s+4>>2]|0;l=d+(p<<3)|0;f[l>>2]=f[s>>2];f[l+4>>2]=q}q=k|3;if(b[a+q>>0]|0){l=m+(q<<3)|0;s=f[l+4>>2]|0;p=d+(q<<3)|0;f[p>>2]=f[l>>2];f[p+4>>2]=s}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){s=m+(k<<3)|0;p=f[s+4>>2]|0;l=d+(k<<3)|0;f[l>>2]=f[s>>2];f[l+4>>2]=p}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function MP(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q*12|0)|0;s=m+(q*12|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k*12|0)|0;l=m+(k*12|0)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2]}l=k|1;if(b[a+l>>0]|0){p=d+(l*12|0)|0;q=m+(l*12|0)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2]}q=k|2;if(b[a+q>>0]|0){p=d+(q*12|0)|0;l=m+(q*12|0)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2]}l=k|3;if(b[a+l>>0]|0){p=d+(l*12|0)|0;q=m+(l*12|0)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2]}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k*12|0)|0;p=m+(k*12|0)|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];f[q+8>>2]=f[p+8>>2]}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function NP(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q<<4)|0;s=m+(q<<4)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k<<4)|0;l=m+(k<<4)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2]}l=k|1;if(b[a+l>>0]|0){p=d+(l<<4)|0;q=m+(l<<4)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2]}q=k|2;if(b[a+q>>0]|0){p=d+(q<<4)|0;l=m+(q<<4)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2]}l=k|3;if(b[a+l>>0]|0){p=d+(l<<4)|0;q=m+(l<<4)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2]}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k<<4)|0;p=m+(k<<4)|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];f[q+8>>2]=f[p+8>>2];f[q+12>>2]=f[p+12>>2]}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function OP(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q*24|0)|0;s=m+(q*24|0)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k*24|0)|0;l=m+(k*24|0)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];f[p+16>>2]=f[l+16>>2];f[p+20>>2]=f[l+20>>2]}l=k|1;if(b[a+l>>0]|0){p=d+(l*24|0)|0;q=m+(l*24|0)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2];f[p+16>>2]=f[q+16>>2];f[p+20>>2]=f[q+20>>2]}q=k|2;if(b[a+q>>0]|0){p=d+(q*24|0)|0;l=m+(q*24|0)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];f[p+16>>2]=f[l+16>>2];f[p+20>>2]=f[l+20>>2]}l=k|3;if(b[a+l>>0]|0){p=d+(l*24|0)|0;q=m+(l*24|0)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2];f[p+16>>2]=f[q+16>>2];f[p+20>>2]=f[q+20>>2]}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k*24|0)|0;p=m+(k*24|0)|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];f[q+8>>2]=f[p+8>>2];f[q+12>>2]=f[p+12>>2];f[q+16>>2]=f[p+16>>2];f[q+20>>2]=f[p+20>>2]}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function PP(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;k=f[i+4>>2]|0;if(!k)return;i=j+-4|0;if((j|0)<4){l=(j|0)>0;m=a;n=d;o=g;p=k;while(1){p=p+-1|0;if(l){q=0;do{if(b[n+q>>0]|0){r=o+(q<<5)|0;s=m+(q<<5)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];f[r+12>>2]=f[s+12>>2];f[r+16>>2]=f[s+16>>2];f[r+20>>2]=f[s+20>>2];f[r+24>>2]=f[s+24>>2];f[r+28>>2]=f[s+28>>2]}q=q+1|0}while((q|0)!=(j|0))}if(!p)break;else{m=m+c|0;n=n+e|0;o=o+h|0}}return}o=j&-4;n=(o|0)<(j|0);m=a;a=d;d=g;g=k;while(1){k=0;do{if(b[a+k>>0]|0){p=d+(k<<5)|0;l=m+(k<<5)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];f[p+16>>2]=f[l+16>>2];f[p+20>>2]=f[l+20>>2];f[p+24>>2]=f[l+24>>2];f[p+28>>2]=f[l+28>>2]}l=k|1;if(b[a+l>>0]|0){p=d+(l<<5)|0;q=m+(l<<5)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2];f[p+16>>2]=f[q+16>>2];f[p+20>>2]=f[q+20>>2];f[p+24>>2]=f[q+24>>2];f[p+28>>2]=f[q+28>>2]}q=k|2;if(b[a+q>>0]|0){p=d+(q<<5)|0;l=m+(q<<5)|0;f[p>>2]=f[l>>2];f[p+4>>2]=f[l+4>>2];f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];f[p+16>>2]=f[l+16>>2];f[p+20>>2]=f[l+20>>2];f[p+24>>2]=f[l+24>>2];f[p+28>>2]=f[l+28>>2]}l=k|3;if(b[a+l>>0]|0){p=d+(l<<5)|0;q=m+(l<<5)|0;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];f[p+8>>2]=f[q+8>>2];f[p+12>>2]=f[q+12>>2];f[p+16>>2]=f[q+16>>2];f[p+20>>2]=f[q+20>>2];f[p+24>>2]=f[q+24>>2];f[p+28>>2]=f[q+28>>2]}k=k+4|0}while((k|0)<=(i|0));g=g+-1|0;if(n){k=o;do{if(b[a+k>>0]|0){q=d+(k<<5)|0;p=m+(k<<5)|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];f[q+8>>2]=f[p+8>>2];f[q+12>>2]=f[p+12>>2];f[q+16>>2]=f[p+16>>2];f[q+20>>2]=f[p+20>>2];f[q+24>>2]=f[p+24>>2];f[q+28>>2]=f[p+28>>2]}k=k+1|0}while((k|0)!=(j|0))}if(!g)break;else{m=m+c|0;a=a+e|0;d=d+h|0}}return}function QP(a){a=a|0;var b=0;if(a>>>0<33){b=f[43356+(a<<2)>>2]|0;return ((b|0)==0?140:b)|0}else return 140;return 0}function RP(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=f[j>>2]|0;j=i+4|0;l=f[j>>2]|0;m=l+-1|0;f[j>>2]=m;if(!l)return;l=f[i>>2]|0;if(!k){n=(l|0)>0;o=m;do{if(n){p=0;do p=p+1|0;while((p|0)<(l|0))}p=o;o=o+-1|0}while((p|0)!=0);f[j>>2]=o;return}else{q=a;r=d;s=g;t=l;u=m}while(1){if((t|0)>0){m=s;l=q;g=0;d=t;while(1){if(!(b[r+g>>0]|0))v=d;else{a=0;do{b[m+a>>0]=b[l+a>>0]|0;a=a+1|0}while((a|0)!=(k|0));v=f[i>>2]|0}g=g+1|0;if((g|0)>=(v|0))break;else{m=m+k|0;l=l+k|0;d=v}}w=f[j>>2]|0;x=v}else{w=u;x=t}u=w+-1|0;f[j>>2]=u;if(!w)break;else{q=q+c|0;r=r+e|0;s=s+h|0;t=x}}return}function SP(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+352|0;e=d+344|0;g=d+288|0;h=d+160|0;i=d+32|0;j=d;dQ(e,43488);k=BL(c,-1)|0;if(MM(c)|0?(l=f[a>>2]|0,(k|0)!=(l&4095|0)):0){if((l^k)&4088|0){f[g>>2]=0;f[g+4>>2]=0;m=aD(g,55)|0;n=192255;o=m+55|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,g,192311,192318,260);bD(g)}OJ(a,c,k,1.0,0.0)}else p=6;do if((p|0)==6){if((yM(c)|0)==655360){k=a+16|0;if(f[k>>2]|0){l=a+4|0;q=f[l>>2]|0;if((q|0)<3)r=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{s=f[a+40>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}if(!((q|0)==0|(r|0)==0)){v=a+40|0;wL(c,q,f[v>>2]|0,f[a>>2]&4095,-1,0,0);zM(g,c,-1);t=g+24|0;if(!(f[t>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=aD(h,11)|0;n=192384;o=m+11|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,192311,192318,274);bD(h)}m=h;o=m+128|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));q=f[l>>2]|0;if((q|0)>0)x=f[(f[a+44>>2]|0)+(q+-1<<2)>>2]|0;else x=0;if(q>>>0<32)y=q;else{f[j>>2]=0;f[j+4>>2]=0;m=aD(j,22)|0;n=192396;o=m+22|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,j,192311,192318,276);bD(j);y=f[l>>2]|0}if(!y)z=0;else{q=f[v>>2]|0;s=0;do{f[h+(s<<2)>>2]=f[q+(s<<2)>>2];s=s+1|0}while(s>>>0<y>>>0);z=y}s=h+(z+-1<<2)|0;q=Y(f[s>>2]|0,x)|0;f[s>>2]=q;sI(g,i);q=f[l>>2]|0;s=i+(q+-1<<2)|0;v=Y(f[s>>2]|0,x)|0;f[s>>2]=v;v=f[t>>2]|0;s=f[v+4>>2]|0;Hh[f[(f[s>>2]|0)+32>>2]&255](s,v,f[k>>2]|0,q,h,i,f[g+36>>2]|0,f[a+44>>2]|0);hI(g);break}}$L(c);break}q=a+4|0;v=f[q>>2]|0;if((v|0)>=3){s=a+40|0;wL(c,v,f[s>>2]|0,f[a>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){v=f[c+4>>2]|0;f[g>>2]=f[v>>2];w=g+4|0;A=v+4|0;f[w>>2]=f[A>>2];B=g+8|0;f[B>>2]=f[v+8>>2];f[g+12>>2]=f[v+12>>2];C=g+16|0;f[C>>2]=f[v+16>>2];f[g+20>>2]=f[v+20>>2];f[g+24>>2]=f[v+24>>2];f[g+28>>2]=f[v+28>>2];f[g+32>>2]=f[v+32>>2];D=f[v+36>>2]|0;f[g+36>>2]=D;f[g+40>>2]=B;B=g+48|0;E=g+44|0;f[E>>2]=B;f[B>>2]=0;f[g+52>>2]=0;if(D|0){B=D+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[v+44>>2]|0;B=f[E>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];F=C;break}else{f[w>>2]=0;jL(g,v);F=C;break}}else{yL(g,c,-1);F=g+16|0}while(0);if((f[a+16>>2]|0)!=(f[F>>2]|0)){k=f[q>>2]|0;if((k|0)<3)G=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{t=f[s>>2]|0;l=0;C=1;while(1){v=Y(f[t+(l<<2)>>2]|0,C)|0;l=l+1|0;if((l|0)==(k|0)){G=v;break}else C=v}}if(G|0){f[h>>2]=a;f[h+4>>2]=g;RN(j,h,i,2);C=f[q>>2]|0;if((C|0)>0)H=f[(f[a+44>>2]|0)+(C+-1<<2)>>2]|0;else H=0;C=Y(H,f[j+20>>2]|0)|0;k=j+16|0;l=i+4|0;t=0;while(1){if(t>>>0>=(f[k>>2]|0)>>>0)break;Vac(f[l>>2]|0,f[i>>2]|0,C|0)|0;aL(j)|0;t=t+1|0}}}t=g+36|0;C=f[t>>2]|0;if(C|0?(l=C+12|0,C=f[l>>2]|0,f[l>>2]=C+-1,(C|0)==1):0)kL(g);f[t>>2]=0;t=g+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[t>>2]|0)>0){C=f[g+40>>2]|0;l=0;do{f[C+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[t>>2]|0))}t=f[g+44>>2]|0;if((t|0)!=(g+48|0))UC(t);break}t=a+8|0;l=a+12|0;aM(c,f[t>>2]|0,f[l>>2]|0,f[a>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){C=f[c+4>>2]|0;f[g>>2]=f[C>>2];k=g+4|0;s=C+4|0;f[k>>2]=f[s>>2];v=g+8|0;f[v>>2]=f[C+8>>2];f[g+12>>2]=f[C+12>>2];w=g+16|0;f[w>>2]=f[C+16>>2];f[g+20>>2]=f[C+20>>2];f[g+24>>2]=f[C+24>>2];f[g+28>>2]=f[C+28>>2];f[g+32>>2]=f[C+32>>2];A=f[C+36>>2]|0;f[g+36>>2]=A;f[g+40>>2]=v;v=g+48|0;B=g+44|0;f[B>>2]=v;f[v>>2]=0;f[g+52>>2]=0;if(A|0){v=A+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[s>>2]|0)<3){s=f[C+44>>2]|0;v=f[B>>2]|0;f[v>>2]=f[s>>2];f[v+4>>2]=f[s+4>>2];I=w;break}else{f[k>>2]=0;jL(g,C);I=w;break}}else{yL(g,c,-1);I=g+16|0}while(0);w=a+16|0;if(((f[w>>2]|0)!=(f[I>>2]|0)?(f[t>>2]|0)>0:0)?(f[l>>2]|0)>0:0){if(!(((yM(c)|0)!=196608?(yM(c)|0)!=786432:0)?(yM(c)|0)!=917504:0)){C=g+4|0;k=f[C>>2]|0;if((k|0)<3)K=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{s=f[g+40>>2]|0;v=0;B=1;while(1){A=Y(f[s+(v<<2)>>2]|0,B)|0;v=v+1|0;if((v|0)==(k|0)){K=A;break}else B=A}}WL(h,g,0,K);B=h+36|0;k=f[B>>2]|0;if(k|0){v=k+12|0;f[v>>2]=(f[v>>2]|0)+1}v=g+36|0;k=f[v>>2]|0;if(k|0?(s=k+12|0,k=f[s>>2]|0,f[s>>2]=k+-1,(k|0)==1):0)kL(g);f[v>>2]=0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[C>>2]|0)>0){k=f[g+40>>2]|0;s=0;do{f[k+(s<<2)>>2]=0;s=s+1|0;L=f[C>>2]|0}while((s|0)<(L|0));f[g>>2]=f[h>>2];if((L|0)<3)p=52;else p=54}else{f[g>>2]=f[h>>2];p=52}if((p|0)==52){s=f[h+4>>2]|0;if((s|0)<3){f[C>>2]=s;f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2];s=f[h+44>>2]|0;k=f[g+44>>2]|0;f[k>>2]=f[s>>2];f[k+4>>2]=f[s+4>>2]}else p=54}if((p|0)==54)jL(g,h);s=h+16|0;f[I>>2]=f[s>>2];f[g+20>>2]=f[h+20>>2];f[g+24>>2]=f[h+24>>2];f[g+28>>2]=f[h+28>>2];f[g+32>>2]=f[h+32>>2];k=f[B>>2]|0;f[v>>2]=k;if(k|0?(A=k+12|0,k=f[A>>2]|0,f[A>>2]=k+-1,(k|0)==1):0)kL(h);f[B>>2]=0;k=h+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){s=f[h+40>>2]|0;A=0;do{f[s+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[k>>2]|0))}k=f[h+44>>2]|0;if((k|0)!=(h+48|0))UC(k)}k=f[w>>2]|0;A=f[I>>2]|0;s=f[a>>2]|0;B=f[g>>2]|0;v=f[l>>2]|0;C=f[t>>2]|0;E=cbc(C|0,((C|0)<0)<<31>>31|0,v|0,((v|0)<0)<<31>>31|0)|0;if((s&16384&B|0)!=0?(E|0)==(E|0)&(((E|0)<0)<<31>>31|0)==(J|0):0){M=1;N=E}else{M=C;N=v}v=f[q>>2]|0;if((v|0)>0)O=f[(f[a+44>>2]|0)+(v+-1<<2)>>2]|0;else O=0;v=Y(O,N)|0;if(M|0){C=a+48|0;E=g+48|0;B=A;A=k;k=M;while(1){k=k+-1|0;Vac(B|0,A|0,v|0)|0;if(!k)break;else{B=B+(f[E>>2]|0)|0;A=A+(f[C>>2]|0)|0}}}}C=g+36|0;A=f[C>>2]|0;if(A|0?(E=A+12|0,A=f[E>>2]|0,f[E>>2]=A+-1,(A|0)==1):0)kL(g);f[C>>2]=0;C=g+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[C>>2]|0)>0){A=f[g+40>>2]|0;E=0;do{f[A+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[C>>2]|0))}C=f[g+44>>2]|0;if((C|0)!=(g+48|0))UC(C)}while(0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function TP(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=u;u=u+304|0;g=e+288|0;h=e+232|0;i=e+176|0;j=e+112|0;k=e;l=e+168|0;m=e+88|0;n=e+56|0;o=e+104|0;dQ(g,43508);do if((yM(d)|0)==65536){p=f[d+4>>2]|0;f[h>>2]=f[p>>2];q=h+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=h+8|0;f[s>>2]=f[p+8>>2];f[h+12>>2]=f[p+12>>2];t=h+16|0;f[t>>2]=f[p+16>>2];f[h+20>>2]=f[p+20>>2];f[h+24>>2]=f[p+24>>2];f[h+28>>2]=f[p+28>>2];f[h+32>>2]=f[p+32>>2];v=f[p+36>>2]|0;f[h+36>>2]=v;f[h+40>>2]=s;s=h+48|0;w=h+44|0;f[w>>2]=s;f[s>>2]=0;f[h+52>>2]=0;if(v|0){s=v+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];x=t;break}else{f[q>>2]=0;jL(h,p);x=t;break}}else{yL(h,d,-1);x=h+16|0}while(0);if(f[x>>2]|0){d=f[h>>2]|0;t=d>>>3&511;p=t+1|0;if(!((d&7|0)==0?((t|0)==0?1:(t|0)==((f[a>>2]|0)>>>3&511|0)):0)){f[i>>2]=0;f[i+4>>2]=0;y=aD(i,44)|0;z=192459;A=y+44|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,i,192311,192318,381);bD(i)}d=(t|0)==0;t=a+4|0;if((f[t>>2]|0)<3?(q=f[a+40>>2]|0,r=f[h+40>>2]|0,!((f[q>>2]|0)==(f[r>>2]|0)?(f[q+4>>2]|0)==(f[r+4>>2]|0):0)):0){f[i>>2]=0;f[i+4>>2]=0;y=aD(i,21)|0;z=192504;A=y+21|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,i,192311,192318,385);bD(i)}f[i>>2]=1124007936;z=i+4|0;r=i+8|0;q=i+40|0;y=z;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[q>>2]=r;y=i+48|0;A=i+44|0;f[A>>2]=y;f[y>>2]=0;f[i+52>>2]=0;do if((yM(c)|0)==65536){s=f[c+4>>2]|0;f[j>>2]=f[s>>2];w=j+4|0;v=s+4|0;f[w>>2]=f[v>>2];B=j+8|0;f[B>>2]=f[s+8>>2];f[j+12>>2]=f[s+12>>2];f[j+16>>2]=f[s+16>>2];f[j+20>>2]=f[s+20>>2];f[j+24>>2]=f[s+24>>2];f[j+28>>2]=f[s+28>>2];f[j+32>>2]=f[s+32>>2];C=f[s+36>>2]|0;f[j+36>>2]=C;f[j+40>>2]=B;B=j+48|0;D=j+44|0;f[D>>2]=B;f[B>>2]=0;f[j+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[v>>2];f[B+4>>2]=f[v+4>>2];break}else{f[w>>2]=0;jL(j,s);break}}else yL(j,c,-1);while(0);wL(c,f[t>>2]|0,f[a+40>>2]|0,f[a>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){s=f[c+4>>2]|0;f[k>>2]=f[s>>2];w=k+4|0;v=s+4|0;f[w>>2]=f[v>>2];B=k+8|0;f[B>>2]=f[s+8>>2];f[k+12>>2]=f[s+12>>2];f[k+16>>2]=f[s+16>>2];f[k+20>>2]=f[s+20>>2];f[k+24>>2]=f[s+24>>2];f[k+28>>2]=f[s+28>>2];f[k+32>>2]=f[s+32>>2];D=k+36|0;C=f[s+36>>2]|0;f[D>>2]=C;f[k+40>>2]=B;B=k+48|0;E=k+44|0;f[E>>2]=B;f[B>>2]=0;f[k+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;B=f[E>>2]|0;f[B>>2]=f[v>>2];f[B+4>>2]=f[v+4>>2];F=D;break}else{f[w>>2]=0;jL(k,s);F=D;break}}else{yL(k,c,-1);F=k+36|0}while(0);D=f[F>>2]|0;if(D|0){s=D+12|0;f[s>>2]=(f[s>>2]|0)+1}s=i+36|0;D=f[s>>2]|0;if(D|0?(w=D+12|0,D=f[w>>2]|0,f[w>>2]=D+-1,(D|0)==1):0)kL(i);f[s>>2]=0;D=i+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[z>>2]|0)>0){w=f[q>>2]|0;v=0;do{f[w+(v<<2)>>2]=0;v=v+1|0;G=f[z>>2]|0}while((v|0)<(G|0));f[i>>2]=f[k>>2];if((G|0)<3)H=40;else H=42}else{f[i>>2]=f[k>>2];H=40}if((H|0)==40){G=f[k+4>>2]|0;if((G|0)<3){f[z>>2]=G;f[r>>2]=f[k+8>>2];f[i+12>>2]=f[k+12>>2];r=f[k+44>>2]|0;G=f[A>>2]|0;f[G>>2]=f[r>>2];f[G+4>>2]=f[r+4>>2]}else H=42}if((H|0)==42)jL(i,k);r=k+16|0;f[D>>2]=f[r>>2];f[i+20>>2]=f[k+20>>2];f[i+24>>2]=f[k+24>>2];f[i+28>>2]=f[k+28>>2];f[i+32>>2]=f[k+32>>2];G=f[F>>2]|0;f[s>>2]=G;if(G|0?(v=G+12|0,G=f[v>>2]|0,f[v>>2]=G+-1,(G|0)==1):0)kL(k);f[F>>2]=0;F=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[F>>2]|0)>0){r=f[k+40>>2]|0;G=0;do{f[r+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[F>>2]|0))}F=f[k+44>>2]|0;if((F|0)!=(k+48|0))UC(F);F=j+16|0;if((f[D>>2]|0)!=(f[F>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;UP(i,k)|0}G=j+36|0;r=f[G>>2]|0;if(r|0?(v=r+12|0,r=f[v>>2]|0,f[v>>2]=r+-1,(r|0)==1):0)kL(j);f[G>>2]=0;G=j+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[G>>2]|0)>0){F=f[j+40>>2]|0;r=0;do{f[F+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[G>>2]|0))}G=f[j+44>>2]|0;if((G|0)!=(j+48|0))UC(G);if(d){d=f[t>>2]|0;if((d|0)>0){G=f[(f[a+44>>2]|0)+(d+-1<<2)>>2]|0;f[j>>2]=G;if(G>>>0<33){I=G;K=d;H=66}else{L=d;M=140}}else{N=0;O=d;H=64}}else{N=1212424721>>>(f[a>>2]<<2&28)&15;O=f[t>>2]|0;H=64}if((H|0)==64){f[j>>2]=N;I=N;K=O;H=66}if((H|0)==66){H=f[43356+(I<<2)>>2]|0;L=K;M=(H|0)==0?140:H}if((L|0)<3){L=f[a>>2]|0;H=f[i>>2]|0;K=f[h>>2]|0;I=f[a+12>>2]|0;O=f[a+8>>2]|0;N=cbc(I|0,((I|0)<0)<<31>>31|0,p|0,0)|0;t=cbc(N|0,J|0,O|0,((O|0)<0)<<31>>31|0)|0;if((L&16384&H&K|0)!=0?(t|0)==(t|0)&(((t|0)<0)<<31>>31|0)==(J|0):0){P=1;Q=t}else{P=O;Q=Y(I,p)|0}I=f[a+16>>2]|0;O=f[a+48>>2]|0;t=f[x>>2]|0;K=f[h+48>>2]|0;H=f[D>>2]|0;L=f[y>>2]|0;f[l>>2]=Q;f[l+4>>2]=P;Hh[M&255](I,O,t,K,H,L,l,j)}else{f[k>>2]=a;f[k+4>>2]=i;f[k+8>>2]=h;f[k+12>>2]=0;RN(n,k,m,-1);k=Y(f[n+20>>2]|0,p)|0;p=n+16|0;l=m+8|0;L=m+4|0;H=o+4|0;K=0;while(1){if(K>>>0>=(f[p>>2]|0)>>>0)break;t=f[m>>2]|0;O=f[l>>2]|0;I=f[L>>2]|0;f[o>>2]=k;f[H>>2]=1;Hh[M&255](t,0,O,0,I,0,o,j);aL(n)|0;K=K+1|0}}K=f[s>>2]|0;do if(K|0){n=K+12|0;j=f[n>>2]|0;f[n>>2]=j+-1;if((j|0)!=1)break;kL(i)}while(0);f[s>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[z>>2]|0)>0){D=f[q>>2]|0;q=0;do{f[D+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[z>>2]|0))}z=f[A>>2]|0;if((z|0)!=(y|0))UC(z)}else SP(a,c);c=h+36|0;a=f[c>>2]|0;if(a|0?(z=a+12|0,a=f[z>>2]|0,f[z>>2]=a+-1,(a|0)==1):0)kL(h);f[c>>2]=0;c=h+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[c>>2]|0)>0){x=f[h+40>>2]|0;a=0;do{f[x+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[c>>2]|0))}c=f[h+44>>2]|0;if((c|0)!=(h+48|0))UC(c);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function UP(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+160|0;e=d+144|0;g=d+140|0;h=d+136|0;i=d+104|0;j=d;k=d+96|0;dQ(e,43528);f[g>>2]=a;RN(i,g,h,1);g=f[a+4>>2]|0;if((g|0)>0)l=f[(f[a+44>>2]|0)+(g+-1<<2)>>2]|0;else l=0;g=Y(l,f[i+20>>2]|0)|0;l=c;a:do if((((f[l>>2]|0)==0&(f[l+4>>2]|0)==0?(m=c+8|0,(f[m>>2]|0)==0&(f[m+4>>2]|0)==0):0)?(m=c+16|0,(f[m>>2]|0)==0&(f[m+4>>2]|0)==0):0)?(m=c+24|0,(f[m>>2]|0)==0&(f[m+4>>2]|0)==0):0){m=i+16|0;n=0;while(1){if(n>>>0>=(f[m>>2]|0)>>>0)break a;Nac(f[h>>2]|0,0,g|0)|0;aL(i)|0;n=n+1|0}}else o=10;while(0);if((o|0)==10?(o=i+16|0,f[o>>2]|0):0){xM(c,j,f[a>>2]&4095,12);c=(1212424721>>>(f[a>>2]<<2&28)&15)*12|0;if(g|0){l=k+4|0;n=0;do{m=g-n|0;p=c>>>0>m>>>0?m:c;if(p>>>0>=97){f[k>>2]=0;f[l>>2]=0;m=aD(k,20)|0;q=192526;r=m+20|0;do{b[m>>0]=b[q>>0]|0;m=m+1|0;q=q+1|0}while((m|0)<(r|0));bO(-215,k,489435,192318,451);bD(k)}Vac((f[h>>2]|0)+n|0,j|0,p|0)|0;n=n+c|0}while(g>>>0>n>>>0)}if((f[o>>2]|0)>>>0>1){n=a+16|0;c=1;do{aL(i)|0;Vac(f[h>>2]|0,f[n>>2]|0,g|0)|0;c=c+1|0}while(c>>>0<(f[o>>2]|0)>>>0)}}if(!(f[e+4>>2]|0)){u=d;return a|0}u=d;return a|0}function VP(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=u;u=u+1232|0;g=e+1224|0;h=e+1168|0;i=e+1112|0;j=e+1104|0;k=e+1088|0;l=e;m=e+1048|0;n=e+8|0;o=e+1080|0;dQ(g,43548);if(f[a+16>>2]|0){p=a+4|0;q=f[p>>2]|0;if((q|0)<3)r=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{s=f[a+40>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}if(!((q|0)==0|(r|0)==0)){do if((yM(c)|0)==65536){r=f[c+4>>2]|0;f[h>>2]=f[r>>2];q=h+4|0;v=r+4|0;f[q>>2]=f[v>>2];t=h+8|0;f[t>>2]=f[r+8>>2];f[h+12>>2]=f[r+12>>2];f[h+16>>2]=f[r+16>>2];f[h+20>>2]=f[r+20>>2];f[h+24>>2]=f[r+24>>2];f[h+28>>2]=f[r+28>>2];f[h+32>>2]=f[r+32>>2];s=f[r+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=t;t=h+48|0;w=h+44|0;f[w>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(s|0){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[v>>2]|0)<3){v=f[r+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[v>>2];f[t+4>>2]=f[v+4>>2];break}else{f[q>>2]=0;jL(h,r);break}}else yL(h,c,-1);while(0);do if((yM(d)|0)==65536){c=f[d+4>>2]|0;f[i>>2]=f[c>>2];r=i+4|0;q=c+4|0;f[r>>2]=f[q>>2];v=i+8|0;f[v>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];f[i+16>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[i+32>>2]=f[c+32>>2];t=f[c+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=v;v=i+48|0;w=i+44|0;f[w>>2]=v;f[v>>2]=0;f[i+52>>2]=0;if(t|0){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[q>>2]|0)<3){q=f[c+44>>2]|0;v=f[w>>2]|0;f[v>>2]=f[q>>2];f[v+4>>2]=f[q+4>>2];break}else{f[r>>2]=0;jL(i,c);break}}else yL(i,d,-1);while(0);d=f[a>>2]|0;c=h+4|0;if(((f[c>>2]|0)<=2?(r=f[h>>2]|0,(r&16384|0)!=0):0)?(q=f[h+40>>2]|0,v=f[q+4>>2]|0,w=f[q>>2]|0,q=(v|0)==1,t=(w|0)==1,q|t):0){s=(d>>>3&511)+1|0;if(!((v|0)==(s|0)&t|q&(t|(w|0)==(s|0)))?s>>>0>4|(r&4095|0)!=6|q&(w|0)==4^1:0)x=26}else x=26;if((x|0)==26){f[j>>2]=0;f[j+4>>2]=0;y=aD(j,60)|0;z=192643;A=y+60|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,j,192704,192318,523);bD(j)}w=(f[a>>2]|0)>>>3&511;q=f[i>>2]|0;r=q>>>3&511;s=r+1|0;t=i+16|0;a:do if(f[t>>2]|0){v=f[i+4>>2]|0;if((v|0)<3)B=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{d=f[i+40>>2]|0;C=0;D=1;while(1){E=Y(f[d+(C<<2)>>2]|0,D)|0;C=C+1|0;if((C|0)==(v|0)){B=E;break}else D=E}}if(!((v|0)==0|(B|0)==0)){b:do if(((q&7|0)==0?(r|0)==0|(r|0)==(w|0):0)?(D=f[a+40>>2]|0,C=f[D+-4>>2]|0,d=f[i+40>>2]|0,(C|0)==(f[d+-4>>2]|0)):0){if((C|0)==2){if((f[D>>2]|0)!=(f[d>>2]|0))break;if((f[D+4>>2]|0)==(f[d+4>>2]|0))break a;else break}if((C|0)>0)F=0;else break a;while(1){if((f[D+(F<<2)>>2]|0)!=(f[d+(F<<2)>>2]|0))break b;F=F+1|0;if((F|0)>=(C|0))break a}}while(0);f[j>>2]=0;f[j+4>>2]=0;y=aD(j,83)|0;z=192710;A=y+83|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,j,192704,192318,525);bD(j)}}while(0);if(!r){r=f[p>>2]|0;if((r|0)>0){p=f[(f[a+44>>2]|0)+(r+-1<<2)>>2]|0;f[j>>2]=p;if(p>>>0<33){G=p;x=48}else H=140}else{I=0;x=46}}else{I=1212424721>>>(f[a>>2]<<2&28)&15;x=46}if((x|0)==46){f[j>>2]=I;G=I;x=48}if((x|0)==48){I=f[43356+(G<<2)>>2]|0;H=(I|0)==0?140:I}f[k>>2]=a;if(f[t>>2]|0){I=f[i+4>>2]|0;if((I|0)<3)J=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{G=f[i+40>>2]|0;p=0;r=1;while(1){z=Y(f[G+(p<<2)>>2]|0,r)|0;p=p+1|0;if((p|0)==(I|0)){J=z;break}else r=z}}r=k+4|0;if((I|0)==0|(J|0)==0){K=r;x=56}else{L=i;M=r}}else{K=k+4|0;x=56}if((x|0)==56){L=0;M=K}f[M>>2]=L;f[k+8>>2]=0;L=l;f[L>>2]=0;f[L+4>>2]=0;RN(m,k,l,-1);k=Y(f[m+20>>2]|0,s)|0;L=f[j>>2]|0;M=((L+1023|0)>>>0)/(L>>>0)|0;K=(M|0)<(k|0)?M:k;M=K-((K|0)%(s|0)|0)|0;x=(Y(M,L)|0)+32|0;L=n+8|0;f[n>>2]=L;r=n+4|0;f[r>>2]=x;if(x>>>0>1032){J=N5b(x)|0;f[n>>2]=J;N=J}else N=L;J=N+7&-8;cD(h,f[a>>2]&4095,J,(K|0)/(s|0)|0);s=m+16|0;K=l+4|0;N=o+4|0;c:do if((k|0)>0){x=0;while(1){if(x>>>0>=(f[s>>2]|0)>>>0)break c;I=0;p=f[l>>2]|0;do{G=k-I|0;z=(G|0)<(M|0)?G:M;G=Y(f[j>>2]|0,z)|0;y=f[K>>2]|0;if(!y)Vac(p|0,J|0,G|0)|0;else{f[o>>2]=z;f[N>>2]=1;Hh[H&255](J,0,y,0,p,0,o,j);f[K>>2]=(f[K>>2]|0)+z}p=(f[l>>2]|0)+G|0;f[l>>2]=p;I=I+M|0}while((k|0)>(I|0));aL(m)|0;x=x+1|0}}else{x=0;while(1){if(x>>>0>=(f[s>>2]|0)>>>0)break c;aL(m)|0;x=x+1|0}}while(0);m=f[n>>2]|0;if((m|0)!=(L|0)){if(m|0)P5b(m);f[n>>2]=L;f[r>>2]=1032}r=i+36|0;L=f[r>>2]|0;if(L|0?(n=L+12|0,L=f[n>>2]|0,f[n>>2]=L+-1,(L|0)==1):0)kL(i);f[r>>2]=0;r=i+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[r>>2]|0)>0){t=f[i+40>>2]|0;L=0;do{f[t+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[r>>2]|0))}r=f[i+44>>2]|0;if((r|0)!=(i+48|0))UC(r);r=h+36|0;i=f[r>>2]|0;if(i|0?(L=i+12|0,i=f[L>>2]|0,f[L>>2]=i+-1,(i|0)==1):0)kL(h);f[r>>2]=0;r=h+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[c>>2]|0)>0){r=f[h+40>>2]|0;i=0;do{f[r+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[c>>2]|0))}c=f[h+44>>2]|0;if((c|0)!=(h+48|0))UC(c)}}if(!(f[g+4>>2]|0)){u=e;return a|0}u=e;return a|0}function WP(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;e=u;u=u+160|0;g=e+144|0;h=e+136|0;i=e+72|0;j=e+128|0;k=e+16|0;l=e+8|0;m=e;dQ(g,43568);if((_L(a,-1)|0)>=3){f[h>>2]=0;f[h+4>>2]=0;n=aD(h,16)|0;o=192842;p=n+16|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,h,192859,192318,742);bD(h)}AL(h,a,-1);o=f[h>>2]|0;if((d|0)<0)q=(f[h+4>>2]|0)==1?1:(o|0)==1?0:d;else q=d;d=(o|0)==1;if((!((q|0)>0&d)?(o=h+4|0,n=(f[o>>2]|0)==1,!((q|0)==0&n)):0)?(p=(q|0)<0,!(p&d&n)):0){do if((yM(a)|0)==65536){n=f[a+4>>2]|0;f[i>>2]=f[n>>2];d=i+4|0;r=n+4|0;f[d>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[n+8>>2];f[i+12>>2]=f[n+12>>2];f[i+16>>2]=f[n+16>>2];f[i+20>>2]=f[n+20>>2];f[i+24>>2]=f[n+24>>2];f[i+28>>2]=f[n+28>>2];f[i+32>>2]=f[n+32>>2];t=f[n+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=s;s=i+48|0;v=i+44|0;f[v>>2]=s;f[s>>2]=0;f[i+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[n+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];w=i;break}else{f[d>>2]=0;jL(i,n);w=i;break}}else{yL(i,a,-1);w=i}while(0);n=f[w>>2]|0;w=n&4095;f[j>>2]=f[h>>2];f[j+4>>2]=f[o>>2];vM(c,j,w,-1,0,0);do if((yM(c)|0)==65536){j=f[c+4>>2]|0;f[k>>2]=f[j>>2];o=k+4|0;h=j+4|0;f[o>>2]=f[h>>2];d=k+8|0;f[d>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];r=k+16|0;f[r>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];s=f[j+36>>2]|0;f[k+36>>2]=s;f[k+40>>2]=d;d=k+48|0;v=k+44|0;f[v>>2]=d;f[d>>2]=0;f[k+52>>2]=0;if(s|0){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[h>>2]|0)<3){h=f[j+44>>2]|0;t=f[v>>2]|0;f[t>>2]=f[h>>2];f[t+4>>2]=f[h+4>>2];x=r;y=v;z=d;break}else{f[o>>2]=0;jL(k,j);x=r;y=v;z=d;break}}else{yL(k,c,-1);x=k+16|0;y=k+44|0;z=k+48|0}while(0);d=(n>>>3&511)+1<<(47696>>>(w<<1&14)&3);w=i+16|0;n=f[w>>2]|0;v=i+44|0;r=i+48|0;j=f[r>>2]|0;o=f[x>>2]|0;h=f[z>>2]|0;t=i+40|0;s=f[t>>2]|0;A=f[s+4>>2]|0;B=f[s>>2]|0;a:do if((q|0)<1){s=B+-1|0;C=Y(A,d)|0;if((B|0)>0){D=o+(Y(s,h)|0)|0;E=n+(Y(s,j)|0)|0;s=0-j|0;F=0-h|0;G=C+-4|0;H=C+-16|0;I=(B+1|0)/2|0;if((C|0)<16){J=C&-4;K=(C|0)<4;L=E;M=D;N=0;O=n;P=o;while(1){if(((P|O|L|M)&3|0)!=0|K)Q=0;else{R=0;do{S=f[O+R>>2]|0;f[P+R>>2]=f[L+R>>2];f[M+R>>2]=S;R=R+4|0}while((R|0)<=(G|0));Q=J}if((Q|0)<(C|0)){R=Q;do{S=b[O+R>>0]|0;b[P+R>>0]=b[L+R>>0]|0;b[M+R>>0]=S;R=R+1|0}while((R|0)!=(C|0))}N=N+1|0;if((N|0)>=(I|0))break a;else{L=L+s|0;M=M+F|0;O=O+j|0;P=P+h|0}}}P=C&-16;O=(P|0)>(G|0);M=E;L=D;N=0;J=n;K=o;while(1){if(!((K|J|M|L)&3)){R=0;do{S=J+R|0;T=f[S>>2]|0;U=M+R|0;V=K+R|0;f[V>>2]=f[U>>2];W=L+R|0;f[W>>2]=T;T=f[S+4>>2]|0;f[V+4>>2]=f[U+4>>2];f[W+4>>2]=T;T=f[S+8>>2]|0;f[V+8>>2]=f[U+8>>2];f[W+8>>2]=T;T=f[S+12>>2]|0;f[V+12>>2]=f[U+12>>2];f[W+12>>2]=T;R=R+16|0}while((R|0)<=(H|0));if(O)X=P;else{R=P;while(1){T=f[J+R>>2]|0;f[K+R>>2]=f[M+R>>2];f[L+R>>2]=T;T=R+4|0;if((T|0)>(G|0)){X=T;break}else R=T}}}else X=0;if((X|0)<(C|0)){R=X;do{T=b[J+R>>0]|0;b[K+R>>0]=b[M+R>>0]|0;b[L+R>>0]=T;R=R+1|0}while((R|0)!=(C|0))}N=N+1|0;if((N|0)>=(I|0))break;else{M=M+s|0;L=L+F|0;J=J+j|0;K=K+h|0}}}}else{f[l>>2]=A;f[l+4>>2]=B;XP(n,j,o,h,l,d)}while(0);if(p){p=f[x>>2]|0;l=f[z>>2]|0;h=f[k+40>>2]|0;o=f[h>>2]|0;f[m>>2]=f[h+4>>2];f[m+4>>2]=o;XP(p,l,p,l,m,d)}d=k+36|0;m=f[d>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)kL(k);f[d>>2]=0;d=k+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[d>>2]|0)>0){x=f[k+40>>2]|0;k=0;do{f[x+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[d>>2]|0))}d=f[y>>2]|0;if((d|0)!=(z|0))UC(d);d=i+36|0;z=f[d>>2]|0;if(z|0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0)kL(i);f[d>>2]=0;d=i+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[d>>2]|0)>0){w=f[t>>2]|0;t=0;do{f[w+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[d>>2]|0))}d=f[v>>2]|0;if((d|0)!=(r|0))UC(d)}else JM(a,c);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function XP(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;i=u;u=u+1072|0;j=i;k=f[g>>2]|0;l=Y((k+1|0)/2|0,h)|0;m=Y(k,h)|0;n=j+8|0;f[j>>2]=n;o=j+4|0;f[o>>2]=m;if(m>>>0>264){p=N5b(m>>>0>1073741823?-1:m<<2)|0;f[j>>2]=p;q=p}else q=n;a:do if((k|0)>0){if(!h){p=0;while(1){p=p+1|0;if((p|0)>=(k|0))break a}}p=f[g>>2]|0;m=(h|0)==1;r=0;s=k;while(1){t=~r;v=Y(r,h)|0;w=Y(s+t|0,h)|0;f[q+(v<<2)>>2]=w;if(!m){w=Y((f[g>>2]|0)+t|0,h)|0;t=1;do{f[q+(t+v<<2)>>2]=w+t;t=t+1|0}while((t|0)!=(h|0))}t=r+1|0;if((t|0)<(p|0)){r=t;s=p}else break}}while(0);h=g+4|0;g=f[h>>2]|0;k=g+-1|0;f[h>>2]=k;do if(!g)x=q;else{if((l|0)>0){y=d;z=a}else{p=k;do{s=p;p=p+-1|0}while((s|0)!=0);f[h>>2]=p;x=q;break}while(1){s=0;do{r=f[q+(s<<2)>>2]|0;m=b[z+s>>0]|0;b[y+s>>0]=b[z+r>>0]|0;b[y+r>>0]=m;s=s+1|0}while((s|0)!=(l|0));s=f[h>>2]|0;f[h>>2]=s+-1;if(!s)break;else{y=y+e|0;z=z+c|0}}x=f[j>>2]|0}while(0);if((x|0)==(n|0)){u=i;return}if(x|0)P5b(x);f[j>>2]=n;f[o>>2]=264;u=i;return}function YP(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+128|0;h=g+120|0;i=g+112|0;j=g+56|0;k=g;dQ(h,43588);l=a+4|0;m=e+4|0;if((f[l>>2]|0)==(f[m>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;n=aD(i,30)|0;o=192908;p=n+30|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,i,192939,192318,862);bD(i)}if((_L(a,-1)|0)>=3){f[i>>2]=0;f[i+4>>2]=0;n=aD(i,16)|0;o=192842;p=n+16|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,i,192939,192318,863);bD(i)}if(!((c|0)>0&(d|0)>0)){f[i>>2]=0;f[i+4>>2]=0;n=aD(i,16)|0;o=192946;p=n+16|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,i,192939,192318,864);bD(i)}AL(i,a,-1);o=i+4|0;n=f[o>>2]|0;p=f[i>>2]|0;aM(e,Y(n,c)|0,Y(p,d)|0,BL(a,-1)|0,-1,0,0);do if((yM(a)|0)==65536){d=f[l>>2]|0;f[j>>2]=f[d>>2];p=j+4|0;c=d+4|0;f[p>>2]=f[c>>2];n=j+8|0;f[n>>2]=f[d+8>>2];f[j+12>>2]=f[d+12>>2];f[j+16>>2]=f[d+16>>2];f[j+20>>2]=f[d+20>>2];f[j+24>>2]=f[d+24>>2];f[j+28>>2]=f[d+28>>2];f[j+32>>2]=f[d+32>>2];q=f[d+36>>2]|0;f[j+36>>2]=q;f[j+40>>2]=n;n=j+48|0;r=j+44|0;f[r>>2]=n;f[n>>2]=0;f[j+52>>2]=0;if(q|0){n=q+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[c>>2]|0)<3){c=f[d+44>>2]|0;n=f[r>>2]|0;f[n>>2]=f[c>>2];f[n+4>>2]=f[c+4>>2];break}else{f[p>>2]=0;jL(j,d);break}}else yL(j,a,-1);while(0);do if((yM(e)|0)==65536){a=f[m>>2]|0;f[k>>2]=f[a>>2];l=k+4|0;d=a+4|0;f[l>>2]=f[d>>2];p=k+8|0;f[p>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];c=f[a+36>>2]|0;f[k+36>>2]=c;n=k+40|0;f[n>>2]=p;p=k+48|0;r=k+44|0;f[r>>2]=p;f[p>>2]=0;f[k+52>>2]=0;if(c|0){p=c+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[d>>2]|0)<3){d=f[a+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[d>>2];f[p+4>>2]=f[d+4>>2];s=n;break}else{f[l>>2]=0;jL(k,a);s=n;break}}else{yL(k,e,-1);s=k+40|0}while(0);e=f[s>>2]|0;m=f[e+4>>2]|0;n=f[e>>2]|0;e=j+4|0;a=f[e>>2]|0;if((a|0)>0)t=f[(f[j+44>>2]|0)+(a+-1<<2)>>2]|0;else t=0;a=Y(f[i>>2]|0,t)|0;f[i>>2]=a;l=Y(t,m)|0;m=f[o>>2]|0;a:do if((m|0)>0){t=k+16|0;d=k+44|0;p=j+16|0;r=j+44|0;if((l|0)>0){v=0;w=a}else{c=0;while(1){q=c+1|0;if((q|0)<(m|0))c=q;else{x=q;y=m;break a}}}while(1){c=0;q=w;do{z=(f[t>>2]|0)+(Y(f[f[d>>2]>>2]|0,v)|0)+c|0;Vac(z|0,(f[p>>2]|0)+(Y(f[f[r>>2]>>2]|0,v)|0)|0,q|0)|0;q=f[i>>2]|0;c=q+c|0}while((c|0)<(l|0));c=v+1|0;z=f[o>>2]|0;if((c|0)<(z|0)){v=c;w=q}else{x=c;y=z;break}}}else{x=0;y=m}while(0);if((x|0)<(n|0)?(m=k+16|0,w=k+44|0,v=f[m>>2]|0,i=f[f[w>>2]>>2]|0,Vac(v+(Y(i,x)|0)|0,v+(Y(x-y|0,i)|0)|0,l|0)|0,i=x+1|0,(i|0)!=(n|0)):0){x=i;do{i=f[m>>2]|0;y=f[f[w>>2]>>2]|0;Vac(i+(Y(y,x)|0)|0,i+(Y(x-(f[o>>2]|0)|0,y)|0)|0,l|0)|0;x=x+1|0}while((x|0)!=(n|0))}n=k+36|0;x=f[n>>2]|0;if(x|0?(l=x+12|0,x=f[l>>2]|0,f[l>>2]=x+-1,(x|0)==1):0)kL(k);f[n>>2]=0;n=k+16|0;x=k+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[x>>2]|0)>0){n=f[s>>2]|0;s=0;do{f[n+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[x>>2]|0))}x=f[k+44>>2]|0;if((x|0)!=(k+48|0))UC(x);x=j+36|0;k=f[x>>2]|0;if(k|0?(s=k+12|0,k=f[s>>2]|0,f[s>>2]=k+-1,(k|0)==1):0)kL(j);f[x>>2]=0;x=j+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[e>>2]|0)>0){x=f[j+40>>2]|0;k=0;do{f[x+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[e>>2]|0))}e=f[j+44>>2]|0;if((e|0)!=(j+48|0))UC(e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function ZP(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;if(a>>>0<c>>>0){h=a;u=e;return h|0}switch(d|0){case 1:{h=(a|0)<0?0:c+-1|0;u=e;return h|0}case 2:case 4:{i=(d|0)==4;d=i&1;if((c|0)==1){h=0;u=e;return h|0}j=(c<<1)+-1+(i<<31>>31)|0;i=a;while(1){k=(i|0)<0?d+~i|0:j-i|0;if(k>>>0<c>>>0){h=k;break}else i=k}u=e;return h|0}case 3:{if((c|0)<=0){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,7)|0;b[i>>0]=b[207275]|0;b[i+1>>0]=b[207276]|0;b[i+2>>0]=b[207277]|0;b[i+3>>0]=b[207278]|0;b[i+4>>0]=b[207279]|0;b[i+5>>0]=b[207280]|0;b[i+6>>0]=b[207281]|0;bO(-215,g,193014,192318,936);bD(g)}i=a-c|0;if((a|0)<0)l=~i+a+((i+1|0)%(c|0)|0)|0;else l=a;if((l|0)<(c|0)){h=l;u=e;return h|0}h=(l|0)%(c|0)|0;u=e;return h|0}case 0:{h=-1;u=e;return h|0}default:{f[g>>2]=0;f[g+4>>2]=0;c=aD(g,31)|0;l=193032;i=c+31|0;do{b[c>>0]=b[l>>0]|0;c=c+1|0;l=l+1|0}while((c|0)<(i|0));bO(-5,g,193014,192318,945);bD(g);h=a;u=e;return h|0}}return 0}function _P(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;k=u;u=u+2288|0;l=k+1216|0;m=k+1208|0;n=k+1152|0;o=k+1096|0;q=k;dQ(m,43608);if((e|d|g|h|0)<=-1){f[l>>2]=0;f[l+4>>2]=0;r=aD(l,50)|0;s=193064;t=r+50|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,l,193115,192318,1181);bD(l)}do if((yM(a)|0)==65536){v=f[a+4>>2]|0;f[n>>2]=f[v>>2];w=n+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=n+8|0;f[y>>2]=f[v+8>>2];f[n+12>>2]=f[v+12>>2];f[n+16>>2]=f[v+16>>2];f[n+20>>2]=f[v+20>>2];f[n+24>>2]=f[v+24>>2];f[n+28>>2]=f[v+28>>2];f[n+32>>2]=f[v+32>>2];z=f[v+36>>2]|0;f[n+36>>2]=z;f[n+40>>2]=y;y=n+48|0;A=n+44|0;f[A>>2]=y;f[y>>2]=0;f[n+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];B=n;break}else{f[w>>2]=0;jL(n,v);B=n;break}}else{yL(n,a,-1);B=n}while(0);a=f[B>>2]|0;if((i&16|0)==0&(a&32768|0)!=0){f[l>>2]=0;v=l+4|0;f[v>>2]=0;f[o>>2]=0;w=o+4|0;f[w>>2]=0;uL(n,l,o);x=f[w>>2]|0;w=(x|0)>(d|0)?d:x;y=n+8|0;A=(f[v>>2]|0)-(f[y>>2]|0)-x|0;x=(A|0)>(e|0)?e:A;A=f[o>>2]|0;v=(A|0)>(g|0)?g:A;z=n+12|0;C=(f[l>>2]|0)-(f[z>>2]|0)-A|0;A=(C|0)>(h|0)?h:C;vL(n,w,x,v,A)|0;D=d-w|0;E=e-x|0;F=g-v|0;G=h-A|0;H=y;I=z}else{D=d;E=e;F=g;G=h;H=n+8|0;I=n+12|0}aM(c,D+E+(f[H>>2]|0)|0,F+G+(f[I>>2]|0)|0,a&4095,-1,0,0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[o>>2]=f[a>>2];I=o+4|0;H=a+4|0;f[I>>2]=f[H>>2];h=o+8|0;f[h>>2]=f[a+8>>2];f[o+12>>2]=f[a+12>>2];f[o+16>>2]=f[a+16>>2];f[o+20>>2]=f[a+20>>2];f[o+24>>2]=f[a+24>>2];f[o+28>>2]=f[a+28>>2];f[o+32>>2]=f[a+32>>2];g=f[a+36>>2]|0;f[o+36>>2]=g;f[o+40>>2]=h;h=o+48|0;e=o+44|0;f[e>>2]=h;f[h>>2]=0;f[o+52>>2]=0;if(g|0){h=g+12|0;f[h>>2]=(f[h>>2]|0)+1}if((f[H>>2]|0)<3){H=f[a+44>>2]|0;h=f[e>>2]|0;f[h>>2]=f[H>>2];f[h+4>>2]=f[H+4>>2];break}else{f[I>>2]=0;jL(o,a);break}}else yL(o,c,-1);while(0);do if(F|G|E|D){c=i&-17;if(!c){a=f[B>>2]|0;I=(a>>>3&511)+1|0;H=q+8|0;f[q>>2]=H;h=q+4|0;f[h>>2]=I;if(I>>>0<=136)if(I>>>0>4){J=H;K=87}else{L=I;M=a;N=H}else{e=N5b(I<<3)|0;f[q>>2]=e;J=e;K=87}do if((K|0)==87){O=+p[j>>3];if((O==+p[j+8>>3]?O==+p[j+16>>3]:0)?O==+p[j+24>>3]:0){L=1;M=a;N=J;break}f[l>>2]=0;f[l+4>>2]=0;r=aD(l,68)|0;s=193130;t=r+68|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,l,193115,192318,1229);bD(l);L=1;M=f[B>>2]|0;N=f[q>>2]|0}while(0);xM(j,N,M&7|(L<<3)+-8,I);a=f[n+16>>2]|0;e=f[n+48>>2]|0;g=f[n+40>>2]|0;d=f[g+4>>2]|0;z=f[g>>2]|0;g=f[o+16>>2]|0;y=f[o+48>>2]|0;A=f[o+40>>2]|0;v=f[A+4>>2]|0;x=f[A>>2]|0;A=f[n+4>>2]|0;if((A|0)>0)P=f[(f[n+44>>2]|0)+(A+-1<<2)>>2]|0;else P=0;A=f[q>>2]|0;w=Y(P,v)|0;C=l+8|0;f[l>>2]=C;Q=l+4|0;f[Q>>2]=w;if(w>>>0>1032){R=N5b(w)|0;f[l>>2]=R;S=R}else S=C;R=v-(d+F)|0;T=x-D-z|0;if((v|0)>0&(P|0)>0){x=0;do{U=Y(x,P)|0;V=0;do{b[S+(V+U)>>0]=b[A+V>>0]|0;V=V+1|0}while((V|0)!=(P|0));x=x+1|0}while((x|0)!=(v|0))}v=Y(P,d)|0;x=Y(P,F)|0;A=Y(P,R)|0;I=g+(Y(y,D)|0)|0;if((z|0)>0){V=0-x|0;U=a;W=I+x|0;X=0;while(1){if((W|0)!=(U|0))Vac(W|0,U|0,v|0)|0;Vac(W+V|0,S|0,x|0)|0;Vac(W+v|0,S|0,A|0)|0;X=X+1|0;if((X|0)==(z|0))break;else{U=U+e|0;W=W+y|0}}}if((D|0)>0){W=0;do{Vac(I+(Y(W-D|0,y)|0)|0,S|0,w|0)|0;W=W+1|0}while((W|0)!=(D|0))}if((T|0)>0){W=0;do{Vac(I+(Y(W+z|0,y)|0)|0,S|0,w|0)|0;W=W+1|0}while((W|0)!=(T|0))}T=f[l>>2]|0;if((T|0)!=(C|0)){if(T|0)P5b(T);f[l>>2]=C;f[Q>>2]=1032}T=f[q>>2]|0;if((T|0)!=(H|0)){if(T|0)P5b(T);f[q>>2]=H;f[h>>2]=136}break}T=f[n+16>>2]|0;W=f[n+48>>2]|0;w=f[n+40>>2]|0;y=f[w+4>>2]|0;z=f[w>>2]|0;w=f[o+16>>2]|0;I=f[o+48>>2]|0;e=f[o+40>>2]|0;U=f[e+4>>2]|0;X=f[e>>2]|0;e=f[n+4>>2]|0;if((e|0)>0)Z=f[(f[n+44>>2]|0)+(e+-1<<2)>>2]|0;else Z=0;e=((T|W|I|w|Z)&3|0)==0;A=e?4:1;v=e?(Z|0)/4|0:Z;x=U-y|0;V=Y(v,x)|0;a=l+8|0;f[l>>2]=a;g=l+4|0;f[g>>2]=V;if(V>>>0>264){R=N5b(V>>>0>1073741823?-1:V<<2)|0;f[l>>2]=R;_=R}else _=a;R=x-F|0;x=X-D-z|0;a:do if((F|0)>0){if((v|0)>0)$=0;else{X=0;while(1){ZP(X-F|0,y,c)|0;X=X+1|0;if((X|0)>=(F|0))break a}}do{X=Y(ZP($-F|0,y,c)|0,v)|0;V=Y($,v)|0;d=0;do{f[_+(d+V<<2)>>2]=d+X;d=d+1|0}while((d|0)!=(v|0));$=$+1|0}while(($|0)<(F|0))}while(0);b:do if((R|0)>0){if((v|0)>0)aa=0;else{h=0;while(1){ZP(h+y|0,y,c)|0;h=h+1|0;if((h|0)>=(R|0))break b}}do{h=Y(ZP(aa+y|0,y,c)|0,v)|0;H=Y(aa+F|0,v)|0;Q=0;do{f[_+(Q+H<<2)>>2]=Q+h;Q=Q+1|0}while((Q|0)!=(v|0));aa=aa+1|0}while((aa|0)<(R|0))}while(0);Q=Y(v,y)|0;h=Y(v,U)|0;H=Y(v,F)|0;C=Y(v,R)|0;d=w+(Y(I,D)|0)|0;X=d+(Y(H,A)|0)|0;c:do if((z|0)>0){V=(H|0)>0;ba=(C|0)>0;ca=Y(Q,A)|0;if(!e){if(V){da=X;ea=T;fa=0;while(1){if((da|0)==(ea|0))ga=0;else{Vac(da|0,ea|0,ca|0)|0;ga=0}do{b[da+(ga-H)>>0]=b[ea+(f[_+(ga<<2)>>2]|0)>>0]|0;ga=ga+1|0}while((ga|0)!=(H|0));if(ba){ha=0;do{b[da+(ha+Q)>>0]=b[ea+(f[_+(ha+H<<2)>>2]|0)>>0]|0;ha=ha+1|0}while((ha|0)!=(C|0))}fa=fa+1|0;if((fa|0)==(z|0))break c;else{da=da+I|0;ea=ea+W|0}}}if(ba){ia=X;ja=T;ka=0}else{ea=X;da=T;fa=0;while(1){if((ea|0)!=(da|0))Vac(ea|0,da|0,ca|0)|0;fa=fa+1|0;if((fa|0)==(z|0))break c;else{ea=ea+I|0;da=da+W|0}}}while(1){if((ia|0)==(ja|0))la=0;else{Vac(ia|0,ja|0,ca|0)|0;la=0}do{b[ia+(la+Q)>>0]=b[ja+(f[_+(la+H<<2)>>2]|0)>>0]|0;la=la+1|0}while((la|0)!=(C|0));ka=ka+1|0;if((ka|0)==(z|0))break c;else{ia=ia+I|0;ja=ja+W|0}}}if(V){da=X;ea=T;fa=0;while(1){if((da|0)!=(ea|0))Vac(da|0,ea|0,ca|0)|0;ha=0;do{f[da+(ha-H<<2)>>2]=f[ea+(f[_+(ha<<2)>>2]<<2)>>2];ha=ha+1|0}while((ha|0)!=(H|0));if(ba){ha=0;do{f[da+(ha+Q<<2)>>2]=f[ea+(f[_+(ha+H<<2)>>2]<<2)>>2];ha=ha+1|0}while((ha|0)!=(C|0))}fa=fa+1|0;if((fa|0)==(z|0))break c;else{da=da+I|0;ea=ea+W|0}}}if(ba){ma=X;na=T;oa=0}else{ea=X;da=T;fa=0;while(1){if((ea|0)!=(da|0))Vac(ea|0,da|0,ca|0)|0;fa=fa+1|0;if((fa|0)==(z|0))break c;else{ea=ea+I|0;da=da+W|0}}}while(1){if((ma|0)!=(na|0))Vac(ma|0,na|0,ca|0)|0;da=0;do{f[ma+(da+Q<<2)>>2]=f[na+(f[_+(da+H<<2)>>2]<<2)>>2];da=da+1|0}while((da|0)!=(C|0));oa=oa+1|0;if((oa|0)==(z|0))break;else{ma=ma+I|0;na=na+W|0}}}while(0);W=Y(h,A)|0;if((D|0)>0){C=0;do{H=C-D|0;Vac(d+(Y(H,I)|0)|0,d+(Y(ZP(H,z,c)|0,I)|0)|0,W|0)|0;C=C+1|0}while((C|0)<(D|0))}if((x|0)>0){C=0;do{A=C+z|0;Vac(d+(Y(A,I)|0)|0,d+(Y(ZP(A,z,c)|0,I)|0)|0,W|0)|0;C=C+1|0}while((C|0)<(x|0))}x=f[l>>2]|0;if((x|0)!=(a|0)){if(x|0)P5b(x);f[l>>2]=a;f[g>>2]=264}}else{if((f[n+16>>2]|0)==(f[o+16>>2]|0)?(f[n+48>>2]|0)==(f[o+48>>2]|0):0)break;x=l+8|0;f[x>>2]=0;f[x+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=o;SP(n,l)}while(0);l=o+36|0;D=f[l>>2]|0;if(D|0?(na=D+12|0,D=f[na>>2]|0,f[na>>2]=D+-1,(D|0)==1):0)kL(o);f[l>>2]=0;l=o+16|0;D=o+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[D>>2]|0)>0){l=f[o+40>>2]|0;na=0;do{f[l+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[D>>2]|0))}D=f[o+44>>2]|0;if((D|0)!=(o+48|0))UC(D);D=n+36|0;o=f[D>>2]|0;if(o|0?(na=o+12|0,o=f[na>>2]|0,f[na>>2]=o+-1,(o|0)==1):0)kL(n);f[D>>2]=0;D=n+16|0;o=n+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[o>>2]|0)>0){D=f[n+40>>2]|0;na=0;do{f[D+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[o>>2]|0))}o=f[n+44>>2]|0;if((o|0)!=(n+48|0))UC(o);if(!(f[m+4>>2]|0)){u=k;return}u=k;return}function $P(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+208|0;g=e+144|0;h=e+88|0;i=e+72|0;j=e+56|0;k=e;l=(a|0)!=0;if((l?(c|0?(f[a>>2]&-65536|0)==1111752704:0):0)?(f[c>>2]&-65536|0)==1111752704:0){if(d|0){f[g>>2]=0;f[g+4>>2]=0;m=aD(g,12)|0;n=193289;o=m+12|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,g,193302,192318,1245);bD(g)}p=a+4|0;f[c+4>>2]=f[p>>2];Vac(c+36|0,a+36|0,f[p>>2]<<2|0)|0;f[c+28>>2]=f[a+28>>2];f[c+32>>2]=f[a+32>>2];p=c+16|0;dX(f[p>>2]|0);q=c+24|0;r=f[q>>2]|0;s=c+20|0;if((f[(f[a+16>>2]|0)+60>>2]|0)<(r*3|0)){t=s;v=r;w=f[s>>2]|0}else{WC(f[s>>2]|0);f[s>>2]=0;r=f[a+24>>2]|0;f[q>>2]=r;x=VC(r<<2)|0;f[s>>2]=x;t=s;v=f[q>>2]|0;w=x}Nac(w|0,0,v<<2|0)|0;v=xQ(a,h)|0;a:do if(v|0){w=h+4|0;x=h+8|0;s=v;while(1){r=f[p>>2]|0;y=r+56|0;z=f[y>>2]|0;f[g>>2]=z;if(!z){cX(r,0,g)|0;A=f[p>>2]|0;B=f[g>>2]|0}else{f[y>>2]=f[z+4>>2];f[z>>2]=f[z>>2]&67108863;y=r+60|0;f[y>>2]=(f[y>>2]|0)+1;A=r;B=z}z=(f[q>>2]|0)+-1&f[s>>2];Vac(B|0,s|0,f[A+28>>2]|0)|0;r=(f[t>>2]|0)+(z<<2)|0;f[B+4>>2]=f[r>>2];f[r>>2]=B;r=f[(f[w>>2]|0)+4>>2]|0;if(!r){z=(f[x>>2]|0)+1|0;f[x>>2]=z;y=f[h>>2]|0;C=f[y+24>>2]|0;if((z|0)>=(C|0))break a;D=f[y+20>>2]|0;y=z;while(1){E=f[D+(y<<2)>>2]|0;if(E|0)break;z=y+1|0;if((z|0)<(C|0))y=z;else break a}f[x>>2]=y;F=E}else F=r;f[w>>2]=F;s=F}}while(0);u=e;return}tL(g,a,0,1,1,0);tL(h,c,0,1,1,0);b:do if(((f[h>>2]^f[g>>2])&7|0)==0?(F=f[g+40>>2]|0,E=f[F+-4>>2]|0,B=f[h+40>>2]|0,(E|0)==(f[B+-4>>2]|0)):0){if((E|0)==2){if((f[F>>2]|0)!=(f[B>>2]|0)){G=30;break}if((f[F+4>>2]|0)==(f[B+4>>2]|0))break;else{G=30;break}}if((E|0)>0){t=0;do{if((f[F+(t<<2)>>2]|0)!=(f[B+(t<<2)>>2]|0)){G=30;break b}t=t+1|0}while((t|0)<(E|0))}}else G=30;while(0);if((G|0)==30){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,50)|0;n=193309;o=m+50|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,193302,192318,1279);bD(i)}if((l?(f[a>>2]|0)==112:0)?(f[a+68>>2]|0)!=0:0)H=LQ(a)|0;else H=0;if(((c|0)!=0?(f[c>>2]|0)==112:0)?(f[c+68>>2]|0)!=0:0)I=LQ(c)|0;else I=0;c=(I|0)==0;do if(!(I|H)){if((f[h>>2]^f[g>>2])&4088|0){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,32)|0;n=193433;o=m+32|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,193302,192318,1297);bD(i)}if(!d){a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;SP(g,i);break}a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;tL(k,d,0,1,0,0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=k;TP(g,i,j);a=k+36|0;l=f[a>>2]|0;if(l|0?(E=l+12|0,l=f[E>>2]|0,f[E>>2]=l+-1,(l|0)==1):0)kL(k);f[a>>2]=0;a=k+16|0;l=k+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[l>>2]|0)>0){a=f[k+40>>2]|0;E=0;do{f[a+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))UC(l)}else{if((H|0)==0?(f[g>>2]&4088|0)!=0:0)G=44;else G=42;if(((G|0)==42?c:0)?f[h>>2]&4088|0:0)G=44;if((G|0)==44){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,72)|0;n=193360;o=m+72|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,193302,192318,1290);bD(i)}l=H+-1|0;f[i>>2]=(l|0)>0?l:0;l=I+-1|0;f[i+4>>2]=(l|0)>0?l:0;zI(g,1,h,1,i,1)}while(0);i=h+36|0;I=f[i>>2]|0;if(I|0?(H=I+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)kL(h);f[i>>2]=0;i=h+16|0;I=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[I>>2]|0)>0){i=f[h+40>>2]|0;H=0;do{f[i+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[I>>2]|0))}I=f[h+44>>2]|0;if((I|0)!=(h+48|0))UC(I);I=g+36|0;h=f[I>>2]|0;if(h|0?(H=h+12|0,h=f[H>>2]|0,f[H>>2]=h+-1,(h|0)==1):0)kL(g);f[I>>2]=0;I=g+16|0;h=g+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[h>>2]|0)>0){I=f[g+40>>2]|0;H=0;do{f[I+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))UC(h);u=e;return}function aQ(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+96|0;c=b+32|0;d=b;if(a|0?(f[a>>2]&-65536|0)==1111752704:0){dX(f[a+16>>2]|0);e=f[a+20>>2]|0;if(!e){u=b;return}Nac(e|0,0,f[a+24>>2]<<2|0)|0;u=b;return}tL(c,a,0,1,0,0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;UP(c,d)|0;d=c+36|0;a=f[d>>2]|0;if(a|0?(e=a+12|0,a=f[e>>2]|0,f[e>>2]=a+-1,(a|0)==1):0)kL(c);f[d>>2]=0;d=c+16|0;a=c+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[a>>2]|0)>0){d=f[c+40>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[a>>2]|0))}a=f[c+44>>2]|0;if((a|0)!=(c+48|0))UC(a);u=b;return}function bQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;e=u;u=u+16|0;d=e;f[d>>2]=0;f[d+4>>2]=0;c=aD(d,44)|0;a=215603;g=c+44|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(g|0));bO(-216,d,215648,215662,107);bD(d);u=e;return}function cQ(a){a=a|0;return}function dQ(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;return}function eQ(a){a=a|0;return}function fQ(a,b){a=a|0;b=b|0;return}function gQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=hQ(a,b,c)|0;iQ(d);return d|0}function hQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=d&4095;if((c|a|0)<0){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,28)|0;j=193662;k=i+28|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-201,g,193691,193466,119);bD(g)}l=(d>>>3&511)+1<<(47696>>>(d<<1&14)&3);if((l|0)<1){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,19)|0;j=193709;k=i+19|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-210,g,193691,193466,123);bD(g)}g=Y(l,c)|0;l=VC(28)|0;f[l+4>>2]=g;f[l>>2]=h|1111638016;f[l+20>>2]=a;f[l+24>>2]=c;f[l+16>>2]=0;f[l+8>>2]=0;f[l+12>>2]=1;c=cbc(a|0,((a|0)<0)<<31>>31|0,g|0,((g|0)<0)<<31>>31|0)|0;g=J;if(!((g|0)>0|(g|0)==0&c>>>0>2147483647)){u=e;return l|0}f[l>>2]=h|1111621632;u=e;return l|0}function iQ(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+16|0;d=c;do if(a|0){e=f[a>>2]|0;g=e&-65536;if(((g|0)==1111621632?(h=a+24|0,i=f[h>>2]|0,(i|0)>-1):0)?(j=a+20|0,k=f[j>>2]|0,(k|0)>-1):0){l=f[a+4>>2]|0;if((i|0)==0|(k|0)==0){u=c;return}k=a+16|0;if(f[k>>2]|0){f[d>>2]=0;f[d+4>>2]=0;m=aD(d,25)|0;n=193533;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-2,d,193559,193466,806);bD(d)}if(!l){i=f[a>>2]|0;p=Y((i>>>3&511)+1<<(47696>>>(i<<1&14)&3),f[h>>2]|0)|0}else p=l;i=f[j>>2]|0;q=cbc(i|0,((i|0)<0)<<31>>31|0,p|0,0)|0;i=Kac(q|0,J|0,68,0)|0;if(!((i|0)==(i|0)&(J|0)==0)){f[d>>2]=0;f[d+4>>2]=0;m=aD(d,27)|0;n=193572;o=m+27|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-4,d,193559,193466,814);bD(d)}j=VC(i)|0;f[a+8>>2]=j;f[k>>2]=j+4+63&-64;f[j>>2]=1;u=c;return}if((e|0)==112){j=a+68|0;if(f[j>>2]|0){f[d>>2]=0;f[d+4>>2]=0;m=aD(d,25)|0;n=193533;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-2,d,193559,193466,824);bD(d)}k=f[125766]|0;if(!k){i=f[a+72>>2]|0;l=f[a+44>>2]|0;h=cbc(l|0,((l|0)<0)<<31>>31|0,i|0,((i|0)<0)<<31>>31|0)|0;i=a+64|0;l=f[i>>2]|0;if((l|0)==(h|0)&(((l|0)<0)<<31>>31|0)==(J|0))r=l;else{f[d>>2]=0;f[d+4>>2]=0;m=aD(d,22)|0;n=193600;o=m+22|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-4,d,193559,193466,830);bD(d);r=f[i>>2]|0}l=VC(r)|0;f[a+108>>2]=l;f[j>>2]=l;u=c;return}else{l=a+16|0;h=f[l>>2]|0;q=a+40|0;s=f[q>>2]|0;switch(h|0){case 32:case 64:{t=Y((h|0)==32?4:8,s)|0;f[q>>2]=t;f[l>>2]=8;break}default:{}}_h[k&255](a,0,0);f[q>>2]=s;f[l>>2]=h;u=c;return}}else{if((g|0)!=1111687168)break;h=(e>>>3&511)+1<<(47696>>>(e<<1&14)&3);l=a+20|0;if(!(f[l>>2]|0)){u=c;return}s=a+16|0;if(!(f[s>>2]|0))v=e;else{f[d>>2]=0;f[d+4>>2]=0;m=aD(d,25)|0;n=193533;o=m+25|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-2,d,193559,193466,860);bD(d);v=f[a>>2]|0}if(!(v&16384)){e=f[a+4>>2]|0;if((e|0)>0){g=e;e=h;while(1){k=g;g=g+-1|0;j=Y(f[l+(g<<3)>>2]|0,f[l+(g<<3)+4>>2]|0)|0;i=e>>>0<j>>>0?j:e;if((k|0)<=1){w=i;break}else e=i}}else w=h}else{e=f[a+24>>2]|0;w=Y((e|0)==0?h:e,f[l>>2]|0)|0}e=VC(w+68|0)|0;f[a+8>>2]=e;f[s>>2]=e+4+63&-64;f[e>>2]=1;u=c;return}}while(0);f[d>>2]=0;f[d+4>>2]=0;m=aD(d,38)|0;n=193623;o=m+38|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-5,d,193559,193466,885);bD(d);u=c;return}function jQ(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i;if(!a){f[j>>2]=0;f[j+4>>2]=0;bO(-27,j,193729,193466,147);bD(j)}if((d|c|0)<0){f[j>>2]=0;f[j+4>>2]=0;k=aD(j,25)|0;l=193745;m=k+25|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-201,j,193729,193466,153);bD(j)}l=e&4095|1111621632;f[a>>2]=l;k=a+20|0;f[k>>2]=c;f[a+24>>2]=d;f[a+16>>2]=g;f[a+8>>2]=0;f[a+12>>2]=0;g=Y((e>>>3&511)+1<<(47696>>>(e<<1&14)&3),d)|0;if((h|0)<2147483647)switch(h|0){case 0:{n=g;o=c;break}default:p=6}else switch(h|0){case 2147483647:{n=g;o=c;break}default:p=6}if((p|0)==6)if((g|0)>(h|0)){f[j>>2]=0;f[j+4>>2]=0;bO(-13,j,193729,193466,169);bD(j);n=h;o=f[k>>2]|0}else{n=h;o=c}f[a+4>>2]=n;c=cbc(o|0,((o|0)<0)<<31>>31|0,n|0,((n|0)<0)<<31>>31|0)|0;h=J;f[a>>2]=l|((h|0)>0|(h|0)==0&c>>>0>2147483647?0:(n|0)==(g|0)|(o|0)==1?16384:0);u=i;return a|0}function kQ(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;bO(-9,c,193771,193466,190);bD(c)}d=f[a>>2]|0;if(!d){u=b;return}e=f[d>>2]&-65536;a:do if((e|0)<1111687168){switch(e|0){case 1111621632:break;default:{g=7;break a}}if(!((f[d+24>>2]|0)>-1?(f[d+20>>2]|0)>-1:0))g=7}else switch(e|0){case 1111687168:break;default:g=7}while(0);if((g|0)==7){f[c>>2]=0;f[c+4>>2]=0;bO(-206,c,193771,193466,197);bD(c)}f[a>>2]=0;a=f[d>>2]&-65536;b:do if((a|0)<1111687168){switch(a|0){case 1111621632:break;default:break b}if(((f[d+24>>2]|0)>0?(f[d+20>>2]|0)>0:0)?(c=d+16|0,f[c>>2]|0):0){f[c>>2]=0;c=d+8|0;g=f[c>>2]|0;if(g|0?(e=(f[g>>2]|0)+-1|0,f[g>>2]=e,(e|0)==0):0){WC(g);f[c>>2]=0}f[c>>2]=0}}else{switch(a|0){case 1111687168:break;default:break b}c=d+16|0;if(f[c>>2]|0){f[c>>2]=0;c=d+8|0;g=f[c>>2]|0;if(g|0?(e=(f[g>>2]|0)+-1|0,f[g>>2]=e,(e|0)==0):0){WC(g);f[c>>2]=0}f[c>>2]=0}}while(0);WC(d);u=b;return}function lQ(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;if((((a|0)!=0?(e=f[a>>2]|0,(e&-65536|0)==1111621632):0)?(g=f[a+24>>2]|0,(g|0)>0):0)?(h=f[a+20>>2]|0,(h|0)>0):0){i=h;j=g;k=e}else{f[d>>2]=0;f[d+4>>2]=0;e=aD(d,16)|0;g=193784;h=e+16|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-5,d,193801,193466,212);bD(d);i=f[a+20>>2]|0;j=f[a+24>>2]|0;k=f[a>>2]|0}d=hQ(i,j,k)|0;if(!(f[a+16>>2]|0)){u=c;return d|0}iQ(d);$P(a,d,0);u=c;return d|0}function mQ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0;h=u;u=u+16|0;i=h;j=e&4095;k=(e>>>3&511)+1<<(47696>>>(e<<1&14)&3);if(!a){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,26)|0;m=193812;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-27,i,193839,193466,238);bD(i)}if(!k){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,23)|0;m=193857;n=l+23|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-210,i,193839,193466,241);bD(i)}if(!d){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,20)|0;m=193881;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-27,i,193839,193466,244);bD(i)}if((c+-1|0)>>>0>31){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,46)|0;m=193902;n=l+46|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-211,i,193839,193466,248);bD(i);if((c|0)<=0){o=0;p=k;q=(o|0)<0;r=p>>>0<2147483648;s=(o|0)==0;t=s&r;v=q|t;w=v?1111703552:1111687168;x=w|j;f[a>>2]=x;y=a+4|0;f[y>>2]=c;z=a+16|0;f[z>>2]=g;A=a+8|0;f[A>>2]=0;B=a+12|0;f[B>>2]=0;u=h;return a|0}}e=i+4|0;C=i+4|0;D=c;E=0;F=k;while(1){k=D;D=D+-1|0;G=d+(D<<2)|0;H=f[G>>2]|0;if((H|0)<0){f[i>>2]=0;f[e>>2]=0;l=aD(i,37)|0;m=193949;n=l+37|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-201,i,193839,193466,253);bD(i);I=f[G>>2]|0}else I=H;f[a+20+(D<<3)>>2]=I;if((E|0)>0|(E|0)==0&F>>>0>2147483647){f[i>>2]=0;f[C>>2]=0;l=aD(i,20)|0;m=193987;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-211,i,193839,193466,256);bD(i)}f[a+20+(D<<3)+4>>2]=F;H=f[G>>2]|0;K=cbc(H|0,((H|0)<0)<<31>>31|0,F|0,E|0)|0;H=J;if((k|0)<=1){o=H;p=K;break}else{E=H;F=K}}q=(o|0)<0;r=p>>>0<2147483648;s=(o|0)==0;t=s&r;v=q|t;w=v?1111703552:1111687168;x=w|j;f[a>>2]=x;y=a+4|0;f[y>>2]=c;z=a+16|0;f[z>>2]=g;A=a+8|0;f[A>>2]=0;B=a+12|0;f[B>>2]=0;u=h;return a|0}function nQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=oQ(a,b,c)|0;iQ(d);return d|0}function oQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;if((a+-1|0)>>>0>31){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,46)|0;i=193902;j=h+46|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-211,g,194008,193466,287);bD(g)}g=VC(276)|0;mQ(g,a,c,d,0)|0;f[g+12>>2]=1;u=e;return g|0}function pQ(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+256|0;d=c+128|0;e=c+72|0;g=c+16|0;h=c;if(!((a|0)!=0?(f[a>>2]&-65536|0)==1111687168:0)){f[d>>2]=0;f[d+4>>2]=0;i=aD(d,18)|0;j=194028;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-5,d,194047,193466,302);bD(d)}l=a+4|0;m=f[l>>2]|0;if((m|0)<33)n=m;else{f[d>>2]=0;f[d+4>>2]=0;i=aD(d,15)|0;j=194060;k=i+15|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,d,194047,193466,304);bD(d);n=f[l>>2]|0}if((n|0)>0){l=0;do{f[d+(l<<2)>>2]=f[a+20+(l<<3)>>2];l=l+1|0}while((l|0)<(n|0))}l=oQ(n,d,f[a>>2]|0)|0;if(!(f[a+16>>2]|0)){u=c;return l|0}iQ(l);tL(e,a,0,1,0,0);tL(g,l,0,1,0,0);a=f[l+16>>2]|0;d=h+8|0;f[d>>2]=0;f[d+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;SP(e,h);d=g+16|0;if((f[d>>2]|0)!=(a|0)){f[h>>2]=0;f[h+4>>2]=0;i=aD(h,18)|0;j=194076;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,h,194047,193466,319);bD(h)}h=g+36|0;j=f[h>>2]|0;if(j|0?(i=j+12|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)kL(g);f[h>>2]=0;h=g+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[h>>2]|0)>0){d=f[g+40>>2]|0;j=0;do{f[d+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))UC(h);h=e+36|0;g=f[h>>2]|0;if(g|0?(j=g+12|0,g=f[j>>2]|0,f[j>>2]=g+-1,(g|0)==1):0)kL(e);f[h>>2]=0;h=e+16|0;g=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[g>>2]|0)>0){h=f[e+40>>2]|0;j=0;do{f[h+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)!=(e+48|0))UC(g);u=c;return l|0}function qQ(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;i=u;u=u+16|0;j=i+8|0;k=i;if((a+-1|0)>>>0>9){f[j>>2]=0;f[j+4>>2]=0;l=aD(j,26)|0;m=194095;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-211,j,194122,193466,394);bD(j)}if(!((c|0)!=0&(e|0)!=0)){f[j>>2]=0;f[j+4>>2]=0;l=aD(j,39)|0;m=194143;n=l+39|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-27,j,194122,193466,397);bD(j)}if(!g){f[j>>2]=0;f[j+4>>2]=0;l=aD(j,24)|0;m=194183;n=l+24|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-27,j,194122,193466,400);bD(j)}if(d|0){f[j>>2]=0;f[j+4>>2]=0;l=aD(j,35)|0;m=194208;n=l+35|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-5,j,194122,193466,403);bD(j)}d=j+4|0;o=k+4|0;p=h&255;q=(h&4|0)==0;h=j+4|0;r=j+4|0;s=j+4|0;t=j+4|0;v=j+4|0;w=0;x=-1;y=0;while(1){z=f[c+(y<<2)>>2]|0;if(z)if((f[z>>2]&-65536|0)==1111687168?(f[z+16>>2]|0)!=0:0)A=z;else B=14;else{f[j>>2]=0;f[d>>2]=0;l=aD(j,39)|0;m=194143;n=l+39|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-27,j,194122,193466,411);bD(j);B=14}if((B|0)==14){B=0;f[j>>2]=0;C=rQ(z,e+(y*276|0)|0,j)|0;if(f[j>>2]|0){f[k>>2]=0;f[o>>2]=0;l=aD(k,27)|0;m=194244;n=l+27|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-24,k,194122,193466,420);bD(k)}A=C}z=g+184+(y<<2)|0;f[z>>2]=A;D=A+4|0;if((y|0)>0){if((f[D>>2]|0)!=(f[w+4>>2]|0)){f[j>>2]=0;f[v>>2]=0;l=aD(j,47)|0;m=194272;n=l+47|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-209,j,194122,193466,429);bD(j)}switch(p&3){case 0:{if((f[w>>2]^f[A>>2])&4095|0){f[j>>2]=0;f[r>>2]=0;l=aD(j,40)|0;m=194320;n=l+40|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-205,j,194122,193466,436);bD(j)}break}case 1:{if((f[w>>2]^f[A>>2])&4088|0){f[j>>2]=0;f[s>>2]=0;l=aD(j,49)|0;m=194361;n=l+49|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-205,j,194122,193466,441);bD(j)}break}case 2:{if((f[w>>2]^f[A>>2])&4088|0){f[j>>2]=0;f[t>>2]=0;l=aD(j,36)|0;m=194411;n=l+36|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-205,j,194122,193466,446);bD(j)}break}default:{}}if(q?(C=f[D>>2]|0,(C|0)>0):0){E=0;F=C;while(1){if((f[A+20+(E<<3)>>2]|0)==(f[w+20+(E<<3)>>2]|0))G=F;else{f[j>>2]=0;f[h>>2]=0;l=aD(j,43)|0;m=194448;n=l+43|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-209,j,194122,193466,455);bD(j);G=f[D>>2]|0}E=E+1|0;if((E|0)>=(G|0)){H=w;break}else F=G}}else H=w}else H=A;F=f[A>>2]|0;E=(F>>>3&511)+1<<(47696>>>(F<<1&14)&3);F=f[D>>2]|0;C=F+-1|0;a:do if((C|0)>(x|0)){I=F;K=C;L=E;M=0;while(1){N=f[A+20+(K<<3)+4>>2]|0;if(!((L|0)==(N|0)&(M|0)==(((N|0)<0)<<31>>31|0))){O=I;P=K;Q=M;R=L;break a}N=f[A+20+(K<<3)>>2]|0;S=cbc(N|0,((N|0)<0)<<31>>31|0,L|0,M|0)|0;N=J;T=K+-1|0;if((T|0)>(x|0)){U=K;K=T;L=S;M=N;I=U}else{O=K;P=T;Q=N;R=S;break}}}else{O=F;P=C;Q=0;R=E}while(0);E=(P|0)==(x|0)&((Q|0)>0|(Q|0)==0&R>>>0>2147483647)?O:P;x=(E|0)>(x|0)?E:x;f[z>>2]=A;f[g+16+(y<<2)>>2]=f[A+16>>2];y=y+1|0;if((y|0)>=(a|0))break;else w=H}w=(f[H+4>>2]|0)+-1|0;if((w|0)>(x|0)){y=1;A=w;do{y=Y(f[H+20+(A<<3)>>2]|0,y)|0;A=A+-1|0}while((A|0)>(x|0));V=y;W=1}else{V=1;W=1}y=x+1|0;f[g+4>>2]=y;f[g>>2]=a;a=g+8|0;f[a>>2]=V;f[a+4>>2]=W;if((x|0)<0){u=i;return y|0}else X=0;do{f[g+56+(X<<2)>>2]=f[H+20+(X<<3)>>2];X=X+1|0}while((X|0)!=(y|0));u=i;return y|0}function rQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+48|0;g=e+8|0;h=e;if(d|0)f[d>>2]=0;i=(a|0)!=0;if(!(i&(c|0)!=0)){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,28)|0;k=194492;l=j+28|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-27,g,194521,193466,336);bD(g)}if(i){i=f[a>>2]|0;if((i&-65536|0)==1111687168){if(f[a+16>>2]|0){m=a;u=e;return m|0}f[g>>2]=0;f[g+4>>2]=0;j=aD(g,32)|0;k=194532;l=j+32|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-27,g,194521,193466,341);bD(g);m=a;u=e;return m|0}if((i|0)==112)n=sQ(a,g,d,0)|0;else n=a;if(n)if(((f[n>>2]&-65536|0)==1111621632?(f[n+24>>2]|0)>0:0)?(f[n+20>>2]|0)>0:0){o=n;p=g}else{q=n;r=g;s=16}else{q=0;r=g;s=16}}else{q=0;r=g;s=16}if((s|0)==16){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,38)|0;k=194565;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-5,h,194521,193466,353);bD(h);o=q;p=r}r=o+16|0;p=f[r>>2]|0;if(!p){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,33)|0;k=194604;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-27,h,194521,193466,356);bD(h);t=f[r>>2]|0}else t=p;f[c+16>>2]=t;f[c+8>>2]=0;f[c+12>>2]=0;t=f[o>>2]|0;f[c>>2]=t;f[c+4>>2]=2;f[c+20>>2]=f[o+20>>2];f[c+24>>2]=f[o+4>>2];f[c+28>>2]=f[o+24>>2];f[c+32>>2]=(t>>>3&511)+1<<(47696>>>(t<<1&14)&3);m=c;u=e;return m|0}function sQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+16|0;h=g;i=(a|0)!=0;if(!(i&(c|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,28)|0;k=194492;l=j+28|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-27,h,194638,193466,2391);bD(h)}do if(i){m=f[a>>2]|0;n=m&-65536;if(((n|0)==1111621632?(f[a+24>>2]|0)>0:0)?(f[a+20>>2]|0)>0:0){if(f[a+16>>2]|0){o=a;p=0;break}f[h>>2]=0;f[h+4>>2]=0;j=aD(h,32)|0;k=194532;l=j+32|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-27,h,194638,193466,2396);bD(h);o=a;p=0;break}if((m|0)!=112){if(!((e|0)!=0&(n|0)==1111687168)){q=34;break}r=a+20|0;s=f[r>>2]|0;t=a+16|0;if(!(f[t>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,33)|0;k=194604;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-27,h,194638,193466,2466);bD(h);v=f[a>>2]|0}else v=m;if(!(v&16384)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,44)|0;k=194841;l=j+44|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-5,h,194638,193466,2469);bD(h)}m=f[a+4>>2]|0;if((m|0)<=2)if((m|0)==1)w=1;else w=f[a+28>>2]|0;else{n=1;x=1;while(1){y=Y(f[r+(x<<3)>>2]|0,n)|0;x=x+1|0;if((x|0)==(m|0)){w=y;break}else n=y}}f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=f[t>>2];f[c+20>>2]=s;f[c+24>>2]=w;n=f[a>>2]|0;m=n&4095;f[c>>2]=m|1111638016;x=Y((n>>>3&511)+1<<(47696>>>(n<<1&14)&3),w)|0;n=(s|0)>1?x:0;f[c+4>>2]=n;x=cbc(n|0,((n|0)<0)<<31>>31|0,s|0,((s|0)<0)<<31>>31|0)|0;n=J;if(!((n|0)>0|(n|0)==0&x>>>0>2147483647)){o=c;p=0;break}f[c>>2]=m|1111621632;o=c;p=0;break}m=a+68|0;if(!(f[m>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,31)|0;k=194647;l=j+31|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-27,h,194638,193466,2406);bD(h)}s=f[a+16>>2]|0;t=1125516576>>>((s>>>2&60)+(s>>31&20)|0);s=t&7;x=f[a+8>>2]|0;n=(x|0)>1?f[a+28>>2]|0:0;r=a+48|0;y=f[r>>2]|0;if(!y){z=s|(x<<3)+-8;if(n|0){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,40)|0;k=194800;l=j+40|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-206,h,194638,193466,2452);bD(h)}jQ(c,f[a+44>>2]|0,f[a+40>>2]|0,z,f[m>>2]|0,f[a+72>>2]|0)|0;o=c;p=0;break}A=f[y>>2]|0;if((n|0)==1){if(!A){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,63)|0;k=194679;l=j+63|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-206,h,194638,193466,2422);bD(h);n=f[r>>2]|0;B=n;C=f[n>>2]|0}else{B=y;C=A}n=(f[m>>2]|0)+(Y(C+-1|0,f[a+64>>2]|0)|0)|0;z=f[a+72>>2]|0;D=n+(Y(z,f[B+8>>2]|0)|0)|0;jQ(c,f[B+16>>2]|0,f[B+12>>2]|0,s,D+(f[B+4>>2]<<(47696>>>(t<<1&14)&3))|0,z)|0;o=c;p=0;break}else{z=(x<<3)+-8|0;D=s|z;if((x|0)>512){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,56)|0;k=194743;l=j+56|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-15,h,194638,193466,2438);bD(h);E=f[r>>2]|0}else E=y;x=f[a+72>>2]|0;s=(f[m>>2]|0)+(Y(x,f[E+8>>2]|0)|0)|0;jQ(c,f[E+16>>2]|0,f[E+12>>2]|0,D,s+(Y(f[E+4>>2]|0,(z>>>3&511)+1<<(47696>>>(t<<1&14)&3))|0)|0,x)|0;o=c;p=A;break}}else q=34;while(0);if((q|0)==34){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,38)|0;k=194565;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-206,h,194638,193466,2493);bD(h);o=0;p=0}if(!d){u=g;return o|0}f[d>>2]=p;u=g;return o|0}function tQ(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=f[a+4>>2]|0;if((b|0)<=0){c=0;return c|0}d=a+184|0;e=a+16|0;g=b;while(1){b=g;g=g+-1|0;if((f[a>>2]|0)>0){h=0;do{i=a+16+(h<<2)|0;f[i>>2]=(f[i>>2]|0)+(f[(f[a+184+(h<<2)>>2]|0)+20+(g<<3)+4>>2]|0);h=h+1|0}while((h|0)<(f[a>>2]|0))}h=a+56+(g<<2)|0;i=f[h>>2]|0;f[h>>2]=i+-1;if((i|0)>1){c=1;j=10;break}i=f[d>>2]|0;k=f[i+20+(g<<3)>>2]|0;l=f[a>>2]|0;if((l|0)>0?(m=0-k|0,n=(f[e>>2]|0)+(Y(f[i+20+(g<<3)+4>>2]|0,m)|0)|0,f[e>>2]=n,(l|0)!=1):0){n=1;do{i=a+16+(n<<2)|0;o=(f[i>>2]|0)+(Y(f[(f[a+184+(n<<2)>>2]|0)+20+(g<<3)+4>>2]|0,m)|0)|0;f[i>>2]=o;n=n+1|0}while((n|0)<(l|0))}f[h>>2]=k;if((b|0)<=1){c=0;j=10;break}}if((j|0)==10)return c|0;return 0}function uQ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=d&4095;i=1212424721>>>(d<<2&28)&15;j=Y(i,(d>>>3&511)+1|0)|0;if(!j){f[g>>2]=0;f[g+4>>2]=0;k=aD(g,23)|0;l=193857;m=k+23|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-210,g,194886,193466,537);bD(g)}if((a+-1|0)>>>0>31){f[g>>2]=0;f[g+4>>2]=0;k=aD(g,24)|0;l=194904;m=k+24|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-211,g,194886,193466,540);bD(g)}if(!c){f[g>>2]=0;f[g+4>>2]=0;k=aD(g,20)|0;l=193881;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-27,g,194886,193466,543);bD(g)}if((a|0)>0){d=g+4|0;n=0;do{if((f[c+(n<<2)>>2]|0)<1){f[g>>2]=0;f[d>>2]=0;k=aD(g,37)|0;l=193949;m=k+37|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-201,g,194886,193466,548);bD(g)}n=n+1|0}while((n|0)<(a|0))}n=a+-32|0;g=VC((((n|0)>0?n:0)<<2)+164|0)|0;f[g>>2]=h|1111752704;f[g+4>>2]=a;f[g+8>>2]=0;f[g+12>>2]=1;h=a<<2;Vac(g+36|0,c|0,h|0)|0;c=i+7&0-i;f[g+28>>2]=c;i=j+3+c&65532;f[g+32>>2]=i;c=bX(0,64,h+7+i&-8,zW(4096)|0)|0;f[g+16>>2]=c;f[g+24>>2]=1024;c=VC(4096)|0;f[g+20>>2]=c;Nac(c|0,0,4096)|0;u=e;return g|0}function vQ(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;bO(-9,c,194929,193466,581);bD(c)}d=f[a>>2]|0;if(!d){u=b;return}if((f[d>>2]&-65536|0)!=1111752704){f[c>>2]=0;f[c+4>>2]=0;bO(-206,c,194929,193466,588);bD(c)}f[a>>2]=0;f[c>>2]=f[(f[d+16>>2]|0)+44>>2];BW(c);c=d+20|0;WC(f[c>>2]|0);f[c>>2]=0;WC(d);u=b;return}function wQ(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;if((a|0)!=0?(e=f[a>>2]|0,(e&-65536|0)==1111752704):0)g=e;else{f[d>>2]=0;f[d+4>>2]=0;e=aD(d,27)|0;h=194948;i=e+27|0;do{b[e>>0]=b[h>>0]|0;e=e+1|0;h=h+1|0}while((e|0)<(i|0));bO(-5,d,194976,193466,605);bD(d);g=f[a>>2]|0}d=uQ(f[a+4>>2]|0,a+36|0,g)|0;$P(a,d,0);u=c;return d|0}function xQ(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0?(f[a>>2]&-65536|0)==1111752704:0)){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,28)|0;h=194993;i=g+28|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-5,e,195022,193466,620);bD(e)}if(!c){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,21)|0;h=212132;i=g+21|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-27,e,195022,193466,623);bD(e)}f[c>>2]=a;e=c+4|0;f[e>>2]=0;h=f[a+24>>2]|0;if((h|0)<=0){j=0;k=0;l=c+8|0;f[l>>2]=j;u=d;return k|0}g=f[a+20>>2]|0;a=0;while(1){m=f[g+(a<<2)>>2]|0;if(m|0)break;i=a+1|0;if((i|0)<(h|0))a=i;else{j=i;k=0;n=11;break}}if((n|0)==11){l=c+8|0;f[l>>2]=j;u=d;return k|0}f[e>>2]=m;j=a;k=m;l=c+8|0;f[l>>2]=j;u=d;return k|0}function yQ(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;if(a|0){e=f[a>>2]|0;g=e&-65536;a:do if((g|0)<1111687168){switch(g|0){case 1111621632:break;default:break a}if((f[a+24>>2]|0)>0?(f[a+20>>2]|0)>0:0){if((f[a+24>>2]|0)<=0){u=c;return}if((f[a+20>>2]|0)<=0){u=c;return}h=a+16|0;if(!(f[h>>2]|0)){u=c;return}f[h>>2]=0;h=a+8|0;i=f[h>>2]|0;if(i|0?(j=(f[i>>2]|0)+-1|0,f[i>>2]=j,(j|0)==0):0){WC(i);f[h>>2]=0}f[h>>2]=0;u=c;return}}else{switch(g|0){case 1111687168:break;default:break a}h=a+16|0;if(!(f[h>>2]|0)){u=c;return}f[h>>2]=0;h=a+8|0;i=f[h>>2]|0;if(i|0?(j=(f[i>>2]|0)+-1|0,f[i>>2]=j,(j|0)==0):0){WC(i);f[h>>2]=0}f[h>>2]=0;u=c;return}while(0);if((e|0)==112){e=f[125767]|0;if(!e){g=a+108|0;h=f[g>>2]|0;f[g>>2]=0;f[a+68>>2]=0;WC(h);u=c;return}else{zh[e&2047](a,2);u=c;return}}}f[d>>2]=0;f[d+4>>2]=0;a=aD(d,38)|0;e=193623;h=a+38|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(h|0));bO(-5,d,195046,193466,1001);bD(d);u=c;return}function zQ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+16|0;h=g;do if(a|0){i=f[a>>2]|0;j=i&-65536;if((((j|0)==1111621632?(k=f[a+24>>2]|0,(k|0)>0):0)?(l=f[a+20>>2]|0,(l|0)>0):0)?(m=a+16|0,f[m>>2]|0):0){if(k>>>0>d>>>0&l>>>0>c>>>0)n=i;else{f[h>>2]=0;f[h+4>>2]=0;o=aD(h,21)|0;p=195060;q=o+21|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-211,h,195082,193466,1762);bD(h);n=f[a>>2]|0}if(e|0)f[e>>2]=n&4095;r=(f[m>>2]|0)+(Y(f[a+4>>2]|0,c)|0)+(Y((n>>>3&511)+1<<(47696>>>(n<<1&14)&3),d)|0)|0;u=g;return r|0}if((i|0)==112?(l=f[a+68>>2]|0,l|0):0){k=a+16|0;s=(f[k>>2]|0)>>>3&31;t=(f[a+28>>2]|0)==0;if(t)v=Y(f[a+8>>2]|0,s)|0;else v=s;s=f[a+48>>2]|0;if(s){w=f[s+12>>2]|0;x=f[s+16>>2]|0;y=Y(f[a+72>>2]|0,f[s+8>>2]|0)|0;z=l+((Y(f[s+4>>2]|0,v)|0)+y)|0;if(t){A=z;B=x;C=w}else{t=f[s>>2]|0;if(!t){f[h>>2]=0;f[h+4>>2]=0;o=aD(h,45)|0;p=195090;q=o+45|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-24,h,195082,193466,1793);bD(h)}A=z+(Y(f[a+64>>2]|0,t+-1|0)|0)|0;B=x;C=w}}else{A=l;B=f[a+44>>2]|0;C=f[a+40>>2]|0}if(!(C>>>0>d>>>0&B>>>0>c>>>0)){f[h>>2]=0;f[h+4>>2]=0;o=aD(h,21)|0;p=195060;q=o+21|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-211,h,195082,193466,1805);bD(h)}l=A+((Y(f[a+72>>2]|0,c)|0)+(Y(v,d)|0))|0;if(!e){r=l;u=g;return r|0}w=f[k>>2]|0;x=a+8|0;t=f[x>>2]|0;if((t+-1|0)>>>0>3){f[h>>2]=0;f[h+4>>2]=0;bO(-210,h,195082,193466,1813);bD(h);D=f[x>>2]|0}else D=t;f[e>>2]=(D<<3)+-8|1125516576>>>((w>>>2&60)+(w>>31&20)|0)&7;r=l;u=g;return r|0}if((j|0)!=1111687168){if((j|0)!=1111752704)break;if((f[a+4>>2]|0)!=2){f[h>>2]=0;f[h+4>>2]=0;o=aD(h,30)|0;p=195136;q=o+30|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,h,195082,193466,1833);bD(h)}f[h>>2]=c;f[h+4>>2]=d;r=AQ(a,h,e,1,0)|0;u=g;return r|0}j=a+16|0;k=f[j>>2]|0;if(k|0){if(((f[a+4>>2]|0)==2?(f[a+20>>2]|0)>>>0>c>>>0:0)?(f[a+28>>2]|0)>>>0>d>>>0:0)E=k;else{f[h>>2]=0;f[h+4>>2]=0;o=aD(h,21)|0;p=195060;q=o+21|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-211,h,195082,193466,1825);bD(h);E=f[j>>2]|0}k=E+(Y(f[a+24>>2]|0,c)|0)|0;l=k+(Y(f[a+32>>2]|0,d)|0)|0;if(!e){r=l;u=g;return r|0}f[e>>2]=f[a>>2]&4095;r=l;u=g;return r|0}}while(0);f[h>>2]=0;f[h+4>>2]=0;o=aD(h,38)|0;p=193623;q=o+38|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-5,h,195082,193466,1839);bD(h);r=0;u=g;return r|0}function AQ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=u;u=u+16|0;i=h;if(!g){j=a+4|0;k=f[j>>2]|0;if((k|0)>0){l=i+4|0;m=0;n=0;o=k;while(1){k=f[c+(m<<2)>>2]|0;if(k>>>0<(f[a+36+(m<<2)>>2]|0)>>>0)p=o;else{f[i>>2]=0;f[l>>2]=0;q=aD(i,30)|0;r=195167;s=q+30|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-211,i,195198,193466,657);bD(i);p=f[j>>2]|0}r=k+(Y(n,1540483477)|0)|0;m=m+1|0;if((m|0)>=(p|0)){t=r;break}else{n=r;o=p}}}else t=0}else t=f[g>>2]|0;g=a+24|0;p=f[g>>2]|0;o=p+-1&t;n=t&2147483647;a:do if((e|0)>-2?(t=f[(f[a+20>>2]|0)+(o<<2)>>2]|0,(t|0)!=0):0){m=a+32|0;j=a+4|0;l=t;while(1){if((f[l>>2]|0)==(n|0)){t=l+(f[m>>2]|0)|0;r=f[j>>2]|0;b:do if((r|0)>0){q=0;while(1){if((f[c+(q<<2)>>2]|0)!=(f[t+(q<<2)>>2]|0)){v=q;break b}s=q+1|0;if((s|0)<(r|0))q=s;else{v=s;break}}}else v=0;while(0);if((v|0)==(r|0))break}t=f[l+4>>2]|0;if(!t){w=0;break a}else l=t}w=l+(f[a+28>>2]|0)|0}else w=0;while(0);if((e|0)!=0&(w|0)==0){v=a+16|0;j=f[v>>2]|0;if((f[j+60>>2]|0)<(p*3|0)){x=o;y=j}else{j=p<<1;p=(j|0)>1024?j:1024;j=p<<2;o=VC(j)|0;Nac(o|0,0,j|0)|0;j=xQ(a,i)|0;if(j|0){m=i+4|0;k=i+8|0;t=p+-1|0;q=j;while(1){j=f[(f[m>>2]|0)+4>>2]|0;c:do if(!j){s=(f[k>>2]|0)+1|0;f[k>>2]=s;z=f[i>>2]|0;A=f[z+24>>2]|0;if((s|0)<(A|0)){B=f[z+20>>2]|0;z=s;while(1){C=f[B+(z<<2)>>2]|0;if(C|0)break;s=z+1|0;if((s|0)<(A|0))z=s;else{D=0;break c}}f[k>>2]=z;E=C;F=28}else D=0}else{E=j;F=28}while(0);if((F|0)==28){F=0;f[m>>2]=E;D=E}j=o+((f[q>>2]&t)<<2)|0;f[q+4>>2]=f[j>>2];f[j>>2]=q;if(!D)break;else q=D}}D=a+20|0;WC(f[D>>2]|0);f[D>>2]=o;f[g>>2]=p;x=p+2147483647&n;y=f[v>>2]|0}v=y+56|0;p=f[v>>2]|0;f[i>>2]=p;if(!p){cX(y,0,i)|0;G=f[i>>2]|0}else{f[v>>2]=f[p+4>>2];f[p>>2]=f[p>>2]&67108863;v=y+60|0;f[v>>2]=(f[v>>2]|0)+1;G=p}f[G>>2]=n;n=(f[a+20>>2]|0)+(x<<2)|0;f[G+4>>2]=f[n>>2];f[n>>2]=G;Vac(G+(f[a+32>>2]|0)|0,c|0,f[a+4>>2]<<2|0)|0;c=G+(f[a+28>>2]|0)|0;if((e|0)>0){e=f[a>>2]|0;Nac(c|0,0,(e>>>3&511)+1<<(47696>>>(e<<1&14)&3)|0)|0;H=c}else H=c}else H=w;if(!d){u=h;return H|0}f[d>>2]=f[a>>2]&4095;u=h;return H|0}function BQ(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;if(a|0){e=f[a>>2]|0;g=e&-65536;a:do if((g|0)<1111687168){switch(g|0){case 1111621632:break;default:break a}if((f[a+24>>2]|0)>0?(f[a+20>>2]|0)>0:0)h=5}else if((g|0)<1111752704)switch(g|0){case 1111687168:{h=5;break a;break}default:break a}else switch(g|0){case 1111752704:{h=5;break a;break}default:break a}while(0);if((h|0)==5){i=e&4095;u=c;return i|0}if((e|0)==112?f[a+68>>2]|0:0){e=f[a+16>>2]|0;i=1125516576>>>((e>>>2&60)+(e>>31&20)|0)&7|(f[a+8>>2]<<3)+-8;u=c;return i|0}}f[d>>2]=0;f[d+4>>2]=0;a=aD(d,38)|0;e=193623;h=a+38|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(h|0));bO(-5,d,195212,193466,1094);bD(d);i=-1;u=c;return i|0}
function Aab(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+160|0;g=e;h=e+112|0;i=e+36|0;j=e+24|0;k=e+16|0;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=h+4;l=h+12|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;m=h+24|0;bD(m);n=aD(m,11)|0;o=411836;p=n+11|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));o=h+32|0;bD(o);q=aD(o,6)|0;b[q>>0]=b[411848]|0;b[q+1>>0]=b[411849]|0;b[q+2>>0]=b[411850]|0;b[q+3>>0]=b[411851]|0;b[q+4>>0]=b[411852]|0;b[q+5>>0]=b[411853]|0;f[i>>2]=0;f[i+4>>2]=0;q=aD(i,4)|0;b[q>>0]=97;b[q+1>>0]=120;b[q+2>>0]=105;b[q+3>>0]=115;f[j>>2]=1;Wwa(h,i,j)|0;bD(i);f[i+40>>2]=0;f[i+44>>2]=0;q=i+40|0;r=i+36|0;n=i;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));f[r>>2]=q;q=i+48|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;q=a+4|0;f[g>>2]=f[q>>2];hO(k,411855,g);r=f[k>>2]|0;n=f[k+4>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(n>>>0>4294967279)V5b(j);if(n>>>0<11){b[j+11>>0]=n;if(!n)s=j;else{t=j;v=6}}else{p=n+16&-16;w=L5b(p)|0;f[j>>2]=w;f[j+8>>2]=p|-2147483648;f[j+4>>2]=n;t=w;v=6}if((v|0)==6){Vac(t|0,r|0,n|0)|0;s=t}b[s+n>>0]=0;bD(k);_5b(i,j)|0;k=f[o>>2]|0;n=h+36|0;s=f[n>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(s>>>0>4294967279)V5b(g);if(s>>>0<11){b[g+11>>0]=s;if(!s)x=g;else{y=g;v=12}}else{t=s+16&-16;r=L5b(t)|0;f[g>>2]=r;f[g+8>>2]=t|-2147483648;f[g+4>>2]=s;y=r;v=12}if((v|0)==12){Vac(y|0,k|0,s|0)|0;x=y}b[x+s>>0]=0;_5b(i+12|0,g)|0;if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);Fab(i+36|0,h)|0;cwa(i+48|0,f[l>>2]|0,f[h+16>>2]|0);l=i+60|0;bD(l);g=f[m>>2]|0;if(!g)z=0;else{s=g+-4|0;f[s>>2]=(f[s>>2]|0)+1;z=f[m>>2]|0}f[l>>2]=z;f[i+64>>2]=f[h+28>>2];z=i+68|0;bD(z);l=f[o>>2]|0;if(!l)A=0;else{m=l+-4|0;f[m>>2]=(f[m>>2]|0)+1;A=f[o>>2]|0}f[z>>2]=A;f[i+72>>2]=f[n>>2];a:do if((c|0)>0){n=a+20|0;A=a+24|0;z=i+28|0;o=i+32|0;m=i+24|0;l=0;while(1){s=f[d+(l<<2)>>2]|0;g=f[n>>2]|0;if((((f[A>>2]|0)-g|0)/12|0)>>>0<=s>>>0)break;x=g+(s*12|0)|0;s=f[z>>2]|0;if((s|0)==(f[o>>2]|0))JT(m,x);else{X5b(s,x);f[z>>2]=(f[z>>2]|0)+12}l=l+1|0;if((l|0)>=(c|0))break a}d4b(n)}while(0);c=a+8|0;_5b(c,j)|0;d=f[a>>2]|0;l=d+16|0;z=f[l>>2]|0;if((z|0)==(f[d+20>>2]|0))Gab(d+12|0,i);else{_ta(z,i);f[l>>2]=(f[l>>2]|0)+76}f[q>>2]=(f[q>>2]|0)+1;q=a+24|0;l=f[q>>2]|0;if((l|0)==(f[a+28>>2]|0))JT(a+20|0,c);else{X5b(l,c);f[q>>2]=(f[q>>2]|0)+12}if((b[j+11>>0]|0)>=0){Zta(i);fua(h);u=e;return}O5b(f[j>>2]|0);Zta(i);fua(h);u=e;return}function Bab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+160|0;e=d;g=d+112|0;h=d+120|0;i=d+36|0;j=d+24|0;k=d+16|0;f[g>>2]=c;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=h+4;c=h+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;l=h+24|0;bD(l);m=aD(l,10)|0;n=411810;o=m+10|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));p=h+32|0;bD(p);q=aD(p,5)|0;b[q>>0]=b[411821]|0;b[q+1>>0]=b[411822]|0;b[q+2>>0]=b[411823]|0;b[q+3>>0]=b[411824]|0;b[q+4>>0]=b[411825]|0;f[i>>2]=0;f[i+4>>2]=0;m=aD(i,12)|0;n=419464;o=m+12|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));Wwa(h,i,g)|0;bD(i);f[i+40>>2]=0;f[i+44>>2]=0;g=i+40|0;n=i+36|0;m=i;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[n>>2]=g;g=i+48|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;g=a+4|0;f[e>>2]=f[g>>2];hO(k,411827,e);n=f[k>>2]|0;m=f[k+4>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(m>>>0>4294967279)V5b(j);if(m>>>0<11){b[j+11>>0]=m;if(!m)r=j;else{s=j;t=6}}else{o=m+16&-16;q=L5b(o)|0;f[j>>2]=q;f[j+8>>2]=o|-2147483648;f[j+4>>2]=m;s=q;t=6}if((t|0)==6){Vac(s|0,n|0,m|0)|0;r=s}b[r+m>>0]=0;bD(k);_5b(i,j)|0;k=f[p>>2]|0;m=h+36|0;r=f[m>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(r>>>0>4294967279)V5b(e);if(r>>>0<11){b[e+11>>0]=r;if(!r)v=e;else{w=e;t=12}}else{s=r+16&-16;n=L5b(s)|0;f[e>>2]=n;f[e+8>>2]=s|-2147483648;f[e+4>>2]=r;w=n;t=12}if((t|0)==12){Vac(w|0,k|0,r|0)|0;v=w}b[v+r>>0]=0;_5b(i+12|0,e)|0;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);Fab(i+36|0,h)|0;cwa(i+48|0,f[c>>2]|0,f[h+16>>2]|0);c=i+60|0;bD(c);e=f[l>>2]|0;if(!e)x=0;else{r=e+-4|0;f[r>>2]=(f[r>>2]|0)+1;x=f[l>>2]|0}f[c>>2]=x;f[i+64>>2]=f[h+28>>2];x=i+68|0;bD(x);c=f[p>>2]|0;if(!c)y=0;else{l=c+-4|0;f[l>>2]=(f[l>>2]|0)+1;y=f[p>>2]|0}f[x>>2]=y;f[i+72>>2]=f[m>>2];m=a+8|0;y=i+28|0;x=f[y>>2]|0;if((x|0)==(f[i+32>>2]|0))JT(i+24|0,m);else{X5b(x,m);f[y>>2]=(f[y>>2]|0)+12}_5b(m,j)|0;y=f[a>>2]|0;x=y+16|0;p=f[x>>2]|0;if((p|0)==(f[y+20>>2]|0))Gab(y+12|0,i);else{_ta(p,i);f[x>>2]=(f[x>>2]|0)+76}f[g>>2]=(f[g>>2]|0)+1;g=a+24|0;x=f[g>>2]|0;if((x|0)==(f[a+28>>2]|0))JT(a+20|0,m);else{X5b(x,m);f[g>>2]=(f[g>>2]|0)+12}if((b[j+11>>0]|0)>=0){Zta(i);fua(h);u=d;return}O5b(f[j>>2]|0);Zta(i);fua(h);u=d;return}function Cab(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,g=0,h=0,i=0.0,j=0;d=u;u=u+160|0;e=d;g=d+8|0;n[e>>2]=c;h=Hab(a,b)|0;if((h|0)==(a+4|0)){i=c;u=d;return +i}a=g+64|0;b=g+8|0;f[b>>2]=106096;j=g+12|0;f[g>>2]=18124;f[a>>2]=18144;f[g+4>>2]=0;RXb(g+64|0,j);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=106076;f[a>>2]=106116;f[b>>2]=106096;WXb(j);f[j>>2]=43284;b=g+44|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[g+60>>2]=24;qP(j,h+28|0);cYb(g,e)|0;kya(g);i=+n[e>>2];u=d;return +i}function Dab(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;c=u;u=u+160|0;d=c;e=c+120|0;g=c+112|0;h=c+32|0;i=c+12|0;j=c+24|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=e+4;k=e+12|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;l=e+24|0;bD(l);m=aD(l,12)|0;n=411778;o=m+12|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));n=e+32|0;bD(n);p=aD(n,7)|0;b[p>>0]=b[411791]|0;b[p+1>>0]=b[411792]|0;b[p+2>>0]=b[411793]|0;b[p+3>>0]=b[411794]|0;b[p+4>>0]=b[411795]|0;b[p+5>>0]=b[411796]|0;b[p+6>>0]=b[411797]|0;p=L5b(16)|0;f[p>>2]=p+8;f[p+4>>2]=4;q=N5b(32)|0;f[p>>2]=q;f[g>>2]=0;f[g+4>>2]=p;p=q;f[p>>2]=0;f[p+4>>2]=0;p=q+8|0;f[p>>2]=2;f[p+4>>2]=0;p=q+16|0;f[p>>2]=3;f[p+4>>2]=0;p=q+24|0;f[p>>2]=1;f[p+4>>2]=0;f[h>>2]=0;f[h+4>>2]=0;p=aD(h,5)|0;b[p>>0]=b[428511]|0;b[p+1>>0]=b[428512]|0;b[p+2>>0]=b[428513]|0;b[p+3>>0]=b[428514]|0;b[p+4>>0]=b[428515]|0;nxa(e,h,g)|0;bD(h);f[h+40>>2]=0;f[h+44>>2]=0;p=h+40|0;q=h+36|0;m=h;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[q>>2]=p;p=h+48|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;p=a+4|0;f[d>>2]=f[p>>2];hO(j,411799,d);q=f[j>>2]|0;m=f[j+4>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(m>>>0>4294967279)V5b(i);if(m>>>0<11){b[i+11>>0]=m;if(!m)r=i;else{s=i;t=6}}else{o=m+16&-16;v=L5b(o)|0;f[i>>2]=v;f[i+8>>2]=o|-2147483648;f[i+4>>2]=m;s=v;t=6}if((t|0)==6){Vac(s|0,q|0,m|0)|0;r=s}b[r+m>>0]=0;bD(j);_5b(h,i)|0;j=f[n>>2]|0;m=e+36|0;r=f[m>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;if(r>>>0>4294967279)V5b(d);if(r>>>0<11){b[d+11>>0]=r;if(!r)w=d;else{x=d;t=12}}else{s=r+16&-16;q=L5b(s)|0;f[d>>2]=q;f[d+8>>2]=s|-2147483648;f[d+4>>2]=r;x=q;t=12}if((t|0)==12){Vac(x|0,j|0,r|0)|0;w=x}b[w+r>>0]=0;_5b(h+12|0,d)|0;if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);Fab(h+36|0,e)|0;cwa(h+48|0,f[k>>2]|0,f[e+16>>2]|0);k=h+60|0;bD(k);d=f[l>>2]|0;if(!d)y=0;else{r=d+-4|0;f[r>>2]=(f[r>>2]|0)+1;y=f[l>>2]|0}f[k>>2]=y;f[h+64>>2]=f[e+28>>2];y=h+68|0;bD(y);k=f[n>>2]|0;if(!k)z=0;else{l=k+-4|0;f[l>>2]=(f[l>>2]|0)+1;z=f[n>>2]|0}f[y>>2]=z;f[h+72>>2]=f[m>>2];m=a+8|0;z=h+28|0;y=f[z>>2]|0;if((y|0)==(f[h+32>>2]|0))JT(h+24|0,m);else{X5b(y,m);f[z>>2]=(f[z>>2]|0)+12}_5b(m,i)|0;z=f[a>>2]|0;y=z+16|0;n=f[y>>2]|0;if((n|0)==(f[z+20>>2]|0))Gab(z+12|0,h);else{_ta(n,h);f[y>>2]=(f[y>>2]|0)+76}f[p>>2]=(f[p>>2]|0)+1;p=a+24|0;y=f[p>>2]|0;if((y|0)==(f[a+28>>2]|0))JT(a+20|0,m);else{X5b(y,m);f[p>>2]=(f[p>>2]|0)+12}if((b[i+11>>0]|0)>=0){Zta(h);gua(g);fua(e);u=c;return}O5b(f[i>>2]|0);Zta(h);gua(g);fua(e);u=c;return}function Eab(a,c,d,e,g,h,i,j,k){a=a|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;l=u;u=u+272|0;m=l+196|0;o=l+192|0;p=l+148|0;q=l+144|0;r=l+140|0;s=l+136|0;t=l+152|0;v=l+24|0;w=l+80|0;x=l+12|0;y=l;n[o>>2]=c;f[p>>2]=d;f[q>>2]=e;f[r>>2]=g;f[s>>2]=h;f[t+4>>2]=0;f[t+8>>2]=0;f[t>>2]=t+4;h=t+12|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;g=t+24|0;bD(g);e=aD(g,11)|0;d=411745;z=e+11|0;do{b[e>>0]=b[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(z|0));A=t+32|0;bD(A);B=aD(A,6)|0;b[B>>0]=b[411757]|0;b[B+1>>0]=b[411758]|0;b[B+2>>0]=b[411759]|0;b[B+3>>0]=b[411760]|0;b[B+4>>0]=b[411761]|0;b[B+5>>0]=b[411762]|0;f[m>>2]=0;f[m+4>>2]=0;B=aD(m,6)|0;b[B>>0]=b[430291]|0;b[B+1>>0]=b[430292]|0;b[B+2>>0]=b[430293]|0;b[B+3>>0]=b[430294]|0;b[B+4>>0]=b[430295]|0;b[B+5>>0]=b[430296]|0;Zwa(t,m,o)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;o=aD(m,6)|0;b[o>>0]=b[430298]|0;b[o+1>>0]=b[430299]|0;b[o+2>>0]=b[430300]|0;b[o+3>>0]=b[430301]|0;b[o+4>>0]=b[430302]|0;b[o+5>>0]=b[430303]|0;Wwa(t,m,p)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;p=aD(m,7)|0;b[p>>0]=b[430305]|0;b[p+1>>0]=b[430306]|0;b[p+2>>0]=b[430307]|0;b[p+3>>0]=b[430308]|0;b[p+4>>0]=b[430309]|0;b[p+5>>0]=b[430310]|0;b[p+6>>0]=b[430311]|0;Wwa(t,m,q)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;q=aD(m,7)|0;b[q>>0]=b[430313]|0;b[q+1>>0]=b[430314]|0;b[q+2>>0]=b[430315]|0;b[q+3>>0]=b[430316]|0;b[q+4>>0]=b[430317]|0;b[q+5>>0]=b[430318]|0;b[q+6>>0]=b[430319]|0;Wwa(t,m,r)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;q=aD(m,8)|0;p=q;b[p>>0]=99;b[p+1>>0]=108;b[p+2>>0]=97;b[p+3>>0]=115;p=q+4|0;b[p>>0]=115;b[p+1>>0]=102;b[p+2>>0]=105;b[p+3>>0]=120;Wwa(t,m,s)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;e=aD(m,12)|0;d=430321;z=e+12|0;do{b[e>>0]=b[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(z|0));b[v>>0]=(j|0)!=0&1;$wa(t,m,v)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;j=aD(m,7)|0;b[j>>0]=b[430334]|0;b[j+1>>0]=b[430335]|0;b[j+2>>0]=b[430336]|0;b[j+3>>0]=b[430337]|0;b[j+4>>0]=b[430338]|0;b[j+5>>0]=b[430339]|0;b[j+6>>0]=b[430340]|0;b[v>>0]=(i|0)!=0&1;$wa(t,m,v)|0;bD(m);i=f[r>>2]|0;r=i<<1;f[w>>2]=1124007941;j=w+4|0;f[j>>2]=2;s=w+8|0;f[s>>2]=1;p=w+12|0;f[p>>2]=r;q=w+16|0;f[q>>2]=k;o=w+20|0;f[o>>2]=k;B=w+24|0;C=w+28|0;D=w+40|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[D>>2]=s;E=w+48|0;F=w+44|0;f[F>>2]=E;f[w+52>>2]=0;f[E>>2]=0;if((k|0)==0&(i|0)!=0){f[m>>2]=0;f[m+4>>2]=0;e=aD(m,26)|0;d=426262;z=e+26|0;do{b[e>>0]=b[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(z|0));bO(-215,m,426289,431198,500);bD(m);G=f[p>>2]|0;H=f[w>>2]|0;I=f[F>>2]|0;J=f[o>>2]|0}else{G=r;H=1124007941;I=E;J=k}k=G<<2;f[w>>2]=H|16384;f[I>>2]=k;f[I+4>>2]=4;I=J+(Y(f[s>>2]|0,k)|0)|0;f[C>>2]=I;f[B>>2]=I+(0-k)+k;f[v>>2]=1124007936;k=v+4|0;I=v+8|0;B=v+40|0;e=k;z=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(z|0));f[B>>2]=I;C=v+48|0;s=v+44|0;f[s>>2]=C;f[C>>2]=0;f[v+52>>2]=0;J=m+8|0;f[J>>2]=0;f[J+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=v;SP(w,m);J=w+36|0;H=f[J>>2]|0;if(H|0?(G=H+12|0,H=f[G>>2]|0,f[G>>2]=H+-1,(H|0)==1):0)kL(w);f[J>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[j>>2]|0)>0){q=f[D>>2]|0;D=0;do{f[q+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[j>>2]|0))}j=f[F>>2]|0;if((j|0)!=(E|0))UC(j);j=t+16|0;E=f[j>>2]|0;if((E|0)==(f[t+20>>2]|0))v2(t+12|0,v);else{f[E>>2]=f[v>>2];F=E+4|0;f[F>>2]=f[k>>2];D=E+8|0;f[D>>2]=f[I>>2];f[E+12>>2]=f[v+12>>2];f[E+16>>2]=f[v+16>>2];f[E+20>>2]=f[v+20>>2];f[E+24>>2]=f[v+24>>2];f[E+28>>2]=f[v+28>>2];f[E+32>>2]=f[v+32>>2];I=f[v+36>>2]|0;f[E+36>>2]=I;f[E+40>>2]=D;D=E+48|0;q=E+44|0;f[q>>2]=D;f[D>>2]=0;f[E+52>>2]=0;if(I|0){D=I+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[k>>2]|0)<3){D=f[s>>2]|0;I=f[q>>2]|0;f[I>>2]=f[D>>2];f[I+4>>2]=f[D+4>>2]}else{f[F>>2]=0;jL(E,v)}f[j>>2]=(f[j>>2]|0)+56}f[m+40>>2]=0;f[m+44>>2]=0;E=m+40|0;F=m+36|0;e=m;z=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(z|0));f[F>>2]=E;E=m+48|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[E+24>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;E=L5b(16)|0;f[x>>2]=E;f[x+8>>2]=-2147483632;f[x+4>>2]=13;e=E;d=411764;z=e+13|0;do{b[e>>0]=b[d>>0]|0;e=e+1|0;d=d+1|0}while((e|0)<(z|0));b[E+13>>0]=0;_5b(m,x)|0;E=f[A>>2]|0;d=t+36|0;e=f[d>>2]|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;if(e>>>0>4294967279)V5b(y);if(e>>>0<11){b[y+11>>0]=e;if(!e)K=y;else{L=y;M=24}}else{z=e+16&-16;F=L5b(z)|0;f[y>>2]=F;f[y+8>>2]=z|-2147483648;f[y+4>>2]=e;L=F;M=24}if((M|0)==24){Vac(L|0,E|0,e|0)|0;K=L}b[K+e>>0]=0;_5b(m+12|0,y)|0;if((b[y+11>>0]|0)<0)O5b(f[y>>2]|0);Fab(m+36|0,t)|0;cwa(m+48|0,f[h>>2]|0,f[j>>2]|0);j=m+60|0;bD(j);h=f[g>>2]|0;if(!h)N=0;else{y=h+-4|0;f[y>>2]=(f[y>>2]|0)+1;N=f[g>>2]|0}f[j>>2]=N;f[m+64>>2]=f[t+28>>2];N=m+68|0;bD(N);j=f[A>>2]|0;if(!j)O=0;else{g=j+-4|0;f[g>>2]=(f[g>>2]|0)+1;O=f[A>>2]|0}f[N>>2]=O;f[m+72>>2]=f[d>>2];d=a+8|0;O=m+28|0;N=f[O>>2]|0;if((N|0)==(f[m+32>>2]|0))JT(m+24|0,d);else{X5b(N,d);f[O>>2]=(f[O>>2]|0)+12}_5b(d,x)|0;O=f[a>>2]|0;N=O+16|0;A=f[N>>2]|0;if((A|0)==(f[O+20>>2]|0))Gab(O+12|0,m);else{_ta(A,m);f[N>>2]=(f[N>>2]|0)+76}N=a+4|0;f[N>>2]=(f[N>>2]|0)+1;N=a+24|0;A=f[N>>2]|0;if((A|0)==(f[a+28>>2]|0))JT(a+20|0,d);else{X5b(A,d);f[N>>2]=(f[N>>2]|0)+12}if((b[x+11>>0]|0)<0)O5b(f[x>>2]|0);Zta(m);m=v+36|0;x=f[m>>2]|0;if(x|0?(N=x+12|0,x=f[N>>2]|0,f[N>>2]=x+-1,(x|0)==1):0)kL(v);f[m>>2]=0;m=v+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[k>>2]|0)>0){m=f[B>>2]|0;B=0;do{f[m+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[k>>2]|0))}k=f[s>>2]|0;if((k|0)==(C|0)){fua(t);u=l;return}UC(k);fua(t);u=l;return}function Fab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;if((a|0)==(b|0)){u=c;return a|0}i=a+4|0;bua(a,f[i>>2]|0);j=a+8|0;f[j>>2]=0;f[a>>2]=i;f[i>>2]=0;k=f[b>>2]|0;l=b+4|0;if((k|0)==(l|0)){u=c;return a|0}b=i;i=a+4|0;m=k;while(1){k=m+16|0;f[h>>2]=b;f[d>>2]=f[h>>2];n=hua(a,d,e,g,k)|0;if(!(f[n>>2]|0)){o=L5b(32)|0;p=f[k>>2]|0;f[o+16>>2]=p;f[o+20>>2]=f[m+20>>2];if(p|0){k=p+-4|0;f[k>>2]=(f[k>>2]|0)+1}iua(o+24|0,m+24|0);k=f[e>>2]|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=k;f[n>>2]=o;k=f[f[a>>2]>>2]|0;if(!k)q=o;else{f[a>>2]=k;q=f[n>>2]|0}mP(f[i>>2]|0,q);f[j>>2]=(f[j>>2]|0)+1}n=f[m+4>>2]|0;if(!n){k=m+8|0;o=f[k>>2]|0;if((f[o>>2]|0)==(m|0))r=o;else{o=k;do{k=f[o>>2]|0;o=k+8|0;p=f[o>>2]|0}while((f[p>>2]|0)!=(k|0));r=p}}else{o=n;while(1){p=f[o>>2]|0;if(!p)break;else o=p}r=o}if((r|0)==(l|0))break;else m=r}u=c;return a|0}function Gab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/76|0;g=e+1|0;if(g>>>0>56512727)c4b(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/76|0;d=i<<1;j=i>>>0<28256363?(d>>>0<g>>>0?g:d):56512727;do if(j)if(j>>>0>56512727){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{k=L5b(j*76|0)|0;break}else k=0;while(0);d=k+(e*76|0)|0;e=d;g=k+(j*76|0)|0;_ta(d,b);b=d+76|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=k}else{i=k;k=e;e=d;do{i=i+-76|0;_ta(e+-76|0,i);e=k+-76|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;h=n;while(1){n=h;if((n|0)==(g|0))break;b=n+-76|0;Zta(b);h=b}if(!m)return;O5b(m);return}function Hab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=ZVb(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=ZVb(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function Iab(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+32|0;i=c+12|0;j=c+8|0;k=c+4|0;l=c;m=c+16|0;n=c+24|0;f[i>>2]=d;f[j>>2]=e;f[k>>2]=g;f[l>>2]=h;f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=a+4;h=a+12|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;h=a+24|0;bD(h);g=aD(h,16)|0;h=411977;e=g+16|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(e|0));d=a+32|0;bD(d);g=aD(d,11)|0;h=411994;e=g+11|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(e|0));f[m>>2]=0;f[m+4>>2]=0;g=aD(m,11)|0;h=442358;e=g+11|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(e|0));Wwa(a,m,i)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;i=aD(m,3)|0;b[i>>0]=b[418063]|0;b[i+1>>0]=b[418064]|0;b[i+2>>0]=b[418065]|0;Wwa(a,m,j)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;j=aD(m,6)|0;b[j>>0]=b[418067]|0;b[j+1>>0]=b[418068]|0;b[j+2>>0]=b[418069]|0;b[j+3>>0]=b[418070]|0;b[j+4>>0]=b[418071]|0;b[j+5>>0]=b[418072]|0;Wwa(a,m,k)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;g=aD(m,9)|0;h=434144;e=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(e|0));b[n>>0]=0;$wa(a,m,n)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;g=aD(m,10)|0;h=424460;e=g+10|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(e|0));Wwa(a,m,l)|0;bD(m);u=c;return}function Jab(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=ZVb(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=ZVb(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function Kab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0;d=u;u=u+688|0;e=d+672|0;g=d+484|0;h=d+480|0;i=d+476|0;j=d+472|0;k=d;l=d+416|0;m=d+460|0;n=d+392|0;o=d+448|0;p=d+404|0;q=d+368|0;r=d+380|0;s=d+356|0;t=d+344|0;v=d+328|0;w=d+272|0;x=d+216|0;y=d+160|0;z=d+104|0;A=d+32|0;B=d+88|0;C=d+8|0;D=d+20|0;E=g+108|0;F=g+8|0;f[g>>2]=18252;f[E>>2]=18272;f[g+4>>2]=0;RXb(g+108|0,F);f[g+180>>2]=0;f[g+184>>2]=-1;f[g>>2]=106336;f[E>>2]=106356;Tza(F);G=g+72|0;if((f[G>>2]|0)==0?(H=YUb(a,443948)|0,f[G>>2]=H,(H|0)!=0):0){f[g+96>>2]=12;QXb(g+(f[(f[g>>2]|0)+-12>>2]|0)|0,0)}else{H=g+(f[(f[g>>2]|0)+-12>>2]|0)|0;QXb(H,f[H+16>>2]|4)}if(!(f[G>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;I=aD(e,15)|0;J=412006;K=I+15|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));bO(-215,e,412022,411193,516);bD(e)}dYb(g,h,4)|0;dYb(g,i,4)|0;dYb(g,j,4)|0;if((((f[h>>2]|0)*10|0)+(f[i>>2]|0)|0)>1)dYb(g,k,8)|0;else{f[e>>2]=0;dYb(g,e,4)|0;j=f[e>>2]|0;G=k;f[G>>2]=j;f[G+4>>2]=((j|0)<0)<<31>>31}if((f[h>>2]|0)>1e3|(f[i>>2]|0)>1e3){f[e>>2]=0;f[e+4>>2]=0;I=aD(e,67)|0;J=412049;K=I+67|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));bO(-213,e,412022,411193,534);bD(e)}i=f[c+8>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;h=m+11|0;b[h>>0]=4;f[m>>2]=1635017060;b[m+4>>0]=0;f[l>>2]=c;f[l+4>>2]=0;j=l+8|0;X5b(j,m);f[l+20>>2]=0;G=l+24|0;f[G>>2]=0;f[l+28>>2]=0;if((b[h>>0]|0)<0)O5b(f[m>>2]|0);m=f[c+36>>2]|0;h=c+40|0;if((m|0)!=(h|0)){k=e+11|0;H=e+4|0;a=n+11|0;L=n+4|0;M=o+11|0;N=o+4|0;O=p+11|0;P=p+7|0;Q=r+11|0;R=r+10|0;S=s+11|0;T=s+6|0;U=t+8|0;V=t+4|0;W=t+11|0;X=v+4|0;Z=v+8|0;_=v+12|0;$=w+4|0;aa=w+8|0;ba=w+40|0;ca=w+48|0;da=w+44|0;ea=w+52|0;fa=e+4|0;ga=x+4|0;ha=x+8|0;ia=x+40|0;ja=x+48|0;ka=x+44|0;la=x+52|0;ma=e+4|0;na=y+4|0;oa=y+8|0;pa=y+40|0;qa=y+48|0;ra=y+44|0;sa=y+52|0;ta=z+4|0;ua=z+8|0;va=z+40|0;wa=z+48|0;xa=z+44|0;ya=z+52|0;za=A+4|0;Aa=A+8|0;Ba=A+40|0;Ca=A+48|0;Da=A+44|0;Ea=A+52|0;Fa=A+16|0;Ga=z+16|0;Ha=x+16|0;Ia=y+16|0;Ja=w+16|0;Ka=e+4|0;La=e+8|0;Ma=e+8|0;Na=C+4|0;Oa=C+8|0;Pa=C+8|0;Qa=D+4|0;Ra=A+12|0;Sa=A+20|0;Ta=A+24|0;Ua=A+28|0;Va=A+32|0;Wa=A+36|0;Xa=z+12|0;Ya=z+20|0;Za=z+24|0;_a=z+28|0;$a=z+32|0;ab=z+36|0;bb=y+12|0;cb=y+20|0;db=y+24|0;eb=y+28|0;fb=y+32|0;gb=y+36|0;hb=q+11|0;ib=q+4|0;jb=x+36|0;kb=w+36|0;lb=B+4|0;mb=e+4|0;nb=e+4|0;ob=c+24|0;c=p+8|0;pb=-1;qb=-1;rb=i;i=m;while(1){qb=qb+1|0;m=pb+1|0;sb=i+20|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[k>>0]=4;f[e>>2]=1701869940;b[H>>0]=0;X5b(n,sab(sb,e)|0);if((b[k>>0]|0)<0)O5b(f[e>>2]|0);tb=b[a>>0]|0;if(((tb<<24>>24<0?f[L>>2]|0:tb&255)|0)==13?(u6b(n,0,-1,411357,13)|0)==0:0){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;b[M>>0]=4;f[o>>2]=1702521203;b[N>>0]=0;tb=uab(sb,o,-1)|0;if((b[M>>0]|0)<0)O5b(f[o>>2]|0);f[c>>2]=0;b[O>>0]=7;b[p>>0]=b[411371]|0;b[p+1>>0]=b[411372]|0;b[p+2>>0]=b[411373]|0;b[p+3>>0]=b[411374]|0;b[p+4>>0]=b[411375]|0;b[p+5>>0]=b[411376]|0;b[p+6>>0]=b[411377]|0;b[P>>0]=0;ub=uab(sb,p,-1)|0;if((b[O>>0]|0)<0)O5b(f[p>>2]|0);b[Q>>0]=10;I=r;J=411379;K=I+10|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));b[R>>0]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;b[S>>0]=6;b[s>>0]=b[411390]|0;b[s+1>>0]=b[411391]|0;b[s+2>>0]=b[411392]|0;b[s+3>>0]=b[411393]|0;b[s+4>>0]=b[411394]|0;b[s+5>>0]=b[411395]|0;b[T>>0]=0;vab(q,sb,r,s);if((b[S>>0]|0)<0)O5b(f[s>>2]|0);if((b[Q>>0]|0)<0)O5b(f[r>>2]|0);f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;vb=L5b(16)|0;f[t>>2]=vb;f[U>>2]=-2147483632;f[V>>2]=15;I=vb;J=411397;K=I+15|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));b[vb+15>>0]=0;wb=(uab(sb,t,0)|0)==1;if((b[W>>0]|0)<0)O5b(f[t>>2]|0);if(!((tb|0)>0&(ub|0)>0)){f[e>>2]=0;f[nb>>2]=0;I=aD(e,30)|0;J=411507;K=I+30|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));bO(-215,e,412022,411193,556);bD(e)}if((rb|0)<=0){f[e>>2]=0;f[mb>>2]=0;I=aD(e,20)|0;J=411538;K=I+20|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));bO(-215,e,412022,411193,557);bD(e)}f[v>>2]=ub;f[X>>2]=rb;f[Z>>2]=tb;f[_>>2]=tb;f[w>>2]=1124007936;I=$;K=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(K|0));f[ba>>2]=aa;f[da>>2]=ca;f[ca>>2]=0;f[ea>>2]=0;hL(w,4,v,5);if(!(f[w>>2]&16384)){f[e>>2]=0;f[fa>>2]=0;I=aD(e,26)|0;J=412117;K=I+26|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));bO(-215,e,412022,411193,563);bD(e)}f[x>>2]=1124007936;I=ga;K=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(K|0));f[ia>>2]=ha;f[ka>>2]=ja;f[ja>>2]=0;f[la>>2]=0;f[e>>2]=1;f[ma>>2]=ub;hL(x,2,e,5);f[y>>2]=1124007936;I=na;K=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(K|0));f[pa>>2]=oa;f[ra>>2]=qa;f[qa>>2]=0;f[sa>>2]=0;f[e>>2]=1;f[ma>>2]=ub;hL(y,2,e,5);f[z>>2]=1124007936;I=ta;K=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(K|0));f[va>>2]=ua;f[xa>>2]=wa;f[wa>>2]=0;f[ya>>2]=0;f[e>>2]=1;f[ma>>2]=ub;hL(z,2,e,5);f[A>>2]=1124007936;I=za;K=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(K|0));f[Ba>>2]=Aa;f[Da>>2]=Ca;f[Ca>>2]=0;f[Ea>>2]=0;f[e>>2]=1;f[ma>>2]=ub;hL(A,2,e,5);sb=ub<<2;dYb(g,f[Fa>>2]|0,sb)|0;if(wb){dYb(g,f[Ga>>2]|0,sb)|0;dYb(g,f[Ha>>2]|0,sb)|0;dYb(g,f[Ia>>2]|0,sb)|0;xb=wb}else xb=0;dYb(g,f[Ja>>2]|0,Y(Y(Y(rb<<2,tb)|0,tb)|0,ub)|0)|0;f[e>>2]=0;f[Ka>>2]=0;f[La>>2]=0;v2(e,w);do if(!xb){sb=f[Ka>>2]|0;if((sb|0)==(f[Ma>>2]|0)){v2(e,A);break}f[sb>>2]=f[A>>2];vb=sb+4|0;f[vb>>2]=f[za>>2];yb=sb+8|0;f[yb>>2]=f[Aa>>2];f[sb+12>>2]=f[Ra>>2];f[sb+16>>2]=f[Fa>>2];f[sb+20>>2]=f[Sa>>2];f[sb+24>>2]=f[Ta>>2];f[sb+28>>2]=f[Ua>>2];f[sb+32>>2]=f[Va>>2];zb=f[Wa>>2]|0;f[sb+36>>2]=zb;f[sb+40>>2]=yb;yb=sb+48|0;Ab=sb+44|0;f[Ab>>2]=yb;f[yb>>2]=0;f[sb+52>>2]=0;if(zb|0){yb=zb+12|0;f[yb>>2]=(f[yb>>2]|0)+1}if((f[za>>2]|0)<3){yb=f[Da>>2]|0;zb=f[Ab>>2]|0;f[zb>>2]=f[yb>>2];f[zb+4>>2]=f[yb+4>>2]}else{f[vb>>2]=0;jL(sb,A)}f[Ka>>2]=(f[Ka>>2]|0)+56}while(0);aua(B,e);ub=(f[(f[l>>2]|0)+12>>2]|0)+(m*76|0)+48|0;if((ub|0)!=(B|0))cwa(ub,f[B>>2]|0,f[lb>>2]|0);et(B);if(wb){ub=pb+2|0;f[C>>2]=0;f[Na>>2]=0;f[Oa>>2]=0;v2(C,x);tb=f[Na>>2]|0;if((tb|0)==(f[Pa>>2]|0)){v2(C,y);Bb=f[Na>>2]|0}else{f[tb>>2]=f[y>>2];sb=tb+4|0;f[sb>>2]=f[na>>2];vb=tb+8|0;f[vb>>2]=f[oa>>2];f[tb+12>>2]=f[bb>>2];f[tb+16>>2]=f[Ia>>2];f[tb+20>>2]=f[cb>>2];f[tb+24>>2]=f[db>>2];f[tb+28>>2]=f[eb>>2];f[tb+32>>2]=f[fb>>2];yb=f[gb>>2]|0;f[tb+36>>2]=yb;f[tb+40>>2]=vb;vb=tb+48|0;zb=tb+44|0;f[zb>>2]=vb;f[vb>>2]=0;f[tb+52>>2]=0;if(yb|0){vb=yb+12|0;f[vb>>2]=(f[vb>>2]|0)+1}if((f[na>>2]|0)<3){vb=f[ra>>2]|0;yb=f[zb>>2]|0;f[yb>>2]=f[vb>>2];f[yb+4>>2]=f[vb+4>>2]}else{f[sb>>2]=0;jL(tb,y)}tb=(f[Na>>2]|0)+56|0;f[Na>>2]=tb;Bb=tb}if((Bb|0)==(f[Pa>>2]|0)){v2(C,z);Cb=f[Na>>2]|0}else{f[Bb>>2]=f[z>>2];tb=Bb+4|0;f[tb>>2]=f[ta>>2];sb=Bb+8|0;f[sb>>2]=f[ua>>2];f[Bb+12>>2]=f[Xa>>2];f[Bb+16>>2]=f[Ga>>2];f[Bb+20>>2]=f[Ya>>2];f[Bb+24>>2]=f[Za>>2];f[Bb+28>>2]=f[_a>>2];f[Bb+32>>2]=f[$a>>2];vb=f[ab>>2]|0;f[Bb+36>>2]=vb;f[Bb+40>>2]=sb;sb=Bb+48|0;yb=Bb+44|0;f[yb>>2]=sb;f[sb>>2]=0;f[Bb+52>>2]=0;if(vb|0){sb=vb+12|0;f[sb>>2]=(f[sb>>2]|0)+1}if((f[ta>>2]|0)<3){sb=f[xa>>2]|0;vb=f[yb>>2]|0;f[vb>>2]=f[sb>>2];f[vb+4>>2]=f[sb+4>>2]}else{f[tb>>2]=0;jL(Bb,z)}tb=(f[Na>>2]|0)+56|0;f[Na>>2]=tb;Cb=tb}if((Cb|0)==(f[Pa>>2]|0))v2(C,A);else{f[Cb>>2]=f[A>>2];tb=Cb+4|0;f[tb>>2]=f[za>>2];sb=Cb+8|0;f[sb>>2]=f[Aa>>2];f[Cb+12>>2]=f[Ra>>2];f[Cb+16>>2]=f[Fa>>2];f[Cb+20>>2]=f[Sa>>2];f[Cb+24>>2]=f[Ta>>2];f[Cb+28>>2]=f[Ua>>2];f[Cb+32>>2]=f[Va>>2];vb=f[Wa>>2]|0;f[Cb+36>>2]=vb;f[Cb+40>>2]=sb;sb=Cb+48|0;yb=Cb+44|0;f[yb>>2]=sb;f[sb>>2]=0;f[Cb+52>>2]=0;if(vb|0){sb=vb+12|0;f[sb>>2]=(f[sb>>2]|0)+1}if((f[za>>2]|0)<3){sb=f[Da>>2]|0;vb=f[yb>>2]|0;f[vb>>2]=f[sb>>2];f[vb+4>>2]=f[sb+4>>2]}else{f[tb>>2]=0;jL(Cb,A)}f[Na>>2]=(f[Na>>2]|0)+56}aua(D,C);tb=(f[(f[l>>2]|0)+12>>2]|0)+(ub*76|0)+48|0;if((tb|0)!=(D|0))cwa(tb,f[D>>2]|0,f[Qa>>2]|0);et(D);et(C);Db=ub}else Db=m;ub=b[hb>>0]|0;if(((ub<<24>>24<0?f[ib>>2]|0:ub&255)|0)==5)Eb=((u6b(q,0,-1,411413,5)|0)==0&1)+Db|0;else Eb=Db;et(e);ub=f[Wa>>2]|0;do if(ub|0){tb=ub+12|0;sb=f[tb>>2]|0;f[tb>>2]=sb+-1;if((sb|0)!=1)break;kL(A)}while(0);f[Wa>>2]=0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=0;f[Fa+12>>2]=0;if((f[za>>2]|0)>0){ub=f[Ba>>2]|0;wb=0;do{f[ub+(wb<<2)>>2]=0;wb=wb+1|0}while((wb|0)<(f[za>>2]|0))}wb=f[Da>>2]|0;if((wb|0)!=(Ca|0))UC(wb);wb=f[ab>>2]|0;do if(wb|0){ub=wb+12|0;sb=f[ub>>2]|0;f[ub>>2]=sb+-1;if((sb|0)!=1)break;kL(z)}while(0);f[ab>>2]=0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[ta>>2]|0)>0){wb=f[va>>2]|0;sb=0;do{f[wb+(sb<<2)>>2]=0;sb=sb+1|0}while((sb|0)<(f[ta>>2]|0))}sb=f[xa>>2]|0;if((sb|0)!=(wa|0))UC(sb);sb=f[gb>>2]|0;do if(sb|0){wb=sb+12|0;ub=f[wb>>2]|0;f[wb>>2]=ub+-1;if((ub|0)!=1)break;kL(y)}while(0);f[gb>>2]=0;f[Ia>>2]=0;f[Ia+4>>2]=0;f[Ia+8>>2]=0;f[Ia+12>>2]=0;if((f[na>>2]|0)>0){sb=f[pa>>2]|0;ub=0;do{f[sb+(ub<<2)>>2]=0;ub=ub+1|0}while((ub|0)<(f[na>>2]|0))}ub=f[ra>>2]|0;if((ub|0)!=(qa|0))UC(ub);ub=f[jb>>2]|0;do if(ub|0){sb=ub+12|0;wb=f[sb>>2]|0;f[sb>>2]=wb+-1;if((wb|0)!=1)break;kL(x)}while(0);f[jb>>2]=0;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=0;f[Ha+12>>2]=0;if((f[ga>>2]|0)>0){ub=f[ia>>2]|0;wb=0;do{f[ub+(wb<<2)>>2]=0;wb=wb+1|0}while((wb|0)<(f[ga>>2]|0))}wb=f[ka>>2]|0;if((wb|0)!=(ja|0))UC(wb);wb=f[kb>>2]|0;do if(wb|0){ub=wb+12|0;sb=f[ub>>2]|0;f[ub>>2]=sb+-1;if((sb|0)!=1)break;kL(w)}while(0);f[kb>>2]=0;f[Ja>>2]=0;f[Ja+4>>2]=0;f[Ja+8>>2]=0;f[Ja+12>>2]=0;if((f[$>>2]|0)>0){wb=f[ba>>2]|0;sb=0;do{f[wb+(sb<<2)>>2]=0;sb=sb+1|0}while((sb|0)<(f[$>>2]|0))}sb=f[da>>2]|0;if((sb|0)!=(ca|0))UC(sb);if((b[hb>>0]|0)<0)O5b(f[q>>2]|0);Fb=Eb}else Fb=m;rb=f[(f[ob>>2]|0)+(qb<<2)>>2]|0;if((b[a>>0]|0)<0)O5b(f[n>>2]|0);sb=f[i+4>>2]|0;if(!sb){wb=i+8|0;ub=f[wb>>2]|0;if((f[ub>>2]|0)==(i|0))Gb=ub;else{ub=wb;do{wb=f[ub>>2]|0;ub=wb+8|0;tb=f[ub>>2]|0}while((f[tb>>2]|0)!=(wb|0));Gb=tb}}else{ub=sb;while(1){m=f[ub>>2]|0;if(!m)break;else ub=m}Gb=ub}if((Gb|0)==(h|0))break;else{pb=Fb;i=Gb}}}Gb=l+20|0;l=f[Gb>>2]|0;if(l|0){i=f[G>>2]|0;if((i|0)==(l|0))Hb=l;else{Fb=i;while(1){i=Fb+-12|0;f[G>>2]=i;if((b[i+11>>0]|0)<0){O5b(f[i>>2]|0);Ib=f[G>>2]|0}else Ib=i;if((Ib|0)==(l|0))break;else Fb=Ib}Hb=f[Gb>>2]|0}O5b(Hb)}if((b[j+11>>0]|0)>=0){f[g>>2]=106336;f[E>>2]=106356;Uza(F);rXb(g,106368);AWb(E);u=d;return 1}O5b(f[j>>2]|0);f[g>>2]=106336;f[E>>2]=106356;Uza(F);rXb(g,106368);AWb(E);u=d;return 1}function Lab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+32|0;e=d+24|0;g=d+12|0;h=d;if(pab(a,c)|0){u=d;return};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;c=kUb(a)|0;if(c>>>0>4294967279)V5b(h);if(c>>>0<11){b[h+11>>0]=c;if(!c)i=h;else{j=h;k=7}}else{l=c+16&-16;m=L5b(l)|0;f[h>>2]=m;f[h+8>>2]=l|-2147483648;f[h+4>>2]=c;j=m;k=7}if((k|0)==7){Vac(j|0,a|0,c|0)|0;i=j}b[i+c>>0]=0;dua(g,412144,h);f[e>>2]=0;f[e+4>>2]=0;c=g+11|0;i=b[c>>0]|0;j=i<<24>>24<0?f[g+4>>2]|0:i&255;if(j|0){i=aD(e,j)|0;Vac(i|0,((b[c>>0]|0)<0?f[g>>2]|0:g)|0,j|0)|0}bO(-212,e,412180,411193,612);bD(e);if((b[c>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);u=d;return}function Mab(a,b){a=a|0;b=b|0;Kab(a,b)|0;return}function Nab(a,b){a=a|0;b=b|0;var c=0;c=L5b(60)|0;Oab(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=118928;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Oab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0.0,F=0,G=0.0,H=0,I=0,K=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;Jwa(a);f[a>>2]=118948;Kwa(a,c);i=a+36|0;f[i>>2]=-1;f[g>>2]=0;f[g+4>>2]=0;j=aD(g,11)|0;k=412286;l=j+11|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));f[h>>2]=0;m=h+4|0;f[m>>2]=0;j=aD(h,15)|0;k=412298;l=j+15|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));o=c+4|0;c=f[o>>2]|0;do if(c){p=f[g>>2]|0;q=(p|0)==0?1124530:p;r=o;s=c;a:while(1){t=s;while(1){v=f[t+16>>2]|0;if((v|0)==(p|0))break;if((gTb((v|0)==0?1124530:v,q)|0)>=0)break;v=f[t+4>>2]|0;if(!v){w=r;break a}else t=v}s=f[t>>2]|0;if(!s){w=t;break}else r=t}if((w|0)!=(o|0)){r=f[w+16>>2]|0;if((p|0)!=(r|0)?(gTb(q,(r|0)==0?1124530:r)|0)<=-1:0){x=12;break}Hwa(e,w+24|0,-1)}else x=12}else x=12;while(0);if((x|0)==12?(w=f[h>>2]|0,f[e>>2]=w,f[e+4>>2]=f[m>>2],w|0):0){m=w+-4|0;f[m>>2]=(f[m>>2]|0)+1}bD(h);bD(g);m=f[e>>2]|0;do if((m|0)!=412298?(w=(m|0)==0?1124530:m,(gTb(w,412298)|0)!=0):0){if((m|0)!=412314?gTb(w,412314)|0:0){f[h>>2]=0;w=h+4|0;f[w>>2]=0;c=e+4|0;aD(h,(f[c>>2]|0)+21|0)|0;r=f[h>>2]|0;j=r;k=412329;l=j+21|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));q=f[c>>2]|0;if(q|0)Vac(r+21|0,f[e>>2]|0,q|0)|0;f[g>>2]=0;f[g+4>>2]=0;aD(g,(f[w>>2]|0)+1|0)|0;q=f[w>>2]|0;if(!q)y=0;else{Vac(f[g>>2]|0,f[h>>2]|0,q|0)|0;y=f[w>>2]|0}b[(f[g>>2]|0)+y>>0]=34;bO(-5,g,412351,412364,74);bD(g);bD(h);break}f[i>>2]=1}else x=16;while(0);if((x|0)==16)f[i>>2]=0;f[g>>2]=0;f[g+4>>2]=0;j=aD(g,10)|0;k=412441;l=j+10|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));i=f[o>>2]|0;do if(i){x=f[g>>2]|0;h=(x|0)==0?1124530:x;y=o;m=i;b:while(1){q=m;while(1){p=f[q+16>>2]|0;if((p|0)==(x|0))break;if((gTb((p|0)==0?1124530:p,h)|0)>=0)break;p=f[q+4>>2]|0;if(!p){z=y;break b}else q=p}m=f[q>>2]|0;if(!m){z=q;break}else y=q}if((z|0)!=(o|0)){y=f[z+16>>2]|0;if((x|0)!=(y|0)?(gTb(h,(y|0)==0?1124530:y)|0)<=-1:0){A=5;break}y=Gwa(z+24|0,-1)|0;A=y}else A=5}else A=5;while(0);z=a+40|0;f[z>>2]=A;bD(g);A=f[z>>2]|0;if((A|0)<1|((A|0)%2|0|0)!=1){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,58)|0;k=412452;l=j+58|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-5,g,412351,412364,78);bD(g)}f[g>>2]=0;f[g+4>>2]=0;A=aD(g,5)|0;b[A>>0]=b[412511]|0;b[A+1>>0]=b[412512]|0;b[A+2>>0]=b[412513]|0;b[A+3>>0]=b[412514]|0;b[A+4>>0]=b[412515]|0;A=f[o>>2]|0;do if(A){z=f[g>>2]|0;i=(z|0)==0?1124530:z;y=o;m=A;c:while(1){w=m;while(1){r=f[w+16>>2]|0;if((r|0)==(z|0))break;if((gTb((r|0)==0?1124530:r,i)|0)>=0)break;r=f[w+4>>2]|0;if(!r){B=y;break c}else w=r}m=f[w>>2]|0;if(!m){B=w;break}else y=w}if((B|0)!=(o|0)){y=f[B+16>>2]|0;if((z|0)!=(y|0)?(gTb(i,(y|0)==0?1124530:y)|0)<=-1:0){C=1.0;break}C=+Hya(B+24|0,-1)}else C=1.0}else C=1.0;while(0);n[a+44>>2]=C;bD(g);f[g>>2]=0;f[g+4>>2]=0;B=aD(g,4)|0;b[B>>0]=98;b[B+1>>0]=101;b[B+2>>0]=116;b[B+3>>0]=97;B=f[o>>2]|0;do if(B){A=f[g>>2]|0;y=(A|0)==0?1124530:A;m=o;h=B;d:while(1){x=h;while(1){q=f[x+16>>2]|0;if((q|0)==(A|0))break;if((gTb((q|0)==0?1124530:q,y)|0)>=0)break;q=f[x+4>>2]|0;if(!q){D=m;break d}else x=q}h=f[x>>2]|0;if(!h){D=x;break}else m=x}if((D|0)!=(o|0)){m=f[D+16>>2]|0;if((A|0)!=(m|0)?(gTb(y,(m|0)==0?1124530:m)|0)<=-1:0){E=.75;break}E=+Hya(D+24|0,-1)}else E=.75}else E=.75;while(0);n[a+48>>2]=E;bD(g);f[g>>2]=0;f[g+4>>2]=0;D=aD(g,4)|0;b[D>>0]=98;b[D+1>>0]=105;b[D+2>>0]=97;b[D+3>>0]=115;D=f[o>>2]|0;do if(D){B=f[g>>2]|0;m=(B|0)==0?1124530:B;h=o;i=D;e:while(1){z=i;while(1){w=f[z+16>>2]|0;if((w|0)==(B|0))break;if((gTb((w|0)==0?1124530:w,m)|0)>=0)break;w=f[z+4>>2]|0;if(!w){F=h;break e}else z=w}i=f[z>>2]|0;if(!i){F=z;break}else h=z}if((F|0)!=(o|0)){h=f[F+16>>2]|0;if((B|0)!=(h|0)?(gTb(m,(h|0)==0?1124530:h)|0)<=-1:0){G=1.0;break}G=+Hya(F+24|0,-1)}else G=1.0}else G=1.0;while(0);n[a+52>>2]=G;bD(g);f[g>>2]=0;f[g+4>>2]=0;j=aD(g,12)|0;k=412517;l=j+12|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));k=f[o>>2]|0;if(!k){H=1;I=a+56|0;b[I>>0]=H;bD(g);bD(e);u=d;return}j=f[g>>2]|0;l=(j|0)==0?1124530:j;F=o;D=k;f:while(1){k=D;while(1){h=f[k+16>>2]|0;if((h|0)==(j|0))break;if((gTb((h|0)==0?1124530:h,l)|0)>=0)break;h=f[k+4>>2]|0;if(!h){K=F;break f}else k=h}D=f[k>>2]|0;if(!D){K=k;break}else F=k}if((K|0)==(o|0)){H=1;I=a+56|0;b[I>>0]=H;bD(g);bD(e);u=d;return}o=f[K+16>>2]|0;if((j|0)!=(o|0)?(gTb(l,(o|0)==0?1124530:o)|0)<=-1:0){H=1;I=a+56|0;b[I>>0]=H;bD(g);bD(e);u=d;return}o=Gwa(K+24|0,-1)|0;H=((o|0)!=0|(J|0)!=0)&1;I=a+56|0;b[I>>0]=H;bD(g);bD(e);u=d;return}function Pab(a){a=a|0;O5b(a);return}function Qab(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Rab(a){a=a|0;lua(a);O5b(a);return}function Sab(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(g,119072);i=c+4|0;j=f[i>>2]|0;k=f[c>>2]|0;if((j-k>>2|0)==(((f[d+4>>2]|0)-(f[d>>2]|0)|0)/56|0|0)){l=k;m=j}else{f[h>>2]=0;f[h+4>>2]=0;n=aD(h,31)|0;o=414902;p=n+31|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,h,443123,412364,154);bD(h);l=f[c>>2]|0;m=f[i>>2]|0}a:do if((m|0)!=(l|0)){j=a+36|0;k=h+4|0;q=h+4|0;r=0;s=l;while(1){t=s;if((f[(f[t+(r<<2)>>2]|0)+4>>2]|0)==4)v=t;else{f[h>>2]=0;f[q>>2]=0;n=aD(h,20)|0;o=412678;p=n+20|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,h,443123,412364,158);bD(h);v=f[c>>2]|0}t=f[v+(r<<2)>>2]|0;w=(f[d>>2]|0)+(r*56|0)|0;switch(f[j>>2]|0){case 0:{Yab(a,t,w);break}case 1:{Zab(a,t,w);break}default:{f[h>>2]=0;f[k>>2]=0;n=aD(h,31)|0;o=412699;p=n+31|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-213,h,443123,412364,172);bD(h)}}r=r+1|0;s=f[c>>2]|0;if(r>>>0>=(f[i>>2]|0)-s>>2>>>0)break a}}while(0);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Tab(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g+8|0;i=g;dQ(h,119040);j=EM(c,-1)|0;if((j|0)!=(EM(d,-1)|0)){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,41)|0;k=412530;l=j+41|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,i,443123,412364,140);bD(i)}Lwa(a,c,d,e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function Uab(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function Vab(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Wab(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function Xab(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=u;u=u+16|0;e=d;g=c+4|0;h=f[g>>2]|0;i=f[c>>2]|0;if((h|0)==(i|0)){f[e>>2]=0;f[e+4>>2]=0;j=aD(e,17)|0;k=441774;l=j+17|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,e,427670,412364,376);bD(e);m=f[c>>2]|0;n=f[g>>2]|0}else{m=i;n=h}if((n|0)==(m|0)){o=0;p=(o|0)<0;q=p<<31>>31;J=q;u=d;return o|0}n=a+36|0;h=a+40|0;a=e+4|0;i=e+4|0;r=e+4|0;s=e+4|0;t=0;v=0;w=m;while(1){m=w;x=m+(v*12|0)|0;if(!(f[n>>2]|0)){y=f[x>>2]|0;z=f[y+4>>2]|0;A=((f[h>>2]|0)+-1|0)/2|0;B=f[y>>2]|0;C=((z|0)<(A|0)?z:A)<<1;D=f[m+(v*12|0)+4>>2]|0;E=D-y|0;F=E>>2;do if((y|0)!=(D|0)){if((E|0)<8){f[e>>2]=0;f[r>>2]=0;j=aD(e,70)|0;k=442586;l=j+70|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,e,442657,442663,160);bD(e);G=1;break}if((E|0)==8)G=1;else{H=f[x>>2]|0;I=2;K=1;while(1){L=Y(f[H+(I<<2)>>2]|0,K)|0;I=I+1|0;if((I|0)==(F|0)){G=L;break}else K=L}}}else G=0;while(0);F=Y(C,G)|0;E=z<<2;D=f[c>>2]|0;y=D+(v*12|0)|0;K=f[D+(v*12|0)+4>>2]|0;D=f[y>>2]|0;I=K-D|0;H=I>>2;do if((D|0)!=(K|0)){if((I|0)<8){f[e>>2]=0;f[i>>2]=0;j=aD(e,70)|0;k=442586;l=j+70|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,e,442657,442663,160);bD(e);M=1;break}if((I|0)==8)M=1;else{L=f[y>>2]|0;N=2;O=1;while(1){P=Y(f[L+(N<<2)>>2]|0,O)|0;N=N+1|0;if((N|0)==(H|0)){M=P;break}else O=P}}}else M=0;while(0);H=(Y((Y(E,M)|0)+F|0,B)|0)+t|0;if((A|0)<(z|0)){y=f[h>>2]|0;I=(z-y<<1)+y|0;y=f[c>>2]|0;K=y+(v*12|0)|0;D=f[y+(v*12|0)+4>>2]|0;y=f[K>>2]|0;C=D-y|0;O=C>>2;do if((y|0)!=(D|0)){if((C|0)<8){f[e>>2]=0;f[a>>2]=0;j=aD(e,70)|0;k=442586;l=j+70|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,e,442657,442663,160);bD(e);Q=1;break}if((C|0)==8)Q=1;else{N=f[K>>2]|0;L=2;P=1;while(1){R=Y(f[N+(L<<2)>>2]|0,P)|0;L=L+1|0;if((L|0)==(O|0)){Q=R;break}else P=R}}}else Q=0;while(0);S=(Y(Q,I)|0)+H|0}else S=H}else{O=f[m+(v*12|0)+4>>2]|0;K=f[x>>2]|0;C=O-K|0;D=C>>2;do if((K|0)!=(O|0)){if((C|0)<0){f[e>>2]=0;f[s>>2]=0;j=aD(e,70)|0;k=442586;l=j+70|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,e,442657,442663,160);bD(e);T=1;break}if(!C)T=1;else{y=f[x>>2]|0;z=0;A=1;while(1){B=Y(f[y+(z<<2)>>2]|0,A)|0;z=z+1|0;if((z|0)==(D|0)){T=B;break}else A=B}}}else T=0;while(0);D=f[h>>2]|0;S=(Y((Y(D<<1,D)|0)+2|0,T)|0)+t|0}v=v+1|0;w=f[c>>2]|0;if(v>>>0>=(((f[g>>2]|0)-w|0)/12|0)>>>0){o=S;break}else t=S}p=(o|0)<0;q=p<<31>>31;J=q;u=d;return o|0}function Yab(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0.0;e=u;u=u+64|0;g=e+8|0;h=e;i=f[c+40>>2]|0;j=f[i>>2]|0;k=f[i+4>>2]|0;l=f[a+40>>2]|0;m=(b[a+56>>0]|0)==0?1.0:+(l|0);o=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;i=SQ()|0;p=(i|0)>1?i:1;i=f[c+16>>2]|0;c=f[d+16>>2]|0;q=+n[a+44>>2]/m;d=f[a+52>>2]|0;m=-+n[a+48>>2];f[g>>2]=119112;f[g+4>>2]=i;f[g+8>>2]=c;f[g+28>>2]=k;f[g+32>>2]=(l+-1|0)/2|0;n[g+12>>2]=q;f[g+16>>2]=d;n[g+20>>2]=m;f[g+24>>2]=o;f[g+36>>2]=j;f[g+40>>2]=p;f[h>>2]=0;f[h+4>>2]=p;RQ(h,g,+(p|0));u=e;return}function Zab(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0;e=u;u=u+272|0;g=e+216|0;h=e+160|0;i=e+104|0;j=e+48|0;k=e+32|0;l=e+16|0;m=e;o=f[c+40>>2]|0;p=f[o>>2]|0;q=f[o+4>>2]|0;if(!(b[a+56>>0]|0))r=1;else{o=f[a+40>>2]|0;r=Y(o,o)|0}f[g>>2]=f[c>>2];o=g+4|0;s=c+4|0;t=f[s>>2]|0;f[o>>2]=t;v=g+8|0;f[v>>2]=f[c+8>>2];f[g+12>>2]=f[c+12>>2];w=g+16|0;f[w>>2]=f[c+16>>2];f[g+20>>2]=f[c+20>>2];f[g+24>>2]=f[c+24>>2];f[g+28>>2]=f[c+28>>2];f[g+32>>2]=f[c+32>>2];x=g+36|0;y=f[c+36>>2]|0;f[x>>2]=y;z=g+40|0;f[z>>2]=v;v=g+48|0;A=g+44|0;f[A>>2]=v;f[v>>2]=0;f[g+52>>2]=0;if(!y)B=t;else{t=y+12|0;f[t>>2]=(f[t>>2]|0)+1;B=f[s>>2]|0}if((B|0)<3){B=f[c+44>>2]|0;s=f[A>>2]|0;f[s>>2]=f[B>>2];f[s+4>>2]=f[B+4>>2]}else{f[o>>2]=0;jL(g,c)}f[h>>2]=f[d>>2];c=h+4|0;B=d+4|0;s=f[B>>2]|0;f[c>>2]=s;t=h+8|0;f[t>>2]=f[d+8>>2];f[h+12>>2]=f[d+12>>2];y=h+16|0;f[y>>2]=f[d+16>>2];f[h+20>>2]=f[d+20>>2];f[h+24>>2]=f[d+24>>2];f[h+28>>2]=f[d+28>>2];f[h+32>>2]=f[d+32>>2];C=h+36|0;D=f[d+36>>2]|0;f[C>>2]=D;E=h+40|0;f[E>>2]=t;t=h+48|0;F=h+44|0;f[F>>2]=t;f[t>>2]=0;f[h+52>>2]=0;if(!D)G=s;else{s=D+12|0;f[s>>2]=(f[s>>2]|0)+1;G=f[B>>2]|0}if((G|0)<3){G=f[d+44>>2]|0;B=f[F>>2]|0;f[B>>2]=f[G>>2];f[B+4>>2]=f[G+4>>2]}else{f[c>>2]=0;jL(h,d)}if((p|0)>0){d=(q|0)>0;G=k+8|0;B=k+4|0;s=a+44|0;H=+(r|0);r=a+52|0;D=k+8|0;I=k+12|0;J=k+4|0;K=a+48|0;L=l+8|0;M=l+4|0;N=k+8|0;O=k+12|0;P=k+4|0;Q=l+8|0;R=l+12|0;S=l+4|0;T=m+8|0;U=m+4|0;V=j+36|0;W=j+16|0;X=j+4|0;Z=j+40|0;_=j+44|0;$=j+48|0;aa=i+36|0;ba=i+16|0;ca=i+4|0;da=i+40|0;ea=i+44|0;fa=i+48|0;ga=0;do{if(d){ha=0;do{_ab(i,g,ga,ha);_ab(j,h,ga,ha);$ab(a,i,j);ia=G;f[ia>>2]=0;f[ia+4>>2]=0;f[k>>2]=33619968;f[B>>2]=j;OJ(j,k,f[j>>2]&4095,+n[s>>2]/H,+n[r>>2]);f[D>>2]=0;f[I>>2]=0;f[k>>2]=16842752;f[J>>2]=j;ja=+n[K>>2];ia=L;f[ia>>2]=0;f[ia+4>>2]=0;f[l>>2]=33619968;f[M>>2]=j;XO(k,ja,l);f[N>>2]=0;f[O>>2]=0;f[k>>2]=16842752;f[P>>2]=i;f[Q>>2]=0;f[R>>2]=0;f[l>>2]=16842752;f[S>>2]=j;ia=T;f[ia>>2]=0;f[ia+4>>2]=0;f[m>>2]=33619968;f[U>>2]=j;VE(k,l,m,1.0,-1);ia=f[V>>2]|0;if(ia|0?(ka=ia+12|0,ia=f[ka>>2]|0,f[ka>>2]=ia+-1,(ia|0)==1):0)kL(j);f[V>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[X>>2]|0)>0){ia=f[Z>>2]|0;ka=0;do{f[ia+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[X>>2]|0))}ka=f[_>>2]|0;if((ka|0)!=($|0))UC(ka);ka=f[aa>>2]|0;if(ka|0?(ia=ka+12|0,ka=f[ia>>2]|0,f[ia>>2]=ka+-1,(ka|0)==1):0)kL(i);f[aa>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[ca>>2]|0)>0){ka=f[da>>2]|0;ia=0;do{f[ka+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[ca>>2]|0))}ia=f[ea>>2]|0;if((ia|0)!=(fa|0))UC(ia);ha=ha+1|0}while((ha|0)<(q|0))}ga=ga+1|0}while((ga|0)<(p|0))}p=f[C>>2]|0;if(p|0?(ga=p+12|0,p=f[ga>>2]|0,f[ga>>2]=p+-1,(p|0)==1):0)kL(h);f[C>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[E>>2]|0;E=0;do{f[y+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[c>>2]|0))}c=f[F>>2]|0;if((c|0)!=(t|0))UC(c);c=f[x>>2]|0;if(c|0?(t=c+12|0,c=f[t>>2]|0,f[t>>2]=c+-1,(c|0)==1):0)kL(g);f[x>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[o>>2]|0)>0){w=f[z>>2]|0;z=0;do{f[w+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[o>>2]|0))}o=f[A>>2]|0;if((o|0)==(v|0)){u=e;return}UC(o);u=e;return}function _ab(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+128|0;h=g;i=c+4|0;j=f[i>>2]|0;if((j|0)<=2){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,10)|0;l=435143;m=k+10|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,435154,442663,114);bD(h);l=f[i>>2]|0;if((l|0)>2){n=l;o=h;p=4}else{q=l;r=h}}else{n=j;o=h;p=4}if((p|0)==4){p=f[c+40>>2]|0;j=2;do{f[h+(j+-2<<2)>>2]=f[p+(j<<2)>>2];j=j+1|0}while((j|0)<(n|0));q=n;r=o}o=f[c+44>>2]|0;r=(f[c+16>>2]|0)+(Y(f[o>>2]|0,d)|0)|0;oL(a,q+-2|0,h,f[c>>2]&4095,r+(Y(f[o+4>>2]|0,e)|0)|0,0);u=g;return}function $ab(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+112|0;e=d+48|0;g=d+32|0;h=d+16|0;i=d+8|0;j=d;Qi(e,f[b+8>>2]|0,f[b+12>>2]|0,f[b>>2]&4095,f[b+16>>2]|0,f[f[b+44>>2]>>2]|0);f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=e;b=h+8|0;f[b>>2]=0;f[b+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=c;b=f[c>>2]&7;c=f[a+40>>2]|0;f[i>>2]=c;f[i+4>>2]=c;f[j>>2]=-1;f[j+4>>2]=-1;i7(g,h,b,i,j,0,0);j=e+36|0;i=f[j>>2]|0;if(i|0?(b=i+12|0,i=f[b>>2]|0,f[b>>2]=i+-1,(i|0)==1):0)kL(e);f[j>>2]=0;j=e+16|0;i=e+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[i>>2]|0)>0){j=f[e+40>>2]|0;b=0;do{f[j+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[i>>2]|0))}i=f[e+44>>2]|0;if((i|0)==(e+48|0)){u=d;return}UC(i);u=d;return}function abb(a){a=a|0;O5b(a);return}function bbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0;c=u;u=u+1072|0;d=c;e=f[a+36>>2]|0;g=f[a+40>>2]|0;h=f[a+24>>2]|0;i=Y(h,e)|0;j=((g+-1+i|0)>>>0)/(g>>>0)|0;k=Y(f[b>>2]|0,j)|0;l=f[b+4>>2]|0;b=Y(l,j)|0;j=(l|0)==(g|0)?i:b;b=i>>>0<k>>>0?i:k;k=i>>>0<j>>>0?i:j;m=+n[a+12>>2];o=+n[a+16>>2];p=+n[a+20>>2];j=f[a+28>>2]|0;i=f[a+32>>2]|0;g=((i<<1)+j<<1)+8|0;l=d+8|0;f[d>>2]=l;q=d+4|0;f[q>>2]=g;if(g>>>0>264){r=N5b(g>>>0>1073741823?-1:g<<2)|0;f[d>>2]=r;s=r}else s=l;r=s+(j<<2)+(i<<2)+4|0;if((i|0)>=0){g=0;while(1){n[r+(g+j<<2)>>2]=0.0;n[r+(~g<<2)>>2]=0.0;if((g|0)==(i|0))break;else g=g+1|0}}if(k>>>0>b>>>0){g=a+4|0;t=a+8|0;a=(j|0)>0;v=(i|0)>0;w=~i;x=b;while(1){b=(x>>>0)/(h>>>0)|0;if((b|0)>=(e|0))break;y=Y(b,h)|0;b=x-y|0;z=h-b|0;A=k-x|0;B=(A>>>0<z>>>0?A:z)+x|0;z=Y(y,j)|0;y=(f[t>>2]|0)+(z<<2)+(b<<2)|0;a:do if(x>>>0<B>>>0){if(!a){A=x;while(1){if(v){C=0;do C=C+1|0;while((C|0)!=(i|0))}XY(s,s,j);VY(s,s,j);C=A+1|0;if(C>>>0<B>>>0)A=C;else{D=C;break a}}}A=y;C=(f[g>>2]|0)+(z<<2)+(b<<2)|0;E=x;while(1){F=0;do{G=C+((Y(F,h)|0)<<2)|0;f[r+(F<<2)>>2]=f[G>>2];F=F+1|0}while((F|0)!=(j|0));if(v){H=0.0;F=0;while(1){I=+n[r+(F<<2)>>2];J=H+I*I;F=F+1|0;if((F|0)==(i|0)){K=J;L=0;break}else H=J}}else{K=0.0;L=0}do{H=+n[r+(L+i<<2)>>2];J=+n[r+(L+w<<2)>>2];I=K+(H+J)*(H-J);K=I<0.0?0.0:I;n[s+(L<<2)>>2]=o+m*K;L=L+1|0}while((L|0)!=(j|0));XY(s,s,j);F=0;do{G=s+(F<<2)|0;n[G>>2]=p*+n[G>>2];F=F+1|0}while((F|0)!=(j|0));VY(s,s,j);F=0;do{G=A+((Y(F,h)|0)<<2)|0;n[G>>2]=+n[r+(F<<2)>>2]*+n[s+(F<<2)>>2];F=F+1|0}while((F|0)!=(j|0));F=E+1|0;if(F>>>0<B>>>0){A=A+4|0;C=C+4|0;E=F}else{D=F;break}}}else D=x;while(0);if(k>>>0>D>>>0)x=D;else break}M=f[d>>2]|0}else M=s;if((M|0)==(l|0)){u=c;return}if(M|0)P5b(M);f[d>>2]=l;f[q>>2]=264;u=c;return}function cbb(a,b){a=a|0;b=b|0;var c=0;c=L5b(40)|0;dbb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=119132;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function dbb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;Jwa(a);f[a>>2]=119152;Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,9)|0;h=413015;i=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j=f[c+4>>2]|0;do if(!j)bD(e);else{k=f[e>>2]|0;l=(k|0)==0?1124530:k;m=j;while(1){n=f[m+16>>2]|0;if((k|0)==(n|0)){o=9;break}p=(n|0)==0?1124530:n;if((gTb(l,p)|0)<0)q=m;else{if((gTb(p,l)|0)>=0){o=10;break}q=m+4|0}m=f[q>>2]|0;if(!m){o=14;break}}if((o|0)==9)bD(e);else if((o|0)==10)bD(e);else if((o|0)==14){bD(e);break}f[e>>2]=0;f[e+4>>2]=0;g=aD(e,9)|0;h=413015;i=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));m=Gwa(Eya(c,e)|0,-1)|0;l=a+36|0;f[l>>2]=m;bD(e);if((f[l>>2]|0)>-1){u=d;return}f[e>>2]=0;f[e+4>>2]=0;g=aD(e,17)|0;h=413025;i=g+17|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-215,e,413043,413058,61);bD(e);u=d;return}while(0);f[a+36>>2]=-1;u=d;return}function ebb(a){a=a|0;O5b(a);return}function fbb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function gbb(a){a=a|0;lua(a);O5b(a);return}function hbb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+32|0;a=e+16|0;g=e;dQ(a,119276);h=d+4|0;i=f[d>>2]|0;if((f[h>>2]|0)!=(i|0)){j=g+8|0;k=g+4|0;l=g+4|0;m=0;n=i;do{i=n;o=f[f[c>>2]>>2]|0;p=f[o+4>>2]|0;if((p|0)<3)q=Y(f[o+12>>2]|0,f[o+8>>2]|0)|0;else{r=f[o+40>>2]|0;s=0;t=1;while(1){v=Y(f[r+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(p|0)){q=v;break}else t=v}}t=f[i+(m*56|0)+4>>2]|0;if((t|0)<3)w=Y(f[i+(m*56|0)+12>>2]|0,f[i+(m*56|0)+8>>2]|0)|0;else{p=f[i+(m*56|0)+40>>2]|0;s=0;r=1;while(1){v=Y(f[p+(s<<2)>>2]|0,r)|0;s=s+1|0;if((s|0)==(t|0)){w=v;break}else r=v}}if((q|0)==(w|0)){x=i;y=o}else{f[g>>2]=0;f[l>>2]=0;r=aD(g,40)|0;t=413245;s=r+40|0;do{b[r>>0]=b[t>>0]|0;r=r+1|0;t=t+1|0}while((r|0)<(s|0));bO(-215,g,443123,413058,96);bD(g);x=f[d>>2]|0;y=f[f[c>>2]>>2]|0}t=j;f[t>>2]=0;f[t+4>>2]=0;f[g>>2]=33619968;f[k>>2]=x+(m*56|0);SP(y,g);m=m+1|0;n=f[d>>2]|0}while(m>>>0<(((f[h>>2]|0)-n|0)/56|0)>>>0)}if(!(f[a+4>>2]|0)){u=e;return}u=e;return}function ibb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,119244);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function jbb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h;if(((f[c+4>>2]|0)-(f[c>>2]|0)|0)!=12){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,18)|0;k=443104;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,i,442770,413058,74);bD(i)}i=f[a+36>>2]|0;k=(i|0)>-1?i:d;yua(a,c,(k|0)>1?k:1,e,g)|0;u=h;return 0}function kbb(a,b){a=a|0;b=b|0;var c=0;c=L5b(48)|0;lbb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=119316;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function lbb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;Jwa(a);f[a>>2]=119336;Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,1)|0;b[g>>0]=112;g=c+4|0;c=f[g>>2]|0;do if(c){h=f[e>>2]|0;i=(h|0)==0?1124530:h;j=g;k=c;a:while(1){l=k;while(1){m=f[l+16>>2]|0;if((m|0)==(h|0))break;if((gTb((m|0)==0?1124530:m,i)|0)>=0)break;m=f[l+4>>2]|0;if(!m){o=j;break a}else l=m}k=f[l>>2]|0;if(!k){o=l;break}else j=l}if((o|0)!=(g|0)){j=f[o+16>>2]|0;if((h|0)!=(j|0)?(gTb(i,(j|0)==0?1124530:j)|0)<=-1:0){p=2.0;break}p=+Hya(o+24|0,-1)}else p=2.0}else p=2.0;while(0);o=a+36|0;n[o>>2]=p;bD(e);f[e>>2]=0;f[e+4>>2]=0;c=aD(e,3)|0;b[c>>0]=b[433709]|0;b[c+1>>0]=b[433710]|0;b[c+2>>0]=b[433711]|0;c=f[g>>2]|0;do if(c){j=f[e>>2]|0;k=(j|0)==0?1124530:j;m=g;q=c;b:while(1){r=q;while(1){s=f[r+16>>2]|0;if((s|0)==(j|0))break;if((gTb((s|0)==0?1124530:s,k)|0)>=0)break;s=f[r+4>>2]|0;if(!s){t=m;break b}else r=s}q=f[r>>2]|0;if(!q){t=r;break}else m=r}if((t|0)!=(g|0)){m=f[t+16>>2]|0;if((j|0)!=(m|0)?(gTb(k,(m|0)==0?1124530:m)|0)<=-1:0){v=1.000000013351432e-10;break}v=+Hya(t+24|0,-1)}else v=1.000000013351432e-10}else v=1.000000013351432e-10;while(0);n[a+40>>2]=v;bD(e);f[e>>2]=0;f[e+4>>2]=0;t=aD(e,14)|0;c=413549;m=t+14|0;do{b[t>>0]=b[c>>0]|0;t=t+1|0;c=c+1|0}while((t|0)<(m|0));q=f[g>>2]|0;do if(q){i=f[e>>2]|0;h=(i|0)==0?1124530:i;l=g;s=q;c:while(1){w=s;while(1){x=f[w+16>>2]|0;if((x|0)==(i|0))break;if((gTb((x|0)==0?1124530:x,h)|0)>=0)break;x=f[w+4>>2]|0;if(!x){y=l;break c}else w=x}s=f[w>>2]|0;if(!s){y=w;break}else l=w}if((y|0)!=(g|0)){l=f[y+16>>2]|0;if((i|0)!=(l|0)?(gTb(h,(l|0)==0?1124530:l)|0)<=-1:0){z=1;break}l=Gwa(y+24|0,-1)|0;z=((l|0)!=0|(J|0)!=0)&1}else z=1}else z=1;while(0);b[a+44>>0]=z;bD(e);if(+n[o>>2]>0.0){u=d;return}f[e>>2]=0;f[e+4>>2]=0;t=aD(e,9)|0;c=413564;m=t+9|0;do{b[t>>0]=b[c>>0]|0;t=t+1|0;c=c+1|0}while((t|0)<(m|0));bO(-215,e,413574,413597,57);bD(e);u=d;return}function mbb(a){a=a|0;O5b(a);return}function nbb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function obb(a){a=a|0;lua(a);O5b(a);return}function pbb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0.0,Xb=0,Yb=0,Zb=0,_b=0,$b=0;g=u;u=u+496|0;h=g+480|0;i=g+80|0;j=g+64|0;k=g+472|0;l=g+416|0;m=g+360|0;o=g+32|0;q=g+304|0;r=g;dQ(k,119460);s=f[c>>2]|0;t=s;if(((f[c+4>>2]|0)-s|0)==4?((f[d+4>>2]|0)-(f[d>>2]|0)|0)==56:0){v=c;w=t}else{f[h>>2]=0;f[h+4>>2]=0;x=aD(h,41)|0;y=413801;z=x+41|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,h,443123,413597,85);bD(h);v=c;w=f[c>>2]|0}c=f[w>>2]|0;w=f[c+4>>2]|0;if((w|0)<3)A=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{t=f[c+40>>2]|0;c=0;s=1;while(1){B=Y(f[t+(c<<2)>>2]|0,s)|0;c=c+1|0;if((c|0)==(w|0)){A=B;break}else s=B}}s=f[d>>2]|0;w=f[s+4>>2]|0;if((w|0)<3)C=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;else{c=f[s+40>>2]|0;s=0;t=1;while(1){B=Y(f[c+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(w|0)){C=B;break}else t=B}}if((A|0)!=(C|0)){f[h>>2]=0;f[h+4>>2]=0;x=aD(h,40)|0;y=413843;z=x+40|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,h,443123,413597,86);bD(h)}C=f[f[v>>2]>>2]|0;v=f[e>>2]|0;e=f[C+40>>2]|0;A=f[e>>2]|0;t=f[e+4>>2]|0;w=f[C+4>>2]|0;if((w|0)<3)D=Y(f[C+12>>2]|0,f[C+8>>2]|0)|0;else{s=1;c=A;while(1){B=Y(f[e+(s<<2)>>2]|0,c)|0;s=s+1|0;if((s|0)==(w|0)){D=B;break}else c=B}}c=(D>>>0)/((Y(t,A)|0)>>>0)|0;if(A|0){D=C+16|0;w=C+44|0;C=l+4|0;s=l+8|0;e=l+12|0;B=l+16|0;E=l+20|0;F=l+24|0;G=l+28|0;H=l+40|0;I=l+48|0;J=l+44|0;K=l+52|0;L=(Y(c,t)|0)!=0;M=h+4|0;O=m+4|0;P=m+8|0;Q=m+12|0;R=m+16|0;S=m+20|0;T=m+24|0;U=m+28|0;V=m+40|0;W=m+48|0;X=m+44|0;Z=m+52|0;_=h+4|0;$=h+8|0;aa=h+12|0;ba=h+4|0;ca=a+36|0;da=j+8|0;ea=j+4|0;fa=a+44|0;ga=q+4|0;ha=q+8|0;ia=q+40|0;ja=q+48|0;ka=q+44|0;la=q+52|0;ma=h+8|0;na=h+12|0;oa=h+4|0;pa=i+8|0;qa=i+4|0;ra=a+40|0;sa=r+8|0;ta=h+8|0;ua=h+12|0;va=h+4|0;wa=i+8|0;xa=i+12|0;ya=i+4|0;za=j+8|0;Aa=j+4|0;Ba=h+8|0;Ca=h+12|0;Da=h+4|0;Ea=i+8|0;Fa=i+4|0;Ga=h+8|0;Ha=h+12|0;Ia=h+4|0;Ja=i+8|0;Ka=i+4|0;La=h+8|0;Ma=h+12|0;Na=h+4|0;Oa=i+8|0;Pa=i+12|0;Qa=i+4|0;Ra=j+8|0;Sa=j+4|0;Ta=q+36|0;Ua=q+16|0;Va=a+4|0;Wa=a+8|0;a=m+36|0;Xa=l+36|0;Ya=i+4|0;Za=i+8|0;_a=i+12|0;$a=i+16|0;ab=i+20|0;bb=i+24|0;cb=i+28|0;db=i+32|0;eb=i+36|0;fb=i+40|0;gb=i+48|0;hb=i+44|0;ib=i+52|0;jb=h+8|0;kb=h+4|0;lb=h+8|0;mb=h+12|0;nb=h+4|0;ob=j+8|0;pb=j+4|0;qb=h+8|0;rb=h+12|0;sb=h+4|0;tb=j+8|0;ub=j+12|0;vb=j+4|0;wb=q+8|0;xb=q+4|0;yb=h+4|0;zb=h+8|0;Ab=h+12|0;Bb=h+4|0;Cb=h+8|0;Db=h+12|0;Eb=h+4|0;Fb=i+8|0;Gb=i+12|0;Hb=i+4|0;Ib=q+8|0;Jb=q+4|0;Kb=0;do{Lb=(f[D>>2]|0)+(Y(f[f[w>>2]>>2]|0,Kb)|0)|0;f[l>>2]=1124007941;f[C>>2]=2;f[s>>2]=t;f[e>>2]=c;f[B>>2]=Lb;f[E>>2]=Lb;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;f[H>>2]=s;f[J>>2]=I;f[K>>2]=0;f[I>>2]=0;if(L&(Lb|0)==0){f[h>>2]=0;f[M>>2]=0;x=aD(h,26)|0;y=426262;z=x+26|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,h,426289,431198,500);bD(h);Mb=f[e>>2]|0;Nb=f[l>>2]|0;Ob=f[J>>2]|0;Pb=f[E>>2]|0}else{Mb=c;Nb=1124007941;Ob=I;Pb=Lb}Qb=Mb<<2;f[l>>2]=Nb|16384;f[Ob>>2]=Qb;f[Ob+4>>2]=4;Rb=Pb+(Y(f[s>>2]|0,Qb)|0)|0;f[G>>2]=Rb;f[F>>2]=Rb+(0-Qb)+Qb;Qb=f[d>>2]|0;Rb=(f[Qb+16>>2]|0)+(Y(f[f[Qb+44>>2]>>2]|0,Kb)|0)|0;f[m>>2]=1124007941;f[O>>2]=2;f[P>>2]=t;f[Q>>2]=c;f[R>>2]=Rb;f[S>>2]=Rb;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;f[V>>2]=P;f[X>>2]=W;f[Z>>2]=0;f[W>>2]=0;if(L&(Rb|0)==0){f[h>>2]=0;f[_>>2]=0;x=aD(h,26)|0;y=426262;z=x+26|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,h,426289,431198,500);bD(h);Sb=f[Q>>2]|0;Tb=f[m>>2]|0;Ub=f[X>>2]|0;Vb=f[S>>2]|0}else{Sb=c;Tb=1124007941;Ub=W;Vb=Rb}Lb=Sb<<2;f[m>>2]=Tb|16384;f[Ub>>2]=Lb;f[Ub+4>>2]=4;Qb=Vb+(Y(f[P>>2]|0,Lb)|0)|0;f[U>>2]=Qb;f[T>>2]=Qb+(0-Lb)+Lb;KS(i,l);f[$>>2]=0;f[aa>>2]=0;f[h>>2]=-1056571392;f[ba>>2]=i;Wb=+n[ca>>2];Lb=da;f[Lb>>2]=0;f[Lb+4>>2]=0;f[j>>2]=33619968;f[ea>>2]=v;XO(h,Wb,j);Wi(i);if(!(b[fa>>0]|0)){f[q>>2]=1124007936;x=ga;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[ia>>2]=ha;f[ka>>2]=ja;f[ja>>2]=0;f[la>>2]=0;f[ma>>2]=0;f[na>>2]=0;f[h>>2]=16842752;f[oa>>2]=v;Rb=pa;f[Rb>>2]=0;f[Rb+4>>2]=0;f[i>>2]=33619968;f[qa>>2]=q;aN(h,i,0,0,-1);p[r>>3]=+n[ra>>2];f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;f[sa+16>>2]=0;f[sa+20>>2]=0;f[ta>>2]=0;f[ua>>2]=0;f[h>>2]=16842752;f[va>>2]=q;f[i>>2]=-1056833530;f[ya>>2]=r;f[wa>>2]=1;f[xa>>2]=4;Rb=za;f[Rb>>2]=0;f[Rb+4>>2]=0;f[j>>2]=33619968;f[Aa>>2]=q;VD(h,i,j,UM()|0,-1);f[Ba>>2]=0;f[Ca>>2]=0;f[h>>2]=16842752;f[Da>>2]=q;Wb=+n[ca>>2];Rb=Ea;f[Rb>>2]=0;f[Rb+4>>2]=0;f[i>>2]=33619968;f[Fa>>2]=q;XO(h,-1.0/Wb,i);f[Ga>>2]=0;f[Ha>>2]=0;f[h>>2]=16842752;f[Ia>>2]=q;Rb=Ja;f[Rb>>2]=0;f[Rb+4>>2]=0;f[i>>2]=33619968;f[Ka>>2]=v;YP(h,t,1,i);f[La>>2]=0;f[Ma>>2]=0;f[h>>2]=16842752;f[Na>>2]=l;f[Oa>>2]=0;f[Pa>>2]=0;f[i>>2]=16842752;f[Qa>>2]=v;Rb=Ra;f[Rb>>2]=0;f[Rb+4>>2]=0;f[j>>2]=33619968;f[Sa>>2]=m;NE(h,i,j,1.0,-1);Rb=f[Ta>>2]|0;if(Rb|0?(Lb=Rb+12|0,Rb=f[Lb>>2]|0,f[Lb>>2]=Rb+-1,(Rb|0)==1):0)kL(q);f[Ta>>2]=0;f[Ua>>2]=0;f[Ua+4>>2]=0;f[Ua+8>>2]=0;f[Ua+12>>2]=0;if((f[ga>>2]|0)>0){Rb=f[ia>>2]|0;Lb=0;do{f[Rb+(Lb<<2)>>2]=0;Lb=Lb+1|0}while((Lb|0)<(f[ga>>2]|0))}Lb=f[ka>>2]|0;if((Lb|0)!=(ja|0))UC(Lb)}else{f[zb>>2]=0;f[Ab>>2]=0;f[h>>2]=16842752;f[Bb>>2]=v;fG(o,h);Wb=+N(+(+p[o>>3]+ +n[ra>>2]),+(1.0/+n[ca>>2]));f[Cb>>2]=0;f[Db>>2]=0;f[h>>2]=16842752;f[Eb>>2]=l;p[j>>3]=1.0/Wb;f[i>>2]=-1056833530;f[Hb>>2]=j;f[Fb>>2]=1;f[Gb>>2]=1;Lb=Ib;f[Lb>>2]=0;f[Lb+4>>2]=0;f[q>>2]=33619968;f[Jb>>2]=m;NE(h,i,q,1.0,-1)}Lb=f[Va>>2]|0;if((Lb|0)!=(f[Wa>>2]|0)){f[i>>2]=f[Lb>>2];Rb=Lb+4|0;f[Ya>>2]=f[Rb>>2];f[Za>>2]=f[Lb+8>>2];f[_a>>2]=f[Lb+12>>2];f[$a>>2]=f[Lb+16>>2];f[ab>>2]=f[Lb+20>>2];f[bb>>2]=f[Lb+24>>2];f[cb>>2]=f[Lb+28>>2];f[db>>2]=f[Lb+32>>2];Qb=f[Lb+36>>2]|0;f[eb>>2]=Qb;f[fb>>2]=Za;f[hb>>2]=gb;f[gb>>2]=0;f[ib>>2]=0;if(Qb|0){Xb=Qb+12|0;f[Xb>>2]=(f[Xb>>2]|0)+1}if((f[Rb>>2]|0)<3){Rb=f[Lb+44>>2]|0;Xb=f[hb>>2]|0;f[Xb>>2]=f[Rb>>2];f[Xb+4>>2]=f[Rb+4>>2]}else{f[Ya>>2]=0;jL(i,Lb)}Lb=f[Ya>>2]|0;Rb=(Lb|0)<3;if(Rb)Yb=Y(f[_a>>2]|0,f[Za>>2]|0)|0;else{Xb=f[fb>>2]|0;Qb=0;Zb=1;while(1){_b=Y(f[Xb+(Qb<<2)>>2]|0,Zb)|0;Qb=Qb+1|0;if((Qb|0)==(Lb|0)){Yb=_b;break}else Zb=_b}}if((Yb|0)==1){Wb=+n[f[$a>>2]>>2];Zb=jb;f[Zb>>2]=0;f[Zb+4>>2]=0;f[h>>2]=33619968;f[kb>>2]=m;OJ(m,h,-1,Wb,0.0)}else{if(Rb)$b=Y(f[_a>>2]|0,f[Za>>2]|0)|0;else{Zb=f[fb>>2]|0;Qb=0;Xb=1;while(1){_b=Y(f[Zb+(Qb<<2)>>2]|0,Xb)|0;Qb=Qb+1|0;if((Qb|0)==(Lb|0)){$b=_b;break}else Xb=_b}}if(($b|0)!=(t|0)){f[h>>2]=0;f[yb>>2]=0;x=aD(h,25)|0;y=413884;z=x+25|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,h,443123,413597,132);bD(h)}f[lb>>2]=0;f[mb>>2]=0;f[h>>2]=16842752;f[nb>>2]=i;Xb=f[Q>>2]|0;Lb=ob;f[Lb>>2]=0;f[Lb+4>>2]=0;f[j>>2]=33619968;f[pb>>2]=v;YP(h,1,Xb,j);f[qb>>2]=0;f[rb>>2]=0;f[h>>2]=16842752;f[sb>>2]=m;f[tb>>2]=0;f[ub>>2]=0;f[j>>2]=16842752;f[vb>>2]=v;Xb=wb;f[Xb>>2]=0;f[Xb+4>>2]=0;f[q>>2]=33619968;f[xb>>2]=m;NE(h,j,q,1.0,-1)}Xb=f[eb>>2]|0;do if(Xb|0){Lb=Xb+12|0;Qb=f[Lb>>2]|0;f[Lb>>2]=Qb+-1;if((Qb|0)!=1)break;kL(i)}while(0);f[eb>>2]=0;f[$a>>2]=0;f[$a+4>>2]=0;f[$a+8>>2]=0;f[$a+12>>2]=0;if((f[Ya>>2]|0)>0){Xb=f[fb>>2]|0;Qb=0;do{f[Xb+(Qb<<2)>>2]=0;Qb=Qb+1|0}while((Qb|0)<(f[Ya>>2]|0))}Qb=f[hb>>2]|0;if((Qb|0)!=(gb|0))UC(Qb)}Qb=f[a>>2]|0;if(Qb|0?(Xb=Qb+12|0,Qb=f[Xb>>2]|0,f[Xb>>2]=Qb+-1,(Qb|0)==1):0)kL(m);f[a>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[O>>2]|0)>0){Qb=f[V>>2]|0;Xb=0;do{f[Qb+(Xb<<2)>>2]=0;Xb=Xb+1|0}while((Xb|0)<(f[O>>2]|0))}Xb=f[X>>2]|0;if((Xb|0)!=(W|0))UC(Xb);Xb=f[Xa>>2]|0;if(Xb|0?(Qb=Xb+12|0,Xb=f[Qb>>2]|0,f[Qb>>2]=Xb+-1,(Xb|0)==1):0)kL(l);f[Xa>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[C>>2]|0)>0){Xb=f[H>>2]|0;Qb=0;do{f[Xb+(Qb<<2)>>2]=0;Qb=Qb+1|0}while((Qb|0)<(f[C>>2]|0))}Qb=f[J>>2]|0;if((Qb|0)!=(I|0))UC(Qb);Kb=Kb+1|0}while(Kb>>>0<A>>>0)}if(!(f[k+4>>2]|0)){u=g;return}u=g;return}function qbb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,119428);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function rbb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+16|0;i=h;if(((f[c+4>>2]|0)-(f[c>>2]|0)|0)!=12){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,18)|0;k=443104;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,i,442770,413597,65);bD(i)}yua(a,c,d,e,g)|0;e=g+4|0;d=f[e>>2]|0;a=f[g>>2]|0;i=d-a|0;k=(i|0)/12|0;j=d;if(!i){sbb(g,1-k|0,f[c>>2]|0);m=f[g>>2]|0;n=f[m>>2]|0;f[n>>2]=1;u=h;return 1}if(k>>>0<=1){m=f[g>>2]|0;n=f[m>>2]|0;f[n>>2]=1;u=h;return 1}k=a+12|0;if((j|0)==(k|0)){m=f[g>>2]|0;n=f[m>>2]|0;f[n>>2]=1;u=h;return 1}else o=j;while(1){j=o+-12|0;f[e>>2]=j;a=f[j>>2]|0;if(!a)p=j;else{j=o+-8|0;c=f[j>>2]|0;if((c|0)!=(a|0))f[j>>2]=c+(~((c+-4-a|0)>>>2)<<2);O5b(a);p=f[e>>2]|0}if((p|0)==(k|0))break;else o=p}m=f[g>>2]|0;n=f[m>>2]|0;f[n>>2]=1;u=h;return 1}function sbb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/12|0)>>>0>=b>>>0){i=b;j=h;do{Bua(j,c);j=(f[g>>2]|0)+12|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/12|0;h=j+b|0;if(h>>>0>357913941)c4b(a);k=(e-i|0)/12|0;i=k<<1;e=k>>>0<178956970?(i>>>0<h>>>0?h:i):357913941;do if(e)if(e>>>0>357913941){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{l=L5b(e*12|0)|0;break}else l=0;while(0);i=l+(j*12|0)|0;j=i;h=l+(e*12|0)|0;e=b;b=j;l=i;do{Bua(l,c);l=b+12|0;b=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=f[g>>2]|0;if((l|0)==(e|0)){m=j;n=e;o=e}else{c=l;l=j;j=i;do{c=c+-12|0;Bua(j+-12|0,c);j=l+-12|0;l=j}while((c|0)!=(e|0));m=l;n=f[a>>2]|0;o=f[g>>2]|0}f[a>>2]=m;f[g>>2]=b;f[d>>2]=h;h=n;if((o|0)!=(h|0)){d=o;do{o=d;d=d+-12|0;b=f[d>>2]|0;if(b|0){g=o+-8|0;o=f[g>>2]|0;if((o|0)!=(b|0))f[g>>2]=o+(~((o+-4-b|0)>>>2)<<2);O5b(b)}}while((d|0)!=(h|0))}if(!n)return;O5b(n);return}function tbb(a,b){a=a|0;b=b|0;var c=0;c=L5b(36)|0;ubb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=119500;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function ubb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;Jwa(a);f[a>>2]=119520;Kwa(a,c);if(((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)==56){u=d;return}f[e>>2]=0;f[e+4>>2]=0;a=aD(e,17)|0;c=430177;g=a+17|0;do{b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0}while((a|0)<(g|0));bO(-215,e,414189,414204,26);bD(e);u=d;return}function vbb(a){a=a|0;O5b(a);return}function wbb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xbb(a){a=a|0;lua(a);O5b(a);return}function ybb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;g=u;u=u+352|0;h=g+344|0;i=g+16|0;j=g+288|0;k=g;l=g+272|0;m=g+256|0;n=g+240|0;dQ(h,119644);if((f[c+4>>2]|0)==(f[c>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;o=aD(i,17)|0;q=441774;r=o+17|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));bO(-215,i,443123,414204,52);bD(i)}s=a+4|0;t=f[s>>2]|0;if((f[a+8>>2]|0)==(t|0)){f[i>>2]=0;f[i+4>>2]=0;o=aD(i,16)|0;q=414391;r=o+16|0;do{b[o>>0]=b[q>>0]|0;o=o+1|0;q=q+1|0}while((o|0)<(r|0));bO(-215,i,443123,414204,53);bD(i);v=s;w=f[s>>2]|0}else{v=s;w=t}t=f[f[c>>2]>>2]|0;a:do if((f[t+4>>2]|0)==(f[w+4>>2]|0)){q=d+4|0;o=f[d>>2]|0;if((f[q>>2]|0)!=(o|0)){r=0;a=o;o=t;while(1){sS(i,o,f[v>>2]|0);x=f[i>>2]|0;th[f[(f[x>>2]|0)+12>>2]&511](x,i,a+(r*56|0)|0,-1);Wi(i);x=r+1|0;y=f[d>>2]|0;if(x>>>0>=(((f[q>>2]|0)-y|0)/56|0)>>>0)break a;r=x;a=y;o=f[(f[c>>2]|0)+(x<<2)>>2]|0}}}else{o=f[e>>2]|0;f[i>>2]=f[o>>2];a=i+4|0;r=o+4|0;f[a>>2]=f[r>>2];q=i+8|0;f[q>>2]=f[o+8>>2];f[i+12>>2]=f[o+12>>2];x=i+16|0;f[x>>2]=f[o+16>>2];f[i+20>>2]=f[o+20>>2];f[i+24>>2]=f[o+24>>2];f[i+28>>2]=f[o+28>>2];f[i+32>>2]=f[o+32>>2];y=i+36|0;z=f[o+36>>2]|0;f[y>>2]=z;A=i+40|0;f[A>>2]=q;q=i+48|0;B=i+44|0;f[B>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(z|0){C=z+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[r>>2]|0)<3){r=f[o+44>>2]|0;C=f[B>>2]|0;f[C>>2]=f[r>>2];f[C+4>>2]=f[r+4>>2]}else{f[a>>2]=0;jL(i,o)}p[k>>3]=1.0;f[j>>2]=-1056833530;f[j+4>>2]=k;f[j+8>>2]=1;f[j+12>>2]=1;VP(i,j,UM()|0)|0;o=d+4|0;r=f[d>>2]|0;if((f[o>>2]|0)!=(r|0)){C=j+8|0;z=j+4|0;D=k+8|0;E=k+12|0;F=k+4|0;G=l+8|0;H=l+12|0;I=l+4|0;J=m+8|0;K=m+12|0;L=m+4|0;M=n+8|0;N=n+4|0;O=j+36|0;P=j+16|0;Q=j+4|0;R=j+40|0;S=j+44|0;T=j+48|0;U=0;V=r;do{r=V;W=f[(f[c>>2]|0)+(U<<2)>>2]|0;X=r+(U*56|0)|0;Z=C;f[Z>>2]=0;f[Z+4>>2]=0;f[j>>2]=33619968;f[z>>2]=X;SP(W,j);Z=W+40|0;W=f[Z>>2]|0;if((f[W>>2]|0)>0){_=r+(U*56|0)+16|0;$=r+(U*56|0)+44|0;r=0;aa=W;do{W=Y(f[aa+12>>2]|0,f[aa+8>>2]|0)|0;Qi(j,f[aa+4>>2]|0,W,f[X>>2]&4095,(f[_>>2]|0)+(Y(f[f[$>>2]>>2]|0,r)|0)|0,0);W=f[s>>2]|0;f[D>>2]=0;f[E>>2]=0;f[k>>2]=16842752;f[F>>2]=W;f[G>>2]=0;f[H>>2]=0;f[l>>2]=16842752;f[I>>2]=i;f[J>>2]=0;f[K>>2]=0;f[m>>2]=16842752;f[L>>2]=j;W=M;f[W>>2]=0;f[W+4>>2]=0;f[n>>2]=33619968;f[N>>2]=j;CX(k,l,1.0,m,1.0,n,0);W=f[O>>2]|0;if(W|0?(ba=W+12|0,W=f[ba>>2]|0,f[ba>>2]=W+-1,(W|0)==1):0)kL(j);f[O>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[Q>>2]|0)>0){W=f[R>>2]|0;ba=0;do{f[W+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[Q>>2]|0))}ba=f[S>>2]|0;if((ba|0)!=(T|0))UC(ba);r=r+1|0;aa=f[Z>>2]|0}while((r|0)<(f[aa>>2]|0))}U=U+1|0;V=f[d>>2]|0}while(U>>>0<(((f[o>>2]|0)-V|0)/56|0)>>>0)}V=f[y>>2]|0;if(V|0?(o=V+12|0,V=f[o>>2]|0,f[o>>2]=V+-1,(V|0)==1):0)kL(i);f[y>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[a>>2]|0)>0){V=f[A>>2]|0;o=0;do{f[V+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[a>>2]|0))}a=f[B>>2]|0;if((a|0)!=(q|0))UC(a)}while(0);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function zbb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,119612);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Abb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;h=u;u=u+32|0;i=h+16|0;j=h;yua(a,c,d,e,g)|0;e=f[c>>2]|0;c=f[e+4>>2]|0;d=f[e>>2]|0;a=c-d|0;k=a>>2;do if((d|0)!=(c|0)){if((a|0)<8){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,70)|0;m=442586;n=l+70|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,i,442657,442663,160);bD(i);o=1;break}if((a|0)==8)o=1;else{m=f[e>>2]|0;l=2;n=1;while(1){p=Y(f[m+(l<<2)>>2]|0,n)|0;l=l+1|0;if((l|0)==(k|0)){o=p;break}else n=p}}}else o=0;while(0);f[i>>2]=1;f[i+4>>2]=o;f[i+8>>2]=-1;f[i+12>>2]=-1;f[j>>2]=0;o=j+4|0;f[o>>2]=0;f[j+8>>2]=0;Rva(j,i,i+16|0);i=f[j>>2]|0;k=f[o>>2]|0;a:do if((i|0)==(k|0)){q=i;r=10}else{e=i;do{if((f[e>>2]|0)<0){q=e;r=10;break a}e=e+4|0}while((e|0)!=(k|0))}while(0);if((r|0)==10?(q|0)!=(k|0):0){r=q+4|0;if((r|0)==(k|0)){s=k;t=q}else{i=r;r=q;while(1){q=f[i>>2]|0;if((q|0)<0)v=r;else{f[r>>2]=q;v=r+4|0}i=i+4|0;if((i|0)==(k|0))break;else r=v}s=f[o>>2]|0;t=v}if((t|0)!=(s|0))f[o>>2]=s+(~((s+-4-t|0)>>>2)<<2)}Aua(g,1,j);g=f[j>>2]|0;if(!g){u=h;return 1}j=f[o>>2]|0;if((j|0)!=(g|0))f[o>>2]=j+(~((j+-4-g|0)>>>2)<<2);O5b(g);u=h;return 1}function Bbb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;a=d;e=c+4|0;g=f[c>>2]|0;if((f[e>>2]|0)==(g|0)){h=0;i=0;J=h;u=d;return i|0}j=a+4|0;k=0;l=0;m=g;do{g=m;n=g+(l*12|0)|0;o=f[g+(l*12|0)+4>>2]|0;g=f[n>>2]|0;p=o-g|0;q=p>>2;do if((g|0)!=(o|0)){if((p|0)<0){f[a>>2]=0;f[j>>2]=0;r=aD(a,70)|0;s=442586;t=r+70|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,a,442657,442663,160);bD(a);v=1;break}if(!p)v=1;else{s=f[n>>2]|0;r=0;t=1;while(1){w=Y(f[s+(r<<2)>>2]|0,t)|0;r=r+1|0;if((r|0)==(q|0)){v=w;break}else t=w}}}else v=0;while(0);k=v+k|0;l=l+1|0;m=f[c>>2]|0}while(l>>>0<(((f[e>>2]|0)-m|0)/12|0)>>>0);h=((k|0)<0)<<31>>31;i=k;J=h;u=d;return i|0}function Cbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=L5b(192)|0;Jwa(e);g=e+36|0;h=g+48|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=119684;f[e+88>>2]=1124007936;i=e+96|0;j=e+128|0;g=e+92|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[j>>2]=i;i=e+136|0;f[e+132>>2]=i;g=i;h=g+56|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=L5b(16)|0;h=g+4|0;f[h>>2]=1;f[g>>2]=119788;f[g+8>>2]=e;f[a>>2]=g;f[a+4>>2]=e;f[d>>2]=g;f[d+4>>2]=e;f[h>>2]=(f[h>>2]|0)+1;Dbb(d,b);b=f[d>>2]|0;if(!b){u=c;return}d=b+4|0;h=f[d>>2]|0;f[d>>2]=h+-1;if((h|0)!=1){u=c;return}bi[f[(f[b>>2]|0)+8>>2]&2047](b);u=c;return}function Dbb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=a+4|0;Kwa(f[g>>2]|0,c);a=f[g>>2]|0;Hcb(c,a+40|0,a+36|0,a+56|0,a+52|0,a+48|0,a+44|0,a+64|0,a+60|0,a+76|0);f[e>>2]=0;f[e+4>>2]=0;a=aD(e,10)|0;h=424460;i=a+10|0;do{b[a>>0]=b[h>>0]|0;a=a+1|0;h=h+1|0}while((a|0)<(i|0));j=Gwa(Eya(c,e)|0,-1)|0;f[(f[g>>2]|0)+84>>2]=j;bD(e);f[e>>2]=0;f[e+4>>2]=0;j=aD(e,5)|0;b[j>>0]=b[450653]|0;b[j+1>>0]=b[450654]|0;b[j+2>>0]=b[450655]|0;b[j+3>>0]=b[450656]|0;b[j+4>>0]=b[450657]|0;j=c+4|0;c=f[j>>2]|0;do if(c){k=f[e>>2]|0;l=(k|0)==0?1124530:k;m=j;n=c;a:while(1){o=n;while(1){p=f[o+16>>2]|0;if((p|0)==(k|0))break;if((gTb((p|0)==0?1124530:p,l)|0)>=0)break;p=f[o+4>>2]|0;if(!p){q=m;break a}else o=p}n=f[o>>2]|0;if(!n){q=o;break}else m=o}if((q|0)!=(j|0)){m=f[q+16>>2]|0;if((k|0)!=(m|0)?(gTb(l,(m|0)==0?1124530:m)|0)<=-1:0){r=1;break}m=Gwa(q+24|0,-1)|0;r=m}else r=1}else r=1;while(0);bD(e);f[e>>2]=0;f[e+4>>2]=0;q=aD(e,5)|0;b[q>>0]=b[414585]|0;b[q+1>>0]=b[414586]|0;b[q+2>>0]=b[414587]|0;b[q+3>>0]=b[414588]|0;b[q+4>>0]=b[414589]|0;q=f[j>>2]|0;do if(q){c=f[e>>2]|0;m=(c|0)==0?1124530:c;n=j;p=q;b:while(1){s=p;while(1){t=f[s+16>>2]|0;if((t|0)==(c|0))break;if((gTb((t|0)==0?1124530:t,m)|0)>=0)break;t=f[s+4>>2]|0;if(!t){v=n;break b}else s=t}p=f[s>>2]|0;if(!p){v=s;break}else n=s}if((v|0)!=(j|0)){n=f[v+16>>2]|0;if((c|0)!=(n|0)?(gTb(m,(n|0)==0?1124530:n)|0)<=-1:0){w=0;break}n=Gwa(v+24|0,-1)|0;w=n}else w=0}else w=0;while(0);f[(f[g>>2]|0)+72>>2]=w;bD(e);f[e>>2]=0;f[e+4>>2]=0;w=aD(e,5)|0;b[w>>0]=b[414591]|0;b[w+1>>0]=b[414592]|0;b[w+2>>0]=b[414593]|0;b[w+3>>0]=b[414594]|0;b[w+4>>0]=b[414595]|0;w=f[j>>2]|0;do if(w){v=f[e>>2]|0;q=(v|0)==0?1124530:v;n=j;p=w;c:while(1){l=p;while(1){k=f[l+16>>2]|0;if((k|0)==(v|0))break;if((gTb((k|0)==0?1124530:k,q)|0)>=0)break;k=f[l+4>>2]|0;if(!k){x=n;break c}else l=k}p=f[l>>2]|0;if(!p){x=l;break}else n=l}if((x|0)!=(j|0)){n=f[x+16>>2]|0;if((v|0)!=(n|0)?(gTb(q,(n|0)==0?1124530:n)|0)<=-1:0){y=0;break}n=Gwa(x+24|0,-1)|0;y=n}else y=0}else y=0;while(0);f[(f[g>>2]|0)+68>>2]=y;bD(e);y=f[g>>2]|0;if(!((f[y+84>>2]|0)%(r|0)|0))z=y;else{f[e>>2]=0;f[e+4>>2]=0;a=aD(e,27)|0;h=414597;i=a+27|0;do{b[a>>0]=b[h>>0]|0;a=a+1|0;h=h+1|0}while((a|0)<(i|0));bO(-215,e,414625,414654,1465);bD(e);z=f[g>>2]|0}if((f[z+68>>2]|0)<(f[z+44>>2]|0)?(f[z+72>>2]|0)<(f[z+48>>2]|0):0){u=d;return}f[e>>2]=0;f[e+4>>2]=0;a=aD(e,78)|0;h=414739;i=a+78|0;do{b[a>>0]=b[h>>0]|0;a=a+1|0;h=h+1|0}while((a|0)<(i|0));bO(-215,e,414625,414654,1467);bD(e);u=d;return}function Ebb(a){a=a|0;O5b(a);return}function Fbb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Gbb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=119684;b=a+184|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+188>>2]=0;b=a+176|0;c=f[b>>2]|0;if(c|0?(e=c+4|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+180>>2]=0;b=a+168|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+172>>2]=0;b=f[a+156>>2]|0;if(b|0){c=a+160|0;e=f[c>>2]|0;if((e|0)!=(b|0))f[c>>2]=e+(~((e+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+144>>2]|0;if(b|0){e=a+148|0;c=f[e>>2]|0;if((c|0)!=(b|0))f[e>>2]=c+(~((c+-4-b|0)>>>2)<<2);O5b(b)}b=a+88|0;c=a+124|0;e=f[c>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)kL(b);f[c>>2]=0;c=a+104|0;b=a+92|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+128>>2]|0;e=0;do{f[c+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[b>>2]|0))}b=f[a+132>>2]|0;if((b|0)==(a+136|0)){f[a>>2]=119892;g=a+76|0;bD(g);lua(a);return}UC(b);f[a>>2]=119892;g=a+76|0;bD(g);lua(a);return}function Hbb(a){a=a|0;Gbb(a);O5b(a);return}function Ibb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=u;u=u+16|0;g=e+8|0;h=e;i=c+4|0;if((f[i>>2]|0)==(f[c>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,17)|0;k=441774;l=j+17|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,443724,414654,72);bD(g)}m=a+4|0;n=f[m>>2]|0;o=(f[a+8>>2]|0)-n|0;if((o|0)!=0&((o|0)/56|0)>>>0<3)p=n;else{f[g>>2]=0;f[g+4>>2]=0;j=aD(g,38)|0;k=416255;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,443724,414654,74);bD(g);p=f[m>>2]|0}if(!(((f[p+4>>2]|0)==4?(m=f[p+40>>2]|0,(f[m+12>>2]|0)==(f[a+36>>2]|0)):0)?(f[m+8>>2]|0)==(f[a+40>>2]|0):0)){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,91)|0;k=416294;l=j+91|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,443724,414654,75);bD(g)}m=f[c>>2]|0;p=f[m>>2]|0;if((f[p+4>>2]|0)==4?((f[p>>2]&4095)+-5|0)>>>0<2:0){q=m;r=m}else{f[g>>2]=0;f[g+4>>2]=0;j=aD(g,59)|0;k=416386;l=j+59|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,443724,414654,78);bD(g);m=f[c>>2]|0;q=m;r=m}if((f[i>>2]|0)==(r|0)){s=p+40|0;t=f[d>>2]|0;v=t+40|0;w=f[v>>2]|0;x=w+12|0;y=f[x>>2]|0;z=w+8|0;A=f[z>>2]|0;f[g>>2]=y;B=g+4|0;f[B>>2]=A;C=f[s>>2]|0;D=C+12|0;E=f[D>>2]|0;F=C+8|0;G=f[F>>2]|0;f[h>>2]=E;H=h+4|0;f[H>>2]=G;I=a+36|0;J=a+44|0;K=a+76|0;L=a+60|0;M=a+52|0;Jcb(h,g,I,J,K,L,M);u=e;return}m=p+40|0;n=g+4|0;o=g+4|0;N=g+4|0;O=0;P=r;r=q;while(1){if(!((f[p>>2]^f[f[r+(O<<2)>>2]>>2])&4095)){Q=P;R=r}else{f[g>>2]=0;f[N>>2]=0;j=aD(g,33)|0;k=416446;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,443724,414654,81);bD(g);q=f[c>>2]|0;Q=q;R=q}q=f[R+(O<<2)>>2]|0;if((f[q+4>>2]|0)==4?(S=f[m>>2]|0,(f[(f[q+40>>2]|0)+4>>2]|0)==(f[S+4>>2]|0)):0){T=R;U=S;V=Q}else{f[g>>2]=0;f[o>>2]=0;j=aD(g,59)|0;k=416480;l=j+59|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,443724,414654,82);bD(g);S=f[c>>2]|0;T=S;U=f[m>>2]|0;V=S}S=f[(f[T+(O<<2)>>2]|0)+40>>2]|0;if((f[S+8>>2]|0)==(f[U+8>>2]|0)?(f[S+12>>2]|0)==(f[U+12>>2]|0):0)W=V;else{f[g>>2]=0;f[n>>2]=0;j=aD(g,74)|0;k=416540;l=j+74|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,443724,414654,83);bD(g);W=f[c>>2]|0}O=O+1|0;if(O>>>0>=(f[i>>2]|0)-W>>2>>>0){s=m;break}else{P=W;r=W}}t=f[d>>2]|0;v=t+40|0;w=f[v>>2]|0;x=w+12|0;y=f[x>>2]|0;z=w+8|0;A=f[z>>2]|0;f[g>>2]=y;B=g+4|0;f[B>>2]=A;C=f[s>>2]|0;D=C+12|0;E=f[D>>2]|0;F=C+8|0;G=f[F>>2]|0;f[h>>2]=E;H=h+4|0;f[H>>2]=G;I=a+36|0;J=a+44|0;K=a+76|0;L=a+60|0;M=a+52|0;Jcb(h,g,I,J,K,L,M);u=e;return}function Jbb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0;e=u;u=u+448|0;g=e+384|0;h=e;i=e+320|0;j=e+256|0;k=e+328|0;l=e+192|0;m=e+128|0;o=e+64|0;p=e+56|0;q=e+312|0;r=e+248|0;s=e+184|0;t=e+120|0;dQ(i,119832);v=f[c>>2]|0;if(((f[c+4>>2]|0)-v|0)==4?(w=f[(f[(f[v>>2]|0)+40>>2]|0)+4>>2]|0,v=a+4|0,x=f[(f[(f[v>>2]|0)+40>>2]|0)+4>>2]|0,((w|0)%(x|0)|0|0)==0):0){y=v;z=c;A=x;B=w}else{f[g>>2]=0;f[g+4>>2]=0;C=aD(g,72)|0;D=415212;E=C+72|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,g,443123,414654,907);bD(g);w=a+4|0;y=w;z=c;A=f[(f[(f[w>>2]|0)+40>>2]|0)+4>>2]|0;B=f[(f[(f[f[c>>2]>>2]|0)+40>>2]|0)+4>>2]|0}c=(B|0)/(A|0)|0;if((f[(f[(f[d>>2]|0)+40>>2]|0)+4>>2]|0)%(c|0)|0|0){f[g>>2]=0;f[g+4>>2]=0;C=aD(g,33)|0;D=415285;E=C+33|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,g,443123,414654,909);bD(g)}A=f[y>>2]|0;y=f[f[A+40>>2]>>2]|0;B=a+88|0;w=a+104|0;if(f[w>>2]|0){x=f[a+92>>2]|0;if((x|0)<3)F=Y(f[a+100>>2]|0,f[a+96>>2]|0)|0;else{v=f[a+128>>2]|0;G=0;H=1;while(1){I=Y(f[v+(G<<2)>>2]|0,H)|0;G=G+1|0;if((G|0)==(x|0)){F=I;break}else H=I}}if((x|0)==0|(F|0)==0)J=14}else J=14;if((J|0)==14){WL(k,A,1,y);f[j>>2]=1124007936;A=j+4|0;F=j+8|0;x=j+40|0;C=A;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[x>>2]=F;H=j+48|0;G=j+44|0;f[G>>2]=H;f[H>>2]=0;f[j+52>>2]=0;v=g+8|0;f[v>>2]=0;f[v+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;SP(k,g);v=k+36|0;I=f[v>>2]|0;if(I|0?(K=I+12|0,I=f[K>>2]|0,f[K>>2]=I+-1,(I|0)==1):0)kL(k);f[v>>2]=0;v=k+16|0;I=k+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[I>>2]|0)>0){v=f[k+40>>2]|0;K=0;do{f[v+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[I>>2]|0))}I=f[k+44>>2]|0;if((I|0)!=(k+48|0))UC(I);I=f[j>>2]|0;k=((f[f[G>>2]>>2]|0)>>>0)/((1212424721>>>(I<<2&28)&15)>>>0)|0;if(k&7|0){K=k+7&-8;k=I&4095;f[l>>2]=1124007936;I=l+4|0;v=l+8|0;L=l+40|0;C=I;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[L>>2]=v;v=l+48|0;M=l+44|0;f[M>>2]=v;f[v>>2]=0;f[l+52>>2]=0;f[g>>2]=y;f[g+4>>2]=K;hL(l,2,g,k);k=j+12|0;N=f[k>>2]|0;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=N;f[h+4>>2]=K;lL(m,l,g,h);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[g>>2]=-1056833530;f[g+4>>2]=h;f[g+8>>2]=1;f[g+12>>2]=4;VP(m,g,UM()|0)|0;K=f[k>>2]|0;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=0;f[h+4>>2]=K;lL(o,l,g,h);K=g+8|0;f[K>>2]=0;f[K+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=o;SP(j,g);K=o+36|0;N=f[K>>2]|0;if(N|0){O=N+12|0;f[O>>2]=(f[O>>2]|0)+1}O=j+36|0;N=f[O>>2]|0;if(N|0?(P=N+12|0,N=f[P>>2]|0,f[P>>2]=N+-1,(N|0)==1):0)kL(j);f[O>>2]=0;N=j+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[A>>2]|0)>0){P=f[x>>2]|0;Q=0;do{f[P+(Q<<2)>>2]=0;Q=Q+1|0;R=f[A>>2]|0}while((Q|0)<(R|0));f[j>>2]=f[o>>2];if((R|0)<3)J=33;else J=35}else{f[j>>2]=f[o>>2];J=33}if((J|0)==33){R=f[o+4>>2]|0;if((R|0)<3){f[A>>2]=R;f[F>>2]=f[o+8>>2];f[k>>2]=f[o+12>>2];k=f[o+44>>2]|0;R=f[G>>2]|0;f[R>>2]=f[k>>2];f[R+4>>2]=f[k+4>>2]}else J=35}if((J|0)==35)jL(j,o);k=o+16|0;f[N>>2]=f[k>>2];f[j+20>>2]=f[o+20>>2];f[j+24>>2]=f[o+24>>2];f[j+28>>2]=f[o+28>>2];f[j+32>>2]=f[o+32>>2];N=f[K>>2]|0;f[O>>2]=N;if(N|0?(O=N+12|0,N=f[O>>2]|0,f[O>>2]=N+-1,(N|0)==1):0)kL(o);f[K>>2]=0;K=o+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[K>>2]|0)>0){k=f[o+40>>2]|0;N=0;do{f[k+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[K>>2]|0))}K=f[o+44>>2]|0;if((K|0)!=(o+48|0))UC(K);K=m+36|0;N=f[K>>2]|0;if(N|0?(k=N+12|0,N=f[k>>2]|0,f[k>>2]=N+-1,(N|0)==1):0)kL(m);f[K>>2]=0;K=m+16|0;N=m+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[N>>2]|0)>0){K=f[m+40>>2]|0;k=0;do{f[K+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[N>>2]|0))}N=f[m+44>>2]|0;if((N|0)!=(m+48|0))UC(N);N=l+36|0;k=f[N>>2]|0;do if(k|0){K=k+12|0;O=f[K>>2]|0;f[K>>2]=O+-1;if((O|0)!=1)break;kL(l)}while(0);f[N>>2]=0;N=l+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[I>>2]|0)>0){N=f[L>>2]|0;L=0;do{f[N+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[I>>2]|0))}I=f[M>>2]|0;if((I|0)!=(v|0))UC(I)}if((B|0)!=(j|0)){I=j+36|0;v=f[I>>2]|0;if(v|0){M=v+12|0;f[M>>2]=(f[M>>2]|0)+1}M=a+124|0;v=f[M>>2]|0;if(v|0?(L=v+12|0,v=f[L>>2]|0,f[L>>2]=v+-1,(v|0)==1):0)kL(B);f[M>>2]=0;v=a+92|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[v>>2]|0)>0){L=f[a+128>>2]|0;N=0;do{f[L+(N<<2)>>2]=0;N=N+1|0;S=f[v>>2]|0}while((N|0)<(S|0));f[B>>2]=f[j>>2];if((S|0)<3)J=72;else J=74}else{f[B>>2]=f[j>>2];J=72}if((J|0)==72){S=f[A>>2]|0;if((S|0)<3){f[v>>2]=S;f[a+96>>2]=f[F>>2];f[a+100>>2]=f[j+12>>2];F=f[G>>2]|0;S=f[a+132>>2]|0;f[S>>2]=f[F>>2];f[S+4>>2]=f[F+4>>2]}else J=74}if((J|0)==74)jL(B,j);f[w>>2]=f[j+16>>2];f[a+108>>2]=f[j+20>>2];f[a+112>>2]=f[j+24>>2];f[a+116>>2]=f[j+28>>2];f[a+120>>2]=f[j+32>>2];f[M>>2]=f[I>>2]}I=f[a+4>>2]|0;if((((f[a+8>>2]|0)-I|0)/56|0)>>>0>1)WL(g,I+56|0,1,y);else{f[g>>2]=1124007936;I=g+8|0;M=g+40|0;C=g+4|0;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[M>>2]=I;I=g+48|0;f[g+44>>2]=I;f[I>>2]=0;f[g+52>>2]=0}I=a+144|0;M=y+2|0;F=a+148|0;S=f[F>>2]|0;v=f[I>>2]|0;N=S-v>>2;L=v;v=S;if(M>>>0<=N>>>0){if(M>>>0<N>>>0?(S=L+(M<<2)|0,(v|0)!=(S|0)):0)f[F>>2]=v+(~((v+-4-S|0)>>>2)<<2)}else ipa(I,M-N|0);N=g+16|0;M=f[N>>2]|0;a:do if(M){S=f[g+4>>2]|0;if((S|0)<3)T=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{v=f[g+40>>2]|0;F=0;L=1;while(1){k=Y(f[v+(F<<2)>>2]|0,L)|0;F=F+1|0;if((F|0)==(S|0)){T=k;break}else L=k}}if(!((S|0)==0|(T|0)==0)){if((y|0)>0){L=f[g+40>>2]|0;F=L+4|0;v=f[g+44>>2]|0;k=f[g+12>>2]|0;O=f[I>>2]|0;if(f[g>>2]&16384|0){K=0;while(1){f[O+(K<<2)>>2]=f[M+(K<<2)>>2];K=K+1|0;if((K|0)==(y|0))break a}}K=(f[L>>2]|0)==1;S=0;do{do if(!K){R=f[v>>2]|0;if((f[F>>2]|0)==1){U=M+(Y(R,S)|0)|0;break}else{Q=(S|0)/(k|0)|0;U=M+(Y(Q,R)|0)+(S-(Y(Q,k)|0)<<2)|0;break}}else U=M+(S<<2)|0;while(0);f[O+(S<<2)>>2]=f[U>>2];S=S+1|0}while((S|0)!=(y|0))}}else J=99}else J=99;while(0);if((J|0)==99?(y|0)>0:0)Nac(f[I>>2]|0,0,y<<2|0)|0;U=f[a+180>>2]|0;M=(U|0)==0;if(!(M?!(f[a+188>>2]|0):0)){f[h>>2]=1124007936;T=h+4|0;S=h+8|0;O=h+40|0;C=T;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[O>>2]=S;k=h+48|0;F=h+44|0;f[F>>2]=k;f[k>>2]=0;f[h+52>>2]=0;f[l>>2]=1124007936;v=l+4|0;K=l+8|0;L=l+40|0;C=v;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[L>>2]=K;Q=l+48|0;R=l+44|0;f[R>>2]=Q;f[Q>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;P=m+4|0;V=m+8|0;W=m+40|0;C=P;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[W>>2]=V;X=m+48|0;Z=m+44|0;f[Z>>2]=X;f[X>>2]=0;f[m+52>>2]=0;f[o>>2]=1124007936;_=o+4|0;$=o+8|0;aa=o+40|0;C=_;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[aa>>2]=$;ba=o+48|0;ca=o+44|0;f[ca>>2]=ba;f[ba>>2]=0;f[o+52>>2]=0;if(M){da=0;ea=0}else{_h[f[(f[U>>2]|0)+92>>2]&255](U,h,l);U=f[h>>2]|0;do if((U&16384|0)!=0?((U&4095|0)==5?(f[l>>2]&20479|0)==16389:0):0){M=f[T>>2]|0;if((M|0)<3)fa=Y(f[h+12>>2]|0,f[S>>2]|0)|0;else{ga=f[O>>2]|0;ha=0;ia=1;while(1){ja=Y(f[ga+(ha<<2)>>2]|0,ia)|0;ha=ha+1|0;if((ha|0)==(M|0)){fa=ja;break}else ia=ja}}if((fa|0)!=(y|0)){J=117;break}ia=f[v>>2]|0;if((ia|0)<3)ka=Y(f[l+12>>2]|0,f[K>>2]|0)|0;else{M=f[L>>2]|0;ha=0;ga=1;while(1){ja=Y(f[M+(ha<<2)>>2]|0,ga)|0;ha=ha+1|0;if((ha|0)==(ia|0)){ka=ja;break}else ga=ja}}if((ka|0)!=(y|0))J=117}else J=117;while(0);if((J|0)==117){f[p>>2]=0;f[p+4>>2]=0;Vac(aD(p,154)|0,415319,154)|0;bO(-215,p,443123,414654,954);bD(p)}da=f[h+16>>2]|0;ea=f[l+16>>2]|0}ka=a+188|0;K=f[ka>>2]|0;do if(!K){la=0;ma=0}else{fa=f[K+4>>2]|0;if((m|0)!=(fa|0)){S=fa+36|0;U=f[S>>2]|0;if(U|0){ga=U+12|0;f[ga>>2]=(f[ga>>2]|0)+1}ga=m+36|0;U=f[ga>>2]|0;do if(U|0){ia=U+12|0;ha=f[ia>>2]|0;f[ia>>2]=ha+-1;if((ha|0)!=1)break;kL(m)}while(0);f[ga>>2]=0;U=m+16|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[P>>2]|0)>0){ha=f[W>>2]|0;ia=0;do{f[ha+(ia<<2)>>2]=0;ia=ia+1|0;na=f[P>>2]|0}while((ia|0)<(na|0));f[m>>2]=f[fa>>2];if((na|0)<3)J=131;else J=133}else{f[m>>2]=f[fa>>2];J=131}do if((J|0)==131){ia=f[fa+4>>2]|0;if((ia|0)>=3){J=133;break}f[P>>2]=ia;f[V>>2]=f[fa+8>>2];f[m+12>>2]=f[fa+12>>2];ia=f[fa+44>>2]|0;ha=f[Z>>2]|0;f[ha>>2]=f[ia>>2];f[ha+4>>2]=f[ia+4>>2]}while(0);if((J|0)==133)jL(m,fa);f[U>>2]=f[fa+16>>2];f[m+20>>2]=f[fa+20>>2];f[m+24>>2]=f[fa+24>>2];f[m+28>>2]=f[fa+28>>2];f[m+32>>2]=f[fa+32>>2];f[ga>>2]=f[S>>2]}if((f[m>>2]&20479|0)==16389){ia=f[P>>2]|0;if((ia|0)<3)oa=Y(f[m+12>>2]|0,f[V>>2]|0)|0;else{ha=f[W>>2]|0;M=0;ja=1;while(1){pa=Y(f[ha+(M<<2)>>2]|0,ja)|0;M=M+1|0;if((M|0)==(ia|0)){oa=pa;break}else ja=pa}}if((oa|0)!=(y|0))J=141}else J=141;if((J|0)==141){f[p>>2]=0;f[p+4>>2]=0;C=aD(p,78)|0;D=415474;E=C+78|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,p,443123,414654,962);bD(p)}ja=f[m+16>>2]|0;ia=f[ka>>2]|0;if(!(b[ia+36>>0]|0)){la=ja;ma=0;break}M=f[ia+4>>2]|0;ia=M+56|0;if((o|0)!=(ia|0)){ha=M+92|0;S=f[ha>>2]|0;if(S|0){ga=S+12|0;f[ga>>2]=(f[ga>>2]|0)+1}ga=o+36|0;S=f[ga>>2]|0;do if(S|0){fa=S+12|0;U=f[fa>>2]|0;f[fa>>2]=U+-1;if((U|0)!=1)break;kL(o)}while(0);f[ga>>2]=0;S=o+16|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[_>>2]|0)>0){U=f[aa>>2]|0;fa=0;do{f[U+(fa<<2)>>2]=0;fa=fa+1|0;qa=f[_>>2]|0}while((fa|0)<(qa|0));f[o>>2]=f[ia>>2];if((qa|0)<3)J=154;else J=156}else{f[o>>2]=f[ia>>2];J=154}do if((J|0)==154){fa=f[M+60>>2]|0;if((fa|0)>=3){J=156;break}f[_>>2]=fa;f[$>>2]=f[M+64>>2];f[o+12>>2]=f[M+68>>2];fa=f[M+100>>2]|0;U=f[ca>>2]|0;f[U>>2]=f[fa>>2];f[U+4>>2]=f[fa+4>>2]}while(0);if((J|0)==156)jL(o,ia);f[S>>2]=f[M+72>>2];f[o+20>>2]=f[M+76>>2];f[o+24>>2]=f[M+80>>2];f[o+28>>2]=f[M+84>>2];f[o+32>>2]=f[M+88>>2];f[ga>>2]=f[ha>>2]}if((f[o>>2]&20479|0)==16389){fa=f[_>>2]|0;if((fa|0)<3)ra=Y(f[o+12>>2]|0,f[$>>2]|0)|0;else{U=f[aa>>2]|0;pa=0;sa=1;while(1){ta=Y(f[U+(pa<<2)>>2]|0,sa)|0;pa=pa+1|0;if((pa|0)==(fa|0)){ra=ta;break}else sa=ta}}if((ra|0)!=(y|0))J=164}else J=164;if((J|0)==164){f[p>>2]=0;f[p+4>>2]=0;C=aD(p,78)|0;D=415553;E=C+78|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,p,443123,414654,968);bD(p)}la=ja;ma=f[o+16>>2]|0}while(0);if((y|0)>0){p=(ea|0)==0;ra=(la|0)==0;$=(ma|0)==0;qa=f[w>>2]|0;w=f[f[a+132>>2]>>2]|0;ka=f[a+100>>2]|0;oa=(ka|0)>0;V=f[I>>2]|0;if(!da){na=0;do{if(p)ua=0.0;else ua=+n[ea+(na<<2)>>2];if(ra)va=1.0;else va=+n[la+(na<<2)>>2];if($)wa=0.0;else wa=+n[ma+(na<<2)>>2];K=qa+(Y(w,na)|0)|0;if(oa){sa=0;do{fa=K+(sa<<2)|0;n[fa>>2]=va*+n[fa>>2];sa=sa+1|0}while((sa|0)!=(ka|0))}sa=V+(na<<2)|0;n[sa>>2]=ua*va+wa+va*+n[sa>>2];na=na+1|0}while((na|0)!=(y|0))}else{na=0;do{if(p)xa=0.0;else xa=+n[ea+(na<<2)>>2];if(ra)ya=1.0;else ya=+n[la+(na<<2)>>2];if($)za=0.0;else za=+n[ma+(na<<2)>>2];sa=qa+(Y(w,na)|0)|0;va=+n[da+(na<<2)>>2]*ya;if(oa){K=0;do{ja=sa+(K<<2)|0;n[ja>>2]=va*+n[ja>>2];K=K+1|0}while((K|0)!=(ka|0))}K=V+(na<<2)|0;n[K>>2]=xa*ya+za+va*+n[K>>2];na=na+1|0}while((na|0)!=(y|0))}}na=o+36|0;V=f[na>>2]|0;do if(V|0){ka=V+12|0;oa=f[ka>>2]|0;f[ka>>2]=oa+-1;if((oa|0)!=1)break;kL(o)}while(0);f[na>>2]=0;na=o+16|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[_>>2]|0)>0){na=f[aa>>2]|0;aa=0;do{f[na+(aa<<2)>>2]=0;aa=aa+1|0}while((aa|0)<(f[_>>2]|0))}_=f[ca>>2]|0;if((_|0)!=(ba|0))UC(_);_=m+36|0;ba=f[_>>2]|0;do if(ba|0){ca=ba+12|0;aa=f[ca>>2]|0;f[ca>>2]=aa+-1;if((aa|0)!=1)break;kL(m)}while(0);f[_>>2]=0;_=m+16|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[P>>2]|0)>0){_=f[W>>2]|0;W=0;do{f[_+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[P>>2]|0))}P=f[Z>>2]|0;if((P|0)!=(X|0))UC(P);P=l+36|0;X=f[P>>2]|0;do if(X|0){Z=X+12|0;W=f[Z>>2]|0;f[Z>>2]=W+-1;if((W|0)!=1)break;kL(l)}while(0);f[P>>2]=0;P=l+16|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[v>>2]|0)>0){P=f[L>>2]|0;L=0;do{f[P+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[v>>2]|0))}v=f[R>>2]|0;if((v|0)!=(Q|0))UC(v);v=h+36|0;Q=f[v>>2]|0;do if(Q|0){R=Q+12|0;L=f[R>>2]|0;f[R>>2]=L+-1;if((L|0)!=1)break;kL(h)}while(0);f[v>>2]=0;v=h+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[T>>2]|0)>0){v=f[O>>2]|0;O=0;do{f[v+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[T>>2]|0))}T=f[F>>2]|0;if((T|0)!=(k|0))UC(T)}T=f[I>>2]|0;I=f[T+(y+-1<<2)>>2]|0;f[T+(y+1<<2)>>2]=I;f[T+(y<<2)>>2]=I;I=g+36|0;T=f[I>>2]|0;if(T|0?(k=T+12|0,T=f[k>>2]|0,f[k>>2]=T+-1,(T|0)==1):0)kL(g);f[I>>2]=0;I=g+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[I>>2]|0)>0){N=f[g+40>>2]|0;T=0;do{f[N+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[I>>2]|0))}I=f[g+44>>2]|0;if((I|0)!=(g+48|0))UC(I);I=j+36|0;T=f[I>>2]|0;if(T|0?(N=T+12|0,T=f[N>>2]|0,f[N>>2]=T+-1,(T|0)==1):0)kL(j);f[I>>2]=0;I=j+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[A>>2]|0)>0){I=f[x>>2]|0;x=0;do{f[I+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[A>>2]|0))}A=f[G>>2]|0;if((A|0)!=(H|0))UC(A)}A=a+156|0;H=f[A>>2]|0;G=a+160|0;x=f[G>>2]|0;if((x|0)!=(H|0))f[G>>2]=x+(~((x+-4-H|0)>>>2)<<2);H=a+172|0;x=f[H>>2]|0;if(x|0){I=a+168|0;j=T6b(x,17896,20136,0)|0;x=f[I>>2]|0;T=(x|0)==0;if(!T){N=x+4|0;f[N>>2]=(f[N>>2]|0)+1}if(j|0)Ubb(A,y+2|0,j+36|0);j=f[H>>2]|0;if(!j)Aa=0;else Aa=T6b(j,17896,20152,0)|0;j=f[I>>2]|0;I=(j|0)==0;if(!I){N=j+4|0;f[N>>2]=(f[N>>2]|0)+1}if(Aa|0){N=f[Aa+4>>2]|0;if((f[N>>2]&20479|0)==16389){Aa=f[N+4>>2]|0;if((Aa|0)<3)Ba=Y(f[N+12>>2]|0,f[N+8>>2]|0)|0;else{k=f[N+40>>2]|0;F=0;O=1;while(1){v=Y(f[k+(F<<2)>>2]|0,O)|0;F=F+1|0;if((F|0)==(Aa|0)){Ba=v;break}else O=v}}if((Ba|0)!=(y|0))J=254}else J=254;if((J|0)==254){f[g>>2]=0;f[g+4>>2]=0;C=aD(g,60)|0;D=415632;E=C+60|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,g,443123,414654,1004);bD(g)}g=f[N+16>>2]|0;N=y+2|0;D=f[G>>2]|0;C=f[A>>2]|0;E=D-C>>2;J=C;C=D;if(N>>>0<=E>>>0){if(N>>>0<E>>>0?(D=J+(N<<2)|0,(C|0)!=(D|0)):0)f[G>>2]=C+(~((C+-4-D|0)>>>2)<<2)}else ipa(A,N-E|0);E=g+(y<<2)-g|0;if(E|0)Xac(f[A>>2]|0,g|0,E|0)|0;E=f[A>>2]|0;g=f[E+(y+-1<<2)>>2]|0;f[E+(y+1<<2)>>2]=g;f[E+(y<<2)>>2]=g}g=j;if(!I?(I=g+4|0,y=f[I>>2]|0,f[I>>2]=y+-1,(y|0)==1):0)bi[f[(f[j>>2]|0)+8>>2]&2047](g);g=x;if(!T?(T=g+4|0,j=f[T>>2]|0,f[T>>2]=j+-1,(j|0)==1):0)bi[f[(f[x>>2]|0)+8>>2]&2047](g)}g=SQ()|0;x=f[f[z>>2]>>2]|0;z=f[d>>2]|0;f[q>>2]=f[a+36>>2];f[q+4>>2]=f[a+40>>2];f[r>>2]=f[a+52>>2];f[r+4>>2]=f[a+56>>2];f[s>>2]=f[a+44>>2];f[s+4>>2]=f[a+48>>2];f[t>>2]=f[a+60>>2];f[t+4>>2]=f[a+64>>2];Vbb(x,z,B,a+144|0,A,q,r,s,t,f[H>>2]|0,c,(g|0)>1?g:1);if(!(f[i+4>>2]|0)){u=e;return}u=e;return}function Kbb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,119800);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Lbb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function Mbb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Nbb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function Obb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+168|0;d=f[b>>2]|0;e=f[b+4>>2]|0;if(d|0){b=d+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[c>>2]=d;d=a+172|0;f[d>>2]=e;if(!b)g=e;else{e=b+4|0;c=f[e>>2]|0;f[e>>2]=c+-1;if((c|0)==1)bi[f[(f[b>>2]|0)+8>>2]&2047](b);g=f[d>>2]|0}if(g|0){h=(g|0)!=0;return h|0}d=f[a+156>>2]|0;b=a+160|0;a=f[b>>2]|0;if((a|0)==(d|0)){h=(g|0)!=0;return h|0}f[b>>2]=a+(~((a+-4-d|0)>>>2)<<2);h=(g|0)!=0;return h|0}function Pbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if(f[a+188>>2]|0){c=0;return c|0}d=a+176|0;e=f[b>>2]|0;g=f[b+4>>2]|0;if(e|0){b=e+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[d>>2]|0;f[d>>2]=e;e=a+180|0;f[e>>2]=g;if(b|0?(g=b+4|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)bi[f[(f[b>>2]|0)+8>>2]&2047](b);b=a+88|0;d=a+124|0;g=f[d>>2]|0;if(g|0?(h=g+12|0,g=f[h>>2]|0,f[h>>2]=g+-1,(g|0)==1):0)kL(b);f[d>>2]=0;d=a+104|0;b=a+92|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+128>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0))}c=(f[e>>2]|0)!=0;return c|0}function Qbb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+184|0;d=f[b>>2]|0;e=f[b+4>>2]|0;if(d|0){b=d+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[c>>2]=d;d=a+188|0;f[d>>2]=e;if(b|0?(e=b+4|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)bi[f[(f[b>>2]|0)+8>>2]&2047](b);b=a+88|0;c=a+124|0;e=f[c>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)kL(b);f[c>>2]=0;c=a+104|0;b=a+92|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)<=0){h=f[d>>2]|0;i=(h|0)!=0;return i|0}c=f[a+128>>2]|0;a=0;do{f[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0));h=f[d>>2]|0;i=(h|0)!=0;return i|0}function Rbb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+48|0;h=d+32|0;i=d+16|0;j=d;k=a+4|0;l=a+8|0;m=f[l>>2]|0;n=f[k>>2]|0;if((m|0)==(n|0)){f[h>>2]=0;f[h+4>>2]=0;o=aD(h,17)|0;p=414934;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,h,442770,414654,193);bD(h);r=f[k>>2]|0;s=f[l>>2]|0}else{r=n;s=m}m=r;if(((s-r|0)/56|0)>>>0>1){r=f[m+60>>2]|0;if((r|0)<3)t=Y(f[m+68>>2]|0,f[m+64>>2]|0)|0;else{s=f[m+96>>2]|0;n=0;l=1;while(1){v=Y(f[s+(n<<2)>>2]|0,l)|0;n=n+1|0;if((n|0)==(r|0)){t=v;break}else l=v}}if((t|0)!=(f[f[m+40>>2]>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;o=aD(h,58)|0;p=414952;q=o+58|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,h,442770,414654,194);bD(h)}}m=c+4|0;if(((f[m>>2]|0)-(f[c>>2]|0)|0)!=12){f[h>>2]=0;f[h+4>>2]=0;o=aD(h,26)|0;p=415011;q=o+26|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,h,442770,414654,195);bD(h)}t=f[g>>2]|0;l=g+4|0;g=f[l>>2]|0;if((g|0)!=(t|0)){r=g;while(1){g=r+-12|0;f[l>>2]=g;n=f[g>>2]|0;if(!n)w=g;else{g=r+-8|0;s=f[g>>2]|0;if((s|0)!=(n|0))f[g>>2]=s+(~((s+-4-n|0)>>>2)<<2);O5b(n);w=f[l>>2]|0}if((w|0)==(t|0))break;else r=w}}w=f[f[c>>2]>>2]|0;r=f[w+4>>2]|0;t=f[w+8>>2]|0;l=f[w+12>>2]|0;w=f[(f[k>>2]|0)+40>>2]|0;n=f[w>>2]|0;f[h>>2]=0;s=h+4|0;f[s>>2]=0;if(!(f[a+80>>2]|0)){g=t+-1+(f[a+56>>2]<<1)-(Y((f[a+40>>2]|0)+-1|0,f[a+64>>2]|0)|0)|0;f[s>>2]=((g|0)/(f[a+48>>2]|0)|0)+1;g=l+-1+(f[a+52>>2]<<1)-(Y((f[a+36>>2]|0)+-1|0,f[a+60>>2]|0)|0)|0;f[h>>2]=((g|0)/(f[a+44>>2]|0)|0)+1;x=w}else{f[i>>2]=l;f[i+4>>2]=t;Icb(i,a+36|0,a+44|0,a+76|0,a+60|0,h);x=f[(f[k>>2]|0)+40>>2]|0}k=(r|0)/(f[x+4>>2]|0)|0;if(!(((k|0)>0?((r|0)%(k|0)|0|0)==0:0)?!((n|0)%(k|0)|0|0):0)){f[i>>2]=0;f[i+4>>2]=0;o=aD(i,59)|0;p=415038;q=o+59|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,i,442770,414654,217);bD(i)}p=f[c>>2]|0;f[i>>2]=f[f[p>>2]>>2];f[i+4>>2]=n;f[i+8>>2]=f[s>>2];f[i+12>>2]=f[h>>2];h=((f[m>>2]|0)-p|0)/12|0;f[j>>2]=0;p=j+4|0;f[p>>2]=0;f[j+8>>2]=0;Rva(j,i,i+16|0);i=e+4|0;m=f[i>>2]|0;s=f[e>>2]|0;n=(m-s|0)/12|0;c=s;s=m;if(h>>>0<=n>>>0){if(h>>>0<n>>>0?(m=c+(h*12|0)|0,(s|0)!=(m|0)):0){c=s;while(1){s=c+-12|0;f[i>>2]=s;o=f[s>>2]|0;if(!o)y=s;else{s=c+-8|0;q=f[s>>2]|0;if((q|0)!=(o|0))f[s>>2]=q+(~((q+-4-o|0)>>>2)<<2);O5b(o);y=f[i>>2]|0}if((y|0)==(m|0))break;else c=y}}}else sbb(e,h-n|0,j);n=f[j>>2]|0;if(!n){u=d;return 0}j=f[p>>2]|0;if((j|0)!=(n|0))f[p>>2]=j+(~((j+-4-n|0)>>>2)<<2);O5b(n);u=d;return 0}function Sbb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+16|0;g=e;h=c+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i-j|0)==((f[d+4>>2]|0)-(f[d>>2]|0)|0)){k=j;l=i}else{f[g>>2]=0;f[g+4>>2]=0;m=aD(g,31)|0;n=414902;o=m+31|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,g,427670,414654,1021);bD(g);k=f[c>>2]|0;l=f[h>>2]|0}if((l|0)==(k|0)){p=0;q=0;J=p;u=e;return q|0}i=a+36|0;j=a+40|0;a=g+4|0;r=0;s=k;k=0;t=0;v=l;while(1){l=s;w=f[d>>2]|0;x=f[w+(r*12|0)+4>>2]|0;y=f[w+(r*12|0)>>2]|0;w=x-y|0;z=w>>2;A=y;do if((A|0)!=(x|0)){if((w|0)<=-4){f[g>>2]=0;f[a>>2]=0;m=aD(g,70)|0;n=442586;o=m+70|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,g,442657,442663,160);bD(g);y=f[c>>2]|0;B=1;C=y;D=y;E=f[h>>2]|0;break}if((w|0)>0){y=0;F=1;while(1){G=Y(f[A+(y<<2)>>2]|0,F)|0;y=y+1|0;if((y|0)>=(z|0)){B=G;C=l;D=s;E=v;break}else F=G}}else{B=1;C=l;D=s;E=v}}else{B=0;C=l;D=s;E=v}while(0);l=Y(f[j>>2]|0,f[i>>2]|0)|0;z=$ac(l|0,((l|0)<0)<<31>>31|0,1)|0;l=f[(f[C+(r*12|0)>>2]|0)+4>>2]|0;A=cbc(z|0,J|0,l|0,((l|0)<0)<<31>>31|0)|0;l=cbc(A|1|0,J|0,B|0,((B|0)<0)<<31>>31|0)|0;A=Kac(l|0,J|0,k|0,t|0)|0;l=J;r=r+1|0;if(r>>>0>=((E-D|0)/12|0)>>>0){p=l;q=A;break}else{s=D;k=A;t=l;v=E}}J=p;u=e;return q|0}function Tbb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;e=c;g=f[d>>2]|0;d=Y(f[b+40>>2]|0,f[(f[(f[b+4>>2]|0)+40>>2]|0)+4>>2]|0)|0;h=Y(d,f[b+36>>2]|0)|0;b=Y(f[g+8>>2]|0,f[g+12>>2]|0)|0;f[e>>2]=b;f[e+4>>2]=h;f[e+8>>2]=-1;f[e+12>>2]=-1;f[a>>2]=0;h=a+4|0;f[h>>2]=0;f[a+8>>2]=0;Rva(a,e,e+16|0);e=f[a>>2]|0;a=f[h>>2]|0;a:do if((e|0)==(a|0))i=e;else{b=e;do{if((f[b>>2]|0)<0){i=b;break a}b=b+4|0}while((b|0)!=(a|0));u=c;return}while(0);if((i|0)==(a|0)){u=c;return}e=i+4|0;if((e|0)==(a|0)){j=a;k=i}else{b=e;e=i;while(1){i=f[b>>2]|0;if((i|0)<0)l=e;else{f[e>>2]=i;l=e+4|0}b=b+4|0;if((b|0)==(a|0))break;else e=l}j=f[h>>2]|0;k=l}if((k|0)==(j|0)){u=c;return}f[h>>2]=j+(~((j+-4-k|0)>>>2)<<2);u=c;return}function Ubb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;if(e-g>>2>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>2;l=k>>>0<b>>>0;m=l?k:b;n=j;o=j;if(m|0){p=m;m=h;while(1){f[m>>2]=f[c>>2];p=p+-1|0;if(!p)break;else m=m+4|0}}if(l){l=b-k|0;k=o+(l<<2)|0;o=l;l=j;while(1){f[l>>2]=f[c>>2];o=o+-1|0;if(!o)break;else l=l+4|0}f[i>>2]=k;return}else{k=h+(b<<2)|0;if((n|0)==(k|0))return;f[i>>2]=n+(~((n+-4-k|0)>>>2)<<2);return}}else{k=g;if(!g)q=e;else{e=a+4|0;n=f[e>>2]|0;if((n|0)!=(h|0))f[e>>2]=n+(~((n+-4-g|0)>>>2)<<2);O5b(k);f[d>>2]=0;f[e>>2]=0;f[a>>2]=0;q=0}if(b>>>0>1073741823)c4b(a);e=q>>1;k=q>>2>>>0<536870911?(e>>>0<b>>>0?b:e):1073741823;if(k>>>0>1073741823)c4b(a);e=L5b(k<<2)|0;q=a+4|0;f[q>>2]=e;f[a>>2]=e;f[d>>2]=e+(k<<2);k=e+(b<<2)|0;d=b;b=e;while(1){f[b>>2]=f[c>>2];d=d+-1|0;if(!d)break;else b=b+4|0}f[q>>2]=k;return}}function Vbb(a,c,e,g,h,i,j,k,l,m,n,o){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;p=u;u=u+112|0;q=p+8|0;r=p;if(!((f[a+4>>2]|0)==4?(f[c+4>>2]|0)==4:0)){f[q>>2]=0;f[q+4>>2]=0;s=aD(q,35)|0;t=415693;v=s+35|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,q,443206,414654,369);bD(q)}w=a+40|0;x=c+40|0;y=f[x>>2]|0;if((f[f[w>>2]>>2]|0)==(f[y>>2]|0))z=y;else{f[q>>2]=0;f[q+4>>2]=0;s=aD(q,31)|0;t=415729;v=s+31|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,q,443206,414654,369);bD(q);z=f[x>>2]|0}if((f[e+8>>2]|0)!=(f[z+4>>2]|0)){f[q>>2]=0;f[q+4>>2]=0;s=aD(q,30)|0;t=415761;v=s+30|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,q,443206,414654,369);bD(q)}z=Y(f[i>>2]|0,(f[(f[w>>2]|0)+4>>2]|0)/(n|0)|0)|0;y=i+4|0;if((f[e+12>>2]|0)!=(Y(z,f[y>>2]|0)|0)){f[q>>2]=0;f[q+4>>2]=0;s=aD(q,66)|0;t=415792;v=s+66|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,q,443206,414654,369);bD(q)}z=f[a>>2]|0;if(!((f[c>>2]^z)&4095))A=z;else{f[q>>2]=0;f[q+4>>2]=0;s=aD(q,29)|0;t=415859;v=s+29|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,q,443206,414654,369);bD(q);A=f[a>>2]|0}if(!((f[e>>2]^A)&4095))B=A;else{f[q>>2]=0;f[q+4>>2]=0;s=aD(q,30)|0;t=415889;v=s+30|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,q,443206,414654,369);bD(q);B=f[a>>2]|0}if((B&4095|0)==5)C=B;else{f[q>>2]=0;f[q+4>>2]=0;s=aD(q,17)|0;t=415920;v=s+17|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,q,443206,414654,369);bD(q);C=f[a>>2]|0}if(!(C&16384)){f[q>>2]=0;f[q+4>>2]=0;s=aD(q,20)|0;t=421674;v=s+20|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,q,443206,414654,369);bD(q)}if(!(f[c>>2]&16384)){f[q>>2]=0;f[q+4>>2]=0;s=aD(q,21)|0;t=415938;v=s+21|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,q,443206,414654,369);bD(q)}C=f[x>>2]|0;if(((f[g+4>>2]|0)-(f[g>>2]|0)>>2|0)==((f[C+4>>2]|0)+2|0))D=C;else{f[q>>2]=0;f[q+4>>2]=0;s=aD(q,42)|0;t=415960;v=s+42|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,q,443206,414654,369);bD(q);D=f[x>>2]|0}f[q>>2]=119872;x=q+4|0;t=q+8|0;C=q+12|0;B=q+32|0;s=B;v=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));d[B+64>>1]=0;b[B+66>>0]=0;f[x>>2]=a;f[t>>2]=e;f[C>>2]=c;f[q+16>>2]=f[D>>2];c=f[D+4>>2]|0;C=q+20|0;f[C>>2]=c;f[q+24>>2]=f[D+8>>2];f[q+28>>2]=f[D+12>>2];f[C>>2]=(c|0)/(n|0)|0;c=f[i>>2]|0;f[B>>2]=c;B=f[y>>2]|0;f[q+36>>2]=B;C=f[j>>2]|0;f[q+40>>2]=C;D=f[j+4>>2]|0;f[q+44>>2]=D;f[q+48>>2]=f[k>>2];f[q+52>>2]=f[k+4>>2];f[q+56>>2]=f[l>>2];k=l+4|0;f[q+60>>2]=f[k>>2];f[q+64>>2]=n;f[q+68>>2]=o;j=f[w>>2]|0;w=f[j+12>>2]|0;e=f[j+8>>2]|0;t=(f[j+4>>2]|0)/(n|0)|0;b[q+96>>0]=(B|c|(D|C)|0)==0&1;C=(oO(10)|0)&1;b[q+97>>0]=C;C=(oO(11)|0)&1;b[q+98>>0]=C;C=(t|0)<64?t:64;D=q+72|0;c=Y(Y(f[i>>2]|0,C)|0,f[y>>2]|0)|0;B=q+76|0;n=f[B>>2]|0;j=f[D>>2]|0;a=n-j>>2;x=j;j=n;if(c>>>0<=a>>>0)if(c>>>0<a>>>0?(n=x+(c<<2)|0,(j|0)!=(n|0)):0){f[B>>2]=j+(~((j+-4-n|0)>>>2)<<2);E=x}else E=x;else{HC(D,c-a|0);E=f[D>>2]|0}if((t|0)>0){t=0;D=f[y>>2]|0;while(1){if((D|0)>0){a=Y(t,e)|0;c=0;x=f[i>>2]|0;n=D;while(1){if((x|0)>0){j=0;s=n;v=x;while(1){A=Y((Y(f[k>>2]|0,c)|0)+a|0,w)|0;z=A+(Y(f[l>>2]|0,j)|0)|0;A=E+((Y((Y(s,t)|0)+c|0,v)|0)+j<<2)|0;f[A>>2]=z;j=j+1|0;z=f[i>>2]|0;A=f[y>>2]|0;if((j|0)>=(z|0)){F=A;G=z;break}else{s=A;v=z}}}else{F=n;G=x}c=c+1|0;if((c|0)>=(F|0)){H=F;break}else{x=G;n=F}}}else H=D;t=t+1|0;if((t|0)>=(C|0))break;else D=H}}f[q+84>>2]=g;f[q+88>>2]=h;f[q+92>>2]=(f[h>>2]|0)==(f[h+4>>2]|0)?m:0;f[r>>2]=0;f[r+4>>2]=o;RQ(r,q,+(o|0));f[q>>2]=119872;o=f[q+72>>2]|0;if(!o){u=p;return}q=f[B>>2]|0;if((q|0)!=(o|0))f[B>>2]=q+(~((q+-4-o|0)>>>2)<<2);O5b(o);u=p;return}function Wbb(a){a=a|0;var b=0,c=0;f[a>>2]=119872;b=f[a+72>>2]|0;if(!b)return;c=a+76|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);O5b(b);return}function Xbb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=119872;b=f[a+72>>2]|0;if(!b){O5b(a);return}c=a+76|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);O5b(a);return}function Ybb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0;d=u;u=u+1072|0;e=d+1068|0;g=d+1064|0;h=d;i=f[a+64>>2]|0;j=f[a+4>>2]|0;k=f[j+40>>2]|0;l=Y(f[k>>2]|0,i)|0;m=f[a+12>>2]|0;o=f[m+40>>2]|0;p=f[o+12>>2]|0;q=(f[o+4>>2]|0)/(i|0)|0;r=f[k+12>>2]|0;s=f[k+8>>2]|0;t=(f[k+4>>2]|0)/(i|0)|0;k=f[a+68>>2]|0;v=f[a+32>>2]|0;w=f[a+36>>2]|0;x=f[a+40>>2]|0;y=f[a+44>>2]|0;z=f[a+48>>2]|0;A=f[a+52>>2]|0;B=f[a+56>>2]|0;C=f[a+60>>2]|0;D=Y(w,v)|0;E=Y(s,r)|0;F=Y(f[o+8>>2]|0,p)|0;f[e>>2]=F;o=(b[a+96>>0]|0)==0;G=f[c>>2]|0;H=f[c+4>>2]|0;if((k|0)<(l<<1|0)){c=(l+-1+k|0)/(k|0)|0;I=(c|0)>1?c:1;J=1;K=Y(I,G)|0;L=Y(I,H)|0;M=F}else{I=(k|0)/(l|0)|0;k=(((I+-1+F|0)>>>0)/(I>>>0)|0)+7&-8;f[g>>2]=k;J=I;K=G;L=H;M=F>>>0<k>>>0?f[e>>2]|0:k}f[g>>2]=M;M=f[j+16>>2]|0;j=f[a+72>>2]|0;k=f[a+8>>2]|0;F=f[k+16>>2]|0;H=((f[f[k+44>>2]>>2]|0)>>>0)/((1212424721>>>(f[k>>2]<<2&28)&15)>>>0)|0;k=f[a+84>>2]|0;G=f[k>>2]|0;if((f[k+4>>2]|0)==(G|0))d4b(k);k=G;G=f[a+88>>2]|0;I=f[G>>2]|0;c=(I|0)==(f[G+4>>2]|0)?0:I;I=f[m+16>>2]|0;m=D<<11|8;G=h+8|0;f[h>>2]=G;N=h+4|0;f[N>>2]=m;if(m>>>0>264){O=N5b(m>>>0>1073741823?-1:m<<2)|0;f[h>>2]=O;P=O}else P=G;O=P+31&-32;P=O;Nac(O|0,0,D<<13|0)|0;a:do if((K|0)<(L|0)){O=Y(t,E)|0;m=(t|0)>0;Q=a+92|0;R=(c|0)!=0;S=s-(Y(C,w+-1|0)|0)|0;T=C+-1|0;U=s+-1+C|0;V=z<<1;W=r-(Y(B,v+-1|0)|0)|0;X=B+-1|0;Z=r+-1+B|0;_=Y(C,r)|0;$=(q|0)>0;aa=~t;ba=~p;ca=K;da=K;do{ca=ca+1|0;ea=(da|0)/(J|0)|0;if((ea|0)>=(l|0))break a;fa=Y(ea,J)|0;ga=f[g>>2]|0;ha=Y(ga,da-fa|0)|0;ia=ha+ga|0;ja=f[e>>2]|0;ka=ja>>>0<ia>>>0?ja:ia;ia=M+((Y(O,ea)|0)<<2)|0;la=I+((Y(Y(ea,q)|0,ja)|0)<<2)|0;ma=Y((ea|0)%(i|0)|0,q)|0;ea=F+((Y(ma,H)|0)<<2)|0;na=k+(ma<<2)|0;if(m){oa=c+(ma<<2)|0;pa=(ka|0)>(ha|0);qa=Y(ga,ca-fa|0)|0;fa=~(ja>>>0>qa>>>0?qa:ja);ja=-33-ha|0;qa=0;ga=-1;ra=-65;while(1){sa=((Y(D,ga-((ra|0)>(aa|0)?ra:aa)|0)|0)+7|0)>>>3;ta=qa;qa=qa+64|0;ua=((t|0)<(qa|0)?t:qa)-ta|0;va=Y(ua,D)|0;wa=va+7&-8;xa=ea+((Y(ta,D)|0)<<2)|0;ya=R&(t|0)<=(qa|0)?oa:0;if(pa){za=Y(ta,s)|0;Aa=(va|0)>0;Ba=va<<2;Ca=(ua|0)>0;Da=(ya|0)!=0;Ea=(ta|0)==0;ta=ha;Fa=ja;while(1){Ga=(Fa|0)<(fa|0)?fa:Fa;Ha=ta;ta=ta+32|0;Ia=(ka|0)<(ta|0)?ka:ta;Ja=(Ha|0)/(p|0)|0;if((Ia|0)>(Ha|0)){Ka=Ha;La=Ja;Ma=Ha-(Y(Ja,p)|0)|0;Ja=P;while(1){Na=Ia-Ka|0;Oa=p-Ma|0;Pa=(Oa|0)<(Na|0)?Oa:Na;Na=Pa+Ma|0;Oa=(Y(La,A)|0)-y|0;Qa=(Y(Ma,z)|0)-x|0;Ra=ia+((Y(Oa+za|0,r)|0)<<2)+(Qa<<2)|0;do if(o){Sa=(Oa|0)>-1&(Oa|0)<(S|0);Ta=(T-Oa|0)/(C|0)|0;Ua=(Ta|0)>0?Ta:0;Ta=(U-Oa|0)/(C|0)|0;Va=(Ta|0)<(w|0)?Ta:w;if((Pa|0)>0){Ta=(Ua|0)<(Va|0);Wa=Ra;Xa=Ma;Ya=Ja;Za=Qa;while(1){do if(Sa){if((Za|0)<0|(Xa+2|0)>(Na|0)|(Za+V|0)>(W|0)){_a=34;break}if(Aa){$a=0;do{ab=f[j+($a<<2)>>2]|0;bb=f[Wa+(ab+z<<2)>>2]|0;f[Ya+($a<<2)>>2]=f[Wa+(ab<<2)>>2];f[Ya+($a+wa<<2)>>2]=bb;$a=$a+1|0}while(($a|0)<(va|0))}cb=Za+z|0;db=Wa+(z<<2)|0;eb=Xa+1|0;fb=Ya+(wa<<2)|0}else _a=34;while(0);do if((_a|0)==34){_a=0;$a=(X-Za|0)/(B|0)|0;bb=($a|0)>0?$a:0;$a=(Z-Za|0)/(B|0)|0;ab=($a|0)<(v|0)?$a:v;Nac(Ya|0,0,Ba|0)|0;if(!Ca){cb=Za;db=Wa;eb=Xa;fb=Ya;break}$a=(bb|0)<(ab|0);if(Ta)gb=0;else{cb=Za;db=Wa;eb=Xa;fb=Ya;break}do{hb=Y(gb,E)|0;ib=Y(gb,w)|0;if($a){jb=Ua;do{kb=(Y(_,jb)|0)+hb|0;lb=Y(jb+ib|0,v)|0;mb=bb;do{nb=Wa+(kb+(Y(mb,B)|0)<<2)|0;f[Ya+(mb+lb<<2)>>2]=f[nb>>2];mb=mb+1|0}while((mb|0)<(ab|0));jb=jb+1|0}while((jb|0)<(Va|0))}gb=gb+1|0}while((gb|0)<(ua|0));cb=Za;db=Wa;eb=Xa;fb=Ya}while(0);Xa=eb+1|0;ab=fb+(wa<<2)|0;if((Xa|0)>=(Na|0)){ob=ab;break}else{Wa=db+(z<<2)|0;Ya=ab;Za=cb+z|0}}}else ob=Ja}else if((Pa|0)>0){if(Aa){pb=Ra;qb=Ma;rb=Ja}else{Za=Ma+ba|0;Ya=Ga+Ka|0;Wa=Ma+-1-((Za|0)>(Ya|0)?Za:Ya)|0;Ya=Ma+1|0;ob=Ja+(Y(sa,((Wa|0)>(Ya|0)?Wa:Ya)-Ma<<5)|0)|0;break}while(1){Ya=0;do{Wa=pb+((Y(Ya,E)|0)<<2)|0;f[rb+(Ya<<2)>>2]=f[Wa>>2];Ya=Ya+1|0}while((Ya|0)<(va|0));qb=qb+1|0;Ya=rb+(wa<<2)|0;if((qb|0)>=(Na|0)){ob=Ya;break}else{pb=pb+(z<<2)|0;rb=Ya}}}else ob=Ja;while(0);Ka=Pa+Ka|0;if((Ia|0)<=(Ka|0))break;else{La=La+1|0;Ma=0;Ja=ob}}}Ja=Ia-Ha|0;if($){Ma=la+(Ha<<2)|0;La=(Ja|0)>0;Ka=0;do{Ga=xa+((Y(Ka,H)|0)<<2)|0;Na=f[e>>2]|0;Ra=Ma+((Y(Na,Ka)|0)<<2)|0;sb=+n[na+(Ka<<2)>>2];Qa=Ka|1;Oa=(Qa|0)<(q|0);Ya=Oa?Ga+(H<<2)|0:Ga;Wa=Oa?Ra+(Na<<2)|0:Ra;tb=Oa?+n[na+(Qa<<2)>>2]:sb;if(Da){ub=+n[ya+(Qa<<2)>>2];vb=+n[ya+(Ka<<2)>>2]}else{ub=1.0;vb=1.0}if(La)if(Ea){Qa=0;do{Oa=P+((Y(Qa,wa)|0)<<2)|0;if(Aa){wb=sb;xb=tb;Na=0;while(1){yb=+n[Oa+(Na<<2)>>2];zb=wb+yb*+n[Ga+(Na<<2)>>2];Ab=xb+yb*+n[Ya+(Na<<2)>>2];Na=Na+1|0;if((Na|0)>=(va|0)){Bb=Ab;Cb=zb;break}else{wb=zb;xb=Ab}}}else{Bb=tb;Cb=sb}n[Ra+(Qa<<2)>>2]=Da?(Cb>0.0?Cb:vb*Cb):Cb;n[Wa+(Qa<<2)>>2]=Da?(Bb>0.0?Bb:ub*Bb):Bb;Qa=Qa+1|0}while((Qa|0)<(Ja|0))}else{Qa=0;do{Pa=P+((Y(Qa,wa)|0)<<2)|0;Na=Wa+(Qa<<2)|0;Oa=Ra+(Qa<<2)|0;sb=+n[Oa>>2];tb=+n[Na>>2];if(Aa){xb=sb;wb=tb;Za=0;while(1){Ab=+n[Pa+(Za<<2)>>2];zb=xb+Ab*+n[Ga+(Za<<2)>>2];yb=wb+Ab*+n[Ya+(Za<<2)>>2];Za=Za+1|0;if((Za|0)>=(va|0)){Db=yb;Eb=zb;break}else{xb=zb;wb=yb}}}else{Db=tb;Eb=sb}n[Oa>>2]=Da?(Eb>0.0?Eb:vb*Eb):Eb;n[Na>>2]=Da?(Db>0.0?Db:ub*Db):Db;Qa=Qa+1|0}while((Qa|0)<(Ja|0))}Ka=Ka+2|0}while((Ka|0)<(q|0))}if((ta|0)>=(ka|0))break;else Fa=Fa+-32|0}}if((qa|0)>=(t|0))break;else{ga=ga+-64|0;ra=ra+-64|0}}}ra=f[Q>>2]|0;if(ra|0){ga=la+(ha<<2)|0;Qh[f[(f[ra>>2]|0)+92>>2]&127](ra,ga,ga,ka-ha|0,f[e>>2]|0,ma,ma+q|0)}da=da+1|0}while((da|0)<(L|0))}while(0);L=f[h>>2]|0;if((L|0)==(G|0)){u=d;return}if(L|0)P5b(L);f[h>>2]=G;f[N>>2]=264;u=d;return}function Zbb(a){a=a|0;f[a>>2]=119892;bD(a+76|0);lua(a);return}function _bb(a){a=a|0;f[a>>2]=119892;bD(a+76|0);lua(a);O5b(a);return}function $bb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=L5b(200)|0;Jwa(e);g=e+36|0;h=g+48|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=119992;f[e+88>>2]=1124007936;i=e+96|0;j=e+128|0;g=e+92|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[j>>2]=i;i=e+136|0;f[e+132>>2]=i;f[i>>2]=0;f[e+140>>2]=0;f[e+144>>2]=1124007936;i=e+152|0;j=e+184|0;g=e+148|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[j>>2]=i;i=e+192|0;f[e+188>>2]=i;f[i>>2]=0;f[e+196>>2]=0;i=L5b(16)|0;j=i+4|0;f[j>>2]=1;f[i>>2]=120096;f[i+8>>2]=e;f[a>>2]=i;f[a+4>>2]=e;f[d>>2]=i;f[d+4>>2]=e;f[j>>2]=(f[j>>2]|0)+1;Dbb(d,b);b=f[d>>2]|0;if(!b){u=c;return}d=b+4|0;j=f[d>>2]|0;f[d>>2]=j+-1;if((j|0)!=1){u=c;return}bi[f[(f[b>>2]|0)+8>>2]&2047](b);u=c;return}function acb(a){a=a|0;O5b(a);return}function bcb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ccb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=119992;b=a+144|0;c=a+180|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+160|0;b=a+148|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+184>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+188>>2]|0;if((b|0)!=(a+192|0))UC(b);b=a+88|0;d=a+124|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+104|0;b=a+92|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+128>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+132>>2]|0;if((b|0)==(a+136|0)){f[a>>2]=119892;g=a+76|0;bD(g);lua(a);return}UC(b);f[a>>2]=119892;g=a+76|0;bD(g);lua(a);return}function dcb(a){a=a|0;ccb(a);O5b(a);return}function ecb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0;g=u;u=u+640|0;h=g+576|0;i=g+568|0;j=g+512|0;k=g+456|0;l=g;m=g+400|0;n=g+344|0;o=g+288|0;p=g+232|0;q=g+224|0;dQ(i,120140);r=f[a+84>>2]|0;s=f[(f[(f[f[c>>2]>>2]|0)+40>>2]|0)+4>>2]|0;t=a+40|0;if(((((f[t>>2]|0)==1?(f[a+36>>2]|0)==1:0)?(f[a+48>>2]|0)==1:0)?(f[a+44>>2]|0)==1:0)?(f[a+64>>2]|0)==1:0)v=(f[a+60>>2]|0)==1;else v=0;w=SQ()|0;x=a+88|0;if(f[a+104>>2]|0){y=f[a+92>>2]|0;if((y|0)<3)z=Y(f[a+100>>2]|0,f[a+96>>2]|0)|0;else{A=f[a+128>>2]|0;B=0;C=1;while(1){D=Y(f[A+(B<<2)>>2]|0,C)|0;B=B+1|0;if((B|0)==(y|0)){z=D;break}else C=D}}if((y|0)==0|(z|0)==0)E=17}else E=17;if((E|0)==17){WL(j,f[a+4>>2]|0,1,s);f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=j;z=k+8|0;f[z>>2]=0;f[z+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=x;ZL(h,k);z=j+36|0;y=f[z>>2]|0;if(y|0?(C=y+12|0,y=f[C>>2]|0,f[C>>2]=y+-1,(y|0)==1):0)kL(j);f[z>>2]=0;z=j+16|0;y=j+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[y>>2]|0)>0){z=f[j+40>>2]|0;C=0;do{f[z+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[y>>2]|0))}y=f[j+44>>2]|0;if((y|0)!=(j+48|0))UC(y);y=f[a+4>>2]|0;if((((f[a+8>>2]|0)-y|0)/56|0)>>>0>1){WL(h,y+56|0,1,r);F=0}else{QS(l,r,1,5);f[h>>2]=1124007936;y=h+8|0;C=h+40|0;z=h+4|0;B=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(B|0));f[C>>2]=y;y=h+48|0;f[h+44>>2]=y;f[y>>2]=0;f[h+52>>2]=0;y=f[l>>2]|0;th[f[(f[y>>2]|0)+12>>2]&511](y,l,h,-1);F=1}y=a+144|0;C=h+36|0;z=f[C>>2]|0;if((y|0)==(h|0))G=z;else{if(z|0){B=z+12|0;f[B>>2]=(f[B>>2]|0)+1}B=a+180|0;z=f[B>>2]|0;if(z|0?(A=z+12|0,z=f[A>>2]|0,f[A>>2]=z+-1,(z|0)==1):0)kL(y);f[B>>2]=0;z=a+160|0;A=a+148|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[A>>2]|0)>0){D=f[a+184>>2]|0;H=0;do{f[D+(H<<2)>>2]=0;H=H+1|0;I=f[A>>2]|0}while((H|0)<(I|0));f[y>>2]=f[h>>2];if((I|0)<3)E=39;else E=41}else{f[y>>2]=f[h>>2];E=39}if((E|0)==39){I=f[h+4>>2]|0;if((I|0)<3){f[A>>2]=I;f[a+152>>2]=f[h+8>>2];f[a+156>>2]=f[h+12>>2];I=f[h+44>>2]|0;A=f[a+188>>2]|0;f[A>>2]=f[I>>2];f[A+4>>2]=f[I+4>>2]}else E=41}if((E|0)==41)jL(y,h);f[z>>2]=f[h+16>>2];f[a+164>>2]=f[h+20>>2];f[a+168>>2]=f[h+24>>2];f[a+172>>2]=f[h+28>>2];f[a+176>>2]=f[h+32>>2];z=f[C>>2]|0;f[B>>2]=z;G=z}if(G|0?(z=G+12|0,G=f[z>>2]|0,f[z>>2]=G+-1,(G|0)==1):0)kL(h);f[C>>2]=0;C=h+16|0;G=h+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[G>>2]|0)>0){C=f[h+40>>2]|0;z=0;do{f[C+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[G>>2]|0))}G=f[h+44>>2]|0;if((G|0)!=(h+48|0))UC(G);if(F)Wi(l)}l=d+4|0;if((f[l>>2]|0)!=(f[d>>2]|0)){F=a+4|0;G=k+36|0;z=k+16|0;C=k+4|0;B=k+40|0;y=k+44|0;E=k+48|0;I=j+36|0;A=j+16|0;H=j+4|0;D=j+40|0;J=j+44|0;K=j+48|0;L=n+4|0;M=h+4|0;N=o+4|0;O=h+4|0;P=p+4|0;Q=h+4|0;R=a+144|0;S=q+4|0;T=h+4|0;U=h+4|0;V=h+8|0;W=h+12|0;X=h+16|0;Z=h+20|0;_=h+21|0;$=q+4|0;aa=+(w|0);ba=a+36|0;ca=a+56|0;da=a+52|0;ea=a+48|0;fa=a+44|0;a=m+16|0;ga=m+44|0;ha=p+16|0;ia=p+44|0;ja=p+36|0;ka=p+4|0;la=p+40|0;ma=p+48|0;na=o+36|0;oa=o+16|0;pa=o+4|0;qa=o+40|0;ra=o+44|0;sa=o+48|0;ta=n+36|0;ua=n+16|0;va=n+4|0;wa=n+40|0;xa=n+44|0;ya=n+48|0;za=m+36|0;Aa=m+4|0;Ba=m+40|0;Ca=m+48|0;Da=0;Ea=f[d>>2]|0;do{Fa=f[(f[(f[F>>2]|0)+40>>2]|0)+4>>2]|0;Ga=(r|0)/(Fa|0)|0;Ha=(s|0)/(Ga|0)|0;Ia=f[(f[c>>2]|0)+(Da<<2)>>2]|0;Ja=f[f[Ia+40>>2]>>2]|0;Ka=f[Ea+(Da*56|0)+40>>2]|0;La=f[Ka+8>>2]|0;Ma=f[Ka+12>>2]|0;WL(j,Ia,1,Y(Ja,s)|0);WL(k,Ea+(Da*56|0)|0,1,Y(Ja,r)|0);if((Ja|0)>0){Ia=(Ga|0)>0;Ka=0;do{if(Ia){Na=Y(Ka,Ga)|0;Oa=0;do{Pa=Oa+Na|0;Qa=Y(Pa,Fa)|0;f[n>>2]=Qa;f[L>>2]=Qa+Fa;f[h>>2]=-2147483648;f[M>>2]=2147483647;lL(m,k,n,h);Qa=v?m:f[e>>2]|0;Ra=Y(Pa,Ha)|0;f[o>>2]=Ra;f[N>>2]=Ra+Ha;f[h>>2]=-2147483648;f[O>>2]=2147483647;lL(n,j,o,h);Ra=Y(Oa,Ha)|0;f[p>>2]=Ra;f[P>>2]=Ra+Ha;f[h>>2]=-2147483648;f[Q>>2]=2147483647;lL(o,x,h,p);Ra=Y(Oa,Fa)|0;f[q>>2]=Ra;f[S>>2]=Ra+Fa;f[h>>2]=-2147483648;f[T>>2]=2147483647;lL(p,R,q,h);f[h>>2]=120180;f[U>>2]=o;f[V>>2]=n;f[W>>2]=Qa;f[X>>2]=w;Ra=(oO(10)|0)&1;b[Z>>0]=Ra;Ra=(oO(11)|0)&1;b[_>>0]=Ra;f[q>>2]=0;f[$>>2]=w;RQ(q,h,aa);kcb(f[Qa+16>>2]|0,Fa,La,Ma,f[t>>2]|0,f[ba>>2]|0,f[ca>>2]|0,f[da>>2]|0,f[ea>>2]|0,f[fa>>2]|0,f[a>>2]|0,f[ha>>2]|0,v);Qa=f[ja>>2]|0;if(Qa|0?(Ra=Qa+12|0,Qa=f[Ra>>2]|0,f[Ra>>2]=Qa+-1,(Qa|0)==1):0)kL(p);f[ja>>2]=0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ka>>2]|0)>0){Qa=f[la>>2]|0;Ra=0;do{f[Qa+(Ra<<2)>>2]=0;Ra=Ra+1|0}while((Ra|0)<(f[ka>>2]|0))}Ra=f[ia>>2]|0;if((Ra|0)!=(ma|0))UC(Ra);Ra=f[na>>2]|0;if(Ra|0?(Qa=Ra+12|0,Ra=f[Qa>>2]|0,f[Qa>>2]=Ra+-1,(Ra|0)==1):0)kL(o);f[na>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[pa>>2]|0)>0){Ra=f[qa>>2]|0;Qa=0;do{f[Ra+(Qa<<2)>>2]=0;Qa=Qa+1|0}while((Qa|0)<(f[pa>>2]|0))}Qa=f[ra>>2]|0;if((Qa|0)!=(sa|0))UC(Qa);Qa=f[ta>>2]|0;do if(Qa|0){Ra=Qa+12|0;Pa=f[Ra>>2]|0;f[Ra>>2]=Pa+-1;if((Pa|0)!=1)break;kL(n)}while(0);f[ta>>2]=0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;if((f[va>>2]|0)>0){Qa=f[wa>>2]|0;Pa=0;do{f[Qa+(Pa<<2)>>2]=0;Pa=Pa+1|0}while((Pa|0)<(f[va>>2]|0))}Pa=f[xa>>2]|0;if((Pa|0)!=(ya|0))UC(Pa);Pa=f[za>>2]|0;do if(Pa|0){Qa=Pa+12|0;Ra=f[Qa>>2]|0;f[Qa>>2]=Ra+-1;if((Ra|0)!=1)break;kL(m)}while(0);f[za>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[Aa>>2]|0)>0){Pa=f[Ba>>2]|0;Ra=0;do{f[Pa+(Ra<<2)>>2]=0;Ra=Ra+1|0}while((Ra|0)<(f[Aa>>2]|0))}Ra=f[ga>>2]|0;if((Ra|0)!=(Ca|0))UC(Ra);Oa=Oa+1|0}while((Oa|0)<(Ga|0))}Ka=Ka+1|0}while((Ka|0)<(Ja|0))}Ja=f[G>>2]|0;if(Ja|0?(Ka=Ja+12|0,Ja=f[Ka>>2]|0,f[Ka>>2]=Ja+-1,(Ja|0)==1):0)kL(k);f[G>>2]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[C>>2]|0)>0){Ja=f[B>>2]|0;Ka=0;do{f[Ja+(Ka<<2)>>2]=0;Ka=Ka+1|0}while((Ka|0)<(f[C>>2]|0))}Ka=f[y>>2]|0;if((Ka|0)!=(E|0))UC(Ka);Ka=f[I>>2]|0;if(Ka|0?(Ja=Ka+12|0,Ka=f[Ja>>2]|0,f[Ja>>2]=Ka+-1,(Ka|0)==1):0)kL(j);f[I>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[H>>2]|0)>0){Ka=f[D>>2]|0;Ja=0;do{f[Ka+(Ja<<2)>>2]=0;Ja=Ja+1|0}while((Ja|0)<(f[H>>2]|0))}Ja=f[J>>2]|0;if((Ja|0)!=(K|0))UC(Ja);Da=Da+1|0;Ea=f[d>>2]|0}while(Da>>>0<(((f[l>>2]|0)-Ea|0)/56|0)>>>0)}if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function fcb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,120108);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function gcb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function hcb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+48|0;h=d+32|0;i=d+16|0;j=d;k=a+4|0;l=a+8|0;m=f[k>>2]|0;n=m;if((((f[l>>2]|0)-m|0)/56|0)>>>0>1){m=f[n+60>>2]|0;if((m|0)<3)o=Y(f[n+68>>2]|0,f[n+64>>2]|0)|0;else{p=f[n+96>>2]|0;n=0;q=1;while(1){r=Y(f[p+(n<<2)>>2]|0,q)|0;n=n+1|0;if((n|0)==(m|0)){o=r;break}else q=r}}if((o|0)!=(f[a+84>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;s=aD(h,51)|0;t=416769;v=s+51|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,h,442770,414654,1055);bD(h)}}o=c+4|0;q=f[c>>2]|0;if((f[o>>2]|0)==(q|0)){f[h>>2]=0;f[h+4>>2]=0;s=aD(h,18)|0;t=442751;v=s+18|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,h,442770,414654,1056);bD(h);w=c;x=f[c>>2]|0}else{w=c;x=q}q=f[x>>2]|0;x=f[q+4>>2]|0;c=a+48|0;m=Y(f[c>>2]|0,(f[q+8>>2]|0)+-1|0)|0;n=a+40|0;p=m+(f[n>>2]|0)-(f[a+56>>2]<<1)+(f[a+72>>2]|0)|0;m=a+44|0;r=Y(f[m>>2]|0,(f[q+12>>2]|0)+-1|0)|0;q=a+36|0;y=r+(f[q>>2]|0)-(f[a+52>>2]<<1)+(f[a+68>>2]|0)|0;r=f[a+84>>2]|0;z=a+4|0;A=f[(f[z>>2]|0)+40>>2]|0;B=f[A+4>>2]|0;if(!((r|0)%(B|0)|0)){C=A;D=B}else{f[h>>2]=0;f[h+4>>2]=0;s=aD(h,29)|0;t=416821;v=s+29|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,h,442770,414654,1066);bD(h);B=f[(f[z>>2]|0)+40>>2]|0;C=B;D=f[B+4>>2]|0}B=(r|0)/(D|0)|0;if(((x|0)%(B|0)|0|0)==0?((r|0)%(B|0)|0|0)==0:0)E=C;else{f[h>>2]=0;f[h+4>>2]=0;s=aD(h,44)|0;t=416851;v=s+44|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,h,442770,414654,1069);bD(h);E=f[(f[z>>2]|0)+40>>2]|0}if((f[E>>2]|0)!=(x|0)){f[h>>2]=0;f[h+4>>2]=0;s=aD(h,25)|0;t=416896;v=s+25|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,h,442770,414654,1070);bD(h)}t=f[w>>2]|0;f[i>>2]=f[f[t>>2]>>2];f[i+4>>2]=r;f[i+8>>2]=p;f[i+12>>2]=y;r=((f[o>>2]|0)-t|0)/12|0;f[h>>2]=0;t=h+4|0;f[t>>2]=0;f[h+8>>2]=0;Rva(h,i,i+16|0);i=e+4|0;o=f[i>>2]|0;s=f[e>>2]|0;v=(o-s|0)/12|0;x=s;s=o;if(r>>>0<=v>>>0){if(r>>>0<v>>>0?(o=x+(r*12|0)|0,(s|0)!=(o|0)):0){x=s;while(1){s=x+-12|0;f[i>>2]=s;E=f[s>>2]|0;if(!E)F=s;else{s=x+-8|0;z=f[s>>2]|0;if((z|0)!=(E|0))f[s>>2]=z+(~((z+-4-E|0)>>>2)<<2);O5b(E);F=f[i>>2]|0}if((F|0)==(o|0))break;else x=F}}}else sbb(e,r-v|0,h);v=f[h>>2]|0;if(v|0){r=f[t>>2]|0;if((r|0)!=(v|0))f[t>>2]=r+(~((r+-4-v|0)>>>2)<<2);O5b(v)}f[h>>2]=0;v=h+4|0;f[v>>2]=0;f[h+8>>2]=0;r=g+4|0;t=f[r>>2]|0;F=g+8|0;if((t|0)==(f[F>>2]|0)){Sva(g,h);G=f[h>>2]|0}else{f[t>>2]=0;x=t+4|0;f[x>>2]=0;f[t+8>>2]=0;o=f[h>>2]|0;i=(f[v>>2]|0)-o|0;E=i>>2;if(E){if(E>>>0>1073741823)c4b(t);z=L5b(i)|0;f[x>>2]=z;f[t>>2]=z;f[t+8>>2]=z+(E<<2);E=f[h>>2]|0;t=(f[v>>2]|0)-E|0;if((t|0)>0){Vac(z|0,E|0,t|0)|0;f[x>>2]=z+(t>>>2<<2);H=E}else H=E}else H=o;f[r>>2]=(f[r>>2]|0)+12;G=H}if(G|0){H=f[v>>2]|0;if((H|0)!=(G|0))f[v>>2]=H+(~((H+-4-G|0)>>>2)<<2);O5b(G)}if(!((((((f[n>>2]|0)==1?(f[q>>2]|0)==1:0)?(f[c>>2]|0)==1:0)?(f[m>>2]|0)==1:0)?(f[a+64>>2]|0)==1:0)?(f[a+60>>2]|0)==1:0)){th[f[(f[a>>2]|0)+92>>2]&511](h,a,f[w>>2]|0,f[e>>2]|0);e=f[g>>2]|0;if((e|0)!=(h|0))r2(e,f[h>>2]|0,f[h+4>>2]|0);e=f[h>>2]|0;if(e|0){w=h+4|0;a=f[w>>2]|0;if((a|0)!=(e|0))f[w>>2]=a+(~((a+-4-e|0)>>>2)<<2);O5b(e)}}if((((f[l>>2]|0)-(f[k>>2]|0)|0)/56|0)>>>0<=1){u=d;return 0}k=Y(y,p)|0;f[h>>2]=1;f[h+4>>2]=k;f[h+8>>2]=-1;f[h+12>>2]=-1;f[j>>2]=0;k=j+4|0;f[k>>2]=0;f[j+8>>2]=0;Rva(j,h,h+16|0);h=f[j>>2]|0;p=f[k>>2]|0;a:do if((h|0)==(p|0)){I=h;J=60}else{y=h;do{if((f[y>>2]|0)<0){I=y;J=60;break a}y=y+4|0}while((y|0)!=(p|0))}while(0);if((J|0)==60?(I|0)!=(p|0):0){J=I+4|0;if((J|0)==(p|0)){K=p;L=I}else{h=J;J=I;while(1){I=f[h>>2]|0;if((I|0)<0)M=J;else{f[J>>2]=I;M=J+4|0}h=h+4|0;if((h|0)==(p|0))break;else J=M}K=f[k>>2]|0;L=M}if((L|0)!=(K|0))f[k>>2]=K+(~((K+-4-L|0)>>>2)<<2)}L=f[r>>2]|0;if((L|0)==(f[F>>2]|0)){Sva(g,j);N=f[j>>2]|0}else{f[L>>2]=0;g=L+4|0;f[g>>2]=0;f[L+8>>2]=0;F=f[j>>2]|0;K=(f[k>>2]|0)-F|0;M=K>>2;if(M){if(M>>>0>1073741823)c4b(L);J=L5b(K)|0;f[g>>2]=J;f[L>>2]=J;f[L+8>>2]=J+(M<<2);M=f[j>>2]|0;j=(f[k>>2]|0)-M|0;if((j|0)>0){Vac(J|0,M|0,j|0)|0;f[g>>2]=J+(j>>>2<<2);O=M}else O=M}else O=F;f[r>>2]=(f[r>>2]|0)+12;N=O}if(N|0){O=f[k>>2]|0;if((O|0)!=(N|0))f[k>>2]=O+(~((O+-4-N|0)>>>2)<<2);O5b(N)}u=d;return 0}function icb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+16|0;g=e;h=c+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i-j|0)==((f[d+4>>2]|0)-(f[d>>2]|0)|0)){k=j;l=i}else{f[g>>2]=0;f[g+4>>2]=0;m=aD(g,31)|0;n=414902;o=m+31|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,g,427670,414654,1437);bD(g);k=f[c>>2]|0;l=f[h>>2]|0}if((l|0)==(k|0)){p=0;q=0;J=p;u=e;return q|0}i=f[f[(f[a+4>>2]|0)+40>>2]>>2]|0;j=$ac(i|0,((i|0)<0)<<31>>31|0,1)|0;i=J;d=a+36|0;r=a+40|0;a=g+4|0;s=0.0;t=0;v=k;k=l;while(1){l=v;w=Y(f[r>>2]|0,f[d>>2]|0)|0;x=cbc(j|0,i|0,w|0,((w|0)<0)<<31>>31|0)|0;w=J;y=f[l+(t*12|0)+4>>2]|0;z=f[l+(t*12|0)>>2]|0;l=y-z|0;A=l>>2;B=z;do if((B|0)!=(y|0)){if((l|0)<=-4){f[g>>2]=0;f[a>>2]=0;m=aD(g,70)|0;n=442586;o=m+70|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,g,442657,442663,160);bD(g);C=1;D=f[c>>2]|0;E=f[h>>2]|0;break}if((l|0)>0){z=0;F=1;while(1){G=Y(f[B+(z<<2)>>2]|0,F)|0;z=z+1|0;if((z|0)>=(A|0)){C=G;D=v;E=k;break}else F=G}}else{C=1;D=v;E=k}}else{C=0;D=v;E=k}while(0);A=cbc(x|0,w|0,C|0,((C|0)<0)<<31>>31|0)|0;s=s+(+(A>>>0)+4294967296.0*+(J|0));t=t+1|0;if(t>>>0>=((E-D|0)/12|0)>>>0)break;else{v=D;k=E}}p=+L(s)>=1.0?(s>0.0?~~+Z(+K(s/4294967296.0),4294967295.0)>>>0:~~+X((s-+(~~s>>>0))/4294967296.0)>>>0):0;q=~~s>>>0;J=p;u=e;return q|0}function jcb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;c=Y(f[b+40>>2]|0,(f[(f[d>>2]|0)+4>>2]|0)/((f[h+4>>2]|0)/(f[f[(f[b+4>>2]|0)+40>>2]>>2]|0)|0|0)|0)|0;d=Y(c,f[b+36>>2]|0)|0;b=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;f[g>>2]=d;f[g+4>>2]=b;f[g+8>>2]=-1;f[g+12>>2]=-1;f[a>>2]=0;b=a+4|0;f[b>>2]=0;f[a+8>>2]=0;Rva(a,g,g+16|0);g=f[a>>2]|0;a=f[b>>2]|0;a:do if((g|0)==(a|0))i=g;else{d=g;do{if((f[d>>2]|0)<0){i=d;break a}d=d+4|0}while((d|0)!=(a|0));u=e;return}while(0);if((i|0)==(a|0)){u=e;return}g=i+4|0;if((g|0)==(a|0)){j=a;k=i}else{d=g;g=i;while(1){i=f[d>>2]|0;if((i|0)<0)l=g;else{f[g>>2]=i;l=g+4|0}d=d+4|0;if((d|0)==(a|0))break;else g=l}j=f[b>>2]|0;k=l}if((k|0)==(j|0)){u=e;return}f[b>>2]=j+(~((j+-4-k|0)>>>2)<<2);u=e;return}function kcb(a,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0;p=u;u=u+80|0;q=p+8|0;r=p;s=SQ()|0;f[q>>2]=120200;f[q+4>>2]=a;f[q+48>>2]=m;f[q+12>>2]=c;f[q+16>>2]=d;f[q+20>>2]=e;f[q+24>>2]=g;f[q+28>>2]=h;f[q+32>>2]=i;f[q+36>>2]=j;f[q+40>>2]=k;f[q+44>>2]=l;f[q+52>>2]=((d-g+(i<<1)|0)/(k|0)|0)+1;f[q+56>>2]=((e-h+(j<<1)|0)/(l|0)|0)+1;f[q+60>>2]=s;b[q+64>>0]=o&1;f[q+8>>2]=n;f[r>>2]=0;f[r+4>>2]=s;RQ(r,q,+(s|0));u=p;return}function lcb(a){a=a|0;O5b(a);return}function mcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=f[a+4>>2]|0;e=f[a+48>>2]|0;g=f[a+40>>2]|0;h=f[a+28>>2]|0;i=Y(h,g)|0;j=f[a+52>>2]|0;k=1-(Y(i,j)|0)|0;i=f[a+56>>2]|0;l=Y(k,i)|0;k=f[a+44>>2]|0;m=Y(i,j)|0;o=1-(Y(m,k)|0)|0;p=f[a+16>>2]|0;q=Y(p,f[a+12>>2]|0)|0;r=f[a+20>>2]|0;s=Y(q,r)|0;q=f[a+60>>2]|0;t=((q+-1+s|0)>>>0)/(q>>>0)|0;q=Y(f[c>>2]|0,t)|0;u=Y(f[c+4>>2]|0,t)|0;t=s>>>0<u>>>0?s:u;u=f[a+36>>2]|0;s=u+((q>>>0)%(r>>>0)|0)|0;c=f[a+32>>2]|0;v=c+((((q>>>0)/(r>>>0)|0)>>>0)%(p>>>0)|0)|0;w=Y(r,p)|0;x=(q>>>0)/(w>>>0)|0;y=f[a+24>>2]|0;if((v|0)<(y|0))z=0;else z=((v-y|0)/(g|0)|0)+1|0;A=((v|0)/(g|0)|0)+1|0;B=(b[a+64>>0]|0)==0;C=f[a+8>>2]|0;if(q>>>0>=t>>>0)return;a=Y((Y((Y(y,x)|0)+v|0,h)|0)+s|0,m)|0;v=u+r|0;D=s;s=q;q=x;x=z;z=a;a=(j|0)<(A|0)?j:A;while(1){if((D|0)<(h|0))E=0;else E=((D-h|0)/(k|0)|0)+1|0;A=((D|0)/(k|0)|0)+1|0;F=(i|0)<(A|0)?i:A;if(B)if((x|0)<(a|0)&(E|0)<(F|0)){A=x;G=0.0;while(1){H=(Y(l,A)|0)+z|0;I=E;J=G;do{K=d+(H+(Y(I,o)|0)<<2)|0;J=J+ +n[K>>2];I=I+1|0}while((I|0)<(F|0));A=A+1|0;if((A|0)==(a|0)){L=J;break}else G=J}}else L=0.0;else L=+n[e+(s<<2)>>2];n[e+(s<<2)>>2]=L+ +n[C+(q<<2)>>2];A=D+1|0;if((A|0)<(v|0)){M=A;N=q;O=x;P=z+m|0;Q=a;R=s+1|0}else{A=s+1|0;F=((A>>>0)%(r>>>0)|0)+u|0;I=c+((((A>>>0)/(r>>>0)|0)>>>0)%(p>>>0)|0)|0;H=(A>>>0)/(w>>>0)|0;if((I|0)<(y|0))S=0;else S=((I-y|0)/(g|0)|0)+1|0;K=((I|0)/(g|0)|0)+1|0;M=F;N=H;O=S;P=Y((Y((Y(y,H)|0)+I|0,h)|0)+F|0,m)|0;Q=(j|0)<(K|0)?j:K;R=A}if(R>>>0<t>>>0){D=M;s=R;q=N;x=O;z=P;a=Q}else break}return}function ncb(a){a=a|0;O5b(a);return}function ocb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;c=f[a+8>>2]|0;d=f[c+12>>2]|0;e=f[a+16>>2]|0;g=((d+-1+e|0)/(e|0)|0)+15&-16;e=Y(g,f[b>>2]|0)|0;h=Y(f[b+4>>2]|0,g)|0;g=f[a+4>>2]|0;b=f[g+8>>2]|0;i=((d|0)<(h|0)?d:h)-e|0;h=f[g+12>>2]|0;d=f[g+16>>2]|0;j=(f[c+16>>2]|0)+(e<<2)|0;k=f[a+12>>2]|0;a=(f[k+16>>2]|0)+(e<<2)|0;e=((f[f[g+44>>2]>>2]|0)>>>0)/((1212424721>>>(f[g>>2]<<2&28)&15)>>>0)|0;g=((f[f[c+44>>2]>>2]|0)>>>0)/((1212424721>>>(f[c>>2]<<2&28)&15)>>>0)|0;c=((f[f[k+44>>2]>>2]|0)>>>0)/((1212424721>>>(f[k>>2]<<2&28)&15)>>>0)|0;if((b|0)<=0)return;k=b+-1|0;b=(i|0)>0;l=k>>>1;m=(h|0)<1|b^1;o=0;p=0;while(1){q=a+((Y(o,c)|0)<<2)|0;r=o|1;s=(k|0)<(r|0)?k:r;r=a+((Y(s,c)|0)<<2)|0;t=d+((Y(o,e)|0)<<2)|0;u=d+((Y(s,e)|0)<<2)|0;if(b){s=0;do{n[q+(s<<2)>>2]=0.0;n[r+(s<<2)>>2]=0.0;s=s+1|0}while((s|0)<(i|0))}if(!m){s=0;do{v=+n[t+(s<<2)>>2];w=+n[u+(s<<2)>>2];x=j+((Y(s,g)|0)<<2)|0;y=s|1;if((y|0)<(h|0)){z=+n[t+(y<<2)>>2];A=+n[u+(y<<2)>>2];y=x+(g<<2)|0;B=s|2;if((B|0)<(h|0)){C=+n[t+(B<<2)>>2];D=+n[u+(B<<2)>>2];B=y+(g<<2)|0;E=s|3;if((E|0)<(h|0)){F=z;G=A;H=C;I=B+(g<<2)|0;J=B;K=y;L=D;M=+n[u+(E<<2)>>2];N=+n[t+(E<<2)>>2]}else{F=z;G=A;H=C;I=x;J=B;K=y;L=D;M=0.0;N=0.0}}else{F=z;G=A;H=0.0;I=x;J=x;K=y;L=0.0;M=0.0;N=0.0}}else{F=0.0;G=0.0;H=0.0;I=x;J=x;K=x;L=0.0;M=0.0;N=0.0}y=0;do{A=+n[x+(y<<2)>>2];z=+n[K+(y<<2)>>2];D=+n[J+(y<<2)>>2];C=+n[I+(y<<2)>>2];B=q+(y<<2)|0;E=r+(y<<2)|0;O=M*C+(L*D+(G*z+(w*A+ +n[E>>2])));n[B>>2]=N*C+(H*D+(F*z+(v*A+ +n[B>>2])));n[E>>2]=O;y=y+1|0}while((y|0)<(i|0));s=s+4|0}while((s|0)<(h|0))}if((p|0)==(l|0))break;else{o=o+2|0;p=p+1|0}}return}function pcb(a,b){a=a|0;b=b|0;var c=0;c=L5b(64)|0;qcb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=120220;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function qcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;Jwa(a);f[a+40>>2]=0;g=a+44|0;f[g>>2]=0;f[a+48>>2]=0;f[a>>2]=120240;f[a+52>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;h=aD(e,4)|0;b[h>>0]=97;b[h+1>>0]=120;b[h+2>>0]=105;b[h+3>>0]=115;h=c+4|0;c=f[h>>2]|0;do if(c){i=f[e>>2]|0;j=(i|0)==0?1124530:i;k=h;l=c;a:while(1){m=l;while(1){n=f[m+16>>2]|0;if((n|0)==(i|0))break;if((gTb((n|0)==0?1124530:n,j)|0)>=0)break;n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(h|0)){k=f[o+16>>2]|0;if((i|0)!=(k|0)?(gTb(j,(k|0)==0?1124530:k)|0)<=-1:0){p=2;break}k=Gwa(o+24|0,-1)|0;p=k}else p=2}else p=2;while(0);f[a+36>>2]=p;bD(e);f[e>>2]=0;f[e+4>>2]=0;p=aD(e,6)|0;b[p>>0]=b[425782]|0;b[p+1>>0]=b[425783]|0;b[p+2>>0]=b[425784]|0;b[p+3>>0]=b[425785]|0;b[p+4>>0]=b[425786]|0;b[p+5>>0]=b[425787]|0;p=f[h>>2]|0;do if(p){o=f[e>>2]|0;c=(o|0)==0?1124530:o;k=h;l=p;b:while(1){n=l;while(1){q=f[n+16>>2]|0;if((q|0)==(o|0))break;if((gTb((q|0)==0?1124530:q,c)|0)>=0)break;q=f[n+4>>2]|0;if(!q){r=k;break b}else n=q}l=f[n>>2]|0;if(!l){r=n;break}else k=n}if((r|0)!=(h|0)){k=f[r+16>>2]|0;if((o|0)!=(k|0)?(gTb(c,(k|0)==0?1124530:k)|0)<0:0){s=0;break}s=r+24|0}else s=0}else s=0;while(0);bD(e);if(!s){u=d;return}r=e+4|0;h=a+48|0;p=a+40|0;a=s+4|0;k=s+4|0;l=0;while(1){switch(f[s>>2]|0){case 0:{t=f[(f[a>>2]|0)+4>>2]|0;break}case 3:{t=f[(f[k>>2]|0)+4>>2]|0;break}case 2:{t=f[(f[k>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[r>>2]=0;bO(-3,e,429353,429358,272);bD(e);t=-1}}if((l|0)>=(t|0))break;j=Gwa(s,l)|0;f[e>>2]=j;i=f[g>>2]|0;if((i|0)==(f[h>>2]|0))IO(p,e);else{f[i>>2]=j;f[g>>2]=i+4}l=l+1|0}u=d;return}function rcb(a){a=a|0;O5b(a);return}function scb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function tcb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=120340;b=f[a+40>>2]|0;if(!b){lua(a);return}c=a+44|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);lua(a);return}function ucb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=120340;b=f[a+40>>2]|0;if(!b){lua(a);O5b(a);return}c=a+44|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);lua(a);O5b(a);return}function vcb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=120240;b=f[a+52>>2]|0;if(b|0){c=a+56|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);O5b(b)}f[a>>2]=120340;b=f[a+40>>2]|0;if(!b){lua(a);return}d=a+44|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);O5b(b);lua(a);return}function wcb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=120240;b=f[a+52>>2]|0;if(b|0){c=a+56|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);O5b(b)}f[a>>2]=120340;b=f[a+40>>2]|0;if(!b){lua(a);O5b(a);return}d=a+44|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);O5b(b);lua(a);O5b(a);return}function xcb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+32|0;e=d+8|0;g=d;h=f[c>>2]|0;if(((f[c+4>>2]|0)-h|0)==8)i=h;else{f[e>>2]=0;f[e+4>>2]=0;j=aD(e,18)|0;k=417696;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,e,443724,417404,88);bD(e);i=f[c>>2]|0}c=f[i>>2]|0;h=f[i+4>>2]|0;i=f[c+4>>2]|0;m=f[a+36>>2]|0;n=((m|0)<0?i:0)+m|0;f[e>>2]=0;m=e+4|0;f[m>>2]=0;f[e+8>>2]=0;do if(i)if(i>>>0>1073741823)c4b(e);else{o=i<<2;p=L5b(o)|0;f[e>>2]=p;q=p+(i<<2)|0;f[e+8>>2]=q;Nac(p|0,0,o|0)|0;f[m>>2]=q;r=p;break}else r=0;while(0);p=a+40|0;q=a+44|0;o=f[p>>2]|0;s=(f[q>>2]|0)-o>>2;t=o;switch(s|0){case 1:{if((i|0)>(n|0)){o=n;do{f[r+(o<<2)>>2]=f[t>>2];o=o+1|0}while((o|0)!=(i|0))}break}case 0:break;default:{if((s|0)!=(i-n|0)){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,91)|0;k=417715;l=j+91|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-5,g,443724,417404,106);bD(g)}if((i|0)>(n|0)){s=f[p>>2]|0;o=f[e>>2]|0;t=n;do{f[o+(t<<2)>>2]=f[s+(t-n<<2)>>2];t=t+1|0}while((t|0)!=(i|0))}}}t=a+52|0;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;s=a+56|0;a=f[s>>2]|0;o=f[t>>2]|0;r=a-o>>3;v=o;o=a;if(i>>>0<=r>>>0){if(i>>>0<r>>>0?(a=v+(i<<3)|0,(o|0)!=(a|0)):0)f[s>>2]=o+(~((o+-8-a|0)>>>3)<<3)}else Bcb(t,i-r|0,g);if((i|0)>0){r=h+40|0;h=c+40|0;c=g+4|0;a=g+4|0;o=0;do{if((o|0)>=(n|0)){if((f[p>>2]|0)==(f[q>>2]|0)){s=f[(f[r>>2]|0)+(o<<2)>>2]|0;v=f[(f[h>>2]|0)+(o<<2)>>2]|0;if((s|0)>(v|0)){f[g>>2]=0;f[c>>2]=0;j=aD(g,24)|0;k=417831;l=j+24|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-5,g,443724,417404,128);bD(g);w=f[(f[r>>2]|0)+(o<<2)>>2]|0;x=f[(f[h>>2]|0)+(o<<2)>>2]|0}else{w=s;x=v}y=(x-w|0)/2|0;z=y;A=y+w|0}else{y=f[(f[e>>2]|0)+(o<<2)>>2]|0;if((y|0)>=0?(B=f[(f[r>>2]|0)+(o<<2)>>2]|0,(B+y|0)<=(f[(f[h>>2]|0)+(o<<2)>>2]|0)):0){C=y;D=B}else{f[g>>2]=0;f[a>>2]=0;j=aD(g,23)|0;k=417807;l=j+23|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-5,g,443724,417404,121);bD(g);C=f[(f[e>>2]|0)+(o<<2)>>2]|0;D=f[(f[r>>2]|0)+(o<<2)>>2]|0}z=C;A=D+C|0}v=(f[t>>2]|0)+(o<<3)|0;f[v>>2]=z;f[v+4>>2]=A}o=o+1|0}while((o|0)<(i|0))}i=f[e>>2]|0;if(!i){u=d;return}e=f[m>>2]|0;if((e|0)!=(i|0))f[m>>2]=e+(~((e+-4-i|0)>>>2)<<2);O5b(i);u=d;return}function ycb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;d=u;u=u+80|0;e=d+72|0;g=d;h=d+56|0;dQ(e,120464);i=f[c>>2]|0;mL(g,f[f[b>>2]>>2]|0,f[a+52>>2]|0);a=h+8|0;f[a>>2]=0;f[a+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=i;SP(g,h);h=g+36|0;i=f[h>>2]|0;if(i|0?(a=i+12|0,i=f[a>>2]|0,f[a>>2]=i+-1,(i|0)==1):0)kL(g);f[h>>2]=0;h=g+16|0;i=g+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[i>>2]|0)>0){h=f[g+40>>2]|0;a=0;do{f[h+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[i>>2]|0))}i=f[g+44>>2]|0;if((i|0)!=(g+48|0))UC(i);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function zcb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,120432);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Acb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;if(((f[c+4>>2]|0)-h|0)==24){i=c;j=h}else{f[d>>2]=0;f[d+4>>2]=0;h=aD(d,18)|0;k=442898;l=h+18|0;do{b[h>>0]=b[k>>0]|0;h=h+1|0;k=k+1|0}while((h|0)<(l|0));bO(-215,d,442770,417404,72);bD(d);i=c;j=f[c>>2]|0}Bua(d,j);j=f[a+36>>2]|0;a=d+4|0;c=f[d>>2]|0;k=(f[a>>2]|0)-c>>2;h=((j|0)<0?k:0)+j|0;j=c;if(h>>>0<k>>>0){c=f[(f[i>>2]|0)+12>>2]|0;i=h;do{f[j+(i<<2)>>2]=f[c+(i<<2)>>2];i=i+1|0}while(i>>>0<k>>>0)}k=e+4|0;i=f[k>>2]|0;c=f[e>>2]|0;j=i-c|0;h=(j|0)/12|0;l=c;c=i;if(j){if(h>>>0>1?(j=l+12|0,(c|0)!=(j|0)):0){l=c;while(1){c=l+-12|0;f[k>>2]=c;i=f[c>>2]|0;if(!i)m=c;else{c=l+-8|0;n=f[c>>2]|0;if((n|0)!=(i|0))f[c>>2]=n+(~((n+-4-i|0)>>>2)<<2);O5b(i);m=f[k>>2]|0}if((m|0)==(j|0))break;else l=m}}}else sbb(e,1-h|0,d);h=f[d>>2]|0;if(!h){u=g;return 0}d=f[a>>2]|0;if((d|0)!=(h|0))f[a>>2]=d+(~((d+-4-h|0)>>>2)<<2);O5b(h);u=g;return 0}function Bcb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>3>>>0>=b>>>0){i=b;j=h;do{k=c;l=f[k+4>>2]|0;m=j;f[m>>2]=f[k>>2];f[m+4>>2]=l;j=(f[g>>2]|0)+8|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>3;h=j+b|0;if(h>>>0>536870911)c4b(a);l=e-i|0;i=l>>2;e=l>>3>>>0<268435455?(i>>>0<h>>>0?h:i):536870911;do if(e)if(e>>>0>536870911){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{n=L5b(e<<3)|0;break}else n=0;while(0);i=n+(j<<3)|0;j=n+(e<<3)|0;e=b;b=i;n=i;do{h=c;l=f[h+4>>2]|0;m=b;f[m>>2]=f[h>>2];f[m+4>>2]=l;b=n+8|0;n=b;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;b=(f[g>>2]|0)-e|0;c=i+(0-(b>>3)<<3)|0;if((b|0)>0)Vac(c|0,e|0,b|0)|0;f[a>>2]=c;f[g>>2]=n;f[d>>2]=j;if(!e)return;O5b(e);return}function Ccb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=g?f[c>>2]|0:c;c=j+h|0;if(c>>>0>4294967279)V5b(a);if(c>>>0<11){b[a+11>>0]=h;k=a}else{g=c+16&-16;c=L5b(g)|0;f[a>>2]=c;f[a+8>>2]=g|-2147483648;f[a+4>>2]=h;k=c}if(!h){l=k+h|0;b[l>>0]=0;m=f[d>>2]|0;n=i?m:d;j6b(a,n,j)|0;return}Vac(k|0,e|0,h|0)|0;l=k+h|0;b[l>>0]=0;m=f[d>>2]|0;n=i?m:d;j6b(a,n,j)|0;return}function Dcb(a,c,e,g,h,i,j){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=u;u=u+64|0;l=k+40|0;m=k+28|0;n=k+16|0;o=k+8|0;p=k;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;q=m+11|0;b[q>>0]=2;d[m>>1]=26719;b[m+2>>0]=0;Ccb(l,c,m);if((b[q>>0]|0)<0)O5b(f[m>>2]|0);f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;q=n+11|0;b[q>>0]=2;d[n>>1]=30559;b[n+2>>0]=0;Ccb(m,c,n);if((b[q>>0]|0)<0)O5b(f[n>>2]|0);X5b(n,e);e=n+11|0;q=b[e>>0]|0;r=n+4|0;if(((q<<24>>24<0?f[r>>2]|0:q&255)|0)==0?(u6b(n,0,-1,1124530,0)|0)==0:0)_5b(n,c)|0;f[o>>2]=0;f[o+4>>2]=0;c=l+11|0;q=b[c>>0]|0;s=l+4|0;t=q<<24>>24<0?f[s>>2]|0:q&255;if(t|0){q=aD(o,t)|0;Vac(q|0,((b[c>>0]|0)<0?f[l>>2]|0:l)|0,t|0)|0}t=a+4|0;q=f[t>>2]|0;do if(!q){bD(o);v=39}else{w=f[o>>2]|0;x=(w|0)==0?1124530:w;y=q;while(1){z=f[y+16>>2]|0;if((w|0)==(z|0))break;A=(z|0)==0?1124530:z;if((gTb(x,A)|0)<0)B=y;else{if((gTb(A,x)|0)>=0)break;B=y+4|0}y=f[B>>2]|0;if(!y){v=36;break}}if((v|0)==36){bD(o);v=39;break}f[p>>2]=0;f[p+4>>2]=0;y=m+11|0;x=b[y>>0]|0;w=x<<24>>24<0?f[m+4>>2]|0:x&255;if(!w)C=q;else{x=aD(p,w)|0;Vac(x|0,((b[y>>0]|0)<0?f[m>>2]|0:m)|0,w|0)|0;C=f[t>>2]|0}if(!C){bD(p);bD(o);v=39;break}w=f[p>>2]|0;y=(w|0)==0?1124530:w;x=C;while(1){A=f[x+16>>2]|0;if((w|0)==(A|0)){v=29;break}z=(A|0)==0?1124530:A;if((gTb(y,z)|0)<0)D=x;else{if((gTb(z,y)|0)>=0){v=28;break}D=x+4|0}x=f[D>>2]|0;if(!x){v=38;break}}if((v|0)==28){bD(p);bD(o)}else if((v|0)==29){bD(p);bD(o)}else if((v|0)==38){bD(p);bD(o);v=39;break}f[o>>2]=0;f[o+4>>2]=0;x=b[c>>0]|0;y=x<<24>>24<0?f[s>>2]|0:x&255;if(y|0){x=aD(o,y)|0;Vac(x|0,((b[c>>0]|0)<0?f[l>>2]|0:l)|0,y|0)|0}y=Gwa(Eya(a,o)|0,-1)|0;f[g>>2]=y;bD(o);f[o>>2]=0;f[o+4>>2]=0;y=m+11|0;x=b[y>>0]|0;w=x<<24>>24<0?f[m+4>>2]|0:x&255;if(w|0){x=aD(o,w)|0;Vac(x|0,((b[y>>0]|0)<0?f[m>>2]|0:m)|0,w|0)|0}w=Gwa(Eya(a,o)|0,-1)|0;f[h>>2]=w;bD(o);E=1}while(0);a:do if((v|0)==39){f[o>>2]=0;f[o+4>>2]=0;s=b[e>>0]|0;p=s<<24>>24<0?f[r>>2]|0:s&255;if(p|0){s=aD(o,p)|0;Vac(s|0,((b[e>>0]|0)<0?f[n>>2]|0:n)|0,p|0)|0}p=f[t>>2]|0;do if(!p)bD(o);else{s=f[o>>2]|0;D=(s|0)==0?1124530:s;C=p;while(1){q=f[C+16>>2]|0;if((s|0)==(q|0)){v=49;break}B=(q|0)==0?1124530:q;if((gTb(D,B)|0)<0)F=C;else{if((gTb(B,D)|0)>=0){v=50;break}F=C+4|0}C=f[F>>2]|0;if(!C){v=55;break}}if((v|0)==49)bD(o);else if((v|0)==50)bD(o);else if((v|0)==55){bD(o);break}f[o>>2]=0;f[o+4>>2]=0;C=b[e>>0]|0;D=C<<24>>24<0?f[r>>2]|0:C&255;if(D|0){C=aD(o,D)|0;Vac(C|0,((b[e>>0]|0)<0?f[n>>2]|0:n)|0,D|0)|0}D=Gwa(Eya(a,o)|0,-1)|0;f[h>>2]=D;f[g>>2]=D;bD(o);E=1;break a}while(0);if(i){p=f[j>>2]|0;f[h>>2]=p;f[g>>2]=p;E=1}else E=0}while(0);if((b[e>>0]|0)<0)O5b(f[n>>2]|0);if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);if((b[c>>0]|0)>=0){u=k;return E|0}O5b(f[l>>2]|0);u=k;return E|0}function Ecb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+16|0;h=e+4|0;i=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;j=g+11|0;b[j>>0]=6;b[g>>0]=b[417881]|0;b[g+1>>0]=b[417882]|0;b[g+2>>0]=b[417883]|0;b[g+3>>0]=b[417884]|0;b[g+4>>0]=b[417885]|0;b[g+5>>0]=b[417886]|0;b[g+6>>0]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=L5b(16)|0;f[h>>2]=k;f[h+8>>2]=-2147483632;f[h+4>>2]=11;l=k;m=442358;n=l+11|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+11>>0]=0;f[i>>2]=0;k=Dcb(a,g,h,c,d,0,i)|0;if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[j>>0]|0)<0)O5b(f[g>>2]|0);if(!k){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,52)|0;m=417888;n=l+52|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-5,g,417941,417955,101);bD(g)}if((f[c>>2]|0)>0&(f[d>>2]|0)>0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;l=aD(g,26)|0;m=418036;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,g,417941,417955,104);bD(g);u=e;return}function Fcb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=u;u=u+32|0;j=i+16|0;k=i+4|0;l=i;m=j+4|0;f[m>>2]=0;f[m+4>>2]=0;m=j+11|0;b[m>>0]=3;b[j>>0]=b[418063]|0;b[j+1>>0]=b[418064]|0;b[j+2>>0]=b[418065]|0;b[j+3>>0]=0;n=k+4|0;f[n>>2]=0;f[n+4>>2]=0;n=k+11|0;b[n>>0]=3;b[k>>0]=b[418063]|0;b[k+1>>0]=b[418064]|0;b[k+2>>0]=b[418065]|0;b[k+3>>0]=0;f[l>>2]=0;Dcb(a,j,k,c,d,1,l)|0;if((b[n>>0]|0)<0)O5b(f[k>>2]|0);if((b[m>>0]|0)<0)O5b(f[j>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;m=j+11|0;b[m>>0]=6;b[j>>0]=b[418067]|0;b[j+1>>0]=b[418068]|0;b[j+2>>0]=b[418069]|0;b[j+3>>0]=b[418070]|0;b[j+4>>0]=b[418071]|0;b[j+5>>0]=b[418072]|0;b[j+6>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;n=k+11|0;b[n>>0]=6;b[k>>0]=b[418067]|0;b[k+1>>0]=b[418068]|0;b[k+2>>0]=b[418069]|0;b[k+3>>0]=b[418070]|0;b[k+4>>0]=b[418071]|0;b[k+5>>0]=b[418072]|0;b[k+6>>0]=0;f[l>>2]=1;Dcb(a,j,k,e,g,1,l)|0;if((b[n>>0]|0)<0)O5b(f[k>>2]|0);if((b[m>>0]|0)<0)O5b(f[j>>2]|0);bD(h);f[j>>2]=0;f[j+4>>2]=0;m=aD(j,8)|0;n=m;b[n>>0]=112;b[n+1>>0]=97;b[n+2>>0]=100;b[n+3>>0]=95;n=m+4|0;b[n>>0]=109;b[n+1>>0]=111;b[n+2>>0]=100;b[n+3>>0]=101;n=f[a+4>>2]|0;a:do if(!n)o=17;else{m=f[j>>2]|0;l=(m|0)==0?1124530:m;p=n;while(1){q=f[p+16>>2]|0;if((m|0)==(q|0))break;r=(q|0)==0?1124530:q;if((gTb(l,r)|0)<0)s=p;else{if((gTb(r,l)|0)>=0)break;s=p+4|0}p=f[s>>2]|0;if(!p){o=17;break a}}bD(j);f[k>>2]=0;f[k+4>>2]=0;p=aD(k,8)|0;l=p;b[l>>0]=112;b[l+1>>0]=97;b[l+2>>0]=100;b[l+3>>0]=95;l=p+4|0;b[l>>0]=109;b[l+1>>0]=111;b[l+2>>0]=100;b[l+3>>0]=101;Hwa(j,Eya(a,k)|0,-1);if((j|0)!=(h|0)){bD(h);l=f[j>>2]|0;if(!l)t=0;else{p=l+-4|0;f[p>>2]=(f[p>>2]|0)+1;t=f[j>>2]|0}f[h>>2]=t;f[h+4>>2]=f[j+4>>2]}bD(j);bD(k)}while(0);if((o|0)==17)bD(j);if(((f[e>>2]|0)>0?(f[d>>2]|f[c>>2]|0)>-1:0)&(f[g>>2]|0)>0){u=i;return}f[j>>2]=0;f[j+4>>2]=0;g=aD(j,52)|0;c=418074;d=g+52|0;do{b[g>>0]=b[c>>0]|0;g=g+1|0;c=c+1|0}while((g|0)<(d|0));bO(-215,j,418127,417955,118);bD(j);u=i;return}function Gcb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;l=u;u=u+32|0;m=l+16|0;n=l+8|0;o=l;Fcb(a,g,h,i,j,k);f[m>>2]=0;f[m+4>>2]=0;k=aD(m,14)|0;p=418147;q=k+14|0;do{b[k>>0]=b[p>>0]|0;k=k+1|0;p=p+1|0}while((k|0)<(q|0));r=a+4|0;s=f[r>>2]|0;a:do if(!s)t=10;else{v=f[m>>2]|0;w=(v|0)==0?1124530:v;x=s;while(1){y=f[x+16>>2]|0;if((v|0)==(y|0))break;z=(y|0)==0?1124530:y;if((gTb(w,z)|0)<0)A=x;else{if((gTb(z,w)|0)>=0)break;A=x+4|0}x=f[A>>2]|0;if(!x){t=10;break a}}f[n>>2]=0;f[n+4>>2]=0;k=aD(n,14)|0;p=418147;q=k+14|0;do{b[k>>0]=b[p>>0]|0;k=k+1|0;p=p+1|0}while((k|0)<(q|0));x=Gwa(Eya(a,n)|0,-1)|0;b[e>>0]=((x|0)!=0|(J|0)!=0)&1;bD(n)}while(0);if((t|0)==10)b[e>>0]=0;bD(m);if(!(b[e>>0]|0)){Ecb(a,c,d);u=l;return}f[m>>2]=0;f[m+4>>2]=0;d=aD(m,8)|0;c=d;b[c>>0]=107;b[c+1>>0]=101;b[c+2>>0]=114;b[c+3>>0]=110;c=d+4|0;b[c>>0]=101;b[c+1>>0]=108;b[c+2>>0]=95;b[c+3>>0]=104;c=f[r>>2]|0;b:do if(!c)t=20;else{d=f[m>>2]|0;a=(d|0)==0?1124530:d;e=c;while(1){A=f[e+16>>2]|0;if((d|0)==(A|0))break;s=(A|0)==0?1124530:A;if((gTb(a,s)|0)<0)B=e;else{if((gTb(s,a)|0)>=0)break;B=e+4|0}e=f[B>>2]|0;if(!e){t=20;break b}}bD(m);t=41}while(0);c:do if((t|0)==20){f[n>>2]=0;f[n+4>>2]=0;B=aD(n,8)|0;c=B;b[c>>0]=107;b[c+1>>0]=101;b[c+2>>0]=114;b[c+3>>0]=110;c=B+4|0;b[c>>0]=101;b[c+1>>0]=108;b[c+2>>0]=95;b[c+3>>0]=119;c=f[r>>2]|0;d:do if(c|0){B=f[n>>2]|0;e=(B|0)==0?1124530:B;a=c;while(1){d=f[a+16>>2]|0;if((B|0)==(d|0)){t=38;break}s=(d|0)==0?1124530:d;if((gTb(e,s)|0)<0)C=a;else{if((gTb(s,e)|0)>=0){t=39;break}C=a+4|0}a=f[C>>2]|0;if(!a)break d}if((t|0)==38){bD(n);bD(m);t=41;break c}else if((t|0)==39){bD(n);bD(m);t=41;break c}}while(0);f[o>>2]=0;f[o+4>>2]=0;k=aD(o,11)|0;p=442358;q=k+11|0;do{b[k>>0]=b[p>>0]|0;k=k+1|0;p=p+1|0}while((k|0)<(q|0));c=f[r>>2]|0;if(!c){bD(o);bD(n);bD(m);break}a=f[o>>2]|0;e=(a|0)==0?1124530:a;B=c;while(1){c=f[B+16>>2]|0;if((a|0)==(c|0)){t=40;break}s=(c|0)==0?1124530:c;if((gTb(e,s)|0)<0)D=B;else{if((gTb(s,e)|0)>=0){t=36;break}D=B+4|0}B=f[D>>2]|0;if(!B){t=43;break}}if((t|0)==36){bD(o);bD(n);bD(m);t=41;break}else if((t|0)==40){bD(o);bD(n);bD(m);t=41;break}else if((t|0)==43){bD(o);bD(n);bD(m);break}}while(0);if((t|0)==41){f[m>>2]=0;f[m+4>>2]=0;k=aD(m,82)|0;p=418162;q=k+82|0;do{b[k>>0]=b[p>>0]|0;k=k+1|0;p=p+1|0}while((k|0)<(q|0));bO(-5,m,418245,417955,135);bD(m)}if(((f[i>>2]|0)==1?(f[h>>2]|f[g>>2]|0)==0:0)&(f[j>>2]|0)==1){u=l;return}f[m>>2]=0;f[m+4>>2]=0;k=aD(m,90)|0;p=418268;q=k+90|0;do{b[k>>0]=b[p>>0]|0;k=k+1|0;p=p+1|0}while((k|0)<(q|0));bO(-5,m,418245,417955,139);bD(m);u=l;return}function Hcb(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+32|0;n=m+16|0;o=m;p=m+28|0;Ecb(a,c,d);Fcb(a,e,g,h,i,l);f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;l=n+11|0;b[l>>0]=8;i=n;f[i>>2]=1634494820;f[i+4>>2]=1852795252;b[n+8>>0]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;i=o+11|0;b[i>>0]=8;h=o;f[h>>2]=1634494820;f[h+4>>2]=1852795252;b[o+8>>0]=0;f[p>>2]=1;Dcb(a,n,o,j,k,1,p)|0;if((b[i>>0]|0)<0)O5b(f[o>>2]|0);if((b[l>>0]|0)<0)O5b(f[n>>2]|0);if((f[j>>2]|0)>0&(f[k>>2]|0)>0){u=m;return}f[n>>2]=0;f[n+4>>2]=0;k=aD(n,30)|0;j=418359;l=k+30|0;do{b[k>>0]=b[j>>0]|0;k=k+1|0;j=j+1|0}while((k|0)<(l|0));bO(-215,n,418390,417955,156);bD(n);u=m;return}function Icb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i;k=f[e>>2]|0;if((k|0)!=418417?(e=(k|0)==0?1124530:k,gTb(e,418417)|0):0){if((k|0)!=418423?gTb(e,418423)|0:0){f[j>>2]=0;f[j+4>>2]=0;e=aD(j,24)|0;k=418428;l=e+24|0;do{b[e>>0]=b[k>>0]|0;e=e+1|0;k=k+1|0}while((e|0)<(l|0));bO(-2,j,418453,417955,184);bD(j);u=i;return}j=f[d+4>>2]|0;f[h+4>>2]=((f[a+4>>2]|0)+-1+j|0)/(j|0)|0;j=f[d>>2]|0;f[h>>2]=((f[a>>2]|0)+-1+j|0)/(j|0)|0;u=i;return}j=Y((f[c+4>>2]|0)+-1|0,f[g+4>>2]|0)|0;k=f[d+4>>2]|0;f[h+4>>2]=((f[a+4>>2]|0)+-1+k-j|0)/(k|0)|0;k=Y((f[c>>2]|0)+-1|0,f[g>>2]|0)|0;g=f[d>>2]|0;f[h>>2]=((f[a>>2]|0)+-1+g-k|0)/(g|0)|0;u=i;return}function Jcb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=f[e>>2]|0;if((i|0)!=418417?(e=(i|0)==0?1124530:i,(gTb(e,418417)|0)!=0):0){if((i|0)!=418423?gTb(e,418423)|0:0)return;e=Y((f[b+4>>2]|0)+-1|0,f[d+4>>2]|0)|0;i=Y((f[c+4>>2]|0)+-1|0,f[g+4>>2]|0)|0;j=e+1-(f[a+4>>2]|0)+i|0;i=Y((f[b>>2]|0)+-1|0,f[d>>2]|0)|0;d=Y((f[c>>2]|0)+-1|0,f[g>>2]|0)|0;g=i+1-(f[a>>2]|0)+d|0;k=((j|0)>0?j:0)>>>1;l=((g|0)>0?g:0)>>>1}else{k=0;l=0}f[h>>2]=l;f[h+4>>2]=k;return}function Kcb(a,b){a=a|0;b=b|0;var c=0;c=L5b(80)|0;Lcb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=120504;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Lcb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+48|0;e=d+24|0;g=d+16|0;h=d+8|0;i=d;Jwa(a);f[a>>2]=120524;j=a+36|0;k=a+40|0;l=a+68|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;m=aD(e,5)|0;b[m>>0]=b[471917]|0;b[m+1>>0]=b[471918]|0;b[m+2>>0]=b[471919]|0;b[m+3>>0]=b[471920]|0;b[m+4>>0]=b[471921]|0;m=c+4|0;o=f[m>>2]|0;do if(o){p=f[e>>2]|0;q=(p|0)==0?1124530:p;r=m;s=o;a:while(1){t=s;while(1){v=f[t+16>>2]|0;if((v|0)==(p|0))break;if((gTb((v|0)==0?1124530:v,q)|0)>=0)break;v=f[t+4>>2]|0;if(!v){w=r;break a}else t=v}s=f[t>>2]|0;if(!s){w=t;break}else r=t}if((w|0)!=(m|0)){r=f[w+16>>2]|0;if((p|0)!=(r|0)?(gTb(q,(r|0)==0?1124530:r)|0)<=-1:0){x=0.0;break}x=+Hya(w+24|0,-1)}else x=0.0}else x=0.0;while(0);n[a+64>>2]=x;bD(e);f[e>>2]=0;f[e+4>>2]=0;w=aD(e,10)|0;o=418554;r=w+10|0;do{b[w>>0]=b[o>>0]|0;w=w+1|0;o=o+1|0}while((w|0)<(r|0));s=f[m>>2]|0;do if(s){v=f[e>>2]|0;y=(v|0)==0?1124530:v;z=m;A=s;b:while(1){B=A;while(1){C=f[B+16>>2]|0;if((C|0)==(v|0))break;if((gTb((C|0)==0?1124530:C,y)|0)>=0)break;C=f[B+4>>2]|0;if(!C){D=z;break b}else B=C}A=f[B>>2]|0;if(!A){D=B;break}else z=B}if((D|0)!=(m|0)){z=f[D+16>>2]|0;if((v|0)!=(z|0)?(gTb(y,(z|0)==0?1124530:z)|0)<=-1:0){E=-1;break}z=Gwa(D+24|0,-1)|0;E=z}else E=-1}else E=-1;while(0);f[a+60>>2]=E;bD(e);f[h>>2]=0;f[h+4>>2]=0;E=aD(h,4)|0;b[E>>0]=116;b[E+1>>0]=121;b[E+2>>0]=112;b[E+3>>0]=101;f[i>>2]=0;E=i+4|0;f[E>>2]=0;a=aD(i,8)|0;D=a;b[D>>0]=99;b[D+1>>0]=111;b[D+2>>0]=110;b[D+3>>0]=115;D=a+4|0;b[D>>0]=116;b[D+1>>0]=97;b[D+2>>0]=110;b[D+3>>0]=116;D=f[m>>2]|0;do if(D){a=f[h>>2]|0;s=(a|0)==0?1124530:a;z=m;A=D;c:while(1){q=A;while(1){p=f[q+16>>2]|0;if((p|0)==(a|0))break;if((gTb((p|0)==0?1124530:p,s)|0)>=0)break;p=f[q+4>>2]|0;if(!p){F=z;break c}else q=p}A=f[q>>2]|0;if(!A){F=q;break}else z=q}if((F|0)!=(m|0)){z=f[F+16>>2]|0;if((a|0)!=(z|0)?(gTb(s,(z|0)==0?1124530:z)|0)<=-1:0){G=34;break}Hwa(g,F+24|0,-1);H=g+4|0}else G=34}else G=34;while(0);if((G|0)==34){F=f[i>>2]|0;f[g>>2]=F;D=g+4|0;f[D>>2]=f[E>>2];if(!F)H=D;else{E=F+-4|0;f[E>>2]=(f[E>>2]|0)+1;H=D}}D=f[g>>2]|0;E=f[H>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(E>>>0>4294967279)V5b(e);if(E>>>0<11){b[e+11>>0]=E;if(!E)I=e;else{J=e;G=41}}else{H=E+16&-16;F=L5b(H)|0;f[e>>2]=F;f[e+8>>2]=H|-2147483648;f[e+4>>2]=E;J=F;G=41}if((G|0)==41){Vac(J|0,D|0,E|0)|0;I=J}b[I+E>>0]=0;_5b(l,e)|0;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);bD(g);bD(i);bD(h);f[e>>2]=0;f[e+4>>2]=0;h=aD(e,8)|0;i=h;b[i>>0]=112;b[i+1>>0]=97;b[i+2>>0]=100;b[i+3>>0]=100;i=h+4|0;b[i>>0]=105;b[i+1>>0]=110;b[i+2>>0]=103;b[i+3>>0]=115;i=f[m>>2]|0;do if(i){m=f[e>>2]|0;h=(m|0)==0?1124530:m;g=i;while(1){l=f[g+16>>2]|0;if((m|0)==(l|0)){G=52;break}E=(l|0)==0?1124530:l;if((gTb(h,E)|0)<0)K=g;else{if((gTb(E,h)|0)>=0){G=56;break}K=g+4|0}g=f[K>>2]|0;if(!g){G=54;break}}if((G|0)==52){bD(e);break}else if((G|0)==54){bD(e);G=55;break}else if((G|0)==56){bD(e);break}}else{bD(e);G=55}while(0);if((G|0)==55){f[e>>2]=0;f[e+4>>2]=0;w=aD(e,22)|0;o=418565;r=w+22|0;do{b[w>>0]=b[o>>0]|0;w=w+1|0;o=o+1|0}while((w|0)<(r|0));bO(-215,e,418588,418605,32);bD(e)}f[e>>2]=0;f[e+4>>2]=0;K=aD(e,8)|0;i=K;b[i>>0]=112;b[i+1>>0]=97;b[i+2>>0]=100;b[i+3>>0]=100;i=K+4|0;b[i>>0]=105;b[i+1>>0]=110;b[i+2>>0]=103;b[i+3>>0]=115;i=Eya(c,e)|0;bD(e);c=f[i>>2]|0;switch(c|0){case 0:{L=(f[i+4>>2]|0)+4|0;G=62;break}case 3:{L=(f[i+4>>2]|0)+4|0;G=62;break}case 2:{L=(f[i+4>>2]|0)+4|0;G=62;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);G=63}}if((G|0)==62)if(!(f[L>>2]&1))M=c;else G=63;if((G|0)==63){f[e>>2]=0;f[e+4>>2]=0;w=aD(e,31)|0;o=418686;r=w+31|0;do{b[w>>0]=b[o>>0]|0;w=w+1|0;o=o+1|0}while((w|0)<(r|0));bO(-215,e,418588,418605,34);bD(e);M=f[i>>2]|0}switch(M|0){case 0:{N=f[(f[i+4>>2]|0)+4>>2]|0;break}case 3:{N=f[(f[i+4>>2]|0)+4>>2]|0;break}case 2:{N=f[(f[i+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);N=-1}}M=(N|0)/2|0;N=f[k>>2]|0;G=f[j>>2]|0;c=N-G>>3;L=G;K=N;if(M>>>0<=c>>>0)if(M>>>0<c>>>0?(g=L+(M<<3)|0,(K|0)!=(g|0)):0){L=K+(~((K+-8-g|0)>>>3)<<3)|0;f[k>>2]=L;O=L;P=G}else{O=N;P=G}else{Ocb(j,M-c|0);O=f[k>>2]|0;P=f[j>>2]|0}if((O|0)==(P|0)){u=d;return}P=e+4|0;O=e+4|0;c=0;do{M=c<<1;G=Gwa(i,M)|0;f[(f[j>>2]|0)+(c<<3)>>2]=G;G=Gwa(i,M|1)|0;M=f[j>>2]|0;f[M+(c<<3)+4>>2]=G;if((f[M+(c<<3)>>2]|0)>-1){Q=M;R=G}else{f[e>>2]=0;f[O>>2]=0;w=aD(e,22)|0;o=418718;r=w+22|0;do{b[w>>0]=b[o>>0]|0;w=w+1|0;o=o+1|0}while((w|0)<(r|0));bO(-215,e,418588,418605,41);bD(e);G=f[j>>2]|0;Q=G;R=f[G+(c<<3)+4>>2]|0}if((R|0)>-1)S=Q;else{f[e>>2]=0;f[P>>2]=0;w=aD(e,23)|0;o=418741;r=w+23|0;do{b[w>>0]=b[o>>0]|0;w=w+1|0;o=o+1|0}while((w|0)<(r|0));bO(-215,e,418588,418605,41);bD(e);S=f[j>>2]|0}c=c+1|0}while(c>>>0<(f[k>>2]|0)-S>>3>>>0);u=d;return}function Mcb(a){a=a|0;O5b(a);return}function Ncb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Ocb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){Nac(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)c4b(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;Nac(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)Vac(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;O5b(h);return}function Pcb(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=120524;c=a+68|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);c=f[a+48>>2]|0;if(c|0){d=a+52|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);O5b(c)}c=f[a+36>>2]|0;if(!c){lua(a);return}e=a+40|0;d=f[e>>2]|0;if((d|0)!=(c|0))f[e>>2]=d+(~((d+-8-c|0)>>>3)<<3);O5b(c);lua(a);return}function Qcb(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=120524;c=a+68|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);c=f[a+48>>2]|0;if(c|0){d=a+52|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-8-c|0)>>>3)<<3);O5b(c)}c=f[a+36>>2]|0;if(!c){lua(a);O5b(a);return}e=a+40|0;d=f[e>>2]|0;if((d|0)!=(c|0))f[e>>2]=d+(~((d+-8-c|0)>>>3)<<3);O5b(c);lua(a);O5b(a);return}function Rcb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+32|0;d=c;e=c+8|0;g=c+16|0;h=f[f[b>>2]>>2]|0;i=a+48|0;j=a+36|0;k=a+40|0;l=(f[k>>2]|0)-(f[j>>2]|0)>>3;m=a+52|0;n=f[m>>2]|0;o=f[i>>2]|0;p=n-o>>3;q=o;o=n;if(l>>>0<=p>>>0){if(l>>>0<p>>>0?(n=q+(l<<3)|0,(o|0)!=(n|0)):0)f[m>>2]=o+(~((o+-8-n|0)>>>3)<<3)}else Ycb(i,l-p|0);p=f[a+60>>2]|0;if((p|0)!=-1?(f[(f[f[b>>2]>>2]|0)+4>>2]|0)!=(p|0):0){f[e>>2]=f[i>>2];f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[d>>2]=f[e>>2];Zcb(i,d,g)|0;r=1}else r=0;g=f[k>>2]|0;k=f[j>>2]|0;j=k;if((g|0)==(k|0))s=f[i>>2]|0;else{e=f[i>>2]|0;p=f[h+40>>2]|0;h=g-k>>3;k=e;g=0;do{l=f[j+(g<<3)>>2]|0;n=g+r|0;f[e+(n<<3)>>2]=l;f[e+(n<<3)+4>>2]=(f[p+(n<<2)>>2]|0)+l;g=g+1|0}while(g>>>0<h>>>0);s=k}k=f[m>>2]|0;h=k-s>>3;if((h|0)>=(f[(f[f[b>>2]>>2]|0)+4>>2]|0)){u=c;return}s=d+4|0;g=a+56|0;a=h;h=k;while(1){f[d>>2]=-2147483648;f[s>>2]=2147483647;if((h|0)==(f[g>>2]|0))_cb(i,d);else{k=d;p=f[k+4>>2]|0;e=h;f[e>>2]=f[k>>2];f[e+4>>2]=p;f[m>>2]=(f[m>>2]|0)+8}p=a+1|0;if((p|0)>=(f[(f[f[b>>2]>>2]|0)+4>>2]|0))break;a=p;h=f[m>>2]|0}u=c;return}function Scb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;e=u;u=u+192|0;g=e+176|0;h=e+160|0;i=e+32|0;j=e+144|0;k=e+88|0;l=e;dQ(g,120648);m=a+68|0;o=m+11|0;q=b[o>>0]|0;r=a+72|0;s=f[r>>2]|0;do if(((q<<24>>24<0?s:q&255)|0)==8){if(u6b(m,0,-1,418995,8)|0){t=b[o>>0]|0;v=f[r>>2]|0;w=15;break}x=f[d>>2]|0;p[i>>3]=+n[a+64>>2];f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;VP(x,h,UM()|0)|0;x=f[f[c>>2]>>2]|0;qL(i,f[d>>2]|0,a+48|0);y=h+8|0;f[y>>2]=0;f[y+4>>2]=0;f[h>>2]=-1040121856;f[h+4>>2]=i;SP(x,h);x=i+36|0;y=f[x>>2]|0;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)kL(i);f[x>>2]=0;x=i+16|0;y=i+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[y>>2]|0)>0){x=f[i+40>>2]|0;z=0;do{f[x+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[y>>2]|0))}y=f[i+44>>2]|0;if((y|0)!=(i+48|0))UC(y)}else{t=q;v=s;w=15}while(0);a:do if((w|0)==15){if(((t<<24>>24<0?v:t&255)|0)==7?(u6b(m,0,-1,419004,7)|0)==0:0){if(((f[c+4>>2]|0)-(f[c>>2]|0)|0)!=4){f[h>>2]=0;f[h+4>>2]=0;A=aD(h,18)|0;B=443104;C=A+18|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,443123,418605,114);bD(h)}if(((f[d+4>>2]|0)-(f[d>>2]|0)|0)!=56){f[h>>2]=0;f[h+4>>2]=0;A=aD(h,19)|0;B=443151;C=A+19|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,443123,418605,115);bD(h)}if((f[(f[f[c>>2]>>2]|0)+4>>2]|0)!=4){f[h>>2]=0;f[h+4>>2]=0;A=aD(h,20)|0;B=419012;C=A+20|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,443123,418605,116);bD(h)}s=f[d>>2]|0;if((f[s+4>>2]|0)==4)D=s;else{f[h>>2]=0;f[h+4>>2]=0;A=aD(h,20)|0;B=419033;C=A+20|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,443123,418605,117);bD(h);D=f[d>>2]|0}s=f[(f[f[c>>2]>>2]|0)+40>>2]|0;q=f[D+40>>2]|0;if((f[s>>2]|0)==(f[q>>2]|0)?(f[s+4>>2]|0)==(f[q+4>>2]|0):0){E=s;F=q}else{f[h>>2]=0;f[h+4>>2]=0;A=aD(h,45)|0;B=419054;C=A+45|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-213,h,443123,418605,120);bD(h);E=f[(f[f[c>>2]>>2]|0)+40>>2]|0;F=f[(f[d>>2]|0)+40>>2]|0}q=f[E+8>>2]|0;s=f[E+12>>2]|0;r=f[a+48>>2]|0;o=f[r+16>>2]|0;y=(f[F+8>>2]|0)-(f[r+20>>2]|0)|0;z=f[r+24>>2]|0;x=(f[F+12>>2]|0)-(f[r+28>>2]|0)|0;if((o|0)>=(q|0)){f[h>>2]=0;f[h+4>>2]=0;A=aD(h,18)|0;B=419100;C=A+18|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,443123,418605,131);bD(h)}if((y|0)>=(q|0)){f[h>>2]=0;f[h+4>>2]=0;A=aD(h,21)|0;B=419119;C=A+21|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,443123,418605,131);bD(h)}if((z|0)>=(s|0)){f[h>>2]=0;f[h+4>>2]=0;A=aD(h,18)|0;B=419141;C=A+18|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,443123,418605,131);bD(h)}if((x|0)>=(s|0)){f[h>>2]=0;f[h+4>>2]=0;A=aD(h,19)|0;B=419160;C=A+19|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,443123,418605,131);bD(h)}s=f[f[c>>2]>>2]|0;q=f[s+40>>2]|0;r=f[q>>2]|0;if(!r)break;G=h+8|0;H=h+12|0;I=h+4|0;J=j+8|0;K=j+4|0;L=k+36|0;M=k+16|0;N=k+4|0;O=k+40|0;P=k+44|0;Q=k+48|0;R=i+36|0;S=i+16|0;T=i+4|0;U=i+40|0;V=i+44|0;W=i+48|0;X=0;Y=q;q=r;r=s;while(1){if(!(f[Y+4>>2]|0)){Z=q;_=Y;$=r}else{s=0;aa=r;do{Xcb(i,aa,X,s);f[G>>2]=0;f[H>>2]=0;f[h>>2]=16842752;f[I>>2]=i;Xcb(k,f[d>>2]|0,X,s);ba=J;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=-1040121856;f[K>>2]=k;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;_P(h,j,o,y,z,x,4,l);ba=f[L>>2]|0;do if(ba|0){ca=ba+12|0;da=f[ca>>2]|0;f[ca>>2]=da+-1;if((da|0)!=1)break;kL(k)}while(0);f[L>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[N>>2]|0)>0){ba=f[O>>2]|0;da=0;do{f[ba+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[N>>2]|0))}da=f[P>>2]|0;if((da|0)!=(Q|0))UC(da);da=f[R>>2]|0;do if(da|0){ba=da+12|0;ca=f[ba>>2]|0;f[ba>>2]=ca+-1;if((ca|0)!=1)break;kL(i)}while(0);f[R>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[T>>2]|0)>0){da=f[U>>2]|0;ca=0;do{f[da+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[T>>2]|0))}ca=f[V>>2]|0;if((ca|0)!=(W|0))UC(ca);s=s+1|0;aa=f[f[c>>2]>>2]|0;ea=f[aa+40>>2]|0}while(s>>>0<(f[ea+4>>2]|0)>>>0);Z=f[ea>>2]|0;_=ea;$=aa}X=X+1|0;if(X>>>0>=Z>>>0)break a;else{Y=_;q=Z;r=$}}}dua(i,419180,m);f[h>>2]=0;f[h+4>>2]=0;r=i+11|0;q=b[r>>0]|0;Y=q<<24>>24<0?f[i+4>>2]|0:q&255;if(Y|0){q=aD(h,Y)|0;Vac(q|0,((b[r>>0]|0)<0?f[i>>2]|0:i)|0,Y|0)|0}bO(-213,h,443123,418605,145);bD(h);if((b[r>>0]|0)<0)O5b(f[i>>2]|0)}while(0);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Tcb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,120616);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Ucb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{if(Owa()|0)c=((f[a+52>>2]|0)-(f[a+48>>2]|0)|0)==32;else c=0;break}default:c=0}return c|0}function Vcb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Wcb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;if(((f[c+4>>2]|0)-h|0)==12)i=h;else{f[d>>2]=0;f[d+4>>2]=0;j=aD(d,18)|0;k=443104;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,d,442770,418605,50);bD(d);i=f[c>>2]|0}c=i+4|0;h=a+36|0;m=a+40|0;if((f[c>>2]|0)-(f[i>>2]|0)>>2>>>0<(f[m>>2]|0)-(f[h>>2]|0)>>3>>>0){f[d>>2]=0;f[d+4>>2]=0;j=aD(d,34)|0;k=418765;l=j+34|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,d,442770,418605,52);bD(d)}n=a+60|0;a=f[n>>2]|0;if(((a|0)!=-1?(o=(f[c>>2]|0)-(f[i>>2]|0)>>2,(o|0)!=(a|0)):0)?o>>>0<=(f[m>>2]|0)-(f[h>>2]|0)>>3>>>0:0){f[d>>2]=0;f[d+4>>2]=0;j=aD(d,84)|0;k=418800;l=j+84|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,d,442770,418605,53);bD(d)}d=e+4|0;k=f[d>>2]|0;j=f[e>>2]|0;l=k-j|0;o=(l|0)/12|0;a=j;j=k;if(l){if(o>>>0>1?(l=a+12|0,(j|0)!=(l|0)):0){a=j;while(1){j=a+-12|0;f[d>>2]=j;k=f[j>>2]|0;if(!k)p=j;else{j=a+-8|0;q=f[j>>2]|0;if((q|0)!=(k|0))f[j>>2]=q+(~((q+-4-k|0)>>>2)<<2);O5b(k);p=f[d>>2]|0}if((p|0)==(l|0))break;else a=p}}}else sbb(e,1-o|0,i);o=f[n>>2]|0;if((o|0)==-1)r=0;else r=(f[c>>2]|0)-(f[i>>2]|0)>>2>>>0>o>>>0&1;o=f[m>>2]|0;m=f[h>>2]|0;h=m;if((o|0)==(m|0)){u=g;return 0}c=f[i>>2]|0;i=f[f[e>>2]>>2]|0;e=o-m>>3;m=0;do{o=m+r|0;f[i+(o<<2)>>2]=(f[h+(m<<3)>>2]|0)+(f[c+(o<<2)>>2]|0)+(f[h+(m<<3)+4>>2]|0);m=m+1|0}while(m>>>0<e>>>0);u=g;return 0}function Xcb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+128|0;h=g;i=c+4|0;j=f[i>>2]|0;if((j|0)<=2){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,10)|0;l=435143;m=k+10|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,435154,442663,114);bD(h);l=f[i>>2]|0;if((l|0)>2){n=l;o=h;p=4}else{q=l;r=h}}else{n=j;o=h;p=4}if((p|0)==4){p=f[c+40>>2]|0;j=2;do{f[h+(j+-2<<2)>>2]=f[p+(j<<2)>>2];j=j+1|0}while((j|0)<(n|0));q=n;r=o}o=f[c+44>>2]|0;r=(f[c+16>>2]|0)+(Y(f[o>>2]|0,d)|0)|0;oL(a,q+-2|0,h,f[c>>2]&4095,r+(Y(f[o+4>>2]|0,e)|0)|0,0);u=g;return}function Ycb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){Nac(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)c4b(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;Nac(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)Vac(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;O5b(h);return}function Zcb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=f[a>>2]|0;e=d;g=(f[b>>2]|0)-e|0;b=d+(g>>3<<3)|0;h=a+4|0;i=f[h>>2]|0;j=a+8|0;k=f[j>>2]|0;l=i;m=k;if(i>>>0<k>>>0){if((b|0)==(i|0)){k=c;n=f[k+4>>2]|0;o=b;f[o>>2]=f[k>>2];f[o+4>>2]=n;f[h>>2]=(f[h>>2]|0)+8;p=b;return p|0}n=l-(b+8)|0;o=n>>3;k=b+(o<<3)|0;if(k>>>0<i>>>0){q=k;k=i;do{r=q;s=f[r+4>>2]|0;t=k;f[t>>2]=f[r>>2];f[t+4>>2]=s;q=q+8|0;k=(f[h>>2]|0)+8|0;f[h>>2]=k}while(q>>>0<i>>>0)}if(o|0)Xac(i+(0-o<<3)|0,b|0,n|0)|0;if(b>>>0>c>>>0)u=c;else u=(f[h>>2]|0)>>>0>c>>>0?c+8|0:c;n=u;u=f[n+4>>2]|0;o=b;f[o>>2]=f[n>>2];f[o+4>>2]=u;p=b;return p|0}u=(l-e>>3)+1|0;if(u>>>0>536870911)c4b(a);l=m-e|0;e=l>>2;m=l>>3>>>0<268435455?(e>>>0<u>>>0?u:e):536870911;e=b;u=g>>3;do if(m)if(m>>>0>536870911){l=ze(8)|0;T5b(l,477177);f[l>>2]=149528;If(l|0,25408,1411)}else{l=L5b(m<<3)|0;v=l;w=l;break}else{v=0;w=0}while(0);l=w+(u<<3)|0;o=l;n=w+(m<<3)|0;do if((u|0)==(m|0)){if((g|0)>0){i=l+(((m+1|0)/-2|0)<<3)|0;x=i;y=n;z=i;A=d;break}i=m<<3>>2;q=(i|0)==0?1:i;if(q>>>0>536870911){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}i=L5b(q<<3)|0;k=i+(q>>>2<<3)|0;s=k;t=i+(q<<3)|0;if(!w){x=s;y=t;z=k;A=d}else{O5b(v);x=s;y=t;z=k;A=f[a>>2]|0}}else{x=o;y=n;z=l;A=d}while(0);d=c;c=f[d+4>>2]|0;l=z;f[l>>2]=f[d>>2];f[l+4>>2]=c;c=x+8|0;l=x;x=e-A|0;d=l+(0-(x>>3)<<3)|0;if((x|0)>0)Vac(d|0,A|0,x|0)|0;x=(f[h>>2]|0)-e|0;if((x|0)>0){Vac(c|0,b|0,x|0)|0;B=c+(x>>>3<<3)|0}else B=c;c=f[a>>2]|0;f[a>>2]=d;f[h>>2]=B;f[j>>2]=y;if(!c){p=l;return p|0}O5b(c);p=l;return p|0}function _cb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;O5b(d);return}function $cb(a,b){a=a|0;b=b|0;var c=0;c=L5b(40)|0;adb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=120688;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function adb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;Jwa(a);f[a>>2]=120708;Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,12)|0;h=419464;i=g+12|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j=c+4|0;c=f[j>>2]|0;do if(c){k=f[e>>2]|0;l=(k|0)==0?1124530:k;m=j;n=c;a:while(1){o=n;while(1){p=f[o+16>>2]|0;if((p|0)==(k|0))break;if((gTb((p|0)==0?1124530:p,l)|0)>=0)break;p=f[o+4>>2]|0;if(!p){q=m;break a}else o=p}n=f[o>>2]|0;if(!n){q=o;break}else m=o}if((q|0)!=(j|0)){m=f[q+16>>2]|0;if((k|0)!=(m|0)?(gTb(l,(m|0)==0?1124530:m)|0)<=-1:0){r=2;break}m=Gwa(q+24|0,-1)|0;r=m}else r=2}else r=2;while(0);q=a+36|0;f[q>>2]=r;bD(e);if((f[q>>2]|0)>0){u=d;return}f[e>>2]=0;f[e+4>>2]=0;g=aD(e,15)|0;h=419477;i=g+15|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-215,e,419493,419508,64);bD(e);u=d;return}function bdb(a){a=a|0;O5b(a);return}function cdb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ddb(a){a=a|0;lua(a);O5b(a);return}function edb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+96|0;e=d+80|0;g=d+24|0;h=d+12|0;i=d;dQ(e,120832);j=b+4|0;k=f[b>>2]|0;if((f[j>>2]|0)!=(k|0)){l=g+4|0;m=g+8|0;n=g+12|0;o=g+16|0;p=g+20|0;q=g+24|0;r=g+28|0;s=g+32|0;t=g+36|0;v=g+40|0;w=g+48|0;x=g+44|0;y=g+52|0;z=h+4|0;A=h+8|0;B=i+4|0;C=i+8|0;D=a+36|0;a=0;E=k;do{k=f[E+(a<<2)>>2]|0;f[g>>2]=f[k>>2];F=k+4|0;f[l>>2]=f[F>>2];f[m>>2]=f[k+8>>2];f[n>>2]=f[k+12>>2];f[o>>2]=f[k+16>>2];f[p>>2]=f[k+20>>2];f[q>>2]=f[k+24>>2];f[r>>2]=f[k+28>>2];f[s>>2]=f[k+32>>2];G=f[k+36>>2]|0;f[t>>2]=G;f[v>>2]=m;f[x>>2]=w;f[w>>2]=0;f[y>>2]=0;if(G|0){H=G+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[F>>2]|0)<3){F=f[k+44>>2]|0;H=f[x>>2]|0;f[H>>2]=f[F>>2];f[H+4>>2]=f[F+4>>2]}else{f[l>>2]=0;jL(g,k)}k=f[l>>2]|0;F=f[v>>2]|0;f[h>>2]=0;f[z>>2]=0;f[A>>2]=0;Rva(h,F,F+(k<<2)|0);k=f[c>>2]|0;F=f[k+(a*56|0)+4>>2]|0;H=f[k+(a*56|0)+40>>2]|0;f[i>>2]=0;f[B>>2]=0;f[C>>2]=0;Rva(i,H,H+(F<<2)|0);F=f[(f[c>>2]|0)+16>>2]|0;H=f[o>>2]|0;k=f[h>>2]|0;G=f[k+4>>2]|0;I=f[k+8>>2]|0;J=f[k+12>>2]|0;K=f[D>>2]|0;L=(G|0)/(Y(K,K)|0)|0;if((G|0)>0?(M=(J|0)>0,(I|0)>0):0){N=0;do{O=Y(N,I)|0;if(M){P=(N|0)/(L|0)|0;Q=(P|0)%(K|0)|0;R=(P|0)/(K|0)|0;P=Y((N|0)%(L|0)|0,I)|0;S=0;do{T=Y(S+O|0,J)|0;U=Y((Y(P+S|0,K)|0)+R|0,J)|0;V=0;do{W=H+((Y(U+V|0,K)|0)+Q<<2)|0;f[F+(V+T<<2)>>2]=f[W>>2];V=V+1|0}while((V|0)!=(J|0));S=S+1|0}while((S|0)!=(I|0))}N=N+1|0}while((N|0)!=(G|0))}G=f[i>>2]|0;if(!G)X=k;else{N=f[B>>2]|0;if((N|0)!=(G|0))f[B>>2]=N+(~((N+-4-G|0)>>>2)<<2);O5b(G);X=f[h>>2]|0}if(X|0){G=f[z>>2]|0;if((G|0)!=(X|0))f[z>>2]=G+(~((G+-4-X|0)>>>2)<<2);O5b(X)}G=f[t>>2]|0;if(G|0?(N=G+12|0,G=f[N>>2]|0,f[N>>2]=G+-1,(G|0)==1):0)kL(g);f[t>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[l>>2]|0)>0){G=f[v>>2]|0;N=0;do{f[G+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[l>>2]|0))}N=f[x>>2]|0;if((N|0)!=(w|0))UC(N);a=a+1|0;E=f[b>>2]|0}while(a>>>0<(f[j>>2]|0)-E>>2>>>0)}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function fdb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,120800);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function gdb(a,b){a=a|0;b=b|0;return (b|0)==0|0}function hdb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+48|0;d=g+24|0;h=g+12|0;i=g;j=c+4|0;k=f[j>>2]|0;l=f[c>>2]|0;if((k|0)==(l|0)){f[d>>2]=0;f[d+4>>2]=0;m=aD(d,17)|0;n=441774;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,d,442770,419508,72);bD(d);p=f[c>>2]|0;q=f[j>>2]|0}else{p=l;q=k}k=(q-p|0)/12|0;q=f[p>>2]|0;p=f[a+36>>2]|0;a=Y(Y(p,f[q+4>>2]|0)|0,p)|0;l=(f[q+8>>2]|0)/(p|0)|0;j=(f[q+12>>2]|0)/(p|0)|0;f[d>>2]=f[q>>2];f[d+4>>2]=a;f[d+8>>2]=l;f[d+12>>2]=j;f[i>>2]=0;j=i+4|0;f[j>>2]=0;f[i+8>>2]=0;Rva(i,d,d+16|0);l=f[i>>2]|0;a=f[j>>2]|0;a:do if((l|0)==(a|0)){r=l;s=6}else{q=l;do{if((f[q>>2]|0)<0){r=q;s=6;break a}q=q+4|0}while((q|0)!=(a|0))}while(0);if((s|0)==6?(r|0)!=(a|0):0){s=r+4|0;if((s|0)==(a|0)){t=a;v=r}else{l=s;s=r;while(1){r=f[l>>2]|0;if((r|0)<0)w=s;else{f[s>>2]=r;w=s+4|0}l=l+4|0;if((l|0)==(a|0))break;else s=w}t=f[j>>2]|0;v=w}if((v|0)!=(t|0))f[j>>2]=t+(~((t+-4-v|0)>>>2)<<2)}jdb(h,k,i);if((h|0)!=(e|0))xwa(e,f[h>>2]|0,f[h+4>>2]|0);k=f[h>>2]|0;if(k|0){v=h+4|0;t=f[v>>2]|0;if((t|0)==(k|0))x=k;else{w=t;while(1){t=w+-12|0;f[v>>2]=t;s=f[t>>2]|0;if(!s)y=t;else{t=w+-8|0;a=f[t>>2]|0;if((a|0)!=(s|0))f[t>>2]=a+(~((a+-4-s|0)>>>2)<<2);O5b(s);y=f[v>>2]|0}if((y|0)==(k|0))break;else w=y}x=f[h>>2]|0}O5b(x)}x=f[i>>2]|0;if(x|0){i=f[j>>2]|0;if((i|0)!=(x|0))f[j>>2]=i+(~((i+-4-x|0)>>>2)<<2);O5b(x)}x=f[e>>2]|0;i=f[x>>2]|0;if((((f[i>>2]|0)>0?(f[i+4>>2]|0)>0:0)?(f[i+8>>2]|0)>0:0)?(f[i+12>>2]|0)>0:0)z=x;else{f[d>>2]=0;f[d+4>>2]=0;m=aD(d,80)|0;n=419587;o=m+80|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,d,442770,419508,79);bD(d);z=f[e>>2]|0}e=f[z+4>>2]|0;x=f[z>>2]|0;z=e-x|0;i=z>>2;j=x;do if((j|0)!=(e|0)){if((z|0)<=-4){f[d>>2]=0;f[d+4>>2]=0;m=aD(d,70)|0;n=442586;o=m+70|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,d,442657,442663,160);bD(d);A=1;break}if((z|0)>0){x=0;h=1;while(1){y=Y(f[j+(x<<2)>>2]|0,h)|0;x=x+1|0;if((x|0)>=(i|0)){A=y;break}else h=y}}else A=1}else A=0;while(0);i=f[c>>2]|0;c=f[i+4>>2]|0;j=f[i>>2]|0;i=c-j|0;z=i>>2;e=j;do if((e|0)!=(c|0)){if((i|0)<=-4){f[d>>2]=0;f[d+4>>2]=0;m=aD(d,70)|0;n=442586;o=m+70|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,d,442657,442663,160);bD(d);B=1;break}if((i|0)>0){j=0;h=1;while(1){x=Y(f[e+(j<<2)>>2]|0,h)|0;j=j+1|0;if((j|0)>=(z|0)){B=x;break}else h=x}}else B=1}else B=0;while(0);if((A|0)==(B|0)){u=g;return 0}f[d>>2]=0;f[d+4>>2]=0;m=aD(d,37)|0;n=419668;o=m+37|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,d,442770,419508,80);bD(d);u=g;return 0}function idb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;a=d;e=c+4|0;g=f[e>>2]|0;h=f[c>>2]|0;if((g|0)==(h|0)){i=0;j=0;J=j;u=d;return i|0}k=a+4|0;l=0;m=h;h=0;n=0;o=g;while(1){g=m;p=f[g+(l*12|0)+4>>2]|0;q=f[g+(l*12|0)>>2]|0;g=p-q|0;r=g>>2;s=q;do if((s|0)!=(p|0)){if((g|0)<=-4){f[a>>2]=0;f[k>>2]=0;q=aD(a,70)|0;t=442586;v=q+70|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,a,442657,442663,160);bD(a);w=1;x=f[c>>2]|0;y=f[e>>2]|0;break}if((g|0)>0){t=0;q=1;while(1){v=Y(f[s+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)>=(r|0)){w=v;x=m;y=o;break}else q=v}}else{w=1;x=m;y=o}}else{w=0;x=m;y=o}while(0);r=w*21|0;s=Kac(r|0,((r|0)<0)<<31>>31|0,h|0,n|0)|0;r=J;l=l+1|0;if(l>>>0>=((y-x|0)/12|0)>>>0){i=s;j=r;break}else{m=x;h=s;n=r;o=y}}J=j;u=d;return i|0}function jdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>357913941)c4b(a);e=L5b(b*12|0)|0;f[d>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(b*12|0);a=b;b=e;do{Bua(b,c);b=(f[d>>2]|0)+12|0;f[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function kdb(a,b){a=a|0;b=b|0;var c=0;c=L5b(108)|0;ldb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=120872;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function ldb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d+8|0;g=d;Jwa(a);f[a>>2]=120892;h=a+36|0;i=a+40|0;j=a+44|0;k=a+100|0;l=a+104|0;f[l>>2]=0;m=h;n=m+64|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(n|0));b[h+64>>0]=0;f[e>>2]=0;f[e+4>>2]=0;h=aD(e,5)|0;b[h>>0]=b[428511]|0;b[h+1>>0]=b[428512]|0;b[h+2>>0]=b[428513]|0;b[h+3>>0]=b[428514]|0;b[h+4>>0]=b[428515]|0;h=f[c+4>>2]|0;if(!h){bD(e);u=d;return}o=f[e>>2]|0;p=(o|0)==0?1124530:o;q=h;while(1){h=f[q+16>>2]|0;if((o|0)==(h|0)){r=9;break}s=(h|0)==0?1124530:h;if((gTb(p,s)|0)<0)t=q;else{if((gTb(s,p)|0)>=0){r=10;break}t=q+4|0}q=f[t>>2]|0;if(!q){r=36;break}}if((r|0)==9)bD(e);else if((r|0)==10)bD(e);else if((r|0)==36){bD(e);u=d;return}f[e>>2]=0;f[e+4>>2]=0;q=aD(e,5)|0;b[q>>0]=b[428511]|0;b[q+1>>0]=b[428512]|0;b[q+2>>0]=b[428513]|0;b[q+3>>0]=b[428514]|0;b[q+4>>0]=b[428515]|0;iua(g,Eya(c,e)|0);bD(e);switch(f[g>>2]|0){case 0:{v=(f[g+4>>2]|0)+4|0;r=16;break}case 3:{v=(f[g+4>>2]|0)+4|0;r=16;break}case 2:{v=(f[g+4>>2]|0)+4|0;r=16;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e)}}if((r|0)==16?(f[v>>2]|0)>4:0){f[e>>2]=0;f[e+4>>2]=0;m=aD(e,52)|0;v=420071;n=m+52|0;do{b[m>>0]=b[v>>0]|0;m=m+1|0;v=v+1|0}while((m|0)<(n|0));bO(-5,e,420124,420141,99);bD(e)}switch(f[g>>2]|0){case 0:{w=(f[g+4>>2]|0)+4|0;r=23;break}case 3:{w=(f[g+4>>2]|0)+4|0;r=23;break}case 2:{w=(f[g+4>>2]|0)+4|0;r=23;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);f[l>>2]=-1;r=24}}if((r|0)==23?(v=f[w>>2]|0,f[l>>2]=v,v|0):0)r=24;if((r|0)==24){r=a+48|0;v=0;do{w=Gwa(g,v)|0;odb(a,w);f[e>>2]=w;m=f[j>>2]|0;if((m|0)==(f[r>>2]|0))FP(i,e);else{f[m>>2]=w;f[j>>2]=m+4}v=v+1|0}while(v>>>0<(f[l>>2]|0)>>>0)}Kwa(a,c);b[k>>0]=0;c=f[l>>2]|0;a:do if(c|0){l=f[a+40>>2]|0;v=0;while(1){if((f[l+(v<<2)>>2]|0)!=(v|0))break;v=v+1|0;if(v>>>0>=c>>>0)break a}b[k>>0]=1}while(0);gua(g);u=d;return}function mdb(a){a=a|0;O5b(a);return}function ndb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function odb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;if(c>>>0>3){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,74)|0;h=420222;i=g+74|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-5,e,420297,420141,63);bD(e)}j=f[a+40>>2]|0;k=f[a+44>>2]|0;a:do if((j|0)==(k|0))l=j;else{a=j;do{if((f[a>>2]|0)==(c|0)){l=a;break a}a=a+4|0}while((a|0)!=(k|0));u=d;return}while(0);if((l|0)==(k|0)){u=d;return}f[e>>2]=0;f[e+4>>2]=0;g=aD(e,51)|0;h=420315;i=g+51|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-5,e,420297,420141,69);bD(e);u=d;return}function pdb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=120892;b=f[a+88>>2]|0;if(b|0){c=a+92|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+76>>2]|0;if(b|0){d=a+80|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+64>>2]|0;if(b|0){c=a+68|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+52>>2]|0;if(b|0){d=a+56|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+40>>2]|0;if(!b){lua(a);return}c=a+44|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);lua(a);return}function qdb(a){a=a|0;pdb(a);O5b(a);return}function rdb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+12|0;h=e;if(!(b[a+100>>0]|0)){u=e;return}i=f[c>>2]|0;if((f[c+4>>2]|0)==(i|0)){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,17)|0;k=441774;l=j+17|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,443724,420141,172);bD(g);m=c;n=f[c>>2]|0}else{m=c;n=i}if((f[a+104>>2]|0)!=(f[(f[n>>2]|0)+4>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,26)|0;k=421154;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,443724,420141,174);bD(g)}k=f[f[m>>2]>>2]|0;m=f[k+4>>2]|0;j=f[k+40>>2]|0;f[g>>2]=0;k=g+4|0;f[k>>2]=0;f[g+8>>2]=0;Rva(g,j,j+(m<<2)|0);m=f[d>>2]|0;d=f[m+4>>2]|0;j=f[m+40>>2]|0;f[h>>2]=0;m=h+4|0;f[m>>2]=0;f[h+8>>2]=0;Rva(h,j,j+(d<<2)|0);ydb(a,g,h);a=f[h>>2]|0;if(a|0){h=f[m>>2]|0;if((h|0)!=(a|0))f[m>>2]=h+(~((h+-4-a|0)>>>2)<<2);O5b(a)}a=f[g>>2]|0;if(a|0){g=f[k>>2]|0;if((g|0)!=(a|0))f[k>>2]=g+(~((g+-4-a|0)>>>2)<<2);O5b(a)}u=e;return}function sdb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=u;u=u+32|0;g=e+16|0;h=e;dQ(g,121016);i=f[c>>2]|0;j=(f[c+4>>2]|0)-i>>2;k=i;a:do if(!(b[a+100>>0]|0)){if(j|0){i=h+8|0;l=h+4|0;m=h+4|0;n=0;do{o=f[d>>2]|0;p=f[o+(n*56|0)+4>>2]|0;if((p|0)<3)q=Y(f[o+(n*56|0)+12>>2]|0,f[o+(n*56|0)+8>>2]|0)|0;else{r=f[o+(n*56|0)+40>>2]|0;s=0;t=1;while(1){v=Y(f[r+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(p|0)){q=v;break}else t=v}}t=f[(f[c>>2]|0)+(n<<2)>>2]|0;p=f[t+4>>2]|0;if((p|0)<3)w=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;else{s=f[t+40>>2]|0;r=0;v=1;while(1){x=Y(f[s+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(p|0)){w=x;break}else v=x}}if((q|0)==(w|0)){y=o;z=t}else{f[h>>2]=0;f[m>>2]=0;A=aD(h,40)|0;B=420636;C=A+40|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,443123,420141,323);bD(h);y=f[d>>2]|0;z=f[(f[c>>2]|0)+(n<<2)>>2]|0}if((f[y+(n*56|0)+16>>2]|0)!=(f[z+16>>2]|0)){t=i;f[t>>2]=0;f[t+4>>2]=0;f[h>>2]=33619968;f[l>>2]=y+(n*56|0);SP(z,h)}n=n+1|0}while(n>>>0<j>>>0)}}else{n=f[a+36>>2]|0;l=f[a+104>>2]|0;i=f[a+88>>2]|0;m=f[a+76>>2]|0;t=a+40|0;o=f[t>>2]|0;if(j|0){v=h+4|0;p=(l|0)==4;r=(n|0)==0;s=(l|0)==0;x=h+4|0;D=h+4|0;E=h+4|0;F=0;G=k;while(1){H=f[G+(F<<2)>>2]|0;I=f[d>>2]|0;J=I+(F*56|0)|0;b:do if((f[H+4>>2]|0)==(l|0)?(K=f[H+40>>2]|0,L=f[K+-4>>2]|0,M=f[(f[G>>2]|0)+40>>2]|0,(L|0)==(f[M+-4>>2]|0)):0){if((L|0)==2){if((f[K>>2]|0)!=(f[M>>2]|0)){N=29;break}if((f[K+4>>2]|0)==(f[M+4>>2]|0))break;else{N=29;break}}if((L|0)>0){O=0;do{if((f[K+(O<<2)>>2]|0)!=(f[M+(O<<2)>>2]|0)){N=29;break b}O=O+1|0}while((O|0)<(L|0))}}else N=29;while(0);if((N|0)==29){N=0;f[h>>2]=0;f[E>>2]=0;A=aD(h,50)|0;B=420677;C=A+50|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,443123,420141,340);bD(h)}c:do if((f[I+(F*56|0)+4>>2]|0)==(l|0)?(L=f[I+(F*56|0)+40>>2]|0,O=f[L+-4>>2]|0,M=f[(f[d>>2]|0)+40>>2]|0,(O|0)==(f[M+-4>>2]|0)):0){if((O|0)==2){if((f[L>>2]|0)!=(f[M>>2]|0)){N=38;break}if((f[L+4>>2]|0)==(f[M+4>>2]|0))break;else{N=38;break}}if((O|0)>0){K=0;do{if((f[L+(K<<2)>>2]|0)!=(f[M+(K<<2)>>2]|0)){N=38;break c}K=K+1|0}while((K|0)<(O|0))}}else N=38;while(0);if((N|0)==38){N=0;f[h>>2]=0;f[D>>2]=0;A=aD(h,50)|0;B=420728;C=A+50|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,443123,420141,341);bD(h)}O=f[H>>2]|0;if((O&16384|0)!=0?(f[J>>2]&16384|0)!=0:0)P=O;else{f[h>>2]=0;f[v>>2]=0;A=aD(h,40)|0;B=420779;C=A+40|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,443123,420141,343);bD(h);P=f[H>>2]|0}if(!((P&4095|0)==5?(f[J>>2]&4095|0)==5:0)){f[h>>2]=0;f[x>>2]=0;A=aD(h,34)|0;B=420820;C=A+34|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,443123,420141,344);bD(h)}d:do if(!p){O=f[H+16>>2]|0;K=f[I+(F*56|0)+16>>2]|0;if(!r){if(s){M=0;while(1){f[K+(M<<2)>>2]=f[O>>2];M=M+1|0;if((M|0)==(n|0))break d}}else Q=0;do{M=0;L=0;R=Q;while(1){S=f[i+(L<<2)>>2]|0;M=(Y(f[m+(f[o+(L<<2)>>2]<<2)>>2]|0,(R>>>0)/(S>>>0)|0)|0)+M|0;L=L+1|0;if((L|0)==(l|0))break;else R=(R>>>0)%(S>>>0)|0}f[K+(Q<<2)>>2]=f[O+(M<<2)>>2];Q=Q+1|0}while((Q|0)!=(n|0))}}else vdb(H,J,t,SQ()|0);while(0);J=F+1|0;if(J>>>0>=j>>>0)break a;F=J;G=f[c>>2]|0}}}while(0);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function tdb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,120984);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function udb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;h=u;u=u+32|0;i=h+24|0;j=h+12|0;k=h;if(!(b[a+100>>0]|0)){yua(a,c,d,e,g)|0;l=1;u=h;return l|0}g=c+4|0;d=f[c>>2]|0;if((f[g>>2]|0)==(d|0)){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,17)|0;n=441774;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,442770,420141,126);bD(i);p=c;q=f[c>>2]|0}else{p=c;q=d}d=a+104|0;if((f[d>>2]|0)==((f[q+4>>2]|0)-(f[q>>2]|0)>>2|0))r=q;else{f[i>>2]=0;f[i+4>>2]=0;m=aD(i,33)|0;n=420367;o=m+33|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,442770,420141,127);bD(i);r=f[p>>2]|0}Bua(j,r);f[k>>2]=0;r=k+4|0;f[r>>2]=0;f[k+8>>2]=0;a:do if(f[d>>2]|0){q=a+40|0;s=k+8|0;t=0;v=0;w=0;while(1){x=(f[j>>2]|0)+(f[(f[q>>2]|0)+(t<<2)>>2]<<2)|0;if((v|0)==(w|0))IO(k,x);else{f[v>>2]=f[x>>2];f[r>>2]=v+4}x=t+1|0;if(x>>>0>=(f[d>>2]|0)>>>0)break a;t=x;v=f[r>>2]|0;w=f[s>>2]|0}}while(0);d=f[e>>2]|0;a=e+4|0;s=f[a>>2]|0;if((s|0)!=(d|0)){w=s;while(1){s=w+-12|0;f[a>>2]=s;v=f[s>>2]|0;if(!v)y=s;else{s=w+-8|0;t=f[s>>2]|0;if((t|0)!=(v|0))f[s>>2]=t+(~((t+-4-v|0)>>>2)<<2);O5b(v);y=f[a>>2]|0}if((y|0)==(d|0))break;else w=y}}y=f[c>>2]|0;b:do if((f[g>>2]|0)!=(y|0)){w=e+8|0;d=i+4|0;v=i+4|0;t=i+4|0;s=i+4|0;q=i+4|0;x=0;z=y;while(1){A=z;if(((f[A+(x*12|0)+4>>2]|0)-(f[A+(x*12|0)>>2]|0)|0)==16)B=A;else{f[i>>2]=0;f[q>>2]=0;m=aD(i,21)|0;n=420401;o=m+21|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,442770,420141,139);bD(i);B=f[p>>2]|0}A=f[B+(x*12|0)>>2]|0;C=f[j>>2]|0;if((f[A+8>>2]|0)==(f[C+8>>2]|0)?(f[A+12>>2]|0)==(f[C+12>>2]|0):0)D=B;else{f[i>>2]=0;f[s>>2]=0;m=aD(i,64)|0;n=420423;o=m+64|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,442770,420141,140);bD(i);D=f[p>>2]|0}C=f[D+(x*12|0)+4>>2]|0;A=f[D+(x*12|0)>>2]|0;E=C-A|0;F=E>>2;G=A;do if((G|0)!=(C|0)){if((E|0)<=-4){f[i>>2]=0;f[t>>2]=0;m=aD(i,70)|0;n=442586;o=m+70|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,442657,442663,160);bD(i);H=1;break}if((E|0)>0){A=0;I=1;while(1){J=Y(f[G+(A<<2)>>2]|0,I)|0;A=A+1|0;if((A|0)>=(F|0)){H=J;break}else I=J}}else H=1}else H=0;while(0);F=f[r>>2]|0;G=f[k>>2]|0;E=F-G|0;C=E>>2;I=G;do if((I|0)!=(F|0)){if((E|0)<=-4){f[i>>2]=0;f[v>>2]=0;m=aD(i,70)|0;n=442586;o=m+70|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,442657,442663,160);bD(i);K=1;break}if((E|0)>0){G=0;A=1;while(1){J=Y(f[I+(G<<2)>>2]|0,A)|0;G=G+1|0;if((G|0)>=(C|0)){K=J;break}else A=J}}else K=1}else K=0;while(0);if((H|0)!=(K|0)){f[i>>2]=0;f[d>>2]=0;m=aD(i,37)|0;n=420488;o=m+37|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,442770,420141,141);bD(i)}L=f[a>>2]|0;if((L|0)==(f[w>>2]|0))Sva(e,k);else{f[L>>2]=0;C=L+4|0;f[C>>2]=0;f[L+8>>2]=0;I=(f[r>>2]|0)-(f[k>>2]|0)|0;E=I>>2;if(E|0){if(E>>>0>1073741823)break;F=L5b(I)|0;f[C>>2]=F;f[L>>2]=F;f[L+8>>2]=F+(E<<2);E=f[k>>2]|0;I=(f[r>>2]|0)-E|0;if((I|0)>0){Vac(F|0,E|0,I|0)|0;f[C>>2]=F+(I>>>2<<2)}}f[a>>2]=(f[a>>2]|0)+12}x=x+1|0;z=f[c>>2]|0;if(x>>>0>=(((f[g>>2]|0)-z|0)/12|0)>>>0)break b}c4b(L)}while(0);L=f[k>>2]|0;if(L|0){k=f[r>>2]|0;if((k|0)!=(L|0))f[r>>2]=k+(~((k+-4-L|0)>>>2)<<2);O5b(L)}L=f[j>>2]|0;if(L|0){k=j+4|0;j=f[k>>2]|0;if((j|0)!=(L|0))f[k>>2]=j+(~((j+-4-L|0)>>>2)<<2);O5b(L)}l=0;u=h;return l|0}function vdb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0.0;e=u;u=u+32|0;g=e+8|0;h=e;f[g>>2]=121056;f[g+4>>2]=a;f[g+8>>2]=b;f[g+12>>2]=c;f[g+16>>2]=d;i=f[b+40>>2]|0;b=f[c>>2]|0;c=f[a+40>>2]|0;if((((f[i>>2]|0)==(f[c+(f[b>>2]<<2)>>2]|0)?(f[i+4>>2]|0)==(f[c+(f[b+4>>2]<<2)>>2]|0):0)?(f[i+8>>2]|0)==(f[c+(f[b+8>>2]<<2)>>2]|0):0)?(f[i+12>>2]|0)==(f[c+(f[b+12>>2]<<2)>>2]|0):0){f[h>>2]=0;j=h+4|0;f[j>>2]=d;k=+(d|0);RQ(h,g,k);u=e;return}f[h>>2]=0;f[h+4>>2]=0;Vac(aD(h,144)|0,420855,144)|0;bO(-215,h,443206,420141,216);bD(h);f[h>>2]=0;j=h+4|0;f[j>>2]=d;k=+(d|0);RQ(h,g,k);u=e;return}function wdb(a){a=a|0;O5b(a);return}function xdb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=f[a+8>>2]|0;d=f[c+40>>2]|0;e=f[d>>2]|0;g=f[d+4>>2]|0;h=f[d+8>>2]|0;i=f[d+12>>2]|0;d=Y(Y(g,e)|0,h)|0;j=f[a+16>>2]|0;k=((d+-1+j|0)>>>0)/(j>>>0)|0;j=Y(f[b>>2]|0,k)|0;l=Y(f[b+4>>2]|0,k)|0;k=d>>>0<l>>>0?d:l;l=f[c+44>>2]|0;d=(f[l>>2]|0)>>>2;b=(f[l+4>>2]|0)>>>2;m=(f[l+8>>2]|0)>>>2;l=f[a+12>>2]|0;n=f[l>>2]|0;if((f[l+4>>2]|0)==(n|0))d4b(l);l=n;n=f[a+4>>2]|0;a=f[n+44>>2]|0;o=(f[a+(f[l>>2]<<2)>>2]|0)>>>2;p=(f[a+(f[l+4>>2]<<2)>>2]|0)>>>2;q=(f[a+(f[l+8>>2]<<2)>>2]|0)>>>2;r=(f[a+(f[l+12>>2]<<2)>>2]|0)>>>2;l=(j>>>0)/(h>>>0)|0;a=f[n+16>>2]|0;n=f[c+16>>2]|0;if(!(j>>>0<k>>>0&(i|0)>0))return;c=(j>>>0)%(h>>>0)|0;s=(l>>>0)%(g>>>0)|0;t=j;j=(l>>>0)/(g>>>0)|0;while(1){l=a+((Y(j,o)|0)<<2)+((Y(s,p)|0)<<2)+((Y(c,q)|0)<<2)|0;u=n+((Y(j,d)|0)<<2)+((Y(s,b)|0)<<2)+((Y(c,m)|0)<<2)|0;v=0;do{w=l+((Y(v,r)|0)<<2)|0;f[u+(v<<2)>>2]=f[w>>2];v=v+1|0}while((v|0)!=(i|0));v=c+1|0;if((v|0)>=(h|0)){u=s+1|0;if((u|0)>=(g|0)){l=j+1|0;if((l|0)<(e|0)){x=0;y=0;z=l}else{A=11;break}}else{x=0;y=u;z=j}}else{x=v;y=s;z=j}t=t+1|0;if(t>>>0>=k>>>0){A=11;break}else{c=x;s=y;j=z}}if((A|0)==11)return}function ydb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=a+76|0;e=a+104|0;g=f[e>>2]|0;h=a+80|0;i=f[h>>2]|0;j=f[d>>2]|0;k=i-j>>2;l=j;j=i;if(g>>>0<=k>>>0)if(g>>>0<k>>>0?(i=l+(g<<2)|0,(j|0)!=(i|0)):0){f[h>>2]=j+(~((j+-4-i|0)>>>2)<<2);m=g}else m=g;else{UN(d,g-k|0);m=f[e>>2]|0}k=a+88|0;g=a+92|0;i=f[g>>2]|0;j=f[k>>2]|0;h=i-j>>2;l=j;j=i;if(m>>>0<=h>>>0)if(m>>>0<h>>>0?(i=l+(m<<2)|0,(j|0)!=(i|0)):0){f[g>>2]=j+(~((j+-4-i|0)>>>2)<<2);n=m;o=l}else{n=m;o=l}else{UN(k,m-h|0);n=f[e>>2]|0;o=f[k>>2]|0}h=f[d>>2]|0;f[h+(n+-1<<2)>>2]=1;f[o+((f[e>>2]|0)+-1<<2)>>2]=1;o=(f[e>>2]|0)+-2|0;if((o|0)<=-1){p=f[b>>2]|0;q=f[h>>2]|0;r=f[p>>2]|0;s=Y(r,q)|0;t=a+36|0;f[t>>2]=s;return}e=f[b>>2]|0;b=f[k>>2]|0;k=f[c>>2]|0;c=o;while(1){o=c+1|0;n=Y(f[e+(o<<2)>>2]|0,f[h+(o<<2)>>2]|0)|0;f[h+(c<<2)>>2]=n;n=Y(f[k+(o<<2)>>2]|0,f[b+(o<<2)>>2]|0)|0;f[b+(c<<2)>>2]=n;if((c|0)>0)c=c+-1|0;else{p=e;break}}q=f[h>>2]|0;r=f[p>>2]|0;s=Y(r,q)|0;t=a+36|0;f[t>>2]=s;return}function zdb(a,b){a=a|0;b=b|0;var c=0;c=L5b(60)|0;Adb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=121076;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Adb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d+8|0;g=d;Jwa(a);h=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a>>2]=121096;Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;i=aD(e,8)|0;j=i;b[j>>0]=112;b[j+1>>0]=111;b[j+2>>0]=111;b[j+3>>0]=108;j=i+4|0;b[j>>0]=95;b[j+1>>0]=107;b[j+2>>0]=95;b[j+3>>0]=119;j=Gwa(Eya(c,e)|0,-1)|0;f[g>>2]=0;f[g+4>>2]=0;i=aD(g,8)|0;k=i;b[k>>0]=112;b[k+1>>0]=111;b[k+2>>0]=111;b[k+3>>0]=108;k=i+4|0;b[k>>0]=95;b[k+1>>0]=107;b[k+2>>0]=95;b[k+3>>0]=104;k=Gwa(Eya(c,g)|0,-1)|0;f[h>>2]=j;f[a+40>>2]=k;bD(g);bD(e);f[e>>2]=0;f[e+4>>2]=0;k=aD(e,10)|0;j=421336;h=k+10|0;do{b[k>>0]=b[j>>0]|0;k=k+1|0;j=j+1|0}while((k|0)<(h|0));i=Gwa(Eya(c,e)|0,-1)|0;f[g>>2]=0;f[g+4>>2]=0;k=aD(g,10)|0;j=421347;h=k+10|0;do{b[k>>0]=b[j>>0]|0;k=k+1|0;j=j+1|0}while((k|0)<(h|0));l=Gwa(Eya(c,g)|0,-1)|0;f[a+44>>2]=i;f[a+48>>2]=l;bD(g);bD(e);f[e>>2]=0;f[e+4>>2]=0;k=aD(e,13)|0;j=421358;h=k+13|0;do{b[k>>0]=b[j>>0]|0;k=k+1|0;j=j+1|0}while((k|0)<(h|0));l=Gwa(Eya(c,e)|0,-1)|0;f[g>>2]=0;f[g+4>>2]=0;k=aD(g,13)|0;j=421372;h=k+13|0;do{b[k>>0]=b[j>>0]|0;k=k+1|0;j=j+1|0}while((k|0)<(h|0));j=Gwa(Eya(c,g)|0,-1)|0;f[a+52>>2]=l;f[a+56>>2]=j;bD(g);bD(e);u=d;return}function Bdb(a){a=a|0;O5b(a);return}function Cdb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Ddb(a){a=a|0;lua(a);O5b(a);return}function Edb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;e=u;u=u+192|0;a=e+64|0;g=e+56|0;h=e;dQ(g,121220);i=f[c>>2]|0;if(((f[c+4>>2]|0)-i|0)==8)j=i;else{f[a>>2]=0;f[a+4>>2]=0;k=aD(a,18)|0;l=442898;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,a,443123,421386,73);bD(a);j=f[c>>2]|0}c=f[j>>2]|0;i=f[j+4>>2]|0;j=f[c+4>>2]|0;if((j|0)<3)o=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{q=f[c+40>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(j|0)){o=t;break}else s=t}}s=f[i+4>>2]|0;if((s|0)<3)v=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{j=f[i+40>>2]|0;r=0;q=1;while(1){t=Y(f[j+(r<<2)>>2]|0,q)|0;r=r+1|0;if((r|0)==(s|0)){v=t;break}else q=t}}if((o|0)!=(v|0)){f[a>>2]=0;f[a+4>>2]=0;k=aD(a,32)|0;l=421622;m=k+32|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,a,443123,421386,77);bD(a)}v=c+40|0;if((f[f[v>>2]>>2]|0)!=1){f[a>>2]=0;f[a+4>>2]=0;k=aD(a,18)|0;l=421655;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,a,443123,421386,78);bD(a)}if(!(f[c>>2]&16384)){f[a>>2]=0;f[a+4>>2]=0;k=aD(a,20)|0;l=421674;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,a,443123,421386,79);bD(a)}o=d+4|0;q=f[d>>2]|0;if((f[o>>2]|0)!=(q|0)){s=a+8|0;r=a+12|0;j=a+4|0;t=c+16|0;w=c+44|0;c=i+16|0;x=i+44|0;y=h+16|0;z=h+44|0;A=h+36|0;B=h+4|0;C=h+40|0;D=h+48|0;E=i+40|0;i=a+4|0;F=a+4|0;G=a+4|0;H=0;I=q;do{q=I;J=q+(H*56|0)|0;p[h>>3]=0.0;f[a>>2]=-1056833530;f[j>>2]=h;f[s>>2]=1;f[r>>2]=1;VP(J,a,UM()|0)|0;K=f[(f[v>>2]|0)+4>>2]|0;L=q+(H*56|0)+40|0;M=f[L>>2]|0;if((K|0)==(f[M+4>>2]|0)){N=M;O=K}else{f[a>>2]=0;f[G>>2]=0;k=aD(a,32)|0;l=421695;m=k+32|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,a,443123,421386,85);bD(a);N=f[L>>2]|0;O=f[(f[v>>2]|0)+4>>2]|0}K=Y(f[N+12>>2]|0,f[N+8>>2]|0)|0;if((O|0)>0){M=q+(H*56|0)+4|0;P=q+(H*56|0)+16|0;Q=q+(H*56|0)+44|0;R=0;do{S=f[M>>2]|0;if((S|0)<=2){f[a>>2]=0;f[F>>2]=0;k=aD(a,10)|0;l=435143;m=k+10|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,a,435154,442663,114);bD(a);T=f[M>>2]|0;if((T|0)>2){U=T;V=33}else W=T}else{U=S;V=33}if((V|0)==33){V=0;T=f[L>>2]|0;X=2;do{f[a+(X+-2<<2)>>2]=f[T+(X<<2)>>2];X=X+1|0}while((X|0)<(U|0));W=U}oL(h,W+-2|0,a,f[J>>2]&4095,(f[P>>2]|0)+(Y(f[(f[Q>>2]|0)+4>>2]|0,R)|0)|0,0);X=f[v>>2]|0;T=Y(f[X+12>>2]|0,f[X+8>>2]|0)|0;X=(f[t>>2]|0)+(Y(f[(f[w>>2]|0)+4>>2]|0,R)|0)|0;S=(f[c>>2]|0)+(Y(f[(f[x>>2]|0)+4>>2]|0,R)|0)|0;Z=f[y>>2]|0;if((T|0)>0){_=0;do{$=~~+n[S+(_<<2)>>2];if(($|0)>-1&($|0)<(K|0))aa=X+(_<<2)|0;else{ba=iYb(rP(854796,421728,4)|0,H)|0;TXb(a,ba+(f[(f[ba>>2]|0)+-12>>2]|0)|0);ca=xZb(a,855500)|0;da=Uh[f[(f[ca>>2]|0)+28>>2]&1023](ca,10)|0;yZb(a);mYb(ba,da)|0;ZXb(ba)|0;da=iYb(rP(ba,421733,4)|0,R)|0;TXb(a,da+(f[(f[da>>2]|0)+-12>>2]|0)|0);ba=xZb(a,855500)|0;ca=Uh[f[(f[ba>>2]|0)+28>>2]&1023](ba,10)|0;yZb(a);mYb(da,ca)|0;ZXb(da)|0;ca=iYb(rP(da,421738,5)|0,_)|0;TXb(a,ca+(f[(f[ca>>2]|0)+-12>>2]|0)|0);da=xZb(a,855500)|0;ba=Uh[f[(f[da>>2]|0)+28>>2]&1023](da,10)|0;yZb(a);mYb(ca,ba)|0;ZXb(ca)|0;ba=iYb(rP(ca,421744,6)|0,$)|0;TXb(a,ba+(f[(f[ba>>2]|0)+-12>>2]|0)|0);ca=xZb(a,855500)|0;da=Uh[f[(f[ca>>2]|0)+28>>2]&1023](ca,10)|0;yZb(a);mYb(ba,da)|0;ZXb(ba)|0;da=rP(ba,421751,7)|0;ba=X+(_<<2)|0;ca=lYb(da,+n[ba>>2])|0;TXb(a,ca+(f[(f[ca>>2]|0)+-12>>2]|0)|0);da=xZb(a,855500)|0;ea=Uh[f[(f[da>>2]|0)+28>>2]&1023](da,10)|0;yZb(a);mYb(ca,ea)|0;ZXb(ca)|0;ea=iYb(rP(ca,421759,14)|0,K)|0;TXb(a,ea+(f[(f[ea>>2]|0)+-12>>2]|0)|0);ca=xZb(a,855500)|0;da=Uh[f[(f[ca>>2]|0)+28>>2]&1023](ca,10)|0;yZb(a);mYb(ea,da)|0;ZXb(ea)|0;da=rP(ea,421774,11)|0;ea=f[v>>2]|0;ca=f[ea+-4>>2]|0;a:do if((ca|0)>0){fa=ca+-1|0;ga=0;ha=ea;while(1){iYb(da,f[ha+(ga<<2)>>2]|0)|0;if((ga|0)<(fa|0))rP(da,421786,3)|0;ia=ga+1|0;if((ia|0)==(ca|0))break a;ga=ia;ha=f[v>>2]|0}}while(0);TXb(a,da+(f[(f[da>>2]|0)+-12>>2]|0)|0);ca=xZb(a,855500)|0;ea=Uh[f[(f[ca>>2]|0)+28>>2]&1023](ca,10)|0;yZb(a);mYb(da,ea)|0;ZXb(da)|0;ea=rP(da,421790,13)|0;ca=f[E>>2]|0;ha=f[ca+-4>>2]|0;b:do if((ha|0)>0){ga=ha+-1|0;fa=0;ia=ca;while(1){iYb(ea,f[ia+(fa<<2)>>2]|0)|0;if((fa|0)<(ga|0))rP(ea,421786,3)|0;ja=fa+1|0;if((ja|0)==(ha|0))break b;fa=ja;ia=f[E>>2]|0}}while(0);TXb(a,ea+(f[(f[ea>>2]|0)+-12>>2]|0)|0);ha=xZb(a,855500)|0;ca=Uh[f[(f[ha>>2]|0)+28>>2]&1023](ha,10)|0;yZb(a);mYb(ea,ca)|0;ZXb(ea)|0;ca=rP(ea,421804,8)|0;ha=f[L>>2]|0;da=f[ha+-4>>2]|0;c:do if((da|0)>0){ia=da+-1|0;fa=0;ga=ha;while(1){iYb(ca,f[ga+(fa<<2)>>2]|0)|0;if((fa|0)<(ia|0))rP(ca,421786,3)|0;ja=fa+1|0;if((ja|0)==(da|0))break c;fa=ja;ga=f[L>>2]|0}}while(0);TXb(a,ca+(f[(f[ca>>2]|0)+-12>>2]|0)|0);da=xZb(a,855500)|0;ha=Uh[f[(f[da>>2]|0)+28>>2]&1023](da,10)|0;yZb(a);mYb(ca,ha)|0;ZXb(ca)|0;f[a>>2]=0;f[i>>2]=0;k=aD(a,35)|0;l=421813;m=k+35|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,a,443123,421386,112);bD(a);aa=ba}f[Z+($<<2)>>2]=f[aa>>2];_=_+1|0}while((_|0)<(T|0))}T=f[A>>2]|0;if(T|0?(_=T+12|0,T=f[_>>2]|0,f[_>>2]=T+-1,(T|0)==1):0)kL(h);f[A>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[B>>2]|0)>0){T=f[C>>2]|0;_=0;do{f[T+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[B>>2]|0))}_=f[z>>2]|0;if((_|0)!=(D|0))UC(_);R=R+1|0}while((R|0)<(f[(f[v>>2]|0)+4>>2]|0))}H=H+1|0;I=f[d>>2]|0}while(H>>>0<(((f[o>>2]|0)-I|0)/56|0)>>>0)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Fdb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,121188);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Gdb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{if(Owa()|0?(f[a+44>>2]|0)==0:0)c=(f[a+48>>2]|0)==0;else c=0;break}default:c=0}return c|0}function Hdb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Idb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;if(((f[c+4>>2]|0)-h|0)==24){i=c;j=h}else{f[d>>2]=0;f[d+4>>2]=0;k=aD(d,18)|0;l=442898;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,d,442770,421386,47);bD(d);i=c;j=f[c>>2]|0}c=f[j+4>>2]|0;h=f[j>>2]|0;j=c-h|0;n=j>>2;o=h;do if((o|0)!=(c|0)){if((j|0)<=-4){f[d>>2]=0;f[d+4>>2]=0;k=aD(d,70)|0;l=442586;m=k+70|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,d,442657,442663,160);bD(d);p=1;break}if((j|0)>0){h=0;q=1;while(1){r=Y(f[o+(h<<2)>>2]|0,q)|0;h=h+1|0;if((h|0)>=(n|0)){p=r;break}else q=r}}else p=1}else p=0;while(0);n=f[i>>2]|0;o=f[n+16>>2]|0;j=f[n+12>>2]|0;n=o-j|0;c=n>>2;q=j;do if((q|0)!=(o|0)){if((n|0)<=-4){f[d>>2]=0;f[d+4>>2]=0;k=aD(d,70)|0;l=442586;m=k+70|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,d,442657,442663,160);bD(d);s=1;break}if((n|0)>0){j=0;h=1;while(1){r=Y(f[q+(j<<2)>>2]|0,h)|0;j=j+1|0;if((j|0)>=(c|0)){s=r;break}else h=r}}else s=1}else s=0;while(0);if((p|0)!=(s|0)){f[d>>2]=0;f[d+4>>2]=0;k=aD(d,36)|0;l=421473;m=k+36|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,d,442770,421386,48);bD(d)}Bua(d,f[i>>2]|0);i=f[d>>2]|0;l=i+8|0;k=Y((f[l>>2]|0)+-1|0,f[a+56>>2]|0)|0;f[l>>2]=k+(f[a+40>>2]|0)-(f[a+48>>2]<<1);k=i+12|0;i=Y((f[k>>2]|0)+-1|0,f[a+52>>2]|0)|0;f[k>>2]=i+(f[a+36>>2]|0)-(f[a+44>>2]<<1);a=f[e>>2]|0;i=e+4|0;k=f[i>>2]|0;if((k|0)!=(a|0)){l=k;while(1){k=l+-12|0;f[i>>2]=k;m=f[k>>2]|0;if(!m)t=k;else{k=l+-8|0;s=f[k>>2]|0;if((s|0)!=(m|0))f[k>>2]=s+(~((s+-4-m|0)>>>2)<<2);O5b(m);t=f[i>>2]|0}if((t|0)==(a|0))break;else l=t}}if((a|0)==(f[e+8>>2]|0)){Sva(e,d);v=f[d>>2]|0}else{f[a>>2]=0;e=a+4|0;f[e>>2]=0;f[a+8>>2]=0;t=d+4|0;l=f[d>>2]|0;m=(f[t>>2]|0)-l|0;s=m>>2;if(s){if(s>>>0>1073741823)c4b(a);k=L5b(m)|0;f[e>>2]=k;f[a>>2]=k;f[a+8>>2]=k+(s<<2);s=f[d>>2]|0;a=(f[t>>2]|0)-s|0;if((a|0)>0){Vac(k|0,s|0,a|0)|0;f[e>>2]=k+(a>>>2<<2);w=s}else w=s}else w=l;f[i>>2]=(f[i>>2]|0)+12;v=w}if(!v){u=g;return 0}w=d+4|0;d=f[w>>2]|0;if((d|0)!=(v|0))f[w>>2]=d+(~((d+-4-v|0)>>>2)<<2);O5b(v);u=g;return 0}function Jdb(a,b){a=a|0;b=b|0;var c=0;c=L5b(156)|0;Kdb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=121260;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Kdb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,K=0,L=0,N=0.0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0;d=u;u=u+16|0;e=d;Jwa(a);f[a>>2]=121280;g=a+44|0;f[g>>2]=1124007936;h=a+48|0;i=a+52|0;j=a+84|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;j=a+92|0;f[a+88>>2]=j;f[j>>2]=0;f[a+96>>2]=0;j=a+100|0;f[j>>2]=1124007936;m=a+104|0;o=a+108|0;p=a+140|0;k=m;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[p>>2]=o;p=a+148|0;f[a+144>>2]=p;f[p>>2]=0;f[a+152>>2]=0;Kwa(a,c);p=a+4|0;q=a+8|0;if((((f[q>>2]|0)-(f[p>>2]|0)|0)/56|0)>>>0<=2){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,17)|0;r=423011;l=k+17|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));bO(-215,e,422120,422139,29);bD(e)}f[e>>2]=0;f[e+4>>2]=0;k=aD(e,10)|0;r=422223;l=k+10|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));s=c+4|0;c=f[s>>2]|0;do if(c){t=f[e>>2]|0;v=(t|0)==0?1124530:t;w=s;x=c;a:while(1){y=x;while(1){z=f[y+16>>2]|0;if((z|0)==(t|0))break;if((gTb((z|0)==0?1124530:z,v)|0)>=0)break;z=f[y+4>>2]|0;if(!z){A=w;break a}else y=z}x=f[y>>2]|0;if(!x){A=y;break}else w=y}if((A|0)!=(s|0)){w=f[A+16>>2]|0;if((t|0)!=(w|0)?(gTb(v,(w|0)==0?1124530:w)|0)<=-1:0){B=0;break}w=Gwa(A+24|0,-1)|0;B=(w|0)!=0|(J|0)!=0}else B=0}else B=0;while(0);A=a+36|0;b[A>>0]=B&1;bD(e);f[e>>2]=0;f[e+4>>2]=0;B=aD(e,8)|0;c=B;b[c>>0]=104;b[c+1>>0]=97;b[c+2>>0]=115;b[c+3>>0]=95;c=B+4|0;b[c>>0]=98;b[c+1>>0]=105;b[c+2>>0]=97;b[c+3>>0]=115;c=f[s>>2]|0;do if(c){B=f[e>>2]|0;w=(B|0)==0?1124530:B;x=s;z=c;b:while(1){C=z;while(1){D=f[C+16>>2]|0;if((D|0)==(B|0))break;if((gTb((D|0)==0?1124530:D,w)|0)>=0)break;D=f[C+4>>2]|0;if(!D){E=x;break b}else C=D}z=f[C>>2]|0;if(!z){E=C;break}else x=C}if((E|0)!=(s|0)){x=f[E+16>>2]|0;if((B|0)!=(x|0)?(gTb(w,(x|0)==0?1124530:x)|0)<=-1:0){F=0;break}x=Gwa(E+24|0,-1)|0;F=(x|0)!=0|(J|0)!=0}else F=0}else F=0;while(0);E=a+37|0;b[E>>0]=F&1;bD(e);f[e>>2]=0;f[e+4>>2]=0;F=aD(e,3)|0;b[F>>0]=b[433709]|0;b[F+1>>0]=b[433710]|0;b[F+2>>0]=b[433711]|0;F=f[s>>2]|0;do if(F){c=f[e>>2]|0;x=(c|0)==0?1124530:c;z=s;v=F;c:while(1){t=v;while(1){y=f[t+16>>2]|0;if((y|0)==(c|0))break;if((gTb((y|0)==0?1124530:y,x)|0)>=0)break;y=f[t+4>>2]|0;if(!y){G=z;break c}else t=y}v=f[t>>2]|0;if(!v){G=t;break}else z=t}if((G|0)!=(s|0)){z=f[G+16>>2]|0;if((c|0)!=(z|0)?(gTb(x,(z|0)==0?1124530:z)|0)<=-1:0){H=9.999999747378752e-06;break}H=+Hya(G+24|0,-1)}else H=9.999999747378752e-06}else H=9.999999747378752e-06;while(0);G=a+40|0;n[G>>2]=H;bD(e);s=f[p>>2]|0;F=f[s+4>>2]|0;if((F|0)<3)I=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;else{z=f[s+40>>2]|0;v=0;w=1;while(1){B=Y(f[z+(v<<2)>>2]|0,w)|0;v=v+1|0;if((v|0)==(F|0)){I=B;break}else w=B}}w=f[s+60>>2]|0;if((w|0)<3)K=Y(f[s+68>>2]|0,f[s+64>>2]|0)|0;else{F=f[s+96>>2]|0;v=0;z=1;while(1){B=Y(f[F+(v<<2)>>2]|0,z)|0;v=v+1|0;if((v|0)==(w|0)){K=B;break}else z=B}}if(!(((K|0)==(I|0)?(K=f[s>>2]|0,(K&16384|0)!=0):0)?((K&4095|0)==5?(f[s+56>>2]&20479|0)==16389:0):0)){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,123)|0;r=422234;l=k+123|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));bO(-215,e,422120,422139,38);bD(e)}s=b[A>>0]|0;if(!(s<<24>>24)){if(!(b[E>>0]|0)){K=f[p>>2]|0;if((f[K+112>>2]&4095|0)==5)L=K;else{f[e>>2]=0;f[e+4>>2]=0;k=aD(e,20)|0;r=422358;l=k+20|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));bO(-215,e,422120,422139,42);bD(e);L=f[p>>2]|0}H=+n[f[L+128>>2]>>2];if(H!=0.0)N=1.0/H;else N=H}else N=1.0;L=b[A>>0]|0;K=(L|2)&255;if(!(L<<24>>24)){O=N;P=K}else{Q=N;R=K;S=56}}else{Q=1.0;R=(s|2)&255;S=56}do if((S|0)==56){s=f[p>>2]|0;if((((f[q>>2]|0)-s|0)/56|0)>>>0>2)T=s;else{f[e>>2]=0;f[e+4>>2]=0;k=aD(e,39)|0;r=422379;l=k+39|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));bO(-215,e,422120,422139,53);bD(e);T=f[p>>2]|0}if((f[T+112>>2]&20479|0)==16389){x=f[T+116>>2]|0;if((x|0)<3)U=Y(f[T+124>>2]|0,f[T+120>>2]|0)|0;else{c=f[T+152>>2]|0;s=0;K=1;while(1){L=Y(f[c+(s<<2)>>2]|0,K)|0;s=s+1|0;if((s|0)==(x|0)){U=L;break}else K=L}}if((U|0)==(I|0)){O=Q;P=R;break}}f[e>>2]=0;f[e+4>>2]=0;k=aD(e,59)|0;r=422419;l=k+59|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));bO(-215,e,422120,422139,55);bD(e);O=Q;P=R}while(0);do if(b[E>>0]|0){R=f[p>>2]|0;if(P>>>0<(((f[q>>2]|0)-R|0)/56|0)>>>0)V=R;else{f[e>>2]=0;f[e+4>>2]=0;k=aD(e,36)|0;r=422479;l=k+36|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));bO(-215,e,422120,422139,60);bD(e);V=f[p>>2]|0}if((f[V+112>>2]&20479|0)==16389){R=f[V+116>>2]|0;if((R|0)<3)W=Y(f[V+124>>2]|0,f[V+120>>2]|0)|0;else{U=f[V+152>>2]|0;T=0;S=1;while(1){K=Y(f[U+(T<<2)>>2]|0,S)|0;T=T+1|0;if((T|0)==(R|0)){W=K;break}else S=K}}if((W|0)==(I|0))break}f[e>>2]=0;f[e+4>>2]=0;k=aD(e,59)|0;r=422516;l=k+59|0;do{b[k>>0]=b[r>>0]|0;k=k+1|0;r=r+1|0}while((k|0)<(l|0));bO(-215,e,422120,422139,62);bD(e)}while(0);r=f[p>>2]|0;p=f[r+16>>2]|0;k=f[r+72>>2]|0;if(!(b[A>>0]|0))X=0;else X=f[r+128>>2]|0;if(!(b[E>>0]|0))Z=0;else Z=f[r+(P*56|0)+16>>2]|0;if(!(((((f[h>>2]|0)<3?(f[i>>2]|0)==1:0)?(f[a+56>>2]|0)==(I|0):0)?(f[g>>2]&4095|0)==5:0)?(f[a+60>>2]|0)!=0:0)){f[e>>2]=1;f[e+4>>2]=I;hL(g,2,e,5)}if(((((f[m>>2]|0)<3?(f[o>>2]|0)==1:0)?(f[a+112>>2]|0)==(I|0):0)?(f[j>>2]&4095|0)==5:0)?(o=f[a+116>>2]|0,(o|0)!=0):0)_=o;else{f[e>>2]=1;f[e+4>>2]=I;hL(j,2,e,5);_=f[a+116>>2]|0}e=f[a+60>>2]|0;if(!I){u=d;return}a=(b[E>>0]|0)==0;if(b[A>>0]|0){A=0;do{Q=+n[X+(A<<2)>>2]/+M(+(O*+n[k+(A<<2)>>2]+ +n[G>>2]));n[e+(A<<2)>>2]=Q;if(a)$=0.0;else $=+n[Z+(A<<2)>>2];n[_+(A<<2)>>2]=$-O*(Q*+n[p+(A<<2)>>2]);A=A+1|0}while((A|0)!=(I|0));u=d;return}if(a){a=0;do{$=1.0/+M(+(O*+n[k+(a<<2)>>2]+ +n[G>>2]));n[e+(a<<2)>>2]=$;n[_+(a<<2)>>2]=0.0-O*($*+n[p+(a<<2)>>2]);a=a+1|0}while((a|0)!=(I|0));u=d;return}else{a=0;do{$=1.0/+M(+(O*+n[k+(a<<2)>>2]+ +n[G>>2]));n[e+(a<<2)>>2]=$;n[_+(a<<2)>>2]=+n[Z+(a<<2)>>2]-O*($*+n[p+(a<<2)>>2]);a=a+1|0}while((a|0)!=(I|0));u=d;return}}function Ldb(a){a=a|0;O5b(a);return}function Mdb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Ndb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=121280;b=a+100|0;c=a+136|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+116|0;b=a+104|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+140>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+144>>2]|0;if((b|0)!=(a+148|0))UC(b);b=a+44|0;d=a+80|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+60|0;b=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+84>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+88>>2]|0;if((b|0)==(a+92|0)){lua(a);return}UC(b);lua(a);return}function Odb(a){a=a|0;Ndb(a);O5b(a);return}function Pdb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;e=u;u=u+144|0;g=e+120|0;h=e+112|0;i=e+56|0;j=e;dQ(h,121408);if((((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)/56|0)>>>0<=1){f[g>>2]=0;f[g+4>>2]=0;k=aD(g,17)|0;l=422688;m=k+17|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,443123,422139,118);bD(g)}o=f[c>>2]|0;if(((f[c+4>>2]|0)-o|0)==4)p=o;else{f[g>>2]=0;f[g+4>>2]=0;k=aD(g,18)|0;l=443104;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,443123,422139,119);bD(g);p=f[c>>2]|0}c=f[p>>2]|0;p=c+4|0;o=f[p>>2]|0;switch(o|0){case 4:case 2:{q=o;break}default:{f[g>>2]=0;f[g+4>>2]=0;k=aD(g,38)|0;l=422706;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,443123,422139,122);bD(g);q=f[p>>2]|0}}if((q|0)>2){q=f[c+40>>2]|0;r=f[q+8>>2]|0;s=f[q+12>>2]|0}else{r=1;s=1}q=d+4|0;p=f[d>>2]|0;if((f[q>>2]|0)!=(p|0)){o=a+44|0;t=a+60|0;v=a+84|0;w=a+88|0;x=a+56|0;y=a+100|0;z=a+116|0;A=a+140|0;B=a+144|0;C=a+112|0;a=c+16|0;D=c+44|0;c=i+4|0;E=i+8|0;F=i+12|0;G=i+16|0;H=i+20|0;I=i+24|0;J=i+28|0;K=i+40|0;L=i+48|0;M=i+44|0;N=i+52|0;O=(Y(s,r)|0)!=0;P=g+4|0;Q=j+4|0;R=j+8|0;S=j+12|0;T=j+16|0;U=j+20|0;V=j+24|0;W=j+28|0;X=j+40|0;Z=j+48|0;_=j+44|0;$=j+52|0;aa=g+4|0;ba=g+8|0;ca=g+4|0;da=j+36|0;ea=i+36|0;fa=0;ga=p;do{p=ga;ha=p+(fa*56|0)+40|0;ia=f[ha>>2]|0;ja=f[ia>>2]|0;if((ja|0)>0){ka=p+(fa*56|0)+16|0;la=p+(fa*56|0)+44|0;p=0;ma=ja;ja=ia;while(1){if((f[ja+4>>2]|0)>0){ia=0;do{na=f[t>>2]|0;do if((f[o>>2]&16384|0)==0?(oa=f[v>>2]|0,(f[oa>>2]|0)!=1):0){pa=f[f[w>>2]>>2]|0;if((f[oa+4>>2]|0)==1){qa=na+(Y(pa,ia)|0)|0;break}else{oa=f[x>>2]|0;ra=(ia|0)/(oa|0)|0;qa=na+(Y(ra,pa)|0)+(ia-(Y(ra,oa)|0)<<2)|0;break}}else sa=25;while(0);if((sa|0)==25){sa=0;qa=na+(ia<<2)|0}ta=+n[qa>>2];oa=f[z>>2]|0;do if((f[y>>2]&16384|0)==0?(ra=f[A>>2]|0,(f[ra>>2]|0)!=1):0){pa=f[f[B>>2]>>2]|0;if((f[ra+4>>2]|0)==1){ua=oa+(Y(pa,ia)|0)|0;break}else{ra=f[C>>2]|0;va=(ia|0)/(ra|0)|0;ua=oa+(Y(va,pa)|0)+(ia-(Y(va,ra)|0)<<2)|0;break}}else sa=31;while(0);if((sa|0)==31){sa=0;ua=oa+(ia<<2)|0}wa=+n[ua>>2];na=f[D>>2]|0;ra=(f[a>>2]|0)+(Y(f[na>>2]|0,p)|0)|0;va=ra+(Y(f[na+4>>2]|0,ia)|0)|0;f[i>>2]=1124007941;f[c>>2]=2;f[E>>2]=r;f[F>>2]=s;f[G>>2]=va;f[H>>2]=va;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;f[K>>2]=E;f[M>>2]=L;f[N>>2]=0;f[L>>2]=0;if(O&(va|0)==0){f[g>>2]=0;f[P>>2]=0;k=aD(g,26)|0;l=426262;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,426289,431198,500);bD(g);xa=f[F>>2]|0;ya=f[i>>2]|0;za=f[M>>2]|0;Aa=f[H>>2]|0}else{xa=s;ya=1124007941;za=L;Aa=va}oa=xa<<2;f[i>>2]=ya|16384;f[za>>2]=oa;f[za+4>>2]=4;na=Aa+(Y(f[E>>2]|0,oa)|0)|0;f[J>>2]=na;f[I>>2]=na+(0-oa)+oa;oa=f[la>>2]|0;na=(f[ka>>2]|0)+(Y(f[oa>>2]|0,p)|0)|0;ra=na+(Y(f[oa+4>>2]|0,ia)|0)|0;f[j>>2]=1124007941;f[Q>>2]=2;f[R>>2]=r;f[S>>2]=s;f[T>>2]=ra;f[U>>2]=ra;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;f[X>>2]=R;f[_>>2]=Z;f[$>>2]=0;f[Z>>2]=0;if(O&(ra|0)==0){f[g>>2]=0;f[aa>>2]=0;k=aD(g,26)|0;l=426262;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,426289,431198,500);bD(g);Ba=f[S>>2]|0;Ca=f[j>>2]|0;Da=f[_>>2]|0;Ea=f[U>>2]|0}else{Ba=s;Ca=1124007941;Da=Z;Ea=ra}va=Ba<<2;f[j>>2]=Ca|16384;f[Da>>2]=va;f[Da+4>>2]=4;oa=Ea+(Y(f[R>>2]|0,va)|0)|0;f[W>>2]=oa;f[V>>2]=oa+(0-va)+va;va=ba;f[va>>2]=0;f[va+4>>2]=0;f[g>>2]=33619968;f[ca>>2]=j;OJ(i,g,5,ta,wa);va=f[da>>2]|0;if(va|0?(oa=va+12|0,va=f[oa>>2]|0,f[oa>>2]=va+-1,(va|0)==1):0)kL(j);f[da>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[Q>>2]|0)>0){va=f[X>>2]|0;oa=0;do{f[va+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[Q>>2]|0))}oa=f[_>>2]|0;if((oa|0)!=(Z|0))UC(oa);oa=f[ea>>2]|0;do if(oa|0){va=oa+12|0;ra=f[va>>2]|0;f[va>>2]=ra+-1;if((ra|0)!=1)break;kL(i)}while(0);f[ea>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[c>>2]|0)>0){oa=f[K>>2]|0;ra=0;do{f[oa+(ra<<2)>>2]=0;ra=ra+1|0}while((ra|0)<(f[c>>2]|0))}ra=f[M>>2]|0;if((ra|0)!=(L|0))UC(ra);ia=ia+1|0;Fa=f[ha>>2]|0}while((ia|0)<(f[Fa+4>>2]|0));Ga=f[Fa>>2]|0;Ha=Fa}else{Ga=ma;Ha=ja}p=p+1|0;if((p|0)>=(Ga|0))break;else{ma=Ga;ja=Ha}}}fa=fa+1|0;ga=f[d>>2]|0}while(fa>>>0<(((f[q>>2]|0)-ga|0)/56|0)>>>0)}if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function Qdb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,121376);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Rdb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function Sdb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Tdb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Udb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yua(a,b,c,d,e)|0;return 1}function Vdb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;a=d;e=c+4|0;g=f[e>>2]|0;h=f[c>>2]|0;if((g|0)==(h|0)){i=0;j=0;J=j;u=d;return i|0}k=a+4|0;l=0;m=h;h=0;n=0;o=g;while(1){g=m;p=f[g+(l*12|0)+4>>2]|0;q=f[g+(l*12|0)>>2]|0;g=p-q|0;r=g>>2;s=q;do if((s|0)!=(p|0)){if((g|0)<=-4){f[a>>2]=0;f[k>>2]=0;q=aD(a,70)|0;t=442586;v=q+70|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,a,442657,442663,160);bD(a);w=1;x=f[c>>2]|0;y=f[e>>2]|0;break}if((g|0)>0){t=0;q=1;while(1){v=Y(f[s+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)>=(r|0)){w=v;x=m;y=o;break}else q=v}}else{w=1;x=m;y=o}}else{w=0;x=m;y=o}while(0);r=w*3|0;s=Kac(r|0,((r|0)<0)<<31>>31|0,h|0,n|0)|0;r=J;l=l+1|0;if(l>>>0>=((y-x|0)/12|0)>>>0){i=s;j=r;break}else{m=x;h=s;n=r;o=y}}J=j;u=d;return i|0}function Wdb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+44|0;if((d|0)!=(b|0)){e=a+80|0;g=f[e>>2]|0;if(g|0){h=g+12|0;f[h>>2]=(f[h>>2]|0)+1}h=b+36|0;g=f[h>>2]|0;if(g|0?(i=g+12|0,g=f[i>>2]|0,f[i>>2]=g+-1,(g|0)==1):0)kL(b);f[h>>2]=0;g=b+16|0;i=b+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[i>>2]|0)>0){j=f[b+40>>2]|0;k=0;do{f[j+(k<<2)>>2]=0;k=k+1|0;l=f[i>>2]|0}while((k|0)<(l|0));f[b>>2]=f[d>>2];if((l|0)<3)m=12;else m=14}else{f[b>>2]=f[d>>2];m=12}if((m|0)==12){l=f[a+48>>2]|0;if((l|0)<3){f[i>>2]=l;f[b+8>>2]=f[a+52>>2];f[b+12>>2]=f[a+56>>2];l=f[a+88>>2]|0;i=f[b+44>>2]|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2]}else m=14}if((m|0)==14)jL(b,d);f[g>>2]=f[a+60>>2];f[b+20>>2]=f[a+64>>2];f[b+24>>2]=f[a+68>>2];f[b+28>>2]=f[a+72>>2];f[b+32>>2]=f[a+76>>2];f[h>>2]=f[e>>2]}e=a+100|0;if((e|0)==(c|0))return;h=a+136|0;b=f[h>>2]|0;if(b|0){g=b+12|0;f[g>>2]=(f[g>>2]|0)+1}g=c+36|0;b=f[g>>2]|0;if(b|0?(d=b+12|0,b=f[d>>2]|0,f[d>>2]=b+-1,(b|0)==1):0)kL(c);f[g>>2]=0;b=c+16|0;d=c+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){l=f[c+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0;n=f[d>>2]|0}while((i|0)<(n|0));f[c>>2]=f[e>>2];if((n|0)<3)m=27;else m=29}else{f[c>>2]=f[e>>2];m=27}if((m|0)==27){n=f[a+104>>2]|0;if((n|0)<3){f[d>>2]=n;f[c+8>>2]=f[a+108>>2];f[c+12>>2]=f[a+112>>2];n=f[a+144>>2]|0;d=f[c+44>>2]|0;f[d>>2]=f[n>>2];f[d+4>>2]=f[n+4>>2]}else m=29}if((m|0)==29)jL(c,e);f[b>>2]=f[a+116>>2];f[c+20>>2]=f[a+120>>2];f[c+24>>2]=f[a+124>>2];f[c+28>>2]=f[a+128>>2];f[c+32>>2]=f[a+132>>2];f[g>>2]=f[h>>2];return}function Xdb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+16|0;d=a+8|0;e=a;g=f[c>>2]|0;if(g){h=c+4|0;i=f[h>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;if(i|0?(Vac(aD(d,i)|0,g|0,i|0)|0,f[h>>2]|0):0){i=0;do{g=(gVb(b[(f[c>>2]|0)+i>>0]|0)|0)&255;b[(f[d>>2]|0)+i>>0]=g;i=i+1|0}while(i>>>0<(f[h>>2]|0)>>>0)}h=f[d>>2]|0;f[e>>2]=h;f[e+4>>2]=f[j>>2];if(h|0){j=h+-4|0;f[j>>2]=(f[j>>2]|0)+1}bD(d);d=f[e>>2]|0;if((d|0)==422891)bD(e);else{k=d;l=10}}else{f[e>>2]=0;f[e+4>>2]=0;k=0;l=10}if((l|0)==10?(l=(gTb((k|0)==0?1124530:k,422891)|0)==0,bD(e),!l):0){m=-1;u=a;return m|0}m=0;u=a;return m|0}function Ydb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+16|0;d=a+8|0;e=a;g=f[c>>2]|0;if(g){h=c+4|0;i=f[h>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;if(i|0?(Vac(aD(d,i)|0,g|0,i|0)|0,f[h>>2]|0):0){i=0;do{g=(gVb(b[(f[c>>2]|0)+i>>0]|0)|0)&255;b[(f[d>>2]|0)+i>>0]=g;i=i+1|0}while(i>>>0<(f[h>>2]|0)>>>0)}h=f[d>>2]|0;f[e>>2]=h;f[e+4>>2]=f[j>>2];if(h|0){j=h+-4|0;f[j>>2]=(f[j>>2]|0)+1}bD(d);j=f[e>>2]|0;if((j|0)==422887){bD(e);k=0;u=a;return k|0}else l=j}else{f[e>>2]=0;f[e+4>>2]=0;l=0}j=(gTb((l|0)==0?1124530:l,422887)|0)==0;bD(e);if(j){k=0;u=a;return k|0}j=f[c>>2]|0;if(j){l=c+4|0;h=f[l>>2]|0;f[d>>2]=0;i=d+4|0;f[i>>2]=0;if(h|0?(Vac(aD(d,h)|0,j|0,h|0)|0,f[l>>2]|0):0){h=0;do{j=(gVb(b[(f[c>>2]|0)+h>>0]|0)|0)&255;b[(f[d>>2]|0)+h>>0]=j;h=h+1|0}while(h>>>0<(f[l>>2]|0)>>>0)}l=f[d>>2]|0;f[e>>2]=l;f[e+4>>2]=f[i>>2];if(l|0){i=l+-4|0;f[i>>2]=(f[i>>2]|0)+1}bD(d);d=f[e>>2]|0;if((d|0)==422889)bD(e);else{m=d;n=20}}else{f[e>>2]=0;f[e+4>>2]=0;m=0;n=20}if((n|0)==20?(n=(gTb((m|0)==0?1124530:m,422889)|0)==0,bD(e),!n):0){k=-1;u=a;return k|0}k=1;u=a;return k|0}function Zdb(a,b){a=a|0;b=b|0;var c=0;c=L5b(88)|0;_db(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=121448;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function _db(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0,V=0.0,W=0,X=0,Z=0,_=0;d=u;u=u+64|0;e=d;Jwa(a);f[a>>2]=121468;f[a+36>>2]=0;f[a+40>>2]=0;g=a+48|0;h=a+52|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;Kwa(a,c);i=a+4|0;j=f[i>>2]|0;k=a+8|0;l=f[k>>2]|0;do if((j|0)!=(l|0)){if(((l-j|0)/56|0)>>>0>2)m=j;else{f[e>>2]=0;f[e+4>>2]=0;o=aD(e,17)|0;p=423011;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,e,423029,423043,105);bD(e);m=f[i>>2]|0}WL(e,m+112|0,1,1);r=f[i>>2]|0;s=r+112|0;t=e+36|0;v=f[t>>2]|0;if((s|0)==(e|0))w=v;else{if(v|0){x=v+12|0;f[x>>2]=(f[x>>2]|0)+1}x=r+148|0;v=f[x>>2]|0;if(v|0?(y=v+12|0,v=f[y>>2]|0,f[y>>2]=v+-1,(v|0)==1):0)kL(s);f[x>>2]=0;v=r+128|0;y=r+116|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[y>>2]|0)>0){z=f[r+152>>2]|0;A=0;do{f[z+(A<<2)>>2]=0;A=A+1|0;B=f[y>>2]|0}while((A|0)<(B|0));f[s>>2]=f[e>>2];if((B|0)<3)C=15;else C=17}else{f[s>>2]=f[e>>2];C=15}if((C|0)==15){A=f[e+4>>2]|0;if((A|0)<3){f[y>>2]=A;f[r+120>>2]=f[e+8>>2];f[r+124>>2]=f[e+12>>2];A=f[e+44>>2]|0;z=f[r+156>>2]|0;f[z>>2]=f[A>>2];f[z+4>>2]=f[A+4>>2]}else C=17}if((C|0)==17)jL(s,e);f[v>>2]=f[e+16>>2];f[r+132>>2]=f[e+20>>2];f[r+136>>2]=f[e+24>>2];f[r+140>>2]=f[e+28>>2];f[r+144>>2]=f[e+32>>2];A=f[t>>2]|0;f[x>>2]=A;w=A}if(w|0?(A=w+12|0,z=f[A>>2]|0,f[A>>2]=z+-1,(z|0)==1):0)kL(e);f[t>>2]=0;z=e+16|0;A=e+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[A>>2]|0)>0){z=f[e+40>>2]|0;D=0;do{f[z+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[A>>2]|0))}A=f[e+44>>2]|0;if((A|0)!=(e+48|0))UC(A);A=f[i>>2]|0;D=A+112|0;if(!((f[A+4>>2]|0)==2?(f[A+60>>2]|0)==2:0)){f[e>>2]=0;f[e+4>>2]=0;o=aD(e,28)|0;p=423127;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,e,423029,423043,112);bD(e)}z=A+8|0;t=f[z>>2]|0;if((t|0)==(f[A+64>>2]|0))E=t;else{f[e>>2]=0;f[e+4>>2]=0;o=aD(e,18)|0;p=423156;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,e,423029,423043,113);bD(e);E=f[z>>2]|0}t=A+12|0;if((E|0)==(f[t>>2]<<2|0))F=E;else{f[e>>2]=0;f[e+4>>2]=0;o=aD(e,20)|0;p=423175;q=o+20|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,e,423029,423043,114);bD(e);F=f[z>>2]|0}x=f[A+116>>2]|0;if((x|0)<3)G=Y(f[A+124>>2]|0,f[A+120>>2]|0)|0;else{r=f[A+152>>2]|0;v=0;s=1;while(1){y=Y(f[r+(v<<2)>>2]|0,s)|0;v=v+1|0;if((v|0)==(x|0)){G=y;break}else s=y}}if((F|0)!=(G|0)){f[e>>2]=0;f[e+4>>2]=0;o=aD(e,28)|0;p=423196;q=o+28|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,e,423029,423043,115);bD(e)}s=f[A>>2]&4095;if(!((s|0)==(f[A+56>>2]&4095|0)?(s|0)==(f[D>>2]&4095|0):0)){f[e>>2]=0;f[e+4>>2]=0;o=aD(e,50)|0;p=423225;q=o+50|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,e,423029,423043,116);bD(e)}A=f[i>>2]|0;s=(f[k>>2]|0)-A|0;if(((s|0)/56|0)>>>0>3){if((s|0)==336)H=A;else{f[e>>2]=0;f[e+4>>2]=0;o=aD(e,17)|0;p=423276;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,e,423029,423043,121);bD(e);H=f[i>>2]|0}A=e+4|0;s=e+4|0;x=f[H+176>>2]|0;if((x|0)==(f[t>>2]|0)?(f[H+180>>2]|0)==(x|0):0)I=H;else{f[e>>2]=0;f[s>>2]=0;o=aD(e,52)|0;p=423294;q=o+52|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,e,423029,423043,124);bD(e);I=f[i>>2]|0}if(!((f[D>>2]^f[I+168>>2])&4095))K=I;else{f[e>>2]=0;f[A>>2]=0;o=aD(e,30)|0;p=423347;q=o+30|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,e,423029,423043,125);bD(e);K=f[i>>2]|0}x=f[K+232>>2]|0;if((x|0)==(f[t>>2]|0)?(f[K+236>>2]|0)==(x|0):0)L=K;else{f[e>>2]=0;f[s>>2]=0;o=aD(e,52)|0;p=423294;q=o+52|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,e,423029,423043,124);bD(e);L=f[i>>2]|0}if(!((f[D>>2]^f[L+224>>2])&4095))M=L;else{f[e>>2]=0;f[A>>2]=0;o=aD(e,30)|0;p=423347;q=o+30|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,e,423029,423043,125);bD(e);M=f[i>>2]|0}x=f[M+288>>2]|0;if((x|0)==(f[t>>2]|0)?(f[M+292>>2]|0)==(x|0):0)N=M;else{f[e>>2]=0;f[s>>2]=0;o=aD(e,52)|0;p=423294;q=o+52|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,e,423029,423043,124);bD(e);N=f[i>>2]|0}if(!((f[D>>2]^f[N+280>>2])&4095))break;f[e>>2]=0;f[A>>2]=0;o=aD(e,30)|0;p=423347;q=o+30|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,e,423029,423043,125);bD(e)}}while(0);f[e>>2]=0;f[e+4>>2]=0;o=aD(e,17)|0;p=423378;q=o+17|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));N=c+4|0;c=f[N>>2]|0;do if(c){i=f[e>>2]|0;M=(i|0)==0?1124530:i;L=N;K=c;a:while(1){I=K;while(1){H=f[I+16>>2]|0;if((H|0)==(i|0))break;if((gTb((H|0)==0?1124530:H,M)|0)>=0)break;H=f[I+4>>2]|0;if(!H){O=L;break a}else I=H}K=f[I>>2]|0;if(!K){O=I;break}else L=I}if((O|0)!=(N|0)){L=f[O+16>>2]|0;if((i|0)!=(L|0)?(gTb(M,(L|0)==0?1124530:L)|0)<=-1:0){P=1;break}L=Gwa(O+24|0,-1)|0;P=(L|0)!=0|(J|0)!=0}else P=1}else P=1;while(0);b[a+72>>0]=P&1;bD(e);f[e>>2]=0;f[e+4>>2]=0;o=aD(e,19)|0;p=423396;q=o+19|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));P=f[N>>2]|0;do if(P){O=f[e>>2]|0;c=(O|0)==0?1124530:O;L=N;K=P;b:while(1){H=K;while(1){k=f[H+16>>2]|0;if((k|0)==(O|0))break;if((gTb((k|0)==0?1124530:k,c)|0)>=0)break;k=f[H+4>>2]|0;if(!k){Q=L;break b}else H=k}K=f[H>>2]|0;if(!K){Q=H;break}else L=H}if((Q|0)!=(N|0)){L=f[Q+16>>2]|0;if((O|0)!=(L|0)?(gTb(c,(L|0)==0?1124530:L)|0)<=-1:0){R=0;break}L=Gwa(Q+24|0,-1)|0;R=(L|0)!=0|(J|0)!=0}else R=0}else R=0;while(0);b[a+73>>0]=R&1;bD(e);f[e>>2]=0;f[e+4>>2]=0;o=aD(e,11)|0;p=423416;q=o+11|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));R=f[N>>2]|0;do if(R){Q=f[e>>2]|0;P=(Q|0)==0?1124530:Q;L=N;K=R;c:while(1){M=K;while(1){i=f[M+16>>2]|0;if((i|0)==(Q|0))break;if((gTb((i|0)==0?1124530:i,P)|0)>=0)break;i=f[M+4>>2]|0;if(!i){S=L;break c}else M=i}K=f[M>>2]|0;if(!K){S=M;break}else L=M}if((S|0)!=(N|0)){L=f[S+16>>2]|0;if((Q|0)!=(L|0)?(gTb(P,(L|0)==0?1124530:L)|0)<=-1:0){T=0.0;break}T=+Hya(S+24|0,-1)}else T=0.0}else T=0.0;while(0);n[a+76>>2]=T;bD(e);f[e>>2]=0;f[e+4>>2]=0;o=aD(e,9)|0;p=423428;q=o+9|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));S=f[N>>2]|0;do if(S){R=f[e>>2]|0;L=(R|0)==0?1124530:R;K=N;c=S;d:while(1){O=c;while(1){H=f[O+16>>2]|0;if((H|0)==(R|0))break;if((gTb((H|0)==0?1124530:H,L)|0)>=0)break;H=f[O+4>>2]|0;if(!H){U=K;break d}else O=H}c=f[O>>2]|0;if(!c){U=O;break}else K=O}if((U|0)!=(N|0)){K=f[U+16>>2]|0;if((R|0)!=(K|0)?(gTb(L,(K|0)==0?1124530:K)|0)<=-1:0){V=0.0;break}V=+Hya(U+24|0,-1)}else V=0.0}else V=0.0;while(0);n[a+80>>2]=V;bD(e);f[e>>2]=0;f[e+4>>2]=0;o=aD(e,13)|0;p=423438;q=o+13|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));U=f[N>>2]|0;do if(U){S=f[e>>2]|0;K=(S|0)==0?1124530:S;c=N;P=U;e:while(1){Q=P;while(1){M=f[Q+16>>2]|0;if((M|0)==(S|0))break;if((gTb((M|0)==0?1124530:M,K)|0)>=0)break;M=f[Q+4>>2]|0;if(!M){W=c;break e}else Q=M}P=f[Q>>2]|0;if(!P){W=Q;break}else c=Q}if((W|0)!=(N|0)){c=f[W+16>>2]|0;if((S|0)!=(c|0)?(gTb(K,(c|0)==0?1124530:c)|0)<=-1:0){X=0;break}c=Gwa(W+24|0,-1)|0;X=(c|0)!=0|(J|0)!=0}else X=0}else X=0;while(0);b[a+84>>0]=X&1;bD(e);f[e>>2]=0;f[e+4>>2]=0;o=aD(e,12)|0;p=423452;q=o+12|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));p=f[N>>2]|0;do if(p){o=f[e>>2]|0;q=(o|0)==0?1124530:o;X=N;W=p;f:while(1){U=W;while(1){c=f[U+16>>2]|0;if((c|0)==(o|0))break;if((gTb((c|0)==0?1124530:c,q)|0)>=0)break;c=f[U+4>>2]|0;if(!c){Z=X;break f}else U=c}W=f[U>>2]|0;if(!W){Z=U;break}else X=U}if((Z|0)!=(N|0)){X=f[Z+16>>2]|0;if((o|0)!=(X|0)?(gTb(q,(X|0)==0?1124530:X)|0)<=-1:0){_=0;break}X=Gwa(Z+24|0,-1)|0;_=((X|0)!=0|(J|0)!=0)&1}else _=0}else _=0;while(0);b[a+85>>0]=_;bD(e);b[a+44>>0]=0;a=f[g>>2]|0;g=f[h>>2]|0;if((g|0)==(a|0)){u=d;return}f[h>>2]=g+(~((g+-4-a|0)>>>2)<<2);u=d;return}function $db(a){a=a|0;O5b(a);return}function aeb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function beb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=121468;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+48>>2]|0;if(!b){lua(a);return}d=a+52|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);O5b(b);lua(a);return}function ceb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=121468;b=f[a+60>>2]|0;if(b|0){c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+48>>2]|0;if(!b){lua(a);O5b(a);return}d=a+52|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);O5b(b);lua(a);O5b(a);return}function deb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+32|0;e=d+24|0;g=d+20|0;h=d+16|0;i=d;j=d+12|0;k=d+8|0;l=d+4|0;if(!(b[a+85>>0]|0)){if(((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)!=168)m=4}else if(((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)!=336)m=4;if((m|0)==4){f[e>>2]=0;f[e+4>>2]=0;n=aD(e,69)|0;o=423597;p=n+69|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,e,443724,423043,222);bD(e)}q=f[c>>2]|0;if(((f[c+4>>2]|0)-q|0)==4)r=q;else{f[e>>2]=0;f[e+4>>2]=0;n=aD(e,17)|0;o=424054;p=n+17|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,e,443724,423043,223);bD(e);r=f[c>>2]|0}c=f[r>>2]|0;r=f[a+4>>2]|0;f[i>>2]=f[(f[r+40>>2]|0)+4>>2];q=f[(f[r+96>>2]|0)+4>>2]|0;r=a+48|0;s=f[r>>2]|0;t=a+52|0;v=f[t>>2]|0;if((s|0)!=(v|0)){w=v-s|0;s=w>>2;if((w|0)>=0)if(!w)x=1;else{w=f[r>>2]|0;v=0;y=1;while(1){z=Y(f[w+(v<<2)>>2]|0,y)|0;v=v+1|0;if((v|0)==(s|0)){x=z;break}else y=z}}else{f[e>>2]=0;f[e+4>>2]=0;n=aD(e,70)|0;o=442586;p=n+70|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,e,442657,442663,160);bD(e);x=1}if((x|0)!=(f[i>>2]|0)){f[e>>2]=0;f[e+4>>2]=0;n=aD(e,29)|0;o=424072;p=n+29|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,e,443724,423043,231);bD(e)}}else leb(r,1,i);i=f[c+4>>2]|0;x=(i|0)>1;do if(!(b[a+72>>0]|0)){if(x){y=f[c+40>>2]|0;s=1;v=1;do{s=Y(f[y+(v<<2)>>2]|0,s)|0;v=v+1|0}while((v|0)!=(i|0));if((s|0)==(q|0)){A=1;B=0;C=y;break}}f[e>>2]=0;f[e+4>>2]=0;n=aD(e,46)|0;o=424149;p=n+46|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,e,443724,423043,243);bD(e);A=1;B=0;C=f[c+40>>2]|0}else{if(x){if((i|0)==2)D=1;else{y=f[c+40>>2]|0;s=1;v=2;while(1){w=Y(f[y+(v<<2)>>2]|0,s)|0;v=v+1|0;if((v|0)>=(i|0)){D=w;break}else s=w}}if((D|0)!=(q|0))m=23}else m=23;if((m|0)==23){f[e>>2]=0;f[e+4>>2]=0;n=aD(e,46)|0;o=424102;p=n+46|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,e,443724,423043,237);bD(e)}s=f[c+40>>2]|0;A=f[s>>2]|0;B=1;C=s}while(0);f[a+36>>2]=A;A=f[C+(B<<2)>>2]|0;B=a+40|0;f[B>>2]=A;C=a+60|0;c=f[C>>2]|0;o=a+64|0;n=f[o>>2]|0;if((n|0)==(c|0))E=c;else{p=n+(~((n+-4-c|0)>>>2)<<2)|0;f[o>>2]=p;E=p}if((E|0)==(f[a+68>>2]|0)){IO(C,B);F=f[o>>2]|0;f[j>>2]=F;G=f[r>>2]|0;f[k>>2]=G;H=f[t>>2]|0;f[l>>2]=H;f[h>>2]=f[j>>2];f[g>>2]=f[k>>2];f[e>>2]=f[l>>2];s2(C,h,g,e)|0;I=a+44|0;b[I>>0]=1;u=d;return}else{f[E>>2]=A;A=E+4|0;f[o>>2]=A;F=A;f[j>>2]=F;G=f[r>>2]|0;f[k>>2]=G;H=f[t>>2]|0;f[l>>2]=H;f[h>>2]=f[j>>2];f[g>>2]=f[k>>2];f[e>>2]=f[l>>2];s2(C,h,g,e)|0;I=a+44|0;b[I>>0]=1;u=d;return}}function eeb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0.0;g=u;u=u+816|0;h=g+792|0;i=g+56|0;j=g+784|0;k=g+728|0;l=g+672|0;m=g+616|0;o=g+560|0;q=g+504|0;r=g+448|0;s=g+392|0;t=g+384|0;v=g+328|0;w=g+272|0;x=g+216|0;y=g+160|0;z=g+104|0;A=g;B=g+88|0;C=g+72|0;dQ(j,121608);D=a+4|0;E=f[D>>2]|0;F=E+56|0;G=E+112|0;H=f[(f[E+40>>2]|0)+4>>2]|0;I=f[e>>2]|0;f[k>>2]=f[I>>2];J=k+4|0;K=I+4|0;f[J>>2]=f[K>>2];L=k+8|0;f[L>>2]=f[I+8>>2];f[k+12>>2]=f[I+12>>2];M=k+16|0;f[M>>2]=f[I+16>>2];f[k+20>>2]=f[I+20>>2];f[k+24>>2]=f[I+24>>2];f[k+28>>2]=f[I+28>>2];f[k+32>>2]=f[I+32>>2];N=k+36|0;O=f[I+36>>2]|0;f[N>>2]=O;P=k+40|0;f[P>>2]=L;L=k+48|0;Q=k+44|0;f[Q>>2]=L;f[L>>2]=0;f[k+52>>2]=0;if(O|0){R=O+12|0;f[R>>2]=(f[R>>2]|0)+1}if((f[K>>2]|0)<3){K=f[I+44>>2]|0;R=f[Q>>2]|0;f[R>>2]=f[K>>2];f[R+4>>2]=f[K+4>>2]}else{f[J>>2]=0;jL(k,I)}I=f[e>>2]|0;K=I+56|0;f[l>>2]=f[K>>2];R=l+4|0;O=I+60|0;S=f[O>>2]|0;f[R>>2]=S;T=l+8|0;f[T>>2]=f[I+64>>2];f[l+12>>2]=f[I+68>>2];U=l+16|0;f[U>>2]=f[I+72>>2];f[l+20>>2]=f[I+76>>2];f[l+24>>2]=f[I+80>>2];f[l+28>>2]=f[I+84>>2];f[l+32>>2]=f[I+88>>2];V=l+36|0;W=f[I+92>>2]|0;f[V>>2]=W;X=l+40|0;f[X>>2]=T;T=l+48|0;Z=l+44|0;f[Z>>2]=T;f[T>>2]=0;f[l+52>>2]=0;if(!W)_=S;else{S=W+12|0;f[S>>2]=(f[S>>2]|0)+1;_=f[O>>2]|0}if((_|0)<3){_=f[I+100>>2]|0;I=f[Z>>2]|0;f[I>>2]=f[_>>2];f[I+4>>2]=f[_+4>>2]}else{f[R>>2]=0;jL(l,K)}K=f[e>>2]|0;_=K+112|0;f[m>>2]=f[_>>2];I=m+4|0;O=K+116|0;S=f[O>>2]|0;f[I>>2]=S;W=m+8|0;f[W>>2]=f[K+120>>2];f[m+12>>2]=f[K+124>>2];$=m+16|0;f[$>>2]=f[K+128>>2];f[m+20>>2]=f[K+132>>2];f[m+24>>2]=f[K+136>>2];f[m+28>>2]=f[K+140>>2];f[m+32>>2]=f[K+144>>2];aa=m+36|0;ba=f[K+148>>2]|0;f[aa>>2]=ba;ca=m+40|0;f[ca>>2]=W;W=m+48|0;da=m+44|0;f[da>>2]=W;f[W>>2]=0;f[m+52>>2]=0;if(!ba)ea=S;else{S=ba+12|0;f[S>>2]=(f[S>>2]|0)+1;ea=f[O>>2]|0}if((ea|0)<3){ea=f[K+156>>2]|0;K=f[da>>2]|0;f[K>>2]=f[ea>>2];f[K+4>>2]=f[ea+4>>2]}else{f[I>>2]=0;jL(m,_)}_=f[e>>2]|0;e=_+168|0;f[o>>2]=f[e>>2];ea=o+4|0;K=_+172|0;O=f[K>>2]|0;f[ea>>2]=O;S=o+8|0;f[S>>2]=f[_+176>>2];f[o+12>>2]=f[_+180>>2];ba=o+16|0;f[ba>>2]=f[_+184>>2];f[o+20>>2]=f[_+188>>2];f[o+24>>2]=f[_+192>>2];f[o+28>>2]=f[_+196>>2];f[o+32>>2]=f[_+200>>2];fa=o+36|0;ga=f[_+204>>2]|0;f[fa>>2]=ga;ha=o+40|0;f[ha>>2]=S;S=o+48|0;ia=o+44|0;f[ia>>2]=S;f[S>>2]=0;f[o+52>>2]=0;if(!ga)ja=O;else{O=ga+12|0;f[O>>2]=(f[O>>2]|0)+1;ja=f[K>>2]|0}if((ja|0)<3){ja=f[_+212>>2]|0;_=f[ia>>2]|0;f[_>>2]=f[ja>>2];f[_+4>>2]=f[ja+4>>2]}else{f[ea>>2]=0;jL(o,e)}p[i>>3]=0.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;VP(k,h,UM()|0)|0;p[i>>3]=0.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;VP(l,h,UM()|0)|0;p[i>>3]=1.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;VP(m,h,UM()|0)|0;e=a+36|0;ja=a+40|0;_=Y(f[ja>>2]|0,f[e>>2]|0)|0;WL(q,f[f[c>>2]>>2]|0,1,_);WL(r,f[d>>2]|0,1,_);c=a+73|0;if(!(b[c>>0]|0)){f[s>>2]=1124007936;K=s+8|0;O=s+40|0;ga=s+4|0;ka=ga+36|0;do{f[ga>>2]=0;ga=ga+4|0}while((ga|0)<(ka|0));f[O>>2]=K;K=s+48|0;f[s+44>>2]=K;f[K>>2]=0;f[s+52>>2]=0}else WL(s,(f[d>>2]|0)+56|0,1,_);if((f[e>>2]|0)>0){_=t+4|0;d=h+4|0;K=h+8|0;O=h+12|0;ga=h+4|0;ka=i+8|0;la=i+12|0;ma=i+4|0;na=w+8|0;oa=w+12|0;pa=w+4|0;qa=x+8|0;ra=x+4|0;sa=h+8|0;ta=h+12|0;ua=h+4|0;va=i+8|0;wa=i+12|0;xa=i+4|0;ya=w+8|0;za=w+12|0;Aa=w+4|0;Ba=x+8|0;Ca=x+4|0;Da=h+8|0;Ea=h+12|0;Fa=h+4|0;Ga=i+8|0;Ha=i+12|0;Ia=i+4|0;Ja=w+8|0;Ka=w+12|0;La=w+4|0;Ma=x+8|0;Na=x+4|0;Oa=h+4|0;Pa=i+4|0;Qa=H<<1;Ra=h+4|0;Sa=i+4|0;Ta=H*3|0;Ua=h+4|0;Va=i+4|0;Wa=H<<2;Xa=h+4|0;Ya=i+4|0;Za=a+76|0;_a=h+8|0;$a=h+12|0;ab=h+4|0;bb=i+8|0;cb=i+12|0;db=i+4|0;eb=B+8|0;fb=B+4|0;gb=a+85|0;hb=h+4|0;ib=i+4|0;jb=A+36|0;kb=A+16|0;lb=A+4|0;mb=A+40|0;nb=A+44|0;ob=A+48|0;pb=h+8|0;qb=h+12|0;rb=h+4|0;sb=i+8|0;tb=i+12|0;ub=i+4|0;vb=A+8|0;wb=A+4|0;xb=h+8|0;yb=h+12|0;zb=h+4|0;Ab=i+8|0;Bb=i+12|0;Cb=i+4|0;Db=A+8|0;Eb=A+4|0;Fb=h+8|0;Gb=h+12|0;Hb=h+4|0;Ib=i+8|0;Jb=i+12|0;Kb=i+4|0;Lb=A+8|0;Mb=A+4|0;Nb=a+84|0;Ob=h+8|0;Pb=h+12|0;Qb=h+4|0;Rb=i+8|0;Sb=i+12|0;Tb=i+4|0;Ub=A+8|0;Vb=A+4|0;Wb=h+4|0;Xb=i+8|0;Yb=i+4|0;Zb=A+36|0;_b=A+16|0;$b=A+4|0;ac=A+40|0;bc=A+44|0;cc=A+48|0;dc=z+36|0;ec=z+16|0;fc=z+4|0;gc=z+40|0;hc=z+44|0;ic=z+48|0;jc=y+36|0;kc=y+16|0;lc=y+4|0;mc=y+40|0;nc=y+44|0;oc=y+48|0;pc=x+36|0;qc=x+16|0;rc=x+4|0;sc=x+40|0;tc=x+44|0;uc=x+48|0;vc=w+36|0;wc=w+16|0;xc=w+4|0;yc=w+40|0;zc=w+44|0;Ac=w+48|0;Bc=v+36|0;Cc=v+16|0;Dc=v+4|0;Ec=v+40|0;Fc=v+44|0;Gc=v+48|0;Hc=h+4|0;Ic=i+8|0;Jc=i+4|0;Kc=A+36|0;Lc=A+16|0;Mc=A+4|0;Nc=A+40|0;Oc=A+44|0;Pc=A+48|0;Qc=h+8|0;Rc=h+12|0;Sc=h+4|0;Tc=i+8|0;Uc=i+12|0;Vc=i+4|0;Wc=A+8|0;Xc=A+12|0;Yc=A+4|0;Zc=B+8|0;_c=B+4|0;$c=h+8|0;ad=h+12|0;bd=h+4|0;cd=a+80|0;a=i+8|0;dd=i+12|0;ed=i+4|0;fd=B+8|0;gd=B+4|0;hd=h+8|0;id=h+12|0;jd=h+4|0;kd=i+8|0;ld=i+12|0;md=i+4|0;nd=B+8|0;od=B+4|0;pd=h+4|0;qd=i+4|0;rd=h+8|0;sd=h+12|0;td=h+4|0;ud=i+8|0;vd=i+12|0;wd=i+4|0;xd=B+8|0;yd=B+12|0;zd=B+4|0;Ad=C+8|0;Bd=C+4|0;Cd=h+8|0;Dd=h+12|0;Ed=h+4|0;Fd=i+8|0;Gd=i+12|0;Hd=i+4|0;Id=B+8|0;Jd=B+12|0;Kd=B+4|0;Ld=C+8|0;Md=C+4|0;Nd=A+36|0;Od=A+16|0;Pd=A+4|0;Qd=A+40|0;Rd=A+44|0;Sd=A+48|0;Td=0;do{Ud=f[ja>>2]|0;Vd=Y(Ud,Td)|0;Td=Td+1|0;Wd=Y(Ud,Td)|0;f[t>>2]=Vd;f[_>>2]=Wd;f[h>>2]=-2147483648;f[d>>2]=2147483647;lL(v,q,t,h);f[K>>2]=0;f[O>>2]=0;f[h>>2]=16842752;f[ga>>2]=v;f[ka>>2]=0;f[la>>2]=0;f[i>>2]=16842752;f[ma>>2]=F;f[na>>2]=0;f[oa>>2]=0;f[w>>2]=16842752;f[pa>>2]=o;Wd=qa;f[Wd>>2]=0;f[Wd+4>>2]=0;f[x>>2]=33619968;f[ra>>2]=o;CX(h,i,1.0,w,0.0,x,2);f[sa>>2]=0;f[ta>>2]=0;f[h>>2]=16842752;f[ua>>2]=k;f[va>>2]=0;f[wa>>2]=0;f[i>>2]=16842752;f[xa>>2]=E;f[ya>>2]=0;f[za>>2]=0;f[w>>2]=16842752;f[Aa>>2]=o;Wd=Ba;f[Wd>>2]=0;f[Wd+4>>2]=0;f[x>>2]=33619968;f[Ca>>2]=o;CX(h,i,1.0,w,1.0,x,2);f[Da>>2]=0;f[Ea>>2]=0;f[h>>2]=16842752;f[Fa>>2]=m;f[Ga>>2]=0;f[Ha>>2]=0;f[i>>2]=16842752;f[Ia>>2]=G;f[Ja>>2]=0;f[Ka>>2]=0;f[w>>2]=16842752;f[La>>2]=o;Wd=Ma;f[Wd>>2]=0;f[Wd+4>>2]=0;f[x>>2]=33619968;f[Na>>2]=o;CX(h,i,1.0,w,1.0,x,0);f[h>>2]=-2147483648;f[Oa>>2]=2147483647;f[i>>2]=0;f[Pa>>2]=H;lL(w,o,h,i);f[h>>2]=-2147483648;f[Ra>>2]=2147483647;f[i>>2]=H;f[Sa>>2]=Qa;lL(x,o,h,i);f[h>>2]=-2147483648;f[Ua>>2]=2147483647;f[i>>2]=Qa;f[Va>>2]=Ta;lL(y,o,h,i);f[h>>2]=-2147483648;f[Xa>>2]=2147483647;f[i>>2]=Ta;f[Ya>>2]=Wa;lL(z,o,h,i);Xd=+n[Za>>2];if(Xd!=0.0){f[_a>>2]=0;f[$a>>2]=0;f[h>>2]=16842752;f[ab>>2]=x;p[A>>3]=Xd;f[i>>2]=-1056833530;f[db>>2]=A;f[bb>>2]=1;f[cb>>2]=1;Wd=eb;f[Wd>>2]=0;f[Wd+4>>2]=0;f[B>>2]=33619968;f[fb>>2]=x;VD(h,i,B,UM()|0,-1)}if(!(b[gb>>0]|0)){f[h>>2]=-2147483648;f[hb>>2]=2147483647;f[i>>2]=0;f[ib>>2]=Ta;lL(A,o,h,i);meb(A,A);Wd=f[jb>>2]|0;if(Wd|0?(Vd=Wd+12|0,Wd=f[Vd>>2]|0,f[Vd>>2]=Wd+-1,(Wd|0)==1):0)kL(A);f[jb>>2]=0;f[kb>>2]=0;f[kb+4>>2]=0;f[kb+8>>2]=0;f[kb+12>>2]=0;if((f[lb>>2]|0)>0){Wd=f[mb>>2]|0;Vd=0;do{f[Wd+(Vd<<2)>>2]=0;Vd=Vd+1|0}while((Vd|0)<(f[lb>>2]|0))}Vd=f[nb>>2]|0;if((Vd|0)!=(ob|0))UC(Vd)}else{f[h>>2]=-2147483648;f[pd>>2]=2147483647;f[i>>2]=0;f[qd>>2]=Qa;lL(A,o,h,i);f[rd>>2]=0;f[sd>>2]=0;f[h>>2]=16842752;f[td>>2]=l;Vd=(f[D>>2]|0)+168|0;f[ud>>2]=0;f[vd>>2]=0;f[i>>2]=16842752;f[wd>>2]=Vd;f[xd>>2]=0;f[yd>>2]=0;f[B>>2]=16842752;f[zd>>2]=w;Vd=Ad;f[Vd>>2]=0;f[Vd+4>>2]=0;f[C>>2]=33619968;f[Bd>>2]=w;CX(h,i,1.0,B,1.0,C,0);f[Cd>>2]=0;f[Dd>>2]=0;f[h>>2]=16842752;f[Ed>>2]=l;Vd=(f[D>>2]|0)+224|0;f[Fd>>2]=0;f[Gd>>2]=0;f[i>>2]=16842752;f[Hd>>2]=Vd;f[Id>>2]=0;f[Jd>>2]=0;f[B>>2]=16842752;f[Kd>>2]=x;Vd=Ld;f[Vd>>2]=0;f[Vd+4>>2]=0;f[C>>2]=33619968;f[Md>>2]=x;CX(h,i,1.0,B,1.0,C,0);meb(A,A);Vd=f[Nd>>2]|0;if(Vd|0?(Wd=Vd+12|0,Vd=f[Wd>>2]|0,f[Wd>>2]=Vd+-1,(Vd|0)==1):0)kL(A);f[Nd>>2]=0;f[Od>>2]=0;f[Od+4>>2]=0;f[Od+8>>2]=0;f[Od+12>>2]=0;if((f[Pd>>2]|0)>0){Vd=f[Qd>>2]|0;Wd=0;do{f[Vd+(Wd<<2)>>2]=0;Wd=Wd+1|0}while((Wd|0)<(f[Pd>>2]|0))}Wd=f[Rd>>2]|0;if((Wd|0)!=(Sd|0))UC(Wd)}neb(z,z);f[pb>>2]=0;f[qb>>2]=0;f[h>>2]=16842752;f[rb>>2]=x;f[sb>>2]=0;f[tb>>2]=0;f[i>>2]=16842752;f[ub>>2]=l;Wd=vb;f[Wd>>2]=0;f[Wd+4>>2]=0;f[A>>2]=33619968;f[wb>>2]=x;NE(h,i,A,1.0,-1);f[xb>>2]=0;f[yb>>2]=0;f[h>>2]=16842752;f[zb>>2]=w;f[Ab>>2]=0;f[Bb>>2]=0;f[i>>2]=16842752;f[Cb>>2]=z;Wd=Db;f[Wd>>2]=0;f[Wd+4>>2]=0;f[A>>2]=33619968;f[Eb>>2]=w;NE(h,i,A,1.0,-1);f[Fb>>2]=0;f[Gb>>2]=0;f[h>>2]=16842752;f[Hb>>2]=x;f[Ib>>2]=0;f[Jb>>2]=0;f[i>>2]=16842752;f[Kb>>2]=w;Wd=Lb;f[Wd>>2]=0;f[Wd+4>>2]=0;f[A>>2]=33619968;f[Mb>>2]=l;VD(h,i,A,UM()|0,-1);if(b[Nb>>0]|0){f[$c>>2]=0;f[ad>>2]=0;f[h>>2]=16842752;f[bd>>2]=l;p[A>>3]=+n[cd>>2];f[i>>2]=-1056833530;f[ed>>2]=A;f[a>>2]=1;f[dd>>2]=1;Wd=fd;f[Wd>>2]=0;f[Wd+4>>2]=0;f[B>>2]=33619968;f[gd>>2]=l;ED(h,i,B);f[hd>>2]=0;f[id>>2]=0;f[h>>2]=16842752;f[jd>>2]=l;p[A>>3]=-+n[cd>>2];f[i>>2]=-1056833530;f[md>>2]=A;f[kd>>2]=1;f[ld>>2]=1;Wd=nd;f[Wd>>2]=0;f[Wd+4>>2]=0;f[B>>2]=33619968;f[od>>2]=l;pD(h,i,B)}if(b[gb>>0]|0){f[Qc>>2]=0;f[Rc>>2]=0;f[h>>2]=16842752;f[Sc>>2]=l;Wd=(f[D>>2]|0)+280|0;f[Tc>>2]=0;f[Uc>>2]=0;f[i>>2]=16842752;f[Vc>>2]=Wd;f[Wc>>2]=0;f[Xc>>2]=0;f[A>>2]=16842752;f[Yc>>2]=y;Wd=Zc;f[Wd>>2]=0;f[Wd+4>>2]=0;f[B>>2]=33619968;f[_c>>2]=y;CX(h,i,1.0,A,1.0,B,0);meb(y,y)}neb(l,k);f[Ob>>2]=0;f[Pb>>2]=0;f[h>>2]=16842752;f[Qb>>2]=y;f[Rb>>2]=0;f[Sb>>2]=0;f[i>>2]=16842752;f[Tb>>2]=k;Wd=Ub;f[Wd>>2]=0;f[Wd+4>>2]=0;f[A>>2]=33619968;f[Vb>>2]=k;NE(h,i,A,1.0,-1);f[h>>2]=-2147483648;f[Wb>>2]=2147483647;lL(A,r,t,h);Wd=Xb;f[Wd>>2]=0;f[Wd+4>>2]=0;f[i>>2]=-1040121856;f[Yb>>2]=A;SP(k,i);Wd=f[Zb>>2]|0;if(Wd|0?(Vd=Wd+12|0,Wd=f[Vd>>2]|0,f[Vd>>2]=Wd+-1,(Wd|0)==1):0)kL(A);f[Zb>>2]=0;f[_b>>2]=0;f[_b+4>>2]=0;f[_b+8>>2]=0;f[_b+12>>2]=0;if((f[$b>>2]|0)>0){Wd=f[ac>>2]|0;Vd=0;do{f[Wd+(Vd<<2)>>2]=0;Vd=Vd+1|0}while((Vd|0)<(f[$b>>2]|0))}Vd=f[bc>>2]|0;if((Vd|0)!=(cc|0))UC(Vd);if(b[c>>0]|0){f[h>>2]=-2147483648;f[Hc>>2]=2147483647;lL(A,s,t,h);Vd=Ic;f[Vd>>2]=0;f[Vd+4>>2]=0;f[i>>2]=-1040121856;f[Jc>>2]=A;SP(l,i);Vd=f[Kc>>2]|0;do if(Vd|0){Wd=Vd+12|0;Ud=f[Wd>>2]|0;f[Wd>>2]=Ud+-1;if((Ud|0)!=1)break;kL(A)}while(0);f[Kc>>2]=0;f[Lc>>2]=0;f[Lc+4>>2]=0;f[Lc+8>>2]=0;f[Lc+12>>2]=0;if((f[Mc>>2]|0)>0){Vd=f[Nc>>2]|0;Ud=0;do{f[Vd+(Ud<<2)>>2]=0;Ud=Ud+1|0}while((Ud|0)<(f[Mc>>2]|0))}Ud=f[Oc>>2]|0;if((Ud|0)!=(Pc|0))UC(Ud)}Ud=f[dc>>2]|0;do if(Ud|0){Vd=Ud+12|0;Wd=f[Vd>>2]|0;f[Vd>>2]=Wd+-1;if((Wd|0)!=1)break;kL(z)}while(0);f[dc>>2]=0;f[ec>>2]=0;f[ec+4>>2]=0;f[ec+8>>2]=0;f[ec+12>>2]=0;if((f[fc>>2]|0)>0){Ud=f[gc>>2]|0;Wd=0;do{f[Ud+(Wd<<2)>>2]=0;Wd=Wd+1|0}while((Wd|0)<(f[fc>>2]|0))}Wd=f[hc>>2]|0;if((Wd|0)!=(ic|0))UC(Wd);Wd=f[jc>>2]|0;do if(Wd|0){Ud=Wd+12|0;Vd=f[Ud>>2]|0;f[Ud>>2]=Vd+-1;if((Vd|0)!=1)break;kL(y)}while(0);f[jc>>2]=0;f[kc>>2]=0;f[kc+4>>2]=0;f[kc+8>>2]=0;f[kc+12>>2]=0;if((f[lc>>2]|0)>0){Wd=f[mc>>2]|0;Vd=0;do{f[Wd+(Vd<<2)>>2]=0;Vd=Vd+1|0}while((Vd|0)<(f[lc>>2]|0))}Vd=f[nc>>2]|0;if((Vd|0)!=(oc|0))UC(Vd);Vd=f[pc>>2]|0;do if(Vd|0){Wd=Vd+12|0;Ud=f[Wd>>2]|0;f[Wd>>2]=Ud+-1;if((Ud|0)!=1)break;kL(x)}while(0);f[pc>>2]=0;f[qc>>2]=0;f[qc+4>>2]=0;f[qc+8>>2]=0;f[qc+12>>2]=0;if((f[rc>>2]|0)>0){Vd=f[sc>>2]|0;Ud=0;do{f[Vd+(Ud<<2)>>2]=0;Ud=Ud+1|0}while((Ud|0)<(f[rc>>2]|0))}Ud=f[tc>>2]|0;if((Ud|0)!=(uc|0))UC(Ud);Ud=f[vc>>2]|0;do if(Ud|0){Vd=Ud+12|0;Wd=f[Vd>>2]|0;f[Vd>>2]=Wd+-1;if((Wd|0)!=1)break;kL(w)}while(0);f[vc>>2]=0;f[wc>>2]=0;f[wc+4>>2]=0;f[wc+8>>2]=0;f[wc+12>>2]=0;if((f[xc>>2]|0)>0){Ud=f[yc>>2]|0;Wd=0;do{f[Ud+(Wd<<2)>>2]=0;Wd=Wd+1|0}while((Wd|0)<(f[xc>>2]|0))}Wd=f[zc>>2]|0;if((Wd|0)!=(Ac|0))UC(Wd);Wd=f[Bc>>2]|0;do if(Wd|0){Ud=Wd+12|0;Vd=f[Ud>>2]|0;f[Ud>>2]=Vd+-1;if((Vd|0)!=1)break;kL(v)}while(0);f[Bc>>2]=0;f[Cc>>2]=0;f[Cc+4>>2]=0;f[Cc+8>>2]=0;f[Cc+12>>2]=0;if((f[Dc>>2]|0)>0){Wd=f[Ec>>2]|0;Vd=0;do{f[Wd+(Vd<<2)>>2]=0;Vd=Vd+1|0}while((Vd|0)<(f[Dc>>2]|0))}Vd=f[Fc>>2]|0;if((Vd|0)!=(Gc|0))UC(Vd)}while((Td|0)<(f[e>>2]|0))}e=s+36|0;Td=f[e>>2]|0;if(Td|0?(Gc=Td+12|0,Td=f[Gc>>2]|0,f[Gc>>2]=Td+-1,(Td|0)==1):0)kL(s);f[e>>2]=0;e=s+16|0;Td=s+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[Td>>2]|0)>0){e=f[s+40>>2]|0;Gc=0;do{f[e+(Gc<<2)>>2]=0;Gc=Gc+1|0}while((Gc|0)<(f[Td>>2]|0))}Td=f[s+44>>2]|0;if((Td|0)!=(s+48|0))UC(Td);Td=r+36|0;s=f[Td>>2]|0;if(s|0?(Gc=s+12|0,s=f[Gc>>2]|0,f[Gc>>2]=s+-1,(s|0)==1):0)kL(r);f[Td>>2]=0;Td=r+16|0;s=r+4|0;f[Td>>2]=0;f[Td+4>>2]=0;f[Td+8>>2]=0;f[Td+12>>2]=0;if((f[s>>2]|0)>0){Td=f[r+40>>2]|0;Gc=0;do{f[Td+(Gc<<2)>>2]=0;Gc=Gc+1|0}while((Gc|0)<(f[s>>2]|0))}s=f[r+44>>2]|0;if((s|0)!=(r+48|0))UC(s);s=q+36|0;r=f[s>>2]|0;if(r|0?(Gc=r+12|0,r=f[Gc>>2]|0,f[Gc>>2]=r+-1,(r|0)==1):0)kL(q);f[s>>2]=0;s=q+16|0;r=q+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[q+40>>2]|0;Gc=0;do{f[s+(Gc<<2)>>2]=0;Gc=Gc+1|0}while((Gc|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))UC(r);r=f[fa>>2]|0;do if(r|0){q=r+12|0;Gc=f[q>>2]|0;f[q>>2]=Gc+-1;if((Gc|0)!=1)break;kL(o)}while(0);f[fa>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[ea>>2]|0)>0){ba=f[ha>>2]|0;ha=0;do{f[ba+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[ea>>2]|0))}ea=f[ia>>2]|0;if((ea|0)!=(S|0))UC(ea);ea=f[aa>>2]|0;do if(ea|0){S=ea+12|0;ia=f[S>>2]|0;f[S>>2]=ia+-1;if((ia|0)!=1)break;kL(m)}while(0);f[aa>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[I>>2]|0)>0){$=f[ca>>2]|0;ca=0;do{f[$+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[I>>2]|0))}I=f[da>>2]|0;if((I|0)!=(W|0))UC(I);I=f[V>>2]|0;do if(I|0){W=I+12|0;da=f[W>>2]|0;f[W>>2]=da+-1;if((da|0)!=1)break;kL(l)}while(0);f[V>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[R>>2]|0)>0){U=f[X>>2]|0;X=0;do{f[U+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[R>>2]|0))}R=f[Z>>2]|0;if((R|0)!=(T|0))UC(R);R=f[N>>2]|0;do if(R|0){T=R+12|0;Z=f[T>>2]|0;f[T>>2]=Z+-1;if((Z|0)!=1)break;kL(k)}while(0);f[N>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[J>>2]|0)>0){M=f[P>>2]|0;P=0;do{f[M+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[J>>2]|0))}J=f[Q>>2]|0;if((J|0)!=(L|0))UC(J);if(!(f[j+4>>2]|0)){u=g;return}u=g;return}function feb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,121576);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function geb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;d=u;u=u+80|0;h=d+64|0;i=d+52|0;j=d+48|0;k=d+36|0;l=d+20|0;m=d+8|0;n=d+4|0;o=d;p=d+44|0;q=d+40|0;r=d+32|0;if(!(b[a+85>>0]|0)){if(((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)!=168)s=4}else if(((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)!=336)s=4;if((s|0)==4){f[h>>2]=0;f[h+4>>2]=0;t=aD(h,69)|0;v=423597;w=t+69|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,h,442770,423043,177);bD(h)}x=f[c>>2]|0;if(((f[c+4>>2]|0)-x|0)==12)y=x;else{f[h>>2]=0;f[h+4>>2]=0;t=aD(h,18)|0;v=443104;w=t+18|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,h,442770,423043,178);bD(h);y=f[c>>2]|0}c=f[a+4>>2]|0;f[k>>2]=f[(f[c+40>>2]|0)+4>>2];x=f[(f[c+96>>2]|0)+4>>2]|0;Bua(l,a+48|0);f[m>>2]=0;c=m+4|0;f[c>>2]=0;f[m+8>>2]=0;z=f[l>>2]|0;A=l+4|0;B=f[A>>2]|0;if((z|0)!=(B|0)){C=B-z|0;z=C>>2;if((C|0)>=0)if(!C)D=1;else{C=f[l>>2]|0;B=0;E=1;while(1){F=Y(f[C+(B<<2)>>2]|0,E)|0;B=B+1|0;if((B|0)==(z|0)){D=F;break}else E=F}}else{f[h>>2]=0;f[h+4>>2]=0;t=aD(h,70)|0;v=442586;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,h,442657,442663,160);bD(h);D=1}if((D|0)!=(f[k>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;t=aD(h,31)|0;v=423667;w=t+31|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,h,442770,423043,187);bD(h)}}else leb(l,1,k);D=f[y+4>>2]|0;E=f[y>>2]|0;z=D-E|0;B=z>>2;C=B>>>0>1;do if(b[a+72>>0]|0){if(C){do if((E|0)!=(D|0)){if((z|0)<8){f[h>>2]=0;f[h+4>>2]=0;t=aD(h,70)|0;v=442586;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,h,442657,442663,160);bD(h);G=1;break}if((z|0)==8)G=1;else{F=f[y>>2]|0;H=2;I=1;while(1){J=Y(f[F+(H<<2)>>2]|0,I)|0;H=H+1|0;if((H|0)==(B|0)){G=J;break}else I=J}}}else G=0;while(0);if((G|0)==(x|0))K=y;else s=26}else s=26;if((s|0)==26){f[h>>2]=0;f[h+4>>2]=0;t=aD(h,45)|0;v=423699;w=t+45|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,h,442770,423043,194);bD(h);K=y}I=f[K>>2]|0;H=f[I>>2]|0;f[n>>2]=H;f[o>>2]=f[I+4>>2];I=f[c>>2]|0;F=m+8|0;if((I|0)==(f[F>>2]|0)){IO(m,n);L=F;break}else{f[I>>2]=H;f[c>>2]=I+4;L=F;break}}else{if(C){do if((E|0)!=(D|0)){if((z|0)<4){f[h>>2]=0;f[h+4>>2]=0;t=aD(h,70)|0;v=442586;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,h,442657,442663,160);bD(h);M=1;break}if((z|0)==4)M=1;else{F=f[y>>2]|0;I=1;H=1;while(1){J=Y(f[F+(I<<2)>>2]|0,H)|0;I=I+1|0;if((I|0)==(B|0)){M=J;break}else H=J}}}else M=0;while(0);if((M|0)==(x|0))N=y;else s=38}else s=38;if((s|0)==38){f[h>>2]=0;f[h+4>>2]=0;t=aD(h,45)|0;v=423745;w=t+45|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,h,442770,423043,201);bD(h);N=y}f[n>>2]=1;f[o>>2]=f[f[N>>2]>>2];L=m+8|0}while(0);N=f[c>>2]|0;if((N|0)==(f[L>>2]|0)){IO(m,o);O=f[c>>2]|0}else{f[N>>2]=f[o>>2];L=N+4|0;f[c>>2]=L;O=L}f[p>>2]=O;f[q>>2]=f[l>>2];f[r>>2]=f[A>>2];f[j>>2]=f[p>>2];f[i>>2]=f[q>>2];f[h>>2]=f[r>>2];s2(m,j,i,h)|0;Aua(e,b[a+73>>0]|0?2:1,m);a=f[k>>2]|0;f[h>>2]=f[o>>2];e=h+4|0;f[e>>2]=a;a=h+8|0;f[a>>2]=-1;j=h+12|0;f[j>>2]=-1;f[i>>2]=0;r=i+4|0;f[r>>2]=0;f[i+8>>2]=0;q=h+16|0;Rva(i,h,q);p=f[i>>2]|0;O=f[r>>2]|0;a:do if((p|0)==(O|0)){P=p;s=46}else{L=p;do{if((f[L>>2]|0)<0){P=L;s=46;break a}L=L+4|0}while((L|0)!=(O|0))}while(0);if((s|0)==46?(P|0)!=(O|0):0){p=P+4|0;if((p|0)==(O|0)){Q=O;R=P}else{L=p;p=P;while(1){P=f[L>>2]|0;if((P|0)<0)S=p;else{f[p>>2]=P;S=p+4|0}L=L+4|0;if((L|0)==(O|0))break;else p=S}Q=f[r>>2]|0;R=S}if((R|0)!=(Q|0))f[r>>2]=Q+(~((Q+-4-R|0)>>>2)<<2)}Aua(g,1,i);R=f[i>>2]|0;if(R|0){Q=f[r>>2]|0;if((Q|0)!=(R|0))f[r>>2]=Q+(~((Q+-4-R|0)>>>2)<<2);O5b(R)}R=f[k>>2]|0;f[h>>2]=f[o>>2];f[e>>2]=R;f[a>>2]=-1;f[j>>2]=-1;f[i>>2]=0;R=i+4|0;f[R>>2]=0;f[i+8>>2]=0;Rva(i,h,q);Q=f[i>>2]|0;r=f[R>>2]|0;b:do if((Q|0)==(r|0)){T=Q;s=61}else{S=Q;do{if((f[S>>2]|0)<0){T=S;s=61;break b}S=S+4|0}while((S|0)!=(r|0))}while(0);if((s|0)==61?(T|0)!=(r|0):0){Q=T+4|0;if((Q|0)==(r|0)){U=r;V=T}else{S=Q;Q=T;while(1){T=f[S>>2]|0;if((T|0)<0)W=Q;else{f[Q>>2]=T;W=Q+4|0}S=S+4|0;if((S|0)==(r|0))break;else Q=W}U=f[R>>2]|0;V=W}if((V|0)!=(U|0))f[R>>2]=U+(~((U+-4-V|0)>>>2)<<2)}V=g+4|0;U=f[V>>2]|0;W=g+8|0;if((U|0)==(f[W>>2]|0)){Sva(g,i);X=f[i>>2]|0}else{f[U>>2]=0;Q=U+4|0;f[Q>>2]=0;f[U+8>>2]=0;r=f[i>>2]|0;S=(f[R>>2]|0)-r|0;T=S>>2;if(T){if(T>>>0>1073741823)c4b(U);p=L5b(S)|0;f[Q>>2]=p;f[U>>2]=p;f[U+8>>2]=p+(T<<2);T=f[i>>2]|0;U=(f[R>>2]|0)-T|0;if((U|0)>0){Vac(p|0,T|0,U|0)|0;f[Q>>2]=p+(U>>>2<<2);Z=T}else Z=T}else Z=r;f[V>>2]=(f[V>>2]|0)+12;X=Z}if(X|0){Z=f[R>>2]|0;if((Z|0)!=(X|0))f[R>>2]=Z+(~((Z+-4-X|0)>>>2)<<2);O5b(X)}f[h>>2]=f[o>>2];f[e>>2]=1;f[a>>2]=-1;f[j>>2]=-1;f[i>>2]=0;X=i+4|0;f[X>>2]=0;f[i+8>>2]=0;Rva(i,h,q);Z=f[i>>2]|0;R=f[X>>2]|0;c:do if((Z|0)==(R|0)){_=Z;s=84}else{r=Z;do{if((f[r>>2]|0)<0){_=r;s=84;break c}r=r+4|0}while((r|0)!=(R|0))}while(0);if((s|0)==84?(_|0)!=(R|0):0){Z=_+4|0;if((Z|0)==(R|0)){$=R;aa=_}else{r=Z;Z=_;while(1){_=f[r>>2]|0;if((_|0)<0)ba=Z;else{f[Z>>2]=_;ba=Z+4|0}r=r+4|0;if((r|0)==(R|0))break;else Z=ba}$=f[X>>2]|0;aa=ba}if((aa|0)!=($|0))f[X>>2]=$+(~(($+-4-aa|0)>>>2)<<2)}aa=f[V>>2]|0;if((aa|0)==(f[W>>2]|0)){Sva(g,i);ca=f[i>>2]|0}else{f[aa>>2]=0;$=aa+4|0;f[$>>2]=0;f[aa+8>>2]=0;ba=f[i>>2]|0;Z=(f[X>>2]|0)-ba|0;R=Z>>2;if(R){if(R>>>0>1073741823)c4b(aa);r=L5b(Z)|0;f[$>>2]=r;f[aa>>2]=r;f[aa+8>>2]=r+(R<<2);R=f[i>>2]|0;aa=(f[X>>2]|0)-R|0;if((aa|0)>0){Vac(r|0,R|0,aa|0)|0;f[$>>2]=r+(aa>>>2<<2);da=R}else da=R}else da=ba;f[V>>2]=(f[V>>2]|0)+12;ca=da}if(ca|0){da=f[X>>2]|0;if((da|0)!=(ca|0))f[X>>2]=da+(~((da+-4-ca|0)>>>2)<<2);O5b(ca)}ca=f[k>>2]<<2;f[h>>2]=f[o>>2];f[e>>2]=ca;f[a>>2]=-1;f[j>>2]=-1;f[i>>2]=0;j=i+4|0;f[j>>2]=0;f[i+8>>2]=0;Rva(i,h,q);q=f[i>>2]|0;h=f[j>>2]|0;d:do if((q|0)==(h|0)){ea=q;s=107}else{a=q;do{if((f[a>>2]|0)<0){ea=a;s=107;break d}a=a+4|0}while((a|0)!=(h|0))}while(0);if((s|0)==107?(ea|0)!=(h|0):0){s=ea+4|0;if((s|0)==(h|0)){fa=h;ga=ea}else{q=s;s=ea;while(1){ea=f[q>>2]|0;if((ea|0)<0)ha=s;else{f[s>>2]=ea;ha=s+4|0}q=q+4|0;if((q|0)==(h|0))break;else s=ha}fa=f[j>>2]|0;ga=ha}if((ga|0)!=(fa|0))f[j>>2]=fa+(~((fa+-4-ga|0)>>>2)<<2)}ga=f[V>>2]|0;if((ga|0)==(f[W>>2]|0)){Sva(g,i);ia=f[i>>2]|0}else{f[ga>>2]=0;g=ga+4|0;f[g>>2]=0;f[ga+8>>2]=0;W=f[i>>2]|0;fa=(f[j>>2]|0)-W|0;ha=fa>>2;if(ha){if(ha>>>0>1073741823)c4b(ga);s=L5b(fa)|0;f[g>>2]=s;f[ga>>2]=s;f[ga+8>>2]=s+(ha<<2);ha=f[i>>2]|0;i=(f[j>>2]|0)-ha|0;if((i|0)>0){Vac(s|0,ha|0,i|0)|0;f[g>>2]=s+(i>>>2<<2);ja=ha}else ja=ha}else ja=W;f[V>>2]=(f[V>>2]|0)+12;ia=ja}if(ia|0){ja=f[j>>2]|0;if((ja|0)!=(ia|0))f[j>>2]=ja+(~((ja+-4-ia|0)>>>2)<<2);O5b(ia)}ia=f[m>>2]|0;if(ia|0){m=f[c>>2]|0;if((m|0)!=(ia|0))f[c>>2]=m+(~((m+-4-ia|0)>>>2)<<2);O5b(ia)}ia=f[l>>2]|0;if(!ia){u=d;return 0}l=f[A>>2]|0;if((l|0)!=(ia|0))f[A>>2]=l+(~((l+-4-ia|0)>>>2)<<2);O5b(ia);u=d;return 0}function heb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+128|0;h=g+112|0;i=g;j=g+56|0;if(!((f[c+4>>2]|0)==2?(f[d+4>>2]|0)==2:0)){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,28)|0;l=423127;m=k+28|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,423586,423043,160);bD(h)}n=c+8|0;o=f[n>>2]|0;if((o|0)==(f[d+8>>2]|0))p=o;else{f[h>>2]=0;f[h+4>>2]=0;k=aD(h,18)|0;l=423156;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,423586,423043,161);bD(h);p=f[n>>2]|0}if((p|0)==(f[c+12>>2]<<2|0))q=p;else{f[h>>2]=0;f[h+4>>2]=0;k=aD(h,20)|0;l=423175;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,423586,423043,162);bD(h);q=f[n>>2]|0}n=f[e+4>>2]|0;if((n|0)<3)r=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{p=f[e+40>>2]|0;o=0;s=1;while(1){t=Y(f[p+(o<<2)>>2]|0,s)|0;o=o+1|0;if((o|0)==(n|0)){r=t;break}else s=t}}if((q|0)!=(r|0)){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,28)|0;l=423196;m=k+28|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,423586,423043,163);bD(h)}r=f[c>>2]&4095;if(!((r|0)==(f[d>>2]&4095|0)?(r|0)==(f[e>>2]&4095|0):0)){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,50)|0;l=423225;m=k+50|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,423586,423043,164);bD(h)}l=a+4|0;SL(l,3);f[i>>2]=1124007936;a=i+4|0;r=i+8|0;q=i+40|0;k=a;m=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(m|0));f[q>>2]=r;s=i+48|0;n=i+44|0;f[n>>2]=s;f[s>>2]=0;f[i+52>>2]=0;o=h+8|0;f[o>>2]=0;f[o+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=i;SP(c,h);c=f[l>>2]|0;o=i+36|0;if((c|0)!=(i|0)){p=f[o>>2]|0;if(p|0){t=p+12|0;f[t>>2]=(f[t>>2]|0)+1}t=c+36|0;p=f[t>>2]|0;if(p|0?(v=p+12|0,p=f[v>>2]|0,f[v>>2]=p+-1,(p|0)==1):0)kL(c);f[t>>2]=0;p=c+16|0;v=c+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[v>>2]|0)>0){w=f[c+40>>2]|0;x=0;do{f[w+(x<<2)>>2]=0;x=x+1|0;y=f[v>>2]|0}while((x|0)<(y|0));f[c>>2]=f[i>>2];if((y|0)<3)z=28;else z=30}else{f[c>>2]=f[i>>2];z=28}if((z|0)==28){y=f[a>>2]|0;if((y|0)<3){f[v>>2]=y;f[c+8>>2]=f[r>>2];f[c+12>>2]=f[i+12>>2];r=f[n>>2]|0;y=f[c+44>>2]|0;f[y>>2]=f[r>>2];f[y+4>>2]=f[r+4>>2]}else z=30}if((z|0)==30)jL(c,i);f[p>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[c+28>>2]=f[i+28>>2];f[c+32>>2]=f[i+32>>2];f[t>>2]=f[o>>2]}t=f[o>>2]|0;if(t|0?(c=t+12|0,t=f[c>>2]|0,f[c>>2]=t+-1,(t|0)==1):0)kL(i);f[o>>2]=0;o=i+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[a>>2]|0)>0){o=f[q>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[a>>2]|0))}a=f[n>>2]|0;if((a|0)!=(s|0))UC(a);f[i>>2]=1124007936;a=i+4|0;s=i+8|0;n=i+40|0;k=a;m=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(m|0));f[n>>2]=s;q=i+48|0;o=i+44|0;f[o>>2]=q;f[q>>2]=0;f[i+52>>2]=0;t=h+8|0;f[t>>2]=0;f[t+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=i;SP(d,h);d=f[l>>2]|0;t=d+56|0;c=i+36|0;p=f[c>>2]|0;if((t|0)==(i|0))A=p;else{if(p|0){r=p+12|0;f[r>>2]=(f[r>>2]|0)+1}r=d+92|0;p=f[r>>2]|0;if(p|0?(y=p+12|0,p=f[y>>2]|0,f[y>>2]=p+-1,(p|0)==1):0)kL(t);f[r>>2]=0;p=d+72|0;y=d+60|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[y>>2]|0)>0){v=f[d+96>>2]|0;x=0;do{f[v+(x<<2)>>2]=0;x=x+1|0;B=f[y>>2]|0}while((x|0)<(B|0));f[t>>2]=f[i>>2];if((B|0)<3)z=51;else z=53}else{f[t>>2]=f[i>>2];z=51}if((z|0)==51){B=f[a>>2]|0;if((B|0)<3){f[y>>2]=B;f[d+64>>2]=f[s>>2];f[d+68>>2]=f[i+12>>2];s=f[o>>2]|0;B=f[d+100>>2]|0;f[B>>2]=f[s>>2];f[B+4>>2]=f[s+4>>2]}else z=53}if((z|0)==53)jL(t,i);f[p>>2]=f[i+16>>2];f[d+76>>2]=f[i+20>>2];f[d+80>>2]=f[i+24>>2];f[d+84>>2]=f[i+28>>2];f[d+88>>2]=f[i+32>>2];d=f[c>>2]|0;f[r>>2]=d;A=d}if(A|0?(d=A+12|0,A=f[d>>2]|0,f[d>>2]=A+-1,(A|0)==1):0)kL(i);f[c>>2]=0;c=i+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[n>>2]|0;n=0;do{f[c+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[a>>2]|0))}a=f[o>>2]|0;if((a|0)!=(q|0))UC(a);f[j>>2]=1124007936;a=j+4|0;q=j+8|0;o=j+40|0;k=a;m=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(m|0));f[o>>2]=q;q=j+48|0;k=j+44|0;f[k>>2]=q;f[q>>2]=0;f[j+52>>2]=0;m=h+8|0;f[m>>2]=0;f[m+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=j;SP(e,h);WL(i,j,1,1);h=f[l>>2]|0;l=h+112|0;e=i+36|0;m=f[e>>2]|0;if((l|0)==(i|0))C=m;else{if(m|0){n=m+12|0;f[n>>2]=(f[n>>2]|0)+1}n=h+148|0;m=f[n>>2]|0;if(m|0?(c=m+12|0,m=f[c>>2]|0,f[c>>2]=m+-1,(m|0)==1):0)kL(l);f[n>>2]=0;m=h+128|0;c=h+116|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[c>>2]|0)>0){A=f[h+152>>2]|0;d=0;do{f[A+(d<<2)>>2]=0;d=d+1|0;D=f[c>>2]|0}while((d|0)<(D|0));f[l>>2]=f[i>>2];if((D|0)<3)z=74;else z=76}else{f[l>>2]=f[i>>2];z=74}do if((z|0)==74){D=f[i+4>>2]|0;if((D|0)>=3){z=76;break}f[c>>2]=D;f[h+120>>2]=f[i+8>>2];f[h+124>>2]=f[i+12>>2];D=f[i+44>>2]|0;d=f[h+156>>2]|0;f[d>>2]=f[D>>2];f[d+4>>2]=f[D+4>>2]}while(0);if((z|0)==76)jL(l,i);f[m>>2]=f[i+16>>2];f[h+132>>2]=f[i+20>>2];f[h+136>>2]=f[i+24>>2];f[h+140>>2]=f[i+28>>2];f[h+144>>2]=f[i+32>>2];h=f[e>>2]|0;f[n>>2]=h;C=h}if(C|0?(h=C+12|0,C=f[h>>2]|0,f[h>>2]=C+-1,(C|0)==1):0)kL(i);f[e>>2]=0;e=i+16|0;C=i+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[C>>2]|0)>0){e=f[i+40>>2]|0;h=0;do{f[e+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[C>>2]|0))}C=f[i+44>>2]|0;if((C|0)!=(i+48|0))UC(C);C=j+36|0;i=f[C>>2]|0;do if(i|0){h=i+12|0;e=f[h>>2]|0;f[h>>2]=e+-1;if((e|0)!=1)break;kL(j)}while(0);f[C>>2]=0;C=j+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[a>>2]|0)>0){C=f[o>>2]|0;o=0;do{f[C+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[a>>2]|0))}a=f[k>>2]|0;if((a|0)==(q|0)){u=g;return}UC(a);u=g;return}function ieb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=a+48|0;if(b[a+44>>0]|0){h=f[a+52>>2]|0;a=f[g>>2]|0;i=h-a|0;j=i>>2;do if((a|0)!=(h|0)){if((i|0)<0){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,70)|0;l=442586;m=k+70|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,e,442657,442663,160);bD(e);n=1;break}if(!i)n=1;else{o=f[g>>2]|0;p=0;q=1;while(1){r=Y(f[o+(p<<2)>>2]|0,q)|0;p=p+1|0;if((p|0)==(j|0)){n=r;break}else q=r}}}else n=0;while(0);j=f[c+4>>2]|0;i=f[c>>2]|0;h=j-i|0;a=h>>2;do if((i|0)!=(j|0)){if((h|0)<0){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,70)|0;l=442586;m=k+70|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,e,442657,442663,160);bD(e);s=1;break}if(!h)s=1;else{q=f[c>>2]|0;p=0;o=1;while(1){r=Y(f[q+(p<<2)>>2]|0,o)|0;p=p+1|0;if((p|0)==(a|0)){s=r;break}else o=r}}}else s=0;while(0);if((n|0)!=(s|0)){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,57)|0;l=423516;m=k+57|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,e,423574,423043,154);bD(e)}}if((g|0)==(c|0)){u=d;return}r2(g,f[c>>2]|0,f[c+4>>2]|0);u=d;return}function jeb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;g=c&1;if(!(b[a+44>>0]|0)){h=a+72|0;b[h>>0]=g;u=d;return}f[e>>2]=0;f[e+4>>2]=0;c=aD(e,10)|0;i=423465;j=c+10|0;do{b[c>>0]=b[i>>0]|0;c=c+1|0;i=i+1|0}while((c|0)<(j|0));bO(-215,e,423497,423043,142);bD(e);h=a+72|0;b[h>>0]=g;u=d;return}function keb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;g=c&1;if(!(b[a+44>>0]|0)){h=a+73|0;b[h>>0]=g;u=d;return}f[e>>2]=0;f[e+4>>2]=0;c=aD(e,10)|0;i=423465;j=c+10|0;do{b[c>>0]=b[i>>0]|0;c=c+1|0;i=i+1|0}while((c|0)<(j|0));bO(-215,e,423476,423043,148);bD(e);h=a+73|0;b[h>>0]=g;u=d;return}function leb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>2>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>2;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=m;m=h;while(1){f[m>>2]=f[c>>2];j=j+-1|0;if(!j)break;else m=m+4|0}}if(!l){m=h+(b<<2)|0;if((n|0)==(m|0))return;else{o=i;p=n+(~((n+-4-m|0)>>>2)<<2)|0;break}}else{m=b-k|0;j=m;q=n;while(1){f[q>>2]=f[c>>2];j=j+-1|0;if(!j)break;else q=q+4|0}o=i;p=n+(m<<2)|0;break}}else{q=g;if(!g)r=e;else{j=a+4|0;k=f[j>>2]|0;if((k|0)!=(h|0))f[j>>2]=k+(~((k+-4-g|0)>>>2)<<2);O5b(q);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;r=0}if(b>>>0>1073741823)c4b(a);j=r>>1;q=r>>2>>>0<536870911?(j>>>0<b>>>0?b:j):1073741823;if(q>>>0>1073741823)c4b(a);j=L5b(q<<2)|0;k=a+4|0;f[k>>2]=j;f[a>>2]=j;f[d>>2]=j+(q<<2);q=b;l=j;while(1){f[l>>2]=f[c>>2];q=q+-1|0;if(!q)break;else l=l+4|0}o=k;p=j+(b<<2)|0}while(0);f[o>>2]=p;return}function meb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+288|0;d=c+272|0;e=c+32|0;g=c;h=c+256|0;AS(e,a);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=-1056571392;f[d+4>>2]=e;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=b;VO(d,g);Wi(e);p[g>>3]=1.0;a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;tS(e,g,b);f[d+8>>2]=0;f[d+12>>2]=0;f[d>>2]=-1056571392;f[d+4>>2]=e;g=h+8|0;f[g>>2]=0;f[g+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=b;XO(d,-1.0,h);Wi(e);u=c;return}function neb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0;d=u;u=u+64|0;e=d+40|0;g=d+20|0;h=d;i=a+4|0;j=a+40|0;hL(c,f[i>>2]|0,f[j>>2]|0,f[a>>2]&4095);k=f[a>>2]|0;switch(k&4095){case 5:{f[e>>2]=a;l=e+4|0;m=f[i>>2]|0;if((m|0)>0)o=f[(f[a+44>>2]|0)+(m+-1<<2)>>2]|0;else o=0;f[l>>2]=o;q=e+8|0;f[q>>2]=0;r=e+12|0;f[r>>2]=0;s=e+16|0;f[s>>2]=0;if(k&16384|0){t=f[a+16>>2]|0;f[r>>2]=t;if((m|0)<3)v=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{r=f[j>>2]|0;w=0;x=1;while(1){y=Y(f[r+(w<<2)>>2]|0,x)|0;w=w+1|0;if((w|0)==(m|0)){v=y;break}else x=y}}x=t+(Y(v,o)|0)|0;f[s>>2]=x}TN(e,0,0);f[g>>2]=c;x=g+4|0;o=f[c+4>>2]|0;if((o|0)>0)z=f[(f[c+44>>2]|0)+(o+-1<<2)>>2]|0;else z=0;f[x>>2]=z;v=g+8|0;f[v>>2]=0;t=g+12|0;f[t>>2]=0;m=g+16|0;f[m>>2]=0;if(f[c>>2]&16384|0){w=f[c+16>>2]|0;f[t>>2]=w;if((o|0)<3)A=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{t=f[c+40>>2]|0;r=0;y=1;while(1){B=Y(f[t+(r<<2)>>2]|0,y)|0;r=r+1|0;if((r|0)==(o|0)){A=B;break}else y=B}}y=w+(Y(A,z)|0)|0;f[m>>2]=y}TN(g,0,0);oeb(h,a);y=f[e>>2]|0;z=f[q>>2]|0;A=h+8|0;if((y|0)!=(f[h>>2]|0)?1:(z|0)!=(f[A>>2]|0)){w=y;y=z;do{C=+GVb(+n[y>>2]);n[f[v>>2]>>2]=C;z=f[l>>2]|0;if(w|0?(o=f[s>>2]|0,r=y+z|0,f[q>>2]=r,r>>>0>=o>>>0):0){f[q>>2]=r+(0-z);SN(e,1,1)}z=f[x>>2]|0;if(f[g>>2]|0?(r=f[m>>2]|0,o=(f[v>>2]|0)+z|0,f[v>>2]=o,o>>>0>=r>>>0):0){f[v>>2]=o+(0-z);SN(g,1,1)}oeb(h,a);w=f[e>>2]|0;y=f[q>>2]|0}while((w|0)!=(f[h>>2]|0)?1:(y|0)!=(f[A>>2]|0))}u=d;return}case 6:{f[e>>2]=a;A=e+4|0;y=f[i>>2]|0;if((y|0)>0)D=f[(f[a+44>>2]|0)+(y+-1<<2)>>2]|0;else D=0;f[A>>2]=D;i=e+8|0;f[i>>2]=0;w=e+12|0;f[w>>2]=0;q=e+16|0;f[q>>2]=0;if(k&16384|0){k=f[a+16>>2]|0;f[w>>2]=k;if((y|0)<3)E=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{w=f[j>>2]|0;j=0;v=1;while(1){m=Y(f[w+(j<<2)>>2]|0,v)|0;j=j+1|0;if((j|0)==(y|0)){E=m;break}else v=m}}v=k+(Y(E,D)|0)|0;f[q>>2]=v}TN(e,0,0);f[g>>2]=c;v=g+4|0;D=f[c+4>>2]|0;if((D|0)>0)F=f[(f[c+44>>2]|0)+(D+-1<<2)>>2]|0;else F=0;f[v>>2]=F;E=g+8|0;f[E>>2]=0;k=g+12|0;f[k>>2]=0;y=g+16|0;f[y>>2]=0;if(f[c>>2]&16384|0){j=f[c+16>>2]|0;f[k>>2]=j;if((D|0)<3)G=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{k=f[c+40>>2]|0;c=0;w=1;while(1){m=Y(f[k+(c<<2)>>2]|0,w)|0;c=c+1|0;if((c|0)==(D|0)){G=m;break}else w=m}}w=j+(Y(G,F)|0)|0;f[y>>2]=w}TN(g,0,0);peb(h,a);w=f[e>>2]|0;F=f[i>>2]|0;G=h+8|0;if((w|0)!=(f[h>>2]|0)?1:(F|0)!=(f[G>>2]|0)){j=w;w=F;do{C=+KVb(+p[w>>3]);p[f[E>>2]>>3]=C;F=f[A>>2]|0;if(j|0?(D=f[q>>2]|0,c=w+F|0,f[i>>2]=c,c>>>0>=D>>>0):0){f[i>>2]=c+(0-F);SN(e,1,1)}F=f[v>>2]|0;if(f[g>>2]|0?(c=f[y>>2]|0,D=(f[E>>2]|0)+F|0,f[E>>2]=D,D>>>0>=c>>>0):0){f[E>>2]=D+(0-F);SN(g,1,1)}peb(h,a);j=f[e>>2]|0;w=f[i>>2]|0}while((j|0)!=(f[h>>2]|0)?1:(w|0)!=(f[G>>2]|0))}u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;G=aD(e,43)|0;w=423898;h=G+43|0;do{b[G>>0]=b[w>>0]|0;G=G+1|0;w=w+1|0}while((G|0)<(h|0));bO(-210,e,423942,423043,74);bD(e);u=d;return}}}function oeb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[a>>2]=b;c=a+4|0;d=b+4|0;e=f[d>>2]|0;if((e|0)>0)g=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else g=0;f[c>>2]=g;h=a+8|0;f[h>>2]=0;i=a+12|0;f[i>>2]=0;j=a+16|0;f[j>>2]=0;if(f[b>>2]&16384|0){k=f[b+16>>2]|0;f[i>>2]=k;if((e|0)<3)l=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{m=f[b+40>>2]|0;n=0;o=1;while(1){p=Y(f[m+(n<<2)>>2]|0,o)|0;n=n+1|0;if((n|0)==(e|0)){l=p;break}else o=p}}o=k+(Y(l,g)|0)|0;f[j>>2]=o}TN(a,0,0);o=f[d>>2]|0;if((o|0)<3)q=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{d=f[b+40>>2]|0;b=0;g=1;while(1){l=Y(f[d+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(o|0)){q=l;break}else g=l}}if((q|0)==0|(f[a>>2]|0)==0)return;g=Y(f[c>>2]|0,q)|0;c=(f[h>>2]|0)+g|0;f[h>>2]=c;if(c>>>0>=(f[i>>2]|0)>>>0?(f[j>>2]|0)>>>0>c>>>0:0)return;f[h>>2]=c+(0-g);SN(a,q,1);return}function peb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[a>>2]=b;c=a+4|0;d=b+4|0;e=f[d>>2]|0;if((e|0)>0)g=f[(f[b+44>>2]|0)+(e+-1<<2)>>2]|0;else g=0;f[c>>2]=g;h=a+8|0;f[h>>2]=0;i=a+12|0;f[i>>2]=0;j=a+16|0;f[j>>2]=0;if(f[b>>2]&16384|0){k=f[b+16>>2]|0;f[i>>2]=k;if((e|0)<3)l=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{m=f[b+40>>2]|0;n=0;o=1;while(1){p=Y(f[m+(n<<2)>>2]|0,o)|0;n=n+1|0;if((n|0)==(e|0)){l=p;break}else o=p}}o=k+(Y(l,g)|0)|0;f[j>>2]=o}TN(a,0,0);o=f[d>>2]|0;if((o|0)<3)q=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;else{d=f[b+40>>2]|0;b=0;g=1;while(1){l=Y(f[d+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(o|0)){q=l;break}else g=l}}if((q|0)==0|(f[a>>2]|0)==0)return;g=Y(f[c>>2]|0,q)|0;c=(f[h>>2]|0)+g|0;f[h>>2]=c;if(c>>>0>=(f[i>>2]|0)>>>0?(f[j>>2]|0)>>>0>c>>>0:0)return;f[h>>2]=c+(0-g);SN(a,q,1);return}function qeb(a,b){a=a|0;b=b|0;var c=0;c=L5b(164)|0;reb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=121648;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function reb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0;d=u;u=u+432|0;e=d+32|0;g=d;h=d+368|0;i=d+312|0;j=d+256|0;Jwa(a);f[a>>2]=121668;k=a+44|0;f[k>>2]=1124007936;l=a+48|0;m=a+52|0;n=a+84|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=m;q=a+92|0;r=a+88|0;f[r>>2]=q;f[q>>2]=0;f[a+96>>2]=0;q=a+100|0;f[q>>2]=1124007936;s=a+104|0;t=a+108|0;v=a+140|0;o=s;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[v>>2]=t;w=a+148|0;x=a+144|0;f[x>>2]=w;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;Kwa(a,c);w=a+4|0;y=a+8|0;z=(f[y>>2]|0)-(f[w>>2]|0)|0;if(!((z|0)!=0&((z|0)/56|0)>>>0<3)){f[e>>2]=0;f[e+4>>2]=0;o=aD(e,38)|0;A=424308;p=o+38|0;do{b[o>>0]=b[A>>0]|0;o=o+1|0;A=A+1|0}while((o|0)<(p|0));bO(-215,e,424347,424371,71);bD(e)}f[e>>2]=0;f[e+4>>2]=0;o=aD(e,10)|0;A=424460;p=o+10|0;do{b[o>>0]=b[A>>0]|0;o=o+1|0;A=A+1|0}while((o|0)<(p|0));z=Gwa(Eya(c,e)|0,-1)|0;bD(e);B=f[w>>2]|0;C=f[B+4>>2]|0;if((C|0)<3)D=Y(f[B+12>>2]|0,f[B+8>>2]|0)|0;else{E=f[B+40>>2]|0;B=0;F=1;while(1){G=Y(f[E+(B<<2)>>2]|0,F)|0;B=B+1|0;if((B|0)==(C|0)){D=G;break}else F=G}}f[e>>2]=0;f[e+4>>2]=0;o=aD(e,9)|0;A=434144;p=o+9|0;do{b[o>>0]=b[A>>0]|0;o=o+1|0;A=A+1|0}while((o|0)<(p|0));F=c+4|0;c=f[F>>2]|0;do if(c){C=f[e>>2]|0;B=(C|0)==0?1124530:C;E=F;G=c;a:while(1){H=G;while(1){I=f[H+16>>2]|0;if((I|0)==(C|0))break;if((gTb((I|0)==0?1124530:I,B)|0)>=0)break;I=f[H+4>>2]|0;if(!I){K=E;break a}else H=I}G=f[H>>2]|0;if(!G){K=H;break}else E=H}if((K|0)!=(F|0)){E=f[K+16>>2]|0;if((C|0)!=(E|0)?(gTb(B,(E|0)==0?1124530:E)|0)<=-1:0){L=1;break}E=Gwa(K+24|0,-1)|0;L=(E|0)!=0|(J|0)!=0}else L=1}else L=1;while(0);K=a+40|0;b[K>>0]=L&1;bD(e);f[e>>2]=0;f[e+4>>2]=0;L=aD(e,4)|0;b[L>>0]=97;b[L+1>>0]=120;b[L+2>>0]=105;b[L+3>>0]=115;L=f[F>>2]|0;do if(L){c=f[e>>2]|0;E=(c|0)==0?1124530:c;G=F;I=L;b:while(1){M=I;while(1){N=f[M+16>>2]|0;if((N|0)==(c|0))break;if((gTb((N|0)==0?1124530:N,E)|0)>=0)break;N=f[M+4>>2]|0;if(!N){O=G;break b}else M=N}I=f[M>>2]|0;if(!I){O=M;break}else G=M}if((O|0)!=(F|0)){G=f[O+16>>2]|0;if((c|0)!=(G|0)?(gTb(E,(G|0)==0?1124530:G)|0)<=-1:0){P=1;break}G=Gwa(O+24|0,-1)|0;P=G}else P=1}else P=1;while(0);f[a+36>>2]=P;bD(e);P=f[w>>2]|0;O=f[P+4>>2]|0;if((O|0)>1){if((O|0)==2)Q=Y(f[P+12>>2]|0,f[P+8>>2]|0)|0;else{F=f[P+40>>2]|0;P=0;L=1;while(1){G=Y(f[F+(P<<2)>>2]|0,L)|0;P=P+1|0;if((P|0)==(O|0)){Q=G;break}else L=G}}if((D-((D|0)%(z|0)|0)|0)!=(Q|0))R=35}else R=35;if((R|0)==35){f[e>>2]=0;f[e+4>>2]=0;o=aD(e,73)|0;A=424471;p=o+73|0;do{b[o>>0]=b[A>>0]|0;o=o+1|0;A=A+1|0}while((o|0)<(p|0));bO(-215,e,424347,424371,78);bD(e)}do if(b[K>>0]|0){Q=f[w>>2]|0;D=Q;if(((f[y>>2]|0)-Q|0)==112){Q=f[D+60>>2]|0;if((Q|0)<3)S=Y(f[D+68>>2]|0,f[D+64>>2]|0)|0;else{L=f[D+96>>2]|0;D=0;O=1;while(1){P=Y(f[L+(D<<2)>>2]|0,O)|0;D=D+1|0;if((D|0)==(Q|0)){S=P;break}else O=P}}if((z|0)==(S|0))break}f[e>>2]=0;f[e+4>>2]=0;o=aD(e,69)|0;A=424545;p=o+69|0;do{b[o>>0]=b[A>>0]|0;o=o+1|0;A=A+1|0}while((o|0)<(p|0));bO(-215,e,424347,424371,79);bD(e)}while(0);WL(e,f[w>>2]|0,1,z);A=f[w>>2]|0;if((A|0)!=(e|0)){S=e+36|0;y=f[S>>2]|0;if(y|0){O=y+12|0;f[O>>2]=(f[O>>2]|0)+1}O=A+36|0;y=f[O>>2]|0;if(y|0?(Q=y+12|0,y=f[Q>>2]|0,f[Q>>2]=y+-1,(y|0)==1):0)kL(A);f[O>>2]=0;y=A+16|0;Q=A+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[Q>>2]|0)>0){D=f[A+40>>2]|0;L=0;do{f[D+(L<<2)>>2]=0;L=L+1|0;T=f[Q>>2]|0}while((L|0)<(T|0));f[A>>2]=f[e>>2];if((T|0)<3)R=55;else R=57}else{f[A>>2]=f[e>>2];R=55}if((R|0)==55){T=f[e+4>>2]|0;if((T|0)<3){f[Q>>2]=T;f[A+8>>2]=f[e+8>>2];f[A+12>>2]=f[e+12>>2];T=f[e+44>>2]|0;Q=f[A+44>>2]|0;f[Q>>2]=f[T>>2];f[Q+4>>2]=f[T+4>>2]}else R=57}if((R|0)==57)jL(A,e);f[y>>2]=f[e+16>>2];f[A+20>>2]=f[e+20>>2];f[A+24>>2]=f[e+24>>2];f[A+28>>2]=f[e+28>>2];f[A+32>>2]=f[e+32>>2];f[O>>2]=f[S>>2]}if((k|0)!=(A|0)){S=A+36|0;O=f[S>>2]|0;if(O|0){y=O+12|0;f[y>>2]=(f[y>>2]|0)+1}y=a+80|0;O=f[y>>2]|0;if(O|0?(T=O+12|0,O=f[T>>2]|0,f[T>>2]=O+-1,(O|0)==1):0)kL(k);f[y>>2]=0;O=a+60|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[l>>2]|0)>0){T=f[n>>2]|0;Q=0;do{f[T+(Q<<2)>>2]=0;Q=Q+1|0;U=f[l>>2]|0}while((Q|0)<(U|0));f[k>>2]=f[A>>2];if((U|0)<3)R=70;else R=72}else{f[k>>2]=f[A>>2];R=70}if((R|0)==70){U=f[A+4>>2]|0;if((U|0)<3){f[l>>2]=U;f[m>>2]=f[A+8>>2];f[a+56>>2]=f[A+12>>2];U=f[A+44>>2]|0;Q=f[r>>2]|0;f[Q>>2]=f[U>>2];f[Q+4>>2]=f[U+4>>2]}else R=72}if((R|0)==72)jL(k,A);f[O>>2]=f[A+16>>2];f[a+64>>2]=f[A+20>>2];f[a+68>>2]=f[A+24>>2];f[a+72>>2]=f[A+28>>2];f[a+76>>2]=f[A+32>>2];f[y>>2]=f[S>>2]}S=e+36|0;y=f[S>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)kL(e);f[S>>2]=0;S=e+16|0;y=e+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[y>>2]|0)>0){S=f[e+40>>2]|0;A=0;do{f[S+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[y>>2]|0))}y=f[e+44>>2]|0;if((y|0)!=(e+48|0))UC(y);y=a+56|0;A=f[y>>2]|0;if(A&7|0){S=A+7&-8;O=f[m>>2]|0;U=f[k>>2]&4095;f[h>>2]=1124007936;Q=h+4|0;T=h+8|0;L=h+40|0;o=Q;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[L>>2]=T;T=h+48|0;o=h+44|0;f[o>>2]=T;f[T>>2]=0;f[h+52>>2]=0;f[e>>2]=O;f[e+4>>2]=S;hL(h,2,e,U);f[e>>2]=-2147483648;f[e+4>>2]=2147483647;f[g>>2]=A;f[g+4>>2]=S;lL(i,h,e,g);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[e>>2]=-1056833530;f[e+4>>2]=g;f[e+8>>2]=1;f[e+12>>2]=4;VP(i,e,UM()|0)|0;f[e>>2]=-2147483648;f[e+4>>2]=2147483647;f[g>>2]=0;f[g+4>>2]=A;lL(j,h,e,g);g=j+36|0;A=f[g>>2]|0;if((k|0)==(j|0))V=A;else{if(A|0){S=A+12|0;f[S>>2]=(f[S>>2]|0)+1}S=a+80|0;A=f[S>>2]|0;if(A|0?(U=A+12|0,A=f[U>>2]|0,f[U>>2]=A+-1,(A|0)==1):0)kL(k);f[S>>2]=0;A=a+60|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[l>>2]|0)>0){U=f[n>>2]|0;n=0;do{f[U+(n<<2)>>2]=0;n=n+1|0;W=f[l>>2]|0}while((n|0)<(W|0));f[k>>2]=f[j>>2];if((W|0)<3)R=94;else R=96}else{f[k>>2]=f[j>>2];R=94}if((R|0)==94){W=f[j+4>>2]|0;if((W|0)<3){f[l>>2]=W;f[m>>2]=f[j+8>>2];f[y>>2]=f[j+12>>2];y=f[j+44>>2]|0;m=f[r>>2]|0;f[m>>2]=f[y>>2];f[m+4>>2]=f[y+4>>2]}else R=96}if((R|0)==96)jL(k,j);f[A>>2]=f[j+16>>2];f[a+64>>2]=f[j+20>>2];f[a+68>>2]=f[j+24>>2];f[a+72>>2]=f[j+28>>2];f[a+76>>2]=f[j+32>>2];A=f[g>>2]|0;f[S>>2]=A;V=A}if(V|0?(A=V+12|0,V=f[A>>2]|0,f[A>>2]=V+-1,(V|0)==1):0)kL(j);f[g>>2]=0;g=j+16|0;V=j+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[V>>2]|0)>0){g=f[j+40>>2]|0;A=0;do{f[g+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[V>>2]|0))}V=f[j+44>>2]|0;if((V|0)!=(j+48|0))UC(V);V=f[w>>2]|0;j=e+8|0;f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=k;SP(V,e);V=i+36|0;j=f[V>>2]|0;if(j|0?(A=j+12|0,j=f[A>>2]|0,f[A>>2]=j+-1,(j|0)==1):0)kL(i);f[V>>2]=0;V=i+16|0;j=i+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[j>>2]|0)>0){V=f[i+40>>2]|0;A=0;do{f[V+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))UC(j);j=h+36|0;i=f[j>>2]|0;do if(i|0){A=i+12|0;V=f[A>>2]|0;f[A>>2]=V+-1;if((V|0)!=1)break;kL(h)}while(0);f[j>>2]=0;j=h+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[Q>>2]|0)>0){j=f[L>>2]|0;L=0;do{f[j+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[Q>>2]|0))}Q=f[o>>2]|0;if((Q|0)!=(T|0))UC(Q)}if(!(b[K>>0]|0)){QS(e,1,z,f[k>>2]&4095);k=f[e>>2]|0;th[f[(f[k>>2]|0)+12>>2]&511](k,e,q,-1);Wi(e);u=d;return}WL(e,(f[w>>2]|0)+56|0,1,1);k=f[w>>2]|0;w=k+56|0;if((w|0)!=(e|0)){z=e+36|0;K=f[z>>2]|0;if(K|0){Q=K+12|0;f[Q>>2]=(f[Q>>2]|0)+1}Q=k+92|0;K=f[Q>>2]|0;if(K|0?(T=K+12|0,K=f[T>>2]|0,f[T>>2]=K+-1,(K|0)==1):0)kL(w);f[Q>>2]=0;K=k+72|0;T=k+60|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[T>>2]|0)>0){o=f[k+96>>2]|0;L=0;do{f[o+(L<<2)>>2]=0;L=L+1|0;X=f[T>>2]|0}while((L|0)<(X|0));f[w>>2]=f[e>>2];if((X|0)<3)R=135;else R=137}else{f[w>>2]=f[e>>2];R=135}if((R|0)==135){X=f[e+4>>2]|0;if((X|0)<3){f[T>>2]=X;f[k+64>>2]=f[e+8>>2];f[k+68>>2]=f[e+12>>2];X=f[e+44>>2]|0;T=f[k+100>>2]|0;f[T>>2]=f[X>>2];f[T+4>>2]=f[X+4>>2]}else R=137}if((R|0)==137)jL(w,e);f[K>>2]=f[e+16>>2];f[k+76>>2]=f[e+20>>2];f[k+80>>2]=f[e+24>>2];f[k+84>>2]=f[e+28>>2];f[k+88>>2]=f[e+32>>2];f[Q>>2]=f[z>>2]}if((q|0)!=(w|0)){z=k+92|0;Q=f[z>>2]|0;if(Q|0){K=Q+12|0;f[K>>2]=(f[K>>2]|0)+1}K=a+136|0;Q=f[K>>2]|0;if(Q|0?(X=Q+12|0,Q=f[X>>2]|0,f[X>>2]=Q+-1,(Q|0)==1):0)kL(q);f[K>>2]=0;Q=a+116|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[s>>2]|0)>0){X=f[v>>2]|0;v=0;do{f[X+(v<<2)>>2]=0;v=v+1|0;Z=f[s>>2]|0}while((v|0)<(Z|0));f[q>>2]=f[w>>2];if((Z|0)<3)R=150;else R=152}else{f[q>>2]=f[w>>2];R=150}do if((R|0)==150){Z=f[k+60>>2]|0;if((Z|0)>=3){R=152;break}f[s>>2]=Z;f[t>>2]=f[k+64>>2];f[a+112>>2]=f[k+68>>2];Z=f[k+100>>2]|0;v=f[x>>2]|0;f[v>>2]=f[Z>>2];f[v+4>>2]=f[Z+4>>2]}while(0);if((R|0)==152)jL(q,w);f[Q>>2]=f[k+72>>2];f[a+120>>2]=f[k+76>>2];f[a+124>>2]=f[k+80>>2];f[a+128>>2]=f[k+84>>2];f[a+132>>2]=f[k+88>>2];f[K>>2]=f[z>>2]}z=e+36|0;K=f[z>>2]|0;if(K|0?(k=K+12|0,K=f[k>>2]|0,f[k>>2]=K+-1,(K|0)==1):0)kL(e);f[z>>2]=0;z=e+16|0;K=e+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[K>>2]|0)>0){z=f[e+40>>2]|0;k=0;do{f[z+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[K>>2]|0))}K=f[e+44>>2]|0;if((K|0)!=(e+48|0))UC(K);u=d;return}function seb(a){a=a|0;O5b(a);return}function teb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ueb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=121668;b=a+156|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+160>>2]=0;b=a+100|0;c=a+136|0;e=f[c>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)kL(b);f[c>>2]=0;c=a+116|0;b=a+104|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+140>>2]|0;e=0;do{f[c+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[b>>2]|0))}b=f[a+144>>2]|0;if((b|0)!=(a+148|0))UC(b);b=a+44|0;e=a+80|0;c=f[e>>2]|0;if(c|0?(d=c+12|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0)kL(b);f[e>>2]=0;e=a+60|0;b=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[b>>2]|0)>0){e=f[a+84>>2]|0;c=0;do{f[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+88>>2]|0;if((b|0)==(a+92|0)){lua(a);return}UC(b);lua(a);return}function veb(a){a=a|0;ueb(a);O5b(a);return}function web(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=u;u=u+128|0;g=e+64|0;h=e+56|0;i=e;dQ(h,121792);j=f[a+36>>2]|0;k=f[f[c>>2]>>2]|0;l=k+4|0;m=f[l>>2]|0;n=((j|0)<0?m:0)+j|0;if((n|0)<0){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,35)|0;o=431162;p=j+35|0;do{b[j>>0]=b[o>>0]|0;j=j+1|0;o=o+1|0}while((j|0)<(p|0));bO(-215,g,442657,431198,913);bD(g);q=f[l>>2]|0}else q=m;m=(q|0)<(n|0)?q:n;if((m|0)>0){n=f[k+40>>2]|0;k=1;q=0;while(1){l=Y(f[n+(q<<2)>>2]|0,k)|0;q=q+1|0;if((q|0)>=(m|0)){r=l;break}else k=l}}else r=1;k=c+4|0;m=f[c>>2]|0;if((f[k>>2]|0)!=(m|0)){q=a+44|0;n=a+100|0;l=a+160|0;a=i+36|0;o=i+16|0;j=i+4|0;p=i+40|0;s=i+44|0;t=i+48|0;v=g+36|0;w=g+16|0;x=g+4|0;y=g+40|0;z=g+44|0;A=g+48|0;B=0;C=m;do{WL(g,f[C+(B<<2)>>2]|0,1,r);WL(i,(f[d>>2]|0)+(B*56|0)|0,1,r);m=SQ()|0;Deb(g,q,n,i,f[l>>2]|0,m);m=f[a>>2]|0;if(m|0?(D=m+12|0,m=f[D>>2]|0,f[D>>2]=m+-1,(m|0)==1):0)kL(i);f[a>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[j>>2]|0)>0){m=f[p>>2]|0;D=0;do{f[m+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[j>>2]|0))}D=f[s>>2]|0;if((D|0)!=(t|0))UC(D);D=f[v>>2]|0;if(D|0?(m=D+12|0,D=f[m>>2]|0,f[m>>2]=D+-1,(D|0)==1):0)kL(g);f[v>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){D=f[y>>2]|0;m=0;do{f[D+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[x>>2]|0))}m=f[z>>2]|0;if((m|0)!=(A|0))UC(m);B=B+1|0;C=f[c>>2]|0}while(B>>>0<(f[k>>2]|0)-C>>2>>>0)}if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function xeb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,121760);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function yeb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{if(Owa()|0)c=(f[a+36>>2]|0)==1;else c=0;break}default:c=0}return c|0}function zeb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Aeb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+156|0;d=f[b>>2]|0;e=f[b+4>>2]|0;if(d|0){b=d+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[c>>2]=d;d=a+160|0;f[d>>2]=e;if(b|0?(e=b+4|0,a=f[e>>2]|0,f[e>>2]=a+-1,(a|0)==1):0)bi[f[(f[b>>2]|0)+8>>2]&2047](b);return (f[d>>2]|0)!=0|0}function Beb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+32|0;d=g+8|0;h=g;i=c+4|0;if(((f[i>>2]|0)-(f[c>>2]|0)|0)!=12){f[d>>2]=0;f[d+4>>2]=0;j=aD(d,18)|0;k=443104;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,d,442770,424371,110);bD(d)}m=a+4|0;n=f[m>>2]|0;o=(f[a+8>>2]|0)-n|0;if((o|0)!=0&((o|0)/56|0)>>>0<3){p=m;q=n}else{f[d>>2]=0;f[d+4>>2]=0;j=aD(d,38)|0;k=424308;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,d,442770,424371,111);bD(d);p=m;q=f[m>>2]|0}if((f[q+4>>2]|0)!=2){f[d>>2]=0;f[d+4>>2]=0;j=aD(d,18)|0;k=424615;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,d,442770,424371,112);bD(d)}q=f[a+36>>2]|0;m=f[c>>2]|0;c=((q|0)<0?(f[m+4>>2]|0)-(f[m>>2]|0)>>2:0)+q|0;q=f[f[(f[p>>2]|0)+40>>2]>>2]|0;n=c+1|0;f[d>>2]=0;o=d+4|0;f[o>>2]=0;f[d+8>>2]=0;r=m;if(n>>>0>1073741823)c4b(d);s=n<<2;t=L5b(s)|0;f[d>>2]=t;v=t+(n<<2)|0;f[d+8>>2]=v;Nac(t|0,0,s|0)|0;f[o>>2]=v;if((c|0)>0){s=f[m>>2]|0;m=0;do{f[t+(m<<2)>>2]=f[s+(m<<2)>>2];m=m+1|0}while((m|0)!=(c|0))}f[v+-4>>2]=q;v=((f[i>>2]|0)-r|0)/12|0;r=e+4|0;i=f[r>>2]|0;c=f[e>>2]|0;m=(i-c|0)/12|0;s=c;c=i;if(v>>>0<=m>>>0){if(v>>>0<m>>>0?(i=s+(v*12|0)|0,(c|0)!=(i|0)):0){s=c;while(1){c=s+-12|0;f[r>>2]=c;t=f[c>>2]|0;if(!t)w=c;else{c=s+-8|0;n=f[c>>2]|0;if((n|0)!=(t|0))f[c>>2]=n+(~((n+-4-t|0)>>>2)<<2);O5b(t);w=f[r>>2]|0}if((w|0)==(i|0))break;else s=w}}}else sbb(e,v-m|0,d);if(b[a+40>>0]|0){a=f[p>>2]|0;p=f[a+60>>2]|0;if((p|0)<3)x=Y(f[a+68>>2]|0,f[a+64>>2]|0)|0;else{m=f[a+96>>2]|0;a=0;v=1;while(1){e=Y(f[m+(a<<2)>>2]|0,v)|0;a=a+1|0;if((a|0)==(p|0)){x=e;break}else v=e}}if((q|0)!=(x|0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,46)|0;k=424634;l=j+46|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,442770,424371,123);bD(h)}}h=f[d>>2]|0;if(!h){u=g;return 0}d=f[o>>2]|0;if((d|0)!=(h|0))f[o>>2]=d+(~((d+-4-h|0)>>>2)<<2);O5b(h);u=g;return 0}function Ceb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+16|0;e=c;g=d+4|0;h=f[g>>2]|0;i=f[d>>2]|0;if((h|0)==(i|0)){j=0;k=0;J=j;u=c;return k|0}l=f[(f[(f[a+4>>2]|0)+40>>2]|0)+4>>2]|0;a=cbc(l|0,((l|0)<0)<<31>>31|0,3,0)|0;l=J;m=e+4|0;n=0;o=i;i=0;p=0;q=h;while(1){h=o;r=f[h+(n*12|0)+4>>2]|0;s=f[h+(n*12|0)>>2]|0;h=r-s|0;t=h>>2;v=s;do if((v|0)!=(r|0)){if((h|0)<=-4){f[e>>2]=0;f[m>>2]=0;s=aD(e,70)|0;w=442586;x=s+70|0;do{b[s>>0]=b[w>>0]|0;s=s+1|0;w=w+1|0}while((s|0)<(x|0));bO(-215,e,442657,442663,160);bD(e);y=1;z=f[d>>2]|0;A=f[g>>2]|0;break}if((h|0)>0){w=0;s=1;while(1){x=Y(f[v+(w<<2)>>2]|0,s)|0;w=w+1|0;if((w|0)>=(t|0)){y=x;z=o;A=q;break}else s=x}}else{y=1;z=o;A=q}}else{y=0;z=o;A=q}while(0);t=cbc(a|0,l|0,y|0,((y|0)<0)<<31>>31|0)|0;v=Kac(t|0,J|0,i|0,p|0)|0;n=n+1|0;t=Rac(0,v|0,32)|0;v=J;if(n>>>0>=((A-z|0)/12|0)>>>0){j=v;k=t;break}else{o=z;i=t;p=v;q=A}}J=j;u=c;return k|0}function Deb(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;j=u;u=u+48|0;k=j+8|0;l=j;if((((((f[a+4>>2]|0)==2?(f[a+12>>2]|0)==(f[c+12>>2]|0):0)?(f[g+8>>2]|0)==(f[a+8>>2]|0):0)?(m=f[g+12>>2]|0,(m|0)==(f[c+8>>2]|0)):0)?(n=f[a>>2]|0,o=n&4095,(o|0)==(f[c>>2]&4095|0)):0)?((o|0)==5?(o|0)==(f[g>>2]&4095|0):0):0){if(f[e+16>>2]|0){o=f[e+4>>2]|0;p=(o|0)<3;if(p)q=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{r=f[e+40>>2]|0;s=0;t=1;while(1){v=Y(f[r+(s<<2)>>2]|0,t)|0;s=s+1|0;if((s|0)==(o|0)){q=v;break}else t=v}}if(!((o|0)==0|(q|0)==0)){q=f[e>>2]|0;if((q&16384|0)!=0&((n^q)&4095|0)==0){if(p)w=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{p=f[e+40>>2]|0;q=0;n=1;while(1){t=Y(f[p+(q<<2)>>2]|0,n)|0;q=q+1|0;if((q|0)==(o|0)){w=t;break}else n=t}}if((w|0)!=(m|0))x=19}else x=19}}}else x=19;if((x|0)==19){f[k>>2]=0;f[k+4>>2]=0;Vac(aD(k,323)|0,424798,323)|0;bO(-215,k,443206,424371,152);bD(k)}f[k>>2]=121832;x=k+4|0;d[x+24>>1]=0;f[x>>2]=a;f[k+8>>2]=c;f[k+12>>2]=e;f[k+20>>2]=g;f[k+24>>2]=i;f[k+16>>2]=h;h=(oO(10)|0)&1;b[k+28>>0]=h;h=(oO(11)|0)&1;b[k+29>>0]=h;f[l>>2]=0;f[l+4>>2]=i;RQ(l,k,+(i|0));u=j;return}function Eeb(a){a=a|0;O5b(a);return}function Feb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;c=u;u=u+1072|0;d=c;e=a+4|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]|0;j=f[i+8>>2]|0;k=f[g+12>>2]|0;l=k+7|0;m=l&-8;o=Y(j,f[g+8>>2]|0)|0;g=f[a+24>>2]|0;p=((o+-1+g|0)>>>0)/(g>>>0)|0;q=Y(f[b>>2]|0,p)|0;r=f[b+4>>2]|0;b=Y(r,p)|0;p=(r|0)==(g|0)|o>>>0<b>>>0?o:b;b=((f[f[i+44>>2]>>2]|0)>>>0)/((1212424721>>>(f[i>>2]<<2&28)&15)>>>0)|0;i=m+8|0;o=d+8|0;f[d>>2]=o;g=d+4|0;f[g>>2]=i;if(i>>>0>264){r=N5b(i>>>0>1073741823?-1:i<<2)|0;f[d>>2]=r;s=r}else s=o;r=s+31&-32;s=r;if((k|0)<(m|0))Nac(s+(k<<2)|0,0,(l>>>3<<5)-(k<<2)|0)|0;a:do if(p>>>0>q>>>0){l=a+20|0;m=a+12|0;i=r;t=k<<2;v=a+16|0;if((k|0)>0)w=q;else{x=q;while(1){y=(x>>>0)/(j>>>0)|0;z=x-(Y(y,j)|0)|0;A=f[e>>2]|0;B=(f[A+16>>2]|0)+(Y(f[f[A+44>>2]>>2]|0,y)|0)|0;A=f[l>>2]|0;C=(f[A+16>>2]|0)+(Y(f[f[A+44>>2]>>2]|0,y)|0)+(z<<2)|0;y=(f[(f[m>>2]|0)+16>>2]|0)+(z<<2)|0;A=j-z|0;D=p-x|0;E=(D|0)<(A|0)?D:A;Vac(i|0,B|0,t|0)|0;if((E|0)>0){B=0;do{f[C+(B<<2)>>2]=f[y+(B<<2)>>2];B=B+1|0}while((B|0)<(E|0))}B=f[v>>2]|0;if(B|0)Qh[f[(f[B>>2]|0)+92>>2]&127](B,C,C,1,1,z,E+z|0);x=E+x|0;if(p>>>0<=x>>>0)break a}}do{x=(w>>>0)/(j>>>0)|0;B=w-(Y(x,j)|0)|0;y=f[e>>2]|0;A=(f[y+16>>2]|0)+(Y(f[f[y+44>>2]>>2]|0,x)|0)|0;y=f[h>>2]|0;D=f[y+16>>2]|0;F=f[f[y+44>>2]>>2]|0;y=f[l>>2]|0;G=(f[y+16>>2]|0)+(Y(f[f[y+44>>2]>>2]|0,x)|0)+(B<<2)|0;x=(f[(f[m>>2]|0)+16>>2]|0)+(B<<2)|0;y=j-B|0;H=p-w|0;I=(H|0)<(y|0)?H:y;Vac(i|0,A|0,t|0)|0;if((I|0)>0){A=0;y=D+(Y(F,B)|0)|0;while(1){J=+n[x+(A<<2)>>2];F=0;do{J=J+ +n[s+(F<<2)>>2]*+n[y+(F<<2)>>2];F=F+1|0}while((F|0)!=(k|0));n[G+(A<<2)>>2]=J;A=A+1|0;if((A|0)>=(I|0))break;else y=y+(b<<2)|0}}y=f[v>>2]|0;if(y|0)Qh[f[(f[y>>2]|0)+92>>2]&127](y,G,G,1,1,B,I+B|0);w=I+w|0}while(p>>>0>w>>>0)}while(0);w=f[d>>2]|0;if((w|0)==(o|0)){u=c;return}if(w|0)P5b(w);f[d>>2]=o;f[g>>2]=264;u=c;return}function Geb(){var a=0;f[124364]=0;f[124365]=0;f[124366]=0;b[497467]=8;a=497456;f[a>>2]=1869181520;f[a+4>>2]=2020557426;b[497464]=0;zd(1483,497456,x|0)|0;return}function Heb(a,b){a=a|0;b=b|0;var c=0;c=L5b(152)|0;Ieb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=121852;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Ieb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+32|0;e=d;g=d+20|0;h=d+16|0;i=d+12|0;Jwa(a);f[a>>2]=121872;n[a+44>>2]=0.0;n[a+48>>2]=0.0;j=a+60|0;k=a+64|0;l=a+84|0;m=a+88|0;o=a+96|0;p=a+100|0;q=a+108|0;r=a+112|0;s=a+120|0;t=a+124|0;v=a+132|0;w=a+136|0;x=j;y=x+84|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=e+11|0;b[z>>0]=8;A=e;f[A>>2]=1601071469;f[A+4>>2]=1702521203;b[e+8>>0]=0;f[g>>2]=0;n[h>>2]=0.0;B=+Leb(a,c,e,g,0,h);A=a+36|0;n[A>>2]=B;if((b[z>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=e+11|0;b[z>>0]=4;f[e>>2]=1885957222;b[e+4>>0]=0;f[g>>2]=0;b[h>>0]=1;C=(Meb(a,c,e,g,0,h)|0)&1;b[a+144>>0]=C;if((b[z>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=e+11|0;b[z>>0]=4;f[e>>2]=1885957219;b[e+4>>0]=0;f[g>>2]=0;b[h>>0]=1;C=(Meb(a,c,e,g,0,h)|0)&1;b[a+145>>0]=C;if((b[z>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=L5b(16)|0;f[e>>2]=z;f[e+8>>2]=-2147483632;f[e+4>>2]=15;x=z;C=431744;y=x+15|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));b[z+15>>0]=0;f[g>>2]=0;b[h>>0]=1;z=(Meb(a,c,e,g,0,h)|0)&1;b[a+147>>0]=z;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);z=f[l>>2]|0;D=f[m>>2]|0;if((D|0)!=(z|0))f[m>>2]=D+(~((D+-4-z|0)>>>2)<<2);z=f[j>>2]|0;D=f[k>>2]|0;if((D|0)!=(z|0))f[k>>2]=D+(~((D+-4-z|0)>>>2)<<2);Neb(a,c);Oeb(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=e+11|0;b[z>>0]=6;b[e>>0]=b[425456]|0;b[e+1>>0]=b[425457]|0;b[e+2>>0]=b[425458]|0;b[e+3>>0]=b[425459]|0;b[e+4>>0]=b[425460]|0;b[e+5>>0]=b[425461]|0;b[e+6>>0]=0;Peb(e,c,l);if((b[z>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=e+11|0;b[z>>0]=5;b[e>>0]=b[434730]|0;b[e+1>>0]=b[434731]|0;b[e+2>>0]=b[434732]|0;b[e+3>>0]=b[434733]|0;b[e+4>>0]=b[434734]|0;b[e+5>>0]=0;Peb(e,c,o);if((b[z>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;z=e+11|0;b[z>>0]=6;b[e>>0]=b[434884]|0;b[e+1>>0]=b[434885]|0;b[e+2>>0]=b[434886]|0;b[e+3>>0]=b[434887]|0;b[e+4>>0]=b[434888]|0;b[e+5>>0]=b[434889]|0;b[e+6>>0]=0;Peb(e,c,q);if((b[z>>0]|0)<0)O5b(f[e>>2]|0);z=f[o>>2]|0;l=f[p>>2]|0;D=a+146|0;m=(z|0)!=(l|0)&1;b[D>>0]=m;if((l-z|0)==((f[r>>2]|0)-(f[q>>2]|0)|0))E=m;else{f[e>>2]=0;f[e+4>>2]=0;x=aD(e,33)|0;C=425463;y=x+33|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,198);bD(e);E=b[D>>0]|0}D=(f[j>>2]|0)==(f[k>>2]|0);if(!(E<<24>>24)){if(D){f[e>>2]=0;f[e+4>>2]=0;x=aD(e,22)|0;C=425668;y=x+22|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,207);bD(e)}if(!(+n[A>>2]>0.0)){f[e>>2]=0;f[e+4>>2]=0;x=aD(e,12)|0;C=425691;y=x+12|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,207);bD(e)}F=((f[k>>2]|0)-(f[j>>2]|0)>>2)+1|0}else{if(!D){f[e>>2]=0;f[e+4>>2]=0;x=aD(e,21)|0;C=425598;y=x+21|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,202);bD(e)}f[e>>2]=0;f[e+4>>2]=0;D=aD(e,8)|0;j=D;b[j>>0]=109;b[j+1>>0]=105;b[j+2>>0]=110;b[j+3>>0]=95;j=D+4|0;b[j>>0]=115;b[j+1>>0]=105;b[j+2>>0]=122;b[j+3>>0]=101;j=c+4|0;D=f[j>>2]|0;do if(!D)bD(e);else{k=f[e>>2]|0;E=(k|0)==0?1124530:k;m=D;while(1){q=f[m+16>>2]|0;if((k|0)==(q|0)){G=32;break}r=(q|0)==0?1124530:q;if((gTb(E,r)|0)<0)H=m;else{if((gTb(r,E)|0)>=0){G=33;break}H=m+4|0}m=f[H>>2]|0;if(!m){G=36;break}}if((G|0)==32)bD(e);else if((G|0)==33)bD(e);else if((G|0)==36){bD(e);break}f[e>>2]=0;f[e+4>>2]=0;x=aD(e,23)|0;C=425620;y=x+23|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,202);bD(e)}while(0);f[e>>2]=0;f[e+4>>2]=0;H=aD(e,8)|0;D=H;b[D>>0]=109;b[D+1>>0]=97;b[D+2>>0]=120;b[D+3>>0]=95;D=H+4|0;b[D>>0]=115;b[D+1>>0]=105;b[D+2>>0]=122;b[D+3>>0]=101;D=f[j>>2]|0;do if(!D)bD(e);else{j=f[e>>2]|0;H=(j|0)==0?1124530:j;m=D;while(1){E=f[m+16>>2]|0;if((j|0)==(E|0)){G=45;break}k=(E|0)==0?1124530:E;if((gTb(H,k)|0)<0)I=m;else{if((gTb(k,H)|0)>=0){G=46;break}I=m+4|0}m=f[I>>2]|0;if(!m){G=49;break}}if((G|0)==45)bD(e);else if((G|0)==46)bD(e);else if((G|0)==49){bD(e);break}f[e>>2]=0;f[e+4>>2]=0;x=aD(e,23)|0;C=425644;y=x+23|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,202);bD(e)}while(0);F=(f[p>>2]|0)-(f[o>>2]|0)>>2}o=a+148|0;f[o>>2]=F;F=a+40|0;n[F>>2]=-1.0;f[e>>2]=0;f[e+4>>2]=0;p=aD(e,8)|0;I=p;b[I>>0]=109;b[I+1>>0]=97;b[I+2>>0]=120;b[I+3>>0]=95;I=p+4|0;b[I>>0]=115;b[I+1>>0]=105;b[I+2>>0]=122;b[I+3>>0]=101;I=c+4|0;p=f[I>>2]|0;do if(!p)bD(e);else{D=f[e>>2]|0;m=(D|0)==0?1124530:D;H=p;while(1){j=f[H+16>>2]|0;if((D|0)==(j|0)){G=64;break}k=(j|0)==0?1124530:j;if((gTb(m,k)|0)<0)J=H;else{if((gTb(k,m)|0)>=0){G=65;break}J=H+4|0}H=f[J>>2]|0;if(!H){G=70;break}}if((G|0)==64)bD(e);else if((G|0)==65)bD(e);else if((G|0)==70){bD(e);break}f[e>>2]=0;f[e+4>>2]=0;H=aD(e,8)|0;m=H;b[m>>0]=109;b[m+1>>0]=97;b[m+2>>0]=120;b[m+3>>0]=95;m=H+4|0;b[m>>0]=115;b[m+1>>0]=105;b[m+2>>0]=122;b[m+3>>0]=101;B=+Hya(Eya(c,e)|0,0);n[F>>2]=B;bD(e);if(!(+n[F>>2]>+n[A>>2])){f[e>>2]=0;f[e+4>>2]=0;x=aD(e,19)|0;C=425704;y=x+19|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,215);bD(e)}f[o>>2]=(f[o>>2]|0)+1}while(0);f[e>>2]=0;f[e+4>>2]=0;A=aD(e,6)|0;b[A>>0]=b[425724]|0;b[A+1>>0]=b[425725]|0;b[A+2>>0]=b[425726]|0;b[A+3>>0]=b[425727]|0;b[A+4>>0]=b[425728]|0;b[A+5>>0]=b[425729]|0;A=f[I>>2]|0;a:do if(A){F=f[e>>2]|0;J=(F|0)==0?1124530:F;p=A;while(1){m=f[p+16>>2]|0;if((F|0)==(m|0)){G=88;break}H=(m|0)==0?1124530:m;if((gTb(J,H)|0)<0)K=p;else{if((gTb(H,J)|0)>=0){G=89;break}K=p+4|0}p=f[K>>2]|0;if(!p){G=79;break a}}if((G|0)==88){bD(e);G=91;break}else if((G|0)==89){bD(e);G=91;break}}else G=79;while(0);b:do if((G|0)==79){f[g>>2]=0;f[g+4>>2]=0;K=aD(g,6)|0;b[K>>0]=b[425731]|0;b[K+1>>0]=b[425732]|0;b[K+2>>0]=b[425733]|0;b[K+3>>0]=b[425734]|0;b[K+4>>0]=b[425735]|0;b[K+5>>0]=b[425736]|0;K=f[I>>2]|0;do if(K){A=f[g>>2]|0;p=(A|0)==0?1124530:A;J=K;while(1){F=f[J+16>>2]|0;if((A|0)==(F|0)){G=90;break}H=(F|0)==0?1124530:F;if((gTb(p,H)|0)<0)L=J;else{if((gTb(H,p)|0)>=0){G=87;break}L=J+4|0}J=f[L>>2]|0;if(!J){G=113;break}}if((G|0)==87){bD(g);bD(e);G=91;break b}else if((G|0)==90){bD(g);bD(e);G=91;break b}else if((G|0)==113){bD(g);bD(e);break}}else{bD(g);bD(e)}while(0);f[e>>2]=0;f[e+4>>2]=0;K=aD(e,4)|0;b[K>>0]=115;b[K+1>>0]=116;b[K+2>>0]=101;b[K+3>>0]=112;K=f[I>>2]|0;do if(!K)bD(e);else{J=f[e>>2]|0;p=(J|0)==0?1124530:J;A=K;while(1){H=f[A+16>>2]|0;if((J|0)==(H|0)){G=122;break}F=(H|0)==0?1124530:H;if((gTb(p,F)|0)<0)M=A;else{if((gTb(F,p)|0)>=0){G=123;break}M=A+4|0}A=f[M>>2]|0;if(!A){G=130;break}}if((G|0)==122)bD(e);else if((G|0)==123)bD(e);else if((G|0)==130){bD(e);break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;A=e+11|0;b[A>>0]=4;f[e>>2]=1885697139;b[e+4>>0]=0;f[g>>2]=0;n[h>>2]=0.0;B=+Leb(a,c,e,g,1,h);if((b[A>>0]|0)<0)O5b(f[e>>2]|0);if(!(B>0.0)){f[e>>2]=0;f[e+4>>2]=0;A=aD(e,8)|0;p=A;b[p>>0]=115;b[p+1>>0]=116;b[p+2>>0]=101;b[p+3>>0]=112;p=A+4|0;b[p>>0]=32;b[p+1>>0]=62;b[p+2>>0]=32;b[p+3>>0]=48;bO(-215,e,425497,425515,228);bD(e)}n[a+56>>2]=B;n[a+52>>2]=B;break b}while(0);n[a+56>>2]=0.0;n[a+52>>2]=0.0}while(0);if((G|0)==91){f[e>>2]=0;f[e+4>>2]=0;M=aD(e,4)|0;b[M>>0]=115;b[M+1>>0]=116;b[M+2>>0]=101;b[M+3>>0]=112;M=f[I>>2]|0;do if(!M)bD(e);else{L=f[e>>2]|0;K=(L|0)==0?1124530:L;p=M;while(1){A=f[p+16>>2]|0;if((L|0)==(A|0)){G=99;break}J=(A|0)==0?1124530:A;if((gTb(K,J)|0)<0)N=p;else{if((gTb(J,K)|0)>=0){G=100;break}N=p+4|0}p=f[N>>2]|0;if(!p){G=103;break}}if((G|0)==99)bD(e);else if((G|0)==100)bD(e);else if((G|0)==103){bD(e);break}f[e>>2]=0;f[e+4>>2]=0;x=aD(e,19)|0;C=425738;y=x+19|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,221);bD(e)}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;N=e+11|0;b[N>>0]=6;b[e>>0]=b[425724]|0;b[e+1>>0]=b[425725]|0;b[e+2>>0]=b[425726]|0;b[e+3>>0]=b[425727]|0;b[e+4>>0]=b[425728]|0;b[e+5>>0]=b[425729]|0;b[e+6>>0]=0;f[g>>2]=0;n[h>>2]=0.0;B=+Leb(a,c,e,g,1,h);M=a+56|0;n[M>>2]=B;if((b[N>>0]|0)<0){O5b(f[e>>2]|0);O=+n[M>>2]}else O=B;if(!(O>0.0)){f[e>>2]=0;f[e+4>>2]=0;x=aD(e,11)|0;C=425758;y=x+11|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,223);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;M=e+11|0;b[M>>0]=6;b[e>>0]=b[425731]|0;b[e+1>>0]=b[425732]|0;b[e+2>>0]=b[425733]|0;b[e+3>>0]=b[425734]|0;b[e+4>>0]=b[425735]|0;b[e+5>>0]=b[425736]|0;b[e+6>>0]=0;f[g>>2]=0;n[h>>2]=0.0;O=+Leb(a,c,e,g,1,h);N=a+52|0;n[N>>2]=O;if((b[M>>0]|0)<0){O5b(f[e>>2]|0);P=+n[N>>2]}else P=O;if(!(P>0.0)){f[e>>2]=0;f[e+4>>2]=0;x=aD(e,11)|0;C=425770;y=x+11|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,225);bD(e)}}f[e>>2]=0;f[e+4>>2]=0;N=aD(e,8)|0;M=N;b[M>>0]=111;b[M+1>>0]=102;b[M+2>>0]=102;b[M+3>>0]=115;M=N+4|0;b[M>>0]=101;b[M+1>>0]=116;b[M+2>>0]=95;b[M+3>>0]=104;M=f[I>>2]|0;c:do if(M){N=f[e>>2]|0;p=(N|0)==0?1124530:N;K=M;while(1){L=f[K+16>>2]|0;if((N|0)==(L|0)){G=149;break}J=(L|0)==0?1124530:L;if((gTb(p,J)|0)<0)Q=K;else{if((gTb(J,p)|0)>=0){G=150;break}Q=K+4|0}K=f[Q>>2]|0;if(!K){G=140;break c}}if((G|0)==149){bD(e);break}else if((G|0)==150){bD(e);break}}else G=140;while(0);d:do if((G|0)==140){f[g>>2]=0;f[g+4>>2]=0;Q=aD(g,8)|0;M=Q;b[M>>0]=111;b[M+1>>0]=102;b[M+2>>0]=102;b[M+3>>0]=115;M=Q+4|0;b[M>>0]=101;b[M+1>>0]=116;b[M+2>>0]=95;b[M+3>>0]=119;M=f[I>>2]|0;do if(M){Q=f[g>>2]|0;K=(Q|0)==0?1124530:Q;p=M;while(1){N=f[p+16>>2]|0;if((Q|0)==(N|0)){G=151;break}J=(N|0)==0?1124530:N;if((gTb(K,J)|0)<0)R=p;else{if((gTb(J,K)|0)>=0){G=148;break}R=p+4|0}p=f[R>>2]|0;if(!p){G=199;break}}if((G|0)==148){bD(g);bD(e);break d}else if((G|0)==151){bD(g);bD(e);break d}else if((G|0)==199){bD(g);bD(e);break}}else{bD(g);bD(e)}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;M=g+11|0;b[M>>0]=6;b[g>>0]=b[425782]|0;b[g+1>>0]=b[425783]|0;b[g+2>>0]=b[425784]|0;b[g+3>>0]=b[425785]|0;b[g+4>>0]=b[425786]|0;b[g+5>>0]=b[425787]|0;b[g+6>>0]=0;f[h>>2]=0;n[i>>2]=.5;P=+Leb(a,c,g,h,0,i);if((b[M>>0]|0)<0)O5b(f[g>>2]|0);n[e>>2]=P;Ubb(s,1,e);Ubb(v,1,e);u=d;return}while(0);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,6)|0;b[g>>0]=b[425782]|0;b[g+1>>0]=b[425783]|0;b[g+2>>0]=b[425784]|0;b[g+3>>0]=b[425785]|0;b[g+4>>0]=b[425786]|0;b[g+5>>0]=b[425787]|0;g=f[I>>2]|0;do if(!g)bD(e);else{i=f[e>>2]|0;h=(i|0)==0?1124530:i;a=g;while(1){R=f[a+16>>2]|0;if((i|0)==(R|0)){G=160;break}M=(R|0)==0?1124530:R;if((gTb(h,M)|0)<0)S=a;else{if((gTb(M,h)|0)>=0){G=161;break}S=a+4|0}a=f[S>>2]|0;if(!a){G=164;break}}if((G|0)==160)bD(e);else if((G|0)==161)bD(e);else if((G|0)==164){bD(e);break}f[e>>2]=0;f[e+4>>2]=0;x=aD(e,21)|0;C=425789;y=x+21|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,237);bD(e)}while(0);f[e>>2]=0;f[e+4>>2]=0;S=aD(e,8)|0;g=S;b[g>>0]=111;b[g+1>>0]=102;b[g+2>>0]=102;b[g+3>>0]=115;g=S+4|0;b[g>>0]=101;b[g+1>>0]=116;b[g+2>>0]=95;b[g+3>>0]=104;g=f[I>>2]|0;do if(g){S=f[e>>2]|0;a=(S|0)==0?1124530:S;h=g;while(1){i=f[h+16>>2]|0;if((S|0)==(i|0)){G=173;break}M=(i|0)==0?1124530:i;if((gTb(a,M)|0)<0)T=h;else{if((gTb(M,a)|0)>=0){G=177;break}T=h+4|0}h=f[T>>2]|0;if(!h){G=175;break}}if((G|0)==173){bD(e);break}else if((G|0)==175){bD(e);G=176;break}else if((G|0)==177){bD(e);break}}else{bD(e);G=176}while(0);if((G|0)==176){f[e>>2]=0;f[e+4>>2]=0;x=aD(e,22)|0;C=425811;y=x+22|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,237);bD(e)}f[e>>2]=0;f[e+4>>2]=0;T=aD(e,8)|0;g=T;b[g>>0]=111;b[g+1>>0]=102;b[g+2>>0]=102;b[g+3>>0]=115;g=T+4|0;b[g>>0]=101;b[g+1>>0]=116;b[g+2>>0]=95;b[g+3>>0]=119;g=f[I>>2]|0;do if(g){I=f[e>>2]|0;T=(I|0)==0?1124530:I;h=g;while(1){a=f[h+16>>2]|0;if((I|0)==(a|0)){G=186;break}S=(a|0)==0?1124530:a;if((gTb(T,S)|0)<0)U=h;else{if((gTb(S,T)|0)>=0){G=190;break}U=h+4|0}h=f[U>>2]|0;if(!h){G=188;break}}if((G|0)==186){bD(e);break}else if((G|0)==188){bD(e);G=189;break}else if((G|0)==190){bD(e);break}}else{bD(e);G=189}while(0);if((G|0)==189){f[e>>2]=0;f[e+4>>2]=0;x=aD(e,22)|0;C=425834;y=x+22|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,237);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G=e+11|0;b[G>>0]=8;U=e;f[U>>2]=1936090735;f[U+4>>2]=1751086181;b[e+8>>0]=0;Peb(e,c,v);if((b[G>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;G=e+11|0;b[G>>0]=8;U=e;f[U>>2]=1936090735;f[U+4>>2]=2002744421;b[e+8>>0]=0;Peb(e,c,s);if((b[G>>0]|0)<0)O5b(f[e>>2]|0);G=f[t>>2]|0;c=f[s>>2]|0;if((G-c|0)==((f[w>>2]|0)-(f[v>>2]|0)|0)){V=c;W=G}else{f[e>>2]=0;f[e+4>>2]=0;x=aD(e,36)|0;C=425857;y=x+36|0;do{b[x>>0]=b[C>>0]|0;x=x+1|0;C=C+1|0}while((x|0)<(y|0));bO(-215,e,425497,425515,240);bD(e);V=f[s>>2]|0;W=f[t>>2]|0}t=(W-V>>1)+-2|0;V=Y(t>>>0>1?t:1,f[o>>2]|0)|0;f[o>>2]=V;u=d;return}function Jeb(a){a=a|0;O5b(a);return}function Keb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Leb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0.0;a=u;u=u+32|0;i=a+24|0;j=a+8|0;k=a;f[i>>2]=0;l=L5b(16)|0;m=l+8|0;f[l>>2]=m;f[l+4>>2]=1;f[i+4>>2]=l;l=m;f[l>>2]=0;f[l+4>>2]=0;if(!(Qeb(c,d,i)|0)){if(!g){o=+n[h>>2];gua(i);u=a;return +o}X5b(j,497456);k6b(j,431949)|0;h=b[d+11>>0]|0;g=h<<24>>24<0;j6b(j,g?f[d>>2]|0:d,g?f[d+4>>2]|0:h&255)|0;k6b(j,431984)|0;f[k>>2]=0;f[k+4>>2]=0;h=j+11|0;d=b[h>>0]|0;g=d<<24>>24<0?f[j+4>>2]|0:d&255;if(g|0){d=aD(k,g)|0;Vac(d|0,((b[h>>0]|0)<0?f[j>>2]|0:j)|0,g|0)|0}bO(-5,k,431996,425515,88);bD(k);if((b[h>>0]|0)<0)O5b(f[j>>2]|0)}o=+Hya(i,f[e>>2]|0);gua(i);u=a;return +o}function Meb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+32|0;i=a+24|0;j=a+8|0;k=a;f[i>>2]=0;l=L5b(16)|0;m=l+8|0;f[l>>2]=m;f[l+4>>2]=1;f[i+4>>2]=l;l=m;f[l>>2]=0;f[l+4>>2]=0;if(!(Qeb(c,d,i)|0)){if(!g){n=(b[h>>0]|0)!=0;gua(i);u=a;return n|0}X5b(j,497456);k6b(j,431949)|0;h=b[d+11>>0]|0;g=h<<24>>24<0;j6b(j,g?f[d>>2]|0:d,g?f[d+4>>2]|0:h&255)|0;k6b(j,431984)|0;f[k>>2]=0;f[k+4>>2]=0;h=j+11|0;d=b[h>>0]|0;g=d<<24>>24<0?f[j+4>>2]|0:d&255;if(g|0){d=aD(k,g)|0;Vac(d|0,((b[h>>0]|0)<0?f[j>>2]|0:j)|0,g|0)|0}bO(-5,k,431996,425515,88);bD(k);if((b[h>>0]|0)<0)O5b(f[j>>2]|0)}j=Gwa(i,f[e>>2]|0)|0;n=(j|0)!=0|(J|0)!=0;gua(i);u=a;return n|0}function Neb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;f[g>>2]=0;i=g+4|0;j=L5b(16)|0;k=j+8|0;f[j>>2]=k;f[j+4>>2]=1;f[i>>2]=j;j=k;f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=L5b(16)|0;f[e>>2]=j;f[e+8>>2]=-2147483632;f[e+4>>2]=12;k=j;l=425964;m=k+12|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));b[j+12>>0]=0;j=Qeb(c,e,g)|0;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if(!j){gua(g);u=d;return}j=e+4|0;c=a+60|0;l=a+64|0;k=a+68|0;m=a+144|0;a=g+4|0;o=0;while(1){switch(f[g>>2]|0){case 0:{p=f[(f[i>>2]|0)+4>>2]|0;break}case 3:{p=f[(f[a>>2]|0)+4>>2]|0;break}case 2:{p=f[(f[a>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[j>>2]=0;bO(-3,e,429353,429358,272);bD(e);p=-1}}if((o|0)>=(p|0))break;q=+Hya(g,o);n[e>>2]=q;r=f[l>>2]|0;s=f[c>>2]|0;t=s;v=r;a:do if((r|0)==(s|0))w=15;else{x=r-s>>2;y=0;while(1){if(+L(+(q-+n[t+(y<<2)>>2]))<1.0e-06)break a;y=y+1|0;if(y>>>0>=x>>>0){w=15;break}}}while(0);if((w|0)==15){w=0;if((v|0)==(f[k>>2]|0))upa(c,e);else{n[r>>2]=q;f[l>>2]=v+4}if(b[m>>0]|0){z=1.0/+n[e>>2];n[h>>2]=z;t=f[l>>2]|0;if((t|0)==(f[k>>2]|0))upa(c,h);else{n[t>>2]=z;f[l>>2]=t+4}}}o=o+1|0}gua(g);u=d;return}function Oeb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0;d=u;u=u+32|0;e=d;g=d+24|0;h=d+16|0;f[g>>2]=0;i=g+4|0;j=L5b(16)|0;k=j+8|0;f[j>>2]=k;f[j+4>>2]=1;f[i>>2]=j;j=k;f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=8;k=e;f[k>>2]=1769103734;f[k+4>>2]=1701015137;b[e+8>>0]=0;k=Qeb(c,e,g)|0;if((b[j>>0]|0)<0)O5b(f[e>>2]|0);if(!k){f[e>>2]=0;f[e+4>>2]=0;l=aD(e,26)|0;m=425894;o=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));bO(-215,e,425921,425515,149);bD(e)}switch(f[g>>2]|0){case 0:{p=(f[i>>2]|0)+4|0;q=10;break}case 3:{p=(f[g+4>>2]|0)+4|0;q=10;break}case 2:{p=(f[g+4>>2]|0)+4|0;q=10;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e)}}do if((q|0)==10){i=f[p>>2]|0;if((i|0)<=1){if((i|0)!=1)break;r=+Hya(g,0);n[e>>2]=r;if(!(r>0.0)){f[h>>2]=0;f[h+4>>2]=0;l=aD(h,12)|0;m=425951;o=l+12|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));bO(-215,h,425921,425515,169);bD(h)}k=a+76|0;j=f[k>>2]|0;if((j|0)==(f[a+80>>2]|0))upa(a+72|0,e);else{f[j>>2]=f[e>>2];f[k>>2]=j+4}gua(g);u=d;return}if((i|0)!=4){f[e>>2]=0;f[e+4>>2]=0;l=aD(e,17)|0;m=425933;o=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));bO(-215,e,425921,425515,155);bD(e)}j=a+76|0;k=a+80|0;c=a+72|0;s=h+4|0;t=0;do{r=+Hya(g,t);n[e>>2]=r;if(!(r>0.0)){f[h>>2]=0;f[s>>2]=0;l=aD(h,12)|0;m=425951;o=l+12|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));bO(-215,h,425921,425515,160);bD(h)}v=f[j>>2]|0;if((v|0)==(f[k>>2]|0))upa(c,e);else{f[v>>2]=f[e>>2];f[j>>2]=v+4}t=t+1|0}while((t|0)<(i|0));gua(g);u=d;return}while(0);n[e>>2]=.10000000149011612;h=a+76|0;m=f[h>>2]|0;if((m|0)==(f[a+80>>2]|0))upa(a+72|0,e);else{f[m>>2]=1036831949;f[h>>2]=m+4}gua(g);u=d;return}function Peb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0.0;d=u;u=u+16|0;e=d+8|0;g=d;f[g>>2]=0;h=g+4|0;i=L5b(16)|0;j=i+8|0;f[i>>2]=j;f[i+4>>2]=1;f[h>>2]=i;i=j;f[i>>2]=0;f[i+4>>2]=0;if(!(Qeb(b,a,g)|0)){a=f[c>>2]|0;b=c+4|0;i=f[b>>2]|0;if((i|0)==(a|0)){gua(g);u=d;return}f[b>>2]=i+(~((i+-4-a|0)>>>2)<<2);gua(g);u=d;return}switch(f[g>>2]|0){case 0:{k=f[(f[h>>2]|0)+4>>2]|0;break}case 3:{k=f[(f[g+4>>2]|0)+4>>2]|0;break}case 2:{k=f[(f[g+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);k=-1}}a=c+4|0;i=f[a>>2]|0;b=f[c>>2]|0;j=i-b>>2;l=b;b=i;if(k>>>0<=j>>>0){if(k>>>0<j>>>0?(i=l+(k<<2)|0,(b|0)!=(i|0)):0)f[a>>2]=b+(~((b+-4-i|0)>>>2)<<2)}else ipa(c,k-j|0);j=e+4|0;k=g+4|0;i=0;while(1){switch(f[g>>2]|0){case 0:{m=f[(f[h>>2]|0)+4>>2]|0;break}case 3:{m=f[(f[k>>2]|0)+4>>2]|0;break}case 2:{m=f[(f[k>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[j>>2]=0;bO(-3,e,429353,429358,272);bD(e);m=-1}}if((i|0)>=(m|0))break;o=+Hya(g,i);n[(f[c>>2]|0)+(i<<2)>>2]=o;i=i+1|0}gua(g);u=d;return}function Qeb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;f[g>>2]=0;f[g+4>>2]=0;h=c+11|0;i=b[h>>0]|0;j=c+4|0;k=i<<24>>24<0?f[j>>2]|0:i&255;if(k|0){i=aD(g,k)|0;Vac(i|0,((b[h>>0]|0)<0?f[c>>2]|0:c)|0,k|0)|0}k=f[a+4>>2]|0;a:do if(k|0){i=f[g>>2]|0;l=(i|0)==0?1124530:i;m=k;while(1){n=f[m+16>>2]|0;if((i|0)==(n|0))break;o=(n|0)==0?1124530:n;if((gTb(l,o)|0)<0)p=m;else{if((gTb(o,l)|0)>=0)break;p=m+4|0}m=f[p>>2]|0;if(!m)break a}bD(g);f[g>>2]=0;f[g+4>>2]=0;m=b[h>>0]|0;l=m<<24>>24<0?f[j>>2]|0:m&255;if(l|0){m=aD(g,l)|0;Vac(m|0,((b[h>>0]|0)<0?f[c>>2]|0:c)|0,l|0)|0}$xa(d,Eya(a,g)|0)|0;bD(g);q=1;u=e;return q|0}while(0);bD(g);q=0;u=e;return q|0}function Reb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=121872;b=f[a+132>>2]|0;if(b|0){c=a+136|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+120>>2]|0;if(b|0){d=a+124|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+108>>2]|0;if(b|0){c=a+112|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+96>>2]|0;if(b|0){d=a+100|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+84>>2]|0;if(b|0){c=a+88|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+72>>2]|0;if(b|0){d=a+76|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+60>>2]|0;if(!b){lua(a);return}c=a+64|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);lua(a);return}function Seb(a){a=a|0;Reb(a);O5b(a);return}function Teb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0;e=u;u=u+112|0;g=e+96|0;h=e+88|0;i=e+32|0;j=e;dQ(h,121996);if(((f[c+4>>2]|0)-(f[c>>2]|0)|0)!=8){f[g>>2]=0;f[g+4>>2]=0;k=aD(g,18)|0;l=442898;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,443123,425515,384);bD(g)}o=a+148|0;q=+((f[o>>2]|0)>>>0);r=a+120|0;s=a+124|0;t=~~(q/+jd(+(+((((f[s>>2]|0)-(f[r>>2]|0)>>2)+-1|0)>>>0))))>>>0;v=a+84|0;w=f[v>>2]|0;x=a+88|0;y=f[x>>2]|0;z=y;A=w;if((w|0)==(y|0)){n[g>>2]=1.0;y=z-A>>2;if(t>>>0<=y>>>0){if(!(t>>>0>=y>>>0|(t|0)==0))f[x>>2]=w+(~((-4-(t<<2)|0)>>>2)<<2)}else fs(v,t-y|0,g)}else if((z-A>>2|0)!=(t|0)){f[g>>2]=0;f[g+4>>2]=0;k=aD(g,32)|0;l=426088;m=k+32|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,443123,425515,390);bD(g)}t=f[c>>2]|0;c=f[(f[t>>2]|0)+40>>2]|0;A=f[c+12>>2]|0;z=f[c+8>>2]|0;c=f[(f[t+4>>2]|0)+40>>2]|0;t=f[c+12>>2]|0;y=f[c+8>>2]|0;q=+n[a+52>>2];if(!(q==0.0)?(B=+n[a+56>>2],!(B==0.0)):0){C=q;D=B}else{C=+(t|0)/+(A|0);D=+(y|0)/+(z|0)}c=Y(Y(A<<2,z)|0,f[o>>2]|0)|0;w=f[(f[d>>2]|0)+16>>2]|0;E=(z|0)==0;if(E)F=w;else{G=(A|0)==0;H=a+146|0;I=a+36|0;J=a+48|0;K=a+44|0;L=a+40|0;N=a+132|0;B=+(t|0);q=+(y|0);y=a+147|0;t=a+60|0;O=a+64|0;P=a+96|0;Q=a+100|0;R=a+108|0;S=g+4|0;T=g+4|0;U=a+96|0;V=w;w=0;while(1){if(G)W=V;else{X=+(w>>>0);Z=0;_=V;while(1){if(!(b[H>>0]|0)){$=+n[I>>2]*+n[f[v>>2]>>2];n[J>>2]=$;n[K>>2]=$;aa=$;ba=$}else{ca=f[v>>2]|0;$=+n[f[U>>2]>>2]*+n[ca>>2];n[K>>2]=$;da=+n[f[R>>2]>>2]*+n[ca>>2];n[J>>2]=da;aa=da;ba=$}ca=f[s>>2]|0;ea=f[r>>2]|0;fa=ea;a:do if((ca|0)==(ea|0)){ga=_;ha=ca;ia=ca;ja=fa}else{$=+(Z>>>0);ka=0;la=_;ma=fa;da=ba;na=aa;while(1){oa=C*($+ +n[ma+(ka<<2)>>2]);pa=D*(X+ +n[(f[N>>2]|0)+(ka<<2)>>2]);qa=da*.5;ra=oa-qa;sa=oa+qa;qa=na*.5;oa=pa+qa;ta=pa-qa;if(!(b[y>>0]|0)){n[la>>2]=ra;ua=oa+-1.0;va=sa+-1.0;wa=ta}else{n[la>>2]=ra/B;ua=oa/q;va=sa/B;wa=ta/q}n[la+4>>2]=wa;n[la+8>>2]=va;n[la+12>>2]=ua;xa=la+16|0;ya=ka+1|0;za=f[s>>2]|0;Aa=f[r>>2]|0;Ba=Aa;if(ya>>>0>=za-Aa>>2>>>0){ga=xa;ha=za;ia=Aa;ja=Ba;break a}ka=ya;la=xa;ma=Ba;da=+n[K>>2];na=+n[J>>2]}}while(0);na=+n[L>>2];b:do if(na>0.0?(da=+M(+(na*+n[I>>2])),$=da*+n[(f[v>>2]|0)+4>>2],n[J>>2]=$,n[K>>2]=$,(ha|0)!=(ia|0)):0){da=+(Z>>>0);fa=0;ca=ga;ea=ja;ta=$;sa=$;while(1){$=C*(da+ +n[ea+(fa<<2)>>2]);oa=D*(X+ +n[(f[N>>2]|0)+(fa<<2)>>2]);ra=ta*.5;qa=$-ra;pa=$+ra;ra=sa*.5;$=oa+ra;Ca=oa-ra;if(!(b[y>>0]|0)){n[ca>>2]=qa;Da=$+-1.0;Ea=pa+-1.0;Fa=Ca}else{n[ca>>2]=qa/B;Da=$/q;Ea=pa/B;Fa=Ca/q}n[ca+4>>2]=Fa;n[ca+8>>2]=Ea;n[ca+12>>2]=Da;ma=ca+16|0;la=fa+1|0;ka=f[r>>2]|0;if(la>>>0>=(f[s>>2]|0)-ka>>2>>>0){Ga=ma;break b}fa=la;ca=ma;ea=ka;ta=+n[K>>2];sa=+n[J>>2]}}else Ga=ga;while(0);ea=f[t>>2]|0;ca=f[O>>2]|0;fa=ca;ka=ea;if((ea|0)!=(ca|0)?((fa-ka>>2)+(+n[L>>2]>0.0?2:1)|0)!=((f[x>>2]|0)-(f[v>>2]|0)>>2|0):0){f[g>>2]=0;f[T>>2]=0;k=aD(g,88)|0;l=426121;m=k+88|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,443123,425515,444);bD(g);ca=f[t>>2]|0;Ha=f[O>>2]|0;Ia=ca;Ja=ca}else{Ha=fa;Ia=ka;Ja=ea}if((Ha|0)==(Ia|0))Ka=Ga;else{na=+(Z>>>0);ca=f[r>>2]|0;ma=0;la=Ga;Ba=Ja;xa=f[s>>2]|0;ya=ca;Aa=Ia;za=Ha;La=ca;while(1){sa=+n[(f[v>>2]|0)+((+n[L>>2]>0.0?2:1)+ma<<2)>>2];ta=+n[I>>2];da=+M(+(+n[Ba+(ma<<2)>>2]));Ca=sa*(ta*da);n[K>>2]=Ca;pa=sa*(ta/da);n[J>>2]=pa;if((xa|0)==(ya|0)){Ma=la;Na=Aa;Oa=za;Pa=La;Qa=ya;Ra=ya}else{ca=0;Sa=la;Ta=La;da=Ca;Ca=pa;while(1){pa=C*(na+ +n[Ta+(ca<<2)>>2]);ta=D*(X+ +n[(f[N>>2]|0)+(ca<<2)>>2]);sa=da*.5;$=pa-sa;qa=pa+sa;sa=Ca*.5;pa=ta+sa;ra=ta-sa;if(!(b[y>>0]|0)){n[Sa>>2]=$;Ua=pa+-1.0;Va=qa+-1.0;Wa=ra}else{n[Sa>>2]=$/B;Ua=pa/q;Va=qa/B;Wa=ra/q}n[Sa+4>>2]=Wa;n[Sa+8>>2]=Va;n[Sa+12>>2]=Ua;Xa=Sa+16|0;Ya=ca+1|0;Za=f[s>>2]|0;_a=f[r>>2]|0;$a=_a;if(Ya>>>0>=Za-_a>>2>>>0)break;ca=Ya;Sa=Xa;Ta=$a;da=+n[K>>2];Ca=+n[J>>2]}Ma=Xa;Na=f[t>>2]|0;Oa=f[O>>2]|0;Pa=$a;Qa=_a;Ra=Za}ma=ma+1|0;if(ma>>>0>=Oa-Na>>2>>>0){Ka=Ma;break}else{la=Ma;Ba=Na;xa=Ra;ya=Qa;Aa=Na;za=Oa;La=Pa}}}La=f[P>>2]|0;za=f[Q>>2]|0;Aa=za;ya=La;if((La|0)!=(za|0)?(Aa-ya|0)!=((f[x>>2]|0)-(f[v>>2]|0)|0):0){f[g>>2]=0;f[S>>2]=0;k=aD(g,51)|0;l=426210;m=k+51|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,443123,425515,461);bD(g);za=f[P>>2]|0;ab=za;bb=f[Q>>2]|0;cb=za}else{ab=ya;bb=Aa;cb=La}if(bb-ab>>2>>>0>1){na=+(Z>>>0);za=f[r>>2]|0;xa=1;Ba=Ka;la=cb;ma=f[s>>2]|0;ea=za;ka=ab;fa=bb;Ta=za;while(1){za=(f[v>>2]|0)+(xa<<2)|0;Ca=+n[la+(xa<<2)>>2]*+n[za>>2];n[K>>2]=Ca;da=+n[(f[R>>2]|0)+(xa<<2)>>2]*+n[za>>2];n[J>>2]=da;if((ma|0)==(ea|0)){db=Ba;eb=ka;fb=fa;gb=Ta;hb=ea;ib=ea}else{za=0;Sa=Ba;ca=Ta;ra=Ca;Ca=da;while(1){da=C*(na+ +n[ca+(za<<2)>>2]);qa=D*(X+ +n[(f[N>>2]|0)+(za<<2)>>2]);pa=ra*.5;$=da-pa;sa=da+pa;pa=Ca*.5;da=qa+pa;ta=qa-pa;if(!(b[y>>0]|0)){n[Sa>>2]=$;jb=da+-1.0;kb=sa+-1.0;lb=ta}else{n[Sa>>2]=$/B;jb=da/q;kb=sa/B;lb=ta/q}n[Sa+4>>2]=lb;n[Sa+8>>2]=kb;n[Sa+12>>2]=jb;mb=Sa+16|0;Ya=za+1|0;nb=f[s>>2]|0;ob=f[r>>2]|0;pb=ob;if(Ya>>>0>=nb-ob>>2>>>0)break;za=Ya;Sa=mb;ca=pb;ra=+n[K>>2];Ca=+n[J>>2]}db=mb;eb=f[P>>2]|0;fb=f[Q>>2]|0;gb=pb;hb=ob;ib=nb}xa=xa+1|0;if(xa>>>0>=fb-eb>>2>>>0){qb=db;break}else{Ba=db;la=eb;ma=ib;ea=hb;ka=eb;fa=fb;Ta=gb}}}else qb=Ka;Z=Z+1|0;if(Z>>>0>=A>>>0){W=qb;break}else _=qb}}w=w+1|0;if(w>>>0>=z>>>0){F=W;break}else V=W}}if((b[a+145>>0]|0)!=0&(c|0)!=0){W=0;do{V=F+(W<<2)|0;n[g>>2]=0.0;w=+n[V>>2]<0.0?g:V;n[i>>2]=1.0;f[V>>2]=f[(+n[w>>2]>1.0?i:w)>>2];W=W+1|0}while((W|0)!=(c|0))}c=f[d>>2]|0;d=(f[c+16>>2]|0)+(f[(f[c+44>>2]|0)+4>>2]|0)|0;W=a+72|0;F=f[W>>2]|0;w=F;if(((f[a+76>>2]|0)-F|0)==4){a=f[c+40>>2]|0;c=f[a+8>>2]|0;V=f[a+12>>2]|0;f[i>>2]=1124007941;a=i+4|0;f[a>>2]=2;qb=i+8|0;f[qb>>2]=c;Ka=i+12|0;f[Ka>>2]=V;gb=i+16|0;f[gb>>2]=d;fb=i+20|0;f[fb>>2]=d;eb=i+24|0;hb=i+28|0;ib=i+40|0;f[eb>>2]=0;f[eb+4>>2]=0;f[eb+8>>2]=0;f[eb+12>>2]=0;f[ib>>2]=qb;db=i+48|0;nb=i+44|0;f[nb>>2]=db;f[i+52>>2]=0;f[db>>2]=0;if((d|0)==0&(Y(V,c)|0)!=0){f[g>>2]=0;f[g+4>>2]=0;k=aD(g,26)|0;l=426262;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,426289,431198,500);bD(g);rb=f[Ka>>2]|0;sb=f[i>>2]|16384;tb=f[nb>>2]|0;ub=f[fb>>2]|0;vb=f[W>>2]|0}else{rb=V;sb=1124024325;tb=db;ub=d;vb=w}V=rb<<2;f[i>>2]=sb;f[tb>>2]=V;f[tb+4>>2]=4;tb=ub+(Y(f[qb>>2]|0,V)|0)|0;f[hb>>2]=tb;f[eb>>2]=tb+(0-V)+V;p[j>>3]=+n[vb>>2];vb=j+8|0;f[vb>>2]=0;f[vb+4>>2]=0;f[vb+8>>2]=0;f[vb+12>>2]=0;f[vb+16>>2]=0;f[vb+20>>2]=0;f[g>>2]=-1056833530;f[g+4>>2]=j;f[g+8>>2]=1;f[g+12>>2]=4;VP(i,g,UM()|0)|0;g=i+36|0;j=f[g>>2]|0;if(j|0?(vb=j+12|0,j=f[vb>>2]|0,f[vb>>2]=j+-1,(j|0)==1):0)kL(i);f[g>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[a>>2]|0)>0){gb=f[ib>>2]|0;ib=0;do{f[gb+(ib<<2)>>2]=0;ib=ib+1|0}while((ib|0)<(f[a>>2]|0))}a=f[nb>>2]|0;if((a|0)!=(db|0))UC(a)}else if(!(E|(A|0)==0)){E=f[o>>2]|0;o=F;F=w+4|0;a=w+8|0;db=w+12|0;w=0;nb=0;ib=E;while(1){if(!ib){wb=0;xb=nb}else{gb=0;g=nb;while(1){i=0;j=g;do{f[d+(j<<2)>>2]=f[o>>2];f[d+(j+1<<2)>>2]=f[F>>2];f[d+(j+2<<2)>>2]=f[a>>2];f[d+(j+3<<2)>>2]=f[db>>2];j=j+4|0;i=i+1|0}while(i>>>0<E>>>0);gb=gb+1|0;if((gb|0)==(A|0)){wb=E;xb=j;break}else g=j}}w=w+1|0;if((w|0)==(z|0))break;else{nb=xb;ib=wb}}}if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function Ueb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,121964);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Veb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+32|0;d=g+16|0;h=g;i=f[c>>2]|0;if((i|0)==(f[c+4>>2]|0)){f[d>>2]=0;f[d+4>>2]=0;j=aD(d,15)|0;k=443708;l=j+15|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,d,442770,425515,256);bD(d);m=f[c>>2]|0}else m=i;i=f[m>>2]|0;m=Y(Y(f[i+8>>2]<<2,f[i+12>>2]|0)|0,f[a+148>>2]|0)|0;f[d>>2]=1;f[d+4>>2]=2;f[d+8>>2]=m;f[d+12>>2]=-1;f[h>>2]=0;m=h+4|0;f[m>>2]=0;f[h+8>>2]=0;Rva(h,d,d+16|0);d=f[h>>2]|0;a=f[m>>2]|0;a:do if((d|0)==(a|0)){n=d;o=6}else{i=d;do{if((f[i>>2]|0)<0){n=i;o=6;break a}i=i+4|0}while((i|0)!=(a|0))}while(0);if((o|0)==6?(n|0)!=(a|0):0){o=n+4|0;if((o|0)==(a|0)){p=a;q=n}else{d=o;o=n;while(1){n=f[d>>2]|0;if((n|0)<0)r=o;else{f[o>>2]=n;r=o+4|0}d=d+4|0;if((d|0)==(a|0))break;else o=r}p=f[m>>2]|0;q=r}if((q|0)!=(p|0))f[m>>2]=p+(~((p+-4-q|0)>>>2)<<2)}q=e+4|0;p=f[q>>2]|0;r=f[e>>2]|0;o=p-r|0;a=(o|0)/12|0;d=r;r=p;if(o){if(a>>>0>1?(o=d+12|0,(r|0)!=(o|0)):0){d=r;while(1){r=d+-12|0;f[q>>2]=r;p=f[r>>2]|0;if(!p)s=r;else{r=d+-8|0;n=f[r>>2]|0;if((n|0)!=(p|0))f[r>>2]=n+(~((n+-4-p|0)>>>2)<<2);O5b(p);s=f[q>>2]|0}if((s|0)==(o|0))break;else d=s}}}else sbb(e,1-a|0,h);a=f[h>>2]|0;if(!a){u=g;return 0}h=f[m>>2]|0;if((h|0)!=(a|0))f[m>>2]=h+(~((h+-4-a|0)>>>2)<<2);O5b(a);u=g;return 0}function Web(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=f[g>>2]|0;i=f[c>>2]|0;if((h|0)==(i|0)){j=0;k=0;J=j;u=d;return k|0}l=a+148|0;a=e+4|0;m=0;n=0;o=i;i=h;while(1){h=o;p=f[h+(n*12|0)+4>>2]|0;q=f[h+(n*12|0)>>2]|0;h=p-q|0;r=h>>2;s=q;do if((s|0)!=(p|0)){if((h|0)<=4){f[e>>2]=0;f[a>>2]=0;q=aD(e,70)|0;t=442586;v=q+70|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,e,442657,442663,160);bD(e);w=1;x=f[c>>2]|0;y=f[g>>2]|0;break}if((h|0)>8){t=2;q=1;while(1){v=Y(f[s+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)>=(r|0)){w=v;x=o;y=i;break}else q=v}}else{w=1;x=o;y=i}}else{w=0;x=o;y=i}while(0);m=(Y(w<<2,f[l>>2]|0)|0)+m|0;n=n+1|0;if(n>>>0>=((y-x|0)/12|0)>>>0)break;else{o=x;i=y}}j=((m|0)<0)<<31>>31;k=m;J=j;u=d;return k|0}function Xeb(a,b){a=a|0;b=b|0;var c=0;c=L5b(52)|0;Yeb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=122036;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Yeb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;Jwa(a);f[a+36>>2]=0;i=a+40|0;f[i>>2]=0;f[a+44>>2]=0;f[a>>2]=122056;Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;j=aD(e,4)|0;b[j>>0]=97;b[j+1>>0]=120;b[j+2>>0]=105;b[j+3>>0]=115;j=c+4|0;k=f[j>>2]|0;do if(k){l=f[e>>2]|0;m=(l|0)==0?1124530:l;n=j;o=k;a:while(1){p=o;while(1){q=f[p+16>>2]|0;if((q|0)==(l|0))break;if((gTb((q|0)==0?1124530:q,m)|0)>=0)break;q=f[p+4>>2]|0;if(!q){r=n;break a}else p=q}o=f[p>>2]|0;if(!o){r=p;break}else n=p}if((r|0)!=(j|0)){n=f[r+16>>2]|0;if((l|0)!=(n|0)?(gTb(m,(n|0)==0?1124530:n)|0)<=-1:0){s=1;break}n=Gwa(r+24|0,-1)|0;s=n}else s=1}else s=1;while(0);r=a+48|0;f[r>>2]=s;bD(e);f[e>>2]=0;f[e+4>>2]=0;s=aD(e,11)|0;k=426557;n=s+11|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));o=f[j>>2]|0;do if(!o)bD(e);else{q=f[e>>2]|0;t=(q|0)==0?1124530:q;v=o;while(1){w=f[v+16>>2]|0;if((q|0)==(w|0)){x=20;break}y=(w|0)==0?1124530:w;if((gTb(t,y)|0)<0)z=v;else{if((gTb(y,t)|0)>=0){x=21;break}z=v+4|0}v=f[z>>2]|0;if(!v){x=89;break}}if((x|0)==20)bD(e);else if((x|0)==21)bD(e);else if((x|0)==89){bD(e);break}f[e>>2]=0;f[e+4>>2]=0;v=aD(e,5)|0;b[v>>0]=b[426569]|0;b[v+1>>0]=b[426570]|0;b[v+2>>0]=b[426571]|0;b[v+3>>0]=b[426572]|0;b[v+4>>0]=b[426573]|0;v=f[j>>2]|0;b:do if(v){t=f[e>>2]|0;q=(t|0)==0?1124530:t;m=v;while(1){l=f[m+16>>2]|0;if((t|0)==(l|0)){x=47;break}y=(l|0)==0?1124530:l;if((gTb(q,y)|0)<0)A=m;else{if((gTb(y,q)|0)>=0){x=48;break}A=m+4|0}m=f[A>>2]|0;if(!m){x=30;break b}}if((x|0)==47){bD(e);x=52;break}else if((x|0)==48){bD(e);x=52;break}}else x=30;while(0);c:do if((x|0)==30){f[g>>2]=0;f[g+4>>2]=0;v=aD(g,4)|0;b[v>>0]=115;b[v+1>>0]=105;b[v+2>>0]=122;b[v+3>>0]=101;v=f[j>>2]|0;d:do if(v|0){m=f[g>>2]|0;q=(m|0)==0?1124530:m;t=v;while(1){p=f[t+16>>2]|0;if((m|0)==(p|0)){x=50;break}y=(p|0)==0?1124530:p;if((gTb(q,y)|0)<0)B=t;else{if((gTb(y,q)|0)>=0){x=49;break}B=t+4|0}t=f[B>>2]|0;if(!t)break d}if((x|0)==49){bD(g);bD(e);x=52;break c}else if((x|0)==50){bD(g);bD(e);x=52;break c}}while(0);f[h>>2]=0;f[h+4>>2]=0;v=aD(h,3)|0;b[v>>0]=b[426575]|0;b[v+1>>0]=b[426576]|0;b[v+2>>0]=b[426577]|0;v=f[j>>2]|0;if(!v){bD(h);bD(g);bD(e);break}t=f[h>>2]|0;q=(t|0)==0?1124530:t;m=v;while(1){v=f[m+16>>2]|0;if((t|0)==(v|0)){x=46;break}y=(v|0)==0?1124530:v;if((gTb(q,y)|0)<0)C=m;else{if((gTb(y,q)|0)>=0){x=51;break}C=m+4|0}m=f[C>>2]|0;if(!m){x=54;break}}if((x|0)==46){bD(h);bD(g);bD(e);x=52;break}else if((x|0)==51){bD(h);bD(g);bD(e);x=52;break}else if((x|0)==54){bD(h);bD(g);bD(e);break}}while(0);if((x|0)==52){f[e>>2]=0;f[e+4>>2]=0;s=aD(e,65)|0;k=426579;n=s+65|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));bO(-215,e,426645,426660,61);bD(e)}f[e>>2]=0;f[e+4>>2]=0;s=aD(e,11)|0;k=426557;n=s+11|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));m=Eya(c,e)|0;bD(e);q=a+36|0;switch(f[m>>2]|0){case 0:{D=f[(f[m+4>>2]|0)+4>>2]|0;break}case 3:{D=f[(f[m+4>>2]|0)+4>>2]|0;break}case 2:{D=f[(f[m+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);D=-1}}t=D+1|0;y=(f[r>>2]|0)+1|0;f[e>>2]=0;v=e+4|0;f[v>>2]=0;f[e+8>>2]=0;if(y|0){if(y>>>0>536870911)c4b(e);p=L5b(y<<3)|0;f[v>>2]=p;f[e>>2]=p;f[e+8>>2]=p+(y<<3);l=y;w=p;E=p;while(1){F=w;f[F>>2]=-2147483648;f[F+4>>2]=2147483647;F=E+8|0;G=l+-1|0;if(!G)break;else{l=G;w=F;E=F}}f[v>>2]=p+(y<<3)}E=f[i>>2]|0;w=f[q>>2]|0;l=(E-w|0)/12|0;F=w;w=E;if(t>>>0<=l>>>0){if(t>>>0<l>>>0?(E=F+(t*12|0)|0,(w|0)!=(E|0)):0){F=w;while(1){w=F+-12|0;f[i>>2]=w;G=f[w>>2]|0;if(!G)H=w;else{w=F+-8|0;I=f[w>>2]|0;if((I|0)!=(G|0))f[w>>2]=I+(~((I+-8-G|0)>>>3)<<3);O5b(G);H=f[i>>2]|0}if((H|0)==(E|0))break;else F=H}}}else $eb(q,t-l|0,e);F=f[e>>2]|0;if(F|0){E=f[v>>2]|0;if((E|0)!=(F|0))f[v>>2]=E+(~((E+-8-F|0)>>>3)<<3);O5b(F)}F=e+4|0;E=m+4|0;y=m+4|0;p=0;G=0;while(1){switch(f[m>>2]|0){case 0:{J=f[(f[E>>2]|0)+4>>2]|0;break}case 3:{J=f[(f[y>>2]|0)+4>>2]|0;break}case 2:{J=f[(f[y>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[F>>2]=0;bO(-3,e,429353,429358,272);bD(e);J=-1}}if((p|0)>=(J|0))break;f[(f[(f[q>>2]|0)+(p*12|0)>>2]|0)+(f[r>>2]<<3)>>2]=G;I=Gwa(m,p)|0;f[(f[(f[q>>2]|0)+(p*12|0)>>2]|0)+(f[r>>2]<<3)+4>>2]=I;p=p+1|0;G=I}f[(f[(f[i>>2]|0)+-12>>2]|0)+(f[r>>2]<<3)>>2]=G;u=d;return}while(0);f[e>>2]=0;f[e+4>>2]=0;r=aD(e,5)|0;b[r>>0]=b[426569]|0;b[r+1>>0]=b[426570]|0;b[r+2>>0]=b[426571]|0;b[r+3>>0]=b[426572]|0;b[r+4>>0]=b[426573]|0;r=f[j>>2]|0;if(!r){bD(e);u=d;return}J=f[e>>2]|0;H=(J|0)==0?1124530:J;D=r;while(1){r=f[D+16>>2]|0;if((J|0)==(r|0)){x=98;break}h=(r|0)==0?1124530:r;if((gTb(H,h)|0)<0)K=D;else{if((gTb(h,H)|0)>=0){x=99;break}K=D+4|0}D=f[K>>2]|0;if(!D){x=187;break}}if((x|0)==98)bD(e);else if((x|0)==99)bD(e);else if((x|0)==187){bD(e);u=d;return}f[e>>2]=0;f[e+4>>2]=0;D=aD(e,4)|0;b[D>>0]=115;b[D+1>>0]=105;b[D+2>>0]=122;b[D+3>>0]=101;D=f[j>>2]|0;e:do if(!D)L=0;else{K=f[e>>2]|0;H=(K|0)==0?1124530:K;J=D;while(1){h=f[J+16>>2]|0;if((K|0)==(h|0)){L=1;break e}r=(h|0)==0?1124530:h;if((gTb(H,r)|0)<0)M=J;else{if((gTb(r,H)|0)>=0){L=1;break e}M=J+4|0}J=f[M>>2]|0;if(!J){L=0;break}}}while(0);f[g>>2]=0;f[g+4>>2]=0;M=aD(g,3)|0;b[M>>0]=b[426575]|0;b[M+1>>0]=b[426576]|0;b[M+2>>0]=b[426577]|0;M=f[j>>2]|0;f:do if(!M)N=0;else{D=f[g>>2]|0;J=(D|0)==0?1124530:D;H=M;while(1){K=f[H+16>>2]|0;if((D|0)==(K|0)){N=1;break f}G=(K|0)==0?1124530:K;if((gTb(J,G)|0)<0)O=H;else{if((gTb(G,J)|0)>=0){N=1;break f}O=H+4|0}H=f[O>>2]|0;if(!H){N=0;break}}}while(0);bD(g);bD(e);if(!(L^N)){f[e>>2]=0;f[e+4>>2]=0;s=aD(e,38)|0;k=426739;n=s+38|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));bO(-215,e,426645,426660,76);bD(e)}f[e>>2]=0;f[e+4>>2]=0;N=aD(e,5)|0;b[N>>0]=b[426569]|0;b[N+1>>0]=b[426570]|0;b[N+2>>0]=b[426571]|0;b[N+3>>0]=b[426572]|0;b[N+4>>0]=b[426573]|0;N=Eya(c,e)|0;bD(e);f[e>>2]=0;f[e+4>>2]=0;L=aD(e,4)|0;b[L>>0]=115;b[L+1>>0]=105;b[L+2>>0]=122;b[L+3>>0]=101;L=f[j>>2]|0;g:do if(!L)x=127;else{O=f[e>>2]|0;M=(O|0)==0?1124530:O;H=L;while(1){J=f[H+16>>2]|0;if((O|0)==(J|0))break;D=(J|0)==0?1124530:J;if((gTb(M,D)|0)<0)P=H;else{if((gTb(D,M)|0)>=0)break;P=H+4|0}H=f[P>>2]|0;if(!H){x=127;break g}}f[g>>2]=0;f[g+4>>2]=0;H=aD(g,4)|0;b[H>>0]=115;b[H+1>>0]=105;b[H+2>>0]=122;b[H+3>>0]=101;H=Eya(c,g)|0;bD(g);Q=H}while(0);if((x|0)==127){f[g>>2]=0;f[g+4>>2]=0;P=aD(g,3)|0;b[P>>0]=b[426575]|0;b[P+1>>0]=b[426576]|0;b[P+2>>0]=b[426577]|0;P=Eya(c,g)|0;bD(g);Q=P}bD(e);switch(f[N>>2]|0){case 0:{R=f[(f[N+4>>2]|0)+4>>2]|0;break}case 3:{R=f[(f[N+4>>2]|0)+4>>2]|0;break}case 2:{R=f[(f[N+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);R=-1}}switch(f[Q>>2]|0){case 0:{S=f[(f[Q+4>>2]|0)+4>>2]|0;break}case 3:{S=f[(f[Q+4>>2]|0)+4>>2]|0;break}case 2:{S=f[(f[Q+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);S=-1}}if((R|0)!=(S|0)){f[e>>2]=0;f[e+4>>2]=0;s=aD(e,35)|0;k=426778;n=s+35|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));bO(-215,e,426645,426660,79);bD(e)}S=a+36|0;a=f[i>>2]|0;R=f[S>>2]|0;P=a-R|0;g=(P|0)/12|0;c=R;R=a;if(P){if(g>>>0>1?(P=c+12|0,(R|0)!=(P|0)):0){c=R;while(1){R=c+-12|0;f[i>>2]=R;a=f[R>>2]|0;if(!a)T=R;else{R=c+-8|0;L=f[R>>2]|0;if((L|0)!=(a|0))f[R>>2]=L+(~((L+-8-a|0)>>>3)<<3);O5b(a);T=f[i>>2]|0}if((T|0)==(P|0))break;else c=T}}}else afb(S,1-g|0);g=f[S>>2]|0;switch(f[N>>2]|0){case 0:{U=f[(f[N+4>>2]|0)+4>>2]|0;break}case 3:{U=f[(f[N+4>>2]|0)+4>>2]|0;break}case 2:{U=f[(f[N+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);U=-1}}f[e>>2]=-2147483648;f[e+4>>2]=2147483647;T=g+4|0;c=f[T>>2]|0;P=f[g>>2]|0;i=c-P>>3;a=P;P=c;if(U>>>0<=i>>>0){if(U>>>0<i>>>0?(c=a+(U<<3)|0,(P|0)!=(c|0)):0)f[T>>2]=P+(~((P+-8-c|0)>>>3)<<3)}else Bcb(g,U-i|0,e);i=e+4|0;U=e+4|0;g=e+4|0;c=e+4|0;P=e+4|0;T=N+4|0;a=N+4|0;L=0;while(1){switch(f[N>>2]|0){case 0:{V=f[(f[T>>2]|0)+4>>2]|0;break}case 3:{V=f[(f[a>>2]|0)+4>>2]|0;break}case 2:{V=f[(f[a>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[i>>2]=0;bO(-3,e,429353,429358,272);bD(e);V=-1}}if((L|0)>=(V|0))break;R=Gwa(N,L)|0;H=Gwa(Q,L)|0;if((R|0)<=-1){f[e>>2]=0;f[P>>2]=0;s=aD(e,10)|0;k=426814;n=s+10|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));bO(-215,e,426645,426660,87);bD(e)}f[(f[f[S>>2]>>2]|0)+(L<<3)>>2]=R;f[e>>2]=0;f[U>>2]=0;M=aD(e,4)|0;b[M>>0]=115;b[M+1>>0]=105;b[M+2>>0]=122;b[M+3>>0]=101;M=f[j>>2]|0;do if(!M){bD(e);x=183}else{O=f[e>>2]|0;D=(O|0)==0?1124530:O;J=M;while(1){G=f[J+16>>2]|0;if((O|0)==(G|0)){x=176;break}K=(G|0)==0?1124530:G;if((gTb(D,K)|0)<0)W=J;else{if((gTb(K,D)|0)>=0){x=177;break}W=J+4|0}J=f[W>>2]|0;if(!J){x=182;break}}if((x|0)==176){x=0;bD(e)}else if((x|0)==177){x=0;bD(e)}else if((x|0)==182){x=0;bD(e);x=183;break}if(!((H|0)==-1|(H|0)>0)){f[e>>2]=0;f[g>>2]=0;s=aD(e,22)|0;k=426825;n=s+22|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));bO(-215,e,426645,426660,93);bD(e)}X=(R|0)>0?H+R|0:-1}while(0);if((x|0)==183){x=0;if((H|0)<0|(H|0)>(R|0))X=H;else{f[e>>2]=0;f[c>>2]=0;s=aD(e,22)|0;k=426848;n=s+22|0;do{b[s>>0]=b[k>>0]|0;s=s+1|0;k=k+1|0}while((s|0)<(n|0));bO(-215,e,426645,426660,99);bD(e);X=H}}f[(f[f[S>>2]>>2]|0)+(L<<3)+4>>2]=X;L=L+1|0}u=d;return}function Zeb(a){a=a|0;O5b(a);return}function _eb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function $eb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/12|0)>>>0>=b>>>0){i=b;j=h;do{dfb(j,c);j=(f[g>>2]|0)+12|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/12|0;h=j+b|0;if(h>>>0>357913941)c4b(a);k=(e-i|0)/12|0;i=k<<1;e=k>>>0<178956970?(i>>>0<h>>>0?h:i):357913941;do if(e)if(e>>>0>357913941){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{l=L5b(e*12|0)|0;break}else l=0;while(0);i=l+(j*12|0)|0;j=i;h=l+(e*12|0)|0;e=b;b=j;l=i;do{dfb(l,c);l=b+12|0;b=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=f[g>>2]|0;if((l|0)==(e|0)){m=j;n=e;o=e}else{c=l;l=j;j=i;do{c=c+-12|0;dfb(j+-12|0,c);j=l+-12|0;l=j}while((c|0)!=(e|0));m=l;n=f[a>>2]|0;o=f[g>>2]|0}f[a>>2]=m;f[g>>2]=b;f[d>>2]=h;h=n;if((o|0)!=(h|0)){d=o;do{o=d;d=d+-12|0;b=f[d>>2]|0;if(b|0){g=o+-8|0;o=f[g>>2]|0;if((o|0)!=(b|0))f[g>>2]=o+(~((o+-8-b|0)>>>3)<<3);O5b(b)}}while((d|0)!=(h|0))}if(!n)return;O5b(n);return}function afb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){Nac(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;k=j+b|0;l=i;if(k>>>0>357913941)c4b(a);m=(d-i|0)/12|0;i=m<<1;d=m>>>0<178956970?(i>>>0<k>>>0?k:i):357913941;do if(d)if(d>>>0>357913941){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{n=L5b(d*12|0)|0;break}else n=0;while(0);i=n+(j*12|0)|0;j=i;k=n+(d*12|0)|0;Nac(i|0,0,b*12|0)|0;d=i+(b*12|0)|0;if((h|0)==(l|0)){o=j;p=g;q=h}else{g=h;h=j;j=i;do{g=g+-12|0;dfb(j+-12|0,g);j=h+-12|0;h=j}while((g|0)!=(l|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=d;f[c>>2]=k;k=p;if((q|0)!=(k|0)){c=q;do{q=c;c=c+-12|0;d=f[c>>2]|0;if(d|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(d|0))f[e>>2]=q+(~((q+-8-d|0)>>>3)<<3);O5b(d)}}while((c|0)!=(k|0))}if(!p)return;O5b(p);return}function bfb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=122156;b=a+36|0;c=f[b>>2]|0;if(!c){lua(a);return}d=a+40|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-8-i|0)>>>3)<<3);O5b(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[b>>2]|0}O5b(g);lua(a);return}function cfb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=122156;b=a+36|0;c=f[b>>2]|0;if(!c){lua(a);O5b(a);return}d=a+40|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-8-i|0)>>>3)<<3);O5b(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[b>>2]|0}O5b(g);lua(a);O5b(a);return}function dfb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>3;if(!g)return;if(g>>>0>536870911)c4b(a);h=L5b(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<3);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;Vac(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>3<<3);return}function efb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=122156;b=a+36|0;c=f[b>>2]|0;if(!c){lua(a);O5b(a);return}d=a+40|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-8-i|0)>>>3)<<3);O5b(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[b>>2]|0}O5b(g);lua(a);O5b(a);return}function ffb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;if(((f[c+4>>2]|0)-h|0)==4)i=h;else{f[g>>2]=0;f[g+4>>2]=0;j=aD(g,18)|0;k=443104;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,443724,426660,138);bD(g);i=f[c>>2]|0}c=(f[i>>2]|0)+40|0;i=a+36|0;h=f[i>>2]|0;m=a+40|0;n=f[m>>2]|0;o=n;p=h;if((h|0)!=(n|0)){n=d+4|0;h=f[n>>2]|0;q=f[d>>2]|0;if(((h-q|0)/56|0|0)==((o-p|0)/12|0|0)){r=n;s=d;t=h;v=q}else{f[g>>2]=0;f[g+4>>2]=0;j=aD(g,36)|0;k=427218;l=j+36|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,443724,426660,156);bD(g);r=n;s=d;t=f[n>>2]|0;v=f[d>>2]|0}}else{n=a+48|0;a=f[n>>2]|0;q=d+4|0;h=((f[q>>2]|0)-(f[d>>2]|0)|0)/56|0;w=((f[(f[c>>2]|0)+(a<<2)>>2]|0)>>>0)/(h>>>0)|0;x=a+1|0;f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;if(!x){y=p;z=o}else{if(x>>>0>536870911)c4b(g);o=L5b(x<<3)|0;f[a>>2]=o;f[g>>2]=o;f[g+8>>2]=o+(x<<3);p=x;A=o;B=o;while(1){C=A;f[C>>2]=-2147483648;f[C+4>>2]=2147483647;C=B+8|0;D=p+-1|0;if(!D)break;else{p=D;A=C;B=C}}f[a>>2]=o+(x<<3);y=f[i>>2]|0;z=f[m>>2]|0}x=(z-y|0)/12|0;o=y;y=z;if(h>>>0<=x>>>0){if(h>>>0<x>>>0?(z=o+(h*12|0)|0,(y|0)!=(z|0)):0){o=y;while(1){y=o+-12|0;f[m>>2]=y;B=f[y>>2]|0;if(!B)E=y;else{y=o+-8|0;A=f[y>>2]|0;if((A|0)!=(B|0))f[y>>2]=A+(~((A+-8-B|0)>>>3)<<3);O5b(B);E=f[m>>2]|0}if((E|0)==(z|0))break;else o=E}}}else $eb(i,h-x|0,g);x=f[g>>2]|0;if(x|0){h=f[a>>2]|0;if((h|0)!=(x|0))f[a>>2]=h+(~((h+-8-x|0)>>>3)<<3);O5b(x)}x=f[q>>2]|0;h=f[d>>2]|0;if((x|0)==(h|0)){u=e;return}a=f[i>>2]|0;E=f[n>>2]|0;n=(x-h|0)/56|0;o=0;z=0;do{m=f[a+(o*12|0)>>2]|0;f[m+(E<<3)>>2]=z;z=z+w|0;f[m+(E<<3)+4>>2]=z;o=o+1|0}while(o>>>0<n>>>0);r=q;s=d;t=x;v=h}if((t|0)==(v|0)){u=e;return}v=g+4|0;t=g+4|0;h=0;x=f[c>>2]|0;while(1){d=f[i>>2]|0;q=f[d+(h*12|0)+4>>2]|0;n=f[d+(h*12|0)>>2]|0;if(q-n>>3>>>0>(f[x+-4>>2]|0)>>>0){f[g>>2]=0;f[v>>2]=0;j=aD(g,37)|0;k=427363;l=j+37|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,443724,426660,160);bD(g);o=f[i>>2]|0;F=f[o+(h*12|0)+4>>2]|0;G=f[o+(h*12|0)>>2]|0;H=o}else{F=q;G=n;H=d}if((F|0)==(G|0)){I=0;J=H}else{o=0;z=H;while(1){jfb(g,(f[z+(h*12|0)>>2]|0)+(o<<3)|0,f[(f[c>>2]|0)+(o<<2)>>2]|0);E=g;w=f[E+4>>2]|0;a=(f[(f[i>>2]|0)+(h*12|0)>>2]|0)+(o<<3)|0;f[a>>2]=f[E>>2];f[a+4>>2]=w;o=o+1|0;w=f[i>>2]|0;a=(f[w+(h*12|0)+4>>2]|0)-(f[w+(h*12|0)>>2]|0)>>3;if(o>>>0>=a>>>0){I=a;J=w;break}else z=w}}z=f[c>>2]|0;a:do if((I|0)<(f[z+-4>>2]|0)){o=I;d=J;while(1){f[g>>2]=-2147483648;f[t>>2]=2147483647;n=d+(h*12|0)+4|0;q=f[n>>2]|0;if((q|0)==(f[d+(h*12|0)+8>>2]|0))_cb(d+(h*12|0)|0,g);else{w=g;a=f[w+4>>2]|0;E=q;f[E>>2]=f[w>>2];f[E+4>>2]=a;f[n>>2]=(f[n>>2]|0)+8}n=o+1|0;a=f[c>>2]|0;if((n|0)>=(f[a+-4>>2]|0)){K=a;break a}o=n;d=f[i>>2]|0}}else K=z;while(0);h=h+1|0;if(h>>>0>=(((f[r>>2]|0)-(f[s>>2]|0)|0)/56|0)>>>0)break;else x=K}u=e;return}function gfb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+80|0;g=e+72|0;h=e+56|0;i=e;dQ(g,122280);j=f[f[c>>2]>>2]|0;c=d+4|0;k=f[c>>2]|0;l=f[d>>2]|0;m=a+36|0;if(((k-l|0)/56|0|0)==(((f[a+40>>2]|0)-(f[m>>2]|0)|0)/12|0|0)){n=k;o=l}else{f[h>>2]=0;f[h+4>>2]=0;l=aD(h,36)|0;k=427218;a=l+36|0;do{b[l>>0]=b[k>>0]|0;l=l+1|0;k=k+1|0}while((l|0)<(a|0));bO(-215,h,443123,426660,188);bD(h);n=f[c>>2]|0;o=f[d>>2]|0}if((n|0)!=(o|0)){o=h+8|0;n=h+4|0;k=i+36|0;l=i+16|0;a=i+4|0;p=i+40|0;q=i+44|0;r=i+48|0;s=0;do{qL(i,j,(f[m>>2]|0)+(s*12|0)|0);t=(f[d>>2]|0)+(s*56|0)|0;v=o;f[v>>2]=0;f[v+4>>2]=0;f[h>>2]=33619968;f[n>>2]=t;SP(i,h);t=f[k>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)kL(i);f[k>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[a>>2]|0)>0){t=f[p>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[a>>2]|0))}v=f[q>>2]|0;if((v|0)!=(r|0))UC(v);s=s+1|0}while(s>>>0<(((f[c>>2]|0)-(f[d>>2]|0)|0)/56|0)>>>0)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function hfb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,122248);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function ifb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;g=u;u=u+32|0;h=g+16|0;i=g;j=g+8|0;k=f[c>>2]|0;if(((f[c+4>>2]|0)-k|0)==12)l=k;else{f[h>>2]=0;f[h+4>>2]=0;m=aD(h,18)|0;n=443104;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,442770,426660,111);bD(h);l=f[c>>2]|0}Bua(h,l);l=a+36|0;c=f[l>>2]|0;k=f[a+40>>2]|0;do if((c|0)==(k|0)){p=a+48|0;q=f[p>>2]|0;if(!((q|0)>-1?q>>>0<(f[h+4>>2]|0)-(f[h>>2]|0)>>2>>>0:0)){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,35)|0;n=426955;o=m+35|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,442770,426660,128);bD(i)}if((d|0)>0?(q=f[p>>2]|0,r=f[h>>2]|0,s=f[r+(q<<2)>>2]|0,((s|0)%(d|0)|0|0)==0):0){t=h;v=r;w=q;x=s}else{f[i>>2]=0;f[i+4>>2]=0;m=aD(i,60)|0;n=426991;o=m+60|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,442770,426660,129);bD(i);s=f[p>>2]|0;q=f[h>>2]|0;t=h;v=q;w=s;x=f[q+(s<<2)>>2]|0}f[v+(w<<2)>>2]=(x|0)/(d|0)|0;s=e+4|0;q=f[s>>2]|0;r=f[e>>2]|0;y=(q-r|0)/12|0;z=q;if(y>>>0<d>>>0){sbb(e,d-y|0,h);A=t;break}if(y>>>0>d>>>0?(y=r+(d*12|0)|0,(z|0)!=(y|0)):0){r=z;while(1){z=r+-12|0;f[s>>2]=z;q=f[z>>2]|0;if(!q)B=z;else{z=r+-8|0;C=f[z>>2]|0;if((C|0)!=(q|0))f[z>>2]=C+(~((C+-4-q|0)>>>2)<<2);O5b(q);B=f[s>>2]|0}if((B|0)==(y|0)){A=t;break}else r=B}}else A=t}else{r=(k-c|0)/12|0;y=e+4|0;s=f[y>>2]|0;p=f[e>>2]|0;q=(s-p|0)/12|0;C=p;p=s;if(r>>>0<=q>>>0)if(r>>>0<q>>>0?(z=C+(r*12|0)|0,(p|0)!=(z|0)):0){C=p;while(1){p=C+-12|0;f[y>>2]=p;D=f[p>>2]|0;if(!D)E=p;else{p=C+-8|0;F=f[p>>2]|0;if((F|0)!=(D|0))f[p>>2]=F+(~((F+-4-D|0)>>>2)<<2);O5b(D);E=f[y>>2]|0}if((E|0)==(z|0))break;else C=E}G=E}else G=s;else{sbb(e,r-q|0,h);G=f[y>>2]|0}if((G|0)==(f[e>>2]|0)){A=h;break}C=h+4|0;z=i+4|0;D=j+4|0;F=0;p=f[l>>2]|0;while(1){H=f[p+(F*12|0)+4>>2]|0;I=f[p+(F*12|0)>>2]|0;if(H-I>>3>>>0>(f[C>>2]|0)-(f[h>>2]|0)>>2>>>0){f[i>>2]=0;f[z>>2]=0;m=aD(i,40)|0;n=426914;o=m+40|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,442770,426660,119);bD(i);J=f[l>>2]|0;K=J;L=f[J+(F*12|0)+4>>2]|0;M=f[J+(F*12|0)>>2]|0}else{K=p;L=H;M=I}if((L|0)==(M|0)){N=K;O=f[e>>2]|0}else{J=0;P=K;do{jfb(j,(f[P+(F*12|0)>>2]|0)+(J<<3)|0,f[(f[h>>2]|0)+(J<<2)>>2]|0);Q=f[e>>2]|0;f[(f[Q+(F*12|0)>>2]|0)+(J<<2)>>2]=(f[D>>2]|0)-(f[j>>2]|0);J=J+1|0;P=f[l>>2]|0}while(J>>>0<(f[P+(F*12|0)+4>>2]|0)-(f[P+(F*12|0)>>2]|0)>>3>>>0);N=P;O=Q}F=F+1|0;if(F>>>0>=(((f[y>>2]|0)-O|0)/12|0)>>>0){A=h;break}else p=N}}while(0);N=f[A>>2]|0;if(!N){u=g;return 0}A=h+4|0;h=f[A>>2]|0;if((h|0)!=(N|0))f[A>>2]=h+(~((h+-4-N|0)>>>2)<<2);O5b(N);u=g;return 0}function jfb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;i=(h|0)>0?h:0;h=f[c+4>>2]|0;c=(h|0)>0?((h|0)>(d|0)?d:h):d+1+h|0;f[a>>2]=i;f[a+4>>2]=c;if((i|0)>=(c|0)){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,27)|0;k=427052;l=j+27|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,427080,442663,199);bD(g)}if((c|0)<=(d|0)){u=e;return}f[g>>2]=0;f[g+4>>2]=0;j=aD(g,23)|0;k=427086;l=j+23|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,427080,442663,199);bD(g);u=e;return}function kfb(a,b){a=a|0;b=b|0;var c=0;c=L5b(60)|0;lfb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=122320;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function lfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0;d=u;u=u+32|0;e=d+24|0;g=d+8|0;h=d+16|0;i=d;Jwa(a);f[a>>2]=122340;j=a+40|0;k=a+44|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;Kwa(a,c);l=a+36|0;f[l>>2]=1;f[e>>2]=0;f[e+4>>2]=0;a=aD(e,9)|0;m=427507;o=a+9|0;do{b[a>>0]=b[m>>0]|0;a=a+1|0;m=m+1|0}while((a|0)<(o|0));p=c+4|0;q=f[p>>2]|0;do if(!q)bD(e);else{r=f[e>>2]|0;s=(r|0)==0?1124530:r;t=q;while(1){v=f[t+16>>2]|0;if((r|0)==(v|0)){w=9;break}x=(v|0)==0?1124530:v;if((gTb(s,x)|0)<0)y=t;else{if((gTb(x,s)|0)>=0){w=10;break}y=t+4|0}t=f[y>>2]|0;if(!t){w=35;break}}if((w|0)==9)bD(e);else if((w|0)==10)bD(e);else if((w|0)==35){bD(e);break}f[i>>2]=0;f[i+4>>2]=0;a=aD(i,9)|0;m=427507;o=a+9|0;do{b[a>>0]=b[m>>0]|0;a=a+1|0;m=m+1|0}while((a|0)<(o|0));Hwa(h,Eya(c,i)|0,-1);t=f[h>>2]|0;if(!t){f[g>>2]=0;f[g+4>>2]=0}else{s=h+4|0;r=f[s>>2]|0;f[e>>2]=0;x=e+4|0;f[x>>2]=0;if(r|0?(Vac(aD(e,r)|0,t|0,r|0)|0,f[s>>2]|0):0){r=0;do{t=(gVb(b[(f[h>>2]|0)+r>>0]|0)|0)&255;b[(f[e>>2]|0)+r>>0]=t;r=r+1|0}while(r>>>0<(f[s>>2]|0)>>>0)}s=f[e>>2]|0;f[g>>2]=s;f[g+4>>2]=f[x>>2];if(s|0){r=s+-4|0;f[r>>2]=(f[r>>2]|0)+1}bD(e)}bD(h);bD(i);r=f[g>>2]|0;do if((r|0)!=427517?(s=(r|0)==0?1124530:r,(gTb(s,427517)|0)!=0):0){if((r|0)!=427522?gTb(s,427522)|0:0){if((r|0)!=442370?gTb(s,442370)|0:0){f[i>>2]=0;s=i+4|0;f[s>>2]=0;t=g+4|0;aD(i,(f[t>>2]|0)+25|0)|0;v=f[i>>2]|0;a=v;m=427526;o=a+25|0;do{b[a>>0]=b[m>>0]|0;a=a+1|0;m=m+1|0}while((a|0)<(o|0));z=f[t>>2]|0;if(z|0)Vac(v+25|0,f[g>>2]|0,z|0)|0;f[e>>2]=0;f[e+4>>2]=0;aD(e,(f[s>>2]|0)+1|0)|0;z=f[s>>2]|0;if(!z)A=0;else{Vac(f[e>>2]|0,f[i>>2]|0,z|0)|0;A=f[s>>2]|0}b[(f[e>>2]|0)+A>>0]=34;bO(-5,e,427552,427569,77);bD(e);bD(i);break}f[l>>2]=2;break}f[l>>2]=1}else w=21;while(0);if((w|0)==21)f[l>>2]=0;bD(g)}while(0);f[e>>2]=0;f[e+4>>2]=0;l=aD(e,5)|0;b[l>>0]=b[427650]|0;b[l+1>>0]=b[427651]|0;b[l+2>>0]=b[427652]|0;b[l+3>>0]=b[427653]|0;b[l+4>>0]=b[427654]|0;l=f[p>>2]|0;if(!l){bD(e);u=d;return}p=f[e>>2]|0;i=(p|0)==0?1124530:p;A=l;while(1){l=f[A+16>>2]|0;if((p|0)==(l|0)){w=44;break}m=(l|0)==0?1124530:l;if((gTb(i,m)|0)<0)B=A;else{if((gTb(m,i)|0)>=0){w=45;break}B=A+4|0}A=f[B>>2]|0;if(!A){w=60;break}}if((w|0)==44)bD(e);else if((w|0)==45)bD(e);else if((w|0)==60){bD(e);u=d;return}f[e>>2]=0;f[e+4>>2]=0;w=aD(e,5)|0;b[w>>0]=b[427650]|0;b[w+1>>0]=b[427651]|0;b[w+2>>0]=b[427652]|0;b[w+3>>0]=b[427653]|0;b[w+4>>0]=b[427654]|0;iua(g,Eya(c,e)|0);bD(e);switch(f[g>>2]|0){case 0:{C=f[(f[g+4>>2]|0)+4>>2]|0;break}case 3:{C=f[(f[g+4>>2]|0)+4>>2]|0;break}case 2:{C=f[(f[g+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);C=-1}}e=f[k>>2]|0;c=f[j>>2]|0;w=e-c>>2;A=c;c=e;if(C>>>0<=w>>>0){if(C>>>0<w>>>0?(e=A+(C<<2)|0,(c|0)!=(e|0)):0)f[k>>2]=c+(~((c+-4-e|0)>>>2)<<2)}else ipa(j,C-w|0);if((C|0)>0){w=0;do{D=+Hya(g,w);n[(f[j>>2]|0)+(w<<2)>>2]=D;w=w+1|0}while((w|0)<(C|0))}gua(g);u=d;return}function mfb(a){a=a|0;O5b(a);return}function nfb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ofb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=122340;b=a+52|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+56>>2]=0;b=f[a+40>>2]|0;if(!b){lua(a);return}c=a+44|0;e=f[c>>2]|0;if((e|0)!=(b|0))f[c>>2]=e+(~((e+-4-b|0)>>>2)<<2);O5b(b);lua(a);return}function pfb(a){a=a|0;ofb(a);O5b(a);return}function qfb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(g,122464);if(((f[d+4>>2]|0)-(f[d>>2]|0)|0)!=56){f[h>>2]=0;f[h+4>>2]=0;i=aD(h,19)|0;j=443151;k=i+19|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,h,443123,427569,275);bD(h)}h=SQ()|0;j=f[c>>2]|0;xfb(j,(f[c+4>>2]|0)-j>>2,f[d>>2]|0,a+40|0,f[a+36>>2]|0,f[a+56>>2]|0,h);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function rfb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,122432);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function sfb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function tfb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ufb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+52|0;d=f[b>>2]|0;e=f[b+4>>2]|0;if(d|0){b=d+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[c>>2]=d;d=a+56|0;f[d>>2]=e;if(b|0?(e=b+4|0,a=f[e>>2]|0,f[e>>2]=a+-1,(a|0)==1):0)bi[f[(f[b>>2]|0)+8>>2]&2047](b);return (f[d>>2]|0)!=0|0}function vfb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+16|0;d=g;h=c+4|0;if((((f[h>>2]|0)-(f[c>>2]|0)|0)/12|0)>>>0<=1){f[d>>2]=0;f[d+4>>2]=0;i=aD(d,18)|0;j=427679;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,d,442770,427569,103);bD(d)}l=a+40|0;m=a+44|0;n=(f[m>>2]|0)-(f[l>>2]|0)>>2;if(n|0?(n|0)!=(((f[h>>2]|0)-(f[c>>2]|0)|0)/12|0|0):0){f[d>>2]=0;f[d+4>>2]=0;i=aD(d,52)|0;j=427698;k=i+52|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,d,442770,427569,104);bD(d)}if((f[a+36>>2]|0)!=1?(f[m>>2]|0)!=(f[l>>2]|0):0){f[d>>2]=0;f[d+4>>2]=0;i=aD(d,31)|0;j=427751;k=i+31|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,d,442770,427569,105);bD(d)}l=f[h>>2]|0;m=f[c>>2]|0;a=m;if(((l-m|0)/12|0)>>>0<=1){o=a;Aua(e,1,o);u=g;return 0}n=d+4|0;p=1;q=a;a=m;m=l;while(1){l=f[q+4>>2]|0;r=f[a>>2]|0;s=f[q+(p*12|0)>>2]|0;t=r;v=l;a:do if((l-r|0)==((f[q+(p*12|0)+4>>2]|0)-s|0))if((t|0)==(v|0)){w=a;x=m}else{y=t;z=s;while(1){if((f[y>>2]|0)!=(f[z>>2]|0)){A=17;break a}y=y+4|0;if((y|0)==(v|0)){w=a;x=m;break}else z=z+4|0}}else A=17;while(0);if((A|0)==17){A=0;f[d>>2]=0;f[n>>2]=0;i=aD(d,22)|0;j=427783;k=i+22|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,d,442770,427569,109);bD(d);w=f[c>>2]|0;x=f[h>>2]|0}p=p+1|0;v=w;if(p>>>0>=((x-w|0)/12|0)>>>0){o=v;break}else{q=v;a=w;m=x}}Aua(e,1,o);u=g;return 0}function wfb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;a=d;e=c+4|0;g=f[e>>2]|0;h=f[c>>2]|0;if((g|0)==(h|0)){f[a>>2]=0;f[a+4>>2]=0;i=aD(a,13)|0;j=427656;k=i+13|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,a,427670,427569,331);bD(a);l=f[c>>2]|0;m=f[e>>2]|0}else{l=h;m=g}g=(m-l|0)/12|0;m=l;h=f[m+4>>2]|0;e=f[l>>2]|0;l=h-e|0;c=l>>2;do if((e|0)!=(h|0)){if((l|0)<=-4){f[a>>2]=0;f[a+4>>2]=0;i=aD(a,70)|0;j=442586;k=i+70|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,a,442657,442663,160);bD(a);n=1;break}if((l|0)>0){o=f[m>>2]|0;p=0;q=1;while(1){r=Y(f[o+(p<<2)>>2]|0,q)|0;p=p+1|0;if((p|0)>=(c|0)){n=r;break}else q=r}}else n=1}else n=0;while(0);c=Y(n,g)|0;J=((c|0)<0)<<31>>31;u=d;return c|0}function xfb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0;j=u;u=u+48|0;k=j+8|0;l=j;m=d+4|0;if(((f[m>>2]|0)+-2|0)>>>0>=3){f[k>>2]=0;f[k+4>>2]=0;o=aD(k,29)|0;p=427916;q=o+29|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,k,443206,427569,136);bD(k)}r=f[d>>2]|0;if((r&4095|0)==5)s=r;else{f[k>>2]=0;f[k+4>>2]=0;o=aD(k,15)|0;p=427946;q=o+15|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,k,443206,427569,136);bD(k);s=f[d>>2]|0}if(!(s&16384)){f[k>>2]=0;f[k+4>>2]=0;o=aD(k,18)|0;p=443210;q=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,k,443206,427569,136);bD(k)}s=f[e>>2]|0;r=e+4|0;t=f[r>>2]|0;if((s|0)!=(t|0)?(t-s>>2|0)!=(c|0):0){f[k>>2]=0;f[k+4>>2]=0;o=aD(k,48)|0;p=427962;q=o+48|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,k,443206,427569,137);bD(k)}if((c|0)<0){s=d+40|0;t=k+4|0;v=0;while(1){w=f[a+(v<<2)>>2]|0;x=f[w+40>>2]|0;y=f[x+-4>>2]|0;z=f[s>>2]|0;a:do if((y|0)==(f[z+-4>>2]|0)){if((y|0)==2){if((f[x>>2]|0)!=(f[z>>2]|0)){A=21;break}if((f[x+4>>2]|0)!=(f[z+4>>2]|0)){A=21;break}}else if((y|0)>0){B=0;do{if((f[x+(B<<2)>>2]|0)!=(f[z+(B<<2)>>2]|0)){A=21;break a}B=B+1|0}while((B|0)<(y|0))}B=f[w>>2]|0;if(!(B&16384|0?((f[d>>2]^B)&4095|0)==0:0))A=21}else A=21;while(0);if((A|0)==21){A=0;f[k>>2]=0;f[t>>2]=0;o=aD(k,85)|0;p=428011;q=o+85|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,k,443206,427569,143);bD(k)}v=v+1|0}}f[k>>2]=122504;v=k+4|0;t=v+12|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[v>>2]=a;f[k+8>>2]=c;f[k+12>>2]=d;f[k+20>>2]=g;f[k+24>>2]=i;a=f[m>>2]|0;m=f[d+40>>2]|0;if((a|0)!=4){f[k+32>>2]=1;v=f[m+(a+-1<<2)>>2]|0;if((a|0)>2){C=1;D=v;A=25}else{f[k+36>>2]=v;E=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;F=1;G=v}}else{v=f[m+4>>2]|0;f[k+32>>2]=v;C=v;D=f[m+(a+-1<<2)>>2]|0;A=25}if((A|0)==25){v=Y(f[m+(a+-2<<2)>>2]|0,D)|0;f[k+36>>2]=v;D=0;d=1;while(1){t=Y(f[m+(D<<2)>>2]|0,d)|0;D=D+1|0;if((D|0)==(a|0)){E=t;F=C;G=v;break}else d=t}}if((E|0)!=(Y(Y(F,f[m>>2]|0)|0,G)|0)){f[l>>2]=0;f[l+4>>2]=0;o=aD(l,53)|0;p=428097;q=o+53|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,l,443206,427569,155);bD(l)}if((g|0)!=1){H=0;I=k+16|0;f[I>>2]=H;J=k+28|0;f[J>>2]=h;f[l>>2]=0;K=l+4|0;f[K>>2]=i;L=+(i|0);RQ(l,k,L);u=j;return}g=f[e>>2]|0;G=f[r>>2]|0;m=G;F=g;if((g|0)==(G|0)){H=0;I=k+16|0;f[I>>2]=H;J=k+28|0;f[J>>2]=h;f[l>>2]=0;K=l+4|0;f[K>>2]=i;L=+(i|0);RQ(l,k,L);u=j;return}if((m-F>>2|0)==(c|0)){M=m;N=F;O=g}else{f[l>>2]=0;f[l+4>>2]=0;o=aD(l,30)|0;p=428151;q=o+30|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,l,443206,427569,160);bD(l);p=f[e>>2]|0;M=f[r>>2]|0;N=p;O=p}if((M|0)==(N|0)){H=0;I=k+16|0;f[I>>2]=H;J=k+28|0;f[J>>2]=h;f[l>>2]=0;K=l+4|0;f[K>>2]=i;L=+(i|0);RQ(l,k,L);u=j;return}N=M-O>>2;M=0;while(1){if(+n[O+(M<<2)>>2]!=1.0){H=e;A=38;break}M=M+1|0;if(M>>>0>=N>>>0){H=0;A=38;break}}if((A|0)==38){I=k+16|0;f[I>>2]=H;J=k+28|0;f[J>>2]=h;f[l>>2]=0;K=l+4|0;f[K>>2]=i;L=+(i|0);RQ(l,k,L);u=j;return}}function yfb(a){a=a|0;O5b(a);return}function zfb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0;c=f[a+12>>2]|0;d=a+36|0;e=f[d>>2]|0;g=Y(e,f[f[c+40>>2]>>2]|0)|0;h=f[a+24>>2]|0;i=((h+-1+g|0)>>>0)/(h>>>0)|0;h=Y(f[b>>2]|0,i)|0;j=Y(f[b+4>>2]|0,i)|0;i=g>>>0<j>>>0?g:j;j=f[a+8>>2]|0;g=f[a+16>>2]|0;if(!g)k=0;else{b=f[g>>2]|0;k=(b|0)==(f[g+4>>2]|0)?0:b}b=f[c+16>>2]|0;if(i>>>0<=h>>>0)return;c=a+32|0;g=a+28|0;l=a+4|0;m=a+20|0;a=(k|0)==0;o=(j|0)>1;p=(h>>>0)/(e>>>0)|0;q=h-(Y(p,e)|0)|0;r=i-h|0;s=e-q|0;t=(s|0)<(r|0)?s:r;r=(t|0)<4096?t:4096;if((r|0)<1)return;else{u=h;v=r;w=t;x=p;y=e;z=q}while(1){q=f[c>>2]|0;a:do if((q|0)>0){e=f[l>>2]|0;p=f[(f[e>>2]|0)+16>>2]|0;t=f[m>>2]|0;r=(w|0)>0;h=Y(q,x)|0;s=o&r;A=o&r;B=o&r;r=0;while(1){C=(Y(y,h+r|0)|0)+z|0;D=b+(C<<2)|0;b:do switch(t|0){case 0:{if(A){E=1;F=p;while(1){G=(f[(f[e+(E<<2)>>2]|0)+16>>2]|0)+(C<<2)|0;H=F+(C<<2)|0;I=0;do{n[D+(I<<2)>>2]=+n[H+(I<<2)>>2]*+n[G+(I<<2)>>2];I=I+1|0}while((I|0)<(v|0));I=E+1|0;if((I|0)==(j|0))break;else{E=I;F=b}}}break}case 2:{if(B){F=1;E=p;while(1){I=(f[(f[e+(F<<2)>>2]|0)+16>>2]|0)+(C<<2)|0;G=E+(C<<2)|0;H=0;do{J=G+(H<<2)|0;K=I+(H<<2)|0;f[D+(H<<2)>>2]=f[(+n[J>>2]<+n[K>>2]?K:J)>>2];H=H+1|0}while((H|0)<(v|0));H=F+1|0;if((H|0)==(j|0))break;else{F=H;E=b}}}break}default:{if(a){if(s){L=1;M=p}else break b;while(1){E=(f[(f[e+(L<<2)>>2]|0)+16>>2]|0)+(C<<2)|0;F=M+(C<<2)|0;H=0;do{n[D+(H<<2)>>2]=+n[F+(H<<2)>>2]+ +n[E+(H<<2)>>2];H=H+1|0}while((H|0)<(v|0));H=L+1|0;if((H|0)==(j|0))break b;else{L=H;M=b}}}if(s){N=+n[k>>2];H=1;E=p;while(1){F=(f[(f[e+(H<<2)>>2]|0)+16>>2]|0)+(C<<2)|0;O=+n[k+(H<<2)>>2];I=E+(C<<2)|0;G=0;do{n[D+(G<<2)>>2]=N*+n[I+(G<<2)>>2]+O*+n[F+(G<<2)>>2];G=G+1|0}while((G|0)<(v|0));G=H+1|0;if((G|0)==(j|0))break;else{N=1.0;H=G;E=b}}}}}while(0);r=r+1|0;if((r|0)>=(q|0))break a}}while(0);r=f[g>>2]|0;if(r|0){e=b+(z<<2)+((Y(Y(q,x)|0,y)|0)<<2)|0;Qh[f[(f[r>>2]|0)+92>>2]&127](r,e,e,v,y,0,q)}u=v+u|0;if(i>>>0<=u>>>0){P=31;break}y=f[d>>2]|0;x=(u>>>0)/(y>>>0)|0;z=u-(Y(x,y)|0)|0;e=i-u|0;r=y-z|0;w=(r|0)<(e|0)?r:e;v=(w|0)<4096?w:4096;if((v|0)<1){P=31;break}}if((P|0)==31)return}function Afb(a,b){a=a|0;b=b|0;var c=0;c=L5b(128)|0;Bfb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=122524;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Bfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0;d=u;u=u+144|0;e=d+104|0;g=d+96|0;h=d+92|0;i=d+88|0;j=d+80|0;k=d+72|0;l=d+32|0;m=d+20|0;o=d+8|0;q=d;Jwa(a);f[a>>2]=122544;r=a+36|0;s=a+40|0;t=a+44|0;v=a+48|0;w=a+52|0;x=a+56|0;y=a+60|0;z=a+64|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[r+28>>2]=0;f[a+72>>2]=1124007936;A=a+80|0;B=a+112|0;C=a+76|0;D=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(D|0));f[B>>2]=A;A=a+120|0;f[a+116>>2]=A;f[A>>2]=0;f[a+124>>2]=0;Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;C=aD(e,11)|0;A=428445;D=C+11|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));B=c+4|0;E=f[B>>2]|0;do if(E){F=f[e>>2]|0;G=(F|0)==0?1124530:F;H=B;I=E;a:while(1){J=I;while(1){L=f[J+16>>2]|0;if((L|0)==(F|0))break;if((gTb((L|0)==0?1124530:L,G)|0)>=0)break;L=f[J+4>>2]|0;if(!L){N=H;break a}else J=L}I=f[J>>2]|0;if(!I){N=J;break}else H=J}if((N|0)!=(B|0)){H=f[N+16>>2]|0;if((F|0)!=(H|0)?(gTb(G,(H|0)==0?1124530:H)|0)<=-1:0){O=16;break}H=Gwa(N+24|0,-1)|0;O=H}else O=16}else O=16;while(0);bD(e);f[g>>2]=O;f[e>>2]=0;f[e+4>>2]=0;C=aD(e,9)|0;A=428457;D=C+9|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));O=f[B>>2]|0;do if(O){N=f[e>>2]|0;E=(N|0)==0?1124530:N;H=B;I=O;b:while(1){L=I;while(1){P=f[L+16>>2]|0;if((P|0)==(N|0))break;if((gTb((P|0)==0?1124530:P,E)|0)>=0)break;P=f[L+4>>2]|0;if(!P){Q=H;break b}else L=P}I=f[L>>2]|0;if(!I){Q=L;break}else H=L}if((Q|0)!=(B|0)){H=f[Q+16>>2]|0;if((N|0)!=(H|0)?(gTb(E,(H|0)==0?1124530:H)|0)<=-1:0){R=16;break}H=Gwa(Q+24|0,-1)|0;R=H}else R=16}else R=16;while(0);bD(e);f[e>>2]=0;f[e+4>>2]=0;C=aD(e,12)|0;A=428467;D=C+12|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));Q=f[B>>2]|0;do if(Q){O=f[e>>2]|0;H=(O|0)==0?1124530:O;I=B;G=Q;c:while(1){F=G;while(1){J=f[F+16>>2]|0;if((J|0)==(O|0))break;if((gTb((J|0)==0?1124530:J,H)|0)>=0)break;J=f[F+4>>2]|0;if(!J){S=I;break c}else F=J}G=f[F>>2]|0;if(!G){S=F;break}else I=F}if((S|0)!=(B|0)){I=f[S+16>>2]|0;if((O|0)!=(I|0)?(gTb(H,(I|0)==0?1124530:I)|0)<=-1:0){T=6e3;break}I=Gwa(S+24|0,-1)|0;T=I}else T=6e3}else T=6e3;while(0);bD(e);f[h>>2]=T;f[e>>2]=0;f[e+4>>2]=0;C=aD(e,13)|0;A=428480;D=C+13|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));T=f[B>>2]|0;do if(T){S=f[e>>2]|0;Q=(S|0)==0?1124530:S;I=B;G=T;d:while(1){E=G;while(1){N=f[E+16>>2]|0;if((N|0)==(S|0))break;if((gTb((N|0)==0?1124530:N,Q)|0)>=0)break;N=f[E+4>>2]|0;if(!N){U=I;break d}else E=N}G=f[E>>2]|0;if(!G){U=E;break}else I=E}if((U|0)!=(B|0)){I=f[U+16>>2]|0;if((S|0)!=(I|0)?(gTb(Q,(I|0)==0?1124530:I)|0)<=-1:0){V=300;break}I=Gwa(U+24|0,-1)|0;V=I}else V=300}else V=300;while(0);U=a+68|0;f[U>>2]=V;bD(e);f[e>>2]=0;f[e+4>>2]=0;C=aD(e,10)|0;A=428494;D=C+10|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));V=f[B>>2]|0;do if(V){a=f[e>>2]|0;T=(a|0)==0?1124530:a;I=B;G=V;e:while(1){H=G;while(1){O=f[H+16>>2]|0;if((O|0)==(a|0))break;if((gTb((O|0)==0?1124530:O,T)|0)>=0)break;O=f[H+4>>2]|0;if(!O){W=I;break e}else H=O}G=f[H>>2]|0;if(!G){W=H;break}else I=H}if((W|0)!=(B|0)){I=f[W+16>>2]|0;if((a|0)!=(I|0)?(gTb(T,(I|0)==0?1124530:I)|0)<=-1:0){X=.699999988079071;break}X=+Hya(W+24|0,-1)}else X=.699999988079071}else X=.699999988079071;while(0);bD(e);n[i>>2]=X;f[e>>2]=0;f[e+4>>2]=0;W=aD(e,5)|0;b[W>>0]=b[428505]|0;b[W+1>>0]=b[428506]|0;b[W+2>>0]=b[428507]|0;b[W+3>>0]=b[428508]|0;b[W+4>>0]=b[428509]|0;iua(j,Eya(c,e)|0);bD(e);f[e>>2]=0;f[e+4>>2]=0;W=aD(e,5)|0;b[W>>0]=b[439628]|0;b[W+1>>0]=b[439629]|0;b[W+2>>0]=b[439630]|0;b[W+3>>0]=b[439631]|0;b[W+4>>0]=b[439632]|0;iua(k,Eya(c,e)|0);bD(e);f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=l+4;c=l+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=0;f[e>>2]=0;f[e+4>>2]=0;c=aD(e,4)|0;b[c>>0]=115;b[c+1>>0]=116;b[c+2>>0]=101;b[c+3>>0]=112;dza(l,e,g)|0;bD(e);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,4)|0;b[g>>0]=102;b[g+1>>0]=108;b[g+2>>0]=105;b[g+3>>0]=112;b[m>>0]=0;$wa(l,e,m)|0;bD(e);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,4)|0;b[g>>0]=99;b[g+1>>0]=108;b[g+2>>0]=105;b[g+3>>0]=112;b[m>>0]=0;$wa(l,e,m)|0;bD(e);f[e>>2]=0;f[e+4>>2]=0;C=aD(e,15)|0;A=431744;D=C+15|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));b[m>>0]=0;$wa(l,e,m)|0;bD(e);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,8)|0;c=g;b[c>>0]=118;b[c+1>>0]=97;b[c+2>>0]=114;b[c+3>>0]=105;c=g+4|0;b[c>>0]=97;b[c+1>>0]=110;b[c+2>>0]=99;b[c+3>>0]=101;c=L5b(16)|0;f[c>>2]=c+8;f[c+4>>2]=4;g=N5b(32)|0;f[c>>2]=g;f[m>>2]=2;f[m+4>>2]=c;p[g>>3]=.10000000149011612;p[g+8>>3]=.10000000149011612;p[g+16>>3]=.20000000298023224;p[g+24>>3]=.20000000298023224;nxa(l,e,m)|0;gua(m);bD(e);f[m>>2]=0;g=m+4|0;f[g>>2]=0;f[m+8>>2]=0;f[o>>2]=0;c=o+4|0;f[c>>2]=0;f[o+8>>2]=0;switch(f[j>>2]|0){case 0:{Z=f[(f[j+4>>2]|0)+4>>2]|0;break}case 3:{Z=f[(f[j+4>>2]|0)+4>>2]|0;break}case 2:{Z=f[(f[j+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);Z=-1}}switch(f[k>>2]|0){case 0:{_=f[(f[k+4>>2]|0)+4>>2]|0;break}case 3:{_=f[(f[k+4>>2]|0)+4>>2]|0;break}case 2:{_=f[(f[k+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);_=-1}}rra(m,Y(_,Z)|0);switch(f[j>>2]|0){case 0:{$=f[(f[j+4>>2]|0)+4>>2]|0;break}case 3:{$=f[(f[j+4>>2]|0)+4>>2]|0;break}case 2:{$=f[(f[j+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);$=-1}}switch(f[k>>2]|0){case 0:{aa=f[(f[k+4>>2]|0)+4>>2]|0;break}case 3:{aa=f[(f[k+4>>2]|0)+4>>2]|0;break}case 2:{aa=f[(f[k+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);aa=-1}}rra(o,Y(aa,$)|0);$=e+4|0;aa=e+4|0;X=+(R>>>0);R=m+8|0;Z=o+8|0;_=k+4|0;W=k+4|0;B=j+4|0;V=j+4|0;I=0;while(1){switch(f[j>>2]|0){case 0:{ba=f[(f[B>>2]|0)+4>>2]|0;break}case 3:{ba=f[(f[V>>2]|0)+4>>2]|0;break}case 2:{ba=f[(f[V>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[$>>2]=0;bO(-3,e,429353,429358,272);bD(e);ba=-1}}if((I|0)>=(ba|0))break;ca=+Hya(j,I);G=0;while(1){switch(f[k>>2]|0){case 0:{da=f[(f[_>>2]|0)+4>>2]|0;break}case 3:{da=f[(f[W>>2]|0)+4>>2]|0;break}case 2:{da=f[(f[W>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[aa>>2]=0;bO(-3,e,429353,429358,272);bD(e);da=-1}}if((G|0)>=(da|0))break;ea=+Hya(k,G);fa=+K(+(X/+M(+ca)+.5));ga=+K(+(ca*fa+.5));ha=ea*fa;n[e>>2]=ha;Q=f[g>>2]|0;if((Q|0)==(f[R>>2]|0))upa(m,e);else{n[Q>>2]=ha;f[g>>2]=Q+4}ha=ea*ga;n[e>>2]=ha;Q=f[c>>2]|0;if((Q|0)==(f[Z>>2]|0))upa(o,e);else{n[Q>>2]=ha;f[c>>2]=Q+4}G=G+1|0}I=I+1|0}f[e>>2]=0;f[e+4>>2]=0;I=aD(e,5)|0;b[I>>0]=b[434730]|0;b[I+1>>0]=b[434731]|0;b[I+2>>0]=b[434732]|0;b[I+3>>0]=b[434733]|0;b[I+4>>0]=b[434734]|0;I=f[m>>2]|0;Z=(f[g>>2]|0)-I|0;R=Z>>2;da=L5b(16)|0;aa=da+8|0;f[da>>2]=aa;f[da+4>>2]=R;if(R>>>0>1){W=N5b(R>>>0>536870911?-1:R<<3)|0;f[da>>2]=W;ia=W}else ia=aa;f[q>>2]=2;f[q+4>>2]=da;if((Z|0)>0){Z=I;I=0;while(1){p[ia+(I<<3)>>3]=+n[Z>>2];I=I+1|0;if((I|0)==(R|0))break;else Z=Z+4|0}}nxa(l,e,q)|0;gua(q);bD(e);f[e>>2]=0;f[e+4>>2]=0;Z=aD(e,6)|0;b[Z>>0]=b[434884]|0;b[Z+1>>0]=b[434885]|0;b[Z+2>>0]=b[434886]|0;b[Z+3>>0]=b[434887]|0;b[Z+4>>0]=b[434888]|0;b[Z+5>>0]=b[434889]|0;Z=f[o>>2]|0;R=(f[c>>2]|0)-Z|0;I=R>>2;ia=L5b(16)|0;da=ia+8|0;f[ia>>2]=da;f[ia+4>>2]=I;if(I>>>0>1){aa=N5b(I>>>0>536870911?-1:I<<3)|0;f[ia>>2]=aa;ja=aa}else ja=da;f[q>>2]=2;f[q+4>>2]=ia;if((R|0)>0){R=Z;Z=0;while(1){p[ja+(Z<<3)>>3]=+n[R>>2];Z=Z+1|0;if((Z|0)==(I|0))break;else R=R+4|0}}nxa(l,e,q)|0;gua(q);bD(e);Heb(e,l);q=f[e>>2]|0;R=f[e+4>>2]|0;if(q|0){I=q+4|0;f[I>>2]=(f[I>>2]|0)+1}I=f[r>>2]|0;f[r>>2]=q;f[s>>2]=R;if(I|0?(R=I+4|0,s=f[R>>2]|0,f[R>>2]=s+-1,(s|0)==1):0)bi[f[(f[I>>2]|0)+8>>2]&2047](I);I=f[e>>2]|0;if(I|0?(s=I+4|0,R=f[s>>2]|0,f[s>>2]=R+-1,(R|0)==1):0)bi[f[(f[I>>2]|0)+8>>2]&2047](I);I=f[o>>2]|0;if(I|0){o=f[c>>2]|0;if((o|0)!=(I|0))f[c>>2]=o+(~((o+-4-I|0)>>>2)<<2);O5b(I)}I=f[m>>2]|0;if(I|0){o=f[g>>2]|0;if((o|0)!=(I|0))f[g>>2]=o+(~((o+-4-I|0)>>>2)<<2);O5b(I)}fua(l);f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=e+4;I=e+12|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;f[I+16>>2]=0;f[I+20>>2]=0;f[I+24>>2]=0;f[l>>2]=0;f[l+4>>2]=0;I=aD(l,5)|0;b[I>>0]=b[428511]|0;b[I+1>>0]=b[428512]|0;b[I+2>>0]=b[428513]|0;b[I+3>>0]=b[428514]|0;b[I+4>>0]=b[428515]|0;I=L5b(16)|0;f[I>>2]=I+8;f[I+4>>2]=4;o=N5b(32)|0;f[I>>2]=o;f[m>>2]=0;f[m+4>>2]=I;I=o;f[I>>2]=0;f[I+4>>2]=0;I=o+8|0;f[I>>2]=2;f[I+4>>2]=0;I=o+16|0;f[I>>2]=3;f[I+4>>2]=0;I=o+24|0;f[I>>2]=1;f[I+4>>2]=0;nxa(e,l,m)|0;gua(m);bD(l);kdb(l,e);I=f[l>>2]|0;o=f[l+4>>2]|0;if(I|0){g=I+4|0;f[g>>2]=(f[g>>2]|0)+1}g=f[w>>2]|0;f[w>>2]=I;f[x>>2]=o;if(g|0?(o=g+4|0,x=f[o>>2]|0,f[o>>2]=x+-1,(x|0)==1):0)bi[f[(f[g>>2]|0)+8>>2]&2047](g);g=f[l>>2]|0;if(g|0?(x=g+4|0,o=f[x>>2]|0,f[x>>2]=o+-1,(o|0)==1):0)bi[f[(f[g>>2]|0)+8>>2]&2047](g);kdb(l,e);g=f[l>>2]|0;o=f[l+4>>2]|0;if(g|0){x=g+4|0;f[x>>2]=(f[x>>2]|0)+1}x=f[y>>2]|0;f[y>>2]=g;f[z>>2]=o;do if(x|0){o=x+4|0;z=f[o>>2]|0;f[o>>2]=z+-1;if((z|0)!=1)break;bi[f[(f[x>>2]|0)+8>>2]&2047](x)}while(0);x=f[l>>2]|0;do if(x|0){z=x+4|0;o=f[z>>2]|0;f[z>>2]=o+-1;if((o|0)!=1)break;bi[f[(f[x>>2]|0)+8>>2]&2047](x)}while(0);fua(e);f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=e+4;x=e+12|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[l>>2]=0;f[l+4>>2]=0;C=aD(l,9)|0;A=431908;D=C+9|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));Efb(e,l,431930)|0;bD(l);f[l>>2]=0;f[l+4>>2]=0;C=aD(l,11)|0;A=431612;D=C+11|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));f[m>>2]=1;Wwa(e,l,m)|0;bD(l);f[l>>2]=0;f[l+4>>2]=0;C=aD(l,14)|0;A=431624;D=C+14|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));b[m>>0]=1;$wa(e,l,m)|0;bD(l);f[l>>2]=0;f[l+4>>2]=0;C=aD(l,19)|0;A=431639;D=C+19|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));f[m>>2]=1;Wwa(e,l,m)|0;bD(l);f[l>>2]=0;f[l+4>>2]=0;C=aD(l,26)|0;A=431659;D=C+26|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));b[m>>0]=1;$wa(e,l,m)|0;bD(l);f[l>>2]=0;f[l+4>>2]=0;C=aD(l,10)|0;A=431686;D=C+10|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));dza(e,l,U)|0;bD(l);f[l>>2]=0;f[l+4>>2]=0;U=aD(l,5)|0;b[U>>0]=b[431718]|0;b[U+1>>0]=b[431719]|0;b[U+2>>0]=b[431720]|0;b[U+3>>0]=b[431721]|0;b[U+4>>0]=b[431722]|0;dza(e,l,h)|0;bD(l);f[l>>2]=0;f[l+4>>2]=0;C=aD(l,13)|0;A=431760;D=C+13|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));Zwa(e,l,i)|0;bD(l);f[l>>2]=0;f[l+4>>2]=0;C=aD(l,15)|0;A=431744;D=C+15|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(D|0));b[m>>0]=0;$wa(e,l,m)|0;bD(l);f[l>>2]=0;f[l+4>>2]=0;A=aD(l,4)|0;b[A>>0]=99;b[A+1>>0]=108;b[A+2>>0]=105;b[A+3>>0]=112;b[m>>0]=1;$wa(e,l,m)|0;bD(l);Egb(l,e);m=f[l>>2]|0;A=f[l+4>>2]|0;if(m|0){C=m+4|0;f[C>>2]=(f[C>>2]|0)+1}C=f[t>>2]|0;f[t>>2]=m;f[v>>2]=A;do if(C|0){A=C+4|0;v=f[A>>2]|0;f[A>>2]=v+-1;if((v|0)!=1)break;bi[f[(f[C>>2]|0)+8>>2]&2047](C)}while(0);C=f[l>>2]|0;if(!C){fua(e);gua(k);gua(j);u=d;return}l=C+4|0;v=f[l>>2]|0;f[l>>2]=v+-1;if((v|0)!=1){fua(e);gua(k);gua(j);u=d;return}bi[f[(f[C>>2]|0)+8>>2]&2047](C);fua(e);gua(k);gua(j);u=d;return}function Cfb(a){a=a|0;O5b(a);return}function Dfb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Efb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1124530:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((gTb((r|0)==0?1124530:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=L5b(16)|0;p=o+8|0;f[p>>2]=0;f[o+12>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;bD(p);o=kUb(c)|0;if(o|0)Vac(aD(p,o)|0,c|0,o|0)|0;$xa(s+24|0,e)|0;gua(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=L5b(16)|0;t=b+8|0;f[t>>2]=0;f[b+12>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;bD(t);b=kUb(c)|0;if(b|0)Vac(aD(t,b)|0,c|0,b|0)|0;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;iua(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;iua(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1124530:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1124530:A;if((gTb(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=28;break}else{E=z;F=C}}else{if((gTb(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=31;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==28){v=z;w=z;break b}else if((D|0)==31){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=L5b(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}iua(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}mP(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}gua(t);bD(e);gua(s);bD(g);gua(i);bD(h);u=d;return c|0}function Ffb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=122544;b=a+72|0;c=a+108|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+88|0;b=a+76|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+112>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+116>>2]|0;if((b|0)!=(a+120|0))UC(b);b=a+60|0;d=f[b>>2]|0;if(d|0?(c=d+4|0,e=f[c>>2]|0,f[c>>2]=e+-1,(e|0)==1):0)bi[f[(f[d>>2]|0)+8>>2]&2047](d);f[b>>2]=0;f[a+64>>2]=0;b=a+52|0;d=f[b>>2]|0;if(d|0?(e=d+4|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)bi[f[(f[d>>2]|0)+8>>2]&2047](d);f[b>>2]=0;f[a+56>>2]=0;b=a+44|0;d=f[b>>2]|0;if(d|0?(c=d+4|0,e=f[c>>2]|0,f[c>>2]=e+-1,(e|0)==1):0)bi[f[(f[d>>2]|0)+8>>2]&2047](d);f[b>>2]=0;f[a+48>>2]=0;b=a+36|0;d=f[b>>2]|0;if(!d){f[b>>2]=0;g=a+40|0;f[g>>2]=0;lua(a);return}e=d+4|0;c=f[e>>2]|0;f[e>>2]=c+-1;if((c|0)!=1){f[b>>2]=0;g=a+40|0;f[g>>2]=0;lua(a);return}bi[f[(f[d>>2]|0)+8>>2]&2047](d);f[b>>2]=0;g=a+40|0;f[g>>2]=0;lua(a);return}function Gfb(a){a=a|0;Ffb(a);O5b(a);return}function Hfb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+224|0;e=d+208|0;g=d+196|0;h=d+184|0;i=d+128|0;j=d+72|0;k=d+16|0;l=d;f[g>>2]=0;m=g+4|0;f[m>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Lfb(i,f[f[c>>2]>>2]|0);f[e>>2]=i;Nfb(g,1,e);n=i+40|0;o=f[n>>2]|0;p=f[o+8>>2]|0;q=f[o+12>>2]|0;r=f[o+4>>2]|0;f[e>>2]=f[o>>2];o=e+4|0;f[o>>2]=p;p=e+8|0;f[p>>2]=q;q=e+12|0;f[q>>2]=r;f[k>>2]=0;r=k+4|0;f[r>>2]=0;f[k+8>>2]=0;s=e+16|0;Rva(k,e,s);t=f[k>>2]|0;v=f[r>>2]|0;a:do if((t|0)==(v|0)){w=t;x=4}else{y=t;do{if((f[y>>2]|0)<0){w=y;x=4;break a}y=y+4|0}while((y|0)!=(v|0))}while(0);if((x|0)==4?(w|0)!=(v|0):0){t=w+4|0;if((t|0)==(v|0)){z=v;A=w}else{y=t;t=w;while(1){w=f[y>>2]|0;if((w|0)<0)B=t;else{f[t>>2]=w;B=t+4|0}y=y+4|0;if((y|0)==(v|0))break;else t=B}z=f[r>>2]|0;A=B}if((A|0)!=(z|0))f[r>>2]=z+(~((z+-4-A|0)>>>2)<<2)}f[j>>2]=1124007936;A=j+4|0;z=j+8|0;B=j+40|0;t=A;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[B>>2]=z;z=j+48|0;y=j+44|0;f[y>>2]=z;f[z>>2]=0;f[j+52>>2]=0;iL(j,k,5);Mfb(h,1,j);w=j+36|0;C=f[w>>2]|0;if(C|0?(D=C+12|0,C=f[D>>2]|0,f[D>>2]=C+-1,(C|0)==1):0)kL(j);f[w>>2]=0;w=j+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[A>>2]|0)>0){w=f[B>>2]|0;B=0;do{f[w+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[A>>2]|0))}A=f[y>>2]|0;if((A|0)!=(z|0))UC(A);A=f[k>>2]|0;if(A|0){z=f[r>>2]|0;if((z|0)!=(A|0))f[r>>2]=z+(~((z+-4-A|0)>>>2)<<2);O5b(A)}A=f[a+64>>2]|0;_h[f[(f[A>>2]|0)+32>>2]&255](A,g,h);A=f[(f[c>>2]|0)+4>>2]|0;f[j>>2]=A;if((f[A+4>>2]|0)!=4){f[e>>2]=0;f[e+4>>2]=0;t=aD(e,21)|0;A=429060;v=t+21|0;do{b[t>>0]=b[A>>0]|0;t=t+1|0;A=A+1|0}while((t|0)<(v|0));bO(-215,e,443724,428536,144);bD(e)}Nfb(g,1,j);A=f[(f[j>>2]|0)+40>>2]|0;j=f[A+8>>2]|0;c=f[A+12>>2]|0;z=f[A+4>>2]|0;f[e>>2]=f[A>>2];f[o>>2]=j;f[p>>2]=c;f[q>>2]=z;f[l>>2]=0;z=l+4|0;f[z>>2]=0;f[l+8>>2]=0;Rva(l,e,s);s=f[l>>2]|0;e=f[z>>2]|0;b:do if((s|0)==(e|0)){E=s;x=29}else{q=s;do{if((f[q>>2]|0)<0){E=q;x=29;break b}q=q+4|0}while((q|0)!=(e|0))}while(0);if((x|0)==29?(E|0)!=(e|0):0){x=E+4|0;if((x|0)==(e|0)){F=e;G=E}else{s=x;x=E;while(1){E=f[s>>2]|0;if((E|0)<0)H=x;else{f[x>>2]=E;H=x+4|0}s=s+4|0;if((s|0)==(e|0))break;else x=H}F=f[z>>2]|0;G=H}if((G|0)!=(F|0))f[z>>2]=F+(~((F+-4-G|0)>>>2)<<2)}f[k>>2]=1124007936;G=k+4|0;F=k+8|0;H=k+40|0;t=G;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[H>>2]=F;F=k+48|0;t=k+44|0;f[t>>2]=F;f[F>>2]=0;f[k+52>>2]=0;iL(k,l,5);Mfb(h,1,k);v=k+36|0;x=f[v>>2]|0;if(x|0?(e=x+12|0,x=f[e>>2]|0,f[e>>2]=x+-1,(x|0)==1):0)kL(k);f[v>>2]=0;v=k+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[G>>2]|0)>0){v=f[H>>2]|0;H=0;do{f[v+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[G>>2]|0))}G=f[t>>2]|0;if((G|0)!=(F|0))UC(G);G=f[l>>2]|0;if(G|0){l=f[z>>2]|0;if((l|0)!=(G|0))f[z>>2]=l+(~((l+-4-G|0)>>>2)<<2);O5b(G)}G=f[a+56>>2]|0;_h[f[(f[G>>2]|0)+32>>2]&255](G,g,h);G=i+36|0;a=f[G>>2]|0;if(a|0?(l=a+12|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)kL(i);f[G>>2]=0;G=i+16|0;a=i+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[a>>2]|0)>0){G=f[n>>2]|0;n=0;do{f[G+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[a>>2]|0))}a=f[i+44>>2]|0;if((a|0)!=(i+48|0))UC(a);et(h);h=f[g>>2]|0;if(!h){u=d;return}g=f[m>>2]|0;if((g|0)!=(h|0))f[m>>2]=g+(~((g+-4-h|0)>>>2)<<2);O5b(h);u=d;return}function Ifb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;g=u;u=u+464|0;h=g+400|0;i=g;j=g+224|0;k=g+212|0;l=g+200|0;m=g+144|0;o=g+344|0;q=g+88|0;r=g+72|0;s=g+16|0;t=g+288|0;v=g+232|0;dQ(j,122668);if(((f[c+4>>2]|0)-(f[c>>2]|0)|0)!=12){f[h>>2]=0;f[h+4>>2]=0;w=aD(h,18)|0;x=428517;y=w+18|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,h,443123,428536,164);bD(h)}z=f[e>>2]|0;if(((f[e+4>>2]|0)-z|0)==168)A=z;else{f[h>>2]=0;f[h+4>>2]=0;w=aD(h,21)|0;x=428817;y=w+21|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,h,443123,428536,165);bD(h);A=f[e>>2]|0}z=f[c>>2]|0;c=f[z>>2]|0;B=f[z+4>>2]|0;C=f[z+8>>2]|0;z=A+56|0;D=A+112|0;E=f[C+4>>2]|0;if((E|0)<3)F=Y(f[C+12>>2]|0,f[C+8>>2]|0)|0;else{G=f[C+40>>2]|0;H=0;I=1;while(1){J=Y(f[G+(H<<2)>>2]|0,I)|0;H=H+1|0;if((H|0)==(E|0)){F=J;break}else I=J}}if(F>>>0<=1){f[h>>2]=0;f[h+4>>2]=0;w=aD(h,19)|0;x=428839;y=w+19|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,h,443123,428536,173);bD(h)}F=a+72|0;I=f[C+16>>2]|0;K=+n[I>>2];do if((f[C>>2]&16384|0)==0?(E=f[C+40>>2]|0,(f[E>>2]|0)!=1):0){H=f[f[C+44>>2]>>2]|0;if((f[E+4>>2]|0)==1){L=I+H|0;break}else{E=f[C+12>>2]|0;G=(E+1|0)>>>0<3?E:0;L=I+(Y(G,H)|0)+(1-(Y(G,E)|0)<<2)|0;break}}else M=16;while(0);if((M|0)==16)L=I+4|0;I=~~+n[L>>2];f[h>>2]=1;f[h+4>>2]=1;f[h+8>>2]=~~K;f[h+12>>2]=I;f[i>>2]=0;I=i+4|0;f[I>>2]=0;f[i+8>>2]=0;Rva(i,h,h+16|0);L=f[i>>2]|0;C=f[I>>2]|0;a:do if((L|0)==(C|0)){N=L;M=23}else{E=L;do{if((f[E>>2]|0)<0){N=E;M=23;break a}E=E+4|0}while((E|0)!=(C|0))}while(0);if((M|0)==23?(N|0)!=(C|0):0){L=N+4|0;if((L|0)==(C|0)){O=C;P=N}else{E=L;L=N;while(1){N=f[E>>2]|0;if((N|0)<0)Q=L;else{f[L>>2]=N;Q=L+4|0}E=E+4|0;if((E|0)==(C|0))break;else L=Q}O=f[I>>2]|0;P=Q}if((P|0)!=(O|0))f[I>>2]=O+(~((O+-4-P|0)>>>2)<<2)}iL(F,i,0);P=f[i>>2]|0;if(P|0){O=f[I>>2]|0;if((O|0)!=(P|0))f[I>>2]=O+(~((O+-4-P|0)>>>2)<<2);O5b(P)}f[k>>2]=0;P=k+4|0;f[P>>2]=0;f[k+8>>2]=0;O=L5b(112)|0;f[k>>2]=O;f[k+8>>2]=O+112;f[O>>2]=1124007936;I=O+8|0;Q=O+40|0;w=O+4|0;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[Q>>2]=I;I=O+48|0;f[O+44>>2]=I;f[I>>2]=0;f[O+52>>2]=0;f[O+56>>2]=1124007936;I=O+64|0;Q=O+96|0;w=O+60|0;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[Q>>2]=I;I=O+104|0;f[O+100>>2]=I;f[I>>2]=0;f[O+108>>2]=0;f[P>>2]=O+112;Dua(l,1,A);O=f[k>>2]|0;if((O|0)==(c|0))R=c;else{P=c+36|0;I=f[P>>2]|0;if(I|0){Q=I+12|0;f[Q>>2]=(f[Q>>2]|0)+1}Q=O+36|0;I=f[Q>>2]|0;if(I|0?(L=I+12|0,I=f[L>>2]|0,f[L>>2]=I+-1,(I|0)==1):0)kL(O);f[Q>>2]=0;I=O+16|0;L=O+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[L>>2]|0)>0){C=f[O+40>>2]|0;E=0;do{f[C+(E<<2)>>2]=0;E=E+1|0;S=f[L>>2]|0}while((E|0)<(S|0));f[O>>2]=f[c>>2];if((S|0)<3)M=46;else M=48}else{f[O>>2]=f[c>>2];M=46}if((M|0)==46){S=f[c+4>>2]|0;if((S|0)<3){f[L>>2]=S;f[O+8>>2]=f[c+8>>2];f[O+12>>2]=f[c+12>>2];S=f[c+44>>2]|0;L=f[O+44>>2]|0;f[L>>2]=f[S>>2];f[L+4>>2]=f[S+4>>2]}else M=48}if((M|0)==48)jL(O,c);f[I>>2]=f[c+16>>2];f[O+20>>2]=f[c+20>>2];f[O+24>>2]=f[c+24>>2];f[O+28>>2]=f[c+28>>2];f[O+32>>2]=f[c+32>>2];f[Q>>2]=f[P>>2];R=f[k>>2]|0}P=R+56|0;if((P|0)!=(F|0)){Q=a+108|0;O=f[Q>>2]|0;if(O|0){I=O+12|0;f[I>>2]=(f[I>>2]|0)+1}I=R+92|0;O=f[I>>2]|0;if(O|0?(S=O+12|0,O=f[S>>2]|0,f[S>>2]=O+-1,(O|0)==1):0)kL(P);f[I>>2]=0;O=R+72|0;S=R+60|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[S>>2]|0)>0){L=f[R+96>>2]|0;E=0;do{f[L+(E<<2)>>2]=0;E=E+1|0;T=f[S>>2]|0}while((E|0)<(T|0));f[P>>2]=f[F>>2];if((T|0)<3)M=61;else M=63}else{f[P>>2]=f[F>>2];M=61}if((M|0)==61){T=f[a+76>>2]|0;if((T|0)<3){f[S>>2]=T;f[R+64>>2]=f[a+80>>2];f[R+68>>2]=f[a+84>>2];T=f[a+116>>2]|0;S=f[R+100>>2]|0;f[S>>2]=f[T>>2];f[S+4>>2]=f[T+4>>2]}else M=63}if((M|0)==63)jL(P,F);f[O>>2]=f[a+88>>2];f[R+76>>2]=f[a+92>>2];f[R+80>>2]=f[a+96>>2];f[R+84>>2]=f[a+100>>2];f[R+88>>2]=f[a+104>>2];f[I>>2]=f[Q>>2]}Q=f[a+40>>2]|0;I=f[(f[Q>>2]|0)+40>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=k;R=i+8|0;f[R>>2]=0;f[R+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=l;R=m+8|0;f[R>>2]=0;f[R+4>>2]=0;f[m>>2]=33882112;f[m+4>>2]=e;th[I&511](Q,h,i,m);Lfb(h,c);Mfb(k,1,h);c=h+36|0;Q=f[c>>2]|0;if(Q|0?(I=Q+12|0,Q=f[I>>2]|0,f[I>>2]=Q+-1,(Q|0)==1):0)kL(h);f[c>>2]=0;c=h+16|0;Q=h+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[Q>>2]|0)>0){c=f[h+40>>2]|0;I=0;do{f[c+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[Q>>2]|0))}Q=f[h+44>>2]|0;if((Q|0)!=(h+48|0))UC(Q);Mfb(l,1,z);Q=f[a+64>>2]|0;I=f[(f[Q>>2]|0)+40>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=k;c=i+8|0;f[c>>2]=0;f[c+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=l;c=m+8|0;f[c>>2]=0;f[c+4>>2]=0;f[m>>2]=33882112;f[m+4>>2]=e;th[I&511](Q,h,i,m);Mfb(k,1,B);Mfb(l,1,D);B=f[a+56>>2]|0;Q=f[(f[B>>2]|0)+40>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=k;I=i+8|0;f[I>>2]=0;f[I+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=l;I=m+8|0;f[I>>2]=0;f[I+4>>2]=0;f[m>>2]=33882112;f[m+4>>2]=e;th[Q&511](B,h,i,m);SL(k,4);B=f[k>>2]|0;if((B|0)!=(D|0)){Q=A+148|0;I=f[Q>>2]|0;if(I|0){c=I+12|0;f[c>>2]=(f[c>>2]|0)+1}c=B+36|0;I=f[c>>2]|0;if(I|0?(R=I+12|0,I=f[R>>2]|0,f[R>>2]=I+-1,(I|0)==1):0)kL(B);f[c>>2]=0;I=B+16|0;R=B+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[R>>2]|0)>0){O=f[B+40>>2]|0;P=0;do{f[O+(P<<2)>>2]=0;P=P+1|0;U=f[R>>2]|0}while((P|0)<(U|0));f[B>>2]=f[D>>2];if((U|0)<3)M=84;else M=86}else{f[B>>2]=f[D>>2];M=84}if((M|0)==84){U=f[A+116>>2]|0;if((U|0)<3){f[R>>2]=U;f[B+8>>2]=f[A+120>>2];f[B+12>>2]=f[A+124>>2];U=f[A+156>>2]|0;R=f[B+44>>2]|0;f[R>>2]=f[U>>2];f[R+4>>2]=f[U+4>>2]}else M=86}if((M|0)==86)jL(B,D);f[I>>2]=f[A+128>>2];f[B+20>>2]=f[A+132>>2];f[B+24>>2]=f[A+136>>2];f[B+28>>2]=f[A+140>>2];f[B+32>>2]=f[A+144>>2];f[c>>2]=f[Q>>2];Q=f[k>>2]|0;if((Q|0)==(A|0))V=A;else{W=Q;M=88}}else{W=D;M=88}if((M|0)==88){D=W+56|0;Q=A+92|0;c=f[Q>>2]|0;if(c|0){B=c+12|0;f[B>>2]=(f[B>>2]|0)+1}B=W+92|0;c=f[B>>2]|0;if(c|0?(I=c+12|0,c=f[I>>2]|0,f[I>>2]=c+-1,(c|0)==1):0)kL(D);f[B>>2]=0;c=W+72|0;I=W+60|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[I>>2]|0)>0){U=f[W+96>>2]|0;R=0;do{f[U+(R<<2)>>2]=0;R=R+1|0;X=f[I>>2]|0}while((R|0)<(X|0));f[D>>2]=f[z>>2];if((X|0)<3)M=98;else M=100}else{f[D>>2]=f[z>>2];M=98}if((M|0)==98){X=f[A+60>>2]|0;if((X|0)<3){f[I>>2]=X;f[W+64>>2]=f[A+64>>2];f[W+68>>2]=f[A+68>>2];X=f[A+100>>2]|0;I=f[W+100>>2]|0;f[I>>2]=f[X>>2];f[I+4>>2]=f[X+4>>2]}else M=100}if((M|0)==100)jL(D,z);f[c>>2]=f[A+72>>2];f[W+76>>2]=f[A+76>>2];f[W+80>>2]=f[A+80>>2];f[W+84>>2]=f[A+84>>2];f[W+88>>2]=f[A+88>>2];f[B>>2]=f[Q>>2];V=f[k>>2]|0}Q=V+112|0;if((Q|0)==(A|0))Z=V;else{B=A+36|0;W=f[B>>2]|0;if(W|0){c=W+12|0;f[c>>2]=(f[c>>2]|0)+1}c=V+148|0;W=f[c>>2]|0;if(W|0?(z=W+12|0,W=f[z>>2]|0,f[z>>2]=W+-1,(W|0)==1):0)kL(Q);f[c>>2]=0;W=V+128|0;z=V+116|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[z>>2]|0)>0){D=f[V+152>>2]|0;X=0;do{f[D+(X<<2)>>2]=0;X=X+1|0;_=f[z>>2]|0}while((X|0)<(_|0));f[Q>>2]=f[A>>2];if((_|0)<3)M=113;else M=115}else{f[Q>>2]=f[A>>2];M=113}do if((M|0)==113){_=f[A+4>>2]|0;if((_|0)>=3){M=115;break}f[z>>2]=_;f[V+120>>2]=f[A+8>>2];f[V+124>>2]=f[A+12>>2];_=f[A+44>>2]|0;X=f[V+156>>2]|0;f[X>>2]=f[_>>2];f[X+4>>2]=f[_+4>>2]}while(0);if((M|0)==115)jL(Q,A);f[W>>2]=f[A+16>>2];f[V+132>>2]=f[A+20>>2];f[V+136>>2]=f[A+24>>2];f[V+140>>2]=f[A+28>>2];f[V+144>>2]=f[A+32>>2];f[c>>2]=f[B>>2];Z=f[k>>2]|0}B=Z+168|0;if((B|0)!=(F|0)){c=a+108|0;A=f[c>>2]|0;if(A|0){V=A+12|0;f[V>>2]=(f[V>>2]|0)+1}V=Z+204|0;A=f[V>>2]|0;do if(A|0){W=A+12|0;Q=f[W>>2]|0;f[W>>2]=Q+-1;if((Q|0)!=1)break;kL(B)}while(0);f[V>>2]=0;A=Z+184|0;Q=Z+172|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[Q>>2]|0)>0){W=f[Z+208>>2]|0;z=0;do{f[W+(z<<2)>>2]=0;z=z+1|0;$=f[Q>>2]|0}while((z|0)<($|0));f[B>>2]=f[F>>2];if(($|0)<3)M=128;else M=130}else{f[B>>2]=f[F>>2];M=128}do if((M|0)==128){$=f[a+76>>2]|0;if(($|0)>=3){M=130;break}f[Q>>2]=$;f[Z+176>>2]=f[a+80>>2];f[Z+180>>2]=f[a+84>>2];$=f[a+116>>2]|0;z=f[Z+212>>2]|0;f[z>>2]=f[$>>2];f[z+4>>2]=f[$+4>>2]}while(0);if((M|0)==130)jL(B,F);f[A>>2]=f[a+88>>2];f[Z+188>>2]=f[a+92>>2];f[Z+192>>2]=f[a+96>>2];f[Z+196>>2]=f[a+100>>2];f[Z+200>>2]=f[a+104>>2];f[V>>2]=f[c>>2]}f[h>>2]=1124007936;c=h+4|0;V=h+8|0;Z=h+40|0;w=c;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[Z>>2]=V;A=h+48|0;F=h+44|0;f[F>>2]=A;f[A>>2]=0;f[h+52>>2]=0;B=f[l>>2]|0;Q=h+36|0;do if((B|0)!=(h|0)){$=B+36|0;z=f[$>>2]|0;do if(z|0){W=z+12|0;_=f[W>>2]|0;f[W>>2]=_+-1;if((_|0)!=1)break;kL(B)}while(0);f[$>>2]=0;z=B+16|0;_=B+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[_>>2]|0)>0){W=f[B+40>>2]|0;X=0;do{f[W+(X<<2)>>2]=0;X=X+1|0;aa=f[_>>2]|0}while((X|0)<(aa|0));f[B>>2]=f[h>>2];if((aa|0)<3)M=141;else M=143}else{f[B>>2]=f[h>>2];M=141}do if((M|0)==141){X=f[c>>2]|0;if((X|0)>=3){M=143;break}f[_>>2]=X;f[B+8>>2]=f[V>>2];f[B+12>>2]=f[h+12>>2];X=f[F>>2]|0;W=f[B+44>>2]|0;f[W>>2]=f[X>>2];f[W+4>>2]=f[X+4>>2]}while(0);if((M|0)==143)jL(B,h);f[z>>2]=f[h+16>>2];f[B+20>>2]=f[h+20>>2];f[B+24>>2]=f[h+24>>2];f[B+28>>2]=f[h+28>>2];f[B+32>>2]=f[h+32>>2];f[$>>2]=f[Q>>2];_=f[Q>>2]|0;if(!_)break;X=_+12|0;_=f[X>>2]|0;f[X>>2]=_+-1;if((_|0)!=1)break;kL(h)}while(0);f[Q>>2]=0;Q=h+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[c>>2]|0)>0){Q=f[Z>>2]|0;Z=0;do{f[Q+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[c>>2]|0))}c=f[F>>2]|0;if((c|0)!=(A|0))UC(c);c=f[a+48>>2]|0;A=f[(f[c>>2]|0)+40>>2]|0;f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=17104896;f[h+4>>2]=k;F=i+8|0;f[F>>2]=0;f[F+4>>2]=0;f[i>>2]=33882112;f[i+4>>2]=l;F=m+8|0;f[F>>2]=0;f[F+4>>2]=0;f[m>>2]=33882112;f[m+4>>2]=e;th[A&511](c,h,i,m);c=f[l>>2]|0;A=f[c+4>>2]|0;if((A|0)<3)ba=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{e=f[c+40>>2]|0;F=0;Z=1;while(1){Q=Y(f[e+(F<<2)>>2]|0,Z)|0;F=F+1|0;if((F|0)==(A|0)){ba=Q;break}else Z=Q}}Z=(ba>>>0)/7|0;ba=a+68|0;if(Z>>>0>(f[ba>>2]|0)>>>0){f[h>>2]=0;f[h+4>>2]=0;w=aD(h,26)|0;x=428859;y=w+26|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,h,443123,428536,207);bD(h);ca=f[l>>2]|0}else ca=c;WL(o,ca,1,Z);f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[i>>2]=3;f[i+4>>2]=7;lL(m,o,h,i);ca=o+36|0;c=f[ca>>2]|0;do if(c|0){x=c+12|0;w=f[x>>2]|0;f[x>>2]=w+-1;if((w|0)!=1)break;kL(o)}while(0);f[ca>>2]=0;ca=o+16|0;c=o+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[c>>2]|0)>0){ca=f[o+40>>2]|0;w=0;do{f[ca+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[c>>2]|0))}c=f[o+44>>2]|0;if((c|0)!=(o+48|0))UC(c);c=f[d>>2]|0;f[h>>2]=0;f[h+4>>2]=Z;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;lL(q,c,h,i);f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[i>>2]=1;f[i+4>>2]=5;lL(s,q,h,i);c=r+8|0;f[c>>2]=0;f[c+4>>2]=0;f[r>>2]=-1040121856;f[r+4>>2]=s;SP(m,r);r=s+36|0;c=f[r>>2]|0;do if(c|0){o=c+12|0;w=f[o>>2]|0;f[o>>2]=w+-1;if((w|0)!=1)break;kL(s)}while(0);f[r>>2]=0;r=s+16|0;c=s+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[c>>2]|0)>0){r=f[s+40>>2]|0;w=0;do{f[r+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[c>>2]|0))}c=f[s+44>>2]|0;if((c|0)!=(s+48|0))UC(c);f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[i>>2]=0;f[i+4>>2]=1;lL(t,q,h,i);p[i>>3]=0.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;VP(t,h,UM()|0)|0;c=t+36|0;s=f[c>>2]|0;do if(s|0){w=s+12|0;r=f[w>>2]|0;f[w>>2]=r+-1;if((r|0)!=1)break;kL(t)}while(0);f[c>>2]=0;c=t+16|0;s=t+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[s>>2]|0)>0){c=f[t+40>>2]|0;r=0;do{f[c+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[s>>2]|0))}s=f[t+44>>2]|0;if((s|0)!=(t+48|0))UC(s);s=f[ba>>2]|0;do if(Z>>>0<s>>>0){ba=f[d>>2]|0;f[h>>2]=Z;f[h+4>>2]=s;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;lL(v,ba,h,i);p[i>>3]=0.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;VP(v,h,UM()|0)|0;ba=v+36|0;t=f[ba>>2]|0;do if(t|0){r=t+12|0;c=f[r>>2]|0;f[r>>2]=c+-1;if((c|0)!=1)break;kL(v)}while(0);f[ba>>2]=0;t=v+16|0;$=v+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[$>>2]|0)>0){t=f[v+40>>2]|0;z=0;do{f[t+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[$>>2]|0))}$=f[v+44>>2]|0;if(($|0)==(v+48|0))break;UC($)}while(0);v=q+36|0;h=f[v>>2]|0;do if(h|0){i=h+12|0;s=f[i>>2]|0;f[i>>2]=s+-1;if((s|0)!=1)break;kL(q)}while(0);f[v>>2]=0;v=q+16|0;h=q+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[h>>2]|0)>0){v=f[q+40>>2]|0;s=0;do{f[v+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[h>>2]|0))}h=f[q+44>>2]|0;if((h|0)!=(q+48|0))UC(h);h=m+36|0;q=f[h>>2]|0;do if(q|0){s=q+12|0;v=f[s>>2]|0;f[s>>2]=v+-1;if((v|0)!=1)break;kL(m)}while(0);f[h>>2]=0;h=m+16|0;q=m+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[q>>2]|0)>0){h=f[m+40>>2]|0;v=0;do{f[h+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[q>>2]|0))}q=f[m+44>>2]|0;if((q|0)!=(m+48|0))UC(q);et(l);et(k);if(!(f[j+4>>2]|0)){u=g;return}u=g;return}function Jfb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,122636);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Kfb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+80|0;h=d+64|0;i=d+48|0;j=d+36|0;k=d+24|0;l=d+12|0;m=d;n=f[c>>2]|0;if(((f[c+4>>2]|0)-n|0)==36)o=n;else{f[h>>2]=0;f[h+4>>2]=0;p=aD(h,18)|0;q=428517;r=p+18|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,442770,428536,94);bD(h);o=f[c>>2]|0}c=o+12|0;f[i>>2]=0;n=i+4|0;f[n>>2]=0;f[i+8>>2]=0;f[j>>2]=0;s=j+4|0;f[s>>2]=0;f[j+8>>2]=0;f[k>>2]=0;t=k+4|0;f[t>>2]=0;f[k+8>>2]=0;Aua(i,1,o);v=f[a+40>>2]|0;nh[f[(f[v>>2]|0)+84>>2]&127](v,i,1,j,k)|0;if(((f[s>>2]|0)-(f[j>>2]|0)|0)!=12){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,24)|0;q=428618;r=p+24|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,442770,428536,104);bD(h)}if((f[k>>2]|0)!=(f[t>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,22)|0;q=428643;r=p+22|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,442770,428536,105);bD(h)}v=f[j>>2]|0;w=g+4|0;x=f[w>>2]|0;y=g+8|0;if((x|0)==(f[y>>2]|0))Sva(g,v);else{Bua(x,v);f[w>>2]=(f[w>>2]|0)+12}if(((f[o+4>>2]|0)-(f[o>>2]|0)|0)!=16){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,18)|0;q=428666;r=p+18|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,442770,428536,109);bD(h)}Bua(l,o);if(f[(f[o>>2]|0)+4>>2]&1|0){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,20)|0;q=428685;r=p+20|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,442770,428536,111);bD(h)}o=(f[l>>2]|0)+4|0;f[o>>2]=(f[o>>2]|0)/2|0;Aua(i,1,l);o=f[a+64>>2]|0;nh[f[(f[o>>2]|0)+84>>2]&127](o,i,1,j,k)|0;if(((f[s>>2]|0)-(f[j>>2]|0)|0)!=12){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,24)|0;q=428618;r=p+24|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,442770,428536,115);bD(h)}if((f[k>>2]|0)!=(f[t>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,22)|0;q=428643;r=p+22|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,442770,428536,116);bD(h)}o=f[j>>2]|0;v=f[w>>2]|0;if((v|0)==(f[y>>2]|0))Sva(g,o);else{Bua(v,o);f[w>>2]=(f[w>>2]|0)+12}Aua(i,1,c);c=f[a+56>>2]|0;nh[f[(f[c>>2]|0)+84>>2]&127](c,i,1,j,k)|0;if(((f[s>>2]|0)-(f[j>>2]|0)|0)!=12){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,24)|0;q=428618;r=p+24|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,442770,428536,122);bD(h)}if((f[k>>2]|0)!=(f[t>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,22)|0;q=428643;r=p+22|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,442770,428536,123);bD(h)}q=f[j>>2]|0;p=f[w>>2]|0;if((p|0)==(f[y>>2]|0))Sva(g,q);else{Bua(p,q);f[w>>2]=(f[w>>2]|0)+12}f[h>>2]=f[a+68>>2];f[h+4>>2]=5;f[h+8>>2]=-1;f[h+12>>2]=-1;f[m>>2]=0;a=m+4|0;f[a>>2]=0;f[m+8>>2]=0;Rva(m,h,h+16|0);h=f[m>>2]|0;w=f[a>>2]|0;a:do if((h|0)==(w|0)){z=h;A=32}else{q=h;do{if((f[q>>2]|0)<0){z=q;A=32;break a}q=q+4|0}while((q|0)!=(w|0))}while(0);if((A|0)==32?(z|0)!=(w|0):0){A=z+4|0;if((A|0)==(w|0)){B=w;C=z}else{h=A;A=z;while(1){z=f[h>>2]|0;if((z|0)<0)D=A;else{f[A>>2]=z;D=A+4|0}h=h+4|0;if((h|0)==(w|0))break;else A=D}B=f[a>>2]|0;C=D}if((C|0)!=(B|0))f[a>>2]=B+(~((B+-4-C|0)>>>2)<<2)}C=e+4|0;B=f[C>>2]|0;D=f[e>>2]|0;A=B-D|0;w=(A|0)/12|0;h=D;D=B;if(A){if(w>>>0>1?(A=h+12|0,(D|0)!=(A|0)):0){h=D;while(1){D=h+-12|0;f[C>>2]=D;B=f[D>>2]|0;if(!B)E=D;else{D=h+-8|0;z=f[D>>2]|0;if((z|0)!=(B|0))f[D>>2]=z+(~((z+-4-B|0)>>>2)<<2);O5b(B);E=f[C>>2]|0}if((E|0)==(A|0))break;else h=E}}}else sbb(e,1-w|0,m);w=f[m>>2]|0;if(w|0){m=f[a>>2]|0;if((m|0)!=(w|0))f[a>>2]=m+(~((m+-4-w|0)>>>2)<<2);O5b(w)}w=f[l>>2]|0;if(w|0){m=l+4|0;l=f[m>>2]|0;if((l|0)!=(w|0))f[m>>2]=l+(~((l+-4-w|0)>>>2)<<2);O5b(w)}w=f[k>>2]|0;if(w|0){l=f[t>>2]|0;if((l|0)==(w|0))F=w;else{m=l;while(1){l=m+-12|0;f[t>>2]=l;a=f[l>>2]|0;if(!a)G=l;else{l=m+-8|0;e=f[l>>2]|0;if((e|0)!=(a|0))f[l>>2]=e+(~((e+-4-a|0)>>>2)<<2);O5b(a);G=f[t>>2]|0}if((G|0)==(w|0))break;else m=G}F=f[k>>2]|0}O5b(F)}F=f[j>>2]|0;if(F|0){k=f[s>>2]|0;if((k|0)==(F|0))H=F;else{G=k;while(1){k=G+-12|0;f[s>>2]=k;m=f[k>>2]|0;if(!m)I=k;else{k=G+-8|0;w=f[k>>2]|0;if((w|0)!=(m|0))f[k>>2]=w+(~((w+-4-m|0)>>>2)<<2);O5b(m);I=f[s>>2]|0}if((I|0)==(F|0))break;else G=I}H=f[j>>2]|0}O5b(H)}H=f[i>>2]|0;if(!H){u=d;return 0}j=f[n>>2]|0;if((j|0)==(H|0))J=H;else{I=j;while(1){j=I+-12|0;f[n>>2]=j;G=f[j>>2]|0;if(!G)K=j;else{j=I+-8|0;F=f[j>>2]|0;if((F|0)!=(G|0))f[j>>2]=F+(~((F+-4-G|0)>>>2)<<2);O5b(G);K=f[n>>2]|0}if((K|0)==(H|0))break;else I=K}J=f[i>>2]|0}O5b(J);u=d;return 0}function Lfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+256|0;e=d;g=c+4|0;if((f[g>>2]|0)!=4){f[e>>2]=0;f[e+4>>2]=0;h=aD(e,11)|0;i=428886;j=h+11|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-215,e,428898,428536,222);bD(e)}k=c+40|0;l=f[k>>2]|0;if((f[l>>2]|0)==1)m=l;else{f[e>>2]=0;f[e+4>>2]=0;h=aD(e,14)|0;i=428914;j=h+14|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-215,e,428898,428536,223);bD(e);m=f[k>>2]|0}k=f[m+4>>2]|0;if(k&1|0){f[e>>2]=0;f[e+4>>2]=0;h=aD(e,19)|0;i=428929;j=h+19|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-215,e,428898,428536,225);bD(e)}m=(k|0)/2|0;l=f[g>>2]|0;if((l|0)>1)n=l;else{f[e>>2]=0;f[e+4>>2]=0;h=aD(e,11)|0;i=434484;j=h+11|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-215,e,434496,442663,78);bD(e);n=f[g>>2]|0}Nac(e|0,0,256)|0;if((n|0)>2)o=2;else{p=e;q=p;f[q>>2]=-2147483648;r=p+4|0;s=r;f[s>>2]=2147483647;t=e+8|0;v=t;w=v;f[w>>2]=m;x=v+4|0;y=x;f[y>>2]=k;mL(a,c,e);u=d;return}do{g=e+(o<<3)|0;f[g>>2]=-2147483648;f[g+4>>2]=2147483647;o=o+1|0}while((o|0)!=(n|0));p=e;q=p;f[q>>2]=-2147483648;r=p+4|0;s=r;f[s>>2]=2147483647;t=e+8|0;v=t;w=v;f[w>>2]=m;x=v+4|0;y=x;f[y>>2]=k;mL(a,c,e);u=d;return}function Mfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=a+8|0;e=f[a>>2]|0;g=e;if((((f[d>>2]|0)-e|0)/56|0)>>>0<b>>>0){dwa(a);if(b>>>0>76695844)c4b(a);h=((f[d>>2]|0)-(f[a>>2]|0)|0)/56|0;i=h<<1;j=h>>>0<38347922?(i>>>0<b>>>0?b:i):76695844;if(j>>>0>76695844)c4b(a);i=L5b(j*56|0)|0;h=a+4|0;f[h>>2]=i;f[a>>2]=i;f[d>>2]=i+(j*56|0);j=c+4|0;d=c+8|0;k=c+12|0;l=c+16|0;m=c+20|0;n=c+24|0;o=c+28|0;p=c+32|0;q=c+36|0;r=c+44|0;s=b;t=i;do{f[t>>2]=f[c>>2];i=t+4|0;f[i>>2]=f[j>>2];u=t+8|0;f[u>>2]=f[d>>2];f[t+12>>2]=f[k>>2];f[t+16>>2]=f[l>>2];f[t+20>>2]=f[m>>2];f[t+24>>2]=f[n>>2];f[t+28>>2]=f[o>>2];f[t+32>>2]=f[p>>2];v=f[q>>2]|0;f[t+36>>2]=v;f[t+40>>2]=u;u=t+48|0;w=t+44|0;f[w>>2]=u;f[u>>2]=0;f[t+52>>2]=0;if(v|0){u=v+12|0;f[u>>2]=(f[u>>2]|0)+1}if((f[j>>2]|0)<3){u=f[r>>2]|0;v=f[w>>2]|0;f[v>>2]=f[u>>2];f[v+4>>2]=f[u+4>>2]}else{f[i>>2]=0;jL(t,c)}t=(f[h>>2]|0)+56|0;f[h>>2]=t;s=s+-1|0}while((s|0)!=0);return}s=a+4|0;t=((f[s>>2]|0)-e|0)/56|0;e=t>>>0<b>>>0;h=e?t:b;if(h|0){r=c+36|0;j=c+4|0;q=c+8|0;p=c+12|0;o=c+44|0;n=c+16|0;m=c+20|0;l=c+24|0;k=c+28|0;d=c+32|0;i=h;h=g;while(1){if((h|0)!=(c|0)){g=f[r>>2]|0;if(g|0){u=g+12|0;f[u>>2]=(f[u>>2]|0)+1}u=h+36|0;g=f[u>>2]|0;if(g|0?(v=g+12|0,g=f[v>>2]|0,f[v>>2]=g+-1,(g|0)==1):0)kL(h);f[u>>2]=0;g=h+16|0;v=h+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[v>>2]|0)>0){w=f[h+40>>2]|0;x=0;do{f[w+(x<<2)>>2]=0;x=x+1|0;y=f[v>>2]|0}while((x|0)<(y|0));f[h>>2]=f[c>>2];if((y|0)<3)z=15;else z=17}else{f[h>>2]=f[c>>2];z=15}if((z|0)==15){z=0;x=f[j>>2]|0;if((x|0)<3){f[v>>2]=x;f[h+8>>2]=f[q>>2];f[h+12>>2]=f[p>>2];x=f[o>>2]|0;w=f[h+44>>2]|0;f[w>>2]=f[x>>2];f[w+4>>2]=f[x+4>>2]}else z=17}if((z|0)==17){z=0;jL(h,c)}f[g>>2]=f[n>>2];f[h+20>>2]=f[m>>2];f[h+24>>2]=f[l>>2];f[h+28>>2]=f[k>>2];f[h+32>>2]=f[d>>2];f[u>>2]=f[r>>2]}i=i+-1|0;if(!i)break;else h=h+56|0}}if(e){e=c+4|0;h=c+8|0;i=c+12|0;r=c+16|0;d=c+20|0;k=c+24|0;l=c+28|0;m=c+32|0;n=c+36|0;z=c+44|0;o=b-t|0;t=f[s>>2]|0;do{f[t>>2]=f[c>>2];p=t+4|0;f[p>>2]=f[e>>2];q=t+8|0;f[q>>2]=f[h>>2];f[t+12>>2]=f[i>>2];f[t+16>>2]=f[r>>2];f[t+20>>2]=f[d>>2];f[t+24>>2]=f[k>>2];f[t+28>>2]=f[l>>2];f[t+32>>2]=f[m>>2];j=f[n>>2]|0;f[t+36>>2]=j;f[t+40>>2]=q;q=t+48|0;y=t+44|0;f[y>>2]=q;f[q>>2]=0;f[t+52>>2]=0;if(j|0){q=j+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[e>>2]|0)<3){q=f[z>>2]|0;j=f[y>>2]|0;f[j>>2]=f[q>>2];f[j+4>>2]=f[q+4>>2]}else{f[p>>2]=0;jL(t,c)}t=(f[s>>2]|0)+56|0;f[s>>2]=t;o=o+-1|0}while((o|0)!=0);return}o=(f[a>>2]|0)+(b*56|0)|0;b=f[s>>2]|0;if((b|0)==(o|0))return;else A=b;do{b=A+-56|0;f[s>>2]=b;a=A+-20|0;t=f[a>>2]|0;if(t|0?(c=t+12|0,t=f[c>>2]|0,f[c>>2]=t+-1,(t|0)==1):0)kL(b);f[a>>2]=0;a=A+-40|0;b=A+-52|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[b>>2]|0)>0){a=f[A+-16>>2]|0;t=0;do{f[a+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[b>>2]|0))}b=f[A+-12>>2]|0;if((b|0)!=(A+-8|0))UC(b);A=f[s>>2]|0}while((A|0)!=(o|0));return}function Nfb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;if(e-g>>2>>>0<b>>>0){i=g;if(!g)j=e;else{e=a+4|0;k=f[e>>2]|0;if((k|0)!=(h|0))f[e>>2]=k+(~((k+-4-g|0)>>>2)<<2);O5b(i);f[d>>2]=0;f[e>>2]=0;f[a>>2]=0;j=0}if(b>>>0>1073741823)c4b(a);e=j>>1;i=j>>2>>>0<536870911?(e>>>0<b>>>0?b:e):1073741823;if(i>>>0>1073741823)c4b(a);e=L5b(i<<2)|0;j=a+4|0;f[j>>2]=e;f[a>>2]=e;f[d>>2]=e+(i<<2);i=b;d=e;do{f[d>>2]=f[c>>2];d=(f[j>>2]|0)+4|0;f[j>>2]=d;i=i+-1|0}while((i|0)!=0);return}else{i=a+4|0;d=(f[i>>2]|0)-g>>2;g=d>>>0<b>>>0;j=g?d:b;if(j|0){e=j;j=h;while(1){f[j>>2]=f[c>>2];e=e+-1|0;if(!e)break;else j=j+4|0}}if(g){g=b-d|0;d=f[i>>2]|0;do{f[d>>2]=f[c>>2];d=(f[i>>2]|0)+4|0;f[i>>2]=d;g=g+-1|0}while((g|0)!=0);return}g=(f[a>>2]|0)+(b<<2)|0;b=f[i>>2]|0;if((b|0)==(g|0))return;f[i>>2]=b+(~((b+-4-g|0)>>>2)<<2);return}}function Ofb(a,b){a=a|0;b=b|0;var c=0;c=L5b(56)|0;Pfb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=122708;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Pfb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;Jwa(a);g=a+36|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[a>>2]=122728;Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,4)|0;b[g>>0]=97;b[g+1>>0]=120;b[g+2>>0]=105;b[g+3>>0]=115;g=c+4|0;h=f[g>>2]|0;do if(h){i=f[e>>2]|0;j=(i|0)==0?1124530:i;k=g;l=h;a:while(1){m=l;while(1){n=f[m+16>>2]|0;if((n|0)==(i|0))break;if((gTb((n|0)==0?1124530:n,j)|0)>=0)break;n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(g|0)){k=f[o+16>>2]|0;if((i|0)!=(k|0)?(gTb(j,(k|0)==0?1124530:k)|0)<=-1:0){p=0;break}k=Gwa(o+24|0,-1)|0;p=k}else p=0}else p=0;while(0);bD(e);f[e>>2]=0;f[e+4>>2]=0;o=aD(e,8)|0;h=o;b[h>>0]=110;b[h+1>>0]=117;b[h+2>>0]=109;b[h+3>>0]=95;h=o+4|0;b[h>>0]=97;b[h+1>>0]=120;b[h+2>>0]=101;b[h+3>>0]=115;h=f[g>>2]|0;do if(h){o=f[e>>2]|0;k=(o|0)==0?1124530:o;l=g;n=h;b:while(1){q=n;while(1){r=f[q+16>>2]|0;if((r|0)==(o|0))break;if((gTb((r|0)==0?1124530:r,k)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=l;break b}else q=r}n=f[q>>2]|0;if(!n){s=q;break}else l=q}if((s|0)!=(g|0)){l=f[s+16>>2]|0;if((o|0)!=(l|0)?(gTb(k,(l|0)==0?1124530:l)|0)<=-1:0){t=-1;break}l=Gwa(s+24|0,-1)|0;t=l}else t=-1}else t=-1;while(0);bD(e);if((t|0)>-2)if((t|0)==-1)v=2147483647;else w=26;else{f[e>>2]=0;f[e+4>>2]=0;s=aD(e,13)|0;h=429237;l=s+13|0;do{b[s>>0]=b[h>>0]|0;s=s+1|0;h=h+1|0}while((s|0)<(l|0));bO(-215,e,429251,429268,154);bD(e);w=26}if((w|0)==26)v=t+p|0;t=a+48|0;f[t>>2]=p;f[t+4>>2]=v;v=a+36|0;t=f[v>>2]|0;p=a+40|0;a=f[p>>2]|0;if((a|0)!=(t|0))f[p>>2]=a+(~((a+-4-t|0)>>>2)<<2);f[e>>2]=0;f[e+4>>2]=0;t=aD(e,3)|0;b[t>>0]=b[429349]|0;b[t+1>>0]=b[429350]|0;b[t+2>>0]=b[429351]|0;t=f[g>>2]|0;if(!t){bD(e);u=d;return}g=f[e>>2]|0;a=(g|0)==0?1124530:g;h=t;while(1){t=f[h+16>>2]|0;if((g|0)==(t|0)){w=37;break}s=(t|0)==0?1124530:t;if((gTb(a,s)|0)<0)x=h;else{if((gTb(s,a)|0)>=0){w=38;break}x=h+4|0}h=f[x>>2]|0;if(!h){w=52;break}}if((w|0)==37)bD(e);else if((w|0)==38)bD(e);else if((w|0)==52){bD(e);u=d;return}f[e>>2]=0;f[e+4>>2]=0;w=aD(e,3)|0;b[w>>0]=b[429349]|0;b[w+1>>0]=b[429350]|0;b[w+2>>0]=b[429351]|0;w=Eya(c,e)|0;bD(e);switch(f[w>>2]|0){case 0:{y=f[(f[w+4>>2]|0)+4>>2]|0;break}case 3:{y=f[(f[w+4>>2]|0)+4>>2]|0;break}case 2:{y=f[(f[w+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);y=-1}}e=f[p>>2]|0;c=f[v>>2]|0;h=e-c>>2;x=c;c=e;if(y>>>0<=h>>>0){if(y>>>0<h>>>0?(e=x+(y<<2)|0,(c|0)!=(e|0)):0)f[p>>2]=c+(~((c+-4-e|0)>>>2)<<2)}else HC(v,y-h|0);if((y|0)>0)z=0;else{u=d;return}do{h=Gwa(w,z)|0;f[(f[v>>2]|0)+(z<<2)>>2]=h;z=z+1|0}while((z|0)<(y|0));u=d;return}function Qfb(a){a=a|0;O5b(a);return}function Rfb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Sfb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=122828;b=f[a+36>>2]|0;if(!b){lua(a);return}c=a+40|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);lua(a);return}function Tfb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=122828;b=f[a+36>>2]|0;if(!b){lua(a);O5b(a);return}c=a+40|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);lua(a);O5b(a);return}function Ufb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=122828;b=f[a+36>>2]|0;if(!b){lua(a);O5b(a);return}c=a+40|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);lua(a);O5b(a);return}function Vfb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=u;u=u+160|0;a=d+144|0;e=d+88|0;g=d+16|0;h=d+72|0;i=d;dQ(a,122952);j=b+4|0;k=f[b>>2]|0;if((f[j>>2]|0)!=(k|0)){l=e+4|0;m=e+8|0;n=e+12|0;o=e+16|0;p=e+20|0;q=e+24|0;r=e+28|0;s=e+32|0;t=e+36|0;v=e+40|0;w=e+48|0;x=e+44|0;y=e+52|0;z=h+4|0;A=h+8|0;B=i+8|0;C=i+4|0;D=g+36|0;E=g+16|0;F=g+4|0;G=g+40|0;H=g+44|0;I=g+48|0;J=0;K=k;do{k=f[K+(J<<2)>>2]|0;f[e>>2]=f[k>>2];L=k+4|0;f[l>>2]=f[L>>2];f[m>>2]=f[k+8>>2];f[n>>2]=f[k+12>>2];f[o>>2]=f[k+16>>2];f[p>>2]=f[k+20>>2];f[q>>2]=f[k+24>>2];f[r>>2]=f[k+28>>2];f[s>>2]=f[k+32>>2];M=f[k+36>>2]|0;f[t>>2]=M;f[v>>2]=m;f[x>>2]=w;f[w>>2]=0;f[y>>2]=0;if(M|0){N=M+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[L>>2]|0)<3){L=f[k+44>>2]|0;N=f[x>>2]|0;f[N>>2]=f[L>>2];f[N+4>>2]=f[L+4>>2]}else{f[l>>2]=0;jL(e,k)}k=f[c>>2]|0;if((f[k+(J*56|0)+16>>2]|0)!=(f[o>>2]|0)){L=f[k+(J*56|0)+4>>2]|0;N=f[k+(J*56|0)+40>>2]|0;f[h>>2]=0;f[z>>2]=0;f[A>>2]=0;Rva(h,N,N+(L<<2)|0);PN(g,e,1,h);L=(f[c>>2]|0)+(J*56|0)|0;N=B;f[N>>2]=0;f[N+4>>2]=0;f[i>>2]=33619968;f[C>>2]=L;SP(g,i);L=f[D>>2]|0;if(L|0?(N=L+12|0,L=f[N>>2]|0,f[N>>2]=L+-1,(L|0)==1):0)kL(g);f[D>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[F>>2]|0)>0){L=f[G>>2]|0;N=0;do{f[L+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[F>>2]|0))}N=f[H>>2]|0;if((N|0)!=(I|0))UC(N);N=f[h>>2]|0;if(N|0){L=f[z>>2]|0;if((L|0)!=(N|0))f[z>>2]=L+(~((L+-4-N|0)>>>2)<<2);O5b(N)}}N=f[t>>2]|0;if(N|0?(L=N+12|0,N=f[L>>2]|0,f[L>>2]=N+-1,(N|0)==1):0)kL(e);f[t>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[l>>2]|0)>0){N=f[v>>2]|0;L=0;do{f[N+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[l>>2]|0))}L=f[x>>2]|0;if((L|0)!=(w|0))UC(L);J=J+1|0;K=f[b>>2]|0}while(J>>>0<(f[j>>2]|0)-K>>2>>>0)}if(!(f[a+4>>2]|0)){u=d;return}u=d;return}function Wfb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,122920);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Xfb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;d=u;u=u+16|0;h=d;i=d+4|0;j=f[e>>2]|0;k=e+4|0;l=f[k>>2]|0;if((l|0)!=(j|0)){m=l;while(1){l=m+-12|0;f[k>>2]=l;n=f[l>>2]|0;if(!n)o=l;else{l=m+-8|0;p=f[l>>2]|0;if((p|0)!=(n|0))f[l>>2]=p+(~((p+-4-n|0)>>>2)<<2);O5b(n);o=f[k>>2]|0}if((o|0)==(j|0))break;else m=o}}o=c+4|0;a:do if((f[o>>2]|0)!=(f[c>>2]|0)){m=i+4|0;n=i+8|0;p=e+8|0;l=a+36|0;q=a+48|0;r=a+40|0;s=i+4|0;t=i+4|0;v=i+4|0;w=i+4|0;x=i+4|0;y=i+4|0;z=i+4|0;A=i+4|0;B=i+4|0;C=0;D=j;while(1){f[i>>2]=0;f[m>>2]=0;f[n>>2]=0;if((D|0)==(f[p>>2]|0)){Sva(e,i);E=f[i>>2]|0}else{f[D>>2]=0;F=D+4|0;f[F>>2]=0;f[D+8>>2]=0;G=f[i>>2]|0;H=(f[m>>2]|0)-G|0;I=H>>2;if(I){if(I>>>0>1073741823)break;J=L5b(H)|0;f[F>>2]=J;f[D>>2]=J;f[D+8>>2]=J+(I<<2);I=f[i>>2]|0;H=(f[m>>2]|0)-I|0;if((H|0)>0){Vac(J|0,I|0,H|0)|0;f[F>>2]=J+(H>>>2<<2);K=I}else K=I}else K=G;f[k>>2]=(f[k>>2]|0)+12;E=K}if(E|0){G=f[m>>2]|0;if((G|0)!=(E|0))f[m>>2]=G+(~((G+-4-E|0)>>>2)<<2);O5b(E)}G=f[c>>2]|0;I=G+(C*12|0)|0;H=q;J=f[H>>2]|0;F=f[H+4>>2]|0;H=f[k>>2]|0;L=H+-12|0;M=G+(C*12|0)+4|0;G=(f[M>>2]|0)-(f[I>>2]|0)>>2;N=f[r>>2]|0;O=f[l>>2]|0;P=N-O|0;Q=P>>2;R=(F|0)==2147483647;S=O;O=N;N=(J|0)<0?G:0;T=(J|0)==-2147483648&R?0:N+J|0;J=R?G:N+F|0;F=(S|0)!=(O|0);N=(P|0)>0;if(N&F){R=0;do{U=(f[S+(R<<2)>>2]|0)>0;R=R+1|0}while((R|0)<(Q|0)&U);V=U}else V=F;if(V){if((S|0)!=(O|0)){if((P|0)<0){f[i>>2]=0;f[t>>2]=0;W=aD(i,70)|0;X=442586;Z=W+70|0;do{b[W>>0]=b[X>>0]|0;W=W+1|0;X=X+1|0}while((W|0)<(Z|0));bO(-215,i,442657,442663,160);bD(i)}if(N){P=f[l>>2]|0;O=1;S=0;while(1){F=Y(f[P+(S<<2)>>2]|0,O)|0;S=S+1|0;if((S|0)==(Q|0)){_=F;break}else O=F}}else _=1}else _=0;b:do if((J|0)>(T|0)){O=0;S=J;while(1){P=S;S=S+-1|0;if(O){if(!S){$=1;break b}if((Yfb(I,S,J)|0)==(_|0))aa=1;else{$=P;break b}}else aa=(Yfb(I,S,J)|0)==(_|0);if((S|0)<=(T|0)){$=T;break}else O=aa}}else $=T;while(0);if((Yfb(I,$,J)|0)==(_|0))ba=$;else{f[i>>2]=0;f[s>>2]=0;W=aD(i,58)|0;X=429487;Z=W+58|0;do{b[W>>0]=b[X>>0]|0;W=W+1|0;X=X+1|0}while((W|0)<(Z|0));bO(-215,i,429546,429268,95);bD(i);ba=$}}else ba=T;if(!((ba|0)>-1?!((J|0)>(G|0)|(ba|0)>(J|0)):0)){f[i>>2]=0;f[v>>2]=0;W=aD(i,85)|0;X=429572;Z=W+85|0;do{b[W>>0]=b[X>>0]|0;W=W+1|0;X=X+1|0}while((W|0)<(Z|0));bO(-215,i,429546,429268,98);bD(i)}T=Q+G-J+ba|0;O=H+-8|0;S=f[O>>2]|0;P=f[L>>2]|0;F=S-P>>2;R=P;P=S;if(T>>>0<=F>>>0){if(T>>>0<F>>>0?(S=R+(T<<2)|0,(P|0)!=(S|0)):0)f[O>>2]=P+(~((P+-4-S|0)>>>2)<<2)}else HC(L,T-F|0);F=f[I>>2]|0;T=F+(ba<<2)|0;S=F;if(ba|0){P=f[L>>2]|0;R=F;while(1){f[P>>2]=f[R>>2];R=R+4|0;if((R|0)==(T|0))break;else P=P+4|0}}P=F+(G<<2)|0;if((J|0)!=(G|0)){T=(f[L>>2]|0)+(ba<<2)+(Q<<2)|0;R=F+(J<<2)|0;while(1){f[T>>2]=f[R>>2];R=R+4|0;if((R|0)==(P|0))break;else T=T+4|0}}if(N){T=0;P=-1;while(1){R=f[(f[l>>2]|0)+(T<<2)>>2]|0;c:do if((R|0)>0){f[(f[L>>2]|0)+(T+ba<<2)>>2]=R;ca=P}else switch(R|0){case 0:{J=T+ba|0;if((J|0)>=(G|0)){f[h>>2]=J;hO(i,429658,h);bO(-5,i,429546,429268,115);bD(i)}f[(f[L>>2]|0)+(J<<2)>>2]=f[(f[I>>2]|0)+(J<<2)>>2];ca=P;break c;break}case -1:{if((P|0)!=-1){f[i>>2]=0;f[x>>2]=0;W=aD(i,50)|0;X=429727;Z=W+50|0;do{b[W>>0]=b[X>>0]|0;W=W+1|0;X=X+1|0}while((W|0)<(Z|0));bO(-215,i,429546,429268,121);bD(i)}J=T+ba|0;f[(f[L>>2]|0)+(J<<2)>>2]=1;ca=J;break c;break}default:{f[i>>2]=0;f[w>>2]=0;W=aD(i,18)|0;X=429778;Z=W+18|0;do{b[W>>0]=b[X>>0]|0;W=W+1|0;X=X+1|0}while((W|0)<(Z|0));bO(-5,i,429546,429268,126);bD(i);ca=P;break c}}while(0);T=T+1|0;if((T|0)>=(Q|0))break;else P=ca}P=f[I>>2]|0;da=ca;ea=P;fa=P}else{da=-1;ea=S;fa=F}P=f[M>>2]|0;Q=P-ea|0;T=Q>>2;do if((ea|0)!=(P|0)){if((Q|0)<0){f[i>>2]=0;f[B>>2]=0;W=aD(i,70)|0;X=442586;Z=W+70|0;do{b[W>>0]=b[X>>0]|0;W=W+1|0;X=X+1|0}while((W|0)<(Z|0));bO(-215,i,442657,442663,160);bD(i);ga=1;break}if(!Q)ga=1;else{G=1;N=0;while(1){R=Y(f[fa+(N<<2)>>2]|0,G)|0;N=N+1|0;if((N|0)==(T|0)){ga=R;break}else G=R}}}else ga=0;while(0);T=f[O>>2]|0;Q=f[L>>2]|0;P=T-Q|0;M=P>>2;F=Q;do if((F|0)!=(T|0)){if((P|0)<0){f[i>>2]=0;f[A>>2]=0;W=aD(i,70)|0;X=442586;Z=W+70|0;do{b[W>>0]=b[X>>0]|0;W=W+1|0;X=X+1|0}while((W|0)<(Z|0));bO(-215,i,442657,442663,160);bD(i);ha=1;break}if(!P)ha=1;else{Q=1;S=0;while(1){I=Y(f[F+(S<<2)>>2]|0,Q)|0;S=S+1|0;if((S|0)==(M|0)){ha=I;break}else Q=I}}}else ha=0;while(0);if((da|0)==-1){if((ga|0)!=(ha|0)){f[i>>2]=0;f[y>>2]=0;W=aD(i,20)|0;X=429829;Z=W+20|0;do{b[W>>0]=b[X>>0]|0;W=W+1|0;X=X+1|0}while((W|0)<(Z|0));bO(-215,i,429546,429268,141);bD(i)}}else{if((ga>>>0)%(ha>>>0)|0|0){f[i>>2]=0;f[z>>2]=0;W=aD(i,31)|0;X=429797;Z=W+31|0;do{b[W>>0]=b[X>>0]|0;W=W+1|0;X=X+1|0}while((W|0)<(Z|0));bO(-1,i,429546,429268,135);bD(i)}f[(f[L>>2]|0)+(da<<2)>>2]=(ga>>>0)/(ha>>>0)|0}M=C+1|0;if(M>>>0>=(((f[o>>2]|0)-(f[c>>2]|0)|0)/12|0)>>>0)break a;C=M;D=f[k>>2]|0}c4b(D)}while(0);if((g|0)==(e|0)){u=d;return 1}xwa(g,f[e>>2]|0,f[k>>2]|0);u=d;return 1}function Yfb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e;h=(c|0)==-1?0:c;if((d|0)==-1){c=f[a+4>>2]|0;i=f[a>>2]|0;j=c-i>>2;k=a;l=i;m=c;n=i;o=c}else{c=f[a>>2]|0;i=f[a+4>>2]|0;j=d;k=a;l=c;m=i;n=c;o=i}if((l|0)==(m|0)){p=0;u=e;return p|0}m=o-n>>2;if(!((h|0)<=(m|0)?!((h|0)>(j|0)|(j|0)>(m|0)):0)){f[g>>2]=0;f[g+4>>2]=0;m=aD(g,70)|0;n=442586;o=m+70|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,g,442657,442663,160);bD(g)}if((h|0)>=(j|0)){p=1;u=e;return p|0}g=f[k>>2]|0;k=1;n=h;while(1){h=Y(f[g+(n<<2)>>2]|0,k)|0;n=n+1|0;if((n|0)==(j|0)){p=h;break}else k=h}u=e;return p|0}function Zfb(a,b){a=a|0;b=b|0;var c=0;c=L5b(64)|0;_fb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=122992;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function _fb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0.0;d=u;u=u+16|0;e=d;Jwa(a);f[a>>2]=123012;Kwa(a,c);if(((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)!=56){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,17)|0;h=430177;i=g+17|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-215,e,430195,430211,64);bD(e)}f[e>>2]=0;f[e+4>>2]=0;j=aD(e,6)|0;b[j>>0]=b[430291]|0;b[j+1>>0]=b[430292]|0;b[j+2>>0]=b[430293]|0;b[j+3>>0]=b[430294]|0;b[j+4>>0]=b[430295]|0;b[j+5>>0]=b[430296]|0;j=c+4|0;c=f[j>>2]|0;do if(c){k=f[e>>2]|0;l=(k|0)==0?1124530:k;m=j;o=c;a:while(1){p=o;while(1){q=f[p+16>>2]|0;if((q|0)==(k|0))break;if((gTb((q|0)==0?1124530:q,l)|0)>=0)break;q=f[p+4>>2]|0;if(!q){r=m;break a}else p=q}o=f[p>>2]|0;if(!o){r=p;break}else m=p}if((r|0)!=(j|0)){m=f[r+16>>2]|0;if((k|0)!=(m|0)?(gTb(l,(m|0)==0?1124530:m)|0)<=-1:0){s=.20000000298023224;break}s=+Hya(r+24|0,-1)}else s=.20000000298023224}else s=.20000000298023224;while(0);n[a+52>>2]=s;bD(e);f[e>>2]=0;f[e+4>>2]=0;r=aD(e,6)|0;b[r>>0]=b[430298]|0;b[r+1>>0]=b[430299]|0;b[r+2>>0]=b[430300]|0;b[r+3>>0]=b[430301]|0;b[r+4>>0]=b[430302]|0;b[r+5>>0]=b[430303]|0;r=f[j>>2]|0;do if(r){c=f[e>>2]|0;m=(c|0)==0?1124530:c;o=j;q=r;b:while(1){t=q;while(1){v=f[t+16>>2]|0;if((v|0)==(c|0))break;if((gTb((v|0)==0?1124530:v,m)|0)>=0)break;v=f[t+4>>2]|0;if(!v){w=o;break b}else t=v}q=f[t>>2]|0;if(!q){w=t;break}else o=t}if((w|0)!=(j|0)){o=f[w+16>>2]|0;if((c|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){x=4;break}o=Gwa(w+24|0,-1)|0;x=o}else x=4}else x=4;while(0);w=a+36|0;f[w>>2]=x;bD(e);f[e>>2]=0;f[e+4>>2]=0;x=aD(e,7)|0;b[x>>0]=b[430305]|0;b[x+1>>0]=b[430306]|0;b[x+2>>0]=b[430307]|0;b[x+3>>0]=b[430308]|0;b[x+4>>0]=b[430309]|0;b[x+5>>0]=b[430310]|0;b[x+6>>0]=b[430311]|0;x=f[j>>2]|0;do if(x){r=f[e>>2]|0;o=(r|0)==0?1124530:r;q=j;l=x;c:while(1){k=l;while(1){p=f[k+16>>2]|0;if((p|0)==(r|0))break;if((gTb((p|0)==0?1124530:p,o)|0)>=0)break;p=f[k+4>>2]|0;if(!p){y=q;break c}else k=p}l=f[k>>2]|0;if(!l){y=k;break}else q=k}if((y|0)!=(j|0)){q=f[y+16>>2]|0;if((r|0)!=(q|0)?(gTb(o,(q|0)==0?1124530:q)|0)<=-1:0){z=0;break}q=Gwa(y+24|0,-1)|0;z=q}else z=0}else z=0;while(0);y=a+40|0;f[y>>2]=z;bD(e);f[e>>2]=0;f[e+4>>2]=0;z=aD(e,7)|0;b[z>>0]=b[430313]|0;b[z+1>>0]=b[430314]|0;b[z+2>>0]=b[430315]|0;b[z+3>>0]=b[430316]|0;b[z+4>>0]=b[430317]|0;b[z+5>>0]=b[430318]|0;b[z+6>>0]=b[430319]|0;z=f[j>>2]|0;do if(z){x=f[e>>2]|0;q=(x|0)==0?1124530:x;l=j;m=z;d:while(1){c=m;while(1){t=f[c+16>>2]|0;if((t|0)==(x|0))break;if((gTb((t|0)==0?1124530:t,q)|0)>=0)break;t=f[c+4>>2]|0;if(!t){A=l;break d}else c=t}m=f[c>>2]|0;if(!m){A=c;break}else l=c}if((A|0)!=(j|0)){l=f[A+16>>2]|0;if((x|0)!=(l|0)?(gTb(q,(l|0)==0?1124530:l)|0)<=-1:0){B=5;break}l=Gwa(A+24|0,-1)|0;B=l}else B=5}else B=5;while(0);A=a+44|0;f[A>>2]=B;bD(e);f[e>>2]=0;f[e+4>>2]=0;B=aD(e,8)|0;z=B;b[z>>0]=99;b[z+1>>0]=108;b[z+2>>0]=97;b[z+3>>0]=115;z=B+4|0;b[z>>0]=115;b[z+1>>0]=102;b[z+2>>0]=105;b[z+3>>0]=120;z=f[j>>2]|0;do if(z){B=f[e>>2]|0;l=(B|0)==0?1124530:B;m=j;o=z;e:while(1){r=o;while(1){k=f[r+16>>2]|0;if((k|0)==(B|0))break;if((gTb((k|0)==0?1124530:k,l)|0)>=0)break;k=f[r+4>>2]|0;if(!k){C=m;break e}else r=k}o=f[r>>2]|0;if(!o){C=r;break}else m=r}if((C|0)!=(j|0)){m=f[C+16>>2]|0;if((B|0)!=(m|0)?(gTb(l,(m|0)==0?1124530:m)|0)<=-1:0){D=0;break}m=Gwa(C+24|0,-1)|0;D=m}else D=0}else D=0;while(0);f[a+48>>2]=D;bD(e);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,12)|0;h=430321;i=g+12|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));D=f[j>>2]|0;do if(D){C=f[e>>2]|0;z=(C|0)==0?1124530:C;m=j;o=D;f:while(1){q=o;while(1){x=f[q+16>>2]|0;if((x|0)==(C|0))break;if((gTb((x|0)==0?1124530:x,z)|0)>=0)break;x=f[q+4>>2]|0;if(!x){E=m;break f}else q=x}o=f[q>>2]|0;if(!o){E=q;break}else m=q}if((E|0)!=(j|0)){m=f[E+16>>2]|0;if((C|0)!=(m|0)?(gTb(z,(m|0)==0?1124530:m)|0)<=-1:0){F=0;break}m=Gwa(E+24|0,-1)|0;F=(m|0)!=0|(J|0)!=0}else F=0}else F=0;while(0);E=a+60|0;b[E>>0]=F&1;bD(e);f[e>>2]=0;f[e+4>>2]=0;F=aD(e,7)|0;b[F>>0]=b[430334]|0;b[F+1>>0]=b[430335]|0;b[F+2>>0]=b[430336]|0;b[F+3>>0]=b[430337]|0;b[F+4>>0]=b[430338]|0;b[F+5>>0]=b[430339]|0;b[F+6>>0]=b[430340]|0;F=f[j>>2]|0;do if(F){D=f[e>>2]|0;m=(D|0)==0?1124530:D;o=j;l=F;g:while(1){B=l;while(1){r=f[B+16>>2]|0;if((r|0)==(D|0))break;if((gTb((r|0)==0?1124530:r,m)|0)>=0)break;r=f[B+4>>2]|0;if(!r){G=o;break g}else B=r}l=f[B>>2]|0;if(!l){G=B;break}else o=B}if((G|0)!=(j|0)){o=f[G+16>>2]|0;if((D|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){H=0;break}o=Gwa(G+24|0,-1)|0;H=(o|0)!=0|(J|0)!=0}else H=0}else H=0;while(0);G=a+61|0;b[G>>0]=H&1;bD(e);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,13)|0;h=431760;i=g+13|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));H=f[j>>2]|0;do if(H){F=f[e>>2]|0;o=(F|0)==0?1124530:F;l=j;z=H;h:while(1){C=z;while(1){q=f[C+16>>2]|0;if((q|0)==(F|0))break;if((gTb((q|0)==0?1124530:q,o)|0)>=0)break;q=f[C+4>>2]|0;if(!q){I=l;break h}else C=q}z=f[C>>2]|0;if(!z){I=C;break}else l=C}if((I|0)!=(j|0)){l=f[I+16>>2]|0;if((F|0)!=(l|0)?(gTb(o,(l|0)==0?1124530:l)|0)<=-1:0){K=.4000000059604645;break}K=+Hya(I+24|0,-1)}else K=.4000000059604645}else K=.4000000059604645;while(0);I=a+56|0;n[I>>2]=K;bD(e);if(!(+n[I>>2]>=0.0)){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,18)|0;h=430342;i=g+18|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-215,e,430195,430211,75);bD(e)}if((f[w>>2]|0)!=4){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,11)|0;h=430361;i=g+11|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-215,e,430195,430211,76);bD(e)}if((f[y>>2]|0)<=0){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,12)|0;h=430373;i=g+12|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-215,e,430195,430211,77);bD(e)}if((f[A>>2]|0)<=0){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,12)|0;h=430386;i=g+12|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-215,e,430195,430211,78);bD(e)}if(b[E>>0]|0){u=d;return}if(b[G>>0]|0){u=d;return}f[e>>2]=0;f[e+4>>2]=0;g=aD(e,28)|0;h=430399;i=g+28|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-215,e,430195,430211,79);bD(e);u=d;return}function $fb(a){a=a|0;O5b(a);return}function agb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function bgb(a){a=a|0;lua(a);O5b(a);return}function cgb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0,T=0.0,U=0,W=0.0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(g,123136);if((f[c+4>>2]|0)==(f[c>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;i=aD(h,18)|0;j=430584;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,h,443123,430211,202);bD(h)}l=a+40|0;m=(f[l>>2]|0)+1+(f[a+36>>2]|0)|0;o=f[(f[a+4>>2]|0)+16>>2]|0;p=d+4|0;q=f[d>>2]|0;if((f[p>>2]|0)!=(q|0)){r=a+44|0;s=a+60|0;t=a+61|0;v=a+48|0;w=a+52|0;x=h+4|0;y=a+56|0;z=h+4|0;A=0;B=q;do{q=f[(f[c>>2]|0)+(A<<2)>>2]|0;C=f[q+40>>2]|0;D=f[C+4>>2]|0;E=f[C+8>>2]|0;C=f[q+16>>2]|0;q=f[B+(A*56|0)+16>>2]|0;F=Y(E,D)|0;G=f[r>>2]|0;H=Y(G,F)|0;I=(H|0)>0;if(I){J=0;do{K=(Y(J,m)|0)+4|0;L=1.0/(+V(+-+n[C+(K<<2)>>2])+1.0);n[q+(K<<2)>>2]=L;J=J+1|0}while((J|0)<(H|0))}if(!(b[s>>0]|0)){if(b[t>>0]|0){if(I?(J=f[l>>2]|0,(J|0)>0):0){K=0;do{M=Y(K,m)|0;N=C+(M<<2)+20|0;O=q+(M<<2)|0;L=-3402823466385288598117041.0e14;M=0;do{P=+n[N+(M<<2)>>2];L=P>L?P:L;M=M+1|0}while((M|0)!=(J|0));M=O+20|0;P=0.0;Q=0;do{R=+V(+(+n[N+(Q<<2)>>2]-L));P=P+R;n[M+(Q<<2)>>2]=R;Q=Q+1|0}while((Q|0)!=(J|0));S=0;do{Q=M+(S<<2)|0;n[Q>>2]=+n[Q>>2]/P;S=S+1|0}while((S|0)!=(J|0));K=K+1|0}while((K|0)<(H|0))}if((E|0)>0){H=(D|0)>0;P=+(E|0);L=+(D|0);K=0;J=G;while(1){if(H){R=+(K|0);I=0;M=J;while(1){if((M|0)>0){Q=(Y(I,E)|0)+K|0;T=+(I|0);N=0;O=M;while(1){U=Y((Y(O,Q)|0)+N|0,m)|0;W=+n[q+(U+4<<2)>>2];X=W<.5&(f[v>>2]|0)==-1?0.0:W;W=(R+1.0/(+V(+-+n[C+(U<<2)>>2])+1.0))/P;n[q+(U<<2)>>2]=W;Z=U+1|0;W=(T+1.0/(+V(+-+n[C+(Z<<2)>>2])+1.0))/L;n[q+(Z<<2)>>2]=W;Z=U+2|0;W=+V(+(+n[C+(Z<<2)>>2]));_=N<<1;n[q+(Z<<2)>>2]=W*+n[o+(_<<2)>>2]/P;Z=U+3|0;W=+V(+(+n[C+(Z<<2)>>2]));n[q+(Z<<2)>>2]=W*+n[o+((_|1)<<2)>>2]/L;_=U+5|0;do if(!(b[s>>0]|0)){U=f[l>>2]|0;if((U|0)>0)$=0;else{aa=O;break}do{Z=q+(_+$<<2)|0;W=X*+n[Z>>2];n[Z>>2]=W>+n[w>>2]?W:0.0;$=$+1|0}while(($|0)<(U|0));aa=O}else{f[h>>2]=0;f[x>>2]=0;i=aD(h,27)|0;j=430603;k=i+27|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-213,h,443123,430211,252);bD(h);aa=f[r>>2]|0}while(0);N=N+1|0;if((N|0)>=(aa|0)){ba=aa;break}else O=aa}}else ba=M;I=I+1|0;if((I|0)>=(D|0)){ca=ba;break}else M=ba}}else ca=J;K=K+1|0;if((K|0)>=(E|0))break;else J=ca}}}}else{f[h>>2]=0;f[z>>2]=0;i=aD(h,27)|0;j=430603;k=i+27|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-213,h,443123,430211,226);bD(h)}L=+n[y>>2];if(L>0.0){J=Y(f[r>>2]|0,F)|0;hgb(a,q,J,+n[w>>2],L)}A=A+1|0;B=f[d>>2]|0}while(A>>>0<(((f[p>>2]|0)-B|0)/56|0)>>>0)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function dgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,123104);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function egb(a,b){a=a|0;b=b|0;return (b|0)==0|0}function fgb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+48|0;d=g+24|0;h=g+12|0;i=g;j=c+4|0;k=f[c>>2]|0;if((f[j>>2]|0)==(k|0)){f[d>>2]=0;f[d+4>>2]=0;l=aD(d,17)|0;m=441774;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,442770,430211,87);bD(d);o=f[c>>2]|0;p=o;q=o}else{p=k;q=k}k=a+44|0;o=f[k>>2]|0;if((f[(f[q>>2]|0)+12>>2]|0)==(Y((f[a+36>>2]|0)+1+(f[a+40>>2]|0)|0,o)|0)){r=p;s=o}else{f[d>>2]=0;f[d+4>>2]=0;l=aD(d,46)|0;m=430428;n=l+46|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,442770,430211,88);bD(d);r=f[c>>2]|0;s=f[k>>2]|0}k=((f[j>>2]|0)-r|0)/12|0;j=f[r>>2]|0;r=Y(Y(f[j+8>>2]|0,f[j+4>>2]|0)|0,s)|0;c=(f[j+12>>2]|0)/(s|0)|0;f[d>>2]=r;f[d+4>>2]=c;f[d+8>>2]=-1;f[d+12>>2]=-1;f[i>>2]=0;c=i+4|0;f[c>>2]=0;f[i+8>>2]=0;Rva(i,d,d+16|0);d=f[i>>2]|0;r=f[c>>2]|0;a:do if((d|0)==(r|0)){t=d;v=9}else{s=d;do{if((f[s>>2]|0)<0){t=s;v=9;break a}s=s+4|0}while((s|0)!=(r|0))}while(0);if((v|0)==9?(t|0)!=(r|0):0){v=t+4|0;if((v|0)==(r|0)){w=r;x=t}else{d=v;v=t;while(1){t=f[d>>2]|0;if((t|0)<0)y=v;else{f[v>>2]=t;y=v+4|0}d=d+4|0;if((d|0)==(r|0))break;else v=y}w=f[c>>2]|0;x=y}if((x|0)!=(w|0))f[c>>2]=w+(~((w+-4-x|0)>>>2)<<2)}jdb(h,k,i);if((h|0)!=(e|0))xwa(e,f[h>>2]|0,f[h+4>>2]|0);e=f[h>>2]|0;if(e|0){k=h+4|0;x=f[k>>2]|0;if((x|0)==(e|0))z=e;else{w=x;while(1){x=w+-12|0;f[k>>2]=x;y=f[x>>2]|0;if(!y)A=x;else{x=w+-8|0;v=f[x>>2]|0;if((v|0)!=(y|0))f[x>>2]=v+(~((v+-4-y|0)>>>2)<<2);O5b(y);A=f[k>>2]|0}if((A|0)==(e|0))break;else w=A}z=f[h>>2]|0}O5b(z)}z=f[i>>2]|0;if(!z){u=g;return 0}i=f[c>>2]|0;if((i|0)!=(z|0))f[c>>2]=i+(~((i+-4-z|0)>>>2)<<2);O5b(z);u=g;return 0}function ggb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;a=d;e=c+4|0;g=f[e>>2]|0;h=f[c>>2]|0;if((g|0)==(h|0)){i=0;j=0;J=j;u=d;return i|0}k=a+4|0;l=0;m=h;h=0;n=0;o=g;while(1){g=m;p=f[g+(l*12|0)+4>>2]|0;q=f[g+(l*12|0)>>2]|0;g=p-q|0;r=g>>2;s=q;do if((s|0)!=(p|0)){if((g|0)<=-4){f[a>>2]=0;f[k>>2]=0;q=aD(a,70)|0;t=442586;v=q+70|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,a,442657,442663,160);bD(a);w=1;x=f[c>>2]|0;y=f[e>>2]|0;break}if((g|0)>0){t=0;q=1;while(1){v=Y(f[s+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)>=(r|0)){w=v;x=m;y=o;break}else q=v}}else{w=1;x=m;y=o}}else{w=0;x=m;y=o}while(0);r=w*60|0;s=Kac(r|0,((r|0)<0)<<31>>31|0,h|0,n|0)|0;r=J;l=l+1|0;if(l>>>0>=((y-x|0)/12|0)>>>0){i=s;j=r;break}else{m=x;h=s;n=r;o=y}}J=j;u=d;return i|0}function hgb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+48|0;h=g+24|0;i=g+12|0;j=g;f[h>>2]=0;k=h+4|0;f[k>>2]=0;f[h+8>>2]=0;l=(c|0)==0;do if(!l)if(c>>>0>268435455)c4b(h);else{m=c<<4;o=L5b(m)|0;f[h>>2]=o;f[h+8>>2]=o+(c<<4);Nac(o|0,0,m|0)|0;f[k>>2]=o+m;p=o;break}else p=0;while(0);f[i>>2]=0;o=i+4|0;f[o>>2]=0;f[i+8>>2]=0;if(l){l=a+40|0;q=l;r=0;t=0;v=f[l>>2]|0}else{l=c<<2;m=L5b(l)|0;f[i>>2]=m;w=m+(c<<2)|0;f[i+8>>2]=w;Nac(m|0,0,l|0)|0;f[o>>2]=w;w=a+40|0;l=f[w>>2]|0;x=l+1+(f[a+36>>2]|0)|0;y=0;do{z=Y(x,y)|0;A=f[b+(z+2<<2)>>2]|0;f[p+(y<<4)+8>>2]=A;B=f[b+(z+3<<2)>>2]|0;f[p+(y<<4)+12>>2]=B;n[p+(y<<4)>>2]=+n[b+(z<<2)>>2]-(f[s>>2]=A,+n[s>>2])*.5;n[p+(y<<4)+4>>2]=+n[b+(z+1<<2)>>2]-(f[s>>2]=B,+n[s>>2])*.5;y=y+1|0}while((y|0)!=(c|0));q=w;r=1;t=m;v=l}f[j>>2]=0;l=j+4|0;f[l>>2]=0;f[j+8>>2]=0;if((v|0)>0){m=a+36|0;a:do if(r){a=0;w=v;y=t;while(1){p=w+1+(f[m>>2]|0)|0;x=a+5|0;B=0;do{z=b+(x+(Y(p,B)|0)<<2)|0;f[y+(B<<2)>>2]=f[z>>2];n[z>>2]=0.0;B=B+1|0}while((B|0)!=(c|0));jgb(h,i,d,e,1.0,0,j,24);B=f[l>>2]|0;p=f[j>>2]|0;z=B-p|0;A=z>>2;C=p;p=f[q>>2]|0;if((z|0)>0){z=p+1+(f[m>>2]|0)|0;D=f[i>>2]|0;E=0;do{F=f[C+(E<<2)>>2]|0;G=Y(z,F)|0;f[b+(x+G<<2)>>2]=f[D+(F<<2)>>2];E=E+1|0}while((E|0)<(A|0))}A=a+1|0;if((A|0)>=(p|0)){H=B;I=C;break a}a=A;w=p;y=f[i>>2]|0}}else{y=0;do{jgb(h,i,d,e,1.0,0,j,24);w=f[l>>2]|0;a=f[j>>2]|0;A=w-a|0;E=A>>2;D=a;a=f[q>>2]|0;if((A|0)>0){A=a+1+(f[m>>2]|0)|0;x=f[i>>2]|0;z=y+5|0;F=0;do{G=f[D+(F<<2)>>2]|0;J=Y(A,G)|0;f[b+(z+J<<2)>>2]=f[x+(G<<2)>>2];F=F+1|0}while((F|0)<(E|0))}y=y+1|0}while((y|0)<(a|0));H=w;I=D}while(0);b=H;if(I|0){if((b|0)!=(I|0))f[l>>2]=b+(~((b+-4-I|0)>>>2)<<2);O5b(I)}}I=f[i>>2]|0;if(I|0){i=f[o>>2]|0;if((i|0)!=(I|0))f[o>>2]=i+(~((i+-4-I|0)>>>2)<<2);O5b(I)}I=f[h>>2]|0;if(!I){u=g;return}h=f[k>>2]|0;if((h|0)!=(I|0))f[k>>2]=h+(~((h+-16-I|0)>>>4)<<4);O5b(I);u=g;return}function igb(a,b){a=a|0;b=b|0;var c=0.0,d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0;c=+n[a+8>>2];d=+n[a+12>>2];e=+n[b+8>>2];f=+n[b+12>>2];g=c*d+e*f;if(g<=1.1920928955078125e-07){h=0.0;i=1.0-h;j=i;return +j}k=+n[a>>2];l=+n[a+4>>2];m=+n[b>>2];o=+n[b+4>>2];p=c+k;c=e+m;e=(c<p?c:p)-(k<m?m:k);k=d+l;d=f+o;f=(d<k?d:k)-(l<o?o:l);b=!(e<=0.0)&!(f<=0.0);l=(b?e:0.0)*(b?f:0.0);h=1.0-l/(g-l);i=1.0-h;j=i;return +j}function jgb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=u;u=u+16|0;l=k+4|0;m=k;if(((f[a+4>>2]|0)-(f[a>>2]|0)>>4|0)!=((f[c+4>>2]|0)-(f[c>>2]|0)>>2|0)){f[l>>2]=0;f[l+4>>2]=0;n=aD(l,30)|0;o=432504;p=n+30|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,l,432535,430631,72);bD(l)}f[l>>2]=0;o=l+4|0;f[o>>2]=0;f[l+8>>2]=0;kgb(c,d,h,l);h=f[i>>2]|0;c=i+4|0;n=f[c>>2]|0;p=h;if((n|0)==(h|0)){q=n;r=h}else{s=n+(~((n+-4-p|0)>>>2)<<2)|0;f[c>>2]=s;q=s;r=s}s=q;q=f[o>>2]|0;n=f[l>>2]|0;t=n;a:do if((q|0)!=(n|0)){v=i+8|0;if(g<1.0){w=0;d=e;x=r;y=h;z=t;A=p;B=s;while(1){C=f[z+(w<<3)+4>>2]|0;f[m>>2]=C;if((B-A|0)>0){D=0;E=y;F=C;while(1){C=f[a>>2]|0;G=+yg[j&31](C+(F<<4)|0,C+(f[E+(D<<2)>>2]<<4)|0)<=d;C=D+1|0;H=f[c>>2]|0;I=f[i>>2]|0;if(!(G&(C|0)<(H-I>>2|0)))break;D=C;E=I;F=f[m>>2]|0}if(G){J=H;K=9}else L=0}else{J=x;K=9}do if((K|0)==9){K=0;if((J|0)==(f[v>>2]|0)){IO(i,m);L=1;break}else{f[J>>2]=f[m>>2];f[c>>2]=J+4;L=1;break}}while(0);F=w+1|0;E=f[o>>2]|0;D=f[l>>2]|0;I=D;if(F>>>0>=E-D>>3>>>0){M=E;N=I;break a}E=f[c>>2]|0;D=f[i>>2]|0;w=F;d=d>.5&L?d*g:d;x=E;y=D;z=I;A=D;B=E}}else{B=0;A=r;z=h;y=t;x=p;w=s;while(1){E=f[y+(B<<3)+4>>2]|0;f[m>>2]=E;if((w-x|0)>0){D=0;I=z;F=E;while(1){E=f[a>>2]|0;O=+yg[j&31](E+(F<<4)|0,E+(f[I+(D<<2)>>2]<<4)|0)<=e;E=D+1|0;P=f[c>>2]|0;C=f[i>>2]|0;if(!(O&(E|0)<(P-C>>2|0)))break;D=E;I=C;F=f[m>>2]|0}if(O){Q=P;K=25}}else{Q=A;K=25}do if((K|0)==25){K=0;if((Q|0)==(f[v>>2]|0)){IO(i,m);break}else{f[Q>>2]=f[m>>2];f[c>>2]=Q+4;break}}while(0);F=B+1|0;I=f[o>>2]|0;D=f[l>>2]|0;C=D;if(F>>>0>=I-D>>3>>>0){M=I;N=C;break a}I=f[c>>2]|0;D=f[i>>2]|0;B=F;A=I;z=D;y=C;x=D;w=I}}}else{M=q;N=t}while(0);t=M;if(!N){u=k;return}if((t|0)!=(N|0))f[o>>2]=t+(~((t+-8-N|0)>>>3)<<3);O5b(N);u=k;return}function kgb(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+32|0;g=e;h=e+20|0;i=e+16|0;j=e+12|0;k=e+8|0;l=a+4|0;m=f[l>>2]|0;o=f[a>>2]|0;if((m|0)==(o|0))p=d+4|0;else{q=g+4|0;r=d+4|0;s=d+8|0;t=0;v=o;o=m;while(1){m=v;if(+n[m+(t<<2)>>2]>b){f[g>>2]=f[m+(t<<2)>>2];f[q>>2]=t;m=f[r>>2]|0;if((m|0)==(f[s>>2]|0))ngb(d,g);else{w=g;x=f[w+4>>2]|0;y=m;f[y>>2]=f[w>>2];f[y+4>>2]=x;f[r>>2]=(f[r>>2]|0)+8}z=f[a>>2]|0;A=f[l>>2]|0}else{z=v;A=o}t=t+1|0;if(t>>>0>=A-z>>2>>>0){p=r;break}else{v=z;o=A}}}A=f[d>>2]|0;o=f[p>>2]|0;f[i>>2]=560;z=o-A|0;v=z>>3;if((z|0)>0){z=(v|0)<268435455?v:268435455;while(1){r=M5b(z<<3,1124529)|0;if(r|0){B=r;C=z;break}z=z>>>1;if(!z){B=0;C=0;break}}D=B;E=C;F=B}else{D=0;E=0;F=0}f[j>>2]=A;f[k>>2]=o;f[h>>2]=f[j>>2];f[g>>2]=f[k>>2];mgb(h,g,i,v,D,E);if(D|0)O5b(F);if((c|0)<=0){u=e;return}F=f[p>>2]|0;D=f[d>>2]|0;E=F-D>>3;if((E|0)<=(c|0)){u=e;return}v=F;if(E>>>0<c>>>0){ogb(d,c-E|0);u=e;return}if(E>>>0<=c>>>0){u=e;return}E=D+(c<<3)|0;if((v|0)==(E|0)){u=e;return}f[p>>2]=v+(~((v+-8-E|0)>>>3)<<3);u=e;return}function lgb(a,b){a=a|0;b=b|0;return +n[a>>2]>+n[b>>2]|0}function mgb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;h=u;u=u+64|0;i=h;j=h+56|0;k=h+52|0;l=h+48|0;m=h+44|0;n=h+40|0;o=h+36|0;p=h+32|0;q=h+28|0;r=h+24|0;s=h+20|0;t=h+16|0;v=h+12|0;w=h+8|0;switch(d|0){case 2:{x=f[c>>2]|0;y=f[b>>2]|0;z=y+-8|0;f[b>>2]=z;A=f[a>>2]|0;if(!(Uh[x&1023](z,A)|0)){u=h;return}x=f[A>>2]|0;f[A>>2]=f[z>>2];f[z>>2]=x;x=A+4|0;A=y+-4|0;y=f[x>>2]|0;f[x>>2]=f[A>>2];f[A>>2]=y;u=h;return}case 1:case 0:{u=h;return}default:{if((d|0)<1){y=f[a>>2]|0;A=f[b>>2]|0;if((y|0)==(A|0)){u=h;return}x=y+8|0;if((x|0)==(A|0)){u=h;return}z=i+4|0;B=x;do{x=B;C=B;D=f[C>>2]|0;E=f[C+4>>2]|0;C=i;f[C>>2]=D;f[C+4>>2]=E;if((B|0)==(y|0)){F=x;G=D;H=E}else{E=x;x=B;while(1){D=x;x=x+-8|0;if(!(Uh[f[c>>2]&1023](i,x)|0)){I=E;break}C=E;f[E>>2]=f[x>>2];f[C+4>>2]=f[D+-4>>2];D=C+-8|0;if((x|0)==(y|0)){I=D;break}else E=D}F=I;G=f[i>>2]|0;H=f[z>>2]|0}f[F>>2]=G;f[F+4>>2]=H;B=B+8|0}while((B|0)!=(A|0));u=h;return}A=d>>>1;B=f[a>>2]|0;a=B+(A<<3)|0;H=B;if((d|0)>(g|0)){f[p>>2]=H;f[q>>2]=a;f[j>>2]=f[p>>2];f[i>>2]=f[q>>2];mgb(j,i,c,A,e,g);f[r>>2]=a;q=f[b>>2]|0;f[s>>2]=q;p=d-A|0;f[j>>2]=f[r>>2];f[i>>2]=f[s>>2];mgb(j,i,c,p,e,g);f[t>>2]=H;f[v>>2]=a;f[w>>2]=q;f[k>>2]=f[t>>2];f[j>>2]=f[v>>2];f[i>>2]=f[w>>2];qgb(k,j,i,c,A,p,e,g);u=h;return}f[l>>2]=H;f[m>>2]=a;f[j>>2]=f[l>>2];f[i>>2]=f[m>>2];pgb(j,i,c,A,e);f[n>>2]=a;f[o>>2]=f[b>>2];b=e+(A<<3)|0;f[j>>2]=f[n>>2];f[i>>2]=f[o>>2];pgb(j,i,c,d-A|0,b);A=e+(d<<3)|0;d=b;i=e;e=H;while(1){if((d|0)==(A|0))break;H=e;if(Uh[f[c>>2]&1023](d,i)|0){f[e>>2]=f[d>>2];J=d;K=d+8|0;L=i}else{f[e>>2]=f[i>>2];J=i;K=d;L=i+8|0}f[H+4>>2]=f[J+4>>2];M=H+8|0;if((L|0)==(b|0)){N=15;break}else{d=K;i=L;e=M}}if((N|0)==15){if((K|0)==(A|0)){u=h;return}else{O=K;P=M}while(1){f[P>>2]=f[O>>2];f[P+4>>2]=f[O+4>>2];O=O+8|0;if((O|0)==(A|0))break;else P=P+8|0}u=h;return}if((i|0)==(b|0)){u=h;return}P=i;i=e;while(1){f[i>>2]=f[P>>2];f[i+4>>2]=f[P+4>>2];P=P+8|0;if((P|0)==(b|0))break;else i=i+8|0}u=h;return}}}function ngb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;O5b(d);return}function ogb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){Nac(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)c4b(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;Nac(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)Vac(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;O5b(h);return}function pgb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+32|0;h=g+8|0;i=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;switch(d|0){case 1:{n=f[a>>2]|0;o=f[n+4>>2]|0;p=e;f[p>>2]=f[n>>2];f[p+4>>2]=o;u=g;return}case 2:{o=f[c>>2]|0;p=(f[b>>2]|0)+-8|0;f[b>>2]=p;n=Uh[o&1023](p,f[a>>2]|0)|0;p=f[(n?b:a)>>2]|0;o=f[p+4>>2]|0;q=e;f[q>>2]=f[p>>2];f[q+4>>2]=o;o=f[(n?a:b)>>2]|0;n=f[o+4>>2]|0;q=e+8|0;f[q>>2]=f[o>>2];f[q+4>>2]=n;u=g;return}case 0:{u=g;return}default:{if((d|0)<9){n=f[a>>2]|0;q=f[b>>2]|0;if((n|0)==(q|0)){u=g;return}o=n;p=f[o+4>>2]|0;r=e;f[r>>2]=f[o>>2];f[r+4>>2]=p;p=n+8|0;if((p|0)==(q|0)){u=g;return}else{s=p;t=e}do{p=t;t=t+8|0;if(Uh[f[c>>2]&1023](s,p)|0){n=p;r=f[n+4>>2]|0;o=t;f[o>>2]=f[n>>2];f[o+4>>2]=r;a:do if((p|0)==(e|0))v=e;else{r=p;while(1){o=r;r=r+-8|0;if(!(Uh[f[c>>2]&1023](s,r)|0)){v=o;break a}f[o>>2]=f[r>>2];f[o+4>>2]=f[o+-4>>2];if((r|0)==(e|0)){v=e;break}}}while(0);f[v>>2]=f[s>>2];f[v+4>>2]=f[s+4>>2]}else{p=s;r=f[p+4>>2]|0;o=t;f[o>>2]=f[p>>2];f[o+4>>2]=r}s=s+8|0}while((s|0)!=(q|0));u=g;return}q=d>>>1;s=f[a>>2]|0;a=s+(q<<3)|0;t=s;f[j>>2]=t;f[k>>2]=a;f[i>>2]=f[j>>2];f[h>>2]=f[k>>2];mgb(i,h,c,q,e,q);f[l>>2]=a;k=f[b>>2]|0;f[m>>2]=k;b=d-q|0;f[i>>2]=f[l>>2];f[h>>2]=f[m>>2];mgb(i,h,c,b,e+(q<<3)|0,b);b=k;f[h>>2]=a;f[i>>2]=t;b:do if(q){if((a|0)==(b|0)){w=e;x=s}else{t=e;k=s;m=a;while(1){l=Uh[f[c>>2]&1023](m,k)|0;d=l?h:i;l=f[d>>2]|0;j=l;v=f[j+4>>2]|0;r=t;f[r>>2]=f[j>>2];f[r+4>>2]=v;f[d>>2]=l+8;l=t+8|0;d=f[i>>2]|0;m=f[h>>2]|0;if((d|0)==(a|0)){y=l;z=m;A=16;break b}if((m|0)==(b|0)){w=l;x=d;break}else{t=l;k=d}}}if((x|0)!=(a|0)){k=(a+-8-x|0)>>>3;t=w;m=x;while(1){d=m;l=f[d+4>>2]|0;v=t;f[v>>2]=f[d>>2];f[v+4>>2]=l;m=m+8|0;if((m|0)==(a|0))break;else t=t+8|0}f[i>>2]=x+(k+1<<3)}}else{y=e;z=s;A=16}while(0);if((A|0)==16?(z|0)!=(b|0):0){A=(b+-8-z|0)>>>3;s=y;y=z;while(1){e=y;x=f[e+4>>2]|0;i=s;f[i>>2]=f[e>>2];f[i+4>>2]=x;y=y+8|0;if((y|0)==(b|0))break;else s=s+8|0}f[h>>2]=z+(A+1<<3)}u=g;return}}}function qgb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;j=u;u=u+64|0;k=j+52|0;l=j;m=j+48|0;n=j+44|0;o=j+40|0;p=j+36|0;q=j+16|0;r=j+8|0;s=j+32|0;t=j+28|0;v=j+24|0;w=j+20|0;x=j+12|0;y=j+4|0;if(!g){u=j;return}z=e;e=g;a:while(1){if(!((e|0)>(i|0)&(z|0)>(i|0))){A=6;break}if(!z){A=37;break}B=f[b>>2]|0;g=B;C=z;D=f[a>>2]|0;while(1){if(Uh[f[d>>2]&1023](B,D)|0)break;E=D+8|0;f[a>>2]=E;F=C+-1|0;if(!F){A=37;break a}else{C=F;D=E}}E=D;if((C|0)<(e|0)){F=(e|0)/2|0;G=B+(F<<3)|0;f[r>>2]=G;H=g-E>>3;if(!H)I=D;else{J=H;H=D;K=D;while(1){L=(J|0)/2|0;M=K+(L<<3)|0;N=Uh[f[d>>2]&1023](G,M)|0;O=M+8|0;M=N?H:O;J=N?L:J+-1-L|0;if(!J){I=M;break}else{H=M;K=N?K:O}}}K=I;f[q>>2]=K;P=K-E>>3;Q=F;R=G;S=I}else{if((C|0)==1){A=14;break}K=(C|0)/2|0;H=D+(K<<3)|0;f[q>>2]=H;J=(f[c>>2]|0)-g>>3;if(!J)T=B;else{O=J;J=B;N=B;while(1){M=(O|0)/2|0;L=N+(M<<3)|0;U=Uh[f[d>>2]&1023](L,H)|0;V=L+8|0;L=U?V:J;O=U?O+-1-M|0:M;if(!O){T=L;break}else{J=L;N=U?V:N}}}N=T;f[r>>2]=N;P=K;Q=N-g>>3;R=T;S=H}N=C-P|0;J=e-Q|0;if((S|0)!=(B|0))if((B|0)==(R|0))W=S;else{f[l>>2]=g;O=S;G=l;F=k;b:while(1){f[F>>2]=f[G>>2];E=f[l>>2]|0;V=f[k>>2]|0;X=O;do{U=f[X>>2]|0;f[X>>2]=f[V>>2];f[V>>2]=U;U=X+4|0;L=V+4|0;M=f[U>>2]|0;f[U>>2]=f[L>>2];f[L>>2]=M;X=X+8|0;V=V+8|0;Y=(X|0)==(E|0);if((V|0)==(R|0))break b}while(!Y);f[k>>2]=V;O=E;G=k;F=l}f[k>>2]=R;if(!Y){F=k;G=l;O=X;while(1){f[F>>2]=f[G>>2];g=f[l>>2]|0;C=g;H=f[k>>2]|0;K=O;while(1){M=f[K>>2]|0;f[K>>2]=f[H>>2];f[H>>2]=M;M=K+4|0;L=H+4|0;U=f[M>>2]|0;f[M>>2]=f[L>>2];f[L>>2]=U;K=K+8|0;H=H+8|0;Z=(K|0)==(C|0);if((H|0)==(R|0)){A=30;break}if(Z){A=27;break}}if((A|0)==27){A=0;f[k>>2]=H;F=l;G=k;O=g;continue}else if((A|0)==30){A=0;f[k>>2]=R;if(Z)break;else{F=k;G=l;O=K;continue}}}}W=X}else W=R;f[b>>2]=W;O=W;if((P+Q|0)<(N+J|0)){f[s>>2]=f[a>>2];f[t>>2]=f[q>>2];f[v>>2]=O;f[m>>2]=f[s>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];qgb(m,l,k,d,P,Q,h,i);_=J;$=N;aa=r;ba=a}else{f[w>>2]=O;f[x>>2]=f[r>>2];f[y>>2]=f[c>>2];f[m>>2]=f[w>>2];f[l>>2]=f[x>>2];f[k>>2]=f[y>>2];qgb(m,l,k,d,N,J,h,i);_=Q;$=P;aa=q;ba=c}f[ba>>2]=O;f[b>>2]=f[aa>>2];if(!_){A=37;break}else{z=$;e=_}}if((A|0)==6){f[n>>2]=f[a>>2];f[o>>2]=f[b>>2];f[p>>2]=f[c>>2];f[m>>2]=f[n>>2];f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];rgb(m,l,k,d,z,e,h);u=j;return}else if((A|0)==14){h=f[D>>2]|0;f[D>>2]=f[B>>2];f[B>>2]=h;h=D+4|0;D=B+4|0;B=f[h>>2]|0;f[h>>2]=f[D>>2];f[D>>2]=B;u=j;return}else if((A|0)==37){u=j;return}}function rgb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+16|0;j=i+4|0;k=i;if((e|0)>(g|0)){g=f[b>>2]|0;e=g;l=f[c>>2]|0;if((e|0)==(l|0))m=h;else{n=((l+-8+(0-g)|0)>>>3)+1|0;o=h;p=g;q=e;while(1){r=p;s=f[r+4>>2]|0;t=o;f[t>>2]=f[r>>2];f[t+4>>2]=s;s=q+8|0;if((s|0)==(l|0))break;else{o=o+8|0;p=s;q=s}}m=h+(n<<3)|0}n=f[a>>2]|0;f[j>>2]=g;f[k>>2]=m;a:do if((m|0)!=(h|0)){if((e|0)==(n|0)){v=m;w=l}else{g=e;q=m;p=l;while(1){o=Uh[f[d>>2]&1023](g+-8|0,q+-8|0)|0;s=o?k:j;o=f[s>>2]|0;t=o+-8|0;r=p+-8|0;f[r>>2]=f[t>>2];f[p+-4>>2]=f[o+-4>>2];f[s>>2]=t;t=f[k>>2]|0;if((t|0)==(h|0))break a;g=f[j>>2]|0;if((g|0)==(n|0)){v=t;w=r;break}else{q=t;p=r}}}if((v|0)!=(h|0)){p=v;q=w;do{g=p;p=p+-8|0;r=q;q=q+-8|0;f[q>>2]=f[p>>2];f[r+-4>>2]=f[g+-4>>2]}while((p|0)!=(h|0))}}while(0);u=i;return}w=f[a>>2]|0;a=w;v=f[b>>2]|0;if((a|0)==(v|0)){u=i;return}b=((v+-8+(0-w)|0)>>>3)+1|0;n=h;j=w;k=a;while(1){a=j;l=f[a+4>>2]|0;m=n;f[m>>2]=f[a>>2];f[m+4>>2]=l;l=k+8|0;if((l|0)==(v|0))break;else{n=n+8|0;j=l;k=l}}k=h+(b<<3)|0;b=f[d>>2]|0;if((k|0)==(h|0)){u=i;return}d=f[c>>2]|0;c=h;h=w;w=v;while(1){if((w|0)==(d|0))break;v=h;if(Uh[b&1023](w,c)|0){f[h>>2]=f[w>>2];x=w;y=c;z=w+8|0}else{f[h>>2]=f[c>>2];x=c;y=c+8|0;z=w}f[v+4>>2]=f[x+4>>2];if((y|0)==(k|0)){A=25;break}else{c=y;h=v+8|0;w=z}}if((A|0)==25){u=i;return}A=c;c=h;while(1){f[c>>2]=f[A>>2];f[c+4>>2]=f[A+4>>2];A=A+8|0;if((A|0)==(k|0))break;else c=c+8|0}u=i;return}function sgb(a,b){a=a|0;b=b|0;var c=0;c=L5b(44)|0;tgb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=123176;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function tgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;Jwa(a);f[a>>2]=123196;f[e>>2]=0;f[e+4>>2]=0;g=aD(e,4)|0;b[g>>0]=97;b[g+1>>0]=120;b[g+2>>0]=105;b[g+3>>0]=115;g=c+4|0;h=f[g>>2]|0;do if(h){i=f[e>>2]|0;j=(i|0)==0?1124530:i;k=g;l=h;a:while(1){m=l;while(1){n=f[m+16>>2]|0;if((n|0)==(i|0))break;if((gTb((n|0)==0?1124530:n,j)|0)>=0)break;n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(g|0)){k=f[o+16>>2]|0;if((i|0)!=(k|0)?(gTb(j,(k|0)==0?1124530:k)|0)<=-1:0){p=1;break}k=Gwa(o+24|0,-1)|0;p=k}else p=1}else p=1;while(0);f[a+40>>2]=p;bD(e);f[e>>2]=0;f[e+4>>2]=0;p=aD(e,11)|0;o=430959;h=p+11|0;do{b[p>>0]=b[o>>0]|0;p=p+1|0;o=o+1|0}while((p|0)<(h|0));o=f[g>>2]|0;if(!o){q=0;r=a+36|0;b[r>>0]=q;bD(e);Kwa(a,c);u=d;return}p=f[e>>2]|0;h=(p|0)==0?1124530:p;k=g;l=o;b:while(1){o=l;while(1){n=f[o+16>>2]|0;if((n|0)==(p|0))break;if((gTb((n|0)==0?1124530:n,h)|0)>=0)break;n=f[o+4>>2]|0;if(!n){s=k;break b}else o=n}l=f[o>>2]|0;if(!l){s=o;break}else k=o}if((s|0)==(g|0)){q=0;r=a+36|0;b[r>>0]=q;bD(e);Kwa(a,c);u=d;return}g=f[s+16>>2]|0;if((p|0)!=(g|0)?(gTb(h,(g|0)==0?1124530:g)|0)<=-1:0){q=0;r=a+36|0;b[r>>0]=q;bD(e);Kwa(a,c);u=d;return}g=Gwa(s+24|0,-1)|0;q=(g|0)!=0&1;r=a+36|0;b[r>>0]=q;bD(e);Kwa(a,c);u=d;return}function ugb(a){a=a|0;O5b(a);return}function vgb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function wgb(a){a=a|0;lua(a);O5b(a);return}function xgb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;g=u;u=u+48|0;h=g+24|0;i=g+16|0;j=g;dQ(i,123320);k=f[f[c>>2]>>2]|0;c=f[d>>2]|0;d=f[a+40>>2]|0;l=k+4|0;m=f[l>>2]|0;o=((d|0)<0?m:0)+d|0;d=(o|0)<0;if(d){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,35)|0;q=431162;r=p+35|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,442657,431198,913);bD(h);s=f[l>>2]|0}else s=m;m=(s|0)<(o|0)?s:o;t=k+40|0;v=f[t>>2]|0;if((m|0)>0){w=1;x=0;while(1){y=Y(f[v+(x<<2)>>2]|0,w)|0;x=x+1|0;if((x|0)>=(m|0)){z=y;break}else w=y}}else z=1;w=f[v+(o<<2)>>2]|0;v=o+1|0;m=(o|0)<-1;if(m){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,35)|0;q=431162;r=p+35|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,442657,431198,913);bD(h);A=f[l>>2]|0}else A=s;if((A|0)>(v|0)){s=f[t>>2]|0;x=1;y=v;while(1){B=Y(f[s+(y<<2)>>2]|0,x)|0;y=y+1|0;if((y|0)==(A|0)){C=B;break}else x=B}}else C=1;x=f[k>>2]|0;if((x&4095|0)==5)D=x;else{f[h>>2]=0;f[h+4>>2]=0;p=aD(h,15)|0;q=443229;r=p+15|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,443123,431081,209);bD(h);D=f[k>>2]|0}if(!((D&16384|0)!=0?(f[c>>2]&16384|0)!=0:0)){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,40)|0;q=431284;r=p+40|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,443123,431081,210);bD(h)}D=f[k+16>>2]|0;k=f[c+16>>2]|0;x=f[(f[e>>2]|0)+16>>2]|0;if(d){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,35)|0;q=431162;r=p+35|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,442657,431198,913);bD(h)}d=f[l>>2]|0;if((d|0)>(o|0)){e=f[t>>2]|0;A=1;y=o;while(1){o=Y(f[e+(y<<2)>>2]|0,A)|0;y=y+1|0;if((y|0)==(d|0)){E=o;break}else A=o}}else E=1;if(m){f[h>>2]=0;f[h+4>>2]=0;p=aD(h,35)|0;q=431162;r=p+35|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,h,442657,431198,913);bD(h);F=f[l>>2]|0}else F=d;if((F|0)>(v|0)){d=f[t>>2]|0;t=1;l=v;while(1){v=Y(f[d+(l<<2)>>2]|0,t)|0;l=l+1|0;if((l|0)==(F|0)){G=v;break}else t=v}}else G=1;t=(z|0)==0;if(!t){F=C<<2;l=(C|0)==0;if(w>>>0>1){d=0;do{v=Y(d,E)|0;q=Y(d,G)|0;Vac(x+(q<<2)|0,D+(v<<2)|0,F|0)|0;if(!l){p=1;do{r=(Y(p,G)|0)+v|0;m=0;do{A=x+(m+q<<2)|0;y=D+(r+m<<2)|0;f[A>>2]=f[(+n[A>>2]<+n[y>>2]?y:A)>>2];m=m+1|0}while((m|0)!=(C|0));p=p+1|0}while((p|0)!=(w|0))}d=d+1|0}while((d|0)!=(z|0))}else{d=0;do{Vac(x+((Y(d,G)|0)<<2)|0,D+((Y(d,E)|0)<<2)|0,F|0)|0;d=d+1|0}while((d|0)!=(z|0))}if(!t?(d=(C|0)==0,w|0):0){F=0;do{l=Y(F,E)|0;p=Y(F,G)|0;if(!d){q=0;do{v=(Y(q,G)|0)+l|0;m=0;do{r=v+m|0;n[k+(r<<2)>>2]=+n[D+(r<<2)>>2]-+n[x+(m+p<<2)>>2];m=m+1|0}while((m|0)!=(C|0));q=q+1|0}while((q|0)!=(w|0))}F=F+1|0}while((F|0)!=(z|0))}}f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=c;F=j+8|0;f[F>>2]=0;f[F+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=c;VO(h,j);if(!t){t=(C|0)==0;j=(w|0)==0;h=C<<2;c=(b[a+36>>0]|0)==0|j|t;a=0;do{F=Y(G,a)|0;D=Y(a,E)|0;if(!t)Nac(x+(F<<2)|0,0,h|0)|0;a:do if(!j){do if(!t){d=0;do{q=(Y(d,G)|0)+D|0;p=0;do{l=x+(p+F<<2)|0;n[l>>2]=+n[k+(q+p<<2)>>2]+ +n[l>>2];p=p+1|0}while((p|0)!=(C|0));d=d+1|0}while((d|0)!=(w|0));if(j)break a;if(t)break;else H=0;do{d=(Y(H,G)|0)+D|0;p=0;do{q=k+(d+p<<2)|0;n[q>>2]=+n[q>>2]/+n[x+(p+F<<2)>>2];p=p+1|0}while((p|0)!=(C|0));H=H+1|0}while((H|0)!=(w|0))}while(0);if(!c){p=0;do{d=(Y(p,G)|0)+D|0;q=0;do{l=k+(d+q<<2)|0;I=+W(+(+n[l>>2]));n[l>>2]=I;q=q+1|0}while((q|0)!=(C|0));p=p+1|0}while((p|0)!=(w|0))}}while(0);a=a+1|0}while((a|0)!=(z|0))}if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function ygb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,123288);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function zgb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{if(Owa()|0)c=(f[a+40>>2]|0)==1;else c=0;break}default:c=0}return c|0}function Agb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Bgb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;i=yua(a,b,c,d,e)|0;Bua(h,f[b>>2]|0);b=f[a+40>>2]|0;a=h+4|0;d=f[h>>2]|0;f[d+(((b|0)<0?(f[a>>2]|0)-d>>2:0)+b<<2)>>2]=1;Aua(e,1,h);e=f[h>>2]|0;if(!e){u=g;return i|0}h=f[a>>2]|0;if((h|0)!=(e|0))f[a>>2]=h+(~((h+-4-e|0)>>>2)<<2);O5b(e);u=g;return i|0}function Cgb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;a=d;e=c+4|0;g=f[e>>2]|0;h=f[c>>2]|0;if((g|0)==(h|0)){i=0;j=0;J=j;u=d;return i|0}k=a+4|0;l=0;m=h;h=0;n=0;o=g;while(1){g=m;p=f[g+(l*12|0)+4>>2]|0;q=f[g+(l*12|0)>>2]|0;g=p-q|0;r=g>>2;s=q;do if((s|0)!=(p|0)){if((g|0)<=-4){f[a>>2]=0;f[k>>2]=0;q=aD(a,70)|0;t=442586;v=q+70|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,a,442657,442663,160);bD(a);w=1;x=f[c>>2]|0;y=f[e>>2]|0;break}if((g|0)>0){t=0;q=1;while(1){v=Y(f[s+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)>=(r|0)){w=v;x=m;y=o;break}else q=v}}else{w=1;x=m;y=o}}else{w=0;x=m;y=o}while(0);r=w<<2;s=Kac(r|0,((r|0)<0)<<31>>31|0,h|0,n|0)|0;r=J;l=l+1|0;if(l>>>0>=((y-x|0)/12|0)>>>0){i=s;j=r;break}else{m=x;h=s;n=r;o=y}}J=j;u=d;return i|0}function Dgb(){var a=0,c=0,d=0,e=0;f[213292]=0;f[213293]=0;f[213294]=0;a=L5b(16)|0;f[213292]=a;f[213294]=-2147483632;f[213293]=15;c=a;d=431508;e=c+15|0;do{b[c>>0]=b[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(e|0));b[a+15>>0]=0;zd(1483,853168,x|0)|0;return}function Egb(a,b){a=a|0;b=b|0;var c=0;c=L5b(84)|0;Fgb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=123360;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Fgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0;d=u;u=u+32|0;e=d+8|0;g=d+4|0;h=d;Jwa(a);f[a>>2]=123380;f[a+52>>2]=0;f[a+56>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=L5b(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=11;j=i;k=431612;l=j+11|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+11>>0]=0;f[g>>2]=0;f[h>>2]=0;i=Igb(a,c,e,g,1,h)|0;m=a+36|0;f[m>>2]=i;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=L5b(16)|0;f[e>>2]=i;f[e+8>>2]=-2147483632;f[e+4>>2]=14;j=i;k=431624;l=j+14|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[i+14>>0]=0;f[g>>2]=0;b[h>>0]=0;i=a+40|0;o=(Jgb(a,c,e,g,1,h)|0)&1;b[i>>0]=o;if((b[e+11>>0]|0)<0){O5b(f[e>>2]|0);p=b[i>>0]|0}else p=o;if(!(p<<24>>24))q=f[m>>2]|0;else q=1;f[a+44>>2]=q;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=L5b(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=19;j=q;k=431639;l=j+19|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+19>>0]=0;f[g>>2]=0;f[h>>2]=0;q=Kgb(a,c,e,g,1,h)|0;f[a+48>>2]=q;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=L5b(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=26;j=q;k=431659;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+26>>0]=0;f[g>>2]=0;b[h>>0]=0;q=(Jgb(a,c,e,g,0,h)|0)&1;b[a+60>>0]=q;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);q=e+11|0;b[q>>0]=10;j=e;k=431686;l=j+10|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[e+10>>0]=0;f[g>>2]=0;f[h>>2]=0;m=Kgb(a,c,e,g,1,h)|0;f[a+64>>2]=m;if((b[q>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=L5b(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=20;j=q;k=431697;l=j+20|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+20>>0]=0;f[g>>2]=0;n[h>>2]=-3402823466385288598117041.0e14;r=+Lgb(a,c,e,g,0,h);n[a+68>>2]=r;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=e+11|0;b[q>>0]=5;b[e>>0]=b[431718]|0;b[e+1>>0]=b[431719]|0;b[e+2>>0]=b[431720]|0;b[e+3>>0]=b[431721]|0;b[e+4>>0]=b[431722]|0;b[e+5>>0]=0;f[g>>2]=0;f[h>>2]=-1;m=Kgb(a,c,e,g,0,h)|0;f[a+76>>2]=m;if((b[q>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=L5b(32)|0;f[e>>2]=q;f[e+8>>2]=-2147483616;f[e+4>>2]=19;j=q;k=431724;l=j+19|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+19>>0]=0;f[g>>2]=0;b[h>>0]=0;q=(Jgb(a,c,e,g,0,h)|0)&1;b[a+80>>0]=q;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=L5b(16)|0;f[e>>2]=q;f[e+8>>2]=-2147483632;f[e+4>>2]=15;j=q;k=431744;l=j+15|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+15>>0]=0;f[g>>2]=0;b[h>>0]=1;q=(Jgb(a,c,e,g,0,h)|0)&1;b[a+81>>0]=q;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=e+11|0;b[q>>0]=4;f[e>>2]=1885957219;b[e+4>>0]=0;f[g>>2]=0;b[h>>0]=0;m=(Jgb(a,c,e,g,0,h)|0)&1;b[a+82>>0]=m;if((b[q>>0]|0)<0)O5b(f[e>>2]|0);Mgb(a,c);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=L5b(16)|0;f[e>>2]=q;f[e+8>>2]=-2147483632;f[e+4>>2]=13;j=q;k=431760;l=j+13|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));b[q+13>>0]=0;f[g>>2]=0;n[h>>2]=0.0;r=+Lgb(a,c,e,g,1,h);h=a+72|0;n[h>>2]=r;if((b[e+11>>0]|0)<0){O5b(f[e>>2]|0);s=+n[h>>2]}else s=r;if(s>0.0){Kwa(a,c);u=d;return}f[e>>2]=0;f[e+4>>2]=0;j=aD(e,18)|0;k=431774;l=j+18|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,e,431793,431818,187);bD(e);Kwa(a,c);u=d;return}function Ggb(a){a=a|0;O5b(a);return}function Hgb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Igb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+32|0;j=i+24|0;k=i+8|0;l=i;f[j>>2]=0;m=L5b(16)|0;n=m+8|0;f[m>>2]=n;f[m+4>>2]=1;f[j+4>>2]=m;m=n;f[m>>2]=0;f[m+4>>2]=0;if(Ngb(a,c,d,j)|0){c=Gwa(j,f[e>>2]|0)|0;o=c;gua(j);u=i;return o|0}if(!g){o=f[h>>2]|0;gua(j);u=i;return o|0}X5b(k,853168);k6b(k,431949)|0;o=b[d+11>>0]|0;i=o<<24>>24<0;j6b(k,i?f[d>>2]|0:d,i?f[d+4>>2]|0:o&255)|0;k6b(k,431984)|0;f[l>>2]=0;f[l+4>>2]=0;o=k+11|0;d=b[o>>0]|0;i=d<<24>>24<0?f[k+4>>2]|0:d&255;if(!i)Ogb(-5,l,431996,150);d=aD(l,i)|0;Vac(d|0,((b[o>>0]|0)<0?f[k>>2]|0:k)|0,i|0)|0;Ogb(-5,l,431996,150);return 0}function Jgb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+32|0;j=i+24|0;k=i+8|0;l=i;f[j>>2]=0;m=L5b(16)|0;n=m+8|0;f[m>>2]=n;f[m+4>>2]=1;f[j+4>>2]=m;m=n;f[m>>2]=0;f[m+4>>2]=0;if(Ngb(a,c,d,j)|0){c=Gwa(j,f[e>>2]|0)|0;o=(c|0)!=0|(J|0)!=0;gua(j);u=i;return o|0}if(!g){o=(b[h>>0]|0)!=0;gua(j);u=i;return o|0}X5b(k,853168);k6b(k,431949)|0;o=b[d+11>>0]|0;i=o<<24>>24<0;j6b(k,i?f[d>>2]|0:d,i?f[d+4>>2]|0:o&255)|0;k6b(k,431984)|0;f[l>>2]=0;f[l+4>>2]=0;o=k+11|0;d=b[o>>0]|0;i=d<<24>>24<0?f[k+4>>2]|0:d&255;if(!i)Ogb(-5,l,431996,150);d=aD(l,i)|0;Vac(d|0,((b[o>>0]|0)<0?f[k>>2]|0:k)|0,i|0)|0;Ogb(-5,l,431996,150);return 0}function Kgb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+32|0;j=i+24|0;k=i+8|0;l=i;f[j>>2]=0;m=L5b(16)|0;n=m+8|0;f[m>>2]=n;f[m+4>>2]=1;f[j+4>>2]=m;m=n;f[m>>2]=0;f[m+4>>2]=0;if(Ngb(a,c,d,j)|0){c=Gwa(j,f[e>>2]|0)|0;o=c;gua(j);u=i;return o|0}if(!g){o=f[h>>2]|0;gua(j);u=i;return o|0}X5b(k,853168);k6b(k,431949)|0;o=b[d+11>>0]|0;i=o<<24>>24<0;j6b(k,i?f[d>>2]|0:d,i?f[d+4>>2]|0:o&255)|0;k6b(k,431984)|0;f[l>>2]=0;f[l+4>>2]=0;o=k+11|0;d=b[o>>0]|0;i=d<<24>>24<0?f[k+4>>2]|0:d&255;if(!i)Ogb(-5,l,431996,150);d=aD(l,i)|0;Vac(d|0,((b[o>>0]|0)<0?f[k>>2]|0:k)|0,i|0)|0;Ogb(-5,l,431996,150);return 0}function Lgb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0.0;i=u;u=u+32|0;j=i+24|0;k=i+8|0;l=i;f[j>>2]=0;m=L5b(16)|0;o=m+8|0;f[m>>2]=o;f[m+4>>2]=1;f[j+4>>2]=m;m=o;f[m>>2]=0;f[m+4>>2]=0;if(Ngb(a,c,d,j)|0){p=+Hya(j,f[e>>2]|0);gua(j);u=i;return +p}if(!g){p=+n[h>>2];gua(j);u=i;return +p}X5b(k,853168);k6b(k,431949)|0;i=b[d+11>>0]|0;j=i<<24>>24<0;j6b(k,j?f[d>>2]|0:d,j?f[d+4>>2]|0:i&255)|0;k6b(k,431984)|0;f[l>>2]=0;f[l+4>>2]=0;i=k+11|0;d=b[i>>0]|0;j=d<<24>>24<0?f[k+4>>2]|0:d&255;if(!j)Ogb(-5,l,431996,150);d=aD(l,j)|0;Vac(d|0,((b[i>>0]|0)<0?f[k>>2]|0:k)|0,j|0)|0;Ogb(-5,l,431996,150);return +(0.0)}function Mgb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+32|0;e=d+24|0;g=d+16|0;h=d;i=d+8|0;f[i>>2]=0;f[i+4>>2]=0;j=aD(i,9)|0;k=431908;l=j+9|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));Hwa(h,Eya(c,i)|0,-1);c=f[h>>2]|0;if(!c){f[g>>2]=0;f[g+4>>2]=0}else{m=h+4|0;n=f[m>>2]|0;f[e>>2]=0;o=e+4|0;f[o>>2]=0;if(n|0?(Vac(aD(e,n)|0,c|0,n|0)|0,f[m>>2]|0):0){n=0;do{c=(gVb(b[(f[h>>2]|0)+n>>0]|0)|0)&255;b[(f[e>>2]|0)+n>>0]=c;n=n+1|0}while(n>>>0<(f[m>>2]|0)>>>0)}m=f[e>>2]|0;f[g>>2]=m;f[g+4>>2]=f[o>>2];if(m|0){o=m+-4|0;f[o>>2]=(f[o>>2]|0)+1}bD(e)}bD(h);bD(i);i=f[g>>2]|0;if((i|0)!=431918){h=a+52|0;if(!(gTb((i|0)==0?1124530:i,431918)|0))p=h;else{bD(h);i=aD(h,6)|0;b[i>>0]=b[431942]|0;b[i+1>>0]=b[431943]|0;b[i+2>>0]=b[431944]|0;b[i+3>>0]=b[431945]|0;b[i+4>>0]=b[431946]|0;b[i+5>>0]=b[431947]|0;bD(g);u=d;return}}else p=a+52|0;bD(p);j=aD(p,11)|0;k=431930;l=j+11|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bD(g);u=d;return}function Ngb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=u;u=u+16|0;g=a;f[g>>2]=0;f[g+4>>2]=0;h=d+11|0;i=b[h>>0]|0;j=d+4|0;k=i<<24>>24<0?f[j>>2]|0:i&255;if(k|0){i=aD(g,k)|0;Vac(i|0,((b[h>>0]|0)<0?f[d>>2]|0:d)|0,k|0)|0}k=f[c+4>>2]|0;a:do if(k|0){i=f[g>>2]|0;l=(i|0)==0?1124530:i;m=k;while(1){n=f[m+16>>2]|0;if((i|0)==(n|0))break;o=(n|0)==0?1124530:n;if((gTb(l,o)|0)<0)p=m;else{if((gTb(o,l)|0)>=0)break;p=m+4|0}m=f[p>>2]|0;if(!m)break a}bD(g);f[g>>2]=0;f[g+4>>2]=0;m=b[h>>0]|0;l=m<<24>>24<0?f[j>>2]|0:m&255;if(l|0){m=aD(g,l)|0;Vac(m|0,((b[h>>0]|0)<0?f[d>>2]|0:d)|0,l|0)|0}$xa(e,Eya(c,g)|0)|0;bD(g);q=1;u=a;return q|0}while(0);bD(g);q=0;u=a;return q|0}function Ogb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;bO(a,b,c,431818,d);return}function Pgb(a){a=a|0;f[a>>2]=123380;bD(a+52|0);lua(a);return}function Qgb(a){a=a|0;f[a>>2]=123380;bD(a+52|0);lua(a);O5b(a);return}function Rgb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=u;u=u+208|0;g=e+192|0;h=e+176|0;i=e+164|0;j=e+152|0;k=e+120|0;l=e+104|0;m=e;o=e+80|0;q=e+72|0;r=e+16|0;dQ(g,123504);f[h>>2]=0;s=h+4|0;f[s>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;t=f[c>>2]|0;v=f[t>>2]|0;w=f[f[v+40>>2]>>2]|0;x=f[t+8>>2]|0;y=(f[(f[x+40>>2]|0)+8>>2]|0)/4|0;f[j>>2]=y;z=f[v+16>>2]|0;v=f[(f[t+4>>2]|0)+16>>2]|0;t=f[x+16>>2]|0;f[k>>2]=0;x=k+4|0;f[x>>2]=0;f[k+8>>2]=0;A=a+44|0;B=a+40|0;Ugb(z,w,y,f[A>>2]|0,(b[B>>0]|0)!=0,(b[a+80>>0]|0)!=0,k);Vgb(v,w,f[j>>2]|0,f[a+36>>2]|0,i);f[l>>2]=0;v=l+4|0;f[v>>2]=0;f[l+8>>2]=0;f[m>>2]=0;y=m+4|0;f[y>>2]=0;f[m+8>>2]=0;z=a+81|0;Wgb(t,j,(b[z>>0]|0)!=0,l,m);n[o+20>>2]=0.0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;b[o+16>>0]=0;t=a+82|0;a:do if(b[t>>0]|0){do if(!(b[z>>0]|0)){if((f[c+4>>2]|0)-(f[c>>2]|0)>>2>>>0<=3){f[q>>2]=0;f[q+4>>2]=0;C=aD(q,39)|0;D=432269;E=C+39|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,q,443123,431818,406);bD(q);F=b[z>>0]|0;n[o+4>>2]=0.0;n[o>>2]=0.0;if(F<<24>>24)break}else{n[o+4>>2]=0.0;n[o>>2]=0.0}F=f[(f[c>>2]|0)+12>>2]|0;if((f[F+4>>2]|0)==4)G=F;else{f[q>>2]=0;f[q+4>>2]=0;C=aD(q,20)|0;D=432309;E=C+20|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,q,443123,431818,413);bD(q);G=f[(f[c>>2]|0)+12>>2]|0}F=f[G+40>>2]|0;n[o+8>>2]=+((f[F+12>>2]|0)+-1|0);n[o+12>>2]=+((f[F+8>>2]|0)+-1|0);break a}else{n[o+4>>2]=0.0;n[o>>2]=0.0}while(0);n[o+12>>2]=1.0;n[o+8>>2]=1.0}while(0);Xgb(k,l,m,w,(b[B>>0]|0)!=0,f[A>>2]|0,f[a+48>>2]|0,a+52|0,(b[a+60>>0]|0)!=0,(b[t>>0]|0)!=0,o,(b[z>>0]|0)!=0,h);z=f[m>>2]|0;if(z|0){o=f[y>>2]|0;if((o|0)==(z|0))H=z;else{t=o;while(1){o=t+-12|0;f[y>>2]=o;A=f[o>>2]|0;if(!A)I=o;else{o=t+-8|0;B=f[o>>2]|0;if((B|0)!=(A|0))f[o>>2]=B+(~((B+-4-A|0)>>>2)<<2);O5b(A);I=f[y>>2]|0}if((I|0)==(z|0))break;else t=I}H=f[m>>2]|0}O5b(H)}H=f[l>>2]|0;if(H|0){I=f[v>>2]|0;if((I|0)!=(H|0))f[v>>2]=I+(~(((I+-24-H|0)>>>0)/24|0)*24|0);O5b(H)}H=f[k>>2]|0;if(H|0){I=f[x>>2]|0;if((I|0)==(H|0))J=H;else{v=I;do{I=v+-12|0;f[x>>2]=I;Ygb(I,f[v+-8>>2]|0);v=f[x>>2]|0}while((v|0)!=(H|0));J=f[k>>2]|0}O5b(J)}f[j>>2]=0;J=j+4|0;f[J>>2]=0;f[j+8>>2]=0;H=(w|0)>0;if(H){v=0;x=0;do{x=(Zgb(a,(f[h>>2]|0)+(v*12|0)|0,(f[i>>2]|0)+(v*56|0)|0,j)|0)+x|0;v=v+1|0}while((v|0)<(w|0));if(x){f[k>>2]=1;f[k+4>>2]=1;f[k+8>>2]=x;f[k+12>>2]=7;hL(f[d>>2]|0,4,k,5);v=f[(f[d>>2]|0)+16>>2]|0;if(H){H=0;I=0;while(1){t=(_gb(a,H,v+(I*7<<2)|0,(f[h>>2]|0)+(H*12|0)|0,(f[i>>2]|0)+(H*56|0)|0,(f[j>>2]|0)+(H*12|0)|0)|0)+I|0;H=H+1|0;if((H|0)>=(w|0)){K=t;break}else I=t}}else K=0;if((K|0)!=(x|0)){f[l>>2]=0;f[l+4>>2]=0;C=aD(l,16)|0;D=432330;E=C+16|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,l,443123,431818,449);bD(l)}}else L=34}else L=34;if((L|0)==34){f[k>>2]=-2147483648;f[k+4>>2]=2147483647;f[k+8>>2]=-2147483648;f[k+12>>2]=2147483647;f[k+16>>2]=-2147483648;f[k+20>>2]=2147483647;f[k+24>>2]=2;f[k+28>>2]=3;mL(r,f[d>>2]|0,k);p[m>>3]=0.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;VP(r,l,UM()|0)|0;l=r+36|0;m=f[l>>2]|0;if(m|0?(k=m+12|0,m=f[k>>2]|0,f[k>>2]=m+-1,(m|0)==1):0)kL(r);f[l>>2]=0;l=r+16|0;m=r+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[r+40>>2]|0;k=0;do{f[l+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[m>>2]|0))}m=f[r+44>>2]|0;if((m|0)!=(r+48|0))UC(m)}m=f[j>>2]|0;if(m|0){r=f[J>>2]|0;if((r|0)==(m|0))M=m;else{k=r;do{r=k+-12|0;f[J>>2]=r;owa(r,f[k+-8>>2]|0);k=f[J>>2]|0}while((k|0)!=(m|0));M=f[j>>2]|0}O5b(M)}et(i);i=f[h>>2]|0;if(i|0){M=f[s>>2]|0;if((M|0)==(i|0))N=i;else{j=M;do{M=j+-12|0;f[s>>2]=M;Ygb(M,f[j+-8>>2]|0);j=f[s>>2]|0}while((j|0)!=(i|0));N=f[h>>2]|0}O5b(N)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Sgb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,123472);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Tgb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+32|0;d=g+16|0;h=g;i=f[c>>2]|0;if((((f[c+4>>2]|0)-i|0)/12|0)>>>0>2){j=c;k=i}else{f[d>>2]=0;f[d+4>>2]=0;l=aD(d,18)|0;m=432009;n=l+18|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,442770,431818,197);bD(d);j=c;k=f[c>>2]|0}if((f[f[k>>2]>>2]|0)==(f[f[k+12>>2]>>2]|0))o=k;else{f[d>>2]=0;f[d+4>>2]=0;l=aD(d,28)|0;m=432028;n=l+28|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,442770,431818,198);bD(d);o=f[j>>2]|0}k=(f[(f[o+24>>2]|0)+8>>2]|0)/4|0;c=Y(f[a+44>>2]<<2,k)|0;if((c|0)==(f[(f[o>>2]|0)+4>>2]|0))p=o;else{f[d>>2]=0;f[d+4>>2]=0;l=aD(d,48)|0;m=432057;n=l+48|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,442770,431818,201);bD(d);p=f[j>>2]|0}j=Y(f[a+36>>2]|0,k)|0;if((j|0)!=(f[(f[p+12>>2]|0)+4>>2]|0)){f[d>>2]=0;f[d+4>>2]=0;l=aD(d,44)|0;m=432106;n=l+44|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,442770,431818,202);bD(d)}f[d>>2]=1;f[d+4>>2]=1;f[d+8>>2]=1;f[d+12>>2]=7;f[h>>2]=0;m=h+4|0;f[m>>2]=0;f[h+8>>2]=0;Rva(h,d,d+16|0);d=f[h>>2]|0;l=f[m>>2]|0;a:do if((d|0)==(l|0)){q=d;r=13}else{n=d;do{if((f[n>>2]|0)<0){q=n;r=13;break a}n=n+4|0}while((n|0)!=(l|0))}while(0);if((r|0)==13?(q|0)!=(l|0):0){r=q+4|0;if((r|0)==(l|0)){s=l;t=q}else{d=r;r=q;while(1){q=f[d>>2]|0;if((q|0)<0)v=r;else{f[r>>2]=q;v=r+4|0}d=d+4|0;if((d|0)==(l|0))break;else r=v}s=f[m>>2]|0;t=v}if((t|0)!=(s|0))f[m>>2]=s+(~((s+-4-t|0)>>>2)<<2)}t=e+4|0;s=f[t>>2]|0;v=f[e>>2]|0;r=s-v|0;l=(r|0)/12|0;d=v;v=s;if(r){if(l>>>0>1?(r=d+12|0,(v|0)!=(r|0)):0){d=v;while(1){v=d+-12|0;f[t>>2]=v;s=f[v>>2]|0;if(!s)w=v;else{v=d+-8|0;q=f[v>>2]|0;if((q|0)!=(s|0))f[v>>2]=q+(~((q+-4-s|0)>>>2)<<2);O5b(s);w=f[t>>2]|0}if((w|0)==(r|0))break;else d=w}}}else sbb(e,1-l|0,h);l=f[h>>2]|0;if(!l){u=g;return 0}h=f[m>>2]|0;if((h|0)!=(l|0))f[m>>2]=h+(~((h+-4-l|0)>>>2)<<2);O5b(l);u=g;return 0}function Ugb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;j=u;u=u+16|0;k=j;l=f[i>>2]|0;m=i+4|0;n=f[m>>2]|0;if((n|0)==(l|0))o=n;else{p=n;while(1){n=p+-12|0;f[m>>2]=n;Ygb(n,f[p+-8>>2]|0);n=f[m>>2]|0;if((n|0)==(l|0)){o=n;break}else p=n}}if((e|0)==1|g^1)q=o;else{f[k>>2]=0;f[k+4>>2]=0;o=aD(k,18)|0;p=432870;l=o+18|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(l|0));bO(-215,k,432889,431818,766);bD(k);q=f[m>>2]|0}k=f[i>>2]|0;p=(q-k|0)/12|0;o=k;k=q;if(p>>>0>=c>>>0){if(p>>>0>c>>>0?(q=o+(c*12|0)|0,(k|0)!=(q|0)):0){o=k;do{k=o+-12|0;f[m>>2]=k;Ygb(k,f[o+-8>>2]|0);o=f[m>>2]|0}while((o|0)!=(q|0))}}else nhb(i,c-p|0);if((c|0)<=0){u=j;return}p=(d|0)>0;q=Y(d<<2,e)|0;o=(e|0)>0;m=a;a=0;while(1){k=f[i>>2]|0;l=k+(a*12|0)|0;if(p){n=k+(a*12|0)+4|0;r=k+(a*12|0)+4|0;s=k+(a*12|0)+8|0;k=0;do{t=Y(k,e)|0;if(o){v=0;do{w=g?-1:v;x=f[n>>2]|0;do if(x){y=n;z=x;a:while(1){A=z;while(1){if((f[A+16>>2]|0)>=(w|0))break;B=f[A+4>>2]|0;if(!B){C=y;break a}else A=B}z=f[A>>2]|0;if(!z){C=A;break}else y=A}if((C|0)!=(n|0)?(w|0)>=(f[C+16>>2]|0):0)break;y=r;z=x;B=x;while(1){D=f[z+16>>2]|0;if((w|0)<(D|0)){E=f[z>>2]|0;if(!E){F=30;break}else{G=z;H=E}}else{if((D|0)>=(w|0)){F=34;break}I=z+4|0;D=f[I>>2]|0;if(!D){F=33;break}else{G=I;H=D}}y=G;z=H;B=H}if((F|0)==30){F=0;J=z;K=z;F=35;break}else if((F|0)==33){F=0;J=I;K=z;F=35;break}else if((F|0)==34){F=0;if(!B){J=y;K=z;F=35;break}else{L=B;F=38;break}}}else{J=n;K=n;F=35}while(0);if((F|0)==35){F=0;x=L5b(32)|0;f[x+16>>2]=w;f[x+20>>2]=0;f[x+24>>2]=0;f[x+28>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=K;f[J>>2]=x;D=f[f[l>>2]>>2]|0;if(!D)M=x;else{f[l>>2]=D;M=f[J>>2]|0}mP(f[r>>2]|0,M);f[s>>2]=(f[s>>2]|0)+1;L=x;F=38}do if((F|0)==38){F=0;x=L+20|0;D=L+24|0;E=f[D>>2]|0;N=f[x>>2]|0;O=(E-N|0)/24|0;P=E;if(O>>>0<d>>>0){phb(x,d-O|0);break}if(O>>>0>d>>>0?(O=N+(d*24|0)|0,(P|0)!=(O|0)):0)f[D>>2]=P+(~(((P+-24-O|0)>>>0)/24|0)*24|0)}while(0);O=f[n>>2]|0;do if(O){P=r;D=O;N=O;while(1){x=f[D+16>>2]|0;if((w|0)<(x|0)){E=f[D>>2]|0;if(!E){F=47;break}else{Q=D;R=E}}else{if((x|0)>=(w|0)){F=51;break}S=D+4|0;x=f[S>>2]|0;if(!x){F=50;break}else{Q=S;R=x}}P=Q;D=R;N=R}if((F|0)==47){F=0;T=D;U=D;F=53;break}else if((F|0)==50){F=0;T=S;U=D;F=53;break}else if((F|0)==51){F=0;V=P;W=D;X=N;F=52;break}}else{V=n;W=n;X=O;F=52}while(0);if((F|0)==52){F=0;if(!X){T=V;U=W;F=53}else Z=X}if((F|0)==53){F=0;O=L5b(32)|0;f[O+16>>2]=w;f[O+20>>2]=0;f[O+24>>2]=0;f[O+28>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=U;f[T>>2]=O;B=f[f[l>>2]>>2]|0;if(!B)_=O;else{f[l>>2]=B;_=f[T>>2]|0}mP(f[r>>2]|0,_);f[s>>2]=(f[s>>2]|0)+1;Z=O}O=f[Z+20>>2]|0;B=O+(k*24|0)|0;z=v+t<<2;y=f[m+(z<<2)>>2]|0;x=z|1;E=z|2;if(h){f[O+(k*24|0)+4>>2]=y;f[B>>2]=f[m+(x<<2)>>2];f[O+(k*24|0)+12>>2]=f[m+(E<<2)>>2];$=O+(k*24|0)+8|0}else{f[B>>2]=y;f[O+(k*24|0)+4>>2]=f[m+(x<<2)>>2];f[O+(k*24|0)+8>>2]=f[m+(E<<2)>>2];$=O+(k*24|0)+12|0}f[$>>2]=f[m+((z|3)<<2)>>2];v=v+1|0}while((v|0)!=(e|0))}k=k+1|0}while((k|0)!=(d|0))}a=a+1|0;if((a|0)==(c|0))break;else m=m+(q<<2)|0}u=j;return}function Vgb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+64|0;h=g+56|0;i=g;f[h>>2]=d;f[h+4>>2]=c;j=(b|0)>0;if(!j){u=g;return}k=i+4|0;l=i+8|0;m=i+40|0;n=i+48|0;o=i+44|0;p=i+52|0;q=e+4|0;r=e+8|0;s=i+36|0;t=i+16|0;v=i+12|0;w=i+20|0;x=i+24|0;y=i+28|0;z=i+32|0;A=0;do{f[i>>2]=1124007936;B=k;C=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));f[m>>2]=l;f[o>>2]=n;f[n>>2]=0;f[p>>2]=0;hL(i,2,h,5);B=f[q>>2]|0;if((B|0)==(f[r>>2]|0))v2(e,i);else{f[B>>2]=f[i>>2];C=B+4|0;f[C>>2]=f[k>>2];D=B+8|0;f[D>>2]=f[l>>2];f[B+12>>2]=f[v>>2];f[B+16>>2]=f[t>>2];f[B+20>>2]=f[w>>2];f[B+24>>2]=f[x>>2];f[B+28>>2]=f[y>>2];f[B+32>>2]=f[z>>2];E=f[s>>2]|0;f[B+36>>2]=E;f[B+40>>2]=D;D=B+48|0;F=B+44|0;f[F>>2]=D;f[D>>2]=0;f[B+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[k>>2]|0)<3){D=f[o>>2]|0;E=f[F>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2]}else{f[C>>2]=0;jL(B,i)}f[q>>2]=(f[q>>2]|0)+56}B=f[s>>2]|0;if(B|0?(C=B+12|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)kL(i);f[s>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[k>>2]|0)>0){B=f[m>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[k>>2]|0))}C=f[o>>2]|0;if((C|0)!=(n|0))UC(C);A=A+1|0}while((A|0)<(b|0));if(!j){u=g;return}j=i+4|0;A=i+8|0;n=i+12|0;o=i+16|0;k=i+20|0;m=i+24|0;t=i+28|0;s=i+32|0;q=i+36|0;z=i+40|0;y=i+48|0;x=i+44|0;w=i+52|0;v=(d|0)>0;l=(c|0)>0;r=Y(d,c)|0;h=0;p=a;while(1){a=f[e>>2]|0;C=a+(h*56|0)|0;f[i>>2]=f[C>>2];B=a+(h*56|0)+4|0;f[j>>2]=f[B>>2];f[A>>2]=f[a+(h*56|0)+8>>2];f[n>>2]=f[a+(h*56|0)+12>>2];f[o>>2]=f[a+(h*56|0)+16>>2];f[k>>2]=f[a+(h*56|0)+20>>2];f[m>>2]=f[a+(h*56|0)+24>>2];f[t>>2]=f[a+(h*56|0)+28>>2];f[s>>2]=f[a+(h*56|0)+32>>2];D=f[a+(h*56|0)+36>>2]|0;f[q>>2]=D;f[z>>2]=A;f[x>>2]=y;f[y>>2]=0;f[w>>2]=0;if(D|0){E=D+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[B>>2]|0)<3){B=f[a+(h*56|0)+44>>2]|0;a=f[x>>2]|0;f[a>>2]=f[B>>2];f[a+4>>2]=f[B+4>>2]}else{f[j>>2]=0;jL(i,C)}if(v?(C=f[o>>2]|0,l):0){B=f[f[x>>2]>>2]|0;a=0;do{E=C+(Y(B,a)|0)|0;D=0;do{F=p+((Y(D,d)|0)+a<<2)|0;f[E+(D<<2)>>2]=f[F>>2];D=D+1|0}while((D|0)!=(c|0));a=a+1|0}while((a|0)!=(d|0))}a=f[q>>2]|0;if(a|0?(B=a+12|0,a=f[B>>2]|0,f[B>>2]=a+-1,(a|0)==1):0)kL(i);f[q>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[j>>2]|0)>0){a=f[z>>2]|0;B=0;do{f[a+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[j>>2]|0))}B=f[x>>2]|0;if((B|0)!=(y|0))UC(B);h=h+1|0;if((h|0)==(b|0))break;else p=p+(r<<2)|0}u=g;return}function Wgb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[e>>2]|0;i=e+4|0;j=f[i>>2]|0;k=h;if((j|0)==(h|0))l=j;else{m=j+(~(((j+-24-k|0)>>>0)/24|0)*24|0)|0;f[i>>2]=m;l=m}m=f[c>>2]|0;j=(l-k|0)/24|0;if(m>>>0<=j>>>0){if(m>>>0<j>>>0?(k=h+(m*24|0)|0,(l|0)!=(k|0)):0)f[i>>2]=l+(~(((l+-24-k|0)>>>0)/24|0)*24|0)}else phb(e,m-j|0);j=f[g>>2]|0;m=g+4|0;k=f[m>>2]|0;if((k|0)==(j|0)){o=k;p=j}else{l=k;while(1){k=l+-12|0;f[m>>2]=k;i=f[k>>2]|0;if(!i)q=k;else{k=l+-8|0;h=f[k>>2]|0;if((h|0)!=(i|0))f[k>>2]=h+(~((h+-4-i|0)>>>2)<<2);O5b(i);q=f[m>>2]|0}if((q|0)==(j|0))break;else l=q}o=q;p=f[g>>2]|0}q=f[c>>2]|0;l=(o-p|0)/12|0;j=p;if(q>>>0<=l>>>0){if(q>>>0<l>>>0?(p=j+(q*12|0)|0,(o|0)!=(p|0)):0){j=o;while(1){o=j+-12|0;f[m>>2]=o;i=f[o>>2]|0;if(!i)r=o;else{o=j+-8|0;h=f[o>>2]|0;if((h|0)!=(i|0))f[o>>2]=h+(~((h+-4-i|0)>>>2)<<2);O5b(i);r=f[m>>2]|0}if((r|0)==(p|0))break;else j=r}}}else vhb(g,q-l|0);l=f[c>>2]|0;q=(l|0)>0;if(!q)return;r=f[e>>2]|0;if(d){d=0;do{e=d<<2;j=f[a+(e<<2)>>2]|0;f[r+(d*24|0)>>2]=j;p=f[a+((e|1)<<2)>>2]|0;f[r+(d*24|0)+4>>2]=p;m=f[a+((e|2)<<2)>>2]|0;f[r+(d*24|0)+8>>2]=m;i=f[a+((e|3)<<2)>>2]|0;f[r+(d*24|0)+12>>2]=i;t=(f[s>>2]=m,+n[s>>2]);u=(f[s>>2]=j,+n[s>>2]);v=(f[s>>2]=i,+n[s>>2]);w=(f[s>>2]=p,+n[s>>2]);do if(!(t<u|v<w))if(!(b[r+(d*24|0)+16>>0]|0)){x=(t-u)*(v-w);break}else{x=+n[r+(d*24|0)+20>>2];break}else x=0.0;while(0);n[r+(d*24|0)+20>>2]=x;b[r+(d*24|0)+16>>0]=1;d=d+1|0}while((d|0)<(l|0))}else{d=0;do{p=d<<2;i=f[a+(p<<2)>>2]|0;f[r+(d*24|0)>>2]=i;j=f[a+((p|1)<<2)>>2]|0;f[r+(d*24|0)+4>>2]=j;m=f[a+((p|2)<<2)>>2]|0;f[r+(d*24|0)+8>>2]=m;e=f[a+((p|3)<<2)>>2]|0;f[r+(d*24|0)+12>>2]=e;x=(f[s>>2]=m,+n[s>>2]);w=(f[s>>2]=i,+n[s>>2]);v=(f[s>>2]=e,+n[s>>2]);u=(f[s>>2]=j,+n[s>>2]);do if(!(x<w|v<u))if(!(b[r+(d*24|0)+16>>0]|0)){y=(x-w+1.0)*(v-u+1.0);break}else{y=+n[r+(d*24|0)+20>>2];break}else y=0.0;while(0);n[r+(d*24|0)+20>>2]=y;b[r+(d*24|0)+16>>0]=1;d=d+1|0}while((d|0)<(l|0))}if(q){z=0;A=l}else return;do{l=A+z<<2;q=f[g>>2]|0;d=a+(l<<2)|0;r=q+(z*12|0)+4|0;j=f[r>>2]|0;e=f[q+(z*12|0)+8>>2]|0;if((j|0)==(e|0)){upa(q+(z*12|0)|0,d);i=f[g>>2]|0;B=f[i+(z*12|0)+4>>2]|0;C=f[i+(z*12|0)+8>>2]|0;D=i}else{f[j>>2]=f[d>>2];d=j+4|0;f[r>>2]=d;B=d;C=e;D=q}q=a+((l|1)<<2)|0;if((B|0)==(C|0)){upa(D+(z*12|0)|0,q);e=f[g>>2]|0;E=f[e+(z*12|0)+4>>2]|0;F=f[e+(z*12|0)+8>>2]|0;G=e}else{f[B>>2]=f[q>>2];q=B+4|0;f[D+(z*12|0)+4>>2]=q;E=q;F=C;G=D}q=a+((l|2)<<2)|0;if((E|0)==(F|0)){upa(G+(z*12|0)|0,q);e=f[g>>2]|0;H=f[e+(z*12|0)+4>>2]|0;I=f[e+(z*12|0)+8>>2]|0;J=e}else{f[E>>2]=f[q>>2];q=E+4|0;f[G+(z*12|0)+4>>2]=q;H=q;I=F;J=G}q=a+((l|3)<<2)|0;if((H|0)==(I|0))upa(J+(z*12|0)|0,q);else{f[H>>2]=f[q>>2];f[J+(z*12|0)+4>>2]=H+4}z=z+1|0;A=f[c>>2]|0}while((z|0)<(A|0));return}function Xgb(a,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;p=u;u=u+16|0;q=p;r=p+8|0;if((((f[a+4>>2]|0)-(f[a>>2]|0)|0)/12|0|0)!=(e|0)){f[r>>2]=0;f[r+4>>2]=0;s=aD(r,27)|0;t=432622;v=s+27|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,r,432650,431818,691);bD(r)}t=f[o>>2]|0;s=o+4|0;v=f[s>>2]|0;if((v|0)==(t|0)){w=v;x=t}else{y=v;do{v=y+-12|0;f[s>>2]=v;Ygb(v,f[y+-8>>2]|0);y=f[s>>2]|0}while((y|0)!=(t|0));w=y;x=f[o>>2]|0}y=(w-x|0)/12|0;t=x;if(y>>>0>=e>>>0){if(y>>>0>e>>>0?(x=t+(e*12|0)|0,(w|0)!=(x|0)):0){t=w;do{w=t+-12|0;f[s>>2]=w;Ygb(w,f[t+-8>>2]|0);t=f[s>>2]|0}while((t|0)!=(x|0))}}else nhb(o,e-y|0);if((e|0)<=0){u=p;return}y=(h|0)>0;x=(i|0)==-1;t=0;a:while(1){s=f[o>>2]|0;w=s+(t*12|0)|0;if(y){v=(f[a>>2]|0)+(t*12|0)+4|0;z=s+(t*12|0)+4|0;A=s+(t*12|0)+4|0;B=s+(t*12|0)+8|0;if(g){s=0;do{if(!x){C=f[v>>2]|0;if(!C){D=-1;E=49;break a}else{F=v;G=C}b:while(1){C=G;while(1){if((f[C+16>>2]|0)>=-1)break;H=f[C+4>>2]|0;if(!H){I=F;break b}else C=H}G=f[C>>2]|0;if(!G){I=C;break}else F=C}if((I|0)==(v|0)){D=-1;E=49;break a}if((f[I+16>>2]|0)>-1){D=-1;E=49;break a}H=I+20|0;J=f[z>>2]|0;do if(J){K=A;L=J;M=J;while(1){N=f[L+16>>2]|0;if((N|0)>-1){O=f[L>>2]|0;if(!O){E=33;break}else{P=L;Q=O}}else{if((N|0)==-1){E=28;break}R=L+4|0;N=f[R>>2]|0;if(!N){E=30;break}else{P=R;Q=N}}K=P;L=Q;M=Q}if((E|0)==28){E=0;S=K;T=L;U=M;E=34;break}else if((E|0)==30){E=0;V=R;W=L;E=35;break}else if((E|0)==33){E=0;V=L;W=L;E=35;break}}else{S=z;T=z;U=J;E=34}while(0);if((E|0)==34){E=0;if(!U){V=S;W=T;E=35}else X=U}if((E|0)==35){E=0;J=L5b(32)|0;f[J+16>>2]=-1;f[J+20>>2]=0;f[J+24>>2]=0;f[J+28>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=W;f[V>>2]=J;C=f[f[w>>2]>>2]|0;if(!C)Y=J;else{f[w>>2]=C;Y=f[V>>2]|0}mP(f[A>>2]|0,Y);f[B>>2]=(f[B>>2]|0)+1;X=J}ohb(c,d,j,k,l,m,n,H,X+20|0)}s=s+1|0}while((s|0)<(h|0))}else{s=0;do{if((s|0)!=(i|0)){J=f[v>>2]|0;if(!J){D=s;E=49;break a}else{Z=v;_=J}c:while(1){J=_;while(1){if((f[J+16>>2]|0)>=(s|0))break;C=f[J+4>>2]|0;if(!C){$=Z;break c}else J=C}_=f[J>>2]|0;if(!_){$=J;break}else Z=J}if(($|0)==(v|0)){D=s;E=49;break a}if((s|0)<(f[$+16>>2]|0)){D=s;E=49;break a}H=$+20|0;L=f[z>>2]|0;do if(L){M=A;K=L;C=L;while(1){N=f[K+16>>2]|0;if((s|0)<(N|0)){O=f[K>>2]|0;if(!O){E=54;break}else{aa=K;ba=O}}else{if((N|0)>=(s|0)){E=58;break}ca=K+4|0;N=f[ca>>2]|0;if(!N){E=57;break}else{aa=ca;ba=N}}M=aa;K=ba;C=ba}if((E|0)==54){E=0;da=K;ea=K;E=60;break}else if((E|0)==57){E=0;da=ca;ea=K;E=60;break}else if((E|0)==58){E=0;fa=M;ga=K;ha=C;E=59;break}}else{fa=z;ga=z;ha=L;E=59}while(0);if((E|0)==59){E=0;if(!ha){da=fa;ea=ga;E=60}else ia=ha}if((E|0)==60){E=0;L=L5b(32)|0;f[L+16>>2]=s;f[L+20>>2]=0;f[L+24>>2]=0;f[L+28>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=ea;f[da>>2]=L;J=f[f[w>>2]>>2]|0;if(!J)ja=L;else{f[w>>2]=J;ja=f[da>>2]|0}mP(f[A>>2]|0,ja);f[B>>2]=(f[B>>2]|0)+1;ia=L}ohb(c,d,j,k,l,m,n,H,ia+20|0)}s=s+1|0}while((s|0)<(h|0))}}t=t+1|0;if((t|0)>=(e|0)){E=14;break}}if((E|0)==14){u=p;return}else if((E|0)==49){f[q>>2]=D;hO(r,432416,q);Ogb(-2,r,432650,706)}}function Ygb(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b)return;Ygb(a,f[b>>2]|0);Ygb(a,f[b+4>>2]|0);a=f[b+20>>2]|0;if(a|0){c=b+24|0;d=f[c>>2]|0;if((d|0)!=(a|0))f[c>>2]=d+(~(((d+-24-a|0)>>>0)/24|0)*24|0);O5b(a)}O5b(b);return}
function Hqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+240|0;d=c+132|0;e=c+88|0;g=c+44|0;h=c+8|0;i=c;j=a+112|0;k=f[j>>2]|0;if(k|0?(l=k+4|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)bi[f[(f[k>>2]|0)+8>>2]&2047](k);f[j>>2]=0;k=a+116|0;f[k>>2]=0;m=d;l=m+100|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(l|0));m=a+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;if((m|0)!=(d|0)){cra(a+32|0,0,0);dra(a+44|0,f[d+40>>2]|0,f[d+44>>2]|0);era(a+56|0,f[d+52>>2]|0,f[d+56>>2]|0);IA(a+68|0,f[d+64>>2]|0,f[d+68>>2]|0);r2(a+80|0,f[d+76>>2]|0,f[d+80>>2]|0);fra(a+92|0,f[d+88>>2]|0,f[d+92>>2]|0)}gra(d);m=a+104|0;l=f[m>>2]|0;if(l|0?(n=l+4|0,o=f[n>>2]|0,f[n>>2]=o+-1,(o|0)==1):0)bi[f[(f[l>>2]|0)+8>>2]&2047](l);f[m>>2]=0;f[a+108>>2]=0;f[d>>2]=0;f[d+4>>2]=0;dW(h,b,0,d);bD(d);if(!(qT(h)|0)){p=0;nT(h);u=c;return p|0}fW(d,h,0);m=d+4|0;kW(e,f[d>>2]|0,f[m>>2]|0,0);l=f[d>>2]|0;o=f[m>>2]|0;kW(g,l,o,lW(d)|0);d=f[e>>2]|0;o=d;if((((d|0)==(f[g>>2]|0)?(f[e+4>>2]|0)==(f[g+4>>2]|0):0)?(f[e+20>>2]|0)==(f[g+20>>2]|0):0)?(f[e+40>>2]|0)==(f[g+40>>2]|0):0){f[i>>2]=0;f[i+4>>2]=0}else{g=f[e+20>>2]|0;f[i>>2]=o;f[i+4>>2]=g}if(hra(a,i)|0){p=1;nT(h);u=c;return p|0}rT(h);i=f[b>>2]|0;b=cW((i|0)==0?1124530:i,0,0,0)|0;if(!b)q=0;else{i=L5b(16)|0;f[i+4>>2]=1;f[i>>2]=104216;f[i+8>>2]=b;q=i}i=f[j>>2]|0;f[j>>2]=q;f[k>>2]=b;if(i|0?(b=i+4|0,q=f[b>>2]|0,f[b>>2]=q+-1,(q|0)==1):0)bi[f[(f[i>>2]|0)+8>>2]&2047](i);p=(f[k>>2]|0)!=0;nT(h);u=c;return p|0}function Iqa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=u;u=u+48|0;k=j+40|0;l=j+28|0;m=j+16|0;n=j+8|0;o=j;dQ(k,104188);f[l>>2]=0;p=l+4|0;f[p>>2]=0;f[l+8>>2]=0;f[m>>2]=0;q=m+4|0;f[q>>2]=0;f[m+8>>2]=0;r=f[(f[a>>2]|0)+44>>2]|0;f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[o>>2]=f[i>>2];f[o+4>>2]=f[i+4>>2];Eg[r&3](a,b,c,l,m,d,e,g,n,o,0);o=f[m>>2]|0;if(o|0){m=f[q>>2]|0;if((m|0)!=(o|0))f[q>>2]=m+(~((m+-8-o|0)>>>3)<<3);O5b(o)}o=f[l>>2]|0;if(o|0){l=f[p>>2]|0;if((l|0)!=(o|0))f[p>>2]=l+(~((l+-4-o|0)>>>2)<<2);O5b(o)}if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function Jqa(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;l=u;u=u+160|0;m=l+136|0;n=l+128|0;o=l+72|0;p=l+56|0;q=l+32|0;r=l+48|0;s=l+24|0;t=l+16|0;v=l+8|0;w=l;dQ(n,104148);do if((yM(c)|0)==65536){x=f[c+4>>2]|0;f[o>>2]=f[x>>2];y=o+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=o+8|0;f[A>>2]=f[x+8>>2];f[o+12>>2]=f[x+12>>2];f[o+16>>2]=f[x+16>>2];f[o+20>>2]=f[x+20>>2];f[o+24>>2]=f[x+24>>2];f[o+28>>2]=f[x+28>>2];f[o+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[o+36>>2]=B;f[o+40>>2]=A;A=o+48|0;C=o+44|0;f[C>>2]=A;f[A>>2]=0;f[o+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(o,x);break}}else yL(o,c,-1);while(0);if(!(g>1.0?!(f[o>>2]&7|0):0)){f[m>>2]=0;f[m+4>>2]=0;c=aD(m,37)|0;x=353513;y=c+37|0;do{b[c>>0]=b[x>>0]|0;c=c+1|0;x=x+1|0}while((c|0)<(y|0));bO(-215,m,352012,350849,1424);bD(m)}if(!(di[f[(f[a>>2]|0)+20>>2]&1023](a)|0)){f[p>>2]=0;x=p+4|0;f[x>>2]=0;f[p+8>>2]=0;f[q>>2]=0;c=q+4|0;f[c>>2]=0;f[q+8>>2]=0;if(di[f[(f[a>>2]|0)+48>>2]&1023](a)|0){f[m>>2]=0;y=m+4|0;f[y>>2]=0;f[m+8>>2]=0;z=f[a+112>>2]|0;f[r>>2]=z;A=r+4|0;f[A>>2]=f[a+116>>2];if(z|0){C=z+4|0;f[C>>2]=(f[C>>2]|0)+1}f[s>>2]=f[j>>2];f[s+4>>2]=f[j+4>>2];f[t>>2]=f[k>>2];f[t+4>>2]=f[k+4>>2];Rqa(o,r,d,p,q,m,g,h,i,s,t,0);t=f[r>>2]|0;if(t|0?(s=t+4|0,i=f[s>>2]|0,f[s>>2]=i+-1,(i|0)==1):0)bi[f[(f[t>>2]|0)+8>>2]&2047](t);f[r>>2]=0;f[A>>2]=0;A=f[y>>2]|0;r=f[m>>2]|0;t=(A-r|0)/20|0;i=e+4|0;s=f[i>>2]|0;C=f[e>>2]|0;z=s-C>>2;B=C;C=s;s=r;r=A;if(t>>>0<=z>>>0)if(t>>>0<z>>>0?(A=B+(t<<2)|0,(C|0)!=(A|0)):0){f[i>>2]=C+(~((C+-4-A|0)>>>2)<<2);D=s;E=r;F=B}else{D=s;E=r;F=B}else{HC(e,t-z|0);D=f[m>>2]|0;E=f[y>>2]|0;F=f[e>>2]|0}if((D|0)!=(E|0)){z=D;t=F;while(1){f[t>>2]=f[z+16>>2];z=z+20|0;if((z|0)==(E|0))break;else t=t+4|0}}if(D|0){if((E|0)!=(D|0))f[y>>2]=E+(~(((E+-20-D|0)>>>0)/20|0)*20|0);O5b(D)}}else{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=o;f[v>>2]=f[j>>2];f[v+4>>2]=f[j+4>>2];f[w>>2]=f[k>>2];f[w+4>>2]=f[k+4>>2];Sqa(a,m,d,p,q,g,v,w,0);dQ(m,104168);Tqa(d,h,.2,e,0)}e=f[q>>2]|0;if(e|0){q=f[c>>2]|0;if((q|0)!=(e|0))f[c>>2]=q+(~((q+-8-e|0)>>>3)<<3);O5b(e)}e=f[p>>2]|0;if(e|0){p=f[x>>2]|0;if((p|0)!=(e|0))f[x>>2]=p+(~((p+-4-e|0)>>>2)<<2);O5b(e)}}e=o+36|0;p=f[e>>2]|0;if(p|0?(x=p+12|0,p=f[x>>2]|0,f[x>>2]=p+-1,(p|0)==1):0)kL(o);f[e>>2]=0;e=o+16|0;p=o+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[p>>2]|0)>0){e=f[o+40>>2]|0;x=0;do{f[e+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[p>>2]|0))}p=f[o+44>>2]|0;if((p|0)!=(o+48|0))UC(p);if(!(f[n+4>>2]|0)){u=l;return}u=l;return}function Kqa(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;n=u;u=u+128|0;o=n+64|0;p=n+56|0;q=n+16|0;r=n+48|0;s=n+40|0;t=n+32|0;v=n+8|0;w=n;dQ(p,103908);if(!(h>1.0?!(FM(c,-1)|0):0)){f[o>>2]=0;f[o+4>>2]=0;x=aD(o,38)|0;y=351973;z=x+38|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,o,352012,350849,1376);bD(o)}do if(!(di[f[(f[a>>2]|0)+20>>2]&1023](a)|0)){if(!(di[f[(f[a>>2]|0)+48>>2]&1023](a)|0)){f[v>>2]=f[k>>2];f[v+4>>2]=f[k+4>>2];f[w>>2]=f[l>>2];f[w+4>>2]=f[l+4>>2];Sqa(a,c,d,e,g,h,v,w,m);if(m){dQ(o,103928);Tqa(d,i,.2,e,g);break}else{dQ(o,103948);Tqa(d,i,.2,0,0);break}}do if((yM(c)|0)==65536){y=f[c+4>>2]|0;f[o>>2]=f[y>>2];x=o+4|0;z=y+4|0;f[x>>2]=f[z>>2];A=o+8|0;f[A>>2]=f[y+8>>2];f[o+12>>2]=f[y+12>>2];f[o+16>>2]=f[y+16>>2];f[o+20>>2]=f[y+20>>2];f[o+24>>2]=f[y+24>>2];f[o+28>>2]=f[y+28>>2];f[o+32>>2]=f[y+32>>2];B=f[y+36>>2]|0;f[o+36>>2]=B;f[o+40>>2]=A;A=o+48|0;C=o+44|0;f[C>>2]=A;f[A>>2]=0;f[o+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[y+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[x>>2]=0;jL(o,y);break}}else yL(o,c,-1);while(0);f[q>>2]=0;y=q+4|0;f[y>>2]=0;f[q+8>>2]=0;x=f[a+112>>2]|0;f[r>>2]=x;z=r+4|0;f[z>>2]=f[a+116>>2];if(x|0){A=x+4|0;f[A>>2]=(f[A>>2]|0)+1}f[s>>2]=f[k>>2];f[s+4>>2]=f[k+4>>2];f[t>>2]=f[l>>2];f[t+4>>2]=f[l+4>>2];Rqa(o,r,d,e,g,q,h,i,j,s,t,m);A=f[r>>2]|0;if(A|0?(x=A+4|0,C=f[x>>2]|0,f[x>>2]=C+-1,(C|0)==1):0)bi[f[(f[A>>2]|0)+8>>2]&2047](A);f[r>>2]=0;f[z>>2]=0;z=f[q>>2]|0;if(z|0){A=f[y>>2]|0;if((A|0)!=(z|0))f[y>>2]=A+(~(((A+-20-z|0)>>>0)/20|0)*20|0);O5b(z)}z=o+36|0;A=f[z>>2]|0;if(A|0?(y=A+12|0,A=f[y>>2]|0,f[y>>2]=A+-1,(A|0)==1):0)kL(o);f[z>>2]=0;z=o+16|0;A=o+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[A>>2]|0)>0){z=f[o+40>>2]|0;y=0;do{f[z+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[A>>2]|0))}A=f[o+44>>2]|0;if((A|0)!=(o+48|0))UC(A)}while(0);if(!(f[p+4>>2]|0)){u=n;return}u=n;return}function Lqa(a){a=a|0;return (f[a+116>>2]|0)!=0|0}function Mqa(a,b){a=a|0;b=b|0;f[a>>2]=f[b+24>>2];f[a+4>>2]=f[b+28>>2];return}function Nqa(a){a=a|0;var b=0;b=f[a+108>>2]|0;return di[f[(f[b>>2]|0)+16>>2]&1023](b)|0}function Oqa(a){a=a|0;return f[a+116>>2]|0}function Pqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+120|0;d=f[b>>2]|0;e=f[b+4>>2]|0;if(d|0){b=d+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[c>>2]=d;f[a+124>>2]=e;if(!b)return;e=b+4|0;a=f[e>>2]|0;f[e>>2]=a+-1;if((a|0)!=1)return;bi[f[(f[b>>2]|0)+8>>2]&2047](b);return}function Qqa(a,b){a=a|0;b=b|0;var c=0;c=f[b+120>>2]|0;f[a>>2]=c;f[a+4>>2]=f[b+124>>2];if(!c)return;b=c+4|0;f[b>>2]=(f[b>>2]|0)+1;return}function Rqa(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;o=u;u=u+64|0;p=o+56|0;q=o;r=o+8|0;s=o+48|0;t=o+40|0;v=zW(0)|0;if(!v)w=0;else{x=L5b(16)|0;f[x+4>>2]=1;f[x>>2]=56496;f[x+8>>2]=v;w=x}x=f[a+8>>2]|0;y=(f[a+4>>2]|0)==1?1:f[a+12>>2]|0;z=f[a>>2]|0;A=z&4095;B=f[a+16>>2]|0;C=Y((z>>>3&511)+1<<(47696>>>(A<<1&14)&3),y)|0;f[r>>2]=A|1111638016;A=r+4|0;f[A>>2]=C;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=B;f[r+20>>2]=x;f[r+24>>2]=y;f[A>>2]=f[f[a+44>>2]>>2];f[r>>2]=z&20479|1111621632;z=f[c+4>>2]|0;f[s>>2]=f[l>>2];f[s+4>>2]=f[l+4>>2];f[t>>2]=f[m>>2];f[t+4>>2]=f[m+4>>2];f[q>>2]=f[s>>2];f[q+4>>2]=f[s+4>>2];f[p>>2]=f[t>>2];f[p+4>>2]=f[t+4>>2];t=csa(r,z,v,e,g,i,j,k,q,p,n)|0;if(!t){D=q;E=0}else{if((f[t+28>>2]|0)!=20){f[p>>2]=0;f[p+4>>2]=0;n=aD(p,39)|0;k=353217;j=n+39|0;do{b[n>>0]=b[k>>0]|0;n=n+1|0;k=k+1|0}while((n|0)<(j|0));bO(-215,p,353257,353261,2974);bD(p)}D=q;E=f[t+24>>2]|0}D=h+4|0;k=f[D>>2]|0;n=f[h>>2]|0;j=(k-n|0)/20|0;g=n;n=k;if(E>>>0<=j>>>0){if(E>>>0<j>>>0?(k=g+(E*20|0)|0,(n|0)!=(k|0)):0)f[D>>2]=n+(~(((n+-20-k|0)>>>0)/20|0)*20|0)}else bra(h,E-j|0);if((t|0)!=0&(E|0)!=0){E=f[h>>2]|0;j=q;f[j>>2]=0;f[j+4>>2]=1073741823;f[p>>2]=f[q>>2];f[p+4>>2]=f[q+4>>2];LW(t,E,p)|0}p=f[D>>2]|0;E=f[h>>2]|0;t=(p-E|0)/20|0;q=d+4|0;j=f[q>>2]|0;k=f[d>>2]|0;n=j-k>>4;g=k;k=j;j=E;E=p;if(t>>>0<=n>>>0)if(t>>>0<n>>>0?(p=g+(t<<4)|0,(k|0)!=(p|0)):0){f[q>>2]=k+(~((k+-16-p|0)>>>4)<<4);F=j;G=E;H=g}else{F=j;G=E;H=g}else{Voa(d,t-n|0);F=f[h>>2]|0;G=f[D>>2]|0;H=f[d>>2]|0}if((F|0)!=(G|0)){d=F;F=H;while(1){H=f[d+4>>2]|0;D=f[d+8>>2]|0;h=f[d+12>>2]|0;f[F>>2]=f[d>>2];f[F+4>>2]=H;f[F+8>>2]=D;f[F+12>>2]=h;d=d+20|0;if((d|0)==(G|0))break;else F=F+16|0}}if(!w){u=o;return}F=w+4|0;G=f[F>>2]|0;f[F>>2]=G+-1;if((G|0)!=1){u=o;return}bi[f[(f[w>>2]|0)+8>>2]&2047](w);u=o;return}function Sqa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;k=u;u=u+1360|0;l=k+1352|0;m=k+1344|0;o=k+1336|0;q=k+1324|0;r=k+1312|0;s=k+1256|0;t=k;v=k+1200|0;w=k+136|0;x=k+24|0;y=k+16|0;dQ(l,103988);AL(m,b,-1);zh[f[(f[a>>2]|0)+52>>2]&2047](o,a);z=i+4|0;if((f[z>>2]|0)!=0?(f[i>>2]|0)!=0:0){A=m+4|0;B=A;C=f[A>>2]|0}else{f[i>>2]=f[m>>2];A=m+4|0;D=f[A>>2]|0;f[z>>2]=D;B=A;C=D}D=o+4|0;A=f[D>>2]|0;if((C|0)>=(A|0)?(E=f[m>>2]|0,F=f[o>>2]|0,(E|0)>=(F|0)):0){f[q>>2]=0;G=q+4|0;f[G>>2]=0;f[q+8>>2]=0;f[r>>2]=0;H=r+4|0;f[H>>2]=0;f[r+8>>2]=0;I=q+8|0;J=L5b(4096)|0;K=J;L=J+4096|0;f[q>>2]=K;f[G>>2]=K;f[I>>2]=L;M=r+8|0;N=L5b(4096)|0;O=N;f[r>>2]=O;f[H>>2]=O;f[M>>2]=N+4096;N=MVb(+(F|0))|0;a:do if(!((N|0)>(E|0)|(MVb(+(A|0))|0)>(C|0))){P=1.0;O=E;Q=A;R=F;S=J;T=L;while(1){U=P;n[s>>2]=U;if((S|0)==(T|0)){upa(q,s);V=f[o>>2]|0;W=f[D>>2]|0;X=f[m>>2]|0}else{n[S>>2]=U;f[G>>2]=S+4;V=R;W=Q;X=O}U=P*g;Z=MVb(U*+(V|0))|0;_=MVb(U*+(W|0))|0;if((Z|0)>(X|0)?1:(_|0)>(f[B>>2]|0))break;P=U;O=X;Q=W;R=V;S=f[G>>2]|0;T=f[I>>2]|0}T=f[G>>2]|0;S=f[q>>2]|0;R=S;Q=T;if((T|0)!=(S|0)){O=h+4|0;P=+n[R>>2];_=LVb(+(V|0)*P)|0;if((_|0)>(f[i>>2]|0)){$=G;aa=R;ba=Q;ca=T;da=S;ea=R;fa=R}else{Z=0;U=P;ga=R;ha=T;T=S;ia=R;ja=Q;ka=R;la=R;ma=LVb(P*+(W|0))|0;na=_;while(1){if((ma|0)>(f[z>>2]|0)){$=G;aa=ia;ba=ja;ca=ha;da=T;ea=la;fa=ka;break a}do if((na|0)>=(f[h>>2]|0)?(ma|0)>=(f[O>>2]|0):0){_=f[H>>2]|0;if((_|0)==(f[M>>2]|0)){upa(r,ga);oa=f[G>>2]|0;pa=f[q>>2]|0;qa=pa;ra=pa;sa=oa;ta=qa;ua=qa;va=oa;wa=qa;break}else{n[_>>2]=U;f[H>>2]=_+4;ra=T;sa=ha;ta=la;ua=ka;va=ja;wa=ia;break}}else{ra=T;sa=ha;ta=la;ua=ka;va=ja;wa=ia}while(0);Z=Z+1|0;if(Z>>>0>=sa-ra>>2>>>0){$=G;aa=wa;ba=va;ca=sa;da=ra;ea=ta;fa=ua;break a}_=f[D>>2]|0;ga=ra+(Z<<2)|0;U=+n[ga>>2];na=LVb(+(f[o>>2]|0)*U)|0;ma=LVb(U*+(_|0))|0;if((na|0)>(f[i>>2]|0)){$=G;aa=wa;ba=va;ca=sa;da=ra;ea=ta;fa=ua;break}else{ha=sa;T=ra;ia=wa;ja=va;ka=ua;la=ta}}}}else{$=G;aa=R;ba=Q;ca=S;da=S;ea=R;fa=R}}else{$=G;aa=J;ba=J;ca=K;da=K;ea=J;fa=J}while(0);if(!((aa|0)==(ba|0)?1:(f[r>>2]|0)!=(f[H>>2]|0))){f[s>>2]=0;ba=s+4|0;f[ba>>2]=0;f[s+8>>2]=0;if((ca|0)!=(da|0)){aa=h+4|0;J=s+8|0;K=0;ta=fa;fa=0;ua=0;va=ea;wa=da;da=ca;while(1){g=+n[ta+(K<<2)>>2];ca=LVb(+(f[o>>2]|0)*g)|0;ra=LVb(g*+(f[D>>2]|0))|0;sa=(f[h>>2]|0)-ca|0;ca=Y(sa,sa)|0;sa=(f[aa>>2]|0)-ra|0;g=+((Y(sa,sa)|0)+ca|0);p[t>>3]=g;if((fa|0)==(ua|0)){apa(s,t);ca=f[q>>2]|0;xa=ca;ya=f[$>>2]|0;za=ca}else{p[fa>>3]=g;f[ba>>2]=fa+8;xa=wa;ya=da;za=va}ca=K+1|0;if(ca>>>0>=ya-xa>>2>>>0)break;K=ca;ta=xa;fa=f[ba>>2]|0;ua=f[J>>2]|0;va=za;wa=xa;da=ya}ya=f[s>>2]|0;da=ya;if((f[ba>>2]|0)==(ya|0)){Aa=0;Ba=za;Ca=da}else{xa=(f[ba>>2]|0)-ya>>3;ya=0;wa=0;while(1){va=+p[da+(wa<<3)>>3]>+p[da+(ya<<3)>>3]?ya:wa;ya=ya+1|0;if(ya>>>0>=xa>>>0){Aa=va;Ba=za;Ca=da;break}else wa=va}}}else{Aa=0;Ba=ea;Ca=0}ea=Ba+(Aa<<2)|0;Aa=f[H>>2]|0;if((Aa|0)==(f[M>>2]|0)){upa(r,ea);Da=f[s>>2]|0}else{f[Aa>>2]=f[ea>>2];f[H>>2]=Aa+4;Da=Ca}if(Da|0){Ca=f[ba>>2]|0;if((Ca|0)!=(Da|0))f[ba>>2]=Ca+(~((Ca+-8-Da|0)>>>3)<<3);O5b(Da)}}Da=f[c>>2]|0;Ca=c+4|0;ba=f[Ca>>2]|0;if((ba|0)!=(Da|0))f[Ca>>2]=ba+(~((ba+-16-Da|0)>>>4)<<4);Da=f[d>>2]|0;ba=d+4|0;Ca=f[ba>>2]|0;if((Ca|0)!=(Da|0))f[ba>>2]=Ca+(~((Ca+-4-Da|0)>>>2)<<2);Da=f[e>>2]|0;Ca=e+4|0;ba=f[Ca>>2]|0;if((ba|0)!=(Da|0))f[Ca>>2]=ba+(~((ba+-8-Da|0)>>>3)<<3);f[s>>2]=1124007936;Da=s+4|0;ba=s+8|0;Ca=s+40|0;Aa=Da;ea=Aa+36|0;do{f[Aa>>2]=0;Aa=Aa+4|0}while((Aa|0)<(ea|0));f[Ca>>2]=ba;M=s+48|0;Ba=s+44|0;f[Ba>>2]=M;f[M>>2]=0;f[s+52>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;do if((GM(b,-1)|0)<=1){if((yM(b)|0)!=65536){wa=v+8|0;f[wa>>2]=0;f[wa+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=s;JM(b,v);break}do if((yM(b)|0)==65536){wa=f[b+4>>2]|0;f[v>>2]=f[wa>>2];da=v+4|0;za=wa+4|0;f[da>>2]=f[za>>2];xa=v+8|0;f[xa>>2]=f[wa+8>>2];f[v+12>>2]=f[wa+12>>2];f[v+16>>2]=f[wa+16>>2];f[v+20>>2]=f[wa+20>>2];f[v+24>>2]=f[wa+24>>2];f[v+28>>2]=f[wa+28>>2];f[v+32>>2]=f[wa+32>>2];ya=v+36|0;va=f[wa+36>>2]|0;f[ya>>2]=va;f[v+40>>2]=xa;xa=v+48|0;J=v+44|0;f[J>>2]=xa;f[xa>>2]=0;f[v+52>>2]=0;if(va|0){xa=va+12|0;f[xa>>2]=(f[xa>>2]|0)+1}if((f[za>>2]|0)<3){za=f[wa+44>>2]|0;xa=f[J>>2]|0;f[xa>>2]=f[za>>2];f[xa+4>>2]=f[za+4>>2];Ea=ya;break}else{f[da>>2]=0;jL(v,wa);Ea=ya;break}}else{yL(v,b,-1);Ea=v+36|0}while(0);R=f[Ea>>2]|0;if(R|0){S=R+12|0;f[S>>2]=(f[S>>2]|0)+1}S=s+36|0;R=f[S>>2]|0;if(R|0?(Q=R+12|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)kL(s);f[S>>2]=0;R=s+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[Da>>2]|0)>0){Q=f[Ca>>2]|0;ya=0;do{f[Q+(ya<<2)>>2]=0;ya=ya+1|0;Fa=f[Da>>2]|0}while((ya|0)<(Fa|0));f[s>>2]=f[v>>2];if((Fa|0)<3)Ga=71;else Ga=73}else{f[s>>2]=f[v>>2];Ga=71}if((Ga|0)==71){ya=f[v+4>>2]|0;if((ya|0)<3){f[Da>>2]=ya;f[ba>>2]=f[v+8>>2];f[s+12>>2]=f[v+12>>2];ya=f[v+44>>2]|0;Q=f[Ba>>2]|0;f[Q>>2]=f[ya>>2];f[Q+4>>2]=f[ya+4>>2]}else Ga=73}if((Ga|0)==73)jL(s,v);ya=v+16|0;f[R>>2]=f[ya>>2];f[s+20>>2]=f[v+20>>2];f[s+24>>2]=f[v+24>>2];f[s+28>>2]=f[v+28>>2];f[s+32>>2]=f[v+32>>2];Q=f[Ea>>2]|0;f[S>>2]=Q;if(Q|0?(wa=Q+12|0,Q=f[wa>>2]|0,f[wa>>2]=Q+-1,(Q|0)==1):0)kL(v);f[Ea>>2]=0;Q=v+4|0;f[ya>>2]=0;f[ya+4>>2]=0;f[ya+8>>2]=0;f[ya+12>>2]=0;if((f[Q>>2]|0)>0){ya=f[v+40>>2]|0;wa=0;do{f[ya+(wa<<2)>>2]=0;wa=wa+1|0}while((wa|0)<(f[Q>>2]|0))}Q=f[v+44>>2]|0;if((Q|0)!=(v+48|0))UC(Q)}else{Q=v+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=s;D1(b,v,6,0)}while(0);f[t>>2]=16842752;b=t+4|0;f[b>>2]=s;f[t+8>>2]=0;f[t+12>>2]=0;Ea=a+108|0;ba=f[Ea>>2]|0;if(li[f[(f[ba>>2]|0)+20>>2]&511](ba,t,r)|0){ba=f[Ea>>2]|0;bi[f[(f[ba>>2]|0)+32>>2]&2047](ba);f[v>>2]=1124007936;ba=v+4|0;Fa=v+8|0;Q=v+40|0;Aa=ba;ea=Aa+36|0;do{f[Aa>>2]=0;Aa=Aa+4|0}while((Aa|0)<(ea|0));f[Q>>2]=Fa;Aa=v+48|0;ea=v+44|0;f[ea>>2]=Aa;f[Aa>>2]=0;f[v+52>>2]=0;wa=f[a+124>>2]|0;if(wa|0){ya=f[(f[wa>>2]|0)+8>>2]|0;do if((yM(t)|0)==65536){S=f[b>>2]|0;f[x>>2]=f[S>>2];R=x+4|0;da=S+4|0;f[R>>2]=f[da>>2];za=x+8|0;f[za>>2]=f[S+8>>2];f[x+12>>2]=f[S+12>>2];f[x+16>>2]=f[S+16>>2];f[x+20>>2]=f[S+20>>2];f[x+24>>2]=f[S+24>>2];f[x+28>>2]=f[S+28>>2];f[x+32>>2]=f[S+32>>2];xa=f[S+36>>2]|0;f[x+36>>2]=xa;f[x+40>>2]=za;za=x+48|0;J=x+44|0;f[J>>2]=za;f[za>>2]=0;f[x+52>>2]=0;if(xa|0){za=xa+12|0;f[za>>2]=(f[za>>2]|0)+1}if((f[da>>2]|0)<3){da=f[S+44>>2]|0;za=f[J>>2]|0;f[za>>2]=f[da>>2];f[za+4>>2]=f[da+4>>2];break}else{f[R>>2]=0;jL(x,S);break}}else yL(x,t,-1);while(0);_h[ya&255](w,wa,x);wa=w+36|0;ya=f[wa>>2]|0;if(ya|0){t=ya+12|0;f[t>>2]=(f[t>>2]|0)+1}t=v+36|0;ya=f[t>>2]|0;if(ya|0?(b=ya+12|0,ya=f[b>>2]|0,f[b>>2]=ya+-1,(ya|0)==1):0)kL(v);f[t>>2]=0;ya=v+16|0;f[ya>>2]=0;f[ya+4>>2]=0;f[ya+8>>2]=0;f[ya+12>>2]=0;if((f[ba>>2]|0)>0){b=f[Q>>2]|0;S=0;do{f[b+(S<<2)>>2]=0;S=S+1|0;Ha=f[ba>>2]|0}while((S|0)<(Ha|0));f[v>>2]=f[w>>2];if((Ha|0)<3)Ga=103;else Ga=105}else{f[v>>2]=f[w>>2];Ga=103}if((Ga|0)==103){Ha=f[w+4>>2]|0;if((Ha|0)<3){f[ba>>2]=Ha;f[Fa>>2]=f[w+8>>2];f[v+12>>2]=f[w+12>>2];Fa=f[w+44>>2]|0;Ha=f[ea>>2]|0;f[Ha>>2]=f[Fa>>2];f[Ha+4>>2]=f[Fa+4>>2]}else Ga=105}if((Ga|0)==105)jL(v,w);Ga=w+16|0;f[ya>>2]=f[Ga>>2];f[v+20>>2]=f[w+20>>2];f[v+24>>2]=f[w+24>>2];f[v+28>>2]=f[w+28>>2];f[v+32>>2]=f[w+32>>2];ya=f[wa>>2]|0;f[t>>2]=ya;do if(ya|0){t=ya+12|0;Fa=f[t>>2]|0;f[t>>2]=Fa+-1;if((Fa|0)!=1)break;kL(w)}while(0);f[wa>>2]=0;wa=w+4|0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;if((f[wa>>2]|0)>0){Ga=f[w+40>>2]|0;ya=0;do{f[Ga+(ya<<2)>>2]=0;ya=ya+1|0}while((ya|0)<(f[wa>>2]|0))}wa=f[w+44>>2]|0;if((wa|0)!=(w+48|0))UC(wa);wa=x+36|0;ya=f[wa>>2]|0;do if(ya|0){Ga=ya+12|0;Fa=f[Ga>>2]|0;f[Ga>>2]=Fa+-1;if((Fa|0)!=1)break;kL(x)}while(0);f[wa>>2]=0;wa=x+16|0;ya=x+4|0;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;if((f[ya>>2]|0)>0){wa=f[x+40>>2]|0;Fa=0;do{f[wa+(Fa<<2)>>2]=0;Fa=Fa+1|0}while((Fa|0)<(f[ya>>2]|0))}ya=f[x+44>>2]|0;if((ya|0)!=(x+48|0))UC(ya)}ya=(f[H>>2]|0)-(f[r>>2]|0)>>2;Fa=w+8|0;f[w>>2]=Fa;wa=w+4|0;f[wa>>2]=ya;if(ya>>>0>264){Ga=N5b(ya>>>0>1073741823?-1:ya<<2)|0;f[w>>2]=Ga;Ia=Ga}else Ia=Fa;Ga=$pa(f[Ea>>2]|0,0)|0;Ea=a+28|0;t=(f[Ga+4>>2]|0)-(f[a+24>>2]|0)|0;g=+(((t|0)>0?t:0)|0)*.03125;t=~~g;Ha=(+(t|0)<g&1)+t|0;if(ya|0){t=Ha+-1|0;S=0;do{b=(f[Ga+(S*20|0)+8>>2]|0)-(f[Ea>>2]|0)|0;R=f[Ga+(S*20|0)+16>>2]|0;da=(t+((((b|0)>0?b:0)|0)/(R|0)|0)|0)/(Ha|0)|0;b=Y((da|0)>1?da:1,R)|0;f[Ia+(S<<2)>>2]=b;S=S+1|0}while((S|0)!=(ya|0))}Uqa(x,a,ya,Ha,Ga,Ia,c,d,e,j,v,a+416|0);f[y>>2]=0;f[y+4>>2]=Ha;RQ(y,x,-1.0);Vqa(x);x=f[w>>2]|0;if((x|0)!=(Fa|0)){if(x|0)P5b(x);f[w>>2]=Fa;f[wa>>2]=264}wa=v+36|0;Fa=f[wa>>2]|0;if(Fa|0?(w=Fa+12|0,Fa=f[w>>2]|0,f[w>>2]=Fa+-1,(Fa|0)==1):0)kL(v);f[wa>>2]=0;wa=v+16|0;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;if((f[ba>>2]|0)>0){wa=f[Q>>2]|0;Q=0;do{f[wa+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[ba>>2]|0))}ba=f[ea>>2]|0;if((ba|0)!=(Aa|0))UC(ba)}ba=s+36|0;Aa=f[ba>>2]|0;if(Aa|0?(ea=Aa+12|0,Aa=f[ea>>2]|0,f[ea>>2]=Aa+-1,(Aa|0)==1):0)kL(s);f[ba>>2]=0;ba=s+16|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[Da>>2]|0)>0){ba=f[Ca>>2]|0;Ca=0;do{f[ba+(Ca<<2)>>2]=0;Ca=Ca+1|0}while((Ca|0)<(f[Da>>2]|0))}Da=f[Ba>>2]|0;if((Da|0)!=(M|0))UC(Da);Da=f[r>>2]|0;if(Da|0){r=f[H>>2]|0;if((r|0)!=(Da|0))f[H>>2]=r+(~((r+-4-Da|0)>>>2)<<2);O5b(Da)}Da=f[q>>2]|0;if(Da|0){q=f[G>>2]|0;if((q|0)!=(Da|0))f[G>>2]=q+(~((q+-4-Da|0)>>>2)<<2);O5b(Da)}}if(!(f[l+4>>2]|0)){u=k;return}u=k;return}function Tqa(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;g=u;u=u+112|0;h=g+16|0;i=g+104|0;j=g+92|0;k=g+8|0;l=g+80|0;m=g+68|0;n=g+56|0;o=g+40|0;q=g+32|0;r=g;s=g+28|0;dQ(i,103968);if((b|0)>=1?(t=a+4|0,(f[a>>2]|0)!=(f[t>>2]|0)):0){f[j>>2]=0;v=j+4|0;f[v>>2]=0;f[j+8>>2]=0;p[k>>3]=c;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];k=epa(a,j,h)|0;f[h>>2]=0;w=h+4|0;f[w>>2]=0;f[h+8>>2]=0;x=(k|0)==0;do if(!x)if(k>>>0>268435455)c4b(h);else{y=k<<4;z=L5b(y)|0;f[h>>2]=z;f[h+8>>2]=z+(k<<4);Nac(z|0,0,y|0)|0;f[w>>2]=z+y;A=z;break}else A=0;while(0);f[l>>2]=0;z=l+4|0;f[z>>2]=0;f[l+8>>2]=0;if(x)B=0;else{y=k<<2;C=L5b(y)|0;f[l>>2]=C;D=C+(k<<2)|0;f[l+8>>2]=D;Nac(C|0,0,y|0)|0;f[z>>2]=D;B=C}f[m>>2]=0;C=m+4|0;f[C>>2]=0;f[m+8>>2]=0;if(x)E=0;else{D=k<<2;y=L5b(D)|0;f[m>>2]=y;F=y+(k<<2)|0;f[m+8>>2]=F;Nac(y|0,0,D|0)|0;f[C>>2]=F;E=y}f[n>>2]=0;y=n+4|0;f[y>>2]=0;f[n+8>>2]=0;if(x)G=0;else{x=L5b(k<<3)|0;f[y>>2]=x;f[n>>2]=x;F=x+(k<<3)|0;f[n+8>>2]=F;D=k;H=x;while(1){p[H>>3]=2.2250738585072014e-308;D=D+-1|0;if(!D)break;else H=H+8|0}f[y>>2]=F;G=x}x=f[j>>2]|0;F=(f[v>>2]|0)-x|0;H=F>>2;D=(F|0)>0;F=x;if(D){x=f[a>>2]|0;I=0;do{J=f[F+(I<<2)>>2]|0;K=A+(J<<4)|0;f[K>>2]=(f[K>>2]|0)+(f[x+(I<<4)>>2]|0);K=A+(J<<4)+4|0;f[K>>2]=(f[K>>2]|0)+(f[x+(I<<4)+4>>2]|0);K=A+(J<<4)+8|0;f[K>>2]=(f[K>>2]|0)+(f[x+(I<<4)+8>>2]|0);K=A+(J<<4)+12|0;f[K>>2]=(f[K>>2]|0)+(f[x+(I<<4)+12>>2]|0);K=B+(J<<2)|0;f[K>>2]=(f[K>>2]|0)+1;I=I+1|0}while((I|0)<(H|0))}I=(e|0)!=0;x=(d|0)!=0;if(x&I?(K=f[d>>2]|0,(K|0)!=(f[d+4>>2]|0)):0){J=f[e>>2]|0;L=(J|0)==(f[e+4>>2]|0);if(L|D^1){M=L;N=G}else{L=f[n>>2]|0;D=0;do{O=f[F+(D<<2)>>2]|0;P=f[K+(D<<2)>>2]|0;Q=E+(O<<2)|0;R=f[Q>>2]|0;if((P|0)<=(R|0)){if((P|0)==(R|0)?(S=+p[J+(D<<3)>>3],R=L+(O<<3)|0,S>+p[R>>3]):0)p[R>>3]=S}else{f[Q>>2]=P;p[L+(O<<3)>>3]=+p[J+(D<<3)>>3]}D=D+1|0}while((D|0)<(H|0));M=0;N=L}}else{M=1;N=G}G=(k|0)>0;if(G){L=0;do{H=A+(L<<4)|0;D=A+(L<<4)+4|0;J=f[D>>2]|0;K=A+(L<<4)+8|0;F=f[K>>2]|0;O=A+(L<<4)+12|0;P=f[O>>2]|0;S=1.0/+(f[B+(L<<2)>>2]|0);Q=LVb(+(f[H>>2]|0)*S)|0;R=LVb(+(J|0)*S)|0;J=LVb(+(F|0)*S)|0;F=LVb(+(P|0)*S)|0;f[H>>2]=Q;f[D>>2]=R;f[K>>2]=J;f[O>>2]=F;L=L+1|0}while((L|0)!=(k|0))}L=f[a>>2]|0;F=f[t>>2]|0;if((F|0)!=(L|0))f[t>>2]=F+(~((F+-16-L|0)>>>4)<<4);if(x?(L=f[d>>2]|0,F=d+4|0,O=f[F>>2]|0,(O|0)!=(L|0)):0)f[F>>2]=O+(~((O+-4-L|0)>>>2)<<2);if(I?(L=f[e>>2]|0,O=e+4|0,F=f[O>>2]|0,(F|0)!=(L|0)):0)f[O>>2]=F+(~((F+-8-L|0)>>>3)<<3);if(G){G=o+4|0;L=o+8|0;F=o+12|0;O=a+8|0;J=M?q:s;M=d+4|0;K=d+8|0;R=e+4|0;D=e+8|0;Q=f[n>>2]|0;H=f[l>>2]|0;P=f[m>>2]|0;T=0;U=A;A=B;B=E;while(1){E=f[U+(T<<4)>>2]|0;f[o>>2]=E;V=f[U+(T<<4)+4>>2]|0;f[G>>2]=V;W=f[U+(T<<4)+8>>2]|0;f[L>>2]=W;X=f[U+(T<<4)+12>>2]|0;f[F>>2]=X;Y=f[A+(T<<2)>>2]|0;f[q>>2]=Y;p[r>>3]=+p[Q+(T<<3)>>3];f[s>>2]=f[B+(T<<2)>>2];do if((Y|0)>(b|0)){Z=f[h>>2]|0;_=W+E|0;$=X+V|0;aa=(Y|0)>3?Y:3;a:do if((Y|0)<3){ba=0;while(1){do if((ba|0)!=(T|0)?(f[A+(ba<<2)>>2]|0)>(b|0):0){ca=f[Z+(ba<<4)>>2]|0;da=f[Z+(ba<<4)+4>>2]|0;ea=f[Z+(ba<<4)+8>>2]|0;fa=f[Z+(ba<<4)+12>>2]|0;ga=MVb(+(ea|0)*c)|0;ha=MVb(+(fa|0)*c)|0;if((E|0)<(ca-ga|0)|(V|0)<(da-ha|0))break;if((_|0)>(ea+ca+ga|0))break;if(($|0)<=(fa+da+ha|0)){ia=ba;break a}}while(0);ha=ba+1|0;if((ha|0)<(k|0))ba=ha;else{ia=ha;break}}}else{ba=0;while(1){ha=f[A+(ba<<2)>>2]|0;do if((ba|0)!=(T|0)&(ha|0)>(b|0)){da=f[Z+(ba<<4)>>2]|0;fa=f[Z+(ba<<4)+4>>2]|0;ga=f[Z+(ba<<4)+8>>2]|0;ca=f[Z+(ba<<4)+12>>2]|0;ea=MVb(+(ga|0)*c)|0;ja=MVb(+(ca|0)*c)|0;if((E|0)<(da-ea|0)|(V|0)<(fa-ja|0))break;if((_|0)>(ga+da+ea|0))break;if((ha|0)>(aa|0)?($|0)<=(ca+fa+ja|0):0){ia=ba;break a}}while(0);ha=ba+1|0;if((ha|0)<(k|0))ba=ha;else{ia=ha;break}}}while(0);if((ia|0)==(k|0)){$=f[t>>2]|0;if(($|0)==(f[O>>2]|0))Zoa(a,o);else{f[$>>2]=E;f[$+4>>2]=V;f[$+8>>2]=W;f[$+12>>2]=X;f[t>>2]=$+16}do if(x){$=f[M>>2]|0;if(($|0)==(f[K>>2]|0)){IO(d,J);break}else{f[$>>2]=f[J>>2];f[M>>2]=$+4;break}}while(0);if(!I)break;$=f[R>>2]|0;if(($|0)==(f[D>>2]|0)){apa(e,r);break}else{p[$>>3]=+p[r>>3];f[R>>2]=$+8;break}}}while(0);X=T+1|0;if((X|0)>=(k|0))break;T=X;U=f[h>>2]|0;A=H;B=P}ka=f[n>>2]|0}else ka=N;if(ka|0){N=f[y>>2]|0;if((N|0)!=(ka|0))f[y>>2]=N+(~((N+-8-ka|0)>>>3)<<3);O5b(ka)}ka=f[m>>2]|0;if(ka|0){m=f[C>>2]|0;if((m|0)!=(ka|0))f[C>>2]=m+(~((m+-4-ka|0)>>>2)<<2);O5b(ka)}ka=f[l>>2]|0;if(ka|0){l=f[z>>2]|0;if((l|0)!=(ka|0))f[z>>2]=l+(~((l+-4-ka|0)>>>2)<<2);O5b(ka)}ka=f[h>>2]|0;if(ka|0){h=f[w>>2]|0;if((h|0)!=(ka|0))f[w>>2]=h+(~((h+-16-ka|0)>>>4)<<4);O5b(ka)}ka=f[j>>2]|0;if(ka|0){j=f[v>>2]|0;if((j|0)!=(ka|0))f[v>>2]=j+(~((j+-4-ka|0)>>>2)<<2);O5b(ka)}}else la=3;do if((la|0)==3?!((d|0)==0|(e|0)!=0):0){ka=(f[a+4>>2]|0)-(f[a>>2]|0)>>4;j=d+4|0;v=f[j>>2]|0;h=f[d>>2]|0;w=v-h>>2;l=h;h=v;if(ka>>>0<=w>>>0){if(ka>>>0<w>>>0?(v=l+(ka<<2)|0,(h|0)!=(v|0)):0)f[j>>2]=h+(~((h+-4-v|0)>>>2)<<2);if(!ka)break}else HC(d,ka-w|0);w=f[d>>2]|0;v=0;do{f[w+(v<<2)>>2]=1;v=v+1|0}while((v|0)!=(ka|0))}while(0);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function Uqa(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f[a>>2]=104016;f[a+36>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;n=a+48|0;f[n>>2]=1124007936;o=a+52|0;p=a+56|0;q=a+88|0;r=o;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=p;r=a+96|0;s=a+92|0;f[s>>2]=r;f[r>>2]=0;f[a+100>>2]=0;f[a+4>>2]=b;f[a+12>>2]=c;f[a+16>>2]=d;f[a+20>>2]=e;f[a+24>>2]=g;f[a+8>>2]=h;f[a+28>>2]=k?i:0;f[a+32>>2]=k?j:0;if((n|0)==(l|0)){t=a+104|0;f[t>>2]=m;return}j=l+36|0;k=f[j>>2]|0;if(k){i=k+12|0;f[i>>2]=(f[i>>2]|0)+1;i=a+84|0;k=f[i>>2]|0;if((k|0)!=0?(h=k+12|0,k=f[h>>2]|0,f[h>>2]=k+-1,(k|0)==1):0){kL(n);u=i}else u=i}else u=a+84|0;f[u>>2]=0;i=a+64|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[o>>2]|0)>0){k=f[q>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0;v=f[o>>2]|0}while((q|0)<(v|0));f[n>>2]=f[l>>2];if((v|0)<3)w=12;else w=14}else{f[n>>2]=f[l>>2];w=12}if((w|0)==12){v=f[l+4>>2]|0;if((v|0)<3){f[o>>2]=v;f[p>>2]=f[l+8>>2];f[a+60>>2]=f[l+12>>2];p=f[l+44>>2]|0;v=f[s>>2]|0;f[v>>2]=f[p>>2];f[v+4>>2]=f[p+4>>2]}else w=14}if((w|0)==14)jL(n,l);f[i>>2]=f[l+16>>2];f[a+68>>2]=f[l+20>>2];f[a+72>>2]=f[l+24>>2];f[a+76>>2]=f[l+28>>2];f[a+80>>2]=f[l+32>>2];f[u>>2]=f[j>>2];t=a+104|0;f[t>>2]=m;return}function Vqa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=104016;b=a+48|0;c=a+84|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+64|0;b=a+52|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+88>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+92>>2]|0;if((b|0)!=(a+96|0))UC(b);b=f[a+36>>2]|0;if(!b)return;d=a+40|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-4-b|0)>>>2)<<2);O5b(b);return}function Wqa(a){a=a|0;Vqa(a);O5b(a);return}function Xqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0;c=u;u=u+48|0;d=c+40|0;e=c+32|0;g=c;h=c+8|0;i=c+16|0;dQ(d,104028);j=a+4|0;k=f[(f[j>>2]|0)+108>>2]|0;zh[f[(f[k>>2]|0)+12>>2]&2047](e,k);p[g>>3]=0.0;k=f[j>>2]|0;l=f[k+24>>2]|0;m=f[k+28>>2]|0;k=a+12|0;o=f[k>>2]|0;if((o|0)>0){q=a+20|0;r=a+24|0;s=b+4|0;t=+(l|0);v=+(m|0);w=h+4|0;x=a+28|0;y=a+104|0;z=a+8|0;A=i+4|0;B=i+8|0;C=i+12|0;D=i+4|0;E=i+8|0;F=i+12|0;G=a+32|0;a=0;H=o;while(1){o=f[q>>2]|0;I=+n[o+(a*20|0)>>2];J=f[o+(a*20|0)+16>>2]|0;K=f[(f[r>>2]|0)+(a<<2)>>2]|0;L=Y(f[b>>2]|0,K)|0;M=(f[o+(a*20|0)+4>>2]|0)-l|0;N=(M|0)>0;O=N?M:0;M=(f[o+(a*20|0)+8>>2]|0)-m|0;o=(M|0)>0?M:0;M=Y(f[s>>2]|0,K)|0;K=(o|0)<(M|0)?o:M;M=LVb(t*I)|0;o=LVb(v*I)|0;if((L|0)<(K|0)){P=L;do{if(N){Q=I*+(P|0);L=0;do{R=f[j>>2]|0;f[h>>2]=L;f[w>>2]=P;S=Yqa(R,e,h,a,g)|0;if(!(f[x>>2]|0))if((S|0)>0){PO(f[y>>2]|0);R=f[z>>2]|0;T=LVb(I*+(L|0))|0;U=LVb(Q)|0;f[i>>2]=T;f[A>>2]=U;f[B>>2]=M;f[C>>2]=o;V=R+4|0;W=f[V>>2]|0;if((W|0)==(f[R+8>>2]|0))Zoa(R,i);else{f[W>>2]=T;f[W+4>>2]=U;f[W+8>>2]=M;f[W+12>>2]=o;f[V>>2]=W+16}QO(f[y>>2]|0);X=S}else X=S;else{W=f[j>>2]|0;if((S|0)==1){V=f[W+36>>2]|0;U=f[W+32>>2]|0;Z=(V-U|0)/-12|0;_=U;$=V}else{Z=S;_=f[W+32>>2]|0;$=f[W+36>>2]|0}W=($-_|0)/12|0;if((W|0)==(0-Z|0)){PO(f[y>>2]|0);S=f[z>>2]|0;V=LVb(I*+(L|0))|0;U=LVb(Q)|0;f[i>>2]=V;f[D>>2]=U;f[E>>2]=M;f[F>>2]=o;T=S+4|0;R=f[T>>2]|0;if((R|0)==(f[S+8>>2]|0))Zoa(S,i);else{f[R>>2]=V;f[R+4>>2]=U;f[R+8>>2]=M;f[R+12>>2]=o;f[T>>2]=R+16}R=f[x>>2]|0;f[i>>2]=W;T=R+4|0;U=f[T>>2]|0;if((U|0)==(f[R+8>>2]|0))IO(R,i);else{f[U>>2]=W;f[T>>2]=U+4}U=f[G>>2]|0;T=U+4|0;W=f[T>>2]|0;if((W|0)==(f[U+8>>2]|0))apa(U,g);else{p[W>>3]=+p[g>>3];f[T>>2]=W+8}QO(f[y>>2]|0);X=Z}else X=Z}L=L+J+((X|0)==0?J:0)|0}while((L|0)<(O|0))}P=P+J|0}while((P|0)<(K|0));aa=f[k>>2]|0}else aa=H;a=a+1|0;if((a|0)>=(aa|0))break;else H=aa}}aa=f[e>>2]|0;if(aa|0?(e=aa+4|0,H=f[e>>2]|0,f[e>>2]=H+-1,(H|0)==1):0)bi[f[(f[aa>>2]|0)+8>>2]&2047](aa);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function Yqa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+16|0;h=g+8|0;i=g;dQ(h,104048);j=f[b+4>>2]|0;k=f[(f[j>>2]|0)+24>>2]|0;f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];do if(li[k&511](j,i,d)|0){c=f[a+8>>2]|0;l=(c|0)==0;if((f[a+20>>2]|0)==1){if(l){m=Zqa(a,b,e)|0;break}if((c|0)!=1){m=-2;break}m=_qa(a,b,e)|0;break}else{if(l){m=$qa(a,b,e)|0;break}if((c|0)!=1){m=-2;break}m=ara(a,b,e)|0;break}}else m=-1;while(0);if(!(f[h+4>>2]|0)){u=g;return m|0}u=g;return m|0}function Zqa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0,x=0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(g,104128);i=a+92|0;j=f[i>>2]|0;if((j|0)==(f[a+96>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,28)|0;l=352533;m=k+28|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,352713,351208,575);bD(h);o=f[i>>2]|0}else o=j;j=f[c+4>>2]|0;c=f[a+32>>2]|0;i=(f[a+36>>2]|0)-c|0;a=(i|0)/12|0;a:do if((i|0)>0){h=o;l=0;while(1){k=f[c+(l*12|0)+4>>2]|0;if((k|0)>0){m=0;q=0.0;while(1){r=+_pa(j,f[h+(m<<4)>>2]|0);s=q+ +n[(r<+n[h+(m<<4)+4>>2]?h+(m<<4)+8|0:h+(m<<4)+12|0)>>2];m=m+1|0;if((m|0)>=(k|0)){t=s;break}else q=s}}else t=0.0;if(t<+n[c+(l*12|0)+8>>2])break;m=l+1|0;if((m|0)<(a|0)){h=h+(k<<4)|0;l=m}else{v=t;w=9;break a}}p[d>>3]=t;x=0-l|0}else{v=0.0;w=9}while(0);if((w|0)==9){p[d>>3]=v;x=1}if(!(f[g+4>>2]|0)){u=e;return x|0}u=e;return x|0}function _qa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(g,104108);i=a+92|0;if((f[i>>2]|0)==(f[a+96>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,28)|0;k=352533;l=j+28|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,352562,351208,614);bD(h)}h=f[a+32>>2]|0;k=(f[a+36>>2]|0)-h|0;j=(k|0)/12|0;l=f[c+4>>2]|0;c=((f[a+12>>2]|0)+31|0)/32|0;m=h;a:do if((k|0)>0){h=l+380|0;o=l+384|0;q=f[a+80>>2]|0;r=f[i>>2]|0;s=0;while(1){t=f[m+(s*12|0)+4>>2]|0;if((t|0)>0){v=f[h>>2]|0;w=f[o>>2]|0;x=0;y=0.0;while(1){z=f[r+(x<<4)>>2]|0;A=f[w+(f[v+(z<<6)+20>>2]<<2)>>2]|0;B=f[w+(f[v+(z<<6)+24>>2]<<2)>>2]|0;C=f[w+(f[v+(z<<6)+36>>2]<<2)>>2]|0;D=f[w+(f[v+(z<<6)+40>>2]<<2)>>2]|0;E=A-B-C+D|0;F=f[w+(f[v+(z<<6)+4>>2]<<2)>>2]|0;G=f[w+(f[v+(z<<6)+16>>2]<<2)>>2]|0;H=f[w+(f[v+(z<<6)+8>>2]<<2)>>2]|0;I=f[w+(f[v+(z<<6)+28>>2]<<2)>>2]|0;J=f[w+(f[v+(z<<6)+44>>2]<<2)>>2]|0;K=f[w+(f[v+(z<<6)+56>>2]<<2)>>2]|0;L=f[w+(f[v+(z<<6)+52>>2]<<2)>>2]|0;M=f[w+(f[v+(z<<6)+32>>2]<<2)>>2]|0;N=q+((Y(x,c)|0)<<2)+((((B-A+F-H|0)>=(E|0)?2:0)|(((f[w+(f[v+(z<<6)>>2]<<2)>>2]|0)+A-F-G|0)>=(E|0)?4:0)|(H-B-(f[w+(f[v+(z<<6)+12>>2]<<2)>>2]|0)+I|0)>=(E|0))<<2)|0;O=y+ +n[(1<<(((D-J-K+(f[w+(f[v+(z<<6)+60>>2]<<2)>>2]|0)|0)>=(E|0)?8:0)|((B-D-I+J|0)>=(E|0)?16:0)|((C-D+K-L|0)>=(E|0)?4:0)|(C-A+G-M|0)>=(E|0)|((L-C+M-(f[w+(f[v+(z<<6)+48>>2]<<2)>>2]|0)|0)>=(E|0)?2:0))&f[N>>2]|0?r+(x<<4)+8|0:r+(x<<4)+12|0)>>2];x=x+1|0;if((x|0)==(t|0)){P=O;break}else y=O}}else P=0.0;if(P<+n[m+(s*12|0)+8>>2])break;q=q+((Y(t,c)|0)<<2)|0;x=s+1|0;if((x|0)>=(j|0)){Q=P;R=11;break a}else{r=r+(t<<4)|0;s=x}}p[d>>3]=P;S=0-s|0}else{Q=0.0;R=11}while(0);if((R|0)==11){p[d>>3]=Q;S=1}if(!(f[g+4>>2]|0)){u=e;return S|0}u=e;return S|0}function $qa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0.0,F=0;d=u;u=u+16|0;e=d;dQ(e,104088);g=f[a+32>>2]|0;h=(f[a+36>>2]|0)-g|0;i=(h|0)/12|0;j=f[b+4>>2]|0;b=f[a+68>>2]|0;k=f[a+56>>2]|0;l=f[a+44>>2]|0;a=g;a:do if((h|0)>0){g=0;m=0;o=0;while(1){q=f[a+(o*12|0)+4>>2]|0;p[c>>3]=0.0;if((q|0)>0){r=a+(o*12|0)|0;s=0;t=g;v=m;while(1){w=(f[r>>2]|0)+s|0;x=0;do{y=x+t|0;z=+_pa(j,f[k+(y<<4)>>2]|0);x=f[(z<+n[k+(y<<4)+4>>2]?k+(y<<4)+8|0:k+(y<<4)+12|0)>>2]|0}while((x|0)>0);z=+p[c>>3]+ +n[b+(v-x<<2)>>2];p[c>>3]=z;y=f[l+(w<<2)>>2]|0;A=y+t|0;B=v+1+y|0;s=s+1|0;if((s|0)>=(q|0)){C=A;D=B;E=z;break}else{t=A;v=B}}}else{C=g;D=m;E=0.0}if(E<+n[a+(o*12|0)+8>>2]){F=0-o|0;break a}o=o+1|0;if((o|0)>=(i|0)){F=1;break}else{g=C;m=D}}}else F=1;while(0);if(!(f[e+4>>2]|0)){u=d;return F|0}u=d;return F|0}function ara(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0.0,W=0,X=0;d=u;u=u+16|0;e=d;dQ(e,104068);g=f[a+32>>2]|0;h=(f[a+36>>2]|0)-g|0;i=(h|0)/12|0;j=f[b+4>>2]|0;b=((f[a+12>>2]|0)+31|0)/32|0;k=f[a+80>>2]|0;l=f[a+68>>2]|0;m=f[a+56>>2]|0;o=f[a+44>>2]|0;a=g;if((h|0)>0){h=j+380|0;g=j+384|0;j=0;q=0;r=0;while(1){s=f[a+(r*12|0)+4>>2]|0;if((s|0)>0){t=f[a+(r*12|0)>>2]|0;v=f[h>>2]|0;w=f[g>>2]|0;x=0;y=j;z=q;A=0.0;while(1){B=0;do{C=B+y|0;D=f[m+(C<<4)>>2]|0;E=f[w+(f[v+(D<<6)+20>>2]<<2)>>2]|0;F=f[w+(f[v+(D<<6)+24>>2]<<2)>>2]|0;G=f[w+(f[v+(D<<6)+36>>2]<<2)>>2]|0;H=f[w+(f[v+(D<<6)+40>>2]<<2)>>2]|0;I=E-F-G+H|0;J=f[w+(f[v+(D<<6)+4>>2]<<2)>>2]|0;K=f[w+(f[v+(D<<6)+16>>2]<<2)>>2]|0;L=f[w+(f[v+(D<<6)+8>>2]<<2)>>2]|0;M=f[w+(f[v+(D<<6)+28>>2]<<2)>>2]|0;N=f[w+(f[v+(D<<6)+44>>2]<<2)>>2]|0;O=f[w+(f[v+(D<<6)+56>>2]<<2)>>2]|0;P=f[w+(f[v+(D<<6)+52>>2]<<2)>>2]|0;Q=f[w+(f[v+(D<<6)+32>>2]<<2)>>2]|0;R=k+((Y(C,b)|0)<<2)+((((F-E+J-L|0)>=(I|0)?2:0)|(((f[w+(f[v+(D<<6)>>2]<<2)>>2]|0)+E-J-K|0)>=(I|0)?4:0)|(L-F-(f[w+(f[v+(D<<6)+12>>2]<<2)>>2]|0)+M|0)>=(I|0))<<2)|0;B=f[(1<<(((H-N-O+(f[w+(f[v+(D<<6)+60>>2]<<2)>>2]|0)|0)>=(I|0)?8:0)|((F-H-M+N|0)>=(I|0)?16:0)|((G-H+O-P|0)>=(I|0)?4:0)|(G-E+K-Q|0)>=(I|0)|((P-G+Q-(f[w+(f[v+(D<<6)+48>>2]<<2)>>2]|0)|0)>=(I|0)?2:0))&f[R>>2]|0?m+(C<<4)+8|0:m+(C<<4)+12|0)>>2]|0}while((B|0)>0);S=A+ +n[l+(z-B<<2)>>2];C=f[o+(t+x<<2)>>2]|0;R=C+y|0;I=z+1+C|0;x=x+1|0;if((x|0)==(s|0)){T=R;U=I;V=S;break}else{y=R;z=I;A=S}}}else{T=j;U=q;V=0.0}if(V<+n[a+(r*12|0)+8>>2]){W=0-r|0;break}r=r+1|0;if((r|0)>=(i|0)){W=1;break}else{j=T;q=U}}p[c>>3]=V;X=W}else X=1;if(!(f[e+4>>2]|0)){u=d;return X|0}u=d;return X|0}function bra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/20|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;i=(f[e>>2]|0)+20|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/20|0;g=i+b|0;if(g>>>0>214748364)c4b(a);j=(d-h|0)/20|0;h=j<<1;d=j>>>0<107374182?(h>>>0<g>>>0?g:h):214748364;do if(d)if(d>>>0>214748364){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d*20|0)|0;break}else k=0;while(0);h=k+(i*20|0)|0;i=k+(d*20|0)|0;d=b;b=h;k=h;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;b=k+20|0;k=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;g=h+(((b|0)/-20|0)*20|0)|0;if((b|0)>0)Vac(g|0,d|0,b|0)|0;f[a>>2]=g;f[e>>2]=k;f[c>>2]=i;if(!d)return;O5b(d);return}function cra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=(g|0)/12|0;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=((j-k|0)/12|0)>>>0){m=a+4|0;n=((f[m>>2]|0)-k|0)/12|0;o=h>>>0>n>>>0;p=o?b+(n*12|0)|0:c;c=p;n=c-e|0;if(n|0)Xac(k|0,b|0,n|0)|0;e=l+(((n|0)/12|0)*12|0)|0;if(o){o=d-c|0;if((o|0)<=0)return;Vac(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(((o>>>0)/12|0)*12|0);return}else{o=f[m>>2]|0;if((o|0)==(e|0))return;f[m>>2]=o+(~(((o+-12-e|0)>>>0)/12|0)*12|0);return}}e=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~(((o+-12-k|0)>>>0)/12|0)*12|0);O5b(e);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>357913941)c4b(a);j=(q|0)/12|0;q=j<<1;e=j>>>0<178956970?(q>>>0<h>>>0?h:q):357913941;if(e>>>0>357913941)c4b(a);q=L5b(e*12|0)|0;h=a+4|0;f[h>>2]=q;f[a>>2]=q;f[i>>2]=q+(e*12|0);if((g|0)<=0)return;Vac(q|0,b|0,g|0)|0;f[h>>2]=q+(((g>>>0)/12|0)*12|0);return}function dra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>2;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>2>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>2;o=h>>>0>n>>>0;p=o?b+(n<<2)|0:c;c=p;n=c-e|0;e=n>>2;if(e|0)Xac(k|0,b|0,n|0)|0;n=l+(e<<2)|0;if(o){o=d-c|0;if((o|0)<=0)return;Vac(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>2<<2);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);O5b(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>1073741823)c4b(a);j=q>>1;n=q>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;if(n>>>0>1073741823)c4b(a);j=L5b(n<<2)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<2);if((g|0)<=0)return;Vac(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>2<<2);return}function era(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>4;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>4>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>4;o=h>>>0>n>>>0;p=o?b+(n<<4)|0:c;c=p;n=c-e|0;e=n>>4;if(e|0)Xac(k|0,b|0,n|0)|0;n=l+(e<<4)|0;if(o){o=d-c|0;if((o|0)<=0)return;Vac(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>4<<4);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-16-n|0)>>>4)<<4);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-16-k|0)>>>4)<<4);O5b(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>268435455)c4b(a);j=q>>3;n=q>>4>>>0<134217727?(j>>>0<h>>>0?h:j):268435455;if(n>>>0>268435455)c4b(a);j=L5b(n<<4)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<4);if((g|0)<=0)return;Vac(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>4<<4);return}function fra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>4;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>4>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>4;o=h>>>0>n>>>0;p=o?b+(n<<4)|0:c;c=p;n=c-e|0;e=n>>4;if(e|0)Xac(k|0,b|0,n|0)|0;n=l+(e<<4)|0;if(o){o=d-c|0;if((o|0)<=0)return;Vac(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>4<<4);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-16-n|0)>>>4)<<4);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-16-k|0)>>>4)<<4);O5b(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>268435455)c4b(a);j=q>>3;n=q>>4>>>0<134217727?(j>>>0<h>>>0?h:j):268435455;if(n>>>0>268435455)c4b(a);j=L5b(n<<4)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<4);if((g|0)<=0)return;Vac(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>4<<4);return}function gra(a){a=a|0;var b=0,c=0,d=0;b=f[a+88>>2]|0;if(b|0){c=a+92|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);O5b(b)}b=f[a+76>>2]|0;if(b|0){d=a+80|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+64>>2]|0;if(b|0){c=a+68|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+52>>2]|0;if(b|0){d=a+56|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-16-b|0)>>>4)<<4);O5b(b)}b=f[a+40>>2]|0;if(b|0){c=a+44|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+28>>2]|0;if(!b)return;d=a+32|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~(((a+-12-b|0)>>>0)/12|0)*12|0);O5b(b);return}function hra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c+8|0;e=c;g=a+224|0;h=a+248|0;i=f[h>>2]|0;if(i|0?(j=i+8|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)iI(g);g=a+228|0;if((f[g>>2]|0)>0){i=f[a+256>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[g>>2]|0))}f[h>>2]=0;h=a+272|0;g=a+296|0;j=f[g>>2]|0;if(j|0?(i=j+8|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)iI(h);h=a+276|0;if((f[h>>2]|0)>0){j=f[a+304>>2]|0;i=0;do{f[j+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[h>>2]|0))}f[g>>2]=0;g=a+320|0;h=a+344|0;i=f[h>>2]|0;if(i|0?(j=i+8|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)iI(g);g=a+324|0;if((f[g>>2]|0)>0){i=f[a+352>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[g>>2]|0))}f[h>>2]=0;if(!(kra(a+4|0,b)|0)){k=0;u=c;return k|0}lra(d,f[a+8>>2]|0);h=a+104|0;g=f[d>>2]|0;j=f[d+4>>2]|0;if(g|0){i=g+4|0;f[i>>2]=(f[i>>2]|0)+1}i=f[h>>2]|0;f[h>>2]=g;g=a+108|0;f[g>>2]=j;if(i|0?(j=i+4|0,h=f[j>>2]|0,f[j>>2]=h+-1,(h|0)==1):0)bi[f[(f[i>>2]|0)+8>>2]&2047](i);i=f[d>>2]|0;if(i|0?(h=i+4|0,j=f[h>>2]|0,f[h>>2]=j+-1,(j|0)==1):0)bi[f[(f[i>>2]|0)+8>>2]&2047](i);jW(d,b,353969);if(!(f[d+4>>2]|0))l=0;else{b=f[g>>2]|0;g=f[(f[b>>2]|0)+8>>2]|0;f[e>>2]=f[a+24>>2];f[e+4>>2]=f[a+28>>2];l=li[g&511](b,d,e)|0}k=l;u=c;return k|0}function ira(a){a=a|0;O5b(a);return}function jra(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c>>2]=f[a+8>>2];Vra(c);if(!a){u=b;return}bi[f[(f[a>>2]|0)+4>>2]&2047](a);u=b;return}function kra(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0;d=u;u=u+512|0;e=d+16|0;g=d+480|0;h=d+464|0;i=d+504|0;j=d+496|0;k=d+8|0;l=d+488|0;m=d+420|0;o=d+376|0;p=d;q=d+352|0;r=d+472|0;s=d+292|0;t=d+248|0;v=d+232|0;w=d+216|0;x=d+200|0;y=d+196|0;z=d+152|0;A=d+108|0;B=d+64|0;C=d+368|0;D=d+344|0;E=d+336|0;F=d+60|0;G=d+240|0;H=d+224|0;I=d+208|0;jW(e,c,353978);f[g>>2]=0;f[g+4>>2]=0;yW(e,g,g);J=f[g>>2]|0;if((J|0)!=353988?gTb((J|0)==0?1124530:J,353988)|0:0){K=0;bD(g);u=d;return K|0}f[a>>2]=0;jW(e,c,353994);f[h>>2]=0;f[h+4>>2]=0;yW(e,h,h);J=f[h>>2]|0;do if((J|0)!=354006?(L=(J|0)==0?1124530:J,(gTb(L,354006)|0)!=0):0){if((J|0)!=354011?gTb(L,354011)|0:0){if((J|0)!=354015?gTb(L,354015)|0:0){M=0;break}f[a+4>>2]=2;f[e>>2]=0;f[e+4>>2]=0;N=aD(e,35)|0;O=354019;P=N+35|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));bO(-213,e,363731,350849,1472);bD(e);Q=12;break}f[a+4>>2]=1;Q=12}else Q=5;while(0);if((Q|0)==5){f[a+4>>2]=0;Q=12}if((Q|0)==12){jW(i,c,434730);vW(i,e,0);i=a+20|0;f[i>>2]=f[e>>2];jW(j,c,434884);vW(j,e,0);j=f[e>>2]|0;f[a+24>>2]=j;if(!((j|0)>0?(f[i>>2]|0)>0:0)){f[e>>2]=0;f[e+4>>2]=0;N=aD(e,47)|0;O=354055;P=N+47|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));bO(-215,e,363731,350849,1479);bD(e)}jW(k,c,354103);i=k+4|0;if((f[i>>2]|0)!=0?(jW(l,k,354117),vW(l,e,0),l=f[e>>2]|0,f[a+8>>2]=l,j=(l+31|0)/32|0,J=(l|0)>0,l=J?j+3|0:4,jW(e,c,355036),c=e,L=f[c>>2]|0,R=f[c+4>>2]|0,c=k,f[c>>2]=L,f[c+4>>2]=R,!(R>>>0<1|(R|0)==1&L>>>0<0)):0){L=a+28|0;mra(L,lW(k)|0);R=a+40|0;c=f[R>>2]|0;S=a+44|0;T=f[S>>2]|0;if((T|0)!=(c|0))f[S>>2]=T+(~((T+-4-c|0)>>>2)<<2);c=a+52|0;T=f[c>>2]|0;U=a+56|0;V=f[U>>2]|0;if((V|0)!=(T|0))f[U>>2]=V+(~((V+-16-T|0)>>>4)<<4);T=a+88|0;V=f[T>>2]|0;W=a+92|0;X=f[W>>2]|0;if((X|0)!=(V|0))f[W>>2]=X+(~((X+-16-V|0)>>>4)<<4);kW(m,f[k>>2]|0,f[i>>2]|0,0);V=f[k>>2]|0;X=f[i>>2]|0;kW(o,V,X,lW(k)|0);k=a+12|0;f[k>>2]=2147483647;X=a+16|0;f[X>>2]=0;V=m+4|0;i=o+4|0;Z=m+20|0;_=o+20|0;$=m+40|0;aa=o+40|0;ba=p+4|0;ca=q+8|0;da=q+4|0;ea=a+32|0;fa=a+36|0;ga=s+4|0;ha=t+4|0;ia=s+20|0;ja=t+20|0;ka=s+40|0;la=t+40|0;ma=v+4|0;na=w+4|0;oa=x+4|0;pa=a+48|0;qa=a+64|0;ra=a+68|0;sa=a+76|0;ta=a+80|0;ua=z+4|0;va=A+4|0;wa=z+20|0;xa=A+20|0;ya=z+40|0;za=A+40|0;Aa=C+4|0;Ba=B+8|0;Ca=D+4|0;Da=B+12|0;Ea=E+4|0;Fa=a+60|0;Ga=H+4|0;Ha=B+4|0;Ia=G+4|0;Ja=a+84|0;Ka=I+4|0;La=a+72|0;Ma=0;a:while(1){Na=f[m>>2]|0;Oa=Na;if((((Na|0)==(f[o>>2]|0)?(f[V>>2]|0)==(f[i>>2]|0):0)?(f[Z>>2]|0)==(f[_>>2]|0):0)?(f[$>>2]|0)==(f[aa>>2]|0):0){Q=73;break}Na=f[Z>>2]|0;f[p>>2]=Oa;f[ba>>2]=Na;jW(r,p,354129);wW(r,e,0.0);n[ca>>2]=+n[e>>2]+-9.999999747378752e-06;jW(e,p,354144);Na=e;Oa=f[Na>>2]|0;Pa=f[Na+4>>2]|0;Na=p;f[Na>>2]=Oa;f[Na+4>>2]=Pa;if(Pa>>>0<1|(Pa|0)==1&Oa>>>0<0){Q=29;break}Oa=lW(p)|0;f[da>>2]=Oa;f[q>>2]=(f[S>>2]|0)-(f[R>>2]|0)>>2;Oa=f[ea>>2]|0;if((Oa|0)==(f[fa>>2]|0))nra(L,q);else{f[Oa>>2]=f[q>>2];f[Oa+4>>2]=f[q+4>>2];f[Oa+8>>2]=f[q+8>>2];f[ea>>2]=(f[ea>>2]|0)+12}Oa=f[L>>2]|0;ora(R,(f[Oa+(Ma*12|0)+4>>2]|0)+(f[Oa+(Ma*12|0)>>2]|0)|0);kW(s,f[p>>2]|0,f[ba>>2]|0,0);Oa=f[p>>2]|0;Pa=f[ba>>2]|0;kW(t,Oa,Pa,lW(p)|0);while(1){Pa=f[s>>2]|0;Oa=Pa;if((((Pa|0)==(f[t>>2]|0)?(f[ga>>2]|0)==(f[ha>>2]|0):0)?(f[ia>>2]|0)==(f[ja>>2]|0):0)?(f[ka>>2]|0)==(f[la>>2]|0):0)break;Pa=f[ia>>2]|0;f[v>>2]=Oa;f[ma>>2]=Pa;jW(w,v,354160);jW(x,v,354174);if((f[na>>2]|0)==0|(f[oa>>2]|0)==0){Q=71;break a}Pa=(lW(w)|0)/(l|0)|0;f[y>>2]=Pa;Oa=f[k>>2]|0;f[k>>2]=(Pa|0)<(Oa|0)?Pa:Oa;Oa=f[X>>2]|0;f[X>>2]=(Oa|0)<(Pa|0)?Pa:Oa;Oa=f[S>>2]|0;if((Oa|0)==(f[pa>>2]|0))pra(R,y);else{f[Oa>>2]=Pa;f[S>>2]=Oa+4}qra(c,((f[U>>2]|0)-(f[c>>2]|0)>>4)+(f[y>>2]|0)|0);Oa=f[ra>>2]|0;Pa=f[qa>>2]|0;rra(qa,(Oa-Pa>>2)+(lW(x)|0)|0);if(J)sra(sa,((f[ta>>2]|0)-(f[sa>>2]|0)>>2)+(Y(f[y>>2]|0,j)|0)|0);kW(z,f[w>>2]|0,f[na>>2]|0,0);Pa=f[w>>2]|0;Oa=f[na>>2]|0;kW(A,Pa,Oa,lW(w)|0);b:while(1){Oa=f[z>>2]|0;Pa=Oa;do if((Oa|0)==(f[A>>2]|0)){if((f[ua>>2]|0)!=(f[va>>2]|0))break;if((f[wa>>2]|0)!=(f[xa>>2]|0))break;if((f[ya>>2]|0)==(f[za>>2]|0))break b}while(0);Oa=f[wa>>2]|0;f[C>>2]=Pa;f[Aa>>2]=Oa;vW(C,e,0);f[Ba>>2]=f[e>>2];mW(z)|0;Oa=f[wa>>2]|0;f[D>>2]=f[z>>2];f[Ca>>2]=Oa;vW(D,e,0);f[Da>>2]=f[e>>2];mW(z)|0;Oa=f[wa>>2]|0;f[E>>2]=f[z>>2];f[Ea>>2]=Oa;vW(E,e,0);f[B>>2]=f[e>>2];mW(z)|0;if(J){Oa=0;while(1){if((Oa|0)>=(j|0))break;Na=f[wa>>2]|0;f[G>>2]=f[z>>2];f[Ia>>2]=Na;vW(G,e,0);Na=f[e>>2]|0;f[F>>2]=Na;Qa=f[ta>>2]|0;if((Qa|0)==(f[Ja>>2]|0))IO(sa,F);else{f[Qa>>2]=Na;f[ta>>2]=Qa+4}mW(z)|0;Oa=Oa+1|0}n[Ha>>2]=0.0}else{Oa=f[wa>>2]|0;f[H>>2]=f[z>>2];f[Ga>>2]=Oa;wW(H,e,0.0);f[Ha>>2]=f[e>>2];mW(z)|0}Oa=f[U>>2]|0;if((Oa|0)==(f[Fa>>2]|0))tra(c,B);else{f[Oa>>2]=f[B>>2];f[Oa+4>>2]=f[B+4>>2];f[Oa+8>>2]=f[B+8>>2];f[Oa+12>>2]=f[B+12>>2];f[U>>2]=(f[U>>2]|0)+16}}kW(e,f[x>>2]|0,f[oa>>2]|0,0);N=z;O=e;P=N+44|0;do{f[N>>2]=f[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(P|0));Oa=f[x>>2]|0;Pa=f[oa>>2]|0;kW(B,Oa,Pa,lW(x)|0);N=A;O=B;P=N+44|0;do{f[N>>2]=f[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(P|0));c:while(1){Pa=f[z>>2]|0;Oa=Pa;do if((Pa|0)==(f[A>>2]|0)){if((f[ua>>2]|0)!=(f[va>>2]|0))break;if((f[wa>>2]|0)!=(f[xa>>2]|0))break;if((f[ya>>2]|0)==(f[za>>2]|0))break c}while(0);Pa=f[wa>>2]|0;f[I>>2]=Oa;f[Ka>>2]=Pa;wW(I,e,0.0);Pa=f[e>>2]|0;f[B>>2]=Pa;Qa=f[ra>>2]|0;if((Qa|0)==(f[La>>2]|0))upa(qa,B);else{f[Qa>>2]=Pa;f[ra>>2]=Qa+4}mW(z)|0}mW(s)|0}mW(m)|0;Ma=Ma+1|0}d:do if((Q|0)==29)Ra=0;else if((Q|0)==71)Ra=0;else if((Q|0)==73)if((f[X>>2]|0)==1?(Ma=f[L>>2]|0,m=(f[ea>>2]|0)-Ma|0,s=(m|0)/12|0,(m|0)!=0):0){m=a+64|0;z=e+4|0;ra=e+8|0;B=e+12|0;qa=a+96|0;La=0;I=0;Ka=0;wa=Ma;while(1){Ma=f[wa+(La*12|0)+4>>2]|0;if((Ma|0)>0){za=0;ya=I;xa=Ka;while(1){va=f[c>>2]|0;ua=f[va+(xa<<4)+4>>2]|0;A=f[m>>2]|0;O=f[A+(ya<<2)>>2]|0;N=f[A+(ya+1<<2)>>2]|0;f[e>>2]=f[va+(xa<<4)>>2];f[z>>2]=ua;f[ra>>2]=O;f[B>>2]=N;N=f[W>>2]|0;if((N|0)==(f[qa>>2]|0))ura(T,e);else{f[N>>2]=f[e>>2];f[N+4>>2]=f[e+4>>2];f[N+8>>2]=f[e+8>>2];f[N+12>>2]=f[e+12>>2];f[W>>2]=(f[W>>2]|0)+16}za=za+1|0;N=xa+1|0;O=ya+2|0;if((za|0)>=(Ma|0)){Sa=O;Ta=N;break}else{ya=O;xa=N}}}else{Sa=I;Ta=Ka}xa=La+1|0;if(xa>>>0>=s>>>0){Ra=1;break d}La=xa;I=Sa;Ka=Ta;wa=f[L>>2]|0}}else Ra=1;while(0);Ua=Ra}else Ua=0;M=Ua}bD(h);K=M;bD(g);u=d;return K|0}function lra(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;switch(c|0){case 0:{c=L5b(436)|0;d=c+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[c+44>>2]=1124007936;d=c+52|0;e=c+84|0;g=c+48|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=c+92|0;f[c+88>>2]=d;f[d>>2]=0;f[c+96>>2]=0;f[c+100>>2]=1124007936;d=c+108|0;e=c+140|0;g=c+104|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=d;d=c+148|0;f[c+144>>2]=d;f[d>>2]=0;f[c+152>>2]=0;f[c+156>>2]=1124007936;d=c+160|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+188>>2]=c+164;d=c+196|0;f[c+192>>2]=d;f[c+200>>2]=0;f[d>>2]=0;f[c+204>>2]=1124007936;d=c+208|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+236>>2]=c+212;d=c+244|0;f[c+240>>2]=d;f[c+248>>2]=0;f[d>>2]=0;f[c+252>>2]=1124007936;d=c+256|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+284>>2]=c+260;d=c+292|0;f[c+288>>2]=d;f[c+296>>2]=0;f[d>>2]=0;f[c+300>>2]=1124007936;d=c+304|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+332>>2]=c+308;d=c+340|0;f[c+336>>2]=d;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[c>>2]=103556;d=c+356|0;e=c+24|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;g=c+392|0;h=g+40|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=4;f[c+28>>2]=2;f[c+32>>2]=0;f[c+36>>2]=0;f[c+40>>2]=0;f[c+384>>2]=0;f[c+388>>2]=0;n[c+432>>2]=0.0;b[c+380>>0]=0;e=L5b(16)|0;f[e+4>>2]=1;f[e>>2]=103656;f[e+8>>2]=c;f[a>>2]=e;f[a+4>>2]=c;return}case 1:{c=L5b(388)|0;uqa(c);e=L5b(16)|0;f[e+4>>2]=1;f[e>>2]=103776;f[e+8>>2]=c;f[a>>2]=e;f[a+4>>2]=c;return}default:{f[a>>2]=0;f[a+4>>2]=0;return}}}function mra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[a>>2]|0;if((((f[c>>2]|0)-d|0)/12|0)>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>357913941){g=ze(8)|0;T5b(g,477177);f[g>>2]=149528;If(g|0,25408,1411)}g=(f[e>>2]|0)-d|0;h=L5b(b*12|0)|0;i=h+(((g|0)/12|0)*12|0)|0;j=i+(((g|0)/-12|0)*12|0)|0;if((g|0)>0)Vac(j|0,d|0,g|0)|0;f[a>>2]=j;f[e>>2]=i;f[c>>2]=h+(b*12|0);if(!d)return;O5b(d);return}function nra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)c4b(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;O5b(d);return}function ora(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=ze(8)|0;T5b(g,477177);f[g>>2]=149528;If(g|0,25408,1411)}g=(f[e>>2]|0)-d|0;h=g>>2;i=L5b(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)Vac(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;O5b(d);return}function pra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function qra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>4>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>268435455){g=ze(8)|0;T5b(g,477177);f[g>>2]=149528;If(g|0,25408,1411)}g=(f[e>>2]|0)-d|0;h=g>>4;i=L5b(b<<4)|0;j=i+(h<<4)|0;k=j+(0-h<<4)|0;if((g|0)>0)Vac(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<4);if(!d)return;O5b(d);return}function rra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=ze(8)|0;T5b(g,477177);f[g>>2]=149528;If(g|0,25408,1411)}g=(f[e>>2]|0)-d|0;h=g>>2;i=L5b(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)Vac(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;O5b(d);return}function sra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=ze(8)|0;T5b(g,477177);f[g>>2]=149528;If(g|0,25408,1411)}g=(f[e>>2]|0)-d|0;h=g>>2;i=L5b(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)Vac(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;O5b(d);return}function tra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;O5b(d);return}function ura(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;O5b(d);return}function vra(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0;d=u;u=u+16|0;e=d;dQ(e,103948);Tqa(a,b,c,0,0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function wra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,104168);Tqa(a,c,d,b,0);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function xra(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0;g=u;u=u+16|0;h=g;dQ(h,103928);Tqa(a,d,e,b,c);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function yra(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0;g=u;u=u+192|0;h=g+172|0;i=g+160|0;j=g+148|0;k=g+136|0;l=g+88|0;m=g;n=g+120|0;o=g+112|0;dQ(o,104228);q=f[e>>2]|0;r=f[e+4>>2]|0;e=a+4|0;s=f[e>>2]|0;t=f[a>>2]|0;v=s-t|0;w=v>>4;f[h>>2]=0;x=h+4|0;f[x>>2]=0;f[h+8>>2]=0;y=(w|0)==0;z=t;A=s;do if(!y)if(w>>>0>178956970)c4b(h);else{s=w*24|0;B=L5b(s)|0;f[h>>2]=B;f[h+8>>2]=B+(w*24|0);Nac(B|0,0,s|0)|0;f[x>>2]=B+s;C=B;break}else C=0;while(0);f[i>>2]=0;B=i+4|0;f[B>>2]=0;f[i+8>>2]=0;f[j>>2]=0;s=j+4|0;f[s>>2]=0;f[j+8>>2]=0;if(y)D=0;else{y=v>>1;E=L5b(y)|0;f[j>>2]=E;F=E+(w<<3)|0;f[j+8>>2]=F;Nac(E|0,0,y|0)|0;f[s>>2]=F;D=E}f[k>>2]=0;E=k+4|0;f[E>>2]=0;f[k+8>>2]=0;if((v|0)>0){v=f[b>>2]|0;F=f[c>>2]|0;c=0;do{p[D+(c<<3)>>3]=+p[v+(c<<3)>>3];y=(f[z+(c<<4)+12>>2]|0)+(f[z+(c<<4)+4>>2]<<1)|0;G=MVb(+((f[z+(c<<4)+8>>2]|0)+(f[z+(c<<4)>>2]<<1)|0)*.5)|0;H=+(MVb(+(y|0)*.5)|0);I=+W(+(+p[F+(c<<3)>>3]));p[C+(c*24|0)>>3]=+(G|0);p[C+(c*24|0)+8>>3]=H;p[C+(c*24|0)+16>>3]=I;c=c+1|0}while((c|0)<(w|0))}if((A|0)!=(z|0))f[e>>2]=A+(~((A+-16-t|0)>>>4)<<4);t=f[b>>2]|0;A=b+4|0;z=f[A>>2]|0;if((z|0)!=(t|0))f[A>>2]=z+(~((z+-8-t|0)>>>3)<<3);p[l>>3]=8.0;p[l+8>>3]=16.0;p[l+16>>3]=.26236426446749106;zra(m,l,h,j,1.0e-05,100);Ara(m,i,k,1.0);l=f[i>>2]|0;if((f[B>>2]|0)!=(l|0)){t=n+4|0;z=n+8|0;w=n+12|0;c=a+8|0;C=b+8|0;I=+(q|0);H=+(r|0);r=0;q=l;do{l=q;J=+V(+(+p[l+(r*24|0)+16>>3]));F=~~(I*J);v=~~(H*J);D=~~(+p[l+(r*24|0)>>3]-+((F|0)/2|0|0));G=~~(+p[l+(r*24|0)+8>>3]-+((v|0)/2|0|0));f[n>>2]=D;f[t>>2]=G;f[z>>2]=F;f[w>>2]=v;l=f[k>>2]|0;do if(+p[l+(r<<3)>>3]>d){y=f[e>>2]|0;if((y|0)==(f[c>>2]|0)){Zoa(a,n);K=f[k>>2]|0}else{f[y>>2]=D;f[y+4>>2]=G;f[y+8>>2]=F;f[y+12>>2]=v;f[e>>2]=y+16;K=l}y=K+(r<<3)|0;L=f[A>>2]|0;if((L|0)==(f[C>>2]|0)){apa(b,y);break}else{p[L>>3]=+p[y>>3];f[A>>2]=L+8;break}}while(0);r=r+1|0;q=f[i>>2]|0}while(r>>>0<(((f[B>>2]|0)-q|0)/24|0)>>>0)}q=f[m+64>>2]|0;if(q|0){r=m+68|0;A=f[r>>2]|0;if((A|0)!=(q|0))f[r>>2]=A+(~(((A+-24-q|0)>>>0)/24|0)*24|0);O5b(q)}q=f[m+52>>2]|0;if(q|0){A=m+56|0;r=f[A>>2]|0;if((r|0)!=(q|0))f[A>>2]=r+(~(((r+-24-q|0)>>>0)/24|0)*24|0);O5b(q)}q=f[m+12>>2]|0;if(q|0){r=m+16|0;A=f[r>>2]|0;if((A|0)!=(q|0))f[r>>2]=A+(~((A+-8-q|0)>>>3)<<3);O5b(q)}q=f[m>>2]|0;if(q|0){A=m+4|0;m=f[A>>2]|0;if((m|0)!=(q|0))f[A>>2]=m+(~(((m+-24-q|0)>>>0)/24|0)*24|0);O5b(q)}q=f[k>>2]|0;if(q|0){k=f[E>>2]|0;if((k|0)!=(q|0))f[E>>2]=k+(~((k+-8-q|0)>>>3)<<3);O5b(q)}q=f[j>>2]|0;if(q|0){j=f[s>>2]|0;if((j|0)!=(q|0))f[s>>2]=j+(~((j+-8-q|0)>>>3)<<3);O5b(q)}q=f[i>>2]|0;if(q|0){i=f[B>>2]|0;if((i|0)!=(q|0))f[B>>2]=i+(~(((i+-24-q|0)>>>0)/24|0)*24|0);O5b(q)}q=f[h>>2]|0;if(q|0){h=f[x>>2]|0;if((h|0)!=(q|0))f[x>>2]=h+(~(((h+-24-q|0)>>>0)/24|0)*24|0);O5b(q)}if(!(f[o+4>>2]|0)){u=g;return}u=g;return}function zra(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0;h=u;u=u+48|0;i=h+24|0;j=h;k=a+4|0;l=a+12|0;m=a+52|0;n=a+56|0;o=a+64|0;q=a+68|0;r=a;s=r+48|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;p[a+24>>3]=+p[b>>3];r=a+32|0;p[r>>3]=+p[b+8>>3];s=a+40|0;p[s>>3]=+p[b+16>>3];if((l|0)!=(d|0))Dra(l,f[d>>2]|0,f[d+4>>2]|0);if((a|0)==(c|0))t=c+4|0;else{d=c+4|0;Era(a,f[c>>2]|0,f[d>>2]|0);t=d}d=((f[t>>2]|0)-(f[c>>2]|0)|0)/24|0;c=a+48|0;f[c>>2]=d;t=f[n>>2]|0;l=f[m>>2]|0;b=(t-l|0)/24|0;v=l;l=t;if(d>>>0<=b>>>0)if(d>>>0<b>>>0?(t=v+(d*24|0)|0,(l|0)!=(t|0)):0){f[n>>2]=l+(~(((l+-24-t|0)>>>0)/24|0)*24|0);w=d}else w=d;else{Fra(m,d-b|0);w=f[c>>2]|0}c=f[q>>2]|0;b=f[o>>2]|0;d=(c-b|0)/24|0;t=b;b=c;if(w>>>0<=d>>>0){if(w>>>0<d>>>0?(c=t+(w*24|0)|0,(b|0)!=(c|0)):0)f[q>>2]=b+(~(((b+-24-c|0)>>>0)/24|0)*24|0)}else Fra(o,w-d|0);d=a+76|0;f[d>>2]=g;g=a+80|0;p[g>>3]=e;w=f[a>>2]|0;if((f[k>>2]|0)==(w|0)){u=h;return}c=i+8|0;b=i+16|0;q=i+8|0;t=i+16|0;l=j+8|0;n=j+16|0;v=a+24|0;x=0;y=w;do{Gra(i,a,y+(x*24|0)|0);w=f[m>>2]|0;z=w+(x*24|0)|0;p[z>>3]=+p[i>>3];A=w+(x*24|0)+8|0;p[A>>3]=+p[c>>3];B=w+(x*24|0)+16|0;p[B>>3]=+p[b>>3];e=+p[z>>3];C=+p[A>>3];D=+p[B>>3];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;if((f[d>>2]|0)>0){B=0;E=D;F=e;G=C;do{p[i>>3]=F;p[q>>3]=G;p[t>>3]=E;Gra(j,a,i);F=+p[j>>3];G=+p[l>>3];E=+p[n>>3];H=+p[t>>3];I=+V(+H);J=(+p[i>>3]-F)/(+p[v>>3]*I);K=(+p[q>>3]-G)/(+p[r>>3]*I);I=(H-E)/+p[s>>3];B=B+1|0;if(I*I+(K*K+J*J)<=+p[g>>3])break}while((B|0)<(f[d>>2]|0));L=F;M=G;N=E;O=f[m>>2]|0}else{L=e;M=C;N=D;O=w}B=f[o>>2]|0;p[B+(x*24|0)>>3]=L;p[B+(x*24|0)+8>>3]=M;p[B+(x*24|0)+16>>3]=N;y=f[a>>2]|0;J=+p[y+(x*24|0)+8>>3];K=+p[y+(x*24|0)+16>>3];B=O+(x*24|0)|0;p[B>>3]=+p[B>>3]-+p[y+(x*24|0)>>3];B=O+(x*24|0)+8|0;p[B>>3]=+p[B>>3]-J;B=O+(x*24|0)+16|0;p[B>>3]=+p[B>>3]-K;x=x+1|0}while(x>>>0<(((f[k>>2]|0)-y|0)/24|0)>>>0);u=h;return}function Ara(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0;e=a+64|0;g=a+68|0;h=f[e>>2]|0;i=b+4|0;if((f[g>>2]|0)!=(h|0)){j=b+8|0;k=a+24|0;l=a+32|0;m=a+40|0;n=0;o=h;while(1){h=o;q=f[i>>2]|0;r=f[b>>2]|0;s=r;t=q;a:do if((q|0)==(r|0))u=14;else{v=+p[k>>3];w=+p[l>>3];x=+p[m>>3];y=(q-r|0)/24|0;z=+p[h+(n*24|0)>>3];A=+p[h+(n*24|0)+8>>3];B=+p[h+(n*24|0)+16>>3];C=0;while(1){D=+p[s+(C*24|0)+16>>3];E=+V(+D);F=(+p[s+(C*24|0)>>3]-z)/(v*E);G=(+p[s+(C*24|0)+8>>3]-A)/(w*E);E=(D-B)/x;C=C+1|0;if(E*E+(G*G+F*F)<d){H=o;break a}if(C>>>0>=y>>>0){u=14;break}}}while(0);do if((u|0)==14){u=0;s=h+(n*24|0)|0;if((t|0)==(f[j>>2]|0)){Bra(b,s);H=f[e>>2]|0;break}else{p[t>>3]=+p[s>>3];p[t+8>>3]=+p[h+(n*24|0)+8>>3];p[t+16>>3]=+p[h+(n*24|0)+16>>3];f[i>>2]=t+24;H=o;break}}while(0);n=n+1|0;if(n>>>0>=(((f[g>>2]|0)-H|0)/24|0)>>>0)break;else o=H}}H=f[i>>2]|0;o=f[b>>2]|0;g=(H-o|0)/24|0;n=c+4|0;e=f[n>>2]|0;j=f[c>>2]|0;u=e-j>>3;m=j;j=e;e=o;if(g>>>0<=u>>>0)if(g>>>0<u>>>0?(l=m+(g<<3)|0,(j|0)!=(l|0)):0){f[n>>2]=j+(~((j+-8-l|0)>>>3)<<3);I=e;J=H;K=o}else{I=e;J=H;K=o}else{Z2(c,g-u|0);u=f[b>>2]|0;I=u;J=f[i>>2]|0;K=u}if((J|0)==(K|0))return;K=0;J=I;do{d=+Cra(a,J+(K*24|0)|0);p[(f[c>>2]|0)+(K<<3)>>3]=d;K=K+1|0;J=f[b>>2]|0}while(K>>>0<(((f[i>>2]|0)-J|0)/24|0)>>>0);return}function Bra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/24|0;h=g+1|0;i=e;j=d;if(h>>>0>178956970)c4b(a);d=a+8|0;k=((f[d>>2]|0)-e|0)/24|0;l=k<<1;m=k>>>0<89478485?(l>>>0<h>>>0?h:l):178956970;do if(m)if(m>>>0>178956970){l=ze(8)|0;T5b(l,477177);f[l>>2]=149528;If(l|0,25408,1411)}else{n=L5b(m*24|0)|0;break}else n=0;while(0);l=n+(g*24|0)|0;h=n+(m*24|0)|0;p[l>>3]=+p[b>>3];p[n+(g*24|0)+8>>3]=+p[b+8>>3];p[n+(g*24|0)+16>>3]=+p[b+16>>3];b=l+24|0;if((j|0)==(i|0))o=l;else{g=j;j=l;while(1){l=g;g=g+-24|0;p[j+-24>>3]=+p[g>>3];p[j+-16>>3]=+p[l+-16>>3];p[j+-8>>3]=+p[l+-8>>3];l=j+-24|0;if((g|0)==(i|0)){o=l;break}else j=l}}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;O5b(e);return}function Cra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0;c=f[a+4>>2]|0;d=f[a>>2]|0;e=d;if((c|0)==(d|0)){g=0.0;return +g}h=+p[a+24>>3];i=+p[a+32>>3];j=+p[a+40>>3];k=+p[b>>3];l=+p[b+8>>3];m=+p[b+16>>3];b=f[a+12>>2]|0;a=(c-d|0)/24|0;n=0.0;d=0;while(1){o=+p[e+(d*24|0)+16>>3];q=+V(+o);r=h*q;s=i*q;q=(+p[e+(d*24|0)>>3]-k)/r;t=(+p[e+(d*24|0)+8>>3]-l)/s;u=(o-m)/j;o=n+ +p[b+(d<<3)>>3]*+V(+((q*q+t*t+u*u)*-.5))/+M(+(j+(r+s)));d=d+1|0;if(d>>>0>=a>>>0){g=o;break}else n=o}return +g}function Dra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>3;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>3>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>3;o=h>>>0>n>>>0;p=o?b+(n<<3)|0:c;c=p;n=c-e|0;e=n>>3;if(e|0)Xac(k|0,b|0,n|0)|0;n=l+(e<<3)|0;if(o){o=d-c|0;if((o|0)<=0)return;Vac(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>3<<3);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-8-n|0)>>>3)<<3);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-8-k|0)>>>3)<<3);O5b(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>536870911)c4b(a);j=q>>2;n=q>>3>>>0<268435455?(j>>>0<h>>>0?h:j):536870911;if(n>>>0>536870911)c4b(a);j=L5b(n<<3)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<3);if((g|0)<=0)return;Vac(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>3<<3);return}function Era(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;d=(c-b|0)/24|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0<=((g-h|0)/24|0)>>>0){j=a+4|0;k=f[j>>2]|0;l=(k-h|0)/24|0;m=d>>>0>l>>>0;n=b+(l*24|0)|0;l=m?n:c;o=k;if((l|0)==(b|0))q=i;else{k=b;r=i;while(1){p[r>>3]=+p[k>>3];p[r+8>>3]=+p[k+8>>3];p[r+16>>3]=+p[k+16>>3];k=k+24|0;s=r+24|0;if((k|0)==(l|0)){q=s;break}else r=s}}if(!m){if((o|0)==(q|0))return;f[j>>2]=o+(~(((o+-24-q|0)>>>0)/24|0)*24|0);return}if((l|0)==(c|0))return;l=n;n=f[j>>2]|0;do{p[n>>3]=+p[l>>3];p[n+8>>3]=+p[l+8>>3];p[n+16>>3]=+p[l+16>>3];l=l+24|0;n=n+24|0}while((l|0)!=(c|0));f[j>>2]=n;return}n=h;if(!h)t=g;else{g=a+4|0;j=f[g>>2]|0;if((j|0)!=(i|0))f[g>>2]=j+(~(((j+-24-h|0)>>>0)/24|0)*24|0);O5b(n);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;t=0}if(d>>>0>178956970)c4b(a);g=(t|0)/24|0;t=g<<1;n=g>>>0<89478485?(t>>>0<d>>>0?d:t):178956970;if(n>>>0>178956970)c4b(a);t=L5b(n*24|0)|0;d=a+4|0;f[d>>2]=t;f[a>>2]=t;f[e>>2]=t+(n*24|0);if((b|0)==(c|0))return;n=b;b=t;do{p[b>>3]=+p[n>>3];p[b+8>>3]=+p[n+8>>3];p[b+16>>3]=+p[n+16>>3];n=n+24|0;b=b+24|0}while((n|0)!=(c|0));f[d>>2]=b;return}function Fra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/24|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=(f[e>>2]|0)+24|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/24|0;g=i+b|0;if(g>>>0>178956970)c4b(a);j=(d-h|0)/24|0;h=j<<1;d=j>>>0<89478485?(h>>>0<g>>>0?g:h):178956970;do if(d)if(d>>>0>178956970){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d*24|0)|0;break}else k=0;while(0);h=k+(i*24|0)|0;i=h;g=k+(d*24|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;b=k+24|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{i=b;b=h;do{h=i;i=i+-24|0;p[b+-24>>3]=+p[i>>3];p[b+-16>>3]=+p[h+-16>>3];p[b+-8>>3]=+p[h+-8>>3];b=b+-24|0}while((i|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;O5b(m);return}function Gra(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,N=0.0,O=0.0;d=a+8|0;e=a+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;g=f[b+4>>2]|0;h=f[b>>2]|0;i=h;if((g|0)==(h|0)){j=0.0;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;q=m/j;p[a>>3]=q;r=n/l;p[d>>3]=r;s=o/k;p[e>>3]=s;return}t=+p[c>>3];u=+p[c+8>>3];v=+p[b+24>>3];w=+p[b+32>>3];x=+p[b+40>>3];y=+p[c+16>>3]/x;c=f[b+12>>2]|0;b=(g-h|0)/24|0;h=0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;do{F=+p[i+(h*24|0)+16>>3];G=+V(+F);H=v*G;I=w*G;G=+p[i+(h*24|0)>>3]/H;J=+p[i+(h*24|0)+8>>3]/I;K=F/x;F=G-t/H;L=J-u/I;N=K-y;O=+p[c+(h<<3)>>3]*+V(+((N*N+(F*F+L*L))*-.5))/+M(+(x+(H+I)));C=C+G*O;D=J*O+D;E=K*O+E;z=z+O/H;B=B+O/I;A=A+O/x;h=h+1|0}while(h>>>0<b>>>0);p[a>>3]=C;p[d>>3]=D;p[e>>3]=E;j=z;k=A;l=B;m=C;n=D;o=E;q=m/j;p[a>>3]=q;r=n/l;p[d>>3]=r;s=o/k;p[e>>3]=s;return}function Hra(a){a=a|0;var b=0,c=0,d=0;FY(a);f[a>>2]=103836;b=a+128|0;c=a+4|0;d=c+124|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(d|0));f[b>>2]=1124007936;b=a+132|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+160>>2]=a+136;b=a+168|0;f[a+164>>2]=b;f[a+172>>2]=0;f[b>>2]=0;f[a+176>>2]=1124007936;b=a+180|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+208>>2]=a+184;b=a+216|0;f[a+212>>2]=b;f[a+220>>2]=0;f[b>>2]=0;f[a+224>>2]=1124007936;b=a+228|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+256>>2]=a+232;b=a+264|0;f[a+260>>2]=b;f[a+268>>2]=0;f[b>>2]=0;f[a+272>>2]=1124007936;b=a+276|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+304>>2]=a+280;b=a+312|0;f[a+308>>2]=b;f[a+316>>2]=0;f[b>>2]=0;f[a+320>>2]=1124007936;b=a+324|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+352>>2]=a+328;b=a+360|0;f[a+356>>2]=b;f[a+364>>2]=0;f[b>>2]=0;f[a+368>>2]=1124007936;b=a+372|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+400>>2]=a+376;b=a+408|0;f[a+404>>2]=b;f[a+412>>2]=0;f[b>>2]=0;NO(a+416|0);return}function Ira(a){a=a|0;f[a>>2]=0;f[a+4>>2]=0;return}function Jra(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;Kra(a,b)|0;return}function Kra(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=L5b(420)|0;Hra(c);d=L5b(16)|0;e=d+4|0;f[e>>2]=1;f[d>>2]=104256;f[d+8>>2]=c;f[e>>2]=(f[e>>2]|0)+1;g=f[a>>2]|0;f[a>>2]=d;h=a+4|0;f[h>>2]=c;if(g|0?(c=g+4|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)bi[f[(f[g>>2]|0)+8>>2]&2047](g);g=f[e>>2]|0;f[e>>2]=g+-1;if((g|0)==1)bi[f[(f[d>>2]|0)+8>>2]&2047](d);d=f[h>>2]|0;if(Uh[f[(f[d>>2]|0)+32>>2]&1023](d,b)|0){b=f[h>>2]|0;if(!b){j=0;return j|0}j=(di[f[(f[b>>2]|0)+20>>2]&1023](b)|0)^1;return j|0}b=f[a>>2]|0;if(b|0?(d=b+4|0,g=f[d>>2]|0,f[d>>2]=g+-1,(g|0)==1):0)bi[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=0;f[h>>2]=0;j=0;return j|0}function Lra(a){a=a|0;O5b(a);return}function Mra(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Nra(a){a=a|0;var b=0,c=0,d=0;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)bi[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=0;f[a+4>>2]=0;return}function Ora(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;if(!b){c=1;return c|0}c=di[f[(f[b>>2]|0)+20>>2]&1023](b)|0;return c|0}function Pra(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+16|0;h=g;i=c+4|0;j=(f[i>>2]|0)-(f[c>>2]|0)>>4;k=f[a>>2]|0;l=f[a+4>>2]|0;a=(d|0)!=0;if(a?((f[d+4>>2]|0)-(f[d>>2]|0)>>2|0)!=(j|0):0){f[h>>2]=0;f[h+4>>2]=0;m=aD(h,14)|0;n=354440;o=m+14|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,354455,350849,1659);bD(h)}q=(e|0)!=0;if(q?((f[e+4>>2]|0)-(f[e>>2]|0)>>3|0)!=(j|0):0){f[h>>2]=0;f[h+4>>2]=0;m=aD(h,14)|0;n=354467;o=m+14|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,354455,350849,1663);bD(h)}a:do if(j){h=d+4|0;n=e+4|0;m=f[c>>2]|0;if(!a){o=q^1;r=0;s=0;while(1){t=f[m+(r<<4)>>2]|0;v=(t|0)>0?t:0;w=f[m+(r<<4)+4>>2]|0;x=(w|0)>0?w:0;y=(f[m+(r<<4)+8>>2]|0)+t|0;t=((y|0)<(k|0)?y:k)-v|0;y=(f[m+(r<<4)+12>>2]|0)+w|0;w=((y|0)<(l|0)?y:l)-x|0;y=(t|0)<1|(w|0)<1;z=y?0:w;w=y?0:t;if((w|0)<1|(z|0)<1)A=s;else{f[m+(s<<4)>>2]=y?0:v;f[m+(s<<4)+4>>2]=y?0:x;f[m+(s<<4)+8>>2]=w;f[m+(s<<4)+12>>2]=z;if(!(r>>>0<=s>>>0|o)){z=f[e>>2]|0;w=(f[n>>2]|0)-z>>3;if(w>>>0<=r>>>0){B=25;break}x=z;if(w>>>0<=s>>>0){B=27;break}p[x+(s<<3)>>3]=+p[x+(r<<3)>>3]}A=s+1|0}r=r+1|0;if(r>>>0>=j>>>0){C=A;break a}else s=A}if((B|0)==25)d4b(e);else if((B|0)==27)d4b(e)}else{D=0;E=0}while(1){s=f[m+(D<<4)>>2]|0;r=(s|0)>0?s:0;o=f[m+(D<<4)+4>>2]|0;x=(o|0)>0?o:0;w=(f[m+(D<<4)+8>>2]|0)+s|0;s=((w|0)<(k|0)?w:k)-r|0;w=(f[m+(D<<4)+12>>2]|0)+o|0;o=((w|0)<(l|0)?w:l)-x|0;w=(s|0)<1|(o|0)<1;z=w?0:o;o=w?0:s;if((o|0)<1|(z|0)<1)F=E;else{f[m+(E<<4)>>2]=w?0:r;f[m+(E<<4)+4>>2]=w?0:x;f[m+(E<<4)+8>>2]=o;f[m+(E<<4)+12>>2]=z;if(D>>>0>E>>>0){z=f[d>>2]|0;o=(f[h>>2]|0)-z>>2;if(o>>>0<=D>>>0){B=22;break}x=z;if(o>>>0<=E>>>0){B=23;break}f[x+(E<<2)>>2]=f[x+(D<<2)>>2];if(q){x=f[e>>2]|0;o=(f[n>>2]|0)-x>>3;if(o>>>0<=D>>>0){B=25;break}z=x;if(o>>>0<=E>>>0){B=27;break}p[z+(E<<3)>>3]=+p[z+(D<<3)>>3]}}F=E+1|0}D=D+1|0;if(D>>>0>=j>>>0){C=F;break a}else E=F}if((B|0)==22)d4b(d);else if((B|0)==23)d4b(d);else if((B|0)==25)d4b(e);else if((B|0)==27)d4b(e)}else C=0;while(0);if(C>>>0>=j>>>0){u=g;return}j=f[i>>2]|0;B=f[c>>2]|0;F=j-B>>4;E=B;B=j;if(C>>>0<=F>>>0){if(C>>>0<F>>>0?(j=E+(C<<4)|0,(B|0)!=(j|0)):0)f[i>>2]=B+(~((B+-16-j|0)>>>4)<<4)}else Voa(c,C-F|0);do if(a){F=d+4|0;c=f[F>>2]|0;j=f[d>>2]|0;B=c-j>>2;i=c;if(C>>>0>B>>>0){HC(d,C-B|0);break}if(C>>>0<B>>>0?(B=j+(C<<2)|0,(i|0)!=(B|0)):0)f[F>>2]=i+(~((i+-4-B|0)>>>2)<<2)}while(0);if(!q){u=g;return}q=e+4|0;d=f[q>>2]|0;a=f[e>>2]|0;B=d-a>>3;i=d;if(C>>>0>B>>>0){Z2(e,C-B|0);u=g;return}if(C>>>0>=B>>>0){u=g;return}B=a+(C<<3)|0;if((i|0)==(B|0)){u=g;return}f[q>>2]=i+(~((i+-8-B|0)>>>3)<<3);u=g;return}function Qra(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=u;u=u+48|0;l=k+32|0;m=k+24|0;n=k+16|0;o=k+8|0;p=k;dQ(l,104268);q=a+4|0;a=f[q>>2]|0;if(!((a|0)!=0?!(di[f[(f[a>>2]|0)+20>>2]&1023](a)|0):0)){f[m>>2]=0;f[m+4>>2]=0;a=aD(m,8)|0;r=a;b[r>>0]=33;b[r+1>>0]=101;b[r+2>>0]=109;b[r+3>>0]=112;r=a+4|0;b[r>>0]=116;b[r+1>>0]=121;b[r+2>>0]=40;b[r+3>>0]=41;bO(-215,m,352012,350849,1698);bD(m)}m=f[q>>2]|0;q=f[(f[m>>2]|0)+36>>2]|0;f[n>>2]=f[i>>2];f[n+4>>2]=f[i+4>>2];f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];Xg[q&3](m,c,d,e,g,h,n,o);AL(p,c,-1);Pra(p,d,0,0);if(!(f[l+4>>2]|0)){u=k;return}u=k;return}function Rra(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=u;u=u+48|0;m=l+32|0;n=l+24|0;o=l+16|0;p=l+8|0;q=l;dQ(m,104288);r=a+4|0;a=f[r>>2]|0;if(!((a|0)!=0?!(di[f[(f[a>>2]|0)+20>>2]&1023](a)|0):0)){f[n>>2]=0;f[n+4>>2]=0;a=aD(n,8)|0;s=a;b[s>>0]=33;b[s+1>>0]=101;b[s+2>>0]=109;b[s+3>>0]=112;s=a+4|0;b[s>>0]=116;b[s+1>>0]=121;b[s+2>>0]=40;b[s+3>>0]=41;bO(-215,n,352012,350849,1712);bD(n)}n=f[r>>2]|0;r=f[(f[n>>2]|0)+40>>2]|0;f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];f[p>>2]=f[k>>2];f[p+4>>2]=f[k+4>>2];vh[r&7](n,c,d,e,g,h,i,o,p);AL(q,c,-1);Pra(q,d,e,0);if(!(f[m+4>>2]|0)){u=l;return}u=l;return}function Sra(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;n=u;u=u+48|0;o=n+32|0;p=n+24|0;q=n+16|0;r=n+8|0;s=n;dQ(o,104308);t=a+4|0;a=f[t>>2]|0;if(!((a|0)!=0?!(di[f[(f[a>>2]|0)+20>>2]&1023](a)|0):0)){f[p>>2]=0;f[p+4>>2]=0;a=aD(p,8)|0;v=a;b[v>>0]=33;b[v+1>>0]=101;b[v+2>>0]=109;b[v+3>>0]=112;v=a+4|0;b[v>>0]=116;b[v+1>>0]=121;b[v+2>>0]=40;b[v+3>>0]=41;bO(-215,p,352012,350849,1729);bD(p)}p=f[t>>2]|0;t=f[(f[p>>2]|0)+44>>2]|0;f[q>>2]=f[k>>2];f[q+4>>2]=f[k+4>>2];f[r>>2]=f[l>>2];f[r+4>>2]=f[l+4>>2];Eg[t&3](p,c,d,e,g,h,i,j,q,r,m);AL(s,c,-1);Pra(s,d,e,g);if(!(f[o+4>>2]|0)){u=n;return}u=n;return}function Tra(){$V(851548,354875,717,1476,559,280,718);zd(1467,851548,x|0)|0;return}function Ura(a){a=a|0;var b=0;if(!a)b=0;else b=(f[a>>2]&-65536|0)==1112539136;return b&1|0}function Vra(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if(!a)return;b=f[a>>2]|0;if(!b)return;c=b+4|0;if((f[c>>2]|0)>0){d=b+32|0;e=0;do{g=f[d>>2]|0;h=f[g+(e*24|0)+8>>2]|0;if((f[g+(e*24|0)>>2]|0)>0){g=0;i=h;while(1){WC(f[i+(g*24|0)+4>>2]|0);f[(f[(f[d>>2]|0)+(e*24|0)+8>>2]|0)+(g*24|0)+4>>2]=0;g=g+1|0;j=f[d>>2]|0;k=f[j+(e*24|0)+8>>2]|0;if((g|0)>=(f[j+(e*24|0)>>2]|0)){l=k;break}else i=k}}else l=h;WC(l);f[(f[d>>2]|0)+(e*24|0)+8>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=b+36|0;b=f[c>>2]|0;if(b|0){WC(b);f[c>>2]=0}WC(f[a>>2]|0);f[a>>2]=0;return}function Wra(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0;d=u;u=u+752|0;e=d+352|0;g=d+344|0;h=d+336|0;i=d+328|0;j=d+312|0;k=d+296|0;l=d+280|0;m=d+264|0;o=d+248|0;q=d+232|0;r=d+216|0;s=d+200|0;t=d+184|0;v=d+168|0;w=d+152|0;x=d+136|0;y=d+120|0;z=d+104|0;A=d+88|0;B=d+72|0;C=d+56|0;D=d+40|0;E=d+24|0;F=d+16|0;G=d+8|0;H=d;I=d+496|0;J=d+464|0;K=d+432|0;L=d+400|0;M=d+368|0;N=d+360|0;O=MV(a,c,355036)|0;if(!((O|0)!=0?(f[O>>2]&7|0)==5:0)){f[K>>2]=0;f[K+4>>2]=0;P=aD(K,19)|0;Q=355183;R=P+19|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));bO(-2,K,355203,354965,1790);bD(K)}S=O+8|0;O=f[(f[S>>2]|0)+24>>2]|0;T=Zra(O)|0;U=MV(a,c,429353)|0;if(((U|0)!=0?(f[U>>2]&7|0)==5:0)?(c=U+8|0,V=f[c>>2]|0,(f[V+24>>2]|0)==2):0){W=c;X=V}else{f[K>>2]=0;f[K+4>>2]=0;P=aD(K,34)|0;Q=355225;R=P+34|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));bO(-2,K,355203,354965,1798);bD(K);V=U+8|0;W=V;X=f[V>>2]|0}V=KW(X,0)|0;if((f[V>>2]&7|0)==1?(X=f[V+8>>2]|0,(X|0)>=1):0)Y=X;else{f[K>>2]=0;f[K+4>>2]=0;P=aD(K,49)|0;Q=355260;R=P+49|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));bO(-2,K,355203,354965,1801);bD(K);Y=f[V+8>>2]|0}V=T+8|0;f[V>>2]=Y;Y=KW(f[W>>2]|0,1)|0;if((f[Y>>2]&7|0)==1?(W=f[Y+8>>2]|0,(W|0)>=1):0)Z=W;else{f[K>>2]=0;f[K+4>>2]=0;P=aD(K,50)|0;Q=355310;R=P+50|0;do{b[P>>0]=b[Q>>0]|0;P=P+1|0;Q=Q+1|0}while((P|0)<(R|0));bO(-2,K,355203,354965,1805);bD(K);Z=f[Y+8>>2]|0}Y=T+12|0;f[Y>>2]=Z;MW(f[S>>2]|0,J,0);if((O|0)<=0){u=d;return T|0}S=J+12|0;Z=L+4|0;Q=T+32|0;P=L+4|0;R=L+4|0;W=L+4|0;X=J+20|0;U=T+4|0;c=K+12|0;_=M+4|0;$=K+20|0;aa=M+4|0;ba=L+12|0;ca=N+4|0;da=N+4|0;ea=N+4|0;fa=N+4|0;ga=N+4|0;ha=N+4|0;ia=N+4|0;ja=N+4|0;ka=N+4|0;la=N+4|0;ma=L+20|0;na=N+4|0;oa=N+4|0;pa=M+12|0;qa=N+4|0;ra=N+4|0;sa=N+4|0;ta=N+4|0;ua=M+20|0;va=N+4|0;wa=N+4|0;xa=N+4|0;ya=L+4|0;za=0;do{Aa=f[S>>2]|0;if((f[Aa>>2]&7|0)!=6){f[H>>2]=za;_Ub(I,355361,H)|0;f[L>>2]=0;f[ya>>2]=0;Ba=kUb(I)|0;if(Ba|0)Vac(aD(L,Ba)|0,I|0,Ba|0)|0;bO(-2,L,355203,354965,1819);bD(L)}Ba=MV(a,Aa,355052)|0;if(((Ba|0)!=0?(f[Ba>>2]&7|0)==5:0)?(Ca=Ba+8|0,Da=f[(f[Ca>>2]|0)+24>>2]|0,(Da|0)>=1):0){Ea=Ca;Fa=Da}else{f[G>>2]=za;_Ub(I,355378,G)|0;f[L>>2]=0;f[Z>>2]=0;Da=kUb(I)|0;if(Da|0)Vac(aD(L,Da)|0,I|0,Da|0)|0;bO(-2,L,355203,354965,1827);bD(L);Da=Ba+8|0;Ea=Da;Fa=f[(f[Da>>2]|0)+24>>2]|0}Da=VC(Fa*24|0)|0;Ba=f[Q>>2]|0;f[Ba+(za*24|0)+8>>2]=Da;Ca=f[Ea>>2]|0;Ga=f[Ca+24>>2]|0;if((Ga|0)>0){Ha=0;do{f[Da+(Ha*24|0)+4>>2]=0;Ha=Ha+1|0;Ia=f[Ea>>2]|0;Ja=f[Ia+24>>2]|0}while((Ha|0)<(Ja|0));Ka=Ja;La=Ia}else{Ka=Ga;La=Ca}f[Ba+(za*24|0)>>2]=Ka;MW(La,K,0);if((f[(f[Ea>>2]|0)+24>>2]|0)>0){Ha=0;do{Da=f[(f[Q>>2]|0)+(za*24|0)+8>>2]|0;Ia=f[c>>2]|0;if((f[Ia>>2]&7|0)==5?(Ja=Ia+8|0,Ma=f[(f[Ja>>2]|0)+24>>2]|0,(Ma|0)>=1):0){Na=Ja;Oa=Ma}else{f[F>>2]=za;f[F+4>>2]=Ha;_Ub(I,355425,F)|0;f[M>>2]=0;f[_>>2]=0;Ma=kUb(I)|0;if(Ma|0)Vac(aD(M,Ma)|0,I|0,Ma|0)|0;bO(-2,M,355203,354965,1853);bD(M);Ma=Ia+8|0;Na=Ma;Oa=f[(f[Ma>>2]|0)+24>>2]|0}Ma=Da+(Ha*24|0)|0;f[Ma>>2]=Oa;Ia=VC(Oa*80|4)|0;Ja=Da+(Ha*24|0)+4|0;f[Ja>>2]=Ia;Pa=f[Ma>>2]|0;Qa=Ia+(Pa<<6)|0;Ia=Da+(Ha*24|0)+8|0;f[Ia>>2]=Qa;Ra=Qa+(Pa<<2)|0;Qa=Da+(Ha*24|0)+12|0;f[Qa>>2]=Ra;Sa=Ra+(Pa<<2)|0;Ra=Da+(Ha*24|0)+16|0;f[Ra>>2]=Sa;Ta=Da+(Ha*24|0)+20|0;f[Ta>>2]=Sa+(Pa<<2);MW(f[Na>>2]|0,L,0);if((f[(f[Na>>2]|0)+24>>2]|0)>0){Pa=0;Sa=0;while(1){Da=f[ba>>2]|0;if((f[Da>>2]&7|0)!=6){f[E>>2]=Pa;f[E+4>>2]=za;f[E+8>>2]=Ha;_Ub(I,355480,E)|0;f[N>>2]=0;f[xa>>2]=0;Ua=kUb(I)|0;if(Ua|0)Vac(aD(N,Ua)|0,I|0,Ua|0)|0;bO(-2,N,355203,354965,1881);bD(N)}Ua=MV(a,Da,355084)|0;if(!((Ua|0)!=0?(f[Ua>>2]&7|0)==6:0)){f[D>>2]=za;f[D+4>>2]=Ha;f[D+8>>2]=Pa;_Ub(I,355533,D)|0;f[N>>2]=0;f[ca>>2]=0;Va=kUb(I)|0;if(Va|0)Vac(aD(N,Va)|0,I|0,Va|0)|0;bO(-2,N,355203,354965,1888);bD(N)}Va=MV(a,Ua,355092)|0;do if(Va){if((f[Va>>2]&7|0)!=5){Wa=47;break}Xa=Va+8|0;Ya=f[Xa>>2]|0;if(((f[Ya+24>>2]|0)+-1|0)>>>0<=2){Za=Xa;_a=Ya}else Wa=47}else Wa=47;while(0);if((Wa|0)==47){Wa=0;f[C>>2]=za;f[C+4>>2]=Ha;f[C+8>>2]=Pa;_Ub(I,355595,C)|0;f[N>>2]=0;f[da>>2]=0;Ya=kUb(I)|0;if(Ya|0)Vac(aD(N,Ya)|0,I|0,Ya|0)|0;bO(-2,N,355203,354965,1897);bD(N);Ya=Va+8|0;Za=Ya;_a=f[Ya>>2]|0}MW(_a,M,0);Ya=f[(f[Za>>2]|0)+24>>2]|0;if((Ya|0)>0){Xa=0;do{$a=f[pa>>2]|0;if((f[$a>>2]&7|0)==5?(ab=$a+8|0,bb=f[ab>>2]|0,(f[bb+24>>2]|0)==5):0){cb=ab;db=bb}else{f[B>>2]=Xa;f[B+4>>2]=za;f[B+8>>2]=Ha;f[B+12>>2]=Pa;_Ub(I,355660,B)|0;f[N>>2]=0;f[wa>>2]=0;bb=kUb(I)|0;if(bb|0)Vac(aD(N,bb)|0,I|0,bb|0)|0;bO(-2,N,355203,354965,1910);bD(N);bb=$a+8|0;cb=bb;db=f[bb>>2]|0}bb=f[db+52>>2]|0;do if(!bb)Wa=60;else{if(!(f[bb+12>>2]|0)){Wa=60;break}eb=f[bb+16>>2]|0}while(0);if((Wa|0)==60){Wa=0;eb=KW(f[cb>>2]|0,0)|0}if((f[eb>>2]&7|0)==1?(bb=f[eb+8>>2]|0,(bb|0)>=0):0)fb=bb;else{f[A>>2]=za;f[A+4>>2]=Ha;f[A+8>>2]=Pa;f[A+12>>2]=Xa;_Ub(I,355722,A)|0;f[N>>2]=0;f[qa>>2]=0;bb=kUb(I)|0;if(bb|0)Vac(aD(N,bb)|0,I|0,bb|0)|0;bO(-2,N,355203,354965,1918);bD(N);fb=f[eb+8>>2]|0}bb=f[cb>>2]|0;$a=f[bb+52>>2]|0;do if(!$a)Wa=69;else{if((f[$a+12>>2]|0)>>>0<=1){Wa=69;break}gb=(f[$a+16>>2]|0)+16|0}while(0);if((Wa|0)==69){Wa=0;gb=KW(bb,1)|0}if((f[gb>>2]&7|0)==1?($a=f[gb+8>>2]|0,($a|0)>=0):0)hb=$a;else{f[z>>2]=za;f[z+4>>2]=Ha;f[z+8>>2]=Pa;f[z+12>>2]=Xa;_Ub(I,355803,z)|0;f[N>>2]=0;f[ra>>2]=0;$a=kUb(I)|0;if($a|0)Vac(aD(N,$a)|0,I|0,$a|0)|0;bO(-2,N,355203,354965,1926);bD(N);hb=f[gb+8>>2]|0}$a=f[cb>>2]|0;ab=f[$a+52>>2]|0;do if(!ab)Wa=78;else{if((f[ab+12>>2]|0)>>>0<=2){Wa=78;break}ib=(f[ab+16>>2]|0)+32|0}while(0);if((Wa|0)==78){Wa=0;ib=KW($a,2)|0}do if((f[ib>>2]&7|0)==1){ab=f[ib+8>>2]|0;if((ab|0)<1){Wa=82;break}if((ab+fb|0)<=(f[V>>2]|0))jb=ab;else Wa=82}else Wa=82;while(0);if((Wa|0)==82){Wa=0;f[y>>2]=za;f[y+4>>2]=Ha;f[y+8>>2]=Pa;f[y+12>>2]=Xa;_Ub(I,355884,y)|0;f[N>>2]=0;f[sa>>2]=0;$a=kUb(I)|0;if($a|0)Vac(aD(N,$a)|0,I|0,$a|0)|0;bO(-2,N,355203,354965,1936);bD(N);jb=f[ib+8>>2]|0}$a=f[cb>>2]|0;ab=f[$a+52>>2]|0;do if(!ab)Wa=88;else{if((f[ab+12>>2]|0)>>>0<=3){Wa=88;break}kb=(f[ab+16>>2]|0)+48|0}while(0);if((Wa|0)==88){Wa=0;kb=KW($a,3)|0}do if((f[kb>>2]&7|0)==1){ab=f[kb+8>>2]|0;if((ab|0)<1){Wa=92;break}if((ab+hb|0)<=(f[Y>>2]|0))lb=ab;else Wa=92}else Wa=92;while(0);if((Wa|0)==92){Wa=0;f[x>>2]=za;f[x+4>>2]=Ha;f[x+8>>2]=Pa;f[x+12>>2]=Xa;_Ub(I,355999,x)|0;f[N>>2]=0;f[ta>>2]=0;$a=kUb(I)|0;if($a|0)Vac(aD(N,$a)|0,I|0,$a|0)|0;bO(-2,N,355203,354965,1946);bD(N);lb=f[kb+8>>2]|0}$a=f[cb>>2]|0;ab=f[$a+52>>2]|0;do if(!ab)Wa=98;else{if((f[ab+12>>2]|0)>>>0<=4){Wa=98;break}mb=(f[ab+16>>2]|0)+64|0}while(0);if((Wa|0)==98){Wa=0;mb=KW($a,4)|0}if((f[mb>>2]&7|0)!=2){f[w>>2]=za;f[w+4>>2]=Ha;f[w+8>>2]=Pa;f[w+12>>2]=Xa;_Ub(I,356117,w)|0;f[N>>2]=0;f[va>>2]=0;ab=kUb(I)|0;if(ab|0)Vac(aD(N,ab)|0,I|0,ab|0)|0;bO(-2,N,355203,354965,1954);bD(N)}ab=f[Ja>>2]|0;n[ab+(Pa<<6)+4+(Xa*20|0)+16>>2]=+p[mb+8>>3];f[ab+(Pa<<6)+4+(Xa*20|0)>>2]=fb;f[ab+(Pa<<6)+4+(Xa*20|0)+4>>2]=hb;f[ab+(Pa<<6)+4+(Xa*20|0)+8>>2]=jb;f[ab+(Pa<<6)+4+(Xa*20|0)+12>>2]=lb;ab=(f[pa>>2]|0)+16|0;f[pa>>2]=ab;if(ab>>>0>=(f[ua>>2]|0)>>>0)VW(M,1);Xa=Xa+1|0;nb=f[(f[Za>>2]|0)+24>>2]|0}while((Xa|0)<(nb|0));if((nb|0)<3){ob=nb;Wa=106}}else{ob=Ya;Wa=106}if((Wa|0)==106)while(1){Wa=0;Xa=f[Ja>>2]|0;n[Xa+(Pa<<6)+4+(ob*20|0)+16>>2]=0.0;Va=Xa+(Pa<<6)+4+(ob*20|0)|0;f[Va>>2]=0;f[Va+4>>2]=0;f[Va+8>>2]=0;f[Va+12>>2]=0;ob=ob+1|0;if((ob|0)==3)break;else Wa=106}Ya=MV(a,Ua,355098)|0;if(!((Ya|0)!=0?(f[Ya>>2]&7|0)==1:0)){f[v>>2]=za;f[v+4>>2]=Ha;f[v+8>>2]=Pa;_Ub(I,356183,v)|0;f[N>>2]=0;f[ea>>2]=0;Va=kUb(I)|0;if(Va|0)Vac(aD(N,Va)|0,I|0,Va|0)|0;bO(-2,N,355203,354965,1973);bD(N)}f[(f[Ja>>2]|0)+(Pa<<6)>>2]=(f[Ya+8>>2]|0)!=0&1;Ya=MV(a,Da,355105)|0;if(!((Ya|0)!=0?(f[Ya>>2]&7|0)==2:0)){f[t>>2]=za;f[t+4>>2]=Ha;f[t+8>>2]=Pa;_Ub(I,356235,t)|0;f[N>>2]=0;f[fa>>2]=0;Va=kUb(I)|0;if(Va|0)Vac(aD(N,Va)|0,I|0,Va|0)|0;bO(-2,N,355203,354965,1981);bD(N)}n[(f[Ia>>2]|0)+(Pa<<2)>>2]=+p[Ya+8>>3];Ya=MV(a,Da,355115)|0;if(!Ya){Va=MV(a,Da,355125)|0;if(!Va){f[r>>2]=za;f[r+4>>2]=Ha;f[r+8>>2]=Pa;_Ub(I,356361,r)|0;f[N>>2]=0;f[ga>>2]=0;Xa=kUb(I)|0;if(Xa|0)Vac(aD(N,Xa)|0,I|0,Xa|0)|0;bO(-2,N,355203,354965,2004);bD(N)}if((f[Va>>2]&7|0)!=2){f[q>>2]=za;f[q+4>>2]=Ha;f[q+8>>2]=Pa;_Ub(I,356433,q)|0;f[N>>2]=0;f[ia>>2]=0;Xa=kUb(I)|0;if(Xa|0)Vac(aD(N,Xa)|0,I|0,Xa|0)|0;bO(-2,N,355203,354965,2010);bD(N)}if((Sa|0)>(f[Ma>>2]|0)){f[o>>2]=za;f[o+4>>2]=Ha;f[o+8>>2]=Pa;_Ub(I,356494,o)|0;f[N>>2]=0;f[ha>>2]=0;Xa=kUb(I)|0;if(Xa|0)Vac(aD(N,Xa)|0,I|0,Xa|0)|0;bO(-2,N,355203,354965,2017);bD(N)}f[(f[Qa>>2]|0)+(Pa<<2)>>2]=0-Sa;n[(f[Ta>>2]|0)+(Sa<<2)>>2]=+p[Va+8>>3];pb=Sa+1|0}else{do if((f[Ya>>2]&7|0)==1){Va=f[Ya+8>>2]|0;if((Va|0)<=(Pa|0)){Wa=121;break}if((Va|0)<(f[(f[Na>>2]|0)+24>>2]|0))qb=Va;else Wa=121}else Wa=121;while(0);if((Wa|0)==121){Wa=0;f[s>>2]=za;f[s+4>>2]=Ha;f[s+8>>2]=Pa;_Ub(I,356295,s)|0;f[N>>2]=0;f[oa>>2]=0;Ua=kUb(I)|0;if(Ua|0)Vac(aD(N,Ua)|0,I|0,Ua|0)|0;bO(-2,N,355203,354965,1992);bD(N);qb=f[Ya+8>>2]|0}f[(f[Qa>>2]|0)+(Pa<<2)>>2]=qb;pb=Sa}Ua=MV(a,Da,355134)|0;if(!Ua){Va=MV(a,Da,355145)|0;if(!Va){f[l>>2]=za;f[l+4>>2]=Ha;f[l+8>>2]=Pa;_Ub(I,356633,l)|0;f[N>>2]=0;f[ja>>2]=0;Xa=kUb(I)|0;if(Xa|0)Vac(aD(N,Xa)|0,I|0,Xa|0)|0;bO(-2,N,355203,354965,2042);bD(N)}if((f[Va>>2]&7|0)!=2){f[k>>2]=za;f[k+4>>2]=Ha;f[k+8>>2]=Pa;_Ub(I,356707,k)|0;f[N>>2]=0;f[la>>2]=0;Xa=kUb(I)|0;if(Xa|0)Vac(aD(N,Xa)|0,I|0,Xa|0)|0;bO(-2,N,355203,354965,2048);bD(N)}if((pb|0)>(f[Ma>>2]|0)){f[j>>2]=za;f[j+4>>2]=Ha;f[j+8>>2]=Pa;_Ub(I,356494,j)|0;f[N>>2]=0;f[ka>>2]=0;Xa=kUb(I)|0;if(Xa|0)Vac(aD(N,Xa)|0,I|0,Xa|0)|0;bO(-2,N,355203,354965,2055);bD(N)}f[(f[Ra>>2]|0)+(Pa<<2)>>2]=0-pb;n[(f[Ta>>2]|0)+(pb<<2)>>2]=+p[Va+8>>3];rb=pb+1|0}else{do if((f[Ua>>2]&7|0)==1){Va=f[Ua+8>>2]|0;if((Va|0)<=(Pa|0)){Wa=142;break}if((Va|0)<(f[(f[Na>>2]|0)+24>>2]|0))sb=Va;else Wa=142}else Wa=142;while(0);if((Wa|0)==142){Wa=0;f[m>>2]=za;f[m+4>>2]=Ha;f[m+8>>2]=Pa;_Ub(I,356566,m)|0;f[N>>2]=0;f[na>>2]=0;Da=kUb(I)|0;if(Da|0)Vac(aD(N,Da)|0,I|0,Da|0)|0;bO(-2,N,355203,354965,2030);bD(N);sb=f[Ua+8>>2]|0}f[(f[Ra>>2]|0)+(Pa<<2)>>2]=sb;rb=pb}Da=(f[ba>>2]|0)+16|0;f[ba>>2]=Da;if(Da>>>0>=(f[ma>>2]|0)>>>0)VW(L,1);Pa=Pa+1|0;if((Pa|0)>=(f[(f[Na>>2]|0)+24>>2]|0)){tb=rb;break}else Sa=rb}}else tb=0;if((tb|0)!=((f[Ma>>2]|0)+1|0)){f[i>>2]=za;f[i+4>>2]=Ha;_Ub(I,356769,i)|0;f[M>>2]=0;f[aa>>2]=0;Sa=kUb(I)|0;if(Sa|0)Vac(aD(M,Sa)|0,I|0,Sa|0)|0;bO(-2,M,355203,354965,2067);bD(M)}Sa=(f[c>>2]|0)+16|0;f[c>>2]=Sa;if(Sa>>>0>=(f[$>>2]|0)>>>0)VW(K,1);Ha=Ha+1|0}while((Ha|0)<(f[(f[Ea>>2]|0)+24>>2]|0))}Ha=MV(a,Aa,355155)|0;if(!((Ha|0)!=0?(f[Ha>>2]&7|0)==2:0)){f[h>>2]=za;_Ub(I,356831,h)|0;f[L>>2]=0;f[P>>2]=0;Ba=kUb(I)|0;if(Ba|0)Vac(aD(L,Ba)|0,I|0,Ba|0)|0;bO(-2,L,355203,354965,2077);bD(L)}n[(f[Q>>2]|0)+(za*24|0)+4>>2]=+p[Ha+8>>3];Ha=MV(a,Aa,355171)|0;if((((Ha|0)!=0?(f[Ha>>2]&7|0)==1:0)?(Ba=f[Ha+8>>2]|0,(Ba|0)>=-1):0)?(Ba|0)<(f[U>>2]|0):0)ub=Ba;else{f[g>>2]=za;_Ub(I,356879,g)|0;f[L>>2]=0;f[R>>2]=0;Ba=kUb(I)|0;if(Ba|0)Vac(aD(L,Ba)|0,I|0,Ba|0)|0;bO(-2,L,355203,354965,2089);bD(L);ub=f[Ha+8>>2]|0}Ha=MV(a,Aa,355178)|0;if((((Ha|0)!=0?(f[Ha>>2]&7|0)==1:0)?(Ba=f[Ha+8>>2]|0,(Ba|0)>=-1):0)?(Ba|0)<(f[U>>2]|0):0)vb=Ba;else{f[e>>2]=za;_Ub(I,356921,e)|0;f[L>>2]=0;f[W>>2]=0;Ba=kUb(I)|0;if(Ba|0)Vac(aD(L,Ba)|0,I|0,Ba|0)|0;bO(-2,L,355203,354965,2097);bD(L);vb=f[Ha+8>>2]|0}Ha=f[Q>>2]|0;f[Ha+(za*24|0)+20>>2]=ub;f[Ha+(za*24|0)+12>>2]=vb;f[Ha+(za*24|0)+16>>2]=-1;if((ub|0)!=-1?(Ba=Ha+(ub*24|0)+16|0,(f[Ba>>2]|0)==-1):0)f[Ba>>2]=za;Ba=(f[S>>2]|0)+16|0;f[S>>2]=Ba;if(Ba>>>0>=(f[X>>2]|0)>>>0)VW(J,1);za=za+1|0}while((za|0)<(O|0));u=d;return T|0}function Xra(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;g=u;u=u+368|0;h=g+104|0;i=g+16|0;j=g+8|0;k=g;l=g+112|0;m=g+24|0;o=g+96|0;p=g+88|0;q=g+80|0;r=g+72|0;s=g+64|0;t=g+56|0;v=g+48|0;w=g+40|0;x=g+32|0;y=e;e=f[y+4>>2]|0;z=m;f[z>>2]=f[y>>2];f[z+4>>2]=e;f[h>>2]=f[m>>2];f[h+4>>2]=f[m+4>>2];xV(a,c,6,354875,h);f[o>>2]=0;f[o+4>>2]=0;f[h>>2]=f[o>>2];f[h+4>>2]=f[o+4>>2];xV(a,429353,13,0,h);RV(a,0,f[d+8>>2]|0);RV(a,0,f[d+12>>2]|0);uT(a);f[p>>2]=0;f[p+4>>2]=0;f[h>>2]=f[p>>2];f[h+4>>2]=f[p+4>>2];xV(a,355036,5,0,h);p=d+4|0;if((f[p>>2]|0)<=0){uT(a);uT(a);u=g;return}o=q+4|0;c=r+4|0;m=d+32|0;d=s+4|0;e=t+4|0;z=v+4|0;y=w+4|0;A=x+4|0;B=0;do{f[q>>2]=0;f[o>>2]=0;f[h>>2]=f[q>>2];f[h+4>>2]=f[q+4>>2];xV(a,0,6,0,h);f[k>>2]=B;_Ub(l,355043,k)|0;_V(a,l,1);f[r>>2]=0;f[c>>2]=0;f[h>>2]=f[r>>2];f[h+4>>2]=f[r+4>>2];xV(a,355052,5,0,h);C=f[m>>2]|0;if((f[C+(B*24|0)>>2]|0)>0){D=0;E=C;do{C=f[E+(B*24|0)+8>>2]|0;f[s>>2]=0;f[d>>2]=0;f[h>>2]=f[s>>2];f[h+4>>2]=f[s+4>>2];xV(a,0,5,0,h);f[j>>2]=D;_Ub(l,355058,j)|0;_V(a,l,1);F=C+(D*24|0)|0;if((f[F>>2]|0)>0){G=C+(D*24|0)+4|0;H=C+(D*24|0)+8|0;I=C+(D*24|0)+12|0;J=C+(D*24|0)+16|0;K=C+(D*24|0)+20|0;C=0;do{L=f[G>>2]|0;f[t>>2]=0;f[e>>2]=0;f[h>>2]=f[t>>2];f[h+4>>2]=f[t+4>>2];xV(a,0,6,0,h);if(!C){M=l;N=355074;O=M+10|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0))}else{f[i>>2]=C;_Ub(l,355066,i)|0}_V(a,l,1);f[v>>2]=0;f[z>>2]=0;f[h>>2]=f[v>>2];f[h+4>>2]=f[v+4>>2];xV(a,355084,6,0,h);f[w>>2]=0;f[y>>2]=0;f[h>>2]=f[w>>2];f[h+4>>2]=f[w+4>>2];xV(a,355092,5,0,h);N=L+(C<<6)+12|0;if((f[N>>2]|0?(f[x>>2]=0,f[A>>2]=0,f[h>>2]=f[x>>2],f[h+4>>2]=f[x+4>>2],xV(a,0,13,0,h),RV(a,0,f[L+(C<<6)+4>>2]|0),RV(a,0,f[L+(C<<6)+8>>2]|0),RV(a,0,f[N>>2]|0),RV(a,0,f[L+(C<<6)+16>>2]|0),ZV(a,0,+n[L+(C<<6)+20>>2]),uT(a),N=L+(C<<6)+32|0,f[N>>2]|0):0)?(f[x>>2]=0,f[A>>2]=0,f[h>>2]=f[x>>2],f[h+4>>2]=f[x+4>>2],xV(a,0,13,0,h),RV(a,0,f[L+(C<<6)+24>>2]|0),RV(a,0,f[L+(C<<6)+28>>2]|0),RV(a,0,f[N>>2]|0),RV(a,0,f[L+(C<<6)+36>>2]|0),ZV(a,0,+n[L+(C<<6)+40>>2]),uT(a),N=L+(C<<6)+52|0,f[N>>2]|0):0){f[x>>2]=0;f[A>>2]=0;f[h>>2]=f[x>>2];f[h+4>>2]=f[x+4>>2];xV(a,0,13,0,h);RV(a,0,f[L+(C<<6)+44>>2]|0);RV(a,0,f[L+(C<<6)+48>>2]|0);RV(a,0,f[N>>2]|0);RV(a,0,f[L+(C<<6)+56>>2]|0);ZV(a,0,+n[L+(C<<6)+60>>2]);uT(a)}uT(a);RV(a,355098,f[L+(C<<6)>>2]|0);uT(a);ZV(a,355105,+n[(f[H>>2]|0)+(C<<2)>>2]);N=f[(f[I>>2]|0)+(C<<2)>>2]|0;if((N|0)>0)RV(a,355115,N);else ZV(a,355125,+n[(f[K>>2]|0)+(0-N<<2)>>2]);N=f[(f[J>>2]|0)+(C<<2)>>2]|0;if((N|0)>0)RV(a,355134,N);else ZV(a,355145,+n[(f[K>>2]|0)+(0-N<<2)>>2]);uT(a);C=C+1|0}while((C|0)<(f[F>>2]|0))}uT(a);D=D+1|0;E=f[m>>2]|0}while((D|0)<(f[E+(B*24|0)>>2]|0))}uT(a);ZV(a,355155,+n[(f[m>>2]|0)+(B*24|0)+4>>2]);RV(a,355171,f[(f[m>>2]|0)+(B*24|0)+20>>2]|0);RV(a,355178,f[(f[m>>2]|0)+(B*24|0)+12>>2]|0);uT(a);B=B+1|0}while((B|0)<(f[p>>2]|0));uT(a);uT(a);u=g;return}function Yra(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;b=f[a+4>>2]|0;c=Zra(b)|0;d=a+8|0;e=f[d+4>>2]|0;g=c+8|0;f[g>>2]=f[d>>2];f[g+4>>2]=e;if((b|0)<=0)return c|0;e=a+32|0;a=c+32|0;g=0;d=f[a>>2]|0;while(1){h=f[e>>2]|0;f[d+(g*24|0)+20>>2]=f[h+(g*24|0)+20>>2];f[d+(g*24|0)+12>>2]=f[h+(g*24|0)+12>>2];f[d+(g*24|0)+16>>2]=f[h+(g*24|0)+16>>2];f[d+(g*24|0)+4>>2]=f[h+(g*24|0)+4>>2];f[d+(g*24|0)>>2]=0;i=VC((f[h+(g*24|0)>>2]|0)*24|0)|0;h=f[a>>2]|0;f[h+(g*24|0)+8>>2]=i;j=f[e>>2]|0;k=f[j+(g*24|0)>>2]|0;f[h+(g*24|0)>>2]=k;l=(k|0)>0;a:do if(l){m=0;do{f[i+(m*24|0)+4>>2]=0;m=m+1|0}while((m|0)<(k|0));if(l){m=0;n=j;o=i;while(1){p=f[n+(g*24|0)+8>>2]|0;q=f[p+(m*24|0)>>2]|0;r=o+(m*24|0)|0;f[r>>2]=q;s=VC(q*80|4)|0;q=o+(m*24|0)+4|0;f[q>>2]=s;t=f[r>>2]|0;u=s+(t<<6)|0;v=o+(m*24|0)+8|0;f[v>>2]=u;w=u+(t<<2)|0;u=o+(m*24|0)+12|0;f[u>>2]=w;x=w+(t<<2)|0;w=o+(m*24|0)+16|0;f[w>>2]=x;y=x+(t<<2)|0;x=o+(m*24|0)+20|0;f[x>>2]=y;b:do if((t|0)>0){z=p+(m*24|0)+4|0;A=p+(m*24|0)+8|0;B=p+(m*24|0)+12|0;C=p+(m*24|0)+16|0;D=p+(m*24|0)+20|0;E=0;F=s;while(1){G=F+(E<<6)|0;H=(f[z>>2]|0)+(E<<6)|0;I=G+64|0;do{f[G>>2]=f[H>>2];G=G+4|0;H=H+4|0}while((G|0)<(I|0));f[(f[v>>2]|0)+(E<<2)>>2]=f[(f[A>>2]|0)+(E<<2)>>2];f[(f[u>>2]|0)+(E<<2)>>2]=f[(f[B>>2]|0)+(E<<2)>>2];f[(f[w>>2]|0)+(E<<2)>>2]=f[(f[C>>2]|0)+(E<<2)>>2];H=f[D>>2]|0;G=f[x>>2]|0;f[G+(E<<2)>>2]=f[H+(E<<2)>>2];I=E+1|0;J=f[r>>2]|0;if((I|0)>=(J|0)){K=J;L=H;M=G;break b}E=I;F=f[q>>2]|0}}else{K=t;L=f[p+(m*24|0)+20>>2]|0;M=y}while(0);f[M+(K<<2)>>2]=f[L+(K<<2)>>2];y=m+1|0;p=f[a>>2]|0;if((y|0)>=(f[p+(g*24|0)>>2]|0)){N=p;break a}m=y;n=f[e>>2]|0;o=f[p+(g*24|0)+8>>2]|0}}else N=h}else N=h;while(0);g=g+1|0;if((g|0)==(b|0))break;else d=N}return c|0}function Zra(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;e=(a*24|0)+40|0;if((a|0)<1){f[d>>2]=0;f[d+4>>2]=0;g=aD(d,35)|0;h=354898;i=g+35|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-211,d,354934,354965,114);bD(d)}d=VC(e)|0;Nac(d|0,0,e|0)|0;f[d+32>>2]=d+40;f[d>>2]=1112539136;f[d+4>>2]=a;u=c;return d|0}function _ra(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0;h=u;u=u+144|0;i=h+112|0;j=h+84|0;k=h+56|0;l=h+52|0;m=h+48|0;o=h;f[l>>2]=0;f[m>>2]=0;q=(a|0)!=0;if(!(q?(f[a>>2]&-65536|0)==1112539136:0)){r=q?-5:-27;f[o>>2]=0;f[o+4>>2]=0;s=aD(o,26)|0;t=356961;v=s+26|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(r,o,356988,354965,411);bD(o)}if(g<=0.0){f[o>>2]=0;f[o+4>>2]=0;s=aD(o,22)|0;t=357024;v=s+22|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-211,o,356988,354965,414);bD(o)}r=sQ(c,i,l,0)|0;i=sQ(d,j,m,0)|0;if(f[m>>2]|f[l>>2]|0){f[o>>2]=0;f[o+4>>2]=0;s=aD(o,20)|0;t=357047;v=s+20|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-24,o,356988,354965,420);bD(o)}l=r+20|0;if(!((f[l>>2]|0)==(f[i+20>>2]|0)?(f[r+24>>2]|0)==(f[i+24>>2]|0):0)){f[o>>2]=0;f[o+4>>2]=0;s=aD(o,43)|0;t=357068;v=s+43|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-209,o,356988,354965,423);bD(o)}if(!((f[i>>2]&4095|0)==6?(f[r>>2]&4095|0)==4:0)){f[o>>2]=0;f[o+4>>2]=0;s=aD(o,77)|0;t=357112;v=s+77|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-210,o,356988,354965,428);bD(o)}j=a+36|0;d=f[j>>2]|0;if(!d){$ra(a);w=f[j>>2]|0}else w=d;if(!(f[w+4>>2]|0)){x=e;y=r+4|0}else{d=sQ(e,k,m,0)|0;if((f[d>>2]&4095|0)!=4){f[o>>2]=0;f[o+4>>2]=0;s=aD(o,77)|0;t=357112;v=s+77|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-210,o,356988,354965,441);bD(o)}m=r+4|0;if((f[m>>2]|0)!=(f[d+4>>2]|0)){f[o>>2]=0;f[o+4>>2]=0;s=aD(o,62)|0;t=357190;v=s+62|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-209,o,356988,354965,445);bD(o)}if(!((f[l>>2]|0)==(f[d+20>>2]|0)?(f[r+24>>2]|0)==(f[d+24>>2]|0):0)){f[o>>2]=0;f[o+4>>2]=0;s=aD(o,43)|0;t=357068;v=s+43|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-209,o,356988,354965,448);bD(o)}t=w+72|0;f[t>>2]=f[d>>2];f[t+4>>2]=f[d+4>>2];f[t+8>>2]=f[d+8>>2];f[t+12>>2]=f[d+12>>2];f[t+16>>2]=f[d+16>>2];f[t+20>>2]=f[d+20>>2];f[t+24>>2]=f[d+24>>2];x=d;y=m}p[a+24>>3]=g;m=a+8|0;d=MVb(+(f[m>>2]|0)*g)|0;f[a+16>>2]=d;d=a+12|0;t=MVb(+(f[d>>2]|0)*g)|0;f[a+20>>2]=t;t=w+16|0;f[t>>2]=f[r>>2];f[t+4>>2]=f[r+4>>2];f[t+8>>2]=f[r+8>>2];f[t+12>>2]=f[r+12>>2];f[t+16>>2]=f[r+16>>2];f[t+20>>2]=f[r+20>>2];f[t+24>>2]=f[r+24>>2];t=w+44|0;f[t>>2]=f[i>>2];f[t+4>>2]=f[i+4>>2];f[t+8>>2]=f[i+8>>2];f[t+12>>2]=f[i+12>>2];f[t+16>>2]=f[i+16>>2];f[t+20>>2]=f[i+20>>2];f[t+24>>2]=f[i+24>>2];t=MVb(g)|0;l=MVb(+((f[m>>2]|0)+-2|0)*g)|0;m=MVb(+((f[d>>2]|0)+-2|0)*g)|0;z=1.0/+(Y(m,l)|0);p[w+8>>3]=z;d=r+16|0;r=f[y>>2]|0;k=Y(r,t)|0;e=t<<2;f[w+120>>2]=(f[d>>2]|0)+k+e;j=l+t|0;l=j<<2;f[w+124>>2]=(f[d>>2]|0)+k+l;k=m+t|0;m=Y(r,k)|0;f[w+128>>2]=(f[d>>2]|0)+m+e;f[w+132>>2]=(f[d>>2]|0)+m+l;l=i+16|0;m=f[i+4>>2]|0;i=Y(m,t)|0;e=t<<3;f[w+104>>2]=(f[l>>2]|0)+i+e;t=j<<3;f[w+108>>2]=(f[l>>2]|0)+i+t;i=Y(m,k)|0;f[w+112>>2]=(f[l>>2]|0)+i+e;f[w+116>>2]=(f[l>>2]|0)+i+t;t=f[a+4>>2]|0;if((t|0)<=0){u=h;return}i=w+100|0;w=a+32|0;a=o+4|0;l=o+8|0;e=o+12|0;k=x+16|0;m=x+4|0;x=o+16|0;j=o+24|0;r=o+28|0;c=o+20|0;q=o+32|0;A=o+40|0;B=o+44|0;C=o+36|0;D=0;E=f[i>>2]|0;while(1){if((f[E+(D*28|0)>>2]|0)>0){F=0;G=E;while(1){H=f[G+(D*28|0)+8>>2]|0;if((f[H+(F*12|0)>>2]|0)>0){I=0;J=H;H=G;while(1){K=f[(f[(f[w>>2]|0)+(D*24|0)+8>>2]|0)+(F*24|0)+4>>2]|0;L=f[J+(F*12|0)+4>>2]|0;s=o;v=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));if(f[L+(I*72|0)>>2]|0){M=K+(I<<6)+4|0;f[o>>2]=f[M>>2];f[o+4>>2]=f[M+4>>2];f[o+8>>2]=f[M+8>>2];f[o+12>>2]=f[M+12>>2];M=f[l>>2]|0;N=M+-1|0;O=f[o>>2]|0;P=f[e>>2]|0;Q=P+-1|0;R=f[a>>2]|0;if(f[L+(I*72|0)+20>>2]|0){S=K+(I<<6)+24|0;f[x>>2]=f[S>>2];f[x+4>>2]=f[S+4>>2];f[x+8>>2]=f[S+8>>2];f[x+12>>2]=f[S+12>>2];S=(f[j>>2]|0)+-1|0;T=(N>>>0>=S>>>0?S^N:0)^N;S=(f[x>>2]|0)-O+-1|0;U=(T>>>0>=S>>>0?T^S:0)^T;T=(f[r>>2]|0)+-1|0;S=(Q>>>0>=T>>>0?T^Q:0)^Q;T=(f[c>>2]|0)-R+-1|0;V=(S>>>0>=T>>>0?S^T:0)^S;if(!(f[L+(I*72|0)+40>>2]|0)){W=V;X=U;Z=2;_=M;$=P;aa=O;ba=R}else{S=K+(I<<6)+44|0;f[q>>2]=f[S>>2];f[q+4>>2]=f[S+4>>2];f[q+8>>2]=f[S+8>>2];f[q+12>>2]=f[S+12>>2];S=(f[A>>2]|0)+-1|0;T=(U>>>0>=S>>>0?S^U:0)^U;U=(f[q>>2]|0)-O+-1|0;S=(f[B>>2]|0)+-1|0;ca=(V>>>0>=S>>>0?S^V:0)^V;V=(f[C>>2]|0)-R+-1|0;W=(ca>>>0>=V>>>0?ca^V:0)^ca;X=(T>>>0>=U>>>0?T^U:0)^T;Z=3;_=M;$=P;aa=O;ba=R}}else{W=Q;X=N;Z=1;_=M;$=P;aa=O;ba=R}}else{W=-1;X=-1;Z=0;_=0;$=0;aa=0;ba=0}R=X+1|0;O=W+1|0;P=(_|0)/(R|0)|0;M=($|0)/(O|0)|0;if((P|0)<1){N=(MVb(+(_|0)*g)|0)/(P|0)|0;da=MVb(+(aa|0)*g)|0;ea=1;fa=N}else{da=0;ea=0;fa=0}if((M|0)<1){N=(MVb(+($|0)*g)|0)/(M|0)|0;ga=MVb(+(ba|0)*g)|0;ha=1;ia=N}else{ga=0;ha=0;ia=0}if(!Z){ja=0.0;ka=0.0;la=H}else{N=(ea|0)==0;M=(ha|0)==0;P=(f[K+(I<<6)>>2]|0)!=0;ma=z*(P?.5:1.0);na=0.0;oa=0.0;Q=0;T=aa;U=_;while(1){if(N){ca=MVb(+(T|0)*g)|0;pa=MVb(+(U|0)*g)|0;qa=ca}else{pa=(Y(U,fa)|0)/(R|0)|0;qa=((Y(T-aa|0,fa)|0)/(R|0)|0)+da|0}ca=f[o+(Q<<4)+4>>2]|0;V=f[o+(Q<<4)+12>>2]|0;if(M){S=MVb(+(ca|0)*g)|0;ra=MVb(+(V|0)*g)|0;sa=S}else{ra=(Y(V,ia)|0)/(O|0)|0;sa=((Y(ca-ba|0,ia)|0)/(O|0)|0)+ga|0}ca=qa<<2;V=pa+qa|0;S=ra+sa|0;ta=V<<2;if(P){ua=f[m>>2]|0;va=sa+pa|0;wa=(f[k>>2]|0)+(Y(ua,va)|0)+ta|0;f[L+(I*72|0)+(Q*20|0)+8>>2]=wa;wa=(f[k>>2]|0)+(Y(ua,va+ra|0)|0)+(V-ra<<2)|0;f[L+(I*72|0)+(Q*20|0)+12>>2]=wa;wa=(f[k>>2]|0)+(Y(ua,sa)|0)+ca|0;f[L+(I*72|0)+(Q*20|0)>>2]=wa;xa=(f[k>>2]|0)+(Y(ua,S)|0)+(qa-ra<<2)|0;ya=L+(I*72|0)+(Q*20|0)+4|0}else{ua=f[y>>2]|0;wa=Y(ua,sa)|0;f[L+(I*72|0)+(Q*20|0)>>2]=(f[d>>2]|0)+wa+ca;f[L+(I*72|0)+(Q*20|0)+4>>2]=(f[d>>2]|0)+wa+ta;wa=Y(ua,S)|0;f[L+(I*72|0)+(Q*20|0)+8>>2]=(f[d>>2]|0)+wa+ca;xa=(f[d>>2]|0)+wa+ta|0;ya=L+(I*72|0)+(Q*20|0)+12|0}f[ya>>2]=xa;za=ma*+n[K+(I<<6)+4+(Q*20|0)+16>>2];n[L+(I*72|0)+(Q*20|0)+16>>2]=za;if(!Q){Aa=+(Y(ra,pa)|0);Ba=oa}else{Aa=na;Ba=oa+ +(ra|0)*(+(pa|0)*za)}ta=Q+1|0;if((ta|0)==(Z|0))break;na=Aa;oa=Ba;Q=ta;T=f[o+(ta<<4)>>2]|0;U=f[o+(ta<<4)+8>>2]|0}ja=Aa;ka=Ba;la=f[i>>2]|0}n[L+(I*72|0)+16>>2]=-ka/ja;I=I+1|0;J=f[la+(D*28|0)+8>>2]|0;if((I|0)>=(f[J+(F*12|0)>>2]|0)){Ca=la;break}else H=la}}else Ca=G;F=F+1|0;if((F|0)>=(f[Ca+(D*28|0)>>2]|0)){Da=Ca;break}else G=Ca}}else Da=E;D=D+1|0;if((D|0)>=(t|0))break;else E=Da}u=h;return}function $ra(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;c=u;u=u+1040|0;d=c+8|0;e=c;g=c+32|0;h=c+24|0;i=(a|0)!=0;if(!(i?(f[a>>2]&-65536|0)==1112539136:0)){j=i?-5:-27;f[h>>2]=0;f[h+4>>2]=0;k=aD(h,26)|0;l=356961;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(j,h,357253,354965,174);bD(h)}j=a+36|0;if(f[j>>2]|0){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,36)|0;l=357287;m=k+36|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,h,357253,354965,177);bD(h)}i=a+32|0;if(!(f[i>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;bO(-27,h,357253,354965,180);bD(h)}o=a+4|0;if((f[o>>2]|0)<1){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,33)|0;l=357324;m=k+33|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-211,h,357253,354965,183);bD(h);l=f[o>>2]|0;p=a+8|0;if((l|0)>0){q=f[p>>2]|0;r=f[p+4>>2]|0;s=11}else{t=0;v=0;w=0;x=l}}else{l=a+8|0;q=f[l>>2]|0;r=f[l+4>>2]|0;s=11}if((s|0)==11){l=h+4|0;a=h+4|0;p=0;y=0;z=0;A=0;while(1){B=f[i>>2]|0;C=B+(A*24|0)|0;D=B+(A*24|0)+8|0;if((f[D>>2]|0)!=0?(B=f[C>>2]|0,(B|0)>=1):0){E=C;F=B+p|0;s=18}else{f[e>>2]=A;_Ub(g,357358,e)|0;f[h>>2]=0;f[l>>2]=0;B=kUb(g)|0;if(B|0)Vac(aD(h,B)|0,g|0,B|0)|0;bO(-2,h,357253,354965,198);bD(h);B=f[C>>2]|0;G=B+p|0;if((B|0)>0){E=C;F=G;s=18}else{H=y;I=z;J=G}}if((s|0)==18){s=0;G=0;C=y;B=z;while(1){K=f[D>>2]|0;M=K+(G*24|0)|0;N=f[M>>2]|0;O=N+C|0;if((N|0)>0){N=K+(G*24|0)+4|0;K=0;P=B;while(1){Q=0;R=P;while(1){S=f[N>>2]|0;T=f[S+(K<<6)+4+(Q*20|0)+8>>2]|0;a:do if(!T)U=R;else{V=f[S+(K<<6)+4+(Q*20|0)>>2]|0;W=f[S+(K<<6)+4+(Q*20|0)+4>>2]|0;X=f[S+(K<<6)+4+(Q*20|0)+12>>2]|0;Y=(f[S+(K<<6)>>2]|0)!=0;Z=R|Y;do if(!((V+T|0)>(q|0)|(W|T|X|0)<0)){if(!Y)if((V|0)<0|(X+W|0)>(r|0))break;else{U=Z;break a}if((V|0)>=(X|0)?(W+T+X|0)<=(r|0):0){U=Z;break a}}while(0);f[d>>2]=Q;f[d+4>>2]=G;f[d+8>>2]=A;_Ub(g,357456,d)|0;f[h>>2]=0;f[a>>2]=0;X=kUb(g)|0;if(X|0)Vac(aD(h,X)|0,g|0,X|0)|0;bO(-27,h,357253,354965,230);bD(h);U=Z}while(0);Q=Q+1|0;if((Q|0)>=3)break;else R=U}K=K+1|0;if((K|0)>=(f[M>>2]|0)){_=U;break}else P=U}}else _=B;G=G+1|0;if((G|0)>=(f[E>>2]|0)){H=O;I=_;J=F;break}else{C=O;B=_}}}A=A+1|0;B=f[o>>2]|0;if((A|0)>=(B|0)){t=J;v=H;w=I;x=B;break}else{p=J;y=H;z=I}}}I=VC((v*72|0)+144+(t*12|0)+(t+v<<2)+(x*28|0)|0)|0;Nac(I+8|0,0,136)|0;x=f[o>>2]|0;f[I>>2]=x;v=I+144|0;z=I+100|0;f[z>>2]=v;H=v+(x*28|0)|0;y=I+141|0;b[y>>0]=1;f[I+4>>2]=w&1;w=I+140|0;b[w>>0]=0;if((x|0)<=0){f[j>>2]=I;WC(0);WC(0);WC(0);WC(0);WC(0);WC(0);u=c;return}J=H;p=H+(t*12|0)|0;t=0;H=v;v=x;while(1){x=f[i>>2]|0;A=x+(t*24|0)|0;_=f[A>>2]|0;f[H+(t*28|0)>>2]=_;n[H+(t*28|0)+4>>2]=+n[x+(t*24|0)+4>>2]+-9.999999747378752e-05;F=H+(t*28|0)+8|0;f[F>>2]=J;E=H+(t*28|0)+12|0;f[E>>2]=1;U=J+(_*12|0)|0;h=f[x+(t*24|0)+20>>2]|0;f[H+(t*28|0)+24>>2]=(h|0)==-1?0:H+(h*28|0)|0;h=f[x+(t*24|0)+12>>2]|0;g=(h|0)==-1?0:H+(h*28|0)|0;f[H+(t*28|0)+16>>2]=g;h=f[x+(t*24|0)+16>>2]|0;f[H+(t*28|0)+20>>2]=(h|0)==-1?0:H+(h*28|0)|0;b[w>>0]=(g|0)!=0|b[w>>0];if((_|0)>0){_=x+(t*24|0)+8|0;x=0;g=p;h=J;while(1){a=f[_>>2]|0;d=f[a+(x*24|0)>>2]|0;r=g+(d*72|0)|0;f[h+(x*12|0)>>2]=d;q=h+(x*12|0)+4|0;f[q>>2]=g;f[h+(x*12|0)+8>>2]=r;b:do if((d|0)>0){s=a+(x*24|0)+4|0;l=a+(x*24|0)+8|0;e=a+(x*24|0)+12|0;B=a+(x*24|0)+16|0;C=0;G=g;while(1){D=f[s>>2]|0;k=G+(C*72|0)|0;m=k+72|0;do{f[k>>2]=-1;k=k+4|0}while((k|0)<(m|0));f[G+(C*72|0)+60>>2]=f[(f[l>>2]|0)+(C<<2)>>2];f[G+(C*72|0)+64>>2]=f[(f[e>>2]|0)+(C<<2)>>2];f[G+(C*72|0)+68>>2]=f[(f[B>>2]|0)+(C<<2)>>2];if((!(+L(+(+n[D+(C<<6)+60>>2]))<2.220446049250313e-16)?(f[D+(C<<6)+52>>2]|0)!=0:0)?(f[D+(C<<6)+56>>2]|0)!=0:0)f[E>>2]=0;else{P=G+(C*72|0)+40|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;f[P+16>>2]=0}P=C+1|0;if((P|0)==(d|0))break b;C=P;G=f[q>>2]|0}}while(0);Vac(r|0,f[a+(x*24|0)+20>>2]|0,(d<<2)+4|0)|0;$=r+(d<<2)+4+3&-4;b[y>>0]=(d|0)==1&(b[y>>0]|0)!=0&1;q=x+1|0;if((q|0)>=(f[A>>2]|0))break;x=q;g=$;h=f[F>>2]|0}aa=$;ba=f[o>>2]|0}else{aa=p;ba=v}F=t+1|0;if((F|0)>=(ba|0))break;J=U;p=aa;t=F;H=f[z>>2]|0;v=ba}f[j>>2]=I;WC(0);WC(0);WC(0);WC(0);WC(0);WC(0);u=c;return}function asa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0.0,t=0.0,v=0.0,w=0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0.0;h=u;u=u+16|0;i=h;j=(a|0)!=0;if(!(j?(f[a>>2]&-65536|0)==1112539136:0)){k=j?-5:-27;f[i>>2]=0;f[i+4>>2]=0;l=aD(i,23)|0;m=357574;o=l+23|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));bO(k,i,357598,354965,684);bD(i)}k=f[a+36>>2]|0;if(!k){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,76)|0;m=357628;o=l+76|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));bO(-27,i,357598,354965,689);bD(i)}if((d|c|0)<0){q=-1;u=h;return q|0}if(((f[a+16>>2]|0)+c|0)>=(f[k+40>>2]|0)){q=-1;u=h;return q|0}if(((f[a+20>>2]|0)+d|0)>=(f[k+36>>2]|0)){q=-1;u=h;return q|0}a=(Y((f[k+20>>2]|0)>>>2,d)|0)+c|0;i=(Y((f[k+48>>2]|0)>>>3,d)|0)+c|0;r=+p[k+8>>3];s=r*+((f[(f[k+120>>2]|0)+(a<<2)>>2]|0)-(f[(f[k+124>>2]|0)+(a<<2)>>2]|0)-(f[(f[k+128>>2]|0)+(a<<2)>>2]|0)+(f[(f[k+132>>2]|0)+(a<<2)>>2]|0)|0);t=r*(+p[(f[k+104>>2]|0)+(i<<3)>>3]-+p[(f[k+108>>2]|0)+(i<<3)>>3]-+p[(f[k+112>>2]|0)+(i<<3)>>3]+ +p[(f[k+116>>2]|0)+(i<<3)>>3])-s*s;if(!(t>=0.0))v=1.0;else v=+M(+t);if(b[k+140>>0]|0){i=f[k+100>>2]|0;if(!i){q=1;u=h;return q|0}else w=i;a:while(1){p[e>>3]=0.0;i=f[w>>2]|0;if((i|0)>0){c=f[w+8>>2]|0;d=0;t=0.0;while(1){s=+bsa(c+(d*12|0)|0,v,a)+t;p[e>>3]=s;d=d+1|0;if((d|0)>=(i|0)){x=s;break}else t=s}}else x=0.0;if(x>=+n[w+4>>2]){i=f[w+20>>2]|0;if(!i){q=1;y=43;break}else{w=i;continue}}else z=w;while(1){i=f[z+16>>2]|0;if(i|0){w=i;continue a}z=f[z+24>>2]|0;if(!z){q=0;y=43;break a}}}if((y|0)==43){u=h;return q|0}}z=f[k>>2]|0;w=(z|0)>(g|0);if(!(b[k+141>>0]|0)){if(!w){q=1;u=h;return q|0}i=f[k+100>>2]|0;d=g;while(1){p[e>>3]=0.0;c=f[i+(d*28|0)>>2]|0;if((c|0)>0){m=f[i+(d*28|0)+8>>2]|0;l=0;x=0.0;while(1){t=+bsa(m+(l*12|0)|0,v,a)+x;p[e>>3]=t;l=l+1|0;if((l|0)>=(c|0)){A=t;break}else x=t}}else A=0.0;if(A<+n[i+(d*28|0)+4>>2]){q=0-d|0;y=43;break}d=d+1|0;if((d|0)>=(z|0)){q=1;y=43;break}}if((y|0)==43){u=h;return q|0}}if(!w){q=1;u=h;return q|0}w=f[k+100>>2]|0;k=g;while(1){g=f[w+(k*28|0)>>2]|0;d=(g|0)>0;if(!(f[w+(k*28|0)+12>>2]|0))if(d){i=f[w+(k*28|0)+8>>2]|0;c=0;A=0.0;while(1){l=f[i+(c*12|0)+4>>2]|0;x=+n[l+16>>2]*+((f[(f[l>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+4>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+8>>2]|0)+(a<<2)>>2]|0)+(f[(f[l+12>>2]|0)+(a<<2)>>2]|0)|0)+ +n[l+36>>2]*+((f[(f[l+20>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+24>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+28>>2]|0)+(a<<2)>>2]|0)+(f[(f[l+32>>2]|0)+(a<<2)>>2]|0)|0);m=f[l+40>>2]|0;if(!m)B=x;else B=x+ +n[l+56>>2]*+((f[m+(a<<2)>>2]|0)-(f[(f[l+44>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+48>>2]|0)+(a<<2)>>2]|0)+(f[(f[l+52>>2]|0)+(a<<2)>>2]|0)|0);x=A+ +n[(f[i+(c*12|0)+8>>2]|0)+((B>=v*+n[l+60>>2]&1)<<2)>>2];c=c+1|0;if((c|0)>=(g|0)){C=x;break}else A=x}}else C=0.0;else if(d){c=f[w+(k*28|0)+8>>2]|0;i=0;A=0.0;while(1){l=f[c+(i*12|0)+4>>2]|0;x=A+ +n[(f[c+(i*12|0)+8>>2]|0)+((+n[l+16>>2]*+((f[(f[l>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+4>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+8>>2]|0)+(a<<2)>>2]|0)+(f[(f[l+12>>2]|0)+(a<<2)>>2]|0)|0)+ +n[l+36>>2]*+((f[(f[l+20>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+24>>2]|0)+(a<<2)>>2]|0)-(f[(f[l+28>>2]|0)+(a<<2)>>2]|0)+(f[(f[l+32>>2]|0)+(a<<2)>>2]|0)|0)>=v*+n[l+60>>2]&1)<<2)>>2];i=i+1|0;if((i|0)>=(g|0)){C=x;break}else A=x}}else C=0.0;if(C<+n[w+(k*28|0)+4>>2]){y=35;break}g=k+1|0;if((g|0)<(z|0))k=g;else{y=42;break}}if((y|0)==35){p[e>>3]=C;q=0-k|0;u=h;return q|0}else if((y|0)==42){p[e>>3]=C;q=1;u=h;return q|0}return 0}function bsa(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0.0,h=0,i=0.0;d=f[a+4>>2]|0;e=0;do{g=+n[d+(e*72|0)+16>>2]*+((f[(f[d+(e*72|0)>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+4>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+8>>2]|0)+(c<<2)>>2]|0)+(f[(f[d+(e*72|0)+12>>2]|0)+(c<<2)>>2]|0)|0)+ +n[d+(e*72|0)+36>>2]*+((f[(f[d+(e*72|0)+20>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+24>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+28>>2]|0)+(c<<2)>>2]|0)+(f[(f[d+(e*72|0)+32>>2]|0)+(c<<2)>>2]|0)|0);h=f[d+(e*72|0)+40>>2]|0;if(!h)i=g;else i=g+ +n[d+(e*72|0)+56>>2]*+((f[h+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+44>>2]|0)+(c<<2)>>2]|0)-(f[(f[d+(e*72|0)+48>>2]|0)+(c<<2)>>2]|0)+(f[(f[d+(e*72|0)+52>>2]|0)+(c<<2)>>2]|0)|0);e=f[(i<+n[d+(e*72|0)+60>>2]*b?d+(e*72|0)+64|0:d+(e*72|0)+68|0)>>2]|0}while((e|0)>0);return +(+n[(f[a+8>>2]|0)+(0-e<<2)>>2])}function csa(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0.0,Ub=0.0,Vb=0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0;n=u;u=u+704|0;o=n+696|0;q=n+664|0;r=n+652|0;s=n+640|0;t=n+628|0;v=n+624|0;w=n+620|0;x=n+592|0;y=n+564|0;z=n+536|0;A=n+176|0;B=n+508|0;C=n+480|0;D=n+424|0;E=n+352|0;F=n+344|0;G=n;H=n+288|0;I=n+232|0;J=n+408|0;dQ(o,104348);f[r>>2]=0;K=r+4|0;f[K>>2]=0;f[r+8>>2]=0;f[s>>2]=0;L=s+4|0;f[L>>2]=0;f[s+8>>2]=0;f[t>>2]=0;M=t+4|0;f[M>>2]=0;f[t+8>>2]=0;N=(j&1|0)!=0;O=j&4;P=(O|0)!=0;Q=(j&8|0)!=0;NO(w);R=(c|0)!=0;if(!(R?(f[c>>2]&-65536|0)==1112539136:0)){f[x>>2]=0;f[x+4>>2]=0;S=aD(x,26)|0;T=357783;U=S+26|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));bO(R?-5:-27,x,357810,354965,1238);bD(x)}if(!d){f[x>>2]=0;f[x+4>>2]=0;S=aD(x,20)|0;T=357836;U=S+20|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));bO(-27,x,357810,354965,1241);bD(x)}R=sQ(a,q,v,0)|0;if(f[v>>2]|0){f[x>>2]=0;f[x+4>>2]=0;S=aD(x,20)|0;T=357047;U=S+20|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));bO(-24,x,357810,354965,1245);bD(x)}if(f[R>>2]&7|0){f[x>>2]=0;f[x+4>>2]=0;S=aD(x,31)|0;T=357857;U=S+31|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));bO(-210,x,357810,354965,1248);bD(x)}if(h<=1.0){f[x>>2]=0;f[x+4>>2]=0;S=aD(x,24)|0;T=357889;U=S+24|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));bO(-211,x,357810,354965,1251);bD(x)}T=l+4|0;S=f[T>>2]|0;if((S|0)!=0?(U=f[l>>2]|0,(U|0)!=0):0){v=R+20|0;q=R+24|0;V=q;W=v;X=U;Z=S;_=f[v>>2]|0;$=f[q>>2]|0}else{q=R+20|0;v=f[q>>2]|0;f[T>>2]=v;S=R+24|0;U=f[S>>2]|0;f[l>>2]=U;V=S;W=q;X=U;Z=v;_=v;$=U}U=gQ(_,$,0)|0;if(!U)aa=0;else{$=L5b(16)|0;f[$+4>>2]=1;f[$>>2]=66704;f[$+8>>2]=U;aa=$}$=gQ((f[W>>2]|0)+1|0,(f[V>>2]|0)+1|0,4)|0;if(!$)ba=0;else{_=L5b(16)|0;f[_+4>>2]=1;f[_>>2]=66704;f[_+8>>2]=$;ba=_}_=gQ((f[W>>2]|0)+1|0,(f[V>>2]|0)+1|0,6)|0;if(!_)ca=0;else{v=L5b(16)|0;f[v+4>>2]=1;f[v>>2]=66704;f[v+8>>2]=_;ca=v}v=c+36|0;q=f[v>>2]|0;if(!q){$ra(c);da=f[v>>2]|0}else da=q;if(!(f[da+4>>2]|0)){ea=0;fa=0}else{da=gQ((f[W>>2]|0)+1|0,(f[V>>2]|0)+1|0,4)|0;if(!da)ga=0;else{V=L5b(16)|0;f[V+4>>2]=1;f[V>>2]=66704;f[V+8>>2]=da;ga=V}ea=ga;fa=da}da=IW(0,56,20,d)|0;if(!(f[R>>2]&4088))ha=R;else{E1(R,U,6);ha=U}a:do if((j&6|0)==2){R=f[c+8>>2]|0;d=f[c+12>>2]|0;ga=ha+20|0;V=ha+24|0;W=gQ((f[ga>>2]|0)+1|0,(f[V>>2]|0)+1|0,0)|0;if(!W)ia=0;else{q=L5b(16)|0;f[q+4>>2]=1;f[q>>2]=66704;f[q+8>>2]=W;ia=q}ja=+(R|0);ka=+(d|0);q=R+-2|0;v=d+-2|0;S=k+4|0;a=W+16|0;W=x+4|0;la=x+8|0;ma=x+12|0;na=x+16|0;oa=x+20|0;pa=x+24|0;qa=$+16|0;ra=y+4|0;sa=y+8|0;ta=y+12|0;ua=y+16|0;va=y+20|0;wa=y+24|0;xa=_+16|0;ya=z+4|0;za=z+8|0;Aa=z+12|0;Ba=z+16|0;Ca=z+20|0;Da=z+24|0;Ea=(fa|0)==0;Fa=A+4|0;Ga=A+8|0;Ha=A+12|0;Ia=A+16|0;Ja=A+20|0;Ka=A+24|0;La=U+16|0;Ma=C+4|0;Na=C+8|0;Oa=C+12|0;Pa=C+16|0;Qa=C+20|0;Ra=C+24|0;Sa=F+4|0;Ta=J+4|0;Ua=J+8|0;Va=J+12|0;Wa=I+36|0;Xa=I+16|0;Ya=I+4|0;Za=I+40|0;_a=I+44|0;$a=I+48|0;ab=H+36|0;bb=H+16|0;cb=H+4|0;db=H+40|0;eb=H+44|0;fb=H+48|0;gb=E+36|0;hb=E+16|0;ib=E+4|0;jb=E+40|0;kb=E+44|0;lb=E+48|0;mb=D+36|0;nb=D+16|0;ob=D+4|0;pb=D+40|0;qb=D+44|0;rb=D+48|0;sb=fa+16|0;tb=B+4|0;ub=B+8|0;vb=B+12|0;wb=B+16|0;xb=B+20|0;yb=B+24|0;zb=1.0;while(1){Ab=MVb(ja*zb)|0;Bb=MVb(ka*zb)|0;Cb=MVb(+(f[V>>2]|0)/zb)|0;Db=MVb(+(f[ga>>2]|0)/zb)|0;Eb=Cb-R|0;Fb=Eb+1|0;Gb=Db-d|0;Hb=Gb+1|0;if((Eb|0)<0){Ib=78;break}if((Gb|0)<0){Ib=77;break}if((Ab|0)>(f[l>>2]|0)){Ib=80;break}if((Bb|0)>(f[T>>2]|0)){Ib=79;break}do if((Ab|0)>=(f[k>>2]|0)){if((Bb|0)<(f[S>>2]|0)){Ib=75;break}Eb=f[a>>2]|0;f[x>>2]=1111638016;f[W>>2]=Cb;f[la>>2]=0;f[ma>>2]=0;f[na>>2]=Eb;f[oa>>2]=Db;f[pa>>2]=Cb;Eb=Db+1|0;Jb=Cb+1|0;Kb=f[qa>>2]|0;Lb=Jb<<2;f[y>>2]=1111638020;f[ra>>2]=Lb;f[sa>>2]=0;f[ta>>2]=0;f[ua>>2]=Kb;f[va>>2]=Eb;f[wa>>2]=Jb;Kb=f[xa>>2]|0;f[z>>2]=1111638022;f[ya>>2]=Jb<<3;f[za>>2]=0;f[Aa>>2]=0;f[Ba>>2]=Kb;f[Ca>>2]=Eb;f[Da>>2]=Jb;if(Ea)Mb=0;else{Kb=f[sb>>2]|0;f[B>>2]=1111638020;f[tb>>2]=Lb;f[ub>>2]=0;f[vb>>2]=0;f[wb>>2]=Kb;f[xb>>2]=Eb;f[yb>>2]=Jb;Mb=B}f[A>>2]=1111638021;f[Fa>>2]=Fb<<2;f[Ga>>2]=0;f[Ha>>2]=0;f[Ia>>2]=0;f[Ja>>2]=Hb;f[Ka>>2]=Fb;Jb=f[La>>2]|0;f[C>>2]=1111638016;f[Ma>>2]=Fb;f[Na>>2]=0;f[Oa>>2]=0;f[Pa>>2]=Jb;f[Qa>>2]=Hb;f[Ra>>2]=Fb;Mia(ha,x,5);F3(x,y,z,Mb);Jb=zb>2.0?1:2;Eb=((Y((Fb|0)/(Jb|0)|0,Gb+Jb|0)|0)/(Jb|0)|0)+500|0;Kb=(Eb|0)<1e3?1:(Eb|0)/1e3|0;Eb=(Kb|0)<100?Kb:100;_ra(c,y,z,Mb,1.0);tL(D,A,0,1,0,0);tL(E,C,0,1,0,0);f[F>>2]=0;f[Sa>>2]=Eb;Kb=Jb+-1+((Eb+Gb|0)/(Eb|0)|0)|0;tL(H,y,0,1,0,0);tL(I,z,0,1,0,0);f[J>>2]=1;f[Ta>>2]=1;f[Ua>>2]=q;f[Va>>2]=v;dsa(G,c,Kb-((Kb|0)%(Jb|0)|0)|0,zb,H,I,D,E,J,r,e,g,m,w);RQ(F,G,-1.0);esa(G);Jb=f[Wa>>2]|0;do if(Jb|0){Kb=Jb+12|0;Eb=f[Kb>>2]|0;f[Kb>>2]=Eb+-1;if((Eb|0)!=1)break;kL(I)}while(0);f[Wa>>2]=0;f[Xa>>2]=0;f[Xa+4>>2]=0;f[Xa+8>>2]=0;f[Xa+12>>2]=0;if((f[Ya>>2]|0)>0){Jb=f[Za>>2]|0;Eb=0;do{f[Jb+(Eb<<2)>>2]=0;Eb=Eb+1|0}while((Eb|0)<(f[Ya>>2]|0))}Eb=f[_a>>2]|0;if((Eb|0)!=($a|0))UC(Eb);Eb=f[ab>>2]|0;do if(Eb|0){Jb=Eb+12|0;Kb=f[Jb>>2]|0;f[Jb>>2]=Kb+-1;if((Kb|0)!=1)break;kL(H)}while(0);f[ab>>2]=0;f[bb>>2]=0;f[bb+4>>2]=0;f[bb+8>>2]=0;f[bb+12>>2]=0;if((f[cb>>2]|0)>0){Eb=f[db>>2]|0;Kb=0;do{f[Eb+(Kb<<2)>>2]=0;Kb=Kb+1|0}while((Kb|0)<(f[cb>>2]|0))}Kb=f[eb>>2]|0;if((Kb|0)!=(fb|0))UC(Kb);Kb=f[gb>>2]|0;do if(Kb|0){Eb=Kb+12|0;Jb=f[Eb>>2]|0;f[Eb>>2]=Jb+-1;if((Jb|0)!=1)break;kL(E)}while(0);f[gb>>2]=0;f[hb>>2]=0;f[hb+4>>2]=0;f[hb+8>>2]=0;f[hb+12>>2]=0;if((f[ib>>2]|0)>0){Kb=f[jb>>2]|0;Jb=0;do{f[Kb+(Jb<<2)>>2]=0;Jb=Jb+1|0}while((Jb|0)<(f[ib>>2]|0))}Jb=f[kb>>2]|0;if((Jb|0)!=(lb|0))UC(Jb);Jb=f[mb>>2]|0;do if(Jb|0){Kb=Jb+12|0;Eb=f[Kb>>2]|0;f[Kb>>2]=Eb+-1;if((Eb|0)!=1)break;kL(D)}while(0);f[mb>>2]=0;f[nb>>2]=0;f[nb+4>>2]=0;f[nb+8>>2]=0;f[nb+12>>2]=0;if((f[ob>>2]|0)>0){Jb=f[pb>>2]|0;Eb=0;do{f[Jb+(Eb<<2)>>2]=0;Eb=Eb+1|0}while((Eb|0)<(f[ob>>2]|0))}Eb=f[qb>>2]|0;if((Eb|0)!=(rb|0))UC(Eb)}else Ib=75;while(0);if((Ib|0)==75)Ib=0;zb=zb*h}if((Ib|0)==77){Nb=ia;Ob=0;break}else if((Ib|0)==78){Nb=ia;Ob=0;break}else if((Ib|0)==79){Nb=ia;Ob=0;break}else if((Ib|0)==80){Nb=ia;Ob=0;break}}else{rb=fa;F3(ha,$,_,rb);if(N){qb=ha+24|0;ob=gQ((f[ha+20>>2]|0)+1|0,(f[qb>>2]|0)+1|0,4)|0;if(!ob)Pb=0;else{pb=L5b(16)|0;f[pb+4>>2]=1;f[pb>>2]=66704;f[pb+8>>2]=ob;Pb=pb}X4(ha,U,0.0,50.0,3);F3(U,ob,0,0);Qb=qb;Rb=Pb;Sb=ob}else{Qb=ha+24|0;Rb=0;Sb=0}ob=c+8|0;qb=f[ob>>2]|0;zb=+(qb|0);pb=f[Qb>>2]|0;ka=+(pb+-10|0);if(zb<ka){ja=+(f[c+12>>2]|0);Tb=+((f[ha+20>>2]|0)+-10|0);nb=0;Ub=1.0;while(1){if(!(Ub*ja<Tb)){Vb=nb;Wb=Ub;break}mb=nb+1|0;Xb=Ub*h;if(Xb*zb<ka){nb=mb;Ub=Xb}else{Vb=mb;Wb=Xb;break}}Ub=1.0/h;ka=P?Ub:h;if((Vb|0)>0){nb=c+12|0;mb=ha+20|0;lb=k+4|0;kb=Sb;ib=kb+16|0;jb=kb+4|0;kb=x+4|0;hb=x+8|0;gb=x+12|0;fb=$+16|0;eb=$+4|0;cb=y+4|0;db=y+8|0;bb=y+12|0;ab=z+4|0;$a=A+20|0;_a=A+24|0;Ya=A+28|0;Za=A+4|0;Xa=A+8|0;Wa=A+16|0;v=A+36|0;Va=A+40|0;q=A+44|0;Ua=A+48|0;Ta=(i|0)>1?i:1;Sa=r+8|0;Ra=z+4|0;Qa=z+8|0;Pa=z+12|0;zb=Q?.6:.4;Tb=P?Ub*Wb:1.0;Oa=Vb;Na=0;Ma=0;La=0;Ka=0;Ja=qb;Ia=pb;Ha=f[k>>2]|0;while(1){Ga=Oa+-1|0;Ub=Tb>2.0?Tb:2.0;Fa=MVb(Tb*+(Ja|0))|0;yb=MVb(Tb*+(f[nb>>2]|0))|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;xb=MVb(+(Ia-Fa|0)/Ub)|0;wb=MVb(+((f[mb>>2]|0)-yb|0)/Ub)|0;do if((Fa|0)<(Ha|0))Ib=94;else{if((yb|0)<(f[lb>>2]|0)){Ib=94;break}if((Fa|0)>(X|0)|(yb|0)>(Z|0))if(P){Yb=Na;Zb=Ma;_b=La;$b=Ka;ac=Ha;break}else{Nb=0;Ob=Rb;break a}_ra(c,$,_,rb,Tb);aQ(U);if(N){ja=+(Fa|0);vb=MVb(ja*.15)|0;Xb=+(yb|0);ub=MVb(Xb*.15)|0;tb=MVb(ja*.7)|0;sb=MVb(Xb*.7)|0;Ea=f[ib>>2]|0;Da=f[jb>>2]|0;Ca=Ea+(Y(Da,ub)|0)+(vb<<2)|0;f[x>>2]=Ca;f[kb>>2]=Ca+(tb<<2);Ca=sb+ub|0;sb=Ea+(Y(Da,Ca)|0)+(vb<<2)|0;f[hb>>2]=sb;f[gb>>2]=sb+(tb<<2);sb=f[fb>>2]|0;Da=f[eb>>2]|0;Ea=sb+(Y(Da,ub)|0)+(vb<<2)|0;f[y>>2]=Ea;f[cb>>2]=Ea+(tb<<2);Ea=sb+(Y(Da,Ca)|0)+(vb<<2)|0;f[db>>2]=Ea;f[bb>>2]=Ea+(tb<<2)}tb=Y(Ka,La)|0;if((tb|0)>0){Ea=MVb(+(Ma|0)/Ub)|0;vb=MVb(+(Ka+Ma-yb|0)/Ub)|0;Ca=MVb(+(Na|0)/Ub)|0;bc=vb;cc=MVb(+(La+Na-Fa|0)/Ub)|0;dc=Ea;ec=Ca}else{bc=wb;cc=xb;dc=0;ec=0}f[z>>2]=dc;f[ab>>2]=bc;Ca=f[eb>>2]|0;f[A>>2]=104376;f[Za>>2]=c;f[$a>>2]=Fa;f[_a>>2]=yb;Ea=Ya;f[Ea>>2]=ec;f[Ea+4>>2]=cc;p[Xa>>3]=Ub;f[Wa>>2]=Ca;f[v>>2]=x;f[Va>>2]=y;f[q>>2]=r;f[Ua>>2]=w;RQ(z,A,-1.0);if(!P){Yb=Na;Zb=Ma;_b=La;$b=Ka;ac=Ha;break}Ca=f[r>>2]|0;Ea=f[K>>2]|0;if((Ca|0)==(Ea|0)){Yb=Na;Zb=Ma;_b=La;$b=Ka;ac=Ha;break}if(tb|0){Yb=Na;Zb=Ma;_b=La;$b=Ka;ac=Ha;break}tb=Ea-Ca>>4;vb=f[L>>2]|0;Da=f[s>>2]|0;sb=vb-Da>>4;ub=Da;Da=vb;do if(tb>>>0>sb>>>0){Voa(s,tb-sb|0);fc=f[r>>2]|0;gc=f[K>>2]|0}else{if(tb>>>0>=sb>>>0){fc=Ca;gc=Ea;break}vb=ub+(tb<<4)|0;if((Da|0)==(vb|0)){fc=Ca;gc=Ea;break}f[L>>2]=Da+(~((Da+-16-vb|0)>>>4)<<4);fc=Ca;gc=Ea}while(0);if((fc|0)!=(gc|0)){Ea=fc;Ca=f[s>>2]|0;while(1){f[Ca>>2]=f[Ea>>2];f[Ca+4>>2]=f[Ea+4>>2];f[Ca+8>>2]=f[Ea+8>>2];f[Ca+12>>2]=f[Ea+12>>2];Ea=Ea+16|0;if((Ea|0)==(gc|0))break;else Ca=Ca+16|0}}vra(s,Ta,.2);Ca=f[s>>2]|0;Ea=f[L>>2]|0;if((Ca|0)==(Ea|0)){Yb=Na;Zb=Ma;_b=La;$b=Ka;ac=Ha;break}Da=Ea-Ca>>4;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if(!Da){hc=0;ic=0;jc=0;kc=0}else{Ea=0;tb=0;ub=0;sb=0;vb=0;while(1){Ba=f[Ca+(Ea<<4)+8>>2]|0;Aa=f[Ca+(Ea<<4)+12>>2]|0;if((Y(Aa,Ba)|0)>(Y(ub,tb)|0)){za=f[Ca+(Ea<<4)>>2]|0;f[z>>2]=za;ya=f[Ca+(Ea<<4)+4>>2]|0;f[Ra>>2]=ya;f[Qa>>2]=Ba;f[Pa>>2]=Aa;lc=ya;mc=za;nc=Aa;oc=Ba}else{lc=sb;mc=vb;nc=ub;oc=tb}Ea=Ea+1|0;if((Ea|0)==(Da|0)){hc=mc;ic=lc;jc=oc;kc=nc;break}else{tb=oc;ub=nc;sb=lc;vb=mc}}}vb=f[K>>2]|0;if((vb|0)==(f[Sa>>2]|0))Zoa(r,z);else{f[vb>>2]=hc;f[vb+4>>2]=ic;f[vb+8>>2]=jc;f[vb+12>>2]=kc;f[K>>2]=vb+16}vb=f[z>>2]|0;sb=f[Ra>>2]|0;ub=f[Qa>>2]|0;tb=f[Pa>>2]|0;Xb=+(ub|0);Da=MVb(Xb*.2)|0;ja=+(tb|0);Ea=MVb(ja*.2)|0;Ca=vb-Da|0;vb=(Ca|0)>0?Ca:0;Ca=sb-Ea|0;sb=(Ca|0)>0?Ca:0;Ca=(Da<<1)+ub|0;ub=(f[Qb>>2]|0)+-1-vb|0;Da=(Ea<<1)+tb|0;tb=(f[mb>>2]|0)+-1-sb|0;Ea=MVb(zb*Xb)|0;f[k>>2]=Ea;Ba=MVb(zb*ja)|0;f[lb>>2]=Ba;Yb=vb;Zb=sb;_b=(ub|0)<(Ca|0)?ub:Ca;$b=(tb|0)<(Da|0)?tb:Da;ac=Ea}while(0);if((Ib|0)==94){Ib=0;if(P){Nb=0;Ob=Rb;break a}else{Yb=Na;Zb=Ma;_b=La;$b=Ka;ac=Ha}}if((Oa|0)<=1){Nb=0;Ob=Rb;break a}Tb=ka*Tb;Oa=Ga;Na=Yb;Ma=Zb;La=_b;Ka=$b;Ja=f[ob>>2]|0;Ia=f[Qb>>2]|0;Ha=ac}}else{Nb=0;Ob=Rb}}else{Nb=0;Ob=Rb}}while(0);Rb=f[K>>2]|0;ac=f[r>>2]|0;Qb=Rb-ac>>4;$b=f[L>>2]|0;_b=f[s>>2]|0;Zb=$b-_b>>4;Yb=_b;_b=$b;$b=ac;ac=Rb;if(Qb>>>0<=Zb>>>0)if(Qb>>>0<Zb>>>0?(Rb=Yb+(Qb<<4)|0,(_b|0)!=(Rb|0)):0){f[L>>2]=_b+(~((_b+-16-Rb|0)>>>4)<<4);pc=$b;qc=ac}else{pc=$b;qc=ac}else{Voa(s,Qb-Zb|0);pc=f[r>>2]|0;qc=f[K>>2]|0}if((pc|0)!=(qc|0)){Zb=pc;pc=f[s>>2]|0;while(1){f[pc>>2]=f[Zb>>2];f[pc+4>>2]=f[Zb+4>>2];f[pc+8>>2]=f[Zb+8>>2];f[pc+12>>2]=f[Zb+12>>2];Zb=Zb+16|0;if((Zb|0)==(qc|0))break;else pc=pc+16|0}}do if(O|i)if(m){xra(s,e,g,i,.2);break}else{wra(s,t,(i|0)>1?i:1,.2);break}else{pc=(f[L>>2]|0)-(f[s>>2]|0)>>4;f[x>>2]=0;qc=f[M>>2]|0;Zb=f[t>>2]|0;Qb=qc-Zb>>2;ac=Zb;Zb=qc;do if(pc>>>0<=Qb>>>0){if(pc>>>0<Qb>>>0){qc=ac+(pc<<2)|0;if((Zb|0)==(qc|0))break;f[M>>2]=Zb+(~((Zb+-4-qc|0)>>>2)<<2)}}else Rr(t,pc-Qb|0,x);while(0)}while(0);i=f[L>>2]|0;g=f[s>>2]|0;e=(i|0)==(g|0);if(P){P=g;if(!e){m=x+4|0;O=x+8|0;Qb=x+12|0;pc=x+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;Zb=f[t>>2]|0;ac=i-g>>4;i=0;qc=0;$b=0;while(1){Rb=f[P+(i<<4)+8>>2]|0;_b=f[P+(i<<4)+12>>2]|0;if((Y(_b,Rb)|0)>(Y($b,qc)|0)){Yb=f[P+(i<<4)+4>>2]|0;f[x>>2]=f[P+(i<<4)>>2];f[m>>2]=Yb;f[O>>2]=Rb;f[Qb>>2]=_b;f[pc>>2]=f[Zb+(i<<2)>>2];rc=_b;sc=Rb}else{rc=$b;sc=qc}i=i+1|0;if(i>>>0>=ac>>>0)break;else{qc=sc;$b=rc}}XW(da,x)|0}}else if(!e){e=x+4|0;rc=x+8|0;$b=x+12|0;sc=x+16|0;qc=0;ac=g;do{g=ac;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;i=f[g+(qc<<4)+4>>2]|0;Zb=f[g+(qc<<4)+8>>2]|0;pc=f[g+(qc<<4)+12>>2]|0;f[x>>2]=f[g+(qc<<4)>>2];f[e>>2]=i;f[rc>>2]=Zb;f[$b>>2]=pc;pc=f[t>>2]|0;if((pc|0)==(f[M>>2]|0))tc=0;else tc=f[pc+(qc<<2)>>2]|0;f[sc>>2]=tc;XW(da,x)|0;qc=qc+1|0;ac=f[s>>2]|0}while(qc>>>0<(f[L>>2]|0)-ac>>4>>>0)}OO(w);w=f[t>>2]|0;if(w|0){t=f[M>>2]|0;if((t|0)!=(w|0))f[M>>2]=t+(~((t+-4-w|0)>>>2)<<2);O5b(w)}w=f[s>>2]|0;if(w|0){s=f[L>>2]|0;if((s|0)!=(w|0))f[L>>2]=s+(~((s+-16-w|0)>>>4)<<4);O5b(w)}w=f[r>>2]|0;if(w|0){r=f[K>>2]|0;if((r|0)!=(w|0))f[K>>2]=r+(~((r+-16-w|0)>>>4)<<4);O5b(w)}w=Nb;do if(Nb|0){r=w+4|0;K=f[r>>2]|0;f[r>>2]=K+-1;if((K|0)!=1)break;bi[f[(f[Nb>>2]|0)+8>>2]&2047](w)}while(0);w=Ob;do if(Ob|0){Nb=w+4|0;K=f[Nb>>2]|0;f[Nb>>2]=K+-1;if((K|0)!=1)break;bi[f[(f[Ob>>2]|0)+8>>2]&2047](w)}while(0);w=ca;do if(ca|0){Ob=w+4|0;K=f[Ob>>2]|0;f[Ob>>2]=K+-1;if((K|0)!=1)break;bi[f[(f[ca>>2]|0)+8>>2]&2047](w)}while(0);w=ea;do if(ea|0){ca=w+4|0;K=f[ca>>2]|0;f[ca>>2]=K+-1;if((K|0)!=1)break;bi[f[(f[ea>>2]|0)+8>>2]&2047](w)}while(0);w=ba;do if(ba|0){ea=w+4|0;K=f[ea>>2]|0;f[ea>>2]=K+-1;if((K|0)!=1)break;bi[f[(f[ba>>2]|0)+8>>2]&2047](w)}while(0);w=aa;do if(aa|0){ba=w+4|0;K=f[ba>>2]|0;f[ba>>2]=K+-1;if((K|0)!=1)break;bi[f[(f[aa>>2]|0)+8>>2]&2047](w)}while(0);if(!(f[o+4>>2]|0)){u=n;return da|0}u=n;return da|0}function dsa(a,b,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;f[a>>2]=104416;q=a+24|0;f[q>>2]=1124007936;r=a+28|0;s=a+32|0;t=a+64|0;u=r;v=u+36|0;do{f[u>>2]=0;u=u+4|0}while((u|0)<(v|0));f[t>>2]=s;w=a+72|0;x=a+68|0;f[x>>2]=w;f[w>>2]=0;f[a+76>>2]=0;w=a+80|0;f[w>>2]=1124007936;y=a+84|0;z=a+88|0;A=a+120|0;u=y;v=u+36|0;do{f[u>>2]=0;u=u+4|0}while((u|0)<(v|0));f[A>>2]=z;u=a+128|0;v=a+124|0;f[v>>2]=u;f[u>>2]=0;f[a+132>>2]=0;u=a+144|0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=0;f[u+12>>2]=0;f[a+4>>2]=b;f[a+8>>2]=c;p[a+16>>3]=d;if((q|0)!=(e|0)){c=e+36|0;b=f[c>>2]|0;if(b){B=b+12|0;f[B>>2]=(f[B>>2]|0)+1;B=a+60|0;b=f[B>>2]|0;if((b|0)!=0?(C=b+12|0,b=f[C>>2]|0,f[C>>2]=b+-1,(b|0)==1):0){kL(q);D=B}else D=B}else D=a+60|0;f[D>>2]=0;B=a+40|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[r>>2]|0)>0){b=f[t>>2]|0;t=0;do{f[b+(t<<2)>>2]=0;t=t+1|0;E=f[r>>2]|0}while((t|0)<(E|0));f[q>>2]=f[e>>2];if((E|0)<3)F=12;else F=14}else{f[q>>2]=f[e>>2];F=12}if((F|0)==12){E=f[e+4>>2]|0;if((E|0)<3){f[r>>2]=E;f[s>>2]=f[e+8>>2];f[a+36>>2]=f[e+12>>2];s=f[e+44>>2]|0;E=f[x>>2]|0;f[E>>2]=f[s>>2];f[E+4>>2]=f[s+4>>2]}else F=14}if((F|0)==14)jL(q,e);f[B>>2]=f[e+16>>2];f[a+44>>2]=f[e+20>>2];f[a+48>>2]=f[e+24>>2];f[a+52>>2]=f[e+28>>2];f[a+56>>2]=f[e+32>>2];f[D>>2]=f[c>>2]}if((w|0)==(g|0)){G=a+136|0;f[G>>2]=h;H=a+140|0;f[H>>2]=i;I=f[j>>2]|0;f[u>>2]=I;J=j+4|0;K=f[J>>2]|0;L=a+148|0;f[L>>2]=K;M=j+8|0;N=f[M>>2]|0;O=a+152|0;f[O>>2]=N;P=j+12|0;Q=f[P>>2]|0;R=a+156|0;f[R>>2]=Q;S=a+160|0;f[S>>2]=k;T=n?l:0;U=a+164|0;f[U>>2]=T;V=n?m:0;W=a+168|0;f[W>>2]=V;X=a+172|0;f[X>>2]=o;return}c=g+36|0;D=f[c>>2]|0;if(D|0){e=D+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+116|0;D=f[e>>2]|0;if(D|0?(B=D+12|0,D=f[B>>2]|0,f[B>>2]=D+-1,(D|0)==1):0)kL(w);f[e>>2]=0;D=a+96|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[y>>2]|0)>0){B=f[A>>2]|0;A=0;do{f[B+(A<<2)>>2]=0;A=A+1|0;Y=f[y>>2]|0}while((A|0)<(Y|0));f[w>>2]=f[g>>2];if((Y|0)<3)F=27;else F=29}else{f[w>>2]=f[g>>2];F=27}if((F|0)==27){Y=f[g+4>>2]|0;if((Y|0)<3){f[y>>2]=Y;f[z>>2]=f[g+8>>2];f[a+92>>2]=f[g+12>>2];z=f[g+44>>2]|0;Y=f[v>>2]|0;f[Y>>2]=f[z>>2];f[Y+4>>2]=f[z+4>>2]}else F=29}if((F|0)==29)jL(w,g);f[D>>2]=f[g+16>>2];f[a+100>>2]=f[g+20>>2];f[a+104>>2]=f[g+24>>2];f[a+108>>2]=f[g+28>>2];f[a+112>>2]=f[g+32>>2];f[e>>2]=f[c>>2];G=a+136|0;f[G>>2]=h;H=a+140|0;f[H>>2]=i;I=f[j>>2]|0;f[u>>2]=I;J=j+4|0;K=f[J>>2]|0;L=a+148|0;f[L>>2]=K;M=j+8|0;N=f[M>>2]|0;O=a+152|0;f[O>>2]=N;P=j+12|0;Q=f[P>>2]|0;R=a+156|0;f[R>>2]=Q;S=a+160|0;f[S>>2]=k;T=n?l:0;U=a+164|0;f[U>>2]=T;V=n?m:0;W=a+168|0;f[W>>2]=V;X=a+172|0;f[X>>2]=o;return}function esa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=104416;b=a+80|0;c=a+116|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+96|0;b=a+84|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+120>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+124>>2]|0;if((b|0)!=(a+128|0))UC(b);b=a+24|0;d=a+60|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+40|0;b=a+28|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+64>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0))return;UC(b);return}function fsa(a){a=a|0;O5b(a);return}function gsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;c=u;u=u+80|0;d=c+64|0;e=c;g=c+56|0;h=c+32|0;i=c+12|0;j=c+52|0;k=c+48|0;l=c+44|0;m=c+40|0;n=c+24|0;o=c+8|0;dQ(h,104388);q=f[b>>2]|0;r=f[b+4>>2]|0;b=f[a+36>>2]|0;s=f[b>>2]|0;t=f[b+4>>2]|0;v=f[b+8>>2]|0;w=f[b+12>>2]|0;b=f[a+40>>2]|0;x=f[b>>2]|0;y=f[b+4>>2]|0;z=f[b+8>>2]|0;A=f[b+12>>2]|0;b=(s|0)==0;B=(f[a+16>>2]|0)>>>2;f[i>>2]=0;C=i+4|0;f[C>>2]=0;f[i+8>>2]=0;if((q|0)<(r|0)){D=a+8|0;E=a+28|0;F=a+32|0;G=a+4|0;H=d+4|0;H=a+20|0;I=a+24|0;J=d+4|0;K=d+8|0;L=d+12|0;M=i+8|0;N=a+48|0;O=a+44|0;P=q;q=f[F>>2]|0;while(1){Q=+p[D>>3];R=MVb(+(P|0)*Q)|0;S=f[E>>2]|0;a:do if((S|0)<(q|0)){T=Y(R,B)|0;U=S;V=q;W=Q;while(1){X=MVb(+(U|0)*W)|0;if(!b?(Z=X+T|0,((f[s+(Z<<2)>>2]|0)-(f[t+(Z<<2)>>2]|0)-(f[v+(Z<<2)>>2]|0)+(f[w+(Z<<2)>>2]|0)|0)<100?1:((f[x+(Z<<2)>>2]|0)-(f[y+(Z<<2)>>2]|0)-(f[z+(Z<<2)>>2]|0)+(f[A+(Z<<2)>>2]|0)|0)<20):0){_=2;$=V}else{Z=f[G>>2]|0;dQ(d,104328);aa=asa(Z,X,R,e,0)|0;if((aa|0)>0){Z=f[H>>2]|0;ba=f[I>>2]|0;f[d>>2]=X;f[J>>2]=R;f[K>>2]=Z;f[L>>2]=ba;ca=f[C>>2]|0;if((ca|0)==(f[M>>2]|0)){Zoa(i,d);da=f[C>>2]|0}else{f[ca>>2]=X;f[ca+4>>2]=R;f[ca+8>>2]=Z;f[ca+12>>2]=ba;ba=ca+16|0;f[C>>2]=ba;da=ba}if(da-(f[i>>2]|0)>>4>>>0>99?(PO(f[N>>2]|0),ba=f[O>>2]|0,f[j>>2]=f[ba+4>>2],f[k>>2]=f[i>>2],f[l>>2]=f[C>>2],f[g>>2]=f[j>>2],f[e>>2]=f[k>>2],f[d>>2]=f[l>>2],hsa(ba,g,e,d)|0,QO(f[N>>2]|0),ba=f[i>>2]|0,ca=f[C>>2]|0,(ca|0)!=(ba|0)):0)f[C>>2]=ca+(~((ca+-16-ba|0)>>>4)<<4)}_=aa|0?1:2;$=f[F>>2]|0}aa=_+U|0;if((aa|0)>=($|0)){ea=$;break a}U=aa;V=$;W=+p[D>>3]}}else ea=q;while(0);P=P+1|0;if((P|0)>=(r|0))break;else q=ea}ea=f[i>>2]|0;if((f[C>>2]|0)==(ea|0))fa=ea;else{ea=a+48|0;PO(f[ea>>2]|0);q=f[a+44>>2]|0;f[m>>2]=f[q+4>>2];f[n>>2]=f[i>>2];f[o>>2]=f[C>>2];f[g>>2]=f[m>>2];f[e>>2]=f[n>>2];f[d>>2]=f[o>>2];hsa(q,g,e,d)|0;QO(f[ea>>2]|0);fa=f[i>>2]|0}if(fa|0){i=f[C>>2]|0;if((i|0)!=(fa|0))f[C>>2]=i+(~((i+-16-fa|0)>>>4)<<4);O5b(fa)}}if(!(f[h+4>>2]|0)){u=c;return}u=c;return}function hsa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=h>>4;i=e+(b<<4)|0;j=f[c>>2]|0;c=f[d>>2]|0;d=c-j|0;k=d>>4;l=j;m=c;if((d|0)<=0){n=i;return n|0}d=a+8|0;o=f[d>>2]|0;p=a+4|0;q=f[p>>2]|0;r=q;if((k|0)<=(o-r>>4|0)){s=i;t=r-s|0;u=t>>4;if((k|0)>(u|0)){v=l+(u<<4)|0;u=v;if((v|0)==(m|0))w=q;else{x=m+-16-u|0;y=v;v=q;while(1){f[v>>2]=f[y>>2];f[v+4>>2]=f[y+4>>2];f[v+8>>2]=f[y+8>>2];f[v+12>>2]=f[y+12>>2];y=y+16|0;if((y|0)==(m|0))break;else v=v+16|0}v=q+((x>>>4)+1<<4)|0;f[p>>2]=v;w=v}if((t|0)>0){z=u;A=w}else{n=i;return n|0}}else{z=c;A=q}c=A-(i+(k<<4))>>4;w=i+(c<<4)|0;if(w>>>0<q>>>0){u=(q+(0-c<<4)+~s|0)>>>4;s=w;t=A;while(1){f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];s=s+16|0;if(s>>>0>=q>>>0)break;else t=t+16|0}f[p>>2]=A+(u+1<<4)}if(c|0){c=w;w=A;do{A=c;c=c+-16|0;u=w;w=w+-16|0;f[w>>2]=f[c>>2];f[u+-12>>2]=f[A+-12>>2];f[u+-8>>2]=f[A+-8>>2];f[u+-4>>2]=f[A+-4>>2]}while((c|0)!=(i|0))}c=z;if((l|0)==(c|0)){n=i;return n|0}else{B=i;C=l}while(1){f[B>>2]=f[C>>2];f[B+4>>2]=f[C+4>>2];f[B+8>>2]=f[C+8>>2];f[B+12>>2]=f[C+12>>2];C=C+16|0;if((C|0)==(c|0)){n=i;break}else B=B+16|0}return n|0}B=(r-g>>4)+k|0;if(B>>>0>268435455)c4b(a);k=o-g|0;o=k>>3;r=k>>4>>>0<134217727?(o>>>0<B>>>0?B:o):268435455;o=i;B=h>>4;do if(r)if(r>>>0>268435455){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{D=L5b(r<<4)|0;break}else D=0;while(0);h=D+(B<<4)|0;B=D+(r<<4)|0;if((l|0)==(m|0))E=h;else{r=((m+-16-j|0)>>>4)+1|0;j=l;l=h;while(1){f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];f[l+8>>2]=f[j+8>>2];f[l+12>>2]=f[j+12>>2];j=j+16|0;if((j|0)==(m|0))break;else l=l+16|0}E=h+(r<<4)|0}if(!b)F=h;else{b=i+-16-g|0;g=i;r=h;while(1){l=g;g=g+-16|0;f[r+-16>>2]=f[g>>2];f[r+-12>>2]=f[l+-12>>2];f[r+-8>>2]=f[l+-8>>2];f[r+-4>>2]=f[l+-4>>2];if((g|0)==(e|0))break;else r=r+-16|0}F=h+(~(b>>>4)<<4)|0}b=F;if((q|0)==(i|0))G=E;else{F=q+-16-o|0;o=i;i=E;while(1){f[i>>2]=f[o>>2];f[i+4>>2]=f[o+4>>2];f[i+8>>2]=f[o+8>>2];f[i+12>>2]=f[o+12>>2];o=o+16|0;if((o|0)==(q|0))break;else i=i+16|0}G=E+((F>>>4)+1<<4)|0}f[a>>2]=b;f[p>>2]=G;f[d>>2]=B;if(!e){n=h;return n|0}O5b(e);n=h;return n|0}function isa(a){a=a|0;esa(a);O5b(a);return}function jsa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0;c=u;u=u+176|0;d=c+160|0;e=c+152|0;g=c+148|0;h=c+72|0;i=c+56|0;j=c+40|0;k=c+24|0;l=c;m=c+144|0;n=c+140|0;o=c+136|0;q=c+132|0;r=c+128|0;s=c+124|0;t=c+120|0;v=c+116|0;w=c+112|0;x=c+108|0;y=c+104|0;z=c+100|0;A=c+96|0;B=c+92|0;C=c+88|0;D=c+84|0;E=c+80|0;F=c+68|0;G=c+52|0;H=c+36|0;I=c+20|0;J=c+16|0;K=c+12|0;L=c+8|0;dQ(h,104428);M=a+4|0;N=f[M>>2]|0;O=f[N+8>>2]|0;P=f[N+12>>2]|0;N=a+16|0;Q=+p[N>>3];R=MVb(+(O|0)*Q)|0;S=MVb(+(P|0)*Q)|0;T=f[a+8>>2]|0;U=Y(T,f[b>>2]|0)|0;V=Y(f[b+4>>2]|0,T)|0;T=(f[a+32>>2]|0)+~P|0;P=(T|0)<(V|0)?T:V;if((P|0)>(U|0)?(V=f[a+36>>2]|0,(V|0)>(O+1|0)):0){T=V+~O|0;O=Q>2.0?1:2;f[i>>2]=0;V=i+4|0;f[V>>2]=0;f[i+8>>2]=0;f[j>>2]=0;b=j+4|0;f[b>>2]=0;f[j+8>>2]=0;f[k>>2]=0;W=k+4|0;f[W>>2]=0;f[k+8>>2]=0;X=(T|0)>0;Z=a+164|0;_=d+4|0;$=d+8|0;aa=d+12|0;ba=i+8|0;ca=a+172|0;da=a+160|0;ea=d+4|0;fa=d+8|0;ga=d+12|0;ha=j+8|0;ia=k+8|0;ja=a+168|0;ka=U;do{if(X){Q=+(ka|0);U=0;do{la=asa(f[M>>2]|0,U,ka,l,0)|0;if(!(f[Z>>2]|0)){if((la|0)>0){ma=+p[N>>3];na=MVb(+(U|0)*ma)|0;oa=MVb(Q*ma)|0;f[d>>2]=na;f[_>>2]=oa;f[$>>2]=R;f[aa>>2]=S;pa=f[V>>2]|0;if((pa|0)==(f[ba>>2]|0)){Zoa(i,d);qa=f[V>>2]|0}else{f[pa>>2]=na;f[pa+4>>2]=oa;f[pa+8>>2]=R;f[pa+12>>2]=S;oa=pa+16|0;f[V>>2]=oa;qa=oa}if(qa-(f[i>>2]|0)>>4>>>0>99?(PO(f[ca>>2]|0),oa=f[da>>2]|0,f[x>>2]=f[oa+4>>2],f[y>>2]=f[i>>2],f[z>>2]=f[V>>2],f[g>>2]=f[x>>2],f[e>>2]=f[y>>2],f[d>>2]=f[z>>2],hsa(oa,g,e,d)|0,QO(f[ca>>2]|0),oa=f[i>>2]|0,pa=f[V>>2]|0,(pa|0)!=(oa|0)):0)f[V>>2]=pa+(~((pa+-16-oa|0)>>>4)<<4)}}else{oa=f[(f[M>>2]|0)+4>>2]|0;pa=(la|0)==1?0-oa|0:la;if((pa+oa|0)<4){ma=+p[N>>3];oa=MVb(+(U|0)*ma)|0;la=MVb(Q*ma)|0;f[d>>2]=oa;f[ea>>2]=la;f[fa>>2]=R;f[ga>>2]=S;na=f[V>>2]|0;if((na|0)==(f[ba>>2]|0))Zoa(i,d);else{f[na>>2]=oa;f[na+4>>2]=la;f[na+8>>2]=R;f[na+12>>2]=S;f[V>>2]=na+16}na=0-pa|0;f[d>>2]=na;pa=f[b>>2]|0;if((pa|0)==(f[ha>>2]|0))IO(j,d);else{f[pa>>2]=na;f[b>>2]=pa+4}pa=f[W>>2]|0;if((pa|0)==(f[ia>>2]|0))apa(k,l);else{p[pa>>3]=+p[l>>3];f[W>>2]=pa+8}if((f[V>>2]|0)-(f[i>>2]|0)>>4>>>0>99){PO(f[ca>>2]|0);pa=f[da>>2]|0;f[m>>2]=f[pa+4>>2];f[n>>2]=f[i>>2];f[o>>2]=f[V>>2];f[g>>2]=f[m>>2];f[e>>2]=f[n>>2];f[d>>2]=f[o>>2];hsa(pa,g,e,d)|0;pa=f[Z>>2]|0;f[q>>2]=f[pa+4>>2];f[r>>2]=f[j>>2];f[s>>2]=f[b>>2];f[g>>2]=f[q>>2];f[e>>2]=f[r>>2];f[d>>2]=f[s>>2];s2(pa,g,e,d)|0;pa=f[ja>>2]|0;f[t>>2]=f[pa+4>>2];f[v>>2]=f[k>>2];f[w>>2]=f[W>>2];f[g>>2]=f[t>>2];f[e>>2]=f[v>>2];f[d>>2]=f[w>>2];ksa(pa,g,e,d)|0;QO(f[ca>>2]|0);pa=f[i>>2]|0;na=f[V>>2]|0;if((na|0)!=(pa|0))f[V>>2]=na+(~((na+-16-pa|0)>>>4)<<4);pa=f[j>>2]|0;na=f[b>>2]|0;if((na|0)!=(pa|0))f[b>>2]=na+(~((na+-4-pa|0)>>>2)<<2);pa=f[k>>2]|0;na=f[W>>2]|0;if((na|0)!=(pa|0))f[W>>2]=na+(~((na+-8-pa|0)>>>3)<<3)}}}U=U+O|0}while((U|0)<(T|0))}ka=ka+O|0}while((ka|0)<(P|0));if((f[b>>2]|0)==(f[j>>2]|0)){if((f[V>>2]|0)!=(f[i>>2]|0)){P=a+172|0;PO(f[P>>2]|0);ka=f[a+160>>2]|0;f[J>>2]=f[ka+4>>2];f[K>>2]=f[i>>2];f[L>>2]=f[V>>2];f[g>>2]=f[J>>2];f[e>>2]=f[K>>2];f[d>>2]=f[L>>2];hsa(ka,g,e,d)|0;QO(f[P>>2]|0)}}else{P=a+172|0;PO(f[P>>2]|0);ka=f[a+160>>2]|0;f[A>>2]=f[ka+4>>2];f[B>>2]=f[i>>2];f[C>>2]=f[V>>2];f[g>>2]=f[A>>2];f[e>>2]=f[B>>2];f[d>>2]=f[C>>2];hsa(ka,g,e,d)|0;ka=f[a+164>>2]|0;f[D>>2]=f[ka+4>>2];f[E>>2]=f[j>>2];f[F>>2]=f[b>>2];f[g>>2]=f[D>>2];f[e>>2]=f[E>>2];f[d>>2]=f[F>>2];s2(ka,g,e,d)|0;ka=f[a+168>>2]|0;f[G>>2]=f[ka+4>>2];f[H>>2]=f[k>>2];f[I>>2]=f[W>>2];f[g>>2]=f[G>>2];f[e>>2]=f[H>>2];f[d>>2]=f[I>>2];ksa(ka,g,e,d)|0;QO(f[P>>2]|0)}P=f[k>>2]|0;if(P|0){k=f[W>>2]|0;if((k|0)!=(P|0))f[W>>2]=k+(~((k+-8-P|0)>>>3)<<3);O5b(P)}P=f[j>>2]|0;if(P|0){j=f[b>>2]|0;if((j|0)!=(P|0))f[b>>2]=j+(~((j+-4-P|0)>>>2)<<2);O5b(P)}P=f[i>>2]|0;if(P|0){i=f[V>>2]|0;if((i|0)!=(P|0))f[V>>2]=i+(~((i+-16-P|0)>>>4)<<4);O5b(P)}}if(!(f[h+4>>2]|0)){u=c;return}u=c;return}function ksa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=e+(h>>3<<3)|0;i=f[c>>2]|0;j=f[d>>2]|0;d=j-i|0;k=d>>3;l=j;if((d|0)<=0){m=b;return m|0}d=a+8|0;n=f[d>>2]|0;o=a+4|0;q=f[o>>2]|0;r=q;if((k|0)<=(n-r>>3|0)){s=b;t=r-s|0;u=t>>3;if((k|0)>(u|0)){v=i+(u<<3)|0;u=v;if((v|0)==(l|0))w=q;else{x=l+-8-u|0;y=v;v=q;while(1){p[v>>3]=+p[y>>3];y=y+8|0;if((y|0)==(l|0))break;else v=v+8|0}v=q+((x>>>3)+1<<3)|0;f[o>>2]=v;w=v}if((t|0)>0){z=u;A=w}else{m=b;return m|0}}else{z=j;A=q}j=A-(b+(k<<3))|0;w=j>>3;u=b+(w<<3)|0;if(u>>>0<q>>>0){t=(q+(0-w<<3)+~s|0)>>>3;s=u;u=A;while(1){p[u>>3]=+p[s>>3];s=s+8|0;if(s>>>0>=q>>>0)break;else u=u+8|0}f[o>>2]=A+(t+1<<3)}if(!w)B=i;else{Xac(A+(0-w<<3)|0,b|0,j|0)|0;B=f[c>>2]|0}c=z-B|0;if(!c){m=b;return m|0}Xac(b|0,B|0,c|0)|0;m=b;return m|0}c=(r-g>>3)+k|0;if(c>>>0>536870911)c4b(a);k=n-g|0;g=k>>2;n=k>>3>>>0<268435455?(g>>>0<c>>>0?c:g):536870911;g=b;c=h>>3;do if(n)if(n>>>0>536870911){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{C=L5b(n<<3)|0;break}else C=0;while(0);k=C+(c<<3)|0;B=C+(n<<3)|0;n=i;if((n|0)==(l|0))D=k;else{C=((l+-8-i|0)>>>3)+1|0;i=n;n=k;while(1){p[n>>3]=+p[i>>3];i=i+8|0;if((i|0)==(l|0))break;else n=n+8|0}D=k+(C<<3)|0}C=k+(0-c<<3)|0;if((h|0)>0)Vac(C|0,e|0,h|0)|0;h=r-g|0;if((h|0)>0){Vac(D|0,b|0,h|0)|0;E=D+(h>>>3<<3)|0}else E=D;f[a>>2]=C;f[o>>2]=E;f[d>>2]=B;if(!e){m=k;return m|0}O5b(e);m=k;return m|0}function lsa(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=l|0;var m=0,n=0,o=0;m=u;u=u+16|0;n=m;dQ(n,104448);o=L5b(48)|0;FY(o);f[o>>2]=104476;f[o+4>>2]=g;p[o+8>>3]=e;b[o+16>>0]=0;f[o+20>>2]=h;f[o+24>>2]=i;f[o+28>>2]=j;p[o+32>>3]=k;f[o+40>>2]=l;l=L5b(16)|0;j=l+4|0;f[j>>2]=1;f[l>>2]=104588;f[l+8>>2]=o;f[j>>2]=(f[j>>2]|0)+1;i=f[j>>2]|0;f[j>>2]=i+-1;if((i|0)==1)bi[f[(f[l>>2]|0)+8>>2]&2047](l);th[f[(f[o>>2]|0)+32>>2]&511](o,a,c,d);d=f[j>>2]|0;f[j>>2]=d+-1;if((d|0)==1)bi[f[(f[l>>2]|0)+8>>2]&2047](l);if(!(f[n+4>>2]|0)){u=m;return}u=m;return}function msa(a){a=a|0;O5b(a);return}function nsa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function osa(a){a=a|0;xY(a);O5b(a);return}function psa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0.0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0.0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0.0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0.0,ud=0.0,vd=0.0,wd=0,xd=0.0,yd=0.0,zd=0.0,Ad=0,Bd=0,Cd=0,Dd=0.0,Ed=0,Fd=0.0,Gd=0.0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0,Sd=0.0,Td=0.0,Ud=0,Vd=0.0,Wd=0.0,Xd=0.0,Yd=0.0,Zd=0.0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0.0,fe=0,ge=0,he=0,ie=0,je=0;g=u;u=u+7040|0;h=g+2128|0;i=g+5968|0;j=g+1064|0;k=g;l=g+4904|0;m=g+3840|0;o=g+3808|0;q=g+3752|0;r=g+3696|0;s=g+3688|0;t=g+3624|0;v=g+3560|0;w=g+3504|0;x=g+3832|0;y=g+3448|0;z=g+3824|0;A=g+3816|0;B=g+3336|0;C=g+3280|0;D=g+3224|0;E=g+3680|0;F=g+3616|0;dQ(o,104600);do if((yM(c)|0)==65536){G=f[c+4>>2]|0;f[q>>2]=f[G>>2];H=q+4|0;I=G+4|0;f[H>>2]=f[I>>2];J=q+8|0;f[J>>2]=f[G+8>>2];f[q+12>>2]=f[G+12>>2];f[q+16>>2]=f[G+16>>2];f[q+20>>2]=f[G+20>>2];f[q+24>>2]=f[G+24>>2];f[q+28>>2]=f[G+28>>2];f[q+32>>2]=f[G+32>>2];K=f[G+36>>2]|0;f[q+36>>2]=K;f[q+40>>2]=J;J=q+48|0;L=q+44|0;f[L>>2]=J;f[J>>2]=0;f[q+52>>2]=0;if(K|0){J=K+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[I>>2]|0)<3){I=f[G+44>>2]|0;J=f[L>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];break}else{f[H>>2]=0;jL(q,G);break}}else yL(q,c,-1);while(0);do if((yM(d)|0)==65536){c=f[d+4>>2]|0;f[r>>2]=f[c>>2];G=r+4|0;H=c+4|0;f[G>>2]=f[H>>2];I=r+8|0;f[I>>2]=f[c+8>>2];f[r+12>>2]=f[c+12>>2];f[r+16>>2]=f[c+16>>2];f[r+20>>2]=f[c+20>>2];f[r+24>>2]=f[c+24>>2];f[r+28>>2]=f[c+28>>2];f[r+32>>2]=f[c+32>>2];J=f[c+36>>2]|0;f[r+36>>2]=J;L=r+40|0;f[L>>2]=I;I=r+48|0;K=r+44|0;f[K>>2]=I;f[I>>2]=0;f[r+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[H>>2]|0)<3){H=f[c+44>>2]|0;I=f[K>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2];M=L;break}else{f[G>>2]=0;jL(r,c);M=L;break}}else{yL(r,d,-1);M=r+40|0}while(0);f[s>>2]=q;f[s+4>>2]=r;f[t>>2]=1124007936;d=t+4|0;L=t+8|0;c=t+40|0;G=d;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[c>>2]=L;I=t+48|0;K=t+44|0;f[K>>2]=I;f[I>>2]=0;f[t+52>>2]=0;f[v>>2]=1124007936;J=v+4|0;N=v+8|0;O=v+40|0;G=J;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[O>>2]=N;P=v+48|0;Q=v+44|0;f[Q>>2]=P;f[P>>2]=0;f[v+52>>2]=0;f[w>>2]=1124007936;R=w+4|0;S=w+8|0;T=w+40|0;G=R;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[T>>2]=S;S=w+48|0;U=w+44|0;f[U>>2]=S;f[S>>2]=0;f[w+52>>2]=0;W=f[a+4>>2]|0;X=q+40|0;Z=f[X>>2]|0;_=f[Z+4>>2]|0;$=f[Z>>2]|0;Z=f[M>>2]|0;if(((($|0)==(f[Z>>2]|0)?(_|0)==(f[Z+4>>2]|0):0)?(Z=(f[q>>2]|0)>>>3&511,(Z|0)==0?(Z|0)==((f[r>>2]|0)>>>3&511|0):0):0)?+p[a+8>>3]<1.0:0){aa=_;ba=$}else{f[h>>2]=0;f[h+4>>2]=0;G=aD(h,110)|0;ca=358460;H=G+110|0;do{b[G>>0]=b[ca>>0]|0;G=G+1|0;ca=ca+1|0}while((G|0)<(H|0));bO(-215,h,359852,358571,1114);bD(h);$=f[X>>2]|0;aa=f[$+4>>2]|0;ba=f[$>>2]|0}f[x>>2]=aa;f[x+4>>2]=ba;vM(e,x,13,-1,0,0);do if((yM(e)|0)==65536){x=f[e+4>>2]|0;f[y>>2]=f[x>>2];ba=y+4|0;aa=x+4|0;f[ba>>2]=f[aa>>2];$=y+8|0;f[$>>2]=f[x+8>>2];f[y+12>>2]=f[x+12>>2];f[y+16>>2]=f[x+16>>2];f[y+20>>2]=f[x+20>>2];f[y+24>>2]=f[x+24>>2];f[y+28>>2]=f[x+28>>2];f[y+32>>2]=f[x+32>>2];_=f[x+36>>2]|0;f[y+36>>2]=_;f[y+40>>2]=$;$=y+48|0;Z=y+44|0;f[Z>>2]=$;f[$>>2]=0;f[y+52>>2]=0;if(_|0){$=_+12|0;f[$>>2]=(f[$>>2]|0)+1}if((f[aa>>2]|0)<3){aa=f[x+44>>2]|0;$=f[Z>>2]|0;f[$>>2]=f[aa>>2];f[$+4>>2]=f[aa+4>>2];break}else{f[ba>>2]=0;jL(y,x);break}}else yL(y,e,-1);while(0);if((W|0)>0){da=+p[a+8>>3];ea=+(f[q+12>>2]|0);fa=+(f[q+8>>2]|0);ga=1.0;e=0;while(1){ga=ga*da;if(ga*ea<32.0|ga*fa<32.0){ha=e;break}x=e+1|0;if((x|0)>=(W|0)){ha=x;break}else e=x}if((ha|0)>-1){ia=ha;ja=30}else ka=y+36|0}else{ia=0;ja=30}if((ja|0)==30){ha=q+12|0;e=q+8|0;W=v+12|0;x=v+16|0;ba=i+4|0;aa=t+16|0;$=a+40|0;Z=h+8|0;_=h+12|0;la=h+4|0;ma=i+8|0;na=i+4|0;oa=z+4|0;pa=h+8|0;qa=h+4|0;ra=C+4|0;sa=C+8|0;ta=C+40|0;ua=C+48|0;va=C+44|0;wa=C+52|0;xa=D+4|0;ya=D+8|0;za=D+40|0;Aa=D+48|0;Ba=D+44|0;Ca=D+52|0;Da=h+8|0;Ea=h+4|0;Fa=h+8|0;Ga=h+12|0;Ha=h+4|0;Ia=i+8|0;Ja=i+4|0;Ka=E+4|0;La=h+8|0;Ma=h+12|0;Na=h+4|0;Oa=i+8|0;Pa=i+4|0;Qa=F+4|0;Ra=a+28|0;Sa=a+32|0;Ta=C+12|0;Ua=l+8|0;Va=l+4|0;Wa=m+8|0;Xa=m+4|0;Ya=h+4|0;Za=h+8|0;_a=h+40|0;$a=h+48|0;ab=h+44|0;bb=h+52|0;cb=i+8|0;db=i+12|0;eb=i+4|0;fb=h+16|0;gb=i+16|0;hb=i+44|0;ib=i+36|0;jb=i+4|0;kb=i+40|0;lb=i+48|0;mb=h+36|0;nb=C+16|0;ob=h+4|0;pb=B+56|0;qb=a+24|0;rb=v+36|0;sb=t+36|0;tb=t+12|0;ub=v+20|0;vb=t+20|0;wb=v+24|0;xb=t+24|0;yb=v+28|0;zb=t+28|0;Ab=v+32|0;Bb=t+32|0;Cb=D+36|0;Db=D+16|0;Eb=C+36|0;Fb=a+20|0;Gb=h+8|0;Hb=h+4|0;Ib=h+8|0;Jb=h+4|0;Kb=i+8|0;Lb=i+4|0;Mb=Kb;Nb=j+8|0;Ob=j+4|0;Pb=k+8|0;Qb=k+4|0;Rb=h+8|0;Sb=h+12|0;Tb=h+4|0;Ub=i+8|0;Vb=i+4|0;Wb=A+4|0;Xb=a+8|0;a=h+8|0;Yb=h+4|0;Zb=y+36|0;_b=y+4|0;$b=y+8|0;ac=y+12|0;bc=y+44|0;cc=y+16|0;dc=y+20|0;ec=y+24|0;fc=y+28|0;gc=y+32|0;hc=B+4|0;ic=B+8|0;jc=B+40|0;kc=B+48|0;lc=B+44|0;mc=B+52|0;nc=B+56|0;oc=B+60|0;pc=B+64|0;qc=B+96|0;rc=B+104|0;sc=B+100|0;tc=B+108|0;uc=B+56|0;vc=B+92|0;wc=B+72|0;xc=B+60|0;yc=B+96|0;zc=B+100|0;Ac=B+104|0;Bc=B+36|0;Cc=B+16|0;Dc=B+4|0;Ec=B+40|0;Fc=B+44|0;Gc=B+48|0;Hc=ia;while(1){ia=(Hc|0)>0;if(ia){fa=+p[Xb>>3];Ic=0;ga=1.0;while(1){ea=ga*fa;Ic=Ic+1|0;if((Ic|0)==(Hc|0)){Jc=ea;break}else ga=ea}}else Jc=1.0;ga=(1.0/Jc+-1.0)*.5;Ic=MVb(ga*5.0)|0|1;Kc=(Ic|0)>3?Ic:3;Ic=MVb(Jc*+(f[ha>>2]|0))|0;Lc=MVb(Jc*+(f[e>>2]|0))|0;do if(ia){if(((f[J>>2]|0)<3?(f[N>>2]|0)==(Lc|0):0)&(f[W>>2]|0)==(Ic|0)?!((f[x>>2]|0)==0?1:(f[v>>2]&4095|0)!=13):0)break;f[i>>2]=Lc;f[ba>>2]=Ic;hL(v,2,i,13)}else{Mc=f[Zb>>2]|0;if(Mc|0){Nc=Mc+12|0;f[Nc>>2]=(f[Nc>>2]|0)+1}Nc=f[rb>>2]|0;if(Nc|0?(Mc=Nc+12|0,Nc=f[Mc>>2]|0,f[Mc>>2]=Nc+-1,(Nc|0)==1):0)kL(v);f[rb>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[J>>2]|0)>0){Nc=f[O>>2]|0;Mc=0;do{f[Nc+(Mc<<2)>>2]=0;Mc=Mc+1|0;Oc=f[J>>2]|0}while((Mc|0)<(Oc|0));f[v>>2]=f[y>>2];if((Oc|0)<3)ja=50;else ja=52}else{f[v>>2]=f[y>>2];ja=50}if((ja|0)==50){ja=0;Mc=f[_b>>2]|0;if((Mc|0)<3){f[J>>2]=Mc;f[N>>2]=f[$b>>2];f[W>>2]=f[ac>>2];Mc=f[bc>>2]|0;Nc=f[Q>>2]|0;f[Nc>>2]=f[Mc>>2];f[Nc+4>>2]=f[Mc+4>>2]}else ja=52}if((ja|0)==52){ja=0;jL(v,y)}f[x>>2]=f[cc>>2];f[ub>>2]=f[dc>>2];f[wb>>2]=f[ec>>2];f[yb>>2]=f[fc>>2];f[Ab>>2]=f[gc>>2];f[rb>>2]=f[Zb>>2]}while(0);if(f[aa>>2]|0){Mc=f[d>>2]|0;if((Mc|0)<3)Pc=Y(f[tb>>2]|0,f[L>>2]|0)|0;else{Nc=f[c>>2]|0;Qc=0;Rc=1;while(1){Sc=Y(f[Nc+(Qc<<2)>>2]|0,Rc)|0;Qc=Qc+1|0;if((Qc|0)==(Mc|0)){Pc=Sc;break}else Rc=Sc}}if(!((Mc|0)==0|(Pc|0)==0)){f[Rb>>2]=0;f[Sb>>2]=0;f[h>>2]=16842752;f[Tb>>2]=t;Rc=Ub;f[Rc>>2]=0;f[Rc+4>>2]=0;f[i>>2]=33619968;f[Vb>>2]=v;f[A>>2]=Ic;f[Wb>>2]=Lc;Lia(h,i,A,0.0,0.0,1);fa=1.0/+p[Xb>>3];Rc=a;f[Rc>>2]=0;f[Rc+4>>2]=0;f[h>>2]=33619968;f[Yb>>2]=v;OJ(v,h,-1,fa,0.0)}else ja=60}else ja=60;do if((ja|0)==60){ja=0;if(!(f[$>>2]&4)){QS(h,Lc,Ic,13);Rc=f[h>>2]|0;th[f[(f[Rc>>2]|0)+12>>2]&511](Rc,h,v,-1);Wi(h);break}else{f[Z>>2]=0;f[_>>2]=0;f[h>>2]=16842752;f[la>>2]=y;Rc=ma;f[Rc>>2]=0;f[Rc+4>>2]=0;f[i>>2]=33619968;f[na>>2]=v;f[z>>2]=Ic;f[oa>>2]=Lc;Lia(h,i,z,0.0,0.0,3);Rc=pa;f[Rc>>2]=0;f[Rc+4>>2]=0;f[h>>2]=33619968;f[qa>>2]=v;OJ(v,h,-1,Jc,0.0);break}}while(0);f[B>>2]=1124007936;G=hc;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[jc>>2]=ic;f[lc>>2]=kc;f[kc>>2]=0;f[mc>>2]=0;f[nc>>2]=1124007936;G=oc;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[qc>>2]=pc;f[sc>>2]=rc;f[rc>>2]=0;f[tc>>2]=0;f[C>>2]=1124007936;G=ra;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[ta>>2]=sa;f[va>>2]=ua;f[ua>>2]=0;f[wa>>2]=0;f[D>>2]=1124007936;G=xa;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[za>>2]=ya;f[Ba>>2]=Aa;f[Aa>>2]=0;f[Ca>>2]=0;Mc=0;do{Rc=f[s+(Mc<<2)>>2]|0;Qc=Da;f[Qc>>2]=0;f[Qc+4>>2]=0;f[h>>2]=33619968;f[Ea>>2]=w;OJ(Rc,h,5,1.0,0.0);f[Fa>>2]=0;f[Ga>>2]=0;f[h>>2]=16842752;f[Ha>>2]=w;Rc=Ia;f[Rc>>2]=0;f[Rc+4>>2]=0;f[i>>2]=33619968;f[Ja>>2]=w;f[E>>2]=Kc;f[Ka>>2]=Kc;F7(h,i,E,ga,ga,4);f[La>>2]=0;f[Ma>>2]=0;f[h>>2]=16842752;f[Na>>2]=w;Rc=Oa;f[Rc>>2]=0;f[Rc+4>>2]=0;f[i>>2]=33619968;f[Pa>>2]=C;f[F>>2]=Ic;f[Qa>>2]=Lc;Lia(h,i,F,1.0,0.0,1);Rc=B+(Mc*56|0)|0;Qc=f[Ra>>2]|0;fa=+p[Sa>>3];if((f[C>>2]&4095|0)!=5){f[h>>2]=0;f[ob>>2]=0;G=aD(h,55)|0;ca=358643;H=G+55|0;do{b[G>>0]=b[ca>>0]|0;G=G+1|0;ca=ca+1|0}while((G|0)<(H|0));bO(-215,h,358699,358571,120);bD(h)}Nc=f[Ta>>2]|0;Sc=f[sa>>2]|0;Tc=(Qc*6|0)+3|0;f[l>>2]=Ua;f[Va>>2]=Tc;if(Tc>>>0>264){Uc=N5b(Tc>>>0>1073741823?-1:Tc<<2)|0;f[l>>2]=Uc;Vc=Uc}else Vc=Ua;Uc=Qc<<1;Tc=(Nc+Uc|0)*3|0;f[m>>2]=Wa;f[Xa>>2]=Tc;if(Tc>>>0>264){Wc=N5b(Tc>>>0>1073741823?-1:Tc<<2)|0;f[m>>2]=Wc;Xc=Wc}else Xc=Wa;Wc=Vc+(Qc<<2)|0;Tc=Wc+(Uc<<2)+4|0;Yc=Tc+(Uc<<2)+4|0;Uc=Qc*3|0;Zc=Xc+(Uc<<2)|0;ea=fa<1.1920928955078125e-07?+(Qc|0)*.3:fa;_c=0-Qc|0;$c=(Qc|0)<(_c|0);if(!$c){da=ea*(ea*2.0);ad=_c;ea=0.0;while(1){bd=+V(+(+(Y(ad,0-ad|0)|0)/da));n[Wc+(ad<<2)>>2]=bd;ea=ea+bd;if((ad|0)>=(Qc|0))break;else ad=ad+1|0}da=1.0/ea;ad=_c;while(1){cd=Wc+(ad<<2)|0;fa=da*+n[cd>>2];n[cd>>2]=fa;n[Tc+(ad<<2)>>2]=+(ad|0)*fa;bd=+(Y(ad,ad)|0)*fa;n[Yc+(ad<<2)>>2]=bd;if((ad|0)<(Qc|0))ad=ad+1|0;else break}}f[h>>2]=1124007936;G=Ya;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[_a>>2]=Za;f[ab>>2]=$a;f[$a>>2]=0;f[bb>>2]=0;f[i>>2]=6;f[ba>>2]=6;hL(h,2,i,6);p[j>>3]=0.0;f[i>>2]=-1056833530;f[eb>>2]=j;f[cb>>2]=1;f[db>>2]=1;VP(h,i,UM()|0)|0;if($c){ad=f[fb>>2]|0;dd=ad;ed=ad}else{ad=f[fb>>2]|0;cd=f[f[ab>>2]>>2]|0;fd=ad+cd+8|0;gd=ad+(cd*3|0)+24|0;hd=ad+(cd*5|0)+40|0;cd=_c;while(1){da=+n[Wc+(cd<<2)>>2];ea=+(cd|0);id=_c;while(1){bd=da*+n[Wc+(id<<2)>>2];p[ad>>3]=+p[ad>>3]+bd;fa=+(id|0);jd=fa*(fa*bd);p[fd>>3]=+p[fd>>3]+jd;p[gd>>3]=+p[gd>>3]+fa*(fa*jd);p[hd>>3]=ea*(ea*jd)+ +p[hd>>3];if((id|0)<(Qc|0))id=id+1|0;else break}if((cd|0)<(Qc|0))cd=cd+1|0;else{dd=ad;ed=ad;break}}}ad=f[f[ab>>2]>>2]|0;ea=+p[dd+ad+8>>3];cd=dd+(ad<<2)|0;p[cd>>3]=ea;hd=dd+(ad*3|0)|0;p[hd>>3]=ea;p[ed+32>>3]=ea;p[ed+24>>3]=ea;p[ed+(ad<<1)+16>>3]=ea;p[cd+32>>3]=+p[hd+24>>3];ea=+p[dd+(ad*5|0)+40>>3];p[cd+24>>3]=ea;p[hd+32>>3]=ea;OS(k,h,3);LZ(i,k);Wi(k);hd=f[gb>>2]|0;cd=f[f[hb>>2]>>2]|0;ea=+p[hd+cd+8>>3];da=+p[hd+24>>3];jd=+p[hd+(cd*3|0)+24>>3];fa=+p[hd+(cd*5|0)+40>>3];cd=f[ib>>2]|0;if(cd|0?(hd=cd+12|0,cd=f[hd>>2]|0,f[hd>>2]=cd+-1,(cd|0)==1):0)kL(i);f[ib>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[jb>>2]|0)>0){cd=f[kb>>2]|0;hd=0;do{f[cd+(hd<<2)>>2]=0;hd=hd+1|0}while((hd|0)<(f[jb>>2]|0))}hd=f[hb>>2]|0;if((hd|0)!=(lb|0))UC(hd);hd=f[mb>>2]|0;do if(hd|0){cd=hd+12|0;ad=f[cd>>2]|0;f[cd>>2]=ad+-1;if((ad|0)!=1)break;kL(h)}while(0);f[mb>>2]=0;f[fb>>2]=0;f[fb+4>>2]=0;f[fb+8>>2]=0;f[fb+12>>2]=0;if((f[Ya>>2]|0)>0){hd=f[_a>>2]|0;ad=0;do{f[hd+(ad<<2)>>2]=0;ad=ad+1|0}while((ad|0)<(f[Ya>>2]|0))}ad=f[ab>>2]|0;if((ad|0)!=($a|0))UC(ad);do if((f[B+(Mc*56|0)+4>>2]|0)<3){if((f[B+(Mc*56|0)+8>>2]|0)!=(Sc|0)){ja=103;break}if((f[B+(Mc*56|0)+12>>2]|0)!=(Nc|0)){ja=103;break}if((f[Rc>>2]&4095|0)!=37){ja=103;break}if(!(f[B+(Mc*56|0)+16>>2]|0))ja=103}else ja=103;while(0);if((ja|0)==103){ja=0;f[i>>2]=Sc;f[ba>>2]=Nc;hL(Rc,2,i,37)}if((Sc|0)>0){ad=f[nb>>2]|0;hd=f[f[va>>2]>>2]|0;cd=f[B+(Mc*56|0)+16>>2]|0;gd=f[f[B+(Mc*56|0)+44>>2]>>2]|0;fd=(Nc|0)>0;_c=(Qc|0)<1;$c=(Qc|0)>0;id=Nc*3|0;kd=Sc+-1|0;ld=Qc+1|0;md=_c|fd^1;nd=0;do{bd=+n[Wc>>2];od=ad+(Y(nd,hd)|0)|0;pd=cd+(Y(nd,gd)|0)|0;do if(fd){qd=0;do{rd=qd*3|0;n[Zc+(rd<<2)>>2]=bd*+n[od+(qd<<2)>>2];n[Zc+(rd+2<<2)>>2]=0.0;n[Zc+(rd+1<<2)>>2]=0.0;qd=qd+1|0}while((qd|0)!=(Nc|0));if(md)break;else sd=1;do{td=+n[Wc+(sd<<2)>>2];ud=+n[Tc+(sd<<2)>>2];vd=+n[Yc+(sd<<2)>>2];qd=nd-sd|0;rd=ad+(Y((qd|0)>0?qd:0,hd)|0)|0;qd=sd+nd|0;wd=ad+(Y((kd|0)<(qd|0)?kd:qd,hd)|0)|0;qd=0;do{xd=+n[rd+(qd<<2)>>2];yd=+n[wd+(qd<<2)>>2];zd=xd+yd;Ad=qd*3|0;Bd=Zc+(Ad<<2)|0;Cd=Zc+(Ad+1<<2)|0;Dd=+n[Cd>>2]+ud*(yd-xd);Ed=Zc+(Ad+2<<2)|0;xd=vd*zd+ +n[Ed>>2];n[Bd>>2]=+n[Bd>>2]+td*zd;n[Cd>>2]=Dd;n[Ed>>2]=xd;qd=qd+1|0}while((qd|0)!=(Nc|0));sd=sd+1|0}while((sd|0)!=(ld|0))}while(0);if($c){od=0;do{f[Zc+(~od<<2)>>2]=f[Zc+(2-od<<2)>>2];qd=od+id|0;f[Zc+(qd<<2)>>2]=f[Zc+(qd+-3<<2)>>2];od=od+1|0}while((od|0)<(Uc|0))}a:do if(fd){od=0;td=bd;while(1){qd=od*3|0;vd=td*+n[Zc+(qd<<2)>>2];ud=td*+n[Zc+(qd+1<<2)>>2];xd=td*+n[Zc+(qd+2<<2)>>2];if(_c){Fd=0.0;Gd=xd;Hd=0.0;Id=ud;Jd=0.0;Kd=vd}else{Dd=0.0;zd=xd;xd=0.0;yd=ud;ud=0.0;Ld=vd;qd=1;while(1){wd=(qd+od|0)*3|0;vd=+n[Zc+(wd<<2)>>2];rd=(od-qd|0)*3|0;Md=+n[Zc+(rd<<2)>>2];Nd=vd+Md;Od=+n[Wc+(qd<<2)>>2];Pd=Ld+Nd*Od;Qd=xd+Nd*+n[Yc+(qd<<2)>>2];Nd=+n[Tc+(qd<<2)>>2];Rd=ud+(vd-Md)*Nd;Md=+n[Zc+(wd+1<<2)>>2];vd=+n[Zc+(rd+1<<2)>>2];Sd=yd+Od*(Md+vd);Td=Dd+Nd*(Md-vd);vd=zd+Od*(+n[Zc+(wd+2<<2)>>2]+ +n[Zc+(rd+2<<2)>>2]);qd=qd+1|0;if((qd|0)==(ld|0)){Fd=Td;Gd=vd;Hd=Qd;Id=Sd;Jd=Rd;Kd=Pd;break}else{Dd=Td;zd=vd;xd=Qd;yd=Sd;ud=Rd;Ld=Pd}}}qd=od*5|0;n[pd+(qd+1<<2)>>2]=ea*Jd;n[pd+(qd<<2)>>2]=ea*Id;Ld=da*Kd;n[pd+(qd+3<<2)>>2]=Ld+jd*Hd;n[pd+(qd+2<<2)>>2]=Ld+jd*Gd;n[pd+(qd+4<<2)>>2]=fa*Fd;qd=od+1|0;if((qd|0)==(Nc|0))break a;od=qd;td=+n[Wc>>2]}}while(0);nd=nd+1|0}while((nd|0)!=(Sc|0))}Sc=f[m>>2]|0;if((Sc|0)!=(Wa|0)){if(Sc|0)P5b(Sc);f[m>>2]=Wa;f[Xa>>2]=264}Sc=f[l>>2]|0;if((Sc|0)!=(Ua|0)){if(Sc|0)P5b(Sc);f[l>>2]=Ua;f[Va>>2]=264}Mc=Mc+1|0}while((Mc|0)<2);Hsa(B,pb,v,D,0,f[N>>2]|0);Mc=f[qb>>2]|0;if((Mc|0)>0){Lc=0;Ic=Mc;do{Mc=f[Fb>>2]|0;Kc=(Lc|0)<(Ic+-1|0);Sc=f[W>>2]|0;nd=f[N>>2]|0;Wc=(Mc|0)/2|0;Nc=1024/(Sc|0)|0;ld=(Nc|0)<(Mc|0)?Mc:Nc;if(!(f[$>>2]&256)){ga=1.0/+(Y(Mc,Mc)|0);Nc=(((Wc<<1)+Sc|0)*5|0)+10|0;f[h>>2]=Gb;f[Hb>>2]=Nc;if(Nc>>>0>136){Zc=N5b(Nc>>>0>536870911?-1:Nc<<3)|0;f[h>>2]=Zc;Ud=Zc}else Ud=Gb;Zc=(Wc*5|0)+5|0;Nc=Ud+(Zc<<3)|0;Tc=f[Db>>2]|0;Yc=Sc*5|0;_c=(Sc|0)>0;if(_c){fa=+(Wc+2|0);fd=0;do{p[Nc+(fd<<3)>>3]=fa*+n[Tc+(fd<<2)>>2];fd=fd+1|0}while((fd|0)<(Yc|0))}fd=(Mc|0)>3;if(fd?(Uc=nd+-1|0,id=f[f[Ba>>2]>>2]|0,_c):0){$c=1;do{hd=Tc+(Y((Uc|0)<($c|0)?Uc:$c,id)|0)|0;kd=0;do{ad=Nc+(kd<<3)|0;p[ad>>3]=+p[ad>>3]+ +n[hd+(kd<<2)>>2];kd=kd+1|0}while((kd|0)<(Yc|0));$c=$c+1|0}while(($c|0)<(Wc|0))}if((nd|0)>0){$c=nd+-1|0;id=(Zc|0)>0;fa=+(Wc+2|0);Uc=Nc+8|0;kd=Nc+16|0;hd=Nc+24|0;ad=Nc+32|0;md=0;gd=Tc;cd=0;while(1){Qc=(f[x>>2]|0)+(Y(f[f[Q>>2]>>2]|0,cd)|0)|0;Rc=cd-Wc+-1|0;pd=f[f[Ba>>2]>>2]|0;od=gd+(Y(pd,(Rc|0)>0?Rc:0)|0)|0;Rc=cd+Wc|0;qd=gd+(Y(pd,($c|0)<(Rc|0)?$c:Rc)|0)|0;if(_c){Rc=0;do{pd=Nc+(Rc<<3)|0;p[pd>>3]=+p[pd>>3]+(+n[qd+(Rc<<2)>>2]-+n[od+(Rc<<2)>>2]);Rc=Rc+1|0}while((Rc|0)<(Yc|0))}if(id){Rc=0;do{p[Nc+(~Rc<<3)>>3]=+p[Nc+(4-Rc<<3)>>3];od=Rc+Yc|0;p[Nc+(od<<3)>>3]=+p[Nc+(od+-5<<3)>>3];Rc=Rc+1|0}while((Rc|0)!=(Zc|0))}jd=fa*+p[Nc>>3];da=fa*+p[Uc>>3];ea=fa*+p[kd>>3];bd=fa*+p[hd>>3];td=fa*+p[ad>>3];if(fd){Ld=jd;ud=da;yd=ea;xd=td;zd=bd;Rc=1;while(1){od=Rc*5|0;Dd=Ld+ +p[Nc+(od<<3)>>3];Pd=ud+ +p[Nc+(od+1<<3)>>3];Rd=yd+ +p[Nc+(od+2<<3)>>3];Sd=zd+ +p[Nc+(od+3<<3)>>3];Qd=xd+ +p[Nc+(od+4<<3)>>3];Rc=Rc+1|0;if((Rc|0)>=(Wc|0)){Vd=Dd;Wd=Pd;Xd=Rd;Yd=Qd;Zd=Sd;break}else{Ld=Dd;ud=Pd;yd=Rd;xd=Qd;zd=Sd}}}else{Vd=jd;Wd=da;Xd=ea;Yd=td;Zd=bd}if(_c){zd=Vd;xd=Wd;yd=Xd;ud=Yd;Ld=Zd;Rc=0;do{od=(Rc+Wc|0)*5|0;qd=(Rc-Wc|0)*5|0;zd=zd+(+p[Nc+(od<<3)>>3]-+p[Nc+(qd+-5<<3)>>3]);xd=xd+(+p[Nc+(od+1<<3)>>3]-+p[Nc+(qd+-4<<3)>>3]);yd=yd+(+p[Nc+(od+2<<3)>>3]-+p[Nc+(qd+-3<<3)>>3]);Ld=Ld+(+p[Nc+(od+3<<3)>>3]-+p[Nc+(qd+-2<<3)>>3]);ud=ud+(+p[Nc+(od+4<<3)>>3]-+p[Nc+(qd+-1<<3)>>3]);Sd=ga*zd;Qd=ga*xd;Rd=ga*yd;Pd=ga*Ld;Dd=ga*ud;vd=1.0/(Sd*Rd-Qd*Qd+.001);qd=Rc<<1;n[Qc+(qd<<2)>>2]=vd*(Sd*Dd-Qd*Pd);n[Qc+((qd|1)<<2)>>2]=vd*(Rd*Pd-Qd*Dd);Rc=Rc+1|0}while((Rc|0)!=(Sc|0))}Rc=(cd|0)==($c|0)?nd:cd-Mc|0;do if(Kc){if((Rc|0)!=(nd|0)&(Rc|0)<(md+ld|0)){_d=md;break}Hsa(B,pb,v,D,md,Rc);_d=Rc}else _d=md;while(0);Rc=cd+1|0;if((Rc|0)>=(nd|0))break;md=_d;gd=f[Db>>2]|0;cd=Rc}$d=f[h>>2]|0}else $d=Ud;if(($d|0)!=(Gb|0)){if($d|0)P5b($d);f[h>>2]=Gb;f[Hb>>2]=136}}else{ga=+(Wc|0)*.3;cd=Wc<<1;gd=((cd+Sc|0)*5|0)+26|0;f[h>>2]=Ib;f[Jb>>2]=gd;if(gd>>>0>264){md=N5b(gd>>>0>1073741823?-1:gd<<2)|0;f[h>>2]=md;ae=md}else ae=Ib;md=Sc*5|0;gd=md+16|0;f[i>>2]=Kb;f[Lb>>2]=gd;if(gd>>>0>264){$c=N5b(gd>>>0>1073741823?-1:gd<<2)|0;f[i>>2]=$c;be=$c}else be=Mb;$c=Wc*5|0;gd=$c+21|0;f[j>>2]=Nb;f[Ob>>2]=gd;if(gd>>>0>264){Nc=N5b(gd>>>0>1073741823?-1:gd<<2)|0;f[j>>2]=Nc;ce=Nc}else ce=Nb;Nc=cd|1;f[k>>2]=Pb;f[Qb>>2]=Nc;if(Nc>>>0>264){cd=N5b(Nc>>>0>1073741823?-1:Nc<<2)|0;f[k>>2]=cd;de=cd}else de=Pb;cd=ae+($c+5<<2)+15&-16;Nc=be+15&-16;n[ce>>2]=1.0;gd=(Mc|0)<2;if(gd)ee=1.0;else{fa=ga*(ga*2.0);_c=1;ga=1.0;while(1){ud=+V(+(+(Y(_c,0-_c|0)|0)/fa));n[ce+(_c<<2)>>2]=ud;Ld=ga+ud*2.0;if((_c|0)<(Wc|0)){_c=_c+1|0;ga=Ld}else{ee=Ld;break}}}ga=1.0/ee;_c=(Mc|0)<-1;if(!_c){fd=0;while(1){ad=ce+(fd<<2)|0;n[ad>>2]=ga*+n[ad>>2];if((fd|0)<(Wc|0))fd=fd+1|0;else break}}if((nd|0)>0){fd=(Sc|0)>0;ad=de+(Wc<<2)|0;hd=($c|0)>0;kd=nd+-1|0;Uc=0;Zc=0;while(1){Yc=(f[x>>2]|0)+(Y(f[f[Q>>2]>>2]|0,Uc)|0)|0;if(!_c){id=f[Db>>2]|0;Tc=f[f[Ba>>2]>>2]|0;Rc=0;while(1){Qc=Uc-Rc|0;qd=id+(Y((Qc|0)>0?Qc:0,Tc)|0)|0;f[de+(Wc-Rc<<2)>>2]=qd;qd=Rc+Uc|0;Qc=id+(Y((kd|0)<(qd|0)?kd:qd,Tc)|0)|0;f[de+(Rc+Wc<<2)>>2]=Qc;if((Wc|0)>(Rc|0))Rc=Rc+1|0;else break}}b:do if(fd){Rc=f[ad>>2]|0;if(gd){Tc=0;while(1){n[cd+(Tc<<2)>>2]=+n[Rc+(Tc<<2)>>2]*+n[ce>>2];Tc=Tc+1|0;if((Tc|0)>=(md|0))break b}}else fe=0;do{ga=+n[Rc+(fe<<2)>>2]*+n[ce>>2];Tc=1;while(1){ga=ga+(+n[(f[de+(Tc+Wc<<2)>>2]|0)+(fe<<2)>>2]+ +n[(f[de+(Wc-Tc<<2)>>2]|0)+(fe<<2)>>2])*+n[ce+(Tc<<2)>>2];if((Wc|0)<=(Tc|0))break;else Tc=Tc+1|0}n[cd+(fe<<2)>>2]=ga;fe=fe+1|0}while((fe|0)<(md|0))}while(0);if(hd){Rc=0;do{f[cd+(~Rc<<2)>>2]=f[cd+(4-Rc<<2)>>2];Tc=Rc+md|0;f[cd+(Tc<<2)>>2]=f[cd+(Tc+-5<<2)>>2];Rc=Rc+1|0}while((Rc|0)!=($c|0))}if(fd){if(gd){Rc=0;do{n[Nc+(Rc<<2)>>2]=+n[cd+(Rc<<2)>>2]*+n[ce>>2];Rc=Rc+1|0}while((Rc|0)<(md|0));ge=0}else{Rc=0;do{fa=+n[cd+(Rc<<2)>>2]*+n[ce>>2];Tc=1;while(1){id=Tc*5|0;fa=fa+ +n[ce+(Tc<<2)>>2]*(+n[cd+(Rc-id<<2)>>2]+ +n[cd+(id+Rc<<2)>>2]);if((Tc|0)>=(Wc|0))break;else Tc=Tc+1|0}n[Nc+(Rc<<2)>>2]=fa;Rc=Rc+1|0}while((Rc|0)<(md|0));ge=0}do{Rc=ge*5|0;Ld=+n[Nc+(Rc<<2)>>2];ud=+n[Nc+(Rc+1<<2)>>2];yd=+n[Nc+(Rc+2<<2)>>2];xd=+n[Nc+(Rc+3<<2)>>2];zd=+n[Nc+(Rc+4<<2)>>2];bd=1.0/(Ld*yd-ud*ud+.001);Rc=ge<<1;n[Yc+(Rc<<2)>>2]=(Ld*zd-ud*xd)*bd;n[Yc+((Rc|1)<<2)>>2]=(yd*xd-ud*zd)*bd;ge=ge+1|0}while((ge|0)!=(Sc|0))}Yc=(Uc|0)==(kd|0)?nd:Uc-Mc|0;do if(Kc){if((Yc|0)!=(nd|0)&(Yc|0)<(Zc+ld|0)){he=Zc;break}Hsa(B,pb,v,D,Zc,Yc);he=Yc}else he=Zc;while(0);Uc=Uc+1|0;if((Uc|0)>=(nd|0))break;else Zc=he}ie=f[k>>2]|0}else ie=de;if((ie|0)!=(Pb|0)){if(ie|0)P5b(ie);f[k>>2]=Pb;f[Qb>>2]=264}Zc=f[j>>2]|0;if((Zc|0)!=(Nb|0)){if(Zc|0)P5b(Zc);f[j>>2]=Nb;f[Ob>>2]=264}Zc=f[i>>2]|0;if((Zc|0)!=(Kb|0)){if(Zc|0)P5b(Zc);f[i>>2]=Kb;f[Lb>>2]=264}Zc=f[h>>2]|0;if((Zc|0)!=(Ib|0)){if(Zc|0)P5b(Zc);f[h>>2]=Ib;f[Jb>>2]=264}}Lc=Lc+1|0;Ic=f[qb>>2]|0}while((Lc|0)<(Ic|0))}Ic=f[rb>>2]|0;if(Ic|0){Lc=Ic+12|0;f[Lc>>2]=(f[Lc>>2]|0)+1}Lc=f[sb>>2]|0;if(Lc|0?(Ic=Lc+12|0,Lc=f[Ic>>2]|0,f[Ic>>2]=Lc+-1,(Lc|0)==1):0)kL(t);f[sb>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[d>>2]|0)>0){Lc=f[c>>2]|0;Ic=0;do{f[Lc+(Ic<<2)>>2]=0;Ic=Ic+1|0;je=f[d>>2]|0}while((Ic|0)<(je|0));f[t>>2]=f[v>>2];if((je|0)<3)ja=228;else ja=230}else{f[t>>2]=f[v>>2];ja=228}if((ja|0)==228){ja=0;Ic=f[J>>2]|0;if((Ic|0)<3){f[d>>2]=Ic;f[L>>2]=f[N>>2];f[tb>>2]=f[W>>2];Ic=f[Q>>2]|0;Lc=f[K>>2]|0;f[Lc>>2]=f[Ic>>2];f[Lc+4>>2]=f[Ic+4>>2]}else ja=230}if((ja|0)==230){ja=0;jL(t,v)}f[aa>>2]=f[x>>2];f[vb>>2]=f[ub>>2];f[xb>>2]=f[wb>>2];f[zb>>2]=f[yb>>2];f[Bb>>2]=f[Ab>>2];f[sb>>2]=f[rb>>2];Ic=f[Cb>>2]|0;if(Ic|0?(Lc=Ic+12|0,Ic=f[Lc>>2]|0,f[Lc>>2]=Ic+-1,(Ic|0)==1):0)kL(D);f[Cb>>2]=0;f[Db>>2]=0;f[Db+4>>2]=0;f[Db+8>>2]=0;f[Db+12>>2]=0;if((f[xa>>2]|0)>0){Ic=f[za>>2]|0;Lc=0;do{f[Ic+(Lc<<2)>>2]=0;Lc=Lc+1|0}while((Lc|0)<(f[xa>>2]|0))}Lc=f[Ba>>2]|0;if((Lc|0)!=(Aa|0))UC(Lc);Lc=f[Eb>>2]|0;if(Lc|0?(Ic=Lc+12|0,Lc=f[Ic>>2]|0,f[Ic>>2]=Lc+-1,(Lc|0)==1):0)kL(C);f[Eb>>2]=0;f[nb>>2]=0;f[nb+4>>2]=0;f[nb+8>>2]=0;f[nb+12>>2]=0;if((f[ra>>2]|0)>0){Lc=f[ta>>2]|0;Ic=0;do{f[Lc+(Ic<<2)>>2]=0;Ic=Ic+1|0}while((Ic|0)<(f[ra>>2]|0))}Ic=f[va>>2]|0;if((Ic|0)!=(ua|0))UC(Ic);Ic=f[vc>>2]|0;do if(Ic|0){Lc=Ic+12|0;Zc=f[Lc>>2]|0;f[Lc>>2]=Zc+-1;if((Zc|0)!=1)break;kL(uc)}while(0);f[vc>>2]=0;f[wc>>2]=0;f[wc+4>>2]=0;f[wc+8>>2]=0;f[wc+12>>2]=0;if((f[xc>>2]|0)>0){Ic=f[yc>>2]|0;Zc=0;do{f[Ic+(Zc<<2)>>2]=0;Zc=Zc+1|0}while((Zc|0)<(f[xc>>2]|0))}Zc=f[zc>>2]|0;if((Zc|0)!=(Ac|0))UC(Zc);Zc=f[Bc>>2]|0;do if(Zc|0){Ic=Zc+12|0;Lc=f[Ic>>2]|0;f[Ic>>2]=Lc+-1;if((Lc|0)!=1)break;kL(B)}while(0);f[Bc>>2]=0;f[Cc>>2]=0;f[Cc+4>>2]=0;f[Cc+8>>2]=0;f[Cc+12>>2]=0;if((f[Dc>>2]|0)>0){Zc=f[Ec>>2]|0;Lc=0;do{f[Zc+(Lc<<2)>>2]=0;Lc=Lc+1|0}while((Lc|0)<(f[Dc>>2]|0))}Lc=f[Fc>>2]|0;if((Lc|0)!=(Gc|0))UC(Lc);if(ia)Hc=Hc+-1|0;else{ka=Zb;break}}}Zb=f[ka>>2]|0;if(Zb|0?(Hc=Zb+12|0,Zb=f[Hc>>2]|0,f[Hc>>2]=Zb+-1,(Zb|0)==1):0)kL(y);f[ka>>2]=0;ka=y+16|0;Zb=y+4|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[Zb>>2]|0)>0){ka=f[y+40>>2]|0;Hc=0;do{f[ka+(Hc<<2)>>2]=0;Hc=Hc+1|0}while((Hc|0)<(f[Zb>>2]|0))}Zb=f[y+44>>2]|0;if((Zb|0)!=(y+48|0))UC(Zb);Zb=w+36|0;y=f[Zb>>2]|0;if(y|0?(Hc=y+12|0,y=f[Hc>>2]|0,f[Hc>>2]=y+-1,(y|0)==1):0)kL(w);f[Zb>>2]=0;Zb=w+16|0;f[Zb>>2]=0;f[Zb+4>>2]=0;f[Zb+8>>2]=0;f[Zb+12>>2]=0;if((f[R>>2]|0)>0){Zb=f[T>>2]|0;T=0;do{f[Zb+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[U>>2]|0;if((R|0)!=(S|0))UC(R);R=v+36|0;S=f[R>>2]|0;if(S|0?(U=S+12|0,S=f[U>>2]|0,f[U>>2]=S+-1,(S|0)==1):0)kL(v);f[R>>2]=0;R=v+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[J>>2]|0)>0){R=f[O>>2]|0;O=0;do{f[R+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[J>>2]|0))}J=f[Q>>2]|0;if((J|0)!=(P|0))UC(J);J=t+36|0;P=f[J>>2]|0;if(P|0?(Q=P+12|0,P=f[Q>>2]|0,f[Q>>2]=P+-1,(P|0)==1):0)kL(t);f[J>>2]=0;J=t+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[d>>2]|0)>0){J=f[c>>2]|0;c=0;do{f[J+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[K>>2]|0;if((d|0)!=(I|0))UC(d);d=r+36|0;I=f[d>>2]|0;if(I|0?(K=I+12|0,I=f[K>>2]|0,f[K>>2]=I+-1,(I|0)==1):0)kL(r);f[d>>2]=0;d=r+16|0;I=r+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[I>>2]|0)>0){d=f[M>>2]|0;M=0;do{f[d+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[I>>2]|0))}I=f[r+44>>2]|0;if((I|0)!=(r+48|0))UC(I);I=q+36|0;r=f[I>>2]|0;do if(r|0){M=r+12|0;d=f[M>>2]|0;f[M>>2]=d+-1;if((d|0)!=1)break;kL(q)}while(0);f[I>>2]=0;I=q+16|0;r=q+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[r>>2]|0)>0){I=f[X>>2]|0;X=0;do{f[I+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))UC(r);if(!(f[o+4>>2]|0)){u=g;return}u=g;return}function qsa(a){a=a|0;return}function rsa(a){a=a|0;return f[a+4>>2]|0}function ssa(a,b){a=a|0;b=b|0;f[a+4>>2]=b;return}function tsa(a){a=a|0;return +(+p[a+8>>3])}function usa(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function vsa(a){a=a|0;return (b[a+16>>0]|0)!=0|0}function wsa(a,c){a=a|0;c=c|0;b[a+16>>0]=c&1;return}function xsa(a){a=a|0;return f[a+20>>2]|0}function ysa(a,b){a=a|0;b=b|0;f[a+20>>2]=b;return}function zsa(a){a=a|0;return f[a+24>>2]|0}function Asa(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function Bsa(a){a=a|0;return f[a+28>>2]|0}function Csa(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function Dsa(a){a=a|0;return +(+p[a+32>>3])}function Esa(a,b){a=a|0;b=+b;p[a+32>>3]=b;return}function Fsa(a){a=a|0;return f[a+40>>2]|0}function Gsa(a,b){a=a|0;b=b|0;f[a+40>>2]=b;return}function Hsa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0;h=u;u=u+16|0;i=h;j=f[c+12>>2]|0;k=f[c+8>>2]|0;l=f[b+16>>2]|0;m=(f[b+48>>2]|0)>>>2;if(!(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(k|0):0)?(f[d+12>>2]|0)==(j|0):0)?(f[d>>2]&4095|0)==37:0)?(f[d+16>>2]|0)!=0:0)){f[i>>2]=k;f[i+4>>2]=j;hL(d,2,i,37)}if((e|0)>=(g|0)){u=h;return}i=f[c+16>>2]|0;b=f[f[c+44>>2]>>2]|0;c=f[a+16>>2]|0;o=f[f[a+44>>2]>>2]|0;a=f[d+16>>2]|0;p=f[f[d+44>>2]>>2]|0;d=(j|0)>0;q=j+-1|0;r=k+-1|0;s=m+5|0;t=m+1|0;v=m+6|0;w=m+2|0;x=m+7|0;y=m+3|0;z=m+8|0;A=m+4|0;B=m+9|0;C=j+-10|0;D=k+-10|0;E=j+-5|0;F=k+-5|0;k=e;do{e=i+(Y(b,k)|0)|0;G=c+(Y(o,k)|0)|0;H=a+(Y(p,k)|0)|0;if(d){I=+(k|0);J=(k|0)<5;K=104620+(k<<2)|0;L=(k|0)<(F|0);M=104620+(r-k<<2)|0;N=(k+-5|0)>>>0>=D>>>0;O=0;do{P=O<<1;Q=+n[e+(P<<2)>>2];R=+n[e+((P|1)<<2)>>2];S=+(O|0)+Q;T=I+R;P=~~S;U=P-(+(P|0)>S&1)|0;P=~~T;V=P-(+(P|0)>T&1)|0;P=l+((Y(V,m)|0)<<2)+(U*5<<2)|0;W=S-+(U|0);S=T-+(V|0);if(U>>>0<q>>>0&V>>>0<r>>>0){T=1.0-W;X=1.0-S;Z=T*X;_=W*X;X=T*S;T=W*S;V=O*5|0;$=Z*+n[P>>2]+_*+n[P+20>>2]+X*+n[P+(m<<2)>>2]+T*+n[P+(s<<2)>>2];aa=(Z*+n[P+16>>2]+_*+n[P+36>>2]+X*+n[P+(A<<2)>>2]+T*+n[P+(B<<2)>>2]+ +n[G+(V+4<<2)>>2])*.25;ba=(Z*+n[P+12>>2]+_*+n[P+32>>2]+X*+n[P+(y<<2)>>2]+T*+n[P+(z<<2)>>2]+ +n[G+(V+3<<2)>>2])*.5;ca=(Z*+n[P+8>>2]+_*+n[P+28>>2]+X*+n[P+(w<<2)>>2]+T*+n[P+(x<<2)>>2]+ +n[G+(V+2<<2)>>2])*.5;da=Z*+n[P+4>>2]+_*+n[P+24>>2]+X*+n[P+(t<<2)>>2]+T*+n[P+(v<<2)>>2];ea=V}else{V=O*5|0;$=0.0;aa=+n[G+(V+4<<2)>>2]*.5;ba=+n[G+(V+3<<2)>>2];ca=+n[G+(V+2<<2)>>2];da=0.0;ea=V}V=ea+1|0;T=R*ca+Q*aa+(+n[G+(ea<<2)>>2]-$)*.5;X=Q*ba+R*aa+(+n[G+(V<<2)>>2]-da)*.5;if((O+-5|0)>>>0>=C>>>0|N){if((O|0)<5)fa=+n[104620+(O<<2)>>2];else fa=1.0;if((O|0)<(E|0))ga=1.0;else ga=+n[104620+(q-O<<2)>>2];if(J)ha=+n[K>>2];else ha=1.0;if(L)ia=1.0;else ia=+n[M>>2];R=fa*ga*ha*ia;ja=T*R;ka=aa*R;la=ba*R;ma=ca*R;na=X*R}else{ja=T;ka=aa;la=ba;ma=ca;na=X}X=ka*ka;n[H+(ea<<2)>>2]=ma*ma+X;n[H+(V<<2)>>2]=(ma+la)*ka;n[H+(ea+2<<2)>>2]=la*la+X;n[H+(ea+3<<2)>>2]=na*ka+ma*ja;n[H+(ea+4<<2)>>2]=na*la+ka*ja;O=O+1|0}while((O|0)!=(j|0))}k=k+1|0}while((k|0)!=(g|0));u=h;return}function Isa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;e=u;u=u+432|0;g=e+424|0;h=e+368|0;i=e+320|0;j=e+264|0;k=e;l=e+248|0;m=e+192|0;dQ(g,104640);f[h>>2]=1124007936;n=h+4|0;o=h+8|0;q=h+40|0;r=n;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=o;t=h+48|0;v=h+44|0;f[v>>2]=t;f[t>>2]=0;f[h+52>>2]=0;f[i>>2]=1124007936;w=i+4|0;x=i+8|0;y=i+20|0;z=i+24|0;A=i+28|0;B=i+32|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;f[w+24>>2]=0;f[B>>2]=x;C=i+40|0;D=i+36|0;f[D>>2]=C;f[i+44>>2]=0;f[C>>2]=0;C=(yM(a)|0)==655360;if(C){zM(j,a,-1);E=j+24|0;F=f[E>>2]|0;if(F|0){G=F+8|0;f[G>>2]=(f[G>>2]|0)+1}G=f[z>>2]|0;if(G|0?(F=G+8|0,G=f[F>>2]|0,f[F>>2]=G+-1,(G|0)==1):0)iI(i);if((f[w>>2]|0)>0){G=f[B>>2]|0;F=0;do{f[G+(F<<2)>>2]=0;F=F+1|0;H=f[w>>2]|0}while((F|0)<(H|0));f[z>>2]=0;f[i>>2]=f[j>>2];if((H|0)<3)I=12;else I=14}else{f[z>>2]=0;f[i>>2]=f[j>>2];I=12}if((I|0)==12){H=f[j+4>>2]|0;if((H|0)<3){f[w>>2]=H;f[x>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];x=f[j+36>>2]|0;H=f[D>>2]|0;f[H>>2]=f[x>>2];f[H+4>>2]=f[x+4>>2]}else I=14}if((I|0)==14)gI(i,j);f[i+16>>2]=f[j+16>>2];if(!(f[y>>2]|0))f[y>>2]=f[j+20>>2];f[z>>2]=f[E>>2];f[A>>2]=f[j+28>>2];A=f[i>>2]|0;E=f[B>>2]|0;B=f[E+4>>2]|0;z=f[E>>2]|0;hI(j);J=A;K=B;M=z}else{do if((yM(a)|0)==65536){z=f[a+4>>2]|0;f[j>>2]=f[z>>2];B=j+4|0;A=z+4|0;f[B>>2]=f[A>>2];E=j+8|0;f[E>>2]=f[z+8>>2];f[j+12>>2]=f[z+12>>2];f[j+16>>2]=f[z+16>>2];f[j+20>>2]=f[z+20>>2];f[j+24>>2]=f[z+24>>2];f[j+28>>2]=f[z+28>>2];f[j+32>>2]=f[z+32>>2];y=j+36|0;x=f[z+36>>2]|0;f[y>>2]=x;f[j+40>>2]=E;E=j+48|0;H=j+44|0;f[H>>2]=E;f[E>>2]=0;f[j+52>>2]=0;if(x|0){E=x+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[A>>2]|0)<3){A=f[z+44>>2]|0;E=f[H>>2]|0;f[E>>2]=f[A>>2];f[E+4>>2]=f[A+4>>2];N=y;break}else{f[B>>2]=0;jL(j,z);N=y;break}}else{yL(j,a,-1);N=j+36|0}while(0);a=f[N>>2]|0;if(a|0){y=a+12|0;f[y>>2]=(f[y>>2]|0)+1}y=h+36|0;a=f[y>>2]|0;if(a|0?(z=a+12|0,a=f[z>>2]|0,f[z>>2]=a+-1,(a|0)==1):0)kL(h);f[y>>2]=0;a=h+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[n>>2]|0)>0){z=f[q>>2]|0;B=0;do{f[z+(B<<2)>>2]=0;B=B+1|0;O=f[n>>2]|0}while((B|0)<(O|0));f[h>>2]=f[j>>2];if((O|0)<3)I=35;else I=37}else{f[h>>2]=f[j>>2];I=35}if((I|0)==35){O=f[j+4>>2]|0;if((O|0)<3){f[n>>2]=O;f[o>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];o=f[j+44>>2]|0;O=f[v>>2]|0;f[O>>2]=f[o>>2];f[O+4>>2]=f[o+4>>2]}else I=37}if((I|0)==37)jL(h,j);o=j+16|0;f[a>>2]=f[o>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];a=f[N>>2]|0;f[y>>2]=a;y=f[h>>2]|0;O=f[q>>2]|0;B=f[O+4>>2]|0;z=f[O>>2]|0;if(a|0?(O=a+12|0,a=f[O>>2]|0,f[O>>2]=a+-1,(a|0)==1):0)kL(j);f[N>>2]=0;N=j+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[N>>2]|0)>0){o=f[j+40>>2]|0;a=0;do{f[o+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[N>>2]|0))}N=f[j+44>>2]|0;if((N|0)!=(j+48|0))UC(N);J=y;K=B;M=z}f[j>>2]=f[c>>2];z=j+4|0;B=c+4|0;f[z>>2]=f[B>>2];y=j+8|0;N=c+8|0;a=f[N>>2]|0;f[y>>2]=a;o=j+12|0;O=c+12|0;A=f[O>>2]|0;f[o>>2]=A;if(!(J&4088)){P=A;Q=a}else{f[k>>2]=0;f[k+4>>2]=0;a=aD(k,7)|0;b[a>>0]=b[359044]|0;b[a+1>>0]=b[359045]|0;b[a+2>>0]=b[359046]|0;b[a+3>>0]=b[359047]|0;b[a+4>>0]=b[359048]|0;b[a+5>>0]=b[359049]|0;b[a+6>>0]=b[359050]|0;bO(-215,k,359052,359062,61);bD(k);P=f[O>>2]|0;Q=f[N>>2]|0}if((P|0)<1|(Q|0)<1){f[k>>2]=0;f[k+4>>2]=0;r=aD(k,35)|0;a=359133;s=r+35|0;do{b[r>>0]=b[a>>0]|0;r=r+1|0;a=a+1|0}while((r|0)<(s|0));bO(-5,k,359052,359062,64);bD(k);R=f[N>>2]|0;S=f[O>>2]|0}else{R=Q;S=P}P=f[c>>2]|0;Q=f[B>>2]|0;a=(P|0)>0?P:0;r=(Q|0)>0?Q:0;s=R+P|0;P=((K|0)<(s|0)?K:s)-a|0;s=S+Q|0;Q=((M|0)<(s|0)?M:s)-r|0;s=(P|0)<1|(Q|0)<1;f[c>>2]=s?0:a;f[B>>2]=s?0:r;f[N>>2]=s?0:P;f[O>>2]=s?0:Q;Q=f[d>>2]|0;if(!(Q&2))T=1.0;else{U=+p[d+8>>3];T=U<0.0?0.0:U}s=MVb(T*T)|0;P=((s|0)<0)<<31>>31;if(!(Q&1))V=100;else{Q=f[d+4>>2]|0;V=(Q|0)>1?Q:1}Q=(K|0)/2|0;d=(M|0)/2|0;r=l+8|0;a=l+12|0;S=l+4|0;R=k+8|0;A=k+16|0;J=l+8|0;E=l+12|0;H=l+4|0;x=m+36|0;D=m+16|0;w=m+4|0;F=m+40|0;G=m+44|0;W=m+48|0;X=0;Z=f[j>>2]|0;_=f[z>>2]|0;$=f[y>>2]|0;aa=f[o>>2]|0;while(1){ba=(Z|0)>0?Z:0;ca=(_|0)>0?_:0;da=$+Z|0;ea=((K|0)<(da|0)?K:da)-ba|0;da=aa+_|0;fa=((M|0)<(da|0)?M:da)-ca|0;da=(ea|0)<1|(fa|0)<1;ga=da?0:fa;ha=da?0:ea;f[j>>2]=da?0:ba;f[z>>2]=da?0:ca;f[y>>2]=ha;f[o>>2]=ga;if((ca|ba|0)==0|da?da|(ea|fa|0)==0:0){f[j>>2]=Q;f[z>>2]=d}f[y>>2]=(ha|0)>1?ha:1;f[o>>2]=(ga|0)>1?ga:1;if(!C){nL(m,h,j);f[J>>2]=0;f[E>>2]=0;f[l>>2]=16842752;f[H>>2]=m;loa(k,l,0);ga=f[x>>2]|0;if(ga|0?(ha=ga+12|0,ga=f[ha>>2]|0,f[ha>>2]=ga+-1,(ga|0)==1):0)kL(m);f[x>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[w>>2]|0)>0){ga=f[F>>2]|0;ha=0;do{f[ga+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[w>>2]|0))}ha=f[G>>2]|0;if((ha|0)!=(W|0))UC(ha)}else{dI(m,i,j);f[r>>2]=0;f[a>>2]=0;f[l>>2]=17432576;f[S>>2]=m;loa(k,l,0);hI(m)}T=+p[k>>3];if(+L(+T)<2.220446049250313e-16){I=72;break}ha=MVb(+p[R>>3]/T-+(f[N>>2]|0)*.5)|0;ga=MVb(+p[A>>3]/T-+(f[O>>2]|0)*.5)|0;fa=f[j>>2]|0;ea=fa+ha|0;$=f[y>>2]|0;ha=K-$|0;da=(ea|0)>0?ea:0;Z=(ha|0)<(da|0)?ha:da;da=f[z>>2]|0;ha=da+ga|0;aa=f[o>>2]|0;ga=M-aa|0;ea=(ha|0)>0?ha:0;_=(ga|0)<(ea|0)?ga:ea;ea=Z-fa|0;fa=_-da|0;f[j>>2]=Z;f[z>>2]=_;if(0<(P|0)|(0==(P|0)?((Y(fa,fa)|0)+(Y(ea,ea)|0)|0)>>>0<s>>>0:0)){I=72;break}ea=X+1|0;if((ea|0)>=(V|0)){ia=ea;break}else X=ea}if((I|0)==72)ia=X;f[c>>2]=f[j>>2];f[B>>2]=f[z>>2];f[N>>2]=f[y>>2];f[O>>2]=f[o>>2];hI(i);i=h+36|0;o=f[i>>2]|0;if(o|0?(O=o+12|0,o=f[O>>2]|0,f[O>>2]=o+-1,(o|0)==1):0)kL(h);f[i>>2]=0;i=h+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[n>>2]|0)>0){i=f[q>>2]|0;q=0;do{f[i+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[n>>2]|0))}n=f[v>>2]|0;if((n|0)!=(t|0))UC(n);if(!(f[g+4>>2]|0)){u=e;return ia|0}u=e;return ia|0}function Jsa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0;e=u;u=u+384|0;g=e;h=e+368|0;i=e+312|0;j=e+264|0;k=e+248|0;l=e+192|0;dQ(h,104660);f[i>>2]=1124007936;m=i+4|0;o=i+8|0;q=i+40|0;r=m;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=o;r=i+48|0;s=i+44|0;f[s>>2]=r;f[r>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;t=j+4|0;v=j+8|0;w=j+20|0;x=j+24|0;y=j+28|0;z=j+32|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[z>>2]=v;A=j+40|0;B=j+36|0;f[B>>2]=A;f[j+44>>2]=0;f[A>>2]=0;A=(yM(b)|0)==655360;if(A){zM(g,b,-1);C=g+24|0;D=f[C>>2]|0;if(D|0){E=D+8|0;f[E>>2]=(f[E>>2]|0)+1}E=f[x>>2]|0;if(E|0?(D=E+8|0,E=f[D>>2]|0,f[D>>2]=E+-1,(E|0)==1):0)iI(j);if((f[t>>2]|0)>0){E=f[z>>2]|0;D=0;do{f[E+(D<<2)>>2]=0;D=D+1|0;F=f[t>>2]|0}while((D|0)<(F|0));f[x>>2]=0;f[j>>2]=f[g>>2];if((F|0)<3)G=12;else G=14}else{f[x>>2]=0;f[j>>2]=f[g>>2];G=12}if((G|0)==12){F=f[g+4>>2]|0;if((F|0)<3){f[t>>2]=F;f[v>>2]=f[g+8>>2];f[j+12>>2]=f[g+12>>2];v=f[g+36>>2]|0;F=f[B>>2]|0;f[F>>2]=f[v>>2];f[F+4>>2]=f[v+4>>2]}else G=14}if((G|0)==14)gI(j,g);f[j+16>>2]=f[g+16>>2];if(!(f[w>>2]|0))f[w>>2]=f[g+20>>2];f[x>>2]=f[C>>2];f[y>>2]=f[g+28>>2];y=f[z>>2]|0;z=f[y+4>>2]|0;C=f[y>>2]|0;hI(g);H=z;I=C}else{do if((yM(b)|0)==65536){C=f[b+4>>2]|0;f[g>>2]=f[C>>2];z=g+4|0;y=C+4|0;f[z>>2]=f[y>>2];x=g+8|0;f[x>>2]=f[C+8>>2];f[g+12>>2]=f[C+12>>2];f[g+16>>2]=f[C+16>>2];f[g+20>>2]=f[C+20>>2];f[g+24>>2]=f[C+24>>2];f[g+28>>2]=f[C+28>>2];f[g+32>>2]=f[C+32>>2];w=g+36|0;v=f[C+36>>2]|0;f[w>>2]=v;f[g+40>>2]=x;x=g+48|0;F=g+44|0;f[F>>2]=x;f[x>>2]=0;f[g+52>>2]=0;if(v|0){x=v+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[y>>2]|0)<3){y=f[C+44>>2]|0;x=f[F>>2]|0;f[x>>2]=f[y>>2];f[x+4>>2]=f[y+4>>2];J=w;break}else{f[z>>2]=0;jL(g,C);J=w;break}}else{yL(g,b,-1);J=g+36|0}while(0);w=f[J>>2]|0;if(w|0){C=w+12|0;f[C>>2]=(f[C>>2]|0)+1}C=i+36|0;w=f[C>>2]|0;if(w|0?(z=w+12|0,w=f[z>>2]|0,f[z>>2]=w+-1,(w|0)==1):0)kL(i);f[C>>2]=0;w=i+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[m>>2]|0)>0){z=f[q>>2]|0;y=0;do{f[z+(y<<2)>>2]=0;y=y+1|0;K=f[m>>2]|0}while((y|0)<(K|0));f[i>>2]=f[g>>2];if((K|0)<3)G=35;else G=37}else{f[i>>2]=f[g>>2];G=35}if((G|0)==35){K=f[g+4>>2]|0;if((K|0)<3){f[m>>2]=K;f[o>>2]=f[g+8>>2];f[i+12>>2]=f[g+12>>2];o=f[g+44>>2]|0;K=f[s>>2]|0;f[K>>2]=f[o>>2];f[K+4>>2]=f[o+4>>2]}else G=37}if((G|0)==37)jL(i,g);G=g+16|0;f[w>>2]=f[G>>2];f[i+20>>2]=f[g+20>>2];f[i+24>>2]=f[g+24>>2];f[i+28>>2]=f[g+28>>2];f[i+32>>2]=f[g+32>>2];w=f[J>>2]|0;f[C>>2]=w;C=f[q>>2]|0;o=f[C+4>>2]|0;K=f[C>>2]|0;if(w|0?(C=w+12|0,w=f[C>>2]|0,f[C>>2]=w+-1,(w|0)==1):0)kL(g);f[J>>2]=0;J=g+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[J>>2]|0)>0){G=f[g+40>>2]|0;w=0;do{f[G+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[J>>2]|0))}J=f[g+44>>2]|0;if((J|0)!=(g+48|0))UC(J);H=o;I=K};f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];Isa(b,c,g)|0;b=f[c>>2]|0;d=(b|0)<10?0:b+-10|0;f[c>>2]=d;b=c+4|0;K=f[b>>2]|0;o=(K|0)<10?0:K+-10|0;f[b>>2]=o;K=c+8|0;J=(f[K>>2]|0)+20|0;f[K>>2]=(d+J|0)>(H|0)?H-d|0:J;J=c+12|0;d=(f[J>>2]|0)+20|0;f[J>>2]=(o+d|0)>(I|0)?I-o|0:d;if(!A){nL(l,i,c);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=l;loa(g,k,0);A=l+36|0;d=f[A>>2]|0;if(d|0?(o=d+12|0,d=f[o>>2]|0,f[o>>2]=d+-1,(d|0)==1):0)kL(l);f[A>>2]=0;A=l+16|0;d=l+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[d>>2]|0)>0){A=f[l+40>>2]|0;o=0;do{f[A+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[d>>2]|0))}d=f[l+44>>2]|0;if((d|0)!=(l+48|0))UC(d)}else{dI(l,j,c);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=17432576;f[k+4>>2]=l;loa(g,k,0);hI(l)}N=+p[g>>3];Q=+p[g+88>>3];R=+p[g+80>>3];S=+p[g+96>>3];if(+L(+N)<2.220446049250313e-16){f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0}else{T=+p[g+16>>3];V=1.0/N;l=MVb(V*+p[g+8>>3]+ +(f[c>>2]|0))|0;g=MVb(V*T+ +(f[b>>2]|0))|0;T=Q*V;N=V*R-V*S;W=+U(+(T*2.0),+(N+ +M(+(T*(T*4.0)+N*N))));N=+O(+W);T=+P(+W);X=N*N;Y=Q*(N*2.0*T);Q=T*T;Z=+M(+(V*(S*Q+(R*X+Y))))*4.0;_=+M(+(V*(S*X+(R*Q-Y))))*4.0;if(Z<_){$=1.5707963267948966-W;aa=Z;ba=_;ca=N;da=T}else{$=W;aa=_;ba=Z;ca=T;da=N}k=MVb(+L(+(da*ba)))|0;d=MVb(+L(+(ca*aa)))|0;o=((k|0)<(d|0)?d:k)+2|0;k=H-l<<1;d=(o|0)>(k|0)?k:o;o=MVb(+L(+(ca*ba)))|0;k=MVb(+L(+(da*aa)))|0;A=((o|0)<(k|0)?k:o)+2|0;o=I-g<<1;k=(A|0)>(o|0)?o:A;A=l-((d|0)/2|0)|0;l=(A|0)>0?A:0;f[c>>2]=l;c=g-((k|0)/2|0)|0;g=(c|0)>0?c:0;f[b>>2]=g;b=H-l|0;H=(b|0)>(d|0)?d:b;f[K>>2]=H;K=I-g|0;I=(K|0)>(k|0)?k:K;f[J>>2]=I;da=ba;ba=aa;aa=($+1.5707963267948966)*180.0/3.141592653589793;if(aa<0.0){$=aa;while(1){ca=$+360.0;if(ca<0.0)$=ca;else{ea=ca;break}}}else ea=aa;if(!(ea>=360.0))fa=ea;else{aa=ea;while(1){ea=aa+-360.0;if(!(ea>=360.0)){fa=ea;break}else aa=ea}}n[a>>2]=+(l|0)+ +(H|0)*.5;n[a+4>>2]=+(g|0)+ +(I|0)*.5;n[a+8>>2]=ba;n[a+12>>2]=da;n[a+16>>2]=!(fa>=180.0)?fa:fa+-180.0}hI(j);j=i+36|0;a=f[j>>2]|0;if(a|0?(I=a+12|0,a=f[I>>2]|0,f[I>>2]=a+-1,(a|0)==1):0)kL(i);f[j>>2]=0;j=i+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[m>>2]|0)>0){j=f[q>>2]|0;q=0;do{f[j+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[m>>2]|0))}m=f[s>>2]|0;if((m|0)!=(r|0))UC(m);if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function Ksa(a){a=a|0;O5b(a);return}function Lsa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0.0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0.0,Xa=0.0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0.0,db=0.0,eb=0,fb=0.0,gb=0.0,hb=0.0,ib=0,jb=0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0.0,Eb=0,Fb=0.0;e=u;u=u+1200|0;g=e+1184|0;i=e+136|0;j=e+80|0;k=e+16|0;l=e+24|0;m=e;o=e+8|0;dQ(g,104700);q=a+32|0;r=f[q>>2]|0;s=+(r+-1|0)*.5;t=a+36|0;v=f[t>>2]|0;w=+(v+-1|0)*.5;x=f[a+4>>2]|0;y=f[a+8>>2]|0;z=f[a+12>>2]|0;A=((f[x>>2]|0)>>>3&511)+1|0;B=A<<1;C=Y(Y(r*3|0,v)|0,A)|0;D=i+8|0;f[i>>2]=D;E=i+4|0;f[E>>2]=C;if(C>>>0>520){F=N5b(C>>>0>2147483647?-1:C<<1)|0;f[i>>2]=F;G=F}else G=D;f[k>>2]=r;f[k+4>>2]=v;JF(j,k,(A<<3)+-5|0,G,0);G=f[q>>2]|0;f[m>>2]=G;k=f[t>>2]|0;f[m+4>>2]=k;JF(l,m,(A<<4)+-5|0,(f[i>>2]|0)+((Y(Y(k,A)|0,G)|0)<<1)|0,0);G=f[c>>2]|0;k=c+4|0;if((G|0)<(f[k>>2]|0)){c=a+16|0;m=a+56|0;v=a+60|0;r=a+64|0;F=a+20|0;C=a+24|0;H=a+28|0;I=z+12|0;J=z+8|0;K=z+48|0;N=x+48|0;O=y+48|0;P=x+16|0;Q=z+16|0;R=j+16|0;S=j+44|0;T=l+16|0;U=l+44|0;V=B|1;W=a+68|0;X=a+44|0;Z=y+12|0;_=y+8|0;$=y+16|0;aa=a+48|0;a=o+4|0;ba=A<<5;ca=G;do{G=f[c>>2]|0;da=f[m>>2]|0;ea=1.0/+(1<<da|0);fa=+n[G+(ca<<3)>>2]*ea;ga=+n[G+(ca<<3)+4>>2]*ea;if((da|0)==(f[v>>2]|0))if(!(f[r>>2]&4)){ha=fa;ia=ga;ja=f[F>>2]|0}else{ka=ea;la=17}else{ka=2.0;la=17}if((la|0)==17){la=0;G=f[F>>2]|0;ha=ka*+n[G+(ca<<3)>>2];ia=ka*+n[G+(ca<<3)+4>>2];ja=G}G=ja+(ca<<3)|0;n[G>>2]=ha;ma=ja+(ca<<3)+4|0;n[ma>>2]=ia;ea=fa-s;fa=ga-w;na=~~ea;oa=na-(+(na|0)>ea&1)|0;na=~~fa;pa=na-(+(na|0)>fa&1)|0;na=f[q>>2]|0;a:do if((((oa|0)>=(0-na|0)?(oa|0)<(f[I>>2]|0):0)?(qa=f[t>>2]|0,(pa|0)>=(0-qa|0)):0)?(pa|0)<(f[J>>2]|0):0){ga=ea-+(oa|0);ra=fa-+(pa|0);sa=1.0-ga;ta=1.0-ra;ua=LVb(sa*ta*16384.0)|0;va=LVb(ga*ta*16384.0)|0;wa=LVb(ra*sa*16384.0)|0;xa=16384-ua-va-wa|0;ya=((f[K>>2]|0)>>>0)/((1212424721>>>(f[z>>2]<<2&28)&15)>>>0)|0;za=((f[N>>2]|0)>>>0)/((1212424721>>>(f[x>>2]<<2&28)&15)>>>0)|0;Aa=((f[O>>2]|0)>>>0)/((1212424721>>>(f[y>>2]<<2&28)&15)>>>0)|0;if((qa|0)>0){Ba=Y(oa,A)|0;Ca=Y(oa,B)|0;Da=ya+B|0;Ea=ya+1|0;Fa=Da+1|0;Ga=f[P>>2]|0;Ha=f[Q>>2]|0;Ia=f[R>>2]|0;Ja=f[f[S>>2]>>2]|0;Ka=f[T>>2]|0;La=f[f[U>>2]>>2]|0;Ma=Y(na,A)|0;Na=(Ma|0)>0;sa=0.0;ra=0.0;ta=0.0;Oa=0;Pa=qa;while(1){Qa=Oa+pa|0;Ra=Ga+(Y(Qa,za)|0)+Ba|0;Sa=Ia+(Y(Ja,Oa)|0)|0;if(Na){Ta=Ka+(Y(La,Oa)|0)|0;Ua=0;Va=Ha+((Y(Qa,ya)|0)<<1)+(Ca<<1)|0;ga=sa;Wa=ra;Xa=ta;while(1){Qa=Y(h[Ra+Ua>>0]|0,ua)|0;Ya=Y(h[Ra+(Ua+A)>>0]|0,va)|0;Za=Ua+za|0;_a=Y(h[Ra+Za>>0]|0,wa)|0;$a=(Qa+256+Ya+_a+(Y(h[Ra+(Za+A)>>0]|0,xa)|0)|0)>>>9;Za=Y(d[Va>>1]|0,ua)|0;_a=Y(d[Va+(B<<1)>>1]|0,va)|0;Ya=Y(d[Va+(ya<<1)>>1]|0,wa)|0;Qa=Za+8192+_a+Ya+(Y(d[Va+(Da<<1)>>1]|0,xa)|0)>>14;Ya=Y(d[Va+2>>1]|0,ua)|0;_a=Y(d[Va+(V<<1)>>1]|0,va)|0;Za=Y(d[Va+(Ea<<1)>>1]|0,wa)|0;ab=Ya+8192+_a+Za+(Y(d[Va+(Fa<<1)>>1]|0,xa)|0)>>14;d[Sa+(Ua<<1)>>1]=$a;d[Ta>>1]=Qa;d[Ta+2>>1]=ab;ga=ga+ +(Y(Qa,Qa)|0);Wa=Wa+ +(Y(ab,Qa)|0);Xa=Xa+ +(Y(ab,ab)|0);Ua=Ua+1|0;if((Ua|0)>=(Ma|0))break;else{Ta=Ta+4|0;Va=Va+4|0}}bb=ga;cb=Wa;db=Xa;eb=f[t>>2]|0}else{bb=sa;cb=ra;db=ta;eb=Pa}Oa=Oa+1|0;if((Oa|0)>=(eb|0))break;else{sa=bb;ra=cb;ta=db;Pa=eb}}fb=bb;gb=cb;hb=db;ib=eb;jb=f[q>>2]|0}else{fb=0.0;gb=0.0;hb=0.0;ib=qa;jb=na}ta=fb*9.5367431640625e-07;ra=gb*9.5367431640625e-07;sa=hb*9.5367431640625e-07;kb=sa*ta-ra*ra;lb=ta-sa;mb=(sa+ta-+M(+(ra*(ra*4.0)+lb*lb)))/+(Y(ib<<1,jb)|0);Pa=f[H>>2]|0;if(Pa|0?f[r>>2]&8|0:0)n[Pa+(ca<<2)>>2]=mb;if(kb<1.1920928955078125e-07?1:mb<+n[W>>2]){if(da|0)break;Pa=f[C>>2]|0;if(!Pa)break;b[Pa+ca>>0]=0;break}mb=1.0/kb;Pa=f[X>>2]|0;b:do if((Pa|0)>0){Oa=0-jb|0;Ma=0-ib|0;xa=(ib|0)>0;Fa=Y(jb,A)|0;wa=(Fa|0)>0;Ea=0;kb=ha-s;lb=ia-w;nb=0.0;ob=0.0;c:while(1){va=~~kb;ua=va-(+(va|0)>kb&1)|0;va=~~lb;Da=va-(+(va|0)>lb&1)|0;if((ua|0)<(Oa|0))break;if((Da|0)<(Ma|0)?1:(ua|0)>=(f[Z>>2]|0))break;if((Da|0)>=(f[_>>2]|0))break;pb=kb-+(ua|0);qb=lb-+(Da|0);rb=1.0-pb;sb=1.0-qb;va=LVb(rb*sb*16384.0)|0;ya=LVb(pb*sb*16384.0)|0;za=LVb(rb*qb*16384.0)|0;Ca=16384-va-ya-za|0;do if(xa){Ha=f[$>>2]|0;La=Y(ua,A)|0;Ka=f[R>>2]|0;Na=f[f[S>>2]>>2]|0;Ja=f[T>>2]|0;Ia=f[f[U>>2]>>2]|0;if(wa){tb=0.0;ub=0.0;vb=0}else{wb=0.0;xb=0.0;break}while(1){Ba=Ha+(Y(vb+Da|0,Aa)|0)+La|0;Ga=Ka+(Y(Na,vb)|0)|0;Va=Ja+(Y(Ia,vb)|0)|0;qb=tb;rb=ub;Ta=0;while(1){Ua=Y(h[Ba+Ta>>0]|0,va)|0;Sa=Y(h[Ba+(Ta+A)>>0]|0,ya)|0;Ra=Ta+Aa|0;ab=Y(h[Ba+Ra>>0]|0,za)|0;Qa=Ua+256+Sa+ab+(Y(h[Ba+(Ra+A)>>0]|0,Ca)|0)>>9;Ra=Qa-(d[Ga+(Ta<<1)>>1]|0)|0;rb=rb+ +(Y(Ra,d[Va>>1]|0)|0);qb=qb+ +(Y(Ra,d[Va+2>>1]|0)|0);Ta=Ta+1|0;if((Ta|0)>=(Fa|0))break;else Va=Va+4|0}vb=vb+1|0;if((vb|0)>=(ib|0)){wb=qb;xb=rb;break}else{tb=qb;ub=rb}}}else{wb=0.0;xb=0.0}while(0);sb=xb*9.5367431640625e-07;pb=wb*9.5367431640625e-07;yb=nb;nb=mb*(ra*pb-sa*sb);zb=ob;ob=mb*(ra*sb-ta*pb);kb=kb+nb;lb=lb+ob;Ab=s+kb;Bb=w+lb;n[G>>2]=Ab;n[ma>>2]=Bb;pb=nb;sb=ob;if(pb*pb+sb*sb<=+p[aa>>3]){la=61;break b}do if((Ea|0)>0){if(!(+L(+(yb+nb))<.01))break;if(+L(+(zb+ob))<.01){la=59;break c}}while(0);Ea=Ea+1|0;if((Ea|0)>=(Pa|0)){la=61;break b}}if((la|0)==59){la=0;n[G>>2]=Ab-nb*.5;n[ma>>2]=Bb-ob*.5;la=61;break}if(!da){Ea=f[C>>2]|0;if(!Ea)la=62;else{b[Ea+ca>>0]=0;la=61}}else la=61}else la=61;while(0);if((la|0)==61){la=0;Pa=f[C>>2]|0;if(!Pa)la=62;else Cb=Pa}if((la|0)==62){la=0;f[o>>2]=0;f[a>>2]=0;Pa=aD(o,12)|0;qa=359292;Ea=Pa+12|0;do{b[Pa>>0]=b[qa>>0]|0;Pa=Pa+1|0;qa=qa+1|0}while((Pa|0)<(Ea|0));bO(-215,o,489445,359305,657);bD(o);Cb=f[C>>2]|0}qa=Cb+ca|0;if(((b[qa>>0]|0?(Pa=f[H>>2]|0,Pa|0):0)?(f[m>>2]|0)==0:0)?(f[r>>2]&8|0)==0:0){Ea=f[F>>2]|0;ta=+n[Ea+(ca<<3)>>2]-s;ra=+n[Ea+(ca<<3)+4>>2]-w;Ea=~~ta;Fa=Ea-(+(Ea|0)>ta&1)|0;Ea=~~ra;wa=Ea-(+(Ea|0)>ra&1)|0;Ea=f[q>>2]|0;do if((Fa|0)>=(0-Ea|0)){if((Fa|0)>=(f[Z>>2]|0))break;xa=f[t>>2]|0;if((wa|0)<(0-xa|0))break;if((wa|0)>=(f[_>>2]|0))break;mb=ta-+(Fa|0);sa=ra-+(wa|0);lb=1.0-mb;kb=1.0-sa;Ma=LVb(lb*kb*16384.0)|0;Oa=LVb(mb*kb*16384.0)|0;Ca=LVb(lb*sa*16384.0)|0;za=16384-Ma-Oa-Ca|0;do if((xa|0)>0){ya=f[$>>2]|0;va=Y(Fa,A)|0;Da=f[R>>2]|0;ua=f[f[S>>2]>>2]|0;Ia=Y(Ea,A)|0;if((Ia|0)>0){Db=0.0;Eb=0}else{Fb=0.0;break}while(1){Ja=ya+(Y(Eb+wa|0,Aa)|0)+va|0;Na=Da+(Y(ua,Eb)|0)|0;sa=Db;Ka=0;do{La=Y(h[Ja+Ka>>0]|0,Ma)|0;Ha=Y(h[Ja+(Ka+A)>>0]|0,Oa)|0;Va=Ka+Aa|0;Ta=Y(h[Ja+Va>>0]|0,Ca)|0;Ga=La+256+Ha+Ta+(Y(h[Ja+(Va+A)>>0]|0,za)|0)>>9;sa=sa+ +L(+(+(Ga-(d[Na+(Ka<<1)>>1]|0)|0)));Ka=Ka+1|0}while((Ka|0)<(Ia|0));Eb=Eb+1|0;if((Eb|0)>=(xa|0)){Fb=sa;break}else Db=sa}}else Fb=0.0;while(0);ob=Fb/+(Y(Y(ba,xa)|0,Ea)|0);n[Pa+(ca<<2)>>2]=ob;break a}while(0);if(Cb|0)b[qa>>0]=0}}else la=22;while(0);if((la|0)==22?(la=0,(da|0)==0):0){ma=f[C>>2]|0;if(ma|0)b[ma+ca>>0]=0;ma=f[H>>2]|0;if(ma|0)n[ma+(ca<<2)>>2]=0.0}ca=ca+1|0}while((ca|0)<(f[k>>2]|0))}k=l+36|0;ca=f[k>>2]|0;if(ca|0?(H=ca+12|0,ca=f[H>>2]|0,f[H>>2]=ca+-1,(ca|0)==1):0)kL(l);f[k>>2]=0;k=l+16|0;ca=l+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[ca>>2]|0)>0){k=f[l+40>>2]|0;H=0;do{f[k+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[ca>>2]|0))}ca=f[l+44>>2]|0;if((ca|0)!=(l+48|0))UC(ca);ca=j+36|0;l=f[ca>>2]|0;if(l|0?(H=l+12|0,l=f[H>>2]|0,f[H>>2]=l+-1,(l|0)==1):0)kL(j);f[ca>>2]=0;ca=j+16|0;l=j+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[l>>2]|0)>0){ca=f[j+40>>2]|0;H=0;do{f[ca+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))UC(l);l=f[i>>2]|0;if((l|0)!=(D|0)){if(l|0)P5b(l);f[i>>2]=D;f[E>>2]=520}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Msa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0;k=u;u=u+368|0;l=k+312|0;m=k+304|0;n=k+248|0;o=k+192|0;p=k+64|0;q=k+136|0;r=k+120|0;s=k+32|0;t=k;dQ(m,104720);do if((yM(a)|0)==65536){v=f[a+4>>2]|0;f[n>>2]=f[v>>2];w=n+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=n+8|0;f[y>>2]=f[v+8>>2];f[n+12>>2]=f[v+12>>2];f[n+16>>2]=f[v+16>>2];f[n+20>>2]=f[v+20>>2];f[n+24>>2]=f[v+24>>2];f[n+28>>2]=f[v+28>>2];f[n+32>>2]=f[v+32>>2];z=f[v+36>>2]|0;f[n+36>>2]=z;f[n+40>>2]=y;y=n+48|0;A=n+44|0;f[A>>2]=y;f[y>>2]=0;f[n+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];B=n;break}else{f[w>>2]=0;jL(n,v);B=n;break}}else{yL(n,a,-1);B=n}while(0);if(!(((f[B>>2]&7|0)==0?(f[d>>2]|0)>2:0)?(f[d+4>>2]|0)>2:0)){f[l>>2]=0;f[l+4>>2]=0;a=aD(l,59)|0;v=359487;w=a+59|0;do{b[a>>0]=b[v>>0]|0;a=a+1|0;v=v+1|0}while((a|0)<(w|0));bO(-215,l,359547,359305,706);bD(l)}v=g?2:1;aM(c,1,Y(v,e+1|0)|0,0,-1,1,0);a=f[B>>2]|0;w=a<<1&8176|11;do if(j?(h&16|0)==0&(a&32768|0)!=0:0){f[l>>2]=0;x=l+4|0;f[x>>2]=0;f[o>>2]=0;y=o+4|0;f[y>>2]=0;uL(n,l,o);A=f[o>>2]|0;z=f[d>>2]|0;if((A|0)<(z|0)){C=38;break}D=f[y>>2]|0;y=f[d+4>>2]|0;if((D|0)<(y|0)){C=38;break}E=n+12|0;if((z+A+(f[E>>2]|0)|0)>(f[l>>2]|0)){C=38;break}A=n+8|0;if((y+D+(f[A>>2]|0)|0)>(f[x>>2]|0)){C=38;break}x=KM(c,0)|0;if((x|0)!=(n|0)){D=n+36|0;y=f[D>>2]|0;if(y|0){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1}z=x+36|0;y=f[z>>2]|0;if(y|0?(F=y+12|0,y=f[F>>2]|0,f[F>>2]=y+-1,(y|0)==1):0)kL(x);f[z>>2]=0;y=x+16|0;F=x+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[F>>2]|0)>0){G=f[x+40>>2]|0;H=0;do{f[G+(H<<2)>>2]=0;H=H+1|0;I=f[F>>2]|0}while((H|0)<(I|0));f[x>>2]=f[B>>2];if((I|0)<3)C=29;else C=31}else{f[x>>2]=f[B>>2];C=29}if((C|0)==29){H=f[n+4>>2]|0;if((H|0)<3){f[F>>2]=H;f[x+8>>2]=f[A>>2];f[x+12>>2]=f[E>>2];H=f[n+44>>2]|0;G=f[x+44>>2]|0;f[G>>2]=f[H>>2];f[G+4>>2]=f[H+4>>2]}else C=31}if((C|0)==31)jL(x,n);f[y>>2]=f[n+16>>2];f[x+20>>2]=f[n+20>>2];f[x+24>>2]=f[n+24>>2];f[x+28>>2]=f[n+28>>2];f[x+32>>2]=f[n+32>>2];f[z>>2]=f[D>>2]}}else C=38;while(0);if((C|0)==38){I=KM(c,0)|0;a=I+16|0;if(f[a>>2]|0){j=f[I+4>>2]|0;if((j|0)<3)J=Y(f[I+12>>2]|0,f[I+8>>2]|0)|0;else{H=f[I+40>>2]|0;G=0;K=1;while(1){L=Y(f[H+(G<<2)>>2]|0,K)|0;G=G+1|0;if((G|0)==(j|0)){J=L;break}else K=L}}if(!((j|0)==0|(J|0)==0)){J=f[d+4>>2]|0;j=f[d>>2]|0;vL(I,J,J,j,j)|0}}j=f[I>>2]|0;J=f[B>>2]|0;K=n+12|0;G=f[K>>2]|0;if(!((J^j)&4095)){H=f[d>>2]|0;if(!((f[I+12>>2]|0)==((H<<1)+G|0)?(f[I+8>>2]|0)==((f[d+4>>2]<<1)+(f[n+8>>2]|0)|0):0)){M=H;C=49}}else{M=f[d>>2]|0;C=49}do if((C|0)==49){H=(f[d+4>>2]<<1)+(f[n+8>>2]|0)|0;L=(M<<1)+G|0;N=J&4095;if((((f[I+4>>2]|0)<3?(f[I+8>>2]|0)==(H|0):0)?(f[I+12>>2]|0)==(L|0):0)?!((j&4095|0)!=(N|0)|(f[a>>2]|0)==0):0)break;f[l>>2]=H;f[l+4>>2]=L;hL(I,2,l,N)}while(0);if((h|0)==5){a=d+4|0;j=f[a>>2]|0;J=f[K>>2]|0;K=f[n+8>>2]|0;f[p>>2]=f[d>>2];f[p+4>>2]=j;f[p+8>>2]=J;f[p+12>>2]=K;nL(o,I,p);K=l+8|0;f[K>>2]=0;f[K+4>>2]=0;f[l>>2]=-1040121856;f[l+4>>2]=o;SP(n,l);K=o+36|0;J=f[K>>2]|0;if(J|0?(j=J+12|0,J=f[j>>2]|0,f[j>>2]=J+-1,(J|0)==1):0)kL(o);f[K>>2]=0;K=o+16|0;J=o+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[J>>2]|0)>0){K=f[o+40>>2]|0;j=0;do{f[K+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[J>>2]|0))}J=f[o+44>>2]|0;if((J|0)!=(o+48|0))UC(J);O=d;P=a}else{f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=n;a=o+8|0;f[a>>2]=0;f[a+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=I;a=d+4|0;J=f[a>>2]|0;j=f[d>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[p+28>>2]=0;_P(l,o,J,J,j,j,h,p);O=d;P=a}a=0-(f[P>>2]|0)|0;P=0-(f[O>>2]|0)|0;vL(I,a,a,P,P)|0}P=n+40|0;a=f[P>>2]|0;I=f[a>>2]|0;f[o>>2]=f[a+4>>2];a=o+4|0;f[a>>2]=I;I=KM(c,0)|0;f[p>>2]=f[I>>2];O=p+4|0;j=I+4|0;f[O>>2]=f[j>>2];J=p+8|0;f[J>>2]=f[I+8>>2];K=p+12|0;f[K>>2]=f[I+12>>2];G=p+16|0;f[G>>2]=f[I+16>>2];M=p+20|0;f[M>>2]=f[I+20>>2];N=p+24|0;f[N>>2]=f[I+24>>2];L=p+28|0;f[L>>2]=f[I+28>>2];H=p+32|0;f[H>>2]=f[I+32>>2];Q=p+36|0;R=f[I+36>>2]|0;f[Q>>2]=R;S=p+40|0;f[S>>2]=J;T=p+48|0;U=p+44|0;f[U>>2]=T;f[T>>2]=0;f[p+52>>2]=0;if(R|0){V=R+12|0;f[V>>2]=(f[V>>2]|0)+1}if((f[j>>2]|0)<3){j=f[I+44>>2]|0;V=f[U>>2]|0;f[V>>2]=f[j>>2];f[V+4>>2]=f[j+4>>2]}else{f[O>>2]=0;jL(p,I)}f[q>>2]=f[p>>2];I=q+4|0;j=f[O>>2]|0;f[I>>2]=j;V=q+8|0;f[V>>2]=f[J>>2];R=q+12|0;f[R>>2]=f[K>>2];W=q+16|0;f[W>>2]=f[G>>2];X=q+20|0;f[X>>2]=f[M>>2];Z=q+24|0;f[Z>>2]=f[N>>2];_=q+28|0;f[_>>2]=f[L>>2];$=q+32|0;f[$>>2]=f[H>>2];aa=q+36|0;ba=f[Q>>2]|0;f[aa>>2]=ba;ca=q+40|0;f[ca>>2]=V;da=q+48|0;ea=q+44|0;f[ea>>2]=da;f[da>>2]=0;f[q+52>>2]=0;if(!ba)fa=j;else{j=ba+12|0;f[j>>2]=(f[j>>2]|0)+1;fa=f[O>>2]|0}if((fa|0)<3){fa=f[U>>2]|0;j=f[ea>>2]|0;f[j>>2]=f[fa>>2];f[j+4>>2]=f[fa+4>>2]}else{f[I>>2]=0;jL(q,p)}a:do if((e|0)<0)ga=e;else{fa=d+4|0;j=r+4|0;ba=r+8|0;ha=r+12|0;ia=(i|0)==5;ja=l+36|0;ka=l+16|0;la=l+4|0;ma=l+40|0;na=l+44|0;oa=l+48|0;pa=r+8|0;qa=r+12|0;ra=r+4|0;sa=s+8|0;ta=s+4|0;ua=i|16;va=w&4091;wa=l+4|0;xa=r+4|0;ya=r+8|0;za=r+12|0;Aa=l+36|0;Ba=l+4|0;Ca=l+8|0;Da=l+12|0;Ea=l+44|0;Fa=l+16|0;Ga=l+20|0;Ha=l+24|0;Ia=l+28|0;Ja=l+32|0;Ka=l+40|0;La=l+48|0;Ma=l+8|0;Na=l+12|0;Oa=l+4|0;Pa=r+8|0;Qa=r+4|0;Ra=(h|0)==5;Sa=l+8|0;Ta=l+12|0;Ua=l+4|0;Va=r+8|0;Wa=r+4|0;Xa=h|16;Ya=0;while(1){if(Ya|0){Za=KM(c,Y(Ya,v)|0)|0;_a=Za+16|0;if(f[_a>>2]|0){$a=f[Za+4>>2]|0;if(($a|0)<3)ab=Y(f[Za+12>>2]|0,f[Za+8>>2]|0)|0;else{bb=f[Za+40>>2]|0;cb=0;db=1;while(1){eb=Y(f[bb+(cb<<2)>>2]|0,db)|0;cb=cb+1|0;if((cb|0)==($a|0)){ab=eb;break}else db=eb}}if(!(($a|0)==0|(ab|0)==0)){db=f[fa>>2]|0;cb=f[d>>2]|0;vL(Za,db,db,cb,cb)|0}}cb=f[Za>>2]|0;db=f[B>>2]|0;bb=f[o>>2]|0;if(!((db^cb)&4095)){eb=f[d>>2]|0;if((f[Za+12>>2]|0)==((eb<<1)+bb|0)?(fb=f[fa>>2]|0,gb=f[a>>2]|0,(f[Za+8>>2]|0)==((fb<<1)+gb|0)):0){hb=eb;ib=fb;jb=bb;kb=gb}else{lb=eb;C=90}}else{lb=f[d>>2]|0;C=90}do if((C|0)==90){C=0;eb=f[a>>2]|0;gb=f[fa>>2]|0;fb=(gb<<1)+eb|0;mb=(lb<<1)+bb|0;nb=db&4095;if((((f[Za+4>>2]|0)<3?(f[Za+8>>2]|0)==(fb|0):0)?(f[Za+12>>2]|0)==(mb|0):0)?!((cb&4095|0)!=(nb|0)|(f[_a>>2]|0)==0):0){hb=lb;ib=gb;jb=bb;kb=eb;break}f[l>>2]=fb;f[wa>>2]=mb;hL(Za,2,l,nb);hb=f[d>>2]|0;ib=f[fa>>2]|0;jb=f[o>>2]|0;kb=f[a>>2]|0}while(0);f[r>>2]=hb;f[xa>>2]=ib;f[ya>>2]=jb;f[za>>2]=kb;nL(l,Za,r);bb=f[Aa>>2]|0;if(bb|0){_a=bb+12|0;f[_a>>2]=(f[_a>>2]|0)+1}_a=f[aa>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)kL(q);f[aa>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[I>>2]|0)>0){_a=f[ca>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0;ob=f[I>>2]|0}while((bb|0)<(ob|0));f[q>>2]=f[l>>2];if((ob|0)<3)C=105;else C=107}else{f[q>>2]=f[l>>2];C=105}if((C|0)==105){C=0;bb=f[Ba>>2]|0;if((bb|0)<3){f[I>>2]=bb;f[V>>2]=f[Ca>>2];f[R>>2]=f[Da>>2];bb=f[Ea>>2]|0;_a=f[ea>>2]|0;f[_a>>2]=f[bb>>2];f[_a+4>>2]=f[bb+4>>2]}else C=107}if((C|0)==107){C=0;jL(q,l)}f[W>>2]=f[Fa>>2];f[X>>2]=f[Ga>>2];f[Z>>2]=f[Ha>>2];f[_>>2]=f[Ia>>2];f[$>>2]=f[Ja>>2];bb=f[Aa>>2]|0;f[aa>>2]=bb;if(bb|0?(_a=bb+12|0,bb=f[_a>>2]|0,f[_a>>2]=bb+-1,(bb|0)==1):0)kL(l);f[Aa>>2]=0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=0;f[Fa+12>>2]=0;if((f[Ba>>2]|0)>0){bb=f[Ka>>2]|0;_a=0;do{f[bb+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[Ba>>2]|0))}_a=f[Ea>>2]|0;if((_a|0)!=(La|0))UC(_a);f[Ma>>2]=0;f[Na>>2]=0;f[l>>2]=16842752;f[Oa>>2]=p;_a=Pa;f[_a>>2]=0;f[_a+4>>2]=0;f[r>>2]=33619968;f[Qa>>2]=q;F1(l,r,o,4);if(!Ra){f[Sa>>2]=0;f[Ta>>2]=0;f[l>>2]=16842752;f[Ua>>2]=q;_a=Va;f[_a>>2]=0;f[_a+4>>2]=0;f[r>>2]=33619968;f[Wa>>2]=Za;_a=f[fa>>2]|0;bb=f[d>>2]|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;f[s+20>>2]=0;f[s+24>>2]=0;f[s+28>>2]=0;_P(l,r,_a,_a,bb,bb,Xa,s)}bb=0-(f[fa>>2]|0)|0;_a=0-(f[d>>2]|0)|0;vL(Za,bb,bb,_a,_a)|0}if(g){_a=KM(c,(Y(Ya,v)|0)+1|0)|0;bb=_a+16|0;if(f[bb>>2]|0){cb=f[_a+4>>2]|0;if((cb|0)<3)pb=Y(f[_a+12>>2]|0,f[_a+8>>2]|0)|0;else{db=f[_a+40>>2]|0;$a=0;nb=1;while(1){mb=Y(f[db+($a<<2)>>2]|0,nb)|0;$a=$a+1|0;if(($a|0)==(cb|0)){pb=mb;break}else nb=mb}}if(!((cb|0)==0|(pb|0)==0)){nb=f[fa>>2]|0;$a=f[d>>2]|0;vL(_a,nb,nb,$a,$a)|0}}$a=f[_a>>2]&4095;nb=f[o>>2]|0;if(($a|0)==(w|0)){db=f[d>>2]|0;if((f[_a+12>>2]|0)==((db<<1)+nb|0)?(Za=f[fa>>2]|0,mb=f[a>>2]|0,(f[_a+8>>2]|0)==((Za<<1)+mb|0)):0){qb=db;rb=Za;sb=nb;tb=mb}else{ub=db;C=131}}else{ub=f[d>>2]|0;C=131}do if((C|0)==131){C=0;db=f[a>>2]|0;mb=f[fa>>2]|0;Za=(mb<<1)+db|0;fb=(ub<<1)+nb|0;if((((f[_a+4>>2]|0)<3?(f[_a+8>>2]|0)==(Za|0):0)?(f[_a+12>>2]|0)==(fb|0):0)?!(($a|0)!=(va|0)|(f[bb>>2]|0)==0):0){qb=ub;rb=mb;sb=nb;tb=db;break}f[l>>2]=Za;f[wa>>2]=fb;hL(_a,2,l,va);qb=f[d>>2]|0;rb=f[fa>>2]|0;sb=f[o>>2]|0;tb=f[a>>2]|0}while(0);f[r>>2]=qb;f[j>>2]=rb;f[ba>>2]=sb;f[ha>>2]=tb;nL(l,_a,r);Nsa(q,l);if(!ia){f[pa>>2]=0;f[qa>>2]=0;f[r>>2]=16842752;f[ra>>2]=l;nb=sa;f[nb>>2]=0;f[nb+4>>2]=0;f[s>>2]=33619968;f[ta>>2]=_a;nb=f[fa>>2]|0;bb=f[d>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;f[t+24>>2]=0;f[t+28>>2]=0;_P(r,s,nb,nb,bb,bb,ua,t)}bb=0-(f[fa>>2]|0)|0;nb=0-(f[d>>2]|0)|0;vL(_a,bb,bb,nb,nb)|0;nb=f[ja>>2]|0;if(nb|0?(bb=nb+12|0,nb=f[bb>>2]|0,f[bb>>2]=nb+-1,(nb|0)==1):0)kL(l);f[ja>>2]=0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[la>>2]|0)>0){nb=f[ma>>2]|0;bb=0;do{f[nb+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[la>>2]|0))}bb=f[na>>2]|0;if((bb|0)!=(oa|0))UC(bb)}bb=((f[o>>2]|0)+1|0)/2|0;nb=((f[a>>2]|0)+1|0)/2|0;f[o>>2]=bb;f[a>>2]=nb;if((bb|0)<=(f[d>>2]|0))break;if((nb|0)<=(f[fa>>2]|0))break;nb=f[aa>>2]|0;if(nb|0){bb=nb+12|0;f[bb>>2]=(f[bb>>2]|0)+1}bb=f[Q>>2]|0;if(bb|0?(nb=bb+12|0,bb=f[nb>>2]|0,f[nb>>2]=bb+-1,(bb|0)==1):0)kL(p);f[Q>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[O>>2]|0)>0){bb=f[S>>2]|0;nb=0;do{f[bb+(nb<<2)>>2]=0;nb=nb+1|0;vb=f[O>>2]|0}while((nb|0)<(vb|0));f[p>>2]=f[q>>2];if((vb|0)<3)C=160;else C=162}else{f[p>>2]=f[q>>2];C=160}if((C|0)==160){C=0;nb=f[I>>2]|0;if((nb|0)<3){f[O>>2]=nb;f[J>>2]=f[V>>2];f[K>>2]=f[R>>2];nb=f[ea>>2]|0;bb=f[U>>2]|0;f[bb>>2]=f[nb>>2];f[bb+4>>2]=f[nb+4>>2]}else C=162}if((C|0)==162){C=0;jL(p,q)}f[G>>2]=f[W>>2];f[M>>2]=f[X>>2];f[N>>2]=f[Z>>2];f[L>>2]=f[_>>2];f[H>>2]=f[$>>2];f[Q>>2]=f[aa>>2];if((Ya|0)<(e|0))Ya=Ya+1|0;else{ga=e;break a}}aM(c,1,Y(Ya+1|0,v)|0,0,-1,1,0);ga=Ya}while(0);v=f[aa>>2]|0;if(v|0?(c=v+12|0,v=f[c>>2]|0,f[c>>2]=v+-1,(v|0)==1):0)kL(q);f[aa>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[I>>2]|0)>0){W=f[ca>>2]|0;ca=0;do{f[W+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[I>>2]|0))}I=f[ea>>2]|0;if((I|0)!=(da|0))UC(I);I=f[Q>>2]|0;if(I|0?(da=I+12|0,I=f[da>>2]|0,f[da>>2]=I+-1,(I|0)==1):0)kL(p);f[Q>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[O>>2]|0)>0){G=f[S>>2]|0;S=0;do{f[G+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[O>>2]|0))}O=f[U>>2]|0;if((O|0)!=(T|0))UC(O);O=n+36|0;T=f[O>>2]|0;if(T|0?(U=T+12|0,T=f[U>>2]|0,f[U>>2]=T+-1,(T|0)==1):0)kL(n);f[O>>2]=0;O=n+16|0;T=n+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[T>>2]|0)>0){O=f[P>>2]|0;P=0;do{f[O+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[T>>2]|0))}T=f[n+44>>2]|0;if((T|0)!=(n+48|0))UC(T);if(!(f[m+4>>2]|0)){u=k;return ga|0}u=k;return ga|0}function Nsa(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+1056|0;g=e;i=f[a+8>>2]|0;k=f[a+12>>2]|0;l=f[a>>2]|0;m=(l>>>3&511)+1|0;n=Y(m,k)|0;if(l&7|0){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,10)|0;o=359571;p=l+10|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(p|0));bO(-215,g,359582,359305,60);bD(g)}o=(m<<4)+4091&4091;if(!(((((f[c+4>>2]|0)<3?(f[c+8>>2]|0)==(i|0):0)?(f[c+12>>2]|0)==(k|0):0)?(f[c>>2]&4095|0)==(o|0):0)?(f[c+16>>2]|0)!=0:0)){f[g>>2]=i;f[g+4>>2]=k;hL(c,2,g,o)}o=(Y(m,k+2|0)|0)+15&-16;l=(o<<1)+64|0;p=g+8|0;f[g>>2]=p;q=g+4|0;f[q>>2]=l;if(l>>>0>520){r=N5b(l>>>0>2147483647?-1:l<<1)|0;f[g>>2]=r;s=r}else s=p;r=s+(m<<1)+15&-16;l=r+(o<<1)|0;if((i|0)>0){o=(i|0)!=1;t=o&1;v=i+-1|0;w=o?i+-2|0:0;o=(n|0)>0;x=(k|0)>1;y=x?m:0;z=Y(m,x?k+-2|0:0)|0;k=f[a+16>>2]|0;x=f[f[a+44>>2]>>2]|0;a=f[c+16>>2]|0;A=f[f[c+44>>2]>>2]|0;c=0;do{B=k+(Y(x,(c|0)>0?c+-1|0:t)|0)|0;C=k+(Y(x,c)|0)|0;D=c;c=c+1|0;E=k+(Y(x,(D|0)<(v|0)?c:w)|0)|0;F=a+(Y(A,D)|0)|0;if(o){D=0;do{G=h[B+D>>0]|0;H=h[E+D>>0]|0;d[r+(D<<1)>>1]=((H+G|0)*3|0)+((h[C+D>>0]|0)*10|0);d[l+(D<<1)>>1]=H-G;D=D+1|0}while((D|0)!=(n|0));I=0}else I=0;do{D=I+y|0;C=I-m|0;d[r+(C<<1)>>1]=d[r+(D<<1)>>1]|0;E=I+z|0;B=I+n|0;d[r+(B<<1)>>1]=d[r+(E<<1)>>1]|0;d[l+(C<<1)>>1]=d[l+(D<<1)>>1]|0;d[l+(B<<1)>>1]=d[l+(E<<1)>>1]|0;I=I+1|0}while((I|0)!=(m|0));if(o){E=0;do{B=E+m|0;D=E-m|0;C=(((d[l+(D<<1)>>1]|0)+(d[l+(B<<1)>>1]|0)|0)*3|0)+((d[l+(E<<1)>>1]|0)*10|0)&65535;G=E<<1;d[F+(G<<1)>>1]=(j[r+(B<<1)>>1]|0)-(j[r+(D<<1)>>1]|0);d[F+((G|1)<<1)>>1]=C;E=E+1|0}while((E|0)!=(n|0))}}while((c|0)!=(i|0))}if((s|0)==(p|0)){u=e;return}P5b(s);f[g>>2]=p;f[q>>2]=520;u=e;return}function Osa(a){a=a|0;O5b(a);return}function Psa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Qsa(a){a=a|0;xY(a);O5b(a);return}function Rsa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0;j=u;u=u+576|0;k=j+512|0;l=j+504|0;m=j+448|0;o=j+440|0;q=j+384|0;r=j+328|0;s=j+272|0;t=j+244|0;v=j+232|0;w=j+176|0;x=j+120|0;y=j+264|0;z=j+256|0;A=j+32|0;B=j+104|0;C=j;dQ(l,104844);do if((yM(e)|0)==65536){D=f[e+4>>2]|0;f[m>>2]=f[D>>2];E=m+4|0;F=D+4|0;f[E>>2]=f[F>>2];G=m+8|0;f[G>>2]=f[D+8>>2];f[m+12>>2]=f[D+12>>2];f[m+16>>2]=f[D+16>>2];f[m+20>>2]=f[D+20>>2];f[m+24>>2]=f[D+24>>2];f[m+28>>2]=f[D+28>>2];f[m+32>>2]=f[D+32>>2];H=f[D+36>>2]|0;f[m+36>>2]=H;f[m+40>>2]=G;G=m+48|0;I=m+44|0;f[I>>2]=G;f[G>>2]=0;f[m+52>>2]=0;if(H|0){G=H+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[D+44>>2]|0;G=f[I>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];break}else{f[E>>2]=0;jL(m,D);break}}else yL(m,e,-1);while(0);e=a+12|0;if(!(((f[e>>2]|0)>-1?(f[a+4>>2]|0)>2:0)?(f[a+8>>2]|0)>2:0)){f[k>>2]=0;f[k+4>>2]=0;J=aD(k,56)|0;K=359795;L=J+56|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-215,k,359852,359305,1241);bD(k)}D=wM(m,2,5,1)|0;if((D|0)>-1)if(!D){$L(g);$L(h);$L(i)}else M=16;else{f[k>>2]=0;f[k+4>>2]=0;J=aD(k,51)|0;K=359857;L=J+51|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-215,k,359852,359305,1244);bD(k);M=16}if((M|0)==16){E=a+32|0;if(!(f[E>>2]&4)){F=f[m+40>>2]|0;G=f[F>>2]|0;f[o>>2]=f[F+4>>2];f[o+4>>2]=G;vM(g,o,f[m>>2]&4095,-1,1,0)}do if((yM(g)|0)==65536){o=f[g+4>>2]|0;f[q>>2]=f[o>>2];G=q+4|0;F=o+4|0;f[G>>2]=f[F>>2];I=q+8|0;f[I>>2]=f[o+8>>2];f[q+12>>2]=f[o+12>>2];f[q+16>>2]=f[o+16>>2];f[q+20>>2]=f[o+20>>2];f[q+24>>2]=f[o+24>>2];f[q+28>>2]=f[o+28>>2];f[q+32>>2]=f[o+32>>2];H=f[o+36>>2]|0;f[q+36>>2]=H;f[q+40>>2]=I;I=q+48|0;N=q+44|0;f[N>>2]=I;f[I>>2]=0;f[q+52>>2]=0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[F>>2]|0)<3){F=f[o+44>>2]|0;I=f[N>>2]|0;f[I>>2]=f[F>>2];f[I+4>>2]=f[F+4>>2];break}else{f[G>>2]=0;jL(q,o);break}}else yL(q,g,-1);while(0);if((wM(q,2,5,1)|0)!=(D|0)){f[k>>2]=0;f[k+4>>2]=0;J=aD(k,45)|0;K=359909;L=J+45|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-215,k,359852,359305,1258);bD(k)}g=f[m+16>>2]|0;o=q+16|0;G=f[o>>2]|0;F=q+44|0;aM(h,D,1,0,-1,1,0);do if((yM(h)|0)==65536){I=f[h+4>>2]|0;f[r>>2]=f[I>>2];N=r+4|0;H=I+4|0;f[N>>2]=f[H>>2];O=r+8|0;f[O>>2]=f[I+8>>2];f[r+12>>2]=f[I+12>>2];f[r+16>>2]=f[I+16>>2];f[r+20>>2]=f[I+20>>2];f[r+24>>2]=f[I+24>>2];f[r+28>>2]=f[I+28>>2];f[r+32>>2]=f[I+32>>2];P=f[I+36>>2]|0;f[r+36>>2]=P;f[r+40>>2]=O;O=r+48|0;Q=r+44|0;f[Q>>2]=O;f[O>>2]=0;f[r+52>>2]=0;if(P|0){O=P+12|0;f[O>>2]=(f[O>>2]|0)+1}if((f[H>>2]|0)<3){H=f[I+44>>2]|0;O=f[Q>>2]|0;f[O>>2]=f[H>>2];f[O+4>>2]=f[H+4>>2];R=r;break}else{f[N>>2]=0;jL(r,I);R=r;break}}else{yL(r,h,-1);R=r}while(0);f[s>>2]=1124007936;h=s+4|0;I=s+8|0;N=s+40|0;J=h;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[N>>2]=I;H=s+48|0;O=s+44|0;f[O>>2]=H;f[H>>2]=0;f[s+52>>2]=0;if(!(f[R>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;J=aD(k,24)|0;K=359955;L=J+24|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-215,k,359852,359305,1265);bD(k)}R=r+16|0;Q=f[R>>2]|0;P=r+44|0;if((D|0)>0)Nac(Q|0,1,D|0)|0;if(PM(i)|0){aM(i,D,1,5,-1,1,0);do if((yM(i)|0)==65536){S=f[i+4>>2]|0;f[k>>2]=f[S>>2];T=k+4|0;U=S+4|0;f[T>>2]=f[U>>2];V=k+8|0;f[V>>2]=f[S+8>>2];f[k+12>>2]=f[S+12>>2];f[k+16>>2]=f[S+16>>2];f[k+20>>2]=f[S+20>>2];f[k+24>>2]=f[S+24>>2];f[k+28>>2]=f[S+28>>2];f[k+32>>2]=f[S+32>>2];W=k+36|0;X=f[S+36>>2]|0;f[W>>2]=X;f[k+40>>2]=V;V=k+48|0;Z=k+44|0;f[Z>>2]=V;f[V>>2]=0;f[k+52>>2]=0;if(X|0){V=X+12|0;f[V>>2]=(f[V>>2]|0)+1}if((f[U>>2]|0)<3){U=f[S+44>>2]|0;V=f[Z>>2]|0;f[V>>2]=f[U>>2];f[V+4>>2]=f[U+4>>2];_=W;break}else{f[T>>2]=0;jL(k,S);_=W;break}}else{yL(k,i,-1);_=k+36|0}while(0);i=f[_>>2]|0;if(i|0){W=i+12|0;f[W>>2]=(f[W>>2]|0)+1}W=s+36|0;i=f[W>>2]|0;if(i|0?(S=i+12|0,i=f[S>>2]|0,f[S>>2]=i+-1,(i|0)==1):0)kL(s);f[W>>2]=0;i=s+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[h>>2]|0)>0){S=f[N>>2]|0;T=0;do{f[S+(T<<2)>>2]=0;T=T+1|0;$=f[h>>2]|0}while((T|0)<($|0));f[s>>2]=f[k>>2];if(($|0)<3)M=56;else M=58}else{f[s>>2]=f[k>>2];M=56}if((M|0)==56){$=f[k+4>>2]|0;if(($|0)<3){f[h>>2]=$;f[I>>2]=f[k+8>>2];f[s+12>>2]=f[k+12>>2];I=f[k+44>>2]|0;$=f[O>>2]|0;f[$>>2]=f[I>>2];f[$+4>>2]=f[I+4>>2]}else M=58}if((M|0)==58)jL(s,k);I=k+16|0;f[i>>2]=f[I>>2];f[s+20>>2]=f[k+20>>2];f[s+24>>2]=f[k+24>>2];f[s+28>>2]=f[k+28>>2];f[s+32>>2]=f[k+32>>2];$=f[_>>2]|0;f[W>>2]=$;if($|0?(W=$+12|0,$=f[W>>2]|0,f[W>>2]=$+-1,($|0)==1):0)kL(k);f[_>>2]=0;_=k+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[_>>2]|0)>0){I=f[k+40>>2]|0;$=0;do{f[I+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[_>>2]|0))}_=f[k+44>>2]|0;if((_|0)!=(k+48|0))UC(_);if(!(f[s>>2]&16384)){f[k>>2]=0;f[k+4>>2]=0;J=aD(k,21)|0;K=359980;L=J+21|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-215,k,359852,359305,1276);bD(k)}aa=f[i>>2]|0}else aa=0;f[t>>2]=0;i=t+4|0;f[i>>2]=0;f[t+8>>2]=0;f[v>>2]=0;_=v+4|0;f[_>>2]=0;f[v+8>>2]=0;if((yM(c)|0)==327680){AM(c,t);$=(f[i>>2]|0)-(f[t>>2]|0)|0;i=(($|0)/56|0)+-1|0;if(($|0)<=0){f[k>>2]=0;f[k+4>>2]=0;J=aD(k,12)|0;K=360002;L=J+12|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-215,k,359852,359305,1291);bD(k)}if(((i|0)%2|0|0)==1?($=f[t>>2]|0,I=f[$+56>>2]|0,(I&7|0)==3?((f[$>>2]|0)>>>2&1022|1|0)==(I>>>3&511|0):0):0){ba=2;ca=(i|0)/2|0}else{ba=1;ca=i}if((ca|0)>0){f[k>>2]=0;i=k+4|0;f[i>>2]=0;f[w>>2]=0;I=w+4|0;f[I>>2]=0;uL((f[t>>2]|0)+(ba*56|0)|0,k,w);$=f[w>>2]|0;W=f[a+4>>2]|0;do if(($|0)>=(W|0)?(T=f[I>>2]|0,S=f[a+8>>2]|0,(T|0)>=(S|0)):0){U=f[t>>2]|0;if((W+$+(f[U+(ba*56|0)+12>>2]|0)|0)>(f[k>>2]|0)){M=81;break}if((S+T+(f[U+(ba*56|0)+8>>2]|0)|0)>(f[i>>2]|0))M=81}else M=81;while(0);if((M|0)==81){f[x>>2]=0;f[x+4>>2]=0;Vac(aD(x,187)|0,360015,187)|0;bO(-215,x,359852,359305,1307);bD(x)}}if((ca|0)<(f[e>>2]|0)){f[e>>2]=ca;da=ba;ea=ca}else{da=ba;ea=ca}}else{da=1;ea=-1}if((yM(d)|0)==327680){AM(d,v);ca=(f[_>>2]|0)-(f[v>>2]|0)|0;_=((ca|0)/56|0)+-1|0;if((ca|0)<=0){f[k>>2]=0;f[k+4>>2]=0;J=aD(k,12)|0;K=360203;L=J+12|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-215,k,359852,359305,1319);bD(k)}if(((_|0)%2|0|0)==1?(ca=f[v>>2]|0,ba=f[ca+56>>2]|0,(ba&7|0)==3?((f[ca>>2]|0)>>>2&1022|1|0)==(ba>>>3&511|0):0):0){fa=2;ga=(_|0)/2|0}else{fa=1;ga=_}if((ga|0)>0){f[k>>2]=0;_=k+4|0;f[_>>2]=0;f[w>>2]=0;ba=w+4|0;f[ba>>2]=0;uL((f[v>>2]|0)+(fa*56|0)|0,k,w);ca=f[w>>2]|0;i=f[a+4>>2]|0;do if((ca|0)>=(i|0)){$=f[ba>>2]|0;W=f[a+8>>2]|0;if(($|0)<(W|0)){M=96;break}I=f[v>>2]|0;if((i+ca+(f[I+(fa*56|0)+12>>2]|0)|0)>(f[k>>2]|0)){M=96;break}if((W+$+(f[I+(fa*56|0)+8>>2]|0)|0)>(f[_>>2]|0))M=96}else M=96;while(0);if((M|0)==96){f[x>>2]=0;f[x+4>>2]=0;Vac(aD(x,187)|0,360216,187)|0;bO(-215,x,359852,359305,1335);bD(x)}}if((ga|0)<(f[e>>2]|0)){f[e>>2]=ga;ha=fa;ia=ga}else{ha=fa;ia=ga}}else{ha=1;ia=-1}if((ea|0)<0){ea=k+8|0;f[ea>>2]=0;f[ea+4>>2]=0;f[k>>2]=33882112;f[k+4>>2]=t;f[y>>2]=f[a+4>>2];f[y+4>>2]=f[a+8>>2];ea=Msa(c,k,y,f[e>>2]|0,0,4,0,1)|0;f[e>>2]=ea}if((ia|0)<0){ia=k+8|0;f[ia>>2]=0;f[ia+4>>2]=0;f[k>>2]=33882112;f[k+4>>2]=v;f[z>>2]=f[a+4>>2];f[z+4>>2]=f[a+8>>2];ia=Msa(d,k,z,f[e>>2]|0,0,4,0,1)|0;f[e>>2]=ia}ia=a+16|0;z=f[ia>>2]|0;d=a+20|0;if(!(z&1))ja=30;else{ea=f[d>>2]|0;y=(ea|0)>0?ea:0;ja=(y|0)<100?y:100}f[d>>2]=ja;ja=a+24|0;if(!(z&2))ka=.01;else{la=+p[ja>>3];ma=la<0.0?0.0:la;ka=ma>10.0?10.0:ma}p[ja>>3]=ka*ka;f[w>>2]=1124007936;ja=w+4|0;z=w+8|0;d=w+40|0;J=ja;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[d>>2]=z;z=w+48|0;y=w+44|0;f[y>>2]=z;f[z>>2]=0;f[w+52>>2]=0;ea=(da|0)==1;if(ea){c=f[t>>2]|0;ga=(f[a+4>>2]<<1)+(f[c+12>>2]|0)|0;fa=f[c>>2]<<1&4080|11;f[k>>2]=(f[a+8>>2]<<1)+(f[c+8>>2]|0);f[k+4>>2]=ga;hL(w,2,k,fa)}fa=f[e>>2]|0;if((fa|0)>-1){ga=k+4|0;c=k+8|0;_=k+40|0;ca=k+48|0;i=k+44|0;ba=k+52|0;I=a+8|0;$=a+4|0;W=w+16|0;U=B+4|0;T=B+8|0;S=B+12|0;V=A+36|0;Z=k+36|0;X=k+16|0;na=A+4|0;oa=A+8|0;pa=A+12|0;qa=k+12|0;ra=A+44|0;sa=A+16|0;ta=A+20|0;ua=k+20|0;va=A+24|0;wa=k+24|0;xa=A+28|0;ya=k+28|0;za=A+32|0;Aa=k+32|0;Ba=A+40|0;Ca=A+48|0;Da=A+8|0;Ea=A+12|0;Fa=A+4|0;Ga=B+8|0;Ha=B+4|0;Ia=x+36|0;Ja=x+16|0;Ka=x+4|0;La=x+40|0;Ma=x+44|0;Na=x+48|0;Oa=x+4|0;Pa=a+40|0;a=A+32|0;Qa=A+36|0;Ra=A+40|0;Sa=A+4|0;Ta=A+12|0;Ua=A+8|0;Va=A+16|0;Wa=A+20|0;Xa=A+24|0;Ya=A+28|0;Za=A+56|0;_a=A+60|0;$a=A+64|0;ab=A+68|0;bb=x+4|0;cb=x+4|0;db=fa;while(1){f[k>>2]=1124007936;J=ga;L=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(L|0));f[_>>2]=c;f[i>>2]=ca;f[ca>>2]=0;f[ba>>2]=0;fa=Y(db,da)|0;do if(ea){eb=f[(f[t>>2]|0)+(fa*56|0)+40>>2]|0;fb=f[eb+4>>2]|0;gb=f[eb>>2]|0;Qi(x,(f[I>>2]<<1)+gb|0,(f[$>>2]<<1)+fb|0,f[w>>2]&4095,f[W>>2]|0,0);eb=f[I>>2]|0;f[B>>2]=f[$>>2];f[U>>2]=eb;f[T>>2]=fb;f[S>>2]=gb;nL(A,x,B);gb=f[V>>2]|0;if(gb|0){fb=gb+12|0;f[fb>>2]=(f[fb>>2]|0)+1}fb=f[Z>>2]|0;do if(fb|0){gb=fb+12|0;eb=f[gb>>2]|0;f[gb>>2]=eb+-1;if((eb|0)!=1)break;kL(k)}while(0);f[Z>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[ga>>2]|0)>0){fb=f[_>>2]|0;eb=0;do{f[fb+(eb<<2)>>2]=0;eb=eb+1|0;hb=f[ga>>2]|0}while((eb|0)<(hb|0));f[k>>2]=f[A>>2];if((hb|0)<3)M=123;else M=125}else{f[k>>2]=f[A>>2];M=123}do if((M|0)==123){M=0;eb=f[na>>2]|0;if((eb|0)>=3){M=125;break}f[ga>>2]=eb;f[c>>2]=f[oa>>2];f[qa>>2]=f[pa>>2];eb=f[ra>>2]|0;fb=f[i>>2]|0;f[fb>>2]=f[eb>>2];f[fb+4>>2]=f[eb+4>>2]}while(0);if((M|0)==125){M=0;jL(k,A)}f[X>>2]=f[sa>>2];f[ua>>2]=f[ta>>2];f[wa>>2]=f[va>>2];f[ya>>2]=f[xa>>2];f[Aa>>2]=f[za>>2];eb=f[V>>2]|0;f[Z>>2]=eb;do if(eb|0){fb=eb+12|0;gb=f[fb>>2]|0;f[fb>>2]=gb+-1;if((gb|0)!=1)break;kL(A)}while(0);f[V>>2]=0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[na>>2]|0)>0){eb=f[Ba>>2]|0;gb=0;do{f[eb+(gb<<2)>>2]=0;gb=gb+1|0}while((gb|0)<(f[na>>2]|0))}gb=f[ra>>2]|0;if((gb|0)!=(Ca|0))UC(gb);Nsa((f[t>>2]|0)+(fa*56|0)|0,k);f[Da>>2]=0;f[Ea>>2]=0;f[A>>2]=16842752;f[Fa>>2]=k;gb=Ga;f[gb>>2]=0;f[gb+4>>2]=0;f[B>>2]=33619968;f[Ha>>2]=x;gb=f[I>>2]|0;eb=f[$>>2]|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;f[C+16>>2]=0;f[C+20>>2]=0;f[C+24>>2]=0;f[C+28>>2]=0;_P(A,B,gb,gb,eb,eb,16,C);eb=f[Ia>>2]|0;do if(eb|0){gb=eb+12|0;fb=f[gb>>2]|0;f[gb>>2]=fb+-1;if((fb|0)!=1)break;kL(x)}while(0);f[Ia>>2]=0;f[Ja>>2]=0;f[Ja+4>>2]=0;f[Ja+8>>2]=0;f[Ja+12>>2]=0;if((f[Ka>>2]|0)>0){eb=f[La>>2]|0;fb=0;do{f[eb+(fb<<2)>>2]=0;fb=fb+1|0}while((fb|0)<(f[Ka>>2]|0))}fb=f[Ma>>2]|0;if((fb|0)!=(Na|0))UC(fb)}else{fb=fa+1|0;eb=f[t>>2]|0;gb=eb+(fb*56|0)|0;if((k|0)==(gb|0))break;ib=eb+(fb*56|0)+36|0;jb=f[ib>>2]|0;do if(jb|0){kb=jb+12|0;f[kb>>2]=(f[kb>>2]|0)+1;kb=f[Z>>2]|0;if(!kb)break;lb=kb+12|0;kb=f[lb>>2]|0;f[lb>>2]=kb+-1;if((kb|0)!=1)break;kL(k)}while(0);f[Z>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[ga>>2]|0)>0){jb=f[_>>2]|0;kb=0;do{f[jb+(kb<<2)>>2]=0;kb=kb+1|0;mb=f[ga>>2]|0}while((kb|0)<(mb|0));f[k>>2]=f[gb>>2];if((mb|0)<3)M=153;else M=155}else{f[k>>2]=f[gb>>2];M=153}do if((M|0)==153){M=0;kb=f[eb+(fb*56|0)+4>>2]|0;if((kb|0)>=3){M=155;break}f[ga>>2]=kb;f[c>>2]=f[eb+(fb*56|0)+8>>2];f[qa>>2]=f[eb+(fb*56|0)+12>>2];kb=f[eb+(fb*56|0)+44>>2]|0;jb=f[i>>2]|0;f[jb>>2]=f[kb>>2];f[jb+4>>2]=f[kb+4>>2]}while(0);if((M|0)==155){M=0;jL(k,gb)}f[X>>2]=f[eb+(fb*56|0)+16>>2];f[ua>>2]=f[eb+(fb*56|0)+20>>2];f[wa>>2]=f[eb+(fb*56|0)+24>>2];f[ya>>2]=f[eb+(fb*56|0)+28>>2];f[Aa>>2]=f[eb+(fb*56|0)+32>>2];f[Z>>2]=f[ib>>2]}while(0);kb=f[t>>2]|0;jb=f[kb+(fa*56|0)+40>>2]|0;lb=Y(db,ha)|0;nb=f[v>>2]|0;ob=f[nb+(lb*56|0)+40>>2]|0;if((f[jb>>2]|0)==(f[ob>>2]|0)?(f[jb+4>>2]|0)==(f[ob+4>>2]|0):0){pb=kb;qb=nb}else{f[x>>2]=0;f[cb>>2]=0;J=aD(x,68)|0;K=360404;L=J+68|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-215,x,359852,359305,1378);bD(x);pb=f[t>>2]|0;qb=f[v>>2]|0}if(!((f[qb+(lb*56|0)>>2]^f[pb+(fa*56|0)>>2])&4095)){rb=pb;sb=qb}else{f[x>>2]=0;f[bb>>2]=0;J=aD(x,68)|0;K=360473;L=J+68|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-215,x,359852,359305,1379);bD(x);rb=f[t>>2]|0;sb=f[v>>2]|0}f[x>>2]=0;f[Oa>>2]=D;nb=f[$>>2]|0;kb=f[I>>2]|0;ob=f[e>>2]|0;jb=f[E>>2]|0;ka=+p[Pa>>3];f[A>>2]=104688;f[Sa>>2]=rb+(fa*56|0);f[Ta>>2]=k;f[Ua>>2]=sb+(lb*56|0);f[Va>>2]=g;f[Wa>>2]=G;f[Xa>>2]=Q;f[Ya>>2]=aa;f[a>>2]=nb;f[Qa>>2]=kb;f[Ra>>2]=f[ia>>2];f[Ra+4>>2]=f[ia+4>>2];f[Ra+8>>2]=f[ia+8>>2];f[Ra+12>>2]=f[ia+12>>2];f[Za>>2]=db;f[_a>>2]=ob;f[$a>>2]=jb;n[ab>>2]=ka;RQ(x,A,-1.0);jb=f[Z>>2]|0;do if(jb|0){ob=jb+12|0;kb=f[ob>>2]|0;f[ob>>2]=kb+-1;if((kb|0)!=1)break;kL(k)}while(0);f[Z>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[ga>>2]|0)>0){jb=f[_>>2]|0;lb=0;do{f[jb+(lb<<2)>>2]=0;lb=lb+1|0}while((lb|0)<(f[ga>>2]|0))}lb=f[i>>2]|0;if((lb|0)!=(ca|0))UC(lb);if((db|0)>0)db=db+-1|0;else break}}db=w+36|0;ca=f[db>>2]|0;do if(ca|0){i=ca+12|0;ga=f[i>>2]|0;f[i>>2]=ga+-1;if((ga|0)!=1)break;kL(w)}while(0);f[db>>2]=0;db=w+16|0;f[db>>2]=0;f[db+4>>2]=0;f[db+8>>2]=0;f[db+12>>2]=0;if((f[ja>>2]|0)>0){db=f[d>>2]|0;d=0;do{f[db+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[ja>>2]|0))}ja=f[y>>2]|0;if((ja|0)!=(z|0))UC(ja);et(v);et(t);t=s+36|0;v=f[t>>2]|0;do if(v|0){ja=v+12|0;z=f[ja>>2]|0;f[ja>>2]=z+-1;if((z|0)!=1)break;kL(s)}while(0);f[t>>2]=0;t=s+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[h>>2]|0)>0){t=f[N>>2]|0;N=0;do{f[t+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[h>>2]|0))}h=f[O>>2]|0;if((h|0)!=(H|0))UC(h);h=r+36|0;H=f[h>>2]|0;do if(H|0){O=H+12|0;N=f[O>>2]|0;f[O>>2]=N+-1;if((N|0)!=1)break;kL(r)}while(0);f[h>>2]=0;h=r+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[h>>2]|0)>0){R=f[r+40>>2]|0;H=0;do{f[R+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[h>>2]|0))}h=f[P>>2]|0;if((h|0)!=(r+48|0))UC(h);h=q+36|0;r=f[h>>2]|0;do if(r|0){P=r+12|0;H=f[P>>2]|0;f[P>>2]=H+-1;if((H|0)!=1)break;kL(q)}while(0);f[h>>2]=0;h=q+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[h>>2]|0)>0){o=f[q+40>>2]|0;r=0;do{f[o+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[h>>2]|0))}h=f[F>>2]|0;if((h|0)!=(q+48|0))UC(h)}h=m+36|0;q=f[h>>2]|0;if(q|0?(F=q+12|0,q=f[F>>2]|0,f[F>>2]=q+-1,(q|0)==1):0)kL(m);f[h>>2]=0;h=m+16|0;q=m+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[q>>2]|0)>0){h=f[m+40>>2]|0;F=0;do{f[h+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[q>>2]|0))}q=f[m+44>>2]|0;if((q|0)!=(m+48|0))UC(q);if(!(f[l+4>>2]|0)){u=j;return}u=j;return}function Ssa(a,b){a=a|0;b=b|0;f[a>>2]=f[b+4>>2];f[a+4>>2]=f[b+8>>2];return}function Tsa(a,b){a=a|0;b=b|0;f[a+4>>2]=f[b>>2];f[a+8>>2]=f[b+4>>2];return}function Usa(a){a=a|0;return f[a+12>>2]|0}function Vsa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Wsa(a,b){a=a|0;b=b|0;var c=0;c=b+16|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];return}function Xsa(a,b){a=a|0;b=b|0;var c=0;c=a+16|0;f[c>>2]=f[b>>2];f[c+4>>2]=f[b+4>>2];f[c+8>>2]=f[b+8>>2];f[c+12>>2]=f[b+12>>2];return}function Ysa(a){a=a|0;return f[a+32>>2]|0}function Zsa(a,b){a=a|0;b=b|0;f[a+32>>2]=b;return}function _sa(a){a=a|0;return +(+p[a+40>>3])}function $sa(a,b){a=a|0;b=+b;p[a+40>>3]=b;return}function ata(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,q=0.0;m=f[h>>2]|0;n=f[h+4>>2]|0;h=f[j>>2]|0;o=f[j+4>>2]|0;q=+p[j+8>>3];j=L5b(48)|0;FY(j);f[j>>2]=104748;f[j+4>>2]=m;f[j+8>>2]=n;f[j+12>>2]=i;f[j+16>>2]=h;f[j+20>>2]=o;p[j+24>>3]=q;f[j+32>>2]=k;p[j+40>>3]=l;k=L5b(16)|0;o=k+4|0;f[o>>2]=1;f[k>>2]=104832;f[k+8>>2]=j;f[o>>2]=(f[o>>2]|0)+1;h=f[o>>2]|0;f[o>>2]=h+-1;if((h|0)==1)bi[f[(f[k>>2]|0)+8>>2]&2047](k);Qh[f[(f[j>>2]|0)+32>>2]&127](j,a,b,c,d,e,g);g=f[o>>2]|0;f[o>>2]=g+-1;if((g|0)!=1)return;bi[f[(f[k>>2]|0)+8>>2]&2047](k);return}function bta(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0;g=u;u=u+624|0;h=g+16|0;i=g+616|0;j=g+560|0;k=g+504|0;l=g+448|0;m=g+432|0;o=g+420|0;q=g+408|0;r=g+336|0;t=g+352|0;v=g+280|0;w=g+208|0;x=g+144|0;y=g+112|0;z=g+96|0;A=g+272|0;B=g+264|0;C=g+200|0;D=g+136|0;E=g+72|0;F=g+88|0;G=g;dQ(i,104864);f[j>>2]=1124007936;H=j+4|0;I=j+8|0;K=j+40|0;N=H;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[K>>2]=I;P=j+48|0;Q=j+44|0;f[Q>>2]=P;f[P>>2]=0;f[j+52>>2]=0;f[h>>2]=2;f[h+4>>2]=3;hL(j,2,h,6);do if((yM(c)|0)==65536){R=f[c+4>>2]|0;f[k>>2]=f[R>>2];S=k+4|0;T=R+4|0;f[S>>2]=f[T>>2];U=k+8|0;f[U>>2]=f[R+8>>2];f[k+12>>2]=f[R+12>>2];f[k+16>>2]=f[R+16>>2];f[k+20>>2]=f[R+20>>2];f[k+24>>2]=f[R+24>>2];f[k+28>>2]=f[R+28>>2];f[k+32>>2]=f[R+32>>2];V=f[R+36>>2]|0;f[k+36>>2]=V;f[k+40>>2]=U;U=k+48|0;W=k+44|0;f[W>>2]=U;f[U>>2]=0;f[k+52>>2]=0;if(V|0){U=V+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[T>>2]|0)<3){T=f[R+44>>2]|0;U=f[W>>2]|0;f[U>>2]=f[T>>2];f[U+4>>2]=f[T+4>>2];break}else{f[S>>2]=0;jL(k,R);break}}else yL(k,c,-1);while(0);do if((yM(d)|0)==65536){c=f[d+4>>2]|0;f[l>>2]=f[c>>2];R=l+4|0;S=c+4|0;f[R>>2]=f[S>>2];T=l+8|0;f[T>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];f[l+16>>2]=f[c+16>>2];f[l+20>>2]=f[c+20>>2];f[l+24>>2]=f[c+24>>2];f[l+28>>2]=f[c+28>>2];f[l+32>>2]=f[c+32>>2];U=f[c+36>>2]|0;f[l+36>>2]=U;W=l+40|0;f[W>>2]=T;T=l+48|0;V=l+44|0;f[V>>2]=T;f[T>>2]=0;f[l+52>>2]=0;if(U|0){T=U+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[S>>2]|0)<3){S=f[c+44>>2]|0;T=f[V>>2]|0;f[T>>2]=f[S>>2];f[T+4>>2]=f[S+4>>2];X=W;break}else{f[R>>2]=0;jL(l,c);X=W;break}}else{yL(l,d,-1);X=l+40|0}while(0);f[m>>2]=0;d=m+4|0;f[d>>2]=0;f[m+8>>2]=0;f[o>>2]=0;W=o+4|0;f[W>>2]=0;f[o+8>>2]=0;f[q>>2]=0;c=q+4|0;f[c>>2]=0;f[q+8>>2]=0;f[r>>2]=0;R=r+4|0;f[R>>2]=0;f[r+8>>2]=0;S=k+40|0;T=f[S>>2]|0;V=f[X>>2]|0;if((f[T>>2]|0)!=(f[V>>2]|0)?1:(f[T+4>>2]|0)!=(f[V+4>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;N=aD(h,41)|0;Y=360798;O=N+41|0;do{b[N>>0]=b[Y>>0]|0;N=N+1|0;Y=Y+1|0}while((N|0)<(O|0));bO(-209,h,360840,359305,1513);bD(h)}if((f[l>>2]^f[k>>2])&4095|0){f[h>>2]=0;f[h+4>>2]=0;N=aD(h,46)|0;Y=361149;O=N+46|0;do{b[N>>0]=b[Y>>0]|0;N=N+1|0;Y=Y+1|0}while((N|0)<(O|0));bO(-205,h,360840,359305,1516);bD(h)}V=wM(k,2,-1,1)|0;do if((V|0)>0){WL(t,k,2,V);T=h+8|0;f[T>>2]=0;f[T+4>>2]=0;f[h>>2]=-2113732595;f[h+4>>2]=m;OJ(t,h,5,1.0,0.0);T=t+36|0;U=f[T>>2]|0;if(U|0?(Z=U+12|0,U=f[Z>>2]|0,f[Z>>2]=U+-1,(U|0)==1):0)kL(t);f[T>>2]=0;T=t+16|0;U=t+4|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[U>>2]|0)>0){T=f[t+40>>2]|0;Z=0;do{f[T+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[U>>2]|0))}U=f[t+44>>2]|0;if((U|0)!=(t+48|0))UC(U);WL(v,l,2,V);U=h+8|0;f[U>>2]=0;f[U+4>>2]=0;f[h>>2]=-2113732595;f[h+4>>2]=o;OJ(v,h,5,1.0,0.0);U=v+36|0;Z=f[U>>2]|0;if(Z|0?(T=Z+12|0,Z=f[T>>2]|0,f[T>>2]=Z+-1,(Z|0)==1):0)kL(v);f[U>>2]=0;U=v+16|0;Z=v+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[Z>>2]|0)>0){U=f[v+40>>2]|0;T=0;do{f[U+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[Z>>2]|0))}Z=f[v+44>>2]|0;if((Z|0)==(v+48|0)){_=1.0;$=V}else{UC(Z);_=1.0;$=V}}else{Z=f[k>>2]|0;if(Z&7|0){f[h>>2]=0;f[h+4>>2]=0;N=aD(h,52)|0;Y=360893;O=N+52|0;do{b[N>>0]=b[Y>>0]|0;N=N+1|0;Y=Y+1|0}while((N|0)<(O|0));bO(-210,h,360840,359305,1596);bD(h);_=1.0;$=V;break}T=Z>>>3;U=T&511;switch(T&511){case 0:case 2:case 3:break;default:{f[h>>2]=0;f[h+4>>2]=0;N=aD(h,29)|0;Y=360863;O=N+29|0;do{b[N>>0]=b[Y>>0]|0;N=N+1|0;Y=Y+1|0}while((N|0)<(O|0));bO(-215,h,360840,359305,1528);bD(h)}}Z=f[S>>2]|0;T=f[Z+4>>2]|0;aa=f[Z>>2]|0;ba=+(T|0);ca=160.0/ba;da=+(aa|0);ea=120.0/da;fa=ca<ea?ea:ca;ca=fa>1.0?fa:1.0;Z=MVb(ba*ca)|0;ga=MVb(da*ca)|0;ha=(U|0)!=0;if(ha|((Z|0)!=(T|0)|(ga|0)!=(aa|0))){f[h>>2]=1124007936;aa=h+4|0;T=h+8|0;ia=h+40|0;N=aa;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[ia>>2]=T;U=h+48|0;ja=h+44|0;f[ja>>2]=U;f[U>>2]=0;f[h+52>>2]=0;f[w>>2]=1124007936;ka=w+4|0;la=w+8|0;ma=w+40|0;N=ka;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[ma>>2]=la;na=w+48|0;oa=w+44|0;f[oa>>2]=na;f[na>>2]=0;f[w+52>>2]=0;if(ha){f[x>>2]=1124007936;pa=x+4|0;qa=x+8|0;ra=x+40|0;N=pa;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[ra>>2]=qa;ha=x+48|0;sa=x+44|0;f[sa>>2]=ha;f[ha>>2]=0;f[x+52>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=k;ta=z+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=x;D1(y,z,6,0);f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=x;ta=z+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=h;f[A>>2]=Z;f[A+4>>2]=ga;Lia(y,z,A,0.0,0.0,3);f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=l;ta=z+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=x;D1(y,z,6,0);f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=x;ta=z+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=w;f[B>>2]=Z;f[B+4>>2]=ga;Lia(y,z,B,0.0,0.0,3);ta=x+36|0;ua=f[ta>>2]|0;if(ua|0?(va=ua+12|0,ua=f[va>>2]|0,f[va>>2]=ua+-1,(ua|0)==1):0)kL(x);f[ta>>2]=0;ta=x+16|0;f[ta>>2]=0;f[ta+4>>2]=0;f[ta+8>>2]=0;f[ta+12>>2]=0;if((f[pa>>2]|0)>0){ta=f[ra>>2]|0;ua=0;do{f[ta+(ua<<2)>>2]=0;ua=ua+1|0}while((ua|0)<(f[pa>>2]|0))}pa=f[sa>>2]|0;if((pa|0)!=(ha|0))UC(pa)}else{f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=k;pa=y+8|0;f[pa>>2]=0;f[pa+4>>2]=0;f[y>>2]=33619968;f[y+4>>2]=h;f[C>>2]=Z;f[C+4>>2]=ga;Lia(x,y,C,0.0,0.0,3);f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=l;pa=y+8|0;f[pa>>2]=0;f[pa+4>>2]=0;f[y>>2]=33619968;f[y+4>>2]=w;f[D>>2]=Z;f[D+4>>2]=ga;Lia(x,y,D,0.0,0.0,3)}pa=h+36|0;ua=f[pa>>2]|0;if(ua|0){ta=ua+12|0;f[ta>>2]=(f[ta>>2]|0)+1}ta=k+36|0;ua=f[ta>>2]|0;if(ua|0?(ra=ua+12|0,ua=f[ra>>2]|0,f[ra>>2]=ua+-1,(ua|0)==1):0)kL(k);f[ta>>2]=0;ua=k+16|0;ra=k+4|0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;if((f[ra>>2]|0)>0){qa=f[S>>2]|0;va=0;do{f[qa+(va<<2)>>2]=0;va=va+1|0;wa=f[ra>>2]|0}while((va|0)<(wa|0));f[k>>2]=f[h>>2];if((wa|0)<3)xa=61;else xa=63}else{f[k>>2]=f[h>>2];xa=61}if((xa|0)==61){va=f[aa>>2]|0;if((va|0)<3){f[ra>>2]=va;f[k+8>>2]=f[T>>2];f[k+12>>2]=f[h+12>>2];va=f[ja>>2]|0;qa=f[k+44>>2]|0;f[qa>>2]=f[va>>2];f[qa+4>>2]=f[va+4>>2]}else xa=63}if((xa|0)==63)jL(k,h);va=h+16|0;f[ua>>2]=f[va>>2];f[k+20>>2]=f[h+20>>2];f[k+24>>2]=f[h+24>>2];f[k+28>>2]=f[h+28>>2];f[k+32>>2]=f[h+32>>2];f[ta>>2]=f[pa>>2];qa=w+36|0;ha=f[qa>>2]|0;if(ha|0){sa=ha+12|0;f[sa>>2]=(f[sa>>2]|0)+1}sa=l+36|0;ha=f[sa>>2]|0;if(ha|0?(ya=ha+12|0,ha=f[ya>>2]|0,f[ya>>2]=ha+-1,(ha|0)==1):0)kL(l);f[sa>>2]=0;ha=l+16|0;ya=l+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ya>>2]|0)>0){za=f[X>>2]|0;Aa=0;do{f[za+(Aa<<2)>>2]=0;Aa=Aa+1|0;Ba=f[ya>>2]|0}while((Aa|0)<(Ba|0));f[l>>2]=f[w>>2];if((Ba|0)<3)xa=74;else xa=76}else{f[l>>2]=f[w>>2];xa=74}if((xa|0)==74){Aa=f[ka>>2]|0;if((Aa|0)<3){f[ya>>2]=Aa;f[l+8>>2]=f[la>>2];f[l+12>>2]=f[w+12>>2];Aa=f[oa>>2]|0;za=f[l+44>>2]|0;f[za>>2]=f[Aa>>2];f[za+4>>2]=f[Aa+4>>2]}else xa=76}if((xa|0)==76)jL(l,w);Aa=w+16|0;f[ha>>2]=f[Aa>>2];f[l+20>>2]=f[w+20>>2];f[l+24>>2]=f[w+24>>2];f[l+28>>2]=f[w+28>>2];f[l+32>>2]=f[w+32>>2];za=f[qa>>2]|0;f[sa>>2]=za;if(za|0?(ta=za+12|0,za=f[ta>>2]|0,f[ta>>2]=za+-1,(za|0)==1):0)kL(w);f[qa>>2]=0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[Aa+8>>2]=0;f[Aa+12>>2]=0;if((f[ka>>2]|0)>0){Aa=f[ma>>2]|0;za=0;do{f[Aa+(za<<2)>>2]=0;za=za+1|0}while((za|0)<(f[ka>>2]|0))}ka=f[oa>>2]|0;if((ka|0)!=(na|0))UC(ka);ka=f[pa>>2]|0;do if(ka|0){za=ka+12|0;Aa=f[za>>2]|0;f[za>>2]=Aa+-1;if((Aa|0)!=1)break;kL(h)}while(0);f[pa>>2]=0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;if((f[aa>>2]|0)>0){ka=f[ia>>2]|0;na=0;do{f[ka+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[aa>>2]|0))}aa=f[ja>>2]|0;if((aa|0)!=(U|0))UC(aa)}aa=MVb(+(Z|0)*15.0/+(ga|0))|0;na=aa*15|0;ka=f[d>>2]|0;ia=f[m>>2]|0;va=ka-ia>>3;pa=ia;ia=ka;if(na>>>0<=va>>>0){if(na>>>0<va>>>0?(ka=pa+(na<<3)|0,(ia|0)!=(ka|0)):0)f[d>>2]=ia+(~((ia+-8-ka|0)>>>3)<<3)}else cta(m,na-va|0);va=f[W>>2]|0;ka=f[o>>2]|0;ia=va-ka>>3;pa=ka;ka=va;if(na>>>0<=ia>>>0){if(na>>>0<ia>>>0?(va=pa+(na<<3)|0,(ka|0)!=(va|0)):0)f[W>>2]=ka+(~((ka+-8-va|0)>>>3)<<3)}else cta(o,na-ia|0);ia=f[R>>2]|0;va=f[r>>2]|0;ka=ia-va|0;pa=va;va=ia;if(na>>>0<=ka>>>0){if(na>>>0<ka>>>0?(ia=pa+na|0,(va|0)!=(ia|0)):0)f[R>>2]=ia}else DL(r,na-ka|0);ka=(aa|0)>0;da=+(Z|0);ba=+(aa|0);ia=f[m>>2]|0;fa=+(ga|0);if(ka){va=0;pa=0;while(1){ea=fa*(+(va|0)+.5)/15.0;oa=0;Aa=pa;while(1){n[ia+(Aa<<3)>>2]=da*(+(oa|0)+.5)/ba;n[ia+(Aa<<3)+4>>2]=ea;oa=oa+1|0;if((oa|0)==(aa|0))break;else Aa=Aa+1|0}va=va+1|0;if((va|0)==15)break;else pa=aa+pa|0}}f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=16842752;f[w+4>>2]=k;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=l;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=-2130509811;f[y+4>>2]=m;pa=z+8|0;f[pa>>2]=0;f[pa+4>>2]=0;f[z>>2]=-2096955379;f[z+4>>2]=o;pa=E+8|0;f[pa>>2]=0;f[pa+4>>2]=0;f[E>>2]=-2113732608;f[E+4>>2]=r;pa=UM()|0;f[F>>2]=21;f[F+4>>2]=21;f[G>>2]=1;f[G+4>>2]=40;p[G+8>>3]=.1;f[h>>2]=f[G>>2];f[h+4>>2]=f[G+4>>2];f[h+8>>2]=f[G+8>>2];f[h+12>>2]=f[G+12>>2];ata(w,x,y,z,E,pa,F,3,h,0,.0001);if(ka){pa=f[r>>2]|0;aa=0;va=0;while(1){if(!(b[pa+aa>>0]|0))Ca=va;else{if((aa|0)>(va|0)){ia=f[m>>2]|0;f[ia+(va<<3)>>2]=f[ia+(aa<<3)>>2];f[ia+(va<<3)+4>>2]=f[ia+(aa<<3)+4>>2];ia=f[o>>2]|0;f[ia+(va<<3)>>2]=f[ia+(aa<<3)>>2];f[ia+(va<<3)+4>>2]=f[ia+(aa<<3)+4>>2]}Ca=va+1|0}aa=aa+1|0;if((aa|0)>=(na|0)){Da=Ca;break}else va=Ca}}else Da=0;va=f[d>>2]|0;na=f[m>>2]|0;aa=va-na>>3;pa=na;na=va;if(Da>>>0<=aa>>>0){if(Da>>>0<aa>>>0?(va=pa+(Da<<3)|0,(na|0)!=(va|0)):0)f[d>>2]=na+(~((na+-8-va|0)>>>3)<<3)}else cta(m,Da-aa|0);aa=f[W>>2]|0;va=f[o>>2]|0;na=aa-va>>3;pa=aa;if(Da>>>0>na>>>0){cta(o,Da-na|0);_=ca;$=Da;break}if(Da>>>0<na>>>0?(na=va+(Da<<3)|0,(pa|0)!=(na|0)):0){f[W>>2]=pa+(~((pa+-8-na|0)>>>3)<<3);_=ca;$=Da}else{_=ca;$=Da}}while(0);Da=f[c>>2]|0;Ca=f[q>>2]|0;F=Da-Ca>>2;E=Ca;Ca=Da;if($>>>0<=F>>>0){if($>>>0<F>>>0?(Da=E+($<<2)|0,(Ca|0)!=(Da|0)):0)f[c>>2]=Ca+(~((Ca+-4-Da|0)>>>2)<<2)}else HC(q,$-F|0);if(($|0)>=3){f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=-2130509811;f[w+4>>2]=o;jea(h,w);F=x+4|0;Da=w+4|0;Ca=x+8|0;E=x+12|0;z=w+8|0;G=x+16|0;Ba=x+20|0;wa=y+4|0;D=y+8|0;C=y+12|0;B=y+16|0;A=y+20|0;Y=j+16|0;ba=+($|0)*.5;V=h+8|0;v=h+12|0;h=0;t=-1;na=-1;while(1){f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[y+16>>2]=0;f[y+20>>2]=0;pa=f[m>>2]|0;va=f[o>>2]|0;aa=0;ka=t;ia=na;ga=f[x>>2]|0;Z=f[F>>2]|0;U=f[Ca>>2]|0;ja=f[E>>2]|0;Aa=f[G>>2]|0;oa=f[Ba>>2]|0;za=f[y>>2]|0;ma=f[wa>>2]|0;qa=f[D>>2]|0;sa=f[C>>2]|0;ha=f[B>>2]|0;la=f[A>>2]|0;a:while(1){ya=w+(aa<<2)|0;ta=(aa|0)>0;ua=(aa|0)==2;T=0;ra=la;Ea=ha;Fa=sa;Ga=qa;Ha=ma;Ia=za;Ja=oa;Ka=Aa;La=ja;Ma=U;Na=Z;Oa=ga;Pa=ka;Qa=ia;while(1){Ra=cbc(Pa|0,0,-130063606,0)|0;Pa=Kac(Ra|0,J|0,Qa|0,0)|0;Qa=J;Ra=(Pa>>>0)%($>>>0)|0;f[ya>>2]=Ra;b:do if(ta){Sa=pa+(Ra<<3)|0;Ta=pa+(Ra<<3)+4|0;Ua=va+(Ra<<3)|0;Va=va+(Ra<<3)+4|0;Wa=0;while(1){Xa=f[w+(Wa<<2)>>2]|0;if((Xa|0)==(Ra|0)){Ya=ra;Za=Ea;_a=Fa;$a=Ga;ab=Ha;bb=Ia;cb=Ja;db=Ka;eb=La;fb=Ma;gb=Na;hb=Oa;break b}da=+L(+(+n[Sa>>2]-+n[pa+(Xa<<3)>>2]));if(da+ +L(+(+n[Ta>>2]-+n[pa+(Xa<<3)+4>>2]))<1.1920928955078125e-07){Ya=ra;Za=Ea;_a=Fa;$a=Ga;ab=Ha;bb=Ia;cb=Ja;db=Ka;eb=La;fb=Ma;gb=Na;hb=Oa;break b}da=+L(+(+n[Ua>>2]-+n[va+(Xa<<3)>>2]));Wa=Wa+1|0;if(da+ +L(+(+n[Va>>2]-+n[va+(Xa<<3)+4>>2]))<1.1920928955078125e-07){Ya=ra;Za=Ea;_a=Fa;$a=Ga;ab=Ha;bb=Ia;cb=Ja;db=Ka;eb=La;fb=Ma;gb=Na;hb=Oa;break b}if((Wa|0)>=(aa|0)){xa=148;break}}}else xa=148;while(0);if((xa|0)==148){xa=0;if(!ua){ib=Oa;jb=Na;kb=Ma;lb=La;mb=Ka;nb=Ja;ob=Ia;pb=Ha;qb=Ga;rb=Fa;sb=Ea;tb=ra;break}Ra=f[w>>2]|0;Wa=f[pa+(Ra<<3)>>2]|0;Va=f[pa+(Ra<<3)+4>>2]|0;Ua=f[Da>>2]|0;Ta=f[pa+(Ua<<3)>>2]|0;Sa=f[pa+(Ua<<3)+4>>2]|0;Xa=f[z>>2]|0;ub=f[pa+(Xa<<3)>>2]|0;vb=f[pa+(Xa<<3)+4>>2]|0;wb=f[va+(Ra<<3)>>2]|0;xb=f[va+(Ra<<3)+4>>2]|0;Ra=f[va+(Ua<<3)>>2]|0;yb=f[va+(Ua<<3)+4>>2]|0;Ua=f[va+(Xa<<3)>>2]|0;zb=f[va+(Xa<<3)+4>>2]|0;da=(f[s>>2]=Ta,+n[s>>2]);fa=(f[s>>2]=Wa,+n[s>>2]);ea=da-fa;da=(f[s>>2]=Sa,+n[s>>2]);Ab=(f[s>>2]=Va,+n[s>>2]);Bb=da-Ab;da=(f[s>>2]=ub,+n[s>>2])-fa;fa=(f[s>>2]=vb,+n[s>>2])-Ab;Ab=(f[s>>2]=Ra,+n[s>>2]);Cb=(f[s>>2]=wb,+n[s>>2]);Db=Ab-Cb;Ab=(f[s>>2]=yb,+n[s>>2]);Eb=(f[s>>2]=xb,+n[s>>2]);Fb=Ab-Eb;Ab=(f[s>>2]=Ua,+n[s>>2])-Cb;Cb=(f[s>>2]=zb,+n[s>>2])-Eb;if(!(+L(+(ea*fa-Bb*da))<+M(+(ea*ea+Bb*Bb))*.01*+M(+(da*da+fa*fa)))?!(+L(+(Db*Cb-Fb*Ab))<+M(+(Db*Db+Fb*Fb))*.01*+M(+(Ab*Ab+Cb*Cb))):0){ib=Wa;jb=Va;kb=Ta;lb=Sa;mb=ub;nb=vb;ob=wb;pb=xb;qb=Ra;rb=yb;sb=Ua;tb=zb;break}else{Ya=zb;Za=Ua;_a=yb;$a=Ra;ab=xb;bb=wb;cb=vb;db=ub;eb=Sa;fb=Ta;gb=Va;hb=Wa}}Wa=T+1|0;if((Wa|0)>=500){xa=158;break a}else{T=Wa;ra=Ya;Ea=Za;Fa=_a;Ga=$a;Ha=ab;Ia=bb;Ja=cb;Ka=db;La=eb;Ma=fb;Na=gb;Oa=hb}}aa=aa+1|0;if((T|0)>499){Gb=ib;Hb=jb;Ib=kb;Jb=lb;Kb=mb;Lb=nb;Mb=ob;Nb=pb;Ob=qb;Pb=rb;Qb=sb;Rb=tb;xa=159;break}if((aa|0)>=3){xa=153;break}else{ka=Pa;ia=Qa;ga=ib;Z=jb;U=kb;ja=lb;Aa=mb;oa=nb;za=ob;ma=pb;qa=qb;sa=rb;ha=sb;la=tb}}if((xa|0)==153){xa=0;f[x>>2]=ib;f[F>>2]=jb;f[Ca>>2]=kb;f[E>>2]=lb;f[G>>2]=mb;f[Ba>>2]=nb;f[y>>2]=ob;f[wa>>2]=pb;f[D>>2]=qb;f[C>>2]=rb;f[B>>2]=sb;f[A>>2]=tb;dta(x,y,3,j,e);ia=f[Y>>2]|0;ka=f[m>>2]|0;ca=+p[ia+16>>3];aa=f[o>>2]|0;Cb=+p[ia+24>>3];Ab=+p[ia+32>>3];Fb=+p[ia+40>>3];va=f[q>>2]|0;Db=+p[ia>>3];fa=+p[ia+8>>3];ia=0;pa=0;while(1){da=+n[ka+(pa<<3)>>2];Bb=+n[ka+(pa<<3)+4>>2];ea=+L(+(ca+(Db*da+fa*Bb)-+n[aa+(pa<<3)>>2]));Eb=+L(+(Fb+(da*Cb+Bb*Ab)-+n[aa+(pa<<3)+4>>2]));Oa=f[V>>2]|0;Na=f[v>>2]|0;if(ea+Eb<+(((Oa|0)<(Na|0)?Na:Oa)|0)*.05){f[va+(ia<<2)>>2]=pa;Sb=ia+1|0}else Sb=ia;pa=pa+1|0;if((pa|0)==($|0))break;else ia=Sb}if(+(Sb|0)>=ba){xa=161;break}}else if((xa|0)==158){xa=0;f[x>>2]=ga;f[F>>2]=Z;f[Ca>>2]=U;f[E>>2]=ja;f[G>>2]=Aa;f[Ba>>2]=oa;f[y>>2]=za;f[wa>>2]=ma;f[D>>2]=qa;f[C>>2]=sa;f[B>>2]=ha;f[A>>2]=la;Gb=hb;Hb=gb;Ib=fb;Jb=eb;Kb=db;Lb=cb;Mb=bb;Nb=ab;Ob=$a;Pb=_a;Qb=Za;Rb=Ya;xa=159}if((xa|0)==159){xa=0;f[x>>2]=Gb;f[F>>2]=Hb;f[Ca>>2]=Ib;f[E>>2]=Jb;f[G>>2]=Kb;f[Ba>>2]=Lb;f[y>>2]=Mb;f[wa>>2]=Nb;f[D>>2]=Ob;f[C>>2]=Pb;f[B>>2]=Qb;f[A>>2]=Rb}ia=h+1|0;if((ia|0)<500){h=ia;t=Pa;na=Qa}else{xa=162;break}}do if((xa|0)==161)if((h|0)<=499){if((Sb|0)<($|0)&(Sb|0)>0){Qa=f[q>>2]|0;na=f[m>>2]|0;Pa=f[o>>2]|0;t=0;do{Rb=f[Qa+(t<<2)>>2]|0;f[na+(t<<3)>>2]=f[na+(Rb<<3)>>2];f[na+(t<<3)+4>>2]=f[na+(Rb<<3)+4>>2];f[Pa+(t<<3)>>2]=f[Pa+(Rb<<3)>>2];f[Pa+(t<<3)+4>>2]=f[Pa+(Rb<<3)+4>>2];t=t+1|0}while((t|0)!=(Sb|0))}dta(f[m>>2]|0,f[o>>2]|0,Sb,j,e);t=f[Y>>2]|0;Pa=t+16|0;p[Pa>>3]=+p[Pa>>3]/_;Pa=t+(f[f[Q>>2]>>2]|0)+16|0;p[Pa>>3]=+p[Pa>>3]/_;f[a>>2]=f[j>>2];Pa=a+4|0;na=f[H>>2]|0;f[Pa>>2]=na;Qa=a+8|0;f[Qa>>2]=f[I>>2];f[a+12>>2]=f[j+12>>2];f[a+16>>2]=t;f[a+20>>2]=f[j+20>>2];f[a+24>>2]=f[j+24>>2];f[a+28>>2]=f[j+28>>2];f[a+32>>2]=f[j+32>>2];t=f[j+36>>2]|0;f[a+36>>2]=t;f[a+40>>2]=Qa;Qa=a+48|0;la=a+44|0;f[la>>2]=Qa;f[Qa>>2]=0;f[a+52>>2]=0;if(!t)Tb=na;else{na=t+12|0;f[na>>2]=(f[na>>2]|0)+1;Tb=f[H>>2]|0}if((Tb|0)<3){na=f[Q>>2]|0;t=f[la>>2]|0;f[t>>2]=f[na>>2];f[t+4>>2]=f[na+4>>2];break}else{f[Pa>>2]=0;jL(a,j);break}}else xa=162;while(0);if((xa|0)==162){f[a>>2]=1124007936;xa=a+8|0;Tb=a+40|0;N=a+4|0;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[Tb>>2]=xa;xa=a+48|0;f[a+44>>2]=xa;f[xa>>2]=0;f[a+52>>2]=0}}else{f[a>>2]=1124007936;xa=a+8|0;Tb=a+40|0;N=a+4|0;O=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(O|0));f[Tb>>2]=xa;xa=a+48|0;f[a+44>>2]=xa;f[xa>>2]=0;f[a+52>>2]=0}a=f[r>>2]|0;if(a|0){if((f[R>>2]|0)!=(a|0))f[R>>2]=a;O5b(a)}a=f[q>>2]|0;if(a|0){q=f[c>>2]|0;if((q|0)!=(a|0))f[c>>2]=q+(~((q+-4-a|0)>>>2)<<2);O5b(a)}a=f[o>>2]|0;if(a|0){o=f[W>>2]|0;if((o|0)!=(a|0))f[W>>2]=o+(~((o+-8-a|0)>>>3)<<3);O5b(a)}a=f[m>>2]|0;if(a|0){m=f[d>>2]|0;if((m|0)!=(a|0))f[d>>2]=m+(~((m+-8-a|0)>>>3)<<3);O5b(a)}a=l+36|0;m=f[a>>2]|0;if(m|0?(d=m+12|0,m=f[d>>2]|0,f[d>>2]=m+-1,(m|0)==1):0)kL(l);f[a>>2]=0;a=l+16|0;m=l+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[m>>2]|0)>0){a=f[X>>2]|0;X=0;do{f[a+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))UC(m);m=k+36|0;l=f[m>>2]|0;if(l|0?(X=l+12|0,l=f[X>>2]|0,f[X>>2]=l+-1,(l|0)==1):0)kL(k);f[m>>2]=0;m=k+16|0;l=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){m=f[S>>2]|0;S=0;do{f[m+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))UC(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(S=k+12|0,k=f[S>>2]|0,f[S>>2]=k+-1,(k|0)==1):0)kL(j);f[l>>2]=0;l=j+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[H>>2]|0)>0){l=f[K>>2]|0;K=0;do{f[l+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[H>>2]|0))}H=f[Q>>2]|0;if((H|0)!=(P|0))UC(H);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function cta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(d-g>>3>>>0>=b>>>0){Nac(g|0,0,b<<3|0)|0;f[e>>2]=h+(b<<3);return}i=f[a>>2]|0;j=g-i>>3;g=j+b|0;k=i;if(g>>>0>536870911)c4b(a);l=d-i|0;d=l>>2;m=l>>3>>>0<268435455?(d>>>0<g>>>0?g:d):536870911;do if(m)if(m>>>0>536870911){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{n=L5b(m<<3)|0;break}else n=0;while(0);d=n+(j<<3)|0;j=n+(m<<3)|0;Nac(d|0,0,b<<3|0)|0;m=d+(b<<3)|0;if((h|0)==(k|0)){o=d;p=i}else{b=h+-8-i|0;i=h;h=d;do{n=h;h=h+-8|0;g=i;i=i+-8|0;f[h>>2]=f[i>>2];f[n+-4>>2]=f[g+-4>>2]}while((i|0)!=(k|0));o=d+(~(b>>>3)<<3)|0;p=f[a>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=j;if(!p)return;O5b(p);return}function dta(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0,J=0.0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0;h=u;u=u+608|0;i=h+104|0;j=h+56|0;k=h;l=h+552|0;m=h+496|0;o=h+440|0;q=h+424|0;r=h+408|0;s=h+392|0;if(!(f[e>>2]&16384)){f[i>>2]=0;f[i+4>>2]=0;t=aD(i,16)|0;v=360946;w=t+16|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,i,360963,359305,1418);bD(i)}if(g){Nac(i|0,0,288)|0;t=j;w=t+48|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));g=k+4|0;f[g>>2]=2;v=k+8|0;f[v>>2]=6;f[k+12>>2]=6;x=k+16|0;f[x>>2]=i;f[k+20>>2]=i;y=k+24|0;z=k+40|0;A=y+8|0;f[A>>2]=0;f[A+4>>2]=0;f[z>>2]=v;v=k+48|0;A=k+44|0;f[A>>2]=v;f[k>>2]=1124024326;f[v>>2]=48;f[k+52>>2]=8;f[k+28>>2]=i+288;f[y>>2]=i+288;y=l+4|0;f[y>>2]=2;B=l+8|0;f[B>>2]=6;f[l+12>>2]=1;C=l+16|0;f[C>>2]=j;f[l+20>>2]=j;D=l+24|0;E=l+40|0;F=D+8|0;f[F>>2]=0;f[F+4>>2]=0;f[E>>2]=B;B=l+48|0;F=l+44|0;f[F>>2]=B;f[l>>2]=1124024326;f[B>>2]=8;f[l+52>>2]=8;f[l+28>>2]=j+48;f[D>>2]=j+48;WL(m,e,1,6);D=i+64|0;G=+p[D>>3];H=i+8|0;I=+p[H>>3];J=+p[i>>3];K=i+16|0;L=+p[K>>3];M=i+56|0;N=+p[M>>3];if((d|0)>0){O=j+8|0;P=j+16|0;Q=j+24|0;R=j+32|0;S=j+40|0;T=0;U=+p[O>>3];V=+p[P>>3];W=+p[Q>>3];X=+p[R>>3];Y=+p[S>>3];Z=J;_=I;$=L;aa=N;ba=G;ca=+p[j>>3];do{da=+n[a+(T<<3)>>2];Z=Z+da*da;ea=+n[a+(T<<3)+4>>2];_=_+da*ea;$=$+da;aa=aa+ea*ea;ba=ba+ea;fa=+n[c+(T<<3)>>2];ca=ca+da*fa;U=ea*fa+U;V=fa+V;fa=+n[c+(T<<3)+4>>2];W=W+da*fa;X=ea*fa+X;Y=fa+Y;T=T+1|0}while((T|0)!=(d|0));p[i>>3]=Z;p[H>>3]=_;p[K>>3]=$;p[M>>3]=aa;p[D>>3]=ba;p[j>>3]=ca;p[O>>3]=U;p[P>>3]=V;p[Q>>3]=W;p[R>>3]=X;p[S>>3]=Y;ga=aa;ha=$;ia=Z;ja=_;ka=ba}else{ga=N;ha=L;ia=J;ja=I;ka=G}p[i+48>>3]=ja;p[i+216>>3]=ja;p[i+176>>3]=ja;p[i+96>>3]=ha;p[i+264>>3]=ha;p[i+184>>3]=ha;p[i+104>>3]=ka;p[i+272>>3]=ka;p[i+232>>3]=ka;p[i+168>>3]=ia;p[i+224>>3]=ga;ga=+(d|0);p[i+112>>3]=ga;p[i+280>>3]=ga;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;S=r+8|0;f[S>>2]=0;f[S+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=m;jT(o,q,r,2)|0;S=m+36|0;R=f[S>>2]|0;if(R|0?(Q=R+12|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)kL(m);f[S>>2]=0;S=m+16|0;R=m+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[R>>2]|0)>0){S=f[m+40>>2]|0;Q=0;do{f[S+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[R>>2]|0))}R=f[m+44>>2]|0;if((R|0)!=(m+48|0))UC(R);R=l+36|0;Q=f[R>>2]|0;if(Q|0?(S=Q+12|0,Q=f[S>>2]|0,f[S>>2]=Q+-1,(Q|0)==1):0)kL(l);f[R>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[y>>2]|0)>0){C=f[E>>2]|0;E=0;do{f[C+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[y>>2]|0))}y=f[F>>2]|0;if((y|0)!=(B|0))UC(y);y=k+36|0;B=f[y>>2]|0;if(B|0?(F=B+12|0,B=f[F>>2]|0,f[F>>2]=B+-1,(B|0)==1):0)kL(k);f[y>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[g>>2]|0)>0){x=f[z>>2]|0;z=0;do{f[x+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[g>>2]|0))}g=f[A>>2]|0;if((g|0)!=(v|0))UC(g);u=h;return}else{t=i;w=t+128|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;t=l+4|0;f[t>>2]=2;w=l+8|0;f[w>>2]=4;f[l+12>>2]=4;g=l+16|0;f[g>>2]=i;f[l+20>>2]=i;v=l+24|0;A=l+40|0;z=v+8|0;f[z>>2]=0;f[z+4>>2]=0;f[A>>2]=w;w=l+48|0;z=l+44|0;f[z>>2]=w;f[l>>2]=1124024326;f[w>>2]=32;f[l+52>>2]=8;f[l+28>>2]=i+128;f[v>>2]=i+128;v=m+4|0;f[v>>2]=2;x=m+8|0;f[x>>2]=4;f[m+12>>2]=1;y=m+16|0;f[y>>2]=j;f[m+20>>2]=j;B=m+24|0;F=m+40|0;E=B+8|0;f[E>>2]=0;f[E+4>>2]=0;f[F>>2]=x;x=m+48|0;E=m+44|0;f[E>>2]=x;f[m>>2]=1124024326;f[x>>2]=8;f[m+52>>2]=8;f[m+28>>2]=j+32;f[B>>2]=j+32;B=o+4|0;f[B>>2]=2;C=o+8|0;f[C>>2]=4;f[o+12>>2]=1;R=o+16|0;f[R>>2]=k;f[o+20>>2]=k;Q=o+24|0;S=o+40|0;P=Q+8|0;f[P>>2]=0;f[P+4>>2]=0;f[S>>2]=C;C=o+48|0;P=o+44|0;f[P>>2]=C;f[o>>2]=1124024326;f[C>>2]=8;f[o+52>>2]=8;f[o+28>>2]=k+32;f[Q>>2]=k+32;Q=i+24|0;ga=+p[Q>>3];ia=+p[i>>3];O=i+16|0;ka=+p[O>>3];if((d|0)>0){D=j+8|0;M=j+16|0;K=j+24|0;H=0;ha=ia;ja=ka;G=ga;I=+p[j>>3];J=+p[D>>3];L=+p[M>>3];N=+p[K>>3];do{ba=+n[a+(H<<3)>>2];_=+n[a+(H<<3)+4>>2];ha=ha+(ba*ba+_*_);ja=ja+ba;G=G+_;Z=+n[c+(H<<3)>>2];$=+n[c+(H<<3)+4>>2];I=I+(ba*Z+_*$);J=J+(ba*$-_*Z);L=Z+L;N=$+N;H=H+1|0}while((H|0)!=(d|0));p[i>>3]=ha;p[O>>3]=ja;p[Q>>3]=G;p[j>>3]=I;p[D>>3]=J;p[M>>3]=L;p[K>>3]=N;la=ja;ma=ha;na=G}else{la=ka;ma=ia;na=ga}p[i+40>>3]=ma;ma=-na;p[i+48>>3]=ma;p[i+72>>3]=ma;p[i+64>>3]=la;p[i+56>>3]=la;p[i+104>>3]=la;la=+(d|0);p[i+120>>3]=la;p[i+80>>3]=la;p[i+96>>3]=na;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;i=s+8|0;f[i>>2]=0;f[i+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=o;jT(q,r,s,2)|0;s=f[e+16>>2]|0;na=+p[k>>3];p[s+32>>3]=na;p[s>>3]=na;e=k+8|0;p[s+8>>3]=-+p[e>>3];p[s+24>>3]=+p[e>>3];p[s+16>>3]=+p[k+16>>3];p[s+40>>3]=+p[k+24>>3];k=o+36|0;s=f[k>>2]|0;if(s|0?(e=s+12|0,s=f[e>>2]|0,f[e>>2]=s+-1,(s|0)==1):0)kL(o);f[k>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[B>>2]|0)>0){R=f[S>>2]|0;S=0;do{f[R+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[B>>2]|0))}B=f[P>>2]|0;if((B|0)!=(C|0))UC(B);B=m+36|0;C=f[B>>2]|0;if(C|0?(P=C+12|0,C=f[P>>2]|0,f[P>>2]=C+-1,(C|0)==1):0)kL(m);f[B>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[v>>2]|0)>0){y=f[F>>2]|0;F=0;do{f[y+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[v>>2]|0))}v=f[E>>2]|0;if((v|0)!=(x|0))UC(v);v=l+36|0;x=f[v>>2]|0;if(x|0?(E=x+12|0,x=f[E>>2]|0,f[E>>2]=x+-1,(x|0)==1):0)kL(l);f[v>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[t>>2]|0)>0){g=f[A>>2]|0;A=0;do{f[g+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[t>>2]|0))}t=f[z>>2]|0;if((t|0)!=(w|0))UC(t);u=h;return}}function eta(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0.0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,ei=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,Zj=0,_j=0,$j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0,hk=0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0,ok=0,pk=0,qk=0,rk=0,sk=0,tk=0,uk=0,vk=0,wk=0,xk=0,yk=0,zk=0,Ak=0,Bk=0,Ck=0,Dk=0,Ek=0,Fk=0,Gk=0,Hk=0,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0,$k=0,al=0,bl=0,cl=0,dl=0,el=0,fl=0,gl=0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0,nl=0,ol=0,pl=0,ql=0,rl=0,sl=0,tl=0,ul=0,vl=0,wl=0,xl=0,yl=0,zl=0,Al=0,Bl=0,Cl=0,Dl=0,El=0,Fl=0.0,Gl=0,Hl=0.0,Il=0,Jl=0,Kl=0.0,Ll=0.0,Ml=0.0,Nl=0.0,Ol=0,Pl=0,Ql=0,Rl=0,Sl=0,Tl=0,Ul=0,Vl=0,Wl=0,Xl=0,Yl=0,Zl=0,_l=0.0,$l=0.0,am=0.0,bm=0.0,cm=0.0,dm=0,em=0,fm=0,gm=0,hm=0.0;i=u;u=u+5568|0;j=i+3264|0;k=i+3040|0;l=i+2816|0;m=i+2592|0;o=i+2144|0;q=i+1920|0;r=i+1472|0;t=i+1248|0;v=i+1024|0;w=i+800|0;x=i+576|0;y=i+352|0;z=i+5408|0;A=i+5352|0;B=i+128|0;C=i+5296|0;D=i+5240|0;E=i+5184|0;F=i+5128|0;G=i+5072|0;H=i+5016|0;I=i+4960|0;J=i+4904|0;K=i+4848|0;N=i+4792|0;Q=i+4736|0;R=i+4680|0;T=i+4624|0;U=i+4568|0;V=i+4512|0;W=i+4456|0;X=i+4400|0;Z=i+4344|0;_=i+4288|0;$=i+5560|0;aa=i+4232|0;ba=i+5552|0;ca=i+5544|0;da=i+4176|0;ea=i+2368|0;fa=i+4120|0;ga=i+1696|0;ha=i+4064|0;ia=i+4008|0;ja=i+3992|0;ka=i+5536|0;la=i+5528|0;ma=i+3936|0;na=i+3880|0;oa=i+3824|0;pa=i+3768|0;qa=i+3712|0;ra=i+3656|0;sa=i+3600|0;ta=i+3544|0;ua=i+3488|0;va=i+5520|0;wa=i+5512|0;xa=i+5504|0;ya=i+5496|0;za=i+5488|0;Aa=i+5480|0;Ba=i+5472|0;Ca=i+5464|0;Da=i+96|0;Ea=i+64|0;Fa=i+32|0;Ga=i;do if((yM(a)|0)==65536){Ha=f[a+4>>2]|0;f[H>>2]=f[Ha>>2];Ia=H+4|0;Ja=Ha+4|0;f[Ia>>2]=f[Ja>>2];Ka=H+8|0;f[Ka>>2]=f[Ha+8>>2];f[H+12>>2]=f[Ha+12>>2];f[H+16>>2]=f[Ha+16>>2];f[H+20>>2]=f[Ha+20>>2];f[H+24>>2]=f[Ha+24>>2];f[H+28>>2]=f[Ha+28>>2];f[H+32>>2]=f[Ha+32>>2];La=f[Ha+36>>2]|0;f[H+36>>2]=La;f[H+40>>2]=Ka;Ka=H+48|0;Ma=H+44|0;f[Ma>>2]=Ka;f[Ka>>2]=0;f[H+52>>2]=0;if(La|0){Ka=La+12|0;f[Ka>>2]=(f[Ka>>2]|0)+1}if((f[Ja>>2]|0)<3){Ja=f[Ha+44>>2]|0;Ka=f[Ma>>2]|0;f[Ka>>2]=f[Ja>>2];f[Ka+4>>2]=f[Ja+4>>2];break}else{f[Ia>>2]=0;jL(H,Ha);break}}else yL(H,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[I>>2]=f[a>>2];Ha=I+4|0;Ia=a+4|0;f[Ha>>2]=f[Ia>>2];Ja=I+8|0;f[Ja>>2]=f[a+8>>2];f[I+12>>2]=f[a+12>>2];f[I+16>>2]=f[a+16>>2];f[I+20>>2]=f[a+20>>2];f[I+24>>2]=f[a+24>>2];f[I+28>>2]=f[a+28>>2];f[I+32>>2]=f[a+32>>2];Ka=f[a+36>>2]|0;f[I+36>>2]=Ka;f[I+40>>2]=Ja;Ja=I+48|0;Ma=I+44|0;f[Ma>>2]=Ja;f[Ja>>2]=0;f[I+52>>2]=0;if(Ka|0){Ja=Ka+12|0;f[Ja>>2]=(f[Ja>>2]|0)+1}if((f[Ia>>2]|0)<3){Ia=f[a+44>>2]|0;Ja=f[Ma>>2]|0;f[Ja>>2]=f[Ia>>2];f[Ja+4>>2]=f[Ia+4>>2];break}else{f[Ha>>2]=0;jL(I,a);break}}else yL(I,c,-1);while(0);do if((yM(d)|0)==65536){c=f[d+4>>2]|0;f[J>>2]=f[c>>2];a=J+4|0;Ha=c+4|0;f[a>>2]=f[Ha>>2];Ia=J+8|0;f[Ia>>2]=f[c+8>>2];f[J+12>>2]=f[c+12>>2];f[J+16>>2]=f[c+16>>2];f[J+20>>2]=f[c+20>>2];f[J+24>>2]=f[c+24>>2];f[J+28>>2]=f[c+28>>2];f[J+32>>2]=f[c+32>>2];Ja=f[c+36>>2]|0;f[J+36>>2]=Ja;f[J+40>>2]=Ia;Ia=J+48|0;Ma=J+44|0;f[Ma>>2]=Ia;f[Ia>>2]=0;f[J+52>>2]=0;if(Ja|0){Ia=Ja+12|0;f[Ia>>2]=(f[Ia>>2]|0)+1}if((f[Ha>>2]|0)<3){Ha=f[c+44>>2]|0;Ia=f[Ma>>2]|0;f[Ia>>2]=f[Ha>>2];f[Ia+4>>2]=f[Ha+4>>2];break}else{f[a>>2]=0;jL(J,c);break}}else yL(J,d,-1);while(0);c=H+16|0;if(f[c>>2]|0){a=f[H+4>>2]|0;if((a|0)<3)Na=Y(f[H+12>>2]|0,f[H+8>>2]|0)|0;else{Ha=f[H+40>>2]|0;Ia=0;Ma=1;while(1){Ja=Y(f[Ha+(Ia<<2)>>2]|0,Ma)|0;Ia=Ia+1|0;if((Ia|0)==(a|0)){Na=Ja;break}else Ma=Ja}}if((a|0)==0|(Na|0)==0)Oa=28}else Oa=28;if((Oa|0)==28){f[j>>2]=0;f[j+4>>2]=0;Pa=aD(j,12)|0;Qa=361040;Ra=Pa+12|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361053,361070,325);bD(j)}Na=I+16|0;if(f[Na>>2]|0){a=f[I+4>>2]|0;if((a|0)<3)Sa=Y(f[I+12>>2]|0,f[I+8>>2]|0)|0;else{Ma=f[I+40>>2]|0;Ia=0;Ha=1;while(1){Ja=Y(f[Ma+(Ia<<2)>>2]|0,Ha)|0;Ia=Ia+1|0;if((Ia|0)==(a|0)){Sa=Ja;break}else Ha=Ja}}if((a|0)==0|(Sa|0)==0)Oa=35}else Oa=35;if((Oa|0)==35){f[j>>2]=0;f[j+4>>2]=0;Pa=aD(j,12)|0;Qa=361136;Ra=Pa+12|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361053,361070,326);bD(j)}Sa=J+16|0;if(f[Sa>>2]|0){a=f[J+4>>2]|0;if((a|0)<3)Ta=Y(f[J+12>>2]|0,f[J+8>>2]|0)|0;else{Ha=f[J+40>>2]|0;Ia=0;Ma=1;while(1){Ja=Y(f[Ha+(Ia<<2)>>2]|0,Ma)|0;Ia=Ia+1|0;if((Ia|0)==(a|0)){Ta=Ja;break}else Ma=Ja}}if((a|0)==0|(Ta|0)==0)Oa=42}else Oa=42;if((Oa|0)==42){Ta=(e|0)==3?3:2;aM(d,Ta,3,5,-1,0,0);do if((yM(d)|0)==65536){a=f[d+4>>2]|0;f[j>>2]=f[a>>2];Ma=j+4|0;Ia=a+4|0;f[Ma>>2]=f[Ia>>2];Ha=j+8|0;f[Ha>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];Ja=j+36|0;Ka=f[a+36>>2]|0;f[Ja>>2]=Ka;f[j+40>>2]=Ha;Ha=j+48|0;La=j+44|0;f[La>>2]=Ha;f[Ha>>2]=0;f[j+52>>2]=0;if(Ka|0){Ha=Ka+12|0;f[Ha>>2]=(f[Ha>>2]|0)+1}if((f[Ia>>2]|0)<3){Ia=f[a+44>>2]|0;Ha=f[La>>2]|0;f[Ha>>2]=f[Ia>>2];f[Ha+4>>2]=f[Ia+4>>2];Ua=Ja;break}else{f[Ma>>2]=0;jL(j,a);Ua=Ja;break}}else{yL(j,d,-1);Ua=j+36|0}while(0);d=f[Ua>>2]|0;if(d|0){Ja=d+12|0;f[Ja>>2]=(f[Ja>>2]|0)+1}Ja=J+36|0;d=f[Ja>>2]|0;if(d|0?(a=d+12|0,d=f[a>>2]|0,f[a>>2]=d+-1,(d|0)==1):0)kL(J);f[Ja>>2]=0;d=J+4|0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[d>>2]|0)>0){a=f[J+40>>2]|0;Ma=0;do{f[a+(Ma<<2)>>2]=0;Ma=Ma+1|0;Va=f[d>>2]|0}while((Ma|0)<(Va|0));f[J>>2]=f[j>>2];if((Va|0)<3)Oa=59;else Oa=61}else{f[J>>2]=f[j>>2];Oa=59}if((Oa|0)==59){Va=f[j+4>>2]|0;if((Va|0)<3){f[d>>2]=Va;f[J+8>>2]=f[j+8>>2];f[J+12>>2]=f[j+12>>2];Va=f[j+44>>2]|0;d=f[J+44>>2]|0;f[d>>2]=f[Va>>2];f[d+4>>2]=f[Va+4>>2]}else Oa=61}if((Oa|0)==61)jL(J,j);Va=j+16|0;f[Sa>>2]=f[Va>>2];f[J+20>>2]=f[j+20>>2];f[J+24>>2]=f[j+24>>2];f[J+28>>2]=f[j+28>>2];f[J+32>>2]=f[j+32>>2];d=f[Ua>>2]|0;f[Ja>>2]=d;if(d|0?(Ja=d+12|0,d=f[Ja>>2]|0,f[Ja>>2]=d+-1,(d|0)==1):0)kL(j);f[Ua>>2]=0;Ua=j+4|0;f[Va>>2]=0;f[Va+4>>2]=0;f[Va+8>>2]=0;f[Va+12>>2]=0;if((f[Ua>>2]|0)>0){Va=f[j+40>>2]|0;d=0;do{f[Va+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[Ua>>2]|0))}Ua=f[j+44>>2]|0;if((Ua|0)!=(j+48|0))UC(Ua);VS(j,Ta,3,5);Ta=f[j>>2]|0;th[f[(f[Ta>>2]|0)+12>>2]&511](Ta,j,J,-1);Wi(j)}Ta=f[H>>2]|0;if(!((f[I>>2]^Ta)&4095))Wa=Ta;else{f[j>>2]=0;f[j+4>>2]=0;Pa=aD(j,46)|0;Qa=361149;Ra=Pa+46|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-205,j,361053,361070,340);bD(j);Wa=f[H>>2]|0}switch(Wa&4095){case 5:case 0:break;default:{f[j>>2]=0;f[j+4>>2]=0;Pa=aD(j,35)|0;Qa=361196;Ra=Pa+35|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-210,j,361053,361070,344);bD(j)}}if((f[J>>2]&4095|0)!=5){f[j>>2]=0;f[j+4>>2]=0;Pa=aD(j,55)|0;Qa=361232;Ra=Pa+55|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-210,j,361053,361070,347);bD(j)}if((f[J+12>>2]|0)!=3){f[j>>2]=0;f[j+4>>2]=0;Pa=aD(j,13)|0;Qa=361288;Ra=Pa+13|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361053,361070,349);bD(j)}Wa=J+8|0;if((f[Wa>>2]&-2|0)!=2){f[j>>2]=0;f[j+4>>2]=0;Pa=aD(j,29)|0;Qa=361302;Ra=Pa+29|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361053,361070,350);bD(j)}switch(e|0){case 3:{if((f[Wa>>2]|0)!=3)Oa=84;break}case 2:case 1:case 0:break;default:{f[j>>2]=0;f[j+4>>2]=0;Vac(aD(j,132)|0,361332,132)|0;bO(-215,j,361053,361070,353);bD(j);if(!((e|0)!=3|(f[Wa>>2]|0)==3))Oa=84}}if((Oa|0)==84){f[j>>2]=0;f[j+4>>2]=0;Pa=aD(j,12)|0;Qa=361465;Ra=Pa+12|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361053,361070,356);bD(j)}Oa=f[g>>2]|0;if(!(Oa&3)){f[j>>2]=0;f[j+4>>2]=0;Pa=aD(j,72)|0;Qa=361478;Ra=Pa+72|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361053,361070,359);bD(j)}if(!(Oa&1))Xa=200;else Xa=f[g+4>>2]|0;if(!(Oa&2))Ya=-1.0;else Ya=+p[g+8>>3];switch(e|0){case 0:{Za=2;break}case 1:{Za=3;break}case 3:{Za=8;break}default:Za=6}g=f[H+12>>2]|0;Oa=f[H+8>>2]|0;Ta=f[I+12>>2]|0;Ua=f[I+8>>2]|0;f[K>>2]=1124007936;d=K+4|0;Va=K+8|0;Ja=K+40|0;Pa=d;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ja>>2]=Va;Va=K+48|0;Ma=K+44|0;f[Ma>>2]=Va;f[Va>>2]=0;f[K+52>>2]=0;f[j>>2]=1;a=j+4|0;f[a>>2]=g;hL(K,2,j,5);f[N>>2]=1124007936;Ia=N+4|0;Ha=N+8|0;La=N+40|0;Pa=Ia;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[La>>2]=Ha;Ha=N+48|0;Ka=N+44|0;f[Ka>>2]=Ha;f[Ha>>2]=0;f[N+52>>2]=0;f[j>>2]=Oa;f[a>>2]=1;hL(N,2,j,5);f[Q>>2]=1124007936;_a=Q+4|0;$a=Q+8|0;ab=Q+40|0;Pa=_a;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[ab>>2]=$a;$a=Q+48|0;bb=Q+44|0;f[bb>>2]=$a;f[$a>>2]=0;f[Q+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;hL(Q,2,j,5);f[R>>2]=1124007936;cb=R+4|0;db=R+8|0;eb=R+40|0;Pa=cb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[eb>>2]=db;db=R+48|0;fb=R+44|0;f[fb>>2]=db;f[db>>2]=0;f[R+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;hL(R,2,j,5);gb=K+16|0;hb=f[gb>>2]|0;ib=N+16|0;jb=f[ib>>2]|0;if((g|0)>0){kb=0;do{n[hb+(kb<<2)>>2]=+(kb|0);kb=kb+1|0}while((kb|0)!=(g|0))}if((Oa|0)>0){kb=0;do{n[jb+(kb<<2)>>2]=+(kb|0);kb=kb+1|0}while((kb|0)!=(Oa|0))}f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=K;kb=k+8|0;f[kb>>2]=0;f[kb+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=Q;YP(j,Oa,1,k);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=N;kb=k+8|0;f[kb>>2]=0;f[kb+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=R;YP(j,1,g,k);kb=K+36|0;jb=f[kb>>2]|0;if(jb|0?(hb=jb+12|0,jb=f[hb>>2]|0,f[hb>>2]=jb+-1,(jb|0)==1):0)kL(K);f[kb>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[d>>2]|0)>0){jb=f[Ja>>2]|0;hb=0;do{f[jb+(hb<<2)>>2]=0;hb=hb+1|0}while((hb|0)<(f[d>>2]|0))}hb=N+36|0;jb=f[hb>>2]|0;if(jb|0?(lb=jb+12|0,jb=f[lb>>2]|0,f[lb>>2]=jb+-1,(jb|0)==1):0)kL(N);f[hb>>2]=0;f[ib>>2]=0;f[ib+4>>2]=0;f[ib+8>>2]=0;f[ib+12>>2]=0;if((f[Ia>>2]|0)>0){jb=f[La>>2]|0;lb=0;do{f[jb+(lb<<2)>>2]=0;lb=lb+1|0}while((lb|0)<(f[Ia>>2]|0))}f[T>>2]=1124007936;lb=T+4|0;jb=T+8|0;mb=T+40|0;Pa=lb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[mb>>2]=jb;nb=T+48|0;ob=T+44|0;f[ob>>2]=nb;f[nb>>2]=0;f[T+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;hL(T,2,j,5);f[U>>2]=1124007936;pb=U+4|0;qb=U+8|0;rb=U+40|0;Pa=pb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[rb>>2]=qb;qb=U+48|0;sb=U+44|0;f[sb>>2]=qb;f[qb>>2]=0;f[U+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;hL(U,2,j,5);f[V>>2]=1124007936;tb=V+4|0;ub=V+8|0;vb=V+40|0;Pa=tb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[vb>>2]=ub;ub=V+48|0;wb=V+44|0;f[wb>>2]=ub;f[ub>>2]=0;f[V+52>>2]=0;f[j>>2]=Ua;f[a>>2]=Ta;hL(V,2,j,5);f[W>>2]=1124007936;xb=W+4|0;yb=W+8|0;zb=W+40|0;Pa=xb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[zb>>2]=yb;yb=W+48|0;Ab=W+44|0;f[Ab>>2]=yb;f[yb>>2]=0;f[W+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;hL(W,2,j,5);f[X>>2]=1124007936;Bb=X+4|0;Cb=X+8|0;Db=X+40|0;Pa=Bb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Db>>2]=Cb;Cb=X+48|0;Eb=X+44|0;f[Eb>>2]=Cb;f[Cb>>2]=0;f[X+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;hL(X,2,j,0);do if((yM(h)|0)==65536){Fb=f[h+4>>2]|0;f[Z>>2]=f[Fb>>2];Gb=Z+4|0;Hb=Fb+4|0;f[Gb>>2]=f[Hb>>2];Ib=Z+8|0;f[Ib>>2]=f[Fb+8>>2];f[Z+12>>2]=f[Fb+12>>2];f[Z+16>>2]=f[Fb+16>>2];f[Z+20>>2]=f[Fb+20>>2];f[Z+24>>2]=f[Fb+24>>2];f[Z+28>>2]=f[Fb+28>>2];f[Z+32>>2]=f[Fb+32>>2];Jb=f[Fb+36>>2]|0;f[Z+36>>2]=Jb;f[Z+40>>2]=Ib;Ib=Z+48|0;Kb=Z+44|0;f[Kb>>2]=Ib;f[Ib>>2]=0;f[Z+52>>2]=0;if(Jb|0){Ib=Jb+12|0;f[Ib>>2]=(f[Ib>>2]|0)+1}if((f[Hb>>2]|0)<3){Hb=f[Fb+44>>2]|0;Ib=f[Kb>>2]|0;f[Ib>>2]=f[Hb>>2];f[Ib+4>>2]=f[Hb+4>>2];break}else{f[Gb>>2]=0;jL(Z,Fb);break}}else yL(Z,h,-1);while(0);f[_>>2]=1124007936;Fb=_+4|0;Gb=_+8|0;Hb=_+40|0;Pa=Fb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Hb>>2]=Gb;Gb=_+48|0;Ib=_+44|0;f[Ib>>2]=Gb;f[Gb>>2]=0;f[_+52>>2]=0;if(HM(h)|0){TS(j,Ua,Ta,0);Kb=f[j>>2]|0;th[f[(f[Kb>>2]|0)+12>>2]&511](Kb,j,_,-1);Wi(j)}else{Kb=j+8|0;f[Kb>>2]=0;f[Kb+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=_;+nea(h,j,0.0,1.0,0)}h=j+8|0;f[h>>2]=0;f[h+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=U;OJ(H,j,f[U>>2]&4095,1.0,0.0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=U;h=k+8|0;f[h>>2]=0;f[h+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=U;f[$>>2]=5;f[$+4>>2]=5;F7(j,k,$,0.0,0.0,4);f[aa>>2]=1124007936;$=aa+4|0;h=aa+8|0;Kb=aa+40|0;Pa=$;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Kb>>2]=h;h=aa+48|0;Jb=aa+44|0;f[Jb>>2]=h;f[h>>2]=0;f[aa+52>>2]=0;Lb=j+8|0;f[Lb>>2]=0;f[Lb+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=aa;OJ(_,j,5,1.0,0.0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=aa;Lb=k+8|0;f[Lb>>2]=0;f[Lb+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=aa;f[ba>>2]=5;f[ba+4>>2]=5;F7(j,k,ba,0.0,0.0,4);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=aa;OJ(aa,j,-1,.5263157894736842,0.0);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=_;OJ(aa,j,f[_>>2]&4095,1.0,0.0);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=aa;OJ(_,j,f[aa>>2]&4095,1.0,0.0);ba=j+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=V;OJ(I,j,f[V>>2]&4095,1.0,0.0);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=V;ba=k+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=V;f[ca>>2]=5;f[ca+4>>2]=5;F7(j,k,ca,0.0,0.0,4);QS(ea,Ua,Ta,5);f[da>>2]=1124007936;ca=da+4|0;ba=da+8|0;Lb=da+40|0;Pa=ca;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Lb>>2]=ba;ba=da+48|0;Mb=da+44|0;f[Mb>>2]=ba;f[ba>>2]=0;f[da+52>>2]=0;Nb=f[ea>>2]|0;th[f[(f[Nb>>2]|0)+12>>2]&511](Nb,ea,da,-1);Wi(ea);QS(ga,Ua,Ta,5);f[fa>>2]=1124007936;Ta=fa+4|0;Ua=fa+8|0;ea=fa+40|0;Pa=Ta;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[ea>>2]=Ua;Ua=fa+48|0;Nb=fa+44|0;f[Nb>>2]=Ua;f[Ua>>2]=0;f[fa+52>>2]=0;Ob=f[ga>>2]|0;th[f[(f[Ob>>2]|0)+12>>2]&511](Ob,ga,fa,-1);Wi(ga);f[ha>>2]=1124007936;ga=ha+4|0;Ob=ha+8|0;Pb=ha+40|0;Pa=ga;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Pb>>2]=Ob;Qb=ha+48|0;Rb=ha+44|0;f[Rb>>2]=Qb;f[Qb>>2]=0;f[ha+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;hL(ha,2,j,5);f[ia>>2]=1124007936;Sb=ia+4|0;Tb=ia+8|0;Ub=ia+40|0;Pa=Sb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ub>>2]=Tb;Tb=ia+48|0;Vb=ia+44|0;f[Vb>>2]=Tb;f[Tb>>2]=0;f[ia+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;hL(ia,2,j,5);n[ja>>2]=-.5;Wb=ja+4|0;n[Wb>>2]=0.0;Xb=ja+8|0;n[Xb>>2]=.5;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=V;Yb=k+8|0;f[Yb>>2]=0;f[Yb+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=da;f[l>>2]=-1056833531;f[l+4>>2]=ja;f[l+8>>2]=3;f[l+12>>2]=1;f[ka>>2]=-1;f[ka+4>>2]=-1;Mda(j,k,-1,l,ka,0.0,4);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=V;ka=k+8|0;f[ka>>2]=0;f[ka+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=fa;f[m>>2]=f[ja>>2];f[m+4>>2]=f[Wb>>2];f[m+8>>2]=f[Xb>>2];f[l>>2]=-1056833531;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=3;f[la>>2]=-1;f[la+4>>2]=-1;Mda(j,k,-1,l,la,0.0,4);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=aa;PS(j,da,k,1.0);la=f[j>>2]|0;th[f[(f[la>>2]|0)+12>>2]&511](la,j,da,-1);Wi(j);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=aa;PS(j,fa,k,1.0);la=f[j>>2]|0;th[f[(f[la>>2]|0)+12>>2]&511](la,j,fa,-1);Wi(j);la=Y(g,Za)|0;f[ma>>2]=1124007936;Xb=ma+4|0;Wb=ma+8|0;ja=ma+40|0;Pa=Xb;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[ja>>2]=Wb;ka=ma+48|0;Yb=ma+44|0;f[Yb>>2]=ka;f[ka>>2]=0;f[ma+52>>2]=0;f[j>>2]=Oa;f[a>>2]=la;hL(ma,2,j,5);f[na>>2]=1124007936;la=na+4|0;Zb=na+8|0;_b=na+40|0;Pa=la;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[_b>>2]=Zb;Zb=na+48|0;$b=na+44|0;f[$b>>2]=Zb;f[Zb>>2]=0;f[na+52>>2]=0;f[j>>2]=Za;f[a>>2]=Za;hL(na,2,j,5);f[oa>>2]=1124007936;ac=oa+4|0;bc=oa+8|0;cc=oa+40|0;Pa=ac;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[cc>>2]=bc;bc=oa+48|0;dc=oa+44|0;f[dc>>2]=bc;f[bc>>2]=0;f[oa+52>>2]=0;f[j>>2]=Za;f[a>>2]=Za;hL(oa,2,j,5);f[pa>>2]=1124007936;ec=pa+4|0;fc=pa+8|0;gc=pa+40|0;Pa=ec;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[gc>>2]=fc;fc=pa+48|0;hc=pa+44|0;f[hc>>2]=fc;f[fc>>2]=0;f[pa+52>>2]=0;f[j>>2]=Za;f[a>>2]=1;hL(pa,2,j,5);f[qa>>2]=1124007936;ic=qa+4|0;jc=qa+8|0;kc=qa+40|0;Pa=ic;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[kc>>2]=jc;jc=qa+48|0;lc=qa+44|0;f[lc>>2]=jc;f[jc>>2]=0;f[qa+52>>2]=0;f[j>>2]=Za;f[a>>2]=1;hL(qa,2,j,5);f[ra>>2]=1124007936;mc=ra+4|0;nc=ra+8|0;oc=ra+40|0;Pa=mc;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[oc>>2]=nc;nc=ra+48|0;pc=ra+44|0;f[pc>>2]=nc;f[nc>>2]=0;f[ra+52>>2]=0;f[j>>2]=Za;f[a>>2]=1;hL(ra,2,j,5);f[sa>>2]=1124007936;qc=sa+4|0;rc=sa+8|0;sc=sa+40|0;Pa=qc;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[sc>>2]=rc;rc=sa+48|0;tc=sa+44|0;f[tc>>2]=rc;f[rc>>2]=0;f[sa+52>>2]=0;f[j>>2]=Za;f[a>>2]=1;hL(sa,2,j,5);f[ta>>2]=1124007936;uc=ta+4|0;vc=ta+8|0;wc=ta+40|0;Pa=uc;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[wc>>2]=vc;xc=ta+48|0;yc=ta+44|0;f[yc>>2]=xc;f[xc>>2]=0;f[ta+52>>2]=0;f[j>>2]=Za;f[a>>2]=1;hL(ta,2,j,5);f[ua>>2]=1124007936;Za=ua+4|0;zc=ua+8|0;Ac=ua+40|0;Pa=Za;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ac>>2]=zc;zc=ua+48|0;Bc=ua+44|0;f[Bc>>2]=zc;f[zc>>2]=0;f[ua+52>>2]=0;f[j>>2]=Oa;f[a>>2]=g;hL(ua,2,j,5);a:do if((Xa|0)<1)Cc=-1.0;else{g=(e|0)==3;a=j+8|0;Oa=j+12|0;Dc=j+4|0;Ec=k+8|0;Fc=k+4|0;Gc=l+8|0;Hc=l+12|0;Ic=l+4|0;Jc=za+4|0;Kc=j+8|0;Lc=j+12|0;Mc=j+4|0;Nc=k+8|0;Oc=k+4|0;Pc=l+8|0;Qc=l+12|0;Rc=l+4|0;Sc=Aa+4|0;Tc=j+8|0;Uc=j+12|0;Vc=j+4|0;Wc=k+8|0;Xc=k+4|0;Yc=l+8|0;Zc=l+12|0;_c=l+4|0;$c=Ba+4|0;ad=j+8|0;bd=j+12|0;cd=j+4|0;dd=k+8|0;ed=k+4|0;fd=l+8|0;gd=l+12|0;hd=l+4|0;id=Ca+4|0;jd=j+8|0;kd=j+12|0;ld=j+4|0;md=k+4|0;nd=k+8|0;od=k+12|0;pd=l+4|0;qd=l+8|0;rd=l+12|0;sd=m+8|0;td=m+12|0;ud=m+4|0;vd=j+8|0;wd=j+12|0;xd=j+4|0;yd=k+4|0;zd=k+8|0;Ad=k+12|0;Bd=l+4|0;Cd=l+8|0;Dd=l+12|0;Ed=m+8|0;Fd=m+12|0;Gd=m+4|0;Hd=j+8|0;Id=j+12|0;Jd=j+4|0;Kd=k+8|0;Ld=k+12|0;Md=k+4|0;Nd=l+8|0;Od=l+4|0;Pd=m+8|0;Qd=m+12|0;Rd=m+4|0;Sd=T+12|0;Td=j+8|0;Ud=j+12|0;Vd=j+4|0;Wd=k+8|0;Xd=k+12|0;Yd=k+4|0;Zd=l+8|0;_d=l+4|0;$d=m+8|0;ae=m+12|0;be=m+4|0;ce=j+8|0;de=j+12|0;ee=j+4|0;fe=j+8|0;ge=j+12|0;he=j+4|0;ie=j+8|0;je=j+12|0;ke=j+4|0;le=j+4|0;me=j+8|0;ne=j+12|0;oe=j+4|0;pe=j+8|0;qe=j+12|0;re=j+4|0;se=(e|0)==0;te=(e|0)==1;ue=(e|0)==2;ve=e>>>0<4;we=j+4|0;xe=ta+12|0;ye=j+4|0;ze=j+4|0;Ae=ta+16|0;Be=j+4|0;Ce=j+4|0;De=j+4|0;Ee=j+4|0;Fe=j+4|0;Ge=j+4|0;He=j+4|0;Ie=j+4|0;Je=ma+12|0;Ke=ha+12|0;Le=m+8|0;Me=m+12|0;Ne=m+4|0;Oe=j+4|0;Pe=k+4|0;Qe=o+36|0;Re=o+16|0;Se=o+4|0;Te=o+40|0;Ue=o+44|0;Ve=o+48|0;We=m+8|0;Xe=m+12|0;Ye=m+4|0;Ze=j+4|0;_e=k+4|0;$e=q+36|0;af=q+16|0;bf=q+4|0;cf=q+40|0;df=q+44|0;ef=q+48|0;ff=m+8|0;gf=m+12|0;hf=m+4|0;jf=j+4|0;kf=k+4|0;lf=r+36|0;mf=r+16|0;nf=r+4|0;of=r+40|0;pf=r+44|0;qf=r+48|0;rf=m+8|0;sf=m+12|0;tf=m+4|0;uf=j+4|0;vf=k+4|0;wf=t+36|0;xf=t+16|0;yf=t+4|0;zf=t+40|0;Af=t+44|0;Bf=t+48|0;Cf=j+4|0;Df=k+4|0;Ef=l+8|0;Ff=l+4|0;Gf=m+36|0;Hf=m+16|0;If=m+4|0;Jf=m+40|0;Kf=m+44|0;Lf=m+48|0;Mf=j+4|0;Nf=k+4|0;Of=l+8|0;Pf=l+4|0;Qf=m+36|0;Rf=m+16|0;Sf=m+4|0;Tf=m+40|0;Uf=m+44|0;Vf=m+48|0;Wf=j+4|0;Xf=j+4|0;Yf=j+4|0;Zf=j+4|0;_f=j+4|0;$f=j+4|0;ag=j+4|0;bg=q+8|0;cg=l+4|0;dg=l+8|0;eg=l+40|0;fg=l+48|0;gg=l+44|0;hg=l+52|0;ig=v+8|0;jg=o+4|0;kg=o+8|0;lg=o+40|0;mg=o+48|0;ng=o+44|0;og=o+52|0;pg=j+8|0;qg=j+12|0;rg=j+4|0;sg=k+8|0;tg=k+12|0;ug=k+4|0;vg=q+8|0;wg=q+4|0;xg=x+8|0;yg=q+4|0;zg=q+8|0;Ag=q+40|0;Bg=q+48|0;Cg=q+44|0;Dg=q+52|0;Eg=j+8|0;Fg=j+12|0;Gg=j+4|0;Hg=k+8|0;Ig=k+12|0;Jg=k+4|0;Kg=t+8|0;Lg=t+4|0;Mg=t+4|0;Ng=t+8|0;Og=t+40|0;Pg=t+48|0;Qg=t+44|0;Rg=t+52|0;Sg=v+4|0;Tg=v+8|0;Ug=v+40|0;Vg=v+48|0;Wg=v+44|0;Xg=v+52|0;Yg=j+8|0;Zg=j+12|0;_g=j+4|0;$g=k+8|0;ah=k+12|0;bh=k+4|0;ch=x+8|0;dh=x+4|0;eh=j+8|0;fh=j+12|0;gh=j+4|0;hh=k+8|0;ih=k+12|0;jh=k+4|0;kh=x+8|0;lh=x+4|0;mh=y+8|0;nh=y+12|0;oh=y+4|0;ph=j+4|0;qh=k+4|0;rh=z+36|0;sh=z+16|0;uh=z+4|0;vh=z+40|0;wh=z+44|0;xh=z+48|0;yh=y+8|0;zh=y+12|0;Ah=y+4|0;Bh=j+4|0;Ch=k+4|0;Dh=A+36|0;Eh=A+16|0;Fh=A+4|0;Gh=A+40|0;Hh=A+44|0;Ih=A+48|0;Jh=k+8|0;Kh=k+12|0;Lh=k+4|0;Mh=C+8|0;Nh=C+12|0;Oh=C+4|0;Ph=x+4|0;Qh=x+8|0;Rh=x+40|0;Sh=x+48|0;Th=x+44|0;Uh=x+52|0;Vh=C+8|0;Wh=C+12|0;Xh=C+4|0;Yh=j+4|0;Zh=k+4|0;_h=D+36|0;$h=D+16|0;ai=D+4|0;bi=D+40|0;ci=D+44|0;di=D+48|0;ei=o+36|0;fi=o+16|0;gi=q+36|0;hi=q+16|0;ii=C+8|0;ji=C+12|0;ki=C+4|0;li=j+4|0;mi=k+4|0;ni=E+36|0;oi=E+16|0;pi=E+4|0;qi=E+40|0;ri=E+44|0;si=E+48|0;ti=C+8|0;ui=C+12|0;vi=C+4|0;wi=j+4|0;xi=k+4|0;yi=F+36|0;zi=F+16|0;Ai=F+4|0;Bi=F+40|0;Ci=F+44|0;Di=F+48|0;Ei=C+8|0;Fi=C+12|0;Gi=C+4|0;Hi=j+4|0;Ii=k+4|0;Ji=G+36|0;Ki=G+16|0;Li=G+4|0;Mi=G+40|0;Ni=G+44|0;Oi=G+48|0;Pi=j+4|0;Qi=k+4|0;Ri=y+8|0;Si=y+4|0;Ti=C+36|0;Ui=C+16|0;Vi=C+4|0;Xi=C+40|0;Yi=C+44|0;Zi=C+48|0;_i=j+4|0;$i=k+4|0;aj=y+8|0;bj=y+4|0;cj=C+36|0;dj=C+16|0;ej=C+4|0;fj=C+40|0;gj=C+44|0;hj=C+48|0;ij=x+36|0;jj=x+16|0;kj=v+36|0;lj=v+16|0;mj=t+36|0;nj=t+16|0;oj=l+36|0;pj=l+16|0;qj=j+4|0;rj=j+4|0;sj=j+4|0;tj=j+4|0;uj=j+4|0;vj=j+4|0;wj=j+4|0;xj=k+4|0;yj=l+8|0;zj=l+4|0;Aj=m+36|0;Bj=m+16|0;Cj=m+4|0;Dj=m+40|0;Ej=m+44|0;Fj=m+48|0;Gj=j+4|0;Hj=k+4|0;Ij=l+8|0;Jj=l+4|0;Kj=m+36|0;Lj=m+16|0;Mj=m+4|0;Nj=m+40|0;Oj=m+44|0;Pj=m+48|0;Qj=j+4|0;Rj=j+4|0;Sj=j+4|0;Tj=j+4|0;Uj=j+4|0;Vj=l+4|0;Wj=l+8|0;Xj=l+40|0;Yj=l+48|0;Zj=l+44|0;_j=l+52|0;$j=o+4|0;ak=o+8|0;bk=o+40|0;ck=o+48|0;dk=o+44|0;ek=o+52|0;fk=v+8|0;gk=v+12|0;hk=v+4|0;ik=x+8|0;jk=x+12|0;kk=x+4|0;lk=j+4|0;mk=k+4|0;nk=y+36|0;ok=y+16|0;pk=y+4|0;qk=y+40|0;rk=y+44|0;sk=y+48|0;tk=j+4|0;uk=k+4|0;vk=r+8|0;wk=r+4|0;xk=t+36|0;yk=t+16|0;zk=t+4|0;Ak=t+40|0;Bk=t+44|0;Ck=t+48|0;Dk=j+4|0;Ek=k+4|0;Fk=r+8|0;Gk=r+4|0;Hk=t+36|0;Ik=t+16|0;Jk=t+4|0;Kk=t+40|0;Lk=t+44|0;Mk=t+48|0;Nk=o+36|0;Ok=o+16|0;Pk=l+36|0;Qk=l+16|0;Rk=j+4|0;Sk=j+4|0;Tk=j+4|0;Uk=j+4|0;Vk=j+4|0;Wk=j+4|0;Xk=j+8|0;Yk=j+12|0;Zk=j+4|0;_k=k+8|0;$k=k+4|0;al=l+8|0;bl=l+12|0;cl=l+4|0;dl=va+4|0;el=j+8|0;fl=j+12|0;gl=j+4|0;hl=k+8|0;il=k+4|0;jl=l+8|0;kl=l+12|0;ll=l+4|0;ml=wa+4|0;nl=j+8|0;ol=j+12|0;pl=j+4|0;ql=k+8|0;rl=k+4|0;sl=l+8|0;tl=l+12|0;ul=l+4|0;vl=xa+4|0;wl=j+8|0;xl=j+12|0;yl=j+4|0;zl=k+8|0;Al=k+4|0;Bl=l+8|0;Cl=l+12|0;Dl=l+4|0;El=ya+4|0;Fl=-1.0;Gl=1;Hl=-Ya;while(1){if(!(+L(+(Fl-Hl))>=Ya)){Cc=Fl;break a}if(g){f[a>>2]=0;f[Oa>>2]=0;f[j>>2]=16842752;f[Dc>>2]=V;Il=Ec;f[Il>>2]=0;f[Il+4>>2]=0;f[k>>2]=33619968;f[Fc>>2]=W;f[Gc>>2]=0;f[Hc>>2]=0;f[l>>2]=16842752;f[Ic>>2]=J;Il=f[zb>>2]|0;Jl=f[Il>>2]|0;f[za>>2]=f[Il+4>>2];f[Jc>>2]=Jl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;coa(j,k,l,za,17,0,m);f[Kc>>2]=0;f[Lc>>2]=0;f[j>>2]=16842752;f[Mc>>2]=da;Jl=Nc;f[Jl>>2]=0;f[Jl+4>>2]=0;f[k>>2]=33619968;f[Oc>>2]=ha;f[Pc>>2]=0;f[Qc>>2]=0;f[l>>2]=16842752;f[Rc>>2]=J;Jl=f[Pb>>2]|0;Il=f[Jl>>2]|0;f[Aa>>2]=f[Jl+4>>2];f[Sc>>2]=Il;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;coa(j,k,l,Aa,17,0,m);f[Tc>>2]=0;f[Uc>>2]=0;f[j>>2]=16842752;f[Vc>>2]=fa;Il=Wc;f[Il>>2]=0;f[Il+4>>2]=0;f[k>>2]=33619968;f[Xc>>2]=ia;f[Yc>>2]=0;f[Zc>>2]=0;f[l>>2]=16842752;f[_c>>2]=J;Il=f[Ub>>2]|0;Jl=f[Il>>2]|0;f[Ba>>2]=f[Il+4>>2];f[$c>>2]=Jl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;coa(j,k,l,Ba,17,0,m);f[ad>>2]=0;f[bd>>2]=0;f[j>>2]=16842752;f[cd>>2]=_;Jl=dd;f[Jl>>2]=0;f[Jl+4>>2]=0;f[k>>2]=33619968;f[ed>>2]=X;f[fd>>2]=0;f[gd>>2]=0;f[l>>2]=16842752;f[hd>>2]=J;Jl=f[Db>>2]|0;Il=f[Jl>>2]|0;f[Ca>>2]=f[Jl+4>>2];f[id>>2]=Il;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;coa(j,k,l,Ca,16,0,m)}else{f[Xk>>2]=0;f[Yk>>2]=0;f[j>>2]=16842752;f[Zk>>2]=V;Il=_k;f[Il>>2]=0;f[Il+4>>2]=0;f[k>>2]=33619968;f[$k>>2]=W;f[al>>2]=0;f[bl>>2]=0;f[l>>2]=16842752;f[cl>>2]=J;Il=f[zb>>2]|0;Jl=f[Il>>2]|0;f[va>>2]=f[Il+4>>2];f[dl>>2]=Jl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Yna(j,k,l,va,17,0,m);f[el>>2]=0;f[fl>>2]=0;f[j>>2]=16842752;f[gl>>2]=da;Jl=hl;f[Jl>>2]=0;f[Jl+4>>2]=0;f[k>>2]=33619968;f[il>>2]=ha;f[jl>>2]=0;f[kl>>2]=0;f[l>>2]=16842752;f[ll>>2]=J;Jl=f[Pb>>2]|0;Il=f[Jl>>2]|0;f[wa>>2]=f[Jl+4>>2];f[ml>>2]=Il;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Yna(j,k,l,wa,17,0,m);f[nl>>2]=0;f[ol>>2]=0;f[j>>2]=16842752;f[pl>>2]=fa;Il=ql;f[Il>>2]=0;f[Il+4>>2]=0;f[k>>2]=33619968;f[rl>>2]=ia;f[sl>>2]=0;f[tl>>2]=0;f[l>>2]=16842752;f[ul>>2]=J;Il=f[Ub>>2]|0;Jl=f[Il>>2]|0;f[xa>>2]=f[Il+4>>2];f[vl>>2]=Jl;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Yna(j,k,l,xa,17,0,m);f[wl>>2]=0;f[xl>>2]=0;f[j>>2]=16842752;f[yl>>2]=_;Jl=zl;f[Jl>>2]=0;f[Jl+4>>2]=0;f[k>>2]=33619968;f[Al>>2]=X;f[Bl>>2]=0;f[Cl>>2]=0;f[l>>2]=16842752;f[Dl>>2]=J;Jl=f[Db>>2]|0;Il=f[Jl>>2]|0;f[ya>>2]=f[Jl+4>>2];f[El>>2]=Il;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;Yna(j,k,l,ya,16,0,m)};f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=0;f[Da+12>>2]=0;f[Da+16>>2]=0;f[Da+20>>2]=0;f[Da+24>>2]=0;f[Da+28>>2]=0;f[Ea>>2]=0;f[Ea+4>>2]=0;f[Ea+8>>2]=0;f[Ea+12>>2]=0;f[Ea+16>>2]=0;f[Ea+20>>2]=0;f[Ea+24>>2]=0;f[Ea+28>>2]=0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=0;f[Fa+12>>2]=0;f[Fa+16>>2]=0;f[Fa+20>>2]=0;f[Fa+24>>2]=0;f[Fa+28>>2]=0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=0;f[Ga+12>>2]=0;f[Ga+16>>2]=0;f[Ga+20>>2]=0;f[Ga+24>>2]=0;f[Ga+28>>2]=0;f[jd>>2]=0;f[kd>>2]=0;f[j>>2]=16842752;f[ld>>2]=W;f[k>>2]=-1040056314;f[md>>2]=Da;f[nd>>2]=1;f[od>>2]=4;f[l>>2]=-1040056314;f[pd>>2]=Ea;f[qd>>2]=1;f[rd>>2]=4;f[sd>>2]=0;f[td>>2]=0;f[m>>2]=16842752;f[ud>>2]=X;uG(j,k,l,m);f[vd>>2]=0;f[wd>>2]=0;f[j>>2]=16842752;f[xd>>2]=U;f[k>>2]=-1040056314;f[yd>>2]=Fa;f[zd>>2]=1;f[Ad>>2]=4;f[l>>2]=-1040056314;f[Bd>>2]=Ga;f[Cd>>2]=1;f[Dd>>2]=4;f[Ed>>2]=0;f[Fd>>2]=0;f[m>>2]=16842752;f[Gd>>2]=X;uG(j,k,l,m);f[Hd>>2]=0;f[Id>>2]=0;f[j>>2]=16842752;f[Jd>>2]=W;f[k>>2]=-1056833530;f[Md>>2]=Da;f[Kd>>2]=1;f[Ld>>2]=4;Il=Nd;f[Il>>2]=0;f[Il+4>>2]=0;f[l>>2]=33619968;f[Od>>2]=W;f[Pd>>2]=0;f[Qd>>2]=0;f[m>>2]=16842752;f[Rd>>2]=X;jE(j,k,l,m,-1);QS(j,f[jb>>2]|0,f[Sd>>2]|0,f[T>>2]&4095);Il=f[j>>2]|0;th[f[(f[Il>>2]|0)+12>>2]&511](Il,j,T,-1);Wi(j);f[Td>>2]=0;f[Ud>>2]=0;f[j>>2]=16842752;f[Vd>>2]=U;f[k>>2]=-1056833530;f[Yd>>2]=Fa;f[Wd>>2]=1;f[Xd>>2]=4;Il=Zd;f[Il>>2]=0;f[Il+4>>2]=0;f[l>>2]=33619968;f[_d>>2]=T;f[$d>>2]=0;f[ae>>2]=0;f[m>>2]=16842752;f[be>>2]=X;jE(j,k,l,m,-1);f[ce>>2]=0;f[de>>2]=0;f[j>>2]=16842752;f[ee>>2]=X;Kl=+(nG(j)|0);Ll=+p[Ga>>3];Ml=+M(+(Ll*(Kl*Ll)));f[fe>>2]=0;f[ge>>2]=0;f[j>>2]=16842752;f[he>>2]=X;Ll=+(nG(j)|0);Kl=+p[Ea>>3];Nl=+M(+(Kl*(Ll*Kl)));switch(e|0){case 2:{Il=f[Pb>>2]|0;Jl=f[Il+4>>2]|0;Ol=f[Il>>2]|0;Il=f[Ub>>2]|0;if((Ol|0)==(f[Il>>2]|0)?(Jl|0)==(f[Il+4>>2]|0):0){Pl=Jl;Ql=Ol}else{f[j>>2]=0;f[$f>>2]=0;Pa=aD(j,26)|0;Qa=361551;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361578,361070,167);bD(j);Ol=f[Pb>>2]|0;Pl=f[Ol+4>>2]|0;Ql=f[Ol>>2]|0}Ol=f[ab>>2]|0;if((Ql|0)==(f[Ol>>2]|0)?(Pl|0)==(f[Ol+4>>2]|0):0){Rl=Pl;Sl=Ql}else{f[j>>2]=0;f[_f>>2]=0;Pa=aD(j,26)|0;Qa=361604;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361578,361070,168);bD(j);Ol=f[Pb>>2]|0;Rl=f[Ol+4>>2]|0;Sl=f[Ol>>2]|0}Ol=f[eb>>2]|0;if(!((Sl|0)==(f[Ol>>2]|0)?(Rl|0)==(f[Ol+4>>2]|0):0)){f[j>>2]=0;f[Zf>>2]=0;Pa=aD(j,26)|0;Qa=361631;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361578,361070,169);bD(j)}if((f[Ob>>2]|0)!=(f[Wb>>2]|0)){f[j>>2]=0;f[Yf>>2]=0;Pa=aD(j,21)|0;Qa=361658;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361578,361070,171);bD(j)}if((f[Je>>2]|0)!=((f[Ke>>2]|0)*6|0)){f[j>>2]=0;f[Xf>>2]=0;Pa=aD(j,25)|0;Qa=361680;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361578,361070,172);bD(j)}if((f[ma>>2]&4095|0)!=5){f[j>>2]=0;f[Wf>>2]=0;Pa=aD(j,55)|0;Qa=361706;Ra=Pa+55|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361578,361070,174);bD(j)}Ol=f[Ke>>2]|0;f[Le>>2]=0;f[Me>>2]=0;f[m>>2]=16842752;f[Ne>>2]=Q;PS(l,ha,m,1.0);f[j>>2]=-2147483648;f[Oe>>2]=2147483647;f[k>>2]=0;f[Pe>>2]=Ol;lL(o,ma,j,k);Jl=f[l>>2]|0;th[f[(f[Jl>>2]|0)+12>>2]&511](Jl,l,o,-1);Jl=f[Qe>>2]|0;do if(Jl|0){Il=Jl+12|0;Tl=f[Il>>2]|0;f[Il>>2]=Tl+-1;if((Tl|0)!=1)break;kL(o)}while(0);f[Qe>>2]=0;f[Re>>2]=0;f[Re+4>>2]=0;f[Re+8>>2]=0;f[Re+12>>2]=0;if((f[Se>>2]|0)>0){Jl=f[Te>>2]|0;Tl=0;do{f[Jl+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[Se>>2]|0))}Tl=f[Ue>>2]|0;if((Tl|0)!=(Ve|0))UC(Tl);Wi(l);f[We>>2]=0;f[Xe>>2]=0;f[m>>2]=16842752;f[Ye>>2]=Q;PS(l,ia,m,1.0);Tl=Ol<<1;f[j>>2]=-2147483648;f[Ze>>2]=2147483647;f[k>>2]=Ol;f[_e>>2]=Tl;lL(q,ma,j,k);Jl=f[l>>2]|0;th[f[(f[Jl>>2]|0)+12>>2]&511](Jl,l,q,-1);Jl=f[$e>>2]|0;do if(Jl|0){Il=Jl+12|0;Ul=f[Il>>2]|0;f[Il>>2]=Ul+-1;if((Ul|0)!=1)break;kL(q)}while(0);f[$e>>2]=0;f[af>>2]=0;f[af+4>>2]=0;f[af+8>>2]=0;f[af+12>>2]=0;if((f[bf>>2]|0)>0){Jl=f[cf>>2]|0;Ul=0;do{f[Jl+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[bf>>2]|0))}Ul=f[df>>2]|0;if((Ul|0)!=(ef|0))UC(Ul);Wi(l);f[ff>>2]=0;f[gf>>2]=0;f[m>>2]=16842752;f[hf>>2]=R;PS(l,ha,m,1.0);Ul=Ol*3|0;f[j>>2]=-2147483648;f[jf>>2]=2147483647;f[k>>2]=Tl;f[kf>>2]=Ul;lL(r,ma,j,k);Jl=f[l>>2]|0;th[f[(f[Jl>>2]|0)+12>>2]&511](Jl,l,r,-1);Jl=f[lf>>2]|0;do if(Jl|0){Il=Jl+12|0;Vl=f[Il>>2]|0;f[Il>>2]=Vl+-1;if((Vl|0)!=1)break;kL(r)}while(0);f[lf>>2]=0;f[mf>>2]=0;f[mf+4>>2]=0;f[mf+8>>2]=0;f[mf+12>>2]=0;if((f[nf>>2]|0)>0){Jl=f[of>>2]|0;Tl=0;do{f[Jl+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[nf>>2]|0))}Tl=f[pf>>2]|0;if((Tl|0)!=(qf|0))UC(Tl);Wi(l);f[rf>>2]=0;f[sf>>2]=0;f[m>>2]=16842752;f[tf>>2]=R;PS(l,ia,m,1.0);Tl=Ol<<2;f[j>>2]=-2147483648;f[uf>>2]=2147483647;f[k>>2]=Ul;f[vf>>2]=Tl;lL(t,ma,j,k);Jl=f[l>>2]|0;th[f[(f[Jl>>2]|0)+12>>2]&511](Jl,l,t,-1);Jl=f[wf>>2]|0;do if(Jl|0){Vl=Jl+12|0;Il=f[Vl>>2]|0;f[Vl>>2]=Il+-1;if((Il|0)!=1)break;kL(t)}while(0);f[wf>>2]=0;f[xf>>2]=0;f[xf+4>>2]=0;f[xf+8>>2]=0;f[xf+12>>2]=0;if((f[yf>>2]|0)>0){Jl=f[zf>>2]|0;Ul=0;do{f[Jl+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[yf>>2]|0))}Ul=f[Af>>2]|0;if((Ul|0)!=(Bf|0))UC(Ul);Wi(l);Ul=Ol*5|0;f[j>>2]=-2147483648;f[Cf>>2]=2147483647;f[k>>2]=Tl;f[Df>>2]=Ul;lL(m,ma,j,k);Jl=Ef;f[Jl>>2]=0;f[Jl+4>>2]=0;f[l>>2]=-1040121856;f[Ff>>2]=m;SP(ha,l);Jl=f[Gf>>2]|0;do if(Jl|0){Il=Jl+12|0;Vl=f[Il>>2]|0;f[Il>>2]=Vl+-1;if((Vl|0)!=1)break;kL(m)}while(0);f[Gf>>2]=0;f[Hf>>2]=0;f[Hf+4>>2]=0;f[Hf+8>>2]=0;f[Hf+12>>2]=0;if((f[If>>2]|0)>0){Jl=f[Jf>>2]|0;Tl=0;do{f[Jl+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[If>>2]|0))}Tl=f[Kf>>2]|0;if((Tl|0)!=(Lf|0))UC(Tl);f[j>>2]=-2147483648;f[Mf>>2]=2147483647;f[k>>2]=Ul;f[Nf>>2]=Ol*6;lL(m,ma,j,k);Tl=Of;f[Tl>>2]=0;f[Tl+4>>2]=0;f[l>>2]=-1040121856;f[Pf>>2]=m;SP(ia,l);Tl=f[Qf>>2]|0;do if(Tl|0){Jl=Tl+12|0;Vl=f[Jl>>2]|0;f[Jl>>2]=Vl+-1;if((Vl|0)!=1)break;kL(m)}while(0);f[Qf>>2]=0;f[Rf>>2]=0;f[Rf+4>>2]=0;f[Rf+8>>2]=0;f[Rf+12>>2]=0;if((f[Sf>>2]|0)>0){Tl=f[Tf>>2]|0;Ol=0;do{f[Tl+(Ol<<2)>>2]=0;Ol=Ol+1|0}while((Ol|0)<(f[Sf>>2]|0))}Ol=f[Uf>>2]|0;if((Ol|0)!=(Vf|0))UC(Ol);break}case 3:{Ol=f[Pb>>2]|0;Tl=f[Ol+4>>2]|0;Ul=f[Ol>>2]|0;Ol=f[Ub>>2]|0;if((Ul|0)==(f[Ol>>2]|0)?(Tl|0)==(f[Ol+4>>2]|0):0){Wl=Tl;Xl=Ul}else{f[j>>2]=0;f[vj>>2]=0;Pa=aD(j,26)|0;Qa=361551;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361762,361070,57);bD(j);Ul=f[Pb>>2]|0;Wl=f[Ul+4>>2]|0;Xl=f[Ul>>2]|0}Ul=f[ab>>2]|0;if((Xl|0)==(f[Ul>>2]|0)?(Wl|0)==(f[Ul+4>>2]|0):0){Yl=Wl;Zl=Xl}else{f[j>>2]=0;f[uj>>2]=0;Pa=aD(j,26)|0;Qa=361604;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361762,361070,58);bD(j);Ul=f[Pb>>2]|0;Yl=f[Ul+4>>2]|0;Zl=f[Ul>>2]|0}Ul=f[eb>>2]|0;if(!((Zl|0)==(f[Ul>>2]|0)?(Yl|0)==(f[Ul+4>>2]|0):0)){f[j>>2]=0;f[tj>>2]=0;Pa=aD(j,26)|0;Qa=361631;Ra=Pa+26|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361762,361070,59);bD(j)}if((f[Ob>>2]|0)!=(f[Wb>>2]|0)){f[j>>2]=0;f[sj>>2]=0;Pa=aD(j,21)|0;Qa=361658;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361762,361070,61);bD(j)}if((f[Je>>2]|0)!=(f[Ke>>2]<<3|0)){f[j>>2]=0;f[rj>>2]=0;Pa=aD(j,25)|0;Qa=361786;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361762,361070,62);bD(j)}if((f[ma>>2]&4095|0)!=5){f[j>>2]=0;f[qj>>2]=0;Pa=aD(j,55)|0;Qa=361706;Ra=Pa+55|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361762,361070,63);bD(j)}if(!(f[J>>2]&16384)){f[j>>2]=0;f[ag>>2]=0;Pa=aD(j,19)|0;Qa=361812;Ra=Pa+19|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361762,361070,65);bD(j)}Ul=f[Sa>>2]|0;Kl=+n[Ul>>2];Ll=+n[Ul+12>>2];_l=+n[Ul+4>>2];$l=+n[Ul+16>>2];am=+n[Ul+28>>2];bm=+n[Ul+8>>2];cm=+n[Ul+20>>2];Tl=f[Ke>>2]|0;DS(k,Q,+n[Ul+24>>2]);DS(o,R,am);vS(j,k,o);p[q>>3]=1.0;f[bg>>2]=0;f[bg+4>>2]=0;f[bg+8>>2]=0;f[bg+12>>2]=0;f[bg+16>>2]=0;f[bg+20>>2]=0;uS(m,j,q);f[l>>2]=1124007936;Pa=cg;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[eg>>2]=dg;f[gg>>2]=fg;f[fg>>2]=0;f[hg>>2]=0;Ul=f[m>>2]|0;th[f[(f[Ul>>2]|0)+12>>2]&511](Ul,m,l,-1);Wi(m);Wi(j);Wi(o);Wi(k);AS(q,Q);FS(k,q,Kl);DS(t,R,_l);zS(j,k,t);p[v>>3]=bm;f[ig>>2]=0;f[ig+4>>2]=0;f[ig+8>>2]=0;f[ig+12>>2]=0;f[ig+16>>2]=0;f[ig+20>>2]=0;yS(r,j,v);f[o>>2]=1124007936;Pa=jg;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[lg>>2]=kg;f[ng>>2]=mg;f[mg>>2]=0;f[og>>2]=0;Ul=f[r>>2]|0;th[f[(f[Ul>>2]|0)+12>>2]&511](Ul,r,o,-1);Wi(r);Wi(j);Wi(t);Wi(k);Wi(q);f[pg>>2]=0;f[qg>>2]=0;f[j>>2]=16842752;f[rg>>2]=o;f[sg>>2]=0;f[tg>>2]=0;f[k>>2]=16842752;f[ug>>2]=l;Ul=vg;f[Ul>>2]=0;f[Ul+4>>2]=0;f[q>>2]=33619968;f[wg>>2]=o;VE(j,k,q,1.0,-1);AS(t,Q);FS(k,t,Ll);DS(v,R,$l);zS(j,k,v);p[x>>3]=cm;f[xg>>2]=0;f[xg+4>>2]=0;f[xg+8>>2]=0;f[xg+12>>2]=0;f[xg+16>>2]=0;f[xg+20>>2]=0;yS(w,j,x);f[q>>2]=1124007936;Pa=yg;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ag>>2]=zg;f[Cg>>2]=Bg;f[Bg>>2]=0;f[Dg>>2]=0;Ul=f[w>>2]|0;th[f[(f[Ul>>2]|0)+12>>2]&511](Ul,w,q,-1);Wi(w);Wi(j);Wi(v);Wi(k);Wi(t);f[Eg>>2]=0;f[Fg>>2]=0;f[j>>2]=16842752;f[Gg>>2]=q;f[Hg>>2]=0;f[Ig>>2]=0;f[k>>2]=16842752;f[Jg>>2]=l;Ul=Kg;f[Ul>>2]=0;f[Ul+4>>2]=0;f[t>>2]=33619968;f[Lg>>2]=q;VE(j,k,t,1.0,-1);f[t>>2]=1124007936;Pa=Mg;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Og>>2]=Ng;f[Qg>>2]=Pg;f[Pg>>2]=0;f[Rg>>2]=0;f[v>>2]=1124007936;Pa=Sg;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Ug>>2]=Tg;f[Wg>>2]=Vg;f[Vg>>2]=0;f[Xg>>2]=0;f[Yg>>2]=0;f[Zg>>2]=0;f[j>>2]=16842752;f[_g>>2]=ha;f[$g>>2]=0;f[ah>>2]=0;f[k>>2]=16842752;f[bh>>2]=l;Ul=ch;f[Ul>>2]=0;f[Ul+4>>2]=0;f[x>>2]=33619968;f[dh>>2]=t;VE(j,k,x,1.0,-1);f[eh>>2]=0;f[fh>>2]=0;f[j>>2]=16842752;f[gh>>2]=ia;f[hh>>2]=0;f[ih>>2]=0;f[k>>2]=16842752;f[jh>>2]=l;Ul=kh;f[Ul>>2]=0;f[Ul+4>>2]=0;f[x>>2]=33619968;f[lh>>2]=v;VE(j,k,x,1.0,-1);f[mh>>2]=0;f[nh>>2]=0;f[y>>2]=16842752;f[oh>>2]=Q;PS(x,t,y,1.0);f[j>>2]=-2147483648;f[ph>>2]=2147483647;f[k>>2]=0;f[qh>>2]=Tl;lL(z,ma,j,k);Ul=f[x>>2]|0;th[f[(f[Ul>>2]|0)+12>>2]&511](Ul,x,z,-1);Ul=f[rh>>2]|0;do if(Ul|0){Ol=Ul+12|0;Vl=f[Ol>>2]|0;f[Ol>>2]=Vl+-1;if((Vl|0)!=1)break;kL(z)}while(0);f[rh>>2]=0;f[sh>>2]=0;f[sh+4>>2]=0;f[sh+8>>2]=0;f[sh+12>>2]=0;if((f[uh>>2]|0)>0){Ul=f[vh>>2]|0;Vl=0;do{f[Ul+(Vl<<2)>>2]=0;Vl=Vl+1|0}while((Vl|0)<(f[uh>>2]|0))}Vl=f[wh>>2]|0;if((Vl|0)!=(xh|0))UC(Vl);Wi(x);f[yh>>2]=0;f[zh>>2]=0;f[y>>2]=16842752;f[Ah>>2]=Q;PS(x,v,y,1.0);Vl=Tl<<1;f[j>>2]=-2147483648;f[Bh>>2]=2147483647;f[k>>2]=Tl;f[Ch>>2]=Vl;lL(A,ma,j,k);Ul=f[x>>2]|0;th[f[(f[Ul>>2]|0)+12>>2]&511](Ul,x,A,-1);Ul=f[Dh>>2]|0;do if(Ul|0){Ol=Ul+12|0;Jl=f[Ol>>2]|0;f[Ol>>2]=Jl+-1;if((Jl|0)!=1)break;kL(A)}while(0);f[Dh>>2]=0;f[Eh>>2]=0;f[Eh+4>>2]=0;f[Eh+8>>2]=0;f[Eh+12>>2]=0;if((f[Fh>>2]|0)>0){Ul=f[Gh>>2]|0;Jl=0;do{f[Ul+(Jl<<2)>>2]=0;Jl=Jl+1|0}while((Jl|0)<(f[Fh>>2]|0))}Jl=f[Hh>>2]|0;if((Jl|0)!=(Ih|0))UC(Jl);Wi(x);f[Jh>>2]=0;f[Kh>>2]=0;f[k>>2]=16842752;f[Lh>>2]=t;PS(j,o,k,1.0);f[Mh>>2]=0;f[Nh>>2]=0;f[C>>2]=16842752;f[Oh>>2]=v;PS(y,q,C,1.0);vS(B,j,y);f[x>>2]=1124007936;Pa=Ph;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Rh>>2]=Qh;f[Th>>2]=Sh;f[Sh>>2]=0;f[Uh>>2]=0;Jl=f[B>>2]|0;th[f[(f[Jl>>2]|0)+12>>2]&511](Jl,B,x,-1);Wi(B);Wi(y);Wi(j);f[Vh>>2]=0;f[Wh>>2]=0;f[C>>2]=16842752;f[Xh>>2]=Q;PS(y,x,C,1.0);Jl=Tl*3|0;f[j>>2]=-2147483648;f[Yh>>2]=2147483647;f[k>>2]=Vl;f[Zh>>2]=Jl;lL(D,ma,j,k);Ul=f[y>>2]|0;th[f[(f[Ul>>2]|0)+12>>2]&511](Ul,y,D,-1);Ul=f[_h>>2]|0;do if(Ul|0){Ol=Ul+12|0;Il=f[Ol>>2]|0;f[Ol>>2]=Il+-1;if((Il|0)!=1)break;kL(D)}while(0);f[_h>>2]=0;f[$h>>2]=0;f[$h+4>>2]=0;f[$h+8>>2]=0;f[$h+12>>2]=0;if((f[ai>>2]|0)>0){Ul=f[bi>>2]|0;Vl=0;do{f[Ul+(Vl<<2)>>2]=0;Vl=Vl+1|0}while((Vl|0)<(f[ai>>2]|0))}Vl=f[ci>>2]|0;if((Vl|0)!=(di|0))UC(Vl);Wi(y);Vl=f[ei>>2]|0;do if(Vl|0){Ul=Vl+12|0;Il=f[Ul>>2]|0;f[Ul>>2]=Il+-1;if((Il|0)!=1)break;kL(o)}while(0);f[ei>>2]=0;f[fi>>2]=0;f[fi+4>>2]=0;f[fi+8>>2]=0;f[fi+12>>2]=0;if((f[jg>>2]|0)>0){Vl=f[lg>>2]|0;Il=0;do{f[Vl+(Il<<2)>>2]=0;Il=Il+1|0}while((Il|0)<(f[jg>>2]|0))}Il=f[gi>>2]|0;do if(Il|0){Vl=Il+12|0;Ul=f[Vl>>2]|0;f[Vl>>2]=Ul+-1;if((Ul|0)!=1)break;kL(q)}while(0);f[gi>>2]=0;f[hi>>2]=0;f[hi+4>>2]=0;f[hi+8>>2]=0;f[hi+12>>2]=0;if((f[yg>>2]|0)>0){Il=f[Ag>>2]|0;Ul=0;do{f[Il+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[yg>>2]|0))}f[ii>>2]=0;f[ji>>2]=0;f[C>>2]=16842752;f[ki>>2]=R;PS(y,t,C,1.0);Ul=Tl<<2;f[j>>2]=-2147483648;f[li>>2]=2147483647;f[k>>2]=Jl;f[mi>>2]=Ul;lL(E,ma,j,k);Il=f[y>>2]|0;th[f[(f[Il>>2]|0)+12>>2]&511](Il,y,E,-1);Il=f[ni>>2]|0;do if(Il|0){Vl=Il+12|0;Ol=f[Vl>>2]|0;f[Vl>>2]=Ol+-1;if((Ol|0)!=1)break;kL(E)}while(0);f[ni>>2]=0;f[oi>>2]=0;f[oi+4>>2]=0;f[oi+8>>2]=0;f[oi+12>>2]=0;if((f[pi>>2]|0)>0){Il=f[qi>>2]|0;Jl=0;do{f[Il+(Jl<<2)>>2]=0;Jl=Jl+1|0}while((Jl|0)<(f[pi>>2]|0))}Jl=f[ri>>2]|0;if((Jl|0)!=(si|0))UC(Jl);Wi(y);f[ti>>2]=0;f[ui>>2]=0;f[C>>2]=16842752;f[vi>>2]=R;PS(y,v,C,1.0);Jl=Tl*5|0;f[j>>2]=-2147483648;f[wi>>2]=2147483647;f[k>>2]=Ul;f[xi>>2]=Jl;lL(F,ma,j,k);Il=f[y>>2]|0;th[f[(f[Il>>2]|0)+12>>2]&511](Il,y,F,-1);Il=f[yi>>2]|0;do if(Il|0){Ol=Il+12|0;Vl=f[Ol>>2]|0;f[Ol>>2]=Vl+-1;if((Vl|0)!=1)break;kL(F)}while(0);f[yi>>2]=0;f[zi>>2]=0;f[zi+4>>2]=0;f[zi+8>>2]=0;f[zi+12>>2]=0;if((f[Ai>>2]|0)>0){Il=f[Bi>>2]|0;Ul=0;do{f[Il+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[Ai>>2]|0))}Ul=f[Ci>>2]|0;if((Ul|0)!=(Di|0))UC(Ul);Wi(y);f[Ei>>2]=0;f[Fi>>2]=0;f[C>>2]=16842752;f[Gi>>2]=R;PS(y,x,C,1.0);Ul=Tl*6|0;f[j>>2]=-2147483648;f[Hi>>2]=2147483647;f[k>>2]=Jl;f[Ii>>2]=Ul;lL(G,ma,j,k);Il=f[y>>2]|0;th[f[(f[Il>>2]|0)+12>>2]&511](Il,y,G,-1);Il=f[Ji>>2]|0;do if(Il|0){Vl=Il+12|0;Ol=f[Vl>>2]|0;f[Vl>>2]=Ol+-1;if((Ol|0)!=1)break;kL(G)}while(0);f[Ji>>2]=0;f[Ki>>2]=0;f[Ki+4>>2]=0;f[Ki+8>>2]=0;f[Ki+12>>2]=0;if((f[Li>>2]|0)>0){Il=f[Mi>>2]|0;Jl=0;do{f[Il+(Jl<<2)>>2]=0;Jl=Jl+1|0}while((Jl|0)<(f[Li>>2]|0))}Jl=f[Ni>>2]|0;if((Jl|0)!=(Oi|0))UC(Jl);Wi(y);Jl=Tl*7|0;f[j>>2]=-2147483648;f[Pi>>2]=2147483647;f[k>>2]=Ul;f[Qi>>2]=Jl;lL(C,ma,j,k);Il=Ri;f[Il>>2]=0;f[Il+4>>2]=0;f[y>>2]=-1040121856;f[Si>>2]=C;SP(t,y);Il=f[Ti>>2]|0;do if(Il|0){Ol=Il+12|0;Vl=f[Ol>>2]|0;f[Ol>>2]=Vl+-1;if((Vl|0)!=1)break;kL(C)}while(0);f[Ti>>2]=0;f[Ui>>2]=0;f[Ui+4>>2]=0;f[Ui+8>>2]=0;f[Ui+12>>2]=0;if((f[Vi>>2]|0)>0){Il=f[Xi>>2]|0;Ul=0;do{f[Il+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[Vi>>2]|0))}Ul=f[Yi>>2]|0;if((Ul|0)!=(Zi|0))UC(Ul);f[j>>2]=-2147483648;f[_i>>2]=2147483647;f[k>>2]=Jl;f[$i>>2]=Tl<<3;lL(C,ma,j,k);Ul=aj;f[Ul>>2]=0;f[Ul+4>>2]=0;f[y>>2]=-1040121856;f[bj>>2]=C;SP(v,y);Ul=f[cj>>2]|0;do if(Ul|0){Il=Ul+12|0;Vl=f[Il>>2]|0;f[Il>>2]=Vl+-1;if((Vl|0)!=1)break;kL(C)}while(0);f[cj>>2]=0;f[dj>>2]=0;f[dj+4>>2]=0;f[dj+8>>2]=0;f[dj+12>>2]=0;if((f[ej>>2]|0)>0){Ul=f[fj>>2]|0;Tl=0;do{f[Ul+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[ej>>2]|0))}Tl=f[gj>>2]|0;if((Tl|0)!=(hj|0))UC(Tl);Tl=f[ij>>2]|0;do if(Tl|0){Ul=Tl+12|0;Jl=f[Ul>>2]|0;f[Ul>>2]=Jl+-1;if((Jl|0)!=1)break;kL(x)}while(0);f[ij>>2]=0;f[jj>>2]=0;f[jj+4>>2]=0;f[jj+8>>2]=0;f[jj+12>>2]=0;if((f[Ph>>2]|0)>0){Tl=f[Rh>>2]|0;Jl=0;do{f[Tl+(Jl<<2)>>2]=0;Jl=Jl+1|0}while((Jl|0)<(f[Ph>>2]|0))}Jl=f[Th>>2]|0;if((Jl|0)!=(Sh|0))UC(Jl);Jl=f[kj>>2]|0;do if(Jl|0){Tl=Jl+12|0;Ul=f[Tl>>2]|0;f[Tl>>2]=Ul+-1;if((Ul|0)!=1)break;kL(v)}while(0);f[kj>>2]=0;f[lj>>2]=0;f[lj+4>>2]=0;f[lj+8>>2]=0;f[lj+12>>2]=0;if((f[Sg>>2]|0)>0){Jl=f[Ug>>2]|0;Ul=0;do{f[Jl+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[Sg>>2]|0))}Ul=f[Wg>>2]|0;if((Ul|0)!=(Vg|0))UC(Ul);Ul=f[mj>>2]|0;do if(Ul|0){Jl=Ul+12|0;Tl=f[Jl>>2]|0;f[Jl>>2]=Tl+-1;if((Tl|0)!=1)break;kL(t)}while(0);f[mj>>2]=0;f[nj>>2]=0;f[nj+4>>2]=0;f[nj+8>>2]=0;f[nj+12>>2]=0;if((f[Mg>>2]|0)>0){Ul=f[Og>>2]|0;Tl=0;do{f[Ul+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[Mg>>2]|0))}Tl=f[Qg>>2]|0;if((Tl|0)!=(Pg|0))UC(Tl);Tl=f[gi>>2]|0;do if(Tl|0){Ul=Tl+12|0;Jl=f[Ul>>2]|0;f[Ul>>2]=Jl+-1;if((Jl|0)!=1)break;kL(q)}while(0);f[gi>>2]=0;f[hi>>2]=0;f[hi+4>>2]=0;f[hi+8>>2]=0;f[hi+12>>2]=0;if((f[yg>>2]|0)>0){Tl=f[Ag>>2]|0;Jl=0;do{f[Tl+(Jl<<2)>>2]=0;Jl=Jl+1|0}while((Jl|0)<(f[yg>>2]|0))}Jl=f[Cg>>2]|0;if((Jl|0)!=(Bg|0))UC(Jl);Jl=f[ei>>2]|0;do if(Jl|0){Tl=Jl+12|0;Ul=f[Tl>>2]|0;f[Tl>>2]=Ul+-1;if((Ul|0)!=1)break;kL(o)}while(0);f[ei>>2]=0;f[fi>>2]=0;f[fi+4>>2]=0;f[fi+8>>2]=0;f[fi+12>>2]=0;if((f[jg>>2]|0)>0){Jl=f[lg>>2]|0;Ul=0;do{f[Jl+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[jg>>2]|0))}Ul=f[ng>>2]|0;if((Ul|0)!=(mg|0))UC(Ul);Ul=f[oj>>2]|0;do if(Ul|0){Jl=Ul+12|0;Tl=f[Jl>>2]|0;f[Jl>>2]=Tl+-1;if((Tl|0)!=1)break;kL(l)}while(0);f[oj>>2]=0;f[pj>>2]=0;f[pj+4>>2]=0;f[pj+8>>2]=0;f[pj+12>>2]=0;if((f[cg>>2]|0)>0){Ul=f[eg>>2]|0;Tl=0;do{f[Ul+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[cg>>2]|0))}Tl=f[gg>>2]|0;if((Tl|0)!=(fg|0))UC(Tl);break}case 0:{Tl=f[Pb>>2]|0;Ul=f[Ub>>2]|0;if(!((f[Tl>>2]|0)==(f[Ul>>2]|0)?(f[Tl+4>>2]|0)==(f[Ul+4>>2]|0):0)){f[j>>2]=0;f[Tj>>2]=0;Pa=aD(j,24)|0;Qa=361832;Ra=Pa+24|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361857,361070,193);bD(j)}if((f[Ob>>2]|0)!=(f[Wb>>2]|0)){f[j>>2]=0;f[Sj>>2]=0;Pa=aD(j,21)|0;Qa=361658;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361857,361070,195);bD(j)}if((f[Je>>2]|0)!=(f[Ke>>2]<<1|0)){f[j>>2]=0;f[Rj>>2]=0;Pa=aD(j,25)|0;Qa=361888;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361857,361070,196);bD(j)}if((f[ma>>2]&4095|0)!=5){f[j>>2]=0;f[Qj>>2]=0;Pa=aD(j,55)|0;Qa=361706;Ra=Pa+55|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361857,361070,197);bD(j)}Ul=f[Ke>>2]|0;f[j>>2]=-2147483648;f[wj>>2]=2147483647;f[k>>2]=0;f[xj>>2]=Ul;lL(m,ma,j,k);Tl=yj;f[Tl>>2]=0;f[Tl+4>>2]=0;f[l>>2]=-1040121856;f[zj>>2]=m;SP(ha,l);Tl=f[Aj>>2]|0;do if(Tl|0){Jl=Tl+12|0;Vl=f[Jl>>2]|0;f[Jl>>2]=Vl+-1;if((Vl|0)!=1)break;kL(m)}while(0);f[Aj>>2]=0;f[Bj>>2]=0;f[Bj+4>>2]=0;f[Bj+8>>2]=0;f[Bj+12>>2]=0;if((f[Cj>>2]|0)>0){Tl=f[Dj>>2]|0;Vl=0;do{f[Tl+(Vl<<2)>>2]=0;Vl=Vl+1|0}while((Vl|0)<(f[Cj>>2]|0))}Vl=f[Ej>>2]|0;if((Vl|0)!=(Fj|0))UC(Vl);f[j>>2]=-2147483648;f[Gj>>2]=2147483647;f[k>>2]=Ul;f[Hj>>2]=Ul<<1;lL(m,ma,j,k);Vl=Ij;f[Vl>>2]=0;f[Vl+4>>2]=0;f[l>>2]=-1040121856;f[Jj>>2]=m;SP(ia,l);Vl=f[Kj>>2]|0;do if(Vl|0){Tl=Vl+12|0;Jl=f[Tl>>2]|0;f[Tl>>2]=Jl+-1;if((Jl|0)!=1)break;kL(m)}while(0);f[Kj>>2]=0;f[Lj>>2]=0;f[Lj+4>>2]=0;f[Lj+8>>2]=0;f[Lj+12>>2]=0;if((f[Mj>>2]|0)>0){Vl=f[Nj>>2]|0;Ul=0;do{f[Vl+(Ul<<2)>>2]=0;Ul=Ul+1|0}while((Ul|0)<(f[Mj>>2]|0))}Ul=f[Oj>>2]|0;if((Ul|0)!=(Pj|0))UC(Ul);break}case 1:{Ul=f[Pb>>2]|0;Vl=f[Ul+4>>2]|0;Jl=f[Ul>>2]|0;Ul=f[Ub>>2]|0;if((Jl|0)==(f[Ul>>2]|0)?(Vl|0)==(f[Ul+4>>2]|0):0){dm=Vl;em=Jl}else{f[j>>2]=0;f[Wk>>2]=0;Pa=aD(j,24)|0;Qa=361832;Ra=Pa+24|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361914,361070,130);bD(j);Jl=f[Pb>>2]|0;dm=f[Jl+4>>2]|0;em=f[Jl>>2]|0}Jl=f[ab>>2]|0;if((em|0)==(f[Jl>>2]|0)?(dm|0)==(f[Jl+4>>2]|0):0){fm=dm;gm=em}else{f[j>>2]=0;f[Vk>>2]=0;Pa=aD(j,24)|0;Qa=361943;Ra=Pa+24|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361914,361070,131);bD(j);Jl=f[Pb>>2]|0;fm=f[Jl+4>>2]|0;gm=f[Jl>>2]|0}Jl=f[eb>>2]|0;if(!((gm|0)==(f[Jl>>2]|0)?(fm|0)==(f[Jl+4>>2]|0):0)){f[j>>2]=0;f[Uk>>2]=0;Pa=aD(j,24)|0;Qa=361968;Ra=Pa+24|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361914,361070,132);bD(j)}if((f[Ob>>2]|0)!=(f[Wb>>2]|0)){f[j>>2]=0;f[Tk>>2]=0;Pa=aD(j,21)|0;Qa=361658;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361914,361070,134);bD(j)}if((f[Je>>2]|0)!=((f[Ke>>2]|0)*3|0)){f[j>>2]=0;f[Sk>>2]=0;Pa=aD(j,25)|0;Qa=361993;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361914,361070,135);bD(j)}if((f[ma>>2]&4095|0)!=5){f[j>>2]=0;f[Rk>>2]=0;Pa=aD(j,55)|0;Qa=361706;Ra=Pa+55|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361914,361070,136);bD(j)}if(!(f[J>>2]&16384)){f[j>>2]=0;f[Uj>>2]=0;Pa=aD(j,19)|0;Qa=361812;Ra=Pa+19|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,361914,361070,138);bD(j)}Jl=f[Sa>>2]|0;cm=+n[Jl>>2];Vl=f[Ke>>2]|0;$l=+n[Jl+12>>2];DS(k,Q,$l);BS(j,k);Ll=cm;DS(o,R,Ll);zS(m,j,o);f[l>>2]=1124007936;Pa=Vj;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[Xj>>2]=Wj;f[Zj>>2]=Yj;f[Yj>>2]=0;f[_j>>2]=0;Jl=f[m>>2]|0;th[f[(f[Jl>>2]|0)+12>>2]&511](Jl,m,l,-1);Wi(m);Wi(o);Wi(j);Wi(k);DS(j,Q,Ll);DS(k,R,$l);zS(q,j,k);f[o>>2]=1124007936;Pa=$j;Ra=Pa+36|0;do{f[Pa>>2]=0;Pa=Pa+4|0}while((Pa|0)<(Ra|0));f[bk>>2]=ak;f[dk>>2]=ck;f[ck>>2]=0;f[ek>>2]=0;Jl=f[q>>2]|0;th[f[(f[Jl>>2]|0)+12>>2]&511](Jl,q,o,-1);Wi(q);Wi(k);Wi(j);f[fk>>2]=0;f[gk>>2]=0;f[v>>2]=16842752;f[hk>>2]=l;PS(t,ha,v,1.0);f[ik>>2]=0;f[jk>>2]=0;f[x>>2]=16842752;f[kk>>2]=o;PS(w,ia,x,1.0);vS(r,t,w);f[j>>2]=-2147483648;f[lk>>2]=2147483647;f[k>>2]=0;f[mk>>2]=Vl;lL(y,ma,j,k);Jl=f[r>>2]|0;th[f[(f[Jl>>2]|0)+12>>2]&511](Jl,r,y,-1);Jl=f[nk>>2]|0;do if(Jl|0){Ul=Jl+12|0;Tl=f[Ul>>2]|0;f[Ul>>2]=Tl+-1;if((Tl|0)!=1)break;kL(y)}while(0);f[nk>>2]=0;f[ok>>2]=0;f[ok+4>>2]=0;f[ok+8>>2]=0;f[ok+12>>2]=0;if((f[pk>>2]|0)>0){Jl=f[qk>>2]|0;Tl=0;do{f[Jl+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[pk>>2]|0))}Tl=f[rk>>2]|0;if((Tl|0)!=(sk|0))UC(Tl);Wi(r);Wi(w);Wi(t);Tl=Vl<<1;f[j>>2]=-2147483648;f[tk>>2]=2147483647;f[k>>2]=Vl;f[uk>>2]=Tl;lL(t,ma,j,k);Jl=vk;f[Jl>>2]=0;f[Jl+4>>2]=0;f[r>>2]=-1040121856;f[wk>>2]=t;SP(ha,r);Jl=f[xk>>2]|0;do if(Jl|0){Ul=Jl+12|0;Il=f[Ul>>2]|0;f[Ul>>2]=Il+-1;if((Il|0)!=1)break;kL(t)}while(0);f[xk>>2]=0;f[yk>>2]=0;f[yk+4>>2]=0;f[yk+8>>2]=0;f[yk+12>>2]=0;if((f[zk>>2]|0)>0){Jl=f[Ak>>2]|0;Il=0;do{f[Jl+(Il<<2)>>2]=0;Il=Il+1|0}while((Il|0)<(f[zk>>2]|0))}Il=f[Bk>>2]|0;if((Il|0)!=(Ck|0))UC(Il);f[j>>2]=-2147483648;f[Dk>>2]=2147483647;f[k>>2]=Tl;f[Ek>>2]=Vl*3;lL(t,ma,j,k);Il=Fk;f[Il>>2]=0;f[Il+4>>2]=0;f[r>>2]=-1040121856;f[Gk>>2]=t;SP(ia,r);Il=f[Hk>>2]|0;do if(Il|0){Jl=Il+12|0;Ul=f[Jl>>2]|0;f[Jl>>2]=Ul+-1;if((Ul|0)!=1)break;kL(t)}while(0);f[Hk>>2]=0;f[Ik>>2]=0;f[Ik+4>>2]=0;f[Ik+8>>2]=0;f[Ik+12>>2]=0;if((f[Jk>>2]|0)>0){Il=f[Kk>>2]|0;Vl=0;do{f[Il+(Vl<<2)>>2]=0;Vl=Vl+1|0}while((Vl|0)<(f[Jk>>2]|0))}Vl=f[Lk>>2]|0;if((Vl|0)!=(Mk|0))UC(Vl);Vl=f[Nk>>2]|0;do if(Vl|0){Il=Vl+12|0;Tl=f[Il>>2]|0;f[Il>>2]=Tl+-1;if((Tl|0)!=1)break;kL(o)}while(0);f[Nk>>2]=0;f[Ok>>2]=0;f[Ok+4>>2]=0;f[Ok+8>>2]=0;f[Ok+12>>2]=0;if((f[$j>>2]|0)>0){Vl=f[bk>>2]|0;Tl=0;do{f[Vl+(Tl<<2)>>2]=0;Tl=Tl+1|0}while((Tl|0)<(f[$j>>2]|0))}Tl=f[dk>>2]|0;if((Tl|0)!=(ck|0))UC(Tl);Tl=f[Pk>>2]|0;do if(Tl|0){Vl=Tl+12|0;Il=f[Vl>>2]|0;f[Vl>>2]=Il+-1;if((Il|0)!=1)break;kL(l)}while(0);f[Pk>>2]=0;f[Qk>>2]=0;f[Qk+4>>2]=0;f[Qk+8>>2]=0;f[Qk+12>>2]=0;if((f[Vj>>2]|0)>0){Tl=f[Xj>>2]|0;Il=0;do{f[Tl+(Il<<2)>>2]=0;Il=Il+1|0}while((Il|0)<(f[Vj>>2]|0))}Il=f[Zj>>2]|0;if((Il|0)!=(Yj|0))UC(Il);break}default:{}}fta(ma,ma,na);OS(j,na,0);Il=f[j>>2]|0;th[f[(f[Il>>2]|0)+12>>2]&511](Il,j,oa,-1);Wi(j);f[ie>>2]=0;f[je>>2]=0;f[j>>2]=16842752;f[ke>>2]=W;$l=+pY(T,j);Ll=$l/(Ml*Nl);p[s>>3]=Ll;if(((f[s+4>>2]&2147483647)+((f[s>>2]|0)!=0&1)|0)>>>0>2146435072){f[j>>2]=0;f[le>>2]=0;Pa=aD(j,16)|0;Qa=362019;Ra=Pa+16|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-7,j,361053,361070,525);bD(j)}fta(ma,W,pa);fta(ma,T,qa);CS(j,oa,pa);Il=f[j>>2]|0;th[f[(f[Il>>2]|0)+12>>2]&511](Il,j,ra,-1);Wi(j);f[me>>2]=0;f[ne>>2]=0;f[j>>2]=16842752;f[oe>>2]=ra;Ml=Nl*Nl-+pY(pa,j);f[pe>>2]=0;f[qe>>2]=0;f[j>>2]=16842752;f[re>>2]=ra;cm=$l-+pY(qa,j);if(!(cm<=0.0))hm=Ll;else{f[j>>2]=0;f[Ie>>2]=0;Vac(aD(j,132)|0,362036,132)|0;bO(-7,j,361053,361070,540);bD(j);hm=-1.0}ES(k,Ml/cm,T);xS(j,k,W);Il=f[j>>2]|0;th[f[(f[Il>>2]|0)+12>>2]&511](Il,j,ua,-1);Wi(j);Wi(k);fta(ma,ua,sa);CS(j,oa,sa);Il=f[j>>2]|0;th[f[(f[Il>>2]|0)+12>>2]&511](Il,j,ta,-1);Wi(j);if((f[J>>2]&4095|0)!=5){f[j>>2]=0;f[He>>2]=0;Pa=aD(j,62)|0;Qa=362169;Ra=Pa+62|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,362232,361070,252);bD(j)}if((f[ta>>2]&4095|0)!=5){f[j>>2]=0;f[Ge>>2]=0;Pa=aD(j,58)|0;Qa=362258;Ra=Pa+58|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,362232,361070,253);bD(j)}if(!ve){f[j>>2]=0;f[Fe>>2]=0;Vac(aD(j,132)|0,362317,132)|0;bO(-215,j,362232,361070,256);bD(j)}Il=f[Wa>>2]|0;do if(!g){Tl=(Il|0)==2;Vl=f[vc>>2]|0;if(ue){if(Tl&(Vl|0)==6)break;f[j>>2]=0;f[Ce>>2]=0;Pa=aD(j,40)|0;Qa=362491;Ra=Pa+40|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,362232,361070,261);bD(j);break}if(te){if(Tl&(Vl|0)==3)break;f[j>>2]=0;f[De>>2]=0;Pa=aD(j,40)|0;Qa=362532;Ra=Pa+40|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,362232,361070,263);bD(j);break}else{if(Tl&(Vl|0)==2)break;f[j>>2]=0;f[Ee>>2]=0;Pa=aD(j,40)|0;Qa=362573;Ra=Pa+40|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,362232,361070,265);bD(j);break}}else{if((Il|0)==3&(f[vc>>2]|0)==8)break;f[j>>2]=0;f[we>>2]=0;Pa=aD(j,40)|0;Qa=362450;Ra=Pa+40|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,362232,361070,259);bD(j)}while(0);if((f[xe>>2]|0)!=1){f[j>>2]=0;f[Be>>2]=0;Pa=aD(j,16)|0;Qa=362614;Ra=Pa+16|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,362232,361070,267);bD(j)}if(!(f[J>>2]&16384)){f[j>>2]=0;f[ye>>2]=0;Pa=aD(j,25)|0;Qa=362631;Ra=Pa+25|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,362232,361070,269);bD(j)}if(!(f[ta>>2]&16384)){f[j>>2]=0;f[ze>>2]=0;Pa=aD(j,21)|0;Qa=362657;Ra=Pa+21|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,j,362232,361070,270);bD(j)}Il=f[Sa>>2]|0;Vl=f[Ae>>2]|0;if(se){Tl=Il+8|0;n[Tl>>2]=+n[Vl>>2]+ +n[Tl>>2];Tl=Il+20|0;n[Tl>>2]=+n[Vl+4>>2]+ +n[Tl>>2]}if(ue){n[Il>>2]=+n[Vl>>2]+ +n[Il>>2];Tl=Il+12|0;n[Tl>>2]=+n[Vl+4>>2]+ +n[Tl>>2];Tl=Il+4|0;n[Tl>>2]=+n[Vl+8>>2]+ +n[Tl>>2];Tl=Il+16|0;n[Tl>>2]=+n[Vl+12>>2]+ +n[Tl>>2];Tl=Il+8|0;n[Tl>>2]=+n[Vl+16>>2]+ +n[Tl>>2];Tl=Il+20|0;n[Tl>>2]=+n[Vl+20>>2]+ +n[Tl>>2]}if(g){n[Il>>2]=+n[Vl>>2]+ +n[Il>>2];Tl=Il+12|0;n[Tl>>2]=+n[Vl+4>>2]+ +n[Tl>>2];Tl=Il+24|0;n[Tl>>2]=+n[Vl+8>>2]+ +n[Tl>>2];Tl=Il+4|0;n[Tl>>2]=+n[Vl+12>>2]+ +n[Tl>>2];Tl=Il+16|0;n[Tl>>2]=+n[Vl+16>>2]+ +n[Tl>>2];Tl=Il+28|0;n[Tl>>2]=+n[Vl+20>>2]+ +n[Tl>>2];Tl=Il+8|0;n[Tl>>2]=+n[Vl+24>>2]+ +n[Tl>>2];Tl=Il+20|0;n[Tl>>2]=+n[Vl+28>>2]+ +n[Tl>>2]}if(te){Tl=Il+12|0;Ll=+n[Vl>>2]+ +S(+(+n[Tl>>2]));Ul=Il+8|0;n[Ul>>2]=+n[Vl+4>>2]+ +n[Ul>>2];Ul=Il+20|0;n[Ul>>2]=+n[Vl+8>>2]+ +n[Ul>>2];$l=+O(+Ll);n[Il+16>>2]=$l;n[Il>>2]=$l;$l=+P(+Ll);n[Tl>>2]=$l;n[Il+4>>2]=-$l}if((Gl|0)<(Xa|0)){$l=Fl;Fl=hm;Gl=Gl+1|0;Hl=$l}else{Cc=hm;break a}}}while(0);Xa=ua+36|0;j=f[Xa>>2]|0;do if(j|0){Qa=j+12|0;Pa=f[Qa>>2]|0;f[Qa>>2]=Pa+-1;if((Pa|0)!=1)break;kL(ua)}while(0);f[Xa>>2]=0;Xa=ua+16|0;f[Xa>>2]=0;f[Xa+4>>2]=0;f[Xa+8>>2]=0;f[Xa+12>>2]=0;if((f[Za>>2]|0)>0){Xa=f[Ac>>2]|0;Ac=0;do{f[Xa+(Ac<<2)>>2]=0;Ac=Ac+1|0}while((Ac|0)<(f[Za>>2]|0))}Za=f[Bc>>2]|0;if((Za|0)!=(zc|0))UC(Za);Za=ta+36|0;zc=f[Za>>2]|0;do if(zc|0){Bc=zc+12|0;Ac=f[Bc>>2]|0;f[Bc>>2]=Ac+-1;if((Ac|0)!=1)break;kL(ta)}while(0);f[Za>>2]=0;Za=ta+16|0;f[Za>>2]=0;f[Za+4>>2]=0;f[Za+8>>2]=0;f[Za+12>>2]=0;if((f[uc>>2]|0)>0){Za=f[wc>>2]|0;wc=0;do{f[Za+(wc<<2)>>2]=0;wc=wc+1|0}while((wc|0)<(f[uc>>2]|0))}uc=f[yc>>2]|0;if((uc|0)!=(xc|0))UC(uc);uc=sa+36|0;xc=f[uc>>2]|0;do if(xc|0){yc=xc+12|0;wc=f[yc>>2]|0;f[yc>>2]=wc+-1;if((wc|0)!=1)break;kL(sa)}while(0);f[uc>>2]=0;uc=sa+16|0;f[uc>>2]=0;f[uc+4>>2]=0;f[uc+8>>2]=0;f[uc+12>>2]=0;if((f[qc>>2]|0)>0){uc=f[sc>>2]|0;sc=0;do{f[uc+(sc<<2)>>2]=0;sc=sc+1|0}while((sc|0)<(f[qc>>2]|0))}qc=f[tc>>2]|0;if((qc|0)!=(rc|0))UC(qc);qc=ra+36|0;rc=f[qc>>2]|0;do if(rc|0){tc=rc+12|0;sc=f[tc>>2]|0;f[tc>>2]=sc+-1;if((sc|0)!=1)break;kL(ra)}while(0);f[qc>>2]=0;qc=ra+16|0;f[qc>>2]=0;f[qc+4>>2]=0;f[qc+8>>2]=0;f[qc+12>>2]=0;if((f[mc>>2]|0)>0){qc=f[oc>>2]|0;oc=0;do{f[qc+(oc<<2)>>2]=0;oc=oc+1|0}while((oc|0)<(f[mc>>2]|0))}mc=f[pc>>2]|0;if((mc|0)!=(nc|0))UC(mc);mc=qa+36|0;nc=f[mc>>2]|0;do if(nc|0){pc=nc+12|0;oc=f[pc>>2]|0;f[pc>>2]=oc+-1;if((oc|0)!=1)break;kL(qa)}while(0);f[mc>>2]=0;mc=qa+16|0;f[mc>>2]=0;f[mc+4>>2]=0;f[mc+8>>2]=0;f[mc+12>>2]=0;if((f[ic>>2]|0)>0){mc=f[kc>>2]|0;kc=0;do{f[mc+(kc<<2)>>2]=0;kc=kc+1|0}while((kc|0)<(f[ic>>2]|0))}ic=f[lc>>2]|0;if((ic|0)!=(jc|0))UC(ic);ic=pa+36|0;jc=f[ic>>2]|0;do if(jc|0){lc=jc+12|0;kc=f[lc>>2]|0;f[lc>>2]=kc+-1;if((kc|0)!=1)break;kL(pa)}while(0);f[ic>>2]=0;ic=pa+16|0;f[ic>>2]=0;f[ic+4>>2]=0;f[ic+8>>2]=0;f[ic+12>>2]=0;if((f[ec>>2]|0)>0){ic=f[gc>>2]|0;gc=0;do{f[ic+(gc<<2)>>2]=0;gc=gc+1|0}while((gc|0)<(f[ec>>2]|0))}ec=f[hc>>2]|0;if((ec|0)!=(fc|0))UC(ec);ec=oa+36|0;fc=f[ec>>2]|0;do if(fc|0){hc=fc+12|0;gc=f[hc>>2]|0;f[hc>>2]=gc+-1;if((gc|0)!=1)break;kL(oa)}while(0);f[ec>>2]=0;ec=oa+16|0;f[ec>>2]=0;f[ec+4>>2]=0;f[ec+8>>2]=0;f[ec+12>>2]=0;if((f[ac>>2]|0)>0){ec=f[cc>>2]|0;cc=0;do{f[ec+(cc<<2)>>2]=0;cc=cc+1|0}while((cc|0)<(f[ac>>2]|0))}ac=f[dc>>2]|0;if((ac|0)!=(bc|0))UC(ac);ac=na+36|0;bc=f[ac>>2]|0;do if(bc|0){dc=bc+12|0;cc=f[dc>>2]|0;f[dc>>2]=cc+-1;if((cc|0)!=1)break;kL(na)}while(0);f[ac>>2]=0;ac=na+16|0;f[ac>>2]=0;f[ac+4>>2]=0;f[ac+8>>2]=0;f[ac+12>>2]=0;if((f[la>>2]|0)>0){ac=f[_b>>2]|0;_b=0;do{f[ac+(_b<<2)>>2]=0;_b=_b+1|0}while((_b|0)<(f[la>>2]|0))}la=f[$b>>2]|0;if((la|0)!=(Zb|0))UC(la);la=ma+36|0;Zb=f[la>>2]|0;do if(Zb|0){$b=Zb+12|0;_b=f[$b>>2]|0;f[$b>>2]=_b+-1;if((_b|0)!=1)break;kL(ma)}while(0);f[la>>2]=0;la=ma+16|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[Xb>>2]|0)>0){la=f[ja>>2]|0;ja=0;do{f[la+(ja<<2)>>2]=0;ja=ja+1|0}while((ja|0)<(f[Xb>>2]|0))}Xb=f[Yb>>2]|0;if((Xb|0)!=(ka|0))UC(Xb);Xb=ia+36|0;ka=f[Xb>>2]|0;do if(ka|0){Yb=ka+12|0;ja=f[Yb>>2]|0;f[Yb>>2]=ja+-1;if((ja|0)!=1)break;kL(ia)}while(0);f[Xb>>2]=0;Xb=ia+16|0;f[Xb>>2]=0;f[Xb+4>>2]=0;f[Xb+8>>2]=0;f[Xb+12>>2]=0;if((f[Sb>>2]|0)>0){Xb=f[Ub>>2]|0;Ub=0;do{f[Xb+(Ub<<2)>>2]=0;Ub=Ub+1|0}while((Ub|0)<(f[Sb>>2]|0))}Sb=f[Vb>>2]|0;if((Sb|0)!=(Tb|0))UC(Sb);Sb=ha+36|0;Tb=f[Sb>>2]|0;do if(Tb|0){Vb=Tb+12|0;Ub=f[Vb>>2]|0;f[Vb>>2]=Ub+-1;if((Ub|0)!=1)break;kL(ha)}while(0);f[Sb>>2]=0;Sb=ha+16|0;f[Sb>>2]=0;f[Sb+4>>2]=0;f[Sb+8>>2]=0;f[Sb+12>>2]=0;if((f[ga>>2]|0)>0){Sb=f[Pb>>2]|0;Pb=0;do{f[Sb+(Pb<<2)>>2]=0;Pb=Pb+1|0}while((Pb|0)<(f[ga>>2]|0))}ga=f[Rb>>2]|0;if((ga|0)!=(Qb|0))UC(ga);ga=fa+36|0;Qb=f[ga>>2]|0;do if(Qb|0){Rb=Qb+12|0;Pb=f[Rb>>2]|0;f[Rb>>2]=Pb+-1;if((Pb|0)!=1)break;kL(fa)}while(0);f[ga>>2]=0;ga=fa+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[Ta>>2]|0)>0){ga=f[ea>>2]|0;ea=0;do{f[ga+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[Ta>>2]|0))}Ta=f[Nb>>2]|0;if((Ta|0)!=(Ua|0))UC(Ta);Ta=da+36|0;Ua=f[Ta>>2]|0;do if(Ua|0){Nb=Ua+12|0;ea=f[Nb>>2]|0;f[Nb>>2]=ea+-1;if((ea|0)!=1)break;kL(da)}while(0);f[Ta>>2]=0;Ta=da+16|0;f[Ta>>2]=0;f[Ta+4>>2]=0;f[Ta+8>>2]=0;f[Ta+12>>2]=0;if((f[ca>>2]|0)>0){Ta=f[Lb>>2]|0;Lb=0;do{f[Ta+(Lb<<2)>>2]=0;Lb=Lb+1|0}while((Lb|0)<(f[ca>>2]|0))}ca=f[Mb>>2]|0;if((ca|0)!=(ba|0))UC(ca);ca=aa+36|0;ba=f[ca>>2]|0;do if(ba|0){Mb=ba+12|0;Lb=f[Mb>>2]|0;f[Mb>>2]=Lb+-1;if((Lb|0)!=1)break;kL(aa)}while(0);f[ca>>2]=0;ca=aa+16|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[$>>2]|0)>0){ca=f[Kb>>2]|0;Kb=0;do{f[ca+(Kb<<2)>>2]=0;Kb=Kb+1|0}while((Kb|0)<(f[$>>2]|0))}$=f[Jb>>2]|0;if(($|0)!=(h|0))UC($);$=_+36|0;h=f[$>>2]|0;do if(h|0){Jb=h+12|0;Kb=f[Jb>>2]|0;f[Jb>>2]=Kb+-1;if((Kb|0)!=1)break;kL(_)}while(0);f[$>>2]=0;$=_+16|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[Fb>>2]|0)>0){$=f[Hb>>2]|0;Hb=0;do{f[$+(Hb<<2)>>2]=0;Hb=Hb+1|0}while((Hb|0)<(f[Fb>>2]|0))}Fb=f[Ib>>2]|0;if((Fb|0)!=(Gb|0))UC(Fb);Fb=Z+36|0;Gb=f[Fb>>2]|0;do if(Gb|0){Ib=Gb+12|0;Hb=f[Ib>>2]|0;f[Ib>>2]=Hb+-1;if((Hb|0)!=1)break;kL(Z)}while(0);f[Fb>>2]=0;Fb=Z+16|0;Gb=Z+4|0;f[Fb>>2]=0;f[Fb+4>>2]=0;f[Fb+8>>2]=0;f[Fb+12>>2]=0;if((f[Gb>>2]|0)>0){Fb=f[Z+40>>2]|0;Hb=0;do{f[Fb+(Hb<<2)>>2]=0;Hb=Hb+1|0}while((Hb|0)<(f[Gb>>2]|0))}Gb=f[Z+44>>2]|0;if((Gb|0)!=(Z+48|0))UC(Gb);Gb=X+36|0;Z=f[Gb>>2]|0;do if(Z|0){Hb=Z+12|0;Fb=f[Hb>>2]|0;f[Hb>>2]=Fb+-1;if((Fb|0)!=1)break;kL(X)}while(0);f[Gb>>2]=0;Gb=X+16|0;f[Gb>>2]=0;f[Gb+4>>2]=0;f[Gb+8>>2]=0;f[Gb+12>>2]=0;if((f[Bb>>2]|0)>0){Gb=f[Db>>2]|0;Db=0;do{f[Gb+(Db<<2)>>2]=0;Db=Db+1|0}while((Db|0)<(f[Bb>>2]|0))}Bb=f[Eb>>2]|0;if((Bb|0)!=(Cb|0))UC(Bb);Bb=W+36|0;Cb=f[Bb>>2]|0;do if(Cb|0){Eb=Cb+12|0;Db=f[Eb>>2]|0;f[Eb>>2]=Db+-1;if((Db|0)!=1)break;kL(W)}while(0);f[Bb>>2]=0;Bb=W+16|0;f[Bb>>2]=0;f[Bb+4>>2]=0;f[Bb+8>>2]=0;f[Bb+12>>2]=0;if((f[xb>>2]|0)>0){Bb=f[zb>>2]|0;zb=0;do{f[Bb+(zb<<2)>>2]=0;zb=zb+1|0}while((zb|0)<(f[xb>>2]|0))}xb=f[Ab>>2]|0;if((xb|0)!=(yb|0))UC(xb);xb=V+36|0;yb=f[xb>>2]|0;do if(yb|0){Ab=yb+12|0;zb=f[Ab>>2]|0;f[Ab>>2]=zb+-1;if((zb|0)!=1)break;kL(V)}while(0);f[xb>>2]=0;xb=V+16|0;f[xb>>2]=0;f[xb+4>>2]=0;f[xb+8>>2]=0;f[xb+12>>2]=0;if((f[tb>>2]|0)>0){xb=f[vb>>2]|0;vb=0;do{f[xb+(vb<<2)>>2]=0;vb=vb+1|0}while((vb|0)<(f[tb>>2]|0))}tb=f[wb>>2]|0;if((tb|0)!=(ub|0))UC(tb);tb=U+36|0;ub=f[tb>>2]|0;do if(ub|0){wb=ub+12|0;vb=f[wb>>2]|0;f[wb>>2]=vb+-1;if((vb|0)!=1)break;kL(U)}while(0);f[tb>>2]=0;tb=U+16|0;f[tb>>2]=0;f[tb+4>>2]=0;f[tb+8>>2]=0;f[tb+12>>2]=0;if((f[pb>>2]|0)>0){tb=f[rb>>2]|0;rb=0;do{f[tb+(rb<<2)>>2]=0;rb=rb+1|0}while((rb|0)<(f[pb>>2]|0))}pb=f[sb>>2]|0;if((pb|0)!=(qb|0))UC(pb);pb=T+36|0;qb=f[pb>>2]|0;do if(qb|0){sb=qb+12|0;rb=f[sb>>2]|0;f[sb>>2]=rb+-1;if((rb|0)!=1)break;kL(T)}while(0);f[pb>>2]=0;pb=T+16|0;f[pb>>2]=0;f[pb+4>>2]=0;f[pb+8>>2]=0;f[pb+12>>2]=0;if((f[lb>>2]|0)>0){pb=f[mb>>2]|0;mb=0;do{f[pb+(mb<<2)>>2]=0;mb=mb+1|0}while((mb|0)<(f[lb>>2]|0))}lb=f[ob>>2]|0;if((lb|0)!=(nb|0))UC(lb);lb=R+36|0;nb=f[lb>>2]|0;do if(nb|0){ob=nb+12|0;mb=f[ob>>2]|0;f[ob>>2]=mb+-1;if((mb|0)!=1)break;kL(R)}while(0);f[lb>>2]=0;lb=R+16|0;f[lb>>2]=0;f[lb+4>>2]=0;f[lb+8>>2]=0;f[lb+12>>2]=0;if((f[cb>>2]|0)>0){lb=f[eb>>2]|0;eb=0;do{f[lb+(eb<<2)>>2]=0;eb=eb+1|0}while((eb|0)<(f[cb>>2]|0))}cb=f[fb>>2]|0;if((cb|0)!=(db|0))UC(cb);cb=Q+36|0;db=f[cb>>2]|0;do if(db|0){fb=db+12|0;eb=f[fb>>2]|0;f[fb>>2]=eb+-1;if((eb|0)!=1)break;kL(Q)}while(0);f[cb>>2]=0;cb=Q+16|0;f[cb>>2]=0;f[cb+4>>2]=0;f[cb+8>>2]=0;f[cb+12>>2]=0;if((f[_a>>2]|0)>0){cb=f[ab>>2]|0;ab=0;do{f[cb+(ab<<2)>>2]=0;ab=ab+1|0}while((ab|0)<(f[_a>>2]|0))}_a=f[bb>>2]|0;if((_a|0)!=($a|0))UC(_a);_a=f[hb>>2]|0;do if(_a|0){$a=_a+12|0;bb=f[$a>>2]|0;f[$a>>2]=bb+-1;if((bb|0)!=1)break;kL(N)}while(0);f[hb>>2]=0;f[ib>>2]=0;f[ib+4>>2]=0;f[ib+8>>2]=0;f[ib+12>>2]=0;if((f[Ia>>2]|0)>0){ib=f[La>>2]|0;La=0;do{f[ib+(La<<2)>>2]=0;La=La+1|0}while((La|0)<(f[Ia>>2]|0))}Ia=f[Ka>>2]|0;if((Ia|0)!=(Ha|0))UC(Ia);Ia=f[kb>>2]|0;do if(Ia|0){Ha=Ia+12|0;Ka=f[Ha>>2]|0;f[Ha>>2]=Ka+-1;if((Ka|0)!=1)break;kL(K)}while(0);f[kb>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[d>>2]|0)>0){gb=f[Ja>>2]|0;Ja=0;do{f[gb+(Ja<<2)>>2]=0;Ja=Ja+1|0}while((Ja|0)<(f[d>>2]|0))}d=f[Ma>>2]|0;if((d|0)!=(Va|0))UC(d);d=J+36|0;Va=f[d>>2]|0;do if(Va|0){Ma=Va+12|0;Ja=f[Ma>>2]|0;f[Ma>>2]=Ja+-1;if((Ja|0)!=1)break;kL(J)}while(0);f[d>>2]=0;d=J+4|0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[d>>2]|0)>0){Sa=f[J+40>>2]|0;Va=0;do{f[Sa+(Va<<2)>>2]=0;Va=Va+1|0}while((Va|0)<(f[d>>2]|0))}d=f[J+44>>2]|0;if((d|0)!=(J+48|0))UC(d);d=I+36|0;J=f[d>>2]|0;do if(J|0){Va=J+12|0;Sa=f[Va>>2]|0;f[Va>>2]=Sa+-1;if((Sa|0)!=1)break;kL(I)}while(0);f[d>>2]=0;d=I+4|0;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=0;f[Na+12>>2]=0;if((f[d>>2]|0)>0){Na=f[I+40>>2]|0;J=0;do{f[Na+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[d>>2]|0))}d=f[I+44>>2]|0;if((d|0)!=(I+48|0))UC(d);d=H+36|0;I=f[d>>2]|0;do if(I|0){J=I+12|0;Na=f[J>>2]|0;f[J>>2]=Na+-1;if((Na|0)!=1)break;kL(H)}while(0);f[d>>2]=0;d=H+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[H+40>>2]|0;I=0;do{f[c+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[d>>2]|0))}d=f[H+44>>2]|0;if((d|0)==(H+48|0)){u=i;return +Cc}UC(d);u=i;return +Cc}function fta(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;e=u;u=u+192|0;g=e+176|0;h=e+168|0;i=e+112|0;j=e+56|0;k=e;if((f[a+8>>2]|0)!=(f[c+8>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,22)|0;m=362679;o=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));bO(-215,g,362702,361070,219);bD(g)}p=a+12|0;q=f[p>>2]|0;r=c+12|0;s=f[r>>2]|0;if(!((q|0)%(s|0)|0)){t=q;v=s}else{f[g>>2]=0;f[g+4>>2]=0;l=aD(g,28)|0;m=362728;o=l+28|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));bO(-215,g,362702,361070,220);bD(g);t=f[p>>2]|0;v=f[r>>2]|0}p=f[d+16>>2]|0;if((t|0)!=(v|0)){t=d+8|0;if((f[t>>2]|0)<=0){u=e;return}s=g+4|0;q=h+4|0;w=i+8|0;x=i+12|0;y=i+4|0;z=j+36|0;A=j+16|0;B=j+4|0;C=j+40|0;D=j+44|0;E=j+48|0;F=0;do{G=Y(F,v)|0;H=F;F=F+1|0;I=Y(F,v)|0;f[g>>2]=-2147483648;f[s>>2]=2147483647;f[h>>2]=G;f[q>>2]=I;lL(j,a,g,h);f[w>>2]=0;f[x>>2]=0;f[i>>2]=16842752;f[y>>2]=j;J=+pY(c,i);n[p+(H<<2)>>2]=J;H=f[z>>2]|0;if(H|0?(I=H+12|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)kL(j);f[z>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){H=f[C>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[B>>2]|0))}I=f[D>>2]|0;if((I|0)!=(E|0))UC(I)}while((F|0)<(f[t>>2]|0));u=e;return}t=d+12|0;F=f[t>>2]|0;E=d+8|0;if((F|0)==(f[E>>2]|0)){K=F;L=v;M=F}else{f[g>>2]=0;f[g+4>>2]=0;l=aD(g,20)|0;m=362757;o=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));bO(-215,g,362702,361070,233);bD(g);K=f[t>>2]|0;L=f[r>>2]|0;M=f[E>>2]|0}r=(L|0)/(K|0)|0;f[i>>2]=1124007936;K=i+4|0;L=i+8|0;m=i+40|0;l=K;o=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(o|0));f[m>>2]=L;l=i+48|0;o=i+44|0;f[o>>2]=l;f[l>>2]=0;f[i+52>>2]=0;if((M|0)>0){M=g+4|0;F=h+4|0;v=j+36|0;d=i+36|0;D=i+16|0;B=j+4|0;C=j+8|0;A=j+12|0;z=i+12|0;y=j+44|0;x=j+16|0;w=j+20|0;q=i+20|0;s=j+24|0;I=i+24|0;H=j+28|0;G=i+28|0;N=j+32|0;O=i+32|0;P=j+40|0;Q=j+48|0;R=g+8|0;S=g+12|0;T=g+4|0;U=g+4|0;V=h+4|0;W=j+8|0;X=j+12|0;Z=j+4|0;_=k+36|0;$=k+16|0;aa=k+4|0;ba=k+40|0;ca=k+44|0;da=k+48|0;ea=0;do{fa=Y(ea,r)|0;ga=ea;ea=ea+1|0;ha=Y(ea,r)|0;f[g>>2]=-2147483648;f[M>>2]=2147483647;f[h>>2]=fa;f[F>>2]=ha;lL(j,a,g,h);ha=f[v>>2]|0;if(ha|0){fa=ha+12|0;f[fa>>2]=(f[fa>>2]|0)+1}fa=f[d>>2]|0;if(fa|0?(ha=fa+12|0,fa=f[ha>>2]|0,f[ha>>2]=fa+-1,(fa|0)==1):0)kL(i);f[d>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[K>>2]|0)>0){fa=f[m>>2]|0;ha=0;do{f[fa+(ha<<2)>>2]=0;ha=ha+1|0;ia=f[K>>2]|0}while((ha|0)<(ia|0));f[i>>2]=f[j>>2];if((ia|0)<3)ja=43;else ja=45}else{f[i>>2]=f[j>>2];ja=43}if((ja|0)==43){ja=0;ha=f[B>>2]|0;if((ha|0)<3){f[K>>2]=ha;f[L>>2]=f[C>>2];f[z>>2]=f[A>>2];ha=f[y>>2]|0;fa=f[o>>2]|0;f[fa>>2]=f[ha>>2];f[fa+4>>2]=f[ha+4>>2]}else ja=45}if((ja|0)==45){ja=0;jL(i,j)}f[D>>2]=f[x>>2];f[q>>2]=f[w>>2];f[I>>2]=f[s>>2];f[G>>2]=f[H>>2];f[O>>2]=f[N>>2];ha=f[v>>2]|0;f[d>>2]=ha;if(ha|0?(fa=ha+12|0,ha=f[fa>>2]|0,f[fa>>2]=ha+-1,(ha|0)==1):0)kL(j);f[v>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[B>>2]|0)>0){ha=f[P>>2]|0;fa=0;do{f[ha+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[B>>2]|0))}fa=f[y>>2]|0;if((fa|0)!=(Q|0))UC(fa);f[R>>2]=0;f[S>>2]=0;f[g>>2]=16842752;f[T>>2]=i;J=+LG(g,4,UM()|0);fa=f[E>>2]|0;ha=p+((Y(fa+1|0,ga)|0)<<2)|0;n[ha>>2]=J*J;if((ea|0)<(f[t>>2]|0)){ha=ea;do{ka=Y(ha,r)|0;la=ha;ha=ha+1|0;ma=Y(ha,r)|0;f[g>>2]=-2147483648;f[U>>2]=2147483647;f[h>>2]=ka;f[V>>2]=ma;lL(k,c,g,h);f[W>>2]=0;f[X>>2]=0;f[j>>2]=16842752;f[Z>>2]=k;J=+pY(i,j);ma=p+((Y(f[t>>2]|0,ga)|0)+la<<2)|0;n[ma>>2]=J;ma=f[_>>2]|0;if(ma|0?(ka=ma+12|0,ma=f[ka>>2]|0,f[ka>>2]=ma+-1,(ma|0)==1):0)kL(k);f[_>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[aa>>2]|0)>0){ma=f[ba>>2]|0;ka=0;do{f[ma+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[aa>>2]|0))}ka=f[ca>>2]|0;if((ka|0)!=(da|0))UC(ka);ka=f[t>>2]|0;ma=p+((Y(ka,ga)|0)+la<<2)|0;na=p+((Y(ka,la)|0)+ga<<2)|0;f[na>>2]=f[ma>>2]}while((ha|0)<(ka|0));oa=f[E>>2]|0}else oa=fa}while((ea|0)<(oa|0));oa=f[d>>2]|0;if((oa|0)!=0?(ea=oa+12|0,oa=f[ea>>2]|0,f[ea>>2]=oa+-1,(oa|0)==1):0){kL(i);pa=d}else pa=d}else pa=i+36|0;f[pa>>2]=0;pa=i+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[K>>2]|0)>0){pa=f[m>>2]|0;m=0;do{f[pa+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[K>>2]|0))}K=f[o>>2]|0;if((K|0)!=(l|0))UC(K);u=e;return}function gta(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=104892;bD(a+184|0);b=a+72|0;c=a+108|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+88|0;b=a+76|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+112>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+116>>2]|0;if((b|0)!=(a+120|0))UC(b);b=a+16|0;d=a+52|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+32|0;b=a+20|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+56>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+60>>2]|0;if((b|0)==(a+64|0)){xY(a);return}UC(b);xY(a);return}function hta(a){a=a|0;gta(a);O5b(a);return}function ita(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;GY(a,c);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,4)|0;b[g>>0]=110;b[g+1>>0]=97;b[g+2>>0]=109;b[g+3>>0]=101;g=gW(c,e)|0;bD(e);i=gW(g,a+184|0)|0;f[e>>2]=0;f[e+4>>2]=0;g=aD(e,7)|0;b[g>>0]=b[363736]|0;b[g+1>>0]=b[363737]|0;b[g+2>>0]=b[363738]|0;b[g+3>>0]=b[363739]|0;b[g+4>>0]=b[363740]|0;b[g+5>>0]=b[363741]|0;b[g+6>>0]=b[363742]|0;g=gW(i,e)|0;bD(e);i=a+132|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](g)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,30)|0;l=363892;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,e,489622,363923,1181);bD(e)}oW(g,c+12|0,f[i>>2]|0);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=aD(e,9)|0;l=363744;m=k+9|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j=gW(g,e)|0;bD(e);g=a+136|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,30)|0;l=363892;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,e,489622,363923,1181);bD(e)}oW(j,c+12|0,f[g>>2]|0);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=aD(e,15)|0;l=363754;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));i=gW(j,e)|0;bD(e);j=a+152|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](i)|0){g=c+32|0;if((f[g>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,30)|0;l=363892;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,e,489622,363923,1181);bD(e)}pW(i,c+12|0,+n[j>>2]);if(f[g>>2]&4|0)f[g>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=aD(e,12)|0;l=363770;m=k+12|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));g=gW(i,e)|0;bD(e);i=a+144|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](g)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,30)|0;l=363892;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,e,489622,363923,1181);bD(e)}qW(g,c+12|0,+p[i>>3]);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=aD(e,15)|0;l=363783;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j=gW(g,e)|0;bD(e);g=a+156|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,30)|0;l=363892;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,e,489622,363923,1181);bD(e)}pW(j,c+12|0,+n[g>>2]);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;i=aD(e,7)|0;b[i>>0]=b[363799]|0;b[i+1>>0]=b[363800]|0;b[i+2>>0]=b[363801]|0;b[i+3>>0]=b[363802]|0;b[i+4>>0]=b[363803]|0;b[i+5>>0]=b[363804]|0;b[i+6>>0]=b[363805]|0;i=gW(j,e)|0;bD(e);j=a+160|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](i)|0){g=c+32|0;if((f[g>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,30)|0;l=363892;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,e,489622,363923,1181);bD(e)}pW(i,c+12|0,+n[j>>2]);if(f[g>>2]&4|0)f[g>>2]=6}f[e>>2]=0;f[e+4>>2]=0;g=aD(e,6)|0;b[g>>0]=b[363807]|0;b[g+1>>0]=b[363808]|0;b[g+2>>0]=b[363809]|0;b[g+3>>0]=b[363810]|0;b[g+4>>0]=b[363811]|0;b[g+5>>0]=b[363812]|0;g=gW(i,e)|0;bD(e);i=a+164|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](g)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,30)|0;l=363892;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,e,489622,363923,1181);bD(e)}pW(g,c+12|0,+n[i>>2]);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;j=aD(e,6)|0;b[j>>0]=b[363814]|0;b[j+1>>0]=b[363815]|0;b[j+2>>0]=b[363816]|0;b[j+3>>0]=b[363817]|0;b[j+4>>0]=b[363818]|0;b[j+5>>0]=b[363819]|0;j=gW(g,e)|0;bD(e);g=a+168|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,30)|0;l=363892;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,e,489622,363923,1181);bD(e)}pW(j,c+12|0,+n[g>>2]);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=aD(e,28)|0;l=363821;m=k+28|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));i=gW(j,e)|0;bD(e);j=a+172|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](i)|0){g=c+32|0;if((f[g>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,30)|0;l=363892;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,e,489622,363923,1181);bD(e)}pW(i,c+12|0,+n[j>>2]);if(f[g>>2]&4|0)f[g>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=aD(e,13)|0;l=363850;m=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));g=gW(i,e)|0;bD(e);i=h[a+176>>0]|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](g)|0){j=c+32|0;if((f[j>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,30)|0;l=363892;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,e,489622,363923,1181);bD(e)}oW(g,c+12|0,i);if(f[j>>2]&4|0)f[j>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=aD(e,11)|0;l=363864;m=k+11|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));j=gW(g,e)|0;bD(e);g=h[a+177>>0]|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](j)|0){i=c+32|0;if((f[i>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,30)|0;l=363892;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,e,489622,363923,1181);bD(e)}oW(j,c+12|0,g);if(f[i>>2]&4|0)f[i>>2]=6}f[e>>2]=0;f[e+4>>2]=0;k=aD(e,15)|0;l=363876;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));i=gW(j,e)|0;bD(e);j=a+180|0;if(!(di[f[(f[c>>2]|0)+12>>2]&1023](i)|0)){u=d;return}a=c+32|0;if((f[a>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;k=aD(e,30)|0;l=363892;m=k+30|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-2,e,489622,363923,1181);bD(e)}pW(i,c+12|0,+n[j>>2]);if(!(f[a>>2]&4)){u=d;return}f[a>>2]=6;u=d;return}function jta(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+112|0;e=d;g=d+8|0;h=d+104|0;i=d+96|0;j=d+88|0;k=d+80|0;l=d+72|0;m=d+64|0;n=d+56|0;o=d+48|0;q=d+40|0;r=d+32|0;s=d+24|0;t=d+16|0;jW(g,c,442989);f[e>>2]=0;f[e+4>>2]=0;yW(g,e,e);g=f[e>>2]|0;v=f[a+184>>2]|0;if((g|0)!=(v|0)){w=(gTb((g|0)==0?1124530:g,(v|0)==0?1124530:v)|0)==0;bD(e);if(!w){f[e>>2]=0;f[e+4>>2]=0;w=aD(e,27)|0;v=363703;g=w+27|0;do{b[w>>0]=b[v>>0]|0;w=w+1|0;v=v+1|0}while((w|0)<(g|0));bO(-215,e,363731,363026,307);bD(e)}}else bD(e);jW(h,c,363736);vW(h,e,0);f[a+132>>2]=f[e>>2];jW(i,c,363744);vW(i,e,0);f[a+136>>2]=f[e>>2];jW(j,c,363754);wW(j,e,0.0);f[a+152>>2]=f[e>>2];jW(k,c,363770);xW(k,e,0.0);p[a+144>>3]=+p[e>>3];jW(l,c,363783);wW(l,e,0.0);f[a+156>>2]=f[e>>2];jW(m,c,363799);wW(m,e,0.0);f[a+160>>2]=f[e>>2];jW(n,c,363807);wW(n,e,0.0);f[a+164>>2]=f[e>>2];jW(o,c,363814);wW(o,e,0.0);f[a+168>>2]=f[e>>2];jW(q,c,363821);wW(q,e,0.0);f[a+172>>2]=f[e>>2];jW(r,c,363850);vW(r,e,0);b[a+176>>0]=(f[e>>2]|0)!=0&1;jW(s,c,363864);vW(s,e,0);s=f[e>>2]|0;b[a+177>>0]=s>>>0<256?s:(s|0)>0?255:0;jW(t,c,363876);wW(t,e,0.0);f[a+180>>2]=f[e>>2];u=d;return}function kta(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0;g=u;u=u+224|0;h=g+208|0;i=g+152|0;j=g+144|0;k=g+80|0;l=g+88|0;m=g+72|0;o=g;dQ(h,105108);q=a+128|0;do if(!(e>=1.0|(f[q>>2]|0)==0)){AL(i,c,-1);if(!((f[i>>2]|0)!=(f[a+4>>2]|0)?1:(f[i+4>>2]|0)!=(f[a+8>>2]|0))?(r=BL(c,-1)|0,(r|0)==(f[a+12>>2]|0)):0)break;else{s=5;break}}else s=5;while(0);if((s|0)==5){AL(j,c,-1);Ota(a,j,BL(c,-1)|0)}do if((yM(c)|0)==65536){j=f[c+4>>2]|0;f[i>>2]=f[j>>2];s=i+4|0;r=j+4|0;f[s>>2]=f[r>>2];t=i+8|0;f[t>>2]=f[j+8>>2];f[i+12>>2]=f[j+12>>2];f[i+16>>2]=f[j+16>>2];f[i+20>>2]=f[j+20>>2];f[i+24>>2]=f[j+24>>2];f[i+28>>2]=f[j+28>>2];f[i+32>>2]=f[j+32>>2];v=f[j+36>>2]|0;f[i+36>>2]=v;w=i+40|0;f[w>>2]=t;t=i+48|0;x=i+44|0;f[x>>2]=t;f[t>>2]=0;f[i+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[r>>2]|0)<3){r=f[j+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[r>>2];f[t+4>>2]=f[r+4>>2];y=w;break}else{f[s>>2]=0;jL(i,j);y=w;break}}else{yL(i,c,-1);y=i+40|0}while(0);c=f[y>>2]|0;w=f[c>>2]|0;f[k>>2]=f[c+4>>2];f[k+4>>2]=w;vM(d,k,0,-1,0,0);do if((yM(d)|0)==65536){k=f[d+4>>2]|0;f[l>>2]=f[k>>2];w=l+4|0;c=k+4|0;f[w>>2]=f[c>>2];j=l+8|0;f[j>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[l+16>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];s=f[k+36>>2]|0;f[l+36>>2]=s;f[l+40>>2]=j;j=l+48|0;r=l+44|0;f[r>>2]=j;f[j>>2]=0;f[l+52>>2]=0;if(s|0){j=s+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[c>>2]|0)<3){c=f[k+44>>2]|0;j=f[r>>2]|0;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];break}else{f[w>>2]=0;jL(l,k);break}}else yL(l,d,-1);while(0);d=f[q>>2]|0;k=d+1|0;f[q>>2]=k;if(e>=0.0&(d|0)>0)z=e;else{d=k<<1;k=f[a+132>>2]|0;z=1.0/+(((k|0)<(d|0)?k:d)|0)}if(!(z>=0.0)){f[m>>2]=0;f[m+4>>2]=0;d=aD(m,17)|0;k=363535;q=d+17|0;do{b[d>>0]=b[k>>0]|0;d=d+1|0;k=k+1|0}while((d|0)<(q|0));bO(-215,m,440399,363026,865);bD(m)}k=i+8|0;d=f[k>>2]|0;f[m>>2]=0;f[m+4>>2]=d;q=f[a+32>>2]|0;w=f[a+136>>2]|0;c=Y(w<<3,d)|0;d=f[i+12>>2]|0;j=q+(Y(c,d)|0)|0;c=f[a+88>>2]|0;e=+p[a+144>>3];r=f[a+152>>2]|0;s=f[a+156>>2]|0;t=f[a+160>>2]|0;A=+n[a+164>>2];B=+n[a+168>>2];C=-(z*+n[a+172>>2]);x=f[a+180>>2]|0;v=b[a+176>>0]|0;D=b[a+177>>0]|0;f[o>>2]=105136;f[o+4>>2]=i;f[o+8>>2]=l;f[o+12>>2]=q;f[o+16>>2]=j;f[o+20>>2]=c;f[o+24>>2]=w;n[o+28>>2]=z;n[o+32>>2]=e;f[o+36>>2]=r;f[o+40>>2]=s;f[o+44>>2]=t;n[o+48>>2]=A>B?B:A;n[o+52>>2]=A<B?B:A;n[o+56>>2]=C;f[o+60>>2]=x;b[o+64>>0]=v;b[o+65>>0]=D;D=i+4|0;v=f[D>>2]|0;if((v|0)<3)E=Y(d,f[k>>2]|0)|0;else{k=f[y>>2]|0;d=0;x=1;while(1){t=Y(f[k+(d<<2)>>2]|0,x)|0;d=d+1|0;if((d|0)==(v|0)){E=t;break}else x=t}}RQ(m,o,+(E>>>0)*.0000152587890625);E=l+36|0;o=f[E>>2]|0;if(o|0?(m=o+12|0,o=f[m>>2]|0,f[m>>2]=o+-1,(o|0)==1):0)kL(l);f[E>>2]=0;E=l+16|0;o=l+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[o>>2]|0)>0){E=f[l+40>>2]|0;m=0;do{f[E+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[o>>2]|0))}o=f[l+44>>2]|0;if((o|0)!=(l+48|0))UC(o);o=i+36|0;l=f[o>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)kL(i);f[o>>2]=0;o=i+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[D>>2]|0)>0){o=f[y>>2]|0;y=0;do{f[o+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[D>>2]|0))}D=f[i+44>>2]|0;if((D|0)!=(i+48|0))UC(D);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function lta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=a+12|0;g=f[e>>2]|0;switch(g|0){case 21:case 5:case 16:case 0:{h=g;break}default:{f[d>>2]=0;f[d+4>>2]=0;Vac(aD(d,228)|0,362778,228)|0;bO(-215,d,363007,363026,924);bD(d);h=f[e>>2]|0}}switch(h|0){case 0:{Kta(a,b);u=c;return}case 16:{Lta(a,b);u=c;return}case 5:{Mta(a,b);u=c;return}case 21:{Nta(a,b);u=c;return}default:{u=c;return}}}function mta(a){a=a|0;return f[a+132>>2]|0}function nta(a,b){a=a|0;b=b|0;f[a+132>>2]=b;return}function ota(a){a=a|0;return f[a+136>>2]|0}function pta(a,b){a=a|0;b=b|0;f[a+136>>2]=b;return}function qta(a){a=a|0;return +(+n[a+152>>2])}function rta(a,b){a=a|0;b=+b;n[a+152>>2]=b;return}function sta(a){a=a|0;return +(+p[a+144>>3])}function tta(a,b){a=a|0;b=+b;p[a+144>>3]=b;return}function uta(a){a=a|0;return +(+n[a+156>>2])}function vta(a,b){a=a|0;b=+b;n[a+156>>2]=b;return}function wta(a){a=a|0;return +(+n[a+160>>2])}function xta(a,b){a=a|0;b=+b;n[a+160>>2]=b;return}function yta(a){a=a|0;return +(+n[a+164>>2])}function zta(a,b){a=a|0;b=+b;n[a+164>>2]=b;return}function Ata(a){a=a|0;return +(+n[a+168>>2])}function Bta(a,b){a=a|0;b=+b;n[a+168>>2]=b;return}function Cta(a){a=a|0;return +(+n[a+172>>2])}function Dta(a,b){a=a|0;b=+b;n[a+172>>2]=b;return}function Eta(a){a=a|0;return (b[a+176>>0]|0)!=0|0}function Fta(a,c){a=a|0;c=c|0;var d=0;d=a+176|0;if(!((b[d>>0]|0)!=0^c))return;b[d>>0]=c&1;return}function Gta(a){a=a|0;return h[a+177>>0]|0|0}function Hta(a,c){a=a|0;c=c|0;b[a+177>>0]=c;return}function Ita(a){a=a|0;return +(+n[a+180>>2])}function Jta(a,b){a=a|0;b=+b;n[a+180>>2]=b;return}function Kta(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,M=0,N=0,O=0,P=0;d=u;u=u+112|0;e=d+96|0;g=d+88|0;h=d+32|0;i=d;dQ(g,105088);j=a+4|0;k=f[j>>2]|0;l=a+8|0;m=f[l>>2]|0;o=f[a+12>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;s=p;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;s=h+48|0;t=h+44|0;f[t>>2]=s;f[s>>2]=0;f[h+52>>2]=0;f[e>>2]=m;f[e+4>>2]=k;hL(h,2,e,o&4095);UP(h,i)|0;i=f[a+32>>2]|0;o=Y(f[l>>2]|0,f[j>>2]|0)|0;j=a+136|0;l=i+((Y(o,f[j>>2]|0)|0)<<3)|0;o=f[q>>2]|0;if((o|0)>0){e=h+12|0;k=a+88|0;m=a+116|0;v=h+16|0;w=a+152|0;a=0;x=0;y=o;o=f[e>>2]|0;while(1){if((o|0)>0){z=0;A=a;do{B=(f[k>>2]|0)+(Y(f[f[m>>2]>>2]|0,x)|0)+z|0;C=b[B>>0]|0;B=(C&255)+A|0;if(!(C<<24>>24)){D=0.0;E=0.0}else{F=+n[w>>2];C=A;G=0.0;H=0.0;while(1){I=+n[i+(C<<3)>>2];J=H+I*+n[l+(C<<2)>>2];K=G+I;C=C+1|0;if(!(!(K>F)&(C|0)<(B|0))){D=K;E=J;break}else{G=K;H=J}}}B=+L(+D)>1.1920928955078125e-07;C=LVb(E*(B?1.0/D:0.0))|0;B=(f[v>>2]|0)+(Y(f[f[t>>2]>>2]|0,x)|0)+z|0;b[B>>0]=C>>>0<256?C:(C|0)>0?255:0;A=(f[j>>2]|0)+A|0;z=z+1|0;M=f[e>>2]|0}while((z|0)<(M|0));N=A;O=M;P=f[q>>2]|0}else{N=a;O=o;P=y}x=x+1|0;if((x|0)>=(P|0))break;else{a=N;y=P;o=O}}}SP(h,c);c=h+36|0;O=f[c>>2]|0;if(O|0?(o=O+12|0,O=f[o>>2]|0,f[o>>2]=O+-1,(O|0)==1):0)kL(h);f[c>>2]=0;c=h+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[r>>2]|0;r=0;do{f[c+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[t>>2]|0;if((p|0)!=(s|0))UC(p);if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function Lta(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,M=0.0,N=0.0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+112|0;e=d+96|0;g=d+88|0;h=d+32|0;i=d;dQ(g,105068);j=a+4|0;k=f[j>>2]|0;l=a+8|0;m=f[l>>2]|0;o=f[a+12>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;s=p;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;s=h+48|0;t=h+44|0;f[t>>2]=s;f[s>>2]=0;f[h+52>>2]=0;f[e>>2]=m;f[e+4>>2]=k;hL(h,2,e,o&4095);UP(h,i)|0;i=f[a+32>>2]|0;o=Y(f[l>>2]|0,f[j>>2]|0)|0;j=a+136|0;l=i+((Y(o,f[j>>2]|0)|0)<<3)|0;o=f[q>>2]|0;if((o|0)>0){e=h+12|0;k=a+88|0;m=a+116|0;v=h+16|0;w=a+152|0;a=0;x=0;y=o;o=f[e>>2]|0;while(1){if((o|0)>0){z=0;A=a;do{B=(f[k>>2]|0)+(Y(f[f[m>>2]>>2]|0,x)|0)+z|0;C=b[B>>0]|0;B=(C&255)+A|0;if(!(C<<24>>24)){D=0.0;E=0.0;F=0.0;G=0.0}else{H=+n[w>>2];C=A;I=0.0;J=0.0;K=0.0;M=0.0;while(1){N=+n[i+(C<<3)>>2];O=C*3|0;P=J+N*+n[l+(O<<2)>>2];Q=K+N*+n[l+(O+1<<2)>>2];R=M+N*+n[l+(O+2<<2)>>2];S=I+N;C=C+1|0;if(!(!(S>H)&(C|0)<(B|0))){D=S;E=P;F=Q;G=R;break}else{I=S;J=P;K=Q;M=R}}}B=+L(+D)>1.1920928955078125e-07;M=B?1.0/D:0.0;B=LVb(E*M)|0;C=LVb(F*M)|0;O=LVb(M*G)|0;T=(f[v>>2]|0)+(Y(f[f[t>>2]>>2]|0,x)|0)|0;b[T+(z*3|0)>>0]=B>>>0<256?B:(B|0)>0?255:0;b[T+(z*3|0)+1>>0]=C>>>0<256?C:(C|0)>0?255:0;b[T+(z*3|0)+2>>0]=O>>>0<256?O:(O|0)>0?255:0;A=(f[j>>2]|0)+A|0;z=z+1|0;U=f[e>>2]|0}while((z|0)<(U|0));V=A;W=U;X=f[q>>2]|0}else{V=a;W=o;X=y}x=x+1|0;if((x|0)>=(X|0))break;else{a=V;y=X;o=W}}}SP(h,c);c=h+36|0;W=f[c>>2]|0;if(W|0?(o=W+12|0,W=f[o>>2]|0,f[o>>2]=W+-1,(W|0)==1):0)kL(h);f[c>>2]=0;c=h+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[r>>2]|0;r=0;do{f[c+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[t>>2]|0;if((p|0)!=(s|0))UC(p);if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function Mta(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,M=0,N=0,O=0,P=0;d=u;u=u+112|0;e=d+96|0;g=d+88|0;h=d+32|0;i=d;dQ(g,105048);j=a+4|0;k=f[j>>2]|0;l=a+8|0;m=f[l>>2]|0;o=f[a+12>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;s=p;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;s=h+48|0;t=h+44|0;f[t>>2]=s;f[s>>2]=0;f[h+52>>2]=0;f[e>>2]=m;f[e+4>>2]=k;hL(h,2,e,o&4095);UP(h,i)|0;i=f[a+32>>2]|0;o=Y(f[l>>2]|0,f[j>>2]|0)|0;j=a+136|0;l=i+((Y(o,f[j>>2]|0)|0)<<3)|0;o=f[q>>2]|0;if((o|0)>0){e=h+12|0;k=a+88|0;m=a+116|0;v=h+16|0;w=a+152|0;a=0;x=0;y=f[e>>2]|0;z=o;while(1){if((y|0)>0){o=0;A=a;do{B=(f[k>>2]|0)+(Y(f[f[m>>2]>>2]|0,x)|0)+o|0;C=b[B>>0]|0;B=(C&255)+A|0;if(!(C<<24>>24)){D=0.0;E=0.0}else{F=+n[w>>2];C=A;G=0.0;H=0.0;while(1){I=+n[i+(C<<3)>>2];J=H+I*+n[l+(C<<2)>>2];K=G+I;C=C+1|0;if(!(!(K>F)&(C|0)<(B|0))){D=K;E=J;break}else{G=K;H=J}}}B=+L(+D)>1.1920928955078125e-07;C=(f[v>>2]|0)+(Y(f[f[t>>2]>>2]|0,x)|0)+(o<<2)|0;n[C>>2]=E*(B?1.0/D:0.0);A=(f[j>>2]|0)+A|0;o=o+1|0;M=f[e>>2]|0}while((o|0)<(M|0));N=A;O=f[q>>2]|0;P=M}else{N=a;O=z;P=y}x=x+1|0;if((x|0)>=(O|0))break;else{a=N;y=P;z=O}}}SP(h,c);c=h+36|0;O=f[c>>2]|0;if(O|0?(z=O+12|0,O=f[z>>2]|0,f[z>>2]=O+-1,(O|0)==1):0)kL(h);f[c>>2]=0;c=h+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[r>>2]|0;r=0;do{f[c+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[t>>2]|0;if((p|0)!=(s|0))UC(p);if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function Nta(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,M=0.0,N=0.0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0;d=u;u=u+112|0;e=d+96|0;g=d+88|0;h=d+32|0;i=d;dQ(g,105028);j=a+4|0;k=f[j>>2]|0;l=a+8|0;m=f[l>>2]|0;o=f[a+12>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;f[h>>2]=1124007936;p=h+4|0;q=h+8|0;r=h+40|0;s=p;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;s=h+48|0;t=h+44|0;f[t>>2]=s;f[s>>2]=0;f[h+52>>2]=0;f[e>>2]=m;f[e+4>>2]=k;hL(h,2,e,o&4095);UP(h,i)|0;i=f[a+32>>2]|0;o=Y(f[l>>2]|0,f[j>>2]|0)|0;j=a+136|0;l=i+((Y(o,f[j>>2]|0)|0)<<3)|0;o=f[q>>2]|0;if((o|0)>0){e=h+12|0;k=a+88|0;m=a+116|0;v=h+16|0;w=a+152|0;a=0;x=0;y=o;o=f[e>>2]|0;while(1){if((o|0)>0){z=0;A=a;do{B=(f[k>>2]|0)+(Y(f[f[m>>2]>>2]|0,x)|0)+z|0;C=b[B>>0]|0;B=(C&255)+A|0;if(!(C<<24>>24)){D=0.0;E=0.0;F=0.0;G=0.0}else{H=+n[w>>2];C=A;I=0.0;J=0.0;K=0.0;M=0.0;while(1){N=+n[i+(C<<3)>>2];O=C*3|0;P=J+N*+n[l+(O<<2)>>2];Q=K+N*+n[l+(O+1<<2)>>2];R=M+N*+n[l+(O+2<<2)>>2];S=I+N;C=C+1|0;if(!(!(S>H)&(C|0)<(B|0))){D=S;E=P;F=Q;G=R;break}else{I=S;J=P;K=Q;M=R}}}B=+L(+D)>1.1920928955078125e-07;M=B?1.0/D:0.0;B=(f[v>>2]|0)+(Y(f[f[t>>2]>>2]|0,x)|0)|0;n[B+(z*12|0)>>2]=E*M;n[B+(z*12|0)+4>>2]=F*M;n[B+(z*12|0)+8>>2]=M*G;A=(f[j>>2]|0)+A|0;z=z+1|0;T=f[e>>2]|0}while((z|0)<(T|0));U=A;V=T;W=f[q>>2]|0}else{U=a;V=o;W=y}x=x+1|0;if((x|0)>=(W|0))break;else{a=U;y=W;o=V}}}SP(h,c);c=h+36|0;V=f[c>>2]|0;if(V|0?(o=V+12|0,V=f[o>>2]|0,f[o>>2]=V+-1,(V|0)==1):0)kL(h);f[c>>2]=0;c=h+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[r>>2]|0;r=0;do{f[c+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[t>>2]|0;if((p|0)!=(s|0))UC(p);if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function Ota(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+32|0;g=e;h=a+4|0;f[h>>2]=f[c>>2];i=a+8|0;f[i>>2]=f[c+4>>2];f[a+12>>2]=d;f[a+128>>2]=0;c=d>>>3&511;if((c+1|0)>>>0>=513){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,16)|0;k=363572;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,363589,363026,192);bD(g)}d=a+136|0;m=f[d>>2]|0;if((m|0)<256)n=m;else{f[g>>2]=0;f[g+4>>2]=0;j=aD(g,16)|0;k=363600;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,363589,363026,193);bD(g);n=f[d>>2]|0}d=a+16|0;k=f[i>>2]|0;j=f[h>>2]|0;l=Y(Y(Y(k,c+3|0)|0,j)|0,n)|0;if(((((f[a+20>>2]|0)<3?(f[a+24>>2]|0)==1:0)?(f[a+28>>2]|0)==(l|0):0)?(f[d>>2]&4095|0)==5:0)?(f[a+32>>2]|0)!=0:0){o=k;p=j}else{f[g>>2]=1;f[g+4>>2]=l;hL(d,2,g,5);o=f[i>>2]|0;p=f[h>>2]|0}h=a+72|0;if(((((f[a+76>>2]|0)<3?(f[a+80>>2]|0)==(o|0):0)?(f[a+84>>2]|0)==(p|0):0)?(f[h>>2]&4095|0)==0:0)?f[a+88>>2]|0:0){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;UP(h,g)|0;u=e;return}f[g>>2]=o;f[g+4>>2]=p;hL(h,2,g,0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;UP(h,g)|0;u=e;return}function Pta(a){a=a|0;O5b(a);return}function Qta(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0.0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0,Na=0,Oa=0,Pa=0.0,Qa=0.0,Ra=0,Sa=0,Ta=0.0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0.0,eb=0.0,fb=0,gb=0,hb=0;d=u;u=u+3248|0;e=d+3224|0;g=d+3168|0;i=d+2104|0;j=d+56|0;k=d;l=f[c>>2]|0;m=f[c+4>>2]|0;c=a+4|0;o=f[c>>2]|0;p=f[o+12>>2]|0;q=((f[o>>2]|0)>>>3&511)+1|0;r=Y(p,q)|0;s=i+8|0;f[i>>2]=s;t=i+4|0;f[t>>2]=r;if(r>>>0>264){v=N5b(r>>>0>1073741823?-1:r<<2)|0;f[i>>2]=v;w=v}else w=s;v=a+28|0;x=1.0-+n[v>>2];a:do if((l|0)<(m|0)){r=a+16|0;y=a+24|0;z=a+12|0;A=a+20|0;B=a+8|0;C=(p|0)>0;D=a+64|0;E=a+32|0;F=a+36|0;G=a+60|0;H=a+65|0;I=a+44|0;J=a+56|0;K=(q|0)==3;M=j+4|0;N=j+8|0;O=a+40|0;P=a+48|0;Q=a+52|0;R=e+4|0;S=g+4|0;T=(q<<3)+-3|0;U=e+8|0;V=e+4|0;W=g+36|0;X=g+16|0;Z=g+4|0;_=g+40|0;$=g+44|0;aa=g+48|0;ba=k+36|0;ca=k+16|0;da=k+4|0;ea=k+40|0;fa=k+44|0;ga=k+48|0;ha=l;ia=o;ja=w;while(1){if((f[ia>>2]&7|0)!=5){f[e>>2]=ha;f[R>>2]=ha+1;f[g>>2]=-2147483648;f[S>>2]=2147483647;lL(k,ia,e,g);Qi(g,1,p,T,ja,0);ka=U;f[ka>>2]=0;f[ka+4>>2]=0;f[e>>2]=-1040121856;f[V>>2]=g;OJ(k,e,5,1.0,0.0);ka=f[W>>2]|0;if(ka|0?(la=ka+12|0,ka=f[la>>2]|0,f[la>>2]=ka+-1,(ka|0)==1):0)kL(g);f[W>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Z>>2]|0)>0){ka=f[_>>2]|0;la=0;do{f[ka+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[Z>>2]|0))}la=f[$>>2]|0;if((la|0)!=(aa|0))UC(la);la=f[ba>>2]|0;if(la|0?(ka=la+12|0,la=f[ka>>2]|0,f[ka>>2]=la+-1,(la|0)==1):0)kL(k);f[ba>>2]=0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[da>>2]|0)>0){la=f[ea>>2]|0;ka=0;do{f[la+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[da>>2]|0))}ka=f[fa>>2]|0;if((ka|0)==(ga|0))ma=ja;else{UC(ka);ma=ja}}else ma=(f[ia+16>>2]|0)+(Y(f[f[ia+44>>2]>>2]|0,ha)|0)|0;ka=Y(f[y>>2]|0,p)|0;la=(f[A>>2]|0)+(Y(ha,p)|0)|0;na=f[B>>2]|0;oa=(f[na+16>>2]|0)+(Y(f[f[na+44>>2]>>2]|0,ha)|0)|0;if(C){na=(f[z>>2]|0)+((Y(ka,ha)|0)<<3)|0;pa=0;qa=na;na=(f[r>>2]|0)+((Y(Y(ha,q)|0,ka)|0)<<2)|0;ka=ma;while(1){ra=la+pa|0;sa=b[ra>>0]|0;ta=sa&255;if(!(sa<<24>>24)){ua=0.0;va=ta;wa=0;xa=0}else{sa=ka+4|0;ya=ka+8|0;za=0;Aa=na;Ba=0.0;Ca=ta;ta=0;Da=0;Ea=+n[J>>2];while(1){Fa=x*+n[qa+(za<<3)>>2]+Ea;b:do if(!ta){Ga=qa+(za<<3)+4|0;Ha=+n[Ga>>2];if(K){Ia=+n[Aa>>2]-+n[ka>>2];n[j>>2]=Ia;Ja=+n[Aa+4>>2]-+n[sa>>2];n[M>>2]=Ja;Ka=+n[Aa+8>>2]-+n[ya>>2];n[N>>2]=Ka;La=Ka*Ka+(Ia*Ia+Ja*Ja)}else{Ma=0;Ja=0.0;while(1){Ia=+n[Aa+(Ma<<2)>>2]-+n[ka+(Ma<<2)>>2];n[j+(Ma<<2)>>2]=Ia;Ka=Ja+Ia*Ia;Ma=Ma+1|0;if((Ma|0)==(q|0)){La=Ka;break}else Ja=Ka}}if(Ba<+n[F>>2]?La<Ha*+n[E>>2]:0)Na=1;else Na=Da;if(La<Ha*+n[O>>2]){Ja=+n[v>>2];Ka=Fa+Ja;Ia=Ja/Ka;Ma=0;do{Oa=Aa+(Ma<<2)|0;n[Oa>>2]=+n[Oa>>2]-Ia*+n[j+(Ma<<2)>>2];Ma=Ma+1|0}while((Ma|0)!=(q|0));Ja=Ha+(La-Ha)*Ia;Pa=+n[P>>2];Qa=Ja<Pa?Pa:Ja;Ja=+n[Q>>2];n[Ga>>2]=Qa>Ja?Ja:Qa;if((za|0)>0){Ma=za;Oa=0;while(1){Ra=Ma;Ma=Ma+-1|0;Sa=qa+(Ma<<3)|0;if(Ka<+n[Sa>>2]){Ta=Ka;Ua=Oa;Va=1;Wa=Na;break b}Xa=qa+(Ra<<3)|0;Ya=Xa;Za=f[Ya>>2]|0;_a=f[Ya+4>>2]|0;Ya=Sa;$a=f[Ya+4>>2]|0;ab=Xa;f[ab>>2]=f[Ya>>2];f[ab+4>>2]=$a;$a=Sa;f[$a>>2]=Za;f[$a+4>>2]=_a;_a=Y(Ra,q)|0;$a=Y(Ma,q)|0;Za=0;do{Sa=na+(Za+_a<<2)|0;ab=na+(Za+$a<<2)|0;Ya=f[Sa>>2]|0;f[Sa>>2]=f[ab>>2];f[ab>>2]=Ya;Za=Za+1|0}while((Za|0)!=(q|0));Za=Oa+1|0;if((Ra|0)<=1){Ta=Ka;Ua=Za;Va=1;Wa=Na;break}else Oa=Za}}else{Ta=Ka;Ua=0;Va=1;Wa=Na}}else{Ta=Fa;Ua=0;Va=0;Wa=Na}}else{Ta=Fa;Ua=0;Va=1;Wa=Da}while(0);Ea=+n[J>>2];Oa=Ta<-Ea;Ma=(Oa<<31>>31)+Ca|0;Fa=Oa?0.0:Ta;n[qa+(za-Ua<<3)>>2]=Fa;Ia=Ba+Fa;za=za+1|0;if((za|0)>=(Ma|0)){ua=Ia;va=Ma;wa=Va;xa=Wa;break}else{Aa=Aa+(q<<2)|0;Ba=Ia;Ca=Ma;ta=Va;Da=Wa}}}Da=+L(+ua)>1.1920928955078125e-07;Ba=Da?1.0/ua:0.0;if((va|0)>0){Da=0;do{ta=qa+(Da<<3)|0;n[ta>>2]=Ba*+n[ta>>2];Da=Da+1|0}while((Da|0)!=(va|0))}c:do if(!wa?(Ba=+n[v>>2],Ba>0.0):0){Da=f[y>>2]|0;ta=(va|0)==(Da|0);Ca=((ta^1)&1)+va|0;Aa=ta?Da+-1|0:va;Da=qa+(Aa<<3)|0;if((Ca|0)!=1){n[Da>>2]=Ba;ta=Ca+-1|0;if((Ca|0)>1){za=0;do{ya=qa+(za<<3)|0;n[ya>>2]=x*+n[ya>>2];za=za+1|0}while((za|0)<(ta|0))}}else n[Da>>2]=1.0;ta=Y(Aa,q)|0;za=0;do{f[na+(za+ta<<2)>>2]=f[ka+(za<<2)>>2];za=za+1|0}while((za|0)!=(q|0));f[qa+(Aa<<3)+4>>2]=f[I>>2];if((Ca|0)>1){za=Ca;while(1){ta=za+-2|0;za=za+-1|0;Da=qa+(ta<<3)|0;if(+n[v>>2]<+n[Da>>2]){bb=Ca;break c}ya=qa+(za<<3)|0;sa=ya;Ma=f[sa>>2]|0;Oa=f[sa+4>>2]|0;sa=Da;Ga=f[sa+4>>2]|0;Za=ya;f[Za>>2]=f[sa>>2];f[Za+4>>2]=Ga;Ga=Da;f[Ga>>2]=Ma;f[Ga+4>>2]=Oa;Oa=Y(za,q)|0;Ga=Y(ta,q)|0;ta=0;do{Ma=na+(ta+Oa<<2)|0;Da=na+(ta+Ga<<2)|0;Za=f[Ma>>2]|0;f[Ma>>2]=f[Da>>2];f[Da>>2]=Za;ta=ta+1|0}while((ta|0)!=(q|0));if((za|0)<=1){bb=Ca;break}}}else bb=Ca}else bb=va;while(0);b[ra>>0]=bb;d:do if(!xa)if((b[D>>0]|0)!=0?(Ka=+n[E>>2],Ba=+n[F>>2],Ea=+n[G>>2],(bb|0)>0):0){za=0;Aa=na;Ia=0.0;ta=0;while(1){Fa=+n[qa+(ta<<3)>>2];Ha=+n[qa+(ta<<3)+4>>2];Ga=0;Qa=0.0;Ja=0.0;do{Pa=+n[Aa+(Ga<<2)>>2];Ja=Ja+ +n[ka+(Ga<<2)>>2]*Pa;Qa=Qa+Pa*Pa;Ga=Ga+1|0}while((Ga|0)!=(q|0));if(Qa==0.0){cb=255;break d}if(!(!(Ja<=Qa)|!(Ja>=Ea*Qa))){Pa=Ja/Qa;Ga=0;db=0.0;do{eb=Pa*+n[Aa+(Ga<<2)>>2]-+n[ka+(Ga<<2)>>2];db=db+eb*eb;Ga=Ga+1|0}while((Ga|0)!=(q|0));Ga=db<Pa*(Ka*Ha*Pa);fb=za|Ga;if(Ga)break;else gb=fb}else gb=za;Ia=Ia+Fa;if(Ia>Ba){cb=255;break d}ta=ta+1|0;if((ta|0)>=(bb|0)){cb=255;break d}else{za=gb;Aa=Aa+(q<<2)|0}}if(fb)cb=h[H>>0]|0;else cb=255}else cb=255;else cb=0;while(0);b[oa+pa>>0]=cb;pa=pa+1|0;ra=f[y>>2]|0;na=na+((Y(ra,q)|0)<<2)|0;if((pa|0)==(p|0))break;else{qa=qa+(ra<<3)|0;ka=ka+(q<<2)|0}}}ka=ha+1|0;qa=f[i>>2]|0;if((ka|0)>=(m|0)){hb=qa;break a}ha=ka;ia=f[c>>2]|0;ja=qa}}else hb=w;while(0);if((hb|0)==(s|0)){u=d;return}if(hb|0)P5b(hb);f[i>>2]=s;f[t>>2]=264;u=d;return}function Rta(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;var e=0;e=L5b(192)|0;Sta(e,b,c,d);d=L5b(16)|0;b=d+4|0;f[b>>2]=1;f[d>>2]=105156;f[d+8>>2]=e;f[a>>2]=d;f[a+4>>2]=e;f[b>>2]=(f[b>>2]|0)+1;e=f[b>>2]|0;f[b>>2]=e+-1;if((e|0)!=1)return;bi[f[(f[d>>2]|0)+8>>2]&2047](d);return}function Sta(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=e&1;FY(a);f[a>>2]=104892;e=a+4|0;h=a+8|0;f[a+16>>2]=1124007936;i=a+24|0;j=a+56|0;k=a+20|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+64|0;f[a+60>>2]=i;f[i>>2]=0;f[a+68>>2]=0;f[a+72>>2]=1124007936;i=a+80|0;j=a+112|0;k=a+76|0;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;i=a+120|0;f[a+116>>2]=i;f[i>>2]=0;f[a+124>>2]=0;i=a+184|0;f[i>>2]=0;f[a+188>>2]=0;f[e>>2]=0;f[h>>2]=0;f[a+12>>2]=0;f[a+128>>2]=0;f[a+132>>2]=(c|0)>0?c:500;p[a+144>>3]=d>0.0?d:16.0;b[a+176>>0]=g;f[a+136>>2]=5;n[a+152>>2]=.8999999761581421;n[a+160>>2]=15.0;n[a+168>>2]=75.0;n[a+164>>2]=4.0;n[a+156>>2]=9.0;n[a+172>>2]=.05000000074505806;b[a+177>>0]=127;n[a+180>>2]=.5;bD(i);k=aD(i,25)|0;i=364137;l=k+25|0;do{b[k>>0]=b[i>>0]|0;k=k+1|0;i=i+1|0}while((k|0)<(l|0));return}function Tta(a){a=a|0;O5b(a);return}function Uta(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Vta(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0;e=u;u=u+320|0;g=e;h=e+296|0;i=e+276|0;j=e+264|0;k=e+256|0;l=e+168|0;m=e+160|0;n=e+152|0;o=e+112|0;p=e+100|0;q=e+88|0;r=e+4|0;s=e+248|0;t=f[c>>2]|0;c=f[d>>2]|0;d=(c|0)==0?1124530:c;f[r+40>>2]=0;f[r+44>>2]=0;c=r+40|0;v=r+36|0;w=r;x=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(x|0));f[v>>2]=c;f[r+52>>2]=0;f[r+56>>2]=0;v=r+52|0;f[r+48>>2]=v;y=r+60|0;f[y>>2]=0;z=r+64|0;f[z>>2]=0;f[r+68>>2]=0;A=r+72|0;f[r+76>>2]=0;B=r+80|0;f[B>>2]=0;C=r+76|0;f[A>>2]=C;dQ(h,105168);Lab((t|0)==0?1124530:t,r);if(b[d>>0]|0)Mab(d,r);Fua(a);d=f[a>>2]|0;f[s>>2]=d;f[s+4>>2]=f[a+4>>2];if(d|0){a=d+4|0;f[a>>2]=(f[a>>2]|0)+1}dQ(k,105188);k=r+12|0;a=r+16|0;d=(f[a>>2]|0)-(f[k>>2]|0)|0;t=(d|0)/76|0;Wta(A,f[C>>2]|0);f[B>>2]=0;f[A>>2]=C;f[C>>2]=0;B=f[y>>2]|0;D=f[z>>2]|0;if((D|0)==(B|0)){E=B;F=y;G=E;H=E}else{E=D;while(1){D=E+-20|0;f[z>>2]=D;if((b[D+11>>0]|0)<0){O5b(f[D>>2]|0);I=f[z>>2]|0}else I=D;if((I|0)==(B|0))break;else E=I}F=y;G=B;H=f[y>>2]|0}I=t+1|0;E=r+68|0;D=H;if((((f[E>>2]|0)-H|0)/20|0)>>>0<I>>>0){if(I>>>0>214748364){J=ze(8)|0;T5b(J,477177);f[J>>2]=149528;If(J|0,25408,1411)}J=L5b(I*20|0)|0;K=J+(((G-H|0)/20|0)*20|0)|0;H=K;L=J+(I*20|0)|0;if((B|0)==(D|0)){M=H;N=G;O=B}else{G=B;B=H;I=K;do{K=G;G=G+-20|0;X5b(I+-20|0,G);J=K+-8|0;K=f[J+4>>2]|0;P=I+-8|0;f[P>>2]=f[J>>2];f[P+4>>2]=K;I=B+-20|0;B=I}while((G|0)!=(D|0));M=B;N=f[F>>2]|0;O=f[z>>2]|0}f[F>>2]=M;f[z>>2]=H;f[E>>2]=L;L=N;if((O|0)!=(L|0)){H=O;do{H=H+-20|0;if((b[H+11>>0]|0)<0)O5b(f[H>>2]|0)}while((H|0)!=(L|0))}if(N|0)O5b(N)}f[h>>2]=0;N=h+4|0;f[N>>2]=0;f[h+8>>2]=0;L=L5b(8)|0;f[h>>2]=L;H=L+8|0;f[h+8>>2]=H;O=L;f[O>>2]=0;f[O+4>>2]=0;f[N>>2]=H;H=j+11|0;O=i+12|0;L=i+11|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[H>>0]=4;f[j>>2]=1635017060;b[j+4>>0]=0;X5b(i,j);f[O>>2]=0;f[i+16>>2]=0;M=f[z>>2]|0;B=f[E>>2]|0;D=B;if((M|0)==(B|0)){B=f[F>>2]|0;G=(M-B|0)/20|0;I=G+1|0;if(I>>>0>214748364)c4b(y);K=(D-B|0)/20|0;B=K<<1;D=K>>>0<107374182?(B>>>0<I>>>0?I:B):214748364;do if(D)if(D>>>0>214748364){B=ze(8)|0;T5b(B,477177);f[B>>2]=149528;If(B|0,25408,1411)}else{Q=L5b(D*20|0)|0;break}else Q=0;while(0);B=Q+(G*20|0)|0;I=B;K=Q+(D*20|0)|0;X5b(B,i);D=O;P=f[D+4>>2]|0;J=Q+(G*20|0)+12|0;f[J>>2]=f[D>>2];f[J+4>>2]=P;P=B+20|0;J=f[y>>2]|0;D=f[z>>2]|0;if((D|0)==(J|0)){R=I;S=J;T=J}else{G=D;D=I;I=B;do{B=G;G=G+-20|0;X5b(I+-20|0,G);Q=B+-8|0;B=f[Q+4>>2]|0;U=I+-8|0;f[U>>2]=f[Q>>2];f[U+4>>2]=B;I=D+-20|0;D=I}while((G|0)!=(J|0));R=D;S=f[F>>2]|0;T=f[z>>2]|0}f[F>>2]=R;f[z>>2]=P;f[E>>2]=K;K=S;if((T|0)!=(K|0)){P=T;do{P=P+-20|0;if((b[P+11>>0]|0)<0)O5b(f[P>>2]|0)}while((P|0)!=(K|0))}if(S|0)O5b(S)}else{X5b(M,i);S=O;O=f[S+4>>2]|0;K=M+12|0;f[K>>2]=f[S>>2];f[K+4>>2]=O;f[z>>2]=(f[z>>2]|0)+20}if((b[L>>0]|0)<0)O5b(f[i>>2]|0);if((b[H>>0]|0)<0)O5b(f[j>>2]|0);H=f[h>>2]|0;bD(H);L=aD(H,4)|0;b[L>>0]=100;b[L+1>>0]=97;b[L+2>>0]=116;b[L+3>>0]=97;Dwa(s,h);L=f[h>>2]|0;if(L|0){while(1){H=f[N>>2]|0;if((H|0)==(L|0))break;O=H+-8|0;f[N>>2]=O;bD(O)}O5b(f[h>>2]|0)}a:do if((d|0)>0){N=m+4|0;L=h+11|0;O=h+4|0;H=l+12|0;K=n+4|0;S=h+11|0;M=h+4|0;P=l+36|0;T=o+12|0;R=l+48|0;D=o+24|0;J=l+60|0;G=o+28|0;I=l+64|0;B=o+32|0;U=l+68|0;Q=o+36|0;V=l+72|0;W=l+24|0;X=l+28|0;Y=p+11|0;Z=p+4|0;_=q+11|0;$=h+4|0;aa=i+11|0;ba=i+4|0;ca=j+11|0;da=h+11|0;ea=h+4|0;fa=i+11|0;ga=i+4|0;ha=i+4|0;ia=i+12|0;ja=i+16|0;ka=i+11|0;la=0;b:while(1){ma=f[k>>2]|0;if((((f[a>>2]|0)-ma|0)/76|0)>>>0<=la>>>0){na=60;break}_ta(l,ma+(la*76|0)|0);X5b(h,l);f[m>>2]=0;f[N>>2]=0;ma=b[L>>0]|0;oa=ma<<24>>24<0?f[O>>2]|0:ma&255;if(!oa)pa=ma;else{ma=aD(m,oa)|0;Vac(ma|0,((b[L>>0]|0)<0?f[h>>2]|0:h)|0,oa|0)|0;pa=b[L>>0]|0}if(pa<<24>>24<0)O5b(f[h>>2]|0);X5b(h,H);f[n>>2]=0;f[K>>2]=0;oa=b[S>>0]|0;ma=oa<<24>>24<0?f[M>>2]|0:oa&255;if(!ma)qa=oa;else{oa=aD(n,ma)|0;Vac(oa|0,((b[S>>0]|0)<0?f[h>>2]|0:h)|0,ma|0)|0;qa=b[S>>0]|0}if(qa<<24>>24<0)O5b(f[h>>2]|0);$ta(o,P);aua(T,R);ma=f[J>>2]|0;f[D>>2]=ma;f[G>>2]=f[I>>2];if(ma|0){oa=ma+-4|0;f[oa>>2]=(f[oa>>2]|0)+1}oa=f[U>>2]|0;f[B>>2]=oa;f[Q>>2]=f[V>>2];if(oa|0){ma=oa+-4|0;f[ma>>2]=(f[ma>>2]|0)+1}ma=cua(A,m)|0;oa=f[ma>>2]|0;f[ma>>2]=oa+1;if(oa|0){f[g>>2]=oa;hO(h,364163,g);eP(m,h)|0;bD(h)}oa=lva(s,m,n,o)|0;ma=f[X>>2]|0;ra=f[W>>2]|0;if((ma-ra|0)>0){sa=0;ta=ra;ra=ma;do{if(((ra-ta|0)/12|0)>>>0<=sa>>>0){na=77;break b}X5b(p,ta+(sa*12|0)|0);X5b(q,l);ma=f[F>>2]|0;ua=(f[z>>2]|0)-ma|0;va=ma;c:do if((ua|0)>0){ma=(ua>>>0)/20|0;wa=b[Y>>0]|0;xa=wa<<24>>24<0;ya=xa?f[Z>>2]|0:wa&255;wa=xa?f[p>>2]|0:p;d:do if(ya){xa=ma;e:while(1){za=xa+-1|0;Aa=va+(za*20|0)|0;Ba=b[Aa+11>>0]|0;Ca=Ba<<24>>24<0;Da=Ba&255;do if(((Ca?f[va+(za*20|0)+4>>2]|0:Da)|0)==(ya|0)){Ba=f[Aa>>2]|0;if(Ca)if(!(ZVb(Ba,wa,ya)|0)){Ea=za;break d}else break;if((Ba&255)<<24>>24!=(b[wa>>0]|0))break;Ba=Aa;Fa=Da;Ga=wa;do{Fa=Fa+-1|0;Ba=Ba+1|0;if(!Fa)break e;Ga=Ga+1|0}while((b[Ba>>0]|0)==(b[Ga>>0]|0))}while(0);if((xa|0)>1)xa=za;else{na=91;break c}}if((xa|0)<1){na=91;break c}else Ea=za}else{Da=ma;while(1){Aa=Da;Da=Da+-1|0;Ca=b[va+(Da*20|0)+11>>0]|0;if(!((Ca<<24>>24<0?f[va+(Da*20|0)+4>>2]|0:Ca&255)|0)){Ea=Da;break d}if((Aa|0)<=1){na=91;break c}}}while(0);tva(s,f[va+(Ea*20|0)+12>>2]|0,f[va+(Ea*20|0)+16>>2]|0,oa,sa)}else na=91;while(0);if((na|0)==91){na=0;dua(j,376755,p);eua(i,j,476054);f[h>>2]=0;f[$>>2]=0;va=b[aa>>0]|0;ua=va<<24>>24<0?f[ba>>2]|0:va&255;if(ua|0){va=aD(h,ua)|0;Vac(va|0,((b[aa>>0]|0)<0?f[i>>2]|0:i)|0,ua|0)|0}bO(-204,h,376780,364167,170);bD(h);if((b[aa>>0]|0)<0)O5b(f[i>>2]|0);if((b[ca>>0]|0)<0)O5b(f[j>>2]|0)}if((b[_>>0]|0)<0)O5b(f[q>>2]|0);if((b[Y>>0]|0)<0)O5b(f[p>>2]|0);sa=sa+1|0;ra=f[X>>2]|0;ta=f[W>>2]|0}while((sa|0)<((ra-ta|0)/12|0|0))}X5b(h,l);ta=f[F>>2]|0;ra=(f[z>>2]|0)-ta|0;sa=ta;f:do if((ra|0)>0){ta=(ra>>>0)/20|0;ua=b[da>>0]|0;va=ua<<24>>24<0;ma=va?f[ea>>2]|0:ua&255;ua=va?f[h>>2]|0:h;g:do if(!ma){va=ta;while(1){wa=va;va=va+-1|0;ya=b[sa+(va*20|0)+11>>0]|0;if(!((ya<<24>>24<0?f[sa+(va*20|0)+4>>2]|0:ya&255)|0))break g;if((wa|0)<=1)break f}}else{va=ta;while(1){wa=va;va=va+-1|0;ya=sa+(va*20|0)|0;Da=b[ya+11>>0]|0;xa=Da<<24>>24<0;Aa=Da&255;do if(((xa?f[sa+(va*20|0)+4>>2]|0:Aa)|0)==(ma|0)){Da=f[ya>>2]|0;if(xa)if(!(ZVb(Da,ua,ma)|0))break g;else break;if((Da&255)<<24>>24!=(b[ua>>0]|0))break;Da=ya;Ca=Aa;Ga=ua;do{Ca=Ca+-1|0;Da=Da+1|0;if(!Ca)break g;Ga=Ga+1|0}while((b[Da>>0]|0)==(b[Ga>>0]|0))}while(0);if((wa|0)<=1)break f}}while(0);ua=f[W>>2]|0;h:do if(((f[X>>2]|0)-ua|0)>0){X5b(i,ua);ma=b[fa>>0]|0;ta=ma<<24>>24<0;va=ma&255;ma=ta?f[ga>>2]|0:va;Aa=b[da>>0]|0;ya=Aa<<24>>24<0;i:do if((ma|0)==((ya?f[ea>>2]|0:Aa&255)|0)){xa=f[i>>2]|0;Ga=ta?xa:i;Da=ya?f[h>>2]|0:h;Ca=(ma|0)==0;if(ta)if(!Ca){Ba=(ZVb(Ga,Da,ma)|0)==0;O5b(xa);if(Ba)break f;else break h}else{O5b(xa);break f}if(Ca)break f;if((xa&255)<<24>>24==(b[Da>>0]|0)){Ha=i;Ia=va;Ja=Da}else break h;while(1){Ia=Ia+-1|0;Ha=Ha+1|0;if(!Ia){Ka=1;break i}Ja=Ja+1|0;if((b[Ha>>0]|0)!=(b[Ja>>0]|0)){Ka=0;break}}}else Ka=0;while(0);if(ta){O5b(f[i>>2]|0);if(Ka)break f;else break}else if(Ka)break f;else break}while(0);f[i>>2]=0;f[ha>>2]=0;w=aD(i,44)|0;ua=376789;x=w+44|0;do{b[w>>0]=b[ua>>0]|0;w=w+1|0;ua=ua+1|0}while((w|0)<(x|0));bO(-5,i,376834,364167,153);bD(i)}while(0);X5b(i,h);f[ia>>2]=oa;f[ja>>2]=0;sa=f[z>>2]|0;ra=f[E>>2]|0;ua=ra;do if((sa|0)==(ra|0)){va=f[F>>2]|0;ma=(sa-va|0)/20|0;ya=ma+1|0;if(ya>>>0>214748364){na=136;break b}Aa=(ua-va|0)/20|0;va=Aa<<1;wa=Aa>>>0<107374182?(va>>>0<ya>>>0?ya:va):214748364;if(!wa)La=0;else{if(wa>>>0>214748364){na=139;break b}La=L5b(wa*20|0)|0}va=La+(ma*20|0)|0;ya=va;Aa=La+(wa*20|0)|0;X5b(va,i);wa=ia;Da=f[wa+4>>2]|0;xa=La+(ma*20|0)+12|0;f[xa>>2]=f[wa>>2];f[xa+4>>2]=Da;Da=va+20|0;xa=f[y>>2]|0;wa=f[z>>2]|0;if((wa|0)==(xa|0)){Ma=ya;Na=xa;Oa=xa}else{ma=wa;wa=ya;ya=va;do{va=ma;ma=ma+-20|0;X5b(ya+-20|0,ma);Ca=va+-8|0;va=f[Ca+4>>2]|0;Ba=ya+-8|0;f[Ba>>2]=f[Ca>>2];f[Ba+4>>2]=va;ya=wa+-20|0;wa=ya}while((ma|0)!=(xa|0));Ma=wa;Na=f[F>>2]|0;Oa=f[z>>2]|0}f[F>>2]=Ma;f[z>>2]=Da;f[E>>2]=Aa;xa=Na;if((Oa|0)!=(xa|0)){ma=Oa;do{ma=ma+-20|0;if((b[ma+11>>0]|0)<0)O5b(f[ma>>2]|0)}while((ma|0)!=(xa|0))}if(!Na)break;O5b(Na)}else{X5b(sa,i);xa=ia;ma=f[xa+4>>2]|0;Aa=sa+12|0;f[Aa>>2]=f[xa>>2];f[Aa+4>>2]=ma;f[z>>2]=(f[z>>2]|0)+20}while(0);if((b[ka>>0]|0)<0)O5b(f[i>>2]|0);if((b[da>>0]|0)<0)O5b(f[h>>2]|0);fua(o);bD(n);bD(m);Zta(l);la=la+1|0;if((la|0)>=(t|0))break a}if((na|0)==60)d4b(k);else if((na|0)==77)d4b(W);else if((na|0)==136)c4b(y);else if((na|0)==139){la=ze(8)|0;T5b(la,477177);f[la>>2]=149528;If(la|0,25408,1411)}}while(0);na=f[y>>2]|0;y=f[z>>2]|0;if((y|0)!=(na|0)){k=y;while(1){y=k+-20|0;f[z>>2]=y;if((b[y+11>>0]|0)<0){O5b(f[y>>2]|0);Pa=f[z>>2]|0}else Pa=y;if((Pa|0)==(na|0))break;else k=Pa}}kva(s);Wta(r+72|0,f[C>>2]|0);C=r+60|0;s=f[C>>2]|0;if(s|0){Pa=f[z>>2]|0;if((Pa|0)==(s|0))Qa=s;else{k=Pa;while(1){Pa=k+-20|0;f[z>>2]=Pa;if((b[Pa+11>>0]|0)<0){O5b(f[Pa>>2]|0);Ra=f[z>>2]|0}else Ra=Pa;if((Ra|0)==(s|0))break;else k=Ra}Qa=f[C>>2]|0}O5b(Qa)}Xta(r+48|0,f[v>>2]|0);Yta(r+36|0,f[c>>2]|0);c=f[r+24>>2]|0;if(c|0){v=r+28|0;Qa=f[v>>2]|0;if((Qa|0)!=(c|0))f[v>>2]=Qa+(~((Qa+-4-c|0)>>>2)<<2);O5b(c)}c=r+12|0;r=f[c>>2]|0;if(!r){u=e;return}while(1){Qa=f[a>>2]|0;if((Qa|0)==(r|0))break;v=Qa+-76|0;f[a>>2]=v;Zta(v)}O5b(f[c>>2]|0);u=e;return}function Wta(a,b){a=a|0;b=b|0;if(!b)return;Wta(a,f[b>>2]|0);Wta(a,f[b+4>>2]|0);bD(b+16|0);O5b(b);return}function Xta(a,c){a=a|0;c=c|0;var d=0;if(!c)return;Xta(a,f[c>>2]|0);Xta(a,f[c+4>>2]|0);a=c+16|0;d=c+28|0;if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(c);return}function Yta(a,b){a=a|0;b=b|0;if(!b)return;else{Yta(a,f[b>>2]|0);Yta(a,f[b+4>>2]|0);Xta(b+20|0,f[b+24>>2]|0);O5b(b);return}}function Zta(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;fua(a+36|0);c=a+24|0;d=f[c>>2]|0;if(d|0){e=a+28|0;g=f[e>>2]|0;if((g|0)==(d|0))h=d;else{i=g;while(1){g=i+-12|0;f[e>>2]=g;if((b[g+11>>0]|0)<0){O5b(f[g>>2]|0);j=f[e>>2]|0}else j=g;if((j|0)==(d|0))break;else i=j}h=f[c>>2]|0}O5b(h)}h=a+12|0;if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[a+11>>0]|0)>=0)return;O5b(f[a>>2]|0);return}function _ta(a,b){a=a|0;b=b|0;var c=0,d=0;X5b(a,b);X5b(a+12|0,b+12|0);kua(a+24|0,b+24|0);$ta(a+36|0,b+36|0);aua(a+48|0,b+48|0);c=f[b+60>>2]|0;f[a+60>>2]=c;f[a+64>>2]=f[b+64>>2];if(c|0){d=c+-4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[b+68>>2]|0;f[a+68>>2]=d;f[a+72>>2]=f[b+72>>2];if(!d)return;b=d+-4|0;f[b>>2]=(f[b>>2]|0)+1;return}function $ta(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;i=a+4|0;f[i>>2]=0;j=a+8|0;f[j>>2]=0;k=a+4|0;f[a>>2]=k;l=f[b>>2]|0;m=b+4|0;if((l|0)==(m|0)){u=c;return}b=k;k=l;while(1){l=k+16|0;f[h>>2]=b;f[d>>2]=f[h>>2];n=hua(a,d,e,g,l)|0;if(!(f[n>>2]|0)){o=L5b(32)|0;p=f[l>>2]|0;f[o+16>>2]=p;f[o+20>>2]=f[k+20>>2];if(p|0){l=p+-4|0;f[l>>2]=(f[l>>2]|0)+1}iua(o+24|0,k+24|0);l=f[e>>2]|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=l;f[n>>2]=o;l=f[f[a>>2]>>2]|0;if(!l)q=o;else{f[a>>2]=l;q=f[n>>2]|0}mP(f[i>>2]|0,q);f[j>>2]=(f[j>>2]|0)+1}n=f[k+4>>2]|0;if(!n){l=k+8|0;o=f[l>>2]|0;if((f[o>>2]|0)==(k|0))r=o;else{o=l;do{l=f[o>>2]|0;o=l+8|0;p=f[o>>2]|0}while((f[p>>2]|0)!=(l|0));r=p}}else{o=n;while(1){p=f[o>>2]|0;if(!p)break;else o=p}r=o}if((r|0)==(m|0))break;else k=r}u=c;return}function aua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/56|0;if(!e)return;if(g>>>0>76695844)c4b(a);h=L5b(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*56|0);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{f[g>>2]=f[d>>2];h=g+4|0;a=d+4|0;f[h>>2]=f[a>>2];e=g+8|0;f[e>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];f[g+16>>2]=f[d+16>>2];f[g+20>>2]=f[d+20>>2];f[g+24>>2]=f[d+24>>2];f[g+28>>2]=f[d+28>>2];f[g+32>>2]=f[d+32>>2];i=f[d+36>>2]|0;f[g+36>>2]=i;f[g+40>>2]=e;e=g+48|0;j=g+44|0;f[j>>2]=e;f[e>>2]=0;f[g+52>>2]=0;if(i|0){e=i+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[a>>2]|0)<3){a=f[d+44>>2]|0;e=f[j>>2]|0;f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2]}else{f[h>>2]=0;jL(g,d)}d=d+56|0;g=(f[c>>2]|0)+56|0;f[c>>2]=g}while((d|0)!=(b|0));return}function bua(a,b){a=a|0;b=b|0;if(!b)return;bua(a,f[b>>2]|0);bua(a,f[b+4>>2]|0);gua(b+24|0);bD(b+16|0);O5b(b);return}function cua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=a+4|0;d=f[c>>2]|0;a:do if(!d){e=c;g=c;h=d;i=12}else{j=a+4|0;k=f[b>>2]|0;l=(k|0)==0?1124530:k;m=f[d+16>>2]|0;b:do if((k|0)!=(m|0)){n=j;o=d;p=m;q=d;while(1){r=(p|0)==0?1124530:p;if((gTb(l,r)|0)<0){s=f[o>>2]|0;if(!s){i=6;break}else{t=o;u=s}}else{if((gTb(r,l)|0)>=0){v=n;w=o;x=q;break b}y=o+4|0;r=f[y>>2]|0;if(!r){i=9;break}else{t=y;u=r}}p=f[u+16>>2]|0;if((k|0)==(p|0)){v=t;w=u;x=u;break b}else{n=t;o=u;q=u}}if((i|0)==6){z=o;A=o;break a}else if((i|0)==9){z=y;A=o;break a}}else{v=j;w=d;x=d}while(0);e=v;g=w;h=x;i=12}while(0);if((i|0)==12)if(!h){z=e;A=g}else{B=h;C=B+24|0;return C|0}h=L5b(28)|0;g=f[b>>2]|0;f[h+16>>2]=g;f[h+20>>2]=f[b+4>>2];if(g|0){b=g+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[h+24>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=A;f[z>>2]=h;A=f[f[a>>2]>>2]|0;if(!A)D=h;else{f[a>>2]=A;D=f[z>>2]|0}mP(f[a+4>>2]|0,D);D=a+8|0;f[D>>2]=(f[D>>2]|0)+1;B=h;C=B+24|0;return C|0}function dua(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=kUb(c)|0;g=b[d+11>>0]|0;h=g<<24>>24<0;i=h?f[d+4>>2]|0:g&255;g=i+e|0;if(g>>>0>4294967279)V5b(a);if(g>>>0<11){b[a+11>>0]=e;j=a}else{k=g+16&-16;g=L5b(k)|0;f[a>>2]=g;f[a+8>>2]=k|-2147483648;f[a+4>>2]=e;j=g}if(e|0)Vac(j|0,c|0,e|0)|0;b[j+e>>0]=0;j6b(a,h?f[d>>2]|0:d,i)|0;return}function eua(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=kUb(d)|0;i=g?f[c>>2]|0:c;c=h+e|0;if(c>>>0>4294967279)V5b(a);if(c>>>0<11){b[a+11>>0]=h;j=a}else{g=c+16&-16;c=L5b(g)|0;f[a>>2]=c;f[a+8>>2]=g|-2147483648;f[a+4>>2]=h;j=c}if(!h){k=j+h|0;b[k>>0]=0;j6b(a,d,e)|0;return}Vac(j|0,i|0,h|0)|0;k=j+h|0;b[k>>0]=0;j6b(a,d,e)|0;return}function fua(a){a=a|0;bD(a+32|0);bD(a+24|0);et(a+12|0);bua(a,f[a+4>>2]|0);return}function gua(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;switch(f[a>>2]|0){case 0:{b=f[a+4>>2]|0;if(!b)return;c=f[b>>2]|0;if(!((c|0)==(b+8|0)|(c|0)==0))P5b(c);O5b(b);return}case 3:{b=f[a+4>>2]|0;if(!b)return;c=f[b>>2]|0;d=b+8|0;if((c|0)!=(d|0)){if(c|0){e=c+-4|0;g=f[e>>2]|0;if(g|0){h=c+(g<<3)|0;do{h=h+-8|0;bD(h)}while((h|0)!=(c|0))}P5b(e)}f[b>>2]=d;f[b+4>>2]=1}bD(d);O5b(b);return}case 2:{b=f[a+4>>2]|0;if(!b)return;a=f[b>>2]|0;if(!((a|0)==(b+8|0)|(a|0)==0))P5b(a);O5b(b);return}default:return}}function hua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=a+4|0;h=f[b>>2]|0;b=h;do if((h|0)!=(g|0)){i=f[e>>2]|0;j=f[h+16>>2]|0;if((i|0)!=(j|0)){if((gTb((i|0)==0?1124530:i,(j|0)==0?1124530:j)|0)<0)break;k=(i|0)==0?1124530:i;if((gTb((j|0)==0?1124530:j,k)|0)<0){j=h+4|0;l=f[j>>2]|0;if(!l){m=h+8|0;n=f[m>>2]|0;if((f[n>>2]|0)==(h|0))o=n;else{n=m;do{m=f[n>>2]|0;n=m+8|0;p=f[n>>2]|0}while((f[p>>2]|0)!=(m|0));o=p}}else{n=l;while(1){p=f[n>>2]|0;if(!p)break;else n=p}o=n}do if((o|0)!=(g|0)){l=f[o+16>>2]|0;if((i|0)!=(l|0)?(gTb(k,(l|0)==0?1124530:l)|0)<0:0)break;l=f[g>>2]|0;if(!l){f[c>>2]=g;q=g;return q|0}p=a+4|0;m=f[l+16>>2]|0;a:do if((i|0)!=(m|0)){r=p;s=l;t=m;while(1){u=(t|0)==0?1124530:t;if((gTb(k,u)|0)<0){v=f[s>>2]|0;if(!v){w=41;break}else{x=s;y=v}}else{if((gTb(u,k)|0)>=0){z=r;A=s;break a}B=s+4|0;u=f[B>>2]|0;if(!u){w=44;break}else{x=B;y=u}}t=f[y+16>>2]|0;if((i|0)==(t|0)){z=x;A=y;break a}else{r=x;s=y}}if((w|0)==41){f[c>>2]=s;q=s;return q|0}else if((w|0)==44){f[c>>2]=s;q=B;return q|0}}else{z=p;A=l}while(0);f[c>>2]=A;q=z;return q|0}while(0);if(!(f[h+4>>2]|0)){f[c>>2]=b;q=j;return q|0}else{f[c>>2]=o;q=o;return q|0}}}f[c>>2]=b;f[d>>2]=b;q=d;return q|0}while(0);d=f[h>>2]|0;do if((h|0)==(f[a>>2]|0))C=b;else{if(!d){o=h;while(1){z=f[o+8>>2]|0;if((f[z>>2]|0)==(o|0))o=z;else{D=z;break}}}else{o=d;while(1){j=f[o+4>>2]|0;if(!j){D=o;break}else o=j}}o=f[D+16>>2]|0;j=f[e>>2]|0;if((o|0)!=(j|0)?(gTb((o|0)==0?1124530:o,(j|0)==0?1124530:j)|0)<0:0){C=D;break}o=f[g>>2]|0;if(!o){f[c>>2]=g;q=g;return q|0}z=a+4|0;A=(j|0)==0?1124530:j;B=f[o+16>>2]|0;b:do if((j|0)!=(B|0)){y=z;x=o;i=B;while(1){k=(i|0)==0?1124530:i;if((gTb(A,k)|0)<0){n=f[x>>2]|0;if(!n){w=18;break}else{E=x;F=n}}else{if((gTb(k,A)|0)>=0){G=y;H=x;break b}I=x+4|0;k=f[I>>2]|0;if(!k){w=21;break}else{E=I;F=k}}i=f[F+16>>2]|0;if((j|0)==(i|0)){G=E;H=F;break b}else{y=E;x=F}}if((w|0)==18){f[c>>2]=x;q=x;return q|0}else if((w|0)==21){f[c>>2]=x;q=I;return q|0}}else{G=z;H=o}while(0);f[c>>2]=H;q=G;return q|0}while(0);if(!d){f[c>>2]=h;q=h;return q|0}else{h=C;f[c>>2]=h;q=h+4|0;return q|0}return 0}function iua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f[a>>2]=f[b>>2];switch(f[b>>2]|0){case 0:{c=L5b(16)|0;d=f[b+4>>2]|0;e=c+8|0;f[c>>2]=e;g=c+4|0;f[g>>2]=1;h=f[d+4>>2]|0;f[g>>2]=h;if(h>>>0<=1){if(h|0){i=e;j=5}}else{e=N5b(h>>>0>536870911?-1:h<<3)|0;f[c>>2]=e;i=e;j=5}if((j|0)==5){e=f[d>>2]|0;d=0;do{g=e+(d<<3)|0;k=f[g+4>>2]|0;l=i+(d<<3)|0;f[l>>2]=f[g>>2];f[l+4>>2]=k;d=d+1|0}while(d>>>0<h>>>0)}f[a+4>>2]=c;return}case 3:{c=L5b(16)|0;jua(c,f[b+4>>2]|0);f[a+4>>2]=c;return}case 2:{c=L5b(16)|0;h=f[b+4>>2]|0;b=c+8|0;f[c>>2]=b;d=c+4|0;f[d>>2]=1;i=f[h+4>>2]|0;f[d>>2]=i;if(i>>>0<=1){if(i|0){m=b;j=12}}else{b=N5b(i>>>0>536870911?-1:i<<3)|0;f[c>>2]=b;m=b;j=12}if((j|0)==12){j=f[h>>2]|0;h=0;do{p[m+(h<<3)>>3]=+p[j+(h<<3)>>3];h=h+1|0}while(h>>>0<i>>>0)}f[a+4>>2]=c;return}default:return}}function jua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;f[c>>2]=0;f[a+12>>2]=0;f[a>>2]=c;d=a+4|0;f[d>>2]=1;e=f[b+4>>2]|0;f[d>>2]=e;if(e>>>0<=1)if(!e)return;else g=c;else{c=e<<3;h=N5b(e>>>0>536870911|c>>>0>4294967291?-1:c+4|0)|0;f[h>>2]=e;c=h+4|0;Nac(c|0,0,e<<3|0)|0;f[a>>2]=c;g=c}c=0;h=g;g=e;while(1){e=f[b>>2]|0;i=e+(c<<3)|0;j=h+(c<<3)|0;if((e|0)==(h|0))k=g;else{bD(j);l=f[i>>2]|0;if(!l)m=0;else{n=l+-4|0;f[n>>2]=(f[n>>2]|0)+1;m=f[i>>2]|0}f[j>>2]=m;f[h+(c<<3)+4>>2]=f[e+(c<<3)+4>>2];k=f[d>>2]|0}e=c+1|0;if(e>>>0>=k>>>0)break;c=e;h=f[a>>2]|0;g=k}return}function kua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/12|0;if(!e)return;if(g>>>0>357913941)c4b(a);h=L5b(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*12|0);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{X5b(g,d);d=d+12|0;g=(f[c>>2]|0)+12|0;f[c>>2]=g}while((d|0)!=(b|0));return}function lua(a){a=a|0;f[a>>2]=105216;bD(a+24|0);bD(a+16|0);et(a+4|0);xY(a);return}function mua(a){a=a|0;lua(a);O5b(a);return}function nua(a,b,c){a=a|0;b=b|0;c=c|0;return}function oua(a,b){a=a|0;b=b|0;return -1}function pua(a,b){a=a|0;b=b|0;return -1}function qua(a,b){a=a|0;b=b|0;return (b|0)==0|0}function rua(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+8|0;g=d;f[g>>2]=0;h=g+4|0;f[h>>2]=0;i=c+28|0;aD(g,(f[i>>2]|0)+19|0)|0;j=f[g>>2]|0;k=j;l=364552;m=k+19|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));n=f[i>>2]|0;if(n|0)Vac(j+19|0,f[c+24>>2]|0,n|0)|0;f[e>>2]=0;f[e+4>>2]=0;aD(e,(f[h>>2]|0)+23|0)|0;n=f[h>>2]|0;if(!n)o=0;else{Vac(f[e>>2]|0,f[g>>2]|0,n|0)|0;o=f[h>>2]|0}k=(f[e>>2]|0)+o|0;l=364572;m=k+23|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-213,e,364596,364488,2330);bD(e);bD(g);f[a>>2]=0;f[a+4>>2]=0;u=d;return}function sua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function tua(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function uua(a,b){a=a|0;b=b|0;return 0}function vua(a,b){a=a|0;b=b|0;return 0}function wua(a,b){a=a|0;b=b|0;return 0}function xua(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;d=f[(f[a>>2]|0)+68>>2]|0;f[c>>2]=0;f[c+4>>2]=0;Uh[d&1023](a,c)|0;d=f[c>>2]|0;if(d|0?(e=d+4|0,g=f[e>>2]|0,f[e>>2]=g+-1,(g|0)==1):0)bi[f[(f[d>>2]|0)+8>>2]&2047](d);d=f[(f[a>>2]|0)+72>>2]|0;f[c>>2]=0;f[c+4>>2]=0;Uh[d&1023](a,c)|0;d=f[c>>2]|0;if(d|0?(g=d+4|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)bi[f[(f[d>>2]|0)+8>>2]&2047](d);d=f[(f[a>>2]|0)+76>>2]|0;f[c>>2]=0;f[c+4>>2]=0;Uh[d&1023](a,c)|0;a=f[c>>2]|0;if(!a){u=b;return}c=a+4|0;d=f[c>>2]|0;f[c>>2]=d+-1;if((d|0)!=1){u=b;return}bi[f[(f[a>>2]|0)+8>>2]&2047](a);u=b;return}function yua(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;a=g;h=c+4|0;i=f[h>>2]|0;j=f[c>>2]|0;if((i|0)==(j|0)){f[a>>2]=0;f[a+4>>2]=0;k=aD(a,13)|0;l=427656;m=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,a,442770,364488,2490);bD(a);n=f[c>>2]|0;o=f[h>>2]|0}else{n=j;o=i}i=(o-n|0)/12|0;Aua(e,(i|0)>(d|0)?i:d,n);u=g;return 0}function zua(a,b,c){a=a|0;b=b|0;c=c|0;J=0;return 0}function Aua(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;if(((e-g|0)/12|0)>>>0<b>>>0){if(!g)i=e;else{e=a+4|0;j=f[e>>2]|0;if((j|0)==(h|0))k=g;else{l=j;while(1){j=l+-12|0;f[e>>2]=j;m=f[j>>2]|0;if(!m)n=j;else{j=l+-8|0;o=f[j>>2]|0;if((o|0)!=(m|0))f[j>>2]=o+(~((o+-4-m|0)>>>2)<<2);O5b(m);n=f[e>>2]|0}if((n|0)==(h|0))break;else l=n}k=f[a>>2]|0}O5b(k);f[d>>2]=0;f[e>>2]=0;f[a>>2]=0;i=0}if(b>>>0>357913941)c4b(a);e=(i|0)/12|0;i=e<<1;k=e>>>0<178956970?(i>>>0<b>>>0?b:i):357913941;if(k>>>0>357913941)c4b(a);i=L5b(k*12|0)|0;e=a+4|0;f[e>>2]=i;f[a>>2]=i;f[d>>2]=i+(k*12|0);k=b;d=i;do{Bua(d,c);d=(f[e>>2]|0)+12|0;f[e>>2]=d;k=k+-1|0}while((k|0)!=0);return}k=a+4|0;d=((f[k>>2]|0)-g|0)/12|0;g=d>>>0<b>>>0;e=g?d:b;if(e|0){i=c+4|0;n=e;e=h;while(1){if((e|0)!=(c|0))r2(e,f[c>>2]|0,f[i>>2]|0);n=n+-1|0;if(!n)break;else e=e+12|0}}if(g){g=b-d|0;d=f[k>>2]|0;do{Bua(d,c);d=(f[k>>2]|0)+12|0;f[k>>2]=d;g=g+-1|0}while((g|0)!=0);return}g=(f[a>>2]|0)+(b*12|0)|0;b=f[k>>2]|0;if((b|0)==(g|0))return;else p=b;while(1){b=p+-12|0;f[k>>2]=b;a=f[b>>2]|0;if(!a)q=b;else{b=p+-8|0;d=f[b>>2]|0;if((d|0)!=(a|0))f[b>>2]=d+(~((d+-4-a|0)>>>2)<<2);O5b(a);q=f[k>>2]|0}if((q|0)==(g|0))break;else p=q}return}function Bua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>2;if(!g)return;if(g>>>0>1073741823)c4b(a);h=L5b(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<2);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;Vac(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>2<<2);return}function Cua(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=u;u=u+96|0;j=i+80|0;k=i+64|0;l=i+8|0;m=i;dQ(j,105308);do if((yM(b)|0)==65536){n=f[b+4>>2]|0;f[l>>2]=f[n>>2];o=l+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=l+8|0;f[q>>2]=f[n+8>>2];f[l+12>>2]=f[n+12>>2];f[l+16>>2]=f[n+16>>2];f[l+20>>2]=f[n+20>>2];f[l+24>>2]=f[n+24>>2];f[l+28>>2]=f[n+28>>2];f[l+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[l+36>>2]=r;f[l+40>>2]=q;q=l+48|0;s=l+44|0;f[s>>2]=q;f[q>>2]=0;f[l+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;jL(l,n);break}}else yL(l,b,-1);while(0);Dua(k,1,l);b=l+36|0;n=f[b>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)kL(l);f[b>>2]=0;b=l+16|0;n=l+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[n>>2]|0)>0){b=f[l+40>>2]|0;o=0;do{f[b+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)!=(l+48|0))UC(n);f[m>>2]=f[d>>2];f[m+4>>2]=f[d+4>>2];Eua(a,k,c,m,e,g,h);et(k);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function Dua(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>76695844)c4b(a);e=L5b(b*56|0)|0;f[d>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(b*56|0);a=c+4|0;g=c+8|0;h=c+12|0;i=c+16|0;j=c+20|0;k=c+24|0;l=c+28|0;m=c+32|0;n=c+36|0;o=c+44|0;p=b;b=e;do{f[b>>2]=f[c>>2];e=b+4|0;f[e>>2]=f[a>>2];q=b+8|0;f[q>>2]=f[g>>2];f[b+12>>2]=f[h>>2];f[b+16>>2]=f[i>>2];f[b+20>>2]=f[j>>2];f[b+24>>2]=f[k>>2];f[b+28>>2]=f[l>>2];f[b+32>>2]=f[m>>2];r=f[n>>2]|0;f[b+36>>2]=r;f[b+40>>2]=q;q=b+48|0;s=b+44|0;f[s>>2]=q;f[q>>2]=0;f[b+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[a>>2]|0)<3){q=f[o>>2]|0;r=f[s>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2]}else{f[e>>2]=0;jL(b,c)}b=(f[d>>2]|0)+56|0;f[d>>2]=b;p=p+-1|0}while((p|0)!=0);return}function Eua(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0;j=u;u=u+624|0;k=j+560|0;l=j+504|0;m=j+440|0;n=j+424|0;o=j+408|0;q=j+496|0;r=j+432|0;s=j;t=j+392|0;v=j+168|0;w=j+112|0;x=j+56|0;dQ(n,105328);aua(o,c);c=o+4|0;y=f[o>>2]|0;if((f[c>>2]|0)!=(y|0)){z=e+4|0;A=k+8|0;B=k+12|0;C=k+4|0;D=l+8|0;E=l+4|0;F=q+4|0;G=k+4|0;H=k+8|0;I=k+12|0;J=l+36|0;K=l+16|0;L=l+4|0;M=l+40|0;N=l+44|0;O=l+48|0;P=l+8|0;Q=l+12|0;R=l+20|0;S=l+24|0;T=l+28|0;U=l+32|0;V=k+8|0;W=k+12|0;X=k+4|0;Z=l+8|0;_=l+4|0;$=r+4|0;aa=k+8|0;ba=k+4|0;ca=g+8|0;da=s+8|0;ea=g+16|0;fa=s+16|0;ga=g+24|0;ha=s+24|0;ia=k+8|0;ja=k+12|0;ka=k+4|0;la=l+8|0;ma=l+12|0;na=l+4|0;oa=m+8|0;pa=m+4|0;qa=k+8|0;ra=k+4|0;sa=0;ta=y;do{y=f[ta+(sa*56|0)+40>>2]|0;ua=f[y+4>>2]|0;va=f[y>>2]|0;y=f[e>>2]|0;wa=f[z>>2]|0;if(!(wa|y)){f[e>>2]=ua;f[z>>2]=va;xa=ua;ya=va}else{xa=y;ya=wa}do if((xa|0)!=(ua|0)|(ya|0)!=(va|0)){if(!i){f[V>>2]=0;f[W>>2]=0;f[k>>2]=16842752;f[X>>2]=ta+(sa*56|0);wa=Z;f[wa>>2]=0;f[wa+4>>2]=0;f[l>>2]=33619968;f[_>>2]=ta+(sa*56|0);f[r>>2]=xa;f[$>>2]=ya;Lia(k,l,r,0.0,0.0,1);break}za=+(xa|0)/+(ua|0);Aa=+(ya|0)/+(va|0);f[A>>2]=0;f[B>>2]=0;f[k>>2]=16842752;f[C>>2]=ta+(sa*56|0);wa=D;f[wa>>2]=0;f[wa+4>>2]=0;f[l>>2]=33619968;f[E>>2]=ta+(sa*56|0);f[q>>2]=0;f[F>>2]=0;Ba=za<Aa?Aa:za;Lia(k,l,q,Ba,Ba,1);wa=f[o>>2]|0;y=f[e>>2]|0;Ca=f[z>>2]|0;Da=~~(+((f[wa+(sa*56|0)+8>>2]|0)-Ca|0)*.5);f[k>>2]=~~(+((f[wa+(sa*56|0)+12>>2]|0)-y|0)*.5);f[G>>2]=Da;f[H>>2]=y;f[I>>2]=Ca;nL(l,wa+(sa*56|0)|0,k);wa=f[o>>2]|0;Ca=wa+(sa*56|0)|0;if((Ca|0)!=(l|0)){y=f[J>>2]|0;if(y|0){Da=y+12|0;f[Da>>2]=(f[Da>>2]|0)+1}Da=wa+(sa*56|0)+36|0;y=f[Da>>2]|0;if(y|0?(Ea=y+12|0,y=f[Ea>>2]|0,f[Ea>>2]=y+-1,(y|0)==1):0)kL(Ca);f[Da>>2]=0;y=wa+(sa*56|0)+16|0;Ea=wa+(sa*56|0)+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[Ea>>2]|0)>0){Fa=f[wa+(sa*56|0)+40>>2]|0;Ga=0;do{f[Fa+(Ga<<2)>>2]=0;Ga=Ga+1|0;Ha=f[Ea>>2]|0}while((Ga|0)<(Ha|0));f[Ca>>2]=f[l>>2];if((Ha|0)<3)Ia=19;else Ia=21}else{f[Ca>>2]=f[l>>2];Ia=19}if((Ia|0)==19){Ia=0;Ga=f[L>>2]|0;if((Ga|0)<3){f[Ea>>2]=Ga;f[wa+(sa*56|0)+8>>2]=f[P>>2];f[wa+(sa*56|0)+12>>2]=f[Q>>2];Ga=f[N>>2]|0;Fa=f[wa+(sa*56|0)+44>>2]|0;f[Fa>>2]=f[Ga>>2];f[Fa+4>>2]=f[Ga+4>>2]}else Ia=21}if((Ia|0)==21){Ia=0;jL(Ca,l)}f[y>>2]=f[K>>2];f[wa+(sa*56|0)+20>>2]=f[R>>2];f[wa+(sa*56|0)+24>>2]=f[S>>2];f[wa+(sa*56|0)+28>>2]=f[T>>2];f[wa+(sa*56|0)+32>>2]=f[U>>2];f[Da>>2]=f[J>>2]}Ga=f[J>>2]|0;if(Ga|0?(Fa=Ga+12|0,Ga=f[Fa>>2]|0,f[Fa>>2]=Ga+-1,(Ga|0)==1):0)kL(l);f[J>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[L>>2]|0)>0){Ga=f[M>>2]|0;Fa=0;do{f[Ga+(Fa<<2)>>2]=0;Fa=Fa+1|0}while((Fa|0)<(f[L>>2]|0))}Fa=f[N>>2]|0;if((Fa|0)!=(O|0))UC(Fa)}while(0);va=(f[o>>2]|0)+(sa*56|0)|0;if(!(f[va>>2]&7)){ua=aa;f[ua>>2]=0;f[ua+4>>2]=0;f[k>>2]=33619968;f[ba>>2]=va;OJ(va,k,5,1.0,0.0)}Ba=+p[g>>3];p[s>>3]=Ba;p[da>>3]=+p[ca>>3];za=+p[ea>>3];p[fa>>3]=za;p[ha>>3]=+p[ga>>3];if(h){p[s>>3]=za;p[fa>>3]=Ba}va=(f[o>>2]|0)+(sa*56|0)|0;f[ia>>2]=0;f[ja>>2]=0;f[k>>2]=16842752;f[ka>>2]=va;f[l>>2]=-1056833530;f[na>>2]=s;f[la>>2]=1;f[ma>>2]=4;ua=oa;f[ua>>2]=0;f[ua+4>>2]=0;f[m>>2]=33619968;f[pa>>2]=va;jE(k,l,m,UM()|0,-1);va=(f[o>>2]|0)+(sa*56|0)|0;ua=qa;f[ua>>2]=0;f[ua+4>>2]=0;f[k>>2]=33619968;f[ra>>2]=va;OJ(va,k,-1,d,0.0);sa=sa+1|0;va=f[o>>2]|0;Ja=(f[c>>2]|0)-va|0;Ka=(Ja|0)/56|0;ta=va}while(sa>>>0<Ka>>>0);if(Ja){f[l>>2]=f[ta>>2];sa=l+4|0;c=ta+4|0;f[sa>>2]=f[c>>2];ra=l+8|0;f[ra>>2]=f[ta+8>>2];qa=l+12|0;f[qa>>2]=f[ta+12>>2];pa=l+16|0;f[pa>>2]=f[ta+16>>2];f[l+20>>2]=f[ta+20>>2];f[l+24>>2]=f[ta+24>>2];f[l+28>>2]=f[ta+28>>2];f[l+32>>2]=f[ta+32>>2];oa=l+36|0;ma=f[ta+36>>2]|0;f[oa>>2]=ma;la=l+40|0;f[la>>2]=ra;na=l+48|0;ka=l+44|0;f[ka>>2]=na;f[na>>2]=0;f[l+52>>2]=0;if(ma|0){ja=ma+12|0;f[ja>>2]=(f[ja>>2]|0)+1}if((f[c>>2]|0)<3){c=f[ta+44>>2]|0;ja=f[ka>>2]|0;f[ja>>2]=f[c>>2];f[ja+4>>2]=f[c+4>>2]}else{f[sa>>2]=0;jL(l,ta)}ta=(f[l>>2]|0)>>>3;c=ta&511;ja=c+1|0;if((f[sa>>2]|0)!=2){f[k>>2]=0;f[k+4>>2]=0;La=aD(k,16)|0;Ma=364644;Na=La+16|0;do{b[La>>0]=b[Ma>>0]|0;La=La+1|0;Ma=Ma+1|0}while((La|0)<(Na|0));bO(-215,k,364661,364488,135);bD(k)}f[m>>2]=1124007936;ma=m+4|0;ia=m+8|0;fa=m+40|0;La=ma;Na=La+36|0;do{f[La>>2]=0;La=La+4|0}while((La|0)<(Na|0));f[fa>>2]=ia;ga=m+48|0;ha=m+44|0;f[ha>>2]=ga;f[ga>>2]=0;f[m+52>>2]=0;f[s>>2]=1124007936;ea=s+4|0;ca=s+8|0;da=s+40|0;La=ea;Na=La+36|0;do{f[La>>2]=0;La=La+4|0}while((La|0)<(Na|0));f[da>>2]=ca;g=s+48|0;ba=s+44|0;f[ba>>2]=g;f[g>>2]=0;f[s+52>>2]=0;if((ta&510|0)==2){f[t>>2]=Ka;f[t+4>>2]=ja;f[t+8>>2]=f[ra>>2];f[t+12>>2]=f[qa>>2];f[k>>2]=1124007936;ja=k+4|0;ta=k+8|0;aa=k+40|0;La=ja;Na=La+36|0;do{f[La>>2]=0;La=La+4|0}while((La|0)<(Na|0));f[aa>>2]=ta;O=k+48|0;N=k+44|0;f[N>>2]=O;f[O>>2]=0;f[k+52>>2]=0;hL(k,4,t,5);L=k+36|0;M=f[L>>2]|0;if(M|0){K=M+12|0;f[K>>2]=(f[K>>2]|0)+1}K=m+36|0;M=f[K>>2]|0;if(M|0?(J=M+12|0,M=f[J>>2]|0,f[J>>2]=M+-1,(M|0)==1):0)kL(m);f[K>>2]=0;M=m+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[ma>>2]|0)>0){J=f[fa>>2]|0;U=0;do{f[J+(U<<2)>>2]=0;U=U+1|0;Oa=f[ma>>2]|0}while((U|0)<(Oa|0));f[m>>2]=f[k>>2];if((Oa|0)<3)Ia=57;else Ia=59}else{f[m>>2]=f[k>>2];Ia=57}if((Ia|0)==57){Oa=f[ja>>2]|0;if((Oa|0)<3){f[ma>>2]=Oa;f[ia>>2]=f[ta>>2];f[m+12>>2]=f[k+12>>2];ta=f[N>>2]|0;Oa=f[ha>>2]|0;f[Oa>>2]=f[ta>>2];f[Oa+4>>2]=f[ta+4>>2]}else Ia=59}if((Ia|0)==59)jL(m,k);ta=k+16|0;f[M>>2]=f[ta>>2];Oa=m+20|0;f[Oa>>2]=f[k+20>>2];U=m+24|0;f[U>>2]=f[k+24>>2];J=m+28|0;f[J>>2]=f[k+28>>2];T=m+32|0;f[T>>2]=f[k+32>>2];S=f[L>>2]|0;f[K>>2]=S;if(S|0?(R=S+12|0,S=f[R>>2]|0,f[R>>2]=S+-1,(S|0)==1):0)kL(k);f[L>>2]=0;f[ta>>2]=0;f[ta+4>>2]=0;f[ta+8>>2]=0;f[ta+12>>2]=0;if((f[ja>>2]|0)>0){ta=f[aa>>2]|0;aa=0;do{f[ta+(aa<<2)>>2]=0;aa=aa+1|0}while((aa|0)<(f[ja>>2]|0))}ja=f[N>>2]|0;if((ja|0)!=(O|0))UC(ja);f[v>>2]=1124007936;ja=v+4|0;O=v+8|0;N=v+40|0;La=ja;Na=La+36|0;do{f[La>>2]=0;La=La+4|0}while((La|0)<(Na|0));f[N>>2]=O;aa=v+48|0;ta=v+44|0;f[ta>>2]=aa;f[aa>>2]=0;f[v+52>>2]=0;f[v+56>>2]=1124007936;aa=v+64|0;L=v+96|0;La=v+60|0;Na=La+36|0;do{f[La>>2]=0;La=La+4|0}while((La|0)<(Na|0));f[L>>2]=aa;aa=v+104|0;f[v+100>>2]=aa;f[aa>>2]=0;f[v+108>>2]=0;f[v+112>>2]=1124007936;aa=v+116|0;L=v+120|0;S=v+152|0;La=aa;Na=La+36|0;do{f[La>>2]=0;La=La+4|0}while((La|0)<(Na|0));f[S>>2]=L;R=v+160|0;Q=v+156|0;f[Q>>2]=R;f[R>>2]=0;f[v+164>>2]=0;f[v+168>>2]=1124007936;R=v+176|0;P=v+208|0;La=v+172|0;Na=La+36|0;do{f[La>>2]=0;La=La+4|0}while((La|0)<(Na|0));f[P>>2]=R;R=v+216|0;f[v+212>>2]=R;f[R>>2]=0;f[v+220>>2]=0;if(Ja){R=k+4|0;P=s+12|0;Ha=w+4|0;I=w+8|0;H=w+12|0;G=w+16|0;z=w+20|0;e=w+24|0;q=w+28|0;F=w+40|0;E=w+48|0;D=w+44|0;C=w+52|0;B=k+4|0;A=w+36|0;ya=w+32|0;xa=v+112|0;r=k+4|0;$=k+8|0;_=k+12|0;Z=v+12|0;X=k+16|0;W=v+16|0;V=k+20|0;i=v+20|0;va=k+24|0;ua=v+24|0;Fa=k+28|0;Ga=v+28|0;Da=k+32|0;wa=v+32|0;y=k+36|0;Ca=v+36|0;Ea=k+40|0;Pa=k+48|0;Qa=k+44|0;Ra=k+52|0;Sa=v+148|0;Ta=v+124|0;Ua=v+128|0;Va=v+132|0;Wa=v+136|0;Xa=v+140|0;Ya=v+144|0;Za=k+4|0;_a=k+4|0;$a=s+36|0;ab=s+16|0;bb=s+20|0;cb=s+24|0;db=s+28|0;eb=s+32|0;fb=0;do{gb=f[o>>2]|0;hb=gb+(fb*56|0)|0;if((s|0)!=(hb|0)){ib=gb+(fb*56|0)+36|0;jb=f[ib>>2]|0;if(jb|0){kb=jb+12|0;f[kb>>2]=(f[kb>>2]|0)+1}kb=f[$a>>2]|0;do if(kb|0){jb=kb+12|0;lb=f[jb>>2]|0;f[jb>>2]=lb+-1;if((lb|0)!=1)break;kL(s)}while(0);f[$a>>2]=0;f[ab>>2]=0;f[ab+4>>2]=0;f[ab+8>>2]=0;f[ab+12>>2]=0;if((f[ea>>2]|0)>0){kb=f[da>>2]|0;lb=0;do{f[kb+(lb<<2)>>2]=0;lb=lb+1|0;mb=f[ea>>2]|0}while((lb|0)<(mb|0));f[s>>2]=f[hb>>2];if((mb|0)<3)Ia=82;else Ia=84}else{f[s>>2]=f[hb>>2];Ia=82}do if((Ia|0)==82){Ia=0;lb=f[gb+(fb*56|0)+4>>2]|0;if((lb|0)>=3){Ia=84;break}f[ea>>2]=lb;f[ca>>2]=f[gb+(fb*56|0)+8>>2];f[P>>2]=f[gb+(fb*56|0)+12>>2];lb=f[gb+(fb*56|0)+44>>2]|0;kb=f[ba>>2]|0;f[kb>>2]=f[lb>>2];f[kb+4>>2]=f[lb+4>>2]}while(0);if((Ia|0)==84){Ia=0;jL(s,hb)}f[ab>>2]=f[gb+(fb*56|0)+16>>2];f[bb>>2]=f[gb+(fb*56|0)+20>>2];f[cb>>2]=f[gb+(fb*56|0)+24>>2];f[db>>2]=f[gb+(fb*56|0)+28>>2];f[eb>>2]=f[gb+(fb*56|0)+32>>2];f[$a>>2]=f[ib>>2]}lb=f[s>>2]|0;if((lb&7|0)==5)nb=lb;else{f[k>>2]=0;f[_a>>2]=0;La=aD(k,18)|0;Ma=364676;Na=La+18|0;do{b[La>>0]=b[Ma>>0]|0;La=La+1|0;Ma=Ma+1|0}while((La|0)<(Na|0));bO(-215,k,364661,364488,146);bD(k);nb=f[s>>2]|0}ib=nb>>>3;gb=ib&511;if(!((f[ea>>2]|0)==2&(ib&510|0)==2)){f[k>>2]=0;f[Za>>2]=0;La=aD(k,41)|0;Ma=364695;Na=La+41|0;do{b[La>>0]=b[Ma>>0]|0;La=La+1|0;Ma=Ma+1|0}while((La|0)<(Na|0));bO(-215,k,364661,364488,148);bD(k)}ib=f[da>>2]|0;hb=f[la>>2]|0;if((f[ib>>2]|0)==(f[hb>>2]|0)?(f[ib+4>>2]|0)==(f[hb+4>>2]|0):0)ob=0;else{f[k>>2]=0;f[R>>2]=0;La=aD(k,29)|0;Ma=364737;Na=La+29|0;do{b[La>>0]=b[Ma>>0]|0;La=La+1|0;Ma=Ma+1|0}while((La|0)<(Na|0));bO(-215,k,364661,364488,149);bD(k);ob=0}while(1){hb=f[ca>>2]|0;ib=f[P>>2]|0;lb=f[ha>>2]|0;kb=(f[M>>2]|0)+(Y(f[lb>>2]|0,fb)|0)|0;jb=kb+(Y(f[lb+4>>2]|0,ob)|0)|0;f[w>>2]=1124007941;f[Ha>>2]=2;f[I>>2]=hb;f[H>>2]=ib;f[G>>2]=jb;f[z>>2]=jb;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[F>>2]=I;f[D>>2]=E;f[C>>2]=0;f[E>>2]=0;if((Y(ib,hb)|0)!=0&(jb|0)==0){f[k>>2]=0;f[B>>2]=0;La=aD(k,26)|0;Ma=426262;Na=La+26|0;do{b[La>>0]=b[Ma>>0]|0;La=La+1|0;Ma=Ma+1|0}while((La|0)<(Na|0));bO(-215,k,426289,431198,500);bD(k);pb=f[H>>2]|0;qb=f[w>>2]|0;rb=f[D>>2]|0;sb=f[z>>2]|0}else{pb=ib;qb=1124007941;rb=E;sb=jb}hb=pb<<2;f[w>>2]=qb|16384;f[rb>>2]=hb;f[rb+4>>2]=4;lb=sb+(Y(f[I>>2]|0,hb)|0)|0;f[q>>2]=lb;f[e>>2]=lb+(0-hb)+hb;hb=v+(ob*56|0)|0;lb=f[A>>2]|0;if((hb|0)==(w|0))tb=lb;else{if(lb|0){kb=lb+12|0;f[kb>>2]=(f[kb>>2]|0)+1}kb=v+(ob*56|0)+36|0;lb=f[kb>>2]|0;do if(lb|0){ub=lb+12|0;vb=f[ub>>2]|0;f[ub>>2]=vb+-1;if((vb|0)!=1)break;kL(hb)}while(0);f[kb>>2]=0;lb=v+(ob*56|0)+16|0;jb=v+(ob*56|0)+4|0;f[lb>>2]=0;f[lb+4>>2]=0;f[lb+8>>2]=0;f[lb+12>>2]=0;if((f[jb>>2]|0)>0){ib=f[v+(ob*56|0)+40>>2]|0;vb=0;do{f[ib+(vb<<2)>>2]=0;vb=vb+1|0;wb=f[jb>>2]|0}while((vb|0)<(wb|0));f[hb>>2]=f[w>>2];if((wb|0)<3)Ia=106;else Ia=108}else{f[hb>>2]=f[w>>2];Ia=106}do if((Ia|0)==106){Ia=0;vb=f[Ha>>2]|0;if((vb|0)>=3){Ia=108;break}f[jb>>2]=vb;f[v+(ob*56|0)+8>>2]=f[I>>2];f[v+(ob*56|0)+12>>2]=f[H>>2];vb=f[D>>2]|0;ib=f[v+(ob*56|0)+44>>2]|0;f[ib>>2]=f[vb>>2];f[ib+4>>2]=f[vb+4>>2]}while(0);if((Ia|0)==108){Ia=0;jL(hb,w)}f[lb>>2]=f[G>>2];f[v+(ob*56|0)+20>>2]=f[z>>2];f[v+(ob*56|0)+24>>2]=f[e>>2];f[v+(ob*56|0)+28>>2]=f[q>>2];f[v+(ob*56|0)+32>>2]=f[ya>>2];jb=f[A>>2]|0;f[kb>>2]=jb;tb=jb}do if(tb|0){jb=tb+12|0;vb=f[jb>>2]|0;f[jb>>2]=vb+-1;if((vb|0)!=1)break;kL(w)}while(0);f[A>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[Ha>>2]|0)>0){kb=f[F>>2]|0;lb=0;do{f[kb+(lb<<2)>>2]=0;lb=lb+1|0}while((lb|0)<(f[Ha>>2]|0))}lb=f[D>>2]|0;if((lb|0)!=(E|0))UC(lb);if((ob|0)<(gb|0))ob=ob+1|0;else break}if(h){f[k>>2]=f[v>>2];gb=f[ja>>2]|0;f[r>>2]=gb;f[$>>2]=f[O>>2];f[_>>2]=f[Z>>2];f[X>>2]=f[W>>2];f[V>>2]=f[i>>2];f[va>>2]=f[ua>>2];f[Fa>>2]=f[Ga>>2];f[Da>>2]=f[wa>>2];lb=f[Ca>>2]|0;f[y>>2]=lb;f[Ea>>2]=$;f[Qa>>2]=Pa;f[Pa>>2]=0;f[Ra>>2]=0;if(!lb)xb=gb;else{gb=lb+12|0;f[gb>>2]=(f[gb>>2]|0)+1;xb=f[ja>>2]|0}if((xb|0)<3){gb=f[ta>>2]|0;lb=f[Qa>>2]|0;f[lb>>2]=f[gb>>2];f[lb+4>>2]=f[gb+4>>2]}else{f[r>>2]=0;jL(k,v)}gb=f[Sa>>2]|0;if(gb|0){lb=gb+12|0;f[lb>>2]=(f[lb>>2]|0)+1}lb=f[Ca>>2]|0;do if(lb|0){gb=lb+12|0;kb=f[gb>>2]|0;f[gb>>2]=kb+-1;if((kb|0)!=1)break;kL(v)}while(0);f[Ca>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[ja>>2]|0)>0){lb=f[N>>2]|0;kb=0;do{f[lb+(kb<<2)>>2]=0;kb=kb+1|0;yb=f[ja>>2]|0}while((kb|0)<(yb|0));f[v>>2]=f[xa>>2];if((yb|0)<3)Ia=134;else Ia=136}else{f[v>>2]=f[xa>>2];Ia=134}do if((Ia|0)==134){Ia=0;kb=f[aa>>2]|0;if((kb|0)>=3){Ia=136;break}f[ja>>2]=kb;f[O>>2]=f[L>>2];f[Z>>2]=f[Ta>>2];kb=f[Q>>2]|0;lb=f[ta>>2]|0;f[lb>>2]=f[kb>>2];f[lb+4>>2]=f[kb+4>>2]}while(0);if((Ia|0)==136){Ia=0;jL(v,xa)}f[W>>2]=f[Ua>>2];f[i>>2]=f[Va>>2];f[ua>>2]=f[Wa>>2];f[Ga>>2]=f[Xa>>2];f[wa>>2]=f[Ya>>2];kb=f[Sa>>2]|0;f[Ca>>2]=kb;lb=f[y>>2]|0;if(!lb)zb=kb;else{kb=lb+12|0;f[kb>>2]=(f[kb>>2]|0)+1;zb=f[Sa>>2]|0}do if(zb|0){kb=zb+12|0;lb=f[kb>>2]|0;f[kb>>2]=lb+-1;if((lb|0)!=1)break;kL(xa)}while(0);f[Sa>>2]=0;f[Ua>>2]=0;f[Ua+4>>2]=0;f[Ua+8>>2]=0;f[Ua+12>>2]=0;if((f[aa>>2]|0)>0){lb=f[S>>2]|0;kb=0;do{f[lb+(kb<<2)>>2]=0;kb=kb+1|0;Ab=f[aa>>2]|0}while((kb|0)<(Ab|0));f[xa>>2]=f[k>>2];if((Ab|0)<3)Ia=147;else Ia=149}else{f[xa>>2]=f[k>>2];Ia=147}do if((Ia|0)==147){Ia=0;kb=f[r>>2]|0;if((kb|0)>=3){Ia=149;break}f[aa>>2]=kb;f[L>>2]=f[$>>2];f[Ta>>2]=f[_>>2];kb=f[Qa>>2]|0;lb=f[Q>>2]|0;f[lb>>2]=f[kb>>2];f[lb+4>>2]=f[kb+4>>2]}while(0);if((Ia|0)==149){Ia=0;jL(xa,k)}f[Ua>>2]=f[X>>2];f[Va>>2]=f[V>>2];f[Wa>>2]=f[va>>2];f[Xa>>2]=f[Fa>>2];f[Ya>>2]=f[Da>>2];kb=f[y>>2]|0;f[Sa>>2]=kb;do if(kb|0){lb=kb+12|0;gb=f[lb>>2]|0;f[lb>>2]=gb+-1;if((gb|0)!=1)break;kL(k)}while(0);f[y>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[r>>2]|0)>0){kb=f[Ea>>2]|0;gb=0;do{f[kb+(gb<<2)>>2]=0;gb=gb+1|0}while((gb|0)<(f[r>>2]|0))}gb=f[Qa>>2]|0;if((gb|0)!=(Pa|0))UC(gb)}wI(s,v);fb=fb+1|0}while(fb>>>0<Ka>>>0);fb=v+204|0;Pa=f[fb>>2]|0;Qa=v+168|0;if((Pa|0)!=0?(r=Pa+12|0,Pa=f[r>>2]|0,f[r>>2]=Pa+-1,(Pa|0)==1):0){kL(Qa);Bb=fb}else Bb=fb}else Bb=v+204|0;f[Bb>>2]=0;Bb=v+184|0;fb=v+172|0;f[Bb>>2]=0;f[Bb+4>>2]=0;f[Bb+8>>2]=0;f[Bb+12>>2]=0;if((f[fb>>2]|0)>0){Bb=f[v+208>>2]|0;Qa=0;do{f[Bb+(Qa<<2)>>2]=0;Qa=Qa+1|0}while((Qa|0)<(f[fb>>2]|0))}fb=f[v+212>>2]|0;if((fb|0)!=(v+216|0))UC(fb);fb=v+112|0;Qa=v+148|0;Bb=f[Qa>>2]|0;if(Bb|0?(Pa=Bb+12|0,Bb=f[Pa>>2]|0,f[Pa>>2]=Bb+-1,(Bb|0)==1):0)kL(fb);f[Qa>>2]=0;Qa=v+128|0;fb=v+116|0;f[Qa>>2]=0;f[Qa+4>>2]=0;f[Qa+8>>2]=0;f[Qa+12>>2]=0;if((f[fb>>2]|0)>0){Qa=f[v+152>>2]|0;Bb=0;do{f[Qa+(Bb<<2)>>2]=0;Bb=Bb+1|0}while((Bb|0)<(f[fb>>2]|0))}fb=f[v+156>>2]|0;if((fb|0)!=(v+160|0))UC(fb);fb=v+56|0;Bb=v+92|0;Qa=f[Bb>>2]|0;do if(Qa|0){Pa=Qa+12|0;r=f[Pa>>2]|0;f[Pa>>2]=r+-1;if((r|0)!=1)break;kL(fb)}while(0);f[Bb>>2]=0;Bb=v+72|0;fb=v+60|0;f[Bb>>2]=0;f[Bb+4>>2]=0;f[Bb+8>>2]=0;f[Bb+12>>2]=0;if((f[fb>>2]|0)>0){Bb=f[v+96>>2]|0;Qa=0;do{f[Bb+(Qa<<2)>>2]=0;Qa=Qa+1|0}while((Qa|0)<(f[fb>>2]|0))}fb=f[v+100>>2]|0;if((fb|0)!=(v+104|0))UC(fb);fb=v+36|0;Qa=f[fb>>2]|0;do if(Qa|0){Bb=Qa+12|0;r=f[Bb>>2]|0;f[Bb>>2]=r+-1;if((r|0)!=1)break;kL(v)}while(0);f[fb>>2]=0;fb=v+16|0;Qa=v+4|0;f[fb>>2]=0;f[fb+4>>2]=0;f[fb+8>>2]=0;f[fb+12>>2]=0;if((f[Qa>>2]|0)>0){fb=f[v+40>>2]|0;r=0;do{f[fb+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[Qa>>2]|0))}Qa=f[v+44>>2]|0;if((Qa|0)!=(v+48|0))UC(Qa);Cb=M;Db=Oa;Eb=U;Fb=J;Gb=T;Hb=K;Ib=K;Jb=M}else{if(c|0){f[k>>2]=0;f[k+4>>2]=0;c=aD(k,8)|0;M=c;b[M>>0]=110;b[M+1>>0]=99;b[M+2>>0]=104;b[M+3>>0]=32;M=c+4|0;b[M>>0]=61;b[M+1>>0]=61;b[M+2>>0]=32;b[M+3>>0]=49;bO(-215,k,364661,364488,160);bD(k)}f[t>>2]=Ka;f[t+4>>2]=1;f[t+8>>2]=f[ra>>2];f[t+12>>2]=f[qa>>2];f[k>>2]=1124007936;qa=k+4|0;ra=k+8|0;M=k+40|0;La=qa;Na=La+36|0;do{f[La>>2]=0;La=La+4|0}while((La|0)<(Na|0));f[M>>2]=ra;c=k+48|0;K=k+44|0;f[K>>2]=c;f[c>>2]=0;f[k+52>>2]=0;hL(k,4,t,5);t=k+36|0;T=f[t>>2]|0;if(T|0){J=T+12|0;f[J>>2]=(f[J>>2]|0)+1}J=m+36|0;T=f[J>>2]|0;if(T|0?(U=T+12|0,T=f[U>>2]|0,f[U>>2]=T+-1,(T|0)==1):0)kL(m);f[J>>2]=0;T=m+16|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[ma>>2]|0)>0){U=f[fa>>2]|0;Oa=0;do{f[U+(Oa<<2)>>2]=0;Oa=Oa+1|0;Kb=f[ma>>2]|0}while((Oa|0)<(Kb|0));f[m>>2]=f[k>>2];if((Kb|0)<3)Ia=181;else Ia=183}else{f[m>>2]=f[k>>2];Ia=181}if((Ia|0)==181){Kb=f[qa>>2]|0;if((Kb|0)<3){f[ma>>2]=Kb;f[ia>>2]=f[ra>>2];f[m+12>>2]=f[k+12>>2];ra=f[K>>2]|0;Kb=f[ha>>2]|0;f[Kb>>2]=f[ra>>2];f[Kb+4>>2]=f[ra+4>>2]}else Ia=183}if((Ia|0)==183)jL(m,k);ra=k+16|0;f[T>>2]=f[ra>>2];Kb=m+20|0;f[Kb>>2]=f[k+20>>2];Oa=m+24|0;f[Oa>>2]=f[k+24>>2];U=m+28|0;f[U>>2]=f[k+28>>2];Qa=m+32|0;f[Qa>>2]=f[k+32>>2];r=f[t>>2]|0;f[J>>2]=r;if(r|0?(fb=r+12|0,r=f[fb>>2]|0,f[fb>>2]=r+-1,(r|0)==1):0)kL(k);f[t>>2]=0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[qa>>2]|0)>0){ra=f[M>>2]|0;M=0;do{f[ra+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[qa>>2]|0))}qa=f[K>>2]|0;if((qa|0)!=(c|0))UC(qa);if(Ja|0){Ja=v+4|0;qa=v+8|0;c=v+12|0;K=v+16|0;M=v+20|0;ra=v+24|0;t=v+28|0;r=v+32|0;fb=v+36|0;Bb=v+40|0;Pa=v+48|0;Ea=v+44|0;X=v+52|0;y=x+4|0;Sa=x+8|0;Da=x+12|0;Ya=x+16|0;Fa=x+20|0;Xa=x+24|0;va=x+28|0;Wa=x+40|0;V=x+48|0;Va=x+44|0;Ua=x+52|0;xa=k+4|0;Q=w+8|0;_=w+4|0;Ta=x+36|0;$=k+4|0;L=k+4|0;aa=k+4|0;Ab=0;do{S=f[o>>2]|0;zb=S+(Ab*56|0)|0;f[v>>2]=f[zb>>2];Ca=S+(Ab*56|0)+4|0;f[Ja>>2]=f[Ca>>2];f[qa>>2]=f[S+(Ab*56|0)+8>>2];f[c>>2]=f[S+(Ab*56|0)+12>>2];f[K>>2]=f[S+(Ab*56|0)+16>>2];f[M>>2]=f[S+(Ab*56|0)+20>>2];f[ra>>2]=f[S+(Ab*56|0)+24>>2];f[t>>2]=f[S+(Ab*56|0)+28>>2];f[r>>2]=f[S+(Ab*56|0)+32>>2];wa=f[S+(Ab*56|0)+36>>2]|0;f[fb>>2]=wa;f[Bb>>2]=qa;f[Ea>>2]=Pa;f[Pa>>2]=0;f[X>>2]=0;if(wa|0){Ga=wa+12|0;f[Ga>>2]=(f[Ga>>2]|0)+1}if((f[Ca>>2]|0)<3){Ca=f[S+(Ab*56|0)+44>>2]|0;S=f[Ea>>2]|0;f[S>>2]=f[Ca>>2];f[S+4>>2]=f[Ca+4>>2]}else{f[Ja>>2]=0;jL(v,zb)}zb=f[v>>2]|0;if((zb&7|0)==5)Lb=zb;else{f[k>>2]=0;f[aa>>2]=0;La=aD(k,18)|0;Ma=364676;Na=La+18|0;do{b[La>>0]=b[Ma>>0]|0;La=La+1|0;Ma=Ma+1|0}while((La|0)<(Na|0));bO(-215,k,364661,364488,167);bD(k);Lb=f[v>>2]|0}if(!((f[Ja>>2]|0)==2&(Lb&4088|0)==0)){f[k>>2]=0;f[L>>2]=0;La=aD(k,29)|0;Ma=364767;Na=La+29|0;do{b[La>>0]=b[Ma>>0]|0;La=La+1|0;Ma=Ma+1|0}while((La|0)<(Na|0));bO(-215,k,364661,364488,169);bD(k)}zb=f[Bb>>2]|0;Ca=f[la>>2]|0;if(!((f[zb>>2]|0)==(f[Ca>>2]|0)?(f[zb+4>>2]|0)==(f[Ca+4>>2]|0):0)){f[k>>2]=0;f[$>>2]=0;La=aD(k,29)|0;Ma=364737;Na=La+29|0;do{b[La>>0]=b[Ma>>0]|0;La=La+1|0;Ma=Ma+1|0}while((La|0)<(Na|0));bO(-215,k,364661,364488,170);bD(k)}Ca=f[qa>>2]|0;zb=f[c>>2]|0;S=(f[T>>2]|0)+(Y(f[f[ha>>2]>>2]|0,Ab)|0)|0;f[x>>2]=1124007941;f[y>>2]=2;f[Sa>>2]=Ca;f[Da>>2]=zb;f[Ya>>2]=S;f[Fa>>2]=S;f[Xa>>2]=0;f[Xa+4>>2]=0;f[Xa+8>>2]=0;f[Xa+12>>2]=0;f[Wa>>2]=Sa;f[Va>>2]=V;f[Ua>>2]=0;f[V>>2]=0;if((Y(zb,Ca)|0)!=0&(S|0)==0){f[k>>2]=0;f[xa>>2]=0;La=aD(k,26)|0;Ma=426262;Na=La+26|0;do{b[La>>0]=b[Ma>>0]|0;La=La+1|0;Ma=Ma+1|0}while((La|0)<(Na|0));bO(-215,k,426289,431198,500);bD(k);Mb=f[Da>>2]|0;Nb=f[x>>2]|0;Ob=f[Va>>2]|0;Pb=f[Fa>>2]|0}else{Mb=zb;Nb=1124007941;Ob=V;Pb=S}Ca=Mb<<2;f[x>>2]=Nb|16384;f[Ob>>2]=Ca;f[Ob+4>>2]=4;Ga=Pb+(Y(f[Sa>>2]|0,Ca)|0)|0;f[va>>2]=Ga;f[Xa>>2]=Ga+(0-Ca)+Ca;Ca=Q;f[Ca>>2]=0;f[Ca+4>>2]=0;f[w>>2]=-1040121856;f[_>>2]=x;SP(v,w);Ca=f[Ta>>2]|0;do if(Ca|0){Ga=Ca+12|0;wa=f[Ga>>2]|0;f[Ga>>2]=wa+-1;if((wa|0)!=1)break;kL(x)}while(0);f[Ta>>2]=0;f[Ya>>2]=0;f[Ya+4>>2]=0;f[Ya+8>>2]=0;f[Ya+12>>2]=0;if((f[y>>2]|0)>0){Ca=f[Wa>>2]|0;S=0;do{f[Ca+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[y>>2]|0))}S=f[Va>>2]|0;if((S|0)!=(V|0))UC(S);S=f[fb>>2]|0;do if(S|0){Ca=S+12|0;zb=f[Ca>>2]|0;f[Ca>>2]=zb+-1;if((zb|0)!=1)break;kL(v)}while(0);f[fb>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[Ja>>2]|0)>0){S=f[Bb>>2]|0;zb=0;do{f[S+(zb<<2)>>2]=0;zb=zb+1|0}while((zb|0)<(f[Ja>>2]|0))}zb=f[Ea>>2]|0;if((zb|0)!=(Pa|0))UC(zb);Ab=Ab+1|0}while(Ab>>>0<Ka>>>0)}Cb=T;Db=Kb;Eb=Oa;Fb=U;Gb=Qa;Hb=J;Ib=J;Jb=T}f[a>>2]=f[m>>2];T=a+4|0;J=f[ma>>2]|0;f[T>>2]=J;Qa=a+8|0;f[Qa>>2]=f[ia>>2];f[a+12>>2]=f[m+12>>2];f[a+16>>2]=f[Cb>>2];f[a+20>>2]=f[Db>>2];f[a+24>>2]=f[Eb>>2];f[a+28>>2]=f[Fb>>2];f[a+32>>2]=f[Gb>>2];Gb=f[Ib>>2]|0;f[a+36>>2]=Gb;f[a+40>>2]=Qa;Qa=a+48|0;Ib=a+44|0;f[Ib>>2]=Qa;f[Qa>>2]=0;f[a+52>>2]=0;if(!Gb)Qb=J;else{J=Gb+12|0;f[J>>2]=(f[J>>2]|0)+1;Qb=f[ma>>2]|0}if((Qb|0)<3){Qb=f[ha>>2]|0;J=f[Ib>>2]|0;f[J>>2]=f[Qb>>2];f[J+4>>2]=f[Qb+4>>2]}else{f[T>>2]=0;jL(a,m)}T=s+36|0;Qb=f[T>>2]|0;if(Qb|0?(J=Qb+12|0,Qb=f[J>>2]|0,f[J>>2]=Qb+-1,(Qb|0)==1):0)kL(s);f[T>>2]=0;T=s+16|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[ea>>2]|0)>0){T=f[da>>2]|0;da=0;do{f[T+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[ea>>2]|0))}ea=f[ba>>2]|0;if((ea|0)!=(g|0))UC(ea);ea=f[Hb>>2]|0;if(ea|0?(g=ea+12|0,ea=f[g>>2]|0,f[g>>2]=ea+-1,(ea|0)==1):0)kL(m);f[Hb>>2]=0;f[Jb>>2]=0;f[Jb+4>>2]=0;f[Jb+8>>2]=0;f[Jb+12>>2]=0;if((f[ma>>2]|0)>0){Jb=f[fa>>2]|0;fa=0;do{f[Jb+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[ma>>2]|0))}ma=f[ha>>2]|0;if((ma|0)!=(ga|0))UC(ma);ma=f[oa>>2]|0;if(ma|0?(ga=ma+12|0,ma=f[ga>>2]|0,f[ga>>2]=ma+-1,(ma|0)==1):0)kL(l);f[oa>>2]=0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[sa>>2]|0)>0){pa=f[la>>2]|0;la=0;do{f[pa+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[sa>>2]|0))}sa=f[ka>>2]|0;if((sa|0)!=(na|0))UC(sa)}else Ia=38}else Ia=38;if((Ia|0)==38){f[a>>2]=1124007936;Ia=a+8|0;sa=a+40|0;La=a+4|0;Na=La+36|0;do{f[La>>2]=0;La=La+4|0}while((La|0)<(Na|0));f[sa>>2]=Ia;Ia=a+48|0;f[a+44>>2]=Ia;f[Ia>>2]=0;f[a+52>>2]=0}et(o);if(!(f[n+4>>2]|0)){u=j;return}u=j;return}function Fua(a){a=a|0;var b=0,c=0;b=L5b(160)|0;Gua(b);c=L5b(16)|0;f[c+4>>2]=1;f[c>>2]=105356;f[c+8>>2]=b;f[a>>2]=c;f[a+4>>2]=b;return}function Gua(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;c=u;u=u+736|0;d=c+492|0;e=c+248|0;g=c+8|0;h=c;i=a+4|0;j=a+32|0;k=a+36|0;f[k>>2]=0;l=a+40|0;f[l>>2]=0;m=a+36|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;f[j>>2]=m;n=a+44|0;o=a+48|0;f[o>>2]=0;p=a+52|0;f[p>>2]=0;q=a+48|0;f[n>>2]=q;f[a+60>>2]=0;f[a+64>>2]=0;f[a+56>>2]=a+60;f[a+72>>2]=0;f[a+76>>2]=0;f[a+68>>2]=a+72;f[a+84>>2]=0;f[a+88>>2]=0;f[a+80>>2]=a+84;f[a+96>>2]=0;f[a+100>>2]=0;f[a+92>>2]=a+96;f[a+120>>2]=0;f[a+124>>2]=0;f[a+132>>2]=0;f[a+136>>2]=0;f[a+128>>2]=a+132;f[a+148>>2]=0;f[a+152>>2]=0;f[a+156>>2]=0;r=L5b(48)|0;s=r;t=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));FY(r);v=r+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;f[v+24>>2]=0;f[v+28>>2]=0;f[r>>2]=105376;f[r+36>>2]=0;f[r+40>>2]=0;f[r+44>>2]=0;v=L5b(16)|0;w=v+4|0;f[w>>2]=1;f[v>>2]=105476;f[v+8>>2]=r;f[w>>2]=(f[w>>2]|0)+1;x=f[a>>2]|0;f[a>>2]=v;f[i>>2]=r;if(x|0?(r=x+4|0,y=f[r>>2]|0,f[r>>2]=y+-1,(y|0)==1):0)bi[f[(f[x>>2]|0)+8>>2]&2047](x);x=f[w>>2]|0;f[w>>2]=x+-1;if((x|0)==1)bi[f[(f[v>>2]|0)+8>>2]&2047](v);f[g>>2]=-1;v=g+4|0;f[g+24>>2]=0;f[g+28>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[g+20>>2]=g+24;f[g+76>>2]=0;f[g+80>>2]=0;v=g+76|0;x=g+72|0;s=g+32|0;t=s+40|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[x>>2]=v;f[g+88>>2]=0;f[g+92>>2]=0;f[g+84>>2]=g+88;f[g+216>>2]=0;f[g+220>>2]=0;v=g+216|0;x=g+212|0;s=g+96|0;t=s+116|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[x>>2]=v;f[g+228>>2]=0;f[g+232>>2]=0;f[g+224>>2]=g+228;f[g+236>>2]=0;f[e>>2]=0;v=e+4|0;Uua(v,g);f[d>>2]=f[e>>2];x=d+4|0;Uua(x,v);w=f[m>>2]|0;do if(w){y=f[d>>2]|0;r=k;z=w;while(1){A=f[z+16>>2]|0;if((y|0)<(A|0)){B=f[z>>2]|0;if(!B){C=11;break}else{D=z;E=B}}else{if((A|0)>=(y|0)){C=15;break}F=z+4|0;A=f[F>>2]|0;if(!A){C=14;break}else{D=F;E=A}}r=D;z=E}if((C|0)==11){G=z;H=z;break}else if((C|0)==14){G=F;H=z;break}else if((C|0)==15){G=r;H=z;break}}else{G=m;H=m}while(0);m=f[G>>2]|0;if(!m){F=L5b(260)|0;f[F+16>>2]=f[d>>2];Uua(F+20|0,x);f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=H;f[G>>2]=F;H=f[f[j>>2]>>2]|0;if(!H)I=F;else{f[j>>2]=H;I=f[G>>2]|0}mP(f[k>>2]|0,I);f[l>>2]=(f[l>>2]|0)+1;J=F}else J=m;Qua(x);Qua(v);Qua(g);g=J+20|0;f[g>>2]=0;v=J+24|0;bD(v);x=aD(v,6)|0;b[x>>0]=b[365124]|0;b[x+1>>0]=b[365125]|0;b[x+2>>0]=b[365126]|0;b[x+3>>0]=b[365127]|0;b[x+4>>0]=b[365128]|0;b[x+5>>0]=b[365129]|0;x=J+32|0;bD(x);s=aD(x,17)|0;x=365131;t=s+17|0;do{b[s>>0]=b[x>>0]|0;s=s+1|0;x=x+1|0}while((s|0)<(t|0));x=J+152|0;s=f[a>>2]|0;t=f[i>>2]|0;if(s|0){i=s+4|0;f[i>>2]=(f[i>>2]|0)+1}i=f[x>>2]|0;f[x>>2]=s;f[J+156>>2]=t;if(i|0?(t=i+4|0,s=f[t>>2]|0,f[t>>2]=s+-1,(s|0)==1):0)bi[f[(f[i>>2]|0)+8>>2]&2047](i);i=f[v>>2]|0;f[h>>2]=i;v=h+4|0;s=f[J+28>>2]|0;f[v>>2]=s;if(i){J=i+-4|0;f[J>>2]=(f[J>>2]|0)+1;J=f[h>>2]|0;i=f[v>>2]|0;v=f[g>>2]|0;f[e>>2]=J;t=e+4|0;f[t>>2]=i;if(J){x=J+-4|0;f[x>>2]=(f[x>>2]|0)+1;x=f[e>>2]|0;J=f[t>>2]|0;t=e+8|0;f[t>>2]=v;f[d>>2]=x;m=d+4|0;f[m>>2]=J;if(!x){K=v;L=d;M=m}else{J=x+-4|0;f[J>>2]=(f[J>>2]|0)+1;K=f[t>>2]|0;L=d;M=m}}else{N=v;O=i;C=29}}else{i=f[g>>2]|0;f[e>>2]=0;f[e+4>>2]=s;N=i;O=s;C=29}if((C|0)==29){f[e+8>>2]=N;f[d>>2]=0;s=d+4|0;f[s>>2]=O;K=N;L=d;M=s}s=d+8|0;f[s>>2]=K;N=f[q>>2]|0;a:do if(!N){P=q;Q=q}else{O=f[d>>2]|0;i=(O|0)==0?1124530:O;g=f[N+16>>2]|0;b:do if((O|0)!=(g|0)){v=o;m=N;t=g;while(1){J=(t|0)==0?1124530:t;if((gTb(i,J)|0)<0){x=f[m>>2]|0;if(!x){C=37;break}else{R=m;S=x}}else{if((gTb(J,i)|0)>=0){T=v;U=m;break b}V=m+4|0;J=f[V>>2]|0;if(!J){C=40;break}else{R=V;S=J}}t=f[S+16>>2]|0;if((O|0)==(t|0)){T=R;U=S;break b}else{v=R;m=S}}if((C|0)==37){P=m;Q=m;break a}else if((C|0)==40){P=V;Q=m;break a}}else{T=o;U=N}while(0);P=T;Q=U}while(0);if(f[P>>2]|0){bD(d);bD(e);bD(h);W=a+140|0;f[W>>2]=0;X=a+144|0;b[X>>0]=0;Y=a+145|0;b[Y>>0]=1;Z=a+104|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;u=c;return}U=L5b(28)|0;T=f[L>>2]|0;f[U+16>>2]=T;f[U+20>>2]=f[M>>2];if(!T)_=K;else{K=T+-4|0;f[K>>2]=(f[K>>2]|0)+1;_=f[s>>2]|0}f[U+24>>2]=_;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=Q;f[P>>2]=U;Q=f[f[n>>2]>>2]|0;if(!Q)$=U;else{f[n>>2]=Q;$=f[P>>2]|0}mP(f[o>>2]|0,$);f[p>>2]=(f[p>>2]|0)+1;bD(d);bD(e);bD(h);W=a+140|0;f[W>>2]=0;X=a+144|0;b[X>>0]=0;Y=a+145|0;b[Y>>0]=1;Z=a+104|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;u=c;return}function Hua(a){a=a|0;O5b(a);return}function Iua(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0){Jua(b);O5b(b)}bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Jua(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+148>>2]|0;if(b|0){c=a+152|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);O5b(b)}Kua(a+128|0,f[a+132>>2]|0);bD(a+120|0);Lua(a+92|0,f[a+96>>2]|0);Mua(a+80|0,f[a+84>>2]|0);Nua(a+68|0,f[a+72>>2]|0);Oua(a+56|0,f[a+60>>2]|0);Wta(a+44|0,f[a+48>>2]|0);Pua(a+32|0,f[a+36>>2]|0);b=f[a+20>>2]|0;if(b|0){d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b)}b=f[a+8>>2]|0;if(b|0){c=a+12|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a>>2]|0;if(!b){f[a>>2]=0;e=a+4|0;f[e>>2]=0;return}d=b+4|0;c=f[d>>2]|0;f[d>>2]=c+-1;if((c|0)!=1){f[a>>2]=0;e=a+4|0;f[e>>2]=0;return}bi[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=0;e=a+4|0;f[e>>2]=0;return}function Kua(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b)return;Kua(a,f[b>>2]|0);Kua(a,f[b+4>>2]|0);a=f[b+20>>2]|0;if(a|0?(c=a+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)bi[f[(f[a>>2]|0)+8>>2]&2047](a);O5b(b);return}function Lua(a,b){a=a|0;b=b|0;if(!b)return;Lua(a,f[b>>2]|0);Lua(a,f[b+4>>2]|0);hI(b+24|0);O5b(b);return}function Mua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(!b)return;Mua(a,f[b>>2]|0);Mua(a,f[b+4>>2]|0);a=b+24|0;c=b+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(a);f[c>>2]=0;c=b+40|0;a=b+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[b+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[b+68>>2]|0;if((a|0)!=(b+72|0))UC(a);O5b(b);return}function Nua(a,b){a=a|0;b=b|0;if(!b)return;else{Nua(a,f[b>>2]|0);Nua(a,f[b+4>>2]|0);O5b(b);return}}function Oua(a,b){a=a|0;b=b|0;if(!b)return;else{Oua(a,f[b>>2]|0);Oua(a,f[b+4>>2]|0);O5b(b);return}}function Pua(a,b){a=a|0;b=b|0;if(!b)return;Pua(a,f[b>>2]|0);Pua(a,f[b+4>>2]|0);Qua(b+20|0);O5b(b);return}function Qua(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;Rua(a+224|0,f[a+228>>2]|0);Sua(a+212|0,f[a+216>>2]|0);b=a+200|0;c=f[b>>2]|0;if(c|0){d=a+204|0;while(1){e=f[d>>2]|0;if((e|0)==(c|0))break;g=e+-48|0;f[d>>2]=g;hI(g)}O5b(f[b>>2]|0)}b=a+188|0;d=f[b>>2]|0;if(d|0){c=a+192|0;while(1){g=f[c>>2]|0;if((g|0)==(d|0))break;e=g+-48|0;f[c>>2]=e;hI(e)}O5b(f[b>>2]|0)}b=a+176|0;c=f[b>>2]|0;if(c|0){d=a+180|0;while(1){e=f[d>>2]|0;if((e|0)==(c|0))break;g=e+-48|0;f[d>>2]=g;hI(g)}O5b(f[b>>2]|0)}et(a+164|0);b=f[a+152>>2]|0;if(b|0){d=a+156|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-4-b|0)>>>2)<<2);O5b(b)}et(a+140|0);b=a+132|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,g=f[d>>2]|0,f[d>>2]=g+-1,(g|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+136>>2]=0;b=a+120|0;c=f[b>>2]|0;if(c|0){g=a+124|0;d=f[g>>2]|0;if((d|0)==(c|0))h=c;else{e=d;do{d=e+-8|0;f[g>>2]=d;i=f[d>>2]|0;if(i|0?(j=i+4|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)bi[f[(f[i>>2]|0)+8>>2]&2047](i);f[d>>2]=0;f[e+-4>>2]=0;e=f[g>>2]|0}while((e|0)!=(c|0));h=f[b>>2]|0}O5b(h)}h=a+108|0;b=f[h>>2]|0;if(b|0){c=a+112|0;e=f[c>>2]|0;if((e|0)==(b|0))l=b;else{g=e;do{e=g+-8|0;f[c>>2]=e;d=f[e>>2]|0;if(d|0?(i=d+4|0,k=f[i>>2]|0,f[i>>2]=k+-1,(k|0)==1):0)bi[f[(f[d>>2]|0)+8>>2]&2047](d);f[e>>2]=0;f[g+-4>>2]=0;g=f[c>>2]|0}while((g|0)!=(b|0));l=f[h>>2]|0}O5b(l)}l=f[a+96>>2]|0;if(l|0){h=a+100|0;b=f[h>>2]|0;if((b|0)!=(l|0))f[h>>2]=b+(~((b+-8-l|0)>>>3)<<3);O5b(l)}Tua(a+84|0,f[a+88>>2]|0);Tua(a+72|0,f[a+76>>2]|0);l=f[a+60>>2]|0;if(!l){m=a+20|0;fua(m);n=a+12|0;bD(n);o=a+4|0;bD(o);return}b=a+64|0;h=f[b>>2]|0;if((h|0)!=(l|0))f[b>>2]=h+(~((h+-8-l|0)>>>3)<<3);O5b(l);m=a+20|0;fua(m);n=a+12|0;bD(n);o=a+4|0;bD(o);return}function Rua(a,b){a=a|0;b=b|0;if(!b)return;else{Rua(a,f[b>>2]|0);Rua(a,f[b+4>>2]|0);O5b(b);return}}function Sua(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b)return;Sua(a,f[b>>2]|0);Sua(a,f[b+4>>2]|0);a=f[b+20>>2]|0;if(a|0?(c=a+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)bi[f[(f[a>>2]|0)+8>>2]&2047](a);O5b(b);return}function Tua(a,b){a=a|0;b=b|0;if(!b)return;else{Tua(a,f[b>>2]|0);Tua(a,f[b+4>>2]|0);O5b(b);return}}function Uua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;f[a>>2]=f[b>>2];i=f[b+4>>2]|0;f[a+4>>2]=i;f[a+8>>2]=f[b+8>>2];if(i|0){j=i+-4|0;f[j>>2]=(f[j>>2]|0)+1}j=f[b+12>>2]|0;f[a+12>>2]=j;f[a+16>>2]=f[b+16>>2];if(j|0){i=j+-4|0;f[i>>2]=(f[i>>2]|0)+1}$ta(a+20|0,b+20|0);aua(a+32|0,b+32|0);i=f[b+44>>2]|0;f[a+44>>2]=i;f[a+48>>2]=f[b+48>>2];if(i|0){j=i+-4|0;f[j>>2]=(f[j>>2]|0)+1}j=f[b+52>>2]|0;f[a+52>>2]=j;f[a+56>>2]=f[b+56>>2];if(j|0){i=j+-4|0;f[i>>2]=(f[i>>2]|0)+1}Vua(a+60|0,b+60|0);i=a+72|0;j=a+76|0;f[j>>2]=0;k=a+80|0;f[k>>2]=0;l=a+76|0;f[i>>2]=l;m=f[b+72>>2]|0;n=b+76|0;if((m|0)!=(n|0)){o=l;l=m;while(1){m=l+16|0;f[h>>2]=o;f[d>>2]=f[h>>2];p=Wua(i,d,e,g,m)|0;if(!(f[p>>2]|0)){q=L5b(20)|0;f[q+16>>2]=f[m>>2];m=f[e>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=m;f[p>>2]=q;m=f[f[i>>2]>>2]|0;if(!m)r=q;else{f[i>>2]=m;r=f[p>>2]|0}mP(f[j>>2]|0,r);f[k>>2]=(f[k>>2]|0)+1}p=f[l+4>>2]|0;if(!p){m=l+8|0;q=f[m>>2]|0;if((f[q>>2]|0)==(l|0))s=q;else{q=m;do{m=f[q>>2]|0;q=m+8|0;t=f[q>>2]|0}while((f[t>>2]|0)!=(m|0));s=t}}else{q=p;while(1){t=f[q>>2]|0;if(!t)break;else q=t}s=q}if((s|0)==(n|0))break;else l=s}}s=a+84|0;l=a+88|0;f[l>>2]=0;n=a+92|0;f[n>>2]=0;k=a+88|0;f[s>>2]=k;r=f[b+84>>2]|0;j=b+88|0;if((r|0)!=(j|0)){i=k;k=r;while(1){r=k+16|0;f[h>>2]=i;f[d>>2]=f[h>>2];o=Wua(s,d,e,g,r)|0;if(!(f[o>>2]|0)){p=L5b(20)|0;f[p+16>>2]=f[r>>2];r=f[e>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=r;f[o>>2]=p;r=f[f[s>>2]>>2]|0;if(!r)v=p;else{f[s>>2]=r;v=f[o>>2]|0}mP(f[l>>2]|0,v);f[n>>2]=(f[n>>2]|0)+1}o=f[k+4>>2]|0;if(!o){r=k+8|0;p=f[r>>2]|0;if((f[p>>2]|0)==(k|0))w=p;else{p=r;do{r=f[p>>2]|0;p=r+8|0;t=f[p>>2]|0}while((f[t>>2]|0)!=(r|0));w=t}}else{p=o;while(1){q=f[p>>2]|0;if(!q)break;else p=q}w=p}if((w|0)==(j|0))break;else k=w}}Vua(a+96|0,b+96|0);Xua(a+108|0,b+108|0);Xua(a+120|0,b+120|0);w=f[b+132>>2]|0;f[a+132>>2]=w;f[a+136>>2]=f[b+136>>2];if(w|0){k=w+4|0;f[k>>2]=(f[k>>2]|0)+1}aua(a+140|0,b+140|0);Yua(a+152|0,b+152|0);aua(a+164|0,b+164|0);Zua(a+176|0,b+176|0);Zua(a+188|0,b+188|0);Zua(a+200|0,b+200|0);k=a+212|0;w=a+216|0;f[w>>2]=0;j=a+220|0;f[j>>2]=0;n=a+216|0;f[k>>2]=n;v=f[b+212>>2]|0;l=b+216|0;if((v|0)!=(l|0)){s=n;n=v;while(1){v=n+16|0;f[h>>2]=s;f[d>>2]=f[h>>2];i=_ua(k,d,e,g,v)|0;if(!(f[i>>2]|0)){o=L5b(28)|0;f[o+16>>2]=f[v>>2];v=f[n+20>>2]|0;f[o+20>>2]=v;f[o+24>>2]=f[n+24>>2];if(v|0){q=v+4|0;f[q>>2]=(f[q>>2]|0)+1}q=f[e>>2]|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=q;f[i>>2]=o;q=f[f[k>>2]>>2]|0;if(!q)x=o;else{f[k>>2]=q;x=f[i>>2]|0}mP(f[w>>2]|0,x);f[j>>2]=(f[j>>2]|0)+1}i=f[n+4>>2]|0;if(!i){q=n+8|0;o=f[q>>2]|0;if((f[o>>2]|0)==(n|0))y=o;else{o=q;do{q=f[o>>2]|0;o=q+8|0;v=f[o>>2]|0}while((f[v>>2]|0)!=(q|0));y=v}}else{o=i;while(1){p=f[o>>2]|0;if(!p)break;else o=p}y=o}if((y|0)==(l|0))break;else n=y}}y=a+224|0;n=a+228|0;f[n>>2]=0;l=a+232|0;f[l>>2]=0;j=a+228|0;f[y>>2]=j;x=f[b+224>>2]|0;w=b+228|0;if((x|0)==(w|0)){z=a+236|0;A=b+236|0;B=f[A>>2]|0;f[z>>2]=B;u=c;return}k=j;j=x;while(1){x=j+16|0;f[h>>2]=k;f[d>>2]=f[h>>2];s=$ua(y,d,e,g,x)|0;if(!(f[s>>2]|0)){i=L5b(24)|0;p=x;x=f[p+4>>2]|0;v=i+16|0;f[v>>2]=f[p>>2];f[v+4>>2]=x;x=f[e>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=x;f[s>>2]=i;x=f[f[y>>2]>>2]|0;if(!x)C=i;else{f[y>>2]=x;C=f[s>>2]|0}mP(f[n>>2]|0,C);f[l>>2]=(f[l>>2]|0)+1}s=f[j+4>>2]|0;if(!s){x=j+8|0;i=f[x>>2]|0;if((f[i>>2]|0)==(j|0))D=i;else{i=x;do{x=f[i>>2]|0;i=x+8|0;v=f[i>>2]|0}while((f[v>>2]|0)!=(x|0));D=v}}else{i=s;while(1){o=f[i>>2]|0;if(!o)break;else i=o}D=i}if((D|0)==(w|0))break;else j=D}z=a+236|0;A=b+236|0;B=f[A>>2]|0;f[z>>2]=B;u=c;return}function Vua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>3;if(!g)return;if(g>>>0>536870911)c4b(a);h=L5b(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<3);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;Vac(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>3<<3);return}function Wua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){if((j|0)>=(i|0)){f[c>>2]=b;f[d>>2]=b;k=d;return k|0}d=h+4|0;j=f[d>>2]|0;if(!j){l=h+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));n=o}}else{m=j;while(1){j=f[m>>2]|0;if(!j)break;else m=j}n=m}if((n|0)!=(g|0)?(i|0)>=(f[n+16>>2]|0):0){m=f[g>>2]|0;if(!m){f[c>>2]=g;k=g;return k|0}j=a+4|0;o=m;while(1){m=f[o+16>>2]|0;if((i|0)<(m|0)){l=f[o>>2]|0;if(!l){p=39;break}else{q=o;r=l}}else{if((m|0)>=(i|0)){p=43;break}s=o+4|0;m=f[s>>2]|0;if(!m){p=42;break}else{q=s;r=m}}j=q;o=r}if((p|0)==39){f[c>>2]=o;k=o;return k|0}else if((p|0)==42){f[c>>2]=o;k=s;return k|0}else if((p|0)==43){f[c>>2]=o;k=j;return k|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;k=d;return k|0}else{f[c>>2]=n;k=n;return k|0}}n=f[h>>2]|0;if((h|0)!=(f[a>>2]|0)){if(!n){d=h;while(1){j=f[d+8>>2]|0;if((f[j>>2]|0)==(d|0))d=j;else{t=j;break}}}else{d=n;while(1){j=f[d+4>>2]|0;if(!j){t=d;break}else d=j}}d=f[e>>2]|0;if((f[t+16>>2]|0)>=(d|0)){e=f[g>>2]|0;if(!e){f[c>>2]=g;k=g;return k|0}g=a+4|0;a=e;while(1){e=f[a+16>>2]|0;if((d|0)<(e|0)){j=f[a>>2]|0;if(!j){p=17;break}else{u=a;v=j}}else{if((e|0)>=(d|0)){p=21;break}w=a+4|0;e=f[w>>2]|0;if(!e){p=20;break}else{u=w;v=e}}g=u;a=v}if((p|0)==17){f[c>>2]=a;k=a;return k|0}else if((p|0)==20){f[c>>2]=a;k=w;return k|0}else if((p|0)==21){f[c>>2]=a;k=g;return k|0}}else x=t}else x=b;if(!n){f[c>>2]=h;k=h;return k|0}else{h=x;f[c>>2]=h;k=h+4|0;return k|0}return 0}function Xua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>3;if(!g)return;if(g>>>0>536870911)c4b(a);h=L5b(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<3);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{h=f[d>>2]|0;f[g>>2]=h;f[g+4>>2]=f[d+4>>2];if(h|0){a=h+4|0;f[a>>2]=(f[a>>2]|0)+1}d=d+8|0;g=(f[c>>2]|0)+8|0;f[c>>2]=g}while((d|0)!=(b|0));return}function Yua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=e>>2;if(!g)return;if(g>>>0>1073741823)c4b(a);h=L5b(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g<<2);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;Vac(h|0,g|0,b|0)|0;f[c>>2]=h+(b>>>2<<2);return}function Zua(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/48|0;if(!e)return;if(g>>>0>89478485)c4b(a);h=L5b(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*48|0);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{f[g>>2]=f[d>>2];h=g+4|0;a=d+4|0;f[h>>2]=f[a>>2];e=g+8|0;f[e>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];f[g+16>>2]=f[d+16>>2];f[g+20>>2]=f[d+20>>2];i=f[d+24>>2]|0;f[g+24>>2]=i;f[g+28>>2]=f[d+28>>2];f[g+32>>2]=e;e=g+40|0;j=g+36|0;f[j>>2]=e;f[g+44>>2]=0;f[e>>2]=0;if(i|0){e=i+8|0;f[e>>2]=(f[e>>2]|0)+1}if((f[a>>2]|0)<3){a=f[d+36>>2]|0;e=f[j>>2]|0;f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2]}else{f[h>>2]=0;gI(g,d)}d=d+48|0;g=(f[c>>2]|0)+48|0;f[c>>2]=g}while((d|0)!=(b|0));return}function _ua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){if((j|0)>=(i|0)){f[c>>2]=b;f[d>>2]=b;k=d;return k|0}d=h+4|0;j=f[d>>2]|0;if(!j){l=h+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));n=o}}else{m=j;while(1){j=f[m>>2]|0;if(!j)break;else m=j}n=m}if((n|0)!=(g|0)?(i|0)>=(f[n+16>>2]|0):0){m=f[g>>2]|0;if(!m){f[c>>2]=g;k=g;return k|0}j=a+4|0;o=m;while(1){m=f[o+16>>2]|0;if((i|0)<(m|0)){l=f[o>>2]|0;if(!l){p=39;break}else{q=o;r=l}}else{if((m|0)>=(i|0)){p=43;break}s=o+4|0;m=f[s>>2]|0;if(!m){p=42;break}else{q=s;r=m}}j=q;o=r}if((p|0)==39){f[c>>2]=o;k=o;return k|0}else if((p|0)==42){f[c>>2]=o;k=s;return k|0}else if((p|0)==43){f[c>>2]=o;k=j;return k|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;k=d;return k|0}else{f[c>>2]=n;k=n;return k|0}}n=f[h>>2]|0;if((h|0)!=(f[a>>2]|0)){if(!n){d=h;while(1){j=f[d+8>>2]|0;if((f[j>>2]|0)==(d|0))d=j;else{t=j;break}}}else{d=n;while(1){j=f[d+4>>2]|0;if(!j){t=d;break}else d=j}}d=f[e>>2]|0;if((f[t+16>>2]|0)>=(d|0)){e=f[g>>2]|0;if(!e){f[c>>2]=g;k=g;return k|0}g=a+4|0;a=e;while(1){e=f[a+16>>2]|0;if((d|0)<(e|0)){j=f[a>>2]|0;if(!j){p=17;break}else{u=a;v=j}}else{if((e|0)>=(d|0)){p=21;break}w=a+4|0;e=f[w>>2]|0;if(!e){p=20;break}else{u=w;v=e}}g=u;a=v}if((p|0)==17){f[c>>2]=a;k=a;return k|0}else if((p|0)==20){f[c>>2]=a;k=w;return k|0}else if((p|0)==21){f[c>>2]=a;k=g;return k|0}}else x=t}else x=b;if(!n){f[c>>2]=h;k=h;return k|0}else{h=x;f[c>>2]=h;k=h+4|0;return k|0}return 0}function $ua(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){if((j|0)>=(i|0)){f[c>>2]=b;f[d>>2]=b;k=d;return k|0}d=h+4|0;j=f[d>>2]|0;if(!j){l=h+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));n=o}}else{m=j;while(1){j=f[m>>2]|0;if(!j)break;else m=j}n=m}if((n|0)!=(g|0)?(i|0)>=(f[n+16>>2]|0):0){m=f[g>>2]|0;if(!m){f[c>>2]=g;k=g;return k|0}j=a+4|0;o=m;while(1){m=f[o+16>>2]|0;if((i|0)<(m|0)){l=f[o>>2]|0;if(!l){p=39;break}else{q=o;r=l}}else{if((m|0)>=(i|0)){p=43;break}s=o+4|0;m=f[s>>2]|0;if(!m){p=42;break}else{q=s;r=m}}j=q;o=r}if((p|0)==39){f[c>>2]=o;k=o;return k|0}else if((p|0)==42){f[c>>2]=o;k=s;return k|0}else if((p|0)==43){f[c>>2]=o;k=j;return k|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;k=d;return k|0}else{f[c>>2]=n;k=n;return k|0}}n=f[h>>2]|0;if((h|0)!=(f[a>>2]|0)){if(!n){d=h;while(1){j=f[d+8>>2]|0;if((f[j>>2]|0)==(d|0))d=j;else{t=j;break}}}else{d=n;while(1){j=f[d+4>>2]|0;if(!j){t=d;break}else d=j}}d=f[e>>2]|0;if((f[t+16>>2]|0)>=(d|0)){e=f[g>>2]|0;if(!e){f[c>>2]=g;k=g;return k|0}g=a+4|0;a=e;while(1){e=f[a+16>>2]|0;if((d|0)<(e|0)){j=f[a>>2]|0;if(!j){p=17;break}else{u=a;v=j}}else{if((e|0)>=(d|0)){p=21;break}w=a+4|0;e=f[w>>2]|0;if(!e){p=20;break}else{u=w;v=e}}g=u;a=v}if((p|0)==17){f[c>>2]=a;k=a;return k|0}else if((p|0)==20){f[c>>2]=a;k=w;return k|0}else if((p|0)==21){f[c>>2]=a;k=g;return k|0}}else x=t}else x=b;if(!n){f[c>>2]=h;k=h;return k|0}else{h=x;f[c>>2]=h;k=h+4|0;return k|0}return 0}function ava(a){a=a|0;O5b(a);return}function bva(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function cva(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=105376;b=a+36|0;c=f[b>>2]|0;if(!c){lua(a);return}d=a+40|0;while(1){e=f[d>>2]|0;if((e|0)==(c|0))break;g=e+-8|0;f[d>>2]=g;bD(g)}O5b(f[b>>2]|0);lua(a);return}function dva(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=105376;b=a+36|0;c=f[b>>2]|0;if(c|0){d=a+40|0;while(1){e=f[d>>2]|0;if((e|0)==(c|0))break;g=e+-8|0;f[d>>2]=g;bD(g)}O5b(f[b>>2]|0)}lua(a);O5b(a);return}function eva(a,b,c){a=a|0;b=b|0;c=c|0;return}function fva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function gva(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function hva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+36>>2]|0;d=f[a+40>>2]|0;a=c;e=d;a:do if((c|0)==(d|0))g=c;else{h=f[b>>2]|0;i=(h|0)==0?1124530:h;j=c;while(1){k=f[j>>2]|0;if((k|0)==(h|0)){g=j;break a}if(!(gTb((k|0)==0?1124530:k,i)|0)){g=j;break a}j=j+8|0;if((j|0)==(d|0)){g=d;break}}}while(0);d=g-a>>3;return ((d|0)<(e-a>>3|0)?d:-1)|0}function iva(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+32|0;a=g+16|0;h=g+8|0;i=g+4|0;j=g;k=c+4|0;l=f[k>>2]|0;m=f[c>>2]|0;if(((l-m|0)/12|0|0)==(d|0)){n=m;o=l}else{f[a>>2]=0;f[a+4>>2]=0;l=aD(a,32)|0;m=365242;d=l+32|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(d|0));bO(-215,a,442770,364488,287);bD(a);n=f[c>>2]|0;o=f[k>>2]|0}f[i>>2]=n;f[j>>2]=o;f[h>>2]=f[i>>2];f[a>>2]=f[j>>2];jva(e,h,a);u=g;return 0}function jva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[b>>2]|0;e=f[c>>2]|0;g=(e-d|0)/12|0;h=a+8|0;i=f[h>>2]|0;j=f[a>>2]|0;k=d;d=j;l=e;if(g>>>0>((i-j|0)/12|0)>>>0){if(!j)m=i;else{i=a+4|0;n=f[i>>2]|0;if((n|0)==(d|0))o=j;else{p=n;while(1){n=p+-12|0;f[i>>2]=n;q=f[n>>2]|0;if(!q)r=n;else{n=p+-8|0;s=f[n>>2]|0;if((s|0)!=(q|0))f[n>>2]=s+(~((s+-4-q|0)>>>2)<<2);O5b(q);r=f[i>>2]|0}if((r|0)==(d|0))break;else p=r}o=f[a>>2]|0}O5b(o);f[h>>2]=0;f[i>>2]=0;f[a>>2]=0;m=0}if(g>>>0>357913941)c4b(a);i=(m|0)/12|0;m=i<<1;o=i>>>0<178956970?(m>>>0<g>>>0?g:m):357913941;if(o>>>0>357913941)c4b(a);m=L5b(o*12|0)|0;i=a+4|0;f[i>>2]=m;f[a>>2]=m;f[h>>2]=m+(o*12|0);o=f[b>>2]|0;b=f[c>>2]|0;if((o|0)==(b|0))return;c=m;m=o;do{Bua(c,m);m=m+12|0;c=(f[i>>2]|0)+12|0;f[i>>2]=c}while((m|0)!=(b|0));return}else{b=a+4|0;a=((f[b>>2]|0)-j|0)/12|0;j=g>>>0>a>>>0;g=j?k+(a*12|0)|0:e;if((k|0)==(g|0))t=d;else{e=d;d=k;while(1){if((e|0)!=(d|0))r2(e,f[d>>2]|0,f[d+4>>2]|0);d=d+12|0;k=e+12|0;if((d|0)==(g|0)){t=k;break}else e=k}}if(j){if((g|0)==(l|0))return;j=f[b>>2]|0;e=g;do{Bua(j,e);e=e+12|0;j=(f[b>>2]|0)+12|0;f[b>>2]=j}while((e|0)!=(l|0));return}l=f[b>>2]|0;if((l|0)==(t|0))return;else u=l;while(1){l=u+-12|0;f[b>>2]=l;e=f[l>>2]|0;if(!e)v=l;else{l=u+-8|0;j=f[l>>2]|0;if((j|0)!=(e|0))f[l>>2]=j+(~((j+-4-e|0)>>>2)<<2);O5b(e);v=f[b>>2]|0}if((v|0)==(t|0))break;else u=v}return}}function kva(a){a=a|0;var b=0,c=0,d=0;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)bi[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=0;f[a+4>>2]=0;return}function lva(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;g=u;u=u+752|0;h=g+736|0;i=g+492|0;j=g+248|0;k=g+240|0;l=g;dQ(h,105488);m=c+4|0;n=f[m>>2]|0;a:do if((n|0)!=0?(o=f[c>>2]|0,p=o+n+-1|0,q=o,o>>>0<=p>>>0):0){r=o;while(1){if((b[r>>0]|0)==46)break;o=r+1|0;if(o>>>0>p>>>0){s=11;break a}else r=o}if((r-q|0)!=-1){f[j>>2]=0;p=j+4|0;f[p>>2]=0;aD(j,n+18|0)|0;o=f[j>>2]|0;t=o;v=365316;w=t+18|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));q=f[m>>2]|0;if(q|0)Vac(o+18|0,f[c>>2]|0,q|0)|0;f[i>>2]=0;f[i+4>>2]=0;aD(i,(f[p>>2]|0)+29|0)|0;q=f[p>>2]|0;if(!q)x=0;else{Vac(f[i>>2]|0,f[j>>2]|0,q|0)|0;x=f[p>>2]|0}t=(f[i>>2]|0)+x|0;v=365335;w=t+29|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-5,i,365365,364488,1714);bD(i);bD(j);y=-1}else s=11}else s=11;while(0);b:do if((s|0)==11){x=a+4|0;p=f[x>>2]|0;o=p+48|0;q=f[o>>2]|0;do if(q){r=f[c>>2]|0;z=(r|0)==0?1124530:r;A=r;B=o;C=q;c:while(1){D=C;while(1){E=f[D+16>>2]|0;if((E|0)==(r|0))break;if((gTb((E|0)==0?1124530:E,z)|0)>=0)break;E=f[D+4>>2]|0;if(!E){F=B;break c}else D=E}C=f[D>>2]|0;if(!C){F=D;break}else B=D}if((F|0)!=(o|0)){B=f[F+16>>2]|0;if((r|0)!=(B|0)?(gTb(z,(B|0)==0?1124530:B)|0)<=-1:0){G=A;break}if((f[F+24>>2]|0)>-1){f[j>>2]=0;B=j+4|0;f[B>>2]=0;aD(j,n+7|0)|0;C=f[j>>2]|0;b[C>>0]=b[365374]|0;b[C+1>>0]=b[365375]|0;b[C+2>>0]=b[365376]|0;b[C+3>>0]=b[365377]|0;b[C+4>>0]=b[365378]|0;b[C+5>>0]=b[365379]|0;b[C+6>>0]=b[365380]|0;C=f[m>>2]|0;if(C|0)Vac((f[j>>2]|0)+7|0,f[c>>2]|0,C|0)|0;f[i>>2]=0;f[i+4>>2]=0;aD(i,(f[B>>2]|0)+18|0)|0;C=f[B>>2]|0;if(!C)H=0;else{Vac(f[i>>2]|0,f[j>>2]|0,C|0)|0;H=f[B>>2]|0}t=(f[i>>2]|0)+H|0;v=365382;w=t+18|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-5,i,365365,364488,1720);bD(i);bD(j);y=-1;break b}else G=A}else G=A}else G=f[c>>2]|0;while(0);q=p+140|0;z=(f[q>>2]|0)+1|0;f[q>>2]=z;q=p+44|0;f[k>>2]=G;r=k+4|0;f[r>>2]=n;if(G){B=G+-4|0;f[B>>2]=(f[B>>2]|0)+1;B=f[k>>2]|0;C=f[r>>2]|0;f[j>>2]=B;r=j+4|0;f[r>>2]=C;if(B){E=B+-4|0;f[E>>2]=(f[E>>2]|0)+1;E=f[j>>2]|0;B=f[r>>2]|0;r=j+8|0;f[r>>2]=z;f[i>>2]=E;I=i+4|0;f[I>>2]=B;if(!E){J=z;K=i;L=I}else{B=E+-4|0;f[B>>2]=(f[B>>2]|0)+1;J=f[r>>2]|0;K=i;L=I}}else{M=C;s=31}}else{f[j>>2]=0;f[j+4>>2]=n;M=n;s=31}if((s|0)==31){f[j+8>>2]=z;f[i>>2]=0;C=i+4|0;f[C>>2]=M;J=z;K=i;L=C}C=i+8|0;f[C>>2]=J;I=f[o>>2]|0;d:do if(!I){N=o;O=o}else{r=p+48|0;B=f[i>>2]|0;E=(B|0)==0?1124530:B;P=f[I+16>>2]|0;e:do if((B|0)!=(P|0)){Q=r;R=I;S=P;while(1){T=(S|0)==0?1124530:S;if((gTb(E,T)|0)<0){U=f[R>>2]|0;if(!U){s=39;break}else{V=R;W=U}}else{if((gTb(T,E)|0)>=0){X=Q;Y=R;break e}Z=R+4|0;T=f[Z>>2]|0;if(!T){s=42;break}else{V=Z;W=T}}S=f[W+16>>2]|0;if((B|0)==(S|0)){X=V;Y=W;break e}else{Q=V;R=W}}if((s|0)==39){N=R;O=R;break d}else if((s|0)==42){N=Z;O=R;break d}}else{X=r;Y=I}while(0);N=X;O=Y}while(0);if(!(f[N>>2]|0)){I=L5b(28)|0;o=f[K>>2]|0;f[I+16>>2]=o;f[I+20>>2]=f[L>>2];if(!o)_=J;else{r=o+-4|0;f[r>>2]=(f[r>>2]|0)+1;_=f[C>>2]|0}f[I+24>>2]=_;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=O;f[N>>2]=I;r=f[f[q>>2]>>2]|0;if(!r)$=I;else{f[q>>2]=r;$=f[N>>2]|0}mP(f[p+48>>2]|0,$);r=p+52|0;f[r>>2]=(f[r>>2]|0)+1}bD(i);bD(j);bD(k);r=f[x>>2]|0;I=r+32|0;mva(l,z,c,d,e);f[j>>2]=z;o=j+4|0;Uua(o,l);f[i>>2]=f[j>>2];B=i+4|0;Uua(B,o);E=r+36|0;P=f[E>>2]|0;do if(P){A=f[i>>2]|0;Q=r+36|0;S=P;while(1){D=f[S+16>>2]|0;if((A|0)<(D|0)){T=f[S>>2]|0;if(!T){s=56;break}else{aa=S;ba=T}}else{if((D|0)>=(A|0)){s=60;break}ca=S+4|0;D=f[ca>>2]|0;if(!D){s=59;break}else{aa=ca;ba=D}}Q=aa;S=ba}if((s|0)==56){da=S;ea=S;break}else if((s|0)==59){da=ca;ea=S;break}else if((s|0)==60){da=Q;ea=S;break}}else{da=E;ea=E}while(0);if(!(f[da>>2]|0)){E=L5b(260)|0;f[E+16>>2]=f[i>>2];Uua(E+20|0,B);f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=ea;f[da>>2]=E;P=f[f[I>>2]>>2]|0;if(!P)fa=E;else{f[I>>2]=P;fa=f[da>>2]|0}mP(f[r+36>>2]|0,fa);P=r+40|0;f[P>>2]=(f[P>>2]|0)+1}Qua(B);Qua(o);Qua(l);y=z}while(0);if(!(f[h+4>>2]|0)){u=g;return y|0}u=g;return y|0}function mva(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+16|0;h=g;f[a>>2]=b;b=a+4|0;i=f[c>>2]|0;f[b>>2]=i;j=a+8|0;f[j>>2]=f[c+4>>2];if(i|0){c=i+-4|0;f[c>>2]=(f[c>>2]|0)+1}c=a+12|0;i=f[d>>2]|0;f[c>>2]=i;k=a+16|0;f[k>>2]=f[d+4>>2];if(i|0){d=i+-4|0;f[d>>2]=(f[d>>2]|0)+1}$ta(a+20|0,e);aua(a+32|0,e+12|0);d=a+44|0;i=f[e+24>>2]|0;f[d>>2]=i;l=a+48|0;f[l>>2]=f[e+28>>2];if(i|0){m=i+-4|0;f[m>>2]=(f[m>>2]|0)+1}m=a+52|0;i=f[e+32>>2]|0;f[m>>2]=i;n=a+56|0;f[n>>2]=f[e+36>>2];if(i|0){e=i+-4|0;f[e>>2]=(f[e>>2]|0)+1}f[a+60>>2]=0;f[a+64>>2]=0;f[a+68>>2]=0;f[a+76>>2]=0;f[a+80>>2]=0;f[a+72>>2]=a+76;f[a+88>>2]=0;f[a+92>>2]=0;f[a+84>>2]=a+88;e=a+212|0;f[a+216>>2]=0;f[a+220>>2]=0;i=a+216|0;o=a+96|0;p=o+116|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[e>>2]=i;f[a+228>>2]=0;f[a+232>>2]=0;f[a+224>>2]=a+228;f[a+236>>2]=0;dQ(h,105508);bD(d);a=f[b>>2]|0;if(!a)q=0;else{i=a+-4|0;f[i>>2]=(f[i>>2]|0)+1;q=f[b>>2]|0}f[d>>2]=q;f[l>>2]=f[j>>2];bD(m);j=f[c>>2]|0;if(!j)r=0;else{l=j+-4|0;f[l>>2]=(f[l>>2]|0)+1;r=f[c>>2]|0}f[m>>2]=r;f[n>>2]=f[k>>2];if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function nva(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;h=u;u=u+16|0;i=h;j=h+8|0;if((c|0)>=(e|0)){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,22)|0;l=365675;m=k+22|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,371919,364488,956);bD(i)}l=ova(a,c)|0;k=ova(a,e)|0;f[j>>2]=c;f[j+4>>2]=d;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];pva(k,g,i);g=l+84|0;k=l+88|0;j=f[k>>2]|0;do if(j){c=l+88|0;a=j;while(1){m=f[a+16>>2]|0;if((m|0)>(d|0)){n=f[a>>2]|0;if(!n){o=8;break}else{p=a;q=n}}else{if((m|0)>=(d|0)){o=12;break}r=a+4|0;m=f[r>>2]|0;if(!m){o=11;break}else{p=r;q=m}}c=p;a=q}if((o|0)==8){s=a;t=a;break}else if((o|0)==11){s=r;t=a;break}else if((o|0)==12){s=c;t=a;break}}else{s=k;t=k}while(0);if(!(f[s>>2]|0)){k=L5b(20)|0;f[k+16>>2]=d;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=t;f[s>>2]=k;t=f[f[g>>2]>>2]|0;if(!t)v=k;else{f[g>>2]=t;v=f[s>>2]|0}mP(f[l+88>>2]|0,v);v=l+92|0;f[v>>2]=(f[v>>2]|0)+1}f[i>>2]=e;f[i+4>>2]=d;d=l+100|0;e=f[d>>2]|0;if((e|0)==(f[l+104>>2]|0)){qva(l+96|0,i);u=h;return}else{l=i;i=f[l+4>>2]|0;v=e;f[v>>2]=f[l>>2];f[v+4>>2]=i;f[d>>2]=(f[d>>2]|0)+8;u=h;return}}function ova(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;e=c+8|0;g=a+36|0;a=f[g>>2]|0;if(a|0){h=g;i=a;a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(b|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)!=(g|0)?(f[k+16>>2]|0)<=(b|0):0){l=k;m=l+20|0;u=c;return m|0}}f[d>>2]=b;hO(e,365755,d);bO(-204,e,365792,364488,856);bD(e);l=g;m=l+20|0;u=c;return m|0}function pva(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+48|0;g=e+32|0;h=e+40|0;i=e+24|0;j=e+16|0;k=e+8|0;l=e;f[g>>2]=c;m=a+60|0;n=a+64|0;o=f[n>>2]|0;p=f[m>>2]|0;q=o-p>>3;r=p;do if((q|0)>(c|0)){p=r+(c<<3)|0;s=f[p>>2]|0;t=f[p+4>>2]|0;if((t|s|0)>=0){if((s|0)==(f[d>>2]|0)?(t|0)==(f[d+4>>2]|0):0)break;sva(l,g);f[k>>2]=0;t=k+4|0;f[t>>2]=0;s=l+4|0;aD(k,(f[s>>2]|0)+7|0)|0;p=f[k>>2]|0;b[p>>0]=b[365698]|0;b[p+1>>0]=b[365699]|0;b[p+2>>0]=b[365700]|0;b[p+3>>0]=b[365701]|0;b[p+4>>0]=b[365702]|0;b[p+5>>0]=b[365703]|0;b[p+6>>0]=b[365704]|0;p=f[s>>2]|0;if(p|0)Vac((f[k>>2]|0)+7|0,f[l>>2]|0,p|0)|0;f[j>>2]=0;p=j+4|0;f[p>>2]=0;aD(j,(f[t>>2]|0)+10|0)|0;s=f[t>>2]|0;if(!s)v=0;else{Vac(f[j>>2]|0,f[k>>2]|0,s|0)|0;v=f[t>>2]|0}t=(f[j>>2]|0)+v|0;s=365706;w=t+10|0;do{b[t>>0]=b[s>>0]|0;t=t+1|0;s=s+1|0}while((t|0)<(w|0));f[i>>2]=0;x=i+4|0;f[x>>2]=0;y=a+8|0;aD(i,(f[y>>2]|0)+(f[p>>2]|0)|0)|0;z=f[p>>2]|0;if(z|0)Vac(f[i>>2]|0,f[j>>2]|0,z|0)|0;z=f[y>>2]|0;if(z|0)Vac((f[i>>2]|0)+(f[p>>2]|0)|0,f[a+4>>2]|0,z|0)|0;f[h>>2]=0;f[h+4>>2]=0;aD(h,(f[x>>2]|0)+23|0)|0;z=f[x>>2]|0;if(!z)A=0;else{Vac(f[h>>2]|0,f[i>>2]|0,z|0)|0;A=f[x>>2]|0}t=(f[h>>2]|0)+A|0;s=365717;w=t+23|0;do{b[t>>0]=b[s>>0]|0;t=t+1|0;s=s+1|0}while((t|0)<(w|0));bO(-2,h,365741,364488,890);bD(h);bD(i);bD(j);bD(k);bD(l)}}else{s=c+1|0;t=o;if(s>>>0>q>>>0){rva(m,s-q|0);break}if(s>>>0<q>>>0?(w=r+(s<<3)|0,(t|0)!=(w|0)):0)f[n>>2]=t+(~((t+-8-w|0)>>>3)<<3)}while(0);n=d;d=f[n+4>>2]|0;r=(f[m>>2]|0)+(c<<3)|0;f[r>>2]=f[n>>2];f[r+4>>2]=d;u=e;return}function qva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;O5b(d);return}function rva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){Nac(g|0,-1,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)c4b(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;Nac(d|0,-1,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)Vac(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;O5b(h);return}function sva(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+160|0;e=d+136|0;g=d;h=g+56|0;i=g+4|0;f[g>>2]=18164;f[h>>2]=18184;RXb(g+56|0,i);f[g+128>>2]=0;f[g+132>>2]=-1;f[g>>2]=43248;f[h>>2]=43268;WXb(i);f[i>>2]=43284;h=g+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[g+52>>2]=16;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;qP(i,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);iYb(g,f[c>>2]|0)|0;sP(e,i);f[a>>2]=0;f[a+4>>2]=0;i=e+11|0;c=b[i>>0]|0;h=c<<24>>24<0?f[e+4>>2]|0:c&255;if(!h)j=c;else{c=aD(a,h)|0;Vac(c|0,((b[i>>0]|0)<0?f[e>>2]|0:e)|0,h|0)|0;j=b[i>>0]|0}if(j<<24>>24>=0){tP(g);u=d;return}O5b(f[e>>2]|0);tP(g);u=d;return}function tva(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;dQ(h,105528);nva(f[a+4>>2]|0,b,c,d,e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function uva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d+8|0;g=d;f[a>>2]=-1;h=a+4|0;f[h>>2]=-1;f[e>>2]=0;i=e+4|0;f[i>>2]=0;f[g>>2]=0;f[g+4>>2]=0;vva(c,e,g);a:do if(!(f[i>>2]|0)){f[a>>2]=0;j=0}else{c=b+48|0;k=f[c>>2]|0;do if(k|0){l=f[e>>2]|0;m=(l|0)==0?1124530:l;n=c;o=k;b:while(1){p=o;while(1){q=f[p+16>>2]|0;if((q|0)==(l|0))break;if((gTb((q|0)==0?1124530:q,m)|0)>=0)break;q=f[p+4>>2]|0;if(!q){r=n;break b}else p=q}o=f[p>>2]|0;if(!o){r=p;break}else n=p}if((r|0)!=(c|0)){n=f[r+16>>2]|0;if((l|0)!=(n|0)?(gTb(m,(n|0)==0?1124530:n)|0)<=-1:0)break;n=f[r+24>>2]|0;f[a>>2]=n;if((n|0)>-1){j=n;break a}bD(g);bD(e);u=d;return}}while(0);f[a>>2]=-1;bD(g);bD(e);u=d;return}while(0);a=wva(b,ova(b,j)|0,g)|0;f[h>>2]=a;bD(g);bD(e);u=d;return}function vva(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;h=a+4|0;i=f[h>>2]|0;a:do if((i|0)!=0?(j=f[a>>2]|0,k=j+i+-1|0,l=j,j>>>0<=k>>>0):0){m=j;while(1){if((b[m>>0]|0)==46)break;j=m+1|0;if(j>>>0>k>>>0){n=-1;break a}else m=j}n=m-l|0}else n=-1;while(0);f[g>>2]=0;k=g+4|0;f[k>>2]=0;j=i>>>0>n>>>0;o=j?n:i;do if(o|0)if(j){i=aD(g,o)|0;Vac(i|0,f[a>>2]|0,o|0)|0;break}else{i=(f[a>>2]|0)+-4|0;f[i>>2]=(f[i>>2]|0)+1;f[g>>2]=f[a>>2];f[k>>2]=f[h>>2];break}while(0);if((g|0)!=(c|0)){bD(c);o=f[g>>2]|0;if(!o)p=0;else{j=o+-4|0;f[j>>2]=(f[j>>2]|0)+1;p=f[g>>2]|0}f[c>>2]=p;f[c+4>>2]=f[k>>2]}bD(g);do if((n|0)!=-1){k=n+1|0;f[g>>2]=0;c=g+4|0;f[c>>2]=0;p=f[h>>2]|0;j=p>>>0<k>>>0?p:k;k=p-j|0;if(k|0)if(!j){p=(f[a>>2]|0)+-4|0;f[p>>2]=(f[p>>2]|0)+1;f[g>>2]=f[a>>2];f[c>>2]=f[h>>2];break}else{c=aD(g,k)|0;Vac(c|0,(f[a>>2]|0)+j|0,k|0)|0;break}}else{f[g>>2]=0;f[g+4>>2]=0}while(0);if((g|0)==(d|0)){bD(g);u=e;return}bD(d);a=f[g>>2]|0;if(!a)q=0;else{h=a+-4|0;f[h>>2]=(f[h>>2]|0)+1;q=f[g>>2]|0}f[d>>2]=q;f[d+4>>2]=f[g+4>>2];bD(g);u=e;return}function wva(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;a=u;u=u+32|0;e=a+16|0;g=a+8|0;h=a;i=d+4|0;if(!(f[i>>2]|0)){j=0;u=a;return j|0}k=f[d>>2]|0;if(((b[k>>0]|0)+-48|0)>>>0<10?(l=WVb((k|0)==0?1124530:k,e,10)|0,(b[f[e>>2]>>0]|0)==0):0){j=l;u=a;return j|0}xva(g,c);c=g+4|0;l=f[c>>2]|0;e=f[(f[l>>2]|0)+48>>2]|0;k=f[d>>2]|0;f[h>>2]=k;f[h+4>>2]=f[i>>2];if(k|0){i=k+-4|0;f[i>>2]=(f[i>>2]|0)+1}i=Uh[e&1023](l,h)|0;bD(h);h=f[g>>2]|0;if(h|0?(l=h+4|0,e=f[l>>2]|0,f[l>>2]=e+-1,(e|0)==1):0)bi[f[(f[h>>2]|0)+8>>2]&2047](h);f[g>>2]=0;f[c>>2]=0;j=i;u=a;return j|0}function xva(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+48|0;e=d+32|0;g=d+24|0;h=d+16|0;i=d+8|0;j=d;dQ(e,105548);k=c+132|0;l=c+136|0;m=f[l>>2]|0;if(!m){n=c+12|0;yva(g,n,c+20|0);o=f[g>>2]|0;p=f[g+4>>2]|0;if(o|0){q=o+4|0;f[q>>2]=(f[q>>2]|0)+1}q=f[k>>2]|0;f[k>>2]=o;f[l>>2]=p;if(q|0?(p=q+4|0,o=f[p>>2]|0,f[p>>2]=o+-1,(o|0)==1):0)bi[f[(f[q>>2]|0)+8>>2]&2047](q);q=f[g>>2]|0;if(q|0?(o=q+4|0,p=f[o>>2]|0,f[o>>2]=p+-1,(p|0)==1):0)bi[f[(f[q>>2]|0)+8>>2]&2047](q);q=f[l>>2]|0;p=q;if(!q){f[j>>2]=0;q=j+4|0;f[q>>2]=0;o=c+8|0;aD(j,(f[o>>2]|0)+20|0)|0;r=f[j>>2]|0;s=r;t=365873;v=s+20|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));w=f[o>>2]|0;if(w|0)Vac(r+20|0,f[c+4>>2]|0,w|0)|0;f[i>>2]=0;w=i+4|0;f[w>>2]=0;aD(i,(f[q>>2]|0)+11|0)|0;r=f[q>>2]|0;if(!r)x=0;else{Vac(f[i>>2]|0,f[j>>2]|0,r|0)|0;x=f[q>>2]|0}s=(f[i>>2]|0)+x|0;t=365894;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));f[h>>2]=0;t=h+4|0;f[t>>2]=0;s=c+16|0;aD(h,(f[s>>2]|0)+(f[w>>2]|0)|0)|0;c=f[w>>2]|0;if(c|0)Vac(f[h>>2]|0,f[i>>2]|0,c|0)|0;c=f[s>>2]|0;if(c|0)Vac((f[h>>2]|0)+(f[w>>2]|0)|0,f[n>>2]|0,c|0)|0;f[g>>2]=0;f[g+4>>2]=0;aD(g,(f[t>>2]|0)+1|0)|0;c=f[t>>2]|0;if(!c)y=0;else{Vac(f[g>>2]|0,f[h>>2]|0,c|0)|0;y=f[t>>2]|0}b[(f[g>>2]|0)+y>>0]=34;bO(-2,g,365906,364488,257);bD(g);bD(h);bD(i);bD(j);z=f[l>>2]|0}else z=p;p=f[k>>2]|0;f[a>>2]=p;f[a+4>>2]=z;if(p|0){z=p+4|0;f[z>>2]=(f[z>>2]|0)+1}}else{z=f[k>>2]|0;f[a>>2]=z;f[a+4>>2]=m;if(z|0){m=z+4|0;f[m>>2]=(f[m>>2]|0)+1}}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function yva(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;dQ(h,105580);j=zva()|0;PO(j);k=f[c>>2]|0;if(!k){f[i>>2]=0;f[i+4>>2]=0}else{l=c+4|0;m=f[l>>2]|0;f[g>>2]=0;n=g+4|0;f[n>>2]=0;if(m|0?(Vac(aD(g,m)|0,k|0,m|0)|0,f[l>>2]|0):0){m=0;do{k=(gVb(b[(f[c>>2]|0)+m>>0]|0)|0)&255;b[(f[g>>2]|0)+m>>0]=k;m=m+1|0}while(m>>>0<(f[l>>2]|0)>>>0)}l=f[g>>2]|0;f[i>>2]=l;f[i+4>>2]=f[n>>2];if(l|0){n=l+-4|0;f[n>>2]=(f[n>>2]|0)+1}bD(g)}g=(Ava()|0)+4|0;n=f[g>>2]|0;if(n){l=f[i>>2]|0;m=(l|0)==0?1124530:l;c=g;k=n;a:while(1){n=k;while(1){o=f[n+16>>2]|0;if((o|0)==(l|0))break;if((gTb((o|0)==0?1124530:o,m)|0)>=0)break;o=f[n+4>>2]|0;if(!o){p=c;break a}else n=o}k=f[n>>2]|0;if(!k){p=n;break}else c=n}if((p|0)!=(g|0)){c=f[p+16>>2]|0;if((l|0)!=(c|0)?(gTb(m,(c|0)==0?1124530:c)|0)<0:0)q=21;else r=p}else q=21}else q=21;if((q|0)==21)r=g;if((r|0)==((Ava()|0)+4|0)){f[a>>2]=0;f[a+4>>2]=0}else zh[f[r+24>>2]&2047](a,d);bD(i);QO(j);if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function zva(){var a=0,b=0,c=0;if(f[212916]|0){a=f[212916]|0;return a|0}b=C9a()|0;PO(b);if(!(f[212916]|0)){c=L5b(4)|0;NO(c);f[212916]=c}QO(b);a=f[212916]|0;return a|0}function Ava(){var a=0,c=0;if(f[212912]|0){a=f[212912]|0;return a|0}c=zva()|0;PO(c);if(!(f[212912]|0)){if((b[491768]|0)==0?Cac(491768)|0:0){f[212914]=0;f[212915]=0;f[212913]=851656;zd(1477,851652,x|0)|0}f[212912]=851652;D9a()}QO(c);a=f[212912]|0;return a|0}function Bva(a){a=a|0;Cva(a,f[a+4>>2]|0);return}function Cva(a,b){a=a|0;b=b|0;if(!b)return;Cva(a,f[b>>2]|0);Cva(a,f[b+4>>2]|0);bD(b+16|0);O5b(b);return}function Dva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+64|0;e=d+40|0;g=d+32|0;h=d+24|0;i=d+8|0;j=d;dQ(g,105612);k=f[c>>2]|0;f[h>>2]=k;l=h+4|0;m=f[c+4>>2]|0;f[l>>2]=m;if(!k)n=m;else{m=k+-4|0;f[m>>2]=(f[m>>2]|0)+1;n=f[l>>2]|0}if(!n){Eva(i,b);n=i+4|0;m=f[n>>2]|0;k=m+-8|0;if((k|0)!=(h|0)){bD(h);c=f[k>>2]|0;if(!c)o=0;else{p=c+-4|0;f[p>>2]=(f[p>>2]|0)+1;o=f[k>>2]|0}f[h>>2]=o;f[l>>2]=f[m+-4>>2]}m=f[i>>2]|0;if(m|0){while(1){o=f[n>>2]|0;if((o|0)==(m|0))break;k=o+-8|0;f[n>>2]=k;bD(k)}O5b(f[i>>2]|0)}}i=b+4|0;b=f[i>>2]|0;f[e>>2]=0;n=e+4|0;f[n>>2]=0;f[e+8>>2]=0;Fva(b,e);b=f[e>>2]|0;if(b|0){m=f[n>>2]|0;if((m|0)!=(b|0))f[n>>2]=m+(~((m+-8-b|0)>>>3)<<3);O5b(b)}b=f[i>>2]|0;Hva(b,Gva(b,h)|0,1);b=f[i>>2]|0;i=f[h>>2]|0;f[j>>2]=i;f[j+4>>2]=f[l>>2];if(i|0){l=i+-4|0;f[l>>2]=(f[l>>2]|0)+1}uva(e,b,j);Iva(a,b,e);bD(j);bD(h);if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function Eva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;zwa(a,f[(f[d>>2]|0)+40>>2]|0);b=f[d>>2]|0;e=f[b+32>>2]|0;if((e|0)==(b+36|0))return;b=a+8|0;g=e;while(1){do if(f[g+20>>2]|0){e=g+24|0;h=f[c>>2]|0;if((h|0)==(f[b>>2]|0)){awa(a,e);break}i=f[e>>2]|0;f[h>>2]=i;f[h+4>>2]=f[g+28>>2];if(!i)j=h;else{h=i+-4|0;f[h>>2]=(f[h>>2]|0)+1;j=f[c>>2]|0}f[c>>2]=j+8}while(0);h=f[g+4>>2]|0;if(!h){i=g+8|0;e=f[i>>2]|0;if((f[e>>2]|0)==(g|0))k=e;else{e=i;do{i=f[e>>2]|0;e=i+8|0;l=f[e>>2]|0}while((f[l>>2]|0)!=(i|0));k=l}}else{e=h;while(1){l=f[e>>2]|0;if(!l)break;else e=l}k=e}if((k|0)==((f[d>>2]|0)+36|0))break;else g=k}return}function Fva(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d+8|0;g=d;dQ(e,105692);h=a+144|0;a:do if((b[h>>0]|0)!=0?(i=f[a+24>>2]|0,j=f[a+20>>2]|0,k=f[c>>2]|0,l=j,m=i,(i-j|0)==((f[c+4>>2]|0)-k|0)):0){if((l|0)!=(m|0)){j=l;l=k;while(1){if((f[j>>2]|0)!=(f[l>>2]|0)){n=8;break a}if((f[j+4>>2]|0)!=(f[l+4>>2]|0)){n=8;break a}j=j+8|0;if((j|0)==(m|0))break;else l=l+8|0}}}else n=8;while(0);if((n|0)==8){Mva(a);Nva(a,c);Ova(a);Pva(a);if((b[h>>0]|0)==0?(f[a+112>>2]|0)==1:0){f[g>>2]=0;f[g+4>>2]=0;n=aD(g,39)|0;l=366747;m=n+39|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(m|0));bO(-215,g,366787,364488,813);bD(g)}b[h>>0]=1;h=a+20|0;if((h|0)!=(c|0))Qva(h,f[c>>2]|0,f[c+4>>2]|0)}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function Gva(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d+8|0;g=d;h=a+48|0;i=f[h>>2]|0;do if(i){j=f[c>>2]|0;k=(j|0)==0?1124530:j;l=h;m=i;a:while(1){n=m;while(1){o=f[n+16>>2]|0;if((o|0)==(j|0))break;if((gTb((o|0)==0?1124530:o,k)|0)>=0)break;o=f[n+4>>2]|0;if(!o){p=l;break a}else n=o}m=f[n>>2]|0;if(!m){p=n;break}else l=n}if((p|0)!=(h|0)){l=f[p+16>>2]|0;if((j|0)!=(l|0)?(gTb(k,(l|0)==0?1124530:l)|0)<=-1:0){q=-1;break}l=f[p+24>>2]|0;if((l|0)<0)q=l;else{r=l;s=ova(a,r)|0;u=d;return s|0}}else q=-1}else q=-1;while(0);f[g>>2]=0;p=g+4|0;f[p>>2]=0;h=c+4|0;aD(g,(f[h>>2]|0)+16|0)|0;i=f[g>>2]|0;l=i;m=366718;o=l+16|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));t=f[h>>2]|0;if(t|0)Vac(i+16|0,f[c>>2]|0,t|0)|0;f[e>>2]=0;f[e+4>>2]=0;aD(e,(f[p>>2]|0)+11|0)|0;t=f[p>>2]|0;if(!t)v=0;else{Vac(f[e>>2]|0,f[g>>2]|0,t|0)|0;v=f[p>>2]|0}l=(f[e>>2]|0)+v|0;m=366735;o=l+11|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));bO(-2,e,365792,364488,866);bD(e);bD(g);r=q;s=ova(a,r)|0;u=d;return s|0}function Hva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;dQ(e,105652);if(c?(c=f[a+32>>2]|0,g=a+36|0,(c|0)!=(g|0)):0){h=c;while(1){f[h+256>>2]=0;c=f[h+4>>2]|0;if(!c){i=h+8|0;j=f[i>>2]|0;if((f[j>>2]|0)==(h|0))k=j;else{j=i;do{i=f[j>>2]|0;j=i+8|0;l=f[j>>2]|0}while((f[l>>2]|0)!=(i|0));k=l}}else{j=c;while(1){l=f[j>>2]|0;if(!l)break;else j=l}k=j}if((k|0)==(g|0))break;else h=k}}if(!(f[b+236>>2]|0)){k=f[a+32>>2]|0;h=a+36|0;a:do if((k|0)!=(h|0)){g=k;while(1){c=g+20|0;if((f[c>>2]|0)>=(f[b>>2]|0))break a;if(!(f[g+256>>2]|0))Lva(a,c);c=f[g+4>>2]|0;if(!c){l=g+8|0;i=f[l>>2]|0;if((f[i>>2]|0)==(g|0))m=i;else{i=l;do{l=f[i>>2]|0;i=l+8|0;n=f[i>>2]|0}while((f[n>>2]|0)!=(l|0));m=n}}else{i=c;while(1){n=f[i>>2]|0;if(!n)break;else i=n}m=i}if((m|0)==(h|0))break;else g=m}}while(0);Lva(a,b)}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function Iva(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=u;u=u+96|0;g=e+80|0;h=e+64|0;i=e+56|0;j=e+48|0;k=e+40|0;l=e+32|0;m=e+24|0;n=e+16|0;o=e+8|0;p=e;dQ(g,105632);if(!((f[d>>2]|0)>-1?(f[d+4>>2]|0)>-1:0)){f[h>>2]=0;f[h+4>>2]=0;q=aD(h,24)|0;r=366206;s=q+24|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-204,h,366231,364488,1645);bD(h)}t=Jva(c+32|0,d)|0;v=d+4|0;d=t+140|0;w=t+144|0;if((f[v>>2]|0)>>>0>=(((f[w>>2]|0)-(f[d>>2]|0)|0)/56|0)>>>0){f[m>>2]=0;x=m+4|0;f[x>>2]=0;y=t+8|0;aD(m,(f[y>>2]|0)+7|0)|0;z=f[m>>2]|0;b[z>>0]=b[365374]|0;b[z+1>>0]=b[365375]|0;b[z+2>>0]=b[365376]|0;b[z+3>>0]=b[365377]|0;b[z+4>>0]=b[365378]|0;b[z+5>>0]=b[365379]|0;b[z+6>>0]=b[365380]|0;z=f[y>>2]|0;if(z|0)Vac((f[m>>2]|0)+7|0,f[t+4>>2]|0,z|0)|0;f[l>>2]=0;z=l+4|0;f[z>>2]=0;aD(l,(f[x>>2]|0)+15|0)|0;y=f[x>>2]|0;if(!y)A=0;else{Vac(f[l>>2]|0,f[m>>2]|0,y|0)|0;A=f[x>>2]|0}q=(f[l>>2]|0)+A|0;r=366239;s=q+15|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));f[o>>2]=((f[w>>2]|0)-(f[d>>2]|0)|0)/56|0;Kva(n,o);f[k>>2]=0;o=k+4|0;f[o>>2]=0;w=n+4|0;aD(k,(f[w>>2]|0)+(f[z>>2]|0)|0)|0;A=f[z>>2]|0;if(A|0)Vac(f[k>>2]|0,f[l>>2]|0,A|0)|0;A=f[w>>2]|0;if(A|0)Vac((f[k>>2]|0)+(f[z>>2]|0)|0,f[n>>2]|0,A|0)|0;f[j>>2]=0;A=j+4|0;f[A>>2]=0;aD(j,(f[o>>2]|0)+15|0)|0;z=f[o>>2]|0;if(!z)B=0;else{Vac(f[j>>2]|0,f[k>>2]|0,z|0)|0;B=f[o>>2]|0}q=(f[j>>2]|0)+B|0;r=366255;s=q+15|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));sva(p,v);f[i>>2]=0;B=i+4|0;f[B>>2]=0;o=p+4|0;aD(i,(f[o>>2]|0)+(f[A>>2]|0)|0)|0;z=f[A>>2]|0;if(z|0)Vac(f[i>>2]|0,f[j>>2]|0,z|0)|0;z=f[o>>2]|0;if(z|0)Vac((f[i>>2]|0)+(f[A>>2]|0)|0,f[p>>2]|0,z|0)|0;f[h>>2]=0;f[h+4>>2]=0;aD(h,(f[B>>2]|0)+13|0)|0;z=f[B>>2]|0;if(!z)C=0;else{Vac(f[h>>2]|0,f[i>>2]|0,z|0)|0;C=f[B>>2]|0}q=(f[h>>2]|0)+C|0;r=366271;s=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-211,h,366231,364488,1651);bD(h);bD(i);bD(p);bD(j);bD(k);bD(n);bD(l);bD(m)}if(!(f[c+112>>2]|0)){if((f[c+116>>2]|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;q=aD(h,75)|0;r=366285;s=q+75|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-215,h,366231,364488,1660);bD(h)}}else{r=f[(f[t+108>>2]|0)+(f[v>>2]<<3)+4>>2]|0;bi[f[(f[r>>2]|0)+8>>2]&2047](r)}r=f[t+176>>2]|0;q=r;if((f[t+180>>2]|0)!=(r|0)?(r=f[v>>2]|0,f[q+(r*48|0)+24>>2]|0):0){t=f[q+(r*48|0)+4>>2]|0;if((t|0)<3)D=Y(f[q+(r*48|0)+12>>2]|0,f[q+(r*48|0)+8>>2]|0)|0;else{s=f[q+(r*48|0)+32>>2]|0;c=0;m=1;while(1){l=Y(f[s+(c<<2)>>2]|0,m)|0;c=c+1|0;if((c|0)==(t|0)){D=l;break}else m=l}}if(!((t|0)==0|(D|0)==0)){D=(f[d>>2]|0)+(r*56|0)|0;t=h+8|0;f[t>>2]=0;f[t+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=D;oI(q+(r*48|0)|0,h)}}h=f[v>>2]|0;v=f[d>>2]|0;d=v+(h*56|0)|0;f[a>>2]=f[d>>2];r=a+4|0;q=v+(h*56|0)+4|0;f[r>>2]=f[q>>2];D=a+8|0;f[D>>2]=f[v+(h*56|0)+8>>2];f[a+12>>2]=f[v+(h*56|0)+12>>2];f[a+16>>2]=f[v+(h*56|0)+16>>2];f[a+20>>2]=f[v+(h*56|0)+20>>2];f[a+24>>2]=f[v+(h*56|0)+24>>2];f[a+28>>2]=f[v+(h*56|0)+28>>2];f[a+32>>2]=f[v+(h*56|0)+32>>2];t=f[v+(h*56|0)+36>>2]|0;f[a+36>>2]=t;f[a+40>>2]=D;D=a+48|0;m=a+44|0;f[m>>2]=D;f[D>>2]=0;f[a+52>>2]=0;if(t|0){D=t+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[q>>2]|0)<3){q=f[v+(h*56|0)+44>>2]|0;h=f[m>>2]|0;f[h>>2]=f[q>>2];f[h+4>>2]=f[q+4>>2]}else{f[r>>2]=0;jL(a,d)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Jva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;c=a+4|0;d=f[c>>2]|0;do if(d){e=f[b>>2]|0;g=a+4|0;h=d;i=d;while(1){j=f[h+16>>2]|0;if((e|0)<(j|0)){k=f[h>>2]|0;if(!k){l=6;break}else{m=h;n=k}}else{if((j|0)>=(e|0)){l=10;break}o=h+4|0;j=f[o>>2]|0;if(!j){l=9;break}else{m=o;n=j}}g=m;h=n;i=n}if((l|0)==6){p=h;q=h;break}else if((l|0)==9){p=o;q=h;break}else if((l|0)==10){r=g;s=h;t=i;l=12;break}}else{r=c;s=c;t=d;l=12}while(0);if((l|0)==12)if(!t){p=r;q=s}else{u=t;v=u+20|0;return v|0}t=L5b(260)|0;f[t+16>>2]=f[b>>2];f[t+20>>2]=-1;b=t+24|0;s=t+44|0;f[s>>2]=0;f[t+48>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[t+40>>2]=s;s=t+96|0;f[s>>2]=0;f[t+100>>2]=0;b=t+92|0;r=t+52|0;l=r+40|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(l|0));f[b>>2]=s;s=t+108|0;f[s>>2]=0;f[t+112>>2]=0;f[t+104>>2]=s;s=t+236|0;f[s>>2]=0;f[t+240>>2]=0;b=t+232|0;r=t+116|0;l=r+116|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(l|0));f[b>>2]=s;s=t+248|0;f[s>>2]=0;f[t+252>>2]=0;f[t+244>>2]=s;f[t+256>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=q;f[p>>2]=t;q=f[f[a>>2]>>2]|0;if(!q)w=t;else{f[a>>2]=q;w=f[p>>2]|0}mP(f[a+4>>2]|0,w);w=a+8|0;f[w>>2]=(f[w>>2]|0)+1;u=t;v=u+20|0;return v|0}function Kva(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+160|0;e=d+136|0;g=d;h=g+56|0;i=g+4|0;f[g>>2]=18164;f[h>>2]=18184;RXb(g+56|0,i);f[g+128>>2]=0;f[g+132>>2]=-1;f[g>>2]=43248;f[h>>2]=43268;WXb(i);f[i>>2]=43284;h=g+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[g+52>>2]=16;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;qP(i,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);jYb(g,f[c>>2]|0)|0;sP(e,i);f[a>>2]=0;f[a+4>>2]=0;i=e+11|0;c=b[i>>0]|0;h=c<<24>>24<0?f[e+4>>2]|0:c&255;if(!h)j=c;else{c=aD(a,h)|0;Vac(c|0,((b[i>>0]|0)<0?f[e>>2]|0:e)|0,h|0)|0;j=b[i>>0]|0}if(j<<24>>24>=0){tP(g);u=d;return}O5b(f[e>>2]|0);tP(g);u=d;return}function Lva(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;d=u;u=u+64|0;e=d+48|0;g=d+32|0;h=d+16|0;i=d;dQ(e,105672);j=f[c+132>>2]|0;k=f[c+136>>2]|0;l=(j|0)==0;if(!l){m=j+4|0;f[m>>2]=(f[m>>2]|0)+1}m=JO()|0;n=J;o=a+112|0;p=f[o>>2]|0;if((p|0)!=0?Uh[f[(f[k>>2]|0)+52>>2]&1023](k,p)|0:0){p=c+224|0;q=c+228|0;r=f[q>>2]|0;do if(r){s=f[o>>2]|0;t=c+228|0;v=r;w=r;while(1){x=f[v+16>>2]|0;if((s|0)<(x|0)){y=f[v>>2]|0;if(!y){z=42;break}else{A=v;B=y}}else{if((x|0)>=(s|0)){z=46;break}C=v+4|0;x=f[C>>2]|0;if(!x){z=45;break}else{A=C;B=x}}t=A;v=B;w=B}if((z|0)==42){D=v;E=v;z=49;break}else if((z|0)==45){D=C;E=v;z=49;break}else if((z|0)==46){F=t;G=v;H=w;z=48;break}}else{F=q;G=q;H=r;z=48}while(0);if((z|0)==48)if(!H){D=F;E=G;z=49}else I=H;if((z|0)==49){H=L5b(24)|0;f[H+16>>2]=f[o>>2];b[H+20>>0]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=E;f[D>>2]=H;E=f[f[p>>2]>>2]|0;if(!E)K=H;else{f[p>>2]=E;K=f[D>>2]|0}mP(f[c+228>>2]|0,K);K=c+232|0;f[K>>2]=(f[K>>2]|0)+1;I=H}if(!(b[I+20>>0]|0)){I=c+212|0;H=c+216|0;K=f[H>>2]|0;do if(K){D=f[o>>2]|0;E=c+216|0;p=K;G=K;while(1){F=f[p+16>>2]|0;if((D|0)<(F|0)){r=f[p>>2]|0;if(!r){z=58;break}else{L=p;M=r}}else{if((F|0)>=(D|0)){z=62;break}N=p+4|0;F=f[N>>2]|0;if(!F){z=61;break}else{L=N;M=F}}E=L;p=M;G=M}if((z|0)==58){O=p;P=p;z=65;break}else if((z|0)==61){O=N;P=p;z=65;break}else if((z|0)==62){Q=E;R=p;S=G;z=64;break}}else{Q=H;R=H;S=K;z=64}while(0);if((z|0)==64)if(!S){O=Q;P=R;z=65}else T=S;if((z|0)==65){S=L5b(28)|0;f[S+16>>2]=f[o>>2];f[S+20>>2]=0;f[S+24>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=P;f[O>>2]=S;P=f[f[I>>2]>>2]|0;if(!P)U=S;else{f[I>>2]=P;U=f[O>>2]|0}mP(f[c+216>>2]|0,U);U=c+220|0;f[U>>2]=(f[U>>2]|0)+1;T=S}S=f[T+20>>2]|0;f[g>>2]=S;f[g+4>>2]=f[T+24>>2];if(S|0){T=S+4|0;f[T>>2]=(f[T>>2]|0)+1}if((f[o>>2]|0)!=1){f[h>>2]=0;f[h+4>>2]=0;T=aD(h,26)|0;S=366466;U=T+26|0;do{b[T>>0]=b[S>>0]|0;T=T+1|0;S=S+1|0}while((T|0)<(U|0));bO(-213,h,366493,364488,1536);bD(h)}S=f[g>>2]|0;if(S|0?(T=S+4|0,U=f[T>>2]|0,f[T>>2]=U+-1,(U|0)==1):0)bi[f[(f[S>>2]|0)+8>>2]&2047](S);V=m;W=n}else{V=m;W=n}}else z=5;a:do if((z|0)==5){S=c+224|0;U=c+228|0;T=f[U>>2]|0;do if(T){O=c+228|0;P=T;I=T;while(1){R=f[P+16>>2]|0;if((R|0)>0){Q=f[P>>2]|0;if(!Q){z=10;break}else{X=P;Y=Q}}else{if((R|0)>=0){z=14;break}Z=P+4|0;R=f[Z>>2]|0;if(!R){z=13;break}else{X=Z;Y=R}}O=X;P=Y;I=Y}if((z|0)==10){_=P;$=P;z=17;break}else if((z|0)==13){_=Z;$=P;z=17;break}else if((z|0)==14){aa=O;ba=P;ca=I;z=16;break}}else{aa=U;ba=U;ca=T;z=16}while(0);if((z|0)==16)if(!ca){_=aa;$=ba;z=17}else da=ca;if((z|0)==17){T=L5b(24)|0;f[T+16>>2]=0;b[T+20>>0]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=$;f[_>>2]=T;U=f[f[S>>2]>>2]|0;if(!U)ea=T;else{f[S>>2]=U;ea=f[_>>2]|0}mP(f[c+228>>2]|0,ea);U=c+232|0;f[U>>2]=(f[U>>2]|0)+1;da=T}if(!(b[da+20>>0]|0)){T=c+120|0;U=f[T>>2]|0;G=(f[c+124>>2]|0)-U|0;p=G>>3;b:do if((G|0)>0){E=0;R=U;while(1){Q=f[R+(E<<3)+4>>2]|0;if(Q|0)bi[f[(f[Q>>2]|0)+8>>2]&2047](Q);Q=E+1|0;if((Q|0)>=(p|0))break b;E=Q;R=f[T>>2]|0}}while(0);if((f[o>>2]|0)==0?(f[a+116>>2]|0)==1:0){T=f[(f[k>>2]|0)+40>>2]|0;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=17498112;f[g+4>>2]=c+188;p=h+8|0;f[p>>2]=0;f[p+4>>2]=0;f[h>>2]=34275328;f[h+4>>2]=c+176;p=i+8|0;f[p>>2]=0;f[p+4>>2]=0;f[i>>2]=34275328;f[i+4>>2]=c+200;th[T&511](k,g,h,i)}else th[f[(f[k>>2]|0)+36>>2]&511](k,c+152|0,c+140|0,c+164|0);T=c+108|0;p=f[T>>2]|0;U=(f[c+112>>2]|0)-p|0;G=U>>3;if((U|0)>0){U=0;S=p;while(1){p=f[S+(U<<3)+4>>2]|0;if(p|0)bi[f[(f[p>>2]|0)+12>>2]&2047](p);p=U+1|0;if((p|0)>=(G|0)){V=m;W=n;break a}U=p;S=f[T>>2]|0}}else{V=m;W=n}}else{V=0;W=0}}while(0);n=JO()|0;m=(V|0)==0&(W|0)==0;k=Jac(n|0,J|0,V|0,W|0)|0;W=(f[a+148>>2]|0)+(f[c>>2]<<3)|0;f[W>>2]=m?0:k;f[W+4>>2]=m?0:J;f[c+236>>2]=1;c=j;if(!l?(l=c+4|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)bi[f[(f[j>>2]|0)+8>>2]&2047](c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function Mva(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=u;u=u+16|0;d=c+8|0;e=c;dQ(d,105852);g=f[a+32>>2]|0;h=a+36|0;if((g|0)!=(h|0)){i=g;while(1){a:do if(f[i+20>>2]|0){g=f[i+172>>2]|0;j=i+176|0;k=f[j>>2]|0;if((k|0)!=(g|0))f[j>>2]=k+(~((k+-4-g|0)>>>2)<<2);g=f[i+160>>2]|0;k=i+164|0;j=f[k>>2]|0;if((j|0)!=(g|0)){l=j;do{j=l+-56|0;f[k>>2]=j;m=l+-20|0;n=f[m>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)kL(j);f[m>>2]=0;m=l+-40|0;j=l+-52|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[j>>2]|0)>0){m=f[l+-16>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[j>>2]|0))}j=f[l+-12>>2]|0;if((j|0)!=(l+-8|0))UC(j);l=f[k>>2]|0}while((l|0)!=(g|0))}g=f[i+184>>2]|0;l=i+188|0;k=f[l>>2]|0;if((k|0)!=(g|0)){j=k;do{k=j+-56|0;f[l>>2]=k;n=j+-20|0;m=f[n>>2]|0;if(m|0?(o=m+12|0,m=f[o>>2]|0,f[o>>2]=m+-1,(m|0)==1):0)kL(k);f[n>>2]=0;n=j+-40|0;k=j+-52|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[k>>2]|0)>0){n=f[j+-16>>2]|0;m=0;do{f[n+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[j+-12>>2]|0;if((k|0)!=(j+-8|0))UC(k);j=f[l>>2]|0}while((j|0)!=(g|0))}g=f[i+208>>2]|0;j=i+212|0;while(1){l=f[j>>2]|0;if((l|0)==(g|0))break;k=l+-48|0;f[j>>2]=k;hI(k)}j=f[i+196>>2]|0;g=i+200|0;while(1){k=f[g>>2]|0;if((k|0)==(j|0))break;l=k+-48|0;f[g>>2]=l;hI(l)}g=f[i+220>>2]|0;j=i+224|0;while(1){l=f[j>>2]|0;if((l|0)==(g|0))break a;k=l+-48|0;f[j>>2]=k;hI(k)}}while(0);j=i+244|0;g=i+248|0;Rua(j,f[g>>2]|0);f[i+252>>2]=0;f[j>>2]=g;f[g>>2]=0;g=f[i+152>>2]|0;j=f[i+156>>2]|0;k=(g|0)==0;if(!k){l=g+4|0;f[l>>2]=(f[l>>2]|0)+1}if(!j){if(!k){p=g;q=45}}else{bi[f[(f[j>>2]|0)+80>>2]&2047](j);l=T6b(j,17800,17944,0)|0;if(!k){j=g+4|0;f[j>>2]=(f[j>>2]|0)+1}if(l|0)b[l+65>>0]=1;l=g;if(!k){k=l+4|0;j=f[k>>2]|0;f[k>>2]=j+-1;if((j|0)==1){bi[f[(f[g>>2]|0)+8>>2]&2047](l);p=l;q=45}else{p=l;q=45}}}if((q|0)==45?(q=0,l=p+4|0,j=f[l>>2]|0,f[l>>2]=j+-1,(j|0)==1):0)bi[f[(f[g>>2]|0)+8>>2]&2047](p);g=f[i+4>>2]|0;if(!g){j=i+8|0;l=f[j>>2]|0;if((f[l>>2]|0)==(i|0))r=l;else{l=j;do{j=f[l>>2]|0;l=j+8|0;k=f[l>>2]|0}while((f[k>>2]|0)!=(j|0));r=k}}else{l=g;while(1){k=f[l>>2]|0;if(!k)break;else l=k}r=l}if((r|0)==(h|0))break;else i=r}}r=f[h>>2]|0;if(r){i=h;p=r;b:while(1){r=p;while(1){if((f[r+16>>2]|0)>=0)break;g=f[r+4>>2]|0;if(!g){s=i;break b}else r=g}p=f[r>>2]|0;if(!p){s=r;break}else i=r}if((s|0)!=(h|0)?(f[s+16>>2]|0)<=0:0)t=s;else q=60}else q=60;if((q|0)==60){f[e>>2]=0;f[e+4>>2]=0;s=aD(e,18)|0;i=368678;p=s+18|0;do{b[s>>0]=b[i>>0]|0;s=s+1|0;i=i+1|0}while((s|0)<(p|0));bO(-215,e,368697,364488,789);bD(e);t=h}h=t+244|0;e=t+248|0;i=f[e>>2]|0;do if(i){s=t+248|0;p=i;l=i;while(1){g=f[p+16>>2]|0;if((g|0)>0){k=f[p>>2]|0;if(!k){q=66;break}else{v=p;w=k}}else{if((g|0)>=0){q=70;break}x=p+4|0;g=f[x>>2]|0;if(!g){q=69;break}else{v=x;w=g}}s=v;p=w;l=w}if((q|0)==66){y=p;z=p;q=73;break}else if((q|0)==69){y=x;z=p;q=73;break}else if((q|0)==70){A=s;B=p;C=l;q=72;break}}else{A=e;B=e;C=i;q=72}while(0);if((q|0)==72)if(!C){y=A;z=B;q=73}else D=C;if((q|0)==73){q=L5b(24)|0;f[q+16>>2]=0;b[q+20>>0]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=z;f[y>>2]=q;z=f[f[h>>2]>>2]|0;if(!z)E=q;else{f[h>>2]=z;E=f[y>>2]|0}mP(f[t+248>>2]|0,E);E=t+252|0;f[E>>2]=(f[E>>2]|0)+1;D=q}b[D+20>>0]=1;D=f[a+148>>2]|0;q=a+152|0;a=f[q>>2]|0;if((a|0)!=(D|0))f[q>>2]=a+(~((a+-8-D|0)>>>3)<<3);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function Nva(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0;d=u;u=u+48|0;e=d+32|0;g=d+20|0;h=d+8|0;i=d;dQ(e,105752);j=a+32|0;k=f[j>>2]|0;l=a+36|0;if((k|0)!=(l|0)){m=k;while(1){f[m+256>>2]=0;k=f[m+4>>2]|0;if(!k){n=m+8|0;o=f[n>>2]|0;if((f[o>>2]|0)==(m|0))p=o;else{o=n;do{n=f[o>>2]|0;o=n+8|0;q=f[o>>2]|0}while((f[q>>2]|0)!=(n|0));p=q}}else{o=k;while(1){q=f[o>>2]|0;if(!q)break;else o=q}p=o}if((p|0)==(l|0))break;else m=p}}f[g>>2]=0;p=Jva(j,g)|0;if((f[p+140>>2]|0)==(f[p+144>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;r=aD(g,30)|0;s=366986;t=r+30|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,g,367017,364488,1457);bD(g)}f[g>>2]=0;p=g+4|0;f[p>>2]=0;f[g+8>>2]=0;m=h+4|0;k=h+4|0;q=h+8|0;n=g+8|0;v=0;while(1){f[h>>2]=0;w=Jva(j,h)|0;if(v>>>0>=(((f[w+144>>2]|0)-(f[w+140>>2]|0)|0)/56|0)>>>0)break;f[h>>2]=0;w=(Jva(j,h)|0)+140|0;x=f[w>>2]|0;w=f[x+(v*56|0)+4>>2]|0;if((w|0)<3)y=Y(f[x+(v*56|0)+12>>2]|0,f[x+(v*56|0)+8>>2]|0)|0;else{z=f[x+(v*56|0)+40>>2]|0;x=0;A=1;while(1){B=Y(f[z+(x<<2)>>2]|0,A)|0;x=x+1|0;if((x|0)==(w|0)){y=B;break}else A=B}}if(!y){f[h>>2]=0;f[m>>2]=0;r=aD(h,32)|0;s=367032;t=r+32|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,h,367017,364488,1461);bD(h)}f[i>>2]=0;A=(Jva(j,i)|0)+140|0;w=f[A>>2]|0;A=f[w+(v*56|0)+4>>2]|0;x=f[w+(v*56|0)+40>>2]|0;f[h>>2]=0;f[k>>2]=0;f[q>>2]=0;Rva(h,x,x+(A<<2)|0);C=f[p>>2]|0;if((C|0)==(f[n>>2]|0)){Sva(g,h);D=f[h>>2]|0}else{f[C>>2]=0;A=C+4|0;f[A>>2]=0;f[C+8>>2]=0;x=f[h>>2]|0;w=(f[k>>2]|0)-x|0;z=w>>2;if(z){if(z>>>0>1073741823){E=21;break}o=L5b(w)|0;f[A>>2]=o;f[C>>2]=o;f[C+8>>2]=o+(z<<2);z=f[h>>2]|0;w=(f[k>>2]|0)-z|0;if((w|0)>0){Vac(o|0,z|0,w|0)|0;f[A>>2]=o+(w>>>2<<2);F=z;G=f[p>>2]|0}else{F=z;G=C}}else{F=x;G=C}f[p>>2]=G+12;D=F}if(D|0){x=f[k>>2]|0;if((x|0)!=(D|0))f[k>>2]=x+(~((x+-4-D|0)>>>2)<<2);O5b(D)}v=v+1|0}if((E|0)==21)c4b(C);f[h+4>>2]=0;f[h+8>>2]=0;C=h+4|0;f[h>>2]=C;Tva(a,g,h);v=a+56|0;Uva(v);f[a+104>>2]=f[a+116>>2];f[a+108>>2]=f[a+112>>2];D=a+128|0;k=a+132|0;Kua(D,f[k>>2]|0);f[a+136>>2]=0;f[D>>2]=k;f[k>>2]=0;k=a+60|0;D=a+60|0;F=a+64|0;G=0;while(1){f[i>>2]=0;n=Jva(j,i)|0;if(G>>>0>=(((f[n+144>>2]|0)-(f[n+140>>2]|0)|0)/56|0)>>>0)break;n=f[k>>2]|0;q=(n|0)==0;a:do if(!q){s=k;r=n;b:while(1){t=r;while(1){m=f[t+16>>2]|0;if((m|0)>=0){if(m|0)break;if((f[t+20>>2]|0)>=(G|0))break}m=f[t+4>>2]|0;if(!m){H=s;break b}else t=m}r=f[t>>2]|0;if(!r){H=t;break}else s=t}do if((H|0)!=(k|0)?(s=f[H+16>>2]|0,(s|0)<=0):0){if((s|0)==0?(G|0)<(f[H+20>>2]|0):0)break;s=H+24|0;f[s>>2]=(f[s>>2]|0)+1;break a}while(0);if(!q){s=D;r=n;m=n;c:while(1){y=f[r+16>>2]|0;do if((y|0)<=0){if(!y){x=f[r+20>>2]|0;if((G|0)<(x|0)){E=52;break}if((x|0)>=(G|0)){E=57;break c}}I=r+4|0;x=f[I>>2]|0;if(!x){E=56;break c}else{J=I;K=x}}else E=52;while(0);if((E|0)==52){E=0;y=f[r>>2]|0;if(!y){E=53;break}else{J=r;K=y}}s=J;r=K;m=K}if((E|0)==53){E=0;L=r;M=r;E=59;break}else if((E|0)==56){E=0;L=I;M=r;E=59;break}else if((E|0)==57){E=0;N=s;O=r;P=m;E=58;break}}else{N=k;O=k;P=n;E=58}}else{N=k;O=k;P=n;E=58}while(0);if((E|0)==58){E=0;if(!P){L=N;M=O;E=59}else{Q=P;E=62}}if((E|0)==59){E=0;n=L5b(28)|0;q=n+16|0;f[q>>2]=0;f[q+4>>2]=G;f[n+24>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=M;f[L>>2]=n;q=f[f[v>>2]>>2]|0;if(!q)R=n;else{f[v>>2]=q;R=f[L>>2]|0}mP(f[D>>2]|0,R);f[F>>2]=(f[F>>2]|0)+1;Q=n;E=62}if((E|0)==62){E=0;f[Q+24>>2]=1}G=G+1|0}G=f[j>>2]|0;if((G|0)!=(l|0)){Q=G;while(1){G=Q+80|0;F=Q+84|0;R=f[F>>2]|0;D=f[G>>2]|0;if((R|0)!=(D|0)){L=0;M=D;D=R;while(1){R=M;P=R+(L<<3)|0;O=f[k>>2]|0;do if(O){N=f[P>>2]|0;I=f[R+(L<<3)+4>>2]|0;K=k;J=O;d:while(1){H=J;while(1){n=f[H+16>>2]|0;if((n|0)>=(N|0)){if((n|0)!=(N|0))break;if((f[H+20>>2]|0)>=(I|0))break}n=f[H+4>>2]|0;if(!n){S=K;break d}else H=n}J=f[H>>2]|0;if(!J){S=H;break}else K=H}if((S|0)!=(k|0)?(K=f[S+16>>2]|0,(N|0)>=(K|0)):0){if((N|0)==(K|0)?(I|0)<(f[S+20>>2]|0):0){E=80;break}K=S+24|0;f[K>>2]=(f[K>>2]|0)+1;T=M;U=D}else E=80}else E=80;while(0);if((E|0)==80){E=0;O=Vva(v,P)|0;f[O>>2]=1;T=f[G>>2]|0;U=f[F>>2]|0}L=L+1|0;if(L>>>0>=U-T>>3>>>0)break;else{M=T;D=U}}}D=f[Q+4>>2]|0;if(!D){M=Q+8|0;L=f[M>>2]|0;if((f[L>>2]|0)==(Q|0))V=L;else{L=M;do{M=f[L>>2]|0;L=M+8|0;F=f[L>>2]|0}while((f[F>>2]|0)!=(M|0));V=F}}else{L=D;while(1){F=f[L>>2]|0;if(!F)break;else L=F}V=L}if((V|0)==(l|0))break;else Q=V}}V=c+4|0;Q=f[V>>2]|0;U=f[c>>2]|0;if((Q|0)!=(U|0)){T=0;S=U;U=Q;while(1){Q=S;D=Q+(T<<3)|0;F=f[k>>2]|0;do if(F){M=f[D>>2]|0;G=f[Q+(T<<3)+4>>2]|0;O=k;R=F;e:while(1){m=R;while(1){r=f[m+16>>2]|0;if((r|0)>=(M|0)){if((r|0)!=(M|0))break;if((f[m+20>>2]|0)>=(G|0))break}r=f[m+4>>2]|0;if(!r){W=O;break e}else m=r}R=f[m>>2]|0;if(!R){W=m;break}else O=m}if((W|0)!=(k|0)?(O=f[W+16>>2]|0,(M|0)>=(O|0)):0){if((M|0)==(O|0)?(G|0)<(f[W+20>>2]|0):0){E=102;break}O=W+24|0;f[O>>2]=(f[O>>2]|0)+1;X=S;Z=U}else E=102}else E=102;while(0);if((E|0)==102){E=0;F=Vva(v,D)|0;f[F>>2]=1;X=f[c>>2]|0;Z=f[V>>2]|0}T=T+1|0;if(T>>>0>=Z-X>>3>>>0)break;else{S=X;U=Z}}}Z=f[j>>2]|0;if((Z|0)!=(l|0)){j=Z;while(1){Wva(a,f[j+16>>2]|0,h);Z=f[j+4>>2]|0;if(!Z){U=j+8|0;X=f[U>>2]|0;if((f[X>>2]|0)==(j|0))_=X;else{X=U;do{U=f[X>>2]|0;X=U+8|0;S=f[X>>2]|0}while((f[S>>2]|0)!=(U|0));_=S}}else{X=Z;while(1){D=f[X>>2]|0;if(!D)break;else X=D}_=X}if((_|0)==(l|0))break;else j=_}}_=a+148|0;j=(f[a+140>>2]|0)+1|0;l=i;f[l>>2]=0;f[l+4>>2]=0;l=a+152|0;Z=f[l>>2]|0;D=f[_>>2]|0;S=Z-D>>3;U=D;D=Z;if(j>>>0<=S>>>0){if(j>>>0<S>>>0?(Z=U+(j<<3)|0,(D|0)!=(Z|0)):0)f[l>>2]=D+(~((D+-8-Z|0)>>>3)<<3)}else Xva(_,j-S|0,i);Yva(a,c);Zva(h,f[C>>2]|0);C=f[g>>2]|0;if(C|0){h=f[p>>2]|0;if((h|0)==(C|0))$=C;else{c=h;while(1){h=c+-12|0;f[p>>2]=h;a=f[h>>2]|0;if(!a)aa=h;else{h=c+-8|0;i=f[h>>2]|0;if((i|0)!=(a|0))f[h>>2]=i+(~((i+-4-a|0)>>>2)<<2);O5b(a);aa=f[p>>2]|0}if((aa|0)==(C|0))break;else c=aa}$=f[g>>2]|0}O5b($)}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function Ova(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=u;u=u+16|0;c=b+8|0;d=b;dQ(c,105732);e=a+8|0;g=f[e>>2]|0;h=a+12|0;i=f[h>>2]|0;if((i|0)!=(g|0))f[h>>2]=i+(~((i+-4-g|0)>>>2)<<2);g=f[a+32>>2]|0;i=a+36|0;if((g|0)!=(i|0)){j=a+16|0;a=g;while(1){g=f[a+16>>2]|0;f[d>>2]=g;do if(!(f[a+112>>2]|0)){k=f[h>>2]|0;if((k|0)==(f[j>>2]|0)){IO(e,d);break}else{f[k>>2]=g;f[h>>2]=k+4;break}}while(0);g=f[a+4>>2]|0;if(!g){k=a+8|0;l=f[k>>2]|0;if((f[l>>2]|0)==(a|0))m=l;else{l=k;do{k=f[l>>2]|0;l=k+8|0;n=f[l>>2]|0}while((f[n>>2]|0)!=(k|0));m=n}}else{l=g;while(1){n=f[l>>2]|0;if(!n)break;else l=n}m=l}if((m|0)==(i|0))break;else a=m}}if(!(f[c+4>>2]|0)){u=b;return}u=b;return}function Pva(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0;c=u;u=u+32|0;d=c+16|0;e=c+8|0;g=c;dQ(d,105712);h=a+112|0;if(!(f[h>>2]|0)){if((f[a+116>>2]|0)>>>0>=2){f[e>>2]=0;f[e+4>>2]=0;i=aD(e,75)|0;j=366285;k=i+75|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,e,366796,364488,994);bD(e)}}else{l=a+32|0;m=f[l>>2]|0;n=m;f[e>>2]=n;o=a+36|0;if((n|0)!=(o|0)){a=g+4|0;p=g+4|0;q=g+4|0;r=g+4|0;s=m;m=n;while(1){n=s;t=f[n+152>>2]|0;v=f[n+156>>2]|0;w=(t|0)==0;if(!w){x=t+4|0;f[x>>2]=(f[x>>2]|0)+1}if(Uh[f[(f[v>>2]|0)+52>>2]&1023](v,f[h>>2]|0)|0){x=f[e>>2]|0;y=f[x+152>>2]|0;z=f[x+156>>2]|0;A=(y|0)==0;if(!A){B=y+4|0;f[B>>2]=(f[B>>2]|0)+1}if(((((m|0)!=(f[l>>2]|0)?Uh[f[(f[z>>2]|0)+52>>2]&1023](z,f[h>>2]|0)|0:0)?(z=f[n+172>>2]|0,B=z,((f[n+176>>2]|0)-z|0)==4):0)?(z=f[x+160>>2]|0,((f[x+164>>2]|0)-z|0)==56):0)?(f[(f[B>>2]|0)+16>>2]|0)==(f[z+16>>2]|0):0){z=x+232|0;B=x+236|0;C=f[B>>2]|0;do if(C){D=f[h>>2]|0;E=x+236|0;F=C;G=C;while(1){H=f[F+16>>2]|0;if((D|0)<(H|0)){I=f[F>>2]|0;if(!I){J=22;break}else{K=F;L=I}}else{if((H|0)>=(D|0)){J=26;break}M=F+4|0;H=f[M>>2]|0;if(!H){J=25;break}else{K=M;L=H}}E=K;F=L;G=L}if((J|0)==22){J=0;N=F;O=F;J=29;break}else if((J|0)==25){J=0;N=M;O=F;J=29;break}else if((J|0)==26){J=0;P=E;Q=F;R=G;J=28;break}}else{P=B;Q=B;R=C;J=28}while(0);if((J|0)==28){J=0;if(!R){N=P;O=Q;J=29}else S=R}if((J|0)==29){J=0;C=L5b(28)|0;f[C+16>>2]=f[h>>2];f[C+20>>2]=0;f[C+24>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=O;f[N>>2]=C;D=f[f[z>>2]>>2]|0;if(!D)T=C;else{f[z>>2]=D;T=f[N>>2]|0}mP(f[x+236>>2]|0,T);D=x+240|0;f[D>>2]=(f[D>>2]|0)+1;S=C}if(!(f[S+24>>2]|0)){f[g>>2]=0;f[q>>2]=0;i=aD(g,46)|0;j=366808;k=i+46|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,g,366796,364488,1028);bD(g)}C=f[(f[v>>2]|0)+64>>2]|0;D=f[B>>2]|0;do if(D){H=f[h>>2]|0;I=x+236|0;U=D;V=D;while(1){W=f[U+16>>2]|0;if((H|0)<(W|0)){X=f[U>>2]|0;if(!X){J=39;break}else{Y=U;Z=X}}else{if((W|0)>=(H|0)){J=43;break}_=U+4|0;W=f[_>>2]|0;if(!W){J=42;break}else{Y=_;Z=W}}I=Y;U=Z;V=Z}if((J|0)==39){J=0;$=U;aa=U;J=46;break}else if((J|0)==42){J=0;$=_;aa=U;J=46;break}else if((J|0)==43){J=0;ba=I;ca=U;da=V;J=45;break}}else{ba=B;ca=B;da=D;J=45}while(0);if((J|0)==45){J=0;if(!da){$=ba;aa=ca;J=46}else ea=da}if((J|0)==46){J=0;D=L5b(28)|0;f[D+16>>2]=f[h>>2];f[D+20>>2]=0;f[D+24>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=aa;f[$>>2]=D;H=f[f[z>>2]>>2]|0;if(!H)fa=D;else{f[z>>2]=H;fa=f[$>>2]|0}mP(f[x+236>>2]|0,fa);H=x+240|0;f[H>>2]=(f[H>>2]|0)+1;ea=D}_h[C&255](g,v,ea+20|0);do if(!(f[r>>2]|0))ga=0;else{D=n+244|0;H=n+248|0;G=f[H>>2]|0;do if(G){F=f[h>>2]|0;E=n+248|0;W=G;X=G;while(1){ha=f[W+16>>2]|0;if((F|0)<(ha|0)){ia=f[W>>2]|0;if(!ia){J=55;break}else{ja=W;ka=ia}}else{if((ha|0)>=(F|0)){J=59;break}la=W+4|0;ha=f[la>>2]|0;if(!ha){J=58;break}else{ja=la;ka=ha}}E=ja;W=ka;X=ka}if((J|0)==55){J=0;ma=W;na=W;J=62;break}else if((J|0)==58){J=0;ma=la;na=W;J=62;break}else if((J|0)==59){J=0;oa=E;pa=W;qa=X;J=61;break}}else{oa=H;pa=H;qa=G;J=61}while(0);if((J|0)==61){J=0;if(!qa){ma=oa;na=pa;J=62}else ra=qa}if((J|0)==62){J=0;G=L5b(24)|0;f[G+16>>2]=f[h>>2];b[G+20>>0]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=na;f[ma>>2]=G;H=f[f[D>>2]>>2]|0;if(!H)sa=G;else{f[D>>2]=H;sa=f[ma>>2]|0}mP(f[n+248>>2]|0,sa);H=n+252|0;f[H>>2]=(f[H>>2]|0)+1;ra=G}b[ra+20>>0]=1;G=f[B>>2]|0;do if(G){H=f[h>>2]|0;V=x+236|0;U=G;I=G;while(1){F=f[U+16>>2]|0;if((H|0)<(F|0)){ha=f[U>>2]|0;if(!ha){J=70;break}else{ta=U;ua=ha}}else{if((F|0)>=(H|0)){J=74;break}va=U+4|0;F=f[va>>2]|0;if(!F){J=73;break}else{ta=va;ua=F}}V=ta;U=ua;I=ua}if((J|0)==70){J=0;wa=U;xa=U;J=77;break}else if((J|0)==73){J=0;wa=va;xa=U;J=77;break}else if((J|0)==74){J=0;ya=V;za=U;Aa=I;J=76;break}}else{ya=B;za=B;Aa=G;J=76}while(0);if((J|0)==76){J=0;if(!Aa){wa=ya;xa=za;J=77}else Ba=Aa}if((J|0)==77){J=0;G=L5b(28)|0;f[G+16>>2]=f[h>>2];f[G+20>>2]=0;f[G+24>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=xa;f[wa>>2]=G;D=f[f[z>>2]>>2]|0;if(!D)Ca=G;else{f[z>>2]=D;Ca=f[wa>>2]|0}mP(f[x+236>>2]|0,Ca);D=x+240|0;f[D>>2]=(f[D>>2]|0)+1;Ba=G}G=Ba+20|0;D=f[g>>2]|0;H=f[r>>2]|0;if(D|0){X=D+4|0;f[X>>2]=(f[X>>2]|0)+1}X=f[G>>2]|0;f[G>>2]=D;f[Ba+24>>2]=H;if(!X){ga=4;break}H=X+4|0;D=f[H>>2]|0;f[H>>2]=D+-1;if((D|0)!=1){ga=4;break}bi[f[(f[X>>2]|0)+8>>2]&2047](X);ga=4}while(0);x=f[g>>2]|0;do if(x|0){z=x+4|0;B=f[z>>2]|0;f[z>>2]=B+-1;if((B|0)!=1)break;bi[f[(f[x>>2]|0)+8>>2]&2047](x)}while(0);if(!ga)J=89}else J=89;do if((J|0)==89){J=0;x=n+244|0;B=n+248|0;z=f[B>>2]|0;do if(z){C=f[h>>2]|0;X=n+248|0;D=z;H=z;while(1){G=f[D+16>>2]|0;if((C|0)<(G|0)){W=f[D>>2]|0;if(!W){J=94;break}else{Da=D;Ea=W}}else{if((G|0)>=(C|0)){J=98;break}Fa=D+4|0;G=f[Fa>>2]|0;if(!G){J=97;break}else{Da=Fa;Ea=G}}X=Da;D=Ea;H=Ea}if((J|0)==94){J=0;Ga=D;Ha=D;J=101;break}else if((J|0)==97){J=0;Ga=Fa;Ha=D;J=101;break}else if((J|0)==98){J=0;Ia=X;Ja=D;Ka=H;J=100;break}}else{Ia=B;Ja=B;Ka=z;J=100}while(0);if((J|0)==100){J=0;if(!Ka){Ga=Ia;Ha=Ja;J=101}else La=Ka}if((J|0)==101){J=0;z=L5b(24)|0;f[z+16>>2]=f[h>>2];b[z+20>>0]=0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=Ha;f[Ga>>2]=z;B=f[f[x>>2]>>2]|0;if(!B)Ma=z;else{f[x>>2]=B;Ma=f[Ga>>2]|0}mP(f[n+248>>2]|0,Ma);B=n+252|0;f[B>>2]=(f[B>>2]|0)+1;La=z}b[La+20>>0]=0;if((f[h>>2]|0)!=1){f[g>>2]=0;f[p>>2]=0;i=aD(g,26)|0;j=366466;k=i+26|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-213,g,366796,364488,1049);bD(g);break}_h[f[(f[v>>2]|0)+56>>2]&255](g,v,n+140|0);x=n+232|0;z=n+236|0;B=f[z>>2]|0;do if(B){C=n+236|0;I=B;U=B;while(1){V=f[I+16>>2]|0;if((V|0)>1){G=f[I>>2]|0;if(!G){J=110;break}else{Na=I;Oa=G}}else{if((V|0)==1){J=114;break}Pa=I+4|0;V=f[Pa>>2]|0;if(!V){J=113;break}else{Na=Pa;Oa=V}}C=Na;I=Oa;U=Oa}if((J|0)==110){J=0;Qa=I;Ra=I;J=117;break}else if((J|0)==113){J=0;Qa=Pa;Ra=I;J=117;break}else if((J|0)==114){J=0;Sa=C;Ta=I;Ua=U;J=116;break}}else{Sa=z;Ta=z;Ua=B;J=116}while(0);if((J|0)==116){J=0;if(!Ua){Qa=Sa;Ra=Ta;J=117}else Va=Ua}if((J|0)==117){J=0;B=L5b(28)|0;f[B+16>>2]=1;f[B+20>>2]=0;f[B+24>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=Ra;f[Qa>>2]=B;z=f[f[x>>2]>>2]|0;if(!z)Wa=B;else{f[x>>2]=z;Wa=f[Qa>>2]|0}mP(f[n+236>>2]|0,Wa);z=n+240|0;f[z>>2]=(f[z>>2]|0)+1;Va=B}B=Va+20|0;z=f[g>>2]|0;H=f[a>>2]|0;if(z|0){D=z+4|0;f[D>>2]=(f[D>>2]|0)+1}D=f[B>>2]|0;f[B>>2]=z;f[Va+24>>2]=H;if(D|0?(H=D+4|0,z=f[H>>2]|0,f[H>>2]=z+-1,(z|0)==1):0)bi[f[(f[D>>2]|0)+8>>2]&2047](D);D=f[g>>2]|0;if(D|0?(z=D+4|0,H=f[z>>2]|0,f[z>>2]=H+-1,(H|0)==1):0)bi[f[(f[D>>2]|0)+8>>2]&2047](D);f[e>>2]=s}while(0);n=y;if(!A?(v=n+4|0,D=f[v>>2]|0,f[v>>2]=D+-1,(D|0)==1):0)bi[f[(f[y>>2]|0)+8>>2]&2047](n)}else f[e>>2]=s;n=t;if(!w?(D=n+4|0,v=f[D>>2]|0,f[D>>2]=v+-1,(v|0)==1):0)bi[f[(f[t>>2]|0)+8>>2]&2047](n);n=f[m+4>>2]|0;if(!n){v=m+8|0;D=f[v>>2]|0;if((f[D>>2]|0)==(s|0))Xa=D;else{D=v;do{v=f[D>>2]|0;D=v+8|0;H=f[D>>2]|0}while((f[H>>2]|0)!=(v|0));Xa=H}}else{D=n;while(1){t=f[D>>2]|0;if(!t)break;else D=t}Xa=D}if((Xa|0)==(o|0))break;else{s=Xa;m=Xa}}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function Qva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>3;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>3>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>3;o=h>>>0>n>>>0;p=o?b+(n<<3)|0:c;c=p;n=c-e|0;e=n>>3;if(e|0)Xac(k|0,b|0,n|0)|0;n=l+(e<<3)|0;if(o){o=d-c|0;if((o|0)<=0)return;Vac(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>3<<3);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-8-n|0)>>>3)<<3);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-8-k|0)>>>3)<<3);O5b(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>536870911)c4b(a);j=q>>2;n=q>>3>>>0<268435455?(j>>>0<h>>>0?h:j):536870911;if(n>>>0>536870911)c4b(a);j=L5b(n<<3)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<3);if((g|0)<=0)return;Vac(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>3<<3);return}function Rva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=b;e=c-d>>2;g=a+8|0;h=f[g>>2]|0;i=f[a>>2]|0;j=i;if(e>>>0<=h-i>>2>>>0){k=a+4|0;l=(f[k>>2]|0)-i>>2;m=e>>>0>l>>>0;n=b+(l<<2)|0;l=m?n:c;o=l;p=o-d|0;q=p>>2;if(q|0)Xac(i|0,b|0,p|0)|0;p=j+(q<<2)|0;if(!m){m=f[k>>2]|0;if((m|0)==(p|0))return;f[k>>2]=m+(~((m+-4-p|0)>>>2)<<2);return}if((l|0)==(c|0))return;l=f[k>>2]|0;p=c+-4-o|0;o=n;n=l;while(1){f[n>>2]=f[o>>2];o=o+4|0;if((o|0)==(c|0))break;else n=n+4|0}f[k>>2]=l+((p>>>2)+1<<2);return}p=i;if(!i)r=h;else{h=a+4|0;l=f[h>>2]|0;if((l|0)!=(j|0))f[h>>2]=l+(~((l+-4-i|0)>>>2)<<2);O5b(p);f[g>>2]=0;f[h>>2]=0;f[a>>2]=0;r=0}if(e>>>0>1073741823)c4b(a);h=r>>1;p=r>>2>>>0<536870911?(h>>>0<e>>>0?e:h):1073741823;if(p>>>0>1073741823)c4b(a);h=L5b(p<<2)|0;e=a+4|0;f[e>>2]=h;f[a>>2]=h;f[g>>2]=h+(p<<2);if((b|0)==(c|0))return;p=c+-4-d|0;d=b;b=h;while(1){f[b>>2]=f[d>>2];d=d+4|0;if((d|0)==(c|0))break;else b=b+4|0}f[e>>2]=h+((p>>>2)+1<<2);return}function Sva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/12|0;g=e+1|0;if(g>>>0>357913941)c4b(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/12|0;d=i<<1;j=i>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(j)if(j>>>0>357913941){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{k=L5b(j*12|0)|0;break}else k=0;while(0);d=k+(e*12|0)|0;e=d;g=k+(j*12|0)|0;Bua(d,b);b=d+12|0;j=f[a>>2]|0;k=f[c>>2]|0;if((k|0)==(j|0)){l=e;m=j;n=j}else{i=k;k=e;e=d;do{i=i+-12|0;Bua(e+-12|0,i);e=k+-12|0;k=e}while((i|0)!=(j|0));l=k;m=f[a>>2]|0;n=f[c>>2]|0}f[a>>2]=l;f[c>>2]=b;f[h>>2]=g;g=m;if((n|0)!=(g|0)){h=n;do{n=h;h=h+-12|0;b=f[h>>2]|0;if(b|0){c=n+-8|0;n=f[c>>2]|0;if((n|0)!=(b|0))f[c>>2]=n+(~((n+-4-b|0)>>>2)<<2);O5b(b)}}while((h|0)!=(g|0))}if(!m)return;O5b(m);return}function Tva(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=d+4|0;Zva(d,f[e>>2]|0);g=d+8|0;f[g>>2]=0;f[d>>2]=e;f[e>>2]=0;h=L5b(60)|0;i=h+16|0;j=h+20|0;f[h>>2]=0;f[h+4>>2]=0;k=h+8|0;l=i;m=l+40|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));b[i+40>>0]=0;f[k>>2]=e;f[e>>2]=h;f[d>>2]=h;mP(h,h);f[g>>2]=(f[g>>2]|0)+1;if((j|0)!=(c|0))xwa(j,f[c>>2]|0,f[c+4>>2]|0);c=f[a+32>>2]|0;j=a+36|0;if((c|0)==(j|0))return;else n=c;while(1){ywa(a,f[n+16>>2]|0,d);c=f[n+4>>2]|0;if(!c){g=n+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(n|0))o=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;e=f[h>>2]|0}while((f[e>>2]|0)!=(g|0));o=e}}else{h=c;while(1){e=f[h>>2]|0;if(!e)break;else h=e}o=h}if((o|0)==(j|0))break;else n=o}return}function Uva(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;dQ(c,105832);d=a+4|0;Oua(a,f[d>>2]|0);f[a+8>>2]=0;f[a>>2]=d;f[d>>2]=0;d=a+12|0;e=a+16|0;Nua(d,f[e>>2]|0);f[a+20>>2]=0;f[d>>2]=e;f[e>>2]=0;e=a+24|0;d=a+28|0;Mua(e,f[d>>2]|0);f[a+32>>2]=0;f[e>>2]=d;f[d>>2]=0;d=a+36|0;e=a+40|0;Lua(d,f[e>>2]|0);f[a+44>>2]=0;f[d>>2]=e;f[e>>2]=0;f[a+48>>2]=0;f[a+52>>2]=0;if(!(f[c+4>>2]|0)){u=b;return}u=b;return}function Vva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+4|0;d=f[c>>2]|0;do if(d){e=f[b>>2]|0;g=f[b+4>>2]|0;h=a+4|0;i=d;j=d;a:while(1){k=f[i+16>>2]|0;do if((e|0)>=(k|0)){l=(e|0)==(k|0);if(l?(g|0)<(f[i+20>>2]|0):0){m=7;break}if((k|0)>=(e|0)){if(!l){m=14;break a}if((f[i+20>>2]|0)>=(g|0)){m=14;break a}}n=i+4|0;l=f[n>>2]|0;if(!l){m=13;break a}else{o=n;p=l}}else m=7;while(0);if((m|0)==7){m=0;k=f[i>>2]|0;if(!k){m=8;break}else{o=i;p=k}}h=o;i=p;j=p}if((m|0)==8){q=i;r=i;break}else if((m|0)==13){q=n;r=i;break}else if((m|0)==14){s=h;t=i;u=j;m=16;break}}else{s=c;t=c;u=d;m=16}while(0);if((m|0)==16)if(!u){q=s;r=t}else{v=u;w=v+24|0;return w|0}u=L5b(28)|0;t=b;b=f[t+4>>2]|0;s=u+16|0;f[s>>2]=f[t>>2];f[s+4>>2]=b;f[u+24>>2]=0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=r;f[q>>2]=u;r=f[f[a>>2]>>2]|0;if(!r)x=u;else{f[a>>2]=r;x=f[q>>2]|0}mP(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;v=u;w=v+24|0;return w|0}
function Zgb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0;g=u;u=u+208|0;h=g+192|0;i=g+16|0;j=g+8|0;k=g;l=g+184|0;m=g+172|0;o=g+168|0;p=g+44|0;q=g+112|0;r=g+32|0;s=g+56|0;t=g+20|0;v=p+4|0;f[v>>2]=0;w=p+8|0;f[w>>2]=0;x=p+4|0;f[p>>2]=x;y=a+36|0;z=f[y>>2]|0;do if((z|0)>0){A=a+48|0;B=d+8|0;C=h+4|0;D=l+4|0;E=m+4|0;F=m+8|0;G=h+8|0;H=h+4|0;I=q+36|0;J=q+16|0;K=q+4|0;L=q+40|0;M=q+44|0;N=q+48|0;O=a+40|0;P=c+4|0;Q=a+81|0;R=a+68|0;S=a+72|0;T=a+76|0;U=0;V=z;W=0;while(1){if((W|0)==(f[A>>2]|0)){X=U;Y=W+1|0;Z=V}else{if((W|0)>=(f[B>>2]|0)){_=7;break}$=W+1|0;f[h>>2]=W;f[C>>2]=$;f[l>>2]=-2147483648;f[D>>2]=2147483647;lL(q,d,h,l);f[m>>2]=0;f[E>>2]=0;f[F>>2]=0;aa=G;f[aa>>2]=0;f[aa+4>>2]=0;f[h>>2]=-2113732603;f[H>>2]=m;SP(q,h);aa=f[I>>2]|0;if(aa|0?(ba=aa+12|0,aa=f[ba>>2]|0,f[ba>>2]=aa+-1,(aa|0)==1):0)kL(q);f[I>>2]=0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[K>>2]|0)>0){aa=f[L>>2]|0;ba=0;do{f[aa+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[K>>2]|0))}ba=f[M>>2]|0;if((ba|0)!=(N|0))UC(ba);ca=b[O>>0]|0?-1:W;ba=f[P>>2]|0;if(!ba){_=23;break}else{da=P;ea=ba}a:while(1){ba=ea;while(1){if((f[ba+16>>2]|0)>=(ca|0))break;aa=f[ba+4>>2]|0;if(!aa){fa=da;break a}else ba=aa}ea=f[ba>>2]|0;if(!ea){fa=ba;break}else da=ba}if((fa|0)==(P|0)){_=23;break}if((ca|0)<(f[fa+16>>2]|0)){_=23;break}aa=fa+20|0;ga=+n[R>>2];ha=+n[S>>2];ia=f[T>>2]|0;ja=f[x>>2]|0;ka=(ja|0)==0;if(!(b[Q>>0]|0)){do if(!ka){la=v;ma=ja;na=ja;while(1){oa=f[ma+16>>2]|0;if((W|0)<(oa|0)){pa=f[ma>>2]|0;if(!pa){_=43;break}else{qa=ma;ra=pa}}else{if((oa|0)>=(W|0)){_=47;break}sa=ma+4|0;oa=f[sa>>2]|0;if(!oa){_=46;break}else{qa=sa;ra=oa}}la=qa;ma=ra;na=ra}if((_|0)==43){_=0;ta=ma;ua=ma;_=49;break}else if((_|0)==46){_=0;ta=sa;ua=ma;_=49;break}else if((_|0)==47){_=0;va=la;wa=ma;xa=na;_=48;break}}else{va=x;wa=x;xa=ja;_=48}while(0);if((_|0)==48){_=0;if(!xa){ta=va;ua=wa;_=49}else ya=xa}if((_|0)==49){_=0;ba=L5b(32)|0;f[ba+16>>2]=W;f[ba+20>>2]=0;f[ba+24>>2]=0;f[ba+28>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=ua;f[ta>>2]=ba;oa=f[f[p>>2]>>2]|0;if(!oa)za=ba;else{f[p>>2]=oa;za=f[ta>>2]|0}mP(f[v>>2]|0,za);f[w>>2]=(f[w>>2]|0)+1;ya=ba}ahb(aa,m,ga,ha,1.0,ia,ya+20|0,26)}else{do if(!ka){ba=v;oa=ja;pa=ja;while(1){Aa=f[oa+16>>2]|0;if((W|0)<(Aa|0)){Ba=f[oa>>2]|0;if(!Ba){_=29;break}else{Ca=oa;Da=Ba}}else{if((Aa|0)>=(W|0)){_=33;break}Ea=oa+4|0;Aa=f[Ea>>2]|0;if(!Aa){_=32;break}else{Ca=Ea;Da=Aa}}ba=Ca;oa=Da;pa=Da}if((_|0)==29){_=0;Fa=oa;Ga=oa;_=35;break}else if((_|0)==32){_=0;Fa=Ea;Ga=oa;_=35;break}else if((_|0)==33){_=0;Ha=ba;Ia=oa;Ja=pa;_=34;break}}else{Ha=x;Ia=x;Ja=ja;_=34}while(0);if((_|0)==34){_=0;if(!Ja){Fa=Ha;Ga=Ia;_=35}else Ka=Ja}if((_|0)==35){_=0;ja=L5b(32)|0;f[ja+16>>2]=W;f[ja+20>>2]=0;f[ja+24>>2]=0;f[ja+28>>2]=0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=Ga;f[Fa>>2]=ja;ka=f[f[p>>2]>>2]|0;if(!ka)La=ja;else{f[p>>2]=ka;La=f[Fa>>2]|0}mP(f[v>>2]|0,La);f[w>>2]=(f[w>>2]|0)+1;Ka=ja}ahb(aa,m,ga,ha,1.0,ia,Ka+20|0,25)}ja=f[x>>2]|0;do if(ja){ka=v;na=ja;ma=ja;while(1){la=f[na+16>>2]|0;if((W|0)<(la|0)){Aa=f[na>>2]|0;if(!Aa){_=57;break}else{Ma=na;Na=Aa}}else{if((la|0)>=(W|0)){_=61;break}Oa=na+4|0;la=f[Oa>>2]|0;if(!la){_=60;break}else{Ma=Oa;Na=la}}ka=Ma;na=Na;ma=Na}if((_|0)==57){_=0;Pa=na;Qa=na;_=63;break}else if((_|0)==60){_=0;Pa=Oa;Qa=na;_=63;break}else if((_|0)==61){_=0;Ra=ka;Sa=na;Ta=ma;_=62;break}}else{Ra=x;Sa=x;Ta=ja;_=62}while(0);if((_|0)==62){_=0;if(!Ta){Pa=Ra;Qa=Sa;_=63}else Ua=Ta}if((_|0)==63){_=0;ja=L5b(32)|0;f[ja+16>>2]=W;f[ja+20>>2]=0;f[ja+24>>2]=0;f[ja+28>>2]=0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=Qa;f[Pa>>2]=ja;ia=f[f[p>>2]>>2]|0;if(!ia)Va=ja;else{f[p>>2]=ia;Va=f[Pa>>2]|0}mP(f[v>>2]|0,Va);f[w>>2]=(f[w>>2]|0)+1;Ua=ja}ja=(f[Ua+24>>2]|0)-(f[Ua+20>>2]|0)>>2;ia=f[m>>2]|0;if(ia|0){aa=f[E>>2]|0;if((aa|0)!=(ia|0))f[E>>2]=aa+(~((aa+-4-ia|0)>>>2)<<2);O5b(ia)}X=ja+U|0;Y=$;Z=f[y>>2]|0}if((Y|0)<(Z|0)){U=X;V=Z;W=Y}else{_=3;break}}if((_|0)==3){V=a+64|0;U=f[V>>2]|0;if(!((U|0)>-1&X>>>0>U>>>0)){Wa=X;break}f[r>>2]=0;U=r+4|0;f[U>>2]=0;f[r+8>>2]=0;E=f[p>>2]|0;do if((E|0)!=(x|0)){Q=d+8|0;T=h+4|0;S=l+4|0;R=m+4|0;P=m+8|0;O=h+8|0;N=h+4|0;M=s+36|0;K=s+16|0;L=s+4|0;J=s+40|0;I=s+44|0;H=s+48|0;G=h+4|0;F=h+8|0;D=r+8|0;C=h+4|0;B=E;while(1){Xa=f[B+16>>2]|0;A=B+20|0;if((Xa|0)>=(f[Q>>2]|0)){_=77;break}f[h>>2]=Xa;f[T>>2]=Xa+1;f[l>>2]=-2147483648;f[S>>2]=2147483647;lL(s,d,h,l);f[m>>2]=0;f[R>>2]=0;f[P>>2]=0;ja=O;f[ja>>2]=0;f[ja+4>>2]=0;f[h>>2]=-2113732603;f[N>>2]=m;SP(s,h);ja=f[M>>2]|0;if(ja|0?(ia=ja+12|0,ja=f[ia>>2]|0,f[ia>>2]=ja+-1,(ja|0)==1):0)kL(s);f[M>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[L>>2]|0)>0){ja=f[J>>2]|0;ia=0;do{f[ja+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[L>>2]|0))}ia=f[I>>2]|0;if((ia|0)!=(H|0))UC(ia);ia=B+24|0;ja=f[A>>2]|0;if((f[ia>>2]|0)!=(ja|0)){ma=0;na=ja;do{ja=f[na+(ma<<2)>>2]|0;ka=f[m>>2]|0;if(ja>>>0<(f[R>>2]|0)-ka>>2>>>0)Ya=ka;else{f[h>>2]=0;f[C>>2]=0;ka=aD(h,19)|0;aa=432484;pa=ka+19|0;do{b[ka>>0]=b[aa>>0]|0;ka=ka+1|0;aa=aa+1|0}while((ka|0)<(pa|0));bO(-215,h,432465,431818,529);bD(h);Ya=f[m>>2]|0}f[h>>2]=f[Ya+(ja<<2)>>2];f[G>>2]=Xa;f[F>>2]=ja;aa=f[U>>2]|0;if((aa|0)==(f[D>>2]|0))ehb(r,h);else{f[aa>>2]=f[h>>2];f[aa+4>>2]=f[h+4>>2];f[aa+8>>2]=f[h+8>>2];f[U>>2]=(f[U>>2]|0)+12}ma=ma+1|0;na=f[A>>2]|0}while(ma>>>0<(f[ia>>2]|0)-na>>2>>>0)}na=f[m>>2]|0;if(na|0){ia=f[R>>2]|0;if((ia|0)!=(na|0))f[R>>2]=ia+(~((ia+-4-na|0)>>>2)<<2);O5b(na)}na=f[B+4>>2]|0;if(!na){ia=B+8|0;ma=f[ia>>2]|0;if((f[ma>>2]|0)==(B|0))Za=ma;else{ma=ia;do{ia=f[ma>>2]|0;ma=ia+8|0;A=f[ma>>2]|0}while((f[A>>2]|0)!=(ia|0));Za=A}}else{ma=na;while(1){A=f[ma>>2]|0;if(!A)break;else ma=A}Za=ma}if((Za|0)==(x|0)){_=74;break}else B=Za}if((_|0)==74){_a=f[r>>2]|0;$a=f[U>>2]|0;break}else if((_|0)==77){f[i>>2]=Xa;hO(h,432416,i);Ogb(-2,h,432465,524)}}else{_a=0;$a=0}while(0);f[h>>2]=561;dhb(_a,$a,h);E=f[V>>2]|0;B=f[U>>2]|0;R=f[r>>2]|0;D=(B-R|0)/12|0;F=R;G=B;if(E>>>0<=D>>>0)if(E>>>0<D>>>0?(C=F+(E*12|0)|0,(G|0)!=(C|0)):0){H=G+(~(((G+-12-C|0)>>>0)/12|0)*12|0)|0;f[U>>2]=H;ab=H;bb=R;cb=F}else{ab=B;bb=R;cb=F}else{fhb(r,E-D|0);D=f[r>>2]|0;ab=f[U>>2]|0;bb=D;cb=D}D=t+4|0;f[D>>2]=0;E=t+8|0;f[E>>2]=0;F=t+4|0;f[t>>2]=F;b:do if((ab|0)!=(bb|0)){R=0;B=cb;H=0;C=0;while(1){G=f[B+(R*12|0)+4>>2]|0;f[h>>2]=f[B+(R*12|0)+8>>2];do if(H){I=D;L=H;J=C;while(1){K=f[L+16>>2]|0;if((G|0)<(K|0)){M=f[L>>2]|0;if(!M){_=128;break}else{db=L;eb=M}}else{if((K|0)>=(G|0)){_=132;break}fb=L+4|0;K=f[fb>>2]|0;if(!K){_=131;break}else{db=fb;eb=K}}I=db;L=eb;J=eb}if((_|0)==128){_=0;gb=L;hb=L;_=134;break}else if((_|0)==131){_=0;gb=fb;hb=L;_=134;break}else if((_|0)==132){_=0;ib=I;jb=L;kb=J;_=133;break}}else{ib=F;jb=F;kb=C;_=133}while(0);if((_|0)==133){_=0;if(!kb){gb=ib;hb=jb;_=134}else lb=kb}if((_|0)==134){_=0;ma=L5b(32)|0;f[ma+16>>2]=G;f[ma+20>>2]=0;f[ma+24>>2]=0;f[ma+28>>2]=0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=hb;f[gb>>2]=ma;ja=f[f[t>>2]>>2]|0;if(!ja)mb=ma;else{f[t>>2]=ja;mb=f[gb>>2]|0}mP(f[D>>2]|0,mb);f[E>>2]=(f[E>>2]|0)+1;lb=ma}ma=lb+24|0;ja=f[ma>>2]|0;if((ja|0)==(f[lb+28>>2]|0))IO(lb+20|0,h);else{f[ja>>2]=f[h>>2];f[ma>>2]=ja+4}ja=R+1|0;ma=f[r>>2]|0;if(ja>>>0>=(((f[U>>2]|0)-ma|0)/12|0)>>>0)break b;K=f[F>>2]|0;R=ja;B=ma;H=K;C=K}}while(0);E=e+4|0;D=f[E>>2]|0;if((D|0)==(f[e+8>>2]|0))hhb(e,t);else{C=D+4|0;f[C>>2]=0;H=D+8|0;f[H>>2]=0;B=D+4|0;f[D>>2]=B;R=f[t>>2]|0;if((R|0)!=(F|0)){K=B;B=R;while(1){R=B+16|0;f[o>>2]=K;f[h>>2]=f[o>>2];ma=ghb(D,h,l,m,R)|0;if(!(f[ma>>2]|0)){ja=L5b(32)|0;f[ja+16>>2]=f[R>>2];Bua(ja+20|0,B+20|0);R=f[l>>2]|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=R;f[ma>>2]=ja;R=f[f[D>>2]>>2]|0;if(!R)nb=ja;else{f[D>>2]=R;nb=f[ma>>2]|0}mP(f[C>>2]|0,nb);f[H>>2]=(f[H>>2]|0)+1}ma=f[B+4>>2]|0;if(!ma){R=B+8|0;ja=f[R>>2]|0;if((f[ja>>2]|0)==(B|0))ob=ja;else{ja=R;do{R=f[ja>>2]|0;ja=R+8|0;M=f[ja>>2]|0}while((f[M>>2]|0)!=(R|0));ob=M}}else{ja=ma;while(1){M=f[ja>>2]|0;if(!M)break;else ja=M}ob=ja}if((ob|0)==(F|0))break;else B=ob}}f[E>>2]=(f[E>>2]|0)+12}B=f[V>>2]|0;owa(t,f[F>>2]|0);H=f[r>>2]|0;if(H|0){C=f[U>>2]|0;if((C|0)!=(H|0))f[U>>2]=C+(~(((C+-12-H|0)>>>0)/12|0)*12|0);O5b(H)}pb=B;qb=f[x>>2]|0;owa(p,qb);u=g;return pb|0}else if((_|0)==7){f[k>>2]=W;hO(h,432347,k);Ogb(-2,h,432465,499)}else if((_|0)==23){f[j>>2]=ca;hO(h,432416,j);Ogb(-2,h,432465,506)}}else Wa=0;while(0);j=e+4|0;ca=f[j>>2]|0;if((ca|0)==(f[e+8>>2]|0)){hhb(e,p);pb=Wa;qb=f[x>>2]|0;owa(p,qb);u=g;return pb|0}e=ca+4|0;f[e>>2]=0;_=ca+8|0;f[_>>2]=0;k=ca+4|0;f[ca>>2]=k;r=f[p>>2]|0;if((r|0)!=(x|0)){t=k;k=r;while(1){r=k+16|0;f[o>>2]=t;f[h>>2]=f[o>>2];ob=ghb(ca,h,l,m,r)|0;if(!(f[ob>>2]|0)){nb=L5b(32)|0;f[nb+16>>2]=f[r>>2];Bua(nb+20|0,k+20|0);r=f[l>>2]|0;f[nb>>2]=0;f[nb+4>>2]=0;f[nb+8>>2]=r;f[ob>>2]=nb;r=f[f[ca>>2]>>2]|0;if(!r)rb=nb;else{f[ca>>2]=r;rb=f[ob>>2]|0}mP(f[e>>2]|0,rb);f[_>>2]=(f[_>>2]|0)+1}ob=f[k+4>>2]|0;if(!ob){r=k+8|0;nb=f[r>>2]|0;if((f[nb>>2]|0)==(k|0))sb=nb;else{nb=r;do{r=f[nb>>2]|0;nb=r+8|0;lb=f[nb>>2]|0}while((f[lb>>2]|0)!=(r|0));sb=lb}}else{nb=ob;while(1){W=f[nb>>2]|0;if(!W)break;else nb=W}sb=nb}if((sb|0)==(x|0))break;else k=sb}}f[j>>2]=(f[j>>2]|0)+12;pb=Wa;qb=f[x>>2]|0;owa(p,qb);u=g;return pb|0}function _gb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0;i=u;u=u+112|0;j=i+8|0;k=i;l=i+88|0;m=i+80|0;o=i+12|0;p=i+24|0;q=f[h>>2]|0;r=h+4|0;if((q|0)==(r|0)){s=0;u=i;return s|0}h=g+8|0;t=l+4|0;v=m+4|0;w=o+4|0;x=o+8|0;y=l+8|0;z=l+4|0;A=p+36|0;B=p+16|0;C=p+4|0;D=p+40|0;E=p+44|0;F=p+48|0;G=a+40|0;a=e+4|0;H=+(c|0);c=0;e=q;while(1){I=f[e+16>>2]|0;if((f[h>>2]|0)<=(I|0)){J=5;break}f[l>>2]=I;f[t>>2]=I+1;f[m>>2]=-2147483648;f[v>>2]=2147483647;lL(p,g,l,m);f[o>>2]=0;f[w>>2]=0;f[x>>2]=0;q=y;f[q>>2]=0;f[q+4>>2]=0;f[l>>2]=-2113732603;f[z>>2]=o;SP(p,l);q=f[A>>2]|0;if(q|0?(K=q+12|0,q=f[K>>2]|0,f[K>>2]=q+-1,(q|0)==1):0)kL(p);f[A>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[C>>2]|0)>0){q=f[D>>2]|0;K=0;do{f[q+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[C>>2]|0))}K=f[E>>2]|0;if((K|0)!=(F|0))UC(K);L=b[G>>0]|0?-1:I;K=f[a>>2]|0;if(!K){J=21;break}else{M=a;N=K}a:while(1){K=N;while(1){if((f[K+16>>2]|0)>=(L|0))break;q=f[K+4>>2]|0;if(!q){O=M;break a}else K=q}N=f[K>>2]|0;if(!N){O=K;break}else M=K}if((O|0)==(a|0)){J=21;break}if((L|0)<(f[O+16>>2]|0)){J=21;break}q=f[e+24>>2]|0;P=f[e+20>>2]|0;Q=P;if((q|0)==(P|0)){R=f[o>>2]|0;if(!R)S=c;else{T=c;U=R;J=25}}else{R=f[O+20>>2]|0;V=+(I|0);W=f[o>>2]|0;X=q-P>>2;P=0;q=c;while(1){Y=f[Q+(P<<2)>>2]|0;Z=q*7|0;n[d+(Z<<2)>>2]=H;n[d+(Z+1<<2)>>2]=V;f[d+(Z+2<<2)>>2]=f[W+(Y<<2)>>2];f[d+(Z+3<<2)>>2]=f[R+(Y*24|0)>>2];f[d+(Z+4<<2)>>2]=f[R+(Y*24|0)+4>>2];f[d+(Z+5<<2)>>2]=f[R+(Y*24|0)+8>>2];f[d+(Z+6<<2)>>2]=f[R+(Y*24|0)+12>>2];P=P+1|0;Y=q+1|0;if(P>>>0>=X>>>0){T=Y;U=W;J=25;break}else q=Y}}if((J|0)==25){J=0;q=f[w>>2]|0;if((q|0)!=(U|0))f[w>>2]=q+(~((q+-4-U|0)>>>2)<<2);O5b(U);S=T}q=f[e+4>>2]|0;if(!q){W=e+8|0;X=f[W>>2]|0;if((f[X>>2]|0)==(e|0))_=X;else{X=W;do{W=f[X>>2]|0;X=W+8|0;P=f[X>>2]|0}while((f[P>>2]|0)!=(W|0));_=P}}else{X=q;while(1){P=f[X>>2]|0;if(!P)break;else X=P}_=X}if((_|0)==(r|0)){s=S;J=3;break}else{c=S;e=_}}if((J|0)==3){u=i;return s|0}else if((J|0)==5){f[k>>2]=I;hO(l,432347,k);Ogb(-2,l,432398,463)}else if((J|0)==21){f[j>>2]=L;hO(l,432416,j);Ogb(-2,l,432398,468)}return 0}function $gb(a,c){a=a|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0;d=+n[a>>2];e=+n[c>>2];f=d<e?e:d;g=+n[c+8>>2];h=+n[a+8>>2];i=g<h?g:h;if(i<f){j=0.0;return +j}k=+n[c+12>>2];l=+n[a+12>>2];m=k<l?k:l;o=+n[a+4>>2];p=+n[c+4>>2];q=o<p?p:o;if(m<q){j=0.0;return +j}r=(i-f)*(m-q);if(!(r>0.0)){j=0.0;return +j}do if(!(h<d|l<o))if(!(b[a+16>>0]|0)){s=(h-d)*(l-o);break}else{s=+n[a+20>>2];break}else s=0.0;while(0);do if(!(g<e|k<p))if(!(b[c+16>>0]|0)){t=(g-e)*(k-p);break}else{t=+n[c+20>>2];break}else t=0.0;while(0);j=r/(s+t-r);return +j}function ahb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=+d;e=+e;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=u;u=u+16|0;l=k+4|0;m=k;if((((f[a+4>>2]|0)-(f[a>>2]|0)|0)/24|0|0)!=((f[c+4>>2]|0)-(f[c>>2]|0)>>2|0)){f[l>>2]=0;f[l+4>>2]=0;n=aD(l,30)|0;o=432504;p=n+30|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,l,432535,432544,72);bD(l)}f[l>>2]=0;o=l+4|0;f[o>>2]=0;f[l+8>>2]=0;kgb(c,d,h,l);h=f[i>>2]|0;c=i+4|0;n=f[c>>2]|0;p=h;if((n|0)==(h|0)){q=n;r=h}else{s=n+(~((n+-4-p|0)>>>2)<<2)|0;f[c>>2]=s;q=s;r=s}s=q;q=f[o>>2]|0;n=f[l>>2]|0;t=n;a:do if((q|0)!=(n|0)){v=i+8|0;if(g<1.0){w=0;d=e;x=r;y=h;z=t;A=p;B=s;while(1){C=f[z+(w<<3)+4>>2]|0;f[m>>2]=C;if((B-A|0)>0){D=0;E=y;F=C;while(1){C=f[a>>2]|0;G=+yg[j&31](C+(F*24|0)|0,C+((f[E+(D<<2)>>2]|0)*24|0)|0)<=d;C=D+1|0;H=f[c>>2]|0;I=f[i>>2]|0;if(!(G&(C|0)<(H-I>>2|0)))break;D=C;E=I;F=f[m>>2]|0}if(G){J=H;K=9}else L=0}else{J=x;K=9}do if((K|0)==9){K=0;if((J|0)==(f[v>>2]|0)){IO(i,m);L=1;break}else{f[J>>2]=f[m>>2];f[c>>2]=J+4;L=1;break}}while(0);F=w+1|0;E=f[o>>2]|0;D=f[l>>2]|0;I=D;if(F>>>0>=E-D>>3>>>0){M=E;N=I;break a}E=f[c>>2]|0;D=f[i>>2]|0;w=F;d=d>.5&L?d*g:d;x=E;y=D;z=I;A=D;B=E}}else{B=0;A=r;z=h;y=t;x=p;w=s;while(1){E=f[y+(B<<3)+4>>2]|0;f[m>>2]=E;if((w-x|0)>0){D=0;I=z;F=E;while(1){E=f[a>>2]|0;O=+yg[j&31](E+(F*24|0)|0,E+((f[I+(D<<2)>>2]|0)*24|0)|0)<=e;E=D+1|0;P=f[c>>2]|0;C=f[i>>2]|0;if(!(O&(E|0)<(P-C>>2|0)))break;D=E;I=C;F=f[m>>2]|0}if(O){Q=P;K=25}}else{Q=A;K=25}do if((K|0)==25){K=0;if((Q|0)==(f[v>>2]|0)){IO(i,m);break}else{f[Q>>2]=f[m>>2];f[c>>2]=Q+4;break}}while(0);F=B+1|0;I=f[o>>2]|0;D=f[l>>2]|0;C=D;if(F>>>0>=I-D>>3>>>0){M=I;N=C;break a}I=f[c>>2]|0;D=f[i>>2]|0;B=F;A=I;z=D;y=C;x=D;w=I}}}else{M=q;N=t}while(0);t=M;if(!N){u=k;return}if((t|0)!=(N|0))f[o>>2]=t+(~((t+-8-N|0)>>>3)<<3);O5b(N);u=k;return}function bhb(a,c){a=a|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0;d=+n[a>>2];e=+n[c>>2];f=d<e?e:d;g=+n[c+8>>2];h=+n[a+8>>2];i=g<h?g:h;if(i<f){j=0.0;return +j}k=+n[c+12>>2];l=+n[a+12>>2];m=k<l?k:l;o=+n[a+4>>2];p=+n[c+4>>2];q=o<p?p:o;if(m<q){j=0.0;return +j}r=(i-f+1.0)*(m-q+1.0);if(!(r>0.0)){j=0.0;return +j}do if(!(h<d|l<o))if(!(b[a+16>>0]|0)){s=(h-d+1.0)*(l-o+1.0);break}else{s=+n[a+20>>2];break}else s=0.0;while(0);do if(!(g<e|k<p))if(!(b[c+16>>0]|0)){t=(g-e+1.0)*(k-p+1.0);break}else{t=+n[c+20>>2];break}else t=0.0;while(0);j=r/(s+t-r);return +j}function chb(a,b){a=a|0;b=b|0;return +n[a>>2]>+n[b>>2]|0}function dhb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=u;u=u+16|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-12|0;i=a+-8|0;j=a+-4|0;k=g;while(1){l=k;b:while(1){m=l;n=b-m|0;switch((n|0)/12|0|0){case 2:{o=5;break a;break}case 3:{o=7;break a;break}case 4:{o=8;break a;break}case 5:{o=9;break a;break}case 1:case 0:{o=53;break a;break}default:{}}if((n|0)<84){o=11;break a}p=l+(((n>>>0)/24|0)*12|0)|0;if((n|0)>11988){q=(n>>>0)/48|0;r=lhb(l,l+(q*12|0)|0,p,p+(q*12|0)|0,h,c)|0}else r=jhb(l,p,h,c)|0;if(Uh[f[c>>2]&1023](l,p)|0){s=h;t=r;break}else v=h;while(1){w=v+-12|0;if((l|0)==(w|0))break;if(Uh[f[c>>2]&1023](w,p)|0){o=36;break b}else v=w}q=l+12|0;if(Uh[f[c>>2]&1023](l,h)|0)x=q;else{if((q|0)==(h|0)){o=53;break a}else y=q;while(1){if(Uh[f[c>>2]&1023](l,y)|0)break;q=y+12|0;if((q|0)==(h|0)){o=53;break a}else y=q}q=f[y>>2]|0;f[y>>2]=f[h>>2];f[h>>2]=q;q=y+4|0;n=f[q>>2]|0;f[q>>2]=f[i>>2];f[i>>2]=n;n=y+8|0;q=f[n>>2]|0;f[n>>2]=f[j>>2];f[j>>2]=q;x=y+12|0}if((x|0)==(h|0)){o=53;break a}else{z=h;A=x}while(1){q=A;while(1){B=q+12|0;if(Uh[f[c>>2]&1023](l,q)|0){C=z;break}else q=B}while(1){D=C+-12|0;if(Uh[f[c>>2]&1023](l,D)|0)C=D;else break}if(q>>>0>=D>>>0){l=q;continue b}n=f[q>>2]|0;f[q>>2]=f[D>>2];f[D>>2]=n;n=q+4|0;E=C+-8|0;F=f[n>>2]|0;f[n>>2]=f[E>>2];f[E>>2]=F;F=q+8|0;E=C+-4|0;n=f[F>>2]|0;f[F>>2]=f[E>>2];f[E>>2]=n;z=D;A=B}}if((o|0)==36){o=0;n=f[l>>2]|0;f[l>>2]=f[w>>2];f[w>>2]=n;n=l+4|0;E=v+-8|0;F=f[n>>2]|0;f[n>>2]=f[E>>2];f[E>>2]=F;F=l+8|0;E=v+-4|0;n=f[F>>2]|0;f[F>>2]=f[E>>2];f[E>>2]=n;s=w;t=r+1|0}n=l+12|0;c:do if(n>>>0<s>>>0){E=p;F=s;G=n;H=t;while(1){I=G;while(1){J=I+12|0;if(Uh[f[c>>2]&1023](I,E)|0)I=J;else{K=F;break}}while(1){L=K+-12|0;if(Uh[f[c>>2]&1023](L,E)|0)break;else K=L}if(I>>>0>L>>>0){M=E;N=H;O=I;break c}q=f[I>>2]|0;f[I>>2]=f[L>>2];f[L>>2]=q;q=I+4|0;P=K+-8|0;Q=f[q>>2]|0;f[q>>2]=f[P>>2];f[P>>2]=Q;Q=I+8|0;P=K+-4|0;q=f[Q>>2]|0;f[Q>>2]=f[P>>2];f[P>>2]=q;E=(E|0)==(I|0)?L:E;F=L;G=J;H=H+1|0}}else{M=p;N=t;O=n}while(0);if((O|0)!=(M|0)?Uh[f[c>>2]&1023](M,O)|0:0){n=f[O>>2]|0;f[O>>2]=f[M>>2];f[M>>2]=n;n=O+4|0;H=M+4|0;G=f[n>>2]|0;f[n>>2]=f[H>>2];f[H>>2]=G;G=O+8|0;H=M+8|0;n=f[G>>2]|0;f[G>>2]=f[H>>2];f[H>>2]=n;R=N+1|0}else R=N;if(!R){S=mhb(l,O,c)|0;n=O+12|0;if(mhb(n,a,c)|0){o=52;break}if(S){k=n;continue}}n=O;if((n-m|0)>=(b-n|0)){o=51;break}dhb(l,O,c);k=O+12|0}if((o|0)==51){o=0;dhb(O+12|0,a,c);g=l;a=O;continue}else if((o|0)==52){o=0;if(S){o=53;break}else{g=l;a=O;continue}}}if((o|0)==5){if(!(Uh[f[c>>2]&1023](h,l)|0)){u=d;return}O=f[l>>2]|0;f[l>>2]=f[h>>2];f[h>>2]=O;O=l+4|0;g=f[O>>2]|0;f[O>>2]=f[i>>2];f[i>>2]=g;g=l+8|0;i=f[g>>2]|0;f[g>>2]=f[j>>2];f[j>>2]=i;u=d;return}else if((o|0)==7){jhb(l,l+12|0,h,c)|0;u=d;return}else if((o|0)==8){khb(l,l+12|0,l+24|0,h,c)|0;u=d;return}else if((o|0)==9){lhb(l,l+12|0,l+24|0,l+36|0,h,c)|0;u=d;return}else if((o|0)==11){h=l+24|0;jhb(l,l+12|0,h,c)|0;i=l+36|0;if((i|0)==(a|0)){u=d;return}j=e+4|0;g=e+8|0;O=i;i=h;while(1){if(Uh[f[c>>2]&1023](O,i)|0){f[e>>2]=f[O>>2];f[e+4>>2]=f[O+4>>2];f[e+8>>2]=f[O+8>>2];h=i;S=O;while(1){f[S>>2]=f[h>>2];T=h+4|0;f[S+4>>2]=f[T>>2];U=h+8|0;f[S+8>>2]=f[U>>2];if((h|0)==(l|0))break;m=h+-12|0;if(Uh[f[c>>2]&1023](e,m)|0){R=h;h=m;S=R}else break}f[h>>2]=f[e>>2];f[T>>2]=f[j>>2];f[U>>2]=f[g>>2]}S=O+12|0;if((S|0)==(a|0))break;else{R=O;O=S;i=R}}u=d;return}else if((o|0)==53){u=d;return}}function ehb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)c4b(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;O5b(d);return}function fhb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){Nac(g|0,0,b*12|0)|0;f[e>>2]=g+(b*12|0);return}h=f[a>>2]|0;i=g-h|0;g=(i|0)/12|0;j=g+b|0;if(j>>>0>357913941)c4b(a);k=(d-h|0)/12|0;d=k<<1;l=k>>>0<178956970?(d>>>0<j>>>0?j:d):357913941;do if(l)if(l>>>0>357913941){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{m=L5b(l*12|0)|0;break}else m=0;while(0);d=m+(g*12|0)|0;Nac(d|0,0,b*12|0)|0;g=d+(((i|0)/-12|0)*12|0)|0;if((i|0)>0)Vac(g|0,h|0,i|0)|0;f[a>>2]=g;f[e>>2]=d+(b*12|0);f[c>>2]=m+(l*12|0);if(!h)return;O5b(h);return}function ghb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){if((j|0)>=(i|0)){f[c>>2]=b;f[d>>2]=b;k=d;return k|0}d=h+4|0;j=f[d>>2]|0;if(!j){l=h+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));n=o}}else{m=j;while(1){j=f[m>>2]|0;if(!j)break;else m=j}n=m}if((n|0)!=(g|0)?(i|0)>=(f[n+16>>2]|0):0){m=f[g>>2]|0;if(!m){f[c>>2]=g;k=g;return k|0}j=a+4|0;o=m;while(1){m=f[o+16>>2]|0;if((i|0)<(m|0)){l=f[o>>2]|0;if(!l){p=39;break}else{q=o;r=l}}else{if((m|0)>=(i|0)){p=43;break}s=o+4|0;m=f[s>>2]|0;if(!m){p=42;break}else{q=s;r=m}}j=q;o=r}if((p|0)==39){f[c>>2]=o;k=o;return k|0}else if((p|0)==42){f[c>>2]=o;k=s;return k|0}else if((p|0)==43){f[c>>2]=o;k=j;return k|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;k=d;return k|0}else{f[c>>2]=n;k=n;return k|0}}n=f[h>>2]|0;if((h|0)!=(f[a>>2]|0)){if(!n){d=h;while(1){j=f[d+8>>2]|0;if((f[j>>2]|0)==(d|0))d=j;else{t=j;break}}}else{d=n;while(1){j=f[d+4>>2]|0;if(!j){t=d;break}else d=j}}d=f[e>>2]|0;if((f[t+16>>2]|0)>=(d|0)){e=f[g>>2]|0;if(!e){f[c>>2]=g;k=g;return k|0}g=a+4|0;a=e;while(1){e=f[a+16>>2]|0;if((d|0)<(e|0)){j=f[a>>2]|0;if(!j){p=17;break}else{u=a;v=j}}else{if((e|0)>=(d|0)){p=21;break}w=a+4|0;e=f[w>>2]|0;if(!e){p=20;break}else{u=w;v=e}}g=u;a=v}if((p|0)==17){f[c>>2]=a;k=a;return k|0}else if((p|0)==20){f[c>>2]=a;k=w;return k|0}else if((p|0)==21){f[c>>2]=a;k=g;return k|0}}else x=t}else x=b;if(!n){f[c>>2]=h;k=h;return k|0}else{h=x;f[c>>2]=h;k=h+4|0;return k|0}return 0}function hhb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+48|0;d=c+32|0;e=c+28|0;g=c+24|0;h=c+20|0;i=c;j=f[a>>2]|0;k=((f[a+4>>2]|0)-j|0)/12|0;l=k+1|0;if(l>>>0>357913941)c4b(a);m=((f[a+8>>2]|0)-j|0)/12|0;j=m<<1;n=m>>>0<178956970?(j>>>0<l>>>0?l:j):357913941;f[i+12>>2]=0;f[i+16>>2]=a+8;do if(n)if(n>>>0>357913941){j=ze(8)|0;T5b(j,477177);f[j>>2]=149528;If(j|0,25408,1411)}else{o=L5b(n*12|0)|0;break}else o=0;while(0);f[i>>2]=o;j=o+(k*12|0)|0;l=i+8|0;f[l>>2]=j;m=i+4|0;f[m>>2]=j;f[i+12>>2]=o+(n*12|0);n=o+(k*12|0)+4|0;f[n>>2]=0;p=o+(k*12|0)+8|0;f[p>>2]=0;q=o+(k*12|0)+4|0;f[j>>2]=q;k=f[b>>2]|0;o=b+4|0;if((k|0)==(o|0))r=j;else{b=q;q=k;while(1){k=q+16|0;f[h>>2]=b;f[d>>2]=f[h>>2];s=ghb(j,d,e,g,k)|0;if(!(f[s>>2]|0)){t=L5b(32)|0;f[t+16>>2]=f[k>>2];Bua(t+20|0,q+20|0);k=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=k;f[s>>2]=t;k=f[f[j>>2]>>2]|0;if(!k)v=t;else{f[j>>2]=k;v=f[s>>2]|0}mP(f[n>>2]|0,v);f[p>>2]=(f[p>>2]|0)+1}s=f[q+4>>2]|0;if(!s){k=q+8|0;t=f[k>>2]|0;if((f[t>>2]|0)==(q|0))w=t;else{t=k;do{k=f[t>>2]|0;t=k+8|0;x=f[t>>2]|0}while((f[x>>2]|0)!=(k|0));w=x}}else{t=s;while(1){x=f[t>>2]|0;if(!x)break;else t=x}w=t}if((w|0)==(o|0))break;else q=w}r=f[l>>2]|0}f[l>>2]=r+12;ihb(a,i);a=f[m>>2]|0;m=f[l>>2]|0;if((m|0)!=(a|0)){r=m;do{m=r+-12|0;f[l>>2]=m;owa(m,f[r+-8>>2]|0);r=f[l>>2]|0}while((r|0)!=(a|0))}a=f[i>>2]|0;if(!a){u=c;return}O5b(a);u=c;return}function ihb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;i=f[a>>2]|0;j=a+4|0;k=f[j>>2]|0;l=b+4|0;if((k|0)==(i|0)){m=l;n=a;o=f[l>>2]|0;p=i;f[n>>2]=o;f[m>>2]=p;q=b+8|0;r=f[j>>2]|0;s=f[q>>2]|0;f[j>>2]=s;f[q>>2]=r;t=a+8|0;v=b+12|0;w=f[t>>2]|0;x=f[v>>2]|0;f[t>>2]=x;f[v>>2]=w;y=f[m>>2]|0;f[b>>2]=y;u=c;return}z=k;k=f[l>>2]|0;do{A=k+-12|0;B=z;z=z+-12|0;C=k+-8|0;f[C>>2]=0;D=k+-4|0;f[D>>2]=0;E=k+-8|0;f[A>>2]=E;F=f[z>>2]|0;G=B+-8|0;if((F|0)!=(G|0)){B=E;E=F;while(1){F=E+16|0;f[h>>2]=B;f[d>>2]=f[h>>2];H=ghb(A,d,e,g,F)|0;if(!(f[H>>2]|0)){I=L5b(32)|0;f[I+16>>2]=f[F>>2];Bua(I+20|0,E+20|0);F=f[e>>2]|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=F;f[H>>2]=I;F=f[f[A>>2]>>2]|0;if(!F)J=I;else{f[A>>2]=F;J=f[H>>2]|0}mP(f[C>>2]|0,J);f[D>>2]=(f[D>>2]|0)+1}H=f[E+4>>2]|0;if(!H){F=E+8|0;I=f[F>>2]|0;if((f[I>>2]|0)==(E|0))K=I;else{I=F;do{F=f[I>>2]|0;I=F+8|0;L=f[I>>2]|0}while((f[L>>2]|0)!=(F|0));K=L}}else{I=H;while(1){L=f[I>>2]|0;if(!L)break;else I=L}K=I}if((K|0)==(G|0))break;else E=K}}k=(f[l>>2]|0)+-12|0;f[l>>2]=k}while((z|0)!=(i|0));m=l;n=a;o=k;p=f[a>>2]|0;f[n>>2]=o;f[m>>2]=p;q=b+8|0;r=f[j>>2]|0;s=f[q>>2]|0;f[j>>2]=s;f[q>>2]=r;t=a+8|0;v=b+12|0;w=f[t>>2]|0;x=f[v>>2]|0;f[t>>2]=x;f[v>>2]=w;y=f[m>>2]|0;f[b>>2]=y;u=c;return}function jhb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=Uh[f[d>>2]&1023](b,a)|0;g=Uh[f[d>>2]&1023](c,b)|0;if(!e){if(!g){h=0;return h|0}e=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=e;e=b+4|0;i=c+4|0;j=f[e>>2]|0;f[e>>2]=f[i>>2];f[i>>2]=j;j=b+8|0;i=c+8|0;k=f[j>>2]|0;f[j>>2]=f[i>>2];f[i>>2]=k;if(!(Uh[f[d>>2]&1023](b,a)|0)){h=1;return h|0}k=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=k;k=a+4|0;i=f[k>>2]|0;f[k>>2]=f[e>>2];f[e>>2]=i;i=a+8|0;e=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=e;h=2;return h|0}e=f[a>>2]|0;if(g){f[a>>2]=f[c>>2];f[c>>2]=e;g=a+4|0;j=c+4|0;i=f[g>>2]|0;f[g>>2]=f[j>>2];f[j>>2]=i;i=a+8|0;j=c+8|0;g=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=g;h=1;return h|0}f[a>>2]=f[b>>2];f[b>>2]=e;e=a+4|0;g=b+4|0;j=f[e>>2]|0;f[e>>2]=f[g>>2];f[g>>2]=j;j=a+8|0;a=b+8|0;e=f[j>>2]|0;f[j>>2]=f[a>>2];f[a>>2]=e;if(!(Uh[f[d>>2]&1023](c,b)|0)){h=1;return h|0}d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;d=c+4|0;b=f[g>>2]|0;f[g>>2]=f[d>>2];f[d>>2]=b;b=c+8|0;c=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=c;h=2;return h|0}function khb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=jhb(a,b,c,e)|0;if(!(Uh[f[e>>2]&1023](d,c)|0)){h=g;return h|0}i=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=i;i=c+4|0;j=d+4|0;k=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=k;k=c+8|0;j=d+8|0;d=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=d;if(!(Uh[f[e>>2]&1023](c,b)|0)){h=g+1|0;return h|0}d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;d=b+4|0;c=f[d>>2]|0;f[d>>2]=f[i>>2];f[i>>2]=c;c=b+8|0;i=f[c>>2]|0;f[c>>2]=f[k>>2];f[k>>2]=i;if(!(Uh[f[e>>2]&1023](b,a)|0)){h=g+2|0;return h|0}e=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=e;e=a+4|0;b=f[e>>2]|0;f[e>>2]=f[d>>2];f[d>>2]=b;b=a+8|0;a=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=a;h=g+3|0;return h|0}function lhb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=khb(a,b,c,d,g)|0;if(!(Uh[f[g>>2]&1023](e,d)|0)){i=h;return i|0}j=f[d>>2]|0;f[d>>2]=f[e>>2];f[e>>2]=j;j=d+4|0;k=e+4|0;l=f[j>>2]|0;f[j>>2]=f[k>>2];f[k>>2]=l;l=d+8|0;k=e+8|0;e=f[l>>2]|0;f[l>>2]=f[k>>2];f[k>>2]=e;if(!(Uh[f[g>>2]&1023](d,c)|0)){i=h+1|0;return i|0}e=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=e;e=c+4|0;d=f[e>>2]|0;f[e>>2]=f[j>>2];f[j>>2]=d;d=c+8|0;j=f[d>>2]|0;f[d>>2]=f[l>>2];f[l>>2]=j;if(!(Uh[f[g>>2]&1023](c,b)|0)){i=h+2|0;return i|0}j=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=j;j=b+4|0;c=f[j>>2]|0;f[j>>2]=f[e>>2];f[e>>2]=c;c=b+8|0;e=f[c>>2]|0;f[c>>2]=f[d>>2];f[d>>2]=e;if(!(Uh[f[g>>2]&1023](b,a)|0)){i=h+3|0;return i|0}g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;b=f[g>>2]|0;f[g>>2]=f[j>>2];f[j>>2]=b;b=a+8|0;a=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=a;i=h+4|0;return i|0}function mhb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;switch((b-a|0)/12|0|0){case 2:{g=b+-12|0;if(!(Uh[f[c>>2]&1023](g,a)|0)){h=1;u=d;return h|0}i=f[a>>2]|0;f[a>>2]=f[g>>2];f[g>>2]=i;i=a+4|0;g=b+-8|0;j=f[i>>2]|0;f[i>>2]=f[g>>2];f[g>>2]=j;j=a+8|0;g=b+-4|0;i=f[j>>2]|0;f[j>>2]=f[g>>2];f[g>>2]=i;h=1;u=d;return h|0}case 3:{jhb(a,a+12|0,b+-12|0,c)|0;h=1;u=d;return h|0}case 4:{khb(a,a+12|0,a+24|0,b+-12|0,c)|0;h=1;u=d;return h|0}case 5:{lhb(a,a+12|0,a+24|0,a+36|0,b+-12|0,c)|0;h=1;u=d;return h|0}case 1:case 0:{h=1;u=d;return h|0}default:{i=a+24|0;jhb(a,a+12|0,i,c)|0;g=a+36|0;a:do if((g|0)==(b|0)){k=1;l=0}else{j=e+4|0;m=e+8|0;n=g;o=0;p=i;while(1){if(Uh[f[c>>2]&1023](n,p)|0){f[e>>2]=f[n>>2];f[e+4>>2]=f[n+4>>2];f[e+8>>2]=f[n+8>>2];q=p;r=n;while(1){f[r>>2]=f[q>>2];s=q+4|0;f[r+4>>2]=f[s>>2];t=q+8|0;f[r+8>>2]=f[t>>2];if((q|0)==(a|0))break;v=q+-12|0;if(Uh[f[c>>2]&1023](e,v)|0){w=q;q=v;r=w}else break}f[q>>2]=f[e>>2];f[s>>2]=f[j>>2];f[t>>2]=f[m>>2];r=o+1|0;if((r|0)==8){k=0;l=(n+12|0)==(b|0);break a}else x=r}else x=o;r=n+12|0;if((r|0)==(b|0)){k=1;l=0;break}else{w=n;n=r;o=x;p=w}}}while(0);h=l|k;u=d;return h|0}}return 0}function nhb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=f[a+8>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/12|0)>>>0>=b>>>0){i=b;j=h;do{f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=j+4;j=(f[g>>2]|0)+12|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);u=c;return}i=f[a>>2]|0;j=(h-i|0)/12|0;h=j+b|0;if(h>>>0>357913941)c4b(a);g=(e-i|0)/12|0;i=g<<1;e=g>>>0<178956970?(i>>>0<h>>>0?h:i):357913941;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(e)if(e>>>0>357913941){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{k=L5b(e*12|0)|0;break}else k=0;while(0);f[d>>2]=k;i=k+(j*12|0)|0;j=d+8|0;f[j>>2]=i;g=d+4|0;f[g>>2]=i;f[d+12>>2]=k+(e*12|0);e=b;b=i;while(1){f[b+4>>2]=0;f[b+8>>2]=0;f[b>>2]=b+4;e=e+-1|0;if(!e)break;else b=b+12|0}f[j>>2]=k+(h*12|0);shb(a,d);a=f[g>>2]|0;g=f[j>>2]|0;if((g|0)!=(a|0)){h=g;do{g=h+-12|0;f[j>>2]=g;Ygb(g,f[h+-8>>2]|0);h=f[j>>2]|0}while((h|0)!=(a|0))}a=f[d>>2]|0;if(a|0)O5b(a);u=c;return}function ohb(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;l=u;u=u+16|0;m=l;n=a+4|0;o=f[n>>2]|0;p=f[a>>2]|0;if(((o-p|0)/24|0|0)==(((f[c+4>>2]|0)-(f[c>>2]|0)|0)/12|0|0)){q=p;r=o}else{f[m>>2]=0;f[m+4>>2]=0;s=aD(m,45)|0;t=432666;v=s+45|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,m,432712,431818,660);bD(m);q=f[a>>2]|0;r=f[n>>2]|0}if((r-q|0)==((f[j+4>>2]|0)-(f[j>>2]|0)|0)){w=q;x=r}else{f[m>>2]=0;f[m+4>>2]=0;s=aD(m,36)|0;t=432725;v=s+36|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,m,432712,431818,661);bD(m);w=f[a>>2]|0;x=f[n>>2]|0}n=x-w|0;w=(n|0)/24|0;if(n|0?(x=f[c>>2]|0,((f[x+4>>2]|0)-(f[x>>2]|0)|0)!=16):0){f[m>>2]=0;f[m+4>>2]=0;s=aD(m,49)|0;t=432762;v=s+49|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,m,432712,431818,663);bD(m)}m=f[k>>2]|0;t=k+4|0;s=f[t>>2]|0;v=m;if((s|0)==(m|0))y=s;else{x=s+(~(((s+-24-v|0)>>>0)/24|0)*24|0)|0;f[t>>2]=x;y=x}x=(y-v|0)/24|0;if(w>>>0<=x>>>0){if(w>>>0<x>>>0?(v=m+(w*24|0)|0,(y|0)!=(v|0)):0)f[t>>2]=y+(~(((y+-24-v|0)>>>0)/24|0)*24|0)}else phb(k,w-x|0);x=(n|0)!=0;if(e){if(!x){u=l;return}e=0;do{qhb((f[a>>2]|0)+(e*24|0)|0,(f[c>>2]|0)+(e*12|0)|0,d,g,h,i,(f[j>>2]|0)+(e*24|0)|0,(f[k>>2]|0)+(e*24|0)|0);e=e+1|0}while(e>>>0<w>>>0);u=l;return}else{if(!x){u=l;return}x=0;do{rhb((f[a>>2]|0)+(x*24|0)|0,(f[c>>2]|0)+(x*12|0)|0,d,g,h,i,(f[j>>2]|0)+(x*24|0)|0,(f[k>>2]|0)+(x*24|0)|0);x=x+1|0}while(x>>>0<w>>>0);u=l;return}}function phb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(((e-h|0)/24|0)>>>0>=c>>>0){i=c;j=h;do{n[j+20>>2]=0.0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;b[j+16>>0]=0;j=(f[g>>2]|0)+24|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=(h-i|0)/24|0;h=j+c|0;if(h>>>0>178956970)c4b(a);k=(e-i|0)/24|0;i=k<<1;e=k>>>0<89478485?(i>>>0<h>>>0?h:i):178956970;do if(e)if(e>>>0>178956970){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{l=L5b(e*24|0)|0;break}else l=0;while(0);i=l+(j*24|0)|0;j=l+(e*24|0)|0;e=c;c=i;l=i;do{n[l+20>>2]=0.0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;b[l+16>>0]=0;l=c+24|0;c=l;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;l=(f[g>>2]|0)-e|0;h=i+(((l|0)/-24|0)*24|0)|0;if((l|0)>0)Vac(h|0,e|0,l|0)|0;f[a>>2]=h;f[g>>2]=c;f[d>>2]=j;if(!e)return;O5b(e);return}function qhb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;c=u;u=u+16|0;k=c;l=+n[i>>2];m=+n[i+4>>2];o=+n[i+8>>2];p=+n[i+12>>2];i=f[d>>2]|0;if((i|0)!=431942?(d=(i|0)==0?1124530:i,(gTb(d,431942)|0)!=0):0){if((i|0)!=431930?gTb(d,431930)|0:0){f[k>>2]=0;f[k+4>>2]=0;q=aD(k,13)|0;r=432856;t=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(t|0));Ogb(-5,k,432828,637)}v=+n[a+8>>2]-+n[a>>2];d=a+4|0;w=+n[a+12>>2]-+n[d>>2];x=h?w:w+1.0;w=h?v:v+1.0;if(!(w>0.0)){f[k>>2]=0;f[k+4>>2]=0;q=aD(k,15)|0;r=432812;t=q+15|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(t|0));bO(-215,k,432828,431818,620);bD(k)}if(!(x>0.0)){f[k>>2]=0;f[k+4>>2]=0;q=aD(k,16)|0;r=432839;t=q+16|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(t|0));bO(-215,k,432828,431818,621);bD(k)}v=m*x+(x*.5+ +n[d>>2]);y=x*+V(+p);x=l*w+(w*.5+ +n[a>>2]);z=w*+V(+o)*.5;w=x-z;n[j>>2]=w;A=v;v=y*.5;y=A-v;n[j+4>>2]=y;B=x+z;n[j+8>>2]=B;C=y;D=B;E=A+v;F=w}else{w=l+ +n[a>>2];n[j>>2]=w;l=m+ +n[a+4>>2];n[j+4>>2]=l;m=o+ +n[a+8>>2];n[j+8>>2]=m;C=l;D=m;E=p+ +n[a+12>>2];F=w}a=j+12|0;n[a>>2]=E;if(e){e=g+8|0;d=+n[e>>2]<F?e:j;k=f[(+n[d>>2]<+n[g>>2]?g:d)>>2]|0;f[j>>2]=k;d=j+4|0;r=g+12|0;q=+n[r>>2]<C?r:d;t=g+4|0;i=f[(+n[q>>2]<+n[t>>2]?t:q)>>2]|0;f[d>>2]=i;d=j+8|0;q=+n[e>>2]<D?e:d;e=f[(+n[q>>2]<+n[g>>2]?g:q)>>2]|0;f[d>>2]=e;d=+n[r>>2]<E?r:a;r=f[(+n[d>>2]<+n[t>>2]?t:d)>>2]|0;f[a>>2]=r;w=(f[s>>2]=e,+n[s>>2]);p=(f[s>>2]=k,+n[s>>2]);m=(f[s>>2]=r,+n[s>>2]);G=p;H=w;I=(f[s>>2]=i,+n[s>>2]);J=m}else{G=F;H=D;I=C;J=E}i=j+20|0;n[i>>2]=0.0;r=j+16|0;b[r>>0]=0;if(H<G|J<I){K=0.0;n[i>>2]=K;b[r>>0]=1;u=c;return}E=H-G;G=J-I;if(h){K=E*G;n[i>>2]=K;b[r>>0]=1;u=c;return}else{K=(E+1.0)*(G+1.0);n[i>>2]=K;b[r>>0]=1;u=c;return}}function rhb(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0;k=u;u=u+16|0;l=k;m=f[c>>2]|0;o=+n[m>>2]*+n[i>>2];p=+n[m+4>>2]*+n[i+4>>2];q=+n[m+8>>2]*+n[i+8>>2];r=+n[m+12>>2]*+n[i+12>>2];i=f[d>>2]|0;if((i|0)!=431942?(d=(i|0)==0?1124530:i,(gTb(d,431942)|0)!=0):0){if((i|0)!=431930?gTb(d,431930)|0:0){f[l>>2]=0;f[l+4>>2]=0;t=aD(l,13)|0;v=432856;w=t+13|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));Ogb(-5,l,432828,637)}x=+n[a+8>>2]-+n[a>>2];d=a+4|0;y=+n[a+12>>2]-+n[d>>2];z=h?y:y+1.0;y=h?x:x+1.0;if(!(y>0.0)){f[l>>2]=0;f[l+4>>2]=0;t=aD(l,15)|0;v=432812;w=t+15|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,l,432828,431818,620);bD(l)}if(!(z>0.0)){f[l>>2]=0;f[l+4>>2]=0;t=aD(l,16)|0;v=432839;w=t+16|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,l,432828,431818,621);bD(l)}x=p*z+(z*.5+ +n[d>>2]);A=z*+V(+r);z=o*y+(y*.5+ +n[a>>2]);B=y*+V(+q)*.5;y=z-B;n[j>>2]=y;C=x;x=A*.5;A=C-x;n[j+4>>2]=A;D=z+B;n[j+8>>2]=D;E=C+x;F=y;G=A;H=D}else{D=o+ +n[a>>2];n[j>>2]=D;o=p+ +n[a+4>>2];n[j+4>>2]=o;p=q+ +n[a+8>>2];n[j+8>>2]=p;E=r+ +n[a+12>>2];F=D;G=o;H=p}a=j+12|0;n[a>>2]=E;if(e){e=g+8|0;d=+n[e>>2]<F?e:j;l=f[(+n[d>>2]<+n[g>>2]?g:d)>>2]|0;f[j>>2]=l;d=j+4|0;v=g+12|0;t=+n[v>>2]<G?v:d;w=g+4|0;i=f[(+n[t>>2]<+n[w>>2]?w:t)>>2]|0;f[d>>2]=i;d=j+8|0;t=+n[e>>2]<H?e:d;e=f[(+n[t>>2]<+n[g>>2]?g:t)>>2]|0;f[d>>2]=e;d=+n[v>>2]<E?v:a;v=f[(+n[d>>2]<+n[w>>2]?w:d)>>2]|0;f[a>>2]=v;p=(f[s>>2]=e,+n[s>>2]);o=(f[s>>2]=l,+n[s>>2]);D=(f[s>>2]=v,+n[s>>2]);I=o;J=p;K=(f[s>>2]=i,+n[s>>2]);L=D}else{I=F;J=H;K=G;L=E}i=j+20|0;n[i>>2]=0.0;v=j+16|0;b[v>>0]=0;if(J<I|L<K){M=0.0;n[i>>2]=M;b[v>>0]=1;u=k;return}E=J-I;I=L-K;if(h){M=E*I;n[i>>2]=M;b[v>>0]=1;u=k;return}else{M=(E+1.0)*(I+1.0);n[i>>2]=M;b[v>>0]=1;u=k;return}}function shb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;i=f[a>>2]|0;j=a+4|0;k=f[j>>2]|0;l=b+4|0;if((k|0)==(i|0)){m=l;n=a;o=f[l>>2]|0;p=i;f[n>>2]=o;f[m>>2]=p;q=b+8|0;r=f[j>>2]|0;s=f[q>>2]|0;f[j>>2]=s;f[q>>2]=r;t=a+8|0;v=b+12|0;w=f[t>>2]|0;x=f[v>>2]|0;f[t>>2]=x;f[v>>2]=w;y=f[m>>2]|0;f[b>>2]=y;u=c;return}z=k;k=f[l>>2]|0;do{A=k+-12|0;B=z;z=z+-12|0;C=k+-8|0;f[C>>2]=0;D=k+-4|0;f[D>>2]=0;E=k+-8|0;f[A>>2]=E;F=f[z>>2]|0;G=B+-8|0;if((F|0)!=(G|0)){B=E;E=F;while(1){F=E+16|0;f[h>>2]=B;f[d>>2]=f[h>>2];H=thb(A,d,e,g,F)|0;if(!(f[H>>2]|0)){I=L5b(32)|0;f[I+16>>2]=f[F>>2];uhb(I+20|0,E+20|0);F=f[e>>2]|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=F;f[H>>2]=I;F=f[f[A>>2]>>2]|0;if(!F)J=I;else{f[A>>2]=F;J=f[H>>2]|0}mP(f[C>>2]|0,J);f[D>>2]=(f[D>>2]|0)+1}H=f[E+4>>2]|0;if(!H){F=E+8|0;I=f[F>>2]|0;if((f[I>>2]|0)==(E|0))K=I;else{I=F;do{F=f[I>>2]|0;I=F+8|0;L=f[I>>2]|0}while((f[L>>2]|0)!=(F|0));K=L}}else{I=H;while(1){L=f[I>>2]|0;if(!L)break;else I=L}K=I}if((K|0)==(G|0))break;else E=K}}k=(f[l>>2]|0)+-12|0;f[l>>2]=k}while((z|0)!=(i|0));m=l;n=a;o=k;p=f[a>>2]|0;f[n>>2]=o;f[m>>2]=p;q=b+8|0;r=f[j>>2]|0;s=f[q>>2]|0;f[j>>2]=s;f[q>>2]=r;t=a+8|0;v=b+12|0;w=f[t>>2]|0;x=f[v>>2]|0;f[t>>2]=x;f[v>>2]=w;y=f[m>>2]|0;f[b>>2]=y;u=c;return}function thb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){if((j|0)>=(i|0)){f[c>>2]=b;f[d>>2]=b;k=d;return k|0}d=h+4|0;j=f[d>>2]|0;if(!j){l=h+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));n=o}}else{m=j;while(1){j=f[m>>2]|0;if(!j)break;else m=j}n=m}if((n|0)!=(g|0)?(i|0)>=(f[n+16>>2]|0):0){m=f[g>>2]|0;if(!m){f[c>>2]=g;k=g;return k|0}j=a+4|0;o=m;while(1){m=f[o+16>>2]|0;if((i|0)<(m|0)){l=f[o>>2]|0;if(!l){p=39;break}else{q=o;r=l}}else{if((m|0)>=(i|0)){p=43;break}s=o+4|0;m=f[s>>2]|0;if(!m){p=42;break}else{q=s;r=m}}j=q;o=r}if((p|0)==39){f[c>>2]=o;k=o;return k|0}else if((p|0)==42){f[c>>2]=o;k=s;return k|0}else if((p|0)==43){f[c>>2]=o;k=j;return k|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;k=d;return k|0}else{f[c>>2]=n;k=n;return k|0}}n=f[h>>2]|0;if((h|0)!=(f[a>>2]|0)){if(!n){d=h;while(1){j=f[d+8>>2]|0;if((f[j>>2]|0)==(d|0))d=j;else{t=j;break}}}else{d=n;while(1){j=f[d+4>>2]|0;if(!j){t=d;break}else d=j}}d=f[e>>2]|0;if((f[t+16>>2]|0)>=(d|0)){e=f[g>>2]|0;if(!e){f[c>>2]=g;k=g;return k|0}g=a+4|0;a=e;while(1){e=f[a+16>>2]|0;if((d|0)<(e|0)){j=f[a>>2]|0;if(!j){p=17;break}else{u=a;v=j}}else{if((e|0)>=(d|0)){p=21;break}w=a+4|0;e=f[w>>2]|0;if(!e){p=20;break}else{u=w;v=e}}g=u;a=v}if((p|0)==17){f[c>>2]=a;k=a;return k|0}else if((p|0)==20){f[c>>2]=a;k=w;return k|0}else if((p|0)==21){f[c>>2]=a;k=g;return k|0}}else x=t}else x=b;if(!n){f[c>>2]=h;k=h;return k|0}else{h=x;f[c>>2]=h;k=h+4|0;return k|0}return 0}function uhb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/24|0;if(!e)return;if(g>>>0>178956970)c4b(a);h=L5b(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*24|0);g=f[b>>2]|0;b=(f[d>>2]|0)-g|0;if((b|0)<=0)return;Vac(h|0,g|0,b|0)|0;f[c>>2]=h+(((b>>>0)/24|0)*24|0);return}function vhb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){Nac(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;k=j+b|0;l=i;if(k>>>0>357913941)c4b(a);m=(d-i|0)/12|0;i=m<<1;d=m>>>0<178956970?(i>>>0<k>>>0?k:i):357913941;do if(d)if(d>>>0>357913941){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{n=L5b(d*12|0)|0;break}else n=0;while(0);i=n+(j*12|0)|0;j=i;k=n+(d*12|0)|0;Nac(i|0,0,b*12|0)|0;d=i+(b*12|0)|0;if((h|0)==(l|0)){o=j;p=g;q=h}else{g=h;h=j;j=i;do{g=g+-12|0;HA(j+-12|0,g);j=h+-12|0;h=j}while((g|0)!=(l|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=d;f[c>>2]=k;k=p;if((q|0)!=(k|0)){c=q;do{q=c;c=c+-12|0;d=f[c>>2]|0;if(d|0){e=q+-8|0;q=f[e>>2]|0;if((q|0)!=(d|0))f[e>>2]=q+(~((q+-4-d|0)>>>2)<<2);O5b(d)}}while((c|0)!=(k|0))}if(!p)return;O5b(p);return}function whb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0;d=u;u=u+64|0;e=d+48|0;g=d+8|0;h=d;f[e>>2]=0;f[e+4>>2]=0;i=aD(e,11)|0;j=433114;k=i+11|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));l=c+4|0;m=f[l>>2]|0;do if(m){o=f[e>>2]|0;p=(o|0)==0?1124530:o;q=l;r=m;a:while(1){s=r;while(1){t=f[s+16>>2]|0;if((t|0)==(o|0))break;if((gTb((t|0)==0?1124530:t,p)|0)>=0)break;t=f[s+4>>2]|0;if(!t){v=q;break a}else s=t}r=f[s>>2]|0;if(!r){v=s;break}else q=s}if((v|0)!=(l|0)){q=f[v+16>>2]|0;if((o|0)!=(q|0)?(gTb(p,(q|0)==0?1124530:q)|0)<=-1:0){w=12;break}q=Gwa(v+24|0,-1)|0;r=(q|0)==0&(J|0)==0;bD(e);if(r){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,13)|0;j=433126;k=i+13|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));p=f[l>>2]|0;do if(p){o=f[g>>2]|0;r=(o|0)==0?1124530:o;q=l;t=p;b:while(1){x=t;while(1){y=f[x+16>>2]|0;if((y|0)==(o|0))break;if((gTb((y|0)==0?1124530:y,r)|0)>=0)break;y=f[x+4>>2]|0;if(!y){z=q;break b}else x=y}t=f[x>>2]|0;if(!t){z=x;break}else q=x}if((z|0)!=(l|0)){q=f[z+16>>2]|0;if((o|0)!=(q|0)?(gTb(r,(q|0)==0?1124530:q)|0)<=-1:0){A=.5;break}A=+Hya(z+24|0,-1)}else A=.5}else A=.5;while(0);B=1.0-A;bD(g);n[e>>2]=B;if(!(B>0.0)){f[g>>2]=0;f[g+4>>2]=0;i=aD(g,9)|0;j=433140;k=i+9|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,g,440241,433150,103);bD(g)}f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=g+4;p=g+12|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;p=c+24|0;q=g+24|0;if((g|0)!=(c|0)){bD(q);t=f[p>>2]|0;if(!t)C=0;else{s=t+-4|0;f[s>>2]=(f[s>>2]|0)+1;C=f[p>>2]|0}f[q>>2]=C;f[g+28>>2]=f[c+28>>2]}q=g+32|0;bD(q);p=aD(q,5)|0;b[p>>0]=b[433229]|0;b[p+1>>0]=b[433230]|0;b[p+2>>0]=b[433231]|0;b[p+3>>0]=b[433232]|0;b[p+4>>0]=b[433233]|0;f[h>>2]=0;f[h+4>>2]=0;p=aD(h,5)|0;b[p>>0]=b[439628]|0;b[p+1>>0]=b[439629]|0;b[p+2>>0]=b[439630]|0;b[p+3>>0]=b[439631]|0;b[p+4>>0]=b[439632]|0;Zwa(g,h,e)|0;bD(h);Wjb(h,g);p=f[h>>2]|0;f[a>>2]=p;f[a+4>>2]=f[h+4>>2];q=p;if(!p){D=h;E=q}else{p=q+4|0;f[p>>2]=(f[p>>2]|0)+1;D=h;E=f[h>>2]|0}if(E|0?(p=E+4|0,q=f[p>>2]|0,f[p>>2]=q+-1,(q|0)==1):0)bi[f[(f[E>>2]|0)+8>>2]&2047](E);f[D>>2]=0;fua(g);u=d;return}}else w=12}else w=12;while(0);if((w|0)==12)bD(e);e=L5b(36)|0;Jwa(e);f[e>>2]=123544;Kwa(e,c);c=L5b(16)|0;w=c+4|0;f[w>>2]=1;f[c>>2]=123644;f[c+8>>2]=e;f[a>>2]=c;f[a+4>>2]=e;f[w>>2]=(f[w>>2]|0)+1;e=f[w>>2]|0;f[w>>2]=e+-1;if((e|0)!=1){u=d;return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);u=d;return}function xhb(a){a=a|0;O5b(a);return}function yhb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function zhb(a){a=a|0;lua(a);O5b(a);return}function Ahb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+32|0;a=d+16|0;e=d;dQ(a,123688);g=f[c>>2]|0;h=(f[c+4>>2]|0)-g|0;i=(h|0)/56|0;a:do if((h|0)>0){j=e+8|0;k=e+4|0;l=0;m=g;while(1){n=f[(f[b>>2]|0)+(l<<2)>>2]|0;if((f[m+(l*56|0)+16>>2]|0)!=(f[n+16>>2]|0)){o=j;f[o>>2]=0;f[o+4>>2]=0;f[e>>2]=33619968;f[k>>2]=m+(l*56|0);SP(n,e)}n=l+1|0;if((n|0)>=(i|0))break a;l=n;m=f[c>>2]|0}}while(0);if(!(f[a+4>>2]|0)){u=d;return}u=d;return}function Bhb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,123656);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Chb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yua(a,b,c,d,e)|0;return 1}function Dhb(a,b){a=a|0;b=b|0;var c=0;c=L5b(44)|0;Ehb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=123728;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Ehb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0,z=0;d=u;u=u+16|0;e=d;Jwa(a);f[a>>2]=123748;Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,18)|0;h=433674;i=g+18|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j=c+4|0;c=f[j>>2]|0;do if(c){k=f[e>>2]|0;l=(k|0)==0?1124530:k;m=j;o=c;a:while(1){p=o;while(1){q=f[p+16>>2]|0;if((q|0)==(k|0))break;if((gTb((q|0)==0?1124530:q,l)|0)>=0)break;q=f[p+4>>2]|0;if(!q){r=m;break a}else p=q}o=f[p>>2]|0;if(!o){r=p;break}else m=p}if((r|0)!=(j|0)){m=f[r+16>>2]|0;if((k|0)!=(m|0)?(gTb(l,(m|0)==0?1124530:m)|0)<=-1:0){s=1;break}m=Gwa(r+24|0,-1)|0;s=(m|0)!=0|(J|0)!=0}else s=1}else s=1;while(0);b[a+40>>0]=s&1;bD(e);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,15)|0;h=433693;i=g+15|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));h=f[j>>2]|0;do if(h){g=f[e>>2]|0;i=(g|0)==0?1124530:g;s=j;r=h;b:while(1){c=r;while(1){m=f[c+16>>2]|0;if((m|0)==(g|0))break;if((gTb((m|0)==0?1124530:m,i)|0)>=0)break;m=f[c+4>>2]|0;if(!m){t=s;break b}else c=m}r=f[c>>2]|0;if(!r){t=c;break}else s=c}if((t|0)!=(j|0)){s=f[t+16>>2]|0;if((g|0)!=(s|0)?(gTb(i,(s|0)==0?1124530:s)|0)<=-1:0){v=0;break}s=Gwa(t+24|0,-1)|0;v=((s|0)!=0|(J|0)!=0)&1}else v=0}else v=0;while(0);b[a+41>>0]=v;bD(e);f[e>>2]=0;f[e+4>>2]=0;v=aD(e,3)|0;b[v>>0]=b[433709]|0;b[v+1>>0]=b[433710]|0;b[v+2>>0]=b[433711]|0;v=f[j>>2]|0;if(!v){w=1.0e-09;x=w;y=a+36|0;n[y>>2]=x;bD(e);u=d;return}t=f[e>>2]|0;h=(t|0)==0?1124530:t;s=j;r=v;c:while(1){v=r;while(1){l=f[v+16>>2]|0;if((l|0)==(t|0))break;if((gTb((l|0)==0?1124530:l,h)|0)>=0)break;l=f[v+4>>2]|0;if(!l){z=s;break c}else v=l}r=f[v>>2]|0;if(!r){z=v;break}else s=v}if((z|0)==(j|0)){w=1.0e-09;x=w;y=a+36|0;n[y>>2]=x;bD(e);u=d;return}j=f[z+16>>2]|0;if((t|0)!=(j|0)?(gTb(h,(j|0)==0?1124530:j)|0)<=-1:0){w=1.0e-09;x=w;y=a+36|0;n[y>>2]=x;bD(e);u=d;return}w=+Hya(z+24|0,-1);x=w;y=a+36|0;n[y>>2]=x;bD(e);u=d;return}function Fhb(a){a=a|0;O5b(a);return}function Ghb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Hhb(a){a=a|0;lua(a);O5b(a);return}function Ihb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0;e=u;u=u+352|0;g=e+328|0;h=e+312|0;i=e+304|0;j=e+248|0;k=e+192|0;l=e+48|0;m=e+16|0;o=e+136|0;q=e+80|0;r=e;dQ(i,123872);s=c+4|0;t=f[c>>2]|0;if((f[s>>2]|0)!=(t|0)){v=a+41|0;w=k+36|0;x=k+16|0;y=k+4|0;z=k+40|0;A=k+44|0;B=k+48|0;C=j+36|0;D=j+16|0;E=j+4|0;F=j+40|0;G=j+44|0;H=j+48|0;I=g+4|0;J=h+4|0;K=g+4|0;L=h+4|0;M=g+8|0;N=g+12|0;O=g+4|0;P=h+4|0;Q=h+8|0;R=h+12|0;S=a+40|0;T=r+8|0;U=r+12|0;V=g+8|0;W=g+4|0;X=q+36|0;Z=q+16|0;_=q+4|0;$=q+40|0;aa=q+44|0;ba=q+48|0;ca=o+36|0;da=o+16|0;ea=o+4|0;fa=o+40|0;ga=o+44|0;ha=o+48|0;ia=a+36|0;a=r+4|0;ja=0;ka=t;do{t=f[ka+(ja<<2)>>2]|0;la=f[d>>2]|0;ma=b[v>>0]|0?1:2;na=f[t+40>>2]|0;oa=1;pa=0;do{oa=Y(f[na+(pa<<2)>>2]|0,oa)|0;pa=pa+1|0}while((pa|0)<(ma|0));WL(j,t,1,oa);WL(k,la+(ja*56|0)|0,1,oa);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;if((oa|0)>0){ma=0;do{pa=ma;ma=ma+1|0;f[g>>2]=pa;f[I>>2]=ma;f[h>>2]=-2147483648;f[J>>2]=2147483647;lL(o,j,g,h);f[g>>2]=pa;f[K>>2]=ma;f[h>>2]=-2147483648;f[L>>2]=2147483647;lL(q,k,g,h);f[M>>2]=0;f[N>>2]=0;f[g>>2]=16842752;f[O>>2]=o;f[h>>2]=-1040056314;f[P>>2]=l;f[Q>>2]=1;f[R>>2]=4;if(!(b[S>>0]|0)){pa=UM()|0;na=pa;qa=f[na+4>>2]|0;ra=r;f[ra>>2]=f[na>>2];f[ra+4>>2]=qa;f[T>>2]=f[pa+8>>2];sa=f[pa+12>>2]|0}else{f[r>>2]=-1023279098;f[a>>2]=m;f[T>>2]=1;sa=4}f[U>>2]=sa;uG(g,h,r,UM()|0);if(!(b[S>>0]|0))ta=1.0;else ta=1.0/(+n[ia>>2]+ +p[m>>3]);pa=V;f[pa>>2]=0;f[pa+4>>2]=0;f[g>>2]=33619968;f[W>>2]=q;OJ(o,g,f[q>>2]&4095,ta,-(ta*+p[l>>3]));pa=f[X>>2]|0;if(pa|0?(qa=pa+12|0,pa=f[qa>>2]|0,f[qa>>2]=pa+-1,(pa|0)==1):0)kL(q);f[X>>2]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[_>>2]|0)>0){pa=f[$>>2]|0;qa=0;do{f[pa+(qa<<2)>>2]=0;qa=qa+1|0}while((qa|0)<(f[_>>2]|0))}qa=f[aa>>2]|0;if((qa|0)!=(ba|0))UC(qa);qa=f[ca>>2]|0;if(qa|0?(pa=qa+12|0,qa=f[pa>>2]|0,f[pa>>2]=qa+-1,(qa|0)==1):0)kL(o);f[ca>>2]=0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[ea>>2]|0)>0){qa=f[fa>>2]|0;pa=0;do{f[qa+(pa<<2)>>2]=0;pa=pa+1|0}while((pa|0)<(f[ea>>2]|0))}pa=f[ga>>2]|0;if((pa|0)!=(ha|0))UC(pa)}while((ma|0)<(oa|0))}oa=f[w>>2]|0;if(oa|0?(ma=oa+12|0,oa=f[ma>>2]|0,f[ma>>2]=oa+-1,(oa|0)==1):0)kL(k);f[w>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[y>>2]|0)>0){oa=f[z>>2]|0;ma=0;do{f[oa+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[y>>2]|0))}ma=f[A>>2]|0;if((ma|0)!=(B|0))UC(ma);ma=f[C>>2]|0;if(ma|0?(oa=ma+12|0,ma=f[oa>>2]|0,f[oa>>2]=ma+-1,(ma|0)==1):0)kL(j);f[C>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[E>>2]|0)>0){ma=f[F>>2]|0;oa=0;do{f[ma+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[E>>2]|0))}oa=f[G>>2]|0;if((oa|0)!=(H|0))UC(oa);ja=ja+1|0;ka=f[c>>2]|0}while(ja>>>0<(f[s>>2]|0)-ka>>2>>>0)}if(!(f[i+4>>2]|0)){u=e;return}u=e;return}function Jhb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,123840);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Khb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+16|0;e=d;g=c+4|0;h=f[c>>2]|0;if((f[g>>2]|0)==(h|0)){i=0;j=0;J=i;u=d;return j|0}k=a+40|0;a=e+4|0;l=e+4|0;m=0;n=0;o=h;while(1){h=o;p=h+(n*12|0)|0;q=f[h+(n*12|0)+4>>2]|0;h=f[p>>2]|0;r=q-h|0;s=r>>2;do if((h|0)!=(q|0)){if((r|0)<0){f[e>>2]=0;f[l>>2]=0;t=aD(e,70)|0;v=442586;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,e,442657,442663,160);bD(e);x=1;break}if(!r)x=1;else{y=f[p>>2]|0;z=1;A=0;while(1){B=Y(f[y+(A<<2)>>2]|0,z)|0;A=A+1|0;if((A|0)==(s|0)){x=B;break}else z=B}}}else x=0;while(0);s=x*6|0;p=f[c>>2]|0;r=b[k>>0]|0?2:1;q=p+(n*12|0)|0;h=f[q>>2]|0;z=f[p+(n*12|0)+4>>2]|0;if((h|0)==(z|0)){C=0;D=p}else{p=z-h|0;if((p|0)<0|(r|0)>(p>>2|0)){f[e>>2]=0;f[a>>2]=0;t=aD(e,70)|0;v=442586;w=t+70|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,e,442657,442663,160);bD(e);E=f[q>>2]|0}else E=h;p=1;z=0;do{p=Y(f[E+(z<<2)>>2]|0,p)|0;z=z+1|0}while((z|0)!=(r|0));C=p;D=f[c>>2]|0}m=s+m+(C*3|0)|0;n=n+1|0;if(n>>>0>=(((f[g>>2]|0)-D|0)/12|0)>>>0)break;else o=D}i=((m|0)<0)<<31>>31;j=m;J=i;u=d;return j|0}function Lhb(a,b){a=a|0;b=b|0;var c=0;c=L5b(40)|0;Mhb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=123912;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Mhb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;Jwa(a);f[a>>2]=123932;Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,9)|0;h=434144;i=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));h=c+4|0;c=f[h>>2]|0;if(!c){j=0;k=a+36|0;b[k>>0]=j;bD(e);u=d;return}g=f[e>>2]|0;i=(g|0)==0?1124530:g;l=h;m=c;a:while(1){c=m;while(1){n=f[c+16>>2]|0;if((n|0)==(g|0))break;if((gTb((n|0)==0?1124530:n,i)|0)>=0)break;n=f[c+4>>2]|0;if(!n){o=l;break a}else c=n}m=f[c>>2]|0;if(!m){o=c;break}else l=c}if((o|0)==(h|0)){j=0;k=a+36|0;b[k>>0]=j;bD(e);u=d;return}h=f[o+16>>2]|0;if((g|0)!=(h|0)?(gTb(i,(h|0)==0?1124530:h)|0)<=-1:0){j=0;k=a+36|0;b[k>>0]=j;bD(e);u=d;return}h=Gwa(o+24|0,-1)|0;j=((h|0)!=0|(J|0)!=0)&1;k=a+36|0;b[k>>0]=j;bD(e);u=d;return}function Nhb(a){a=a|0;O5b(a);return}function Ohb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Phb(a){a=a|0;lua(a);O5b(a);return}function Qhb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=u;u=u+384|0;g=e;h=e+368|0;i=e+312|0;j=e+256|0;dQ(h,124056);k=d+4|0;l=f[d>>2]|0;if((f[k>>2]|0)!=(l|0)){m=a+4|0;o=a+36|0;a=g+4|0;p=g+8|0;q=g+8|0;r=g+4|0;s=j+36|0;t=j+16|0;v=j+4|0;w=j+40|0;x=j+44|0;y=j+48|0;z=i+36|0;A=i+16|0;B=i+4|0;C=i+40|0;D=i+44|0;E=i+48|0;F=g+4|0;G=g+4|0;H=g+4|0;I=g+4|0;J=0;K=l;do{l=K;L=f[(f[c>>2]|0)+(J<<2)>>2]|0;M=l+(J*56|0)|0;N=L+40|0;O=f[(f[N>>2]|0)+4>>2]|0;P=f[m>>2]|0;Q=f[P+4>>2]|0;if((Q|0)<3)R=Y(f[P+12>>2]|0,f[P+8>>2]|0)|0;else{S=f[P+40>>2]|0;P=0;T=1;while(1){U=Y(f[S+(P<<2)>>2]|0,T)|0;P=P+1|0;if((P|0)==(Q|0)){R=U;break}else T=U}}if((O|0)!=(R|0)){f[g>>2]=0;f[I>>2]=0;V=aD(g,35)|0;W=434369;X=V+35|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));bO(-215,g,443123,434182,65);bD(g)}if(b[o>>0]|0){O=f[(f[N>>2]|0)+4>>2]|0;T=f[m>>2]|0;Q=f[T+60>>2]|0;if((Q|0)<3)Z=Y(f[T+68>>2]|0,f[T+64>>2]|0)|0;else{P=f[T+96>>2]|0;T=0;S=1;while(1){U=Y(f[P+(T<<2)>>2]|0,S)|0;T=T+1|0;if((T|0)==(Q|0)){Z=U;break}else S=U}}if((O|0)!=(Z|0)){f[g>>2]=0;f[H>>2]=0;V=aD(g,35)|0;W=434405;X=V+35|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));bO(-215,g,443123,434182,67);bD(g)}}if(!((f[L>>2]&4095|0)==5?(f[M>>2]&4095|0)==5:0)){f[g>>2]=0;f[a>>2]=0;V=aD(g,42)|0;W=434441;X=V+42|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));bO(-215,g,443123,434182,69);bD(g)}O=f[N>>2]|0;S=f[O>>2]|0;if((S|0)>0){Q=l+(J*56|0)+4|0;T=L+4|0;P=0;U=O;O=S;while(1){S=P;P=P+1|0;if((f[U+4>>2]|0)>0){_=0;do{$=f[m>>2]|0;aa=f[$+16>>2]|0;do if((f[$>>2]&16384|0)==0?(ba=f[$+40>>2]|0,(f[ba>>2]|0)!=1):0){ca=f[f[$+44>>2]>>2]|0;if((f[ba+4>>2]|0)==1){da=aa+(Y(ca,_)|0)|0;break}else{ba=f[$+12>>2]|0;ea=(_|0)/(ba|0)|0;da=aa+(Y(ea,ca)|0)+(_-(Y(ea,ba)|0)<<2)|0;break}}else fa=33;while(0);if((fa|0)==33){fa=0;da=aa+(_<<2)|0}ga=+n[da>>2];if(!(b[o>>0]|0))ha=0.0;else{ba=f[$+72>>2]|0;do if((f[$+56>>2]&16384|0)==0?(ea=f[$+96>>2]|0,(f[ea>>2]|0)!=1):0){ca=f[f[$+100>>2]>>2]|0;if((f[ea+4>>2]|0)==1){ia=ba+(Y(ca,_)|0)|0;break}else{ea=f[$+68>>2]|0;ja=(_|0)/(ea|0)|0;ia=ba+(Y(ja,ca)|0)+(_-(Y(ja,ea)|0)<<2)|0;break}}else fa=40;while(0);if((fa|0)==40){fa=0;ia=ba+(_<<2)|0}ha=+n[ia>>2]}$=_;_=_+1|0;aa=f[Q>>2]|0;if((aa|0)>1)ka=aa;else{f[g>>2]=0;f[G>>2]=0;V=aD(g,11)|0;W=434484;X=V+11|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));bO(-215,g,434496,442663,78);bD(g);ka=f[Q>>2]|0}Nac(g|0,0,256)|0;if((ka|0)>2){ba=2;do{aa=g+(ba<<3)|0;f[aa>>2]=-2147483648;f[aa+4>>2]=2147483647;ba=ba+1|0}while((ba|0)!=(ka|0))}ba=g;f[ba>>2]=S;f[ba+4>>2]=P;ba=p;f[ba>>2]=$;f[ba+4>>2]=_;mL(i,M,g);ba=f[T>>2]|0;if((ba|0)>1)la=ba;else{f[g>>2]=0;f[F>>2]=0;V=aD(g,11)|0;W=434484;X=V+11|0;do{b[V>>0]=b[W>>0]|0;V=V+1|0;W=W+1|0}while((V|0)<(X|0));bO(-215,g,434496,442663,78);bD(g);la=f[T>>2]|0}Nac(g|0,0,256)|0;if((la|0)>2){ba=2;do{aa=g+(ba<<3)|0;f[aa>>2]=-2147483648;f[aa+4>>2]=2147483647;ba=ba+1|0}while((ba|0)!=(la|0))}ba=g;f[ba>>2]=S;f[ba+4>>2]=P;ba=p;f[ba>>2]=$;f[ba+4>>2]=_;mL(j,L,g);ba=q;f[ba>>2]=0;f[ba+4>>2]=0;f[g>>2]=33619968;f[r>>2]=i;OJ(j,g,5,ga,ha);ba=f[s>>2]|0;do if(ba|0){aa=ba+12|0;ea=f[aa>>2]|0;f[aa>>2]=ea+-1;if((ea|0)!=1)break;kL(j)}while(0);f[s>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[v>>2]|0)>0){ba=f[w>>2]|0;$=0;do{f[ba+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[v>>2]|0))}$=f[x>>2]|0;if(($|0)!=(y|0))UC($);$=f[z>>2]|0;do if($|0){ba=$+12|0;ea=f[ba>>2]|0;f[ba>>2]=ea+-1;if((ea|0)!=1)break;kL(i)}while(0);f[z>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){$=f[C>>2]|0;ea=0;do{f[$+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[B>>2]|0))}ea=f[D>>2]|0;if((ea|0)!=(E|0))UC(ea);ma=f[N>>2]|0}while((_|0)<(f[ma+4>>2]|0));na=f[ma>>2]|0;oa=ma}else{na=O;oa=U}if((P|0)>=(na|0))break;else{U=oa;O=na}}}J=J+1|0;K=f[d>>2]|0}while(J>>>0<(((f[k>>2]|0)-K|0)/56|0)>>>0)}if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function Rhb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,124024);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Shb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function Thb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Uhb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Vhb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h;if((((f[a+8>>2]|0)-(f[a+4>>2]|0)|0)/56|0|0)!=((b[a+36>>0]|0)+1&255|0)){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,27)|0;k=434154;l=j+27|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,i,442770,434182,36);bD(i)}yua(a,c,d,e,g)|0;u=h;return 1}function Whb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;a=d;e=c+4|0;g=f[e>>2]|0;h=f[c>>2]|0;if((g|0)==(h|0)){i=0;j=0;J=i;u=d;return j|0}k=a+4|0;l=0;m=0;n=h;h=g;while(1){g=n;o=f[g+(m*12|0)+4>>2]|0;p=f[g+(m*12|0)>>2]|0;g=o-p|0;q=g>>2;r=p;do if((r|0)!=(o|0)){if((g|0)<=-4){f[a>>2]=0;f[k>>2]=0;p=aD(a,70)|0;s=442586;t=p+70|0;do{b[p>>0]=b[s>>0]|0;p=p+1|0;s=s+1|0}while((p|0)<(t|0));bO(-215,a,442657,442663,160);bD(a);v=1;w=f[c>>2]|0;x=f[e>>2]|0;break}if((g|0)>0){s=0;p=1;while(1){t=Y(f[r+(s<<2)>>2]|0,p)|0;s=s+1|0;if((s|0)>=(q|0)){v=t;w=n;x=h;break}else p=t}}else{v=1;w=n;x=h}}else{v=0;w=n;x=h}while(0);l=(v<<1)+l|0;m=m+1|0;if(m>>>0>=((x-w|0)/12|0)>>>0)break;else{n=w;h=x}}i=((l|0)<0)<<31>>31;j=l;J=i;u=d;return j|0}function Xhb(a,b){a=a|0;b=b|0;var c=0;c=L5b(48)|0;Yhb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=124096;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Yhb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;Jwa(a);f[a>>2]=124116;Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,5)|0;b[g>>0]=b[434730]|0;b[g+1>>0]=b[434731]|0;b[g+2>>0]=b[434732]|0;b[g+3>>0]=b[434733]|0;b[g+4>>0]=b[434734]|0;g=c+4|0;h=f[g>>2]|0;do if(h){i=f[e>>2]|0;j=(i|0)==0?1124530:i;k=h;while(1){l=f[k+16>>2]|0;if((i|0)==(l|0)){m=9;break}n=(l|0)==0?1124530:l;if((gTb(j,n)|0)<0)o=k;else{if((gTb(n,j)|0)>=0){m=13;break}o=k+4|0}k=f[o>>2]|0;if(!k){m=11;break}}if((m|0)==9){bD(e);break}else if((m|0)==11){bD(e);m=12;break}else if((m|0)==13){bD(e);break}}else{bD(e);m=12}while(0);if((m|0)==12){f[e>>2]=0;f[e+4>>2]=0;p=aD(e,19)|0;q=434736;r=p+19|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,e,434756,434787,19);bD(e)}f[e>>2]=0;f[e+4>>2]=0;o=aD(e,6)|0;b[o>>0]=b[434884]|0;b[o+1>>0]=b[434885]|0;b[o+2>>0]=b[434886]|0;b[o+3>>0]=b[434887]|0;b[o+4>>0]=b[434888]|0;b[o+5>>0]=b[434889]|0;o=f[g>>2]|0;do if(o){h=f[e>>2]|0;k=(h|0)==0?1124530:h;j=o;while(1){i=f[j+16>>2]|0;if((h|0)==(i|0)){m=22;break}n=(i|0)==0?1124530:i;if((gTb(k,n)|0)<0)s=j;else{if((gTb(n,k)|0)>=0){m=26;break}s=j+4|0}j=f[s>>2]|0;if(!j){m=24;break}}if((m|0)==22){bD(e);break}else if((m|0)==24){bD(e);m=25;break}else if((m|0)==26){bD(e);break}}else{bD(e);m=25}while(0);if((m|0)==25){f[e>>2]=0;f[e+4>>2]=0;p=aD(e,20)|0;q=434891;r=p+20|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,e,434756,434787,19);bD(e)}f[e>>2]=0;f[e+4>>2]=0;m=aD(e,5)|0;b[m>>0]=b[434730]|0;b[m+1>>0]=b[434731]|0;b[m+2>>0]=b[434732]|0;b[m+3>>0]=b[434733]|0;b[m+4>>0]=b[434734]|0;m=~~+Hya(Eya(c,e)|0,-1);f[a+36>>2]=m;bD(e);f[e>>2]=0;f[e+4>>2]=0;m=aD(e,6)|0;b[m>>0]=b[434884]|0;b[m+1>>0]=b[434885]|0;b[m+2>>0]=b[434886]|0;b[m+3>>0]=b[434887]|0;b[m+4>>0]=b[434888]|0;b[m+5>>0]=b[434889]|0;m=~~+Hya(Eya(c,e)|0,-1);f[a+40>>2]=m;bD(e);f[e>>2]=0;f[e+4>>2]=0;p=aD(e,13)|0;q=434912;r=p+13|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));m=f[g>>2]|0;do if(m){c=f[e>>2]|0;s=(c|0)==0?1124530:c;o=g;j=m;a:while(1){k=j;while(1){h=f[k+16>>2]|0;if((h|0)==(c|0))break;if((gTb((h|0)==0?1124530:h,s)|0)>=0)break;h=f[k+4>>2]|0;if(!h){t=o;break a}else k=h}j=f[k>>2]|0;if(!j){t=k;break}else o=k}if((t|0)!=(g|0)){o=f[t+16>>2]|0;if((c|0)!=(o|0)?(gTb(s,(o|0)==0?1124530:o)|0)<=-1:0){v=0;break}o=Gwa(t+24|0,-1)|0;v=((o|0)!=0|(J|0)!=0)&1}else v=0}else v=0;while(0);t=a+44|0;b[t>>0]=v;bD(e);if(!(b[t>>0]|0)){u=d;return}f[e>>2]=0;f[e+4>>2]=0;p=aD(e,70)|0;q=434926;r=p+70|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-213,e,434756,434787,24);bD(e);u=d;return}function Zhb(a){a=a|0;O5b(a);return}function _hb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function $hb(a){a=a|0;lua(a);O5b(a);return}function aib(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+160|0;e=d+152|0;g=d+136|0;h=d+80|0;i=d+64|0;j=d+8|0;k=d;dQ(e,124240);l=a+40|0;m=f[f[b>>2]>>2]|0;n=f[m+40>>2]|0;if(!((f[l>>2]|0)==(f[n+8>>2]|0)?(f[a+36>>2]|0)==(f[n+12>>2]|0):0))o=5;if((o|0)==5?(o=f[c>>2]|0,c=f[n>>2]|0,c|0):0){p=g+8|0;q=g+12|0;r=g+4|0;s=i+8|0;t=i+4|0;v=a+36|0;a=k+4|0;w=j+36|0;x=j+16|0;y=j+4|0;z=j+40|0;A=j+44|0;B=j+48|0;C=h+36|0;D=h+16|0;E=h+4|0;F=h+40|0;G=h+44|0;H=h+48|0;I=0;J=c;c=n;while(1){if(!(f[c+4>>2]|0)){K=c;L=J}else{n=0;do{dib(h,m,I,n);f[p>>2]=0;f[q>>2]=0;f[g>>2]=16842752;f[r>>2]=h;dib(j,o,I,n);M=s;f[M>>2]=0;f[M+4>>2]=0;f[i>>2]=-1040121856;f[t>>2]=j;M=f[l>>2]|0;f[k>>2]=f[v>>2];f[a>>2]=M;Lia(g,i,k,0.0,0.0,0);M=f[w>>2]|0;if(M|0?(N=M+12|0,M=f[N>>2]|0,f[N>>2]=M+-1,(M|0)==1):0)kL(j);f[w>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[y>>2]|0)>0){M=f[z>>2]|0;N=0;do{f[M+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[y>>2]|0))}N=f[A>>2]|0;if((N|0)!=(B|0))UC(N);N=f[C>>2]|0;if(N|0?(M=N+12|0,N=f[M>>2]|0,f[M>>2]=N+-1,(N|0)==1):0)kL(h);f[C>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[E>>2]|0)>0){N=f[F>>2]|0;M=0;do{f[N+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[E>>2]|0))}M=f[G>>2]|0;if((M|0)!=(H|0))UC(M);n=n+1|0;O=f[(f[f[b>>2]>>2]|0)+40>>2]|0}while(n>>>0<(f[O+4>>2]|0)>>>0);K=O;L=f[O>>2]|0}I=I+1|0;if(I>>>0>=L>>>0)break;else{J=L;c=K}}}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function bib(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,124208);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function cib(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;d=g;h=f[c>>2]|0;if(((f[c+4>>2]|0)-h|0)==12){i=c;j=h}else{f[d>>2]=0;f[d+4>>2]=0;k=aD(d,18)|0;l=443104;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,d,442770,434787,32);bD(d);i=c;j=f[c>>2]|0}if(((f[j+4>>2]|0)-(f[j>>2]|0)|0)!=16){f[d>>2]=0;f[d+4>>2]=0;k=aD(d,21)|0;l=434997;m=k+21|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,d,442770,434787,32);bD(d)}d=e+4|0;l=f[d>>2]|0;k=f[e>>2]|0;m=l-k|0;j=(m|0)/12|0;c=k;k=l;if(m){if(j>>>0>1?(m=c+12|0,(k|0)!=(m|0)):0){c=k;while(1){k=c+-12|0;f[d>>2]=k;l=f[k>>2]|0;if(!l)n=k;else{k=c+-8|0;h=f[k>>2]|0;if((h|0)!=(l|0))f[k>>2]=h+(~((h+-4-l|0)>>>2)<<2);O5b(l);n=f[d>>2]|0}if((n|0)==(m|0))break;else c=n}}}else sbb(e,1-j|0,f[i>>2]|0);j=f[a+40>>2]|0;n=f[f[e>>2]>>2]|0;f[n+8>>2]=j;e=f[a+36>>2]|0;f[n+12>>2]=e;n=f[f[i>>2]>>2]|0;if((j|0)!=(f[n+8>>2]|0)){o=0;u=g;return o|0}o=(e|0)==(f[n+12>>2]|0);u=g;return o|0}function dib(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+128|0;h=g;i=c+4|0;j=f[i>>2]|0;if((j|0)<=2){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,10)|0;l=435143;m=k+10|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,435154,442663,114);bD(h);l=f[i>>2]|0;if((l|0)>2){n=l;o=h;p=4}else{q=l;r=h}}else{n=j;o=h;p=4}if((p|0)==4){p=f[c+40>>2]|0;j=2;do{f[h+(j+-2<<2)>>2]=f[p+(j<<2)>>2];j=j+1|0}while((j|0)<(n|0));q=n;r=o}o=f[c+44>>2]|0;r=(f[c+16>>2]|0)+(Y(f[o>>2]|0,d)|0)|0;oL(a,q+-2|0,h,f[c>>2]&4095,r+(Y(f[o+4>>2]|0,e)|0)|0,0);u=g;return}function eib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=aD(e,14)|0;h=435388;i=g+14|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));h=c+4|0;g=f[h>>2]|0;do if(g){i=f[e>>2]|0;j=(i|0)==0?1124530:i;k=h;l=g;a:while(1){m=l;while(1){o=f[m+16>>2]|0;if((o|0)==(i|0))break;if((gTb((o|0)==0?1124530:o,j)|0)>=0)break;o=f[m+4>>2]|0;if(!o){p=k;break a}else m=o}l=f[m>>2]|0;if(!l){p=m;break}else k=m}if((p|0)!=(h|0)){k=f[p+16>>2]|0;if((i|0)!=(k|0)?(gTb(j,(k|0)==0?1124530:k)|0)<=-1:0){q=0.0;break}q=+Hya(p+24|0,-1)}else q=0.0}else q=0.0;while(0);bD(e);e=L5b(48)|0;Jwa(e);f[e>>2]=124280;b[e+44>>0]=0;n[e+40>>2]=q;p=L5b(16)|0;f[p+4>>2]=1;f[p>>2]=124384;f[p+8>>2]=e;f[a>>2]=p;f[a+4>>2]=e;Kwa(e,c);n[e+36>>2]=q;u=d;return}function fib(a){a=a|0;O5b(a);return}function gib(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hib(a){a=a|0;lua(a);O5b(a);return}function iib(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e;dQ(g,124416);j=c+4|0;k=f[c>>2]|0;if((f[j>>2]|0)!=(k|0)){l=a+40|0;a=h+4|0;m=h+8|0;n=h+12|0;o=h+16|0;p=i+4|0;q=h+4|0;r=0;s=k;do{k=f[s+(r<<2)>>2]|0;t=f[d>>2]|0;v=t+(r*56|0)|0;w=f[k+40>>2]|0;x=f[w+-4>>2]|0;y=f[t+(r*56|0)+40>>2]|0;a:do if((x|0)==(f[y+-4>>2]|0)){if((x|0)==2){if((f[w>>2]|0)!=(f[y>>2]|0)){z=14;break}if((f[w+4>>2]|0)!=(f[y+4>>2]|0)){z=14;break}}else if((x|0)>0){t=0;do{if((f[w+(t<<2)>>2]|0)!=(f[y+(t<<2)>>2]|0)){z=14;break a}t=t+1|0}while((t|0)<(x|0))}t=f[k>>2]|0;A=t&4095;B=f[v>>2]|0;if(!((A|0)==5&((A|0)==(B&4095|0)&(t&16384&B|0)!=0)))z=14}else z=14;while(0);if((z|0)==14){z=0;f[h>>2]=0;f[q>>2]=0;x=aD(h,111)|0;y=435751;w=x+111|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(w|0));bO(-215,h,443123,435665,179);bD(h)}y=SQ()|0;f[h>>2]=124444;f[a>>2]=l;f[m>>2]=k;f[n>>2]=v;f[o>>2]=y;f[i>>2]=0;f[p>>2]=y;RQ(i,h,+(y|0));r=r+1|0;s=f[c>>2]|0}while(r>>>0<(f[j>>2]|0)-s>>2>>>0)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function jib(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,124396);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function kib(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function lib(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function mib(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function nib(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yua(a,b,c,d,e)|0;return 1}function oib(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;a=c;e=d+4|0;g=f[e>>2]|0;h=f[d>>2]|0;if((g|0)==(h|0)){i=0;j=0;J=j;u=c;return i|0}k=a+4|0;l=0;m=h;h=0;n=0;o=g;while(1){g=m;p=f[g+(l*12|0)+4>>2]|0;q=f[g+(l*12|0)>>2]|0;g=p-q|0;r=g>>2;s=q;do if((s|0)!=(p|0)){if((g|0)<=-4){f[a>>2]=0;f[k>>2]=0;q=aD(a,70)|0;t=442586;v=q+70|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,a,442657,442663,160);bD(a);w=1;x=f[d>>2]|0;y=f[e>>2]|0;break}if((g|0)>0){t=0;q=1;while(1){v=Y(f[s+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)>=(r|0)){w=v;x=m;y=o;break}else q=v}}else{w=1;x=m;y=o}}else{w=0;x=m;y=o}while(0);r=Kac(w|0,0,h|0,n|0)|0;l=l+1|0;s=Rac(0,r|0,32)|0;r=J;if(l>>>0>=((y-x|0)/12|0)>>>0){i=s;j=r;break}else{m=x;h=s;n=r;o=y}}J=j;u=c;return i|0}function pib(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0,k=0,l=0.0;h=+n[a+40>>2];if((d|0)>0&(f|0)<(g|0)){i=f;j=c;k=b}else return;while(1){b=0;do{l=+n[k+(b<<2)>>2];n[j+(b<<2)>>2]=!(l>=0.0)?h*l:l;b=b+1|0}while((b|0)!=(d|0));i=i+1|0;if((i|0)==(g|0))break;else{j=j+(e<<2)|0;k=k+(e<<2)|0}}return}function qib(a){a=a|0;O5b(a);return}function rib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;i=f[d+16>>2]|0;e=f[f[d+44>>2]>>2]|0;d=f[a+4>>2]|0;a=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(a|0)>0)q=0;else return;do{o=h+(Y(b,q)|0)+(c<<2)|0;m=i+(Y(e,q)|0)+(c<<2)|0;r=+n[d>>2];g=0;p=m;m=o;while(1){o=0;do{s=+n[m+(o<<2)>>2];n[p+(o<<2)>>2]=!(s>=0.0)?r*s:s;o=o+1|0}while((o|0)!=(a|0));g=g+1|0;if((g|0)==(j|0))break;else{p=p+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function sib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=aD(e,9)|0;h=436127;i=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));j=c+4|0;k=f[j>>2]|0;do if(k){l=f[e>>2]|0;m=(l|0)==0?1124530:l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((gTb((r|0)==0?1124530:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)!=(j|0)){o=f[s+16>>2]|0;if((l|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){t=0.0;break}t=+Hya(s+24|0,-1)}else t=0.0}else t=0.0;while(0);bD(e);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,9)|0;h=436137;i=g+9|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));s=f[j>>2]|0;do if(s){k=f[e>>2]|0;o=(k|0)==0?1124530:k;p=j;r=s;b:while(1){v=r;while(1){w=f[v+16>>2]|0;if((w|0)==(k|0))break;if((gTb((w|0)==0?1124530:w,o)|0)>=0)break;w=f[v+4>>2]|0;if(!w){x=p;break b}else v=w}r=f[v>>2]|0;if(!r){x=v;break}else p=v}if((x|0)!=(j|0)){p=f[x+16>>2]|0;if((k|0)!=(p|0)?(gTb(o,(p|0)==0?1124530:p)|0)<=-1:0){y=6.0;break}y=+Hya(x+24|0,-1)}else y=6.0}else y=6.0;while(0);bD(e);x=L5b(48)|0;if(t<=y){Jwa(x);f[x>>2]=124464;z=x+36|0;A=x+40|0;B=x+44|0;b[B>>0]=0;n[z>>2]=t;n[A>>2]=y;C=L5b(16)|0;D=C+4|0;f[D>>2]=1;f[C>>2]=124568;E=C+8|0;f[E>>2]=x;f[a>>2]=C;F=a+4|0;f[F>>2]=x;Kwa(x,c);u=d;return}f[e>>2]=0;f[e+4>>2]=0;g=aD(e,20)|0;h=436147;i=g+20|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-215,e,436168,435665,323);bD(e);Jwa(x);f[x>>2]=124464;z=x+36|0;A=x+40|0;B=x+44|0;b[B>>0]=0;n[z>>2]=t;n[A>>2]=y;C=L5b(16)|0;D=C+4|0;f[D>>2]=1;f[C>>2]=124568;E=C+8|0;f[E>>2]=x;f[a>>2]=C;F=a+4|0;f[F>>2]=x;Kwa(x,c);u=d;return}function tib(a){a=a|0;O5b(a);return}function uib(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function vib(a){a=a|0;lua(a);O5b(a);return}function wib(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e;dQ(g,124600);j=c+4|0;k=f[c>>2]|0;if((f[j>>2]|0)!=(k|0)){l=a+36|0;a=h+4|0;m=h+8|0;n=h+12|0;o=h+16|0;p=i+4|0;q=h+4|0;r=0;s=k;do{k=f[s+(r<<2)>>2]|0;t=f[d>>2]|0;v=t+(r*56|0)|0;w=f[k+40>>2]|0;x=f[w+-4>>2]|0;y=f[t+(r*56|0)+40>>2]|0;a:do if((x|0)==(f[y+-4>>2]|0)){if((x|0)==2){if((f[w>>2]|0)!=(f[y>>2]|0)){z=14;break}if((f[w+4>>2]|0)!=(f[y+4>>2]|0)){z=14;break}}else if((x|0)>0){t=0;do{if((f[w+(t<<2)>>2]|0)!=(f[y+(t<<2)>>2]|0)){z=14;break a}t=t+1|0}while((t|0)<(x|0))}t=f[k>>2]|0;A=t&4095;B=f[v>>2]|0;if(!((A|0)==5&((A|0)==(B&4095|0)&(t&16384&B|0)!=0)))z=14}else z=14;while(0);if((z|0)==14){z=0;f[h>>2]=0;f[q>>2]=0;x=aD(h,111)|0;y=435751;w=x+111|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(w|0));bO(-215,h,443123,435665,179);bD(h)}y=SQ()|0;f[h>>2]=124628;f[a>>2]=l;f[m>>2]=k;f[n>>2]=v;f[o>>2]=y;f[i>>2]=0;f[p>>2]=y;RQ(i,h,+(y|0));r=r+1|0;s=f[c>>2]|0}while(r>>>0<(f[j>>2]|0)-s>>2>>>0)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function xib(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,124580);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function yib(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function zib(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Aib(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Bib(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yua(a,b,c,d,e)|0;return 1}function Cib(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;a=c;e=d+4|0;g=f[e>>2]|0;h=f[d>>2]|0;if((g|0)==(h|0)){i=0;j=0;J=j;u=c;return i|0}k=a+4|0;l=0;m=h;h=0;n=0;o=g;while(1){g=m;p=f[g+(l*12|0)+4>>2]|0;q=f[g+(l*12|0)>>2]|0;g=p-q|0;r=g>>2;s=q;do if((s|0)!=(p|0)){if((g|0)<=-4){f[a>>2]=0;f[k>>2]=0;q=aD(a,70)|0;t=442586;v=q+70|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,a,442657,442663,160);bD(a);w=1;x=f[d>>2]|0;y=f[e>>2]|0;break}if((g|0)>0){t=0;q=1;while(1){v=Y(f[s+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)>=(r|0)){w=v;x=m;y=o;break}else q=v}}else{w=1;x=m;y=o}}else{w=0;x=m;y=o}while(0);r=$ac(w|0,((w|0)<0)<<31>>31|0,1)|0;s=Kac(r|0,J|0,h|0,n|0)|0;l=l+1|0;r=Rac(0,s|0,32)|0;s=J;if(l>>>0>=((y-x|0)/12|0)>>>0){i=r;j=s;break}else{m=x;h=r;n=s;o=y}}J=j;u=c;return i|0}function Dib(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0;if((f|0)>=(g|0))return;h=a+36|0;i=a+40|0;if((d|0)>0){j=f;k=c;l=b}else return;while(1){b=0;do{m=+n[l+(b<<2)>>2];o=+n[h>>2];if(!(m>=o))p=o;else{o=+n[i>>2];p=m<=o?m:o}n[k+(b<<2)>>2]=p;b=b+1|0}while((b|0)!=(d|0));j=j+1|0;if((j|0)==(g|0))break;else{k=k+(e<<2)|0;l=l+(e<<2)|0}}return}function Eib(a){a=a|0;O5b(a);return}function Fib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[a+12>>2]|0;b=f[a+4>>2]|0;a=(k>>>0<o>>>0?k:o)-c|0;o=(a|0)>0;i=b+4|0;if((j|0)<=0)return;e=f[h+16>>2]|0;m=f[f[h+44>>2]>>2]|0;h=f[d+16>>2]|0;g=f[f[d+44>>2]>>2]|0;d=0;do{if(o){p=0;q=e+(Y(m,d)|0)+(c<<2)|0;r=h+(Y(g,d)|0)+(c<<2)|0;while(1){s=0;do{t=+n[r+(s<<2)>>2];u=+n[b>>2];if(!(t>=u))v=u;else{u=+n[i>>2];v=t<=u?t:u}n[q+(s<<2)>>2]=v;s=s+1|0}while((s|0)!=(a|0));p=p+1|0;if((p|0)==(j|0))break;else{q=q+(k<<2)|0;r=r+(k<<2)|0}}}d=d+1|0}while((d|0)!=(l|0));return}function Gib(a,c){a=a|0;c=c|0;var d=0,e=0;d=L5b(40)|0;Jwa(d);f[d>>2]=124648;b[d+37>>0]=0;e=L5b(16)|0;f[e+4>>2]=1;f[e>>2]=124752;f[e+8>>2]=d;f[a>>2]=e;f[a+4>>2]=d;Kwa(d,c);return}function Hib(a){a=a|0;O5b(a);return}function Iib(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Jib(a){a=a|0;lua(a);O5b(a);return}function Kib(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e;dQ(g,124784);j=c+4|0;k=f[c>>2]|0;if((f[j>>2]|0)!=(k|0)){l=a+36|0;a=h+4|0;m=h+8|0;n=h+12|0;o=h+16|0;p=i+4|0;q=h+4|0;r=0;s=k;do{k=f[s+(r<<2)>>2]|0;t=f[d>>2]|0;v=t+(r*56|0)|0;w=f[k+40>>2]|0;x=f[w+-4>>2]|0;y=f[t+(r*56|0)+40>>2]|0;a:do if((x|0)==(f[y+-4>>2]|0)){if((x|0)==2){if((f[w>>2]|0)!=(f[y>>2]|0)){z=14;break}if((f[w+4>>2]|0)!=(f[y+4>>2]|0)){z=14;break}}else if((x|0)>0){t=0;do{if((f[w+(t<<2)>>2]|0)!=(f[y+(t<<2)>>2]|0)){z=14;break a}t=t+1|0}while((t|0)<(x|0))}t=f[k>>2]|0;A=t&4095;B=f[v>>2]|0;if(!((A|0)==5&((A|0)==(B&4095|0)&(t&16384&B|0)!=0)))z=14}else z=14;while(0);if((z|0)==14){z=0;f[h>>2]=0;f[q>>2]=0;x=aD(h,111)|0;y=435751;w=x+111|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(w|0));bO(-215,h,443123,435665,179);bD(h)}y=SQ()|0;f[h>>2]=124812;f[a>>2]=l;f[m>>2]=k;f[n>>2]=v;f[o>>2]=y;f[i>>2]=0;f[p>>2]=y;RQ(i,h,+(y|0));r=r+1|0;s=f[c>>2]|0}while(r>>>0<(f[j>>2]|0)-s>>2>>>0)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Lib(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,124764);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Mib(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function Nib(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Oib(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Pib(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yua(a,b,c,d,e)|0;return 1}function Qib(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;a=c;e=d+4|0;g=f[e>>2]|0;h=f[d>>2]|0;if((g|0)==(h|0)){i=0;j=0;J=j;u=c;return i|0}k=a+4|0;l=0;m=h;h=0;n=0;o=g;while(1){g=m;p=f[g+(l*12|0)+4>>2]|0;q=f[g+(l*12|0)>>2]|0;g=p-q|0;r=g>>2;s=q;do if((s|0)!=(p|0)){if((g|0)<=-4){f[a>>2]=0;f[k>>2]=0;q=aD(a,70)|0;t=442586;v=q+70|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,a,442657,442663,160);bD(a);w=1;x=f[d>>2]|0;y=f[e>>2]|0;break}if((g|0)>0){t=0;q=1;while(1){v=Y(f[s+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)>=(r|0)){w=v;x=m;y=o;break}else q=v}}else{w=1;x=m;y=o}}else{w=0;x=m;y=o}while(0);r=Kac(w|0,0,h|0,n|0)|0;l=l+1|0;s=Rac(0,r|0,32)|0;r=J;if(l>>>0>=((y-x|0)/12|0)>>>0){i=s;j=r;break}else{m=x;h=s;n=r;o=y}}J=j;u=c;return i|0}function Rib(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=+GVb(+n[j+(b<<2)>>2]);n[i+(b<<2)>>2]=k;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function Sib(a){a=a|0;O5b(a);return}function Tib(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=+GVb(+n[m+(g<<2)>>2]);n[e+(g<<2)>>2]=r;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function Uib(a,c){a=a|0;c=c|0;var d=0,e=0;d=L5b(40)|0;Jwa(d);f[d>>2]=124832;b[d+37>>0]=0;e=L5b(16)|0;f[e+4>>2]=1;f[e>>2]=124936;f[e+8>>2]=d;f[a>>2]=e;f[a+4>>2]=d;Kwa(d,c);return}function Vib(a){a=a|0;O5b(a);return}function Wib(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Xib(a){a=a|0;lua(a);O5b(a);return}function Yib(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e;dQ(g,124968);j=c+4|0;k=f[c>>2]|0;if((f[j>>2]|0)!=(k|0)){l=a+36|0;a=h+4|0;m=h+8|0;n=h+12|0;o=h+16|0;p=i+4|0;q=h+4|0;r=0;s=k;do{k=f[s+(r<<2)>>2]|0;t=f[d>>2]|0;v=t+(r*56|0)|0;w=f[k+40>>2]|0;x=f[w+-4>>2]|0;y=f[t+(r*56|0)+40>>2]|0;a:do if((x|0)==(f[y+-4>>2]|0)){if((x|0)==2){if((f[w>>2]|0)!=(f[y>>2]|0)){z=14;break}if((f[w+4>>2]|0)!=(f[y+4>>2]|0)){z=14;break}}else if((x|0)>0){t=0;do{if((f[w+(t<<2)>>2]|0)!=(f[y+(t<<2)>>2]|0)){z=14;break a}t=t+1|0}while((t|0)<(x|0))}t=f[k>>2]|0;A=t&4095;B=f[v>>2]|0;if(!((A|0)==5&((A|0)==(B&4095|0)&(t&16384&B|0)!=0)))z=14}else z=14;while(0);if((z|0)==14){z=0;f[h>>2]=0;f[q>>2]=0;x=aD(h,111)|0;y=435751;w=x+111|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(w|0));bO(-215,h,443123,435665,179);bD(h)}y=SQ()|0;f[h>>2]=124996;f[a>>2]=l;f[m>>2]=k;f[n>>2]=v;f[o>>2]=y;f[i>>2]=0;f[p>>2]=y;RQ(i,h,+(y|0));r=r+1|0;s=f[c>>2]|0}while(r>>>0<(f[j>>2]|0)-s>>2>>>0)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Zib(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,124948);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function _ib(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function $ib(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ajb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function bjb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yua(a,b,c,d,e)|0;return 1}function cjb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;a=c;e=d+4|0;g=f[e>>2]|0;h=f[d>>2]|0;if((g|0)==(h|0)){i=0;j=0;J=j;u=c;return i|0}k=a+4|0;l=0;m=h;h=0;n=0;o=g;while(1){g=m;p=f[g+(l*12|0)+4>>2]|0;q=f[g+(l*12|0)>>2]|0;g=p-q|0;r=g>>2;s=q;do if((s|0)!=(p|0)){if((g|0)<=-4){f[a>>2]=0;f[k>>2]=0;q=aD(a,70)|0;t=442586;v=q+70|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,a,442657,442663,160);bD(a);w=1;x=f[d>>2]|0;y=f[e>>2]|0;break}if((g|0)>0){t=0;q=1;while(1){v=Y(f[s+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)>=(r|0)){w=v;x=m;y=o;break}else q=v}}else{w=1;x=m;y=o}}else{w=0;x=m;y=o}while(0);r=cbc(w|0,((w|0)<0)<<31>>31|0,3,0)|0;s=Kac(r|0,J|0,h|0,n|0)|0;l=l+1|0;r=Rac(0,s|0,32)|0;s=J;if(l>>>0>=((y-x|0)/12|0)>>>0){i=r;j=s;break}else{m=x;h=r;n=s;o=y}}J=j;u=c;return i|0}function djb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=1.0/(+V(+-+n[j+(b<<2)>>2])+1.0);n[i+(b<<2)>>2]=k;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function ejb(a){a=a|0;O5b(a);return}function fjb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=1.0/(+V(+-+n[m+(g<<2)>>2])+1.0);n[e+(g<<2)>>2]=r;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function gjb(a,c){a=a|0;c=c|0;var d=0,e=0;d=L5b(40)|0;Jwa(d);f[d>>2]=125016;b[d+37>>0]=0;e=L5b(16)|0;f[e+4>>2]=1;f[e>>2]=125120;f[e+8>>2]=d;f[a>>2]=e;f[a+4>>2]=d;Kwa(d,c);return}function hjb(a){a=a|0;O5b(a);return}function ijb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function jjb(a){a=a|0;lua(a);O5b(a);return}function kjb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e;dQ(g,125152);j=c+4|0;k=f[c>>2]|0;if((f[j>>2]|0)!=(k|0)){l=a+36|0;a=h+4|0;m=h+8|0;n=h+12|0;o=h+16|0;p=i+4|0;q=h+4|0;r=0;s=k;do{k=f[s+(r<<2)>>2]|0;t=f[d>>2]|0;v=t+(r*56|0)|0;w=f[k+40>>2]|0;x=f[w+-4>>2]|0;y=f[t+(r*56|0)+40>>2]|0;a:do if((x|0)==(f[y+-4>>2]|0)){if((x|0)==2){if((f[w>>2]|0)!=(f[y>>2]|0)){z=14;break}if((f[w+4>>2]|0)!=(f[y+4>>2]|0)){z=14;break}}else if((x|0)>0){t=0;do{if((f[w+(t<<2)>>2]|0)!=(f[y+(t<<2)>>2]|0)){z=14;break a}t=t+1|0}while((t|0)<(x|0))}t=f[k>>2]|0;A=t&4095;B=f[v>>2]|0;if(!((A|0)==5&((A|0)==(B&4095|0)&(t&16384&B|0)!=0)))z=14}else z=14;while(0);if((z|0)==14){z=0;f[h>>2]=0;f[q>>2]=0;x=aD(h,111)|0;y=435751;w=x+111|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(w|0));bO(-215,h,443123,435665,179);bD(h)}y=SQ()|0;f[h>>2]=125180;f[a>>2]=l;f[m>>2]=k;f[n>>2]=v;f[o>>2]=y;f[i>>2]=0;f[p>>2]=y;RQ(i,h,+(y|0));r=r+1|0;s=f[c>>2]|0}while(r>>>0<(f[j>>2]|0)-s>>2>>>0)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function ljb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,125132);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function mjb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function njb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ojb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function pjb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yua(a,b,c,d,e)|0;return 1}function qjb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;a=c;e=d+4|0;g=f[e>>2]|0;h=f[d>>2]|0;if((g|0)==(h|0)){i=0;j=0;J=j;u=c;return i|0}k=a+4|0;l=0;m=h;h=0;n=0;o=g;while(1){g=m;p=f[g+(l*12|0)+4>>2]|0;q=f[g+(l*12|0)>>2]|0;g=p-q|0;r=g>>2;s=q;do if((s|0)!=(p|0)){if((g|0)<=-4){f[a>>2]=0;f[k>>2]=0;q=aD(a,70)|0;t=442586;v=q+70|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,a,442657,442663,160);bD(a);w=1;x=f[d>>2]|0;y=f[e>>2]|0;break}if((g|0)>0){t=0;q=1;while(1){v=Y(f[s+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)>=(r|0)){w=v;x=m;y=o;break}else q=v}}else{w=1;x=m;y=o}}else{w=0;x=m;y=o}while(0);r=$ac(w|0,((w|0)<0)<<31>>31|0,1)|0;s=Kac(r|0,J|0,h|0,n|0)|0;l=l+1|0;r=Rac(0,s|0,32)|0;s=J;if(l>>>0>=((y-x|0)/12|0)>>>0){i=r;j=s;break}else{m=x;h=r;n=s;o=y}}J=j;u=c;return i|0}function rjb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=+n[j+(b<<2)>>2];if(!(k>=0.0))l=+V(+k)+-1.0;else l=k;n[i+(b<<2)>>2]=l;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function sjb(a){a=a|0;O5b(a);return}function tjb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=+n[m+(g<<2)>>2];if(!(r>=0.0))s=+V(+r)+-1.0;else s=r;n[e+(g<<2)>>2]=s;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function ujb(a,c){a=a|0;c=c|0;var d=0,e=0;d=L5b(40)|0;Jwa(d);f[d>>2]=125200;b[d+37>>0]=0;e=L5b(16)|0;f[e+4>>2]=1;f[e>>2]=125304;f[e+8>>2]=d;f[a>>2]=e;f[a+4>>2]=d;Kwa(d,c);return}function vjb(a){a=a|0;O5b(a);return}function wjb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xjb(a){a=a|0;lua(a);O5b(a);return}function yjb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e;dQ(g,125336);j=c+4|0;k=f[c>>2]|0;if((f[j>>2]|0)!=(k|0)){l=a+36|0;a=h+4|0;m=h+8|0;n=h+12|0;o=h+16|0;p=i+4|0;q=h+4|0;r=0;s=k;do{k=f[s+(r<<2)>>2]|0;t=f[d>>2]|0;v=t+(r*56|0)|0;w=f[k+40>>2]|0;x=f[w+-4>>2]|0;y=f[t+(r*56|0)+40>>2]|0;a:do if((x|0)==(f[y+-4>>2]|0)){if((x|0)==2){if((f[w>>2]|0)!=(f[y>>2]|0)){z=14;break}if((f[w+4>>2]|0)!=(f[y+4>>2]|0)){z=14;break}}else if((x|0)>0){t=0;do{if((f[w+(t<<2)>>2]|0)!=(f[y+(t<<2)>>2]|0)){z=14;break a}t=t+1|0}while((t|0)<(x|0))}t=f[k>>2]|0;A=t&4095;B=f[v>>2]|0;if(!((A|0)==5&((A|0)==(B&4095|0)&(t&16384&B|0)!=0)))z=14}else z=14;while(0);if((z|0)==14){z=0;f[h>>2]=0;f[q>>2]=0;x=aD(h,111)|0;y=435751;w=x+111|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(w|0));bO(-215,h,443123,435665,179);bD(h)}y=SQ()|0;f[h>>2]=125364;f[a>>2]=l;f[m>>2]=k;f[n>>2]=v;f[o>>2]=y;f[i>>2]=0;f[p>>2]=y;RQ(i,h,+(y|0));r=r+1|0;s=f[c>>2]|0}while(r>>>0<(f[j>>2]|0)-s>>2>>>0)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function zjb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,125316);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Ajb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function Bjb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Cjb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Djb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yua(a,b,c,d,e)|0;return 1}function Ejb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;a=c;e=d+4|0;g=f[e>>2]|0;h=f[d>>2]|0;if((g|0)==(h|0)){i=0;j=0;J=j;u=c;return i|0}k=a+4|0;l=0;m=h;h=0;n=0;o=g;while(1){g=m;p=f[g+(l*12|0)+4>>2]|0;q=f[g+(l*12|0)>>2]|0;g=p-q|0;r=g>>2;s=q;do if((s|0)!=(p|0)){if((g|0)<=-4){f[a>>2]=0;f[k>>2]=0;q=aD(a,70)|0;t=442586;v=q+70|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,a,442657,442663,160);bD(a);w=1;x=f[d>>2]|0;y=f[e>>2]|0;break}if((g|0)>0){t=0;q=1;while(1){v=Y(f[s+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)>=(r|0)){w=v;x=m;y=o;break}else q=v}}else{w=1;x=m;y=o}}else{w=0;x=m;y=o}while(0);r=Kac(w|0,0,h|0,n|0)|0;l=l+1|0;s=Rac(0,r|0,32)|0;r=J;if(l>>>0>=((y-x|0)/12|0)>>>0){i=s;j=r;break}else{m=x;h=s;n=r;o=y}}J=j;u=c;return i|0}function Fjb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=+L(+(+n[j+(b<<2)>>2]));n[i+(b<<2)>>2]=k;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function Gjb(a){a=a|0;O5b(a);return}function Hjb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=+L(+(+n[m+(g<<2)>>2]));n[e+(g<<2)>>2]=r;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function Ijb(a,c){a=a|0;c=c|0;var d=0,e=0;d=L5b(40)|0;Jwa(d);f[d>>2]=125384;b[d+37>>0]=0;e=L5b(16)|0;f[e+4>>2]=1;f[e>>2]=125488;f[e+8>>2]=d;f[a>>2]=e;f[a+4>>2]=d;Kwa(d,c);return}function Jjb(a){a=a|0;O5b(a);return}function Kjb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Ljb(a){a=a|0;lua(a);O5b(a);return}function Mjb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e;dQ(g,125520);j=c+4|0;k=f[c>>2]|0;if((f[j>>2]|0)!=(k|0)){l=a+36|0;a=h+4|0;m=h+8|0;n=h+12|0;o=h+16|0;p=i+4|0;q=h+4|0;r=0;s=k;do{k=f[s+(r<<2)>>2]|0;t=f[d>>2]|0;v=t+(r*56|0)|0;w=f[k+40>>2]|0;x=f[w+-4>>2]|0;y=f[t+(r*56|0)+40>>2]|0;a:do if((x|0)==(f[y+-4>>2]|0)){if((x|0)==2){if((f[w>>2]|0)!=(f[y>>2]|0)){z=14;break}if((f[w+4>>2]|0)!=(f[y+4>>2]|0)){z=14;break}}else if((x|0)>0){t=0;do{if((f[w+(t<<2)>>2]|0)!=(f[y+(t<<2)>>2]|0)){z=14;break a}t=t+1|0}while((t|0)<(x|0))}t=f[k>>2]|0;A=t&4095;B=f[v>>2]|0;if(!((A|0)==5&((A|0)==(B&4095|0)&(t&16384&B|0)!=0)))z=14}else z=14;while(0);if((z|0)==14){z=0;f[h>>2]=0;f[q>>2]=0;x=aD(h,111)|0;y=435751;w=x+111|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(w|0));bO(-215,h,443123,435665,179);bD(h)}y=SQ()|0;f[h>>2]=125548;f[a>>2]=l;f[m>>2]=k;f[n>>2]=v;f[o>>2]=y;f[i>>2]=0;f[p>>2]=y;RQ(i,h,+(y|0));r=r+1|0;s=f[c>>2]|0}while(r>>>0<(f[j>>2]|0)-s>>2>>>0)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Njb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,125500);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Ojb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function Pjb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Qjb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Rjb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yua(a,b,c,d,e)|0;return 1}function Sjb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;a=c;e=d+4|0;g=f[e>>2]|0;h=f[d>>2]|0;if((g|0)==(h|0)){i=0;j=0;J=j;u=c;return i|0}k=a+4|0;l=0;m=h;h=0;n=0;o=g;while(1){g=m;p=f[g+(l*12|0)+4>>2]|0;q=f[g+(l*12|0)>>2]|0;g=p-q|0;r=g>>2;s=q;do if((s|0)!=(p|0)){if((g|0)<=-4){f[a>>2]=0;f[k>>2]=0;q=aD(a,70)|0;t=442586;v=q+70|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,a,442657,442663,160);bD(a);w=1;x=f[d>>2]|0;y=f[e>>2]|0;break}if((g|0)>0){t=0;q=1;while(1){v=Y(f[s+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)>=(r|0)){w=v;x=m;y=o;break}else q=v}}else{w=1;x=m;y=o}}else{w=0;x=m;y=o}while(0);r=cbc(w|0,((w|0)<0)<<31>>31|0,5,0)|0;s=Kac(r|0,J|0,h|0,n|0)|0;l=l+1|0;r=Rac(0,s|0,32)|0;s=J;if(l>>>0>=((y-x|0)/12|0)>>>0){i=r;j=s;break}else{m=x;h=r;n=s;o=y}}J=j;u=c;return i|0}function Tjb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0.0;if((d|0)>0&(f|0)<(g|0)){h=f;i=c;j=b}else return;while(1){b=0;do{k=+W(+(+V(+-+L(+(+n[j+(b<<2)>>2])))+1.0));n[i+(b<<2)>>2]=k;b=b+1|0}while((b|0)!=(d|0));h=h+1|0;if((h|0)==(g|0))break;else{i=i+(e<<2)|0;j=j+(e<<2)|0}}return}function Ujb(a){a=a|0;O5b(a);return}function Vjb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;a=f[d+16>>2]|0;i=f[f[d+44>>2]>>2]|0;d=(k>>>0<o>>>0?k:o)-c|0;if((j|0)>0&(d|0)>0)q=0;else return;do{o=0;e=a+(Y(i,q)|0)+(c<<2)|0;m=h+(Y(b,q)|0)+(c<<2)|0;while(1){g=0;do{r=+W(+(+V(+-+L(+(+n[m+(g<<2)>>2])))+1.0));n[e+(g<<2)>>2]=r;g=g+1|0}while((g|0)!=(d|0));o=o+1|0;if((o|0)==(j|0))break;else{e=e+(k<<2)|0;m=m+(k<<2)|0}}q=q+1|0}while((q|0)!=(l|0));return}function Wjb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0.0,w=0,x=0.0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=aD(e,5)|0;b[g>>0]=b[439622]|0;b[g+1>>0]=b[439623]|0;b[g+2>>0]=b[439624]|0;b[g+3>>0]=b[439625]|0;b[g+4>>0]=b[439626]|0;g=c+4|0;h=f[g>>2]|0;do if(h){i=f[e>>2]|0;j=(i|0)==0?1124530:i;k=g;l=h;a:while(1){m=l;while(1){o=f[m+16>>2]|0;if((o|0)==(i|0))break;if((gTb((o|0)==0?1124530:o,j)|0)>=0)break;o=f[m+4>>2]|0;if(!o){p=k;break a}else m=o}l=f[m>>2]|0;if(!l){p=m;break}else k=m}if((p|0)!=(g|0)){k=f[p+16>>2]|0;if((i|0)!=(k|0)?(gTb(j,(k|0)==0?1124530:k)|0)<=-1:0){q=1.0;break}q=+Hya(p+24|0,-1)}else q=1.0}else q=1.0;while(0);bD(e);f[e>>2]=0;f[e+4>>2]=0;p=aD(e,5)|0;b[p>>0]=b[439628]|0;b[p+1>>0]=b[439629]|0;b[p+2>>0]=b[439630]|0;b[p+3>>0]=b[439631]|0;b[p+4>>0]=b[439632]|0;p=f[g>>2]|0;do if(p){h=f[e>>2]|0;k=(h|0)==0?1124530:h;l=g;o=p;b:while(1){r=o;while(1){s=f[r+16>>2]|0;if((s|0)==(h|0))break;if((gTb((s|0)==0?1124530:s,k)|0)>=0)break;s=f[r+4>>2]|0;if(!s){t=l;break b}else r=s}o=f[r>>2]|0;if(!o){t=r;break}else l=r}if((t|0)!=(g|0)){l=f[t+16>>2]|0;if((h|0)!=(l|0)?(gTb(k,(l|0)==0?1124530:l)|0)<=-1:0){v=1.0;break}v=+Hya(t+24|0,-1)}else v=1.0}else v=1.0;while(0);bD(e);f[e>>2]=0;f[e+4>>2]=0;t=aD(e,5)|0;b[t>>0]=b[439634]|0;b[t+1>>0]=b[439635]|0;b[t+2>>0]=b[439636]|0;b[t+3>>0]=b[439637]|0;b[t+4>>0]=b[439638]|0;t=f[g>>2]|0;do if(t){p=f[e>>2]|0;l=(p|0)==0?1124530:p;o=g;j=t;c:while(1){i=j;while(1){m=f[i+16>>2]|0;if((m|0)==(p|0))break;if((gTb((m|0)==0?1124530:m,l)|0)>=0)break;m=f[i+4>>2]|0;if(!m){w=o;break c}else i=m}j=f[i>>2]|0;if(!j){w=i;break}else o=i}if((w|0)!=(g|0)){o=f[w+16>>2]|0;if((p|0)!=(o|0)?(gTb(l,(o|0)==0?1124530:o)|0)<=-1:0){x=0.0;break}x=+Hya(w+24|0,-1)}else x=0.0}else x=0.0;while(0);bD(e);e=L5b(64)|0;Jwa(e);f[e>>2]=125568;b[e+60>>0]=0;n[e+48>>2]=q;n[e+52>>2]=v;n[e+56>>2]=x;w=L5b(16)|0;f[w+4>>2]=1;f[w>>2]=125672;f[w+8>>2]=e;f[a>>2]=w;f[a+4>>2]=e;Kwa(e,c);n[e+36>>2]=q;n[e+40>>2]=v;n[e+44>>2]=x;u=d;return}function Xjb(a){a=a|0;O5b(a);return}function Yjb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Zjb(a){a=a|0;lua(a);O5b(a);return}function _jb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e;dQ(g,125704);j=c+4|0;k=f[c>>2]|0;if((f[j>>2]|0)!=(k|0)){l=a+48|0;a=h+4|0;m=h+8|0;n=h+12|0;o=h+16|0;p=i+4|0;q=h+4|0;r=0;s=k;do{k=f[s+(r<<2)>>2]|0;t=f[d>>2]|0;v=t+(r*56|0)|0;w=f[k+40>>2]|0;x=f[w+-4>>2]|0;y=f[t+(r*56|0)+40>>2]|0;a:do if((x|0)==(f[y+-4>>2]|0)){if((x|0)==2){if((f[w>>2]|0)!=(f[y>>2]|0)){z=14;break}if((f[w+4>>2]|0)!=(f[y+4>>2]|0)){z=14;break}}else if((x|0)>0){t=0;do{if((f[w+(t<<2)>>2]|0)!=(f[y+(t<<2)>>2]|0)){z=14;break a}t=t+1|0}while((t|0)<(x|0))}t=f[k>>2]|0;A=t&4095;B=f[v>>2]|0;if(!((A|0)==5&((A|0)==(B&4095|0)&(t&16384&B|0)!=0)))z=14}else z=14;while(0);if((z|0)==14){z=0;f[h>>2]=0;f[q>>2]=0;x=aD(h,111)|0;y=435751;w=x+111|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(w|0));bO(-215,h,443123,435665,179);bD(h)}y=SQ()|0;f[h>>2]=125732;f[a>>2]=l;f[m>>2]=k;f[n>>2]=v;f[o>>2]=y;f[i>>2]=0;f[p>>2]=y;RQ(i,h,+(y|0));r=r+1|0;s=f[c>>2]|0}while(r>>>0<(f[j>>2]|0)-s>>2>>>0)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function $jb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,125684);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function akb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function bkb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function ckb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function dkb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yua(a,b,c,d,e)|0;return 1}function ekb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+16|0;e=c;g=d+4|0;h=f[g>>2]|0;i=f[d>>2]|0;if((h|0)==(i|0)){j=0;k=0;J=j;u=c;return k|0}l=a+48|0;a=e+4|0;m=0;o=i;i=0;p=0;q=h;while(1){h=o;r=f[h+(m*12|0)+4>>2]|0;s=f[h+(m*12|0)>>2]|0;h=r-s|0;t=h>>2;v=s;do if((v|0)!=(r|0)){if((h|0)<=-4){f[e>>2]=0;f[a>>2]=0;s=aD(e,70)|0;w=442586;x=s+70|0;do{b[s>>0]=b[w>>0]|0;s=s+1|0;w=w+1|0}while((s|0)<(x|0));bO(-215,e,442657,442663,160);bD(e);y=1;z=f[d>>2]|0;A=f[g>>2]|0;break}if((h|0)>0){w=0;s=1;while(1){x=Y(f[v+(w<<2)>>2]|0,s)|0;w=w+1|0;if((w|0)>=(t|0)){y=x;z=o;A=q;break}else s=x}}else{y=1;z=o;A=q}}else{y=0;z=o;A=q}while(0);t=+n[l>>2]==1.0;v=cbc((t?2:10)|0,(t?0:0)|0,y|0,((y|0)<0)<<31>>31|0)|0;t=Kac(v|0,J|0,i|0,p|0)|0;m=m+1|0;v=Rac(0,t|0,32)|0;t=J;if(m>>>0>=((A-z|0)/12|0)>>>0){j=t;k=v;break}else{o=z;i=v;p=t;q=A}}J=j;u=c;return k|0}function fkb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0;h=+n[a+52>>2];i=+n[a+56>>2];j=+n[a+48>>2];a=(d|0)>0&(f|0)<(g|0);if(j==1.0){if(a){k=c;l=f;m=b}else return;while(1){o=0;do{n[k+(o<<2)>>2]=i+h*+n[m+(o<<2)>>2];o=o+1|0}while((o|0)!=(d|0));l=l+1|0;if((l|0)==(g|0))break;else{k=k+(e<<2)|0;m=m+(e<<2)|0}}return}else{if(a){p=f;q=c;r=b}else return;while(1){b=0;do{s=+N(+(i+h*+n[r+(b<<2)>>2]),+j);n[q+(b<<2)>>2]=s;b=b+1|0}while((b|0)!=(d|0));p=p+1|0;if((p|0)==(g|0))break;else{q=q+(e<<2)|0;r=r+(e<<2)|0}}return}}function gkb(a){a=a|0;O5b(a);return}function hkb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0.0;c=f[a+16>>2]|0;d=f[a+8>>2]|0;e=f[d+4>>2]|0;g=f[d+40>>2]|0;h=f[g>>2]|0;if((e|0)>1){i=f[g+4>>2]|0;if((e|0)==2){j=i;k=1;l=h}else{m=2;o=1;while(1){p=Y(f[g+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)>=(e|0)){j=i;k=p;l=h;break}else o=p}}}else{j=h;k=1;l=1}h=((c+-1+k|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,h)|0;o=Y(f[b+4>>2]|0,h)|0;if((l|0)<=0)return;h=f[d+16>>2]|0;b=f[f[d+44>>2]>>2]|0;d=f[a+12>>2]|0;i=f[d+16>>2]|0;e=f[f[d+44>>2]>>2]|0;d=f[a+4>>2]|0;a=(k>>>0<o>>>0?k:o)-c|0;o=d+4|0;m=d+8|0;if((j|0)>0&(a|0)>0)q=0;else return;do{g=h+(Y(b,q)|0)+(c<<2)|0;p=i+(Y(e,q)|0)+(c<<2)|0;r=+n[o>>2];s=+n[m>>2];t=+n[d>>2];if(t==1.0){u=p;v=0;w=g;while(1){x=0;do{n[u+(x<<2)>>2]=s+r*+n[w+(x<<2)>>2];x=x+1|0}while((x|0)!=(a|0));v=v+1|0;if((v|0)==(j|0))break;else{u=u+(k<<2)|0;w=w+(k<<2)|0}}}else{w=0;u=p;v=g;while(1){x=0;do{y=+N(+(s+r*+n[v+(x<<2)>>2]),+t);n[u+(x<<2)>>2]=y;x=x+1|0}while((x|0)!=(a|0));w=w+1|0;if((w|0)==(j|0))break;else{u=u+(k<<2)|0;v=v+(k<<2)|0}}}q=q+1|0}while((q|0)!=(l|0));return}function ikb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+64|0;e=d+8|0;g=d;h=c+12|0;i=f[h>>2]|0;if(((f[c+16>>2]|0)-i|0)==56){j=h;k=i}else{f[e>>2]=0;f[e+4>>2]=0;l=aD(e,24)|0;m=440216;n=l+24|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,e,440241,435665,769);bD(e);j=h;k=f[h>>2]|0}i=f[k+4>>2]|0;if((i|0)<3)o=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{p=f[k+40>>2]|0;k=0;q=1;while(1){r=Y(f[p+(k<<2)>>2]|0,q)|0;k=k+1|0;if((k|0)==(i|0)){o=r;break}else q=r}}if((o|0)==1){$ta(e,c);aua(e+12|0,h);h=f[c+24>>2]|0;f[e+24>>2]=h;f[e+28>>2]=f[c+28>>2];if(h|0){o=h+-4|0;f[o>>2]=(f[o>>2]|0)+1}o=f[c+32>>2]|0;f[e+32>>2]=o;f[e+36>>2]=f[c+36>>2];if(o|0){h=o+-4|0;f[h>>2]=(f[h>>2]|0)+1}f[g>>2]=0;f[g+4>>2]=0;l=aD(g,14)|0;m=435388;n=l+14|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Zwa(e,g,f[(f[j>>2]|0)+16>>2]|0)|0;bD(g);eib(g,e);m=f[g>>2]|0;f[a>>2]=m;f[a+4>>2]=f[g+4>>2];l=m;if(!m){s=g;t=l}else{m=l+4|0;f[m>>2]=(f[m>>2]|0)+1;s=g;t=f[g>>2]|0}if(t|0?(g=t+4|0,m=f[g>>2]|0,f[g>>2]=m+-1,(m|0)==1):0)bi[f[(f[t>>2]|0)+8>>2]&2047](t);f[s>>2]=0;fua(e);u=d;return}s=L5b(96)|0;t=f[j>>2]|0;f[e>>2]=f[t>>2];j=e+4|0;m=t+4|0;f[j>>2]=f[m>>2];g=e+8|0;f[g>>2]=f[t+8>>2];f[e+12>>2]=f[t+12>>2];l=e+16|0;f[l>>2]=f[t+16>>2];f[e+20>>2]=f[t+20>>2];f[e+24>>2]=f[t+24>>2];f[e+28>>2]=f[t+28>>2];f[e+32>>2]=f[t+32>>2];n=e+36|0;h=f[t+36>>2]|0;f[n>>2]=h;o=e+40|0;f[o>>2]=g;g=e+48|0;q=e+44|0;f[q>>2]=g;f[g>>2]=0;f[e+52>>2]=0;if(h|0){i=h+12|0;f[i>>2]=(f[i>>2]|0)+1}if((f[m>>2]|0)<3){m=f[t+44>>2]|0;i=f[q>>2]|0;f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2]}else{f[j>>2]=0;jL(e,t)}jkb(s,e);t=L5b(16)|0;m=t+4|0;f[m>>2]=1;f[t>>2]=125752;f[t+8>>2]=s;i=t;h=s;k=f[n>>2]|0;if(k|0?(p=k+12|0,k=f[p>>2]|0,f[p>>2]=k+-1,(k|0)==1):0)kL(e);f[n>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[j>>2]|0)>0){l=f[o>>2]|0;o=0;do{f[l+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[j>>2]|0))}j=f[q>>2]|0;if((j|0)!=(g|0))UC(j);Kwa(s,c);f[a>>2]=i;f[a+4>>2]=h;f[m>>2]=(f[m>>2]|0)+1;h=f[m>>2]|0;f[m>>2]=h+-1;if((h|0)!=1){u=d;return}bi[f[(f[t>>2]|0)+8>>2]&2047](t);u=d;return}function jkb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;Jwa(a);f[a>>2]=125772;d=a+36|0;f[d>>2]=1124007936;e=a+40|0;g=a+44|0;h=a+48|0;i=a+52|0;j=a+56|0;k=a+60|0;l=a+64|0;m=a+68|0;n=a+72|0;o=a+76|0;p=e;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=g;p=a+84|0;q=a+80|0;f[q>>2]=p;f[p>>2]=0;f[a+88>>2]=0;b[a+92>>0]=0;if((d|0)==(c|0))return;a=c+36|0;p=f[a>>2]|0;if((p|0?(r=p+12|0,f[r>>2]=(f[r>>2]|0)+1,r=f[n>>2]|0,r|0):0)?(p=r+12|0,r=f[p>>2]|0,f[p>>2]=r+-1,(r|0)==1):0)kL(d);f[n>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[e>>2]|0)>0){r=f[o>>2]|0;o=0;do{f[r+(o<<2)>>2]=0;o=o+1|0;s=f[e>>2]|0}while((o|0)<(s|0));f[d>>2]=f[c>>2];if((s|0)<3)t=11;else t=13}else{f[d>>2]=f[c>>2];t=11}if((t|0)==11){s=f[c+4>>2]|0;if((s|0)<3){f[e>>2]=s;f[g>>2]=f[c+8>>2];f[h>>2]=f[c+12>>2];h=f[c+44>>2]|0;g=f[q>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else t=13}if((t|0)==13)jL(d,c);f[i>>2]=f[c+16>>2];f[j>>2]=f[c+20>>2];f[k>>2]=f[c+24>>2];f[l>>2]=f[c+28>>2];f[m>>2]=f[c+32>>2];f[n>>2]=f[a>>2];return}function kkb(a){a=a|0;O5b(a);return}function lkb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function mkb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=125772;b=a+36|0;c=a+72|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+52|0;b=a+40|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+76>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+80>>2]|0;if((b|0)==(a+84|0)){lua(a);return}UC(b);lua(a);return}function nkb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=125772;b=a+36|0;c=a+72|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+52|0;b=a+40|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+76>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+80>>2]|0;if((b|0)==(a+84|0)){lua(a);O5b(a);return}UC(b);lua(a);O5b(a);return}function okb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e;dQ(g,125888);j=c+4|0;k=f[c>>2]|0;if((f[j>>2]|0)!=(k|0)){l=a+36|0;a=h+4|0;m=h+8|0;n=h+12|0;o=h+16|0;p=i+4|0;q=h+4|0;r=0;s=k;do{k=f[s+(r<<2)>>2]|0;t=f[d>>2]|0;v=t+(r*56|0)|0;w=f[k+40>>2]|0;x=f[w+-4>>2]|0;y=f[t+(r*56|0)+40>>2]|0;a:do if((x|0)==(f[y+-4>>2]|0)){if((x|0)==2){if((f[w>>2]|0)!=(f[y>>2]|0)){z=14;break}if((f[w+4>>2]|0)!=(f[y+4>>2]|0)){z=14;break}}else if((x|0)>0){t=0;do{if((f[w+(t<<2)>>2]|0)!=(f[y+(t<<2)>>2]|0)){z=14;break a}t=t+1|0}while((t|0)<(x|0))}t=f[k>>2]|0;A=t&4095;B=f[v>>2]|0;if(!((A|0)==5&((A|0)==(B&4095|0)&(t&16384&B|0)!=0)))z=14}else z=14;while(0);if((z|0)==14){z=0;f[h>>2]=0;f[q>>2]=0;x=aD(h,111)|0;y=435751;w=x+111|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(w|0));bO(-215,h,443123,435665,179);bD(h)}y=SQ()|0;f[h>>2]=125916;f[a>>2]=l;f[m>>2]=k;f[n>>2]=v;f[o>>2]=y;f[i>>2]=0;f[p>>2]=y;RQ(i,h,+(y|0));r=r+1|0;s=f[c>>2]|0}while(r>>>0<(f[j>>2]|0)-s>>2>>>0)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function pkb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,125868);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function qkb(a,b){a=a|0;b=b|0;var c=0;switch(b|0){case 0:{c=1;break}case 1:{c=Owa()|0;break}default:c=0}return c|0}function rkb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function skb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function tkb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;yua(a,b,c,d,e)|0;return 1}function ukb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;a=c;e=d+4|0;g=f[e>>2]|0;h=f[d>>2]|0;if((g|0)==(h|0)){i=0;j=0;J=j;u=c;return i|0}k=a+4|0;l=0;m=h;h=0;n=0;o=g;while(1){g=m;p=f[g+(l*12|0)+4>>2]|0;q=f[g+(l*12|0)>>2]|0;g=p-q|0;r=g>>2;s=q;do if((s|0)!=(p|0)){if((g|0)<=-4){f[a>>2]=0;f[k>>2]=0;q=aD(a,70)|0;t=442586;v=q+70|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,a,442657,442663,160);bD(a);w=1;x=f[d>>2]|0;y=f[e>>2]|0;break}if((g|0)>0){t=0;q=1;while(1){v=Y(f[s+(t<<2)>>2]|0,q)|0;t=t+1|0;if((t|0)>=(r|0)){w=v;x=m;y=o;break}else q=v}}else{w=1;x=m;y=o}}else{w=0;x=m;y=o}while(0);r=Kac(w|0,0,h|0,n|0)|0;l=l+1|0;s=Rac(0,r|0,32)|0;r=J;if(l>>>0>=((y-x|0)/12|0)>>>0){i=s;j=r;break}else{m=x;h=s;n=r;o=y}}J=j;u=c;return i|0}function vkb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;wkb(a+36|0,b,c,d,e,f,g);return}function wkb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0;j=u;u=u+16|0;k=j;if((f[a>>2]&20479|0)!=16389){f[k>>2]=0;f[k+4>>2]=0;l=aD(k,41)|0;m=440357;o=l+41|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));bO(-215,k,440399,435665,634);bD(k)}p=f[a+16>>2]|0;q=(h|0)<(i|0);if((h|0)>-1&q){r=f[a+4>>2]|0;if((r|0)<3)s=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{t=f[a+40>>2]|0;a=0;v=1;while(1){w=Y(f[t+(a<<2)>>2]|0,v)|0;a=a+1|0;if((a|0)==(r|0)){s=w;break}else v=w}}if((s|0)<(i|0))x=9}else x=9;if((x|0)==9){f[k>>2]=0;f[k+4>>2]=0;l=aD(k,50)|0;m=440405;o=l+50|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));bO(-215,k,440399,435665,637);bD(k)}if(q&(e|0)>0){y=d;z=h;A=c}else{u=j;return}while(1){B=+n[p+(z<<2)>>2];c=0;do{C=+n[A+(c<<2)>>2];n[y+(c<<2)>>2]=!(C>=0.0)?B*C:C;c=c+1|0}while((c|0)!=(e|0));z=z+1|0;if((z|0)==(i|0))break;else{y=y+(g<<2)|0;A=A+(g<<2)|0}}u=j;return}function xkb(a){a=a|0;O5b(a);return}function ykb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+16>>2]|0;d=a+8|0;e=f[d>>2]|0;g=f[e+4>>2]|0;h=f[e+40>>2]|0;i=f[h>>2]|0;if((g|0)>1){j=f[h+4>>2]|0;if((g|0)==2){k=j;l=1;m=i}else{n=2;o=1;while(1){p=Y(f[h+(n<<2)>>2]|0,o)|0;n=n+1|0;if((n|0)>=(g|0)){k=j;l=p;m=i;break}else o=p}}}else{k=i;l=1;m=1}i=((c+-1+l|0)>>>0)/(c>>>0)|0;c=Y(f[b>>2]|0,i)|0;o=Y(f[b+4>>2]|0,i)|0;if((m|0)<=0)return;i=a+12|0;b=a+4|0;a=(l>>>0<o>>>0?l:o)-c|0;o=0;j=e;while(1){e=(f[j+16>>2]|0)+(Y(f[f[j+44>>2]>>2]|0,o)|0)+(c<<2)|0;g=f[i>>2]|0;n=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,o)|0)+(c<<2)|0;wkb(f[b>>2]|0,e,n,a,l,0,k);n=o+1|0;if((n|0)==(m|0))break;o=n;j=f[d>>2]|0}return}function zkb(a,b){a=a|0;b=b|0;var c=0;c=L5b(44)|0;Akb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=125936;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Akb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;Jwa(a);f[a>>2]=125956;Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;g=aD(e,4)|0;b[g>>0]=97;b[g+1>>0]=120;b[g+2>>0]=105;b[g+3>>0]=115;g=c+4|0;c=f[g>>2]|0;do if(c){h=f[e>>2]|0;i=(h|0)==0?1124530:h;j=g;k=c;a:while(1){l=k;while(1){m=f[l+16>>2]|0;if((m|0)==(h|0))break;if((gTb((m|0)==0?1124530:m,i)|0)>=0)break;m=f[l+4>>2]|0;if(!m){n=j;break a}else l=m}k=f[l>>2]|0;if(!k){n=l;break}else j=l}if((n|0)!=(g|0)){j=f[n+16>>2]|0;if((h|0)!=(j|0)?(gTb(i,(j|0)==0?1124530:j)|0)<=-1:0){o=1;break}j=Gwa(n+24|0,-1)|0;o=j}else o=1}else o=1;while(0);f[a+36>>2]=o;bD(e);f[e>>2]=0;f[e+4>>2]=0;o=aD(e,7)|0;b[o>>0]=b[441015]|0;b[o+1>>0]=b[441016]|0;b[o+2>>0]=b[441017]|0;b[o+3>>0]=b[441018]|0;b[o+4>>0]=b[441019]|0;b[o+5>>0]=b[441020]|0;b[o+6>>0]=b[441021]|0;o=f[g>>2]|0;if(!o){p=0;q=a+40|0;b[q>>0]=p;bD(e);u=d;return}n=f[e>>2]|0;c=(n|0)==0?1124530:n;j=g;k=o;b:while(1){o=k;while(1){m=f[o+16>>2]|0;if((m|0)==(n|0))break;if((gTb((m|0)==0?1124530:m,c)|0)>=0)break;m=f[o+4>>2]|0;if(!m){r=j;break b}else o=m}k=f[o>>2]|0;if(!k){r=o;break}else j=o}if((r|0)==(g|0)){p=0;q=a+40|0;b[q>>0]=p;bD(e);u=d;return}g=f[r+16>>2]|0;if((n|0)!=(g|0)?(gTb(c,(g|0)==0?1124530:g)|0)<=-1:0){p=0;q=a+40|0;b[q>>0]=p;bD(e);u=d;return}g=Gwa(r+24|0,-1)|0;p=((g|0)!=0|(J|0)!=0)&1;q=a+40|0;b[q>>0]=p;bD(e);u=d;return}function Bkb(a){a=a|0;O5b(a);return}function Ckb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Dkb(a){a=a|0;lua(a);O5b(a);return}function Ekb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+96|0;g=e+88|0;h=e+72|0;i=e;j=e+16|0;dQ(g,126080);k=f[a+36>>2]|0;l=((k|0)<0?f[(f[f[c>>2]>>2]|0)+4>>2]|0:0)+k|0;k=f[d>>2]|0;m=a+40|0;if(b[m>>0]|0){p[i>>3]=0.0;f[h>>2]=-1056833530;f[h+4>>2]=i;f[h+8>>2]=1;f[h+12>>2]=1;VP(k,h,UM()|0)|0}if(((l|0)==1?(f[k+4>>2]|0)==4:0)?(b[m>>0]|0)==0:0)Jkb(c,k,SQ()|0);else{m=f[(f[d>>2]|0)+4>>2]|0;f[h>>2]=0;d=h+4|0;f[d>>2]=0;f[h+8>>2]=0;if(m>>>0>536870911)c4b(h);a=L5b(m<<3)|0;f[d>>2]=a;f[h>>2]=a;f[h+8>>2]=a+(m<<3);n=m;o=a;q=a;while(1){r=o;f[r>>2]=-2147483648;f[r+4>>2]=2147483647;r=q+8|0;s=n+-1|0;if(!s)break;else{n=s;o=r;q=r}}f[d>>2]=a+(m<<3);f[a+(l<<3)>>2]=0;m=c+4|0;q=f[c>>2]|0;if((f[m>>2]|0)==(q|0))t=a;else{o=k+4|0;n=i+8|0;r=i+4|0;s=j+36|0;v=j+16|0;w=j+4|0;x=j+40|0;y=j+44|0;z=j+48|0;A=k+40|0;B=0;C=q;q=f[a+(l<<3)>>2]|0;D=a;while(1){f[D+(l<<3)+4>>2]=(f[(f[(f[C+(B<<2)>>2]|0)+40>>2]|0)+(l<<2)>>2]|0)+q;a=f[o>>2]|0;if((a|0)>0){E=(f[c>>2]|0)+(B<<2)|0;F=f[h>>2]|0;G=0;do{if((G|0)!=(l|0)){H=(f[(f[E>>2]|0)+40>>2]|0)+(G<<2)|0;I=((f[(f[A>>2]|0)+(G<<2)>>2]|0)-(f[H>>2]|0)|0)/2|0;f[F+(G<<3)>>2]=I;f[F+(G<<3)+4>>2]=(f[H>>2]|0)+I}G=G+1|0}while((G|0)<(a|0))}a=f[(f[c>>2]|0)+(B<<2)>>2]|0;mL(j,k,f[h>>2]|0);G=n;f[G>>2]=0;f[G+4>>2]=0;f[i>>2]=-1040121856;f[r>>2]=j;SP(a,i);a=f[s>>2]|0;if(a|0?(G=a+12|0,a=f[G>>2]|0,f[G>>2]=a+-1,(a|0)==1):0)kL(j);f[s>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[w>>2]|0)>0){a=f[x>>2]|0;G=0;do{f[a+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[w>>2]|0))}G=f[y>>2]|0;if((G|0)!=(z|0))UC(G);G=f[h>>2]|0;q=f[G+(l<<3)+4>>2]|0;f[G+(l<<3)>>2]=q;B=B+1|0;C=f[c>>2]|0;if(B>>>0>=(f[m>>2]|0)-C>>2>>>0){t=G;break}else D=G}}if(t|0){D=f[d>>2]|0;if((D|0)!=(t|0))f[d>>2]=D+(~((D+-8-t|0)>>>3)<<3);O5b(t)}}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Fkb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,126048);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Gkb(a,c){a=a|0;c=c|0;var d=0;switch(c|0){case 0:{d=1;break}case 1:{if(Owa()|0?(f[a+36>>2]|0)==1:0)d=(b[a+40>>0]|0)==0;else d=0;break}default:d=0}return d|0}function Hkb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function Ikb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+32|0;d=g+8|0;h=g;i=c+4|0;if((f[i>>2]|0)==(f[c>>2]|0)){f[d>>2]=0;f[d+4>>2]=0;j=aD(d,17)|0;k=441774;l=j+17|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,d,442770,441023,68);bD(d)}m=e+4|0;n=f[m>>2]|0;o=f[e>>2]|0;p=n-o|0;q=(p|0)/12|0;r=o;o=n;if(p){if(q>>>0>1?(p=r+12|0,(o|0)!=(p|0)):0){r=o;while(1){o=r+-12|0;f[m>>2]=o;n=f[o>>2]|0;if(!n)s=o;else{o=r+-8|0;t=f[o>>2]|0;if((t|0)!=(n|0))f[o>>2]=t+(~((t+-4-n|0)>>>2)<<2);O5b(n);s=f[m>>2]|0}if((s|0)==(p|0))break;else r=s}}}else sbb(e,1-q|0,f[c>>2]|0);q=f[a+36>>2]|0;s=f[c>>2]|0;r=((q|0)<0?(f[s+4>>2]|0)-(f[s>>2]|0)>>2:0)+q|0;if((f[i>>2]|0)==(s|0)){v=0;w=e;x=f[w>>2]|0;y=f[x>>2]|0;z=y+(r<<2)|0;f[z>>2]=v;u=g;return 0}q=a+40|0;a=d+4|0;p=h+4|0;m=h+4|0;n=0;t=0;o=s;while(1){Bua(d,o+(n*12|0)|0);if(!(b[q>>0]|0)){s=f[e>>2]|0;A=f[s+4>>2]|0;B=f[s>>2]|0;if(((f[a>>2]|0)-(f[d>>2]|0)|0)==(A-B|0)){C=s;D=A;E=B}else{f[h>>2]=0;f[p>>2]=0;j=aD(h,36)|0;k=441103;l=j+36|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,442770,441023,86);bD(h);B=f[e>>2]|0;C=B;D=f[B+4>>2]|0;E=f[B>>2]|0}if((D|0)!=(E|0)){B=0;A=C;while(1){if((B|0)!=(r|0)?(f[(f[A>>2]|0)+(B<<2)>>2]|0)!=(f[(f[d>>2]|0)+(B<<2)>>2]|0):0){f[h>>2]=0;f[m>>2]=0;j=aD(h,33)|0;k=441140;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-201,h,442770,441023,90);bD(h);F=f[e>>2]|0}else F=A;B=B+1|0;if(B>>>0>=(f[F+4>>2]|0)-(f[F>>2]|0)>>2>>>0)break;else A=F}}}else{A=f[e>>2]|0;B=f[A+4>>2]|0;s=f[A>>2]|0;A=s;if((B|0)!=(s|0)){G=f[d>>2]|0;H=B-s>>2;s=0;do{B=A+(s<<2)|0;I=f[B>>2]|0;J=f[G+(s<<2)>>2]|0;f[B>>2]=(I|0)<(J|0)?J:I;s=s+1|0}while(s>>>0<H>>>0)}}H=f[d>>2]|0;s=(f[H+(r<<2)>>2]|0)+t|0;if(H|0){G=f[a>>2]|0;if((G|0)!=(H|0))f[a>>2]=G+(~((G+-4-H|0)>>>2)<<2);O5b(H)}n=n+1|0;o=f[c>>2]|0;if(n>>>0>=(((f[i>>2]|0)-o|0)/12|0)>>>0){v=s;w=e;break}else t=s}x=f[w>>2]|0;y=f[x>>2]|0;z=y+(r<<2)|0;f[z>>2]=v;u=g;return 0}function Jkb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+48|0;g=e+8|0;h=e;f[g>>2]=126120;i=g+4|0;j=i+12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[i>>2]=a;f[g+8>>2]=c;f[g+12>>2]=d;i=f[a>>2]|0;j=(f[a+4>>2]|0)-i>>2;k=c+40|0;l=f[k>>2]|0;m=f[l>>2]|0;n=(j|0)==0;if(n){o=0;p=l}else{l=h+4|0;q=0;r=0;s=i;while(1){i=f[s+(q<<2)>>2]|0;if(((((f[i>>2]&20479|0)==16389?(f[i+4>>2]|0)==4:0)?(t=f[i+40>>2]|0,v=f[k>>2]|0,(f[t>>2]|0)==(f[v>>2]|0)):0)?(f[t+8>>2]|0)==(f[v+8>>2]|0):0)?(f[t+12>>2]|0)==(f[v+12>>2]|0):0)w=t;else{f[h>>2]=0;f[l>>2]=0;Vac(aD(h,153)|0,441283,153)|0;bO(-215,h,443206,441023,129);bD(h);w=f[i+40>>2]|0}x=(f[w+4>>2]|0)+r|0;i=q+1|0;if(i>>>0>=j>>>0)break;q=i;r=x;s=f[a>>2]|0}o=x;p=f[k>>2]|0}if((o|0)!=(f[p+4>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;y=aD(h,27)|0;z=441437;A=y+27|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,h,443206,441023,132);bD(h)}if((f[c>>2]&20479|0)!=16389){f[h>>2]=0;f[h+4>>2]=0;y=aD(h,43)|0;z=441465;A=y+43|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,h,443206,441023,133);bD(h)}z=g+16|0;y=Y(o,m)|0;A=g+20|0;c=f[A>>2]|0;p=f[z>>2]|0;k=c-p>>2;x=p;p=c;if(y>>>0<=k>>>0){if(y>>>0<k>>>0?(c=x+(y<<2)|0,(p|0)!=(c|0)):0)f[A>>2]=p+(~((p+-4-c|0)>>>2)<<2)}else Kkb(z,y-k|0);if(!n?(m|0)>0:0){n=0;k=0;while(1){y=f[(f[a>>2]|0)+(k<<2)>>2]|0;c=y+40|0;p=y+16|0;x=y+44|0;y=0;s=f[(f[c>>2]|0)+4>>2]|0;while(1){if((s|0)>0){r=(Y(y,o)|0)+n|0;q=0;do{w=f[x>>2]|0;l=(f[p>>2]|0)+(Y(f[w>>2]|0,y)|0)|0;i=l+(Y(f[w+4>>2]|0,q)|0)|0;f[(f[z>>2]|0)+(r+q<<2)>>2]=i;q=q+1|0;i=f[(f[c>>2]|0)+4>>2]|0}while((q|0)<(i|0));B=i}else B=s;y=y+1|0;if((y|0)==(m|0))break;else s=B}k=k+1|0;if((k|0)==(j|0))break;else n=B+n|0}}f[h>>2]=0;f[h+4>>2]=d;RQ(h,g,+(d|0));f[g>>2]=126120;d=f[g+16>>2]|0;if(!d){u=e;return}g=f[A>>2]|0;if((g|0)!=(d|0))f[A>>2]=g+(~((g+-4-d|0)>>>2)<<2);O5b(d);u=e;return}function Kkb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)c4b(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)Vac(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;O5b(d);return}function Lkb(a){a=a|0;var b=0,c=0;f[a>>2]=126120;b=f[a+16>>2]|0;if(!b)return;c=a+20|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);O5b(b);return}function Mkb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=126120;b=f[a+16>>2]|0;if(!b){O5b(a);return}c=a+20|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);O5b(a);return}function Nkb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a+8>>2]|0;d=f[c+40>>2]|0;e=Y(f[d+12>>2]|0,f[d+8>>2]|0)|0;d=f[a+16>>2]|0;g=Y((f[a+20>>2]|0)-d>>2,e)|0;h=f[a+12>>2]|0;a=((h+-1+g|0)>>>0)/(h>>>0)|0;h=Y(f[b>>2]|0,a)|0;i=Y(f[b+4>>2]|0,a)|0;a=i>>>0<g>>>0?i:g;g=d;d=f[c+16>>2]|0;if(h>>>0<a>>>0)j=h;else return;do{h=(j>>>0)/(e>>>0)|0;c=j-(Y(h,e)|0)|0;i=e-c|0;b=i>>>0<65536?i:65536;Vac(d+(j<<2)|0,(f[g+(h<<2)>>2]|0)+(c<<2)|0,b<<2|0)|0;j=b+j|0}while(j>>>0<a>>>0);return}function Okb(a,b){a=a|0;b=b|0;var c=0;c=L5b(44)|0;Pkb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=126140;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Pkb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;Jwa(a);f[a>>2]=126160;f[e>>2]=0;f[e+4>>2]=0;g=aD(e,4)|0;b[g>>0]=97;b[g+1>>0]=120;b[g+2>>0]=105;b[g+3>>0]=115;g=c+4|0;h=f[g>>2]|0;do if(h){i=f[e>>2]|0;j=(i|0)==0?1124530:i;k=g;l=h;a:while(1){m=l;while(1){n=f[m+16>>2]|0;if((n|0)==(i|0))break;if((gTb((n|0)==0?1124530:n,j)|0)>=0)break;n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(g|0)){k=f[o+16>>2]|0;if((i|0)!=(k|0)?(gTb(j,(k|0)==0?1124530:k)|0)<=-1:0){p=1;break}k=Gwa(o+24|0,-1)|0;p=k}else p=1}else p=1;while(0);f[a+36>>2]=p;bD(e);f[e>>2]=0;f[e+4>>2]=0;p=aD(e,8)|0;o=p;b[o>>0]=101;b[o+1>>0]=110;b[o+2>>0]=100;b[o+3>>0]=95;o=p+4|0;b[o>>0]=97;b[o+1>>0]=120;b[o+2>>0]=105;b[o+3>>0]=115;o=f[g>>2]|0;if(!o){q=-1;r=a+40|0;f[r>>2]=q;bD(e);Kwa(a,c);u=d;return}p=f[e>>2]|0;h=(p|0)==0?1124530:p;k=g;l=o;b:while(1){o=l;while(1){n=f[o+16>>2]|0;if((n|0)==(p|0))break;if((gTb((n|0)==0?1124530:n,h)|0)>=0)break;n=f[o+4>>2]|0;if(!n){s=k;break b}else o=n}l=f[o>>2]|0;if(!l){s=o;break}else k=o}if((s|0)==(g|0)){q=-1;r=a+40|0;f[r>>2]=q;bD(e);Kwa(a,c);u=d;return}g=f[s+16>>2]|0;if((p|0)!=(g|0)?(gTb(h,(g|0)==0?1124530:g)|0)<=-1:0){q=-1;r=a+40|0;f[r>>2]=q;bD(e);Kwa(a,c);u=d;return}g=Gwa(s+24|0,-1)|0;q=g;r=a+40|0;f[r>>2]=q;bD(e);Kwa(a,c);u=d;return}function Qkb(a){a=a|0;O5b(a);return}function Rkb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Skb(a){a=a|0;lua(a);O5b(a);return}function Tkb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+80|0;a=d+72|0;e=d+56|0;g=d;dQ(a,126284);h=b+4|0;if((f[h>>2]|0)!=(f[b>>2]|0)){i=e+4|0;j=e+8|0;k=g+36|0;l=g+16|0;m=g+4|0;n=g+40|0;o=g+44|0;p=g+48|0;q=g+8|0;r=g+12|0;s=g+20|0;t=g+24|0;v=g+28|0;w=g+32|0;x=0;do{y=f[c>>2]|0;z=f[y+(x*56|0)+4>>2]|0;A=f[y+(x*56|0)+40>>2]|0;f[e>>2]=0;f[i>>2]=0;f[j>>2]=0;Rva(e,A,A+(z<<2)|0);z=f[e>>2]|0;XL(g,f[(f[b>>2]|0)+(x<<2)>>2]|0,1,(f[i>>2]|0)-z>>2,z);z=f[c>>2]|0;A=z+(x*56|0)|0;if((A|0)!=(g|0)){y=f[k>>2]|0;if(y|0){B=y+12|0;f[B>>2]=(f[B>>2]|0)+1}B=z+(x*56|0)+36|0;y=f[B>>2]|0;if(y|0?(C=y+12|0,y=f[C>>2]|0,f[C>>2]=y+-1,(y|0)==1):0)kL(A);f[B>>2]=0;y=z+(x*56|0)+16|0;C=z+(x*56|0)+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[C>>2]|0)>0){D=f[z+(x*56|0)+40>>2]|0;E=0;do{f[D+(E<<2)>>2]=0;E=E+1|0;F=f[C>>2]|0}while((E|0)<(F|0));f[A>>2]=f[g>>2];if((F|0)<3)G=19;else G=21}else{f[A>>2]=f[g>>2];G=19}if((G|0)==19){G=0;E=f[m>>2]|0;if((E|0)<3){f[C>>2]=E;f[z+(x*56|0)+8>>2]=f[q>>2];f[z+(x*56|0)+12>>2]=f[r>>2];E=f[o>>2]|0;D=f[z+(x*56|0)+44>>2]|0;f[D>>2]=f[E>>2];f[D+4>>2]=f[E+4>>2]}else G=21}if((G|0)==21){G=0;jL(A,g)}f[y>>2]=f[l>>2];f[z+(x*56|0)+20>>2]=f[s>>2];f[z+(x*56|0)+24>>2]=f[t>>2];f[z+(x*56|0)+28>>2]=f[v>>2];f[z+(x*56|0)+32>>2]=f[w>>2];f[B>>2]=f[k>>2]}E=f[k>>2]|0;if(E|0?(D=E+12|0,E=f[D>>2]|0,f[D>>2]=E+-1,(E|0)==1):0)kL(g);f[k>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){E=f[n>>2]|0;D=0;do{f[E+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[m>>2]|0))}D=f[o>>2]|0;if((D|0)!=(p|0))UC(D);D=f[e>>2]|0;if(D|0){E=f[i>>2]|0;if((E|0)!=(D|0))f[i>>2]=E+(~((E+-4-D|0)>>>2)<<2);O5b(D)}x=x+1|0}while(x>>>0<(f[h>>2]|0)-(f[b>>2]|0)>>2>>>0)}if(!(f[a+4>>2]|0)){u=d;return}u=d;return}function Ukb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,126252);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Vkb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;g=u;u=u+32|0;d=g+8|0;h=g;i=c+4|0;j=f[i>>2]|0;k=f[c>>2]|0;if((j|0)==(k|0)){f[d>>2]=0;f[d+4>>2]=0;l=aD(d,17)|0;m=441774;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,442770,441792,69);bD(d);o=f[c>>2]|0;p=f[i>>2]|0}else{o=k;p=j}j=o;k=o;if(((p-o|0)/12|0)>>>0>1){q=d+4|0;r=1;s=k;t=j;v=p;w=o;while(1){x=f[s+(r*12|0)+4>>2]|0;y=f[s+(r*12|0)>>2]|0;z=f[w>>2]|0;A=y;B=x;a:do if((x-y|0)==((f[s+4>>2]|0)-z|0))if((A|0)==(B|0)){C=t;D=w;E=v}else{F=A;G=z;while(1){if((f[F>>2]|0)!=(f[G>>2]|0)){H=12;break a}F=F+4|0;if((F|0)==(B|0)){C=t;D=w;E=v;break}else G=G+4|0}}else H=12;while(0);if((H|0)==12){H=0;f[d>>2]=0;f[q>>2]=0;l=aD(d,22)|0;m=441873;n=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,442770,441792,72);bD(d);B=f[c>>2]|0;C=B;D=B;E=f[i>>2]|0}r=r+1|0;B=D;if(r>>>0>=((E-D|0)/12|0)>>>0){I=B;J=D;K=C;L=E;break}else{s=B;t=C;v=E;w=D}}}else{I=k;J=o;K=j;L=p}p=(f[I+4>>2]|0)-(f[J>>2]|0)>>2;I=f[a+36>>2]|0;j=((I|0)<0?p:0)+I|0;I=f[a+40>>2]|0;a=((I|0)<0?p:0)+I|0;if(((L-J|0)/12|0)>>>0>1){I=d+4|0;o=1;k=J;J=L;L=K;while(1){K=f[L+(o*12|0)+4>>2]|0;D=f[L+(o*12|0)>>2]|0;w=f[L>>2]|0;E=D;v=K;b:do if((K-D|0)==((f[L+4>>2]|0)-w|0))if((E|0)==(v|0)){M=k;N=J}else{C=E;t=w;while(1){if((f[C>>2]|0)!=(f[t>>2]|0)){H=20;break b}C=C+4|0;if((C|0)==(v|0)){M=k;N=J;break}else t=t+4|0}}else H=20;while(0);if((H|0)==20){H=0;f[d>>2]=0;f[I>>2]=0;l=aD(d,22)|0;m=441873;n=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,442770,441792,81);bD(d);M=f[c>>2]|0;N=f[i>>2]|0}o=o+1|0;if(o>>>0>=((N-M|0)/12|0)>>>0)break;else{k=M;J=N;L=M}}}if((j|0)<=-1){f[d>>2]=0;f[d+4>>2]=0;l=aD(d,14)|0;m=441896;n=l+14|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,442770,441792,85);bD(d)}if(!((a|0)>=(j|0)&(a|0)<(p|0))){f[d>>2]=0;f[d+4>>2]=0;l=aD(d,46)|0;m=441911;n=l+46|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,442770,441792,86);bD(d)}M=f[c>>2]|0;L=a+1|0;a=(j|0)==-1?0:j;if((L|0)==-1){N=f[M+4>>2]|0;J=f[M>>2]|0;O=N-J>>2;P=M;Q=J;R=N;S=J;T=N}else{N=f[M>>2]|0;J=f[M+4>>2]|0;O=L;P=M;Q=N;R=J;S=N;T=J}if((Q|0)!=(R|0)){R=T-S>>2;if(!((a|0)<=(R|0)?!((a|0)>(O|0)|(O|0)>(R|0)):0)){f[d>>2]=0;f[d+4>>2]=0;l=aD(d,70)|0;m=442586;n=l+70|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,442657,442663,160);bD(d)}if((a|0)<(O|0)){R=f[P>>2]|0;P=1;S=a;while(1){a=Y(f[R+(S<<2)>>2]|0,P)|0;S=S+1|0;if((S|0)==(O|0)){U=a;break}else P=a}}else U=1}else U=0;f[d>>2]=0;P=d+4|0;f[P>>2]=0;f[d+8>>2]=0;O=d+8|0;if((j|0)>0){S=0;R=0;a=0;do{T=(f[f[c>>2]>>2]|0)+(S<<2)|0;if((R|0)==(a|0))IO(d,T);else{f[R>>2]=f[T>>2];f[P>>2]=R+4}S=S+1|0;R=f[P>>2]|0;a=f[O>>2]|0}while((S|0)<(j|0));f[h>>2]=U;if((R|0)==(a|0)){V=h;H=39}else{f[R>>2]=U;f[P>>2]=R+4;W=h}}else{f[h>>2]=U;V=h;H=39}if((H|0)==39){IO(d,h);W=V}if(L>>>0<p>>>0){V=L;do{L=(f[f[c>>2]>>2]|0)+(V<<2)|0;W=f[P>>2]|0;if((W|0)==(f[O>>2]|0))IO(d,L);else{f[W>>2]=f[L>>2];f[P>>2]=W+4}V=V+1|0}while(V>>>0<p>>>0)}if((f[P>>2]|0)-(f[d>>2]|0)>>2>>>0>=5){f[h>>2]=0;f[h+4>>2]=0;l=aD(h,26)|0;m=441958;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,h,442770,441792,100);bD(h)}h=((f[i>>2]|0)-(f[c>>2]|0)|0)/12|0;c=e+4|0;i=f[c>>2]|0;m=f[e>>2]|0;l=(i-m|0)/12|0;n=m;m=i;if(h>>>0<=l>>>0){if(h>>>0<l>>>0?(i=n+(h*12|0)|0,(m|0)!=(i|0)):0){n=m;while(1){m=n+-12|0;f[c>>2]=m;p=f[m>>2]|0;if(!p)X=m;else{m=n+-8|0;V=f[m>>2]|0;if((V|0)!=(p|0))f[m>>2]=V+(~((V+-4-p|0)>>>2)<<2);O5b(p);X=f[c>>2]|0}if((X|0)==(i|0))break;else n=X}}}else sbb(e,h-l|0,d);l=f[d>>2]|0;if(!l){u=g;return 1}d=f[P>>2]|0;if((d|0)!=(l|0))f[P>>2]=d+(~((d+-4-l|0)>>>2)<<2);O5b(l);u=g;return 1}function Wkb(a,b){a=a|0;b=b|0;var c=0;c=L5b(96)|0;Xkb(c,b);b=L5b(16)|0;f[b+4>>2]=1;f[b>>2]=126324;f[b+8>>2]=c;f[a>>2]=b;f[a+4>>2]=c;return}function Xkb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0;d=u;u=u+48|0;e=d+32|0;g=d+24|0;h=d+16|0;i=d;j=d+8|0;Jwa(a);k=a+40|0;f[a+68>>2]=0;f[a+72>>2]=0;l=a+80|0;f[l>>2]=0;m=a+84|0;f[m>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[a>>2]=126344;o=a+65|0;b[o>>0]=1;p=a+64|0;b[p>>0]=0;q=a+48|0;f[q>>2]=1;r=a+52|0;f[r>>2]=1;f[e>>2]=0;f[e+4>>2]=0;s=aD(e,4)|0;b[s>>0]=112;b[s+1>>0]=111;b[s+2>>0]=111;b[s+3>>0]=108;s=c+4|0;t=f[s>>2]|0;a:do if(t){v=f[e>>2]|0;w=(v|0)==0?1124530:v;x=t;while(1){y=f[x+16>>2]|0;if((v|0)==(y|0)){z=34;break}A=(y|0)==0?1124530:y;if((gTb(w,A)|0)<0)B=x;else{if((gTb(A,w)|0)>=0){z=35;break}B=x+4|0}x=f[B>>2]|0;if(!x){z=9;break a}}if((z|0)==34){bD(e);z=41;break}else if((z|0)==35){bD(e);z=41;break}}else z=9;while(0);b:do if((z|0)==9){f[g>>2]=0;f[g+4>>2]=0;C=aD(g,11)|0;D=442358;E=C+11|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));B=f[s>>2]|0;c:do if(B|0){t=f[g>>2]|0;x=(t|0)==0?1124530:t;w=B;while(1){v=f[w+16>>2]|0;if((t|0)==(v|0)){z=36;break}A=(v|0)==0?1124530:v;if((gTb(x,A)|0)<0)F=w;else{if((gTb(A,x)|0)>=0){z=37;break}F=w+4|0}w=f[F>>2]|0;if(!w)break c}if((z|0)==36){bD(g);bD(e);z=41;break b}else if((z|0)==37){bD(g);bD(e);z=41;break b}}while(0);f[h>>2]=0;f[h+4>>2]=0;B=aD(h,8)|0;w=B;b[w>>0]=107;b[w+1>>0]=101;b[w+2>>0]=114;b[w+3>>0]=110;w=B+4|0;b[w>>0]=101;b[w+1>>0]=108;b[w+2>>0]=95;b[w+3>>0]=119;w=f[s>>2]|0;d:do if(w|0){B=f[h>>2]|0;x=(B|0)==0?1124530:B;t=w;while(1){A=f[t+16>>2]|0;if((B|0)==(A|0)){z=38;break}v=(A|0)==0?1124530:A;if((gTb(x,v)|0)<0)G=t;else{if((gTb(v,x)|0)>=0){z=39;break}G=t+4|0}t=f[G>>2]|0;if(!t)break d}if((z|0)==38){bD(h);bD(g);bD(e);z=41;break b}else if((z|0)==39){bD(h);bD(g);bD(e);z=41;break b}}while(0);f[i>>2]=0;f[i+4>>2]=0;w=aD(i,8)|0;t=w;b[t>>0]=107;b[t+1>>0]=101;b[t+2>>0]=114;b[t+3>>0]=110;t=w+4|0;b[t>>0]=101;b[t+1>>0]=108;b[t+2>>0]=95;b[t+3>>0]=104;t=f[s>>2]|0;do if(t){w=f[i>>2]|0;x=(w|0)==0?1124530:w;B=t;while(1){v=f[B+16>>2]|0;if((w|0)==(v|0)){z=40;break}A=(v|0)==0?1124530:v;if((gTb(x,A)|0)<0)H=B;else{if((gTb(A,x)|0)>=0){z=33;break}H=B+4|0}B=f[H>>2]|0;if(!B){z=78;break}}if((z|0)==33){bD(i);bD(h);bD(g);bD(e);z=41;break b}else if((z|0)==40){bD(i);bD(h);bD(g);bD(e);z=41;break b}else if((z|0)==78){bD(i);bD(h);bD(g);bD(e);break}}else{bD(i);bD(h);bD(g);bD(e)}while(0);f[e>>2]=0;f[e+4>>2]=0;t=aD(e,8)|0;B=t;b[B>>0]=112;b[B+1>>0]=111;b[B+2>>0]=111;b[B+3>>0]=108;B=t+4|0;b[B>>0]=101;b[B+1>>0]=100;b[B+2>>0]=95;b[B+3>>0]=119;B=f[s>>2]|0;e:do if(B){t=f[e>>2]|0;x=(t|0)==0?1124530:t;w=B;while(1){A=f[w+16>>2]|0;if((t|0)==(A|0)){z=96;break}v=(A|0)==0?1124530:A;if((gTb(x,v)|0)<0)I=w;else{if((gTb(v,x)|0)>=0){z=97;break}I=w+4|0}w=f[I>>2]|0;if(!w){z=87;break e}}if((z|0)==96){bD(e);break}else if((z|0)==97){bD(e);break}}else z=87;while(0);f:do if((z|0)==87){f[g>>2]=0;f[g+4>>2]=0;B=aD(g,8)|0;w=B;b[w>>0]=112;b[w+1>>0]=111;b[w+2>>0]=111;b[w+3>>0]=108;w=B+4|0;b[w>>0]=101;b[w+1>>0]=100;b[w+2>>0]=95;b[w+3>>0]=104;w=f[s>>2]|0;do if(w){B=f[g>>2]|0;x=(B|0)==0?1124530:B;t=w;while(1){v=f[t+16>>2]|0;if((B|0)==(v|0)){z=98;break}A=(v|0)==0?1124530:v;if((gTb(x,A)|0)<0)K=t;else{if((gTb(A,x)|0)>=0){z=95;break}K=t+4|0}t=f[K>>2]|0;if(!t){z=123;break}}if((z|0)==95){bD(g);bD(e);break f}else if((z|0)==98){bD(g);bD(e);break f}else if((z|0)==123){bD(g);bD(e);break}}else{bD(g);bD(e)}while(0);f[e>>2]=0;f[e+4>>2]=0;C=aD(e,10)|0;D=442510;E=C+10|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));w=f[s>>2]|0;do if(!w)bD(e);else{t=f[e>>2]|0;x=(t|0)==0?1124530:t;B=w;while(1){A=f[B+16>>2]|0;if((t|0)==(A|0))break;v=(A|0)==0?1124530:A;if((gTb(x,v)|0)<0)L=B;else{if((gTb(v,x)|0)>=0)break;L=B+4|0}B=f[L>>2]|0;if(!B){z=144;break}}if((z|0)==144){bD(e);break}f[g>>2]=0;f[g+4>>2]=0;C=aD(g,10)|0;D=442521;E=C+10|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));B=f[s>>2]|0;if(!B){bD(g);bD(e);break}x=f[g>>2]|0;t=(x|0)==0?1124530:x;v=B;while(1){B=f[v+16>>2]|0;if((x|0)==(B|0)){z=141;break}A=(B|0)==0?1124530:B;if((gTb(t,A)|0)<0)M=v;else{if((gTb(A,t)|0)>=0){z=140;break}M=v+4|0}v=f[M>>2]|0;if(!v){z=146;break}}if((z|0)==140){bD(g);bD(e)}else if((z|0)==141){bD(g);bD(e)}else if((z|0)==146){bD(g);bD(e);break}f[a+36>>2]=4;f[e>>2]=0;f[e+4>>2]=0;C=aD(e,10)|0;D=442521;E=C+10|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));v=Gwa(Eya(c,e)|0,-1)|0;f[l>>2]=v;bD(e);f[m>>2]=f[l>>2];f[e>>2]=0;f[e+4>>2]=0;C=aD(e,10)|0;D=442510;E=C+10|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));v=Gwa(Eya(c,e)|0,-1)|0;f[a+92>>2]=v;bD(e);break b}while(0);f[e>>2]=0;f[e+4>>2]=0;C=aD(e,29)|0;D=442532;E=C+29|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-5,e,442412,442429,104);bD(e);break b}while(0);f[a+36>>2]=3;b[o>>0]=0;f[e>>2]=0;f[e+4>>2]=0;w=aD(e,8)|0;v=w;b[v>>0]=112;b[v+1>>0]=111;b[v+2>>0]=111;b[v+3>>0]=108;v=w+4|0;b[v>>0]=101;b[v+1>>0]=100;b[v+2>>0]=95;b[v+3>>0]=119;v=f[s>>2]|0;do if(v){w=f[e>>2]|0;t=(w|0)==0?1124530:w;x=s;A=v;g:while(1){B=A;while(1){y=f[B+16>>2]|0;if((y|0)==(w|0))break;if((gTb((y|0)==0?1124530:y,t)|0)>=0)break;y=f[B+4>>2]|0;if(!y){N=x;break g}else B=y}A=f[B>>2]|0;if(!A){N=B;break}else x=B}if((N|0)!=(s|0)){x=f[N+16>>2]|0;if((w|0)!=(x|0)?(gTb(t,(x|0)==0?1124530:x)|0)<=-1:0){O=1;break}x=Gwa(N+24|0,-1)|0;O=x}else O=1}else O=1;while(0);f[l>>2]=O;bD(e);f[e>>2]=0;f[e+4>>2]=0;v=aD(e,8)|0;x=v;b[x>>0]=112;b[x+1>>0]=111;b[x+2>>0]=111;b[x+3>>0]=108;x=v+4|0;b[x>>0]=101;b[x+1>>0]=100;b[x+2>>0]=95;b[x+3>>0]=104;x=f[s>>2]|0;do if(x){v=f[e>>2]|0;A=(v|0)==0?1124530:v;y=s;P=x;h:while(1){Q=P;while(1){R=f[Q+16>>2]|0;if((R|0)==(v|0))break;if((gTb((R|0)==0?1124530:R,A)|0)>=0)break;R=f[Q+4>>2]|0;if(!R){S=y;break h}else Q=R}P=f[Q>>2]|0;if(!P){S=Q;break}else y=Q}if((S|0)!=(s|0)){y=f[S+16>>2]|0;if((v|0)!=(y|0)?(gTb(A,(y|0)==0?1124530:y)|0)<=-1:0){T=1;break}y=Gwa(S+24|0,-1)|0;T=y}else T=1}else T=1;while(0);f[m>>2]=T;bD(e)}while(0);if((z|0)==41){f[h>>2]=0;f[h+4>>2]=0;T=aD(h,4)|0;b[T>>0]=112;b[T+1>>0]=111;b[T+2>>0]=111;b[T+3>>0]=108;f[i>>2]=0;T=i+4|0;f[T>>2]=0;m=aD(i,3)|0;b[m>>0]=b[442370]|0;b[m+1>>0]=b[442371]|0;b[m+2>>0]=b[442372]|0;m=f[s>>2]|0;do if(m){S=f[h>>2]|0;O=(S|0)==0?1124530:S;l=s;N=m;i:while(1){o=N;while(1){M=f[o+16>>2]|0;if((M|0)==(S|0))break;if((gTb((M|0)==0?1124530:M,O)|0)>=0)break;M=f[o+4>>2]|0;if(!M){U=l;break i}else o=M}N=f[o>>2]|0;if(!N){U=o;break}else l=o}if((U|0)!=(s|0)){l=f[U+16>>2]|0;if((S|0)!=(l|0)?(gTb(O,(l|0)==0?1124530:l)|0)<=-1:0){z=52;break}Hwa(j,U+24|0,-1)}else z=52}else z=52;while(0);if((z|0)==52?(U=f[i>>2]|0,f[j>>2]=U,f[j+4>>2]=f[T>>2],U|0):0){T=U+-4|0;f[T>>2]=(f[T>>2]|0)+1}T=f[j>>2]|0;if(!T){f[g>>2]=0;f[g+4>>2]=0}else{U=j+4|0;m=f[U>>2]|0;f[e>>2]=0;l=e+4|0;f[l>>2]=0;if(m|0?(Vac(aD(e,m)|0,T|0,m|0)|0,f[U>>2]|0):0){m=0;do{T=(gVb(b[(f[j>>2]|0)+m>>0]|0)|0)&255;b[(f[e>>2]|0)+m>>0]=T;m=m+1|0}while(m>>>0<(f[U>>2]|0)>>>0)}U=f[e>>2]|0;f[g>>2]=U;f[g+4>>2]=f[l>>2];if(U|0){l=U+-4|0;f[l>>2]=(f[l>>2]|0)+1}bD(e)}bD(j);bD(i);bD(h);i=f[g>>2]|0;do if((i|0)!=442370?(j=(i|0)==0?1124530:i,(gTb(j,442370)|0)!=0):0){if((i|0)!=442374?gTb(j,442374)|0:0){if((i|0)!=442378?gTb(j,442378)|0:0){f[h>>2]=0;j=h+4|0;f[j>>2]=0;l=g+4|0;aD(h,(f[l>>2]|0)+22|0)|0;U=f[h>>2]|0;C=U;D=442389;E=C+22|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));O=f[l>>2]|0;if(O|0)Vac(U+22|0,f[g>>2]|0,O|0)|0;f[e>>2]=0;f[e+4>>2]=0;aD(e,(f[j>>2]|0)+1|0)|0;O=f[j>>2]|0;if(!O)V=0;else{Vac(f[e>>2]|0,f[h>>2]|0,O|0)|0;V=f[j>>2]|0}b[(f[e>>2]|0)+V>>0]=34;bO(-5,e,442412,442429,85);bD(e);bD(h);break}f[a+36>>2]=2;break}f[a+36>>2]=1}else z=64;while(0);if((z|0)==64)f[a+36>>2]=0;Gcb(c,a+44|0,k,p,a+60|0,a+56|0,r,q,a+68|0);bD(g)}Kwa(a,c);f[e>>2]=0;f[e+4>>2]=0;C=aD(e,9)|0;D=442562;E=C+9|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));c=f[s>>2]|0;do if(c){g=f[e>>2]|0;q=(g|0)==0?1124530:g;r=s;p=c;j:while(1){k=p;while(1){z=f[k+16>>2]|0;if((z|0)==(g|0))break;if((gTb((z|0)==0?1124530:z,q)|0)>=0)break;z=f[k+4>>2]|0;if(!z){W=r;break j}else k=z}p=f[k>>2]|0;if(!p){W=k;break}else r=k}if((W|0)!=(s|0)){r=f[W+16>>2]|0;if((g|0)!=(r|0)?(gTb(q,(r|0)==0?1124530:r)|0)<=-1:0){X=1;break}r=Gwa(W+24|0,-1)|0;X=((r|0)!=0|(J|0)!=0)&1}else X=1}else X=1;while(0);b[a+76>>0]=X;bD(e);f[e>>2]=0;f[e+4>>2]=0;C=aD(e,13)|0;D=442572;E=C+13|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));D=f[s>>2]|0;if(!D){Y=1.0;Z=a+88|0;n[Z>>2]=Y;bD(e);u=d;return}C=f[e>>2]|0;E=(C|0)==0?1124530:C;X=s;W=D;k:while(1){D=W;while(1){c=f[D+16>>2]|0;if((c|0)==(C|0))break;if((gTb((c|0)==0?1124530:c,E)|0)>=0)break;c=f[D+4>>2]|0;if(!c){_=X;break k}else D=c}W=f[D>>2]|0;if(!W){_=D;break}else X=D}if((_|0)==(s|0)){Y=1.0;Z=a+88|0;n[Z>>2]=Y;bD(e);u=d;return}s=f[_+16>>2]|0;if((C|0)!=(s|0)?(gTb(E,(s|0)==0?1124530:s)|0)<=-1:0){Y=1.0;Z=a+88|0;n[Z>>2]=Y;bD(e);u=d;return}Y=+Hya(_+24|0,-1);Z=a+88|0;n[Z>>2]=Y;bD(e);u=d;return}function Ykb(a){a=a|0;O5b(a);return}function Zkb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _kb(a){a=a|0;f[a>>2]=126452;bD(a+68|0);lua(a);return}function $kb(a){a=a|0;f[a>>2]=126452;bD(a+68|0);lua(a);O5b(a);return}function alb(a){a=a|0;f[a>>2]=126452;bD(a+68|0);lua(a);O5b(a);return}function blb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=f[c>>2]|0;if((j|0)==(f[c+4>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;k=aD(g,15)|0;l=443708;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,443724,442429,116);bD(g);n=f[c>>2]|0}else n=j;j=f[(f[n>>2]|0)+40>>2]|0;n=f[j+12>>2]|0;c=f[j+8>>2]|0;f[g>>2]=n;f[g+4>>2]=c;j=f[(f[d>>2]|0)+40>>2]|0;d=f[j+8>>2]|0;f[h>>2]=f[j+12>>2];f[h+4>>2]=d;if(b[a+64>>0]|0){f[a+40>>2]=n;f[a+44>>2]=c}f[i>>2]=1;f[i+4>>2]=1;Jcb(g,h,a+40|0,a+48|0,a+68|0,i,a+56|0);u=e;return}function clb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(g,126576);switch(f[a+36>>2]|0){case 0:{if(((f[c+4>>2]|0)-(f[c>>2]|0)|0)!=4){f[h>>2]=0;f[h+4>>2]=0;i=aD(h,18)|0;j=443104;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,h,443123,442429,198);bD(h)}l=f[d>>2]|0;if(((f[d+4>>2]|0)-l|0)==112)m=l;else{f[h>>2]=0;f[h+4>>2]=0;i=aD(h,19)|0;j=443131;k=i+19|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,h,443123,442429,198);bD(h);m=f[d>>2]|0}llb(a,f[f[c>>2]>>2]|0,m,m+56|0);break}case 1:{if(((f[c+4>>2]|0)-(f[c>>2]|0)|0)!=4){f[h>>2]=0;f[h+4>>2]=0;i=aD(h,18)|0;j=443104;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,h,443123,442429,202);bD(h)}m=f[d>>2]|0;if(((f[d+4>>2]|0)-m|0)==56)n=m;else{f[h>>2]=0;f[h+4>>2]=0;i=aD(h,19)|0;j=443151;k=i+19|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,h,443123,442429,202);bD(h);n=f[d>>2]|0}mlb(a,f[f[c>>2]>>2]|0,n);break}case 4:case 3:{if(((f[c+4>>2]|0)-(f[c>>2]|0)|0)!=8){f[h>>2]=0;f[h+4>>2]=0;i=aD(h,18)|0;j=442898;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,h,443123,442429,206);bD(h)}n=f[d>>2]|0;if(((f[d+4>>2]|0)-n|0)==56)o=n;else{f[h>>2]=0;f[h+4>>2]=0;i=aD(h,19)|0;j=443151;k=i+19|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,h,443123,442429,206);bD(h);o=f[d>>2]|0}d=f[c>>2]|0;nlb(a,f[d>>2]|0,f[d+4>>2]|0,o);break}default:{f[h>>2]=0;f[h+4>>2]=0;i=aD(h,15)|0;j=443171;k=i+15|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-213,h,443123,442429,210);bD(h)}}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function dlb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;dQ(g,126544);Lwa(a,b,c,d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function elb(a,b){a=a|0;b=b|0;var c=0;a:do switch(b|0){case 0:{c=1;break}case 1:{if(Owa()|0){switch(f[a+36>>2]|0){case 0:{c=1;break a;break}case 1:break;default:{c=0;break a}}if(!(f[a+56>>2]|0))c=(f[a+60>>2]|0)==0;else c=0}else c=0;break}default:c=0}while(0);return c|0}function flb(a,b,c){a=a|0;b=b|0;c=c|0;switch(f[b+36>>2]|0){case 0:{_h[f[(f[b>>2]|0)+92>>2]&255](a,b,c);return}case 1:{_h[f[(f[b>>2]|0)+96>>2]&255](a,b,c);return}default:{f[a>>2]=0;f[a+4>>2]=0;return}}}function glb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return}function hlb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;g=u;u=u+48|0;d=g+40|0;h=g+32|0;i=g+16|0;j=g;k=c+4|0;l=f[c>>2]|0;if((f[k>>2]|0)==(l|0)){f[d>>2]=0;f[d+4>>2]=0;m=aD(d,18)|0;n=442751;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,d,442770,442429,764);bD(d);p=c;q=f[c>>2]|0}else{p=c;q=l}l=f[q>>2]|0;q=f[l+12>>2]|0;c=f[l+8>>2]|0;f[d>>2]=q;f[d+4>>2]=c;f[h>>2]=0;l=h+4|0;f[l>>2]=0;do if(!(b[a+64>>0]|0)){r=a+36|0;if(((f[r>>2]|0)+-3|0)>>>0<2){f[l>>2]=f[a+84>>2];f[h>>2]=f[a+80>>2];s=r;break}if(f[a+72>>2]|0){f[i>>2]=1;f[i+4>>2]=1;Icb(d,a+40|0,a+48|0,a+68|0,i,h);s=r;break}t=f[a+60>>2]|0;v=f[a+52>>2]|0;w=+((t<<1)+c-(f[a+44>>2]|0)|0)/+(v|0);x=a+56|0;y=f[x>>2]|0;z=a+48|0;A=f[z>>2]|0;B=+((y<<1)+q-(f[a+40>>2]|0)|0)/+(A|0);if(!(b[a+76>>0]|0)){C=~~(+K(+w)+1.0);f[l>>2]=C;D=+K(+B);E=C}else{C=~~(+X(+w)+1.0);f[l>>2]=C;D=+X(+B);E=C}C=~~(D+1.0);f[h>>2]=C;if(t|y){F=E+-1|0;G=c+t|0;if((Y(F,v)|0)<(G|0))H=E;else{f[l>>2]=F;H=F}F=C+-1|0;if((Y(F,A)|0)<(y+q|0))I=C;else{f[h>>2]=F;I=F}if((Y(H+-1|0,v)|0)<(G|0)){J=I;L=A;M=q;N=y}else{f[i>>2]=0;f[i+4>>2]=0;m=aD(i,57)|0;n=442786;o=m+57|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,442770,442429,792);bD(i);J=f[h>>2]|0;L=f[z>>2]|0;M=f[d>>2]|0;N=f[x>>2]|0}if((Y(J+-1|0,L)|0)>=(N+M|0)){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,53)|0;n=442844;o=m+53|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,442770,442429,793);bD(i);s=r}else s=r}else s=r}else{f[l>>2]=1;f[h>>2]=1;s=a+36|0}while(0);M=f[p>>2]|0;N=f[M>>2]|0;f[i>>2]=f[N>>2];f[i+4>>2]=f[N+4>>2];f[i+8>>2]=f[l>>2];f[i+12>>2]=f[h>>2];h=f[s>>2]|0;l=M;switch(h|0){case 3:{if(((f[k>>2]|0)-l|0)==24)O=M;else{f[j>>2]=0;f[j+4>>2]=0;m=aD(j,18)|0;n=442898;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,j,442770,442429,804);bD(j);O=f[p>>2]|0}P=0;Q=f[O+12>>2]|0;R=31;break}case 4:{if(((f[k>>2]|0)-l|0)==24){S=N;T=M}else{f[j>>2]=0;f[j+4>>2]=0;m=aD(j,18)|0;n=442898;o=m+18|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,j,442770,442429,809);bD(j);M=f[p>>2]|0;S=f[M>>2]|0;T=M}M=a+92|0;if((Y(Y(f[a+80>>2]|0,f[M>>2]|0)|0,f[a+84>>2]|0)|0)==(f[S+4>>2]|0))U=T;else{f[j>>2]=0;f[j+4>>2]=0;m=aD(j,71)|0;n=442917;o=m+71|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,j,442770,442429,810);bD(j);U=f[p>>2]|0}f[i>>2]=f[f[U+12>>2]>>2];P=1;Q=M;R=31;break}default:V=h}if((R|0)==31){f[i+(P<<2)>>2]=f[Q>>2];V=f[s>>2]|0}f[j>>2]=0;s=j+4|0;f[s>>2]=0;f[j+8>>2]=0;Rva(j,i,i+16|0);Aua(e,(V|0)==0?2:1,j);V=f[j>>2]|0;if(!V){u=g;return 0}j=f[s>>2]|0;if((j|0)!=(V|0))f[s>>2]=j+(~((j+-4-V|0)>>>2)<<2);O5b(V);u=g;return 0}function ilb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;c=u;u=u+16|0;e=c;g=d+4|0;h=f[d>>2]|0;if((f[g>>2]|0)==(h|0)){i=0;j=(i|0)<0;k=j<<31>>31;J=k;u=c;return i|0}l=a+36|0;m=a+40|0;n=a+44|0;a=e+4|0;o=e+4|0;p=0;q=0;r=h;while(1){h=r;if(!(f[l>>2]|0))if(!(q&1)){s=f[h+(q*12|0)+4>>2]|0;t=f[h+(q*12|0)>>2]|0;v=s-t|0;w=v>>2;x=t;do if((x|0)!=(s|0)){if((v|0)<=-4){f[e>>2]=0;f[a>>2]=0;y=aD(e,70)|0;z=442586;A=y+70|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,e,442657,442663,160);bD(e);B=1;break}if((v|0)>0){t=0;C=1;while(1){D=Y(f[x+(t<<2)>>2]|0,C)|0;t=t+1|0;if((t|0)>=(w|0)){B=D;break}else C=D}}else B=1}else B=0;while(0);E=(Y(Y(f[m>>2]|0,B)|0,f[n>>2]|0)|0)+p|0}else E=p;else{w=f[h+(q*12|0)+4>>2]|0;x=f[h+(q*12|0)>>2]|0;v=w-x|0;s=v>>2;C=x;do if((C|0)!=(w|0)){if((v|0)<=-4){f[e>>2]=0;f[o>>2]=0;y=aD(e,70)|0;z=442586;A=y+70|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,e,442657,442663,160);bD(e);F=1;break}if((v|0)>0){x=0;t=1;while(1){D=Y(f[C+(x<<2)>>2]|0,t)|0;x=x+1|0;if((x|0)>=(s|0)){F=D;break}else t=D}}else F=1}else F=0;while(0);E=(Y((Y(f[n>>2]|0,f[m>>2]|0)|0)+1|0,F)|0)+p|0}q=q+1|0;r=f[d>>2]|0;if(q>>>0>=(((f[g>>2]|0)-r|0)/12|0)>>>0){i=E;break}else p=E}j=(i|0)<0;k=j<<31>>31;J=k;u=c;return i|0}function jlb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function klb(a,b,c){a=a|0;b=b|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;return}function llb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;g=u;u=u+80|0;h=g+24|0;i=g+16|0;j=g+8|0;k=g;l=SQ()|0;f[h>>2]=1124007936;m=h+4|0;o=h+8|0;p=h+40|0;q=m;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=o;o=h+48|0;q=h+44|0;f[q>>2]=o;f[o>>2]=0;f[h+52>>2]=0;f[i>>2]=f[a+40>>2];f[i+4>>2]=f[a+44>>2];f[j>>2]=f[a+48>>2];f[j+4>>2]=f[a+52>>2];f[k>>2]=f[a+56>>2];f[k+4>>2]=f[a+60>>2];olb(c,h,d,e,i,j,k,f[a+36>>2]|0,+n[a+88>>2],(b[a+65>>0]|0)!=0,l);l=h+36|0;a=f[l>>2]|0;if(a|0?(k=a+12|0,a=f[k>>2]|0,f[k>>2]=a+-1,(a|0)==1):0)kL(h);f[l>>2]=0;l=h+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[p>>2]|0;p=0;do{f[l+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[m>>2]|0))}m=f[q>>2]|0;if((m|0)==(o|0)){u=g;return}UC(m);u=g;return}function mlb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+144|0;g=e+80|0;h=e+24|0;i=e+16|0;j=e+8|0;k=e;l=SQ()|0;f[g>>2]=1124007936;m=g+4|0;o=g+8|0;p=g+40|0;q=m;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=o;o=g+48|0;s=g+44|0;f[s>>2]=o;f[o>>2]=0;f[g+52>>2]=0;f[h>>2]=1124007936;t=h+4|0;v=h+8|0;w=h+40|0;q=t;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[w>>2]=v;v=h+48|0;q=h+44|0;f[q>>2]=v;f[v>>2]=0;f[h+52>>2]=0;f[i>>2]=f[a+40>>2];f[i+4>>2]=f[a+44>>2];f[j>>2]=f[a+48>>2];f[j+4>>2]=f[a+52>>2];f[k>>2]=f[a+56>>2];f[k+4>>2]=f[a+60>>2];olb(c,g,d,h,i,j,k,f[a+36>>2]|0,+n[a+88>>2],(b[a+65>>0]|0)!=0,l);l=h+36|0;a=f[l>>2]|0;if(a|0?(k=a+12|0,a=f[k>>2]|0,f[k>>2]=a+-1,(a|0)==1):0)kL(h);f[l>>2]=0;l=h+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[t>>2]|0)>0){l=f[w>>2]|0;w=0;do{f[l+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[t>>2]|0))}t=f[q>>2]|0;if((t|0)!=(v|0))UC(t);t=g+36|0;v=f[t>>2]|0;if(v|0?(q=v+12|0,v=f[q>>2]|0,f[q>>2]=v+-1,(v|0)==1):0)kL(g);f[t>>2]=0;t=g+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[m>>2]|0)>0){t=f[p>>2]|0;p=0;do{f[t+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[m>>2]|0))}m=f[s>>2]|0;if((m|0)==(o|0)){u=e;return}UC(m);u=e;return}function nlb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;g=u;u=u+80|0;h=g+24|0;i=g+16|0;j=g+8|0;k=g;l=SQ()|0;f[h>>2]=1124007936;m=h+4|0;o=h+8|0;p=h+40|0;q=m;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[p>>2]=o;o=h+48|0;q=h+44|0;f[q>>2]=o;f[o>>2]=0;f[h+52>>2]=0;f[i>>2]=f[a+40>>2];f[i+4>>2]=f[a+44>>2];f[j>>2]=f[a+48>>2];f[j+4>>2]=f[a+52>>2];f[k>>2]=f[a+56>>2];f[k+4>>2]=f[a+60>>2];olb(c,d,e,h,i,j,k,f[a+36>>2]|0,+n[a+88>>2],(b[a+65>>0]|0)!=0,l);l=h+36|0;a=f[l>>2]|0;if(a|0?(k=a+12|0,a=f[k>>2]|0,f[k>>2]=a+-1,(a|0)==1):0)kL(h);f[l>>2]=0;l=h+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[p>>2]|0;p=0;do{f[l+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[m>>2]|0))}m=f[q>>2]|0;if((m|0)==(o|0)){u=g;return}UC(m);u=g;return}function olb(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;o=u;u=u+80|0;p=o+8|0;q=o;r=l&1;if(!(f[a>>2]&16384)){f[p>>2]=0;f[p+4>>2]=0;s=aD(p,18)|0;t=443187;v=s+18|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,p,443206,442429,249);bD(p)}if(!(f[d>>2]&16384)){f[p>>2]=0;f[p+4>>2]=0;s=aD(p,18)|0;t=443210;v=s+18|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,p,443206,442429,249);bD(p)}w=f[a>>2]|0;if((w&4095|0)==5)x=w;else{f[p>>2]=0;f[p+4>>2]=0;s=aD(p,15)|0;t=443229;v=s+15|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,p,443206,442429,249);bD(p);x=f[a>>2]|0}if((f[d>>2]^x)&4095|0){f[p>>2]=0;f[p+4>>2]=0;s=aD(p,24)|0;t=443245;v=s+24|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,p,443206,442429,249);bD(p)}if((f[a+4>>2]|0)!=4){f[p>>2]=0;f[p+4>>2]=0;s=aD(p,13)|0;t=443270;v=s+13|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,p,443206,442429,249);bD(p)}if((f[d+4>>2]|0)!=4){f[p>>2]=0;f[p+4>>2]=0;s=aD(p,13)|0;t=443284;v=s+13|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,p,443206,442429,249);bD(p)}x=(j|0)==4;w=f[f[d+40>>2]>>2]|0;if(!((j+-3|0)>>>0<2?(w|0)==(f[f[c+40>>2]>>2]|0):0))y=15;if((y|0)==15?(f[f[a+40>>2]>>2]|0)!=(w|0):0){f[p>>2]=0;f[p+4>>2]=0;s=aD(p,106)|0;t=443298;v=s+106|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,p,443206,442429,249);bD(p)}if(!x?(f[(f[a+40>>2]|0)+4>>2]|0)!=(f[(f[d+40>>2]|0)+4>>2]|0):0){f[p>>2]=0;f[p+4>>2]=0;s=aD(p,50)|0;t=443405;v=s+50|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,p,443206,442429,249);bD(p)}a:do if(f[e+16>>2]|0){x=f[e+4>>2]|0;if((x|0)<3)z=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{w=f[e+40>>2]|0;y=0;A=1;while(1){B=Y(f[w+(y<<2)>>2]|0,A)|0;y=y+1|0;if((y|0)==(x|0)){z=B;break}else A=B}}if(!((x|0)==0|(z|0)==0)){b:do if(((f[a>>2]^f[e>>2])&4095|0)==0?(A=f[e+40>>2]|0,y=f[A+-4>>2]|0,w=f[d+40>>2]|0,(y|0)==(f[w+-4>>2]|0)):0){if((y|0)==2){if((f[A>>2]|0)!=(f[w>>2]|0))break;if((f[A+4>>2]|0)==(f[w+4>>2]|0))break a;else break}if((y|0)>0)C=0;else break a;while(1){if((f[A+(C<<2)>>2]|0)!=(f[w+(C<<2)>>2]|0))break b;C=C+1|0;if((C|0)>=(y|0))break a}}while(0);f[p>>2]=0;f[p+4>>2]=0;s=aD(p,70)|0;t=443456;v=s+70|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,p,443206,442429,249);bD(p)}}while(0);f[p>>2]=126616;t=p+52|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;e=f[g>>2]|0;f[p+20>>2]=e;d=g+4|0;c=f[d>>2]|0;f[p+24>>2]=c;f[p+28>>2]=f[h>>2];f[p+32>>2]=f[h+4>>2];f[p+36>>2]=f[i>>2];f[p+40>>2]=f[i+4>>2];f[p+44>>2]=m;b[p+48>>0]=r;f[p+64>>2]=j;n[p+68>>2]=k;if(!l){l=p+52|0;j=Y(c,e)|0;if(!j)D=c;else{HC(l,j);D=f[d>>2]|0}if((D|0)>0){j=(f[a+40>>2]|0)+12|0;a=f[l>>2]|0;l=0;c=f[g>>2]|0;e=D;while(1){if((c|0)>0){D=0;r=c;do{i=(Y(f[j>>2]|0,l)|0)+D|0;h=a+((Y(r,l)|0)+D<<2)|0;f[h>>2]=i;D=D+1|0;r=f[g>>2]|0}while((D|0)<(r|0));E=f[d>>2]|0;F=r}else{E=e;F=c}l=l+1|0;if((l|0)>=(E|0))break;else{c=F;e=E}}}}f[q>>2]=0;f[q+4>>2]=m;RQ(q,p,+(m|0));f[p>>2]=126616;m=f[t>>2]|0;if(!m){u=o;return}t=p+56|0;p=f[t>>2]|0;if((p|0)!=(m|0))f[t>>2]=p+(~((p+-4-m|0)>>>2)<<2);O5b(m);u=o;return}function plb(a){a=a|0;var b=0,c=0;f[a>>2]=126616;b=f[a+52>>2]|0;if(!b)return;c=a+56|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);O5b(b);return}function qlb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=126616;b=f[a+52>>2]|0;if(!b){O5b(a);return}c=a+56|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);O5b(a);return}function rlb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0.0,G=0,H=0,I=0,J=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0;d=u;u=u+16|0;e=d;g=a+12|0;h=f[g>>2]|0;i=f[h+40>>2]|0;j=f[i+4>>2]|0;k=f[i+12>>2]|0;l=f[i+8>>2]|0;m=a+4|0;o=f[(f[m>>2]|0)+40>>2]|0;p=f[o+12>>2]|0;q=f[o+8>>2]|0;o=f[h+4>>2]|0;if((o|0)<3)r=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{h=0;t=1;while(1){v=Y(f[i+(h<<2)>>2]|0,t)|0;h=h+1|0;if((h|0)==(o|0)){r=v;break}else t=v}}t=f[a+44>>2]|0;o=((r+-1+t|0)>>>0)/(t>>>0)|0;t=Y(f[c>>2]|0,o)|0;h=Y(f[c+4>>2]|0,o)|0;o=r>>>0<h>>>0?r:h;h=f[a+20>>2]|0;r=f[a+24>>2]|0;c=f[a+36>>2]|0;i=f[a+40>>2]|0;v=f[a+28>>2]|0;w=f[a+32>>2]|0;x=(b[a+48>>0]|0)!=0;if(o>>>0<=t>>>0){u=d;return}y=a+64|0;z=i+q|0;A=a+16|0;B=a+8|0;C=a+68|0;D=+(k|0);a=e+4|0;E=c+p|0;F=+(l|0);G=e+4|0;H=t;do{t=(H>>>0)%(k>>>0)|0;I=(H>>>0)/(k>>>0)|0;J=(I>>>0)%(l>>>0)|0;L=(I>>>0)/(l>>>0)|0;I=(L>>>0)%(j>>>0)|0;M=(L>>>0)/(j>>>0)|0;switch(f[y>>2]|0){case 3:{L=f[B>>2]|0;N=(f[L+16>>2]|0)+(Y(f[f[L+44>>2]>>2]|0,M)|0)|0;O=+n[C>>2];P=+n[N+8>>2]*O;L=~~(P+(P>=0.0?.5:-.5));P=O*+n[N+16>>2];Q=~~(P+(P>=0.0?.5:-.5))-L+1|0;P=+(((Q|0)>1?Q:1)|0)/F;O=+(L|0);L=~~(O+ +(J|0)*P);Q=~~(+X(+(+(J+1|0)*P))+O);O=+n[N>>2];R=f[m>>2]|0;if(O<+(f[f[R+40>>2]>>2]|0)){S=O;T=R}else{f[e>>2]=0;f[G>>2]=0;U=aD(e,26)|0;V=443527;W=U+26|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));bO(-215,e,489445,442429,319);bD(e);S=+n[N>>2];T=f[m>>2]|0}R=f[T+44>>2]|0;Z=(f[T+16>>2]|0)+(Y(f[R>>2]|0,~~S)|0)+(Y(f[R+4>>2]|0,I)|0)|0;_=L;$=Q;break}case 4:{R=f[B>>2]|0;aa=(f[R+16>>2]|0)+(Y(f[f[R+44>>2]>>2]|0,M)|0)|0;O=+n[aa+8>>2];P=+n[C>>2];ba=P*+(~~(O+(O>=0.0?.5:-.5))|0);O=+n[aa+16>>2]+1.0;ca=P*+(~~(O+(O>=0.0?.5:-.5))|0)-ba;O=(ca<.10000000149011612?.10000000149011612:ca)/F;Z=0;_=~~+K(+(ba+ +(J|0)*O));$=~~+X(+(ba+ +(J+1|0)*O));break}default:{aa=(Y(J,w)|0)-i|0;R=aa+r|0;da=f[m>>2]|0;ea=f[da+44>>2]|0;Z=(f[da+16>>2]|0)+(Y(f[ea>>2]|0,M)|0)+(Y(f[ea+4>>2]|0,I)|0)|0;_=aa;$=(z|0)<(R|0)?z:R}}R=$-_|0;aa=(_|0)>0?_:0;ea=(q|0)<($|0)?q:$;da=f[g>>2]|0;fa=f[da+16>>2]|0;ga=f[da+44>>2]|0;da=Y(f[ga>>2]|0,M)|0;ha=Y(f[ga+4>>2]|0,I)|0;ia=Y(f[ga+8>>2]|0,J)|0;ga=fa+da+ha+ia|0;ja=f[A>>2]|0;ka=f[ja+16>>2]|0;if(!ka)la=0;else{ma=f[ja+44>>2]|0;ja=ka+(Y(f[ma>>2]|0,M)|0)|0;ka=ja+(Y(f[ma+4>>2]|0,I)|0)|0;la=ka+(Y(f[ma+8>>2]|0,J)|0)|0}ma=o-H|0;ka=k-t|0;ja=(ka|0)<(ma|0)?ka:ma;H=ja+H|0;ma=ja+t|0;ka=f[y>>2]|0;a:do switch(ka|0){case 0:{if((ja|0)>0){na=(ea|0)>(aa|0);oa=(la|0)==0;pa=x&(la|0)!=0;qa=t;do{ra=(Y(qa,v)|0)-c|0;sa=ra+h|0;ta=(p|0)<(sa|0)?p:sa;sa=(ra|0)>0?ra:0;do if(na&(sa|0)<(ta|0)){if(x){ua=-1;va=aa;wa=-3402823466385288598117041.0e14}else{ra=aa;O=-3402823466385288598117041.0e14;xa=-8388609;while(1){ya=Y(ra,p)|0;za=sa;ba=O;Aa=xa;do{Ba=f[Z+(za+ya<<2)>>2]|0;Aa=ba<(f[s>>2]=Ba,+n[s>>2])?Ba:Aa;za=za+1|0;ba=(f[s>>2]=Aa,+n[s>>2])}while((za|0)<(ta|0));ra=ra+1|0;if((ra|0)>=(ea|0))break;else{O=ba;xa=Aa}}f[ga+(qa<<2)>>2]=Aa;break}while(1){xa=Y(va,p)|0;ra=sa;Ca=ua;Da=wa;do{za=ra+xa|0;O=+n[Z+(za<<2)>>2];ya=O>Da;Da=ya?O:Da;Ca=ya?za:Ca;ra=ra+1|0}while((ra|0)<(ta|0));va=va+1|0;if((va|0)>=(ea|0))break;else{ua=Ca;wa=Da}}n[ga+(qa<<2)>>2]=Da;if(!oa)n[la+(qa<<2)>>2]=+(Ca|0)}else{n[ga+(qa<<2)>>2]=0.0;if(pa)n[la+(qa<<2)>>2]=-1.0}while(0);qa=qa+1|0}while((qa|0)<(ma|0))}break}case 1:{if((ja|0)>0){if((ea|0)>(aa|0))Ea=t;else{qa=t;while(1){pa=(Y(qa,v)|0)-c|0;oa=pa+h|0;ba=1.0/+(Y(((E|0)<(oa|0)?E:oa)-pa|0,R)|0)*0.0;n[ga+(qa<<2)>>2]=ba;qa=qa+1|0;if((qa|0)>=(ma|0))break a}}do{qa=(Y(Ea,v)|0)-c|0;pa=qa+h|0;oa=(E|0)<(pa|0)?E:pa;pa=(qa|0)>0?qa:0;na=(p|0)<(oa|0)?p:oa;ba=1.0/+(Y(oa-qa|0,R)|0);if((pa|0)<(na|0)){O=0.0;qa=aa;while(1){oa=Y(qa,p)|0;ta=pa;ca=O;do{ca=ca+ +n[Z+(ta+oa<<2)>>2];ta=ta+1|0}while((ta|0)<(na|0));qa=qa+1|0;if((qa|0)>=(ea|0)){Fa=ca;break}else O=ca}}else Fa=0.0;n[ga+(Ea<<2)>>2]=ba*Fa;Ea=Ea+1|0}while((Ea|0)<(ma|0))}break}default:{qa=f[B>>2]|0;na=(f[qa+16>>2]|0)+(Y(f[f[qa+44>>2]>>2]|0,M)|0)|0;if((ka|0)!=3){if(!(+n[na>>2]<+(f[f[(f[m>>2]|0)+40>>2]>>2]|0))){f[e>>2]=0;f[a>>2]=0;U=aD(e,26)|0;V=443527;W=U+26|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));bO(-215,e,489445,442429,585);bD(e)}O=+n[na+4>>2];P=+n[C>>2];Ga=P*+(~~(O+(O>=0.0?.5:-.5))|0);O=+n[na+12>>2]+1.0;Ha=P*+(~~(O+(O>=0.0?.5:-.5))|0)-Ga;O=(Ha<.10000000149011612?.10000000149011612:Ha)/D;if((ja|0)<=0)break a;qa=Y((Y(I,l)|0)+J|0,k)|0;pa=ea-aa|0;if((ea|0)>(aa|0))Ia=t;else{ta=t<<2;oa=t+1|0;Nac(fa+(ia+ha+da+ta)|0,0,(((ma|0)>(oa|0)?ma:oa)<<2)-ta|0)|0;break a}while(1){ta=~~+K(+(Ga+O*+(Ia|0)));oa=Ia;Ia=Ia+1|0;sa=~~+X(+(Ga+O*+(Ia|0)));ra=(ta|0)>0?ta:0;ta=(p|0)<(sa|0)?p:sa;if((ta|0)>(ra|0)){sa=f[m>>2]|0;xa=f[sa+44>>2]|0;za=(f[sa+16>>2]|0)+(Y(f[xa>>2]|0,~~+n[na>>2])|0)|0;sa=za+(Y(f[xa+4>>2]|0,oa+qa|0)|0)|0;xa=aa;Ha=0.0;while(1){za=Y(xa,p)|0;ya=ra;Ja=Ha;do{Ja=Ja+ +n[sa+(ya+za<<2)>>2];ya=ya+1|0}while((ya|0)<(ta|0));xa=xa+1|0;if((xa|0)>=(ea|0))break;else Ha=Ja}Ka=Ja/+(Y(ta-ra|0,pa)|0)}else Ka=0.0;n[ga+(oa<<2)>>2]=Ka;if((Ia|0)>=(ma|0))break a}}O=+n[C>>2];Ga=+n[na+4>>2]*O;pa=~~(Ga+(Ga>=0.0?.5:-.5));Ga=O*+n[na+12>>2];qa=~~(Ga+(Ga>=0.0?.5:-.5))-pa+1|0;Ga=+(((qa|0)>1?qa:1)|0)/D;if((ja|0)>0){O=+(pa|0);pa=x&(la|0)!=0;if((ea|0)>(aa|0))La=t;else{qa=t;while(1){n[ga+(qa<<2)>>2]=0.0;if(pa)n[la+(qa<<2)>>2]=-1.0;qa=qa+1|0;if((qa|0)>=(ma|0))break a}}do{qa=~~(O+Ga*+(La|0));na=La;La=La+1|0;xa=~~(O+ +X(+(Ga*+(La|0))));sa=(qa|0)>0?qa:0;qa=(p|0)<(xa|0)?p:xa;if((sa|0)>=(qa|0)){n[ga+(na<<2)>>2]=0.0;if(pa)n[la+(na<<2)>>2]=-1.0}else{xa=aa;Ha=-3402823466385288598117041.0e14;ya=-8388609;while(1){za=Y(xa,p)|0;Ba=sa;ba=Ha;Ma=ya;do{Na=f[Z+(Ba+za<<2)>>2]|0;Ma=ba<(f[s>>2]=Na,+n[s>>2])?Na:Ma;Ba=Ba+1|0;ba=(f[s>>2]=Ma,+n[s>>2])}while((Ba|0)<(qa|0));xa=xa+1|0;if((xa|0)>=(ea|0))break;else{Ha=ba;ya=Ma}}f[ga+(na<<2)>>2]=Ma}}while((La|0)<(ma|0))}}}while(0)}while(o>>>0>H>>>0);u=d;return}function slb(a,b,c){a=a|0;b=b|0;c=c|0;return li[f[(f[a>>2]|0)+4>>2]&511](a,b,c)|0}function tlb(a,b,c){a=a|0;b=b|0;c=c|0;return li[f[(f[a>>2]|0)+8>>2]&511](a,b,c)|0}function ulb(a,b,c){a=a|0;b=b|0;c=c|0;return li[f[(f[a>>2]|0)+12>>2]&511](a,b,c)|0}function vlb(a,b,c){a=a|0;b=b|0;c=c|0;return li[f[(f[a>>2]|0)+16>>2]&511](a,b,c)|0}function wlb(a,b,c){a=a|0;b=b|0;c=c|0;return li[f[(f[a>>2]|0)+20>>2]&511](a,b,c)|0}function xlb(a,b,c){a=a|0;b=b|0;c=c|0;return li[f[(f[a>>2]|0)+24>>2]&511](a,b,c)|0}function ylb(a,b,c){a=a|0;b=b|0;c=c|0;return li[f[(f[a>>2]|0)+28>>2]&511](a,b,c)|0}function zlb(a,b){a=a|0;b=b|0;zh[f[(f[a>>2]|0)+36>>2]&2047](a,b);return}function Alb(a){a=a|0;return di[f[(f[a>>2]|0)+44>>2]&1023](a)|0}function Blb(a){a=a|0;bi[f[(f[a>>2]|0)+52>>2]&2047](a);return}function Clb(a){a=a|0;return di[f[f[a>>2]>>2]&1023](a)|0}function Dlb(a){a=a|0;f[a+16>>2]=1;return}function Elb(a){a=a|0;f[a+16>>2]=0;return}function Flb(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;li[f[(f[a>>2]|0)+16>>2]&511](a,c,1)|0;u=b;return f[c>>2]|0}function Glb(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;li[f[(f[a>>2]|0)+20>>2]&511](a,c,1)|0;a=c;J=f[a+4>>2]|0;u=b;return f[a>>2]|0}function Hlb(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;li[f[(f[a>>2]|0)+28>>2]&511](a,c,1)|0;u=b;return +(+p[c>>3])}function Ilb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e+16|0;h=e;i=e+24|0;switch(kUb(c)|0){case 1:{switch(b[c>>0]|0){case 114:{j=0;k=1;l=32;break}case 119:{m=1;n=0;o=6;break}default:o=5}break}case 2:{if((b[c>>0]|0)==114?(b[c+1>>0]|0)==119:0){m=1;n=1;o=6}else o=5;break}default:o=5}if((o|0)==5){f[i>>2]=0;f[i+4>>2]=0;p=aD(i,47)|0;q=443859;r=p+47|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,i,443907,443782,480);bD(i);m=0;n=0;o=6}if((o|0)==6){f[i>>2]=0;f[i+4>>2]=0;p=aD(i,25)|0;q=443922;r=p+25|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,i,443907,443782,482);bD(i);j=m;k=n;l=m|0?119:32}m=a+11|0;n=YUb((b[m>>0]|0)<0?f[a>>2]|0:a,443948)|0;do if(!n)if(!d){f[h>>2]=(b[m>>0]|0)<0?f[a>>2]|0:a;f[h+4>>2]=k|0?114:32;f[h+8>>2]=l;hO(i,443951,h);bO(-2,i,443907,443782,496);bD(i);break}else{s=0;u=e;return s|0}while(0);h=OSb(40)|0;if(!h){hO(i,443981,g);bO(-2,i,443907,443782,501);bD(i)}f[h+28>>2]=n;f[h+32>>2]=1;f[h+36>>2]=0;f[h>>2]=126628;f[h+4>>2]=d;f[h+8>>2]=k;f[h+12>>2]=j;f[h+16>>2]=0;f[h+20>>2]=1;f[h+24>>2]=0;s=h;u=e;return s|0}function Jlb(a){a=a|0;return (f[a+28>>2]|0)!=0|0}function Klb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=e+8|0;i=a+28|0;if(!(f[i>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,20)|0;k=443761;l=j+20|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,444632,443782,266);bD(h)}if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,23)|0;k=444234;l=j+23|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,444632,443782,266);bD(h)}a:do if(!(f[a+16>>2]|0))if((d|0)>0){k=oUb(c,1,d,f[i>>2]|0)|0;if(!(f[a+20>>2]|0))m=k;else{j=lTb(f[i>>2]|0)|0;switch(j|0){case 10:case -1:{m=k;break a;break}default:{}}NUb(j,f[i>>2]|0)|0;m=k}}else m=0;else m=oUb(c,1,d,f[i>>2]|0)|0;while(0);if((m|0)==(d|0)){u=e;return m|0}f[a+24>>2]=1;if(f[a+4>>2]|0){u=e;return m|0}f[g>>2]=m;f[g+4>>2]=d;hO(h,444450,g);bO(-2,h,444632,443782,266);bD(h);u=e;return m|0}function Llb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=e+8|0;i=a+28|0;if(!(f[i>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,20)|0;k=443761;l=j+20|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,444612,443782,270);bD(h)}if(!(f[a+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,23)|0;k=444234;l=j+23|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,444612,443782,270);bD(h)}a:do if(!(f[a+16>>2]|0))if((d|0)>0){k=oUb(c,1,d,f[i>>2]|0)|0;if(!(f[a+20>>2]|0))m=k;else{j=lTb(f[i>>2]|0)|0;switch(j|0){case 10:case -1:{m=k;break a;break}default:{}}NUb(j,f[i>>2]|0)|0;m=k}}else m=0;else m=oUb(c,1,d,f[i>>2]|0)|0;while(0);if((m|0)==(d|0)){u=e;return m|0}f[a+24>>2]=1;if(f[a+4>>2]|0){u=e;return m|0}f[g>>2]=m;f[g+4>>2]=d;hO(h,444450,g);bO(-2,h,444612,443782,270);bD(h);u=e;return m|0}function Mlb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e+8|0;h=e;i=e+16|0;j=a+28|0;if(!(f[j>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,20)|0;l=443761;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,444587,443782,274);bD(i)}if(!(f[a+8>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,23)|0;l=444234;m=k+23|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,444587,443782,274);bD(i)}a:do if(!(f[a+16>>2]|0)){l=(d|0)>0;if(l){k=0;m=0;do{n=f[j>>2]|0;f[h>>2]=c+(k<<1);o=(OTb(n,444608,h)|0)>0;m=(o&1)+m|0;k=k+1|0}while(o&(k|0)<(d|0));if(l&(f[a+20>>2]|0)!=0){k=lTb(f[j>>2]|0)|0;switch(k|0){case 10:case -1:{p=m;break a;break}default:{}}NUb(k,f[j>>2]|0)|0;p=m}else p=m}else p=0}else{k=oUb(c,2,d,f[j>>2]|0)|0;if((k|0)>0&(f[a+32>>2]|0)==0){o=0;n=c;while(1){q=b[n>>0]|0;r=n+1|0;b[n>>0]=b[r>>0]|0;b[r>>0]=q;o=o+1|0;if((o|0)==(k|0)){p=k;break}else n=n+2|0}}else p=k}while(0);if((p|0)==(d|0)){u=e;return p|0}f[a+24>>2]=1;if(f[a+4>>2]|0){u=e;return p|0}f[g>>2]=p;f[g+4>>2]=d;hO(i,444450,g);bO(-2,i,444587,443782,274);bD(i);u=e;return p|0}function Nlb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e+8|0;h=e;i=e+16|0;j=a+28|0;if(!(f[j>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,20)|0;l=443761;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,444563,443782,278);bD(i)}if(!(f[a+8>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,23)|0;l=444234;m=k+23|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,444563,443782,278);bD(i)}a:do if(!(f[a+16>>2]|0)){l=(d|0)>0;if(l){k=0;m=0;do{n=f[j>>2]|0;f[h>>2]=c+(k<<2);o=(OTb(n,444582,h)|0)>0;m=(o&1)+m|0;k=k+1|0}while(o&(k|0)<(d|0));if(l&(f[a+20>>2]|0)!=0){k=lTb(f[j>>2]|0)|0;switch(k|0){case 10:case -1:{p=m;break a;break}default:{}}NUb(k,f[j>>2]|0)|0;p=m}else p=m}else p=0}else{k=oUb(c,4,d,f[j>>2]|0)|0;if((k|0)>0&(f[a+32>>2]|0)==0){o=0;n=c;while(1){q=b[n>>0]|0;r=n+3|0;b[n>>0]=b[r>>0]|0;b[r>>0]=q;q=n+1|0;r=b[q>>0]|0;s=n+2|0;b[q>>0]=b[s>>0]|0;b[s>>0]=r;o=o+1|0;if((o|0)==(k|0)){p=k;break}else n=n+4|0}}else p=k}while(0);if((p|0)==(d|0)){u=e;return p|0}f[a+24>>2]=1;if(f[a+4>>2]|0){u=e;return p|0}f[g>>2]=p;f[g+4>>2]=d;hO(i,444450,g);bO(-2,i,444563,443782,278);bD(i);u=e;return p|0}function Olb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+32|0;g=e+16|0;h=e+8|0;i=e;j=e+24|0;k=a+28|0;if(!(f[k>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;l=aD(j,20)|0;m=443761;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,j,444515,443782,299);bD(j)}if(!(f[a+8>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;l=aD(j,23)|0;m=444234;n=l+23|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,j,444515,443782,300);bD(j)}a:do if(!(f[a+16>>2]|0)){m=(d|0)>0;if(m){l=0;while(1){n=f[k>>2]|0;f[h>>2]=j;if((OTb(n,444559,h)|0)<1){o=24;break}n=l+1|0;p=f[j>>2]|0;q=c+(l<<3)|0;f[q>>2]=p;f[q+4>>2]=((p|0)<0)<<31>>31;if((n|0)<(d|0))l=n;else{r=n;break}}if((o|0)==24)r=l;if(m&(f[a+20>>2]|0)!=0){n=lTb(f[k>>2]|0)|0;switch(n|0){case 10:case -1:{s=r;break a;break}default:{}}NUb(n,f[k>>2]|0)|0;s=r}else s=r}else s=0}else switch(f[a+36>>2]|0){case 8:case 0:{n=oUb(c,8,d,f[k>>2]|0)|0;if((n|0)>0&(f[a+32>>2]|0)==0){t=0;v=c}else{s=n;break a}while(1){p=b[v>>0]|0;q=v+7|0;b[v>>0]=b[q>>0]|0;b[q>>0]=p;p=v+1|0;q=b[p>>0]|0;w=v+6|0;b[p>>0]=b[w>>0]|0;b[w>>0]=q;q=v+2|0;w=b[q>>0]|0;p=v+5|0;b[q>>0]=b[p>>0]|0;b[p>>0]=w;w=v+3|0;p=b[w>>0]|0;q=v+4|0;b[w>>0]=b[q>>0]|0;b[q>>0]=p;t=t+1|0;if((t|0)==(n|0)){s=n;break}else v=v+8|0}break}case 4:{n=oUb(c,4,d,f[k>>2]|0)|0;m=(n|0)>0;if(m&(f[a+32>>2]|0)==0){l=0;p=c;while(1){q=b[p>>0]|0;w=p+3|0;b[p>>0]=b[w>>0]|0;b[w>>0]=q;q=p+1|0;w=b[q>>0]|0;x=p+2|0;b[q>>0]=b[x>>0]|0;b[x>>0]=w;l=l+1|0;if((l|0)==(n|0))break;else p=p+4|0}}if(!m){s=n;break a}p=n;do{l=p;p=p+-1|0;w=f[c+(p<<2)>>2]|0;x=c+(p<<3)|0;f[x>>2]=w;f[x+4>>2]=((w|0)<0)<<31>>31}while((l|0)>1);s=n;break}default:{n=OSb(d<<3)|0;if(!n){hO(j,444535,i);bO(-2,j,444515,443782,323);bD(j)}p=oUb(n,8,d,f[k>>2]|0)|0;m=(p|0)>0;if(m){l=p;do{w=l;l=l+-1|0;x=f[n+(l<<1<<2)>>2]|0;q=c+(l<<3)|0;f[q>>2]=x;f[q+4>>2]=((x|0)<0)<<31>>31}while((w|0)>1)}PSb(n);if(!(m&(f[a+32>>2]|0)==0)){s=p;break a}l=0;w=c;while(1){x=b[w>>0]|0;q=w+3|0;b[w>>0]=b[q>>0]|0;b[q>>0]=x;x=w+1|0;q=b[x>>0]|0;y=w+2|0;b[x>>0]=b[y>>0]|0;b[y>>0]=q;l=l+1|0;if((l|0)==(p|0)){s=p;break}else w=w+4|0}}}while(0);if((s|0)==(d|0)){u=e;return s|0}f[a+24>>2]=1;if(f[a+4>>2]|0){u=e;return s|0}f[g>>2]=s;f[g+4>>2]=d;hO(j,444450,g);bO(-2,j,444515,443782,354);bD(j);u=e;return s|0}function Plb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e+8|0;h=e;i=e+16|0;j=a+28|0;if(!(f[j>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,20)|0;l=443761;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,444491,443782,286);bD(i)}if(!(f[a+8>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,23)|0;l=444234;m=k+23|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,444491,443782,286);bD(i)}a:do if(!(f[a+16>>2]|0)){l=(d|0)>0;if(l){k=0;m=0;do{n=f[j>>2]|0;f[h>>2]=c+(k<<2);o=(OTb(n,444512,h)|0)>0;m=(o&1)+m|0;k=k+1|0}while(o&(k|0)<(d|0));if(l&(f[a+20>>2]|0)!=0){k=lTb(f[j>>2]|0)|0;switch(k|0){case 10:case -1:{p=m;break a;break}default:{}}NUb(k,f[j>>2]|0)|0;p=m}else p=m}else p=0}else{k=oUb(c,4,d,f[j>>2]|0)|0;if((k|0)>0&(f[a+32>>2]|0)==0){o=0;n=c;while(1){q=b[n>>0]|0;r=n+3|0;b[n>>0]=b[r>>0]|0;b[r>>0]=q;q=n+1|0;r=b[q>>0]|0;s=n+2|0;b[q>>0]=b[s>>0]|0;b[s>>0]=r;o=o+1|0;if((o|0)==(k|0)){p=k;break}else n=n+4|0}}else p=k}while(0);if((p|0)==(d|0)){u=e;return p|0}f[a+24>>2]=1;if(f[a+4>>2]|0){u=e;return p|0}f[g>>2]=p;f[g+4>>2]=d;hO(i,444450,g);bO(-2,i,444491,443782,286);bD(i);u=e;return p|0}function Qlb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e+8|0;h=e;i=e+16|0;j=a+28|0;if(!(f[j>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,20)|0;l=443761;m=k+20|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,444424,443782,290);bD(i)}if(!(f[a+8>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,23)|0;l=444234;m=k+23|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,444424,443782,290);bD(i)}a:do if(!(f[a+16>>2]|0)){l=(d|0)>0;if(l){k=0;m=0;do{n=f[j>>2]|0;f[h>>2]=c+(k<<3);o=(OTb(n,444446,h)|0)>0;m=(o&1)+m|0;k=k+1|0}while(o&(k|0)<(d|0));if(l&(f[a+20>>2]|0)!=0){k=lTb(f[j>>2]|0)|0;switch(k|0){case 10:case -1:{p=m;break a;break}default:{}}NUb(k,f[j>>2]|0)|0;p=m}else p=m}else p=0}else{k=oUb(c,8,d,f[j>>2]|0)|0;if((k|0)>0&(f[a+32>>2]|0)==0){o=0;n=c;while(1){q=b[n>>0]|0;r=n+7|0;b[n>>0]=b[r>>0]|0;b[r>>0]=q;q=n+1|0;r=b[q>>0]|0;s=n+6|0;b[q>>0]=b[s>>0]|0;b[s>>0]=r;r=n+2|0;s=b[r>>0]|0;q=n+5|0;b[r>>0]=b[q>>0]|0;b[q>>0]=s;s=n+3|0;q=b[s>>0]|0;r=n+4|0;b[s>>0]=b[r>>0]|0;b[r>>0]=q;o=o+1|0;if((o|0)==(k|0)){p=k;break}else n=n+8|0}}else p=k}while(0);if((p|0)==(d|0)){u=e;return p|0}f[a+24>>2]=1;if(f[a+4>>2]|0){u=e;return p|0}f[g>>2]=p;f[g+4>>2]=d;hO(i,444450,g);bO(-2,i,444424,443782,290);bD(i);u=e;return p|0}function Rlb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+48|0;g=e+24|0;h=e+16|0;i=e+8|0;j=e;k=e+32|0;l=a+28|0;if(!(f[l>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;m=aD(k,20)|0;n=443761;o=m+20|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,k,444212,443782,364);bD(k)}if(!(f[a+8>>2]|0)){f[k>>2]=0;f[k+4>>2]=0;m=aD(k,23)|0;n=444234;o=m+23|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,k,444212,443782,365);bD(k)}if(((kUb(c)|0)>>>0>1?(b[c>>0]|0)==42:0)?(p=b[c+1>>0]|0,!(p<<24>>24==97^p<<24>>24!=108)):0)q=p;else{f[k>>2]=0;f[k+4>>2]=0;m=aD(k,88)|0;n=444258;o=m+88|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,k,444212,443782,366);bD(k);q=b[c+1>>0]|0}c=OSb(1024)|0;if(q<<24>>24==97){q=0;n=1024;m=c;while(1){o=n+1024|0;if((n|0)==(q|0)){r=o;s=QSb(m,o)|0}else{r=n;s=m}if(!s){hO(k,444347,j);bO(-2,k,444212,443782,386);bD(k)}q=(oUb(s+q|0,1,r-q|0,f[l>>2]|0)|0)+q|0;if((q|0)<(r|0))break;else{n=r;m=s}}if(q|0){t=s;v=q;f[d>>2]=t;u=e;return v|0}PSb(s);f[a+24>>2]=1;if(f[a+4>>2]|0){t=0;v=0;f[d>>2]=t;u=e;return v|0}hO(k,444385,i);bO(-2,k,444212,443782,395);bD(k);t=0;v=0;f[d>>2]=t;u=e;return v|0}i=0;s=1024;q=c;while(1){c=s+1024|0;if((s-i|0)<2){w=c;x=QSb(q,c)|0}else{w=s;x=q}if(!x){hO(k,444347,h);bO(-2,k,444212,443782,420);bD(k)}c=x+i|0;if(!(MUb(c,w-i|0,f[l>>2]|0)|0))break;m=kUb(c)|0;if(m|0?(y=m+-1|0,(b[c+y>>0]|0)==10):0){z=31;break}i=m+i|0;s=w;q=x}if((z|0)==31){t=x;v=y+i|0;f[d>>2]=t;u=e;return v|0}if(i|0){t=x;v=i;f[d>>2]=t;u=e;return v|0}PSb(x);f[a+24>>2]=1;if(f[a+4>>2]|0){t=0;v=0;f[d>>2]=t;u=e;return v|0}hO(k,444385,g);bO(-2,k,444212,443782,428);bD(k);t=0;v=0;f[d>>2]=t;u=e;return v|0}function Slb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=d+8|0;h=a+28|0;i=f[h>>2]|0;if(!i){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,20)|0;k=443761;l=j+20|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,444166,443782,111);bD(g);m=f[h>>2]|0}else m=i;if((UUb(m,c,0)|0)>=0){u=d;return}f[a+24>>2]=1;if(f[a+4>>2]|0){u=d;return}f[e>>2]=c;hO(g,444182,e);bO(-2,g,444166,443782,123);bD(g);u=d;return}function Tlb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=c+8|0;g=a+28|0;h=f[g>>2]|0;if(!h){f[e>>2]=0;f[e+4>>2]=0;i=aD(e,20)|0;j=443761;k=i+20|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,e,444117,443782,131);bD(e);l=f[g>>2]|0}else l=h;if((UUb(l,0,2)|0)>=0){u=c;return}f[a+24>>2]=1;if(f[a+4>>2]|0){u=c;return}hO(e,444136,d);bO(-2,e,444117,443782,143);bD(e);u=c;return}function Ulb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;e=c+8|0;g=a+28|0;h=f[g>>2]|0;if(!h){f[e>>2]=0;f[e+4>>2]=0;i=aD(e,20)|0;j=443761;k=i+20|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,e,444030,443782,150);bD(e);l=f[g>>2]|0}else l=h;h=qUb(l)|0;if((h|0)>-1){m=h;u=c;return m|0}if(f[a+4>>2]|0){m=0;u=c;return m|0}hO(e,444050,d);bO(-2,e,444030,443782,162);bD(e);m=0;u=c;return m|0}function Vlb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;e=a+28|0;a=f[e>>2]|0;if(a|0){g=a;yUb(g)|0;f[e>>2]=0;u=c;return}f[d>>2]=0;f[d+4>>2]=0;a=aD(d,20)|0;h=443761;i=a+20|0;do{b[a>>0]=b[h>>0]|0;a=a+1|0;h=h+1|0}while((a|0)<(i|0));bO(-215,d,444013,443782,170);bD(d);g=f[e>>2]|0;yUb(g)|0;f[e>>2]=0;u=c;return}function Wlb(a){a=a|0;var b=0;b=f[a+28>>2]|0;if(!b){PSb(a);return}yUb(b)|0;PSb(a);return}function Xlb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!(b&2147483647)){c=b>>31&-822083584;f[a>>2]=c;return}d=(b|0)<0?0-b|0:b;e=d>>>0<65536;g=e?d<<16:d;i=e?16:0;e=g>>>0<16777216;j=((h[444652+((e?g<<8:g)>>>24)>>0]|0)+((e?i|8:i)&255)<<24)+-16777216|0;i=j>>24;e=156-i|0;if((j|0)>100663296&e>>>0<253){c=(d<<i+-7)+(b&-2147483648)+(b|0?e<<23:0)|0;f[a>>2]=c;return}j=d<<i;i=j&127;do if(e>>>0>252){if((e|0)>=0){if(!((e|0)>253|(j+64|0)<0)){k=e;l=i;m=j;break}c=b&-2147483648|2139095040;f[a>>2]=c;return}d=0-e|0;if(d>>>0<31)n=(j<<(e&31)|0)!=0|j>>>d;else n=(j|0)!=0&1;k=0;l=n&127;m=n}else{k=e;l=i;m=j}while(0);j=(m+64|0)>>>7&~(l<<24>>24==64);c=((j|0)==0?0:k<<23)+(j|b&-2147483648)|0;f[a>>2]=c;return}function Ylb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[b>>2]|0;b=c>>>23;d=c&8388607;a:do switch((b&255)<<24>>24){case -1:{e=c>>>31;if(!d){g=$ac(e|0,0,63)|0;i=g;j=J|2146435072;break a}else{g=$ac(e|0,0,63)|0;e=J;k=$ac(c|0,0,29)|0;i=k|g;j=J|e|2146959360;break a}break}case 0:{if(!d){e=$ac(c>>>31|0,0,63)|0;i=e;j=J;break a}else{e=d>>>0<65536;g=e?c<<16:d;k=e?16:0;e=g>>>0<16777216;l=((h[444652+((e?g<<8:g)>>>24)>>0]|0)+((e?k|8:k)&255)<<24)+-134217728>>24;m=0-l|0;n=d<<l;o=8;break a}break}default:{m=b&255;n=d;o=8}}while(0);if((o|0)==8){o=$ac(c>>>31|0,0,63)|0;c=J;d=$ac(m+896|0,0,52)|0;m=J;b=$ac(n|0,0,29)|0;n=Kac(d|0,m|0,b|o|0,J|c|0)|0;i=n;j=J}n=a;f[n>>2]=i;f[n+4>>2]=j;return}function Zlb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b>>2]|0;b=f[c>>2]|0;if((b^d|0)<0){_lb(a,d,b);return}else{$lb(a,d,b);return}}function _lb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=b>>>23&255;e=b&8388607;g=c>>>23&255;i=c&8388607;j=d-g|0;a:do if(!j){if((d|0)==255){if(!(i|e))k=-4194304;else break;f[a>>2]=k;return}l=e-i|0;if(!l){k=0;f[a>>2]=k;return}m=(d|0)==0?0:d+-1|0;n=(l|0)<0;o=n?0-l|0:l;l=o>>>0<65536;p=l?o<<16:o;q=l?16:0;l=p>>>0<16777216;r=((h[444652+((l?p<<8:p)>>>24)>>0]|0)+((l?q|8:q)&255)&255)+248|0;q=m-(r<<24>>24)|0;l=(q|0)<0;k=(l?0:q<<23)+(((n?(b|0)>-1:(b|0)<0)&1)<<31)+(o<<((l?m:r)<<24>>24))|0;f[a>>2]=k;return}else{r=e<<7;m=i<<7;do if((j|0)<0){if((g|0)!=255){s=(d|0?1073741824:r)+r|0;t=m;u=0-j|0;v=g;w=(b|0)>-1;break}if(i|0)break a;k=(b&-2147483648)+-8388608|0;f[a>>2]=k;return}else{if((d|0)!=255){s=(g|0?1073741824:m)+m|0;t=r;u=j;v=d;w=(b|0)<0;break}if(!e)k=b;else break a;f[a>>2]=k;return}while(0);if(u>>>0<31)x=(s<<(0-u&31)|0)!=0|s>>>u;else x=(s|0)!=0&1;r=(t|1073741824)-x|0;m=r>>>0<65536;l=m?r<<16:r;o=m?16:0;m=l>>>0<16777216;n=(((m?o|8:o)&255)+(h[444652+((m?l<<8:l)>>>24)>>0]|0)<<24)+-16777216|0;l=n>>24;m=v+-1-l|0;if((n|0)>100663296&m>>>0<253){k=(r<<l+-7)+((w&1)<<31)+(r|0?m<<23:0)|0;f[a>>2]=k;return}n=r<<l;l=n&127;do if(m>>>0>252){if((m|0)>=0){if(!((m|0)>253|(n+64|0)<0)){y=m;z=l;A=n;break}k=(w&1)<<31|2139095040;f[a>>2]=k;return}r=0-m|0;if(r>>>0<31)B=(n<<(m&31)|0)!=0|n>>>r;else B=(n|0)!=0&1;y=0;z=B&127;A=B}else{y=m;z=l;A=n}while(0);n=(A+64|0)>>>7&~(z<<24>>24==64);k=((n|0)==0?0:y<<23)+(n|(w&1)<<31)|0;f[a>>2]=k;return}while(0);k=((b&2143289344|0)==2139095040&(b&4194303|0)!=0?b:(b&2139095040|0)!=2139095040|(e|0)==0?c:b)|4194304;f[a>>2]=k;return}function $lb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=b>>>23;e=d&255;g=b&8388607;h=c>>>23;i=h&255;j=c&8388607;k=e-i|0;a:do if(!k)switch((d&255)<<24>>24){case 0:{l=j+b|0;f[a>>2]=l;return}case -1:{if(!(j|g))l=b;else{m=30;break a}f[a>>2]=l;return}default:{n=(g|16777216)+j|0;if(!(e>>>0<254&(c+b&1|0)==0)){o=n<<6;p=e;break a}l=(e<<23|b&-2147483648)+(n>>>1)|0;f[a>>2]=l;return}}else{n=g<<6;q=j<<6;do if((k|0)<0)if((i|0)!=255){r=(e|0?536870912:n)+n|0;s=0-k|0;if(s>>>0<31){t=i;u=(r<<(d-h&31)|0)!=0|r>>>s;v=q;break}else{t=i;u=(r|0)!=0&1;v=q;break}}else{if(j|0){m=30;break a}l=b&-2147483648|2139095040;f[a>>2]=l;return}else{if((e|0)==255){if(!g)l=b;else{m=30;break a}f[a>>2]=l;return}r=(i|0?536870912:q)+q|0;if(k>>>0<31){t=e;u=n;v=(r<<(0-k&31)|0)!=0|r>>>k;break}else{t=e;u=n;v=(r|0)!=0&1;break}}while(0);n=v+536870912+u|0;q=n>>>0<1073741824;o=n<<(q&1);p=(q<<31>>31)+t|0}while(0);if((m|0)==30){l=((b&2143289344|0)==2139095040&(b&4194303|0)!=0?b:(b&2139095040|0)!=2139095040|(g|0)==0?c:b)|4194304;f[a>>2]=l;return}c=o&127;do if(p>>>0>252){if((p|0)>=0){if(!((p|0)>253|(o+64|0)<0)){w=p;x=c;y=o;break}l=b&-2147483648|2139095040;f[a>>2]=l;return}g=0-p|0;if(g>>>0<31)z=(o<<(p&31)|0)!=0|o>>>g;else z=(o|0)!=0&1;w=0;x=z&127;y=z}else{w=p;x=c;y=o}while(0);o=(y+64|0)>>>7&~(x<<24>>24==64);l=((o|0)==0?0:w<<23)+(o|b&-2147483648)|0;f[a>>2]=l;return}function amb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=f[b>>2]|0;b=f[c>>2]|0;if((b^d|0)<0){$lb(a,d,b);return}else{_lb(a,d,b);return}}function bmb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=f[b>>2]|0;b=f[c>>2]|0;c=d>>>23&255;e=d&8388607;g=b>>>23&255;i=b&8388607;j=b^d;do if((c|0)==255)if((e|0)==0?!((i|0)!=0&(g|0)==255):0){k=g|i;l=24}else l=23;else{if((g|0)==255){if(i|0){l=23;break}k=c|e;l=24;break}if(!c){if(e|0){m=e>>>0<65536;n=m?d<<16:e;o=m?16:0;m=n>>>0<16777216;p=((h[444652+((m?n<<8:n)>>>24)>>0]|0)+((m?o|8:o)&255)<<24)+-134217728>>24;q=1-p|0;r=e<<p;l=11}}else{q=c;r=e;l=11}do if((l|0)==11){if(!g){if(!i)break;p=i>>>0<65536;o=p?b<<16:i;m=p?16:0;p=o>>>0<16777216;n=((h[444652+((p?o<<8:o)>>>24)>>0]|0)+((p?m|8:m)&255)<<24)+-134217728>>24;s=i<<n;t=1-n|0}else{s=i;t=g}n=cbc(s<<8|-2147483648|0,0,r<<7|1073741824|0,0)|0;m=((n&-32768|0)!=0|0!=0)&1|J;n=m>>>0<1073741824;p=t+q+(n?-128:-127)|0;o=m<<(n&1);n=o&127;do if(p>>>0>252){if((p|0)>=0){if(!((p|0)>253|(o+64|0)<0)){u=p;v=n;w=o;break}x=j&-2147483648|2139095040;f[a>>2]=x;return}m=0-p|0;if(m>>>0<31)y=(o<<(p&31)|0)!=0|o>>>m;else y=(o|0)!=0&1;u=0;v=y&127;w=y}else{u=p;v=n;w=o}while(0);o=(w+64|0)>>>7&~(v<<24>>24==64);x=((o|0)==0?0:u<<23)+(o|j&-2147483648)|0;f[a>>2]=x;return}while(0);x=j&-2147483648;f[a>>2]=x;return}while(0);if((l|0)==23){x=((d&2143289344|0)==2139095040&(d&4194303|0)!=0?d:(d&2139095040|0)!=2139095040|(e|0)==0?b:d)|4194304;f[a>>2]=x;return}else if((l|0)==24){x=(k|0)==0?-4194304:j&-2147483648|2139095040;f[a>>2]=x;return}}function cmb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[b>>2]|0;b=f[c>>2]|0;c=d>>>23&255;e=d&8388607;g=b>>>23;i=g&255;j=b&8388607;k=b^d;a:do if((c|0)==255)if(!e)if((i|0)==255)if(!j){l=-4194304;f[a>>2]=l;return}else m=22;else m=23;else m=22;else{b:do switch((g&255)<<24>>24){case -1:{if(j|0){m=22;break a}break}case 0:{if(j|0){n=j>>>0<65536;o=n?b<<16:j;p=n?16:0;n=o>>>0<16777216;q=((h[444652+((n?o<<8:o)>>>24)>>0]|0)+((n?p|8:p)&255)<<24)+-134217728>>24;r=j<<q;s=1-q|0;m=10;break b}if(!(c|e))l=-4194304;else{m=23;break a}f[a>>2]=l;return}default:{r=j;s=i;m=10}}while(0);do if((m|0)==10){if(!c){if(!e)break;q=e>>>0<65536;p=q?d<<16:e;n=q?16:0;q=p>>>0<16777216;o=((h[444652+((q?p<<8:p)>>>24)>>0]|0)+((q?n|8:n)&255)<<24)+-134217728>>24;t=1-o|0;u=e<<o}else{t=c;u=e}o=u|8388608;n=r|8388608;q=o>>>0<n>>>0;p=(q?125:126)+(t-s)|0;v=$ac(o|0,0,(q?31:30)|0)|0;q=J;o=Uac(v|0,q|0,n|0,0)|0;w=cbc(o|0,0,n|0,0)|0;n=(o&63|0)==0&((w|0)!=(v|0)|(J|0)!=(q|0))&1|o;o=n&127;do if(p>>>0>252){if((p|0)>=0){if(!((p|0)>253|(n+64|0)<0)){x=p;y=o;z=n;break}l=k&-2147483648|2139095040;f[a>>2]=l;return}q=0-p|0;if(q>>>0<31)A=(n<<(p&31)|0)!=0|n>>>q;else A=(n|0)!=0&1;x=0;y=A&127;z=A}else{x=p;y=o;z=n}while(0);n=(z+64|0)>>>7&~(y<<24>>24==64);l=((n|0)==0?0:x<<23)+(n|k&-2147483648)|0;f[a>>2]=l;return}while(0);l=k&-2147483648;f[a>>2]=l;return}while(0);if((m|0)==22){l=((d&2143289344|0)==2139095040&(d&4194303|0)!=0?d:(d&2139095040|0)!=2139095040|(e|0)==0?b:d)|4194304;f[a>>2]=l;return}else if((m|0)==23){l=k&-2147483648|2139095040;f[a>>2]=l;return}}function dmb(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[b>>2]|0;b=f[a>>2]|0;if(!((c&2139095040|0)!=2139095040|(c&8388607|0)==0)){d=0;return d|0}if(!((b&2139095040|0)!=2139095040|(b&8388607|0)==0)){d=0;return d|0}a=c>>>31;if((a|0)==(b>>>31|0)){d=(c|0)!=(b|0)&(a|0)!=(c>>>0<b>>>0|0);return d|0}else{d=(c|0)<0&((b|c)&2147483647|0)!=0;return d|0}return 0}function emb(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[a>>2]|0;a=f[b>>2]|0;if(!((c&2139095040|0)!=2139095040|(c&8388607|0)==0)){d=0;return d|0}if(!((a&2139095040|0)!=2139095040|(a&8388607|0)==0)){d=0;return d|0}b=c>>>31;if((b|0)==(a>>>31|0)){d=(c|0)!=(a|0)&(b|0)!=(c>>>0<a>>>0|0);return d|0}else{d=(c|0)<0&((a|c)&2147483647|0)!=0;return d|0}return 0}function fmb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=(e|0)==0;i=g?32:0;j=g?d:e;g=j>>>0<65536;k=g?i|16:i;i=g?j<<16:j;j=i>>>0<16777216;g=((h[444652+((j?i<<8:i)>>>24)>>0]|0)+((j?k|8:k)&255)<<24)+-16777216|0;k=g>>24;j=c-k|0;if((g|0)>150994944&j>>>0<2045){g=$ac(b&1|0,0,63)|0;c=J;i=(d|0)!=0|(e|0)!=0;l=$ac(j|0,0,52)|0;m=i?J:0;n=$ac(d|0,e|0,k+-10|0)|0;o=Kac(n|0,J|0,g|0,c|0)|0;c=Kac(o|0,J|0,(i?l:0)|0,m|0)|0;p=J;q=c;r=a;s=r;f[s>>2]=q;t=r+4|0;u=t;f[u>>2]=p;return}c=$ac(d|0,e|0,k|0)|0;k=J;e=c&1023;do if((j&65535)>>>0>2044){if((j|0)>=0){Kac(c|0,k|0,512,0)|0;if(!((j|0)>2045|(J|0)<0)){v=j;w=e;x=c;y=k;break}d=$ac(b&1|0,0,63)|0;p=J|2146435072;q=d;r=a;s=r;f[s>>2]=q;t=r+4|0;u=t;f[u>>2]=p;return}d=0-j|0;if(d>>>0<63){m=Sac(c|0,k|0,d|0)|0;d=J;l=$ac(c|0,k|0,j&63|0)|0;z=d;A=((l|0)!=0|(J|0)!=0)&1|m}else{z=0;A=((c|0)!=0|(k|0)!=0)&1}v=0;w=A&1023;x=A;y=z}else{v=j;w=e;x=c;y=k}while(0);k=Kac(x|0,y|0,512,0)|0;y=Sac(k|0,J|0,10)|0;k=J;x=y&~((w|0)==512);w=(x|0)==0&(k|0)==0;y=$ac(b&1|0,0,63)|0;b=J;c=$ac(v|0,0,52)|0;v=Kac((w?0:c)|0,(w?0:J)|0,x|y|0,k|b|0)|0;p=J;q=v;r=a;s=r;f[s>>2]=q;t=r+4|0;u=t;f[u>>2]=p;return}function gmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!b){c=0;d=0;e=a;g=e;f[g>>2]=c;i=e+4|0;j=i;f[j>>2]=d;return}k=(b|0)<0?0-b|0:b;l=k>>>0<65536;m=l?k<<16:k;n=l?16:0;l=m>>>0<16777216;o=(h[444652+((l?m<<8:m)>>>24)>>0]|0)+((l?n|8:n)&255)|0;n=$ac(b>>>31|0,0,63)|0;b=J;l=(o<<24)+352321536>>24;o=$ac(1074-l|0,0,52)|0;m=J;p=$ac(k|0,0,l|0)|0;l=Kac(p|0,J|0,n|0,b|0)|0;b=Kac(l|0,J|0,o|0,m|0)|0;c=b;d=J;e=a;g=e;f[g>>2]=c;i=e+4|0;j=i;f[j>>2]=d;return}function hmb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=(c|0)<0;if((b|0)==0&(c&2147483647|0)==0){Rac(b|0,c|0,63)|0;h=e;f[h>>2]=0;f[h+4>>2]=J&-1008730112}else{h=Jac(0,0,b|0,c|0)|0;fmb(e,g,1084,g?h:b,g?J:c)}if((e|0)==(a|0)){u=d;return}c=e;e=f[c+4>>2]|0;g=a;f[g>>2]=f[c>>2];f[g+4>>2]=e;u=d;return}function imb(a){a=a|0;var b=0,c=0,d=0;b=f[a>>2]|0;a=b>>>23&255;c=158-a|0;if((c|0)>31){d=0;return d|0}if((c|0)<1){d=(b|0)==-822083584?-2147483648:(b&8388607|0)!=0&(a|0)==255?2147483647:(b>>>31)+2147483647|0;return d|0}else{a=(b<<8|-2147483648)>>>c;d=(b|0)<0?0-a|0:a;return d|0}return 0}function jmb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;a=b>>>23&255;c=b&8388607;d=(b|0)<0&((c|0)==0|(a|0)!=255);b=(a|0)==0?c:c|8388608;c=170-a|0;do if((c|0)>0)if(c>>>0<63){a=Sac(0,b|0,c|0)|0;e=J;g=$ac(0,b|0,0-c&63|0)|0;h=((g|0)!=0|(J|0)!=0)&1|a;i=e;break}else{h=(b|0)!=0&1;i=0;break}else{h=0;i=b}while(0);b=Kac(h|0,i|0,2048,0)|0;i=J;if(!(i>>>0>4095|(i|0)==4095&b>>>0>4294967295)){c=Sac(b|0,i|0,12)|0;i=(h&4095|0)==2048&0==0&1;h=d?(i|~c)+1|0:c&~i;if(!h){j=0;return j|0}if((h>>>31|0)==(d&1|0)){j=h;return j|0}}j=d?-2147483648:2147483647;return j|0}function kmb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a;a=f[b>>2]|0;c=f[b+4>>2]|0;b=Sac(a|0,c|0,52)|0;d=b&2047;b=c&1048575;e=(c|0)<0&((a|0)==0&(b|0)==0|(d|0)!=2047);c=(d|0)==0;g=c?a:a;a=c?b:b|1048576;b=1063-d|0;do if((b|0)>0)if(b>>>0<63){d=Sac(g|0,a|0,b|0)|0;c=J;h=$ac(g|0,a|0,0-b&63|0)|0;i=((h|0)!=0|(J|0)!=0)&1|d;j=c;break}else{i=((g|0)!=0|(a|0)!=0)&1;j=0;break}else{i=g;j=a}while(0);a=Kac(i|0,j|0,2048,0)|0;j=J;if(!(j>>>0>4095|(j|0)==4095&a>>>0>4294967295)){g=Sac(a|0,j|0,12)|0;j=(i&4095|0)==2048&0==0&1;i=e?(j|~g)+1|0:g&~j;if(!i){k=0;return k|0}if((i>>>31|0)==(e&1|0)){k=i;return k|0}}k=e?-2147483648:2147483647;return k|0}function lmb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a;a=f[b>>2]|0;c=f[b+4>>2]|0;b=Sac(a|0,c|0,52)|0;d=b&2047;b=c&1048575;e=(c|0)<0&((a|0)==0&(b|0)==0|(d|0)!=2047);c=(d|0)==0;g=c?a:a;a=c?b:b|1048576;b=1063-d|0;do if((b|0)>0)if(b>>>0<63){d=Sac(g|0,a|0,b|0)|0;c=J;h=$ac(g|0,a|0,0-b&63|0)|0;i=((h|0)!=0|(J|0)!=0)&1|d;j=c;break}else{i=((g|0)!=0|(a|0)!=0)&1;j=0;break}else{i=g;j=a}while(0);a=Kac(i|0,j|0,(e?4095:0)|0,(e?0:0)|0)|0;j=J;if(!(j>>>0>4095|(j|0)==4095&a>>>0>4294967295)){i=Sac(a|0,j|0,12)|0;j=e?0-i|0:i;if(!j){k=0;return k|0}if((j>>>31|0)==(e&1|0)){k=j;return k|0}}k=e?-2147483648:2147483647;return k|0}function mmb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=a;a=f[b>>2]|0;c=f[b+4>>2]|0;b=Sac(a|0,c|0,52)|0;d=b&2047;b=c&1048575;e=(c|0)<0&((a|0)==0&(b|0)==0|(d|0)!=2047);c=(d|0)==0;g=c?a:a;a=c?b:b|1048576;b=1075-d|0;if((b|0)<1){d=$ac(g|0,a|0,0-b|0)|0;c=J;if((b|0)<-11|(c|0)<0){h=e?-2147483648:2147483647;i=e?0:-1;J=h;return i|0}else{j=Jac(0,0,d|0,c|0)|0;h=e?J:c;i=e?j:d;J=h;return i|0}}if((b|0)>=64){h=0;i=0;J=h;return i|0}d=Sac(g|0,a|0,b|0)|0;j=J;c=$ac(g|0,a|0,0-b&63|0)|0;b=J;if((b|0)<0){a=Kac(d|0,j|0,1,0)|0;g=J;if(!((a|0)==0&(g|0)==0)){k=a&~((c|0)==0&(b&2147483647|0)==0&1);l=g;m=9}}else{k=d;l=j;m=9}if((m|0)==9){m=Jac(0,0,k|0,l|0)|0;j=e?m:k;m=e?J:l;if((k|0)==0&(l|0)==0){h=m;i=j;J=h;return i|0}l=Sac(j|0,m|0,63)|0;if((l|0)==(e&1|0)){h=m;i=j;J=h;return i|0}}h=e?-2147483648:2147483647;i=e?0:-1;J=h;return i|0}function nmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=b;b=f[c>>2]|0;d=f[c+4>>2]|0;c=Sac(b|0,d|0,52)|0;e=c&2047;g=d&1048575;if((e|0)==2047){h=d&-2147483648;if((b|0)==0&(g|0)==0){i=h|2139095040;f[a>>2]=i;return}else{j=Sac(b|0,d|0,29)|0;i=h|2143289344|j&8388607;f[a>>2]=i;return}}j=Sac(b|0,g|0,22)|0;g=((b&4194303|0)!=0|0!=0)&1|j;if(!(g|e)){i=d&-2147483648;f[a>>2]=i;return}j=e+-897|0;b=g|1073741824;h=g&127;do if(j>>>0>252){if(e>>>0<897){g=897-e|0;k=g>>>0<31?(b<<(c+31&31)|0)!=0|b>>>g:1;l=0;m=k&127;n=k;break}if((j|0)>253|(b+64|0)<0){i=d&-2147483648|2139095040;f[a>>2]=i;return}else{l=j;m=h;n=b}}else{l=j;m=h;n=b}while(0);b=(n+64|0)>>>7&~(m<<24>>24==64);i=((b|0)==0?0:l<<23)+(b|d&-2147483648)|0;f[a>>2]=i;return}function omb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=(e|0)<0;h=Sac(b|0,e|0,63)|0;i=Sac(c|0,g|0,63)|0;if((h|0)==(i|0)){pmb(a,b,e,c,g,d);return}else{qmb(a,b,e,c,g,d);return}}function pmb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;h=Sac(b|0,c|0,52)|0;i=h&2047;j=c&1048575;k=Sac(d|0,e|0,52)|0;l=k&2047;m=e&1048575;n=i-l|0;a:do if(!n)switch(h&2047){case 0:{o=Kac(d|0,m|0,b|0,c|0)|0;p=J;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}case 2047:{if((d|b|0)==0&(m|j|0)==0){o=b;p=c}else{u=28;break a}q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}default:{v=i;w=$ac(Kac(b|0,j|2097152|0,d|0,m|0)|0,J|0,9)|0;x=J;break a}}else{y=$ac(b|0,j|0,9)|0;z=J;A=$ac(d|0,m|0,9)|0;B=J;do if((n|0)<0)if((l|0)!=2047){C=(i|0)==0;D=$ac(b|0,j|0,10)|0;E=C?D:y;D=C?J:z|536870912;C=0-n|0;if(C>>>0<63){F=Sac(E|0,D|0,C|0)|0;C=J;G=$ac(E|0,D|0,h-k&63|0)|0;H=l;I=A;K=B;L=((G|0)!=0|(J|0)!=0)&1|F;M=C;break}else{H=l;I=A;K=B;L=((E|0)!=0|(D|0)!=0)&1;M=0;break}}else{if(!((d|0)==0&(m|0)==0)){u=28;break a}D=$ac(g&1|0,0,63)|0;o=D;p=J|2146435072;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}else{if((i|0)==2047){if((b|0)==0&(j|0)==0){o=b;p=c}else{u=28;break a}q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}D=(l|0)==0;E=$ac(d|0,m|0,10)|0;C=D?E:A;E=D?J:B|536870912;if(n>>>0<63){D=Sac(C|0,E|0,n|0)|0;F=J;G=$ac(C|0,E|0,0-n&63|0)|0;H=i;I=((G|0)!=0|(J|0)!=0)&1|D;K=F;L=y;M=z;break}else{H=i;I=((C|0)!=0|(E|0)!=0)&1;K=0;L=y;M=z;break}}while(0);z=Kac(I|0,K|0,0,536870912)|0;y=Kac(z|0,J|0,L|0,M|0)|0;z=J;B=z>>>0<1073741824|(z|0)==1073741824&y>>>0<0;A=$ac(y|0,z|0,B&1|0)|0;v=(B<<31>>31)+H|0;w=A;x=J}while(0);if((u|0)==28){u=0==0&(c&2146959360|0)==2146435072&((b|0)!=0|(c&524287|0)!=0);H=0!=0|(c&2146435072|0)!=2146435072|(b|0)==0&(j|0)==0;o=u?b:H?d:b;p=(u?c:H?e:c)|524288;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}c=w&1023;do if((v&65535)>>>0>2044){if((v|0)>=0){Kac(w|0,x|0,512,0)|0;if(!((v|0)>2045|(J|0)<0)){N=v;O=c;P=w;Q=x;break}e=$ac(g&1|0,0,63)|0;o=e;p=J|2146435072;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}e=0-v|0;if(e>>>0<63){H=Sac(w|0,x|0,e|0)|0;e=J;u=$ac(w|0,x|0,v&63|0)|0;R=((u|0)!=0|(J|0)!=0)&1|H;S=e}else{R=((w|0)!=0|(x|0)!=0)&1;S=0}N=0;O=R&1023;P=R;Q=S}else{N=v;O=c;P=w;Q=x}while(0);x=Kac(P|0,Q|0,512,0)|0;Q=Sac(x|0,J|0,10)|0;x=J;P=Q&~((O|0)==512);O=(P|0)==0&(x|0)==0;Q=$ac(g&1|0,0,63)|0;g=J;w=$ac(N|0,0,52)|0;N=Kac((O?0:w)|0,(O?0:J)|0,P|Q|0,x|g|0)|0;o=N;p=J;q=a;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}function qmb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=Sac(b|0,c|0,52)|0;j=i&2047;k=c&1048575;l=Sac(d|0,e|0,52)|0;m=l&2047;n=e&1048575;o=j-m|0;a:do if(!o){if((j|0)==2047)if((d|b|0)==0&(n|k|0)==0){p=0;q=-524288;break}else{r=19;break}s=Jac(b|0,k|0,d|0,n|0)|0;t=J;if((s|0)==0&(t|0)==0){p=0;q=0}else{u=(j|0)==0?0:j+-1|0;v=(t|0)<0;w=Jac(0,0,s|0,t|0)|0;x=v?w:s;s=v?J:t;t=(s|0)==0;w=t?32:0;y=t?x:s;t=y>>>0<65536;z=t?w|16:w;w=t?y<<16:y;y=w>>>0<16777216;t=((h[444652+((y?w<<8:w)>>>24)>>0]|0)+((y?z|8:z)&255)&255)+245|0;z=u-(t<<24>>24)|0;y=(z|0)<0;w=$ac((v^g)&1|0,0,63)|0;v=J;A=$ac(z|0,0,52)|0;z=Kac((y?0:A)|0,(y?0:J)|0,w|0,v|0)|0;v=J;w=$ac(x|0,s|0,(y?u:t)<<24>>24|0)|0;t=Kac(z|0,v|0,w|0,J|0)|0;p=t;q=J}}else{t=$ac(b|0,k|0,10)|0;w=J;v=$ac(d|0,n|0,10)|0;z=J;do if((o|0)<0){u=g^1;if((m|0)==2047){if(!((d|0)==0&(n|0)==0)){r=19;break a}y=$ac(u&1|0,0,63)|0;p=y;q=J|2146435072;break a}y=(j|0)!=0;s=Kac((y?0:t)|0,(y?1073741824:w)|0,t|0,w|0)|0;y=J;x=0-o|0;if(x>>>0<63){A=Sac(s|0,y|0,x|0)|0;x=J;B=$ac(s|0,y|0,i-l&63|0)|0;C=m;D=u;E=z;F=v;G=((B|0)!=0|(J|0)!=0)&1|A;H=x;break}else{C=m;D=u;E=z;F=v;G=((s|0)!=0|(y|0)!=0)&1;H=0;break}}else{if((j|0)==2047)if((b|0)==0&(k|0)==0){p=b;q=c;break a}else{r=19;break a}y=(m|0)!=0;s=Kac((y?0:v)|0,(y?1073741824:z)|0,v|0,z|0)|0;y=J;if(o>>>0<63){u=Sac(s|0,y|0,o|0)|0;x=J;A=$ac(s|0,y|0,0-o&63|0)|0;C=j;D=g;E=w;F=t;G=((A|0)!=0|(J|0)!=0)&1|u;H=x;break}else{C=j;D=g;E=w;F=t;G=((s|0)!=0|(y|0)!=0)&1;H=0;break}}while(0);t=Jac(F|0,E|1073741824|0,G|0,H|0)|0;fmb(a,D,C+-1|0,t,J);return}while(0);if((r|0)==19){r=0==0&(c&2146959360|0)==2146435072&((b|0)!=0|(c&524287|0)!=0);C=0!=0|(c&2146435072|0)!=2146435072|(b|0)==0&(k|0)==0;p=r?b:C?d:b;q=(r?c:C?e:c)|524288}c=a;f[c>>2]=p;f[c+4>>2]=q;return}function rmb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=(e|0)<0;h=Sac(b|0,e|0,63)|0;i=Sac(c|0,g|0,63)|0;if((h|0)==(i|0)){qmb(a,b,e,c,g,d);return}else{pmb(a,b,e,c,g,d);return}}function smb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=Sac(b|0,e|0,52)|0;i=d&2047;d=e&1048575;j=Sac(c|0,g|0,52)|0;k=j&2047;j=g&1048575;l=g^e;do if((i|0)==2047)if((b|0)==0&(d|0)==0?!(((c|0)!=0|(j|0)!=0)&(k|0)==2047):0){m=k;n=c;o=j;p=22}else p=21;else{if((k|0)==2047)if((c|0)==0&(j|0)==0){m=i;n=b;o=d;p=22;break}else{p=21;break}if(!i){if(!((b|0)==0&(d|0)==0)){q=(d|0)==0;r=q?32:0;s=q?b:d;q=s>>>0<65536;t=q?r|16:r;r=q?s<<16:s;s=r>>>0<16777216;q=((h[444652+((s?r<<8:r)>>>24)>>0]|0)+((s?t|8:t)&255)<<24)+-184549376>>24;t=$ac(b|0,d|0,q|0)|0;u=1-q|0;v=t;w=J;p=9}}else{u=i;v=b;w=d;p=9}do if((p|0)==9){if(!k){if((c|0)==0&(j|0)==0)break;t=(j|0)==0;q=t?32:0;s=t?c:j;t=s>>>0<65536;r=t?q|16:q;q=t?s<<16:s;s=q>>>0<16777216;t=((h[444652+((s?q<<8:q)>>>24)>>0]|0)+((s?r|8:r)&255)<<24)+-184549376>>24;r=$ac(c|0,j|0,t|0)|0;x=1-t|0;y=r;z=J}else{x=k;y=c;z=j}r=$ac(v|0,w|0,10)|0;t=$ac(y|0,z|0,11)|0;s=Sac(v|0,w|0,22)|0;q=s&-1073741825|1073741824;s=Sac(y|0,z|0,21)|0;A=s&2147483647|-2147483648;s=r&-1024;r=t&-2048;t=cbc(r|0,0,s|0,0)|0;B=J;C=cbc(r|0,0,q|0,0)|0;r=J;D=cbc(A|0,0,s|0,0)|0;s=Kac(D|0,J|0,C|0,r|0)|0;D=J;E=cbc(A|0,0,q|0,0)|0;q=Kac(D|0,(D>>>0<r>>>0|(D|0)==(r|0)&s>>>0<C>>>0)&1|0,E|0,J|0)|0;E=J;C=Kac(0,s|0,t|0,B|0)|0;B=J;t=Kac(q|0,E|0,(B>>>0<s>>>0|(B|0)==(s|0)&C>>>0<0)&1|0,0)|0;s=J;E=t|((C|0)!=0|(B|0)!=0)&1;B=s>>>0<1073741824|(s|0)==1073741824&E>>>0<0;C=x+u+(B?-1024:-1023)|0;t=$ac(E|0,s|0,B&1|0)|0;B=J;s=t&1023;do if((C&65535)>>>0>2044){if((C|0)>=0){Kac(t|0,B|0,512,0)|0;if(!((C|0)>2045|(J|0)<0)){F=C;G=s;H=t;I=B;break}K=0;L=l&-2147483648|2146435072;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}E=0-C|0;if(E>>>0<63){q=Sac(t|0,B|0,E|0)|0;E=J;r=$ac(t|0,B|0,C&63|0)|0;Q=((r|0)!=0|(J|0)!=0)&1|q;R=E}else{Q=((t|0)!=0|(B|0)!=0)&1;R=0}F=0;G=Q&1023;H=Q;I=R}else{F=C;G=s;H=t;I=B}while(0);B=Kac(H|0,I|0,512,0)|0;t=Sac(B|0,J|0,10)|0;B=J;s=t&~((G|0)==512);t=(s|0)==0&(B|0)==0;C=$ac(F|0,0,52)|0;E=Kac((t?0:C)|0,(t?0:J)|0,s|0,B|l&-2147483648|0)|0;K=E;L=J;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}while(0);K=0;L=l&-2147483648;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}while(0);if((p|0)==21){F=0==0&(e&2146959360|0)==2146435072&((b|0)!=0|(e&524287|0)!=0);G=0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(d|0)==0;K=F?b:G?c:b;L=(F?e:G?g:e)|524288;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}else if((p|0)==22){p=(m|n|0)==0&(o|0)==0;K=p?0:0;L=p?-524288:l&-2147483648|2146435072;M=a;N=M;f[N>>2]=K;O=M+4|0;P=O;f[P>>2]=L;return}}function tmb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=c;c=f[d>>2]|0;g=f[d+4>>2]|0;d=Sac(b|0,e|0,52)|0;i=d&2047;d=e&1048575;j=Sac(c|0,g|0,52)|0;k=j&2047;l=g&1048575;m=g^e;a:do if((i|0)==2047)if((b|0)==0&(d|0)==0)if((k|0)==2047)if((c|0)==0&(l|0)==0){n=0;o=-524288;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}else t=26;else t=27;else t=26;else{b:do switch(j&2047){case 2047:{if(!((c|0)==0&(l|0)==0)){t=26;break a}break}case 0:{if(!((c|0)==0&(l|0)==0)){u=(l|0)==0;v=u?32:0;w=u?c:l;u=w>>>0<65536;x=u?v|16:v;v=u?w<<16:w;w=v>>>0<16777216;u=((h[444652+((w?v<<8:v)>>>24)>>0]|0)+((w?x|8:x)&255)<<24)+-184549376>>24;x=$ac(c|0,l|0,u|0)|0;y=1-u|0;z=J;A=x;t=10;break b}if((i|b|0)==0&(d|0)==0){n=0;o=-524288}else{t=27;break a}p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}default:{y=k;z=l;A=c;t=10}}while(0);do if((t|0)==10){if(!i){if((b|0)==0&(d|0)==0)break;x=(d|0)==0;u=x?32:0;w=x?b:d;x=w>>>0<65536;v=x?u|16:u;u=x?w<<16:w;w=u>>>0<16777216;x=((h[444652+((w?u<<8:u)>>>24)>>0]|0)+((w?v|8:v)&255)<<24)+-184549376>>24;v=$ac(b|0,d|0,x|0)|0;B=1-x|0;C=J;D=v}else{B=i;C=d;D=b}v=C|1048576;x=z|1048576;w=v>>>0<x>>>0|(v|0)==(x|0)&D>>>0<A>>>0;u=(w?1021:1022)+(B-y)|0;E=$ac(D|0,v|0,(w?11:10)|0)|0;w=J;v=Sac(A|0,x|0,21)|0;x=Uac(-1,2147483647,v|0,0)|0;F=x+-2|0;cbc(w|0,0,F|0,0)|0;x=J;G=$ac(x|0,0,1)|0;H=G&-2;G=cbc(H|0,0,v|0,0)|0;I=Jac(E|0,w|0,G|0,J|0)|0;G=$ac(I|0,J|0,28)|0;I=J;w=A<<7&268435328;E=cbc(H|0,0,w|0,0)|0;H=Jac(G|0,I|0,E|0,J|0)|0;E=J;cbc(E|0,0,F|0,0)|0;F=Kac(J|0,0,4,0)|0;I=$ac(F|0,J|0,4)|0;G=Kac(I&-16|0,J&15|0,0,x|0)|0;x=J;do if(0<0|0==0&(G&448)>>>0<64){I=G&-128;K=F<<1&-16;L=cbc(K|0,0,v|0,0)|0;M=Jac(H|0,E|0,L|0,J|0)|0;L=$ac(M|0,J|0,28)|0;M=J;N=cbc(K|0,0,w|0,0)|0;K=Jac(L|0,M|0,N|0,J|0)|0;N=J;if((N|0)<0){M=Kac(I|0,x|0,-128,-1)|0;O=M;P=J;break}else{O=((K|0)!=0|(N|0)!=0)&1|I;P=x;break}}else{O=G;P=x}while(0);x=O&1023;do if((u&65535)>>>0>2044){if((u|0)>=0){Kac(O|0,P|0,512,0)|0;if(!((u|0)>2045|(J|0)<0)){Q=u;R=x;S=O;T=P;break}n=0;o=m&-2147483648|2146435072;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}G=0-u|0;if(G>>>0<63){w=Sac(O|0,P|0,G|0)|0;G=J;E=$ac(O|0,P|0,u&63|0)|0;U=((E|0)!=0|(J|0)!=0)&1|w;V=G}else{U=((O|0)!=0|(P|0)!=0)&1;V=0}Q=0;R=U&1023;S=U;T=V}else{Q=u;R=x;S=O;T=P}while(0);x=Kac(S|0,T|0,512,0)|0;u=Sac(x|0,J|0,10)|0;x=J;G=u&~((R|0)==512);u=(G|0)==0&(x|0)==0;w=$ac(Q|0,0,52)|0;E=Kac((u?0:w)|0,(u?0:J)|0,G|0,x|m&-2147483648|0)|0;n=E;o=J;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}while(0);n=0;o=m&-2147483648;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}while(0);if((t|0)==26){Q=0==0&(e&2146959360|0)==2146435072&((b|0)!=0|(e&524287|0)!=0);R=0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(d|0)==0;n=Q?b:R?c:b;o=(Q?e:R?g:e)|524288;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}else if((t|0)==27){n=0;o=m&-2147483648|2146435072;p=a;q=p;f[q>>2]=n;r=p+4|0;s=r;f[s>>2]=o;return}}function umb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a;a=f[c>>2]|0;d=f[c+4>>2]|0;c=b;b=f[c>>2]|0;e=f[c+4>>2]|0;if(!(0!=0|(d&2146435072|0)!=2146435072|(a|0)==0&(d&1048575|0)==0)){g=0;return g|0}if(!(0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(e&1048575|0)==0)){g=0;return g|0}g=(a|0)==(b|0)&(d|0)==(e|0)|(b|a|0)==0&((e|d)&2147483647|0)==0;return g|0}function vmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a;a=f[c>>2]|0;d=f[c+4>>2]|0;c=b;b=f[c>>2]|0;e=f[c+4>>2]|0;if(!(0!=0|(d&2146435072|0)!=2146435072|(a|0)==0&(d&1048575|0)==0)){g=0;return g|0}if(!(0!=0|(e&2146435072|0)!=2146435072|(b|0)==0&(e&1048575|0)==0)){g=0;return g|0}c=Sac(a|0,d|0,63)|0;h=Sac(b|0,e|0,63)|0;if((c|0)==(h|0)){g=(a|0)==(b|0)&(d|0)==(e|0)|(c|0)!=((d>>>0<e>>>0|(d|0)==(e|0)&a>>>0<b>>>0)&1|0);return g|0}else{g=(d|0)<0|(b|a|0)==0&((e|d)&2147483647|0)==0;return g|0}return 0}function wmb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;e=f[b>>2]|0;b=f[c>>2]|0;c=f[d>>2]|0;d=e>>>23&255;g=e&8388607;i=b>>>23&255;j=b&8388607;k=c>>>31;l=k&255;m=c>>>23&255;n=c&8388607;o=b^e;p=o>>>31;q=p&255;do if((d|0)==255)if((g|0)==0?!((j|0)!=0&(i|0)==255):0){r=i|j;s=54}else s=53;else{if((i|0)==255){if(j|0){s=53;break}r=d|g;s=54;break}if((m|0)==255){if(!n)t=c;else{u=0;break}f[a>>2]=t;return}if(!d)if(!g)s=59;else{v=g>>>0<65536;w=v?e<<16:g;x=v?16:0;v=w>>>0<16777216;y=((h[444652+((v?w<<8:w)>>>24)>>0]|0)+((v?x|8:x)&255)<<24)+-134217728>>24;z=1-y|0;A=g<<y;s=13}else{z=d;A=g;s=13}a:do if((s|0)==13){if(!i){if(!j){s=59;break}y=j>>>0<65536;x=y?b<<16:j;v=y?16:0;y=x>>>0<16777216;w=((h[444652+((y?x<<8:x)>>>24)>>0]|0)+((y?v|8:v)&255)<<24)+-134217728>>24;B=1-w|0;C=j<<w}else{B=i;C=j}w=cbc(C<<7|1073741824|0,0,A<<7|1073741824|0,0)|0;v=J;y=v>>>0<536870912|(v|0)==536870912&w>>>0<0;x=B+z+(y?-127:-126)|0;D=$ac(w|0,v|0,y&1|0)|0;y=J;do if(!m)if(!n){v=Sac(D|0,y|0,31)|0;E=((D&2147467264|0)!=0|0!=0)&1|v;F=(p|0)!=0;G=x+-1|0;break}else{v=n>>>0<65536;w=v?c<<16:n;H=v?16:0;v=w>>>0<16777216;I=((h[444652+((v?w<<8:w)>>>24)>>0]|0)+((v?H|8:H)&255)<<24)+-134217728>>24;K=n<<I;L=1-I|0;s=20;break}else{K=n;L=m;s=20}while(0);do if((s|0)==20){I=K<<6|536870912;H=x-L|0;if((o^c|0)>-1){if((H|0)<1){v=32-H|0;if(v>>>0<63){w=Sac(D|0,y|0,v|0)|0;M=$ac(D|0,y|0,0-v&63|0)|0;N=((M|0)!=0|(J|0)!=0)&1|w}else N=((D|0)!=0|(y|0)!=0)&1;O=N+I|0;P=L}else{if(H>>>0<63){w=Sac(0,I|0,H|0)|0;M=J;v=$ac(0,I|0,0-H&63|0)|0;Q=((v|0)!=0|(J|0)!=0)&1|w;R=M}else{Q=1;R=0}M=Kac(Q|0,R|0,D|0,y|0)|0;O=((M|0)!=0|0!=0)&1|J;P=x}M=O>>>0<1073741824;E=O<<(M&1);F=(p|0)!=0;G=(M<<31>>31)+P|0;break}do if((H|0)<0){M=0-H|0;if(M>>>0<63){w=Sac(D|0,y|0,M|0)|0;M=J;v=$ac(D|0,y|0,H&63|0)|0;S=((v|0)!=0|(J|0)!=0)&1|w;T=M}else{S=((D|0)!=0|(y|0)!=0)&1;T=0}M=Jac(0,I|0,S|0,T|0)|0;U=l;V=L;W=J;X=M}else{if(!H){M=Jac(D|0,y|0,0,I|0)|0;w=J;if((M|0)==0&(w|0)==0)break a;v=(w|0)<0;Y=Jac(0,0,M|0,w|0)|0;Z=J;_=Sac(M|0,w|0,63)|0;U=_&255^q;V=x;W=v?Z:w;X=v?Y:M;break}if(H>>>0<63){M=Sac(0,I|0,H|0)|0;Y=J;v=$ac(0,I|0,0-H&63|0)|0;$=((v|0)!=0|(J|0)!=0)&1|M;aa=Y}else{$=1;aa=0}Y=Jac(D|0,y|0,$|0,aa|0)|0;U=q;V=x;W=J;X=Y}while(0);H=(W|0)==0;I=H?32:0;Y=H?X:W;H=Y>>>0<65536;M=H?I|16:I;I=H?Y<<16:Y;Y=I>>>0<16777216;H=((Y?M|8:M)&255)+(h[444652+((Y?I<<8:I)>>>24)>>0]|0)<<24;I=V-(H+-16777216>>24)|0;Y=H+-553648128|0;H=Y>>24;if((Y|0)<0){Y=0-H&255;M=Sac(X|0,W|0,Y|0)|0;v=$ac(1,0,Y|0)|0;Y=Kac(v|0,J|0,-1,-1)|0;E=((Y&X|0)!=0|(J&W|0)!=0)&1|M;F=(U&1)!=0;G=I;break}else{E=X<<H;F=(U&1)!=0;G=I;break}}while(0);x=E&127;do if(G>>>0>252){if((G|0)>=0){if(!((G|0)>253|(E+64|0)<0)){ba=G;ca=x;da=E;break}t=(F&1)<<31|2139095040;f[a>>2]=t;return}y=0-G|0;if(y>>>0<31)ea=(E<<(G&31)|0)!=0|E>>>y;else ea=(E|0)!=0&1;ba=0;ca=ea&127;da=ea}else{ba=G;ca=x;da=E}while(0);x=(da+64|0)>>>7&~(ca<<24>>24==64);t=((x|0)==0?0:ba<<23)+(x|(F&1)<<31)|0;f[a>>2]=t;return}while(0);if((s|0)==59?!((o^c|0)<0&(m|n|0)==0):0){t=c;f[a>>2]=t;return}t=0;f[a>>2]=t;return}while(0);if((s|0)==53)u=((e&2143289344|0)==2139095040&(e&4194303|0)!=0?e:(e&2139095040|0)!=2139095040|(g|0)==0?b:e)|4194304;else if((s|0)==54)if(r){r=p<<31|2139095040;if((m|0)!=255){t=r;f[a>>2]=t;return}if(!n)if((p|0)==(k|0)){t=r;f[a>>2]=t;return}else u=-4194304;else u=r}else u=-4194304;t=((u&2143289344|0)==2139095040&(u&4194303|0)!=0?u:(u&2139095040|0)!=2139095040|(u&8388607|0)==0?c:u)|4194304;f[a>>2]=t;return}function xmb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+176|0;e=d+160|0;g=d+144|0;h=d+136|0;i=d+120|0;j=d+104|0;k=d+96|0;l=d+168|0;m=d+152|0;n=d+88|0;o=d+80|0;p=d+128|0;q=d+72|0;r=d+112|0;s=d+64|0;t=d+56|0;v=d+48|0;w=d+40|0;x=d+32|0;y=d+24|0;z=d+16|0;A=d+8|0;B=d;C=c;D=f[C>>2]|0;E=f[C+4>>2]|0;C=E&2147483647;if(C>>>0>2146435072|(C|0)==2146435072&D>>>0>0){F=a;f[F>>2]=-1;f[F+4>>2]=2147483647;u=d;return}if((D|0)==0&(C|0)==2146435072)if((D|0)==0&(E|0)==2146435072&(0!=0|(E&2146435072|0)!=2146435072|(D|0)==0&(E&1048575|0)==0)){E=a;f[E>>2]=0;f[E+4>>2]=2146435072;u=d;return}else{E=a;f[E>>2]=0;f[E+4>>2]=0;u=d;return}if((b[497472]|0)==0?Cac(497472)|0:0){E=e;f[E>>2]=0;f[E+4>>2]=1072693248;tmb(497480,e,21912)}if((b[497488]|0)==0?Cac(497488)|0:0){e=g;f[e>>2]=-17155599;f[e+4>>2]=1072049730;tmb(497496,g,21912)}if((b[497504]|0)==0?Cac(497504)|0:0){g=h;f[g>>2]=-8215462;f[g+4>>2]=1070514109;tmb(497512,h,21912)}if((b[497520]|0)==0?Cac(497520)|0:0){h=i;f[h>>2]=-668996491;f[h+4>>2]=1068264200;tmb(497528,i,21912)}if((b[497536]|0)==0?Cac(497536)|0:0){i=j;f[i>>2]=726613203;f[i+4>>2]=1065595559;tmb(497544,j,21912)}if((b[497552]|0)==0?Cac(497552)|0:0){j=k;f[j>>2]=359056036;f[j+4>>2]=1062594474;tmb(497560,k,21912)}k=l;f[k>>2]=0;f[k+4>>2]=0;k=f[c+4>>2]|0;j=k&2145386496;if(j>>>0>1083179008|(j|0)==1083179008&0>0){j=k&-2147483648|1091006464;k=l;f[k>>2]=0;f[k+4>>2]=j;G=0;H=j}else{smb(m,c,21920);c=m;j=f[c>>2]|0;k=f[c+4>>2]|0;c=l;f[c>>2]=j;f[c+4>>2]=k;G=j;H=k}k=Sac(G|0,H|0,52)|0;j=k&2047;k=H&1048575;c=(H|0)<0;i=(G|0)==0&(k|0)==0|(j|0)!=2047;h=c&i;g=(j|0)==0;e=g?G:G;E=g?k:k|1048576;g=1063-j|0;do if((g|0)>0)if(g>>>0<63){D=Sac(e|0,E|0,g|0)|0;C=J;F=$ac(e|0,E|0,0-g&63|0)|0;I=((F|0)!=0|(J|0)!=0)&1|D;K=C;break}else{I=((e|0)!=0|(E|0)!=0)&1;K=0;break}else{I=e;K=E}while(0);E=Kac(I|0,K|0,2048,0)|0;K=J;if(!(K>>>0>4095|(K|0)==4095&E>>>0>4294967295)){e=Sac(E|0,K|0,12)|0;K=(I&4095|0)==2048&0==0&1;I=h?(K|~e)+1|0:e&~K;if(I)if((I>>>31|0)==(h&1|0))L=I;else M=35;else L=0}else M=35;if((M|0)==35)L=h?-2147483648:2147483647;h=L>>6;M=h+1023|0;I=(h|0)<-1023;h=$ac(((M|0)<2047?M:2047)|0,0,52)|0;M=m;f[M>>2]=I?0:h;f[M+4>>2]=I?0:J;do if(j>>>0>=1023){if(j>>>0<=1074){I=$ac(1,0,1075-j|0)|0;M=J;h=Kac(I|0,M|0,-1,-1)|0;K=J;e=Sac(I|0,M|0,1)|0;E=Kac(e|0,J|0,G|0,H|0)|0;e=J;g=(E&h|0)==0&(e&K|0)==0;K=Jac(0,0,I|0,M|0)|0;N=E&K&(g?~I:-1);O=e&J&(g?~M:-1);break}if(i){N=G;O=H}else{M=0==0&(H&2146959360|0)==2146435072&((G|0)!=0|(H&524287|0)!=0);g=0!=0|(H&2146435072|0)!=2146435072;N=M?G:g?0:G;O=(M?H:g?0:H)|524288}}else{g=(G|0)==0&(H&2147483647|0)==0;M=H&-2147483648;e=((G|0)!=0|(k|0)!=0)&(j|0)==1022;N=g?G:e?0:0;O=g?H:e?M|1072693248:M}while(0);j=Sac(G|0,H|0,63)|0;k=Sac(N|0,O|0,63)|0;if((j|0)==(k|0))qmb(n,G,H,N,O,c);else pmb(n,G,H,N,O,c);smb(l,n,21928);smb(o,m,21912);m=21936+((L&63)<<3)|0;L=f[m+4>>2]|0;n=p;f[n>>2]=f[m>>2];f[n+4>>2]=L;smb(q,o,p);smb(s,497560,l);p=s;s=f[p>>2]|0;o=f[p+4>>2]|0;p=497544;L=f[p>>2]|0;n=f[p+4>>2]|0;p=(o|0)<0;m=Sac(s|0,o|0,63)|0;c=Sac(L|0,n|0,63)|0;if((m|0)==(c|0))pmb(t,s,o,L,n,p);else qmb(t,s,o,L,n,p);smb(v,t,l);t=v;v=f[t>>2]|0;p=f[t+4>>2]|0;t=497528;n=f[t>>2]|0;L=f[t+4>>2]|0;t=(p|0)<0;o=Sac(v|0,p|0,63)|0;s=Sac(n|0,L|0,63)|0;if((o|0)==(s|0))pmb(w,v,p,n,L,t);else qmb(w,v,p,n,L,t);smb(x,w,l);w=x;x=f[w>>2]|0;t=f[w+4>>2]|0;w=497512;L=f[w>>2]|0;n=f[w+4>>2]|0;w=(t|0)<0;p=Sac(x|0,t|0,63)|0;v=Sac(L|0,n|0,63)|0;if((p|0)==(v|0))pmb(y,x,t,L,n,w);else qmb(y,x,t,L,n,w);smb(z,y,l);y=z;z=f[y>>2]|0;w=f[y+4>>2]|0;y=497496;n=f[y>>2]|0;L=f[y+4>>2]|0;y=(w|0)<0;t=Sac(z|0,w|0,63)|0;x=Sac(n|0,L|0,63)|0;if((t|0)==(x|0))pmb(A,z,w,n,L,y);else qmb(A,z,w,n,L,y);smb(B,A,l);l=B;B=f[l>>2]|0;A=f[l+4>>2]|0;l=497480;y=f[l>>2]|0;L=f[l+4>>2]|0;l=(A|0)<0;n=Sac(B|0,A|0,63)|0;w=Sac(y|0,L|0,63)|0;if((n|0)==(w|0))pmb(r,B,A,y,L,l);else qmb(r,B,A,y,L,l);smb(a,q,r);u=d;return}function ymb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+240|0;e=d+232|0;g=d+224|0;i=d+216|0;j=d+208|0;k=d+200|0;l=d+192|0;m=d+184|0;n=d+176|0;o=d+168|0;p=d+160|0;q=d+152|0;r=d+144|0;s=d+128|0;t=d+136|0;v=d+120|0;w=d+112|0;x=d+96|0;y=d+88|0;z=d+80|0;A=d+72|0;B=d+64|0;C=d+56|0;D=d+48|0;E=d+104|0;F=d+40|0;G=d+32|0;H=d+24|0;I=d+16|0;K=d+8|0;L=d;M=c;N=f[M>>2]|0;O=f[M+4>>2]|0;M=O&2147483647;if(!(M>>>0>2146435072|(M|0)==2146435072&N>>>0>0)?(P=O&2146435072,Q=O&1048575,(N|0)==0&(M|0)==0|((O|0)>-1|(O|0)==-1&N>>>0>4294967295|((N|0)!=0|(Q|0)!=0)&(0==0&(P|0)==2146435072))):0){a:do if(0!=0|(P|0)!=2146435072|(N|0)==0&(Q|0)==0?(N|0)==0:0){if((O|0)<0)switch(O|0){case -2147483648:break;default:break a}else switch(O|0){case 0:break;default:break a}M=a;f[M>>2]=0;f[M+4>>2]=-1048576;u=d;return}while(0);if((b[497568]|0)==0?Cac(497568)|0:0){O=497576;f[O>>2]=0;f[O+4>>2]=1072693248}if((b[497584]|0)==0?Cac(497584)|0:0){O=g;f[O>>2]=0;f[O+4>>2]=-1074790400;O=e;f[O>>2]=0;f[O+4>>2]=1073741824;tmb(497592,g,e)}if((b[497600]|0)==0?Cac(497600)|0:0){g=i;f[g>>2]=0;f[g+4>>2]=1072693248;g=e;f[g>>2]=0;f[g+4>>2]=1074266112;tmb(497608,i,e)}if((b[497616]|0)==0?Cac(497616)|0:0){i=j;f[i>>2]=0;f[i+4>>2]=-1074790400;i=e;f[i>>2]=0;f[i+4>>2]=1074790400;tmb(497624,j,e)}if((b[497632]|0)==0?Cac(497632)|0:0){j=k;f[j>>2]=0;f[j+4>>2]=1072693248;j=e;f[j>>2]=0;f[j+4>>2]=1075052544;tmb(497640,k,e)}if((b[497648]|0)==0?Cac(497648)|0:0){k=l;f[k>>2]=0;f[k+4>>2]=-1074790400;k=e;f[k>>2]=0;f[k+4>>2]=1075314688;tmb(497656,l,e)}if((b[497664]|0)==0?Cac(497664)|0:0){l=m;f[l>>2]=0;f[l+4>>2]=1072693248;l=e;f[l>>2]=0;f[l+4>>2]=1075576832;tmb(497672,m,e)}if((b[497680]|0)==0?Cac(497680)|0:0){m=n;f[m>>2]=0;f[m+4>>2]=-1074790400;m=e;f[m>>2]=0;f[m+4>>2]=1075838976;tmb(497688,n,e)}n=c;m=f[n>>2]|0;l=f[n+4>>2]|0;n=Sac(m|0,l|0,44)|0;k=n&255;n=l&4095|1072693248;l=o;f[l>>2]=m;f[l+4>>2]=n;qmb(o,m,n,0,1072693248,0);n=k<<1;m=4112+(n<<3)|0;l=f[m>>2]|0;j=f[m+4>>2]|0;m=4112+((n|1)<<3)|0;n=f[m+4>>2]|0;i=p;f[i>>2]=f[m>>2];f[i+4>>2]=n;smb(q,o,p);if((k|0)==255){k=s;f[k>>2]=0;f[k+4>>2]=-1074790400;k=t;f[k>>2]=0;f[k+4>>2]=1082130432;tmb(r,s,t);s=q;k=f[s>>2]|0;p=f[s+4>>2]|0;s=r;o=f[s>>2]|0;n=f[s+4>>2]|0;s=(p|0)<0;i=Sac(k|0,p|0,63)|0;m=Sac(o|0,n|0,63)|0;if((i|0)==(m|0))pmb(e,k,p,o,n,s);else qmb(e,k,p,o,n,s);s=e;n=f[s+4>>2]|0;o=q;f[o>>2]=f[s>>2];f[o+4>>2]=n}smb(e,q,q);n=c;c=Sac(f[n>>2]|0,f[n+4>>2]|0,52)|0;n=c&2047;c=n+-1023|0;if(!c){R=0;S=0}else{o=n>>>0<1023?1023-n|0:c;n=o>>>0<65536;s=n?o<<16:o;p=n?16:0;n=s>>>0<16777216;k=(h[444652+((n?s<<8:s)>>>24)>>0]|0)+((n?p|8:p)&255)|0;p=$ac(c>>>31|0,0,63)|0;c=J;n=(k<<24)+352321536>>24;k=$ac(1074-n|0,0,52)|0;s=J;m=$ac(o|0,0,n|0)|0;n=Kac(m|0,J|0,p|0,c|0)|0;c=Kac(n|0,J|0,k|0,s|0)|0;R=c;S=J}c=r;f[c>>2]=R;f[c+4>>2]=S;smb(v,22448,r);r=v;v=f[r>>2]|0;S=f[r+4>>2]|0;r=(S|0)<0;c=Sac(v|0,S|0,63)|0;R=Sac(l|0,j|0,63)|0;if((c|0)==(R|0))pmb(w,v,S,l,j,r);else qmb(w,v,S,l,j,r);smb(x,497688,e);r=x;x=f[r>>2]|0;j=f[r+4>>2]|0;r=497656;l=f[r>>2]|0;S=f[r+4>>2]|0;r=(j|0)<0;v=Sac(x|0,j|0,63)|0;R=Sac(l|0,S|0,63)|0;if((v|0)==(R|0))pmb(y,x,j,l,S,r);else qmb(y,x,j,l,S,r);smb(z,y,e);y=z;z=f[y>>2]|0;r=f[y+4>>2]|0;y=497624;S=f[y>>2]|0;l=f[y+4>>2]|0;y=(r|0)<0;j=Sac(z|0,r|0,63)|0;x=Sac(S|0,l|0,63)|0;if((j|0)==(x|0))pmb(A,z,r,S,l,y);else qmb(A,z,r,S,l,y);smb(B,A,e);A=B;B=f[A>>2]|0;y=f[A+4>>2]|0;A=497592;l=f[A>>2]|0;S=f[A+4>>2]|0;A=(y|0)<0;r=Sac(B|0,y|0,63)|0;z=Sac(l|0,S|0,63)|0;if((r|0)==(z|0))pmb(C,B,y,l,S,A);else qmb(C,B,y,l,S,A);smb(t,C,e);C=w;w=f[C>>2]|0;A=f[C+4>>2]|0;C=t;t=f[C>>2]|0;S=f[C+4>>2]|0;C=(A|0)<0;l=Sac(w|0,A|0,63)|0;y=Sac(t|0,S|0,63)|0;if((l|0)==(y|0))pmb(D,w,A,t,S,C);else qmb(D,w,A,t,S,C);smb(F,497672,e);C=F;F=f[C>>2]|0;S=f[C+4>>2]|0;C=497640;t=f[C>>2]|0;A=f[C+4>>2]|0;C=(S|0)<0;w=Sac(F|0,S|0,63)|0;y=Sac(t|0,A|0,63)|0;if((w|0)==(y|0))pmb(G,F,S,t,A,C);else qmb(G,F,S,t,A,C);smb(H,G,e);G=H;H=f[G>>2]|0;C=f[G+4>>2]|0;G=497608;A=f[G>>2]|0;t=f[G+4>>2]|0;G=(C|0)<0;S=Sac(H|0,C|0,63)|0;F=Sac(A|0,t|0,63)|0;if((S|0)==(F|0))pmb(I,H,C,A,t,G);else qmb(I,H,C,A,t,G);smb(K,I,e);e=K;K=f[e>>2]|0;I=f[e+4>>2]|0;e=497576;G=f[e>>2]|0;t=f[e+4>>2]|0;e=(I|0)<0;A=Sac(K|0,I|0,63)|0;C=Sac(G|0,t|0,63)|0;if((A|0)==(C|0))pmb(L,K,I,G,t,e);else qmb(L,K,I,G,t,e);smb(E,L,q);q=D;D=f[q>>2]|0;L=f[q+4>>2]|0;q=E;E=f[q>>2]|0;e=f[q+4>>2]|0;q=(L|0)<0;t=Sac(D|0,L|0,63)|0;G=Sac(E|0,e|0,63)|0;if((t|0)==(G|0))pmb(a,D,L,E,e,q);else qmb(a,D,L,E,e,q);u=d;return}q=a;f[q>>2]=-1;f[q+4>>2]=2147483647;u=d;return}function zmb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=u;u=u+64|0;g=e+56|0;h=e+48|0;i=e+40|0;j=e+32|0;k=e+8|0;l=e;m=e+24|0;n=e+16|0;o=c;c=f[o+4>>2]|0;p=m;f[p>>2]=f[o>>2];f[p+4>>2]=c;c=d;d=f[c+4>>2]|0;p=n;f[p>>2]=f[c>>2];f[p+4>>2]=d;if((b[497696]|0)==0?Cac(497696)|0:0){d=497704;f[d>>2]=0;f[d+4>>2]=0}if((b[497712]|0)==0?Cac(497712)|0:0){d=497720;f[d>>2]=0;f[d+4>>2]=1072693248}if((b[497728]|0)==0?Cac(497728)|0:0){d=497736;f[d>>2]=0;f[d+4>>2]=2146435072}if((b[497744]|0)==0?Cac(497744)|0:0){d=497752;f[d>>2]=-1;f[d+4>>2]=2147483647}d=m;m=f[d>>2]|0;p=f[d+4>>2]|0;d=p&2147483647;c=(m|0)==0&(d|0)==2146435072;o=n;q=f[o>>2]|0;r=f[o+4>>2]|0;o=r&2147483647;s=(q|0)==0&(o|0)==2146435072;t=d>>>0>2146435072|(d|0)==2146435072&m>>>0>0;v=o>>>0>2146435072|(o|0)==2146435072&q>>>0>0;w=497704;x=f[w>>2]|0;y=f[w+4>>2]|0;w=y&2146435072;z=y&1048575;A=0!=0|(w|0)!=2146435072|(x|0)==0&(z|0)==0;do if(A?0!=0|(r&2146435072|0)!=2146435072|(q|0)==0&(r&1048575|0)==0:0){B=Sac(x|0,y|0,63)|0;C=Sac(q|0,r|0,63)|0;if((B|0)==(C|0)){D=((x|0)!=(q|0)|(y|0)!=(r|0))&(B|0)!=((y>>>0<r>>>0|(y|0)==(r|0)&x>>>0<q>>>0)&1|0);break}else{D=(y|0)<0&((x|q|0)!=0|((y|r)&2147483647|0)!=0);break}}else D=0;while(0);B=497720;C=f[B>>2]|0;E=f[B+4>>2]|0;B=E&2146435072;F=0!=0|(B|0)!=2146435072;G=E&1048575;H=(C|0)==0&(G|0)==0;do if(F|H?0!=0|(p&2146435072|0)!=2146435072|(m|0)==0&(p&1048575|0)==0:0)if((E|0)>-1|(E|0)==-1&C>>>0>4294967295){I=E>>>0<d>>>0|(E|0)==(d|0)&C>>>0<m>>>0;break}else{I=(C|m|0)!=0|((E|p)&2147483647|0)!=0;break}else I=0;while(0);K=D^I;I=a;f[I>>2]=0;f[I+4>>2]=0;if(v){if((a|0)==497752){u=e;return}v=497752;I=f[v+4>>2]|0;D=a;f[D>>2]=f[v>>2];f[D+4>>2]=I;u=e;return}if(s){if(((m|0)!=0|(p&1048575|0)!=0)&(0==0&(p&2146435072|0)==2146435072)|(F|H)^1){L=t;M=K?497704:497736}else{L=(m|0)==(C|0)&(d|0)==(E|0)|(C|m|0)==0&((E|p)&2147483647|0)==0;M=t?497752:K?497704:497736}K=L?497752:M;if((K|0)==(a|0)){u=e;return}M=K;K=f[M+4>>2]|0;L=a;f[L>>2]=f[M>>2];f[L+4>>2]=K;u=e;return}K=0!=0|(r&2146435072|0)!=2146435072;L=r&1048575;M=(q|0)==0&(L|0)==0;d=K|M;do if(d){if(((x|0)!=0|(z|0)!=0)&(0==0&(w|0)==2146435072)|((q|0)!=(x|0)|(r|0)!=(y|0))&((x|q|0)!=0|((y|r)&2147483647|0)!=0)){if(((C|0)!=0|(G|0)!=0)&(0==0&(B|0)==2146435072)|((q|0)!=(C|0)|(r|0)!=(E|0))&((C|q|0)!=0|((E|r)&2147483647|0)!=0))break;H=a;f[H>>2]=m;f[H+4>>2]=p;u=e;return}if((a|0)==497720){u=e;return}H=a;f[H>>2]=C;f[H+4>>2]=E;u=e;return}while(0);if(t){if((a|0)==497752){u=e;return}t=497752;E=f[t+4>>2]|0;C=a;f[C>>2]=f[t>>2];f[C+4>>2]=E;u=e;return}if(c){do if(d&A){c=Sac(q|0,r|0,63)|0;E=Sac(x|0,y|0,63)|0;if((c|0)==(E|0)){if(!(((q|0)!=(x|0)|(r|0)!=(y|0))&(E|0)!=((r>>>0<y>>>0|(r|0)==(y|0)&q>>>0<x>>>0)&1|0))){N=497736;break}}else if(!((r|0)<0&((x|q|0)!=0|((y|r)&2147483647|0)!=0))){N=497736;break}N=497704}else N=497736;while(0);if((N|0)==(a|0)){u=e;return}E=N;N=f[E+4>>2]|0;c=a;f[c>>2]=f[E>>2];f[c+4>>2]=N;u=e;return}N=Sac(q|0,r|0,52)|0;c=N&2047;do if(c>>>0>=1023){if(c>>>0<=1074){N=$ac(1,0,1075-c|0)|0;E=J;C=Kac(N|0,E|0,-1,-1)|0;t=J;B=Sac(N|0,E|0,1)|0;G=Kac(B|0,J|0,q|0,r|0)|0;B=J;H=(G&C|0)==0&(B&t|0)==0;t=Jac(0,0,N|0,E|0)|0;O=B&J&(H?~E:-1);P=G&t&(H?~N:-1);break}if(M|(c|0)!=2047){O=r;P=q}else{N=0==0&(r&2146959360|0)==2146435072&((q|0)!=0|(r&524287|0)!=0);O=(N?r:K?0:r)|524288;P=N?q:K?0:q}}else{N=(q|0)==0&(o|0)==0;H=r&-2147483648;t=((q|0)!=0|(L|0)!=0)&(c|0)==1022;O=N?r:t?H|1072693248:H;P=N?q:t?0:0}while(0);if(d?!(((P|0)!=0|(O&1048575|0)!=0)&(0==0&(O&2146435072|0)==2146435072)|((q|0)!=(P|0)|(r|0)!=(O|0))&((P|q|0)!=0|((O|r)&2147483647|0)!=0)):0){O=(r|0)<0&(M|(c|0)!=2047);M=(c|0)==0;P=M?q:q;o=M?L:L|1048576;L=1063-c|0;do if((L|0)>0)if(L>>>0<63){c=Sac(P|0,o|0,L|0)|0;M=J;K=$ac(P|0,o|0,0-L&63|0)|0;Q=((K|0)!=0|(J|0)!=0)&1|c;R=M;break}else{Q=((P|0)!=0|(o|0)!=0)&1;R=0;break}else{Q=P;R=o}while(0);o=Kac(Q|0,R|0,2048,0)|0;R=J;if(!(R>>>0>4095|(R|0)==4095&o>>>0>4294967295)){P=Sac(o|0,R|0,12)|0;R=(Q&4095|0)==2048&0==0&1;Q=O?(R|~P)+1|0:P&~R;if(Q)if((Q>>>31|0)==(O&1|0))S=Q;else T=64;else S=0}else T=64;if((T|0)==64)S=O?-2147483648:2147483647;a:do if(0!=0|(p&2146435072|0)!=2146435072|(m|0)==0&(p&1048575|0)==0?(m|0)==0:0){if((p|0)<0)switch(p|0){case -2147483648:break;default:{T=69;break a}}else switch(p|0){case 0:break;default:{T=69;break a}}O=(S|0)<0;Q=(S|0)==0;U=O?0:Q?0:0;V=O?2146435072:Q?1072693248:0}else T=69;while(0);if((T|0)==69){T=h;f[T>>2]=0;f[T+4>>2]=1072693248;T=i;f[T>>2]=m;f[T+4>>2]=p;T=(S|0)>-1?S:0-S|0;if((S|0)<0){S=j;f[S>>2]=0;f[S+4>>2]=1072693248;tmb(g,j,i);j=g;S=f[j+4>>2]|0;Q=i;f[Q>>2]=f[j>>2];f[Q+4>>2]=S}if((T|0)>1){S=T;while(1){if(S&1|0){smb(g,h,i);T=g;Q=f[T+4>>2]|0;j=h;f[j>>2]=f[T>>2];f[j+4>>2]=Q}smb(g,i,i);Q=g;j=f[Q+4>>2]|0;T=i;f[T>>2]=f[Q>>2];f[T+4>>2]=j;if(S>>>0>3)S=S>>>1;else break}}smb(g,h,i);i=g;U=f[i>>2]|0;V=f[i+4>>2]|0}i=a;f[i>>2]=U;f[i+4>>2]=V;u=e;return}if(0!=0|(p&2146435072|0)!=2146435072|(m|0)==0&(p&1048575|0)==0){do if(A){V=Sac(m|0,p|0,63)|0;i=Sac(x|0,y|0,63)|0;if((V|0)==(i|0)){if(!(((m|0)!=(x|0)|(p|0)!=(y|0))&(i|0)!=((p>>>0<y>>>0|(p|0)==(y|0)&m>>>0<x>>>0)&1|0)))break}else if(!((p|0)<0&((x|m|0)!=0|((y|p)&2147483647|0)!=0)))break;if((a|0)==497752){u=e;return}i=497752;V=f[i+4>>2]|0;U=a;f[U>>2]=f[i>>2];f[U+4>>2]=V;u=e;return}while(0);if(!(((x|0)!=0|(z|0)!=0)&(0==0&(w|0)==2146435072)|((m|0)!=(x|0)|(p|0)!=(y|0))&((x|m|0)!=0|((y|p)&2147483647|0)!=0))){do if(d&A){w=Sac(q|0,r|0,63)|0;z=Sac(x|0,y|0,63)|0;if((w|0)!=(z|0)){w=x|q;V=(y|r)&2147483647;if((r|0)<0&((w|0)!=0|(V|0)!=0)){W=497736;break}else{X=w;Y=V}}else{if(((q|0)!=(x|0)|(r|0)!=(y|0))&(z|0)!=((r>>>0<y>>>0|(r|0)==(y|0)&q>>>0<x>>>0)&1|0)){W=497736;break}X=x|q;Y=(y|r)&2147483647}W=(q|0)==(x|0)&(r|0)==(y|0)|(X|0)==0&(Y|0)==0?497720:497704}else W=497704;while(0);if((W|0)==(a|0)){u=e;return}Y=W;W=f[Y+4>>2]|0;X=a;f[X>>2]=f[Y>>2];f[X+4>>2]=W;u=e;return}}W=l;f[W>>2]=m;f[W+4>>2]=p;ymb(h,l);smb(k,n,h);xmb(g,k);if((g|0)!=(a|0)){k=g;g=f[k+4>>2]|0;h=a;f[h>>2]=f[k>>2];f[h+4>>2]=g}u=e;return}function Amb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=u;u=u+160|0;d=c+152|0;e=c+144|0;g=c+136|0;h=c+128|0;i=c+120|0;j=c+112|0;k=c+104|0;l=c+96|0;m=c+88|0;n=c+80|0;o=c+72|0;p=c+64|0;q=c+56|0;r=c+48|0;s=c+40|0;t=c+32|0;v=c+24|0;w=c+16|0;x=c+8|0;y=c;z=f[b>>2]|0;b=z&2147483647;if(b>>>0>2139095040){f[a>>2]=2147483647;u=c;return}if((b|0)==2139095040){f[a>>2]=z;u=c;return}A=(z>>>23&255)+-127|0;B=(A|0)%3|0;C=B+-3-(B>>31&-3)|0;B=$ac(C+1023|0,0,52)|0;D=J;E=$ac(z&8388607|0,0,29)|0;F=d;f[F>>2]=B|E;f[F+4>>2]=D|J;D=e;f[D>>2]=1716763248;f[D+4>>2]=1078370462;D=g;f[D>>2]=1712249633;f[D+4>>2]=1076731424;smb(i,e,d);e=i;i=f[e>>2]|0;D=f[e+4>>2]|0;e=(D|0)<0;if((D|0)>-1|(D|0)==-1&i>>>0>4294967295)pmb(j,i,D,1818302176,1080559860,e);else qmb(j,i,D,1818302176,1080559860,e);smb(k,j,d);j=k;k=f[j>>2]|0;e=f[j+4>>2]|0;j=(e|0)<0;if((e|0)>-1|(e|0)==-1&k>>>0>4294967295)pmb(l,k,e,1134341652,1079888535,j);else qmb(l,k,e,1134341652,1079888535,j);smb(m,l,d);l=m;m=f[l>>2]|0;j=f[l+4>>2]|0;l=(j|0)<0;if((j|0)>-1|(j|0)==-1&m>>>0>4294967295)pmb(n,m,j,-763202304,1076551024,l);else qmb(n,m,j,-763202304,1076551024,l);smb(o,n,d);n=o;o=f[n>>2]|0;l=f[n+4>>2]|0;n=(l|0)<0;if((l|0)>-1|(l|0)==-1&o>>>0>4294967295)pmb(p,o,l,-2081071827,1069871455,n);else qmb(p,o,l,-2081071827,1069871455,n);smb(r,g,d);g=r;r=f[g>>2]|0;n=f[g+4>>2]|0;g=(n|0)<0;if((n|0)>-1|(n|0)==-1&r>>>0>4294967295)pmb(s,r,n,-1071097835,1080229653,g);else qmb(s,r,n,-1071097835,1080229653,g);smb(t,s,d);s=t;t=f[s>>2]|0;g=f[s+4>>2]|0;s=(g|0)<0;if((g|0)>-1|(g|0)==-1&t>>>0>4294967295)pmb(v,t,g,1786843854,1080365264,s);else qmb(v,t,g,1786843854,1080365264,s);smb(w,v,d);v=w;w=f[v>>2]|0;s=f[v+4>>2]|0;v=(s|0)<0;if((s|0)>-1|(s|0)==-1&w>>>0>4294967295)pmb(x,w,s,-907885707,1078001355,v);else qmb(x,w,s,-907885707,1078001355,v);smb(y,x,d);x=y;y=f[x>>2]|0;v=f[x+4>>2]|0;x=(v|0)<0;if((v|0)>-1|(v|0)==-1&y>>>0>4294967295)pmb(q,y,v,0,1072693248,x);else qmb(q,y,v,0,1072693248,x);tmb(h,p,q);q=h;h=f[q>>2]|0;p=f[q+4>>2]|0;q=d;f[q>>2]=h;f[q+4>>2]=p;if(!b)G=0;else{b=Sac(h|0,p|0,29)|0;G=b&8388607|(((A-C|0)/3|0)<<23)+(z&-2147483648|1056964608)}f[a>>2]=G;u=c;return}function Bmb(a){a=a|0;var b=0;do if(a)if((f[a+12>>2]|0)==7247){b=Lmb(a)|0;break}else{b=Qmb(a)|0;break}else b=-2;while(0);return b|0}function Cmb(a,b){a=a|0;b=b|0;return Dmb(a,-1,b)|0}function Dmb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+16|0;g=e+8|0;h=e;if(!a){i=0;u=e;return i|0}j=OSb(140)|0;if(!j){i=0;u=e;return i|0}f[j+24>>2]=0;f[j+28>>2]=8192;k=j+80|0;f[k>>2]=0;l=j+12|0;f[l>>2]=0;m=j+60|0;f[m>>2]=-1;n=j+64|0;f[n>>2]=0;o=j+40|0;f[o>>2]=0;p=b[d>>0]|0;a:do if(p<<24>>24){q=0;r=d;s=0;t=p;v=0;w=0;b:while(1){x=t<<24>>24;c:do if((t+-48&255)<10){f[m>>2]=x+-48;y=s;z=q;A=w;B=v}else do switch(x|0){case 43:{C=10;break b;break}case 114:{f[l>>2]=7247;y=s;z=q;A=7247;B=v;break c;break}case 119:{f[l>>2]=31153;y=s;z=q;A=31153;B=v;break c;break}case 97:{f[l>>2]=1;y=s;z=q;A=1;B=v;break c;break}case 84:{f[o>>2]=1;y=s;z=q;A=w;B=1;break c;break}case 101:{y=s;z=1;A=w;B=v;break c;break}case 120:{y=1;z=q;A=w;B=v;break c;break}case 102:{f[n>>2]=1;y=s;z=q;A=w;B=v;break c;break}case 104:{f[n>>2]=2;y=s;z=q;A=w;B=v;break c;break}case 82:{f[n>>2]=3;y=s;z=q;A=w;B=v;break c;break}case 70:{f[n>>2]=4;y=s;z=q;A=w;B=v;break c;break}default:{y=s;z=q;A=w;B=v;break c}}while(0);while(0);r=r+1|0;t=b[r>>0]|0;if(!(t<<24>>24))break;else{q=z;s=y;v=B;w=A}}if((C|0)==10){PSb(j);i=0;u=e;return i|0}d:do if((A|0)<7247)switch(A|0){case 0:{break a;break}default:{}}else{switch(A|0){case 7247:break;default:break d}if(!B){f[o>>2]=1;break}PSb(j);i=0;u=e;return i|0}while(0);w=(kUb(a)|0)+1|0;v=OSb(w)|0;s=j+20|0;f[s>>2]=v;if(!v){PSb(j);i=0;u=e;return i|0}f[h>>2]=a;GUb(v,w,444908,h)|0;w=f[l>>2]|0;do if((c|0)>-1){f[j+16>>2]=c;D=w;E=c}else{f[g>>2]=438;v=fTb(a,((w|0)==7247?0:((w|0)==31153?512:1024)|(y|0?193:65))|(z|0?557056:32768),g)|0;f[j+16>>2]=v;if((v|0)!=-1){D=f[l>>2]|0;E=v;break}PSb(f[s>>2]|0);PSb(j);i=0;u=e;return i|0}while(0);e:do if((D|0)>=7247){switch(D|0){case 7247:break;default:{F=j;C=35;break e}}s=hTb(E,0,1)|0;f[j+48>>2]=(s|0)==-1?0:s;s=f[l>>2]|0;f[j>>2]=0;if((s|0)==7247){f[j+52>>2]=0;f[j+56>>2]=0;F=j+44|0;C=35}}else{switch(D|0){case 1:break;default:{F=j;C=35;break e}}hTb(E,0,2)|0;f[l>>2]=31153;F=j;C=35}while(0);if((C|0)==35)f[F>>2]=0;f[j+72>>2]=0;s=f[k>>2]|0;w=j+76|0;if(s|0){if((f[w>>2]|0)!=-4)PSb(s);f[k>>2]=0}f[w>>2]=0;f[j+8>>2]=0;f[j+88>>2]=0;i=j;u=e;return i|0}while(0);PSb(j);i=0;u=e;return i|0}function Emb(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a){b=-1;return b|0}c=a+12|0;if((f[c>>2]|0)!=7247){b=-1;return b|0}d=a+76|0;switch(f[d>>2]|0){case -5:case 0:break;default:{b=-1;return b|0}}if((hTb(f[a+16>>2]|0,f[a+48>>2]|0,0)|0)==-1){b=-1;return b|0}f[a>>2]=0;if((f[c>>2]|0)==7247){f[a+52>>2]=0;f[a+56>>2]=0;f[a+44>>2]=0}f[a+72>>2]=0;c=a+80|0;e=f[c>>2]|0;if(e|0){if((f[d>>2]|0)!=-4)PSb(e);f[c>>2]=0}f[d>>2]=0;f[a+8>>2]=0;f[a+88>>2]=0;b=0;return b|0}function Fmb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=a+80|0;h=f[g>>2]|0;if(h|0){if((f[a+76>>2]|0)!=-4)PSb(h);f[g>>2]=0}switch(b|0){case 0:case -5:break;default:f[a>>2]=0}h=a+76|0;f[h>>2]=b;if((b|0)==-4|(c|0)==0){u=d;return}b=f[a+20>>2]|0;a=kUb(b)|0;i=OSb(a+3+(kUb(c)|0)|0)|0;f[g>>2]=i;if(!i){f[h>>2]=-4;u=d;return}else{h=kUb(b)|0;g=h+3+(kUb(c)|0)|0;f[e>>2]=b;f[e+4>>2]=475786;f[e+8>>2]=c;GUb(i,g,444911,e)|0;u=d;return}}function Gmb(a){a=a|0;var b=0;if((a|0)!=0?(f[a+12>>2]|0)==7247:0)b=f[a+56>>2]|0;else b=0;return b|0}function Hmb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+44|0;c=a+52|0;d=a+88|0;e=a+24|0;g=a+100|0;h=a+36|0;i=a+96|0;a:while(1){switch(f[b>>2]|0){case 1:{j=5;break a;break}case 0:{if((Jmb(a)|0)==-1){k=-1;j=16;break a}if(!(f[b>>2]|0)){k=0;j=16;break a}break}case 2:{f[g>>2]=f[e>>2]<<1;f[i>>2]=f[h>>2];if((Imb(a)|0)==-1){k=-1;j=16;break a}break}default:{}}if(f[a>>2]|0){k=0;j=16;break}if(!(f[c>>2]|0))continue;if(!(f[d>>2]|0)){k=0;j=16;break}}if((j|0)==5){d=f[h>>2]|0;i=f[e>>2]<<1;f[a>>2]=0;e=a+16|0;g=0;do{b=i-g|0;l=kWb(f[e>>2]|0,d+g|0,b>>>0<1073741824?b:1073741824)|0;if((l|0)<1){j=8;break}g=(f[a>>2]|0)+l|0;f[a>>2]=g}while(g>>>0<i>>>0);do if((j|0)==8){if((l|0)>=0){f[c>>2]=1;break}i=ZSb()|0;Fmb(a,-1,wTb(f[i>>2]|0)|0);k=-1;return k|0}while(0);f[a+4>>2]=f[h>>2];k=0;return k|0}else if((j|0)==16)return k|0;return 0}function Imb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=a+84|0;c=a+100|0;d=f[c>>2]|0;e=a+88|0;g=a+76|0;h=a+52|0;i=a+32|0;j=a+24|0;k=a+16|0;l=0;a:while(1){if(!(f[e>>2]|0)){switch(f[g>>2]|0){case -5:case 0:break;default:{m=-1;n=20;break a}}if(f[h>>2]|0){n=12;break}o=f[i>>2]|0;p=f[j>>2]|0;q=0;while(1){r=p-q|0;s=kWb(f[k>>2]|0,o+q|0,r>>>0<1073741824?r:1073741824)|0;if((s|0)<1){n=8;break}r=s+q|0;if(r>>>0<p>>>0)q=r;else{t=r;break}}if((n|0)==8){n=0;if((s|0)<0){n=10;break}f[h>>2]=1;t=q}p=(f[e>>2]|0)+t|0;f[e>>2]=p;f[b>>2]=f[i>>2];if(!p){n=12;break}}p=Umb(b,0)|0;switch(p|0){case 2:case -2:{n=14;break a;break}case -4:{n=15;break a;break}case -3:{n=16;break a;break}default:{}}o=f[c>>2]|0;if((p|0)!=1&(o|0)!=0)l=p;else{u=p;v=o;break}}if((n|0)==10){b=ZSb()|0;Fmb(a,-1,wTb(f[b>>2]|0)|0);m=-1;return m|0}else if((n|0)==12){Fmb(a,-5,444918);u=l;v=f[c>>2]|0}else if((n|0)==14){Fmb(a,-2,444941);m=-1;return m|0}else if((n|0)==15){Fmb(a,-4,445041);m=-1;return m|0}else if((n|0)==16){c=f[a+108>>2]|0;Fmb(a,-3,(c|0)==0?444980:c);m=-1;return m|0}else if((n|0)==20)return m|0;n=d-v|0;f[a>>2]=n;f[a+4>>2]=(f[a+96>>2]|0)+(0-n);if((u|0)!=1){m=0;return m|0}f[a+44>>2]=0;m=0;return m|0}function Jmb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+84|0;d=a+24|0;if(!(f[d>>2]|0)){e=f[a+28>>2]|0;g=OSb(e)|0;h=a+32|0;f[h>>2]=g;i=OSb(e<<1)|0;j=a+36|0;f[j>>2]=i;if((g|0)==0|(i|0)==0){PSb(i);PSb(f[h>>2]|0);Fmb(a,-4,445041);k=-1;return k|0}f[d>>2]=e;f[a+116>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;e=a+88|0;f[e>>2]=0;f[c>>2]=0;if(!(Tmb(c,31,445055,56)|0))l=e;else{PSb(f[j>>2]|0);PSb(f[h>>2]|0);f[d>>2]=0;Fmb(a,-4,445041);k=-1;return k|0}}else l=a+88|0;h=f[l>>2]|0;a:do if(h>>>0<2){switch(f[a+76>>2]|0){case -5:case 0:break;default:{k=-1;return k|0}}j=a+52|0;if(!(f[j>>2]|0)){e=a+32|0;if(!h)m=0;else{b[f[e>>2]>>0]=b[f[c>>2]>>0]|0;m=f[l>>2]|0}i=(f[e>>2]|0)+m|0;g=(f[d>>2]|0)-m|0;n=a+16|0;o=0;while(1){p=g-o|0;q=kWb(f[n>>2]|0,i+o|0,p>>>0<1073741824?p:1073741824)|0;if((q|0)<1){r=15;break}p=q+o|0;if(p>>>0<g>>>0)o=p;else{s=p;break}}do if((r|0)==15){if((q|0)>=0){f[j>>2]=1;s=o;break}g=ZSb()|0;Fmb(a,-1,wTb(f[g>>2]|0)|0);k=-1;return k|0}while(0);o=(f[l>>2]|0)+s|0;f[l>>2]=o;f[c>>2]=f[e>>2];t=o}else t=h;switch(t|0){case 1:{u=1;break a;break}case 0:{k=0;break}default:{v=t;r=20;break a}}return k|0}else{v=h;r=20}while(0);if((r|0)==20){r=f[c>>2]|0;if((b[r>>0]|0)==31?(b[r+1>>0]|0)==-117:0){Rmb(c)|0;f[a+44>>2]=2;f[a+40>>2]=0;k=0;return k|0}else u=v}v=a+40|0;if(!(f[v>>2]|0)){f[l>>2]=0;f[a+52>>2]=1;f[a>>2]=0;k=0;return k|0}else{r=f[a+36>>2]|0;f[a+4>>2]=r;Vac(r|0,f[c>>2]|0,u|0)|0;f[a>>2]=f[l>>2];f[l>>2]=0;f[a+44>>2]=1;f[v>>2]=1;k=0;return k|0}return 0}function Kmb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((a|0)==0|(c|0)==0|(d|0)<1){e=0;return e|0}if((f[a+12>>2]|0)!=7247){e=0;return e|0}switch(f[a+76>>2]|0){case -5:case 0:break;default:{e=0;return e|0}}g=a+72|0;a:do if(f[g>>2]|0?(f[g>>2]=0,h=f[a+68>>2]|0,i=a+88|0,j=a+52|0,k=a+4|0,l=a+8|0,h|0):0){m=h;b:while(1){while(1){n=f[a>>2]|0;if(n|0)break;if(f[j>>2]|0?(f[i>>2]|0)==0:0)break a;if((Hmb(a)|0)==-1){e=0;break b}}h=(n|0)<0|(n|0)>(m|0)?m:n;f[a>>2]=n-h;f[k>>2]=(f[k>>2]|0)+h;f[l>>2]=(f[l>>2]|0)+h;m=m-h|0;if(!m)break a}return e|0}while(0);n=d+-1|0;if(!n){e=0;return e|0}d=a+4|0;g=a+8|0;m=c;l=n;n=f[a>>2]|0;while(1){if(!n){if((Hmb(a)|0)==-1){e=0;o=21;break}k=f[a>>2]|0;if(!k){o=17;break}else p=k}else p=n;k=p>>>0>l>>>0?l:p;i=f[d>>2]|0;j=xTb(i,10,k)|0;h=(j|0)==0;q=h?k:1-i+j|0;Vac(m|0,i|0,q|0)|0;n=(f[a>>2]|0)-q|0;f[a>>2]=n;f[d>>2]=(f[d>>2]|0)+q;f[g>>2]=(f[g>>2]|0)+q;l=l-q|0;i=m+q|0;if(!(h&(l|0)!=0)){r=i;break}else m=i}if((o|0)==17){f[a+56>>2]=1;r=m}else if((o|0)==21)return e|0;if((r|0)==(c|0)){e=0;return e|0}b[r>>0]=0;e=c;return e|0}function Lmb(a){a=a|0;var b=0,c=0,d=0;if(!a){b=-2;return b|0}if((f[a+12>>2]|0)!=7247){b=-2;return b|0}if(f[a+24>>2]|0){Wmb(a+84|0)|0;PSb(f[a+36>>2]|0);PSb(f[a+32>>2]|0)}c=(f[a+76>>2]|0)==-5?-5:0;Fmb(a,0,0);PSb(f[a+20>>2]|0);d=eTb(f[a+16>>2]|0)|0;PSb(a);b=d|0?-1:c;return b|0}function Mmb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;if(!c){d=0;return d|0}e=a+24|0;if((f[e>>2]|0)==0?(Nmb(a)|0)==-1:0){d=0;return d|0}g=a+72|0;a:do if(f[g>>2]|0){f[g>>2]=0;h=f[a+68>>2]|0;i=a+84|0;j=a+88|0;if(f[j>>2]|0?(Omb(a,0)|0)==-1:0){d=0;return d|0}if(h|0){k=a+32|0;l=a+8|0;m=h;h=0;while(1){n=f[e>>2]|0;o=(n|0)<0|(n|0)>(m|0)?m:n;if(!h)Nac(f[k>>2]|0,0,o|0)|0;f[j>>2]=o;f[i>>2]=f[k>>2];f[l>>2]=(f[l>>2]|0)+o;m=m-o|0;if((Omb(a,0)|0)==-1){d=0;break}if(!m)break a;else h=1}return d|0}}while(0);g=a+88|0;if((f[e>>2]|0)>>>0<=c>>>0){if(!(f[g>>2]|0)){p=a+84|0;f[p>>2]=b;q=a+8|0;f[g>>2]=c;r=f[q>>2]|0;s=r+c|0;f[q>>2]=s;t=Omb(a,0)|0;u=(t|0)==-1;v=u?0:c;return v|0}if((Omb(a,0)|0)==-1){d=0;return d|0}else{p=a+84|0;f[p>>2]=b;q=a+8|0;f[g>>2]=c;r=f[q>>2]|0;s=r+c|0;f[q>>2]=s;t=Omb(a,0)|0;u=(t|0)==-1;v=u?0:c;return v|0}}v=a+32|0;u=a+84|0;t=a+8|0;s=b;b=c;while(1){q=f[g>>2]|0;r=f[v>>2]|0;if(!q){f[u>>2]=r;w=r}else w=f[u>>2]|0;p=w+q|0;q=r-p+(f[e>>2]|0)|0;r=q>>>0>b>>>0?b:q;Vac(p|0,s|0,r|0)|0;f[g>>2]=r+(f[g>>2]|0);f[t>>2]=r+(f[t>>2]|0);b=b-r|0;if(!b){d=c;x=23;break}if((Omb(a,0)|0)==-1){d=0;x=23;break}else s=s+r|0}if((x|0)==23)return d|0;return 0}function Nmb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=a+84|0;c=a+28|0;d=f[c>>2]|0;e=OSb(d<<1)|0;g=a+32|0;f[g>>2]=e;if(!e){Fmb(a,-4,445041);h=-1;return h|0}i=a+40|0;if(f[i>>2]|0){f[a+24>>2]=d;h=0;return h|0}j=OSb(d)|0;d=a+36|0;f[d>>2]=j;if(!j){PSb(e);Fmb(a,-4,445041);h=-1;return h|0}f[a+116>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;if(dnb(b,f[a+60>>2]|0,8,31,8,f[a+64>>2]|0,445055,56)|0){PSb(f[d>>2]|0);PSb(f[g>>2]|0);Fmb(a,-4,445041);h=-1;return h|0}f[b>>2]=0;b=f[c>>2]|0;c=f[i>>2]|0;f[a+24>>2]=b;if(c|0){h=0;return h|0}f[a+100>>2]=b;b=f[a+36>>2]|0;f[a+96>>2]=b;f[a+4>>2]=b;h=0;return h|0}function Omb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+84|0;d=a+24|0;if((f[d>>2]|0)==0?(Nmb(a)|0)==-1:0){e=-1;return e|0}if(f[a+40>>2]|0){g=a+88|0;h=f[g>>2]|0;if(!h){e=0;return e|0}i=a+16|0;j=h;h=f[c>>2]|0;while(1){k=jWb(f[i>>2]|0,h,j>>>0<1073741824?j:1073741824)|0;if((k|0)<0)break;j=(f[g>>2]|0)-k|0;f[g>>2]=j;h=(f[c>>2]|0)+k|0;f[c>>2]=h;if(!j){e=0;l=41;break}}if((l|0)==41)return e|0;j=ZSb()|0;Fmb(a,-1,wTb(f[j>>2]|0)|0);e=-1;return e|0}j=a+100|0;h=a+96|0;g=a+4|0;i=a+36|0;k=a+16|0;a:do switch(b|0){case 0:{m=f[j>>2]|0;while(1){do if(!m){n=f[h>>2]|0;o=f[g>>2]|0;if(n>>>0>o>>>0){p=n;n=o;do{o=p-n|0;q=jWb(f[k>>2]|0,n,(o|0)<1073741824?o:1073741824)|0;if((q|0)<0){l=31;break a}n=(f[g>>2]|0)+q|0;f[g>>2]=n;p=f[h>>2]|0}while(p>>>0>n>>>0);n=f[j>>2]|0;if(n|0){r=n;break}}n=f[d>>2]|0;f[j>>2]=n;p=f[i>>2]|0;f[h>>2]=p;f[g>>2]=p;r=n}else r=m;while(0);if((mnb(c,0)|0)==-2){l=37;break a}m=f[j>>2]|0;if((r|0)==(m|0)){l=39;break}}break}case 4:{m=0;n=f[j>>2]|0;while(1){if((n|0)==0|(m|0)==1){p=f[h>>2]|0;q=f[g>>2]|0;if(p>>>0>q>>>0){o=p;p=q;do{q=o-p|0;s=jWb(f[k>>2]|0,p,(q|0)<1073741824?q:1073741824)|0;if((s|0)<0){l=31;break a}p=(f[g>>2]|0)+s|0;f[g>>2]=p;o=f[h>>2]|0}while(o>>>0>p>>>0);t=f[j>>2]|0}else t=n;if(!t){p=f[d>>2]|0;f[j>>2]=p;o=f[i>>2]|0;f[h>>2]=o;f[g>>2]=o;u=p}else u=t}else u=n;m=mnb(c,4)|0;if((m|0)==-2){l=37;break a}n=f[j>>2]|0;if((u|0)==(n|0)){l=39;break}}break}default:while(1){n=f[h>>2]|0;m=f[g>>2]|0;if(n>>>0>m>>>0){p=n;n=m;do{m=p-n|0;o=jWb(f[k>>2]|0,n,(m|0)<1073741824?m:1073741824)|0;if((o|0)<0){l=31;break a}n=(f[g>>2]|0)+o|0;f[g>>2]=n;p=f[h>>2]|0}while(p>>>0>n>>>0)}n=f[j>>2]|0;if(!n){p=f[d>>2]|0;f[j>>2]=p;o=f[i>>2]|0;f[h>>2]=o;f[g>>2]=o;v=p}else v=n;if((mnb(c,b)|0)==-2){l=37;break a}if((v|0)==(f[j>>2]|0)){l=39;break}}}while(0);if((l|0)==31){j=ZSb()|0;Fmb(a,-1,wTb(f[j>>2]|0)|0);e=-1;return e|0}else if((l|0)==37){Fmb(a,-2,445002);e=-1;return e|0}else if((l|0)==39){if((b|0)!=4){e=0;return e|0}lnb(c)|0;e=0;return e|0}return 0}function Pmb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(!a){c=-1;return c|0}if((f[a+12>>2]|0)!=31153){c=-1;return c|0}if(f[a+76>>2]|0){c=-1;return c|0}d=kUb(b)|0;e=Mmb(a,b,d)|0;c=(d|0)!=0&(e|0)==0?-1:e;return c|0}function Qmb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!a){b=-2;return b|0}if((f[a+12>>2]|0)!=31153){b=-2;return b|0}c=a+72|0;a:do if(!(f[c>>2]|0))d=0;else{f[c>>2]=0;e=f[a+68>>2]|0;g=a+88|0;if(!((f[g>>2]|0)!=0?(Omb(a,0)|0)==-1:0))h=6;b:do if((h|0)==6){if(!e){d=0;break a}i=a+24|0;j=a+32|0;k=a+84|0;l=a+8|0;m=e;n=0;while(1){o=f[i>>2]|0;p=(o|0)<0|(o|0)>(m|0)?m:o;if(!n)Nac(f[j>>2]|0,0,p|0)|0;f[g>>2]=p;f[k>>2]=f[j>>2];f[l>>2]=(f[l>>2]|0)+p;m=m-p|0;if((Omb(a,0)|0)==-1)break b;if(!m){d=0;break a}else n=1}}while(0);d=f[a+76>>2]|0}while(0);if((Omb(a,4)|0)==-1)q=f[a+76>>2]|0;else q=d;if(f[a+24>>2]|0){if(!(f[a+40>>2]|0)){enb(a+84|0)|0;PSb(f[a+36>>2]|0)}PSb(f[a+32>>2]|0)}Fmb(a,0,0);PSb(f[a+20>>2]|0);d=(eTb(f[a+16>>2]|0)|0)==-1;PSb(a);b=d?-1:q;return b|0}function Rmb(a){a=a|0;var b=0,c=0,d=0,e=0;if(!a){b=-2;return b|0}if(!(f[a+32>>2]|0)){b=-2;return b|0}if(!(f[a+36>>2]|0)){b=-2;return b|0}c=f[a+28>>2]|0;if(!c){b=-2;return b|0}if((f[c>>2]|0)!=(a|0)){b=-2;return b|0}d=c+4|0;if(((f[d>>2]|0)+-16180|0)>>>0>31){b=-2;return b|0}f[c+44>>2]=0;f[c+48>>2]=0;f[c+52>>2]=0;f[c+32>>2]=0;f[a+20>>2]=0;f[a+8>>2]=0;f[a+24>>2]=0;e=f[c+12>>2]|0;if(e|0)f[a+48>>2]=e&1;f[d>>2]=16180;f[c+8>>2]=0;f[c+16>>2]=0;f[c+24>>2]=32768;f[c+36>>2]=0;f[c+60>>2]=0;f[c+64>>2]=0;d=c+1332|0;f[c+112>>2]=d;f[c+84>>2]=d;f[c+80>>2]=d;f[c+7108>>2]=1;f[c+7112>>2]=-1;b=0;return b|0}function Smb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if(!a){c=-2;return c|0}d=a+32|0;if(!(f[d>>2]|0)){c=-2;return c|0}e=a+36|0;g=f[e>>2]|0;if(!g){c=-2;return c|0}h=a+28|0;i=f[h>>2]|0;if(!i){c=-2;return c|0}if((f[i>>2]|0)!=(a|0)){c=-2;return c|0}if(((f[i+4>>2]|0)+-16180|0)>>>0>31){c=-2;return c|0}if((b|0)<0){j=0;k=0-b|0}else{j=(b>>>4)+5|0;k=(b|0)<48?b&15:b}if(!((k|0)==0|(k&-8|0)==8)){c=-2;return c|0}b=i+56|0;l=f[b>>2]|0;m=i+40|0;if((l|0)!=0?(f[m>>2]|0)!=(k|0):0){zh[g&2047](f[a+40>>2]|0,l);f[b>>2]=0;b=f[d>>2]|0;f[i+12>>2]=j;f[m>>2]=k;if(!b){c=-2;return c|0}}else{f[i+12>>2]=j;f[m>>2]=k}if(!(f[e>>2]|0)){c=-2;return c|0}e=f[h>>2]|0;if(!e){c=-2;return c|0}if((f[e>>2]|0)!=(a|0)){c=-2;return c|0}h=e+4|0;if(((f[h>>2]|0)+-16180|0)>>>0>31){c=-2;return c|0}f[e+44>>2]=0;f[e+48>>2]=0;f[e+52>>2]=0;f[e+32>>2]=0;f[a+20>>2]=0;f[a+8>>2]=0;f[a+24>>2]=0;k=f[e+12>>2]|0;if(k|0)f[a+48>>2]=k&1;f[h>>2]=16180;f[e+8>>2]=0;f[e+16>>2]=0;f[e+24>>2]=32768;f[e+36>>2]=0;f[e+60>>2]=0;f[e+64>>2]=0;h=e+1332|0;f[e+112>>2]=h;f[e+84>>2]=h;f[e+80>>2]=h;f[e+7108>>2]=1;f[e+7112>>2]=-1;c=0;return c|0}function Tmb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;if(!d){g=-6;return g|0}if((e|0)!=56|(b[d>>0]|0)!=49){g=-6;return g|0}if(!a){g=-2;return g|0}f[a+24>>2]=0;d=a+32|0;e=f[d>>2]|0;if(!e){f[d>>2]=280;f[a+40>>2]=0;h=280}else h=e;e=a+36|0;if(!(f[e>>2]|0))f[e>>2]=1028;d=a+40|0;i=li[h&511](f[d>>2]|0,1,7120)|0;if(!i){g=-4;return g|0}h=a+28|0;f[h>>2]=i;f[i>>2]=a;f[i+56>>2]=0;f[i+4>>2]=16180;j=Smb(a,c)|0;if(!j){g=0;return g|0}zh[f[e>>2]&2047](f[d>>2]|0,i);f[h>>2]=0;g=j;return g|0}function Umb(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0;e=u;u=u+16|0;g=e;if(!a){i=-2;u=e;return i|0}if(!(f[a+32>>2]|0)){i=-2;u=e;return i|0}if(!(f[a+36>>2]|0)){i=-2;u=e;return i|0}k=f[a+28>>2]|0;if(!k){i=-2;u=e;return i|0}if((f[k>>2]|0)!=(a|0)){i=-2;u=e;return i|0}l=k+4|0;m=f[l>>2]|0;if((m+-16180|0)>>>0>31){i=-2;u=e;return i|0}n=a+12|0;o=f[n>>2]|0;if(!o){i=-2;u=e;return i|0}p=f[a>>2]|0;if((p|0)==0?f[a+4>>2]|0:0){i=-2;u=e;return i|0}if((m|0)==16191){f[l>>2]=16192;q=16192}else q=m;m=a+16|0;r=f[m>>2]|0;s=a+4|0;t=f[s>>2]|0;v=k+60|0;w=k+64|0;x=k+12|0;y=k+40|0;z=k+28|0;A=g+1|0;B=k+20|0;C=k+36|0;D=a+24|0;E=k+24|0;F=a+48|0;G=k+68|0;H=k+16|0;I=(c+-5|0)>>>0<2;J=k+8|0;K=k+80|0;L=k+88|0;M=k+84|0;N=k+92|0;O=(c|0)==6;P=k+7112|0;Q=k+76|0;R=k+7116|0;S=k+72|0;T=k+48|0;U=k+7108|0;V=k+52|0;W=k+56|0;X=k+44|0;Y=a+20|0;Z=k+32|0;_=g+2|0;$=g+3|0;aa=k+108|0;ba=k+100|0;ca=k+104|0;da=k+628|0;ea=k+1332|0;fa=k+112|0;ga=k+116|0;ha=k+756|0;ia=k+96|0;ja=0;ka=r;la=t;ma=p;p=r;r=f[w>>2]|0;na=f[v>>2]|0;oa=o;o=q;a:while(1){b:do switch(o|0){case 16208:{pa=r;qa=na;ra=la;sa=ma;ta=1;ua=ka;va=296;break a;break}case 16209:{wa=p;xa=r;ya=na;za=la;Aa=ma;Ba=-3;Ca=ka;break a;break}case 16210:{va=310;break a;break}case 16180:{q=f[x>>2]|0;if(!q){f[l>>2]=16192;Da=ja;Ea=ka;Fa=la;Ga=oa;Ha=ma;Ia=p;Ja=r;Ka=na;break b}if(r>>>0<16){La=la;Ma=ma;Na=r;Oa=na;while(1){if(!La){wa=p;xa=Na;ya=Oa;za=0;Aa=Ma;Ba=ja;Ca=ka;break a}Pa=La+-1|0;Qa=Ma+1|0;Ra=(h[Ma>>0]<<Na)+Oa|0;Sa=Na+8|0;if(Sa>>>0<16){La=Pa;Ma=Qa;Na=Sa;Oa=Ra}else{Ta=Pa;Ua=Qa;Va=Sa;Wa=Ra;break}}}else{Ta=la;Ua=ma;Va=r;Wa=na}if((Wa|0)==35615&(q&2|0)!=0){if(!(f[y>>2]|0))f[y>>2]=15;Oa=cnb(0,0,0)|0;f[z>>2]=Oa;b[g>>0]=31;b[A>>0]=-117;Na=cnb(Oa,g,2)|0;f[z>>2]=Na;f[l>>2]=16181;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=0;Ka=0;break b}f[B>>2]=0;Na=f[C>>2]|0;if(Na|0)f[Na+48>>2]=-1;if(q&1|0?((((Wa<<8&65280)+(Wa>>>8)|0)>>>0)%31|0|0)==0:0){if((Wa&15|0)!=8){f[D>>2]=445085;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=Va;Ka=Wa;break b}Na=Wa>>>4;Oa=Na&15;Ma=Oa+8|0;La=f[y>>2]|0;if(!La){f[y>>2]=Ma;Xa=Ma}else Xa=La;if(Ma>>>0>15|Ma>>>0>Xa>>>0){f[D>>2]=445112;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=Va+-4|0;Ka=Na;break b}else{f[E>>2]=256<<Oa;Oa=anb(0,0,0)|0;f[z>>2]=Oa;f[F>>2]=Oa;f[l>>2]=Wa>>>12&2^16191;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=0;Ka=0;break b}}f[D>>2]=445062;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ta;Ga=oa;Ha=Ua;Ia=p;Ja=Va;Ka=Wa;break}case 16181:{if(r>>>0<16){Oa=la;Na=ma;Ma=r;La=na;while(1){if(!Oa){wa=p;xa=Ma;ya=La;za=0;Aa=Na;Ba=ja;Ca=ka;break a}Ra=Oa+-1|0;Sa=Na+1|0;Qa=(h[Na>>0]<<Ma)+La|0;Pa=Ma+8|0;if(Pa>>>0<16){Oa=Ra;Na=Sa;Ma=Pa;La=Qa}else{Ya=Ra;Za=Sa;_a=Pa;$a=Qa;break}}}else{Ya=la;Za=ma;_a=r;$a=na}f[B>>2]=$a;if(($a&255|0)!=8){f[D>>2]=445085;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ya;Ga=oa;Ha=Za;Ia=p;Ja=_a;Ka=$a;break b}if($a&57344|0){f[D>>2]=445132;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Ya;Ga=oa;Ha=Za;Ia=p;Ja=_a;Ka=$a;break b}La=f[C>>2]|0;if(La|0)f[La>>2]=$a>>>8&1;if($a&512|0?f[x>>2]&4|0:0){b[g>>0]=$a;b[A>>0]=$a>>>8;La=cnb(f[z>>2]|0,g,2)|0;f[z>>2]=La}f[l>>2]=16182;ab=Ya;bb=Za;cb=0;db=0;va=55;break}case 16182:{if(r>>>0<32){ab=la;bb=ma;cb=r;db=na;va=55}else{eb=la;fb=ma;gb=na;va=57}break}case 16183:{if(r>>>0<16){hb=la;ib=ma;jb=r;kb=na;va=64}else{lb=la;mb=ma;nb=na;va=66}break}case 16184:{ob=la;pb=ma;qb=r;rb=na;va=72;break}case 16185:{sb=la;tb=ma;ub=r;vb=na;va=84;break}case 16186:{wb=la;xb=ma;yb=r;zb=na;va=95;break}case 16187:{Ab=r;Bb=na;Cb=la;Db=ma;va=109;break}case 16188:{Eb=r;Fb=na;Gb=la;Hb=ma;va=123;break}case 16189:{if(r>>>0<32){La=r;Ma=na;Na=la;Oa=ma;while(1){if(!Na){wa=p;xa=La;ya=Ma;za=0;Aa=Oa;Ba=ja;Ca=ka;break a}q=Na+-1|0;Qa=Oa+1|0;Pa=(h[Oa>>0]<<La)+Ma|0;La=La+8|0;if(La>>>0>=32){Ib=Pa;Jb=q;Kb=Qa;break}else{Ma=Pa;Na=q;Oa=Qa}}}else{Ib=na;Jb=la;Kb=ma}Oa=Zac(Ib|0)|0;f[z>>2]=Oa;f[F>>2]=Oa;f[l>>2]=16190;Lb=0;Mb=0;Nb=Jb;Ob=Kb;va=136;break}case 16190:{Lb=r;Mb=na;Nb=la;Ob=ma;va=136;break}case 16191:{Pb=r;Qb=na;Rb=la;Sb=ma;va=139;break}case 16192:{Tb=r;Ub=na;Vb=la;Wb=ma;va=140;break}case 16193:{Oa=r&7;Na=na>>>Oa;Ma=r-Oa|0;if(Ma>>>0<32){Oa=Ma;La=Na;Qa=la;q=ma;while(1){if(!Qa){wa=p;xa=Oa;ya=La;za=0;Aa=q;Ba=ja;Ca=ka;break a}Pa=Qa+-1|0;Sa=q+1|0;Ra=(h[q>>0]<<Oa)+La|0;Xb=Oa+8|0;if(Xb>>>0<32){Oa=Xb;La=Ra;Qa=Pa;q=Sa}else{Yb=Xb;Zb=Ra;_b=Pa;$b=Sa;break}}}else{Yb=Ma;Zb=Na;_b=la;$b=ma}q=Zb&65535;if((q|0)==(Zb>>>16^65535|0)){f[G>>2]=q;f[l>>2]=16194;if(O){pa=0;qa=0;ra=_b;sa=$b;ta=ja;ua=ka;va=296;break a}else{ac=0;bc=0;cc=_b;dc=$b;va=159;break b}}else{f[D>>2]=445196;f[l>>2]=16209;Da=ja;Ea=ka;Fa=_b;Ga=oa;Ha=$b;Ia=p;Ja=Yb;Ka=Zb;break b}break}case 16194:{ac=r;bc=na;cc=la;dc=ma;va=159;break}case 16195:{ec=r;fc=na;gc=la;hc=ma;va=160;break}case 16196:{if(r>>>0<14){q=r;Qa=na;La=la;Oa=ma;while(1){if(!La){wa=p;xa=q;ya=Qa;za=0;Aa=Oa;Ba=ja;Ca=ka;break a}Sa=La+-1|0;Pa=Oa+1|0;Ra=(h[Oa>>0]<<q)+Qa|0;Xb=q+8|0;if(Xb>>>0<14){q=Xb;Qa=Ra;La=Sa;Oa=Pa}else{ic=Xb;jc=Ra;kc=Sa;lc=Pa;break}}}else{ic=r;jc=na;kc=la;lc=ma}Oa=(jc&31)+257|0;f[ba>>2]=Oa;La=(jc>>>5&31)+1|0;f[ca>>2]=La;Qa=(jc>>>10&15)+4|0;f[ia>>2]=Qa;q=jc>>>14;Na=ic+-14|0;if(Oa>>>0>286|La>>>0>30){f[D>>2]=445225;f[l>>2]=16209;Da=ja;Ea=ka;Fa=kc;Ga=oa;Ha=lc;Ia=p;Ja=Na;Ka=q;break b}else{f[aa>>2]=0;f[l>>2]=16197;mc=Na;nc=q;oc=kc;pc=lc;qc=Qa;rc=0;va=170;break b}break}case 16197:{Qa=f[aa>>2]|0;q=f[ia>>2]|0;if(Qa>>>0<q>>>0){mc=r;nc=na;oc=la;pc=ma;qc=q;rc=Qa;va=170}else{sc=r;tc=na;uc=la;vc=ma;wc=Qa;va=171}break}case 16198:{xc=ja;yc=r;zc=na;Ac=la;Bc=ma;Cc=f[aa>>2]|0;va=181;break}case 16199:{Dc=ja;Ec=r;Fc=na;Gc=la;Hc=ma;va=214;break}case 16200:{Ic=ja;Jc=r;Kc=na;Lc=la;Mc=ma;va=215;break}case 16201:{Nc=r;Oc=na;Pc=ja;Qc=la;Rc=ma;Sc=f[Q>>2]|0;va=233;break}case 16202:{Tc=r;Uc=na;Vc=la;Wc=ma;Xc=ja;va=240;break}case 16203:{Yc=r;Zc=na;_c=la;$c=ma;ad=ja;bd=f[Q>>2]|0;va=252;break}case 16204:{cd=r;dd=na;ed=la;fd=ma;gd=ja;va=258;break}case 16205:{if(!ka){pa=r;qa=na;ra=la;sa=ma;ta=ja;ua=0;va=296;break a}b[oa>>0]=f[G>>2];f[l>>2]=16200;Da=ja;Ea=ka+-1|0;Fa=la;Ga=oa+1|0;Ha=ma;Ia=p;Ja=r;Ka=na;break}case 16206:{Qa=f[x>>2]|0;if(Qa){if(r>>>0<32){q=na;Na=r;La=la;Oa=ma;while(1){if(!La){wa=p;xa=Na;ya=q;za=0;Aa=Oa;Ba=ja;Ca=ka;break a}Ma=La+-1|0;Pa=Oa+1|0;Sa=(h[Oa>>0]<<Na)+q|0;Ra=Na+8|0;if(Ra>>>0<32){q=Sa;Na=Ra;La=Ma;Oa=Pa}else{hd=Ra;id=Sa;jd=Ma;kd=Pa;break}}}else{hd=r;id=na;jd=la;kd=ma}Oa=p-ka|0;f[Y>>2]=(f[Y>>2]|0)+Oa;f[Z>>2]=(f[Z>>2]|0)+Oa;if((Oa|0)!=0&(Qa&4|0)!=0){La=f[z>>2]|0;Na=oa+(0-Oa)|0;if(!(f[B>>2]|0))ld=anb(La,Na,Oa)|0;else ld=cnb(La,Na,Oa)|0;f[z>>2]=ld;f[F>>2]=ld;md=f[x>>2]|0}else md=Qa;if((md&4|0)!=0?(Oa=(f[B>>2]|0)==0,Na=Zac(id|0)|0,((Oa?Na:id)|0)!=(f[z>>2]|0)):0){f[D>>2]=445399;f[l>>2]=16209;Da=ja;Ea=ka;Fa=jd;Ga=oa;Ha=kd;Ia=ka;Ja=hd;Ka=id;break b}else{nd=ka;od=0;pd=0;qd=jd;rd=kd;sd=md}}else{nd=p;od=r;pd=na;qd=la;rd=ma;sd=0}f[l>>2]=16207;td=nd;ud=od;vd=pd;wd=qd;xd=rd;yd=sd;va=288;break}case 16207:{td=p;ud=r;vd=na;wd=la;xd=ma;yd=f[x>>2]|0;va=288;break}default:{i=-2;va=311;break a}}while(0);if((va|0)==55)while(1){va=0;if(!ab){wa=p;xa=cb;ya=db;za=0;Aa=bb;Ba=ja;Ca=ka;break a}Na=ab+-1|0;Oa=bb+1|0;La=(h[bb>>0]<<cb)+db|0;cb=cb+8|0;if(cb>>>0>=32){eb=Na;fb=Oa;gb=La;va=57;break}else{ab=Na;bb=Oa;db=La;va=55}}else if((va|0)==136){va=0;if(!(f[H>>2]|0)){va=137;break}La=anb(0,0,0)|0;f[z>>2]=La;f[F>>2]=La;f[l>>2]=16191;Pb=Lb;Qb=Mb;Rb=Nb;Sb=Ob;va=139}else if((va|0)==159){va=0;f[l>>2]=16195;ec=ac;fc=bc;gc=cc;hc=dc;va=160}else if((va|0)==170){va=0;La=mc;Oa=nc;Na=oc;q=pc;Pa=rc;while(1){if(La>>>0<3){if(!Na){wa=p;xa=La;ya=Oa;za=0;Aa=q;Ba=ja;Ca=ka;break a}zd=La+8|0;Ad=(h[q>>0]<<La)+Oa|0;Bd=Na+-1|0;Cd=q+1|0}else{zd=La;Ad=Oa;Bd=Na;Cd=q}Ma=Pa+1|0;f[aa>>2]=Ma;d[k+116+(j[151852+(Pa<<1)>>1]<<1)>>1]=Ad&7;Sa=Ad>>>3;Ra=zd+-3|0;if(Ma>>>0<qc>>>0){La=Ra;Oa=Sa;Na=Bd;q=Cd;Pa=Ma}else{sc=Ra;tc=Sa;uc=Bd;vc=Cd;wc=Ma;va=171;break}}}else if((va|0)==288){va=0;if(!yd){Dd=ud;Ed=vd;Fd=wd;Gd=xd;va=295;break}if(!(f[B>>2]|0)){Dd=ud;Ed=vd;Fd=wd;Gd=xd;va=295;break}if(ud>>>0<32){Pa=vd;q=ud;Na=xd;Oa=wd;while(1){if(!Oa){wa=td;xa=q;ya=Pa;za=0;Aa=Na;Ba=ja;Ca=ka;break a}La=Oa+-1|0;Ma=Na+1|0;Sa=(h[Na>>0]<<q)+Pa|0;Ra=q+8|0;if(Ra>>>0<32){Pa=Sa;q=Ra;Na=Ma;Oa=La}else{Hd=Ra;Id=Sa;Jd=La;Kd=Ma;break}}}else{Hd=ud;Id=vd;Jd=wd;Kd=xd}if((Id|0)==(f[Z>>2]|0)){Dd=0;Ed=0;Fd=Jd;Gd=Kd;va=295;break}f[D>>2]=445420;f[l>>2]=16209;Da=ja;Ea=ka;Fa=Jd;Ga=oa;Ha=Kd;Ia=td;Ja=Hd;Ka=Id}do if((va|0)==57){va=0;Oa=f[C>>2]|0;if(Oa|0)f[Oa+4>>2]=gb;if(f[B>>2]&512|0?f[x>>2]&4|0:0){b[g>>0]=gb;b[A>>0]=gb>>>8;b[_>>0]=gb>>>16;b[$>>0]=gb>>>24;Oa=cnb(f[z>>2]|0,g,4)|0;f[z>>2]=Oa}f[l>>2]=16183;hb=eb;ib=fb;jb=0;kb=0;va=64}else if((va|0)==139){va=0;if(I){pa=Pb;qa=Qb;ra=Rb;sa=Sb;ta=ja;ua=ka;va=296;break a}else{Tb=Pb;Ub=Qb;Vb=Rb;Wb=Sb;va=140}}else if((va|0)==160){va=0;Oa=f[G>>2]|0;if(!Oa){f[l>>2]=16191;Da=ja;Ea=ka;Fa=gc;Ga=oa;Ha=hc;Ia=p;Ja=ec;Ka=fc;break}Na=Oa>>>0>gc>>>0?gc:Oa;Oa=Na>>>0>ka>>>0?ka:Na;if(!Oa){pa=ec;qa=fc;ra=gc;sa=hc;ta=ja;ua=ka;va=296;break a}Vac(oa|0,hc|0,Oa|0)|0;f[G>>2]=(f[G>>2]|0)-Oa;Da=ja;Ea=ka-Oa|0;Fa=gc-Oa|0;Ga=oa+Oa|0;Ha=hc+Oa|0;Ia=p;Ja=ec;Ka=fc}else if((va|0)==171){va=0;if(wc>>>0<19){Oa=wc;do{d[k+116+(j[151852+(Oa<<1)>>1]<<1)>>1]=0;Oa=Oa+1|0}while((Oa|0)!=19);f[aa>>2]=19}f[fa>>2]=ea;f[K>>2]=ea;f[L>>2]=7;Oa=Xmb(0,ga,19,fa,L,ha)|0;if(!Oa){f[aa>>2]=0;f[l>>2]=16198;xc=0;yc=sc;zc=tc;Ac=uc;Bc=vc;Cc=0;va=181;break}else{f[D>>2]=445261;f[l>>2]=16209;Da=Oa;Ea=ka;Fa=uc;Ga=oa;Ha=vc;Ia=p;Ja=sc;Ka=tc;break}}while(0);c:do if((va|0)==64)while(1){va=0;if(!hb){wa=p;xa=jb;ya=kb;za=0;Aa=ib;Ba=ja;Ca=ka;break a}Oa=hb+-1|0;Qa=ib+1|0;Na=(h[ib>>0]<<jb)+kb|0;jb=jb+8|0;if(jb>>>0>=16){lb=Oa;mb=Qa;nb=Na;va=66;break}else{hb=Oa;ib=Qa;kb=Na;va=64}}else if((va|0)==140){va=0;if(f[J>>2]|0){Na=Tb&7;f[l>>2]=16206;Da=ja;Ea=ka;Fa=Vb;Ga=oa;Ha=Wb;Ia=p;Ja=Tb-Na|0;Ka=Ub>>>Na;break}if(Tb>>>0<3){if(!Vb){pa=Tb;qa=Ub;ra=0;sa=Wb;ta=ja;ua=ka;va=296;break a}Ld=Tb+8|0;Md=(h[Wb>>0]<<Tb)+Ub|0;Nd=Vb+-1|0;Od=Wb+1|0}else{Ld=Tb;Md=Ub;Nd=Vb;Od=Wb}f[J>>2]=Md&1;switch(Md>>>1&3){case 0:{Pd=16193;va=151;break}case 1:{f[K>>2]=149676;f[L>>2]=9;f[M>>2]=151724;f[N>>2]=5;f[l>>2]=16199;if(O){va=147;break a}break}case 2:{Pd=16196;va=151;break}case 3:{f[D>>2]=445177;Pd=16209;va=151;break}default:{va=150;break a}}if((va|0)==151){va=0;f[l>>2]=Pd}Da=ja;Ea=ka;Fa=Nd;Ga=oa;Ha=Od;Ia=p;Ja=Ld+-3|0;Ka=Md>>>3}else if((va|0)==181){va=0;Na=f[ba>>2]|0;Qa=f[ca>>2]|0;do if(Cc>>>0<(Qa+Na|0)>>>0){Oa=yc;q=zc;Pa=Ac;Ma=Bc;La=Cc;Sa=Na;Ra=Qa;d:while(1){Xb=f[K>>2]|0;Qd=(1<<f[L>>2])+-1|0;Rd=Qd&q;Sd=h[Xb+(Rd<<2)+1>>0]|0;if(Oa>>>0<Sd>>>0){Td=Oa;Ud=q;Vd=Pa;Wd=Ma;while(1){if(!Vd){wa=p;xa=Td;ya=Ud;za=0;Aa=Wd;Ba=xc;Ca=ka;break a}Xd=Vd+-1|0;Yd=Wd+1|0;Zd=(h[Wd>>0]<<Td)+Ud|0;_d=Td+8|0;$d=Qd&Zd;ae=h[Xb+($d<<2)+1>>0]|0;if(_d>>>0<ae>>>0){Td=_d;Ud=Zd;Vd=Xd;Wd=Yd}else{be=_d;ce=Zd;de=Xd;ee=Yd;fe=ae;ge=$d;break}}}else{be=Oa;ce=q;de=Pa;ee=Ma;fe=Sd;ge=Rd}Wd=d[Xb+(ge<<2)+2>>1]|0;if((Wd&65535)>=16){switch(Wd<<16>>16){case 16:{Vd=fe+2|0;if(be>>>0<Vd>>>0){Ud=be;Td=ce;Qd=de;$d=ee;while(1){if(!Qd){wa=p;xa=Ud;ya=Td;za=0;Aa=$d;Ba=xc;Ca=ka;break a}ae=Qd+-1|0;Yd=$d+1|0;Xd=(h[$d>>0]<<Ud)+Td|0;Zd=Ud+8|0;if(Zd>>>0<Vd>>>0){Ud=Zd;Td=Xd;Qd=ae;$d=Yd}else{he=Zd;ie=Xd;je=ae;ke=Yd;break}}}else{he=be;ie=ce;je=de;ke=ee}$d=ie>>>fe;Qd=he-fe|0;if(!La){le=Qd;me=$d;ne=je;oe=ke;va=205;break d}pe=j[k+116+(La+-1<<1)>>1]|0;qe=Qd+-2|0;re=$d>>>2;se=je;te=ke;ue=($d&3)+3|0;break}case 17:{$d=fe+3|0;if(be>>>0<$d>>>0){Qd=be;Td=ce;Ud=de;Vd=ee;while(1){if(!Ud){wa=p;xa=Qd;ya=Td;za=0;Aa=Vd;Ba=xc;Ca=ka;break a}Xb=Ud+-1|0;Rd=Vd+1|0;Sd=(h[Vd>>0]<<Qd)+Td|0;Yd=Qd+8|0;if(Yd>>>0<$d>>>0){Qd=Yd;Td=Sd;Ud=Xb;Vd=Rd}else{ve=Yd;we=Sd;xe=Xb;ye=Rd;break}}}else{ve=be;we=ce;xe=de;ye=ee}Vd=we>>>fe;pe=0;qe=-3-fe+ve|0;re=Vd>>>3;se=xe;te=ye;ue=(Vd&7)+3|0;break}default:{Vd=fe+7|0;if(be>>>0<Vd>>>0){Ud=be;Td=ce;Qd=de;$d=ee;while(1){if(!Qd){wa=p;xa=Ud;ya=Td;za=0;Aa=$d;Ba=xc;Ca=ka;break a}Rd=Qd+-1|0;Xb=$d+1|0;Sd=(h[$d>>0]<<Ud)+Td|0;Yd=Ud+8|0;if(Yd>>>0<Vd>>>0){Ud=Yd;Td=Sd;Qd=Rd;$d=Xb}else{ze=Yd;Ae=Sd;Be=Rd;Ce=Xb;break}}}else{ze=be;Ae=ce;Be=de;Ce=ee}$d=Ae>>>fe;pe=0;qe=-7-fe+ze|0;re=$d>>>7;se=Be;te=Ce;ue=($d&127)+11|0}}if((La+ue|0)>>>0>(Ra+Sa|0)>>>0){le=qe;me=re;ne=se;oe=te;va=205;break}$d=pe&65535;Qd=ue+-1|0;f[aa>>2]=La+1;d[k+116+(La<<1)>>1]=$d;if(!Qd){De=qe;Ee=re;Fe=se;Ge=te}else{Td=Qd;do{Qd=f[aa>>2]|0;Td=Td+-1|0;f[aa>>2]=Qd+1;d[k+116+(Qd<<1)>>1]=$d}while((Td|0)!=0);De=qe;Ee=re;Fe=se;Ge=te}}else{f[aa>>2]=La+1;d[k+116+(La<<1)>>1]=Wd;De=be-fe|0;Ee=ce>>>fe;Fe=de;Ge=ee}La=f[aa>>2]|0;Sa=f[ba>>2]|0;Ra=f[ca>>2]|0;if(La>>>0>=(Ra+Sa|0)>>>0){va=206;break}else{Oa=De;q=Ee;Pa=Fe;Ma=Ge}}if((va|0)==205){va=0;f[D>>2]=445286;f[l>>2]=16209;Da=xc;Ea=ka;Fa=ne;Ga=oa;Ha=oe;Ia=p;Ja=le;Ka=me;break c}else if((va|0)==206){va=0;if((f[l>>2]|0)==16209){Da=xc;Ea=ka;Fa=Fe;Ga=oa;Ha=Ge;Ia=p;Ja=De;Ka=Ee;break c}else{He=De;Ie=Ee;Je=Fe;Ke=Ge;Le=Sa;break}}}else{He=yc;Ie=zc;Je=Ac;Ke=Bc;Le=Na}while(0);if(!(d[da>>1]|0)){f[D>>2]=445312;f[l>>2]=16209;Da=xc;Ea=ka;Fa=Je;Ga=oa;Ha=Ke;Ia=p;Ja=He;Ka=Ie;break}f[fa>>2]=ea;f[K>>2]=ea;f[L>>2]=9;Na=Xmb(1,ga,Le,fa,L,ha)|0;if(Na|0){f[D>>2]=445349;f[l>>2]=16209;Da=Na;Ea=ka;Fa=Je;Ga=oa;Ha=Ke;Ia=p;Ja=He;Ka=Ie;break}f[M>>2]=f[fa>>2];f[N>>2]=6;Na=Xmb(2,k+116+(f[ba>>2]<<1)|0,f[ca>>2]|0,fa,N,ha)|0;if(!Na){f[l>>2]=16199;if(O){pa=He;qa=Ie;ra=Je;sa=Ke;ta=0;ua=ka;va=296;break a}else{Dc=0;Ec=He;Fc=Ie;Gc=Je;Hc=Ke;va=214;break}}else{f[D>>2]=445377;f[l>>2]=16209;Da=Na;Ea=ka;Fa=Je;Ga=oa;Ha=Ke;Ia=p;Ja=He;Ka=Ie;break}}while(0);if((va|0)==66){va=0;Na=f[C>>2]|0;if(Na|0){f[Na+8>>2]=nb&255;f[Na+12>>2]=nb>>>8}if(f[B>>2]&512|0?f[x>>2]&4|0:0){b[g>>0]=nb;b[A>>0]=nb>>>8;Na=cnb(f[z>>2]|0,g,2)|0;f[z>>2]=Na}f[l>>2]=16184;ob=lb;pb=mb;qb=0;rb=0;va=72}else if((va|0)==214){va=0;f[l>>2]=16200;Ic=Dc;Jc=Ec;Kc=Fc;Lc=Gc;Mc=Hc;va=215}do if((va|0)==72){va=0;Na=f[B>>2]|0;if(!(Na&1024)){Qa=f[C>>2]|0;if(!Qa){Me=ob;Ne=pb;Oe=qb;Pe=rb}else{f[Qa+16>>2]=0;Me=ob;Ne=pb;Oe=qb;Pe=rb}}else{if(qb>>>0<16){Qa=ob;Ma=pb;Pa=qb;q=rb;while(1){if(!Qa){wa=p;xa=Pa;ya=q;za=0;Aa=Ma;Ba=ja;Ca=ka;break a}Oa=Qa+-1|0;Ra=Ma+1|0;La=(h[Ma>>0]<<Pa)+q|0;Pa=Pa+8|0;if(Pa>>>0>=16){Qe=Oa;Re=Ra;Se=La;break}else{Qa=Oa;Ma=Ra;q=La}}}else{Qe=ob;Re=pb;Se=rb}f[G>>2]=Se;q=f[C>>2]|0;if(q|0)f[q+20>>2]=Se;if((Na&512|0)!=0?(f[x>>2]&4|0)!=0:0){b[g>>0]=Se;b[A>>0]=Se>>>8;q=cnb(f[z>>2]|0,g,2)|0;f[z>>2]=q;Me=Qe;Ne=Re;Oe=0;Pe=0}else{Me=Qe;Ne=Re;Oe=0;Pe=0}}f[l>>2]=16185;sb=Me;tb=Ne;ub=Oe;vb=Pe;va=84}else if((va|0)==215){va=0;if(ka>>>0>257&Lc>>>0>5){f[n>>2]=oa;f[m>>2]=ka;f[a>>2]=Mc;f[s>>2]=Lc;f[v>>2]=Kc;f[w>>2]=Jc;Ymb(a,p);q=f[n>>2]|0;Ma=f[m>>2]|0;Qa=f[a>>2]|0;Pa=f[s>>2]|0;La=f[v>>2]|0;Ra=f[w>>2]|0;if((f[l>>2]|0)!=16191){Da=Ic;Ea=Ma;Fa=Pa;Ga=q;Ha=Qa;Ia=p;Ja=Ra;Ka=La;break}f[P>>2]=-1;Da=Ic;Ea=Ma;Fa=Pa;Ga=q;Ha=Qa;Ia=p;Ja=Ra;Ka=La;break}f[P>>2]=0;La=f[K>>2]|0;Ra=(1<<f[L>>2])+-1|0;Qa=Ra&Kc;q=b[La+(Qa<<2)+1>>0]|0;Pa=q&255;if(Pa>>>0>Jc>>>0){Ma=Jc;Oa=Kc;Td=Lc;$d=Mc;while(1){if(!Td){wa=p;xa=Ma;ya=Oa;za=0;Aa=$d;Ba=Ic;Ca=ka;break a}Qd=Td+-1|0;Ud=$d+1|0;Vd=(h[$d>>0]<<Ma)+Oa|0;Xb=Ma+8|0;Rd=Ra&Vd;Sd=b[La+(Rd<<2)+1>>0]|0;Yd=Sd&255;if(Yd>>>0>Xb>>>0){Ma=Xb;Oa=Vd;Td=Qd;$d=Ud}else{Te=Xb;Ue=Vd;Ve=Qd;We=Ud;Xe=Yd;Ye=Rd;Ze=Sd;break}}}else{Te=Jc;Ue=Kc;Ve=Lc;We=Mc;Xe=Pa;Ye=Qa;Ze=q}$d=d[La+(Ye<<2)+2>>1]|0;Td=b[La+(Ye<<2)>>0]|0;Oa=Td&255;if(Td<<24>>24!=0&(Oa&240|0)==0){Ma=$d&65535;Ra=(1<<Xe+Oa)+-1|0;Oa=((Ue&Ra)>>>Xe)+Ma|0;Na=b[La+(Oa<<2)+1>>0]|0;if(((Na&255)+Xe|0)>>>0>Te>>>0){Sd=Te;Rd=Ue;Yd=Ve;Ud=We;while(1){if(!Yd){wa=p;xa=Sd;ya=Rd;za=0;Aa=Ud;Ba=Ic;Ca=ka;break a}Qd=Yd+-1|0;Vd=Ud+1|0;Xb=(h[Ud>>0]<<Sd)+Rd|0;ae=Sd+8|0;Xd=((Xb&Ra)>>>Xe)+Ma|0;Zd=b[La+(Xd<<2)+1>>0]|0;if(((Zd&255)+Xe|0)>>>0>ae>>>0){Sd=ae;Rd=Xb;Yd=Qd;Ud=Vd}else{_e=ae;$e=Xb;af=Qd;bf=Vd;cf=Xd;df=Zd;break}}}else{_e=Te;$e=Ue;af=Ve;bf=We;cf=Oa;df=Na}Ud=d[La+(cf<<2)+2>>1]|0;Yd=b[La+(cf<<2)>>0]|0;f[P>>2]=Xe;ef=_e-Xe|0;ff=$e>>>Xe;gf=af;hf=bf;jf=Yd;kf=df;lf=Ud;mf=Xe}else{ef=Te;ff=Ue;gf=Ve;hf=We;jf=Td;kf=Ze;lf=$d;mf=0}Ud=kf&255;Yd=ff>>>Ud;Rd=ef-Ud|0;f[P>>2]=mf+Ud;f[G>>2]=lf&65535;Ud=jf&255;if(!(jf<<24>>24)){f[l>>2]=16205;Da=Ic;Ea=ka;Fa=gf;Ga=oa;Ha=hf;Ia=p;Ja=Rd;Ka=Yd;break}if(Ud&32|0){f[P>>2]=-1;f[l>>2]=16191;Da=Ic;Ea=ka;Fa=gf;Ga=oa;Ha=hf;Ia=p;Ja=Rd;Ka=Yd;break}if(!(Ud&64)){Sd=Ud&15;f[Q>>2]=Sd;f[l>>2]=16201;Nc=Rd;Oc=Yd;Pc=Ic;Qc=gf;Rc=hf;Sc=Sd;va=233;break}else{f[D>>2]=445443;f[l>>2]=16209;Da=Ic;Ea=ka;Fa=gf;Ga=oa;Ha=hf;Ia=p;Ja=Rd;Ka=Yd;break}}while(0);if((va|0)==84){va=0;Yd=f[B>>2]|0;if(Yd&1024){Rd=f[G>>2]|0;Sd=Rd>>>0>sb>>>0?sb:Rd;if(!Sd){nf=sb;of=tb;pf=Rd}else{Ud=f[C>>2]|0;if((Ud|0)!=0?(Ma=f[Ud+16>>2]|0,(Ma|0)!=0):0){Ra=(f[Ud+20>>2]|0)-Rd|0;Rd=f[Ud+24>>2]|0;Vac(Ma+Ra|0,tb|0,((Ra+Sd|0)>>>0>Rd>>>0?Rd-Ra|0:Sd)|0)|0;qf=f[B>>2]|0}else qf=Yd;if(qf&512|0?f[x>>2]&4|0:0){Yd=cnb(f[z>>2]|0,tb,Sd)|0;f[z>>2]=Yd}Yd=(f[G>>2]|0)-Sd|0;f[G>>2]=Yd;nf=sb-Sd|0;of=tb+Sd|0;pf=Yd}if(!pf){rf=nf;sf=of}else{pa=ub;qa=vb;ra=nf;sa=of;ta=ja;ua=ka;va=296;break}}else{rf=sb;sf=tb}f[G>>2]=0;f[l>>2]=16186;wb=rf;xb=sf;yb=ub;zb=vb;va=95}else if((va|0)==233){va=0;if(!Sc){tf=Nc;uf=Oc;vf=Qc;wf=Rc;xf=f[G>>2]|0}else{if(Nc>>>0<Sc>>>0){Yd=Nc;Sd=Oc;Ra=Qc;Rd=Rc;while(1){if(!Ra){wa=p;xa=Yd;ya=Sd;za=0;Aa=Rd;Ba=Pc;Ca=ka;break a}Ma=Ra+-1|0;Ud=Rd+1|0;q=(h[Rd>>0]<<Yd)+Sd|0;Qa=Yd+8|0;if(Qa>>>0<Sc>>>0){Yd=Qa;Sd=q;Ra=Ma;Rd=Ud}else{yf=Qa;zf=q;Af=Ma;Bf=Ud;break}}}else{yf=Nc;zf=Oc;Af=Qc;Bf=Rc}Rd=(f[G>>2]|0)+(zf&(1<<Sc)+-1)|0;f[G>>2]=Rd;f[P>>2]=(f[P>>2]|0)+Sc;tf=yf-Sc|0;uf=zf>>>Sc;vf=Af;wf=Bf;xf=Rd}f[R>>2]=xf;f[l>>2]=16202;Tc=tf;Uc=uf;Vc=vf;Wc=wf;Xc=Pc;va=240}do if((va|0)==95){va=0;if(!(f[B>>2]&2048)){Rd=f[C>>2]|0;if(!Rd){Cf=wb;Df=xb}else{f[Rd+28>>2]=0;Cf=wb;Df=xb}}else{if(!wb){pa=yb;qa=zb;ra=0;sa=xb;ta=ja;ua=ka;va=296;break a}else Ef=0;do{Rd=Ef;Ef=Ef+1|0;Ra=b[xb+Rd>>0]|0;Rd=f[C>>2]|0;if((Rd|0?(Sd=f[Rd+28>>2]|0,Sd|0):0)?(Yd=f[G>>2]|0,Yd>>>0<(f[Rd+32>>2]|0)>>>0):0){f[G>>2]=Yd+1;b[Sd+Yd>>0]=Ra}Ff=Ra<<24>>24!=0}while(Ff&wb>>>0>Ef>>>0);if(f[B>>2]&512|0?f[x>>2]&4|0:0){$d=cnb(f[z>>2]|0,xb,Ef)|0;f[z>>2]=$d}$d=wb-Ef|0;Td=xb+Ef|0;if(Ff){pa=yb;qa=zb;ra=$d;sa=Td;ta=ja;ua=ka;va=296;break a}else{Cf=$d;Df=Td}}f[G>>2]=0;f[l>>2]=16187;Ab=yb;Bb=zb;Cb=Cf;Db=Df;va=109}else if((va|0)==240){va=0;Td=f[M>>2]|0;$d=(1<<f[N>>2])+-1|0;La=$d&Uc;Na=b[Td+(La<<2)+1>>0]|0;Oa=Na&255;if(Oa>>>0>Tc>>>0){Ra=Tc;Yd=Uc;Sd=Vc;Rd=Wc;while(1){if(!Sd){wa=p;xa=Ra;ya=Yd;za=0;Aa=Rd;Ba=Xc;Ca=ka;break a}Ud=Sd+-1|0;Ma=Rd+1|0;q=(h[Rd>>0]<<Ra)+Yd|0;Qa=Ra+8|0;Pa=$d&q;Zd=b[Td+(Pa<<2)+1>>0]|0;Xd=Zd&255;if(Xd>>>0>Qa>>>0){Ra=Qa;Yd=q;Sd=Ud;Rd=Ma}else{Gf=Qa;Hf=q;If=Ud;Jf=Ma;Kf=Xd;Lf=Pa;Mf=Zd;break}}}else{Gf=Tc;Hf=Uc;If=Vc;Jf=Wc;Kf=Oa;Lf=La;Mf=Na}Rd=d[Td+(Lf<<2)+2>>1]|0;Sd=b[Td+(Lf<<2)>>0]|0;Yd=Sd&255;if(!(Yd&240)){Ra=Rd&65535;$d=(1<<Kf+Yd)+-1|0;Yd=((Hf&$d)>>>Kf)+Ra|0;Zd=b[Td+(Yd<<2)+1>>0]|0;if(((Zd&255)+Kf|0)>>>0>Gf>>>0){Pa=Gf;Xd=Hf;Ma=If;Ud=Jf;while(1){if(!Ma){wa=p;xa=Pa;ya=Xd;za=0;Aa=Ud;Ba=Xc;Ca=ka;break a}q=Ma+-1|0;Qa=Ud+1|0;Vd=(h[Ud>>0]<<Pa)+Xd|0;Qd=Pa+8|0;Xb=((Vd&$d)>>>Kf)+Ra|0;ae=b[Td+(Xb<<2)+1>>0]|0;if(((ae&255)+Kf|0)>>>0>Qd>>>0){Pa=Qd;Xd=Vd;Ma=q;Ud=Qa}else{Nf=Qd;Of=Vd;Pf=q;Qf=Qa;Rf=Xb;Sf=ae;break}}}else{Nf=Gf;Of=Hf;Pf=If;Qf=Jf;Rf=Yd;Sf=Zd}Ud=d[Td+(Rf<<2)+2>>1]|0;Ma=b[Td+(Rf<<2)>>0]|0;Xd=(f[P>>2]|0)+Kf|0;f[P>>2]=Xd;Tf=Nf-Kf|0;Uf=Of>>>Kf;Vf=Pf;Wf=Qf;Xf=Ma;Yf=Sf;Zf=Ud;_f=Xd}else{Tf=Gf;Uf=Hf;Vf=If;Wf=Jf;Xf=Sd;Yf=Mf;Zf=Rd;_f=f[P>>2]|0}Xd=Yf&255;Ud=Uf>>>Xd;Ma=Tf-Xd|0;f[P>>2]=_f+Xd;Xd=Xf&255;if(!(Xd&64)){f[S>>2]=Zf&65535;Pa=Xd&15;f[Q>>2]=Pa;f[l>>2]=16203;Yc=Ma;Zc=Ud;_c=Vf;$c=Wf;ad=Xc;bd=Pa;va=252;break}else{f[D>>2]=445471;f[l>>2]=16209;Da=Xc;Ea=ka;Fa=Vf;Ga=oa;Ha=Wf;Ia=p;Ja=Ma;Ka=Ud;break}}while(0);if((va|0)==109){va=0;if(!(f[B>>2]&4096)){Ud=f[C>>2]|0;if(!Ud){$f=Cb;ag=Db}else{f[Ud+36>>2]=0;$f=Cb;ag=Db}}else{if(!Cb){pa=Ab;qa=Bb;ra=0;sa=Db;ta=ja;ua=ka;va=296;break}else bg=0;do{Ud=bg;bg=bg+1|0;Ma=b[Db+Ud>>0]|0;Ud=f[C>>2]|0;if((Ud|0?(Pa=f[Ud+36>>2]|0,Pa|0):0)?(Xd=f[G>>2]|0,Xd>>>0<(f[Ud+40>>2]|0)>>>0):0){f[G>>2]=Xd+1;b[Pa+Xd>>0]=Ma}cg=Ma<<24>>24!=0}while(cg&Cb>>>0>bg>>>0);if(f[B>>2]&512|0?f[x>>2]&4|0:0){Ma=cnb(f[z>>2]|0,Db,bg)|0;f[z>>2]=Ma}Ma=Cb-bg|0;Xd=Db+bg|0;if(cg){pa=Ab;qa=Bb;ra=Ma;sa=Xd;ta=ja;ua=ka;va=296;break}else{$f=Ma;ag=Xd}}f[l>>2]=16188;Eb=Ab;Fb=Bb;Gb=$f;Hb=ag;va=123}else if((va|0)==252){va=0;if(!bd){dg=Yc;eg=Zc;fg=_c;gg=$c}else{if(Yc>>>0<bd>>>0){Xd=Yc;Ma=Zc;Pa=_c;Ud=$c;while(1){if(!Pa){wa=p;xa=Xd;ya=Ma;za=0;Aa=Ud;Ba=ad;Ca=ka;break a}Ra=Pa+-1|0;$d=Ud+1|0;Na=(h[Ud>>0]<<Xd)+Ma|0;La=Xd+8|0;if(La>>>0<bd>>>0){Xd=La;Ma=Na;Pa=Ra;Ud=$d}else{hg=La;ig=Na;jg=Ra;kg=$d;break}}}else{hg=Yc;ig=Zc;jg=_c;kg=$c}f[S>>2]=(f[S>>2]|0)+(ig&(1<<bd)+-1);f[P>>2]=(f[P>>2]|0)+bd;dg=hg-bd|0;eg=ig>>>bd;fg=jg;gg=kg}f[l>>2]=16204;cd=dg;dd=eg;ed=fg;fd=gg;gd=ad;va=258}do if((va|0)==123){va=0;Ud=f[B>>2]|0;if(Ud&512){if(Eb>>>0<16){Pa=Eb;Ma=Fb;Xd=Gb;$d=Hb;while(1){if(!Xd){wa=p;xa=Pa;ya=Ma;za=0;Aa=$d;Ba=ja;Ca=ka;break a}Ra=Xd+-1|0;Na=$d+1|0;La=(h[$d>>0]<<Pa)+Ma|0;Oa=Pa+8|0;if(Oa>>>0<16){Pa=Oa;Ma=La;Xd=Ra;$d=Na}else{lg=Oa;mg=La;ng=Ra;og=Na;break}}}else{lg=Eb;mg=Fb;ng=Gb;og=Hb}if((f[x>>2]&4|0)!=0?(mg|0)!=(f[z>>2]&65535|0):0){f[D>>2]=445157;f[l>>2]=16209;Da=ja;Ea=ka;Fa=ng;Ga=oa;Ha=og;Ia=p;Ja=lg;Ka=mg;break}else{pg=0;qg=0;rg=ng;sg=og}}else{pg=Eb;qg=Fb;rg=Gb;sg=Hb}$d=f[C>>2]|0;if($d|0){f[$d+44>>2]=Ud>>>9&1;f[$d+48>>2]=1}$d=cnb(0,0,0)|0;f[z>>2]=$d;f[F>>2]=$d;f[l>>2]=16191;Da=ja;Ea=ka;Fa=rg;Ga=oa;Ha=sg;Ia=p;Ja=pg;Ka=qg}else if((va|0)==258){va=0;if(!ka){pa=cd;qa=dd;ra=ed;sa=fd;ta=gd;ua=0;va=296;break a}$d=p-ka|0;Xd=f[S>>2]|0;if(Xd>>>0>$d>>>0){Ma=Xd-$d|0;if(Ma>>>0>(f[T>>2]|0)>>>0?f[U>>2]|0:0){f[D>>2]=445493;f[l>>2]=16209;Da=gd;Ea=ka;Fa=ed;Ga=oa;Ha=fd;Ia=p;Ja=cd;Ka=dd;break}$d=f[V>>2]|0;if(Ma>>>0>$d>>>0){Pa=Ma-$d|0;tg=Pa;ug=(f[X>>2]|0)-Pa|0}else{tg=Ma;ug=$d-Ma|0}Ma=f[G>>2]|0;vg=(f[W>>2]|0)+ug|0;wg=tg>>>0>Ma>>>0?Ma:tg;xg=Ma}else{Ma=f[G>>2]|0;vg=oa+(0-Xd)|0;wg=Ma;xg=Ma}Ma=wg>>>0>ka>>>0?ka:wg;f[G>>2]=xg-Ma;Xd=Ma+1|0;$d=Ma;Pa=oa;Rd=vg;while(1){b[Pa>>0]=b[Rd>>0]|0;$d=$d+-1|0;if(!$d)break;else{Pa=Pa+1|0;Rd=Rd+1|0}}Rd=ka-Ma|0;Pa=oa+-1+Xd|0;if(!(f[G>>2]|0)){f[l>>2]=16200;Da=gd;Ea=Rd;Fa=ed;Ga=Pa;Ha=fd;Ia=p;Ja=cd;Ka=dd}else{Da=gd;Ea=Rd;Fa=ed;Ga=Pa;Ha=fd;Ia=p;Ja=cd;Ka=dd}}while(0);ja=Da;ka=Ea;la=Fa;ma=Ha;p=Ia;r=Ja;na=Ka;oa=Ga;o=f[l>>2]|0}if((va|0)==137){f[n>>2]=oa;f[m>>2]=ka;f[a>>2]=Ob;f[s>>2]=Nb;f[v>>2]=Mb;f[w>>2]=Lb;i=2;u=e;return i|0}else if((va|0)==147){wa=p;xa=Ld+-3|0;ya=Md>>>3;za=Nd;Aa=Od;Ba=ja;Ca=ka}else if((va|0)!=150)if((va|0)==295){f[l>>2]=16208;wa=td;xa=Dd;ya=Ed;za=Fd;Aa=Gd;Ba=1;Ca=ka}else if((va|0)==296){wa=p;xa=pa;ya=qa;za=ra;Aa=sa;Ba=ta;Ca=ua}else if((va|0)==310){i=-4;u=e;return i|0}else if((va|0)==311){u=e;return i|0}f[n>>2]=oa;f[m>>2]=Ca;f[a>>2]=Aa;f[s>>2]=za;f[v>>2]=ya;f[w>>2]=xa;if(!(f[X>>2]|0))if(((wa|0)!=(Ca|0)?(X=f[l>>2]|0,X>>>0<16209):0)?(c|0)!=4|X>>>0<16206:0)va=301;else{yg=za;zg=Ca}else va=301;do if((va|0)==301){if(!(Vmb(a,oa,wa-Ca|0)|0)){yg=f[s>>2]|0;zg=f[m>>2]|0;break}f[l>>2]=16210;i=-4;u=e;return i|0}while(0);m=t-yg|0;yg=wa-zg|0;zg=a+8|0;f[zg>>2]=(f[zg>>2]|0)+m;f[Y>>2]=(f[Y>>2]|0)+yg;f[Z>>2]=(f[Z>>2]|0)+yg;if((yg|0)!=0&(f[x>>2]&4|0)!=0){x=f[z>>2]|0;Z=(f[n>>2]|0)+(0-yg)|0;if(!(f[B>>2]|0))Ag=anb(x,Z,yg)|0;else Ag=cnb(x,Z,yg)|0;f[z>>2]=Ag;f[F>>2]=Ag}Ag=f[l>>2]|0;f[a+44>>2]=(f[J>>2]|0?64:0)+(f[w>>2]|0)+((Ag|0)==16191?128:0)+((Ag|0)==16199|(Ag|0)==16194?256:0);i=(Ba|0)==0&((c|0)==4|(yg|m|0)==0)?-5:Ba;u=e;return i|0}function Vmb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=f[a+28>>2]|0;e=d+56|0;g=f[e>>2]|0;if(!g){h=li[f[a+32>>2]&511](f[a+40>>2]|0,1<<f[d+40>>2],1)|0;f[e>>2]=h;if(!h){i=1;return i|0}else j=h}else j=g;g=d+44|0;h=f[g>>2]|0;if(!h){a=1<<f[d+40>>2];f[g>>2]=a;f[d+52>>2]=0;f[d+48>>2]=0;k=a}else k=h;if(k>>>0<=c>>>0){Vac(j|0,b+(0-k)|0,k|0)|0;f[d+52>>2]=0;f[d+48>>2]=f[g>>2];i=0;return i|0}h=d+52|0;a=f[h>>2]|0;l=k-a|0;k=l>>>0>c>>>0?c:l;Vac(j+a|0,b+(0-c)|0,k|0)|0;a=c-k|0;if(a|0){Vac(f[e>>2]|0,b+(0-a)|0,a|0)|0;f[h>>2]=a;f[d+48>>2]=f[g>>2];i=0;return i|0}a=(f[h>>2]|0)+k|0;b=f[g>>2]|0;f[h>>2]=(a|0)==(b|0)?0:a;a=d+48|0;d=f[a>>2]|0;if(d>>>0>=b>>>0){i=0;return i|0}f[a>>2]=d+k;i=0;return i|0}function Wmb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if(!a){b=-2;return b|0}if(!(f[a+32>>2]|0)){b=-2;return b|0}c=a+36|0;d=f[c>>2]|0;if(!d){b=-2;return b|0}e=a+28|0;g=f[e>>2]|0;if(!g){b=-2;return b|0}if((f[g>>2]|0)!=(a|0)){b=-2;return b|0}if(((f[g+4>>2]|0)+-16180|0)>>>0>31){b=-2;return b|0}h=f[g+56>>2]|0;i=a+40|0;if(!h){j=d;k=g}else{zh[d&2047](f[i>>2]|0,h);j=f[c>>2]|0;k=f[e>>2]|0}zh[j&2047](f[i>>2]|0,k);f[e>>2]=0;b=0;return b|0}function Xmb(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;k=u;u=u+64|0;l=k+32|0;m=k;n=l;o=n+32|0;do{d[n>>1]=0;n=n+2|0}while((n|0)<(o|0));n=(e|0)==0;if(!n){o=0;do{p=l+(j[c+(o<<1)>>1]<<1)|0;d[p>>1]=(d[p>>1]|0)+1<<16>>16;o=o+1|0}while((o|0)!=(e|0));o=d[l+30>>1]|0;p=f[h>>2]|0;if(!(o<<16>>16)){q=p;r=5}else{s=15;t=p;v=o;r=7}}else{q=f[h>>2]|0;r=5}do if((r|0)==5)if(!(d[l+28>>1]|0))if(!(d[l+26>>1]|0))if(!(d[l+24>>1]|0))if(!(d[l+22>>1]|0))if(!(d[l+20>>1]|0))if(!(d[l+18>>1]|0))if(!(d[l+16>>1]|0))if(!(d[l+14>>1]|0))if(!(d[l+12>>1]|0))if(!(d[l+10>>1]|0))if(!(d[l+8>>1]|0))if(!(d[l+6>>1]|0))if(!(d[l+4>>1]|0)){if(d[l+2>>1]|0){w=(q|0)!=0&1;x=1;y=1;z=0;break}o=f[g>>2]|0;f[g>>2]=o+4;b[o>>0]=64;b[o+1>>0]=1;d[o+2>>1]=0;o=f[g>>2]|0;f[g>>2]=o+4;b[o>>0]=64;b[o+1>>0]=1;d[o+2>>1]=0;f[h>>2]=1;A=0;u=k;return A|0}else{s=2;t=q;v=0;r=7}else{s=3;t=q;v=0;r=7}else{s=4;t=q;v=0;r=7}else{s=5;t=q;v=0;r=7}else{s=6;t=q;v=0;r=7}else{s=7;t=q;v=0;r=7}else{s=8;t=q;v=0;r=7}else{s=9;t=q;v=0;r=7}else{s=10;t=q;v=0;r=7}else{s=11;t=q;v=0;r=7}else{s=12;t=q;v=0;r=7}else{s=13;t=q;v=0;r=7}else{s=14;t=q;v=0;r=7}while(0);a:do if((r|0)==7){q=t>>>0>s>>>0?s:t;o=1;while(1){if(d[l+(o<<1)>>1]|0){w=q;x=s;y=o;z=v;break a}p=o+1|0;if(p>>>0<s>>>0)o=p;else{w=q;x=s;y=p;z=v;break}}}while(0);v=w>>>0<y>>>0?y:w;w=d[l+2>>1]|0;s=w&65535;t=2-s|0;if((t|0)<0){A=-1;u=k;return A|0}q=j[l+4>>1]|0;o=(t<<1)-q|0;if((o|0)<0){A=-1;u=k;return A|0}t=j[l+6>>1]|0;p=(o<<1)-t|0;if((p|0)<0){A=-1;u=k;return A|0}o=j[l+8>>1]|0;B=(p<<1)-o|0;if((B|0)<0){A=-1;u=k;return A|0}p=j[l+10>>1]|0;C=(B<<1)-p|0;if((C|0)<0){A=-1;u=k;return A|0}B=j[l+12>>1]|0;D=(C<<1)-B|0;if((D|0)<0){A=-1;u=k;return A|0}C=j[l+14>>1]|0;E=(D<<1)-C|0;if((E|0)<0){A=-1;u=k;return A|0}D=j[l+16>>1]|0;F=(E<<1)-D|0;if((F|0)<0){A=-1;u=k;return A|0}E=j[l+18>>1]|0;G=(F<<1)-E|0;if((G|0)<0){A=-1;u=k;return A|0}F=j[l+20>>1]|0;H=(G<<1)-F|0;if((H|0)<0){A=-1;u=k;return A|0}G=j[l+22>>1]|0;I=(H<<1)-G|0;if((I|0)<0){A=-1;u=k;return A|0}H=j[l+24>>1]|0;J=(I<<1)-H|0;if((J|0)<0){A=-1;u=k;return A|0}I=j[l+26>>1]|0;K=(J<<1)-I|0;if((K|0)<0){A=-1;u=k;return A|0}J=j[l+28>>1]|0;L=(K<<1)-J|0;if((L|0)<0){A=-1;u=k;return A|0}K=(L<<1)-(z&65535)|0;if((K|0)<0){A=-1;u=k;return A|0}if(K|0?(a|0)==0|(x|0)!=1:0){A=-1;u=k;return A|0}d[m+2>>1]=0;d[m+4>>1]=w;w=q+s|0;d[m+6>>1]=w;d[m+8>>1]=t+w;s=w+t|0;d[m+10>>1]=o+s;t=s+o|0;d[m+12>>1]=p+t;o=t+p|0;d[m+14>>1]=B+o;p=o+B|0;d[m+16>>1]=C+p;B=p+C|0;d[m+18>>1]=D+B;C=B+D|0;d[m+20>>1]=E+C;D=C+E|0;d[m+22>>1]=F+D;E=D+F|0;d[m+24>>1]=G+E;F=E+G|0;d[m+26>>1]=H+F;G=F+H|0;d[m+28>>1]=I+G;d[m+30>>1]=J+(G+I);if(!n){n=0;do{I=d[c+(n<<1)>>1]|0;if(I<<16>>16){G=m+((I&65535)<<1)|0;I=d[G>>1]|0;d[G>>1]=I+1<<16>>16;d[i+((I&65535)<<1)>>1]=n}n=n+1|0}while((n|0)!=(e|0))}switch(a|0){case 0:{M=i;N=i;O=20;P=0;Q=0;break}case 1:{if(v>>>0>9){A=1;u=k;return A|0}else{M=152080;N=151954;O=257;P=0;Q=1}break}default:{e=(a|0)==2;if(e&v>>>0>9){A=1;u=k;return A|0}else{M=152016;N=151890;O=0;P=e;Q=0}}}e=1<<v;a=e+-1|0;n=v&255;m=f[g>>2]|0;I=-1;G=0;J=e;e=0;H=v;F=0;E=y;b:while(1){y=1<<H;R=G;D=F;C=E;while(1){B=C-e|0;S=B&255;p=d[i+(D<<1)>>1]|0;o=p&65535;do if((o+1|0)>>>0<O>>>0){T=p;U=0}else{t=o-O|0;if(o>>>0<O>>>0){T=0;U=96;break}T=d[N+(t<<1)>>1]|0;U=d[M+(t<<1)>>1]&255}while(0);o=1<<B;p=R>>>e;t=y;do{t=t-o|0;s=t+p|0;b[m+(s<<2)>>0]=U;b[m+(s<<2)+1>>0]=S;d[m+(s<<2)+2>>1]=T}while((t|0)!=0);t=1<<C+-1;while(1)if(!(t&R))break;else t=t>>>1;p=R;R=(t|0)==0?0:(t+-1&R)+t|0;p=D;D=D+1|0;p=l+(C<<1)|0;o=(d[p>>1]|0)+-1<<16>>16;d[p>>1]=o;if(!(o<<16>>16)){if((C|0)==(x|0))break b;V=j[c+(j[i+(D<<1)>>1]<<1)>>1]|0}else V=C;if(V>>>0<=v>>>0){R=R;D=D;C=V;continue}W=R&a;if((W|0)!=(I|0))break;else C=V}C=(e|0)==0?v:e;o=m+(y<<2)|0;p=V-C|0;c:do if(V>>>0<x>>>0){B=1<<p;s=p;w=V;while(1){q=B-(j[l+(w<<1)>>1]|0)|0;if((q|0)<1){X=s;break c}K=s+1|0;w=K+C|0;if(w>>>0>=x>>>0){X=K;break}else{B=q<<1;s=K}}}else X=p;while(0);p=(1<<X)+J|0;if(Q&p>>>0>852|P&p>>>0>592){A=1;r=43;break}y=f[g>>2]|0;b[y+(W<<2)>>0]=X;b[y+(W<<2)+1>>0]=n;d[y+(W<<2)+2>>1]=(o-y|0)>>>2;m=o;I=W;G=R;J=p;e=C;H=X;F=D;E=V}if((r|0)==43){u=k;return A|0}if(R|0){b[m+(R<<2)>>0]=64;b[m+(R<<2)+1>>0]=S;d[m+(R<<2)+2>>1]=0}f[g>>2]=(f[g>>2]|0)+(J<<2);f[h>>2]=v;A=0;u=k;return A|0}function Ymb(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0;e=f[a+28>>2]|0;g=f[a>>2]|0;i=a+4|0;j=g+((f[i>>2]|0)+-5)|0;k=a+12|0;l=f[k>>2]|0;m=a+16|0;n=f[m>>2]|0;o=l+(n+-257)|0;p=f[e+44>>2]|0;q=f[e+48>>2]|0;r=f[e+52>>2]|0;s=f[e+56>>2]|0;t=e+60|0;u=e+64|0;v=f[e+80>>2]|0;w=f[e+84>>2]|0;x=(1<<f[e+88>>2])+-1|0;y=(1<<f[e+92>>2])+-1|0;z=l+(n-c)|0;c=e+7108|0;n=(r|0)==0;A=r+p|0;B=z-r|0;C=g;g=l;l=f[t>>2]|0;D=f[u>>2]|0;a:while(1){if(D>>>0<15){E=C+2|0;F=((h[C>>0]|0)<<D)+l+((h[C+1>>0]|0)<<D+8)|0;G=D+16|0}else{E=C;F=l;G=D}H=F&x;I=b[v+(H<<2)>>0]|0;J=d[v+(H<<2)+2>>1]|0;K=h[v+(H<<2)+1>>0]|0;H=F>>>K;L=G-K|0;do if(I<<24>>24){K=J;M=I&255;N=L;O=H;while(1){if(M&16|0)break;if(M&64|0){P=53;break a}Q=(O&(1<<M)+-1)+(K&65535)|0;R=b[v+(Q<<2)>>0]|0;S=d[v+(Q<<2)+2>>1]|0;T=h[v+(Q<<2)+1>>0]|0;U=O>>>T;V=N-T|0;if(!(R<<24>>24)){P=6;break}else{K=S;M=R&255;N=V;O=U}}if((P|0)==6){P=0;W=V;X=U;Y=S&255;P=7;break}R=K&65535;T=M&15;if(!T){Z=R;_=E;$=O;aa=N}else{if(N>>>0<T>>>0){ba=E+1|0;ca=((h[E>>0]|0)<<N)+O|0;da=N+8|0}else{ba=E;ca=O;da=N}Z=(ca&(1<<T)+-1)+R|0;_=ba;$=ca>>>T;aa=da-T|0}if(aa>>>0<15){ea=_+2|0;fa=((h[_>>0]|0)<<aa)+$+((h[_+1>>0]|0)<<aa+8)|0;ga=aa+16|0}else{ea=_;fa=$;ga=aa}T=fa&y;R=d[w+(T<<2)+2>>1]|0;Q=h[w+(T<<2)+1>>0]|0;ha=fa>>>Q;ia=ga-Q|0;Q=h[w+(T<<2)>>0]|0;if(!(Q&16)){T=R;ja=Q;ka=ha;la=ia;while(1){if(ja&64|0){ma=ea;na=ka;oa=la;pa=445471;P=55;break a}qa=(ka&(1<<ja)+-1)+(T&65535)|0;ra=d[w+(qa<<2)+2>>1]|0;sa=h[w+(qa<<2)+1>>0]|0;ta=ka>>>sa;ua=la-sa|0;sa=h[w+(qa<<2)>>0]|0;if(!(sa&16)){T=ra;ja=sa;ka=ta;la=ua}else{va=sa;wa=ua;xa=ta;ya=ra;break}}}else{va=Q;wa=ia;xa=ha;ya=R}la=ya&65535;ka=va&15;if(wa>>>0<ka>>>0){ja=ea+1|0;T=((h[ea>>0]|0)<<wa)+xa|0;K=wa+8|0;if(K>>>0<ka>>>0){za=ea+2|0;Aa=((h[ja>>0]|0)<<K)+T|0;Ba=wa+16|0}else{za=ja;Aa=T;Ba=K}}else{za=ea;Aa=xa;Ba=wa}K=(Aa&(1<<ka)+-1)+la|0;la=Aa>>>ka;T=Ba-ka|0;ka=g;ja=ka-z|0;if(K>>>0<=ja>>>0){ra=Z;ta=g+(0-K)|0;ua=g;while(1){b[ua>>0]=b[ta>>0]|0;b[ua+1>>0]=b[ta+1>>0]|0;Ca=ta+3|0;Da=ua+3|0;b[ua+2>>0]=b[ta+2>>0]|0;ra=ra+-3|0;if(ra>>>0<=2)break;else{ta=Ca;ua=Da}}if(!ra){Ea=za;Fa=Da;Ga=la;Ha=T;break}R=ua+4|0;b[Da>>0]=b[Ca>>0]|0;if((ra|0)==1){Ea=za;Fa=R;Ga=la;Ha=T;break}b[R>>0]=b[ta+4>>0]|0;Ea=za;Fa=ua+5|0;Ga=la;Ha=T;break}R=K-ja|0;if(R>>>0>q>>>0?f[c>>2]|0:0){ma=za;na=la;oa=T;pa=445493;P=55;break a}do if(n){ha=s+(p-R)|0;if(Z>>>0>R>>>0){ia=Z-R|0;Q=K-ka|0;sa=ha;qa=R;Ia=g;while(1){b[Ia>>0]=b[sa>>0]|0;qa=qa+-1|0;if(!qa)break;else{sa=sa+1|0;Ia=Ia+1|0}}Ia=g+z+Q|0;Ja=ia;Ka=Ia+(0-K)|0;La=Ia}else{Ja=Z;Ka=ha;La=g}}else{if(r>>>0>=R>>>0){Ia=s+(r-R)|0;if(Z>>>0<=R>>>0){Ja=Z;Ka=Ia;La=g;break}sa=Z-R|0;qa=K-ka|0;Ma=Ia;Ia=R;Na=g;while(1){b[Na>>0]=b[Ma>>0]|0;Ia=Ia+-1|0;if(!Ia)break;else{Ma=Ma+1|0;Na=Na+1|0}}Na=g+z+qa|0;Ja=sa;Ka=Na+(0-K)|0;La=Na;break}Na=s+(A-R)|0;Ma=R-r|0;if(Z>>>0>Ma>>>0){Ia=Z-Ma|0;ha=K-ka|0;ia=Na;Q=Ma;Ma=g;while(1){b[Ma>>0]=b[ia>>0]|0;Q=Q+-1|0;if(!Q)break;else{ia=ia+1|0;Ma=Ma+1|0}}Ma=g+B+ha|0;if(Ia>>>0>r>>>0){ia=g+z|0;Q=s;sa=r;qa=Ma;while(1){b[qa>>0]=b[Q>>0]|0;sa=sa+-1|0;if(!sa)break;else{Q=Q+1|0;qa=qa+1|0}}qa=ia+ha|0;Ja=Ia-r|0;Ka=qa+(0-K)|0;La=qa}else{Ja=Ia;Ka=s;La=Ma}}else{Ja=Z;Ka=Na;La=g}}while(0);if(Ja>>>0>2){K=Ja;ka=Ka;R=La;while(1){b[R>>0]=b[ka>>0]|0;b[R+1>>0]=b[ka+1>>0]|0;ja=ka+3|0;ua=R+3|0;b[R+2>>0]=b[ka+2>>0]|0;ta=K+-3|0;if(ta>>>0>2){K=ta;ka=ja;R=ua}else{Oa=ta;Pa=ja;Qa=ua;break}}}else{Oa=Ja;Pa=Ka;Qa=La}if(Oa){R=Qa+1|0;b[Qa>>0]=b[Pa>>0]|0;if((Oa|0)==1){Ea=za;Fa=R;Ga=la;Ha=T}else{b[R>>0]=b[Pa+1>>0]|0;Ea=za;Fa=Qa+2|0;Ga=la;Ha=T}}else{Ea=za;Fa=Qa;Ga=la;Ha=T}}else{W=L;X=H;Y=J&255;P=7}while(0);if((P|0)==7){P=0;b[g>>0]=Y;Ea=E;Fa=g+1|0;Ga=X;Ha=W}if(Fa>>>0<o>>>0&Ea>>>0<j>>>0){C=Ea;g=Fa;l=Ga;D=Ha}else{Ra=Ga;Sa=Ha;Ta=Ea;Ua=Fa;P=57;break}}if((P|0)==53)if(!(M&32)){ma=E;na=O;oa=N;pa=445443;P=55}else{Va=E;Wa=O;Xa=N;Ya=16191}else if((P|0)==57){Za=Sa>>>3;_a=0-Za|0;$a=Ta+_a|0;ab=Za<<3;bb=Sa-ab|0;cb=1<<bb;db=cb+-1|0;eb=db&Ra;f[a>>2]=$a;f[k>>2]=Ua;fb=j;gb=$a;hb=fb+5|0;ib=hb-gb|0;f[i>>2]=ib;jb=o;kb=Ua;lb=jb+257|0;mb=lb-kb|0;f[m>>2]=mb;f[t>>2]=eb;f[u>>2]=bb;return}if((P|0)==55){f[a+24>>2]=pa;Va=ma;Wa=na;Xa=oa;Ya=16209}f[e+4>>2]=Ya;Ra=Wa;Sa=Xa;Ta=Va;Ua=g;Za=Sa>>>3;_a=0-Za|0;$a=Ta+_a|0;ab=Za<<3;bb=Sa-ab|0;cb=1<<bb;db=cb+-1|0;eb=db&Ra;f[a>>2]=$a;f[k>>2]=Ua;fb=j;gb=$a;hb=fb+5|0;ib=hb-gb|0;f[i>>2]=ib;jb=o;kb=Ua;lb=jb+257|0;mb=lb-kb|0;f[m>>2]=mb;f[t>>2]=eb;f[u>>2]=bb;return}function Zmb(a,b,c){a=a|0;b=b|0;c=c|0;return OSb(Y(c,b)|0)|0}function _mb(a,b){a=a|0;b=b|0;PSb(b);return}function $mb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=a>>>16;e=a&65535;if((c|0)==1){a=(h[b>>0]|0)+e|0;f=a>>>0>65520?a+-65521|0:a;a=f+d|0;g=(a>>>0>65520?a+15|0:a)<<16|f;return g|0}if(!b){g=1;return g|0}if(c>>>0<16){if(!c){i=d;j=e}else{f=c;a=b;k=e;l=d;while(1){f=f+-1|0;m=(h[a>>0]|0)+k|0;n=m+l|0;if(!f){i=n;j=m;break}else{a=a+1|0;k=m;l=n}}}g=((i>>>0)%65521|0)<<16|(j>>>0>65520?j+-65521|0:j);return g|0}if(c>>>0>5551){j=c;i=b;l=d;k=e;do{j=j+-5552|0;a=347;f=i;n=l;m=k;while(1){o=(h[f>>0]|0)+m|0;p=o+(h[f+1>>0]|0)|0;q=p+(h[f+2>>0]|0)|0;r=q+(h[f+3>>0]|0)|0;s=r+(h[f+4>>0]|0)|0;t=s+(h[f+5>>0]|0)|0;u=t+(h[f+6>>0]|0)|0;v=u+(h[f+7>>0]|0)|0;w=v+(h[f+8>>0]|0)|0;x=w+(h[f+9>>0]|0)|0;y=x+(h[f+10>>0]|0)|0;z=y+(h[f+11>>0]|0)|0;A=z+(h[f+12>>0]|0)|0;B=A+(h[f+13>>0]|0)|0;C=B+(h[f+14>>0]|0)|0;m=C+(h[f+15>>0]|0)|0;n=o+n+p+q+r+s+t+u+v+w+x+y+z+A+B+C+m|0;a=a+-1|0;if(!a)break;else f=f+16|0}i=i+5552|0;k=(m>>>0)%65521|0;l=(n>>>0)%65521|0}while(j>>>0>5551);if(j)if(j>>>0>15){D=j;E=i;F=l;G=k;H=14}else{I=j;J=i;K=l;L=k;H=17}else{M=l;N=k}}else{D=c;E=b;F=d;G=e;H=14}if((H|0)==14){e=D+-16|0;d=e&-16;b=d+16|0;c=D;D=E;k=F;F=G;while(1){c=c+-16|0;G=(h[D>>0]|0)+F|0;l=G+(h[D+1>>0]|0)|0;i=l+(h[D+2>>0]|0)|0;j=i+(h[D+3>>0]|0)|0;f=j+(h[D+4>>0]|0)|0;a=f+(h[D+5>>0]|0)|0;C=a+(h[D+6>>0]|0)|0;B=C+(h[D+7>>0]|0)|0;A=B+(h[D+8>>0]|0)|0;z=A+(h[D+9>>0]|0)|0;y=z+(h[D+10>>0]|0)|0;x=y+(h[D+11>>0]|0)|0;w=x+(h[D+12>>0]|0)|0;v=w+(h[D+13>>0]|0)|0;u=v+(h[D+14>>0]|0)|0;F=u+(h[D+15>>0]|0)|0;k=G+k+l+i+j+f+a+C+B+A+z+y+x+w+v+u+F|0;if(c>>>0<=15)break;else D=D+16|0}D=e-d|0;if(!D){O=k;P=F;H=18}else{I=D;J=E+b|0;K=k;L=F;H=17}}if((H|0)==17)while(1){H=0;I=I+-1|0;F=(h[J>>0]|0)+L|0;k=F+K|0;if(!I){O=k;P=F;H=18;break}else{J=J+1|0;K=k;L=F;H=17}}if((H|0)==18){M=(O>>>0)%65521|0;N=(P>>>0)%65521|0}g=M<<16|N;return g|0}function anb(a,b,c){a=a|0;b=b|0;c=c|0;return $mb(a,b,c)|0}function bnb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;if(!b){d=0;return d|0}e=~a;a:do if(c){a=e;g=c;i=b;while(1){if(!(i&3))break;j=f[126724+(((h[i>>0]|0)^a&255)<<2)>>2]^a>>>8;k=g+-1|0;if(!k){l=j;break a}else{a=j;g=k;i=i+1|0}}if(g>>>0>31){k=g+-32|0;j=k&-32;m=i+(j+32)|0;n=i;o=a;p=g;while(1){q=f[n>>2]^o;r=f[128772+((q>>>8&255)<<2)>>2]^f[129796+((q&255)<<2)>>2]^f[127748+((q>>>16&255)<<2)>>2]^f[126724+(q>>>24<<2)>>2]^f[n+4>>2];q=f[128772+((r>>>8&255)<<2)>>2]^f[129796+((r&255)<<2)>>2]^f[127748+((r>>>16&255)<<2)>>2]^f[126724+(r>>>24<<2)>>2]^f[n+8>>2];r=f[128772+((q>>>8&255)<<2)>>2]^f[129796+((q&255)<<2)>>2]^f[127748+((q>>>16&255)<<2)>>2]^f[126724+(q>>>24<<2)>>2]^f[n+12>>2];q=f[128772+((r>>>8&255)<<2)>>2]^f[129796+((r&255)<<2)>>2]^f[127748+((r>>>16&255)<<2)>>2]^f[126724+(r>>>24<<2)>>2]^f[n+16>>2];r=f[128772+((q>>>8&255)<<2)>>2]^f[129796+((q&255)<<2)>>2]^f[127748+((q>>>16&255)<<2)>>2]^f[126724+(q>>>24<<2)>>2]^f[n+20>>2];q=f[128772+((r>>>8&255)<<2)>>2]^f[129796+((r&255)<<2)>>2]^f[127748+((r>>>16&255)<<2)>>2]^f[126724+(r>>>24<<2)>>2]^f[n+24>>2];r=f[128772+((q>>>8&255)<<2)>>2]^f[129796+((q&255)<<2)>>2]^f[127748+((q>>>16&255)<<2)>>2]^f[126724+(q>>>24<<2)>>2]^f[n+28>>2];o=f[128772+((r>>>8&255)<<2)>>2]^f[129796+((r&255)<<2)>>2]^f[127748+((r>>>16&255)<<2)>>2]^f[126724+(r>>>24<<2)>>2];p=p+-32|0;if(p>>>0<=31)break;else n=n+32|0}s=m;t=o;u=k-j|0}else{s=i;t=a;u=g}if(u>>>0>3){n=u+-4|0;p=n>>>2;r=p+1|0;q=s;v=u;w=t;while(1){x=f[q>>2]^w;w=f[128772+((x>>>8&255)<<2)>>2]^f[129796+((x&255)<<2)>>2]^f[127748+((x>>>16&255)<<2)>>2]^f[126724+(x>>>24<<2)>>2];v=v+-4|0;if(v>>>0<=3)break;else q=q+4|0}y=s+(r<<2)|0;z=w;A=n-(p<<2)|0}else{y=s;z=t;A=u}if(!A)l=z;else{q=y;v=z;g=A;while(1){a=f[126724+(((h[q>>0]|0)^v&255)<<2)>>2]^v>>>8;g=g+-1|0;if(!g){l=a;break}else{q=q+1|0;v=a}}}}else l=e;while(0);d=~l;return d|0}function cnb(a,b,c){a=a|0;b=b|0;c=c|0;return bnb(a,b,c)|0}function dnb(a,c,e,g,h,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;if(!k){m=-6;return m|0}if((l|0)!=56|(b[k>>0]|0)!=49){m=-6;return m|0}if(!a){m=-2;return m|0}k=a+24|0;f[k>>2]=0;l=a+32|0;n=f[l>>2]|0;if(!n){f[l>>2]=280;f[a+40>>2]=0;o=280}else o=n;n=a+36|0;if(!(f[n>>2]|0))f[n>>2]=1028;n=(c|0)==-1?6:c;if((g|0)<0){p=0;q=0-g|0}else{c=(g|0)>15;p=c?2:1;q=c?g+-16|0:g}if(i>>>0>4|(n>>>0>9|((e|0)!=8|(h+-1|0)>>>0>8|(q&-8|0)!=8))){m=-2;return m|0}e=(q|0)==8;if(e&(p|0)!=1){m=-2;return m|0}g=e?9:q;q=a+40|0;e=li[o&511](f[q>>2]|0,1,5828)|0;if(!e){m=-4;return m|0}o=a+28|0;f[o>>2]=e;f[e>>2]=a;c=e+4|0;f[c>>2]=42;f[e+24>>2]=p;f[e+28>>2]=0;f[e+48>>2]=g;p=1<<g;g=e+44|0;f[g>>2]=p;f[e+52>>2]=p+-1;r=h+7|0;f[e+80>>2]=r;s=1<<r;r=e+76|0;f[r>>2]=s;f[e+84>>2]=s+-1;f[e+88>>2]=((h+9|0)>>>0)/3|0;s=li[f[l>>2]&511](f[q>>2]|0,p,2)|0;p=e+56|0;f[p>>2]=s;s=li[f[l>>2]&511](f[q>>2]|0,f[g>>2]|0,2)|0;g=e+64|0;f[g>>2]=s;s=li[f[l>>2]&511](f[q>>2]|0,f[r>>2]|0,2)|0;r=e+68|0;f[r>>2]=s;f[e+5824>>2]=0;s=1<<h+6;h=e+5788|0;f[h>>2]=s;t=li[f[l>>2]&511](f[q>>2]|0,s,4)|0;f[e+8>>2]=t;s=f[h>>2]|0;f[e+12>>2]=s<<2;if((f[p>>2]|0?f[g>>2]|0:0)?!((f[r>>2]|0)==0|(t|0)==0):0){f[e+5796>>2]=t+(s>>>1<<1);f[e+5784>>2]=t+(s*3|0);f[e+132>>2]=n;f[e+136>>2]=i;b[e+36>>0]=8;e=fnb(a)|0;if(e|0){m=e;return m|0}e=f[o>>2]|0;f[e+60>>2]=f[e+44>>2]<<1;o=f[e+68>>2]|0;i=(f[e+76>>2]|0)+-1|0;d[o+(i<<1)>>1]=0;Nac(o|0,0,i<<1|0)|0;i=f[e+132>>2]|0;f[e+128>>2]=j[134916+(i*12|0)+2>>1];f[e+140>>2]=j[134916+(i*12|0)>>1];f[e+144>>2]=j[134916+(i*12|0)+4>>1];f[e+124>>2]=j[134916+(i*12|0)+6>>1];f[e+108>>2]=0;f[e+92>>2]=0;f[e+116>>2]=0;f[e+5812>>2]=0;f[e+120>>2]=2;f[e+96>>2]=2;f[e+104>>2]=0;f[e+72>>2]=0;m=0;return m|0}f[c>>2]=666;f[k>>2]=f[31677];enb(a)|0;m=-4;return m|0}function enb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!a){b=-2;return b|0}if(!(f[a+32>>2]|0)){b=-2;return b|0}c=a+36|0;d=f[c>>2]|0;if(!d){b=-2;return b|0}e=a+28|0;g=f[e>>2]|0;if(!g){b=-2;return b|0}if((f[g>>2]|0)!=(a|0)){b=-2;return b|0}h=f[g+4>>2]|0;switch(h|0){case 666:case 113:case 103:case 91:case 73:case 69:case 57:case 42:break;default:{b=-2;return b|0}}i=f[g+8>>2]|0;if(!i)j=g;else{zh[d&2047](f[a+40>>2]|0,i);j=f[e>>2]|0}i=f[j+68>>2]|0;if(!i)k=j;else{zh[f[c>>2]&2047](f[a+40>>2]|0,i);k=f[e>>2]|0}i=f[k+64>>2]|0;if(!i)l=k;else{zh[f[c>>2]&2047](f[a+40>>2]|0,i);l=f[e>>2]|0}i=f[l+56>>2]|0;if(!i){m=a+40|0;n=l}else{l=a+40|0;zh[f[c>>2]&2047](f[l>>2]|0,i);m=l;n=f[e>>2]|0}zh[f[c>>2]&2047](f[m>>2]|0,n);f[e>>2]=0;b=(h|0)==113?-3:0;return b|0}function fnb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;if(!a){b=-2;return b|0}if(!(f[a+32>>2]|0)){b=-2;return b|0}if(!(f[a+36>>2]|0)){b=-2;return b|0}c=f[a+28>>2]|0;if(!c){b=-2;return b|0}if((f[c>>2]|0)!=(a|0)){b=-2;return b|0}d=c+4|0;switch(f[d>>2]|0){case 666:case 113:case 103:case 91:case 73:case 69:case 57:case 42:break;default:{b=-2;return b|0}}f[a+20>>2]=0;f[a+8>>2]=0;f[a+24>>2]=0;f[a+44>>2]=2;f[c+20>>2]=0;f[c+16>>2]=f[c+8>>2];e=c+24|0;g=f[e>>2]|0;h=0-g|0;if((g|0)<0){f[e>>2]=h;i=h}else i=g;g=(i|0)==2;f[d>>2]=g?57:i|0?42:113;if(g)j=cnb(0,0,0)|0;else j=anb(0,0,0)|0;f[a+48>>2]=j;f[c+40>>2]=0;nnb(c);b=0;return b|0}function gnb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;d=a+12|0;e=(f[d>>2]|0)+-5|0;g=a+44|0;h=f[g>>2]|0;i=e>>>0>h>>>0?h:e;e=f[a>>2]|0;h=f[e+4>>2]|0;j=a+5820|0;k=a+108|0;l=a+92|0;m=(c|0)!=4;n=(c|0)==0;o=(c|0)==4;p=a+8|0;q=a+20|0;r=a+56|0;s=(f[j>>2]|0)+42>>3;t=f[e+16>>2]|0;a:do if(t>>>0<s>>>0){u=0;v=e}else{w=0;x=s;y=t;z=e;while(1){A=y-x|0;B=(f[k>>2]|0)-(f[l>>2]|0)|0;C=B+(f[z+4>>2]|0)|0;D=C>>>0<65535?C:65535;E=D>>>0>A>>>0?A:D;if(E>>>0<i>>>0?!((E|0)==(C|0)&((n|m&(E|0)==0)^1)):0){u=w;v=z;break a}D=o&(E|0)==(C|0);C=D&1;pnb(a,0,0,C);b[(f[p>>2]|0)+((f[q>>2]|0)+-4)>>0]=E;b[(f[p>>2]|0)+((f[q>>2]|0)+-3)>>0]=E>>>8;A=~E;b[(f[p>>2]|0)+((f[q>>2]|0)+-2)>>0]=A;b[(f[p>>2]|0)+((f[q>>2]|0)+-1)>>0]=A>>>8;A=f[a>>2]|0;F=f[A+28>>2]|0;qnb(F);G=F+20|0;H=f[G>>2]|0;I=A+16|0;J=f[I>>2]|0;K=H>>>0>J>>>0?J:H;if(K|0?(H=A+12|0,J=F+16|0,Vac(f[H>>2]|0,f[J>>2]|0,K|0)|0,f[H>>2]=(f[H>>2]|0)+K,f[J>>2]=(f[J>>2]|0)+K,H=A+20|0,f[H>>2]=(f[H>>2]|0)+K,f[I>>2]=(f[I>>2]|0)-K,I=(f[G>>2]|0)-K|0,f[G>>2]=I,(I|0)==0):0)f[J>>2]=f[F+8>>2];if(!B)L=E;else{F=B>>>0>E>>>0?E:B;Vac(f[(f[a>>2]|0)+12>>2]|0,(f[r>>2]|0)+(f[l>>2]|0)|0,F|0)|0;B=f[a>>2]|0;J=B+12|0;f[J>>2]=(f[J>>2]|0)+F;J=B+16|0;f[J>>2]=(f[J>>2]|0)-F;J=B+20|0;f[J>>2]=(f[J>>2]|0)+F;f[l>>2]=(f[l>>2]|0)+F;L=E-F|0}if(L|0){F=f[a>>2]|0;E=f[F+12>>2]|0;J=F+4|0;B=f[J>>2]|0;I=B>>>0>L>>>0?L:B;if(!I){M=F;N=E}else{f[J>>2]=B-I;Vac(E|0,f[F>>2]|0,I|0)|0;switch(f[(f[F+28>>2]|0)+24>>2]|0){case 1:{B=F+48|0;O=B;P=anb(f[B>>2]|0,E,I)|0;Q=14;break}case 2:{B=F+48|0;O=B;P=cnb(f[B>>2]|0,E,I)|0;Q=14;break}default:{}}if((Q|0)==14){Q=0;f[O>>2]=P}f[F>>2]=(f[F>>2]|0)+I;E=F+8|0;f[E>>2]=(f[E>>2]|0)+I;I=f[a>>2]|0;M=I;N=f[I+12>>2]|0}f[M+12>>2]=N+L;I=M+16|0;f[I>>2]=(f[I>>2]|0)-L;I=M+20|0;f[I>>2]=(f[I>>2]|0)+L}I=f[a>>2]|0;if(D){u=C;v=I;break a}x=(f[j>>2]|0)+42>>3;y=f[I+16>>2]|0;if(y>>>0<x>>>0){u=C;v=I;break}else{w=C;z=I}}}while(0);L=h-(f[v+4>>2]|0)|0;if(!L)R=f[k>>2]|0;else{h=f[g>>2]|0;if(L>>>0<h>>>0){M=f[k>>2]|0;if(((f[a+60>>2]|0)-M|0)>>>0<=L>>>0?(N=M-h|0,f[k>>2]=N,M=f[r>>2]|0,Vac(M|0,M+h|0,N|0)|0,N=a+5808|0,M=f[N>>2]|0,M>>>0<2):0)f[N>>2]=M+1;Vac((f[r>>2]|0)+(f[k>>2]|0)|0,(f[f[a>>2]>>2]|0)+(0-L)|0,L|0)|0;M=(f[k>>2]|0)+L|0;f[k>>2]=M;S=M;T=f[g>>2]|0}else{f[a+5808>>2]=2;Vac(f[r>>2]|0,(f[v>>2]|0)+(0-h)|0,h|0)|0;h=f[g>>2]|0;f[k>>2]=h;S=h;T=h}f[l>>2]=S;h=a+5812|0;v=f[h>>2]|0;M=T-v|0;f[h>>2]=(L>>>0>M>>>0?M:L)+v;R=S}S=a+5824|0;if((f[S>>2]|0)>>>0<R>>>0)f[S>>2]=R;if(u|0){U=3;return U|0}u=(c|0)!=0;v=f[a>>2]|0;L=f[v+4>>2]|0;switch(c|0){case 0:case 4:break;default:if((L|0)==0?(R|0)==(f[l>>2]|0):0){U=1;return U|0}}c=(f[a+60>>2]|0)-R+-1|0;if(L>>>0>c>>>0?(M=f[l>>2]|0,h=f[g>>2]|0,(M|0)>=(h|0)):0){f[l>>2]=M-h;M=R-h|0;f[k>>2]=M;R=f[r>>2]|0;Vac(R|0,R+h|0,M|0)|0;M=a+5808|0;h=f[M>>2]|0;if(h>>>0<2)f[M>>2]=h+1;h=f[a>>2]|0;V=(f[g>>2]|0)+c|0;W=f[h+4>>2]|0;X=h}else{V=c;W=L;X=v}v=V>>>0>W>>>0?W:V;if(!v)Y=f[k>>2]|0;else{V=(f[r>>2]|0)+(f[k>>2]|0)|0;f[X+4>>2]=W-v;Vac(V|0,f[X>>2]|0,v|0)|0;switch(f[(f[X+28>>2]|0)+24>>2]|0){case 1:{W=X+48|0;Z=W;_=anb(f[W>>2]|0,V,v)|0;Q=44;break}case 2:{W=X+48|0;Z=W;_=cnb(f[W>>2]|0,V,v)|0;Q=44;break}default:{}}if((Q|0)==44)f[Z>>2]=_;f[X>>2]=(f[X>>2]|0)+v;_=X+8|0;f[_>>2]=(f[_>>2]|0)+v;_=(f[k>>2]|0)+v|0;f[k>>2]=_;Y=_}if((f[S>>2]|0)>>>0<Y>>>0)f[S>>2]=Y;S=(f[d>>2]|0)-((f[j>>2]|0)+42>>3)|0;j=S>>>0<65535?S:65535;S=f[g>>2]|0;g=f[l>>2]|0;d=Y-g|0;if(d>>>0<(j>>>0>S>>>0?S:j)>>>0)if(u&(o|(d|0)!=0)?!(d>>>0>j>>>0?1:(f[(f[a>>2]|0)+4>>2]|0)!=0):0)Q=51;else $=0;else Q=51;if((Q|0)==51){Q=d>>>0>j>>>0?j:d;if(o)aa=d>>>0<=j>>>0?(f[(f[a>>2]|0)+4>>2]|0)==0:0;else aa=0;j=aa&1;pnb(a,(f[r>>2]|0)+g|0,Q,j);f[l>>2]=(f[l>>2]|0)+Q;Q=f[a>>2]|0;a=f[Q+28>>2]|0;qnb(a);l=a+20|0;g=f[l>>2]|0;r=Q+16|0;aa=f[r>>2]|0;d=g>>>0>aa>>>0?aa:g;if((d|0)!=0?(g=Q+12|0,aa=a+16|0,Vac(f[g>>2]|0,f[aa>>2]|0,d|0)|0,f[g>>2]=(f[g>>2]|0)+d,f[aa>>2]=(f[aa>>2]|0)+d,g=Q+20|0,f[g>>2]=(f[g>>2]|0)+d,f[r>>2]=(f[r>>2]|0)-d,r=(f[l>>2]|0)-d|0,f[l>>2]=r,(r|0)==0):0){f[aa>>2]=f[a+8>>2];$=j}else $=j}U=$|0?2:0;return U|0}function hnb(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=a+116|0;g=(c|0)==0;i=a+72|0;j=a+88|0;k=a+56|0;l=a+108|0;m=a+84|0;n=a+68|0;o=a+64|0;p=a+52|0;q=a+44|0;r=a+96|0;s=a+5784|0;t=a+5796|0;u=a+112|0;v=a+5792|0;w=a+5788|0;x=a+128|0;y=a+92|0;while(1){if((f[e>>2]|0)>>>0<262){jnb(a);z=f[e>>2]|0;if(g&z>>>0<262){A=0;B=39;break}if(!z){B=24;break}if(z>>>0<=2)B=9;else B=6}else B=6;if((B|0)==6){B=0;z=f[l>>2]|0;C=((h[(f[k>>2]|0)+(z+2)>>0]|0)^f[i>>2]<<f[j>>2])&f[m>>2];f[i>>2]=C;D=(f[n>>2]|0)+(C<<1)|0;C=d[D>>1]|0;d[(f[o>>2]|0)+((f[p>>2]&z)<<1)>>1]=C;E=C&65535;d[D>>1]=z;if(C<<16>>16!=0?(z-E|0)>>>0<=((f[q>>2]|0)+-262|0)>>>0:0){z=knb(a,E)|0;f[r>>2]=z;F=z}else B=9}if((B|0)==9){B=0;F=f[r>>2]|0}z=f[s>>2]|0;E=f[t>>2]|0;do if(F>>>0>2){C=F+253|0;D=(f[l>>2]|0)-(f[u>>2]|0)|0;G=f[v>>2]|0;d[E+(G<<1)>>1]=D;f[v>>2]=G+1;b[z+G>>0]=C;G=a+148+((h[446151+(C&255)>>0]|0|256)+1<<2)|0;d[G>>1]=(d[G>>1]|0)+1<<16>>16;G=D+65535&65535;D=a+2440+((h[445639+(G>>>0<256?G:(G>>>7)+256|0)>>0]|0)<<2)|0;d[D>>1]=(d[D>>1]|0)+1<<16>>16;D=(f[v>>2]|0)==((f[w>>2]|0)+-1|0)&1;G=f[r>>2]|0;C=(f[e>>2]|0)-G|0;f[e>>2]=C;if(!(C>>>0>2?G>>>0<=(f[x>>2]|0)>>>0:0)){C=(f[l>>2]|0)+G|0;f[l>>2]=C;f[r>>2]=0;H=f[k>>2]|0;I=h[H+C>>0]|0;f[i>>2]=I;f[i>>2]=((h[H+(C+1)>>0]|0)^I<<f[j>>2])&f[m>>2];J=D;K=C;break}C=G+-1|0;f[r>>2]=C;G=f[j>>2]|0;I=f[k>>2]|0;H=f[m>>2]|0;L=f[n>>2]|0;M=f[o>>2]|0;N=f[p>>2]|0;O=f[l>>2]|0;P=f[i>>2]|0;Q=C;while(1){C=O+1|0;f[l>>2]=C;P=((h[I+(O+3)>>0]|0)^P<<G)&H;f[i>>2]=P;R=L+(P<<1)|0;d[M+((N&C)<<1)>>1]=d[R>>1]|0;d[R>>1]=C;Q=Q+-1|0;f[r>>2]=Q;if(!Q)break;else O=C}Q=O+2|0;f[l>>2]=Q;J=D;K=Q}else{Q=b[(f[k>>2]|0)+(f[l>>2]|0)>>0]|0;N=f[v>>2]|0;d[E+(N<<1)>>1]=0;f[v>>2]=N+1;b[z+N>>0]=Q;N=a+148+((Q&255)<<2)|0;d[N>>1]=(d[N>>1]|0)+1<<16>>16;N=(f[v>>2]|0)==((f[w>>2]|0)+-1|0)&1;f[e>>2]=(f[e>>2]|0)+-1;Q=(f[l>>2]|0)+1|0;f[l>>2]=Q;J=N;K=Q}while(0);if(!J)continue;z=f[y>>2]|0;if((z|0)>-1)S=(f[k>>2]|0)+z|0;else S=0;snb(a,S,K-z|0,0);f[y>>2]=f[l>>2];z=f[a>>2]|0;E=f[z+28>>2]|0;qnb(E);Q=E+20|0;N=f[Q>>2]|0;M=z+16|0;P=f[M>>2]|0;L=N>>>0>P>>>0?P:N;if(L|0?(N=z+12|0,P=E+16|0,Vac(f[N>>2]|0,f[P>>2]|0,L|0)|0,f[N>>2]=(f[N>>2]|0)+L,f[P>>2]=(f[P>>2]|0)+L,N=z+20|0,f[N>>2]=(f[N>>2]|0)+L,f[M>>2]=(f[M>>2]|0)-L,M=(f[Q>>2]|0)-L|0,f[Q>>2]=M,(M|0)==0):0)f[P>>2]=f[E+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){A=0;B=39;break}}if((B|0)==24){K=f[l>>2]|0;f[a+5812>>2]=K>>>0<2?K:2;if((c|0)==4){c=f[y>>2]|0;if((c|0)>-1)T=(f[k>>2]|0)+c|0;else T=0;snb(a,T,K-c|0,1);f[y>>2]=f[l>>2];c=f[a>>2]|0;T=f[c+28>>2]|0;qnb(T);S=T+20|0;J=f[S>>2]|0;e=c+16|0;w=f[e>>2]|0;r=J>>>0>w>>>0?w:J;if(r|0?(J=c+12|0,w=T+16|0,Vac(f[J>>2]|0,f[w>>2]|0,r|0)|0,f[J>>2]=(f[J>>2]|0)+r,f[w>>2]=(f[w>>2]|0)+r,J=c+20|0,f[J>>2]=(f[J>>2]|0)+r,f[e>>2]=(f[e>>2]|0)-r,e=(f[S>>2]|0)-r|0,f[S>>2]=e,(e|0)==0):0)f[w>>2]=f[T+8>>2];A=(f[(f[a>>2]|0)+16>>2]|0)==0?2:3;return A|0}if(f[v>>2]|0){v=f[y>>2]|0;if((v|0)>-1)U=(f[k>>2]|0)+v|0;else U=0;snb(a,U,K-v|0,0);f[y>>2]=f[l>>2];l=f[a>>2]|0;y=f[l+28>>2]|0;qnb(y);v=y+20|0;K=f[v>>2]|0;U=l+16|0;k=f[U>>2]|0;T=K>>>0>k>>>0?k:K;if(T|0?(K=l+12|0,k=y+16|0,Vac(f[K>>2]|0,f[k>>2]|0,T|0)|0,f[K>>2]=(f[K>>2]|0)+T,f[k>>2]=(f[k>>2]|0)+T,K=l+20|0,f[K>>2]=(f[K>>2]|0)+T,f[U>>2]=(f[U>>2]|0)-T,U=(f[v>>2]|0)-T|0,f[v>>2]=U,(U|0)==0):0)f[k>>2]=f[y+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){A=0;return A|0}}A=1;return A|0}else if((B|0)==39)return A|0;return 0}function inb(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=a+116|0;g=(c|0)==0;i=a+72|0;j=a+88|0;k=a+56|0;l=a+108|0;m=a+84|0;n=a+68|0;o=a+64|0;p=a+52|0;q=a+96|0;r=a+120|0;s=a+112|0;t=a+100|0;u=a+5796|0;v=a+5792|0;w=a+5784|0;x=a+5788|0;y=a+104|0;z=a+92|0;A=a+128|0;B=a+44|0;C=a+136|0;a:while(1){D=f[e>>2]|0;while(1){if(D>>>0<262){jnb(a);E=f[e>>2]|0;if(g&E>>>0<262){F=0;G=55;break a}if(!E){G=38;break a}if(E>>>0<=2){f[r>>2]=f[q>>2];f[t>>2]=f[s>>2];f[q>>2]=2;H=2;G=16}else G=8}else G=8;do if((G|0)==8){G=0;E=f[l>>2]|0;I=((h[(f[k>>2]|0)+(E+2)>>0]|0)^f[i>>2]<<f[j>>2])&f[m>>2];f[i>>2]=I;J=(f[n>>2]|0)+(I<<1)|0;I=d[J>>1]|0;d[(f[o>>2]|0)+((f[p>>2]&E)<<1)>>1]=I;K=I&65535;d[J>>1]=E;E=f[q>>2]|0;f[r>>2]=E;f[t>>2]=f[s>>2];f[q>>2]=2;if(I<<16>>16)if(E>>>0<(f[A>>2]|0)>>>0)if(((f[l>>2]|0)-K|0)>>>0<=((f[B>>2]|0)+-262|0)>>>0){I=knb(a,K)|0;f[q>>2]=I;if(I>>>0<6){if((f[C>>2]|0)!=1){if((I|0)!=3){H=I;G=16;break}if(((f[l>>2]|0)-(f[s>>2]|0)|0)>>>0<=4096){H=3;G=16;break}}f[q>>2]=2;H=2;G=16}else{H=I;G=16}}else{H=2;G=16}else{L=E;M=2}else{H=2;G=16}}while(0);if((G|0)==16){G=0;L=f[r>>2]|0;M=H}if(!(L>>>0<3|M>>>0>L>>>0))break;if(!(f[y>>2]|0)){f[y>>2]=1;f[l>>2]=(f[l>>2]|0)+1;E=(f[e>>2]|0)+-1|0;f[e>>2]=E;D=E;continue}E=b[(f[k>>2]|0)+((f[l>>2]|0)+-1)>>0]|0;I=f[v>>2]|0;d[(f[u>>2]|0)+(I<<1)>>1]=0;K=f[w>>2]|0;f[v>>2]=I+1;b[K+I>>0]=E;I=a+148+((E&255)<<2)|0;d[I>>1]=(d[I>>1]|0)+1<<16>>16;if((f[v>>2]|0)==((f[x>>2]|0)+-1|0)){I=f[z>>2]|0;if((I|0)>-1)N=(f[k>>2]|0)+I|0;else N=0;snb(a,N,(f[l>>2]|0)-I|0,0);f[z>>2]=f[l>>2];I=f[a>>2]|0;E=f[I+28>>2]|0;qnb(E);K=E+20|0;J=f[K>>2]|0;O=I+16|0;P=f[O>>2]|0;Q=J>>>0>P>>>0?P:J;if(Q|0?(J=I+12|0,P=E+16|0,Vac(f[J>>2]|0,f[P>>2]|0,Q|0)|0,f[J>>2]=(f[J>>2]|0)+Q,f[P>>2]=(f[P>>2]|0)+Q,J=I+20|0,f[J>>2]=(f[J>>2]|0)+Q,f[O>>2]=(f[O>>2]|0)-Q,O=(f[K>>2]|0)-Q|0,f[K>>2]=O,(O|0)==0):0)f[P>>2]=f[E+8>>2]}f[l>>2]=(f[l>>2]|0)+1;D=(f[e>>2]|0)+-1|0;f[e>>2]=D;if(!(f[(f[a>>2]|0)+16>>2]|0)){F=0;G=55;break a}}D=f[l>>2]|0;E=D+-3+(f[e>>2]|0)|0;P=L+253|0;O=D+65535-(f[t>>2]|0)|0;D=f[v>>2]|0;d[(f[u>>2]|0)+(D<<1)>>1]=O;K=f[w>>2]|0;f[v>>2]=D+1;b[K+D>>0]=P;D=a+148+((h[446151+(P&255)>>0]|0|256)+1<<2)|0;d[D>>1]=(d[D>>1]|0)+1<<16>>16;D=O+65535&65535;O=a+2440+((h[445639+(D>>>0<256?D:(D>>>7)+256|0)>>0]|0)<<2)|0;d[O>>1]=(d[O>>1]|0)+1<<16>>16;O=f[v>>2]|0;D=(f[x>>2]|0)+-1|0;P=f[r>>2]|0;f[e>>2]=1-P+(f[e>>2]|0);K=P+-2|0;f[r>>2]=K;P=f[l>>2]|0;Q=K;while(1){K=P+1|0;f[l>>2]=K;if(K>>>0<=E>>>0){J=((h[(f[k>>2]|0)+(P+3)>>0]|0)^f[i>>2]<<f[j>>2])&f[m>>2];f[i>>2]=J;I=(f[n>>2]|0)+(J<<1)|0;d[(f[o>>2]|0)+((f[p>>2]&K)<<1)>>1]=d[I>>1]|0;d[I>>1]=K}Q=Q+-1|0;f[r>>2]=Q;if(!Q)break;else P=K}f[y>>2]=0;f[q>>2]=2;Q=P+2|0;f[l>>2]=Q;if((O|0)!=(D|0))continue;E=f[z>>2]|0;if((E|0)>-1)R=(f[k>>2]|0)+E|0;else R=0;snb(a,R,Q-E|0,0);f[z>>2]=f[l>>2];E=f[a>>2]|0;Q=f[E+28>>2]|0;qnb(Q);K=Q+20|0;I=f[K>>2]|0;J=E+16|0;S=f[J>>2]|0;T=I>>>0>S>>>0?S:I;if(T|0?(I=E+12|0,S=Q+16|0,Vac(f[I>>2]|0,f[S>>2]|0,T|0)|0,f[I>>2]=(f[I>>2]|0)+T,f[S>>2]=(f[S>>2]|0)+T,I=E+20|0,f[I>>2]=(f[I>>2]|0)+T,f[J>>2]=(f[J>>2]|0)-T,J=(f[K>>2]|0)-T|0,f[K>>2]=J,(J|0)==0):0)f[S>>2]=f[Q+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){F=0;G=55;break}}if((G|0)==38){if(f[y>>2]|0){R=b[(f[k>>2]|0)+((f[l>>2]|0)+-1)>>0]|0;q=f[v>>2]|0;d[(f[u>>2]|0)+(q<<1)>>1]=0;u=f[w>>2]|0;f[v>>2]=q+1;b[u+q>>0]=R;q=a+148+((R&255)<<2)|0;d[q>>1]=(d[q>>1]|0)+1<<16>>16;f[y>>2]=0}y=f[l>>2]|0;f[a+5812>>2]=y>>>0<2?y:2;if((c|0)==4){c=f[z>>2]|0;if((c|0)>-1)U=(f[k>>2]|0)+c|0;else U=0;snb(a,U,y-c|0,1);f[z>>2]=f[l>>2];c=f[a>>2]|0;U=f[c+28>>2]|0;qnb(U);q=U+20|0;R=f[q>>2]|0;u=c+16|0;w=f[u>>2]|0;r=R>>>0>w>>>0?w:R;if(r|0?(R=c+12|0,w=U+16|0,Vac(f[R>>2]|0,f[w>>2]|0,r|0)|0,f[R>>2]=(f[R>>2]|0)+r,f[w>>2]=(f[w>>2]|0)+r,R=c+20|0,f[R>>2]=(f[R>>2]|0)+r,f[u>>2]=(f[u>>2]|0)-r,u=(f[q>>2]|0)-r|0,f[q>>2]=u,(u|0)==0):0)f[w>>2]=f[U+8>>2];F=(f[(f[a>>2]|0)+16>>2]|0)==0?2:3;return F|0}if(f[v>>2]|0){v=f[z>>2]|0;if((v|0)>-1)V=(f[k>>2]|0)+v|0;else V=0;snb(a,V,y-v|0,0);f[z>>2]=f[l>>2];l=f[a>>2]|0;z=f[l+28>>2]|0;qnb(z);v=z+20|0;y=f[v>>2]|0;V=l+16|0;k=f[V>>2]|0;U=y>>>0>k>>>0?k:y;if(U|0?(y=l+12|0,k=z+16|0,Vac(f[y>>2]|0,f[k>>2]|0,U|0)|0,f[y>>2]=(f[y>>2]|0)+U,f[k>>2]=(f[k>>2]|0)+U,y=l+20|0,f[y>>2]=(f[y>>2]|0)+U,f[V>>2]=(f[V>>2]|0)-U,V=(f[v>>2]|0)-U|0,f[v>>2]=V,(V|0)==0):0)f[k>>2]=f[z+8>>2];if(!(f[(f[a>>2]|0)+16>>2]|0)){F=0;return F|0}}F=1;return F|0}else if((G|0)==55)return F|0;return 0}function jnb(a){a=a|0;var b=0,c=0,e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=a+44|0;c=f[b>>2]|0;e=a+60|0;g=a+116|0;i=a+108|0;k=c+-262|0;l=a+56|0;m=a+5812|0;n=a+72|0;o=a+88|0;p=a+84|0;q=a+68|0;r=a+64|0;s=a+52|0;t=a+112|0;u=a+92|0;v=a+76|0;w=f[g>>2]|0;x=c;while(1){y=f[i>>2]|0;z=(f[e>>2]|0)-w-y|0;if(y>>>0<(k+x|0)>>>0){A=z;B=y}else{y=f[l>>2]|0;Vac(y|0,y+c|0,c-z|0)|0;f[t>>2]=(f[t>>2]|0)-c;y=(f[i>>2]|0)-c|0;f[i>>2]=y;f[u>>2]=(f[u>>2]|0)-c;C=f[b>>2]|0;D=f[v>>2]|0;E=D;F=(f[q>>2]|0)+(D<<1)|0;do{F=F+-2|0;D=j[F>>1]|0;d[F>>1]=D>>>0<C>>>0?0:D-C&65535;E=E+-1|0}while((E|0)!=0);E=C;F=(f[r>>2]|0)+(C<<1)|0;do{F=F+-2|0;D=j[F>>1]|0;d[F>>1]=D>>>0<C>>>0?0:D-C&65535;E=E+-1|0}while((E|0)!=0);A=z+c|0;B=y}E=f[a>>2]|0;C=E+4|0;F=f[C>>2]|0;if(!F)break;D=f[g>>2]|0;G=(f[l>>2]|0)+B+D|0;H=F>>>0>A>>>0?A:F;if(!H){I=0;J=D}else{f[C>>2]=F-H;Vac(G|0,f[E>>2]|0,H|0)|0;switch(f[(f[E+28>>2]|0)+24>>2]|0){case 1:{F=E+48|0;K=F;L=anb(f[F>>2]|0,G,H)|0;M=13;break}case 2:{F=E+48|0;K=F;L=cnb(f[F>>2]|0,G,H)|0;M=13;break}default:{}}if((M|0)==13){M=0;f[K>>2]=L}f[E>>2]=(f[E>>2]|0)+H;G=E+8|0;f[G>>2]=(f[G>>2]|0)+H;I=H;J=f[g>>2]|0}H=J+I|0;f[g>>2]=H;G=f[m>>2]|0;a:do if((G+H|0)>>>0>2){E=(f[i>>2]|0)-G|0;F=f[l>>2]|0;C=h[F+E>>0]|0;f[n>>2]=C;D=f[o>>2]|0;N=f[p>>2]|0;O=((h[F+(E+1)>>0]|0)^C<<D)&N;f[n>>2]=O;C=E;E=G;P=O;while(1){if(!E)break a;P=((h[F+(C+2)>>0]|0)^P<<D)&N;f[n>>2]=P;O=(f[q>>2]|0)+(P<<1)|0;d[(f[r>>2]|0)+((f[s>>2]&C)<<1)>>1]=d[O>>1]|0;d[O>>1]=C;E=E+-1|0;f[m>>2]=E;if((H+E|0)>>>0<3)break;else C=C+1|0}}while(0);if(H>>>0>=262)break;if(!(f[(f[a>>2]|0)+4>>2]|0))break;w=H;x=f[b>>2]|0}b=a+5824|0;a=f[b>>2]|0;x=f[e>>2]|0;if(x>>>0<=a>>>0)return;e=(f[g>>2]|0)+(f[i>>2]|0)|0;do if(a>>>0>=e>>>0){i=e+258|0;if(i>>>0>a>>>0){g=i-a|0;i=x-a|0;w=g>>>0>i>>>0?i:g;Nac((f[l>>2]|0)+a|0,0,w|0)|0;Q=(f[b>>2]|0)+w|0;break}else return}else{w=x-e|0;g=w>>>0<258?w:258;Nac((f[l>>2]|0)+e|0,0,g|0)|0;Q=g+e|0}while(0);f[b>>2]=Q;return}function knb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=f[a+124>>2]|0;e=f[a+56>>2]|0;g=f[a+108>>2]|0;h=e+g|0;i=f[a+120>>2]|0;k=f[a+144>>2]|0;l=(f[a+44>>2]|0)+-262|0;m=g>>>0>l>>>0?g-l|0:0;l=f[a+64>>2]|0;g=f[a+52>>2]|0;n=f[a+116>>2]|0;o=k>>>0>n>>>0?n:k;k=a+112|0;p=h+1|0;q=h+258|0;r=b[h+i>>0]|0;s=b[h+(i+-1)>>0]|0;t=c;c=i;u=i>>>0<(f[a+140>>2]|0)>>>0?d:d>>>2;while(1){d=e+t|0;if((((b[d+c>>0]|0)==r<<24>>24?(b[d+(c+-1)>>0]|0)==s<<24>>24:0)?(b[d>>0]|0)==(b[h>>0]|0):0)?(a=d+1|0,(b[a>>0]|0)==(b[p>>0]|0)):0){d=2;i=a;while(1){a=h+d|0;v=a+1|0;if((b[v>>0]|0)!=(b[i+2>>0]|0)){w=v;break}v=a+2|0;if((b[v>>0]|0)!=(b[i+3>>0]|0)){w=v;break}v=a+3|0;if((b[v>>0]|0)!=(b[i+4>>0]|0)){w=v;break}v=a+4|0;if((b[v>>0]|0)!=(b[i+5>>0]|0)){w=v;break}v=a+5|0;if((b[v>>0]|0)!=(b[i+6>>0]|0)){w=v;break}v=a+6|0;if((b[v>>0]|0)!=(b[i+7>>0]|0)){w=v;break}v=a+7|0;a=i;i=i+8|0;if((b[v>>0]|0)!=(b[i>>0]|0)){w=v;break}d=d+8|0;v=h+d|0;if(!((d|0)<258?(b[v>>0]|0)==(b[a+9>>0]|0):0)){w=v;break}}d=w-q|0;i=d+258|0;if((i|0)>(c|0)){f[k>>2]=t;if((i|0)>=(o|0)){x=i;y=19;break}z=b[h+i>>0]|0;A=b[h+(d+257)>>0]|0;B=i}else{z=r;A=s;B=c}}else{z=r;A=s;B=c}t=j[l+((t&g)<<1)>>1]|0;if(t>>>0<=m>>>0){x=B;y=19;break}u=u+-1|0;if(!u){x=B;y=19;break}else{r=z;s=A;c=B}}if((y|0)==19)return (x>>>0>n>>>0?n:x)|0;return 0}function lnb(a){a=a|0;var b=0,c=0,e=0;b=fnb(a)|0;if(b|0)return b|0;c=f[a+28>>2]|0;f[c+60>>2]=f[c+44>>2]<<1;a=f[c+68>>2]|0;e=(f[c+76>>2]|0)+-1|0;d[a+(e<<1)>>1]=0;Nac(a|0,0,e<<1|0)|0;e=f[c+132>>2]|0;f[c+128>>2]=j[134916+(e*12|0)+2>>1];f[c+140>>2]=j[134916+(e*12|0)>>1];f[c+144>>2]=j[134916+(e*12|0)+4>>1];f[c+124>>2]=j[134916+(e*12|0)+6>>1];f[c+108>>2]=0;f[c+92>>2]=0;f[c+116>>2]=0;f[c+5812>>2]=0;f[c+120>>2]=2;f[c+96>>2]=2;f[c+104>>2]=0;f[c+72>>2]=0;return b|0}function mnb(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;if(!a){e=-2;return e|0}if(!(f[a+32>>2]|0)){e=-2;return e|0}if(!(f[a+36>>2]|0)){e=-2;return e|0}g=a+28|0;i=f[g>>2]|0;if(!i){e=-2;return e|0}if((f[i>>2]|0)!=(a|0)){e=-2;return e|0}j=i+4|0;k=f[j>>2]|0;switch(k|0){case 666:case 113:case 103:case 91:case 73:case 69:case 57:case 42:break;default:{e=-2;return e|0}}if(c>>>0>5){e=-2;return e|0}l=a+12|0;do if(f[l>>2]|0){m=a+4|0;n=(f[m>>2]|0)==0;if(!n?(f[a>>2]|0)==0:0)break;o=(c|0)!=4;if(!(o&(k|0)==666)){p=a+16|0;if(!(f[p>>2]|0)){f[a+24>>2]=f[31678];e=-5;return e|0}q=i+40|0;r=f[q>>2]|0;f[q>>2]=c;s=i+20|0;do if(!(f[s>>2]|0))if(n?o&((c<<1)-((c|0)>4?9:0)|0)<=((r<<1)-((r|0)>4?9:0)|0):0){f[a+24>>2]=f[31678];e=-5;return e|0}else{t=0;u=k}else{qnb(i);v=f[s>>2]|0;w=f[p>>2]|0;x=v>>>0>w>>>0?w:v;if(x){y=i+16|0;Vac(f[l>>2]|0,f[y>>2]|0,x|0)|0;f[l>>2]=(f[l>>2]|0)+x;f[y>>2]=(f[y>>2]|0)+x;z=a+20|0;f[z>>2]=(f[z>>2]|0)+x;z=(f[p>>2]|0)-x|0;f[p>>2]=z;A=(f[s>>2]|0)-x|0;f[s>>2]=A;if(!A){f[y>>2]=f[i+8>>2];B=0;C=z}else{B=A;C=z}}else{B=v;C=w}if(C|0){t=B;u=f[j>>2]|0;break}f[q>>2]=-1;e=0;return e|0}while(0);a:do switch(u|0){case 666:{if(!(f[m>>2]|0))D=123;else{f[a+24>>2]=f[31678];e=-5;return e|0}break}case 42:{r=(f[i+48>>2]<<12)+-30720|0;if((f[i+136>>2]|0)<=1?(n=f[i+132>>2]|0,(n|0)>=2):0)E=(n|0)<6?64:(n|0)==6?128:192;else E=0;n=E|r;r=i+108|0;w=(f[r>>2]|0)==0?n:n|32;n=(((w>>>0)%31|0)^31)+w|0;w=i+8|0;v=f[w>>2]|0;f[s>>2]=t+1;b[v+t>>0]=n>>>8;v=f[w>>2]|0;z=f[s>>2]|0;f[s>>2]=z+1;b[v+z>>0]=n;n=a+48|0;if(f[r>>2]|0){r=f[n>>2]|0;z=f[w>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[z+v>>0]=r>>>24;v=f[w>>2]|0;z=f[s>>2]|0;f[s>>2]=z+1;b[v+z>>0]=r>>>16;r=f[n>>2]|0;z=f[w>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[z+v>>0]=r>>>8;v=f[w>>2]|0;w=f[s>>2]|0;f[s>>2]=w+1;b[v+w>>0]=r}r=anb(0,0,0)|0;f[n>>2]=r;f[j>>2]=113;r=f[g>>2]|0;qnb(r);n=r+20|0;w=f[n>>2]|0;v=f[p>>2]|0;z=w>>>0>v>>>0?v:w;if(z|0?(w=r+16|0,Vac(f[l>>2]|0,f[w>>2]|0,z|0)|0,f[l>>2]=(f[l>>2]|0)+z,f[w>>2]=(f[w>>2]|0)+z,v=a+20|0,f[v>>2]=(f[v>>2]|0)+z,f[p>>2]=(f[p>>2]|0)-z,v=(f[n>>2]|0)-z|0,f[n>>2]=v,(v|0)==0):0)f[w>>2]=f[r+8>>2];if(!(f[s>>2]|0)){F=f[j>>2]|0;D=39;break a}f[q>>2]=-1;e=0;return e|0}default:{F=u;D=39}}while(0);if((D|0)==39){do if((F|0)==57){r=cnb(0,0,0)|0;w=a+48|0;f[w>>2]=r;r=i+8|0;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=31;n=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[n+v>>0]=-117;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=8;n=i+28|0;v=f[n>>2]|0;if(v|0){z=((f[v+44>>2]|0?2:0)|(f[v>>2]|0)!=0|((f[v+16>>2]|0)==0?0:4)|((f[v+28>>2]|0)==0?0:8)|((f[v+36>>2]|0)==0?0:16))&255;v=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[v+A>>0]=z;z=f[(f[n>>2]|0)+4>>2]&255;A=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[A+v>>0]=z;z=(f[(f[n>>2]|0)+4>>2]|0)>>>8&255;v=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[v+A>>0]=z;z=(f[(f[n>>2]|0)+4>>2]|0)>>>16&255;A=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[A+v>>0]=z;z=(f[(f[n>>2]|0)+4>>2]|0)>>>24&255;v=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[v+A>>0]=z;z=f[i+132>>2]|0;if((z|0)==9)G=2;else G=((z|0)<2?1:(f[i+136>>2]|0)>1)?4:0;z=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[z+A>>0]=G;A=f[(f[n>>2]|0)+12>>2]&255;z=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[z+v>>0]=A;A=f[n>>2]|0;if(!(f[A+16>>2]|0))H=A;else{v=f[A+20>>2]&255;A=f[r>>2]|0;z=f[s>>2]|0;f[s>>2]=z+1;b[A+z>>0]=v;v=(f[(f[n>>2]|0)+20>>2]|0)>>>8&255;z=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[z+A>>0]=v;H=f[n>>2]|0}if(f[H+44>>2]|0){v=cnb(f[w>>2]|0,f[r>>2]|0,f[s>>2]|0)|0;f[w>>2]=v}f[i+32>>2]=0;f[j>>2]=69;I=n;D=59;break}n=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[n+v>>0]=0;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=0;n=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[n+v>>0]=0;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=0;n=f[r>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[n+v>>0]=0;v=f[i+132>>2]|0;if((v|0)==9)J=2;else J=((v|0)<2?1:(f[i+136>>2]|0)>1)?4:0;v=f[r>>2]|0;n=f[s>>2]|0;f[s>>2]=n+1;b[v+n>>0]=J;n=f[r>>2]|0;r=f[s>>2]|0;f[s>>2]=r+1;b[n+r>>0]=3;f[j>>2]=113;r=f[g>>2]|0;qnb(r);n=r+20|0;v=f[n>>2]|0;w=f[p>>2]|0;A=v>>>0>w>>>0?w:v;if(A|0?(v=r+16|0,Vac(f[l>>2]|0,f[v>>2]|0,A|0)|0,f[l>>2]=(f[l>>2]|0)+A,f[v>>2]=(f[v>>2]|0)+A,w=a+20|0,f[w>>2]=(f[w>>2]|0)+A,f[p>>2]=(f[p>>2]|0)-A,w=(f[n>>2]|0)-A|0,f[n>>2]=w,(w|0)==0):0)f[v>>2]=f[r+8>>2];if(!(f[s>>2]|0)){K=f[j>>2]|0;D=56;break}f[q>>2]=-1;e=0;return e|0}else{K=F;D=56}while(0);b:do if((D|0)==56)switch(K|0){case 69:{I=i+28|0;D=59;break b;break}case 73:{L=i+28|0;D=74;break b;break}case 91:{M=i+28|0;D=93;break b;break}case 103:{N=i+28|0;D=109;break b;break}default:break b}while(0);if((D|0)==59){r=f[I>>2]|0;v=f[r+16>>2]|0;if(v|0){w=f[s>>2]|0;n=i+32|0;A=f[n>>2]|0;z=(f[r+20>>2]&65535)-A|0;r=i+12|0;y=f[r>>2]|0;x=i+8|0;c:do if((w+z|0)>>>0>y>>>0){O=a+48|0;P=a+20|0;Q=z;R=w;S=y;T=v;U=A;while(1){V=S-R|0;Vac((f[x>>2]|0)+R|0,T+U|0,V|0)|0;W=f[r>>2]|0;f[s>>2]=W;if(W>>>0>R>>>0?(f[(f[I>>2]|0)+44>>2]|0)!=0:0){X=cnb(f[O>>2]|0,(f[x>>2]|0)+R|0,W-R|0)|0;f[O>>2]=X}f[n>>2]=(f[n>>2]|0)+V;X=f[g>>2]|0;qnb(X);W=X+20|0;Y=f[W>>2]|0;Z=f[p>>2]|0;_=Y>>>0>Z>>>0?Z:Y;do if(_|0){Y=X+16|0;Vac(f[l>>2]|0,f[Y>>2]|0,_|0)|0;f[l>>2]=(f[l>>2]|0)+_;f[Y>>2]=(f[Y>>2]|0)+_;f[P>>2]=(f[P>>2]|0)+_;f[p>>2]=(f[p>>2]|0)-_;Z=(f[W>>2]|0)-_|0;f[W>>2]=Z;if(Z|0)break;f[Y>>2]=f[X+8>>2]}while(0);if(f[s>>2]|0)break;X=Q-V|0;S=f[r>>2]|0;W=f[(f[I>>2]|0)+16>>2]|0;_=f[n>>2]|0;if(X>>>0<=S>>>0){$=X;aa=0;ba=W;ca=_;break c}else{Q=X;R=0;T=W;U=_}}f[q>>2]=-1;e=0;return e|0}else{$=z;aa=w;ba=v;ca=A}while(0);Vac((f[x>>2]|0)+aa|0,ba+ca|0,$|0)|0;A=(f[s>>2]|0)+$|0;f[s>>2]=A;if(A>>>0>aa>>>0?(f[(f[I>>2]|0)+44>>2]|0)!=0:0){v=a+48|0;w=cnb(f[v>>2]|0,(f[x>>2]|0)+aa|0,A-aa|0)|0;f[v>>2]=w}f[n>>2]=0}f[j>>2]=73;L=I;D=74}if((D|0)==74){if(f[(f[L>>2]|0)+28>>2]|0){w=f[s>>2]|0;v=i+12|0;A=a+48|0;z=i+8|0;r=a+20|0;y=i+32|0;U=w;T=w;while(1){if((T|0)==(f[v>>2]|0)){if(T>>>0>U>>>0?(f[(f[L>>2]|0)+44>>2]|0)!=0:0){w=cnb(f[A>>2]|0,(f[z>>2]|0)+U|0,T-U|0)|0;f[A>>2]=w}w=f[g>>2]|0;qnb(w);R=w+20|0;Q=f[R>>2]|0;S=f[p>>2]|0;P=Q>>>0>S>>>0?S:Q;do if(P|0){Q=w+16|0;Vac(f[l>>2]|0,f[Q>>2]|0,P|0)|0;f[l>>2]=(f[l>>2]|0)+P;f[Q>>2]=(f[Q>>2]|0)+P;f[r>>2]=(f[r>>2]|0)+P;f[p>>2]=(f[p>>2]|0)-P;S=(f[R>>2]|0)-P|0;f[R>>2]=S;if(S|0)break;f[Q>>2]=f[w+8>>2]}while(0);if(!(f[s>>2]|0)){da=0;ea=0}else{D=83;break}}else{da=U;ea=T}w=f[(f[L>>2]|0)+28>>2]|0;R=f[y>>2]|0;f[y>>2]=R+1;P=b[w+R>>0]|0;R=f[z>>2]|0;f[s>>2]=ea+1;b[R+ea>>0]=P;if(!(P<<24>>24))break;U=da;T=f[s>>2]|0}if((D|0)==83){f[q>>2]=-1;e=0;return e|0}if(f[(f[L>>2]|0)+44>>2]|0?(T=f[s>>2]|0,T>>>0>da>>>0):0){U=cnb(f[A>>2]|0,(f[z>>2]|0)+da|0,T-da|0)|0;f[A>>2]=U}f[y>>2]=0}f[j>>2]=91;M=L;D=93}if((D|0)==93){if(f[(f[M>>2]|0)+36>>2]|0){U=f[s>>2]|0;T=i+12|0;r=a+48|0;v=i+8|0;n=a+20|0;x=i+32|0;P=U;R=U;while(1){if((R|0)==(f[T>>2]|0)){if(R>>>0>P>>>0?(f[(f[M>>2]|0)+44>>2]|0)!=0:0){U=cnb(f[r>>2]|0,(f[v>>2]|0)+P|0,R-P|0)|0;f[r>>2]=U}U=f[g>>2]|0;qnb(U);w=U+20|0;Q=f[w>>2]|0;S=f[p>>2]|0;O=Q>>>0>S>>>0?S:Q;do if(O|0){Q=U+16|0;Vac(f[l>>2]|0,f[Q>>2]|0,O|0)|0;f[l>>2]=(f[l>>2]|0)+O;f[Q>>2]=(f[Q>>2]|0)+O;f[n>>2]=(f[n>>2]|0)+O;f[p>>2]=(f[p>>2]|0)-O;S=(f[w>>2]|0)-O|0;f[w>>2]=S;if(S|0)break;f[Q>>2]=f[U+8>>2]}while(0);if(!(f[s>>2]|0)){fa=0;ga=0}else{D=102;break}}else{fa=P;ga=R}U=f[(f[M>>2]|0)+36>>2]|0;w=f[x>>2]|0;f[x>>2]=w+1;O=b[U+w>>0]|0;w=f[v>>2]|0;f[s>>2]=ga+1;b[w+ga>>0]=O;if(!(O<<24>>24))break;P=fa;R=f[s>>2]|0}if((D|0)==102){f[q>>2]=-1;e=0;return e|0}if(f[(f[M>>2]|0)+44>>2]|0?(R=f[s>>2]|0,R>>>0>fa>>>0):0){P=cnb(f[r>>2]|0,(f[v>>2]|0)+fa|0,R-fa|0)|0;f[r>>2]=P}}f[j>>2]=103;N=M;D=109}if((D|0)==109){if(f[(f[N>>2]|0)+44>>2]|0){P=f[s>>2]|0;do if((P+2|0)>>>0>(f[i+12>>2]|0)>>>0){R=f[g>>2]|0;qnb(R);x=R+20|0;n=f[x>>2]|0;T=f[p>>2]|0;y=n>>>0>T>>>0?T:n;do if(y|0){n=R+16|0;Vac(f[l>>2]|0,f[n>>2]|0,y|0)|0;f[l>>2]=(f[l>>2]|0)+y;f[n>>2]=(f[n>>2]|0)+y;T=a+20|0;f[T>>2]=(f[T>>2]|0)+y;f[p>>2]=(f[p>>2]|0)-y;T=(f[x>>2]|0)-y|0;f[x>>2]=T;if(T|0)break;f[n>>2]=f[R+8>>2]}while(0);if(!(f[s>>2]|0)){ha=0;break}f[q>>2]=-1;e=0;return e|0}else ha=P;while(0);P=a+48|0;r=f[P>>2]&255;v=i+8|0;R=f[v>>2]|0;f[s>>2]=ha+1;b[R+ha>>0]=r;r=(f[P>>2]|0)>>>8&255;R=f[v>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[R+v>>0]=r;r=cnb(0,0,0)|0;f[P>>2]=r}f[j>>2]=113;r=f[g>>2]|0;qnb(r);P=r+20|0;v=f[P>>2]|0;R=f[p>>2]|0;x=v>>>0>R>>>0?R:v;if(x|0?(v=r+16|0,Vac(f[l>>2]|0,f[v>>2]|0,x|0)|0,f[l>>2]=(f[l>>2]|0)+x,f[v>>2]=(f[v>>2]|0)+x,R=a+20|0,f[R>>2]=(f[R>>2]|0)+x,f[p>>2]=(f[p>>2]|0)-x,R=(f[P>>2]|0)-x|0,f[P>>2]=R,(R|0)==0):0)f[v>>2]=f[r+8>>2];if(f[s>>2]|0){f[q>>2]=-1;e=0;return e|0}}if(!(f[m>>2]|0))D=123;else D=126}if((D|0)==123)if(!(f[i+116>>2]|0)){if(c|0?(f[j>>2]|0)!=666:0)D=126}else D=126;do if((D|0)==126){r=f[i+132>>2]|0;d:do if(!r){ia=gnb(i,c)|0;D=200}else switch(f[i+136>>2]|0){case 2:{v=i+116|0;R=i+96|0;P=i+56|0;x=i+108|0;y=i+5796|0;n=i+5792|0;T=i+5784|0;A=i+5788|0;z=i+92|0;while(1){if((f[v>>2]|0)==0?(jnb(i),(f[v>>2]|0)==0):0)break;f[R>>2]=0;O=b[(f[P>>2]|0)+(f[x>>2]|0)>>0]|0;w=f[n>>2]|0;d[(f[y>>2]|0)+(w<<1)>>1]=0;U=f[T>>2]|0;f[n>>2]=w+1;b[U+w>>0]=O;w=i+148+((O&255)<<2)|0;d[w>>1]=(d[w>>1]|0)+1<<16>>16;w=(f[n>>2]|0)==((f[A>>2]|0)+-1|0);f[v>>2]=(f[v>>2]|0)+-1;O=(f[x>>2]|0)+1|0;f[x>>2]=O;if(!w)continue;w=f[z>>2]|0;if((w|0)>-1)ja=(f[P>>2]|0)+w|0;else ja=0;snb(i,ja,O-w|0,0);f[z>>2]=f[x>>2];w=f[i>>2]|0;O=f[w+28>>2]|0;qnb(O);U=O+20|0;Q=f[U>>2]|0;S=w+16|0;_=f[S>>2]|0;W=Q>>>0>_>>>0?_:Q;do if(W|0){Q=w+12|0;_=O+16|0;Vac(f[Q>>2]|0,f[_>>2]|0,W|0)|0;f[Q>>2]=(f[Q>>2]|0)+W;f[_>>2]=(f[_>>2]|0)+W;Q=w+20|0;f[Q>>2]=(f[Q>>2]|0)+W;f[S>>2]=(f[S>>2]|0)-W;Q=(f[U>>2]|0)-W|0;f[U>>2]=Q;if(Q|0)break;f[_>>2]=f[O+8>>2]}while(0);if(!(f[(f[i>>2]|0)+16>>2]|0)){D=203;break d}}if(!c){D=203;break d}f[i+5812>>2]=0;if((c|0)==4){v=f[z>>2]|0;if((v|0)>-1)ka=(f[P>>2]|0)+v|0;else ka=0;snb(i,ka,(f[x>>2]|0)-v|0,1);f[z>>2]=f[x>>2];v=f[i>>2]|0;A=f[v+28>>2]|0;qnb(A);T=A+20|0;y=f[T>>2]|0;R=v+16|0;V=f[R>>2]|0;O=y>>>0>V>>>0?V:y;do if(O|0){y=v+12|0;V=A+16|0;Vac(f[y>>2]|0,f[V>>2]|0,O|0)|0;f[y>>2]=(f[y>>2]|0)+O;f[V>>2]=(f[V>>2]|0)+O;y=v+20|0;f[y>>2]=(f[y>>2]|0)+O;f[R>>2]=(f[R>>2]|0)-O;y=(f[T>>2]|0)-O|0;f[T>>2]=y;if(y|0)break;f[V>>2]=f[A+8>>2]}while(0);ia=(f[(f[i>>2]|0)+16>>2]|0)==0?2:3;D=200;break d}if(!(f[n>>2]|0))break d;A=f[z>>2]|0;if((A|0)>-1)la=(f[P>>2]|0)+A|0;else la=0;snb(i,la,(f[x>>2]|0)-A|0,0);f[z>>2]=f[x>>2];A=f[i>>2]|0;T=f[A+28>>2]|0;qnb(T);O=T+20|0;R=f[O>>2]|0;v=A+16|0;V=f[v>>2]|0;y=R>>>0>V>>>0?V:R;do if(y|0){R=A+12|0;V=T+16|0;Vac(f[R>>2]|0,f[V>>2]|0,y|0)|0;f[R>>2]=(f[R>>2]|0)+y;f[V>>2]=(f[V>>2]|0)+y;R=A+20|0;f[R>>2]=(f[R>>2]|0)+y;f[v>>2]=(f[v>>2]|0)-y;R=(f[O>>2]|0)-y|0;f[O>>2]=R;if(R|0)break;f[V>>2]=f[T+8>>2]}while(0);if(!(f[(f[i>>2]|0)+16>>2]|0)){D=203;break d}else break d;break}case 3:{T=i+116|0;O=(c|0)==0;y=i+96|0;v=i+108|0;A=i+5784|0;x=i+5796|0;z=i+5792|0;P=i+5788|0;n=i+56|0;V=i+92|0;e:while(1){R=f[T>>2]|0;do if(R>>>0<259){jnb(i);U=f[T>>2]|0;if(O&U>>>0<259){D=203;break d}if(!U)break e;f[y>>2]=0;if(U>>>0>2){ma=U;D=161;break}na=f[v>>2]|0;oa=f[x>>2]|0;pa=f[A>>2]|0;D=177}else{f[y>>2]=0;ma=R;D=161}while(0);f:do if((D|0)==161){D=0;R=f[v>>2]|0;do if(R|0){U=(f[n>>2]|0)+R|0;W=b[U+-1>>0]|0;if(W<<24>>24!=(b[U>>0]|0))break;S=U+1|0;if(W<<24>>24!=(b[S>>0]|0))break;if(W<<24>>24!=(b[S+1>>0]|0))break;S=U+258|0;w=1;while(1){_=U+w|0;Q=_+2|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+3|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+4|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+5|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+6|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=_+7|0;if(W<<24>>24!=(b[Q>>0]|0)){qa=Q;break}Q=w;w=w+8|0;_=U+w|0;if(W<<24>>24!=(b[_>>0]|0)){qa=_;break}_=Q+9|0;Q=U+_|0;if(!((_|0)<258?W<<24>>24==(b[Q>>0]|0):0)){qa=Q;break}}W=qa-S+258|0;U=W>>>0>ma>>>0?ma:W;f[y>>2]=U;W=f[A>>2]|0;w=f[x>>2]|0;if(U>>>0<=2){na=R;oa=w;pa=W;D=177;break f}Q=U+253|0;U=f[z>>2]|0;d[w+(U<<1)>>1]=1;f[z>>2]=U+1;b[W+U>>0]=Q;U=i+148+((h[446151+(Q&255)>>0]|256)+1<<2)|0;d[U>>1]=(d[U>>1]|0)+1<<16>>16;U=i+2440+(h[445639]<<2)|0;d[U>>1]=(d[U>>1]|0)+1<<16>>16;U=(f[z>>2]|0)==((f[P>>2]|0)+-1|0)&1;Q=f[y>>2]|0;f[T>>2]=(f[T>>2]|0)-Q;W=(f[v>>2]|0)+Q|0;f[v>>2]=W;f[y>>2]=0;ra=U;sa=W;break f}while(0);na=R;oa=f[x>>2]|0;pa=f[A>>2]|0;D=177}while(0);if((D|0)==177){D=0;W=b[(f[n>>2]|0)+na>>0]|0;U=f[z>>2]|0;d[oa+(U<<1)>>1]=0;f[z>>2]=U+1;b[pa+U>>0]=W;U=i+148+((W&255)<<2)|0;d[U>>1]=(d[U>>1]|0)+1<<16>>16;U=(f[z>>2]|0)==((f[P>>2]|0)+-1|0)&1;f[T>>2]=(f[T>>2]|0)+-1;W=(f[v>>2]|0)+1|0;f[v>>2]=W;ra=U;sa=W}if(!ra)continue;W=f[V>>2]|0;if((W|0)>-1)ta=(f[n>>2]|0)+W|0;else ta=0;snb(i,ta,sa-W|0,0);f[V>>2]=f[v>>2];W=f[i>>2]|0;U=f[W+28>>2]|0;qnb(U);Q=U+20|0;w=f[Q>>2]|0;_=W+16|0;X=f[_>>2]|0;Y=w>>>0>X>>>0?X:w;do if(Y|0){w=W+12|0;X=U+16|0;Vac(f[w>>2]|0,f[X>>2]|0,Y|0)|0;f[w>>2]=(f[w>>2]|0)+Y;f[X>>2]=(f[X>>2]|0)+Y;w=W+20|0;f[w>>2]=(f[w>>2]|0)+Y;f[_>>2]=(f[_>>2]|0)-Y;w=(f[Q>>2]|0)-Y|0;f[Q>>2]=w;if(w|0)break;f[X>>2]=f[U+8>>2]}while(0);if(!(f[(f[i>>2]|0)+16>>2]|0)){D=203;break d}}f[i+5812>>2]=0;if((c|0)==4){T=f[V>>2]|0;if((T|0)>-1)ua=(f[n>>2]|0)+T|0;else ua=0;snb(i,ua,(f[v>>2]|0)-T|0,1);f[V>>2]=f[v>>2];T=f[i>>2]|0;P=f[T+28>>2]|0;qnb(P);A=P+20|0;x=f[A>>2]|0;y=T+16|0;O=f[y>>2]|0;U=x>>>0>O>>>0?O:x;do if(U|0){x=T+12|0;O=P+16|0;Vac(f[x>>2]|0,f[O>>2]|0,U|0)|0;f[x>>2]=(f[x>>2]|0)+U;f[O>>2]=(f[O>>2]|0)+U;x=T+20|0;f[x>>2]=(f[x>>2]|0)+U;f[y>>2]=(f[y>>2]|0)-U;x=(f[A>>2]|0)-U|0;f[A>>2]=x;if(x|0)break;f[O>>2]=f[P+8>>2]}while(0);ia=(f[(f[i>>2]|0)+16>>2]|0)==0?2:3;D=200;break d}if(!(f[z>>2]|0))break d;P=f[V>>2]|0;if((P|0)>-1)va=(f[n>>2]|0)+P|0;else va=0;snb(i,va,(f[v>>2]|0)-P|0,0);f[V>>2]=f[v>>2];P=f[i>>2]|0;A=f[P+28>>2]|0;qnb(A);U=A+20|0;y=f[U>>2]|0;T=P+16|0;O=f[T>>2]|0;x=y>>>0>O>>>0?O:y;do if(x|0){y=P+12|0;O=A+16|0;Vac(f[y>>2]|0,f[O>>2]|0,x|0)|0;f[y>>2]=(f[y>>2]|0)+x;f[O>>2]=(f[O>>2]|0)+x;y=P+20|0;f[y>>2]=(f[y>>2]|0)+x;f[T>>2]=(f[T>>2]|0)-x;y=(f[U>>2]|0)-x|0;f[U>>2]=y;if(y|0)break;f[O>>2]=f[A+8>>2]}while(0);if(!(f[(f[i>>2]|0)+16>>2]|0)){D=203;break d}else break d;break}default:{ia=Uh[f[134916+(r*12|0)+8>>2]&1023](i,c)|0;D=200;break d}}while(0);if((D|0)==200){if((ia|1|0)==3)f[j>>2]=666;if((ia|2|0)!=2){if((ia|0)!=1)break}else D=203}if((D|0)==203){if(f[p>>2]|0){e=0;return e|0}f[q>>2]=-1;e=0;return e|0}switch(c|0){case 1:{rnb(i);break}case 5:break;default:{pnb(i,0,0,0);if((c|0)==3?(r=f[i+68>>2]|0,A=(f[i+76>>2]|0)+-1|0,d[r+(A<<1)>>1]=0,Nac(r|0,0,A<<1|0)|0,(f[i+116>>2]|0)==0):0){f[i+108>>2]=0;f[i+92>>2]=0;f[i+5812>>2]=0}}}A=f[g>>2]|0;qnb(A);r=A+20|0;U=f[r>>2]|0;x=f[p>>2]|0;T=U>>>0>x>>>0?x:U;if(T){U=A+16|0;Vac(f[l>>2]|0,f[U>>2]|0,T|0)|0;f[l>>2]=(f[l>>2]|0)+T;f[U>>2]=(f[U>>2]|0)+T;P=a+20|0;f[P>>2]=(f[P>>2]|0)+T;P=(f[p>>2]|0)-T|0;f[p>>2]=P;v=(f[r>>2]|0)-T|0;f[r>>2]=v;if(!v){f[U>>2]=f[A+8>>2];wa=P}else wa=P}else wa=x;if(!wa){f[q>>2]=-1;e=0;return e|0}}while(0);if(o){e=0;return e|0}q=i+24|0;m=f[q>>2]|0;if((m|0)<1){e=1;return e|0}x=a+48|0;P=f[x>>2]|0;if((m|0)==2){m=i+8|0;A=f[m>>2]|0;U=f[s>>2]|0;f[s>>2]=U+1;b[A+U>>0]=P;U=(f[x>>2]|0)>>>8&255;A=f[m>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[A+v>>0]=U;U=(f[x>>2]|0)>>>16&255;v=f[m>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[v+A>>0]=U;U=(f[x>>2]|0)>>>24&255;A=f[m>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[A+v>>0]=U;U=a+8|0;v=f[U>>2]&255;A=f[m>>2]|0;r=f[s>>2]|0;f[s>>2]=r+1;b[A+r>>0]=v;v=(f[U>>2]|0)>>>8&255;r=f[m>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[r+A>>0]=v;v=(f[U>>2]|0)>>>16&255;A=f[m>>2]|0;r=f[s>>2]|0;f[s>>2]=r+1;b[A+r>>0]=v;v=(f[U>>2]|0)>>>24;U=f[m>>2]|0;m=f[s>>2]|0;f[s>>2]=m+1;xa=v;ya=U+m|0}else{m=i+8|0;U=f[m>>2]|0;v=f[s>>2]|0;f[s>>2]=v+1;b[U+v>>0]=P>>>24;v=f[m>>2]|0;U=f[s>>2]|0;f[s>>2]=U+1;b[v+U>>0]=P>>>16;P=f[x>>2]|0;x=f[m>>2]|0;U=f[s>>2]|0;f[s>>2]=U+1;b[x+U>>0]=P>>>8;U=f[m>>2]|0;m=f[s>>2]|0;f[s>>2]=m+1;xa=P;ya=U+m|0}b[ya>>0]=xa;m=f[g>>2]|0;qnb(m);U=m+20|0;P=f[U>>2]|0;x=f[p>>2]|0;v=P>>>0>x>>>0?x:P;if(v|0?(P=m+16|0,Vac(f[l>>2]|0,f[P>>2]|0,v|0)|0,f[l>>2]=(f[l>>2]|0)+v,f[P>>2]=(f[P>>2]|0)+v,x=a+20|0,f[x>>2]=(f[x>>2]|0)+v,f[p>>2]=(f[p>>2]|0)-v,x=(f[U>>2]|0)-v|0,f[U>>2]=x,(x|0)==0):0)f[P>>2]=f[m+8>>2];m=f[q>>2]|0;if((m|0)>0)f[q>>2]=0-m;e=(f[s>>2]|0)==0&1;return e|0}}while(0);f[a+24>>2]=f[31675];e=-2;return e|0}function nnb(a){a=a|0;f[a+2840>>2]=a+148;f[a+2848>>2]=135036;f[a+2852>>2]=a+2440;f[a+2860>>2]=135056;f[a+2864>>2]=a+2684;f[a+2872>>2]=135076;d[a+5816>>1]=0;f[a+5820>>2]=0;onb(a);return}function onb(a){a=a|0;var b=0;b=0;do{d[a+148+(b<<2)>>1]=0;b=b+1|0}while((b|0)!=286);d[a+2440>>1]=0;d[a+2444>>1]=0;d[a+2448>>1]=0;d[a+2452>>1]=0;d[a+2456>>1]=0;d[a+2460>>1]=0;d[a+2464>>1]=0;d[a+2468>>1]=0;d[a+2472>>1]=0;d[a+2476>>1]=0;d[a+2480>>1]=0;d[a+2484>>1]=0;d[a+2488>>1]=0;d[a+2492>>1]=0;d[a+2496>>1]=0;d[a+2500>>1]=0;d[a+2504>>1]=0;d[a+2508>>1]=0;d[a+2512>>1]=0;d[a+2516>>1]=0;d[a+2520>>1]=0;d[a+2524>>1]=0;d[a+2528>>1]=0;d[a+2532>>1]=0;d[a+2536>>1]=0;d[a+2540>>1]=0;d[a+2544>>1]=0;d[a+2548>>1]=0;d[a+2552>>1]=0;d[a+2556>>1]=0;d[a+2684>>1]=0;d[a+2688>>1]=0;d[a+2692>>1]=0;d[a+2696>>1]=0;d[a+2700>>1]=0;d[a+2704>>1]=0;d[a+2708>>1]=0;d[a+2712>>1]=0;d[a+2716>>1]=0;d[a+2720>>1]=0;d[a+2724>>1]=0;d[a+2728>>1]=0;d[a+2732>>1]=0;d[a+2736>>1]=0;d[a+2740>>1]=0;d[a+2744>>1]=0;d[a+2748>>1]=0;d[a+2752>>1]=0;d[a+2756>>1]=0;d[a+1172>>1]=1;f[a+5804>>2]=0;f[a+5800>>2]=0;f[a+5808>>2]=0;f[a+5792>>2]=0;return}function pnb(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=a+5820|0;i=f[h>>2]|0;k=g&65535;g=a+5816|0;l=j[g>>1]|0|k<<i;d[g>>1]=l;if((i|0)>13){m=a+8|0;n=f[m>>2]|0;o=a+20|0;p=f[o>>2]|0;f[o>>2]=p+1;b[n+p>>0]=l;p=(j[g>>1]|0)>>>8&255;n=f[m>>2]|0;m=f[o>>2]|0;f[o>>2]=m+1;b[n+m>>0]=p;p=f[h>>2]|0;m=k>>>(16-p|0);d[g>>1]=m;q=m;r=p+-13|0}else{q=l;r=i+3|0}i=q&255;f[h>>2]=r;if((r|0)<=8){if((r|0)>0){r=f[a+8>>2]|0;q=a+20|0;l=f[q>>2]|0;f[q>>2]=l+1;s=i;t=r+l|0;u=8}}else{l=a+8|0;r=f[l>>2]|0;q=a+20|0;p=f[q>>2]|0;f[q>>2]=p+1;b[r+p>>0]=i;i=(j[g>>1]|0)>>>8&255;p=f[l>>2]|0;l=f[q>>2]|0;f[q>>2]=l+1;s=i;t=p+l|0;u=8}if((u|0)==8)b[t>>0]=s;d[g>>1]=0;f[h>>2]=0;h=a+8|0;g=f[h>>2]|0;s=a+20|0;a=f[s>>2]|0;f[s>>2]=a+1;b[g+a>>0]=e;a=f[h>>2]|0;g=f[s>>2]|0;f[s>>2]=g+1;b[a+g>>0]=e>>>8;g=e&65535^65535;a=f[h>>2]|0;t=f[s>>2]|0;f[s>>2]=t+1;b[a+t>>0]=g;t=f[h>>2]|0;a=f[s>>2]|0;f[s>>2]=a+1;b[t+a>>0]=g>>>8;Vac((f[h>>2]|0)+(f[s>>2]|0)|0,c|0,e|0)|0;f[s>>2]=(f[s>>2]|0)+e;return}function qnb(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0;c=a+5820|0;e=f[c>>2]|0;do if((e|0)!=16)if((e|0)>7){g=a+5816|0;h=d[g>>1]&255;i=f[a+8>>2]|0;k=a+20|0;l=f[k>>2]|0;f[k>>2]=l+1;b[i+l>>0]=h;d[g>>1]=(j[g>>1]|0)>>>8;m=(f[c>>2]|0)+-8|0;break}else return;else{g=a+5816|0;h=d[g>>1]&255;l=a+8|0;i=f[l>>2]|0;k=a+20|0;n=f[k>>2]|0;f[k>>2]=n+1;b[i+n>>0]=h;h=(j[g>>1]|0)>>>8&255;n=f[l>>2]|0;l=f[k>>2]|0;f[k>>2]=l+1;b[n+l>>0]=h;d[g>>1]=0;m=0}while(0);f[c>>2]=m;return}function rnb(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+5820|0;e=f[c>>2]|0;g=a+5816|0;h=j[g>>1]|0|2<<e;d[g>>1]=h;if((e|0)>13){i=a+8|0;k=f[i>>2]|0;l=a+20|0;m=f[l>>2]|0;f[l>>2]=m+1;b[k+m>>0]=h;m=(j[g>>1]|0)>>>8&255;k=f[i>>2]|0;i=f[l>>2]|0;f[l>>2]=i+1;b[k+i>>0]=m;m=f[c>>2]|0;i=2>>>(16-m|0);d[g>>1]=i;n=i;o=m+-13|0}else{n=h;o=e+3|0}e=n&255;f[c>>2]=o;if((o|0)>9){n=a+8|0;h=f[n>>2]|0;m=a+20|0;i=f[m>>2]|0;f[m>>2]=i+1;b[h+i>>0]=e;i=(j[g>>1]|0)>>>8&255;h=f[n>>2]|0;n=f[m>>2]|0;f[m>>2]=n+1;b[h+n>>0]=i;i=f[c>>2]|0;d[g>>1]=0;p=0;q=i+-9|0}else{p=e;q=o+7|0}f[c>>2]=q;do if((q|0)!=16)if((q|0)>7){o=f[a+8>>2]|0;e=a+20|0;i=f[e>>2]|0;f[e>>2]=i+1;b[o+i>>0]=p;d[g>>1]=(j[g>>1]|0)>>>8;r=(f[c>>2]|0)+-8|0;break}else return;else{i=a+8|0;o=f[i>>2]|0;e=a+20|0;n=f[e>>2]|0;f[e>>2]=n+1;b[o+n>>0]=p;n=(j[g>>1]|0)>>>8&255;o=f[i>>2]|0;i=f[e>>2]|0;f[e>>2]=i+1;b[o+i>>0]=n;d[g>>1]=0;r=0}while(0);f[c>>2]=r;return}function snb(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;if((f[a+132>>2]|0)>0){i=(f[a>>2]|0)+44|0;if((f[i>>2]|0)==2){k=-201342849;l=0;while(1){if(k&1|0?d[a+148+(l<<2)>>1]|0:0){m=0;break}l=l+1|0;if((l|0)>=32){n=6;break}else k=k>>>1}a:do if((n|0)==6)if(((d[a+184>>1]|0)==0?(d[a+188>>1]|0)==0:0)?(d[a+200>>1]|0)==0:0){k=32;while(1){if(d[a+148+(k<<2)>>1]|0){m=1;break a}k=k+1|0;if((k|0)>=256){m=0;break}}}else m=1;while(0);f[i>>2]=m}tnb(a,a+2840|0);tnb(a,a+2852|0);m=f[a+2844>>2]|0;i=d[a+150>>1]|0;k=i<<16>>16==0;d[a+148+(m+1<<2)+2>>1]=-1;l=a+2756|0;o=a+2752|0;p=a+2748|0;q=i&65535;i=0;r=-1;s=k?3:4;t=k?138:7;b:while(1){k=0;u=i;do{if((u|0)>(m|0))break b;u=u+1|0;v=d[a+148+(u<<2)+2>>1]|0;w=v&65535;k=k+1|0;x=(q|0)==(w|0)}while((k|0)<(t|0)&x);if((k|0)<(s|0)){y=a+2684+(q<<2)|0;d[y>>1]=(j[y>>1]|0)+k}else{if(q){y=a+2684+(q<<2)|0;if((q|0)==(r|0))z=p;else{d[y>>1]=(d[y>>1]|0)+1<<16>>16;z=p}}else z=(k|0)<11?o:l;d[z>>1]=(d[z>>1]|0)+1<<16>>16}y=v<<16>>16==0;A=q;q=w;i=u;s=y|x?3:4;t=y?138:x?6:7;r=A}r=f[a+2856>>2]|0;x=d[a+2442>>1]|0;t=x<<16>>16==0;d[a+2440+(r+1<<2)+2>>1]=-1;s=x&65535;x=0;i=-1;w=t?3:4;q=t?138:7;c:while(1){t=0;v=x;do{if((v|0)>(r|0))break c;v=v+1|0;B=d[a+2440+(v<<2)+2>>1]|0;C=B&65535;t=t+1|0;D=(s|0)==(C|0)}while((t|0)<(q|0)&D);if((t|0)<(w|0)){u=a+2684+(s<<2)|0;d[u>>1]=(j[u>>1]|0)+t}else{if(s){u=a+2684+(s<<2)|0;if((s|0)==(i|0))E=p;else{d[u>>1]=(d[u>>1]|0)+1<<16>>16;E=p}}else E=(t|0)<11?o:l;d[E>>1]=(d[E>>1]|0)+1<<16>>16}u=B<<16>>16==0;k=s;s=C;x=v;w=u|D?3:4;q=u?138:D?6:7;i=k}tnb(a,a+2864|0);if(!(d[a+2746>>1]|0))if(!(d[a+2690>>1]|0))if(!(d[a+2742>>1]|0))if(!(d[a+2694>>1]|0))if(!(d[a+2738>>1]|0))if(!(d[a+2698>>1]|0))if(!(d[a+2734>>1]|0))if(!(d[a+2702>>1]|0))if(!(d[a+2730>>1]|0))if(!(d[a+2706>>1]|0))if(!(d[a+2726>>1]|0))if(!(d[a+2710>>1]|0))if(!(d[a+2722>>1]|0))if(!(d[a+2714>>1]|0))if(!(d[a+2718>>1]|0))F=(d[a+2686>>1]|0)==0?2:3;else F=4;else F=5;else F=6;else F=7;else F=8;else F=9;else F=10;else F=11;else F=12;else F=13;else F=14;else F=15;else F=16;else F=17;else F=18;i=a+5800|0;D=(F*3|0)+17+(f[i>>2]|0)|0;f[i>>2]=D;i=(D+10|0)>>>3;D=((f[a+5804>>2]|0)+10|0)>>>3;G=D>>>0>i>>>0?i:D;H=D;I=F}else{F=e+5|0;G=F;H=F;I=0}do if((c|0)!=0&(e+4|0)>>>0<=G>>>0)pnb(a,c,e,g);else{F=a+5820|0;D=f[F>>2]|0;i=(D|0)>13;if((H|0)==(G|0)?1:(f[a+136>>2]|0)==4){q=g+2&65535;w=a+5816|0;x=j[w>>1]|q<<D;d[w>>1]=x;if(i){C=a+8|0;s=f[C>>2]|0;B=a+20|0;E=f[B>>2]|0;f[B>>2]=E+1;b[s+E>>0]=x;x=(j[w>>1]|0)>>>8&255;E=f[C>>2]|0;C=f[B>>2]|0;f[B>>2]=C+1;b[E+C>>0]=x;x=f[F>>2]|0;d[w>>1]=q>>>(16-x|0);J=x+-13|0}else J=D+3|0;f[F>>2]=J;unb(a,152262,152142);break}x=g+4&65535;q=a+5816|0;w=j[q>>1]|x<<D;d[q>>1]=w;if(i){i=a+8|0;C=f[i>>2]|0;E=a+20|0;B=f[E>>2]|0;f[E>>2]=B+1;b[C+B>>0]=w;B=(j[q>>1]|0)>>>8&255;C=f[i>>2]|0;i=f[E>>2]|0;f[E>>2]=i+1;b[C+i>>0]=B;B=f[F>>2]|0;i=x>>>(16-B|0);d[q>>1]=i;K=i;L=B+-13|0}else{K=w;L=D+3|0}f[F>>2]=L;D=f[a+2844>>2]|0;w=f[a+2856>>2]|0;B=D+65280&65535;i=K&65535|B<<L;d[q>>1]=i;if((L|0)>11){x=a+8|0;C=f[x>>2]|0;E=a+20|0;s=f[E>>2]|0;f[E>>2]=s+1;b[C+s>>0]=i;s=(j[q>>1]|0)>>>8&255;C=f[x>>2]|0;x=f[E>>2]|0;f[E>>2]=x+1;b[C+x>>0]=s;s=f[F>>2]|0;x=B>>>(16-s|0);d[q>>1]=x;M=s+-11|0;N=x}else{M=L+5|0;N=i}f[F>>2]=M;i=w&65535;x=i<<M|N&65535;d[q>>1]=x;if((M|0)>11){s=a+8|0;B=f[s>>2]|0;C=a+20|0;E=f[C>>2]|0;f[C>>2]=E+1;b[B+E>>0]=x;E=(j[q>>1]|0)>>>8&255;B=f[s>>2]|0;s=f[C>>2]|0;f[C>>2]=s+1;b[B+s>>0]=E;E=f[F>>2]|0;s=i>>>(16-E|0);d[q>>1]=s;O=E+-11|0;P=s}else{O=M+5|0;P=x}f[F>>2]=O;x=I+65533&65535;s=x<<O|P&65535;d[q>>1]=s;if((O|0)>12){E=a+8|0;i=f[E>>2]|0;B=a+20|0;C=f[B>>2]|0;f[B>>2]=C+1;b[i+C>>0]=s;C=(j[q>>1]|0)>>>8&255;i=f[E>>2]|0;l=f[B>>2]|0;f[B>>2]=l+1;b[i+l>>0]=C;C=f[F>>2]|0;l=x>>>(16-C|0);d[q>>1]=l;Q=B;R=E;S=l;T=C+-12|0}else{Q=a+20|0;R=a+8|0;S=s;T=O+4|0}f[F>>2]=T;s=0;C=T;l=S;while(1){E=j[a+2684+(h[446407+s>>0]<<2)+2>>1]|0;B=E<<C|l&65535;d[q>>1]=B;if((C|0)>13){x=f[R>>2]|0;i=f[Q>>2]|0;f[Q>>2]=i+1;b[x+i>>0]=B;i=(j[q>>1]|0)>>>8&255;x=f[R>>2]|0;o=f[Q>>2]|0;f[Q>>2]=o+1;b[x+o>>0]=i;i=f[F>>2]|0;o=E>>>(16-i|0);d[q>>1]=o;U=o;V=i+-13|0}else{U=B;V=C+3|0}f[F>>2]=V;if((s|0)==(I|0))break;else{s=s+1|0;C=V;l=U}}l=a+148|0;vnb(a,l,D);C=a+2440|0;vnb(a,C,w);unb(a,l,C)}while(0);onb(a);if(!g)return;g=a+5820|0;U=f[g>>2]|0;if((U|0)<=8){if((U|0)>0){U=d[a+5816>>1]&255;V=f[a+8>>2]|0;I=a+20|0;Q=f[I>>2]|0;f[I>>2]=Q+1;W=U;X=V+Q|0;n=84}}else{Q=a+5816|0;V=d[Q>>1]&255;U=a+8|0;I=f[U>>2]|0;R=a+20|0;S=f[R>>2]|0;f[R>>2]=S+1;b[I+S>>0]=V;V=(j[Q>>1]|0)>>>8&255;Q=f[U>>2]|0;U=f[R>>2]|0;f[R>>2]=U+1;W=V;X=Q+U|0;n=84}if((n|0)==84)b[X>>0]=W;d[a+5816>>1]=0;f[g>>2]=0;return}function tnb(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=u;u=u+32|0;g=e;i=f[c>>2]|0;k=c+8|0;l=f[k>>2]|0;m=f[l>>2]|0;n=f[l+12>>2]|0;l=a+5200|0;f[l>>2]=0;o=a+5204|0;f[o>>2]=573;if((n|0)>0){p=-1;q=0;while(1){if(!(d[i+(q<<2)>>1]|0)){d[i+(q<<2)+2>>1]=0;r=p}else{s=(f[l>>2]|0)+1|0;f[l>>2]=s;f[a+2908+(s<<2)>>2]=q;b[a+5208+q>>0]=0;r=q}q=q+1|0;if((q|0)==(n|0))break;else p=r}p=f[l>>2]|0;if((p|0)<2){t=r;v=p;w=3}else{x=r;y=p}}else{t=-1;v=0;w=3}if((w|0)==3){w=a+5800|0;p=a+5804|0;if(!m){r=t;q=v;while(1){s=(r|0)<2;z=r+1|0;A=s?z:r;B=s?z:0;z=q+1|0;f[l>>2]=z;f[a+2908+(z<<2)>>2]=B;d[i+(B<<2)>>1]=1;b[a+5208+B>>0]=0;f[w>>2]=(f[w>>2]|0)+-1;B=f[l>>2]|0;if((B|0)<2){r=A;q=B}else{x=A;y=B;break}}}else{q=t;t=v;while(1){v=(q|0)<2;r=q+1|0;B=v?r:q;A=v?r:0;r=t+1|0;f[l>>2]=r;f[a+2908+(r<<2)>>2]=A;d[i+(A<<2)>>1]=1;b[a+5208+A>>0]=0;f[w>>2]=(f[w>>2]|0)+-1;f[p>>2]=(f[p>>2]|0)-(j[m+(A<<2)+2>>1]|0);A=f[l>>2]|0;if((A|0)<2){q=B;t=A}else{x=B;y=A;break}}}}t=c+4|0;f[t>>2]=x;q=y>>>1;if(!q)C=y;else{m=q;q=y;while(1){y=f[a+2908+(m<<2)>>2]|0;p=a+5208+y|0;w=m<<1;a:do if((w|0)>(q|0))D=m;else{A=i+(y<<2)|0;B=m;r=w;v=q;while(1){do if((r|0)<(v|0)){z=r|1;s=f[a+2908+(z<<2)>>2]|0;E=d[i+(s<<2)>>1]|0;F=f[a+2908+(r<<2)>>2]|0;G=d[i+(F<<2)>>1]|0;if((E&65535)>=(G&65535)){if(E<<16>>16!=G<<16>>16){H=r;break}if((h[a+5208+s>>0]|0)>(h[a+5208+F>>0]|0)){H=r;break}}H=z}else H=r;while(0);z=d[A>>1]|0;F=f[a+2908+(H<<2)>>2]|0;s=d[i+(F<<2)>>1]|0;if((z&65535)<(s&65535)){D=B;break a}if(z<<16>>16==s<<16>>16?(h[p>>0]|0)<=(h[a+5208+F>>0]|0):0){D=B;break a}f[a+2908+(B<<2)>>2]=F;r=H<<1;v=f[l>>2]|0;if((r|0)>(v|0)){D=H;break}else B=H}}while(0);f[a+2908+(D<<2)>>2]=y;if((m|0)<=1)break;m=m+-1|0;q=f[l>>2]|0}C=f[l>>2]|0}q=a+2912|0;m=n;n=C;do{C=f[q>>2]|0;D=n+-1|0;f[l>>2]=D;H=f[a+2908+(n<<2)>>2]|0;f[q>>2]=H;p=a+5208+H|0;b:do if((n|0)<3)I=1;else{w=i+(H<<2)|0;B=1;v=2;r=D;while(1){do if((v|0)<(r|0)){A=v|1;F=f[a+2908+(A<<2)>>2]|0;s=d[i+(F<<2)>>1]|0;z=f[a+2908+(v<<2)>>2]|0;G=d[i+(z<<2)>>1]|0;if((s&65535)>=(G&65535)){if(s<<16>>16!=G<<16>>16){J=v;break}if((h[a+5208+F>>0]|0)>(h[a+5208+z>>0]|0)){J=v;break}}J=A}else J=v;while(0);A=d[w>>1]|0;z=f[a+2908+(J<<2)>>2]|0;F=d[i+(z<<2)>>1]|0;if((A&65535)<(F&65535)){I=B;break b}if(A<<16>>16==F<<16>>16?(h[p>>0]|0)<=(h[a+5208+z>>0]|0):0){I=B;break b}f[a+2908+(B<<2)>>2]=z;v=J<<1;r=f[l>>2]|0;if((v|0)>(r|0)){I=J;break}else B=J}}while(0);f[a+2908+(I<<2)>>2]=H;p=f[q>>2]|0;D=(f[o>>2]|0)+-1|0;f[o>>2]=D;f[a+2908+(D<<2)>>2]=C;D=(f[o>>2]|0)+-1|0;f[o>>2]=D;f[a+2908+(D<<2)>>2]=p;D=i+(m<<2)|0;d[D>>1]=(j[i+(p<<2)>>1]|0)+(j[i+(C<<2)>>1]|0);y=a+5208+m|0;b[y>>0]=(h[((h[a+5208+C>>0]|0)>=(h[a+5208+p>>0]|0)?C:p)+(a+5208)>>0]|0)+1;B=m&65535;d[i+(p<<2)+2>>1]=B;d[i+(C<<2)+2>>1]=B;f[q>>2]=m;B=f[l>>2]|0;c:do if((B|0)<2)K=1;else{p=1;r=2;v=B;while(1){do if((r|0)<(v|0)){w=r|1;z=f[a+2908+(w<<2)>>2]|0;F=d[i+(z<<2)>>1]|0;A=f[a+2908+(r<<2)>>2]|0;G=d[i+(A<<2)>>1]|0;if((F&65535)>=(G&65535)){if(F<<16>>16!=G<<16>>16){L=r;break}if((h[a+5208+z>>0]|0)>(h[a+5208+A>>0]|0)){L=r;break}}L=w}else L=r;while(0);w=d[D>>1]|0;A=f[a+2908+(L<<2)>>2]|0;z=d[i+(A<<2)>>1]|0;if((w&65535)<(z&65535)){K=p;break c}if(w<<16>>16==z<<16>>16?(h[y>>0]|0)<=(h[a+5208+A>>0]|0):0){K=p;break c}f[a+2908+(p<<2)>>2]=A;r=L<<1;v=f[l>>2]|0;if((r|0)>(v|0)){K=L;break}else p=L}}while(0);f[a+2908+(K<<2)>>2]=m;m=m+1|0;n=f[l>>2]|0}while((n|0)>1);n=f[q>>2]|0;q=(f[o>>2]|0)+-1|0;f[o>>2]=q;f[a+2908+(q<<2)>>2]=n;n=f[c>>2]|0;c=f[t>>2]|0;t=f[k>>2]|0;k=f[t>>2]|0;q=f[t+4>>2]|0;l=f[t+8>>2]|0;m=f[t+16>>2]|0;t=a+2876|0;K=t+32|0;do{d[t>>1]=0;t=t+2|0}while((t|0)<(K|0));t=f[o>>2]|0;d[n+(f[a+2908+(t<<2)>>2]<<2)+2>>1]=0;o=t+1|0;d:do if((o|0)<573){t=a+5800|0;K=a+5804|0;if(!k){L=o;I=0;while(1){J=f[a+2908+(L<<2)>>2]|0;y=n+(J<<2)+2|0;D=j[n+(j[y>>1]<<2)+2>>1]|0;B=(D|0)<(m|0);C=B?D+1|0:m;D=((B^1)&1)+I|0;d[y>>1]=C;if((J|0)<=(c|0)){y=a+2876+(C<<1)|0;d[y>>1]=(d[y>>1]|0)+1<<16>>16;if((J|0)<(l|0))M=0;else M=f[q+(J-l<<2)>>2]|0;y=Y(j[n+(J<<2)>>1]|0,M+C|0)|0;f[t>>2]=y+(f[t>>2]|0)}L=L+1|0;if((L|0)==573){N=D;break}else I=D}}else{I=o;L=0;while(1){D=f[a+2908+(I<<2)>>2]|0;y=n+(D<<2)+2|0;C=j[n+(j[y>>1]<<2)+2>>1]|0;J=(C|0)<(m|0);B=J?C+1|0:m;C=((J^1)&1)+L|0;d[y>>1]=B;if((D|0)<=(c|0)){y=a+2876+(B<<1)|0;d[y>>1]=(d[y>>1]|0)+1<<16>>16;if((D|0)<(l|0))O=0;else O=f[q+(D-l<<2)>>2]|0;y=j[n+(D<<2)>>1]|0;J=Y(y,O+B|0)|0;f[t>>2]=J+(f[t>>2]|0);J=Y((j[k+(D<<2)+2>>1]|0)+O|0,y)|0;f[K>>2]=J+(f[K>>2]|0)}I=I+1|0;if((I|0)==573){N=C;break}else L=C}}if(N|0){L=a+2876+(m<<1)|0;I=N;while(1){K=m;while(1){C=K+-1|0;P=a+2876+(C<<1)|0;Q=d[P>>1]|0;if(!(Q<<16>>16))K=C;else break}d[P>>1]=Q+-1<<16>>16;C=a+2876+(K<<1)|0;d[C>>1]=(j[C>>1]|0)+2;R=(d[L>>1]|0)+-1<<16>>16;d[L>>1]=R;if((I|0)>2)I=I+-2|0;else break}if(m|0){I=573;L=m;C=R;while(1){J=L&65535;if(!(C<<16>>16))S=I;else{y=C&65535;D=I;while(1){B=D;do{B=B+-1|0;T=f[a+2908+(B<<2)>>2]|0}while((T|0)>(c|0));H=n+(T<<2)+2|0;p=j[H>>1]|0;if((L|0)!=(p|0)){v=Y(j[n+(T<<2)>>1]|0,L-p|0)|0;f[t>>2]=v+(f[t>>2]|0);d[H>>1]=J}y=y+-1|0;if(!y){S=B;break}else D=B}}D=L+-1|0;if(!D)break d;I=S;L=D;C=d[a+2876+(D<<1)>>1]|0}}}}while(0);S=0;T=1;do{S=(j[a+2876+(T+-1<<1)>>1]|0)+S<<1;d[g+(T<<1)>>1]=S;T=T+1|0}while((T|0)!=16);if((x|0)<0){u=e;return}else U=0;while(1){T=d[i+(U<<2)+2>>1]|0;S=T&65535;if(T<<16>>16){T=g+(S<<1)|0;a=d[T>>1]|0;d[T>>1]=a+1<<16>>16;T=0;n=S;S=a&65535;while(1){V=T|S&1;if((n|0)>1){T=V<<1;n=n+-1|0;S=S>>>1}else break}d[i+(U<<2)>>1]=V}if((U|0)==(x|0))break;else U=U+1|0}u=e;return}function unb(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;g=a+5792|0;if(!(f[g>>2]|0)){i=a+5820|0;k=a+5816|0;l=k;m=i;n=f[i>>2]|0;o=d[k>>1]|0}else{k=a+5796|0;i=a+5784|0;p=a+5820|0;q=a+5816|0;r=a+8|0;s=a+20|0;t=0;do{u=d[(f[k>>2]|0)+(t<<1)>>1]|0;v=u&65535;w=h[(f[i>>2]|0)+t>>0]|0;t=t+1|0;do if(!(u<<16>>16)){x=j[c+(w<<2)+2>>1]|0;y=f[p>>2]|0;z=j[c+(w<<2)>>1]|0;A=j[q>>1]|0|z<<y;B=A&65535;d[q>>1]=B;if((y|0)>(16-x|0)){C=f[r>>2]|0;D=f[s>>2]|0;f[s>>2]=D+1;b[C+D>>0]=A;A=(j[q>>1]|0)>>>8&255;D=f[r>>2]|0;C=f[s>>2]|0;f[s>>2]=C+1;b[D+C>>0]=A;A=f[p>>2]|0;C=z>>>(16-A|0)&65535;d[q>>1]=C;E=C;F=x+-16+A|0;G=23;break}else{E=B;F=y+x|0;G=23;break}}else{x=h[446151+w>>0]|0;y=(x|256)+1|0;B=j[c+(y<<2)+2>>1]|0;A=f[p>>2]|0;C=j[c+(y<<2)>>1]|0;y=j[q>>1]|0|C<<A;z=y&65535;d[q>>1]=z;if((A|0)>(16-B|0)){D=f[r>>2]|0;H=f[s>>2]|0;f[s>>2]=H+1;b[D+H>>0]=y;y=(j[q>>1]|0)>>>8&255;H=f[r>>2]|0;D=f[s>>2]|0;f[s>>2]=D+1;b[H+D>>0]=y;y=f[p>>2]|0;D=C>>>(16-y|0)&65535;d[q>>1]=D;I=D;J=B+-16+y|0}else{I=z;J=A+B|0}f[p>>2]=J;B=f[135292+(x<<2)>>2]|0;if((x+-8|0)>>>0<20){A=w-(f[135408+(x<<2)>>2]|0)&65535;x=A<<J|I&65535;z=x&65535;d[q>>1]=z;if((J|0)>(16-B|0)){y=f[r>>2]|0;D=f[s>>2]|0;f[s>>2]=D+1;b[y+D>>0]=x;x=(j[q>>1]|0)>>>8&255;D=f[r>>2]|0;y=f[s>>2]|0;f[s>>2]=y+1;b[D+y>>0]=x;x=f[p>>2]|0;y=A>>>(16-x|0)&65535;d[q>>1]=y;K=y;L=B+-16+x|0}else{K=z;L=J+B|0}f[p>>2]=L;M=L;N=K}else{M=J;N=I}B=v+-1|0;z=h[445639+(B>>>0<256?B:(B>>>7)+256|0)>>0]|0;x=j[e+(z<<2)+2>>1]|0;y=j[e+(z<<2)>>1]|0;A=N&65535|y<<M;D=A&65535;d[q>>1]=D;if((M|0)>(16-x|0)){C=f[r>>2]|0;H=f[s>>2]|0;f[s>>2]=H+1;b[C+H>>0]=A;A=(j[q>>1]|0)>>>8&255;H=f[r>>2]|0;C=f[s>>2]|0;f[s>>2]=C+1;b[H+C>>0]=A;A=f[p>>2]|0;C=y>>>(16-A|0)&65535;d[q>>1]=C;O=x+-16+A|0;P=C}else{O=M+x|0;P=D}f[p>>2]=O;D=f[135172+(z<<2)>>2]|0;if((z+-4|0)>>>0<26){x=B-(f[135524+(z<<2)>>2]|0)&65535;z=x<<O|P&65535;B=z&65535;d[q>>1]=B;if((O|0)>(16-D|0)){C=f[r>>2]|0;A=f[s>>2]|0;f[s>>2]=A+1;b[C+A>>0]=z;z=(j[q>>1]|0)>>>8&255;A=f[r>>2]|0;C=f[s>>2]|0;f[s>>2]=C+1;b[A+C>>0]=z;z=f[p>>2]|0;C=x>>>(16-z|0)&65535;d[q>>1]=C;E=C;F=D+-16+z|0;G=23;break}else{E=B;F=O+D|0;G=23;break}}else{Q=P;R=O}}while(0);if((G|0)==23){G=0;f[p>>2]=F;Q=E;R=F}}while(t>>>0<(f[g>>2]|0)>>>0);l=q;m=p;n=R;o=Q}Q=j[c+1026>>1]|0;R=j[c+1024>>1]|0;c=o&65535|R<<n;d[l>>1]=c;if((n|0)>(16-Q|0)){o=a+8|0;p=f[o>>2]|0;q=a+20|0;a=f[q>>2]|0;f[q>>2]=a+1;b[p+a>>0]=c;c=(j[l>>1]|0)>>>8&255;a=f[o>>2]|0;o=f[q>>2]|0;f[q>>2]=o+1;b[a+o>>0]=c;c=f[m>>2]|0;d[l>>1]=R>>>(16-c|0);S=Q+-16+c|0;f[m>>2]=S;return}else{S=n+Q|0;f[m>>2]=S;return}}function vnb(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;g=d[c+2>>1]|0;h=g<<16>>16==0;i=a+2754|0;k=a+5820|0;l=a+2752|0;m=a+5816|0;n=a+8|0;o=a+20|0;p=a+2758|0;q=a+2756|0;r=a+2750|0;s=a+2748|0;t=0;u=-1;v=g&65535;g=h?138:7;w=h?3:4;a:while(1){h=t;x=0;while(1){if((h|0)>(e|0))break a;h=h+1|0;y=d[c+(h<<2)+2>>1]|0;z=y&65535;A=x+1|0;B=(v|0)==(z|0);if(!((A|0)<(g|0)&B))break;else x=A}if((A|0)<(w|0)){C=a+2684+(v<<2)+2|0;D=a+2684+(v<<2)|0;E=A;F=f[k>>2]|0;G=d[m>>1]|0;while(1){H=j[C>>1]|0;I=j[D>>1]|0;J=G&65535|I<<F;K=J&65535;d[m>>1]=K;if((F|0)>(16-H|0)){L=f[n>>2]|0;M=f[o>>2]|0;f[o>>2]=M+1;b[L+M>>0]=J;J=(j[m>>1]|0)>>>8&255;M=f[n>>2]|0;L=f[o>>2]|0;f[o>>2]=L+1;b[M+L>>0]=J;J=f[k>>2]|0;L=I>>>(16-J|0)&65535;d[m>>1]=L;N=L;O=H+-16+J|0}else{N=K;O=F+H|0}f[k>>2]=O;E=E+-1|0;if(!E)break;else{F=O;G=N}}}else{do if(!v)if((A|0)<11){G=j[i>>1]|0;F=f[k>>2]|0;E=j[l>>1]|0;D=j[m>>1]|0|E<<F;d[m>>1]=D;if((F|0)>(16-G|0)){C=f[n>>2]|0;H=f[o>>2]|0;f[o>>2]=H+1;b[C+H>>0]=D;H=(j[m>>1]|0)>>>8&255;C=f[n>>2]|0;K=f[o>>2]|0;f[o>>2]=K+1;b[C+K>>0]=H;H=f[k>>2]|0;K=E>>>(16-H|0);d[m>>1]=K;P=G+-16+H|0;Q=K}else{P=F+G|0;Q=D}f[k>>2]=P;D=x+65534&65535;G=Q&65535|D<<P;d[m>>1]=G;if((P|0)>13){F=f[n>>2]|0;K=f[o>>2]|0;f[o>>2]=K+1;b[F+K>>0]=G;G=(j[m>>1]|0)>>>8&255;K=f[n>>2]|0;F=f[o>>2]|0;f[o>>2]=F+1;b[K+F>>0]=G;G=f[k>>2]|0;d[m>>1]=D>>>(16-G|0);R=G+-13|0;break}else{R=P+3|0;break}}else{G=j[p>>1]|0;D=f[k>>2]|0;F=j[q>>1]|0;K=j[m>>1]|0|F<<D;d[m>>1]=K;if((D|0)>(16-G|0)){H=f[n>>2]|0;E=f[o>>2]|0;f[o>>2]=E+1;b[H+E>>0]=K;E=(j[m>>1]|0)>>>8&255;H=f[n>>2]|0;C=f[o>>2]|0;f[o>>2]=C+1;b[H+C>>0]=E;E=f[k>>2]|0;C=F>>>(16-E|0);d[m>>1]=C;S=G+-16+E|0;T=C}else{S=D+G|0;T=K}f[k>>2]=S;K=x+65526&65535;G=T&65535|K<<S;d[m>>1]=G;if((S|0)>9){D=f[n>>2]|0;C=f[o>>2]|0;f[o>>2]=C+1;b[D+C>>0]=G;G=(j[m>>1]|0)>>>8&255;C=f[n>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[C+D>>0]=G;G=f[k>>2]|0;d[m>>1]=K>>>(16-G|0);R=G+-9|0;break}else{R=S+7|0;break}}else{if((v|0)==(u|0)){U=A;V=d[m>>1]|0;W=f[k>>2]|0}else{G=j[a+2684+(v<<2)+2>>1]|0;K=f[k>>2]|0;D=j[a+2684+(v<<2)>>1]|0;C=j[m>>1]|0|D<<K;E=C&65535;d[m>>1]=E;if((K|0)>(16-G|0)){F=f[n>>2]|0;H=f[o>>2]|0;f[o>>2]=H+1;b[F+H>>0]=C;C=(j[m>>1]|0)>>>8&255;H=f[n>>2]|0;F=f[o>>2]|0;f[o>>2]=F+1;b[H+F>>0]=C;C=f[k>>2]|0;F=D>>>(16-C|0)&65535;d[m>>1]=F;X=F;Y=G+-16+C|0}else{X=E;Y=K+G|0}f[k>>2]=Y;U=x;V=X;W=Y}G=j[r>>1]|0;K=j[s>>1]|0;E=V&65535|K<<W;d[m>>1]=E;if((W|0)>(16-G|0)){C=f[n>>2]|0;F=f[o>>2]|0;f[o>>2]=F+1;b[C+F>>0]=E;F=(j[m>>1]|0)>>>8&255;C=f[n>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[C+D>>0]=F;F=f[k>>2]|0;D=K>>>(16-F|0);d[m>>1]=D;Z=G+-16+F|0;_=D}else{Z=W+G|0;_=E}f[k>>2]=Z;E=U+65533&65535;G=_&65535|E<<Z;d[m>>1]=G;if((Z|0)>14){D=f[n>>2]|0;F=f[o>>2]|0;f[o>>2]=F+1;b[D+F>>0]=G;G=(j[m>>1]|0)>>>8&255;F=f[n>>2]|0;D=f[o>>2]|0;f[o>>2]=D+1;b[F+D>>0]=G;G=f[k>>2]|0;d[m>>1]=E>>>(16-G|0);R=G+-14|0;break}else{R=Z+2|0;break}}while(0);f[k>>2]=R}x=y<<16>>16==0;G=v;t=h;v=z;g=x?138:B?6:7;w=x|B?3:4;u=G}return}function wnb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+32|0;i=h;if(!c)j=e;else{e=f[c+12>>2]<<1;j=e>>>0>g>>>0?g:e}if(d>>>0>4294967279){zpb(i,3,446426,132);xpb(h+24|0,vpb(i,446513)|0);Apb(i)}i=d+16|0;d=j>>>0<i>>>0?i:j;j=di[f[a+48>>2]&1023](d)|0;f[j+8>>2]=i;f[j+12>>2]=d;f[j>>2]=b;u=h;return j|0}function xnb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=f[a+28>>2]|0;if(d|0?(e=f[a+68>>2]|0,e|0):0)th[e&511](0,16,0,d);d=22456;e=a;do if(((f[d>>2]|0)==(f[e>>2]|0)?(f[d+4>>2]|0)==(f[e+4>>2]|0):0)?(g=f[5616]|0,(g|0)!=0):0){h=g+8|0;i=f[h>>2]|0;if(((f[g+12>>2]|0)-i|0)>>>0<16){j=ynb(a,16)|0;break}else{f[h>>2]=i+16;j=g+i|0;break}}else k=9;while(0);do if((k|0)==9){e=f[a+12>>2]|0;d=e;if((e|0?(f[d>>2]|0)==22456:0)?(i=d+8|0,g=f[i>>2]|0,((f[d+12>>2]|0)-g|0)>>>0>=16):0){f[i>>2]=g+16;j=e+g|0;break}j=ynb(a,16)|0}while(0);f[j>>2]=b;f[j+4>>2]=c;c=a+16|0;a=f[c>>2]|0;f[c>>2]=j;f[j+8>>2]=a;return}function ynb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=d;a:do if(!d){g=e;h=4}else{i=e;while(1){if((f[i>>2]|0)==22456){g=i;h=4;break a}i=f[i+4>>2]|0;if(!i){j=0;break}}}while(0);if((h|0)==4)if(g){h=g+8|0;if(((f[g+12>>2]|0)-(f[h>>2]|0)|0)>>>0<b>>>0)j=g;else{f[5616]=g;e=a;d=f[e+4>>2]|0;i=22456;f[i>>2]=f[e>>2];f[i+4>>2]=d;f[a+12>>2]=g;d=f[h>>2]|0;f[h>>2]=d+b;k=g+d|0;return k|0}}else j=0;d=wnb(a,22456,j,b,f[a+32>>2]|0,f[a+36>>2]|0)|0;b=a+24|0;npb(b);f[d+4>>2]=f[c>>2];j=d;f[c>>2]=j;if((f[d+12>>2]|0)!=(f[d+8>>2]|0))f[a+12>>2]=j;opb(b);f[5616]=d;b=a;a=f[b+4>>2]|0;j=22456;f[j>>2]=f[b>>2];f[j+4>>2]=a;k=d+16|0;return k|0}function znb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=c+7&-8;c=f[a+28>>2]|0;if(c|0?(e=f[a+68>>2]|0,e|0):0)th[e&511](b,d,0,c);c=22456;b=a;if(((f[c>>2]|0)==(f[b>>2]|0)?(f[c+4>>2]|0)==(f[b+4>>2]|0):0)?(b=f[5616]|0,b|0):0){c=b+8|0;e=f[c>>2]|0;if(((f[b+12>>2]|0)-e|0)>>>0<d>>>0){g=ynb(a,d)|0;return g|0}else{f[c>>2]=e+d;g=b+e|0;return g|0}}e=f[a+12>>2]|0;b=e;if((e|0?(f[b>>2]|0)==22456:0)?(c=b+8|0,h=f[c>>2]|0,((f[b+12>>2]|0)-h|0)>>>0>=d>>>0):0){f[c>>2]=h+d;g=e+h|0;return g|0}g=ynb(a,d)|0;return g|0}function Anb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[a>>2]|0;e=f[c>>2]|0;if((d|0)==(e|0))return;if((d|0)==(b|0)){jza(a,e);return}else{_5b(d,e)|0;return}}function Bnb(){if((b[497771]|0)>=0)return;O5b(f[124440]|0);return}function Cnb(){f[124440]=0;f[124441]=0;f[124442]=0;b[497776]=1;spb(43);return}function Dnb(a){a=a|0;var c=0,d=0,e=0;c=(b[a+11>>0]|0)<0;d=f[a>>2]|0;if(a>>>0>(c?d:a)>>>0){if(!c){e=10;return e|0}}else{if(!c){e=0;return e|0}if(d>>>0<(a+12|0)>>>0){e=0;return e|0}}e=(f[a+8>>2]&2147483647)+-1|0;return e|0}function Enb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;zpb(d,3,446587,77);xpb(c+24|0,ypb(vpb(vpb(vpb(d,446691)|0,a)|0,476117)|0,b)|0);Apb(d);pe(1)}function Fnb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=u;u=u+32|0;c=b;d=b+24|0;e=f[a+8>>2]|0;if(e|0?(g=a+4|0,h=a+32|0,i=a+16|0,j=(f[g>>2]|0)-(f[a>>2]|0)+(f[h>>2]|0)+(f[i>>2]|0)|0,(j|0)>0):0){zh[f[(f[e>>2]|0)+12>>2]&2047](e,j);j=f[a>>2]|0;e=a+12|0;f[e>>2]=j-(f[g>>2]|0)-(f[h>>2]|0)+(f[e>>2]|0);f[g>>2]=j;f[h>>2]=0;f[i>>2]=0}if((f[a+40>>2]|0)!=-2){u=b;return}zpb(c,1,446713,82);i=vpb(c,446810)|0;xpb(d,ypb(i,f[a+12>>2]|0)|0);Apb(c);u=b;return}function Gnb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+12>>2]|0;d=a+4|0;e=f[d>>2]|0;g=a+32|0;h=f[g>>2]|0;i=c-e+(f[a>>2]|0)-h|0;j=a+28|0;k=f[j>>2]|0;l=(b|0)<0|(2147483647-i|0)<(b|0)?2147483647:i+b|0;b=(k|0)<(l|0)?k:l;f[j>>2]=b;j=e+h|0;f[d>>2]=j;h=f[a+36>>2]|0;a=(h|0)<(b|0)?h:b;if((c|0)>(a|0)){b=c-a|0;f[g>>2]=b;f[d>>2]=j+(0-b);return k|0}else{f[g>>2]=0;return k|0}return 0}function Hnb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;f[a+28>>2]=c;d=a+32|0;e=a+4|0;g=(f[e>>2]|0)+(f[d>>2]|0)|0;f[e>>2]=g;h=f[a+36>>2]|0;i=(h|0)<(c|0)?h:c;c=f[a+12>>2]|0;if((c|0)>(i|0)){h=c-i|0;f[d>>2]=h;f[e>>2]=g+(0-h);j=a+24|0;b[j>>0]=0;return}else{f[d>>2]=0;j=a+24|0;b[j>>0]=0;return}}function Inb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[b+12>>2]|0;e=b+4|0;g=f[e>>2]|0;h=b+32|0;i=f[h>>2]|0;j=d-g+(f[b>>2]|0)-i|0;k=b+28|0;l=f[k>>2]|0;m=(c|0)<0|(2147483647-j|0)<(c|0)?2147483647:j+c|0;c=(l|0)<(m|0)?l:m;f[k>>2]=c;k=g+i|0;f[e>>2]=k;i=f[b+36>>2]|0;g=(i|0)<(c|0)?i:c;if((d|0)>(g|0)){c=d-g|0;f[h>>2]=c;f[e>>2]=k+(0-c);n=b+44|0;o=f[n>>2]|0;p=o+-1|0;f[n>>2]=p;f[a>>2]=l;q=a+4|0;f[q>>2]=p;return}else{f[h>>2]=0;n=b+44|0;o=f[n>>2]|0;p=o+-1|0;f[n>>2]=p;f[a>>2]=l;q=a+4|0;f[q>>2]=p;return}}function Jnb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=f[a>>2]|0;d=a+4|0;if(c>>>0<(f[d>>2]|0)>>>0){e=b[c>>0]|0;g=e&255;if(e<<24>>24>-1){f[a>>2]=c+1;h=g;i=5}else{j=g;i=4}}else{j=0;i=4}if((i|0)==4){g=Knb(a,j)|0;j=J;if((j|0)>-1|(j|0)==-1&g>>>0>4294967295){h=g;i=5}else k=0}if((i|0)==5)k=h;h=f[a+12>>2]|0;i=f[d>>2]|0;g=a+32|0;j=f[g>>2]|0;c=h-i+(f[a>>2]|0)-j|0;e=a+28|0;l=f[e>>2]|0;m=(k|0)<0|(2147483647-c|0)<(k|0)?2147483647:c+k|0;k=(l|0)<(m|0)?l:m;f[e>>2]=k;e=i+j|0;f[d>>2]=e;j=f[a+36>>2]|0;a=(j|0)<(k|0)?j:k;if((h|0)>(a|0)){k=h-a|0;f[g>>2]=k;f[d>>2]=e+(0-k);return l|0}else{f[g>>2]=0;return l|0}return 0}function Knb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;g=f[a+4>>2]|0;i=f[a>>2]|0;j=g;k=i;do if((g-i|0)<=9){if(j>>>0>k>>>0?(b[j+-1>>0]|0)>=0:0)break;Lnb(e,a);l=(b[e+8>>0]|0)!=0;m=l?0:-1;n=l?f[e>>2]|0:-1;J=m;u=d;return n|0}while(0);e=k+2|0;j=h[k+1>>0]|0;i=c+-128+(j<<7)|0;if(j&128){j=k+3|0;c=h[e>>0]|0;g=i+-16384+(c<<14)|0;if(c&128){c=k+4|0;l=h[j>>0]|0;o=g+-2097152+(l<<21)|0;if(l&128){l=k+5|0;p=h[c>>0]|0;q=o+-268435456+(p<<28)|0;if(p&128){p=k+6|0;if((b[l>>0]|0)<0){r=k+7|0;if((b[p>>0]|0)<0){s=k+8|0;if((b[r>>0]|0)<0){t=k+9|0;if((b[s>>0]|0)<0)if((b[t>>0]|0)<0){m=-1;n=-1;J=m;u=d;return n|0}else{v=q;w=k+10|0}else{v=q;w=t}}else{v=q;w=s}}else{v=q;w=r}}else{v=q;w=p}}else{v=q;w=l}}else{v=o;w=c}}else{v=g;w=j}}else{v=i;w=e}f[a>>2]=w;m=0;n=v;J=m;u=d;return n|0}function Lnb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=c+4|0;e=f[d>>2]|0;g=f[c>>2]|0;i=e;j=g;a:do if((e-g|0)>9)k=4;else{if(i>>>0>j>>>0?(b[i+-1>>0]|0)>=0:0){k=4;break}else{l=0;m=0;n=0;o=j;p=i}while(1){if((l|0)==10){q=0;r=0;s=0;break a}if((o|0)==(p|0))while(1){if(!(Mnb(c)|0)){q=0;r=0;s=0;break a}t=f[c>>2]|0;u=f[d>>2]|0;if((t|0)!=(u|0)){v=t;w=u;break}}else{v=o;w=p}u=h[v>>0]|0;t=$ac(u&127|0,0,l*7|0)|0;x=t|m;t=J|n;o=v+1|0;f[c>>2]=o;if(!(u&128)){q=1;r=x;s=t;break}else{l=l+1|0;m=x;n=t;p=w}}}while(0);do if((k|0)==4){w=j+1|0;p=h[j>>0]|0;if(p&128){n=j+2|0;m=h[w>>0]|0;l=p+-128+(m<<7)|0;if(m&128){m=j+3|0;o=h[n>>0]|0;v=l+-16384+(o<<14)|0;if(o&128){o=j+4|0;d=h[m>>0]|0;i=v+-2097152+(d<<21)|0;if(d&128){d=i+-268435456|0;g=j+5|0;e=h[o>>0]|0;if(e&128){t=j+6|0;x=h[g>>0]|0;u=e+-128+(x<<7)|0;if(x&128){x=j+7|0;y=h[t>>0]|0;z=u+-16384+(y<<14)|0;if(y&128){y=j+8|0;A=h[x>>0]|0;B=z+-2097152+(A<<21)|0;if(A&128){A=B+-268435456|0;C=j+9|0;D=h[y>>0]|0;if(D&128){E=h[C>>0]|0;if(!(E&128)){F=D+-128+(E<<7)|0;G=A;H=d;I=j+10|0}else{q=0;r=0;s=0;break}}else{F=D;G=A;H=d;I=C}}else{F=0;G=B;H=d;I=y}}else{F=0;G=z;H=d;I=x}}else{F=0;G=u;H=d;I=t}}else{F=0;G=e;H=d;I=g}}else{F=0;G=0;H=i;I=o}}else{F=0;G=0;H=v;I=m}}else{F=0;G=0;H=l;I=n}}else{F=0;G=0;H=p;I=w}w=$ac(G|0,0,28)|0;p=J;n=$ac(F|0,0,56)|0;f[c>>2]=I;q=1;r=w|H|n;s=p|J}while(0);H=a;f[H>>2]=r;f[H+4>>2]=s;b[a+8>>0]=q;return}function Mnb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;b=u;u=u+64|0;c=b+32|0;d=b+61|0;e=b+56|0;g=b+24|0;h=b;i=b+60|0;j=a+32|0;k=f[j>>2]|0;if(((k|0)<=0?(l=a+16|0,(f[l>>2]|0)<=0):0)?(m=a+12|0,n=f[m>>2]|0,o=a+28|0,(n|0)!=(f[o>>2]|0)):0){p=a+40|0;q=f[p>>2]|0;if(!((q|0)<0|(n|0)<(q|0))){zpb(c,1,446713,605);q=vpb(c,446846)|0;xpb(d,vpb(ypb(q,f[a+36>>2]|0)|0,446935)|0);Apb(c);f[p>>2]=-2}p=f[a+8>>2]|0;while(1){if(!(li[f[(f[p>>2]|0)+8>>2]&511](p,e,g)|0)){r=20;break}s=f[g>>2]|0;if(s|0){r=12;break}}do if((r|0)==12){p=f[e>>2]|0;f[a>>2]=p;c=a+4|0;f[c>>2]=p+s;if((s|0)>-1)t=s;else{zpb(h,3,446713,622);xpb(i,vpb(h,447124)|0);Apb(h);t=f[g>>2]|0}p=f[m>>2]|0;q=2147483647-t|0;if((p|0)>(q|0)){d=p-q|0;f[l>>2]=d;q=(f[c>>2]|0)+(0-d)|0;f[c>>2]=q;v=q;w=2147483647}else{v=f[c>>2]|0;w=t+p|0}f[m>>2]=w;p=v+(f[j>>2]|0)|0;f[c>>2]=p;q=f[a+36>>2]|0;d=f[o>>2]|0;n=(q|0)<(d|0)?q:d;if((w|0)>(n|0)){d=w-n|0;f[j>>2]=d;f[c>>2]=p+(0-d);x=1;break}else{f[j>>2]=0;x=1;break}}else if((r|0)==20){f[a>>2]=0;f[a+4>>2]=0;x=0}while(0);y=x;u=b;return y|0}x=f[a+36>>2]|0;if(((f[a+12>>2]|0)-k|0)<(x|0)){y=0;u=b;return y|0}if((x|0)==(f[a+28>>2]|0)){y=0;u=b;return y|0}Nnb(a);y=0;u=b;return y|0}function Nnb(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+32|0;c=b;zpb(c,2,446713,208);d=vpb(c,447161)|0;xpb(b+24|0,vpb(ypb(d,f[a+36>>2]|0)|0,447228)|0);Apb(c);u=b;return}function Onb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+24|0;e=(b[d>>0]|0)!=0;f[a+28>>2]=c;g=a+32|0;h=a+4|0;i=(f[h>>2]|0)+(f[g>>2]|0)|0;f[h>>2]=i;j=f[a+36>>2]|0;k=(j|0)<(c|0)?j:c;c=f[a+12>>2]|0;if((c|0)>(k|0)){j=c-k|0;f[g>>2]=j;f[h>>2]=i+(0-j);b[d>>0]=0;l=a+44|0;m=f[l>>2]|0;n=m+1|0;f[l>>2]=n;return e|0}else{f[g>>2]=0;b[d>>0]=0;l=a+44|0;m=f[l>>2]|0;n=m+1|0;f[l>>2]=n;return e|0}return 0}function Pnb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+24|0;e=(b[d>>0]|0)!=0;f[a+28>>2]=c;g=a+32|0;h=a+4|0;i=(f[h>>2]|0)+(f[g>>2]|0)|0;f[h>>2]=i;j=f[a+36>>2]|0;k=(j|0)<(c|0)?j:c;c=f[a+12>>2]|0;if((c|0)>(k|0)){a=c-k|0;f[g>>2]=a;f[h>>2]=i+(0-a);b[d>>0]=0;return e|0}else{f[g>>2]=0;b[d>>0]=0;return e|0}return 0}function Qnb(a){a=a|0;var b=0,c=0;b=f[a+28>>2]|0;if((b|0)==2147483647){c=-1;return c|0}c=b-(f[a+12>>2]|0)+(f[a+4>>2]|0)-(f[a>>2]|0)+(f[a+32>>2]|0)|0;return c|0}function Rnb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=f[a+12>>2]|0;e=a+4|0;g=f[e>>2]|0;h=a+32|0;i=f[h>>2]|0;j=d-g+(f[a>>2]|0)-i|0;k=(j|0)<(b|0)?b:j;f[a+36>>2]=k;f[a+40>>2]=(c|0)>-1?c:-1;c=g+i|0;f[e>>2]=c;i=f[a+28>>2]|0;a=(k|0)<(i|0)?k:i;if((d|0)>(a|0)){i=d-a|0;f[h>>2]=i;f[e>>2]=c+(0-i);return}else{f[h>>2]=0;return}}function Snb(a){a=a|0;var b=0,c=0;b=f[a+36>>2]|0;if((b|0)==2147483647){c=-1;return c|0}c=b-(f[a+12>>2]|0)+(f[a+4>>2]|0)-(f[a>>2]|0)+(f[a+32>>2]|0)|0;return c|0}function Tnb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)<0){c=0;return c|0}d=a+4|0;e=f[a>>2]|0;g=(f[d>>2]|0)-e|0;h=e;if((g|0)>=(b|0)){f[a>>2]=h+b;c=1;return c|0}if((f[a+32>>2]|0)>0){f[a>>2]=h+g;c=0;return c|0}h=b-g|0;f[a>>2]=0;f[d>>2]=0;d=f[a+36>>2]|0;g=f[a+28>>2]|0;b=(d|0)<(g|0)?d:g;g=a+12|0;d=f[g>>2]|0;e=b-d|0;if((e|0)>=(h|0)){f[g>>2]=d+h;d=f[a+8>>2]|0;c=Uh[f[(f[d>>2]|0)+16>>2]&1023](d,h)|0;return c|0}if((e|0)<=0){c=0;return c|0}f[g>>2]=b;b=f[a+8>>2]|0;Uh[f[(f[b>>2]|0)+16>>2]&1023](b,e)|0;c=0;return c|0}function Unb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;e=c;c=b;while(1){b=f[a>>2]|0;g=(f[d>>2]|0)-b|0;h=b;if((e|0)<=(g|0))break;Vac(c|0,h|0,g|0)|0;f[a>>2]=(f[a>>2]|0)+g;if(Mnb(a)|0){e=e-g|0;c=c+g|0}else{i=0;j=5;break}}if((j|0)==5)return i|0;Vac(c|0,h|0,e|0)|0;f[a>>2]=(f[a>>2]|0)+e;i=1;return i|0}function Vnb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;if((d|0)<0){e=0;return e|0}if(((f[a+4>>2]|0)-(f[a>>2]|0)|0)<(d|0)){e=Wnb(a,c,d)|0;return e|0}e6b(c,d,0);g=b[c+11>>0]|0;h=g<<24>>24<0;if(h)i=f[c+4>>2]|0;else i=g&255;if(!i){e=1;return e|0}if(h)j=f[c>>2]|0;else j=c;if(!j){e=1;return e|0}Vac(j|0,f[a>>2]|0,d|0)|0;f[a>>2]=(f[a>>2]|0)+d;e=1;return e|0}function Wnb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=c+11|0;g=b[e>>0]|0;h=g<<24>>24<0;if(h)i=f[c+4>>2]|0;else i=g&255;do if(i|0)if(h){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[e>>0]=0;break}while(0);e=f[a+36>>2]|0;h=f[a+28>>2]|0;i=(e|0)<(h|0)?e:h;if((i|0)!=2147483647){h=a+4|0;e=i-(f[a+12>>2]|0)+(f[h>>2]|0)-(f[a>>2]|0)+(f[a+32>>2]|0)|0;if((e|0)<(d|0)|((d|0)<1|(e|0)<1)){j=h;k=a}else{c6b(c,d);j=h;k=a}}else{j=a+4|0;k=a}h=d;while(1){d=f[k>>2]|0;e=(f[j>>2]|0)-d|0;l=d;if((h|0)<=(e|0))break;if(!e)m=l;else{j6b(c,l,e)|0;m=f[a>>2]|0}f[a>>2]=m+e;if(Mnb(a)|0)h=h-e|0;else{n=0;o=18;break}}if((o|0)==18)return n|0;j6b(c,l,h)|0;f[a>>2]=(f[a>>2]|0)+h;n=1;return n|0}function Xnb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=a+4|0;i=f[g>>2]|0;j=f[a>>2]|0;k=j;if((i-j|0)>>>0>3){l=k;m=k+4|0}else{k=i-j|0;i=j;a:do if((k|0)<4){j=4;n=e;o=i;p=k;while(1){Vac(n|0,o|0,p|0)|0;f[a>>2]=(f[a>>2]|0)+p;if(!(Mnb(a)|0)){q=0;break}r=j-p|0;s=n+p|0;t=f[a>>2]|0;p=(f[g>>2]|0)-t|0;v=t;if((r|0)<=(p|0)){w=r;x=s;y=v;break a}else{j=r;n=s;o=v}}u=d;return q|0}else{w=4;x=e;y=i}while(0);Vac(x|0,y|0,w|0)|0;l=e;m=(f[a>>2]|0)+w|0}f[a>>2]=m;m=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;b[c>>0]=m;b[c+1>>0]=m>>8;b[c+2>>0]=m>>16;b[c+3>>0]=m>>24;q=1;u=d;return q|0}function Ynb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;g=a+4|0;i=f[g>>2]|0;j=f[a>>2]|0;k=j;if((i-j|0)>>>0>7){l=k;m=k+8|0}else{k=i-j|0;i=j;a:do if((k|0)<8){j=8;n=e;o=i;p=k;while(1){Vac(n|0,o|0,p|0)|0;f[a>>2]=(f[a>>2]|0)+p;if(!(Mnb(a)|0)){q=0;break}r=j-p|0;s=n+p|0;t=f[a>>2]|0;p=(f[g>>2]|0)-t|0;v=t;if((r|0)<=(p|0)){w=r;x=s;y=v;break a}else{j=r;n=s;o=v}}u=d;return q|0}else{w=8;x=e;y=i}while(0);Vac(x|0,y|0,w|0)|0;l=e;m=(f[a>>2]|0)+w|0}f[a>>2]=m;m=l;l=m;a=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;l=m+4|0;m=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;l=c;c=l;b[c>>0]=a;b[c+1>>0]=a>>8;b[c+2>>0]=a>>16;b[c+3>>0]=a>>24;a=l+4|0;b[a>>0]=m;b[a+1>>0]=m>>8;b[a+2>>0]=m>>16;b[a+3>>0]=m>>24;q=1;u=d;return q|0}function Znb(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=u;u=u+16|0;d=c;e=f[a+4>>2]|0;g=f[a>>2]|0;i=e;j=g;do if((e-g|0)<=9){if(i>>>0>j>>>0?(b[i+-1>>0]|0)>=0:0)break;Lnb(d,a);if(!(b[d+8>>0]|0))k=-1;else{l=d;m=f[l>>2]|0;n=f[l+4>>2]|0;k=n>>>0>0|(n|0)==0&m>>>0>2147483647?-1:m}o=k;u=c;return o|0}while(0);k=j+1|0;d=h[j>>0]|0;if(d&128){i=j+2|0;g=h[k>>0]|0;e=d+-128+(g<<7)|0;if(g&128){g=j+3|0;m=h[i>>0]|0;n=e+-16384+(m<<14)|0;if(m&128){m=j+4|0;l=h[g>>0]|0;p=n+-2097152+(l<<21)|0;if(l&128){l=p+-268435456|0;q=j+5|0;r=h[m>>0]|0;if(r&128){s=j+6|0;t=h[q>>0]|0;v=r+-128+(t<<7)|0;if(t&128){t=j+7|0;w=h[s>>0]|0;x=v+-16384+(w<<14)|0;if(w&128){w=j+8|0;y=h[t>>0]|0;z=x+-2097152+(y<<21)|0;if(y&128){y=z+-268435456|0;A=j+9|0;B=h[w>>0]|0;if(B&128){C=h[A>>0]|0;if(!(C&128)){D=B+-128+(C<<7)|0;E=y;F=l;G=j+10|0}else{o=-1;u=c;return o|0}}else{D=B;E=y;F=l;G=A}}else{D=0;E=z;F=l;G=w}}else{D=0;E=x;F=l;G=t}}else{D=0;E=v;F=l;G=s}}else{D=0;E=r;F=l;G=q}}else{D=0;E=0;F=p;G=m}}else{D=0;E=0;F=n;G=g}}else{D=0;E=0;F=e;G=i}}else{D=0;E=0;F=d;G=k}k=$ac(E|0,0,28)|0;E=J;d=k|F;F=$ac(D|0,0,56)|0;D=E|J;if(D>>>0>0|(D|0)==0&(d|F)>>>0>2147483647){o=-1;u=c;return o|0}f[a>>2]=G;o=d;u=c;return o|0}function _nb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;g=a+4|0;i=f[g>>2]|0;j=f[a>>2]|0;k=i-j|0;l=i;i=j;a:do if((k|0)<=9){do if((k|0)>0){if((b[l+-1>>0]|0)>=0)break a}else if(!k){j=f[a+32>>2]|0;m=f[a+12>>2]|0;if((j|0)<=0?(m|0)!=(f[a+28>>2]|0):0)break;if((m-j|0)<(f[a+36>>2]|0)){b[a+24>>0]=1;n=0;u=d;return n|0}}while(0);do if((i|0)==(l|0)){if(Mnb(a)|0){o=f[a>>2]|0;p=f[g>>2]|0;break}j=f[a+36>>2]|0;if(((f[a+12>>2]|0)-(f[a+32>>2]|0)|0)<(j|0)){b[a+24>>0]=1;n=0;u=d;return n|0}else{b[a+24>>0]=(f[a+28>>2]|0)==(j|0)&1;n=0;u=d;return n|0}}else{o=i;p=l}while(0);if(o>>>0<p>>>0?(j=b[o>>0]|0,j<<24>>24>-1):0){f[a>>2]=o+1;q=j&255}else{Lnb(e,a);if(!(b[e+8>>0]|0)){n=0;u=d;return n|0}else q=f[e>>2]|0}n=q;u=d;return n|0}while(0);if(!c){f[a>>2]=i+1;n=0;u=d;return n|0}q=i+2|0;e=h[i+1>>0]|0;o=c+-128+(e<<7)|0;if(e&128){e=i+3|0;c=h[q>>0]|0;p=o+-16384+(c<<14)|0;if(c&128){c=i+4|0;l=h[e>>0]|0;g=p+-2097152+(l<<21)|0;if(l&128){l=i+5|0;k=h[c>>0]|0;j=g+-268435456+(k<<28)|0;if(k&128){k=i+6|0;if((b[l>>0]|0)<0){m=i+7|0;if((b[k>>0]|0)<0){r=i+8|0;if((b[m>>0]|0)<0){s=i+9|0;if((b[r>>0]|0)<0)if((b[s>>0]|0)<0){n=0;u=d;return n|0}else{t=j;v=i+10|0}else{t=j;v=s}}else{t=j;v=r}}else{t=j;v=m}}else{t=j;v=k}}else{t=j;v=l}}else{t=g;v=c}}else{t=p;v=e}}else{t=o;v=q}f[a>>2]=v;n=t;u=d;return n|0}function $nb(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;f[a>>2]=c;h=a+4|0;i=a+8|0;j=a+12|0;k=a+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;d[h+12>>1]=0;b[h+14>>0]=0;if(li[f[(f[c>>2]|0)+8>>2]&511](c,g,i)|0){f[h>>2]=f[g>>2];f[j>>2]=(f[j>>2]|0)+(f[i>>2]|0);b[k>>0]=0;u=e;return}else{f[h>>2]=0;f[i>>2]=0;b[k>>0]=1;b[k>>0]=0;u=e;return}}function aob(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;c=f[b>>2]|0;if((c|0)<=0)return;d=f[a>>2]|0;zh[f[(f[d>>2]|0)+12>>2]&2047](d,c);c=a+12|0;f[c>>2]=(f[c>>2]|0)-(f[b>>2]|0);f[b>>2]=0;f[a+4>>2]=0;return}function bob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;i=f[h>>2]|0;j=a+4|0;k=f[j>>2]|0;a:do if((i|0)<(d|0)){l=a+12|0;m=d;n=c;o=k;p=i;while(1){Vac(o|0,n|0,p|0)|0;q=f[h>>2]|0;r=f[a>>2]|0;if(!(li[f[(f[r>>2]|0)+8>>2]&511](r,g,h)|0))break;r=n+q|0;s=m-q|0;q=f[g>>2]|0;f[j>>2]=q;p=f[h>>2]|0;f[l>>2]=(f[l>>2]|0)+p;t=q;if((p|0)>=(s|0)){v=s;w=r;x=t;break a}else{m=s;n=r;o=t}}f[j>>2]=0;f[h>>2]=0;b[a+16>>0]=1;u=e;return}else{v=d;w=c;x=k}while(0);Vac(x|0,w|0,v|0)|0;f[j>>2]=(f[j>>2]|0)+v;f[h>>2]=(f[h>>2]|0)-v;u=e;return}function cob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0;e=a+8|0;g=f[e>>2]|0;if((g|0)>(d|0)){i=a+4|0;Vac(f[i>>2]|0,c|0,d|0)|0;f[i>>2]=(f[i>>2]|0)+d;f[e>>2]=(f[e>>2]|0)-d;return}if((g|0)>0){i=f[a>>2]|0;zh[f[(f[i>>2]|0)+12>>2]&2047](i,g);g=a+12|0;i=(f[g>>2]|0)-(f[e>>2]|0)|0;f[g>>2]=i;f[e>>2]=0;f[a+4>>2]=0;j=a;k=g;l=i}else{i=a+12|0;j=a;k=i;l=f[i>>2]|0}f[k>>2]=l+d;l=f[j>>2]|0;j=((li[f[(f[l>>2]|0)+20>>2]&511](l,c,d)|0)^1)&1;d=a+16|0;b[d>>0]=h[d>>0]|0|j;return}function dob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+4|0;g=d;h=a+8|0;i=f[h>>2]|0;if(i>>>0>3){j=a+4|0;k=f[j>>2]|0;b[k>>0]=c;b[k+1>>0]=c>>8;b[k+2>>0]=c>>16;b[k+3>>0]=c>>24;f[j>>2]=(f[j>>2]|0)+4;f[h>>2]=(f[h>>2]|0)+-4;u=d;return}f[g>>2]=c;c=a+4|0;j=a+12|0;k=4;l=g;g=f[c>>2]|0;m=i;while(1){Vac(g|0,l|0,m|0)|0;i=f[h>>2]|0;n=f[a>>2]|0;if(!(li[f[(f[n>>2]|0)+8>>2]&511](n,e,h)|0)){o=6;break}l=l+i|0;k=k-i|0;i=f[e>>2]|0;f[c>>2]=i;m=f[h>>2]|0;f[j>>2]=(f[j>>2]|0)+m;g=i;if((m|0)>=(k|0)){o=7;break}}if((o|0)==6){f[c>>2]=0;f[h>>2]=0;b[a+16>>0]=1;u=d;return}else if((o|0)==7){Vac(g|0,l|0,k|0)|0;f[c>>2]=(f[c>>2]|0)+k;f[h>>2]=(f[h>>2]|0)-k;u=d;return}}function eob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e+8|0;h=e;i=a+8|0;j=f[i>>2]|0;if(j>>>0>7){k=a+4|0;l=f[k>>2]|0;m=l;b[m>>0]=c;b[m+1>>0]=c>>8;b[m+2>>0]=c>>16;b[m+3>>0]=c>>24;m=l+4|0;b[m>>0]=d;b[m+1>>0]=d>>8;b[m+2>>0]=d>>16;b[m+3>>0]=d>>24;f[k>>2]=(f[k>>2]|0)+8;f[i>>2]=(f[i>>2]|0)+-8;u=e;return}k=h;f[k>>2]=c;f[k+4>>2]=d;d=a+4|0;k=a+12|0;c=8;m=h;h=f[d>>2]|0;l=j;while(1){Vac(h|0,m|0,l|0)|0;j=f[i>>2]|0;n=f[a>>2]|0;if(!(li[f[(f[n>>2]|0)+8>>2]&511](n,g,i)|0)){o=6;break}m=m+j|0;c=c-j|0;j=f[g>>2]|0;f[d>>2]=j;l=f[i>>2]|0;f[k>>2]=(f[k>>2]|0)+l;h=j;if((l|0)>=(c|0)){o=7;break}}if((o|0)==6){f[d>>2]=0;f[i>>2]=0;b[a+16>>0]=1;u=e;return}else if((o|0)==7){Vac(h|0,m|0,c|0)|0;f[d>>2]=(f[d>>2]|0)+c;f[i>>2]=(f[i>>2]|0)-c;u=e;return}}function fob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=d+4|0;if(c>>>0>127){h=c;i=g;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=g;m=c}b[l>>0]=m;m=l+1-g|0;l=a+8|0;c=f[l>>2]|0;i=a+4|0;h=f[i>>2]|0;a:do if((c|0)<(m|0)){j=a+12|0;k=m;n=g;o=h;p=c;while(1){Vac(o|0,n|0,p|0)|0;q=f[l>>2]|0;r=f[a>>2]|0;if(!(li[f[(f[r>>2]|0)+8>>2]&511](r,e,l)|0))break;r=n+q|0;s=k-q|0;q=f[e>>2]|0;f[i>>2]=q;p=f[l>>2]|0;f[j>>2]=(f[j>>2]|0)+p;t=q;if((p|0)>=(s|0)){v=s;w=r;x=t;break a}else{k=s;n=r;o=t}}f[i>>2]=0;f[l>>2]=0;b[a+16>>0]=1;u=d;return}else{v=m;w=g;x=h}while(0);Vac(x|0,w|0,v|0)|0;f[i>>2]=(f[i>>2]|0)+v;f[l>>2]=(f[l>>2]|0)-v;u=d;return}function gob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0;e=u;u=u+16|0;g=e;h=e+4|0;i=a+8|0;j=f[i>>2]|0;if((j|0)<=9){if(d>>>0>0|(d|0)==0&c>>>0>127){k=0;l=c;m=c;n=d;o=1;while(1){b[h+k>>0]=l|128;p=m;m=Sac(m|0,n|0,7)|0;q=o+1|0;if(!(n>>>0>0|(n|0)==0&p>>>0>16383)){r=o;s=q;t=m;break}else{p=o;l=m;n=J;o=q;k=p}}}else{r=0;s=1;t=c}b[h+r>>0]=t&127;t=a+4|0;k=f[t>>2]|0;a:do if((j|0)>(r|0)){v=s;w=h;x=k;y=28}else{o=a+12|0;n=s;m=h;l=k;p=j;while(1){Vac(l|0,m|0,p|0)|0;q=f[i>>2]|0;z=f[a>>2]|0;if(!(li[f[(f[z>>2]|0)+8>>2]&511](z,g,i)|0))break;z=m+q|0;A=n-q|0;q=f[g>>2]|0;f[t>>2]=q;p=f[i>>2]|0;f[o>>2]=(f[o>>2]|0)+p;B=q;if((p|0)>=(A|0)){v=A;w=z;x=B;y=28;break a}else{n=A;m=z;l=B}}f[t>>2]=0;f[i>>2]=0;b[a+16>>0]=1}while(0);if((y|0)==28){Vac(x|0,w|0,v|0)|0;f[t>>2]=(f[t>>2]|0)+v;f[i>>2]=(f[i>>2]|0)-v}u=e;return}v=a+4|0;a=f[v>>2]|0;t=Sac(c|0,d|0,28)|0;w=Sac(c|0,d|0,56)|0;do if(!w)if(!t)if(c>>>0<16384)if(c>>>0<128){C=1;break}else{D=2;y=19;break}else if(c>>>0<2097152){E=3;y=18;break}else{F=4;y=17;break}else if(t>>>0<16384)if(t>>>0<128){G=5;y=16;break}else{H=6;y=15;break}else if(t>>>0<2097152){I=7;y=14;break}else{K=8;y=13;break}else{if(w>>>0<128)L=9;else{x=Sac(c|0,d|0,63)|0;b[a+9>>0]=x|128;L=10}b[a+8>>0]=w|128;K=L;y=13}while(0);if((y|0)==13){L=Sac(c|0,d|0,49)|0;b[a+7>>0]=L|128;I=K;y=14}if((y|0)==14){K=Sac(c|0,d|0,42)|0;b[a+6>>0]=K|128;H=I;y=15}if((y|0)==15){I=Sac(c|0,d|0,35)|0;b[a+5>>0]=I|128;G=H;y=16}if((y|0)==16){b[a+4>>0]=t|128;F=G;y=17}if((y|0)==17){b[a+3>>0]=c>>>21|128;E=F;y=18}if((y|0)==18){b[a+2>>0]=c>>>14|128;D=E;y=19}if((y|0)==19){b[a+1>>0]=c>>>7|128;C=D}b[a>>0]=c|128;c=a+(C+-1)|0;b[c>>0]=b[c>>0]&127;f[v>>2]=(f[v>>2]|0)+C;f[i>>2]=(f[i>>2]|0)-C;u=e;return}function hob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=Sac(a|0,c|0,28)|0;f=Sac(a|0,c|0,56)|0;do if(!f){if(e|0)if(e>>>0<16384)if(e>>>0<128){g=5;h=15;break}else{i=6;h=14;break}else if(e>>>0<2097152){j=7;h=13;break}else{k=8;h=12;break}if(a>>>0>=16384)if(a>>>0<2097152){l=3;h=17;break}else{m=4;h=16;break}if(a>>>0<128){n=1;o=a|128;p=o&255;b[d>>0]=p;q=n+-1|0;r=d+q|0;s=b[r>>0]|0;t=s&127;b[r>>0]=t;u=d+n|0;return u|0}else v=2}else{if(f>>>0<128)w=9;else{x=Sac(a|0,c|0,63)|0;b[d+9>>0]=x|128;w=10}b[d+8>>0]=f|128;k=w;h=12}while(0);if((h|0)==12){w=Sac(a|0,c|0,49)|0;b[d+7>>0]=w|128;j=k;h=13}if((h|0)==13){k=Sac(a|0,c|0,42)|0;b[d+6>>0]=k|128;i=j;h=14}if((h|0)==14){j=Sac(a|0,c|0,35)|0;b[d+5>>0]=j|128;g=i;h=15}if((h|0)==15){b[d+4>>0]=e|128;m=g;h=16}if((h|0)==16){b[d+3>>0]=a>>>21|128;l=m;h=17}if((h|0)==17){b[d+2>>0]=a>>>14|128;v=l}b[d+1>>0]=a>>>7|128;n=v;o=a|128;p=o&255;b[d>>0]=p;q=n+-1|0;r=d+q|0;s=b[r>>0]|0;t=s&127;b[r>>0]=t;u=d+n|0;return u|0}function iob(a){a=a|0;return (((($(a|0)|0)^31)>>>0)/7|0)+1|0}function job(a,b){a=a|0;b=b|0;var c=0,d=0;if(b>>>0<0|(b|0)==0&a>>>0<128){c=1;return c|0}d=_ac(a|0,b|0,0)|0;c=(((d^63)>>>0)/7|0)+1|0;return c|0}function kob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+11|0;e=b[d>>0]|0;if(e<<24>>24<0){g=a+4|0;h=f[g>>2]|0;if(h>>>0>127){i=h;j=c;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;o=g;break}}}else{m=c;n=h;o=g}}else{m=c;n=e&255;o=a+4|0}b[m>>0]=n;n=m+1|0;m=b[d>>0]|0;d=m<<24>>24<0;e=d?f[o>>2]|0:m&255;Vac(n|0,(d?f[a>>2]|0:a)|0,e|0)|0;return n+e|0}function lob(a){a=a|0;return}function mob(a){a=a|0;O5b(a);return}function nob(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+16|0;e=f[d>>2]|0;g=f[a+8>>2]|0;if((g|0)>(e|0)){h=g-e|0;g=f[a+12>>2]|0;i=(h|0)<(g|0)?h:g;g=a+20|0;f[g>>2]=i;f[b>>2]=(f[a+4>>2]|0)+e;f[c>>2]=i;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0);j=1;return j|0}else{f[a+20>>2]=0;j=0;return j|0}return 0}function oob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+80|0;d=c+48|0;e=c+24|0;g=c;h=a+20|0;i=f[h>>2]|0;if((i|0)>0)j=i;else{zpb(d,3,447373,85);xpb(c+74|0,vpb(vpb(d,447515)|0,447559)|0);Apb(d);j=f[h>>2]|0}if((j|0)<(b|0)){zpb(e,3,447373,87);xpb(c+73|0,vpb(e,447614)|0);Apb(e)}if((b|0)>-1){k=a+16|0;l=f[k>>2]|0;m=l-b|0;f[k>>2]=m;f[h>>2]=0;u=c;return}zpb(g,3,447373,88);xpb(c+72|0,vpb(g,447484)|0);Apb(g);k=a+16|0;l=f[k>>2]|0;m=l-b|0;f[k>>2]=m;f[h>>2]=0;u=c;return}function pob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+32|0;d=c;if((b|0)<=-1){zpb(d,3,447373,94);xpb(c+24|0,vpb(d,447484)|0);Apb(d)}f[a+20>>2]=0;d=f[a+8>>2]|0;e=a+16|0;a=f[e>>2]|0;g=(d-a|0)<(b|0);f[e>>2]=g?d:a+b|0;u=c;return g^1|0}function qob(a){a=a|0;var b=0;b=f[a+16>>2]|0;J=((b|0)<0)<<31>>31;return b|0}function rob(a){a=a|0;return}function sob(a){a=a|0;O5b(a);return}function tob(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+16|0;e=f[d>>2]|0;g=f[a+8>>2]|0;if((g|0)>(e|0)){h=g-e|0;g=f[a+12>>2]|0;i=(h|0)<(g|0)?h:g;g=a+20|0;f[g>>2]=i;f[b>>2]=(f[a+4>>2]|0)+e;f[c>>2]=i;f[d>>2]=(f[d>>2]|0)+(f[g>>2]|0);j=1;return j|0}else{f[a+20>>2]=0;j=0;return j|0}return 0}function uob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+80|0;d=c+48|0;e=c+24|0;g=c;h=a+20|0;i=f[h>>2]|0;if((i|0)>0)j=i;else{zpb(d,3,447373,138);xpb(c+74|0,vpb(vpb(d,447515)|0,447559)|0);Apb(d);j=f[h>>2]|0}if((j|0)<(b|0)){zpb(e,3,447373,140);xpb(c+73|0,vpb(e,447614)|0);Apb(e)}if((b|0)>-1){k=a+16|0;l=f[k>>2]|0;m=l-b|0;f[k>>2]=m;f[h>>2]=0;u=c;return}zpb(g,3,447373,141);xpb(c+72|0,vpb(g,447484)|0);Apb(g);k=a+16|0;l=f[k>>2]|0;m=l-b|0;f[k>>2]=m;f[h>>2]=0;u=c;return}function vob(a){a=a|0;var b=0;b=f[a+16>>2]|0;J=((b|0)<0)<<31>>31;return b|0}function wob(a){a=a|0;return 0}function xob(a){a=a|0;return}function yob(a){a=a|0;O5b(a);return}function zob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+64|0;g=e+24|0;h=e;i=e+48|0;j=a+4|0;a=f[j>>2]|0;if(!a){zpb(g,3,447373,160);xpb(e+49|0,vpb(g,447744)|0);Apb(g);k=f[j>>2]|0}else k=a;a=b[k+11>>0]|0;g=a<<24>>24<0;if(g){l=f[k+4>>2]|0;m=(f[k+8>>2]&2147483647)+-1|0}else{l=a&255;m=10}do if(l>>>0<m>>>0){if(g)n=(f[k+8>>2]&2147483647)+-1|0;else n=10;e6b(k,n,0)}else{if((l|0)<=1073741823){a=l<<1;e6b(k,(a|0)>16?a:16,0);break}zpb(h,2,447373,173);xpb(i,vpb(vpb(h,447821)|0,447871)|0);Apb(h);o=0;u=e;return o|0}while(0);h=f[j>>2]|0;i=b[h+11>>0]|0;k=i<<24>>24<0;if(k)p=f[h+4>>2]|0;else p=i&255;do if(p)if(k){q=f[h>>2]|0;break}else{q=h;break}else q=0;while(0);f[c>>2]=q+l;q=f[j>>2]|0;j=b[q+11>>0]|0;if(j<<24>>24<0)r=f[q+4>>2]|0;else r=j&255;f[d>>2]=r-l;o=1;u=e;return o|0}function Aob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+80|0;e=d+48|0;g=d+24|0;h=d;if((c|0)<=-1){zpb(e,3,447373,191);xpb(d+74|0,vpb(e,447484)|0);Apb(e)}e=a+4|0;a=f[e>>2]|0;if(!a){zpb(g,3,447373,192);xpb(d+73|0,vpb(g,447744)|0);Apb(g);i=f[e>>2]|0}else i=a;a=b[i+11>>0]|0;if(a<<24>>24<0)j=f[i+4>>2]|0;else j=a&255;if(j>>>0<c>>>0){zpb(h,3,447373,193);xpb(d+72|0,vpb(h,447776)|0);Apb(h);h=f[e>>2]|0;k=b[h+11>>0]|0;l=h}else{k=a;l=i}if(k<<24>>24<0){m=f[l+4>>2]|0;n=m-c|0;e6b(l,n,0);u=d;return}else{m=k&255;n=m-c|0;e6b(l,n,0);u=d;return}}function Bob(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+32|0;d=c;e=a+4|0;a=f[e>>2]|0;if(!a){zpb(d,3,447373,198);xpb(c+24|0,vpb(d,447744)|0);Apb(d);g=f[e>>2]|0}else g=a;a=b[g+11>>0]|0;if(a<<24>>24<0){h=f[g+4>>2]|0;J=0;u=c;return h|0}else{h=a&255;J=0;u=c;return h|0}return 0}function Cob(a){a=a|0;var c=0;f[a>>2]=135760;if(b[a+8>>0]|0?(c=f[a+4>>2]|0,c|0):0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+24>>2]|0;if(!c)return;P5b(c);return}function Dob(a){a=a|0;var c=0;f[a>>2]=135760;if(b[a+8>>0]|0?(c=f[a+4>>2]|0,c|0):0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+24>>2]|0;if(!c){O5b(a);return}P5b(c);O5b(a);return}function Eob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+9|0;if(b[e>>0]|0){g=0;return g|0}h=a+24|0;i=f[h>>2]|0;if(!i){j=f[a+28>>2]|0;k=N5b((j|0)>-1?j:-1)|0;f[h>>2]=k;l=k}else l=i;i=a+36|0;k=f[i>>2]|0;if((k|0)>0){f[c>>2]=l+(f[a+32>>2]|0)+(0-k);f[d>>2]=k;f[i>>2]=0;g=1;return g|0}i=f[a+4>>2]|0;k=li[f[(f[i>>2]|0)+8>>2]&511](i,l,f[a+28>>2]|0)|0;f[a+32>>2]=k;if((k|0)>=1){l=a+16|0;i=l;j=Kac(f[i>>2]|0,f[i+4>>2]|0,k|0,((k|0)<0)<<31>>31|0)|0;i=l;f[i>>2]=j;f[i+4>>2]=J;f[d>>2]=k;f[c>>2]=f[h>>2];g=1;return g|0}if((k|0)<0)b[e>>0]=1;Iob(a);g=0;return g|0}function Fob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+80|0;d=c+48|0;e=c+74|0;g=c+24|0;h=c+73|0;i=c;j=c+72|0;k=a+36|0;if(!((f[k>>2]|0)==0?(f[a+24>>2]|0)!=0:0)){zpb(d,3,447373,301);xpb(e,vpb(vpb(d,447933)|0,447993)|0);Apb(d)}if((f[a+32>>2]|0)<(b|0)){zpb(g,3,447373,303);xpb(h,vpb(vpb(g,448036)|0,448078)|0);Apb(g)}if((b|0)>-1){f[k>>2]=b;u=c;return}zpb(i,3,447373,306);xpb(j,vpb(vpb(i,447484)|0,448156)|0);Apb(i);f[k>>2]=b;u=c;return}function Gob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d;if((c|0)<=-1){zpb(e,3,447373,313);xpb(d+24|0,vpb(e,447484)|0);Apb(e)}if(b[a+9>>0]|0){g=0;u=d;return g|0}e=a+36|0;h=f[e>>2]|0;if((h|0)<(c|0)){i=c-h|0;f[e>>2]=0;j=f[a+4>>2]|0;k=Uh[f[(f[j>>2]|0)+12>>2]&1023](j,i)|0;j=a+16|0;a=j;l=Kac(f[a>>2]|0,f[a+4>>2]|0,k|0,((k|0)<0)<<31>>31|0)|0;a=j;f[a>>2]=l;f[a+4>>2]=J;g=(k|0)==(i|0);u=d;return g|0}else{f[e>>2]=h-c;g=1;u=d;return g|0}return 0}function Hob(a){a=a|0;var b=0,c=0;b=a+16|0;c=f[a+36>>2]|0;a=Jac(f[b>>2]|0,f[b+4>>2]|0,c|0,((c|0)<0)<<31>>31|0)|0;return a|0}function Iob(a){a=a|0;var b=0,c=0;b=u;u=u+32|0;c=b;if(f[a+36>>2]|0){zpb(c,3,447373,346);xpb(b+24|0,vpb(c,448198)|0);Apb(c)}f[a+32>>2]=0;c=a+24|0;a=f[c>>2]|0;if(!a){u=b;return}P5b(a);f[c>>2]=0;u=b;return}function Job(a){a=a|0;return}function Kob(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+4096|0;d=c;e=0;while(1){if((e|0)>=(b|0)){g=4;break}h=b-e|0;i=li[f[(f[a>>2]|0)+8>>2]&511](a,d,(h|0)<4096?h:4096)|0;h=(i|0)<1;if(h){g=4;break}else e=(h?0:i)+e|0}if((g|0)==4){u=c;return e|0}return 0}function Lob(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=135656;f[a+4>>2]=b;f[a+8>>2]=c;f[a+12>>2]=(d|0)>0?d:c;f[a+16>>2]=0;f[a+20>>2]=0;return}function Mob(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=135688;f[a+4>>2]=b;f[a+8>>2]=c;f[a+12>>2]=(d|0)>0?d:c;f[a+16>>2]=0;f[a+20>>2]=0;return}function Nob(a,b){a=a|0;b=b|0;f[a>>2]=135724;f[a+4>>2]=b;return}function Oob(a,c,d){a=a|0;c=c|0;d=d|0;f[a>>2]=135760;f[a+4>>2]=c;b[a+8>>0]=0;b[a+9>>0]=0;c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[a+24>>2]=0;f[a+28>>2]=(d|0)>0?d:8192;f[a+32>>2]=0;f[a+36>>2]=0;return}function Pob(a,c){a=a|0;c=c|0;var d=0,e=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=L5b(64)|0;f[a>>2]=c;f[a+8>>2]=-2147483584;f[a+4>>2]=50;a=c;d=448460;e=a+50|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(e|0));b[c+50>>0]=0;return}function Qob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;c=u;u=u+80|0;e=c+48|0;g=c+24|0;h=c;i=di[f[(f[a>>2]|0)+64>>2]&1023](a)|0;Mob(e,d,i,-1);$nb(g,e);zh[f[(f[a>>2]|0)+56>>2]&2047](a,g);if(!(b[g+16>>0]|0)){aob(g);j=d+i|0;rob(e);u=c;return j|0}zpb(h,3,448328,231);xpb(c+72|0,vpb(h,448422)|0);Apb(h);aob(g);j=d+i|0;rob(e);u=c;return j|0}function Rob(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1508);return}function Sob(a){a=a|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Tob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+64|0;e=d+40|0;g=d+16|0;h=d;bi[f[(f[a>>2]|0)+28>>2]&2047](a);if(!(Uh[f[(f[a>>2]|0)+44>>2]&1023](a,c)|0)){i=0;u=d;return i|0}if(di[f[(f[a>>2]|0)+32>>2]&1023](a)|0){i=1;u=d;return i|0}zpb(g,2,448328,119);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k6b(h,448543)|0;k6b(h,448550)|0;k6b(h,448556)|0;zh[f[(f[a>>2]|0)+8>>2]&2047](e,a);c=e+11|0;j=b[c>>0]|0;k=j<<24>>24<0;j6b(h,k?f[e>>2]|0:e,k?f[e+4>>2]|0:j&255)|0;if((b[c>>0]|0)<0)O5b(f[e>>2]|0);k6b(h,448575)|0;zh[f[(f[a>>2]|0)+36>>2]&2047](e,a);a=e+11|0;c=b[a>>0]|0;j=c<<24>>24<0;j6b(h,j?f[e>>2]|0:e,j?f[e+4>>2]|0:c&255)|0;if((b[a>>0]|0)<0)O5b(f[e>>2]|0);xpb(d+52|0,wpb(g,h)|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);Apb(g);i=0;u=d;return i|0}function Uob(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+112|0;g=e+96|0;h=e+72|0;i=e+60|0;j=e+108|0;k=e;l=b[c+11>>0]|0;m=l<<24>>24<0;n=m?f[c>>2]|0:c;o=m?f[c+4>>2]|0:l&255;f[k>>2]=n;f[k+4>>2]=n+o;f[k+8>>2]=0;f[k+12>>2]=o;n=k+16|0;f[n>>2]=0;f[n+4>>2]=0;d[n+8>>1]=0;f[k+28>>2]=o;f[k+32>>2]=0;f[k+36>>2]=67108864;f[k+40>>2]=33554432;o=f[33911]|0;f[k+44>>2]=o;f[k+48>>2]=o;f[k+52>>2]=0;f[k+56>>2]=0;bi[f[(f[a>>2]|0)+28>>2]&2047](a);if(Uh[f[(f[a>>2]|0)+44>>2]&1023](a,k)|0){if(di[f[(f[a>>2]|0)+32>>2]&1023](a)|0){p=(b[k+24>>0]|0)!=0;Fnb(k);u=e;return p|0}zpb(h,2,448328,119);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k6b(i,448543)|0;k6b(i,448550)|0;k6b(i,448556)|0;zh[f[(f[a>>2]|0)+8>>2]&2047](g,a);o=g+11|0;n=b[o>>0]|0;l=n<<24>>24<0;j6b(i,l?f[g>>2]|0:g,l?f[g+4>>2]|0:n&255)|0;if((b[o>>0]|0)<0)O5b(f[g>>2]|0);k6b(i,448575)|0;zh[f[(f[a>>2]|0)+36>>2]&2047](g,a);a=g+11|0;o=b[a>>0]|0;n=o<<24>>24<0;j6b(i,n?f[g>>2]|0:g,n?f[g+4>>2]|0:o&255)|0;if((b[a>>0]|0)<0)O5b(f[g>>2]|0);xpb(j,wpb(h,i)|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);Apb(h)}p=0;Fnb(k);u=e;return p|0}function Vob(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+64|0;g=e;h=b[c+11>>0]|0;i=h<<24>>24<0;j=i?f[c>>2]|0:c;k=i?f[c+4>>2]|0:h&255;f[g>>2]=j;f[g+4>>2]=j+k;f[g+8>>2]=0;f[g+12>>2]=k;j=g+16|0;f[j>>2]=0;f[j+4>>2]=0;d[j+8>>1]=0;f[g+28>>2]=k;f[g+32>>2]=0;f[g+36>>2]=67108864;f[g+40>>2]=33554432;k=f[33911]|0;f[g+44>>2]=k;f[g+48>>2]=k;f[g+52>>2]=0;f[g+56>>2]=0;bi[f[(f[a>>2]|0)+28>>2]&2047](a);k=Uh[f[(f[a>>2]|0)+44>>2]&1023](a,g)|0;a=k&(b[g+24>>0]|0)!=0;Fnb(g);u=e;return a|0}function Wob(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+112|0;h=g+96|0;i=g+72|0;j=g+60|0;k=g+108|0;l=g;f[l>>2]=c;f[l+4>>2]=c+e;f[l+8>>2]=0;f[l+12>>2]=e;c=l+16|0;f[c>>2]=0;f[c+4>>2]=0;d[c+8>>1]=0;f[l+28>>2]=e;f[l+32>>2]=0;f[l+36>>2]=67108864;f[l+40>>2]=33554432;e=f[33911]|0;f[l+44>>2]=e;f[l+48>>2]=e;f[l+52>>2]=0;f[l+56>>2]=0;bi[f[(f[a>>2]|0)+28>>2]&2047](a);if(Uh[f[(f[a>>2]|0)+44>>2]&1023](a,l)|0){if(di[f[(f[a>>2]|0)+32>>2]&1023](a)|0){m=(b[l+24>>0]|0)!=0;Fnb(l);u=g;return m|0}zpb(i,2,448328,119);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;k6b(j,448543)|0;k6b(j,448550)|0;k6b(j,448556)|0;zh[f[(f[a>>2]|0)+8>>2]&2047](h,a);e=h+11|0;c=b[e>>0]|0;n=c<<24>>24<0;j6b(j,n?f[h>>2]|0:h,n?f[h+4>>2]|0:c&255)|0;if((b[e>>0]|0)<0)O5b(f[h>>2]|0);k6b(j,448575)|0;zh[f[(f[a>>2]|0)+36>>2]&2047](h,a);a=h+11|0;e=b[a>>0]|0;c=e<<24>>24<0;j6b(j,c?f[h>>2]|0:h,c?f[h+4>>2]|0:e&255)|0;if((b[a>>0]|0)<0)O5b(f[h>>2]|0);xpb(k,wpb(i,j)|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);Apb(i)}m=0;Fnb(l);u=g;return m|0}function Xob(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+96|0;h=g+48|0;i=g+72|0;j=g+24|0;k=g+85|0;l=g;m=g+84|0;if((a|0)!=(c|0)){zpb(h,3,448328,66);c=vpb(h,448656)|0;zh[f[(f[e>>2]|0)+8>>2]&2047](i,e);xpb(g+86|0,vpb(wpb(c,i)|0,448740)|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);Apb(h)}if((d|0)==(a|0)){zpb(l,3,448328,73);n=vpb(l,449030)|0;xpb(m,n);Apb(l);u=g;return}zpb(j,3,448328,69);a=vpb(vpb(j,448789)|0,448875)|0;zh[f[(f[e>>2]|0)+8>>2]&2047](i,e);xpb(k,vpb(wpb(a,i)|0,489392)|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);Apb(j);zpb(l,3,448328,73);n=vpb(l,449030)|0;xpb(m,n);Apb(l);u=g;return}function Yob(a,b){a=a|0;b=b|0;return Zob(a,b)|0}function Zob(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d;g=c+11|0;h=b[g>>0]|0;if(h<<24>>24<0)i=f[c+4>>2]|0;else i=h&255;h=di[f[(f[a>>2]|0)+52>>2]&1023](a)|0;if((h|0)<0){zpb(e,2,448328,297);xpb(d+24|0,vpb(e,448617)|0);Apb(e);j=0;u=d;return j|0}e6b(c,h+i|0,0);e=b[g>>0]|0;g=e<<24>>24<0;if(g)k=f[c+4>>2]|0;else k=e&255;do if(k)if(g){l=f[c>>2]|0;break}else{l=c;break}else l=0;while(0);c=l+i|0;i=(Uh[f[(f[a>>2]|0)+60>>2]&1023](a,c)|0)-c|0;if((i|0)==(h|0)){j=1;u=d;return j|0}Xob(h,di[f[(f[a>>2]|0)+52>>2]&1023](a)|0,i,a);j=1;u=d;return j|0}function _ob(a,c){a=a|0;c=c|0;var d=0;d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0}else{b[c>>0]=0;b[d>>0]=0}return Zob(a,c)|0}function $ob(a,c){a=a|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(Zob(c,a)|0)return;c=a+11|0;if((b[c>>0]|0)<0){b[f[a>>2]>>0]=0;f[a+4>>2]=0;return}else{b[a>>0]=0;b[c>>0]=0;return}}function apb(a,b){a=a|0;b=b|0;_5b(b,a)|0;return}function bpb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+32|0;d=c;e=a+4|0;g=f[e>>2]|0;h=g+b|0;b=a+8|0;i=f[b>>2]|0;j=a+12|0;k=f[j>>2]|0;if((i|0)>=(h|0)){l=k;m=g;n=l+4+(m<<2)|0;u=c;return n|0}g=f[a>>2]|0;a=i<<1;i=(a|0)<(h|0)?h:a;a=(i|0)>4?i:4;if(a>>>0>1073741822){zpb(d,3,449083,59);xpb(c+24|0,vpb(vpb(d,449179)|0,468650)|0);Apb(d)}d=(a<<2)+4|0;i=(g|0)==0;if(i)o=L5b(d)|0;else o=znb(g,25528,d)|0;f[j>>2]=o;f[b>>2]=a;if((k|0)!=0?(a=f[k>>2]|0,(a|0)>0):0){Vac(o+4|0,k+4|0,a<<2|0)|0;p=f[k>>2]|0;q=f[j>>2]|0}else{p=0;q=o}f[q>>2]=p;if(i){O5b(k);r=f[j>>2]|0}else r=q;l=r;m=f[e>>2]|0;n=l+4+(m<<2)|0;u=c;return n|0}function cpb(a,b){a=a|0;b=b|0;var c=0;c=f[a+4>>2]|0;if((c|0)>=(b|0))return;bpb(a,b-c|0)|0;return}function dpb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+12|0;e=f[d>>2]|0;if(!e)return;g=c+b|0;b=f[e>>2]|0;if((g|0)<(b|0)){h=g;g=e;while(1){f[g+4+(h-c<<2)>>2]=f[g+4+(h<<2)>>2];h=h+1|0;i=f[d>>2]|0;j=f[i>>2]|0;if((h|0)>=(j|0)){k=j;l=i;break}else g=i}}else{k=b;l=e}e=a+4|0;f[e>>2]=(f[e>>2]|0)-c;f[l>>2]=k-c;return}function epb(a){a=a|0;var c=0;f[a>>2]=135792;c=a+12|0;if((b[c+11>>0]|0)>=0)return;O5b(f[c>>2]|0);return}function fpb(a){a=a|0;var c=0;f[a>>2]=135792;c=a+12|0;if((b[c+11>>0]|0)>=0){O5b(a);return}O5b(f[c>>2]|0);O5b(a);return}function gpb(a){a=a|0;var c=0,d=0;c=a+12|0;if((b[c+11>>0]|0)<0){d=f[c>>2]|0;return d|0}else{d=c;return d|0}return 0}function hpb(a){a=a|0;return}function ipb(a){a=a|0;O5b(a);return}function jpb(a){a=a|0;var c=0;c=b[a+8>>0]|0;$h[f[a+4>>2]&127]();if((a|0)==0|c<<24>>24==0)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function kpb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=u;u=u+256|0;g=e+48|0;h=e+32|0;i=e+16|0;j=e;k=e+128|0;l=e+88|0;m=e+112|0;n=e+64|0;if((c|0)>3001e3){f[l>>2]=3;f[l+4>>2]=449404;f[l+8>>2]=67;o=l+12|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;k6b(o,449498)|0;f[j>>2]=(c>>>0)/1e6|0;f[j+4>>2]=(((c>>>0)/1e3|0)>>>0)%1e3|0;f[j+8>>2]=(c>>>0)%1e3|0;GUb(k,128,449529,j)|0;c=k+127|0;b[c>>0]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;p=kUb(k)|0;if(p>>>0>4294967279)V5b(m);if(p>>>0<11){q=m+11|0;b[q>>0]=p;if(!p){r=m;s=q}else{t=m;v=q;w=7}}else{q=p+16&-16;x=L5b(q)|0;f[m>>2]=x;f[m+8>>2]=q|-2147483648;f[m+4>>2]=p;t=x;v=m+11|0;w=7}if((w|0)==7){Vac(t|0,k|0,p|0)|0;r=t;s=v}b[r+p>>0]=0;p=b[s>>0]|0;r=p<<24>>24<0;j6b(o,r?f[m>>2]|0:m,r?f[m+4>>2]|0:p&255)|0;k6b(o,449538)|0;f[i>>2]=3;f[i+4>>2]=1;f[i+8>>2]=0;GUb(k,128,449529,i)|0;b[c>>0]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c=kUb(k)|0;if(c>>>0>4294967279)V5b(j);if(c>>>0<11){i=j+11|0;b[i>>0]=c;if(!c){y=j;z=i}else{A=j;B=i;w=13}}else{i=c+16&-16;p=L5b(i)|0;f[j>>2]=p;f[j+8>>2]=i|-2147483648;f[j+4>>2]=c;A=p;B=j+11|0;w=13}if((w|0)==13){Vac(A|0,k|0,c|0)|0;y=A;z=B}b[y+c>>0]=0;c=b[z>>0]|0;y=c<<24>>24<0;j6b(o,y?f[j>>2]|0:j,y?f[j+4>>2]|0:c&255)|0;k6b(o,449609)|0;k6b(o,d)|0;k6b(o,449815)|0;lpb(l);if((b[z>>0]|0)<0)O5b(f[j>>2]|0);if((b[s>>0]|0)<0)O5b(f[m>>2]|0);if((b[o+11>>0]|0)<0)O5b(f[o>>2]|0)}if((a|0)>=3001e3){u=e;return}f[n>>2]=3;f[n+4>>2]=449404;f[n+8>>2]=78;o=n+12|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;k6b(o,449819)|0;f[h>>2]=(a|0)/1e6|0;f[h+4>>2]=((a|0)/1e3|0|0)%1e3|0;f[h+8>>2]=(a|0)%1e3|0;GUb(k,128,449529,h)|0;a=k+127|0;b[a>>0]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;s=kUb(k)|0;if(s>>>0>4294967279)V5b(m);if(s>>>0<11){j=m+11|0;b[j>>0]=s;if(!s){C=m;D=j}else{E=m;F=j;w=26}}else{j=s+16&-16;z=L5b(j)|0;f[m>>2]=z;f[m+8>>2]=j|-2147483648;f[m+4>>2]=s;E=z;F=m+11|0;w=26}if((w|0)==26){Vac(E|0,k|0,s|0)|0;C=E;D=F}b[C+s>>0]=0;s=b[D>>0]|0;C=s<<24>>24<0;j6b(o,C?f[m>>2]|0:m,C?f[m+4>>2]|0:s&255)|0;k6b(o,449862)|0;f[g>>2]=3;f[g+4>>2]=1;f[g+8>>2]=0;GUb(k,128,449529,g)|0;b[a>>0]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;a=kUb(k)|0;if(a>>>0>4294967279)V5b(h);if(a>>>0<11){g=h+11|0;b[g>>0]=a;if(!a){G=h;H=g}else{I=h;J=g;w=32}}else{g=a+16&-16;s=L5b(g)|0;f[h>>2]=s;f[h+8>>2]=g|-2147483648;f[h+4>>2]=a;I=s;J=h+11|0;w=32}if((w|0)==32){Vac(I|0,k|0,a|0)|0;G=I;H=J}b[G+a>>0]=0;a=b[H>>0]|0;G=a<<24>>24<0;j6b(o,G?f[h>>2]|0:h,G?f[h+4>>2]|0:a&255)|0;k6b(o,449956)|0;k6b(o,d)|0;k6b(o,449815)|0;lpb(n);if((b[H>>0]|0)<0)O5b(f[h>>2]|0);if((b[D>>0]|0)<0)O5b(f[m>>2]|0);if((b[o+11>>0]|0)>=0){u=e;return}O5b(f[o>>2]|0);u=e;return}function lpb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;if((f[a>>2]|0)!=3){if((f[213346]|0)!=2){f[d>>2]=135812;f[d+4>>2]=44;b[d+8>>0]=0;Gpb(853384,d)}d=f[213350]|0;npb(d);e=(f[213351]|0)>0;opb(d);if(!e){g=f[a>>2]|0;h=6}}else{g=3;h=6}if((h|0)==6)th[f[33956]&511](g,f[a+4>>2]|0,f[a+8>>2]|0,a+12|0);if((f[a>>2]|0)==3){g=ze(24)|0;ppb(g,f[a+4>>2]|0,f[a+8>>2]|0,a+12|0);If(g|0,22552,1199)}else{u=c;return}}function mpb(){var a=0,b=0;a=L5b(4)|0;b=L5b(28)|0;f[a>>2]=b;Nf(b|0,0)|0;f[213350]=a;spb(45);return}function npb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c;e=Mac(f[a>>2]|0)|0;if(!e){u=c;return}f[d>>2]=3;f[d+4>>2]=449404;f[d+8>>2]=368;a=d+12|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;k6b(a,450246)|0;k6b(a,wTb(e)|0)|0;lpb(d);if((b[a+11>>0]|0)>=0){u=c;return}O5b(f[a>>2]|0);u=c;return}function opb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+32|0;d=c;e=Lac(f[a>>2]|0)|0;if(!e){u=c;return}f[d>>2]=3;f[d+4>>2]=449404;f[d+8>>2]=375;a=d+12|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;k6b(a,450223)|0;k6b(a,wTb(e)|0)|0;lpb(d);if((b[a+11>>0]|0)>=0){u=c;return}O5b(f[a>>2]|0);u=c;return}function ppb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=135792;f[a+4>>2]=b;f[a+8>>2]=c;X5b(a+12|0,d);return}function qpb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;i=f[35349]|0;j=(b[e+11>>0]|0)<0?f[e>>2]|0:e;f[h>>2]=f[135828+(a<<2)>>2];f[h+4>>2]=c;f[h+8>>2]=d;f[h+12>>2]=j;EUb(i,450177,h)|0;AUb(i)|0;u=g;return}function rpb(){var a=0,b=0;a=f[213350]|0;if(!a){f[213350]=0;return}xf(f[a>>2]|0)|0;b=f[a>>2]|0;if(b|0)O5b(b);O5b(a);f[213350]=0;return}function spb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c+4|0;e=c;f[e>>2]=a;if((f[213349]|0)!=2){f[d>>2]=135812;f[d+4>>2]=46;b[d+8>>0]=0;Gpb(853396,d)}d=f[213348]|0;npb(d);a=f[213347]|0;g=a+4|0;h=f[g>>2]|0;if((h|0)==(f[a+8>>2]|0)){upb(a,e);opb(d);u=c;return}else{f[h>>2]=f[e>>2];f[g>>2]=(f[g>>2]|0)+4;opb(d);u=c;return}}function tpb(){var a=0,b=0;a=L5b(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[213347]=a;a=L5b(4)|0;b=L5b(28)|0;f[a>>2]=b;Nf(b|0,0)|0;f[213348]=a;return}function upb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function vpb(a,b){a=a|0;b=b|0;k6b(a+12|0,b)|0;return a|0}function wpb(a,c){a=a|0;c=c|0;var d=0,e=0;d=b[c+11>>0]|0;e=d<<24>>24<0;j6b(a+12|0,e?f[c>>2]|0:c,e?f[c+4>>2]|0:d&255)|0;return a|0}function xpb(a,b){a=a|0;b=b|0;lpb(b);return}function ypb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+144|0;e=d;g=d+8|0;f[e>>2]=c;GUb(g,128,475964,e)|0;b[g+127>>0]=0;k6b(a+12|0,g)|0;u=d;return a|0}function zpb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;f[a>>2]=b;f[a+4>>2]=c;f[a+8>>2]=d;d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;return}function Apb(a){a=a|0;var c=0;c=a+12|0;if((b[c+11>>0]|0)>=0)return;O5b(f[c>>2]|0);return}function Bpb(a){a=a|0;var b=0;b=L5b(28)|0;f[a>>2]=b;Nf(b|0,0)|0;return}function Cpb(a){a=a|0;var b=0;xf(f[a>>2]|0)|0;b=f[a>>2]|0;if(!b)return;O5b(b);return}function Dpb(a){a=a|0;return}function Epb(a){a=a|0;return Zac(a|0)|0}function Fpb(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+16|0;c=a;if((f[213349]|0)!=2){f[c>>2]=135812;f[c+4>>2]=46;b[c+8>>0]=0;Gpb(853396,c)}c=f[213347]|0;if(!c){u=a;return}d=f[c+4>>2]|0;e=f[c>>2]|0;if((d|0)!=(e|0)){g=0;h=e;do{$h[f[h+(g<<2)>>2]&127]();g=g+1|0;i=f[213347]|0;j=f[i+4>>2]|0;h=f[i>>2]|0}while(g>>>0<j-h>>2>>>0);if(i|0){k=j;l=i;m=7}}else{k=d;l=c;m=7}if((m|0)==7){m=k;k=f[l>>2]|0;if(k|0){if((m|0)!=(k|0))f[l+4>>2]=m+(~((m+-4-k|0)>>>2)<<2);O5b(k)}O5b(l)}f[213347]=0;l=f[213348]|0;if(l|0){xf(f[l>>2]|0)|0;k=f[l>>2]|0;if(k|0)O5b(k);O5b(l)}f[213348]=0;u=a;return}function Gpb(a,b){a=a|0;b=b|0;var c=0;if((f[a>>2]|0)==2)return;c=f[a>>2]|0;if(!c)f[a>>2]=1;switch(((c|0)==0?0:c)|0){case 0:{bi[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=2;return}case 1:{do ve()|0;while((f[a>>2]|0)==1);return}default:return}}function Hpb(){var a=0,b=0,c=0;a=u;u=u+16|0;b=a+8|0;c=a;f[213352]=0;f[213353]=0;f[213354]=0;f[213355]=0;zd(1509,853408,x|0)|0;f[c>>2]=1124530;f[c+4>>2]=0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];Jpb(853424,1,b);zd(1509,853424,x|0)|0;f[c>>2]=1124530;f[c+4>>2]=0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];Jpb(853440,2,b);zd(1509,853440,x|0)|0;u=a;return}function Ipb(a){a=a|0;var c=0;c=a+4|0;if((b[c+11>>0]|0)>=0)return;O5b(f[c>>2]|0);return}function Jpb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;f[a>>2]=c;h=a+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(!c){u=e;return}c=f[d>>2]|0;if(!c){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0}else{a=f[d+4>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(a>>>0>4294967279)V5b(g);if(a>>>0<11){b[g+11>>0]=a;if(!a)i=g;else{j=g;k=9}}else{d=a+16&-16;l=L5b(d)|0;f[g>>2]=l;f[g+8>>2]=d|-2147483648;f[g+4>>2]=a;j=l;k=9}if((k|0)==9){Vac(j|0,c|0,a|0)|0;i=j}b[i+a>>0]=0}_5b(h,g)|0;if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);u=e;return}function Kpb(a){a=a|0;return}function Lpb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;switch(c&7){case 0:{g=f[a>>2]|0;if(g>>>0<(f[a+4>>2]|0)>>>0?(b[g>>0]|0)>-1:0)f[a>>2]=g+1;else i=5;if((i|0)==5?(Lnb(e,a),(b[e+8>>0]|0)==0):0){j=0;u=d;return j|0}j=1;u=d;return j|0}case 1:{g=f[a>>2]|0;if(((f[a+4>>2]|0)-g|0)<=7)if(Ynb(a,e)|0)i=10;else k=0;else{l=g;m=l;n=l+4|0;l=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;n=e;f[n>>2]=h[m>>0]|h[m+1>>0]<<8|h[m+2>>0]<<16|h[m+3>>0]<<24;f[n+4>>2]=l;f[a>>2]=g+8;i=10}if((i|0)==10)k=1;j=k;u=d;return j|0}case 2:{k=f[a>>2]|0;if(k>>>0<(f[a+4>>2]|0)>>>0){g=b[k>>0]|0;l=g&255;if(g<<24>>24>-1){f[a>>2]=k+1;o=l}else{p=l;i=15}}else{p=0;i=15}if((i|0)==15){l=Knb(a,p)|0;p=J;if((p|0)>-1|(p|0)==-1&l>>>0>4294967295)o=l;else{j=0;u=d;return j|0}}j=Tnb(a,o)|0;u=d;return j|0}case 3:{o=a+44|0;l=f[o>>2]|0;f[o>>2]=l+-1;if((l|0)<=0){j=0;u=d;return j|0}l=a+4|0;p=a+20|0;while(1){k=f[a>>2]|0;if(k>>>0<(f[l>>2]|0)>>>0){g=b[k>>0]|0;n=g&255;if(g<<24>>24>-1){f[p>>2]=n;f[a>>2]=k+1;q=n}else{r=n;i=22}}else{r=0;i=22}if((i|0)==22){i=0;n=_nb(a,r)|0;f[p>>2]=n;q=n}if((q|0)==0|(q&7|0)==4)break;if(!(Lpb(a,q)|0)){j=0;i=33;break}}if((i|0)==33){u=d;return j|0}p=f[o>>2]|0;if((p|0)<(f[a+48>>2]|0))f[o>>2]=p+1;j=(q|0)==(c&-8|4|0);u=d;return j|0}case 5:{c=f[a>>2]|0;if(((f[a+4>>2]|0)-c|0)<=3)if(Xnb(a,e)|0)i=31;else s=0;else{q=c;f[e>>2]=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;f[a>>2]=c+4;i=31}if((i|0)==31)s=1;j=s;u=d;return j|0}default:{j=0;u=d;return j|0}}return 0}function Mpb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n}else fob(d,e);if((c|0)<0){gob(d,c,((c|0)<0)<<31>>31);return}if((f[a>>2]|0)<=4){fob(d,c);return}e=d+4|0;d=f[e>>2]|0;if(c>>>0>127){n=c;g=d;while(1){b[g>>0]=n|128;h=n>>>7;m=g+1|0;if(n>>>0>16383){n=h;g=m}else{o=m;p=h;break}}}else{o=d;p=c}b[o>>0]=p;p=o+1-d|0;f[e>>2]=(f[e>>2]|0)+p;f[a>>2]=(f[a>>2]|0)-p;return}function Npb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=a<<3;a=e+8|0;if((f[a>>2]|0)<=4){fob(e,g);gob(e,c,d);return}h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[a>>2]=(f[a>>2]|0)-o;gob(e,c,d);return}function Opb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[a>>2]|0)-n|0;f[a>>2]=g;o=g}else{fob(d,e);o=f[a>>2]|0}if((o|0)<=4){fob(d,c);return}o=d+4|0;d=f[o>>2]|0;if(c>>>0>127){e=c;g=d;while(1){b[g>>0]=e|128;n=e>>>7;h=g+1|0;if(e>>>0>16383){e=n;g=h}else{p=h;q=n;break}}}else{p=d;q=c}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q;return}function Ppb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=a<<3;a=e+8|0;if((f[a>>2]|0)<=4){fob(e,g);gob(e,c,d);return}h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[a>>2]=(f[a>>2]|0)-o;gob(e,c,d);return}function Qpb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[a>>2]|0)-n|0;f[a>>2]=g;o=g}else{fob(d,e);o=f[a>>2]|0}e=c<<1^c>>31;if((o|0)<=4){fob(d,e);return}o=d+4|0;d=f[o>>2]|0;if(e>>>0>127){c=e;g=d;while(1){b[g>>0]=c|128;n=c>>>7;h=g+1|0;if(c>>>0>16383){c=n;g=h}else{p=h;q=n;break}}}else{p=d;q=e}b[p>>0]=q;q=p+1-d|0;f[o>>2]=(f[o>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q;return}function Rpb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=a<<3;a=e+8|0;if((f[a>>2]|0)>4){h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[a>>2]=(f[a>>2]|0)-o}else fob(e,g);g=$ac(c|0,d|0,1)|0;o=J;a=Rac(c|0,d|0,63)|0;gob(e,g^a,o^J);return}function Spb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a<<3|5;a=d+8|0;if((f[a>>2]|0)<=4){fob(d,e);dob(d,c);return}g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n;dob(d,c);return}function Tpb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=a<<3|1;a=e+8|0;if((f[a>>2]|0)<=4){fob(e,g);eob(e,c,d);return}h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[a>>2]=(f[a>>2]|0)-o;eob(e,c,d);return}function Upb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a<<3|5;a=d+8|0;if((f[a>>2]|0)<=4){fob(d,e);dob(d,c);return}g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n;dob(d,c);return}function Vpb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=a<<3|1;a=e+8|0;if((f[a>>2]|0)<=4){fob(e,g);eob(e,c,d);return}h=e+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[a>>2]=(f[a>>2]|0)-o;eob(e,c,d);return}function Wpb(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0;e=a<<3|5;a=d+8|0;if((f[a>>2]|0)<=4){fob(d,e);g=(n[s>>2]=c,f[s>>2]|0);dob(d,g);return}h=d+4|0;i=f[h>>2]|0;if(e>>>0>127){j=e;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{o=m;p=l;break}}}else{o=i;p=e}b[o>>0]=p;p=o+1-i|0;f[h>>2]=(f[h>>2]|0)+p;f[a>>2]=(f[a>>2]|0)-p;g=(n[s>>2]=c,f[s>>2]|0);dob(d,g);return}function Xpb(a,c,d){a=a|0;c=+c;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=a<<3|1;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n}else fob(d,e);p[s>>3]=c;eob(d,f[s>>2]|0,f[s+4>>2]|0);return}function Ypb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;g=(f[a>>2]|0)-n|0;f[a>>2]=g;o=g}else{fob(d,e);o=f[a>>2]|0}if((o|0)>4){o=d+4|0;b[f[o>>2]>>0]=c&1;f[o>>2]=(f[o>>2]|0)+1;f[a>>2]=(f[a>>2]|0)+-1;return}else{fob(d,c&1);return}}function Zpb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=a<<3;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n}else fob(d,e);if((c|0)<0){gob(d,c,((c|0)<0)<<31>>31);return}if((f[a>>2]|0)<=4){fob(d,c);return}e=d+4|0;d=f[e>>2]|0;if(c>>>0>127){n=c;g=d;while(1){b[g>>0]=n|128;h=n>>>7;m=g+1|0;if(n>>>0>16383){n=h;g=m}else{o=m;p=h;break}}}else{o=d;p=c}b[o>>0]=p;p=o+1-d|0;f[e>>2]=(f[e>>2]|0)+p;f[a>>2]=(f[a>>2]|0)-p;return}function _pb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){j=d+4|0;k=f[j>>2]|0;if(i>>>0>127){l=i;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=i}b[p>>0]=q;q=p+1-k|0;f[j>>2]=(f[j>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q}else fob(d,i);i=c+11|0;q=b[i>>0]|0;do if(q<<24>>24<0){j=c+4|0;if((f[j>>2]|0)<=-1?(zpb(g,3,450309,415),xpb(h,vpb(g,450407)|0),Apb(g),k=b[i>>0]|0,k<<24>>24>=0):0){r=k;s=10;break}t=f[j>>2]|0}else{r=q;s=10}while(0);if((s|0)==10)t=r&255;if((f[a>>2]|0)<=4){fob(d,t);v=b[i>>0]|0;w=v<<24>>24<0;x=f[c>>2]|0;y=w?x:c;z=c+4|0;A=f[z>>2]|0;B=v&255;C=w?A:B;bob(d,y,C);u=e;return}r=d+4|0;s=f[r>>2]|0;if(t>>>0>127){q=t;g=s;while(1){b[g>>0]=q|128;h=q>>>7;j=g+1|0;if(q>>>0>16383){q=h;g=j}else{D=j;E=h;break}}}else{D=s;E=t}b[D>>0]=E;E=D+1-s|0;f[r>>2]=(f[r>>2]|0)+E;f[a>>2]=(f[a>>2]|0)-E;v=b[i>>0]|0;w=v<<24>>24<0;x=f[c>>2]|0;y=w?x:c;z=c+4|0;A=f[z>>2]|0;B=v&255;C=w?A:B;bob(d,y,C);u=e;return}function $pb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){j=d+4|0;k=f[j>>2]|0;if(i>>>0>127){l=i;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=i}b[p>>0]=q;q=p+1-k|0;f[j>>2]=(f[j>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q}else fob(d,i);i=c+11|0;q=b[i>>0]|0;do if(q<<24>>24<0){j=c+4|0;if((f[j>>2]|0)<=-1?(zpb(g,3,450309,424),xpb(h,vpb(g,450407)|0),Apb(g),k=b[i>>0]|0,k<<24>>24>=0):0){r=k;s=10;break}t=f[j>>2]|0}else{r=q;s=10}while(0);if((s|0)==10)t=r&255;if((f[a>>2]|0)>4){r=d+4|0;s=f[r>>2]|0;if(t>>>0>127){q=t;g=s;while(1){b[g>>0]=q|128;h=q>>>7;j=g+1|0;if(q>>>0>16383){q=h;g=j}else{v=j;w=h;break}}}else{v=s;w=t}b[v>>0]=w;w=v+1-s|0;f[r>>2]=(f[r>>2]|0)+w;f[a>>2]=(f[a>>2]|0)-w}else fob(d,t);t=b[i>>0]|0;i=t<<24>>24<0;w=i?f[c>>2]|0:c;a=i?f[c+4>>2]|0:t&255;if(!(b[d+17>>0]|0)){bob(d,w,a);u=e;return}else{cob(d,w,a);u=e;return}}function aqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){j=d+4|0;k=f[j>>2]|0;if(i>>>0>127){l=i;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=i}b[p>>0]=q;q=p+1-k|0;f[j>>2]=(f[j>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q}else fob(d,i);i=c+11|0;q=b[i>>0]|0;do if(q<<24>>24<0){j=c+4|0;if((f[j>>2]|0)<=-1?(zpb(g,3,450309,431),xpb(h,vpb(g,450407)|0),Apb(g),k=b[i>>0]|0,k<<24>>24>=0):0){r=k;s=10;break}t=f[j>>2]|0}else{r=q;s=10}while(0);if((s|0)==10)t=r&255;if((f[a>>2]|0)<=4){fob(d,t);v=b[i>>0]|0;w=v<<24>>24<0;x=f[c>>2]|0;y=w?x:c;z=c+4|0;A=f[z>>2]|0;B=v&255;C=w?A:B;bob(d,y,C);u=e;return}r=d+4|0;s=f[r>>2]|0;if(t>>>0>127){q=t;g=s;while(1){b[g>>0]=q|128;h=q>>>7;j=g+1|0;if(q>>>0>16383){q=h;g=j}else{D=j;E=h;break}}}else{D=s;E=t}b[D>>0]=E;E=D+1-s|0;f[r>>2]=(f[r>>2]|0)+E;f[a>>2]=(f[a>>2]|0)-E;v=b[i>>0]|0;w=v<<24>>24<0;x=f[c>>2]|0;y=w?x:c;z=c+4|0;A=f[z>>2]|0;B=v&255;C=w?A:B;bob(d,y,C);u=e;return}function bqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){j=d+4|0;k=f[j>>2]|0;if(i>>>0>127){l=i;m=k;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=k;q=i}b[p>>0]=q;q=p+1-k|0;f[j>>2]=(f[j>>2]|0)+q;f[a>>2]=(f[a>>2]|0)-q}else fob(d,i);i=c+11|0;q=b[i>>0]|0;do if(q<<24>>24<0){j=c+4|0;if((f[j>>2]|0)<=-1?(zpb(g,3,450309,439),xpb(h,vpb(g,450407)|0),Apb(g),k=b[i>>0]|0,k<<24>>24>=0):0){r=k;s=10;break}t=f[j>>2]|0}else{r=q;s=10}while(0);if((s|0)==10)t=r&255;if((f[a>>2]|0)>4){r=d+4|0;s=f[r>>2]|0;if(t>>>0>127){q=t;g=s;while(1){b[g>>0]=q|128;h=q>>>7;j=g+1|0;if(q>>>0>16383){q=h;g=j}else{v=j;w=h;break}}}else{v=s;w=t}b[v>>0]=w;w=v+1-s|0;f[r>>2]=(f[r>>2]|0)+w;f[a>>2]=(f[a>>2]|0)-w}else fob(d,t);t=b[i>>0]|0;i=t<<24>>24<0;w=i?f[c>>2]|0:c;a=i?f[c+4>>2]|0:t&255;if(!(b[d+17>>0]|0)){bob(d,w,a);u=e;return}else{cob(d,w,a);u=e;return}}function cqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=a<<3;a=e|3;g=d+8|0;if((f[g>>2]|0)>4){h=d+4|0;i=f[h>>2]|0;if(a>>>0>127){j=a;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=a}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[g>>2]=(f[g>>2]|0)-o}else fob(d,a);zh[f[(f[c>>2]|0)+56>>2]&2047](c,d);c=e|4;if((f[g>>2]|0)<=4){fob(d,c);return}e=d+4|0;d=f[e>>2]|0;if(c>>>0>127){a=c;o=d;while(1){b[o>>0]=a|128;h=a>>>7;i=o+1|0;if(a>>>0>16383){a=h;o=i}else{p=i;q=h;break}}}else{p=d;q=c}b[p>>0]=q;q=p+1-d|0;f[e>>2]=(f[e>>2]|0)+q;f[g>>2]=(f[g>>2]|0)-q;return}function dqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n}else fob(d,e);e=di[f[(f[c>>2]|0)+64>>2]&1023](c)|0;if((f[a>>2]|0)<=4){fob(d,e);o=f[c>>2]|0;p=o+56|0;q=f[p>>2]|0;zh[q&2047](c,d);return}n=d+4|0;g=f[n>>2]|0;if(e>>>0>127){h=e;m=g;while(1){b[m>>0]=h|128;j=h>>>7;i=m+1|0;if(h>>>0>16383){h=j;m=i}else{r=i;s=j;break}}}else{r=g;s=e}b[r>>0]=s;s=r+1-g|0;f[n>>2]=(f[n>>2]|0)+s;f[a>>2]=(f[a>>2]|0)-s;o=f[c>>2]|0;p=o+56|0;q=f[p>>2]|0;zh[q&2047](c,d);return}function eqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a<<3|2;a=d+8|0;if((f[a>>2]|0)>4){g=d+4|0;h=f[g>>2]|0;if(e>>>0>127){i=e;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=e}b[m>>0]=n;n=m+1-h|0;f[g>>2]=(f[g>>2]|0)+n;f[a>>2]=(f[a>>2]|0)-n}else fob(d,e);e=di[f[(f[c>>2]|0)+64>>2]&1023](c)|0;if((f[a>>2]|0)>4){n=d+4|0;g=f[n>>2]|0;if(e>>>0>127){h=e;m=g;while(1){b[m>>0]=h|128;j=h>>>7;i=m+1|0;if(h>>>0>16383){h=j;m=i}else{o=i;p=j;break}}}else{o=g;p=e}b[o>>0]=p;p=o+1-g|0;f[n>>2]=(f[n>>2]|0)+p;g=(f[a>>2]|0)-p|0;f[a>>2]=g;q=n;r=g}else{fob(d,e);q=d+4|0;r=f[a>>2]|0}if((r|0)>=(e|0)?(g=f[q>>2]|0,f[q>>2]=g+e,f[a>>2]=r-e,g|0):0){li[f[(f[c>>2]|0)+68>>2]&511](c,(b[(b[d+18>>0]|0?d+19|0:1122455)>>0]|0)!=0,g)|0;return}zh[f[(f[c>>2]|0)+56>>2]&2047](c,d);return}function fqb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(d>>>0<g>>>0){g=b[d>>0]|0;i=g&255;if(g<<24>>24>-1){g=d+1|0;f[a>>2]=g;j=i;k=g;l=h}else{m=i;n=4}}else{m=0;n=4}do if((n|0)==4){i=Knb(a,m)|0;if((J|0)<0|(i|0)<0){o=0;return o|0}else{j=i;k=f[a>>2]|0;l=f[e>>2]|0;break}}while(0);if((l-k|0)<(j|0)){o=Wnb(a,c,j)|0;return o|0}e6b(c,j,0);k=b[c+11>>0]|0;l=k<<24>>24<0;if(l)p=f[c+4>>2]|0;else p=k&255;if(!p){o=1;return o|0}if(l)q=f[c>>2]|0;else q=c;if(!q){o=1;return o|0}Vac(q|0,f[a>>2]|0,j|0)|0;f[a>>2]=(f[a>>2]|0)+j;o=1;return o|0}function gqb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+64|0;h=g;i=g+44|0;j=g+32|0;k=g+8|0;l=g+56|0;if(jSb(a,c)|0){m=1;u=g;return m|0}c=(d|0)==0?450465:(d|0)==1?450453:0;d=i+11|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(e|0?(f[h>>2]=e,gSb(j,450473,h),_5b(i,j)|0,(b[j+11>>0]|0)<0):0)O5b(f[j>>2]|0);zpb(k,2,450309,534);xpb(l,vpb(vpb(vpb(vpb(vpb(vpb(wpb(vpb(k,450479)|0,i)|0,450492)|0,450511)|0,c)|0,450528)|0,450541)|0,450597)|0);Apb(k);if((b[d>>0]|0)<0)O5b(f[i>>2]|0);m=0;u=g;return m|0}function hqb(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+32|0;c=b;switch(a|0){case 2:{d=450851;break}case 3:{d=450844;break}case 0:{d=450836;break}default:{zpb(c,3,450744,154);xpb(b+24|0,vpb(c,478311)|0);Apb(c);d=0}}u=b;return d|0}function iqb(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;n[a+28>>2]=1.0;b=a+32|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+48>>2]=1.0;b=a+52|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+68>>2]=1.0;b=a+120|0;c=a+136|0;d=a+72|0;e=d+64|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));n[c>>2]=1.0;jqb(b,3);b=a+140|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+156>>2]=1.0;kqb(b,3);f[a+164>>2]=0;f[a+168>>2]=0;f[a+160>>2]=a+164;d=a+172|0;e=d+48|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));return}function jqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=yWb(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){mqb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=yWb(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;mqb(a,d);return}function kqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=yWb(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){lqb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=yWb(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;lqb(a,d);return}function lqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{e=L5b(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)O5b(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){b:do if(h){c=k;g=l;i=m;while(1){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if(!(gTb(f[o>>2]|0,f[u+8>>2]|0)|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[c>>2]|0;if(!o){v=35;break a}else d=o}g=f[d>>2]|0;if(!g){v=35;break a}else{c=d;i=d}}}else{i=k;c=l;g=m;while(1){o=c;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=g;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if(!(gTb(f[w>>2]|0,f[z+8>>2]|0)|0))y=z;else break}f[g>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=35;break a}else o=w}c=f[o>>2]|0;if(!c){v=35;break a}else{i=o;g=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=35;break}else{j=s;k=p;m=p}}if((v|0)==35)return}function mqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{e=L5b(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)O5b(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){b:do if(h){c=k;g=l;i=m;while(1){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if(!(gTb(f[o>>2]|0,f[u+8>>2]|0)|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[c>>2]|0;if(!o){v=35;break a}else d=o}g=f[d>>2]|0;if(!g){v=35;break a}else{c=d;i=d}}}else{i=k;c=l;g=m;while(1){o=c;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=g;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if(!(gTb(f[w>>2]|0,f[z+8>>2]|0)|0))y=z;else break}f[g>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=35;break a}else o=w}c=f[o>>2]|0;if(!c){v=35;break a}else{i=o;g=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=35;break}else{j=s;k=p;m=p}}if((v|0)==35)return}function nqb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+84|0;d=f[c>>2]|0;e=a+88|0;g=f[e>>2]|0;if((d|0)!=(g|0)){h=d;do{d=f[h>>2]|0;h=h+4|0;if(d|0)bi[f[(f[d>>2]|0)+4>>2]&2047](d)}while((h|0)!=(g|0));g=f[c>>2]|0;h=f[e>>2]|0;if((h|0)!=(g|0))f[e>>2]=h+(~((h+-4-g|0)>>>2)<<2)}g=a+108|0;h=a+112|0;d=f[g>>2]|0;if((f[h>>2]|0)!=(d|0)){i=0;j=d;do{O5b(f[j+(i<<2)>>2]|0);i=i+1|0;j=f[g>>2]|0}while(i>>>0<(f[h>>2]|0)-j>>2>>>0)}j=a+72|0;i=f[j>>2]|0;d=a+76|0;k=f[d>>2]|0;if((i|0)!=(k|0)){l=i;do{i=f[l>>2]|0;l=l+4|0;if(i|0){if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);O5b(i)}}while((l|0)!=(k|0));k=f[j>>2]|0;l=f[d>>2]|0;if((l|0)!=(k|0))f[d>>2]=l+(~((l+-4-k|0)>>>2)<<2)}k=a+96|0;l=f[k>>2]|0;i=a+100|0;m=f[i>>2]|0;if((l|0)!=(m|0)){n=l;do{l=f[n>>2]|0;n=n+4|0;if(l|0){oqb(l);O5b(l)}}while((n|0)!=(m|0));m=f[k>>2]|0;n=f[i>>2]|0;if((n|0)!=(m|0))f[i>>2]=n+(~((n+-4-m|0)>>>2)<<2)}m=f[a+208>>2]|0;if(m|0){n=a+212|0;l=f[n>>2]|0;if((l|0)!=(m|0))f[n>>2]=l+(~((l+-8-m|0)>>>3)<<3);O5b(m)}m=f[a+196>>2]|0;if(m|0){l=a+200|0;n=f[l>>2]|0;if((n|0)!=(m|0))f[l>>2]=n+(~((n+-4-m|0)>>>2)<<2);O5b(m)}m=f[a+184>>2]|0;if(m|0){n=a+188|0;l=f[n>>2]|0;if((l|0)!=(m|0))f[n>>2]=l+(~((l+-4-m|0)>>>2)<<2);O5b(m)}m=f[a+172>>2]|0;if(m|0){l=a+176|0;n=f[l>>2]|0;if((n|0)!=(m|0))f[l>>2]=n+(~(((n+-28-m|0)>>>0)/28|0)*28|0);O5b(m)}pqb(a+160|0,f[a+164>>2]|0);m=f[a+148>>2]|0;if(m|0){n=m;do{m=n;n=f[n>>2]|0;O5b(m)}while((n|0)!=0)}n=a+140|0;m=f[n>>2]|0;f[n>>2]=0;if(m|0)O5b(m);m=f[a+128>>2]|0;if(m|0){n=m;do{m=n;n=f[n>>2]|0;O5b(m)}while((n|0)!=0)}n=a+120|0;m=f[n>>2]|0;f[n>>2]=0;if(m|0)O5b(m);m=f[g>>2]|0;if(m|0){g=f[h>>2]|0;if((g|0)!=(m|0))f[h>>2]=g+(~((g+-4-m|0)>>>2)<<2);O5b(m)}m=f[k>>2]|0;if(m|0){k=f[i>>2]|0;if((k|0)!=(m|0))f[i>>2]=k+(~((k+-4-m|0)>>>2)<<2);O5b(m)}m=f[c>>2]|0;if(m|0){c=f[e>>2]|0;if((c|0)!=(m|0))f[e>>2]=c+(~((c+-4-m|0)>>>2)<<2);O5b(m)}m=f[j>>2]|0;if(m|0){j=f[d>>2]|0;if((j|0)!=(m|0))f[d>>2]=j+(~((j+-4-m|0)>>>2)<<2);O5b(m)}m=f[a+60>>2]|0;if(m|0){j=m;do{m=j;j=f[j>>2]|0;O5b(m)}while((j|0)!=0)}j=a+52|0;m=f[j>>2]|0;f[j>>2]=0;if(m|0)O5b(m);m=f[a+40>>2]|0;if(m|0){j=m;do{m=j;j=f[j>>2]|0;d=m+8|0;if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(m)}while((j|0)!=0)}j=a+32|0;m=f[j>>2]|0;f[j>>2]=0;if(m|0)O5b(m);m=f[a+20>>2]|0;if(m|0){j=m;do{m=j;j=f[j>>2]|0;d=m+8|0;if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(m)}while((j|0)!=0)}j=a+12|0;m=f[j>>2]|0;f[j>>2]=0;if(m|0)O5b(m);m=f[a>>2]|0;if(!m)return;j=a+4|0;d=f[j>>2]|0;if((d|0)==(m|0))o=m;else{c=d;while(1){d=c+-12|0;f[j>>2]=d;if((b[d+11>>0]|0)<0){O5b(f[d>>2]|0);p=f[j>>2]|0}else p=d;if((p|0)==(m|0))break;else c=p}o=f[a>>2]|0}O5b(o);return}function oqb(a){a=a|0;var c=0,d=0,e=0;Cpb(a+144|0);c=f[a+132>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;e=c+8|0;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);O5b(c)}while((d|0)!=0)}d=a+124|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)O5b(c);c=f[a+108>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;O5b(c)}while((d|0)!=0)}d=a+100|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)O5b(c);c=f[a+88>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;O5b(c)}while((d|0)!=0)}d=a+80|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)O5b(c);c=f[a+68>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;O5b(c)}while((d|0)!=0)}d=a+60|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)O5b(c);c=f[a+48>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;O5b(c)}while((d|0)!=0)}d=a+40|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)O5b(c);c=f[a+28>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;O5b(c)}while((d|0)!=0)}d=a+20|0;c=f[d>>2]|0;f[d>>2]=0;if(c|0)O5b(c);c=f[a+8>>2]|0;if(c|0){d=c;do{c=d;d=f[d>>2]|0;O5b(c)}while((d|0)!=0)}d=f[a>>2]|0;f[a>>2]=0;if(!d)return;O5b(d);return}function pqb(a,b){a=a|0;b=b|0;if(!b)return;else{pqb(a,f[b>>2]|0);pqb(a,f[b+4>>2]|0);O5b(b);return}}function qqb(a){a=a|0;var b=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;n[a+16>>2]=1.0;rqb(a,3);b=a+20|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+36>>2]=1.0;sqb(b,3);b=a+40|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+56>>2]=1.0;sqb(b,3);b=a+60|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+76>>2]=1.0;tqb(b,3);b=a+80|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+96>>2]=1.0;uqb(b,3);b=a+100|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+116>>2]=1.0;uqb(b,3);b=a+120|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;n[a+140>>2]=1.0;Bpb(a+144|0);return}function rqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=yWb(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){yqb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=yWb(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;yqb(a,d);return}function sqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=yWb(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){xqb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=yWb(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;xqb(a,d);return}function tqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=yWb(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){wqb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=yWb(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;wqb(a,d);return}function uqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=yWb(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){vqb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=yWb(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;vqb(a,d);return}function vqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{e=L5b(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)O5b(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){c=k;g=l;i=m;b:while(1){c:do if(h){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(n<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=n;break b}p=d+12|0;t=f[d>>2]|0;d:do if(!t)u=d;else{v=f[d+8>>2]|0;w=d;x=t;while(1){if((v|0)!=(f[x+8>>2]|0)){u=w;break d}if((f[p>>2]|0)!=(f[x+12>>2]|0)){u=w;break d}y=f[x>>2]|0;if(!y){u=x;break}else{z=x;x=y;w=z}}}while(0);f[i>>2]=f[u>>2];f[u>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}else{d=g;while(1){p=f[d+4>>2]|0;if(p>>>0<b>>>0)B=p;else B=(p>>>0)%(b>>>0)|0;if((B|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(B<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=B;break b}p=d+12|0;t=f[d>>2]|0;e:do if(!t)C=d;else{w=f[d+8>>2]|0;x=d;v=t;while(1){if((w|0)!=(f[v+8>>2]|0)){C=x;break e}if((f[p>>2]|0)!=(f[v+12>>2]|0)){C=x;break e}z=f[v>>2]|0;if(!z){C=v;break}else{y=v;v=z;x=y}}}while(0);f[i>>2]=f[C>>2];f[C>>2]=f[f[(f[a>>2]|0)+(B<<2)>>2]>>2];f[f[(f[a>>2]|0)+(B<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}while(0);g=f[o>>2]|0;if(!g){A=37;break a}else{c=o;i=o}}f[r>>2]=i;l=f[q>>2]|0;if(!l){A=37;break}else{j=s;k=q;m=q}}if((A|0)==37)return}function wqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{e=L5b(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)O5b(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){c=k;g=l;i=m;b:while(1){c:do if(h){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(n<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=n;break b}p=d+12|0;t=f[d>>2]|0;d:do if(!t)u=d;else{v=f[d+8>>2]|0;w=d;x=t;while(1){if((v|0)!=(f[x+8>>2]|0)){u=w;break d}if((f[p>>2]|0)!=(f[x+12>>2]|0)){u=w;break d}y=f[x>>2]|0;if(!y){u=x;break}else{z=x;x=y;w=z}}}while(0);f[i>>2]=f[u>>2];f[u>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}else{d=g;while(1){p=f[d+4>>2]|0;if(p>>>0<b>>>0)B=p;else B=(p>>>0)%(b>>>0)|0;if((B|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(B<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=B;break b}p=d+12|0;t=f[d>>2]|0;e:do if(!t)C=d;else{w=f[d+8>>2]|0;x=d;v=t;while(1){if((w|0)!=(f[v+8>>2]|0)){C=x;break e}if((f[p>>2]|0)!=(f[v+12>>2]|0)){C=x;break e}z=f[v>>2]|0;if(!z){C=v;break}else{y=v;v=z;x=y}}}while(0);f[i>>2]=f[C>>2];f[C>>2]=f[f[(f[a>>2]|0)+(B<<2)>>2]>>2];f[f[(f[a>>2]|0)+(B<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}while(0);g=f[o>>2]|0;if(!g){A=37;break a}else{c=o;i=o}}f[r>>2]=i;l=f[q>>2]|0;if(!l){A=37;break}else{j=s;k=q;m=q}}if((A|0)==37)return}function xqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{e=L5b(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)O5b(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){c=k;g=l;i=m;b:while(1){c:do if(h){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(n<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=n;break b}p=f[d>>2]|0;d:do if(!p)t=d;else{u=f[d+8>>2]|0;v=d+12|0;w=d;x=p;while(1){if((u|0)!=(f[x+8>>2]|0)){t=w;break d}if(gTb(f[v>>2]|0,f[x+12>>2]|0)|0){t=w;break d}y=f[x>>2]|0;if(!y){t=x;break}else{z=x;x=y;w=z}}}while(0);f[i>>2]=f[t>>2];f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}else{d=g;while(1){p=f[d+4>>2]|0;if(p>>>0<b>>>0)B=p;else B=(p>>>0)%(b>>>0)|0;if((B|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(B<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=B;break b}p=f[d>>2]|0;e:do if(!p)C=d;else{w=f[d+8>>2]|0;x=d+12|0;v=d;u=p;while(1){if((w|0)!=(f[u+8>>2]|0)){C=v;break e}if(gTb(f[x>>2]|0,f[u+12>>2]|0)|0){C=v;break e}z=f[u>>2]|0;if(!z){C=u;break}else{y=u;u=z;v=y}}}while(0);f[i>>2]=f[C>>2];f[C>>2]=f[f[(f[a>>2]|0)+(B<<2)>>2]>>2];f[f[(f[a>>2]|0)+(B<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}while(0);g=f[o>>2]|0;if(!g){A=37;break a}else{c=o;i=o}}f[r>>2]=i;l=f[q>>2]|0;if(!l){A=37;break}else{j=s;k=q;m=q}}if((A|0)==37)return}function yqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{e=L5b(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)O5b(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){c=k;g=l;i=m;b:while(1){c:do if(h){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(n<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=n;break b}p=f[d>>2]|0;d:do if(!p)t=d;else{u=f[d+8>>2]|0;v=d+12|0;w=d;x=p;while(1){if((u|0)!=(f[x+8>>2]|0)){t=w;break d}if(gTb(f[v>>2]|0,f[x+12>>2]|0)|0){t=w;break d}y=f[x>>2]|0;if(!y){t=x;break}else{z=x;x=y;w=z}}}while(0);f[i>>2]=f[t>>2];f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}else{d=g;while(1){p=f[d+4>>2]|0;if(p>>>0<b>>>0)B=p;else B=(p>>>0)%(b>>>0)|0;if((B|0)==(j|0)){o=d;break c}p=(f[a>>2]|0)+(B<<2)|0;if(!(f[p>>2]|0)){q=d;r=p;s=B;break b}p=f[d>>2]|0;e:do if(!p)C=d;else{w=f[d+8>>2]|0;x=d+12|0;v=d;u=p;while(1){if((w|0)!=(f[u+8>>2]|0)){C=v;break e}if(gTb(f[x>>2]|0,f[u+12>>2]|0)|0){C=v;break e}z=f[u>>2]|0;if(!z){C=u;break}else{y=u;u=z;v=y}}}while(0);f[i>>2]=f[C>>2];f[C>>2]=f[f[(f[a>>2]|0)+(B<<2)>>2]>>2];f[f[(f[a>>2]|0)+(B<<2)>>2]>>2]=d;d=f[c>>2]|0;if(!d){A=37;break a}}}while(0);g=f[o>>2]|0;if(!g){A=37;break a}else{c=o;i=o}}f[r>>2]=i;l=f[q>>2]|0;if(!l){A=37;break}else{j=s;k=q;m=q}}if((A|0)==37)return}function zqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/28|0;h=g+1|0;if(h>>>0>153391689)c4b(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/28|0;k=j<<1;l=j>>>0<76695844?(k>>>0<h>>>0?h:k):153391689;do if(l)if(l>>>0>153391689){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l*28|0)|0;break}else m=0;while(0);k=m+(g*28|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];f[k+16>>2]=f[b+16>>2];f[k+20>>2]=f[b+20>>2];f[k+24>>2]=f[b+24>>2];b=k+(((e|0)/-28|0)*28|0)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+28;f[i>>2]=m+(l*28|0);if(!d)return;O5b(d);return}function Aqb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;c=u;u=u+32|0;d=c+16|0;e=c+4|0;g=c;h=a+176|0;i=f[h>>2]|0;j=i+-12|0;k=f[j>>2]|0;l=a+184|0;m=a+188|0;n=f[m>>2]|0;o=f[l>>2]|0;if(k>>>0<n-o>>2>>>0){p=a+124|0;q=a+120|0;r=a+128|0;s=a+132|0;t=k;k=o;o=n;while(1){n=f[k+(t<<2)>>2]|0;v=b[n>>0]|0;if(!(v<<24>>24))w=0;else{x=n;y=0;z=v;while(1){v=(y*5|0)+(z<<24>>24)|0;x=x+1|0;z=b[x>>0]|0;if(!(z<<24>>24)){w=v;break}else y=v}}y=f[p>>2]|0;a:do if(y){z=y+-1|0;x=(z&y|0)==0;if(!x)if(w>>>0<y>>>0)A=w;else A=(w>>>0)%(y>>>0)|0;else A=z&w;v=f[q>>2]|0;B=f[v+(A<<2)>>2]|0;if((B|0)!=0?(C=f[B>>2]|0,(C|0)!=0):0){b:do if(x){B=C;while(1){D=f[B+4>>2]|0;E=(D|0)==(w|0);if(!(E|(D&z|0)==(A|0))){F=k;G=o;break a}if(E?(gTb(f[B+8>>2]|0,n)|0)==0:0){H=B;break b}B=f[B>>2]|0;if(!B){F=k;G=o;break a}}}else{B=C;while(1){E=f[B+4>>2]|0;if((E|0)==(w|0)){if(!(gTb(f[B+8>>2]|0,n)|0)){H=B;break b}}else{if(E>>>0<y>>>0)I=E;else I=(E>>>0)%(y>>>0)|0;if((I|0)!=(A|0)){F=k;G=o;break a}}B=f[B>>2]|0;if(!B){F=k;G=o;break a}}}while(0);if(!x)if(w>>>0<y>>>0)J=w;else J=(w>>>0)%(y>>>0)|0;else J=z&w;C=v+(J<<2)|0;B=f[C>>2]|0;while(1){E=f[B>>2]|0;if((E|0)==(H|0))break;else B=E}if((B|0)!=(r|0)){v=f[B+4>>2]|0;if(!x)if(v>>>0<y>>>0)K=v;else K=(v>>>0)%(y>>>0)|0;else K=v&z;if((K|0)==(J|0))L=H;else M=38}else M=38;do if((M|0)==38){M=0;v=f[H>>2]|0;if(v|0){E=f[v+4>>2]|0;if(!x)if(E>>>0<y>>>0)N=E;else N=(E>>>0)%(y>>>0)|0;else N=E&z;if((N|0)==(J|0)){L=H;break}}f[C>>2]=0;L=H}while(0);C=f[L>>2]|0;E=C;if(C){v=f[C+4>>2]|0;if(!x)if(v>>>0<y>>>0)O=v;else O=(v>>>0)%(y>>>0)|0;else O=v&z;if((O|0)!=(J|0)){f[(f[q>>2]|0)+(O<<2)>>2]=B;P=f[H>>2]|0}else P=E}else P=E;f[B>>2]=P;f[L>>2]=0;f[s>>2]=(f[s>>2]|0)+-1;O5b(H);F=f[l>>2]|0;G=f[m>>2]|0}else{F=k;G=o}}else{F=k;G=o}while(0);t=t+1|0;if(t>>>0>=G-F>>2>>>0)break;else{k=F;o=G}}}G=i+-8|0;o=f[G>>2]|0;F=a+196|0;k=a+200|0;t=f[F>>2]|0;if(o>>>0<(f[k>>2]|0)-t>>2>>>0){H=a+140|0;s=o;o=t;do{t=Bqb(H,o+(s<<2)|0)|0;if(t|0?(f[g>>2]=t,f[d>>2]=f[g>>2],Cqb(e,H,d),t=f[e>>2]|0,f[e>>2]=0,t|0):0)O5b(t);s=s+1|0;o=f[F>>2]|0}while(s>>>0<(f[k>>2]|0)-o>>2>>>0)}o=i+-4|0;s=f[o>>2]|0;e=a+208|0;d=a+212|0;H=f[e>>2]|0;if(s>>>0<(f[d>>2]|0)-H>>3>>>0){g=a+160|0;t=s;s=H;do{Fqb(g,s+(t<<3)|0)|0;t=t+1|0;s=f[e>>2]|0}while(t>>>0<(f[d>>2]|0)-s>>3>>>0)}s=f[j>>2]|0;j=f[m>>2]|0;t=f[l>>2]|0;g=j-t>>2;H=t;t=j;if(s>>>0<=g>>>0){if(s>>>0<g>>>0?(j=H+(s<<2)|0,(t|0)!=(j|0)):0)f[m>>2]=t+(~((t+-4-j|0)>>>2)<<2)}else Dqb(l,s-g|0);g=f[G>>2]|0;G=f[k>>2]|0;s=f[F>>2]|0;l=G-s>>2;j=s;s=G;if(g>>>0<=l>>>0){if(g>>>0<l>>>0?(G=j+(g<<2)|0,(s|0)!=(G|0)):0)f[k>>2]=s+(~((s+-4-G|0)>>>2)<<2)}else Dqb(F,g-l|0);l=f[o>>2]|0;o=f[d>>2]|0;g=f[e>>2]|0;F=o-g>>3;G=g;g=o;if(l>>>0<=F>>>0){if(l>>>0<F>>>0?(o=G+(l<<3)|0,(g|0)!=(o|0)):0)f[d>>2]=g+(~((g+-8-o|0)>>>3)<<3)}else Eqb(e,l-F|0);F=a+72|0;l=i+-28|0;e=(f[F>>2]|0)+(f[l>>2]<<2)|0;o=a+76|0;g=f[o>>2]|0;if((e|0)!=(g|0)){d=e;do{e=f[d>>2]|0;d=d+4|0;if(e|0){if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);O5b(e)}}while((d|0)!=(g|0))}g=a+84|0;d=i+-24|0;e=(f[g>>2]|0)+(f[d>>2]<<2)|0;G=a+88|0;s=f[G>>2]|0;if((e|0)!=(s|0)){k=e;do{e=f[k>>2]|0;k=k+4|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e)}while((k|0)!=(s|0))}s=a+96|0;k=i+-20|0;e=(f[s>>2]|0)+(f[k>>2]<<2)|0;j=a+100|0;t=f[j>>2]|0;if((e|0)!=(t|0)){m=e;do{e=f[m>>2]|0;m=m+4|0;if(e|0){oqb(e);O5b(e)}}while((m|0)!=(t|0))}t=i+-16|0;i=f[t>>2]|0;m=a+108|0;e=a+112|0;a=f[m>>2]|0;if(i>>>0<(f[e>>2]|0)-a>>2>>>0){H=i;i=a;do{O5b(f[i+(H<<2)>>2]|0);H=H+1|0;i=f[m>>2]|0}while(H>>>0<(f[e>>2]|0)-i>>2>>>0)}i=f[l>>2]|0;l=f[o>>2]|0;H=f[F>>2]|0;a=l-H>>2;L=H;H=l;if(i>>>0<=a>>>0){if(i>>>0<a>>>0?(l=L+(i<<2)|0,(H|0)!=(l|0)):0)f[o>>2]=H+(~((H+-4-l|0)>>>2)<<2)}else Gqb(F,i-a|0);a=f[d>>2]|0;d=f[G>>2]|0;i=f[g>>2]|0;F=d-i>>2;l=i;i=d;if(a>>>0<=F>>>0){if(a>>>0<F>>>0?(d=l+(a<<2)|0,(i|0)!=(d|0)):0)f[G>>2]=i+(~((i+-4-d|0)>>>2)<<2)}else Hqb(g,a-F|0);F=f[k>>2]|0;k=f[j>>2]|0;a=f[s>>2]|0;g=k-a>>2;d=a;a=k;if(F>>>0<=g>>>0){if(F>>>0<g>>>0?(k=d+(F<<2)|0,(a|0)!=(k|0)):0)f[j>>2]=a+(~((a+-4-k|0)>>>2)<<2)}else Iqb(s,F-g|0);g=f[t>>2]|0;t=f[e>>2]|0;F=f[m>>2]|0;s=t-F>>2;k=t;if(g>>>0>s>>>0){Jqb(m,g-s|0);Q=f[h>>2]|0;R=Q+-28|0;f[h>>2]=R;u=c;return}if(g>>>0>=s>>>0){Q=f[h>>2]|0;R=Q+-28|0;f[h>>2]=R;u=c;return}s=F+(g<<2)|0;if((k|0)==(s|0)){Q=f[h>>2]|0;R=Q+-28|0;f[h>>2]=R;u=c;return}f[e>>2]=k+(~((k+-4-s|0)>>>2)<<2);Q=f[h>>2]|0;R=Q+-28|0;f[h>>2]=R;u=c;return}function Bqb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;c=b[d>>0]|0;if(!(c<<24>>24))e=0;else{g=d;h=0;i=c;while(1){c=(h*5|0)+(i<<24>>24)|0;g=g+1|0;i=b[g>>0]|0;if(!(i<<24>>24)){e=c;break}else h=c}}h=f[a+4>>2]|0;if(!h){j=0;return j|0}i=h+-1|0;g=(i&h|0)==0;if(!g)if(e>>>0<h>>>0)k=e;else k=(e>>>0)%(h>>>0)|0;else k=i&e;c=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!c){j=0;return j|0}a=f[c>>2]|0;if(!a){j=0;return j|0}if(g){g=a;while(1){c=f[g+4>>2]|0;l=(c|0)==(e|0);if(!(l|(c&i|0)==(k|0))){j=0;m=22;break}if(l?(gTb(f[g+8>>2]|0,d)|0)==0:0){j=g;m=22;break}g=f[g>>2]|0;if(!g){j=0;m=22;break}}if((m|0)==22)return j|0}else n=a;while(1){a=f[n+4>>2]|0;g=(a|0)==(e|0);if(!g){if(a>>>0<h>>>0)o=a;else o=(a>>>0)%(h>>>0)|0;if((o|0)!=(k|0)){j=0;m=22;break}if(g)m=21}else m=21;if((m|0)==21?(m=0,(gTb(f[n+8>>2]|0,d)|0)==0):0){j=n;m=22;break}n=f[n>>2]|0;if(!n){j=0;m=22;break}}if((m|0)==22)return j|0;return 0}function Cqb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=f[c>>2]|0;c=f[b+4>>2]|0;e=f[d+4>>2]|0;g=c+-1|0;h=(g&c|0)==0;if(!h)if(e>>>0<c>>>0)i=e;else i=(e>>>0)%(c>>>0)|0;else i=g&e;e=(f[b>>2]|0)+(i<<2)|0;j=f[e>>2]|0;while(1){k=f[j>>2]|0;if((k|0)==(d|0))break;else j=k}k=b+8|0;if((j|0)!=(k|0)){l=f[j+4>>2]|0;if(!h)if(l>>>0<c>>>0)m=l;else m=(l>>>0)%(c>>>0)|0;else m=l&g;if((m|0)==(i|0))n=d;else o=14}else o=14;do if((o|0)==14){m=f[d>>2]|0;if(m|0){l=f[m+4>>2]|0;if(!h)if(l>>>0<c>>>0)p=l;else p=(l>>>0)%(c>>>0)|0;else p=l&g;if((p|0)==(i|0)){n=d;break}}f[e>>2]=0;n=d}while(0);e=f[n>>2]|0;p=e;if(e){o=f[e+4>>2]|0;if(!h)if(o>>>0<c>>>0)q=o;else q=(o>>>0)%(c>>>0)|0;else q=o&g;if((q|0)!=(i|0)){f[(f[b>>2]|0)+(q<<2)>>2]=j;r=f[d>>2]|0}else r=p}else r=p;f[j>>2]=r;f[n>>2]=0;n=b+12|0;f[n>>2]=(f[n>>2]|0)+-1;f[a>>2]=d;d=a+4|0;f[d>>2]=k;f[d+4>>2]=1;return}function Dqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)c4b(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)Vac(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;O5b(d);return}function Eqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){Nac(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)c4b(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;Nac(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)Vac(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;O5b(h);return}function Fqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[c>>2]|0;if(!d){e=0;return e|0}g=f[b>>2]|0;h=f[b+4>>2]|0;b=c;i=d;a:while(1){j=i;while(1){k=f[j+16>>2]|0;if(k>>>0>=g>>>0){if(g>>>0<k>>>0)break;if((f[j+20>>2]|0)>=(h|0))break}k=f[j+4>>2]|0;if(!k){l=b;break a}else j=k}i=f[j>>2]|0;if(!i){l=j;break}else b=j}if((l|0)==(c|0)){e=0;return e|0}c=f[l+16>>2]|0;if(g>>>0<c>>>0){e=0;return e|0}if(c>>>0>=g>>>0?(h|0)<(f[l+20>>2]|0):0){e=0;return e|0}h=f[l+4>>2]|0;if(!h){g=l+8|0;c=f[g>>2]|0;if((f[c>>2]|0)==(l|0))m=c;else{c=g;do{g=f[c>>2]|0;c=g+8|0;b=f[c>>2]|0}while((f[b>>2]|0)!=(g|0));m=b}}else{c=h;while(1){h=f[c>>2]|0;if(!h)break;else c=h}m=c}if((f[a>>2]|0)==(l|0))f[a>>2]=m;m=a+8|0;f[m>>2]=(f[m>>2]|0)+-1;wwa(d,l);O5b(l);e=1;return e|0}function Gqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)c4b(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)Vac(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;O5b(d);return}function Hqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)c4b(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)Vac(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;O5b(d);return}function Iqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)c4b(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)Vac(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;O5b(d);return}function Jqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)c4b(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)Vac(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;O5b(d);return}function Kqb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]|0;e=b[d>>0]|0;if(!(e<<24>>24))g=0;else{h=d;i=0;j=e;while(1){e=(i*5|0)+(j<<24>>24)|0;h=h+1|0;j=b[h>>0]|0;if(!(j<<24>>24)){g=e;break}else i=e}}i=a+4|0;j=f[i>>2]|0;h=(j|0)==0;a:do if(!h){e=j+-1|0;k=(e&j|0)==0;if(!k)if(g>>>0<j>>>0)l=g;else l=(g>>>0)%(j>>>0)|0;else l=e&g;m=f[(f[a>>2]|0)+(l<<2)>>2]|0;if(!m)o=l;else{if(k){k=m;while(1){k=f[k>>2]|0;if(!k){o=l;break a}p=f[k+4>>2]|0;if(!((p|0)==(g|0)|(p&e|0)==(l|0))){o=l;break a}if(!(gTb(f[k+8>>2]|0,d)|0)){q=0;break}}return q|0}else r=m;while(1){r=f[r>>2]|0;if(!r){o=l;break a}k=f[r+4>>2]|0;if((k|0)!=(g|0)){if(k>>>0<j>>>0)s=k;else s=(k>>>0)%(j>>>0)|0;if((s|0)!=(l|0)){o=l;break a}}if(!(gTb(f[r+8>>2]|0,d)|0)){q=0;break}}return q|0}}else o=0;while(0);d=L5b(16)|0;r=c;c=f[r+4>>2]|0;l=d+8|0;f[l>>2]=f[r>>2];f[l+4>>2]=c;f[d+4>>2]=g;f[d>>2]=0;c=a+12|0;t=+(((f[c>>2]|0)+1|0)>>>0);u=+n[a+16>>2];do if(h|t>+(j>>>0)*u){l=(j>>>0<3|(j+-1&j|0)!=0)&1|j<<1;r=~~+X(+(t/u))>>>0;kqb(a,l>>>0<r>>>0?r:l);l=f[i>>2]|0;r=l+-1|0;if(!(r&l)){v=l;w=r&g;break}if(g>>>0<l>>>0){v=l;w=g}else{v=l;w=(g>>>0)%(l>>>0)|0}}else{v=j;w=o}while(0);o=(f[a>>2]|0)+(w<<2)|0;w=f[o>>2]|0;if(!w){j=a+8|0;f[d>>2]=f[j>>2];f[j>>2]=d;f[o>>2]=j;j=f[d>>2]|0;if(j|0){o=f[j+4>>2]|0;j=v+-1|0;if(j&v)if(o>>>0<v>>>0)x=o;else x=(o>>>0)%(v>>>0)|0;else x=o&j;y=(f[a>>2]|0)+(x<<2)|0;z=32}}else{f[d>>2]=f[w>>2];y=w;z=32}if((z|0)==32)f[y>>2]=d;f[c>>2]=(f[c>>2]|0)+1;q=1;return q|0}function Lqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function Mqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0;e=f[c>>2]|0;g=f[c+4>>2]|0;c=f[d>>2]|0;d=e*65535|0;h=g;i=b[h>>0]|0;j=e;if(!(i<<24>>24))k=0;else{l=h;m=0;o=i;while(1){i=(m*5|0)+(o<<24>>24)|0;l=l+1|0;o=b[l>>0]|0;if(!(o<<24>>24)){k=i;break}else m=i}}m=k+d|0;d=a+4|0;k=f[d>>2]|0;o=(k|0)==0;a:do if(!o){l=k+-1|0;i=(l&k|0)==0;if(!i)if(m>>>0<k>>>0)p=m;else p=(m>>>0)%(k>>>0)|0;else p=l&m;q=f[(f[a>>2]|0)+(p<<2)>>2]|0;if((q|0)!=0?(r=f[q>>2]|0,(r|0)!=0):0){if(i){i=r;while(1){q=f[i+4>>2]|0;if(!((q|0)==(m|0)|(q&l|0)==(p|0))){s=p;break a}if((f[i+8>>2]|0)==(j|0)?(gTb(f[i+12>>2]|0,h)|0)==0:0)break;i=f[i>>2]|0;if(!i){s=p;break a}}return}else t=r;while(1){i=f[t+4>>2]|0;if((i|0)!=(m|0)){if(i>>>0<k>>>0)u=i;else u=(i>>>0)%(k>>>0)|0;if((u|0)!=(p|0)){s=p;break a}}if((f[t+8>>2]|0)==(j|0)?(gTb(f[t+12>>2]|0,h)|0)==0:0)break;t=f[t>>2]|0;if(!t){s=p;break a}}return}else s=p}else s=0;while(0);p=L5b(20)|0;f[p+8>>2]=e;f[p+12>>2]=g;f[p+16>>2]=c;f[p+4>>2]=m;f[p>>2]=0;c=a+12|0;v=+(((f[c>>2]|0)+1|0)>>>0);w=+n[a+16>>2];do if(o|v>+(k>>>0)*w){g=(k>>>0<3|(k+-1&k|0)!=0)&1|k<<1;e=~~+X(+(v/w))>>>0;sqb(a,g>>>0<e>>>0?e:g);g=f[d>>2]|0;e=g+-1|0;if(!(e&g)){x=g;y=e&m;break}if(m>>>0<g>>>0){x=g;y=m}else{x=g;y=(m>>>0)%(g>>>0)|0}}else{x=k;y=s}while(0);s=(f[a>>2]|0)+(y<<2)|0;y=f[s>>2]|0;if(!y){k=a+8|0;f[p>>2]=f[k>>2];f[k>>2]=p;f[s>>2]=k;k=f[p>>2]|0;if(k|0){s=f[k+4>>2]|0;k=x+-1|0;if(k&x)if(s>>>0<x>>>0)z=s;else z=(s>>>0)%(x>>>0)|0;else z=s&k;A=(f[a>>2]|0)+(z<<2)|0;B=35}}else{f[p>>2]=f[y>>2];A=y;B=35}if((B|0)==35)f[A>>2]=p;f[c>>2]=(f[c>>2]|0)+1;return}function Nqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0;c=b;d=f[b+48>>2]|0;e=f[b+28>>2]|0;b=a+60|0;g=(d*65535|0)+e|0;h=a+64|0;i=f[h>>2]|0;j=(i|0)==0;k=d;a:do if(!j){l=i+-1|0;m=(l&i|0)==0;if(!m)if(g>>>0<i>>>0)o=g;else o=(g>>>0)%(i>>>0)|0;else o=l&g;p=f[(f[b>>2]|0)+(o<<2)>>2]|0;if((p|0)!=0?(q=f[p>>2]|0,(q|0)!=0):0){if(m){m=q;while(1){p=f[m+4>>2]|0;if(!((p|0)==(g|0)|(p&l|0)==(o|0))){r=o;break a}if((f[m+8>>2]|0)==(k|0)?(f[m+12>>2]|0)==(e|0):0){s=0;break}m=f[m>>2]|0;if(!m){r=o;break a}}return s|0}else t=q;while(1){m=f[t+4>>2]|0;if((m|0)!=(g|0)){if(m>>>0<i>>>0)u=m;else u=(m>>>0)%(i>>>0)|0;if((u|0)!=(o|0)){r=o;break a}}if((f[t+8>>2]|0)==(k|0)?(f[t+12>>2]|0)==(e|0):0){s=0;break}t=f[t>>2]|0;if(!t){r=o;break a}}return s|0}else r=o}else r=0;while(0);o=L5b(20)|0;t=o+8|0;f[t>>2]=d;f[t+4>>2]=e;f[o+16>>2]=c;f[o+4>>2]=g;f[o>>2]=0;c=a+72|0;v=+(((f[c>>2]|0)+1|0)>>>0);w=+n[a+76>>2];do if(j|v>+(i>>>0)*w){e=(i>>>0<3|(i+-1&i|0)!=0)&1|i<<1;t=~~+X(+(v/w))>>>0;tqb(b,e>>>0<t>>>0?t:e);e=f[h>>2]|0;t=e+-1|0;if(!(t&e)){x=e;y=t&g;break}if(g>>>0<e>>>0){x=e;y=g}else{x=e;y=(g>>>0)%(e>>>0)|0}}else{x=i;y=r}while(0);r=(f[b>>2]|0)+(y<<2)|0;y=f[r>>2]|0;if(!y){i=a+68|0;f[o>>2]=f[i>>2];f[i>>2]=o;f[r>>2]=i;i=f[o>>2]|0;if(i|0){r=f[i+4>>2]|0;i=x+-1|0;if(i&x)if(r>>>0<x>>>0)z=r;else z=(r>>>0)%(x>>>0)|0;else z=r&i;A=(f[b>>2]|0)+(z<<2)|0;B=33}}else{f[o>>2]=f[y>>2];A=y;B=33}if((B|0)==33)f[A>>2]=o;f[c>>2]=(f[c>>2]|0)+1;s=1;return s|0}function Oqb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0;d=b;b=f[d>>2]|0;e=f[d+4>>2]|0;d=f[c>>2]|0;c=(b*65535|0)+e|0;g=a+4|0;h=f[g>>2]|0;i=(h|0)==0;j=b;a:do if(!i){k=h+-1|0;l=(k&h|0)==0;if(!l)if(c>>>0<h>>>0)m=c;else m=(c>>>0)%(h>>>0)|0;else m=k&c;o=f[(f[a>>2]|0)+(m<<2)>>2]|0;if((o|0)!=0?(p=f[o>>2]|0,(p|0)!=0):0){if(l){l=p;while(1){o=f[l+4>>2]|0;if(!((o|0)==(c|0)|(o&k|0)==(m|0))){q=m;break a}if((f[l+8>>2]|0)==(j|0)?(f[l+12>>2]|0)==(e|0):0){r=0;break}l=f[l>>2]|0;if(!l){q=m;break a}}return r|0}else s=p;while(1){l=f[s+4>>2]|0;if((l|0)!=(c|0)){if(l>>>0<h>>>0)t=l;else t=(l>>>0)%(h>>>0)|0;if((t|0)!=(m|0)){q=m;break a}}if((f[s+8>>2]|0)==(j|0)?(f[s+12>>2]|0)==(e|0):0){r=0;break}s=f[s>>2]|0;if(!s){q=m;break a}}return r|0}else q=m}else q=0;while(0);m=L5b(20)|0;s=m+8|0;f[s>>2]=b;f[s+4>>2]=e;f[m+16>>2]=d;f[m+4>>2]=c;f[m>>2]=0;d=a+12|0;u=+(((f[d>>2]|0)+1|0)>>>0);v=+n[a+16>>2];do if(i|u>+(h>>>0)*v){e=(h>>>0<3|(h+-1&h|0)!=0)&1|h<<1;s=~~+X(+(u/v))>>>0;uqb(a,e>>>0<s>>>0?s:e);e=f[g>>2]|0;s=e+-1|0;if(!(s&e)){w=e;x=s&c;break}if(c>>>0<e>>>0){w=e;x=c}else{w=e;x=(c>>>0)%(e>>>0)|0}}else{w=h;x=q}while(0);q=(f[a>>2]|0)+(x<<2)|0;x=f[q>>2]|0;if(!x){h=a+8|0;f[m>>2]=f[h>>2];f[h>>2]=m;f[q>>2]=h;h=f[m>>2]|0;if(h|0){q=f[h+4>>2]|0;h=w+-1|0;if(h&w)if(q>>>0<w>>>0)y=q;else y=(q>>>0)%(w>>>0)|0;else y=q&h;z=(f[a>>2]|0)+(y<<2)|0;A=33}}else{f[m>>2]=f[x>>2];z=x;A=33}if((A|0)==33)f[z>>2]=m;f[d>>2]=(f[d>>2]|0)+1;r=1;return r|0}function Pqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+16|0;d=c;e=b;g=f[b+48>>2]|0;h=f[b+28>>2]|0;f[d>>2]=g;f[d+4>>2]=h;b=a+160|0;i=a+164|0;j=f[i>>2]|0;do if(j){k=g;l=a+164|0;m=j;a:while(1){n=f[m+16>>2]|0;do if(k>>>0>=n>>>0){if(n>>>0>=k>>>0){o=f[m+20>>2]|0;if((h|0)<(o|0)){p=7;break}if((o|0)>=(h|0)){p=12;break a}}q=m+4|0;o=f[q>>2]|0;if(!o){p=11;break a}else{r=q;s=o}}else p=7;while(0);if((p|0)==7){p=0;n=f[m>>2]|0;if(!n){p=8;break}else{r=m;s=n}}l=r;m=s}if((p|0)==8){t=m;v=m;break}else if((p|0)==11){t=q;v=m;break}else if((p|0)==12){t=l;v=m;break}}else{t=i;v=i}while(0);if(f[t>>2]|0){w=0;u=c;return w|0}i=L5b(28)|0;f[i+16>>2]=g;f[i+20>>2]=h;f[i+24>>2]=e;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=v;f[t>>2]=i;v=f[f[b>>2]>>2]|0;if(!v)x=i;else{f[b>>2]=v;x=f[t>>2]|0}mP(f[a+164>>2]|0,x);x=a+168|0;f[x>>2]=(f[x>>2]|0)+1;x=a+212|0;t=f[x>>2]|0;if((t|0)==(f[a+216>>2]|0)){Qqb(a+208|0,d);w=1;u=c;return w|0}else{a=d;d=f[a+4>>2]|0;v=t;f[v>>2]=f[a>>2];f[v+4>>2]=d;f[x>>2]=(f[x>>2]|0)+8;w=1;u=c;return w|0}return 0}function Qqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;O5b(d);return}function Rqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function Sqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function Tqb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+64|0;d=c+16|0;e=c;g=a+4|0;h=f[g>>2]|0;i=f[h+20>>2]|0;if((i|0)<=0){u=c;return}j=e+11|0;k=d+8|0;l=d+4|0;m=k;n=0;o=h;while(1){h=f[(f[o+28>>2]|0)+4+(n<<2)>>2]|0;p=(f[a>>2]|0)+124|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;q=f[h+24>>2]|0;r=(q|0)==0;s=r?0:q+4|0;t=r?0:q+4+(f[h+16>>2]<<2)|0;if((s|0)!=(t|0)){q=s;do{if((q|0)!=(s|0))k6b(e,489171)|0;r=f[q>>2]|0;f[d>>2]=k;v=(tSb(r,k)|0)-m|0;f[l>>2]=v;ISb(e,d);q=q+4|0}while((q|0)!=(t|0))}t=Uqb(p,e)|0;f[t>>2]=h;if((b[j>>0]|0)<0)O5b(f[e>>2]|0);t=n+1|0;if((t|0)>=(i|0))break;n=t;o=f[g>>2]|0}u=c;return}function Uqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;e=Vqb(a,b)|0;if(!e){g=L5b(24)|0;X5b(g+8|0,b);f[g+20>>2]=0;Wqb(d,a,g);h=f[d>>2]|0;i=h+20|0;u=c;return i|0}else{h=e;i=h+20|0;u=c;return i|0}return 0}function Vqb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=e?f[c>>2]|0:c;h=b[g>>0]|0;if(!(h<<24>>24))i=0;else{j=g;k=0;l=h;while(1){m=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=m;break}else k=m}}k=f[a+4>>2]|0;if(!k){n=0;return n|0}l=k+-1|0;j=(l&k|0)==0;if(!j)if(i>>>0<k>>>0)o=i;else o=(i>>>0)%(k>>>0)|0;else o=l&i;m=f[(f[a>>2]|0)+(o<<2)>>2]|0;if(!m){n=0;return n|0}a=f[m>>2]|0;if(!a){n=0;return n|0}m=e?f[c+4>>2]|0:d&255;d=(m|0)==0;if(j){j=a;a:while(1){c=f[j+4>>2]|0;e=(c|0)==(i|0);if(!(e|(c&l|0)==(o|0))){n=0;p=36;break}do if(e?(c=j+8|0,q=b[c+11>>0]|0,r=q<<24>>24<0,s=q&255,((r?f[j+12>>2]|0:s)|0)==(m|0)):0){q=f[c>>2]|0;t=r?q:c;if(r){if(d){n=j;p=36;break a}if(!(ZVb(t,g,m)|0)){n=j;p=36;break a}else break}if(d){n=j;p=36;break a}if((q&255)<<24>>24==h<<24>>24){q=c;c=s;s=g;do{c=c+-1|0;q=q+1|0;if(!c){n=j;p=36;break a}s=s+1|0}while((b[q>>0]|0)==(b[s>>0]|0))}}while(0);j=f[j>>2]|0;if(!j){n=0;p=36;break}}if((p|0)==36)return n|0}else u=a;b:while(1){a=f[u+4>>2]|0;j=(a|0)==(i|0);if(!j){if(a>>>0<k>>>0)v=a;else v=(a>>>0)%(k>>>0)|0;if((v|0)!=(o|0)){n=0;p=36;break}if(j)p=28}else p=28;do if((p|0)==28?(p=0,j=u+8|0,a=b[j+11>>0]|0,l=a<<24>>24<0,e=a&255,((l?f[u+12>>2]|0:e)|0)==(m|0)):0){a=f[j>>2]|0;s=l?a:j;if(l){if(d){n=u;p=36;break b}if(!(ZVb(s,g,m)|0)){n=u;p=36;break b}else break}if(d){n=u;p=36;break b}if((a&255)<<24>>24==h<<24>>24){a=j;j=e;e=g;do{j=j+-1|0;a=a+1|0;if(!j){n=u;p=36;break b}e=e+1|0}while((b[a>>0]|0)==(b[e>>0]|0))}}while(0);u=f[u>>2]|0;if(!u){n=0;p=36;break}}if((p|0)==36)return n|0;return 0}function Wqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0;e=d+8|0;g=b[e+11>>0]|0;h=g<<24>>24<0;i=h?f[e>>2]|0:e;e=b[i>>0]|0;if(!(e<<24>>24))j=0;else{k=i;l=0;m=e;while(1){e=(l*5|0)+(m<<24>>24)|0;k=k+1|0;m=b[k>>0]|0;if(!(m<<24>>24)){j=e;break}else l=e}}l=d+4|0;f[l>>2]=j;m=c+4|0;k=f[m>>2]|0;e=(k|0)==0;a:do if(!e){o=k+-1|0;p=(o&k|0)==0;if(!p)if(j>>>0<k>>>0)q=j;else q=(j>>>0)%(k>>>0)|0;else q=o&j;r=f[(f[c>>2]|0)+(q<<2)>>2]|0;if((r|0)!=0?(s=f[r>>2]|0,(s|0)!=0):0){r=d+12|0;t=g&255;if(p){p=s;b:while(1){if((f[p+4>>2]&o|0)!=(q|0)){u=q;break a}v=p+8|0;w=b[v+11>>0]|0;x=w<<24>>24<0;y=w&255;w=x?f[p+12>>2]|0:y;do if((w|0)==((h?f[r>>2]|0:t)|0)){z=f[v>>2]|0;A=x?z:v;B=(w|0)==0;if(x){if(B){C=0;D=p;E=47;break b}if(!(ZVb(A,i,w)|0)){C=0;D=p;E=47;break b}else break}if(B){C=0;D=p;E=47;break b}if((z&255)<<24>>24==(b[i>>0]|0)){z=v;B=y;A=i;do{B=B+-1|0;z=z+1|0;if(!B){C=0;D=p;E=47;break b}A=A+1|0}while((b[z>>0]|0)==(b[A>>0]|0))}}while(0);p=f[p>>2]|0;if(!p){u=q;break a}}if((E|0)==47){F=D;f[a>>2]=F;G=a+4|0;b[G>>0]=C;return}}else H=s;c:while(1){p=f[H+4>>2]|0;if(p>>>0<k>>>0)I=p;else I=(p>>>0)%(k>>>0)|0;if((I|0)!=(q|0)){u=q;break a}p=H+8|0;o=b[p+11>>0]|0;y=o<<24>>24<0;v=o&255;o=y?f[H+12>>2]|0:v;do if((o|0)==((h?f[r>>2]|0:t)|0)){w=f[p>>2]|0;x=y?w:p;A=(o|0)==0;if(y){if(A){C=0;D=H;E=47;break c}if(!(ZVb(x,i,o)|0)){C=0;D=H;E=47;break c}else break}if(A){C=0;D=H;E=47;break c}if((w&255)<<24>>24==(b[i>>0]|0)){w=p;A=v;x=i;do{A=A+-1|0;w=w+1|0;if(!A){C=0;D=H;E=47;break c}x=x+1|0}while((b[w>>0]|0)==(b[x>>0]|0))}}while(0);H=f[H>>2]|0;if(!H){u=q;break a}}if((E|0)==47){F=D;f[a>>2]=F;G=a+4|0;b[G>>0]=C;return}}else u=q}else u=0;while(0);q=c+12|0;J=+(((f[q>>2]|0)+1|0)>>>0);K=+n[c+16>>2];do if(e|J>+(k>>>0)*K){E=(k>>>0<3|(k+-1&k|0)!=0)&1|k<<1;H=~~+X(+(J/K))>>>0;Xqb(c,E>>>0<H>>>0?H:E);E=f[m>>2]|0;H=f[l>>2]|0;i=E+-1|0;if(!(i&E)){L=E;M=i&H;break}if(H>>>0<E>>>0){L=E;M=H}else{L=E;M=(H>>>0)%(E>>>0)|0}}else{L=k;M=u}while(0);u=f[(f[c>>2]|0)+(M<<2)>>2]|0;if(!u){k=c+8|0;f[d>>2]=f[k>>2];f[k>>2]=d;f[(f[c>>2]|0)+(M<<2)>>2]=k;k=f[d>>2]|0;if(!k)N=d;else{M=f[k+4>>2]|0;k=L+-1|0;if(k&L)if(M>>>0<L>>>0)O=M;else O=(M>>>0)%(L>>>0)|0;else O=M&k;f[(f[c>>2]|0)+(O<<2)>>2]=d;N=d}}else{f[d>>2]=f[u>>2];f[u>>2]=d;N=d}f[q>>2]=(f[q>>2]|0)+1;C=1;D=N;F=D;f[a>>2]=F;G=a+4|0;b[G>>0]=C;return}function Xqb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=yWb(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){Yqb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=yWb(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;Yqb(a,d);return}function Yqb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=(c|0)!=0;do if(d)if(c>>>0>1073741823){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{g=L5b(c<<2)|0;break}else g=0;while(0);e=f[a>>2]|0;f[a>>2]=g;if(e|0)O5b(e);f[a+4>>2]=c;if(d)h=0;else return;do{f[(f[a>>2]|0)+(h<<2)>>2]=0;h=h+1|0}while((h|0)!=(c|0));h=a+8|0;d=f[h>>2]|0;if(!d)return;e=f[d+4>>2]|0;g=c+-1|0;i=(g&c|0)==0;if(!i)if(e>>>0<c>>>0)j=e;else j=(e>>>0)%(c>>>0)|0;else j=e&g;f[(f[a>>2]|0)+(j<<2)>>2]=h;h=f[d>>2]|0;if(!h)return;else{k=j;l=d;m=h;n=d}a:while(1){d=l;h=m;j=n;b:while(1){o=h;while(1){e=f[o+4>>2]|0;if(!i)if(e>>>0<c>>>0)p=e;else p=(e>>>0)%(c>>>0)|0;else p=e&g;if((p|0)==(k|0))break;q=(f[a>>2]|0)+(p<<2)|0;if(!(f[q>>2]|0))break b;e=f[o>>2]|0;c:do if(!e)r=o;else{s=o+8|0;t=b[s+11>>0]|0;u=t<<24>>24<0;v=t&255;t=u?f[o+12>>2]|0:v;w=(t|0)==0;if(u){u=o;x=e;while(1){y=x+8|0;z=b[y+11>>0]|0;A=z<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:z&255)|0)){r=u;break c}if(!w?ZVb(f[s>>2]|0,A?f[y>>2]|0:y,t)|0:0){r=u;break c}y=f[x>>2]|0;if(!y){r=x;break c}else{A=x;x=y;u=A}}}if(w){u=o;x=e;while(1){A=b[x+8+11>>0]|0;if((A<<24>>24<0?f[x+12>>2]|0:A&255)|0){r=u;break c}A=f[x>>2]|0;if(!A){r=x;break c}else{y=x;x=A;u=y}}}u=o;x=e;while(1){w=x+8|0;y=b[w+11>>0]|0;A=y<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:y&255)|0)){r=u;break c}y=A?f[w>>2]|0:w;if((f[s>>2]&255)<<24>>24==(b[y>>0]|0)){B=s;C=v;D=y}else{r=u;break c}while(1){C=C+-1|0;B=B+1|0;if(!C)break;D=D+1|0;if((b[B>>0]|0)!=(b[D>>0]|0)){r=u;break c}}y=f[x>>2]|0;if(!y){r=x;break}else{w=x;x=y;u=w}}}while(0);f[j>>2]=f[r>>2];f[r>>2]=f[f[(f[a>>2]|0)+(p<<2)>>2]>>2];f[f[(f[a>>2]|0)+(p<<2)>>2]>>2]=o;e=f[d>>2]|0;if(!e){E=41;break a}else o=e}h=f[o>>2]|0;if(!h){E=41;break a}else{d=o;j=o}}f[q>>2]=j;m=f[o>>2]|0;if(!m){E=41;break}else{k=p;l=o;n=o}}if((E|0)==41)return}function Zqb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e+24|0;h=e+16|0;i=e;f[h>>2]=a;f[h+4>>2]=d;d=a+120|0;if((f[d>>2]|0)!=2){f[g>>2]=136220;f[g+4>>2]=1510;b[g+8>>0]=0;f[g+12>>2]=h;Gpb(d,g)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;d=f[c>>2]|0;h=f[c+4>>2]|0;if((d|0)!=(h|0)){c=g+8|0;j=g+4|0;k=c;l=d;do{if((l|0)!=(d|0))k6b(i,489171)|0;m=f[l>>2]|0;f[g>>2]=c;n=(tSb(m,c)|0)-k|0;f[j>>2]=n;ISb(i,g);l=l+4|0}while((l|0)!=(h|0))}h=Vqb(a+124|0,i)|0;if(!h)o=0;else o=f[h+20>>2]|0;if((b[i+11>>0]|0)>=0){u=e;return o|0}O5b(f[i>>2]|0);u=e;return o|0}function _qb(a){a=a|0;O5b(a);return}function $qb(a){a=a|0;var c=0;c=b[a+8>>0]|0;bi[f[a+4>>2]&2047](f[a+12>>2]|0);if((a|0)==0|c<<24>>24==0)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function arb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;e=L5b(4)|0;Bpb(e);f[a>>2]=e;f[a+4>>2]=c;f[a+8>>2]=d;f[a+12>>2]=0;d=L5b(220)|0;iqb(d);f[a+16>>2]=d;b[a+20>>0]=1;b[a+21>>0]=0;b[a+22>>0]=0;f[a+28>>2]=0;f[a+32>>2]=0;f[a+24>>2]=a+28;return}function brb(a){a=a|0;var b=0;b=f[a>>2]|0;if(b|0){Cpb(b);O5b(b)}kP(a+24|0,f[a+28>>2]|0);b=f[a+16>>2]|0;if(!b)return;nqb(b);O5b(b);return}function crb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;c=b[d>>0]|0;if(!(c<<24>>24))e=0;else{g=d;h=0;i=c;while(1){c=(h*5|0)+(i<<24>>24)|0;g=g+1|0;i=b[g>>0]|0;if(!(i<<24>>24)){e=c;break}else h=c}}h=f[a+4>>2]|0;if(!h){j=0;return j|0}i=h+-1|0;g=(i&h|0)==0;if(!g)if(e>>>0<h>>>0)k=e;else k=(e>>>0)%(h>>>0)|0;else k=i&e;c=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!c){j=0;return j|0}a=f[c>>2]|0;if(!a){j=0;return j|0}if(g){g=a;while(1){c=f[g+4>>2]|0;l=(e|0)==(c|0);if(!(l|(c&i|0)==(k|0))){j=0;m=22;break}if(l?(gTb(f[g+8>>2]|0,d)|0)==0:0){j=g;m=22;break}g=f[g>>2]|0;if(!g){j=0;m=22;break}}if((m|0)==22)return j|0}else n=a;while(1){a=f[n+4>>2]|0;g=(e|0)==(a|0);if(!g){if(a>>>0<h>>>0)o=a;else o=(a>>>0)%(h>>>0)|0;if((o|0)!=(k|0)){j=0;m=22;break}if(g)m=21}else m=21;if((m|0)==21?(m=0,(gTb(f[n+8>>2]|0,d)|0)==0):0){j=n;m=22;break}n=f[n>>2]|0;if(!n){j=0;m=22;break}}if((m|0)==22)return j|0;return 0}function drb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;if((f[213364]|0)==2){d=f[213365]|0;u=a;return d|0}f[c>>2]=135812;f[c+4>>2]=47;b[c+8>>0]=0;Gpb(853456,c);hpb(c);d=f[213365]|0;u=a;return d|0}function erb(){var a=0,b=0;a=L5b(52)|0;NEb(a);f[213366]=a;b=L5b(36)|0;arb(b,a,0);f[213365]=b;spb(48);return}function frb(){var a=0;a=f[213366]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);f[213366]=0;a=f[213365]|0;if(!a){f[213365]=0;return}brb(a);O5b(a);f[213365]=0;return}function grb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+48|0;e=d+24|0;g=d;if((f[213364]|0)!=2){f[e>>2]=135812;f[e+4>>2]=47;b[e+8>>0]=0;Gpb(853456,e);hpb(e)}if(OEb(f[213366]|0,a,c)|0){u=d;return}zpb(g,3,450744,1272);xpb(d+36|0,vpb(g,450974)|0);Apb(g);u=d;return}
function Iba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55508;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function Jba(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=(f[a+4>>2]|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=(f[a+76>>2]&1|0)==0;l=f[j>>2]|0;m=f[j+4>>2]|0;j=(m|0)==1;n=(l|0)==2&j;o=(l|0)==-2&j;p=(l|0)==0&(j|(m|0)==-1);j=f[a+72>>2]|0;if(!g)return;a=(m|0)<0;q=h+-4|0;r=(h|0)<4;s=h&-4;t=c;c=b+(i<<2)|0;i=g;while(1){i=i+-1|0;g=f[c+-4>>2]|0;b=f[c>>2]|0;c=c+4|0;u=f[c>>2]|0;a:do if(k)if(p){v=a?u:g;w=a?g:u;if(r)x=0;else{y=w;z=v;A=0;do{B=(f[y+(A<<2)>>2]|0)-(f[z+(A<<2)>>2]|0)+j|0;C=A|1;D=(f[y+(C<<2)>>2]|0)-(f[z+(C<<2)>>2]|0)+j|0;d[t+(A<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;d[t+(C<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;D=A|2;C=(f[y+(D<<2)>>2]|0)-(f[z+(D<<2)>>2]|0)+j|0;B=A|3;E=(f[y+(B<<2)>>2]|0)-(f[z+(B<<2)>>2]|0)+j|0;d[t+(D<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;d[t+(B<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));x=s}if((x|0)>=(h|0))break;A=w;z=v;y=x;do{E=(f[A+(y<<2)>>2]|0)-(f[z+(y<<2)>>2]|0)+j|0;d[t+(y<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;y=y+1|0}while((y|0)!=(h|0))}else{if(r)F=0;else{y=u;z=g;A=0;do{v=(Y((f[y+(A<<2)>>2]|0)-(f[z+(A<<2)>>2]|0)|0,m)|0)+j|0;w=A|1;E=(Y((f[y+(w<<2)>>2]|0)-(f[z+(w<<2)>>2]|0)|0,m)|0)+j|0;d[t+(A<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[t+(w<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;E=A|2;w=(Y((f[y+(E<<2)>>2]|0)-(f[z+(E<<2)>>2]|0)|0,m)|0)+j|0;v=A|3;B=(Y((f[y+(v<<2)>>2]|0)-(f[z+(v<<2)>>2]|0)|0,m)|0)+j|0;d[t+(E<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[t+(v<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));F=s}if((F|0)>=(h|0))break;A=u;z=g;y=F;do{B=(Y((f[A+(y<<2)>>2]|0)-(f[z+(y<<2)>>2]|0)|0,m)|0)+j|0;d[t+(y<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;y=y+1|0}while((y|0)!=(h|0))}else{if(n){if(r)G=0;else{y=g;z=u;A=0;do{B=(f[y+(A<<2)>>2]|0)+j+(f[b+(A<<2)>>2]<<1)+(f[z+(A<<2)>>2]|0)|0;v=A|1;w=(f[y+(v<<2)>>2]|0)+j+(f[b+(v<<2)>>2]<<1)+(f[z+(v<<2)>>2]|0)|0;d[t+(A<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;d[t+(v<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;w=A|2;v=(f[y+(w<<2)>>2]|0)+j+(f[b+(w<<2)>>2]<<1)+(f[z+(w<<2)>>2]|0)|0;B=A|3;E=(f[y+(B<<2)>>2]|0)+j+(f[b+(B<<2)>>2]<<1)+(f[z+(B<<2)>>2]|0)|0;d[t+(w<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[t+(B<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));G=s}if((G|0)>=(h|0))break;A=g;z=u;y=G;while(1){E=(f[A+(y<<2)>>2]|0)+j+(f[b+(y<<2)>>2]<<1)+(f[z+(y<<2)>>2]|0)|0;d[t+(y<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;y=y+1|0;if((y|0)==(h|0))break a}}if(o){if(r)H=0;else{y=g;z=u;A=0;do{E=(f[y+(A<<2)>>2]|0)+j-(f[b+(A<<2)>>2]<<1)+(f[z+(A<<2)>>2]|0)|0;B=A|1;v=(f[y+(B<<2)>>2]|0)+j-(f[b+(B<<2)>>2]<<1)+(f[z+(B<<2)>>2]|0)|0;d[t+(A<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;d[t+(B<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;v=A|2;B=(f[y+(v<<2)>>2]|0)+j-(f[b+(v<<2)>>2]<<1)+(f[z+(v<<2)>>2]|0)|0;E=A|3;w=(f[y+(E<<2)>>2]|0)+j-(f[b+(E<<2)>>2]<<1)+(f[z+(E<<2)>>2]|0)|0;d[t+(v<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;d[t+(E<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));H=s}if((H|0)>=(h|0))break;A=g;z=u;y=H;do{w=(f[A+(y<<2)>>2]|0)+j-(f[b+(y<<2)>>2]<<1)+(f[z+(y<<2)>>2]|0)|0;d[t+(y<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;y=y+1|0}while((y|0)!=(h|0))}else{if(r)I=0;else{y=g;z=u;A=0;do{w=Y((f[z+(A<<2)>>2]|0)+(f[y+(A<<2)>>2]|0)|0,m)|0;E=(Y(f[b+(A<<2)>>2]|0,l)|0)+j+w|0;w=A|1;B=Y((f[z+(w<<2)>>2]|0)+(f[y+(w<<2)>>2]|0)|0,m)|0;v=(Y(f[b+(w<<2)>>2]|0,l)|0)+j+B|0;d[t+(A<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;d[t+(w<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;v=A|2;w=Y((f[z+(v<<2)>>2]|0)+(f[y+(v<<2)>>2]|0)|0,m)|0;E=(Y(f[b+(v<<2)>>2]|0,l)|0)+j+w|0;w=A|3;B=Y((f[z+(w<<2)>>2]|0)+(f[y+(w<<2)>>2]|0)|0,m)|0;C=(Y(f[b+(w<<2)>>2]|0,l)|0)+j+B|0;d[t+(v<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;d[t+(w<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;A=A+4|0}while((A|0)<=(q|0));I=s}if((I|0)>=(h|0))break;A=g;y=u;z=I;do{C=Y((f[y+(z<<2)>>2]|0)+(f[A+(z<<2)>>2]|0)|0,m)|0;w=(Y(f[b+(z<<2)>>2]|0,l)|0)+j+C|0;d[t+(z<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;z=z+1|0}while((z|0)!=(h|0))}}while(0);if(!i)break;else t=t+e|0}return}function Kba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=55508;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=m;q=a+60|0;r=a+56|0;f[r>>2]=q;f[q>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){q=c+36|0;s=f[q>>2]|0;if(s){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1;t=a+48|0;s=f[t>>2]|0;if((s|0)!=0?(v=s+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0){kL(k);w=t}else w=t}else w=a+48|0;f[w>>2]=0;t=a+28|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[l>>2]|0)>0){s=f[n>>2]|0;n=0;do{f[s+(n<<2)>>2]=0;n=n+1|0;x=f[l>>2]|0}while((n|0)<(x|0));f[k>>2]=f[c>>2];if((x|0)<3)y=13;else y=15}else{f[k>>2]=f[c>>2];y=13}if((y|0)==13){x=f[c+4>>2]|0;if((x|0)<3){f[l>>2]=x;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];x=f[c+44>>2]|0;l=f[r>>2]|0;f[l>>2]=f[x>>2];f[l+4>>2]=f[x+4>>2]}else y=15}if((y|0)==15)jL(k,c);f[t>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[w>>2]=f[q>>2]}}else{q=g+8|0;f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;SP(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;j=MVb(e)|0;f[a+72>>2]=j;if((f[k>>2]&4095|0)==4?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;o=aD(g,77)|0;m=245846;p=o+77|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(p|0));bO(-215,g,245924,241836,3251);bD(g);u=h;return}function Lba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55508;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function Mba(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=f[a+72>>2]|0;m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(!(f[a+76>>2]&1)){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;p=h&-4;q=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;r=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;s=c;t=m;u=b;while(1){a:do if(g)v=0;else{if(o){w=0;while(1){d[s+(w<<1)>>1]=r;d[s+((w|1)<<1)>>1]=r;d[s+((w|2)<<1)>>1]=r;d[s+((w|3)<<1)>>1]=r;w=w+4|0;if((w|0)>(a|0)){v=p;break a}}}else x=0;do{w=l;y=l;z=l;A=l;B=1;while(1){C=(f[t+(B<<2)>>2]|0)+(x<<2)|0;D=(f[t+(0-B<<2)>>2]|0)+(x<<2)|0;E=f[k+(B<<2)>>2]|0;A=(Y((f[C>>2]|0)-(f[D>>2]|0)|0,E)|0)+A|0;z=(Y((f[C+4>>2]|0)-(f[D+4>>2]|0)|0,E)|0)+z|0;y=(Y((f[C+8>>2]|0)-(f[D+8>>2]|0)|0,E)|0)+y|0;w=(Y((f[C+12>>2]|0)-(f[D+12>>2]|0)|0,E)|0)+w|0;if((B|0)>=(j|0))break;else B=B+1|0}d[s+(x<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;d[s+((x|1)<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;d[s+((x|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;d[s+((x|3)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;x=x+4|0}while((x|0)<=(a|0));v=p}while(0);b:do if((v|0)<(h|0)){if(o){B=v;while(1){d[s+(B<<1)>>1]=q;B=B+1|0;if((B|0)==(h|0))break b}}else F=v;do{B=l;E=1;while(1){B=(Y((f[(f[t+(E<<2)>>2]|0)+(F<<2)>>2]|0)-(f[(f[t+(0-E<<2)>>2]|0)+(F<<2)>>2]|0)|0,f[k+(E<<2)>>2]|0)|0)+B|0;if((E|0)>=(j|0))break;else E=E+1|0}d[s+(F<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;F=F+1|0}while((F|0)!=(h|0))}while(0);if(!u)break;else{s=s+e|0;t=t+4|0;u=u+-1|0}}return}else{if(n)return;n=h+-4|0;u=(h|0)<4;t=(i|0)<2;i=h&-4;s=m;m=c;c=b;while(1){c:do if(u)G=0;else{b=f[k>>2]|0;F=f[s>>2]|0;if(t){v=0;while(1){q=F+(v<<2)|0;o=(Y(f[q>>2]|0,b)|0)+l|0;p=(Y(f[q+4>>2]|0,b)|0)+l|0;a=(Y(f[q+8>>2]|0,b)|0)+l|0;x=(Y(f[q+12>>2]|0,b)|0)+l|0;d[m+(v<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;d[m+((v|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[m+((v|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[m+((v|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;v=v+4|0;if((v|0)>(n|0)){G=i;break c}}}else H=0;do{v=F+(H<<2)|0;x=(Y(f[v>>2]|0,b)|0)+l|0;a=(Y(f[v+4>>2]|0,b)|0)+l|0;p=(Y(f[v+8>>2]|0,b)|0)+l|0;o=(Y(f[v+12>>2]|0,b)|0)+l|0;v=p;p=a;a=x;x=1;while(1){q=(f[s+(x<<2)>>2]|0)+(H<<2)|0;r=(f[s+(0-x<<2)>>2]|0)+(H<<2)|0;g=f[k+(x<<2)>>2]|0;a=(Y((f[r>>2]|0)+(f[q>>2]|0)|0,g)|0)+a|0;p=(Y((f[r+4>>2]|0)+(f[q+4>>2]|0)|0,g)|0)+p|0;v=(Y((f[r+8>>2]|0)+(f[q+8>>2]|0)|0,g)|0)+v|0;o=(Y((f[r+12>>2]|0)+(f[q+12>>2]|0)|0,g)|0)+o|0;if((x|0)>=(j|0))break;else x=x+1|0}d[m+(H<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[m+((H|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[m+((H|2)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[m+((H|3)<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;H=H+4|0}while((H|0)<=(n|0));G=i}while(0);d:do if((G|0)<(h|0)){b=f[k>>2]|0;F=f[s>>2]|0;if(t){x=G;while(1){B=(Y(f[F+(x<<2)>>2]|0,b)|0)+l|0;d[m+(x<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break d}}else I=G;do{x=(Y(f[F+(I<<2)>>2]|0,b)|0)+l|0;B=1;while(1){x=(Y((f[(f[s+(0-B<<2)>>2]|0)+(I<<2)>>2]|0)+(f[(f[s+(B<<2)>>2]|0)+(I<<2)>>2]|0)|0,f[k+(B<<2)>>2]|0)|0)+x|0;if((B|0)>=(j|0))break;else B=B+1|0}d[m+(I<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!c)break;else{s=s+4|0;m=m+e|0;c=c+-1|0}}return}}function Nba(a){a=a|0;O5b(a);return}function Oba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Pba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55388;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function Qba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=(f[a+4>>2]|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=(f[a+84>>2]&1|0)==0;l=f[j>>2]|0;m=f[j+4>>2]|0;j=(m|0)==1;n=(l|0)==2&j;o=(l|0)==-2&j;p=(l|0)==0&(j|(m|0)==-1);j=a+68|0;q=f[j>>2]|0;if(!g)return;r=(m|0)<0;s=h+-4|0;t=(h|0)<4;u=(f[j+4>>2]|0)+(f[a+80>>2]|0)|0;a=h&-4;j=d;d=c+(i<<2)|0;i=g;while(1){i=i+-1|0;g=f[d+-4>>2]|0;c=f[d>>2]|0;d=d+4|0;v=f[d>>2]|0;a:do if(k)if(p){w=r?v:g;x=r?g:v;if(t)y=0;else{z=x;A=w;B=0;do{C=B|1;D=f[z+(C<<2)>>2]|0;E=f[A+(C<<2)>>2]|0;F=u+(f[z+(B<<2)>>2]|0)-(f[A+(B<<2)>>2]|0)>>q;b[j+B>>0]=F>>>0<256?F:(F|0)>0?255:0;F=u+D-E>>q;b[j+C>>0]=F>>>0<256?F:(F|0)>0?255:0;F=B|2;C=B|3;E=f[z+(C<<2)>>2]|0;D=f[A+(C<<2)>>2]|0;G=u+(f[z+(F<<2)>>2]|0)-(f[A+(F<<2)>>2]|0)>>q;b[j+F>>0]=G>>>0<256?G:(G|0)>0?255:0;G=u+E-D>>q;b[j+C>>0]=G>>>0<256?G:(G|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));y=a}if((y|0)>=(h|0))break;B=x;A=w;z=y;do{G=u+(f[B+(z<<2)>>2]|0)-(f[A+(z<<2)>>2]|0)>>q;b[j+z>>0]=G>>>0<256?G:(G|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}else{if(t)H=0;else{z=v;A=g;B=0;do{w=Y((f[z+(B<<2)>>2]|0)-(f[A+(B<<2)>>2]|0)|0,m)|0;x=B|1;G=Y((f[z+(x<<2)>>2]|0)-(f[A+(x<<2)>>2]|0)|0,m)|0;C=u+w>>q;b[j+B>>0]=C>>>0<256?C:(C|0)>0?255:0;C=u+G>>q;b[j+x>>0]=C>>>0<256?C:(C|0)>0?255:0;C=B|2;x=Y((f[z+(C<<2)>>2]|0)-(f[A+(C<<2)>>2]|0)|0,m)|0;G=B|3;w=Y((f[z+(G<<2)>>2]|0)-(f[A+(G<<2)>>2]|0)|0,m)|0;D=u+x>>q;b[j+C>>0]=D>>>0<256?D:(D|0)>0?255:0;D=u+w>>q;b[j+G>>0]=D>>>0<256?D:(D|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));H=a}if((H|0)>=(h|0))break;B=v;A=g;z=H;do{D=u+(Y((f[B+(z<<2)>>2]|0)-(f[A+(z<<2)>>2]|0)|0,m)|0)>>q;b[j+z>>0]=D>>>0<256?D:(D|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}else{if(n){if(t)I=0;else{z=g;A=v;B=0;do{D=B|1;G=f[z+(D<<2)>>2]|0;w=f[c+(D<<2)>>2]<<1;C=f[A+(D<<2)>>2]|0;x=u+(f[z+(B<<2)>>2]|0)+(f[c+(B<<2)>>2]<<1)+(f[A+(B<<2)>>2]|0)>>q;b[j+B>>0]=x>>>0<256?x:(x|0)>0?255:0;x=u+G+w+C>>q;b[j+D>>0]=x>>>0<256?x:(x|0)>0?255:0;x=B|2;D=B|3;C=f[z+(D<<2)>>2]|0;w=f[c+(D<<2)>>2]<<1;G=f[A+(D<<2)>>2]|0;E=u+(f[z+(x<<2)>>2]|0)+(f[c+(x<<2)>>2]<<1)+(f[A+(x<<2)>>2]|0)>>q;b[j+x>>0]=E>>>0<256?E:(E|0)>0?255:0;E=u+C+w+G>>q;b[j+D>>0]=E>>>0<256?E:(E|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));I=a}if((I|0)>=(h|0))break;B=g;A=v;z=I;while(1){E=u+(f[B+(z<<2)>>2]|0)+(f[c+(z<<2)>>2]<<1)+(f[A+(z<<2)>>2]|0)>>q;b[j+z>>0]=E>>>0<256?E:(E|0)>0?255:0;z=z+1|0;if((z|0)==(h|0))break a}}if(o){if(t)J=0;else{z=g;A=v;B=0;do{E=B|1;D=f[z+(E<<2)>>2]|0;G=f[c+(E<<2)>>2]<<1;w=f[A+(E<<2)>>2]|0;C=u+(f[z+(B<<2)>>2]|0)-(f[c+(B<<2)>>2]<<1)+(f[A+(B<<2)>>2]|0)>>q;b[j+B>>0]=C>>>0<256?C:(C|0)>0?255:0;C=u+D-G+w>>q;b[j+E>>0]=C>>>0<256?C:(C|0)>0?255:0;C=B|2;E=B|3;w=f[z+(E<<2)>>2]|0;G=f[c+(E<<2)>>2]<<1;D=f[A+(E<<2)>>2]|0;x=u+(f[z+(C<<2)>>2]|0)-(f[c+(C<<2)>>2]<<1)+(f[A+(C<<2)>>2]|0)>>q;b[j+C>>0]=x>>>0<256?x:(x|0)>0?255:0;x=u+w-G+D>>q;b[j+E>>0]=x>>>0<256?x:(x|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));J=a}if((J|0)>=(h|0))break;B=g;A=v;z=J;do{x=u+(f[B+(z<<2)>>2]|0)-(f[c+(z<<2)>>2]<<1)+(f[A+(z<<2)>>2]|0)>>q;b[j+z>>0]=x>>>0<256?x:(x|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}else{if(t)K=0;else{z=g;A=v;B=0;do{x=Y((f[A+(B<<2)>>2]|0)+(f[z+(B<<2)>>2]|0)|0,m)|0;E=Y(f[c+(B<<2)>>2]|0,l)|0;D=B|1;G=Y((f[A+(D<<2)>>2]|0)+(f[z+(D<<2)>>2]|0)|0,m)|0;w=Y(f[c+(D<<2)>>2]|0,l)|0;C=u+E+x>>q;b[j+B>>0]=C>>>0<256?C:(C|0)>0?255:0;C=u+w+G>>q;b[j+D>>0]=C>>>0<256?C:(C|0)>0?255:0;C=B|2;D=Y((f[A+(C<<2)>>2]|0)+(f[z+(C<<2)>>2]|0)|0,m)|0;G=Y(f[c+(C<<2)>>2]|0,l)|0;w=B|3;x=Y((f[A+(w<<2)>>2]|0)+(f[z+(w<<2)>>2]|0)|0,m)|0;E=Y(f[c+(w<<2)>>2]|0,l)|0;F=u+G+D>>q;b[j+C>>0]=F>>>0<256?F:(F|0)>0?255:0;F=u+E+x>>q;b[j+w>>0]=F>>>0<256?F:(F|0)>0?255:0;B=B+4|0}while((B|0)<=(s|0));K=a}if((K|0)>=(h|0))break;B=g;z=v;A=K;do{F=Y((f[z+(A<<2)>>2]|0)+(f[B+(A<<2)>>2]|0)|0,m)|0;w=u+(Y(f[c+(A<<2)>>2]|0,l)|0)+F>>q;b[j+A>>0]=w>>>0<256?w:(w|0)>0?255:0;A=A+1|0}while((A|0)!=(h|0))}}while(0);if(!i)break;else j=j+e|0}return}function Rba(a){a=a|0;O5b(a);return}function Sba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Tba(a){a=a|0;O5b(a);return}function Uba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Vba(a){a=a|0;O5b(a);return}function Wba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Xba(a){a=a|0;O5b(a);return}function Yba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Zba(a){a=a|0;O5b(a);return}function _ba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function $ba(a){a=a|0;O5b(a);return}function aca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function bca(a){a=a|0;O5b(a);return}function cca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dca(a){a=a|0;O5b(a);return}function eca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fca(a){a=a|0;O5b(a);return}function gca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hca(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0.0,U=0,V=0,W=0,X=0,Y=0,Z=0;m=u;u=u+288|0;n=m+232|0;o=m+176|0;p=m+120|0;q=m+112|0;r=m+104|0;s=m+48|0;t=m+32|0;v=m+16|0;w=m;do if((yM(e)|0)==65536){x=f[e+4>>2]|0;f[n>>2]=f[x>>2];y=n+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=n+8|0;f[A>>2]=f[x+8>>2];f[n+12>>2]=f[x+12>>2];f[n+16>>2]=f[x+16>>2];f[n+20>>2]=f[x+20>>2];f[n+24>>2]=f[x+24>>2];f[n+28>>2]=f[x+28>>2];f[n+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[n+36>>2]=B;f[n+40>>2]=A;A=n+48|0;C=n+44|0;f[C>>2]=A;f[A>>2]=0;f[n+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(n,x);break}}else yL(n,e,-1);while(0);do if((yM(g)|0)==65536){e=f[g+4>>2]|0;f[o>>2]=f[e>>2];x=o+4|0;y=e+4|0;f[x>>2]=f[y>>2];z=o+8|0;f[z>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];f[o+16>>2]=f[e+16>>2];f[o+20>>2]=f[e+20>>2];f[o+24>>2]=f[e+24>>2];f[o+28>>2]=f[e+28>>2];f[o+32>>2]=f[e+32>>2];A=f[e+36>>2]|0;f[o+36>>2]=A;f[o+40>>2]=z;z=o+48|0;C=o+44|0;f[C>>2]=z;f[z>>2]=0;f[o+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[e+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;jL(o,e);break}}else yL(o,g,-1);while(0);g=c&4095;e=d&4095;x=c&7;y=d&7;z=c>>>3&511;if((z|0)!=(d>>>3&511|0)){f[p>>2]=0;f[p+4>>2]=0;D=aD(p,50)|0;d=248862;E=D+50|0;do{b[D>>0]=b[d>>0]|0;D=D+1|0;d=d+1|0}while((D|0)<(E|0));bO(-215,p,248913,241836,3759);bD(p)}d=n+8|0;c=o+8|0;C=o+12|0;A=(f[c>>2]|0)+-1+(f[C>>2]|0)|0;B=f[h>>2]|0;if((B|0)<0){F=((f[d>>2]|0)+-1+(f[n+12>>2]|0)|0)/2|0;f[h>>2]=F;G=F}else G=B;B=h+4|0;if((f[B>>2]|0)<0)f[B>>2]=(A|0)/2|0;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=n;A=(f[d>>2]|0)==1;f[q>>2]=A?G:0;f[q+4>>2]=A?0:G;G=f8(p,q)|0;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=o;q=(f[c>>2]|0)==1;A=f[B>>2]|0;f[r>>2]=q?A:0;f[r+4>>2]=q?0:A;A=f8(p,r)|0;f[p>>2]=1124007936;r=p+4|0;q=p+8|0;F=p+40|0;D=r;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[F>>2]=q;H=p+48|0;I=p+44|0;f[I>>2]=H;f[H>>2]=0;f[p+52>>2]=0;f[s>>2]=1124007936;J=s+4|0;K=s+8|0;L=s+40|0;D=J;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[L>>2]=K;D=s+48|0;E=s+44|0;f[E>>2]=D;f[D>>2]=0;f[s+52>>2]=0;M=x>>>0<y>>>0?y:x;N=(M|0)>5?M:5;do if(!x){M=(y|0)==0;if(!((G|0)==5&(A|0)==5&M)){if((G&3|0)==0|(A&3|0)==0){O=26;break}if(!((G&8&A|0)!=0&(y|0)==3)){O=26;break}}P=M?8:0;M=t+8|0;f[M>>2]=0;f[M+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=p;Q=+(1<<P|0);OJ(n,t,4,Q,0.0);M=t+8|0;f[M>>2]=0;f[M+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=s;OJ(o,t,4,Q,0.0);M=P<<1;R=M;S=4;T=+(1<<M|0)*i}else O=26;while(0);do if((O|0)==26){if((f[n>>2]&4095|0)==(N|0)){y=n+36|0;x=f[y>>2]|0;if(x){M=x+12|0;f[M>>2]=(f[M>>2]|0)+1;M=p+36|0;x=f[M>>2]|0;if((x|0)!=0?(P=x+12|0,x=f[P>>2]|0,f[P>>2]=x+-1,(x|0)==1):0){kL(p);U=M}else U=M}else U=p+36|0;f[U>>2]=0;M=p+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[r>>2]|0)>0){x=f[F>>2]|0;P=0;do{f[x+(P<<2)>>2]=0;P=P+1|0;V=f[r>>2]|0}while((P|0)<(V|0));f[p>>2]=f[n>>2];if((V|0)<3)O=38;else O=40}else{f[p>>2]=f[n>>2];O=38}if((O|0)==38){P=f[n+4>>2]|0;if((P|0)<3){f[r>>2]=P;f[q>>2]=f[d>>2];f[p+12>>2]=f[n+12>>2];P=f[n+44>>2]|0;x=f[I>>2]|0;f[x>>2]=f[P>>2];f[x+4>>2]=f[P+4>>2]}else O=40}if((O|0)==40)jL(p,n);f[M>>2]=f[n+16>>2];f[p+20>>2]=f[n+20>>2];f[p+24>>2]=f[n+24>>2];f[p+28>>2]=f[n+28>>2];f[p+32>>2]=f[n+32>>2];f[U>>2]=f[y>>2]}else{P=t+8|0;f[P>>2]=0;f[P+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=p;OJ(n,t,N,1.0,0.0)}if((f[o>>2]&4095|0)!=(N|0)){P=t+8|0;f[P>>2]=0;f[P+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=s;OJ(o,t,N,1.0,0.0);R=0;S=N;T=i;break}P=o+36|0;x=f[P>>2]|0;if(x|0){W=x+12|0;f[W>>2]=(f[W>>2]|0)+1}W=s+36|0;x=f[W>>2]|0;if(x|0?(X=x+12|0,x=f[X>>2]|0,f[X>>2]=x+-1,(x|0)==1):0)kL(s);f[W>>2]=0;x=s+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[J>>2]|0)>0){X=f[L>>2]|0;Y=0;do{f[X+(Y<<2)>>2]=0;Y=Y+1|0;Z=f[J>>2]|0}while((Y|0)<(Z|0));f[s>>2]=f[o>>2];if((Z|0)<3)O=54;else O=56}else{f[s>>2]=f[o>>2];O=54}if((O|0)==54){Y=f[o+4>>2]|0;if((Y|0)<3){f[J>>2]=Y;f[K>>2]=f[c>>2];f[s+12>>2]=f[C>>2];Y=f[o+44>>2]|0;X=f[E>>2]|0;f[X>>2]=f[Y>>2];f[X+4>>2]=f[Y+4>>2]}else O=56}if((O|0)==56)jL(s,o);f[x>>2]=f[o+16>>2];f[s+20>>2]=f[o+20>>2];f[s+24>>2]=f[o+24>>2];f[s+28>>2]=f[o+28>>2];f[s+32>>2]=f[o+32>>2];f[W>>2]=f[P>>2];R=0;S=N;T=i}while(0);N=S&7|z<<3;f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=p;g8(t,g,N,v,f[h>>2]|0,G);f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=16842752;f[w+4>>2]=s;F9(v,N,e,w,f[B>>2]|0,A,T,R);R=L5b(200)|0;f[w>>2]=0;f[w+4>>2]=0;d8(R,w,t,v,g,e,N,j,k,l);l=L5b(16)|0;f[l+4>>2]=1;f[l>>2]=53340;f[l+8>>2]=R;f[a>>2]=l;f[a+4>>2]=R;R=f[v>>2]|0;if(R|0?(v=R+4|0,a=f[v>>2]|0,f[v>>2]=a+-1,(a|0)==1):0)bi[f[(f[R>>2]|0)+8>>2]&2047](R);R=f[t>>2]|0;if(R|0?(t=R+4|0,a=f[t>>2]|0,f[t>>2]=a+-1,(a|0)==1):0)bi[f[(f[R>>2]|0)+8>>2]&2047](R);R=s+36|0;a=f[R>>2]|0;if(a|0?(t=a+12|0,a=f[t>>2]|0,f[t>>2]=a+-1,(a|0)==1):0)kL(s);f[R>>2]=0;R=s+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[J>>2]|0)>0){R=f[L>>2]|0;L=0;do{f[R+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[J>>2]|0))}J=f[E>>2]|0;if((J|0)!=(D|0))UC(J);J=p+36|0;D=f[J>>2]|0;if(D|0?(E=D+12|0,D=f[E>>2]|0,f[E>>2]=D+-1,(D|0)==1):0)kL(p);f[J>>2]=0;J=p+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[r>>2]|0)>0){J=f[F>>2]|0;F=0;do{f[J+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[r>>2]|0))}r=f[I>>2]|0;if((r|0)!=(H|0))UC(r);r=o+36|0;H=f[r>>2]|0;if(H|0?(I=H+12|0,H=f[I>>2]|0,f[I>>2]=H+-1,(H|0)==1):0)kL(o);f[r>>2]=0;r=o+16|0;H=o+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[H>>2]|0)>0){r=f[o+40>>2]|0;I=0;do{f[r+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[H>>2]|0))}H=f[o+44>>2]|0;if((H|0)!=(o+48|0))UC(H);H=n+36|0;o=f[H>>2]|0;if(o|0?(I=o+12|0,o=f[I>>2]|0,f[I>>2]=o+-1,(o|0)==1):0)kL(n);f[H>>2]=0;H=n+16|0;o=n+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[o>>2]|0)>0){H=f[n+40>>2]|0;I=0;do{f[H+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[o>>2]|0))}o=f[n+44>>2]|0;if((o|0)==(n+48|0)){u=m;return}UC(o);u=m;return}function ica(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0;e=u;u=u+16|0;g=e;f[g+8>>2]=0;f[g+12>>2]=0;f[g>>2]=16842752;f[g+4>>2]=a;h=nG(g)|0;i=f[a>>2]|0;j=(h|0)==0?1:h;h=i&65535;switch(h&4095){case 0:case 4:case 5:case 6:break;default:{f[g>>2]=0;f[g+4>>2]=0;k=aD(g,52)|0;l=248941;m=k+52|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,248994,241836,3826);bD(g)}}g=c+4|0;l=f[g>>2]|0;k=f[c>>2]|0;m=l-k>>3;o=k;k=l;if(j>>>0<=m>>>0){if(j>>>0<m>>>0?(l=o+(j<<3)|0,(k|0)!=(l|0)):0)f[g>>2]=k+(~((k+-8-l|0)>>>3)<<3)}else jca(c,j-m|0);m=Y((i>>>3&511)+1<<(47696>>>(i<<1&14)&3),j)|0;j=d+4|0;i=f[j>>2]|0;l=f[d>>2]|0;k=i-l|0;g=l;l=i;if(m>>>0<=k>>>0)if(m>>>0<k>>>0?(i=g+m|0,(l|0)!=(i|0)):0){f[j>>2]=i;q=g}else q=g;else{DL(d,m-k|0);q=f[d>>2]|0}d=a+8|0;if((f[d>>2]|0)<=0){u=e;return}k=a+16|0;m=a+44|0;g=a+12|0;a=(h&4095)==0;i=0;j=0;l=f[g>>2]|0;while(1){o=(f[k>>2]|0)+(Y(f[f[m>>2]>>2]|0,i)|0)|0;a:do if((l|0)>0){if(a){r=0;s=j;t=l;while(1){v=b[o+r>>0]|0;if(!(v<<24>>24)){w=s;x=t}else{y=f[c>>2]|0;f[y+(s<<3)>>2]=r;f[y+(s<<3)+4>>2]=i;b[q+s>>0]=v;w=s+1|0;x=f[g>>2]|0}r=r+1|0;if((r|0)>=(x|0)){z=w;A=x;break a}else{s=w;t=x}}}t=f[c>>2]|0;s=0;r=j;v=l;while(1){switch(h&4095){case 5:{B=+n[o+(s<<2)>>2];if(B==0.0){C=r;D=v}else{f[t+(r<<3)>>2]=s;f[t+(r<<3)+4>>2]=i;n[q+(r<<2)>>2]=B;C=r+1|0;D=v}break}case 4:{y=f[o+(s<<2)>>2]|0;if(!y){C=r;D=v}else{f[t+(r<<3)>>2]=s;f[t+(r<<3)+4>>2]=i;f[q+(r<<2)>>2]=y;C=r+1|0;D=f[g>>2]|0}break}default:{B=+p[o+(s<<3)>>3];if(B==0.0){C=r;D=v}else{f[t+(r<<3)>>2]=s;f[t+(r<<3)+4>>2]=i;p[q+(r<<3)>>3]=B;C=r+1|0;D=v}}}s=s+1|0;if((s|0)>=(D|0)){z=C;A=D;break a}else{r=C;v=D}}}else{z=j;A=l}while(0);i=i+1|0;if((i|0)>=(f[d>>2]|0))break;else{j=z;l=A}}u=e;return}function jca(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(d-g>>3>>>0>=b>>>0){Nac(g|0,0,b<<3|0)|0;f[e>>2]=h+(b<<3);return}i=f[a>>2]|0;j=g-i>>3;g=j+b|0;k=i;if(g>>>0>536870911)c4b(a);l=d-i|0;d=l>>2;m=l>>3>>>0<268435455?(d>>>0<g>>>0?g:d):536870911;do if(m)if(m>>>0>536870911){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{n=L5b(m<<3)|0;break}else n=0;while(0);d=n+(j<<3)|0;j=n+(m<<3)|0;Nac(d|0,0,b<<3|0)|0;m=d+(b<<3)|0;if((h|0)==(k|0)){o=d;p=i}else{b=h+-8-i|0;i=h;h=d;while(1){n=i;i=i+-8|0;f[h+-8>>2]=f[i>>2];f[h+-4>>2]=f[n+-4>>2];if((i|0)==(k|0))break;else h=h+-8|0}o=d+(~(b>>>3)<<3)|0;p=f[a>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=j;if(!p)return;O5b(p);return}function kca(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;j=u;u=u+144|0;k=j;l=j+120|0;m=j+137|0;n=j+136|0;o=j+64|0;p=j+8|0;do if((yM(e)|0)==65536){q=f[e+4>>2]|0;f[o>>2]=f[q>>2];r=o+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=o+8|0;f[t>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];f[o+16>>2]=f[q+16>>2];f[o+20>>2]=f[q+20>>2];f[o+24>>2]=f[q+24>>2];f[o+28>>2]=f[q+28>>2];f[o+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[o+36>>2]=v;f[o+40>>2]=t;t=o+48|0;w=o+44|0;f[w>>2]=t;f[t>>2]=0;f[o+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];x=o;break}else{f[r>>2]=0;jL(o,q);x=o;break}}else{yL(o,e,-1);x=o}while(0);e=c&7;q=d&7;if(q>>>0<e>>>0|((d^c)&4088|0)!=0){f[l>>2]=0;f[l+4>>2]=0;y=aD(l,69)|0;z=249013;A=y+69|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,l,249083,241836,4428);bD(l)}r=f[g>>2]|0;s=g+4|0;t=f[s>>2]|0;w=o+40|0;v=f[w>>2]|0;B=f[v+4>>2]|0;C=f[v>>2]|0;v=(r|0)==-1?(B|0)/2|0:r;r=(t|0)==-1?(C|0)/2|0:t;if(!((v|0)>-1&(v|0)<(B|0)?!((r|0)<0|(r|0)>=(C|0)):0)){f[l>>2]=0;f[l+4>>2]=0;y=aD(l,52)|0;z=263653;A=y+52|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,l,263706,263722,363);bD(l)}f[g>>2]=v;f[s>>2]=r;r=(e|0)==6;v=(q|0)==6;z=r|v?6:5;f[p>>2]=1124007936;C=p+4|0;B=p+8|0;t=p+40|0;y=C;A=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(A|0));f[t>>2]=B;y=p+48|0;A=p+44|0;f[A>>2]=y;f[y>>2]=0;f[p+52>>2]=0;D=f[x>>2]&4095;if((D|0)==(z|0)){E=o+36|0;F=f[E>>2]|0;if(F){G=F+12|0;f[G>>2]=(f[G>>2]|0)+1;G=p+36|0;F=f[G>>2]|0;if((F|0)!=0?(H=F+12|0,F=f[H>>2]|0,f[H>>2]=F+-1,(F|0)==1):0){kL(p);I=G}else I=G}else I=p+36|0;f[I>>2]=0;G=p+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[C>>2]|0)>0){F=f[t>>2]|0;H=0;do{f[F+(H<<2)>>2]=0;H=H+1|0;J=f[C>>2]|0}while((H|0)<(J|0));f[p>>2]=f[x>>2];if((J|0)<3)K=24;else K=26}else{f[p>>2]=f[x>>2];K=24}if((K|0)==24){x=f[o+4>>2]|0;if((x|0)<3){f[C>>2]=x;f[B>>2]=f[o+8>>2];f[p+12>>2]=f[o+12>>2];B=f[o+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[B>>2];f[x+4>>2]=f[B+4>>2]}else K=26}if((K|0)==26)jL(p,o);f[G>>2]=f[o+16>>2];f[p+20>>2]=f[o+20>>2];f[p+24>>2]=f[o+24>>2];f[p+28>>2]=f[o+28>>2];f[p+32>>2]=f[o+32>>2];f[I>>2]=f[E>>2]}else{E=l+8|0;f[E>>2]=0;f[E+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=p;OJ(o,l,z,(D|0)==4?1.0/+(1<<i|0):1.0,0.0)}i=(e|0)==0;do if(!((d|c)&7)){D=L5b(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];lca(D,p,l,h,m,n);z=L5b(16)|0;E=z+4|0;f[E>>2]=1;f[z>>2]=55580;f[z+8>>2]=D;f[a>>2]=z;f[a+4>>2]=D;f[E>>2]=(f[E>>2]|0)+1;D=f[E>>2]|0;f[E>>2]=D+-1;if((D|0)==1)bi[f[(f[z>>2]|0)+8>>2]&2047](z)}else{z=(q|0)==2;if(i&z){D=L5b(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];mca(D,p,l,h,m,n);E=L5b(16)|0;I=E+4|0;f[I>>2]=1;f[E>>2]=55600;f[E+8>>2]=D;f[a>>2]=E;f[a+4>>2]=D;f[I>>2]=(f[I>>2]|0)+1;D=f[I>>2]|0;f[I>>2]=D+-1;if((D|0)!=1)break;bi[f[(f[E>>2]|0)+8>>2]&2047](E);break}E=(q|0)==3;if(i&E){D=L5b(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];nca(D,p,l,h,m,n);I=L5b(16)|0;G=I+4|0;f[G>>2]=1;f[I>>2]=55620;f[I+8>>2]=D;f[a>>2]=I;f[a+4>>2]=D;f[G>>2]=(f[G>>2]|0)+1;D=f[G>>2]|0;f[G>>2]=D+-1;if((D|0)==1)bi[f[(f[I>>2]|0)+8>>2]&2047](I);break}I=(q|0)==5;if(i&I){D=L5b(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];oca(D,p,l,h,m,n);G=L5b(16)|0;K=G+4|0;f[K>>2]=1;f[G>>2]=55640;f[G+8>>2]=D;f[a>>2]=G;f[a+4>>2]=D;f[K>>2]=(f[K>>2]|0)+1;D=f[K>>2]|0;f[K>>2]=D+-1;if((D|0)!=1)break;bi[f[(f[G>>2]|0)+8>>2]&2047](G);break}if(i&v){G=L5b(72)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];pca(G,p,l,h,m,n);D=L5b(16)|0;K=D+4|0;f[K>>2]=1;f[D>>2]=55660;f[D+8>>2]=G;f[a>>2]=D;f[a+4>>2]=G;f[K>>2]=(f[K>>2]|0)+1;G=f[K>>2]|0;f[K>>2]=G+-1;if((G|0)!=1)break;bi[f[(f[D>>2]|0)+8>>2]&2047](D);break}D=(e|0)==2;if(D&z){z=L5b(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];qca(z,p,l,h,m,n);G=L5b(16)|0;K=G+4|0;f[K>>2]=1;f[G>>2]=55680;f[G+8>>2]=z;f[a>>2]=G;f[a+4>>2]=z;f[K>>2]=(f[K>>2]|0)+1;z=f[K>>2]|0;f[K>>2]=z+-1;if((z|0)!=1)break;bi[f[(f[G>>2]|0)+8>>2]&2047](G);break}if(D&I){G=L5b(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];rca(G,p,l,h,m,n);z=L5b(16)|0;K=z+4|0;f[K>>2]=1;f[z>>2]=55700;f[z+8>>2]=G;f[a>>2]=z;f[a+4>>2]=G;f[K>>2]=(f[K>>2]|0)+1;G=f[K>>2]|0;f[K>>2]=G+-1;if((G|0)!=1)break;bi[f[(f[z>>2]|0)+8>>2]&2047](z);break}if(D&v){D=L5b(72)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];sca(D,p,l,h,m,n);z=L5b(16)|0;G=z+4|0;f[G>>2]=1;f[z>>2]=55720;f[z+8>>2]=D;f[a>>2]=z;f[a+4>>2]=D;f[G>>2]=(f[G>>2]|0)+1;D=f[G>>2]|0;f[G>>2]=D+-1;if((D|0)!=1)break;bi[f[(f[z>>2]|0)+8>>2]&2047](z);break}z=(e|0)==3;if(z&E){E=L5b(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];tca(E,p,l,h,m,n);D=L5b(16)|0;G=D+4|0;f[G>>2]=1;f[D>>2]=55740;f[D+8>>2]=E;f[a>>2]=D;f[a+4>>2]=E;f[G>>2]=(f[G>>2]|0)+1;E=f[G>>2]|0;f[G>>2]=E+-1;if((E|0)!=1)break;bi[f[(f[D>>2]|0)+8>>2]&2047](D);break}if(z&I){D=L5b(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];uca(D,p,l,h,m,n);E=L5b(16)|0;G=E+4|0;f[G>>2]=1;f[E>>2]=55760;f[E+8>>2]=D;f[a>>2]=E;f[a+4>>2]=D;f[G>>2]=(f[G>>2]|0)+1;D=f[G>>2]|0;f[G>>2]=D+-1;if((D|0)!=1)break;bi[f[(f[E>>2]|0)+8>>2]&2047](E);break}if(z&v){z=L5b(72)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];vca(z,p,l,h,m,n);E=L5b(16)|0;D=E+4|0;f[D>>2]=1;f[E>>2]=55780;f[E+8>>2]=z;f[a>>2]=E;f[a+4>>2]=z;f[D>>2]=(f[D>>2]|0)+1;z=f[D>>2]|0;f[D>>2]=z+-1;if((z|0)!=1)break;bi[f[(f[E>>2]|0)+8>>2]&2047](E);break}if((e|0)==5&I){I=L5b(64)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];wca(I,p,l,h,m,n);E=L5b(16)|0;z=E+4|0;f[z>>2]=1;f[E>>2]=55800;f[E+8>>2]=I;f[a>>2]=E;f[a+4>>2]=I;f[z>>2]=(f[z>>2]|0)+1;I=f[z>>2]|0;f[z>>2]=I+-1;if((I|0)==1)bi[f[(f[E>>2]|0)+8>>2]&2047](E);break}if(!(r&v)){f[k>>2]=c;f[k+4>>2]=d;hO(l,249099,k);bO(-213,l,249083,241836,4493);bD(l);f[a>>2]=0;f[a+4>>2]=0;break}E=L5b(72)|0;f[l>>2]=f[g>>2];f[l+4>>2]=f[s>>2];xca(E,p,l,h,m,n);I=L5b(16)|0;z=I+4|0;f[z>>2]=1;f[I>>2]=55820;f[I+8>>2]=E;f[a>>2]=I;f[a+4>>2]=E;f[z>>2]=(f[z>>2]|0)+1;E=f[z>>2]|0;f[z>>2]=E+-1;if((E|0)==1)bi[f[(f[I>>2]|0)+8>>2]&2047](I)}while(0);a=p+36|0;n=f[a>>2]|0;if(n|0?(m=n+12|0,n=f[m>>2]|0,f[m>>2]=n+-1,(n|0)==1):0)kL(p);f[a>>2]=0;a=p+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[C>>2]|0)>0){a=f[t>>2]|0;t=0;do{f[a+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[C>>2]|0))}C=f[A>>2]|0;if((C|0)!=(y|0))UC(C);C=o+36|0;y=f[C>>2]|0;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)kL(o);f[C>>2]=0;C=o+16|0;y=o+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[y>>2]|0)>0){C=f[w>>2]|0;w=0;do{f[C+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[y>>2]|0))}y=f[o+44>>2]|0;if((y|0)==(o+48|0)){u=j;return}UC(y);u=j;return}function lca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=56128;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=aD(g,36)|0;a=249276;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));bO(-215,g,249313,241836,3887);bD(g)}ica(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Y2(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function mca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=56104;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=aD(g,36)|0;a=249276;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));bO(-215,g,249313,241836,3887);bD(g)}ica(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Y2(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function nca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=56080;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=aD(g,36)|0;a=249276;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));bO(-215,g,249313,241836,3887);bD(g)}ica(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Y2(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function oca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=56056;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=aD(g,36)|0;a=249276;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));bO(-215,g,249313,241836,3887);bD(g)}ica(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Y2(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function pca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=56032;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;o=aD(g,36)|0;a=249276;q=o+36|0;do{b[o>>0]=b[a>>0]|0;o=o+1|0;a=a+1|0}while((o|0)<(q|0));bO(-215,g,249313,241836,3887);bD(g)}ica(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Y2(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function qca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=56008;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=aD(g,36)|0;a=249276;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));bO(-215,g,249313,241836,3887);bD(g)}ica(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Y2(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function rca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=55984;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=aD(g,36)|0;a=249276;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));bO(-215,g,249313,241836,3887);bD(g)}ica(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Y2(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function sca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=55960;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;o=aD(g,36)|0;a=249276;q=o+36|0;do{b[o>>0]=b[a>>0]|0;o=o+1|0;a=a+1|0}while((o|0)<(q|0));bO(-215,g,249313,241836,3887);bD(g)}ica(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Y2(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function tca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=55936;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=aD(g,36)|0;a=249276;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));bO(-215,g,249313,241836,3887);bD(g)}ica(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Y2(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function uca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=55912;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=aD(g,36)|0;a=249276;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));bO(-215,g,249313,241836,3887);bD(g)}ica(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Y2(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function vca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=55888;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;o=aD(g,36)|0;a=249276;q=o+36|0;do{b[o>>0]=b[a>>0]|0;o=o+1|0;a=a+1|0}while((o|0)<(q|0));bO(-215,g,249313,241836,3887);bD(g)}ica(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Y2(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function wca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=55864;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;o=a+48|0;p=j;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;n[a+56>>2]=e;if((f[c>>2]&4095|0)!=5){f[g>>2]=0;f[g+4>>2]=0;p=aD(g,36)|0;a=249276;q=p+36|0;do{b[p>>0]=b[a>>0]|0;p=p+1|0;a=a+1|0}while((p|0)<(q|0));bO(-215,g,249313,241836,3887);bD(g)}ica(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[o>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Y2(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[o>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function xca(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0;h=u;u=u+16|0;g=h;i=a+4|0;f[i>>2]=-1;f[i+4>>2]=-1;f[i+8>>2]=-1;f[i+12>>2]=-1;f[a>>2]=55840;j=a+20|0;k=a+24|0;l=a+32|0;m=a+44|0;n=a+48|0;o=j;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;r=f[d>>2]|0;f[i>>2]=f[d+4>>2];f[a+8>>2]=r;p[a+56>>3]=e;if((f[c>>2]&4095|0)!=6){f[g>>2]=0;f[g+4>>2]=0;o=aD(g,36)|0;a=249276;q=o+36|0;do{b[o>>0]=b[a>>0]|0;o=o+1|0;a=a+1|0}while((o|0)<(q|0));bO(-215,g,249313,241836,3887);bD(g)}ica(c,j,l);l=(f[k>>2]|0)-(f[j>>2]|0)>>3;j=f[n>>2]|0;k=f[m>>2]|0;c=j-k>>2;g=j;if(l>>>0>c>>>0){Y2(m,l-c|0);u=h;return}if(l>>>0>=c>>>0){u=h;return}c=k+(l<<2)|0;if((g|0)==(c|0)){u=h;return}f[n>>2]=g+(~((g+-4-c|0)>>>2)<<2);u=h;return}function yca(a){a=a|0;O5b(a);return}function zca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Aca(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55840;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function Bca(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55840;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b){O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function Cca(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0;i=+p[a+56>>3];j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=f[a+44>>2]|0;m=(f[a+24>>2]|0)-j|0;a=m>>3;n=Y(h,g)|0;if((e|0)<=0)return;g=(m|0)>0;m=n+-4|0;o=(n|0)<4;q=n&-4;r=b;b=c;c=e;while(1){if(g){e=0;do{s=(f[r+(f[j+(e<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(e<<3)>>2]|0,h)|0)<<3)|0;f[l+(e<<2)>>2]=s;e=e+1|0}while((e|0)<(a|0))}a:do if(o)t=0;else{if(g)u=0;else{e=0;while(1){p[b+(e<<3)>>3]=i;p[b+((e|1)<<3)>>3]=i;p[b+((e|2)<<3)>>3]=i;p[b+((e|3)<<3)>>3]=i;e=e+4|0;if((e|0)>(m|0)){t=q;break a}}}do{v=i;w=i;x=i;y=i;e=0;do{s=(f[l+(e<<2)>>2]|0)+(u<<3)|0;z=+p[k+(e<<3)>>3];y=y+z*+p[s>>3];x=x+z*+p[s+8>>3];w=w+z*+p[s+16>>3];v=v+z*+p[s+24>>3];e=e+1|0}while((e|0)<(a|0));p[b+(u<<3)>>3]=y;p[b+((u|1)<<3)>>3]=x;p[b+((u|2)<<3)>>3]=w;p[b+((u|3)<<3)>>3]=v;u=u+4|0}while((u|0)<=(m|0));t=q}while(0);b:do if((t|0)<(n|0)){if(g)A=t;else{e=t;while(1){p[b+(e<<3)>>3]=i;e=e+1|0;if((e|0)==(n|0))break b}}do{z=i;e=0;do{z=z+ +p[k+(e<<3)>>3]*+p[(f[l+(e<<2)>>2]|0)+(A<<3)>>3];e=e+1|0}while((e|0)<(a|0));p[b+(A<<3)>>3]=z;A=A+1|0}while((A|0)!=(n|0))}while(0);if((c|0)>1){r=r+4|0;b=b+d|0;c=c+-1|0}else break}return}function Dca(a){a=a|0;O5b(a);return}function Eca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Fca(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55864;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function Gca(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55864;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b){O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function Hca(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0;i=+n[a+56>>2];j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=f[a+44>>2]|0;m=(f[a+24>>2]|0)-j|0;a=m>>3;o=Y(h,g)|0;if((e|0)<=0)return;g=(m|0)>0;m=o+-4|0;p=(o|0)<4;q=o&-4;r=b;b=c;c=e;while(1){if(g){e=0;do{s=(f[r+(f[j+(e<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(e<<3)>>2]|0,h)|0)<<2)|0;f[l+(e<<2)>>2]=s;e=e+1|0}while((e|0)<(a|0))}a:do if(p)t=0;else{if(g)u=0;else{e=0;while(1){n[b+(e<<2)>>2]=i;n[b+((e|1)<<2)>>2]=i;n[b+((e|2)<<2)>>2]=i;n[b+((e|3)<<2)>>2]=i;e=e+4|0;if((e|0)>(m|0)){t=q;break a}}}do{v=i;w=i;x=i;y=i;e=0;do{s=(f[l+(e<<2)>>2]|0)+(u<<2)|0;z=+n[k+(e<<2)>>2];y=y+z*+n[s>>2];x=x+z*+n[s+4>>2];w=w+z*+n[s+8>>2];v=v+z*+n[s+12>>2];e=e+1|0}while((e|0)<(a|0));n[b+(u<<2)>>2]=y;n[b+((u|1)<<2)>>2]=x;n[b+((u|2)<<2)>>2]=w;n[b+((u|3)<<2)>>2]=v;u=u+4|0}while((u|0)<=(m|0));t=q}while(0);b:do if((t|0)<(o|0)){if(g)A=t;else{e=t;while(1){n[b+(e<<2)>>2]=i;e=e+1|0;if((e|0)==(o|0))break b}}do{z=i;e=0;do{z=z+ +n[k+(e<<2)>>2]*+n[(f[l+(e<<2)>>2]|0)+(A<<2)>>2];e=e+1|0}while((e|0)<(a|0));n[b+(A<<2)>>2]=z;A=A+1|0}while((A|0)!=(o|0))}while(0);if((c|0)>1){r=r+4|0;b=b+d|0;c=c+-1|0}else break}return}function Ica(a){a=a|0;O5b(a);return}function Jca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Kca(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55888;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function Lca(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55888;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b){O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function Mca(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+p[a+56>>3];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;n=(f[a+24>>2]|0)-k|0;a=n>>3;o=Y(i,h)|0;if((g|0)<=0)return;h=(n|0)>0;n=o+-4|0;q=(o|0)<4;r=o&-4;s=b;b=c;c=g;while(1){if(h){g=0;do{t=(f[s+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(g<<3)>>2]|0,i)|0)<<1)|0;f[m+(g<<2)>>2]=t;g=g+1|0}while((g|0)<(a|0))}a:do if(q)u=0;else{if(h)v=0;else{g=0;while(1){p[b+(g<<3)>>3]=j;p[b+((g|1)<<3)>>3]=j;p[b+((g|2)<<3)>>3]=j;p[b+((g|3)<<3)>>3]=j;g=g+4|0;if((g|0)>(n|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;g=0;do{t=(f[m+(g<<2)>>2]|0)+(v<<1)|0;A=+p[l+(g<<3)>>3];z=z+A*+(d[t>>1]|0);y=y+A*+(d[t+2>>1]|0);x=x+A*+(d[t+4>>1]|0);w=w+A*+(d[t+6>>1]|0);g=g+1|0}while((g|0)<(a|0));p[b+(v<<3)>>3]=z;p[b+((v|1)<<3)>>3]=y;p[b+((v|2)<<3)>>3]=x;p[b+((v|3)<<3)>>3]=w;v=v+4|0}while((v|0)<=(n|0));u=r}while(0);b:do if((u|0)<(o|0)){if(h)B=u;else{g=u;while(1){p[b+(g<<3)>>3]=j;g=g+1|0;if((g|0)==(o|0))break b}}do{A=j;g=0;do{A=A+ +p[l+(g<<3)>>3]*+(d[(f[m+(g<<2)>>2]|0)+(B<<1)>>1]|0);g=g+1|0}while((g|0)<(a|0));p[b+(B<<3)>>3]=A;B=B+1|0}while((B|0)!=(o|0))}while(0);if((c|0)>1){s=s+4|0;b=b+e|0;c=c+-1|0}else break}return}function Nca(a){a=a|0;O5b(a);return}function Oca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Pca(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55912;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function Qca(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55912;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b){O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function Rca(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(i,h)|0;if((g|0)<=0)return;h=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=b;b=c;c=g;while(1){if(h){g=0;do{t=(f[s+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(g<<3)>>2]|0,i)|0)<<1)|0;f[m+(g<<2)>>2]=t;g=g+1|0}while((g|0)<(a|0))}a:do if(q)u=0;else{if(h)v=0;else{g=0;while(1){n[b+(g<<2)>>2]=j;n[b+((g|1)<<2)>>2]=j;n[b+((g|2)<<2)>>2]=j;n[b+((g|3)<<2)>>2]=j;g=g+4|0;if((g|0)>(o|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;g=0;do{t=(f[m+(g<<2)>>2]|0)+(v<<1)|0;A=+n[l+(g<<2)>>2];z=z+A*+(d[t>>1]|0);y=y+A*+(d[t+2>>1]|0);x=x+A*+(d[t+4>>1]|0);w=w+A*+(d[t+6>>1]|0);g=g+1|0}while((g|0)<(a|0));n[b+(v<<2)>>2]=z;n[b+((v|1)<<2)>>2]=y;n[b+((v|2)<<2)>>2]=x;n[b+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(h)B=u;else{g=u;while(1){n[b+(g<<2)>>2]=j;g=g+1|0;if((g|0)==(p|0))break b}}do{A=j;g=0;do{A=A+ +n[l+(g<<2)>>2]*+(d[(f[m+(g<<2)>>2]|0)+(B<<1)>>1]|0);g=g+1|0}while((g|0)<(a|0));n[b+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(p|0))}while(0);if((c|0)>1){s=s+4|0;b=b+e|0;c=c+-1|0}else break}return}function Sca(a){a=a|0;O5b(a);return}function Tca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Uca(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55936;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function Vca(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55936;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b){O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function Wca(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(i,h)|0;if((g|0)<=0)return;h=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=b;b=c;c=g;while(1){if(h){g=0;do{t=(f[s+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(g<<3)>>2]|0,i)|0)<<1)|0;f[m+(g<<2)>>2]=t;g=g+1|0}while((g|0)<(a|0))}a:do if(q)u=0;else{if(h)v=0;else{g=LVb(j)|0;t=((g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768)&65535;g=0;while(1){d[b+(g<<1)>>1]=t;d[b+((g|1)<<1)>>1]=t;d[b+((g|2)<<1)>>1]=t;d[b+((g|3)<<1)>>1]=t;g=g+4|0;if((g|0)>(o|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;g=0;do{t=(f[m+(g<<2)>>2]|0)+(v<<1)|0;A=+n[l+(g<<2)>>2];z=z+A*+(d[t>>1]|0);y=y+A*+(d[t+2>>1]|0);x=x+A*+(d[t+4>>1]|0);w=w+A*+(d[t+6>>1]|0);g=g+1|0}while((g|0)<(a|0));g=LVb(z)|0;d[b+(v<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=LVb(y)|0;d[b+((v|1)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=LVb(x)|0;d[b+((v|2)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=LVb(w)|0;d[b+((v|3)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(h)B=u;else{g=LVb(j)|0;t=((g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768)&65535;g=u;while(1){d[b+(g<<1)>>1]=t;g=g+1|0;if((g|0)==(p|0))break b}}do{A=j;g=0;do{A=A+ +n[l+(g<<2)>>2]*+(d[(f[m+(g<<2)>>2]|0)+(B<<1)>>1]|0);g=g+1|0}while((g|0)<(a|0));g=LVb(A)|0;d[b+(B<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;B=B+1|0}while((B|0)!=(p|0))}while(0);if((c|0)>1){s=s+4|0;b=b+e|0;c=c+-1|0}else break}return}function Xca(a){a=a|0;O5b(a);return}function Yca(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Zca(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55960;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function _ca(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55960;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b){O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function $ca(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;i=+p[a+56>>3];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;n=(f[a+24>>2]|0)-k|0;a=n>>3;o=Y(h,g)|0;if((e|0)<=0)return;g=(n|0)>0;n=o+-4|0;q=(o|0)<4;r=o&-4;s=b;b=c;c=e;while(1){if(g){e=0;do{t=(f[s+(f[k+(e<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(e<<3)>>2]|0,h)|0)<<1)|0;f[m+(e<<2)>>2]=t;e=e+1|0}while((e|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{e=0;while(1){p[b+(e<<3)>>3]=i;p[b+((e|1)<<3)>>3]=i;p[b+((e|2)<<3)>>3]=i;p[b+((e|3)<<3)>>3]=i;e=e+4|0;if((e|0)>(n|0)){u=r;break a}}}do{w=i;x=i;y=i;z=i;e=0;do{t=(f[m+(e<<2)>>2]|0)+(v<<1)|0;A=+p[l+(e<<3)>>3];z=z+A*+(j[t>>1]|0);y=y+A*+(j[t+2>>1]|0);x=x+A*+(j[t+4>>1]|0);w=w+A*+(j[t+6>>1]|0);e=e+1|0}while((e|0)<(a|0));p[b+(v<<3)>>3]=z;p[b+((v|1)<<3)>>3]=y;p[b+((v|2)<<3)>>3]=x;p[b+((v|3)<<3)>>3]=w;v=v+4|0}while((v|0)<=(n|0));u=r}while(0);b:do if((u|0)<(o|0)){if(g)B=u;else{e=u;while(1){p[b+(e<<3)>>3]=i;e=e+1|0;if((e|0)==(o|0))break b}}do{A=i;e=0;do{A=A+ +p[l+(e<<3)>>3]*+(j[(f[m+(e<<2)>>2]|0)+(B<<1)>>1]|0);e=e+1|0}while((e|0)<(a|0));p[b+(B<<3)>>3]=A;B=B+1|0}while((B|0)!=(o|0))}while(0);if((c|0)>1){s=s+4|0;b=b+d|0;c=c+-1|0}else break}return}function ada(a){a=a|0;O5b(a);return}function bda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function cda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55984;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function dda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=55984;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b){O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function eda(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;i=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(h,g)|0;if((e|0)<=0)return;g=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=b;b=c;c=e;while(1){if(g){e=0;do{t=(f[s+(f[k+(e<<3)+4>>2]<<2)>>2]|0)+((Y(f[k+(e<<3)>>2]|0,h)|0)<<1)|0;f[m+(e<<2)>>2]=t;e=e+1|0}while((e|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{e=0;while(1){n[b+(e<<2)>>2]=i;n[b+((e|1)<<2)>>2]=i;n[b+((e|2)<<2)>>2]=i;n[b+((e|3)<<2)>>2]=i;e=e+4|0;if((e|0)>(o|0)){u=r;break a}}}do{w=i;x=i;y=i;z=i;e=0;do{t=(f[m+(e<<2)>>2]|0)+(v<<1)|0;A=+n[l+(e<<2)>>2];z=z+A*+(j[t>>1]|0);y=y+A*+(j[t+2>>1]|0);x=x+A*+(j[t+4>>1]|0);w=w+A*+(j[t+6>>1]|0);e=e+1|0}while((e|0)<(a|0));n[b+(v<<2)>>2]=z;n[b+((v|1)<<2)>>2]=y;n[b+((v|2)<<2)>>2]=x;n[b+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(g)B=u;else{e=u;while(1){n[b+(e<<2)>>2]=i;e=e+1|0;if((e|0)==(p|0))break b}}do{A=i;e=0;do{A=A+ +n[l+(e<<2)>>2]*+(j[(f[m+(e<<2)>>2]|0)+(B<<1)>>1]|0);e=e+1|0}while((e|0)<(a|0));n[b+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(p|0))}while(0);if((c|0)>1){s=s+4|0;b=b+d|0;c=c+-1|0}else break}return}function fda(a){a=a|0;O5b(a);return}function gda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56008;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function ida(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56008;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b){O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function jda(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(i,h)|0;if((g|0)<=0)return;h=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=b;b=c;c=g;while(1){if(h){g=0;do{u=(f[t+(f[l+(g<<3)+4>>2]<<2)>>2]|0)+((Y(f[l+(g<<3)>>2]|0,i)|0)<<1)|0;f[o+(g<<2)>>2]=u;g=g+1|0}while((g|0)<(a|0))}a:do if(r)v=0;else{if(h)w=0;else{g=LVb(k)|0;u=(g>>>0<65536?g:(g|0)>0?65535:0)&65535;g=0;while(1){d[b+(g<<1)>>1]=u;d[b+((g|1)<<1)>>1]=u;d[b+((g|2)<<1)>>1]=u;d[b+((g|3)<<1)>>1]=u;g=g+4|0;if((g|0)>(p|0)){v=s;break a}}}do{x=k;y=k;z=k;A=k;g=0;do{u=(f[o+(g<<2)>>2]|0)+(w<<1)|0;B=+n[m+(g<<2)>>2];A=A+B*+(j[u>>1]|0);z=z+B*+(j[u+2>>1]|0);y=y+B*+(j[u+4>>1]|0);x=x+B*+(j[u+6>>1]|0);g=g+1|0}while((g|0)<(a|0));g=LVb(A)|0;d[b+(w<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=LVb(z)|0;d[b+((w|1)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=LVb(y)|0;d[b+((w|2)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=LVb(x)|0;d[b+((w|3)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(h)C=v;else{g=LVb(k)|0;u=(g>>>0<65536?g:(g|0)>0?65535:0)&65535;g=v;while(1){d[b+(g<<1)>>1]=u;g=g+1|0;if((g|0)==(q|0))break b}}do{B=k;g=0;do{B=B+ +n[m+(g<<2)>>2]*+(j[(f[o+(g<<2)>>2]|0)+(C<<1)>>1]|0);g=g+1|0}while((g|0)<(a|0));g=LVb(B)|0;d[b+(C<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;C=C+1|0}while((C|0)!=(q|0))}while(0);if((c|0)>1){t=t+4|0;b=b+e|0;c=c+-1|0}else break}return}function kda(a){a=a|0;O5b(a);return}function lda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function mda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56032;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function nda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56032;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b){O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function oda(a,b,c,d,e,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+p[a+56>>3];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;n=(f[a+24>>2]|0)-k|0;a=n>>3;o=Y(i,g)|0;if((e|0)<=0)return;g=(n|0)>0;n=o+-4|0;q=(o|0)<4;r=o&-4;s=b;b=c;c=e;while(1){if(g){e=0;do{t=(f[s+(f[k+(e<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(e<<3)>>2]|0,i)|0)|0;f[m+(e<<2)>>2]=t;e=e+1|0}while((e|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{e=0;while(1){p[b+(e<<3)>>3]=j;p[b+((e|1)<<3)>>3]=j;p[b+((e|2)<<3)>>3]=j;p[b+((e|3)<<3)>>3]=j;e=e+4|0;if((e|0)>(n|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;e=0;do{t=(f[m+(e<<2)>>2]|0)+v|0;A=+p[l+(e<<3)>>3];z=z+A*+(h[t>>0]|0);y=y+A*+(h[t+1>>0]|0);x=x+A*+(h[t+2>>0]|0);w=w+A*+(h[t+3>>0]|0);e=e+1|0}while((e|0)<(a|0));p[b+(v<<3)>>3]=z;p[b+((v|1)<<3)>>3]=y;p[b+((v|2)<<3)>>3]=x;p[b+((v|3)<<3)>>3]=w;v=v+4|0}while((v|0)<=(n|0));u=r}while(0);b:do if((u|0)<(o|0)){if(g)B=u;else{e=u;while(1){p[b+(e<<3)>>3]=j;e=e+1|0;if((e|0)==(o|0))break b}}do{A=j;e=0;do{A=A+ +p[l+(e<<3)>>3]*+(h[(f[m+(e<<2)>>2]|0)+B>>0]|0);e=e+1|0}while((e|0)<(a|0));p[b+(B<<3)>>3]=A;B=B+1|0}while((B|0)!=(o|0))}while(0);if((c|0)>1){s=s+4|0;b=b+d|0;c=c+-1|0}else break}return}function pda(a){a=a|0;O5b(a);return}function qda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function rda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56056;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function sda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56056;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b){O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function tda(a,b,c,d,e,g,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;j=+n[a+56>>2];k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=f[a+44>>2]|0;o=(f[a+24>>2]|0)-k|0;a=o>>3;p=Y(i,g)|0;if((e|0)<=0)return;g=(o|0)>0;o=p+-4|0;q=(p|0)<4;r=p&-4;s=b;b=c;c=e;while(1){if(g){e=0;do{t=(f[s+(f[k+(e<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(e<<3)>>2]|0,i)|0)|0;f[m+(e<<2)>>2]=t;e=e+1|0}while((e|0)<(a|0))}a:do if(q)u=0;else{if(g)v=0;else{e=0;while(1){n[b+(e<<2)>>2]=j;n[b+((e|1)<<2)>>2]=j;n[b+((e|2)<<2)>>2]=j;n[b+((e|3)<<2)>>2]=j;e=e+4|0;if((e|0)>(o|0)){u=r;break a}}}do{w=j;x=j;y=j;z=j;e=0;do{t=(f[m+(e<<2)>>2]|0)+v|0;A=+n[l+(e<<2)>>2];z=z+A*+(h[t>>0]|0);y=y+A*+(h[t+1>>0]|0);x=x+A*+(h[t+2>>0]|0);w=w+A*+(h[t+3>>0]|0);e=e+1|0}while((e|0)<(a|0));n[b+(v<<2)>>2]=z;n[b+((v|1)<<2)>>2]=y;n[b+((v|2)<<2)>>2]=x;n[b+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(o|0));u=r}while(0);b:do if((u|0)<(p|0)){if(g)B=u;else{e=u;while(1){n[b+(e<<2)>>2]=j;e=e+1|0;if((e|0)==(p|0))break b}}do{A=j;e=0;do{A=A+ +n[l+(e<<2)>>2]*+(h[(f[m+(e<<2)>>2]|0)+B>>0]|0);e=e+1|0}while((e|0)<(a|0));n[b+(B<<2)>>2]=A;B=B+1|0}while((B|0)!=(p|0))}while(0);if((c|0)>1){s=s+4|0;b=b+d|0;c=c+-1|0}else break}return}function uda(a){a=a|0;O5b(a);return}function vda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function wda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56080;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function xda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56080;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b){O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function yda(a,b,c,e,g,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(j,i)|0;if((g|0)<=0)return;i=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=b;b=c;c=g;while(1){if(i){g=0;do{u=(f[t+(f[l+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[l+(g<<3)>>2]|0,j)|0)|0;f[o+(g<<2)>>2]=u;g=g+1|0}while((g|0)<(a|0))}a:do if(r)v=0;else{if(i)w=0;else{g=LVb(k)|0;u=((g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768)&65535;g=0;while(1){d[b+(g<<1)>>1]=u;d[b+((g|1)<<1)>>1]=u;d[b+((g|2)<<1)>>1]=u;d[b+((g|3)<<1)>>1]=u;g=g+4|0;if((g|0)>(p|0)){v=s;break a}}}do{x=k;y=k;z=k;A=k;g=0;do{u=(f[o+(g<<2)>>2]|0)+w|0;B=+n[m+(g<<2)>>2];A=A+B*+(h[u>>0]|0);z=z+B*+(h[u+1>>0]|0);y=y+B*+(h[u+2>>0]|0);x=x+B*+(h[u+3>>0]|0);g=g+1|0}while((g|0)<(a|0));g=LVb(A)|0;d[b+(w<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=LVb(z)|0;d[b+((w|1)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=LVb(y)|0;d[b+((w|2)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;g=LVb(x)|0;d[b+((w|3)<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(i)C=v;else{g=LVb(k)|0;u=((g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768)&65535;g=v;while(1){d[b+(g<<1)>>1]=u;g=g+1|0;if((g|0)==(q|0))break b}}do{B=k;g=0;do{B=B+ +n[m+(g<<2)>>2]*+(h[(f[o+(g<<2)>>2]|0)+C>>0]|0);g=g+1|0}while((g|0)<(a|0));g=LVb(B)|0;d[b+(C<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;C=C+1|0}while((C|0)!=(q|0))}while(0);if((c|0)>1){t=t+4|0;b=b+e|0;c=c+-1|0}else break}return}function zda(a){a=a|0;O5b(a);return}function Ada(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Bda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56104;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function Cda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56104;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b){O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function Dda(a,b,c,e,g,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(j,i)|0;if((g|0)<=0)return;i=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=b;b=c;c=g;while(1){if(i){g=0;do{u=(f[t+(f[l+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[l+(g<<3)>>2]|0,j)|0)|0;f[o+(g<<2)>>2]=u;g=g+1|0}while((g|0)<(a|0))}a:do if(r)v=0;else{if(i)w=0;else{g=LVb(k)|0;u=(g>>>0<65536?g:(g|0)>0?65535:0)&65535;g=0;while(1){d[b+(g<<1)>>1]=u;d[b+((g|1)<<1)>>1]=u;d[b+((g|2)<<1)>>1]=u;d[b+((g|3)<<1)>>1]=u;g=g+4|0;if((g|0)>(p|0)){v=s;break a}}}do{x=k;y=k;z=k;A=k;g=0;do{u=(f[o+(g<<2)>>2]|0)+w|0;B=+n[m+(g<<2)>>2];A=A+B*+(h[u>>0]|0);z=z+B*+(h[u+1>>0]|0);y=y+B*+(h[u+2>>0]|0);x=x+B*+(h[u+3>>0]|0);g=g+1|0}while((g|0)<(a|0));g=LVb(A)|0;d[b+(w<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=LVb(z)|0;d[b+((w|1)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=LVb(y)|0;d[b+((w|2)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;g=LVb(x)|0;d[b+((w|3)<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(i)C=v;else{g=LVb(k)|0;u=(g>>>0<65536?g:(g|0)>0?65535:0)&65535;g=v;while(1){d[b+(g<<1)>>1]=u;g=g+1|0;if((g|0)==(q|0))break b}}do{B=k;g=0;do{B=B+ +n[m+(g<<2)>>2]*+(h[(f[o+(g<<2)>>2]|0)+C>>0]|0);g=g+1|0}while((g|0)<(a|0));g=LVb(B)|0;d[b+(C<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;C=C+1|0}while((C|0)!=(q|0))}while(0);if((c|0)>1){t=t+4|0;b=b+e|0;c=c+-1|0}else break}return}function Eda(a){a=a|0;O5b(a);return}function Fda(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Gda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56128;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b)return;d=a+24|0;a=f[d>>2]|0;if((a|0)!=(b|0))f[d>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function Hda(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=56128;b=f[a+44>>2]|0;if(b|0){c=a+48|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+32>>2]|0;if(b|0){d=a+36|0;if((f[d>>2]|0)!=(b|0))f[d>>2]=b;O5b(b)}b=f[a+20>>2]|0;if(!b){O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function Ida(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0;k=+n[a+56>>2];l=f[a+20>>2]|0;m=f[a+32>>2]|0;o=f[a+44>>2]|0;p=(f[a+24>>2]|0)-l|0;a=p>>3;q=Y(j,i)|0;if((g|0)<=0)return;i=(p|0)>0;p=q+-4|0;r=(q|0)<4;s=q&-4;t=c;c=d;d=g;while(1){if(i){g=0;do{u=(f[t+(f[l+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[l+(g<<3)>>2]|0,j)|0)|0;f[o+(g<<2)>>2]=u;g=g+1|0}while((g|0)<(a|0))}a:do if(r)v=0;else{if(i)w=0;else{g=LVb(k)|0;u=(g>>>0<256?g:(g|0)>0?255:0)&255;g=0;while(1){b[c+g>>0]=u;b[c+(g|1)>>0]=u;b[c+(g|2)>>0]=u;b[c+(g|3)>>0]=u;g=g+4|0;if((g|0)>(p|0)){v=s;break a}}}do{x=k;y=k;z=k;A=k;g=0;do{u=(f[o+(g<<2)>>2]|0)+w|0;B=+n[m+(g<<2)>>2];A=A+B*+(h[u>>0]|0);z=z+B*+(h[u+1>>0]|0);y=y+B*+(h[u+2>>0]|0);x=x+B*+(h[u+3>>0]|0);g=g+1|0}while((g|0)<(a|0));g=LVb(A)|0;b[c+w>>0]=g>>>0<256?g:(g|0)>0?255:0;g=LVb(z)|0;b[c+(w|1)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=LVb(y)|0;b[c+(w|2)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=LVb(x)|0;b[c+(w|3)>>0]=g>>>0<256?g:(g|0)>0?255:0;w=w+4|0}while((w|0)<=(p|0));v=s}while(0);b:do if((v|0)<(q|0)){if(i)C=v;else{g=LVb(k)|0;u=(g>>>0<256?g:(g|0)>0?255:0)&255;g=v;while(1){b[c+g>>0]=u;g=g+1|0;if((g|0)==(q|0))break b}}do{B=k;g=0;do{B=B+ +n[m+(g<<2)>>2]*+(h[(f[o+(g<<2)>>2]|0)+C>>0]|0);g=g+1|0}while((g|0)<(a|0));g=LVb(B)|0;b[c+C>>0]=g>>>0<256?g:(g|0)>0?255:0;C=C+1|0}while((C|0)!=(q|0))}while(0);if((d|0)>1){t=t+4|0;c=c+e|0;d=d+-1|0}else break}return}function Jda(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;l=u;u=u+160|0;m=l+96|0;n=l+40|0;o=l+32|0;p=l+8|0;q=l+24|0;r=l;do if((yM(e)|0)==65536){s=f[e+4>>2]|0;f[m>>2]=f[s>>2];t=m+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=m+8|0;f[w>>2]=f[s+8>>2];f[m+12>>2]=f[s+12>>2];f[m+16>>2]=f[s+16>>2];f[m+20>>2]=f[s+20>>2];f[m+24>>2]=f[s+24>>2];f[m+28>>2]=f[s+28>>2];f[m+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[m+36>>2]=x;f[m+40>>2]=w;w=m+48|0;y=m+44|0;f[y>>2]=w;f[w>>2]=0;f[m+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;jL(m,s);break}}else yL(m,e,-1);while(0);e=c&4095;s=d&4095;if((d^c)&4088|0){f[n>>2]=0;f[n+4>>2]=0;c=aD(n,50)|0;d=248862;t=c+50|0;do{b[c>>0]=b[d>>0]|0;c=c+1|0;d=d+1|0}while((c|0)<(t|0));bO(-215,n,251146,241836,4509);bD(n)}f[n>>2]=f[m>>2];d=n+4|0;c=m+4|0;t=f[c>>2]|0;f[d>>2]=t;v=n+8|0;f[v>>2]=f[m+8>>2];f[n+12>>2]=f[m+12>>2];w=n+16|0;y=m+16|0;f[w>>2]=f[y>>2];f[n+20>>2]=f[m+20>>2];f[n+24>>2]=f[m+24>>2];f[n+28>>2]=f[m+28>>2];f[n+32>>2]=f[m+32>>2];x=n+36|0;z=m+36|0;A=f[z>>2]|0;f[x>>2]=A;B=n+40|0;f[B>>2]=v;v=n+48|0;C=n+44|0;f[C>>2]=v;f[v>>2]=0;f[n+52>>2]=0;if(!A)D=t;else{t=A+12|0;f[t>>2]=(f[t>>2]|0)+1;D=f[c>>2]|0}if((D|0)<3){D=f[m+44>>2]|0;t=f[C>>2]|0;f[t>>2]=f[D>>2];f[t+4>>2]=f[D+4>>2]}else{f[d>>2]=0;jL(n,m)}f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=n;f[q>>2]=f[g>>2];f[q+4>>2]=f[g+4>>2];kca(o,e,s,p,q,h,0);f[p>>2]=0;f[p+4>>2]=0;f[r>>2]=0;f[r+4>>2]=0;q=L5b(200)|0;d8(q,o,p,r,e,s,e,i,j,k);k=L5b(16)|0;f[k+4>>2]=1;f[k>>2]=53340;f[k+8>>2]=q;f[a>>2]=k;f[a+4>>2]=q;q=f[o>>2]|0;if(q|0?(o=q+4|0,a=f[o>>2]|0,f[o>>2]=a+-1,(a|0)==1):0)bi[f[(f[q>>2]|0)+8>>2]&2047](q);q=f[x>>2]|0;if(q|0?(a=q+12|0,q=f[a>>2]|0,f[a>>2]=q+-1,(q|0)==1):0)kL(n);f[x>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[d>>2]|0)>0){w=f[B>>2]|0;B=0;do{f[w+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[d>>2]|0))}d=f[C>>2]|0;if((d|0)!=(v|0))UC(d);d=f[z>>2]|0;if(d|0?(v=d+12|0,d=f[v>>2]|0,f[v>>2]=d+-1,(d|0)==1):0)kL(m);f[z>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[c>>2]|0)>0){y=f[m+40>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[c>>2]|0))}c=f[m+44>>2]|0;if((c|0)==(m+48|0)){u=l;return}UC(c);u=l;return}function Kda(a,b,c,d,e,g,h,i,j,k,l,m,n,o,q,r,s,t,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;q=q|0;r=r|0;s=s|0;t=t|0;v=v|0;w=+w;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;y=u;u=u+496|0;z=y+432|0;A=y+56|0;B=y+376|0;C=y+320|0;D=y+264|0;E=y;F=y+208|0;G=y+200|0;H=y+144|0;I=y+136|0;J=y+128|0;K=y+120|0;L=y+104|0;M=y+88|0;N=y+80|0;O=y+72|0;P=y+64|0;p[A>>3]=w;if((Y(s,r)|0)<=49){f[A>>2]=r;f[A+4>>2]=s;JF(z,A,c,o,q);f[C+8>>2]=0;f[C+12>>2]=0;f[C>>2]=16842752;f[C+4>>2]=z;f[D>>2]=t;f[D+4>>2]=v;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[E+24>>2]=0;f[E+28>>2]=0;Jda(B,a,b,C,D,w,x&-17,-1,E);f[F>>2]=i;f[F+4>>2]=j;JF(C,F,a,d,e);f[G>>2]=i;f[G+4>>2]=j;JF(E,G,b,g,h);Q=f[B+4>>2]|0;R=f[(f[Q>>2]|0)+20>>2]|0;f[H>>2]=k;f[H+4>>2]=l;f[I>>2]=m;f[I+4>>2]=n;uh[R&255](Q,C,E,H,I);Q=E+36|0;R=f[Q>>2]|0;if(R|0?(n=R+12|0,R=f[n>>2]|0,f[n>>2]=R+-1,(R|0)==1):0)kL(E);f[Q>>2]=0;Q=E+16|0;R=E+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[R>>2]|0)>0){Q=f[E+40>>2]|0;n=0;do{f[Q+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[R>>2]|0))}R=f[E+44>>2]|0;if((R|0)!=(E+48|0))UC(R);R=C+36|0;n=f[R>>2]|0;if(n|0?(Q=n+12|0,n=f[Q>>2]|0,f[Q>>2]=n+-1,(n|0)==1):0)kL(C);f[R>>2]=0;R=C+16|0;n=C+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[n>>2]|0)>0){R=f[C+40>>2]|0;Q=0;do{f[R+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[n>>2]|0))}n=f[C+44>>2]|0;if((n|0)!=(C+48|0))UC(n);n=f[B>>2]|0;if(n|0?(Q=n+4|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)bi[f[(f[n>>2]|0)+8>>2]&2047](n);n=z+36|0;R=f[n>>2]|0;if(R|0?(Q=R+12|0,R=f[Q>>2]|0,f[Q>>2]=R+-1,(R|0)==1):0)kL(z);f[n>>2]=0;n=z+16|0;R=z+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[R>>2]|0)>0){n=f[z+40>>2]|0;Q=0;do{f[n+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[R>>2]|0))}R=f[z+44>>2]|0;if((R|0)!=(z+48|0))UC(R);u=y;return}f[C>>2]=r;f[C+4>>2]=s;JF(B,C,c,o,q);f[E>>2]=i;f[E+4>>2]=j;JF(D,E,a,d,e);f[G>>2]=i;f[G+4>>2]=j;JF(F,G,b,g,h);f[H>>2]=1124007936;G=H+4|0;e=H+8|0;E=H+40|0;q=G;o=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(o|0));f[E>>2]=e;q=H+48|0;o=H+44|0;f[o>>2]=q;f[q>>2]=0;f[H+52>>2]=0;c=a>>>3&511;a=b&4088;C=b&7;if((c|0)!=0&+p[A>>3]!=0.0){if((C+-5|0)>>>0>1|(d|0)==(g|0)){s=(C|0)==6?6:5;f[z>>2]=j;f[z+4>>2]=i;hL(H,2,z,s|a);S=s}else{f[I>>2]=i;f[I+4>>2]=j;JF(z,I,b,g,h);I=z+36|0;s=f[I>>2]|0;if(s|0){a=s+12|0;f[a>>2]=(f[a>>2]|0)+1}a=H+36|0;s=f[a>>2]|0;if(s|0?(r=s+12|0,s=f[r>>2]|0,f[r>>2]=s+-1,(s|0)==1):0)kL(H);f[a>>2]=0;s=H+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[G>>2]|0)>0){r=f[E>>2]|0;R=0;do{f[r+(R<<2)>>2]=0;R=R+1|0;T=f[G>>2]|0}while((R|0)<(T|0));f[H>>2]=f[z>>2];if((T|0)<3)U=14;else U=16}else{f[H>>2]=f[z>>2];U=14}if((U|0)==14){T=f[z+4>>2]|0;if((T|0)<3){f[G>>2]=T;f[e>>2]=f[z+8>>2];f[H+12>>2]=f[z+12>>2];T=f[z+44>>2]|0;R=f[o>>2]|0;f[R>>2]=f[T>>2];f[R+4>>2]=f[T+4>>2]}else U=16}if((U|0)==16)jL(H,z);T=z+16|0;f[s>>2]=f[T>>2];f[H+20>>2]=f[z+20>>2];f[H+24>>2]=f[z+24>>2];f[H+28>>2]=f[z+28>>2];f[H+32>>2]=f[z+32>>2];s=f[I>>2]|0;f[a>>2]=s;if(s|0?(a=s+12|0,s=f[a>>2]|0,f[a>>2]=s+-1,(s|0)==1):0)kL(z);f[I>>2]=0;I=z+4|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[I>>2]|0)>0){T=f[z+40>>2]|0;s=0;do{f[T+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[I>>2]|0))}I=f[z+44>>2]|0;if((I|0)!=(z+48|0))UC(I);S=C}I=f[D+40>>2]|0;s=f[I>>2]|0;f[J>>2]=f[I+4>>2];f[J+4>>2]=s;f[K>>2]=t;f[K+4>>2]=v;Oda(D,B,H,J,S|c<<3,K,0.0,x);f[z+8>>2]=0;f[z+12>>2]=0;f[z>>2]=16842752;f[z+4>>2]=H;f[L>>2]=-1056833530;f[L+4>>2]=A;f[L+8>>2]=1;f[L+12>>2]=1;K=M+8|0;f[K>>2]=0;f[K+4>>2]=0;f[M>>2]=33619968;f[M+4>>2]=H;VD(z,L,M,UM()|0,-1);if((f[H+16>>2]|0)!=(g|0)){M=z+8|0;f[M>>2]=0;f[M+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=F;OJ(H,z,f[F>>2]&4095,1.0,0.0)}}else{if((d|0)!=(g|0)){f[N>>2]=i;f[N+4>>2]=j;JF(z,N,b,g,h);h=z+36|0;N=f[h>>2]|0;if(N|0){d=N+12|0;f[d>>2]=(f[d>>2]|0)+1}d=H+36|0;N=f[d>>2]|0;if(N|0?(M=N+12|0,N=f[M>>2]|0,f[M>>2]=N+-1,(N|0)==1):0)kL(H);f[d>>2]=0;N=H+16|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[G>>2]|0)>0){M=f[E>>2]|0;L=0;do{f[M+(L<<2)>>2]=0;L=L+1|0;V=f[G>>2]|0}while((L|0)<(V|0));f[H>>2]=f[z>>2];if((V|0)<3)U=40;else U=42}else{f[H>>2]=f[z>>2];U=40}if((U|0)==40){V=f[z+4>>2]|0;if((V|0)<3){f[G>>2]=V;f[e>>2]=f[z+8>>2];f[H+12>>2]=f[z+12>>2];e=f[z+44>>2]|0;V=f[o>>2]|0;f[V>>2]=f[e>>2];f[V+4>>2]=f[e+4>>2]}else U=42}if((U|0)==42)jL(H,z);U=z+16|0;f[N>>2]=f[U>>2];f[H+20>>2]=f[z+20>>2];f[H+24>>2]=f[z+24>>2];f[H+28>>2]=f[z+28>>2];f[H+32>>2]=f[z+32>>2];N=f[h>>2]|0;f[d>>2]=N;if(N|0?(d=N+12|0,N=f[d>>2]|0,f[d>>2]=N+-1,(N|0)==1):0)kL(z);f[h>>2]=0;h=z+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[h>>2]|0)>0){U=f[z+40>>2]|0;N=0;do{f[U+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[h>>2]|0))}h=f[z+44>>2]|0;if((h|0)!=(z+48|0))UC(h)}else{f[z>>2]=j;f[z+4>>2]=i;hL(H,2,z,b&4095)}b=f[D+40>>2]|0;i=f[b>>2]|0;f[O>>2]=f[b+4>>2];f[O+4>>2]=i;f[P>>2]=t;f[P+4>>2]=v;Oda(D,B,H,O,c<<3|C,P,+p[A>>3],x);if((f[H+16>>2]|0)!=(g|0)){g=z+8|0;f[g>>2]=0;f[g+4>>2]=0;f[z>>2]=33619968;f[z+4>>2]=F;SP(H,z)}}z=H+36|0;g=f[z>>2]|0;if(g|0?(x=g+12|0,g=f[x>>2]|0,f[x>>2]=g+-1,(g|0)==1):0)kL(H);f[z>>2]=0;z=H+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[G>>2]|0)>0){z=f[E>>2]|0;E=0;do{f[z+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[G>>2]|0))}G=f[o>>2]|0;if((G|0)!=(q|0))UC(G);G=F+36|0;q=f[G>>2]|0;if(q|0?(o=q+12|0,q=f[o>>2]|0,f[o>>2]=q+-1,(q|0)==1):0)kL(F);f[G>>2]=0;G=F+16|0;q=F+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[q>>2]|0)>0){G=f[F+40>>2]|0;o=0;do{f[G+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[q>>2]|0))}q=f[F+44>>2]|0;if((q|0)!=(F+48|0))UC(q);q=D+36|0;F=f[q>>2]|0;if(F|0?(o=F+12|0,F=f[o>>2]|0,f[o>>2]=F+-1,(F|0)==1):0)kL(D);f[q>>2]=0;q=D+16|0;F=D+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[F>>2]|0)>0){q=f[D+40>>2]|0;o=0;do{f[q+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[F>>2]|0))}F=f[D+44>>2]|0;if((F|0)!=(D+48|0))UC(F);F=B+36|0;D=f[F>>2]|0;if(D|0?(o=D+12|0,D=f[o>>2]|0,f[o>>2]=D+-1,(D|0)==1):0)kL(B);f[F>>2]=0;F=B+16|0;D=B+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[D>>2]|0)>0){F=f[B+40>>2]|0;o=0;do{f[F+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[D>>2]|0))}D=f[B+44>>2]|0;if((D|0)!=(B+48|0))UC(D);u=y;return}function Lda(a,b,c,d,e,g,h,i,j,k,l,m,n,o,p,q,r,s,t,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;v=+v;w=w|0;var x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;x=u;u=u+320|0;y=x+256|0;z=x+248|0;A=x+192|0;B=x+184|0;C=x+176|0;D=x+120|0;E=x+64|0;F=x+56|0;G=x;H=x+48|0;I=x+40|0;J=x+32|0;f[z>>2]=p;f[z+4>>2]=1;JF(y,z,c,o,0);f[B>>2]=r;f[B+4>>2]=1;JF(A,B,c,q,0);f[D+8>>2]=0;f[D+12>>2]=0;f[D>>2]=16842752;f[D+4>>2]=y;f[E+8>>2]=0;f[E+12>>2]=0;f[E>>2]=16842752;f[E+4>>2]=A;f[F>>2]=s;f[F+4>>2]=t;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;f[G+16>>2]=0;f[G+20>>2]=0;f[G+24>>2]=0;f[G+28>>2]=0;hca(C,a,b,D,E,F,v,w&-17,-1,G);f[H>>2]=i;f[H+4>>2]=j;JF(D,H,a,d,e);f[I>>2]=i;f[I+4>>2]=j;JF(E,I,b,g,h);h=f[C+4>>2]|0;g=f[(f[h>>2]|0)+20>>2]|0;f[G>>2]=k;f[G+4>>2]=l;f[J>>2]=m;f[J+4>>2]=n;uh[g&255](h,D,E,G,J);J=E+36|0;G=f[J>>2]|0;if(G|0?(h=G+12|0,G=f[h>>2]|0,f[h>>2]=G+-1,(G|0)==1):0)kL(E);f[J>>2]=0;J=E+16|0;G=E+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[G>>2]|0)>0){J=f[E+40>>2]|0;h=0;do{f[J+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[G>>2]|0))}G=f[E+44>>2]|0;if((G|0)!=(E+48|0))UC(G);G=D+36|0;E=f[G>>2]|0;if(E|0?(h=E+12|0,E=f[h>>2]|0,f[h>>2]=E+-1,(E|0)==1):0)kL(D);f[G>>2]=0;G=D+16|0;E=D+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[E>>2]|0)>0){G=f[D+40>>2]|0;h=0;do{f[G+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[E>>2]|0))}E=f[D+44>>2]|0;if((E|0)!=(D+48|0))UC(E);E=f[C>>2]|0;if(E|0?(C=E+4|0,D=f[C>>2]|0,f[C>>2]=D+-1,(D|0)==1):0)bi[f[(f[E>>2]|0)+8>>2]&2047](E);E=A+36|0;D=f[E>>2]|0;if(D|0?(C=D+12|0,D=f[C>>2]|0,f[C>>2]=D+-1,(D|0)==1):0)kL(A);f[E>>2]=0;E=A+16|0;D=A+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[D>>2]|0)>0){E=f[A+40>>2]|0;C=0;do{f[E+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[D>>2]|0))}D=f[A+44>>2]|0;if((D|0)!=(A+48|0))UC(D);D=y+36|0;A=f[D>>2]|0;if(A|0?(C=A+12|0,A=f[C>>2]|0,f[C>>2]=A+-1,(A|0)==1):0)kL(y);f[D>>2]=0;D=y+16|0;A=y+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[A>>2]|0)>0){D=f[y+40>>2]|0;C=0;do{f[D+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[A>>2]|0))}A=f[y+44>>2]|0;if((A|0)==(y+48|0)){u=x;return}UC(A);u=x;return}function Mda(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=u;u=u+208|0;k=j+192|0;l=j+184|0;m=j+128|0;n=j+72|0;o=j+8|0;p=j+16|0;q=j;dQ(l,56144);do if((yM(a)|0)==65536){r=f[a+4>>2]|0;f[m>>2]=f[r>>2];s=m+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=m+8|0;f[v>>2]=f[r+8>>2];f[m+12>>2]=f[r+12>>2];f[m+16>>2]=f[r+16>>2];f[m+20>>2]=f[r+20>>2];f[m+24>>2]=f[r+24>>2];f[m+28>>2]=f[r+28>>2];f[m+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[m+36>>2]=w;f[m+40>>2]=v;v=m+48|0;x=m+44|0;f[x>>2]=v;f[v>>2]=0;f[m+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;jL(m,r);break}}else yL(m,a,-1);while(0);do if((yM(e)|0)==65536){a=f[e+4>>2]|0;f[n>>2]=f[a>>2];r=n+4|0;s=a+4|0;f[r>>2]=f[s>>2];t=n+8|0;f[t>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];v=f[a+36>>2]|0;f[n+36>>2]=v;f[n+40>>2]=t;t=n+48|0;x=n+44|0;f[x>>2]=t;f[t>>2]=0;f[n+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[a+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;jL(n,a);break}}else yL(n,e,-1);while(0);e=f[m>>2]|0;a=m+40|0;r=f[a>>2]|0;s=f[r>>2]|0;f[o>>2]=f[r+4>>2];f[o+4>>2]=s;vM(c,o,e&4088|((d|0)<0?e:d)&7,-1,0,0);do if((yM(c)|0)==65536){d=f[c+4>>2]|0;f[p>>2]=f[d>>2];e=p+4|0;o=d+4|0;f[e>>2]=f[o>>2];s=p+8|0;f[s>>2]=f[d+8>>2];f[p+12>>2]=f[d+12>>2];f[p+16>>2]=f[d+16>>2];f[p+20>>2]=f[d+20>>2];f[p+24>>2]=f[d+24>>2];f[p+28>>2]=f[d+28>>2];f[p+32>>2]=f[d+32>>2];r=f[d+36>>2]|0;f[p+36>>2]=r;f[p+40>>2]=s;s=p+48|0;t=p+44|0;f[t>>2]=s;f[s>>2]=0;f[p+52>>2]=0;if(r|0){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[o>>2]|0)<3){o=f[d+44>>2]|0;s=f[t>>2]|0;f[s>>2]=f[o>>2];f[s+4>>2]=f[o+4>>2];break}else{f[e>>2]=0;jL(p,d);break}}else yL(p,c,-1);while(0);c=f[g>>2]|0;d=f[g+4>>2]|0;g=n+40|0;e=f[g>>2]|0;o=f[e+4>>2]|0;s=f[e>>2]|0;e=(c|0)==-1?(o|0)/2|0:c;c=(d|0)==-1?(s|0)/2|0:d;if(!((e|0)>-1&(e|0)<(o|0)?!((c|0)<0|(c|0)>=(s|0)):0)){f[k>>2]=0;f[k+4>>2]=0;s=aD(k,52)|0;o=263653;d=s+52|0;do{b[s>>0]=b[o>>0]|0;s=s+1|0;o=o+1|0}while((s|0)<(d|0));bO(-215,k,263706,263722,363);bD(k)}f[k>>2]=0;o=k+4|0;f[o>>2]=0;s=f[m+12>>2]|0;d=f[m+8>>2]|0;f[q>>2]=s;t=q+4|0;f[t>>2]=d;if(!(i&16)){uL(m,q,k);y=f[q>>2]|0;z=f[t>>2]|0;A=f[k>>2]|0;B=f[o>>2]|0}else{y=s;z=d;A=0;B=0}d=f[m>>2]|0;s=m+16|0;o=m+48|0;k=p+16|0;t=p+48|0;q=n+16|0;r=n+48|0;Kda(d&4095,f[p>>2]&4095,f[n>>2]&4095,f[s>>2]|0,f[o>>2]|0,f[k>>2]|0,f[t>>2]|0,f[p+12>>2]|0,f[p+8>>2]|0,y,z,A,B,f[q>>2]|0,f[r>>2]|0,f[n+12>>2]|0,f[n+8>>2]|0,e,c,h,i,(d&32768|0)!=0);d=p+36|0;i=f[d>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)kL(p);f[d>>2]=0;d=p+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[d>>2]|0)>0){k=f[p+40>>2]|0;i=0;do{f[k+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[d>>2]|0))}d=f[p+44>>2]|0;if((d|0)!=(t|0))UC(d);d=n+36|0;t=f[d>>2]|0;if(t|0?(p=t+12|0,t=f[p>>2]|0,f[p>>2]=t+-1,(t|0)==1):0)kL(n);f[d>>2]=0;d=n+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[d>>2]|0)>0){q=f[g>>2]|0;g=0;do{f[q+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[d>>2]|0))}d=f[n+44>>2]|0;if((d|0)!=(r|0))UC(d);d=m+36|0;r=f[d>>2]|0;if(r|0?(n=r+12|0,r=f[n>>2]|0,f[n>>2]=r+-1,(r|0)==1):0)kL(m);f[d>>2]=0;d=m+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[d>>2]|0)>0){s=f[a>>2]|0;a=0;do{f[s+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[d>>2]|0))}d=f[m+44>>2]|0;if((d|0)!=(o|0))UC(d);if(!(f[l+4>>2]|0)){u=j;return}u=j;return}function Nda(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=u;u=u+384|0;l=k+368|0;m=k+360|0;n=k+304|0;o=k+248|0;p=k+184|0;q=k+240|0;r=k+128|0;s=k+120|0;t=k+112|0;v=k+56|0;w=k;dQ(m,56164);do if((yM(a)|0)==65536){x=f[a+4>>2]|0;f[n>>2]=f[x>>2];y=n+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=n+8|0;f[A>>2]=f[x+8>>2];f[n+12>>2]=f[x+12>>2];f[n+16>>2]=f[x+16>>2];f[n+20>>2]=f[x+20>>2];f[n+24>>2]=f[x+24>>2];f[n+28>>2]=f[x+28>>2];f[n+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[n+36>>2]=B;f[n+40>>2]=A;A=n+48|0;C=n+44|0;f[C>>2]=A;f[A>>2]=0;f[n+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(n,x);break}}else yL(n,a,-1);while(0);do if((yM(e)|0)==65536){a=f[e+4>>2]|0;f[o>>2]=f[a>>2];x=o+4|0;y=a+4|0;f[x>>2]=f[y>>2];z=o+8|0;f[z>>2]=f[a+8>>2];f[o+12>>2]=f[a+12>>2];f[o+16>>2]=f[a+16>>2];f[o+20>>2]=f[a+20>>2];f[o+24>>2]=f[a+24>>2];f[o+28>>2]=f[a+28>>2];f[o+32>>2]=f[a+32>>2];A=f[a+36>>2]|0;f[o+36>>2]=A;f[o+40>>2]=z;z=o+48|0;C=o+44|0;f[C>>2]=z;f[z>>2]=0;f[o+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[a+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;jL(o,a);break}}else yL(o,e,-1);while(0);do if((yM(g)|0)==65536){e=f[g+4>>2]|0;f[p>>2]=f[e>>2];a=p+4|0;x=e+4|0;f[a>>2]=f[x>>2];y=p+8|0;f[y>>2]=f[e+8>>2];f[p+12>>2]=f[e+12>>2];f[p+16>>2]=f[e+16>>2];f[p+20>>2]=f[e+20>>2];f[p+24>>2]=f[e+24>>2];f[p+28>>2]=f[e+28>>2];f[p+32>>2]=f[e+32>>2];z=f[e+36>>2]|0;f[p+36>>2]=z;f[p+40>>2]=y;y=p+48|0;C=p+44|0;f[C>>2]=y;f[y>>2]=0;f[p+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[e+44>>2]|0;y=f[C>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[a>>2]=0;jL(p,e);break}}else yL(p,g,-1);while(0);g=f[n>>2]|0;e=n+40|0;a=f[e>>2]|0;x=f[a>>2]|0;f[q>>2]=f[a+4>>2];f[q+4>>2]=x;vM(c,q,g&4088|((d|0)<0?g:d)&7,-1,0,0);do if((yM(c)|0)==65536){d=f[c+4>>2]|0;f[r>>2]=f[d>>2];g=r+4|0;q=d+4|0;f[g>>2]=f[q>>2];x=r+8|0;f[x>>2]=f[d+8>>2];f[r+12>>2]=f[d+12>>2];f[r+16>>2]=f[d+16>>2];f[r+20>>2]=f[d+20>>2];f[r+24>>2]=f[d+24>>2];f[r+28>>2]=f[d+28>>2];f[r+32>>2]=f[d+32>>2];a=f[d+36>>2]|0;f[r+36>>2]=a;f[r+40>>2]=x;x=r+48|0;y=r+44|0;f[y>>2]=x;f[x>>2]=0;f[r+52>>2]=0;if(a|0){x=a+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[q>>2]|0)<3){q=f[d+44>>2]|0;x=f[y>>2]|0;f[x>>2]=f[q>>2];f[x+4>>2]=f[q+4>>2];break}else{f[g>>2]=0;jL(r,d);break}}else yL(r,c,-1);while(0);f[s>>2]=0;c=s+4|0;f[c>>2]=0;d=f[n+8>>2]|0;f[t>>2]=f[n+12>>2];g=t+4|0;f[g>>2]=d;if(!(j&16))uL(n,t,s);d=f[o>>2]|0;do if(!((f[p>>2]^d)&4095)){if((f[o+12>>2]|0)!=1?(f[o+8>>2]|0)!=1:0){D=36;break}if((f[p+12>>2]|0)!=1?(f[p+8>>2]|0)!=1:0)D=36;else E=d}else D=36;while(0);if((D|0)==36){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,120)|0;D=251245;G=F+120|0;do{b[F>>0]=b[D>>0]|0;F=F+1|0;D=D+1|0}while((F|0)<(G|0));bO(-215,l,251366,241836,4948);bD(l);E=f[o>>2]|0}do if(E&16384){f[v>>2]=E;D=v+4|0;d=o+4|0;q=f[d>>2]|0;f[D>>2]=q;x=v+8|0;f[x>>2]=f[o+8>>2];f[v+12>>2]=f[o+12>>2];f[v+16>>2]=f[o+16>>2];f[v+20>>2]=f[o+20>>2];f[v+24>>2]=f[o+24>>2];f[v+28>>2]=f[o+28>>2];f[v+32>>2]=f[o+32>>2];y=f[o+36>>2]|0;f[v+36>>2]=y;f[v+40>>2]=x;x=v+48|0;a=v+44|0;f[a>>2]=x;f[x>>2]=0;f[v+52>>2]=0;if(!y)H=q;else{q=y+12|0;f[q>>2]=(f[q>>2]|0)+1;H=f[d>>2]|0}if((H|0)<3){d=f[o+44>>2]|0;q=f[a>>2]|0;f[q>>2]=f[d>>2];f[q+4>>2]=f[d+4>>2];break}else{f[D>>2]=0;jL(v,o);break}}else{f[v>>2]=1124007936;D=v+8|0;d=v+40|0;F=v+4|0;G=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(G|0));f[d>>2]=D;q=v+48|0;f[v+44>>2]=q;f[q>>2]=0;f[v+52>>2]=0;q=l+8|0;f[q>>2]=0;f[q+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=v;SP(o,l)}while(0);H=f[p>>2]|0;do if(H&16384){f[w>>2]=H;E=w+4|0;q=p+4|0;a=f[q>>2]|0;f[E>>2]=a;y=w+8|0;x=p+8|0;f[y>>2]=f[x>>2];C=p+12|0;f[w+12>>2]=f[C>>2];z=w+16|0;f[z>>2]=f[p+16>>2];f[w+20>>2]=f[p+20>>2];f[w+24>>2]=f[p+24>>2];f[w+28>>2]=f[p+28>>2];f[w+32>>2]=f[p+32>>2];A=f[p+36>>2]|0;f[w+36>>2]=A;f[w+40>>2]=y;y=w+48|0;B=w+44|0;f[B>>2]=y;f[y>>2]=0;f[w+52>>2]=0;if(!A)I=a;else{a=A+12|0;f[a>>2]=(f[a>>2]|0)+1;I=f[q>>2]|0}if((I|0)<3){q=f[p+44>>2]|0;a=f[B>>2]|0;f[a>>2]=f[q>>2];f[a+4>>2]=f[q+4>>2];J=C;K=x;L=z;break}else{f[E>>2]=0;jL(w,p);J=C;K=x;L=z;break}}else{f[w>>2]=1124007936;z=w+8|0;x=w+40|0;F=w+4|0;G=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(G|0));f[x>>2]=z;D=w+48|0;f[w+44>>2]=D;f[D>>2]=0;f[w+52>>2]=0;D=l+8|0;f[D>>2]=0;f[D+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=w;SP(p,l);J=p+12|0;K=p+8|0;L=w+16|0}while(0);l=n+16|0;F=n+48|0;G=r+16|0;I=r+48|0;H=v+16|0;Lda(f[n>>2]&4095,f[r>>2]&4095,f[o>>2]&4095,f[l>>2]|0,f[F>>2]|0,f[G>>2]|0,f[I>>2]|0,f[r+12>>2]|0,f[r+8>>2]|0,f[t>>2]|0,f[g>>2]|0,f[s>>2]|0,f[c>>2]|0,f[H>>2]|0,(f[o+12>>2]|0)+-1+(f[o+8>>2]|0)|0,f[L>>2]|0,(f[J>>2]|0)+-1+(f[K>>2]|0)|0,f[h>>2]|0,f[h+4>>2]|0,i,j&-17);j=w+36|0;h=f[j>>2]|0;if(h|0?(K=h+12|0,h=f[K>>2]|0,f[K>>2]=h+-1,(h|0)==1):0)kL(w);f[j>>2]=0;j=w+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[j>>2]|0)>0){L=f[w+40>>2]|0;h=0;do{f[L+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[j>>2]|0))}j=f[w+44>>2]|0;if((j|0)!=(w+48|0))UC(j);j=v+36|0;w=f[j>>2]|0;if(w|0?(h=w+12|0,w=f[h>>2]|0,f[h>>2]=w+-1,(w|0)==1):0)kL(v);f[j>>2]=0;j=v+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[j>>2]|0)>0){H=f[v+40>>2]|0;w=0;do{f[H+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[j>>2]|0))}j=f[v+44>>2]|0;if((j|0)!=(v+48|0))UC(j);j=r+36|0;v=f[j>>2]|0;if(v|0?(w=v+12|0,v=f[w>>2]|0,f[w>>2]=v+-1,(v|0)==1):0)kL(r);f[j>>2]=0;j=r+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[j>>2]|0)>0){G=f[r+40>>2]|0;v=0;do{f[G+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[j>>2]|0))}j=f[r+44>>2]|0;if((j|0)!=(I|0))UC(j);j=p+36|0;I=f[j>>2]|0;if(I|0?(r=I+12|0,I=f[r>>2]|0,f[r>>2]=I+-1,(I|0)==1):0)kL(p);f[j>>2]=0;j=p+16|0;I=p+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[I>>2]|0)>0){j=f[p+40>>2]|0;r=0;do{f[j+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[I>>2]|0))}I=f[p+44>>2]|0;if((I|0)!=(p+48|0))UC(I);I=o+36|0;p=f[I>>2]|0;do if(p|0){r=p+12|0;j=f[r>>2]|0;f[r>>2]=j+-1;if((j|0)!=1)break;kL(o)}while(0);f[I>>2]=0;I=o+16|0;p=o+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[p>>2]|0)>0){I=f[o+40>>2]|0;j=0;do{f[I+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[p>>2]|0))}p=f[o+44>>2]|0;if((p|0)!=(o+48|0))UC(p);p=n+36|0;o=f[p>>2]|0;do if(o|0){j=o+12|0;I=f[j>>2]|0;f[j>>2]=I+-1;if((I|0)!=1)break;kL(n)}while(0);f[p>>2]=0;p=n+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[p>>2]|0)>0){l=f[e>>2]|0;e=0;do{f[l+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[p>>2]|0))}p=f[n+44>>2]|0;if((p|0)!=(F|0))UC(p);if(!(f[m+4>>2]|0)){u=k;return}u=k;return}function Oda(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0;k=u;u=u+816|0;l=k+88|0;m=k+792|0;n=k+736|0;o=k+732|0;p=k+728|0;q=k+672|0;r=k+616|0;s=k+608|0;t=k+552|0;v=k+496|0;w=k+440|0;x=k+32|0;y=k+384|0;z=k+328|0;A=k+272|0;B=k+216|0;C=k+160|0;D=k;E=k+144|0;f[m>>2]=0;F=m+4|0;f[F>>2]=0;f[m+8>>2]=0;f[n>>2]=f[c>>2];G=n+4|0;H=c+4|0;I=f[H>>2]|0;f[G>>2]=I;J=n+8|0;f[J>>2]=f[c+8>>2];K=n+12|0;f[K>>2]=f[c+12>>2];L=n+16|0;f[L>>2]=f[c+16>>2];M=n+20|0;f[M>>2]=f[c+20>>2];N=n+24|0;f[N>>2]=f[c+24>>2];O=n+28|0;f[O>>2]=f[c+28>>2];P=n+32|0;f[P>>2]=f[c+32>>2];Q=n+36|0;R=f[c+36>>2]|0;f[Q>>2]=R;S=n+40|0;f[S>>2]=J;T=n+48|0;U=n+44|0;f[U>>2]=T;f[T>>2]=0;f[n+52>>2]=0;if(!R)V=I;else{I=R+12|0;f[I>>2]=(f[I>>2]|0)+1;V=f[H>>2]|0}if((V|0)<3){V=f[c+44>>2]|0;H=f[U>>2]|0;f[H>>2]=f[V>>2];f[H+4>>2]=f[V+4>>2]}else{f[G>>2]=0;jL(n,c)}V=f[a>>2]|0;H=V&7;I=V>>>3;V=I&511;R=f[n>>2]|0;W=R&7;f[o>>2]=W;X=R>>>3&511;R=X+1|0;Z=g&7;f[p>>2]=Z;_=g>>>3;$=_&511;aa=a+4|0;if(!((f[aa>>2]|0)<3&(f[G>>2]|0)<3?(f[d+4>>2]|0)<3:0)){f[l>>2]=0;f[l+4>>2]=0;ba=aD(l,50)|0;ca=251473;da=ba+50|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));bO(-215,l,251524,251534,579);bD(l)}if((H|0)!=(W|0)){ea=H>>>0>5?H:5;if((W|0)==(ea|0))fa=W;else{W=l+8|0;f[W>>2]=0;f[W+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=n;OJ(c,l,ea,1.0,0.0);ea=f[n>>2]&7;f[o>>2]=ea;fa=ea}}else fa=H;if(!((H|0)==(fa|0)|(fa|0)==5)){f[l>>2]=0;f[l+4>>2]=0;ba=aD(l,30)|0;ca=251609;da=ba+30|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));bO(-215,l,251524,251534,587);bD(l)}ea=e+4|0;c=a+8|0;if(!((f[ea>>2]|0)<((f[J>>2]|0)+(f[c>>2]|0)|0)?(f[e>>2]|0)<((f[K>>2]|0)+(f[a+12>>2]|0)|0):0)){f[l>>2]=0;f[l+4>>2]=0;ba=aD(l,91)|0;ca=251640;da=ba+91|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));bO(-215,l,251524,251534,589);bD(l)}W=($|0)==0;if(!(W|i==0.0)){f[l>>2]=0;f[l+4>>2]=0;ba=aD(l,22)|0;ca=251732;da=ba+22|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));bO(-215,l,251524,251534,591);bD(l)}$=f[e>>2]|0;e=f[ea>>2]|0;ea=g&4095;if(!(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(e|0):0)?(f[d+12>>2]|0)==($|0):0)?(f[d>>2]&4095|0)==(ea|0):0)?(f[d+16>>2]|0)!=0:0)){f[l>>2]=e;f[l+4>>2]=$;hL(d,2,l,ea)}if(H>>>0>1)ga=6;else{ea=fa>>>0>5?fa:5;ga=(ea|0)<(Z|0)?Z:ea}ea=f[K>>2]|0;$=MVb(+(ea|0)*4.5)|0;e=256-ea+1|0;g=($|0)<(e|0)?e:$;$=d+12|0;e=f[$>>2]|0;ha=f[J>>2]|0;ia=MVb(+(ha|0)*4.5)|0;ja=256-ha+1|0;ha=(ia|0)<(ja|0)?ja:ia;ia=d+8|0;ja=f[ia>>2]|0;ka=SC(ea+-1+((e|0)<(g|0)?e:g)|0)|0;g=(ka|0)>2?ka:2;ka=SC(((ja|0)<(ha|0)?ja:ha)+-1+(f[J>>2]|0)|0)|0;if((g|0)<1|(ka|0)<1){f[l>>2]=0;f[l+4>>2]=0;ba=aD(l,28)|0;ca=251755;da=ba+28|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));bO(-211,l,251524,251534,608);bD(l)}ha=g-(f[K>>2]|0)|0;ja=f[$>>2]|0;e=(ha|0)>=(ja|0)?ja:ha+1|0;ha=ka-(f[J>>2]|0)|0;ja=f[ia>>2]|0;ea=(ha|0)>=(ja|0)?ja:ha+1|0;ha=Y(ka,R)|0;f[q>>2]=1124007936;R=q+4|0;ja=q+8|0;la=q+40|0;ba=R;da=ba+36|0;do{f[ba>>2]=0;ba=ba+4|0}while((ba|0)<(da|0));f[la>>2]=ja;ja=q+48|0;ma=q+44|0;f[ma>>2]=ja;f[ja>>2]=0;f[q+52>>2]=0;na=ga&4095;f[l>>2]=ha;ha=l+4|0;f[ha>>2]=g;hL(q,2,l,na);f[r>>2]=1124007936;oa=r+4|0;pa=r+8|0;qa=r+40|0;ba=oa;da=ba+36|0;do{f[ba>>2]=0;ba=ba+4|0}while((ba|0)<(da|0));f[qa>>2]=pa;pa=r+48|0;ra=r+44|0;f[ra>>2]=pa;f[pa>>2]=0;f[r+52>>2]=0;f[l>>2]=ka;f[ha>>2]=g;hL(r,2,l,na);na=(X|0)!=0;if((fa|0)==(ga|0)|na^1)sa=0;else sa=Y(f[K>>2]<<(47696>>>(fa<<1)&3),f[J>>2]|0)|0;fa=(V|0)!=0;ha=(H|0)==(ga|0);if(ha|fa^1)ta=sa;else{ua=(Y(ea+-1+(f[J>>2]|0)|0,e+-1+(f[K>>2]|0)|0)|0)<<(47696>>>(H<<1)&3);ta=(sa|0)<(ua|0)?ua:sa}if(((I|_)&511|0)==0|(Z|0)==(ga|0))va=ta;else{_=(Y(ea,e)|0)<<(47696>>>(Z<<1)&3);va=(ta|0)<(_|0)?_:ta}ta=f[F>>2]|0;_=f[m>>2]|0;Z=ta-_|0;I=_;_=ta;if(va>>>0<=Z>>>0){if(va>>>0<Z>>>0?(ta=I+va|0,(_|0)!=(ta|0)):0)f[F>>2]=ta}else DL(m,va-Z|0);CC(s,g,ka,f[q>>2]&7,1,1,1024,f[J>>2]|0);Z=t+4|0;va=t+8|0;ta=t+12|0;_=t+16|0;I=t+20|0;sa=t+24|0;ua=t+28|0;wa=t+32|0;xa=t+36|0;ya=t+40|0;za=t+48|0;Aa=t+44|0;Ba=t+52|0;Ca=l+4|0;Da=l+8|0;Ea=l+12|0;Fa=l+4|0;Ga=l+8|0;Ha=l+12|0;Ia=x+4|0;Ja=w+4|0;Ka=x+8|0;La=w+8|0;Ma=x+12|0;Na=w+12|0;Oa=x+16|0;Pa=w+16|0;Qa=x+20|0;Ra=w+20|0;Sa=x+24|0;Ta=w+24|0;Ua=x+28|0;Va=w+28|0;Wa=x+32|0;Xa=w+32|0;Ya=x+36|0;Za=w+36|0;_a=x+40|0;$a=x+48|0;ab=x+44|0;bb=x+52|0;cb=w+44|0;db=l+4|0;eb=l+4|0;fb=v+12|0;gb=x+4|0;hb=y+4|0;ib=l+36|0;jb=l+16|0;kb=l+4|0;lb=l+40|0;mb=l+44|0;nb=l+48|0;ob=s+4|0;pb=v+16|0;qb=v+48|0;rb=w+40|0;sb=w+48|0;tb=v+36|0;ub=v+4|0;vb=v+40|0;wb=v+44|0;xb=l+8|0;yb=l+4|0;zb=0;while(1){Ab=Y(zb,ka)|0;f[t>>2]=f[n>>2];Bb=f[G>>2]|0;f[Z>>2]=Bb;f[va>>2]=f[J>>2];f[ta>>2]=f[K>>2];f[_>>2]=f[L>>2];f[I>>2]=f[M>>2];f[sa>>2]=f[N>>2];f[ua>>2]=f[O>>2];f[wa>>2]=f[P>>2];Cb=f[Q>>2]|0;f[xa>>2]=Cb;f[ya>>2]=va;f[Aa>>2]=za;f[za>>2]=0;f[Ba>>2]=0;if(!Cb)Db=Bb;else{Bb=Cb+12|0;f[Bb>>2]=(f[Bb>>2]|0)+1;Db=f[G>>2]|0}if((Db|0)<3){Bb=f[U>>2]|0;Cb=f[Aa>>2]|0;f[Cb>>2]=f[Bb>>2];f[Cb+4>>2]=f[Bb+4>>2]}else{f[Z>>2]=0;jL(t,n)}f[l>>2]=0;f[Ca>>2]=Ab;f[Da>>2]=g;f[Ea>>2]=ka;nL(v,q,l);Bb=f[K>>2]|0;Cb=f[J>>2]|0;f[l>>2]=0;f[Fa>>2]=Ab;f[Ga>>2]=Bb;f[Ha>>2]=Cb;nL(w,q,l);if(na){Cb=f[o>>2]|0;do if((Cb|0)==(ga|0)){f[x>>2]=f[w>>2];Bb=f[Ja>>2]|0;f[Ia>>2]=Bb;f[Ka>>2]=f[La>>2];f[Ma>>2]=f[Na>>2];f[Oa>>2]=f[Pa>>2];f[Qa>>2]=f[Ra>>2];f[Sa>>2]=f[Ta>>2];f[Ua>>2]=f[Va>>2];f[Wa>>2]=f[Xa>>2];Ab=f[Za>>2]|0;f[Ya>>2]=Ab;f[_a>>2]=Ka;f[ab>>2]=$a;f[$a>>2]=0;f[bb>>2]=0;if(!Ab)Eb=Bb;else{Bb=Ab+12|0;f[Bb>>2]=(f[Bb>>2]|0)+1;Eb=f[Ja>>2]|0}if((Eb|0)<3){Bb=f[cb>>2]|0;Ab=f[ab>>2]|0;f[Ab>>2]=f[Bb>>2];f[Ab+4>>2]=f[Bb+4>>2];break}else{f[Ia>>2]=0;jL(x,w);break}}else{Bb=f[S>>2]|0;Ab=f[Bb+4>>2]|0;Fb=f[Bb>>2]|0;Bb=f[m>>2]|0;Gb=Cb&4095|1124007936;f[x>>2]=Gb;f[Ia>>2]=2;f[Ka>>2]=Fb;f[Ma>>2]=Ab;f[Oa>>2]=Bb;f[Qa>>2]=Bb;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;f[_a>>2]=Ka;f[ab>>2]=$a;f[bb>>2]=0;f[$a>>2]=0;if((Y(Fb,Ab)|0)!=0&(Bb|0)==0){f[l>>2]=0;f[eb>>2]=0;ba=aD(l,26)|0;ca=426262;da=ba+26|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));bO(-215,l,426289,431198,533);bD(l);Hb=f[Ma>>2]|0;Ib=f[x>>2]|0;Jb=f[ab>>2]|0;Kb=f[Qa>>2]|0}else{Hb=Ab;Ib=Gb;Jb=$a;Kb=Bb}Fb=(Cb>>>3&511)+1<<(47696>>>(Cb<<1&14)&3);Lb=Y(Hb,Fb)|0;f[x>>2]=Ib|16384;f[Jb>>2]=Lb;f[Jb+4>>2]=Fb;Fb=Kb+(Y(f[Ka>>2]|0,Lb)|0)|0;f[Ua>>2]=Fb;f[Sa>>2]=Fb+(0-Lb)+Lb}while(0);Cb=f[Ya>>2]|0;if(Cb|0){Lb=Cb+12|0;f[Lb>>2]=(f[Lb>>2]|0)+1}Lb=f[xa>>2]|0;do if(Lb|0){Cb=Lb+12|0;Fb=f[Cb>>2]|0;f[Cb>>2]=Fb+-1;if((Fb|0)!=1)break;kL(t)}while(0);f[xa>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Z>>2]|0)>0){Lb=f[ya>>2]|0;Fb=0;do{f[Lb+(Fb<<2)>>2]=0;Fb=Fb+1|0;Mb=f[Z>>2]|0}while((Fb|0)<(Mb|0));f[t>>2]=f[x>>2];if((Mb|0)<3)Nb=66;else Nb=68}else{f[t>>2]=f[x>>2];Nb=66}do if((Nb|0)==66){Nb=0;Fb=f[Ia>>2]|0;if((Fb|0)>=3){Nb=68;break}f[Z>>2]=Fb;f[va>>2]=f[Ka>>2];f[ta>>2]=f[Ma>>2];Fb=f[ab>>2]|0;Lb=f[Aa>>2]|0;f[Lb>>2]=f[Fb>>2];f[Lb+4>>2]=f[Fb+4>>2]}while(0);if((Nb|0)==68){Nb=0;jL(t,x)}f[_>>2]=f[Oa>>2];f[I>>2]=f[Qa>>2];f[sa>>2]=f[Sa>>2];f[ua>>2]=f[Ua>>2];f[wa>>2]=f[Wa>>2];Fb=f[Ya>>2]|0;f[xa>>2]=Fb;do if(Fb|0){Lb=Fb+12|0;Cb=f[Lb>>2]|0;f[Lb>>2]=Cb+-1;if((Cb|0)!=1)break;kL(x)}while(0);f[Ya>>2]=0;f[Oa>>2]=0;f[Oa+4>>2]=0;f[Oa+8>>2]=0;f[Oa+12>>2]=0;if((f[Ia>>2]|0)>0){Fb=f[_a>>2]|0;Cb=0;do{f[Fb+(Cb<<2)>>2]=0;Cb=Cb+1|0}while((Cb|0)<(f[Ia>>2]|0))}Cb=f[ab>>2]|0;if((Cb|0)!=($a|0))UC(Cb);f[l>>2]=zb;f[db>>2]=0;zI(n,1,t,1,l,1)}if((f[Pa>>2]|0)!=(f[_>>2]|0)){Cb=xb;f[Cb>>2]=0;f[Cb+4>>2]=0;f[l>>2]=33619968;f[yb>>2]=w;OJ(t,l,f[w>>2]&7,1.0,0.0)}Cb=f[fb>>2]|0;Fb=f[K>>2]|0;if((Cb|0)>(Fb|0)){Lb=f[J>>2]|0;f[x>>2]=0;f[gb>>2]=Lb;f[y>>2]=Fb;f[hb>>2]=Cb;lL(l,v,x,y);f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[x+28>>2]=0;UP(l,x)|0;Cb=f[ib>>2]|0;do if(Cb|0){Fb=Cb+12|0;Lb=f[Fb>>2]|0;f[Fb>>2]=Lb+-1;if((Lb|0)!=1)break;kL(l)}while(0);f[ib>>2]=0;f[jb>>2]=0;f[jb+4>>2]=0;f[jb+8>>2]=0;f[jb+12>>2]=0;if((f[kb>>2]|0)>0){Cb=f[lb>>2]|0;Lb=0;do{f[Cb+(Lb<<2)>>2]=0;Lb=Lb+1|0}while((Lb|0)<(f[kb>>2]|0))}Lb=f[mb>>2]|0;if((Lb|0)!=(nb|0))UC(Lb)}Lb=f[ob>>2]|0;Cb=f[pb>>2]|0;Fb=f[qb>>2]|0;uh[f[f[Lb>>2]>>2]&255](Lb,Cb,Fb,Cb,Fb);Fb=f[Za>>2]|0;do if(Fb|0){Cb=Fb+12|0;Lb=f[Cb>>2]|0;f[Cb>>2]=Lb+-1;if((Lb|0)!=1)break;kL(w)}while(0);f[Za>>2]=0;f[Pa>>2]=0;f[Pa+4>>2]=0;f[Pa+8>>2]=0;f[Pa+12>>2]=0;if((f[Ja>>2]|0)>0){Fb=f[rb>>2]|0;Lb=0;do{f[Fb+(Lb<<2)>>2]=0;Lb=Lb+1|0}while((Lb|0)<(f[Ja>>2]|0))}Lb=f[cb>>2]|0;if((Lb|0)!=(sb|0))UC(Lb);Lb=f[tb>>2]|0;do if(Lb|0){Fb=Lb+12|0;Cb=f[Fb>>2]|0;f[Fb>>2]=Cb+-1;if((Cb|0)!=1)break;kL(v)}while(0);f[tb>>2]=0;f[pb>>2]=0;f[pb+4>>2]=0;f[pb+8>>2]=0;f[pb+12>>2]=0;if((f[ub>>2]|0)>0){Lb=f[vb>>2]|0;Cb=0;do{f[Lb+(Cb<<2)>>2]=0;Cb=Cb+1|0}while((Cb|0)<(f[ub>>2]|0))}Cb=f[wb>>2]|0;if((Cb|0)!=(qb|0))UC(Cb);Cb=f[xa>>2]|0;do if(Cb|0){Lb=Cb+12|0;Fb=f[Lb>>2]|0;f[Lb>>2]=Fb+-1;if((Fb|0)!=1)break;kL(t)}while(0);f[xa>>2]=0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Z>>2]|0)>0){Cb=f[ya>>2]|0;Fb=0;do{f[Cb+(Fb<<2)>>2]=0;Fb=Fb+1|0}while((Fb|0)<(f[Z>>2]|0))}Fb=f[Aa>>2]|0;if((Fb|0)!=(za|0))UC(Fb);if((zb|0)<(X|0))zb=zb+1|0;else break}zb=(e+-1+(f[$>>2]|0)|0)/(e|0)|0;X=ea+-1|0;za=Y((X+(f[ia>>2]|0)|0)/(ea|0)|0,zb)|0;Aa=f[a+40>>2]|0;Z=f[Aa>>2]|0;f[t>>2]=f[Aa+4>>2];Aa=t+4|0;f[Aa>>2]=Z;f[v>>2]=0;Z=v+4|0;f[Z>>2]=0;f[w>>2]=f[a>>2];ya=w+4|0;_=f[aa>>2]|0;f[ya>>2]=_;xa=w+8|0;f[xa>>2]=f[c>>2];qb=w+12|0;wb=a+12|0;f[qb>>2]=f[wb>>2];ub=w+16|0;f[ub>>2]=f[a+16>>2];f[w+20>>2]=f[a+20>>2];f[w+24>>2]=f[a+24>>2];f[w+28>>2]=f[a+28>>2];f[w+32>>2]=f[a+32>>2];vb=w+36|0;pb=f[a+36>>2]|0;f[vb>>2]=pb;tb=w+40|0;f[tb>>2]=xa;sb=w+48|0;cb=w+44|0;f[cb>>2]=sb;f[sb>>2]=0;f[w+52>>2]=0;if(!pb)Ob=_;else{_=pb+12|0;f[_>>2]=(f[_>>2]|0)+1;Ob=f[aa>>2]|0}if((Ob|0)<3){Ob=f[a+44>>2]|0;aa=f[cb>>2]|0;f[aa>>2]=f[Ob>>2];f[aa+4>>2]=f[Ob+4>>2]}else{f[ya>>2]=0;jL(w,a)}if(!(j&16)){uL(a,t,v);a=f[Z>>2]|0;Ob=f[v>>2]|0;vL(w,a,(f[Aa>>2]|0)-a-(f[c>>2]|0)|0,Ob,(f[t>>2]|0)-Ob-(f[wb>>2]|0)|0)|0}wb=j|16;CC(l,g,ka,ga,1,1,1024,X+(f[J>>2]|0)|0);X=f[l>>2]|0;j=f[l+4>>2]|0;Ob=(X|0)==0;t=X;if(Ob){Pb=l;Qb=t}else{c=t+4|0;f[c>>2]=(f[c>>2]|0)+1;Pb=l;Qb=f[l>>2]|0}do if(Qb|0){c=Qb+4|0;a=f[c>>2]|0;f[c>>2]=a+-1;if((a|0)!=1)break;bi[f[(f[Qb>>2]|0)+8>>2]&2047](Qb)}while(0);f[Pb>>2]=0;CC(l,g,ka,ga,1,1,1027,ea);Pb=f[l>>2]|0;Qb=f[l+4>>2]|0;a=(Pb|0)==0;c=Pb;if(a){Rb=l;Sb=c}else{Aa=c+4|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Rb=l;Sb=f[l>>2]|0}do if(Sb|0){Aa=Sb+4|0;aa=f[Aa>>2]|0;f[Aa>>2]=aa+-1;if((aa|0)!=1)break;bi[f[(f[Sb>>2]|0)+8>>2]&2047](Sb)}while(0);f[Rb>>2]=0;if((za|0)>0){Rb=h+4|0;Sb=l+4|0;aa=y+4|0;Aa=l+4|0;_=l+8|0;pb=l+12|0;Ja=l+4|0;rb=l+8|0;Pa=l+12|0;Za=l+4|0;ob=l+8|0;nb=l+12|0;mb=B+4|0;kb=x+4|0;lb=B+8|0;jb=x+8|0;ib=B+12|0;hb=x+12|0;gb=B+16|0;fb=x+16|0;yb=B+20|0;xb=x+20|0;db=B+24|0;$a=x+24|0;ab=B+28|0;Ia=x+28|0;_a=B+32|0;Oa=x+32|0;Ya=B+36|0;Wa=x+36|0;wa=B+40|0;Ua=B+48|0;ua=B+44|0;Sa=B+52|0;sa=x+44|0;Qa=C+4|0;I=z+4|0;Ma=C+8|0;ta=z+8|0;Ka=C+12|0;va=z+12|0;Mb=C+16|0;Kb=z+16|0;Jb=C+20|0;Ib=z+20|0;Hb=C+24|0;eb=z+24|0;bb=C+28|0;Eb=z+28|0;Xa=C+32|0;Va=z+32|0;Ta=C+36|0;Ra=z+36|0;Na=C+40|0;La=C+48|0;o=C+44|0;Ha=C+52|0;Ga=z+44|0;Fa=l+4|0;Ea=H|1124007936;Da=l+4|0;Ca=47696>>>(H<<1)&3;H=1<<Ca;Db=l+8|0;Ba=l+12|0;P=l+4|0;O=C+8|0;N=C+4|0;M=y+8|0;Fb=y+12|0;Cb=r+16|0;Lb=C+4|0;Tb=C+8|0;Ub=C+12|0;Vb=C+8|0;Wb=C+12|0;Xb=C+4|0;Yb=D+8|0;Zb=D+12|0;_b=D+4|0;$b=E+8|0;ac=E+4|0;bc=D+4|0;cc=D+8|0;dc=D+12|0;ec=C+36|0;fc=C+4|0;gc=C+8|0;hc=C+12|0;ic=C+44|0;jc=C+16|0;kc=C+20|0;lc=C+24|0;mc=C+28|0;nc=C+32|0;oc=C+40|0;pc=C+48|0;qc=C+8|0;rc=C+4|0;sc=C+8|0;tc=C+12|0;uc=C+4|0;vc=D+8|0;wc=D+12|0;xc=D+4|0;yc=E+8|0;zc=E+4|0;Ac=C+4|0;Bc=C+8|0;Cc=C+12|0;Dc=C+16|0;Ec=C+20|0;Fc=C+24|0;Gc=C+28|0;Hc=C+40|0;Ic=C+48|0;Jc=C+44|0;Kc=D+8|0;Lc=D+4|0;Mc=C+36|0;Nc=C+32|0;Oc=l+36|0;Pc=l+16|0;Qc=l+4|0;Rc=l+40|0;Sc=l+44|0;Tc=l+48|0;Uc=C+4|0;Vc=C+4|0;Wc=C+8|0;Xc=C+12|0;Yc=C+16|0;Zc=C+20|0;_c=C+24|0;$c=C+28|0;ad=C+40|0;bd=C+48|0;cd=C+44|0;dd=D+8|0;ed=D+4|0;fd=C+36|0;gd=C+32|0;hd=C+8|0;id=C+12|0;jd=C+4|0;kd=D+8|0;ld=D+4|0;md=l+8|0;nd=l+12|0;od=l+4|0;pd=C+8|0;qd=C+4|0;rd=l+8|0;sd=l+4|0;td=A+36|0;ud=A+16|0;vd=A+4|0;wd=A+40|0;xd=A+44|0;yd=A+48|0;zd=z+40|0;Ad=z+48|0;Bd=y+36|0;Cd=y+16|0;Dd=y+4|0;Ed=y+40|0;Fd=y+44|0;Gd=y+48|0;Hd=x+40|0;Id=x+48|0;Jd=Fc+8|0;Kd=C+52|0;Ld=_c+8|0;Md=C+52|0;Nd=0;do{Od=Y((Nd|0)%(zb|0)|0,e)|0;Pd=Y((Nd|0)/(zb|0)|0,ea)|0;Qd=(f[$>>2]|0)-Od|0;Rd=(Qd|0)<(e|0)?Qd:e;Qd=(f[ia>>2]|0)-Pd|0;Sd=(Qd|0)<(ea|0)?Qd:ea;Td=(f[K>>2]|0)+-1+Rd|0;Ud=(f[J>>2]|0)+-1+Sd|0;Vd=Od-(f[h>>2]|0)+(f[v>>2]|0)|0;Wd=Pd-(f[Rb>>2]|0)+(f[Z>>2]|0)|0;Xd=(Vd|0)>0?Vd:0;Yd=(Wd|0)>0?Wd:0;Zd=Vd+Td|0;_d=f[qb>>2]|0;$d=(Zd|0)<(_d|0)?Zd:_d;_d=Wd+Ud|0;Zd=f[xa>>2]|0;ae=(_d|0)<(Zd|0)?_d:Zd;f[l>>2]=Yd;f[Sb>>2]=ae;f[y>>2]=Xd;f[aa>>2]=$d;lL(x,w,l,y);f[l>>2]=0;f[Aa>>2]=0;f[_>>2]=Td;f[pb>>2]=Ud;nL(y,r,l);Zd=Xd-Vd|0;Vd=Yd-Wd|0;Wd=$d-Xd|0;Xd=ae-Yd|0;f[l>>2]=Zd;f[Ja>>2]=Vd;f[rb>>2]=Wd;f[Pa>>2]=Xd;nL(z,r,l);f[l>>2]=Od;f[Za>>2]=Pd;f[ob>>2]=Rd;f[nb>>2]=Sd;nL(A,d,l);Pd=(Y(Xd,Wd)|0)!=0;Od=(Wd|0)<(Td|0)|(Xd|0)<(Ud|0);Td=(ea|0)<=(Qd|0);Qd=0;while(1){f[B>>2]=f[x>>2];Yd=f[kb>>2]|0;f[mb>>2]=Yd;f[lb>>2]=f[jb>>2];f[ib>>2]=f[hb>>2];f[gb>>2]=f[fb>>2];f[yb>>2]=f[xb>>2];f[db>>2]=f[$a>>2];f[ab>>2]=f[Ia>>2];f[_a>>2]=f[Oa>>2];ae=f[Wa>>2]|0;f[Ya>>2]=ae;f[wa>>2]=lb;f[ua>>2]=Ua;f[Ua>>2]=0;f[Sa>>2]=0;if(!ae)be=Yd;else{Yd=ae+12|0;f[Yd>>2]=(f[Yd>>2]|0)+1;be=f[kb>>2]|0}if((be|0)<3){Yd=f[sa>>2]|0;ae=f[ua>>2]|0;f[ae>>2]=f[Yd>>2];f[ae+4>>2]=f[Yd+4>>2]}else{f[mb>>2]=0;jL(B,x)};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;UP(r,l)|0;if(fa){do if(ha){f[C>>2]=f[z>>2];Yd=f[I>>2]|0;f[Qa>>2]=Yd;f[Ma>>2]=f[ta>>2];f[Ka>>2]=f[va>>2];f[Mb>>2]=f[Kb>>2];f[Jb>>2]=f[Ib>>2];f[Hb>>2]=f[eb>>2];f[bb>>2]=f[Eb>>2];f[Xa>>2]=f[Va>>2];ae=f[Ra>>2]|0;f[Ta>>2]=ae;f[Na>>2]=Ma;f[o>>2]=La;f[La>>2]=0;f[Ha>>2]=0;if(!ae)ce=Yd;else{Yd=ae+12|0;f[Yd>>2]=(f[Yd>>2]|0)+1;ce=f[I>>2]|0}if((ce|0)<3){Yd=f[Ga>>2]|0;ae=f[o>>2]|0;f[ae>>2]=f[Yd>>2];f[ae+4>>2]=f[Yd+4>>2];break}else{f[Qa>>2]=0;jL(C,z);break}}else{Yd=f[m>>2]|0;f[C>>2]=Ea;f[Qa>>2]=2;f[Ma>>2]=Xd;f[Ka>>2]=Wd;f[Mb>>2]=Yd;f[Jb>>2]=Yd;f[Hb>>2]=0;f[Hb+4>>2]=0;f[Hb+8>>2]=0;f[Hb+12>>2]=0;f[Na>>2]=Ma;f[o>>2]=La;f[Ha>>2]=0;f[La>>2]=0;if(Pd&(Yd|0)==0){f[l>>2]=0;f[Da>>2]=0;ba=aD(l,26)|0;ca=426262;da=ba+26|0;do{b[ba>>0]=b[ca>>0]|0;ba=ba+1|0;ca=ca+1|0}while((ba|0)<(da|0));bO(-215,l,426289,431198,500);bD(l);de=f[Ka>>2]|0;ee=f[C>>2]|0;fe=f[o>>2]|0;ge=f[Jb>>2]|0}else{de=Wd;ee=Ea;fe=La;ge=Yd}ae=de<<Ca;f[C>>2]=ee|16384;f[fe>>2]=ae;f[fe+4>>2]=H;$d=ge+(Y(f[Ma>>2]|0,ae)|0)|0;f[bb>>2]=$d;f[Hb>>2]=$d+(0-ae)+ae}while(0);Bb=f[Ta>>2]|0;if(Bb|0){Gb=Bb+12|0;f[Gb>>2]=(f[Gb>>2]|0)+1}Gb=f[Ya>>2]|0;do if(Gb|0){Bb=Gb+12|0;Ab=f[Bb>>2]|0;f[Bb>>2]=Ab+-1;if((Ab|0)!=1)break;kL(B)}while(0);f[Ya>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[mb>>2]|0)>0){Gb=f[wa>>2]|0;Ab=0;do{f[Gb+(Ab<<2)>>2]=0;Ab=Ab+1|0;he=f[mb>>2]|0}while((Ab|0)<(he|0));f[B>>2]=f[C>>2];if((he|0)<3)Nb=162;else Nb=164}else{f[B>>2]=f[C>>2];Nb=162}do if((Nb|0)==162){Nb=0;Ab=f[Qa>>2]|0;if((Ab|0)>=3){Nb=164;break}f[mb>>2]=Ab;f[lb>>2]=f[Ma>>2];f[ib>>2]=f[Ka>>2];Ab=f[o>>2]|0;Gb=f[ua>>2]|0;f[Gb>>2]=f[Ab>>2];f[Gb+4>>2]=f[Ab+4>>2]}while(0);if((Nb|0)==164){Nb=0;jL(B,C)}f[gb>>2]=f[Mb>>2];f[yb>>2]=f[Jb>>2];f[db>>2]=f[Hb>>2];f[ab>>2]=f[bb>>2];f[_a>>2]=f[Xa>>2];Ab=f[Ta>>2]|0;f[Ya>>2]=Ab;do if(Ab|0){Gb=Ab+12|0;Bb=f[Gb>>2]|0;f[Gb>>2]=Bb+-1;if((Bb|0)!=1)break;kL(C)}while(0);f[Ta>>2]=0;f[Mb>>2]=0;f[Mb+4>>2]=0;f[Mb+8>>2]=0;f[Mb+12>>2]=0;if((f[Qa>>2]|0)>0){Ab=f[Na>>2]|0;Bb=0;do{f[Ab+(Bb<<2)>>2]=0;Bb=Bb+1|0}while((Bb|0)<(f[Qa>>2]|0))}Bb=f[o>>2]|0;if((Bb|0)!=(La|0))UC(Bb);f[l>>2]=Qd;f[Fa>>2]=0;zI(x,1,B,1,l,1)}if((f[Kb>>2]|0)!=(f[gb>>2]|0)){Bb=rd;f[Bb>>2]=0;f[Bb+4>>2]=0;f[l>>2]=33619968;f[sd>>2]=z;OJ(B,l,f[z>>2]&7,1.0,0.0)}if(Od){f[Db>>2]=0;f[Ba>>2]=0;f[l>>2]=16842752;f[P>>2]=z;Bb=O;f[Bb>>2]=0;f[Bb+4>>2]=0;f[C>>2]=33619968;f[N>>2]=y;Bb=f[M>>2]|0;Ab=f[ta>>2]|0;Gb=f[Fb>>2]|0;ae=f[va>>2]|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;f[D+16>>2]=0;f[D+20>>2]=0;f[D+24>>2]=0;f[D+28>>2]=0;_P(l,C,Vd,Bb-Vd-Ab|0,Zd,Gb-Zd-ae|0,wb,D)}if(Td){ae=f[Cb>>2]|0;Gb=f[pa>>2]|0;uh[f[f[j>>2]>>2]&255](j,ae,Gb,ae,Gb)}else{f[md>>2]=0;f[nd>>2]=0;f[l>>2]=16842752;f[od>>2]=r;Gb=pd;f[Gb>>2]=0;f[Gb+4>>2]=0;f[C>>2]=33619968;f[qd>>2]=r;QC(l,C,0,Ud)}Gb=Y(Qd,ka)|0;f[C>>2]=0;f[Lb>>2]=na?Gb:0;f[Tb>>2]=g;f[Ub>>2]=ka;nL(l,q,C);f[Vb>>2]=0;f[Wb>>2]=0;f[C>>2]=16842752;f[Xb>>2]=r;f[Yb>>2]=0;f[Zb>>2]=0;f[D>>2]=16842752;f[_b>>2]=l;Gb=$b;f[Gb>>2]=0;f[Gb+4>>2]=0;f[E>>2]=33619968;f[ac>>2]=r;RC(C,D,E,0,1);if(Td){Gb=f[Cb>>2]|0;ae=f[pa>>2]|0;uh[f[f[Qb>>2]>>2]&255](Qb,Gb,ae,Gb,ae)}else{f[hd>>2]=0;f[id>>2]=0;f[C>>2]=16842752;f[jd>>2]=r;ae=kd;f[ae>>2]=0;f[ae+4>>2]=0;f[D>>2]=33619968;f[ld>>2]=r;QC(C,D,3,Sd)}f[D>>2]=0;f[bc>>2]=0;f[cc>>2]=Rd;f[dc>>2]=Sd;nL(C,r,D);ae=f[ec>>2]|0;if(ae|0){Gb=ae+12|0;f[Gb>>2]=(f[Gb>>2]|0)+1}Gb=f[Ya>>2]|0;do if(Gb|0){ae=Gb+12|0;Ab=f[ae>>2]|0;f[ae>>2]=Ab+-1;if((Ab|0)!=1)break;kL(B)}while(0);f[Ya>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[mb>>2]|0)>0){Gb=f[wa>>2]|0;Ab=0;do{f[Gb+(Ab<<2)>>2]=0;Ab=Ab+1|0;ie=f[mb>>2]|0}while((Ab|0)<(ie|0));f[B>>2]=f[C>>2];if((ie|0)<3)Nb=194;else Nb=196}else{f[B>>2]=f[C>>2];Nb=194}do if((Nb|0)==194){Nb=0;Ab=f[fc>>2]|0;if((Ab|0)>=3){Nb=196;break}f[mb>>2]=Ab;f[lb>>2]=f[gc>>2];f[ib>>2]=f[hc>>2];Ab=f[ic>>2]|0;Gb=f[ua>>2]|0;f[Gb>>2]=f[Ab>>2];f[Gb+4>>2]=f[Ab+4>>2]}while(0);if((Nb|0)==196){Nb=0;jL(B,C)}f[gb>>2]=f[jc>>2];f[yb>>2]=f[kc>>2];f[db>>2]=f[lc>>2];f[ab>>2]=f[mc>>2];f[_a>>2]=f[nc>>2];Ab=f[ec>>2]|0;f[Ya>>2]=Ab;do if(Ab|0){Gb=Ab+12|0;ae=f[Gb>>2]|0;f[Gb>>2]=ae+-1;if((ae|0)!=1)break;kL(C)}while(0);f[ec>>2]=0;f[jc>>2]=0;f[jc+4>>2]=0;f[jc+8>>2]=0;f[jc+12>>2]=0;if((f[fc>>2]|0)>0){Ab=f[oc>>2]|0;ae=0;do{f[Ab+(ae<<2)>>2]=0;ae=ae+1|0}while((ae|0)<(f[fc>>2]|0))}ae=f[ic>>2]|0;if((ae|0)!=(pc|0))UC(ae);do if(W){if(!Qd){ae=qc;f[ae>>2]=0;f[ae+4>>2]=0;f[C>>2]=33619968;f[rc>>2]=A;OJ(B,C,f[p>>2]|0,1.0,i);break}ae=f[p>>2]|0;if((ga|0)!=(ae|0)){Ab=f[m>>2]|0;f[Ac>>2]=2;f[Bc>>2]=Sd;f[Cc>>2]=Rd;f[Dc>>2]=Ab;f[Ec>>2]=Ab;Gb=Jd;f[Gb>>2]=0;f[Gb+4>>2]=0;f[Hc>>2]=Bc;f[Jc>>2]=Ic;Gb=(ae>>>3&511)+1<<(47696>>>(ae<<1&14)&3);Bb=Y(Gb,Rd)|0;f[C>>2]=ae&4095|1124024320;f[Ic>>2]=Bb;f[Kd>>2]=Gb;Gb=Ab+(Y(Sd,Bb)|0)|0;f[Gc>>2]=Gb;f[Fc>>2]=Gb+(0-Bb)+Bb;Bb=Kc;f[Bb>>2]=0;f[Bb+4>>2]=0;f[D>>2]=33619968;f[Lc>>2]=C;OJ(B,D,ae,1.0,0.0);ae=f[Mc>>2]|0;if(ae|0){Bb=ae+12|0;f[Bb>>2]=(f[Bb>>2]|0)+1}Bb=f[Ya>>2]|0;do if(Bb|0){ae=Bb+12|0;Gb=f[ae>>2]|0;f[ae>>2]=Gb+-1;if((Gb|0)!=1)break;kL(B)}while(0);f[Ya>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[mb>>2]|0)>0){Bb=f[wa>>2]|0;Yd=0;do{f[Bb+(Yd<<2)>>2]=0;Yd=Yd+1|0;je=f[mb>>2]|0}while((Yd|0)<(je|0));f[B>>2]=f[C>>2];if((je|0)<3)Nb=243;else Nb=245}else{f[B>>2]=f[C>>2];Nb=243}do if((Nb|0)==243){Nb=0;Yd=f[Ac>>2]|0;if((Yd|0)>=3){Nb=245;break}f[mb>>2]=Yd;f[lb>>2]=f[Bc>>2];f[ib>>2]=f[Cc>>2];Yd=f[Jc>>2]|0;Bb=f[ua>>2]|0;f[Bb>>2]=f[Yd>>2];f[Bb+4>>2]=f[Yd+4>>2]}while(0);if((Nb|0)==245){Nb=0;jL(B,C)}f[gb>>2]=f[Dc>>2];f[yb>>2]=f[Ec>>2];f[db>>2]=f[Fc>>2];f[ab>>2]=f[Gc>>2];f[_a>>2]=f[Nc>>2];Yd=f[Mc>>2]|0;f[Ya>>2]=Yd;do if(Yd|0){Bb=Yd+12|0;Gb=f[Bb>>2]|0;f[Bb>>2]=Gb+-1;if((Gb|0)!=1)break;kL(C)}while(0);f[Mc>>2]=0;f[Dc>>2]=0;f[Dc+4>>2]=0;f[Dc+8>>2]=0;f[Dc+12>>2]=0;if((f[Ac>>2]|0)>0){Yd=f[Hc>>2]|0;Gb=0;do{f[Yd+(Gb<<2)>>2]=0;Gb=Gb+1|0}while((Gb|0)<(f[Ac>>2]|0))}Gb=f[Jc>>2]|0;if((Gb|0)!=(Ic|0))UC(Gb)}f[sc>>2]=0;f[tc>>2]=0;f[C>>2]=16842752;f[uc>>2]=B;f[vc>>2]=0;f[wc>>2]=0;f[D>>2]=16842752;f[xc>>2]=A;Gb=yc;f[Gb>>2]=0;f[Gb+4>>2]=0;f[E>>2]=33619968;f[zc>>2]=A;VD(C,D,E,UM()|0,-1)}else{Gb=f[p>>2]|0;if((Gb|0)!=(ga|0)){Yd=f[m>>2]|0;f[Vc>>2]=2;f[Wc>>2]=Sd;f[Xc>>2]=Rd;f[Yc>>2]=Yd;f[Zc>>2]=Yd;Bb=Ld;f[Bb>>2]=0;f[Bb+4>>2]=0;f[ad>>2]=Wc;f[cd>>2]=bd;Bb=(Gb>>>3&511)+1<<(47696>>>(Gb<<1&14)&3);ae=Y(Bb,Rd)|0;f[C>>2]=Gb&4095|1124024320;f[bd>>2]=ae;f[Md>>2]=Bb;Bb=Yd+(Y(Sd,ae)|0)|0;f[$c>>2]=Bb;f[_c>>2]=Bb+(0-ae)+ae;ae=dd;f[ae>>2]=0;f[ae+4>>2]=0;f[D>>2]=33619968;f[ed>>2]=C;OJ(B,D,Gb,1.0,i);Gb=f[fd>>2]|0;if(Gb|0){ae=Gb+12|0;f[ae>>2]=(f[ae>>2]|0)+1}ae=f[Ya>>2]|0;do if(ae|0){Gb=ae+12|0;Bb=f[Gb>>2]|0;f[Gb>>2]=Bb+-1;if((Bb|0)!=1)break;kL(B)}while(0);f[Ya>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[mb>>2]|0)>0){ae=f[wa>>2]|0;Bb=0;do{f[ae+(Bb<<2)>>2]=0;Bb=Bb+1|0;ke=f[mb>>2]|0}while((Bb|0)<(ke|0));f[B>>2]=f[C>>2];if((ke|0)<3)Nb=217;else Nb=219}else{f[B>>2]=f[C>>2];Nb=217}do if((Nb|0)==217){Nb=0;Bb=f[Vc>>2]|0;if((Bb|0)>=3){Nb=219;break}f[mb>>2]=Bb;f[lb>>2]=f[Wc>>2];f[ib>>2]=f[Xc>>2];Bb=f[cd>>2]|0;ae=f[ua>>2]|0;f[ae>>2]=f[Bb>>2];f[ae+4>>2]=f[Bb+4>>2]}while(0);if((Nb|0)==219){Nb=0;jL(B,C)}f[gb>>2]=f[Yc>>2];f[yb>>2]=f[Zc>>2];f[db>>2]=f[_c>>2];f[ab>>2]=f[$c>>2];f[_a>>2]=f[gd>>2];Bb=f[fd>>2]|0;f[Ya>>2]=Bb;do if(Bb|0){ae=Bb+12|0;Gb=f[ae>>2]|0;f[ae>>2]=Gb+-1;if((Gb|0)!=1)break;kL(C)}while(0);f[fd>>2]=0;f[Yc>>2]=0;f[Yc+4>>2]=0;f[Yc+8>>2]=0;f[Yc+12>>2]=0;if((f[Vc>>2]|0)>0){Bb=f[ad>>2]|0;Gb=0;do{f[Bb+(Gb<<2)>>2]=0;Gb=Gb+1|0}while((Gb|0)<(f[Vc>>2]|0))}Gb=f[cd>>2]|0;if((Gb|0)!=(bd|0))UC(Gb)}f[C>>2]=0;f[Uc>>2]=Qd;zI(B,1,A,1,C,1)}while(0);Gb=f[Oc>>2]|0;do if(Gb|0){Bb=Gb+12|0;ae=f[Bb>>2]|0;f[Bb>>2]=ae+-1;if((ae|0)!=1)break;kL(l)}while(0);f[Oc>>2]=0;f[Pc>>2]=0;f[Pc+4>>2]=0;f[Pc+8>>2]=0;f[Pc+12>>2]=0;if((f[Qc>>2]|0)>0){Gb=f[Rc>>2]|0;ae=0;do{f[Gb+(ae<<2)>>2]=0;ae=ae+1|0}while((ae|0)<(f[Qc>>2]|0))}ae=f[Sc>>2]|0;if((ae|0)!=(Tc|0))UC(ae);ae=f[Ya>>2]|0;do if(ae|0){Gb=ae+12|0;Bb=f[Gb>>2]|0;f[Gb>>2]=Bb+-1;if((Bb|0)!=1)break;kL(B)}while(0);f[Ya>>2]=0;f[gb>>2]=0;f[gb+4>>2]=0;f[gb+8>>2]=0;f[gb+12>>2]=0;if((f[mb>>2]|0)>0){ae=f[wa>>2]|0;Bb=0;do{f[ae+(Bb<<2)>>2]=0;Bb=Bb+1|0}while((Bb|0)<(f[mb>>2]|0))}Bb=f[ua>>2]|0;if((Bb|0)!=(Ua|0))UC(Bb);if((Qd|0)<(V|0))Qd=Qd+1|0;else break}Qd=f[td>>2]|0;do if(Qd|0){Sd=Qd+12|0;Rd=f[Sd>>2]|0;f[Sd>>2]=Rd+-1;if((Rd|0)!=1)break;kL(A)}while(0);f[td>>2]=0;f[ud>>2]=0;f[ud+4>>2]=0;f[ud+8>>2]=0;f[ud+12>>2]=0;if((f[vd>>2]|0)>0){Qd=f[wd>>2]|0;Rd=0;do{f[Qd+(Rd<<2)>>2]=0;Rd=Rd+1|0}while((Rd|0)<(f[vd>>2]|0))}Rd=f[xd>>2]|0;if((Rd|0)!=(yd|0))UC(Rd);Rd=f[Ra>>2]|0;do if(Rd|0){Qd=Rd+12|0;Sd=f[Qd>>2]|0;f[Qd>>2]=Sd+-1;if((Sd|0)!=1)break;kL(z)}while(0);f[Ra>>2]=0;f[Kb>>2]=0;f[Kb+4>>2]=0;f[Kb+8>>2]=0;f[Kb+12>>2]=0;if((f[I>>2]|0)>0){Rd=f[zd>>2]|0;Sd=0;do{f[Rd+(Sd<<2)>>2]=0;Sd=Sd+1|0}while((Sd|0)<(f[I>>2]|0))}Sd=f[Ga>>2]|0;if((Sd|0)!=(Ad|0))UC(Sd);Sd=f[Bd>>2]|0;do if(Sd|0){Rd=Sd+12|0;Qd=f[Rd>>2]|0;f[Rd>>2]=Qd+-1;if((Qd|0)!=1)break;kL(y)}while(0);f[Bd>>2]=0;f[Cd>>2]=0;f[Cd+4>>2]=0;f[Cd+8>>2]=0;f[Cd+12>>2]=0;if((f[Dd>>2]|0)>0){Sd=f[Ed>>2]|0;Qd=0;do{f[Sd+(Qd<<2)>>2]=0;Qd=Qd+1|0}while((Qd|0)<(f[Dd>>2]|0))}Qd=f[Fd>>2]|0;if((Qd|0)!=(Gd|0))UC(Qd);Qd=f[Wa>>2]|0;do if(Qd|0){Sd=Qd+12|0;Rd=f[Sd>>2]|0;f[Sd>>2]=Rd+-1;if((Rd|0)!=1)break;kL(x)}while(0);f[Wa>>2]=0;f[fb>>2]=0;f[fb+4>>2]=0;f[fb+8>>2]=0;f[fb+12>>2]=0;if((f[kb>>2]|0)>0){Qd=f[Hd>>2]|0;Rd=0;do{f[Qd+(Rd<<2)>>2]=0;Rd=Rd+1|0}while((Rd|0)<(f[kb>>2]|0))}Rd=f[sa>>2]|0;if((Rd|0)!=(Id|0))UC(Rd);Nd=Nd+1|0}while((Nd|0)<(za|0))}do if(!a){za=c+4|0;Nd=f[za>>2]|0;f[za>>2]=Nd+-1;if((Nd|0)!=1)break;bi[f[(f[Pb>>2]|0)+8>>2]&2047](c)}while(0);do if(!Ob){c=t+4|0;Pb=f[c>>2]|0;f[c>>2]=Pb+-1;if((Pb|0)!=1)break;bi[f[(f[X>>2]|0)+8>>2]&2047](t)}while(0);t=f[vb>>2]|0;do if(t|0){X=t+12|0;Ob=f[X>>2]|0;f[X>>2]=Ob+-1;if((Ob|0)!=1)break;kL(w)}while(0);f[vb>>2]=0;f[ub>>2]=0;f[ub+4>>2]=0;f[ub+8>>2]=0;f[ub+12>>2]=0;if((f[ya>>2]|0)>0){ub=f[tb>>2]|0;tb=0;do{f[ub+(tb<<2)>>2]=0;tb=tb+1|0}while((tb|0)<(f[ya>>2]|0))}ya=f[cb>>2]|0;if((ya|0)!=(sb|0))UC(ya);ya=f[s>>2]|0;do if(ya|0){s=ya+4|0;sb=f[s>>2]|0;f[s>>2]=sb+-1;if((sb|0)!=1)break;bi[f[(f[ya>>2]|0)+8>>2]&2047](ya)}while(0);ya=r+36|0;sb=f[ya>>2]|0;do if(sb|0){s=sb+12|0;cb=f[s>>2]|0;f[s>>2]=cb+-1;if((cb|0)!=1)break;kL(r)}while(0);f[ya>>2]=0;ya=r+16|0;f[ya>>2]=0;f[ya+4>>2]=0;f[ya+8>>2]=0;f[ya+12>>2]=0;if((f[oa>>2]|0)>0){ya=f[qa>>2]|0;qa=0;do{f[ya+(qa<<2)>>2]=0;qa=qa+1|0}while((qa|0)<(f[oa>>2]|0))}oa=f[ra>>2]|0;if((oa|0)!=(pa|0))UC(oa);oa=q+36|0;pa=f[oa>>2]|0;do if(pa|0){ra=pa+12|0;qa=f[ra>>2]|0;f[ra>>2]=qa+-1;if((qa|0)!=1)break;kL(q)}while(0);f[oa>>2]=0;oa=q+16|0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[R>>2]|0)>0){oa=f[la>>2]|0;la=0;do{f[oa+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[R>>2]|0))}R=f[ma>>2]|0;if((R|0)!=(ja|0))UC(R);R=f[Q>>2]|0;do if(R|0){ja=R+12|0;ma=f[ja>>2]|0;f[ja>>2]=ma+-1;if((ma|0)!=1)break;kL(n)}while(0);f[Q>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[G>>2]|0)>0){L=f[S>>2]|0;S=0;do{f[L+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[G>>2]|0))}G=f[U>>2]|0;if((G|0)!=(T|0))UC(G);G=f[m>>2]|0;if(!G){u=k;return}if((f[F>>2]|0)!=(G|0))f[F>>2]=G;O5b(G);u=k;return}function Pda(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0,Sa=0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0;h=u;u=u+2192|0;i=h+1360|0;j=h+2136|0;k=h+1328|0;l=h+1272|0;m=h+1216|0;o=h+2080|0;q=h+2024|0;r=h+1912|0;s=h+1840|0;t=h+992|0;v=h+1768|0;w=h+768|0;x=h+1712|0;y=h+544|0;z=h+512|0;A=h+480|0;B=h+256|0;C=h+32|0;D=h+1656|0;E=h+1648|0;F=h+1640|0;G=h+1632|0;H=h+1624|0;I=h;J=h+1616|0;K=h+1608|0;N=h+1600|0;O=h+1592|0;P=h+1584|0;Q=h+2016|0;R=h+2008|0;S=h+2e3|0;T=h+1992|0;U=h+1984|0;V=h+1976|0;W=h+1968|0;X=h+1904|0;Z=h+1896|0;_=h+1832|0;$=h+1824|0;dQ(P,56184);if(HM(g)|0){aa=BL(a,-1)|0;ba=(aa>>>3&511)+1|0;if(e>>>0>=6){f[i>>2]=0;f[i+4>>2]=0;ca=aD(i,55)|0;da=251784;ea=ca+55|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));bO(-215,i,251930,251534,1101);bD(i)}switch(aa&7){case 0:case 5:{if(!((aa|0)==(BL(c,-1)|0)?(_L(a,-1)|0)<3:0))fa=134;break}default:fa=134}if((fa|0)==134){f[i>>2]=0;f[i+4>>2]=0;ca=aD(i,71)|0;da=251858;ea=ca+71|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));bO(-215,i,251930,251534,1102);bD(i)}AL(Q,a,-1);aa=f[Q+4>>2]|0;AL(R,c,-1);if((aa|0)>=(f[R+4>>2]|0)?(AL(S,a,-1),R=f[S>>2]|0,AL(T,c,-1),(R|0)>=(f[T>>2]|0)):0)ga=0;else fa=137;do if((fa|0)==137){AL(U,a,-1);T=f[U+4>>2]|0;AL(V,c,-1);if((T|0)<=(f[V+4>>2]|0)?(AL(W,a,-1),T=f[W>>2]|0,AL(X,c,-1),(T|0)<=(f[X>>2]|0)):0){ga=1;break}f[i>>2]=0;f[i+4>>2]=0;ca=aD(i,86)|0;da=251944;ea=ca+86|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));bO(-215,i,251930,251534,1107);bD(i);ga=1}while(0);do if((yM(a)|0)==65536){X=f[a+4>>2]|0;f[r>>2]=f[X>>2];W=r+4|0;V=X+4|0;f[W>>2]=f[V>>2];U=r+8|0;f[U>>2]=f[X+8>>2];f[r+12>>2]=f[X+12>>2];f[r+16>>2]=f[X+16>>2];f[r+20>>2]=f[X+20>>2];f[r+24>>2]=f[X+24>>2];f[r+28>>2]=f[X+28>>2];f[r+32>>2]=f[X+32>>2];T=f[X+36>>2]|0;f[r+36>>2]=T;f[r+40>>2]=U;U=r+48|0;R=r+44|0;f[R>>2]=U;f[U>>2]=0;f[r+52>>2]=0;if(T|0){U=T+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[V>>2]|0)<3){V=f[X+44>>2]|0;U=f[R>>2]|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2];break}else{f[W>>2]=0;jL(r,X);break}}else yL(r,a,-1);while(0);do if((yM(c)|0)==65536){X=f[c+4>>2]|0;f[s>>2]=f[X>>2];W=s+4|0;V=X+4|0;f[W>>2]=f[V>>2];U=s+8|0;f[U>>2]=f[X+8>>2];f[s+12>>2]=f[X+12>>2];f[s+16>>2]=f[X+16>>2];f[s+20>>2]=f[X+20>>2];f[s+24>>2]=f[X+24>>2];f[s+28>>2]=f[X+28>>2];f[s+32>>2]=f[X+32>>2];R=f[X+36>>2]|0;f[s+36>>2]=R;f[s+40>>2]=U;U=s+48|0;T=s+44|0;f[T>>2]=U;f[U>>2]=0;f[s+52>>2]=0;if(R|0){U=R+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[V>>2]|0)<3){V=f[X+44>>2]|0;U=f[T>>2]|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2];break}else{f[W>>2]=0;jL(s,X);break}}else yL(s,c,-1);while(0);if(ga){f[i>>2]=f[r>>2];ga=i+4|0;X=r+4|0;W=f[X>>2]|0;f[ga>>2]=W;V=i+8|0;U=r+8|0;f[V>>2]=f[U>>2];T=i+12|0;R=r+12|0;f[T>>2]=f[R>>2];S=i+16|0;aa=r+16|0;f[S>>2]=f[aa>>2];Q=i+20|0;ha=r+20|0;f[Q>>2]=f[ha>>2];ia=i+24|0;ja=r+24|0;f[ia>>2]=f[ja>>2];ka=i+28|0;la=r+28|0;f[ka>>2]=f[la>>2];ma=i+32|0;na=r+32|0;f[ma>>2]=f[na>>2];oa=i+36|0;pa=r+36|0;qa=f[pa>>2]|0;f[oa>>2]=qa;ra=i+40|0;f[ra>>2]=V;sa=i+48|0;ta=i+44|0;f[ta>>2]=sa;f[sa>>2]=0;f[i+52>>2]=0;if(!qa)ua=W;else{W=qa+12|0;f[W>>2]=(f[W>>2]|0)+1;ua=f[X>>2]|0}if((ua|0)<3){ua=f[r+44>>2]|0;W=f[ta>>2]|0;f[W>>2]=f[ua>>2];f[W+4>>2]=f[ua+4>>2]}else{f[ga>>2]=0;jL(i,r)}ua=s+36|0;W=f[ua>>2]|0;if(W|0){qa=W+12|0;f[qa>>2]=(f[qa>>2]|0)+1}qa=f[pa>>2]|0;if(qa|0?(W=qa+12|0,qa=f[W>>2]|0,f[W>>2]=qa+-1,(qa|0)==1):0)kL(r);f[pa>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[X>>2]|0)>0){qa=f[r+40>>2]|0;W=0;do{f[qa+(W<<2)>>2]=0;W=W+1|0;va=f[X>>2]|0}while((W|0)<(va|0));f[r>>2]=f[s>>2];if((va|0)<3)fa=171;else fa=173}else{f[r>>2]=f[s>>2];fa=171}if((fa|0)==171){va=f[s+4>>2]|0;if((va|0)<3){f[X>>2]=va;f[U>>2]=f[s+8>>2];f[R>>2]=f[s+12>>2];va=f[s+44>>2]|0;X=f[r+44>>2]|0;f[X>>2]=f[va>>2];f[X+4>>2]=f[va+4>>2]}else fa=173}if((fa|0)==173)jL(r,s);va=s+16|0;f[aa>>2]=f[va>>2];aa=s+20|0;f[ha>>2]=f[aa>>2];ha=s+24|0;f[ja>>2]=f[ha>>2];ja=s+28|0;f[la>>2]=f[ja>>2];la=s+32|0;f[na>>2]=f[la>>2];na=f[ua>>2]|0;f[pa>>2]=na;pa=f[oa>>2]|0;if(!pa)wa=na;else{na=pa+12|0;f[na>>2]=(f[na>>2]|0)+1;wa=f[ua>>2]|0}if(wa|0?(na=wa+12|0,wa=f[na>>2]|0,f[na>>2]=wa+-1,(wa|0)==1):0)kL(s);f[ua>>2]=0;wa=s+4|0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;if((f[wa>>2]|0)>0){na=f[s+40>>2]|0;pa=0;do{f[na+(pa<<2)>>2]=0;pa=pa+1|0;xa=f[wa>>2]|0}while((pa|0)<(xa|0));f[s>>2]=f[i>>2];if((xa|0)<3)fa=184;else fa=186}else{f[s>>2]=f[i>>2];fa=184}if((fa|0)==184){xa=f[ga>>2]|0;if((xa|0)<3){f[wa>>2]=xa;f[s+8>>2]=f[V>>2];f[s+12>>2]=f[T>>2];T=f[ta>>2]|0;V=f[s+44>>2]|0;f[V>>2]=f[T>>2];f[V+4>>2]=f[T+4>>2]}else fa=186}if((fa|0)==186)jL(s,i);f[va>>2]=f[S>>2];f[aa>>2]=f[Q>>2];f[ha>>2]=f[ia>>2];f[ja>>2]=f[ka>>2];f[la>>2]=f[ma>>2];ma=f[oa>>2]|0;f[ua>>2]=ma;if(ma|0?(ua=ma+12|0,ma=f[ua>>2]|0,f[ua>>2]=ma+-1,(ma|0)==1):0)kL(i);f[oa>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[ga>>2]|0)>0){S=f[ra>>2]|0;ra=0;do{f[S+(ra<<2)>>2]=0;ra=ra+1|0}while((ra|0)<(f[ga>>2]|0))}ga=f[ta>>2]|0;if((ga|0)!=(sa|0))UC(ga);ya=U;za=R}else{ya=r+8|0;za=r+12|0}R=s+12|0;U=s+8|0;ga=(f[ya>>2]|0)+1-(f[U>>2]|0)|0;f[Z>>2]=(f[za>>2]|0)+1-(f[R>>2]|0);f[Z+4>>2]=ga;vM(d,Z,5,-1,0,0);do if((yM(d)|0)==65536){Z=f[d+4>>2]|0;f[t>>2]=f[Z>>2];ga=t+4|0;za=Z+4|0;f[ga>>2]=f[za>>2];ya=t+8|0;f[ya>>2]=f[Z+8>>2];f[t+12>>2]=f[Z+12>>2];f[t+16>>2]=f[Z+16>>2];f[t+20>>2]=f[Z+20>>2];f[t+24>>2]=f[Z+24>>2];f[t+28>>2]=f[Z+28>>2];f[t+32>>2]=f[Z+32>>2];sa=f[Z+36>>2]|0;f[t+36>>2]=sa;ta=t+40|0;f[ta>>2]=ya;ya=t+48|0;ra=t+44|0;f[ra>>2]=ya;f[ya>>2]=0;f[t+52>>2]=0;if(sa|0){ya=sa+12|0;f[ya>>2]=(f[ya>>2]|0)+1}if((f[za>>2]|0)<3){za=f[Z+44>>2]|0;ya=f[ra>>2]|0;f[ya>>2]=f[za>>2];f[ya+4>>2]=f[za+4>>2];Aa=ta;Ba=t;break}else{f[ga>>2]=0;jL(t,Z);Aa=ta;Ba=t;break}}else{yL(t,d,-1);Aa=t+40|0;Ba=t}while(0);ta=f[Aa>>2]|0;Z=f[ta>>2]|0;f[_>>2]=f[ta+4>>2];f[_+4>>2]=Z;Z=f[Ba>>2]&4095;f[$>>2]=0;f[$+4>>2]=0;Oda(r,s,t,_,Z,$,0.0,0);switch(e|0){case 2:break;case 3:{Ca=0;fa=205;break}default:{Ca=(e|1|0)==5?1:2;fa=205}}if((fa|0)==205){$=(e|0)==5;Da=1.0/(+(f[U>>2]|0)*+(f[R>>2]|0));f[i>>2]=1124007936;Z=i+4|0;_=i+8|0;Ba=i+40|0;ca=Z;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[Ba>>2]=_;_=i+48|0;ta=i+44|0;f[ta>>2]=_;f[_>>2]=0;f[i+52>>2]=0;f[j>>2]=1124007936;ga=j+4|0;za=j+8|0;ya=j+40|0;ca=ga;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[ya>>2]=za;za=j+48|0;ra=j+44|0;f[ra>>2]=za;f[za>>2]=0;f[j+52>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;do if((e|0)==4){f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=r;sa=o+8|0;f[sa>>2]=0;f[sa+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=i;D3(m,o,6);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=s;tG(m,o,UM()|0);f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];f[k+12>>2]=f[m+12>>2];f[k+16>>2]=f[m+16>>2];f[k+20>>2]=f[m+20>>2];f[k+24>>2]=f[m+24>>2];f[k+28>>2]=f[m+28>>2];Ea=0;Fa=0;Ga=0;Ha=0;Ia=0.0;Ja=0.0;fa=214}else{f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=r;sa=o+8|0;f[sa>>2]=0;f[sa+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=i;sa=q+8|0;f[sa>>2]=0;f[sa+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=j;E3(m,o,q,6,-1);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=s;f[o>>2]=-1040056314;f[o+4>>2]=k;f[o+8>>2]=1;f[o+12>>2]=4;f[q>>2]=-1040056314;f[q+4>>2]=l;f[q+8>>2]=1;f[q+12>>2]=4;uG(m,o,q,UM()|0);Ka=+p[l>>3];La=+p[l+8>>3];Ma=+p[l+16>>3];Na=+p[l+24>>3];Oa=Ka*Ka+La*La+Ma*Ma+Na*Na;if($&Oa<2.220446049250313e-16){p[m>>3]=1.0;p[m+8>>3]=1.0;p[m+16>>3]=1.0;p[m+24>>3]=1.0;UP(t,m)|0;break}Na=+p[k>>3];Ma=+p[k+8>>3];La=+p[k+16>>3];Ka=+p[k+24>>3];Pa=Oa+Na*Na+Ma*Ma+La*La+Ka*Ka;if((Ca|0)==1)Qa=Oa;else{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;Qa=Pa}Oa=Pa/Da;Pa=+M(+Qa)/+M(+Da);sa=j+16|0;S=f[sa>>2]|0;if(!S){f[m>>2]=0;f[m+4>>2]=0;ca=aD(m,16)|0;da=252031;ea=ca+16|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));bO(-215,m,252048,251534,892);bD(m);Ra=f[sa>>2]|0}else Ra=S;oa=Y(f[R>>2]|0,ba)|0;ma=Ra+(Y(f[za>>2]|0,f[U>>2]|0)|0)|0;Ea=Ra;Fa=Ra+(oa<<3)|0;Ga=ma;Ha=ma+(oa<<3)|0;Ia=Oa;Ja=Pa;fa=214}while(0);if((fa|0)==214){Ra=i+16|0;$=f[Ra>>2]|0;if(!$){f[m>>2]=0;f[m+4>>2]=0;ca=aD(m,14)|0;da=252069;ea=ca+14|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));bO(-215,m,252048,251534,899);bD(m);Sa=f[Ra>>2]|0}else Sa=$;$=Y(f[R>>2]|0,ba)|0;R=Sa+($<<3)|0;Ra=f[_>>2]|0;oa=Sa+(Y(Ra,f[U>>2]|0)|0)|0;U=oa+($<<3)|0;$=(Sa|0)==0?0:Ra>>>3;Ra=(f[j+16>>2]|0)==0?0:(f[za>>2]|0)>>>3;ma=f[t+8>>2]|0;if((ma|0)>0){ua=f[t+16>>2]|0;la=f[f[t+44>>2]>>2]|0;ka=f[t+12>>2]|0;ja=(ka|0)>0;Qa=+((e|0)==1&1);ia=Ca&255;Ca=0;do{ha=ua+(Y(Ca,la)|0)|0;Q=Y(Ca,Ra)|0;a:do if(ja)switch(ia&3){case 1:{aa=Q;va=Y(Ca,$)|0;T=0;while(1){V=ha+(T<<2)|0;Ka=0.0;La=+n[V>>2];xa=0;do{wa=xa+va|0;Ma=+p[Sa+(wa<<3)>>3]-+p[R+(wa<<3)>>3]-+p[oa+(wa<<3)>>3]+ +p[U+(wa<<3)>>3];Ka=Ka+Ma*Ma;La=La-Ma*+p[k+(xa<<3)>>3];xa=xa+1|0}while((xa|0)!=(ba|0));Ma=Da*Ka;switch(e|0){case 1:case 3:case 5:{Na=0.0;xa=0;while(1){wa=xa+aa|0;Ta=Na+(+p[Ea+(wa<<3)>>3]-+p[Fa+(wa<<3)>>3]-+p[Ga+(wa<<3)>>3]+ +p[Ha+(wa<<3)>>3]);xa=xa+1|0;if((xa|0)==(ba|0)){Ua=Ta;break}else Na=Ta}break}default:Ua=0.0}b:do switch(e|0){case 1:case 3:case 5:{Na=Ua-Ma;Ka=Ja*+M(+(Na<0.0?0.0:Na));Na=+L(+La);if(Na<Ka){Va=La/Ka;break b}if(!(Na<Ka*1.125)){Va=Qa;break b}Va=La>0.0?1.0:-1.0;break}default:Va=La}while(0);n[V>>2]=Va;T=T+1|0;if((T|0)==(ka|0))break a;else{aa=aa+ba|0;va=va+ba|0}}break}case 2:{va=Q;aa=0;while(1){T=ha+(aa<<2)|0;La=+n[T>>2];Ma=0.0;xa=0;do{wa=xa+va|0;Ma=Ma+(+p[Ea+(wa<<3)>>3]-+p[Fa+(wa<<3)>>3]-+p[Ga+(wa<<3)>>3]+ +p[Ha+(wa<<3)>>3]);xa=xa+1|0}while((xa|0)!=(ba|0));Ka=Ia+(Ma-La*2.0);Na=Ka<0.0?0.0:Ka;c:do switch(e|0){case 1:case 3:case 5:{Ka=Ja*+M(+(Ma<0.0?0.0:Ma));Ta=+L(+Na);if(Ta<Ka){Wa=Na/Ka;break c}if(!(Ta<Ka*1.125)){Wa=Qa;break c}Wa=Na>0.0?1.0:-1.0;break}default:Wa=Na}while(0);n[T>>2]=Wa;aa=aa+1|0;if((aa|0)==(ka|0))break a;else va=va+ba|0}break}default:{va=Q;aa=0;while(1){xa=ha+(aa<<2)|0;Na=+n[xa>>2];Ma=Na;switch(e|0){case 1:case 3:case 5:{La=0.0;V=0;while(1){wa=V+va|0;Ka=La+(+p[Ea+(wa<<3)>>3]-+p[Fa+(wa<<3)>>3]-+p[Ga+(wa<<3)>>3]+ +p[Ha+(wa<<3)>>3]);V=V+1|0;if((V|0)==(ba|0)){Xa=Ka;break}else La=Ka}break}default:Xa=0.0}d:do switch(e|0){case 1:case 3:case 5:{La=Ja*+M(+(Xa<0.0?0.0:Xa));Ka=+L(+Na);if(Ka<La){Ya=Ma/La;break d}if(!(Ka<La*1.125)){Ya=Qa;break d}Ya=Na>0.0?1.0:-1.0;break}default:Ya=Ma}while(0);n[xa>>2]=Ya;aa=aa+1|0;if((aa|0)==(ka|0))break a;else va=va+ba|0}}}while(0);Ca=Ca+1|0}while((Ca|0)!=(ma|0))}}ma=j+36|0;Ca=f[ma>>2]|0;if(Ca|0?(ba=Ca+12|0,Ca=f[ba>>2]|0,f[ba>>2]=Ca+-1,(Ca|0)==1):0)kL(j);f[ma>>2]=0;ma=j+16|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ga>>2]|0)>0){ma=f[ya>>2]|0;ya=0;do{f[ma+(ya<<2)>>2]=0;ya=ya+1|0}while((ya|0)<(f[ga>>2]|0))}ga=f[ra>>2]|0;if((ga|0)!=(za|0))UC(ga);ga=i+36|0;za=f[ga>>2]|0;if(za|0?(ra=za+12|0,za=f[ra>>2]|0,f[ra>>2]=za+-1,(za|0)==1):0)kL(i);f[ga>>2]=0;ga=i+16|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[Z>>2]|0)>0){ga=f[Ba>>2]|0;Ba=0;do{f[ga+(Ba<<2)>>2]=0;Ba=Ba+1|0}while((Ba|0)<(f[Z>>2]|0))}Z=f[ta>>2]|0;if((Z|0)!=(_|0))UC(Z)}Z=t+36|0;_=f[Z>>2]|0;if(_|0?(ta=_+12|0,_=f[ta>>2]|0,f[ta>>2]=_+-1,(_|0)==1):0)kL(t);f[Z>>2]=0;Z=t+16|0;_=t+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[_>>2]|0)>0){Z=f[Aa>>2]|0;Aa=0;do{f[Z+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[_>>2]|0))}_=f[t+44>>2]|0;if((_|0)!=(t+48|0))UC(_);_=s+36|0;Aa=f[_>>2]|0;if(Aa|0?(Z=Aa+12|0,Aa=f[Z>>2]|0,f[Z>>2]=Aa+-1,(Aa|0)==1):0)kL(s);f[_>>2]=0;_=s+16|0;Aa=s+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Aa>>2]|0)>0){_=f[s+40>>2]|0;Z=0;do{f[_+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[Aa>>2]|0))}Aa=f[s+44>>2]|0;if((Aa|0)!=(s+48|0))UC(Aa);Aa=r+36|0;Z=f[Aa>>2]|0;if(Z|0?(_=Z+12|0,Z=f[_>>2]|0,f[_>>2]=Z+-1,(Z|0)==1):0)kL(r);f[Aa>>2]=0;Aa=r+16|0;Z=r+4|0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[Aa+8>>2]=0;f[Aa+12>>2]=0;if((f[Z>>2]|0)>0){Aa=f[r+40>>2]|0;_=0;do{f[Aa+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[Z>>2]|0))}Z=f[r+44>>2]|0;if((Z|0)!=(r+48|0))UC(Z)}else{Z=BL(a,-1)|0;_=Z&7;Aa=Z&4088;if(e>>>0>=6){f[i>>2]=0;f[i+4>>2]=0;ca=aD(i,55)|0;da=251784;ea=ca+55|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));bO(-215,i,251840,251534,768);bD(i)}ta=(_|0)==0;switch(Z&7){case 0:case 5:{if(!((Z|0)==(BL(c,-1)|0)?(_L(a,-1)|0)<3:0))fa=7;break}default:fa=7}if((fa|0)==7){f[i>>2]=0;f[i+4>>2]=0;ca=aD(i,71)|0;da=251858;ea=ca+71|0;do{b[ca>>0]=b[da>>0]|0;ca=ca+1|0;da=da+1|0}while((ca|0)<(ea|0));bO(-215,i,251840,251534,769);bD(i)}do if((yM(a)|0)==65536){da=f[a+4>>2]|0;f[l>>2]=f[da>>2];fa=l+4|0;Z=da+4|0;f[fa>>2]=f[Z>>2];_=l+8|0;f[_>>2]=f[da+8>>2];f[l+12>>2]=f[da+12>>2];f[l+16>>2]=f[da+16>>2];f[l+20>>2]=f[da+20>>2];f[l+24>>2]=f[da+24>>2];f[l+28>>2]=f[da+28>>2];f[l+32>>2]=f[da+32>>2];Ba=f[da+36>>2]|0;f[l+36>>2]=Ba;f[l+40>>2]=_;_=l+48|0;ga=l+44|0;f[ga>>2]=_;f[_>>2]=0;f[l+52>>2]=0;if(Ba|0){_=Ba+12|0;f[_>>2]=(f[_>>2]|0)+1}if((f[Z>>2]|0)<3){Z=f[da+44>>2]|0;_=f[ga>>2]|0;f[_>>2]=f[Z>>2];f[_+4>>2]=f[Z+4>>2];break}else{f[fa>>2]=0;jL(l,da);break}}else yL(l,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[m>>2]=f[a>>2];da=m+4|0;fa=a+4|0;f[da>>2]=f[fa>>2];Z=m+8|0;f[Z>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];_=f[a+36>>2]|0;f[m+36>>2]=_;f[m+40>>2]=Z;Z=m+48|0;ga=m+44|0;f[ga>>2]=Z;f[Z>>2]=0;f[m+52>>2]=0;if(_|0){Z=_+12|0;f[Z>>2]=(f[Z>>2]|0)+1}if((f[fa>>2]|0)<3){fa=f[a+44>>2]|0;Z=f[ga>>2]|0;f[Z>>2]=f[fa>>2];f[Z+4>>2]=f[fa+4>>2];break}else{f[da>>2]=0;jL(m,a);break}}else yL(m,c,-1);while(0);do if((yM(g)|0)==65536){c=f[g+4>>2]|0;f[o>>2]=f[c>>2];a=o+4|0;da=c+4|0;f[a>>2]=f[da>>2];fa=o+8|0;f[fa>>2]=f[c+8>>2];f[o+12>>2]=f[c+12>>2];f[o+16>>2]=f[c+16>>2];f[o+20>>2]=f[c+20>>2];f[o+24>>2]=f[c+24>>2];f[o+28>>2]=f[c+28>>2];f[o+32>>2]=f[c+32>>2];Z=f[c+36>>2]|0;f[o+36>>2]=Z;f[o+40>>2]=fa;fa=o+48|0;ga=o+44|0;f[ga>>2]=fa;f[fa>>2]=0;f[o+52>>2]=0;if(Z|0){fa=Z+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[da>>2]|0)<3){da=f[c+44>>2]|0;fa=f[ga>>2]|0;f[fa>>2]=f[da>>2];f[fa+4>>2]=f[da+4>>2];break}else{f[a>>2]=0;jL(o,c);break}}else yL(o,g,-1);while(0);g=f[m>>2]|0;c=f[l>>2]&4088;if(ta){a=i+8|0;f[a>>2]=0;f[a+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=l;OJ(l,i,Aa|5,.00392156862745098,0.0)}if(!(g&7)){Aa=i+8|0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=m;OJ(m,i,g&4088|5,.00392156862745098,0.0)}if(ta){f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;f[j>>2]=-1056833530;f[j+4>>2]=k;f[j+8>>2]=1;f[j+12>>2]=4;ta=q+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=o;rF(i,j,q,5);ta=i+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=o;OJ(o,i,c|5,.00392156862745098,0.0)}c=m+12|0;ta=(f[l+12>>2]|0)-(f[c>>2]|0)+1|0;g=m+8|0;Aa=(f[l+8>>2]|0)-(f[g>>2]|0)+1|0;f[r>>2]=ta;f[r+4>>2]=Aa;vM(d,r,5,-1,0,0);do if((yM(d)|0)==65536){r=f[d+4>>2]|0;f[q>>2]=f[r>>2];a=q+4|0;da=r+4|0;f[a>>2]=f[da>>2];fa=q+8|0;f[fa>>2]=f[r+8>>2];f[q+12>>2]=f[r+12>>2];f[q+16>>2]=f[r+16>>2];f[q+20>>2]=f[r+20>>2];f[q+24>>2]=f[r+24>>2];f[q+28>>2]=f[r+28>>2];f[q+32>>2]=f[r+32>>2];ga=f[r+36>>2]|0;f[q+36>>2]=ga;f[q+40>>2]=fa;fa=q+48|0;Z=q+44|0;f[Z>>2]=fa;f[fa>>2]=0;f[q+52>>2]=0;if(ga|0){fa=ga+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[da>>2]|0)<3){da=f[r+44>>2]|0;fa=f[Z>>2]|0;f[fa>>2]=f[da>>2];f[fa+4>>2]=f[da+4>>2];break}else{f[a>>2]=0;jL(q,r);break}}else yL(q,d,-1);while(0);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=l;PS(t,l,i,1.0);f[s>>2]=1124007936;d=s+4|0;r=s+8|0;a=s+40|0;ca=d;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[a>>2]=r;r=s+48|0;da=s+44|0;f[da>>2]=r;f[r>>2]=0;f[s+52>>2]=0;fa=f[t>>2]|0;th[f[(f[fa>>2]|0)+12>>2]&511](fa,t,s,-1);Wi(t);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;PS(w,o,i,1.0);f[v>>2]=1124007936;t=v+4|0;fa=v+8|0;Z=v+40|0;ca=t;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[Z>>2]=fa;fa=v+48|0;ga=v+44|0;f[ga>>2]=fa;f[fa>>2]=0;f[v+52>>2]=0;_=f[w>>2]|0;th[f[(f[_>>2]|0)+12>>2]&511](_,w,v,-1);Wi(w);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=o;PS(y,m,i,1.0);f[x>>2]=1124007936;w=x+4|0;_=x+8|0;Ba=x+40|0;ca=w;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[Ba>>2]=_;_=x+48|0;za=x+44|0;f[za>>2]=_;f[_>>2]=0;f[x+52>>2]=0;ra=f[y>>2]|0;th[f[(f[ra>>2]|0)+12>>2]&511](ra,y,x,-1);Wi(y);f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;f[z+16>>2]=0;f[z+20>>2]=0;f[z+24>>2]=0;f[z+28>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[A+16>>2]=0;f[A+20>>2]=0;f[A+24>>2]=0;f[A+28>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=x;f[j>>2]=-1040056314;f[j+4>>2]=z;f[j+8>>2]=1;f[j+12>>2]=4;f[k>>2]=-1040056314;f[k+4>>2]=A;f[k+8>>2]=1;f[k+12>>2]=4;uG(i,j,k,UM()|0);Ya=+p[A>>3];Qa=+p[A+8>>3];Xa=+p[A+16>>3];Ja=+p[A+24>>3];Wa=+p[z>>3];Ia=+p[z+8>>3];Va=+p[z+16>>3];Ua=+p[z+24>>3];Da=(Ya*Ya+Qa*Qa+Xa*Xa+Ja*Ja+(Wa*Wa+Ia*Ia+Va*Va+Ua*Ua))*(+(f[g>>2]|0)*+(f[c>>2]|0));e:do switch(e|0){case 0:{f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=v;PS(C,m,i,1.0);f[B>>2]=1124007936;c=B+4|0;g=B+8|0;z=B+40|0;ca=c;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[z>>2]=g;A=B+48|0;y=B+44|0;f[y>>2]=A;f[A>>2]=0;f[B+52>>2]=0;ra=f[C>>2]|0;th[f[(f[ra>>2]|0)+12>>2]&511](ra,C,B,-1);Wi(C);f[D>>2]=1124007936;ra=D+4|0;ya=D+8|0;ma=D+40|0;ca=ra;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[ma>>2]=ya;g=D+48|0;Ca=D+44|0;f[Ca>>2]=g;f[g>>2]=0;f[D+52>>2]=0;f[i>>2]=Aa;f[i+4>>2]=ta;hL(D,2,i,5);ba=f[ma>>2]|0;ka=f[ba>>2]|0;f[E>>2]=f[ba+4>>2];f[E+4>>2]=ka;ka=f[D>>2]&4095;f[F>>2]=0;f[F+4>>2]=0;Oda(l,B,D,E,ka,F,0.0,0);ka=f[q+40>>2]|0;ba=f[ka>>2]|0;f[G>>2]=f[ka+4>>2];f[G+4>>2]=ba;ba=f[q>>2]&4095;f[H>>2]=0;f[H+4>>2]=0;Oda(s,o,q,G,ba,H,0.0,0);DS(i,D,2.0);ba=f[i>>2]|0;_h[f[(f[ba>>2]|0)+28>>2]&255](ba,i,q);Wi(i);p[I>>3]=Da;ba=I+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;f[ba+16>>2]=0;f[ba+20>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=q;f[j>>2]=-1056833530;f[j+4>>2]=I;f[j+8>>2]=1;f[j+12>>2]=4;ba=k+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=q;VD(i,j,k,UM()|0,-1);ba=D+36|0;ka=f[ba>>2]|0;if(ka|0?(Ha=ka+12|0,ka=f[Ha>>2]|0,f[Ha>>2]=ka+-1,(ka|0)==1):0)kL(D);f[ba>>2]=0;ba=D+16|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[ra>>2]|0)>0){ba=f[ma>>2]|0;ka=0;do{f[ba+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[ra>>2]|0))}ra=f[Ca>>2]|0;if((ra|0)!=(g|0))UC(ra);ra=B+36|0;ka=f[ra>>2]|0;if(ka|0?(ba=ka+12|0,ka=f[ba>>2]|0,f[ba>>2]=ka+-1,(ka|0)==1):0)kL(B);f[ra>>2]=0;ra=B+16|0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[c>>2]|0)>0){ra=f[z>>2]|0;ka=0;do{f[ra+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[c>>2]|0))}c=f[y>>2]|0;if((c|0)!=(A|0))UC(c);break}case 3:{if(Da<2.220446049250313e-16){p[i>>3]=1.0;p[i+8>>3]=1.0;p[i+16>>3]=1.0;p[i+24>>3]=1.0;UP(q,i)|0;break e}f[j>>2]=1124007936;c=j+4|0;ka=j+8|0;ra=j+40|0;ca=c;ea=ca+36|0;do{f[ca>>2]=0;ca=ca+4|0}while((ca|0)<(ea|0));f[ra>>2]=ka;A=j+48|0;y=j+44|0;f[y>>2]=A;f[A>>2]=0;f[j+52>>2]=0;f[i>>2]=Aa;f[i+4>>2]=ta;hL(j,2,i,5);z=f[ra>>2]|0;g=f[z>>2]|0;f[J>>2]=f[z+4>>2];f[J+4>>2]=g;g=f[j>>2]&4095;f[K>>2]=0;f[K+4>>2]=0;Oda(s,v,j,J,g,K,0.0,0);g=f[q+40>>2]|0;z=f[g>>2]|0;f[N>>2]=f[g+4>>2];f[N+4>>2]=z;z=f[q>>2]&4095;f[O>>2]=0;f[O+4>>2]=0;Oda(l,x,q,N,z,O,0.0,0);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=j;z=k+8|0;f[z>>2]=0;f[z+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=j;dP(i,k);GS(B,1.0,j);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=-1056571392;f[k+4>>2]=B;PS(i,q,k,1.0);z=f[i>>2]|0;th[f[(f[z>>2]|0)+12>>2]&511](z,i,q,-1);Wi(i);Wi(B);Ua=+M(+Da);z=i+8|0;f[z>>2]=0;f[z+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=q;OJ(q,i,-1,1.0/Ua,0.0);z=j+36|0;g=f[z>>2]|0;if(g|0?(Ca=g+12|0,g=f[Ca>>2]|0,f[Ca>>2]=g+-1,(g|0)==1):0)kL(j);f[z>>2]=0;z=j+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[c>>2]|0)>0){z=f[ra>>2]|0;g=0;do{f[z+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[c>>2]|0))}c=f[y>>2]|0;if((c|0)!=(A|0))UC(c);break}default:{f[i>>2]=0;f[i+4>>2]=0;bO(-213,i,251840,251534,841);bD(i)}}while(0);i=x+36|0;j=f[i>>2]|0;if(j|0?(B=j+12|0,j=f[B>>2]|0,f[B>>2]=j+-1,(j|0)==1):0)kL(x);f[i>>2]=0;i=x+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[w>>2]|0)>0){i=f[Ba>>2]|0;Ba=0;do{f[i+(Ba<<2)>>2]=0;Ba=Ba+1|0}while((Ba|0)<(f[w>>2]|0))}w=f[za>>2]|0;if((w|0)!=(_|0))UC(w);w=v+36|0;_=f[w>>2]|0;if(_|0?(za=_+12|0,_=f[za>>2]|0,f[za>>2]=_+-1,(_|0)==1):0)kL(v);f[w>>2]=0;w=v+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[t>>2]|0)>0){w=f[Z>>2]|0;Z=0;do{f[w+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[t>>2]|0))}t=f[ga>>2]|0;if((t|0)!=(fa|0))UC(t);t=s+36|0;fa=f[t>>2]|0;if(fa|0?(ga=fa+12|0,fa=f[ga>>2]|0,f[ga>>2]=fa+-1,(fa|0)==1):0)kL(s);f[t>>2]=0;t=s+16|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[d>>2]|0)>0){t=f[a>>2]|0;a=0;do{f[t+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[d>>2]|0))}d=f[da>>2]|0;if((d|0)!=(r|0))UC(d);d=q+36|0;r=f[d>>2]|0;do if(r|0){da=r+12|0;a=f[da>>2]|0;f[da>>2]=a+-1;if((a|0)!=1)break;kL(q)}while(0);f[d>>2]=0;d=q+16|0;r=q+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[r>>2]|0)>0){d=f[q+40>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)!=(q+48|0))UC(r);r=o+36|0;q=f[r>>2]|0;do if(q|0){a=q+12|0;d=f[a>>2]|0;f[a>>2]=d+-1;if((d|0)!=1)break;kL(o)}while(0);f[r>>2]=0;r=o+16|0;q=o+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[q>>2]|0)>0){r=f[o+40>>2]|0;d=0;do{f[r+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[q>>2]|0))}q=f[o+44>>2]|0;if((q|0)!=(o+48|0))UC(q);q=m+36|0;o=f[q>>2]|0;do if(o|0){d=o+12|0;r=f[d>>2]|0;f[d>>2]=r+-1;if((r|0)!=1)break;kL(m)}while(0);f[q>>2]=0;q=m+16|0;o=m+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[o>>2]|0)>0){q=f[m+40>>2]|0;r=0;do{f[q+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)!=(m+48|0))UC(o);o=l+36|0;m=f[o>>2]|0;do if(m|0){r=m+12|0;q=f[r>>2]|0;f[r>>2]=q+-1;if((q|0)!=1)break;kL(l)}while(0);f[o>>2]=0;o=l+16|0;m=l+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[m>>2]|0)>0){o=f[l+40>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))UC(m)}if(!(f[P+4>>2]|0)){u=h;return}u=h;return}function Qda(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+48|0;e=d+32|0;g=d;f[a>>2]=1124007936;h=a+4|0;i=a+8|0;j=a+40|0;k=h;l=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[j>>2]=i;m=a+48|0;n=a+44|0;f[n>>2]=m;f[m>>2]=0;f[a+52>>2]=0;m=c+16|0;o=(f[m>>2]|0)==0;q=f[c+4>>2]|0;do if(!o){if((q|0)<3)r=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{s=f[c+40>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}if(!((q|0)==0|(r|0)==0)){if(((f[c>>2]&4095|0)==6?(f[c+8>>2]|0)==1:0)?(f[c+12>>2]|0)==65:0)break;f[e>>2]=0;f[e+4>>2]=0;k=aD(e,72)|0;v=252161;l=k+72|0;do{b[k>>0]=b[v>>0]|0;k=k+1|0;v=v+1|0}while((k|0)<(l|0));bO(-5,e,252234,252238,96);bD(e)}else x=7}else x=7;while(0);if((x|0)==7){if(!((((q|0)<3?(f[c+8>>2]|0)==1:0)?(f[c+12>>2]|0)==65:0)?!((f[c>>2]&4095|0)!=6|o):0)){f[e>>2]=1;f[e+4>>2]=65;hL(c,2,e,6)}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;f[e>>2]=-1056833530;f[e+4>>2]=g;f[e+8>>2]=1;f[e+12>>2]=4;VP(c,e,UM()|0)|0}if((a|0)==(c|0))y=f[a+16>>2]|0;else{e=c+36|0;g=f[e>>2]|0;if(g|0){o=g+12|0;f[o>>2]=(f[o>>2]|0)+1}o=a+36|0;g=f[o>>2]|0;if(g|0?(q=g+12|0,g=f[q>>2]|0,f[q>>2]=g+-1,(g|0)==1):0)kL(a);f[o>>2]=0;g=a+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[h>>2]|0)>0){q=f[j>>2]|0;j=0;do{f[q+(j<<2)>>2]=0;j=j+1|0;z=f[h>>2]|0}while((j|0)<(z|0));f[a>>2]=f[c>>2];if((z|0)<3)x=29;else x=31}else{f[a>>2]=f[c>>2];x=29}if((x|0)==29){z=f[c+4>>2]|0;if((z|0)<3){f[h>>2]=z;f[i>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];i=f[c+44>>2]|0;z=f[n>>2]|0;f[z>>2]=f[i>>2];f[z+4>>2]=f[i+4>>2]}else x=31}if((x|0)==31)jL(a,c);x=f[m>>2]|0;f[g>>2]=x;f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];f[o>>2]=f[e>>2];y=x}x=a+56|0;f[x>>2]=y;f[a+60>>2]=y+40;f[a+64>>2]=y+160;if(+p[y>>3]>0.0){Rda(a,0);A=f[x>>2]|0}else A=y;if(+p[A+8>>3]>0.0){Rda(a,1);B=f[x>>2]|0}else B=A;if(+p[B+16>>3]>0.0){Rda(a,2);C=f[x>>2]|0}else C=B;if(+p[C+24>>3]>0.0){Rda(a,3);D=f[x>>2]|0}else D=C;if(!(+p[D+32>>3]>0.0)){E=a+972|0;f[E>>2]=0;u=d;return}Rda(a,4);E=a+972|0;f[E>>2]=0;u=d;return}function Rda(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,n=0,o=0.0,q=0,r=0,s=0.0,t=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;if(!(+p[(f[a+56>>2]|0)+(c<<3)>>3]>0.0)){u=d;return}g=(f[a+64>>2]|0)+(c*9<<3)|0;h=g+32|0;i=+p[h>>3];j=g+64|0;k=+p[j>>3];l=g+40|0;m=+p[l>>3];n=g+56|0;o=+p[n>>3];q=g+8|0;r=g+24|0;s=+p[r>>3];t=g+48|0;v=+p[t>>3];w=g+16|0;x=+p[w>>3]*(o*s-i*v)+(+p[g>>3]*(i*k-m*o)-+p[q>>3]*(k*s-m*v));p[a+432+(c<<3)>>3]=x;if(!(x>2.220446049250313e-16)){f[e>>2]=0;f[e+4>>2]=0;y=aD(e,45)|0;z=252310;A=y+45|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,e,252356,252238,217);bD(e)}p[a+72+(c*72|0)>>3]=(+p[h>>3]*+p[j>>3]-+p[l>>3]*+p[n>>3])/x;p[a+72+(c*72|0)+24>>3]=-(+p[r>>3]*+p[j>>3]-+p[l>>3]*+p[t>>3])/x;p[a+72+(c*72|0)+48>>3]=(+p[r>>3]*+p[n>>3]-+p[h>>3]*+p[t>>3])/x;p[a+72+(c*72|0)+8>>3]=-(+p[q>>3]*+p[j>>3]-+p[w>>3]*+p[n>>3])/x;p[a+72+(c*72|0)+32>>3]=(+p[g>>3]*+p[j>>3]-+p[w>>3]*+p[t>>3])/x;p[a+72+(c*72|0)+56>>3]=-(+p[g>>3]*+p[n>>3]-+p[q>>3]*+p[t>>3])/x;p[a+72+(c*72|0)+16>>3]=(+p[q>>3]*+p[l>>3]-+p[w>>3]*+p[h>>3])/x;p[a+72+(c*72|0)+40>>3]=-(+p[g>>3]*+p[l>>3]-+p[w>>3]*+p[r>>3])/x;p[a+72+(c*72|0)+64>>3]=(+p[g>>3]*+p[h>>3]-+p[q>>3]*+p[r>>3])/x;u=d;return}function Sda(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0.0,i=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,q=0.0;e=u;u=u+16|0;g=e;if(!(+p[(f[a+56>>2]|0)+(c<<3)>>3]>0.0)){h=0.0;u=e;return +h}i=a+432+(c<<3)|0;j=+p[i>>3];if(j>2.220446049250313e-16)k=j;else{f[g>>2]=0;f[g+4>>2]=0;l=aD(g,55)|0;m=252380;n=l+55|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,g,489445,252238,123);bD(g);k=+p[i>>3]}i=(f[a+60>>2]|0)+(c*3<<3)|0;j=+p[d>>3]-+p[i>>3];o=+p[d+8>>3]-+p[i+8>>3];q=+p[d+16>>3]-+p[i+16>>3];h=1.0/+M(+k)*+V(+((j*(j*+p[a+72+(c*72|0)>>3]+o*+p[a+72+(c*72|0)+24>>3]+q*+p[a+72+(c*72|0)+48>>3])+o*(j*+p[a+72+(c*72|0)+8>>3]+o*+p[a+72+(c*72|0)+32>>3]+q*+p[a+72+(c*72|0)+56>>3])+q*(j*+p[a+72+(c*72|0)+16>>3]+o*+p[a+72+(c*72|0)+40>>3]+q*+p[a+72+(c*72|0)+64>>3]))*-.5));u=e;return +h}function Tda(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0;b=a+56|0;c=a+972|0;d=a+60|0;e=a+64|0;g=0;do{h=f[a+952+(g<<2)>>2]|0;i=f[b>>2]|0;if(!h)p[i+(g<<3)>>3]=0.0;else{j=+(h|0);p[i+(g<<3)>>3]=j/+(f[c>>2]|0);i=(f[d>>2]|0)+(g*3<<3)|0;k=+p[a+472+(g*24|0)>>3]/j;p[i>>3]=k;h=i+8|0;p[h>>3]=+p[a+472+(g*24|0)+8>>3]/j;l=i+16|0;p[l>>3]=+p[a+472+(g*24|0)+16>>3]/j;m=(f[e>>2]|0)+(g*9<<3)|0;n=+p[a+592+(g*72|0)>>3]/j-k*k;p[m>>3]=n;k=+p[a+592+(g*72|0)+8>>3]/j-+p[i>>3]*+p[h>>3];p[m+8>>3]=k;o=+p[a+592+(g*72|0)+16>>3]/j-+p[i>>3]*+p[l>>3];p[m+16>>3]=o;q=+p[a+592+(g*72|0)+24>>3]/j-+p[h>>3]*+p[i>>3];p[m+24>>3]=q;r=+p[h>>3];s=+p[a+592+(g*72|0)+32>>3]/j-r*r;t=m+32|0;p[t>>3]=s;r=+p[a+592+(g*72|0)+40>>3]/j-+p[h>>3]*+p[l>>3];p[m+40>>3]=r;u=+p[a+592+(g*72|0)+48>>3]/j-+p[l>>3]*+p[i>>3];p[m+48>>3]=u;v=+p[a+592+(g*72|0)+56>>3]/j-+p[l>>3]*+p[h>>3];p[m+56>>3]=v;w=+p[l>>3];x=+p[a+592+(g*72|0)+64>>3]/j-w*w;l=m+64|0;p[l>>3]=x;if(o*(v*q-s*u)+(n*(x*s-r*v)-k*(x*q-r*u))<=2.220446049250313e-16){p[m>>3]=n+.01;p[t>>3]=s+.01;p[l>>3]=x+.01}Rda(a,g)}g=g+1|0}while((g|0)!=5);return}function Uda(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0.0,Lb=0.0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0;k=u;u=u+2544|0;l=k+2072|0;m=k+2016|0;o=k+2488|0;q=k+2432|0;r=k+2376|0;s=k+2304|0;t=k+2248|0;v=k+1984|0;w=k+1968|0;x=k+2232|0;y=k+1952|0;z=k+2224|0;A=k+2168|0;B=k+976|0;C=k;D=k+2112|0;E=k+2360|0;dQ(z,56204);do if((yM(a)|0)==65536){F=f[a+4>>2]|0;f[A>>2]=f[F>>2];G=A+4|0;H=F+4|0;f[G>>2]=f[H>>2];I=A+8|0;f[I>>2]=f[F+8>>2];f[A+12>>2]=f[F+12>>2];f[A+16>>2]=f[F+16>>2];f[A+20>>2]=f[F+20>>2];f[A+24>>2]=f[F+24>>2];f[A+28>>2]=f[F+28>>2];f[A+32>>2]=f[F+32>>2];J=f[F+36>>2]|0;f[A+36>>2]=J;f[A+40>>2]=I;I=A+48|0;K=A+44|0;f[K>>2]=I;f[I>>2]=0;f[A+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[H>>2]|0)<3){H=f[F+44>>2]|0;I=f[K>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2];break}else{f[G>>2]=0;jL(A,F);break}}else yL(A,a,-1);while(0);a=KM(c,-1)|0;c=KM(e,-1)|0;e=KM(g,-1)|0;g=A+16|0;if(f[g>>2]|0){F=f[A+4>>2]|0;if((F|0)<3)L=Y(f[A+12>>2]|0,f[A+8>>2]|0)|0;else{G=f[A+40>>2]|0;H=0;I=1;while(1){K=Y(f[G+(H<<2)>>2]|0,I)|0;H=H+1|0;if((H|0)==(F|0)){L=K;break}else I=K}}if((F|0)==0|(L|0)==0)M=14}else M=14;if((M|0)==14){f[l>>2]=0;f[l+4>>2]=0;N=aD(l,14)|0;O=252436;P=N+14|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));bO(-5,l,252451,252238,541);bD(l)}if((f[A>>2]&4095|0)!=16){f[l>>2]=0;f[l+4>>2]=0;N=aD(l,28)|0;O=252459;P=N+28|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));bO(-5,l,252451,252238,543);bD(l)}Qda(B,c);Qda(C,e);e=A+40|0;c=f[e>>2]|0;L=f[c+4>>2]|0;F=f[c>>2]|0;f[D>>2]=1124007936;c=D+4|0;I=D+8|0;H=D+40|0;N=c;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[H>>2]=I;I=D+48|0;G=D+44|0;f[G>>2]=I;f[I>>2]=0;f[D+52>>2]=0;f[l>>2]=F;F=l+4|0;f[F>>2]=L;hL(D,2,l,4);if((j|1|0)==1){if(!j){L=f[e>>2]|0;K=f[L+4>>2]|0;J=f[L>>2]|0;f[E>>2]=f[d>>2];L=E+4|0;f[L>>2]=f[d+4>>2];Q=E+8|0;f[Q>>2]=f[d+8>>2];R=E+12|0;f[R>>2]=f[d+12>>2];if(!(((((f[a+4>>2]|0)<3?(f[a+8>>2]|0)==(J|0):0)?(f[a+12>>2]|0)==(K|0):0)?(f[a>>2]&4095|0)==0:0)?(f[a+16>>2]|0)!=0:0)){f[l>>2]=J;f[F>>2]=K;hL(a,2,l,0)}p[m>>3]=0.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;VP(a,l,UM()|0)|0;d=f[E>>2]|0;S=(d|0)>0?d:0;f[E>>2]=S;d=f[L>>2]|0;T=(d|0)>0?d:0;f[L>>2]=T;L=K-S|0;S=f[Q>>2]|0;f[Q>>2]=(L|0)<(S|0)?L:S;S=J-T|0;T=f[R>>2]|0;f[R>>2]=(S|0)<(T|0)?S:T;nL(o,a,E);p[m>>3]=3.0;E=m+8|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=4;VP(o,l,UM()|0)|0;E=o+36|0;T=f[E>>2]|0;if(T|0?(S=T+12|0,T=f[S>>2]|0,f[S>>2]=T+-1,(T|0)==1):0)kL(o);f[E>>2]=0;E=o+16|0;T=o+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[T>>2]|0)>0){E=f[o+40>>2]|0;S=0;do{f[E+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[T>>2]|0))}T=f[o+44>>2]|0;if((T|0)!=(o+48|0))UC(T)}else Vda(A,a);f[m>>2]=1124007936;T=m+4|0;S=m+8|0;E=m+40|0;N=T;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[E>>2]=S;S=m+48|0;R=m+44|0;f[R>>2]=S;f[S>>2]=0;f[m+52>>2]=0;f[o>>2]=1124007936;J=o+4|0;L=o+8|0;Q=o+40|0;N=J;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[Q>>2]=L;L=o+48|0;K=o+44|0;f[K>>2]=L;f[L>>2]=0;f[o+52>>2]=0;f[q>>2]=0;d=q+4|0;f[d>>2]=0;f[q+8>>2]=0;f[r>>2]=0;U=r+4|0;f[U>>2]=0;f[r+8>>2]=0;X=A+8|0;Z=f[X>>2]|0;if((Z|0)>0){_=A+12|0;$=a+16|0;aa=a+44|0;ba=A+44|0;ca=l+4|0;da=l+8|0;ea=r+8|0;fa=l+4|0;ga=l+8|0;ha=q+8|0;ia=Z;Z=f[_>>2]|0;ja=0;while(1){if((Z|0)>0){ka=0;do{la=(f[$>>2]|0)+(Y(f[f[aa>>2]>>2]|0,ja)|0)+ka|0;switch(b[la>>0]|0){case 2:case 0:{la=(f[g>>2]|0)+(Y(f[f[ba>>2]>>2]|0,ja)|0)|0;ma=+(h[la+(ka*3|0)>>0]|0);n[l>>2]=ma;n[fa>>2]=+(h[la+(ka*3|0)+1>>0]|0);n[ga>>2]=+(h[la+(ka*3|0)+2>>0]|0);la=f[d>>2]|0;if((la|0)==(f[ha>>2]|0))e2(q,l);else{n[la>>2]=ma;f[la+4>>2]=f[fa>>2];f[la+8>>2]=f[ga>>2];f[d>>2]=la+12}break}default:{la=(f[g>>2]|0)+(Y(f[f[ba>>2]>>2]|0,ja)|0)|0;ma=+(h[la+(ka*3|0)>>0]|0);n[l>>2]=ma;n[ca>>2]=+(h[la+(ka*3|0)+1>>0]|0);n[da>>2]=+(h[la+(ka*3|0)+2>>0]|0);la=f[U>>2]|0;if((la|0)==(f[ea>>2]|0))e2(r,l);else{n[la>>2]=ma;f[la+4>>2]=f[ca>>2];f[la+8>>2]=f[da>>2];f[U>>2]=la+12}}}ka=ka+1|0;na=f[_>>2]|0}while((ka|0)<(na|0));oa=na;pa=f[X>>2]|0}else{oa=Z;pa=ia}ja=ja+1|0;if((ja|0)>=(pa|0))break;else{ia=pa;Z=oa}}oa=f[q>>2]|0;Z=f[d>>2]|0;pa=Z;ia=oa;if((oa|0)!=(Z|0)?(f[r>>2]|0)!=(f[U>>2]|0):0){qa=d;ra=q;sa=ia;ta=pa}else M=53}else M=53;if((M|0)==53){f[l>>2]=0;f[l+4>>2]=0;N=aD(l,42)|0;O=252488;P=N+42|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));bO(-215,l,252531,252238,380);bD(l);qa=d;ra=q;sa=f[q>>2]|0;ta=f[d>>2]|0}pa=ta-sa|0;ta=sa;f[s>>2]=1124007941;ia=s+4|0;f[ia>>2]=2;Z=s+8|0;f[Z>>2]=(pa|0)/12|0;oa=s+12|0;f[oa>>2]=3;ja=s+16|0;f[ja>>2]=ta;X=s+20|0;f[X>>2]=ta;na=s+24|0;_=s+28|0;da=s+40|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;f[da>>2]=Z;ca=s+48|0;ea=s+44|0;f[ea>>2]=ca;f[s+52>>2]=0;f[ca>>2]=0;if((sa|0)==0&(pa|0)!=0){f[l>>2]=0;f[l+4>>2]=0;N=aD(l,26)|0;O=426262;P=N+26|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));bO(-215,l,426289,431198,500);bD(l);ua=f[oa>>2]|0;va=f[s>>2]|0;wa=f[ea>>2]|0;xa=f[X>>2]|0}else{ua=3;va=1124007941;wa=ca;xa=ta}ta=ua<<2;f[s>>2]=va|16384;f[wa>>2]=ta;f[wa+4>>2]=4;wa=xa+(Y(f[Z>>2]|0,ta)|0)|0;f[_>>2]=wa;f[na>>2]=wa+(0-ta)+ta;f[t+8>>2]=0;f[t+12>>2]=0;f[t>>2]=16842752;f[t+4>>2]=s;ta=v+8|0;f[ta>>2]=0;f[ta+4>>2]=0;f[v>>2]=50397184;f[v+4>>2]=m;f[w>>2]=1;f[w+4>>2]=10;p[w+8>>3]=0.0;ta=UM()|0;f[l>>2]=f[w>>2];f[l+4>>2]=f[w+4>>2];f[l+8>>2]=f[w+8>>2];f[l+12>>2]=f[w+12>>2];+XC(t,5,v,l,0,2,ta);ta=f[r>>2]|0;w=(f[U>>2]|0)-ta|0;wa=ta;f[t>>2]=1124007941;na=t+4|0;f[na>>2]=2;_=t+8|0;f[_>>2]=(w|0)/12|0;Z=t+12|0;f[Z>>2]=3;xa=t+16|0;f[xa>>2]=wa;va=t+20|0;f[va>>2]=wa;ua=t+24|0;X=t+28|0;oa=t+40|0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;f[oa>>2]=_;pa=t+48|0;sa=t+44|0;f[sa>>2]=pa;f[t+52>>2]=0;f[pa>>2]=0;if((ta|0)==0&(w|0)!=0){f[l>>2]=0;f[l+4>>2]=0;N=aD(l,26)|0;O=426262;P=N+26|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));bO(-215,l,426289,431198,500);bD(l);ya=f[Z>>2]|0;za=f[t>>2]|0;Aa=f[sa>>2]|0;Ba=f[va>>2]|0}else{ya=3;za=1124007941;Aa=pa;Ba=wa}wa=ya<<2;f[t>>2]=za|16384;f[Aa>>2]=wa;f[Aa+4>>2]=4;Aa=Ba+(Y(f[_>>2]|0,wa)|0)|0;f[X>>2]=Aa;f[ua>>2]=Aa+(0-wa)+wa;f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=t;wa=x+8|0;f[wa>>2]=0;f[wa+4>>2]=0;f[x>>2]=50397184;f[x+4>>2]=o;f[y>>2]=1;f[y+4>>2]=10;p[y+8>>3]=0.0;wa=UM()|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2];f[l+8>>2]=f[y+8>>2];f[l+12>>2]=f[y+12>>2];+XC(v,5,x,l,0,2,wa);Nac(B+472|0,0,504)|0;wa=f[ra>>2]|0;ra=(f[qa>>2]|0)-wa|0;qa=wa;if((ra|0)>0){wa=f[m+16>>2]|0;x=f[R>>2]|0;y=B+972|0;Aa=(ra>>>0)/12|0;ra=0;do{ua=wa+(Y(f[x>>2]|0,ra)|0)|0;X=f[ua>>2]|0;ma=+n[qa+(ra*12|0)>>2];Ca=+n[qa+(ra*12|0)+4>>2];Da=+n[qa+(ra*12|0)+8>>2];ua=B+472+(X*24|0)|0;p[ua>>3]=ma+ +p[ua>>3];ua=B+472+(X*24|0)+8|0;p[ua>>3]=Ca+ +p[ua>>3];ua=B+472+(X*24|0)+16|0;p[ua>>3]=Da+ +p[ua>>3];ua=B+592+(X*72|0)|0;p[ua>>3]=ma*ma+ +p[ua>>3];Ea=ma*Ca;ua=B+592+(X*72|0)+8|0;p[ua>>3]=Ea+ +p[ua>>3];Fa=ma*Da;ua=B+592+(X*72|0)+16|0;p[ua>>3]=Fa+ +p[ua>>3];ua=B+592+(X*72|0)+24|0;p[ua>>3]=Ea+ +p[ua>>3];ua=B+592+(X*72|0)+32|0;p[ua>>3]=Ca*Ca+ +p[ua>>3];Ea=Ca*Da;ua=B+592+(X*72|0)+40|0;p[ua>>3]=Ea+ +p[ua>>3];ua=B+592+(X*72|0)+48|0;p[ua>>3]=Fa+ +p[ua>>3];ua=B+592+(X*72|0)+56|0;p[ua>>3]=Ea+ +p[ua>>3];ua=B+592+(X*72|0)+64|0;p[ua>>3]=Da*Da+ +p[ua>>3];ua=B+952+(X<<2)|0;f[ua>>2]=(f[ua>>2]|0)+1;f[y>>2]=(f[y>>2]|0)+1;ra=ra+1|0}while((ra|0)<(Aa|0))}Tda(B);Nac(C+472|0,0,504)|0;Aa=f[r>>2]|0;ra=(f[U>>2]|0)-Aa|0;y=Aa;if((ra|0)>0){Aa=f[o+16>>2]|0;qa=f[K>>2]|0;x=C+972|0;wa=(ra>>>0)/12|0;ra=0;do{ua=Aa+(Y(f[qa>>2]|0,ra)|0)|0;X=f[ua>>2]|0;Da=+n[y+(ra*12|0)>>2];Ea=+n[y+(ra*12|0)+4>>2];Fa=+n[y+(ra*12|0)+8>>2];ua=C+472+(X*24|0)|0;p[ua>>3]=Da+ +p[ua>>3];ua=C+472+(X*24|0)+8|0;p[ua>>3]=Ea+ +p[ua>>3];ua=C+472+(X*24|0)+16|0;p[ua>>3]=Fa+ +p[ua>>3];ua=C+592+(X*72|0)|0;p[ua>>3]=Da*Da+ +p[ua>>3];Ca=Da*Ea;ua=C+592+(X*72|0)+8|0;p[ua>>3]=Ca+ +p[ua>>3];ma=Da*Fa;ua=C+592+(X*72|0)+16|0;p[ua>>3]=ma+ +p[ua>>3];ua=C+592+(X*72|0)+24|0;p[ua>>3]=Ca+ +p[ua>>3];ua=C+592+(X*72|0)+32|0;p[ua>>3]=Ea*Ea+ +p[ua>>3];Ca=Ea*Fa;ua=C+592+(X*72|0)+40|0;p[ua>>3]=Ca+ +p[ua>>3];ua=C+592+(X*72|0)+48|0;p[ua>>3]=ma+ +p[ua>>3];ua=C+592+(X*72|0)+56|0;p[ua>>3]=Ca+ +p[ua>>3];ua=C+592+(X*72|0)+64|0;p[ua>>3]=Fa*Fa+ +p[ua>>3];ua=C+952+(X<<2)|0;f[ua>>2]=(f[ua>>2]|0)+1;f[x>>2]=(f[x>>2]|0)+1;ra=ra+1|0}while((ra|0)<(wa|0))}Tda(C);wa=t+36|0;ra=f[wa>>2]|0;if(ra|0?(x=ra+12|0,ra=f[x>>2]|0,f[x>>2]=ra+-1,(ra|0)==1):0)kL(t);f[wa>>2]=0;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=0;f[xa+12>>2]=0;if((f[na>>2]|0)>0){xa=f[oa>>2]|0;oa=0;do{f[xa+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[na>>2]|0))}na=f[sa>>2]|0;if((na|0)!=(pa|0))UC(na);na=s+36|0;pa=f[na>>2]|0;if(pa|0?(sa=pa+12|0,pa=f[sa>>2]|0,f[sa>>2]=pa+-1,(pa|0)==1):0)kL(s);f[na>>2]=0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[ia>>2]|0)>0){ja=f[da>>2]|0;da=0;do{f[ja+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[ia>>2]|0))}ia=f[ea>>2]|0;if((ia|0)!=(ca|0))UC(ia);ia=f[r>>2]|0;if(ia|0){ca=f[U>>2]|0;if((ca|0)!=(ia|0))f[U>>2]=ca+(~(((ca+-12-ia|0)>>>0)/12|0)*12|0);O5b(ia)}ia=f[q>>2]|0;if(ia|0){ca=f[d>>2]|0;if((ca|0)!=(ia|0))f[d>>2]=ca+(~(((ca+-12-ia|0)>>>0)/12|0)*12|0);O5b(ia)}ia=o+36|0;ca=f[ia>>2]|0;do if(ca|0){d=ca+12|0;U=f[d>>2]|0;f[d>>2]=U+-1;if((U|0)!=1)break;kL(o)}while(0);f[ia>>2]=0;ia=o+16|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[J>>2]|0)>0){ia=f[Q>>2]|0;Q=0;do{f[ia+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[J>>2]|0))}J=f[K>>2]|0;if((J|0)!=(L|0))UC(J);J=m+36|0;L=f[J>>2]|0;do if(L|0){K=L+12|0;Q=f[K>>2]|0;f[K>>2]=Q+-1;if((Q|0)!=1)break;kL(m)}while(0);f[J>>2]=0;J=m+16|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[T>>2]|0)>0){J=f[E>>2]|0;E=0;do{f[J+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[T>>2]|0))}T=f[R>>2]|0;if((T|0)!=(S|0))UC(T)}if((i|0)>=1){if((j|0)==2)Vda(A,a);j=A+8|0;T=f[j>>2]|0;S=A+12|0;R=f[S>>2]|0;if((T|0)>0){E=(R|0)>0;J=f[g>>2]|0;L=f[A+44>>2]|0;Q=R+-1|0;K=0;Fa=0.0;while(1){a:do if(E){ia=f[L>>2]|0;ca=J+(Y(ia,K)|0)|0;U=J+(Y(ia,K+-1|0)|0)|0;if((K|0)>0){Ga=0;Ha=Fa}else{ia=0;Ca=Fa;while(1){if((ia|0)>0){d=ia+-1|0;ma=+(h[ca+(ia*3|0)>>0]|0)-+(h[ca+(d*3|0)>>0]|0);Ea=+(h[ca+(ia*3|0)+1>>0]|0)-+(h[ca+(d*3|0)+1>>0]|0);Da=+(h[ca+(ia*3|0)+2>>0]|0)-+(h[ca+(d*3|0)+2>>0]|0);Ia=Ca+(ma*ma+0.0+Ea*Ea+Da*Da)}else Ia=Ca;ia=ia+1|0;if((ia|0)==(R|0)){Ja=Ia;break a}else Ca=Ia}}while(1){Ca=+(h[ca+(Ga*3|0)>>0]|0);Da=+(h[ca+(Ga*3|0)+1>>0]|0);Ea=+(h[ca+(Ga*3|0)+2>>0]|0);if((Ga|0)>0){ia=Ga+-1|0;ma=Ca-+(h[ca+(ia*3|0)>>0]|0);Ka=Da-+(h[ca+(ia*3|0)+1>>0]|0);La=Ea-+(h[ca+(ia*3|0)+2>>0]|0);Ma=Ca-+(h[U+(ia*3|0)>>0]|0);Na=Da-+(h[U+(ia*3|0)+1>>0]|0);Oa=Ea-+(h[U+(ia*3|0)+2>>0]|0);Pa=Ha+(ma*ma+0.0+Ka*Ka+La*La)+(Ma*Ma+0.0+Na*Na+Oa*Oa)}else Pa=Ha;Oa=Ca-+(h[U+(Ga*3|0)>>0]|0);Na=Da-+(h[U+(Ga*3|0)+1>>0]|0);Ma=Ea-+(h[U+(Ga*3|0)+2>>0]|0);La=Pa+(Oa*Oa+0.0+Na*Na+Ma*Ma);ia=Ga;Ga=Ga+1|0;if((ia|0)<(Q|0)){Ma=Ca-+(h[U+(Ga*3|0)>>0]|0);Ca=Da-+(h[U+(Ga*3|0)+1>>0]|0);Da=Ea-+(h[U+(Ga*3|0)+2>>0]|0);Qa=La+(Ma*Ma+0.0+Ca*Ca+Da*Da)}else Qa=La;if((Ga|0)==(R|0)){Ja=Qa;break}else Ha=Qa}}else Ja=Fa;while(0);K=K+1|0;if((K|0)==(T|0))break;else Fa=Ja}if(!(Ja<=2.220446049250313e-16))Ra=1.0/(Ja*2.0/+((Y(T,-3)|0)+2+(Y(R,(T<<2)+-3|0)|0)|0));else Ra=0.0}else Ra=0.0;f[q>>2]=1124007936;K=q+4|0;Ga=q+8|0;Q=q+40|0;N=K;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[Q>>2]=Ga;Ga=q+48|0;J=q+44|0;f[J>>2]=Ga;f[Ga>>2]=0;f[q+52>>2]=0;f[r>>2]=1124007936;L=r+4|0;E=r+8|0;U=r+40|0;N=L;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[U>>2]=E;ca=r+48|0;ia=r+44|0;f[ia>>2]=ca;f[ca>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;d=s+4|0;ea=s+8|0;da=s+40|0;N=d;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[da>>2]=ea;ja=s+48|0;na=s+44|0;f[na>>2]=ja;f[ja>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;pa=t+4|0;sa=t+8|0;oa=t+40|0;N=pa;P=N+36|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));f[oa>>2]=sa;xa=t+48|0;wa=t+44|0;f[wa>>2]=xa;f[xa>>2]=0;f[t+52>>2]=0;f[l>>2]=T;f[F>>2]=R;hL(q,2,l,6);R=f[j>>2]|0;T=f[S>>2]|0;ra=f[E>>2]|0;if((((f[L>>2]|0)<3&(ra|0)==(R|0)?(f[r+12>>2]|0)==(T|0):0)?(f[r>>2]&4095|0)==6:0)?(f[r+16>>2]|0)!=0:0){Sa=R;Ta=ra;Ua=T}else{f[l>>2]=R;f[F>>2]=T;hL(r,2,l,6);T=f[j>>2]|0;Sa=T;Ta=T;Ua=f[S>>2]|0}if(((((f[d>>2]|0)<3?(f[ea>>2]|0)==(Ta|0):0)?(f[s+12>>2]|0)==(Ua|0):0)?(f[s>>2]&4095|0)==6:0)?(f[s+16>>2]|0)!=0:0){Va=Sa;Wa=Ta;Xa=Ua}else{f[l>>2]=Ta;f[F>>2]=Ua;hL(s,2,l,6);Ua=f[j>>2]|0;Va=Ua;Wa=Ua;Xa=f[S>>2]|0}if(((((f[pa>>2]|0)<3?(f[sa>>2]|0)==(Wa|0):0)?(f[t+12>>2]|0)==(Xa|0):0)?(f[t>>2]&4095|0)==6:0)?(f[t+16>>2]|0)!=0:0){Ya=Va;Za=Wa}else{f[l>>2]=Wa;f[F>>2]=Xa;hL(t,2,l,6);Xa=f[j>>2]|0;Ya=Xa;Za=Xa}if((Za|0)>0){Xa=A+44|0;F=q+16|0;Wa=r+16|0;Va=s+16|0;sa=t+16|0;Ua=f[S>>2]|0;Ta=(Ua|0)>0;Sa=0;do{if(Ta){ea=(Sa|0)>0;T=f[g>>2]|0;R=f[f[Xa>>2]>>2]|0;ra=T+(Y(R,Sa)|0)|0;E=T+(Y(R,Sa+-1|0)|0)|0;R=0;while(1){Ja=+(h[ra+(R*3|0)>>0]|0);Fa=+(h[ra+(R*3|0)+1>>0]|0);Qa=+(h[ra+(R*3|0)+2>>0]|0);T=R+-1|0;do if((R|0)>0){Ha=Ja-+(h[ra+(T*3|0)>>0]|0);Pa=Fa-+(h[ra+(T*3|0)+1>>0]|0);Ia=Qa-+(h[ra+(T*3|0)+2>>0]|0);La=+V(+-(Ra*(Ha*Ha+0.0+Pa*Pa+Ia*Ia)))*50.0;x=(f[F>>2]|0)+(Y(f[f[J>>2]>>2]|0,Sa)|0)+(R<<3)|0;p[x>>3]=La;if(ea){La=Ja-+(h[E+(T*3|0)>>0]|0);Ia=Fa-+(h[E+(T*3|0)+1>>0]|0);Pa=Qa-+(h[E+(T*3|0)+2>>0]|0);Ha=+V(+-(Ra*(La*La+0.0+Ia*Ia+Pa*Pa)))*35.35533966440824;x=(f[Wa>>2]|0)+(Y(f[f[ia>>2]>>2]|0,Sa)|0)+(R<<3)|0;p[x>>3]=Ha;M=152;break}else{x=(f[Wa>>2]|0)+(Y(f[f[ia>>2]>>2]|0,Sa)|0)+(R<<3)|0;p[x>>3]=0.0;M=151;break}}else{x=(f[F>>2]|0)+(Y(f[f[J>>2]>>2]|0,Sa)|0)+(R<<3)|0;p[x>>3]=0.0;x=(f[Wa>>2]|0)+(Y(f[f[ia>>2]>>2]|0,Sa)|0)+(R<<3)|0;p[x>>3]=0.0;if(ea)M=152;else M=151}while(0);if((M|0)==151){M=0;T=(f[Va>>2]|0)+(Y(f[f[na>>2]>>2]|0,Sa)|0)+(R<<3)|0;p[T>>3]=0.0;_a=R+1|0;$a=0.0}else if((M|0)==152){M=0;Ha=Ja-+(h[E+(R*3|0)>>0]|0);Pa=Fa-+(h[E+(R*3|0)+1>>0]|0);Ia=Qa-+(h[E+(R*3|0)+2>>0]|0);La=+V(+-(Ra*(Ha*Ha+0.0+Pa*Pa+Ia*Ia)))*50.0;T=(f[Va>>2]|0)+(Y(f[f[na>>2]>>2]|0,Sa)|0)+(R<<3)|0;p[T>>3]=La;T=R+1|0;if((T|0)<(Ua|0)){La=Ja-+(h[E+(T*3|0)>>0]|0);Ia=Fa-+(h[E+(T*3|0)+1>>0]|0);Pa=Qa-+(h[E+(T*3|0)+2>>0]|0);_a=T;$a=+V(+-(Ra*(La*La+0.0+Ia*Ia+Pa*Pa)))*35.35533966440824}else{_a=T;$a=0.0}}T=(f[sa>>2]|0)+(Y(f[f[wa>>2]>>2]|0,Sa)|0)+(R<<3)|0;p[T>>3]=$a;if((_a|0)<(Ua|0))R=_a;else break}}Sa=Sa+1|0}while((Sa|0)!=(Za|0))}b:do if((i|0)>0){Za=A+44|0;Sa=a+16|0;_a=a+44|0;Ua=l+8|0;sa=l+16|0;Va=D+16|0;Wa=l+8|0;F=l+16|0;Xa=B+472|0;Ta=C+472|0;R=v+12|0;E=v+24|0;ea=v+4|0;ra=v+8|0;T=B+56|0;x=l+8|0;y=l+16|0;qa=C+56|0;Aa=l+8|0;ua=l+16|0;X=q+16|0;_=r+16|0;Ba=s+16|0;za=t+16|0;ya=a+8|0;va=a+12|0;Z=l+4|0;w=v+12|0;ta=v+16|0;ba=0;ga=Ya;while(1){f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;f[v+24>>2]=0;f[v+28>>2]=0;if((ga|0)>0){fa=f[S>>2]|0;ha=ga;aa=0;while(1){if((fa|0)>0){$=0;do{ka=(f[g>>2]|0)+(Y(f[f[Za>>2]>>2]|0,aa)|0)|0;$a=+(h[ka+($*3|0)>>0]|0);Ra=+(h[ka+($*3|0)+1>>0]|0);Pa=+(h[ka+($*3|0)+2>>0]|0);ka=(f[Sa>>2]|0)+(Y(f[f[_a>>2]>>2]|0,aa)|0)+$|0;switch(b[ka>>0]|0){case 2:case 0:{p[l>>3]=$a;p[Wa>>3]=Ra;p[F>>3]=Pa;Ia=+Sda(B,0,l);La=Ia>0.0?Ia:0.0;p[l>>3]=$a;p[Wa>>3]=Ra;p[F>>3]=Pa;Ia=+Sda(B,1,l);ka=Ia>La;Ha=ka?Ia:La;p[l>>3]=$a;p[Wa>>3]=Ra;p[F>>3]=Pa;La=+Sda(B,2,l);la=La>Ha;Ia=la?La:Ha;p[l>>3]=$a;p[Wa>>3]=Ra;p[F>>3]=Pa;Ha=+Sda(B,3,l);ab=Ha>Ia;p[l>>3]=$a;p[Wa>>3]=Ra;p[F>>3]=Pa;La=+Sda(B,4,l);bb=La>(ab?Ha:Ia)?4:ab?3:la?2:ka&1;break}default:{p[l>>3]=$a;p[Ua>>3]=Ra;p[sa>>3]=Pa;Ia=+Sda(C,0,l);Ha=Ia>0.0?Ia:0.0;p[l>>3]=$a;p[Ua>>3]=Ra;p[sa>>3]=Pa;Ia=+Sda(C,1,l);ka=Ia>Ha;La=ka?Ia:Ha;p[l>>3]=$a;p[Ua>>3]=Ra;p[sa>>3]=Pa;Ha=+Sda(C,2,l);la=Ha>La;Ia=la?Ha:La;p[l>>3]=$a;p[Ua>>3]=Ra;p[sa>>3]=Pa;La=+Sda(C,3,l);ab=La>Ia;p[l>>3]=$a;p[Ua>>3]=Ra;p[sa>>3]=Pa;Pa=+Sda(C,4,l);bb=Pa>(ab?La:Ia)?4:ab?3:la?2:ka&1}}ka=(f[Va>>2]|0)+(Y(f[f[G>>2]>>2]|0,aa)|0)+($<<2)|0;f[ka>>2]=bb;$=$+1|0;cb=f[S>>2]|0}while(($|0)<(cb|0));db=f[j>>2]|0;eb=cb}else{db=ha;eb=fa}aa=aa+1|0;if((aa|0)>=(db|0)){fb=db;break}else{fa=eb;ha=db}}}else fb=ga;Nac(Xa|0,0,504)|0;Nac(Ta|0,0,504)|0;ha=0;fa=fb;while(1){if((fa|0)>0){aa=C+472+(ha*24|0)|0;$=C+472+(ha*24|0)+8|0;ka=C+472+(ha*24|0)+16|0;la=C+592+(ha*72|0)|0;ab=C+592+(ha*72|0)+8|0;gb=C+592+(ha*72|0)+16|0;hb=C+592+(ha*72|0)+24|0;ib=C+592+(ha*72|0)+32|0;jb=C+592+(ha*72|0)+40|0;kb=C+592+(ha*72|0)+48|0;lb=C+592+(ha*72|0)+56|0;mb=B+472+(ha*24|0)|0;nb=B+472+(ha*24|0)+8|0;ob=B+472+(ha*24|0)+16|0;pb=B+592+(ha*72|0)|0;qb=B+592+(ha*72|0)+8|0;rb=B+592+(ha*72|0)+16|0;sb=B+592+(ha*72|0)+24|0;tb=B+592+(ha*72|0)+32|0;ub=B+592+(ha*72|0)+40|0;vb=B+592+(ha*72|0)+48|0;wb=B+592+(ha*72|0)+56|0;xb=f[S>>2]|0;yb=(xb|0)>0;zb=fa;Ab=0;while(1){if(yb){Bb=f[Va>>2]|0;Cb=f[G>>2]|0;Db=0;while(1){Eb=Bb+(Y(f[Cb>>2]|0,Ab)|0)+(Db<<2)|0;if((f[Eb>>2]|0)==(ha|0)){Eb=(f[Sa>>2]|0)+(Y(f[f[_a>>2]>>2]|0,Ab)|0)+Db|0;switch(b[Eb>>0]|0){case 2:case 0:{Eb=(f[g>>2]|0)+(Y(f[f[Za>>2]>>2]|0,Ab)|0)|0;Qa=+(h[Eb+(Db*3|0)>>0]|0);Fa=+(h[Eb+(Db*3|0)+1>>0]|0);Ja=+(h[Eb+(Db*3|0)+2>>0]|0);p[mb>>3]=Qa+ +p[mb>>3];p[nb>>3]=Fa+ +p[nb>>3];p[ob>>3]=Ja+ +p[ob>>3];p[pb>>3]=Qa*Qa+ +p[pb>>3];Ia=Qa*Fa;p[qb>>3]=Ia+ +p[qb>>3];La=Qa*Ja;p[rb>>3]=La+ +p[rb>>3];p[sb>>3]=Ia+ +p[sb>>3];p[tb>>3]=Fa*Fa+ +p[tb>>3];Ia=Fa*Ja;p[ub>>3]=Ia+ +p[ub>>3];p[vb>>3]=La+ +p[vb>>3];p[wb>>3]=Ia+ +p[wb>>3];Fb=Ja*Ja;Gb=B;break}default:{Eb=(f[g>>2]|0)+(Y(f[f[Za>>2]>>2]|0,Ab)|0)|0;Ja=+(h[Eb+(Db*3|0)>>0]|0);Ia=+(h[Eb+(Db*3|0)+1>>0]|0);La=+(h[Eb+(Db*3|0)+2>>0]|0);p[aa>>3]=Ja+ +p[aa>>3];p[$>>3]=Ia+ +p[$>>3];p[ka>>3]=La+ +p[ka>>3];p[la>>3]=Ja*Ja+ +p[la>>3];Fa=Ja*Ia;p[ab>>3]=Fa+ +p[ab>>3];Qa=Ja*La;p[gb>>3]=Qa+ +p[gb>>3];p[hb>>3]=Fa+ +p[hb>>3];p[ib>>3]=Ia*Ia+ +p[ib>>3];Fa=Ia*La;p[jb>>3]=Fa+ +p[jb>>3];p[kb>>3]=Qa+ +p[kb>>3];p[lb>>3]=Fa+ +p[lb>>3];Fb=La*La;Gb=C}}Eb=Gb+592+(ha*72|0)+64|0;p[Eb>>3]=Fb+ +p[Eb>>3];Eb=Gb+952+(ha<<2)|0;f[Eb>>2]=(f[Eb>>2]|0)+1;Eb=Gb+972|0;f[Eb>>2]=(f[Eb>>2]|0)+1}Db=Db+1|0;if((Db|0)>=(xb|0)){Hb=fb;break}}}else Hb=zb;Ab=Ab+1|0;if((Ab|0)>=(Hb|0)){Ib=Hb;break}else zb=Hb}}else Ib=fa;ha=ha+1|0;if((ha|0)==5)break;else fa=Ib}Tda(B);Tda(C);fa=f[S>>2]|0;ha=f[j>>2]|0;Wda(v,Y(ha,fa)|0);Xda(R,((Y(ha+fa|0,-3)|0)+(Y(fa<<2,ha)|0)<<1)+6|0);p[E>>3]=0.0;ha=f[j>>2]|0;if((ha|0)>0){fa=f[S>>2]|0;zb=ha;ha=0;while(1){if((fa|0)>0){Ab=(ha|0)>0;xb=0;do{N=l;P=N+40|0;do{f[N>>2]=0;N=N+4|0}while((N|0)<(P|0));lb=f[ea>>2]|0;if((lb|0)==(f[ra>>2]|0)){Yda(v,l);Jb=f[ea>>2]|0}else{N=lb;O=l;P=N+40|0;do{f[N>>2]=f[O>>2];N=N+4|0;O=O+4|0}while((N|0)<(P|0));kb=lb+40|0;f[ea>>2]=kb;Jb=kb}kb=(Jb-(f[v>>2]|0)|0)/40|0;jb=kb+-1|0;ib=(f[g>>2]|0)+(Y(f[f[Za>>2]>>2]|0,ha)|0)|0;hb=(f[Sa>>2]|0)+(Y(f[f[_a>>2]>>2]|0,ha)|0)+xb|0;gb=b[hb>>0]|0;if((gb&-2)<<24>>24==2){La=+(h[ib+(xb*3|0)>>0]|0);Fa=+(h[ib+(xb*3|0)+1>>0]|0);Qa=+(h[ib+(xb*3|0)+2>>0]|0);Ia=+p[f[T>>2]>>3];p[l>>3]=La;p[x>>3]=Fa;p[y>>3]=Qa;Ja=+Sda(B,0,l);Pa=+p[(f[T>>2]|0)+8>>3];p[l>>3]=La;p[x>>3]=Fa;p[y>>3]=Qa;Ra=+Sda(B,1,l);$a=+p[(f[T>>2]|0)+16>>3];p[l>>3]=La;p[x>>3]=Fa;p[y>>3]=Qa;Ha=+Sda(B,2,l);Da=+p[(f[T>>2]|0)+24>>3];p[l>>3]=La;p[x>>3]=Fa;p[y>>3]=Qa;Ca=+Sda(B,3,l);Ma=+p[(f[T>>2]|0)+32>>3];p[l>>3]=La;p[x>>3]=Fa;p[y>>3]=Qa;Ea=-+W(+(Ia*Ja+0.0+Pa*Ra+$a*Ha+Da*Ca+Ma*+Sda(B,4,l)));Ma=+p[f[qa>>2]>>3];p[l>>3]=La;p[Aa>>3]=Fa;p[ua>>3]=Qa;Ca=+Sda(C,0,l);Da=+p[(f[qa>>2]|0)+8>>3];p[l>>3]=La;p[Aa>>3]=Fa;p[ua>>3]=Qa;Ha=+Sda(C,1,l);$a=+p[(f[qa>>2]|0)+16>>3];p[l>>3]=La;p[Aa>>3]=Fa;p[ua>>3]=Qa;Ra=+Sda(C,2,l);Pa=+p[(f[qa>>2]|0)+24>>3];p[l>>3]=La;p[Aa>>3]=Fa;p[ua>>3]=Qa;Ja=+Sda(C,3,l);Ia=+p[(f[qa>>2]|0)+32>>3];p[l>>3]=La;p[Aa>>3]=Fa;p[ua>>3]=Qa;Kb=Ea;Lb=-+W(+(Ma*Ca+0.0+Da*Ha+$a*Ra+Pa*Ja+Ia*+Sda(C,4,l)))}else{ib=gb<<24>>24==0;Kb=ib?0.0:450.0;Lb=ib?450.0:0.0}Zda(v,jb,Kb,Lb);do if((xb|0)<=0){if(Ab)M=198}else{ib=(f[X>>2]|0)+(Y(f[f[J>>2]>>2]|0,ha)|0)+(xb<<3)|0;Ia=+p[ib>>3];ib=kb+-2|0;_da(v,jb,ib,Ia,Ia);if(!Ab)break;gb=(f[_>>2]|0)+(Y(f[f[ia>>2]>>2]|0,ha)|0)+(xb<<3)|0;Ia=+p[gb>>3];_da(v,jb,ib-(f[S>>2]|0)|0,Ia,Ia);M=198}while(0);do if((M|0)==198){M=0;lb=(f[Ba>>2]|0)+(Y(f[f[na>>2]>>2]|0,ha)|0)+(xb<<3)|0;Ia=+p[lb>>3];_da(v,jb,jb-(f[S>>2]|0)|0,Ia,Ia);lb=f[S>>2]|0;if((xb|0)>=(lb+-1|0))break;ib=(f[za>>2]|0)+(Y(f[f[wa>>2]>>2]|0,ha)|0)+(xb<<3)|0;Ia=+p[ib>>3];_da(v,jb,kb-lb|0,Ia,Ia)}while(0);xb=xb+1|0;Mb=f[S>>2]|0}while((xb|0)<(Mb|0));Nb=f[j>>2]|0;Ob=Mb}else{Nb=zb;Ob=fa}ha=ha+1|0;if((ha|0)>=(Nb|0))break;else{fa=Ob;zb=Nb}}}+$da(v);zb=f[ya>>2]|0;if((zb|0)>0){fa=f[va>>2]|0;ha=zb;zb=0;while(1){if((fa|0)>0){xb=fa;Ab=0;while(1){kb=f[Sa>>2]|0;jb=f[f[_a>>2]>>2]|0;lb=kb+(Y(jb,zb)|0)+Ab|0;if((b[lb>>0]&-2)<<24>>24==2){lb=(Y(xb,zb)|0)+Ab|0;do if((lb|0)>-1){ib=f[v>>2]|0;if((((f[ea>>2]|0)-ib|0)/40|0|0)<=(lb|0)){M=210;break}Pb=ib;Qb=jb;Rb=kb}else M=210;while(0);if((M|0)==210){M=0;f[l>>2]=0;f[Z>>2]=0;N=aD(l,26)|0;O=252540;P=N+26|0;do{b[N>>0]=b[O>>0]|0;N=N+1|0;O=O+1|0}while((N|0)<(P|0));bO(-215,l,252567,252583,381);bD(l);Pb=f[v>>2]|0;Qb=f[f[_a>>2]>>2]|0;Rb=f[Sa>>2]|0}kb=(b[Pb+(lb*40|0)+32>>0]|0)==0;jb=kb?m:o;f[jb>>2]=Ab;f[jb+4>>2]=zb;jb=Rb+(Y(Qb,zb)|0)+Ab|0;b[jb>>0]=kb?3:2;Sb=f[va>>2]|0}else Sb=xb;Ab=Ab+1|0;if((Ab|0)>=(Sb|0))break;else xb=Sb}Tb=f[ya>>2]|0;Ub=Sb}else{Tb=ha;Ub=fa}zb=zb+1|0;if((zb|0)>=(Tb|0))break;else{fa=Ub;ha=Tb}}}ha=f[w>>2]|0;if(ha|0){fa=f[ta>>2]|0;if((fa|0)!=(ha|0))f[ta>>2]=fa+(~((fa+-16-ha|0)>>>4)<<4);O5b(ha)}ha=f[v>>2]|0;if(ha|0){fa=f[ea>>2]|0;if((fa|0)!=(ha|0))f[ea>>2]=fa+(~(((fa+-40-ha|0)>>>0)/40|0)*40|0);O5b(ha)}ha=ba+1|0;if((ha|0)>=(i|0))break b;ba=ha;ga=f[j>>2]|0}}while(0);j=t+36|0;i=f[j>>2]|0;if(i|0?(v=i+12|0,i=f[v>>2]|0,f[v>>2]=i+-1,(i|0)==1):0)kL(t);f[j>>2]=0;j=t+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[pa>>2]|0)>0){j=f[oa>>2]|0;oa=0;do{f[j+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[pa>>2]|0))}pa=f[wa>>2]|0;if((pa|0)!=(xa|0))UC(pa);pa=s+36|0;xa=f[pa>>2]|0;if(xa|0?(wa=xa+12|0,xa=f[wa>>2]|0,f[wa>>2]=xa+-1,(xa|0)==1):0)kL(s);f[pa>>2]=0;pa=s+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[d>>2]|0)>0){pa=f[da>>2]|0;da=0;do{f[pa+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[d>>2]|0))}d=f[na>>2]|0;if((d|0)!=(ja|0))UC(d);d=r+36|0;ja=f[d>>2]|0;do if(ja|0){na=ja+12|0;da=f[na>>2]|0;f[na>>2]=da+-1;if((da|0)!=1)break;kL(r)}while(0);f[d>>2]=0;d=r+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[L>>2]|0)>0){d=f[U>>2]|0;U=0;do{f[d+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[L>>2]|0))}L=f[ia>>2]|0;if((L|0)!=(ca|0))UC(L);L=q+36|0;ca=f[L>>2]|0;do if(ca|0){ia=ca+12|0;U=f[ia>>2]|0;f[ia>>2]=U+-1;if((U|0)!=1)break;kL(q)}while(0);f[L>>2]=0;L=q+16|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[K>>2]|0)>0){L=f[Q>>2]|0;Q=0;do{f[L+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[K>>2]|0))}K=f[J>>2]|0;if((K|0)!=(Ga|0))UC(K)}K=D+36|0;Ga=f[K>>2]|0;if(Ga|0?(J=Ga+12|0,Ga=f[J>>2]|0,f[J>>2]=Ga+-1,(Ga|0)==1):0)kL(D);f[K>>2]=0;K=D+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[c>>2]|0)>0){K=f[H>>2]|0;H=0;do{f[K+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[c>>2]|0))}c=f[G>>2]|0;if((c|0)!=(I|0))UC(c);c=C+36|0;I=f[c>>2]|0;if(I|0?(G=I+12|0,I=f[G>>2]|0,f[G>>2]=I+-1,(I|0)==1):0)kL(C);f[c>>2]=0;c=C+16|0;I=C+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[I>>2]|0)>0){c=f[C+40>>2]|0;G=0;do{f[c+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[I>>2]|0))}I=f[C+44>>2]|0;if((I|0)!=(C+48|0))UC(I);I=B+36|0;C=f[I>>2]|0;if(C|0?(G=C+12|0,C=f[G>>2]|0,f[G>>2]=C+-1,(C|0)==1):0)kL(B);f[I>>2]=0;I=B+16|0;C=B+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[C>>2]|0)>0){I=f[B+40>>2]|0;G=0;do{f[I+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[C>>2]|0))}C=f[B+44>>2]|0;if((C|0)!=(B+48|0))UC(C);C=A+36|0;B=f[C>>2]|0;if(B|0?(G=B+12|0,B=f[G>>2]|0,f[G>>2]=B+-1,(B|0)==1):0)kL(A);f[C>>2]=0;C=A+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[C>>2]|0)>0){g=f[e>>2]|0;e=0;do{f[g+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[C>>2]|0))}C=f[A+44>>2]|0;if((C|0)!=(A+48|0))UC(C);if(!(f[z+4>>2]|0)){u=k;return}u=k;return}function Vda(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;g=c+16|0;if(f[g>>2]|0){i=f[c+4>>2]|0;if((i|0)<3)j=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{k=f[c+40>>2]|0;l=0;m=1;while(1){n=Y(f[k+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(i|0)){j=n;break}else m=n}}if((i|0)==0|(j|0)==0)o=7}else o=7;if((o|0)==7){f[e>>2]=0;f[e+4>>2]=0;p=aD(e,13)|0;q=252751;r=p+13|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-5,e,252765,252238,326);bD(e)}if(f[c>>2]&4095|0){f[e>>2]=0;f[e+4>>2]=0;p=aD(e,27)|0;q=252775;r=p+27|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-5,e,252765,252238,328);bD(e)}o=c+12|0;if((f[o>>2]|0)==(f[a+12>>2]|0)?(j=c+8|0,i=f[j>>2]|0,(i|0)==(f[a+8>>2]|0)):0){s=j;t=i}else{f[e>>2]=0;f[e+4>>2]=0;p=aD(e,43)|0;q=252803;r=p+43|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-5,e,252765,252238,330);bD(e);i=c+8|0;s=i;t=f[i>>2]|0}if((t|0)<=0){u=d;return}t=c+44|0;c=e+4|0;i=0;j=f[o>>2]|0;while(1){if((j|0)>0){a=0;m=j;while(1){l=(f[g>>2]|0)+(Y(f[f[t>>2]>>2]|0,i)|0)+a|0;if((h[l>>0]|0)<4)v=m;else{f[e>>2]=0;f[c>>2]=0;p=aD(e,75)|0;q=252847;r=p+75|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-5,e,252765,252238,338);bD(e);v=f[o>>2]|0}a=a+1|0;if((a|0)>=(v|0)){w=v;break}else m=v}}else w=j;i=i+1|0;if((i|0)>=(f[s>>2]|0))break;else j=w}u=d;return}function Wda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[a>>2]|0;if((((f[c>>2]|0)-d|0)/40|0)>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>107374182){g=ze(8)|0;T5b(g,477177);f[g>>2]=149528;If(g|0,25408,1411)}g=(f[e>>2]|0)-d|0;h=L5b(b*40|0)|0;i=h+(((g|0)/40|0)*40|0)|0;j=i+(((g|0)/-40|0)*40|0)|0;if((g|0)>0)Vac(j|0,d|0,g|0)|0;f[a>>2]=j;f[e>>2]=i;f[c>>2]=h+(b*40|0);if(!d)return;O5b(d);return}function Xda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>4>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>268435455){g=ze(8)|0;T5b(g,477177);f[g>>2]=149528;If(g|0,25408,1411)}g=(f[e>>2]|0)-d|0;h=g>>4;i=L5b(b<<4)|0;j=i+(h<<4)|0;k=j+(0-h<<4)|0;if((g|0)>0)Vac(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<4);if(!d)return;O5b(d);return}function Yda(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/40|0;h=g+1|0;if(h>>>0>107374182)c4b(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/40|0;k=j<<1;l=j>>>0<53687091?(k>>>0<h>>>0?h:k):107374182;do if(l)if(l>>>0>107374182){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l*40|0)|0;break}else m=0;while(0);k=m+(g*40|0)|0;g=m+(l*40|0)|0;l=k;m=b;b=l+40|0;do{f[l>>2]=f[m>>2];l=l+4|0;m=m+4|0}while((l|0)<(b|0));m=k+(((e|0)/-40|0)*40|0)|0;if((e|0)>0)Vac(m|0,d|0,e|0)|0;f[a>>2]=m;f[c>>2]=k+40;f[i>>2]=g;if(!d)return;O5b(d);return}function Zda(a,c,d,e){a=a|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0;g=u;u=u+16|0;h=g;if((c|0)>-1?(i=f[a>>2]|0,(((f[a+4>>2]|0)-i|0)/40|0|0)>(c|0)):0)j=i;else{f[h>>2]=0;f[h+4>>2]=0;i=aD(h,26)|0;k=252540;l=i+26|0;do{b[i>>0]=b[k>>0]|0;i=i+1|0;k=k+1|0}while((i|0)<(l|0));bO(-215,h,252736,252583,141);bD(h);j=f[a>>2]|0}m=+p[j+(c*40|0)+24>>3];h=m>0.0;n=h?e:e-m;e=h?m+d:d;h=a+24|0;p[h>>3]=+p[h>>3]+(e<n?e:n);p[j+(c*40|0)+24>>3]=e-n;u=g;return}function _da(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;h=u;u=u+32|0;i=h+16|0;j=h;if(!((c|0)>-1?(((f[a+4>>2]|0)-(f[a>>2]|0)|0)/40|0|0)>(c|0):0)){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,26)|0;l=252540;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,252677,252583,116);bD(i)}if(!((d|0)>-1?(((f[a+4>>2]|0)-(f[a>>2]|0)|0)/40|0|0)>(d|0):0)){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,26)|0;l=252686;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,252677,252583,117);bD(i)}if(!(e>=0.0&g>=0.0)){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,15)|0;l=252713;m=k+15|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,252677,252583,118);bD(i)}if((c|0)==(d|0)){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,6)|0;b[l>>0]=b[252729]|0;b[l+1>>0]=b[252730]|0;b[l+2>>0]=b[252731]|0;b[l+3>>0]=b[252732]|0;b[l+4>>0]=b[252733]|0;b[l+5>>0]=b[252734]|0;bO(-215,i,252677,252583,119);bD(i)}l=a+12|0;k=a+16|0;m=f[k>>2]|0;n=f[l>>2]|0;if((m|0)==(n|0)){bea(l,2);o=f[k>>2]|0;q=f[l>>2]|0}else{o=m;q=n}f[i>>2]=d;n=(f[a>>2]|0)+(c*40|0)+8|0;f[i+4>>2]=f[n>>2];p[i+8>>3]=e;f[n>>2]=o-q>>4;q=a+20|0;if((o|0)==(f[q>>2]|0)){cea(l,i);n=f[k>>2]|0;r=n;s=n}else{n=o;f[n>>2]=f[i>>2];f[n+4>>2]=f[i+4>>2];f[n+8>>2]=f[i+8>>2];f[n+12>>2]=f[i+12>>2];i=(f[k>>2]|0)+16|0;f[k>>2]=i;r=i;s=i}f[j>>2]=c;c=(f[a>>2]|0)+(d*40|0)+8|0;f[j+4>>2]=f[c>>2];p[j+8>>3]=g;f[c>>2]=r-(f[l>>2]|0)>>4;if((s|0)==(f[q>>2]|0)){cea(l,j);u=h;return}else{f[s>>2]=f[j>>2];f[s+4>>2]=f[j+4>>2];f[s+8>>2]=f[j+8>>2];f[s+12>>2]=f[j+12>>2];f[k>>2]=(f[k>>2]|0)+16;u=h;return}}function $da(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;c=u;u=u+80|0;d=c;e=c+56|0;g=c+52|0;h=c+48|0;i=c+40|0;f[d>>2]=d;j=f[a>>2]|0;k=f[a+12>>2]|0;f[e>>2]=0;l=e+4|0;f[l>>2]=0;f[e+8>>2]=0;m=(f[a+4>>2]|0)-j|0;if((m|0)>0){n=(m>>>0)/40|0;m=d;o=0;while(1){q=j+(o*40|0)|0;f[j+(o*40|0)+12>>2]=0;r=+p[j+(o*40|0)+24>>3];if(r!=0.0){f[m>>2]=q;f[j+(o*40|0)+16>>2]=1;b[j+(o*40|0)+32>>0]=r<0.0&1;s=q;t=-1}else{s=m;t=0}f[j+(o*40|0)+4>>2]=t;o=o+1|0;if((o|0)>=(n|0))break;else m=s}v=s;w=f[d>>2]|0}else{v=d;w=d}f[v>>2]=d;f[d>>2]=0;s=i+4|0;m=i+4|0;n=i+4|0;o=a+24|0;a=e+8|0;a:do if((w|0)==(d|0))x=0;else{t=w;q=0;y=v;z=0;while(1){A=-1;B=t;C=y;while(1){f[g>>2]=B;if(!(f[B+4>>2]|0)){D=A;E=C;F=B}else{G=b[B+32>>0]|0;H=f[B+8>>2]|0;b:do if(!H){I=A;J=C}else{K=G&255;M=H;N=C;while(1){O=M^K;do if(!(+p[k+(O<<4)+8>>3]==0.0)){P=f[k+(M<<4)>>2]|0;Q=j+(P*40|0)|0;f[h>>2]=Q;R=j+(P*40|0)+4|0;S=j+(P*40|0)+32|0;if(!(f[R>>2]|0)){b[S>>0]=G;f[j+(P*40|0)+4>>2]=M^1;T=f[g>>2]|0;f[j+(P*40|0)+12>>2]=f[T+12>>2];f[j+(P*40|0)+16>>2]=(f[T+16>>2]|0)+1;if(f[Q>>2]|0){U=N;break}f[Q>>2]=d;Q=f[h>>2]|0;f[N>>2]=Q;U=Q;break}if((b[S>>0]|0)!=G<<24>>24){I=O;J=N;break b}S=f[g>>2]|0;Q=(f[S+16>>2]|0)+1|0;if((f[j+(P*40|0)+16>>2]|0)>(Q|0)?(T=f[S+12>>2]|0,(f[j+(P*40|0)+12>>2]|0)<=(T|0)):0){f[R>>2]=M^1;f[j+(P*40|0)+12>>2]=T;f[j+(P*40|0)+16>>2]=Q;U=N}else U=N}else U=N;while(0);M=f[k+(M<<4)+4>>2]|0;if(!M){I=A;J=U;break}else N=U}}while(0);if((I|0)>0){V=B;W=I;X=J;break}D=I;E=J;F=f[g>>2]|0}B=f[B>>2]|0;f[F>>2]=0;if((B|0)==(d|0)){Y=24;break}else{A=D;C=E}}if((Y|0)==24){Y=0;if((D|0)<1){x=z;break a}else{V=d;W=D;X=E}}C=k+(W<<4)+8|0;r=+p[C>>3];if(!(r>0.0)){f[i>>2]=0;f[s>>2]=0;Z=aD(i,13)|0;_=252655;$=Z+13|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));bO(-215,i,252669,252583,244);bD(i)}A=W^1;B=k+(A<<4)|0;G=f[B>>2]|0;f[g>>2]=j+(G*40|0);H=f[j+(G*40|0)+4>>2]|0;if((H|0)<0){aa=r;ba=G}else{ca=r;G=H;while(1){da=+p[k+((G^1)<<4)+8>>3];ea=ca>da?da:ca;if(!(ea>0.0)){f[i>>2]=0;f[n>>2]=0;Z=aD(i,13)|0;_=252655;$=Z+13|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));bO(-215,i,252669,252583,254);bD(i)}H=f[k+(G<<4)>>2]|0;f[g>>2]=j+(H*40|0);G=f[j+(H*40|0)+4>>2]|0;if((G|0)<0){aa=ea;ba=H;break}else ca=ea}}ca=+L(+(+p[j+(ba*40|0)+24>>3]));r=aa>ca?ca:aa;if(!(r>0.0)){f[i>>2]=0;f[m>>2]=0;Z=aD(i,13)|0;_=252655;$=Z+13|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));bO(-215,i,252669,252583,258);bD(i)}G=k+(W<<4)|0;H=f[G>>2]|0;f[g>>2]=j+(H*40|0);N=f[j+(H*40|0)+4>>2]|0;if((N|0)<0){fa=r;ga=H}else{ca=r;H=N;while(1){da=+p[k+(H<<4)+8>>3];ha=ca>da?da:ca;if(!(ha>0.0)){f[i>>2]=0;f[n>>2]=0;Z=aD(i,13)|0;_=252655;$=Z+13|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));bO(-215,i,252669,252583,254);bD(i)}N=f[k+(H<<4)>>2]|0;f[g>>2]=j+(N*40|0);H=f[j+(N*40|0)+4>>2]|0;if((H|0)<0){fa=ha;ga=N;break}else ca=ha}}ca=+L(+(+p[j+(ga*40|0)+24>>3]));r=fa>ca?ca:fa;if(!(r>0.0)){f[i>>2]=0;f[m>>2]=0;Z=aD(i,13)|0;_=252655;$=Z+13|0;do{b[Z>>0]=b[_>>0]|0;Z=Z+1|0;_=_+1|0}while((Z|0)<($|0));bO(-215,i,252669,252583,258);bD(i)}p[C>>3]=+p[C>>3]-r;H=k+(A<<4)+8|0;p[H>>3]=r+ +p[H>>3];p[o>>3]=r+ +p[o>>3];H=f[B>>2]|0;N=j+(H*40|0)|0;f[g>>2]=N;M=f[j+(H*40|0)+4>>2]|0;K=N;if((M|0)<0){ia=H;ja=K}else{H=M;M=K;while(1){K=k+(H<<4)+8|0;p[K>>3]=r+ +p[K>>3];K=k+((H^1)<<4)+8|0;ca=+p[K>>3]-r;p[K>>3]=ca;if(ca==0.0){K=f[l>>2]|0;if((K|0)==(f[a>>2]|0))aea(e,g);else{f[K>>2]=M;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}K=f[k+(H<<4)>>2]|0;N=j+(K*40|0)|0;f[g>>2]=N;H=f[j+(K*40|0)+4>>2]|0;O=N;if((H|0)<0){ia=K;ja=O;break}else M=O}}M=j+(ia*40|0)+24|0;ca=+p[M>>3]-r;p[M>>3]=ca;if(ca==0.0){M=f[l>>2]|0;if((M|0)==(f[a>>2]|0))aea(e,g);else{f[M>>2]=ja;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}M=f[G>>2]|0;H=j+(M*40|0)|0;f[g>>2]=H;B=f[j+(M*40|0)+4>>2]|0;A=H;if((B|0)<0){ka=M;la=A}else{M=B;B=A;while(1){A=k+((M^1)<<4)+8|0;p[A>>3]=r+ +p[A>>3];A=k+(M<<4)+8|0;ca=+p[A>>3]-r;p[A>>3]=ca;if(ca==0.0){A=f[l>>2]|0;if((A|0)==(f[a>>2]|0))aea(e,g);else{f[A>>2]=B;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}A=f[k+(M<<4)>>2]|0;H=j+(A*40|0)|0;f[g>>2]=H;M=f[j+(A*40|0)+4>>2]|0;C=H;if((M|0)<0){ka=A;la=C;break}else B=C}}B=j+(ka*40|0)+24|0;ca=r+ +p[B>>3];p[B>>3]=ca;if(ca==0.0){B=f[l>>2]|0;if((B|0)==(f[a>>2]|0))aea(e,g);else{f[B>>2]=la;f[l>>2]=(f[l>>2]|0)+4}f[(f[g>>2]|0)+4>>2]=-2}q=q+1|0;B=f[e>>2]|0;M=f[l>>2]|0;c:do if((B|0)==(M|0)){ma=X;na=B}else{G=X;C=B;A=M;while(1){H=A;while(1){H=H+-4|0;oa=f[H>>2]|0;f[l>>2]=H;pa=b[oa+32>>0]|0;qa=oa+8|0;O=f[qa>>2]|0;if(!O){Y=51;break}K=(pa^1)&255;N=2147483647;Q=O;O=0;while(1){d:do if(+p[k+((Q^K)<<4)+8>>3]==0.0){ra=N;sa=O}else{P=f[k+(Q<<4)>>2]|0;T=j+(P*40|0)|0;f[h>>2]=T;if((b[j+(P*40|0)+32>>0]|0)!=pa<<24>>24){ra=N;sa=O;break}if(!(f[j+(P*40|0)+4>>2]|0)){ra=N;sa=O;break}R=j+(P*40|0)+12|0;e:do if((f[R>>2]|0)==(q|0)){ta=0;ua=P;Y=57}else{S=0;va=T;wa=R;while(1){xa=f[va+4>>2]|0;ya=S+1|0;if((xa|0)<0)break;za=f[k+(xa<<4)>>2]|0;Aa=j+(za*40|0)|0;f[h>>2]=Aa;Ba=j+(za*40|0)+12|0;if((f[Ba>>2]|0)==(q|0)){ta=ya;ua=za;Y=57;break e}else{S=ya;va=Aa;wa=Ba}}if((xa|0)==-2){ra=N;sa=O;break d}f[wa>>2]=q;f[va+16>>2]=1;Ca=ya}while(0);if((Y|0)==57){Y=0;Ca=(f[j+(ua*40|0)+16>>2]|0)+ta|0}R=Ca+1|0;if((R|0)==2147483647){ra=N;sa=O;break}S=(R|0)<(N|0);Ba=S?Q:O;Aa=S?R:N;f[h>>2]=T;S=j+(P*40|0)+12|0;if((f[S>>2]|0)==(q|0)){ra=Aa;sa=Ba;break}else{Da=R;Ea=P;Fa=S}do{f[Fa>>2]=q;Da=Da+-1|0;f[j+(Ea*40|0)+16>>2]=Da;Ea=f[k+(f[j+(Ea*40|0)+4>>2]<<4)>>2]|0;Fa=j+(Ea*40|0)+12|0}while((f[Fa>>2]|0)!=(q|0));f[h>>2]=j+(Ea*40|0);ra=Aa;sa=Ba}while(0);Q=f[k+(Q<<4)+4>>2]|0;if(!Q)break;else{N=ra;O=sa}}f[oa+4>>2]=sa;O=oa+12|0;if((sa|0)<=0){Ga=O;break}f[O>>2]=q;f[oa+16>>2]=ra;if((C|0)==(H|0)){ma=G;na=C;break c}}if((Y|0)==51){Y=0;f[oa+4>>2]=0;Ga=oa+12|0}f[Ga>>2]=0;O=f[qa>>2]|0;if(!O){Ha=G;Ia=H}else{N=(pa^1)&255;Q=O;O=G;while(1){K=f[k+(Q<<4)>>2]|0;P=j+(K*40|0)|0;f[h>>2]=P;T=f[j+(K*40|0)+4>>2]|0;do if(T|0?(b[j+(K*40|0)+32>>0]|0)==pa<<24>>24:0){do if(+p[k+((Q^N)<<4)+8>>3]!=0.0){if(f[P>>2]|0){Ja=O;break}f[P>>2]=d;S=f[h>>2]|0;f[O>>2]=S;Ja=S}else Ja=O;while(0);if((T|0)<=0){Ka=Ja;break}if((j+((f[k+(T<<4)>>2]|0)*40|0)|0)!=(oa|0)){Ka=Ja;break}S=f[l>>2]|0;if((S|0)==(f[a>>2]|0))aea(e,h);else{f[S>>2]=f[h>>2];f[l>>2]=(f[l>>2]|0)+4}f[(f[h>>2]|0)+4>>2]=-2;Ka=Ja}else Ka=O;while(0);Q=f[k+(Q<<4)+4>>2]|0;if(!Q)break;else O=Ka}Ha=Ka;Ia=f[l>>2]|0}C=f[e>>2]|0;if((C|0)==(Ia|0)){ma=Ha;na=Ia;break}else{G=Ha;A=Ia}}}while(0);if((V|0)==(d|0)){x=na;break}else{t=V;y=ma;z=na}}}while(0);fa=+p[o>>3];if(!x){u=c;return +fa}o=f[l>>2]|0;if((o|0)!=(x|0))f[l>>2]=o+(~((o+-4-x|0)>>>2)<<2);O5b(x);u=c;return +fa}function aea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function bea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)c4b(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=k+(d<<4)|0;d=b;b=h;k=h;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;g=h+(0-(b>>4)<<4)|0;if((b|0)>0)Vac(g|0,d|0,b|0)|0;f[a>>2]=g;f[e>>2]=k;f[c>>2]=i;if(!d)return;O5b(d);return}function cea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;O5b(d);return}function dea(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0;e=u;u=u+80|0;g=e+72|0;h=e+16|0;i=e+8|0;j=e;dQ(g,56224);do if((yM(a)|0)==65536){k=f[a+4>>2]|0;f[h>>2]=f[k>>2];l=h+4|0;m=k+4|0;f[l>>2]=f[m>>2];o=h+8|0;f[o>>2]=f[k+8>>2];f[h+12>>2]=f[k+12>>2];f[h+16>>2]=f[k+16>>2];f[h+20>>2]=f[k+20>>2];f[h+24>>2]=f[k+24>>2];f[h+28>>2]=f[k+28>>2];f[h+32>>2]=f[k+32>>2];p=f[k+36>>2]|0;f[h+36>>2]=p;f[h+40>>2]=o;o=h+48|0;q=h+44|0;f[q>>2]=o;f[o>>2]=0;f[h+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;o=f[q>>2]|0;f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];break}else{f[l>>2]=0;jL(h,k);break}}else yL(h,a,-1);while(0);a=wM(h,2,-1,1)|0;k=f[h>>2]&7;if(!((a|0)>-1&(k|1|0)==5)){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,40)|0;m=253022;o=l+40|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(o|0));bO(-215,i,253063,253082,158);bD(i)}m=c+4|0;n[m>>2]=0.0;n[c>>2]=0.0;n[d>>2]=0.0;a:do if(a|0){l=(k|0)==5;o=f[h+16>>2]|0;switch(a|0){case 1:{q=f[o>>2]|0;if(l){r=q;t=f[o+4>>2]|0}else{p=(n[s>>2]=+(q|0),f[s>>2]|0);r=p;t=(n[s>>2]=+(f[o+4>>2]|0),f[s>>2]|0)}f[c>>2]=r;f[m>>2]=t;n[d>>2]=9.999999747378752e-05;break a;break}case 2:{if(l){v=+n[o+12>>2];w=+n[o+4>>2];x=+n[o+8>>2];y=+n[o>>2]}else{v=+(f[o+12>>2]|0);w=+(f[o+4>>2]|0);x=+(f[o+8>>2]|0);y=+(f[o>>2]|0)}n[c>>2]=(y+x)*.5;n[m>>2]=(w+v)*.5;z=y-x;A=w-v;B=+M(+(A*A+z*z))*.5+9.999999747378752e-05;n[d>>2]=B;break a;break}default:{n[i>>2]=0.0;p=i+4|0;n[p>>2]=0.0;n[j>>2]=0.0;b:do if(l){B=+n[o+8>>2];z=(+n[o>>2]+B)*.5;n[i>>2]=z;q=o+4|0;A=+n[o+12>>2];C=(+n[q>>2]+A)*.5;n[p>>2]=C;D=+n[o>>2]-B;B=+n[q>>2]-A;A=+M(+(D*D+B*B))*.5+9.999999747378752e-05;n[j>>2]=A;if((a|0)>2){q=2;B=z;z=C;C=A;while(1){A=+n[o+(q<<3)>>2]-B;D=+n[o+(q<<3)+4>>2]-z;if(!(+M(+(A*A+D*D))<C))eea(o,q,i,j);E=q+1|0;if((E|0)==(a|0))break b;q=E;B=+n[i>>2];z=+n[p>>2];C=+n[j>>2]}}}else{q=f[o>>2]|0;E=f[o+8>>2]|0;C=+(E+q|0)*.5;n[i>>2]=C;F=f[o+4>>2]|0;G=f[o+12>>2]|0;z=+(G+F|0)*.5;n[p>>2]=z;B=+(q-E|0);D=+(F-G|0);A=+M(+(B*B+D*D))*.5+9.999999747378752e-05;n[j>>2]=A;if((a|0)>2){G=2;D=C;C=z;z=A;while(1){A=+(f[o+(G<<3)>>2]|0)-D;B=+(f[o+(G<<3)+4>>2]|0)-C;if(!(+M(+(A*A+B*B))<z))fea(o,G,i,j);F=G+1|0;if((F|0)==(a|0))break b;G=F;D=+n[i>>2];C=+n[p>>2];z=+n[j>>2]}}}while(0);f[c>>2]=f[i>>2];f[m>>2]=f[p>>2];f[d>>2]=f[j>>2];break a}}}while(0);j=h+36|0;d=f[j>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)kL(h);f[j>>2]=0;j=h+16|0;d=h+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[d>>2]|0)>0){j=f[h+40>>2]|0;m=0;do{f[j+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[d>>2]|0))}d=f[h+44>>2]|0;if((d|0)!=(h+48|0))UC(d);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function eea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0.0,j=0.0,k=0.0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0;e=a+(b<<3)|0;n[c>>2]=(+n[a>>2]+ +n[e>>2])*.5;f=a+4|0;g=a+(b<<3)+4|0;h=c+4|0;n[h>>2]=(+n[f>>2]+ +n[g>>2])*.5;i=+n[a>>2]-+n[e>>2];j=+n[f>>2]-+n[g>>2];k=+M(+(i*i+j*j))*.5+9.999999747378752e-05;n[d>>2]=k;if((b|0)>1){l=1;m=k}else return;while(1){f=a+(l<<3)|0;k=+n[f>>2];o=a+(l<<3)+4|0;j=+n[o>>2];i=+n[c>>2]-k;p=+n[h>>2]-j;if(+M(+(i*i+p*p))<m)q=m;else{n[c>>2]=(k+ +n[e>>2])*.5;n[h>>2]=(j+ +n[g>>2])*.5;j=+n[f>>2]-+n[e>>2];k=+n[o>>2]-+n[g>>2];p=+M(+(j*j+k*k))*.5+9.999999747378752e-05;n[d>>2]=p;r=0;k=p;while(1){p=+n[a+(r<<3)>>2];j=+n[a+(r<<3)+4>>2];i=+n[c>>2]-p;s=+n[h>>2]-j;if(+M(+(i*i+s*s))<k)t=k;else{s=+n[e>>2];i=+n[g>>2];u=+n[f>>2];v=+n[o>>2];w=u-s;x=v-i;y=p-s;z=j-i;A=w*((s+u)*.5)+x*((i+v)*.5);v=y*((p+s)*.5)+z*((j+i)*.5);j=z*w-y*x;p=(z*A-x*v)/j;x=(w*v-y*A)/j;n[c>>2]=p;n[h>>2]=x;j=p-s;s=x-i;i=+M(+(j*j+s*s))+9.999999747378752e-05;n[d>>2]=i;t=i}r=r+1|0;if((r|0)==(l|0)){q=t;break}else k=t}}l=l+1|0;if((l|0)==(b|0))break;else m=q}return}function fea(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0.0,l=0.0,m=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0;e=f[a>>2]|0;g=f[a+(b<<3)>>2]|0;n[c>>2]=+(g+e|0)*.5;h=f[a+4>>2]|0;i=f[a+(b<<3)+4>>2]|0;j=c+4|0;n[j>>2]=+(i+h|0)*.5;k=+(e-g|0);l=+(h-i|0);m=+M(+(k*k+l*l))*.5+9.999999747378752e-05;n[d>>2]=m;if((b|0)<=1)return;l=+(g|0);k=+(i|0);h=1;o=m;while(1){e=f[a+(h<<3)>>2]|0;m=+(e|0);p=f[a+(h<<3)+4>>2]|0;q=+(p|0);r=+n[c>>2]-m;s=+n[j>>2]-q;if(+M(+(r*r+s*s))<o)t=o;else{n[c>>2]=+(g+e|0)*.5;n[j>>2]=+(i+p|0)*.5;s=+(e-g|0);r=+(p-i|0);u=+M(+(s*s+r*r))*.5+9.999999747378752e-05;n[d>>2]=u;r=m-l;s=q-k;v=r*((m+l)*.5)+s*((q+k)*.5);p=0;q=u;while(1){u=+(f[a+(p<<3)>>2]|0);m=+(f[a+(p<<3)+4>>2]|0);w=+n[c>>2]-u;x=+n[j>>2]-m;if(+M(+(w*w+x*x))<q)y=q;else{x=u-l;w=m-k;z=x*((l+u)*.5)+w*((k+m)*.5);m=r*w-s*x;u=(v*w-s*z)/m;w=(r*z-v*x)/m;n[c>>2]=u;n[j>>2]=w;m=u-l;u=w-k;w=+M(+(m*m+u*u))+9.999999747378752e-05;n[d>>2]=w;y=w}p=p+1|0;if((p|0)==(h|0)){t=y;break}else q=y}}h=h+1|0;if((h|0)==(b|0))break;else o=t}return}function gea(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,t=0.0,v=0.0,w=0.0,x=0.0;d=u;u=u+80|0;e=d+64|0;g=d+8|0;h=d;dQ(e,56244);do if((yM(a)|0)==65536){i=f[a+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[g+36>>2]=m;f[g+40>>2]=l;l=g+48|0;o=g+44|0;f[o>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;jL(g,i);break}}else yL(g,a,-1);while(0);a=wM(g,2,-1,1)|0;i=f[g>>2]&7;if(!((a|0)>-1&(i|1|0)==5)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,40)|0;k=253022;l=j+40|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,253217,253082,237);bD(h)}if((a|0)>=2){h=c?a+-1|0:0;c=f[g+16>>2]|0;if((i|0)==5){p=0.0;i=0;k=f[c+(h<<3)>>2]|0;j=f[c+(h<<3)+4>>2]|0;while(1){l=k;k=f[c+(i<<3)>>2]|0;q=(f[s>>2]=k,+n[s>>2]);o=j;j=f[c+(i<<3)+4>>2]|0;r=(f[s>>2]=j,+n[s>>2]);t=q-(f[s>>2]=l,+n[s>>2]);q=r-(f[s>>2]=o,+n[s>>2]);r=p+ +M(+(q*q+t*t));i=i+1|0;if((i|0)==(a|0)){v=r;break}else p=r}}else{p=0.0;i=0;r=+(f[c+(h<<3)>>2]|0);t=+(f[c+(h<<3)+4>>2]|0);while(1){q=r;r=+(f[c+(i<<3)>>2]|0);w=t;t=+(f[c+(i<<3)+4>>2]|0);x=r-q;q=t-w;w=p+ +M(+(q*q+x*x));i=i+1|0;if((i|0)==(a|0)){v=w;break}else p=w}}}else v=0.0;a=g+36|0;i=f[a>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)kL(g);f[a>>2]=0;a=g+16|0;i=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[i>>2]|0)>0){a=f[g+40>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[g+44>>2]|0;if((i|0)!=(g+48|0))UC(i);if(!(f[e+4>>2]|0)){u=d;return +v}u=d;return +v}function hea(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0;d=u;u=u+80|0;e=d+64|0;g=d+8|0;h=d;dQ(e,56264);do if((yM(a)|0)==65536){i=f[a+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[g+36>>2]=m;f[g+40>>2]=l;l=g+48|0;o=g+44|0;f[o>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;jL(g,i);break}}else yL(g,a,-1);while(0);a=wM(g,2,-1,1)|0;i=f[g>>2]&7;if(!((a|0)>-1&(i|1|0)==5)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,42)|0;k=253266;l=j+42|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,253309,253082,272);bD(h)}if(a){h=(i|0)==5;i=f[g+16>>2]|0;k=a+-1|0;if(h){j=f[i+(k<<3)+4>>2]|0;p=+n[i+(k<<3)>>2];q=j;r=(f[s>>2]=j,+n[s>>2])}else{t=+(f[i+(k<<3)+4>>2]|0);p=+(f[i+(k<<3)>>2]|0);q=(n[s>>2]=t,f[s>>2]|0);r=t}if((a|0)>0)if(h){t=0.0;h=0;k=q;v=p;while(1){w=v;v=+n[i+(h<<3)>>2];q=k;k=f[i+(h<<3)+4>>2]|0;x=w*(f[s>>2]=k,+n[s>>2]);w=t+(x-(f[s>>2]=q,+n[s>>2])*v);h=h+1|0;if((h|0)==(a|0)){y=w;break}else t=w}}else{t=0.0;h=0;v=p;p=r;while(1){r=v;v=+(f[i+(h<<3)>>2]|0);w=p;p=+(f[i+(h<<3)+4>>2]|0);x=t+(r*p-w*v);h=h+1|0;if((h|0)==(a|0)){y=x;break}else t=x}}else y=0.0;t=y*.5;if(c)z=t;else z=+L(+t)}else z=0.0;c=g+36|0;a=f[c>>2]|0;if(a|0?(h=a+12|0,a=f[h>>2]|0,f[h>>2]=a+-1,(a|0)==1):0)kL(g);f[c>>2]=0;c=g+16|0;a=g+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[g+40>>2]|0;h=0;do{f[c+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)!=(g+48|0))UC(a);if(!(f[e+4>>2]|0)){u=d;return +z}u=d;return +z}function iea(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0,Xa=0.0,Ya=0.0;d=u;u=u+2592|0;e=d+2584|0;g=d+2528|0;h=d+2232|0;i=d+2192|0;j=d+1096|0;k=d;l=d+2472|0;m=d+2416|0;o=d+2360|0;q=d+2304|0;r=d+2288|0;s=d+2272|0;dQ(e,56284);do if((yM(c)|0)==65536){t=f[c+4>>2]|0;f[g>>2]=f[t>>2];v=g+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=g+8|0;f[x>>2]=f[t+8>>2];f[g+12>>2]=f[t+12>>2];f[g+16>>2]=f[t+16>>2];f[g+20>>2]=f[t+20>>2];f[g+24>>2]=f[t+24>>2];f[g+28>>2]=f[t+28>>2];f[g+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[g+36>>2]=y;f[g+40>>2]=x;x=g+48|0;z=g+44|0;f[z>>2]=x;f[x>>2]=0;f[g+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[v>>2]=0;jL(g,t);break}}else yL(g,c,-1);while(0);c=wM(g,2,-1,1)|0;t=f[g>>2]&7;if(!((c|0)>-1&(t|1|0)==5)){f[h>>2]=0;f[h+4>>2]=0;A=aD(h,36)|0;B=253362;C=A+36|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,h,253399,253082,305);bD(h)};f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;if((c|0)<5){f[h>>2]=0;f[h+4>>2]=0;A=aD(h,52)|0;B=253410;C=A+52|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-201,h,253399,253082,310);bD(h)}A=h;C=A+40|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));A=i;C=A+40|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));A=(t|0)==5;t=g+16|0;C=f[t>>2]|0;B=g+44|0;v=c*5|0;w=j+8|0;f[j>>2]=w;x=j+4|0;f[x>>2]=v;if(v>>>0>136){z=N5b(v>>>0>536870911?-1:v<<3)|0;f[j>>2]=z;D=z}else D=w;z=k+8|0;f[k>>2]=z;v=k+4|0;f[v>>2]=c;if(c>>>0>136){y=N5b(c>>>0>536870911?-1:c<<3)|0;f[k>>2]=y;E=y}else E=z;y=l+4|0;f[y>>2]=2;F=l+8|0;f[F>>2]=c;G=l+12|0;f[G>>2]=5;H=l+16|0;f[H>>2]=D;I=l+20|0;f[I>>2]=D;J=l+24|0;K=l+28|0;N=l+40|0;O=J+8|0;f[O>>2]=0;f[O+4>>2]=0;f[N>>2]=F;O=l+48|0;Q=l+44|0;f[Q>>2]=O;f[l>>2]=1124024326;f[O>>2]=40;f[l+52>>2]=8;R=D+((f[F>>2]|0)*5<<3)|0;f[K>>2]=R;f[J>>2]=R+-40+40;R=m+4|0;f[R>>2]=2;S=m+8|0;f[S>>2]=c;T=m+12|0;f[T>>2]=1;V=m+16|0;f[V>>2]=E;W=m+20|0;f[W>>2]=E;X=m+24|0;Y=m+28|0;Z=m+40|0;_=X+8|0;f[_>>2]=0;f[_+4>>2]=0;f[Z>>2]=S;_=m+48|0;$=m+44|0;f[$>>2]=_;f[m>>2]=1124024326;f[_>>2]=8;f[m+52>>2]=8;aa=E+(f[S>>2]<<3)|0;f[Y>>2]=aa;f[X>>2]=aa+-8+8;aa=o+4|0;f[aa>>2]=2;ba=o+8|0;f[ba>>2]=5;ca=o+12|0;f[ca>>2]=1;da=o+16|0;f[da>>2]=h;ea=o+20|0;f[ea>>2]=h;fa=o+24|0;ga=o+28|0;ha=o+40|0;ia=fa+8|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ha>>2]=ba;ia=o+48|0;ja=o+44|0;f[ja>>2]=ia;f[o>>2]=1124024326;f[ia>>2]=8;f[o+52>>2]=8;f[ga>>2]=h+40;f[fa>>2]=h+40;ka=(c|0)>0;if(ka){if(A){la=0;ma=0.0;na=0.0;while(1){oa=ma+ +n[C+(la<<3)>>2];pa=na+ +n[C+(la<<3)+4>>2];la=la+1|0;if((la|0)==(c|0)){qa=oa;ra=pa;break}else{ma=oa;na=pa}}}else{la=0;na=0.0;ma=0.0;while(1){pa=na+ +(f[C+(la<<3)>>2]|0);oa=ma+ +(f[C+(la<<3)+4>>2]|0);la=la+1|0;if((la|0)==(c|0)){qa=pa;ra=oa;break}else{na=pa;ma=oa}}}ma=+(c|0);na=qa/ma;qa=ra/ma;if(ka)if(A){la=0;do{ma=+n[C+(la<<3)>>2]-na;ra=+n[C+(la<<3)+4>>2]-qa;p[E+(la<<3)>>3]=1.0e4;oa=ma;sa=la*5|0;p[D+(sa<<3)>>3]=-(oa*oa);ma=ra;p[D+(sa+1<<3)>>3]=-(ma*ma);p[D+(sa+2<<3)>>3]=-(ma*oa);p[D+(sa+3<<3)>>3]=oa;p[D+(sa+4<<3)>>3]=ma;la=la+1|0}while((la|0)!=(c|0));ta=na;ua=qa}else{la=0;do{ma=+(f[C+(la<<3)>>2]|0)-na;oa=+(f[C+(la<<3)+4>>2]|0)-qa;p[E+(la<<3)>>3]=1.0e4;ra=ma;sa=la*5|0;p[D+(sa<<3)>>3]=-(ra*ra);ma=oa;p[D+(sa+1<<3)>>3]=-(ma*ma);p[D+(sa+2<<3)>>3]=-(ma*ra);p[D+(sa+3<<3)>>3]=ra;p[D+(sa+4<<3)>>3]=ma;la=la+1|0}while((la|0)!=(c|0));ta=na;ua=qa}else{ta=na;ua=qa}}else{qa=+(c|0);ta=0.0/qa;ua=0.0/qa}f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;la=s+8|0;f[la>>2]=0;f[la+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=o;jT(q,r,s,1)|0;la=q+4|0;f[la>>2]=2;sa=q+8|0;f[sa>>2]=2;va=q+12|0;f[va>>2]=2;wa=q+16|0;f[wa>>2]=D;xa=q+20|0;f[xa>>2]=D;ya=q+24|0;za=q+28|0;Aa=q+40|0;Ba=ya+8|0;f[Ba>>2]=0;f[Ba+4>>2]=0;f[Aa>>2]=sa;Ba=q+48|0;Ca=q+44|0;f[Ca>>2]=Ba;Da=q+36|0;f[q>>2]=1124024326;f[Ba>>2]=16;f[q+52>>2]=8;Ea=D+(f[sa>>2]<<1<<3)|0;f[za>>2]=Ea;f[ya>>2]=Ea+-16+16;Ea=l+36|0;Fa=f[Ea>>2]|0;if(Fa|0?(Ga=Fa+12|0,Fa=f[Ga>>2]|0,f[Ga>>2]=Fa+-1,(Fa|0)==1):0)kL(l);f[Ea>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[y>>2]|0)>0){Fa=f[N>>2]|0;Ga=0;do{f[Fa+(Ga<<2)>>2]=0;Ga=Ga+1|0;Ha=f[y>>2]|0}while((Ga|0)<(Ha|0));f[l>>2]=f[q>>2];if((Ha|0)<3)Ia=33;else Ia=35}else{f[l>>2]=f[q>>2];Ia=33}if((Ia|0)==33){Ha=f[la>>2]|0;if((Ha|0)<3){f[y>>2]=Ha;f[F>>2]=f[sa>>2];f[G>>2]=f[va>>2];va=f[Ca>>2]|0;sa=f[Q>>2]|0;f[sa>>2]=f[va>>2];f[sa+4>>2]=f[va+4>>2]}else Ia=35}if((Ia|0)==35)jL(l,q);f[H>>2]=f[wa>>2];f[I>>2]=f[xa>>2];f[J>>2]=f[ya>>2];f[K>>2]=f[za>>2];za=l+32|0;f[za>>2]=f[q+32>>2];ya=f[Da>>2]|0;f[Ea>>2]=ya;if(ya|0?(xa=ya+12|0,ya=f[xa>>2]|0,f[xa>>2]=ya+-1,(ya|0)==1):0)kL(q);f[Da>>2]=0;f[wa>>2]=0;f[wa+4>>2]=0;f[wa+8>>2]=0;f[wa+12>>2]=0;if((f[la>>2]|0)>0){wa=f[Aa>>2]|0;Aa=0;do{f[wa+(Aa<<2)>>2]=0;Aa=Aa+1|0}while((Aa|0)<(f[la>>2]|0))}la=f[Ca>>2]|0;if((la|0)!=(Ba|0))UC(la);la=q+4|0;f[la>>2]=2;Ba=q+8|0;f[Ba>>2]=2;Ca=q+12|0;f[Ca>>2]=1;Aa=q+16|0;f[Aa>>2]=E;wa=q+20|0;f[wa>>2]=E;Da=q+24|0;ya=q+28|0;xa=q+40|0;va=Da+8|0;f[va>>2]=0;f[va+4>>2]=0;f[xa>>2]=Ba;va=q+48|0;sa=q+44|0;f[sa>>2]=va;Ha=q+36|0;f[q>>2]=1124024326;f[va>>2]=8;f[q+52>>2]=8;Ga=E+(f[Ba>>2]<<3)|0;f[ya>>2]=Ga;f[Da>>2]=Ga+-8+8;Ga=m+36|0;Fa=f[Ga>>2]|0;if(Fa|0?(Ja=Fa+12|0,Fa=f[Ja>>2]|0,f[Ja>>2]=Fa+-1,(Fa|0)==1):0)kL(m);f[Ga>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[R>>2]|0)>0){Fa=f[Z>>2]|0;Ja=0;do{f[Fa+(Ja<<2)>>2]=0;Ja=Ja+1|0;Ka=f[R>>2]|0}while((Ja|0)<(Ka|0));f[m>>2]=f[q>>2];if((Ka|0)<3)Ia=52;else Ia=54}else{f[m>>2]=f[q>>2];Ia=52}if((Ia|0)==52){Ka=f[la>>2]|0;if((Ka|0)<3){f[R>>2]=Ka;f[S>>2]=f[Ba>>2];f[T>>2]=f[Ca>>2];Ca=f[sa>>2]|0;Ba=f[$>>2]|0;f[Ba>>2]=f[Ca>>2];f[Ba+4>>2]=f[Ca+4>>2]}else Ia=54}if((Ia|0)==54)jL(m,q);f[V>>2]=f[Aa>>2];f[W>>2]=f[wa>>2];f[X>>2]=f[Da>>2];f[Y>>2]=f[ya>>2];ya=m+32|0;f[ya>>2]=f[q+32>>2];Da=f[Ha>>2]|0;f[Ga>>2]=Da;if(Da|0?(wa=Da+12|0,Da=f[wa>>2]|0,f[wa>>2]=Da+-1,(Da|0)==1):0)kL(q);f[Ha>>2]=0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[Aa+8>>2]=0;f[Aa+12>>2]=0;if((f[la>>2]|0)>0){Aa=f[xa>>2]|0;xa=0;do{f[Aa+(xa<<2)>>2]=0;xa=xa+1|0}while((xa|0)<(f[la>>2]|0))}la=f[sa>>2]|0;if((la|0)!=(va|0))UC(la);la=q+4|0;f[la>>2]=2;va=q+8|0;f[va>>2]=2;sa=q+12|0;f[sa>>2]=1;xa=q+16|0;f[xa>>2]=i;Aa=q+20|0;f[Aa>>2]=i;Ha=q+24|0;Da=q+28|0;wa=q+40|0;Ca=Ha+8|0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[wa>>2]=va;Ca=q+48|0;Ba=q+44|0;f[Ba>>2]=Ca;f[q>>2]=1124024326;f[Ca>>2]=8;f[q+52>>2]=8;f[Da>>2]=i+16;f[Ha>>2]=i+16;Ka=q+36|0;Ja=o+36|0;Fa=f[Ja>>2]|0;if(Fa|0?(La=Fa+12|0,Fa=f[La>>2]|0,f[La>>2]=Fa+-1,(Fa|0)==1):0)kL(o);f[Ja>>2]=0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[aa>>2]|0)>0){Fa=f[ha>>2]|0;La=0;do{f[Fa+(La<<2)>>2]=0;La=La+1|0;Ma=f[aa>>2]|0}while((La|0)<(Ma|0));f[o>>2]=f[q>>2];if((Ma|0)<3)Ia=71;else Ia=73}else{f[o>>2]=f[q>>2];Ia=71}if((Ia|0)==71){Ma=f[la>>2]|0;if((Ma|0)<3){f[aa>>2]=Ma;f[ba>>2]=f[va>>2];f[ca>>2]=f[sa>>2];sa=f[Ba>>2]|0;va=f[ja>>2]|0;f[va>>2]=f[sa>>2];f[va+4>>2]=f[sa+4>>2]}else Ia=73}if((Ia|0)==73)jL(o,q);f[da>>2]=f[xa>>2];f[ea>>2]=f[Aa>>2];f[fa>>2]=f[Ha>>2];f[ga>>2]=f[Da>>2];Da=o+32|0;f[Da>>2]=f[q+32>>2];Ha=f[Ka>>2]|0;f[Ja>>2]=Ha;do if(Ha|0){Aa=Ha+12|0;sa=f[Aa>>2]|0;f[Aa>>2]=sa+-1;if((sa|0)!=1)break;kL(q)}while(0);f[Ka>>2]=0;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=0;f[xa+12>>2]=0;if((f[la>>2]|0)>0){xa=f[wa>>2]|0;wa=0;do{f[xa+(wa<<2)>>2]=0;wa=wa+1|0}while((wa|0)<(f[la>>2]|0))}la=f[Ba>>2]|0;if((la|0)!=(Ca|0))UC(la);p[D>>3]=+p[h>>3]*2.0;la=h+16|0;qa=+p[la>>3];p[D+16>>3]=qa;p[D+8>>3]=qa;Ca=h+8|0;p[D+24>>3]=+p[Ca>>3]*2.0;p[E>>3]=+p[h+24>>3];p[E+8>>3]=+p[h+32>>3];f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;Ba=s+8|0;f[Ba>>2]=0;f[Ba+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=o;jT(q,r,s,1)|0;Ba=q+4|0;f[Ba>>2]=2;wa=q+8|0;f[wa>>2]=c;xa=q+12|0;f[xa>>2]=3;Ka=q+16|0;f[Ka>>2]=D;Ha=q+20|0;f[Ha>>2]=D;sa=q+24|0;Aa=q+28|0;va=q+40|0;Ma=sa+8|0;f[Ma>>2]=0;f[Ma+4>>2]=0;f[va>>2]=wa;Ma=q+48|0;La=q+44|0;f[La>>2]=Ma;Fa=q+36|0;f[q>>2]=1124024326;f[Ma>>2]=24;f[q+52>>2]=8;Na=D+((f[wa>>2]|0)*3<<3)|0;f[Aa>>2]=Na;f[sa>>2]=Na+-24+24;Na=f[Ea>>2]|0;do if(Na|0){Oa=Na+12|0;Pa=f[Oa>>2]|0;f[Oa>>2]=Pa+-1;if((Pa|0)!=1)break;kL(l)}while(0);f[Ea>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[y>>2]|0)>0){Na=f[N>>2]|0;Pa=0;do{f[Na+(Pa<<2)>>2]=0;Pa=Pa+1|0;Qa=f[y>>2]|0}while((Pa|0)<(Qa|0));f[l>>2]=f[q>>2];if((Qa|0)<3)Ia=90;else Ia=92}else{f[l>>2]=f[q>>2];Ia=90}do if((Ia|0)==90){Qa=f[Ba>>2]|0;if((Qa|0)>=3){Ia=92;break}f[y>>2]=Qa;f[F>>2]=f[wa>>2];f[G>>2]=f[xa>>2];Qa=f[La>>2]|0;Pa=f[Q>>2]|0;f[Pa>>2]=f[Qa>>2];f[Pa+4>>2]=f[Qa+4>>2]}while(0);if((Ia|0)==92)jL(l,q);f[H>>2]=f[Ka>>2];f[I>>2]=f[Ha>>2];f[J>>2]=f[sa>>2];f[K>>2]=f[Aa>>2];f[za>>2]=f[q+32>>2];za=f[Fa>>2]|0;f[Ea>>2]=za;do if(za|0){Aa=za+12|0;K=f[Aa>>2]|0;f[Aa>>2]=K+-1;if((K|0)!=1)break;kL(q)}while(0);f[Fa>>2]=0;f[Ka>>2]=0;f[Ka+4>>2]=0;f[Ka+8>>2]=0;f[Ka+12>>2]=0;if((f[Ba>>2]|0)>0){Ka=f[va>>2]|0;va=0;do{f[Ka+(va<<2)>>2]=0;va=va+1|0}while((va|0)<(f[Ba>>2]|0))}Ba=f[La>>2]|0;if((Ba|0)!=(Ma|0))UC(Ba);Ba=q+4|0;f[Ba>>2]=2;Ma=q+8|0;f[Ma>>2]=c;La=q+12|0;f[La>>2]=1;va=q+16|0;f[va>>2]=E;Ka=q+20|0;f[Ka>>2]=E;Fa=q+24|0;za=q+28|0;K=q+40|0;Aa=Fa+8|0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[K>>2]=Ma;Aa=q+48|0;sa=q+44|0;f[sa>>2]=Aa;J=q+36|0;f[q>>2]=1124024326;f[Aa>>2]=8;f[q+52>>2]=8;Ha=E+(f[Ma>>2]<<3)|0;f[za>>2]=Ha;f[Fa>>2]=Ha+-8+8;Ha=f[Ga>>2]|0;do if(Ha|0){I=Ha+12|0;xa=f[I>>2]|0;f[I>>2]=xa+-1;if((xa|0)!=1)break;kL(m)}while(0);f[Ga>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[R>>2]|0)>0){Ha=f[Z>>2]|0;xa=0;do{f[Ha+(xa<<2)>>2]=0;xa=xa+1|0;Ra=f[R>>2]|0}while((xa|0)<(Ra|0));f[m>>2]=f[q>>2];if((Ra|0)<3)Ia=109;else Ia=111}else{f[m>>2]=f[q>>2];Ia=109}do if((Ia|0)==109){Ra=f[Ba>>2]|0;if((Ra|0)>=3){Ia=111;break}f[R>>2]=Ra;f[S>>2]=f[Ma>>2];f[T>>2]=f[La>>2];Ra=f[sa>>2]|0;xa=f[$>>2]|0;f[xa>>2]=f[Ra>>2];f[xa+4>>2]=f[Ra+4>>2]}while(0);if((Ia|0)==111)jL(m,q);f[V>>2]=f[va>>2];f[W>>2]=f[Ka>>2];f[X>>2]=f[Fa>>2];f[Y>>2]=f[za>>2];f[ya>>2]=f[q+32>>2];ya=f[J>>2]|0;f[Ga>>2]=ya;do if(ya|0){za=ya+12|0;Y=f[za>>2]|0;f[za>>2]=Y+-1;if((Y|0)!=1)break;kL(q)}while(0);f[J>>2]=0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;if((f[Ba>>2]|0)>0){va=f[K>>2]|0;K=0;do{f[va+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[Ba>>2]|0))}Ba=f[sa>>2]|0;if((Ba|0)!=(Aa|0))UC(Ba);Ba=q+4|0;f[Ba>>2]=2;Aa=q+8|0;f[Aa>>2]=3;sa=q+12|0;f[sa>>2]=1;K=q+16|0;f[K>>2]=h;va=q+20|0;f[va>>2]=h;J=q+24|0;ya=q+28|0;Y=q+40|0;za=J+8|0;f[za>>2]=0;f[za+4>>2]=0;f[Y>>2]=Aa;za=q+48|0;Fa=q+44|0;f[Fa>>2]=za;f[q>>2]=1124024326;f[za>>2]=8;f[q+52>>2]=8;f[ya>>2]=h+24;f[J>>2]=h+24;X=q+36|0;Ka=f[Ja>>2]|0;do if(Ka|0){W=Ka+12|0;La=f[W>>2]|0;f[W>>2]=La+-1;if((La|0)!=1)break;kL(o)}while(0);f[Ja>>2]=0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[aa>>2]|0)>0){Ka=f[ha>>2]|0;La=0;do{f[Ka+(La<<2)>>2]=0;La=La+1|0;Sa=f[aa>>2]|0}while((La|0)<(Sa|0));f[o>>2]=f[q>>2];if((Sa|0)<3)Ia=128;else Ia=130}else{f[o>>2]=f[q>>2];Ia=128}do if((Ia|0)==128){Sa=f[Ba>>2]|0;if((Sa|0)>=3){Ia=130;break}f[aa>>2]=Sa;f[ba>>2]=f[Aa>>2];f[ca>>2]=f[sa>>2];Sa=f[Fa>>2]|0;La=f[ja>>2]|0;f[La>>2]=f[Sa>>2];f[La+4>>2]=f[Sa+4>>2]}while(0);if((Ia|0)==130)jL(o,q);f[da>>2]=f[K>>2];f[ea>>2]=f[va>>2];f[fa>>2]=f[J>>2];f[ga>>2]=f[ya>>2];f[Da>>2]=f[q+32>>2];Da=f[X>>2]|0;f[Ja>>2]=Da;do if(Da|0){ya=Da+12|0;ga=f[ya>>2]|0;f[ya>>2]=ga+-1;if((ga|0)!=1)break;kL(q)}while(0);f[X>>2]=0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[Ba>>2]|0)>0){K=f[Y>>2]|0;Y=0;do{f[K+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[Ba>>2]|0))}Ba=f[Fa>>2]|0;if((Ba|0)!=(za|0))UC(Ba);if(ka){qa=+p[i>>3];na=+p[i+8>>3];if(A){A=0;do{ma=+n[C+(A<<3)>>2]-ta;ra=+n[C+(A<<3)+4>>2]-ua;p[E+(A<<3)>>3]=1.0;oa=ma;ma=oa-qa;ka=A*3|0;p[D+(ka<<3)>>3]=ma*ma;ma=ra;ra=ma-na;p[D+(ka+1<<3)>>3]=ra*ra;p[D+(ka+2<<3)>>3]=(oa-qa)*(ma-na);A=A+1|0}while((A|0)!=(c|0))}else{A=0;do{ma=+(f[C+(A<<3)>>2]|0)-ta;oa=+(f[C+(A<<3)+4>>2]|0)-ua;p[E+(A<<3)>>3]=1.0;ra=ma;ma=ra-qa;ka=A*3|0;p[D+(ka<<3)>>3]=ma*ma;ma=oa;oa=ma-na;p[D+(ka+1<<3)>>3]=oa*oa;p[D+(ka+2<<3)>>3]=(ra-qa)*(ma-na);A=A+1|0}while((A|0)!=(c|0))}}f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=l;f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;c=s+8|0;f[c>>2]=0;f[c+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=o;jT(q,r,s,1)|0;na=+p[la>>3];qa=+p[Ca>>3];ma=+p[h>>3];ra=qa-ma;oa=+U(+na,+ra)*-.5;p[i+32>>3]=oa;if(+L(+na)>1.0e-08)Ta=na/+P(+(oa*-2.0));else Ta=ra;ra=ma+qa;qa=+L(+(ra-Ta));if(qa>1.0e-08)Ua=+M(+(2.0/qa));else Ua=qa;p[i+16>>3]=Ua;qa=+L(+(ra+Ta));if(qa>1.0e-08)Va=+M(+(2.0/qa));else Va=qa;p[i+24>>3]=Va;n[a>>2]=ta+ +p[i>>3];n[a+4>>2]=ua+ +p[i+8>>3];ua=Ua*2.0;i=a+8|0;n[i>>2]=ua;Ua=Va*2.0;h=a+12|0;n[h>>2]=Ua;if(ua>Ua){n[i>>2]=Ua;n[h>>2]=ua;ua=oa*180.0/3.141592653589793+90.0;h=a+16|0;n[h>>2]=ua;Wa=h;Xa=ua}else{h=a+16|0;Wa=h;Xa=+n[h>>2]}ua=Xa+360.0;if(Xa<-180.0){n[Wa>>2]=ua;Ya=ua}else Ya=Xa;if(Ya>360.0)n[Wa>>2]=Ya+-360.0;Wa=f[Ja>>2]|0;do if(Wa|0){h=Wa+12|0;a=f[h>>2]|0;f[h>>2]=a+-1;if((a|0)!=1)break;kL(o)}while(0);f[Ja>>2]=0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[aa>>2]|0)>0){da=f[ha>>2]|0;ha=0;do{f[da+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[aa>>2]|0))}aa=f[ja>>2]|0;if((aa|0)!=(ia|0))UC(aa);aa=f[Ga>>2]|0;do if(aa|0){ia=aa+12|0;ja=f[ia>>2]|0;f[ia>>2]=ja+-1;if((ja|0)!=1)break;kL(m)}while(0);f[Ga>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[R>>2]|0)>0){V=f[Z>>2]|0;Z=0;do{f[V+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[R>>2]|0))}R=f[$>>2]|0;if((R|0)!=(_|0))UC(R);R=f[Ea>>2]|0;do if(R|0){_=R+12|0;$=f[_>>2]|0;f[_>>2]=$+-1;if(($|0)!=1)break;kL(l)}while(0);f[Ea>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[y>>2]|0)>0){H=f[N>>2]|0;N=0;do{f[H+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[y>>2]|0))}y=f[Q>>2]|0;if((y|0)!=(O|0))UC(y);y=f[k>>2]|0;if((y|0)!=(z|0)){if(y|0)P5b(y);f[k>>2]=z;f[v>>2]=136}v=f[j>>2]|0;if((v|0)!=(w|0)){if(v|0)P5b(v);f[j>>2]=w;f[x>>2]=136}x=g+36|0;w=f[x>>2]|0;do if(w|0){j=w+12|0;v=f[j>>2]|0;f[j>>2]=v+-1;if((v|0)!=1)break;kL(g)}while(0);f[x>>2]=0;x=g+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[x>>2]|0)>0){t=f[g+40>>2]|0;w=0;do{f[t+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[x>>2]|0))}x=f[B>>2]|0;if((x|0)!=(g+48|0))UC(x);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function jea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+64|0;d=c+56|0;e=c;dQ(d,56304);do if((yM(b)|0)==65536){g=f[b+4>>2]|0;f[e>>2]=f[g>>2];h=e+4|0;i=g+4|0;f[h>>2]=f[i>>2];j=e+8|0;f[j>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[e+16>>2]=f[g+16>>2];f[e+20>>2]=f[g+20>>2];f[e+24>>2]=f[g+24>>2];f[e+28>>2]=f[g+28>>2];f[e+32>>2]=f[g+32>>2];k=f[g+36>>2]|0;f[e+36>>2]=k;f[e+40>>2]=j;j=e+48|0;l=e+44|0;f[l>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[g+44>>2]|0;j=f[l>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];m=e;break}else{f[h>>2]=0;jL(e,g);m=e;break}}else{yL(e,b,-1);m=e}while(0);if(!(f[m>>2]&7))kea(a,e);else lea(a,e);a=e+36|0;m=f[a>>2]|0;if(m|0?(b=m+12|0,m=f[b>>2]|0,f[b>>2]=m+-1,(m|0)==1):0)kL(e);f[a>>2]=0;a=e+16|0;m=e+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[m>>2]|0)>0){a=f[e+40>>2]|0;b=0;do{f[a+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[m>>2]|0))}m=f[e+44>>2]|0;if((m|0)!=(e+48|0))UC(m);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function kea(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;if(!((g&6)>>>0<2&(g&4088|0)==0)){f[e>>2]=0;f[e+4>>2]=0;g=aD(e,39)|0;h=253527;i=g+39|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-215,e,253567,253082,859);bD(e)}e=f[c+40>>2]|0;h=f[e+4>>2]|0;g=f[e>>2]|0;if((g|0)<=0){j=h;k=-1;l=-1;m=0;n=(j|0)<(h|0);o=n?k:0;p=n?j:0;q=l+1|0;r=q-p|0;s=m-o|0;f[a>>2]=p;t=a+4|0;f[t>>2]=o;v=a+8|0;f[v>>2]=r;w=a+12|0;f[w>>2]=s;u=d;return}e=f[c+16>>2]|0;i=f[f[c+44>>2]>>2]|0;c=-1;x=-1;y=0;z=-1;A=h;while(1){B=e+(Y(i,y)|0)|0;C=B;D=C+3&-4;E=D;F=D-C|0;C=(F|0)>(h|0)?h:F;a:do if((C|0)>0){D=0;while(1){if(b[B+D>>0]|0)break;G=D+1|0;if((G|0)<(C|0))D=G;else{H=0;I=x;J=A;break a}}H=1;I=(D|0)>(x|0)?D:x;J=(D|0)<(A|0)?D:A}else{H=0;I=x;J=A}while(0);if((h|0)>(F|0)){B=J-C|0;G=I-C|0;K=h-C|0;L=B+-4|0;b:do if((B|0)<4)M=0;else{N=0;while(1){if(f[E+N>>2]|0){M=N;break b}O=N+4|0;if((O|0)>(L|0)){M=O;break}else N=O}}while(0);c:do if((M|0)<(B|0)){L=M;while(1){if(b[E+L>>0]|0)break;F=L+1|0;if((F|0)<(B|0))L=F;else{P=H;Q=F;R=B;S=G;break c}}P=1;Q=L;R=L;S=(L|0)>(G|0)?L:G}else{P=H;Q=M;R=B;S=G}while(0);G=Q+-1|0;B=(G|0)<(S|0)?S:G;G=K;while(1){T=G+-1|0;U=(T|0)>(B|0);V=(T&3|0)==3;if(V|U^1){W=20;break}if(!(b[E+T>>0]|0))G=T;else{X=T;break}}d:do if((W|0)==20){W=0;if(U&V?(G=B+3|0,(T|0)>(G|0)):0){K=T;while(1){if(f[E+K+-3>>2]|0){X=K;break d}F=K+-4|0;if((F|0)>(G|0))K=F;else{X=F;break}}}else X=T}while(0);e:do if((X|0)>(B|0)){K=X;while(1){if(b[E+K>>0]|0){Z=1;_=K;break e}G=K+-1|0;if((G|0)>(B|0))K=G;else{$=G;W=27;break}}}else{$=X;W=27}while(0);f:do if((W|0)==27){W=0;if(!P){B=Q&-4;K=$+-3|0;g:do if((B|0)>(K|0))aa=B;else{G=B;while(1){if(f[E+G>>2]|0){aa=G;break g}L=G+4|0;if((L|0)>(K|0)){aa=L;break}else G=L}}while(0);if((aa|0)>($|0)){Z=0;_=S}else{K=aa;while(1){if(b[E+K>>0]|0){Z=1;_=S;break f}if((K|0)<($|0))K=K+1|0;else{Z=0;_=S;break}}}}else{Z=P;_=S}}while(0);ba=R+C|0;ca=Z;da=_+C|0}else{ba=J;ca=H;da=I}E=(ca|0)==0;z=E?z:y;c=E?c:(c|0)<0?y:c;y=y+1|0;if((y|0)==(g|0))break;else{x=da;A=ba}}j=ba;k=c;l=da;m=z+1|0;n=(j|0)<(h|0);o=n?k:0;p=n?j:0;q=l+1|0;r=q-p|0;s=m-o|0;f[a>>2]=p;t=a+4|0;f[t>>2]=o;v=a+8|0;f[v>>2]=r;w=a+12|0;f[w>>2]=s;u=d;return}function lea(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0;d=u;u=u+16|0;e=d;g=wM(c,2,-1,1)|0;h=f[c>>2]&7;if(!((g|0)>-1&(h|1|0)==5)){f[e>>2]=0;f[e+4>>2]=0;i=aD(e,42)|0;j=253266;k=i+42|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,e,253506,253082,741);bD(e)}if(!g){f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;u=d;return}e=f[c+16>>2]|0;c=f[e>>2]|0;j=f[e+4>>2]|0;if((h|0)!=5)if((g|0)>1){h=c;i=j;k=c;l=1;m=j;while(1){o=f[e+(l<<3)>>2]|0;p=f[e+(l<<3)+4>>2]|0;q=(h|0)>(o|0)?o:h;r=(k|0)<(o|0)?o:k;o=(i|0)>(p|0)?p:i;t=(m|0)<(p|0)?p:m;l=l+1|0;if((l|0)==(g|0)){v=q;w=o;x=r;y=t;break}else{h=q;i=o;k=r;m=t}}}else{v=c;w=j;x=c;y=j}else{m=c>>31&2147483647^c;c=j>>31&2147483647^j;if((g|0)>1){j=1;k=c;i=m;h=c;l=m;while(1){t=f[e+(j<<3)>>2]|0;r=f[e+(j<<3)+4>>2]|0;o=t>>31&2147483647^t;t=r>>31&2147483647^r;r=(l|0)>(o|0)?o:l;q=(i|0)<(o|0)?o:i;o=(k|0)>(t|0)?t:k;p=(h|0)<(t|0)?t:h;j=j+1|0;if((j|0)==(g|0)){z=r;A=o;B=q;C=p;break}else{k=o;i=q;h=p;l=r}}}else{z=m;A=c;B=m;C=c}D=(f[s>>2]=z>>31&2147483647^z,+n[s>>2]);z=~~D;E=(f[s>>2]=A>>31&2147483647^A,+n[s>>2]);A=~~E;F=(f[s>>2]=B>>31&2147483647^B,+n[s>>2]);B=~~F;G=(f[s>>2]=C>>31&2147483647^C,+n[s>>2]);C=~~G;v=z-(+(z|0)>D&1)|0;w=A-(+(A|0)>E&1)|0;x=B-(+(B|0)>F&1)|0;y=C-(+(C|0)>G&1)|0}f[a>>2]=v;f[a+4>>2]=w;f[a+8>>2]=x+1-v;f[a+12>>2]=y+1-w;u=d;return}function mea(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+1344|0;g=e+1256|0;h=e+1236|0;i=e+1208|0;j=e;k=e+1152|0;l=e+1096|0;m=g+56|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((c|0)!=0?(m=f[c>>2]|0,(m&-65536|0)==1117323264):0){if((m&4094|0)!=12){f[j>>2]=0;f[j+4>>2]=0;n=aD(j,25)|0;o=253622;p=n+25|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-5,j,253648,253082,1316);bD(j)}if((f[c+4>>2]|0)>=88)if(!d){m=c+56|0;f[a>>2]=f[m>>2];f[a+4>>2]=f[m+4>>2];f[a+8>>2]=f[m+8>>2];f[a+12>>2]=f[m+12>>2];u=e;return}else{q=d;r=c;s=21}else{q=0;r=c;s=21}}else s=6;a:do if((s|0)==6){d=sQ(c,i,0,0)|0;switch(f[d>>2]&4095){case 13:case 12:{q=0;r=G3(0,d,g,h)|0;s=21;break a;break}case 1:case 0:break;default:{f[j>>2]=0;f[j+4>>2]=0;n=aD(j,56)|0;o=253663;p=n+56|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-210,j,253648,253082,1336);bD(j)}}if(!d){q=0;r=0;s=21}else{tL(k,d,0,1,0,0);kea(j,k);m=f[j>>2]|0;t=f[j+4>>2]|0;v=f[j+8>>2]|0;w=f[j+12>>2]|0;x=k+36|0;y=f[x>>2]|0;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)kL(k);f[x>>2]=0;x=k+16|0;y=k+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[y>>2]|0)>0){x=f[k+40>>2]|0;z=0;do{f[x+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[y>>2]|0))}y=f[k+44>>2]|0;if((y|0)!=(k+48|0))UC(y);A=m;B=v;C=w;D=t}}while(0);if((s|0)==21){if(!(f[r+24>>2]|0)){E=0;F=0;G=0;H=0}else{s=j+8|0;f[j>>2]=s;o=j+4|0;f[o>>2]=136;tL(l,r,0,0,0,j);lea(k,l);n=f[k>>2]|0;p=f[k+4>>2]|0;h=f[k+8>>2]|0;g=f[k+12>>2]|0;k=l+36|0;i=f[k>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)kL(l);f[k>>2]=0;k=l+16|0;i=l+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[l+40>>2]|0;c=0;do{f[k+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[l+44>>2]|0;if((i|0)!=(l+48|0))UC(i);i=f[j>>2]|0;if((i|0)!=(s|0)){if(i|0)P5b(i);f[j>>2]=s;f[o>>2]=136}E=n;F=h;G=g;H=p}if(!q){A=E;B=F;C=G;D=H}else{f[r+56>>2]=E;f[r+60>>2]=H;f[r+64>>2]=F;f[r+68>>2]=G;A=E;B=F;C=G;D=H}}f[a>>2]=A;f[a+4>>2]=D;f[a+8>>2]=B;f[a+12>>2]=C;u=e;return}function nea(a,c,d,e,g){a=a|0;c=c|0;d=+d;e=+e;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;i=u;u=u+1376|0;j=i+344|0;k=i+336|0;l=i+280|0;m=i+272|0;n=i+144|0;o=i;q=i+216|0;r=i+160|0;dQ(k,56324);do if((yM(a)|0)==65536){s=f[a+4>>2]|0;f[l>>2]=f[s>>2];t=l+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=l+8|0;f[w>>2]=f[s+8>>2];f[l+12>>2]=f[s+12>>2];f[l+16>>2]=f[s+16>>2];f[l+20>>2]=f[s+20>>2];f[l+24>>2]=f[s+24>>2];f[l+28>>2]=f[s+28>>2];f[l+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[l+36>>2]=x;f[l+40>>2]=w;w=l+48|0;y=l+44|0;f[y>>2]=w;f[w>>2]=0;f[l+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;jL(l,s);break}}else yL(l,a,-1);while(0);a=g&7;switch(g&-8|0){case 24:{f[j>>2]=0;f[j+4>>2]=0;z=aD(j,57)|0;A=253720;B=z+57|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,j,355105,253778,1403);bD(j);C=d;break}case 8:{s=f[l>>2]|0;if(!(s&4095))D=s;else{f[j>>2]=0;f[j+4>>2]=0;z=aD(j,55)|0;A=271684;B=z+55|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,j,355105,253778,1406);bD(j);D=f[l>>2]|0}s=f[l+40>>2]|0;t=f[s+4>>2]|0;v=f[s>>2]|0;s=(D&16384|0)!=0;D=Y(v,t)|0;w=s?D:t;t=s?1:v;v=s?D:f[l+48>>2]|0;Nac(j|0,0,1024)|0;a:do if((t|0)>0){s=f[l+16>>2]|0;y=w+-4|0;if((w|0)<4){if((w|0)>0)E=0;else{F=0.0;G=0;break}while(1){x=s+(Y(E,v)|0)|0;H=0;do{I=j+((h[x+H>>0]|0)<<2)|0;f[I>>2]=(f[I>>2]|0)+1;H=H+1|0}while((H|0)!=(w|0));E=E+1|0;if((E|0)==(t|0)){F=0.0;G=0;break a}}}H=w&-4;if((H|0)<(w|0))J=0;else{x=0;while(1){I=s+(Y(x,v)|0)|0;K=0;do{L=h[I+(K|1)>>0]|0;M=j+((h[I+K>>0]|0)<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=j+(L<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=h[I+(K|3)>>0]|0;L=j+((h[I+(K|2)>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=j+(M<<2)|0;f[L>>2]=(f[L>>2]|0)+1;K=K+4|0}while((K|0)<=(y|0));x=x+1|0;if((x|0)==(t|0)){F=0.0;G=0;break a}}}do{x=s+(Y(J,v)|0)|0;K=0;do{I=h[x+(K|1)>>0]|0;L=j+((h[x+K>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=j+(I<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=h[x+(K|3)>>0]|0;I=j+((h[x+(K|2)>>0]|0)<<2)|0;f[I>>2]=(f[I>>2]|0)+1;I=j+(L<<2)|0;f[I>>2]=(f[I>>2]|0)+1;K=K+4|0}while((K|0)<=(y|0));N=H;do{K=j+((h[x+N>>0]|0)<<2)|0;f[K>>2]=(f[K>>2]|0)+1;N=N+1|0}while((N|0)!=(w|0));J=J+1|0}while((J|0)!=(t|0));F=0.0;G=0}else{F=0.0;G=0}while(0);do{F=F+ +(G|0)*+(f[j+(G<<2)>>2]|0);G=G+1|0}while((G|0)!=256);O=1.0/+(D|0);P=O*F;F=0.0;Q=0.0;R=0.0;S=0.0;D=0;while(1){T=O*+(f[j+(D<<2)>>2]|0);U=S*F;F=F+T;V=1.0-F;if(!((V<F?V:F)<1.1920928955078125e-07)?!((F<V?V:F)>.9999998807907104):0){W=+(D|0);X=(U+W*T)/F;T=X-(P-F*X)/V;Z=T*(F*V*T);G=Z>R;_=X;$=G?W:Q;aa=G?Z:R}else{_=U;$=Q;aa=R}D=D+1|0;if((D|0)==256)break;else{Q=$;R=aa;S=_}}C=$;break}case 16:{D=f[l>>2]|0;if(!(D&4095))ba=D;else{f[j>>2]=0;f[j+4>>2]=0;z=aD(j,55)|0;A=271684;B=z+55|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,j,355105,253778,1411);bD(j);ba=f[l>>2]|0}A=f[l+40>>2]|0;z=f[A+4>>2]|0;B=f[A>>2]|0;A=(ba&16384|0)!=0;ba=Y(B,z)|0;D=A?1:B;B=A?ba:z;z=A?ba:f[l+48>>2]|0;Nac(j|0,0,1024)|0;b:do if((D|0)>0){ba=f[l+16>>2]|0;A=B+-4|0;if((B|0)<4){if((B|0)>0)ca=0;else{da=0;break}while(1){G=ba+(Y(ca,z)|0)|0;t=0;do{J=j+((h[G+t>>0]|0)<<2)|0;f[J>>2]=(f[J>>2]|0)+1;t=t+1|0}while((t|0)!=(B|0));ca=ca+1|0;if((ca|0)==(D|0)){da=0;break b}}}t=B&-4;if((t|0)<(B|0))ea=0;else{G=0;while(1){J=ba+(Y(G,z)|0)|0;w=0;do{N=h[J+(w|1)>>0]|0;v=j+((h[J+w>>0]|0)<<2)|0;f[v>>2]=(f[v>>2]|0)+1;v=j+(N<<2)|0;f[v>>2]=(f[v>>2]|0)+1;v=h[J+(w|3)>>0]|0;N=j+((h[J+(w|2)>>0]|0)<<2)|0;f[N>>2]=(f[N>>2]|0)+1;N=j+(v<<2)|0;f[N>>2]=(f[N>>2]|0)+1;w=w+4|0}while((w|0)<=(A|0));G=G+1|0;if((G|0)==(D|0)){da=0;break b}}}do{G=ba+(Y(ea,z)|0)|0;w=0;do{J=h[G+(w|1)>>0]|0;N=j+((h[G+w>>0]|0)<<2)|0;f[N>>2]=(f[N>>2]|0)+1;N=j+(J<<2)|0;f[N>>2]=(f[N>>2]|0)+1;N=h[G+(w|3)>>0]|0;J=j+((h[G+(w|2)>>0]|0)<<2)|0;f[J>>2]=(f[J>>2]|0)+1;J=j+(N<<2)|0;f[J>>2]=(f[J>>2]|0)+1;w=w+4|0}while((w|0)<=(A|0));fa=t;do{w=j+((h[G+fa>>0]|0)<<2)|0;f[w>>2]=(f[w>>2]|0)+1;fa=fa+1|0}while((fa|0)!=(B|0));ea=ea+1|0}while((ea|0)!=(D|0));da=0}else da=0;while(0);while(1){if((f[j+(da<<2)>>2]|0)>0){ga=da;break}da=da+1|0;if((da|0)>=256){ga=0;break}}da=(((ga|0)>0)<<31>>31)+ga|0;ga=255;while(1){if((f[j+(ga<<2)>>2]|0)>0){ha=ga;break}if((ga|0)>1)ga=ga+-1|0;else{ha=0;break}}ga=(ha|0)<255;D=0;ea=0;B=0;do{fa=f[j+(B<<2)>>2]|0;z=(fa|0)>(D|0);ea=z?B:ea;D=z?fa:D;B=B+1|0}while((B|0)!=256);B=(ga&1)+ha|0;if((ea-da|0)<(B-ea|0)){ha=255;ga=0;do{fa=j+(ga<<2)|0;z=f[fa>>2]|0;ca=j+(ha<<2)|0;f[fa>>2]=f[ca>>2];f[ca>>2]=z;ga=ga+1|0;ha=ha+-1|0}while((ga|0)<(ha|0));ia=1;ja=255-B|0;ka=255-ea|0}else{ia=0;ja=da;ka=ea}$=+(ja|0);_=+(D|0);S=+(ja-ka|0);if((ja|0)<(ka|0)){aa=0.0;R=$;D=ja;while(1){D=D+1|0;Q=+(D|0);F=_*Q+S*+(f[j+(D<<2)>>2]|0);ja=F>aa;P=ja?Q:R;if((D|0)==(ka|0)){la=P;break}else{aa=ja?F:aa;R=P}}}else la=$;$=la+-1.0;C=ia?255.0-$:$;break}default:C=d}ia=l+40|0;ka=f[ia>>2]|0;D=f[ka>>2]|0;f[m>>2]=f[ka+4>>2];f[m+4>>2]=D;vM(c,m,f[l>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){m=f[c+4>>2]|0;f[j>>2]=f[m>>2];D=j+4|0;ka=m+4|0;f[D>>2]=f[ka>>2];ja=j+8|0;f[ja>>2]=f[m+8>>2];f[j+12>>2]=f[m+12>>2];f[j+16>>2]=f[m+16>>2];f[j+20>>2]=f[m+20>>2];f[j+24>>2]=f[m+24>>2];f[j+28>>2]=f[m+28>>2];f[j+32>>2]=f[m+32>>2];ea=f[m+36>>2]|0;f[j+36>>2]=ea;f[j+40>>2]=ja;ja=j+48|0;da=j+44|0;f[da>>2]=ja;f[ja>>2]=0;f[j+52>>2]=0;if(ea|0){ja=ea+12|0;f[ja>>2]=(f[ja>>2]|0)+1}if((f[ka>>2]|0)<3){ka=f[m+44>>2]|0;ja=f[da>>2]|0;f[ja>>2]=f[ka>>2];f[ja+4>>2]=f[ka+4>>2];break}else{f[D>>2]=0;jL(j,m);break}}else yL(j,c,-1);while(0);c=f[l>>2]|0;c:do switch(c&7){case 0:{m=~~C;D=m-(+(m|0)>C&1)|0;d=+(D|0);m=MVb(e)|0;ka=(a|0)==2;ja=ka?D:m;m=ja>>>0<256?ja:(ja|0)>0?255:0;ja=m&255;da=(D|0)>254;if(D>>>0<=254){ma=+(m&255);na=d;oa=c;pa=100;break c}if((a|1|0)!=1?!((ka|(a|0)==4)&(D|0)<0|(a|0)==3&da):0){D=n+8|0;f[D>>2]=0;f[D+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=j;SP(l,n);qa=d;break c}switch(g&7){case 0:{ra=da?0:ja;break}case 1:{ra=da?ja:0;break}default:ra=0}p[o>>3]=+(ra|0);f[n>>2]=-1056833530;f[n+4>>2]=o;f[n+8>>2]=1;f[n+12>>2]=1;VP(j,n,UM()|0)|0;qa=d;break}case 3:{ja=~~C;da=ja-(+(ja|0)>C&1)|0;d=+(da|0);ja=MVb(e)|0;D=(a|0)==2;ka=D?da:ja;ja=(ka+32768|0)>>>0<65536?ka:(ka|0)>0?32767:32768;ka=ja<<16>>16;m=(da|0)>32766;if((da+32768|0)>>>0<=65534){ma=+((ja&65535)<<16>>16);na=d;oa=c;pa=100;break c}if((a|1|0)!=1?!((D|(a|0)==4)&(da|0)<-32768|(a|0)==3&m):0){da=n+8|0;f[da>>2]=0;f[da+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=j;SP(l,n);qa=d;break c}switch(g&7){case 0:{sa=m?0:ka;break}case 1:{sa=m?ka:0;break}default:sa=0}p[o>>3]=+(sa|0);f[n>>2]=-1056833530;f[n+4>>2]=o;f[n+8>>2]=1;f[n+12>>2]=1;VP(j,n,UM()|0)|0;qa=d;break}case 2:{ka=~~C;m=ka-(+(ka|0)>C&1)|0;d=+(m|0);ka=MVb(e)|0;da=(a|0)==2?m:ka;ka=da>>>0<65536?da:(da|0)>0?65535:0;da=ka&65535;D=(m|0)>65534;if(m>>>0<=65534){ma=+(ka&65535);na=d;oa=c;pa=100;break c}ka=g&255;d:do if((a|1|0)==1)pa=93;else{switch(ka&7){case 2:case 4:{if((a|0)==3&D|(m|0)<0){pa=93;break d}break}default:if((a|0)==3&D){ta=0;break d}}ja=n+8|0;f[ja>>2]=0;f[ja+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=j;SP(l,n);qa=d;break c}while(0);e:do if((pa|0)==93)switch(ka&7){case 0:{ta=D?0:da;break e;break}case 1:{ta=D?da:0;break e;break}default:{ta=0;break e}}while(0);p[o>>3]=+(ta|0);f[n>>2]=-1056833530;f[n+4>>2]=o;f[n+8>>2]=1;f[n+12>>2]=1;VP(j,n,UM()|0)|0;qa=d;break}case 6:case 5:{ma=e;na=C;oa=c;pa=100;break}default:{f[n>>2]=0;f[n+4>>2]=0;bO(-210,n,355105,253778,1509);bD(n);ma=e;na=C;oa=f[l>>2]|0;pa=100}}while(0);if((pa|0)==100){pa=j+8|0;c=f[pa>>2]|0;f[n>>2]=0;f[n+4>>2]=c;f[q>>2]=oa;oa=q+4|0;c=l+4|0;ta=f[c>>2]|0;f[oa>>2]=ta;g=q+8|0;f[g>>2]=f[l+8>>2];f[q+12>>2]=f[l+12>>2];sa=q+16|0;f[sa>>2]=f[l+16>>2];f[q+20>>2]=f[l+20>>2];f[q+24>>2]=f[l+24>>2];f[q+28>>2]=f[l+28>>2];f[q+32>>2]=f[l+32>>2];ra=q+36|0;da=f[l+36>>2]|0;f[ra>>2]=da;D=q+40|0;f[D>>2]=g;g=q+48|0;ka=q+44|0;f[ka>>2]=g;f[g>>2]=0;f[q+52>>2]=0;if(!da)ua=ta;else{ta=da+12|0;f[ta>>2]=(f[ta>>2]|0)+1;ua=f[c>>2]|0}if((ua|0)<3){ua=f[l+44>>2]|0;c=f[ka>>2]|0;f[c>>2]=f[ua>>2];f[c+4>>2]=f[ua+4>>2]}else{f[oa>>2]=0;jL(q,l)}f[r>>2]=f[j>>2];ua=r+4|0;c=j+4|0;ta=f[c>>2]|0;f[ua>>2]=ta;da=r+8|0;f[da>>2]=f[pa>>2];m=j+12|0;f[r+12>>2]=f[m>>2];ja=r+16|0;f[ja>>2]=f[j+16>>2];f[r+20>>2]=f[j+20>>2];f[r+24>>2]=f[j+24>>2];f[r+28>>2]=f[j+28>>2];f[r+32>>2]=f[j+32>>2];ea=r+36|0;B=f[j+36>>2]|0;f[ea>>2]=B;ha=r+40|0;f[ha>>2]=da;da=r+48|0;ga=r+44|0;f[ga>>2]=da;f[da>>2]=0;f[r+52>>2]=0;if(!B)va=ta;else{ta=B+12|0;f[ta>>2]=(f[ta>>2]|0)+1;va=f[c>>2]|0}if((va|0)<3){va=f[j+44>>2]|0;ta=f[ga>>2]|0;f[ta>>2]=f[va>>2];f[ta+4>>2]=f[va+4>>2]}else{f[ua>>2]=0;jL(r,j)}oea(o,q,r,na,ma,a);a=f[c>>2]|0;if((a|0)<3)wa=Y(f[m>>2]|0,f[pa>>2]|0)|0;else{pa=f[j+40>>2]|0;m=0;c=1;while(1){va=Y(f[pa+(m<<2)>>2]|0,c)|0;m=m+1|0;if((m|0)==(a|0)){wa=va;break}else c=va}}RQ(n,o,+(wa>>>0)*.0000152587890625);pea(o);o=f[ea>>2]|0;if(o|0?(wa=o+12|0,o=f[wa>>2]|0,f[wa>>2]=o+-1,(o|0)==1):0)kL(r);f[ea>>2]=0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[ua>>2]|0)>0){ja=f[ha>>2]|0;ha=0;do{f[ja+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[ua>>2]|0))}ua=f[ga>>2]|0;if((ua|0)!=(da|0))UC(ua);ua=f[ra>>2]|0;if(ua|0?(da=ua+12|0,ua=f[da>>2]|0,f[da>>2]=ua+-1,(ua|0)==1):0)kL(q);f[ra>>2]=0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[oa>>2]|0)>0){sa=f[D>>2]|0;D=0;do{f[sa+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[oa>>2]|0))}oa=f[ka>>2]|0;if((oa|0)!=(g|0))UC(oa);qa=na}oa=j+36|0;g=f[oa>>2]|0;if(g|0?(ka=g+12|0,g=f[ka>>2]|0,f[ka>>2]=g+-1,(g|0)==1):0)kL(j);f[oa>>2]=0;oa=j+16|0;g=j+4|0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[g>>2]|0)>0){oa=f[j+40>>2]|0;ka=0;do{f[oa+(ka<<2)>>2]=0;ka=ka+1|0}while((ka|0)<(f[g>>2]|0))}g=f[j+44>>2]|0;if((g|0)!=(j+48|0))UC(g);g=l+36|0;j=f[g>>2]|0;if(j|0?(ka=j+12|0,j=f[ka>>2]|0,f[ka>>2]=j+-1,(j|0)==1):0)kL(l);f[g>>2]=0;g=l+16|0;j=l+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[j>>2]|0)>0){g=f[ia>>2]|0;ia=0;do{f[g+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[j>>2]|0))}j=f[l+44>>2]|0;if((j|0)!=(l+48|0))UC(j);if(!(f[k+4>>2]|0)){u=i;return +qa}u=i;return +qa}function oea(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f[a>>2]=56352;h=a+4|0;f[h>>2]=1124007936;i=a+8|0;j=a+12|0;k=a+44|0;l=i;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;n=a+52|0;o=a+48|0;f[o>>2]=n;f[n>>2]=0;f[a+56>>2]=0;n=a+60|0;f[n>>2]=1124007936;q=a+64|0;r=a+68|0;s=a+100|0;l=q;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[s>>2]=r;l=a+108|0;m=a+104|0;f[m>>2]=l;f[l>>2]=0;f[a+112>>2]=0;if((h|0)!=(b|0)){l=b+36|0;t=f[l>>2]|0;if(t){u=t+12|0;f[u>>2]=(f[u>>2]|0)+1;u=a+40|0;t=f[u>>2]|0;if((t|0)!=0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0){kL(h);w=u}else w=u}else w=a+40|0;f[w>>2]=0;u=a+20|0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=0;f[u+12>>2]=0;if((f[i>>2]|0)>0){t=f[k>>2]|0;k=0;do{f[t+(k<<2)>>2]=0;k=k+1|0;x=f[i>>2]|0}while((k|0)<(x|0));f[h>>2]=f[b>>2];if((x|0)<3)y=12;else y=14}else{f[h>>2]=f[b>>2];y=12}if((y|0)==12){x=f[b+4>>2]|0;if((x|0)<3){f[i>>2]=x;f[j>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];j=f[b+44>>2]|0;x=f[o>>2]|0;f[x>>2]=f[j>>2];f[x+4>>2]=f[j+4>>2]}else y=14}if((y|0)==14)jL(h,b);f[u>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];f[w>>2]=f[l>>2]}if((n|0)==(c|0)){z=a+120|0;p[z>>3]=d;A=a+128|0;p[A>>3]=e;B=a+136|0;f[B>>2]=g;return}l=c+36|0;w=f[l>>2]|0;if(w|0){b=w+12|0;f[b>>2]=(f[b>>2]|0)+1}b=a+96|0;w=f[b>>2]|0;if(w|0?(u=w+12|0,w=f[u>>2]|0,f[u>>2]=w+-1,(w|0)==1):0)kL(n);f[b>>2]=0;w=a+76|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[q>>2]|0)>0){u=f[s>>2]|0;s=0;do{f[u+(s<<2)>>2]=0;s=s+1|0;C=f[q>>2]|0}while((s|0)<(C|0));f[n>>2]=f[c>>2];if((C|0)<3)y=27;else y=29}else{f[n>>2]=f[c>>2];y=27}if((y|0)==27){C=f[c+4>>2]|0;if((C|0)<3){f[q>>2]=C;f[r>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];r=f[c+44>>2]|0;C=f[m>>2]|0;f[C>>2]=f[r>>2];f[C+4>>2]=f[r+4>>2]}else y=29}if((y|0)==29)jL(n,c);f[w>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];f[b>>2]=f[l>>2];z=a+120|0;p[z>>3]=d;A=a+128|0;p[A>>3]=e;B=a+136|0;f[B>>2]=g;return}function pea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56352;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function qea(a){a=a|0;pea(a);O5b(a);return}function rea(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0;e=u;u=u+384|0;g=e+120|0;i=e+112|0;k=e+56|0;l=e;m=f[c>>2]|0;o=f[c+4>>2]|0;f[g>>2]=m;f[g+4>>2]=o;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;lL(k,a+4|0,g,i);f[g>>2]=m;f[g+4>>2]=o;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;lL(l,a+60|0,g,i);i=k+16|0;o=l+16|0;m=a+120|0;c=a+128|0;q=a+136|0;a=f[k>>2]|0;a:do switch(a&7){case 0:{r=~~+p[m>>3]&255;s=~~+p[c>>3]&255;t=f[q>>2]|0;v=f[k+40>>2]|0;w=f[v>>2]|0;x=Y(f[v+4>>2]|0,(a>>>3&511)+1|0)|0;v=f[k+48>>2]|0;y=f[l+48>>2]|0;if(!(a&16384)){z=v;A=y;B=x;C=w}else{D=(f[l>>2]&16384|0)!=0;E=Y(x,w)|0;z=D?E:v;A=D?E:y;B=D?E:x;C=D?1:w}if((B|0)>0){w=r&255;D=w+1|0;Nac(g|0,0,256)|0;switch(t|0){case 0:{Nac(g|0,0,D|0)|0;if(D>>>0<256)Nac(g+D|0,s|0,w^255|0)|0;break}case 1:{Nac(g|0,s|0,D|0)|0;if(D>>>0<256)Nac(g+D|0,0,w^255|0)|0;break}case 2:{s=0;do{b[g+s>>0]=s;s=s+1|0}while((s|0)!=(D|0));if(D>>>0<256)Nac(g+D|0,r|0,w^255|0)|0;break}case 3:{Nac(g|0,0,D|0)|0;if(D>>>0<256){s=D;do{b[g+s>>0]=s;s=s+1|0}while((s|0)!=256)}break}case 4:{s=0;do{b[g+s>>0]=s;s=s+1|0}while((s|0)!=(D|0));if(D>>>0<256)Nac(g+D|0,0,w^255|0)|0;break}default:{}}s=f[i>>2]|0;r=f[o>>2]|0;b:do if((C|0)>0){t=B+-4|0;if((B|0)<4){x=0;E=s;y=r;while(1){v=0;do{b[y+v>>0]=b[g+(h[E+v>>0]|0)>>0]|0;v=v+1|0}while((v|0)!=(B|0));x=x+1|0;if((x|0)==(C|0))break b;else{E=E+z|0;y=y+A|0}}}y=B&-4;if((y|0)<(B|0)){F=0;G=s;H=r}else{E=0;x=s;v=r;while(1){I=0;do{J=I|1;K=b[g+(h[x+J>>0]|0)>>0]|0;b[v+I>>0]=b[g+(h[x+I>>0]|0)>>0]|0;b[v+J>>0]=K;K=I|2;J=I|3;L=b[g+(h[x+J>>0]|0)>>0]|0;b[v+K>>0]=b[g+(h[x+K>>0]|0)>>0]|0;b[v+J>>0]=L;I=I+4|0}while((I|0)<=(t|0));E=E+1|0;if((E|0)==(C|0))break b;else{x=x+z|0;v=v+A|0}}}while(1){v=0;do{x=v|1;E=b[g+(h[G+x>>0]|0)>>0]|0;b[H+v>>0]=b[g+(h[G+v>>0]|0)>>0]|0;b[H+x>>0]=E;E=v|2;x=v|3;I=b[g+(h[G+x>>0]|0)>>0]|0;b[H+E>>0]=b[g+(h[G+E>>0]|0)>>0]|0;b[H+x>>0]=I;v=v+4|0}while((v|0)<=(t|0));M=y;do{b[H+M>>0]=b[g+(h[G+M>>0]|0)>>0]|0;M=M+1|0}while((M|0)!=(B|0));F=F+1|0;if((F|0)==(C|0))break;else{G=G+z|0;H=H+A|0}}}while(0)}break}case 3:{r=~~+p[m>>3];s=~~+p[c>>3];w=f[k+40>>2]|0;D=f[w>>2]|0;y=Y(f[w+4>>2]|0,(a>>>3&511)+1|0)|0;w=f[i>>2]|0;t=f[o>>2]|0;v=(f[k+48>>2]|0)>>>1;I=(f[l+48>>2]|0)>>>1;if(!(a&16384)){N=I;O=v;P=y;Q=D}else{x=(f[l>>2]&16384|0)!=0;E=Y(y,D)|0;N=x?E:I;O=x?E:v;P=x?E:y;Q=x?1:D}switch(f[q>>2]|0){case 0:{if((P|0)>0&(Q|0)>0){R=w;S=t;T=0}else break a;while(1){D=0;do{d[S+(D<<1)>>1]=(d[R+(D<<1)>>1]|0)>r<<16>>16?s:0;D=D+1|0}while((D|0)!=(P|0));T=T+1|0;if((T|0)==(Q|0))break;else{R=R+(O<<1)|0;S=S+(N<<1)|0}}break}case 1:{if((P|0)>0&(Q|0)>0){U=w;V=t;W=0}else break a;while(1){D=0;do{d[V+(D<<1)>>1]=(d[U+(D<<1)>>1]|0)>r<<16>>16?0:s;D=D+1|0}while((D|0)!=(P|0));W=W+1|0;if((W|0)==(Q|0))break;else{U=U+(O<<1)|0;V=V+(N<<1)|0}}break}case 2:{if((P|0)>0&(Q|0)>0){X=w;Z=t;_=0}else break a;while(1){s=0;do{D=d[X+(s<<1)>>1]|0;d[Z+(s<<1)>>1]=D<<16>>16>r<<16>>16?r:D;s=s+1|0}while((s|0)!=(P|0));_=_+1|0;if((_|0)==(Q|0))break;else{X=X+(O<<1)|0;Z=Z+(N<<1)|0}}break}case 3:{if((P|0)>0&(Q|0)>0){$=w;aa=t;ba=0}else break a;while(1){s=0;do{D=d[$+(s<<1)>>1]|0;d[aa+(s<<1)>>1]=D<<16>>16>r<<16>>16?D:0;s=s+1|0}while((s|0)!=(P|0));ba=ba+1|0;if((ba|0)==(Q|0))break;else{$=$+(O<<1)|0;aa=aa+(N<<1)|0}}break}case 4:{if((P|0)>0&(Q|0)>0){ca=w;da=t;ea=0}else break a;while(1){s=0;do{D=d[ca+(s<<1)>>1]|0;d[da+(s<<1)>>1]=D<<16>>16>r<<16>>16?0:D;s=s+1|0}while((s|0)!=(P|0));ea=ea+1|0;if((ea|0)==(Q|0))break;else{ca=ca+(O<<1)|0;da=da+(N<<1)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;bO(-5,g,253849,253778,120);bD(g);break a}}break}case 2:{r=~~+p[m>>3]&65535;t=~~+p[c>>3]&65535;w=f[k+40>>2]|0;s=f[w>>2]|0;D=Y(f[w+4>>2]|0,(a>>>3&511)+1|0)|0;w=((f[k+48>>2]|0)>>>0)/((1212424721>>>(a<<2&28)&15)>>>0)|0;x=f[l>>2]|0;y=((f[l+48>>2]|0)>>>0)/((1212424721>>>(x<<2&28)&15)>>>0)|0;E=(a&16384|0)==0;v=(x&16384|0)!=0;x=Y(D,s)|0;I=E?D:v?x:D;D=E?s:v?1:s;s=E?y:v?x:y;y=E?w:v?x:w;w=f[i>>2]|0;x=f[o>>2]|0;switch(f[q>>2]|0){case 0:{if((I|0)>0&(D|0)>0){fa=w;ga=x;ha=0}else break a;while(1){v=0;do{d[ga+(v<<1)>>1]=(j[fa+(v<<1)>>1]|0)>(r&65535)?t:0;v=v+1|0}while((v|0)!=(I|0));ha=ha+1|0;if((ha|0)==(D|0))break;else{fa=fa+(y<<1)|0;ga=ga+(s<<1)|0}}break}case 1:{if((I|0)>0&(D|0)>0){ia=w;ja=x;ka=0}else break a;while(1){v=0;do{d[ja+(v<<1)>>1]=(j[ia+(v<<1)>>1]|0)>(r&65535)?0:t;v=v+1|0}while((v|0)!=(I|0));ka=ka+1|0;if((ka|0)==(D|0))break;else{ia=ia+(y<<1)|0;ja=ja+(s<<1)|0}}break}case 2:{if((I|0)>0&(D|0)>0){la=w;ma=x;na=0}else break a;while(1){t=0;do{v=d[la+(t<<1)>>1]|0;d[ma+(t<<1)>>1]=(v&65535)>(r&65535)?r:v;t=t+1|0}while((t|0)!=(I|0));na=na+1|0;if((na|0)==(D|0))break;else{la=la+(y<<1)|0;ma=ma+(s<<1)|0}}break}case 3:{if((I|0)>0&(D|0)>0){oa=w;pa=x;qa=0}else break a;while(1){t=0;do{v=d[oa+(t<<1)>>1]|0;d[pa+(t<<1)>>1]=(v&65535)>(r&65535)?v:0;t=t+1|0}while((t|0)!=(I|0));qa=qa+1|0;if((qa|0)==(D|0))break;else{oa=oa+(y<<1)|0;pa=pa+(s<<1)|0}}break}case 4:{if((I|0)>0&(D|0)>0){ra=w;sa=x;ta=0}else break a;while(1){t=0;do{v=d[ra+(t<<1)>>1]|0;d[sa+(t<<1)>>1]=(v&65535)>(r&65535)?0:v;t=t+1|0}while((t|0)!=(I|0));ta=ta+1|0;if((ta|0)==(D|0))break;else{ra=ra+(y<<1)|0;sa=sa+(s<<1)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;bO(-5,g,253849,253778,120);bD(g);break a}}break}case 5:{ua=+p[m>>3];va=+p[c>>3];s=f[k+40>>2]|0;y=f[s>>2]|0;D=Y(f[s+4>>2]|0,(a>>>3&511)+1|0)|0;s=f[i>>2]|0;I=f[o>>2]|0;r=(f[k+48>>2]|0)>>>2;x=(f[l+48>>2]|0)>>>2;if(!(a&16384)){wa=D;xa=y}else{w=(f[l>>2]&16384|0)!=0;t=Y(w?y:1,D)|0;wa=t;xa=w?1:y}switch(f[q>>2]|0){case 0:{if((wa|0)>0&(xa|0)>0){ya=s;za=I;Aa=0}else break a;while(1){y=0;do{n[za+(y<<2)>>2]=+n[ya+(y<<2)>>2]>ua?va:0.0;y=y+1|0}while((y|0)!=(wa|0));Aa=Aa+1|0;if((Aa|0)==(xa|0))break;else{ya=ya+(r<<2)|0;za=za+(x<<2)|0}}break}case 1:{if((wa|0)>0&(xa|0)>0){Ba=s;Ca=I;Da=0}else break a;while(1){y=0;do{n[Ca+(y<<2)>>2]=!(+n[Ba+(y<<2)>>2]<=ua)?0.0:va;y=y+1|0}while((y|0)!=(wa|0));Da=Da+1|0;if((Da|0)==(xa|0))break;else{Ba=Ba+(r<<2)|0;Ca=Ca+(x<<2)|0}}break}case 2:{if((wa|0)>0&(xa|0)>0){Ea=s;Fa=I;Ga=0}else break a;while(1){y=0;do{va=+n[Ea+(y<<2)>>2];n[Fa+(y<<2)>>2]=va>ua?ua:va;y=y+1|0}while((y|0)!=(wa|0));Ga=Ga+1|0;if((Ga|0)==(xa|0))break;else{Ea=Ea+(r<<2)|0;Fa=Fa+(x<<2)|0}}break}case 3:{if((wa|0)>0&(xa|0)>0){Ha=s;Ia=I;Ja=0}else break a;while(1){y=0;do{va=+n[Ha+(y<<2)>>2];n[Ia+(y<<2)>>2]=va>ua?va:0.0;y=y+1|0}while((y|0)!=(wa|0));Ja=Ja+1|0;if((Ja|0)==(xa|0))break;else{Ha=Ha+(r<<2)|0;Ia=Ia+(x<<2)|0}}break}case 4:{if((wa|0)>0&(xa|0)>0){Ka=s;La=I;Ma=0}else break a;while(1){y=0;do{va=+n[Ka+(y<<2)>>2];n[La+(y<<2)>>2]=!(va<=ua)?0.0:va;y=y+1|0}while((y|0)!=(wa|0));Ma=Ma+1|0;if((Ma|0)==(xa|0))break;else{Ka=Ka+(r<<2)|0;La=La+(x<<2)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;bO(-5,g,253849,253778,120);bD(g);break a}}break}case 6:{ua=+p[m>>3];va=+p[c>>3];x=f[k+40>>2]|0;r=f[x>>2]|0;I=Y(f[x+4>>2]|0,(a>>>3&511)+1|0)|0;x=f[i>>2]|0;s=f[o>>2]|0;y=(f[k+48>>2]|0)>>>3;w=(f[l+48>>2]|0)>>>3;if(!(a&16384)){Na=I;Oa=r}else{t=(f[l>>2]&16384|0)!=0;D=Y(t?r:1,I)|0;Na=D;Oa=t?1:r}switch(f[q>>2]|0){case 0:{if((Na|0)>0&(Oa|0)>0){Pa=x;Qa=s;Ra=0}else break a;while(1){r=0;do{p[Qa+(r<<3)>>3]=+p[Pa+(r<<3)>>3]>ua?va:0.0;r=r+1|0}while((r|0)!=(Na|0));Ra=Ra+1|0;if((Ra|0)==(Oa|0))break;else{Pa=Pa+(y<<3)|0;Qa=Qa+(w<<3)|0}}break}case 1:{if((Na|0)>0&(Oa|0)>0){Sa=x;Ta=s;Ua=0}else break a;while(1){r=0;do{p[Ta+(r<<3)>>3]=!(+p[Sa+(r<<3)>>3]<=ua)?0.0:va;r=r+1|0}while((r|0)!=(Na|0));Ua=Ua+1|0;if((Ua|0)==(Oa|0))break;else{Sa=Sa+(y<<3)|0;Ta=Ta+(w<<3)|0}}break}case 2:{if((Na|0)>0&(Oa|0)>0){Va=x;Wa=s;Xa=0}else break a;while(1){r=0;do{va=+p[Va+(r<<3)>>3];p[Wa+(r<<3)>>3]=va>ua?ua:va;r=r+1|0}while((r|0)!=(Na|0));Xa=Xa+1|0;if((Xa|0)==(Oa|0))break;else{Va=Va+(y<<3)|0;Wa=Wa+(w<<3)|0}}break}case 3:{if((Na|0)>0&(Oa|0)>0){Ya=x;Za=s;_a=0}else break a;while(1){r=0;do{va=+p[Ya+(r<<3)>>3];p[Za+(r<<3)>>3]=va>ua?va:0.0;r=r+1|0}while((r|0)!=(Na|0));_a=_a+1|0;if((_a|0)==(Oa|0))break;else{Ya=Ya+(y<<3)|0;Za=Za+(w<<3)|0}}break}case 4:{if((Na|0)>0&(Oa|0)>0){$a=x;ab=s;bb=0}else break a;while(1){r=0;do{va=+p[$a+(r<<3)>>3];p[ab+(r<<3)>>3]=!(va<=ua)?0.0:va;r=r+1|0}while((r|0)!=(Na|0));bb=bb+1|0;if((bb|0)==(Oa|0))break;else{$a=$a+(y<<3)|0;ab=ab+(w<<3)|0}}break}default:{f[g>>2]=0;f[g+4>>2]=0;bO(-5,g,253849,253778,120);bD(g);break a}}break}default:{}}while(0);g=l+36|0;ab=f[g>>2]|0;if(ab|0?($a=ab+12|0,ab=f[$a>>2]|0,f[$a>>2]=ab+-1,(ab|0)==1):0)kL(l);f[g>>2]=0;g=l+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[g>>2]|0)>0){o=f[l+40>>2]|0;ab=0;do{f[o+(ab<<2)>>2]=0;ab=ab+1|0}while((ab|0)<(f[g>>2]|0))}g=f[l+44>>2]|0;if((g|0)!=(l+48|0))UC(g);g=k+36|0;l=f[g>>2]|0;if(l|0?(ab=l+12|0,l=f[ab>>2]|0,f[ab>>2]=l+-1,(l|0)==1):0)kL(k);f[g>>2]=0;g=k+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[g>>2]|0)>0){i=f[k+40>>2]|0;l=0;do{f[i+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[g>>2]|0))}g=f[k+44>>2]|0;if((g|0)==(k+48|0)){u=e;return}UC(g);u=e;return}function sea(a,c,d,e,g,i,j){a=a|0;c=c|0;d=+d;e=e|0;g=g|0;i=i|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;k=u;u=u+1072|0;l=k+1056|0;m=k+1e3|0;n=k+944|0;o=k+936|0;p=k;q=k+160|0;r=k+96|0;s=k+928|0;t=k+152|0;v=k+72|0;w=k+56|0;x=k+88|0;dQ(l,56364);do if((yM(a)|0)==65536){y=f[a+4>>2]|0;f[m>>2]=f[y>>2];z=m+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=m+8|0;f[B>>2]=f[y+8>>2];f[m+12>>2]=f[y+12>>2];f[m+16>>2]=f[y+16>>2];f[m+20>>2]=f[y+20>>2];f[m+24>>2]=f[y+24>>2];f[m+28>>2]=f[y+28>>2];f[m+32>>2]=f[y+32>>2];C=f[y+36>>2]|0;f[m+36>>2]=C;f[m+40>>2]=B;B=m+48|0;D=m+44|0;f[D>>2]=B;f[B>>2]=0;f[m+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];E=m;break}else{f[z>>2]=0;jL(m,y);E=m;break}}else{yL(m,a,-1);E=m}while(0);if(f[E>>2]&4095|0){f[n>>2]=0;f[n+4>>2]=0;F=aD(n,55)|0;G=271684;H=F+55|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,n,253953,253778,1524);bD(n)}if(!((i|0)>1&((i|0)%2|0|0)==1)){f[n>>2]=0;f[n+4>>2]=0;F=aD(n,35)|0;G=253971;H=F+35|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,n,253953,253778,1525);bD(n)}a=m+40|0;y=f[a>>2]|0;z=f[y+4>>2]|0;A=f[y>>2]|0;f[o>>2]=z;f[o+4>>2]=A;vM(c,o,f[E>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){o=f[c+4>>2]|0;f[n>>2]=f[o>>2];y=n+4|0;B=o+4|0;f[y>>2]=f[B>>2];D=n+8|0;f[D>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];f[n+16>>2]=f[o+16>>2];f[n+20>>2]=f[o+20>>2];f[n+24>>2]=f[o+24>>2];f[n+28>>2]=f[o+28>>2];f[n+32>>2]=f[o+32>>2];C=f[o+36>>2]|0;f[n+36>>2]=C;f[n+40>>2]=D;D=n+48|0;I=n+44|0;f[I>>2]=D;f[D>>2]=0;f[n+52>>2]=0;if(C|0){D=C+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[B>>2]|0)<3){B=f[o+44>>2]|0;D=f[I>>2]|0;f[D>>2]=f[B>>2];f[D+4>>2]=f[B+4>>2];break}else{f[y>>2]=0;jL(n,o);break}}else yL(n,c,-1);while(0);if(!(d<0.0)){c=m+16|0;o=n+16|0;f[p>>2]=1124007936;y=p+4|0;B=p+8|0;D=p+40|0;F=y;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[D>>2]=B;I=p+48|0;C=p+44|0;f[C>>2]=I;f[I>>2]=0;f[p+52>>2]=0;if((f[c>>2]|0)!=(f[o>>2]|0)){J=n+36|0;K=f[J>>2]|0;if(K){L=K+12|0;f[L>>2]=(f[L>>2]|0)+1;L=p+36|0;K=f[L>>2]|0;if((K|0)!=0?(M=K+12|0,K=f[M>>2]|0,f[M>>2]=K+-1,(K|0)==1):0){kL(p);N=L}else N=L}else N=p+36|0;f[N>>2]=0;L=p+16|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[y>>2]|0)>0){K=f[D>>2]|0;M=0;do{f[K+(M<<2)>>2]=0;M=M+1|0;O=f[y>>2]|0}while((M|0)<(O|0));f[p>>2]=f[n>>2];if((O|0)<3)P=32;else P=34}else{f[p>>2]=f[n>>2];P=32}if((P|0)==32){O=f[n+4>>2]|0;if((O|0)<3){f[y>>2]=O;f[B>>2]=f[n+8>>2];f[p+12>>2]=f[n+12>>2];B=f[n+44>>2]|0;O=f[C>>2]|0;f[O>>2]=f[B>>2];f[O+4>>2]=f[B+4>>2]}else P=34}if((P|0)==34)jL(p,n);f[L>>2]=f[o>>2];f[p+20>>2]=f[n+20>>2];f[p+24>>2]=f[n+24>>2];f[p+28>>2]=f[n+28>>2];f[p+32>>2]=f[n+32>>2];f[N>>2]=f[J>>2]}switch(e|0){case 0:{f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=m;e=r+8|0;f[e>>2]=0;f[e+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=p;e=f[E>>2]&4095;f[s>>2]=i;f[s+4>>2]=i;f[t>>2]=-1;f[t+4>>2]=-1;g7(q,r,e,s,t,1,17);break}case 1:{f[q>>2]=1124007936;t=q+4|0;s=q+8|0;e=q+40|0;F=t;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[e>>2]=s;J=q+48|0;N=q+44|0;f[N>>2]=J;f[J>>2]=0;f[q+52>>2]=0;f[r>>2]=1124007936;L=r+4|0;B=r+8|0;O=r+40|0;F=L;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[O>>2]=B;M=r+48|0;K=r+44|0;f[K>>2]=M;f[M>>2]=0;f[r+52>>2]=0;Q=v+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=q;OJ(m,v,5,1.0,0.0);Q=q+36|0;R=f[Q>>2]|0;if(R|0){S=R+12|0;f[S>>2]=(f[S>>2]|0)+1}S=r+36|0;R=f[S>>2]|0;if(R|0?(T=R+12|0,R=f[T>>2]|0,f[T>>2]=R+-1,(R|0)==1):0)kL(r);f[S>>2]=0;R=r+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[L>>2]|0)>0){T=f[O>>2]|0;U=0;do{f[T+(U<<2)>>2]=0;U=U+1|0;V=f[L>>2]|0}while((U|0)<(V|0));f[r>>2]=f[q>>2];if((V|0)<3)P=48;else P=50}else{f[r>>2]=f[q>>2];P=48}if((P|0)==48){V=f[t>>2]|0;if((V|0)<3){f[L>>2]=V;f[B>>2]=f[s>>2];f[r+12>>2]=f[q+12>>2];s=f[N>>2]|0;B=f[K>>2]|0;f[B>>2]=f[s>>2];f[B+4>>2]=f[s+4>>2]}else P=50}if((P|0)==50)jL(r,q);s=q+16|0;f[R>>2]=f[s>>2];f[r+20>>2]=f[q+20>>2];f[r+24>>2]=f[q+24>>2];f[r+28>>2]=f[q+28>>2];f[r+32>>2]=f[q+32>>2];f[S>>2]=f[Q>>2];f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=q;B=w+8|0;f[B>>2]=0;f[B+4>>2]=0;f[w>>2]=33619968;f[w+4>>2]=r;f[x>>2]=i;f[x+4>>2]=i;F7(v,w,x,0.0,0.0,17);x=v+8|0;f[x>>2]=0;f[x+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=p;OJ(r,v,f[E>>2]&4095,1.0,0.0);v=f[S>>2]|0;if(v|0?(x=v+12|0,v=f[x>>2]|0,f[x>>2]=v+-1,(v|0)==1):0)kL(r);f[S>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[L>>2]|0)>0){R=f[O>>2]|0;O=0;do{f[R+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[L>>2]|0))}L=f[K>>2]|0;if((L|0)!=(M|0))UC(L);L=f[Q>>2]|0;if(L|0?(M=L+12|0,L=f[M>>2]|0,f[M>>2]=L+-1,(L|0)==1):0)kL(q);f[Q>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[t>>2]|0)>0){s=f[e>>2]|0;e=0;do{f[s+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[t>>2]|0))}t=f[N>>2]|0;if((t|0)!=(J|0))UC(t);break}default:{f[q>>2]=0;f[q+4>>2]=0;F=aD(q,45)|0;G=254007;H=F+45|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-206,q,253953,253778,1557);bD(q)}}t=MVb(d)|0;J=(t>>>0<256?t:(t|0)>0?255:0)&255;t=~~j;d=+(t|0);do if(!g){N=0-(t+(d<j&1))|0;e=0;do{b[q+e>>0]=(e+-255|0)>(N|0)?J:0;e=e+1|0}while((e|0)!=768);W=q}else{if((g|0)!=1){f[r>>2]=0;f[r+4>>2]=0;F=aD(r,34)|0;G=254053;H=F+34|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-206,r,253953,253778,1571);bD(r);W=q;break}e=(d>j&1)-t|0;N=0;do{b[q+N>>0]=(N+-255|0)<=(e|0)?J:0;N=N+1|0}while((N|0)!=768);W=q}while(0);if((f[E>>2]&16384|0)!=0?(f[p>>2]&16384|0)!=0:0){E=(f[n>>2]&16384|0)!=0;W=Y(E?A:1,z)|0;if(E){X=W;Z=1;P=80}else{_=W;P=79}}else{_=z;P=79}if((P|0)==79?(A|0)>0:0){X=_;Z=A;P=80}if((P|0)==80?(P=m+44|0,A=p+16|0,_=n+44|0,(X|0)>0):0){z=0;do{W=(f[c>>2]|0)+(Y(f[f[P>>2]>>2]|0,z)|0)|0;E=(f[A>>2]|0)+(Y(f[f[C>>2]>>2]|0,z)|0)|0;J=(f[o>>2]|0)+(Y(f[f[_>>2]>>2]|0,z)|0)|0;t=0;do{b[J+t>>0]=b[q+((h[W+t>>0]|0)+255-(h[E+t>>0]|0))>>0]|0;t=t+1|0}while((t|0)!=(X|0));z=z+1|0}while((z|0)!=(Z|0))}Z=p+36|0;z=f[Z>>2]|0;if(z|0?(X=z+12|0,z=f[X>>2]|0,f[X>>2]=z+-1,(z|0)==1):0)kL(p);f[Z>>2]=0;Z=p+16|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[y>>2]|0)>0){Z=f[D>>2]|0;D=0;do{f[Z+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[y>>2]|0))}y=f[C>>2]|0;if((y|0)!=(I|0))UC(y)}else{f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[p+28>>2]=0;UP(n,p)|0}p=n+36|0;y=f[p>>2]|0;if(y|0?(I=y+12|0,y=f[I>>2]|0,f[I>>2]=y+-1,(y|0)==1):0)kL(n);f[p>>2]=0;p=n+16|0;y=n+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[y>>2]|0)>0){p=f[n+40>>2]|0;I=0;do{f[p+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[y>>2]|0))}y=f[n+44>>2]|0;if((y|0)!=(n+48|0))UC(y);y=m+36|0;n=f[y>>2]|0;if(n|0?(I=n+12|0,n=f[I>>2]|0,f[I>>2]=n+-1,(n|0)==1):0)kL(m);f[y>>2]=0;y=m+16|0;n=m+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[n>>2]|0)>0){y=f[a>>2]|0;a=0;do{f[y+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))UC(n);if(!(f[l+4>>2]|0)){u=k;return}u=k;return}function tea(a,c,d,e,g){a=a|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;h=u;u=u+208|0;i=h+144|0;j=h+88|0;k=h+32|0;l=h+16|0;m=h;tL(i,a,0,1,0,0);tL(j,c,0,1,0,0);f[k>>2]=f[j>>2];c=k+4|0;a=j+4|0;n=f[a>>2]|0;f[c>>2]=n;o=k+8|0;f[o>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];p=k+16|0;q=j+16|0;f[p>>2]=f[q>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];r=k+36|0;s=j+36|0;t=f[s>>2]|0;f[r>>2]=t;v=k+40|0;f[v>>2]=o;o=k+48|0;w=k+44|0;f[w>>2]=o;f[o>>2]=0;f[k+52>>2]=0;if(!t)x=n;else{n=t+12|0;f[n>>2]=(f[n>>2]|0)+1;x=f[a>>2]|0}if((x|0)<3){x=f[j+44>>2]|0;n=f[w>>2]|0;f[n>>2]=f[x>>2];f[n+4>>2]=f[x+4>>2]}else{f[c>>2]=0;jL(k,j)}x=i+40|0;n=f[x>>2]|0;t=f[n+-4>>2]|0;y=j+40|0;z=f[y>>2]|0;a:do if((t|0)==(f[z+-4>>2]|0)){if((t|0)==2){if((f[n>>2]|0)!=(f[z>>2]|0)){A=15;break}if((f[n+4>>2]|0)!=(f[z+4>>2]|0)){A=15;break}}else if((t|0)>0){B=0;do{if((f[n+(B<<2)>>2]|0)!=(f[z+(B<<2)>>2]|0)){A=15;break a}B=B+1|0}while((B|0)<(t|0))}B=f[i>>2]|0;C=f[j>>2]|0;if(!(((C^B)&4088|0)==0?(D=C&7,(B&7|0)==(D|0)|(D|0)==0):0))A=15}else A=15;while(0);if((A|0)==15){f[l>>2]=0;f[l+4>>2]=0;A=aD(l,108)|0;t=254171;z=A+108|0;do{b[A>>0]=b[t>>0]|0;A=A+1|0;t=t+1|0}while((A|0)<(z|0));bO(-215,l,254280,253778,1596);bD(l)}f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=i;t=m+8|0;f[t>>2]=0;f[t+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;E=+nea(l,m,d,e,g);if((f[p>>2]|0)!=(f[q>>2]|0)){g=l+8|0;f[g>>2]=0;f[g+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=k;OJ(j,l,f[k>>2]&7,1.0,0.0)}l=f[r>>2]|0;if(l|0?(g=l+12|0,l=f[g>>2]|0,f[g>>2]=l+-1,(l|0)==1):0)kL(k);f[r>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[c>>2]|0)>0){p=f[v>>2]|0;v=0;do{f[p+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[c>>2]|0))}c=f[w>>2]|0;if((c|0)!=(o|0))UC(c);c=f[s>>2]|0;if(c|0?(o=c+12|0,c=f[o>>2]|0,f[o>>2]=c+-1,(c|0)==1):0)kL(j);f[s>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[a>>2]|0)>0){q=f[y>>2]|0;y=0;do{f[q+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[a>>2]|0))}a=f[j+44>>2]|0;if((a|0)!=(j+48|0))UC(a);a=i+36|0;j=f[a>>2]|0;if(j|0?(y=j+12|0,j=f[y>>2]|0,f[y>>2]=j+-1,(j|0)==1):0)kL(i);f[a>>2]=0;a=i+16|0;j=i+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[j>>2]|0)>0){a=f[x>>2]|0;x=0;do{f[a+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=h;return +E}UC(j);u=h;return +E}function uea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+128|0;h=g+120|0;i=g+64|0;j=g;k=g+8|0;dQ(h,56384);do if((yM(a)|0)==65536){l=f[a+4>>2]|0;f[i>>2]=f[l>>2];m=i+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=i+8|0;f[o>>2]=f[l+8>>2];f[i+12>>2]=f[l+12>>2];f[i+16>>2]=f[l+16>>2];f[i+20>>2]=f[l+20>>2];f[i+24>>2]=f[l+24>>2];f[i+28>>2]=f[l+28>>2];f[i+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[i+36>>2]=p;q=i+40|0;f[q>>2]=o;o=i+48|0;r=i+44|0;f[r>>2]=o;f[o>>2]=0;f[i+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];s=q;break}else{f[m>>2]=0;jL(i,l);s=q;break}}else{yL(i,a,-1);s=i+40|0}while(0);a=f[s>>2]|0;q=f[a>>2]|0;f[j>>2]=f[a+4>>2];f[j+4>>2]=q;vM(b,j,5,-1,0,0);do if((yM(b)|0)==65536){j=f[b+4>>2]|0;f[k>>2]=f[j>>2];q=k+4|0;a=j+4|0;f[q>>2]=f[a>>2];l=k+8|0;f[l>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];m=f[j+36>>2]|0;f[k+36>>2]=m;f[k+40>>2]=l;l=k+48|0;n=k+44|0;f[n>>2]=l;f[l>>2]=0;f[k+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[a>>2]|0)<3){a=f[j+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[a>>2];f[l+4>>2]=f[a+4>>2];break}else{f[q>>2]=0;jL(k,j);break}}else yL(k,b,-1);while(0);vea(i,k,c,d,0,0.0,e);e=k+36|0;d=f[e>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)kL(k);f[e>>2]=0;e=k+16|0;d=k+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[d>>2]|0)>0){e=f[k+40>>2]|0;c=0;do{f[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[k+44>>2]|0;if((d|0)!=(k+48|0))UC(d);d=i+36|0;k=f[d>>2]|0;if(k|0?(c=k+12|0,k=f[c>>2]|0,f[c>>2]=k+-1,(k|0)==1):0)kL(i);f[d>>2]=0;d=i+16|0;k=i+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[s>>2]|0;s=0;do{f[d+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)!=(i+48|0))UC(k);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function vea(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0;j=u;u=u+224|0;k=j+200|0;l=j+144|0;m=j+88|0;o=j+24|0;p=j;q=j+80|0;r=j+16|0;s=f[a>>2]|0;t=(e|0)>0;v=+(d|0)*(t?+(1<<e+-1|0):4.0);w=(e|0)<0?v*2.0:v;v=1.0/((s&7|0)==0?w*255.0:w);switch(s&4095){case 5:case 0:break;default:{f[k>>2]=0;f[k+4>>2]=0;x=aD(k,114)|0;s=254292;y=x+114|0;do{b[x>>0]=b[s>>0]|0;x=x+1|0;s=s+1|0}while((x|0)<(y|0));bO(-215,k,254407,254427,269);bD(k)}}f[l>>2]=1124007936;s=l+4|0;z=l+8|0;A=l+40|0;x=s;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[A>>2]=z;z=l+48|0;B=l+44|0;f[B>>2]=z;f[z>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;C=m+4|0;D=m+8|0;E=m+40|0;x=C;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[E>>2]=D;D=m+48|0;F=m+44|0;f[F>>2]=D;f[D>>2]=0;f[m+52>>2]=0;if(t){f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;t=o+8|0;f[t>>2]=0;f[t+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;z2(k,o,5,1,0,e,v,0.0,i);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;t=o+8|0;f[t>>2]=0;f[t+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=m;z2(k,o,5,0,1,e,v,0.0,i)}else{f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;e=o+8|0;f[e>>2]=0;f[e+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;A2(k,o,5,1,0,v,0.0,i);f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=a;e=o+8|0;f[e>>2]=0;f[e+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=m;A2(k,o,5,0,1,v,0.0,i)}e=f[a+40>>2]|0;a=f[e+4>>2]|0;t=f[e>>2]|0;f[o>>2]=1124007936;e=o+4|0;G=o+8|0;H=o+40|0;x=e;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[H>>2]=G;G=o+48|0;x=o+44|0;f[x>>2]=G;f[G>>2]=0;f[o+52>>2]=0;f[k>>2]=t;f[k+4>>2]=a;hL(o,2,k,21);if((t|0)>0?(y=f[o+16>>2]|0,I=f[f[x>>2]>>2]|0,J=f[l+16>>2]|0,K=f[f[B>>2]>>2]|0,N=f[m+16>>2]|0,O=f[f[F>>2]>>2]|0,(a|0)>0):0){P=0;do{Q=y+(Y(I,P)|0)|0;R=J+(Y(K,P)|0)|0;S=N+(Y(O,P)|0)|0;T=0;do{v=+n[R+(T<<2)>>2];w=+n[S+(T<<2)>>2];U=T*3|0;n[Q+(U<<2)>>2]=v*v;n[Q+(U+1<<2)>>2]=v*w;n[Q+(U+2<<2)>>2]=w*w;T=T+1|0}while((T|0)!=(a|0));P=P+1|0}while((P|0)!=(t|0))}f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=o;t=p+8|0;f[t>>2]=0;f[t+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=o;t=f[o>>2]&7;f[q>>2]=d;f[q+4>>2]=d;f[r>>2]=-1;f[r+4>>2]=-1;g7(k,p,t,q,r,0,i);a:do switch(g|0){case 0:{i=f[c+16>>2]|0;r=f[c+44>>2]|0;q=f[H>>2]|0;t=f[q+4>>2]|0;p=f[q>>2]|0;if(f[o>>2]&16384){q=(f[c>>2]&16384|0)!=0;k=Y(q?p:1,t)|0;if(q){V=k;W=1}else{X=k;Z=14}}else{X=t;Z=14}if((Z|0)==14)if((p|0)>0){V=X;W=p}else break a;p=f[o+16>>2]|0;t=f[f[x>>2]>>2]|0;k=f[r>>2]|0;if((V|0)>0){r=0;do{q=p+(Y(r,t)|0)|0;d=i+(Y(r,k)|0)|0;P=0;do{a=P*3|0;w=+n[q+(a<<2)>>2]*.5;v=+n[q+(a+1<<2)>>2];_=+n[q+(a+2<<2)>>2]*.5;$=w-_;aa=w+_-+M(+(v*v+$*$));n[d+(P<<2)>>2]=aa;P=P+1|0}while((P|0)!=(V|0));r=r+1|0}while((r|0)!=(W|0))}break}case 1:{r=f[c+16>>2]|0;k=f[c+44>>2]|0;i=f[H>>2]|0;t=f[i+4>>2]|0;p=f[i>>2]|0;if(f[o>>2]&16384){i=(f[c>>2]&16384|0)!=0;P=Y(i?p:1,t)|0;if(i){ba=P;ca=1}else{da=P;Z=21}}else{da=t;Z=21}if((Z|0)==21)if((p|0)>0){ba=da;ca=p}else break a;p=f[o+16>>2]|0;t=f[f[x>>2]>>2]|0;P=f[k>>2]|0;if((ba|0)>0){k=0;do{i=p+(Y(k,t)|0)|0;d=r+(Y(k,P)|0)|0;q=0;do{a=q*3|0;aa=+n[i+(a<<2)>>2];$=+n[i+(a+1<<2)>>2];v=+n[i+(a+2<<2)>>2];_=aa+v;n[d+(q<<2)>>2]=aa*v-$*$-_*(_*h);q=q+1|0}while((q|0)!=(ba|0));k=k+1|0}while((k|0)!=(ca|0))}break}case 2:{k=f[c+16>>2]|0;P=f[c+44>>2]|0;r=f[H>>2]|0;t=f[r+4>>2]|0;p=f[r>>2]|0;if(f[o>>2]&16384){r=(f[c>>2]&16384|0)!=0;q=Y(r?p:1,t)|0;if(r){ea=q;fa=1}else{ga=q;Z=28}}else{ga=t;Z=28}if((Z|0)==28)if((p|0)>0){ea=ga;fa=p}else break a;p=f[o+16>>2]|0;t=f[f[x>>2]>>2]|0;q=f[P>>2]|0;P=(ea|0)>0;r=0;do{d=p+(Y(r,t)|0)|0;i=k+(Y(r,q)|0)|0;if(P){a=0;do{O=a*3|0;_=+n[d+(O<<2)>>2];$=+n[d+(O+1<<2)>>2];v=$;aa=+n[d+(O+2<<2)>>2];w=(_+aa)*.5;ha=_-aa;ia=+M(+(v*v+ha*ha*.25));ha=ia+w;ja=w-ia;ia=ha-_;w=+L(+$);if(w+ +L(+ia)<.0001){$=ha-aa;ka=w+ +L(+$);la=1.0/(ka+1.1920928955078125e-07);if(ka<.0001){ma=v*la;na=$*la}else{ma=v;na=$}}else{ma=ia;na=v}ia=1.0/+M(+(na*na+ma*ma+2.220446049250313e-16));O=a*6|0;n[i+(O<<2)>>2]=ha;n[i+(O+2<<2)>>2]=na*ia;n[i+(O+3<<2)>>2]=ma*ia;ia=ja-_;if(w+ +L(+ia)<.0001){_=ja-aa;aa=w+ +L(+_);w=1.0/(aa+1.1920928955078125e-07);if(aa<.0001){oa=v*w;pa=_*w}else{oa=v;pa=_}}else{oa=ia;pa=v}v=1.0/+M(+(pa*pa+oa*oa+2.220446049250313e-16));n[i+((O|1)<<2)>>2]=ja;n[i+(O+4<<2)>>2]=pa*v;n[i+(O+5<<2)>>2]=oa*v;a=a+1|0}while((a|0)!=(ea|0))}r=r+1|0}while((r|0)!=(fa|0));break}default:{}}while(0);fa=o+36|0;ea=f[fa>>2]|0;if(ea|0?(ga=ea+12|0,ea=f[ga>>2]|0,f[ga>>2]=ea+-1,(ea|0)==1):0)kL(o);f[fa>>2]=0;fa=o+16|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[e>>2]|0)>0){fa=f[H>>2]|0;H=0;do{f[fa+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[e>>2]|0))}e=f[x>>2]|0;if((e|0)!=(G|0))UC(e);e=m+36|0;G=f[e>>2]|0;if(G|0?(x=G+12|0,G=f[x>>2]|0,f[x>>2]=G+-1,(G|0)==1):0)kL(m);f[e>>2]=0;e=m+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[C>>2]|0)>0){e=f[E>>2]|0;E=0;do{f[e+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[C>>2]|0))}C=f[F>>2]|0;if((C|0)!=(D|0))UC(C);C=l+36|0;D=f[C>>2]|0;if(D|0?(F=D+12|0,D=f[F>>2]|0,f[F>>2]=D+-1,(D|0)==1):0)kL(l);f[C>>2]=0;C=l+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[s>>2]|0)>0){C=f[A>>2]|0;A=0;do{f[C+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[s>>2]|0))}s=f[B>>2]|0;if((s|0)==(z|0)){u=j;return}UC(s);u=j;return}function wea(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=u;u=u+128|0;i=h+120|0;j=h+64|0;k=h;l=h+8|0;dQ(i,56404);do if((yM(a)|0)==65536){m=f[a+4>>2]|0;f[j>>2]=f[m>>2];n=j+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=j+8|0;f[p>>2]=f[m+8>>2];f[j+12>>2]=f[m+12>>2];f[j+16>>2]=f[m+16>>2];f[j+20>>2]=f[m+20>>2];f[j+24>>2]=f[m+24>>2];f[j+28>>2]=f[m+28>>2];f[j+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[j+36>>2]=q;r=j+40|0;f[r>>2]=p;p=j+48|0;s=j+44|0;f[s>>2]=p;f[p>>2]=0;f[j+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[s>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];t=r;break}else{f[n>>2]=0;jL(j,m);t=r;break}}else{yL(j,a,-1);t=j+40|0}while(0);a=f[t>>2]|0;r=f[a>>2]|0;f[k>>2]=f[a+4>>2];f[k+4>>2]=r;vM(b,k,5,-1,0,0);do if((yM(b)|0)==65536){k=f[b+4>>2]|0;f[l>>2]=f[k>>2];r=l+4|0;a=k+4|0;f[r>>2]=f[a>>2];m=l+8|0;f[m>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[l+16>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];n=f[k+36>>2]|0;f[l+36>>2]=n;f[l+40>>2]=m;m=l+48|0;o=l+44|0;f[o>>2]=m;f[m>>2]=0;f[l+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[a>>2]|0)<3){a=f[k+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[a>>2];f[m+4>>2]=f[a+4>>2];break}else{f[r>>2]=0;jL(l,k);break}}else yL(l,b,-1);while(0);vea(j,l,c,d,1,e,g);g=l+36|0;d=f[g>>2]|0;if(d|0?(c=d+12|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)kL(l);f[g>>2]=0;g=l+16|0;d=l+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[d>>2]|0)>0){g=f[l+40>>2]|0;c=0;do{f[g+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[l+44>>2]|0;if((d|0)!=(l+48|0))UC(d);d=j+36|0;l=f[d>>2]|0;if(l|0?(c=l+12|0,l=f[c>>2]|0,f[c>>2]=l+-1,(l|0)==1):0)kL(j);f[d>>2]=0;d=j+16|0;l=j+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[l>>2]|0)>0){d=f[t>>2]|0;t=0;do{f[d+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))UC(l);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function xea(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;if(!((a|0)!=0&(c|0)!=0)){f[e>>2]=0;f[e+4>>2]=0;bO(-27,e,254635,254658,60);bD(e)}if(!((f[a+28>>2]|0)==1?(f[a+4>>2]|0)>=64:0)){f[e>>2]=0;f[e+4>>2]=0;bO(-201,e,254635,254658,63);bD(e)}MW(a,c,0);e=a+56|0;a=f[e+4>>2]|0;g=c+36|0;f[g>>2]=f[e>>2];f[g+4>>2]=a;b[c+44>>0]=1;b[c+45>>0]=0;b[c+46>>0]=1;b[c+47>>0]=-1;b[c+48>>0]=0;a=c+49|0;b[a>>0]=-1;b[a+1>>0]=-1>>8;b[a+2>>0]=-1>>16;b[a+3>>0]=-1>>24;b[c+53>>0]=0;b[c+54>>0]=-1;b[c+55>>0]=1;b[c+56>>0]=0;b[c+57>>0]=1;b[c+58>>0]=1;b[c+59>>0]=1;u=d;return}function yea(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=u;u=u+48|0;l=k+8|0;m=k;if(!c){f[l>>2]=0;f[l+4>>2]=0;bO(-27,l,254731,254658,188);bD(l)}n=sQ(a,l,0,0)|0;l=f[n>>2]|0;a=(l&4095|0)==4;o=(e|0)==2&a?4:e;if(!((l&4094|0)==0&(o|0)<4|a&(o|0)==4)){f[m>>2]=0;f[m+4>>2]=0;p=aD(m,119)|0;q=254756;r=p+119|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-210,m,254731,254658,199);bD(m)}a=f[n+24>>2]|0;l=f[n+20>>2]|0;e=f[n+4>>2]|0;s=f[n+16>>2]|0;if(g>>>0>4){f[m>>2]=0;f[m+4>>2]=0;bO(-211,m,254731,254658,206);bD(m)}t=(g|0)==0;if(((t?64:88)|0)>(d|0)){f[m>>2]=0;f[m+4>>2]=0;bO(-201,m,254731,254658,209);bD(m)}v=VC(788)|0;Nac(v+8|0,0,780)|0;w=v+4|0;f[w>>2]=c;f[v>>2]=c;f[v+40>>2]=s;x=s+e|0;f[v+44>>2]=x;f[v+48>>2]=e;y=a+-1|0;f[v+52>>2]=y;z=l+-1|0;f[v+56>>2]=z;f[v+244>>2]=o;A=v+60|0;f[A>>2]=h;f[A+4>>2]=i;f[v+72>>2]=1;f[v+68>>2]=1;f[v+76>>2]=0;f[v+80>>2]=1;f[v+84>>2]=2;i=v+180|0;f[v+148>>2]=i;f[v+176>>2]=1;f[v+140>>2]=0;f[v+144>>2]=0;A=v+152|0;f[A>>2]=0;f[A+4>>2]=0;f[v+160>>2]=a;f[v+164>>2]=l;f[v+88>>2]=0;f[v+248>>2]=0;f[i>>2]=32768;i=v+236|0;f[i>>2]=g;f[v+240>>2]=g;do if((g+-3|0)>>>0>=2){A=v+252|0;if(t){f[A>>2]=20480;B=d;C=1;D=0;E=20480;F=A;break}else{f[A>>2]=20492;B=d;C=8;D=g;E=20492;F=A;break}}else{f[i>>2]=0;A=v+252|0;f[A>>2]=20480;B=64;C=1;D=g;E=20480;F=A}while(0);f[v+256>>2]=B;f[v+260>>2]=C;f[v+268>>2]=d;d=(D|0)==0;D=v+264|0;f[D>>2]=d?E:20492;f[v+272>>2]=d?C:8;f[F>>2]=E;f[D>>2]=t?20480:20492;DW(c,v+16|0);if((g|0)>2){g=AW(f[w>>2]|0)|0;f[v>>2]=g}if((o|0)>1){o=AW(f[w>>2]|0)|0;f[v+8>>2]=o;w=bX(0,64,44,o)|0;f[v+12>>2]=w}if((e|0)<=-1){f[m>>2]=0;f[m+4>>2]=0;p=aD(m,9)|0;q=254876;r=p+9|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,m,254731,254658,289);bD(m)}if((l|0)<=0){f[m>>2]=0;f[m+4>>2]=0;p=aD(m,16)|0;q=254886;r=p+16|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,m,254731,254658,290);bD(m)}if((j|0?(j=f[n>>2]|0,m=(j>>>3&511)+1<<(47696>>>(j<<1&14)&3),j=Y(m,a)|0,Nac(s|0,0,j|0)|0,Nac(s+(Y(e,z)|0)|0,0,j|0)|0,(z|0)>1):0)?(j=Y(m,y)|0,(m|0)>0):0){y=1;s=x;while(1){x=0;do{b[s+(x+j)>>0]=0;b[s+x>>0]=0;x=x+1|0}while((x|0)!=(m|0));y=y+1|0;if((y|0)==(z|0))break;else s=s+e|0}}if((f[n>>2]&4095|0)==4){u=k;return v|0}+tea(n,n,0.0,1.0,0);u=k;return v|0}function zea(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0;c=u;u=u+128|0;d=c+104|0;e=c+88|0;g=c+80|0;h=c+72|0;i=c+8|0;j=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;bO(-27,d,254903,254658,1012);bD(d)}k=a+48|0;if((f[k>>2]|0)<=-1){f[d>>2]=0;f[d+4>>2]=0;l=aD(d,22)|0;m=254921;n=l+22|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,254903,254658,1018);bD(d)}o=a+88|0;p=f[o>>2]|0;if(p|0){q=a+248|0;if(f[q>>2]|0){r=a+4|0;DW(f[r>>2]|0,d);if((f[d>>2]|0)==(f[a+32>>2]|0)?(f[d+4>>2]|0)==(f[a+36>>2]|0):0)EW(f[r>>2]|0,a+24|0);f[q>>2]=0}q=f[p+12>>2]|0;if(q|0)mX(q,f[(f[p+8>>2]|0)+12>>2]|0,a+180|0);f[o>>2]=0}p=f[a+40>>2]|0;q=a+44|0;r=f[q>>2]|0;s=f[k>>2]|0;k=s>>>2;t=a+68|0;v=f[t>>2]|0;w=a+72|0;x=f[w>>2]|0;y=f[a+52>>2]|0;z=f[a+56>>2]|0;A=f[a+244>>2]|0;B=a+76|0;C=a+80|0;D=a+84|0;E=v+-1|0;F=(A|0)==4;if(F){G=-1073741824;H=f[r+(E<<2)>>2]|0}else{G=-2;H=b[r+E>>0]|0}if((x|0)>=(z|0)){I=0;u=c;return I|0}E=~G;J=(A|0)==0;K=a+136|0;L=a+4|0;M=a+24|0;N=a+252|0;O=a+256|0;P=a+260|0;Q=a+92|0;R=a+60|0;S=a+64|0;T=a+236|0;U=0-s|0;V=1-s|0;W=i+4|0;X=i+8|0;Z=~s;_=i+12|0;$=i+16|0;aa=s+-1|0;ba=i+20|0;ca=i+24|0;da=s+1|0;ea=i+28|0;fa=i+32|0;ga=d+12|0;ha=d+20|0;ia=e+4|0;ja=a+240|0;ka=a+268|0;la=a+12|0;ma=d+4|0;na=0-k|0;oa=1-k|0;pa=~k;qa=k+-1|0;ra=k+1|0;sa=d+12|0;ta=d+20|0;ua=h+4|0;va=d+12|0;wa=d+20|0;xa=h+4|0;ya=(A|0)<2;za=d+4|0;Aa=d+4|0;Ba=d+4|0;Ca=d+4|0;Da=F?p:0;Ea=(Da|0)!=0;Fa=H;H=f[D>>2]|0;Ga=r;r=x;x=v;v=f[B>>2]|0;Ha=f[C>>2]|0;a:while(1){Ia=F?Ga:0;b:do if((x|0)<(y|0)){Ja=(Ia|0)!=0;Ka=Y(Ha,s)|0;La=Y(Ha,k)|0;Ma=0;Na=Fa;Oa=H;Pa=x;Qa=v;while(1){Ra=(Pa|0)<(y|0);c:do if(Ja)if(Ra){Sa=Na;Ta=Pa;while(1){Ua=f[Ia+(Ta<<2)>>2]|0;if((Ua|0)!=(Sa|0)?(Ua^Sa)&E|0:0){Va=Ua;Wa=Sa;Xa=Ta;break c}Ya=Ta+1|0;if((Ya|0)<(y|0)){Sa=Ua;Ta=Ya}else{Va=Ua;Wa=Ua;Xa=Ya;break}}}else{Va=Ma;Wa=Na;Xa=Pa}else if(Ra){Ta=Pa;while(1){Sa=b[Ga+Ta>>0]|0;if((Sa|0)!=(Na|0)){Va=Sa;Wa=Na;Xa=Ta;break c}Sa=Ta+1|0;if((Sa|0)<(y|0))Ta=Sa;else{Va=Na;Wa=Na;Xa=Sa;break}}}else{Va=Ma;Wa=Na;Xa=Pa}while(0);if((Xa|0)>=(y|0)){Za=Oa;break b}if(Ja){Ra=(Wa&G|0)!=0;Ta=(Va&G|0)==0;if(!(((Wa|0)==0|Ra)&Ta))if(Ta&(Ra^1)){_a=Ra;$a=35}else{ab=Va;bb=Oa;cb=Qa}else{db=0;eb=Qa;$a=36}}else if(!((Wa|0)==0&(Va|0)==1))if((Wa|0)<1|(Va|0)!=0){ab=Va;bb=Oa;cb=Qa}else{_a=(Wa&G|0)!=0;$a=35}else{db=0;eb=Qa;$a=36}if(($a|0)==35){$a=0;db=1;eb=_a?Xa+-1|0:Qa;$a=36}d:do if(($a|0)==36){$a=0;e:do if(J){if(db|0){ab=Va;bb=Oa;cb=eb;break d}if((b[p+(eb+Ka)>>0]|0)>0){ab=Va;bb=Oa;cb=eb;break d}else{fb=K;gb=Xa;hb=1}}else{Ra=Xa-db|0;if(!ya){if(!db)switch(A|0){case 2:case 4:{fb=K;gb=Ra;hb=0;break e;break}default:{}}if((eb|0)>=1){if(Ea)ib=f[Da+(eb+La<<2)>>2]|0;else ib=b[p+(eb+Ka)>>0]|0;Ta=f[a+276+((ib&127)<<2)>>2]|0;if(!Ta){$a=80;break a}Sa=Ia+(eb<<2)|0;Ya=Ga+eb|0;Ua=Ta;Ta=0;f:while(1){do if((eb-(f[Ua+16>>2]|0)|0)>>>0<(f[Ua+24>>2]|0)>>>0){if((Ha-(f[Ua+20>>2]|0)|0)>>>0>=(f[Ua+28>>2]|0)>>>0){jb=Ta;break}if(!Ta){jb=Ua;break}kb=f[Ta+36>>2]|0;if(!Ea){lb=p+(Y(kb,s)|0)|0;mb=lb+(f[Ta+32>>2]|0)|0;lb=f[Ta+40>>2]|0;f[i>>2]=1;f[W>>2]=V;f[X>>2]=U;f[_>>2]=Z;f[$>>2]=-1;f[ba>>2]=aa;f[ca>>2]=s;f[ea>>2]=da;f[fa>>2]=f[i>>2];f[fa+4>>2]=f[i+4>>2];f[fa+8>>2]=f[i+8>>2];f[fa+12>>2]=f[i+12>>2];f[fa+16>>2]=f[i+16>>2];f[fa+20>>2]=f[i+20>>2];f[fa+24>>2]=f[i+24>>2];f[fa+28>>2]=f[i+28>>2];nb=lb|0?0:4;lb=nb;do{lb=lb+7&7;ob=mb+(f[i+(lb<<2)>>2]|0)|0;pb=(lb|0)==(nb|0)}while(!((b[ob>>0]|0)!=0|pb));g:do if(pb)qb=mb;else{nb=mb;rb=lb;while(1){sb=rb;while(1){tb=sb+1|0;ub=nb+(f[i+(tb<<2)>>2]|0)|0;if(!ub){f[d>>2]=0;f[Ca>>2]=0;vb=aD(d,8)|0;wb=vb;b[wb>>0]=105;b[wb+1>>0]=52;b[wb+2>>0]=32;b[wb+3>>0]=33;wb=vb+4|0;b[wb>>0]=61;b[wb+1>>0]=32;b[wb+2>>0]=48;b[wb+3>>0]=76;bO(-215,d,254974,254658,668);bD(d)}if((tb|0)<15&(b[ub>>0]|0)==0)sb=tb;else break}if((nb|0)==(Ya|0)){$a=74;break f}if((nb|0)==(ob|0)&(ub|0)==(mb|0)){qb=ob;break g}nb=ub;rb=sb+5&7}}while(0);if((qb|0)==(Ya|0)){xb=Ta;break f}else{jb=Ua;break}}mb=Da+((Y(kb,k)|0)<<2)|0;lb=mb+(f[Ta+32>>2]<<2)|0;mb=f[Ta+40>>2]|0;if(!lb){f[d>>2]=0;f[Aa>>2]=0;l=aD(d,9)|0;m=254944;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,254954,254658,820);bD(d)}kb=f[lb>>2]&1073741823;f[i>>2]=1;f[W>>2]=oa;f[X>>2]=na;f[_>>2]=pa;f[$>>2]=-1;f[ba>>2]=qa;f[ca>>2]=k;f[ea>>2]=ra;f[fa>>2]=f[i>>2];f[fa+4>>2]=f[i+4>>2];f[fa+8>>2]=f[i+8>>2];f[fa+12>>2]=f[i+12>>2];f[fa+16>>2]=f[i+16>>2];f[fa+20>>2]=f[i+20>>2];f[fa+24>>2]=f[i+24>>2];f[fa+28>>2]=f[i+28>>2];rb=mb|0?0:4;nb=rb;do{nb=nb+7&7;yb=lb+(f[i+(nb<<2)>>2]<<2)|0;zb=(nb|0)==(rb|0)}while(!(zb|(f[yb>>2]&1073741823|0)==(kb|0)));h:do if(zb)Ab=lb;else{rb=lb;mb=nb;while(1){tb=mb;while(1){wb=tb+1|0;Bb=rb+(f[i+(wb<<2)>>2]<<2)|0;if(!Bb){f[d>>2]=0;f[Ba>>2]=0;vb=aD(d,8)|0;Cb=vb;b[Cb>>0]=105;b[Cb+1>>0]=52;b[Cb+2>>0]=32;b[Cb+3>>0]=33;Cb=vb+4|0;b[Cb>>0]=61;b[Cb+1>>0]=32;b[Cb+2>>0]=48;b[Cb+3>>0]=76;bO(-215,d,254954,254658,857);bD(d)}if((wb|0)<15?(f[Bb>>2]&1073741823|0)!=(kb|0):0)tb=wb;else break}if((rb|0)==(Sa|0)){$a=62;break f}if((rb|0)==(yb|0)&(Bb|0)==(lb|0)){Ab=yb;break h}rb=Bb;mb=tb+5&7}}while(0);if((Ab|0)==(Sa|0)){xb=Ta;break f}else jb=Ua}else jb=Ta;while(0);Ua=f[Ua+4>>2]|0;if(!Ua){xb=jb;break}else Ta=jb}if(($a|0)==62){$a=0;xb=Ta}else if(($a|0)==74){$a=0;xb=Ta}if(!xb){$a=80;break a}if((f[xb+40>>2]|0)==(db|0)){Ua=f[xb+8>>2]|0;Db=(Ua|0)==0?K:Ua}else Db=xb;if(!(f[Db+12>>2]|0)){ab=Va;bb=Oa;cb=eb;break d}else{fb=Db;gb=Ra;hb=0}}else{fb=K;gb=Ra;hb=0}}else{fb=K;gb=Ra;hb=1}}while(0);DW(f[L>>2]|0,M);Ua=IW(f[N>>2]|0,f[O>>2]|0,f[P>>2]|0,f[a>>2]|0)|0;f[Ua>>2]=f[Ua>>2]|(db|0?32768:0);if(hb){Sa=Ga+Xa+(0-db)|0;Ya=(f[R>>2]|0)+gb|0;lb=(f[S>>2]|0)+r|0;kb=f[T>>2]|0;f[i>>2]=1;f[W>>2]=V;f[X>>2]=U;f[_>>2]=Z;f[$>>2]=-1;f[ba>>2]=aa;f[ca>>2]=s;f[ea>>2]=da;f[fa>>2]=f[i>>2];f[fa+4>>2]=f[i+4>>2];f[fa+8>>2]=f[i+8>>2];f[fa+12>>2]=f[i+12>>2];f[fa+16>>2]=f[i+16>>2];f[fa+20>>2]=f[i+20>>2];f[fa+24>>2]=f[i+24>>2];f[fa+28>>2]=f[i+28>>2];PW(Ua,d);nb=(kb|0)<1;if(nb){mb=Ua+56|0;f[mb>>2]=Ya;f[mb+4>>2]=lb}mb=(f[Ua>>2]|0)>>>13&4^4;rb=mb;do{rb=rb+7&7;Eb=Sa+(f[i+(rb<<2)>>2]|0)|0;Fb=(rb|0)==(mb|0)}while(!((b[Eb>>0]|0)!=0|Fb));i:do if(Fb){b[Sa>>0]=-126;if((kb|0)>0){mb=f[ga>>2]|0;if(mb>>>0<(f[ha>>2]|0)>>>0)Gb=mb;else{TW(d);Gb=f[ga>>2]|0}mb=Gb;sb=mb;b[sb>>0]=Ya;b[sb+1>>0]=Ya>>8;b[sb+2>>0]=Ya>>16;b[sb+3>>0]=Ya>>24;sb=mb+4|0;b[sb>>0]=lb;b[sb+1>>0]=lb>>8;b[sb+2>>0]=lb>>16;b[sb+3>>0]=lb>>24;f[ga>>2]=(f[ga>>2]|0)+8;SW(d)|0;$a=134}else $a=133}else{if(nb){sb=Sa;mb=rb;while(1){wb=mb;while(1){Hb=wb+1|0;Ib=sb+(f[i+(Hb<<2)>>2]|0)|0;if(!Ib){f[e>>2]=0;f[ia>>2]=0;Cb=aD(e,8)|0;vb=Cb;b[vb>>0]=105;b[vb+1>>0]=52;b[vb+2>>0]=32;b[vb+3>>0]=33;vb=Cb+4|0;b[vb>>0]=61;b[vb+1>>0]=32;b[vb+2>>0]=48;b[vb+3>>0]=76;bO(-215,e,255004,254658,572);bD(e)}if((Hb|0)<15&(b[Ib>>0]|0)==0)wb=Hb;else break}vb=Hb&7;if((vb+-1|0)>>>0>=mb>>>0){if((b[sb>>0]|0)==1){Jb=2;$a=115}}else{Jb=-126;$a=115}if(($a|0)==115){$a=0;b[sb>>0]=Jb}Cb=f[ga>>2]|0;if(Cb>>>0<(f[ha>>2]|0)>>>0)Kb=Cb;else{TW(d);Kb=f[ga>>2]|0}b[Kb>>0]=vb;f[ga>>2]=(f[ga>>2]|0)+1;if((sb|0)==(Eb|0)&(Ib|0)==(Sa|0)){$a=133;break i}sb=Ib;mb=wb+5&7}}if((kb|0)==1){mb=Sa;sb=rb;Ra=Ya;Ta=lb;while(1){vb=sb;while(1){Lb=vb+1|0;Mb=mb+(f[i+(Lb<<2)>>2]|0)|0;if(!Mb){f[e>>2]=0;f[ia>>2]=0;Cb=aD(e,8)|0;Nb=Cb;b[Nb>>0]=105;b[Nb+1>>0]=52;b[Nb+2>>0]=32;b[Nb+3>>0]=33;Nb=Cb+4|0;b[Nb>>0]=61;b[Nb+1>>0]=32;b[Nb+2>>0]=48;b[Nb+3>>0]=76;bO(-215,e,255004,254658,572);bD(e)}if((Lb|0)<15&(b[Mb>>0]|0)==0)vb=Lb;else break}wb=Lb&7;if((wb+-1|0)>>>0>=sb>>>0){if((b[mb>>0]|0)==1){Ob=2;$a=104}}else{Ob=-126;$a=104}if(($a|0)==104){$a=0;b[mb>>0]=Ob}Nb=f[ga>>2]|0;if(Nb>>>0<(f[ha>>2]|0)>>>0)Pb=Nb;else{TW(d);Pb=f[ga>>2]|0}Nb=Pb;Cb=Nb;b[Cb>>0]=Ra;b[Cb+1>>0]=Ra>>8;b[Cb+2>>0]=Ra>>16;b[Cb+3>>0]=Ra>>24;Cb=Nb+4|0;b[Cb>>0]=Ta;b[Cb+1>>0]=Ta>>8;b[Cb+2>>0]=Ta>>16;b[Cb+3>>0]=Ta>>24;f[ga>>2]=(f[ga>>2]|0)+8;if((mb|0)==(Eb|0)&(Mb|0)==(Sa|0)){$a=133;break i}mb=Mb;sb=vb+5&7;Ra=(f[56424+(wb<<3)>>2]|0)+Ra|0;Ta=(f[56424+(wb<<3)+4>>2]|0)+Ta|0}}Ta=Sa;Ra=rb^4;sb=rb;mb=Ya;wb=lb;while(1){Cb=sb;while(1){Qb=Cb+1|0;Rb=Ta+(f[i+(Qb<<2)>>2]|0)|0;if(!Rb){f[e>>2]=0;f[ia>>2]=0;Nb=aD(e,8)|0;Sb=Nb;b[Sb>>0]=105;b[Sb+1>>0]=52;b[Sb+2>>0]=32;b[Sb+3>>0]=33;Sb=Nb+4|0;b[Sb>>0]=61;b[Sb+1>>0]=32;b[Sb+2>>0]=48;b[Sb+3>>0]=76;bO(-215,e,255004,254658,572);bD(e)}if((Qb|0)<15&(b[Rb>>0]|0)==0)Cb=Qb;else break}vb=Qb&7;if((vb+-1|0)>>>0>=sb>>>0){if((b[Ta>>0]|0)==1){Tb=2;$a=126}}else{Tb=-126;$a=126}if(($a|0)==126){$a=0;b[Ta>>0]=Tb}if((vb|0)==(Ra|0))Ub=Ra;else{Sb=f[ga>>2]|0;if(Sb>>>0<(f[ha>>2]|0)>>>0)Vb=Sb;else{TW(d);Vb=f[ga>>2]|0}Sb=Vb;Nb=Sb;b[Nb>>0]=mb;b[Nb+1>>0]=mb>>8;b[Nb+2>>0]=mb>>16;b[Nb+3>>0]=mb>>24;Nb=Sb+4|0;b[Nb>>0]=wb;b[Nb+1>>0]=wb>>8;b[Nb+2>>0]=wb>>16;b[Nb+3>>0]=wb>>24;f[ga>>2]=(f[ga>>2]|0)+8;Ub=vb}if((Ta|0)==(Eb|0)&(Rb|0)==(Sa|0)){$a=133;break i}Ta=Rb;Ra=Ub;sb=Cb+5&7;mb=(f[56424+(vb<<3)>>2]|0)+mb|0;wb=(f[56424+(vb<<3)+4>>2]|0)+wb|0}}while(0);if(($a|0)==133?($a=0,SW(d)|0,kb|0):0)$a=134;if(($a|0)==134){$a=0;mea(e,Ua,1)}Wb=Q;Xb=Oa}else{f[j>>2]=0;cX(f[la>>2]|0,0,j)|0;Sa=f[j>>2]|0;lb=0-db|0;if(Ja){Ya=f[Ia+(gb<<2)>>2]&127;rb=Ia+(Xa<<2)+(lb<<2)|0;nb=(f[R>>2]|0)+gb|0;wb=(f[S>>2]|0)+r|0;mb=f[T>>2]|0;if(!rb){f[d>>2]=0;f[ma>>2]=0;l=aD(d,9)|0;m=254944;n=l+9|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,255020,254658,881);bD(d)}f[e>>2]=0;f[g>>2]=0;kb=f[rb>>2]|0;sb=kb&1073741823;Ra=sb|1073741824;Ta=kb|-1073741824;f[i>>2]=1;f[W>>2]=oa;f[X>>2]=na;f[_>>2]=pa;f[$>>2]=-1;f[ba>>2]=qa;f[ca>>2]=k;f[ea>>2]=ra;f[fa>>2]=f[i>>2];f[fa+4>>2]=f[i+4>>2];f[fa+8>>2]=f[i+8>>2];f[fa+12>>2]=f[i+12>>2];f[fa+16>>2]=f[i+16>>2];f[fa+20>>2]=f[i+20>>2];f[fa+24>>2]=f[i+24>>2];f[fa+28>>2]=f[i+28>>2];PW(Ua,d);kb=(mb|0)<1;if(kb){vb=Ua+56|0;f[vb>>2]=nb;f[vb+4>>2]=wb}f[g>>2]=nb;f[e>>2]=nb;vb=(f[Ua>>2]|0)>>>13&4^4;Nb=vb;do{Nb=Nb+7&7;Yb=rb+(f[i+(Nb<<2)>>2]<<2)|0;Zb=(Nb|0)==(vb|0)}while(!(Zb|(f[Yb>>2]&1073741823|0)==(sb|0)));do if(Zb){f[rb>>2]=Ta;if((mb|0)<=0){_b=nb;$b=wb;ac=nb;bc=wb;break}vb=f[sa>>2]|0;if(vb>>>0<(f[ta>>2]|0)>>>0)cc=vb;else{TW(d);cc=f[sa>>2]|0}vb=cc;Sb=vb;b[Sb>>0]=nb;b[Sb+1>>0]=nb>>8;b[Sb+2>>0]=nb>>16;b[Sb+3>>0]=nb>>24;Sb=vb+4|0;b[Sb>>0]=wb;b[Sb+1>>0]=wb>>8;b[Sb+2>>0]=wb>>16;b[Sb+3>>0]=wb>>24;f[sa>>2]=(f[sa>>2]|0)+8;_b=nb;$b=wb;ac=nb;bc=wb}else{Sb=Nb^4;vb=(mb|0)==1;j:do if(kb){dc=rb;ec=Sb;fc=Nb;gc=nb;hc=wb;ic=wb;jc=wb;while(1){kc=fc;while(1){lc=kc+1|0;mc=dc+(f[i+(lc<<2)>>2]<<2)|0;if(!mc){f[h>>2]=0;f[ua>>2]=0;nc=aD(h,8)|0;oc=nc;b[oc>>0]=105;b[oc+1>>0]=52;b[oc+2>>0]=32;b[oc+3>>0]=33;oc=nc+4|0;b[oc>>0]=61;b[oc+1>>0]=32;b[oc+2>>0]=48;b[oc+3>>0]=76;bO(-215,h,255020,254658,941);bD(h)}if((lc|0)<15?(f[mc>>2]&1073741823|0)!=(sb|0):0)kc=lc;else break}oc=lc&7;if((oc+-1|0)>>>0>=fc>>>0){if((f[dc>>2]|0)==(sb|0)){pc=Ra;$a=156}}else{pc=Ta;$a=156}if(($a|0)==156){$a=0;f[dc>>2]=pc}nc=f[sa>>2]|0;if(nc>>>0<(f[ta>>2]|0)>>>0)qc=nc;else{TW(d);qc=f[sa>>2]|0}b[qc>>0]=oc;f[sa>>2]=(f[sa>>2]|0)+1;if((oc|0)==(ec|0)){rc=hc;sc=ic}else{if((gc|0)>=(f[e>>2]|0)){if((gc|0)>(f[g>>2]|0)){tc=g;$a=162}}else{tc=e;$a=162}if(($a|0)==162){$a=0;f[tc>>2]=gc}nc=(jc|0)<(hc|0);rc=nc?jc:hc;sc=nc?ic:(jc|0)>(ic|0)?jc:ic}if((dc|0)==(Yb|0)&(mc|0)==(rb|0)){uc=rc;vc=sc;break j}dc=mc;ec=oc;fc=kc+5&7;gc=(f[56424+(oc<<3)>>2]|0)+gc|0;hc=rc;ic=sc;jc=(f[56424+(oc<<3)+4>>2]|0)+jc|0}}else{jc=rb;ic=Sb;hc=Nb;gc=nb;fc=wb;ec=wb;dc=wb;while(1){Cb=hc;while(1){wc=Cb+1|0;xc=jc+(f[i+(wc<<2)>>2]<<2)|0;if(!xc){f[h>>2]=0;f[ua>>2]=0;oc=aD(h,8)|0;nc=oc;b[nc>>0]=105;b[nc+1>>0]=52;b[nc+2>>0]=32;b[nc+3>>0]=33;nc=oc+4|0;b[nc>>0]=61;b[nc+1>>0]=32;b[nc+2>>0]=48;b[nc+3>>0]=76;bO(-215,h,255020,254658,941);bD(h)}if((wc|0)<15?(f[xc>>2]&1073741823|0)!=(sb|0):0)Cb=wc;else break}kc=wc&7;if((kc+-1|0)>>>0>=hc>>>0){if((f[jc>>2]|0)==(sb|0)){yc=Ra;$a=172}}else{yc=Ta;$a=172}if(($a|0)==172){$a=0;f[jc>>2]=yc}if(vb|(kc|0)!=(ic|0)){nc=f[sa>>2]|0;if(nc>>>0<(f[ta>>2]|0)>>>0)zc=nc;else{TW(d);zc=f[sa>>2]|0}nc=zc;oc=nc;b[oc>>0]=gc;b[oc+1>>0]=gc>>8;b[oc+2>>0]=gc>>16;b[oc+3>>0]=gc>>24;oc=nc+4|0;b[oc>>0]=dc;b[oc+1>>0]=dc>>8;b[oc+2>>0]=dc>>16;b[oc+3>>0]=dc>>24;f[sa>>2]=(f[sa>>2]|0)+8}if((kc|0)==(ic|0)){Ac=fc;Bc=ec}else{if((gc|0)>=(f[e>>2]|0)){if((gc|0)>(f[g>>2]|0)){Cc=g;$a=180}}else{Cc=e;$a=180}if(($a|0)==180){$a=0;f[Cc>>2]=gc}oc=(dc|0)<(fc|0);Ac=oc?dc:fc;Bc=oc?ec:(dc|0)>(ec|0)?dc:ec}if((jc|0)==(Yb|0)&(xc|0)==(rb|0)){uc=Ac;vc=Bc;break j}jc=xc;ic=kc;hc=Cb+5&7;gc=(f[56424+(kc<<3)>>2]|0)+gc|0;fc=Ac;ec=Bc;dc=(f[56424+(kc<<3)+4>>2]|0)+dc|0}}while(0);_b=f[e>>2]|0;$b=uc;ac=f[g>>2]|0;bc=vc}while(0);rb=1-_b+ac|0;f[g>>2]=rb;Ta=bc+1-$b|0;SW(d)|0;if(mb|0){f[Ua+56>>2]=_b;f[Ua+60>>2]=$b;f[Ua+64>>2]=rb;f[Ua+68>>2]=Ta}Ra=Sa+16|0;f[Ra>>2]=_b;sb=Sa+20|0;f[sb>>2]=$b;f[Sa+24>>2]=rb;f[Sa+28>>2]=Ta;Dc=Ya;Ec=Oa;Fc=sb;Gc=Ra}else{Ra=Oa+1&127;sb=((Ra|0)==0?3:0)+Ra|0;Ra=Ga+Xa+lb|0;Ta=(f[R>>2]|0)+gb|0;rb=(f[S>>2]|0)+r|0;wb=f[T>>2]|0;f[e>>2]=0;f[g>>2]=0;f[i>>2]=1;f[W>>2]=V;f[X>>2]=U;f[_>>2]=Z;f[$>>2]=-1;f[ba>>2]=aa;f[ca>>2]=s;f[ea>>2]=da;f[fa>>2]=f[i>>2];f[fa+4>>2]=f[i+4>>2];f[fa+8>>2]=f[i+8>>2];f[fa+12>>2]=f[i+12>>2];f[fa+16>>2]=f[i+16>>2];f[fa+20>>2]=f[i+20>>2];f[fa+24>>2]=f[i+24>>2];f[fa+28>>2]=f[i+28>>2];PW(Ua,d);nb=(wb|0)<1;if(nb){Nb=Ua+56|0;f[Nb>>2]=Ta;f[Nb+4>>2]=rb}f[g>>2]=Ta;f[e>>2]=Ta;Nb=(f[Ua>>2]|0)>>>13&4^4;kb=Nb;do{kb=kb+7&7;Hc=Ra+(f[i+(kb<<2)>>2]|0)|0;Ic=(kb|0)==(Nb|0)}while(!((b[Hc>>0]|0)!=0|Ic));do if(Ic){b[Ra>>0]=Oa|128;if((wb|0)<=0){Jc=Ta;Kc=rb;Lc=Ta;Mc=rb;break}Nb=f[va>>2]|0;if(Nb>>>0<(f[wa>>2]|0)>>>0)Nc=Nb;else{TW(d);Nc=f[va>>2]|0}Nb=Nc;lb=Nb;b[lb>>0]=Ta;b[lb+1>>0]=Ta>>8;b[lb+2>>0]=Ta>>16;b[lb+3>>0]=Ta>>24;lb=Nb+4|0;b[lb>>0]=rb;b[lb+1>>0]=rb>>8;b[lb+2>>0]=rb>>16;b[lb+3>>0]=rb>>24;f[va>>2]=(f[va>>2]|0)+8;Jc=Ta;Kc=rb;Lc=Ta;Mc=rb}else{lb=kb^4;Nb=Oa|128;Ya=(wb|0)==1;k:do if(nb){mb=Ra;vb=lb;Sb=kb;dc=Ta;ec=rb;fc=rb;gc=rb;while(1){hc=Sb;while(1){Oc=hc+1|0;Pc=mb+(f[i+(Oc<<2)>>2]|0)|0;if(!Pc){f[h>>2]=0;f[xa>>2]=0;ic=aD(h,8)|0;jc=ic;b[jc>>0]=105;b[jc+1>>0]=52;b[jc+2>>0]=32;b[jc+3>>0]=33;jc=ic+4|0;b[jc>>0]=61;b[jc+1>>0]=32;b[jc+2>>0]=48;b[jc+3>>0]=76;bO(-215,h,255042,254658,749);bD(h)}if((Oc|0)<15&(b[Pc>>0]|0)==0)hc=Oc;else break}Cb=Oc&7;if((Cb+-1|0)>>>0>=Sb>>>0){if((b[mb>>0]|0)==1){Qc=Oa;$a=205}}else{Qc=Nb;$a=205}if(($a|0)==205){$a=0;b[mb>>0]=Qc}jc=f[va>>2]|0;if(jc>>>0<(f[wa>>2]|0)>>>0)Rc=jc;else{TW(d);Rc=f[va>>2]|0}b[Rc>>0]=Cb;f[va>>2]=(f[va>>2]|0)+1;if((Cb|0)==(vb|0)){Sc=ec;Tc=fc}else{if((dc|0)>=(f[e>>2]|0)){if((dc|0)>(f[g>>2]|0)){Uc=g;$a=211}}else{Uc=e;$a=211}if(($a|0)==211){$a=0;f[Uc>>2]=dc}jc=(gc|0)<(ec|0);Sc=jc?gc:ec;Tc=jc?fc:(gc|0)>(fc|0)?gc:fc}if((mb|0)==(Hc|0)&(Pc|0)==(Ra|0)){Vc=Sc;Wc=Tc;break k}mb=Pc;vb=Cb;Sb=hc+5&7;dc=(f[56424+(Cb<<3)>>2]|0)+dc|0;ec=Sc;fc=Tc;gc=(f[56424+(Cb<<3)+4>>2]|0)+gc|0}}else{gc=Ra;fc=lb;ec=kb;dc=Ta;Sb=rb;vb=rb;mb=rb;while(1){Cb=ec;while(1){Xc=Cb+1|0;Yc=gc+(f[i+(Xc<<2)>>2]|0)|0;if(!Yc){f[h>>2]=0;f[xa>>2]=0;jc=aD(h,8)|0;ic=jc;b[ic>>0]=105;b[ic+1>>0]=52;b[ic+2>>0]=32;b[ic+3>>0]=33;ic=jc+4|0;b[ic>>0]=61;b[ic+1>>0]=32;b[ic+2>>0]=48;b[ic+3>>0]=76;bO(-215,h,255042,254658,749);bD(h)}if((Xc|0)<15&(b[Yc>>0]|0)==0)Cb=Xc;else break}hc=Xc&7;if((hc+-1|0)>>>0>=ec>>>0){if((b[gc>>0]|0)==1){Zc=Oa;$a=221}}else{Zc=Nb;$a=221}if(($a|0)==221){$a=0;b[gc>>0]=Zc}if(Ya|(hc|0)!=(fc|0)){ic=f[va>>2]|0;if(ic>>>0<(f[wa>>2]|0)>>>0)_c=ic;else{TW(d);_c=f[va>>2]|0}ic=_c;jc=ic;b[jc>>0]=dc;b[jc+1>>0]=dc>>8;b[jc+2>>0]=dc>>16;b[jc+3>>0]=dc>>24;jc=ic+4|0;b[jc>>0]=mb;b[jc+1>>0]=mb>>8;b[jc+2>>0]=mb>>16;b[jc+3>>0]=mb>>24;f[va>>2]=(f[va>>2]|0)+8}if((hc|0)==(fc|0)){$c=Sb;ad=vb}else{if((dc|0)>=(f[e>>2]|0)){if((dc|0)>(f[g>>2]|0)){bd=g;$a=229}}else{bd=e;$a=229}if(($a|0)==229){$a=0;f[bd>>2]=dc}jc=(mb|0)<(Sb|0);$c=jc?mb:Sb;ad=jc?vb:(mb|0)>(vb|0)?mb:vb}if((gc|0)==(Hc|0)&(Yc|0)==(Ra|0)){Vc=$c;Wc=ad;break k}gc=Yc;fc=hc;ec=Cb+5&7;dc=(f[56424+(hc<<3)>>2]|0)+dc|0;Sb=$c;vb=ad;mb=(f[56424+(hc<<3)+4>>2]|0)+mb|0}}while(0);Jc=f[e>>2]|0;Kc=Vc;Lc=f[g>>2]|0;Mc=Wc}while(0);Ra=1-Jc+Lc|0;f[g>>2]=Ra;rb=Mc+1-Kc|0;SW(d)|0;if(wb|0){f[Ua+56>>2]=Jc;f[Ua+60>>2]=Kc;f[Ua+64>>2]=Ra;f[Ua+68>>2]=rb}Ta=Sa+16|0;f[Ta>>2]=Jc;kb=Sa+20|0;f[kb>>2]=Kc;f[Sa+24>>2]=Ra;f[Sa+28>>2]=rb;Dc=Oa;Ec=sb;Fc=kb;Gc=Ta}f[Gc>>2]=(f[Gc>>2]|0)-(f[R>>2]|0);f[Fc>>2]=(f[Fc>>2]|0)-(f[S>>2]|0);Ta=a+276+(Dc<<2)|0;f[Sa+4>>2]=f[Ta>>2];f[Ta>>2]=Sa;Wb=Sa;Xb=Ec}f[Wb+40>>2]=db;cd=Wb+12|0;f[cd>>2]=Ua;Ta=Wb+32|0;f[Ta>>2]=gb;f[Ta+4>>2]=r;Ta=Wb+8|0;f[Ta>>2]=fb;kb=f[ja>>2]|0;if((f[T>>2]|0)==(kb|0)){dd=fb;ed=Ua}else{rb=z4(Ua,f[ka>>2]|0,f[L>>2]|0,kb)|0;f[cd>>2]=rb;CW(f[a>>2]|0);dd=f[Ta>>2]|0;ed=f[cd>>2]|0}f[ed+16>>2]=f[dd+12>>2];fd=f[L>>2]|0;if(f[fb+12>>2]|0){$a=245;break a}f[cd>>2]=0;Ta=f[a>>2]|0;if((Ta|0)==(fd|0))EW(fd,M);else CW(Ta);ab=b[Ga+Xa>>0]|0;bb=Xb;cb=gb}while(0);Pa=Xa+1|0;if((Pa|0)>=(y|0)){Za=bb;break}else{Ma=ab;Na=ab;Oa=bb;Qa=ab>>>0>1?Xa:cb}}}else Za=H;while(0);Ia=r+1|0;if((Ia|0)<(z|0)){Fa=0;H=Za;Ga=Ga+s|0;r=Ia;x=1;v=0;Ha=Ia}else{I=0;$a=248;break}}if(($a|0)==80){f[d>>2]=0;f[za>>2]=0;l=aD(d,13)|0;m=254990;n=l+13|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,d,254903,254658,1182);bD(d)}else if(($a|0)==245){DW(fd,a+32|0);f[o>>2]=Wb;f[t>>2]=Xa+1+(Ja?0-db|0:0);f[w>>2]=r;f[B>>2]=gb;f[C>>2]=Ha;f[q>>2]=Ga;f[D>>2]=Xb;I=f[cd>>2]|0;u=c;return I|0}else if(($a|0)==248){u=c;return I|0}return 0}function Aea(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=u;u=u+16|0;c=b;if(!a){f[c>>2]=0;f[c+4>>2]=0;bO(-27,c,255060,254658,1328);bD(c)}d=f[a>>2]|0;if(!d){e=0;u=b;return e|0}g=d+88|0;h=f[g>>2]|0;if(h|0){i=d+248|0;if(f[i>>2]|0){j=d+4|0;DW(f[j>>2]|0,c);if((f[c>>2]|0)==(f[d+32>>2]|0)?(f[c+4>>2]|0)==(f[d+36>>2]|0):0)EW(f[j>>2]|0,d+24|0);f[i>>2]=0}i=f[h+12>>2]|0;if(i|0)mX(i,f[(f[h+8>>2]|0)+12>>2]|0,d+180|0);f[g>>2]=0}if((f[d>>2]|0)!=(f[d+4>>2]|0))BW(d);g=d+8|0;if(f[g>>2]|0)BW(g);g=f[d+200>>2]|0;WC(f[a>>2]|0);f[a>>2]=0;e=g;u=b;return e|0}function Bea(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;m=u;u=u+160|0;n=m+136|0;o=m+112|0;p=m+88|0;q=m+56|0;r=m+24|0;s=m+8|0;t=m;f[t>>2]=0;if(!d){f[n>>2]=0;f[n+4>>2]=0;v=aD(n,25)|0;w=255078;x=v+25|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-27,n,255104,254658,1817);bD(n)}f[d>>2]=0;if((i|0)!=5){y=yea(a,c,e,g,i,j,k,l)|0;f[t>>2]=y;l=-1;i=y;while(1){z=l+1|0;if(!(zea(i)|0))break;l=z;i=f[t>>2]|0}i=Aea(t)|0;f[d>>2]=i;A=z;u=m;return A|0}if(k|j|0){f[n>>2]=0;f[n+4>>2]=0;v=aD(n,51)|0;w=255124;x=v+51|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-211,n,255104,254658,1825);bD(n)}if(!c){f[r>>2]=0;f[r+4>>2]=0;v=aD(r,20)|0;w=255176;x=v+20|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-27,r,255197,254658,1508);bD(r)}j=(d|0)!=0;if(!j){f[r>>2]=0;f[r+4>>2]=0;v=aD(r,25)|0;w=255078;x=v+25|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-27,r,255197,254658,1511);bD(r)}if((e|0)<88){f[r>>2]=0;f[r+4>>2]=0;v=aD(r,48)|0;w=255223;x=v+48|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-201,r,255197,254658,1514);bD(r)}k=AW(c)|0;if(!k)B=0;else{z=L5b(16)|0;f[z+4>>2]=1;f[z>>2]=56496;f[z+8>>2]=k;B=z}z=AW(c)|0;if(!z)C=0;else{i=L5b(16)|0;f[i+4>>2]=1;f[i>>2]=56496;f[i+8>>2]=z;C=i}i=sQ(a,r,0,0)|0;if(f[i>>2]&4094|0){f[s>>2]=0;f[s+4>>2]=0;v=aD(s,32)|0;w=255272;x=v+32|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-5,s,255197,254658,1525);bD(s)}w=f[i+16>>2]|0;r=f[i+4>>2]|0;a=f[i+20>>2]|0;t=f[i+24>>2]|0;i=IW(0,56,16,k)|0;PW(i,p);QW(0,56,4,z,n);QW(0,56,4,z,o);z=p+12|0;k=f[z>>2]|0;l=p+20|0;if(k>>>0<(f[l>>2]|0)>>>0)D=k;else{TW(p);D=f[z>>2]|0}v=D;x=v+16|0;do{b[v>>0]=0;v=v+1|0}while((v|0)<(x|0));v=(f[z>>2]|0)+16|0;f[z>>2]=v;x=p+4|0;D=v+(0-(f[(f[x>>2]|0)+28>>2]|0))|0;v=(t|0)>0;a:do if(v){k=n+12|0;y=n+20|0;g=0;E=D;while(1){F=g;while(1){if(b[w+F>>0]|0){G=F;break}H=F+1|0;if((H|0)<(t|0))F=H;else{G=H;break}}if((G|0)==(t|0)){I=E;break a}F=f[z>>2]|0;if(F>>>0<(f[l>>2]|0)>>>0)J=F;else{TW(p);J=f[z>>2]|0}b[J>>0]=0;b[J+1>>0]=0;b[J+2>>0]=0;b[J+3>>0]=0;F=J+4|0;b[F>>0]=0;b[F+1>>0]=0;b[F+2>>0]=0;b[F+3>>0]=0;F=J+8|0;b[F>>0]=G;b[F+1>>0]=G>>8;b[F+2>>0]=G>>16;b[F+3>>0]=G>>24;F=J+12|0;b[F>>0]=0;b[F+1>>0]=0;b[F+2>>0]=0;b[F+3>>0]=0;F=(f[z>>2]|0)+16|0;f[z>>2]=F;H=F+(0-(f[(f[x>>2]|0)+28>>2]|0))|0;f[E+4>>2]=H;K=G+1|0;b:do if((t|0)>(K|0)){L=K;while(1){if(!(b[w+L>>0]|0)){M=L;break b}N=L+1|0;if((N|0)<(t|0))L=N;else{M=N;break}}}else M=K;while(0);K=M+-1|0;if(F>>>0<(f[l>>2]|0)>>>0)O=F;else{TW(p);O=f[z>>2]|0}b[O>>0]=0;b[O+1>>0]=0;b[O+2>>0]=0;b[O+3>>0]=0;L=O+4|0;b[L>>0]=0;b[L+1>>0]=0;b[L+2>>0]=0;b[L+3>>0]=0;L=O+8|0;b[L>>0]=K;b[L+1>>0]=K>>8;b[L+2>>0]=K>>16;b[L+3>>0]=K>>24;K=O+12|0;b[K>>0]=0;b[K+1>>0]=0;b[K+2>>0]=0;b[K+3>>0]=0;K=(f[z>>2]|0)+16|0;f[z>>2]=K;L=K+(0-(f[(f[x>>2]|0)+28>>2]|0))|0;K=H+4|0;f[K>>2]=L;f[H>>2]=L;L=f[k>>2]|0;if(L>>>0<(f[y>>2]|0)>>>0)P=L;else{TW(n);P=f[k>>2]|0}b[P>>0]=H;b[P+1>>0]=H>>8;b[P+2>>0]=H>>16;b[P+3>>0]=H>>24;f[k>>2]=(f[k>>2]|0)+4;L=f[K>>2]|0;if((M|0)<(t|0)){g=M;E=L}else{I=L;break}}}else I=D;while(0);RW(p);M=f[D+4>>2]|0;D=i+24|0;i=f[D>>2]|0;P=i+-1|0;f[I+4>>2]=0;c:do if((a|0)>1){O=n+12|0;G=n+20|0;J=o+12|0;E=o+20|0;g=1;k=0;y=M;L=w;K=P;N=I;Q=i;while(1){R=L+r|0;d:do if(v){S=0;T=N;while(1){U=S;while(1){if(b[R+U>>0]|0){V=U;break}W=U+1|0;if((W|0)<(t|0))U=W;else{V=W;break}}if((V|0)==(t|0)){X=T;break d}U=f[z>>2]|0;if(U>>>0<(f[l>>2]|0)>>>0)Y=U;else{TW(p);Y=f[z>>2]|0}b[Y>>0]=0;b[Y+1>>0]=0;b[Y+2>>0]=0;b[Y+3>>0]=0;U=Y+4|0;b[U>>0]=0;b[U+1>>0]=0;b[U+2>>0]=0;b[U+3>>0]=0;U=Y+8|0;b[U>>0]=V;b[U+1>>0]=V>>8;b[U+2>>0]=V>>16;b[U+3>>0]=V>>24;U=Y+12|0;b[U>>0]=g;b[U+1>>0]=g>>8;b[U+2>>0]=g>>16;b[U+3>>0]=g>>24;U=(f[z>>2]|0)+16|0;f[z>>2]=U;W=U+(0-(f[(f[x>>2]|0)+28>>2]|0))|0;f[T+4>>2]=W;Z=V+1|0;e:do if((t|0)>(Z|0)){_=Z;while(1){if(!(b[R+_>>0]|0)){$=_;break e}aa=_+1|0;if((aa|0)<(t|0))_=aa;else{$=aa;break}}}else $=Z;while(0);Z=$+-1|0;if(U>>>0<(f[l>>2]|0)>>>0)ba=U;else{TW(p);ba=f[z>>2]|0}b[ba>>0]=0;b[ba+1>>0]=0;b[ba+2>>0]=0;b[ba+3>>0]=0;_=ba+4|0;b[_>>0]=0;b[_+1>>0]=0;b[_+2>>0]=0;b[_+3>>0]=0;_=ba+8|0;b[_>>0]=Z;b[_+1>>0]=Z>>8;b[_+2>>0]=Z>>16;b[_+3>>0]=Z>>24;Z=ba+12|0;b[Z>>0]=g;b[Z+1>>0]=g>>8;b[Z+2>>0]=g>>16;b[Z+3>>0]=g>>24;Z=(f[z>>2]|0)+16|0;f[z>>2]=Z;_=Z+(0-(f[(f[x>>2]|0)+28>>2]|0))|0;f[W+4>>2]=_;if(($|0)<(t|0)){S=$;T=_}else{X=_;break}}}else X=N;while(0);RW(p);H=f[N+4>>2]|0;F=(f[D>>2]|0)-Q|0;f[X+4>>2]=0;T=(K|0)/2|0;S=(F|0)/2|0;f:do if((K|0)>1&(F|0)>1){_=0;Z=H;aa=y;ca=0;da=0;ea=k;while(1){g:do switch(da|0){case 0:{fa=f[aa+4>>2]|0;ga=f[fa+8>>2]|0;ha=Z+4|0;ia=f[ha>>2]|0;ja=f[ia+8>>2]|0;if((ga|0)<(ja|0)){ka=(ga|0)<((f[Z+8>>2]|0)+-1|0);f[(ka?fa:Z)>>2]=aa;la=_+1|0;ma=Z;na=f[fa+4>>2]|0;oa=ca;pa=(ka^1)&1;qa=ka?ea:fa;break g}if((f[aa+8>>2]|0)>(ja+1|0)){f[Z>>2]=ia;ja=f[O>>2]|0;if(ja>>>0<(f[G>>2]|0)>>>0)ra=ja;else{TW(n);ra=f[O>>2]|0}b[ra>>0]=Z;b[ra+1>>0]=Z>>8;b[ra+2>>0]=Z>>16;b[ra+3>>0]=Z>>24;f[O>>2]=(f[O>>2]|0)+4;sa=0;ta=ea;ua=f[ha>>2]|0}else{f[Z>>2]=aa;sa=-1;ta=ia;ua=ia}la=_;ma=f[ua+4>>2]|0;na=aa;oa=ca+1|0;pa=sa;qa=ta;break}case 1:{ia=f[Z+4>>2]|0;ha=f[ia+8>>2]|0;if((f[aa+8>>2]|0)>(ha+1|0)){f[ea>>2]=ia;la=_;ma=f[ia+4>>2]|0;na=aa;oa=ca+1|0;pa=0;qa=ea;break g}f[ea>>2]=aa;ja=f[aa+4>>2]|0;if((f[ja+8>>2]|0)<(ha|0)){la=_+1|0;ma=Z;na=f[ja+4>>2]|0;oa=ca;pa=1;qa=ja;break g}else{la=_;ma=f[ia+4>>2]|0;na=aa;oa=ca+1|0;pa=-1;qa=ia;break g}break}case -1:{ia=aa+4|0;ja=f[ia>>2]|0;if((f[Z+8>>2]|0)>((f[ja+8>>2]|0)+1|0)){f[ja>>2]=ea;la=_+1|0;ma=Z;na=f[ja+4>>2]|0;oa=ca;pa=0;qa=ea;break g}ja=f[J>>2]|0;if(ja>>>0<(f[E>>2]|0)>>>0)va=ja;else{TW(o);va=f[J>>2]|0}b[va>>0]=Z;b[va+1>>0]=Z>>8;b[va+2>>0]=Z>>16;b[va+3>>0]=Z>>24;f[J>>2]=(f[J>>2]|0)+4;f[Z>>2]=ea;ja=f[Z+4>>2]|0;ha=f[ia>>2]|0;if((f[ja+8>>2]|0)<(f[ha+8>>2]|0)){la=_;ma=f[ja+4>>2]|0;na=aa;oa=ca+1|0;pa=-1;qa=ja;break g}else{la=_+1|0;ma=Z;na=f[ha+4>>2]|0;oa=ca;pa=1;qa=ha;break g}break}default:{la=_;ma=Z;na=aa;oa=ca;pa=da;qa=ea}}while(0);if((oa|0)<(S|0)&(la|0)<(T|0)){_=la;Z=ma;aa=na;ca=oa;da=pa;ea=qa}else{wa=la;xa=ma;ya=na;za=oa;Aa=pa;Ba=qa;break f}}}else{wa=0;xa=H;ya=y;za=0;Aa=0;Ba=k}while(0);if((za|0)<(S|0)){ea=xa;da=za;ca=Aa;while(1){aa=ea+4|0;Z=f[aa>>2]|0;if(!ca){f[ea>>2]=Z;_=f[O>>2]|0;if(_>>>0<(f[G>>2]|0)>>>0)Ca=_;else{TW(n);Ca=f[O>>2]|0}b[Ca>>0]=ea;b[Ca+1>>0]=ea>>8;b[Ca+2>>0]=ea>>16;b[Ca+3>>0]=ea>>24;f[O>>2]=(f[O>>2]|0)+4;Da=f[aa>>2]|0}else{f[Ba>>2]=Z;Da=Z}da=da+1|0;if((da|0)>=(S|0)){Ea=0;break}else{ea=f[Da+4>>2]|0;ca=0}}}else Ea=Aa;if((wa|0)<(T|0)){ca=wa;ea=ya;S=Ea;while(1){da=f[ea+4>>2]|0;Z=ea;ea=f[da+4>>2]|0;f[da>>2]=(S|0)==0?Z:Ba;ca=ca+1|0;if((ca|0)==(T|0))break;else S=0}}S=g+1|0;if((S|0)>=(a|0)){Fa=H;Ga=F;break c}g=S;k=Ba;y=H;L=R;K=F;N=X;Q=f[D>>2]|0}}else{Fa=M;Ga=P}while(0);P=(Ga|0)/2|0;if((Ga|0)>1){Ga=0;M=Fa;while(1){Fa=f[M+4>>2]|0;f[Fa>>2]=M;Ga=Ga+1|0;if((Ga|0)>=(P|0))break;else M=f[Fa+4>>2]|0}}M=SW(n)|0;n=SW(o)|0;o=q+12|0;P=q+20|0;Ga=0;Fa=0;D=0;X=0;while(1){Ba=(X|0)==0;a=Ba?M:n;MW(a,q,0);Ea=a+24|0;if((f[Ea>>2]|0)>0)if(Ba){Ba=Fa;a=D;ya=Ga;wa=0;while(1){Aa=f[o>>2]|0;Da=h[Aa>>0]|h[Aa+1>>0]<<8|h[Aa+2>>0]<<16|h[Aa+3>>0]<<24;Ca=Aa+4|0;f[o>>2]=Ca;if(Ca>>>0>=(f[P>>2]|0)>>>0)VW(q,1);do if(!(f[Da>>2]|0)){Ha=Ba;Ia=a}else{QW(20492,e,8,c,p);Ca=Da;Aa=f[z>>2]|0;do{if(Aa>>>0<(f[l>>2]|0)>>>0)Ja=Aa;else{TW(p);Ja=f[z>>2]|0}za=Ca+8|0;xa=za;qa=h[xa>>0]|h[xa+1>>0]<<8|h[xa+2>>0]<<16|h[xa+3>>0]<<24;xa=za+4|0;za=h[xa>>0]|h[xa+1>>0]<<8|h[xa+2>>0]<<16|h[xa+3>>0]<<24;xa=Ja;pa=xa;b[pa>>0]=qa;b[pa+1>>0]=qa>>8;b[pa+2>>0]=qa>>16;b[pa+3>>0]=qa>>24;qa=xa+4|0;b[qa>>0]=za;b[qa+1>>0]=za>>8;b[qa+2>>0]=za>>16;b[qa+3>>0]=za>>24;Aa=(f[z>>2]|0)+8|0;f[z>>2]=Aa;za=Ca;Ca=f[Ca>>2]|0;f[za>>2]=0}while((Ca|0)!=(Da|0));Ca=SW(p)|0;mea(s,Ca,1);if(!Ba){Ha=Ca;Ia=Ca;break}f[Ca+8>>2]=a;f[a+12>>2]=Ca;Ha=Ba;Ia=Ca}while(0);wa=wa+1|0;Da=ya+1|0;if((wa|0)>=(f[Ea>>2]|0)){Ka=Da;La=Ha;Ma=Ia;break}else{Ba=Ha;a=Ia;ya=Da}}}else{ya=Fa;a=D;Ba=Ga;wa=0;while(1){Da=f[o>>2]|0;F=h[Da>>0]|h[Da+1>>0]<<8|h[Da+2>>0]<<16|h[Da+3>>0]<<24;R=Da+4|0;f[o>>2]=R;if(R>>>0>=(f[P>>2]|0)>>>0)VW(q,1);do if(!(f[F>>2]|0)){Na=ya;Oa=a}else{QW(20492,e,8,c,p);R=F;Da=f[z>>2]|0;do{if(Da>>>0<(f[l>>2]|0)>>>0)Pa=Da;else{TW(p);Pa=f[z>>2]|0}H=R+8|0;Ca=H;Aa=h[Ca>>0]|h[Ca+1>>0]<<8|h[Ca+2>>0]<<16|h[Ca+3>>0]<<24;Ca=H+4|0;H=h[Ca>>0]|h[Ca+1>>0]<<8|h[Ca+2>>0]<<16|h[Ca+3>>0]<<24;Ca=Pa;za=Ca;b[za>>0]=Aa;b[za+1>>0]=Aa>>8;b[za+2>>0]=Aa>>16;b[za+3>>0]=Aa>>24;Aa=Ca+4|0;b[Aa>>0]=H;b[Aa+1>>0]=H>>8;b[Aa+2>>0]=H>>16;b[Aa+3>>0]=H>>24;Da=(f[z>>2]|0)+8|0;f[z>>2]=Da;H=R;R=f[R>>2]|0;f[H>>2]=0}while((R|0)!=(F|0));R=SW(p)|0;mea(s,R,1);f[R>>2]=f[R>>2]|32768;if(!ya){Na=R;Oa=R;break}f[R+8>>2]=a;f[a+12>>2]=R;Na=ya;Oa=R}while(0);wa=wa+1|0;F=Ba+1|0;if((wa|0)>=(f[Ea>>2]|0)){Ka=F;La=Na;Ma=Oa;break}else{ya=Na;a=Oa;Ba=F}}}else{Ka=Ga;La=Fa;Ma=D}X=X+1|0;if((X|0)>=2)break;else{Ga=Ka;Fa=La;D=Ma}}Ma=(La|0)==0?-1:Ka;if(j)f[d>>2]=La;La=C;if(C|0?(d=La+4|0,j=f[d>>2]|0,f[d>>2]=j+-1,(j|0)==1):0)bi[f[(f[C>>2]|0)+8>>2]&2047](La);La=B;if(!B){A=Ma;u=m;return A|0}C=La+4|0;j=f[C>>2]|0;f[C>>2]=j+-1;if((j|0)!=1){A=Ma;u=m;return A|0}bi[f[(f[B>>2]|0)+8>>2]&2047](La);A=Ma;u=m;return A|0}function Cea(a){a=a|0;O5b(a);return}function Dea(a){a=a|0;OQ(a+12|0,f[a+8>>2]|0);if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Eea(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;i=u;u=u+304|0;j=i+256|0;k=i+248|0;l=i+192|0;m=i;n=i+132|0;o=i+96|0;p=i+40|0;q=i+32|0;r=i+136|0;dQ(k,56508);if(((yM(c)|0)!=262144?(yM(c)|0)!=327680:0)?(yM(c)|0)!=720896:0){f[j>>2]=0;f[j+4>>2]=0;Vac(aD(j,155)|0,255373,155)|0;bO(-215,j,255529,254658,1892);bD(j)}do if(!(HM(c)|0)){if((GM(c,-1)|0)==2?(FM(c,-1)|0)==4:0)break;f[j>>2]=0;f[j+4>>2]=0;s=aD(j,74)|0;t=255542;v=s+74|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,j,255529,254658,1894);bD(j)}while(0);f[l>>2]=1124007936;w=l+4|0;x=l+8|0;y=l+40|0;s=w;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[y>>2]=x;z=l+48|0;A=l+44|0;f[A>>2]=z;f[z>>2]=0;f[l+52>>2]=0;B=j+8|0;f[B>>2]=0;f[B+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=l;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;_P(a,j,1,1,1,1,16,m);a=zW(0)|0;if(!a)C=0;else{B=L5b(16)|0;f[B+4>>2]=1;f[B>>2]=56496;f[B+8>>2]=a;C=B}B=f[x>>2]|0;x=(f[w>>2]|0)==1?1:f[l+12>>2]|0;D=f[l>>2]|0;E=D&4095;F=l+16|0;G=f[F>>2]|0;H=Y((D>>>3&511)+1<<(47696>>>(E<<1&14)&3),x)|0;f[m>>2]=E|1111638016;E=m+4|0;f[E>>2]=H;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=G;f[m+20>>2]=B;f[m+24>>2]=x;f[E>>2]=f[f[A>>2]>>2];f[m>>2]=D&20479|1111621632;f[n>>2]=0;if(PM(d)|0)OM(d);Bea(m,a,n,88,e,g,(f[h>>2]|0)+-1|0,(f[h+4>>2]|0)+-1|0,0)|0;h=f[n>>2]|0;if(h){n=jX(h,56,a)|0;if(!n)I=0;else{if((f[n+28>>2]|0)!=4){f[j>>2]=0;f[j+4>>2]=0;s=aD(j,39)|0;t=353217;v=s+39|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,j,353257,353261,2974);bD(j)}I=f[n+24>>2]|0}aM(c,I,1,0,-1,1,0);MW(n,o,0);a=o+32|0;f[a>>2]=0;h=(I|0)>0;if(h){g=o+12|0;e=p+4|0;m=p+16|0;D=p+36|0;E=p+40|0;x=p+48|0;B=p+44|0;G=j+4|0;H=q+4|0;J=o+20|0;K=o+4|0;L=0;do{M=f[f[g>>2]>>2]|0;f[M+72>>2]=L;aM(c,f[M+24>>2]|0,1,12,L,1,0);yL(p,c,L);if(!(f[p>>2]&16384)){f[j>>2]=0;f[G>>2]=0;s=aD(j,17)|0;t=255617;v=s+17|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,j,255529,254658,1919);bD(j)}N=f[m>>2]|0;O=q;f[O>>2]=0;f[O+4>>2]=0;f[H>>2]=1073741823;f[j>>2]=f[q>>2];f[j+4>>2]=f[q+4>>2];LW(M,N,j)|0;N=f[D>>2]|0;if(N|0?(O=N+12|0,N=f[O>>2]|0,f[O>>2]=N+-1,(N|0)==1):0)kL(p);f[D>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[e>>2]|0)>0){N=f[E>>2]|0;O=0;do{f[N+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[e>>2]|0))}O=f[B>>2]|0;if((O|0)!=(x|0))UC(O);L=L+1|0;O=(f[g>>2]|0)+4|0;f[g>>2]=O;if(O>>>0>=(f[J>>2]|0)>>>0)VW(o,1);O=(f[a>>2]|0)+1|0;f[a>>2]=O;f[a>>2]=(O|0)<(f[(f[K>>2]|0)+24>>2]<<1|0)?O:0}while((L|0)<(I|0))}if(PM(d)|0){aM(d,1,I,28,-1,1,0);do if((yM(d)|0)==65536){L=f[d+4>>2]|0;f[r>>2]=f[L>>2];K=r+4|0;J=L+4|0;f[K>>2]=f[J>>2];g=r+8|0;f[g>>2]=f[L+8>>2];f[r+12>>2]=f[L+12>>2];x=r+16|0;f[x>>2]=f[L+16>>2];f[r+20>>2]=f[L+20>>2];f[r+24>>2]=f[L+24>>2];f[r+28>>2]=f[L+28>>2];f[r+32>>2]=f[L+32>>2];B=r+36|0;e=f[L+36>>2]|0;f[B>>2]=e;f[r+40>>2]=g;g=r+48|0;E=r+44|0;f[E>>2]=g;f[g>>2]=0;f[r+52>>2]=0;if(e|0){g=e+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[J>>2]|0)<3){J=f[L+44>>2]|0;g=f[E>>2]|0;f[g>>2]=f[J>>2];f[g+4>>2]=f[J+4>>2];P=E;Q=B;R=x;break}else{f[K>>2]=0;jL(r,L);P=E;Q=B;R=x;break}}else{yL(r,d,-1);P=r+44|0;Q=r+36|0;R=r+16|0}while(0);d=f[R>>2]|0;x=f[Q>>2]|0;if(x|0?(B=x+12|0,x=f[B>>2]|0,f[B>>2]=x+-1,(x|0)==1):0)kL(r);f[Q>>2]=0;Q=r+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[Q>>2]|0)>0){R=f[r+40>>2]|0;x=0;do{f[R+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[Q>>2]|0))}Q=f[P>>2]|0;if((Q|0)!=(r+48|0))UC(Q);MW(n,j,0);f[j+32>>2]=0;s=o;t=j;v=s+36|0;do{f[s>>2]=f[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(v|0));if(h){h=o+12|0;t=o+20|0;s=o+4|0;v=0;do{j=f[f[h>>2]>>2]|0;n=f[j+12>>2]|0;if(!n)S=-1;else S=f[n+72>>2]|0;n=f[j+8>>2]|0;if(!n)T=-1;else T=f[n+72>>2]|0;n=f[j+20>>2]|0;if(!n)U=-1;else U=f[n+72>>2]|0;n=f[j+16>>2]|0;if(!n)V=-1;else V=f[n+72>>2]|0;f[d+(v<<4)>>2]=S;f[d+(v<<4)+4>>2]=T;f[d+(v<<4)+8>>2]=U;f[d+(v<<4)+12>>2]=V;v=v+1|0;n=(f[h>>2]|0)+4|0;f[h>>2]=n;if(n>>>0>=(f[t>>2]|0)>>>0)VW(o,1);n=(f[a>>2]|0)+1|0;f[a>>2]=n;f[a>>2]=(n|0)<(f[(f[s>>2]|0)+24>>2]<<1|0)?n:0}while((v|0)<(I|0))}}}else OM(c);if(C|0?(c=C+4|0,I=f[c>>2]|0,f[c>>2]=I+-1,(I|0)==1):0)bi[f[(f[C>>2]|0)+8>>2]&2047](C);C=l+36|0;I=f[C>>2]|0;if(I|0?(c=I+12|0,I=f[c>>2]|0,f[c>>2]=I+-1,(I|0)==1):0)kL(l);f[C>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[w>>2]|0)>0){F=f[y>>2]|0;y=0;do{f[F+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[w>>2]|0))}w=f[A>>2]|0;if((w|0)!=(z|0))UC(w);if(!(f[k+4>>2]|0)){u=i;return}u=i;return}function Fea(a,c,e,g,h,i,j,k,l,m,o,p){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;o=+o;p=p|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0.0,Ja=0;q=u;u=u+2464|0;r=q+1336|0;s=q+272|0;t=q;v=q+264|0;w=q+200|0;x=q+256|0;y=q+136|0;z=q+192|0;dQ(v,56528);if((Y(l,k)|0)<=0?!(m>0.0&o>0.0):0){f[r>>2]=0;f[r+4>>2]=0;A=aD(r,68)|0;B=255726;C=A+68|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,r,255795,255802,3675);bD(r)}if(m<2.220446049250313e-16|o<2.220446049250313e-16){D=+(g|0);E=+(h|0);F=+(k|0)/D;G=+(l|0)/E;H=E;I=D}else{F=m;G=o;H=+(h|0);I=+(g|0)}J=a&7;K=(a>>>3&511)+1|0;M=MVb(I*F)|0;N=MVb(H*G)|0;if((Y(N,M)|0)<=0){f[r>>2]=0;f[r+4>>2]=0;A=aD(r,16)|0;B=255873;C=A+16|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,r,255795,255802,3687);bD(r)}H=1.0/F;I=1.0/G;O=MVb(H)|0;P=MVb(I)|0;if(+L(+(H-+(O|0)))<2.220446049250313e-16)Q=+L(+(I-+(P|0)))<2.220446049250313e-16;else Q=0;f[x>>2]=g;f[x+4>>2]=h;JF(w,x,a,c,e);f[z>>2]=M;f[z+4>>2]=N;JF(y,z,a,i,j);switch(p|0){case 5:{if((K|0)!=2&((P|0)==2&((O|0)==2&Q))){R=3;S=33}else{a=f[56548+(J<<2)>>2]|0;if(J>>>0>=5){f[r>>2]=0;f[r+4>>2]=0;A=aD(r,9)|0;B=255890;C=A+9|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,r,255795,255802,3827);bD(r)}pi[a&7](c,e,g,h,i,j,k,l,K,F,G)}break}case 0:{l=f[(f[w+40>>2]|0)+4>>2]|0;k=y+40|0;j=f[k>>2]|0;i=f[j+4>>2]|0;c=f[j>>2]|0;j=r+8|0;f[r>>2]=j;a=r+4|0;f[a>>2]=i;if(i>>>0>264){z=N5b(i>>>0>1073741823?-1:i<<2)|0;f[r>>2]=z;T=z}else T=j;z=f[w+4>>2]|0;if((z|0)>0)U=f[(f[w+44>>2]|0)+(z+-1<<2)>>2]|0;else U=0;z=U>>>2;if((i|0)>0){x=l+-1|0;l=0;do{o=H*+(l|0);V=~~o;W=V-(+(V|0)>o&1)|0;V=Y((x|0)<(W|0)?x:W,U)|0;f[T+(l<<2)>>2]=V;l=l+1|0}while((l|0)!=(i|0))}f[s>>2]=0;f[s+4>>2]=c;Gea(t,w,y,T,z,I);z=f[y+4>>2]|0;if((z|0)<3)X=Y(f[y+12>>2]|0,f[y+8>>2]|0)|0;else{T=f[k>>2]|0;k=0;c=1;while(1){i=Y(f[T+(k<<2)>>2]|0,c)|0;k=k+1|0;if((k|0)==(z|0)){X=i;break}else c=i}}RQ(s,t,+(X>>>0)*.0000152587890625);Hea(t);t=f[r>>2]|0;if((t|0)!=(j|0)){if(t|0)P5b(t);f[r>>2]=j;f[a>>2]=264}break}default:{R=(p|0)==1&((P|0)==2&((O|0)==2&Q))?3:p;S=33}}do if((S|0)==33){p=(R|0)==3;if(I>=1.0&(H>=1.0&p)){if(Q){a=Y(P,O)|0;j=(e>>>0)/((1212424721>>>(f[w>>2]<<2&28)&15)>>>0)|0;t=a+(Y(M,K)|0)|0;X=r+8|0;f[r>>2]=X;c=r+4|0;f[c>>2]=t;if(t>>>0>264){z=N5b(t>>>0>1073741823?-1:t<<2)|0;f[r>>2]=z;Z=z}else Z=X;z=Z+(a<<2)|0;a=f[56580+(J<<2)>>2]|0;if(!(109>>>J&1)){f[s>>2]=0;f[s+4>>2]=0;A=aD(s,9)|0;B=255890;C=A+9|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,s,255795,255802,3862);bD(s)}if((P|0)>0&(O|0)>0){t=0;k=0;while(1){T=Y(k,j)|0;i=0;l=t;while(1){U=(Y(i,K)|0)+T|0;f[Z+(l<<2)>>2]=U;i=i+1|0;if((i|0)==(O|0))break;else l=l+1|0}k=k+1|0;if((k|0)==(P|0))break;else t=O+t|0}}if((M|0)>0){t=0;do{k=Y(t,K)|0;j=Y(k,O)|0;l=0;do{f[z+(l+k<<2)>>2]=l+j;l=l+1|0}while((l|0)!=(K|0));t=t+1|0}while((t|0)!=(M|0))}Wg[a&127](w,y,Z,z,O,P);t=f[r>>2]|0;if((t|0)!=(X|0)){if(t|0)P5b(t);f[r>>2]=X;f[c>>2]=264}break}t=f[56612+(J<<2)>>2]|0;if(!((109>>>J&1|0)!=0&K>>>0<5)){f[r>>2]=0;f[r+4>>2]=0;A=aD(r,20)|0;B=255900;C=A+20|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,r,255795,255802,3881);bD(r)}c=h+g<<1;X=r+8|0;f[r>>2]=X;z=r+4|0;f[z>>2]=c;if(c>>>0>93){a=N5b(c>>>0>357913941?-1:c*12|0)|0;f[r>>2]=a;_=a}else _=X;a=_+((g<<1)*12|0)|0;c=Iea(g,M,K,H,_)|0;l=Iea(h,N,1,I,a)|0;j=N+1|0;k=s+8|0;f[s>>2]=k;i=s+4|0;f[i>>2]=j;if(j>>>0>264){T=N5b(j>>>0>1073741823?-1:j<<2)|0;f[s>>2]=T;$=T}else $=k;if((l|0)>0){T=0;j=0;while(1){if((j|0)!=0?(f[a+(j*12|0)+4>>2]|0)==(f[a+((j+-1|0)*12|0)+4>>2]|0):0)aa=T;else{f[$+(T<<2)>>2]=j;aa=T+1|0}j=j+1|0;if((j|0)==(l|0)){ba=aa;break}else T=aa}}else ba=0;f[$+(ba<<2)>>2]=l;Qh[t&127](w,y,_,c,a,l,$);T=f[s>>2]|0;if((T|0)!=(k|0)){if(T|0)P5b(T);f[s>>2]=k;f[i>>2]=264}T=f[r>>2]|0;if((T|0)!=(X|0)){if(T|0)P5b(T);f[r>>2]=X;f[z>>2]=93}break}T=Y(M,K)|0;j=(J|0)==0;U=(R|0)==2;if(!U)if((R|0)!=4)if((R|2|0)==3){ca=2;da=56676;S=76}else{f[r>>2]=0;f[r+4>>2]=0;A=aD(r,28)|0;B=269882;C=A+28|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-5,r,255795,255802,3919);bD(r);ea=0;fa=0;S=77}else{ca=8;da=56644;S=76}else{ca=4;da=56708;S=76}if((S|0)==76){z=f[da+(J<<2)>>2]|0;X=ca>>>1;if(!z){ea=ca;fa=X;S=77}else{ga=ca;ha=z;ia=X}}if((S|0)==77){f[r>>2]=0;f[r+4>>2]=0;A=aD(r,9)|0;B=255890;C=A+9|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,r,255795,255802,3922);bD(r);ga=ea;ha=0;ia=fa}X=T+N|0;z=ga<<2;i=Y(z|4,X)|0;k=r+8|0;f[r>>2]=k;l=r+4|0;f[l>>2]=i;if(i>>>0>1032){a=N5b(i)|0;f[r>>2]=a;ja=a}else ja=k;a=ja+(T<<2)|0;i=a+(N<<2)|0;c=Y(ga,T)|0;t=i+(c<<2)|0;x=i+(c<<1)|0;A=s;C=A+64|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));if((M|0)>0){T=ia+-1|0;c=s+4|0;V=s+8|0;W=s+12|0;ka=(ga|0)>0;la=Y(ga,K)|0;ma=(R|0)==4;na=g+-1|0;oa=0;pa=M;qa=0;while(1){ra=Y(la,qa)|0;sa=ja+(X+ra<<2)|0;o=+(qa|0);if(p){m=H*o;ta=~~m;ua=ta-(+(ta|0)>m&1)|0;m=+(qa+1|0)-F*+(ua+1|0);ta=~~m;if(!(m<=0.0)){va=m-+(ta-(+(ta|0)>m&1)|0);wa=ua}else{va=0.0;wa=ua}}else{m=H*(o+.5)+-.5;ua=~~m;ta=ua-(+(ua|0)>m&1)|0;va=m-+(ta|0);wa=ta}a:do if((wa|0)<(T|0)){ta=qa+1|0;if((wa|0)<0){switch(R|0){case 2:case 4:{xa=va;ya=ta;za=wa;break a;break}default:{}}xa=0.0;ya=ta;za=0}else{xa=va;ya=ta;za=wa}}else{xa=va;ya=oa;za=wa}while(0);b:do if((za+ia|0)>=(g|0)){ta=(qa|0)<(pa|0)?qa:pa;if((za|0)<(na|0)){Aa=ta;Ba=xa;Ca=za}else{switch(R|0){case 2:case 4:{Aa=ta;Ba=xa;Ca=za;break b;break}default:{}}Aa=ta;Ba=0.0;Ca=na}}else{Aa=pa;Ba=xa;Ca=za}while(0);ta=Y(Ca,K)|0;ua=Y(qa,K)|0;Da=0;do{f[ja+(Da+ua<<2)>>2]=Da+ta;Da=Da+1|0}while((Da|0)!=(K|0));do if(!U)if(ma){Jea(Ba,s);break}else{n[s>>2]=1.0-Ba;n[c>>2]=Ba;break}else{m=Ba+1.0;o=m*(m*(3.75-m*.75)+-6.0)+3.0;n[s>>2]=o;m=Ba*(Ba*(Ba*1.25+-2.25))+1.0;n[c>>2]=m;D=1.0-Ba;E=D*(D*(D*1.25+-2.25))+1.0;n[V>>2]=E;n[W>>2]=1.0-o-m-E}while(0);if(j){if(ka){Da=0;do{ta=LVb(+n[s+(Da<<2)>>2]*2048.0)|0;d[i+(Da+ra<<1)>>1]=(ta+32768|0)>>>0<65536?ta:(ta|0)>0?32767:32768;Da=Da+1|0}while((Da|0)!=(ga|0));Ea=ga}else Ea=0;if((Ea|0)<(la|0)){Da=Ea;do{ta=Da+ra|0;d[i+(ta<<1)>>1]=d[i+(ta-ga<<1)>>1]|0;Da=Da+1|0}while((Da|0)<(la|0))}}else{if(ka){Vac(sa|0,s|0,z|0)|0;Fa=ga}else Fa=0;if((Fa|0)<(la|0)){Da=Fa;do{ta=Da+ra|0;f[i+(ta<<2)>>2]=f[i+(ta-ga<<2)>>2];Da=Da+1|0}while((Da|0)<(la|0))}}qa=qa+1|0;if((qa|0)==(M|0)){Ga=ya;Ha=Aa;break}else{oa=ya;pa=Aa}}}else{Ga=0;Ha=M}if((N|0)>0){pa=s+4|0;oa=s+8|0;qa=s+12|0;la=(ga|0)>0;ka=(R|0)==4;W=Y(Y(M,z+4|0)|0,K)|0;V=0;do{c=Y(ga,V)|0;ma=ja+(N+c<<2)+W|0;E=+(V|0);if(p){m=I*E;na=~~m;T=na-(+(na|0)>m&1)|0;m=+(V+1|0)-G*+(T+1|0);na=~~m;if(!(m<=0.0)){Ia=m-+(na-(+(na|0)>m&1)|0);Ja=T}else{Ia=0.0;Ja=T}}else{m=I*(E+.5)+-.5;T=~~m;na=T-(+(T|0)>m&1)|0;Ia=m-+(na|0);Ja=na}f[a+(V<<2)>>2]=Ja;do if(!U)if(ka){Jea(Ia,s);break}else{n[s>>2]=1.0-Ia;n[pa>>2]=Ia;break}else{m=Ia+1.0;E=m*(m*(3.75-m*.75)+-6.0)+3.0;n[s>>2]=E;m=Ia*(Ia*(Ia*1.25+-2.25))+1.0;n[pa>>2]=m;o=1.0-Ia;D=o*(o*(o*1.25+-2.25))+1.0;n[oa>>2]=D;n[qa>>2]=1.0-E-m-D}while(0);if(j){if(la){na=0;do{T=LVb(+n[s+(na<<2)>>2]*2048.0)|0;d[x+(na+c<<1)>>1]=(T+32768|0)>>>0<65536?T:(T|0)>0?32767:32768;na=na+1|0}while((na|0)!=(ga|0))}}else if(la)Vac(ma|0,s|0,z|0)|0;V=V+1|0}while((V|0)!=(N|0))}Th[ha&127](w,y,ja,i,a,j?x:t,Ga,Ha,ga);V=f[r>>2]|0;if((V|0)!=(k|0)){if(V|0)P5b(V);f[r>>2]=k;f[l>>2]=1032}}while(0);r=y+36|0;ga=f[r>>2]|0;if(ga|0?(Ha=ga+12|0,ga=f[Ha>>2]|0,f[Ha>>2]=ga+-1,(ga|0)==1):0)kL(y);f[r>>2]=0;r=y+16|0;ga=y+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[ga>>2]|0)>0){r=f[y+40>>2]|0;Ha=0;do{f[r+(Ha<<2)>>2]=0;Ha=Ha+1|0}while((Ha|0)<(f[ga>>2]|0))}ga=f[y+44>>2]|0;if((ga|0)!=(y+48|0))UC(ga);ga=w+36|0;y=f[ga>>2]|0;if(y|0?(Ha=y+12|0,y=f[Ha>>2]|0,f[Ha>>2]=y+-1,(y|0)==1):0)kL(w);f[ga>>2]=0;ga=w+16|0;y=w+4|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[y>>2]|0)>0){ga=f[w+40>>2]|0;Ha=0;do{f[ga+(Ha<<2)>>2]=0;Ha=Ha+1|0}while((Ha|0)<(f[y>>2]|0))}y=f[w+44>>2]|0;if((y|0)!=(w+48|0))UC(y);if(!(f[v+4>>2]|0)){u=q;return}u=q;return}function Gea(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;f[a>>2]=57248;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;jL(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;q=a+128|0;p[q>>3]=g;return}else{f[h>>2]=0;jL(b,c);n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;q=a+128|0;p[q>>3]=g;return}}function Hea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57248;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Iea(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0.0,m=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((b|0)<=0){g=0;return g|0}h=+(a|0);i=a+-1|0;a=0;j=0;while(1){k=+(j|0)*d;l=k+d;m=h-k;o=m<d?m:d;p=~~k;q=(+(p|0)<k&1)+p|0;p=~~l;r=p-(+(p|0)>l&1)|0;p=(i|0)<(r|0)?i:r;r=(p|0)<(q|0)?p:q;m=+(r|0)-k;if(m>.001){s=Y(j,c)|0;f[e+(a*12|0)+4>>2]=s;s=Y(r+-1|0,c)|0;f[e+(a*12|0)>>2]=s;n[e+(a*12|0)+8>>2]=m/o;t=a+1|0}else t=a;if((p|0)>(q|0)){q=Y(j,c)|0;m=1.0/o;s=r;r=t;while(1){f[e+(r*12|0)+4>>2]=q;u=Y(s,c)|0;f[e+(r*12|0)>>2]=u;u=r+1|0;n[e+(r*12|0)+8>>2]=m;s=s+1|0;if((s|0)>=(p|0)){v=u;break}else r=u}}else v=t;m=l-+(p|0);if(m>.001){r=Y(j,c)|0;f[e+(v*12|0)+4>>2]=r;r=Y(p,c)|0;f[e+(v*12|0)>>2]=r;k=m>1.0?1.0:m;n[e+(v*12|0)+8>>2]=(o<k?o:k)/o;w=v+1|0}else w=v;j=j+1|0;if((j|0)==(b|0)){g=w;break}else a=w}return g|0}function Jea(a,b){a=+a;b=b|0;var c=0.0,d=0.0,e=0.0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0;if(a<1.1920928955078125e-07){f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;n[b+12>>2]=1.0;return}else{c=a+3.0;a=-c*3.141592653589793*.25;d=+P(+a);e=+O(+a);g=e*0.0;h=(d+g)/(a*a);a=-(c+-1.0)*3.141592653589793*.25;i=d*-.7071067811865476;j=e*-.7071067811865476;k=(i+j)/(a*a);a=-(c+-2.0)*3.141592653589793*.25;l=d*0.0;m=(l+e)/(a*a);a=-(c+-3.0)*3.141592653589793*.25;o=d*.7071067811865476;p=(o+j)/(a*a);a=-(c+-4.0)*3.141592653589793*.25;j=(g-d)/(a*a);a=-(c+-5.0)*3.141592653589793*.25;d=e*.7071067811865476;g=(o+d)/(a*a);a=-(c+-6.0)*3.141592653589793*.25;o=(l-e)/(a*a);a=-(c+-7.0)*3.141592653589793*.25;c=(i+d)/(a*a);a=1.0/(h+0.0+k+m+p+j+g+o+c);n[b>>2]=a*h;n[b+4>>2]=a*k;n[b+8>>2]=a*m;n[b+12>>2]=a*p;n[b+16>>2]=a*j;n[b+20>>2]=a*g;n[b+24>>2]=a*o;n[b+28>>2]=a*c;return}}function Kea(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;hfa(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);ifa(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);ifa(o);u=k;return}function Lea(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;cfa(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);dfa(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);dfa(o);u=k;return}function Mea(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Zea(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);_ea(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);_ea(o);u=k;return}function Nea(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Uea(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);Vea(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);Vea(o);u=k;return}function Oea(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Pea(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);Qea(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);Qea(o);u=k;return}function Pea(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=56748;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function Qea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56748;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Rea(a){a=a|0;Qea(a);O5b(a);return}function Sea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0;c=u;u=u+1296|0;d=c+1288|0;e=c;g=c+1224|0;h=c+1160|0;i=c+1096|0;j=((f[a+4>>2]|0)>>>3&511)+1|0;k=a+140|0;l=(f[k>>2]|0)+15&-16;m=a+148|0;o=f[m>>2]|0;q=Y(l,o)|0;r=e+8|0;f[e>>2]=r;s=e+4|0;f[s>>2]=q;if(q>>>0>136){t=N5b(q>>>0>536870911?-1:q<<3)|0;f[e>>2]=t;v=t}else v=r;t=g;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=h;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((o|0)>0){Nac(i|0,-1,o<<2|0)|0;t=0;do{q=v+((Y(t,l)|0)<<3)|0;f[h+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(o|0))}t=f[b>>2]|0;q=b+4|0;if((t|0)<(f[q>>2]|0)){b=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=h+4|0;E=h+8|0;F=h+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=l<<3;l=(f[a+128>>2]|0)+((Y(t,o)|0)<<2)|0;a=t;t=o;while(1){if((t|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((t|0)/-2|0)|0;K=t;L=0;M=t;N=0;while(1){O=o+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(L|0)<(N|0)?N:L;a:do if((P|0)<(M|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[i+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(M|0))O=R;else{S=M;T=R;break a}}if((O|0)>(N|0)){Vac(f[h+(N<<2)>>2]|0,f[h+(O<<2)>>2]|0,J|0)|0;S=f[m>>2]|0;T=O}else{S=M;T=O}}else{S=M;T=P}while(0);K=(N|0)<(K|0)&(T|0)==(S|0)?N:K;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[g+(N<<2)>>2]=P;f[i+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{L=T;M=S}}if((S|0)>(K|0))Tea(d,g+(K<<2)|0,h+(K<<2)|0,S-K|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[k>>2]|0,j,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,a)|0)|0;L=f[k>>2]|0;U=+n[l>>2];V=+n[l+4>>2];W=+n[l+8>>2];X=+n[l+12>>2];N=f[h>>2]|0;o=f[D>>2]|0;P=f[E>>2]|0;R=f[F>>2]|0;if((L|0)>0){Z=0;do{p[M+(Z<<3)>>3]=U*+p[N+(Z<<3)>>3]+V*+p[o+(Z<<3)>>3]+W*+p[P+(Z<<3)>>3]+X*+p[R+(Z<<3)>>3];Z=Z+1|0}while((Z|0)!=(L|0))}a=a+1|0;L=f[m>>2]|0;if((a|0)>=(f[q>>2]|0))break;else{l=l+(L<<2)|0;t=L}}_=f[e>>2]|0}else _=v;if((_|0)==(r|0)){u=c;return}if(_|0)P5b(_);f[e>>2]=r;f[s>>2]=136;u=c;return}function Tea(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((d|0)<=0)return;a=j<<1;m=0-(i<<2)|0;o=j<<1;q=j*3|0;r=g;g=0;while(1){s=f[b+(g<<2)>>2]|0;t=f[c+(g<<2)>>2]|0;u=k;v=0;w=r;a:while(1){if((u|0)>(v|0)){x=u-v<<2;y=v;z=w;while(1){A=f[e+(y<<2)>>2]|0;B=A-j|0;if(B>>>0<h>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+j|0;else{E=D;break}while(1)if((E|0)<(h|0)){C=E;break}else E=E-j|0}F=+p[s+(C<<3)>>3]*+n[z>>2]+0.0;if(A>>>0<h>>>0)G=A;else{D=A;while(1)if((D|0)<0)D=D+j|0;else{H=D;break}while(1)if((H|0)<(h|0)){G=H;break}else H=H-j|0}I=F+ +p[s+(G<<3)>>3]*+n[z+4>>2];D=o+B|0;if(D>>>0<h>>>0)J=D;else{A=D;while(1)if((A|0)<0)A=A+j|0;else{K=A;break}while(1)if((K|0)<(h|0)){J=K;break}else K=K-j|0}F=I+ +p[s+(J<<3)>>3]*+n[z+8>>2];A=q+B|0;if(A>>>0<h>>>0)L=A;else{D=A;while(1)if((D|0)<0)D=D+j|0;else{M=D;break}while(1)if((M|0)<(h|0)){L=M;break}else M=M-j|0}p[t+(y<<3)>>3]=F+ +p[s+(L<<3)>>3]*+n[z+12>>2];y=y+1|0;if((y|0)==(u|0))break;else z=z+16|0}N=u;O=w+(x<<2)|0}else{N=v;O=w}if((u|0)==(i|0))break;if((N|0)<(l|0)){P=N;Q=O}else{u=i;v=N;w=O;continue}while(1){z=f[e+(P<<2)>>2]|0;p[t+(P<<3)>>3]=+p[s+(z-j<<3)>>3]*+n[Q>>2]+ +p[s+(z<<3)>>3]*+n[Q+4>>2]+ +p[s+(z+j<<3)>>3]*+n[Q+8>>2]+ +p[s+(z+a<<3)>>3]*+n[Q+12>>2];z=P+1|0;y=Q+16|0;if((z|0)<(l|0)){P=z;Q=y}else{u=i;v=l;w=y;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else r=O+(m<<2)|0}return}function Uea(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=56768;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function Vea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56768;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Wea(a){a=a|0;Vea(a);O5b(a);return}function Xea(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Z=0;c=u;u=u+1264|0;d=c+1256|0;e=c+192|0;g=c+128|0;h=c+64|0;i=c;j=((f[a+4>>2]|0)>>>3&511)+1|0;k=a+140|0;l=(f[k>>2]|0)+15&-16;m=a+148|0;o=f[m>>2]|0;p=Y(l,o)|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=p;if(p>>>0>264){s=N5b(p>>>0>1073741823?-1:p<<2)|0;f[e>>2]=s;t=s}else t=q;s=g;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){Nac(i|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,l)|0)<<2)|0;f[h+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=h+4|0;D=h+8|0;E=h+12|0;F=a+136|0;G=a+20|0;H=a+48|0;I=l<<2;l=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;J=s;K=0;L=s;M=0;while(1){N=o+M|0;O=f[F>>2]|0;P=(N|0)>-1?((N|0)<(O|0)?N:O+-1|0):0;O=(K|0)<(M|0)?M:K;a:do if((O|0)<(L|0)){N=O;while(1){if((N|0)<16?(P|0)==(f[i+(N<<2)>>2]|0):0)break;Q=N+1|0;if((Q|0)<(L|0))N=Q;else{R=L;S=Q;break a}}if((N|0)>(M|0)){Vac(f[h+(M<<2)>>2]|0,f[h+(N<<2)>>2]|0,I|0)|0;R=f[m>>2]|0;S=N}else{R=L;S=N}}else{R=L;S=O}while(0);J=(M|0)<(J|0)&(S|0)==(R|0)?M:J;O=(f[G>>2]|0)+(Y(f[f[H>>2]>>2]|0,P)|0)|0;f[g+(M<<2)>>2]=O;f[i+(M<<2)>>2]=P;M=M+1|0;if((M|0)>=(R|0))break;else{K=S;L=R}}if((R|0)>(J|0))Yea(d,g+(J<<2)|0,h+(J<<2)|0,R-J|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[k>>2]|0,j,f[y>>2]|0,f[z>>2]|0)}L=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;K=f[k>>2]|0;T=+n[l>>2];U=+n[l+4>>2];V=+n[l+8>>2];W=+n[l+12>>2];M=f[h>>2]|0;o=f[C>>2]|0;O=f[D>>2]|0;Q=f[E>>2]|0;if((K|0)>0){X=0;do{n[L+(X<<2)>>2]=T*+n[M+(X<<2)>>2]+U*+n[o+(X<<2)>>2]+V*+n[O+(X<<2)>>2]+W*+n[Q+(X<<2)>>2];X=X+1|0}while((X|0)!=(K|0))}a=a+1|0;K=f[m>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{l=l+(K<<2)|0;s=K}}Z=f[e>>2]|0}else Z=t;if((Z|0)==(q|0)){u=c;return}if(Z|0)P5b(Z);f[e>>2]=q;f[r>>2]=264;u=c;return}function Yea(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;if((d|0)<=0)return;a=j<<1;m=0-(i<<2)|0;o=j<<1;p=j*3|0;q=g;g=0;while(1){r=f[b+(g<<2)>>2]|0;s=f[c+(g<<2)>>2]|0;t=k;u=0;v=q;a:while(1){if((t|0)>(u|0)){w=t-u<<2;x=u;y=v;while(1){z=f[e+(x<<2)>>2]|0;A=z-j|0;if(A>>>0<h>>>0)B=A;else{C=A;while(1)if((C|0)<0)C=C+j|0;else{D=C;break}while(1)if((D|0)<(h|0)){B=D;break}else D=D-j|0}E=+n[r+(B<<2)>>2]*+n[y>>2]+0.0;if(z>>>0<h>>>0)F=z;else{C=z;while(1)if((C|0)<0)C=C+j|0;else{G=C;break}while(1)if((G|0)<(h|0)){F=G;break}else G=G-j|0}H=E+ +n[r+(F<<2)>>2]*+n[y+4>>2];C=o+A|0;if(C>>>0<h>>>0)I=C;else{z=C;while(1)if((z|0)<0)z=z+j|0;else{J=z;break}while(1)if((J|0)<(h|0)){I=J;break}else J=J-j|0}E=H+ +n[r+(I<<2)>>2]*+n[y+8>>2];z=p+A|0;if(z>>>0<h>>>0)K=z;else{C=z;while(1)if((C|0)<0)C=C+j|0;else{L=C;break}while(1)if((L|0)<(h|0)){K=L;break}else L=L-j|0}n[s+(x<<2)>>2]=E+ +n[r+(K<<2)>>2]*+n[y+12>>2];x=x+1|0;if((x|0)==(t|0))break;else y=y+16|0}M=t;N=v+(w<<2)|0}else{M=u;N=v}if((t|0)==(i|0))break;if((M|0)<(l|0)){O=M;P=N}else{t=i;u=M;v=N;continue}while(1){y=f[e+(O<<2)>>2]|0;n[s+(O<<2)>>2]=+n[r+(y-j<<2)>>2]*+n[P>>2]+ +n[r+(y<<2)>>2]*+n[P+4>>2]+ +n[r+(y+j<<2)>>2]*+n[P+8>>2]+ +n[r+(y+a<<2)>>2]*+n[P+12>>2];y=O+1|0;x=P+16|0;if((y|0)<(l|0)){O=y;P=x}else{t=i;u=l;v=x;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else q=N+(m<<2)|0}return}function Zea(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=56788;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function _ea(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56788;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function $ea(a){a=a|0;_ea(a);O5b(a);return}function afa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0,$=0;c=u;u=u+1264|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;o=a+148|0;p=f[o>>2]|0;q=Y(m,p)|0;r=g+8|0;f[g>>2]=r;s=g+4|0;f[s>>2]=q;if(q>>>0>264){t=N5b(q>>>0>1073741823?-1:q<<2)|0;f[g>>2]=t;v=t}else v=r;t=h;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=i;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((p|0)>0){Nac(j|0,-1,p<<2|0)|0;t=0;do{q=v+((Y(t,m)|0)<<2)|0;f[i+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(p|0))}t=f[b>>2]|0;q=b+4|0;if((t|0)<(f[q>>2]|0)){b=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=i+4|0;E=i+8|0;F=i+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=m<<2;m=(f[a+128>>2]|0)+((Y(t,p)|0)<<2)|0;a=t;t=p;while(1){if((t|0)>0){p=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((t|0)/-2|0)|0;K=t;L=0;M=t;N=0;while(1){O=p+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(L|0)<(N|0)?N:L;a:do if((P|0)<(M|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[j+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(M|0))O=R;else{S=M;T=R;break a}}if((O|0)>(N|0)){Vac(f[i+(N<<2)>>2]|0,f[i+(O<<2)>>2]|0,J|0)|0;S=f[o>>2]|0;T=O}else{S=M;T=O}}else{S=M;T=P}while(0);K=(N|0)<(K|0)&(T|0)==(S|0)?N:K;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[h+(N<<2)>>2]=P;f[j+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{L=T;M=S}}if((S|0)>(K|0))bfa(e,h+(K<<2)|0,i+(K<<2)|0,S-K|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[l>>2]|0,k,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,a)|0)|0;L=f[l>>2]|0;U=+n[m>>2];V=+n[m+4>>2];W=+n[m+8>>2];X=+n[m+12>>2];N=f[i>>2]|0;p=f[D>>2]|0;P=f[E>>2]|0;R=f[F>>2]|0;if((L|0)>0){Z=0;do{_=LVb(U*+n[N+(Z<<2)>>2]+V*+n[p+(Z<<2)>>2]+W*+n[P+(Z<<2)>>2]+X*+n[R+(Z<<2)>>2])|0;d[M+(Z<<1)>>1]=(_+32768|0)>>>0<65536?_:(_|0)>0?32767:32768;Z=Z+1|0}while((Z|0)!=(L|0))}a=a+1|0;L=f[o>>2]|0;if((a|0)>=(f[q>>2]|0))break;else{m=m+(L<<2)|0;t=L}}$=f[g>>2]|0}else $=v;if(($|0)==(r|0)){u=c;return}if($|0)P5b($);f[g>>2]=r;f[s>>2]=264;u=c;return}function bfa(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((e|0)<=0)return;a=k<<1;o=0-(j<<2)|0;p=k<<1;q=k*3|0;r=h;h=0;while(1){s=f[b+(h<<2)>>2]|0;t=f[c+(h<<2)>>2]|0;u=l;v=0;w=r;a:while(1){if((u|0)>(v|0)){x=u-v<<2;y=v;z=w;while(1){A=f[g+(y<<2)>>2]|0;B=A-k|0;if(B>>>0<i>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+k|0;else{E=D;break}while(1)if((E|0)<(i|0)){C=E;break}else E=E-k|0}F=+(d[s+(C<<1)>>1]|0)*+n[z>>2]+0.0;if(A>>>0<i>>>0)G=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{H=D;break}while(1)if((H|0)<(i|0)){G=H;break}else H=H-k|0}I=F+ +(d[s+(G<<1)>>1]|0)*+n[z+4>>2];D=p+B|0;if(D>>>0<i>>>0)J=D;else{A=D;while(1)if((A|0)<0)A=A+k|0;else{K=A;break}while(1)if((K|0)<(i|0)){J=K;break}else K=K-k|0}F=I+ +(d[s+(J<<1)>>1]|0)*+n[z+8>>2];A=q+B|0;if(A>>>0<i>>>0)L=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{M=D;break}while(1)if((M|0)<(i|0)){L=M;break}else M=M-k|0}n[t+(y<<2)>>2]=F+ +(d[s+(L<<1)>>1]|0)*+n[z+12>>2];y=y+1|0;if((y|0)==(u|0))break;else z=z+16|0}N=u;O=w+(x<<2)|0}else{N=v;O=w}if((u|0)==(j|0))break;if((N|0)<(m|0)){P=N;Q=O}else{u=j;v=N;w=O;continue}while(1){z=f[g+(P<<2)>>2]|0;n[t+(P<<2)>>2]=+(d[s+(z-k<<1)>>1]|0)*+n[Q>>2]+ +(d[s+(z<<1)>>1]|0)*+n[Q+4>>2]+ +(d[s+(z+k<<1)>>1]|0)*+n[Q+8>>2]+ +(d[s+(z+a<<1)>>1]|0)*+n[Q+12>>2];z=P+1|0;y=Q+16|0;if((z|0)<(m|0)){P=z;Q=y}else{u=j;v=m;w=y;continue a}}}h=h+1|0;if((h|0)==(e|0))break;else r=O+(o<<2)|0}return}function cfa(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=56808;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function dfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56808;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function efa(a){a=a|0;dfa(a);O5b(a);return}function ffa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0,$=0;c=u;u=u+1264|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;o=a+148|0;p=f[o>>2]|0;q=Y(m,p)|0;r=g+8|0;f[g>>2]=r;s=g+4|0;f[s>>2]=q;if(q>>>0>264){t=N5b(q>>>0>1073741823?-1:q<<2)|0;f[g>>2]=t;v=t}else v=r;t=h;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=i;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((p|0)>0){Nac(j|0,-1,p<<2|0)|0;t=0;do{q=v+((Y(t,m)|0)<<2)|0;f[i+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(p|0))}t=f[b>>2]|0;q=b+4|0;if((t|0)<(f[q>>2]|0)){b=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=i+4|0;E=i+8|0;F=i+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=m<<2;m=(f[a+128>>2]|0)+((Y(t,p)|0)<<2)|0;a=t;t=p;while(1){if((t|0)>0){p=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((t|0)/-2|0)|0;K=t;L=0;M=t;N=0;while(1){O=p+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(L|0)<(N|0)?N:L;a:do if((P|0)<(M|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[j+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(M|0))O=R;else{S=M;T=R;break a}}if((O|0)>(N|0)){Vac(f[i+(N<<2)>>2]|0,f[i+(O<<2)>>2]|0,J|0)|0;S=f[o>>2]|0;T=O}else{S=M;T=O}}else{S=M;T=P}while(0);K=(N|0)<(K|0)&(T|0)==(S|0)?N:K;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[h+(N<<2)>>2]=P;f[j+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{L=T;M=S}}if((S|0)>(K|0))gfa(e,h+(K<<2)|0,i+(K<<2)|0,S-K|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[l>>2]|0,k,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,a)|0)|0;L=f[l>>2]|0;U=+n[m>>2];V=+n[m+4>>2];W=+n[m+8>>2];X=+n[m+12>>2];N=f[i>>2]|0;p=f[D>>2]|0;P=f[E>>2]|0;R=f[F>>2]|0;if((L|0)>0){Z=0;do{_=LVb(U*+n[N+(Z<<2)>>2]+V*+n[p+(Z<<2)>>2]+W*+n[P+(Z<<2)>>2]+X*+n[R+(Z<<2)>>2])|0;d[M+(Z<<1)>>1]=_>>>0<65536?_:(_|0)>0?65535:0;Z=Z+1|0}while((Z|0)!=(L|0))}a=a+1|0;L=f[o>>2]|0;if((a|0)>=(f[q>>2]|0))break;else{m=m+(L<<2)|0;t=L}}$=f[g>>2]|0}else $=v;if(($|0)==(r|0)){u=c;return}if($|0)P5b($);f[g>>2]=r;f[s>>2]=264;u=c;return}function gfa(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((d|0)<=0)return;a=k<<1;o=0-(i<<2)|0;p=k<<1;q=k*3|0;r=g;g=0;while(1){s=f[b+(g<<2)>>2]|0;t=f[c+(g<<2)>>2]|0;u=l;v=0;w=r;a:while(1){if((u|0)>(v|0)){x=u-v<<2;y=v;z=w;while(1){A=f[e+(y<<2)>>2]|0;B=A-k|0;if(B>>>0<h>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+k|0;else{E=D;break}while(1)if((E|0)<(h|0)){C=E;break}else E=E-k|0}F=+(j[s+(C<<1)>>1]|0)*+n[z>>2]+0.0;if(A>>>0<h>>>0)G=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{H=D;break}while(1)if((H|0)<(h|0)){G=H;break}else H=H-k|0}I=F+ +(j[s+(G<<1)>>1]|0)*+n[z+4>>2];D=p+B|0;if(D>>>0<h>>>0)J=D;else{A=D;while(1)if((A|0)<0)A=A+k|0;else{K=A;break}while(1)if((K|0)<(h|0)){J=K;break}else K=K-k|0}F=I+ +(j[s+(J<<1)>>1]|0)*+n[z+8>>2];A=q+B|0;if(A>>>0<h>>>0)L=A;else{D=A;while(1)if((D|0)<0)D=D+k|0;else{M=D;break}while(1)if((M|0)<(h|0)){L=M;break}else M=M-k|0}n[t+(y<<2)>>2]=F+ +(j[s+(L<<1)>>1]|0)*+n[z+12>>2];y=y+1|0;if((y|0)==(u|0))break;else z=z+16|0}N=u;O=w+(x<<2)|0}else{N=v;O=w}if((u|0)==(i|0))break;if((N|0)<(m|0)){P=N;Q=O}else{u=i;v=N;w=O;continue}while(1){z=f[e+(P<<2)>>2]|0;n[t+(P<<2)>>2]=+(j[s+(z-k<<1)>>1]|0)*+n[Q>>2]+ +(j[s+(z<<1)>>1]|0)*+n[Q+4>>2]+ +(j[s+(z+k<<1)>>1]|0)*+n[Q+8>>2]+ +(j[s+(z+a<<1)>>1]|0)*+n[Q+12>>2];z=P+1|0;y=Q+16|0;if((z|0)<(m|0)){P=z;Q=y}else{u=i;v=m;w=y;continue a}}}g=g+1|0;if((g|0)==(d|0))break;else r=O+(o<<2)|0}return}function hfa(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=56828;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function ifa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56828;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function jfa(a){a=a|0;ifa(a);O5b(a);return}function kfa(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;e=u;u=u+1264|0;g=e+1256|0;h=e+192|0;i=e+128|0;j=e+64|0;k=e;l=((f[a+4>>2]|0)>>>3&511)+1|0;m=a+140|0;n=(f[m>>2]|0)+15&-16;o=a+148|0;p=f[o>>2]|0;q=Y(n,p)|0;r=h+8|0;f[h>>2]=r;s=h+4|0;f[s>>2]=q;if(q>>>0>264){t=N5b(q>>>0>1073741823?-1:q<<2)|0;f[h>>2]=t;v=t}else v=r;t=i;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));t=j;q=t+64|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(q|0));if((p|0)>0){Nac(k|0,-1,p<<2|0)|0;t=0;do{q=v+((Y(t,n)|0)<<2)|0;f[j+(t<<2)>>2]=q;t=t+1|0}while((t|0)<(p|0))}t=f[c>>2]|0;q=c+4|0;if((t|0)<(f[q>>2]|0)){c=a+120|0;w=a+116|0;x=a+124|0;y=a+132|0;z=a+152|0;A=a+156|0;B=a+76|0;C=a+108|0;D=j+4|0;E=j+8|0;F=j+12|0;G=a+136|0;H=a+20|0;I=a+48|0;J=n<<2;n=(f[a+128>>2]|0)+((Y(t,p)|0)<<1)|0;a=t;t=p;while(1){if((t|0)>0){p=(f[(f[c>>2]|0)+(a<<2)>>2]|0)+1+((t|0)/-2|0)|0;K=t;L=0;M=t;N=0;while(1){O=p+N|0;P=f[G>>2]|0;Q=(O|0)>-1?((O|0)<(P|0)?O:P+-1|0):0;P=(L|0)<(N|0)?N:L;a:do if((P|0)<(M|0)){O=P;while(1){if((O|0)<16?(Q|0)==(f[k+(O<<2)>>2]|0):0)break;R=O+1|0;if((R|0)<(M|0))O=R;else{S=M;T=R;break a}}if((O|0)>(N|0)){Vac(f[j+(N<<2)>>2]|0,f[j+(O<<2)>>2]|0,J|0)|0;S=f[o>>2]|0;T=O}else{S=M;T=O}}else{S=M;T=P}while(0);K=(N|0)<(K|0)&(T|0)==(S|0)?N:K;P=(f[H>>2]|0)+(Y(f[f[I>>2]>>2]|0,Q)|0)|0;f[i+(N<<2)>>2]=P;f[k+(N<<2)>>2]=Q;N=N+1|0;if((N|0)>=(S|0))break;else{L=T;M=S}}if((S|0)>(K|0))lfa(g,i+(K<<2)|0,j+(K<<2)|0,S-K|0,f[w>>2]|0,f[x>>2]|0,f[y>>2]|0,f[m>>2]|0,l,f[z>>2]|0,f[A>>2]|0)}M=(f[B>>2]|0)+(Y(f[C>>2]|0,a)|0)|0;L=f[m>>2]|0;N=d[n>>1]|0;p=d[n+2>>1]|0;P=d[n+4>>1]|0;R=d[n+6>>1]|0;U=f[j>>2]|0;V=f[D>>2]|0;W=f[E>>2]|0;X=f[F>>2]|0;if((L|0)>0){Z=0;do{_=Y(f[U+(Z<<2)>>2]|0,N)|0;$=Y(f[V+(Z<<2)>>2]|0,p)|0;aa=Y(f[W+(Z<<2)>>2]|0,P)|0;ba=_+2097152+$+aa+(Y(f[X+(Z<<2)>>2]|0,R)|0)>>22;b[M+Z>>0]=ba>>>0<256?ba:(ba|0)>0?255:0;Z=Z+1|0}while((Z|0)!=(L|0))}a=a+1|0;L=f[o>>2]|0;if((a|0)>=(f[q>>2]|0))break;else{n=n+(L<<1)|0;t=L}}ca=f[h>>2]|0}else ca=v;if((ca|0)==(r|0)){u=e;return}if(ca|0)P5b(ca);f[h>>2]=r;f[s>>2]=264;u=e;return}function lfa(a,b,c,e,g,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;if((e|0)<=0)return;a=l<<1;o=0-(k<<2)|0;p=l<<1;q=l*3|0;r=i;i=0;while(1){s=f[b+(i<<2)>>2]|0;t=f[c+(i<<2)>>2]|0;u=m;v=0;w=r;a:while(1){if((u|0)>(v|0)){x=u-v<<2;y=v;z=w;while(1){A=f[g+(y<<2)>>2]|0;B=A-l|0;if(B>>>0<j>>>0)C=B;else{D=B;while(1)if((D|0)<0)D=D+l|0;else{E=D;break}while(1)if((E|0)<(j|0)){C=E;break}else E=E-l|0}D=Y(d[z>>1]|0,h[s+C>>0]|0)|0;if(A>>>0<j>>>0)F=A;else{G=A;while(1)if((G|0)<0)G=G+l|0;else{H=G;break}while(1)if((H|0)<(j|0)){F=H;break}else H=H-l|0}G=(Y(d[z+2>>1]|0,h[s+F>>0]|0)|0)+D|0;A=p+B|0;if(A>>>0<j>>>0)I=A;else{J=A;while(1)if((J|0)<0)J=J+l|0;else{K=J;break}while(1)if((K|0)<(j|0)){I=K;break}else K=K-l|0}J=(Y(d[z+4>>1]|0,h[s+I>>0]|0)|0)+G|0;D=q+B|0;if(D>>>0<j>>>0)L=D;else{A=D;while(1)if((A|0)<0)A=A+l|0;else{M=A;break}while(1)if((M|0)<(j|0)){L=M;break}else M=M-l|0}A=(Y(d[z+6>>1]|0,h[s+L>>0]|0)|0)+J|0;f[t+(y<<2)>>2]=A;y=y+1|0;if((y|0)==(u|0))break;else z=z+8|0}N=u;O=w+(x<<1)|0}else{N=v;O=w}if((u|0)==(k|0))break;if((N|0)<(n|0)){P=N;Q=O}else{u=k;v=N;w=O;continue}while(1){z=f[g+(P<<2)>>2]|0;y=Y(d[Q>>1]|0,h[s+(z-l)>>0]|0)|0;A=(Y(d[Q+2>>1]|0,h[s+z>>0]|0)|0)+y|0;y=A+(Y(d[Q+4>>1]|0,h[s+(z+l)>>0]|0)|0)|0;A=y+(Y(d[Q+6>>1]|0,h[s+(z+a)>>0]|0)|0)|0;f[t+(P<<2)>>2]=A;A=P+1|0;z=Q+8|0;if((A|0)<(n|0)){P=A;Q=z}else{u=k;v=n;w=z;continue a}}}i=i+1|0;if((i|0)==(e|0))break;else r=O+(o<<1)|0}return}function mfa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Pfa(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);Qfa(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);Qfa(o);u=k;return}function nfa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Jfa(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);Kfa(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);Kfa(o);u=k;return}function ofa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;Dfa(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);Efa(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);Efa(o);u=k;return}function pfa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;xfa(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);yfa(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);yfa(o);u=k;return}function qfa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;rfa(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);sfa(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);sfa(o);u=k;return}function rfa(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=56848;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function sfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56848;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function tfa(a){a=a|0;sfa(a);O5b(a);return}function ufa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1296|0;d=c+1289|0;e=c+1288|0;g=c;h=c+1224|0;i=c+1160|0;j=c+1096|0;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>136){s=N5b(p>>>0>536870911?-1:p<<3)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){Nac(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<3)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<3;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){Vac(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))vfa(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;wfa(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)P5b(Q);f[g>>2]=q;f[r>>2]=136;u=c;return}function vfa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;a:do if((d|0)<2)m=0;else{k=d+-1|0;h=f[b>>2]|0;a=f[c>>2]|0;if((l|0)<=0){o=(i|0)>0;q=0;r=h;s=a;while(1){q=q+1|0;t=r;r=f[b+(q<<2)>>2]|0;u=s;s=f[c+(q<<2)>>2]|0;if(o){v=0;do{w=f[e+(v<<2)>>2]|0;p[u+(v<<3)>>3]=+p[t+(w<<3)>>3];p[s+(v<<3)>>3]=+p[r+(w<<3)>>3];v=v+1|0}while((v|0)!=(i|0))}if((q|0)==(k|0)){m=k;break a}}}q=(l|0)<(i|0);r=0;s=h;o=a;do{r=r+1|0;v=s;s=f[b+(r<<2)>>2]|0;t=o;o=f[c+(r<<2)>>2]|0;u=0;do{w=f[e+(u<<2)>>2]|0;x=u<<1;y=+n[g+(x<<2)>>2];z=+n[g+((x|1)<<2)>>2];x=w+j|0;A=y*+p[s+(w<<3)>>3]+z*+p[s+(x<<3)>>3];p[t+(u<<3)>>3]=y*+p[v+(w<<3)>>3]+z*+p[v+(x<<3)>>3];p[o+(u<<3)>>3]=A;u=u+1|0}while((u|0)!=(l|0));if(q){u=l;do{x=f[e+(u<<2)>>2]|0;p[t+(u<<3)>>3]=+p[v+(x<<3)>>3];p[o+(u<<3)>>3]=+p[s+(x<<3)>>3];u=u+1|0}while((u|0)!=(i|0))}}while((r|0)!=(k|0));m=k}while(0);if((m|0)>=(d|0))return;if((l|0)<=0){k=(i|0)>0;r=m;do{s=f[b+(r<<2)>>2]|0;o=f[c+(r<<2)>>2]|0;if(k){q=0;do{p[o+(q<<3)>>3]=+p[s+(f[e+(q<<2)>>2]<<3)>>3];q=q+1|0}while((q|0)!=(i|0))}r=r+1|0}while((r|0)!=(d|0));return}r=(l|0)<(i|0);k=m;do{m=f[b+(k<<2)>>2]|0;q=f[c+(k<<2)>>2]|0;s=0;do{o=f[e+(s<<2)>>2]|0;a=s<<1;p[q+(s<<3)>>3]=+p[m+(o<<3)>>3]*+n[g+(a<<2)>>2]+ +p[m+(o+j<<3)>>3]*+n[g+((a|1)<<2)>>2];s=s+1|0}while((s|0)!=(l|0));if(r){s=l;do{p[q+(s<<3)>>3]=+p[m+(f[e+(s<<2)>>2]<<3)>>3];s=s+1|0}while((s|0)!=(i|0))}k=k+1|0}while((k|0)!=(d|0));return}function wfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0.0,h=0.0,i=0,j=0,k=0,l=0.0,m=0,o=0;g=+n[d>>2];h=+n[d+4>>2];d=f[b>>2]|0;a=f[b+4>>2]|0;b=e+-4|0;if((e|0)<4)i=0;else{j=0;do{k=j|1;l=g*+p[d+(k<<3)>>3]+h*+p[a+(k<<3)>>3];p[c+(j<<3)>>3]=g*+p[d+(j<<3)>>3]+h*+p[a+(j<<3)>>3];p[c+(k<<3)>>3]=l;k=j|2;m=j|3;l=g*+p[d+(m<<3)>>3]+h*+p[a+(m<<3)>>3];p[c+(k<<3)>>3]=g*+p[d+(k<<3)>>3]+h*+p[a+(k<<3)>>3];p[c+(m<<3)>>3]=l;j=j+4|0}while((j|0)<=(b|0));i=e&-4}if((i|0)<(e|0))o=i;else return;do{p[c+(o<<3)>>3]=g*+p[d+(o<<3)>>3]+h*+p[a+(o<<3)>>3];o=o+1|0}while((o|0)!=(e|0));return}function xfa(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=56868;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function yfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56868;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function zfa(a){a=a|0;yfa(a);O5b(a);return}function Afa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=N5b(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){Nac(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){Vac(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Bfa(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Cfa(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)P5b(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Bfa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0;a:do if((d|0)<2)m=0;else{k=d+-1|0;h=f[b>>2]|0;a=f[c>>2]|0;if((l|0)<=0){o=(i|0)>0;p=0;q=a;r=h;while(1){p=p+1|0;s=r;r=f[b+(p<<2)>>2]|0;t=q;q=f[c+(p<<2)>>2]|0;if(o){u=0;do{v=f[e+(u<<2)>>2]|0;f[t+(u<<2)>>2]=f[s+(v<<2)>>2];f[q+(u<<2)>>2]=f[r+(v<<2)>>2];u=u+1|0}while((u|0)!=(i|0))}if((p|0)==(k|0)){m=k;break a}}}p=(l|0)<(i|0);r=0;q=h;o=a;do{r=r+1|0;u=q;q=f[b+(r<<2)>>2]|0;s=o;o=f[c+(r<<2)>>2]|0;t=0;do{v=f[e+(t<<2)>>2]|0;w=t<<1;x=+n[g+(w<<2)>>2];y=+n[g+((w|1)<<2)>>2];w=v+j|0;z=x*+n[q+(v<<2)>>2]+y*+n[q+(w<<2)>>2];n[s+(t<<2)>>2]=x*+n[u+(v<<2)>>2]+y*+n[u+(w<<2)>>2];n[o+(t<<2)>>2]=z;t=t+1|0}while((t|0)!=(l|0));if(p){t=l;do{w=f[e+(t<<2)>>2]|0;f[s+(t<<2)>>2]=f[u+(w<<2)>>2];f[o+(t<<2)>>2]=f[q+(w<<2)>>2];t=t+1|0}while((t|0)!=(i|0))}}while((r|0)!=(k|0));m=k}while(0);if((m|0)>=(d|0))return;if((l|0)<=0){k=(i|0)>0;r=m;do{q=f[b+(r<<2)>>2]|0;o=f[c+(r<<2)>>2]|0;if(k){p=0;do{f[o+(p<<2)>>2]=f[q+(f[e+(p<<2)>>2]<<2)>>2];p=p+1|0}while((p|0)!=(i|0))}r=r+1|0}while((r|0)!=(d|0));return}r=(l|0)<(i|0);k=m;do{m=f[b+(k<<2)>>2]|0;p=f[c+(k<<2)>>2]|0;q=0;do{o=f[e+(q<<2)>>2]|0;a=q<<1;n[p+(q<<2)>>2]=+n[m+(o<<2)>>2]*+n[g+(a<<2)>>2]+ +n[m+(o+j<<2)>>2]*+n[g+((a|1)<<2)>>2];q=q+1|0}while((q|0)!=(l|0));if(r){q=l;do{f[p+(q<<2)>>2]=f[m+(f[e+(q<<2)>>2]<<2)>>2];q=q+1|0}while((q|0)!=(i|0))}k=k+1|0}while((k|0)!=(d|0));return}function Cfa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0.0,h=0.0,i=0,j=0,k=0,l=0.0,m=0,o=0;g=+n[d>>2];h=+n[d+4>>2];d=f[b>>2]|0;a=f[b+4>>2]|0;b=e+-4|0;if((e|0)<4)i=0;else{j=0;do{k=j|1;l=g*+n[d+(k<<2)>>2]+h*+n[a+(k<<2)>>2];n[c+(j<<2)>>2]=g*+n[d+(j<<2)>>2]+h*+n[a+(j<<2)>>2];n[c+(k<<2)>>2]=l;k=j|2;m=j|3;l=g*+n[d+(m<<2)>>2]+h*+n[a+(m<<2)>>2];n[c+(k<<2)>>2]=g*+n[d+(k<<2)>>2]+h*+n[a+(k<<2)>>2];n[c+(m<<2)>>2]=l;j=j+4|0}while((j|0)<=(b|0));i=e&-4}if((i|0)<(e|0))o=i;else return;do{n[c+(o<<2)>>2]=g*+n[d+(o<<2)>>2]+h*+n[a+(o<<2)>>2];o=o+1|0}while((o|0)!=(e|0));return}function Dfa(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=56888;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function Efa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56888;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Ffa(a){a=a|0;Efa(a);O5b(a);return}function Gfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=N5b(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){Nac(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){Vac(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Hfa(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Ifa(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)P5b(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Hfa(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;a:do if((e|0)<2)o=0;else{l=e+-1|0;i=f[b>>2]|0;a=f[c>>2]|0;if((m|0)<=0){p=(j|0)>0;q=0;r=i;s=a;while(1){q=q+1|0;t=r;r=f[b+(q<<2)>>2]|0;u=s;s=f[c+(q<<2)>>2]|0;if(p){v=0;do{w=f[g+(v<<2)>>2]|0;n[u+(v<<2)>>2]=+(d[t+(w<<1)>>1]|0);n[s+(v<<2)>>2]=+(d[r+(w<<1)>>1]|0);v=v+1|0}while((v|0)!=(j|0))}if((q|0)==(l|0)){o=l;break a}}}q=(m|0)<(j|0);r=0;s=i;p=a;do{r=r+1|0;v=s;s=f[b+(r<<2)>>2]|0;t=p;p=f[c+(r<<2)>>2]|0;u=0;do{w=f[g+(u<<2)>>2]|0;x=u<<1;y=+n[h+(x<<2)>>2];z=+n[h+((x|1)<<2)>>2];x=w+k|0;A=y*+(d[s+(w<<1)>>1]|0)+z*+(d[s+(x<<1)>>1]|0);n[t+(u<<2)>>2]=y*+(d[v+(w<<1)>>1]|0)+z*+(d[v+(x<<1)>>1]|0);n[p+(u<<2)>>2]=A;u=u+1|0}while((u|0)!=(m|0));if(q){u=m;do{x=f[g+(u<<2)>>2]|0;n[t+(u<<2)>>2]=+(d[v+(x<<1)>>1]|0);n[p+(u<<2)>>2]=+(d[s+(x<<1)>>1]|0);u=u+1|0}while((u|0)!=(j|0))}}while((r|0)!=(l|0));o=l}while(0);if((o|0)>=(e|0))return;if((m|0)<=0){l=(j|0)>0;r=o;do{s=f[b+(r<<2)>>2]|0;p=f[c+(r<<2)>>2]|0;if(l){q=0;do{n[p+(q<<2)>>2]=+(d[s+(f[g+(q<<2)>>2]<<1)>>1]|0);q=q+1|0}while((q|0)!=(j|0))}r=r+1|0}while((r|0)!=(e|0));return}r=(m|0)<(j|0);l=o;do{o=f[b+(l<<2)>>2]|0;q=f[c+(l<<2)>>2]|0;s=0;do{p=f[g+(s<<2)>>2]|0;a=s<<1;n[q+(s<<2)>>2]=+(d[o+(p<<1)>>1]|0)*+n[h+(a<<2)>>2]+ +(d[o+(p+k<<1)>>1]|0)*+n[h+((a|1)<<2)>>2];s=s+1|0}while((s|0)!=(m|0));if(r){s=m;do{n[q+(s<<2)>>2]=+(d[o+(f[g+(s<<2)>>2]<<1)>>1]|0);s=s+1|0}while((s|0)!=(j|0))}l=l+1|0}while((l|0)!=(e|0));return}function Ifa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0.0,i=0.0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0;h=+n[e>>2];i=+n[e+4>>2];e=f[b>>2]|0;a=f[b+4>>2]|0;b=g+-4|0;if((g|0)<4)j=0;else{k=0;do{l=k|1;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];o=LVb(h*+n[e+(k<<2)>>2]+i*+n[a+(k<<2)>>2])|0;d[c+(k<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=LVb(m)|0;d[c+(l<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=k|2;l=k|3;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];p=LVb(h*+n[e+(o<<2)>>2]+i*+n[a+(o<<2)>>2])|0;d[c+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;p=LVb(m)|0;d[c+(l<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;k=k+4|0}while((k|0)<=(b|0));j=g&-4}if((j|0)<(g|0))q=j;else return;do{j=LVb(h*+n[e+(q<<2)>>2]+i*+n[a+(q<<2)>>2])|0;d[c+(q<<1)>>1]=(j+32768|0)>>>0<65536?j:(j|0)>0?32767:32768;q=q+1|0}while((q|0)!=(g|0));return}function Jfa(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=56908;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function Kfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56908;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Lfa(a){a=a|0;Kfa(a);O5b(a);return}function Mfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=N5b(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){Nac(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){Vac(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Nfa(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Ofa(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)P5b(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Nfa(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0;a:do if((d|0)<2)o=0;else{l=d+-1|0;h=f[b>>2]|0;a=f[c>>2]|0;if((m|0)<=0){p=(i|0)>0;q=0;r=h;s=a;while(1){q=q+1|0;t=r;r=f[b+(q<<2)>>2]|0;u=s;s=f[c+(q<<2)>>2]|0;if(p){v=0;do{w=f[e+(v<<2)>>2]|0;n[u+(v<<2)>>2]=+(j[t+(w<<1)>>1]|0);n[s+(v<<2)>>2]=+(j[r+(w<<1)>>1]|0);v=v+1|0}while((v|0)!=(i|0))}if((q|0)==(l|0)){o=l;break a}}}q=(m|0)<(i|0);r=0;s=h;p=a;do{r=r+1|0;v=s;s=f[b+(r<<2)>>2]|0;t=p;p=f[c+(r<<2)>>2]|0;u=0;do{w=f[e+(u<<2)>>2]|0;x=u<<1;y=+n[g+(x<<2)>>2];z=+n[g+((x|1)<<2)>>2];x=w+k|0;A=y*+(j[s+(w<<1)>>1]|0)+z*+(j[s+(x<<1)>>1]|0);n[t+(u<<2)>>2]=y*+(j[v+(w<<1)>>1]|0)+z*+(j[v+(x<<1)>>1]|0);n[p+(u<<2)>>2]=A;u=u+1|0}while((u|0)!=(m|0));if(q){u=m;do{x=f[e+(u<<2)>>2]|0;n[t+(u<<2)>>2]=+(j[v+(x<<1)>>1]|0);n[p+(u<<2)>>2]=+(j[s+(x<<1)>>1]|0);u=u+1|0}while((u|0)!=(i|0))}}while((r|0)!=(l|0));o=l}while(0);if((o|0)>=(d|0))return;if((m|0)<=0){l=(i|0)>0;r=o;do{s=f[b+(r<<2)>>2]|0;p=f[c+(r<<2)>>2]|0;if(l){q=0;do{n[p+(q<<2)>>2]=+(j[s+(f[e+(q<<2)>>2]<<1)>>1]|0);q=q+1|0}while((q|0)!=(i|0))}r=r+1|0}while((r|0)!=(d|0));return}r=(m|0)<(i|0);l=o;do{o=f[b+(l<<2)>>2]|0;q=f[c+(l<<2)>>2]|0;s=0;do{p=f[e+(s<<2)>>2]|0;a=s<<1;n[q+(s<<2)>>2]=+(j[o+(p<<1)>>1]|0)*+n[g+(a<<2)>>2]+ +(j[o+(p+k<<1)>>1]|0)*+n[g+((a|1)<<2)>>2];s=s+1|0}while((s|0)!=(m|0));if(r){s=m;do{n[q+(s<<2)>>2]=+(j[o+(f[e+(s<<2)>>2]<<1)>>1]|0);s=s+1|0}while((s|0)!=(i|0))}l=l+1|0}while((l|0)!=(d|0));return}function Ofa(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0.0,i=0.0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0;h=+n[e>>2];i=+n[e+4>>2];e=f[b>>2]|0;a=f[b+4>>2]|0;b=g+-4|0;if((g|0)<4)j=0;else{k=0;do{l=k|1;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];o=LVb(h*+n[e+(k<<2)>>2]+i*+n[a+(k<<2)>>2])|0;d[c+(k<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=LVb(m)|0;d[c+(l<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=k|2;l=k|3;m=h*+n[e+(l<<2)>>2]+i*+n[a+(l<<2)>>2];p=LVb(h*+n[e+(o<<2)>>2]+i*+n[a+(o<<2)>>2])|0;d[c+(o<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;p=LVb(m)|0;d[c+(l<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;k=k+4|0}while((k|0)<=(b|0));j=g&-4}if((j|0)<(g|0))q=j;else return;do{j=LVb(h*+n[e+(q<<2)>>2]+i*+n[a+(q<<2)>>2])|0;d[c+(q<<1)>>1]=j>>>0<65536?j:(j|0)>0?65535:0;q=q+1|0}while((q|0)!=(g|0));return}function Pfa(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=56928;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function Qfa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56928;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Rfa(a){a=a|0;Qfa(a);O5b(a);return}function Sfa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=N5b(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){Nac(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<1)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){Vac(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Tfa(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Ufa(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<1)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)P5b(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Tfa(a,b,c,e,g,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;a:do if((e|0)<2)o=0;else{m=e+-1|0;j=f[b>>2]|0;a=f[c>>2]|0;if((n|0)<=0){p=(k|0)>0;q=0;r=j;s=a;while(1){q=q+1|0;t=r;r=f[b+(q<<2)>>2]|0;u=s;s=f[c+(q<<2)>>2]|0;if(p){v=0;do{w=f[g+(v<<2)>>2]|0;f[u+(v<<2)>>2]=h[t+w>>0]<<11;f[s+(v<<2)>>2]=h[r+w>>0]<<11;v=v+1|0}while((v|0)!=(k|0))}if((q|0)==(m|0)){o=m;break a}}}q=(n|0)<(k|0);r=0;s=j;p=a;do{r=r+1|0;v=s;s=f[b+(r<<2)>>2]|0;t=p;p=f[c+(r<<2)>>2]|0;u=0;do{w=f[g+(u<<2)>>2]|0;x=u<<1;y=d[i+(x<<1)>>1]|0;z=d[i+((x|1)<<1)>>1]|0;x=Y(h[v+w>>0]|0,y)|0;A=w+l|0;B=(Y(h[v+A>>0]|0,z)|0)+x|0;x=Y(h[s+w>>0]|0,y)|0;y=(Y(h[s+A>>0]|0,z)|0)+x|0;f[t+(u<<2)>>2]=B;f[p+(u<<2)>>2]=y;u=u+1|0}while((u|0)!=(n|0));if(q){u=n;do{y=f[g+(u<<2)>>2]|0;f[t+(u<<2)>>2]=h[v+y>>0]<<11;f[p+(u<<2)>>2]=h[s+y>>0]<<11;u=u+1|0}while((u|0)!=(k|0))}}while((r|0)!=(m|0));o=m}while(0);if((o|0)>=(e|0))return;if((n|0)<=0){m=(k|0)>0;r=o;do{s=f[b+(r<<2)>>2]|0;p=f[c+(r<<2)>>2]|0;if(m){q=0;do{f[p+(q<<2)>>2]=h[s+(f[g+(q<<2)>>2]|0)>>0]<<11;q=q+1|0}while((q|0)!=(k|0))}r=r+1|0}while((r|0)!=(e|0));return}r=(n|0)<(k|0);m=o;do{o=f[b+(m<<2)>>2]|0;q=f[c+(m<<2)>>2]|0;s=0;do{p=f[g+(s<<2)>>2]|0;a=s<<1;j=Y(d[i+(a<<1)>>1]|0,h[o+p>>0]|0)|0;u=(Y(d[i+((a|1)<<1)>>1]|0,h[o+(p+l)>>0]|0)|0)+j|0;f[q+(s<<2)>>2]=u;s=s+1|0}while((s|0)!=(n|0));if(r){s=n;do{f[q+(s<<2)>>2]=h[o+(f[g+(s<<2)>>2]|0)>>0]<<11;s=s+1|0}while((s|0)!=(k|0))}m=m+1|0}while((m|0)!=(e|0));return}function Ufa(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=d[g>>1]|0;i=d[g+2>>1]|0;g=f[c>>2]|0;j=f[c+4>>2]|0;c=h+-4|0;if((h|0)<4)k=0;else{l=a<<16>>16;m=i<<16>>16;n=0;do{o=(Y(f[g+(n<<2)>>2]>>4,l)|0)>>>16;p=(o+2+((Y(f[j+(n<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+n>>0]=p;p=n|1;o=(Y(f[g+(p<<2)>>2]>>4,l)|0)>>>16;q=(o+2+((Y(f[j+(p<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+p>>0]=q;q=n|2;p=(Y(f[g+(q<<2)>>2]>>4,l)|0)>>>16;o=(p+2+((Y(f[j+(q<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+q>>0]=o;o=n|3;q=(Y(f[g+(o<<2)>>2]>>4,l)|0)>>>16;p=(q+2+((Y(f[j+(o<<2)>>2]>>4,m)|0)>>>16)|0)>>>2&255;b[e+o>>0]=p;n=n+4|0}while((n|0)<=(c|0));k=h&-4}if((k|0)>=(h|0))return;c=a<<16>>16;a=i<<16>>16;i=k;do{k=(Y(f[g+(i<<2)>>2]>>4,c)|0)>>>16;n=(k+2+((Y(f[j+(i<<2)>>2]>>4,a)|0)>>>16)|0)>>>2&255;b[e+i>>0]=n;i=i+1|0}while((i|0)!=(h|0));return}function Vfa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;wga(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);xga(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);xga(o);u=k;return}function Wfa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;qga(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);rga(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);rga(o);u=k;return}function Xfa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;kga(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);lga(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);lga(o);u=k;return}function Yfa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;ega(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);fga(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);fga(o);u=k;return}function Zfa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0;k=u;u=u+192|0;l=k+176|0;m=k+168|0;n=k+160|0;o=k;p=f[a+40>>2]|0;q=f[p+4>>2]|0;r=f[p>>2]|0;f[l>>2]=q;f[l+4>>2]=r;r=b+40|0;p=f[r>>2]|0;s=f[p+4>>2]|0;t=f[p>>2]|0;f[m+4>>2]=t;p=((f[a>>2]|0)>>>3&511)+1|0;v=Y(p,q)|0;f[l>>2]=v;v=Y(s,p)|0;f[m>>2]=v;v=Y(p,h)|0;h=Y(p,i)|0;f[n>>2]=0;f[n+4>>2]=t;_fa(o,a,b,c,e,d,g,l,m,j,v,h);h=f[b+4>>2]|0;if((h|0)<3){w=Y(f[b+12>>2]|0,f[b+8>>2]|0)|0;x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);$fa(o);u=k;return}b=f[r>>2]|0;r=0;v=1;while(1){j=Y(f[b+(r<<2)>>2]|0,v)|0;r=r+1|0;if((r|0)==(h|0)){w=j;break}else v=j}x=+(w>>>0);y=x*.0000152587890625;RQ(n,o,y);$fa(o);u=k;return}function _fa(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=56948;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function $fa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56948;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function aga(a){a=a|0;$fa(a);O5b(a);return}function bga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1296|0;d=c+1289|0;e=c+1288|0;g=c;h=c+1224|0;i=c+1160|0;j=c+1096|0;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>136){s=N5b(p>>>0>536870911?-1:p<<3)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){Nac(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<3)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<3;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){Vac(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))cga(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;dga(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)P5b(Q);f[g>>2]=q;f[r>>2]=136;u=c;return}function cga(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((d|0)<=0)return;a=j*3|0;m=j<<1;o=j<<2;q=0-(i<<3)|0;r=0;s=g;while(1){g=f[b+(r<<2)>>2]|0;t=f[c+(r<<2)>>2]|0;u=k;v=0;w=s;a:while(1){if((u|0)>(v|0)){x=u-v<<3;y=v;z=w;while(1){A=f[e+(y<<2)>>2]|0;B=0.0;C=0;do{D=(Y(C+-3|0,j)|0)+A|0;if(D>>>0<h>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+j|0;else{G=F;break}while(1)if((G|0)<(h|0)){E=G;break}else G=G-j|0}B=B+ +p[g+(E<<3)>>3]*+n[z+(C<<2)>>2];C=C+1|0}while((C|0)!=8);p[t+(y<<3)>>3]=B;y=y+1|0;if((y|0)==(u|0))break;else z=z+32|0}H=u;I=w+(x<<2)|0}else{H=v;I=w}if((u|0)==(i|0))break;if((H|0)<(l|0)){J=H;K=I}else{u=i;v=H;w=I;continue}while(1){z=f[e+(J<<2)>>2]|0;p[t+(J<<3)>>3]=+p[g+(z-a<<3)>>3]*+n[K>>2]+ +p[g+(z-m<<3)>>3]*+n[K+4>>2]+ +p[g+(z-j<<3)>>3]*+n[K+8>>2]+ +p[g+(z<<3)>>3]*+n[K+12>>2]+ +p[g+(z+j<<3)>>3]*+n[K+16>>2]+ +p[g+(z+m<<3)>>3]*+n[K+20>>2]+ +p[g+(z+a<<3)>>3]*+n[K+24>>2]+ +p[g+(z+o<<3)>>3]*+n[K+28>>2];z=J+1|0;y=K+32|0;if((z|0)<(l|0)){J=z;K=y}else{u=i;v=l;w=y;continue a}}}r=r+1|0;if((r|0)==(d|0))break;else s=I+(q<<2)|0}return}function dga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0,m=0.0,o=0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0;a=e+-4|0;if((e|0)<4)g=0;else{h=+n[d>>2];i=f[b>>2]|0;j=f[b+16>>2]|0;k=+n[d+4>>2];l=f[b+4>>2]|0;m=+n[d+8>>2];o=f[b+8>>2]|0;q=+n[d+12>>2];r=f[b+12>>2]|0;s=+n[d+16>>2];t=+n[d+20>>2];u=f[b+20>>2]|0;v=+n[d+24>>2];w=f[b+24>>2]|0;x=+n[d+28>>2];y=f[b+28>>2]|0;z=0;do{A=z|1;B=z|2;C=z|3;D=h*+p[i+(A<<3)>>3]+k*+p[l+(A<<3)>>3]+m*+p[o+(A<<3)>>3]+q*+p[r+(A<<3)>>3]+s*+p[j+(A<<3)>>3]+t*+p[u+(A<<3)>>3]+v*+p[w+(A<<3)>>3]+x*+p[y+(A<<3)>>3];E=h*+p[i+(B<<3)>>3]+k*+p[l+(B<<3)>>3]+m*+p[o+(B<<3)>>3]+q*+p[r+(B<<3)>>3]+s*+p[j+(B<<3)>>3]+t*+p[u+(B<<3)>>3]+v*+p[w+(B<<3)>>3]+x*+p[y+(B<<3)>>3];F=h*+p[i+(C<<3)>>3]+k*+p[l+(C<<3)>>3]+m*+p[o+(C<<3)>>3]+q*+p[r+(C<<3)>>3]+s*+p[j+(C<<3)>>3]+t*+p[u+(C<<3)>>3]+v*+p[w+(C<<3)>>3]+x*+p[y+(C<<3)>>3];p[c+(z<<3)>>3]=h*+p[i+(z<<3)>>3]+k*+p[l+(z<<3)>>3]+m*+p[o+(z<<3)>>3]+q*+p[r+(z<<3)>>3]+s*+p[j+(z<<3)>>3]+t*+p[u+(z<<3)>>3]+v*+p[w+(z<<3)>>3]+x*+p[y+(z<<3)>>3];p[c+(A<<3)>>3]=D;p[c+(B<<3)>>3]=E;p[c+(C<<3)>>3]=F;z=z+4|0}while((z|0)<=(a|0));g=e&-4}if((g|0)>=(e|0))return;a=f[b>>2]|0;x=+n[d>>2];z=f[b+4>>2]|0;v=+n[d+4>>2];y=f[b+8>>2]|0;t=+n[d+8>>2];w=f[b+12>>2]|0;s=+n[d+12>>2];u=f[b+16>>2]|0;q=+n[d+16>>2];j=f[b+20>>2]|0;m=+n[d+20>>2];r=f[b+24>>2]|0;k=+n[d+24>>2];o=f[b+28>>2]|0;h=+n[d+28>>2];d=g;do{p[c+(d<<3)>>3]=+p[a+(d<<3)>>3]*x+ +p[z+(d<<3)>>3]*v+ +p[y+(d<<3)>>3]*t+ +p[w+(d<<3)>>3]*s+ +p[u+(d<<3)>>3]*q+ +p[j+(d<<3)>>3]*m+ +p[r+(d<<3)>>3]*k+ +p[o+(d<<3)>>3]*h;d=d+1|0}while((d|0)!=(e|0));return}function ega(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=56968;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function fga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56968;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function gga(a){a=a|0;fga(a);O5b(a);return}function hga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=N5b(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){Nac(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){Vac(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))iga(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;jga(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)P5b(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function iga(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;if((d|0)<=0)return;a=j*3|0;m=j<<1;o=j<<2;p=0-(i<<3)|0;q=0;r=g;while(1){g=f[b+(q<<2)>>2]|0;s=f[c+(q<<2)>>2]|0;t=k;u=0;v=r;a:while(1){if((t|0)>(u|0)){w=t-u<<3;x=u;y=v;while(1){z=f[e+(x<<2)>>2]|0;A=0.0;B=0;do{C=(Y(B+-3|0,j)|0)+z|0;if(C>>>0<h>>>0)D=C;else{E=C;while(1)if((E|0)<0)E=E+j|0;else{F=E;break}while(1)if((F|0)<(h|0)){D=F;break}else F=F-j|0}A=A+ +n[g+(D<<2)>>2]*+n[y+(B<<2)>>2];B=B+1|0}while((B|0)!=8);n[s+(x<<2)>>2]=A;x=x+1|0;if((x|0)==(t|0))break;else y=y+32|0}G=t;H=v+(w<<2)|0}else{G=u;H=v}if((t|0)==(i|0))break;if((G|0)<(l|0)){I=G;J=H}else{t=i;u=G;v=H;continue}while(1){y=f[e+(I<<2)>>2]|0;n[s+(I<<2)>>2]=+n[g+(y-a<<2)>>2]*+n[J>>2]+ +n[g+(y-m<<2)>>2]*+n[J+4>>2]+ +n[g+(y-j<<2)>>2]*+n[J+8>>2]+ +n[g+(y<<2)>>2]*+n[J+12>>2]+ +n[g+(y+j<<2)>>2]*+n[J+16>>2]+ +n[g+(y+m<<2)>>2]*+n[J+20>>2]+ +n[g+(y+a<<2)>>2]*+n[J+24>>2]+ +n[g+(y+o<<2)>>2]*+n[J+28>>2];y=I+1|0;x=J+32|0;if((y|0)<(l|0)){I=y;J=x}else{t=i;u=l;v=x;continue a}}}q=q+1|0;if((q|0)==(d|0))break;else r=H+(p<<2)|0}return}function jga(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;a=e+-4|0;if((e|0)<4)g=0;else{h=f[b>>2]|0;i=d+4|0;j=f[b+16>>2]|0;k=f[b+20>>2]|0;l=f[b+4>>2]|0;m=d+8|0;o=f[b+8>>2]|0;p=d+12|0;q=f[b+12>>2]|0;r=d+16|0;s=d+20|0;t=d+24|0;u=f[b+24>>2]|0;v=d+28|0;w=f[b+28>>2]|0;x=0;do{y=+n[d>>2];z=x|1;A=x|2;B=x|3;C=+n[i>>2];D=+n[m>>2];E=+n[p>>2];F=+n[r>>2];G=+n[s>>2];H=+n[t>>2];I=+n[v>>2];J=y*+n[h+(z<<2)>>2]+C*+n[l+(z<<2)>>2]+D*+n[o+(z<<2)>>2]+E*+n[q+(z<<2)>>2]+F*+n[j+(z<<2)>>2]+G*+n[k+(z<<2)>>2]+H*+n[u+(z<<2)>>2]+I*+n[w+(z<<2)>>2];K=y*+n[h+(A<<2)>>2]+C*+n[l+(A<<2)>>2]+D*+n[o+(A<<2)>>2]+E*+n[q+(A<<2)>>2]+F*+n[j+(A<<2)>>2]+G*+n[k+(A<<2)>>2]+H*+n[u+(A<<2)>>2]+I*+n[w+(A<<2)>>2];L=y*+n[h+(B<<2)>>2]+C*+n[l+(B<<2)>>2]+D*+n[o+(B<<2)>>2]+E*+n[q+(B<<2)>>2]+F*+n[j+(B<<2)>>2]+G*+n[k+(B<<2)>>2]+H*+n[u+(B<<2)>>2]+I*+n[w+(B<<2)>>2];n[c+(x<<2)>>2]=y*+n[h+(x<<2)>>2]+C*+n[l+(x<<2)>>2]+D*+n[o+(x<<2)>>2]+E*+n[q+(x<<2)>>2]+F*+n[j+(x<<2)>>2]+G*+n[k+(x<<2)>>2]+H*+n[u+(x<<2)>>2]+I*+n[w+(x<<2)>>2];n[c+(z<<2)>>2]=J;n[c+(A<<2)>>2]=K;n[c+(B<<2)>>2]=L;x=x+4|0}while((x|0)<=(a|0));g=e&-4}if((g|0)>=(e|0))return;a=f[b>>2]|0;x=f[b+4>>2]|0;w=d+4|0;u=f[b+8>>2]|0;k=d+8|0;j=f[b+12>>2]|0;q=d+12|0;o=f[b+16>>2]|0;l=d+16|0;h=f[b+20>>2]|0;v=d+20|0;t=f[b+24>>2]|0;s=d+24|0;r=f[b+28>>2]|0;b=d+28|0;p=g;do{n[c+(p<<2)>>2]=+n[a+(p<<2)>>2]*+n[d>>2]+ +n[x+(p<<2)>>2]*+n[w>>2]+ +n[u+(p<<2)>>2]*+n[k>>2]+ +n[j+(p<<2)>>2]*+n[q>>2]+ +n[o+(p<<2)>>2]*+n[l>>2]+ +n[h+(p<<2)>>2]*+n[v>>2]+ +n[t+(p<<2)>>2]*+n[s>>2]+ +n[r+(p<<2)>>2]*+n[b>>2];p=p+1|0}while((p|0)!=(e|0));return}function kga(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=56988;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function lga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=56988;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function mga(a){a=a|0;lga(a);O5b(a);return}function nga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=N5b(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){Nac(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){Vac(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))oga(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;pga(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)P5b(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function oga(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((e|0)<=0)return;a=k*3|0;o=k<<1;p=k<<2;q=0-(j<<3)|0;r=0;s=h;while(1){h=f[b+(r<<2)>>2]|0;t=f[c+(r<<2)>>2]|0;u=l;v=0;w=s;a:while(1){if((u|0)>(v|0)){x=u-v<<3;y=v;z=w;while(1){A=f[g+(y<<2)>>2]|0;B=0.0;C=0;do{D=(Y(C+-3|0,k)|0)+A|0;if(D>>>0<i>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+k|0;else{G=F;break}while(1)if((G|0)<(i|0)){E=G;break}else G=G-k|0}B=B+ +(d[h+(E<<1)>>1]|0)*+n[z+(C<<2)>>2];C=C+1|0}while((C|0)!=8);n[t+(y<<2)>>2]=B;y=y+1|0;if((y|0)==(u|0))break;else z=z+32|0}H=u;I=w+(x<<2)|0}else{H=v;I=w}if((u|0)==(j|0))break;if((H|0)<(m|0)){J=H;K=I}else{u=j;v=H;w=I;continue}while(1){z=f[g+(J<<2)>>2]|0;n[t+(J<<2)>>2]=+(d[h+(z-a<<1)>>1]|0)*+n[K>>2]+ +(d[h+(z-o<<1)>>1]|0)*+n[K+4>>2]+ +(d[h+(z-k<<1)>>1]|0)*+n[K+8>>2]+ +(d[h+(z<<1)>>1]|0)*+n[K+12>>2]+ +(d[h+(z+k<<1)>>1]|0)*+n[K+16>>2]+ +(d[h+(z+o<<1)>>1]|0)*+n[K+20>>2]+ +(d[h+(z+a<<1)>>1]|0)*+n[K+24>>2]+ +(d[h+(z+p<<1)>>1]|0)*+n[K+28>>2];z=J+1|0;y=K+32|0;if((z|0)<(m|0)){J=z;K=y}else{u=j;v=m;w=y;continue a}}}r=r+1|0;if((r|0)==(e|0))break;else s=I+(q<<2)|0}return}function pga(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0;a=g+-4|0;if((g|0)<4)h=0;else{i=+n[e>>2];j=f[b>>2]|0;k=+n[e+20>>2];l=f[b+20>>2]|0;m=+n[e+4>>2];o=f[b+4>>2]|0;p=+n[e+8>>2];q=f[b+8>>2]|0;r=+n[e+12>>2];s=f[b+12>>2]|0;t=+n[e+16>>2];u=f[b+16>>2]|0;v=+n[e+24>>2];w=f[b+24>>2]|0;x=+n[e+28>>2];y=f[b+28>>2]|0;z=0;do{A=z|1;B=z|2;C=z|3;D=i*+n[j+(A<<2)>>2]+m*+n[o+(A<<2)>>2]+p*+n[q+(A<<2)>>2]+r*+n[s+(A<<2)>>2]+t*+n[u+(A<<2)>>2]+k*+n[l+(A<<2)>>2]+v*+n[w+(A<<2)>>2]+x*+n[y+(A<<2)>>2];E=i*+n[j+(B<<2)>>2]+m*+n[o+(B<<2)>>2]+p*+n[q+(B<<2)>>2]+r*+n[s+(B<<2)>>2]+t*+n[u+(B<<2)>>2]+k*+n[l+(B<<2)>>2]+v*+n[w+(B<<2)>>2]+x*+n[y+(B<<2)>>2];F=i*+n[j+(C<<2)>>2]+m*+n[o+(C<<2)>>2]+p*+n[q+(C<<2)>>2]+r*+n[s+(C<<2)>>2]+t*+n[u+(C<<2)>>2]+k*+n[l+(C<<2)>>2]+v*+n[w+(C<<2)>>2]+x*+n[y+(C<<2)>>2];G=LVb(i*+n[j+(z<<2)>>2]+m*+n[o+(z<<2)>>2]+p*+n[q+(z<<2)>>2]+r*+n[s+(z<<2)>>2]+t*+n[u+(z<<2)>>2]+k*+n[l+(z<<2)>>2]+v*+n[w+(z<<2)>>2]+x*+n[y+(z<<2)>>2])|0;d[c+(z<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;G=LVb(D)|0;d[c+(A<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;G=LVb(E)|0;d[c+(B<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;G=LVb(F)|0;d[c+(C<<1)>>1]=(G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768;z=z+4|0}while((z|0)<=(a|0));h=g&-4}if((h|0)>=(g|0))return;a=f[b>>2]|0;x=+n[e>>2];z=f[b+4>>2]|0;v=+n[e+4>>2];y=f[b+8>>2]|0;k=+n[e+8>>2];w=f[b+12>>2]|0;t=+n[e+12>>2];l=f[b+16>>2]|0;r=+n[e+16>>2];u=f[b+20>>2]|0;p=+n[e+20>>2];s=f[b+24>>2]|0;m=+n[e+24>>2];q=f[b+28>>2]|0;i=+n[e+28>>2];e=h;do{h=LVb(+n[a+(e<<2)>>2]*x+ +n[z+(e<<2)>>2]*v+ +n[y+(e<<2)>>2]*k+ +n[w+(e<<2)>>2]*t+ +n[l+(e<<2)>>2]*r+ +n[u+(e<<2)>>2]*p+ +n[s+(e<<2)>>2]*m+ +n[q+(e<<2)>>2]*i)|0;d[c+(e<<1)>>1]=(h+32768|0)>>>0<65536?h:(h|0)>0?32767:32768;e=e+1|0}while((e|0)!=(g|0));return}function qga(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=57008;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function rga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57008;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function sga(a){a=a|0;rga(a);O5b(a);return}function tga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=N5b(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){Nac(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<2)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){Vac(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))uga(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;vga(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<2)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)P5b(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function uga(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((d|0)<=0)return;a=k*3|0;o=k<<1;p=k<<2;q=0-(i<<3)|0;r=0;s=g;while(1){g=f[b+(r<<2)>>2]|0;t=f[c+(r<<2)>>2]|0;u=l;v=0;w=s;a:while(1){if((u|0)>(v|0)){x=u-v<<3;y=v;z=w;while(1){A=f[e+(y<<2)>>2]|0;B=0.0;C=0;do{D=(Y(C+-3|0,k)|0)+A|0;if(D>>>0<h>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+k|0;else{G=F;break}while(1)if((G|0)<(h|0)){E=G;break}else G=G-k|0}B=B+ +(j[g+(E<<1)>>1]|0)*+n[z+(C<<2)>>2];C=C+1|0}while((C|0)!=8);n[t+(y<<2)>>2]=B;y=y+1|0;if((y|0)==(u|0))break;else z=z+32|0}H=u;I=w+(x<<2)|0}else{H=v;I=w}if((u|0)==(i|0))break;if((H|0)<(m|0)){J=H;K=I}else{u=i;v=H;w=I;continue}while(1){z=f[e+(J<<2)>>2]|0;n[t+(J<<2)>>2]=+(j[g+(z-a<<1)>>1]|0)*+n[K>>2]+ +(j[g+(z-o<<1)>>1]|0)*+n[K+4>>2]+ +(j[g+(z-k<<1)>>1]|0)*+n[K+8>>2]+ +(j[g+(z<<1)>>1]|0)*+n[K+12>>2]+ +(j[g+(z+k<<1)>>1]|0)*+n[K+16>>2]+ +(j[g+(z+o<<1)>>1]|0)*+n[K+20>>2]+ +(j[g+(z+a<<1)>>1]|0)*+n[K+24>>2]+ +(j[g+(z+p<<1)>>1]|0)*+n[K+28>>2];z=J+1|0;y=K+32|0;if((z|0)<(m|0)){J=z;K=y}else{u=i;v=m;w=y;continue a}}}r=r+1|0;if((r|0)==(d|0))break;else s=I+(q<<2)|0}return}function vga(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0.0,l=0,m=0.0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0,v=0.0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0;a=g+-4|0;if((g|0)<4)h=0;else{i=+n[e>>2];j=f[b>>2]|0;k=+n[e+20>>2];l=f[b+20>>2]|0;m=+n[e+4>>2];o=f[b+4>>2]|0;p=+n[e+8>>2];q=f[b+8>>2]|0;r=+n[e+12>>2];s=f[b+12>>2]|0;t=+n[e+16>>2];u=f[b+16>>2]|0;v=+n[e+24>>2];w=f[b+24>>2]|0;x=+n[e+28>>2];y=f[b+28>>2]|0;z=0;do{A=z|1;B=z|2;C=z|3;D=i*+n[j+(A<<2)>>2]+m*+n[o+(A<<2)>>2]+p*+n[q+(A<<2)>>2]+r*+n[s+(A<<2)>>2]+t*+n[u+(A<<2)>>2]+k*+n[l+(A<<2)>>2]+v*+n[w+(A<<2)>>2]+x*+n[y+(A<<2)>>2];E=i*+n[j+(B<<2)>>2]+m*+n[o+(B<<2)>>2]+p*+n[q+(B<<2)>>2]+r*+n[s+(B<<2)>>2]+t*+n[u+(B<<2)>>2]+k*+n[l+(B<<2)>>2]+v*+n[w+(B<<2)>>2]+x*+n[y+(B<<2)>>2];F=i*+n[j+(C<<2)>>2]+m*+n[o+(C<<2)>>2]+p*+n[q+(C<<2)>>2]+r*+n[s+(C<<2)>>2]+t*+n[u+(C<<2)>>2]+k*+n[l+(C<<2)>>2]+v*+n[w+(C<<2)>>2]+x*+n[y+(C<<2)>>2];G=LVb(i*+n[j+(z<<2)>>2]+m*+n[o+(z<<2)>>2]+p*+n[q+(z<<2)>>2]+r*+n[s+(z<<2)>>2]+t*+n[u+(z<<2)>>2]+k*+n[l+(z<<2)>>2]+v*+n[w+(z<<2)>>2]+x*+n[y+(z<<2)>>2])|0;d[c+(z<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;G=LVb(D)|0;d[c+(A<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;G=LVb(E)|0;d[c+(B<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;G=LVb(F)|0;d[c+(C<<1)>>1]=G>>>0<65536?G:(G|0)>0?65535:0;z=z+4|0}while((z|0)<=(a|0));h=g&-4}if((h|0)>=(g|0))return;a=f[b>>2]|0;x=+n[e>>2];z=f[b+4>>2]|0;v=+n[e+4>>2];y=f[b+8>>2]|0;k=+n[e+8>>2];w=f[b+12>>2]|0;t=+n[e+12>>2];l=f[b+16>>2]|0;r=+n[e+16>>2];u=f[b+20>>2]|0;p=+n[e+20>>2];s=f[b+24>>2]|0;m=+n[e+24>>2];q=f[b+28>>2]|0;i=+n[e+28>>2];e=h;do{h=LVb(+n[a+(e<<2)>>2]*x+ +n[z+(e<<2)>>2]*v+ +n[y+(e<<2)>>2]*k+ +n[w+(e<<2)>>2]*t+ +n[l+(e<<2)>>2]*r+ +n[u+(e<<2)>>2]*p+ +n[s+(e<<2)>>2]*m+ +n[q+(e<<2)>>2]*i)|0;d[c+(e<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;e=e+1|0}while((e|0)!=(g|0));return}function wga(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+16|0;p=o;f[a>>2]=57028;q=a+4|0;f[q>>2]=f[c>>2];r=a+8|0;s=c+4|0;f[r>>2]=f[s>>2];t=a+12|0;f[t>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[a+40>>2]=v;f[a+44>>2]=t;t=a+52|0;w=a+48|0;f[w>>2]=t;f[t>>2]=0;f[a+56>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[c+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2]}else{f[r>>2]=0;jL(q,c)}c=a+60|0;f[c>>2]=f[d>>2];q=a+64|0;r=d+4|0;f[q>>2]=f[r>>2];s=a+68|0;f[s>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];t=f[d+36>>2]|0;f[a+96>>2]=t;f[a+100>>2]=s;s=a+108|0;w=a+104|0;f[w>>2]=s;f[s>>2]=0;f[a+112>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[d+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2]}else{f[q>>2]=0;jL(c,d)}f[a+116>>2]=e;f[a+120>>2]=g;f[a+124>>2]=h;f[a+128>>2]=i;f[a+132>>2]=f[j>>2];f[a+136>>2]=f[j+4>>2];f[a+140>>2]=f[k>>2];f[a+144>>2]=f[k+4>>2];f[a+148>>2]=l;f[a+152>>2]=m;f[a+156>>2]=n;if((l|0)<17){u=o;return}f[p>>2]=0;f[p+4>>2]=0;l=aD(p,18)|0;n=256029;a=l+18|0;do{b[l>>0]=b[n>>0]|0;l=l+1|0;n=n+1|0}while((l|0)<(a|0));bO(-215,p,256048,255802,2211);bD(p);u=o;return}function xga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57028;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function yga(a){a=a|0;xga(a);O5b(a);return}function zga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+1264|0;d=c+1257|0;e=c+1256|0;g=c+192|0;h=c+128|0;i=c+64|0;j=c;k=((f[a+4>>2]|0)>>>3&511)+1|0;l=a+140|0;m=(f[l>>2]|0)+15&-16;n=a+148|0;o=f[n>>2]|0;p=Y(m,o)|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=N5b(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=h;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));s=i;p=s+64|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(p|0));if((o|0)>0){Nac(j|0,-1,o<<2|0)|0;s=0;do{p=t+((Y(s,m)|0)<<2)|0;f[i+(s<<2)>>2]=p;s=s+1|0}while((s|0)<(o|0))}s=f[b>>2]|0;p=b+4|0;if((s|0)<(f[p>>2]|0)){b=a+120|0;v=a+116|0;w=a+124|0;x=a+132|0;y=a+152|0;z=a+156|0;A=a+76|0;B=a+108|0;C=a+136|0;D=a+20|0;E=a+48|0;F=m<<2;m=(f[a+128>>2]|0)+((Y(s,o)|0)<<1)|0;a=s;s=o;while(1){if((s|0)>0){o=(f[(f[b>>2]|0)+(a<<2)>>2]|0)+1+((s|0)/-2|0)|0;G=s;H=0;I=s;J=0;while(1){K=o+J|0;L=f[C>>2]|0;M=(K|0)>-1?((K|0)<(L|0)?K:L+-1|0):0;L=(H|0)<(J|0)?J:H;a:do if((L|0)<(I|0)){K=L;while(1){if((K|0)<16?(M|0)==(f[j+(K<<2)>>2]|0):0)break;N=K+1|0;if((N|0)<(I|0))K=N;else{O=I;P=N;break a}}if((K|0)>(J|0)){Vac(f[i+(J<<2)>>2]|0,f[i+(K<<2)>>2]|0,F|0)|0;O=f[n>>2]|0;P=K}else{O=I;P=K}}else{O=I;P=L}while(0);G=(J|0)<(G|0)&(P|0)==(O|0)?J:G;L=(f[D>>2]|0)+(Y(f[f[E>>2]>>2]|0,M)|0)|0;f[h+(J<<2)>>2]=L;f[j+(J<<2)>>2]=M;J=J+1|0;if((J|0)>=(O|0))break;else{H=P;I=O}}if((O|0)>(G|0))Aga(d,h+(G<<2)|0,i+(G<<2)|0,O-G|0,f[v>>2]|0,f[w>>2]|0,f[x>>2]|0,f[l>>2]|0,k,f[y>>2]|0,f[z>>2]|0)}I=(f[A>>2]|0)+(Y(f[B>>2]|0,a)|0)|0;Bga(e,i,I,m,f[l>>2]|0);a=a+1|0;I=f[n>>2]|0;if((a|0)>=(f[p>>2]|0))break;else{m=m+(I<<1)|0;s=I}}Q=f[g>>2]|0}else Q=t;if((Q|0)==(q|0)){u=c;return}if(Q|0)P5b(Q);f[g>>2]=q;f[r>>2]=264;u=c;return}function Aga(a,b,c,e,g,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;if((e|0)<=0)return;a=l*3|0;o=l<<1;p=l<<2;q=0-(k<<3)|0;r=0;s=i;while(1){i=f[b+(r<<2)>>2]|0;t=f[c+(r<<2)>>2]|0;u=m;v=0;w=s;a:while(1){if((u|0)>(v|0)){x=u-v<<3;y=v;z=w;while(1){A=f[g+(y<<2)>>2]|0;B=0;C=0;do{D=(Y(C+-3|0,l)|0)+A|0;if(D>>>0<j>>>0)E=D;else{F=D;while(1)if((F|0)<0)F=F+l|0;else{G=F;break}while(1)if((G|0)<(j|0)){E=G;break}else G=G-l|0}B=(Y(d[z+(C<<1)>>1]|0,h[i+E>>0]|0)|0)+B|0;C=C+1|0}while((C|0)!=8);f[t+(y<<2)>>2]=B;y=y+1|0;if((y|0)==(u|0))break;else z=z+16|0}H=u;I=w+(x<<1)|0}else{H=v;I=w}if((u|0)==(k|0))break;if((H|0)<(n|0)){J=H;K=I}else{u=k;v=H;w=I;continue}while(1){z=f[g+(J<<2)>>2]|0;y=Y(d[K>>1]|0,h[i+(z-a)>>0]|0)|0;C=(Y(d[K+2>>1]|0,h[i+(z-o)>>0]|0)|0)+y|0;y=C+(Y(d[K+4>>1]|0,h[i+(z-l)>>0]|0)|0)|0;C=y+(Y(d[K+6>>1]|0,h[i+z>>0]|0)|0)|0;y=C+(Y(d[K+8>>1]|0,h[i+(z+l)>>0]|0)|0)|0;C=y+(Y(d[K+10>>1]|0,h[i+(z+o)>>0]|0)|0)|0;y=C+(Y(d[K+12>>1]|0,h[i+(z+a)>>0]|0)|0)|0;C=y+(Y(d[K+14>>1]|0,h[i+(z+p)>>0]|0)|0)|0;f[t+(J<<2)>>2]=C;C=J+1|0;z=K+16|0;if((C|0)<(n|0)){J=C;K=z}else{u=k;v=n;w=z;continue a}}}r=r+1|0;if((r|0)==(e|0))break;else s=I+(q<<1)|0}return}function Bga(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;a=h+-4|0;if((h|0)<4)i=0;else{j=g+2|0;k=c+4|0;l=g+4|0;m=c+8|0;n=g+6|0;o=c+12|0;p=g+8|0;q=c+16|0;r=g+10|0;s=c+20|0;t=g+12|0;u=c+24|0;v=g+14|0;w=c+28|0;x=0;do{y=d[g>>1]|0;z=f[c>>2]|0;A=Y(f[z+(x<<2)>>2]|0,y)|0;B=x|1;C=Y(f[z+(B<<2)>>2]|0,y)|0;D=x|2;E=Y(f[z+(D<<2)>>2]|0,y)|0;F=x|3;G=Y(f[z+(F<<2)>>2]|0,y)|0;y=d[j>>1]|0;z=f[k>>2]|0;H=(Y(f[z+(x<<2)>>2]|0,y)|0)+A|0;A=(Y(f[z+(B<<2)>>2]|0,y)|0)+C|0;C=(Y(f[z+(D<<2)>>2]|0,y)|0)+E|0;E=(Y(f[z+(F<<2)>>2]|0,y)|0)+G|0;G=d[l>>1]|0;y=f[m>>2]|0;z=(Y(f[y+(x<<2)>>2]|0,G)|0)+H|0;H=(Y(f[y+(B<<2)>>2]|0,G)|0)+A|0;A=(Y(f[y+(D<<2)>>2]|0,G)|0)+C|0;C=(Y(f[y+(F<<2)>>2]|0,G)|0)+E|0;E=d[n>>1]|0;G=f[o>>2]|0;y=(Y(f[G+(x<<2)>>2]|0,E)|0)+z|0;z=(Y(f[G+(B<<2)>>2]|0,E)|0)+H|0;H=(Y(f[G+(D<<2)>>2]|0,E)|0)+A|0;A=(Y(f[G+(F<<2)>>2]|0,E)|0)+C|0;C=d[p>>1]|0;E=f[q>>2]|0;G=(Y(f[E+(x<<2)>>2]|0,C)|0)+y|0;y=(Y(f[E+(B<<2)>>2]|0,C)|0)+z|0;z=(Y(f[E+(D<<2)>>2]|0,C)|0)+H|0;H=(Y(f[E+(F<<2)>>2]|0,C)|0)+A|0;A=d[r>>1]|0;C=f[s>>2]|0;E=(Y(f[C+(x<<2)>>2]|0,A)|0)+G|0;G=(Y(f[C+(B<<2)>>2]|0,A)|0)+y|0;y=(Y(f[C+(D<<2)>>2]|0,A)|0)+z|0;z=(Y(f[C+(F<<2)>>2]|0,A)|0)+H|0;H=d[t>>1]|0;A=f[u>>2]|0;C=(Y(f[A+(x<<2)>>2]|0,H)|0)+E|0;E=(Y(f[A+(B<<2)>>2]|0,H)|0)+G|0;G=(Y(f[A+(D<<2)>>2]|0,H)|0)+y|0;y=(Y(f[A+(F<<2)>>2]|0,H)|0)+z|0;z=d[v>>1]|0;H=f[w>>2]|0;A=(Y(f[H+(x<<2)>>2]|0,z)|0)+C|0;C=(Y(f[H+(B<<2)>>2]|0,z)|0)+E|0;E=(Y(f[H+(D<<2)>>2]|0,z)|0)+G|0;G=(Y(f[H+(F<<2)>>2]|0,z)|0)+y|0;y=A+2097152>>22;b[e+x>>0]=y>>>0<256?y:(y|0)>0?255:0;y=C+2097152>>22;b[e+B>>0]=y>>>0<256?y:(y|0)>0?255:0;y=E+2097152>>22;b[e+D>>0]=y>>>0<256?y:(y|0)>0?255:0;y=G+2097152>>22;b[e+F>>0]=y>>>0<256?y:(y|0)>0?255:0;x=x+4|0}while((x|0)<=(a|0));i=h&-4}if((i|0)>=(h|0))return;a=c+4|0;x=g+2|0;w=c+8|0;v=g+4|0;u=c+12|0;t=g+6|0;s=c+16|0;r=g+8|0;q=c+20|0;p=g+10|0;o=c+24|0;n=g+12|0;m=c+28|0;l=g+14|0;k=i;do{i=Y(d[g>>1]|0,f[(f[c>>2]|0)+(k<<2)>>2]|0)|0;j=Y(d[x>>1]|0,f[(f[a>>2]|0)+(k<<2)>>2]|0)|0;y=Y(d[v>>1]|0,f[(f[w>>2]|0)+(k<<2)>>2]|0)|0;F=Y(d[t>>1]|0,f[(f[u>>2]|0)+(k<<2)>>2]|0)|0;G=Y(d[r>>1]|0,f[(f[s>>2]|0)+(k<<2)>>2]|0)|0;D=Y(d[p>>1]|0,f[(f[q>>2]|0)+(k<<2)>>2]|0)|0;E=Y(d[n>>1]|0,f[(f[o>>2]|0)+(k<<2)>>2]|0)|0;B=i+2097152+j+y+F+G+D+E+(Y(d[l>>1]|0,f[(f[m>>2]|0)+(k<<2)>>2]|0)|0)>>22;b[e+k>>0]=B>>>0<256?B:(B|0)>0?255:0;k=k+1|0}while((k|0)!=(h|0));return}function Cga(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=57128;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;RQ(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;RQ(j,k,o);u=i;return}function Dga(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=57108;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;RQ(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;RQ(j,k,o);u=i;return}function Ega(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=57088;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;RQ(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;RQ(j,k,o);u=i;return}function Fga(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=57068;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;RQ(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;RQ(j,k,o);u=i;return}function Gga(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;i=u;u=u+48|0;j=i+32|0;k=i;l=f[b+8>>2]|0;f[j>>2]=0;f[j+4>>2]=l;f[k>>2]=57048;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+20>>2]=d;f[k+16>>2]=e;f[k+24>>2]=g;f[k+28>>2]=h;h=f[b+4>>2]|0;if((h|0)<3){m=Y(f[b+12>>2]|0,l)|0;n=+(m>>>0);o=n*.0000152587890625;RQ(j,k,o);u=i;return}l=f[b+40>>2]|0;b=0;g=1;while(1){e=Y(f[l+(b<<2)>>2]|0,g)|0;b=b+1|0;if((b|0)==(h|0)){m=e;break}else g=e}n=+(m>>>0);o=n*.0000152587890625;RQ(j,k,o);u=i;return}function Hga(a){a=a|0;O5b(a);return}function Iga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0;c=u;u=u+1104|0;d=c;e=a+8|0;g=f[e>>2]|0;h=(f[g>>2]|0)>>>3;i=(h&511)+1|0;j=Y(i,f[(f[g+40>>2]|0)+4>>2]|0)|0;g=j<<1;k=d+8|0;f[d>>2]=k;l=d+4|0;f[l>>2]=g;if(g>>>0>136){m=N5b(g>>>0>536870911?-1:g<<3)|0;f[d>>2]=m;o=m}else o=k;m=f[a+12>>2]|0;g=f[a+20>>2]|0;q=o+(j<<3)|0;r=f[a+28>>2]|0;s=f[r+(f[b>>2]<<2)>>2]|0;t=f[r+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;r=f[(f[b>>2]|0)+(s*12|0)+4>>2]|0;v=(j|0)>0;if(v)Nac(q|0,0,j<<3|0)|0;a:do if((s|0)<(t|0)){w=f[b>>2]|0;x=f[a+4>>2]|0;y=f[x+16>>2]|0;z=f[f[x+44>>2]>>2]|0;x=h&65535;A=(g|0)>0;B=j<<3;C=r;D=s;while(1){E=+n[w+(D*12|0)+8>>2];F=f[w+(D*12|0)+4>>2]|0;G=y+(Y(z,f[w+(D*12|0)>>2]|0)|0)|0;if(v)Nac(o|0,0,B|0)|0;switch(x&511){case 0:{if(A){H=0;do{I=o+(f[m+(H*12|0)+4>>2]<<3)|0;p[I>>3]=+p[I>>3]+ +n[m+(H*12|0)+8>>2]*+p[G+(f[m+(H*12|0)>>2]<<3)>>3];H=H+1|0}while((H|0)!=(g|0))}break}case 1:{if(A){H=0;do{I=f[m+(H*12|0)>>2]|0;J=f[m+(H*12|0)+4>>2]|0;K=+n[m+(H*12|0)+8>>2];L=o+(J<<3)|0;M=o+(J+1<<3)|0;N=+p[M>>3]+K*+p[G+(I+1<<3)>>3];p[L>>3]=+p[L>>3]+K*+p[G+(I<<3)>>3];p[M>>3]=N;H=H+1|0}while((H|0)!=(g|0))}break}case 2:{if(A){H=0;do{M=f[m+(H*12|0)>>2]|0;I=f[m+(H*12|0)+4>>2]|0;N=+n[m+(H*12|0)+8>>2];L=o+(I<<3)|0;J=o+(I+1<<3)|0;K=+p[J>>3]+N*+p[G+(M+1<<3)>>3];O=o+(I+2<<3)|0;P=+p[O>>3]+N*+p[G+(M+2<<3)>>3];p[L>>3]=+p[L>>3]+N*+p[G+(M<<3)>>3];p[J>>3]=K;p[O>>3]=P;H=H+1|0}while((H|0)!=(g|0))}break}case 3:{if(A){H=0;do{O=f[m+(H*12|0)>>2]|0;J=f[m+(H*12|0)+4>>2]|0;P=+n[m+(H*12|0)+8>>2];M=o+(J<<3)|0;L=o+(J+1<<3)|0;K=+p[L>>3]+P*+p[G+(O+1<<3)>>3];p[M>>3]=+p[M>>3]+P*+p[G+(O<<3)>>3];p[L>>3]=K;L=o+(J+2<<3)|0;M=o+(J+3<<3)|0;K=+p[M>>3]+P*+p[G+(O+3<<3)>>3];p[L>>3]=+p[L>>3]+P*+p[G+(O+2<<3)>>3];p[M>>3]=K;H=H+1|0}while((H|0)!=(g|0))}break}default:if(A){H=0;do{M=f[m+(H*12|0)>>2]|0;O=f[m+(H*12|0)+4>>2]|0;K=+n[m+(H*12|0)+8>>2];L=0;do{J=o+(L+O<<3)|0;p[J>>3]=+p[J>>3]+K*+p[G+(L+M<<3)>>3];L=L+1|0}while((L|0)!=(i|0));H=H+1|0}while((H|0)!=(g|0))}}if((F|0)==(C|0))if(v){H=0;do{G=q+(H<<3)|0;p[G>>3]=+p[G>>3]+E*+p[o+(H<<3)>>3];H=H+1|0}while((H|0)!=(j|0));Q=C}else Q=C;else{H=f[e>>2]|0;G=(f[H+16>>2]|0)+(Y(f[f[H+44>>2]>>2]|0,C)|0)|0;if(v){H=0;do{L=q+(H<<3)|0;p[G+(H<<3)>>3]=+p[L>>3];p[L>>3]=E*+p[o+(H<<3)>>3];H=H+1|0}while((H|0)!=(j|0));Q=F}else Q=F}D=D+1|0;if((D|0)==(t|0)){R=Q;break a}else C=Q}}else R=r;while(0);r=f[e>>2]|0;e=(f[r+16>>2]|0)+(Y(f[f[r+44>>2]>>2]|0,R)|0)|0;if(v){v=0;do{p[e+(v<<3)>>3]=+p[q+(v<<3)>>3];v=v+1|0}while((v|0)!=(j|0))}j=f[d>>2]|0;if((j|0)==(k|0)){u=c;return}if(j|0)P5b(j);f[d>>2]=k;f[l>>2]=136;u=c;return}function Jga(a){a=a|0;O5b(a);return}function Kga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0.0,P=0,Q=0;c=u;u=u+1072|0;d=c;e=a+8|0;g=f[e>>2]|0;h=(f[g>>2]|0)>>>3;i=(h&511)+1|0;j=Y(i,f[(f[g+40>>2]|0)+4>>2]|0)|0;g=j<<1;k=d+8|0;f[d>>2]=k;l=d+4|0;f[l>>2]=g;if(g>>>0>264){m=N5b(g>>>0>1073741823?-1:g<<2)|0;f[d>>2]=m;o=m}else o=k;m=f[a+12>>2]|0;g=f[a+20>>2]|0;p=o+(j<<2)|0;q=f[a+28>>2]|0;r=f[q+(f[b>>2]<<2)>>2]|0;s=f[q+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;q=f[(f[b>>2]|0)+(r*12|0)+4>>2]|0;t=(j|0)>0;if(t)Nac(p|0,0,j<<2|0)|0;a:do if((r|0)<(s|0)){v=f[b>>2]|0;w=f[a+4>>2]|0;x=f[w+16>>2]|0;y=f[f[w+44>>2]>>2]|0;w=h&65535;z=(g|0)>0;A=j<<2;B=q;C=r;while(1){D=+n[v+(C*12|0)+8>>2];E=f[v+(C*12|0)+4>>2]|0;F=x+(Y(y,f[v+(C*12|0)>>2]|0)|0)|0;if(t)Nac(o|0,0,A|0)|0;switch(w&511){case 0:{if(z){G=0;do{H=o+(f[m+(G*12|0)+4>>2]<<2)|0;n[H>>2]=+n[H>>2]+ +n[m+(G*12|0)+8>>2]*+n[F+(f[m+(G*12|0)>>2]<<2)>>2];G=G+1|0}while((G|0)!=(g|0))}break}case 1:{if(z){G=0;do{H=f[m+(G*12|0)>>2]|0;I=f[m+(G*12|0)+4>>2]|0;J=+n[m+(G*12|0)+8>>2];K=o+(I<<2)|0;L=o+(I+1<<2)|0;M=+n[L>>2]+J*+n[F+(H+1<<2)>>2];n[K>>2]=+n[K>>2]+J*+n[F+(H<<2)>>2];n[L>>2]=M;G=G+1|0}while((G|0)!=(g|0))}break}case 2:{if(z){G=0;do{L=f[m+(G*12|0)>>2]|0;H=f[m+(G*12|0)+4>>2]|0;M=+n[m+(G*12|0)+8>>2];K=o+(H<<2)|0;I=o+(H+1<<2)|0;J=+n[I>>2]+M*+n[F+(L+1<<2)>>2];N=o+(H+2<<2)|0;O=+n[N>>2]+M*+n[F+(L+2<<2)>>2];n[K>>2]=+n[K>>2]+M*+n[F+(L<<2)>>2];n[I>>2]=J;n[N>>2]=O;G=G+1|0}while((G|0)!=(g|0))}break}case 3:{if(z){G=0;do{N=f[m+(G*12|0)>>2]|0;I=f[m+(G*12|0)+4>>2]|0;O=+n[m+(G*12|0)+8>>2];L=o+(I<<2)|0;K=o+(I+1<<2)|0;J=+n[K>>2]+O*+n[F+(N+1<<2)>>2];n[L>>2]=+n[L>>2]+O*+n[F+(N<<2)>>2];n[K>>2]=J;K=o+(I+2<<2)|0;L=o+(I+3<<2)|0;J=+n[L>>2]+O*+n[F+(N+3<<2)>>2];n[K>>2]=+n[K>>2]+O*+n[F+(N+2<<2)>>2];n[L>>2]=J;G=G+1|0}while((G|0)!=(g|0))}break}default:if(z){G=0;do{L=f[m+(G*12|0)>>2]|0;N=f[m+(G*12|0)+4>>2]|0;J=+n[m+(G*12|0)+8>>2];K=0;do{I=o+(K+N<<2)|0;n[I>>2]=+n[I>>2]+J*+n[F+(K+L<<2)>>2];K=K+1|0}while((K|0)!=(i|0));G=G+1|0}while((G|0)!=(g|0))}}if((E|0)==(B|0))if(t){G=0;do{F=p+(G<<2)|0;n[F>>2]=+n[F>>2]+D*+n[o+(G<<2)>>2];G=G+1|0}while((G|0)!=(j|0));P=B}else P=B;else{G=f[e>>2]|0;F=(f[G+16>>2]|0)+(Y(f[f[G+44>>2]>>2]|0,B)|0)|0;if(t){G=0;do{K=p+(G<<2)|0;f[F+(G<<2)>>2]=f[K>>2];n[K>>2]=D*+n[o+(G<<2)>>2];G=G+1|0}while((G|0)!=(j|0));P=E}else P=E}C=C+1|0;if((C|0)==(s|0)){Q=P;break a}else B=P}}else Q=q;while(0);q=f[e>>2]|0;e=(f[q+16>>2]|0)+(Y(f[f[q+44>>2]>>2]|0,Q)|0)|0;if(t){t=0;do{f[e+(t<<2)>>2]=f[p+(t<<2)>>2];t=t+1|0}while((t|0)!=(j|0))}j=f[d>>2]|0;if((j|0)==(k|0)){u=c;return}if(j|0)P5b(j);f[d>>2]=k;f[l>>2]=264;u=c;return}function Lga(a){a=a|0;O5b(a);return}function Mga(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0;c=u;u=u+1072|0;e=c;g=a+8|0;h=f[g>>2]|0;i=(f[h>>2]|0)>>>3;j=(i&511)+1|0;k=Y(j,f[(f[h+40>>2]|0)+4>>2]|0)|0;h=k<<1;l=e+8|0;f[e>>2]=l;m=e+4|0;f[m>>2]=h;if(h>>>0>264){o=N5b(h>>>0>1073741823?-1:h<<2)|0;f[e>>2]=o;p=o}else p=l;o=f[a+12>>2]|0;h=f[a+20>>2]|0;q=p+(k<<2)|0;r=f[a+28>>2]|0;s=f[r+(f[b>>2]<<2)>>2]|0;t=f[r+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;r=f[(f[b>>2]|0)+(s*12|0)+4>>2]|0;v=(k|0)>0;if(v)Nac(q|0,0,k<<2|0)|0;a:do if((s|0)<(t|0)){w=f[b>>2]|0;x=f[a+4>>2]|0;y=f[x+16>>2]|0;z=f[f[x+44>>2]>>2]|0;x=i&65535;A=(h|0)>0;B=k<<2;C=s;D=r;while(1){E=+n[w+(C*12|0)+8>>2];F=f[w+(C*12|0)+4>>2]|0;G=y+(Y(z,f[w+(C*12|0)>>2]|0)|0)|0;if(v)Nac(p|0,0,B|0)|0;switch(x&511){case 0:{if(A){H=0;do{I=p+(f[o+(H*12|0)+4>>2]<<2)|0;n[I>>2]=+n[I>>2]+ +n[o+(H*12|0)+8>>2]*+(d[G+(f[o+(H*12|0)>>2]<<1)>>1]|0);H=H+1|0}while((H|0)!=(h|0))}break}case 1:{if(A){H=0;do{I=f[o+(H*12|0)>>2]|0;J=f[o+(H*12|0)+4>>2]|0;K=+n[o+(H*12|0)+8>>2];L=p+(J<<2)|0;M=p+(J+1<<2)|0;N=+n[M>>2]+K*+(d[G+(I+1<<1)>>1]|0);n[L>>2]=+n[L>>2]+K*+(d[G+(I<<1)>>1]|0);n[M>>2]=N;H=H+1|0}while((H|0)!=(h|0))}break}case 2:{if(A){H=0;do{M=f[o+(H*12|0)>>2]|0;I=f[o+(H*12|0)+4>>2]|0;N=+n[o+(H*12|0)+8>>2];L=p+(I<<2)|0;J=p+(I+1<<2)|0;K=+n[J>>2]+N*+(d[G+(M+1<<1)>>1]|0);O=p+(I+2<<2)|0;P=+n[O>>2]+N*+(d[G+(M+2<<1)>>1]|0);n[L>>2]=+n[L>>2]+N*+(d[G+(M<<1)>>1]|0);n[J>>2]=K;n[O>>2]=P;H=H+1|0}while((H|0)!=(h|0))}break}case 3:{if(A){H=0;do{O=f[o+(H*12|0)>>2]|0;J=f[o+(H*12|0)+4>>2]|0;P=+n[o+(H*12|0)+8>>2];M=p+(J<<2)|0;L=p+(J+1<<2)|0;K=+n[L>>2]+P*+(d[G+(O+1<<1)>>1]|0);n[M>>2]=+n[M>>2]+P*+(d[G+(O<<1)>>1]|0);n[L>>2]=K;L=p+(J+2<<2)|0;M=p+(J+3<<2)|0;K=+n[M>>2]+P*+(d[G+(O+3<<1)>>1]|0);n[L>>2]=+n[L>>2]+P*+(d[G+(O+2<<1)>>1]|0);n[M>>2]=K;H=H+1|0}while((H|0)!=(h|0))}break}default:if(A){H=0;do{M=f[o+(H*12|0)>>2]|0;O=f[o+(H*12|0)+4>>2]|0;K=+n[o+(H*12|0)+8>>2];L=0;do{J=p+(L+O<<2)|0;n[J>>2]=+n[J>>2]+K*+(d[G+(L+M<<1)>>1]|0);L=L+1|0}while((L|0)!=(j|0));H=H+1|0}while((H|0)!=(h|0))}}if((F|0)==(D|0))if(v){H=0;do{G=q+(H<<2)|0;n[G>>2]=+n[G>>2]+E*+n[p+(H<<2)>>2];H=H+1|0}while((H|0)!=(k|0));Q=D}else Q=D;else{H=f[g>>2]|0;G=(f[H+16>>2]|0)+(Y(f[f[H+44>>2]>>2]|0,D)|0)|0;if(v){H=0;do{L=q+(H<<2)|0;M=LVb(+n[L>>2])|0;d[G+(H<<1)>>1]=(M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768;n[L>>2]=E*+n[p+(H<<2)>>2];H=H+1|0}while((H|0)!=(k|0));Q=F}else Q=F}C=C+1|0;if((C|0)==(t|0)){R=Q;break a}else D=Q}}else R=r;while(0);r=f[g>>2]|0;g=(f[r+16>>2]|0)+(Y(f[f[r+44>>2]>>2]|0,R)|0)|0;if(v){v=0;do{R=LVb(+n[q+(v<<2)>>2])|0;d[g+(v<<1)>>1]=(R+32768|0)>>>0<65536?R:(R|0)>0?32767:32768;v=v+1|0}while((v|0)!=(k|0))}k=f[e>>2]|0;if((k|0)==(l|0)){u=c;return}if(k|0)P5b(k);f[e>>2]=l;f[m>>2]=264;u=c;return}function Nga(a){a=a|0;O5b(a);return}function Oga(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0;c=u;u=u+1072|0;e=c;g=a+8|0;h=f[g>>2]|0;i=(f[h>>2]|0)>>>3;k=(i&511)+1|0;l=Y(k,f[(f[h+40>>2]|0)+4>>2]|0)|0;h=l<<1;m=e+8|0;f[e>>2]=m;o=e+4|0;f[o>>2]=h;if(h>>>0>264){p=N5b(h>>>0>1073741823?-1:h<<2)|0;f[e>>2]=p;q=p}else q=m;p=f[a+12>>2]|0;h=f[a+20>>2]|0;r=q+(l<<2)|0;s=f[a+28>>2]|0;t=f[s+(f[b>>2]<<2)>>2]|0;v=f[s+(f[b+4>>2]<<2)>>2]|0;b=a+16|0;s=f[(f[b>>2]|0)+(t*12|0)+4>>2]|0;w=(l|0)>0;if(w)Nac(r|0,0,l<<2|0)|0;a:do if((t|0)<(v|0)){x=f[b>>2]|0;y=f[a+4>>2]|0;z=f[y+16>>2]|0;A=f[f[y+44>>2]>>2]|0;y=i&65535;B=(h|0)>0;C=l<<2;D=t;E=s;while(1){F=+n[x+(D*12|0)+8>>2];G=f[x+(D*12|0)+4>>2]|0;H=z+(Y(A,f[x+(D*12|0)>>2]|0)|0)|0;if(w)Nac(q|0,0,C|0)|0;switch(y&511){case 0:{if(B){I=0;do{J=q+(f[p+(I*12|0)+4>>2]<<2)|0;n[J>>2]=+n[J>>2]+ +n[p+(I*12|0)+8>>2]*+(j[H+(f[p+(I*12|0)>>2]<<1)>>1]|0);I=I+1|0}while((I|0)!=(h|0))}break}case 1:{if(B){I=0;do{J=f[p+(I*12|0)>>2]|0;K=f[p+(I*12|0)+4>>2]|0;L=+n[p+(I*12|0)+8>>2];M=q+(K<<2)|0;N=q+(K+1<<2)|0;O=+n[N>>2]+L*+(j[H+(J+1<<1)>>1]|0);n[M>>2]=+n[M>>2]+L*+(j[H+(J<<1)>>1]|0);n[N>>2]=O;I=I+1|0}while((I|0)!=(h|0))}break}case 2:{if(B){I=0;do{N=f[p+(I*12|0)>>2]|0;J=f[p+(I*12|0)+4>>2]|0;O=+n[p+(I*12|0)+8>>2];M=q+(J<<2)|0;K=q+(J+1<<2)|0;L=+n[K>>2]+O*+(j[H+(N+1<<1)>>1]|0);P=q+(J+2<<2)|0;Q=+n[P>>2]+O*+(j[H+(N+2<<1)>>1]|0);n[M>>2]=+n[M>>2]+O*+(j[H+(N<<1)>>1]|0);n[K>>2]=L;n[P>>2]=Q;I=I+1|0}while((I|0)!=(h|0))}break}case 3:{if(B){I=0;do{P=f[p+(I*12|0)>>2]|0;K=f[p+(I*12|0)+4>>2]|0;Q=+n[p+(I*12|0)+8>>2];N=q+(K<<2)|0;M=q+(K+1<<2)|0;L=+n[M>>2]+Q*+(j[H+(P+1<<1)>>1]|0);n[N>>2]=+n[N>>2]+Q*+(j[H+(P<<1)>>1]|0);n[M>>2]=L;M=q+(K+2<<2)|0;N=q+(K+3<<2)|0;L=+n[N>>2]+Q*+(j[H+(P+3<<1)>>1]|0);n[M>>2]=+n[M>>2]+Q*+(j[H+(P+2<<1)>>1]|0);n[N>>2]=L;I=I+1|0}while((I|0)!=(h|0))}break}default:if(B){I=0;do{N=f[p+(I*12|0)>>2]|0;P=f[p+(I*12|0)+4>>2]|0;L=+n[p+(I*12|0)+8>>2];M=0;do{K=q+(M+P<<2)|0;n[K>>2]=+n[K>>2]+L*+(j[H+(M+N<<1)>>1]|0);M=M+1|0}while((M|0)!=(k|0));I=I+1|0}while((I|0)!=(h|0))}}if((G|0)==(E|0))if(w){I=0;do{H=r+(I<<2)|0;n[H>>2]=+n[H>>2]+F*+n[q+(I<<2)>>2];I=I+1|0}while((I|0)!=(l|0));R=E}else R=E;else{I=f[g>>2]|0;H=(f[I+16>>2]|0)+(Y(f[f[I+44>>2]>>2]|0,E)|0)|0;if(w){I=0;do{M=r+(I<<2)|0;N=LVb(+n[M>>2])|0;d[H+(I<<1)>>1]=N>>>0<65536?N:(N|0)>0?65535:0;n[M>>2]=F*+n[q+(I<<2)>>2];I=I+1|0}while((I|0)!=(l|0));R=G}else R=G}D=D+1|0;if((D|0)==(v|0)){S=R;break a}else E=R}}else S=s;while(0);s=f[g>>2]|0;g=(f[s+16>>2]|0)+(Y(f[f[s+44>>2]>>2]|0,S)|0)|0;if(w){w=0;do{S=LVb(+n[r+(w<<2)>>2])|0;d[g+(w<<1)>>1]=S>>>0<65536?S:(S|0)>0?65535:0;w=w+1|0}while((w|0)!=(l|0))}l=f[e>>2]|0;if((l|0)==(m|0)){u=c;return}if(l|0)P5b(l);f[e>>2]=m;f[o>>2]=264;u=c;return}function Pga(a){a=a|0;O5b(a);return}function Qga(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0.0,P=0,Q=0;d=u;u=u+1072|0;e=d;g=a+8|0;i=f[g>>2]|0;j=(f[i>>2]|0)>>>3;k=(j&511)+1|0;l=Y(k,f[(f[i+40>>2]|0)+4>>2]|0)|0;i=l<<1;m=e+8|0;f[e>>2]=m;o=e+4|0;f[o>>2]=i;if(i>>>0>264){p=N5b(i>>>0>1073741823?-1:i<<2)|0;f[e>>2]=p;q=p}else q=m;p=f[a+12>>2]|0;i=f[a+20>>2]|0;r=q+(l<<2)|0;s=f[a+28>>2]|0;t=f[s+(f[c>>2]<<2)>>2]|0;v=f[s+(f[c+4>>2]<<2)>>2]|0;c=a+16|0;s=f[(f[c>>2]|0)+(t*12|0)+4>>2]|0;w=(l|0)>0;if(w)Nac(r|0,0,l<<2|0)|0;a:do if((t|0)<(v|0)){x=a+4|0;y=j&65535;z=(i|0)>0;A=l<<2;B=s;C=t;while(1){D=f[c>>2]|0;E=+n[D+(C*12|0)+8>>2];F=f[D+(C*12|0)+4>>2]|0;G=f[x>>2]|0;H=(f[G+16>>2]|0)+(Y(f[f[G+44>>2]>>2]|0,f[D+(C*12|0)>>2]|0)|0)|0;if(w)Nac(q|0,0,A|0)|0;switch(y&511){case 0:{if(z){D=0;do{G=q+(f[p+(D*12|0)+4>>2]<<2)|0;n[G>>2]=+n[G>>2]+ +n[p+(D*12|0)+8>>2]*+(h[H+(f[p+(D*12|0)>>2]|0)>>0]|0);D=D+1|0}while((D|0)!=(i|0))}break}case 1:{if(z){D=0;do{G=f[p+(D*12|0)>>2]|0;I=f[p+(D*12|0)+4>>2]|0;J=+n[p+(D*12|0)+8>>2];K=q+(I<<2)|0;L=q+(I+1<<2)|0;M=+n[L>>2]+J*+(h[H+(G+1)>>0]|0);n[K>>2]=+n[K>>2]+J*+(h[H+G>>0]|0);n[L>>2]=M;D=D+1|0}while((D|0)!=(i|0))}break}case 2:{if(z){D=0;do{L=f[p+(D*12|0)>>2]|0;G=f[p+(D*12|0)+4>>2]|0;M=+n[p+(D*12|0)+8>>2];K=q+(G<<2)|0;I=q+(G+1<<2)|0;J=+n[I>>2]+M*+(h[H+(L+1)>>0]|0);N=q+(G+2<<2)|0;O=+n[N>>2]+M*+(h[H+(L+2)>>0]|0);n[K>>2]=+n[K>>2]+M*+(h[H+L>>0]|0);n[I>>2]=J;n[N>>2]=O;D=D+1|0}while((D|0)!=(i|0))}break}case 3:{if(z){D=0;do{N=f[p+(D*12|0)>>2]|0;I=f[p+(D*12|0)+4>>2]|0;O=+n[p+(D*12|0)+8>>2];L=q+(I<<2)|0;K=q+(I+1<<2)|0;J=+n[K>>2]+O*+(h[H+(N+1)>>0]|0);n[L>>2]=+n[L>>2]+O*+(h[H+N>>0]|0);n[K>>2]=J;K=q+(I+2<<2)|0;L=q+(I+3<<2)|0;J=+n[L>>2]+O*+(h[H+(N+3)>>0]|0);n[K>>2]=+n[K>>2]+O*+(h[H+(N+2)>>0]|0);n[L>>2]=J;D=D+1|0}while((D|0)!=(i|0))}break}default:if(z){D=0;do{L=f[p+(D*12|0)>>2]|0;N=f[p+(D*12|0)+4>>2]|0;J=+n[p+(D*12|0)+8>>2];K=0;do{I=q+(K+N<<2)|0;n[I>>2]=+n[I>>2]+J*+(h[H+(K+L)>>0]|0);K=K+1|0}while((K|0)!=(k|0));D=D+1|0}while((D|0)!=(i|0))}}if((F|0)==(B|0))if(w){D=0;do{H=r+(D<<2)|0;n[H>>2]=+n[H>>2]+E*+n[q+(D<<2)>>2];D=D+1|0}while((D|0)!=(l|0));P=B}else P=B;else{D=f[g>>2]|0;H=(f[D+16>>2]|0)+(Y(f[f[D+44>>2]>>2]|0,B)|0)|0;if(w){D=0;do{K=r+(D<<2)|0;L=LVb(+n[K>>2])|0;b[H+D>>0]=L>>>0<256?L:(L|0)>0?255:0;n[K>>2]=E*+n[q+(D<<2)>>2];D=D+1|0}while((D|0)!=(l|0));P=F}else P=F}C=C+1|0;if((C|0)==(v|0)){Q=P;break a}else B=P}}else Q=s;while(0);s=f[g>>2]|0;g=(f[s+16>>2]|0)+(Y(f[f[s+44>>2]>>2]|0,Q)|0)|0;if(w){w=0;do{Q=LVb(+n[r+(w<<2)>>2])|0;b[g+w>>0]=Q>>>0<256?Q:(Q|0)>0?255:0;w=w+1|0}while((w|0)!=(l|0))}l=f[e>>2]|0;if((l|0)==(m|0)){u=d;return}if(l|0)P5b(l);f[e>>2]=m;f[o>>2]=264;u=d;return}function Rga(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;mha(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}RQ(i,j,+(m>>>0)*.0000152587890625);nha(j);u=h;return}function Sga(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;hha(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}RQ(i,j,+(m>>>0)*.0000152587890625);iha(j);u=h;return}
function KDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=u;u=u+32|0;e=d;g=a+68|0;h=f[g>>2]|0;i=b[h+11>>0]|0;j=i<<24>>24<0;if(j)k=f[h+4>>2]|0;else k=i&255;if(k|0){if(j){l=f[h>>2]|0;m=f[h+4>>2]|0}else{l=h;m=i&255}gqb(l,m,1,383505)|0;$pb(1,f[g>>2]|0,c)}g=a+72|0;m=f[g>>2]|0;l=b[m+11>>0]|0;i=l<<24>>24<0;if(i)n=f[m+4>>2]|0;else n=l&255;if(n|0){if(i){o=f[m>>2]|0;p=f[m+4>>2]|0}else{o=m;p=l&255}gqb(o,p,1,383529)|0;$pb(2,f[g>>2]|0,c)}g=a+12|0;if((f[g>>2]|0)>0){p=a+20|0;o=0;do{l=f[(f[p>>2]|0)+4+(o<<2)>>2]|0;m=b[l+11>>0]|0;if(m<<24>>24<0){q=f[l>>2]|0;r=f[l+4>>2]|0}else{q=l;r=m&255}gqb(q,r,1,383551)|0;_pb(3,f[(f[p>>2]|0)+4+(o<<2)>>2]|0,c);o=o+1|0}while((o|0)<(f[g>>2]|0))}g=a+76|0;o=f[g>>2]|0;p=b[o+11>>0]|0;r=p<<24>>24<0;if(r)s=f[o+4>>2]|0;else s=p&255;if(s|0){if(r){t=f[o>>2]|0;v=f[o+4>>2]|0}else{t=o;v=p&255}gqb(t,v,1,383576)|0;$pb(4,f[g>>2]|0,c)}g=a+24|0;tKb(g);v=a+60|0;t=f[v>>2]|0;p=t+12|0;if(!(b[t+8>>0]|0))w=f[p>>2]|0;else w=(f[p>>2]|0)+20|0;if(!(f[w>>2]|0)){u=d;return}if(b[(b[c+18>>0]|0?c+19|0:1122455)>>0]|0){tKb(g);w=f[v>>2]|0;p=w+12|0;if(!(b[w+8>>0]|0))x=f[p>>2]|0;else x=(f[p>>2]|0)+20|0;if((f[x>>2]|0)>>>0>1){tKb(g);x=f[v>>2]|0;p=x+12|0;if(!(b[x+8>>0]|0))y=f[p>>2]|0;else y=(f[p>>2]|0)+20|0;p=f[y>>2]|0;y=N5b(p>>>0>1073741823?-1:p<<2)|0;tKb(g);p=f[v>>2]|0;if(!(b[p+8>>0]|0)){x=f[p+12>>2]|0;w=f[x+12>>2]|0;t=f[x+4>>2]|0;a:do if(t>>>0>w>>>0){o=f[x+16>>2]|0;r=w;while(1){z=f[o+(r<<2)>>2]|0;if(z|0)break;s=r+1|0;if(s>>>0<t>>>0)r=s;else{A=0;B=s;C=0;break a}}if((z|0)==(f[o+((r^1)<<2)>>2]|0)){s=f[z>>2]|0;A=f[s+16>>2]|0;B=r;C=s;break}else{A=z;B=r;C=0;break}}else{A=0;B=w;C=0}while(0);w=e+4|0;f[w>>2]=A;f[e+8>>2]=x;f[e+12>>2]=B;f[e+16>>2]=C;C=e+20|0;f[C>>2]=0;f[e>>2]=2;B=e+20|0;D=e;E=e+4|0;F=C;G=B;H=B;I=w}else{w=f[(f[p+12>>2]|0)+12>>2]|0;f[e>>2]=1;p=e+4|0;f[p>>2]=0;B=e+20|0;f[B>>2]=w;D=e;E=p;F=e+20|0;G=B;H=B;I=e+4|0}B=0;b:while(1){tKb(g);p=(b[(f[v>>2]|0)+8>>0]|0)==0?2:1;w=f[D>>2]|0;c:do if((w|0)==(p|0))switch(p&3){case 0:{break b;break}case 1:{if(!(f[F>>2]|0))break b;else break c;break}default:if(!(f[E>>2]|0))break b;else break c}while(0);p=(w|0)==1;r=f[G>>2]|0;f[y+(B<<2)>>2]=f[(p?r+20|0:(f[E>>2]|0)+12|0)>>2];if(p)f[H>>2]=f[r>>2];else uxa(I)|0;B=B+1|0}VDa(y,y+(B<<2)|0,e);if(B|0){I=a+56|0;H=0;E=0;do{G=y+(H<<2)|0;F=f[G>>2]|0;D=f[I>>2]|0;if(!D){r=L5b(32)|0;f[r+4>>2]=0;f[r+16>>2]=0;J=r}else{r=znb(D,18512,32)|0;f[r+4>>2]=0;f[r+16>>2]=D;J=r}f[J+8>>2]=497760;f[J+12>>2]=0;f[J>>2]=107432;f[J+24>>2]=F;f[J+28>>2]=F+16;f[J+20>>2]=3;do if((E|0)==(J|0))K=E;else{if(!E){K=J;break}bi[f[(f[E>>2]|0)+4>>2]&2047](E);K=J}while(0);eqb(5,K,c);w=(di[f[(f[K>>2]|0)+20>>2]&1023](K)|0)==0;E=w?K:0;w=f[G>>2]|0;F=b[w+11>>0]|0;if(F<<24>>24<0){L=f[w>>2]|0;M=f[w+4>>2]|0}else{L=w;M=F&255}gqb(L,M,1,383602)|0;H=H+1|0}while(H>>>0<B>>>0);if(E|0)bi[f[(f[E>>2]|0)+4>>2]&2047](E)}P5b(y);u=d;return}}tKb(g);y=f[v>>2]|0;if(!(b[y+8>>0]|0)){E=f[y+12>>2]|0;B=f[E+12>>2]|0;H=f[E+4>>2]|0;d:do if(H>>>0>B>>>0){M=f[E+16>>2]|0;L=B;while(1){N=f[M+(L<<2)>>2]|0;if(N|0)break;K=L+1|0;if(K>>>0<H>>>0)L=K;else{O=0;P=K;Q=0;break d}}if((N|0)==(f[M+((L^1)<<2)>>2]|0)){G=f[N>>2]|0;O=f[G+16>>2]|0;P=L;Q=G;break}else{O=N;P=L;Q=0;break}}else{O=0;P=B;Q=0}while(0);B=e+4|0;f[B>>2]=O;f[e+8>>2]=E;f[e+12>>2]=P;f[e+16>>2]=Q;Q=e+20|0;f[Q>>2]=0;f[e>>2]=2;P=e+20|0;R=e+4|0;S=Q;T=P;U=P;V=B;W=e}else{B=f[(f[y+12>>2]|0)+12>>2]|0;f[e>>2]=1;y=e+4|0;f[y>>2]=0;P=e+20|0;f[P>>2]=B;R=y;S=e+20|0;T=P;U=P;V=e+4|0;W=e}e=a+56|0;a=0;e:while(1){tKb(g);P=(b[(f[v>>2]|0)+8>>0]|0)==0?2:1;y=f[W>>2]|0;f:do if((y|0)==(P|0))switch(P&3){case 0:{break e;break}case 1:{if(!(f[S>>2]|0))break e;else break f;break}default:if(!(f[R>>2]|0))break e;else break f}while(0);P=f[((y|0)==1?(f[T>>2]|0)+20|0:(f[R>>2]|0)+12|0)>>2]|0;L=f[e>>2]|0;if(!L){M=L5b(32)|0;f[M+4>>2]=0;f[M+16>>2]=0;X=M}else{M=znb(L,18512,32)|0;f[M+4>>2]=0;f[M+16>>2]=L;X=M}f[X+8>>2]=497760;f[X+12>>2]=0;f[X>>2]=107432;f[X+24>>2]=P;f[X+28>>2]=P+16;f[X+20>>2]=3;if((a|0)!=(X|0))if(!a)Y=X;else{bi[f[(f[a>>2]|0)+4>>2]&2047](a);Y=X}else Y=a;eqb(5,Y,c);P=(di[f[(f[Y>>2]|0)+20>>2]&1023](Y)|0)==0;M=P?Y:0;P=f[((f[W>>2]|0)==1?(f[T>>2]|0)+20|0:(f[R>>2]|0)+12|0)>>2]|0;L=b[P+11>>0]|0;if(L<<24>>24<0){Z=f[P>>2]|0;_=f[P+4>>2]|0}else{Z=P;_=L&255}gqb(Z,_,1,383602)|0;if((f[W>>2]|0)==1){f[U>>2]=f[f[T>>2]>>2];a=M;continue}else{uxa(V)|0;a=M;continue}}if(!a){u=d;return}bi[f[(f[a>>2]|0)+4>>2]&2047](a);u=d;return}function LDa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function MDa(a){a=a|0;return f[a+80>>2]|0}function NDa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;e=u;u=u+32|0;g=e;h=a+68|0;i=f[h>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0;if(k)l=f[i+4>>2]|0;else l=j&255;if(!l)m=d;else{if(k){n=f[i>>2]|0;o=f[i+4>>2]|0}else{n=i;o=j&255}gqb(n,o,1,383505)|0;o=f[h>>2]|0;b[d>>0]=10;m=kob(o,d+1|0)|0}d=a+72|0;o=f[d>>2]|0;h=b[o+11>>0]|0;n=h<<24>>24<0;if(n)p=f[o+4>>2]|0;else p=h&255;if(!p)q=m;else{if(n){r=f[o>>2]|0;s=f[o+4>>2]|0}else{r=o;s=h&255}gqb(r,s,1,383529)|0;s=f[d>>2]|0;b[m>>0]=18;q=kob(s,m+1|0)|0}m=a+12|0;if((f[m>>2]|0)>0){s=a+20|0;d=0;r=q;while(1){h=f[(f[s>>2]|0)+4+(d<<2)>>2]|0;o=b[h+11>>0]|0;if(o<<24>>24<0){t=f[h>>2]|0;v=f[h+4>>2]|0}else{t=h;v=o&255}gqb(t,v,1,383551)|0;o=f[(f[s>>2]|0)+4+(d<<2)>>2]|0;b[r>>0]=26;h=kob(o,r+1|0)|0;d=d+1|0;if((d|0)>=(f[m>>2]|0)){w=h;break}else r=h}}else w=q;q=a+76|0;r=f[q>>2]|0;m=b[r+11>>0]|0;d=m<<24>>24<0;if(d)x=f[r+4>>2]|0;else x=m&255;if(!x)y=w;else{if(d){z=f[r>>2]|0;A=f[r+4>>2]|0}else{z=r;A=m&255}gqb(z,A,1,383576)|0;A=f[q>>2]|0;b[w>>0]=34;y=kob(A,w+1|0)|0}w=a+24|0;tKb(w);A=a+60|0;q=f[A>>2]|0;z=q+12|0;if(!(b[q+8>>0]|0))B=f[z>>2]|0;else B=(f[z>>2]|0)+20|0;if(!(f[B>>2]|0)){C=y;u=e;return C|0}if(c){tKb(w);B=f[A>>2]|0;z=B+12|0;if(!(b[B+8>>0]|0))D=f[z>>2]|0;else D=(f[z>>2]|0)+20|0;if((f[D>>2]|0)>>>0>1){tKb(w);D=f[A>>2]|0;z=D+12|0;if(!(b[D+8>>0]|0))E=f[z>>2]|0;else E=(f[z>>2]|0)+20|0;z=f[E>>2]|0;E=N5b(z>>>0>1073741823?-1:z<<2)|0;tKb(w);z=f[A>>2]|0;if(!(b[z+8>>0]|0)){D=f[z+12>>2]|0;B=f[D+12>>2]|0;q=f[D+4>>2]|0;a:do if(q>>>0>B>>>0){m=f[D+16>>2]|0;r=B;while(1){F=f[m+(r<<2)>>2]|0;if(F|0)break;d=r+1|0;if(d>>>0<q>>>0)r=d;else{G=0;H=d;I=0;break a}}if((F|0)==(f[m+((r^1)<<2)>>2]|0)){d=f[F>>2]|0;G=f[d+16>>2]|0;H=r;I=d;break}else{G=F;H=r;I=0;break}}else{G=0;H=B;I=0}while(0);B=g+4|0;f[B>>2]=G;f[g+8>>2]=D;f[g+12>>2]=H;f[g+16>>2]=I;I=g+20|0;f[I>>2]=0;f[g>>2]=2;H=g+20|0;J=g+4|0;K=I;L=H;M=H;N=B;O=g}else{B=f[(f[z+12>>2]|0)+12>>2]|0;f[g>>2]=1;z=g+4|0;f[z>>2]=0;H=g+20|0;f[H>>2]=B;J=z;K=g+20|0;L=H;M=H;N=g+4|0;O=g}H=0;b:while(1){tKb(w);z=(b[(f[A>>2]|0)+8>>0]|0)==0?2:1;B=f[O>>2]|0;c:do if((B|0)==(z|0))switch(z&3){case 0:{break b;break}case 1:{if(!(f[K>>2]|0))break b;else break c;break}default:if(!(f[J>>2]|0))break b;else break c}while(0);z=(B|0)==1;r=f[L>>2]|0;f[E+(H<<2)>>2]=f[(z?r+20|0:(f[J>>2]|0)+12|0)>>2];if(z)f[M>>2]=f[r>>2];else uxa(N)|0;H=H+1|0}VDa(E,E+(H<<2)|0,g);if(H){N=a+56|0;M=0;J=y;L=0;do{K=E+(M<<2)|0;O=f[K>>2]|0;r=f[N>>2]|0;if(!r){z=L5b(32)|0;f[z+4>>2]=0;f[z+16>>2]=0;P=z}else{z=znb(r,18512,32)|0;f[z+4>>2]=0;f[z+16>>2]=r;P=z}f[P+8>>2]=497760;f[P+12>>2]=0;f[P>>2]=107432;f[P+24>>2]=O;f[P+28>>2]=O+16;f[P+20>>2]=3;do if((L|0)==(P|0))Q=L;else{if(!L){Q=P;break}bi[f[(f[L>>2]|0)+4>>2]&2047](L);Q=P}while(0);b[J>>0]=42;B=J+1|0;O=Q+20|0;z=f[O>>2]|0;if(!(z&1)){R=z;S=0}else{z=di[f[(f[Q>>2]|0)+72>>2]&1023](Q)|0;r=b[z+11>>0]|0;do if(r<<24>>24<0){m=f[z+4>>2]|0;if(m>>>0<128){T=1;U=m;break}T=iob(m)|0;U=m}else{T=1;U=r&255}while(0);R=f[O>>2]|0;S=U+1+T|0}if(!(R&2))V=0;else{r=di[f[(f[Q>>2]|0)+76>>2]&1023](Q)|0;z=di[f[(f[r>>2]|0)+64>>2]&1023](r)|0;if(z>>>0<128)W=1;else W=iob(z)|0;V=z+1+W|0}z=V+S|0;if(z>>>0>127){r=z;m=B;while(1){b[m>>0]=r|128;I=r>>>7;D=m+1|0;if(r>>>0>16383){r=I;m=D}else{X=D;Y=I;break}}}else{X=B;Y=z}b[X>>0]=Y;J=li[f[(f[Q>>2]|0)+68>>2]&511](Q,1,X+1|0)|0;m=(di[f[(f[Q>>2]|0)+20>>2]&1023](Q)|0)==0;L=m?Q:0;m=f[K>>2]|0;r=b[m+11>>0]|0;if(r<<24>>24<0){Z=f[m>>2]|0;_=f[m+4>>2]|0}else{Z=m;_=r&255}gqb(Z,_,1,383602)|0;M=M+1|0}while(M>>>0<H>>>0);if(!L)$=J;else{bi[f[(f[L>>2]|0)+4>>2]&2047](L);$=J}}else $=y;P5b(E);C=$;u=e;return C|0}}tKb(w);$=f[A>>2]|0;if(!(b[$+8>>0]|0)){E=f[$+12>>2]|0;J=f[E+12>>2]|0;L=f[E+4>>2]|0;d:do if(L>>>0>J>>>0){H=f[E+16>>2]|0;M=J;while(1){aa=f[H+(M<<2)>>2]|0;if(aa|0)break;_=M+1|0;if(_>>>0<L>>>0)M=_;else{ba=0;ca=_;da=0;break d}}if((aa|0)==(f[H+((M^1)<<2)>>2]|0)){K=f[aa>>2]|0;ba=f[K+16>>2]|0;ca=M;da=K;break}else{ba=aa;ca=M;da=0;break}}else{ba=0;ca=J;da=0}while(0);J=g+4|0;f[J>>2]=ba;f[g+8>>2]=E;f[g+12>>2]=ca;f[g+16>>2]=da;da=g+20|0;f[da>>2]=0;f[g>>2]=2;ca=g+20|0;ea=g;fa=g+4|0;ga=da;ha=ca;ia=ca;ja=J}else{J=f[(f[$+12>>2]|0)+12>>2]|0;f[g>>2]=1;$=g+4|0;f[$>>2]=0;ca=g+20|0;f[ca>>2]=J;ea=g;fa=$;ga=g+20|0;ha=ca;ia=ca;ja=g+4|0}g=a+56|0;a=y;y=0;e:while(1){tKb(w);ca=(b[(f[A>>2]|0)+8>>0]|0)==0?2:1;$=f[ea>>2]|0;f:do if(($|0)==(ca|0))switch(ca&3){case 0:{break e;break}case 1:{if(!(f[ga>>2]|0))break e;else break f;break}default:if(!(f[fa>>2]|0))break e;else break f}while(0);ca=f[(($|0)==1?(f[ha>>2]|0)+20|0:(f[fa>>2]|0)+12|0)>>2]|0;M=f[g>>2]|0;if(!M){H=L5b(32)|0;f[H+4>>2]=0;f[H+16>>2]=0;ka=H}else{H=znb(M,18512,32)|0;f[H+4>>2]=0;f[H+16>>2]=M;ka=H}f[ka+8>>2]=497760;f[ka+12>>2]=0;f[ka>>2]=107432;f[ka+24>>2]=ca;f[ka+28>>2]=ca+16;f[ka+20>>2]=3;if((y|0)!=(ka|0))if(!y)la=ka;else{bi[f[(f[y>>2]|0)+4>>2]&2047](y);la=ka}else la=y;b[a>>0]=42;ca=a+1|0;H=la+20|0;M=f[H>>2]|0;if(!(M&1)){ma=M;na=0}else{M=di[f[(f[la>>2]|0)+72>>2]&1023](la)|0;J=b[M+11>>0]|0;if(J<<24>>24<0){da=f[M+4>>2]|0;if(da>>>0<128){oa=1;pa=da}else{oa=iob(da)|0;pa=da}}else{oa=1;pa=J&255}ma=f[H>>2]|0;na=pa+1+oa|0}if(!(ma&2))qa=0;else{H=di[f[(f[la>>2]|0)+76>>2]&1023](la)|0;J=di[f[(f[H>>2]|0)+64>>2]&1023](H)|0;if(J>>>0<128)ra=1;else ra=iob(J)|0;qa=J+1+ra|0}J=qa+na|0;if(J>>>0>127){H=J;da=ca;while(1){b[da>>0]=H|128;M=H>>>7;E=da+1|0;if(H>>>0>16383){H=M;da=E}else{sa=E;ta=M;break}}}else{sa=ca;ta=J}b[sa>>0]=ta;da=li[f[(f[la>>2]|0)+68>>2]&511](la,c,sa+1|0)|0;H=(di[f[(f[la>>2]|0)+20>>2]&1023](la)|0)==0;$=H?la:0;H=f[((f[ea>>2]|0)==1?(f[ha>>2]|0)+20|0:(f[fa>>2]|0)+12|0)>>2]|0;M=b[H+11>>0]|0;if(M<<24>>24<0){ua=f[H>>2]|0;va=f[H+4>>2]|0}else{ua=H;va=M&255}gqb(ua,va,1,383602)|0;if((f[ea>>2]|0)==1){f[ia>>2]=f[f[ha>>2]>>2];a=da;y=$;continue}else{uxa(ja)|0;a=da;y=$;continue}}if(!y){C=a;u=e;return C|0}bi[f[(f[y>>2]|0)+4>>2]&2047](y);C=a;u=e;return C|0}function ODa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function PDa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))SDa(1314);c=T6b(b,23288,18496,0)|0;if(!c){cOb(b,a);return}else{TDa(a,c);return}}function QDa(a,b){a=a|0;b=b|0;f[a+80>>2]=b;return}function RDa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[212961]|0)!=2){f[d>>2]=135812;f[d+4>>2]=8;b[d+8>>0]=0;Gpb(851844,d);hpb(d)}f[a>>2]=f[212964];f[a+4>>2]=f[212965];u=c;return}function SDa(a){a=a|0;Enb(381360,a)}function TDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;UDa(a+8|0,c+8|0);d=c+52|0;e=a+24|0;tKb(e);tKb(d+-28|0);DCa(a+52|0,d);sKb(e);e=f[c+68>>2]|0;d=b[e+11>>0]|0;if(d<<24>>24<0)g=f[e+4>>2]|0;else g=d&255;do if(g|0){d=a+68|0;h=f[a+4>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[d>>2]|0;if((i|0)==497760){dya(d,j,e);break}else{_5b(i,e)|0;break}}while(0);e=f[c+72>>2]|0;j=b[e+11>>0]|0;if(j<<24>>24<0)k=f[e+4>>2]|0;else k=j&255;do if(k|0){j=a+72|0;g=f[a+4>>2]|0;i=g&-2;if(!(g&1))l=i;else l=f[i+4>>2]|0;i=f[j>>2]|0;if((i|0)==497760){dya(j,l,e);break}else{_5b(i,e)|0;break}}while(0);e=f[c+76>>2]|0;c=b[e+11>>0]|0;if(c<<24>>24<0)m=f[e+4>>2]|0;else m=c&255;if(!m)return;m=a+76|0;c=f[a+4>>2]|0;a=c&-2;if(!(c&1))n=a;else n=f[a+4>>2]|0;a=f[m>>2]|0;if((a|0)==497760){dya(m,n,e);return}else{_5b(a,e)|0;return}}function UDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{_5b(f[b+(i<<2)>>2]|0,f[d+4+(i<<2)>>2]|0)|0;i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0))if(!i){a=h;do{j=f[d+4+(a<<2)>>2]|0;k=L5b(12)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;_5b(k,j)|0;f[b+(a<<2)>>2]=k;a=a+1|0}while((a|0)!=(c|0))}else{a=h;do{h=f[d+4+(a<<2)>>2]|0;k=znb(i,8992,12)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;xnb(i,k,1480);_5b(k,h)|0;f[b+(a<<2)>>2]=k;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function VDa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=a;a=c;a:while(1){c=a;g=a+-4|0;h=a+-8|0;i=e;while(1){j=i;b:while(1){k=j;l=c-k|0;m=l>>2;switch(m|0){case 2:{n=5;break a;break}case 3:{n=10;break a;break}case 4:{n=11;break a;break}case 5:{n=12;break a;break}case 1:case 0:{n=111;break a;break}default:{}}if((l|0)<124){n=14;break a}o=j+(((m|0)/2|0)<<2)|0;if((l|0)>3996){l=(m|0)/4|0;p=$Da(j,j+(l<<2)|0,o,o+(l<<2)|0,g,d)|0}else p=ZDa(j,o,g,d)|0;q=f[j>>2]|0;l=f[o>>2]|0;m=b[l+11>>0]|0;r=m<<24>>24<0;s=r?f[l+4>>2]|0:m&255;m=b[q+11>>0]|0;t=m<<24>>24<0;u=t?f[q+4>>2]|0:m&255;m=s>>>0<u>>>0?s:u;if((m|0)!=0?(v=ZVb(t?f[q>>2]|0:q,r?f[l>>2]|0:l,m)|0,(v|0)!=0):0){if((v|0)<0){w=g;x=p;break}}else n=20;if((n|0)==20?(n=0,u>>>0<s>>>0):0){w=g;x=p;break}if((j|0)!=(h|0))if(r){r=h;do{v=f[r>>2]|0;m=b[v+11>>0]|0;y=m<<24>>24<0;z=y?f[v+4>>2]|0:m&255;m=s>>>0<z>>>0?s:z;if((m|0)!=0?(A=ZVb(y?f[v>>2]|0:v,f[l>>2]|0,m)|0,(A|0)!=0):0){if((A|0)<0){B=r;n=74;break b}}else n=27;if((n|0)==27?(n=0,z>>>0<s>>>0):0){B=r;n=74;break b}r=r+-4|0}while((j|0)!=(r|0))}else{r=h;do{z=f[r>>2]|0;A=b[z+11>>0]|0;m=A<<24>>24<0;v=m?f[z+4>>2]|0:A&255;A=s>>>0<v>>>0?s:v;if((A|0)!=0?(y=ZVb(m?f[z>>2]|0:z,l,A)|0,(y|0)!=0):0){if((y|0)<0){B=r;n=74;break b}}else n=71;if((n|0)==71?(n=0,v>>>0<s>>>0):0){B=r;n=74;break b}r=r+-4|0}while((j|0)!=(r|0))}r=j+4|0;s=f[g>>2]|0;l=b[s+11>>0]|0;v=l<<24>>24<0;y=v?f[s+4>>2]|0:l&255;l=y>>>0<u>>>0?y:u;A=s;if((l|0)!=0?(z=ZVb(t?f[q>>2]|0:q,v?f[s>>2]|0:s,l)|0,(z|0)!=0):0)if((z|0)<0)C=r;else n=33;else if(u>>>0<y>>>0)C=r;else n=33;if((n|0)==33){n=0;if((r|0)==(g|0)){n=111;break a}c:do if(t){y=r;while(1){z=f[y>>2]|0;l=b[z+11>>0]|0;s=l<<24>>24<0;v=s?f[z+4>>2]|0:l&255;l=v>>>0<u>>>0?v:u;if((l|0)!=0?(m=ZVb(f[q>>2]|0,s?f[z>>2]|0:z,l)|0,(m|0)!=0):0){if((m|0)<0){D=y;break c}}else n=38;if((n|0)==38?(n=0,u>>>0<v>>>0):0){D=y;break c}y=y+4|0;if((y|0)==(g|0)){n=111;break a}}}else{y=r;while(1){v=f[y>>2]|0;m=b[v+11>>0]|0;l=m<<24>>24<0;z=l?f[v+4>>2]|0:m&255;m=z>>>0<u>>>0?z:u;if((m|0)!=0?(s=ZVb(q,l?f[v>>2]|0:v,m)|0,(s|0)!=0):0){if((s|0)<0){D=y;break c}}else n=42;if((n|0)==42?(n=0,u>>>0<z>>>0):0){D=y;break c}y=y+4|0;if((y|0)==(g|0)){n=111;break a}}}while(0);u=f[D>>2]|0;f[D>>2]=A;f[g>>2]=u;C=D+4|0}if((C|0)==(g|0)){n=111;break a}else{E=g;F=C}while(1){u=f[j>>2]|0;r=b[u+11>>0]|0;t=r<<24>>24<0;y=t?f[u+4>>2]|0:r&255;d:do if(t){r=F;while(1){z=f[r>>2]|0;s=b[z+11>>0]|0;m=s<<24>>24<0;v=m?f[z+4>>2]|0:s&255;s=v>>>0<y>>>0?v:y;if((s|0)!=0?(l=ZVb(f[u>>2]|0,m?f[z>>2]|0:z,s)|0,(l|0)!=0):0){if((l|0)<0){G=r;break d}}else n=51;if((n|0)==51?(n=0,y>>>0<v>>>0):0){G=r;break d}r=r+4|0}}else{r=F;while(1){v=f[r>>2]|0;l=b[v+11>>0]|0;s=l<<24>>24<0;z=s?f[v+4>>2]|0:l&255;l=z>>>0<y>>>0?z:y;if((l|0)!=0?(m=ZVb(u,s?f[v>>2]|0:v,l)|0,(m|0)!=0):0){if((m|0)<0){G=r;break d}}else n=55;if((n|0)==55?(n=0,y>>>0<z>>>0):0){G=r;break d}r=r+4|0}}while(0);e:do if(t){r=E;while(1){z=r+-4|0;m=f[z>>2]|0;l=b[m+11>>0]|0;v=l<<24>>24<0;s=v?f[m+4>>2]|0:l&255;l=s>>>0<y>>>0?s:y;if(l|0?(H=ZVb(f[u>>2]|0,v?f[m>>2]|0:m,l)|0,H|0):0)if((H|0)<0){r=z;continue}else{I=z;break e}if(y>>>0<s>>>0)r=z;else{I=z;break}}}else{r=E;while(1){z=r+-4|0;s=f[z>>2]|0;H=b[s+11>>0]|0;l=H<<24>>24<0;m=l?f[s+4>>2]|0:H&255;H=m>>>0<y>>>0?m:y;if(H|0?(v=ZVb(u,l?f[s>>2]|0:s,H)|0,v|0):0)if((v|0)<0){r=z;continue}else{I=z;break e}if(y>>>0<m>>>0)r=z;else{I=z;break}}}while(0);if(G>>>0>=I>>>0){j=G;continue b}y=f[G>>2]|0;f[G>>2]=f[I>>2];f[I>>2]=y;E=I;F=G+4|0}}if((n|0)==74){n=0;f[j>>2]=f[B>>2];f[B>>2]=q;w=B;x=p+1|0}A=j+4|0;f:do if(A>>>0<w>>>0){y=o;u=w;t=A;r=x;while(1){z=f[y>>2]|0;m=b[z+11>>0]|0;v=m<<24>>24<0;H=v?f[z+4>>2]|0:m&255;g:do if(v){m=t;while(1){s=f[m>>2]|0;l=b[s+11>>0]|0;J=l<<24>>24<0;K=J?f[s+4>>2]|0:l&255;l=H>>>0<K>>>0?H:K;if((l|0)!=0?(L=ZVb(J?f[s>>2]|0:s,f[z>>2]|0,l)|0,(L|0)!=0):0){if((L|0)>=0){M=m;break g}}else n=80;if((n|0)==80?(n=0,K>>>0>=H>>>0):0){M=m;break g}m=m+4|0}}else{m=t;while(1){K=f[m>>2]|0;L=b[K+11>>0]|0;l=L<<24>>24<0;s=l?f[K+4>>2]|0:L&255;L=H>>>0<s>>>0?H:s;if((L|0)!=0?(J=ZVb(l?f[K>>2]|0:K,z,L)|0,(J|0)!=0):0){if((J|0)>=0){M=m;break g}}else n=84;if((n|0)==84?(n=0,s>>>0>=H>>>0):0){M=m;break g}m=m+4|0}}while(0);h:do if(v){m=u;while(1){s=m+-4|0;J=f[s>>2]|0;L=b[J+11>>0]|0;K=L<<24>>24<0;l=K?f[J+4>>2]|0:L&255;L=H>>>0<l>>>0?H:l;if(L|0?(N=ZVb(K?f[J>>2]|0:J,f[z>>2]|0,L)|0,N|0):0)if((N|0)<0){O=s;break h}else{m=s;continue}if(l>>>0<H>>>0){O=s;break}else m=s}}else{m=u;while(1){s=m+-4|0;l=f[s>>2]|0;N=b[l+11>>0]|0;L=N<<24>>24<0;J=L?f[l+4>>2]|0:N&255;N=H>>>0<J>>>0?H:J;if(N|0?(K=ZVb(L?f[l>>2]|0:l,z,N)|0,K|0):0)if((K|0)<0){O=s;break h}else{m=s;continue}if(J>>>0<H>>>0){O=s;break}else m=s}}while(0);if(M>>>0>O>>>0){P=y;Q=r;R=M;break f}H=f[M>>2]|0;f[M>>2]=f[O>>2];f[O>>2]=H;y=(y|0)==(M|0)?O:y;u=O;t=M+4|0;r=r+1|0}}else{P=o;Q=x;R=A}while(0);do if((R|0)==(P|0))S=Q;else{A=f[P>>2]|0;r=f[R>>2]|0;t=b[r+11>>0]|0;u=t<<24>>24<0;y=u?f[r+4>>2]|0:t&255;t=b[A+11>>0]|0;H=t<<24>>24<0;z=H?f[A+4>>2]|0:t&255;t=y>>>0<z>>>0?y:z;v=r;m=A;if((t|0)!=0?(s=ZVb(H?f[A>>2]|0:A,u?f[r>>2]|0:r,t)|0,(s|0)!=0):0){if((s|0)>=0){S=Q;break}}else n=101;if((n|0)==101?(n=0,z>>>0>=y>>>0):0){S=Q;break}f[R>>2]=m;f[P>>2]=v;S=Q+1|0}while(0);if(!S){T=bEa(j,R,d)|0;v=R+4|0;if(bEa(v,a,d)|0){n=110;break}if(T){i=v;continue}}v=R;if((v-k|0)>=(c-v|0)){n=109;break}VDa(j,R,d);i=R+4|0}if((n|0)==109){n=0;VDa(R+4|0,a,d);e=j;a=R;continue}else if((n|0)==110){n=0;if(T){n=111;break}else{e=j;a=R;continue}}}if((n|0)==5){R=f[g>>2]|0;e=f[j>>2]|0;T=b[e+11>>0]|0;k=T<<24>>24<0;S=k?f[e+4>>2]|0:T&255;T=b[R+11>>0]|0;Q=T<<24>>24<0;P=Q?f[R+4>>2]|0:T&255;T=S>>>0<P>>>0?S:P;x=e;o=R;if((T|0)!=0?(M=ZVb(Q?f[R>>2]|0:R,k?f[e>>2]|0:e,T)|0,(M|0)!=0):0){if((M|0)>=0)return}else n=7;if((n|0)==7?P>>>0>=S>>>0:0)return;f[j>>2]=o;f[g>>2]=x;return}else if((n|0)==10){ZDa(j,j+4|0,g,d)|0;return}else if((n|0)==11){_Da(j,j+4|0,j+8|0,g,d)|0;return}else if((n|0)==12){$Da(j,j+4|0,j+8|0,j+12|0,g,d)|0;return}else if((n|0)==14){aEa(j,a,d);return}else if((n|0)==111)return}function WDa(a){a=a|0;var c=0,d=0;f[a>>2]=106944;if((f[a+4>>2]|0)==(a|0)){O5b(a);return}if(f[a+16>>2]|0){O5b(a);return}c=a+8|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=f[a+12>>2]|0;if(!c){O5b(a);return}bi[f[(f[c>>2]|0)+4>>2]&2047](c);O5b(a);return}function XDa(a){a=a|0;return f[a+24>>2]|0}function YDa(a){a=a|0;return f[a+28>>2]|0}function ZDa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=f[c>>2]|0;g=f[a>>2]|0;h=b[g+11>>0]|0;i=h<<24>>24<0;j=g+4|0;k=i?f[j>>2]|0:h&255;h=b[e+11>>0]|0;l=h<<24>>24<0;m=l?f[e+4>>2]|0:h&255;h=k>>>0<m>>>0;n=h?k:m;o=e;p=g;if((n|0)!=0?(q=ZVb(l?f[e>>2]|0:e,i?f[g>>2]|0:g,n)|0,(q|0)!=0):0)r=q;else r=m>>>0<k>>>0?-1:h&1;h=(r|0)<0;r=f[d>>2]|0;k=b[r+11>>0]|0;q=k<<24>>24<0;n=q?f[r+4>>2]|0:k&255;k=m>>>0<n>>>0;i=k?m:n;s=r;if((i|0)!=0?(t=ZVb(q?f[r>>2]|0:r,l?f[e>>2]|0:e,i)|0,(t|0)!=0):0)u=t;else u=n>>>0<m>>>0?-1:k&1;k=(u|0)<0;if(!h){if(!k){v=0;return v|0}f[c>>2]=s;f[d>>2]=o;h=f[c>>2]|0;u=f[a>>2]|0;m=b[u+11>>0]|0;n=m<<24>>24<0;t=n?f[u+4>>2]|0:m&255;m=b[h+11>>0]|0;i=m<<24>>24<0;e=i?f[h+4>>2]|0:m&255;m=t>>>0<e>>>0?t:e;l=u;r=h;if((m|0)!=0?(q=ZVb(i?f[h>>2]|0:h,n?f[u>>2]|0:u,m)|0,(q|0)!=0):0){if((q|0)>=0){v=1;return v|0}}else w=11;if((w|0)==11?e>>>0>=t>>>0:0){v=1;return v|0}f[a>>2]=r;f[c>>2]=l;v=2;return v|0}if(k){f[a>>2]=s;f[d>>2]=p;v=1;return v|0}f[a>>2]=o;f[c>>2]=p;o=f[d>>2]|0;a=b[g+11>>0]|0;s=a<<24>>24<0;k=s?f[j>>2]|0:a&255;a=b[o+11>>0]|0;j=a<<24>>24<0;l=j?f[o+4>>2]|0:a&255;a=k>>>0<l>>>0?k:l;r=o;if((a|0)!=0?(t=ZVb(j?f[o>>2]|0:o,s?f[g>>2]|0:g,a)|0,(t|0)!=0):0){if((t|0)>=0){v=1;return v|0}}else w=18;if((w|0)==18?l>>>0>=k>>>0:0){v=1;return v|0}f[c>>2]=r;f[d>>2]=p;v=2;return v|0}function _Da(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=ZDa(a,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0;l=k?f[i+4>>2]|0:j&255;j=b[g+11>>0]|0;m=j<<24>>24<0;n=m?f[g+4>>2]|0:j&255;j=l>>>0<n>>>0?l:n;o=i;p=g;if((j|0)!=0?(q=ZVb(m?f[g>>2]|0:g,k?f[i>>2]|0:i,j)|0,(q|0)!=0):0){if((q|0)>=0){r=h;return r|0}}else s=3;if((s|0)==3?n>>>0>=l>>>0:0){r=h;return r|0}f[d>>2]=p;f[e>>2]=o;o=h+1|0;e=f[d>>2]|0;p=f[c>>2]|0;l=b[p+11>>0]|0;n=l<<24>>24<0;q=n?f[p+4>>2]|0:l&255;l=b[e+11>>0]|0;j=l<<24>>24<0;i=j?f[e+4>>2]|0:l&255;l=q>>>0<i>>>0?q:i;k=p;g=e;if((l|0)!=0?(m=ZVb(j?f[e>>2]|0:e,n?f[p>>2]|0:p,l)|0,(m|0)!=0):0){if((m|0)>=0){r=o;return r|0}}else s=7;if((s|0)==7?i>>>0>=q>>>0:0){r=o;return r|0}f[c>>2]=g;f[d>>2]=k;k=h+2|0;d=f[c>>2]|0;g=f[a>>2]|0;o=b[g+11>>0]|0;q=o<<24>>24<0;i=q?f[g+4>>2]|0:o&255;o=b[d+11>>0]|0;m=o<<24>>24<0;l=m?f[d+4>>2]|0:o&255;o=i>>>0<l>>>0?i:l;p=g;n=d;if((o|0)!=0?(e=ZVb(m?f[d>>2]|0:d,q?f[g>>2]|0:g,o)|0,(e|0)!=0):0){if((e|0)>=0){r=k;return r|0}}else s=11;if((s|0)==11?l>>>0>=i>>>0:0){r=k;return r|0}f[a>>2]=n;f[c>>2]=p;r=h+3|0;return r|0}function $Da(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=_Da(a,c,d,e,h)|0;h=f[g>>2]|0;j=f[e>>2]|0;k=b[j+11>>0]|0;l=k<<24>>24<0;m=l?f[j+4>>2]|0:k&255;k=b[h+11>>0]|0;n=k<<24>>24<0;o=n?f[h+4>>2]|0:k&255;k=m>>>0<o>>>0?m:o;p=j;q=h;if((k|0)!=0?(r=ZVb(n?f[h>>2]|0:h,l?f[j>>2]|0:j,k)|0,(r|0)!=0):0){if((r|0)>=0){s=i;return s|0}}else t=3;if((t|0)==3?o>>>0>=m>>>0:0){s=i;return s|0}f[e>>2]=q;f[g>>2]=p;p=i+1|0;g=f[e>>2]|0;q=f[d>>2]|0;m=b[q+11>>0]|0;o=m<<24>>24<0;r=o?f[q+4>>2]|0:m&255;m=b[g+11>>0]|0;k=m<<24>>24<0;j=k?f[g+4>>2]|0:m&255;m=r>>>0<j>>>0?r:j;l=q;h=g;if((m|0)!=0?(n=ZVb(k?f[g>>2]|0:g,o?f[q>>2]|0:q,m)|0,(n|0)!=0):0){if((n|0)>=0){s=p;return s|0}}else t=7;if((t|0)==7?j>>>0>=r>>>0:0){s=p;return s|0}f[d>>2]=h;f[e>>2]=l;l=i+2|0;e=f[d>>2]|0;h=f[c>>2]|0;p=b[h+11>>0]|0;r=p<<24>>24<0;j=r?f[h+4>>2]|0:p&255;p=b[e+11>>0]|0;n=p<<24>>24<0;m=n?f[e+4>>2]|0:p&255;p=j>>>0<m>>>0?j:m;q=h;o=e;if((p|0)!=0?(g=ZVb(n?f[e>>2]|0:e,r?f[h>>2]|0:h,p)|0,(g|0)!=0):0){if((g|0)>=0){s=l;return s|0}}else t=11;if((t|0)==11?m>>>0>=j>>>0:0){s=l;return s|0}f[c>>2]=o;f[d>>2]=q;q=i+3|0;d=f[c>>2]|0;o=f[a>>2]|0;l=b[o+11>>0]|0;j=l<<24>>24<0;m=j?f[o+4>>2]|0:l&255;l=b[d+11>>0]|0;g=l<<24>>24<0;p=g?f[d+4>>2]|0:l&255;l=m>>>0<p>>>0?m:p;h=o;r=d;if((l|0)!=0?(e=ZVb(g?f[d>>2]|0:d,j?f[o>>2]|0:o,l)|0,(e|0)!=0):0){if((e|0)>=0){s=q;return s|0}}else t=15;if((t|0)==15?p>>>0>=m>>>0:0){s=q;return s|0}f[a>>2]=r;f[c>>2]=h;s=i+4|0;return s|0}function aEa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=a+8|0;ZDa(a,a+4|0,e,d)|0;d=a+12|0;if((d|0)==(c|0))return;else{g=d;h=e}while(1){e=f[g>>2]|0;d=f[h>>2]|0;i=b[d+11>>0]|0;j=i<<24>>24<0;k=j?f[d+4>>2]|0:i&255;i=b[e+11>>0]|0;l=i<<24>>24<0;m=e+4|0;n=l?f[m>>2]|0:i&255;i=k>>>0<n>>>0?k:n;o=e;p=d;if((i|0)!=0?(q=ZVb(l?f[e>>2]|0:e,j?f[d>>2]|0:d,i)|0,(q|0)!=0):0){if((q|0)<0)r=7}else r=5;if((r|0)==5?(r=0,n>>>0<k>>>0):0)r=7;if((r|0)==7){r=0;f[g>>2]=p;a:do if((h|0)==(a|0))s=h;else{p=b[e+11>>0]|0;k=p<<24>>24<0;n=p&255;p=h;q=h;while(1){i=q;q=p+-4|0;d=f[q>>2]|0;j=b[d+11>>0]|0;l=j<<24>>24<0;t=l?f[d+4>>2]|0:j&255;j=k?f[m>>2]|0:n;u=t>>>0<j>>>0?t:j;v=d;if((u|0)!=0?(w=ZVb(k?f[e>>2]|0:e,l?f[d>>2]|0:d,u)|0,(w|0)!=0):0){if((w|0)>=0){s=i;break a}}else r=11;if((r|0)==11?(r=0,j>>>0>=t>>>0):0){s=i;break a}f[i>>2]=v;if((q|0)==(a|0)){s=q;break}else p=q}}while(0);f[s>>2]=o}e=g+4|0;if((e|0)==(c|0))break;else{m=g;g=e;h=m}}return}function bEa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;switch(c-a>>2|0){case 2:{e=c+-4|0;g=f[e>>2]|0;h=f[a>>2]|0;i=b[h+11>>0]|0;j=i<<24>>24<0;k=j?f[h+4>>2]|0:i&255;i=b[g+11>>0]|0;l=i<<24>>24<0;m=l?f[g+4>>2]|0:i&255;i=k>>>0<m>>>0?k:m;n=h;o=g;if((i|0)!=0?(p=ZVb(l?f[g>>2]|0:g,j?f[h>>2]|0:h,i)|0,(p|0)!=0):0){if((p|0)>=0){q=1;return q|0}}else r=4;if((r|0)==4?m>>>0>=k>>>0:0){q=1;return q|0}f[a>>2]=o;f[e>>2]=n;q=1;return q|0}case 3:{ZDa(a,a+4|0,c+-4|0,d)|0;q=1;return q|0}case 4:{_Da(a,a+4|0,a+8|0,c+-4|0,d)|0;q=1;return q|0}case 5:{$Da(a,a+4|0,a+8|0,a+12|0,c+-4|0,d)|0;q=1;return q|0}case 1:case 0:{q=1;return q|0}default:{n=a+8|0;ZDa(a,a+4|0,n,d)|0;d=a+12|0;a:do if((d|0)==(c|0)){s=1;t=0}else{e=d;o=0;k=n;while(1){m=f[e>>2]|0;p=f[k>>2]|0;i=b[p+11>>0]|0;h=i<<24>>24<0;j=h?f[p+4>>2]|0:i&255;i=b[m+11>>0]|0;g=i<<24>>24<0;l=m+4|0;u=g?f[l>>2]|0:i&255;i=j>>>0<u>>>0?j:u;v=m;w=p;if((i|0)!=0?(x=ZVb(g?f[m>>2]|0:m,h?f[p>>2]|0:p,i)|0,(x|0)!=0):0)if((x|0)<0)r=15;else y=o;else if(u>>>0<j>>>0)r=15;else y=o;if((r|0)==15){r=0;f[e>>2]=w;b:do if((k|0)==(a|0))z=k;else{w=b[m+11>>0]|0;j=w<<24>>24<0;u=w&255;w=k;x=k;while(1){x=x+-4|0;i=f[x>>2]|0;p=b[i+11>>0]|0;h=p<<24>>24<0;g=h?f[i+4>>2]|0:p&255;p=j?f[l>>2]|0:u;A=g>>>0<p>>>0?g:p;B=i;if((A|0)!=0?(C=ZVb(j?f[m>>2]|0:m,h?f[i>>2]|0:i,A)|0,(C|0)!=0):0){if((C|0)>=0){z=w;break b}}else r=19;if((r|0)==19?(r=0,p>>>0>=g>>>0):0){z=w;break b}f[w>>2]=B;if((x|0)==(a|0)){z=x;break}else w=x}}while(0);f[z>>2]=v;m=o+1|0;if((m|0)==8){s=0;t=(e+4|0)==(c|0);break a}else y=m}m=e+4|0;if((m|0)==(c|0)){s=1;t=0;break}else{l=e;e=m;o=y;k=l}}}while(0);q=t|s;return q|0}}return 0}function cEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+80|0;e=d+48|0;g=d+24|0;h=d;i=f[c>>2]|0;j=c+4|0;if(i>>>0<(f[j>>2]|0)>>>0?(b[i>>0]|0)==10:0){f[c>>2]=i+1;i=a+8|0;if(!(fqb(c,i)|0)){k=0;u=d;return k|0}l=f[c>>2]|0;if(((f[j>>2]|0)-l|0)>0?(b[l>>0]|0)==18:0){l=a+4|0;m=f[l>>2]|0;n=m+12|0;if(!(b[m+8>>0]|0))o=f[n>>2]|0;else o=(f[n>>2]|0)+20|0;n=f[o>>2]|0;o=HCa(m,i)|0;m=a+20|0;f[m>>2]=o;o=f[l>>2]|0;p=o+12|0;if(!(b[o+8>>0]|0))q=f[p>>2]|0;else q=(f[p>>2]|0)+20|0;if((n|0)!=(f[q>>2]|0)){Tnb(c,1)|0;q=f[m>>2]|0;m=f[c>>2]|0;if(m>>>0<(f[j>>2]|0)>>>0?(n=b[m>>0]|0,n<<24>>24>-1):0){f[c>>2]=m+1;r=n&255;s=17}else s=16;if((s|0)==16?(n=Znb(c)|0,(n|0)>-1):0){r=n;s=17}do if(((s|0)==17?(Inb(e,c,r),(f[e+4>>2]|0)>=0):0)?JGa(q,c)|0:0){if(!(Onb(c,f[e>>2]|0)|0))break;do if((f[c>>2]|0)==(f[j>>2]|0)){if((f[c+32>>2]|0)==0?(f[c+12>>2]|0)!=(f[c+28>>2]|0):0)break;f[c+20>>2]=0;b[c+24>>0]=1;k=1;u=d;return k|0}while(0);k=dEa(a,c)|0;u=d;return k|0}while(0);j=f[l>>2]|0;l=j+8|0;if(!(b[l>>0]|0)){wxa(e,f[j+12>>2]|0,i);t=2;v=f[e+12>>2]|0;w=0;x=f[e>>2]|0;y=f[e+4>>2]|0;z=f[e+8>>2]|0}else{t=1;v=0;w=Hxa(f[j+12>>2]|0,i)|0;x=0;y=0;z=0}a:do if((t|0)==(((b[l>>0]|0)==0?2:1)|0))switch(t&3){case 0:{break a;break}case 1:{if(!w)break a;else{s=28;break a}break}default:if(!x)break a;else{s=28;break a}}else s=28;while(0);if((s|0)==28){f[g>>2]=t;f[g+4>>2]=x;f[g+8>>2]=y;f[g+12>>2]=z;f[g+16>>2]=v;f[g+20>>2]=w;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[e+16>>2]=f[g+16>>2];f[e+20>>2]=f[g+20>>2];Bxa(h,j,e)}k=0;u=d;return k|0}}}else s=35;if((s|0)==35?(f[e>>2]=0,f[e+4>>2]=0,f[e+8>>2]=0,_5b(a+8|0,e)|0,(b[e+11>>0]|0)<0):0)O5b(f[e>>2]|0);e=f[(f[a>>2]|0)+32>>2]|0;if(!e){s=L5b(24)|0;f[s>>2]=106944;f[s+4>>2]=0;f[s+16>>2]=0;A=s}else{s=znb(e,18368,24)|0;f[s>>2]=106944;f[s+4>>2]=0;f[s+16>>2]=e;A=s}f[A+8>>2]=497760;f[A+12>>2]=0;f[A+20>>2]=0;s=a+24|0;e=f[s>>2]|0;if((e|0)==(A|0))B=A;else{if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);f[s>>2]=A;B=A}A=B+20|0;f[A>>2]=f[A>>2]|1;A=B+8|0;e=f[A>>2]|0;if((e|0)==497760){dya(A,f[B+16>>2]|0,497760);C=f[A>>2]|0}else C=e;_5b(C,a+8|0)|0;C=f[s>>2]|0;if(!(Uh[f[(f[C>>2]|0)+44>>2]&1023](C,c)|0)){k=0;u=d;return k|0}k=eEa(a)|0;u=d;return k|0}function dEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+80|0;e=d;g=d+48|0;h=d+24|0;i=f[(f[a>>2]|0)+32>>2]|0;if(!i){j=L5b(24)|0;f[j>>2]=106944;f[j+4>>2]=0;f[j+16>>2]=0;k=j}else{j=znb(i,18368,24)|0;f[j>>2]=106944;f[j+4>>2]=0;f[j+16>>2]=i;k=j}f[k+8>>2]=497760;f[k+12>>2]=0;f[k+20>>2]=0;j=a+24|0;i=f[j>>2]|0;if((i|0)==(k|0))l=k;else{if(i|0)bi[f[(f[i>>2]|0)+4>>2]&2047](i);f[j>>2]=k;l=k}k=f[a+20>>2]|0;i=l+20|0;f[i>>2]=f[i>>2]|2;i=l+12|0;m=f[l+16>>2]|0;l=f[i>>2]|0;if(!l){if(!m){n=L5b(24)|0;bHa(n);o=n}else{n=znb(m,18600,24)|0;gHa(n,m);o=n}f[i>>2]=o;p=o}else p=l;kHa(p,k);k=f[a+4>>2]|0;p=a+8|0;l=k+8|0;if(!(b[l>>0]|0)){wxa(e,f[k+12>>2]|0,p);q=2;r=f[e+12>>2]|0;s=0;t=f[e>>2]|0;v=f[e+4>>2]|0;w=f[e+8>>2]|0}else{q=1;r=0;s=Hxa(f[k+12>>2]|0,p)|0;t=0;v=0;w=0}a:do if((q|0)==(((b[l>>0]|0)==0?2:1)|0))switch(q&3){case 0:{break a;break}case 1:{if(!s)break a;else{x=20;break a}break}default:if(!t)break a;else{x=20;break a}}else x=20;while(0);if((x|0)==20){f[g>>2]=q;f[g+4>>2]=t;f[g+8>>2]=v;f[g+12>>2]=w;f[g+16>>2]=r;f[g+20>>2]=s;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[e+16>>2]=f[g+16>>2];f[e+20>>2]=f[g+20>>2];Bxa(h,k,e)}k=f[j>>2]|0;h=k+20|0;f[h>>2]=f[h>>2]|1;h=k+8|0;g=f[h>>2]|0;if((g|0)==497760){dya(h,f[k+16>>2]|0,497760);y=f[h>>2]|0}else y=g;f[e>>2]=f[y>>2];f[e+4>>2]=f[y+4>>2];f[e+8>>2]=f[y+8>>2];f[y>>2]=f[p>>2];f[y+4>>2]=f[p+4>>2];f[y+8>>2]=f[p+8>>2];f[p>>2]=f[e>>2];f[p+4>>2]=f[e+4>>2];f[p+8>>2]=f[e+8>>2];e=f[j>>2]|0;if(!(Uh[f[(f[e>>2]|0)+44>>2]&1023](e,c)|0)){z=0;u=d;return z|0}z=eEa(a)|0;u=d;return z|0}function eEa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a+24|0;c=f[b>>2]|0;d=a+8|0;_5b(d,di[f[(f[c>>2]|0)+72>>2]&1023](c)|0)|0;c=HCa(f[a+4>>2]|0,d)|0;d=a+20|0;f[d>>2]=c;a=f[b>>2]|0;e=a+20|0;f[e>>2]=f[e>>2]|2;e=a+12|0;g=f[a+16>>2]|0;a=f[e>>2]|0;if(!a){if(!g){h=L5b(24)|0;bHa(h);i=h}else{h=znb(g,18600,24)|0;gHa(h,g);i=h}f[e>>2]=i;j=f[d>>2]|0;k=i}else{j=c;k=a}kHa(j,k);k=f[b>>2]|0;if(!(di[f[(f[k>>2]|0)+20>>2]&1023](k)|0))return 1;f[b>>2]=0;return 1}function fEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=107040;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;d=a+24|0;f[d>>2]=140148;f[a+28>>2]=c;f[a+32>>2]=0;e=a+36|0;f[e>>2]=0;g=a+40|0;f[g>>2]=0;h=a+44|0;Bpb(h);f[a+48>>2]=0;gEa(c,h);f[d>>2]=107196;h=a+52|0;f[h>>2]=107148;f[a+56>>2]=c;if(!c){i=L5b(16)|0;f[i>>2]=0;f[i+4>>2]=0;b[i+8>>0]=1;Fxa(i);j=i}else{i=znb(c,18528,16)|0;f[i>>2]=c;f[i+4>>2]=0;b[i+8>>0]=1;Fxa(i);j=i}f[a+60>>2]=j;j=(di[f[(f[h>>2]|0)+36>>2]&1023](h)|0)+4|0;f[j>>2]=0;f[d>>2]=107280;f[h>>2]=107384;f[a+64>>2]=0;f[g>>2]=12;f[e>>2]=851864;f[a+68>>2]=497760;f[a+72>>2]=497760;f[a+76>>2]=497760;f[a+80>>2]=0;return}function gEa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1494);return}function hEa(a){a=a|0;Cpb(a);return}function iEa(a){a=a|0;var c=0,d=0,e=0;c=f[a+4>>2]|0;d=c&-2;if(!(c&1))e=d;else e=f[d+4>>2]|0;if(e|0)return;e=a+68|0;d=f[e>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[e>>2]=497760;e=a+72|0;d=f[e>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[e>>2]=497760;e=a+76|0;a=f[e>>2]|0;if(!((a|0)==497760|(a|0)==0)){if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a)}f[e>>2]=497760;return}function jEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;kEa(a+8|0,b+8|0);c=(b|0)==491864;if(!c?(d=b+24|0,e=f[d>>2]|0,e|0):0){g=a+24|0;h=f[g>>2]|0;if(!h){i=f[a+4>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;if(!k){j=L5b(36)|0;QEa(j);l=j}else{j=znb(k,18536,36)|0;REa(j,k);l=j}f[g>>2]=l;m=f[d>>2]|0;n=l}else{m=e;n=h}VEa(n,(m|0)==0?492008:m)}m=f[b+32>>2]|0;if(m|0)f[a+32>>2]=m;if(c)return;c=b+28|0;b=f[c>>2]|0;if(!b)return;m=a+28|0;n=f[m>>2]|0;if(!n){h=f[a+4>>2]|0;a=h&-2;if(!(h&1))o=a;else o=f[a+4>>2]|0;if(!o){a=L5b(44)|0;_Ia(a);p=a}else{a=znb(o,18616,44)|0;cJa(a,o);p=a}f[m>>2]=p;q=f[c>>2]|0;r=p}else{q=b;r=n}dJa(r,(q|0)==0?492488:q);return}function kEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{lEa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=mEa(h,i)|0;lEa(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function lEa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))SDa(1332);else{TDa(b,a);return}}function mEa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(84)|0;uCa(a);c=a;return c|0}else{a=znb(b,18496,84)|0;fEa(a,b);c=a;return c|0}return 0}function nEa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=106684;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;if((a|0)!=491864?(f[212959]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=10;b[d+8>>0]=0;Gpb(851836,d);hpb(d)}d=a+24|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function oEa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212960]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=9;b[c+8>>0]=0;Gpb(851840,c);hpb(c);u=a;return}function pEa(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=107040;c=a+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;vCa(a+24|0);f[a+40>>2]=12;f[a+36>>2]=851864;f[a+68>>2]=497760;f[a+72>>2]=497760;f[a+76>>2]=497760;f[a+80>>2]=0;TDa(a,b);return}function qEa(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);TDa(a,b);return}function rEa(a){a=a|0;var b=0,c=0;f[a>>2]=107520;b=f[a+16>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function sEa(a){a=a|0;var b=0,c=0;f[a>>2]=107520;b=f[a+16>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function tEa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function uEa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(36)|0;QEa(a);c=a;return c|0}else{a=znb(b,18536,36)|0;REa(a,b);c=a;return c|0}return 0}function vEa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function wEa(a){a=a|0;return f[a+4>>2]|0}function xEa(a){a=a|0;var b=0;b=a+24|0;f[b>>2]=0;f[b+4>>2]=0;f[a+8>>2]=0;return}function yEa(a){a=a|0;return 1}function zEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0;d=c+4|0;e=c+20|0;g=a+24|0;h=a+28|0;i=a+8|0;j=a+12|0;k=a+16|0;a=c+32|0;l=c+12|0;m=c+28|0;a:while(1){n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){o=b[n>>0]|0;p=o&255;if(o<<24>>24>0){f[e>>2]=p;f[c>>2]=n+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=_nb(c,s)|0;f[e>>2]=p;if((p+-1|0)>>>0<127){q=p;r=6}else{t=p;r=46}}b:do if((r|0)==6){r=0;c:do switch(q>>>3&536870911|0){case 1:{switch(q|0){case 0:{u=1;r=49;break a;break}case 8:break;default:{v=q;break b}}p=f[c>>2]|0;n=f[d>>2]|0;if(p>>>0<n>>>0){o=b[p>>0]|0;w=o&255;if(o<<24>>24>-1){o=p+1|0;f[c>>2]=o;x=w;y=o;z=n}else{A=w;r=11}}else{A=0;r=11}if((r|0)==11){r=0;w=Knb(c,A)|0;n=J;if(!((n|0)>-1|(n|0)==-1&w>>>0>4294967295)){u=0;r=49;break a}x=w;y=f[c>>2]|0;z=f[d>>2]|0}f[g>>2]=x;if(y>>>0>=z>>>0)continue a;if((b[y>>0]|0)!=16)continue a;w=y+1|0;f[c>>2]=w;B=w;C=z;r=18;break}case 2:{switch(q|0){case 0:{u=1;r=49;break a;break}case 16:break;default:{v=q;break b}}B=f[c>>2]|0;C=f[d>>2]|0;r=18;break}case 3:{switch(q|0){case 0:{u=1;r=49;break a;break}case 26:{D=f[c>>2]|0;E=f[d>>2]|0;r=28;break c;break}case 24:{if(PEa(1,26,c,i)|0)break c;else{u=0;r=49;break a}break}default:{v=q;break b}}break}default:{t=q;r=46;break b}}while(0);if((r|0)==18){r=0;if(B>>>0<C>>>0){w=b[B>>0]|0;n=w&255;if(w<<24>>24>-1){w=B+1|0;f[c>>2]=w;F=n;G=w;H=C}else{I=n;r=21}}else{I=0;r=21}if((r|0)==21){r=0;n=Knb(c,I)|0;w=J;if(!((w|0)>-1|(w|0)==-1&n>>>0>4294967295)){u=0;r=49;break a}F=n;G=f[c>>2]|0;H=f[d>>2]|0}f[h>>2]=F;if(G>>>0>=H>>>0)continue a;if((b[G>>0]|0)!=26)continue a;n=G+1|0;f[c>>2]=n;D=n;E=H;r=28}if((r|0)==28){r=0;if(D>>>0<E>>>0?(n=b[D>>0]|0,n<<24>>24>-1):0){f[c>>2]=D+1;K=n&255}else{n=Znb(c)|0;if((n|0)>-1)K=n;else{u=0;r=49;break a}}n=Gnb(c,K)|0;if((Qnb(c)|0)>0)do{w=f[c>>2]|0;if(w>>>0<(f[d>>2]|0)>>>0){o=b[w>>0]|0;p=o&255;if(o<<24>>24>-1){f[c>>2]=w+1;L=p}else{M=p;r=36}}else{M=0;r=36}if((r|0)==36){r=0;p=Knb(c,M)|0;w=J;if((w|0)>-1|(w|0)==-1&p>>>0>4294967295)L=p;else{u=0;r=49;break a}}p=f[i>>2]|0;if((p|0)==(f[j>>2]|0)){nza(i,p+1|0);N=f[i>>2]|0}else N=p;p=f[k>>2]|0;f[i>>2]=N+1;f[p+4+(N<<2)>>2]=L}while((Qnb(c)|0)>0);Hnb(c,n)}if((f[c>>2]|0)!=(f[d>>2]|0))continue a;if(f[a>>2]|0){r=45;break a}if((f[l>>2]|0)==(f[m>>2]|0)){r=45;break a}else continue a}while(0);if((r|0)==46){r=0;if(!t){u=1;r=49;break}else v=t}if((v&7|0)==4){u=1;r=49;break}if(!(Lpb(c,v)|0)){u=0;r=49;break}}if((r|0)==45){f[e>>2]=0;b[c+24>>0]=1;u=1;return u|0}else if((r|0)==49)return u|0;return 0}function AEa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+24>>2]|0;if(b)if((b|0)>=0)if(b>>>0<128)c=2;else c=(iob(b)|0)+1|0;else c=11;else c=0;b=f[a+28>>2]|0;if(!b)d=c;else{if((b|0)>=0)if(b>>>0<128)e=2;else e=(iob(b)|0)+1|0;else e=11;d=e+c|0}c=f[a+8>>2]|0;if(c){e=a+16|0;b=0;g=0;do{h=f[(f[e>>2]|0)+4+(g<<2)>>2]|0;if((h|0)>=0)if(h>>>0<128)i=1;else i=iob(h)|0;else i=10;b=i+b|0;g=g+1|0}while((g|0)!=(c|0));if(b){if((b|0)>=0)if(b>>>0<128)j=2;else j=(iob(b)|0)+1|0;else j=11;k=b;l=j+d|0}else{k=0;l=d}}else{k=0;l=d}f[a+20>>2]=k;d=l+k|0;f[a+32>>2]=d;return d|0}function BEa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a+24>>2]|0;if(d|0)Mpb(1,d,c);d=f[a+28>>2]|0;if(d|0)Mpb(2,d,c);d=a+8|0;if((f[d>>2]|0)<=0)return;e=c+8|0;if((f[e>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=26;f[g>>2]=(f[g>>2]|0)+1;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;h=g}else{fob(c,26);h=f[e>>2]|0}g=f[a+20>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else fob(c,g);if((f[d>>2]|0)<=0)return;g=a+16|0;a=c+8|0;o=c+4|0;e=0;do{h=f[(f[g>>2]|0)+4+(e<<2)>>2]|0;do if((h|0)<0)gob(c,h,((h|0)<0)<<31>>31);else{if((f[a>>2]|0)<=4){fob(c,h);break}i=f[o>>2]|0;if(h>>>0>127){n=h;k=i;while(1){b[k>>0]=n|128;j=n>>>7;l=k+1|0;if(n>>>0>16383){n=j;k=l}else{p=l;q=j;break}}}else{p=i;q=h}b[p>>0]=q;k=p+1-i|0;f[o>>2]=(f[o>>2]|0)+k;f[a>>2]=(f[a>>2]|0)-k}while(0);e=e+1|0}while((e|0)<(f[d>>2]|0));return}function CEa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function DEa(a){a=a|0;return f[a+32>>2]|0}function EEa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=f[a+24>>2]|0;do if(!c)e=d;else{b[d>>0]=8;g=d+1|0;if((c|0)<0){e=hob(c,((c|0)<0)<<31>>31,g)|0;break}if(c>>>0>127){h=c;i=g;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=g;m=c}b[l>>0]=m;e=l+1|0}while(0);l=f[a+28>>2]|0;do if(!l)n=e;else{b[e>>0]=16;m=e+1|0;if((l|0)<0){n=hob(l,((l|0)<0)<<31>>31,m)|0;break}if(l>>>0>127){c=l;d=m;while(1){b[d>>0]=c|128;i=c>>>7;h=d+1|0;if(c>>>0>16383){c=i;d=h}else{o=h;p=i;break}}}else{o=m;p=l}b[o>>0]=p;n=o+1|0}while(0);o=a+8|0;if((f[o>>2]|0)<=0){q=n;return q|0}b[n>>0]=26;p=n+1|0;n=f[a+20>>2]|0;if(n>>>0>127){l=n;e=p;while(1){b[e>>0]=l|128;d=l>>>7;c=e+1|0;if(l>>>0>16383){l=d;e=c}else{r=c;s=d;break}}}else{r=p;s=n}b[r>>0]=s;s=r+1|0;if((f[o>>2]|0)<=0){q=s;return q|0}r=a+16|0;a=0;n=s;while(1){s=f[(f[r>>2]|0)+4+(a<<2)>>2]|0;if((s|0)<0)t=hob(s,((s|0)<0)<<31>>31,n)|0;else{if(s>>>0>127){p=s;e=n;while(1){b[e>>0]=p|128;l=p>>>7;d=e+1|0;if(p>>>0>16383){p=l;e=d}else{u=d;v=l;break}}}else{u=n;v=s}b[u>>0]=v;t=u+1|0}a=a+1|0;if((a|0)>=(f[o>>2]|0)){q=t;break}else n=t}return q|0}function FEa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function GEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((a|0)==(b|0))OEa(418);c=T6b(b,23288,18536,0)|0;if(!c){cOb(b,a);return}b=a+8|0;d=c+8|0;e=f[d>>2]|0;if(e|0){nza(b,(f[b>>2]|0)+e|0);Vac((f[a+16>>2]|0)+4+(f[b>>2]<<2)|0,(f[c+16>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[b>>2]=(f[b>>2]|0)+(f[d>>2]|0)}d=f[c+24>>2]|0;if(d|0)f[a+24>>2]=d;d=f[c+28>>2]|0;if(!d)return;f[a+28>>2]=d;return}function HEa(a,b){a=a|0;b=b|0;f[a+32>>2]=b;return}function IEa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[212969]|0)!=2){f[d>>2]=135812;f[d+4>>2]=13;b[d+8>>0]=0;Gpb(851876,d);hpb(d)}f[a>>2]=f[212970];f[a+4>>2]=f[212971];u=c;return}function JEa(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+48|0;c=a+24|0;d=a;e=a+36|0;if((f[212968]|0)!=2){f[c>>2]=135812;f[c+4>>2]=14;b[c+8>>0]=0;Gpb(851872,c);hpb(c)}g=drb()|0;h=L5b(16)|0;f[c>>2]=h;f[c+8>>2]=-2147483632;f[c+4>>2]=14;i=h;j=384014;k=i+14|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+14>>0]=0;h=hrb(g,c)|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if(h|0){l=h+40|0;m=f[l>>2]|0;f[212970]=m;n=pIb(m,492008,107620,-1,-1,-1,36,4,-1)|0;f[212971]=n;u=a;return}zpb(d,3,384029,37);xpb(e,vpb(d,459532)|0);Apb(d);l=h+40|0;m=f[l>>2]|0;f[212970]=m;n=pIb(m,492008,107620,-1,-1,-1,36,4,-1)|0;f[212971]=n;u=a;return}function KEa(){var a=0,c=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,384029);if((f[212967]|0)!=2){f[c>>2]=135812;f[c+4>>2]=15;b[c+8>>0]=0;Gpb(851868,c);hpb(c)}grb(384112,162);SNb(384014,1495);spb(16);u=a;return}function LEa(){var a=0;kpb(3001e3,3001e3,384029);f[123002]=107520;f[123003]=0;f[123004]=0;f[123005]=0;f[123006]=0;a=492032;f[a>>2]=0;f[a+4>>2]=0;f[123010]=0;b[492048]=1;return}function MEa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[212969]|0)!=2){f[c>>2]=135812;f[c+4>>2]=13;b[c+8>>0]=0;Gpb(851876,c);hpb(c)}WNb(f[212970]|0,492008);u=a;return}function NEa(){var a=0;if(b[492048]|0){b[492048]=0;bi[f[f[123002]>>2]&2047](492008)}a=f[212971]|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function OEa(a){a=a|0;Enb(384029,a)}function PEa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;a=f[d>>2]|0;g=d+4|0;if(a>>>0<(f[g>>2]|0)>>>0){i=b[a>>0]|0;j=i&255;if(i<<24>>24>-1){f[d>>2]=a+1;k=j}else{l=j;m=4}}else{l=0;m=4}if((m|0)==4){j=Knb(d,l)|0;l=J;if((l|0)>-1|(l|0)==-1&j>>>0>4294967295)k=j;else{n=0;return n|0}}j=f[e>>2]|0;l=e+4|0;if((j|0)==(f[l>>2]|0)){nza(e,j+1|0);o=f[e>>2]|0}else o=j;j=e+8|0;a=f[j>>2]|0;f[e>>2]=o+1;f[a+4+(o<<2)>>2]=k;k=(f[l>>2]|0)-(f[e>>2]|0)|0;if((k|0)<=0){n=1;return n|0}l=c&127|128;o=c>>>7&255;if(c>>>0<128){i=k;p=a;while(1){q=f[d>>2]|0;r=f[g>>2]|0;if(q>>>0>=r>>>0){n=1;m=27;break}if((h[q>>0]|0)!=(c|0)){n=1;m=27;break}s=q+1|0;f[d>>2]=s;if(s>>>0<r>>>0){r=b[s>>0]|0;s=r&255;if(r<<24>>24>-1){f[d>>2]=q+2;t=s;u=p}else{v=s;m=13}}else{v=0;m=13}if((m|0)==13){m=0;s=Knb(d,v)|0;q=J;if(!((q|0)>-1|(q|0)==-1&s>>>0>4294967295)){n=0;m=27;break}t=s;u=f[j>>2]|0}s=f[e>>2]|0;f[e>>2]=s+1;f[u+4+(s<<2)>>2]=t;if((i|0)>1){i=i+-1|0;p=u}else{n=1;m=27;break}}if((m|0)==27)return n|0}if(c>>>0<16384){w=k;x=a}else{n=1;return n|0}while(1){a=f[g>>2]|0;k=f[d>>2]|0;c=k;if((a-k|0)<=1){n=1;m=27;break}if((h[c>>0]|0)!=(l|0)){n=1;m=27;break}if((b[c+1>>0]|0)!=o<<24>>24){n=1;m=27;break}k=c+2|0;f[d>>2]=k;if(k>>>0<a>>>0){a=b[k>>0]|0;k=a&255;if(a<<24>>24>-1){f[d>>2]=c+3;y=k;z=x}else{A=k;m=23}}else{A=0;m=23}if((m|0)==23){m=0;k=Knb(d,A)|0;c=J;if(!((c|0)>-1|(c|0)==-1&k>>>0>4294967295)){n=0;m=27;break}y=k;z=f[j>>2]|0}k=f[e>>2]|0;f[e>>2]=k+1;f[z+4+(k<<2)>>2]=y;if((w|0)>1){w=w+-1|0;x=z}else{n=1;m=27;break}}if((m|0)==27)return n|0;return 0}function QEa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=107520;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=492008?(f[212967]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=15;b[d+8>>0]=0;Gpb(851868,d);hpb(d)}d=a+24|0;f[d>>2]=0;f[d+4>>2]=0;f[a+32>>2]=0;u=c;return}function REa(a,b){a=a|0;b=b|0;var c=0,d=0;f[a>>2]=107520;f[a+4>>2]=b;f[a+8>>2]=0;f[a+12>>2]=0;c=a+16|0;f[c>>2]=0;if(b|0){d=znb(b,25528,4)|0;f[c>>2]=d;f[d>>2]=b}b=a+24|0;f[b>>2]=0;f[b+4>>2]=0;f[a+32>>2]=0;return}function SEa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212968]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=14;b[c+8>>0]=0;Gpb(851872,c);hpb(c);u=a;return}function TEa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212968]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=14;b[c+8>>0]=0;Gpb(851872,c);hpb(c);u=a;return}function UEa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212967]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=15;b[c+8>>0]=0;Gpb(851868,c);hpb(c);u=a;return}function VEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)==(a|0))OEa(436);c=a+8|0;d=b+8|0;e=f[d>>2]|0;if(e|0){nza(c,(f[c>>2]|0)+e|0);Vac((f[a+16>>2]|0)+4+(f[c>>2]<<2)|0,(f[b+16>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[c>>2]=(f[c>>2]|0)+(f[d>>2]|0)}d=f[b+24>>2]|0;if(d|0)f[a+24>>2]=d;d=f[b+28>>2]|0;if(!d)return;f[a+28>>2]=d;return}function WEa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=107640;c=a+4|0;d=f[c>>2]|0;e=d&-2;if(!(d&1))g=e;else g=f[e+4>>2]|0;if(!g){g=a+152|0;e=f[g>>2]|0;if(!((e|0)==497760|(e|0)==0)){if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);O5b(e)}f[g>>2]=497760;if((a|0)!=492056?(g=f[a+156>>2]|0,g|0):0)bi[f[(f[g>>2]|0)+4>>2]&2047](g)}g=f[a+144>>2]|0;if(g|0?(f[g>>2]|0)==0:0)O5b(g);g=f[a+128>>2]|0;if(g|0?(f[g>>2]|0)==0:0)O5b(g);g=f[a+112>>2]|0;if(g|0?(f[g>>2]|0)==0:0)O5b(g);g=f[a+96>>2]|0;if(g|0?(f[g>>2]|0)==0:0)O5b(g);g=a+84|0;e=f[g>>2]|0;if(e|0?(f[a+72>>2]|0)==0:0){d=f[e>>2]|0;if((d|0)>0){h=0;do{i=f[e+4+(h<<2)>>2]|0;if(i|0){if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);O5b(i)}h=h+1|0}while((h|0)!=(d|0));j=f[g>>2]|0}else j=e;O5b(j)}f[g>>2]=0;g=f[a+64>>2]|0;if(g|0?(f[g>>2]|0)==0:0)O5b(g);g=f[a+48>>2]|0;if(g|0?(f[g>>2]|0)==0:0)O5b(g);g=f[a+32>>2]|0;if(g|0?(f[g>>2]|0)==0:0)O5b(g);g=f[a+16>>2]|0;if(g|0?(f[g>>2]|0)==0:0)O5b(g);g=f[c>>2]|0;if(!(g&1)){f[c>>2]=0;return}a=g&-2;g=a;if((a|0)==0|(f[g+4>>2]|0)!=0){f[c>>2]=0;return}if(f[g>>2]|0)GPb(g);O5b(a);f[c>>2]=0;return}function XEa(a){a=a|0;WEa(a);O5b(a);return}function YEa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function ZEa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(172)|0;AFa(a);c=a;return c|0}else{a=znb(b,18552,172)|0;BFa(a,b);c=a;return c|0}return 0}function _Ea(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function $Ea(a){a=a|0;return f[a+4>>2]|0}function aFa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+160|0;f[c>>2]=0;f[c+4>>2]=0;c=f[a+4>>2]|0;d=c&-2;if(!(c&1))e=d;else e=f[d+4>>2]|0;d=a+156|0;if((e|0)==0?(e=f[d>>2]|0,e|0):0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);f[d>>2]=0;d=f[a+152>>2]|0;do if((d|0)!=497760){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);f[a+8>>2]=0;f[a+24>>2]=0;f[a+40>>2]=0;f[a+56>>2]=0;d=a+76|0;e=f[d>>2]|0;if((e|0)<=0){g=a+88|0;f[g>>2]=0;h=a+104|0;f[h>>2]=0;i=a+120|0;f[i>>2]=0;j=a+136|0;f[j>>2]=0;return}c=f[a+84>>2]|0;k=0;do{l=f[c+4+(k<<2)>>2]|0;k=k+1|0;m=l+11|0;if((b[m>>0]|0)<0){b[f[l>>2]>>0]=0;f[l+4>>2]=0}else{b[l>>0]=0;b[m>>0]=0}}while((k|0)!=(e|0));f[d>>2]=0;g=a+88|0;f[g>>2]=0;h=a+104|0;f[h>>2]=0;i=a+120|0;f[i>>2]=0;j=a+136|0;f[j>>2]=0;return}function bFa(a){a=a|0;return 1}function cFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0,pb=0,qb=0,rb=0,sb=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+160|0;k=a+156|0;l=a+4|0;m=e+4|0;n=a+164|0;o=a+152|0;q=a+24|0;r=a+28|0;t=a+32|0;v=a+40|0;w=a+44|0;x=a+48|0;y=a+56|0;z=a+60|0;A=a+64|0;B=a+72|0;C=a+88|0;D=a+92|0;E=a+96|0;F=a+104|0;G=a+108|0;H=a+112|0;I=e+8|0;K=a+120|0;L=a+124|0;M=a+128|0;N=e+8|0;O=a+136|0;P=a+140|0;Q=a+144|0;R=a+8|0;S=a+12|0;T=a+16|0;a=c+32|0;U=c+12|0;V=c+28|0;a:while(1){W=f[c>>2]|0;if(W>>>0<(f[g>>2]|0)>>>0){X=b[W>>0]|0;Y=X&255;if(X<<24>>24>0){f[i>>2]=Y;f[c>>2]=W+1;Z=Y;_=6}else{$=Y;_=5}}else{$=0;_=5}if((_|0)==5){_=0;Y=_nb(c,$)|0;f[i>>2]=Y;if((Y+-1|0)>>>0<127){Z=Y;_=6}else{aa=Y;_=247}}b:do if((_|0)==6){_=0;c:do switch(Z>>>3&536870911|0){case 1:{switch(Z|0){case 0:{ba=1;_=250;break a;break}case 8:break;default:{ca=Z;break b}}Y=f[c>>2]|0;W=f[g>>2]|0;if(Y>>>0<W>>>0){X=b[Y>>0]|0;da=X&255;if(X<<24>>24>-1){X=Y+1|0;f[c>>2]=X;ea=da;fa=X;ga=W}else{ha=da;_=11}}else{ha=0;_=11}if((_|0)==11){_=0;da=Knb(c,ha)|0;W=J;if(!((W|0)>-1|(W|0)==-1&da>>>0>4294967295)){ba=0;_=250;break a}ea=da;fa=f[c>>2]|0;ga=f[g>>2]|0}f[j>>2]=ea;if(fa>>>0>=ga>>>0)continue a;if((b[fa>>0]|0)!=18)continue a;f[c>>2]=fa+1;_=17;break}case 2:{switch(Z|0){case 0:{ba=1;_=250;break a;break}case 18:{_=17;break}default:{ca=Z;break b}}break}case 3:{switch(Z|0){case 0:{ba=1;_=250;break a;break}case 24:break;default:{ca=Z;break b}}ia=f[c>>2]|0;ja=f[g>>2]|0;_=38;break}case 4:{switch(Z|0){case 0:{ba=1;_=250;break a;break}case 34:{_=47;break}default:{ca=Z;break b}}break}case 5:{switch(Z|0){case 0:{ba=1;_=250;break a;break}case 42:{ka=f[c>>2]|0;la=f[g>>2]|0;_=58;break c;break}case 45:{if(wFa(1,42,c,q)|0){_=80;break c}else{ba=0;_=250;break a}break}default:{ca=Z;break b}}break}case 6:{switch(Z|0){case 0:{ba=1;_=250;break a;break}case 50:{ma=f[c>>2]|0;na=f[g>>2]|0;_=85;break c;break}case 49:{if(xFa(1,50,c,v)|0){_=107;break c}else{ba=0;_=250;break a}break}default:{ca=Z;break b}}break}case 7:{switch(Z|0){case 0:{ba=1;_=250;break a;break}case 58:{oa=f[c>>2]|0;pa=f[g>>2]|0;_=112;break c;break}case 56:{if(PEa(1,58,c,y)|0){_=126;break c}else{ba=0;_=250;break a}break}default:{ca=Z;break b}}break}case 8:{switch(Z|0){case 0:{ba=1;_=250;break a;break}case 66:{_=130;break}default:{ca=Z;break b}}break}case 9:{switch(Z|0){case 0:{ba=1;_=250;break a;break}case 74:{qa=f[c>>2]|0;ra=f[g>>2]|0;_=137;break c;break}case 77:{if(wFa(1,74,c,C)|0){_=159;break c}else{ba=0;_=250;break a}break}default:{ca=Z;break b}}break}case 10:{switch(Z|0){case 0:{ba=1;_=250;break a;break}case 82:{sa=f[c>>2]|0;ta=f[g>>2]|0;_=164;break c;break}case 80:{if(yFa(1,82,c,F)|0){_=178;break c}else{ba=0;_=250;break a}break}default:{ca=Z;break b}}break}case 11:{switch(Z|0){case 0:{ba=1;_=250;break a;break}case 90:{ua=f[c>>2]|0;va=f[g>>2]|0;_=183;break c;break}case 88:{if(zFa(1,90,c,K)|0){_=197;break c}else{ba=0;_=250;break a}break}default:{ca=Z;break b}}break}case 12:{switch(Z|0){case 0:{ba=1;_=250;break a;break}case 98:{wa=f[c>>2]|0;xa=f[g>>2]|0;_=202;break c;break}case 97:{if(xFa(1,98,c,O)|0){_=224;break c}else{ba=0;_=250;break a}break}default:{ca=Z;break b}}break}case 13:{switch(Z|0){case 0:{ba=1;_=250;break a;break}case 106:{ya=f[c>>2]|0;za=f[g>>2]|0;_=229;break c;break}case 104:{if(PEa(1,106,c,R)|0){_=243;break c}else{ba=0;_=250;break a}break}default:{ca=Z;break b}}break}default:{aa=Z;_=247;break b}}while(0);if((_|0)==17){_=0;da=f[k>>2]|0;if(!da){W=f[l>>2]|0;X=W&-2;if(!(W&1))Aa=X;else Aa=f[X+4>>2]|0;if(!Aa){X=L5b(32)|0;dBa(X);Ba=X}else{X=znb(Aa,18328,32)|0;jBa(X,Aa);Ba=X}f[k>>2]=Ba;Ca=Ba}else Ca=da;da=f[c>>2]|0;if(da>>>0<(f[g>>2]|0)>>>0?(X=b[da>>0]|0,X<<24>>24>-1):0){f[c>>2]=da+1;Da=X&255}else{X=Znb(c)|0;if((X|0)>-1)Da=X;else{ba=0;_=250;break a}}Inb(e,c,Da);if((f[m>>2]|0)<0){_=31;break a}if(!(QAa(Ca,c)|0)){_=31;break a}if(!(Onb(c,f[e>>2]|0)|0)){ba=0;_=250;break a}X=f[c>>2]|0;da=f[g>>2]|0;if(X>>>0>=da>>>0)continue a;if((b[X>>0]|0)!=24)continue a;W=X+1|0;f[c>>2]=W;ia=W;ja=da;_=38}if((_|0)==38){_=0;if(ia>>>0<ja>>>0){da=b[ia>>0]|0;W=da&255;if(da<<24>>24>-1){da=ia+1|0;f[c>>2]=da;Ea=W;Fa=da;Ga=ja}else{Ha=W;_=41}}else{Ha=0;_=41}if((_|0)==41){_=0;W=Knb(c,Ha)|0;da=J;if(!((da|0)>-1|(da|0)==-1&W>>>0>4294967295)){ba=0;_=250;break a}Ea=W;Fa=f[c>>2]|0;Ga=f[g>>2]|0}f[n>>2]=Ea;if(Fa>>>0>=Ga>>>0)continue a;if((b[Fa>>0]|0)!=34)continue a;f[c>>2]=Fa+1;_=47}if((_|0)==47){_=0;W=f[l>>2]|0;da=W&-2;if(!(W&1))Ia=da;else Ia=f[da+4>>2]|0;da=f[o>>2]|0;if((da|0)==497760){dya(o,Ia,497760);Ja=f[o>>2]|0}else Ja=da;if(!(fqb(c,Ja)|0)){ba=0;_=250;break a}da=f[c>>2]|0;W=f[g>>2]|0;if(da>>>0>=W>>>0)continue a;if((b[da>>0]|0)!=42)continue a;X=da+1|0;f[c>>2]=X;ka=X;la=W;_=58}do if((_|0)==58){_=0;if(ka>>>0<la>>>0?(W=b[ka>>0]|0,W<<24>>24>-1):0){f[c>>2]=ka+1;Ka=W&255}else{W=Znb(c)|0;if((W|0)>-1)Ka=W;else{ba=0;_=250;break a}}La=f[q>>2]|0;W=Ka>>>2;if((W<<2|0)!=(Ka|0)){ba=0;_=250;break a}X=Snb(c)|0;da=Qnb(c)|0;if((((X|0)==-1|(da|0)<(X|0)?da:X)|0)>=(Ka|0)){X=La+W|0;if((f[q>>2]|0)<(X|0)?(qza(q,X),da=f[q>>2]|0,Y=X-da|0,(Y<<2|0)>0):0)Nac((f[t>>2]|0)+((da<<2)+4)|0,0,(((Y|-1073741824|0)==-1073741824?1073741823:1073741822)+Y<<2)+8|0)|0;f[q>>2]=X;X=f[t>>2]|0;if(Unb(c,((X|0)==0?0:X+4|0)+(La<<2)|0,Ka)|0){_=80;break}else{_=69;break a}}if(!W)_=80;else{X=0;while(1){Y=f[c>>2]|0;if(((f[g>>2]|0)-Y|0)>3){da=Y;Ma=h[da>>0]|h[da+1>>0]<<8|h[da+2>>0]<<16|h[da+3>>0]<<24;f[e>>2]=Ma;f[c>>2]=Y+4;Na=Ma}else{if(!(Xnb(c,e)|0)){_=78;break a}Na=f[e>>2]|0}Ma=f[q>>2]|0;if((Ma|0)==(f[r>>2]|0)){qza(q,Ma+1|0);Oa=f[q>>2]|0}else Oa=Ma;Ma=f[t>>2]|0;f[q>>2]=Oa+1;f[Ma+4+(Oa<<2)>>2]=Na;X=X+1|0;if((X|0)>=(W|0)){_=80;break}}}}while(0);if((_|0)==80){_=0;W=f[c>>2]|0;X=f[g>>2]|0;if(W>>>0>=X>>>0)continue a;if((b[W>>0]|0)!=50)continue a;Ma=W+1|0;f[c>>2]=Ma;ma=Ma;na=X;_=85}do if((_|0)==85){_=0;if(ma>>>0<na>>>0?(X=b[ma>>0]|0,X<<24>>24>-1):0){f[c>>2]=ma+1;Pa=X&255}else{X=Znb(c)|0;if((X|0)>-1)Pa=X;else{ba=0;_=250;break a}}Qa=f[v>>2]|0;X=Pa>>>3;if((X<<3|0)!=(Pa|0)){ba=0;_=250;break a}Ma=Snb(c)|0;W=Qnb(c)|0;if((((Ma|0)==-1|(W|0)<(Ma|0)?W:Ma)|0)>=(Pa|0)){Ma=Qa+X|0;if((f[v>>2]|0)<(Ma|0)?(tFa(v,Ma),W=f[v>>2]|0,Y=Ma-W|0,(Y<<3|0)>0):0)Nac((f[x>>2]|0)+((W<<3)+8)|0,0,(((Y|-536870912|0)==-536870912?536870911:536870910)+Y<<3)+16|0)|0;f[v>>2]=Ma;Ma=f[x>>2]|0;if(Unb(c,((Ma|0)==0?0:Ma+8|0)+(Qa<<3)|0,Pa)|0){_=107;break}else{_=96;break a}}if(!X)_=107;else{Ma=0;while(1){Y=f[c>>2]|0;if(((f[g>>2]|0)-Y|0)>7){W=Y;da=W;Ra=h[da>>0]|h[da+1>>0]<<8|h[da+2>>0]<<16|h[da+3>>0]<<24;da=W+4|0;W=h[da>>0]|h[da+1>>0]<<8|h[da+2>>0]<<16|h[da+3>>0]<<24;da=e;f[da>>2]=Ra;f[da+4>>2]=W;f[c>>2]=Y+8;f[s>>2]=Ra;f[s+4>>2]=W;Sa=+p[s>>3]}else{if(!(Ynb(c,e)|0)){_=105;break a}Sa=+p[e>>3]}W=f[v>>2]|0;if((W|0)==(f[w>>2]|0)){tFa(v,W+1|0);Ta=f[v>>2]|0}else Ta=W;W=f[x>>2]|0;f[v>>2]=Ta+1;p[W+8+(Ta<<3)>>3]=Sa;Ma=Ma+1|0;if((Ma|0)>=(X|0)){_=107;break}}}}while(0);if((_|0)==107){_=0;X=f[c>>2]|0;Ma=f[g>>2]|0;if(X>>>0>=Ma>>>0)continue a;if((b[X>>0]|0)!=58)continue a;W=X+1|0;f[c>>2]=W;oa=W;pa=Ma;_=112}if((_|0)==112){_=0;if(oa>>>0<pa>>>0?(Ma=b[oa>>0]|0,Ma<<24>>24>-1):0){f[c>>2]=oa+1;Ua=Ma&255}else{Ma=Znb(c)|0;if((Ma|0)>-1)Ua=Ma;else{ba=0;_=250;break a}}Ma=Gnb(c,Ua)|0;if((Qnb(c)|0)>0)do{W=f[c>>2]|0;if(W>>>0<(f[g>>2]|0)>>>0){X=b[W>>0]|0;Ra=X&255;if(X<<24>>24>-1){f[c>>2]=W+1;Va=Ra}else{Wa=Ra;_=120}}else{Wa=0;_=120}if((_|0)==120){_=0;Ra=Knb(c,Wa)|0;W=J;if((W|0)>-1|(W|0)==-1&Ra>>>0>4294967295)Va=Ra;else{ba=0;_=250;break a}}Ra=f[y>>2]|0;if((Ra|0)==(f[z>>2]|0)){nza(y,Ra+1|0);Xa=f[y>>2]|0}else Xa=Ra;Ra=f[A>>2]|0;f[y>>2]=Xa+1;f[Ra+4+(Xa<<2)>>2]=Va}while((Qnb(c)|0)>0);Hnb(c,Ma);_=126}if((_|0)==126){_=0;Ra=f[c>>2]|0;if(Ra>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[Ra>>0]|0)==66){Ya=Ra;_=129}else continue a}d:while(1)switch(_|0){case 129:{_=0;f[c>>2]=Ya+1;_=130;continue d;break}case 130:{_=0;if(!(fqb(c,mza(B)|0)|0)){ba=0;_=250;break a}Ra=f[c>>2]|0;W=f[g>>2]|0;if(Ra>>>0>=W>>>0)continue a;if((b[Ra>>0]|0)==66){Ya=Ra;_=129;continue d}if((b[Ra>>0]|0)!=74)continue a;X=Ra+1|0;f[c>>2]=X;qa=X;ra=W;_=137;continue d;break}case 137:{_=0;if(qa>>>0<ra>>>0?(W=b[qa>>0]|0,W<<24>>24>-1):0){f[c>>2]=qa+1;Za=W&255}else{W=Znb(c)|0;if((W|0)>-1)Za=W;else{ba=0;_=250;break a}}_a=f[C>>2]|0;W=Za>>>2;if((W<<2|0)!=(Za|0)){ba=0;_=250;break a}X=Snb(c)|0;Ra=Qnb(c)|0;if((((X|0)==-1|(Ra|0)<(X|0)?Ra:X)|0)>=(Za|0)){X=_a+W|0;if((f[C>>2]|0)<(X|0)?(qza(C,X),Ra=f[C>>2]|0,Y=X-Ra|0,(Y<<2|0)>0):0)Nac((f[E>>2]|0)+((Ra<<2)+4)|0,0,(((Y|-1073741824|0)==-1073741824?1073741823:1073741822)+Y<<2)+8|0)|0;f[C>>2]=X;X=f[E>>2]|0;if(Unb(c,((X|0)==0?0:X+4|0)+(_a<<2)|0,Za)|0){_=159;continue d}else{_=148;break a}}if(!W){_=159;continue d}else $a=0;while(1){X=f[c>>2]|0;if(((f[g>>2]|0)-X|0)>3){Y=X;Ra=h[Y>>0]|h[Y+1>>0]<<8|h[Y+2>>0]<<16|h[Y+3>>0]<<24;f[e>>2]=Ra;f[c>>2]=X+4;ab=Ra}else{if(!(Xnb(c,e)|0)){_=157;break a}ab=f[e>>2]|0}Ra=f[C>>2]|0;if((Ra|0)==(f[D>>2]|0)){qza(C,Ra+1|0);bb=f[C>>2]|0}else bb=Ra;Ra=f[E>>2]|0;f[C>>2]=bb+1;f[Ra+4+(bb<<2)>>2]=ab;Ra=$a+1|0;if((Ra|0)<(W|0))$a=Ra;else{_=159;continue d}}break}case 159:{_=0;W=f[c>>2]|0;Ra=f[g>>2]|0;if(W>>>0>=Ra>>>0)continue a;if((b[W>>0]|0)!=82)continue a;X=W+1|0;f[c>>2]=X;sa=X;ta=Ra;_=164;continue d;break}case 164:{_=0;if(sa>>>0<ta>>>0?(Ra=b[sa>>0]|0,Ra<<24>>24>-1):0){f[c>>2]=sa+1;cb=Ra&255}else{Ra=Znb(c)|0;if((Ra|0)>-1)cb=Ra;else{ba=0;_=250;break a}}Ra=Gnb(c,cb)|0;if((Qnb(c)|0)>0)do{X=f[c>>2]|0;if(X>>>0<(f[g>>2]|0)>>>0?(W=b[X>>0]|0,W<<24>>24>-1):0){f[c>>2]=X+1;db=W&255;eb=0}else{Lnb(e,c);W=e;if(!(b[I>>0]|0)){ba=0;_=250;break a}else{db=f[W>>2]|0;eb=f[W+4>>2]|0}}W=f[F>>2]|0;if((W|0)==(f[G>>2]|0)){uFa(F,W+1|0);fb=f[F>>2]|0}else fb=W;W=f[H>>2]|0;f[F>>2]=fb+1;X=W+8+(fb<<3)|0;f[X>>2]=db;f[X+4>>2]=eb}while((Qnb(c)|0)>0);Hnb(c,Ra);_=178;continue d;break}case 178:{_=0;X=f[c>>2]|0;W=f[g>>2]|0;if(X>>>0>=W>>>0)continue a;if((b[X>>0]|0)!=90)continue a;Y=X+1|0;f[c>>2]=Y;ua=Y;va=W;_=183;continue d;break}case 183:{_=0;if(ua>>>0<va>>>0?(W=b[ua>>0]|0,W<<24>>24>-1):0){f[c>>2]=ua+1;gb=W&255}else{W=Znb(c)|0;if((W|0)>-1)gb=W;else{ba=0;_=250;break a}}W=Gnb(c,gb)|0;if((Qnb(c)|0)>0)do{Y=f[c>>2]|0;if(Y>>>0<(f[g>>2]|0)>>>0?(X=b[Y>>0]|0,X<<24>>24>-1):0){f[c>>2]=Y+1;hb=X<<24>>24!=0}else{Lnb(e,c);X=e;if(!(b[N>>0]|0)){ba=0;_=250;break a}else hb=(f[X>>2]|0)!=0|(f[X+4>>2]|0)!=0}X=f[K>>2]|0;if((X|0)==(f[L>>2]|0)){vFa(K,X+1|0);ib=f[K>>2]|0}else ib=X;X=f[M>>2]|0;f[K>>2]=ib+1;b[X+4+ib>>0]=hb&1}while((Qnb(c)|0)>0);Hnb(c,W);_=197;continue d;break}case 197:{_=0;Ra=f[c>>2]|0;X=f[g>>2]|0;if(Ra>>>0>=X>>>0)continue a;if((b[Ra>>0]|0)!=98)continue a;Y=Ra+1|0;f[c>>2]=Y;wa=Y;xa=X;_=202;continue d;break}case 202:{_=0;if(wa>>>0<xa>>>0?(X=b[wa>>0]|0,X<<24>>24>-1):0){f[c>>2]=wa+1;jb=X&255}else{X=Znb(c)|0;if((X|0)>-1)jb=X;else{ba=0;_=250;break a}}kb=f[O>>2]|0;X=jb>>>3;if((X<<3|0)!=(jb|0)){ba=0;_=250;break a}Y=Snb(c)|0;Ra=Qnb(c)|0;if((((Y|0)==-1|(Ra|0)<(Y|0)?Ra:Y)|0)>=(jb|0)){Y=kb+X|0;if((f[O>>2]|0)<(Y|0)?(tFa(O,Y),Ra=f[O>>2]|0,da=Y-Ra|0,(da<<3|0)>0):0)Nac((f[Q>>2]|0)+((Ra<<3)+8)|0,0,(((da|-536870912|0)==-536870912?536870911:536870910)+da<<3)+16|0)|0;f[O>>2]=Y;Y=f[Q>>2]|0;if(Unb(c,((Y|0)==0?0:Y+8|0)+(kb<<3)|0,jb)|0){_=224;continue d}else{_=213;break a}}if(!X){_=224;continue d}else lb=0;while(1){Y=f[c>>2]|0;if(((f[g>>2]|0)-Y|0)>7){da=Y;Ra=da;mb=h[Ra>>0]|h[Ra+1>>0]<<8|h[Ra+2>>0]<<16|h[Ra+3>>0]<<24;Ra=da+4|0;da=h[Ra>>0]|h[Ra+1>>0]<<8|h[Ra+2>>0]<<16|h[Ra+3>>0]<<24;Ra=e;f[Ra>>2]=mb;f[Ra+4>>2]=da;f[c>>2]=Y+8;f[s>>2]=mb;f[s+4>>2]=da;nb=+p[s>>3]}else{if(!(Ynb(c,e)|0)){_=222;break a}nb=+p[e>>3]}da=f[O>>2]|0;if((da|0)==(f[P>>2]|0)){tFa(O,da+1|0);ob=f[O>>2]|0}else ob=da;da=f[Q>>2]|0;f[O>>2]=ob+1;p[da+8+(ob<<3)>>3]=nb;da=lb+1|0;if((da|0)<(X|0))lb=da;else{_=224;continue d}}break}case 224:{_=0;X=f[c>>2]|0;W=f[g>>2]|0;if(X>>>0>=W>>>0)continue a;if((b[X>>0]|0)!=106)continue a;da=X+1|0;f[c>>2]=da;ya=da;za=W;_=229;continue d;break}case 229:{_=0;if(ya>>>0<za>>>0?(W=b[ya>>0]|0,W<<24>>24>-1):0){f[c>>2]=ya+1;pb=W&255}else{W=Znb(c)|0;if((W|0)>-1)pb=W;else{ba=0;_=250;break a}}W=Gnb(c,pb)|0;if((Qnb(c)|0)>0)do{da=f[c>>2]|0;if(da>>>0<(f[g>>2]|0)>>>0){X=b[da>>0]|0;mb=X&255;if(X<<24>>24>-1){f[c>>2]=da+1;qb=mb}else{rb=mb;_=237}}else{rb=0;_=237}if((_|0)==237){_=0;mb=Knb(c,rb)|0;da=J;if((da|0)>-1|(da|0)==-1&mb>>>0>4294967295)qb=mb;else{ba=0;_=250;break a}}mb=f[R>>2]|0;if((mb|0)==(f[S>>2]|0)){nza(R,mb+1|0);sb=f[R>>2]|0}else sb=mb;mb=f[T>>2]|0;f[R>>2]=sb+1;f[mb+4+(sb<<2)>>2]=qb}while((Qnb(c)|0)>0);Hnb(c,W);_=243;continue d;break}case 243:{_=0;if((f[c>>2]|0)==(f[g>>2]|0))break d;else continue a;break}}if(f[a>>2]|0){_=246;break a}if((f[U>>2]|0)==(f[V>>2]|0)){_=246;break a}else continue a}while(0);if((_|0)==247){_=0;if(!aa){ba=1;_=250;break}else ca=aa}if((ca&7|0)==4){ba=1;_=250;break}if(!(Lpb(c,ca)|0)){ba=0;_=250;break}}switch(_|0){case 31:{ba=0;u=d;return ba|0}case 69:{if((f[q>>2]|0)<=0){ba=0;u=d;return ba|0}f[q>>2]=La;ba=0;u=d;return ba|0}case 78:{ba=0;u=d;return ba|0}case 96:{if((f[v>>2]|0)<=0){ba=0;u=d;return ba|0}f[v>>2]=Qa;ba=0;u=d;return ba|0}case 105:{ba=0;u=d;return ba|0}case 148:{if((f[C>>2]|0)<=0){ba=0;u=d;return ba|0}f[C>>2]=_a;ba=0;u=d;return ba|0}case 157:{ba=0;u=d;return ba|0}case 213:{if((f[O>>2]|0)<=0){ba=0;u=d;return ba|0}f[O>>2]=kb;ba=0;u=d;return ba|0}case 222:{ba=0;u=d;return ba|0}case 246:{f[i>>2]=0;b[c+24>>0]=1;ba=1;u=d;return ba|0}case 250:{u=d;return ba|0}}return 0}function dFa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;c=f[a+160>>2]|0;if(!c)d=0;else{if((c|0)>=0)if(c>>>0<128)e=1;else e=iob(c)|0;else e=10;d=e+1|0}if((a|0)!=492056?(e=f[a+156>>2]|0,(e|0)!=0):0){c=RAa(e)|0;if(c>>>0<128)g=1;else g=iob(c)|0;h=d+1+c+g|0}else h=d;d=f[a+164>>2]|0;if(!d)i=h;else{if((d|0)>=0)if(d>>>0<128)j=1;else j=iob(d)|0;else j=10;i=h+1+j|0}j=f[a+152>>2]|0;h=b[j+11>>0]|0;d=h<<24>>24<0;if(d)k=f[j+4>>2]|0;else k=h&255;if(!k)l=i;else{if(d){d=f[j+4>>2]|0;if(d>>>0<128){m=1;n=d}else{m=iob(d)|0;n=d}}else{m=1;n=h&255}l=i+1+n+m|0}m=f[a+8>>2]|0;if(m){n=a+16|0;i=0;h=0;do{d=f[(f[n>>2]|0)+4+(h<<2)>>2]|0;if((d|0)>=0)if(d>>>0<128)o=1;else o=iob(d)|0;else o=10;i=o+i|0;h=h+1|0}while((h|0)!=(m|0));if(i){if((i|0)>=0)if(i>>>0<128)p=1;else p=iob(i)|0;else p=10;q=i;r=l+1+p|0}else{q=0;r=l}}else{q=0;r=l}f[a+20>>2]=q;l=r+q|0;q=f[a+24>>2]<<2;if(!q)s=l;else{if((q|0)>=0)if(q>>>0<128)t=1;else t=iob(q)|0;else t=10;s=l+1+t|0}f[a+36>>2]=q;t=s+q|0;q=f[a+40>>2]<<3;if(!q)u=t;else{if((q|0)>=0)if(q>>>0<128)v=1;else v=iob(q)|0;else v=10;u=t+1+v|0}f[a+52>>2]=q;v=u+q|0;q=f[a+56>>2]|0;if(q){u=a+64|0;t=0;s=0;do{l=f[(f[u>>2]|0)+4+(s<<2)>>2]|0;if((l|0)>=0)if(l>>>0<128)w=1;else w=iob(l)|0;else w=10;t=w+t|0;s=s+1|0}while((s|0)!=(q|0));if(t){if((t|0)>=0)if(t>>>0<128)x=1;else x=iob(t)|0;else x=10;y=t;z=v+1+x|0}else{y=0;z=v}}else{y=0;z=v}f[a+68>>2]=y;v=a+76|0;x=f[v>>2]|0;t=z+y+x|0;if((x|0)>0){y=a+84|0;z=0;q=t;s=x;while(1){x=f[(f[y>>2]|0)+4+(z<<2)>>2]|0;w=b[x+11>>0]|0;if(w<<24>>24<0){u=f[x+4>>2]|0;if(u>>>0<128){A=1;B=u;C=s}else{x=iob(u)|0;A=x;B=u;C=f[v>>2]|0}}else{A=1;B=w&255;C=s}w=B+q+A|0;z=z+1|0;if((z|0)>=(C|0)){D=w;break}else{q=w;s=C}}}else D=t;t=f[a+88>>2]<<2;if(!t)E=D;else{if((t|0)>=0)if(t>>>0<128)F=2;else F=(iob(t)|0)+1|0;else F=11;E=F+D|0}f[a+100>>2]=t;D=E+t|0;t=f[a+104>>2]|0;if(t){E=a+112|0;F=0;C=0;do{s=(f[E>>2]|0)+8+(F<<3)|0;C=(job(f[s>>2]|0,f[s+4>>2]|0)|0)+C|0;F=F+1|0}while((F|0)!=(t|0));if(C){if((C|0)>=0)if(C>>>0<128)G=2;else G=(iob(C)|0)+1|0;else G=11;H=C;I=G+D|0}else{H=0;I=D}}else{H=0;I=D}f[a+116>>2]=H;D=I+H|0;H=f[a+120>>2]|0;if(!H)J=D;else{if((H|0)>=0)if(H>>>0<128)K=2;else K=(iob(H)|0)+1|0;else K=11;J=K+D|0}f[a+132>>2]=H;D=J+H|0;H=f[a+136>>2]<<3;if(!H){L=D;M=a+148|0;f[M>>2]=H;N=L+H|0;O=a+168|0;f[O>>2]=N;return N|0}if((H|0)>=0)if(H>>>0<128)P=2;else P=(iob(H)|0)+1|0;else P=11;L=P+D|0;M=a+148|0;f[M>>2]=H;N=L+H|0;O=a+168|0;f[O>>2]=N;return N|0}function eFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=f[a+160>>2]|0;if(d|0)Zpb(1,d,c);if((a|0)!=492056?(d=f[a+156>>2]|0,d|0):0)eqb(2,d,c);d=f[a+164>>2]|0;if(d|0)Mpb(3,d,c);d=f[a+152>>2]|0;e=b[d+11>>0]|0;if(e<<24>>24<0)g=f[d+4>>2]|0;else g=e&255;if(g|0)bqb(4,d,c);d=a+24|0;if((f[d>>2]|0)>0){g=c+8|0;if((f[g>>2]|0)>4){e=c+4|0;b[f[e>>2]>>0]=42;f[e>>2]=(f[e>>2]|0)+1;e=(f[g>>2]|0)+-1|0;f[g>>2]=e;h=e}else{fob(c,42);h=f[g>>2]|0}e=f[a+36>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(e>>>0>127){j=e;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=e}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[g>>2]=(f[g>>2]|0)-o}else fob(c,e);if((f[d>>2]|0)>0){e=a+32|0;o=0;do{dob(c,f[(f[e>>2]|0)+4+(o<<2)>>2]|0);o=o+1|0}while((o|0)<(f[d>>2]|0))}}d=a+40|0;if((f[d>>2]|0)>0){o=c+8|0;if((f[o>>2]|0)>4){e=c+4|0;b[f[e>>2]>>0]=50;f[e>>2]=(f[e>>2]|0)+1;e=(f[o>>2]|0)+-1|0;f[o>>2]=e;p=e}else{fob(c,50);p=f[o>>2]|0}e=f[a+52>>2]|0;if((p|0)>4){p=c+4|0;g=f[p>>2]|0;if(e>>>0>127){h=e;i=g;while(1){b[i>>0]=h|128;n=h>>>7;k=i+1|0;if(h>>>0>16383){h=n;i=k}else{q=k;r=n;break}}}else{q=g;r=e}b[q>>0]=r;r=q+1-g|0;f[p>>2]=(f[p>>2]|0)+r;f[o>>2]=(f[o>>2]|0)-r}else fob(c,e);if((f[d>>2]|0)>0){e=a+48|0;r=0;do{o=(f[e>>2]|0)+8+(r<<3)|0;eob(c,f[o>>2]|0,f[o+4>>2]|0);r=r+1|0}while((r|0)<(f[d>>2]|0))}}d=a+56|0;if((f[d>>2]|0)>0){r=c+8|0;if((f[r>>2]|0)>4){e=c+4|0;b[f[e>>2]>>0]=58;f[e>>2]=(f[e>>2]|0)+1;e=(f[r>>2]|0)+-1|0;f[r>>2]=e;s=e}else{fob(c,58);s=f[r>>2]|0}e=f[a+68>>2]|0;if((s|0)>4){s=c+4|0;o=f[s>>2]|0;if(e>>>0>127){p=e;g=o;while(1){b[g>>0]=p|128;q=p>>>7;i=g+1|0;if(p>>>0>16383){p=q;g=i}else{t=i;u=q;break}}}else{t=o;u=e}b[t>>0]=u;u=t+1-o|0;f[s>>2]=(f[s>>2]|0)+u;f[r>>2]=(f[r>>2]|0)-u}else fob(c,e);if((f[d>>2]|0)>0){e=a+64|0;u=c+8|0;r=c+4|0;s=0;do{o=f[(f[e>>2]|0)+4+(s<<2)>>2]|0;do if((o|0)<0)gob(c,o,((o|0)<0)<<31>>31);else{if((f[u>>2]|0)<=4){fob(c,o);break}t=f[r>>2]|0;if(o>>>0>127){g=o;p=t;while(1){b[p>>0]=g|128;q=g>>>7;i=p+1|0;if(g>>>0>16383){g=q;p=i}else{v=i;w=q;break}}}else{v=t;w=o}b[v>>0]=w;p=v+1-t|0;f[r>>2]=(f[r>>2]|0)+p;f[u>>2]=(f[u>>2]|0)-p}while(0);s=s+1|0}while((s|0)<(f[d>>2]|0))}}d=a+76|0;if((f[d>>2]|0)>0){s=a+84|0;u=0;do{aqb(8,f[(f[s>>2]|0)+4+(u<<2)>>2]|0,c);u=u+1|0}while((u|0)<(f[d>>2]|0))}d=a+88|0;if((f[d>>2]|0)>0){u=c+8|0;if((f[u>>2]|0)>4){s=c+4|0;b[f[s>>2]>>0]=74;f[s>>2]=(f[s>>2]|0)+1;s=(f[u>>2]|0)+-1|0;f[u>>2]=s;x=s}else{fob(c,74);x=f[u>>2]|0}s=f[a+100>>2]|0;if((x|0)>4){x=c+4|0;r=f[x>>2]|0;if(s>>>0>127){v=s;w=r;while(1){b[w>>0]=v|128;e=v>>>7;o=w+1|0;if(v>>>0>16383){v=e;w=o}else{y=o;z=e;break}}}else{y=r;z=s}b[y>>0]=z;z=y+1-r|0;f[x>>2]=(f[x>>2]|0)+z;f[u>>2]=(f[u>>2]|0)-z}else fob(c,s);if((f[d>>2]|0)>0){s=a+96|0;z=0;do{dob(c,f[(f[s>>2]|0)+4+(z<<2)>>2]|0);z=z+1|0}while((z|0)<(f[d>>2]|0))}}d=a+104|0;if((f[d>>2]|0)>0){z=c+8|0;if((f[z>>2]|0)>4){s=c+4|0;b[f[s>>2]>>0]=82;f[s>>2]=(f[s>>2]|0)+1;s=(f[z>>2]|0)+-1|0;f[z>>2]=s;A=s}else{fob(c,82);A=f[z>>2]|0}s=f[a+116>>2]|0;if((A|0)>4){A=c+4|0;u=f[A>>2]|0;if(s>>>0>127){x=s;r=u;while(1){b[r>>0]=x|128;y=x>>>7;w=r+1|0;if(x>>>0>16383){x=y;r=w}else{B=w;C=y;break}}}else{B=u;C=s}b[B>>0]=C;C=B+1-u|0;f[A>>2]=(f[A>>2]|0)+C;f[z>>2]=(f[z>>2]|0)-C}else fob(c,s);if((f[d>>2]|0)>0){s=a+112|0;C=0;do{z=(f[s>>2]|0)+8+(C<<3)|0;gob(c,f[z>>2]|0,f[z+4>>2]|0);C=C+1|0}while((C|0)<(f[d>>2]|0))}}d=a+120|0;if((f[d>>2]|0)>0){C=c+8|0;if((f[C>>2]|0)>4){s=c+4|0;b[f[s>>2]>>0]=90;f[s>>2]=(f[s>>2]|0)+1;s=(f[C>>2]|0)+-1|0;f[C>>2]=s;D=s}else{fob(c,90);D=f[C>>2]|0}s=f[a+132>>2]|0;if((D|0)>4){D=c+4|0;z=f[D>>2]|0;if(s>>>0>127){A=s;u=z;while(1){b[u>>0]=A|128;B=A>>>7;r=u+1|0;if(A>>>0>16383){A=B;u=r}else{E=r;F=B;break}}}else{E=z;F=s}b[E>>0]=F;F=E+1-z|0;f[D>>2]=(f[D>>2]|0)+F;f[C>>2]=(f[C>>2]|0)-F}else fob(c,s);if((f[d>>2]|0)>0){s=a+128|0;F=c+8|0;C=c+4|0;D=0;do{z=b[(f[s>>2]|0)+4+D>>0]|0;if((f[F>>2]|0)>4){b[f[C>>2]>>0]=z;f[C>>2]=(f[C>>2]|0)+1;f[F>>2]=(f[F>>2]|0)+-1}else fob(c,z&255);D=D+1|0}while((D|0)<(f[d>>2]|0))}}d=a+136|0;if((f[d>>2]|0)>0){D=c+8|0;if((f[D>>2]|0)>4){F=c+4|0;b[f[F>>2]>>0]=98;f[F>>2]=(f[F>>2]|0)+1;F=(f[D>>2]|0)+-1|0;f[D>>2]=F;G=F}else{fob(c,98);G=f[D>>2]|0}F=f[a+148>>2]|0;if((G|0)>4){G=c+4|0;C=f[G>>2]|0;if(F>>>0>127){s=F;z=C;while(1){b[z>>0]=s|128;E=s>>>7;u=z+1|0;if(s>>>0>16383){s=E;z=u}else{H=u;I=E;break}}}else{H=C;I=F}b[H>>0]=I;I=H+1-C|0;f[G>>2]=(f[G>>2]|0)+I;f[D>>2]=(f[D>>2]|0)-I}else fob(c,F);if((f[d>>2]|0)>0){F=a+144|0;I=0;do{D=(f[F>>2]|0)+8+(I<<3)|0;eob(c,f[D>>2]|0,f[D+4>>2]|0);I=I+1|0}while((I|0)<(f[d>>2]|0))}}d=a+8|0;if((f[d>>2]|0)<=0)return;I=c+8|0;if((f[I>>2]|0)>4){F=c+4|0;b[f[F>>2]>>0]=106;f[F>>2]=(f[F>>2]|0)+1;F=(f[I>>2]|0)+-1|0;f[I>>2]=F;J=F}else{fob(c,106);J=f[I>>2]|0}F=f[a+20>>2]|0;if((J|0)>4){J=c+4|0;D=f[J>>2]|0;if(F>>>0>127){G=F;C=D;while(1){b[C>>0]=G|128;H=G>>>7;z=C+1|0;if(G>>>0>16383){G=H;C=z}else{K=z;L=H;break}}}else{K=D;L=F}b[K>>0]=L;L=K+1-D|0;f[J>>2]=(f[J>>2]|0)+L;f[I>>2]=(f[I>>2]|0)-L}else fob(c,F);if((f[d>>2]|0)<=0)return;F=a+16|0;a=c+8|0;L=c+4|0;I=0;do{J=f[(f[F>>2]|0)+4+(I<<2)>>2]|0;do if((J|0)<0)gob(c,J,((J|0)<0)<<31>>31);else{if((f[a>>2]|0)<=4){fob(c,J);break}D=f[L>>2]|0;if(J>>>0>127){K=J;C=D;while(1){b[C>>0]=K|128;G=K>>>7;H=C+1|0;if(K>>>0>16383){K=G;C=H}else{M=H;N=G;break}}}else{M=D;N=J}b[M>>0]=N;C=M+1-D|0;f[L>>2]=(f[L>>2]|0)+C;f[a>>2]=(f[a>>2]|0)-C}while(0);I=I+1|0}while((I|0)<(f[d>>2]|0));return}function fFa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function gFa(a){a=a|0;return f[a+168>>2]|0}function hFa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;c=f[a+160>>2]|0;do if(!c)e=d;else{b[d>>0]=8;g=d+1|0;if((c|0)<0){e=hob(c,((c|0)<0)<<31>>31,g)|0;break}if(c>>>0>127){h=c;i=g;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=g;m=c}b[l>>0]=m;e=l+1|0}while(0);if((a|0)!=492056?(l=f[a+156>>2]|0,(l|0)!=0):0){b[e>>0]=18;m=e+1|0;c=f[l+28>>2]|0;if(c>>>0>127){d=c;i=m;while(1){b[i>>0]=d|128;h=d>>>7;j=i+1|0;if(d>>>0>16383){d=h;i=j}else{n=j;o=h;break}}}else{n=m;o=c}b[n>>0]=o;q=li[f[(f[l>>2]|0)+68>>2]&511](l,0,n+1|0)|0}else q=e;e=f[a+164>>2]|0;do if(!e)r=q;else{b[q>>0]=24;n=q+1|0;if((e|0)<0){r=hob(e,((e|0)<0)<<31>>31,n)|0;break}if(e>>>0>127){l=e;o=n;while(1){b[o>>0]=l|128;c=l>>>7;m=o+1|0;if(l>>>0>16383){l=c;o=m}else{t=m;u=c;break}}}else{t=n;u=e}b[t>>0]=u;r=t+1|0}while(0);t=f[a+152>>2]|0;u=b[t+11>>0]|0;if(u<<24>>24<0)v=f[t+4>>2]|0;else v=u&255;if(!v)w=r;else{b[r>>0]=34;w=kob(t,r+1|0)|0}r=a+24|0;if((f[r>>2]|0)>0){b[w>>0]=42;t=w+1|0;v=f[a+36>>2]|0;if(v>>>0>127){u=v;e=t;while(1){b[e>>0]=u|128;q=u>>>7;o=e+1|0;if(u>>>0>16383){u=q;e=o}else{x=o;y=q;break}}}else{x=t;y=v}b[x>>0]=y;y=x+1|0;if((f[r>>2]|0)>0){x=a+32|0;v=0;t=y;while(1){e=f[(f[x>>2]|0)+4+(v<<2)>>2]|0;b[t>>0]=e;b[t+1>>0]=e>>8;b[t+2>>0]=e>>16;b[t+3>>0]=e>>24;e=t+4|0;v=v+1|0;if((v|0)>=(f[r>>2]|0)){z=e;break}else t=e}}else z=y}else z=w;w=a+40|0;if((f[w>>2]|0)>0){b[z>>0]=50;y=z+1|0;t=f[a+52>>2]|0;if(t>>>0>127){r=t;v=y;while(1){b[v>>0]=r|128;x=r>>>7;e=v+1|0;if(r>>>0>16383){r=x;v=e}else{A=e;B=x;break}}}else{A=y;B=t}b[A>>0]=B;B=A+1|0;if((f[w>>2]|0)>0){A=a+48|0;t=0;y=B;while(1){p[s>>3]=+p[(f[A>>2]|0)+8+(t<<3)>>3];b[y>>0]=b[s>>0];b[y+1>>0]=b[s+1>>0];b[y+2>>0]=b[s+2>>0];b[y+3>>0]=b[s+3>>0];b[y+4>>0]=b[s+4>>0];b[y+5>>0]=b[s+5>>0];b[y+6>>0]=b[s+6>>0];b[y+7>>0]=b[s+7>>0];v=y+8|0;t=t+1|0;if((t|0)>=(f[w>>2]|0)){C=v;break}else y=v}}else C=B}else C=z;z=a+56|0;if((f[z>>2]|0)>0){b[C>>0]=58;B=C+1|0;y=f[a+68>>2]|0;if(y>>>0>127){w=y;t=B;while(1){b[t>>0]=w|128;A=w>>>7;v=t+1|0;if(w>>>0>16383){w=A;t=v}else{D=v;E=A;break}}}else{D=B;E=y}b[D>>0]=E;E=D+1|0;if((f[z>>2]|0)>0){D=a+64|0;y=0;B=E;while(1){t=f[(f[D>>2]|0)+4+(y<<2)>>2]|0;if((t|0)<0)F=hob(t,((t|0)<0)<<31>>31,B)|0;else{if(t>>>0>127){w=t;A=B;while(1){b[A>>0]=w|128;v=w>>>7;r=A+1|0;if(w>>>0>16383){w=v;A=r}else{G=r;H=v;break}}}else{G=B;H=t}b[G>>0]=H;F=G+1|0}y=y+1|0;if((y|0)>=(f[z>>2]|0)){I=F;break}else B=F}}else I=E}else I=C;C=a+76|0;if((f[C>>2]|0)>0){E=a+84|0;F=0;B=I;while(1){z=f[(f[E>>2]|0)+4+(F<<2)>>2]|0;b[B>>0]=66;y=kob(z,B+1|0)|0;F=F+1|0;if((F|0)>=(f[C>>2]|0)){J=y;break}else B=y}}else J=I;I=a+88|0;if((f[I>>2]|0)>0){b[J>>0]=74;B=J+1|0;C=f[a+100>>2]|0;if(C>>>0>127){F=C;E=B;while(1){b[E>>0]=F|128;y=F>>>7;z=E+1|0;if(F>>>0>16383){F=y;E=z}else{K=z;L=y;break}}}else{K=B;L=C}b[K>>0]=L;L=K+1|0;if((f[I>>2]|0)>0){K=a+96|0;C=0;B=L;while(1){E=f[(f[K>>2]|0)+4+(C<<2)>>2]|0;b[B>>0]=E;b[B+1>>0]=E>>8;b[B+2>>0]=E>>16;b[B+3>>0]=E>>24;E=B+4|0;C=C+1|0;if((C|0)>=(f[I>>2]|0)){M=E;break}else B=E}}else M=L}else M=J;J=a+104|0;if((f[J>>2]|0)>0){b[M>>0]=82;L=M+1|0;B=f[a+116>>2]|0;if(B>>>0>127){I=B;C=L;while(1){b[C>>0]=I|128;K=I>>>7;E=C+1|0;if(I>>>0>16383){I=K;C=E}else{N=E;O=K;break}}}else{N=L;O=B}b[N>>0]=O;O=N+1|0;if((f[J>>2]|0)>0){N=a+112|0;B=0;L=O;while(1){C=(f[N>>2]|0)+8+(B<<3)|0;I=hob(f[C>>2]|0,f[C+4>>2]|0,L)|0;B=B+1|0;if((B|0)>=(f[J>>2]|0)){P=I;break}else L=I}}else P=O}else P=M;M=a+120|0;if((f[M>>2]|0)>0){b[P>>0]=90;O=P+1|0;L=f[a+132>>2]|0;if(L>>>0>127){J=L;B=O;while(1){b[B>>0]=J|128;N=J>>>7;I=B+1|0;if(J>>>0>16383){J=N;B=I}else{Q=I;R=N;break}}}else{Q=O;R=L}b[Q>>0]=R;R=Q+1|0;if((f[M>>2]|0)>0){Q=a+128|0;L=0;O=R;while(1){b[O>>0]=b[(f[Q>>2]|0)+4+L>>0]|0;B=O+1|0;L=L+1|0;if((L|0)>=(f[M>>2]|0)){S=B;break}else O=B}}else S=R}else S=P;P=a+136|0;if((f[P>>2]|0)>0){b[S>>0]=98;R=S+1|0;O=f[a+148>>2]|0;if(O>>>0>127){M=O;L=R;while(1){b[L>>0]=M|128;Q=M>>>7;B=L+1|0;if(M>>>0>16383){M=Q;L=B}else{T=B;U=Q;break}}}else{T=R;U=O}b[T>>0]=U;U=T+1|0;if((f[P>>2]|0)>0){T=a+144|0;O=0;R=U;while(1){p[s>>3]=+p[(f[T>>2]|0)+8+(O<<3)>>3];b[R>>0]=b[s>>0];b[R+1>>0]=b[s+1>>0];b[R+2>>0]=b[s+2>>0];b[R+3>>0]=b[s+3>>0];b[R+4>>0]=b[s+4>>0];b[R+5>>0]=b[s+5>>0];b[R+6>>0]=b[s+6>>0];b[R+7>>0]=b[s+7>>0];L=R+8|0;O=O+1|0;if((O|0)>=(f[P>>2]|0)){V=L;break}else R=L}}else V=U}else V=S;S=a+8|0;if((f[S>>2]|0)<=0){W=V;return W|0}b[V>>0]=106;U=V+1|0;V=f[a+20>>2]|0;if(V>>>0>127){R=V;P=U;while(1){b[P>>0]=R|128;O=R>>>7;T=P+1|0;if(R>>>0>16383){R=O;P=T}else{X=T;Y=O;break}}}else{X=U;Y=V}b[X>>0]=Y;Y=X+1|0;if((f[S>>2]|0)<=0){W=Y;return W|0}X=a+16|0;a=0;V=Y;while(1){Y=f[(f[X>>2]|0)+4+(a<<2)>>2]|0;if((Y|0)<0)Z=hob(Y,((Y|0)<0)<<31>>31,V)|0;else{if(Y>>>0>127){U=Y;P=V;while(1){b[P>>0]=U|128;R=U>>>7;O=P+1|0;if(U>>>0>16383){U=R;P=O}else{_=O;$=R;break}}}else{_=V;$=Y}b[_>>0]=$;Z=_+1|0}a=a+1|0;if((a|0)>=(f[S>>2]|0)){W=Z;break}else V=Z}return W|0}function iFa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function jFa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))rFa(1038);c=T6b(b,23288,18552,0)|0;if(!c){cOb(b,a);return}else{sFa(a,c);return}}function kFa(a,b){a=a|0;b=b|0;f[a+168>>2]=b;return}function lFa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[212974]|0)!=2){f[d>>2]=135812;f[d+4>>2]=17;b[d+8>>0]=0;Gpb(851896,d);hpb(d)}f[a>>2]=f[212975];f[a+4>>2]=f[212976];u=c;return}function mFa(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+48|0;c=a+24|0;d=a;e=a+36|0;if((f[212973]|0)!=2){f[c>>2]=135812;f[c+4>>2]=18;b[c+8>>0]=0;Gpb(851892,c);hpb(c)}g=drb()|0;h=L5b(16)|0;f[c>>2]=h;f[c+8>>2]=-2147483632;f[c+4>>2]=12;i=h;j=384302;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+12>>0]=0;h=hrb(g,c)|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if(h|0){l=h+40|0;m=f[l>>2]|0;f[212975]=m;n=pIb(m,492056,107740,-1,-1,-1,172,4,-1)|0;f[212976]=n;u=a;return}zpb(d,3,384315,37);xpb(e,vpb(d,459532)|0);Apb(d);l=h+40|0;m=f[l>>2]|0;f[212975]=m;n=pIb(m,492056,107740,-1,-1,-1,172,4,-1)|0;f[212976]=n;u=a;return}function nFa(){var a=0,c=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,384315);if((f[212972]|0)!=2){f[c>>2]=135812;f[c+4>>2]=19;b[c+8>>0]=0;Gpb(851888,c);hpb(c)}grb(384396,474);SNb(384302,1496);fBa();kJa();spb(20);u=a;return}function oFa(){var a=0,c=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,384315);gBa();lJa();if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123014]=107640;f[123020]=0;f[123021]=0;f[123022]=0;f[123024]=0;f[123025]=0;f[123026]=0;f[123028]=0;f[123029]=0;f[123030]=0;f[123040]=0;f[123041]=0;f[123042]=0;f[123044]=0;f[123045]=0;f[123046]=0;f[123048]=0;f[123049]=0;f[123050]=0;f[123015]=0;f[123016]=0;f[123017]=0;f[123018]=0;f[123032]=0;f[123033]=0;f[123034]=0;f[123035]=0;f[123036]=0;f[123037]=0;f[123038]=0;f[123052]=497760;f[123054]=0;f[123055]=0;f[123056]=0;b[492232]=1;f[123053]=491784;u=a;return}function pFa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[212974]|0)!=2){f[c>>2]=135812;f[c+4>>2]=17;b[c+8>>0]=0;Gpb(851896,c);hpb(c)}WNb(f[212975]|0,492056);u=a;return}function qFa(){var a=0;if(b[492232]|0){b[492232]=0;bi[f[f[123014]>>2]&2047](492056)}a=f[212976]|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function rFa(a){a=a|0;Enb(384315,a)}function sFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=c+8|0;g=f[e>>2]|0;if(g|0){nza(d,(f[d>>2]|0)+g|0);Vac((f[a+16>>2]|0)+4+(f[d>>2]<<2)|0,(f[c+16>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[e>>2]|0)}e=a+24|0;d=c+24|0;g=f[d>>2]|0;if(g|0){qza(e,(f[e>>2]|0)+g|0);Vac((f[a+32>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+32>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[d>>2]|0)}d=a+40|0;e=c+40|0;g=f[e>>2]|0;if(g|0){tFa(d,(f[d>>2]|0)+g|0);Vac((f[a+48>>2]|0)+8+(f[d>>2]<<3)|0,(f[c+48>>2]|0)+8|0,f[e>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[e>>2]|0)}e=a+56|0;d=c+56|0;g=f[d>>2]|0;if(g|0){nza(e,(f[e>>2]|0)+g|0);Vac((f[a+64>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+64>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[d>>2]|0)}UDa(a+72|0,c+72|0);d=a+88|0;e=c+88|0;g=f[e>>2]|0;if(g|0){qza(d,(f[d>>2]|0)+g|0);Vac((f[a+96>>2]|0)+4+(f[d>>2]<<2)|0,(f[c+96>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[e>>2]|0)}e=a+104|0;d=c+104|0;g=f[d>>2]|0;if(g|0){uFa(e,(f[e>>2]|0)+g|0);Vac((f[a+112>>2]|0)+8+(f[e>>2]<<3)|0,(f[c+112>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[e>>2]=(f[e>>2]|0)+(f[d>>2]|0)}d=a+120|0;e=c+120|0;g=f[e>>2]|0;if(g|0){vFa(d,(f[d>>2]|0)+g|0);Vac((f[d>>2]|0)+((f[a+128>>2]|0)+4)|0,(f[c+128>>2]|0)+4|0,f[e>>2]|0)|0;f[d>>2]=(f[d>>2]|0)+(f[e>>2]|0)}e=a+136|0;d=c+136|0;g=f[d>>2]|0;if(g|0){tFa(e,(f[e>>2]|0)+g|0);Vac((f[a+144>>2]|0)+8+(f[e>>2]<<3)|0,(f[c+144>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[e>>2]=(f[e>>2]|0)+(f[d>>2]|0)}d=f[c+160>>2]|0;if(d|0)f[a+160>>2]=d;if((c|0)!=492056?(d=c+156|0,e=f[d>>2]|0,e|0):0){g=a+156|0;h=f[g>>2]|0;if(!h){i=f[a+4>>2]|0;j=i&-2;if(!(i&1))k=j;else k=f[j+4>>2]|0;if(!k){j=L5b(32)|0;dBa(j);l=j}else{j=znb(k,18328,32)|0;jBa(j,k);l=j}f[g>>2]=l;m=f[d>>2]|0;n=l}else{m=e;n=h}lBa(n,(m|0)==0?491784:m)}m=f[c+164>>2]|0;if(m|0)f[a+164>>2]=m;m=f[c+152>>2]|0;c=b[m+11>>0]|0;if(c<<24>>24<0)o=f[m+4>>2]|0;else o=c&255;if(!o)return;o=a+152|0;c=f[a+4>>2]|0;a=c&-2;if(!(c&1))p=a;else p=f[a+4>>2]|0;a=f[o>>2]|0;if((a|0)==497760){dya(o,p,m);return}else{_5b(a,m)|0;return}}function tFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=a+4|0;g=f[e>>2]|0;if((g|0)>=(b|0)){u=c;return}h=a+8|0;i=f[h>>2]|0;j=(i|0)==0;if(j)k=0;else k=f[i>>2]|0;l=g<<1;g=(l|0)<(b|0)?b:l;l=(g|0)>4?g:4;if(l>>>0>536870910){zpb(d,3,468430,1285);xpb(c+24|0,vpb(vpb(d,468525)|0,468650)|0);Apb(d)}d=(l<<3)+8|0;if(!k)m=L5b(d)|0;else m=znb(k,25528,d)|0;f[h>>2]=m;f[m>>2]=k;f[e>>2]=l;e=m+8|0;if((l|0)>0){l=m+d|0;d=m+16|0;Nac(e|0,0,(l>>>0>d>>>0?l:d)+(-9-m)+8&-8|0)|0}m=f[a>>2]|0;if((m|0)>0)Vac(e|0,i+8|0,m<<3|0)|0;if(j){u=c;return}if(f[i>>2]|0){u=c;return}O5b(i);u=c;return}function uFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=a+4|0;g=f[e>>2]|0;if((g|0)>=(b|0)){u=c;return}h=a+8|0;i=f[h>>2]|0;j=(i|0)==0;if(j)k=0;else k=f[i>>2]|0;l=g<<1;g=(l|0)<(b|0)?b:l;l=(g|0)>4?g:4;if(l>>>0>536870910){zpb(d,3,468430,1285);xpb(c+24|0,vpb(vpb(d,468525)|0,468650)|0);Apb(d)}d=(l<<3)+8|0;if(!k)m=L5b(d)|0;else m=znb(k,25528,d)|0;f[h>>2]=m;f[m>>2]=k;f[e>>2]=l;e=m+8|0;if((l|0)>0){l=m+d|0;d=m+16|0;Nac(e|0,0,(l>>>0>d>>>0?l:d)+(-9-m)+8&-8|0)|0}m=f[a>>2]|0;if((m|0)>0)Vac(e|0,i+8|0,m<<3|0)|0;if(j){u=c;return}if(f[i>>2]|0){u=c;return}O5b(i);u=c;return}function vFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=a+4|0;g=f[e>>2]|0;if((g|0)>=(b|0)){u=c;return}h=a+8|0;i=f[h>>2]|0;j=(i|0)==0;if(j)k=0;else k=f[i>>2]|0;l=g<<1;g=(l|0)<(b|0)?b:l;l=(g|0)>4?g:4;if(l>>>0>4294967291){zpb(d,3,468430,1285);xpb(c+24|0,vpb(vpb(d,468525)|0,468650)|0);Apb(d)}d=l+4|0;if(!k)m=L5b(d)|0;else m=znb(k,25528,d)|0;f[h>>2]=m;f[m>>2]=k;f[e>>2]=l;e=m+4|0;if((l|0)>0){l=m+d|0;d=m+5|0;Nac(e|0,0,(l>>>0>d>>>0?l:d)+(-4-m)|0)|0}m=f[a>>2]|0;if((m|0)>0)Vac(e|0,i+4|0,m|0)|0;if(j){u=c;return}if(f[i>>2]|0){u=c;return}O5b(i);u=c;return}function wFa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+16|0;i=g;j=d+4|0;k=f[d>>2]|0;do if(((f[j>>2]|0)-k|0)>3){l=k;m=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;f[i>>2]=m;f[d>>2]=k+4;n=m}else{if(Xnb(d,i)|0){n=f[i>>2]|0;break}o=0;u=g;return o|0}while(0);i=f[e>>2]|0;k=e+4|0;if((i|0)==(f[k>>2]|0)){qza(e,i+1|0);p=f[e>>2]|0}else p=i;i=f[e+8>>2]|0;m=p+1|0;f[e>>2]=m;f[i+4+(p<<2)>>2]=n;n=f[d>>2]|0;p=(f[j>>2]|0)-n|0;if((p|0)<=0){o=1;u=g;return o|0}j=n;n=a+4|0;a=(f[k>>2]|0)-m|0;k=(p|0)/(n|0)|0;p=(k|0)<(a|0)?k:a;a:do if((p|0)>0){a=c&127|128;k=c>>>7&255;if(c>>>0<128){l=0;q=j;r=m;while(1){if((h[q>>0]|0)!=(c|0)){s=l;break a}t=q+1|0;v=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;t=r;r=r+1|0;f[e>>2]=r;f[i+4+(t<<2)>>2]=v;v=l+1|0;if((v|0)>=(p|0)){s=v;break a}else{l=v;q=q+5|0}}}if(c>>>0<16384){q=0;l=j;r=m;while(1){if((h[l>>0]|0)!=(a|0)){s=q;break a}if((b[l+1>>0]|0)!=k<<24>>24){s=q;break a}v=l+2|0;t=h[v>>0]|h[v+1>>0]<<8|h[v+2>>0]<<16|h[v+3>>0]<<24;v=r;r=r+1|0;f[e>>2]=r;f[i+4+(v<<2)>>2]=t;t=q+1|0;if((t|0)>=(p|0)){s=t;break}else{q=t;l=l+6|0}}}else s=0}else s=0;while(0);p=Y(s,n)|0;if((p|0)<=0){o=1;u=g;return o|0}Tnb(d,p)|0;o=1;u=g;return o|0}function xFa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,t=0,v=0,w=0,x=0;g=u;u=u+16|0;i=g;j=d+4|0;k=f[d>>2]|0;do if(((f[j>>2]|0)-k|0)>7){l=k;m=l;n=h[m>>0]|h[m+1>>0]<<8|h[m+2>>0]<<16|h[m+3>>0]<<24;m=l+4|0;l=h[m>>0]|h[m+1>>0]<<8|h[m+2>>0]<<16|h[m+3>>0]<<24;m=i;f[m>>2]=n;f[m+4>>2]=l;f[d>>2]=k+8;f[s>>2]=n;f[s+4>>2]=l;o=+p[s>>3]}else{if(Ynb(d,i)|0){o=+p[i>>3];break}q=0;u=g;return q|0}while(0);i=f[e>>2]|0;k=e+4|0;if((i|0)==(f[k>>2]|0)){tFa(e,i+1|0);r=f[e>>2]|0}else r=i;i=f[e+8>>2]|0;l=r+1|0;f[e>>2]=l;p[i+8+(r<<3)>>3]=o;r=f[d>>2]|0;n=(f[j>>2]|0)-r|0;if((n|0)<=0){q=1;u=g;return q|0}j=r;r=a+8|0;a=(f[k>>2]|0)-l|0;k=(n|0)/(r|0)|0;n=(k|0)<(a|0)?k:a;a:do if((n|0)>0){a=c&127|128;k=c>>>7&255;if(c>>>0<128){m=0;t=j;v=l;while(1){if((h[t>>0]|0)!=(c|0)){w=m;break a}x=t+1|0;b[s>>0]=b[x>>0];b[s+1>>0]=b[x+1>>0];b[s+2>>0]=b[x+2>>0];b[s+3>>0]=b[x+3>>0];b[s+4>>0]=b[x+4>>0];b[s+5>>0]=b[x+5>>0];b[s+6>>0]=b[x+6>>0];b[s+7>>0]=b[x+7>>0];o=+p[s>>3];x=v;v=v+1|0;f[e>>2]=v;p[i+8+(x<<3)>>3]=o;x=m+1|0;if((x|0)>=(n|0)){w=x;break a}else{m=x;t=t+9|0}}}if(c>>>0<16384){t=0;m=j;v=l;while(1){if((h[m>>0]|0)!=(a|0)){w=t;break a}if((b[m+1>>0]|0)!=k<<24>>24){w=t;break a}x=m+2|0;b[s>>0]=b[x>>0];b[s+1>>0]=b[x+1>>0];b[s+2>>0]=b[x+2>>0];b[s+3>>0]=b[x+3>>0];b[s+4>>0]=b[x+4>>0];b[s+5>>0]=b[x+5>>0];b[s+6>>0]=b[x+6>>0];b[s+7>>0]=b[x+7>>0];o=+p[s>>3];x=v;v=v+1|0;f[e>>2]=v;p[i+8+(x<<3)>>3]=o;x=t+1|0;if((x|0)>=(n|0)){w=x;break}else{t=x;m=m+10|0}}}else w=0}else w=0;while(0);n=Y(w,r)|0;if((n|0)<=0){q=1;u=g;return q|0}Tnb(d,n)|0;q=1;u=g;return q|0}function yFa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;a=u;u=u+16|0;g=a;i=f[d>>2]|0;j=d+4|0;if(i>>>0<(f[j>>2]|0)>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=i+1;l=k&255;m=0}else{Lnb(g,d);k=g;if(!(b[g+8>>0]|0)){n=0;u=a;return n|0}else{l=f[k>>2]|0;m=f[k+4>>2]|0}}k=f[e>>2]|0;i=e+4|0;o=f[i>>2]|0;if((k|0)==(o|0)){uFa(e,k+1|0);p=f[e>>2]|0;q=f[i>>2]|0}else{p=k;q=o}o=e+8|0;k=f[o>>2]|0;i=p+1|0;f[e>>2]=i;r=k+8+(p<<3)|0;f[r>>2]=l;f[r+4>>2]=m;m=q-i|0;if((m|0)<=0){n=1;u=a;return n|0}q=g+8|0;r=c&127|128;l=c>>>7&255;if(c>>>0<128){p=m;s=i;t=k;while(1){v=f[d>>2]|0;w=f[j>>2]|0;if(v>>>0>=w>>>0){n=1;x=27;break}if((h[v>>0]|0)!=(c|0)){n=1;x=27;break}y=v+1|0;f[d>>2]=y;if(y>>>0<w>>>0?(w=b[y>>0]|0,w<<24>>24>-1):0){f[d>>2]=v+2;z=s;A=t;B=w&255;C=0}else{Lnb(g,d);w=g;if(!(b[q>>0]|0)){n=0;x=27;break}z=f[e>>2]|0;A=f[o>>2]|0;B=f[w>>2]|0;C=f[w+4>>2]|0}s=z+1|0;f[e>>2]=s;w=A+8+(z<<3)|0;f[w>>2]=B;f[w+4>>2]=C;if((p|0)<=1){n=1;x=27;break}else{p=p+-1|0;t=A}}if((x|0)==27){u=a;return n|0}}if(c>>>0<16384){D=m;E=i;F=k}else{n=1;u=a;return n|0}while(1){k=f[j>>2]|0;i=f[d>>2]|0;m=i;if((k-i|0)<=1){n=1;x=27;break}if((h[m>>0]|0)!=(r|0)){n=1;x=27;break}if((b[m+1>>0]|0)!=l<<24>>24){n=1;x=27;break}i=m+2|0;f[d>>2]=i;if(i>>>0<k>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=m+3;G=E;H=F;I=k&255;J=0}else{Lnb(g,d);k=g;if(!(b[q>>0]|0)){n=0;x=27;break}G=f[e>>2]|0;H=f[o>>2]|0;I=f[k>>2]|0;J=f[k+4>>2]|0}E=G+1|0;f[e>>2]=E;k=H+8+(G<<3)|0;f[k>>2]=I;f[k+4>>2]=J;if((D|0)<=1){n=1;x=27;break}else{D=D+-1|0;F=H}}if((x|0)==27){u=a;return n|0}return 0}function zFa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;a=u;u=u+16|0;g=a;i=f[d>>2]|0;j=d+4|0;if(i>>>0<(f[j>>2]|0)>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=i+1;l=k<<24>>24!=0}else{Lnb(g,d);k=g;if(!(b[g+8>>0]|0)){m=0;u=a;return m|0}else l=(f[k>>2]|0)!=0|(f[k+4>>2]|0)!=0}k=f[e>>2]|0;i=e+4|0;n=f[i>>2]|0;if((k|0)==(n|0)){vFa(e,k+1|0);o=f[e>>2]|0;p=f[i>>2]|0}else{o=k;p=n}n=e+8|0;k=f[n>>2]|0;i=o+1|0;f[e>>2]=i;b[k+4+o>>0]=l&1;l=p-i|0;if((l|0)<=0){m=1;u=a;return m|0}p=g+8|0;o=c&127|128;q=c>>>7&255;if(c>>>0<128){r=l;s=i;t=k;while(1){v=f[d>>2]|0;w=f[j>>2]|0;if(v>>>0>=w>>>0){m=1;x=27;break}if((h[v>>0]|0)!=(c|0)){m=1;x=27;break}y=v+1|0;f[d>>2]=y;if(y>>>0<w>>>0?(w=b[y>>0]|0,w<<24>>24>-1):0){f[d>>2]=v+2;z=w<<24>>24!=0;A=s;B=t}else{Lnb(g,d);w=g;if(!(b[p>>0]|0)){m=0;x=27;break}z=(f[w>>2]|0)!=0|(f[w+4>>2]|0)!=0;A=f[e>>2]|0;B=f[n>>2]|0}s=A+1|0;f[e>>2]=s;b[B+4+A>>0]=z&1;if((r|0)<=1){m=1;x=27;break}else{r=r+-1|0;t=B}}if((x|0)==27){u=a;return m|0}}if(c>>>0<16384){C=l;D=i;E=k}else{m=1;u=a;return m|0}while(1){k=f[j>>2]|0;i=f[d>>2]|0;l=i;if((k-i|0)<=1){m=1;x=27;break}if((h[l>>0]|0)!=(o|0)){m=1;x=27;break}if((b[l+1>>0]|0)!=q<<24>>24){m=1;x=27;break}i=l+2|0;f[d>>2]=i;if(i>>>0<k>>>0?(k=b[i>>0]|0,k<<24>>24>-1):0){f[d>>2]=l+3;F=k<<24>>24!=0;G=D;H=E}else{Lnb(g,d);k=g;if(!(b[p>>0]|0)){m=0;x=27;break}F=(f[k>>2]|0)!=0|(f[k+4>>2]|0)!=0;G=f[e>>2]|0;H=f[n>>2]|0}D=G+1|0;f[e>>2]=D;b[H+4+G>>0]=F&1;if((C|0)<=1){m=1;x=27;break}else{C=C+-1|0;E=H}}if((x|0)==27){u=a;return m|0}return 0}function AFa(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[a>>2]=107640;e=a+4|0;f[a+24>>2]=0;f[a+28>>2]=0;f[a+32>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;f[a+64>>2]=0;g=a+72|0;f[a+104>>2]=0;f[a+108>>2]=0;f[a+112>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;f[a+128>>2]=0;f[a+136>>2]=0;f[a+140>>2]=0;f[a+144>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;if((a|0)!=492056?(f[212972]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=19;b[d+8>>0]=0;Gpb(851888,d);hpb(d)}f[a+152>>2]=497760;d=a+156|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function BFa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=107640;f[a+4>>2]=b;f[a+8>>2]=0;f[a+12>>2]=0;c=a+16|0;f[c>>2]=0;d=(b|0)==0;if(d){f[a+24>>2]=0;f[a+28>>2]=0;f[a+32>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;f[a+64>>2]=0}else{e=znb(b,25528,4)|0;f[c>>2]=e;f[e>>2]=b;f[a+24>>2]=0;f[a+28>>2]=0;e=a+32|0;f[e>>2]=0;c=znb(b,25528,4)|0;f[e>>2]=c;f[c>>2]=b;f[a+40>>2]=0;f[a+44>>2]=0;c=a+48|0;f[c>>2]=0;e=znb(b,25528,8)|0;f[c>>2]=e;f[e>>2]=b;f[a+56>>2]=0;f[a+60>>2]=0;e=a+64|0;f[e>>2]=0;c=znb(b,25528,4)|0;f[e>>2]=c;f[c>>2]=b}f[a+72>>2]=b;c=a+76|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;if(d){f[a+104>>2]=0;f[a+108>>2]=0;f[a+112>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;f[a+128>>2]=0;f[a+136>>2]=0;f[a+140>>2]=0;f[a+144>>2]=0;g=a+152|0;f[g>>2]=497760;h=a+156|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;return}else{d=znb(b,25528,4)|0;f[a+96>>2]=d;f[d>>2]=b;f[a+104>>2]=0;f[a+108>>2]=0;d=a+112|0;f[d>>2]=0;c=znb(b,25528,8)|0;f[d>>2]=c;f[c>>2]=b;f[a+120>>2]=0;f[a+124>>2]=0;c=a+128|0;f[c>>2]=0;d=znb(b,25528,4)|0;f[c>>2]=d;f[d>>2]=b;f[a+136>>2]=0;f[a+140>>2]=0;d=a+144|0;f[d>>2]=0;c=znb(b,25528,8)|0;f[d>>2]=c;f[c>>2]=b;g=a+152|0;f[g>>2]=497760;h=a+156|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;return}}function CFa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212973]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=18;b[c+8>>0]=0;Gpb(851892,c);hpb(c);u=a;return}function DFa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212973]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=18;b[c+8>>0]=0;Gpb(851892,c);hpb(c);u=a;return}function EFa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212972]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=19;b[c+8>>0]=0;Gpb(851888,c);hpb(c);u=a;return}function FFa(a,b){a=a|0;b=b|0;var c=0,d=0;f[a>>2]=107640;c=a+4|0;f[a+24>>2]=0;f[a+28>>2]=0;f[a+32>>2]=0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;f[a+64>>2]=0;d=a+72|0;f[a+104>>2]=0;f[a+108>>2]=0;f[a+112>>2]=0;f[a+120>>2]=0;f[a+124>>2]=0;f[a+128>>2]=0;f[a+136>>2]=0;f[a+140>>2]=0;f[a+144>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[a+152>>2]=497760;d=a+156|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;sFa(a,b);return}function GFa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212972]|0)==2){u=a;return 492056}f[c>>2]=135812;f[c+4>>2]=19;b[c+8>>0]=0;Gpb(851888,c);hpb(c);u=a;return 492056}function HFa(a,b){a=a|0;b=b|0;if((b|0)==(a|0))rFa(1056);else{sFa(a,b);return}}function IFa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=107800;c=a+116|0;d=f[c>>2]|0;if(d|0?(f[a+104>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)bi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=a+100|0;i=f[c>>2]|0;if(i|0?(f[a+88>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;O5b(j)}f[c>>2]=0;c=f[a+80>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=f[a+64>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=f[a+48>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=f[a+32>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=a+20|0;j=f[c>>2]|0;if(j|0?(f[a+8>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);O5b(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;O5b(k)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(k);f[c>>2]=0;return}function JFa(a){a=a|0;IFa(a);O5b(a);return}function KFa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function LFa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(124)|0;UGa(a);c=a;return c|0}else{a=znb(b,18568,124)|0;VGa(a,b);c=a;return c|0}return 0}function MFa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function NFa(a){a=a|0;return f[a+4>>2]|0}function OFa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+20>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}f[a+24>>2]=0;f[a+40>>2]=0;f[a+56>>2]=0;f[a+72>>2]=0;c=a+92|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+100>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((e|0)!=(d|0));f[c>>2]=0}c=a+108|0;d=f[c>>2]|0;if((d|0)<=0)return;e=f[a+116>>2]|0;a=0;do{g=f[e+4+(a<<2)>>2]|0;a=a+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((a|0)!=(d|0));f[c>>2]=0;return}function PFa(a){a=a|0;return 1}function QFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+24|0;l=a+28|0;m=a+32|0;n=e+8|0;o=a+40|0;p=a+44|0;q=a+48|0;r=a+56|0;s=a+60|0;t=a+64|0;v=e+8|0;w=a+72|0;x=a+76|0;y=a+80|0;z=c+44|0;A=a+88|0;B=a+100|0;C=a+96|0;D=a+92|0;E=a+104|0;F=a+116|0;G=a+112|0;H=a+108|0;a=c+32|0;I=c+12|0;K=c+28|0;a:while(1){L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0){M=b[L>>0]|0;N=M&255;if(M<<24>>24>0){f[i>>2]=N;f[c>>2]=L+1;O=N;P=6}else{Q=N;P=5}}else{Q=0;P=5}if((P|0)==5){P=0;N=_nb(c,Q)|0;f[i>>2]=N;if((N+-1|0)>>>0<127){O=N;P=6}else{R=N;P=138}}b:do if((P|0)==6){P=0;c:do switch(O>>>3&536870911|0){case 2:{switch(O|0){case 0:{S=1;P=141;break a;break}case 18:break;default:{T=O;break b}}if(!(fqb(c,mza(j)|0)|0)){S=0;P=141;break a}while(1){U=f[c>>2]|0;V=f[g>>2]|0;if(U>>>0>=V>>>0)continue a;if((b[U>>0]|0)!=18)break;f[c>>2]=U+1;if(!(fqb(c,mza(j)|0)|0)){S=0;P=141;break a}}if((b[U>>0]|0)!=26)continue a;N=U+1|0;f[c>>2]=N;W=N;X=V;P=16;break}case 3:{switch(O|0){case 0:{S=1;P=141;break a;break}case 26:{W=f[c>>2]|0;X=f[g>>2]|0;P=16;break c;break}case 24:{if(yFa(1,26,c,k)|0){P=30;break c}else{S=0;P=141;break a}break}default:{T=O;break b}}break}case 4:{switch(O|0){case 0:{S=1;P=141;break a;break}case 34:{Y=f[c>>2]|0;Z=f[g>>2]|0;P=35;break c;break}case 37:{if(wFa(1,34,c,o)|0){P=57;break c}else{S=0;P=141;break a}break}default:{T=O;break b}}break}case 5:{switch(O|0){case 0:{S=1;P=141;break a;break}case 42:{_=f[c>>2]|0;$=f[g>>2]|0;P=62;break c;break}case 40:{if(zFa(1,42,c,r)|0){P=76;break c}else{S=0;P=141;break a}break}default:{T=O;break b}}break}case 6:{switch(O|0){case 0:{S=1;P=141;break a;break}case 50:{aa=f[c>>2]|0;ba=f[g>>2]|0;P=81;break c;break}case 48:break;default:{T=O;break b}}N=f[c>>2]|0;if(N>>>0<(f[g>>2]|0)>>>0){L=b[N>>0]|0;M=L&255;if(L<<24>>24>-1){f[c>>2]=N+1;ca=M}else{da=M;P=97}}else{da=0;P=97}if((P|0)==97){P=0;M=Knb(c,da)|0;N=J;if((N|0)>-1|(N|0)==-1&M>>>0>4294967295)ca=M;else{S=0;P=141;break a}}M=f[w>>2]|0;if((M|0)==(f[x>>2]|0)){nza(w,M+1|0);ea=f[w>>2]|0}else ea=M;M=f[y>>2]|0;f[w>>2]=ea+1;f[M+4+(ea<<2)>>2]=ca;P=101;break}case 7:{switch(O|0){case 0:{S=1;P=141;break a;break}case 58:{P=105;break}default:{T=O;break b}}break}case 8:{switch(O|0){case 0:{S=1;P=141;break a;break}case 66:break;default:{T=O;break b}}M=f[z>>2]|0;f[z>>2]=M+-1;if((M|0)<=0){S=0;P=141;break a}break}default:{R=O;P=138;break b}}while(0);if((P|0)==16){P=0;if(W>>>0<X>>>0?(M=b[W>>0]|0,M<<24>>24>-1):0){f[c>>2]=W+1;fa=M&255}else{M=Znb(c)|0;if((M|0)>-1)fa=M;else{S=0;P=141;break a}}M=Gnb(c,fa)|0;if((Qnb(c)|0)>0)do{N=f[c>>2]|0;if(N>>>0<(f[g>>2]|0)>>>0?(L=b[N>>0]|0,L<<24>>24>-1):0){f[c>>2]=N+1;ga=L&255;ha=0}else{Lnb(e,c);L=e;if(!(b[n>>0]|0)){S=0;P=141;break a}else{ga=f[L>>2]|0;ha=f[L+4>>2]|0}}L=f[k>>2]|0;if((L|0)==(f[l>>2]|0)){uFa(k,L+1|0);ia=f[k>>2]|0}else ia=L;L=f[m>>2]|0;f[k>>2]=ia+1;N=L+8+(ia<<3)|0;f[N>>2]=ga;f[N+4>>2]=ha}while((Qnb(c)|0)>0);Hnb(c,M);P=30}if((P|0)==30){P=0;N=f[c>>2]|0;L=f[g>>2]|0;if(N>>>0>=L>>>0)continue a;if((b[N>>0]|0)!=34)continue a;ja=N+1|0;f[c>>2]=ja;Y=ja;Z=L;P=35}do if((P|0)==35){P=0;if(Y>>>0<Z>>>0?(L=b[Y>>0]|0,L<<24>>24>-1):0){f[c>>2]=Y+1;ka=L&255}else{L=Znb(c)|0;if((L|0)>-1)ka=L;else{S=0;P=141;break a}}la=f[o>>2]|0;L=ka>>>2;if((L<<2|0)!=(ka|0)){S=0;P=141;break a}ja=Snb(c)|0;N=Qnb(c)|0;if((((ja|0)==-1|(N|0)<(ja|0)?N:ja)|0)>=(ka|0)){ja=la+L|0;if((f[o>>2]|0)<(ja|0)?(qza(o,ja),N=f[o>>2]|0,ma=ja-N|0,(ma<<2|0)>0):0)Nac((f[q>>2]|0)+((N<<2)+4)|0,0,(((ma|-1073741824|0)==-1073741824?1073741823:1073741822)+ma<<2)+8|0)|0;f[o>>2]=ja;ja=f[q>>2]|0;if(Unb(c,((ja|0)==0?0:ja+4|0)+(la<<2)|0,ka)|0){P=57;break}else{P=46;break a}}if(!L)P=57;else{ja=0;while(1){ma=f[c>>2]|0;if(((f[g>>2]|0)-ma|0)>3){N=ma;na=h[N>>0]|h[N+1>>0]<<8|h[N+2>>0]<<16|h[N+3>>0]<<24;f[e>>2]=na;f[c>>2]=ma+4;oa=na}else{if(!(Xnb(c,e)|0)){P=55;break a}oa=f[e>>2]|0}na=f[o>>2]|0;if((na|0)==(f[p>>2]|0)){qza(o,na+1|0);pa=f[o>>2]|0}else pa=na;na=f[q>>2]|0;f[o>>2]=pa+1;f[na+4+(pa<<2)>>2]=oa;ja=ja+1|0;if((ja|0)>=(L|0)){P=57;break}}}}while(0);if((P|0)==57){P=0;M=f[c>>2]|0;L=f[g>>2]|0;if(M>>>0>=L>>>0)continue a;if((b[M>>0]|0)!=42)continue a;ja=M+1|0;f[c>>2]=ja;_=ja;$=L;P=62}if((P|0)==62){P=0;if(_>>>0<$>>>0?(L=b[_>>0]|0,L<<24>>24>-1):0){f[c>>2]=_+1;qa=L&255}else{L=Znb(c)|0;if((L|0)>-1)qa=L;else{S=0;P=141;break a}}L=Gnb(c,qa)|0;if((Qnb(c)|0)>0)do{ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0?(M=b[ja>>0]|0,M<<24>>24>-1):0){f[c>>2]=ja+1;ra=M<<24>>24!=0}else{Lnb(e,c);M=e;if(!(b[v>>0]|0)){S=0;P=141;break a}else ra=(f[M>>2]|0)!=0|(f[M+4>>2]|0)!=0}M=f[r>>2]|0;if((M|0)==(f[s>>2]|0)){vFa(r,M+1|0);sa=f[r>>2]|0}else sa=M;M=f[t>>2]|0;f[r>>2]=sa+1;b[M+4+sa>>0]=ra&1}while((Qnb(c)|0)>0);Hnb(c,L);P=76}if((P|0)==76){P=0;M=f[c>>2]|0;ja=f[g>>2]|0;if(M>>>0>=ja>>>0)continue a;if((b[M>>0]|0)!=50)continue a;na=M+1|0;f[c>>2]=na;aa=na;ba=ja;P=81}if((P|0)==81){P=0;if(aa>>>0<ba>>>0){ja=b[aa>>0]|0;na=ja&255;if(ja<<24>>24>-1){f[c>>2]=aa+1;ta=na}else{ua=na;P=84}}else{ua=0;P=84}if((P|0)==84){P=0;na=Knb(c,ua)|0;ja=J;if((ja|0)>-1|(ja|0)==-1&na>>>0>4294967295)ta=na;else{S=0;P=141;break a}}na=Gnb(c,ta)|0;if((Qnb(c)|0)>0)do{ja=f[c>>2]|0;if(ja>>>0<(f[g>>2]|0)>>>0){M=b[ja>>0]|0;ma=M&255;if(M<<24>>24>-1){f[c>>2]=ja+1;va=ma}else{wa=ma;P=89}}else{wa=0;P=89}if((P|0)==89){P=0;ma=Knb(c,wa)|0;ja=J;if((ja|0)>-1|(ja|0)==-1&ma>>>0>4294967295)va=ma;else{S=0;P=141;break a}}ma=f[w>>2]|0;if((ma|0)==(f[x>>2]|0)){nza(w,ma+1|0);xa=f[w>>2]|0}else xa=ma;ma=f[y>>2]|0;f[w>>2]=xa+1;f[ma+4+(xa<<2)>>2]=va}while((Qnb(c)|0)>0);Hnb(c,na);P=101}if((P|0)==101){P=0;L=f[c>>2]|0;if(L>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[L>>0]|0)!=58)continue a;f[c>>2]=L+1;P=105}do if((P|0)==105){P=0;L=f[z>>2]|0;f[z>>2]=L+-1;if((L|0)<=0){S=0;P=141;break a}while(1){L=f[B>>2]|0;do if(L){ma=f[D>>2]|0;ja=f[L>>2]|0;if((ma|0)>=(ja|0))if((ja|0)==(f[C>>2]|0)){ya=ja;P=111;break}else{za=ja;Aa=L;P=112;break}else{f[D>>2]=ma+1;Ba=f[L+4+(ma<<2)>>2]|0;break}}else{ya=f[C>>2]|0;P=111}while(0);if((P|0)==111){P=0;cpb(A,ya+1|0);L=f[B>>2]|0;za=f[L>>2]|0;Aa=L;P=112}if((P|0)==112){P=0;f[Aa>>2]=za+1;L=aHa(0,f[A>>2]|0)|0;ma=f[B>>2]|0;ja=f[D>>2]|0;f[D>>2]=ja+1;f[ma+4+(ja<<2)>>2]=L;Ba=L}L=Jnb(c)|0;if(!(QAa(Ba,c)|0)){S=0;P=141;break a}if(!(Pnb(c,L)|0)){S=0;P=141;break a}Ca=f[c>>2]|0;if(Ca>>>0>=(f[g>>2]|0)>>>0)break;if((b[Ca>>0]|0)!=58){P=118;break}f[c>>2]=Ca+1}if((P|0)==118?(P=0,(b[Ca>>0]|0)==66):0){Da=Ca;P=122;break}f[z>>2]=(f[z>>2]|0)+1;continue a}while(0);while(1){if((P|0)==122){P=0;f[c>>2]=Da+1}na=f[F>>2]|0;do if(na){L=f[H>>2]|0;ja=f[na>>2]|0;if((L|0)>=(ja|0))if((ja|0)==(f[G>>2]|0)){Ea=ja;P=128;break}else{Fa=ja;Ga=na;P=129;break}else{f[H>>2]=L+1;Ha=f[na+4+(L<<2)>>2]|0;break}}else{Ea=f[G>>2]|0;P=128}while(0);if((P|0)==128){P=0;cpb(E,Ea+1|0);na=f[F>>2]|0;Fa=f[na>>2]|0;Ga=na;P=129}if((P|0)==129){P=0;f[Ga>>2]=Fa+1;na=_Ga(0,f[E>>2]|0)|0;L=f[F>>2]|0;ja=f[H>>2]|0;f[H>>2]=ja+1;f[L+4+(ja<<2)>>2]=na;Ha=na}na=Jnb(c)|0;if(!(cFa(Ha,c)|0)){S=0;P=141;break a}if(!(Pnb(c,na)|0)){S=0;P=141;break a}Da=f[c>>2]|0;Ia=f[g>>2]|0;if(Da>>>0>=Ia>>>0)break;if((b[Da>>0]|0)!=66)break;else P=122}f[z>>2]=(f[z>>2]|0)+1;if((Da|0)!=(Ia|0))continue a;if(f[a>>2]|0){P=137;break a}if((f[I>>2]|0)==(f[K>>2]|0)){P=137;break a}else continue a}while(0);if((P|0)==138){P=0;if(!R){S=1;P=141;break}else T=R}if((T&7|0)==4){S=1;P=141;break}if(!(Lpb(c,T)|0)){S=0;P=141;break}}if((P|0)==46){if((f[o>>2]|0)<=0){S=0;u=d;return S|0}f[o>>2]=la;S=0;u=d;return S|0}else if((P|0)==55){S=0;u=d;return S|0}else if((P|0)==137){f[i>>2]=0;b[c+24>>0]=1;S=1;u=d;return S|0}else if((P|0)==141){u=d;return S|0}return 0}function RFa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=a+20|0;g=0;h=d;i=d;while(1){j=f[(f[e>>2]|0)+4+(g<<2)>>2]|0;k=b[j+11>>0]|0;if(k<<24>>24<0){l=f[j+4>>2]|0;if(l>>>0<128){m=1;n=l;o=i}else{j=iob(l)|0;m=j;n=l;o=f[c>>2]|0}}else{m=1;n=k&255;o=i}k=n+h+m|0;g=g+1|0;if((g|0)>=(o|0)){p=k;break}else{h=k;i=o}}}else p=d;d=f[a+24>>2]|0;if(d){o=a+32|0;i=0;h=0;do{g=(f[o>>2]|0)+8+(h<<3)|0;i=(job(f[g>>2]|0,f[g+4>>2]|0)|0)+i|0;h=h+1|0}while((h|0)!=(d|0));if(i){if((i|0)>=0)if(i>>>0<128)q=1;else q=iob(i)|0;else q=10;r=i;s=p+1+q|0}else{r=0;s=p}}else{r=0;s=p}f[a+36>>2]=r;p=s+r|0;r=f[a+40>>2]<<2;if(!r)t=p;else{if((r|0)>=0)if(r>>>0<128)u=2;else u=(iob(r)|0)+1|0;else u=11;t=u+p|0}f[a+52>>2]=r;p=t+r|0;r=f[a+56>>2]|0;if(!r)v=p;else{if((r|0)>=0)if(r>>>0<128)w=2;else w=(iob(r)|0)+1|0;else w=11;v=w+p|0}f[a+68>>2]=r;p=v+r|0;r=f[a+72>>2]|0;if(r){v=a+80|0;w=0;t=0;do{u=f[(f[v>>2]|0)+4+(w<<2)>>2]|0;if((u|0)>=0)if(u>>>0<128)x=1;else x=iob(u)|0;else x=10;t=x+t|0;w=w+1|0}while((w|0)!=(r|0));if(t){if((t|0)>=0)if(t>>>0<128)y=2;else y=(iob(t)|0)+1|0;else y=11;z=t;A=y+p|0}else{z=0;A=p}}else{z=0;A=p}f[a+84>>2]=z;p=f[a+92>>2]|0;y=A+z+p|0;if(!p)B=y;else{z=a+100|0;A=0;t=y;while(1){y=RAa(f[(f[z>>2]|0)+4+(A<<2)>>2]|0)|0;if(y>>>0<128)C=1;else C=iob(y)|0;r=y+t+C|0;A=A+1|0;if((A|0)==(p|0)){B=r;break}else t=r}}t=f[a+108>>2]|0;p=t+B|0;if(!t){D=p;E=a+120|0;f[E>>2]=D;return D|0}B=a+116|0;A=0;C=p;while(1){p=dFa(f[(f[B>>2]|0)+4+(A<<2)>>2]|0)|0;if(p>>>0<128)F=1;else F=iob(p)|0;z=p+C+F|0;A=A+1|0;if((A|0)==(t|0)){D=z;break}else C=z}E=a+120|0;f[E>>2]=D;return D|0}function SFa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=a+12|0;if((f[d>>2]|0)>0){e=a+20|0;g=0;do{aqb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)<(f[d>>2]|0))}d=a+24|0;if((f[d>>2]|0)>0){g=c+8|0;if((f[g>>2]|0)>4){e=c+4|0;b[f[e>>2]>>0]=26;f[e>>2]=(f[e>>2]|0)+1;e=(f[g>>2]|0)+-1|0;f[g>>2]=e;h=e}else{fob(c,26);h=f[g>>2]|0}e=f[a+36>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(e>>>0>127){j=e;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=e}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[g>>2]=(f[g>>2]|0)-o}else fob(c,e);if((f[d>>2]|0)>0){e=a+32|0;o=0;do{g=(f[e>>2]|0)+8+(o<<3)|0;gob(c,f[g>>2]|0,f[g+4>>2]|0);o=o+1|0}while((o|0)<(f[d>>2]|0))}}d=a+40|0;if((f[d>>2]|0)>0){o=c+8|0;if((f[o>>2]|0)>4){e=c+4|0;b[f[e>>2]>>0]=34;f[e>>2]=(f[e>>2]|0)+1;e=(f[o>>2]|0)+-1|0;f[o>>2]=e;p=e}else{fob(c,34);p=f[o>>2]|0}e=f[a+52>>2]|0;if((p|0)>4){p=c+4|0;g=f[p>>2]|0;if(e>>>0>127){h=e;i=g;while(1){b[i>>0]=h|128;n=h>>>7;k=i+1|0;if(h>>>0>16383){h=n;i=k}else{q=k;r=n;break}}}else{q=g;r=e}b[q>>0]=r;r=q+1-g|0;f[p>>2]=(f[p>>2]|0)+r;f[o>>2]=(f[o>>2]|0)-r}else fob(c,e);if((f[d>>2]|0)>0){e=a+48|0;r=0;do{dob(c,f[(f[e>>2]|0)+4+(r<<2)>>2]|0);r=r+1|0}while((r|0)<(f[d>>2]|0))}}d=a+56|0;if((f[d>>2]|0)>0){r=c+8|0;if((f[r>>2]|0)>4){e=c+4|0;b[f[e>>2]>>0]=42;f[e>>2]=(f[e>>2]|0)+1;e=(f[r>>2]|0)+-1|0;f[r>>2]=e;s=e}else{fob(c,42);s=f[r>>2]|0}e=f[a+68>>2]|0;if((s|0)>4){s=c+4|0;o=f[s>>2]|0;if(e>>>0>127){p=e;g=o;while(1){b[g>>0]=p|128;q=p>>>7;i=g+1|0;if(p>>>0>16383){p=q;g=i}else{t=i;u=q;break}}}else{t=o;u=e}b[t>>0]=u;u=t+1-o|0;f[s>>2]=(f[s>>2]|0)+u;f[r>>2]=(f[r>>2]|0)-u}else fob(c,e);if((f[d>>2]|0)>0){e=a+64|0;u=c+8|0;r=c+4|0;s=0;do{o=b[(f[e>>2]|0)+4+s>>0]|0;if((f[u>>2]|0)>4){b[f[r>>2]>>0]=o;f[r>>2]=(f[r>>2]|0)+1;f[u>>2]=(f[u>>2]|0)+-1}else fob(c,o&255);s=s+1|0}while((s|0)<(f[d>>2]|0))}}d=a+72|0;if((f[d>>2]|0)>0){s=c+8|0;if((f[s>>2]|0)>4){u=c+4|0;b[f[u>>2]>>0]=50;f[u>>2]=(f[u>>2]|0)+1;u=(f[s>>2]|0)+-1|0;f[s>>2]=u;v=u}else{fob(c,50);v=f[s>>2]|0}u=f[a+84>>2]|0;if((v|0)>4){v=c+4|0;r=f[v>>2]|0;if(u>>>0>127){e=u;o=r;while(1){b[o>>0]=e|128;t=e>>>7;g=o+1|0;if(e>>>0>16383){e=t;o=g}else{w=g;x=t;break}}}else{w=r;x=u}b[w>>0]=x;x=w+1-r|0;f[v>>2]=(f[v>>2]|0)+x;f[s>>2]=(f[s>>2]|0)-x}else fob(c,u);if((f[d>>2]|0)>0){u=a+80|0;x=c+8|0;s=c+4|0;v=0;do{r=f[(f[u>>2]|0)+4+(v<<2)>>2]|0;do if((r|0)<0)gob(c,r,((r|0)<0)<<31>>31);else{if((f[x>>2]|0)<=4){fob(c,r);break}w=f[s>>2]|0;if(r>>>0>127){o=r;e=w;while(1){b[e>>0]=o|128;t=o>>>7;g=e+1|0;if(o>>>0>16383){o=t;e=g}else{y=g;z=t;break}}}else{y=w;z=r}b[y>>0]=z;e=y+1-w|0;f[s>>2]=(f[s>>2]|0)+e;f[x>>2]=(f[x>>2]|0)-e}while(0);v=v+1|0}while((v|0)<(f[d>>2]|0))}}d=f[a+92>>2]|0;if(d|0){v=a+100|0;x=0;do{eqb(7,f[(f[v>>2]|0)+4+(x<<2)>>2]|0,c);x=x+1|0}while((x|0)!=(d|0))}d=f[a+108>>2]|0;if(!d)return;x=a+116|0;a=0;do{eqb(8,f[(f[x>>2]|0)+4+(a<<2)>>2]|0,c);a=a+1|0}while((a|0)!=(d|0));return}function TFa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function UFa(a){a=a|0;return f[a+120>>2]|0}function VFa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;c=a+12|0;if((f[c>>2]|0)>0){e=a+20|0;g=d;h=0;while(1){i=f[(f[e>>2]|0)+4+(h<<2)>>2]|0;b[g>>0]=18;j=kob(i,g+1|0)|0;h=h+1|0;if((h|0)>=(f[c>>2]|0)){k=j;break}else g=j}}else k=d;d=a+24|0;if((f[d>>2]|0)>0){b[k>>0]=26;g=k+1|0;c=f[a+36>>2]|0;if(c>>>0>127){h=c;e=g;while(1){b[e>>0]=h|128;j=h>>>7;i=e+1|0;if(h>>>0>16383){h=j;e=i}else{l=i;m=j;break}}}else{l=g;m=c}b[l>>0]=m;m=l+1|0;if((f[d>>2]|0)>0){l=a+32|0;c=0;g=m;while(1){e=(f[l>>2]|0)+8+(c<<3)|0;h=hob(f[e>>2]|0,f[e+4>>2]|0,g)|0;c=c+1|0;if((c|0)>=(f[d>>2]|0)){n=h;break}else g=h}}else n=m}else n=k;k=a+40|0;if((f[k>>2]|0)>0){b[n>>0]=34;m=n+1|0;g=f[a+52>>2]|0;if(g>>>0>127){d=g;c=m;while(1){b[c>>0]=d|128;l=d>>>7;h=c+1|0;if(d>>>0>16383){d=l;c=h}else{o=h;p=l;break}}}else{o=m;p=g}b[o>>0]=p;p=o+1|0;if((f[k>>2]|0)>0){o=a+48|0;g=0;m=p;while(1){c=f[(f[o>>2]|0)+4+(g<<2)>>2]|0;b[m>>0]=c;b[m+1>>0]=c>>8;b[m+2>>0]=c>>16;b[m+3>>0]=c>>24;c=m+4|0;g=g+1|0;if((g|0)>=(f[k>>2]|0)){q=c;break}else m=c}}else q=p}else q=n;n=a+56|0;if((f[n>>2]|0)>0){b[q>>0]=42;p=q+1|0;m=f[a+68>>2]|0;if(m>>>0>127){k=m;g=p;while(1){b[g>>0]=k|128;o=k>>>7;c=g+1|0;if(k>>>0>16383){k=o;g=c}else{r=c;s=o;break}}}else{r=p;s=m}b[r>>0]=s;s=r+1|0;if((f[n>>2]|0)>0){r=a+64|0;m=0;p=s;while(1){b[p>>0]=b[(f[r>>2]|0)+4+m>>0]|0;g=p+1|0;m=m+1|0;if((m|0)>=(f[n>>2]|0)){t=g;break}else p=g}}else t=s}else t=q;q=a+72|0;if((f[q>>2]|0)>0){b[t>>0]=50;s=t+1|0;p=f[a+84>>2]|0;if(p>>>0>127){n=p;m=s;while(1){b[m>>0]=n|128;r=n>>>7;g=m+1|0;if(n>>>0>16383){n=r;m=g}else{u=g;v=r;break}}}else{u=s;v=p}b[u>>0]=v;v=u+1|0;if((f[q>>2]|0)>0){u=a+80|0;p=0;s=v;while(1){m=f[(f[u>>2]|0)+4+(p<<2)>>2]|0;if((m|0)<0)w=hob(m,((m|0)<0)<<31>>31,s)|0;else{if(m>>>0>127){n=m;r=s;while(1){b[r>>0]=n|128;g=n>>>7;k=r+1|0;if(n>>>0>16383){n=g;r=k}else{x=k;y=g;break}}}else{x=s;y=m}b[x>>0]=y;w=x+1|0}p=p+1|0;if((p|0)>=(f[q>>2]|0)){z=w;break}else s=w}}else z=v}else z=t;t=f[a+92>>2]|0;if(!t)A=z;else{v=a+100|0;w=0;s=z;while(1){z=f[(f[v>>2]|0)+4+(w<<2)>>2]|0;b[s>>0]=58;q=s+1|0;p=f[z+28>>2]|0;if(p>>>0>127){x=p;y=q;while(1){b[y>>0]=x|128;u=x>>>7;r=y+1|0;if(x>>>0>16383){x=u;y=r}else{B=r;C=u;break}}}else{B=q;C=p}b[B>>0]=C;y=li[f[(f[z>>2]|0)+68>>2]&511](z,0,B+1|0)|0;w=w+1|0;if((w|0)==(t|0)){A=y;break}else s=y}}s=f[a+108>>2]|0;if(!s){D=A;return D|0}t=a+116|0;a=0;w=A;while(1){A=f[(f[t>>2]|0)+4+(a<<2)>>2]|0;b[w>>0]=66;B=w+1|0;C=f[A+168>>2]|0;if(C>>>0>127){v=C;y=B;while(1){b[y>>0]=v|128;x=v>>>7;m=y+1|0;if(v>>>0>16383){v=x;y=m}else{E=m;F=x;break}}}else{E=B;F=C}b[E>>0]=F;y=li[f[(f[A>>2]|0)+68>>2]&511](A,0,E+1|0)|0;a=a+1|0;if((a|0)==(s|0)){D=y;break}else w=y}return D|0}function WFa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function XFa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))xGa(763);c=T6b(b,23288,18568,0)|0;if(!c){cOb(b,a);return}else{WGa(a,c);return}}function YFa(a,b){a=a|0;b=b|0;f[a+120>>2]=b;return}function ZFa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[212979]|0)!=2){f[d>>2]=135812;f[d+4>>2]=21;b[d+8>>0]=0;Gpb(851916,d);hpb(d)}f[a>>2]=f[212980];f[a+4>>2]=f[212981];u=c;return}function _Fa(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+48|0;c=a+24|0;d=a;e=a+36|0;if((f[212978]|0)!=2){f[c>>2]=135812;f[c+4>>2]=22;b[c+8>>0]=0;Gpb(851912,c);hpb(c)}g=drb()|0;h=L5b(32)|0;f[c>>2]=h;f[c+8>>2]=-2147483616;f[c+4>>2]=16;i=h;j=384899;k=i+16|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+16>>0]=0;h=hrb(g,c)|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if(!h){zpb(d,3,384916,56);xpb(e,vpb(d,459532)|0);Apb(d)}d=h+40|0;f[212982]=f[d>>2];if((b[492480]|0)==0?Cac(492480)|0:0){f[212983]=0;f[212984]=8;f[212985]=16;f[212986]=20;f[212987]=24;f[212988]=28;f[212989]=32;f[212990]=36;f[212991]=40;f[212992]=44;f[212993]=8}h=oIb(f[212982]|0,492240,851932,-1,-1,-1,f[212994]|0,20,24,4,-1)|0;f[212995]=h;h=f[(f[212982]|0)+44>>2]|0;f[212980]=h;e=pIb(h,492272,107900,-1,-1,-1,124,4,-1)|0;f[212981]=e;e=(f[d>>2]|0)+88|0;f[212996]=e;d=pIb(e,492408,107928,-1,-1,-1,60,4,-1)|0;f[212997]=d;f[212998]=f[(f[212996]|0)+44>>2];u=a;return}function $Fa(){var a=0,c=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,384916);if((f[212977]|0)!=2){f[c>>2]=135812;f[c+4>>2]=23;b[c+8>>0]=0;Gpb(851908,c);hpb(c)}grb(385001,797);SNb(384899,1497);DFa();fBa();kJa();spb(24);u=a;return}function aGa(){var a=0,c=0,d=0,e=0,g=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,384916);EFa();gBa();lJa();if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123060]=107944;f[123061]=0;f[123065]=0;f[123064]=0;b[492264]=1;d=L5b(48)|0;e=d;g=e+48|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[212994]=d;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123068]=107800;f[123078]=0;f[123079]=0;f[123080]=0;f[123082]=0;f[123083]=0;f[123084]=0;f[123086]=0;f[123087]=0;f[123088]=0;f[123069]=0;f[123070]=0;f[123071]=0;f[123072]=0;f[123073]=0;f[123074]=0;f[123075]=0;f[123076]=0;e=492360;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));b[492400]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}dGa(492408);b[492472]=1;c=f[212994]|0;f[c>>2]=497760;e=c+8|0;f[e>>2]=0;f[e+4>>2]=0;n[c+16>>2]=0.0;b[c+20>>0]=0;f[c+24>>2]=0;f[c+28>>2]=491784;f[c+32>>2]=492056;f[c+36>>2]=492272;f[c+40>>2]=492408;f[c+44>>2]=497760;u=a;return}function bGa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[212979]|0)!=2){f[c>>2]=135812;f[c+4>>2]=21;b[c+8>>0]=0;Gpb(851916,c);hpb(c)}WNb(f[212982]|0,492240);WNb(f[212980]|0,492272);WNb(f[212996]|0,492408);c=f[212998]|0;WNb(c,JBa(c)|0);u=a;return}function cGa(){var a=0;if(b[492264]|0){b[492264]=0;bi[f[f[123060]>>2]&2047](492240)}a=f[212994]|0;if(a|0)O5b(a);a=f[212995]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[492400]|0){b[492400]=0;bi[f[f[123068]>>2]&2047](492272)}a=f[212981]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[492472]|0){b[492472]=0;bi[f[f[123102]>>2]&2047](492408)}a=f[212997]|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dGa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=108052;f[a+4>>2]=0;vCa(a+8|0);if((a|0)!=492408?(f[212977]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=23;b[d+8>>0]=0;Gpb(851908,d);hpb(d)}f[a+24>>2]=25;f[a+20>>2]=851992;f[a+52>>2]=497760;f[a+56>>2]=0;u=c;return}function eGa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212979]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=21;b[c+8>>0]=0;Gpb(851916,c);hpb(c);u=a;return}function fGa(a){a=a|0;var c=0,d=0,e=0,g=0;f[a>>2]=108052;c=a+4|0;d=f[c>>2]|0;e=d&-2;if(!(d&1))g=e;else g=f[e+4>>2]|0;if(!g){g=a+52|0;e=f[g>>2]|0;if(!((e|0)==497760|(e|0)==0)){if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);O5b(e)}f[g>>2]=497760}f[a+36>>2]=107148;g=f[a+44>>2]|0;if(g|0){txa(g);O5b(g)}QIb(a+8|0);a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}g=a&-2;a=g;if((g|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(g);f[c>>2]=0;return}function gGa(a){a=a|0;fGa(a);O5b(a);return}function hGa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function iGa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(60)|0;dGa(a);c=a;return c|0}else{a=znb(b,18584,60)|0;AGa(a,b);c=a;return c|0}return 0}function jGa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function kGa(a){a=a|0;return f[a+4>>2]|0}function lGa(a){a=a|0;var c=0,d=0;c=f[a+52>>2]|0;do if((c|0)!=497760){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=a+8|0;tKb(c);yxa(f[a+44>>2]|0);sKb(c);return}function mGa(a){a=a|0;return 1}function nGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=u;u=u+48|0;e=d+32|0;g=d;h=c+4|0;i=c+20|0;j=a+52|0;k=a+4|0;l=a+52|0;m=c+44|0;n=a+8|0;a=g+4|0;o=g+8|0;p=g+24|0;q=e+4|0;r=o+11|0;s=g+12|0;t=c+32|0;v=c+12|0;w=c+28|0;a:while(1){x=f[c>>2]|0;if(x>>>0<(f[h>>2]|0)>>>0){y=b[x>>0]|0;z=y&255;if(y<<24>>24>0){f[i>>2]=z;f[c>>2]=x+1;A=z;B=6}else{C=z;B=5}}else{C=0;B=5}if((B|0)==5){B=0;z=_nb(c,C)|0;f[i>>2]=z;if((z+-1|0)>>>0<127){A=z;B=6}else{D=z;B=44}}b:do if((B|0)==6){B=0;switch(A>>>3&536870911|0){case 1:{switch(A|0){case 0:{E=1;B=48;break a;break}case 10:break;default:{F=A;break b}}z=f[k>>2]|0;x=z&-2;if(!(z&1))G=x;else G=f[x+4>>2]|0;x=f[j>>2]|0;if((x|0)==497760){dya(j,G,497760);H=f[j>>2]|0}else H=x;if(!(fqb(c,H)|0)){E=0;B=48;break a}x=f[l>>2]|0;z=b[x+11>>0]|0;if(z<<24>>24<0){I=f[x>>2]|0;J=f[x+4>>2]|0}else{I=x;J=z&255}if(!(gqb(I,J,0,385799)|0)){E=0;B=48;break a}z=f[c>>2]|0;if(z>>>0>=(f[h>>2]|0)>>>0)continue a;if((b[z>>0]|0)!=18)continue a;f[c>>2]=z+1;break}case 2:{switch(A|0){case 0:{E=1;B=48;break a;break}case 18:break;default:{F=A;break b}}break}default:{D=A;B=44;break b}}z=f[m>>2]|0;f[m>>2]=z+-1;if((z|0)<=0){E=0;B=48;break a}while(1){f[g>>2]=n;z=di[f[(f[n>>2]|0)+68>>2]&1023](n)|0;f[a>>2]=z;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[p>>2]=0;z=f[c>>2]|0;if(z>>>0<(f[h>>2]|0)>>>0?(x=b[z>>0]|0,x<<24>>24>-1):0){f[c>>2]=z+1;K=x&255;B=27}else{x=Znb(c)|0;if((x|0)>-1){K=x;B=27}else L=6}do if((B|0)==27){B=0;Inb(e,c,K);if((f[q>>2]|0)>=0?cEa(g,c)|0:0){if(!(Onb(c,f[e>>2]|0)|0)){L=6;break}x=b[r>>0]|0;z=x<<24>>24<0;y=gqb(z?f[o>>2]|0:o,z?f[s>>2]|0:x&255,0,385828)|0;L=y?0:6;break}L=6}while(0);y=f[p>>2]|0;if(y|0)bi[f[(f[y>>2]|0)+4>>2]&2047](y);if((b[r>>0]|0)<0)O5b(f[o>>2]|0);switch(L&7){case 6:{E=0;B=48;break a;break}case 0:break;default:{B=47;break a}}M=f[c>>2]|0;N=f[h>>2]|0;if(M>>>0>=N>>>0)break;if((b[M>>0]|0)!=18)break;f[c>>2]=M+1}f[m>>2]=(f[m>>2]|0)+1;if((M|0)!=(N|0))continue a;if(f[t>>2]|0){B=43;break a}if((f[v>>2]|0)==(f[w>>2]|0)){B=43;break a}else continue a}while(0);if((B|0)==44){B=0;if(!D){E=1;B=48;break}else F=D}if((F&7|0)==4){E=1;B=48;break}if(!(Lpb(c,F)|0)){E=0;B=48;break}}if((B|0)==43){f[i>>2]=0;b[c+24>>0]=1;E=1;u=d;return E|0}else if((B|0)==47){E=1;u=d;return E|0}else if((B|0)==48){u=d;return E|0}return 0}function oGa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;c=u;u=u+32|0;d=c;e=f[a+52>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(!i)j=0;else{if(h){h=f[e+4>>2]|0;if(h>>>0<128){k=1;l=h}else{k=iob(h)|0;l=h}}else{k=1;l=g&255}j=l+1+k|0}k=a+8|0;tKb(k);l=a+44|0;g=f[l>>2]|0;h=g+12|0;if(!(b[g+8>>0]|0))m=f[h>>2]|0;else m=(f[h>>2]|0)+20|0;h=f[m>>2]|0;tKb(k);m=f[l>>2]|0;g=h+j|0;if(!(b[m+8>>0]|0)){j=f[m+12>>2]|0;h=f[j+12>>2]|0;e=f[j+4>>2]|0;a:do if(e>>>0>h>>>0){i=f[j+16>>2]|0;n=h;while(1){o=f[i+(n<<2)>>2]|0;if(o|0)break;p=n+1|0;if(p>>>0<e>>>0)n=p;else{q=0;r=p;s=0;break a}}if((o|0)==(f[i+((n^1)<<2)>>2]|0)){p=f[o>>2]|0;q=f[p+16>>2]|0;r=n;s=p;break}else{q=o;r=n;s=0;break}}else{q=0;r=h;s=0}while(0);h=d+4|0;f[h>>2]=q;f[d+8>>2]=j;f[d+12>>2]=r;f[d+16>>2]=s;s=d+20|0;f[s>>2]=0;f[d>>2]=2;r=d+20|0;t=d+4|0;v=s;w=r;x=r;y=h;z=d}else{h=f[(f[m+12>>2]|0)+12>>2]|0;f[d>>2]=1;m=d+4|0;f[m>>2]=0;r=d+20|0;f[r>>2]=h;t=m;v=d+20|0;w=r;x=r;y=d+4|0;z=d}d=a+40|0;r=g;g=0;b:while(1){tKb(k);m=(b[(f[l>>2]|0)+8>>0]|0)==0?2:1;h=f[z>>2]|0;c:do if((h|0)==(m|0))switch(m&3){case 0:{break b;break}case 1:{if(!(f[v>>2]|0))break b;else break c;break}default:if(!(f[t>>2]|0))break b;else break c}while(0);if(!g){A=0;B=h}else{m=(di[f[(f[g>>2]|0)+20>>2]&1023](g)|0)==0;A=m?g:0;B=f[z>>2]|0}m=f[((B|0)==1?(f[w>>2]|0)+20|0:(f[t>>2]|0)+12|0)>>2]|0;n=f[d>>2]|0;if(!n){i=L5b(32)|0;f[i+4>>2]=0;f[i+16>>2]=0;C=i}else{i=znb(n,18512,32)|0;f[i+4>>2]=0;f[i+16>>2]=n;C=i}f[C+8>>2]=497760;f[C+12>>2]=0;f[C>>2]=107432;f[C+24>>2]=m;f[C+28>>2]=m+16;f[C+20>>2]=3;if((A|0)!=(C|0))if(!A)D=C;else{bi[f[(f[A>>2]|0)+4>>2]&2047](A);D=C}else D=A;m=D+20|0;i=f[m>>2]|0;if(!(i&1)){E=i;F=0}else{i=di[f[(f[D>>2]|0)+72>>2]&1023](D)|0;n=b[i+11>>0]|0;if(n<<24>>24<0){s=f[i+4>>2]|0;if(s>>>0<128){G=1;H=s}else{G=iob(s)|0;H=s}}else{G=1;H=n&255}E=f[m>>2]|0;F=H+1+G|0}if(!(E&2))I=0;else{m=zGa(di[f[(f[D>>2]|0)+76>>2]&1023](D)|0)|0;if(m>>>0<128)J=1;else J=iob(m)|0;I=m+1+J|0}m=I+F|0;if(m>>>0<128)K=1;else K=iob(m)|0;n=m+r+K|0;if((f[z>>2]|0)==1){f[x>>2]=f[f[w>>2]>>2];r=n;g=D;continue}else{uxa(y)|0;r=n;g=D;continue}}if(!g){L=a+56|0;f[L>>2]=r;u=c;return r|0}if(di[f[(f[g>>2]|0)+20>>2]&1023](g)|0){L=a+56|0;f[L>>2]=r;u=c;return r|0}bi[f[(f[g>>2]|0)+4>>2]&2047](g);L=a+56|0;f[L>>2]=r;u=c;return r|0}function pGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+32|0;e=d;g=a+52|0;h=f[g>>2]|0;i=b[h+11>>0]|0;j=i<<24>>24<0;if(j)k=f[h+4>>2]|0;else k=i&255;if(k|0){if(j){l=f[h>>2]|0;m=f[h+4>>2]|0}else{l=h;m=i&255}gqb(l,m,1,385799)|0;$pb(1,f[g>>2]|0,c)}g=a+8|0;tKb(g);m=a+44|0;l=f[m>>2]|0;i=l+12|0;if(!(b[l+8>>0]|0))n=f[i>>2]|0;else n=(f[i>>2]|0)+20|0;if(!(f[n>>2]|0)){u=d;return}if(b[(b[c+18>>0]|0?c+19|0:1122455)>>0]|0){tKb(g);n=f[m>>2]|0;i=n+12|0;if(!(b[n+8>>0]|0))o=f[i>>2]|0;else o=(f[i>>2]|0)+20|0;if((f[o>>2]|0)>>>0>1){tKb(g);o=f[m>>2]|0;i=o+12|0;if(!(b[o+8>>0]|0))p=f[i>>2]|0;else p=(f[i>>2]|0)+20|0;i=f[p>>2]|0;p=N5b(i>>>0>1073741823?-1:i<<2)|0;tKb(g);i=f[m>>2]|0;if(!(b[i+8>>0]|0)){o=f[i+12>>2]|0;n=f[o+12>>2]|0;l=f[o+4>>2]|0;a:do if(l>>>0>n>>>0){h=f[o+16>>2]|0;j=n;while(1){q=f[h+(j<<2)>>2]|0;if(q|0)break;k=j+1|0;if(k>>>0<l>>>0)j=k;else{r=0;s=k;t=0;break a}}if((q|0)==(f[h+((j^1)<<2)>>2]|0)){k=f[q>>2]|0;r=f[k+16>>2]|0;s=j;t=k;break}else{r=q;s=j;t=0;break}}else{r=0;s=n;t=0}while(0);n=e+4|0;f[n>>2]=r;f[e+8>>2]=o;f[e+12>>2]=s;f[e+16>>2]=t;t=e+20|0;f[t>>2]=0;f[e>>2]=2;s=e+20|0;v=e;w=e+4|0;x=t;y=s;z=s;A=n}else{n=f[(f[i+12>>2]|0)+12>>2]|0;f[e>>2]=1;i=e+4|0;f[i>>2]=0;s=e+20|0;f[s>>2]=n;v=e;w=i;x=e+20|0;y=s;z=s;A=e+4|0}s=0;b:while(1){tKb(g);i=(b[(f[m>>2]|0)+8>>0]|0)==0?2:1;n=f[v>>2]|0;c:do if((n|0)==(i|0))switch(i&3){case 0:{break b;break}case 1:{if(!(f[x>>2]|0))break b;else break c;break}default:if(!(f[w>>2]|0))break b;else break c}while(0);i=(n|0)==1;j=f[y>>2]|0;f[p+(s<<2)>>2]=f[(i?j+20|0:(f[w>>2]|0)+12|0)>>2];if(i)f[z>>2]=f[j>>2];else uxa(A)|0;s=s+1|0}VDa(p,p+(s<<2)|0,e);if(s|0){A=a+40|0;z=0;w=0;do{y=p+(z<<2)|0;x=f[y>>2]|0;v=f[A>>2]|0;if(!v){j=L5b(32)|0;f[j+4>>2]=0;f[j+16>>2]=0;B=j}else{j=znb(v,18512,32)|0;f[j+4>>2]=0;f[j+16>>2]=v;B=j}f[B+8>>2]=497760;f[B+12>>2]=0;f[B>>2]=107432;f[B+24>>2]=x;f[B+28>>2]=x+16;f[B+20>>2]=3;if((w|0)!=(B|0))if(!w)C=B;else{bi[f[(f[w>>2]|0)+4>>2]&2047](w);C=B}else C=w;eqb(2,C,c);x=(di[f[(f[C>>2]|0)+20>>2]&1023](C)|0)==0;w=x?C:0;x=f[y>>2]|0;y=b[x+11>>0]|0;if(y<<24>>24<0){D=f[x>>2]|0;E=f[x+4>>2]|0}else{D=x;E=y&255}gqb(D,E,1,385828)|0;z=z+1|0}while(z>>>0<s>>>0);if(w|0)bi[f[(f[w>>2]|0)+4>>2]&2047](w)}P5b(p);u=d;return}}tKb(g);p=f[m>>2]|0;if(!(b[p+8>>0]|0)){w=f[p+12>>2]|0;s=f[w+12>>2]|0;z=f[w+4>>2]|0;d:do if(z>>>0>s>>>0){E=f[w+16>>2]|0;D=s;while(1){F=f[E+(D<<2)>>2]|0;if(F|0)break;C=D+1|0;if(C>>>0<z>>>0)D=C;else{G=0;H=C;I=0;break d}}if((F|0)==(f[E+((D^1)<<2)>>2]|0)){n=f[F>>2]|0;G=f[n+16>>2]|0;H=D;I=n;break}else{G=F;H=D;I=0;break}}else{G=0;H=s;I=0}while(0);s=e+4|0;f[s>>2]=G;f[e+8>>2]=w;f[e+12>>2]=H;f[e+16>>2]=I;I=e+20|0;f[I>>2]=0;f[e>>2]=2;H=e+20|0;J=e+4|0;K=I;L=H;M=H;N=s;O=e}else{s=f[(f[p+12>>2]|0)+12>>2]|0;f[e>>2]=1;p=e+4|0;f[p>>2]=0;H=e+20|0;f[H>>2]=s;J=p;K=e+20|0;L=H;M=H;N=e+4|0;O=e}e=a+40|0;a=0;e:while(1){tKb(g);H=(b[(f[m>>2]|0)+8>>0]|0)==0?2:1;p=f[O>>2]|0;f:do if((p|0)==(H|0))switch(H&3){case 0:{break e;break}case 1:{if(!(f[K>>2]|0))break e;else break f;break}default:if(!(f[J>>2]|0))break e;else break f}while(0);H=f[((p|0)==1?(f[L>>2]|0)+20|0:(f[J>>2]|0)+12|0)>>2]|0;D=f[e>>2]|0;if(!D){E=L5b(32)|0;f[E+4>>2]=0;f[E+16>>2]=0;P=E}else{E=znb(D,18512,32)|0;f[E+4>>2]=0;f[E+16>>2]=D;P=E}f[P+8>>2]=497760;f[P+12>>2]=0;f[P>>2]=107432;f[P+24>>2]=H;f[P+28>>2]=H+16;f[P+20>>2]=3;if((a|0)!=(P|0))if(!a)Q=P;else{bi[f[(f[a>>2]|0)+4>>2]&2047](a);Q=P}else Q=a;eqb(2,Q,c);H=(di[f[(f[Q>>2]|0)+20>>2]&1023](Q)|0)==0;E=H?Q:0;H=f[((f[O>>2]|0)==1?(f[L>>2]|0)+20|0:(f[J>>2]|0)+12|0)>>2]|0;D=b[H+11>>0]|0;if(D<<24>>24<0){R=f[H>>2]|0;S=f[H+4>>2]|0}else{R=H;S=D&255}gqb(R,S,1,385828)|0;if((f[O>>2]|0)==1){f[M>>2]=f[f[L>>2]>>2];a=E;continue}else{uxa(N)|0;a=E;continue}}if(!a){u=d;return}bi[f[(f[a>>2]|0)+4>>2]&2047](a);u=d;return}function qGa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function rGa(a){a=a|0;return f[a+56>>2]|0}function sGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;e=u;u=u+32|0;g=e;h=a+52|0;i=f[h>>2]|0;j=b[i+11>>0]|0;k=j<<24>>24<0;if(k)l=f[i+4>>2]|0;else l=j&255;if(!l)m=d;else{if(k){n=f[i>>2]|0;o=f[i+4>>2]|0}else{n=i;o=j&255}gqb(n,o,1,385799)|0;o=f[h>>2]|0;b[d>>0]=10;m=kob(o,d+1|0)|0}d=a+8|0;tKb(d);o=a+44|0;h=f[o>>2]|0;n=h+12|0;if(!(b[h+8>>0]|0))p=f[n>>2]|0;else p=(f[n>>2]|0)+20|0;if(!(f[p>>2]|0)){q=m;u=e;return q|0}if(c){tKb(d);p=f[o>>2]|0;n=p+12|0;if(!(b[p+8>>0]|0))r=f[n>>2]|0;else r=(f[n>>2]|0)+20|0;if((f[r>>2]|0)>>>0>1){tKb(d);r=f[o>>2]|0;n=r+12|0;if(!(b[r+8>>0]|0))s=f[n>>2]|0;else s=(f[n>>2]|0)+20|0;n=f[s>>2]|0;s=N5b(n>>>0>1073741823?-1:n<<2)|0;tKb(d);n=f[o>>2]|0;if(!(b[n+8>>0]|0)){r=f[n+12>>2]|0;p=f[r+12>>2]|0;h=f[r+4>>2]|0;a:do if(h>>>0>p>>>0){j=f[r+16>>2]|0;i=p;while(1){t=f[j+(i<<2)>>2]|0;if(t|0)break;k=i+1|0;if(k>>>0<h>>>0)i=k;else{v=0;w=k;x=0;break a}}if((t|0)==(f[j+((i^1)<<2)>>2]|0)){k=f[t>>2]|0;v=f[k+16>>2]|0;w=i;x=k;break}else{v=t;w=i;x=0;break}}else{v=0;w=p;x=0}while(0);p=g+4|0;f[p>>2]=v;f[g+8>>2]=r;f[g+12>>2]=w;f[g+16>>2]=x;x=g+20|0;f[x>>2]=0;f[g>>2]=2;w=g+20|0;y=g+4|0;z=x;A=w;B=w;C=p;D=g}else{p=f[(f[n+12>>2]|0)+12>>2]|0;f[g>>2]=1;n=g+4|0;f[n>>2]=0;w=g+20|0;f[w>>2]=p;y=n;z=g+20|0;A=w;B=w;C=g+4|0;D=g}w=0;b:while(1){tKb(d);n=(b[(f[o>>2]|0)+8>>0]|0)==0?2:1;p=f[D>>2]|0;c:do if((p|0)==(n|0))switch(n&3){case 0:{break b;break}case 1:{if(!(f[z>>2]|0))break b;else break c;break}default:if(!(f[y>>2]|0))break b;else break c}while(0);n=(p|0)==1;i=f[A>>2]|0;f[s+(w<<2)>>2]=f[(n?i+20|0:(f[y>>2]|0)+12|0)>>2];if(n)f[B>>2]=f[i>>2];else uxa(C)|0;w=w+1|0}VDa(s,s+(w<<2)|0,g);if(w){C=a+40|0;B=0;y=m;A=0;do{z=s+(B<<2)|0;D=f[z>>2]|0;i=f[C>>2]|0;if(!i){n=L5b(32)|0;f[n+4>>2]=0;f[n+16>>2]=0;E=n}else{n=znb(i,18512,32)|0;f[n+4>>2]=0;f[n+16>>2]=i;E=n}f[E+8>>2]=497760;f[E+12>>2]=0;f[E>>2]=107432;f[E+24>>2]=D;f[E+28>>2]=D+16;f[E+20>>2]=3;if((A|0)!=(E|0))if(!A)F=E;else{bi[f[(f[A>>2]|0)+4>>2]&2047](A);F=E}else F=A;b[y>>0]=18;D=y+1|0;n=F+20|0;i=f[n>>2]|0;if(!(i&1)){G=i;H=0}else{i=di[f[(f[F>>2]|0)+72>>2]&1023](F)|0;j=b[i+11>>0]|0;if(j<<24>>24<0){x=f[i+4>>2]|0;if(x>>>0<128){I=1;J=x}else{I=iob(x)|0;J=x}}else{I=1;J=j&255}G=f[n>>2]|0;H=J+1+I|0}if(!(G&2))K=0;else{n=di[f[(f[F>>2]|0)+76>>2]&1023](F)|0;j=di[f[(f[n>>2]|0)+64>>2]&1023](n)|0;if(j>>>0<128)L=1;else L=iob(j)|0;K=j+1+L|0}j=K+H|0;if(j>>>0>127){n=j;x=D;while(1){b[x>>0]=n|128;i=n>>>7;r=x+1|0;if(n>>>0>16383){n=i;x=r}else{M=r;N=i;break}}}else{M=D;N=j}b[M>>0]=N;y=li[f[(f[F>>2]|0)+68>>2]&511](F,1,M+1|0)|0;x=(di[f[(f[F>>2]|0)+20>>2]&1023](F)|0)==0;A=x?F:0;x=f[z>>2]|0;n=b[x+11>>0]|0;if(n<<24>>24<0){O=f[x>>2]|0;P=f[x+4>>2]|0}else{O=x;P=n&255}gqb(O,P,1,385828)|0;B=B+1|0}while(B>>>0<w>>>0);if(!A)Q=y;else{bi[f[(f[A>>2]|0)+4>>2]&2047](A);Q=y}}else Q=m;P5b(s);q=Q;u=e;return q|0}}tKb(d);Q=f[o>>2]|0;if(!(b[Q+8>>0]|0)){s=f[Q+12>>2]|0;y=f[s+12>>2]|0;A=f[s+4>>2]|0;d:do if(A>>>0>y>>>0){w=f[s+16>>2]|0;B=y;while(1){R=f[w+(B<<2)>>2]|0;if(R|0)break;P=B+1|0;if(P>>>0<A>>>0)B=P;else{S=0;T=P;U=0;break d}}if((R|0)==(f[w+((B^1)<<2)>>2]|0)){z=f[R>>2]|0;S=f[z+16>>2]|0;T=B;U=z;break}else{S=R;T=B;U=0;break}}else{S=0;T=y;U=0}while(0);y=g+4|0;f[y>>2]=S;f[g+8>>2]=s;f[g+12>>2]=T;f[g+16>>2]=U;U=g+20|0;f[U>>2]=0;f[g>>2]=2;T=g+20|0;V=g;W=g+4|0;X=U;Y=T;Z=T;_=y}else{y=f[(f[Q+12>>2]|0)+12>>2]|0;f[g>>2]=1;Q=g+4|0;f[Q>>2]=0;T=g+20|0;f[T>>2]=y;V=g;W=Q;X=g+20|0;Y=T;Z=T;_=g+4|0}g=a+40|0;a=m;m=0;e:while(1){tKb(d);T=(b[(f[o>>2]|0)+8>>0]|0)==0?2:1;Q=f[V>>2]|0;f:do if((Q|0)==(T|0))switch(T&3){case 0:{break e;break}case 1:{if(!(f[X>>2]|0))break e;else break f;break}default:if(!(f[W>>2]|0))break e;else break f}while(0);T=f[((Q|0)==1?(f[Y>>2]|0)+20|0:(f[W>>2]|0)+12|0)>>2]|0;B=f[g>>2]|0;if(!B){w=L5b(32)|0;f[w+4>>2]=0;f[w+16>>2]=0;$=w}else{w=znb(B,18512,32)|0;f[w+4>>2]=0;f[w+16>>2]=B;$=w}f[$+8>>2]=497760;f[$+12>>2]=0;f[$>>2]=107432;f[$+24>>2]=T;f[$+28>>2]=T+16;f[$+20>>2]=3;if((m|0)!=($|0))if(!m)aa=$;else{bi[f[(f[m>>2]|0)+4>>2]&2047](m);aa=$}else aa=m;b[a>>0]=18;T=a+1|0;w=aa+20|0;B=f[w>>2]|0;if(!(B&1)){ba=B;ca=0}else{B=di[f[(f[aa>>2]|0)+72>>2]&1023](aa)|0;y=b[B+11>>0]|0;if(y<<24>>24<0){U=f[B+4>>2]|0;if(U>>>0<128){da=1;ea=U}else{da=iob(U)|0;ea=U}}else{da=1;ea=y&255}ba=f[w>>2]|0;ca=ea+1+da|0}if(!(ba&2))fa=0;else{w=di[f[(f[aa>>2]|0)+76>>2]&1023](aa)|0;y=di[f[(f[w>>2]|0)+64>>2]&1023](w)|0;if(y>>>0<128)ga=1;else ga=iob(y)|0;fa=y+1+ga|0}y=fa+ca|0;if(y>>>0>127){w=y;U=T;while(1){b[U>>0]=w|128;B=w>>>7;s=U+1|0;if(w>>>0>16383){w=B;U=s}else{ha=s;ia=B;break}}}else{ha=T;ia=y}b[ha>>0]=ia;U=li[f[(f[aa>>2]|0)+68>>2]&511](aa,c,ha+1|0)|0;w=(di[f[(f[aa>>2]|0)+20>>2]&1023](aa)|0)==0;Q=w?aa:0;w=f[((f[V>>2]|0)==1?(f[Y>>2]|0)+20|0:(f[W>>2]|0)+12|0)>>2]|0;B=b[w+11>>0]|0;if(B<<24>>24<0){ja=f[w>>2]|0;ka=f[w+4>>2]|0}else{ja=w;ka=B&255}gqb(ja,ka,1,385828)|0;if((f[V>>2]|0)==1){f[Z>>2]=f[f[Y>>2]>>2];a=U;m=Q;continue}else{uxa(_)|0;a=U;m=Q;continue}}if(!m){q=a;u=e;return q|0}bi[f[(f[m>>2]|0)+4>>2]&2047](m);q=a;u=e;return q|0}function tGa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function uGa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))xGa(2838);c=T6b(b,23288,18584,0)|0;if(!c){cOb(b,a);return}else{yGa(a,c);return}}function vGa(a,b){a=a|0;b=b|0;f[a+56>>2]=b;return}function wGa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[212979]|0)!=2){f[d>>2]=135812;f[d+4>>2]=21;b[d+8>>0]=0;Gpb(851916,d);hpb(d)}f[a>>2]=f[212996];f[a+4>>2]=f[212997];u=c;return}function xGa(a){a=a|0;Enb(384916,a)}function yGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=c+36|0;e=a+8|0;tKb(e);tKb(d+-28|0);DCa(a+36|0,d);sKb(e);e=f[c+52>>2]|0;c=b[e+11>>0]|0;if(c<<24>>24<0)g=f[e+4>>2]|0;else g=c&255;if(!g)return;g=a+52|0;c=f[a+4>>2]|0;a=c&-2;if(!(c&1))h=a;else h=f[a+4>>2]|0;a=f[g>>2]|0;if((a|0)==497760){dya(g,h,e);return}else{_5b(a,e)|0;return}}function zGa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;do switch(f[a+20>>2]|0){case 2:{c=f[a+8>>2]|0;d=b[c+11>>0]|0;if(d<<24>>24<0){e=f[c+4>>2]|0;if(e>>>0<128){g=1;h=e}else{g=iob(e)|0;h=e}}else{g=1;h=d&255}i=h+1+g|0;break}case 3:{d=a+8|0;i=(job(f[d>>2]|0,f[d+4>>2]|0)|0)+1|0;break}case 4:{i=5;break}case 5:{i=2;break}case 6:{d=f[a+8>>2]|0;if((d|0)>=0)if(d>>>0<128)i=2;else i=(iob(d)|0)+1|0;else i=11;break}case 7:{d=RAa(f[a+8>>2]|0)|0;if(d>>>0<128)j=1;else j=iob(d)|0;i=d+1+j|0;break}case 8:{d=dFa(f[a+8>>2]|0)|0;if(d>>>0<128)k=1;else k=iob(d)|0;i=d+1+k|0;break}case 1:{d=RFa(f[a+8>>2]|0)|0;if(d>>>0<128)l=1;else l=iob(d)|0;i=d+1+l|0;break}case 10:{d=oGa(f[a+8>>2]|0)|0;if(d>>>0<128)m=1;else m=iob(d)|0;i=d+1+m|0;break}case 9:{d=f[a+8>>2]|0;e=b[d+11>>0]|0;if(e<<24>>24<0){c=f[d+4>>2]|0;if(c>>>0<128){n=1;o=c}else{n=iob(c)|0;o=c}}else{n=1;o=e&255}i=o+1+n|0;break}default:i=0}while(0);f[a+16>>2]=i;return i|0}function AGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=108052;f[a+4>>2]=c;d=a+8|0;f[d>>2]=140148;f[a+12>>2]=c;f[a+16>>2]=0;e=a+20|0;f[e>>2]=0;g=a+24|0;f[g>>2]=0;h=a+28|0;Bpb(h);f[a+32>>2]=0;gEa(c,h);f[d>>2]=107196;h=a+36|0;f[h>>2]=107148;f[a+40>>2]=c;if(!c){i=L5b(16)|0;f[i>>2]=0;f[i+4>>2]=0;b[i+8>>0]=1;Fxa(i);j=i}else{i=znb(c,18528,16)|0;f[i>>2]=c;f[i+4>>2]=0;b[i+8>>0]=1;Fxa(i);j=i}f[a+44>>2]=j;j=(di[f[(f[h>>2]|0)+36>>2]&1023](h)|0)+4|0;f[j>>2]=0;f[d>>2]=107280;f[h>>2]=107384;f[a+48>>2]=0;f[g>>2]=25;f[e>>2]=851992;f[a+52>>2]=497760;f[a+56>>2]=0;return}function BGa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=107944;b=a+4|0;c=f[b>>2]|0;d=c&-2;if(!(c&1))e=d;else e=f[d+4>>2]|0;if((e|0)==0?(f[a+20>>2]|0)!=0:0){TGa(a);g=f[b>>2]|0}else g=c;if(!(g&1)){f[b>>2]=0;return}c=g&-2;g=c;if((c|0)==0|(f[g+4>>2]|0)!=0){f[b>>2]=0;return}if(f[g>>2]|0)GPb(g);O5b(c);f[b>>2]=0;return}function CGa(a){a=a|0;BGa(a);O5b(a);return}function DGa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function EGa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(24)|0;bHa(a);c=a;return c|0}else{a=znb(b,18600,24)|0;f[a>>2]=107944;f[a+4>>2]=b;f[a+20>>2]=0;f[a+16>>2]=0;c=a;return c|0}return 0}function FGa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function GGa(a){a=a|0;return f[a+4>>2]|0}function HGa(a){a=a|0;TGa(a);return}function IGa(a){a=a|0;return 1}function JGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+20|0;k=a+8|0;l=a+4|0;m=e+4|0;n=c+32|0;o=c+12|0;p=c+28|0;q=a+8|0;r=e+8|0;s=e+8|0;t=e+4|0;v=e+4|0;w=e+4|0;a:while(1){b:while(1){x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){y=b[x>>0]|0;z=y&255;if(y<<24>>24>0){f[i>>2]=z;f[c>>2]=x+1;A=z;B=7}else{C=z;B=6}}else{C=0;B=6}if((B|0)==6){B=0;z=_nb(c,C)|0;f[i>>2]=z;if((z+-1|0)>>>0<127){A=z;B=7}else{D=z;B=143}}c:do if((B|0)==7){B=0;do switch(A>>>3&536870911|0){case 1:{switch(A|0){case 0:{E=1;B=146;break a;break}case 10:{B=9;break b;break}default:{F=A;break c}}break}case 2:{switch(A|0){case 0:{E=1;B=146;break a;break}case 18:{B=27;break b;break}default:{F=A;break c}}break}case 3:{switch(A|0){case 0:{E=1;B=146;break a;break}case 24:{B=36;break b;break}default:{F=A;break c}}break}case 4:{switch(A|0){case 0:{E=1;B=146;break a;break}case 37:{B=42;break b;break}default:{F=A;break c}}break}case 5:{switch(A|0){case 0:{E=1;B=146;break a;break}case 40:{B=49;break b;break}default:{F=A;break c}}break}case 6:{switch(A|0){case 0:{E=1;B=146;break a;break}case 48:{B=55;break b;break}default:{F=A;break c}}break}case 7:{switch(A|0){case 0:{E=1;B=146;break a;break}case 58:{B=63;break b;break}default:{F=A;break c}}break}case 8:{switch(A|0){case 0:{E=1;B=146;break a;break}case 66:{B=81;break b;break}default:{F=A;break c}}break}case 9:{switch(A|0){case 0:{E=1;B=146;break a;break}case 74:break;default:{F=A;break c}}if((f[j>>2]|0)!=9){TGa(a);f[j>>2]=9;f[k>>2]=497760}z=f[l>>2]|0;x=z&-2;if(!(z&1))G=x;else G=f[x+4>>2]|0;x=f[k>>2]|0;if((x|0)==497760){dya(k,G,497760);H=f[k>>2]|0}else H=x;if(!(fqb(c,H)|0)){E=0;B=146;break a}x=(f[j>>2]|0)==9;if(x){z=f[k>>2]|0;I=z;K=z}else{I=497760;K=497760}if((b[K+11>>0]|0)<0)L=f[I>>2]|0;else L=I;if(x){x=f[k>>2]|0;M=x;N=x}else{M=497760;N=497760}x=b[N+11>>0]|0;if(x<<24>>24<0)O=f[M+4>>2]|0;else O=x&255;if(!(gqb(L,O,0,385895)|0)){E=0;B=146;break a}P=f[c>>2]|0;if(P>>>0>=(f[g>>2]|0)>>>0)continue b;if((b[P>>0]|0)==82){B=120;break b}else continue b;break}case 10:{switch(A|0){case 0:{E=1;B=146;break a;break}case 82:{B=122;break b;break}default:{F=A;break c}}break}default:{D=A;B=143;break c}}while(0)}while(0);if((B|0)==143){B=0;if(!D){E=1;B=146;break a}else F=D}if((F&7|0)==4){E=1;B=146;break a}if(!(Lpb(c,F)|0)){E=0;B=146;break a}}if((B|0)==9){B=0;if((f[j>>2]|0)==1)Q=f[k>>2]|0;else{TGa(a);f[j>>2]=1;x=f[l>>2]|0;z=x&-2;if(!(x&1))R=z;else R=f[z+4>>2]|0;if(!R){z=L5b(124)|0;UGa(z);S=z}else{z=znb(R,18568,124)|0;VGa(z,R);S=z}f[k>>2]=S;Q=S}z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(x=b[z>>0]|0,x<<24>>24>-1):0){f[c>>2]=z+1;T=x&255}else{x=Znb(c)|0;if((x|0)>-1)T=x;else{E=0;B=146;break}}Inb(e,c,T);if((f[m>>2]|0)<0){B=24;break}if(!(QFa(Q,c)|0)){B=24;break}if(!(Onb(c,f[e>>2]|0)|0)){E=0;B=146;break}}else if((B|0)==27){B=0;if((f[j>>2]|0)!=2){TGa(a);f[j>>2]=2;f[k>>2]=497760}x=f[l>>2]|0;z=x&-2;if(!(x&1))U=z;else U=f[z+4>>2]|0;z=f[k>>2]|0;if((z|0)==497760){dya(k,U,497760);V=f[k>>2]|0}else V=z;if(!(fqb(c,V)|0)){E=0;B=146;break}}else if((B|0)==36){B=0;TGa(a);z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0?(x=b[z>>0]|0,x<<24>>24>-1):0){f[c>>2]=z+1;W=x&255;X=0}else{Lnb(e,c);x=e;if(!(b[r>>0]|0)){E=0;B=146;break}else{W=f[x>>2]|0;X=f[x+4>>2]|0}}x=q;f[x>>2]=W;f[x+4>>2]=X;f[j>>2]=3}else if((B|0)==42){B=0;TGa(a);x=f[c>>2]|0;if(((f[g>>2]|0)-x|0)>3){z=x;y=h[z>>0]|h[z+1>>0]<<8|h[z+2>>0]<<16|h[z+3>>0]<<24;f[e>>2]=y;f[c>>2]=x+4;Y=y}else{if(!(Xnb(c,e)|0)){B=46;break}Y=f[e>>2]|0}f[k>>2]=Y;f[j>>2]=4}else if((B|0)==49){B=0;TGa(a);y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(x=b[y>>0]|0,x<<24>>24>-1):0){f[c>>2]=y+1;Z=x<<24>>24!=0}else{Lnb(e,c);x=e;if(!(b[s>>0]|0)){E=0;B=146;break}else Z=(f[x>>2]|0)!=0|(f[x+4>>2]|0)!=0}b[k>>0]=Z&1;f[j>>2]=5}else if((B|0)==55){B=0;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){y=b[x>>0]|0;z=y&255;if(y<<24>>24>-1){f[c>>2]=x+1;_=z}else{$=z;B=58}}else{$=0;B=58}if((B|0)==58){B=0;z=Knb(c,$)|0;x=J;if((x|0)>-1|(x|0)==-1&z>>>0>4294967295)_=z;else{E=0;B=146;break}}if((f[j>>2]|0)!=6){TGa(a);f[j>>2]=6}f[k>>2]=_}else if((B|0)==63){B=0;if((f[j>>2]|0)==7)aa=f[k>>2]|0;else{TGa(a);f[j>>2]=7;z=f[l>>2]|0;x=z&-2;if(!(z&1))ba=x;else ba=f[x+4>>2]|0;if(!ba){x=L5b(32)|0;dBa(x);ca=x}else{x=znb(ba,18328,32)|0;jBa(x,ba);ca=x}f[k>>2]=ca;aa=ca}x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(z=b[x>>0]|0,z<<24>>24>-1):0){f[c>>2]=x+1;da=z&255}else{z=Znb(c)|0;if((z|0)>-1)da=z;else{E=0;B=146;break}}Inb(e,c,da);if((f[t>>2]|0)<0){B=78;break}if(!(QAa(aa,c)|0)){B=78;break}if(!(Onb(c,f[e>>2]|0)|0)){E=0;B=146;break}}else if((B|0)==81){B=0;if((f[j>>2]|0)==8)ea=f[k>>2]|0;else{TGa(a);f[j>>2]=8;z=f[l>>2]|0;x=z&-2;if(!(z&1))fa=x;else fa=f[x+4>>2]|0;if(!fa){x=L5b(172)|0;AFa(x);ga=x}else{x=znb(fa,18552,172)|0;BFa(x,fa);ga=x}f[k>>2]=ga;ea=ga}x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(z=b[x>>0]|0,z<<24>>24>-1):0){f[c>>2]=x+1;ha=z&255}else{z=Znb(c)|0;if((z|0)>-1)ha=z;else{E=0;B=146;break}}Inb(e,c,ha);if((f[v>>2]|0)<0){B=96;break}if(!(cFa(ea,c)|0)){B=96;break}if(!(Onb(c,f[e>>2]|0)|0)){E=0;B=146;break}}else if((B|0)==120){B=0;f[c>>2]=P+1;B=122}if((B|0)==122){B=0;if((f[j>>2]|0)==10)ia=f[k>>2]|0;else{TGa(a);f[j>>2]=10;z=f[l>>2]|0;x=z&-2;if(!(z&1))ja=x;else ja=f[x+4>>2]|0;if(!ja){x=L5b(60)|0;dGa(x);ka=x}else{x=znb(ja,18584,60)|0;AGa(x,ja);ka=x}f[k>>2]=ka;ia=ka}x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(z=b[x>>0]|0,z<<24>>24>-1):0){f[c>>2]=x+1;la=z&255}else{z=Znb(c)|0;if((z|0)>-1)la=z;else{E=0;B=146;break}}Inb(e,c,la);if((f[w>>2]|0)<0){B=137;break}if(!(nGa(ia,c)|0)){B=137;break}if(!(Onb(c,f[e>>2]|0)|0)){E=0;B=146;break}}if((f[c>>2]|0)!=(f[g>>2]|0))continue;if(f[n>>2]|0){B=142;break}if((f[o>>2]|0)==(f[p>>2]|0)){B=142;break}}if((B|0)==24){E=0;u=d;return E|0}else if((B|0)==46){E=0;u=d;return E|0}else if((B|0)==78){E=0;u=d;return E|0}else if((B|0)==96){E=0;u=d;return E|0}else if((B|0)==137){E=0;u=d;return E|0}else if((B|0)==142){f[i>>2]=0;b[c+24>>0]=1;E=1;u=d;return E|0}else if((B|0)==146){u=d;return E|0}return 0}function KGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;d=a+20|0;e=f[d>>2]|0;if((e|0)==1){eqb(1,f[a+8>>2]|0,c);g=f[d>>2]|0}else g=e;if((g|0)==2){bqb(2,f[a+8>>2]|0,c);h=f[d>>2]|0}else h=g;if((h|0)==3){g=a+8|0;Npb(3,f[g>>2]|0,f[g+4>>2]|0,c);i=f[d>>2]|0}else i=h;if((i|0)==4){Wpb(4,+n[a+8>>2],c);j=f[d>>2]|0}else j=i;if((j|0)==5){Ypb(5,(b[a+8>>0]|0)!=0,c);k=f[d>>2]|0}else k=j;if((k|0)==6){Zpb(6,f[a+8>>2]|0,c);l=f[d>>2]|0}else l=k;if((l|0)==7){eqb(7,f[a+8>>2]|0,c);m=f[d>>2]|0}else m=l;if((m|0)==8){eqb(8,f[a+8>>2]|0,c);o=f[d>>2]|0}else o=m;if((o|0)==9){m=a+8|0;l=f[m>>2]|0;k=b[l+11>>0]|0;if(k<<24>>24<0){p=f[l>>2]|0;q=f[l+4>>2]|0}else{p=l;q=k&255}gqb(p,q,1,385895)|0;if((f[d>>2]|0)==9)r=f[m>>2]|0;else r=497760;$pb(9,r,c);s=f[d>>2]|0}else s=o;if((s|0)!=10)return;eqb(10,f[a+8>>2]|0,c);return}function LGa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function MGa(a){a=a|0;return f[a+16>>2]|0}function NGa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;c=a+20|0;e=f[c>>2]|0;if((e|0)==1){g=f[a+8>>2]|0;b[d>>0]=10;h=d+1|0;i=f[g+120>>2]|0;if(i>>>0>127){j=i;k=h;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=h;o=i}b[n>>0]=o;o=li[f[(f[g>>2]|0)+68>>2]&511](g,0,n+1|0)|0;p=o;q=f[c>>2]|0}else{p=d;q=e}if((q|0)==2){e=f[a+8>>2]|0;b[p>>0]=18;d=kob(e,p+1|0)|0;r=d;s=f[c>>2]|0}else{r=p;s=q}if((s|0)==3){q=a+8|0;p=f[q>>2]|0;d=f[q+4>>2]|0;b[r>>0]=24;q=hob(p,d,r+1|0)|0;t=q;u=f[c>>2]|0}else{t=r;u=s}if((u|0)==4){s=f[a+8>>2]|0;b[t>>0]=37;r=t+1|0;b[r>>0]=s;b[r+1>>0]=s>>8;b[r+2>>0]=s>>16;b[r+3>>0]=s>>24;v=t+5|0;w=f[c>>2]|0}else{v=t;w=u}if((w|0)==5){u=b[a+8>>0]|0;b[v>>0]=40;b[v+1>>0]=u;x=v+2|0;y=f[c>>2]|0}else{x=v;y=w}do if((y|0)==6){w=f[a+8>>2]|0;b[x>>0]=48;v=x+1|0;if((w|0)<0){z=hob(w,((w|0)<0)<<31>>31,v)|0;break}if(w>>>0>127){u=w;t=v;while(1){b[t>>0]=u|128;s=u>>>7;r=t+1|0;if(u>>>0>16383){u=s;t=r}else{A=r;B=s;break}}}else{A=v;B=w}b[A>>0]=B;z=A+1|0}else z=x;while(0);x=f[c>>2]|0;if((x|0)==7){A=f[a+8>>2]|0;b[z>>0]=58;B=z+1|0;y=f[A+28>>2]|0;if(y>>>0>127){t=y;u=B;while(1){b[u>>0]=t|128;s=t>>>7;r=u+1|0;if(t>>>0>16383){t=s;u=r}else{C=r;D=s;break}}}else{C=B;D=y}b[C>>0]=D;D=li[f[(f[A>>2]|0)+68>>2]&511](A,0,C+1|0)|0;E=D;F=f[c>>2]|0}else{E=z;F=x}if((F|0)==8){x=f[a+8>>2]|0;b[E>>0]=66;z=E+1|0;D=f[x+168>>2]|0;if(D>>>0>127){C=D;A=z;while(1){b[A>>0]=C|128;y=C>>>7;B=A+1|0;if(C>>>0>16383){C=y;A=B}else{G=B;H=y;break}}}else{G=z;H=D}b[G>>0]=H;H=li[f[(f[x>>2]|0)+68>>2]&511](x,0,G+1|0)|0;I=H;J=f[c>>2]|0}else{I=E;J=F}if((J|0)==9){F=a+8|0;E=f[F>>2]|0;H=b[E+11>>0]|0;if(H<<24>>24<0){K=f[E>>2]|0;L=f[E+4>>2]|0}else{K=E;L=H&255}gqb(K,L,1,385895)|0;if((f[c>>2]|0)==9)M=f[F>>2]|0;else M=497760;b[I>>0]=74;F=kob(M,I+1|0)|0;N=F;O=f[c>>2]|0}else{N=I;O=J}if((O|0)!=10){P=N;return P|0}O=f[a+8>>2]|0;b[N>>0]=82;a=N+1|0;N=f[O+56>>2]|0;if(N>>>0>127){J=N;I=a;while(1){b[I>>0]=J|128;c=J>>>7;F=I+1|0;if(J>>>0>16383){J=c;I=F}else{Q=F;R=c;break}}}else{Q=a;R=N}b[Q>>0]=R;P=li[f[(f[O>>2]|0)+68>>2]&511](O,0,Q+1|0)|0;return P|0}function OGa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function PGa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))xGa(1417);c=T6b(b,23288,18600,0)|0;if(!c){cOb(b,a);return}else{SGa(a,c);return}}function QGa(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function RGa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[212979]|0)!=2){f[d>>2]=135812;f[d+4>>2]=21;b[d+8>>0]=0;Gpb(851916,d);hpb(d)}f[a>>2]=f[212982];f[a+4>>2]=f[212995];u=c;return}function SGa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=u;u=u+16|0;e=d;g=c+20|0;do switch(f[g>>2]|0){case 2:{h=f[c+8>>2]|0;i=a+20|0;if((f[i>>2]|0)==2)j=a+8|0;else{TGa(a);f[i>>2]=2;i=a+8|0;f[i>>2]=497760;j=i}i=f[a+4>>2]|0;k=i&-2;if(!(i&1))l=k;else l=f[k+4>>2]|0;k=f[j>>2]|0;if((k|0)==497760){dya(j,l,h);u=d;return}else{_5b(k,h)|0;u=d;return}break}case 3:{h=c+8|0;k=f[h>>2]|0;i=f[h+4>>2]|0;h=a+20|0;if((f[h>>2]|0)!=3){TGa(a);f[h>>2]=3}h=a+8|0;f[h>>2]=k;f[h+4>>2]=i;u=d;return}case 4:{i=f[c+8>>2]|0;h=a+20|0;if((f[h>>2]|0)!=4){TGa(a);f[h>>2]=4}f[a+8>>2]=i;u=d;return}case 5:{i=b[c+8>>0]|0;h=a+20|0;if((f[h>>2]|0)!=5){TGa(a);f[h>>2]=5}b[a+8>>0]=i;u=d;return}case 6:{i=f[c+8>>2]|0;h=a+20|0;if((f[h>>2]|0)!=6){TGa(a);f[h>>2]=6}f[a+8>>2]=i;u=d;return}case 7:{i=a+20|0;if((f[i>>2]|0)!=7){TGa(a);f[i>>2]=7;i=f[a+4>>2]|0;h=i&-2;if(!(i&1))m=h;else m=f[h+4>>2]|0;if(!m){h=L5b(32)|0;dBa(h);n=h}else{h=znb(m,18328,32)|0;jBa(h,m);n=h}f[a+8>>2]=n;if((f[g>>2]|0)==7){o=n;p=32}else{q=n;r=kBa()|0}}else{o=f[a+8>>2]|0;p=32}if((p|0)==32){q=o;r=f[c+8>>2]|0}lBa(q,r);u=d;return}case 8:{h=a+20|0;if((f[h>>2]|0)!=8){TGa(a);f[h>>2]=8;h=f[a+4>>2]|0;i=h&-2;if(!(h&1))s=i;else s=f[i+4>>2]|0;if(!s){i=L5b(172)|0;AFa(i);t=i}else{i=znb(s,18552,172)|0;BFa(i,s);t=i}f[a+8>>2]=t;if((f[g>>2]|0)==8){v=t;p=44}else{w=t;x=GFa()|0}}else{v=f[a+8>>2]|0;p=44}if((p|0)==44){w=v;x=f[c+8>>2]|0}HFa(w,x);u=d;return}case 1:{i=a+20|0;if((f[i>>2]|0)!=1){TGa(a);f[i>>2]=1;i=f[a+4>>2]|0;h=i&-2;if(!(i&1))y=h;else y=f[h+4>>2]|0;if(!y){h=L5b(124)|0;UGa(h);z=h}else{h=znb(y,18568,124)|0;VGa(h,y);z=h}f[a+8>>2]=z;if((f[g>>2]|0)!=1)if((f[212977]|0)==2){A=492272;B=z}else{f[e>>2]=135812;f[e+4>>2]=23;b[e+8>>0]=0;Gpb(851908,e);hpb(e);A=492272;B=z}else{C=z;p=56}}else{C=f[a+8>>2]|0;p=56}if((p|0)==56){A=f[c+8>>2]|0;B=C}if((A|0)==(B|0))xGa(781);WGa(B,A);u=d;return}case 10:{h=a+20|0;if((f[h>>2]|0)!=10){TGa(a);f[h>>2]=10;h=f[a+4>>2]|0;i=h&-2;if(!(h&1))D=i;else D=f[i+4>>2]|0;if(!D){i=L5b(60)|0;dGa(i);E=i}else{i=znb(D,18584,60)|0;AGa(i,D);E=i}f[a+8>>2]=E;if((f[g>>2]|0)!=10)if((f[212977]|0)==2){F=492408;G=E}else{f[e>>2]=135812;f[e+4>>2]=23;b[e+8>>0]=0;Gpb(851908,e);hpb(e);F=492408;G=E}else{H=E;p=71}}else{H=f[a+8>>2]|0;p=71}if((p|0)==71){F=f[c+8>>2]|0;G=H}if((F|0)==(G|0))xGa(2856);i=F+36|0;h=G+8|0;tKb(h);tKb(i+-28|0);DCa(G+36|0,i);sKb(h);h=f[F+52>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0)I=f[h+4>>2]|0;else I=i&255;if(!I){u=d;return}i=G+52|0;k=f[G+4>>2]|0;J=k&-2;if(!(k&1))K=J;else K=f[J+4>>2]|0;J=f[i>>2]|0;if((J|0)==497760){dya(i,K,h);u=d;return}else{_5b(J,h)|0;u=d;return}break}case 9:{h=f[c+8>>2]|0;J=a+20|0;if((f[J>>2]|0)==9)L=a+8|0;else{TGa(a);f[J>>2]=9;J=a+8|0;f[J>>2]=497760;L=J}J=f[a+4>>2]|0;i=J&-2;if(!(J&1))M=i;else M=f[i+4>>2]|0;i=f[L>>2]|0;if((i|0)==497760){dya(L,M,h);u=d;return}else{_5b(i,h)|0;u=d;return}break}default:{u=d;return}}while(0)}function TGa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+20|0;switch(f[c>>2]|0){case 2:{d=a+8|0;e=f[a+4>>2]|0;g=e&-2;if(!(e&1))h=g;else h=f[g+4>>2]|0;if((h|0)==0?(h=f[d>>2]|0,!((h|0)==497760|(h|0)==0)):0){if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);O5b(h)}f[d>>2]=497760;f[c>>2]=0;return}case 9:{d=a+8|0;h=f[a+4>>2]|0;g=h&-2;if(!(h&1))i=g;else i=f[g+4>>2]|0;if((i|0)==0?(i=f[d>>2]|0,!((i|0)==497760|(i|0)==0)):0){if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);O5b(i)}f[d>>2]=497760;f[c>>2]=0;return}case 10:{d=f[a+4>>2]|0;i=d&-2;if(!(d&1))j=i;else j=f[i+4>>2]|0;if(j|0){f[c>>2]=0;return}j=f[a+8>>2]|0;if(!j){f[c>>2]=0;return}bi[f[(f[j>>2]|0)+4>>2]&2047](j);f[c>>2]=0;return}case 1:{j=f[a+4>>2]|0;i=j&-2;if(!(j&1))k=i;else k=f[i+4>>2]|0;if(k|0){f[c>>2]=0;return}k=f[a+8>>2]|0;if(!k){f[c>>2]=0;return}bi[f[(f[k>>2]|0)+4>>2]&2047](k);f[c>>2]=0;return}case 8:{k=f[a+4>>2]|0;i=k&-2;if(!(k&1))l=i;else l=f[i+4>>2]|0;if(l|0){f[c>>2]=0;return}l=f[a+8>>2]|0;if(!l){f[c>>2]=0;return}bi[f[(f[l>>2]|0)+4>>2]&2047](l);f[c>>2]=0;return}case 7:{l=f[a+4>>2]|0;i=l&-2;if(!(l&1))m=i;else m=f[i+4>>2]|0;if(m|0){f[c>>2]=0;return}m=f[a+8>>2]|0;if(!m){f[c>>2]=0;return}bi[f[(f[m>>2]|0)+4>>2]&2047](m);f[c>>2]=0;return}default:{f[c>>2]=0;return}}}function UGa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=107800;e=a+4|0;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;f[a+64>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;f[a+80>>2]=0;g=a+88|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;if((a|0)==492272){h=a+120|0;f[h>>2]=0;u=c;return}if((f[212977]|0)==2){h=a+120|0;f[h>>2]=0;u=c;return}f[d>>2]=135812;f[d+4>>2]=23;b[d+8>>0]=0;Gpb(851908,d);hpb(d);h=a+120|0;f[h>>2]=0;u=c;return}function VGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=107800;f[a+4>>2]=b;f[a+8>>2]=b;c=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;if(!b){f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;f[a+56>>2]=0;f[a+60>>2]=0;f[a+64>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;f[a+80>>2]=0;d=a+88|0;f[d>>2]=b;e=a+92|0;f[e>>2]=0;g=a+96|0;f[g>>2]=0;h=a+100|0;f[h>>2]=0;i=a+104|0;f[i>>2]=b;j=a+108|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;return}else{c=znb(b,25528,8)|0;f[a+32>>2]=c;f[c>>2]=b;f[a+40>>2]=0;f[a+44>>2]=0;c=a+48|0;f[c>>2]=0;k=znb(b,25528,4)|0;f[c>>2]=k;f[k>>2]=b;f[a+56>>2]=0;f[a+60>>2]=0;k=a+64|0;f[k>>2]=0;c=znb(b,25528,4)|0;f[k>>2]=c;f[c>>2]=b;f[a+72>>2]=0;f[a+76>>2]=0;c=a+80|0;f[c>>2]=0;k=znb(b,25528,4)|0;f[c>>2]=k;f[k>>2]=b;d=a+88|0;f[d>>2]=b;e=a+92|0;f[e>>2]=0;g=a+96|0;f[g>>2]=0;h=a+100|0;f[h>>2]=0;i=a+104|0;f[i>>2]=b;j=a+108|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;return}}function WGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;UDa(a+8|0,b+8|0);c=a+24|0;d=b+24|0;e=f[d>>2]|0;if(e|0){uFa(c,(f[c>>2]|0)+e|0);Vac((f[a+32>>2]|0)+8+(f[c>>2]<<3)|0,(f[b+32>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[c>>2]=(f[c>>2]|0)+(f[d>>2]|0)}d=a+40|0;c=b+40|0;e=f[c>>2]|0;if(e|0){qza(d,(f[d>>2]|0)+e|0);Vac((f[a+48>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+48>>2]|0)+4|0,f[c>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[c>>2]|0)}c=a+56|0;d=b+56|0;e=f[d>>2]|0;if(e|0){vFa(c,(f[c>>2]|0)+e|0);Vac((f[c>>2]|0)+((f[a+64>>2]|0)+4)|0,(f[b+64>>2]|0)+4|0,f[d>>2]|0)|0;f[c>>2]=(f[c>>2]|0)+(f[d>>2]|0)}d=a+72|0;c=b+72|0;e=f[c>>2]|0;if(!e){g=a+88|0;h=b+88|0;XGa(g,h);i=a+104|0;j=b+104|0;YGa(i,j);return}nza(d,(f[d>>2]|0)+e|0);Vac((f[a+80>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+80>>2]|0)+4|0,f[c>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[c>>2]|0);g=a+88|0;h=b+88|0;XGa(g,h);i=a+104|0;j=b+104|0;YGa(i,j);return}function XGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{$Ga(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=aHa(h,i)|0;$Ga(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function YGa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{ZGa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=_Ga(h,i)|0;ZGa(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function ZGa(a,b){a=a|0;b=b|0;HFa(b,a);return}function _Ga(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(172)|0;AFa(a);c=a;return c|0}else{a=znb(b,18552,172)|0;BFa(a,b);c=a;return c|0}return 0}function $Ga(a,b){a=a|0;b=b|0;lBa(b,a);return}function aHa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(32)|0;dBa(a);c=a;return c|0}else{a=znb(b,18328,32)|0;jBa(a,b);c=a;return c|0}return 0}function bHa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=107944;f[a+4>>2]=0;if((a|0)!=492240?(f[212977]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=23;b[d+8>>0]=0;Gpb(851908,d);hpb(d)}f[a+20>>2]=0;f[a+16>>2]=0;u=c;return}function cHa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212978]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=22;b[c+8>>0]=0;Gpb(851912,c);hpb(c);u=a;return}function dHa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212978]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=22;b[c+8>>0]=0;Gpb(851912,c);hpb(c);u=a;return}function eHa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212977]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=23;b[c+8>>0]=0;Gpb(851908,c);hpb(c);u=a;return}function fHa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212977]|0)==2){u=a;return 492272}f[c>>2]=135812;f[c+4>>2]=23;b[c+8>>0]=0;Gpb(851908,c);hpb(c);u=a;return 492272}function gHa(a,b){a=a|0;b=b|0;f[a>>2]=107944;f[a+4>>2]=b;f[a+20>>2]=0;f[a+16>>2]=0;return}function hHa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212977]|0)==2){u=a;return 492240}f[c>>2]=135812;f[c+4>>2]=23;b[c+8>>0]=0;Gpb(851908,c);hpb(c);u=a;return 492240}function iHa(a,b){a=a|0;b=b|0;if((b|0)==(a|0))xGa(1435);else{SGa(a,b);return}}function jHa(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);SGa(a,b);return}function kHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+32|0;d=c;if((b|0)==(a|0)){u=c;return}e=a+4|0;g=f[e>>2]|0;h=g&-2;if(!(g&1))i=h;else i=f[h+4>>2]|0;h=b+4|0;g=f[h>>2]|0;j=g&-2;if(!(g&1))k=j;else k=f[j+4>>2]|0;if((i|0)!=(k|0)){bHa(d);SGa(d,a);bi[f[(f[a>>2]|0)+28>>2]&2047](a);SGa(a,b);if((d|0)!=(b|0)){bi[f[(f[b>>2]|0)+28>>2]&2047](b);SGa(b,d)}BGa(d);u=c;return}d=a+8|0;k=d;i=f[k>>2]|0;j=f[k+4>>2]|0;k=b+8|0;g=k;l=f[g+4>>2]|0;m=d;f[m>>2]=f[g>>2];f[m+4>>2]=l;l=k;f[l>>2]=i;f[l+4>>2]=j;j=a+20|0;l=b+20|0;i=f[j>>2]|0;f[j>>2]=f[l>>2];f[l>>2]=i;i=f[e>>2]|0;if(!(i&1)){if(f[h>>2]&1|0){n=hBa(e)|0;o=13}}else{n=i&-2;o=13}if((o|0)==13){o=f[h>>2]|0;if(!(o&1))p=hBa(h)|0;else p=o&-2;o=f[n>>2]|0;f[n>>2]=f[p>>2];f[p>>2]=o}o=a+16|0;a=b+16|0;b=f[o>>2]|0;f[o>>2]=f[a>>2];f[a>>2]=b;u=c;return}function lHa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=108160;b=a+36|0;c=f[b>>2]|0;if(c|0?(f[a+24>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h|0?(f[a+8>>2]|0)==0:0){c=f[h>>2]|0;if((c|0)>0){d=0;do{e=f[h+4+(d<<2)>>2]|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(c|0));i=f[b>>2]|0}else i=h;O5b(i)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(i);f[b>>2]=0;return}function mHa(a){a=a|0;lHa(a);O5b(a);return}function nHa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function oHa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){a=L5b(44)|0;_Ia(a);c=a;return c|0}else{a=b;d=znb(b,18616,44)|0;f[d>>2]=108160;f[d+4>>2]=a;f[d+8>>2]=a;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=a;a=d+28|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;c=d;return c|0}return 0}function pHa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function qHa(a){a=a|0;return f[a+4>>2]|0}function rHa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+20>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}b=a+28|0;c=f[b>>2]|0;if((c|0)<=0)return;e=f[a+36>>2]|0;a=0;do{d=f[e+4+(a<<2)>>2]|0;a=a+1|0;bi[f[(f[d>>2]|0)+28>>2]&2047](d)}while((a|0)!=(c|0));f[b>>2]=0;return}function sHa(a){a=a|0;return 1}function tHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=c+4|0;e=c+20|0;g=c+44|0;h=a+8|0;i=a+20|0;j=a+16|0;k=a+12|0;l=a+24|0;m=a+36|0;n=a+32|0;o=a+28|0;a=c+32|0;p=c+12|0;q=c+28|0;a:while(1){r=f[c>>2]|0;if(r>>>0<(f[d>>2]|0)>>>0){s=b[r>>0]|0;t=s&255;if(s<<24>>24>0){f[e>>2]=t;f[c>>2]=r+1;u=t;v=6}else{w=t;v=5}}else{w=0;v=5}if((v|0)==5){v=0;t=_nb(c,w)|0;f[e>>2]=t;if((t+-1|0)>>>0<127){u=t;v=6}else{x=t;v=41}}b:do if((v|0)==6){v=0;c:do switch(u>>>3&536870911|0){case 1:{switch(u|0){case 0:{y=1;v=44;break a;break}case 10:break;default:{z=u;break b}}t=f[g>>2]|0;f[g>>2]=t+-1;if((t|0)<=0){y=0;v=44;break a}while(1){t=f[i>>2]|0;do if(t){r=f[k>>2]|0;s=f[t>>2]|0;if((r|0)>=(s|0))if((s|0)==(f[j>>2]|0)){A=s;v=14;break}else{B=s;C=t;v=15;break}else{f[k>>2]=r+1;D=f[t+4+(r<<2)>>2]|0;break}}else{A=f[j>>2]|0;v=14}while(0);if((v|0)==14){v=0;cpb(h,A+1|0);t=f[i>>2]|0;B=f[t>>2]|0;C=t;v=15}if((v|0)==15){v=0;f[C>>2]=B+1;t=ZIa(0,f[h>>2]|0)|0;r=f[i>>2]|0;s=f[k>>2]|0;f[k>>2]=s+1;f[r+4+(s<<2)>>2]=t;D=t}t=Jnb(c)|0;if(!(FIa(D,c)|0)){y=0;v=44;break a}if(!(Pnb(c,t)|0)){y=0;v=44;break a}E=f[c>>2]|0;if(E>>>0>=(f[d>>2]|0)>>>0)break;if((b[E>>0]|0)!=10){v=21;break}f[c>>2]=E+1}if((v|0)==21?(v=0,(b[E>>0]|0)==18):0){F=E;v=25;break c}f[g>>2]=(f[g>>2]|0)+1;continue a;break}case 2:{switch(u|0){case 0:{y=1;v=44;break a;break}case 18:break;default:{z=u;break b}}t=f[g>>2]|0;f[g>>2]=t+-1;if((t|0)<=0){y=0;v=44;break a}break}default:{x=u;v=41;break b}}while(0);while(1){if((v|0)==25){v=0;f[c>>2]=F+1}t=f[m>>2]|0;do if(t){s=f[o>>2]|0;r=f[t>>2]|0;if((s|0)>=(r|0))if((r|0)==(f[n>>2]|0)){G=r;v=31;break}else{H=r;I=t;v=32;break}else{f[o>>2]=s+1;J=f[t+4+(s<<2)>>2]|0;break}}else{G=f[n>>2]|0;v=31}while(0);if((v|0)==31){v=0;cpb(l,G+1|0);t=f[m>>2]|0;H=f[t>>2]|0;I=t;v=32}if((v|0)==32){v=0;f[I>>2]=H+1;t=XIa(0,f[l>>2]|0)|0;s=f[m>>2]|0;r=f[o>>2]|0;f[o>>2]=r+1;f[s+4+(r<<2)>>2]=t;J=t}t=Jnb(c)|0;if(!(RHa(J,c)|0)){y=0;v=44;break a}if(!(Pnb(c,t)|0)){y=0;v=44;break a}F=f[c>>2]|0;K=f[d>>2]|0;if(F>>>0>=K>>>0)break;if((b[F>>0]|0)!=18)break;else v=25}f[g>>2]=(f[g>>2]|0)+1;if((F|0)!=(K|0))continue a;if(f[a>>2]|0){v=40;break a}if((f[p>>2]|0)==(f[q>>2]|0)){v=40;break a}else continue a}while(0);if((v|0)==41){v=0;if(!x){y=1;v=44;break}else z=x}if((z&7|0)==4){y=1;v=44;break}if(!(Lpb(c,z)|0)){y=0;v=44;break}}if((v|0)==40){f[e>>2]=0;b[c+24>>0]=1;y=1;return y|0}else if((v|0)==44)return y|0;return 0}function uHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=f[a+12>>2]|0;if(!c)d=0;else{e=a+20|0;g=0;h=c;while(1){i=f[(f[e>>2]|0)+4+(g<<2)>>2]|0;if((i|0)!=492544?(j=f[i+24>>2]|0,(j|0)!=0):0){k=qKa(j)|0;if(k>>>0<128)l=1;else l=iob(k)|0;m=k+1+l|0}else m=0;k=f[i+12>>2]|0;j=k+m|0;if(!k)n=j;else{o=i+20|0;p=0;q=j;while(1){j=mIa(f[(f[o>>2]|0)+4+(p<<2)>>2]|0)|0;if(j>>>0<128)r=1;else r=iob(j)|0;s=j+q+r|0;p=p+1|0;if((p|0)==(k|0)){n=s;break}else q=s}}f[i+28>>2]=n;if(n>>>0<128)t=1;else t=iob(n)|0;q=n+h+t|0;g=g+1|0;if((g|0)==(c|0)){d=q;break}else h=q}}h=f[a+28>>2]|0;c=h+d|0;if(!h){u=c;v=a+40|0;f[v>>2]=u;return u|0}d=a+36|0;g=0;t=c;while(1){c=f[(f[d>>2]|0)+4+(g<<2)>>2]|0;n=f[c+8>>2]|0;r=b[n+11>>0]|0;m=r<<24>>24<0;if(m)w=f[n+4>>2]|0;else w=r&255;if(!w)x=0;else{if(m){m=f[n+4>>2]|0;if(m>>>0<128){y=1;z=m}else{y=iob(m)|0;z=m}}else{y=1;z=r&255}x=z+1+y|0}r=f[c+12>>2]|0;m=b[r+11>>0]|0;n=m<<24>>24<0;if(n)A=f[r+4>>2]|0;else A=m&255;if(!A)B=x;else{if(n){n=f[r+4>>2]|0;if(n>>>0<128){C=1;D=n}else{C=iob(n)|0;D=n}}else{C=1;D=m&255}B=x+1+D+C|0}f[c+16>>2]=B;if(B>>>0<128)E=1;else E=iob(B)|0;c=B+t+E|0;g=g+1|0;if((g|0)==(h|0)){u=c;break}else t=c}v=a+40|0;f[v>>2]=u;return u|0}function vHa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+12>>2]|0;if(c|0){d=a+20|0;e=0;do{eqb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+28>>2]|0;if(!c)return;e=a+36|0;a=0;do{eqb(2,f[(f[e>>2]|0)+4+(a<<2)>>2]|0,b);a=a+1|0}while((a|0)!=(c|0));return}function wHa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function xHa(a){a=a|0;return f[a+40>>2]|0}function yHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=f[a+12>>2]|0;if(!c)e=d;else{g=a+20|0;h=0;i=d;while(1){d=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=10;j=i+1|0;k=f[d+28>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=j;q=k}b[p>>0]=q;m=li[f[(f[d>>2]|0)+68>>2]&511](d,0,p+1|0)|0;h=h+1|0;if((h|0)==(c|0)){e=m;break}else i=m}}i=f[a+28>>2]|0;if(!i){r=e;return r|0}c=a+36|0;a=0;h=e;while(1){e=f[(f[c>>2]|0)+4+(a<<2)>>2]|0;b[h>>0]=18;p=h+1|0;q=f[e+16>>2]|0;if(q>>>0>127){g=q;m=p;while(1){b[m>>0]=g|128;l=g>>>7;n=m+1|0;if(g>>>0>16383){g=l;m=n}else{s=n;t=l;break}}}else{s=p;t=q}b[s>>0]=t;m=li[f[(f[e>>2]|0)+68>>2]&511](e,0,s+1|0)|0;a=a+1|0;if((a|0)==(i|0)){r=m;break}else h=m}return r|0}function zHa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function AHa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))$Ha(453);c=T6b(b,23288,18616,0)|0;if(!c){cOb(b,a);return}else{UIa(a+8|0,c+8|0);VIa(a+24|0,c+24|0);return}}function BHa(a,b){a=a|0;b=b|0;f[a+40>>2]=b;return}function CHa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213001]|0)!=2){f[d>>2]=135812;f[d+4>>2]=26;b[d+8>>0]=0;Gpb(852004,d);hpb(d)}f[a>>2]=f[213002];f[a+4>>2]=f[213003];u=c;return}function DHa(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+48|0;c=a+24|0;d=a;e=a+36|0;if((f[213e3]|0)!=2){f[c>>2]=135812;f[c+4>>2]=27;b[c+8>>0]=0;Gpb(852e3,c);hpb(c)}g=drb()|0;h=L5b(16)|0;f[c>>2]=h;f[c+8>>2]=-2147483632;f[c+4>>2]=14;i=h;j=385989;k=i+14|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+14>>0]=0;h=hrb(g,c)|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if(!h){zpb(d,3,386004,47);xpb(e,vpb(d,459532)|0);Apb(d)}d=h+40|0;h=f[d>>2]|0;f[213002]=h;e=pIb(h,492488,108260,-1,-1,-1,44,4,-1)|0;f[213003]=e;e=(f[d>>2]|0)+88|0;f[213004]=e;h=pIb(e,492544,108268,-1,-1,-1,32,4,-1)|0;f[213005]=h;h=f[(f[213004]|0)+44>>2]|0;f[213006]=h;e=pIb(h,492584,108276,-1,-1,-1,108,4,-1)|0;f[213007]=e;f[213008]=f[(f[213006]|0)+44>>2];e=(f[d>>2]|0)+176|0;f[213009]=e;d=pIb(e,492704,108296,-1,-1,-1,20,4,-1)|0;f[213010]=d;u=a;return}function EHa(){var a=0,c=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,386004);if((f[212999]|0)!=2){f[c>>2]=135812;f[c+4>>2]=28;b[c+8>>0]=0;Gpb(851996,c);hpb(c)}grb(386087,566);SNb(385989,1498);dHa();vLa();spb(29);u=a;return}function FHa(){var a=0,c=0,d=0,e=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,386004);eHa();wLa();f[123122]=108160;d=492492;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[123132]=0;b[492536]=1;f[123136]=108312;f[123137]=0;f[123138]=0;f[123139]=0;f[123140]=0;f[123141]=0;f[123142]=0;f[123143]=0;b[492576]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}IHa(492584);b[492696]=1;if((f[213345]|0)==2){f[123176]=108420;f[123177]=0;f[123178]=497760;f[123179]=497760;f[123180]=0;b[492728]=1;f[123142]=492736;u=a;return}f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c);f[123176]=108420;f[123177]=0;f[123178]=497760;f[123179]=497760;f[123180]=0;b[492728]=1;f[123142]=492736;u=a;return}function GHa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[213001]|0)!=2){f[c>>2]=135812;f[c+4>>2]=26;b[c+8>>0]=0;Gpb(852004,c);hpb(c)}WNb(f[213002]|0,492488);WNb(f[213004]|0,492544);WNb(f[213006]|0,492584);c=f[213008]|0;WNb(c,JBa(c)|0);WNb(f[213009]|0,492704);u=a;return}function HHa(){var a=0;if(b[492536]|0){b[492536]=0;bi[f[f[123122]>>2]&2047](492488)}a=f[213003]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[492576]|0){b[492576]=0;bi[f[f[123136]>>2]&2047](492544)}a=f[213005]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[492696]|0){b[492696]=0;bi[f[f[123146]>>2]&2047](492584)}a=f[213007]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[492728]|0){b[492728]=0;bi[f[f[123176]>>2]&2047](492704)}a=f[213010]|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function IHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=108528;e=a+56|0;g=a+4|0;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));vCa(e);if((a|0)!=492584?(f[212999]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=28;b[d+8>>0]=0;Gpb(851996,d);hpb(d)}f[a+72>>2]=30;f[a+68>>2]=852032;f[a+100>>2]=497760;f[a+104>>2]=0;u=c;return}function JHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=108420;c=a+4|0;d=f[c>>2]|0;e=d&-2;if(!(d&1))g=e;else g=f[e+4>>2]|0;if(!g){g=a+8|0;e=f[g>>2]|0;if(!((e|0)==497760|(e|0)==0)){if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);O5b(e)}f[g>>2]=497760;g=a+12|0;a=f[g>>2]|0;if(!((a|0)==497760|(a|0)==0)){if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a)}f[g>>2]=497760;h=f[c>>2]|0}else h=d;if(!(h&1)){f[c>>2]=0;return}d=h&-2;h=d;if((d|0)==0|(f[h+4>>2]|0)!=0){f[c>>2]=0;return}if(f[h>>2]|0)GPb(h);O5b(d);f[c>>2]=0;return}function KHa(a){a=a|0;JHa(a);O5b(a);return}function LHa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function MHa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(20)|0;bIa(a);c=a;return c|0}else{a=znb(b,18632,20)|0;f[a>>2]=108420;f[a+4>>2]=b;f[a+8>>2]=497760;f[a+12>>2]=497760;f[a+16>>2]=0;c=a;return c|0}return 0}function NHa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function OHa(a){a=a|0;return f[a+4>>2]|0}function PHa(a){a=a|0;var c=0,d=0;c=f[a+8>>2]|0;do if((c|0)!=497760){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+12>>2]|0;if((c|0)==497760)return;a=c+11|0;if((b[a>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;return}else{b[c>>0]=0;b[a>>0]=0;return}}function QHa(a){a=a|0;return 1}function RHa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+4|0;i=a+8|0;j=a+12|0;k=a+12|0;a=c+32|0;l=c+12|0;m=c+28|0;a:while(1){n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){o=b[n>>0]|0;p=o&255;if(o<<24>>24>0){f[e>>2]=p;f[c>>2]=n+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=_nb(c,s)|0;f[e>>2]=p;if((p+-1|0)>>>0<127){q=p;r=6}else{t=p;r=36}}b:do if((r|0)==6){r=0;switch(q>>>3&536870911|0){case 1:{switch(q|0){case 0:{u=1;r=39;break a;break}case 10:break;default:{v=q;break b}}p=f[h>>2]|0;n=p&-2;if(!(p&1))w=n;else w=f[n+4>>2]|0;n=f[g>>2]|0;if((n|0)==497760){dya(g,w,497760);x=f[g>>2]|0}else x=n;if(!(fqb(c,x)|0)){u=0;r=39;break a}n=f[i>>2]|0;p=b[n+11>>0]|0;if(p<<24>>24<0){y=f[n>>2]|0;z=f[n+4>>2]|0}else{y=n;z=p&255}if(!(gqb(y,z,0,386654)|0)){u=0;r=39;break a}p=f[c>>2]|0;if(p>>>0>=(f[d>>2]|0)>>>0)continue a;if((b[p>>0]|0)!=18)continue a;f[c>>2]=p+1;break}case 2:{switch(q|0){case 0:{u=1;r=39;break a;break}case 18:break;default:{v=q;break b}}break}default:{t=q;r=36;break b}}p=f[h>>2]|0;n=p&-2;if(!(p&1))A=n;else A=f[n+4>>2]|0;n=f[j>>2]|0;if((n|0)==497760){dya(j,A,497760);B=f[j>>2]|0}else B=n;if(!(fqb(c,B)|0)){u=0;r=39;break a}n=f[k>>2]|0;p=b[n+11>>0]|0;if(p<<24>>24<0){C=f[n>>2]|0;D=f[n+4>>2]|0}else{C=n;D=p&255}if(!(gqb(C,D,0,386691)|0)){u=0;r=39;break a}if((f[c>>2]|0)!=(f[d>>2]|0))continue a;if(f[a>>2]|0){r=35;break a}if((f[l>>2]|0)==(f[m>>2]|0)){r=35;break a}else continue a}while(0);if((r|0)==36){r=0;if(!t){u=1;r=39;break}else v=t}if((v&7|0)==4){u=1;r=39;break}if(!(Lpb(c,v)|0)){u=0;r=39;break}}if((r|0)==35){f[e>>2]=0;b[c+24>>0]=1;u=1;return u|0}else if((r|0)==39)return u|0;return 0}function SHa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a+8>>2]|0;d=b[c+11>>0]|0;e=d<<24>>24<0;if(e)g=f[c+4>>2]|0;else g=d&255;if(!g)h=0;else{if(e){e=f[c+4>>2]|0;if(e>>>0<128){i=1;j=e}else{i=iob(e)|0;j=e}}else{i=1;j=d&255}h=j+1+i|0}i=f[a+12>>2]|0;j=b[i+11>>0]|0;d=j<<24>>24<0;if(d)k=f[i+4>>2]|0;else k=j&255;if(!k){l=h;m=a+16|0;f[m>>2]=l;return l|0}if(d){d=f[i+4>>2]|0;if(d>>>0<128){n=1;o=d}else{n=iob(d)|0;o=d}}else{n=1;o=j&255}l=h+1+o+n|0;m=a+16|0;f[m>>2]=l;return l|0}function THa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+8|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}gqb(j,k,1,386654)|0;$pb(1,f[d>>2]|0,c)}d=a+12|0;a=f[d>>2]|0;k=b[a+11>>0]|0;j=k<<24>>24<0;if(j)l=f[a+4>>2]|0;else l=k&255;if(!l)return;if(j){m=f[a>>2]|0;n=f[a+4>>2]|0}else{m=a;n=k&255}gqb(m,n,1,386691)|0;$pb(2,f[d>>2]|0,c);return}function UHa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function VHa(a){a=a|0;return f[a+16>>2]|0}function WHa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;e=f[c>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(!i)j=d;else{if(h){k=f[e>>2]|0;l=f[e+4>>2]|0}else{k=e;l=g&255}gqb(k,l,1,386654)|0;l=f[c>>2]|0;b[d>>0]=10;j=kob(l,d+1|0)|0}d=a+12|0;a=f[d>>2]|0;l=b[a+11>>0]|0;c=l<<24>>24<0;if(c)m=f[a+4>>2]|0;else m=l&255;if(!m){n=j;return n|0}if(c){o=f[a>>2]|0;p=f[a+4>>2]|0}else{o=a;p=l&255}gqb(o,p,1,386691)|0;p=f[d>>2]|0;b[j>>0]=18;n=kob(p,j+1|0)|0;return n|0}function XHa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function YHa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))$Ha(2122);c=T6b(b,23288,18632,0)|0;if(!c){cOb(b,a);return}else{aIa(a,c);return}}function ZHa(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function _Ha(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213001]|0)!=2){f[d>>2]=135812;f[d+4>>2]=26;b[d+8>>0]=0;Gpb(852004,d);hpb(d)}f[a>>2]=f[213009];f[a+4>>2]=f[213010];u=c;return}function $Ha(a){a=a|0;Enb(386004,a)}function aIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=f[c+8>>2]|0;e=b[d+11>>0]|0;if(e<<24>>24<0)g=f[d+4>>2]|0;else g=e&255;do if(g|0){e=a+8|0;h=f[a+4>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==497760){dya(e,j,d);break}else{_5b(i,d)|0;break}}while(0);d=f[c+12>>2]|0;c=b[d+11>>0]|0;if(c<<24>>24<0)k=f[d+4>>2]|0;else k=c&255;if(!k)return;k=a+12|0;c=f[a+4>>2]|0;a=c&-2;if(!(c&1))l=a;else l=f[a+4>>2]|0;a=f[k>>2]|0;if((a|0)==497760){dya(k,l,d);return}else{_5b(a,d)|0;return}}function bIa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=108420;f[a+4>>2]=0;if((a|0)!=492704?(f[212999]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=28;b[d+8>>0]=0;Gpb(851996,d);hpb(d)}f[a+8>>2]=497760;f[a+12>>2]=497760;f[a+16>>2]=0;u=c;return}function cIa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213001]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=26;b[c+8>>0]=0;Gpb(852004,c);hpb(c);u=a;return}function dIa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;f[a>>2]=108528;c=a+4|0;d=f[c>>2]|0;e=d&-2;if(!(d&1))g=e;else g=f[e+4>>2]|0;if(!g){g=a+100|0;e=f[g>>2]|0;if(!((e|0)==497760|(e|0)==0)){if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);O5b(e)}f[g>>2]=497760}f[a+84>>2]=107148;g=f[a+92>>2]|0;if(g|0){txa(g);O5b(g)}QIb(a+56|0);g=a+52|0;e=f[g>>2]|0;if(e|0?(f[a+40>>2]|0)==0:0){d=f[e>>2]|0;if((d|0)>0){h=0;do{i=f[e+4+(h<<2)>>2]|0;if(i|0){if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);O5b(i)}h=h+1|0}while((h|0)!=(d|0));j=f[g>>2]|0}else j=e;O5b(j)}f[g>>2]=0;g=a+36|0;j=f[g>>2]|0;if(j|0?(f[a+24>>2]|0)==0:0){e=f[j>>2]|0;if((e|0)>0){d=0;do{h=f[j+4+(d<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);O5b(h)}d=d+1|0}while((d|0)!=(e|0));k=f[g>>2]|0}else k=j;O5b(k)}f[g>>2]=0;g=a+20|0;k=f[g>>2]|0;if(k|0?(f[a+8>>2]|0)==0:0){a=f[k>>2]|0;if((a|0)>0){j=0;do{e=f[k+4+(j<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);O5b(e)}j=j+1|0}while((j|0)!=(a|0));l=f[g>>2]|0}else l=k;O5b(l)}f[g>>2]=0;g=f[c>>2]|0;if(!(g&1)){f[c>>2]=0;return}l=g&-2;g=l;if((l|0)==0|(f[g+4>>2]|0)!=0){f[c>>2]=0;return}if(f[g>>2]|0)GPb(g);O5b(l);f[c>>2]=0;return}function eIa(a){a=a|0;dIa(a);O5b(a);return}function fIa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function gIa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(108)|0;IHa(a);c=a;return c|0}else{a=znb(b,18648,108)|0;wIa(a,b);c=a;return c|0}return 0}function hIa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function iIa(a){a=a|0;return f[a+4>>2]|0}function jIa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+100>>2]|0;do if((c|0)!=497760){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+20>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+28|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+36>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;h=i+11|0;if((b[h>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[h>>0]=0}}while((e|0)!=(d|0));f[c>>2]=0}c=a+44|0;d=f[c>>2]|0;if((d|0)<=0){j=a+56|0;tKb(j);k=a+92|0;l=f[k>>2]|0;yxa(l);sKb(j);return}e=f[a+52>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0;j=a+56|0;tKb(j);k=a+92|0;l=f[k>>2]|0;yxa(l);sKb(j);return}function kIa(a){a=a|0;return 1}function lIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;d=u;u=u+48|0;e=d+32|0;g=d;h=c+4|0;i=c+20|0;j=a+8|0;k=a+12|0;l=a+20|0;m=a+100|0;n=a+4|0;o=a+100|0;p=a+24|0;q=a+28|0;r=a+36|0;s=a+40|0;t=a+44|0;v=a+52|0;w=c+44|0;x=a+56|0;a=g+4|0;y=g+8|0;z=g+24|0;A=e+4|0;B=y+11|0;C=g+12|0;D=c+32|0;E=c+12|0;F=c+28|0;a:while(1){G=f[c>>2]|0;if(G>>>0<(f[h>>2]|0)>>>0){H=b[G>>0]|0;I=H&255;if(H<<24>>24>0){f[i>>2]=I;f[c>>2]=G+1;J=I;K=6}else{L=I;K=5}}else{L=0;K=5}if((K|0)==5){K=0;I=_nb(c,L)|0;f[i>>2]=I;if((I+-1|0)>>>0<127){J=I;K=6}else{M=I;K=75}}b:do if((K|0)==6){K=0;switch(J>>>3&536870911|0){case 1:{switch(J|0){case 0:{N=1;K=79;break a;break}case 10:break;default:{O=J;break b}}if(!(fqb(c,mza(j)|0)|0)){N=0;K=79;break a}while(1){I=f[(f[l>>2]|0)+4+((f[k>>2]|0)+-1<<2)>>2]|0;G=b[I+11>>0]|0;if(G<<24>>24<0){P=f[I>>2]|0;Q=f[I+4>>2]|0}else{P=I;Q=G&255}if(!(gqb(P,Q,0,386756)|0)){N=0;K=79;break a}R=f[c>>2]|0;if(R>>>0>=(f[h>>2]|0)>>>0)continue a;if((b[R>>0]|0)!=10)break;f[c>>2]=R+1;if(!(fqb(c,mza(j)|0)|0)){N=0;K=79;break a}}if((b[R>>0]|0)!=18)continue a;f[c>>2]=R+1;K=19;break}case 2:{switch(J|0){case 0:{N=1;K=79;break a;break}case 18:{K=19;break}default:{O=J;break b}}break}case 3:{switch(J|0){case 0:{N=1;K=79;break a;break}case 26:{K=33;break}default:{O=J;break b}}break}case 4:{switch(J|0){case 0:{N=1;K=79;break a;break}case 34:{K=43;break}default:{O=J;break b}}break}case 5:{switch(J|0){case 0:{N=1;K=79;break a;break}case 42:{K=53;break}default:{O=J;break b}}break}default:{M=J;K=75;break b}}if((K|0)==19){K=0;G=f[n>>2]|0;I=G&-2;if(!(G&1))S=I;else S=f[I+4>>2]|0;I=f[m>>2]|0;if((I|0)==497760){dya(m,S,497760);T=f[m>>2]|0}else T=I;if(!(fqb(c,T)|0)){N=0;K=79;break a}I=f[o>>2]|0;G=b[I+11>>0]|0;if(G<<24>>24<0){U=f[I>>2]|0;V=f[I+4>>2]|0}else{U=I;V=G&255}if(!(gqb(U,V,0,386788)|0)){N=0;K=79;break a}G=f[c>>2]|0;if(G>>>0>=(f[h>>2]|0)>>>0)continue a;if((b[G>>0]|0)==26){W=G;K=32}else continue a}while(1){if((K|0)==32){K=0;f[c>>2]=W+1;K=33;continue}else if((K|0)==33){K=0;if(!(fqb(c,mza(p)|0)|0)){N=0;K=79;break a}G=f[(f[r>>2]|0)+4+((f[q>>2]|0)+-1<<2)>>2]|0;I=b[G+11>>0]|0;if(I<<24>>24<0){X=f[G>>2]|0;Y=f[G+4>>2]|0}else{X=G;Y=I&255}if(!(gqb(X,Y,0,386819)|0)){N=0;K=79;break a}I=f[c>>2]|0;if(I>>>0>=(f[h>>2]|0)>>>0)continue a;if((b[I>>0]|0)==26){W=I;K=32;continue}if((b[I>>0]|0)==34)Z=I;else continue a}else if((K|0)==43){K=0;if(!(fqb(c,mza(s)|0)|0)){N=0;K=79;break a}I=f[(f[v>>2]|0)+4+((f[t>>2]|0)+-1<<2)>>2]|0;G=b[I+11>>0]|0;if(G<<24>>24<0){_=f[I>>2]|0;$=f[I+4>>2]|0}else{_=I;$=G&255}if(!(gqb(_,$,0,386851)|0)){N=0;K=79;break a}G=f[c>>2]|0;if(G>>>0>=(f[h>>2]|0)>>>0)continue a;if((b[G>>0]|0)==34)Z=G;else{if((b[G>>0]|0)!=42)continue a;f[c>>2]=G+1;K=53;continue}}else if((K|0)==53){K=0;G=f[w>>2]|0;f[w>>2]=G+-1;if((G|0)>0)break;else{N=0;K=79;break a}}f[c>>2]=Z+1;K=43}while(1){f[g>>2]=x;G=di[f[(f[x>>2]|0)+68>>2]&1023](x)|0;f[a>>2]=G;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[z>>2]=0;G=f[c>>2]|0;if(G>>>0<(f[h>>2]|0)>>>0?(I=b[G>>0]|0,I<<24>>24>-1):0){f[c>>2]=G+1;aa=I&255;K=58}else{I=Znb(c)|0;if((I|0)>-1){aa=I;K=58}else ba=7}do if((K|0)==58){K=0;Inb(e,c,aa);if((f[A>>2]|0)>=0?cEa(g,c)|0:0){if(!(Onb(c,f[e>>2]|0)|0)){ba=7;break}I=b[B>>0]|0;G=I<<24>>24<0;H=gqb(G?f[y>>2]|0:y,G?f[C>>2]|0:I&255,0,386883)|0;ba=H?0:7;break}ba=7}while(0);H=f[z>>2]|0;if(H|0)bi[f[(f[H>>2]|0)+4>>2]&2047](H);if((b[B>>0]|0)<0)O5b(f[y>>2]|0);switch(ba&7){case 7:{N=0;K=79;break a;break}case 0:break;default:{K=78;break a}}ca=f[c>>2]|0;da=f[h>>2]|0;if(ca>>>0>=da>>>0)break;if((b[ca>>0]|0)!=42)break;f[c>>2]=ca+1}f[w>>2]=(f[w>>2]|0)+1;if((ca|0)!=(da|0))continue a;if(f[D>>2]|0){K=74;break a}if((f[E>>2]|0)==(f[F>>2]|0)){K=74;break a}else continue a}while(0);if((K|0)==75){K=0;if(!M){N=1;K=79;break}else O=M}if((O&7|0)==4){N=1;K=79;break}if(!(Lpb(c,O)|0)){N=0;K=79;break}}if((K|0)==74){f[i>>2]=0;b[c+24>>0]=1;N=1;u=d;return N|0}else if((K|0)==78){N=1;u=d;return N|0}else if((K|0)==79){u=d;return N|0}return 0}function mIa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;c=u;u=u+32|0;d=c;e=f[a+100>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(!i)j=0;else{if(h){h=f[e+4>>2]|0;if(h>>>0<128){k=1;l=h}else{k=iob(h)|0;l=h}}else{k=1;l=g&255}j=l+1+k|0}k=a+12|0;l=f[k>>2]|0;g=l+j|0;if((l|0)>0){j=a+20|0;h=0;e=g;i=l;while(1){l=f[(f[j>>2]|0)+4+(h<<2)>>2]|0;m=b[l+11>>0]|0;if(m<<24>>24<0){n=f[l+4>>2]|0;if(n>>>0<128){o=1;p=n;q=i}else{l=iob(n)|0;o=l;p=n;q=f[k>>2]|0}}else{o=1;p=m&255;q=i}m=p+e+o|0;h=h+1|0;if((h|0)>=(q|0)){r=m;break}else{e=m;i=q}}}else r=g;g=a+28|0;q=f[g>>2]|0;i=q+r|0;if((q|0)>0){r=a+36|0;e=0;h=i;o=q;while(1){q=f[(f[r>>2]|0)+4+(e<<2)>>2]|0;p=b[q+11>>0]|0;if(p<<24>>24<0){k=f[q+4>>2]|0;if(k>>>0<128){s=1;t=k;v=o}else{q=iob(k)|0;s=q;t=k;v=f[g>>2]|0}}else{s=1;t=p&255;v=o}p=t+h+s|0;e=e+1|0;if((e|0)>=(v|0)){w=p;break}else{h=p;o=v}}}else w=i;i=a+44|0;v=f[i>>2]|0;o=v+w|0;if((v|0)>0){w=a+52|0;h=0;e=o;s=v;while(1){v=f[(f[w>>2]|0)+4+(h<<2)>>2]|0;t=b[v+11>>0]|0;if(t<<24>>24<0){g=f[v+4>>2]|0;if(g>>>0<128){x=1;y=s;z=g}else{v=iob(g)|0;x=v;y=f[i>>2]|0;z=g}}else{x=1;y=s;z=t&255}t=z+e+x|0;h=h+1|0;if((h|0)>=(y|0)){A=t;break}else{e=t;s=y}}}else A=o;o=a+56|0;tKb(o);y=a+92|0;s=f[y>>2]|0;e=s+12|0;if(!(b[s+8>>0]|0))B=f[e>>2]|0;else B=(f[e>>2]|0)+20|0;e=f[B>>2]|0;tKb(o);B=f[y>>2]|0;s=e+A|0;if(!(b[B+8>>0]|0)){A=f[B+12>>2]|0;e=f[A+12>>2]|0;h=f[A+4>>2]|0;a:do if(h>>>0>e>>>0){x=f[A+16>>2]|0;z=e;while(1){C=f[x+(z<<2)>>2]|0;if(C|0)break;i=z+1|0;if(i>>>0<h>>>0)z=i;else{D=0;E=i;F=0;break a}}if((C|0)==(f[x+((z^1)<<2)>>2]|0)){i=f[C>>2]|0;D=f[i+16>>2]|0;E=z;F=i;break}else{D=C;E=z;F=0;break}}else{D=0;E=e;F=0}while(0);e=d+4|0;f[e>>2]=D;f[d+8>>2]=A;f[d+12>>2]=E;f[d+16>>2]=F;F=d+20|0;f[F>>2]=0;f[d>>2]=2;E=d+20|0;G=d+4|0;H=F;I=E;J=E;K=e;L=d}else{e=f[(f[B+12>>2]|0)+12>>2]|0;f[d>>2]=1;B=d+4|0;f[B>>2]=0;E=d+20|0;f[E>>2]=e;G=B;H=d+20|0;I=E;J=E;K=d+4|0;L=d}d=a+88|0;E=s;s=0;b:while(1){tKb(o);B=(b[(f[y>>2]|0)+8>>0]|0)==0?2:1;e=f[L>>2]|0;c:do if((e|0)==(B|0))switch(B&3){case 0:{break b;break}case 1:{if(!(f[H>>2]|0))break b;else break c;break}default:if(!(f[G>>2]|0))break b;else break c}while(0);if(!s){M=0;N=e}else{B=(di[f[(f[s>>2]|0)+20>>2]&1023](s)|0)==0;M=B?s:0;N=f[L>>2]|0}B=f[((N|0)==1?(f[I>>2]|0)+20|0:(f[G>>2]|0)+12|0)>>2]|0;z=f[d>>2]|0;if(!z){x=L5b(32)|0;f[x+4>>2]=0;f[x+16>>2]=0;O=x}else{x=znb(z,18512,32)|0;f[x+4>>2]=0;f[x+16>>2]=z;O=x}f[O+8>>2]=497760;f[O+12>>2]=0;f[O>>2]=107432;f[O+24>>2]=B;f[O+28>>2]=B+16;f[O+20>>2]=3;if((M|0)!=(O|0))if(!M)P=O;else{bi[f[(f[M>>2]|0)+4>>2]&2047](M);P=O}else P=M;B=P+20|0;x=f[B>>2]|0;if(!(x&1)){Q=x;R=0}else{x=di[f[(f[P>>2]|0)+72>>2]&1023](P)|0;z=b[x+11>>0]|0;if(z<<24>>24<0){F=f[x+4>>2]|0;if(F>>>0<128){S=1;T=F}else{S=iob(F)|0;T=F}}else{S=1;T=z&255}Q=f[B>>2]|0;R=T+1+S|0}if(!(Q&2))U=0;else{B=zGa(di[f[(f[P>>2]|0)+76>>2]&1023](P)|0)|0;if(B>>>0<128)V=1;else V=iob(B)|0;U=B+1+V|0}B=U+R|0;if(B>>>0<128)W=1;else W=iob(B)|0;z=B+E+W|0;if((f[L>>2]|0)==1){f[J>>2]=f[f[I>>2]>>2];E=z;s=P;continue}else{uxa(K)|0;E=z;s=P;continue}}if(!s){X=a+104|0;f[X>>2]=E;u=c;return E|0}if(di[f[(f[s>>2]|0)+20>>2]&1023](s)|0){X=a+104|0;f[X>>2]=E;u=c;return E|0}bi[f[(f[s>>2]|0)+4>>2]&2047](s);X=a+104|0;f[X>>2]=E;u=c;return E|0}function nIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=u;u=u+32|0;e=d;g=a+12|0;if((f[g>>2]|0)>0){h=a+20|0;i=0;do{j=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;k=b[j+11>>0]|0;if(k<<24>>24<0){l=f[j>>2]|0;m=f[j+4>>2]|0}else{l=j;m=k&255}gqb(l,m,1,386756)|0;_pb(1,f[(f[h>>2]|0)+4+(i<<2)>>2]|0,c);i=i+1|0}while((i|0)<(f[g>>2]|0))}g=a+100|0;i=f[g>>2]|0;h=b[i+11>>0]|0;m=h<<24>>24<0;if(m)n=f[i+4>>2]|0;else n=h&255;if(n|0){if(m){o=f[i>>2]|0;p=f[i+4>>2]|0}else{o=i;p=h&255}gqb(o,p,1,386788)|0;$pb(2,f[g>>2]|0,c)}g=a+28|0;if((f[g>>2]|0)>0){p=a+36|0;o=0;do{h=f[(f[p>>2]|0)+4+(o<<2)>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){q=f[h>>2]|0;r=f[h+4>>2]|0}else{q=h;r=i&255}gqb(q,r,1,386819)|0;_pb(3,f[(f[p>>2]|0)+4+(o<<2)>>2]|0,c);o=o+1|0}while((o|0)<(f[g>>2]|0))}g=a+44|0;if((f[g>>2]|0)>0){o=a+52|0;p=0;do{r=f[(f[o>>2]|0)+4+(p<<2)>>2]|0;q=b[r+11>>0]|0;if(q<<24>>24<0){s=f[r>>2]|0;t=f[r+4>>2]|0}else{s=r;t=q&255}gqb(s,t,1,386851)|0;_pb(4,f[(f[o>>2]|0)+4+(p<<2)>>2]|0,c);p=p+1|0}while((p|0)<(f[g>>2]|0))}g=a+56|0;tKb(g);p=a+92|0;o=f[p>>2]|0;t=o+12|0;if(!(b[o+8>>0]|0))v=f[t>>2]|0;else v=(f[t>>2]|0)+20|0;if(!(f[v>>2]|0)){u=d;return}if(b[(b[c+18>>0]|0?c+19|0:1122455)>>0]|0){tKb(g);v=f[p>>2]|0;t=v+12|0;if(!(b[v+8>>0]|0))w=f[t>>2]|0;else w=(f[t>>2]|0)+20|0;if((f[w>>2]|0)>>>0>1){tKb(g);w=f[p>>2]|0;t=w+12|0;if(!(b[w+8>>0]|0))x=f[t>>2]|0;else x=(f[t>>2]|0)+20|0;t=f[x>>2]|0;x=N5b(t>>>0>1073741823?-1:t<<2)|0;tKb(g);t=f[p>>2]|0;if(!(b[t+8>>0]|0)){w=f[t+12>>2]|0;v=f[w+12>>2]|0;o=f[w+4>>2]|0;a:do if(o>>>0>v>>>0){s=f[w+16>>2]|0;q=v;while(1){y=f[s+(q<<2)>>2]|0;if(y|0)break;r=q+1|0;if(r>>>0<o>>>0)q=r;else{z=0;A=r;B=0;break a}}if((y|0)==(f[s+((q^1)<<2)>>2]|0)){r=f[y>>2]|0;z=f[r+16>>2]|0;A=q;B=r;break}else{z=y;A=q;B=0;break}}else{z=0;A=v;B=0}while(0);v=e+4|0;f[v>>2]=z;f[e+8>>2]=w;f[e+12>>2]=A;f[e+16>>2]=B;B=e+20|0;f[B>>2]=0;f[e>>2]=2;A=e+20|0;C=e;D=e+4|0;E=B;F=A;G=A;H=v}else{v=f[(f[t+12>>2]|0)+12>>2]|0;f[e>>2]=1;t=e+4|0;f[t>>2]=0;A=e+20|0;f[A>>2]=v;C=e;D=t;E=e+20|0;F=A;G=A;H=e+4|0}A=0;b:while(1){tKb(g);t=(b[(f[p>>2]|0)+8>>0]|0)==0?2:1;v=f[C>>2]|0;c:do if((v|0)==(t|0))switch(t&3){case 0:{break b;break}case 1:{if(!(f[E>>2]|0))break b;else break c;break}default:if(!(f[D>>2]|0))break b;else break c}while(0);t=(v|0)==1;q=f[F>>2]|0;f[x+(A<<2)>>2]=f[(t?q+20|0:(f[D>>2]|0)+12|0)>>2];if(t)f[G>>2]=f[q>>2];else uxa(H)|0;A=A+1|0}VDa(x,x+(A<<2)|0,e);if(A|0){H=a+88|0;G=0;D=0;do{F=x+(G<<2)|0;E=f[F>>2]|0;C=f[H>>2]|0;if(!C){q=L5b(32)|0;f[q+4>>2]=0;f[q+16>>2]=0;I=q}else{q=znb(C,18512,32)|0;f[q+4>>2]=0;f[q+16>>2]=C;I=q}f[I+8>>2]=497760;f[I+12>>2]=0;f[I>>2]=107432;f[I+24>>2]=E;f[I+28>>2]=E+16;f[I+20>>2]=3;if((D|0)!=(I|0))if(!D)J=I;else{bi[f[(f[D>>2]|0)+4>>2]&2047](D);J=I}else J=D;eqb(5,J,c);E=(di[f[(f[J>>2]|0)+20>>2]&1023](J)|0)==0;D=E?J:0;E=f[F>>2]|0;F=b[E+11>>0]|0;if(F<<24>>24<0){K=f[E>>2]|0;L=f[E+4>>2]|0}else{K=E;L=F&255}gqb(K,L,1,386883)|0;G=G+1|0}while(G>>>0<A>>>0);if(D|0)bi[f[(f[D>>2]|0)+4>>2]&2047](D)}P5b(x);u=d;return}}tKb(g);x=f[p>>2]|0;if(!(b[x+8>>0]|0)){D=f[x+12>>2]|0;A=f[D+12>>2]|0;G=f[D+4>>2]|0;d:do if(G>>>0>A>>>0){L=f[D+16>>2]|0;K=A;while(1){M=f[L+(K<<2)>>2]|0;if(M|0)break;J=K+1|0;if(J>>>0<G>>>0)K=J;else{N=0;O=J;P=0;break d}}if((M|0)==(f[L+((K^1)<<2)>>2]|0)){v=f[M>>2]|0;N=f[v+16>>2]|0;O=K;P=v;break}else{N=M;O=K;P=0;break}}else{N=0;O=A;P=0}while(0);A=e+4|0;f[A>>2]=N;f[e+8>>2]=D;f[e+12>>2]=O;f[e+16>>2]=P;P=e+20|0;f[P>>2]=0;f[e>>2]=2;O=e+20|0;Q=e+4|0;R=P;S=O;T=O;U=A;V=e}else{A=f[(f[x+12>>2]|0)+12>>2]|0;f[e>>2]=1;x=e+4|0;f[x>>2]=0;O=e+20|0;f[O>>2]=A;Q=x;R=e+20|0;S=O;T=O;U=e+4|0;V=e}e=a+88|0;a=0;e:while(1){tKb(g);O=(b[(f[p>>2]|0)+8>>0]|0)==0?2:1;x=f[V>>2]|0;f:do if((x|0)==(O|0))switch(O&3){case 0:{break e;break}case 1:{if(!(f[R>>2]|0))break e;else break f;break}default:if(!(f[Q>>2]|0))break e;else break f}while(0);O=f[((x|0)==1?(f[S>>2]|0)+20|0:(f[Q>>2]|0)+12|0)>>2]|0;K=f[e>>2]|0;if(!K){L=L5b(32)|0;f[L+4>>2]=0;f[L+16>>2]=0;W=L}else{L=znb(K,18512,32)|0;f[L+4>>2]=0;f[L+16>>2]=K;W=L}f[W+8>>2]=497760;f[W+12>>2]=0;f[W>>2]=107432;f[W+24>>2]=O;f[W+28>>2]=O+16;f[W+20>>2]=3;if((a|0)!=(W|0))if(!a)X=W;else{bi[f[(f[a>>2]|0)+4>>2]&2047](a);X=W}else X=a;eqb(5,X,c);O=(di[f[(f[X>>2]|0)+20>>2]&1023](X)|0)==0;L=O?X:0;O=f[((f[V>>2]|0)==1?(f[S>>2]|0)+20|0:(f[Q>>2]|0)+12|0)>>2]|0;K=b[O+11>>0]|0;if(K<<24>>24<0){Y=f[O>>2]|0;Z=f[O+4>>2]|0}else{Y=O;Z=K&255}gqb(Y,Z,1,386883)|0;if((f[V>>2]|0)==1){f[T>>2]=f[f[S>>2]>>2];a=L;continue}else{uxa(U)|0;a=L;continue}}if(!a){u=d;return}bi[f[(f[a>>2]|0)+4>>2]&2047](a);u=d;return}function oIa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function pIa(a){a=a|0;return f[a+104>>2]|0}function qIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;e=u;u=u+32|0;g=e;h=a+12|0;if((f[h>>2]|0)>0){i=a+20|0;j=0;k=d;while(1){l=f[(f[i>>2]|0)+4+(j<<2)>>2]|0;m=b[l+11>>0]|0;if(m<<24>>24<0){n=f[l>>2]|0;o=f[l+4>>2]|0}else{n=l;o=m&255}gqb(n,o,1,386756)|0;m=f[(f[i>>2]|0)+4+(j<<2)>>2]|0;b[k>>0]=10;l=kob(m,k+1|0)|0;j=j+1|0;if((j|0)>=(f[h>>2]|0)){p=l;break}else k=l}}else p=d;d=a+100|0;k=f[d>>2]|0;h=b[k+11>>0]|0;j=h<<24>>24<0;if(j)q=f[k+4>>2]|0;else q=h&255;if(!q)r=p;else{if(j){s=f[k>>2]|0;t=f[k+4>>2]|0}else{s=k;t=h&255}gqb(s,t,1,386788)|0;t=f[d>>2]|0;b[p>>0]=18;r=kob(t,p+1|0)|0}p=a+28|0;if((f[p>>2]|0)>0){t=a+36|0;d=0;s=r;while(1){h=f[(f[t>>2]|0)+4+(d<<2)>>2]|0;k=b[h+11>>0]|0;if(k<<24>>24<0){v=f[h>>2]|0;w=f[h+4>>2]|0}else{v=h;w=k&255}gqb(v,w,1,386819)|0;k=f[(f[t>>2]|0)+4+(d<<2)>>2]|0;b[s>>0]=26;h=kob(k,s+1|0)|0;d=d+1|0;if((d|0)>=(f[p>>2]|0)){x=h;break}else s=h}}else x=r;r=a+44|0;if((f[r>>2]|0)>0){s=a+52|0;p=0;d=x;while(1){t=f[(f[s>>2]|0)+4+(p<<2)>>2]|0;w=b[t+11>>0]|0;if(w<<24>>24<0){y=f[t>>2]|0;z=f[t+4>>2]|0}else{y=t;z=w&255}gqb(y,z,1,386851)|0;w=f[(f[s>>2]|0)+4+(p<<2)>>2]|0;b[d>>0]=34;t=kob(w,d+1|0)|0;p=p+1|0;if((p|0)>=(f[r>>2]|0)){A=t;break}else d=t}}else A=x;x=a+56|0;tKb(x);d=a+92|0;r=f[d>>2]|0;p=r+12|0;if(!(b[r+8>>0]|0))B=f[p>>2]|0;else B=(f[p>>2]|0)+20|0;if(!(f[B>>2]|0)){C=A;u=e;return C|0}if(c){tKb(x);B=f[d>>2]|0;p=B+12|0;if(!(b[B+8>>0]|0))D=f[p>>2]|0;else D=(f[p>>2]|0)+20|0;if((f[D>>2]|0)>>>0>1){tKb(x);D=f[d>>2]|0;p=D+12|0;if(!(b[D+8>>0]|0))E=f[p>>2]|0;else E=(f[p>>2]|0)+20|0;p=f[E>>2]|0;E=N5b(p>>>0>1073741823?-1:p<<2)|0;tKb(x);p=f[d>>2]|0;if(!(b[p+8>>0]|0)){D=f[p+12>>2]|0;B=f[D+12>>2]|0;r=f[D+4>>2]|0;a:do if(r>>>0>B>>>0){s=f[D+16>>2]|0;z=B;while(1){F=f[s+(z<<2)>>2]|0;if(F|0)break;y=z+1|0;if(y>>>0<r>>>0)z=y;else{G=0;H=y;I=0;break a}}if((F|0)==(f[s+((z^1)<<2)>>2]|0)){y=f[F>>2]|0;G=f[y+16>>2]|0;H=z;I=y;break}else{G=F;H=z;I=0;break}}else{G=0;H=B;I=0}while(0);B=g+4|0;f[B>>2]=G;f[g+8>>2]=D;f[g+12>>2]=H;f[g+16>>2]=I;I=g+20|0;f[I>>2]=0;f[g>>2]=2;H=g+20|0;J=g+4|0;K=I;L=H;M=H;N=B;O=g}else{B=f[(f[p+12>>2]|0)+12>>2]|0;f[g>>2]=1;p=g+4|0;f[p>>2]=0;H=g+20|0;f[H>>2]=B;J=p;K=g+20|0;L=H;M=H;N=g+4|0;O=g}H=0;b:while(1){tKb(x);p=(b[(f[d>>2]|0)+8>>0]|0)==0?2:1;B=f[O>>2]|0;c:do if((B|0)==(p|0))switch(p&3){case 0:{break b;break}case 1:{if(!(f[K>>2]|0))break b;else break c;break}default:if(!(f[J>>2]|0))break b;else break c}while(0);p=(B|0)==1;z=f[L>>2]|0;f[E+(H<<2)>>2]=f[(p?z+20|0:(f[J>>2]|0)+12|0)>>2];if(p)f[M>>2]=f[z>>2];else uxa(N)|0;H=H+1|0}VDa(E,E+(H<<2)|0,g);if(H){N=a+88|0;M=0;J=A;L=0;do{K=E+(M<<2)|0;O=f[K>>2]|0;z=f[N>>2]|0;if(!z){p=L5b(32)|0;f[p+4>>2]=0;f[p+16>>2]=0;P=p}else{p=znb(z,18512,32)|0;f[p+4>>2]=0;f[p+16>>2]=z;P=p}f[P+8>>2]=497760;f[P+12>>2]=0;f[P>>2]=107432;f[P+24>>2]=O;f[P+28>>2]=O+16;f[P+20>>2]=3;if((L|0)!=(P|0))if(!L)Q=P;else{bi[f[(f[L>>2]|0)+4>>2]&2047](L);Q=P}else Q=L;b[J>>0]=42;O=J+1|0;p=Q+20|0;z=f[p>>2]|0;if(!(z&1)){R=z;S=0}else{z=di[f[(f[Q>>2]|0)+72>>2]&1023](Q)|0;s=b[z+11>>0]|0;do if(s<<24>>24<0){I=f[z+4>>2]|0;if(I>>>0<128){T=1;U=I;break}T=iob(I)|0;U=I}else{T=1;U=s&255}while(0);R=f[p>>2]|0;S=U+1+T|0}if(!(R&2))V=0;else{s=di[f[(f[Q>>2]|0)+76>>2]&1023](Q)|0;z=di[f[(f[s>>2]|0)+64>>2]&1023](s)|0;if(z>>>0<128)W=1;else W=iob(z)|0;V=z+1+W|0}z=V+S|0;if(z>>>0>127){s=z;B=O;while(1){b[B>>0]=s|128;I=s>>>7;D=B+1|0;if(s>>>0>16383){s=I;B=D}else{X=D;Y=I;break}}}else{X=O;Y=z}b[X>>0]=Y;J=li[f[(f[Q>>2]|0)+68>>2]&511](Q,1,X+1|0)|0;B=(di[f[(f[Q>>2]|0)+20>>2]&1023](Q)|0)==0;L=B?Q:0;B=f[K>>2]|0;s=b[B+11>>0]|0;if(s<<24>>24<0){Z=f[B>>2]|0;_=f[B+4>>2]|0}else{Z=B;_=s&255}gqb(Z,_,1,386883)|0;M=M+1|0}while(M>>>0<H>>>0);if(!L)$=J;else{bi[f[(f[L>>2]|0)+4>>2]&2047](L);$=J}}else $=A;P5b(E);C=$;u=e;return C|0}}tKb(x);$=f[d>>2]|0;if(!(b[$+8>>0]|0)){E=f[$+12>>2]|0;J=f[E+12>>2]|0;L=f[E+4>>2]|0;d:do if(L>>>0>J>>>0){H=f[E+16>>2]|0;M=J;while(1){aa=f[H+(M<<2)>>2]|0;if(aa|0)break;_=M+1|0;if(_>>>0<L>>>0)M=_;else{ba=0;ca=_;da=0;break d}}if((aa|0)==(f[H+((M^1)<<2)>>2]|0)){K=f[aa>>2]|0;ba=f[K+16>>2]|0;ca=M;da=K;break}else{ba=aa;ca=M;da=0;break}}else{ba=0;ca=J;da=0}while(0);J=g+4|0;f[J>>2]=ba;f[g+8>>2]=E;f[g+12>>2]=ca;f[g+16>>2]=da;da=g+20|0;f[da>>2]=0;f[g>>2]=2;ca=g+20|0;ea=g;fa=g+4|0;ga=da;ha=ca;ia=ca;ja=J}else{J=f[(f[$+12>>2]|0)+12>>2]|0;f[g>>2]=1;$=g+4|0;f[$>>2]=0;ca=g+20|0;f[ca>>2]=J;ea=g;fa=$;ga=g+20|0;ha=ca;ia=ca;ja=g+4|0}g=a+88|0;a=A;A=0;e:while(1){tKb(x);ca=(b[(f[d>>2]|0)+8>>0]|0)==0?2:1;$=f[ea>>2]|0;f:do if(($|0)==(ca|0))switch(ca&3){case 0:{break e;break}case 1:{if(!(f[ga>>2]|0))break e;else break f;break}default:if(!(f[fa>>2]|0))break e;else break f}while(0);ca=f[(($|0)==1?(f[ha>>2]|0)+20|0:(f[fa>>2]|0)+12|0)>>2]|0;M=f[g>>2]|0;if(!M){H=L5b(32)|0;f[H+4>>2]=0;f[H+16>>2]=0;ka=H}else{H=znb(M,18512,32)|0;f[H+4>>2]=0;f[H+16>>2]=M;ka=H}f[ka+8>>2]=497760;f[ka+12>>2]=0;f[ka>>2]=107432;f[ka+24>>2]=ca;f[ka+28>>2]=ca+16;f[ka+20>>2]=3;if((A|0)!=(ka|0))if(!A)la=ka;else{bi[f[(f[A>>2]|0)+4>>2]&2047](A);la=ka}else la=A;b[a>>0]=42;ca=a+1|0;H=la+20|0;M=f[H>>2]|0;if(!(M&1)){ma=M;na=0}else{M=di[f[(f[la>>2]|0)+72>>2]&1023](la)|0;J=b[M+11>>0]|0;if(J<<24>>24<0){da=f[M+4>>2]|0;if(da>>>0<128){oa=1;pa=da}else{oa=iob(da)|0;pa=da}}else{oa=1;pa=J&255}ma=f[H>>2]|0;na=pa+1+oa|0}if(!(ma&2))qa=0;else{H=di[f[(f[la>>2]|0)+76>>2]&1023](la)|0;J=di[f[(f[H>>2]|0)+64>>2]&1023](H)|0;if(J>>>0<128)ra=1;else ra=iob(J)|0;qa=J+1+ra|0}J=qa+na|0;if(J>>>0>127){H=J;da=ca;while(1){b[da>>0]=H|128;M=H>>>7;E=da+1|0;if(H>>>0>16383){H=M;da=E}else{sa=E;ta=M;break}}}else{sa=ca;ta=J}b[sa>>0]=ta;da=li[f[(f[la>>2]|0)+68>>2]&511](la,c,sa+1|0)|0;H=(di[f[(f[la>>2]|0)+20>>2]&1023](la)|0)==0;$=H?la:0;H=f[((f[ea>>2]|0)==1?(f[ha>>2]|0)+20|0:(f[fa>>2]|0)+12|0)>>2]|0;M=b[H+11>>0]|0;if(M<<24>>24<0){ua=f[H>>2]|0;va=f[H+4>>2]|0}else{ua=H;va=M&255}gqb(ua,va,1,386883)|0;if((f[ea>>2]|0)==1){f[ia>>2]=f[f[ha>>2]>>2];a=da;A=$;continue}else{uxa(ja)|0;a=da;A=$;continue}}if(!A){C=a;u=e;return C|0}bi[f[(f[A>>2]|0)+4>>2]&2047](A);C=a;u=e;return C|0}function rIa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function sIa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))$Ha(1105);c=T6b(b,23288,18648,0)|0;if(!c){cOb(b,a);return}else{vIa(a,c);return}}function tIa(a,b){a=a|0;b=b|0;f[a+104>>2]=b;return}function uIa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213001]|0)!=2){f[d>>2]=135812;f[d+4>>2]=26;b[d+8>>0]=0;Gpb(852004,d);hpb(d)}f[a>>2]=f[213006];f[a+4>>2]=f[213007];u=c;return}function vIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;UDa(a+8|0,c+8|0);UDa(a+24|0,c+24|0);UDa(a+40|0,c+40|0);d=c+84|0;e=a+56|0;tKb(e);tKb(d+-28|0);DCa(a+84|0,d);sKb(e);e=f[c+100>>2]|0;c=b[e+11>>0]|0;if(c<<24>>24<0)g=f[e+4>>2]|0;else g=c&255;if(!g)return;g=a+100|0;c=f[a+4>>2]|0;a=c&-2;if(!(c&1))h=a;else h=f[a+4>>2]|0;a=f[g>>2]|0;if((a|0)==497760){dya(g,h,e);return}else{_5b(a,e)|0;return}}function wIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=108528;f[a+4>>2]=c;f[a+8>>2]=c;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=c;f[a+28>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=c;f[a+44>>2]=0;f[a+48>>2]=0;f[a+52>>2]=0;d=a+56|0;f[d>>2]=140148;f[a+60>>2]=c;f[a+64>>2]=0;e=a+68|0;f[e>>2]=0;g=a+72|0;f[g>>2]=0;h=a+76|0;Bpb(h);f[a+80>>2]=0;gEa(c,h);f[d>>2]=107196;h=a+84|0;f[h>>2]=107148;f[a+88>>2]=c;if(!c){i=L5b(16)|0;f[i>>2]=0;f[i+4>>2]=0;b[i+8>>0]=1;Fxa(i);j=i}else{i=znb(c,18528,16)|0;f[i>>2]=c;f[i+4>>2]=0;b[i+8>>0]=1;Fxa(i);j=i}f[a+92>>2]=j;j=(di[f[(f[h>>2]|0)+36>>2]&1023](h)|0)+4|0;f[j>>2]=0;f[d>>2]=107280;f[h>>2]=107384;f[a+96>>2]=0;f[g>>2]=30;f[e>>2]=852032;f[a+100>>2]=497760;f[a+104>>2]=0;return}function xIa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=108312;b=a+4|0;c=f[b>>2]|0;d=c&-2;if(!(c&1))e=d;else e=f[d+4>>2]|0;if(!((a|0)==492544|(e|0)!=0)?(e=f[a+24>>2]|0,e|0):0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);e=a+20|0;d=f[e>>2]|0;if(d|0?(f[a+8>>2]|0)==0:0){a=f[d>>2]|0;if((a|0)>0){c=0;do{g=f[d+4+(c<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);c=c+1|0}while((c|0)!=(a|0));h=f[e>>2]|0}else h=d;O5b(h)}f[e>>2]=0;e=f[b>>2]|0;if(!(e&1)){f[b>>2]=0;return}h=e&-2;e=h;if((h|0)==0|(f[e+4>>2]|0)!=0){f[b>>2]=0;return}if(f[e>>2]|0)GPb(e);O5b(h);f[b>>2]=0;return}function yIa(a){a=a|0;xIa(a);O5b(a);return}function zIa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function AIa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){a=L5b(32)|0;TIa(a);c=a;return c|0}else{a=b;d=znb(b,18664,32)|0;f[d>>2]=108312;f[d+4>>2]=a;f[d+8>>2]=a;a=d+12|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;c=d;return c|0}return 0}function BIa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function CIa(a){a=a|0;return f[a+4>>2]|0}function DIa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;c=a+24|0;if((d|0)==0?(d=f[c>>2]|0,d|0):0)bi[f[(f[d>>2]|0)+4>>2]&2047](d);f[c>>2]=0;c=a+12|0;d=f[c>>2]|0;if((d|0)<=0)return;b=f[a+20>>2]|0;a=0;do{e=f[b+4+(a<<2)>>2]|0;a=a+1|0;bi[f[(f[e>>2]|0)+28>>2]&2047](e)}while((a|0)!=(d|0));f[c>>2]=0;return}function EIa(a){a=a|0;return 1}function FIa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+24|0;j=a+4|0;k=e+4|0;l=c+44|0;m=a+8|0;n=a+20|0;o=a+16|0;p=a+12|0;a=c+32|0;q=c+12|0;r=c+28|0;a:while(1){s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0){t=b[s>>0]|0;v=t&255;if(t<<24>>24>0){f[h>>2]=v;f[c>>2]=s+1;w=v;x=6}else{y=v;x=5}}else{y=0;x=5}if((x|0)==5){x=0;v=_nb(c,y)|0;f[h>>2]=v;if((v+-1|0)>>>0<127){w=v;x=6}else{z=v;x=45}}b:do if((x|0)==6){x=0;switch(w>>>3&536870911|0){case 1:{switch(w|0){case 0:{A=1;x=48;break a;break}case 10:break;default:{B=w;break b}}v=f[i>>2]|0;if(!v){s=f[j>>2]|0;t=s&-2;if(!(s&1))C=t;else C=f[t+4>>2]|0;if(!C){t=L5b(80)|0;dKa(t);D=t}else{t=znb(C,18712,80)|0;xLa(t,C);D=t}f[i>>2]=D;E=D}else E=v;v=f[c>>2]|0;if(v>>>0<(f[g>>2]|0)>>>0?(t=b[v>>0]|0,t<<24>>24>-1):0){f[c>>2]=v+1;F=t&255}else{t=Znb(c)|0;if((t|0)>-1)F=t;else{A=0;x=48;break a}}Inb(e,c,F);if((f[k>>2]|0)<0){x=22;break a}if(!(sKa(E,c)|0)){x=22;break a}if(!(Onb(c,f[e>>2]|0)|0)){A=0;x=48;break a}t=f[c>>2]|0;if(t>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[t>>0]|0)!=18)continue a;f[c>>2]=t+1;break}case 2:{switch(w|0){case 0:{A=1;x=48;break a;break}case 18:break;default:{B=w;break b}}break}default:{z=w;x=45;break b}}t=f[l>>2]|0;f[l>>2]=t+-1;if((t|0)<=0){A=0;x=48;break a}while(1){t=f[n>>2]|0;do if(t){v=f[p>>2]|0;s=f[t>>2]|0;if((v|0)>=(s|0))if((s|0)==(f[o>>2]|0)){G=s;x=34;break}else{H=s;I=t;x=35;break}else{f[p>>2]=v+1;J=f[t+4+(v<<2)>>2]|0;break}}else{G=f[o>>2]|0;x=34}while(0);if((x|0)==34){x=0;cpb(m,G+1|0);t=f[n>>2]|0;H=f[t>>2]|0;I=t;x=35}if((x|0)==35){x=0;f[I>>2]=H+1;t=SIa(0,f[m>>2]|0)|0;v=f[n>>2]|0;s=f[p>>2]|0;f[p>>2]=s+1;f[v+4+(s<<2)>>2]=t;J=t}t=Jnb(c)|0;if(!(lIa(J,c)|0)){A=0;x=48;break a}if(!(Pnb(c,t)|0)){A=0;x=48;break a}K=f[c>>2]|0;L=f[g>>2]|0;if(K>>>0>=L>>>0)break;if((b[K>>0]|0)!=18)break;f[c>>2]=K+1}f[l>>2]=(f[l>>2]|0)+1;if((K|0)!=(L|0))continue a;if(f[a>>2]|0){x=44;break a}if((f[q>>2]|0)==(f[r>>2]|0)){x=44;break a}else continue a}while(0);if((x|0)==45){x=0;if(!z){A=1;x=48;break}else B=z}if((B&7|0)==4){A=1;x=48;break}if(!(Lpb(c,B)|0)){A=0;x=48;break}}if((x|0)==22){A=0;u=d;return A|0}else if((x|0)==44){f[h>>2]=0;b[c+24>>0]=1;A=1;u=d;return A|0}else if((x|0)==48){u=d;return A|0}return 0}function GIa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((a|0)!=492544?(b=f[a+24>>2]|0,(b|0)!=0):0){c=qKa(b)|0;if(c>>>0<128)d=1;else d=iob(c)|0;e=c+1+d|0}else e=0;d=f[a+12>>2]|0;c=d+e|0;if(!d){g=c;h=a+28|0;f[h>>2]=g;return g|0}e=a+20|0;b=0;i=c;while(1){c=mIa(f[(f[e>>2]|0)+4+(b<<2)>>2]|0)|0;if(c>>>0<128)j=1;else j=iob(c)|0;k=c+i+j|0;b=b+1|0;if((b|0)==(d|0)){g=k;break}else i=k}h=a+28|0;f[h>>2]=g;return g|0}function HIa(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)!=492544?(c=f[a+24>>2]|0,c|0):0)eqb(1,c,b);c=f[a+12>>2]|0;if(!c)return;d=a+20|0;a=0;do{eqb(2,f[(f[d>>2]|0)+4+(a<<2)>>2]|0,b);a=a+1|0}while((a|0)!=(c|0));return}function IIa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function JIa(a){a=a|0;return f[a+28>>2]|0}function KIa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if((a|0)!=492544?(c=f[a+24>>2]|0,(c|0)!=0):0){b[d>>0]=10;e=d+1|0;g=f[c+76>>2]|0;if(g>>>0>127){h=g;i=e;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=e;m=g}b[l>>0]=m;n=li[f[(f[c>>2]|0)+68>>2]&511](c,0,l+1|0)|0}else n=d;d=f[a+12>>2]|0;if(!d){o=n;return o|0}l=a+20|0;a=0;c=n;while(1){n=f[(f[l>>2]|0)+4+(a<<2)>>2]|0;b[c>>0]=18;m=c+1|0;g=f[n+104>>2]|0;if(g>>>0>127){e=g;i=m;while(1){b[i>>0]=e|128;h=e>>>7;j=i+1|0;if(e>>>0>16383){e=h;i=j}else{p=j;q=h;break}}}else{p=m;q=g}b[p>>0]=q;i=li[f[(f[n>>2]|0)+68>>2]&511](n,0,p+1|0)|0;a=a+1|0;if((a|0)==(d|0)){o=i;break}else c=i}return o|0}function LIa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function MIa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))$Ha(1463);c=T6b(b,23288,18664,0)|0;if(!c){cOb(b,a);return}else{PIa(a,c);return}}function NIa(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function OIa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213001]|0)!=2){f[d>>2]=135812;f[d+4>>2]=26;b[d+8>>0]=0;Gpb(852004,d);hpb(d)}f[a>>2]=f[213004];f[a+4>>2]=f[213005];u=c;return}function PIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;QIa(a+8|0,b+8|0);if((b|0)==492544)return;c=b+24|0;b=f[c>>2]|0;if(!b)return;d=a+24|0;e=f[d>>2]|0;if(!e){g=f[a+4>>2]|0;a=g&-2;if(!(g&1))h=a;else h=f[a+4>>2]|0;if(!h){a=L5b(80)|0;dKa(a);i=a}else{a=znb(h,18712,80)|0;xLa(a,h);i=a}f[d>>2]=i;j=f[c>>2]|0;k=i}else{j=b;k=e}yLa(k,(j|0)==0?492736:j);return}function QIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{RIa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=SIa(h,i)|0;RIa(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function RIa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))$Ha(1123);else{vIa(b,a);return}}function SIa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(108)|0;IHa(a);c=a;return c|0}else{a=znb(b,18648,108)|0;wIa(a,b);c=a;return c|0}return 0}function TIa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=108312;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;if((a|0)!=492544?(f[212999]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=28;b[d+8>>0]=0;Gpb(851996,d);hpb(d)}f[a+24>>2]=0;f[a+28>>2]=0;u=c;return}function UIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{YIa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=ZIa(h,i)|0;YIa(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function VIa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{WIa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=XIa(h,i)|0;WIa(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function WIa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))$Ha(2140);else{aIa(b,a);return}}function XIa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(20)|0;bIa(a);c=a;return c|0}else{a=znb(b,18632,20)|0;f[a>>2]=108420;f[a+4>>2]=b;f[a+8>>2]=497760;f[a+12>>2]=497760;f[a+16>>2]=0;c=a;return c|0}return 0}function YIa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))$Ha(1481);else{PIa(b,a);return}}function ZIa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){a=L5b(32)|0;TIa(a);c=a;return c|0}else{a=b;d=znb(b,18664,32)|0;f[d>>2]=108312;f[d+4>>2]=a;f[d+8>>2]=a;a=d+12|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;c=d;return c|0}return 0}function _Ia(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=108160;e=(a|0)==492488;g=a+4|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[212999]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=28;b[d+8>>0]=0;Gpb(851996,d);hpb(d)}f[a+40>>2]=0;u=c;return}function $Ia(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213e3]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=27;b[c+8>>0]=0;Gpb(852e3,c);hpb(c);u=a;return}function aJa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213e3]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=27;b[c+8>>0]=0;Gpb(852e3,c);hpb(c);u=a;return}function bJa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212999]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=28;b[c+8>>0]=0;Gpb(851996,c);hpb(c);u=a;return}function cJa(a,b){a=a|0;b=b|0;f[a>>2]=108160;f[a+4>>2]=b;f[a+8>>2]=b;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=b;b=a+28|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;return}function dJa(a,b){a=a|0;b=b|0;if((b|0)==(a|0))$Ha(471);else{UIa(a+8|0,b+8|0);VIa(a+24|0,b+24|0);return}}function eJa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213012]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=31;b[c+8>>0]=0;Gpb(852048,c);hpb(c);u=a;return}function fJa(){var a=0,c=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,387021);if((f[213011]|0)!=2){f[c>>2]=135812;f[c+4>>2]=32;b[c+8>>0]=0;Gpb(852044,c);hpb(c)}grb(387101,750);SNb(387852,1499);spb(33);u=a;return}function gJa(){kpb(3001e3,3001e3,387021);return}function hJa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[213013]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=34;b[c+8>>0]=0;Gpb(852052,c);hpb(c);u=a;return}function iJa(){return}function jJa(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a=u;u=u+48|0;c=a+24|0;d=a;e=a+36|0;if((f[213012]|0)!=2){f[c>>2]=135812;f[c+4>>2]=31;b[c+8>>0]=0;Gpb(852048,c);hpb(c)}g=drb()|0;h=L5b(16)|0;f[c>>2]=h;f[c+8>>2]=-2147483632;f[c+4>>2]=11;i=h;j=387852;k=i+11|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+11>>0]=0;h=hrb(g,c)|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if(h|0){l=h+48|0;m=f[l>>2]|0;f[213014]=m;u=a;return}zpb(d,3,387021,35);xpb(e,vpb(d,459532)|0);Apb(d);l=h+48|0;m=f[l>>2]|0;f[213014]=m;u=a;return}function kJa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213012]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=31;b[c+8>>0]=0;Gpb(852048,c);hpb(c);u=a;return}function lJa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213011]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=32;b[c+8>>0]=0;Gpb(852044,c);hpb(c);u=a;return}function mJa(a){a=a|0;var b=0,c=0;f[a>>2]=108636;tLa(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function nJa(a){a=a|0;mJa(a);O5b(a);return}function oJa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function pJa(a,c){a=a|0;c=c|0;var d=0;if(!c){a=L5b(40)|0;oKa(a);d=a;return d|0}else{a=znb(c,18680,40)|0;f[a>>2]=108636;f[a+4>>2]=c;f[a+8>>2]=497760;f[a+12>>2]=497760;f[a+16>>2]=497760;f[a+20>>2]=497760;f[a+24>>2]=497760;c=a+28|0;f[c>>2]=0;b[c+4>>0]=0;f[a+36>>2]=0;d=a;return d|0}return 0}function qJa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function rJa(a){a=a|0;return f[a+4>>2]|0}function sJa(a){a=a|0;var c=0,d=0;c=a+28|0;f[c>>2]=0;b[c+4>>0]=0;c=f[a+8>>2]|0;do if((c|0)!=497760){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+12>>2]|0;do if((c|0)!=497760){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+16>>2]|0;do if((c|0)!=497760){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+20>>2]|0;do if((c|0)!=497760){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+24>>2]|0;if((c|0)==497760)return;a=c+11|0;if((b[a>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;return}else{b[c>>0]=0;b[a>>0]=0;return}}function tJa(a){a=a|0;return 1}function uJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+4|0;l=a+8|0;m=a+12|0;n=a+12|0;o=a+28|0;p=a+16|0;q=a+16|0;r=a+20|0;s=a+20|0;t=a+24|0;v=a+24|0;w=a+32|0;a=c+32|0;x=c+12|0;y=c+28|0;z=e+8|0;a:while(1){A=f[c>>2]|0;B=f[g>>2]|0;do if(A>>>0<B>>>0){C=b[A>>0]|0;D=C&255;if(C<<24>>24>0){E=D;F=1}else{C=A+1|0;if(C>>>0>=B>>>0){G=D;H=7;break}I=h[C>>0]|0;if(((I^128)&D)>>>0<=127){G=D;H=7;break}E=D+-128+(I<<7)|0;F=2}f[i>>2]=E;f[c>>2]=A+F;K=E;H=9}else{G=0;H=7}while(0);if((H|0)==7){H=0;A=_nb(c,G)|0;f[i>>2]=A;if((A+-1|0)>>>0<16383){K=A;H=9}else{L=A;H=102}}b:do if((H|0)==9){H=0;switch(K>>>3&536870911|0){case 1:{switch(K|0){case 0:{M=1;H=105;break a;break}case 10:break;default:{N=K;break b}}A=f[k>>2]|0;B=A&-2;if(!(A&1))O=B;else O=f[B+4>>2]|0;B=f[j>>2]|0;if((B|0)==497760){dya(j,O,497760);P=f[j>>2]|0}else P=B;if(!(fqb(c,P)|0)){M=0;H=105;break a}B=f[l>>2]|0;A=b[B+11>>0]|0;if(A<<24>>24<0){Q=f[B>>2]|0;R=f[B+4>>2]|0}else{Q=B;R=A&255}if(!(gqb(Q,R,0,389178)|0)){M=0;H=105;break a}A=f[c>>2]|0;if(A>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[A>>0]|0)!=18)continue a;f[c>>2]=A+1;H=25;break}case 2:{switch(K|0){case 0:{M=1;H=105;break a;break}case 18:{H=25;break}default:{N=K;break b}}break}case 3:{switch(K|0){case 0:{M=1;H=105;break a;break}case 24:break;default:{N=K;break b}}S=f[c>>2]|0;T=f[g>>2]|0;H=40;break}case 4:{switch(K|0){case 0:{M=1;H=105;break a;break}case 34:{H=49;break}default:{N=K;break b}}break}case 5:{switch(K|0){case 0:{M=1;H=105;break a;break}case 42:{H=63;break}default:{N=K;break b}}break}case 6:{switch(K|0){case 0:{M=1;H=105;break a;break}case 50:{H=77;break}default:{N=K;break b}}break}case 16:{switch(K|0){case 0:{M=1;H=105;break a;break}case 128:break;default:{N=K;break b}}U=f[c>>2]|0;V=f[g>>2]|0;break}default:{L=K;H=102;break b}}if((H|0)==25){H=0;A=f[k>>2]|0;B=A&-2;if(!(A&1))W=B;else W=f[B+4>>2]|0;B=f[m>>2]|0;if((B|0)==497760){dya(m,W,497760);X=f[m>>2]|0}else X=B;if(!(fqb(c,X)|0)){M=0;H=105;break a}B=f[n>>2]|0;A=b[B+11>>0]|0;if(A<<24>>24<0){Y=f[B>>2]|0;Z=f[B+4>>2]|0}else{Y=B;Z=A&255}if(!(gqb(Y,Z,0,389207)|0)){M=0;H=105;break a}A=f[c>>2]|0;B=f[g>>2]|0;if(A>>>0>=B>>>0)continue a;if((b[A>>0]|0)!=24)continue a;I=A+1|0;f[c>>2]=I;S=I;T=B;H=40}if((H|0)==40){H=0;if(S>>>0<T>>>0){B=b[S>>0]|0;I=B&255;if(B<<24>>24>-1){B=S+1|0;f[c>>2]=B;_=I;$=B;aa=T}else{ba=I;H=43}}else{ba=0;H=43}if((H|0)==43){H=0;I=Knb(c,ba)|0;B=J;if(!((B|0)>-1|(B|0)==-1&I>>>0>4294967295)){M=0;H=105;break a}_=I;$=f[c>>2]|0;aa=f[g>>2]|0}f[o>>2]=_;if($>>>0>=aa>>>0)continue a;if((b[$>>0]|0)!=34)continue a;f[c>>2]=$+1;H=49}if((H|0)==49){H=0;I=f[k>>2]|0;B=I&-2;if(!(I&1))ca=B;else ca=f[B+4>>2]|0;B=f[p>>2]|0;if((B|0)==497760){dya(p,ca,497760);da=f[p>>2]|0}else da=B;if(!(fqb(c,da)|0)){M=0;H=105;break a}B=f[q>>2]|0;I=b[B+11>>0]|0;if(I<<24>>24<0){ea=f[B>>2]|0;fa=f[B+4>>2]|0}else{ea=B;fa=I&255}if(!(gqb(ea,fa,0,389243)|0)){M=0;H=105;break a}I=f[c>>2]|0;if(I>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[I>>0]|0)!=42)continue a;f[c>>2]=I+1;H=63}if((H|0)==63){H=0;I=f[k>>2]|0;B=I&-2;if(!(I&1))ga=B;else ga=f[B+4>>2]|0;B=f[r>>2]|0;if((B|0)==497760){dya(r,ga,497760);ha=f[r>>2]|0}else ha=B;if(!(fqb(c,ha)|0)){M=0;H=105;break a}B=f[s>>2]|0;I=b[B+11>>0]|0;if(I<<24>>24<0){ia=f[B>>2]|0;ja=f[B+4>>2]|0}else{ia=B;ja=I&255}if(!(gqb(ia,ja,0,389277)|0)){M=0;H=105;break a}I=f[c>>2]|0;if(I>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[I>>0]|0)!=50)continue a;f[c>>2]=I+1;H=77}if((H|0)==77){H=0;I=f[k>>2]|0;B=I&-2;if(!(I&1))ka=B;else ka=f[B+4>>2]|0;B=f[t>>2]|0;if((B|0)==497760){dya(t,ka,497760);la=f[t>>2]|0}else la=B;if(!(fqb(c,la)|0)){M=0;H=105;break a}B=f[v>>2]|0;I=b[B+11>>0]|0;if(I<<24>>24<0){ma=f[B>>2]|0;na=f[B+4>>2]|0}else{ma=B;na=I&255}if(!(gqb(ma,na,0,389313)|0)){M=0;H=105;break a}I=f[g>>2]|0;B=f[c>>2]|0;A=B;if((I-B|0)<=1)continue a;if((b[A>>0]|0)!=-128)continue a;if((b[A+1>>0]|0)!=1)continue a;B=A+2|0;f[c>>2]=B;U=B;V=I}if(U>>>0<V>>>0?(I=b[U>>0]|0,I<<24>>24>-1):0){B=U+1|0;f[c>>2]=B;oa=I<<24>>24!=0;pa=B;qa=V}else{Lnb(e,c);B=e;if(!(b[z>>0]|0)){M=0;H=105;break a}oa=(f[B>>2]|0)!=0|(f[B+4>>2]|0)!=0;pa=f[c>>2]|0;qa=f[g>>2]|0}b[w>>0]=oa&1;if((pa|0)!=(qa|0))continue a;if(f[a>>2]|0){H=101;break a}if((f[x>>2]|0)==(f[y>>2]|0)){H=101;break a}else continue a}while(0);if((H|0)==102){H=0;if(!L){M=1;H=105;break}else N=L}if((N&7|0)==4){M=1;H=105;break}if(!(Lpb(c,N)|0)){M=0;H=105;break}}if((H|0)==101){f[i>>2]=0;b[c+24>>0]=1;M=1;u=d;return M|0}else if((H|0)==105){u=d;return M|0}return 0}function vJa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;c=f[a+8>>2]|0;d=b[c+11>>0]|0;e=d<<24>>24<0;if(e)g=f[c+4>>2]|0;else g=d&255;if(!g)h=0;else{if(e){e=f[c+4>>2]|0;if(e>>>0<128){i=1;j=e}else{i=iob(e)|0;j=e}}else{i=1;j=d&255}h=j+1+i|0}i=f[a+12>>2]|0;j=b[i+11>>0]|0;d=j<<24>>24<0;if(d)k=f[i+4>>2]|0;else k=j&255;if(!k)l=h;else{if(d){d=f[i+4>>2]|0;if(d>>>0<128){m=1;n=d}else{m=iob(d)|0;n=d}}else{m=1;n=j&255}l=h+1+n+m|0}m=f[a+28>>2]|0;if(!m)o=l;else{if((m|0)>=0)if(m>>>0<128)p=2;else p=(iob(m)|0)+1|0;else p=11;o=p+l|0}l=f[a+16>>2]|0;p=b[l+11>>0]|0;m=p<<24>>24<0;if(m)q=f[l+4>>2]|0;else q=p&255;if(!q)r=o;else{if(m){m=f[l+4>>2]|0;if(m>>>0<128){s=1;t=m}else{s=iob(m)|0;t=m}}else{s=1;t=p&255}r=o+1+t+s|0}s=f[a+20>>2]|0;t=b[s+11>>0]|0;o=t<<24>>24<0;if(o)u=f[s+4>>2]|0;else u=t&255;if(!u)v=r;else{if(o){o=f[s+4>>2]|0;if(o>>>0<128){w=1;x=o}else{w=iob(o)|0;x=o}}else{w=1;x=t&255}v=r+1+x+w|0}w=f[a+24>>2]|0;x=b[w+11>>0]|0;r=x<<24>>24<0;if(r)y=f[w+4>>2]|0;else y=x&255;if(!y){z=v;A=a+32|0;B=b[A>>0]|0;C=B<<24>>24!=0;D=z+3|0;E=C?D:z;F=a+36|0;f[F>>2]=E;return E|0}if(r){r=f[w+4>>2]|0;if(r>>>0<128){G=1;H=r}else{G=iob(r)|0;H=r}}else{G=1;H=x&255}z=v+1+H+G|0;A=a+32|0;B=b[A>>0]|0;C=B<<24>>24!=0;D=z+3|0;E=C?D:z;F=a+36|0;f[F>>2]=E;return E|0}function wJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=a+8|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}gqb(j,k,1,389178)|0;$pb(1,f[d>>2]|0,c)}d=a+12|0;k=f[d>>2]|0;j=b[k+11>>0]|0;g=j<<24>>24<0;if(g)l=f[k+4>>2]|0;else l=j&255;if(l|0){if(g){m=f[k>>2]|0;n=f[k+4>>2]|0}else{m=k;n=j&255}gqb(m,n,1,389207)|0;$pb(2,f[d>>2]|0,c)}d=f[a+28>>2]|0;if(d|0)Zpb(3,d,c);d=a+16|0;n=f[d>>2]|0;m=b[n+11>>0]|0;j=m<<24>>24<0;if(j)o=f[n+4>>2]|0;else o=m&255;if(o|0){if(j){p=f[n>>2]|0;q=f[n+4>>2]|0}else{p=n;q=m&255}gqb(p,q,1,389243)|0;$pb(4,f[d>>2]|0,c)}d=a+20|0;q=f[d>>2]|0;p=b[q+11>>0]|0;m=p<<24>>24<0;if(m)r=f[q+4>>2]|0;else r=p&255;if(r|0){if(m){s=f[q>>2]|0;t=f[q+4>>2]|0}else{s=q;t=p&255}gqb(s,t,1,389277)|0;$pb(5,f[d>>2]|0,c)}d=a+24|0;t=f[d>>2]|0;s=b[t+11>>0]|0;p=s<<24>>24<0;if(p)u=f[t+4>>2]|0;else u=s&255;if(u|0){if(p){v=f[t>>2]|0;w=f[t+4>>2]|0}else{v=t;w=s&255}gqb(v,w,1,389313)|0;$pb(6,f[d>>2]|0,c)}if(!(b[a+32>>0]|0))return;Ypb(16,1,c);return}function xJa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function yJa(a){a=a|0;return f[a+36>>2]|0}function zJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;c=a+8|0;e=f[c>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(!i)j=d;else{if(h){k=f[e>>2]|0;l=f[e+4>>2]|0}else{k=e;l=g&255}gqb(k,l,1,389178)|0;l=f[c>>2]|0;b[d>>0]=10;j=kob(l,d+1|0)|0}d=a+12|0;l=f[d>>2]|0;c=b[l+11>>0]|0;k=c<<24>>24<0;if(k)m=f[l+4>>2]|0;else m=c&255;if(!m)n=j;else{if(k){o=f[l>>2]|0;p=f[l+4>>2]|0}else{o=l;p=c&255}gqb(o,p,1,389207)|0;p=f[d>>2]|0;b[j>>0]=18;n=kob(p,j+1|0)|0}j=f[a+28>>2]|0;do if(!j)q=n;else{b[n>>0]=24;p=n+1|0;if((j|0)<0){q=hob(j,((j|0)<0)<<31>>31,p)|0;break}if(j>>>0>127){d=j;o=p;while(1){b[o>>0]=d|128;c=d>>>7;l=o+1|0;if(d>>>0>16383){d=c;o=l}else{r=l;s=c;break}}}else{r=p;s=j}b[r>>0]=s;q=r+1|0}while(0);r=a+16|0;s=f[r>>2]|0;j=b[s+11>>0]|0;n=j<<24>>24<0;if(n)t=f[s+4>>2]|0;else t=j&255;if(!t)u=q;else{if(n){v=f[s>>2]|0;w=f[s+4>>2]|0}else{v=s;w=j&255}gqb(v,w,1,389243)|0;w=f[r>>2]|0;b[q>>0]=34;u=kob(w,q+1|0)|0}q=a+20|0;w=f[q>>2]|0;r=b[w+11>>0]|0;v=r<<24>>24<0;if(v)x=f[w+4>>2]|0;else x=r&255;if(!x)y=u;else{if(v){z=f[w>>2]|0;A=f[w+4>>2]|0}else{z=w;A=r&255}gqb(z,A,1,389277)|0;A=f[q>>2]|0;b[u>>0]=42;y=kob(A,u+1|0)|0}u=a+24|0;A=f[u>>2]|0;q=b[A+11>>0]|0;z=q<<24>>24<0;if(z)B=f[A+4>>2]|0;else B=q&255;if(!B)C=y;else{if(z){D=f[A>>2]|0;E=f[A+4>>2]|0}else{D=A;E=q&255}gqb(D,E,1,389313)|0;E=f[u>>2]|0;b[y>>0]=50;C=kob(E,y+1|0)|0}if(!(b[a+32>>0]|0)){F=C;return F|0}b[C>>0]=-128;b[C+1>>0]=1;b[C+2>>0]=1;F=C+3|0;return F|0}function AJa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function BJa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))$Ja(738);c=T6b(b,23288,18680,0)|0;if(!c){cOb(b,a);return}else{pKa(a,c);return}}function CJa(a,b){a=a|0;b=b|0;f[a+36>>2]=b;return}function DJa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213017]|0)!=2){f[d>>2]=135812;f[d+4>>2]=35;b[d+8>>0]=0;Gpb(852068,d);hpb(d)}f[a>>2]=f[213018];f[a+4>>2]=f[213019];u=c;return}function EJa(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+48|0;c=a+24|0;d=a;e=a+36|0;if((f[213016]|0)!=2){f[c>>2]=135812;f[c+4>>2]=36;b[c+8>>0]=0;Gpb(852064,c);hpb(c)}g=drb()|0;h=L5b(16)|0;f[c>>2]=h;f[c+8>>2]=-2147483632;f[c+4>>2]=12;i=h;j=387864;k=i+12|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+12>>0]=0;h=hrb(g,c)|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if(!h){zpb(d,3,387877,49);xpb(e,vpb(d,459532)|0);Apb(d)}d=h+40|0;h=f[d>>2]|0;f[213020]=h;e=pIb(h,492736,108736,-1,-1,-1,80,4,-1)|0;f[213021]=e;e=f[(f[213020]|0)+44>>2]|0;f[213018]=e;h=pIb(e,492824,108780,-1,-1,-1,40,4,-1)|0;f[213019]=h;h=(f[(f[213020]|0)+44>>2]|0)+88|0;f[213022]=h;e=pIb(h,492872,108808,-1,-1,-1,48,4,-1)|0;f[213023]=e;e=(f[d>>2]|0)+88|0;f[213024]=e;h=pIb(e,492928,108836,-1,-1,-1,20,4,-1)|0;f[213025]=h;h=(f[d>>2]|0)+176|0;f[213026]=h;d=pIb(h,492960,108844,-1,-1,-1,28,4,-1)|0;f[213027]=d;u=a;return}function FJa(){var a=0,c=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,387877);if((f[213015]|0)!=2){f[c>>2]=135812;f[c+4>>2]=37;b[c+8>>0]=0;Gpb(852060,c);hpb(c)}grb(387958,906);SNb(387864,1500);dHa();kJa();spb(38);u=a;return}function GJa(){var a=0,c=0,d=0,e=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,387877);eHa();lJa();if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123184]=108856;d=492740;e=d+52|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[123198]=497760;f[123199]=497760;f[123200]=497760;f[123201]=0;f[123202]=0;f[123203]=0;b[492816]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123206]=108636;f[123207]=0;f[123208]=497760;f[123209]=497760;f[123210]=497760;f[123211]=497760;f[123212]=497760;f[123213]=0;b[492856]=0;f[123215]=0;b[492864]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123218]=108964;f[123219]=0;f[123220]=497760;f[123221]=497760;f[123222]=497760;f[123223]=0;f[123224]=0;f[123226]=0;f[123227]=0;b[492912]=0;f[123229]=0;b[492920]=1;if((f[213345]|0)==2){f[123232]=109072;f[123233]=0;f[123234]=497760;f[123235]=0;f[123236]=0;b[492952]=1;f[123240]=109180;f[123241]=0;f[123242]=0;f[123243]=0;f[123244]=0;f[123245]=0;f[123246]=0;b[492992]=1;f[123201]=492928;f[123223]=492240;f[123224]=492240;u=a;return}f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c);f[123232]=109072;f[123233]=0;f[123234]=497760;f[123235]=0;f[123236]=0;b[492952]=1;f[123240]=109180;f[123241]=0;f[123242]=0;f[123243]=0;f[123244]=0;f[123245]=0;f[123246]=0;b[492992]=1;f[123201]=492928;f[123223]=492240;f[123224]=492240;u=a;return}function HJa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[213017]|0)!=2){f[c>>2]=135812;f[c+4>>2]=35;b[c+8>>0]=0;Gpb(852068,c);hpb(c)}WNb(f[213020]|0,492736);WNb(f[213018]|0,492824);WNb(f[213022]|0,492872);WNb(f[213024]|0,492928);WNb(f[213026]|0,492960);u=a;return}function IJa(){var a=0;if(b[492816]|0){b[492816]=0;bi[f[f[123184]>>2]&2047](492736)}a=f[213021]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[492864]|0){b[492864]=0;bi[f[f[123206]>>2]&2047](492824)}a=f[213019]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[492920]|0){b[492920]=0;bi[f[f[123218]>>2]&2047](492872)}a=f[213023]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[492952]|0){b[492952]=0;bi[f[f[123232]>>2]&2047](492928)}a=f[213025]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[492992]|0){b[492992]=0;bi[f[f[123240]>>2]&2047](492960)}a=f[213027]|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function JJa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=109180;b=a+20|0;c=f[b>>2]|0;if(c|0?(f[a+8>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(h);f[b>>2]=0;return}function KJa(a){a=a|0;JJa(a);O5b(a);return}function LJa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function MJa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){a=L5b(28)|0;vKa(a);c=a;return c|0}else{a=b;d=znb(b,18696,28)|0;f[d>>2]=109180;f[d+4>>2]=a;f[d+8>>2]=a;a=d+12|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;c=d;return c|0}return 0}function NJa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function OJa(a){a=a|0;return f[a+4>>2]|0}function PJa(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+12|0;c=f[b>>2]|0;if((c|0)<=0)return;d=f[a+20>>2]|0;a=0;do{e=f[d+4+(a<<2)>>2]|0;a=a+1|0;bi[f[(f[e>>2]|0)+28>>2]&2047](e)}while((a|0)!=(c|0));f[b>>2]=0;return}function QJa(a){a=a|0;return 1}function RJa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=c+4|0;e=c+20|0;g=c+44|0;h=a+8|0;i=a+20|0;j=a+16|0;k=a+12|0;a=c+32|0;l=c+12|0;m=c+28|0;a:while(1){n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){o=b[n>>0]|0;p=o&255;if(o<<24>>24>0){f[e>>2]=p;f[c>>2]=n+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=_nb(c,s)|0;f[e>>2]=p;if((p+-1|0)>>>0<127){q=p;r=6}else t=p}if((r|0)==6){r=0;if((q|0)==10){p=f[g>>2]|0;f[g>>2]=p+-1;if((p|0)<=0){u=0;r=26;break}while(1){p=f[i>>2]|0;do if(p){n=f[k>>2]|0;o=f[p>>2]|0;if((n|0)>=(o|0))if((o|0)==(f[j>>2]|0)){v=o;r=13;break}else{w=o;x=p;r=14;break}else{f[k>>2]=n+1;y=f[p+4+(n<<2)>>2]|0;break}}else{v=f[j>>2]|0;r=13}while(0);if((r|0)==13){r=0;cpb(h,v+1|0);p=f[i>>2]|0;w=f[p>>2]|0;x=p;r=14}if((r|0)==14){r=0;f[x>>2]=w+1;p=cKa(0,f[h>>2]|0)|0;n=f[i>>2]|0;o=f[k>>2]|0;f[k>>2]=o+1;f[n+4+(o<<2)>>2]=p;y=p}p=Jnb(c)|0;if(!(sKa(y,c)|0)){u=0;r=26;break a}if(!(Pnb(c,p)|0)){u=0;r=26;break a}z=f[c>>2]|0;A=f[d>>2]|0;if(z>>>0>=A>>>0)break;if((b[z>>0]|0)!=10)break;f[c>>2]=z+1}f[g>>2]=(f[g>>2]|0)+1;if((z|0)!=(A|0))continue;if(f[a>>2]|0){r=23;break}if((f[l>>2]|0)==(f[m>>2]|0)){r=23;break}else continue}else t=q}if((t|0)==0|(t&7|0)==4){u=1;r=26;break}if(!(Lpb(c,t)|0)){u=0;r=26;break}}if((r|0)==23){f[e>>2]=0;b[c+24>>0]=1;u=1;return u|0}else if((r|0)==26)return u|0;return 0}function SJa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a+12>>2]|0;if(!b){c=0;d=a+24|0;f[d>>2]=c;return c|0}e=a+20|0;g=0;h=b;while(1){i=qKa(f[(f[e>>2]|0)+4+(g<<2)>>2]|0)|0;if(i>>>0<128)j=1;else j=iob(i)|0;k=i+h+j|0;g=g+1|0;if((g|0)==(b|0)){c=k;break}else h=k}d=a+24|0;f[d>>2]=c;return c|0}function TJa(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[a+12>>2]|0;if(!c)return;d=a+20|0;a=0;do{eqb(1,f[(f[d>>2]|0)+4+(a<<2)>>2]|0,b);a=a+1|0}while((a|0)!=(c|0));return}function UJa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function VJa(a){a=a|0;return f[a+24>>2]|0}function WJa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[a+12>>2]|0;if(!c){e=d;return e|0}g=a+20|0;a=d;d=0;while(1){h=f[(f[g>>2]|0)+4+(d<<2)>>2]|0;b[a>>0]=10;i=a+1|0;j=f[h+76>>2]|0;if(j>>>0>127){k=j;l=i;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=i;p=j}b[o>>0]=p;l=li[f[(f[h>>2]|0)+68>>2]&511](h,0,o+1|0)|0;d=d+1|0;if((d|0)==(c|0)){e=l;break}else a=l}return e|0}function XJa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function YJa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))$Ja(3927);c=T6b(b,23288,18696,0)|0;if(!c){cOb(b,a);return}else{aKa(a+8|0,c+8|0);return}}function ZJa(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function _Ja(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213017]|0)!=2){f[d>>2]=135812;f[d+4>>2]=35;b[d+8>>0]=0;Gpb(852068,d);hpb(d)}f[a>>2]=f[213026];f[a+4>>2]=f[213027];u=c;return}function $Ja(a){a=a|0;Enb(387877,a)}function aKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{bKa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=cKa(h,i)|0;bKa(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function bKa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))$Ja(2162);else{eKa(b,a);return}}function cKa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){a=L5b(80)|0;dKa(a);c=a;return c|0}else{a=b;d=znb(b,18712,80)|0;f[d>>2]=108856;f[d+4>>2]=a;f[d+8>>2]=a;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=a;f[d+28>>2]=0;f[d+32>>2]=0;f[d+36>>2]=0;f[d+40>>2]=a;f[d+44>>2]=0;f[d+48>>2]=0;f[d+52>>2]=0;f[d+56>>2]=497760;f[d+60>>2]=497760;f[d+64>>2]=497760;f[d+68>>2]=0;f[d+72>>2]=0;f[d+76>>2]=0;c=d;return c|0}return 0}function dKa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=108856;e=(a|0)==492736;g=a+4|0;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[213015]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=37;b[d+8>>0]=0;Gpb(852060,d);hpb(d)}f[a+56>>2]=497760;f[a+60>>2]=497760;f[a+64>>2]=497760;f[a+68>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;u=c;return}function eKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;fKa(a+8|0,c+8|0);fKa(a+24|0,c+24|0);gKa(a+40|0,c+40|0);d=f[c+56>>2]|0;e=b[d+11>>0]|0;if(e<<24>>24<0)g=f[d+4>>2]|0;else g=e&255;do if(g|0){e=a+56|0;h=f[a+4>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==497760){dya(e,j,d);break}else{_5b(i,d)|0;break}}while(0);do if((c|0)!=492736?(d=c+68|0,j=f[d>>2]|0,j|0):0){g=a+68|0;i=f[g>>2]|0;if(!i){e=f[a+4>>2]|0;h=e&-2;if(!(e&1))k=h;else k=f[h+4>>2]|0;if(!k){h=L5b(20)|0;hKa(h);l=h}else{h=znb(k,18728,20)|0;f[h>>2]=109072;f[h+4>>2]=k;f[h+8>>2]=497760;f[h+12>>2]=0;f[h+16>>2]=0;l=h}f[g>>2]=l;m=f[d>>2]|0;n=l}else{m=j;n=i}i=(m|0)==0?492928:m;if((i|0)==(n|0))$Ja(3593);j=f[i+12>>2]|0;if(j|0)f[n+12>>2]=j;j=f[i+8>>2]|0;i=b[j+11>>0]|0;if(i<<24>>24<0)o=f[j+4>>2]|0;else o=i&255;if(o|0){i=n+8|0;d=f[n+4>>2]|0;g=d&-2;if(!(d&1))p=g;else p=f[g+4>>2]|0;g=f[i>>2]|0;if((g|0)==497760){dya(i,p,j);break}else{_5b(g,j)|0;break}}}while(0);p=f[c+60>>2]|0;n=b[p+11>>0]|0;if(n<<24>>24<0)q=f[p+4>>2]|0;else q=n&255;do if(q|0){n=a+60|0;o=f[a+4>>2]|0;m=o&-2;if(!(o&1))r=m;else r=f[m+4>>2]|0;m=f[n>>2]|0;if((m|0)==497760){dya(n,r,p);break}else{_5b(m,p)|0;break}}while(0);p=f[c+64>>2]|0;r=b[p+11>>0]|0;if(r<<24>>24<0)s=f[p+4>>2]|0;else s=r&255;do if(s|0){r=a+64|0;q=f[a+4>>2]|0;m=q&-2;if(!(q&1))t=m;else t=f[m+4>>2]|0;m=f[r>>2]|0;if((m|0)==497760){dya(r,t,p);break}else{_5b(m,p)|0;break}}while(0);if(b[c+72>>0]|0)b[a+72>>0]=1;if(b[c+73>>0]|0)b[a+73>>0]=1;if(b[c+74>>0]|0)b[a+74>>0]=1;if(!(b[c+75>>0]|0))return;b[a+75>>0]=1;return}function fKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{mKa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=nKa(h,i)|0;mKa(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function gKa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{iKa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=jKa(h,i)|0;iKa(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function hKa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=109072;f[a+4>>2]=0;if((a|0)!=492928?(f[213015]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=37;b[d+8>>0]=0;Gpb(852060,d);hpb(d)}f[a+8>>2]=497760;f[a+12>>2]=0;f[a+16>>2]=0;u=c;return}function iKa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))$Ja(1407);else{lKa(b,a);return}}function jKa(a,c){a=a|0;c=c|0;var d=0;if(!c){a=L5b(48)|0;kKa(a);d=a;return d|0}else{a=znb(c,18744,48)|0;f[a>>2]=108964;f[a+4>>2]=c;f[a+8>>2]=497760;f[a+12>>2]=497760;f[a+16>>2]=497760;f[a+20>>2]=0;f[a+24>>2]=0;c=a+32|0;f[c>>2]=0;f[c+4>>2]=0;b[c+8>>0]=0;f[a+44>>2]=0;d=a;return d|0}return 0}function kKa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=108964;f[a+4>>2]=0;if((a|0)!=492872?(f[213015]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=37;b[d+8>>0]=0;Gpb(852060,d);hpb(d)}f[a+8>>2]=497760;f[a+12>>2]=497760;f[a+16>>2]=497760;f[a+20>>2]=0;f[a+24>>2]=0;d=a+32|0;f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=0;f[a+44>>2]=0;u=c;return}function lKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c+8>>2]|0;e=b[d+11>>0]|0;if(e<<24>>24<0)g=f[d+4>>2]|0;else g=e&255;do if(g|0){e=a+8|0;h=f[a+4>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==497760){dya(e,j,d);break}else{_5b(i,d)|0;break}}while(0);d=f[c+12>>2]|0;j=b[d+11>>0]|0;if(j<<24>>24<0)k=f[d+4>>2]|0;else k=j&255;do if(k|0){j=a+12|0;g=f[a+4>>2]|0;i=g&-2;if(!(g&1))l=i;else l=f[i+4>>2]|0;i=f[j>>2]|0;if((i|0)==497760){dya(j,l,d);break}else{_5b(i,d)|0;break}}while(0);d=(c|0)==492872;if(!d?(l=c+20|0,k=f[l>>2]|0,k|0):0){i=a+20|0;j=f[i>>2]|0;if(!j){g=f[a+4>>2]|0;e=g&-2;if(!(g&1))m=e;else m=f[e+4>>2]|0;if(!m){e=L5b(24)|0;bHa(e);n=e}else{e=znb(m,18600,24)|0;gHa(e,m);n=e}f[i>>2]=n;o=f[l>>2]|0;p=n}else{o=k;p=j}iHa(p,(o|0)==0?492240:o)}o=f[c+16>>2]|0;p=b[o+11>>0]|0;if(p<<24>>24<0)q=f[o+4>>2]|0;else q=p&255;do if(q|0){p=a+16|0;j=f[a+4>>2]|0;k=j&-2;if(!(j&1))r=k;else r=f[k+4>>2]|0;k=f[p>>2]|0;if((k|0)==497760){dya(p,r,o);break}else{_5b(k,o)|0;break}}while(0);if(b[c+40>>0]|0)b[a+40>>0]=1;o=c+32|0;r=f[o>>2]|0;q=f[o+4>>2]|0;if(!((r|0)==0&(q|0)==0)){o=a+32|0;f[o>>2]=r;f[o+4>>2]=q}if(d)return;d=c+24|0;c=f[d>>2]|0;if(!c)return;q=a+24|0;o=f[q>>2]|0;if(!o){r=f[a+4>>2]|0;a=r&-2;if(!(r&1))s=a;else s=f[a+4>>2]|0;if(!s){a=L5b(24)|0;bHa(a);t=a}else{a=znb(s,18600,24)|0;gHa(a,s);t=a}f[q>>2]=t;u=f[d>>2]|0;v=t}else{u=c;v=o}iHa(v,(u|0)==0?492240:u);return}function mKa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))$Ja(756);else{pKa(b,a);return}}function nKa(a,c){a=a|0;c=c|0;var d=0;if(!c){a=L5b(40)|0;oKa(a);d=a;return d|0}else{a=znb(c,18680,40)|0;f[a>>2]=108636;f[a+4>>2]=c;f[a+8>>2]=497760;f[a+12>>2]=497760;f[a+16>>2]=497760;f[a+20>>2]=497760;f[a+24>>2]=497760;c=a+28|0;f[c>>2]=0;b[c+4>>0]=0;f[a+36>>2]=0;d=a;return d|0}return 0}function oKa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=108636;f[a+4>>2]=0;if((a|0)!=492824?(f[213015]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=37;b[d+8>>0]=0;Gpb(852060,d);hpb(d)}f[a+8>>2]=497760;f[a+12>>2]=497760;f[a+16>>2]=497760;f[a+20>>2]=497760;f[a+24>>2]=497760;d=a+28|0;f[d>>2]=0;b[d+4>>0]=0;f[a+36>>2]=0;u=c;return}function pKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=f[c+8>>2]|0;e=b[d+11>>0]|0;if(e<<24>>24<0)g=f[d+4>>2]|0;else g=e&255;do if(g|0){e=a+8|0;h=f[a+4>>2]|0;i=h&-2;if(!(h&1))j=i;else j=f[i+4>>2]|0;i=f[e>>2]|0;if((i|0)==497760){dya(e,j,d);break}else{_5b(i,d)|0;break}}while(0);d=f[c+12>>2]|0;j=b[d+11>>0]|0;if(j<<24>>24<0)k=f[d+4>>2]|0;else k=j&255;do if(k|0){j=a+12|0;g=f[a+4>>2]|0;i=g&-2;if(!(g&1))l=i;else l=f[i+4>>2]|0;i=f[j>>2]|0;if((i|0)==497760){dya(j,l,d);break}else{_5b(i,d)|0;break}}while(0);d=f[c+28>>2]|0;if(d|0)f[a+28>>2]=d;d=f[c+16>>2]|0;l=b[d+11>>0]|0;if(l<<24>>24<0)m=f[d+4>>2]|0;else m=l&255;do if(m|0){l=a+16|0;k=f[a+4>>2]|0;i=k&-2;if(!(k&1))n=i;else n=f[i+4>>2]|0;i=f[l>>2]|0;if((i|0)==497760){dya(l,n,d);break}else{_5b(i,d)|0;break}}while(0);d=f[c+20>>2]|0;n=b[d+11>>0]|0;if(n<<24>>24<0)o=f[d+4>>2]|0;else o=n&255;do if(o|0){n=a+20|0;m=f[a+4>>2]|0;i=m&-2;if(!(m&1))p=i;else p=f[i+4>>2]|0;i=f[n>>2]|0;if((i|0)==497760){dya(n,p,d);break}else{_5b(i,d)|0;break}}while(0);d=f[c+24>>2]|0;p=b[d+11>>0]|0;if(p<<24>>24<0)q=f[d+4>>2]|0;else q=p&255;do if(q|0){p=a+24|0;o=f[a+4>>2]|0;i=o&-2;if(!(o&1))r=i;else r=f[i+4>>2]|0;i=f[p>>2]|0;if((i|0)==497760){dya(p,r,d);break}else{_5b(i,d)|0;break}}while(0);if(!(b[c+32>>0]|0))return;b[a+32>>0]=1;return}function qKa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;c=f[a+56>>2]|0;d=b[c+11>>0]|0;e=d<<24>>24<0;if(e)g=f[c+4>>2]|0;else g=d&255;if(!g)h=0;else{if(e){e=f[c+4>>2]|0;if(e>>>0<128){i=1;j=e}else{i=iob(e)|0;j=e}}else{i=1;j=d&255}h=j+1+i|0}if((a|0)!=492736?(i=f[a+68>>2]|0,(i|0)!=0):0){j=f[i+12>>2]|0;if(j)if((j|0)>=0)if(j>>>0<128)k=2;else k=(iob(j)|0)+1|0;else k=11;else k=0;j=f[i+8>>2]|0;d=b[j+11>>0]|0;e=d<<24>>24<0;if(e)l=f[j+4>>2]|0;else l=d&255;if(!l)m=k;else{if(e){e=f[j+4>>2]|0;if(e>>>0<128){n=1;o=e}else{n=iob(e)|0;o=e}}else{n=1;o=d&255}m=k+1+o+n|0}f[i+16>>2]=m;if(m>>>0<128)p=1;else p=iob(m)|0;q=h+1+m+p|0}else q=h;h=f[a+60>>2]|0;p=b[h+11>>0]|0;m=p<<24>>24<0;if(m)r=f[h+4>>2]|0;else r=p&255;if(!r)s=q;else{if(m){m=f[h+4>>2]|0;if(m>>>0<128){t=1;u=m}else{t=iob(m)|0;u=m}}else{t=1;u=p&255}s=q+1+u+t|0}t=f[a+64>>2]|0;u=b[t+11>>0]|0;q=u<<24>>24<0;if(q)v=f[t+4>>2]|0;else v=u&255;if(!v)w=s;else{if(q){q=f[t+4>>2]|0;if(q>>>0<128){x=1;y=q}else{x=iob(q)|0;y=q}}else{x=1;y=u&255}w=s+1+y+x|0}x=b[a+72>>0]|0?w+3|0:w;w=b[a+73>>0]|0?x+3|0:x;x=b[a+74>>0]|0?w+3|0:w;w=f[a+12>>2]|0;y=(b[a+75>>0]|0?x+3|0:x)+w|0;if(!w)z=y;else{x=a+20|0;s=0;u=y;while(1){y=vJa(f[(f[x>>2]|0)+4+(s<<2)>>2]|0)|0;if(y>>>0<128)A=1;else A=iob(y)|0;q=y+u+A|0;s=s+1|0;if((s|0)==(w|0)){z=q;break}else u=q}}u=f[a+28>>2]|0;w=u+z|0;if(!u)B=w;else{z=a+36|0;s=0;A=w;while(1){w=vJa(f[(f[z>>2]|0)+4+(s<<2)>>2]|0)|0;if(w>>>0<128)C=1;else C=iob(w)|0;x=w+A+C|0;s=s+1|0;if((s|0)==(u|0)){B=x;break}else A=x}}A=f[a+44>>2]|0;u=A+B|0;if(!A){D=u;E=a+76|0;f[E>>2]=D;return D|0}B=a+52|0;s=0;C=u;while(1){u=rKa(f[(f[B>>2]|0)+4+(s<<2)>>2]|0)|0;if(u>>>0<128)F=1;else F=iob(u)|0;z=u+C+F|0;s=s+1|0;if((s|0)==(A|0)){D=z;break}else C=z}E=a+76|0;f[E>>2]=D;return D|0}function rKa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=f[a+8>>2]|0;d=b[c+11>>0]|0;e=d<<24>>24<0;if(e)g=f[c+4>>2]|0;else g=d&255;if(!g)h=0;else{if(e){e=f[c+4>>2]|0;if(e>>>0<128){i=1;j=e}else{i=iob(e)|0;j=e}}else{i=1;j=d&255}h=j+1+i|0}i=f[a+12>>2]|0;j=b[i+11>>0]|0;d=j<<24>>24<0;if(d)k=f[i+4>>2]|0;else k=j&255;if(!k)l=h;else{if(d){d=f[i+4>>2]|0;if(d>>>0<128){m=1;n=d}else{m=iob(d)|0;n=d}}else{m=1;n=j&255}l=h+1+n+m|0}m=(a|0)==492872;if(!m?(n=f[a+20>>2]|0,(n|0)!=0):0){h=zGa(n)|0;if(h>>>0<128)o=1;else o=iob(h)|0;p=l+1+h+o|0}else p=l;l=f[a+16>>2]|0;o=b[l+11>>0]|0;h=o<<24>>24<0;if(h)q=f[l+4>>2]|0;else q=o&255;if(!q)r=p;else{if(h){h=f[l+4>>2]|0;if(h>>>0<128){s=1;t=h}else{s=iob(h)|0;t=h}}else{s=1;t=o&255}r=p+1+t+s|0}s=b[a+40>>0]|0?r+2|0:r;r=a+32|0;t=f[r>>2]|0;p=f[r+4>>2]|0;if((t|0)==0&(p|0)==0)u=s;else u=s+1+(job(t,p)|0)|0;if(m){v=u;w=a+44|0;f[w>>2]=v;return v|0}m=f[a+24>>2]|0;if(!m){v=u;w=a+44|0;f[w>>2]=v;return v|0}p=zGa(m)|0;if(p>>>0<128)x=1;else x=iob(p)|0;v=u+1+p+x|0;w=a+44|0;f[w>>2]=v;return v|0}function sKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+56|0;k=a+4|0;l=a+56|0;m=c+44|0;n=a+8|0;o=a+20|0;p=a+16|0;q=a+12|0;r=a+24|0;s=a+36|0;t=a+32|0;v=a+28|0;w=a+40|0;x=a+52|0;y=a+48|0;z=a+44|0;A=a+60|0;B=a+60|0;C=a+64|0;D=a+64|0;E=a+68|0;F=e+4|0;G=a+73|0;H=e+8|0;I=a+74|0;J=e+8|0;K=a+72|0;L=e+8|0;M=a+75|0;a=c+32|0;N=c+12|0;O=c+28|0;P=e+8|0;a:while(1){Q=f[c>>2]|0;R=f[g>>2]|0;do if(Q>>>0<R>>>0){S=b[Q>>0]|0;T=S&255;if(S<<24>>24>0){U=T;V=1}else{S=Q+1|0;if(S>>>0>=R>>>0){W=T;X=7;break}Y=h[S>>0]|0;if(((Y^128)&T)>>>0<=127){W=T;X=7;break}U=T+-128+(Y<<7)|0;V=2}f[i>>2]=U;f[c>>2]=Q+V;Z=U;X=9}else{W=0;X=7}while(0);if((X|0)==7){X=0;Q=_nb(c,W)|0;f[i>>2]=Q;if((Q+-1|0)>>>0<16383){Z=Q;X=9}else{_=Q;X=166}}b:do if((X|0)==9){X=0;do switch(Z>>>3&536870911|0){case 1:{switch(Z|0){case 0:{$=1;X=169;break a;break}case 10:break;default:{aa=Z;break b}}Q=f[k>>2]|0;R=Q&-2;if(!(Q&1))ba=R;else ba=f[R+4>>2]|0;R=f[j>>2]|0;if((R|0)==497760){dya(j,ba,497760);ca=f[j>>2]|0}else ca=R;if(!(fqb(c,ca)|0)){$=0;X=169;break a}R=f[l>>2]|0;Q=b[R+11>>0]|0;if(Q<<24>>24<0){da=f[R>>2]|0;ea=f[R+4>>2]|0}else{da=R;ea=Q&255}if(!(gqb(da,ea,0,388946)|0)){$=0;X=169;break a}Q=f[c>>2]|0;if(Q>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[Q>>0]|0)!=18)continue a;f[c>>2]=Q+1;X=25;break}case 2:{switch(Z|0){case 0:{$=1;X=169;break a;break}case 18:{X=25;break}default:{aa=Z;break b}}break}case 3:{switch(Z|0){case 0:{$=1;X=169;break a;break}case 26:break;default:{aa=Z;break b}}Q=f[m>>2]|0;f[m>>2]=Q+-1;if((Q|0)>0)X=43;else{$=0;X=169;break a}break}case 4:{switch(Z|0){case 0:{$=1;X=169;break a;break}case 34:break;default:{aa=Z;break b}}Q=f[m>>2]|0;f[m>>2]=Q+-1;if((Q|0)>0)X=59;else{$=0;X=169;break a}break}case 5:{switch(Z|0){case 0:{$=1;X=169;break a;break}case 42:{X=74;break}default:{aa=Z;break b}}break}case 6:{switch(Z|0){case 0:{$=1;X=169;break a;break}case 50:{X=88;break}default:{aa=Z;break b}}break}case 8:{switch(Z|0){case 0:{$=1;X=169;break a;break}case 66:{X=102;break}default:{aa=Z;break b}}break}case 16:{switch(Z|0){case 0:{$=1;X=169;break a;break}case 128:break;default:{aa=Z;break b}}Q=f[g>>2]|0;fa=f[c>>2]|0;ga=Q;ha=Q;X=124;break}case 17:{switch(Z|0){case 0:{$=1;X=169;break a;break}case 136:break;default:{aa=Z;break b}}Q=f[g>>2]|0;ia=f[c>>2]|0;ja=Q;ka=Q;X=135;break}case 18:{switch(Z|0){case 0:{$=1;X=169;break a;break}case 144:break;default:{aa=Z;break b}}Q=f[g>>2]|0;la=f[c>>2]|0;ma=Q;na=Q;X=146;break}case 19:{switch(Z|0){case 0:{$=1;X=169;break a;break}case 152:break;default:{aa=Z;break b}}oa=f[c>>2]|0;pa=f[g>>2]|0;X=157;break}default:{_=Z;X=166;break b}}while(0);do if((X|0)==25){X=0;Q=f[m>>2]|0;f[m>>2]=Q+-1;if((Q|0)<=0){$=0;X=169;break a}while(1){Q=f[o>>2]|0;do if(Q){R=f[q>>2]|0;Y=f[Q>>2]|0;if((R|0)>=(Y|0))if((Y|0)==(f[p>>2]|0)){qa=Y;X=31;break}else{ra=Y;sa=Q;X=32;break}else{f[q>>2]=R+1;ta=f[Q+4+(R<<2)>>2]|0;break}}else{qa=f[p>>2]|0;X=31}while(0);if((X|0)==31){X=0;cpb(n,qa+1|0);Q=f[o>>2]|0;ra=f[Q>>2]|0;sa=Q;X=32}if((X|0)==32){X=0;f[sa>>2]=ra+1;Q=nKa(0,f[n>>2]|0)|0;R=f[o>>2]|0;Y=f[q>>2]|0;f[q>>2]=Y+1;f[R+4+(Y<<2)>>2]=Q;ta=Q}Q=Jnb(c)|0;if(!(uJa(ta,c)|0)){$=0;X=169;break a}if(!(Pnb(c,Q)|0)){$=0;X=169;break a}ua=f[c>>2]|0;if(ua>>>0>=(f[g>>2]|0)>>>0)break;if((b[ua>>0]|0)!=18){X=38;break}f[c>>2]=ua+1}if((X|0)==38?(X=0,(b[ua>>0]|0)==26):0){va=ua;X=42;break}f[m>>2]=(f[m>>2]|0)+1;continue a}while(0);c:while(1){switch(X|0){case 42:{X=0;f[c>>2]=va+1;X=43;continue c;break}case 43:{X=0;Q=f[s>>2]|0;do if(Q){Y=f[v>>2]|0;R=f[Q>>2]|0;if((Y|0)>=(R|0))if((R|0)==(f[t>>2]|0)){wa=R;X=48;break}else{xa=R;ya=Q;X=49;break}else{f[v>>2]=Y+1;za=f[Q+4+(Y<<2)>>2]|0;break}}else{wa=f[t>>2]|0;X=48}while(0);if((X|0)==48){X=0;cpb(r,wa+1|0);Q=f[s>>2]|0;xa=f[Q>>2]|0;ya=Q;X=49}if((X|0)==49){X=0;f[ya>>2]=xa+1;Q=nKa(0,f[r>>2]|0)|0;Y=f[s>>2]|0;R=f[v>>2]|0;f[v>>2]=R+1;f[Y+4+(R<<2)>>2]=Q;za=Q}Q=Jnb(c)|0;if(!(uJa(za,c)|0)){$=0;X=169;break a}if(!(Pnb(c,Q)|0)){$=0;X=169;break a}Q=f[c>>2]|0;if(Q>>>0>=(f[g>>2]|0)>>>0){X=55;break c}if((b[Q>>0]|0)==26){va=Q;X=42;continue c}if((b[Q>>0]|0)==34)Aa=Q;else{X=55;break c}break}case 59:{X=0;Q=f[x>>2]|0;do if(Q){R=f[z>>2]|0;Y=f[Q>>2]|0;if((R|0)>=(Y|0))if((Y|0)==(f[y>>2]|0)){Ba=Y;X=64;break}else{Ca=Y;Da=Q;X=65;break}else{f[z>>2]=R+1;Ea=f[Q+4+(R<<2)>>2]|0;break}}else{Ba=f[y>>2]|0;X=64}while(0);if((X|0)==64){X=0;cpb(w,Ba+1|0);Q=f[x>>2]|0;Ca=f[Q>>2]|0;Da=Q;X=65}if((X|0)==65){X=0;f[Da>>2]=Ca+1;Q=jKa(0,f[w>>2]|0)|0;R=f[x>>2]|0;Y=f[z>>2]|0;f[z>>2]=Y+1;f[R+4+(Y<<2)>>2]=Q;Ea=Q}Q=Jnb(c)|0;if(!(tKa(Ea,c)|0)){$=0;X=169;break a}if(!(Pnb(c,Q)|0)){$=0;X=169;break a}Q=f[c>>2]|0;if(Q>>>0>=(f[g>>2]|0)>>>0){X=69;break c}if((b[Q>>0]|0)==34)Aa=Q;else{f[m>>2]=(f[m>>2]|0)+1;if((b[Q>>0]|0)!=42)continue a;f[c>>2]=Q+1;X=74;continue c}break}case 74:{X=0;Q=f[k>>2]|0;Y=Q&-2;if(!(Q&1))Fa=Y;else Fa=f[Y+4>>2]|0;Y=f[A>>2]|0;if((Y|0)==497760){dya(A,Fa,497760);Ga=f[A>>2]|0}else Ga=Y;if(!(fqb(c,Ga)|0)){$=0;X=169;break a}Y=f[B>>2]|0;Q=b[Y+11>>0]|0;if(Q<<24>>24<0){Ha=f[Y>>2]|0;Ia=f[Y+4>>2]|0}else{Ha=Y;Ia=Q&255}if(!(gqb(Ha,Ia,0,388968)|0)){$=0;X=169;break a}Q=f[c>>2]|0;if(Q>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[Q>>0]|0)!=50)continue a;f[c>>2]=Q+1;X=88;continue c;break}case 88:{X=0;Q=f[k>>2]|0;Y=Q&-2;if(!(Q&1))Ja=Y;else Ja=f[Y+4>>2]|0;Y=f[C>>2]|0;if((Y|0)==497760){dya(C,Ja,497760);Ka=f[C>>2]|0}else Ka=Y;if(!(fqb(c,Ka)|0)){$=0;X=169;break a}Y=f[D>>2]|0;Q=b[Y+11>>0]|0;if(Q<<24>>24<0){La=f[Y>>2]|0;Ma=f[Y+4>>2]|0}else{La=Y;Ma=Q&255}if(!(gqb(La,Ma,0,388993)|0)){$=0;X=169;break a}Q=f[c>>2]|0;if(Q>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[Q>>0]|0)!=66)continue a;f[c>>2]=Q+1;X=102;continue c;break}case 102:{X=0;Q=f[E>>2]|0;if(!Q){Y=f[k>>2]|0;R=Y&-2;if(!(Y&1))Na=R;else Na=f[R+4>>2]|0;if(!Na){R=L5b(20)|0;hKa(R);Oa=R}else{R=znb(Na,18728,20)|0;f[R>>2]=109072;f[R+4>>2]=Na;f[R+8>>2]=497760;f[R+12>>2]=0;f[R+16>>2]=0;Oa=R}f[E>>2]=Oa;Pa=Oa}else Pa=Q;Q=f[c>>2]|0;if(Q>>>0<(f[g>>2]|0)>>>0?(R=b[Q>>0]|0,R<<24>>24>-1):0){f[c>>2]=Q+1;Qa=R&255}else{R=Znb(c)|0;if((R|0)>-1)Qa=R;else{$=0;X=169;break a}}Inb(e,c,Qa);if((f[F>>2]|0)<0){X=116;break a}if(!(uKa(Pa,c)|0)){X=116;break a}if(!(Onb(c,f[e>>2]|0)|0)){$=0;X=169;break a}R=f[g>>2]|0;Q=f[c>>2]|0;Y=Q;if((R-Q|0)<=1)continue a;if((b[Y>>0]|0)!=-128)continue a;if((b[Y+1>>0]|0)!=1)continue a;Q=Y+2|0;f[c>>2]=Q;fa=Q;ga=R;ha=R;X=124;continue c;break}case 124:{X=0;if(fa>>>0<ga>>>0?(R=b[fa>>0]|0,R<<24>>24>-1):0){Q=fa+1|0;f[c>>2]=Q;Ra=R<<24>>24!=0;Sa=Q;Ta=ha;Ua=ga}else{Lnb(e,c);Q=e;if(!(b[H>>0]|0)){$=0;X=169;break a}R=f[g>>2]|0;Ra=(f[Q>>2]|0)!=0|(f[Q+4>>2]|0)!=0;Sa=f[c>>2]|0;Ta=R;Ua=R}b[G>>0]=Ra&1;R=Sa;if((Ta-Sa|0)<=1)continue a;if((b[R>>0]|0)!=-120)continue a;if((b[R+1>>0]|0)!=1)continue a;Q=R+2|0;f[c>>2]=Q;ia=Q;ja=Ua;ka=Ta;X=135;continue c;break}case 135:{X=0;if(ia>>>0<ja>>>0?(Q=b[ia>>0]|0,Q<<24>>24>-1):0){R=ia+1|0;f[c>>2]=R;Va=Q<<24>>24!=0;Wa=R;Xa=ka;Ya=ja}else{Lnb(e,c);R=e;if(!(b[J>>0]|0)){$=0;X=169;break a}Q=f[g>>2]|0;Va=(f[R>>2]|0)!=0|(f[R+4>>2]|0)!=0;Wa=f[c>>2]|0;Xa=Q;Ya=Q}b[I>>0]=Va&1;Q=Wa;if((Xa-Wa|0)<=1)continue a;if((b[Q>>0]|0)!=-112)continue a;if((b[Q+1>>0]|0)!=1)continue a;R=Q+2|0;f[c>>2]=R;la=R;ma=Ya;na=Xa;X=146;continue c;break}case 146:{X=0;if(la>>>0<ma>>>0?(R=b[la>>0]|0,R<<24>>24>-1):0){Q=la+1|0;f[c>>2]=Q;Za=R<<24>>24!=0;_a=Q;$a=na;ab=ma}else{Lnb(e,c);Q=e;if(!(b[L>>0]|0)){$=0;X=169;break a}R=f[g>>2]|0;Za=(f[Q>>2]|0)!=0|(f[Q+4>>2]|0)!=0;_a=f[c>>2]|0;$a=R;ab=R}b[K>>0]=Za&1;R=_a;if(($a-_a|0)<=1)continue a;if((b[R>>0]|0)!=-104)continue a;if((b[R+1>>0]|0)!=1)continue a;Q=R+2|0;f[c>>2]=Q;oa=Q;pa=ab;X=157;continue c;break}case 157:{X=0;if(oa>>>0<pa>>>0){X=158;break c}else{X=160;break c}break}}f[c>>2]=Aa+1;X=59}if((X|0)==55){X=0;f[m>>2]=(f[m>>2]|0)+1;continue a}else if((X|0)==69){X=0;f[m>>2]=(f[m>>2]|0)+1;continue a}else if((X|0)==158){X=0;Q=b[oa>>0]|0;if(Q<<24>>24>-1){R=oa+1|0;f[c>>2]=R;bb=Q<<24>>24!=0;cb=R;db=pa}else X=160}if((X|0)==160){X=0;Lnb(e,c);R=e;if(!(b[P>>0]|0)){$=0;X=169;break a}bb=(f[R>>2]|0)!=0|(f[R+4>>2]|0)!=0;cb=f[c>>2]|0;db=f[g>>2]|0}b[M>>0]=bb&1;if((cb|0)!=(db|0))continue a;if(f[a>>2]|0){X=165;break a}if((f[N>>2]|0)==(f[O>>2]|0)){X=165;break a}else continue a}while(0);if((X|0)==166){X=0;if(!_){$=1;X=169;break}else aa=_}if((aa&7|0)==4){$=1;X=169;break}if(!(Lpb(c,aa)|0)){$=0;X=169;break}}if((X|0)==116){$=0;u=d;return $|0}else if((X|0)==165){f[i>>2]=0;b[c+24>>0]=1;$=1;u=d;return $|0}else if((X|0)==169){u=d;return $|0}return 0}function tKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+4|0;k=a+8|0;l=a+12|0;m=a+12|0;n=a+20|0;o=e+4|0;p=a+16|0;q=a+16|0;r=a+40|0;s=e+8|0;t=a+32|0;v=e+8|0;w=a+24|0;a=e+4|0;x=c+32|0;y=c+12|0;z=c+28|0;a:while(1){A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){B=b[A>>0]|0;C=B&255;if(B<<24>>24>0){f[h>>2]=C;f[c>>2]=A+1;D=C;E=6}else{F=C;E=5}}else{F=0;E=5}if((E|0)==5){E=0;C=_nb(c,F)|0;f[h>>2]=C;if((C+-1|0)>>>0<127){D=C;E=6}else{G=C;E=110}}b:do if((E|0)==6){E=0;switch(D>>>3&536870911|0){case 1:{switch(D|0){case 0:{H=1;E=113;break a;break}case 10:break;default:{I=D;break b}}C=f[j>>2]|0;A=C&-2;if(!(C&1))J=A;else J=f[A+4>>2]|0;A=f[i>>2]|0;if((A|0)==497760){dya(i,J,497760);K=f[i>>2]|0}else K=A;if(!(fqb(c,K)|0)){H=0;E=113;break a}A=f[k>>2]|0;C=b[A+11>>0]|0;if(C<<24>>24<0){L=f[A>>2]|0;M=f[A+4>>2]|0}else{L=A;M=C&255}if(!(gqb(L,M,0,389059)|0)){H=0;E=113;break a}C=f[c>>2]|0;if(C>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[C>>0]|0)!=18)continue a;f[c>>2]=C+1;E=22;break}case 2:{switch(D|0){case 0:{H=1;E=113;break a;break}case 18:{E=22;break}default:{I=D;break b}}break}case 3:{switch(D|0){case 0:{H=1;E=113;break a;break}case 26:{E=36;break}default:{I=D;break b}}break}case 4:{switch(D|0){case 0:{H=1;E=113;break a;break}case 34:{E=56;break}default:{I=D;break b}}break}case 5:{switch(D|0){case 0:{H=1;E=113;break a;break}case 40:break;default:{I=D;break b}}N=f[c>>2]|0;O=f[g>>2]|0;E=71;break}case 6:{switch(D|0){case 0:{H=1;E=113;break a;break}case 48:break;default:{I=D;break b}}P=f[c>>2]|0;Q=f[g>>2]|0;E=81;break}case 7:{switch(D|0){case 0:{H=1;E=113;break a;break}case 58:break;default:{I=D;break b}}break}default:{G=D;E=110;break b}}if((E|0)==22){E=0;C=f[j>>2]|0;A=C&-2;if(!(C&1))R=A;else R=f[A+4>>2]|0;A=f[l>>2]|0;if((A|0)==497760){dya(l,R,497760);S=f[l>>2]|0}else S=A;if(!(fqb(c,S)|0)){H=0;E=113;break a}A=f[m>>2]|0;C=b[A+11>>0]|0;if(C<<24>>24<0){T=f[A>>2]|0;U=f[A+4>>2]|0}else{T=A;U=C&255}if(!(gqb(T,U,0,389089)|0)){H=0;E=113;break a}C=f[c>>2]|0;if(C>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[C>>0]|0)!=26)continue a;f[c>>2]=C+1;E=36}if((E|0)==36){E=0;C=f[n>>2]|0;if(!C){A=f[j>>2]|0;B=A&-2;if(!(A&1))V=B;else V=f[B+4>>2]|0;if(!V){B=L5b(24)|0;bHa(B);W=B}else{B=znb(V,18600,24)|0;gHa(B,V);W=B}f[n>>2]=W;X=W}else X=C;C=f[c>>2]|0;if(C>>>0<(f[g>>2]|0)>>>0?(B=b[C>>0]|0,B<<24>>24>-1):0){f[c>>2]=C+1;Y=B&255}else{B=Znb(c)|0;if((B|0)>-1)Y=B;else{H=0;E=113;break a}}Inb(e,c,Y);if((f[o>>2]|0)<0){E=50;break a}if(!(JGa(X,c)|0)){E=50;break a}if(!(Onb(c,f[e>>2]|0)|0)){H=0;E=113;break a}B=f[c>>2]|0;if(B>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[B>>0]|0)!=34)continue a;f[c>>2]=B+1;E=56}if((E|0)==56){E=0;B=f[j>>2]|0;C=B&-2;if(!(B&1))Z=C;else Z=f[C+4>>2]|0;C=f[p>>2]|0;if((C|0)==497760){dya(p,Z,497760);_=f[p>>2]|0}else _=C;if(!(fqb(c,_)|0)){H=0;E=113;break a}C=f[q>>2]|0;B=b[C+11>>0]|0;if(B<<24>>24<0){$=f[C>>2]|0;aa=f[C+4>>2]|0}else{$=C;aa=B&255}if(!(gqb($,aa,0,389119)|0)){H=0;E=113;break a}B=f[c>>2]|0;C=f[g>>2]|0;if(B>>>0>=C>>>0)continue a;if((b[B>>0]|0)!=40)continue a;A=B+1|0;f[c>>2]=A;N=A;O=C;E=71}if((E|0)==71){E=0;if(N>>>0<O>>>0?(C=b[N>>0]|0,C<<24>>24>-1):0){A=N+1|0;f[c>>2]=A;ba=C<<24>>24!=0;ca=A;da=O}else{Lnb(e,c);A=e;if(!(b[s>>0]|0)){H=0;E=113;break a}ba=(f[A>>2]|0)!=0|(f[A+4>>2]|0)!=0;ca=f[c>>2]|0;da=f[g>>2]|0}b[r>>0]=ba&1;if(ca>>>0>=da>>>0)continue a;if((b[ca>>0]|0)!=48)continue a;A=ca+1|0;f[c>>2]=A;P=A;Q=da;E=81}if((E|0)==81){E=0;if(P>>>0<Q>>>0?(A=b[P>>0]|0,A<<24>>24>-1):0){C=P+1|0;f[c>>2]=C;ea=A&255;fa=0;ga=C;ha=Q}else{Lnb(e,c);C=e;if(!(b[v>>0]|0)){H=0;E=113;break a}ea=f[C>>2]|0;fa=f[C+4>>2]|0;ga=f[c>>2]|0;ha=f[g>>2]|0}C=t;f[C>>2]=ea;f[C+4>>2]=fa;if(ga>>>0>=ha>>>0)continue a;if((b[ga>>0]|0)!=58)continue a;f[c>>2]=ga+1}C=f[w>>2]|0;if(!C){A=f[j>>2]|0;B=A&-2;if(!(A&1))ia=B;else ia=f[B+4>>2]|0;if(!ia){B=L5b(24)|0;bHa(B);ja=B}else{B=znb(ia,18600,24)|0;gHa(B,ia);ja=B}f[w>>2]=ja;ka=ja}else ka=C;C=f[c>>2]|0;if(C>>>0<(f[g>>2]|0)>>>0?(B=b[C>>0]|0,B<<24>>24>-1):0){f[c>>2]=C+1;la=B&255}else{B=Znb(c)|0;if((B|0)>-1)la=B;else{H=0;E=113;break a}}Inb(e,c,la);if((f[a>>2]|0)<0){E=104;break a}if(!(JGa(ka,c)|0)){E=104;break a}if(!(Onb(c,f[e>>2]|0)|0)){H=0;E=113;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[x>>2]|0){E=109;break a}if((f[y>>2]|0)==(f[z>>2]|0)){E=109;break a}else continue a}while(0);if((E|0)==110){E=0;if(!G){H=1;E=113;break}else I=G}if((I&7|0)==4){H=1;E=113;break}if(!(Lpb(c,I)|0)){H=0;E=113;break}}if((E|0)==50){H=0;u=d;return H|0}else if((E|0)==104){H=0;u=d;return H|0}else if((E|0)==109){f[h>>2]=0;b[c+24>>0]=1;H=1;u=d;return H|0}else if((E|0)==113){u=d;return H|0}return 0}function uKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=c+4|0;e=c+20|0;g=a+12|0;h=a+8|0;i=a+4|0;j=a+8|0;a=c+32|0;k=c+12|0;l=c+28|0;a:while(1){m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){n=b[m>>0]|0;o=n&255;if(n<<24>>24>0){f[e>>2]=o;f[c>>2]=m+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=_nb(c,r)|0;f[e>>2]=o;if((o+-1|0)>>>0<127){p=o;q=6}else{s=o;q=31}}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{switch(p|0){case 0:{t=1;q=34;break a;break}case 8:break;default:{u=p;break b}}o=f[c>>2]|0;m=f[d>>2]|0;if(o>>>0<m>>>0){n=b[o>>0]|0;v=n&255;if(n<<24>>24>-1){n=o+1|0;f[c>>2]=n;w=v;x=n;y=m}else{z=v;q=11}}else{z=0;q=11}if((q|0)==11){q=0;v=Knb(c,z)|0;m=J;if(!((m|0)>-1|(m|0)==-1&v>>>0>4294967295)){t=0;q=34;break a}w=v;x=f[c>>2]|0;y=f[d>>2]|0}f[g>>2]=w;if(x>>>0>=y>>>0)continue a;if((b[x>>0]|0)!=18)continue a;f[c>>2]=x+1;break}case 2:{switch(p|0){case 0:{t=1;q=34;break a;break}case 18:break;default:{u=p;break b}}break}default:{s=p;q=31;break b}}v=f[i>>2]|0;m=v&-2;if(!(v&1))A=m;else A=f[m+4>>2]|0;m=f[h>>2]|0;if((m|0)==497760){dya(h,A,497760);B=f[h>>2]|0}else B=m;if(!(fqb(c,B)|0)){t=0;q=34;break a}m=f[j>>2]|0;v=b[m+11>>0]|0;if(v<<24>>24<0){C=f[m>>2]|0;D=f[m+4>>2]|0}else{C=m;D=v&255}if(!(gqb(C,D,0,389022)|0)){t=0;q=34;break a}if((f[c>>2]|0)!=(f[d>>2]|0))continue a;if(f[a>>2]|0){q=30;break a}if((f[k>>2]|0)==(f[l>>2]|0)){q=30;break a}else continue a}while(0);if((q|0)==31){q=0;if(!s){t=1;q=34;break}else u=s}if((u&7|0)==4){t=1;q=34;break}if(!(Lpb(c,u)|0)){t=0;q=34;break}}if((q|0)==30){f[e>>2]=0;b[c+24>>0]=1;t=1;return t|0}else if((q|0)==34)return t|0;return 0}function vKa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=109180;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;if((a|0)!=492960?(f[213015]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=37;b[d+8>>0]=0;Gpb(852060,d);hpb(d)}f[a+24>>2]=0;u=c;return}function wKa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=109072;c=a+4|0;d=f[c>>2]|0;e=d&-2;if(!(d&1))g=e;else g=f[e+4>>2]|0;if(!g){g=a+8|0;a=f[g>>2]|0;if((a|0)==497760|(a|0)==0)h=d;else{if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a);h=f[c>>2]|0}f[g>>2]=497760;i=h}else i=d;if(!(i&1)){f[c>>2]=0;return}d=i&-2;i=d;if((d|0)==0|(f[i+4>>2]|0)!=0){f[c>>2]=0;return}if(f[i>>2]|0)GPb(i);O5b(d);f[c>>2]=0;return}function xKa(a){a=a|0;wKa(a);O5b(a);return}function yKa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function zKa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(20)|0;hKa(a);c=a;return c|0}else{a=znb(b,18728,20)|0;f[a>>2]=109072;f[a+4>>2]=b;f[a+8>>2]=497760;f[a+12>>2]=0;f[a+16>>2]=0;c=a;return c|0}return 0}function AKa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function BKa(a){a=a|0;return f[a+4>>2]|0}function CKa(a){a=a|0;var c=0;f[a+12>>2]=0;c=f[a+8>>2]|0;if((c|0)==497760)return;a=c+11|0;if((b[a>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;return}else{b[c>>0]=0;b[a>>0]=0;return}}function DKa(a){a=a|0;return 1}function EKa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a+12>>2]|0;if(c)if((c|0)>=0)if(c>>>0<128)d=2;else d=(iob(c)|0)+1|0;else d=11;else d=0;c=f[a+8>>2]|0;e=b[c+11>>0]|0;g=e<<24>>24<0;if(g)h=f[c+4>>2]|0;else h=e&255;if(!h){i=d;j=a+16|0;f[j>>2]=i;return i|0}if(g){g=f[c+4>>2]|0;if(g>>>0<128){k=1;l=g}else{k=iob(g)|0;l=g}}else{k=1;l=e&255}i=d+1+l+k|0;j=a+16|0;f[j>>2]=i;return i|0}function FKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=f[a+12>>2]|0;if(d|0)Mpb(1,d,c);d=a+8|0;a=f[d>>2]|0;e=b[a+11>>0]|0;g=e<<24>>24<0;if(g)h=f[a+4>>2]|0;else h=e&255;if(!h)return;if(g){i=f[a>>2]|0;j=f[a+4>>2]|0}else{i=a;j=e&255}gqb(i,j,1,389022)|0;$pb(2,f[d>>2]|0,c);return}function GKa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function HKa(a){a=a|0;return f[a+16>>2]|0}function IKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+12>>2]|0;do if(!c)e=d;else{b[d>>0]=8;g=d+1|0;if((c|0)<0){e=hob(c,((c|0)<0)<<31>>31,g)|0;break}if(c>>>0>127){h=c;i=g;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=g;m=c}b[l>>0]=m;e=l+1|0}while(0);l=a+8|0;a=f[l>>2]|0;m=b[a+11>>0]|0;c=m<<24>>24<0;if(c)n=f[a+4>>2]|0;else n=m&255;if(!n){o=e;return o|0}if(c){p=f[a>>2]|0;q=f[a+4>>2]|0}else{p=a;q=m&255}gqb(p,q,1,389022)|0;q=f[l>>2]|0;b[e>>0]=18;o=kob(q,e+1|0)|0;return o|0}function JKa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function KKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if((a|0)==(c|0))$Ja(3575);d=T6b(c,23288,18728,0)|0;if(!d){cOb(c,a);return}c=f[d+12>>2]|0;if(c|0)f[a+12>>2]=c;c=f[d+8>>2]|0;d=b[c+11>>0]|0;if(d<<24>>24<0)e=f[c+4>>2]|0;else e=d&255;if(!e)return;e=a+8|0;d=f[a+4>>2]|0;a=d&-2;if(!(d&1))g=a;else g=f[a+4>>2]|0;a=f[e>>2]|0;if((a|0)==497760){dya(e,g,c);return}else{_5b(a,c)|0;return}}function LKa(a,b){a=a|0;b=b|0;f[a+16>>2]=b;return}function MKa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213017]|0)!=2){f[d>>2]=135812;f[d+4>>2]=35;b[d+8>>0]=0;Gpb(852068,d);hpb(d)}f[a>>2]=f[213024];f[a+4>>2]=f[213025];u=c;return}function NKa(a){a=a|0;var b=0,c=0;f[a>>2]=108964;bLa(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function OKa(a){a=a|0;NKa(a);O5b(a);return}function PKa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function QKa(a,c){a=a|0;c=c|0;var d=0;if(!c){a=L5b(48)|0;kKa(a);d=a;return d|0}else{a=znb(c,18744,48)|0;f[a>>2]=108964;f[a+4>>2]=c;f[a+8>>2]=497760;f[a+12>>2]=497760;f[a+16>>2]=497760;f[a+20>>2]=0;f[a+24>>2]=0;c=a+32|0;f[c>>2]=0;f[c+4>>2]=0;b[c+8>>0]=0;f[a+44>>2]=0;d=a;return d|0}return 0}function RKa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function SKa(a){a=a|0;return f[a+4>>2]|0}function TKa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+32|0;f[c>>2]=0;f[c+4>>2]=0;b[c+8>>0]=0;c=a+4|0;d=f[a+8>>2]|0;do if((d|0)!=497760){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[a+12>>2]|0;do if((d|0)!=497760){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[c>>2]|0;e=d&-2;if(!(d&1))g=e;else g=f[e+4>>2]|0;e=a+20|0;if((g|0)==0?(g=f[e>>2]|0,g|0):0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);f[e>>2]=0;e=f[a+16>>2]|0;do if((e|0)!=497760){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);e=f[c>>2]|0;c=e&-2;if(!(e&1))h=c;else h=f[c+4>>2]|0;c=a+24|0;if(h|0){f[c>>2]=0;return}h=f[c>>2]|0;if(!h){f[c>>2]=0;return}bi[f[(f[h>>2]|0)+4>>2]&2047](h);f[c>>2]=0;return}function UKa(a){a=a|0;return 1}function VKa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+8|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}gqb(j,k,1,389059)|0;$pb(1,f[d>>2]|0,c)}d=a+12|0;k=f[d>>2]|0;j=b[k+11>>0]|0;g=j<<24>>24<0;if(g)l=f[k+4>>2]|0;else l=j&255;if(l|0){if(g){m=f[k>>2]|0;n=f[k+4>>2]|0}else{m=k;n=j&255}gqb(m,n,1,389089)|0;$pb(2,f[d>>2]|0,c)}d=(a|0)==492872;if(!d?(n=f[a+20>>2]|0,n|0):0)eqb(3,n,c);n=a+16|0;m=f[n>>2]|0;j=b[m+11>>0]|0;k=j<<24>>24<0;if(k)o=f[m+4>>2]|0;else o=j&255;if(o|0){if(k){p=f[m>>2]|0;q=f[m+4>>2]|0}else{p=m;q=j&255}gqb(p,q,1,389119)|0;$pb(4,f[n>>2]|0,c)}if(b[a+40>>0]|0)Ypb(5,1,c);n=a+32|0;q=f[n>>2]|0;p=f[n+4>>2]|0;if(!((q|0)==0&(p|0)==0))Npb(6,q,p,c);if(d)return;d=f[a+24>>2]|0;if(!d)return;eqb(7,d,c);return}function WKa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function XKa(a){a=a|0;return f[a+44>>2]|0}function YKa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=a+8|0;e=f[c>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(!i)j=d;else{if(h){k=f[e>>2]|0;l=f[e+4>>2]|0}else{k=e;l=g&255}gqb(k,l,1,389059)|0;l=f[c>>2]|0;b[d>>0]=10;j=kob(l,d+1|0)|0}d=a+12|0;l=f[d>>2]|0;c=b[l+11>>0]|0;k=c<<24>>24<0;if(k)m=f[l+4>>2]|0;else m=c&255;if(!m)n=j;else{if(k){o=f[l>>2]|0;p=f[l+4>>2]|0}else{o=l;p=c&255}gqb(o,p,1,389089)|0;p=f[d>>2]|0;b[j>>0]=18;n=kob(p,j+1|0)|0}j=(a|0)==492872;if(!j?(p=f[a+20>>2]|0,(p|0)!=0):0){b[n>>0]=26;d=n+1|0;o=f[p+16>>2]|0;if(o>>>0>127){c=o;l=d;while(1){b[l>>0]=c|128;k=c>>>7;m=l+1|0;if(c>>>0>16383){c=k;l=m}else{q=m;r=k;break}}}else{q=d;r=o}b[q>>0]=r;s=li[f[(f[p>>2]|0)+68>>2]&511](p,0,q+1|0)|0}else s=n;n=a+16|0;q=f[n>>2]|0;p=b[q+11>>0]|0;r=p<<24>>24<0;if(r)t=f[q+4>>2]|0;else t=p&255;if(!t)u=s;else{if(r){v=f[q>>2]|0;w=f[q+4>>2]|0}else{v=q;w=p&255}gqb(v,w,1,389119)|0;w=f[n>>2]|0;b[s>>0]=34;u=kob(w,s+1|0)|0}if(!(b[a+40>>0]|0))x=u;else{b[u>>0]=40;b[u+1>>0]=1;x=u+2|0}u=a+32|0;s=f[u>>2]|0;w=f[u+4>>2]|0;if((s|0)==0&(w|0)==0)y=x;else{b[x>>0]=48;y=hob(s,w,x+1|0)|0}if(j){z=y;return z|0}j=f[a+24>>2]|0;if(!j){z=y;return z|0}b[y>>0]=58;a=y+1|0;y=f[j+16>>2]|0;if(y>>>0>127){x=y;w=a;while(1){b[w>>0]=x|128;s=x>>>7;u=w+1|0;if(x>>>0>16383){x=s;w=u}else{A=u;B=s;break}}}else{A=a;B=y}b[A>>0]=B;z=li[f[(f[j>>2]|0)+68>>2]&511](j,0,A+1|0)|0;return z|0}function ZKa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function _Ka(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))$Ja(1389);c=T6b(b,23288,18744,0)|0;if(!c){cOb(b,a);return}else{lKa(a,c);return}}function $Ka(a,b){a=a|0;b=b|0;f[a+44>>2]=b;return}function aLa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213017]|0)!=2){f[d>>2]=135812;f[d+4>>2]=35;b[d+8>>0]=0;Gpb(852068,d);hpb(d)}f[a>>2]=f[213022];f[a+4>>2]=f[213023];u=c;return}function bLa(a){a=a|0;var c=0,d=0,e=0;c=f[a+4>>2]|0;d=c&-2;if(!(c&1))e=d;else e=f[d+4>>2]|0;if(e|0)return;e=a+8|0;d=f[e>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[e>>2]=497760;e=a+12|0;d=f[e>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[e>>2]=497760;e=a+16|0;d=f[e>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[e>>2]=497760;if((a|0)==492872)return;e=f[a+20>>2]|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);e=f[a+24>>2]|0;if(!e)return;bi[f[(f[e>>2]|0)+4>>2]&2047](e);return}function cLa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=108856;sLa(a);b=a+52|0;c=f[b>>2]|0;if(c|0?(f[a+40>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+36|0;h=f[b>>2]|0;if(h|0?(f[a+24>>2]|0)==0:0){c=f[h>>2]|0;if((c|0)>0){d=0;do{e=f[h+4+(d<<2)>>2]|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(c|0));i=f[b>>2]|0}else i=h;O5b(i)}f[b>>2]=0;b=a+20|0;i=f[b>>2]|0;if(i|0?(f[a+8>>2]|0)==0:0){h=f[i>>2]|0;if((h|0)>0){c=0;do{d=f[i+4+(c<<2)>>2]|0;if(d|0)bi[f[(f[d>>2]|0)+4>>2]&2047](d);c=c+1|0}while((c|0)!=(h|0));j=f[b>>2]|0}else j=i;O5b(j)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}j=a&-2;a=j;if((j|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(j);f[b>>2]=0;return}function dLa(a){a=a|0;cLa(a);O5b(a);return}function eLa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function fLa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){a=L5b(80)|0;dKa(a);c=a;return c|0}else{a=b;d=znb(b,18712,80)|0;f[d>>2]=108856;f[d+4>>2]=a;f[d+8>>2]=a;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=a;f[d+28>>2]=0;f[d+32>>2]=0;f[d+36>>2]=0;f[d+40>>2]=a;f[d+44>>2]=0;f[d+48>>2]=0;f[d+52>>2]=0;f[d+56>>2]=497760;f[d+60>>2]=497760;f[d+64>>2]=497760;f[d+68>>2]=0;f[d+72>>2]=0;f[d+76>>2]=0;c=d;return c|0}return 0}function gLa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function hLa(a){a=a|0;return f[a+4>>2]|0}function iLa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;d=f[a+56>>2]|0;do if((d|0)!=497760){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);d=f[c>>2]|0;c=d&-2;if(!(d&1))g=c;else g=f[c+4>>2]|0;c=a+68|0;if((g|0)==0?(g=f[c>>2]|0,g|0):0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);f[c>>2]=0;c=f[a+60>>2]|0;do if((c|0)!=497760){g=c+11|0;if((b[g>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[g>>0]=0;break}}while(0);c=f[a+64>>2]|0;do if((c|0)!=497760){g=c+11|0;if((b[g>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[g>>0]=0;break}}while(0);c=a+12|0;f[a+72>>2]=0;g=f[c>>2]|0;if((g|0)>0){d=f[a+20>>2]|0;e=0;do{h=f[d+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(g|0));f[c>>2]=0}c=a+28|0;g=f[c>>2]|0;if((g|0)>0){e=f[a+36>>2]|0;d=0;do{h=f[e+4+(d<<2)>>2]|0;d=d+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((d|0)!=(g|0));f[c>>2]=0}c=a+44|0;g=f[c>>2]|0;if((g|0)<=0)return;d=f[a+52>>2]|0;a=0;do{e=f[d+4+(a<<2)>>2]|0;a=a+1|0;bi[f[(f[e>>2]|0)+28>>2]&2047](e)}while((a|0)!=(g|0));f[c>>2]=0;return}function jLa(a){a=a|0;return 1}function kLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+56|0;e=f[d>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(i|0){if(h){j=f[e>>2]|0;k=f[e+4>>2]|0}else{j=e;k=g&255}gqb(j,k,1,388946)|0;$pb(1,f[d>>2]|0,c)}d=f[a+12>>2]|0;if(d|0){k=a+20|0;j=0;do{eqb(2,f[(f[k>>2]|0)+4+(j<<2)>>2]|0,c);j=j+1|0}while((j|0)!=(d|0))}d=f[a+28>>2]|0;if(d|0){j=a+36|0;k=0;do{eqb(3,f[(f[j>>2]|0)+4+(k<<2)>>2]|0,c);k=k+1|0}while((k|0)!=(d|0))}d=f[a+44>>2]|0;if(d|0){k=a+52|0;j=0;do{eqb(4,f[(f[k>>2]|0)+4+(j<<2)>>2]|0,c);j=j+1|0}while((j|0)!=(d|0))}d=a+60|0;j=f[d>>2]|0;k=b[j+11>>0]|0;g=k<<24>>24<0;if(g)l=f[j+4>>2]|0;else l=k&255;if(l|0){if(g){m=f[j>>2]|0;n=f[j+4>>2]|0}else{m=j;n=k&255}gqb(m,n,1,388968)|0;$pb(5,f[d>>2]|0,c)}d=a+64|0;n=f[d>>2]|0;m=b[n+11>>0]|0;k=m<<24>>24<0;if(k)o=f[n+4>>2]|0;else o=m&255;if(o|0){if(k){p=f[n>>2]|0;q=f[n+4>>2]|0}else{p=n;q=m&255}gqb(p,q,1,388993)|0;$pb(6,f[d>>2]|0,c)}if((a|0)!=492736?(d=f[a+68>>2]|0,d|0):0)eqb(8,d,c);if(b[a+73>>0]|0)Ypb(16,1,c);if(b[a+74>>0]|0)Ypb(17,1,c);if(b[a+72>>0]|0)Ypb(18,1,c);if(!(b[a+75>>0]|0))return;Ypb(19,1,c);return}function lLa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function mLa(a){a=a|0;return f[a+76>>2]|0}function nLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;c=a+56|0;e=f[c>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(!i)j=d;else{if(h){k=f[e>>2]|0;l=f[e+4>>2]|0}else{k=e;l=g&255}gqb(k,l,1,388946)|0;l=f[c>>2]|0;b[d>>0]=10;j=kob(l,d+1|0)|0}d=f[a+12>>2]|0;if(!d)m=j;else{l=a+20|0;c=0;k=j;while(1){j=f[(f[l>>2]|0)+4+(c<<2)>>2]|0;b[k>>0]=18;g=k+1|0;e=f[j+36>>2]|0;if(e>>>0>127){h=e;i=g;while(1){b[i>>0]=h|128;n=h>>>7;o=i+1|0;if(h>>>0>16383){h=n;i=o}else{p=o;q=n;break}}}else{p=g;q=e}b[p>>0]=q;i=li[f[(f[j>>2]|0)+68>>2]&511](j,0,p+1|0)|0;c=c+1|0;if((c|0)==(d|0)){m=i;break}else k=i}}k=f[a+28>>2]|0;if(!k)r=m;else{d=a+36|0;c=0;p=m;while(1){m=f[(f[d>>2]|0)+4+(c<<2)>>2]|0;b[p>>0]=26;q=p+1|0;l=f[m+36>>2]|0;if(l>>>0>127){i=l;h=q;while(1){b[h>>0]=i|128;n=i>>>7;o=h+1|0;if(i>>>0>16383){i=n;h=o}else{s=o;t=n;break}}}else{s=q;t=l}b[s>>0]=t;h=li[f[(f[m>>2]|0)+68>>2]&511](m,0,s+1|0)|0;c=c+1|0;if((c|0)==(k|0)){r=h;break}else p=h}}p=f[a+44>>2]|0;if(!p)u=r;else{k=a+52|0;c=0;s=r;while(1){r=f[(f[k>>2]|0)+4+(c<<2)>>2]|0;b[s>>0]=34;t=s+1|0;d=f[r+44>>2]|0;if(d>>>0>127){h=d;i=t;while(1){b[i>>0]=h|128;j=h>>>7;e=i+1|0;if(h>>>0>16383){h=j;i=e}else{v=e;w=j;break}}}else{v=t;w=d}b[v>>0]=w;i=li[f[(f[r>>2]|0)+68>>2]&511](r,0,v+1|0)|0;c=c+1|0;if((c|0)==(p|0)){u=i;break}else s=i}}s=a+60|0;p=f[s>>2]|0;c=b[p+11>>0]|0;v=c<<24>>24<0;if(v)x=f[p+4>>2]|0;else x=c&255;if(!x)y=u;else{if(v){z=f[p>>2]|0;A=f[p+4>>2]|0}else{z=p;A=c&255}gqb(z,A,1,388968)|0;A=f[s>>2]|0;b[u>>0]=42;y=kob(A,u+1|0)|0}u=a+64|0;A=f[u>>2]|0;s=b[A+11>>0]|0;z=s<<24>>24<0;if(z)B=f[A+4>>2]|0;else B=s&255;if(!B)C=y;else{if(z){D=f[A>>2]|0;E=f[A+4>>2]|0}else{D=A;E=s&255}gqb(D,E,1,388993)|0;E=f[u>>2]|0;b[y>>0]=50;C=kob(E,y+1|0)|0}if((a|0)!=492736?(y=f[a+68>>2]|0,(y|0)!=0):0){b[C>>0]=66;E=C+1|0;u=f[y+16>>2]|0;if(u>>>0>127){D=u;s=E;while(1){b[s>>0]=D|128;A=D>>>7;z=s+1|0;if(D>>>0>16383){D=A;s=z}else{F=z;G=A;break}}}else{F=E;G=u}b[F>>0]=G;H=li[f[(f[y>>2]|0)+68>>2]&511](y,0,F+1|0)|0}else H=C;if(!(b[a+73>>0]|0))I=H;else{b[H>>0]=-128;b[H+1>>0]=1;b[H+2>>0]=1;I=H+3|0}if(!(b[a+74>>0]|0))J=I;else{b[I>>0]=-120;b[I+1>>0]=1;b[I+2>>0]=1;J=I+3|0}if(!(b[a+72>>0]|0))K=J;else{b[J>>0]=-112;b[J+1>>0]=1;b[J+2>>0]=1;K=J+3|0}if(!(b[a+75>>0]|0)){L=K;return L|0}b[K>>0]=-104;b[K+1>>0]=1;b[K+2>>0]=1;L=K+3|0;return L|0}function oLa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function pLa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))$Ja(2144);c=T6b(b,23288,18712,0)|0;if(!c){cOb(b,a);return}else{eKa(a,c);return}}function qLa(a,b){a=a|0;b=b|0;f[a+76>>2]=b;return}function rLa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213017]|0)!=2){f[d>>2]=135812;f[d+4>>2]=35;b[d+8>>0]=0;Gpb(852068,d);hpb(d)}f[a>>2]=f[213020];f[a+4>>2]=f[213021];u=c;return}function sLa(a){a=a|0;var c=0,d=0,e=0;c=f[a+4>>2]|0;d=c&-2;if(!(c&1))e=d;else e=f[d+4>>2]|0;if(e|0)return;e=a+56|0;d=f[e>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[e>>2]=497760;e=a+60|0;d=f[e>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[e>>2]=497760;e=a+64|0;d=f[e>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[e>>2]=497760;if((a|0)==492736)return;e=f[a+68>>2]|0;if(!e)return;bi[f[(f[e>>2]|0)+4>>2]&2047](e);return}function tLa(a){a=a|0;var c=0,d=0,e=0;c=f[a+4>>2]|0;d=c&-2;if(!(c&1))e=d;else e=f[d+4>>2]|0;if(e|0)return;e=a+8|0;d=f[e>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[e>>2]=497760;e=a+12|0;d=f[e>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[e>>2]=497760;e=a+16|0;d=f[e>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[e>>2]=497760;e=a+20|0;d=f[e>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[e>>2]=497760;e=a+24|0;a=f[e>>2]|0;if(!((a|0)==497760|(a|0)==0)){if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a)}f[e>>2]=497760;return}function uLa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213016]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=36;b[c+8>>0]=0;Gpb(852064,c);hpb(c);u=a;return}function vLa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213016]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=36;b[c+8>>0]=0;Gpb(852064,c);hpb(c);u=a;return}function wLa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213015]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=37;b[c+8>>0]=0;Gpb(852060,c);hpb(c);u=a;return}function xLa(a,b){a=a|0;b=b|0;f[a>>2]=108856;f[a+4>>2]=b;f[a+8>>2]=b;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=b;f[a+28>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=b;f[a+44>>2]=0;f[a+48>>2]=0;f[a+52>>2]=0;f[a+56>>2]=497760;f[a+60>>2]=497760;f[a+64>>2]=497760;f[a+68>>2]=0;f[a+72>>2]=0;f[a+76>>2]=0;return}function yLa(a,b){a=a|0;b=b|0;if((b|0)==(a|0))$Ja(2162);else{eKa(a,b);return}}function zLa(a){a=a|0;var b=0,c=0;f[a>>2]=109288;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function ALa(a){a=a|0;var b=0,c=0;f[a>>2]=109288;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function BLa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function CLa(a,b){a=a|0;b=b|0;a=L5b(32)|0;fOa(a);if(!b)return a|0;O8a(b,a);return a|0}function DLa(a){a=a|0;return 0}function ELa(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function FLa(a){a=a|0;return 1}function GLa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+16|0;j=a+20|0;k=a+24|0;l=e+8|0;m=c+32|0;n=c+12|0;o=c+28|0;p=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){q=b[a>>0]|0;r=q&255;if(q<<24>>24>0){f[h>>2]=r;f[c>>2]=a+1;s=r;t=6}else{v=r;t=5}}else{v=0;t=5}if((t|0)==5){t=0;r=_nb(c,v)|0;f[h>>2]=r;if((r+-1|0)>>>0<127){s=r;t=6}else{w=r;t=26}}b:do if((t|0)==6){t=0;if((s&-8|0)==8){switch(s|0){case 0:{x=1;t=32;break a;break}case 10:{r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(a=b[r>>0]|0,a<<24>>24>-1):0){f[c>>2]=r+1;y=a&255}else{a=Znb(c)|0;if((a|0)>-1)y=a;else{x=0;t=32;break a}}a=Gnb(c,y)|0;if((Qnb(c)|0)>0)do{r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(q=b[r>>0]|0,q<<24>>24>-1):0){f[c>>2]=r+1;z=q&255;A=0}else{Lnb(e,c);q=e;if(!(b[l>>0]|0)){x=0;t=32;break a}else{z=f[q>>2]|0;A=f[q+4>>2]|0}}q=f[i>>2]|0;if((q|0)==(f[j>>2]|0)){uFa(i,q+1|0);B=f[i>>2]|0}else B=q;q=f[k>>2]|0;f[i>>2]=B+1;r=q+8+(B<<3)|0;f[r>>2]=z;f[r+4>>2]=A}while((Qnb(c)|0)>0);Hnb(c,a);break}case 8:{if(!(yFa(1,10,c,i)|0)){x=0;t=32;break a}break}default:{C=s;break b}}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[m>>2]|0){t=25;break a}if((f[n>>2]|0)==(f[o>>2]|0)){t=25;break a}else continue a}else{w=s;t=26}}while(0);if((t|0)==26){t=0;if(!w){x=1;t=32;break}else C=w}if((C&7|0)==4){x=1;t=32;break}r=f[p>>2]|0;if(!(r&1))D=hBa(p)|0;else D=r&-2;if(!(ZPb(c,C,D)|0)){x=0;t=32;break}}if((t|0)==25){f[h>>2]=0;b[c+24>>0]=1;x=1;u=d;return x|0}else if((t|0)==32){u=d;return x|0}return 0}function HLa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a+16>>2]|0;if(b){c=a+24|0;d=0;e=0;do{g=(f[c>>2]|0)+8+(e<<3)|0;d=(job(f[g>>2]|0,f[g+4>>2]|0)|0)+d|0;e=e+1|0}while((e|0)!=(b|0));if(d)if((d|0)>=0)if(d>>>0<128){h=2;i=d}else{h=(iob(d)|0)+1|0;i=d}else{h=11;i=d}else{h=0;i=0}}else{h=0;i=0}f[a+28>>2]=i;d=h+i|0;i=f[a+4>>2]|0;if(!(i&1)){j=d;k=a+12|0;f[k>>2]=j;return j|0}j=(dQb(i&-2)|0)+d|0;k=a+12|0;f[k>>2]=j;return j|0}function ILa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+16|0;if((f[d>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=10;f[g>>2]=(f[g>>2]|0)+1;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;h=g}else{fob(c,10);h=f[e>>2]|0}g=f[a+28>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else fob(c,g);if((f[d>>2]|0)>0){g=a+24|0;o=0;do{e=(f[g>>2]|0)+8+(o<<3)|0;gob(c,f[e>>2]|0,f[e+4>>2]|0);o=o+1|0}while((o|0)<(f[d>>2]|0))}}d=f[a+4>>2]|0;if(!(d&1))return;aQb(d&-2,c);return}function JLa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function KLa(a){a=a|0;return f[a+12>>2]|0}function LLa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+16|0;if((f[c>>2]|0)>0){b[d>>0]=10;e=d+1|0;g=f[a+28>>2]|0;if(g>>>0>127){h=g;i=e;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=e;m=g}b[l>>0]=m;m=l+1|0;if((f[c>>2]|0)>0){l=a+24|0;g=0;e=m;while(1){i=(f[l>>2]|0)+8+(g<<3)|0;h=hob(f[i>>2]|0,f[i+4>>2]|0,e)|0;g=g+1|0;if((g|0)>=(f[c>>2]|0)){n=h;break}else e=h}}else n=m}else n=d;d=f[a+4>>2]|0;if(!(d&1)){o=n;return o|0}o=bQb(d&-2,n)|0;return o|0}function MLa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function NLa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((a|0)==(b|0))jMa(2941);c=T6b(b,23288,18760,0)|0;if(!c){cOb(b,a);return}b=a+16|0;d=c+16|0;e=f[d>>2]|0;if(e|0){uFa(b,(f[b>>2]|0)+e|0);Vac((f[a+24>>2]|0)+8+(f[b>>2]<<3)|0,(f[c+24>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[b>>2]=(f[b>>2]|0)+(f[d>>2]|0)}d=f[c+4>>2]|0;if(!(d&1))return;LPb(d&-2,a+4|0);return}function OLa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function PLa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213036];f[a+4>>2]=f[213037];u=c;return}function QLa(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+48|0;c=a+24|0;d=a;e=a+36|0;if((f[213034]|0)!=2){f[c>>2]=135812;f[c+4>>2]=40;b[c+8>>0]=0;Gpb(852136,c);hpb(c)}g=drb()|0;h=L5b(32)|0;f[c>>2]=h;f[c+8>>2]=-2147483616;f[c+4>>2]=18;i=h;j=389381;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+18>>0]=0;h=hrb(g,c)|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if(!h){zpb(d,3,389400,274);xpb(e,vpb(d,459532)|0);Apb(d)}d=h+40|0;e=f[d>>2]|0;f[213036]=e;c=pIb(e,493e3,109388,8,-1,-1,32,4,-1)|0;f[213037]=c;c=(f[d>>2]|0)+88|0;f[213038]=c;e=pIb(c,493040,109392,8,-1,-1,108,4,-1)|0;f[213039]=e;e=(f[d>>2]|0)+176|0;f[213040]=e;c=pIb(e,493160,109436,8,-1,-1,32,4,-1)|0;f[213041]=c;c=(f[d>>2]|0)+264|0;f[213042]=c;e=pIb(c,493200,109440,8,-1,-1,28,4,-1)|0;f[213043]=e;e=(f[d>>2]|0)+352|0;f[213044]=e;c=pIb(e,493240,109444,8,-1,-1,28,4,-1)|0;f[213045]=c;c=(f[d>>2]|0)+440|0;f[213046]=c;e=pIb(c,493280,109460,8,-1,-1,128,4,-1)|0;f[213047]=e;f[213048]=f[(f[213046]|0)+52>>2];e=(f[d>>2]|0)+528|0;f[213049]=e;c=pIb(e,493416,109528,8,-1,-1,52,4,-1)|0;f[213050]=c;c=(f[d>>2]|0)+616|0;f[213051]=c;e=pIb(c,493480,109568,8,-1,-1,52,4,-1)|0;f[213052]=e;e=(f[d>>2]|0)+704|0;f[213053]=e;c=pIb(e,493544,109596,8,-1,-1,48,4,-1)|0;f[213054]=c;f[213055]=f[(f[213053]|0)+52>>2];c=(f[d>>2]|0)+792|0;f[213056]=c;e=pIb(c,493600,109628,8,-1,-1,104,4,-1)|0;f[213057]=e;e=(f[d>>2]|0)+880|0;f[213058]=e;c=pIb(e,493712,109664,8,-1,-1,232,4,-1)|0;f[213059]=c;c=f[(f[213058]|0)+52>>2]|0;f[213060]=c;e=c;f[213061]=e+32;f[213062]=e+64;e=(f[d>>2]|0)+968|0;f[213063]=e;c=pIb(e,493952,109824,8,-1,-1,44,4,-1)|0;f[213064]=c;c=(f[d>>2]|0)+1056|0;f[213065]=c;e=pIb(c,494008,109840,8,-1,-1,40,4,-1)|0;f[213066]=e;e=(f[d>>2]|0)+1144|0;f[213067]=e;c=pIb(e,494056,109852,8,-1,-1,60,4,-1)|0;f[213068]=c;c=(f[d>>2]|0)+1232|0;f[213069]=c;e=pIb(c,494128,109872,8,-1,-1,32,4,-1)|0;f[213070]=e;f[213071]=f[(f[213069]|0)+52>>2];e=(f[d>>2]|0)+1320|0;f[213072]=e;c=pIb(e,494168,109888,8,-1,-1,372,4,-1)|0;f[213073]=c;c=(f[d>>2]|0)+1408|0;f[213074]=c;e=pIb(c,494552,110148,8,-1,-1,44,4,-1)|0;f[213075]=e;e=(f[d>>2]|0)+1496|0;f[213076]=e;c=pIb(e,494608,110176,8,-1,-1,28,4,-1)|0;f[213077]=c;f[213078]=f[(f[213076]|0)+52>>2];c=(f[d>>2]|0)+1584|0;f[213079]=c;e=pIb(c,494648,110188,8,-1,-1,28,4,-1)|0;f[213080]=e;e=(f[d>>2]|0)+1672|0;f[213081]=e;c=pIb(e,494688,110200,8,-1,-1,28,4,-1)|0;f[213082]=c;c=(f[d>>2]|0)+1760|0;f[213083]=c;e=pIb(c,494728,110212,8,-1,-1,24,4,-1)|0;f[213084]=e;e=(f[d>>2]|0)+1848|0;f[213085]=e;c=pIb(e,494760,110220,8,-1,-1,28,4,-1)|0;f[213086]=c;c=(f[d>>2]|0)+1936|0;f[213087]=c;e=pIb(c,494800,110232,8,-1,-1,28,4,-1)|0;f[213088]=e;e=(f[d>>2]|0)+2024|0;f[213089]=e;c=pIb(e,494840,110244,8,-1,-1,24,4,-1)|0;f[213090]=c;c=(f[d>>2]|0)+2112|0;f[213091]=c;e=pIb(c,494872,110252,8,-1,-1,120,4,-1)|0;f[213092]=e;f[213093]=f[(f[213091]|0)+52>>2];e=(f[d>>2]|0)+2200|0;f[213094]=e;c=pIb(e,495e3,110324,8,-1,-1,32,4,-1)|0;f[213095]=c;c=(f[d>>2]|0)+2288|0;f[213096]=c;e=pIb(c,495040,110332,8,-1,-1,52,4,-1)|0;f[213097]=e;f[213098]=f[(f[213096]|0)+52>>2];e=(f[d>>2]|0)+2376|0;f[213099]=e;c=pIb(e,495104,110372,8,-1,-1,28,4,-1)|0;f[213100]=c;c=(f[d>>2]|0)+2464|0;f[213101]=c;e=pIb(c,495144,110384,8,-1,-1,40,4,-1)|0;f[213102]=e;e=(f[d>>2]|0)+2552|0;f[213103]=e;c=pIb(e,495192,110408,8,-1,-1,24,4,-1)|0;f[213104]=c;c=(f[d>>2]|0)+2640|0;f[213105]=c;e=pIb(c,495224,110416,8,-1,-1,96,4,-1)|0;f[213106]=e;e=(f[d>>2]|0)+2728|0;f[213107]=e;c=pIb(e,495328,110440,8,-1,-1,36,4,-1)|0;f[213108]=c;f[213109]=f[(f[213107]|0)+52>>2];c=(f[d>>2]|0)+2816|0;f[213110]=c;e=pIb(c,495376,110452,8,-1,-1,20,4,-1)|0;f[213111]=e;e=(f[d>>2]|0)+2904|0;f[213112]=e;c=pIb(e,495408,110456,8,-1,-1,36,4,-1)|0;f[213113]=c;c=(f[d>>2]|0)+2992|0;f[213114]=c;e=pIb(c,495456,110476,8,-1,-1,28,4,-1)|0;f[213115]=e;e=(f[d>>2]|0)+3080|0;f[213116]=e;c=pIb(e,495496,110488,8,-1,-1,24,4,-1)|0;f[213117]=c;c=(f[d>>2]|0)+3168|0;f[213118]=c;e=pIb(c,495528,110496,8,-1,-1,28,4,-1)|0;f[213119]=e;e=(f[d>>2]|0)+3256|0;f[213120]=e;c=pIb(e,495568,110508,8,-1,-1,20,4,-1)|0;f[213121]=c;c=(f[d>>2]|0)+3344|0;f[213122]=c;e=pIb(c,495600,110512,8,-1,-1,20,4,-1)|0;f[213123]=e;f[213124]=f[(f[213122]|0)+52>>2];e=(f[d>>2]|0)+3432|0;f[213125]=e;c=pIb(e,495632,110516,8,-1,-1,60,4,-1)|0;f[213126]=c;c=(f[d>>2]|0)+3520|0;f[213127]=c;e=pIb(c,495704,110564,8,-1,-1,20,4,-1)|0;f[213128]=e;e=(f[d>>2]|0)+3608|0;f[213129]=e;c=pIb(e,495736,110568,8,-1,-1,36,4,-1)|0;f[213130]=c;c=(f[d>>2]|0)+3696|0;f[213131]=c;e=pIb(c,495784,110592,8,-1,-1,32,4,-1)|0;f[213132]=e;e=(f[d>>2]|0)+3784|0;f[213133]=e;c=pIb(e,495824,110596,8,-1,-1,28,4,-1)|0;f[213134]=c;c=(f[d>>2]|0)+3872|0;f[213135]=c;e=pIb(c,495864,110608,8,-1,-1,40,4,-1)|0;f[213136]=e;e=f[(f[213135]|0)+52>>2]|0;f[213137]=e;f[213138]=e+32;e=(f[d>>2]|0)+3960|0;f[213139]=e;c=pIb(e,495912,110632,8,-1,-1,32,4,-1)|0;f[213140]=c;c=(f[d>>2]|0)+4048|0;f[213141]=c;e=pIb(c,495952,110648,8,-1,-1,24,4,-1)|0;f[213142]=e;e=(f[d>>2]|0)+4136|0;f[213143]=e;c=pIb(e,495984,110660,8,-1,-1,20,4,-1)|0;f[213144]=c;c=(f[d>>2]|0)+4224|0;f[213145]=c;e=pIb(c,496016,110664,8,-1,-1,68,4,-1)|0;f[213146]=e;e=f[(f[213145]|0)+52>>2]|0;f[213147]=e;f[213148]=e+32;e=(f[d>>2]|0)+4312|0;f[213149]=e;c=pIb(e,496096,110716,8,-1,-1,28,4,-1)|0;f[213150]=c;c=(f[d>>2]|0)+4400|0;f[213151]=c;e=pIb(c,496136,110728,8,-1,-1,32,4,-1)|0;f[213152]=e;e=(f[d>>2]|0)+4488|0;f[213153]=e;c=pIb(e,496176,110744,8,-1,-1,32,4,-1)|0;f[213154]=c;c=(f[d>>2]|0)+4576|0;f[213155]=c;e=pIb(c,496216,110764,8,-1,-1,28,4,-1)|0;f[213156]=e;f[213157]=f[(f[213155]|0)+52>>2];e=(f[d>>2]|0)+4664|0;f[213158]=e;c=pIb(e,496256,110776,8,-1,-1,24,4,-1)|0;f[213159]=c;f[213160]=f[(f[213158]|0)+52>>2];c=(f[d>>2]|0)+4752|0;f[213161]=c;e=pIb(c,496288,110784,8,-1,-1,28,4,-1)|0;f[213162]=e;e=(f[d>>2]|0)+4840|0;f[213163]=e;c=pIb(e,496328,110796,8,-1,-1,36,4,-1)|0;f[213164]=c;c=(f[d>>2]|0)+4928|0;f[213165]=c;e=pIb(c,496376,110816,8,-1,-1,20,4,-1)|0;f[213166]=e;f[213167]=f[(f[213165]|0)+52>>2];e=(f[d>>2]|0)+5016|0;f[213168]=e;c=pIb(e,496408,110820,8,-1,-1,36,4,-1)|0;f[213169]=c;c=(f[d>>2]|0)+5104|0;f[213170]=c;e=pIb(c,496456,110832,8,-1,-1,24,4,-1)|0;f[213171]=e;f[213172]=f[(f[213170]|0)+52>>2];e=(f[d>>2]|0)+5192|0;f[213173]=e;c=pIb(e,496488,110840,8,-1,-1,20,4,-1)|0;f[213174]=c;f[213175]=f[(f[213173]|0)+52>>2];c=(f[d>>2]|0)+5280|0;f[213176]=c;e=pIb(c,496520,110844,8,-1,-1,24,4,-1)|0;f[213177]=e;e=(f[d>>2]|0)+5368|0;f[213178]=e;c=pIb(e,496552,110852,8,-1,-1,20,4,-1)|0;f[213179]=c;c=(f[d>>2]|0)+5456|0;f[213180]=c;e=pIb(c,496584,110856,8,-1,-1,64,4,-1)|0;f[213181]=e;e=(f[d>>2]|0)+5544|0;f[213182]=e;c=pIb(e,496656,110908,8,-1,-1,28,4,-1)|0;f[213183]=c;c=f[(f[213182]|0)+52>>2]|0;f[213184]=c;f[213185]=c+32;c=(f[d>>2]|0)+5632|0;f[213186]=c;e=pIb(c,496696,110920,8,-1,-1,296,4,-1)|0;f[213187]=e;e=f[(f[213186]|0)+52>>2]|0;f[213188]=e;f[213189]=e+32;e=(f[d>>2]|0)+5720|0;f[213190]=e;c=pIb(e,497e3,111092,8,-1,-1,196,4,-1)|0;f[213191]=c;f[213192]=f[(f[213190]|0)+52>>2];c=(f[d>>2]|0)+5808|0;f[213193]=c;e=pIb(c,497208,111244,8,-1,-1,24,4,-1)|0;f[213194]=e;e=(f[d>>2]|0)+5896|0;f[213195]=e;c=pIb(e,497240,111252,8,-1,-1,48,4,-1)|0;f[213196]=c;c=(f[d>>2]|0)+5984|0;f[213197]=c;e=pIb(c,497296,111284,8,-1,-1,28,4,-1)|0;f[213198]=e;e=(f[d>>2]|0)+6072|0;f[213199]=e;c=pIb(e,497336,111296,8,-1,-1,64,4,-1)|0;f[213200]=c;c=(f[d>>2]|0)+6160|0;f[213201]=c;d=pIb(c,497408,111328,8,-1,-1,28,4,-1)|0;f[213202]=d;d=f[h+48>>2]|0;f[213203]=d;f[213204]=d+32;u=a;return}function RLa(){var a=0,c=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,389400);if((f[213033]|0)!=2){f[c>>2]=135812;f[c+4>>2]=41;b[c+8>>0]=0;Gpb(852132,c);hpb(c)}grb(389482,18805);SNb(389381,1501);spb(42);u=a;return}function SLa(){var a=0,c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,389400);f[123250]=109288;f[123251]=0;f[123252]=0;f[123253]=0;f[123254]=0;f[123255]=0;f[123256]=0;b[493032]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123260]=111348;f[123261]=0;f[123268]=0;f[123269]=0;f[123270]=0;f[123272]=0;f[123273]=0;f[123274]=0;f[123276]=0;f[123277]=0;f[123278]=0;f[123262]=0;f[123263]=0;f[123264]=0;f[123265]=0;f[123266]=0;f[123280]=497760;f[123281]=0;f[123282]=0;f[123283]=0;f[123284]=0;f[123285]=0;f[123286]=0;b[493152]=1;f[123290]=111456;f[123291]=0;f[123292]=0;f[123293]=0;f[123294]=0;f[123295]=0;f[123296]=0;f[123297]=0;b[493192]=1;f[123300]=111564;f[123301]=0;f[123302]=0;f[123303]=0;f[123304]=0;f[123305]=0;f[123306]=0;b[493232]=1;f[123310]=111672;f[123311]=0;f[123312]=0;f[123313]=0;f[123314]=0;b[493260]=1;b[493261]=1;n[123316]=1.000000013351432e-10;b[493272]=1;f[123320]=111780;f[123321]=0;e=493288;g=e+112|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));b[493400]=1;b[493401]=1;n[123351]=.5;b[493408]=1;f[123354]=111888;f[123355]=0;f[123356]=0;f[123357]=0;f[123358]=0;f[123359]=0;f[123360]=0;f[123361]=0;f[123362]=0;f[123363]=0;f[123364]=-1;f[123365]=1;b[493464]=1;b[493465]=1;b[493472]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123370]=111996;f[123371]=0;f[123372]=0;f[123373]=0;f[123374]=0;f[123375]=0;f[123376]=0;f[123377]=497760;f[123378]=0;f[123379]=0;f[123380]=0;f[123381]=0;b[493528]=0;b[493536]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}h=L5b(12)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=8;i=h;j=i;b[j>>0]=99;b[j+1>>0]=111;b[j+2>>0]=110;b[j+3>>0]=115;j=i+4|0;b[j>>0]=116;b[j+1>>0]=97;b[j+2>>0]=110;b[j+3>>0]=116;b[h+8>>0]=0;f[213028]=h;f[123386]=112104;f[123387]=0;f[123388]=0;f[123389]=0;f[123390]=h;f[123391]=0;f[123392]=0;f[123393]=0;f[123394]=0;f[123395]=-1;n[123396]=1.0;n[123397]=1.0;b[493592]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123400]=112212;f[123401]=0;e=493608;g=e+84|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[123423]=497760;f[123424]=0;d[246850]=0;b[493704]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}h=L5b(12)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=2;b[h>>0]=76;b[h+1>>0]=50;b[h+2>>0]=0;f[213029]=h;j=L5b(12)|0;i=j+4|0;f[i>>2]=0;f[i+4>>2]=0;b[j+11>>0]=3;b[j>>0]=b[408288]|0;b[j+1>>0]=b[408289]|0;b[j+2>>0]=b[408290]|0;b[j+3>>0]=0;f[213030]=j;f[123428]=112320;e=493716;g=e+84|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[123450]=497760;f[123451]=497760;f[123452]=497760;f[123453]=h;f[123454]=497760;f[123455]=j;e=493824;g=e+64|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));n[123472]=.9900000095367432;f[123473]=1;f[123474]=1;b[493900]=1;b[493901]=1;n[123476]=-1.0;f[123477]=1;f[123478]=1;j=493920;f[j>>2]=-1;f[j+4>>2]=-1;n[123482]=9.99999993922529e-09;n[123483]=.9990000128746033;f[123484]=0;b[493944]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123488]=112428;f[123489]=0;f[123490]=0;f[123491]=0;f[123492]=0;f[123493]=0;f[123494]=0;f[123495]=0;f[123496]=497760;j=493988;f[j>>2]=0;f[j+4>>2]=0;b[494e3]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123502]=112536;f[123503]=0;f[123504]=0;f[123505]=0;f[123506]=0;f[123507]=0;f[123508]=0;f[123509]=0;f[123510]=0;f[123511]=1;b[494048]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123514]=112644;f[123515]=0;e=494064;g=e+52|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));b[494120]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123532]=112752;f[123533]=0;f[123534]=0;f[123535]=0;f[123536]=497760;f[123537]=0;n[123538]=1.0;n[123539]=1.0;b[494160]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123542]=112860;f[123543]=0;f[123544]=0;f[123545]=0;f[123546]=0;e=494188;g=e+124|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[123578]=497760;f[123579]=497760;Nac(494320,0,220)|0;b[494544]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123638]=112968;f[123639]=0;f[123640]=0;f[123641]=0;f[123642]=0;f[123643]=0;f[123644]=0;f[123645]=497760;f[123646]=0;d[247294]=0;b[494590]=0;n[123648]=1.0;b[494600]=1;f[123652]=113076;f[123653]=0;f[123654]=0;f[123655]=0;f[123656]=0;b[494628]=0;f[123658]=1;b[494640]=1;f[123662]=113184;f[123663]=0;f[123664]=0;f[123665]=0;f[123666]=0;f[123667]=1;f[123668]=1;b[494680]=1;f[123672]=113292;f[123673]=0;f[123674]=0;f[123675]=0;f[123676]=0;f[123677]=0;f[123678]=1;b[494720]=1;f[123682]=113400;f[123683]=0;f[123684]=0;f[123685]=0;f[123686]=1;f[123687]=1;b[494752]=1;f[123690]=113508;f[123691]=0;f[123692]=0;f[123693]=0;b[494776]=0;n[123695]=.9990000128746033;n[123696]=9.999999747378752e-06;b[494792]=1;f[123700]=113616;f[123701]=0;f[123702]=0;f[123703]=0;f[123704]=0;f[123705]=1;f[123706]=1;b[494832]=1;f[123710]=113724;f[123711]=0;f[123712]=0;f[123713]=0;b[494856]=0;n[123715]=1.0;b[494864]=1;f[123718]=113832;f[123719]=0;e=494880;g=e+96|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));b[494976]=0;f[123745]=1;b[494984]=1;f[123747]=1;b[494992]=1;f[123750]=113940;f[123751]=0;f[123752]=0;f[123753]=0;f[123754]=0;f[123755]=0;f[123756]=0;f[123757]=2;b[495032]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123760]=114048;f[123761]=0;f[123762]=0;f[123763]=0;f[123764]=497760;f[123765]=497760;f[123766]=0;f[123767]=0;f[123768]=0;f[123769]=0;d[247540]=0;n[123771]=1.0;f[123772]=4;b[495096]=1;f[123776]=114156;f[123777]=0;f[123778]=0;f[123779]=0;f[123780]=0;n[123781]=.30000001192092896;n[123782]=1.0;b[495136]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123786]=114264;f[123787]=0;f[123788]=0;f[123789]=0;f[123790]=497760;f[123791]=497760;f[123792]=497760;f[123793]=497760;f[123794]=497760;f[123795]=0;b[495184]=1;f[123798]=114372;f[123799]=0;f[123800]=0;f[123801]=0;n[123802]=.5;b[495212]=1;b[495216]=1;f[123806]=114480;f[123807]=0;e=495232;g=e+88|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));b[495320]=1;f[123832]=114588;f[123833]=0;f[123834]=0;f[123835]=0;f[123836]=0;f[123837]=0;f[123838]=0;f[123839]=1;b[495360]=1;b[495368]=1;f[123844]=114696;f[123845]=0;f[123846]=0;f[123847]=0;n[123848]=1.0;b[495400]=1;f[123852]=114804;f[123853]=0;f[123854]=0;f[123855]=0;f[123856]=0;f[123857]=0;f[123858]=0;f[123859]=0;b[495440]=1;b[495448]=1;f[123864]=114912;f[123865]=0;f[123866]=0;f[123867]=0;n[123868]=0.0;n[123869]=-1.0;n[123870]=1.0;b[495488]=1;f[123874]=115020;f[123875]=0;f[123876]=0;f[123877]=0;f[123878]=1;f[123879]=-1;b[495520]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123882]=115128;f[123883]=0;f[123884]=0;f[123885]=0;f[123886]=497760;f[123887]=0;b[495552]=0;b[495560]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123892]=115236;f[123893]=0;f[123894]=0;f[123895]=0;f[123896]=497760;b[495592]=1;f[123900]=115344;f[123901]=0;f[123902]=0;f[123903]=0;f[123904]=1;b[495624]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123908]=115452;f[123909]=0;f[123910]=0;f[123911]=0;f[123912]=497760;f[123913]=497760;f[123914]=497760;f[123915]=0;f[123916]=0;f[123917]=0;f[123918]=0;f[123919]=0;n[123920]=1.0;f[123921]=1;b[495688]=1;b[495696]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[123926]=115560;f[123927]=0;f[123928]=0;f[123929]=0;f[123930]=497760;b[495728]=1;f[123934]=115668;f[123935]=0;f[123936]=0;f[123937]=0;f[123938]=0;f[123939]=0;f[123940]=0;b[495764]=0;b[495765]=1;f[123942]=1;b[495776]=1;f[123946]=115776;f[123947]=0;f[123948]=0;f[123949]=0;f[123950]=0;f[123951]=0;f[123952]=0;f[123953]=0;b[495816]=1;f[123956]=115884;f[123957]=0;f[123958]=0;f[123959]=0;n[123960]=0.0;n[123961]=-1.0;n[123962]=1.0;b[495856]=1;f[123966]=115992;f[123967]=0;f[123968]=0;f[123969]=0;f[123970]=0;f[123971]=0;f[123972]=5;n[123973]=1.0;n[123974]=.75;n[123975]=1.0;b[495904]=1;f[123978]=116100;f[123979]=0;f[123980]=0;f[123981]=0;f[123982]=0;f[123983]=0;f[123984]=0;f[123985]=0;b[495944]=1;f[123988]=116208;f[123989]=0;f[123990]=0;f[123991]=0;b[495968]=0;b[495969]=1;n[123993]=9.999999717180685e-10;b[495976]=1;f[123996]=116316;f[123997]=0;f[123998]=0;f[123999]=0;f[124e3]=0;b[496008]=1;f[124004]=116424;f[124005]=0;e=496024;g=e+48|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));b[496072]=0;f[124019]=1;b[496080]=1;b[496088]=1;f[124024]=116532;f[124025]=0;f[124026]=0;f[124027]=0;n[124028]=0.0;n[124029]=1.0;n[124030]=1.0;b[496128]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124034]=116640;f[124035]=0;f[124036]=0;f[124037]=0;f[124038]=497760;f[124039]=497760;f[124040]=497760;b[496164]=0;b[496168]=1;f[124044]=116748;f[124045]=0;f[124046]=0;f[124047]=0;f[124048]=0;f[124049]=0;f[124050]=0;d[248102]=0;b[496208]=1;f[124054]=116856;f[124055]=0;f[124056]=0;f[124057]=0;f[124058]=0;f[124059]=1;n[124060]=1.0;b[496248]=1;f[124064]=116964;f[124065]=0;f[124066]=0;f[124067]=0;f[124068]=0;f[124069]=0;b[496280]=1;f[124072]=117072;f[124073]=0;f[124074]=0;f[124075]=0;f[124076]=0;f[124077]=0;f[124078]=-1;b[496320]=1;f[124082]=117180;f[124083]=0;f[124084]=0;f[124085]=0;f[124086]=0;f[124087]=0;b[496352]=0;f[124089]=1;f[124090]=1;b[496368]=1;f[124094]=117288;f[124095]=0;f[124096]=0;f[124097]=0;f[124098]=0;b[496400]=1;f[124102]=117396;f[124103]=0;f[124104]=0;f[124105]=0;f[124106]=0;f[124107]=0;f[124108]=0;f[124109]=1;f[124110]=1;b[496448]=1;f[124114]=117504;f[124115]=0;f[124116]=0;f[124117]=0;f[124118]=0;f[124119]=1;b[496480]=1;f[124122]=117612;f[124123]=0;f[124124]=0;f[124125]=0;f[124126]=0;b[496512]=1;f[124130]=117720;f[124131]=0;f[124132]=0;f[124133]=0;f[124134]=0;f[124135]=1;b[496544]=1;f[124138]=117828;f[124139]=0;f[124140]=0;f[124141]=0;n[124142]=0.0;b[496576]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}j=L5b(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[j+11>>0]=4;b[j>>0]=119;b[j+1>>0]=97;b[j+2>>0]=114;b[j+3>>0]=112;b[j+4>>0]=0;f[213031]=j;f[124146]=117936;f[124147]=0;f[124148]=0;f[124149]=0;f[124150]=497760;f[124151]=497760;f[124152]=j;f[124153]=497760;f[124154]=0;f[124155]=0;f[124156]=0;f[124157]=0;n[124158]=1.0;n[124159]=.5;n[124160]=.5;n[124161]=.25;b[496648]=1;f[124164]=118044;f[124165]=0;f[124166]=0;f[124167]=0;f[124168]=0;f[124169]=0;f[124170]=0;b[496688]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124174]=118152;Nac(496700,0,156)|0;f[124214]=497760;Nac(496860,0,132)|0;b[496992]=1;if((f[213345]|0)==2){k=L5b(12)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;l=k+11|0;b[l>>0]=4;b[k>>0]=119;b[k+1>>0]=97;b[k+2>>0]=114;b[k+3>>0]=112;m=k+4|0;b[m>>0]=0;f[213032]=k;f[124250]=118260;e=497004;g=e+52|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[124264]=497760;f[124265]=497760;f[124266]=497760;f[124267]=497760;o=k;f[124268]=o;e=497076;g=e+64|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[124285]=1;b[497144]=1;f[124287]=1;f[124288]=1;n[124289]=.5;f[124290]=5;n[124291]=1.0;n[124292]=.75;n[124293]=1.0;n[124294]=1.0;n[124295]=.5;n[124296]=.5;n[124297]=.25;f[124298]=0;b[497200]=1;f[124302]=118368;f[124303]=0;f[124304]=0;f[124305]=0;f[124306]=0;b[497228]=0;b[497232]=1;f[124310]=118476;f[124311]=0;e=497248;g=e+40|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));b[497288]=1;f[124324]=118584;f[124325]=0;f[124326]=0;f[124327]=0;f[124328]=0;f[124329]=0;n[124330]=1.0;b[497328]=1;f[124334]=118692;f[124335]=0;f[124336]=0;f[124337]=0;f[124338]=0;f[124339]=0;f[124340]=0;f[124341]=0;f[124342]=0;f[124343]=0;f[124344]=16;f[124345]=16;f[124346]=16;f[124347]=6e3;f[124348]=300;n[124349]=.699999988079071;b[497400]=1;f[124352]=118800;f[124353]=0;f[124354]=0;f[124355]=0;f[124356]=0;f[124357]=0;f[124358]=0;b[497440]=1;f[123281]=493e3;f[123314]=493544;f[123358]=495104;f[123359]=495144;f[123424]=494008;f[123456]=493600;f[123457]=493600;f[123458]=494008;f[123580]=494552;f[123581]=494608;f[123582]=494648;f[123583]=494688;f[123584]=494760;f[123585]=494800;f[123586]=494728;f[123587]=494840;f[123588]=494872;f[123589]=495e3;f[123590]=495040;f[123591]=493416;f[123592]=495192;f[123593]=495224;f[123594]=495328;f[123595]=495376;f[123596]=495408;f[123597]=495456;f[123598]=495496;f[123599]=495528;f[123600]=495568;f[123601]=495600;f[123602]=495632;f[123603]=495704;f[123604]=495736;f[123605]=495784;f[123606]=495824;f[123607]=495864;f[123608]=495912;f[123609]=495952;f[123610]=493240;f[123611]=493200;f[123612]=495984;f[123613]=496016;f[123614]=496096;f[123615]=497208;f[123616]=493280;f[123617]=497336;f[123618]=497408;f[123619]=496136;f[123620]=496176;f[123621]=496216;f[123622]=496256;f[123623]=496288;f[123624]=497296;f[123625]=496328;f[123626]=496376;f[123627]=496456;f[123628]=496656;f[123629]=496408;f[123630]=496488;f[123631]=496552;f[123632]=496520;f[123633]=496584;f[123704]=493544;f[123734]=493544;f[123735]=493544;f[123856]=493544;f[123857]=493544;f[123938]=493544;f[123939]=493544;f[124e3]=493e3;f[124048]=493544;f[124049]=493544;f[124076]=493e3;f[124086]=493544;f[124087]=493544;f[124215]=494648;f[124216]=494688;f[124217]=494728;f[124218]=494840;f[124219]=494872;f[124220]=495040;f[124221]=495192;f[124222]=495224;f[124223]=495328;f[124224]=495456;f[124225]=495528;f[124226]=495568;f[124227]=495600;f[124228]=495632;f[124229]=495704;f[124230]=495736;f[124231]=495864;f[124232]=495912;f[124233]=495952;f[124234]=496016;f[124235]=496096;f[124236]=496256;f[124237]=496376;f[124238]=496456;f[124239]=496408;f[124240]=496488;f[124241]=496552;f[124242]=496584;f[124243]=494552;f[124244]=494608;f[124245]=497e3;f[124269]=493544;f[124270]=493544;f[124271]=495568;f[124306]=493544;u=a;return}f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c);k=L5b(12)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;l=k+11|0;b[l>>0]=4;b[k>>0]=119;b[k+1>>0]=97;b[k+2>>0]=114;b[k+3>>0]=112;m=k+4|0;b[m>>0]=0;f[213032]=k;f[124250]=118260;e=497004;g=e+52|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[124264]=497760;f[124265]=497760;f[124266]=497760;f[124267]=497760;o=k;f[124268]=o;e=497076;g=e+64|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[124285]=1;b[497144]=1;f[124287]=1;f[124288]=1;n[124289]=.5;f[124290]=5;n[124291]=1.0;n[124292]=.75;n[124293]=1.0;n[124294]=1.0;n[124295]=.5;n[124296]=.5;n[124297]=.25;f[124298]=0;b[497200]=1;f[124302]=118368;f[124303]=0;f[124304]=0;f[124305]=0;f[124306]=0;b[497228]=0;b[497232]=1;f[124310]=118476;f[124311]=0;e=497248;g=e+40|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));b[497288]=1;f[124324]=118584;f[124325]=0;f[124326]=0;f[124327]=0;f[124328]=0;f[124329]=0;n[124330]=1.0;b[497328]=1;f[124334]=118692;f[124335]=0;f[124336]=0;f[124337]=0;f[124338]=0;f[124339]=0;f[124340]=0;f[124341]=0;f[124342]=0;f[124343]=0;f[124344]=16;f[124345]=16;f[124346]=16;f[124347]=6e3;f[124348]=300;n[124349]=.699999988079071;b[497400]=1;f[124352]=118800;f[124353]=0;f[124354]=0;f[124355]=0;f[124356]=0;f[124357]=0;f[124358]=0;b[497440]=1;f[123281]=493e3;f[123314]=493544;f[123358]=495104;f[123359]=495144;f[123424]=494008;f[123456]=493600;f[123457]=493600;f[123458]=494008;f[123580]=494552;f[123581]=494608;f[123582]=494648;f[123583]=494688;f[123584]=494760;f[123585]=494800;f[123586]=494728;f[123587]=494840;f[123588]=494872;f[123589]=495e3;f[123590]=495040;f[123591]=493416;f[123592]=495192;f[123593]=495224;f[123594]=495328;f[123595]=495376;f[123596]=495408;f[123597]=495456;f[123598]=495496;f[123599]=495528;f[123600]=495568;f[123601]=495600;f[123602]=495632;f[123603]=495704;f[123604]=495736;f[123605]=495784;f[123606]=495824;f[123607]=495864;f[123608]=495912;f[123609]=495952;f[123610]=493240;f[123611]=493200;f[123612]=495984;f[123613]=496016;f[123614]=496096;f[123615]=497208;f[123616]=493280;f[123617]=497336;f[123618]=497408;f[123619]=496136;f[123620]=496176;f[123621]=496216;f[123622]=496256;f[123623]=496288;f[123624]=497296;f[123625]=496328;f[123626]=496376;f[123627]=496456;f[123628]=496656;f[123629]=496408;f[123630]=496488;f[123631]=496552;f[123632]=496520;f[123633]=496584;f[123704]=493544;f[123734]=493544;f[123735]=493544;f[123856]=493544;f[123857]=493544;f[123938]=493544;f[123939]=493544;f[124e3]=493e3;f[124048]=493544;f[124049]=493544;f[124076]=493e3;f[124086]=493544;f[124087]=493544;f[124215]=494648;f[124216]=494688;f[124217]=494728;f[124218]=494840;f[124219]=494872;f[124220]=495040;f[124221]=495192;f[124222]=495224;f[124223]=495328;f[124224]=495456;f[124225]=495528;f[124226]=495568;f[124227]=495600;f[124228]=495632;f[124229]=495704;f[124230]=495736;f[124231]=495864;f[124232]=495912;f[124233]=495952;f[124234]=496016;f[124235]=496096;f[124236]=496256;f[124237]=496376;f[124238]=496456;f[124239]=496408;f[124240]=496488;f[124241]=496552;f[124242]=496584;f[124243]=494552;f[124244]=494608;f[124245]=497e3;f[124269]=493544;f[124270]=493544;f[124271]=495568;f[124306]=493544;u=a;return}function TLa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[213035]|0)!=2){f[c>>2]=135812;f[c+4>>2]=39;b[c+8>>0]=0;Gpb(852140,c);hpb(c)}WNb(f[213036]|0,493e3);WNb(f[213038]|0,493040);WNb(f[213040]|0,493160);WNb(f[213042]|0,493200);WNb(f[213044]|0,493240);WNb(f[213046]|0,493280);WNb(f[213049]|0,493416);WNb(f[213051]|0,493480);WNb(f[213053]|0,493544);WNb(f[213056]|0,493600);WNb(f[213058]|0,493712);WNb(f[213063]|0,493952);WNb(f[213065]|0,494008);WNb(f[213067]|0,494056);WNb(f[213069]|0,494128);WNb(f[213072]|0,494168);WNb(f[213074]|0,494552);WNb(f[213076]|0,494608);WNb(f[213079]|0,494648);WNb(f[213081]|0,494688);WNb(f[213083]|0,494728);WNb(f[213085]|0,494760);WNb(f[213087]|0,494800);WNb(f[213089]|0,494840);WNb(f[213091]|0,494872);WNb(f[213094]|0,495e3);WNb(f[213096]|0,495040);WNb(f[213099]|0,495104);WNb(f[213101]|0,495144);WNb(f[213103]|0,495192);WNb(f[213105]|0,495224);WNb(f[213107]|0,495328);WNb(f[213110]|0,495376);WNb(f[213112]|0,495408);WNb(f[213114]|0,495456);WNb(f[213116]|0,495496);WNb(f[213118]|0,495528);WNb(f[213120]|0,495568);WNb(f[213122]|0,495600);WNb(f[213125]|0,495632);WNb(f[213127]|0,495704);WNb(f[213129]|0,495736);WNb(f[213131]|0,495784);WNb(f[213133]|0,495824);WNb(f[213135]|0,495864);WNb(f[213139]|0,495912);WNb(f[213141]|0,495952);WNb(f[213143]|0,495984);WNb(f[213145]|0,496016);WNb(f[213149]|0,496096);WNb(f[213151]|0,496136);WNb(f[213153]|0,496176);WNb(f[213155]|0,496216);WNb(f[213158]|0,496256);WNb(f[213161]|0,496288);WNb(f[213163]|0,496328);WNb(f[213165]|0,496376);WNb(f[213168]|0,496408);WNb(f[213170]|0,496456);WNb(f[213173]|0,496488);WNb(f[213176]|0,496520);WNb(f[213178]|0,496552);WNb(f[213180]|0,496584);WNb(f[213182]|0,496656);WNb(f[213186]|0,496696);WNb(f[213190]|0,497e3);WNb(f[213193]|0,497208);WNb(f[213195]|0,497240);WNb(f[213197]|0,497296);WNb(f[213199]|0,497336);WNb(f[213201]|0,497408);u=a;return}function ULa(){var a=0;if(b[493032]|0){b[493032]=0;bi[f[f[123250]>>2]&2047](493e3)}a=f[213037]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[493152]|0){b[493152]=0;bi[f[f[123260]>>2]&2047](493040)}a=f[213039]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[493192]|0){b[493192]=0;bi[f[f[123290]>>2]&2047](493160)}a=f[213041]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[493232]|0){b[493232]=0;bi[f[f[123300]>>2]&2047](493200)}a=f[213043]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[493272]|0){b[493272]=0;bi[f[f[123310]>>2]&2047](493240)}a=f[213045]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[493408]|0){b[493408]=0;bi[f[f[123320]>>2]&2047](493280)}a=f[213047]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[493472]|0){b[493472]=0;bi[f[f[123354]>>2]&2047](493416)}a=f[213050]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[493536]|0){b[493536]=0;bi[f[f[123370]>>2]&2047](493480)}a=f[213052]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[493592]|0){b[493592]=0;bi[f[f[123386]>>2]&2047](493544)}a=f[213054]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);a=f[213028]|0;if(a|0){if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a)}if(b[493704]|0){b[493704]=0;bi[f[f[123400]>>2]&2047](493600)}a=f[213057]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[493944]|0){b[493944]=0;bi[f[f[123428]>>2]&2047](493712)}a=f[213059]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);a=f[213029]|0;if(a|0){if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a)}a=f[213030]|0;if(a|0){if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a)}if(b[494e3]|0){b[494e3]=0;bi[f[f[123488]>>2]&2047](493952)}a=f[213064]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[494048]|0){b[494048]=0;bi[f[f[123502]>>2]&2047](494008)}a=f[213066]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[494120]|0){b[494120]=0;bi[f[f[123514]>>2]&2047](494056)}a=f[213068]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[494160]|0){b[494160]=0;bi[f[f[123532]>>2]&2047](494128)}a=f[213070]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[494544]|0){b[494544]=0;bi[f[f[123542]>>2]&2047](494168)}a=f[213073]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[494600]|0){b[494600]=0;bi[f[f[123638]>>2]&2047](494552)}a=f[213075]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[494640]|0){b[494640]=0;bi[f[f[123652]>>2]&2047](494608)}a=f[213077]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[494680]|0){b[494680]=0;bi[f[f[123662]>>2]&2047](494648)}a=f[213080]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[494720]|0){b[494720]=0;bi[f[f[123672]>>2]&2047](494688)}a=f[213082]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[494752]|0){b[494752]=0;bi[f[f[123682]>>2]&2047](494728)}a=f[213084]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[494792]|0){b[494792]=0;bi[f[f[123690]>>2]&2047](494760)}a=f[213086]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[494832]|0){b[494832]=0;bi[f[f[123700]>>2]&2047](494800)}a=f[213088]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[494864]|0){b[494864]=0;bi[f[f[123710]>>2]&2047](494840)}a=f[213090]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[494992]|0){b[494992]=0;bi[f[f[123718]>>2]&2047](494872)}a=f[213092]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495032]|0){b[495032]=0;bi[f[f[123750]>>2]&2047](495e3)}a=f[213095]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495096]|0){b[495096]=0;bi[f[f[123760]>>2]&2047](495040)}a=f[213097]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495136]|0){b[495136]=0;bi[f[f[123776]>>2]&2047](495104)}a=f[213100]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495184]|0){b[495184]=0;bi[f[f[123786]>>2]&2047](495144)}a=f[213102]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495216]|0){b[495216]=0;bi[f[f[123798]>>2]&2047](495192)}a=f[213104]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495320]|0){b[495320]=0;bi[f[f[123806]>>2]&2047](495224)}a=f[213106]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495368]|0){b[495368]=0;bi[f[f[123832]>>2]&2047](495328)}a=f[213108]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495400]|0){b[495400]=0;bi[f[f[123844]>>2]&2047](495376)}a=f[213111]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495448]|0){b[495448]=0;bi[f[f[123852]>>2]&2047](495408)}a=f[213113]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495488]|0){b[495488]=0;bi[f[f[123864]>>2]&2047](495456)}a=f[213115]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495520]|0){b[495520]=0;bi[f[f[123874]>>2]&2047](495496)}a=f[213117]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495560]|0){b[495560]=0;bi[f[f[123882]>>2]&2047](495528)}a=f[213119]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495592]|0){b[495592]=0;bi[f[f[123892]>>2]&2047](495568)}a=f[213121]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495624]|0){b[495624]=0;bi[f[f[123900]>>2]&2047](495600)}a=f[213123]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495696]|0){b[495696]=0;bi[f[f[123908]>>2]&2047](495632)}a=f[213126]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495728]|0){b[495728]=0;bi[f[f[123926]>>2]&2047](495704)}a=f[213128]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495776]|0){b[495776]=0;bi[f[f[123934]>>2]&2047](495736)}a=f[213130]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495816]|0){b[495816]=0;bi[f[f[123946]>>2]&2047](495784)}a=f[213132]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495856]|0){b[495856]=0;bi[f[f[123956]>>2]&2047](495824)}a=f[213134]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495904]|0){b[495904]=0;bi[f[f[123966]>>2]&2047](495864)}a=f[213136]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495944]|0){b[495944]=0;bi[f[f[123978]>>2]&2047](495912)}a=f[213140]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[495976]|0){b[495976]=0;bi[f[f[123988]>>2]&2047](495952)}a=f[213142]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496008]|0){b[496008]=0;bi[f[f[123996]>>2]&2047](495984)}a=f[213144]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496088]|0){b[496088]=0;bi[f[f[124004]>>2]&2047](496016)}a=f[213146]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496128]|0){b[496128]=0;bi[f[f[124024]>>2]&2047](496096)}a=f[213150]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496168]|0){b[496168]=0;bi[f[f[124034]>>2]&2047](496136)}a=f[213152]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496208]|0){b[496208]=0;bi[f[f[124044]>>2]&2047](496176)}a=f[213154]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496248]|0){b[496248]=0;bi[f[f[124054]>>2]&2047](496216)}a=f[213156]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496280]|0){b[496280]=0;bi[f[f[124064]>>2]&2047](496256)}a=f[213159]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496320]|0){b[496320]=0;bi[f[f[124072]>>2]&2047](496288)}a=f[213162]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496368]|0){b[496368]=0;bi[f[f[124082]>>2]&2047](496328)}a=f[213164]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496400]|0){b[496400]=0;bi[f[f[124094]>>2]&2047](496376)}a=f[213166]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496448]|0){b[496448]=0;bi[f[f[124102]>>2]&2047](496408)}a=f[213169]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496480]|0){b[496480]=0;bi[f[f[124114]>>2]&2047](496456)}a=f[213171]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496512]|0){b[496512]=0;bi[f[f[124122]>>2]&2047](496488)}a=f[213174]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496544]|0){b[496544]=0;bi[f[f[124130]>>2]&2047](496520)}a=f[213177]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496576]|0){b[496576]=0;bi[f[f[124138]>>2]&2047](496552)}a=f[213179]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496648]|0){b[496648]=0;bi[f[f[124146]>>2]&2047](496584)}a=f[213181]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);a=f[213031]|0;if(a|0){if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a)}if(b[496688]|0){b[496688]=0;bi[f[f[124164]>>2]&2047](496656)}a=f[213183]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[496992]|0){b[496992]=0;bi[f[f[124174]>>2]&2047](496696)}a=f[213187]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[497200]|0){b[497200]=0;bi[f[f[124250]>>2]&2047](497e3)}a=f[213191]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);a=f[213032]|0;if(a|0){if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a)}if(b[497232]|0){b[497232]=0;bi[f[f[124302]>>2]&2047](497208)}a=f[213194]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[497288]|0){b[497288]=0;bi[f[f[124310]>>2]&2047](497240)}a=f[213196]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[497328]|0){b[497328]=0;bi[f[f[124324]>>2]&2047](497296)}a=f[213198]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[497400]|0){b[497400]=0;bi[f[f[124334]>>2]&2047](497336)}a=f[213200]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[497440]|0){b[497440]=0;bi[f[f[124352]>>2]&2047](497408)}a=f[213202]|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function VLa(a){a=a|0;var b=0,c=0;f[a>>2]=118800;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function WLa(a){a=a|0;var b=0,c=0;f[a>>2]=118800;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function XLa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function YLa(a,b){a=a|0;b=b|0;a=L5b(28)|0;kMa(a);if(!b)return a|0;lMa(b,a);return a|0}function ZLa(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function _La(a){a=a|0;return (f[a+8>>2]&7|0)==7|0}function $La(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+16|0;l=a+20|0;m=a+24|0;n=c+32|0;o=c+12|0;p=c+28|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[i>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[i>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=37}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=43;break a;break}case 13:break;default:{z=t;break b}}f[j>>2]=f[j>>2]|1;s=f[g>>2]|0;a=f[c>>2]|0;if((s-a|0)>3){r=a;A=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=A;r=a+4|0;f[c>>2]=r;B=A;C=r;D=s}else{if(!(Xnb(c,e)|0)){v=12;break a}B=f[e>>2]|0;C=f[c>>2]|0;D=f[g>>2]|0}f[k>>2]=B;if(C>>>0>=D>>>0)continue a;if((b[C>>0]|0)!=16)continue a;s=C+1|0;f[c>>2]=s;E=s;F=D;v=18;break}case 2:{switch(t|0){case 0:{y=1;v=43;break a;break}case 16:break;default:{z=t;break b}}E=f[c>>2]|0;F=f[g>>2]|0;v=18;break}case 3:{switch(t|0){case 0:{y=1;v=43;break a;break}case 24:break;default:{z=t;break b}}G=f[c>>2]|0;H=f[g>>2]|0;break}default:{x=t;v=37;break b}}if((v|0)==18){v=0;f[j>>2]=f[j>>2]|2;if(E>>>0<F>>>0){s=b[E>>0]|0;r=s&255;if(s<<24>>24>-1){s=E+1|0;f[c>>2]=s;I=r;K=s;L=F}else{M=r;v=21}}else{M=0;v=21}if((v|0)==21){v=0;r=Knb(c,M)|0;s=J;if(!((s|0)>-1|(s|0)==-1&r>>>0>4294967295)){y=0;v=43;break a}I=r;K=f[c>>2]|0;L=f[g>>2]|0}f[l>>2]=I;if(K>>>0>=L>>>0)continue a;if((b[K>>0]|0)!=24)continue a;r=K+1|0;f[c>>2]=r;G=r;H=L}f[j>>2]=f[j>>2]|4;if(G>>>0<H>>>0){r=b[G>>0]|0;s=r&255;if(r<<24>>24>-1){r=G+1|0;f[c>>2]=r;N=s;O=r;P=H}else{Q=s;v=31}}else{Q=0;v=31}if((v|0)==31){v=0;s=Knb(c,Q)|0;r=J;if(!((r|0)>-1|(r|0)==-1&s>>>0>4294967295)){y=0;v=43;break a}N=s;O=f[c>>2]|0;P=f[g>>2]|0}f[m>>2]=N;if((O|0)!=(P|0))continue a;if(f[n>>2]|0){v=36;break a}if((f[o>>2]|0)==(f[p>>2]|0)){v=36;break a}else continue a}while(0);if((v|0)==37){v=0;if(!x){y=1;v=43;break}else z=x}if((z&7|0)==4){y=1;v=43;break}s=f[q>>2]|0;if(!(s&1))R=hBa(q)|0;else R=s&-2;if(!(ZPb(c,z,R)|0)){y=0;v=43;break}}if((v|0)==12){y=0;u=d;return y|0}else if((v|0)==36){f[i>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==43){u=d;return y|0}return 0}function aMa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=a+8|0;c=f[b>>2]|0;if((c&7|0)!=7){d=c&1|0?5:0;if(!(c&2)){e=d;g=c}else{h=f[a+20>>2]|0;if((h|0)>=0)if(h>>>0<128){i=2;j=c}else{k=(iob(h)|0)+1|0;i=k;j=f[b>>2]|0}else{i=11;j=c}e=i+d|0;g=j}if(!(g&4))l=e;else{g=f[a+24>>2]|0;if((g|0)>=0)if(g>>>0<128)m=2;else m=(iob(g)|0)+1|0;else m=11;l=m+e|0}}else{e=f[a+20>>2]|0;if((e|0)>=0)if(e>>>0<128)n=8;else n=(iob(e)|0)+7|0;else n=17;e=f[a+24>>2]|0;if((e|0)>=0)if(e>>>0<128)o=1;else o=iob(e)|0;else o=10;l=n+o|0}o=f[a+4>>2]|0;if(!(o&1)){p=l;q=a+12|0;f[q>>2]=p;return p|0}p=(dQb(o&-2)|0)+l|0;q=a+12|0;f[q>>2]=p;return p|0}function bMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Wpb(1,+n[a+16>>2],b);e=f[c>>2]|0}if(!(e&2))g=e;else{Mpb(2,f[a+20>>2]|0,b);g=f[c>>2]|0}if(g&4|0)Mpb(3,f[a+24>>2]|0,b);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,b);return}function cMa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function dMa(a){a=a|0;return f[a+12>>2]|0}function eMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=13;i=d+1|0;b[i>>0]=e;b[i+1>>0]=e>>8;b[i+2>>0]=e>>16;b[i+3>>0]=e>>24;g=d+5|0;h=f[c>>2]|0}do if(!(h&2))j=g;else{d=f[a+20>>2]|0;b[g>>0]=16;e=g+1|0;if((d|0)<0){j=hob(d,((d|0)<0)<<31>>31,e)|0;break}if(d>>>0>127){i=d;k=e;while(1){b[k>>0]=i|128;l=i>>>7;m=k+1|0;if(i>>>0>16383){i=l;k=m}else{n=m;o=l;break}}}else{n=e;o=d}b[n>>0]=o;j=n+1|0}while(0);do if(!(f[c>>2]&4))p=j;else{n=f[a+24>>2]|0;b[j>>0]=24;o=j+1|0;if((n|0)<0){p=hob(n,((n|0)<0)<<31>>31,o)|0;break}if(n>>>0>127){g=n;h=o;while(1){b[h>>0]=g|128;k=g>>>7;i=h+1|0;if(g>>>0>16383){g=k;h=i}else{q=i;r=k;break}}}else{q=o;r=n}b[q>>0]=r;p=q+1|0}while(0);q=f[a+4>>2]|0;if(!(q&1)){s=p;return s|0}s=bQb(q&-2,p)|0;return s|0}function fMa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function gMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((a|0)==(b|0))jMa(56232);c=T6b(b,23288,18776,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[b>>2]|0}if(!(e&2))h=e;else{e=f[c+20>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+20>>2]=e;h=f[b>>2]|0}if(h&4|0){h=f[c+24>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|4;f[a+24>>2]=h}}h=f[c+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function hMa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function iMa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213201];f[a+4>>2]=f[213202];u=c;return}function jMa(a){a=a|0;Enb(389400,a)}function kMa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=118800;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=497408?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function lMa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function mMa(a){a=a|0;var b=0,c=0;f[a>>2]=118692;b=f[a+36>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function nMa(a){a=a|0;mMa(a);O5b(a);return}function oMa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function pMa(a,b){a=a|0;b=b|0;a=L5b(64)|0;EMa(a);if(!b)return a|0;FMa(b,a);return a|0}function qMa(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&231|0){f[a+40>>2]=16;f[a+44>>2]=16;f[a+48>>2]=16;f[a+52>>2]=6e3;f[a+56>>2]=300;n[a+60>>2]=.699999988079071}f[a+16>>2]=0;f[a+28>>2]=0;f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function rMa(a){a=a|0;return 1}function sMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+40|0;l=a+44|0;m=a+48|0;n=a+16|0;o=a+20|0;p=a+24|0;q=a+28|0;r=a+32|0;s=a+36|0;t=a+52|0;v=a+56|0;w=a+60|0;x=c+32|0;y=c+12|0;z=c+28|0;A=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){B=b[a>>0]|0;C=B&255;if(B<<24>>24>0){f[i>>2]=C;f[c>>2]=a+1;D=C;E=6}else{F=C;E=5}}else{F=0;E=5}if((E|0)==5){E=0;C=_nb(c,F)|0;f[i>>2]=C;if((C+-1|0)>>>0<127){D=C;E=6}else{G=C;E=109}}b:do if((E|0)==6){E=0;c:do switch(D>>>3&536870911|0){case 1:{switch(D|0){case 0:{H=1;E=115;break a;break}case 8:break;default:{I=D;break b}}f[j>>2]=f[j>>2]|1;C=f[c>>2]|0;if(C>>>0<(f[g>>2]|0)>>>0){a=b[C>>0]|0;B=a&255;if(a<<24>>24>-1){f[k>>2]=B;a=C+1|0;f[c>>2]=a;K=a}else{L=B;E=11}}else{L=0;E=11}if((E|0)==11){E=0;B=Knb(c,L)|0;a=J;f[k>>2]=B;if(!((a|0)>-1|(a|0)==-1&B>>>0>4294967295)){H=0;E=115;break a}K=f[c>>2]|0}B=f[g>>2]|0;if(K>>>0>=B>>>0)continue a;if((b[K>>0]|0)!=16)continue a;a=K+1|0;f[c>>2]=a;M=B;N=a;E=18;break}case 2:{switch(D|0){case 0:{H=1;E=115;break a;break}case 16:break;default:{I=D;break b}}M=f[g>>2]|0;N=f[c>>2]|0;E=18;break}case 3:{switch(D|0){case 0:{H=1;E=115;break a;break}case 24:break;default:{I=D;break b}}O=f[g>>2]|0;P=f[c>>2]|0;E=28;break}case 4:{switch(D|0){case 0:{H=1;E=115;break a;break}case 37:{Q=f[c>>2]|0;R=f[g>>2]|0;E=38;break c;break}case 34:{if(DMa(c,n)|0){E=53;break c}else{H=0;E=115;break a}break}default:{I=D;break b}}break}case 5:{switch(D|0){case 0:{H=1;E=115;break a;break}case 45:{S=f[c>>2]|0;T=f[g>>2]|0;E=59;break c;break}case 42:{if(DMa(c,q)|0){E=74;break c}else{H=0;E=115;break a}break}default:{I=D;break b}}break}case 6:{switch(D|0){case 0:{H=1;E=115;break a;break}case 48:break;default:{I=D;break b}}a=f[g>>2]|0;U=f[c>>2]|0;V=a;W=a;E=80;break}case 7:{switch(D|0){case 0:{H=1;E=115;break a;break}case 56:break;default:{I=D;break b}}a=f[g>>2]|0;X=f[c>>2]|0;Y=a;Z=a;E=90;break}case 8:{switch(D|0){case 0:{H=1;E=115;break a;break}case 69:break;default:{I=D;break b}}a=f[g>>2]|0;_=f[c>>2]|0;$=a;aa=a;E=100;break}default:{G=D;E=109;break b}}while(0);if((E|0)==18){E=0;f[j>>2]=f[j>>2]|2;if(N>>>0<M>>>0){a=b[N>>0]|0;B=a&255;if(a<<24>>24>-1){f[l>>2]=B;a=N+1|0;f[c>>2]=a;ba=M;ca=a}else{da=B;E=21}}else{da=0;E=21}if((E|0)==21){E=0;B=Knb(c,da)|0;a=J;f[l>>2]=B;if(!((a|0)>-1|(a|0)==-1&B>>>0>4294967295)){H=0;E=115;break a}ba=f[g>>2]|0;ca=f[c>>2]|0}if(ca>>>0>=ba>>>0)continue a;if((b[ca>>0]|0)!=24)continue a;B=ca+1|0;f[c>>2]=B;O=ba;P=B;E=28}if((E|0)==28){E=0;f[j>>2]=f[j>>2]|4;if(P>>>0<O>>>0){B=b[P>>0]|0;a=B&255;if(B<<24>>24>-1){f[m>>2]=a;B=P+1|0;f[c>>2]=B;ea=O;fa=B}else{ga=a;E=31}}else{ga=0;E=31}if((E|0)==31){E=0;a=Knb(c,ga)|0;B=J;f[m>>2]=a;if(!((B|0)>-1|(B|0)==-1&a>>>0>4294967295)){H=0;E=115;break a}ea=f[g>>2]|0;fa=f[c>>2]|0}if(fa>>>0>=ea>>>0)continue a;if((b[fa>>0]|0)==37){ha=fa;ia=ea;E=37}else continue a}while(1){if((E|0)==37){E=0;a=ha+1|0;f[c>>2]=a;Q=a;R=ia;E=38;continue}else if((E|0)==38){E=0;if((R-Q|0)>3){a=Q;B=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=B;f[c>>2]=Q+4;ja=B}else{if(!(Xnb(c,e)|0)){E=51;break a}ja=f[e>>2]|0}B=f[n>>2]|0;if((B|0)==(f[o>>2]|0)){qza(n,B+1|0);ka=f[n>>2]|0}else ka=B;B=f[p>>2]|0;a=ka+1|0;f[n>>2]=a;f[B+4+(ka<<2)>>2]=ja;C=f[c>>2]|0;la=(f[g>>2]|0)-C|0;if((la|0)<=0){E=53;continue}ma=(f[o>>2]|0)-a|0;na=(la>>>0)/5|0;la=(na|0)<(ma|0)?na:ma;if((la|0)<=0){E=53;continue}ma=0;na=C;C=a;while(1){if((b[na>>0]|0)!=37){oa=ma;break}a=na+1|0;pa=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=C;C=C+1|0;f[n>>2]=C;f[B+4+(a<<2)>>2]=pa;pa=ma+1|0;if((pa|0)>=(la|0)){oa=pa;break}else{ma=pa;na=na+5|0}}if((oa|0)<=0){E=53;continue}Tnb(c,oa*5|0)|0;E=53;continue}else if((E|0)==53){E=0;na=f[c>>2]|0;ma=f[g>>2]|0;la=ma;if(na>>>0>=ma>>>0)continue a;if((b[na>>0]|0)==37){ha=na;ia=la;E=37;continue}if((b[na>>0]|0)==45){qa=na;ra=la}else continue a}else if((E|0)==59){E=0;if((T-S|0)>3){la=S;na=h[la>>0]|h[la+1>>0]<<8|h[la+2>>0]<<16|h[la+3>>0]<<24;f[e>>2]=na;f[c>>2]=S+4;sa=na}else{if(!(Xnb(c,e)|0)){E=72;break a}sa=f[e>>2]|0}na=f[q>>2]|0;if((na|0)==(f[r>>2]|0)){qza(q,na+1|0);ta=f[q>>2]|0}else ta=na;na=f[s>>2]|0;la=ta+1|0;f[q>>2]=la;f[na+4+(ta<<2)>>2]=sa;ma=f[c>>2]|0;B=(f[g>>2]|0)-ma|0;if((B|0)<=0){E=74;continue}C=(f[r>>2]|0)-la|0;pa=(B>>>0)/5|0;B=(pa|0)<(C|0)?pa:C;if((B|0)<=0){E=74;continue}C=0;pa=ma;ma=la;while(1){if((b[pa>>0]|0)!=45){ua=C;break}la=pa+1|0;a=h[la>>0]|h[la+1>>0]<<8|h[la+2>>0]<<16|h[la+3>>0]<<24;la=ma;ma=ma+1|0;f[q>>2]=ma;f[na+4+(la<<2)>>2]=a;a=C+1|0;if((a|0)>=(B|0)){ua=a;break}else{C=a;pa=pa+5|0}}if((ua|0)<=0){E=74;continue}Tnb(c,ua*5|0)|0;E=74;continue}else if((E|0)==74){E=0;pa=f[c>>2]|0;C=f[g>>2]|0;B=C;if(pa>>>0>=C>>>0)continue a;if((b[pa>>0]|0)==45){qa=pa;ra=B}else{if((b[pa>>0]|0)!=48)continue a;na=pa+1|0;f[c>>2]=na;U=na;V=C;W=B;E=80;continue}}else if((E|0)==80){E=0;f[j>>2]=f[j>>2]|32;if(U>>>0<V>>>0){B=b[U>>0]|0;C=B&255;if(B<<24>>24>-1){f[t>>2]=C;B=U+1|0;f[c>>2]=B;va=B;wa=V;xa=W}else{ya=C;E=83}}else{ya=0;E=83}if((E|0)==83){E=0;C=Knb(c,ya)|0;B=J;f[t>>2]=C;if(!((B|0)>-1|(B|0)==-1&C>>>0>4294967295)){H=0;E=115;break a}C=f[g>>2]|0;va=f[c>>2]|0;wa=C;xa=C}if(va>>>0>=wa>>>0)continue a;if((b[va>>0]|0)!=56)continue a;C=va+1|0;f[c>>2]=C;X=C;Y=wa;Z=xa;E=90;continue}else if((E|0)==90){E=0;f[j>>2]=f[j>>2]|64;if(X>>>0<Y>>>0){C=b[X>>0]|0;B=C&255;if(C<<24>>24>-1){f[v>>2]=B;C=X+1|0;f[c>>2]=C;za=C;Aa=Y;Ba=Z}else{Ca=B;E=93}}else{Ca=0;E=93}if((E|0)==93){E=0;B=Knb(c,Ca)|0;C=J;f[v>>2]=B;if(!((C|0)>-1|(C|0)==-1&B>>>0>4294967295)){H=0;E=115;break a}B=f[g>>2]|0;za=f[c>>2]|0;Aa=B;Ba=B}if(za>>>0>=Aa>>>0)continue a;if((b[za>>0]|0)!=69)continue a;B=za+1|0;f[c>>2]=B;_=B;$=Ba;aa=Aa;E=100;continue}else if((E|0)==100){E=0;f[j>>2]=f[j>>2]|128;if(($-_|0)>3){E=101;break}else{E=102;break}}B=qa+1|0;f[c>>2]=B;S=B;T=ra;E=59}if((E|0)==101){E=0;B=_;C=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[e>>2]=C;B=_+4|0;f[c>>2]=B;Da=C;Ea=B;Fa=aa}else if((E|0)==102){E=0;if(!(Xnb(c,e)|0)){E=104;break a}Da=f[e>>2]|0;Ea=f[c>>2]|0;Fa=f[g>>2]|0}f[w>>2]=Da;if((Ea|0)!=(Fa|0))continue a;if(f[x>>2]|0){E=108;break a}if((f[y>>2]|0)==(f[z>>2]|0)){E=108;break a}else continue a}while(0);if((E|0)==109){E=0;if(!G){H=1;E=115;break}else I=G}if((I&7|0)==4){H=1;E=115;break}B=f[A>>2]|0;if(!(B&1))Ga=hBa(A)|0;else Ga=B&-2;if(!(ZPb(c,I,Ga)|0)){H=0;E=115;break}}if((E|0)==51){H=0;u=d;return H|0}else if((E|0)==72){H=0;u=d;return H|0}else if((E|0)==104){H=0;u=d;return H|0}else if((E|0)==108){f[i>>2]=0;b[c+24>>0]=1;H=1;u=d;return H|0}else if((E|0)==115){u=d;return H|0}return 0}function tMa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=a+8|0;c=f[b>>2]|0;if(!(c&231))d=0;else{if(c&1){e=f[a+40>>2]|0;if(e>>>0<128){g=2;h=c}else{i=(iob(e)|0)+1|0;g=i;h=f[b>>2]|0}}else{g=0;h=c}if(!(h&2)){j=g;k=h}else{c=f[a+44>>2]|0;if(c>>>0<128){l=2;m=h}else{h=(iob(c)|0)+1|0;l=h;m=f[b>>2]|0}j=l+g|0;k=m}if(!(k&4)){n=j;o=k}else{m=f[a+48>>2]|0;if(m>>>0<128){p=2;q=k}else{k=(iob(m)|0)+1|0;p=k;q=f[b>>2]|0}n=p+j|0;o=q}if(!(o&32)){r=n;s=o}else{q=f[a+52>>2]|0;if(q>>>0<128){t=2;u=o}else{o=(iob(q)|0)+1|0;t=o;u=f[b>>2]|0}r=t+n|0;s=u}if(!(s&64)){v=r;w=s}else{u=f[a+56>>2]|0;if(u>>>0<128){x=2;y=s}else{s=(iob(u)|0)+1|0;x=s;y=f[b>>2]|0}v=x+r|0;w=y}d=w&128|0?v+5|0:v}v=f[a+16>>2]|0;w=f[a+28>>2]|0;y=v+d+(v<<2)+w+(w<<2)|0;w=f[a+4>>2]|0;if(!(w&1)){z=y;A=a+12|0;f[A>>2]=z;return z|0}z=(dQb(w&-2)|0)+y|0;A=a+12|0;f[A>>2]=z;return z|0}function uMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Opb(1,f[a+40>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{Opb(2,f[a+44>>2]|0,b);g=f[c>>2]|0}if(g&4|0)Opb(3,f[a+48>>2]|0,b);g=a+16|0;if((f[g>>2]|0)>0){e=a+24|0;d=0;do{Wpb(4,+n[(f[e>>2]|0)+4+(d<<2)>>2],b);d=d+1|0}while((d|0)<(f[g>>2]|0))}g=a+28|0;if((f[g>>2]|0)>0){d=a+36|0;e=0;do{Wpb(5,+n[(f[d>>2]|0)+4+(e<<2)>>2],b);e=e+1|0}while((e|0)<(f[g>>2]|0))}g=f[c>>2]|0;if(!(g&32))h=g;else{Opb(6,f[a+52>>2]|0,b);h=f[c>>2]|0}if(!(h&64))i=h;else{Opb(7,f[a+56>>2]|0,b);i=f[c>>2]|0}if(i&128|0)Wpb(8,+n[a+60>>2],b);i=f[a+4>>2]|0;if(!(i&1))return;aQb(i&-2,b);return}function vMa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function wMa(a){a=a|0;return f[a+12>>2]|0}function xMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+40>>2]|0;b[d>>0]=8;i=d+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=e}b[m>>0]=n;g=m+1|0;h=f[c>>2]|0}if(!(h&2)){o=g;p=h}else{h=f[a+44>>2]|0;b[g>>0]=16;m=g+1|0;if(h>>>0>127){g=h;n=m;while(1){b[n>>0]=g|128;e=g>>>7;i=n+1|0;if(g>>>0>16383){g=e;n=i}else{q=i;r=e;break}}}else{q=m;r=h}b[q>>0]=r;o=q+1|0;p=f[c>>2]|0}if(!(p&4))s=o;else{p=f[a+48>>2]|0;b[o>>0]=24;q=o+1|0;if(p>>>0>127){o=p;r=q;while(1){b[r>>0]=o|128;h=o>>>7;m=r+1|0;if(o>>>0>16383){o=h;r=m}else{t=m;u=h;break}}}else{t=q;u=p}b[t>>0]=u;s=t+1|0}t=a+16|0;if((f[t>>2]|0)>0){u=a+24|0;p=0;q=s;while(1){r=f[(f[u>>2]|0)+4+(p<<2)>>2]|0;b[q>>0]=37;o=q+1|0;b[o>>0]=r;b[o+1>>0]=r>>8;b[o+2>>0]=r>>16;b[o+3>>0]=r>>24;r=q+5|0;p=p+1|0;if((p|0)>=(f[t>>2]|0)){v=r;break}else q=r}}else v=s;s=a+28|0;if((f[s>>2]|0)>0){q=a+36|0;t=0;p=v;while(1){u=f[(f[q>>2]|0)+4+(t<<2)>>2]|0;b[p>>0]=45;r=p+1|0;b[r>>0]=u;b[r+1>>0]=u>>8;b[r+2>>0]=u>>16;b[r+3>>0]=u>>24;u=p+5|0;t=t+1|0;if((t|0)>=(f[s>>2]|0)){w=u;break}else p=u}}else w=v;v=f[c>>2]|0;if(!(v&32)){x=w;y=v}else{v=f[a+52>>2]|0;b[w>>0]=48;p=w+1|0;if(v>>>0>127){w=v;s=p;while(1){b[s>>0]=w|128;t=w>>>7;q=s+1|0;if(w>>>0>16383){w=t;s=q}else{z=q;A=t;break}}}else{z=p;A=v}b[z>>0]=A;x=z+1|0;y=f[c>>2]|0}if(!(y&64)){B=x;C=y}else{y=f[a+56>>2]|0;b[x>>0]=56;z=x+1|0;if(y>>>0>127){x=y;A=z;while(1){b[A>>0]=x|128;v=x>>>7;p=A+1|0;if(x>>>0>16383){x=v;A=p}else{D=p;E=v;break}}}else{D=z;E=y}b[D>>0]=E;B=D+1|0;C=f[c>>2]|0}if(!(C&128))F=B;else{C=f[a+60>>2]|0;b[B>>0]=69;c=B+1|0;b[c>>0]=C;b[c+1>>0]=C>>8;b[c+2>>0]=C>>16;b[c+3>>0]=C>>24;F=B+5|0}B=f[a+4>>2]|0;if(!(B&1)){G=F;return G|0}G=bQb(B&-2,F)|0;return G|0}function yMa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function zMa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(55641);c=T6b(b,23288,18792,0)|0;if(!c){cOb(b,a);return}else{CMa(a,c);return}}function AMa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function BMa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213199];f[a+4>>2]=f[213200];u=c;return}function CMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+16|0;d=b+16|0;e=f[d>>2]|0;if(e|0){qza(c,(f[c>>2]|0)+e|0);Vac((f[a+24>>2]|0)+4+(f[c>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[c>>2]=(f[c>>2]|0)+(f[d>>2]|0)}d=a+28|0;c=b+28|0;e=f[c>>2]|0;if(e|0){qza(d,(f[d>>2]|0)+e|0);Vac((f[a+36>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+36>>2]|0)+4|0,f[c>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[c>>2]|0)}c=b+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))g=d;else{d=f[b+40>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;f[a+40>>2]=d;g=f[c>>2]|0}if(!(g&2))h=g;else{g=f[b+44>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+44>>2]=g;h=f[c>>2]|0}if(!(h&4))i=h;else{h=f[b+48>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|4;f[a+48>>2]=h;i=f[c>>2]|0}if(!(i&32))j=i;else{i=f[b+52>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|32;f[a+52>>2]=i;j=f[c>>2]|0}if(!(j&64))k=j;else{j=f[b+56>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|64;f[a+56>>2]=j;k=f[c>>2]|0}if(k&128|0){k=f[b+60>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|128;f[a+60>>2]=k}}k=f[b+4>>2]|0;if(!(k&1))return;LPb(k&-2,a+4|0);return}function DMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;i=a+4|0;if(g>>>0<(f[i>>2]|0)>>>0?(j=b[g>>0]|0,j<<24>>24>-1):0){f[a>>2]=g+1;k=j&255}else{j=Znb(a)|0;if((j|0)>-1)k=j;else{l=0;u=d;return l|0}}j=f[c>>2]|0;g=k>>>2;if((g<<2|0)!=(k|0)){l=0;u=d;return l|0}m=Snb(a)|0;n=Qnb(a)|0;if((((m|0)==-1|(n|0)<(m|0)?n:m)|0)>=(k|0)){m=j+g|0;if((f[c>>2]|0)<(m|0)?(qza(c,m),n=f[c>>2]|0,o=m-n|0,(o<<2|0)>0):0)Nac((f[c+8>>2]|0)+((n<<2)+4)|0,0,(((o|-1073741824|0)==-1073741824?1073741823:1073741822)+o<<2)+8|0)|0;f[c>>2]=m;m=f[c+8>>2]|0;if(Unb(a,((m|0)==0?0:m+4|0)+(j<<2)|0,k)|0){l=1;u=d;return l|0}if((f[c>>2]|0)<=0){l=0;u=d;return l|0}f[c>>2]=j;l=0;u=d;return l|0}if(!g){l=1;u=d;return l|0}j=c+4|0;k=c+8|0;m=0;while(1){o=f[a>>2]|0;if(((f[i>>2]|0)-o|0)>3){n=o;p=h[n>>0]|h[n+1>>0]<<8|h[n+2>>0]<<16|h[n+3>>0]<<24;f[e>>2]=p;f[a>>2]=o+4;q=p}else{if(!(Xnb(a,e)|0))break;q=f[e>>2]|0}p=f[c>>2]|0;if((p|0)==(f[j>>2]|0)){qza(c,p+1|0);r=f[c>>2]|0}else r=p;p=f[k>>2]|0;f[c>>2]=r+1;f[p+4+(r<<2)>>2]=q;m=m+1|0;if((m|0)>=(g|0)){l=1;s=23;break}}if((s|0)==23){u=d;return l|0}l=0;u=d;return l|0}function EMa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=118692;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;if((a|0)!=497336?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+40>>2]=16;f[a+44>>2]=16;f[a+48>>2]=16;f[a+52>>2]=6e3;f[a+56>>2]=300;n[a+60>>2]=.699999988079071;u=c;return}function FMa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function GMa(a){a=a|0;var b=0,c=0;f[a>>2]=118584;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function HMa(a){a=a|0;var b=0,c=0;f[a>>2]=118584;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function IMa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function JMa(a,b){a=a|0;b=b|0;a=L5b(28)|0;WMa(a);if(!b)return a|0;XMa(b,a);return a|0}function KMa(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&7|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function LMa(a){a=a|0;return 1}function MMa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+16|0;l=a+20|0;m=a+24|0;n=c+32|0;o=c+12|0;p=c+28|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[i>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[i>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=37}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=43;break a;break}case 8:break;default:{z=t;break b}}f[j>>2]=f[j>>2]|1;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0){a=b[s>>0]|0;r=a&255;if(a<<24>>24>-1){f[k>>2]=r;a=s+1|0;f[c>>2]=a;A=a}else{B=r;v=11}}else{B=0;v=11}if((v|0)==11){v=0;r=Knb(c,B)|0;a=J;f[k>>2]=r;if(!((a|0)>-1|(a|0)==-1&r>>>0>4294967295)){y=0;v=43;break a}A=f[c>>2]|0}r=f[g>>2]|0;if(A>>>0>=r>>>0)continue a;if((b[A>>0]|0)!=16)continue a;a=A+1|0;f[c>>2]=a;C=r;D=a;v=18;break}case 2:{switch(t|0){case 0:{y=1;v=43;break a;break}case 16:break;default:{z=t;break b}}C=f[g>>2]|0;D=f[c>>2]|0;v=18;break}case 3:{switch(t|0){case 0:{y=1;v=43;break a;break}case 29:break;default:{z=t;break b}}a=f[g>>2]|0;E=f[c>>2]|0;F=a;G=a;break}default:{x=t;v=37;break b}}if((v|0)==18){v=0;f[j>>2]=f[j>>2]|2;if(D>>>0<C>>>0){a=b[D>>0]|0;r=a&255;if(a<<24>>24>-1){f[l>>2]=r;a=D+1|0;f[c>>2]=a;H=C;I=a}else{K=r;v=21}}else{K=0;v=21}if((v|0)==21){v=0;r=Knb(c,K)|0;a=J;f[l>>2]=r;if(!((a|0)>-1|(a|0)==-1&r>>>0>4294967295)){y=0;v=43;break a}H=f[g>>2]|0;I=f[c>>2]|0}if(I>>>0>=H>>>0)continue a;if((b[I>>0]|0)!=29)continue a;r=I+1|0;f[c>>2]=r;E=r;F=H;G=H}f[j>>2]=f[j>>2]|4;if((F-E|0)>3){r=E;a=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=a;r=E+4|0;f[c>>2]=r;L=a;M=r;N=G}else{if(!(Xnb(c,e)|0)){v=32;break a}L=f[e>>2]|0;M=f[c>>2]|0;N=f[g>>2]|0}f[m>>2]=L;if((M|0)!=(N|0))continue a;if(f[n>>2]|0){v=36;break a}if((f[o>>2]|0)==(f[p>>2]|0)){v=36;break a}else continue a}while(0);if((v|0)==37){v=0;if(!x){y=1;v=43;break}else z=x}if((z&7|0)==4){y=1;v=43;break}r=f[q>>2]|0;if(!(r&1))O=hBa(q)|0;else O=r&-2;if(!(ZPb(c,z,O)|0)){y=0;v=43;break}}if((v|0)==32){y=0;u=d;return y|0}else if((v|0)==36){f[i>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==43){u=d;return y|0}return 0}function NMa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+8|0;c=f[b>>2]|0;if(!(c&7))d=0;else{if(c&1){e=f[a+16>>2]|0;if(e>>>0<128){g=2;h=c}else{i=(iob(e)|0)+1|0;g=i;h=f[b>>2]|0}}else{g=0;h=c}if(!(h&2)){j=g;k=h}else{c=f[a+20>>2]|0;if(c>>>0<128){l=2;m=h}else{h=(iob(c)|0)+1|0;l=h;m=f[b>>2]|0}j=l+g|0;k=m}d=k&4|0?j+5|0:j}j=f[a+4>>2]|0;if(!(j&1)){n=d;o=a+12|0;f[o>>2]=n;return n|0}n=(dQb(j&-2)|0)+d|0;o=a+12|0;f[o>>2]=n;return n|0}function OMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Opb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{Opb(2,f[a+20>>2]|0,b);g=f[c>>2]|0}if(g&4|0)Wpb(3,+n[a+24>>2],b);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,b);return}function PMa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function QMa(a){a=a|0;return f[a+12>>2]|0}function RMa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=8;i=d+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=e}b[m>>0]=n;g=m+1|0;h=f[c>>2]|0}if(!(h&2)){o=g;p=h}else{h=f[a+20>>2]|0;b[g>>0]=16;m=g+1|0;if(h>>>0>127){g=h;n=m;while(1){b[n>>0]=g|128;e=g>>>7;i=n+1|0;if(g>>>0>16383){g=e;n=i}else{q=i;r=e;break}}}else{q=m;r=h}b[q>>0]=r;o=q+1|0;p=f[c>>2]|0}if(!(p&4))s=o;else{p=f[a+24>>2]|0;b[o>>0]=29;c=o+1|0;b[c>>0]=p;b[c+1>>0]=p>>8;b[c+2>>0]=p>>16;b[c+3>>0]=p>>24;s=o+5|0}o=f[a+4>>2]|0;if(!(o&1)){t=s;return t|0}t=bQb(o&-2,s)|0;return t|0}function SMa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function TMa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((a|0)==(b|0))jMa(55043);c=T6b(b,23288,18808,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[b>>2]|0}if(!(e&2))h=e;else{e=f[c+20>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+20>>2]=e;h=f[b>>2]|0}if(h&4|0){h=f[c+24>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|4;f[a+24>>2]=h}}h=f[c+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function UMa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function VMa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213197];f[a+4>>2]=f[213198];u=c;return}function WMa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=118584;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=497296?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;n[a+24>>2]=1.0;u=c;return}function XMa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function YMa(a){a=a|0;var b=0,c=0;f[a>>2]=118476;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function ZMa(a){a=a|0;var b=0,c=0;f[a>>2]=118476;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function _Ma(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function $Ma(a,b){a=a|0;b=b|0;a=L5b(48)|0;nNa(a);if(!b)return a|0;oNa(b,a);return a|0}function aNa(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function bNa(a){a=a|0;return 1}function cNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+16|0;l=a+20|0;m=a+24|0;n=a+28|0;o=a+32|0;p=a+36|0;q=e+8|0;r=a+40|0;s=a+44|0;t=c+32|0;v=c+12|0;w=c+28|0;x=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){y=b[a>>0]|0;z=y&255;if(y<<24>>24>0){f[i>>2]=z;f[c>>2]=a+1;A=z;B=6}else{C=z;B=5}}else{C=0;B=5}if((B|0)==5){B=0;z=_nb(c,C)|0;f[i>>2]=z;if((z+-1|0)>>>0<127){A=z;B=6}else{D=z;B=87}}b:do if((B|0)==6){B=0;switch(A>>>3&536870911|0){case 1:{switch(A|0){case 0:{E=1;B=93;break a;break}case 13:break;default:{F=A;break b}}f[j>>2]=f[j>>2]|1;z=f[g>>2]|0;a=f[c>>2]|0;if((z-a|0)>3){y=a;G=h[y>>0]|h[y+1>>0]<<8|h[y+2>>0]<<16|h[y+3>>0]<<24;f[e>>2]=G;y=a+4|0;f[c>>2]=y;H=z;I=G;K=y;L=z}else{if(!(Xnb(c,e)|0)){B=12;break a}z=f[g>>2]|0;H=z;I=f[e>>2]|0;K=f[c>>2]|0;L=z}f[k>>2]=I;if(K>>>0>=L>>>0)continue a;if((b[K>>0]|0)!=21)continue a;z=K+1|0;f[c>>2]=z;M=L;N=z;O=H;B=18;break}case 2:{switch(A|0){case 0:{E=1;B=93;break a;break}case 21:break;default:{F=A;break b}}z=f[g>>2]|0;M=z;N=f[c>>2]|0;O=z;B=18;break}case 3:{switch(A|0){case 0:{E=1;B=93;break a;break}case 29:break;default:{F=A;break b}}z=f[g>>2]|0;P=z;Q=f[c>>2]|0;R=z;B=28;break}case 4:{switch(A|0){case 0:{E=1;B=93;break a;break}case 37:break;default:{F=A;break b}}z=f[g>>2]|0;S=z;T=f[c>>2]|0;U=z;B=38;break}case 5:{switch(A|0){case 0:{E=1;B=93;break a;break}case 40:break;default:{F=A;break b}}z=f[g>>2]|0;V=f[c>>2]|0;W=z;X=z;B=48;break}case 6:{switch(A|0){case 0:{E=1;B=93;break a;break}case 48:break;default:{F=A;break b}}z=f[g>>2]|0;Y=f[c>>2]|0;Z=z;_=z;B=58;break}case 7:{switch(A|0){case 0:{E=1;B=93;break a;break}case 61:break;default:{F=A;break b}}z=f[g>>2]|0;$=f[c>>2]|0;aa=z;ba=z;B=68;break}case 8:{switch(A|0){case 0:{E=1;B=93;break a;break}case 69:break;default:{F=A;break b}}z=f[g>>2]|0;ca=f[c>>2]|0;da=z;ea=z;break}default:{D=A;B=87;break b}}if((B|0)==18){B=0;f[j>>2]=f[j>>2]|2;if((O-N|0)>3){z=N;y=h[z>>0]|h[z+1>>0]<<8|h[z+2>>0]<<16|h[z+3>>0]<<24;f[e>>2]=y;z=N+4|0;f[c>>2]=z;fa=O;ga=y;ha=z;ia=M}else{if(!(Xnb(c,e)|0)){B=22;break a}z=f[g>>2]|0;fa=z;ga=f[e>>2]|0;ha=f[c>>2]|0;ia=z}f[l>>2]=ga;if(ha>>>0>=ia>>>0)continue a;if((b[ha>>0]|0)!=29)continue a;z=ha+1|0;f[c>>2]=z;P=ia;Q=z;R=fa;B=28}if((B|0)==28){B=0;f[j>>2]=f[j>>2]|4;if((R-Q|0)>3){z=Q;y=h[z>>0]|h[z+1>>0]<<8|h[z+2>>0]<<16|h[z+3>>0]<<24;f[e>>2]=y;z=Q+4|0;f[c>>2]=z;ja=R;ka=y;la=z;ma=P}else{if(!(Xnb(c,e)|0)){B=32;break a}z=f[g>>2]|0;ja=z;ka=f[e>>2]|0;la=f[c>>2]|0;ma=z}f[m>>2]=ka;if(la>>>0>=ma>>>0)continue a;if((b[la>>0]|0)!=37)continue a;z=la+1|0;f[c>>2]=z;S=ma;T=z;U=ja;B=38}if((B|0)==38){B=0;f[j>>2]=f[j>>2]|8;if((U-T|0)>3){z=T;y=h[z>>0]|h[z+1>>0]<<8|h[z+2>>0]<<16|h[z+3>>0]<<24;f[e>>2]=y;z=T+4|0;f[c>>2]=z;na=y;oa=z;pa=S;qa=U}else{if(!(Xnb(c,e)|0)){B=42;break a}z=f[g>>2]|0;na=f[e>>2]|0;oa=f[c>>2]|0;pa=z;qa=z}f[n>>2]=na;if(oa>>>0>=pa>>>0)continue a;if((b[oa>>0]|0)!=40)continue a;z=oa+1|0;f[c>>2]=z;V=z;W=pa;X=qa;B=48}if((B|0)==48){B=0;f[j>>2]=f[j>>2]|16;if(V>>>0<W>>>0){z=b[V>>0]|0;y=z&255;if(z<<24>>24>-1){z=V+1|0;f[c>>2]=z;ra=y;sa=z;ta=W;ua=X}else{va=y;B=51}}else{va=0;B=51}if((B|0)==51){B=0;y=Knb(c,va)|0;z=J;if(!((z|0)>-1|(z|0)==-1&y>>>0>4294967295)){E=0;B=93;break a}z=f[g>>2]|0;ra=y;sa=f[c>>2]|0;ta=z;ua=z}f[o>>2]=ra;if(sa>>>0>=ta>>>0)continue a;if((b[sa>>0]|0)!=48)continue a;z=sa+1|0;f[c>>2]=z;Y=z;Z=ta;_=ua;B=58}if((B|0)==58){B=0;f[j>>2]=f[j>>2]|32;if(Y>>>0<Z>>>0?(z=b[Y>>0]|0,z<<24>>24>-1):0){y=Y+1|0;f[c>>2]=y;wa=z<<24>>24!=0;xa=y;ya=Z;za=_}else{Lnb(e,c);y=e;if(!(b[q>>0]|0)){E=0;B=93;break a}z=f[g>>2]|0;wa=(f[y>>2]|0)!=0|(f[y+4>>2]|0)!=0;xa=f[c>>2]|0;ya=z;za=z}b[p>>0]=wa&1;if(xa>>>0>=ya>>>0)continue a;if((b[xa>>0]|0)!=61)continue a;z=xa+1|0;f[c>>2]=z;$=z;aa=za;ba=ya;B=68}if((B|0)==68){B=0;f[j>>2]=f[j>>2]|64;if((aa-$|0)>3){z=$;y=h[z>>0]|h[z+1>>0]<<8|h[z+2>>0]<<16|h[z+3>>0]<<24;f[e>>2]=y;z=$+4|0;f[c>>2]=z;Aa=y;Ba=z;Ca=ba;Da=aa}else{if(!(Xnb(c,e)|0)){B=72;break a}z=f[g>>2]|0;Aa=f[e>>2]|0;Ba=f[c>>2]|0;Ca=z;Da=z}f[r>>2]=Aa;if(Ba>>>0>=Ca>>>0)continue a;if((b[Ba>>0]|0)!=69)continue a;z=Ba+1|0;f[c>>2]=z;ca=z;da=Da;ea=Ca}f[j>>2]=f[j>>2]|128;if((da-ca|0)>3){z=ca;y=h[z>>0]|h[z+1>>0]<<8|h[z+2>>0]<<16|h[z+3>>0]<<24;f[e>>2]=y;z=ca+4|0;f[c>>2]=z;Ea=y;Fa=z;Ga=ea}else{if(!(Xnb(c,e)|0)){B=82;break a}Ea=f[e>>2]|0;Fa=f[c>>2]|0;Ga=f[g>>2]|0}f[s>>2]=Ea;if((Fa|0)!=(Ga|0))continue a;if(f[t>>2]|0){B=86;break a}if((f[v>>2]|0)==(f[w>>2]|0)){B=86;break a}else continue a}while(0);if((B|0)==87){B=0;if(!D){E=1;B=93;break}else F=D}if((F&7|0)==4){E=1;B=93;break}z=f[x>>2]|0;if(!(z&1))Ha=hBa(x)|0;else Ha=z&-2;if(!(ZPb(c,F,Ha)|0)){E=0;B=93;break}}if((B|0)==12){E=0;u=d;return E|0}else if((B|0)==22){E=0;u=d;return E|0}else if((B|0)==32){E=0;u=d;return E|0}else if((B|0)==42){E=0;u=d;return E|0}else if((B|0)==72){E=0;u=d;return E|0}else if((B|0)==82){E=0;u=d;return E|0}else if((B|0)==86){f[i>>2]=0;b[c+24>>0]=1;E=1;u=d;return E|0}else if((B|0)==93){u=d;return E|0}return 0}function dNa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=a+8|0;c=f[b>>2]|0;if(!(c&255))d=0;else{e=c&1|0?5:0;g=c&2|0?e+5|0:e;e=c&4|0?g+5|0:g;g=c&8|0?e+5|0:e;if(!(c&16)){h=g;i=c}else{e=f[a+32>>2]|0;if((e|0)>=0)if(e>>>0<128){j=2;k=c}else{l=(iob(e)|0)+1|0;j=l;k=f[b>>2]|0}else{j=11;k=c}h=j+g|0;i=k}k=i&32|0?h+2|0:h;h=i&64|0?k+5|0:k;d=i&128|0?h+5|0:h}h=f[a+4>>2]|0;if(!(h&1)){m=d;n=a+12|0;f[n>>2]=m;return m|0}m=(dQb(h&-2)|0)+d|0;n=a+12|0;f[n>>2]=m;return m|0}function eNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Wpb(1,+n[a+16>>2],c);g=f[d>>2]|0}if(!(g&2))h=g;else{Wpb(2,+n[a+20>>2],c);h=f[d>>2]|0}if(!(h&4))i=h;else{Wpb(3,+n[a+24>>2],c);i=f[d>>2]|0}if(!(i&8))j=i;else{Wpb(4,+n[a+28>>2],c);j=f[d>>2]|0}if(!(j&16))k=j;else{Mpb(5,f[a+32>>2]|0,c);k=f[d>>2]|0}if(!(k&32))l=k;else{Ypb(6,(b[a+36>>0]|0)!=0,c);l=f[d>>2]|0}if(!(l&64))m=l;else{Wpb(7,+n[a+40>>2],c);m=f[d>>2]|0}if(m&128|0)Wpb(8,+n[a+44>>2],c);m=f[a+4>>2]|0;if(!(m&1))return;aQb(m&-2,c);return}function fNa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function gNa(a){a=a|0;return f[a+12>>2]|0}function hNa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=13;i=d+1|0;b[i>>0]=e;b[i+1>>0]=e>>8;b[i+2>>0]=e>>16;b[i+3>>0]=e>>24;g=d+5|0;h=f[c>>2]|0}if(!(h&2)){j=g;k=h}else{h=f[a+20>>2]|0;b[g>>0]=21;d=g+1|0;b[d>>0]=h;b[d+1>>0]=h>>8;b[d+2>>0]=h>>16;b[d+3>>0]=h>>24;j=g+5|0;k=f[c>>2]|0}if(!(k&4)){l=j;m=k}else{k=f[a+24>>2]|0;b[j>>0]=29;g=j+1|0;b[g>>0]=k;b[g+1>>0]=k>>8;b[g+2>>0]=k>>16;b[g+3>>0]=k>>24;l=j+5|0;m=f[c>>2]|0}if(!(m&8)){n=l;o=m}else{m=f[a+28>>2]|0;b[l>>0]=37;j=l+1|0;b[j>>0]=m;b[j+1>>0]=m>>8;b[j+2>>0]=m>>16;b[j+3>>0]=m>>24;n=l+5|0;o=f[c>>2]|0}do if(!(o&16))p=n;else{l=f[a+32>>2]|0;b[n>>0]=40;m=n+1|0;if((l|0)<0){p=hob(l,((l|0)<0)<<31>>31,m)|0;break}if(l>>>0>127){j=l;k=m;while(1){b[k>>0]=j|128;g=j>>>7;h=k+1|0;if(j>>>0>16383){j=g;k=h}else{q=h;r=g;break}}}else{q=m;r=l}b[q>>0]=r;p=q+1|0}while(0);q=f[c>>2]|0;if(!(q&32)){s=p;t=q}else{q=b[a+36>>0]|0;b[p>>0]=48;b[p+1>>0]=q;s=p+2|0;t=f[c>>2]|0}if(!(t&64)){u=s;v=t}else{t=f[a+40>>2]|0;b[s>>0]=61;p=s+1|0;b[p>>0]=t;b[p+1>>0]=t>>8;b[p+2>>0]=t>>16;b[p+3>>0]=t>>24;u=s+5|0;v=f[c>>2]|0}if(!(v&128))w=u;else{v=f[a+44>>2]|0;b[u>>0]=69;c=u+1|0;b[c>>0]=v;b[c+1>>0]=v>>8;b[c+2>>0]=v>>16;b[c+3>>0]=v>>24;w=u+5|0}u=f[a+4>>2]|0;if(!(u&1)){x=w;return x|0}x=bQb(u&-2,w)|0;return x|0}function iNa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function jNa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(54477);c=T6b(b,23288,18824,0)|0;if(!c){cOb(b,a);return}else{mNa(a,c);return}}function kNa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function lNa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213195];f[a+4>>2]=f[213196];u=c;return}function mNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=c+8|0;e=f[d>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=f[c+16>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;f[a+16>>2]=e;g=f[d>>2]|0}if(!(g&2))i=g;else{g=f[c+20>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;f[a+20>>2]=g;i=f[d>>2]|0}if(!(i&4))j=i;else{i=f[c+24>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|4;f[a+24>>2]=i;j=f[d>>2]|0}if(!(j&8))k=j;else{j=f[c+28>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|8;f[a+28>>2]=j;k=f[d>>2]|0}if(!(k&16))l=k;else{k=f[c+32>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|16;f[a+32>>2]=k;l=f[d>>2]|0}if(!(l&32))m=l;else{l=b[c+36>>0]|0;k=a+8|0;f[k>>2]=f[k>>2]|32;b[a+36>>0]=l;m=f[d>>2]|0}if(!(m&64))n=m;else{m=f[c+40>>2]|0;l=a+8|0;f[l>>2]=f[l>>2]|64;f[a+40>>2]=m;n=f[d>>2]|0}if(n&128|0){n=f[c+44>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|128;f[a+44>>2]=n}}n=f[c+4>>2]|0;if(!(n&1))return;LPb(n&-2,a+4|0);return}function nNa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=118476;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=497240?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}d=a+12|0;a=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(a|0));u=c;return}function oNa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function pNa(a){a=a|0;var b=0,c=0;f[a>>2]=118368;if((a|0)!=497208?(b=f[a+16>>2]|0,b|0):0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function qNa(a){a=a|0;pNa(a);O5b(a);return}function rNa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function sNa(a,b){a=a|0;b=b|0;a=L5b(24)|0;KNa(a);if(!b)return a|0;LNa(b,a);return a|0}function tNa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){if(d&1|0?(d=f[a+16>>2]|0,d|0):0){e=d+8|0;g=f[e>>2]|0;if(g&255|0){h=d+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if(g&1|0?(g=f[213028]|0,h=f[d+16>>2]|0,(h|0)!=(g|0)):0)_5b(h,g)|0;n[d+40>>2]=1.0;n[d+44>>2]=1.0;f[d+36>>2]=-1}f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)GPb(d)}b[a+20>>0]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function uNa(a){a=a|0;return 1}function vNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+16|0;k=e+4|0;l=a+20|0;m=c+32|0;n=c+12|0;o=c+28|0;p=e+8|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[h>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[h>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=32}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=38;break a;break}case 10:break;default:{z=t;break b}}f[i>>2]=f[i>>2]|1;s=f[j>>2]|0;if(!s){a=L5b(48)|0;GNa(a);f[j>>2]=a;A=a}else A=s;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(a=b[s>>0]|0,a<<24>>24>-1):0){f[c>>2]=s+1;B=a&255}else{a=Znb(c)|0;if((a|0)>-1)B=a;else{y=0;v=38;break a}}Inb(e,c,B);if((f[k>>2]|0)<0){v=16;break a}if(!(JNa(A,c)|0)){v=16;break a}if(!(Onb(c,f[e>>2]|0)|0)){y=0;v=38;break a}a=f[c>>2]|0;s=f[g>>2]|0;if(a>>>0>=s>>>0)continue a;if((b[a>>0]|0)!=16)continue a;r=a+1|0;f[c>>2]=r;C=r;D=s;break}case 2:{switch(t|0){case 0:{y=1;v=38;break a;break}case 16:break;default:{z=t;break b}}C=f[c>>2]|0;D=f[g>>2]|0;break}default:{x=t;v=32;break b}}f[i>>2]=f[i>>2]|2;if(C>>>0<D>>>0?(s=b[C>>0]|0,s<<24>>24>-1):0){r=C+1|0;f[c>>2]=r;E=s<<24>>24!=0;F=r;G=D}else{Lnb(e,c);r=e;if(!(b[p>>0]|0)){y=0;v=38;break a}E=(f[r>>2]|0)!=0|(f[r+4>>2]|0)!=0;F=f[c>>2]|0;G=f[g>>2]|0}b[l>>0]=E&1;if((F|0)!=(G|0))continue a;if(f[m>>2]|0){v=31;break a}if((f[n>>2]|0)==(f[o>>2]|0)){v=31;break a}else continue a}while(0);if((v|0)==32){v=0;if(!x){y=1;v=38;break}else z=x}if((z&7|0)==4){y=1;v=38;break}r=f[q>>2]|0;if(!(r&1))H=hBa(q)|0;else H=r&-2;if(!(ZPb(c,z,H)|0)){y=0;v=38;break}}if((v|0)==16){y=0;u=d;return y|0}else if((v|0)==31){f[h>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==38){u=d;return y|0}return 0}function wNa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=a+8|0;c=f[b>>2]|0;if(!(c&3))d=0;else{if(!(c&1)){e=0;g=c}else{c=INa(f[a+16>>2]|0)|0;if(c>>>0<128)h=1;else h=iob(c)|0;e=c+1+h|0;g=f[b>>2]|0}d=g&2|0?e+2|0:e}e=f[a+4>>2]|0;if(!(e&1)){i=d;j=a+12|0;f[j>>2]=i;return i|0}i=(dQb(e&-2)|0)+d|0;j=a+12|0;f[j>>2]=i;return i|0}function xNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{eqb(1,f[a+16>>2]|0,c);g=f[d>>2]|0}if(g&2|0)Ypb(2,(b[a+20>>0]|0)!=0,c);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,c);return}function yNa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function zNa(a){a=a|0;return f[a+12>>2]|0}function ANa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=d+1|0;d=f[e+12>>2]|0;if(d>>>0>127){j=d;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=d}b[n>>0]=o;o=li[f[(f[e>>2]|0)+68>>2]&511](e,0,n+1|0)|0;g=o;h=f[c>>2]|0}if(!(h&2))p=g;else{h=b[a+20>>0]|0;b[g>>0]=16;b[g+1>>0]=h;p=g+2|0}g=f[a+4>>2]|0;if(!(g&1)){q=p;return q|0}q=bQb(g&-2,p)|0;return q|0}function BNa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function CNa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(53909);c=T6b(b,23288,18840,0)|0;if(!c){cOb(b,a);return}else{FNa(a,c);return}}function DNa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function ENa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213193];f[a+4>>2]=f[213194];u=c;return}function FNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=c+8|0;e=f[d>>2]|0;if(e&255|0){do if(e&1){g=a+8|0;f[g>>2]=f[g>>2]|1;g=a+16|0;h=f[g>>2]|0;if(!h){i=L5b(48)|0;GNa(i);f[g>>2]=i;j=i}else j=h;h=f[c+16>>2]|0;i=(h|0)==0?493544:h;if((i|0)==(j|0))jMa(8763);else{HNa(j,i);k=f[d>>2]|0;break}}else k=e;while(0);if(k&2|0){k=b[c+20>>0]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;b[a+20>>0]=k}}k=f[c+4>>2]|0;if(!(k&1))return;LPb(k&-2,a+4|0);return}function GNa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=112104;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=493544?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=f[213028];d=a+20|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[a+36>>2]=-1;n[a+40>>2]=1.0;n[a+44>>2]=1.0;u=c;return}function HNa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c+4|0;e=c;g=b+8|0;h=f[g>>2]|0;if(h&255|0){if(!(h&1))i=h;else{h=a+8|0;f[h>>2]=f[h>>2]|1;h=f[213028]|0;f[e>>2]=f[b+16>>2];f[d>>2]=f[e>>2];Anb(a+16|0,h,d);i=f[g>>2]|0}if(!(i&2))j=i;else{i=f[b+20>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+20>>2]=i;j=f[g>>2]|0}if(!(j&4))k=j;else{j=f[b+24>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|4;f[a+24>>2]=j;k=f[g>>2]|0}if(!(k&8))l=k;else{k=f[b+40>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|8;f[a+40>>2]=k;l=f[g>>2]|0}if(!(l&16))m=l;else{l=f[b+28>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|16;f[a+28>>2]=l;m=f[g>>2]|0}if(!(m&32))n=m;else{m=f[b+44>>2]|0;l=a+8|0;f[l>>2]=f[l>>2]|32;f[a+44>>2]=m;n=f[g>>2]|0}if(!(n&64))o=n;else{n=f[b+36>>2]|0;m=a+8|0;f[m>>2]=f[m>>2]|64;f[a+36>>2]=n;o=f[g>>2]|0}if(o&128|0){o=f[b+32>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|128;f[a+32>>2]=o}}o=f[b+4>>2]|0;if(!(o&1)){u=c;return}LPb(o&-2,a+4|0);u=c;return}function INa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=a+8|0;d=f[c>>2]|0;if(d&255){if(!(d&1)){e=0;g=d}else{h=f[a+16>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}l=g&2|0?e+5|0:e;e=g&4|0?l+5|0:l;l=g&8|0?e+5|0:e;e=g&16|0?l+5|0:l;l=g&32|0?e+5|0:e;if(!(g&64)){n=l;o=g}else{e=f[a+36>>2]|0;if((e|0)>=0)if(e>>>0<128){p=2;q=g}else{k=(iob(e)|0)+1|0;p=k;q=f[c>>2]|0}else{p=11;q=g}n=p+l|0;o=q}if(!(o&128))r=n;else{o=f[a+32>>2]|0;if((o|0)>=0)if(o>>>0<128)s=2;else s=(iob(o)|0)+1|0;else s=11;r=s+n|0}}else r=0;n=f[a+4>>2]|0;if(!(n&1)){t=r;u=a+12|0;f[u>>2]=t;return t|0}t=(dQb(n&-2)|0)+r|0;u=a+12|0;f[u>>2]=t;return t|0}function JNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+16|0;l=a+20|0;m=a+24|0;n=a+40|0;o=a+28|0;p=a+44|0;q=a+36|0;r=a+32|0;s=c+32|0;t=c+12|0;v=c+28|0;w=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){x=b[a>>0]|0;y=x&255;if(x<<24>>24>0){f[i>>2]=y;f[c>>2]=a+1;z=y;A=6}else{B=y;A=5}}else{B=0;A=5}if((A|0)==5){A=0;y=_nb(c,B)|0;f[i>>2]=y;if((y+-1|0)>>>0<127){z=y;A=6}else{C=y;A=90}}b:do if((A|0)==6){A=0;switch(z>>>3&536870911|0){case 1:{switch(z|0){case 0:{D=1;A=96;break a;break}case 10:break;default:{E=z;break b}}f[j>>2]=f[j>>2]|1;y=f[213028]|0;a=f[k>>2]|0;if((a|0)==(y|0)){jza(k,y);F=f[k>>2]|0}else F=a;if(!(fqb(c,F)|0)){D=0;A=96;break a}a=f[c>>2]|0;y=f[g>>2]|0;if(a>>>0>=y>>>0)continue a;if((b[a>>0]|0)!=21)continue a;x=a+1|0;f[c>>2]=x;G=x;H=y;A=16;break}case 2:{switch(z|0){case 0:{D=1;A=96;break a;break}case 21:break;default:{E=z;break b}}G=f[c>>2]|0;H=f[g>>2]|0;A=16;break}case 3:{switch(z|0){case 0:{D=1;A=96;break a;break}case 29:break;default:{E=z;break b}}I=f[c>>2]|0;K=f[g>>2]|0;A=26;break}case 4:{switch(z|0){case 0:{D=1;A=96;break a;break}case 37:break;default:{E=z;break b}}L=f[c>>2]|0;M=f[g>>2]|0;A=36;break}case 5:{switch(z|0){case 0:{D=1;A=96;break a;break}case 45:break;default:{E=z;break b}}N=f[c>>2]|0;O=f[g>>2]|0;A=46;break}case 6:{switch(z|0){case 0:{D=1;A=96;break a;break}case 53:break;default:{E=z;break b}}P=f[c>>2]|0;Q=f[g>>2]|0;A=56;break}case 7:{switch(z|0){case 0:{D=1;A=96;break a;break}case 56:break;default:{E=z;break b}}R=f[c>>2]|0;S=f[g>>2]|0;A=66;break}case 8:{switch(z|0){case 0:{D=1;A=96;break a;break}case 64:break;default:{E=z;break b}}T=f[c>>2]|0;U=f[g>>2]|0;break}default:{C=z;A=90;break b}}if((A|0)==16){A=0;f[j>>2]=f[j>>2]|2;if((H-G|0)>3){y=G;x=h[y>>0]|h[y+1>>0]<<8|h[y+2>>0]<<16|h[y+3>>0]<<24;f[e>>2]=x;y=G+4|0;f[c>>2]=y;V=x;W=y}else{if(!(Xnb(c,e)|0)){A=20;break a}V=f[e>>2]|0;W=f[c>>2]|0}f[l>>2]=V;y=f[g>>2]|0;if(W>>>0>=y>>>0)continue a;if((b[W>>0]|0)!=29)continue a;x=W+1|0;f[c>>2]=x;I=x;K=y;A=26}if((A|0)==26){A=0;f[j>>2]=f[j>>2]|4;if((K-I|0)>3){y=I;x=h[y>>0]|h[y+1>>0]<<8|h[y+2>>0]<<16|h[y+3>>0]<<24;f[e>>2]=x;y=I+4|0;f[c>>2]=y;X=x;Y=y}else{if(!(Xnb(c,e)|0)){A=30;break a}X=f[e>>2]|0;Y=f[c>>2]|0}f[m>>2]=X;y=f[g>>2]|0;if(Y>>>0>=y>>>0)continue a;if((b[Y>>0]|0)!=37)continue a;x=Y+1|0;f[c>>2]=x;L=x;M=y;A=36}if((A|0)==36){A=0;f[j>>2]=f[j>>2]|8;if((M-L|0)>3){y=L;x=h[y>>0]|h[y+1>>0]<<8|h[y+2>>0]<<16|h[y+3>>0]<<24;f[e>>2]=x;y=L+4|0;f[c>>2]=y;Z=x;_=y}else{if(!(Xnb(c,e)|0)){A=40;break a}Z=f[e>>2]|0;_=f[c>>2]|0}f[n>>2]=Z;y=f[g>>2]|0;if(_>>>0>=y>>>0)continue a;if((b[_>>0]|0)!=45)continue a;x=_+1|0;f[c>>2]=x;N=x;O=y;A=46}if((A|0)==46){A=0;f[j>>2]=f[j>>2]|16;if((O-N|0)>3){y=N;x=h[y>>0]|h[y+1>>0]<<8|h[y+2>>0]<<16|h[y+3>>0]<<24;f[e>>2]=x;y=N+4|0;f[c>>2]=y;$=x;aa=y}else{if(!(Xnb(c,e)|0)){A=50;break a}$=f[e>>2]|0;aa=f[c>>2]|0}f[o>>2]=$;y=f[g>>2]|0;if(aa>>>0>=y>>>0)continue a;if((b[aa>>0]|0)!=53)continue a;x=aa+1|0;f[c>>2]=x;P=x;Q=y;A=56}if((A|0)==56){A=0;f[j>>2]=f[j>>2]|32;if((Q-P|0)>3){y=P;x=h[y>>0]|h[y+1>>0]<<8|h[y+2>>0]<<16|h[y+3>>0]<<24;f[e>>2]=x;y=P+4|0;f[c>>2]=y;ba=x;ca=y}else{if(!(Xnb(c,e)|0)){A=60;break a}ba=f[e>>2]|0;ca=f[c>>2]|0}f[p>>2]=ba;y=f[g>>2]|0;if(ca>>>0>=y>>>0)continue a;if((b[ca>>0]|0)!=56)continue a;x=ca+1|0;f[c>>2]=x;R=x;S=y;A=66}if((A|0)==66){A=0;f[j>>2]=f[j>>2]|64;if(R>>>0<S>>>0){y=b[R>>0]|0;x=y&255;if(y<<24>>24>-1){y=R+1|0;f[c>>2]=y;da=x;ea=y;fa=S}else{ga=x;A=69}}else{ga=0;A=69}if((A|0)==69){A=0;x=Knb(c,ga)|0;y=J;if(!((y|0)>-1|(y|0)==-1&x>>>0>4294967295)){D=0;A=96;break a}da=x;ea=f[c>>2]|0;fa=f[g>>2]|0}f[q>>2]=da;if(ea>>>0>=fa>>>0)continue a;if((b[ea>>0]|0)!=64)continue a;x=ea+1|0;f[c>>2]=x;T=x;U=fa}if(T>>>0<U>>>0){x=b[T>>0]|0;y=x&255;if(x<<24>>24>-1){f[c>>2]=T+1;ha=y}else{ia=y;A=79}}else{ia=0;A=79}if((A|0)==79){A=0;y=Knb(c,ia)|0;x=J;if((x|0)>-1|(x|0)==-1&y>>>0>4294967295)ha=y;else{D=0;A=96;break a}}if(ha>>>0<3){f[j>>2]=f[j>>2]|128;f[r>>2]=ha}else{y=f[w>>2]|0;if(!(y&1))ja=hBa(w)|0;else ja=y&-2;NPb(ja,8,ha,((ha|0)<0)<<31>>31)}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[s>>2]|0){A=89;break a}if((f[t>>2]|0)==(f[v>>2]|0)){A=89;break a}else continue a}while(0);if((A|0)==90){A=0;if(!C){D=1;A=96;break}else E=C}if((E&7|0)==4){D=1;A=96;break}y=f[w>>2]|0;if(!(y&1))ka=hBa(w)|0;else ka=y&-2;if(!(ZPb(c,E,ka)|0)){D=0;A=96;break}}if((A|0)==20){D=0;u=d;return D|0}else if((A|0)==30){D=0;u=d;return D|0}else if((A|0)==40){D=0;u=d;return D|0}else if((A|0)==50){D=0;u=d;return D|0}else if((A|0)==60){D=0;u=d;return D|0}else if((A|0)==89){f[i>>2]=0;b[c+24>>0]=1;D=1;u=d;return D|0}else if((A|0)==96){u=d;return D|0}return 0}function KNa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=118368;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=497208?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=0;b[a+20>>0]=0;u=c;return}function LNa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function MNa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=118260;lOa(a);b=f[a+52>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+40>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(h);f[b>>2]=0;return}function NNa(a){a=a|0;MNa(a);O5b(a);return}function ONa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function PNa(a,b){a=a|0;b=b|0;a=L5b(196)|0;jOa(a);if(!b)return a|0;kOa(b,a);return a|0}function QNa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[c>>2]|0;if(d&255|0){e=a+88|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;e=a+8|0;do if(d&1|0?(g=f[a+56>>2]|0,(g|0)!=497760):0){h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);do if(f[e>>2]&2|0?(d=f[a+60>>2]|0,(d|0)!=497760):0){h=d+11|0;if((b[h>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[h>>0]=0;break}}while(0);b[a+144>>0]=1;if(f[e>>2]&16|0?(h=f[a+76>>2]|0,h|0):0){d=h+8|0;g=f[d>>2]|0;if(g&255|0){i=h+20|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if(g&1|0?(g=f[213028]|0,i=f[h+16>>2]|0,(i|0)!=(g|0)):0)_5b(i,g)|0;n[h+40>>2]=1.0;n[h+44>>2]=1.0;f[h+36>>2]=-1}f[d>>2]=0;d=f[h+4>>2]|0;if(d&1|0?(h=d&-2,f[h>>2]|0):0)GPb(h)}if(f[e>>2]&32|0?(e=f[a+80>>2]|0,e|0):0){h=e+8|0;d=f[h>>2]|0;if(d&255|0){g=e+20|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if(d&1|0?(d=f[213028]|0,g=f[e+16>>2]|0,(g|0)!=(d|0)):0)_5b(g,d)|0;n[e+40>>2]=1.0;n[e+44>>2]=1.0;f[e+36>>2]=-1}f[h>>2]=0;h=f[e+4>>2]|0;if(h&1|0?(e=h&-2,f[e>>2]|0):0)GPb(e)}}e=f[c>>2]|0;if(e&65280|0){f[a+148>>2]=1;f[a+152>>2]=1;f[a+100>>2]=0;n[a+156>>2]=.5;f[a+160>>2]=5;n[a+164>>2]=1.0;n[a+168>>2]=.75;n[a+172>>2]=1.0}if(!(e&4128768))j=e;else{h=a+104|0;f[h>>2]=0;f[h+4>>2]=0;h=a+8|0;do if(e&65536|0?(d=f[a+64>>2]|0,(d|0)!=497760):0){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);n[a+176>>2]=1.0;do if(f[h>>2]&262144|0?(e=f[a+68>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);b[a+116>>0]=0;j=f[c>>2]|0}if((j>>>0>33554431?(h=a+120|0,f[h>>2]=0,f[h+4>>2]=0,f[a+112>>2]=0,n[a+180>>2]=.5,n[a+184>>2]=.5,n[a+188>>2]=.25,j&1073741824|0):0)?(j=f[213032]|0,h=f[a+72>>2]|0,(h|0)!=(j|0)):0)_5b(h,j)|0;j=f[a+12>>2]|0;if((j&63|0?(h=a+128|0,f[h>>2]=0,f[h+4>>2]=0,f[h+8>>2]=0,b[a+117>>0]=0,f[a+140>>2]=1,j&32|0):0)?(j=f[a+84>>2]|0,j|0):0){h=j+8|0;do if(f[h>>2]&1|0?(g=f[j+16>>2]|0,(g|0)!=497760):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);f[h>>2]=0;h=f[j+4>>2]|0;if(h&1|0?(j=h&-2,f[j>>2]|0):0)GPb(j)}j=a+20|0;h=f[j>>2]|0;if((h|0)>0){e=f[a+28>>2]|0;g=0;do{d=f[e+4+(g<<2)>>2]|0;g=g+1|0;bi[f[(f[d>>2]|0)+28>>2]&2047](d)}while((g|0)!=(h|0));f[j>>2]=0}f[a+32>>2]=0;f[a+44>>2]=0;j=c;f[j>>2]=0;f[j+4>>2]=0;j=f[a+4>>2]|0;if(!(j&1))return;a=j&-2;if(!(f[a>>2]|0))return;GPb(a);return}function RNa(a){a=a|0;return 1}function SNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+56|0;l=a+60|0;m=a+88|0;n=a+144|0;o=e+8|0;p=a+76|0;q=e+4|0;r=a+80|0;s=e+4|0;t=a+92|0;v=a+96|0;w=a+148|0;x=a+152|0;y=a+100|0;z=a+4|0;A=a+156|0;B=a+160|0;C=a+164|0;D=a+168|0;E=a+64|0;F=a+176|0;G=a+68|0;H=a+104|0;I=a+108|0;K=a+116|0;L=e+8|0;M=a+172|0;N=c+44|0;O=a+16|0;P=a+28|0;Q=a+24|0;R=a+20|0;S=a+32|0;T=a+36|0;U=a+40|0;V=a+44|0;W=a+48|0;X=a+52|0;Y=a+112|0;Z=a+180|0;_=a+184|0;$=a+188|0;aa=a+120|0;ba=a+72|0;ca=a+124|0;da=a+12|0;ea=a+128|0;fa=a+132|0;ga=a+136|0;ha=a+117|0;ia=e+8|0;ja=a+140|0;ka=a+84|0;a=e+4|0;la=c+32|0;ma=c+12|0;na=c+28|0;a:while(1){oa=f[c>>2]|0;pa=f[g>>2]|0;do if(oa>>>0<pa>>>0){qa=b[oa>>0]|0;ra=qa&255;if(qa<<24>>24>0){sa=ra;ta=1}else{qa=oa+1|0;if(qa>>>0>=pa>>>0){ua=ra;va=7;break}wa=h[qa>>0]|0;if(((wa^128)&ra)>>>0<=127){ua=ra;va=7;break}sa=ra+-128+(wa<<7)|0;ta=2}f[i>>2]=sa;f[c>>2]=oa+ta;xa=sa;va=9}else{ua=0;va=7}while(0);if((va|0)==7){va=0;oa=_nb(c,ua)|0;f[i>>2]=oa;if((oa+-1|0)>>>0<16383){xa=oa;va=9}else{ya=oa;va=452}}b:do if((va|0)==9){va=0;c:do switch(xa>>>3&536870911|0){case 1:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 10:break;default:{Aa=xa;break b}}f[j>>2]=f[j>>2]|1;oa=f[k>>2]|0;if((oa|0)==497760){jza(k,497760);Ba=f[k>>2]|0}else Ba=oa;if(!(fqb(c,Ba)|0)){za=0;va=458;break a}oa=f[c>>2]|0;if(oa>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[oa>>0]|0)!=18)continue a;f[c>>2]=oa+1;va=18;break}case 2:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 18:{va=18;break}default:{Aa=xa;break b}}break}case 3:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 24:break;default:{Aa=xa;break b}}Ca=f[c>>2]|0;Da=f[g>>2]|0;va=26;break}case 4:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 32:break;default:{Aa=xa;break b}}Ea=f[c>>2]|0;Fa=f[g>>2]|0;va=36;break}case 5:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 42:{va=45;break}default:{Aa=xa;break b}}break}case 6:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 50:{va=59;break}default:{Aa=xa;break b}}break}case 7:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 56:break;default:{Aa=xa;break b}}Ga=f[c>>2]|0;Ha=f[g>>2]|0;va=74;break}case 8:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 64:break;default:{Aa=xa;break b}}Ia=f[c>>2]|0;Ja=f[g>>2]|0;va=84;break}case 9:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 72:break;default:{Aa=xa;break b}}Ka=f[c>>2]|0;La=f[g>>2]|0;va=94;break}case 10:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 80:break;default:{Aa=xa;break b}}Ma=f[c>>2]|0;Na=f[g>>2]|0;va=104;break}case 11:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 88:break;default:{Aa=xa;break b}}Oa=f[c>>2]|0;Pa=f[g>>2]|0;va=114;break}case 12:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 101:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;Qa=oa;Ra=f[c>>2]|0;Sa=oa;va=129;break}case 13:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 104:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;Ta=oa;Ua=f[c>>2]|0;Va=oa;va=139;break}case 14:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 117:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;Wa=oa;Xa=f[c>>2]|0;Ya=oa;va=149;break}case 15:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 125:break;default:{Aa=xa;break b}}Za=f[c>>2]|0;_a=f[g>>2]|0;va=159;break}case 16:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 130:{va=169;break}default:{Aa=xa;break b}}break}case 17:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 141:break;default:{Aa=xa;break b}}$a=f[c>>2]|0;ab=f[g>>2]|0;va=178;break}case 18:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 146:{va=188;break}default:{Aa=xa;break b}}break}case 19:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 152:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;bb=oa;cb=f[c>>2]|0;db=oa;va=197;break}case 20:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 160:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;eb=oa;fb=f[c>>2]|0;gb=oa;va=208;break}case 21:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 168:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;hb=oa;ib=f[c>>2]|0;jb=oa;va=219;break}case 22:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 181:break;default:{Aa=xa;break b}}kb=f[c>>2]|0;lb=f[g>>2]|0;va=230;break}case 50:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 402:{va=240;break}default:{Aa=xa;break b}}break}case 51:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 413:{mb=f[c>>2]|0;nb=f[g>>2]|0;va=260;break c;break}case 410:{if(DMa(c,S)|0){va=276;break c}else{za=0;va=458;break a}break}default:{Aa=xa;break b}}break}case 52:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 421:{ob=f[c>>2]|0;pb=f[g>>2]|0;va=285;break c;break}case 418:{if(DMa(c,V)|0){va=301;break c}else{za=0;va=458;break a}break}default:{Aa=xa;break b}}break}case 53:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 424:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;qb=oa;rb=f[c>>2]|0;sb=oa;va=310;break}case 54:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 437:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;tb=oa;ub=f[c>>2]|0;vb=oa;va=321;break}case 55:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 445:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;wb=oa;xb=f[c>>2]|0;yb=oa;va=332;break}case 56:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 453:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;zb=oa;Ab=f[c>>2]|0;Bb=oa;va=343;break}case 58:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 464:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;Cb=oa;Db=f[c>>2]|0;Eb=oa;va=354;break}case 59:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 474:{va=364;break}default:{Aa=xa;break b}}break}case 60:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 480:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;Fb=oa;Gb=f[c>>2]|0;Hb=oa;va=373;break}case 61:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 488:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;Ib=oa;Jb=f[c>>2]|0;Kb=oa;va=384;break}case 62:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 496:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;Lb=oa;Mb=f[c>>2]|0;Nb=oa;va=395;break}case 63:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 504:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;Ob=f[c>>2]|0;Pb=oa;Qb=oa;va=406;break}case 64:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 512:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;Rb=f[c>>2]|0;Sb=oa;Tb=oa;va=417;break}case 65:{switch(xa|0){case 0:{za=1;va=458;break a;break}case 520:break;default:{Aa=xa;break b}}oa=f[g>>2]|0;Ub=f[c>>2]|0;Vb=oa;Wb=oa;va=428;break}case 1001:{if((xa|0)<8010)switch(xa|0){case 0:{za=1;va=458;break a;break}default:{Aa=xa;break b}}else switch(xa|0){case 8010:{va=438;break c;break}default:{Aa=xa;break b}}break}default:{ya=xa;va=452;break b}}while(0);if((va|0)==18){va=0;f[j>>2]=f[j>>2]|2;oa=f[l>>2]|0;if((oa|0)==497760){jza(l,497760);Xb=f[l>>2]|0}else Xb=oa;if(!(fqb(c,Xb)|0)){za=0;va=458;break a}oa=f[c>>2]|0;pa=f[g>>2]|0;if(oa>>>0>=pa>>>0)continue a;if((b[oa>>0]|0)!=24)continue a;wa=oa+1|0;f[c>>2]=wa;Ca=wa;Da=pa;va=26}if((va|0)==26){va=0;f[j>>2]=f[j>>2]|4;if(Ca>>>0<Da>>>0){pa=b[Ca>>0]|0;wa=pa&255;if(pa<<24>>24>-1){f[m>>2]=wa;pa=Ca+1|0;f[c>>2]=pa;Yb=pa;Zb=Da}else{_b=wa;va=29}}else{_b=0;va=29}if((va|0)==29){va=0;wa=Knb(c,_b)|0;pa=J;f[m>>2]=wa;if(!((pa|0)>-1|(pa|0)==-1&wa>>>0>4294967295)){za=0;va=458;break a}Yb=f[c>>2]|0;Zb=f[g>>2]|0}if(Yb>>>0>=Zb>>>0)continue a;if((b[Yb>>0]|0)!=32)continue a;wa=Yb+1|0;f[c>>2]=wa;Ea=wa;Fa=Zb;va=36}if((va|0)==36){va=0;f[j>>2]=f[j>>2]|8;if(Ea>>>0<Fa>>>0?(wa=b[Ea>>0]|0,wa<<24>>24>-1):0){pa=Ea+1|0;f[c>>2]=pa;$b=wa<<24>>24!=0;ac=pa;bc=Fa}else{Lnb(e,c);pa=e;if(!(b[o>>0]|0)){za=0;va=458;break a}$b=(f[pa>>2]|0)!=0|(f[pa+4>>2]|0)!=0;ac=f[c>>2]|0;bc=f[g>>2]|0}b[n>>0]=$b&1;if(ac>>>0>=bc>>>0)continue a;if((b[ac>>0]|0)!=42)continue a;f[c>>2]=ac+1;va=45}if((va|0)==45){va=0;f[j>>2]=f[j>>2]|16;pa=f[p>>2]|0;if(!pa){wa=L5b(48)|0;GNa(wa);f[p>>2]=wa;cc=wa}else cc=pa;pa=f[c>>2]|0;if(pa>>>0<(f[g>>2]|0)>>>0?(wa=b[pa>>0]|0,wa<<24>>24>-1):0){f[c>>2]=pa+1;dc=wa&255}else{wa=Znb(c)|0;if((wa|0)>-1)dc=wa;else{za=0;va=458;break a}}Inb(e,c,dc);if((f[q>>2]|0)<0){va=53;break a}if(!(JNa(cc,c)|0)){va=53;break a}if(!(Onb(c,f[e>>2]|0)|0)){za=0;va=458;break a}wa=f[c>>2]|0;if(wa>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[wa>>0]|0)!=50)continue a;f[c>>2]=wa+1;va=59}if((va|0)==59){va=0;f[j>>2]=f[j>>2]|32;wa=f[r>>2]|0;if(!wa){pa=L5b(48)|0;GNa(pa);f[r>>2]=pa;ec=pa}else ec=wa;wa=f[c>>2]|0;if(wa>>>0<(f[g>>2]|0)>>>0?(pa=b[wa>>0]|0,pa<<24>>24>-1):0){f[c>>2]=wa+1;fc=pa&255}else{pa=Znb(c)|0;if((pa|0)>-1)fc=pa;else{za=0;va=458;break a}}Inb(e,c,fc);if((f[s>>2]|0)<0){va=67;break a}if(!(JNa(ec,c)|0)){va=67;break a}if(!(Onb(c,f[e>>2]|0)|0)){za=0;va=458;break a}pa=f[c>>2]|0;wa=f[g>>2]|0;if(pa>>>0>=wa>>>0)continue a;if((b[pa>>0]|0)!=56)continue a;oa=pa+1|0;f[c>>2]=oa;Ga=oa;Ha=wa;va=74}if((va|0)==74){va=0;f[j>>2]=f[j>>2]|64;if(Ga>>>0<Ha>>>0){wa=b[Ga>>0]|0;oa=wa&255;if(wa<<24>>24>-1){f[t>>2]=oa;wa=Ga+1|0;f[c>>2]=wa;gc=wa;hc=Ha}else{ic=oa;va=77}}else{ic=0;va=77}if((va|0)==77){va=0;oa=Knb(c,ic)|0;wa=J;f[t>>2]=oa;if(!((wa|0)>-1|(wa|0)==-1&oa>>>0>4294967295)){za=0;va=458;break a}gc=f[c>>2]|0;hc=f[g>>2]|0}if(gc>>>0>=hc>>>0)continue a;if((b[gc>>0]|0)!=64)continue a;oa=gc+1|0;f[c>>2]=oa;Ia=oa;Ja=hc;va=84}if((va|0)==84){va=0;f[j>>2]=f[j>>2]|128;if(Ia>>>0<Ja>>>0){oa=b[Ia>>0]|0;wa=oa&255;if(oa<<24>>24>-1){f[v>>2]=wa;oa=Ia+1|0;f[c>>2]=oa;jc=oa;kc=Ja}else{lc=wa;va=87}}else{lc=0;va=87}if((va|0)==87){va=0;wa=Knb(c,lc)|0;oa=J;f[v>>2]=wa;if(!((oa|0)>-1|(oa|0)==-1&wa>>>0>4294967295)){za=0;va=458;break a}jc=f[c>>2]|0;kc=f[g>>2]|0}if(jc>>>0>=kc>>>0)continue a;if((b[jc>>0]|0)!=72)continue a;wa=jc+1|0;f[c>>2]=wa;Ka=wa;La=kc;va=94}if((va|0)==94){va=0;f[j>>2]=f[j>>2]|256;if(Ka>>>0<La>>>0){wa=b[Ka>>0]|0;oa=wa&255;if(wa<<24>>24>-1){f[w>>2]=oa;wa=Ka+1|0;f[c>>2]=wa;mc=wa;nc=La}else{oc=oa;va=97}}else{oc=0;va=97}if((va|0)==97){va=0;oa=Knb(c,oc)|0;wa=J;f[w>>2]=oa;if(!((wa|0)>-1|(wa|0)==-1&oa>>>0>4294967295)){za=0;va=458;break a}mc=f[c>>2]|0;nc=f[g>>2]|0}if(mc>>>0>=nc>>>0)continue a;if((b[mc>>0]|0)!=80)continue a;oa=mc+1|0;f[c>>2]=oa;Ma=oa;Na=nc;va=104}if((va|0)==104){va=0;f[j>>2]=f[j>>2]|512;if(Ma>>>0<Na>>>0){oa=b[Ma>>0]|0;wa=oa&255;if(oa<<24>>24>-1){f[x>>2]=wa;oa=Ma+1|0;f[c>>2]=oa;pc=oa;qc=Na}else{rc=wa;va=107}}else{rc=0;va=107}if((va|0)==107){va=0;wa=Knb(c,rc)|0;oa=J;f[x>>2]=wa;if(!((oa|0)>-1|(oa|0)==-1&wa>>>0>4294967295)){za=0;va=458;break a}pc=f[c>>2]|0;qc=f[g>>2]|0}if(pc>>>0>=qc>>>0)continue a;if((b[pc>>0]|0)!=88)continue a;wa=pc+1|0;f[c>>2]=wa;Oa=wa;Pa=qc;va=114}if((va|0)==114){va=0;if(Oa>>>0<Pa>>>0){wa=b[Oa>>0]|0;oa=wa&255;if(wa<<24>>24>-1){f[c>>2]=Oa+1;sc=oa}else{tc=oa;va=117}}else{tc=0;va=117}if((va|0)==117){va=0;oa=Knb(c,tc)|0;wa=J;if((wa|0)>-1|(wa|0)==-1&oa>>>0>4294967295)sc=oa;else{za=0;va=458;break a}}if(sc>>>0<3){f[j>>2]=f[j>>2]|1024;f[y>>2]=sc}else{oa=f[z>>2]|0;if(!(oa&1))uc=hBa(z)|0;else uc=oa&-2;NPb(uc,11,sc,((sc|0)<0)<<31>>31)}oa=f[c>>2]|0;wa=f[g>>2]|0;if(oa>>>0>=wa>>>0)continue a;if((b[oa>>0]|0)!=101)continue a;pa=oa+1|0;f[c>>2]=pa;Qa=wa;Ra=pa;Sa=wa;va=129}if((va|0)==129){va=0;f[j>>2]=f[j>>2]|2048;if((Sa-Ra|0)>3){wa=Ra;pa=h[wa>>0]|h[wa+1>>0]<<8|h[wa+2>>0]<<16|h[wa+3>>0]<<24;f[e>>2]=pa;wa=Ra+4|0;f[c>>2]=wa;vc=Sa;wc=pa;xc=wa;yc=Qa}else{if(!(Xnb(c,e)|0)){va=133;break a}wa=f[g>>2]|0;vc=wa;wc=f[e>>2]|0;xc=f[c>>2]|0;yc=wa}f[A>>2]=wc;if(xc>>>0>=yc>>>0)continue a;if((b[xc>>0]|0)!=104)continue a;wa=xc+1|0;f[c>>2]=wa;Ta=vc;Ua=wa;Va=yc;va=139}if((va|0)==139){va=0;f[j>>2]=f[j>>2]|4096;if(Ua>>>0<Va>>>0){wa=b[Ua>>0]|0;pa=wa&255;if(wa<<24>>24>-1){f[B>>2]=pa;wa=Ua+1|0;f[c>>2]=wa;zc=Ta;Ac=wa;Bc=Va}else{Cc=pa;va=142}}else{Cc=0;va=142}if((va|0)==142){va=0;pa=Knb(c,Cc)|0;wa=J;f[B>>2]=pa;if(!((wa|0)>-1|(wa|0)==-1&pa>>>0>4294967295)){za=0;va=458;break a}pa=f[g>>2]|0;zc=pa;Ac=f[c>>2]|0;Bc=pa}if(Ac>>>0>=Bc>>>0)continue a;if((b[Ac>>0]|0)!=117)continue a;pa=Ac+1|0;f[c>>2]=pa;Wa=Bc;Xa=pa;Ya=zc;va=149}if((va|0)==149){va=0;f[j>>2]=f[j>>2]|8192;if((Ya-Xa|0)>3){pa=Xa;wa=h[pa>>0]|h[pa+1>>0]<<8|h[pa+2>>0]<<16|h[pa+3>>0]<<24;f[e>>2]=wa;pa=Xa+4|0;f[c>>2]=pa;Dc=Ya;Ec=wa;Fc=pa;Gc=Wa}else{if(!(Xnb(c,e)|0)){va=153;break a}pa=f[g>>2]|0;Dc=pa;Ec=f[e>>2]|0;Fc=f[c>>2]|0;Gc=pa}f[C>>2]=Ec;if(Fc>>>0>=Gc>>>0)continue a;if((b[Fc>>0]|0)!=125)continue a;pa=Fc+1|0;f[c>>2]=pa;Za=pa;_a=Dc;va=159}if((va|0)==159){va=0;f[j>>2]=f[j>>2]|16384;if((_a-Za|0)>3){pa=Za;wa=h[pa>>0]|h[pa+1>>0]<<8|h[pa+2>>0]<<16|h[pa+3>>0]<<24;f[e>>2]=wa;pa=Za+4|0;f[c>>2]=pa;Hc=wa;Ic=pa;Jc=_a}else{if(!(Xnb(c,e)|0)){va=163;break a}Hc=f[e>>2]|0;Ic=f[c>>2]|0;Jc=f[g>>2]|0}f[D>>2]=Hc;pa=Ic;if((Jc-Ic|0)<=1)continue a;if((b[pa>>0]|0)!=-126)continue a;if((b[pa+1>>0]|0)!=1)continue a;f[c>>2]=pa+2;va=169}if((va|0)==169){va=0;f[j>>2]=f[j>>2]|65536;pa=f[E>>2]|0;if((pa|0)==497760){jza(E,497760);Kc=f[E>>2]|0}else Kc=pa;if(!(fqb(c,Kc)|0)){za=0;va=458;break a}pa=f[g>>2]|0;wa=f[c>>2]|0;oa=wa;if((pa-wa|0)<=1)continue a;if((b[oa>>0]|0)!=-115)continue a;if((b[oa+1>>0]|0)!=1)continue a;wa=oa+2|0;f[c>>2]=wa;$a=wa;ab=pa;va=178}if((va|0)==178){va=0;f[j>>2]=f[j>>2]|131072;if((ab-$a|0)>3){pa=$a;wa=h[pa>>0]|h[pa+1>>0]<<8|h[pa+2>>0]<<16|h[pa+3>>0]<<24;f[e>>2]=wa;pa=$a+4|0;f[c>>2]=pa;Lc=wa;Mc=pa;Nc=ab}else{if(!(Xnb(c,e)|0)){va=182;break a}Lc=f[e>>2]|0;Mc=f[c>>2]|0;Nc=f[g>>2]|0}f[F>>2]=Lc;pa=Mc;if((Nc-Mc|0)<=1)continue a;if((b[pa>>0]|0)!=-110)continue a;if((b[pa+1>>0]|0)!=1)continue a;f[c>>2]=pa+2;va=188}if((va|0)==188){va=0;f[j>>2]=f[j>>2]|262144;pa=f[G>>2]|0;if((pa|0)==497760){jza(G,497760);Oc=f[G>>2]|0}else Oc=pa;if(!(fqb(c,Oc)|0)){za=0;va=458;break a}pa=f[g>>2]|0;wa=f[c>>2]|0;oa=wa;if((pa-wa|0)<=1)continue a;if((b[oa>>0]|0)!=-104)continue a;if((b[oa+1>>0]|0)!=1)continue a;wa=oa+2|0;f[c>>2]=wa;bb=pa;cb=wa;db=pa;va=197}if((va|0)==197){va=0;f[j>>2]=f[j>>2]|524288;if(cb>>>0<db>>>0){pa=b[cb>>0]|0;wa=pa&255;if(pa<<24>>24>-1){f[H>>2]=wa;pa=cb+1|0;f[c>>2]=pa;Pc=db;Qc=pa;Rc=bb}else{Sc=wa;va=200}}else{Sc=0;va=200}if((va|0)==200){va=0;wa=Knb(c,Sc)|0;pa=J;f[H>>2]=wa;if(!((pa|0)>-1|(pa|0)==-1&wa>>>0>4294967295)){za=0;va=458;break a}wa=f[g>>2]|0;Pc=wa;Qc=f[c>>2]|0;Rc=wa}wa=Qc;if((Rc-Qc|0)<=1)continue a;if((b[wa>>0]|0)!=-96)continue a;if((b[wa+1>>0]|0)!=1)continue a;pa=wa+2|0;f[c>>2]=pa;eb=Rc;fb=pa;gb=Pc;va=208}if((va|0)==208){va=0;f[j>>2]=f[j>>2]|1048576;if(fb>>>0<gb>>>0){pa=b[fb>>0]|0;wa=pa&255;if(pa<<24>>24>-1){f[I>>2]=wa;pa=fb+1|0;f[c>>2]=pa;Tc=gb;Uc=pa;Vc=eb}else{Wc=wa;va=211}}else{Wc=0;va=211}if((va|0)==211){va=0;wa=Knb(c,Wc)|0;pa=J;f[I>>2]=wa;if(!((pa|0)>-1|(pa|0)==-1&wa>>>0>4294967295)){za=0;va=458;break a}wa=f[g>>2]|0;Tc=wa;Uc=f[c>>2]|0;Vc=wa}wa=Uc;if((Vc-Uc|0)<=1)continue a;if((b[wa>>0]|0)!=-88)continue a;if((b[wa+1>>0]|0)!=1)continue a;pa=wa+2|0;f[c>>2]=pa;hb=Vc;ib=pa;jb=Tc;va=219}if((va|0)==219){va=0;f[j>>2]=f[j>>2]|2097152;if(ib>>>0<jb>>>0?(pa=b[ib>>0]|0,pa<<24>>24>-1):0){wa=ib+1|0;f[c>>2]=wa;Xc=pa<<24>>24!=0;Yc=wa;Zc=hb}else{Lnb(e,c);wa=e;if(!(b[L>>0]|0)){za=0;va=458;break a}Xc=(f[wa>>2]|0)!=0|(f[wa+4>>2]|0)!=0;Yc=f[c>>2]|0;Zc=f[g>>2]|0}b[K>>0]=Xc&1;wa=Yc;if((Zc-Yc|0)<=1)continue a;if((b[wa>>0]|0)!=-75)continue a;if((b[wa+1>>0]|0)!=1)continue a;pa=wa+2|0;f[c>>2]=pa;kb=pa;lb=Zc;va=230}if((va|0)==230){va=0;f[j>>2]=f[j>>2]|32768;if((lb-kb|0)>3){pa=kb;wa=h[pa>>0]|h[pa+1>>0]<<8|h[pa+2>>0]<<16|h[pa+3>>0]<<24;f[e>>2]=wa;pa=kb+4|0;f[c>>2]=pa;_c=wa;$c=pa;ad=lb}else{if(!(Xnb(c,e)|0)){va=234;break a}_c=f[e>>2]|0;$c=f[c>>2]|0;ad=f[g>>2]|0}f[M>>2]=_c;pa=$c;if((ad-$c|0)<=1)continue a;if((b[pa>>0]|0)!=-110)continue a;if((b[pa+1>>0]|0)!=3)continue a;f[c>>2]=pa+2;va=240}if((va|0)==240){va=0;pa=f[N>>2]|0;f[N>>2]=pa+-1;if((pa|0)<=0){za=0;va=458;break a}while(1){pa=f[P>>2]|0;do if(pa){wa=f[R>>2]|0;oa=f[pa>>2]|0;if((wa|0)>=(oa|0))if((oa|0)==(f[Q>>2]|0)){bd=oa;va=246;break}else{cd=oa;dd=pa;va=247;break}else{f[R>>2]=wa+1;ed=f[pa+4+(wa<<2)>>2]|0;break}}else{bd=f[Q>>2]|0;va=246}while(0);if((va|0)==246){va=0;cpb(O,bd+1|0);pa=f[P>>2]|0;cd=f[pa>>2]|0;dd=pa;va=247}if((va|0)==247){va=0;f[dd>>2]=cd+1;pa=pza(0,f[O>>2]|0)|0;wa=f[P>>2]|0;oa=f[R>>2]|0;f[R>>2]=oa+1;f[wa+4+(oa<<2)>>2]=pa;ed=pa}pa=Jnb(c)|0;if(!(hOa(ed,c)|0)){za=0;va=458;break a}if(!(Pnb(c,pa)|0)){za=0;va=458;break a}fd=f[g>>2]|0;pa=f[c>>2]|0;gd=pa;if((fd-pa|0)<=1){va=254;break}if((b[gd>>0]|0)!=-110)break;if((b[gd+1>>0]|0)!=3)break;f[c>>2]=gd+2}if((va|0)==254){va=0;f[N>>2]=(f[N>>2]|0)+1;continue a}f[N>>2]=(f[N>>2]|0)+1;if((b[gd>>0]|0)!=-99)continue a;if((b[gd+1>>0]|0)==3){hd=gd;id=fd;va=259}else continue a}d:while(1){switch(va|0){case 259:{va=0;pa=hd+2|0;f[c>>2]=pa;mb=pa;nb=id;va=260;continue d;break}case 260:{va=0;if((nb-mb|0)>3){pa=mb;oa=h[pa>>0]|h[pa+1>>0]<<8|h[pa+2>>0]<<16|h[pa+3>>0]<<24;f[e>>2]=oa;f[c>>2]=mb+4;jd=oa}else{if(!(Xnb(c,e)|0)){va=274;break a}jd=f[e>>2]|0}oa=f[S>>2]|0;if((oa|0)==(f[T>>2]|0)){qza(S,oa+1|0);kd=f[S>>2]|0}else kd=oa;oa=f[U>>2]|0;pa=kd+1|0;f[S>>2]=pa;f[oa+4+(kd<<2)>>2]=jd;wa=f[c>>2]|0;ra=(f[g>>2]|0)-wa|0;if((ra|0)<=0){va=276;continue d}qa=(f[T>>2]|0)-pa|0;ld=(ra>>>0)/6|0;ra=(ld|0)<(qa|0)?ld:qa;if((ra|0)<=0){va=276;continue d}qa=0;ld=wa;wa=pa;while(1){if((b[ld>>0]|0)!=-99){md=qa;break}if((b[ld+1>>0]|0)!=3){md=qa;break}pa=ld+2|0;nd=h[pa>>0]|h[pa+1>>0]<<8|h[pa+2>>0]<<16|h[pa+3>>0]<<24;pa=wa;wa=wa+1|0;f[S>>2]=wa;f[oa+4+(pa<<2)>>2]=nd;nd=qa+1|0;if((nd|0)>=(ra|0)){md=nd;break}else{qa=nd;ld=ld+6|0}}if((md|0)<=0){va=276;continue d}Tnb(c,md*6|0)|0;va=276;continue d;break}case 276:{va=0;ld=f[g>>2]|0;qa=f[c>>2]|0;ra=qa;if((ld-qa|0)<=1)continue a;qa=b[ra>>0]|0;if(qa<<24>>24==-99){if((b[ra+1>>0]|0)==3){hd=ra;id=ld;va=259;continue d}od=b[ra>>0]|0}else od=qa;if(od<<24>>24!=-91)continue a;if((b[ra+1>>0]|0)==3){pd=ra;qd=ld}else continue a;break}case 285:{va=0;if((pb-ob|0)>3){ld=ob;ra=h[ld>>0]|h[ld+1>>0]<<8|h[ld+2>>0]<<16|h[ld+3>>0]<<24;f[e>>2]=ra;f[c>>2]=ob+4;rd=ra}else{if(!(Xnb(c,e)|0)){va=299;break a}rd=f[e>>2]|0}ra=f[V>>2]|0;if((ra|0)==(f[W>>2]|0)){qza(V,ra+1|0);sd=f[V>>2]|0}else sd=ra;ra=f[X>>2]|0;ld=sd+1|0;f[V>>2]=ld;f[ra+4+(sd<<2)>>2]=rd;qa=f[c>>2]|0;oa=(f[g>>2]|0)-qa|0;if((oa|0)<=0){va=301;continue d}wa=(f[W>>2]|0)-ld|0;nd=(oa>>>0)/6|0;oa=(nd|0)<(wa|0)?nd:wa;if((oa|0)<=0){va=301;continue d}wa=0;nd=qa;qa=ld;while(1){if((b[nd>>0]|0)!=-91){td=wa;break}if((b[nd+1>>0]|0)!=3){td=wa;break}ld=nd+2|0;pa=h[ld>>0]|h[ld+1>>0]<<8|h[ld+2>>0]<<16|h[ld+3>>0]<<24;ld=qa;qa=qa+1|0;f[V>>2]=qa;f[ra+4+(ld<<2)>>2]=pa;pa=wa+1|0;if((pa|0)>=(oa|0)){td=pa;break}else{wa=pa;nd=nd+6|0}}if((td|0)<=0){va=301;continue d}Tnb(c,td*6|0)|0;va=301;continue d;break}case 301:{va=0;nd=f[g>>2]|0;wa=f[c>>2]|0;oa=wa;ra=nd;if((nd-wa|0)<=1)continue a;wa=b[oa>>0]|0;if(wa<<24>>24==-91){if((b[oa+1>>0]|0)==3){pd=oa;qd=nd;break}ud=b[oa>>0]|0}else ud=wa;if(ud<<24>>24!=-88)continue a;if((b[oa+1>>0]|0)!=3)continue a;wa=oa+2|0;f[c>>2]=wa;qb=nd;rb=wa;sb=ra;va=310;continue d;break}case 310:{va=0;f[j>>2]=f[j>>2]|33554432;if(rb>>>0<sb>>>0){ra=b[rb>>0]|0;wa=ra&255;if(ra<<24>>24>-1){f[Y>>2]=wa;ra=rb+1|0;f[c>>2]=ra;vd=sb;wd=ra;xd=qb}else{yd=wa;va=313}}else{yd=0;va=313}if((va|0)==313){va=0;wa=Knb(c,yd)|0;ra=J;f[Y>>2]=wa;if(!((ra|0)>-1|(ra|0)==-1&wa>>>0>4294967295)){za=0;va=458;break a}wa=f[g>>2]|0;vd=wa;wd=f[c>>2]|0;xd=wa}wa=wd;if((xd-wd|0)<=1)continue a;if((b[wa>>0]|0)!=-75)continue a;if((b[wa+1>>0]|0)!=3)continue a;ra=wa+2|0;f[c>>2]=ra;tb=vd;ub=ra;vb=xd;va=321;continue d;break}case 321:{va=0;f[j>>2]=f[j>>2]|67108864;if((vb-ub|0)>3){ra=ub;wa=h[ra>>0]|h[ra+1>>0]<<8|h[ra+2>>0]<<16|h[ra+3>>0]<<24;f[e>>2]=wa;ra=ub+4|0;f[c>>2]=ra;zd=tb;Ad=wa;Bd=ra;Cd=vb}else{if(!(Xnb(c,e)|0)){va=325;break a}ra=f[g>>2]|0;zd=ra;Ad=f[e>>2]|0;Bd=f[c>>2]|0;Cd=ra}f[Z>>2]=Ad;ra=Bd;if((Cd-Bd|0)<=1)continue a;if((b[ra>>0]|0)!=-67)continue a;if((b[ra+1>>0]|0)!=3)continue a;wa=ra+2|0;f[c>>2]=wa;wb=zd;xb=wa;yb=Cd;va=332;continue d;break}case 332:{va=0;f[j>>2]=f[j>>2]|134217728;if((yb-xb|0)>3){wa=xb;ra=h[wa>>0]|h[wa+1>>0]<<8|h[wa+2>>0]<<16|h[wa+3>>0]<<24;f[e>>2]=ra;wa=xb+4|0;f[c>>2]=wa;Dd=wb;Ed=ra;Fd=wa;Gd=yb}else{if(!(Xnb(c,e)|0)){va=336;break a}wa=f[g>>2]|0;Dd=wa;Ed=f[e>>2]|0;Fd=f[c>>2]|0;Gd=wa}f[_>>2]=Ed;wa=Fd;if((Gd-Fd|0)<=1)continue a;if((b[wa>>0]|0)!=-59)continue a;if((b[wa+1>>0]|0)!=3)continue a;ra=wa+2|0;f[c>>2]=ra;zb=Dd;Ab=ra;Bb=Gd;va=343;continue d;break}case 343:{va=0;f[j>>2]=f[j>>2]|268435456;if((Bb-Ab|0)>3){ra=Ab;wa=h[ra>>0]|h[ra+1>>0]<<8|h[ra+2>>0]<<16|h[ra+3>>0]<<24;f[e>>2]=wa;ra=Ab+4|0;f[c>>2]=ra;Hd=zb;Id=wa;Jd=ra;Kd=Bb}else{if(!(Xnb(c,e)|0)){va=347;break a}ra=f[g>>2]|0;Hd=ra;Id=f[e>>2]|0;Jd=f[c>>2]|0;Kd=ra}f[$>>2]=Id;ra=Jd;if((Kd-Jd|0)<=1)continue a;if((b[ra>>0]|0)!=-48)continue a;if((b[ra+1>>0]|0)!=3)continue a;wa=ra+2|0;f[c>>2]=wa;Cb=Kd;Db=wa;Eb=Hd;va=354;continue d;break}case 354:{va=0;f[j>>2]=f[j>>2]|536870912;if(Db>>>0<Eb>>>0){wa=b[Db>>0]|0;ra=wa&255;if(wa<<24>>24>-1){f[aa>>2]=ra;wa=Db+1|0;f[c>>2]=wa;Ld=wa;Md=Cb}else{Nd=ra;va=357}}else{Nd=0;va=357}if((va|0)==357){va=0;ra=Knb(c,Nd)|0;wa=J;f[aa>>2]=ra;if(!((wa|0)>-1|(wa|0)==-1&ra>>>0>4294967295)){za=0;va=458;break a}Ld=f[c>>2]|0;Md=f[g>>2]|0}ra=Ld;if((Md-Ld|0)<=1)continue a;if((b[ra>>0]|0)!=-38)continue a;if((b[ra+1>>0]|0)!=3)continue a;f[c>>2]=ra+2;va=364;continue d;break}case 364:{va=0;f[j>>2]=f[j>>2]|1073741824;ra=f[213032]|0;wa=f[ba>>2]|0;if((wa|0)==(ra|0)){jza(ba,ra);Od=f[ba>>2]|0}else Od=wa;if(!(fqb(c,Od)|0)){za=0;va=458;break a}wa=f[g>>2]|0;ra=f[c>>2]|0;nd=ra;if((wa-ra|0)<=1)continue a;if((b[nd>>0]|0)!=-32)continue a;if((b[nd+1>>0]|0)!=3)continue a;ra=nd+2|0;f[c>>2]=ra;Fb=wa;Gb=ra;Hb=wa;va=373;continue d;break}case 373:{va=0;f[j>>2]=f[j>>2]|-2147483648;if(Gb>>>0<Hb>>>0){wa=b[Gb>>0]|0;ra=wa&255;if(wa<<24>>24>-1){wa=Gb+1|0;f[c>>2]=wa;Pd=ra;Qd=Hb;Rd=wa;Sd=Fb}else{Td=ra;va=376}}else{Td=0;va=376}if((va|0)==376){va=0;ra=Knb(c,Td)|0;wa=J;if(!((wa|0)>-1|(wa|0)==-1&ra>>>0>4294967295)){za=0;va=458;break a}wa=f[g>>2]|0;Pd=ra;Qd=wa;Rd=f[c>>2]|0;Sd=wa}f[ca>>2]=Pd;wa=Rd;if((Sd-Rd|0)<=1)continue a;if((b[wa>>0]|0)!=-24)continue a;if((b[wa+1>>0]|0)!=3)continue a;ra=wa+2|0;f[c>>2]=ra;Ib=Sd;Jb=ra;Kb=Qd;va=384;continue d;break}case 384:{va=0;f[da>>2]=f[da>>2]|1;if(Jb>>>0<Kb>>>0){ra=b[Jb>>0]|0;wa=ra&255;if(ra<<24>>24>-1){ra=Jb+1|0;f[c>>2]=ra;Ud=wa;Vd=Kb;Wd=ra;Xd=Ib}else{Yd=wa;va=387}}else{Yd=0;va=387}if((va|0)==387){va=0;wa=Knb(c,Yd)|0;ra=J;if(!((ra|0)>-1|(ra|0)==-1&wa>>>0>4294967295)){za=0;va=458;break a}ra=f[g>>2]|0;Ud=wa;Vd=ra;Wd=f[c>>2]|0;Xd=ra}f[ea>>2]=Ud;ra=Wd;if((Xd-Wd|0)<=1)continue a;if((b[ra>>0]|0)!=-16)continue a;if((b[ra+1>>0]|0)!=3)continue a;wa=ra+2|0;f[c>>2]=wa;Lb=Xd;Mb=wa;Nb=Vd;va=395;continue d;break}case 395:{va=0;f[da>>2]=f[da>>2]|2;if(Mb>>>0<Nb>>>0){wa=b[Mb>>0]|0;ra=wa&255;if(wa<<24>>24>-1){wa=Mb+1|0;f[c>>2]=wa;Zd=ra;_d=wa;$d=Lb;ae=Nb}else{be=ra;va=398}}else{be=0;va=398}if((va|0)==398){va=0;ra=Knb(c,be)|0;wa=J;if(!((wa|0)>-1|(wa|0)==-1&ra>>>0>4294967295)){za=0;va=458;break a}wa=f[g>>2]|0;Zd=ra;_d=f[c>>2]|0;$d=wa;ae=wa}f[fa>>2]=Zd;wa=_d;if(($d-_d|0)<=1)continue a;if((b[wa>>0]|0)!=-8)continue a;if((b[wa+1>>0]|0)!=3)continue a;ra=wa+2|0;f[c>>2]=ra;Ob=ra;Pb=ae;Qb=$d;va=406;continue d;break}case 406:{va=0;f[da>>2]=f[da>>2]|4;if(Ob>>>0<Pb>>>0){ra=b[Ob>>0]|0;wa=ra&255;if(ra<<24>>24>-1){ra=Ob+1|0;f[c>>2]=ra;ce=wa;de=ra;ee=Qb;fe=Pb}else{ge=wa;va=409}}else{ge=0;va=409}if((va|0)==409){va=0;wa=Knb(c,ge)|0;ra=J;if(!((ra|0)>-1|(ra|0)==-1&wa>>>0>4294967295)){za=0;va=458;break a}ra=f[g>>2]|0;ce=wa;de=f[c>>2]|0;ee=ra;fe=ra}f[ga>>2]=ce;ra=de;if((ee-de|0)<=1)continue a;if((b[ra>>0]|0)!=-128)continue a;if((b[ra+1>>0]|0)!=4)continue a;wa=ra+2|0;f[c>>2]=wa;Rb=wa;Sb=fe;Tb=ee;va=417;continue d;break}case 417:{va=0;f[da>>2]=f[da>>2]|8;if(Rb>>>0<Sb>>>0?(wa=b[Rb>>0]|0,wa<<24>>24>-1):0){ra=Rb+1|0;f[c>>2]=ra;he=wa<<24>>24!=0;ie=ra;je=Tb;ke=Sb}else{Lnb(e,c);ra=e;if(!(b[ia>>0]|0)){za=0;va=458;break a}wa=f[g>>2]|0;he=(f[ra>>2]|0)!=0|(f[ra+4>>2]|0)!=0;ie=f[c>>2]|0;je=wa;ke=wa}b[ha>>0]=he&1;wa=ie;if((je-ie|0)<=1)continue a;if((b[wa>>0]|0)!=-120)continue a;if((b[wa+1>>0]|0)!=4)continue a;ra=wa+2|0;f[c>>2]=ra;Ub=ra;Vb=ke;Wb=je;va=428;continue d;break}case 428:{va=0;f[da>>2]=f[da>>2]|16;if(Ub>>>0<Vb>>>0){ra=b[Ub>>0]|0;wa=ra&255;if(ra<<24>>24>-1){f[ja>>2]=wa;ra=Ub+1|0;f[c>>2]=ra;le=ra;me=Wb}else{ne=wa;va=431}}else{ne=0;va=431}if((va|0)==431){va=0;wa=Knb(c,ne)|0;ra=J;f[ja>>2]=wa;if(!((ra|0)>-1|(ra|0)==-1&wa>>>0>4294967295)){za=0;va=458;break a}le=f[c>>2]|0;me=f[g>>2]|0}wa=le;if((me-le|0)<=1)continue a;if((b[wa>>0]|0)!=-54)continue a;if((b[wa+1>>0]|0)!=62)continue a;f[c>>2]=wa+2;va=438;continue d;break}case 438:{va=0;f[da>>2]=f[da>>2]|32;wa=f[ka>>2]|0;if(!wa){va=439;break d}else{oe=wa;break d}break}}wa=pd+2|0;f[c>>2]=wa;ob=wa;pb=qd;va=285}if((va|0)==439){va=0;wa=L5b(20)|0;cOa(wa);f[ka>>2]=wa;oe=wa}wa=f[c>>2]|0;if(wa>>>0<(f[g>>2]|0)>>>0?(ra=b[wa>>0]|0,ra<<24>>24>-1):0){f[c>>2]=wa+1;pe=ra&255}else{ra=Znb(c)|0;if((ra|0)>-1)pe=ra;else{za=0;va=458;break a}}Inb(e,c,pe);if((f[a>>2]|0)<0){va=446;break a}if(!(iOa(oe,c)|0)){va=446;break a}if(!(Onb(c,f[e>>2]|0)|0)){za=0;va=458;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[la>>2]|0){va=451;break a}if((f[ma>>2]|0)==(f[na>>2]|0)){va=451;break a}else continue a}while(0);if((va|0)==452){va=0;if(!ya){za=1;va=458;break}else Aa=ya}if((Aa&7|0)==4){za=1;va=458;break}ra=f[z>>2]|0;if(!(ra&1))qe=hBa(z)|0;else qe=ra&-2;if(!(ZPb(c,Aa,qe)|0)){za=0;va=458;break}}switch(va|0){case 53:{za=0;u=d;return za|0}case 67:{za=0;u=d;return za|0}case 133:{za=0;u=d;return za|0}case 153:{za=0;u=d;return za|0}case 163:{za=0;u=d;return za|0}case 182:{za=0;u=d;return za|0}case 234:{za=0;u=d;return za|0}case 274:{za=0;u=d;return za|0}case 299:{za=0;u=d;return za|0}case 325:{za=0;u=d;return za|0}case 336:{za=0;u=d;return za|0}case 347:{za=0;u=d;return za|0}case 446:{za=0;u=d;return za|0}case 451:{f[i>>2]=0;b[c+24>>0]=1;za=1;u=d;return za|0}case 458:{u=d;return za|0}}return 0}function TNa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;c=a+8|0;d=f[c>>2]|0;if(d&255){if(!(d&1)){e=0;g=d}else{h=f[a+56>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&2)){n=e;o=g}else{l=f[a+60>>2]|0;k=b[l+11>>0]|0;if(k<<24>>24<0){m=f[l+4>>2]|0;if(m>>>0<128){p=1;q=g;r=m}else{l=iob(m)|0;p=l;q=f[c>>2]|0;r=m}}else{p=1;q=g;r=k&255}n=e+1+r+p|0;o=q}if(!(o&4)){s=n;t=o}else{q=f[a+88>>2]|0;if(q>>>0<128){u=1;v=o}else{o=iob(q)|0;u=o;v=f[c>>2]|0}s=n+1+u|0;t=v}v=t&8|0?s+2|0:s;if(!(t&16)){w=v;x=t}else{t=INa(f[a+76>>2]|0)|0;if(t>>>0<128)y=1;else y=iob(t)|0;w=v+1+t+y|0;x=f[c>>2]|0}if(!(x&32)){z=w;A=x}else{x=INa(f[a+80>>2]|0)|0;if(x>>>0<128)B=1;else B=iob(x)|0;z=w+1+x+B|0;A=f[c>>2]|0}if(!(A&64)){C=z;D=A}else{B=f[a+92>>2]|0;if(B>>>0<128){E=1;F=A}else{A=iob(B)|0;E=A;F=f[c>>2]|0}C=z+1+E|0;D=F}if(!(D&128)){G=C;H=D}else{F=f[a+96>>2]|0;if(F>>>0<128){I=1;J=D}else{D=iob(F)|0;I=D;J=f[c>>2]|0}G=C+1+I|0;H=J}}else{G=0;H=d}if(!(H&65280)){K=G;L=H}else{if(!(H&256)){M=G;N=H}else{d=f[a+148>>2]|0;if(d>>>0<128){O=1;P=H}else{H=iob(d)|0;O=H;P=f[c>>2]|0}M=G+1+O|0;N=P}if(!(N&512)){Q=M;R=N}else{P=f[a+152>>2]|0;if(P>>>0<128){S=1;T=N}else{N=iob(P)|0;S=N;T=f[c>>2]|0}Q=M+1+S|0;R=T}if(!(R&1024)){U=Q;V=R}else{T=f[a+100>>2]|0;if((T|0)>=0)if(T>>>0<128){W=1;X=R}else{S=iob(T)|0;W=S;X=f[c>>2]|0}else{W=10;X=R}U=Q+1+W|0;V=X}X=V&2048|0?U+5|0:U;if(!(V&4096)){Y=X;Z=V}else{U=f[a+160>>2]|0;if(U>>>0<128){_=1;$=V}else{V=iob(U)|0;_=V;$=f[c>>2]|0}Y=X+1+_|0;Z=$}$=Z&8192|0?Y+5|0:Y;Y=Z&16384|0?$+5|0:$;K=Z&32768|0?Y+6|0:Y;L=Z}if(!(L&4128768)){aa=K;ba=L}else{if(!(L&65536)){ca=K;da=L}else{Z=f[a+64>>2]|0;Y=b[Z+11>>0]|0;if(Y<<24>>24<0){$=f[Z+4>>2]|0;if($>>>0<128){ea=1;fa=L;ga=$}else{Z=iob($)|0;ea=Z;fa=f[c>>2]|0;ga=$}}else{ea=1;fa=L;ga=Y&255}ca=K+2+ga+ea|0;da=fa}fa=da&131072|0?ca+6|0:ca;if(!(da&262144)){ha=fa;ia=da}else{ca=f[a+68>>2]|0;ea=b[ca+11>>0]|0;if(ea<<24>>24<0){ga=f[ca+4>>2]|0;if(ga>>>0<128){ja=1;ka=da;la=ga}else{ca=iob(ga)|0;ja=ca;ka=f[c>>2]|0;la=ga}}else{ja=1;ka=da;la=ea&255}ha=fa+2+la+ja|0;ia=ka}if(!(ia&524288)){ma=ha;na=ia}else{ka=f[a+104>>2]|0;if(ka>>>0<128){oa=1;pa=ia}else{ia=iob(ka)|0;oa=ia;pa=f[c>>2]|0}ma=ha+2+oa|0;na=pa}if(!(na&1048576)){qa=ma;ra=na}else{pa=f[a+108>>2]|0;if(pa>>>0<128){sa=1;ta=na}else{na=iob(pa)|0;sa=na;ta=f[c>>2]|0}qa=ma+2+sa|0;ra=ta}aa=ra&2097152|0?qa+3|0:qa;ba=ra}if(ba>>>0>33554431){if(!(ba&33554432)){ua=aa;va=ba}else{ra=f[a+112>>2]|0;if(ra>>>0<128){wa=1;xa=ba}else{ba=iob(ra)|0;wa=ba;xa=f[c>>2]|0}ua=aa+2+wa|0;va=xa}xa=va&67108864|0?ua+6|0:ua;ua=va&134217728|0?xa+6|0:xa;xa=va&268435456|0?ua+6|0:ua;if(!(va&536870912)){ya=xa;za=va}else{ua=f[a+120>>2]|0;if(ua>>>0<128){Aa=1;Ba=va}else{va=iob(ua)|0;Aa=va;Ba=f[c>>2]|0}ya=xa+2+Aa|0;za=Ba}if(!(za&1073741824)){Ca=ya;Da=za}else{Ba=f[a+72>>2]|0;Aa=b[Ba+11>>0]|0;if(Aa<<24>>24<0){xa=f[Ba+4>>2]|0;if(xa>>>0<128){Ea=1;Fa=za;Ga=xa}else{Ba=iob(xa)|0;Ea=Ba;Fa=f[c>>2]|0;Ga=xa}}else{Ea=1;Fa=za;Ga=Aa&255}Ca=ya+2+Ga+Ea|0;Da=Fa}if((Da|0)<0){Da=f[a+124>>2]|0;if((Da|0)>=0)if(Da>>>0<128)Ha=1;else Ha=iob(Da)|0;else Ha=10;Ia=Ca+2+Ha|0}else Ia=Ca}else Ia=aa;aa=a+12|0;Ca=f[aa>>2]|0;if(Ca&63){if(!(Ca&1)){Ja=Ia;Ka=Ca}else{Ha=f[a+128>>2]|0;if((Ha|0)>=0)if(Ha>>>0<128){La=1;Ma=Ca}else{Da=iob(Ha)|0;La=Da;Ma=f[aa>>2]|0}else{La=10;Ma=Ca}Ja=Ia+2+La|0;Ka=Ma}if(!(Ka&2)){Na=Ja;Oa=Ka}else{Ma=f[a+132>>2]|0;if((Ma|0)>=0)if(Ma>>>0<128){Pa=3;Qa=Ka}else{La=(iob(Ma)|0)+2|0;Pa=La;Qa=f[aa>>2]|0}else{Pa=12;Qa=Ka}Na=Pa+Ja|0;Oa=Qa}if(!(Oa&4)){Ra=Na;Sa=Oa}else{Qa=f[a+136>>2]|0;if((Qa|0)>=0)if(Qa>>>0<128){Ta=3;Ua=Oa}else{Ja=(iob(Qa)|0)+2|0;Ta=Ja;Ua=f[aa>>2]|0}else{Ta=12;Ua=Oa}Ra=Ta+Na|0;Sa=Ua}Ua=Sa&8|0?Ra+3|0:Ra;if(!(Sa&16)){Va=Ua;Wa=Sa}else{Ra=f[a+140>>2]|0;if(Ra>>>0<128){Xa=3;Ya=Sa}else{Sa=(iob(Ra)|0)+2|0;Xa=Sa;Ya=f[aa>>2]|0}Va=Xa+Ua|0;Wa=Ya}if(!(Wa&32))Za=Va;else{Wa=f[a+84>>2]|0;if(!(f[Wa+8>>2]&1))_a=0;else{Ya=f[Wa+16>>2]|0;Ua=b[Ya+11>>0]|0;if(Ua<<24>>24<0){Xa=f[Ya+4>>2]|0;if(Xa>>>0<128){$a=1;ab=Xa}else{$a=iob(Xa)|0;ab=Xa}}else{$a=1;ab=Ua&255}_a=ab+1+$a|0}$a=f[Wa+4>>2]|0;if(!($a&1))bb=_a;else bb=(dQb($a&-2)|0)+_a|0;f[Wa+12>>2]=bb;if(bb>>>0<128)cb=1;else cb=iob(bb)|0;Za=Va+2+bb+cb|0}}else Za=Ia;Ia=f[a+20>>2]|0;cb=(Ia<<1)+Za|0;if(!Ia)db=cb;else{Za=a+28|0;bb=0;Va=cb;while(1){cb=gOa(f[(f[Za>>2]|0)+4+(bb<<2)>>2]|0)|0;if(cb>>>0<128)eb=1;else eb=iob(cb)|0;Wa=cb+Va+eb|0;bb=bb+1|0;if((bb|0)==(Ia|0)){db=Wa;break}else Va=Wa}}Va=f[a+32>>2]|0;Ia=f[a+44>>2]|0;bb=(Va<<2)+db+(Ia<<2)+(Ia+Va<<1)|0;Va=f[a+4>>2]|0;if(!(Va&1)){fb=bb;gb=a+192|0;f[gb>>2]=fb;return fb|0}fb=(dQb(Va&-2)|0)+bb|0;gb=a+192|0;f[gb>>2]=fb;return fb|0}function UNa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{$pb(1,f[a+56>>2]|0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{$pb(2,f[a+60>>2]|0,c);h=f[d>>2]|0}if(!(h&4))i=h;else{Opb(3,f[a+88>>2]|0,c);i=f[d>>2]|0}if(!(i&8))j=i;else{Ypb(4,(b[a+144>>0]|0)!=0,c);j=f[d>>2]|0}if(!(j&16))k=j;else{eqb(5,f[a+76>>2]|0,c);k=f[d>>2]|0}if(!(k&32))l=k;else{eqb(6,f[a+80>>2]|0,c);l=f[d>>2]|0}if(!(l&64))m=l;else{Opb(7,f[a+92>>2]|0,c);m=f[d>>2]|0}if(!(m&128))o=m;else{Opb(8,f[a+96>>2]|0,c);o=f[d>>2]|0}if(!(o&256))p=o;else{Opb(9,f[a+148>>2]|0,c);p=f[d>>2]|0}if(!(p&512))q=p;else{Opb(10,f[a+152>>2]|0,c);q=f[d>>2]|0}if(!(q&1024))r=q;else{Zpb(11,f[a+100>>2]|0,c);r=f[d>>2]|0}if(!(r&2048))s=r;else{Wpb(12,+n[a+156>>2],c);s=f[d>>2]|0}if(!(s&4096))t=s;else{Opb(13,f[a+160>>2]|0,c);t=f[d>>2]|0}if(!(t&8192))u=t;else{Wpb(14,+n[a+164>>2],c);u=f[d>>2]|0}if(!(u&16384))v=u;else{Wpb(15,+n[a+168>>2],c);v=f[d>>2]|0}if(!(v&65536))w=v;else{$pb(16,f[a+64>>2]|0,c);w=f[d>>2]|0}if(!(w&131072))x=w;else{Wpb(17,+n[a+176>>2],c);x=f[d>>2]|0}if(!(x&262144))y=x;else{$pb(18,f[a+68>>2]|0,c);y=f[d>>2]|0}if(!(y&524288))z=y;else{Opb(19,f[a+104>>2]|0,c);z=f[d>>2]|0}if(!(z&1048576))A=z;else{Opb(20,f[a+108>>2]|0,c);A=f[d>>2]|0}if(!(A&2097152))B=A;else{Ypb(21,(b[a+116>>0]|0)!=0,c);B=f[d>>2]|0}if(B&32768|0)Wpb(22,+n[a+172>>2],c);B=f[a+20>>2]|0;if(B|0){A=a+28|0;z=0;do{eqb(50,f[(f[A>>2]|0)+4+(z<<2)>>2]|0,c);z=z+1|0}while((z|0)!=(B|0))}B=a+32|0;if((f[B>>2]|0)>0){z=a+40|0;A=0;do{Wpb(51,+n[(f[z>>2]|0)+4+(A<<2)>>2],c);A=A+1|0}while((A|0)<(f[B>>2]|0))}B=a+44|0;if((f[B>>2]|0)>0){A=a+52|0;z=0;do{Wpb(52,+n[(f[A>>2]|0)+4+(z<<2)>>2],c);z=z+1|0}while((z|0)<(f[B>>2]|0))}B=f[d>>2]|0;if(!(B&33554432))C=B;else{Opb(53,f[a+112>>2]|0,c);C=f[d>>2]|0}if(!(C&67108864))D=C;else{Wpb(54,+n[a+180>>2],c);D=f[d>>2]|0}if(!(D&134217728))E=D;else{Wpb(55,+n[a+184>>2],c);E=f[d>>2]|0}if(!(E&268435456))F=E;else{Wpb(56,+n[a+188>>2],c);F=f[d>>2]|0}if(!(F&536870912))G=F;else{Opb(58,f[a+120>>2]|0,c);G=f[d>>2]|0}if(!(G&1073741824))H=G;else{$pb(59,f[a+72>>2]|0,c);H=f[d>>2]|0}if((H|0)<0)Mpb(60,f[a+124>>2]|0,c);H=a+12|0;d=f[H>>2]|0;if(!(d&1))I=d;else{Mpb(61,f[a+128>>2]|0,c);I=f[H>>2]|0}if(!(I&2))J=I;else{Mpb(62,f[a+132>>2]|0,c);J=f[H>>2]|0}if(!(J&4))K=J;else{Mpb(63,f[a+136>>2]|0,c);K=f[H>>2]|0}if(!(K&8))L=K;else{Ypb(64,(b[a+117>>0]|0)!=0,c);L=f[H>>2]|0}if(!(L&16))M=L;else{Opb(65,f[a+140>>2]|0,c);M=f[H>>2]|0}if(M&32|0)eqb(1001,f[a+84>>2]|0,c);M=f[a+4>>2]|0;if(!(M&1))return;aQb(M&-2,c);return}function VNa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function WNa(a){a=a|0;return f[a+192>>2]|0}function XNa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+56>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&2)){j=g;k=h}else{h=f[a+60>>2]|0;b[g>>0]=18;i=kob(h,g+1|0)|0;j=i;k=f[c>>2]|0}if(!(k&4)){l=j;m=k}else{k=f[a+88>>2]|0;b[j>>0]=24;i=j+1|0;if(k>>>0>127){j=k;g=i;while(1){b[g>>0]=j|128;h=j>>>7;d=g+1|0;if(j>>>0>16383){j=h;g=d}else{n=d;o=h;break}}}else{n=i;o=k}b[n>>0]=o;l=n+1|0;m=f[c>>2]|0}if(!(m&8)){p=l;q=m}else{m=b[a+144>>0]|0;b[l>>0]=32;b[l+1>>0]=m;p=l+2|0;q=f[c>>2]|0}if(!(q&16)){r=p;s=q}else{q=f[a+76>>2]|0;b[p>>0]=42;l=p+1|0;p=f[q+12>>2]|0;if(p>>>0>127){m=p;n=l;while(1){b[n>>0]=m|128;o=m>>>7;k=n+1|0;if(m>>>0>16383){m=o;n=k}else{t=k;u=o;break}}}else{t=l;u=p}b[t>>0]=u;u=li[f[(f[q>>2]|0)+68>>2]&511](q,0,t+1|0)|0;r=u;s=f[c>>2]|0}if(!(s&32)){v=r;w=s}else{s=f[a+80>>2]|0;b[r>>0]=50;u=r+1|0;r=f[s+12>>2]|0;if(r>>>0>127){t=r;q=u;while(1){b[q>>0]=t|128;p=t>>>7;l=q+1|0;if(t>>>0>16383){t=p;q=l}else{x=l;y=p;break}}}else{x=u;y=r}b[x>>0]=y;y=li[f[(f[s>>2]|0)+68>>2]&511](s,0,x+1|0)|0;v=y;w=f[c>>2]|0}if(!(w&64)){z=v;A=w}else{w=f[a+92>>2]|0;b[v>>0]=56;y=v+1|0;if(w>>>0>127){v=w;x=y;while(1){b[x>>0]=v|128;s=v>>>7;r=x+1|0;if(v>>>0>16383){v=s;x=r}else{B=r;C=s;break}}}else{B=y;C=w}b[B>>0]=C;z=B+1|0;A=f[c>>2]|0}if(!(A&128)){D=z;E=A}else{A=f[a+96>>2]|0;b[z>>0]=64;B=z+1|0;if(A>>>0>127){z=A;C=B;while(1){b[C>>0]=z|128;w=z>>>7;y=C+1|0;if(z>>>0>16383){z=w;C=y}else{F=y;G=w;break}}}else{F=B;G=A}b[F>>0]=G;D=F+1|0;E=f[c>>2]|0}if(!(E&256)){H=D;I=E}else{E=f[a+148>>2]|0;b[D>>0]=72;F=D+1|0;if(E>>>0>127){D=E;G=F;while(1){b[G>>0]=D|128;A=D>>>7;B=G+1|0;if(D>>>0>16383){D=A;G=B}else{J=B;K=A;break}}}else{J=F;K=E}b[J>>0]=K;H=J+1|0;I=f[c>>2]|0}if(!(I&512)){L=H;M=I}else{I=f[a+152>>2]|0;b[H>>0]=80;J=H+1|0;if(I>>>0>127){H=I;K=J;while(1){b[K>>0]=H|128;E=H>>>7;F=K+1|0;if(H>>>0>16383){H=E;K=F}else{N=F;O=E;break}}}else{N=J;O=I}b[N>>0]=O;L=N+1|0;M=f[c>>2]|0}do if(!(M&1024))P=L;else{N=f[a+100>>2]|0;b[L>>0]=88;O=L+1|0;if((N|0)<0){P=hob(N,((N|0)<0)<<31>>31,O)|0;break}if(N>>>0>127){I=N;J=O;while(1){b[J>>0]=I|128;K=I>>>7;H=J+1|0;if(I>>>0>16383){I=K;J=H}else{Q=H;R=K;break}}}else{Q=O;R=N}b[Q>>0]=R;P=Q+1|0}while(0);Q=f[c>>2]|0;if(!(Q&2048)){S=P;T=Q}else{Q=f[a+156>>2]|0;b[P>>0]=101;R=P+1|0;b[R>>0]=Q;b[R+1>>0]=Q>>8;b[R+2>>0]=Q>>16;b[R+3>>0]=Q>>24;S=P+5|0;T=f[c>>2]|0}if(!(T&4096)){U=S;V=T}else{T=f[a+160>>2]|0;b[S>>0]=104;P=S+1|0;if(T>>>0>127){S=T;Q=P;while(1){b[Q>>0]=S|128;R=S>>>7;L=Q+1|0;if(S>>>0>16383){S=R;Q=L}else{W=L;X=R;break}}}else{W=P;X=T}b[W>>0]=X;U=W+1|0;V=f[c>>2]|0}if(!(V&8192)){Y=U;Z=V}else{V=f[a+164>>2]|0;b[U>>0]=117;W=U+1|0;b[W>>0]=V;b[W+1>>0]=V>>8;b[W+2>>0]=V>>16;b[W+3>>0]=V>>24;Y=U+5|0;Z=f[c>>2]|0}if(!(Z&16384)){_=Y;$=Z}else{Z=f[a+168>>2]|0;b[Y>>0]=125;U=Y+1|0;b[U>>0]=Z;b[U+1>>0]=Z>>8;b[U+2>>0]=Z>>16;b[U+3>>0]=Z>>24;_=Y+5|0;$=f[c>>2]|0}if(!($&65536)){aa=_;ba=$}else{$=f[a+64>>2]|0;b[_>>0]=-126;b[_+1>>0]=1;Y=kob($,_+2|0)|0;aa=Y;ba=f[c>>2]|0}if(!(ba&131072)){ca=aa;da=ba}else{ba=f[a+176>>2]|0;b[aa>>0]=-115;b[aa+1>>0]=1;Y=aa+2|0;b[Y>>0]=ba;b[Y+1>>0]=ba>>8;b[Y+2>>0]=ba>>16;b[Y+3>>0]=ba>>24;ca=aa+6|0;da=f[c>>2]|0}if(!(da&262144)){ea=ca;fa=da}else{da=f[a+68>>2]|0;b[ca>>0]=-110;b[ca+1>>0]=1;aa=kob(da,ca+2|0)|0;ea=aa;fa=f[c>>2]|0}if(!(fa&524288)){ga=ea;ha=fa}else{fa=f[a+104>>2]|0;b[ea>>0]=-104;b[ea+1>>0]=1;aa=ea+2|0;if(fa>>>0>127){ea=fa;ca=aa;while(1){b[ca>>0]=ea|128;da=ea>>>7;ba=ca+1|0;if(ea>>>0>16383){ea=da;ca=ba}else{ia=ba;ja=da;break}}}else{ia=aa;ja=fa}b[ia>>0]=ja;ga=ia+1|0;ha=f[c>>2]|0}if(!(ha&1048576)){ka=ga;la=ha}else{ha=f[a+108>>2]|0;b[ga>>0]=-96;b[ga+1>>0]=1;ia=ga+2|0;if(ha>>>0>127){ga=ha;ja=ia;while(1){b[ja>>0]=ga|128;fa=ga>>>7;aa=ja+1|0;if(ga>>>0>16383){ga=fa;ja=aa}else{ma=aa;na=fa;break}}}else{ma=ia;na=ha}b[ma>>0]=na;ka=ma+1|0;la=f[c>>2]|0}if(!(la&2097152)){oa=ka;pa=la}else{la=b[a+116>>0]|0;b[ka>>0]=-88;b[ka+1>>0]=1;b[ka+2>>0]=la;oa=ka+3|0;pa=f[c>>2]|0}if(!(pa&32768))qa=oa;else{pa=f[a+172>>2]|0;b[oa>>0]=-75;b[oa+1>>0]=1;ka=oa+2|0;b[ka>>0]=pa;b[ka+1>>0]=pa>>8;b[ka+2>>0]=pa>>16;b[ka+3>>0]=pa>>24;qa=oa+6|0}oa=f[a+20>>2]|0;if(!oa)ra=qa;else{pa=a+28|0;ka=0;la=qa;while(1){qa=f[(f[pa>>2]|0)+4+(ka<<2)>>2]|0;b[la>>0]=-110;b[la+1>>0]=3;ma=la+2|0;na=f[qa+12>>2]|0;if(na>>>0>127){ha=na;ia=ma;while(1){b[ia>>0]=ha|128;ja=ha>>>7;ga=ia+1|0;if(ha>>>0>16383){ha=ja;ia=ga}else{sa=ga;ta=ja;break}}}else{sa=ma;ta=na}b[sa>>0]=ta;ia=li[f[(f[qa>>2]|0)+68>>2]&511](qa,0,sa+1|0)|0;ka=ka+1|0;if((ka|0)==(oa|0)){ra=ia;break}else la=ia}}la=a+32|0;if((f[la>>2]|0)>0){oa=a+40|0;ka=0;sa=ra;while(1){ta=f[(f[oa>>2]|0)+4+(ka<<2)>>2]|0;b[sa>>0]=-99;b[sa+1>>0]=3;pa=sa+2|0;b[pa>>0]=ta;b[pa+1>>0]=ta>>8;b[pa+2>>0]=ta>>16;b[pa+3>>0]=ta>>24;ta=sa+6|0;ka=ka+1|0;if((ka|0)>=(f[la>>2]|0)){ua=ta;break}else sa=ta}}else ua=ra;ra=a+44|0;if((f[ra>>2]|0)>0){sa=a+52|0;la=0;ka=ua;while(1){oa=f[(f[sa>>2]|0)+4+(la<<2)>>2]|0;b[ka>>0]=-91;b[ka+1>>0]=3;ta=ka+2|0;b[ta>>0]=oa;b[ta+1>>0]=oa>>8;b[ta+2>>0]=oa>>16;b[ta+3>>0]=oa>>24;oa=ka+6|0;la=la+1|0;if((la|0)>=(f[ra>>2]|0)){va=oa;break}else ka=oa}}else va=ua;ua=f[c>>2]|0;if(!(ua&33554432)){wa=va;xa=ua}else{ua=f[a+112>>2]|0;b[va>>0]=-88;b[va+1>>0]=3;ka=va+2|0;if(ua>>>0>127){va=ua;ra=ka;while(1){b[ra>>0]=va|128;la=va>>>7;sa=ra+1|0;if(va>>>0>16383){va=la;ra=sa}else{ya=sa;za=la;break}}}else{ya=ka;za=ua}b[ya>>0]=za;wa=ya+1|0;xa=f[c>>2]|0}if(!(xa&67108864)){Aa=wa;Ba=xa}else{xa=f[a+180>>2]|0;b[wa>>0]=-75;b[wa+1>>0]=3;ya=wa+2|0;b[ya>>0]=xa;b[ya+1>>0]=xa>>8;b[ya+2>>0]=xa>>16;b[ya+3>>0]=xa>>24;Aa=wa+6|0;Ba=f[c>>2]|0}if(!(Ba&134217728)){Ca=Aa;Da=Ba}else{Ba=f[a+184>>2]|0;b[Aa>>0]=-67;b[Aa+1>>0]=3;wa=Aa+2|0;b[wa>>0]=Ba;b[wa+1>>0]=Ba>>8;b[wa+2>>0]=Ba>>16;b[wa+3>>0]=Ba>>24;Ca=Aa+6|0;Da=f[c>>2]|0}if(!(Da&268435456)){Ea=Ca;Fa=Da}else{Da=f[a+188>>2]|0;b[Ca>>0]=-59;b[Ca+1>>0]=3;Aa=Ca+2|0;b[Aa>>0]=Da;b[Aa+1>>0]=Da>>8;b[Aa+2>>0]=Da>>16;b[Aa+3>>0]=Da>>24;Ea=Ca+6|0;Fa=f[c>>2]|0}if(!(Fa&536870912)){Ga=Ea;Ha=Fa}else{Fa=f[a+120>>2]|0;b[Ea>>0]=-48;b[Ea+1>>0]=3;Ca=Ea+2|0;if(Fa>>>0>127){Ea=Fa;Da=Ca;while(1){b[Da>>0]=Ea|128;Aa=Ea>>>7;Ba=Da+1|0;if(Ea>>>0>16383){Ea=Aa;Da=Ba}else{Ia=Ba;Ja=Aa;break}}}else{Ia=Ca;Ja=Fa}b[Ia>>0]=Ja;Ga=Ia+1|0;Ha=f[c>>2]|0}if(!(Ha&1073741824)){Ka=Ga;La=Ha}else{Ha=f[a+72>>2]|0;b[Ga>>0]=-38;b[Ga+1>>0]=3;Ia=kob(Ha,Ga+2|0)|0;Ka=Ia;La=f[c>>2]|0}do if((La|0)<0){c=f[a+124>>2]|0;b[Ka>>0]=-32;b[Ka+1>>0]=3;Ia=Ka+2|0;if((c|0)<0){Ma=hob(c,((c|0)<0)<<31>>31,Ia)|0;break}if(c>>>0>127){Ga=c;Ha=Ia;while(1){b[Ha>>0]=Ga|128;Ja=Ga>>>7;Fa=Ha+1|0;if(Ga>>>0>16383){Ga=Ja;Ha=Fa}else{Na=Fa;Oa=Ja;break}}}else{Na=Ia;Oa=c}b[Na>>0]=Oa;Ma=Na+1|0}else Ma=Ka;while(0);Ka=a+12|0;do if(!(f[Ka>>2]&1))Pa=Ma;else{Na=f[a+128>>2]|0;b[Ma>>0]=-24;b[Ma+1>>0]=3;Oa=Ma+2|0;if((Na|0)<0){Pa=hob(Na,((Na|0)<0)<<31>>31,Oa)|0;break}if(Na>>>0>127){La=Na;Ha=Oa;while(1){b[Ha>>0]=La|128;Ga=La>>>7;qa=Ha+1|0;if(La>>>0>16383){La=Ga;Ha=qa}else{Qa=qa;Ra=Ga;break}}}else{Qa=Oa;Ra=Na}b[Qa>>0]=Ra;Pa=Qa+1|0}while(0);do if(!(f[Ka>>2]&2))Sa=Pa;else{Qa=f[a+132>>2]|0;b[Pa>>0]=-16;b[Pa+1>>0]=3;Ra=Pa+2|0;if((Qa|0)<0){Sa=hob(Qa,((Qa|0)<0)<<31>>31,Ra)|0;break}if(Qa>>>0>127){Ma=Qa;Ha=Ra;while(1){b[Ha>>0]=Ma|128;La=Ma>>>7;c=Ha+1|0;if(Ma>>>0>16383){Ma=La;Ha=c}else{Ta=c;Ua=La;break}}}else{Ta=Ra;Ua=Qa}b[Ta>>0]=Ua;Sa=Ta+1|0}while(0);do if(!(f[Ka>>2]&4))Va=Sa;else{Ta=f[a+136>>2]|0;b[Sa>>0]=-8;b[Sa+1>>0]=3;Ua=Sa+2|0;if((Ta|0)<0){Va=hob(Ta,((Ta|0)<0)<<31>>31,Ua)|0;break}if(Ta>>>0>127){Pa=Ta;Ha=Ua;while(1){b[Ha>>0]=Pa|128;Ma=Pa>>>7;Na=Ha+1|0;if(Pa>>>0>16383){Pa=Ma;Ha=Na}else{Wa=Na;Xa=Ma;break}}}else{Wa=Ua;Xa=Ta}b[Wa>>0]=Xa;Va=Wa+1|0}while(0);Wa=f[Ka>>2]|0;if(!(Wa&8)){Ya=Va;Za=Wa}else{Wa=b[a+117>>0]|0;b[Va>>0]=-128;b[Va+1>>0]=4;b[Va+2>>0]=Wa;Ya=Va+3|0;Za=f[Ka>>2]|0}if(!(Za&16)){_a=Ya;$a=Za}else{Za=f[a+140>>2]|0;b[Ya>>0]=-120;b[Ya+1>>0]=4;Va=Ya+2|0;if(Za>>>0>127){Ya=Za;Wa=Va;while(1){b[Wa>>0]=Ya|128;Xa=Ya>>>7;Sa=Wa+1|0;if(Ya>>>0>16383){Ya=Xa;Wa=Sa}else{ab=Sa;bb=Xa;break}}}else{ab=Va;bb=Za}b[ab>>0]=bb;_a=ab+1|0;$a=f[Ka>>2]|0}if(!($a&32))cb=_a;else{$a=f[a+84>>2]|0;b[_a>>0]=-54;b[_a+1>>0]=62;Ka=_a+2|0;_a=f[$a+12>>2]|0;if(_a>>>0>127){ab=_a;bb=Ka;while(1){b[bb>>0]=ab|128;Za=ab>>>7;Va=bb+1|0;if(ab>>>0>16383){ab=Za;bb=Va}else{db=Va;eb=Za;break}}}else{db=Ka;eb=_a}b[db>>0]=eb;cb=li[f[(f[$a>>2]|0)+68>>2]&511]($a,0,db+1|0)|0}db=f[a+4>>2]|0;if(!(db&1)){fb=cb;return fb|0}fb=bQb(db&-2,cb)|0;return fb|0}function YNa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function ZNa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(52309);c=T6b(b,23288,18856,0)|0;if(!c){cOb(b,a);return}else{aOa(a,c);return}}function _Na(a,b){a=a|0;b=b|0;f[a+192>>2]=b;return}function $Na(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213190];f[a+4>>2]=f[213191];u=c;return}function aOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=u;u=u+32|0;e=d+24|0;g=d;h=d+20|0;i=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;bOa(a+16|0,c+16|0);m=a+32|0;n=c+32|0;o=f[n>>2]|0;if(o|0){qza(m,(f[m>>2]|0)+o|0);Vac((f[a+40>>2]|0)+4+(f[m>>2]<<2)|0,(f[c+40>>2]|0)+4|0,f[n>>2]<<2|0)|0;f[m>>2]=(f[m>>2]|0)+(f[n>>2]|0)}n=a+44|0;m=c+44|0;o=f[m>>2]|0;if(o|0){qza(n,(f[n>>2]|0)+o|0);Vac((f[a+52>>2]|0)+4+(f[n>>2]<<2)|0,(f[c+52>>2]|0)+4|0,f[m>>2]<<2|0)|0;f[n>>2]=(f[n>>2]|0)+(f[m>>2]|0)}m=c+8|0;n=f[m>>2]|0;if(n&255){if(!(n&1))p=n;else{o=a+8|0;f[o>>2]=f[o>>2]|1;f[h>>2]=f[c+56>>2];f[e>>2]=f[h>>2];Anb(a+56|0,497760,e);p=f[m>>2]|0}if(!(p&2))q=p;else{p=a+8|0;f[p>>2]=f[p>>2]|2;f[i>>2]=f[c+60>>2];f[e>>2]=f[i>>2];Anb(a+60|0,497760,e);q=f[m>>2]|0}if(!(q&4))r=q;else{q=f[c+88>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|4;f[a+88>>2]=q;r=f[m>>2]|0}if(!(r&8))s=r;else{r=b[c+144>>0]|0;q=a+8|0;f[q>>2]=f[q>>2]|8;b[a+144>>0]=r;s=f[m>>2]|0}do if(s&16){r=a+8|0;f[r>>2]=f[r>>2]|16;r=a+76|0;q=f[r>>2]|0;if(!q){i=L5b(48)|0;GNa(i);f[r>>2]=i;t=i}else t=q;q=f[c+76>>2]|0;i=(q|0)==0?493544:q;if((i|0)==(t|0))jMa(8763);else{HNa(t,i);v=f[m>>2]|0;break}}else v=s;while(0);do if(v&32){s=a+8|0;f[s>>2]=f[s>>2]|32;s=a+80|0;t=f[s>>2]|0;if(!t){i=L5b(48)|0;GNa(i);f[s>>2]=i;w=i}else w=t;t=f[c+80>>2]|0;i=(t|0)==0?493544:t;if((i|0)==(w|0))jMa(8763);else{HNa(w,i);x=f[m>>2]|0;break}}else x=v;while(0);if(!(x&64))y=x;else{x=f[c+92>>2]|0;v=a+8|0;f[v>>2]=f[v>>2]|64;f[a+92>>2]=x;y=f[m>>2]|0}if(!(y&128))z=y;else{y=f[c+96>>2]|0;x=a+8|0;f[x>>2]=f[x>>2]|128;f[a+96>>2]=y;z=f[m>>2]|0}}else z=n;if(z&65280){if(!(z&256))A=z;else{n=f[c+148>>2]|0;y=a+8|0;f[y>>2]=f[y>>2]|256;f[a+148>>2]=n;A=f[m>>2]|0}if(!(A&512))B=A;else{A=f[c+152>>2]|0;n=a+8|0;f[n>>2]=f[n>>2]|512;f[a+152>>2]=A;B=f[m>>2]|0}if(!(B&1024))C=B;else{B=f[c+100>>2]|0;A=a+8|0;f[A>>2]=f[A>>2]|1024;f[a+100>>2]=B;C=f[m>>2]|0}if(!(C&2048))D=C;else{C=f[c+156>>2]|0;B=a+8|0;f[B>>2]=f[B>>2]|2048;f[a+156>>2]=C;D=f[m>>2]|0}if(!(D&4096))E=D;else{D=f[c+160>>2]|0;C=a+8|0;f[C>>2]=f[C>>2]|4096;f[a+160>>2]=D;E=f[m>>2]|0}if(!(E&8192))F=E;else{E=f[c+164>>2]|0;D=a+8|0;f[D>>2]=f[D>>2]|8192;f[a+164>>2]=E;F=f[m>>2]|0}if(!(F&16384))G=F;else{F=f[c+168>>2]|0;E=a+8|0;f[E>>2]=f[E>>2]|16384;f[a+168>>2]=F;G=f[m>>2]|0}if(!(G&32768))H=G;else{G=f[c+172>>2]|0;F=a+8|0;f[F>>2]=f[F>>2]|32768;f[a+172>>2]=G;H=f[m>>2]|0}}else H=z;if(H&16711680){if(!(H&65536))I=H;else{z=a+8|0;f[z>>2]=f[z>>2]|65536;f[j>>2]=f[c+64>>2];f[e>>2]=f[j>>2];Anb(a+64|0,497760,e);I=f[m>>2]|0}if(!(I&131072))J=I;else{I=f[c+176>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|131072;f[a+176>>2]=I;J=f[m>>2]|0}if(!(J&262144))K=J;else{J=a+8|0;f[J>>2]=f[J>>2]|262144;f[k>>2]=f[c+68>>2];f[e>>2]=f[k>>2];Anb(a+68|0,497760,e);K=f[m>>2]|0}if(!(K&524288))L=K;else{K=f[c+104>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|524288;f[a+104>>2]=K;L=f[m>>2]|0}if(!(L&1048576))M=L;else{L=f[c+108>>2]|0;K=a+8|0;f[K>>2]=f[K>>2]|1048576;f[a+108>>2]=L;M=f[m>>2]|0}if(!(M&2097152))N=M;else{M=b[c+116>>0]|0;L=a+8|0;f[L>>2]=f[L>>2]|2097152;b[a+116>>0]=M;N=f[m>>2]|0}}else N=H;if(N>>>0>33554431){if(!(N&33554432))O=N;else{N=f[c+112>>2]|0;H=a+8|0;f[H>>2]=f[H>>2]|33554432;f[a+112>>2]=N;O=f[m>>2]|0}if(!(O&67108864))P=O;else{O=f[c+180>>2]|0;N=a+8|0;f[N>>2]=f[N>>2]|67108864;f[a+180>>2]=O;P=f[m>>2]|0}if(!(P&134217728))Q=P;else{P=f[c+184>>2]|0;O=a+8|0;f[O>>2]=f[O>>2]|134217728;f[a+184>>2]=P;Q=f[m>>2]|0}if(!(Q&268435456))R=Q;else{Q=f[c+188>>2]|0;P=a+8|0;f[P>>2]=f[P>>2]|268435456;f[a+188>>2]=Q;R=f[m>>2]|0}if(!(R&536870912))S=R;else{R=f[c+120>>2]|0;Q=a+8|0;f[Q>>2]=f[Q>>2]|536870912;f[a+120>>2]=R;S=f[m>>2]|0}if(!(S&1073741824))T=S;else{S=a+8|0;f[S>>2]=f[S>>2]|1073741824;S=f[213032]|0;f[l>>2]=f[c+72>>2];f[e>>2]=f[l>>2];Anb(a+72|0,S,e);T=f[m>>2]|0}if((T|0)<0){T=f[c+124>>2]|0;m=a+8|0;f[m>>2]=f[m>>2]|-2147483648;f[a+124>>2]=T}}T=c+12|0;m=f[T>>2]|0;if(m&255|0){if(!(m&1))U=m;else{m=f[c+128>>2]|0;S=a+12|0;f[S>>2]=f[S>>2]|1;f[a+128>>2]=m;U=f[T>>2]|0}if(!(U&2))V=U;else{U=f[c+132>>2]|0;m=a+12|0;f[m>>2]=f[m>>2]|2;f[a+132>>2]=U;V=f[T>>2]|0}if(!(V&4))W=V;else{V=f[c+136>>2]|0;U=a+12|0;f[U>>2]=f[U>>2]|4;f[a+136>>2]=V;W=f[T>>2]|0}if(!(W&8))X=W;else{W=b[c+117>>0]|0;V=a+12|0;f[V>>2]=f[V>>2]|8;b[a+117>>0]=W;X=f[T>>2]|0}if(!(X&16))Y=X;else{X=f[c+140>>2]|0;W=a+12|0;f[W>>2]=f[W>>2]|16;f[a+140>>2]=X;Y=f[T>>2]|0}if(Y&32|0){Y=a+12|0;f[Y>>2]=f[Y>>2]|32;Y=a+84|0;T=f[Y>>2]|0;if(!T){X=L5b(20)|0;cOa(X);f[Y>>2]=X;Z=X}else Z=T;T=f[c+84>>2]|0;X=(T|0)==0?495568:T;if((X|0)==(Z|0))jMa(33049);if(f[X+8>>2]&1|0){T=Z+8|0;f[T>>2]=f[T>>2]|1;f[g>>2]=f[X+16>>2];f[e>>2]=f[g>>2];Anb(Z+16|0,497760,e)}e=f[X+4>>2]|0;if(e&1|0)LPb(e&-2,Z+4|0)}}Z=f[c+4>>2]|0;if(!(Z&1)){u=d;return}LPb(Z&-2,a+4|0);u=d;return}function bOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{dOa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=pza(h,i)|0;dOa(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function cOa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=115236;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495568?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=497760;u=c;return}function dOa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))jMa(3728);else{eOa(b,a);return}}function eOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;d=c+4|0;e=c;g=a+16|0;h=b+16|0;i=f[h>>2]|0;if(i|0){qza(g,(f[g>>2]|0)+i|0);Vac((f[a+24>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[h>>2]|0)}h=a+32|0;g=b+32|0;i=f[g>>2]|0;if(i|0){qza(h,(f[h>>2]|0)+i|0);Vac((f[a+40>>2]|0)+4+(f[h>>2]<<2)|0,(f[b+40>>2]|0)+4|0,f[g>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[g>>2]|0)}g=a+48|0;h=b+48|0;i=f[h>>2]|0;if(i|0){tFa(g,(f[g>>2]|0)+i|0);Vac((f[a+56>>2]|0)+8+(f[g>>2]<<3)|0,(f[b+56>>2]|0)+8|0,f[h>>2]<<3|0)|0;f[g>>2]=(f[g>>2]|0)+(f[h>>2]|0)}h=a+64|0;g=b+64|0;i=f[g>>2]|0;if(i|0){tFa(h,(f[h>>2]|0)+i|0);Vac((f[a+72>>2]|0)+8+(f[h>>2]<<3)|0,(f[b+72>>2]|0)+8|0,f[g>>2]<<3|0)|0;f[h>>2]=(f[h>>2]|0)+(f[g>>2]|0)}g=b+8|0;h=f[g>>2]|0;if(h&255){if(h&1|0){i=a+8|0;f[i>>2]=f[i>>2]|1;i=a+84|0;j=f[i>>2]|0;if(!j){k=L5b(32)|0;fOa(k);f[i>>2]=k;l=k}else l=j;j=f[b+84>>2]|0;k=(j|0)==0?493e3:j;if((k|0)==(l|0))jMa(2959);j=l+16|0;i=k+16|0;m=f[i>>2]|0;if(m|0){uFa(j,(f[j>>2]|0)+m|0);Vac((f[l+24>>2]|0)+8+(f[j>>2]<<3)|0,(f[k+24>>2]|0)+8|0,f[i>>2]<<3|0)|0;f[j>>2]=(f[j>>2]|0)+(f[i>>2]|0)}i=f[k+4>>2]|0;if(i&1|0)LPb(i&-2,l+4|0)}l=f[g>>2]|0;if(!(l&32))n=l;else{l=f[b+88>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|32;f[a+88>>2]=l;n=f[g>>2]|0}if(!(n&64))o=n;else{n=a+8|0;f[n>>2]=f[n>>2]|64;f[e>>2]=f[b+80>>2];f[d>>2]=f[e>>2];Anb(a+80|0,497760,d);o=f[g>>2]|0}if(!(o&128))p=o;else{o=f[b+92>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|128;f[a+92>>2]=o;p=f[g>>2]|0}}else p=h;if(p&65280|0){if(!(p&256))q=p;else{p=f[b+96>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|256;f[a+96>>2]=p;q=f[g>>2]|0}if(!(q&512))r=q;else{q=f[b+100>>2]|0;p=a+8|0;f[p>>2]=f[p>>2]|512;f[a+100>>2]=q;r=f[g>>2]|0}if(r&1024|0){r=f[b+104>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1024;f[a+104>>2]=r}}r=f[b+4>>2]|0;if(!(r&1)){u=c;return}LPb(r&-2,a+4|0);u=c;return}function fOa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=109288;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=493e3?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;u=c;return}function gOa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;c=a+8|0;d=f[c>>2]|0;if(d&225){if(!(d&1)){e=0;g=d}else{h=f[a+84>>2]|0;i=f[h+16>>2]|0;if(i){j=h+24|0;k=0;l=0;do{m=(f[j>>2]|0)+8+(l<<3)|0;k=(job(f[m>>2]|0,f[m+4>>2]|0)|0)+k|0;l=l+1|0}while((l|0)!=(i|0));if(k)if((k|0)>=0)if(k>>>0<128){n=2;o=k}else{n=(iob(k)|0)+1|0;o=k}else{n=11;o=k}else{n=0;o=0}}else{n=0;o=0}f[h+28>>2]=o;k=n+o|0;o=f[h+4>>2]|0;if(!(o&1))p=k;else p=(dQb(o&-2)|0)+k|0;f[h+12>>2]=p;if(p>>>0<128)q=1;else q=iob(p)|0;e=p+1+q|0;g=f[c>>2]|0}if(!(g&32)){r=e;s=g}else{q=f[a+88>>2]|0;if((q|0)>=0)if(q>>>0<128){t=1;u=g}else{p=iob(q)|0;t=p;u=f[c>>2]|0}else{t=10;u=g}r=e+1+t|0;s=u}if(!(s&64)){v=r;w=s}else{u=f[a+80>>2]|0;t=b[u+11>>0]|0;if(t<<24>>24<0){e=f[u+4>>2]|0;if(e>>>0<128){x=1;y=s;z=e}else{u=iob(e)|0;x=u;y=f[c>>2]|0;z=e}}else{x=1;y=s;z=t&255}v=r+1+z+x|0;w=y}if(!(w&128)){A=v;B=w}else{y=f[a+92>>2]|0;if((y|0)>=0)if(y>>>0<128){C=1;D=w}else{x=iob(y)|0;C=x;D=f[c>>2]|0}else{C=10;D=w}A=v+1+C|0;B=D}}else{A=0;B=d}if(B&1792){if(!(B&256)){E=A;F=B}else{d=f[a+96>>2]|0;if((d|0)>=0)if(d>>>0<128){G=1;H=B}else{D=iob(d)|0;G=D;H=f[c>>2]|0}else{G=10;H=B}E=A+1+G|0;F=H}if(!(F&512)){I=E;J=F}else{H=f[a+100>>2]|0;if((H|0)>=0)if(H>>>0<128){K=2;L=F}else{G=(iob(H)|0)+1|0;K=G;L=f[c>>2]|0}else{K=11;L=F}I=K+E|0;J=L}if(!(J&1024))M=I;else{J=f[a+104>>2]|0;if((J|0)>=0)if(J>>>0<128)N=2;else N=(iob(J)|0)+1|0;else N=11;M=N+I|0}}else M=A;A=f[a+16>>2]<<2;if(!A)O=M;else{if((A|0)>=0)if(A>>>0<128)P=2;else P=(iob(A)|0)+1|0;else P=11;O=P+M|0}f[a+28>>2]=A;M=O+A|0;A=f[a+32>>2]<<2;if(!A)Q=M;else{if((A|0)>=0)if(A>>>0<128)R=2;else R=(iob(A)|0)+1|0;else R=11;Q=R+M|0}f[a+44>>2]=A;M=Q+A|0;A=f[a+48>>2]<<3;if(!A)S=M;else{if((A|0)>=0)if(A>>>0<128)T=2;else T=(iob(A)|0)+1|0;else T=11;S=T+M|0}f[a+60>>2]=A;M=S+A|0;A=f[a+64>>2]<<3;if(!A)U=M;else{if((A|0)>=0)if(A>>>0<128)V=2;else V=(iob(A)|0)+1|0;else V=11;U=V+M|0}f[a+76>>2]=A;M=U+A|0;A=f[a+4>>2]|0;if(!(A&1)){W=M;X=a+12|0;f[X>>2]=W;return W|0}W=(dQb(A&-2)|0)+M|0;X=a+12|0;f[X>>2]=W;return W|0}function hOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+92|0;l=a+96|0;m=a+100|0;n=a+104|0;o=a+16|0;q=a+20|0;r=a+24|0;t=a+32|0;v=a+36|0;w=a+40|0;x=a+84|0;y=e+4|0;z=a+48|0;A=a+52|0;B=a+56|0;C=a+64|0;D=a+68|0;E=a+72|0;F=a+88|0;G=a+4|0;H=a+80|0;a=c+32|0;I=c+12|0;K=c+28|0;a:while(1){L=f[c>>2]|0;if(L>>>0<(f[g>>2]|0)>>>0){M=b[L>>0]|0;N=M&255;if(M<<24>>24>0){f[i>>2]=N;f[c>>2]=L+1;O=N;P=6}else{Q=N;P=5}}else{Q=0;P=5}if((P|0)==5){P=0;N=_nb(c,Q)|0;f[i>>2]=N;if((N+-1|0)>>>0<127){O=N;P=6}else{R=N;P=191}}b:do if((P|0)==6){P=0;c:do switch(O>>>3&536870911|0){case 1:{switch(O|0){case 0:{S=1;P=197;break a;break}case 8:break;default:{T=O;break b}}f[j>>2]=f[j>>2]|128;N=f[c>>2]|0;L=f[g>>2]|0;if(N>>>0<L>>>0){M=b[N>>0]|0;U=M&255;if(M<<24>>24>-1){M=N+1|0;f[c>>2]=M;V=U;W=M;X=L}else{Y=U;P=11}}else{Y=0;P=11}if((P|0)==11){P=0;U=Knb(c,Y)|0;L=J;if(!((L|0)>-1|(L|0)==-1&U>>>0>4294967295)){S=0;P=197;break a}V=U;W=f[c>>2]|0;X=f[g>>2]|0}f[k>>2]=V;if(W>>>0>=X>>>0)continue a;if((b[W>>0]|0)!=16)continue a;U=W+1|0;f[c>>2]=U;Z=U;_=X;P=18;break}case 2:{switch(O|0){case 0:{S=1;P=197;break a;break}case 16:break;default:{T=O;break b}}Z=f[c>>2]|0;_=f[g>>2]|0;P=18;break}case 3:{switch(O|0){case 0:{S=1;P=197;break a;break}case 24:break;default:{T=O;break b}}$=f[c>>2]|0;aa=f[g>>2]|0;P=28;break}case 4:{switch(O|0){case 0:{S=1;P=197;break a;break}case 32:break;default:{T=O;break b}}ba=f[c>>2]|0;ca=f[g>>2]|0;P=38;break}case 5:{switch(O|0){case 0:{S=1;P=197;break a;break}case 42:{da=f[c>>2]|0;ea=f[g>>2]|0;P=48;break c;break}case 45:{if(wFa(1,42,c,o)|0){P=70;break c}else{S=0;P=197;break a}break}default:{T=O;break b}}break}case 6:{switch(O|0){case 0:{S=1;P=197;break a;break}case 50:{fa=f[c>>2]|0;ga=f[g>>2]|0;P=75;break c;break}case 53:{if(wFa(1,50,c,t)|0){P=97;break c}else{S=0;P=197;break a}break}default:{T=O;break b}}break}case 7:{switch(O|0){case 0:{S=1;P=197;break a;break}case 58:{P=101;break}default:{T=O;break b}}break}case 8:{switch(O|0){case 0:{S=1;P=197;break a;break}case 66:{ha=f[c>>2]|0;ia=f[g>>2]|0;P=116;break c;break}case 65:{if(xFa(1,66,c,z)|0){P=138;break c}else{S=0;P=197;break a}break}default:{T=O;break b}}break}case 9:{switch(O|0){case 0:{S=1;P=197;break a;break}case 74:{ja=f[c>>2]|0;ka=f[g>>2]|0;P=143;break c;break}case 73:{if(xFa(1,74,c,C)|0){P=165;break c}else{S=0;P=197;break a}break}default:{T=O;break b}}break}case 10:{switch(O|0){case 0:{S=1;P=197;break a;break}case 80:break;default:{T=O;break b}}la=f[c>>2]|0;ma=f[g>>2]|0;P=170;break}case 12:{switch(O|0){case 0:{S=1;P=197;break a;break}case 98:break;default:{T=O;break b}}break}default:{R=O;P=191;break b}}while(0);if((P|0)==18){P=0;f[j>>2]=f[j>>2]|256;if(Z>>>0<_>>>0){U=b[Z>>0]|0;L=U&255;if(U<<24>>24>-1){U=Z+1|0;f[c>>2]=U;na=L;oa=U;pa=_}else{qa=L;P=21}}else{qa=0;P=21}if((P|0)==21){P=0;L=Knb(c,qa)|0;U=J;if(!((U|0)>-1|(U|0)==-1&L>>>0>4294967295)){S=0;P=197;break a}na=L;oa=f[c>>2]|0;pa=f[g>>2]|0}f[l>>2]=na;if(oa>>>0>=pa>>>0)continue a;if((b[oa>>0]|0)!=24)continue a;L=oa+1|0;f[c>>2]=L;$=L;aa=pa;P=28}if((P|0)==28){P=0;f[j>>2]=f[j>>2]|512;if($>>>0<aa>>>0){L=b[$>>0]|0;U=L&255;if(L<<24>>24>-1){L=$+1|0;f[c>>2]=L;ra=U;sa=L;ta=aa}else{ua=U;P=31}}else{ua=0;P=31}if((P|0)==31){P=0;U=Knb(c,ua)|0;L=J;if(!((L|0)>-1|(L|0)==-1&U>>>0>4294967295)){S=0;P=197;break a}ra=U;sa=f[c>>2]|0;ta=f[g>>2]|0}f[m>>2]=ra;if(sa>>>0>=ta>>>0)continue a;if((b[sa>>0]|0)!=32)continue a;U=sa+1|0;f[c>>2]=U;ba=U;ca=ta;P=38}if((P|0)==38){P=0;f[j>>2]=f[j>>2]|1024;if(ba>>>0<ca>>>0){U=b[ba>>0]|0;L=U&255;if(U<<24>>24>-1){U=ba+1|0;f[c>>2]=U;va=L;wa=U;xa=ca}else{ya=L;P=41}}else{ya=0;P=41}if((P|0)==41){P=0;L=Knb(c,ya)|0;U=J;if(!((U|0)>-1|(U|0)==-1&L>>>0>4294967295)){S=0;P=197;break a}va=L;wa=f[c>>2]|0;xa=f[g>>2]|0}f[n>>2]=va;if(wa>>>0>=xa>>>0)continue a;if((b[wa>>0]|0)!=42)continue a;L=wa+1|0;f[c>>2]=L;da=L;ea=xa;P=48}do if((P|0)==48){P=0;if(da>>>0<ea>>>0?(L=b[da>>0]|0,L<<24>>24>-1):0){f[c>>2]=da+1;za=L&255}else{L=Znb(c)|0;if((L|0)>-1)za=L;else{S=0;P=197;break a}}Aa=f[o>>2]|0;L=za>>>2;if((L<<2|0)!=(za|0)){S=0;P=197;break a}U=Snb(c)|0;M=Qnb(c)|0;if((((U|0)==-1|(M|0)<(U|0)?M:U)|0)>=(za|0)){U=Aa+L|0;if((f[o>>2]|0)<(U|0)?(qza(o,U),M=f[o>>2]|0,N=U-M|0,(N<<2|0)>0):0)Nac((f[r>>2]|0)+((M<<2)+4)|0,0,(((N|-1073741824|0)==-1073741824?1073741823:1073741822)+N<<2)+8|0)|0;f[o>>2]=U;U=f[r>>2]|0;if(Unb(c,((U|0)==0?0:U+4|0)+(Aa<<2)|0,za)|0){P=70;break}else{P=59;break a}}if(!L)P=70;else{U=0;while(1){N=f[c>>2]|0;if(((f[g>>2]|0)-N|0)>3){M=N;Ba=h[M>>0]|h[M+1>>0]<<8|h[M+2>>0]<<16|h[M+3>>0]<<24;f[e>>2]=Ba;f[c>>2]=N+4;Ca=Ba}else{if(!(Xnb(c,e)|0)){P=68;break a}Ca=f[e>>2]|0}Ba=f[o>>2]|0;if((Ba|0)==(f[q>>2]|0)){qza(o,Ba+1|0);Da=f[o>>2]|0}else Da=Ba;Ba=f[r>>2]|0;f[o>>2]=Da+1;f[Ba+4+(Da<<2)>>2]=Ca;U=U+1|0;if((U|0)>=(L|0)){P=70;break}}}}while(0);if((P|0)==70){P=0;L=f[c>>2]|0;U=f[g>>2]|0;if(L>>>0>=U>>>0)continue a;if((b[L>>0]|0)!=50)continue a;Ba=L+1|0;f[c>>2]=Ba;fa=Ba;ga=U;P=75}do if((P|0)==75){P=0;if(fa>>>0<ga>>>0?(U=b[fa>>0]|0,U<<24>>24>-1):0){f[c>>2]=fa+1;Ea=U&255}else{U=Znb(c)|0;if((U|0)>-1)Ea=U;else{S=0;P=197;break a}}Fa=f[t>>2]|0;U=Ea>>>2;if((U<<2|0)!=(Ea|0)){S=0;P=197;break a}Ba=Snb(c)|0;L=Qnb(c)|0;if((((Ba|0)==-1|(L|0)<(Ba|0)?L:Ba)|0)>=(Ea|0)){Ba=Fa+U|0;if((f[t>>2]|0)<(Ba|0)?(qza(t,Ba),L=f[t>>2]|0,N=Ba-L|0,(N<<2|0)>0):0)Nac((f[w>>2]|0)+((L<<2)+4)|0,0,(((N|-1073741824|0)==-1073741824?1073741823:1073741822)+N<<2)+8|0)|0;f[t>>2]=Ba;Ba=f[w>>2]|0;if(Unb(c,((Ba|0)==0?0:Ba+4|0)+(Fa<<2)|0,Ea)|0){P=97;break}else{P=86;break a}}if(!U)P=97;else{Ba=0;while(1){N=f[c>>2]|0;if(((f[g>>2]|0)-N|0)>3){L=N;M=h[L>>0]|h[L+1>>0]<<8|h[L+2>>0]<<16|h[L+3>>0]<<24;f[e>>2]=M;f[c>>2]=N+4;Ga=M}else{if(!(Xnb(c,e)|0)){P=95;break a}Ga=f[e>>2]|0}M=f[t>>2]|0;if((M|0)==(f[v>>2]|0)){qza(t,M+1|0);Ha=f[t>>2]|0}else Ha=M;M=f[w>>2]|0;f[t>>2]=Ha+1;f[M+4+(Ha<<2)>>2]=Ga;Ba=Ba+1|0;if((Ba|0)>=(U|0)){P=97;break}}}}while(0);if((P|0)==97){P=0;U=f[c>>2]|0;if(U>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[U>>0]|0)!=58)continue a;f[c>>2]=U+1;P=101}if((P|0)==101){P=0;f[j>>2]=f[j>>2]|1;U=f[x>>2]|0;if(!U){Ba=L5b(32)|0;fOa(Ba);f[x>>2]=Ba;Ia=Ba}else Ia=U;U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(Ba=b[U>>0]|0,Ba<<24>>24>-1):0){f[c>>2]=U+1;Ja=Ba&255}else{Ba=Znb(c)|0;if((Ba|0)>-1)Ja=Ba;else{S=0;P=197;break a}}Inb(e,c,Ja);if((f[y>>2]|0)<0){P=109;break a}if(!(GLa(Ia,c)|0)){P=109;break a}if(!(Onb(c,f[e>>2]|0)|0)){S=0;P=197;break a}Ba=f[c>>2]|0;U=f[g>>2]|0;if(Ba>>>0>=U>>>0)continue a;if((b[Ba>>0]|0)!=66)continue a;M=Ba+1|0;f[c>>2]=M;ha=M;ia=U;P=116}do if((P|0)==116){P=0;if(ha>>>0<ia>>>0?(U=b[ha>>0]|0,U<<24>>24>-1):0){f[c>>2]=ha+1;Ka=U&255}else{U=Znb(c)|0;if((U|0)>-1)Ka=U;else{S=0;P=197;break a}}La=f[z>>2]|0;U=Ka>>>3;if((U<<3|0)!=(Ka|0)){S=0;P=197;break a}M=Snb(c)|0;Ba=Qnb(c)|0;if((((M|0)==-1|(Ba|0)<(M|0)?Ba:M)|0)>=(Ka|0)){M=La+U|0;if((f[z>>2]|0)<(M|0)?(tFa(z,M),Ba=f[z>>2]|0,N=M-Ba|0,(N<<3|0)>0):0)Nac((f[B>>2]|0)+((Ba<<3)+8)|0,0,(((N|-536870912|0)==-536870912?536870911:536870910)+N<<3)+16|0)|0;f[z>>2]=M;M=f[B>>2]|0;if(Unb(c,((M|0)==0?0:M+8|0)+(La<<3)|0,Ka)|0){P=138;break}else{P=127;break a}}if(!U)P=138;else{M=0;while(1){N=f[c>>2]|0;if(((f[g>>2]|0)-N|0)>7){Ba=N;L=Ba;Ma=h[L>>0]|h[L+1>>0]<<8|h[L+2>>0]<<16|h[L+3>>0]<<24;L=Ba+4|0;Ba=h[L>>0]|h[L+1>>0]<<8|h[L+2>>0]<<16|h[L+3>>0]<<24;L=e;f[L>>2]=Ma;f[L+4>>2]=Ba;f[c>>2]=N+8;f[s>>2]=Ma;f[s+4>>2]=Ba;Na=+p[s>>3]}else{if(!(Ynb(c,e)|0)){P=136;break a}Na=+p[e>>3]}Ba=f[z>>2]|0;if((Ba|0)==(f[A>>2]|0)){tFa(z,Ba+1|0);Oa=f[z>>2]|0}else Oa=Ba;Ba=f[B>>2]|0;f[z>>2]=Oa+1;p[Ba+8+(Oa<<3)>>3]=Na;M=M+1|0;if((M|0)>=(U|0)){P=138;break}}}}while(0);if((P|0)==138){P=0;U=f[c>>2]|0;M=f[g>>2]|0;if(U>>>0>=M>>>0)continue a;if((b[U>>0]|0)!=74)continue a;Ba=U+1|0;f[c>>2]=Ba;ja=Ba;ka=M;P=143}do if((P|0)==143){P=0;if(ja>>>0<ka>>>0?(M=b[ja>>0]|0,M<<24>>24>-1):0){f[c>>2]=ja+1;Pa=M&255}else{M=Znb(c)|0;if((M|0)>-1)Pa=M;else{S=0;P=197;break a}}Qa=f[C>>2]|0;M=Pa>>>3;if((M<<3|0)!=(Pa|0)){S=0;P=197;break a}Ba=Snb(c)|0;U=Qnb(c)|0;if((((Ba|0)==-1|(U|0)<(Ba|0)?U:Ba)|0)>=(Pa|0)){Ba=Qa+M|0;if((f[C>>2]|0)<(Ba|0)?(tFa(C,Ba),U=f[C>>2]|0,Ma=Ba-U|0,(Ma<<3|0)>0):0)Nac((f[E>>2]|0)+((U<<3)+8)|0,0,(((Ma|-536870912|0)==-536870912?536870911:536870910)+Ma<<3)+16|0)|0;f[C>>2]=Ba;Ba=f[E>>2]|0;if(Unb(c,((Ba|0)==0?0:Ba+8|0)+(Qa<<3)|0,Pa)|0){P=165;break}else{P=154;break a}}if(!M)P=165;else{Ba=0;while(1){Ma=f[c>>2]|0;if(((f[g>>2]|0)-Ma|0)>7){U=Ma;N=U;L=h[N>>0]|h[N+1>>0]<<8|h[N+2>>0]<<16|h[N+3>>0]<<24;N=U+4|0;U=h[N>>0]|h[N+1>>0]<<8|h[N+2>>0]<<16|h[N+3>>0]<<24;N=e;f[N>>2]=L;f[N+4>>2]=U;f[c>>2]=Ma+8;f[s>>2]=L;f[s+4>>2]=U;Ra=+p[s>>3]}else{if(!(Ynb(c,e)|0)){P=163;break a}Ra=+p[e>>3]}U=f[C>>2]|0;if((U|0)==(f[D>>2]|0)){tFa(C,U+1|0);Sa=f[C>>2]|0}else Sa=U;U=f[E>>2]|0;f[C>>2]=Sa+1;p[U+8+(Sa<<3)>>3]=Ra;Ba=Ba+1|0;if((Ba|0)>=(M|0)){P=165;break}}}}while(0);if((P|0)==165){P=0;M=f[c>>2]|0;Ba=f[g>>2]|0;if(M>>>0>=Ba>>>0)continue a;if((b[M>>0]|0)!=80)continue a;U=M+1|0;f[c>>2]=U;la=U;ma=Ba;P=170}if((P|0)==170){P=0;if(la>>>0<ma>>>0){Ba=b[la>>0]|0;U=Ba&255;if(Ba<<24>>24>-1){f[c>>2]=la+1;Ta=U}else{Ua=U;P=173}}else{Ua=0;P=173}if((P|0)==173){P=0;U=Knb(c,Ua)|0;Ba=J;if((Ba|0)>-1|(Ba|0)==-1&U>>>0>4294967295)Ta=U;else{S=0;P=197;break a}}if(Ta>>>0<5){f[j>>2]=f[j>>2]|32;f[F>>2]=Ta}else{U=f[G>>2]|0;if(!(U&1))Va=hBa(G)|0;else Va=U&-2;NPb(Va,10,Ta,((Ta|0)<0)<<31>>31)}U=f[c>>2]|0;if(U>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[U>>0]|0)!=98)continue a;f[c>>2]=U+1}f[j>>2]=f[j>>2]|64;U=f[H>>2]|0;if((U|0)==497760){jza(H,497760);Wa=f[H>>2]|0}else Wa=U;if(!(fqb(c,Wa)|0)){S=0;P=197;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[a>>2]|0){P=190;break a}if((f[I>>2]|0)==(f[K>>2]|0)){P=190;break a}else continue a}while(0);if((P|0)==191){P=0;if(!R){S=1;P=197;break}else T=R}if((T&7|0)==4){S=1;P=197;break}U=f[G>>2]|0;if(!(U&1))Xa=hBa(G)|0;else Xa=U&-2;if(!(ZPb(c,T,Xa)|0)){S=0;P=197;break}}switch(P|0){case 59:{if((f[o>>2]|0)<=0){S=0;u=d;return S|0}f[o>>2]=Aa;S=0;u=d;return S|0}case 68:{S=0;u=d;return S|0}case 86:{if((f[t>>2]|0)<=0){S=0;u=d;return S|0}f[t>>2]=Fa;S=0;u=d;return S|0}case 95:{S=0;u=d;return S|0}case 109:{S=0;u=d;return S|0}case 127:{if((f[z>>2]|0)<=0){S=0;u=d;return S|0}f[z>>2]=La;S=0;u=d;return S|0}case 136:{S=0;u=d;return S|0}case 154:{if((f[C>>2]|0)<=0){S=0;u=d;return S|0}f[C>>2]=Qa;S=0;u=d;return S|0}case 163:{S=0;u=d;return S|0}case 190:{f[i>>2]=0;b[c+24>>0]=1;S=1;u=d;return S|0}case 197:{u=d;return S|0}}return 0}function iOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+16|0;i=c+32|0;j=c+12|0;k=c+28|0;l=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[e>>2]=n;f[c>>2]=a+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=_nb(c,q)|0;f[e>>2]=n;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}if((p|0)==6){p=0;if((o|0)==10){f[g>>2]=f[g>>2]|1;n=f[h>>2]|0;if((n|0)==497760){jza(h,497760);s=f[h>>2]|0}else s=n;if(!(fqb(c,s)|0)){t=0;p=19;break}if((f[c>>2]|0)!=(f[d>>2]|0))continue;if(f[i>>2]|0){p=13;break}if((f[j>>2]|0)==(f[k>>2]|0)){p=13;break}else continue}else r=o}if((r|0)==0|(r&7|0)==4){t=1;p=19;break}n=f[l>>2]|0;if(!(n&1))u=hBa(l)|0;else u=n&-2;if(!(ZPb(c,r,u)|0)){t=0;p=19;break}}if((p|0)==13){f[e>>2]=0;b[c+24>>0]=1;t=1;return t|0}else if((p|0)==19)return t|0;return 0}function jOa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=118260;e=(a|0)==497e3;g=a+4|0;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+56>>2]=497760;f[a+60>>2]=497760;f[a+64>>2]=497760;f[a+68>>2]=497760;f[a+72>>2]=f[213032];d=a+140|0;g=a+76|0;h=g+64|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[d>>2]=1;b[a+144>>0]=1;f[a+148>>2]=1;f[a+152>>2]=1;n[a+156>>2]=.5;f[a+160>>2]=5;n[a+164>>2]=1.0;n[a+168>>2]=.75;n[a+172>>2]=1.0;n[a+176>>2]=1.0;n[a+180>>2]=.5;n[a+184>>2]=.5;n[a+188>>2]=.25;f[a+192>>2]=0;u=c;return}function kOa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function lOa(a){a=a|0;var c=0,d=0;c=a+56|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+60|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+64|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+68|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+72|0;d=f[c>>2]|0;if(!((d|0)==(f[213032]|0)|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)==497e3)return;c=f[a+76>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+80>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+84>>2]|0;if(!c)return;bi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function mOa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f[a>>2]=118152;EQa(a);c=f[a+156>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=f[a+144>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=f[a+132>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=f[a+120>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=a+108|0;d=f[c>>2]|0;if(d|0?(f[a+96>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);O5b(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=a+92|0;i=f[c>>2]|0;if(i|0?(f[a+80>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;O5b(j)}f[c>>2]=0;c=a+76|0;j=f[c>>2]|0;if(j|0?(f[a+64>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;O5b(k)}f[c>>2]=0;c=a+60|0;k=f[c>>2]|0;if(k|0?(f[a+48>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)bi[f[(f[d>>2]|0)+4>>2]&2047](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;O5b(l)}f[c>>2]=0;c=a+44|0;l=f[c>>2]|0;if(l|0?(f[a+32>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0){if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);O5b(i)}j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;O5b(m)}f[c>>2]=0;c=a+28|0;m=f[c>>2]|0;if(m|0?(f[a+16>>2]|0)==0:0){l=f[m>>2]|0;if((l|0)>0){k=0;do{j=f[m+4+(k<<2)>>2]|0;if(j|0){if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);O5b(j)}k=k+1|0}while((k|0)!=(l|0));n=f[c>>2]|0}else n=m;O5b(n)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}n=a&-2;a=n;if((n|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(n);f[c>>2]=0;return}function nOa(a){a=a|0;mOa(a);O5b(a);return}function oOa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function pOa(a,b){a=a|0;b=b|0;a=L5b(296)|0;CQa(a);if(!b)return a|0;DQa(b,a);return a|0}
function qOa(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;c=a+8|0;e=f[c>>2]|0;if(!(e&36))g=e;else{do if(e&4|0?(h=f[a+160>>2]|0,(h|0)!=497760):0){i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[i>>0]=0;break}}while(0);f[a+288>>2]=0;g=f[c>>2]|0}if(g&61440|0){e=a+8|0;if(g&4096|0?(g=f[a+164>>2]|0,g|0):0){i=g+8|0;if(f[i>>2]&7|0){f[g+20>>2]=1;f[g+24>>2]=1;f[g+16>>2]=0}f[i>>2]=0;i=f[g+4>>2]|0;if(i&1|0?(g=i&-2,f[g>>2]|0):0)GPb(g)}if(f[e>>2]&8192|0?(g=f[a+168>>2]|0,g|0):0){i=g+8|0;if(f[i>>2]&7|0){h=g+16|0;f[h>>2]=0;f[h+4>>2]=0;f[g+24>>2]=1}f[i>>2]=0;i=f[g+4>>2]|0;if(i&1|0?(g=i&-2,f[g>>2]|0):0)GPb(g)}if(f[e>>2]&16384|0?(g=f[a+172>>2]|0,g|0):0){i=g+8|0;if(f[i>>2]&3|0){f[g+16>>2]=1;f[g+20>>2]=1}f[i>>2]=0;i=f[g+4>>2]|0;if(i&1|0?(g=i&-2,f[g>>2]|0):0)GPb(g)}if(f[e>>2]&32768|0?(e=f[a+176>>2]|0,e|0):0){g=e+8|0;if(f[g>>2]&3|0){n[e+20>>2]=1.0;b[e+16>>0]=0}f[g>>2]=0;g=f[e+4>>2]|0;if(g&1|0?(e=g&-2,f[e>>2]|0):0)GPb(e)}}e=f[c>>2]|0;if(!(e&16711680))j=e;else{g=a+8|0;if((e&65536|0)!=0?(i=f[a+180>>2]|0,(i|0)!=0):0){xQa(i);k=f[g>>2]|0}else k=e;if((k&131072|0)!=0?(e=f[a+184>>2]|0,(e|0)!=0):0){yQa(e);l=f[g>>2]|0}else l=k;if(l&262144|0?(l=f[a+188>>2]|0,l|0):0){k=l+8|0;if(f[k>>2]&3|0){n[l+16>>2]=.5;b[l+20>>0]=1}f[k>>2]=0;k=f[l+4>>2]|0;if(k&1|0?(l=k&-2,f[l>>2]|0):0)GPb(l)}if(f[g>>2]&524288|0?(l=f[a+192>>2]|0,l|0):0){k=l+20|0;e=f[k>>2]|0;if((e|0)>0){i=f[l+28>>2]|0;h=0;do{m=f[i+4+(h<<2)>>2]|0;h=h+1|0;bi[f[(f[m>>2]|0)+28>>2]&2047](m)}while((h|0)!=(e|0));f[k>>2]=0}k=l+36|0;e=f[k>>2]|0;if((e|0)>0){h=f[l+44>>2]|0;i=0;do{m=f[h+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[m>>2]|0)+28>>2]&2047](m)}while((i|0)!=(e|0));f[k>>2]=0}f[l+48>>2]=0;f[l+60>>2]=0;f[l+72>>2]=0;f[l+84>>2]=0;f[l+8>>2]=0;k=f[l+4>>2]|0;if(k&1|0?(l=k&-2,f[l>>2]|0):0)GPb(l)}if(f[g>>2]&1048576|0?(l=f[a+196>>2]|0,l|0):0){k=l+8|0;if(f[k>>2]&5|0){f[l+28>>2]=1;b[l+32>>0]=1}f[l+16>>2]=0;f[k>>2]=0;k=f[l+4>>2]|0;if(k&1|0?(l=k&-2,f[l>>2]|0):0)GPb(l)}if(f[g>>2]&2097152|0?(l=f[a+200>>2]|0,l|0):0){k=l+8|0;if(f[k>>2]&7|0){n[l+20>>2]=-1.0;n[l+24>>2]=1.0;n[l+16>>2]=0.0}f[k>>2]=0;k=f[l+4>>2]|0;if(k&1|0?(l=k&-2,f[l>>2]|0):0)GPb(l)}if(f[g>>2]&4194304|0?(l=f[a+204>>2]|0,l|0):0){k=l+8|0;e=f[k>>2]|0;do if((e&7|0?(i=l+20|0,f[i>>2]=0,b[i+4>>0]=0,e&1|0):0)?(i=f[l+16>>2]|0,(i|0)!=497760):0){h=i+11|0;if((b[h>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0;break}else{b[i>>0]=0;b[h>>0]=0;break}}while(0);f[k>>2]=0;k=f[l+4>>2]|0;if(k&1|0?(l=k&-2,f[l>>2]|0):0)GPb(l)}if(f[g>>2]&8388608|0?(g=f[a+208>>2]|0,g|0):0){l=g+8|0;do if(f[l>>2]&1|0?(k=f[g+16>>2]|0,(k|0)!=497760):0){e=k+11|0;if((b[e>>0]|0)<0){b[f[k>>2]>>0]=0;f[k+4>>2]=0;break}else{b[k>>0]=0;b[e>>0]=0;break}}while(0);f[l>>2]=0;l=f[g+4>>2]|0;if(l&1|0?(g=l&-2,f[g>>2]|0):0)GPb(g)}j=f[c>>2]|0}if(j>>>0>16777215){g=a+8|0;if(((j&16777216|0?(j=f[a+212>>2]|0,j|0):0)?(f[j+16>>2]=1,f[j+8>>2]=0,l=f[j+4>>2]|0,l&1|0):0)?(j=l&-2,f[j>>2]|0):0)GPb(j);j=f[g>>2]|0;if((j&33554432|0)!=0?(l=f[a+216>>2]|0,(l|0)!=0):0){zQa(l);o=f[g>>2]|0}else o=j;if(o&67108864|0?(o=f[a+220>>2]|0,o|0):0){j=o+8|0;do if(f[j>>2]&1|0?(l=f[o+16>>2]|0,(l|0)!=497760):0){e=l+11|0;if((b[e>>0]|0)<0){b[f[l>>2]>>0]=0;f[l+4>>2]=0;break}else{b[l>>0]=0;b[e>>0]=0;break}}while(0);f[j>>2]=0;j=f[o+4>>2]|0;if(j&1|0?(o=j&-2,f[o>>2]|0):0)GPb(o)}o=f[g>>2]|0;if((o&134217728|0)!=0?(j=f[a+224>>2]|0,(j|0)!=0):0){AQa(j);p=f[g>>2]|0}else p=o;if(p&268435456|0?(p=f[a+228>>2]|0,p|0):0){o=p+8|0;if(f[o>>2]&63|0){j=p+16|0;f[j>>2]=0;f[j+4>>2]=0;f[p+24>>2]=5;n[p+28>>2]=1.0;n[p+32>>2]=.75;n[p+36>>2]=1.0}f[o>>2]=0;o=f[p+4>>2]|0;if(o&1|0?(p=o&-2,f[p>>2]|0):0)GPb(p)}if(((f[g>>2]&536870912|0?(p=f[a+232>>2]|0,p|0):0)?(o=p+16|0,f[o>>2]=0,f[o+4>>2]=0,f[o+8>>2]=0,f[o+12>>2]=0,f[p+8>>2]=0,o=f[p+4>>2]|0,o&1|0):0)?(p=o&-2,f[p>>2]|0):0)GPb(p);p=f[g>>2]|0;if(!(p&1073741824))q=p;else{p=f[a+236>>2]|0;if(p|0){o=p+8|0;if(f[o>>2]&7|0){b[p+17>>0]=1;b[p+16>>0]=0;n[p+20>>2]=9.999999717180685e-10}f[o>>2]=0;o=f[p+4>>2]|0;if(o&1|0?(p=o&-2,f[p>>2]|0):0)GPb(p)}q=f[g>>2]|0}if((q|0)<0?(q=f[a+240>>2]|0,q|0):0){g=q+8|0;p=f[g>>2]|0;if(p&255|0){o=q+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;f[q+60>>2]=1}if(p&7936|0){p=q+44|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;b[p+12>>0]=0;b[q+64>>0]=1}f[g>>2]=0;g=f[q+4>>2]|0;if(g&1|0?(q=g&-2,f[q>>2]|0):0)GPb(q)}}q=a+12|0;g=f[q>>2]|0;if(g&255){if(g&1|0?(p=f[a+244>>2]|0,p|0):0){o=p+8|0;if(f[o>>2]&7|0){n[p+20>>2]=1.0;n[p+24>>2]=1.0;n[p+16>>2]=0.0}f[o>>2]=0;o=f[p+4>>2]|0;if(o&1|0?(p=o&-2,f[p>>2]|0):0)GPb(p)}if(((f[q>>2]&2|0?(p=f[a+248>>2]|0,p|0):0)?(o=p+16|0,f[o>>2]=0,f[o+4>>2]=0,f[p+8>>2]=0,o=f[p+4>>2]|0,o&1|0):0)?(p=o&-2,f[p>>2]|0):0)GPb(p);if(((f[q>>2]&4|0?(p=f[a+252>>2]|0,p|0):0)?(f[p+16>>2]=0,f[p+8>>2]=0,o=f[p+4>>2]|0,o&1|0):0)?(p=o&-2,f[p>>2]|0):0)GPb(p);if(f[q>>2]&8|0?(p=f[a+256>>2]|0,p|0):0){o=p+8|0;if(f[o>>2]&3|0){f[p+16>>2]=0;f[p+20>>2]=1}f[o>>2]=0;o=f[p+4>>2]|0;if(o&1|0?(p=o&-2,f[p>>2]|0):0)GPb(p)}if(f[q>>2]&16|0?(p=f[a+260>>2]|0,p|0):0){o=p+8|0;if(f[o>>2]&5|0){f[p+28>>2]=1;f[p+32>>2]=1}f[p+16>>2]=0;f[o>>2]=0;o=f[p+4>>2]|0;if(o&1|0?(p=o&-2,f[p>>2]|0):0)GPb(p)}if(((f[q>>2]&32|0?(p=f[a+264>>2]|0,p|0):0)?(f[p+16>>2]=0,f[p+8>>2]=0,o=f[p+4>>2]|0,o&1|0):0)?(p=o&-2,f[p>>2]|0):0)GPb(p);if(((f[q>>2]&64|0?(p=f[a+268>>2]|0,p|0):0)?(n[p+16>>2]=0.0,f[p+8>>2]=0,o=f[p+4>>2]|0,o&1|0):0)?(p=o&-2,f[p>>2]|0):0)GPb(p);p=f[q>>2]|0;if((p&128|0)!=0?(o=f[a+272>>2]|0,(o|0)!=0):0){BQa(o);r=f[q>>2]|0}else r=p}else r=g;if(r&1792|0){if(r&256|0?(r=f[a+276>>2]|0,r|0):0){g=r+8|0;p=f[g>>2]|0;do if((p&111|0?(o=r+32|0,f[o>>2]=0,d[o+4>>1]=0,b[o+6>>0]=0,n[r+40>>2]=1.0,p&8|0):0)?(o=f[r+28>>2]|0,(o|0)!=497760):0){j=o+11|0;if((b[j>>0]|0)<0){b[f[o>>2]>>0]=0;f[o+4>>2]=0;break}else{b[o>>0]=0;b[j>>0]=0;break}}while(0);f[r+16>>2]=0;f[g>>2]=0;g=f[r+4>>2]|0;if(g&1|0?(r=g&-2,f[r>>2]|0):0)GPb(r)}if(f[q>>2]&512|0?(r=f[a+280>>2]|0,r|0):0){g=r+8|0;if(f[g>>2]&7|0){p=r+16|0;f[p>>2]=0;b[p+4>>0]=0;f[r+24>>2]=1}f[g>>2]=0;g=f[r+4>>2]|0;if(g&1|0?(r=g&-2,f[r>>2]|0):0)GPb(r)}if(f[q>>2]&1024|0?(q=f[a+284>>2]|0,q|0):0)QNa(q)}q=a+20|0;r=f[q>>2]|0;if((r|0)>0){g=f[a+28>>2]|0;p=0;do{j=f[g+4+(p<<2)>>2]|0;p=p+1|0;o=j+11|0;if((b[o>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0}else{b[j>>0]=0;b[o>>0]=0}}while((p|0)!=(r|0));f[q>>2]=0}q=a+36|0;r=f[q>>2]|0;if((r|0)>0){p=f[a+44>>2]|0;g=0;do{o=f[p+4+(g<<2)>>2]|0;g=g+1|0;j=o+11|0;if((b[j>>0]|0)<0){b[f[o>>2]>>0]=0;f[o+4>>2]=0}else{b[o>>0]=0;b[j>>0]=0}}while((g|0)!=(r|0));f[q>>2]=0}q=a+52|0;r=f[q>>2]|0;if((r|0)>0){g=f[a+60>>2]|0;p=0;do{j=f[g+4+(p<<2)>>2]|0;p=p+1|0;bi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((p|0)!=(r|0));f[q>>2]=0}q=a+68|0;r=f[q>>2]|0;if((r|0)>0){p=f[a+76>>2]|0;g=0;do{j=f[p+4+(g<<2)>>2]|0;g=g+1|0;bi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((g|0)!=(r|0));f[q>>2]=0}q=a+84|0;r=f[q>>2]|0;if((r|0)>0){g=f[a+92>>2]|0;p=0;do{j=f[g+4+(p<<2)>>2]|0;p=p+1|0;bi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((p|0)!=(r|0));f[q>>2]=0}q=a+100|0;r=f[q>>2]|0;if((r|0)>0){p=f[a+108>>2]|0;g=0;do{j=f[p+4+(g<<2)>>2]|0;g=g+1|0;o=j+11|0;if((b[o>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0}else{b[j>>0]=0;b[o>>0]=0}}while((g|0)!=(r|0));f[q>>2]=0}f[a+112>>2]=0;f[a+124>>2]=0;f[a+136>>2]=0;f[a+148>>2]=0;q=c;f[q>>2]=0;f[q+4>>2]=0;q=f[a+4>>2]|0;if(!(q&1))return;a=q&-2;if(!(f[a>>2]|0))return;GPb(a);return}function rOa(a){a=a|0;return 1}function sOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+12|0;k=a+284|0;l=e+4|0;m=a+16|0;n=a+32|0;o=a+8|0;p=a+160|0;q=a+288|0;r=a+4|0;s=c+44|0;t=a+80|0;v=a+92|0;w=a+88|0;x=a+84|0;y=a+124|0;z=a+128|0;A=a+132|0;B=a+136|0;C=a+140|0;D=a+144|0;E=a+172|0;F=e+4|0;G=a+180|0;H=e+4|0;I=a+184|0;K=e+4|0;L=a+188|0;M=e+4|0;N=a+204|0;O=e+4|0;P=a+208|0;Q=e+4|0;R=a+216|0;S=e+4|0;T=a+220|0;U=e+4|0;V=a+224|0;W=e+4|0;X=a+228|0;Y=e+4|0;Z=a+240|0;_=e+4|0;$=a+272|0;aa=e+4|0;ba=a+244|0;ca=e+4|0;da=a+232|0;ea=e+4|0;fa=a+168|0;ga=e+4|0;ha=a+196|0;ia=e+4|0;ja=a+268|0;ka=e+4|0;la=a+192|0;ma=e+4|0;na=a+164|0;oa=e+4|0;pa=a+212|0;qa=e+4|0;ra=a+248|0;sa=e+4|0;ta=a+260|0;ua=e+4|0;va=a+48|0;wa=a+60|0;xa=a+56|0;ya=a+52|0;za=a+64|0;Aa=a+76|0;Ba=a+72|0;Ca=a+68|0;Da=a+236|0;Ea=e+4|0;Fa=a+148|0;Ga=a+152|0;Ha=a+156|0;Ia=a+276|0;Ja=e+4|0;Ka=a+264|0;La=e+4|0;Ma=a+252|0;Na=e+4|0;Oa=a+256|0;Pa=e+4|0;Qa=a+176|0;Ra=e+4|0;Sa=a+200|0;Ta=e+4|0;Ua=a+280|0;Va=e+4|0;Wa=a+96|0;Xa=a+112|0;Ya=a+116|0;Za=a+120|0;a=c+32|0;_a=c+12|0;$a=c+28|0;a:while(1){ab=f[c>>2]|0;bb=f[g>>2]|0;do if(ab>>>0<bb>>>0){cb=b[ab>>0]|0;db=cb&255;if(cb<<24>>24>0){eb=db;fb=1}else{cb=ab+1|0;if(cb>>>0>=bb>>>0){gb=db;hb=7;break}ib=h[cb>>0]|0;if(((ib^128)&db)>>>0<=127){gb=db;hb=7;break}eb=db+-128+(ib<<7)|0;fb=2}f[i>>2]=eb;f[c>>2]=ab+fb;jb=eb;hb=9}else{gb=0;hb=7}while(0);if((hb|0)==7){hb=0;ab=_nb(c,gb)|0;f[i>>2]=ab;if((ab+-1|0)>>>0<16383){jb=ab;hb=9}else{kb=ab;hb=658}}b:do if((hb|0)==9){hb=0;c:do switch(jb>>>3&536870911|0){case 1:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 10:break;default:{mb=jb;break b}}f[j>>2]=f[j>>2]|1024;ab=f[k>>2]|0;if(!ab){bb=L5b(196)|0;jOa(bb);f[k>>2]=bb;nb=bb}else nb=ab;ab=f[c>>2]|0;if(ab>>>0<(f[g>>2]|0)>>>0?(bb=b[ab>>0]|0,bb<<24>>24>-1):0){f[c>>2]=ab+1;ob=bb&255}else{bb=Znb(c)|0;if((bb|0)>-1)ob=bb;else{lb=0;hb=664;break a}}Inb(e,c,ob);if((f[l>>2]|0)<0){hb=19;break a}if(!(SNa(nb,c)|0)){hb=19;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}bb=f[c>>2]|0;if(bb>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[bb>>0]|0)==18){pb=bb;hb=24}else continue a;break}case 2:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 18:{hb=25;break}default:{mb=jb;break b}}break}case 3:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 26:{hb=31;break}default:{mb=jb;break b}}break}case 4:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 34:{hb=37;break}default:{mb=jb;break b}}break}case 5:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 40:break;default:{mb=jb;break b}}qb=f[c>>2]|0;rb=f[g>>2]|0;hb=45;break}case 6:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 50:{hb=59;break}default:{mb=jb;break b}}break}case 7:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 61:{sb=f[c>>2]|0;tb=f[g>>2]|0;hb=77;break c;break}case 58:{if(DMa(c,y)|0){hb=92;break c}else{lb=0;hb=664;break a}break}default:{mb=jb;break b}}break}case 8:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 69:{ub=f[c>>2]|0;vb=f[g>>2]|0;hb=98;break c;break}case 66:{if(DMa(c,B)|0){hb=113;break c}else{lb=0;hb=664;break a}break}default:{mb=jb;break b}}break}case 9:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 74:{hb=118;break}default:{mb=jb;break b}}break}case 10:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 82:{hb=132;break}default:{mb=jb;break b}}break}case 11:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 90:{hb=146;break}default:{mb=jb;break b}}break}case 12:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 98:{hb=160;break}default:{mb=jb;break b}}break}case 13:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 106:{hb=174;break}default:{mb=jb;break b}}break}case 14:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 114:{hb=188;break}default:{mb=jb;break b}}break}case 15:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 122:{hb=202;break}default:{mb=jb;break b}}break}case 16:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 130:{hb=217;break}default:{mb=jb;break b}}break}case 17:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 138:{hb=232;break}default:{mb=jb;break b}}break}case 18:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 146:{hb=247;break}default:{mb=jb;break b}}break}case 19:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 154:{hb=262;break}default:{mb=jb;break b}}break}case 20:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 162:{hb=277;break}default:{mb=jb;break b}}break}case 21:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 170:{hb=292;break}default:{mb=jb;break b}}break}case 22:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 178:{hb=307;break}default:{mb=jb;break b}}break}case 23:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 186:{hb=322;break}default:{mb=jb;break b}}break}case 24:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 194:{hb=337;break}default:{mb=jb;break b}}break}case 25:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 202:{hb=352;break}default:{mb=jb;break b}}break}case 26:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 210:{hb=367;break}default:{mb=jb;break b}}break}case 27:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 218:{hb=382;break}default:{mb=jb;break b}}break}case 29:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 234:{hb=397;break}default:{mb=jb;break b}}break}case 30:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 242:{hb=412;break}default:{mb=jb;break b}}break}case 31:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 250:{hb=427;break}default:{mb=jb;break b}}break}case 32:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 258:{hb=442;break}default:{mb=jb;break b}}break}case 33:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 266:break;default:{mb=jb;break b}}bb=f[s>>2]|0;f[s>>2]=bb+-1;if((bb|0)>0)hb=463;else{lb=0;hb=664;break a}break}case 34:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 274:{hb=480;break}default:{mb=jb;break b}}break}case 35:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 285:{wb=f[c>>2]|0;xb=f[g>>2]|0;hb=496;break c;break}case 282:{if(DMa(c,Fa)|0){hb=512;break c}else{lb=0;hb=664;break a}break}default:{mb=jb;break b}}break}case 36:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 290:{hb=520;break}default:{mb=jb;break b}}break}case 37:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 298:{hb=535;break}default:{mb=jb;break b}}break}case 38:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 306:{hb=550;break}default:{mb=jb;break b}}break}case 39:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 314:{hb=565;break}default:{mb=jb;break b}}break}case 40:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 322:{hb=580;break}default:{mb=jb;break b}}break}case 41:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 330:{hb=595;break}default:{mb=jb;break b}}break}case 42:{switch(jb|0){case 0:{lb=1;hb=664;break a;break}case 338:{hb=610;break}default:{mb=jb;break b}}break}case 1001:{if((jb|0)<8010)switch(jb|0){case 0:{lb=1;hb=664;break a;break}default:{mb=jb;break b}}else switch(jb|0){case 8010:{hb=625;break c;break}default:{mb=jb;break b}}break}case 1002:{if((jb|0)<8016)switch(jb|0){case 0:{lb=1;hb=664;break a;break}default:{mb=jb;break b}}switch(jb|0){case 8016:{yb=f[c>>2]|0;zb=f[g>>2]|0;hb=635;break c;break}case 8018:break;default:{mb=jb;break b}}bb=f[r>>2]|0;if(!(bb&1))Ab=hBa(r)|0;else Ab=bb&-2;if($Pb(c,1002,719,Ab,Xa)|0)hb=651;else{lb=0;hb=664;break a}break}default:{kb=jb;hb=658;break b}}while(0);d:while(1){switch(hb|0){case 24:{hb=0;f[c>>2]=pb+1;hb=25;continue d;break}case 25:{hb=0;if(!(fqb(c,mza(m)|0)|0)){lb=0;hb=664;break a}bb=f[c>>2]|0;if(bb>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[bb>>0]|0)==18){pb=bb;hb=24;continue d}if((b[bb>>0]|0)==26){Bb=bb;hb=30}else continue a;break}case 31:{hb=0;if(!(fqb(c,mza(n)|0)|0)){lb=0;hb=664;break a}bb=f[c>>2]|0;if(bb>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[bb>>0]|0)==26){Bb=bb;hb=30}else{if((b[bb>>0]|0)!=34)continue a;f[c>>2]=bb+1;hb=37;continue d}break}case 37:{hb=0;f[o>>2]=f[o>>2]|4;bb=f[p>>2]|0;if((bb|0)==497760){jza(p,497760);Cb=f[p>>2]|0}else Cb=bb;if(!(fqb(c,Cb)|0)){lb=0;hb=664;break a}bb=f[c>>2]|0;ab=f[g>>2]|0;if(bb>>>0>=ab>>>0)continue a;if((b[bb>>0]|0)!=40)continue a;ib=bb+1|0;f[c>>2]=ib;qb=ib;rb=ab;hb=45;continue d;break}case 45:{hb=0;if(qb>>>0<rb>>>0){ab=b[qb>>0]|0;ib=ab&255;if(ab<<24>>24>-1){f[c>>2]=qb+1;Db=ib}else{Eb=ib;hb=48}}else{Eb=0;hb=48}if((hb|0)==48){hb=0;ib=Knb(c,Eb)|0;ab=J;if((ab|0)>-1|(ab|0)==-1&ib>>>0>4294967295)Db=ib;else{lb=0;hb=664;break a}}if(Db>>>0<40){f[o>>2]=f[o>>2]|32;f[q>>2]=Db}else{ib=f[r>>2]|0;if(!(ib&1))Fb=hBa(r)|0;else Fb=ib&-2;NPb(Fb,5,Db,((Db|0)<0)<<31>>31)}ib=f[c>>2]|0;if(ib>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[ib>>0]|0)!=50)continue a;f[c>>2]=ib+1;hb=59;continue d;break}case 59:{hb=0;ib=f[s>>2]|0;f[s>>2]=ib+-1;if((ib|0)<=0){lb=0;hb=664;break a}while(1){ib=f[v>>2]|0;do if(ib){ab=f[x>>2]|0;bb=f[ib>>2]|0;if((ab|0)>=(bb|0))if((bb|0)==(f[w>>2]|0)){Gb=bb;hb=65;break}else{Hb=bb;Ib=ib;hb=66;break}else{f[x>>2]=ab+1;Jb=f[ib+4+(ab<<2)>>2]|0;break}}else{Gb=f[w>>2]|0;hb=65}while(0);if((hb|0)==65){hb=0;cpb(t,Gb+1|0);ib=f[v>>2]|0;Hb=f[ib>>2]|0;Ib=ib;hb=66}if((hb|0)==66){hb=0;f[Ib>>2]=Hb+1;ib=pza(0,f[t>>2]|0)|0;ab=f[v>>2]|0;bb=f[x>>2]|0;f[x>>2]=bb+1;f[ab+4+(bb<<2)>>2]=ib;Jb=ib}ib=Jnb(c)|0;if(!(hOa(Jb,c)|0)){lb=0;hb=664;break a}if(!(Pnb(c,ib)|0)){lb=0;hb=664;break a}Kb=f[c>>2]|0;Lb=f[g>>2]|0;if(Kb>>>0>=Lb>>>0){hb=70;break d}if((b[Kb>>0]|0)!=50)break;f[c>>2]=Kb+1}f[s>>2]=(f[s>>2]|0)+1;if((b[Kb>>0]|0)==61){Mb=Kb;Nb=Lb;hb=76}else continue a;break}case 77:{hb=0;if((tb-sb|0)>3){ib=sb;bb=h[ib>>0]|h[ib+1>>0]<<8|h[ib+2>>0]<<16|h[ib+3>>0]<<24;f[e>>2]=bb;f[c>>2]=sb+4;Ob=bb}else{if(!(Xnb(c,e)|0)){hb=90;break a}Ob=f[e>>2]|0}bb=f[y>>2]|0;if((bb|0)==(f[z>>2]|0)){qza(y,bb+1|0);Pb=f[y>>2]|0}else Pb=bb;bb=f[A>>2]|0;ib=Pb+1|0;f[y>>2]=ib;f[bb+4+(Pb<<2)>>2]=Ob;ab=f[c>>2]|0;db=(f[g>>2]|0)-ab|0;if((db|0)<=0){hb=92;continue d}cb=(f[z>>2]|0)-ib|0;Qb=(db>>>0)/5|0;db=(Qb|0)<(cb|0)?Qb:cb;if((db|0)<=0){hb=92;continue d}cb=0;Qb=ab;ab=ib;while(1){if((b[Qb>>0]|0)!=61){Rb=cb;break}ib=Qb+1|0;Sb=h[ib>>0]|h[ib+1>>0]<<8|h[ib+2>>0]<<16|h[ib+3>>0]<<24;ib=ab;ab=ab+1|0;f[y>>2]=ab;f[bb+4+(ib<<2)>>2]=Sb;Sb=cb+1|0;if((Sb|0)>=(db|0)){Rb=Sb;break}else{cb=Sb;Qb=Qb+5|0}}if((Rb|0)<=0){hb=92;continue d}Tnb(c,Rb*5|0)|0;hb=92;continue d;break}case 92:{hb=0;Qb=f[c>>2]|0;cb=f[g>>2]|0;db=cb;if(Qb>>>0>=cb>>>0)continue a;if((b[Qb>>0]|0)!=61)if((b[Qb>>0]|0)==69){Tb=Qb;Ub=db;hb=97}else continue a;else{Mb=Qb;Nb=db;hb=76}break}case 98:{hb=0;if((vb-ub|0)>3){db=ub;Qb=h[db>>0]|h[db+1>>0]<<8|h[db+2>>0]<<16|h[db+3>>0]<<24;f[e>>2]=Qb;f[c>>2]=ub+4;Vb=Qb}else{if(!(Xnb(c,e)|0)){hb=111;break a}Vb=f[e>>2]|0}Qb=f[B>>2]|0;if((Qb|0)==(f[C>>2]|0)){qza(B,Qb+1|0);Wb=f[B>>2]|0}else Wb=Qb;Qb=f[D>>2]|0;db=Wb+1|0;f[B>>2]=db;f[Qb+4+(Wb<<2)>>2]=Vb;cb=f[c>>2]|0;bb=(f[g>>2]|0)-cb|0;if((bb|0)<=0){hb=113;continue d}ab=(f[C>>2]|0)-db|0;Sb=(bb>>>0)/5|0;bb=(Sb|0)<(ab|0)?Sb:ab;if((bb|0)<=0){hb=113;continue d}ab=0;Sb=cb;cb=db;while(1){if((b[Sb>>0]|0)!=69){Xb=ab;break}db=Sb+1|0;ib=h[db>>0]|h[db+1>>0]<<8|h[db+2>>0]<<16|h[db+3>>0]<<24;db=cb;cb=cb+1|0;f[B>>2]=cb;f[Qb+4+(db<<2)>>2]=ib;ib=ab+1|0;if((ib|0)>=(bb|0)){Xb=ib;break}else{ab=ib;Sb=Sb+5|0}}if((Xb|0)<=0){hb=113;continue d}Tnb(c,Xb*5|0)|0;hb=113;continue d;break}case 113:{hb=0;Sb=f[c>>2]|0;ab=f[g>>2]|0;if(Sb>>>0>=ab>>>0)continue a;if((b[Sb>>0]|0)==69){Tb=Sb;Ub=ab;hb=97}else{if((b[Sb>>0]|0)!=74)continue a;f[c>>2]=Sb+1;hb=118;continue d}break}case 118:{hb=0;f[o>>2]=f[o>>2]|16384;Sb=f[E>>2]|0;if(!Sb){ab=L5b(24)|0;GOa(ab);f[E>>2]=ab;Yb=ab}else Yb=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;Zb=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)Zb=ab;else{lb=0;hb=664;break a}}Inb(e,c,Zb);if((f[F>>2]|0)<0){hb=126;break a}if(!(TPa(Yb,c)|0)){hb=126;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;if(ab>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[ab>>0]|0)!=82)continue a;f[c>>2]=ab+1;hb=132;continue d;break}case 132:{hb=0;f[o>>2]=f[o>>2]|65536;ab=f[G>>2]|0;if(!ab){Sb=L5b(120)|0;IOa(Sb);f[G>>2]=Sb;_b=Sb}else _b=ab;ab=f[c>>2]|0;if(ab>>>0<(f[g>>2]|0)>>>0?(Sb=b[ab>>0]|0,Sb<<24>>24>-1):0){f[c>>2]=ab+1;$b=Sb&255}else{Sb=Znb(c)|0;if((Sb|0)>-1)$b=Sb;else{lb=0;hb=664;break a}}Inb(e,c,$b);if((f[H>>2]|0)<0){hb=140;break a}if(!(UPa(_b,c)|0)){hb=140;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}Sb=f[c>>2]|0;if(Sb>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[Sb>>0]|0)!=90)continue a;f[c>>2]=Sb+1;hb=146;continue d;break}case 146:{hb=0;f[o>>2]=f[o>>2]|131072;Sb=f[I>>2]|0;if(!Sb){ab=L5b(52)|0;KOa(ab);f[I>>2]=ab;ac=ab}else ac=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;bc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)bc=ab;else{lb=0;hb=664;break a}}Inb(e,c,bc);if((f[K>>2]|0)<0){hb=154;break a}if(!(VPa(ac,c)|0)){hb=154;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;if(ab>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[ab>>0]|0)!=98)continue a;f[c>>2]=ab+1;hb=160;continue d;break}case 160:{hb=0;f[o>>2]=f[o>>2]|262144;ab=f[L>>2]|0;if(!ab){Sb=L5b(24)|0;MOa(Sb);f[L>>2]=Sb;cc=Sb}else cc=ab;ab=f[c>>2]|0;if(ab>>>0<(f[g>>2]|0)>>>0?(Sb=b[ab>>0]|0,Sb<<24>>24>-1):0){f[c>>2]=ab+1;dc=Sb&255}else{Sb=Znb(c)|0;if((Sb|0)>-1)dc=Sb;else{lb=0;hb=664;break a}}Inb(e,c,dc);if((f[M>>2]|0)<0){hb=168;break a}if(!(WPa(cc,c)|0)){hb=168;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}Sb=f[c>>2]|0;if(Sb>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[Sb>>0]|0)!=106)continue a;f[c>>2]=Sb+1;hb=174;continue d;break}case 174:{hb=0;f[o>>2]=f[o>>2]|4194304;Sb=f[N>>2]|0;if(!Sb){ab=L5b(28)|0;SOa(ab);f[N>>2]=ab;ec=ab}else ec=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;fc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)fc=ab;else{lb=0;hb=664;break a}}Inb(e,c,fc);if((f[O>>2]|0)<0){hb=182;break a}if(!(XPa(ec,c)|0)){hb=182;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;if(ab>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[ab>>0]|0)!=114)continue a;f[c>>2]=ab+1;hb=188;continue d;break}case 188:{hb=0;f[o>>2]=f[o>>2]|8388608;ab=f[P>>2]|0;if(!ab){Sb=L5b(20)|0;cOa(Sb);f[P>>2]=Sb;gc=Sb}else gc=ab;ab=f[c>>2]|0;if(ab>>>0<(f[g>>2]|0)>>>0?(Sb=b[ab>>0]|0,Sb<<24>>24>-1):0){f[c>>2]=ab+1;hc=Sb&255}else{Sb=Znb(c)|0;if((Sb|0)>-1)hc=Sb;else{lb=0;hb=664;break a}}Inb(e,c,hc);if((f[Q>>2]|0)<0){hb=196;break a}if(!(iOa(gc,c)|0)){hb=196;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}Sb=f[c>>2]|0;if(Sb>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[Sb>>0]|0)!=122)continue a;f[c>>2]=Sb+1;hb=202;continue d;break}case 202:{hb=0;f[o>>2]=f[o>>2]|33554432;Sb=f[R>>2]|0;if(!Sb){ab=L5b(60)|0;VOa(ab);f[R>>2]=ab;ic=ab}else ic=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;jc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)jc=ab;else{lb=0;hb=664;break a}}Inb(e,c,jc);if((f[S>>2]|0)<0){hb=210;break a}if(!(YPa(ic,c)|0)){hb=210;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-126)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=217;continue d;break}case 217:{hb=0;f[o>>2]=f[o>>2]|67108864;Sb=f[T>>2]|0;if(!Sb){ab=L5b(20)|0;XOa(ab);f[T>>2]=ab;kc=ab}else kc=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;lc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)lc=ab;else{lb=0;hb=664;break a}}Inb(e,c,lc);if((f[U>>2]|0)<0){hb=225;break a}if(!(ZPa(kc,c)|0)){hb=225;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-118)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=232;continue d;break}case 232:{hb=0;f[o>>2]=f[o>>2]|134217728;Sb=f[V>>2]|0;if(!Sb){ab=L5b(36)|0;YOa(ab);f[V>>2]=ab;mc=ab}else mc=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;nc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)nc=ab;else{lb=0;hb=664;break a}}Inb(e,c,nc);if((f[W>>2]|0)<0){hb=240;break a}if(!(_Pa(mc,c)|0)){hb=240;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-110)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=247;continue d;break}case 247:{hb=0;f[o>>2]=f[o>>2]|268435456;Sb=f[X>>2]|0;if(!Sb){ab=L5b(40)|0;_Oa(ab);f[X>>2]=ab;oc=ab}else oc=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;pc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)pc=ab;else{lb=0;hb=664;break a}}Inb(e,c,pc);if((f[Y>>2]|0)<0){hb=255;break a}if(!($Pa(oc,c)|0)){hb=255;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-102)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=262;continue d;break}case 262:{hb=0;f[o>>2]=f[o>>2]|-2147483648;Sb=f[Z>>2]|0;if(!Sb){ab=L5b(68)|0;dPa(ab);f[Z>>2]=ab;qc=ab}else qc=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;rc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)rc=ab;else{lb=0;hb=664;break a}}Inb(e,c,rc);if((f[_>>2]|0)<0){hb=270;break a}if(!(aQa(qc,c)|0)){hb=270;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-94)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=277;continue d;break}case 277:{hb=0;f[j>>2]=f[j>>2]|128;Sb=f[$>>2]|0;if(!Sb){ab=L5b(64)|0;nPa(ab);f[$>>2]=ab;sc=ab}else sc=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;tc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)tc=ab;else{lb=0;hb=664;break a}}Inb(e,c,tc);if((f[aa>>2]|0)<0){hb=285;break a}if(!(bQa(sc,c)|0)){hb=285;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-86)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=292;continue d;break}case 292:{hb=0;f[j>>2]=f[j>>2]|1;Sb=f[ba>>2]|0;if(!Sb){ab=L5b(28)|0;fPa(ab);f[ba>>2]=ab;uc=ab}else uc=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;vc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)vc=ab;else{lb=0;hb=664;break a}}Inb(e,c,vc);if((f[ca>>2]|0)<0){hb=300;break a}if(!(cQa(uc,c)|0)){hb=300;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-78)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=307;continue d;break}case 307:{hb=0;f[o>>2]=f[o>>2]|536870912;Sb=f[da>>2]|0;if(!Sb){ab=L5b(32)|0;aPa(ab);f[da>>2]=ab;wc=ab}else wc=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;xc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)xc=ab;else{lb=0;hb=664;break a}}Inb(e,c,xc);if((f[ea>>2]|0)<0){hb=315;break a}if(!(dQa(wc,c)|0)){hb=315;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-70)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=322;continue d;break}case 322:{hb=0;f[o>>2]=f[o>>2]|8192;Sb=f[fa>>2]|0;if(!Sb){ab=L5b(28)|0;FOa(ab);f[fa>>2]=ab;yc=ab}else yc=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;zc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)zc=ab;else{lb=0;hb=664;break a}}Inb(e,c,zc);if((f[ga>>2]|0)<0){hb=330;break a}if(!(eQa(yc,c)|0)){hb=330;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-62)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=337;continue d;break}case 337:{hb=0;f[o>>2]=f[o>>2]|1048576;Sb=f[ha>>2]|0;if(!Sb){ab=L5b(36)|0;POa(ab);f[ha>>2]=ab;Ac=ab}else Ac=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;Bc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)Bc=ab;else{lb=0;hb=664;break a}}Inb(e,c,Bc);if((f[ia>>2]|0)<0){hb=345;break a}if(!(fQa(Ac,c)|0)){hb=345;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-54)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=352;continue d;break}case 352:{hb=0;f[j>>2]=f[j>>2]|64;Sb=f[ja>>2]|0;if(!Sb){ab=L5b(20)|0;mPa(ab);f[ja>>2]=ab;Cc=ab}else Cc=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;Dc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)Dc=ab;else{lb=0;hb=664;break a}}Inb(e,c,Dc);if((f[ka>>2]|0)<0){hb=360;break a}if(!(gQa(Cc,c)|0)){hb=360;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-46)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=367;continue d;break}case 367:{hb=0;f[o>>2]=f[o>>2]|524288;Sb=f[la>>2]|0;if(!Sb){ab=L5b(96)|0;NOa(ab);f[la>>2]=ab;Ec=ab}else Ec=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;Fc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)Fc=ab;else{lb=0;hb=664;break a}}Inb(e,c,Fc);if((f[ma>>2]|0)<0){hb=375;break a}if(!(hQa(Ec,c)|0)){hb=375;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-38)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=382;continue d;break}case 382:{hb=0;f[o>>2]=f[o>>2]|4096;Sb=f[na>>2]|0;if(!Sb){ab=L5b(28)|0;EOa(ab);f[na>>2]=ab;Gc=ab}else Gc=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;Hc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)Hc=ab;else{lb=0;hb=664;break a}}Inb(e,c,Hc);if((f[oa>>2]|0)<0){hb=390;break a}if(!(iQa(Gc,c)|0)){hb=390;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-22)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=397;continue d;break}case 397:{hb=0;f[o>>2]=f[o>>2]|16777216;Sb=f[pa>>2]|0;if(!Sb){ab=L5b(20)|0;UOa(ab);f[pa>>2]=ab;Ic=ab}else Ic=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;Jc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)Jc=ab;else{lb=0;hb=664;break a}}Inb(e,c,Jc);if((f[qa>>2]|0)<0){hb=405;break a}if(!(jQa(Ic,c)|0)){hb=405;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-14)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=412;continue d;break}case 412:{hb=0;f[j>>2]=f[j>>2]|2;Sb=f[ra>>2]|0;if(!Sb){ab=L5b(24)|0;gPa(ab);f[ra>>2]=ab;Kc=ab}else Kc=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;Lc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)Lc=ab;else{lb=0;hb=664;break a}}Inb(e,c,Lc);if((f[sa>>2]|0)<0){hb=420;break a}if(!(kQa(Kc,c)|0)){hb=420;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-6)continue a;if((b[Sb+1>>0]|0)!=1)continue a;f[c>>2]=Sb+2;hb=427;continue d;break}case 427:{hb=0;f[j>>2]=f[j>>2]|16;Sb=f[ta>>2]|0;if(!Sb){ab=L5b(36)|0;jPa(ab);f[ta>>2]=ab;Mc=ab}else Mc=Sb;Sb=f[c>>2]|0;if(Sb>>>0<(f[g>>2]|0)>>>0?(ab=b[Sb>>0]|0,ab<<24>>24>-1):0){f[c>>2]=Sb+1;Nc=ab&255}else{ab=Znb(c)|0;if((ab|0)>-1)Nc=ab;else{lb=0;hb=664;break a}}Inb(e,c,Nc);if((f[ua>>2]|0)<0){hb=435;break a}if(!(lQa(Mc,c)|0)){hb=435;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}ab=f[c>>2]|0;Sb=ab;if(((f[g>>2]|0)-ab|0)<=1)continue a;if((b[Sb>>0]|0)!=-126)continue a;if((b[Sb+1>>0]|0)!=2)continue a;f[c>>2]=Sb+2;hb=442;continue d;break}case 442:{hb=0;Sb=f[s>>2]|0;f[s>>2]=Sb+-1;if((Sb|0)<=0){lb=0;hb=664;break a}while(1){Sb=f[wa>>2]|0;do if(Sb){ab=f[ya>>2]|0;bb=f[Sb>>2]|0;if((ab|0)>=(bb|0))if((bb|0)==(f[xa>>2]|0)){Oc=bb;hb=448;break}else{Pc=bb;Qc=Sb;hb=449;break}else{f[ya>>2]=ab+1;Rc=f[Sb+4+(ab<<2)>>2]|0;break}}else{Oc=f[xa>>2]|0;hb=448}while(0);if((hb|0)==448){hb=0;cpb(va,Oc+1|0);Sb=f[wa>>2]|0;Pc=f[Sb>>2]|0;Qc=Sb;hb=449}if((hb|0)==449){hb=0;f[Qc>>2]=Pc+1;Sb=Hza(0,f[va>>2]|0)|0;ab=f[wa>>2]|0;bb=f[ya>>2]|0;f[ya>>2]=bb+1;f[ab+4+(bb<<2)>>2]=Sb;Rc=Sb}Sb=Jnb(c)|0;if(!(mQa(Rc,c)|0)){lb=0;hb=664;break a}if(!(Pnb(c,Sb)|0)){lb=0;hb=664;break a}Sb=f[c>>2]|0;Sc=Sb;if(((f[g>>2]|0)-Sb|0)<=1){hb=459;break d}Sb=b[Sc>>0]|0;if(Sb<<24>>24!=-126){Tc=Sb;break}if((b[Sc+1>>0]|0)!=2){hb=456;break}f[c>>2]=Sc+2}if((hb|0)==456){hb=0;Tc=b[Sc>>0]|0}if(Tc<<24>>24!=-118){hb=459;break d}if((b[Sc+1>>0]|0)==2){Uc=Sc;hb=462}else{hb=459;break d}break}case 463:{hb=0;Sb=f[Aa>>2]|0;do if(Sb){bb=f[Ca>>2]|0;ab=f[Sb>>2]|0;if((bb|0)>=(ab|0))if((ab|0)==(f[Ba>>2]|0)){Vc=ab;hb=468;break}else{Wc=ab;Xc=Sb;hb=469;break}else{f[Ca>>2]=bb+1;Yc=f[Sb+4+(bb<<2)>>2]|0;break}}else{Vc=f[Ba>>2]|0;hb=468}while(0);if((hb|0)==468){hb=0;cpb(za,Vc+1|0);Sb=f[Aa>>2]|0;Wc=f[Sb>>2]|0;Xc=Sb;hb=469}if((hb|0)==469){hb=0;f[Xc>>2]=Wc+1;Sb=Hza(0,f[za>>2]|0)|0;bb=f[Aa>>2]|0;ab=f[Ca>>2]|0;f[Ca>>2]=ab+1;f[bb+4+(ab<<2)>>2]=Sb;Yc=Sb}Sb=Jnb(c)|0;if(!(mQa(Yc,c)|0)){lb=0;hb=664;break a}if(!(Pnb(c,Sb)|0)){lb=0;hb=664;break a}Sb=f[c>>2]|0;ab=Sb;if(((f[g>>2]|0)-Sb|0)<=1){hb=475;break d}if((b[ab>>0]|0)==-118?(b[ab+1>>0]|0)==2:0){Uc=ab;hb=462;break}f[s>>2]=(f[s>>2]|0)+1;if((b[ab>>0]|0)!=-110)continue a;if((b[ab+1>>0]|0)!=2)continue a;f[c>>2]=ab+2;hb=480;continue d;break}case 480:{hb=0;f[o>>2]=f[o>>2]|1073741824;ab=f[Da>>2]|0;if(!ab){Sb=L5b(24)|0;cPa(Sb);f[Da>>2]=Sb;Zc=Sb}else Zc=ab;ab=f[c>>2]|0;if(ab>>>0<(f[g>>2]|0)>>>0?(Sb=b[ab>>0]|0,Sb<<24>>24>-1):0){f[c>>2]=ab+1;_c=Sb&255}else{Sb=Znb(c)|0;if((Sb|0)>-1)_c=Sb;else{lb=0;hb=664;break a}}Inb(e,c,_c);if((f[Ea>>2]|0)<0){hb=488;break a}if(!(nQa(Zc,c)|0)){hb=488;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}Sb=f[g>>2]|0;ab=f[c>>2]|0;bb=ab;if((Sb-ab|0)<=1)continue a;if((b[bb>>0]|0)!=-99)continue a;if((b[bb+1>>0]|0)==2){$c=bb;ad=Sb;hb=495}else continue a;break}case 496:{hb=0;if((xb-wb|0)>3){Sb=wb;bb=h[Sb>>0]|h[Sb+1>>0]<<8|h[Sb+2>>0]<<16|h[Sb+3>>0]<<24;f[e>>2]=bb;f[c>>2]=wb+4;bd=bb}else{if(!(Xnb(c,e)|0)){hb=510;break a}bd=f[e>>2]|0}bb=f[Fa>>2]|0;if((bb|0)==(f[Ga>>2]|0)){qza(Fa,bb+1|0);cd=f[Fa>>2]|0}else cd=bb;bb=f[Ha>>2]|0;Sb=cd+1|0;f[Fa>>2]=Sb;f[bb+4+(cd<<2)>>2]=bd;ab=f[c>>2]|0;Qb=(f[g>>2]|0)-ab|0;if((Qb|0)<=0){hb=512;continue d}cb=(f[Ga>>2]|0)-Sb|0;ib=(Qb>>>0)/6|0;Qb=(ib|0)<(cb|0)?ib:cb;if((Qb|0)<=0){hb=512;continue d}cb=0;ib=ab;ab=Sb;while(1){if((b[ib>>0]|0)!=-99){dd=cb;break}if((b[ib+1>>0]|0)!=2){dd=cb;break}Sb=ib+2|0;db=h[Sb>>0]|h[Sb+1>>0]<<8|h[Sb+2>>0]<<16|h[Sb+3>>0]<<24;Sb=ab;ab=ab+1|0;f[Fa>>2]=ab;f[bb+4+(Sb<<2)>>2]=db;db=cb+1|0;if((db|0)>=(Qb|0)){dd=db;break}else{cb=db;ib=ib+6|0}}if((dd|0)<=0){hb=512;continue d}Tnb(c,dd*6|0)|0;hb=512;continue d;break}case 512:{hb=0;ib=f[g>>2]|0;cb=f[c>>2]|0;Qb=cb;if((ib-cb|0)<=1)continue a;cb=b[Qb>>0]|0;if(cb<<24>>24==-99){if((b[Qb+1>>0]|0)==2){$c=Qb;ad=ib;hb=495;break}ed=b[Qb>>0]|0}else ed=cb;if(ed<<24>>24!=-94)continue a;if((b[Qb+1>>0]|0)!=2)continue a;f[c>>2]=Qb+2;hb=520;continue d;break}case 520:{hb=0;f[j>>2]=f[j>>2]|256;Qb=f[Ia>>2]|0;if(!Qb){cb=L5b(44)|0;pPa(cb);f[Ia>>2]=cb;fd=cb}else fd=Qb;Qb=f[c>>2]|0;if(Qb>>>0<(f[g>>2]|0)>>>0?(cb=b[Qb>>0]|0,cb<<24>>24>-1):0){f[c>>2]=Qb+1;gd=cb&255}else{cb=Znb(c)|0;if((cb|0)>-1)gd=cb;else{lb=0;hb=664;break a}}Inb(e,c,gd);if((f[Ja>>2]|0)<0){hb=528;break a}if(!(oQa(fd,c)|0)){hb=528;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}cb=f[c>>2]|0;Qb=cb;if(((f[g>>2]|0)-cb|0)<=1)continue a;if((b[Qb>>0]|0)!=-86)continue a;if((b[Qb+1>>0]|0)!=2)continue a;f[c>>2]=Qb+2;hb=535;continue d;break}case 535:{hb=0;f[j>>2]=f[j>>2]|32;Qb=f[Ka>>2]|0;if(!Qb){cb=L5b(20)|0;lPa(cb);f[Ka>>2]=cb;hd=cb}else hd=Qb;Qb=f[c>>2]|0;if(Qb>>>0<(f[g>>2]|0)>>>0?(cb=b[Qb>>0]|0,cb<<24>>24>-1):0){f[c>>2]=Qb+1;id=cb&255}else{cb=Znb(c)|0;if((cb|0)>-1)id=cb;else{lb=0;hb=664;break a}}Inb(e,c,id);if((f[La>>2]|0)<0){hb=543;break a}if(!(pQa(hd,c)|0)){hb=543;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}cb=f[c>>2]|0;Qb=cb;if(((f[g>>2]|0)-cb|0)<=1)continue a;if((b[Qb>>0]|0)!=-78)continue a;if((b[Qb+1>>0]|0)!=2)continue a;f[c>>2]=Qb+2;hb=550;continue d;break}case 550:{hb=0;f[j>>2]=f[j>>2]|4;Qb=f[Ma>>2]|0;if(!Qb){cb=L5b(20)|0;hPa(cb);f[Ma>>2]=cb;jd=cb}else jd=Qb;Qb=f[c>>2]|0;if(Qb>>>0<(f[g>>2]|0)>>>0?(cb=b[Qb>>0]|0,cb<<24>>24>-1):0){f[c>>2]=Qb+1;kd=cb&255}else{cb=Znb(c)|0;if((cb|0)>-1)kd=cb;else{lb=0;hb=664;break a}}Inb(e,c,kd);if((f[Na>>2]|0)<0){hb=558;break a}if(!(qQa(jd,c)|0)){hb=558;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}cb=f[c>>2]|0;Qb=cb;if(((f[g>>2]|0)-cb|0)<=1)continue a;if((b[Qb>>0]|0)!=-70)continue a;if((b[Qb+1>>0]|0)!=2)continue a;f[c>>2]=Qb+2;hb=565;continue d;break}case 565:{hb=0;f[j>>2]=f[j>>2]|8;Qb=f[Oa>>2]|0;if(!Qb){cb=L5b(24)|0;iPa(cb);f[Oa>>2]=cb;ld=cb}else ld=Qb;Qb=f[c>>2]|0;if(Qb>>>0<(f[g>>2]|0)>>>0?(cb=b[Qb>>0]|0,cb<<24>>24>-1):0){f[c>>2]=Qb+1;md=cb&255}else{cb=Znb(c)|0;if((cb|0)>-1)md=cb;else{lb=0;hb=664;break a}}Inb(e,c,md);if((f[Pa>>2]|0)<0){hb=573;break a}if(!(rQa(ld,c)|0)){hb=573;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}cb=f[c>>2]|0;Qb=cb;if(((f[g>>2]|0)-cb|0)<=1)continue a;if((b[Qb>>0]|0)!=-62)continue a;if((b[Qb+1>>0]|0)!=2)continue a;f[c>>2]=Qb+2;hb=580;continue d;break}case 580:{hb=0;f[o>>2]=f[o>>2]|32768;Qb=f[Qa>>2]|0;if(!Qb){cb=L5b(24)|0;HOa(cb);f[Qa>>2]=cb;nd=cb}else nd=Qb;Qb=f[c>>2]|0;if(Qb>>>0<(f[g>>2]|0)>>>0?(cb=b[Qb>>0]|0,cb<<24>>24>-1):0){f[c>>2]=Qb+1;od=cb&255}else{cb=Znb(c)|0;if((cb|0)>-1)od=cb;else{lb=0;hb=664;break a}}Inb(e,c,od);if((f[Ra>>2]|0)<0){hb=588;break a}if(!(sQa(nd,c)|0)){hb=588;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}cb=f[c>>2]|0;Qb=cb;if(((f[g>>2]|0)-cb|0)<=1)continue a;if((b[Qb>>0]|0)!=-54)continue a;if((b[Qb+1>>0]|0)!=2)continue a;f[c>>2]=Qb+2;hb=595;continue d;break}case 595:{hb=0;f[o>>2]=f[o>>2]|2097152;Qb=f[Sa>>2]|0;if(!Qb){cb=L5b(28)|0;ROa(cb);f[Sa>>2]=cb;pd=cb}else pd=Qb;Qb=f[c>>2]|0;if(Qb>>>0<(f[g>>2]|0)>>>0?(cb=b[Qb>>0]|0,cb<<24>>24>-1):0){f[c>>2]=Qb+1;qd=cb&255}else{cb=Znb(c)|0;if((cb|0)>-1)qd=cb;else{lb=0;hb=664;break a}}Inb(e,c,qd);if((f[Ta>>2]|0)<0){hb=603;break a}if(!(tQa(pd,c)|0)){hb=603;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}cb=f[c>>2]|0;Qb=cb;if(((f[g>>2]|0)-cb|0)<=1)continue a;if((b[Qb>>0]|0)!=-46)continue a;if((b[Qb+1>>0]|0)!=2)continue a;f[c>>2]=Qb+2;hb=610;continue d;break}case 610:{hb=0;f[j>>2]=f[j>>2]|512;Qb=f[Ua>>2]|0;if(!Qb){cb=L5b(28)|0;rPa(cb);f[Ua>>2]=cb;rd=cb}else rd=Qb;Qb=f[c>>2]|0;if(Qb>>>0<(f[g>>2]|0)>>>0?(cb=b[Qb>>0]|0,cb<<24>>24>-1):0){f[c>>2]=Qb+1;sd=cb&255}else{cb=Znb(c)|0;if((cb|0)>-1)sd=cb;else{lb=0;hb=664;break a}}Inb(e,c,sd);if((f[Va>>2]|0)<0){hb=618;break a}if(!(uQa(rd,c)|0)){hb=618;break a}if(!(Onb(c,f[e>>2]|0)|0)){lb=0;hb=664;break a}cb=f[c>>2]|0;Qb=cb;if(((f[g>>2]|0)-cb|0)<=1)continue a;if((b[Qb>>0]|0)!=-54)continue a;if((b[Qb+1>>0]|0)==62){td=Qb;hb=624}else continue a;break}case 625:{hb=0;if(!(fqb(c,mza(Wa)|0)|0)){lb=0;hb=664;break a}Qb=f[g>>2]|0;cb=f[c>>2]|0;ib=cb;bb=Qb;if((Qb-cb|0)<=1)continue a;cb=b[ib>>0]|0;if(cb<<24>>24==-54){if((b[ib+1>>0]|0)==62){td=ib;hb=624;break}ud=b[ib>>0]|0}else ud=cb;if(ud<<24>>24!=-48)continue a;if((b[ib+1>>0]|0)==62){vd=ib;wd=bb;hb=634}else continue a;break}case 635:{hb=0;if(yb>>>0<zb>>>0){bb=b[yb>>0]|0;ib=bb&255;if(bb<<24>>24>-1){f[c>>2]=yb+1;xd=ib}else{yd=ib;hb=638}}else{yd=0;hb=638}if((hb|0)==638){hb=0;ib=Knb(c,yd)|0;bb=J;if((bb|0)>-1|(bb|0)==-1&ib>>>0>4294967295)xd=ib;else{lb=0;hb=664;break a}}if(xd>>>0<2){ib=f[Xa>>2]|0;if((ib|0)==(f[Ya>>2]|0)){nza(Xa,ib+1|0);zd=f[Xa>>2]|0}else zd=ib;ib=f[Za>>2]|0;f[Xa>>2]=zd+1;f[ib+4+(zd<<2)>>2]=xd;hb=651;continue d}ib=f[r>>2]|0;if(!(ib&1))Ad=hBa(r)|0;else Ad=ib&-2;NPb(Ad,1002,xd,((xd|0)<0)<<31>>31);hb=651;continue d;break}case 651:{hb=0;ib=f[g>>2]|0;bb=f[c>>2]|0;Bd=bb;Cd=ib;if((ib-bb|0)<=1){hb=654;break d}if((b[Bd>>0]|0)!=-48){hb=654;break d}if((b[Bd+1>>0]|0)==62){vd=Bd;wd=Cd;hb=634}else{hb=654;break d}break}}if((hb|0)==30){hb=0;f[c>>2]=Bb+1;hb=31;continue}else if((hb|0)==76){hb=0;bb=Mb+1|0;f[c>>2]=bb;sb=bb;tb=Nb;hb=77;continue}else if((hb|0)==97){hb=0;bb=Tb+1|0;f[c>>2]=bb;ub=bb;vb=Ub;hb=98;continue}else if((hb|0)==462){hb=0;f[c>>2]=Uc+2;hb=463;continue}else if((hb|0)==495){hb=0;bb=$c+2|0;f[c>>2]=bb;wb=bb;xb=ad;hb=496;continue}else if((hb|0)==624){hb=0;f[c>>2]=td+2;hb=625;continue}else if((hb|0)==634){hb=0;bb=vd+2|0;f[c>>2]=bb;yb=bb;zb=wd;hb=635;continue}}if((hb|0)==70){hb=0;f[s>>2]=(f[s>>2]|0)+1;continue a}else if((hb|0)==459){hb=0;f[s>>2]=(f[s>>2]|0)+1;continue a}else if((hb|0)==475){hb=0;f[s>>2]=(f[s>>2]|0)+1;continue a}else if((hb|0)==654){hb=0;if((Bd|0)!=(Cd|0))continue a;if(f[a>>2]|0){hb=657;break a}if((f[_a>>2]|0)==(f[$a>>2]|0)){hb=657;break a}else continue a}}while(0);if((hb|0)==658){hb=0;if(!kb){lb=1;hb=664;break}else mb=kb}if((mb&7|0)==4){lb=1;hb=664;break}bb=f[r>>2]|0;if(!(bb&1))Dd=hBa(r)|0;else Dd=bb&-2;if(!(ZPb(c,mb,Dd)|0)){lb=0;hb=664;break}}switch(hb|0){case 19:{lb=0;u=d;return lb|0}case 90:{lb=0;u=d;return lb|0}case 111:{lb=0;u=d;return lb|0}case 126:{lb=0;u=d;return lb|0}case 140:{lb=0;u=d;return lb|0}case 154:{lb=0;u=d;return lb|0}case 168:{lb=0;u=d;return lb|0}case 182:{lb=0;u=d;return lb|0}case 196:{lb=0;u=d;return lb|0}case 210:{lb=0;u=d;return lb|0}case 225:{lb=0;u=d;return lb|0}case 240:{lb=0;u=d;return lb|0}case 255:{lb=0;u=d;return lb|0}case 270:{lb=0;u=d;return lb|0}case 285:{lb=0;u=d;return lb|0}case 300:{lb=0;u=d;return lb|0}case 315:{lb=0;u=d;return lb|0}case 330:{lb=0;u=d;return lb|0}case 345:{lb=0;u=d;return lb|0}case 360:{lb=0;u=d;return lb|0}case 375:{lb=0;u=d;return lb|0}case 390:{lb=0;u=d;return lb|0}case 405:{lb=0;u=d;return lb|0}case 420:{lb=0;u=d;return lb|0}case 435:{lb=0;u=d;return lb|0}case 488:{lb=0;u=d;return lb|0}case 510:{lb=0;u=d;return lb|0}case 528:{lb=0;u=d;return lb|0}case 543:{lb=0;u=d;return lb|0}case 558:{lb=0;u=d;return lb|0}case 573:{lb=0;u=d;return lb|0}case 588:{lb=0;u=d;return lb|0}case 603:{lb=0;u=d;return lb|0}case 618:{lb=0;u=d;return lb|0}case 657:{f[i>>2]=0;b[c+24>>0]=1;lb=1;u=d;return lb|0}case 664:{u=d;return lb|0}}return 0}function tOa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0;c=a+8|0;d=f[c>>2]|0;if(d&36){if(!(d&4)){e=0;g=d}else{h=f[a+160>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&32)){n=e;o=g}else{l=f[a+288>>2]|0;if((l|0)>=0)if(l>>>0<128){p=1;q=g}else{k=iob(l)|0;p=k;q=f[c>>2]|0}else{p=10;q=g}n=e+1+p|0;o=q}}else{n=0;o=d}if(o&61440){if(!(o&4096)){r=n;s=o}else{d=EPa(f[a+164>>2]|0)|0;if(d>>>0<128)t=1;else t=iob(d)|0;r=n+2+d+t|0;s=f[c>>2]|0}if(!(s&8192)){u=r;v=s}else{s=f[a+168>>2]|0;t=s+8|0;d=f[t>>2]|0;if(d&7){q=d<<1&2;if(!(d&2)){w=q;x=d}else{p=f[s+24>>2]|0;if(p>>>0<128){y=2;z=d}else{d=(iob(p)|0)+1|0;y=d;z=f[t>>2]|0}w=y+q|0;x=z}if(!(x&4))A=w;else{x=f[s+20>>2]|0;if((x|0)>=0)if(x>>>0<128)B=2;else B=(iob(x)|0)+1|0;else B=11;A=B+w|0}}else A=0;w=f[s+4>>2]|0;if(!(w&1))C=A;else C=(dQb(w&-2)|0)+A|0;f[s+12>>2]=C;if(C>>>0<128)D=1;else D=iob(C)|0;u=r+2+C+D|0;v=f[c>>2]|0}if(!(v&16384)){E=u;F=v}else{v=f[a+172>>2]|0;D=v+8|0;C=f[D>>2]|0;if(C&3){if(C&1){r=f[v+16>>2]|0;if((r|0)>=0)if(r>>>0<128){G=2;H=C}else{s=(iob(r)|0)+1|0;G=s;H=f[D>>2]|0}else{G=11;H=C}}else{G=0;H=C}if(!(H&2))I=G;else{H=f[v+20>>2]|0;if(H>>>0<128)J=2;else J=(iob(H)|0)+1|0;I=J+G|0}}else I=0;G=f[v+4>>2]|0;if(!(G&1))K=I;else K=(dQb(G&-2)|0)+I|0;f[v+12>>2]=K;if(K>>>0<128)L=1;else L=iob(K)|0;E=u+1+K+L|0;F=f[c>>2]|0}if(!(F&32768)){M=E;N=F}else{F=f[a+176>>2]|0;L=f[F+8>>2]|0;K=(L&3|0)==0?0:(L&1|0?5:0)|L&2;L=f[F+4>>2]|0;if(!(L&1))O=K;else O=(dQb(L&-2)|0)+K|0;f[F+12>>2]=O;if(O>>>0<128)P=1;else P=iob(O)|0;M=E+2+O+P|0;N=f[c>>2]|0}}else{M=n;N=o}if(N&16711680){if(!(N&65536)){Q=M;R=N}else{o=FPa(f[a+180>>2]|0)|0;if(o>>>0<128)S=1;else S=iob(o)|0;Q=M+1+o+S|0;R=f[c>>2]|0}if(!(R&131072)){T=Q;U=R}else{R=GPa(f[a+184>>2]|0)|0;if(R>>>0<128)V=1;else V=iob(R)|0;T=Q+1+R+V|0;U=f[c>>2]|0}if(!(U&262144)){W=T;X=U}else{U=f[a+188>>2]|0;V=f[U+8>>2]|0;R=(V&3|0)==0?0:(V&1|0?5:0)|V&2;V=f[U+4>>2]|0;if(!(V&1))Y=R;else Y=(dQb(V&-2)|0)+R|0;f[U+12>>2]=Y;if(Y>>>0<128)Z=1;else Z=iob(Y)|0;W=T+1+Y+Z|0;X=f[c>>2]|0}if(!(X&524288)){_=W;$=X}else{X=HPa(f[a+192>>2]|0)|0;if(X>>>0<128)aa=1;else aa=iob(X)|0;_=W+2+X+aa|0;$=f[c>>2]|0}if(!($&1048576)){ba=_;ca=$}else{$=f[a+196>>2]|0;aa=$+8|0;X=f[aa>>2]|0;if(!(X&5))da=0;else{if(X&1){W=f[$+28>>2]|0;if((W|0)>=0)if(W>>>0<128){ea=2;fa=X}else{Z=(iob(W)|0)+1|0;ea=Z;fa=f[aa>>2]|0}else{ea=11;fa=X}}else{ea=0;fa=X}da=fa&4|0?ea+2|0:ea}ea=f[$+16>>2]|0;fa=ea+da+(ea<<2)|0;ea=f[$+4>>2]|0;if(!(ea&1))ga=fa;else ga=(dQb(ea&-2)|0)+fa|0;f[$+12>>2]=ga;if(ga>>>0<128)ha=1;else ha=iob(ga)|0;ba=_+2+ga+ha|0;ca=f[c>>2]|0}if(!(ca&2097152)){ia=ba;ja=ca}else{ca=f[a+200>>2]|0;ha=f[ca+8>>2]|0;if(!(ha&7))ka=0;else{ga=ha&1|0?5:0;_=ha&2|0?ga+5|0:ga;ka=ha&4|0?_+5|0:_}_=f[ca+4>>2]|0;if(_&1){ha=(dQb(_&-2)|0)+ka|0;f[ca+12>>2]=ha;if(ha>>>0<128){la=1;ma=ha}else{la=iob(ha)|0;ma=ha}}else{f[ca+12>>2]=ka;la=1;ma=ka}ia=ba+2+ma+la|0;ja=f[c>>2]|0}if(!(ja&4194304)){na=ia;oa=ja}else{ja=IPa(f[a+204>>2]|0)|0;if(ja>>>0<128)pa=1;else pa=iob(ja)|0;na=ia+1+ja+pa|0;oa=f[c>>2]|0}if(!(oa&8388608)){qa=na;ra=oa}else{oa=f[a+208>>2]|0;if(!(f[oa+8>>2]&1))sa=0;else{pa=f[oa+16>>2]|0;ja=b[pa+11>>0]|0;if(ja<<24>>24<0){ia=f[pa+4>>2]|0;if(ia>>>0<128){ta=1;ua=ia}else{ta=iob(ia)|0;ua=ia}}else{ta=1;ua=ja&255}sa=ua+1+ta|0}ta=f[oa+4>>2]|0;if(!(ta&1))va=sa;else va=(dQb(ta&-2)|0)+sa|0;f[oa+12>>2]=va;if(va>>>0<128)wa=1;else wa=iob(va)|0;qa=na+1+va+wa|0;ra=f[c>>2]|0}}else{qa=M;ra=N}if(ra>>>0>16777215){if(!(ra&16777216)){xa=qa;ya=ra}else{ra=f[a+212>>2]|0;if(f[ra+8>>2]&1){N=f[ra+16>>2]|0;if((N|0)>=0)if(N>>>0<128)za=2;else za=(iob(N)|0)+1|0;else za=11}else za=0;N=f[ra+4>>2]|0;if(!(N&1))Aa=za;else Aa=(dQb(N&-2)|0)+za|0;f[ra+12>>2]=Aa;if(Aa>>>0<128)Ba=1;else Ba=iob(Aa)|0;xa=qa+2+Aa+Ba|0;ya=f[c>>2]|0}if(!(ya&33554432)){Ca=xa;Da=ya}else{ya=JPa(f[a+216>>2]|0)|0;if(ya>>>0<128)Ea=1;else Ea=iob(ya)|0;Ca=xa+1+ya+Ea|0;Da=f[c>>2]|0}if(!(Da&67108864)){Fa=Ca;Ga=Da}else{Da=f[a+220>>2]|0;if(!(f[Da+8>>2]&1))Ha=0;else{Ea=f[Da+16>>2]|0;ya=b[Ea+11>>0]|0;if(ya<<24>>24<0){xa=f[Ea+4>>2]|0;if(xa>>>0<128){Ia=1;Ja=xa}else{Ia=iob(xa)|0;Ja=xa}}else{Ia=1;Ja=ya&255}Ha=Ja+1+Ia|0}Ia=f[Da+4>>2]|0;if(!(Ia&1))Ka=Ha;else Ka=(dQb(Ia&-2)|0)+Ha|0;f[Da+12>>2]=Ka;if(Ka>>>0<128)La=1;else La=iob(Ka)|0;Fa=Ca+2+Ka+La|0;Ga=f[c>>2]|0}if(!(Ga&134217728)){Ma=Fa;Na=Ga}else{Ga=KPa(f[a+224>>2]|0)|0;if(Ga>>>0<128)Oa=1;else Oa=iob(Ga)|0;Ma=Fa+2+Ga+Oa|0;Na=f[c>>2]|0}if(!(Na&268435456)){Pa=Ma;Qa=Na}else{Na=LPa(f[a+228>>2]|0)|0;if(Na>>>0<128)Ra=1;else Ra=iob(Na)|0;Pa=Ma+2+Na+Ra|0;Qa=f[c>>2]|0}if(!(Qa&536870912)){Sa=Pa;Ta=Qa}else{Qa=MPa(f[a+232>>2]|0)|0;if(Qa>>>0<128)Ua=1;else Ua=iob(Qa)|0;Sa=Pa+2+Qa+Ua|0;Ta=f[c>>2]|0}if(!(Ta&1073741824)){Va=Sa;Wa=Ta}else{Ta=f[a+236>>2]|0;Ua=f[Ta+8>>2]|0;if(!(Ua&7))Xa=0;else{Qa=Ua<<1&2;Pa=Ua&2|0?Qa+2|0:Qa;Xa=Ua&4|0?Pa+5|0:Pa}Pa=f[Ta+4>>2]|0;if(Pa&1){Ua=(dQb(Pa&-2)|0)+Xa|0;f[Ta+12>>2]=Ua;if(Ua>>>0<128){Ya=1;Za=Ua}else{Ya=iob(Ua)|0;Za=Ua}}else{f[Ta+12>>2]=Xa;Ya=1;Za=Xa}Va=Sa+2+Za+Ya|0;Wa=f[c>>2]|0}if((Wa|0)<0){Wa=NPa(f[a+240>>2]|0)|0;if(Wa>>>0<128)_a=1;else _a=iob(Wa)|0;$a=Va+2+Wa+_a|0}else $a=Va}else $a=qa;qa=a+12|0;Va=f[qa>>2]|0;if(Va&255){if(!(Va&1)){ab=$a;bb=Va}else{_a=f[a+244>>2]|0;Wa=f[_a+8>>2]|0;if(!(Wa&7))cb=0;else{c=Wa&1|0?5:0;Ya=Wa&2|0?c+5|0:c;cb=Wa&4|0?Ya+5|0:Ya}Ya=f[_a+4>>2]|0;if(Ya&1){Wa=(dQb(Ya&-2)|0)+cb|0;f[_a+12>>2]=Wa;if(Wa>>>0<128){db=1;eb=Wa}else{db=iob(Wa)|0;eb=Wa}}else{f[_a+12>>2]=cb;db=1;eb=cb}ab=$a+2+eb+db|0;bb=f[qa>>2]|0}if(!(bb&2)){fb=ab;gb=bb}else{bb=f[a+248>>2]|0;db=f[bb+8>>2]|0;if(db&3){eb=db&1|0?5:0;if(!(db&2))hb=eb;else{db=f[bb+20>>2]|0;if((db|0)>=0)if(db>>>0<128)ib=2;else ib=(iob(db)|0)+1|0;else ib=11;hb=ib+eb|0}}else hb=0;eb=f[bb+4>>2]|0;if(!(eb&1))jb=hb;else jb=(dQb(eb&-2)|0)+hb|0;f[bb+12>>2]=jb;if(jb>>>0<128)kb=1;else kb=iob(jb)|0;fb=ab+2+jb+kb|0;gb=f[qa>>2]|0}if(!(gb&4)){lb=fb;mb=gb}else{gb=f[a+252>>2]|0;if(f[gb+8>>2]&1){kb=f[gb+16>>2]|0;if((kb|0)>=0)if(kb>>>0<128)nb=2;else nb=(iob(kb)|0)+1|0;else nb=11}else nb=0;kb=f[gb+4>>2]|0;if(!(kb&1))ob=nb;else ob=(dQb(kb&-2)|0)+nb|0;f[gb+12>>2]=ob;if(ob>>>0<128)pb=1;else pb=iob(ob)|0;lb=fb+2+ob+pb|0;mb=f[qa>>2]|0}if(!(mb&8)){qb=lb;rb=mb}else{mb=f[a+256>>2]|0;pb=mb+8|0;ob=f[pb>>2]|0;if(ob&3){if(ob&1){fb=f[mb+16>>2]|0;if((fb|0)>=0)if(fb>>>0<128){sb=2;tb=ob}else{gb=(iob(fb)|0)+1|0;sb=gb;tb=f[pb>>2]|0}else{sb=11;tb=ob}}else{sb=0;tb=ob}if(!(tb&2))ub=sb;else{tb=f[mb+20>>2]|0;if((tb|0)>=0)if(tb>>>0<128)vb=2;else vb=(iob(tb)|0)+1|0;else vb=11;ub=vb+sb|0}}else ub=0;sb=f[mb+4>>2]|0;if(!(sb&1))wb=ub;else wb=(dQb(sb&-2)|0)+ub|0;f[mb+12>>2]=wb;if(wb>>>0<128)xb=1;else xb=iob(wb)|0;qb=lb+2+wb+xb|0;rb=f[qa>>2]|0}if(!(rb&16)){yb=qb;zb=rb}else{rb=OPa(f[a+260>>2]|0)|0;if(rb>>>0<128)Ab=1;else Ab=iob(rb)|0;yb=qb+2+rb+Ab|0;zb=f[qa>>2]|0}if(!(zb&32)){Bb=yb;Cb=zb}else{zb=f[a+264>>2]|0;if(f[zb+8>>2]&1){Ab=f[zb+16>>2]|0;if((Ab|0)>=0)if(Ab>>>0<128)Db=2;else Db=(iob(Ab)|0)+1|0;else Db=11}else Db=0;Ab=f[zb+4>>2]|0;if(!(Ab&1))Eb=Db;else Eb=(dQb(Ab&-2)|0)+Db|0;f[zb+12>>2]=Eb;if(Eb>>>0<128)Fb=1;else Fb=iob(Eb)|0;Bb=yb+2+Eb+Fb|0;Cb=f[qa>>2]|0}if(!(Cb&64)){Gb=Bb;Hb=Cb}else{Cb=f[a+268>>2]|0;Fb=f[Cb+8>>2]&1|0?5:0;Eb=f[Cb+4>>2]|0;if(Eb&1){yb=(dQb(Eb&-2)|0)+Fb|0;f[Cb+12>>2]=yb;if(yb>>>0<128){Ib=1;Jb=yb}else{Ib=iob(yb)|0;Jb=yb}}else{f[Cb+12>>2]=Fb;Ib=1;Jb=Fb}Gb=Bb+2+Jb+Ib|0;Hb=f[qa>>2]|0}if(!(Hb&128)){Kb=Gb;Lb=Hb}else{Hb=PPa(f[a+272>>2]|0)|0;if(Hb>>>0<128)Mb=1;else Mb=iob(Hb)|0;Kb=Gb+2+Hb+Mb|0;Lb=f[qa>>2]|0}}else{Kb=$a;Lb=Va}if(Lb&1792){if(!(Lb&256)){Nb=Kb;Ob=Lb}else{Lb=QPa(f[a+276>>2]|0)|0;if(Lb>>>0<128)Pb=1;else Pb=iob(Lb)|0;Nb=Kb+2+Lb+Pb|0;Ob=f[qa>>2]|0}if(!(Ob&512)){Qb=Nb;Rb=Ob}else{Ob=RPa(f[a+280>>2]|0)|0;if(Ob>>>0<128)Sb=1;else Sb=iob(Ob)|0;Qb=Nb+2+Ob+Sb|0;Rb=f[qa>>2]|0}if(!(Rb&1024))Tb=Qb;else{Rb=TNa(f[a+284>>2]|0)|0;if(Rb>>>0<128)Ub=1;else Ub=iob(Rb)|0;Tb=Qb+1+Rb+Ub|0}}else Tb=Kb;Kb=a+20|0;Ub=f[Kb>>2]|0;Rb=Ub+Tb|0;if((Ub|0)>0){Tb=a+28|0;Qb=0;qa=Rb;Sb=Ub;while(1){Ub=f[(f[Tb>>2]|0)+4+(Qb<<2)>>2]|0;Ob=b[Ub+11>>0]|0;if(Ob<<24>>24<0){Nb=f[Ub+4>>2]|0;if(Nb>>>0<128){Vb=1;Wb=Nb;Xb=Sb}else{Ub=iob(Nb)|0;Vb=Ub;Wb=Nb;Xb=f[Kb>>2]|0}}else{Vb=1;Wb=Ob&255;Xb=Sb}Ob=Wb+qa+Vb|0;Qb=Qb+1|0;if((Qb|0)>=(Xb|0)){Yb=Ob;break}else{qa=Ob;Sb=Xb}}}else Yb=Rb;Rb=a+36|0;Xb=f[Rb>>2]|0;Sb=Xb+Yb|0;if((Xb|0)>0){Yb=a+44|0;qa=0;Qb=Sb;Vb=Xb;while(1){Xb=f[(f[Yb>>2]|0)+4+(qa<<2)>>2]|0;Wb=b[Xb+11>>0]|0;if(Wb<<24>>24<0){Kb=f[Xb+4>>2]|0;if(Kb>>>0<128){Zb=1;_b=Kb;$b=Vb}else{Xb=iob(Kb)|0;Zb=Xb;_b=Kb;$b=f[Rb>>2]|0}}else{Zb=1;_b=Wb&255;$b=Vb}Wb=_b+Qb+Zb|0;qa=qa+1|0;if((qa|0)>=($b|0)){ac=Wb;break}else{Qb=Wb;Vb=$b}}}else ac=Sb;Sb=f[a+52>>2]|0;$b=(Sb<<1)+ac|0;if(!Sb)bc=$b;else{ac=a+60|0;Vb=0;Qb=$b;while(1){$b=SPa(f[(f[ac>>2]|0)+4+(Vb<<2)>>2]|0)|0;if($b>>>0<128)cc=1;else cc=iob($b)|0;qa=$b+Qb+cc|0;Vb=Vb+1|0;if((Vb|0)==(Sb|0)){bc=qa;break}else Qb=qa}}Qb=f[a+68>>2]|0;Sb=(Qb<<1)+bc|0;if(!Qb)dc=Sb;else{bc=a+76|0;Vb=0;cc=Sb;while(1){Sb=SPa(f[(f[bc>>2]|0)+4+(Vb<<2)>>2]|0)|0;if(Sb>>>0<128)ec=1;else ec=iob(Sb)|0;ac=Sb+cc+ec|0;Vb=Vb+1|0;if((Vb|0)==(Qb|0)){dc=ac;break}else cc=ac}}cc=f[a+84>>2]|0;Qb=cc+dc|0;if(!cc)fc=Qb;else{dc=a+92|0;Vb=0;ec=Qb;while(1){Qb=gOa(f[(f[dc>>2]|0)+4+(Vb<<2)>>2]|0)|0;if(Qb>>>0<128)gc=1;else gc=iob(Qb)|0;bc=Qb+ec+gc|0;Vb=Vb+1|0;if((Vb|0)==(cc|0)){fc=bc;break}else ec=bc}}ec=a+100|0;cc=f[ec>>2]|0;Vb=(cc<<1)+fc|0;if((cc|0)>0){fc=a+108|0;gc=0;dc=Vb;bc=cc;while(1){cc=f[(f[fc>>2]|0)+4+(gc<<2)>>2]|0;Qb=b[cc+11>>0]|0;if(Qb<<24>>24<0){ac=f[cc+4>>2]|0;if(ac>>>0<128){hc=1;ic=ac;jc=bc}else{cc=iob(ac)|0;hc=cc;ic=ac;jc=f[ec>>2]|0}}else{hc=1;ic=Qb&255;jc=bc}Qb=ic+dc+hc|0;gc=gc+1|0;if((gc|0)>=(jc|0)){kc=Qb;break}else{dc=Qb;bc=jc}}}else kc=Vb;Vb=f[a+112>>2]|0;if(!Vb)lc=0;else{jc=a+120|0;bc=0;dc=0;while(1){gc=f[(f[jc>>2]|0)+4+(bc<<2)>>2]|0;if((gc|0)>=0)if(gc>>>0<128)mc=1;else mc=iob(gc)|0;else mc=10;gc=mc+dc|0;bc=bc+1|0;if((bc|0)==(Vb|0)){lc=gc;break}else dc=gc}}dc=f[a+124>>2]|0;bc=f[a+136>>2]|0;mc=f[a+148>>2]|0;jc=lc+kc+dc+bc+(mc<<2)+(bc+dc<<2)+(mc+Vb<<1)|0;Vb=f[a+4>>2]|0;if(!(Vb&1)){nc=jc;oc=a+292|0;f[oc>>2]=nc;return nc|0}nc=(dQb(Vb&-2)|0)+jc|0;oc=a+292|0;f[oc>>2]=nc;return nc|0}function uOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+12|0;if(f[c>>2]&1024|0)eqb(1,f[a+284>>2]|0,b);d=a+20|0;if((f[d>>2]|0)>0){e=a+28|0;g=0;do{_pb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)<(f[d>>2]|0))}d=a+36|0;if((f[d>>2]|0)>0){g=a+44|0;e=0;do{_pb(3,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)<(f[d>>2]|0))}d=a+8|0;e=f[d>>2]|0;if(!(e&4))h=e;else{$pb(4,f[a+160>>2]|0,b);h=f[d>>2]|0}if(h&32|0)Zpb(5,f[a+288>>2]|0,b);h=f[a+84>>2]|0;if(h|0){e=a+92|0;g=0;do{eqb(6,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(h|0))}h=a+124|0;if((f[h>>2]|0)>0){g=a+132|0;e=0;do{Wpb(7,+n[(f[g>>2]|0)+4+(e<<2)>>2],b);e=e+1|0}while((e|0)<(f[h>>2]|0))}h=a+136|0;if((f[h>>2]|0)>0){e=a+144|0;g=0;do{Wpb(8,+n[(f[e>>2]|0)+4+(g<<2)>>2],b);g=g+1|0}while((g|0)<(f[h>>2]|0))}h=f[d>>2]|0;if(!(h&16384))i=h;else{eqb(9,f[a+172>>2]|0,b);i=f[d>>2]|0}if(!(i&65536))j=i;else{eqb(10,f[a+180>>2]|0,b);j=f[d>>2]|0}if(!(j&131072))k=j;else{eqb(11,f[a+184>>2]|0,b);k=f[d>>2]|0}if(!(k&262144))l=k;else{eqb(12,f[a+188>>2]|0,b);l=f[d>>2]|0}if(!(l&4194304))m=l;else{eqb(13,f[a+204>>2]|0,b);m=f[d>>2]|0}if(!(m&8388608))o=m;else{eqb(14,f[a+208>>2]|0,b);o=f[d>>2]|0}if(!(o&33554432))p=o;else{eqb(15,f[a+216>>2]|0,b);p=f[d>>2]|0}if(!(p&67108864))q=p;else{eqb(16,f[a+220>>2]|0,b);q=f[d>>2]|0}if(!(q&134217728))r=q;else{eqb(17,f[a+224>>2]|0,b);r=f[d>>2]|0}if(!(r&268435456))s=r;else{eqb(18,f[a+228>>2]|0,b);s=f[d>>2]|0}if((s|0)<0)eqb(19,f[a+240>>2]|0,b);s=f[c>>2]|0;if(!(s&128))t=s;else{eqb(20,f[a+272>>2]|0,b);t=f[c>>2]|0}if(t&1|0)eqb(21,f[a+244>>2]|0,b);t=f[d>>2]|0;if(!(t&536870912))u=t;else{eqb(22,f[a+232>>2]|0,b);u=f[d>>2]|0}if(!(u&8192))v=u;else{eqb(23,f[a+168>>2]|0,b);v=f[d>>2]|0}if(v&1048576|0)eqb(24,f[a+196>>2]|0,b);if(f[c>>2]&64|0)eqb(25,f[a+268>>2]|0,b);v=f[d>>2]|0;if(!(v&524288))w=v;else{eqb(26,f[a+192>>2]|0,b);w=f[d>>2]|0}if(!(w&4096))x=w;else{eqb(27,f[a+164>>2]|0,b);x=f[d>>2]|0}if(x&16777216|0)eqb(29,f[a+212>>2]|0,b);x=f[c>>2]|0;if(!(x&2))y=x;else{eqb(30,f[a+248>>2]|0,b);y=f[c>>2]|0}if(y&16|0)eqb(31,f[a+260>>2]|0,b);y=f[a+52>>2]|0;if(y|0){x=a+60|0;w=0;do{eqb(32,f[(f[x>>2]|0)+4+(w<<2)>>2]|0,b);w=w+1|0}while((w|0)!=(y|0))}y=f[a+68>>2]|0;if(y|0){w=a+76|0;x=0;do{eqb(33,f[(f[w>>2]|0)+4+(x<<2)>>2]|0,b);x=x+1|0}while((x|0)!=(y|0))}if(f[d>>2]&1073741824|0)eqb(34,f[a+236>>2]|0,b);y=a+148|0;if((f[y>>2]|0)>0){x=a+156|0;w=0;do{Wpb(35,+n[(f[x>>2]|0)+4+(w<<2)>>2],b);w=w+1|0}while((w|0)<(f[y>>2]|0))}y=f[c>>2]|0;if(!(y&256))z=y;else{eqb(36,f[a+276>>2]|0,b);z=f[c>>2]|0}if(!(z&32))A=z;else{eqb(37,f[a+264>>2]|0,b);A=f[c>>2]|0}if(!(A&4))B=A;else{eqb(38,f[a+252>>2]|0,b);B=f[c>>2]|0}if(B&8|0)eqb(39,f[a+256>>2]|0,b);B=f[d>>2]|0;if(!(B&32768))C=B;else{eqb(40,f[a+176>>2]|0,b);C=f[d>>2]|0}if(C&2097152|0)eqb(41,f[a+200>>2]|0,b);if(f[c>>2]&512|0)eqb(42,f[a+280>>2]|0,b);c=a+100|0;if((f[c>>2]|0)>0){C=a+108|0;d=0;do{_pb(1001,f[(f[C>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)<(f[c>>2]|0))}c=a+112|0;if((f[c>>2]|0)>0){d=a+120|0;C=0;do{Zpb(1002,f[(f[d>>2]|0)+4+(C<<2)>>2]|0,b);C=C+1|0}while((C|0)<(f[c>>2]|0))}c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function vOa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function wOa(a){a=a|0;return f[a+292>>2]|0}function xOa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0;c=a+12|0;if(!(f[c>>2]&1024))e=d;else{g=f[a+284>>2]|0;b[d>>0]=10;h=d+1|0;d=f[g+192>>2]|0;if(d>>>0>127){i=d;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=d}b[m>>0]=n;e=li[f[(f[g>>2]|0)+68>>2]&511](g,0,m+1|0)|0}m=a+20|0;if((f[m>>2]|0)>0){g=a+28|0;n=0;d=e;while(1){h=f[(f[g>>2]|0)+4+(n<<2)>>2]|0;b[d>>0]=18;j=kob(h,d+1|0)|0;n=n+1|0;if((n|0)>=(f[m>>2]|0)){o=j;break}else d=j}}else o=e;e=a+36|0;if((f[e>>2]|0)>0){d=a+44|0;m=0;n=o;while(1){g=f[(f[d>>2]|0)+4+(m<<2)>>2]|0;b[n>>0]=26;j=kob(g,n+1|0)|0;m=m+1|0;if((m|0)>=(f[e>>2]|0)){p=j;break}else n=j}}else p=o;o=a+8|0;n=f[o>>2]|0;if(!(n&4)){q=p;r=n}else{n=f[a+160>>2]|0;b[p>>0]=34;e=kob(n,p+1|0)|0;q=e;r=f[o>>2]|0}do if(!(r&32))s=q;else{e=f[a+288>>2]|0;b[q>>0]=40;p=q+1|0;if((e|0)<0){s=hob(e,((e|0)<0)<<31>>31,p)|0;break}if(e>>>0>127){n=e;m=p;while(1){b[m>>0]=n|128;d=n>>>7;j=m+1|0;if(n>>>0>16383){n=d;m=j}else{t=j;u=d;break}}}else{t=p;u=e}b[t>>0]=u;s=t+1|0}while(0);t=f[a+84>>2]|0;if(!t)v=s;else{u=a+92|0;q=0;r=s;while(1){s=f[(f[u>>2]|0)+4+(q<<2)>>2]|0;b[r>>0]=50;m=r+1|0;n=f[s+12>>2]|0;if(n>>>0>127){d=n;j=m;while(1){b[j>>0]=d|128;g=d>>>7;h=j+1|0;if(d>>>0>16383){d=g;j=h}else{w=h;x=g;break}}}else{w=m;x=n}b[w>>0]=x;j=li[f[(f[s>>2]|0)+68>>2]&511](s,0,w+1|0)|0;q=q+1|0;if((q|0)==(t|0)){v=j;break}else r=j}}r=a+124|0;if((f[r>>2]|0)>0){t=a+132|0;q=0;w=v;while(1){x=f[(f[t>>2]|0)+4+(q<<2)>>2]|0;b[w>>0]=61;u=w+1|0;b[u>>0]=x;b[u+1>>0]=x>>8;b[u+2>>0]=x>>16;b[u+3>>0]=x>>24;x=w+5|0;q=q+1|0;if((q|0)>=(f[r>>2]|0)){y=x;break}else w=x}}else y=v;v=a+136|0;if((f[v>>2]|0)>0){w=a+144|0;r=0;q=y;while(1){t=f[(f[w>>2]|0)+4+(r<<2)>>2]|0;b[q>>0]=69;x=q+1|0;b[x>>0]=t;b[x+1>>0]=t>>8;b[x+2>>0]=t>>16;b[x+3>>0]=t>>24;t=q+5|0;r=r+1|0;if((r|0)>=(f[v>>2]|0)){z=t;break}else q=t}}else z=y;y=f[o>>2]|0;if(!(y&16384)){A=z;B=y}else{y=f[a+172>>2]|0;b[z>>0]=74;q=z+1|0;z=f[y+12>>2]|0;if(z>>>0>127){v=z;r=q;while(1){b[r>>0]=v|128;w=v>>>7;t=r+1|0;if(v>>>0>16383){v=w;r=t}else{C=t;D=w;break}}}else{C=q;D=z}b[C>>0]=D;D=li[f[(f[y>>2]|0)+68>>2]&511](y,0,C+1|0)|0;A=D;B=f[o>>2]|0}if(!(B&65536)){E=A;F=B}else{B=f[a+180>>2]|0;b[A>>0]=82;D=A+1|0;A=f[B+12>>2]|0;if(A>>>0>127){C=A;y=D;while(1){b[y>>0]=C|128;z=C>>>7;q=y+1|0;if(C>>>0>16383){C=z;y=q}else{G=q;H=z;break}}}else{G=D;H=A}b[G>>0]=H;H=li[f[(f[B>>2]|0)+68>>2]&511](B,0,G+1|0)|0;E=H;F=f[o>>2]|0}if(!(F&131072)){I=E;J=F}else{F=f[a+184>>2]|0;b[E>>0]=90;H=E+1|0;E=f[F+12>>2]|0;if(E>>>0>127){G=E;B=H;while(1){b[B>>0]=G|128;A=G>>>7;D=B+1|0;if(G>>>0>16383){G=A;B=D}else{K=D;L=A;break}}}else{K=H;L=E}b[K>>0]=L;L=li[f[(f[F>>2]|0)+68>>2]&511](F,0,K+1|0)|0;I=L;J=f[o>>2]|0}if(!(J&262144)){M=I;N=J}else{J=f[a+188>>2]|0;b[I>>0]=98;L=I+1|0;I=f[J+12>>2]|0;if(I>>>0>127){K=I;F=L;while(1){b[F>>0]=K|128;E=K>>>7;H=F+1|0;if(K>>>0>16383){K=E;F=H}else{O=H;P=E;break}}}else{O=L;P=I}b[O>>0]=P;P=li[f[(f[J>>2]|0)+68>>2]&511](J,0,O+1|0)|0;M=P;N=f[o>>2]|0}if(!(N&4194304)){Q=M;R=N}else{N=f[a+204>>2]|0;b[M>>0]=106;P=M+1|0;M=f[N+12>>2]|0;if(M>>>0>127){O=M;J=P;while(1){b[J>>0]=O|128;I=O>>>7;L=J+1|0;if(O>>>0>16383){O=I;J=L}else{S=L;T=I;break}}}else{S=P;T=M}b[S>>0]=T;T=li[f[(f[N>>2]|0)+68>>2]&511](N,0,S+1|0)|0;Q=T;R=f[o>>2]|0}if(!(R&8388608)){U=Q;V=R}else{R=f[a+208>>2]|0;b[Q>>0]=114;T=Q+1|0;Q=f[R+12>>2]|0;if(Q>>>0>127){S=Q;N=T;while(1){b[N>>0]=S|128;M=S>>>7;P=N+1|0;if(S>>>0>16383){S=M;N=P}else{W=P;X=M;break}}}else{W=T;X=Q}b[W>>0]=X;X=li[f[(f[R>>2]|0)+68>>2]&511](R,0,W+1|0)|0;U=X;V=f[o>>2]|0}if(!(V&33554432)){Y=U;Z=V}else{V=f[a+216>>2]|0;b[U>>0]=122;X=U+1|0;U=f[V+12>>2]|0;if(U>>>0>127){W=U;R=X;while(1){b[R>>0]=W|128;Q=W>>>7;T=R+1|0;if(W>>>0>16383){W=Q;R=T}else{_=T;$=Q;break}}}else{_=X;$=U}b[_>>0]=$;$=li[f[(f[V>>2]|0)+68>>2]&511](V,0,_+1|0)|0;Y=$;Z=f[o>>2]|0}if(!(Z&67108864)){aa=Y;ba=Z}else{Z=f[a+220>>2]|0;b[Y>>0]=-126;b[Y+1>>0]=1;$=Y+2|0;Y=f[Z+12>>2]|0;if(Y>>>0>127){_=Y;V=$;while(1){b[V>>0]=_|128;U=_>>>7;X=V+1|0;if(_>>>0>16383){_=U;V=X}else{ca=X;da=U;break}}}else{ca=$;da=Y}b[ca>>0]=da;da=li[f[(f[Z>>2]|0)+68>>2]&511](Z,0,ca+1|0)|0;aa=da;ba=f[o>>2]|0}if(!(ba&134217728)){ea=aa;fa=ba}else{ba=f[a+224>>2]|0;b[aa>>0]=-118;b[aa+1>>0]=1;da=aa+2|0;aa=f[ba+12>>2]|0;if(aa>>>0>127){ca=aa;Z=da;while(1){b[Z>>0]=ca|128;Y=ca>>>7;$=Z+1|0;if(ca>>>0>16383){ca=Y;Z=$}else{ga=$;ha=Y;break}}}else{ga=da;ha=aa}b[ga>>0]=ha;ha=li[f[(f[ba>>2]|0)+68>>2]&511](ba,0,ga+1|0)|0;ea=ha;fa=f[o>>2]|0}if(!(fa&268435456)){ia=ea;ja=fa}else{fa=f[a+228>>2]|0;b[ea>>0]=-110;b[ea+1>>0]=1;ha=ea+2|0;ea=f[fa+12>>2]|0;if(ea>>>0>127){ga=ea;ba=ha;while(1){b[ba>>0]=ga|128;aa=ga>>>7;da=ba+1|0;if(ga>>>0>16383){ga=aa;ba=da}else{ka=da;la=aa;break}}}else{ka=ha;la=ea}b[ka>>0]=la;la=li[f[(f[fa>>2]|0)+68>>2]&511](fa,0,ka+1|0)|0;ia=la;ja=f[o>>2]|0}if((ja|0)<0){ja=f[a+240>>2]|0;b[ia>>0]=-102;b[ia+1>>0]=1;la=ia+2|0;ka=f[ja+12>>2]|0;if(ka>>>0>127){fa=ka;ea=la;while(1){b[ea>>0]=fa|128;ha=fa>>>7;ba=ea+1|0;if(fa>>>0>16383){fa=ha;ea=ba}else{ma=ba;na=ha;break}}}else{ma=la;na=ka}b[ma>>0]=na;oa=li[f[(f[ja>>2]|0)+68>>2]&511](ja,0,ma+1|0)|0}else oa=ia;ia=f[c>>2]|0;if(!(ia&128)){pa=oa;qa=ia}else{ia=f[a+272>>2]|0;b[oa>>0]=-94;b[oa+1>>0]=1;ma=oa+2|0;oa=f[ia+12>>2]|0;if(oa>>>0>127){ja=oa;na=ma;while(1){b[na>>0]=ja|128;ka=ja>>>7;la=na+1|0;if(ja>>>0>16383){ja=ka;na=la}else{ra=la;sa=ka;break}}}else{ra=ma;sa=oa}b[ra>>0]=sa;sa=li[f[(f[ia>>2]|0)+68>>2]&511](ia,0,ra+1|0)|0;pa=sa;qa=f[c>>2]|0}if(!(qa&1))ta=pa;else{qa=f[a+244>>2]|0;b[pa>>0]=-86;b[pa+1>>0]=1;sa=pa+2|0;pa=f[qa+12>>2]|0;if(pa>>>0>127){ra=pa;ia=sa;while(1){b[ia>>0]=ra|128;oa=ra>>>7;ma=ia+1|0;if(ra>>>0>16383){ra=oa;ia=ma}else{ua=ma;va=oa;break}}}else{ua=sa;va=pa}b[ua>>0]=va;ta=li[f[(f[qa>>2]|0)+68>>2]&511](qa,0,ua+1|0)|0}ua=f[o>>2]|0;if(!(ua&536870912)){wa=ta;xa=ua}else{ua=f[a+232>>2]|0;b[ta>>0]=-78;b[ta+1>>0]=1;qa=ta+2|0;ta=f[ua+12>>2]|0;if(ta>>>0>127){va=ta;pa=qa;while(1){b[pa>>0]=va|128;sa=va>>>7;ia=pa+1|0;if(va>>>0>16383){va=sa;pa=ia}else{ya=ia;za=sa;break}}}else{ya=qa;za=ta}b[ya>>0]=za;za=li[f[(f[ua>>2]|0)+68>>2]&511](ua,0,ya+1|0)|0;wa=za;xa=f[o>>2]|0}if(!(xa&8192)){Aa=wa;Ba=xa}else{xa=f[a+168>>2]|0;b[wa>>0]=-70;b[wa+1>>0]=1;za=wa+2|0;wa=f[xa+12>>2]|0;if(wa>>>0>127){ya=wa;ua=za;while(1){b[ua>>0]=ya|128;ta=ya>>>7;qa=ua+1|0;if(ya>>>0>16383){ya=ta;ua=qa}else{Ca=qa;Da=ta;break}}}else{Ca=za;Da=wa}b[Ca>>0]=Da;Da=li[f[(f[xa>>2]|0)+68>>2]&511](xa,0,Ca+1|0)|0;Aa=Da;Ba=f[o>>2]|0}if(!(Ba&1048576))Ea=Aa;else{Ba=f[a+196>>2]|0;b[Aa>>0]=-62;b[Aa+1>>0]=1;Da=Aa+2|0;Aa=f[Ba+12>>2]|0;if(Aa>>>0>127){Ca=Aa;xa=Da;while(1){b[xa>>0]=Ca|128;wa=Ca>>>7;za=xa+1|0;if(Ca>>>0>16383){Ca=wa;xa=za}else{Fa=za;Ga=wa;break}}}else{Fa=Da;Ga=Aa}b[Fa>>0]=Ga;Ea=li[f[(f[Ba>>2]|0)+68>>2]&511](Ba,0,Fa+1|0)|0}if(!(f[c>>2]&64))Ha=Ea;else{Fa=f[a+268>>2]|0;b[Ea>>0]=-54;b[Ea+1>>0]=1;Ba=Ea+2|0;Ea=f[Fa+12>>2]|0;if(Ea>>>0>127){Ga=Ea;Aa=Ba;while(1){b[Aa>>0]=Ga|128;Da=Ga>>>7;xa=Aa+1|0;if(Ga>>>0>16383){Ga=Da;Aa=xa}else{Ia=xa;Ja=Da;break}}}else{Ia=Ba;Ja=Ea}b[Ia>>0]=Ja;Ha=li[f[(f[Fa>>2]|0)+68>>2]&511](Fa,0,Ia+1|0)|0}Ia=f[o>>2]|0;if(!(Ia&524288)){Ka=Ha;La=Ia}else{Ia=f[a+192>>2]|0;b[Ha>>0]=-46;b[Ha+1>>0]=1;Fa=Ha+2|0;Ha=f[Ia+12>>2]|0;if(Ha>>>0>127){Ja=Ha;Ea=Fa;while(1){b[Ea>>0]=Ja|128;Ba=Ja>>>7;Aa=Ea+1|0;if(Ja>>>0>16383){Ja=Ba;Ea=Aa}else{Ma=Aa;Na=Ba;break}}}else{Ma=Fa;Na=Ha}b[Ma>>0]=Na;Na=li[f[(f[Ia>>2]|0)+68>>2]&511](Ia,0,Ma+1|0)|0;Ka=Na;La=f[o>>2]|0}if(!(La&4096)){Oa=Ka;Pa=La}else{La=f[a+164>>2]|0;b[Ka>>0]=-38;b[Ka+1>>0]=1;Na=Ka+2|0;Ka=f[La+12>>2]|0;if(Ka>>>0>127){Ma=Ka;Ia=Na;while(1){b[Ia>>0]=Ma|128;Ha=Ma>>>7;Fa=Ia+1|0;if(Ma>>>0>16383){Ma=Ha;Ia=Fa}else{Qa=Fa;Ra=Ha;break}}}else{Qa=Na;Ra=Ka}b[Qa>>0]=Ra;Ra=li[f[(f[La>>2]|0)+68>>2]&511](La,0,Qa+1|0)|0;Oa=Ra;Pa=f[o>>2]|0}if(!(Pa&16777216))Sa=Oa;else{Pa=f[a+212>>2]|0;b[Oa>>0]=-22;b[Oa+1>>0]=1;Ra=Oa+2|0;Oa=f[Pa+12>>2]|0;if(Oa>>>0>127){Qa=Oa;La=Ra;while(1){b[La>>0]=Qa|128;Ka=Qa>>>7;Na=La+1|0;if(Qa>>>0>16383){Qa=Ka;La=Na}else{Ta=Na;Ua=Ka;break}}}else{Ta=Ra;Ua=Oa}b[Ta>>0]=Ua;Sa=li[f[(f[Pa>>2]|0)+68>>2]&511](Pa,0,Ta+1|0)|0}Ta=f[c>>2]|0;if(!(Ta&2)){Va=Sa;Wa=Ta}else{Ta=f[a+248>>2]|0;b[Sa>>0]=-14;b[Sa+1>>0]=1;Pa=Sa+2|0;Sa=f[Ta+12>>2]|0;if(Sa>>>0>127){Ua=Sa;Oa=Pa;while(1){b[Oa>>0]=Ua|128;Ra=Ua>>>7;La=Oa+1|0;if(Ua>>>0>16383){Ua=Ra;Oa=La}else{Xa=La;Ya=Ra;break}}}else{Xa=Pa;Ya=Sa}b[Xa>>0]=Ya;Ya=li[f[(f[Ta>>2]|0)+68>>2]&511](Ta,0,Xa+1|0)|0;Va=Ya;Wa=f[c>>2]|0}if(!(Wa&16))Za=Va;else{Wa=f[a+260>>2]|0;b[Va>>0]=-6;b[Va+1>>0]=1;Ya=Va+2|0;Va=f[Wa+12>>2]|0;if(Va>>>0>127){Xa=Va;Ta=Ya;while(1){b[Ta>>0]=Xa|128;Sa=Xa>>>7;Pa=Ta+1|0;if(Xa>>>0>16383){Xa=Sa;Ta=Pa}else{_a=Pa;$a=Sa;break}}}else{_a=Ya;$a=Va}b[_a>>0]=$a;Za=li[f[(f[Wa>>2]|0)+68>>2]&511](Wa,0,_a+1|0)|0}_a=f[a+52>>2]|0;if(!_a)ab=Za;else{Wa=a+60|0;$a=0;Va=Za;while(1){Za=f[(f[Wa>>2]|0)+4+($a<<2)>>2]|0;b[Va>>0]=-126;b[Va+1>>0]=2;Ya=Va+2|0;Ta=f[Za+12>>2]|0;if(Ta>>>0>127){Xa=Ta;Sa=Ya;while(1){b[Sa>>0]=Xa|128;Pa=Xa>>>7;Oa=Sa+1|0;if(Xa>>>0>16383){Xa=Pa;Sa=Oa}else{bb=Oa;cb=Pa;break}}}else{bb=Ya;cb=Ta}b[bb>>0]=cb;Sa=li[f[(f[Za>>2]|0)+68>>2]&511](Za,0,bb+1|0)|0;$a=$a+1|0;if(($a|0)==(_a|0)){ab=Sa;break}else Va=Sa}}Va=f[a+68>>2]|0;if(!Va)db=ab;else{_a=a+76|0;$a=0;bb=ab;while(1){ab=f[(f[_a>>2]|0)+4+($a<<2)>>2]|0;b[bb>>0]=-118;b[bb+1>>0]=2;cb=bb+2|0;Wa=f[ab+12>>2]|0;if(Wa>>>0>127){Sa=Wa;Xa=cb;while(1){b[Xa>>0]=Sa|128;s=Sa>>>7;n=Xa+1|0;if(Sa>>>0>16383){Sa=s;Xa=n}else{eb=n;fb=s;break}}}else{eb=cb;fb=Wa}b[eb>>0]=fb;Xa=li[f[(f[ab>>2]|0)+68>>2]&511](ab,0,eb+1|0)|0;$a=$a+1|0;if(($a|0)==(Va|0)){db=Xa;break}else bb=Xa}}if(!(f[o>>2]&1073741824))gb=db;else{bb=f[a+236>>2]|0;b[db>>0]=-110;b[db+1>>0]=2;Va=db+2|0;db=f[bb+12>>2]|0;if(db>>>0>127){$a=db;eb=Va;while(1){b[eb>>0]=$a|128;fb=$a>>>7;_a=eb+1|0;if($a>>>0>16383){$a=fb;eb=_a}else{hb=_a;ib=fb;break}}}else{hb=Va;ib=db}b[hb>>0]=ib;gb=li[f[(f[bb>>2]|0)+68>>2]&511](bb,0,hb+1|0)|0}hb=a+148|0;if((f[hb>>2]|0)>0){bb=a+156|0;ib=0;db=gb;while(1){Va=f[(f[bb>>2]|0)+4+(ib<<2)>>2]|0;b[db>>0]=-99;b[db+1>>0]=2;eb=db+2|0;b[eb>>0]=Va;b[eb+1>>0]=Va>>8;b[eb+2>>0]=Va>>16;b[eb+3>>0]=Va>>24;Va=db+6|0;ib=ib+1|0;if((ib|0)>=(f[hb>>2]|0)){jb=Va;break}else db=Va}}else jb=gb;gb=f[c>>2]|0;if(!(gb&256)){kb=jb;lb=gb}else{gb=f[a+276>>2]|0;b[jb>>0]=-94;b[jb+1>>0]=2;db=jb+2|0;jb=f[gb+12>>2]|0;if(jb>>>0>127){hb=jb;ib=db;while(1){b[ib>>0]=hb|128;bb=hb>>>7;Va=ib+1|0;if(hb>>>0>16383){hb=bb;ib=Va}else{mb=Va;nb=bb;break}}}else{mb=db;nb=jb}b[mb>>0]=nb;nb=li[f[(f[gb>>2]|0)+68>>2]&511](gb,0,mb+1|0)|0;kb=nb;lb=f[c>>2]|0}if(!(lb&32)){ob=kb;pb=lb}else{lb=f[a+264>>2]|0;b[kb>>0]=-86;b[kb+1>>0]=2;nb=kb+2|0;kb=f[lb+12>>2]|0;if(kb>>>0>127){mb=kb;gb=nb;while(1){b[gb>>0]=mb|128;jb=mb>>>7;db=gb+1|0;if(mb>>>0>16383){mb=jb;gb=db}else{qb=db;rb=jb;break}}}else{qb=nb;rb=kb}b[qb>>0]=rb;rb=li[f[(f[lb>>2]|0)+68>>2]&511](lb,0,qb+1|0)|0;ob=rb;pb=f[c>>2]|0}if(!(pb&4)){sb=ob;tb=pb}else{pb=f[a+252>>2]|0;b[ob>>0]=-78;b[ob+1>>0]=2;rb=ob+2|0;ob=f[pb+12>>2]|0;if(ob>>>0>127){qb=ob;lb=rb;while(1){b[lb>>0]=qb|128;kb=qb>>>7;nb=lb+1|0;if(qb>>>0>16383){qb=kb;lb=nb}else{ub=nb;vb=kb;break}}}else{ub=rb;vb=ob}b[ub>>0]=vb;vb=li[f[(f[pb>>2]|0)+68>>2]&511](pb,0,ub+1|0)|0;sb=vb;tb=f[c>>2]|0}if(!(tb&8))wb=sb;else{tb=f[a+256>>2]|0;b[sb>>0]=-70;b[sb+1>>0]=2;vb=sb+2|0;sb=f[tb+12>>2]|0;if(sb>>>0>127){ub=sb;pb=vb;while(1){b[pb>>0]=ub|128;ob=ub>>>7;rb=pb+1|0;if(ub>>>0>16383){ub=ob;pb=rb}else{xb=rb;yb=ob;break}}}else{xb=vb;yb=sb}b[xb>>0]=yb;wb=li[f[(f[tb>>2]|0)+68>>2]&511](tb,0,xb+1|0)|0}xb=f[o>>2]|0;if(!(xb&32768)){zb=wb;Ab=xb}else{xb=f[a+176>>2]|0;b[wb>>0]=-62;b[wb+1>>0]=2;tb=wb+2|0;wb=f[xb+12>>2]|0;if(wb>>>0>127){yb=wb;sb=tb;while(1){b[sb>>0]=yb|128;vb=yb>>>7;pb=sb+1|0;if(yb>>>0>16383){yb=vb;sb=pb}else{Bb=pb;Cb=vb;break}}}else{Bb=tb;Cb=wb}b[Bb>>0]=Cb;Cb=li[f[(f[xb>>2]|0)+68>>2]&511](xb,0,Bb+1|0)|0;zb=Cb;Ab=f[o>>2]|0}if(!(Ab&2097152))Db=zb;else{Ab=f[a+200>>2]|0;b[zb>>0]=-54;b[zb+1>>0]=2;o=zb+2|0;zb=f[Ab+12>>2]|0;if(zb>>>0>127){Cb=zb;Bb=o;while(1){b[Bb>>0]=Cb|128;xb=Cb>>>7;wb=Bb+1|0;if(Cb>>>0>16383){Cb=xb;Bb=wb}else{Eb=wb;Fb=xb;break}}}else{Eb=o;Fb=zb}b[Eb>>0]=Fb;Db=li[f[(f[Ab>>2]|0)+68>>2]&511](Ab,0,Eb+1|0)|0}if(!(f[c>>2]&512))Gb=Db;else{c=f[a+280>>2]|0;b[Db>>0]=-46;b[Db+1>>0]=2;Eb=Db+2|0;Db=f[c+12>>2]|0;if(Db>>>0>127){Ab=Db;Fb=Eb;while(1){b[Fb>>0]=Ab|128;zb=Ab>>>7;o=Fb+1|0;if(Ab>>>0>16383){Ab=zb;Fb=o}else{Hb=o;Ib=zb;break}}}else{Hb=Eb;Ib=Db}b[Hb>>0]=Ib;Gb=li[f[(f[c>>2]|0)+68>>2]&511](c,0,Hb+1|0)|0}Hb=a+100|0;if((f[Hb>>2]|0)>0){c=a+108|0;Ib=0;Db=Gb;while(1){Eb=f[(f[c>>2]|0)+4+(Ib<<2)>>2]|0;b[Db>>0]=-54;b[Db+1>>0]=62;Fb=kob(Eb,Db+2|0)|0;Ib=Ib+1|0;if((Ib|0)>=(f[Hb>>2]|0)){Jb=Fb;break}else Db=Fb}}else Jb=Gb;Gb=a+112|0;if((f[Gb>>2]|0)>0){Db=a+120|0;Hb=0;Ib=Jb;while(1){c=f[(f[Db>>2]|0)+4+(Hb<<2)>>2]|0;b[Ib>>0]=-48;b[Ib+1>>0]=62;Fb=Ib+2|0;if((c|0)<0)Kb=hob(c,((c|0)<0)<<31>>31,Fb)|0;else{if(c>>>0>127){Eb=c;Ab=Fb;while(1){b[Ab>>0]=Eb|128;zb=Eb>>>7;o=Ab+1|0;if(Eb>>>0>16383){Eb=zb;Ab=o}else{Lb=o;Mb=zb;break}}}else{Lb=Fb;Mb=c}b[Lb>>0]=Mb;Kb=Lb+1|0}Hb=Hb+1|0;if((Hb|0)>=(f[Gb>>2]|0)){Nb=Kb;break}else Ib=Kb}}else Nb=Jb;Jb=f[a+4>>2]|0;if(!(Jb&1)){Ob=Nb;return Ob|0}Ob=bQb(Jb&-2,Nb)|0;return Ob|0}function yOa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function zOa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(48594);c=T6b(b,23288,18872,0)|0;if(!c){cOb(b,a);return}else{COa(a,c);return}}function AOa(a,b){a=a|0;b=b|0;f[a+292>>2]=b;return}function BOa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213186];f[a+4>>2]=f[213187];u=c;return}function COa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;d=u;u=u+16|0;e=d+8|0;g=d;h=d+4|0;UDa(a+16|0,c+16|0);UDa(a+32|0,c+32|0);DOa(a+48|0,c+48|0);DOa(a+64|0,c+64|0);bOa(a+80|0,c+80|0);UDa(a+96|0,c+96|0);i=a+112|0;j=c+112|0;k=f[j>>2]|0;if(k|0){nza(i,(f[i>>2]|0)+k|0);Vac((f[a+120>>2]|0)+4+(f[i>>2]<<2)|0,(f[c+120>>2]|0)+4|0,f[j>>2]<<2|0)|0;f[i>>2]=(f[i>>2]|0)+(f[j>>2]|0)}j=a+124|0;i=c+124|0;k=f[i>>2]|0;if(k|0){qza(j,(f[j>>2]|0)+k|0);Vac((f[a+132>>2]|0)+4+(f[j>>2]<<2)|0,(f[c+132>>2]|0)+4|0,f[i>>2]<<2|0)|0;f[j>>2]=(f[j>>2]|0)+(f[i>>2]|0)}i=a+136|0;j=c+136|0;k=f[j>>2]|0;if(k|0){qza(i,(f[i>>2]|0)+k|0);Vac((f[a+144>>2]|0)+4+(f[i>>2]<<2)|0,(f[c+144>>2]|0)+4|0,f[j>>2]<<2|0)|0;f[i>>2]=(f[i>>2]|0)+(f[j>>2]|0)}j=a+148|0;i=c+148|0;k=f[i>>2]|0;if(k|0){qza(j,(f[j>>2]|0)+k|0);Vac((f[a+156>>2]|0)+4+(f[j>>2]<<2)|0,(f[c+156>>2]|0)+4|0,f[i>>2]<<2|0)|0;f[j>>2]=(f[j>>2]|0)+(f[i>>2]|0)}i=c+8|0;j=f[i>>2]|0;if(j&1020){if(!(j&4))l=j;else{k=a+8|0;f[k>>2]=f[k>>2]|4;f[h>>2]=f[c+160>>2];f[e>>2]=f[h>>2];Anb(a+160|0,497760,e);l=f[i>>2]|0}if(!(l&32))m=l;else{l=f[c+288>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|32;f[a+288>>2]=l;m=f[i>>2]|0}}else m=j;if(m&1044480|0){if(m&4096|0){m=a+8|0;f[m>>2]=f[m>>2]|4096;m=a+164|0;j=f[m>>2]|0;if(!j){l=L5b(28)|0;EOa(l);f[m>>2]=l;n=l}else n=j;j=f[c+164>>2]|0;l=(j|0)==0?494648:j;if((l|0)==(n|0))jMa(23075);j=l+8|0;m=f[j>>2]|0;if(m&255|0){if(!(m&1))o=m;else{m=f[l+20>>2]|0;h=n+8|0;f[h>>2]=f[h>>2]|1;f[n+20>>2]=m;o=f[j>>2]|0}if(!(o&2))p=o;else{o=f[l+24>>2]|0;m=n+8|0;f[m>>2]=f[m>>2]|2;f[n+24>>2]=o;p=f[j>>2]|0}if(p&4|0){p=f[l+16>>2]|0;j=n+8|0;f[j>>2]=f[j>>2]|4;f[n+16>>2]=p}}p=f[l+4>>2]|0;if(p&1|0)LPb(p&-2,n+4|0)}if(f[i>>2]&8192|0){n=a+8|0;f[n>>2]=f[n>>2]|8192;n=a+168|0;p=f[n>>2]|0;if(!p){l=L5b(28)|0;FOa(l);f[n>>2]=l;q=l}else q=p;p=f[c+168>>2]|0;l=(p|0)==0?494688:p;if((l|0)==(q|0))jMa(23501);p=l+8|0;n=f[p>>2]|0;if(n&255|0){if(!(n&1))r=n;else{n=b[l+16>>0]|0;j=q+8|0;f[j>>2]=f[j>>2]|1;b[q+16>>0]=n;r=f[p>>2]|0}if(!(r&2))s=r;else{r=f[l+24>>2]|0;n=q+8|0;f[n>>2]=f[n>>2]|2;f[q+24>>2]=r;s=f[p>>2]|0}if(s&4|0){s=f[l+20>>2]|0;p=q+8|0;f[p>>2]=f[p>>2]|4;f[q+20>>2]=s}}s=f[l+4>>2]|0;if(s&1|0)LPb(s&-2,q+4|0)}if(f[i>>2]&16384|0){q=a+8|0;f[q>>2]=f[q>>2]|16384;q=a+172|0;s=f[q>>2]|0;if(!s){l=L5b(24)|0;GOa(l);f[q>>2]=l;t=l}else t=s;s=f[c+172>>2]|0;l=(s|0)==0?494728:s;if((l|0)==(t|0))jMa(23875);s=l+8|0;q=f[s>>2]|0;if(q&255|0){if(!(q&1))v=q;else{q=f[l+16>>2]|0;p=t+8|0;f[p>>2]=f[p>>2]|1;f[t+16>>2]=q;v=f[s>>2]|0}if(v&2|0){v=f[l+20>>2]|0;s=t+8|0;f[s>>2]=f[s>>2]|2;f[t+20>>2]=v}}v=f[l+4>>2]|0;if(v&1|0)LPb(v&-2,t+4|0)}if(f[i>>2]&32768|0){t=a+8|0;f[t>>2]=f[t>>2]|32768;t=a+176|0;v=f[t>>2]|0;if(!v){l=L5b(24)|0;HOa(l);f[t>>2]=l;w=l}else w=v;v=f[c+176>>2]|0;l=(v|0)==0?494840:v;if((l|0)==(w|0))jMa(25058);v=l+8|0;t=f[v>>2]|0;if(t&255|0){if(!(t&1))x=t;else{t=f[l+20>>2]|0;s=w+8|0;f[s>>2]=f[s>>2]|1;f[w+20>>2]=t;x=f[v>>2]|0}if(x&2|0){x=b[l+16>>0]|0;v=w+8|0;f[v>>2]=f[v>>2]|2;b[w+16>>0]=x}}x=f[l+4>>2]|0;if(x&1|0)LPb(x&-2,w+4|0)}}w=f[i>>2]|0;if(w&16711680){do if(w&65536){x=a+8|0;f[x>>2]=f[x>>2]|65536;x=a+180|0;l=f[x>>2]|0;if(!l){v=L5b(120)|0;IOa(v);f[x>>2]=v;y=v}else y=l;l=f[c+180>>2]|0;v=(l|0)==0?494872:l;if((v|0)==(y|0))jMa(26062);else{JOa(y,v);z=f[i>>2]|0;break}}else z=w;while(0);do if(z&131072){y=a+8|0;f[y>>2]=f[y>>2]|131072;y=a+184|0;v=f[y>>2]|0;if(!v){l=L5b(52)|0;KOa(l);f[y>>2]=l;A=l}else A=v;v=f[c+184>>2]|0;l=(v|0)==0?495040:v;if((l|0)==(A|0))jMa(27625);else{LOa(A,l);B=f[i>>2]|0;break}}else B=z;while(0);if(B&262144|0){B=a+8|0;f[B>>2]=f[B>>2]|262144;B=a+188|0;z=f[B>>2]|0;if(!z){A=L5b(24)|0;MOa(A);f[B>>2]=A;C=A}else C=z;z=f[c+188>>2]|0;A=(z|0)==0?495192:z;if((A|0)==(C|0))jMa(29494);z=A+8|0;B=f[z>>2]|0;if(B&255|0){if(!(B&1))D=B;else{B=f[A+16>>2]|0;l=C+8|0;f[l>>2]=f[l>>2]|1;f[C+16>>2]=B;D=f[z>>2]|0}if(D&2|0){D=b[A+20>>0]|0;z=C+8|0;f[z>>2]=f[z>>2]|2;b[C+20>>0]=D}}D=f[A+4>>2]|0;if(D&1|0)LPb(D&-2,C+4|0)}C=f[i>>2]|0;do if(C&524288){D=a+8|0;f[D>>2]=f[D>>2]|524288;D=a+192|0;A=f[D>>2]|0;if(!A){z=L5b(96)|0;NOa(z);f[D>>2]=z;E=z}else E=A;A=f[c+192>>2]|0;z=(A|0)==0?495224:A;if((z|0)==(E|0))jMa(30036);else{OOa(E,z);F=f[i>>2]|0;break}}else F=C;while(0);do if(F&1048576){C=a+8|0;f[C>>2]=f[C>>2]|1048576;C=a+196|0;E=f[C>>2]|0;if(!E){z=L5b(36)|0;POa(z);f[C>>2]=z;G=z}else G=E;E=f[c+196>>2]|0;z=(E|0)==0?495328:E;if((z|0)==(G|0))jMa(30586);else{QOa(G,z);H=f[i>>2]|0;break}}else H=F;while(0);if(H&2097152|0){H=a+8|0;f[H>>2]=f[H>>2]|2097152;H=a+200|0;F=f[H>>2]|0;if(!F){G=L5b(28)|0;ROa(G);f[H>>2]=G;I=G}else I=F;F=f[c+200>>2]|0;G=(F|0)==0?495456:F;if((G|0)==(I|0))jMa(31879);F=G+8|0;H=f[F>>2]|0;do if(H&255|0){if(!(H&1))J=H;else{z=f[G+20>>2]|0;E=I+8|0;f[E>>2]=f[E>>2]|1;f[I+20>>2]=z;J=f[F>>2]|0}if(!(J&2))K=J;else{z=f[G+24>>2]|0;E=I+8|0;f[E>>2]=f[E>>2]|2;f[I+24>>2]=z;K=f[F>>2]|0}if(!(K&4))break;z=f[G+16>>2]|0;E=I+8|0;f[E>>2]=f[E>>2]|4;f[I+16>>2]=z}while(0);K=f[G+4>>2]|0;if(K&1|0)LPb(K&-2,I+4|0)}I=f[i>>2]|0;if(!(I&4194304))L=I;else{I=a+8|0;f[I>>2]=f[I>>2]|4194304;I=a+204|0;K=f[I>>2]|0;if(!K){G=L5b(28)|0;SOa(G);f[I>>2]=G;M=G}else M=K;K=f[c+204>>2]|0;TOa(M,(K|0)==0?495528:K);L=f[i>>2]|0}if(!(L&8388608))N=L;else{L=a+8|0;f[L>>2]=f[L>>2]|8388608;L=a+208|0;K=f[L>>2]|0;if(!K){M=L5b(20)|0;cOa(M);f[L>>2]=M;O=M}else O=K;K=f[c+208>>2]|0;M=(K|0)==0?495568:K;if((M|0)==(O|0))jMa(33049);if(f[M+8>>2]&1|0){K=O+8|0;f[K>>2]=f[K>>2]|1;f[g>>2]=f[M+16>>2];f[e>>2]=f[g>>2];Anb(O+16|0,497760,e)}K=f[M+4>>2]|0;if(K&1|0)LPb(K&-2,O+4|0);N=f[i>>2]|0}}else N=w;do if(N>>>0>16777215){if(N&16777216|0){w=a+8|0;f[w>>2]=f[w>>2]|16777216;w=a+212|0;O=f[w>>2]|0;if(!O){K=L5b(20)|0;UOa(K);f[w>>2]=K;P=K}else P=O;O=f[c+212>>2]|0;K=(O|0)==0?495600:O;if((K|0)==(P|0))jMa(33386);if(f[K+8>>2]&1|0){O=f[K+16>>2]|0;w=P+8|0;f[w>>2]=f[w>>2]|1;f[P+16>>2]=O}O=f[K+4>>2]|0;if(O&1|0)LPb(O&-2,P+4|0)}O=f[i>>2]|0;do if(O&33554432){K=a+8|0;f[K>>2]=f[K>>2]|33554432;K=a+216|0;w=f[K>>2]|0;if(!w){M=L5b(60)|0;VOa(M);f[K>>2]=M;Q=M}else Q=w;w=f[c+216>>2]|0;M=(w|0)==0?495632:w;if((M|0)==(Q|0))jMa(34111);else{WOa(Q,M);R=f[i>>2]|0;break}}else R=O;while(0);if(!(R&67108864))S=R;else{O=a+8|0;f[O>>2]=f[O>>2]|67108864;O=a+220|0;M=f[O>>2]|0;if(!M){w=L5b(20)|0;XOa(w);f[O>>2]=w;T=w}else T=M;M=f[c+220>>2]|0;w=(M|0)==0?495704:M;if((w|0)==(T|0))jMa(34809);if(f[w+8>>2]&1|0){M=T+8|0;f[M>>2]=f[M>>2]|1;f[g>>2]=f[w+16>>2];f[e>>2]=f[g>>2];Anb(T+16|0,497760,e)}M=f[w+4>>2]|0;if(M&1|0)LPb(M&-2,T+4|0);S=f[i>>2]|0}do if(S&134217728){M=a+8|0;f[M>>2]=f[M>>2]|134217728;M=a+224|0;w=f[M>>2]|0;if(!w){O=L5b(36)|0;YOa(O);f[M>>2]=O;U=O}else U=w;w=f[c+224>>2]|0;O=(w|0)==0?495736:w;if((O|0)==(U|0))jMa(35327);else{ZOa(U,O);V=f[i>>2]|0;break}}else V=S;while(0);do if(V&268435456){O=a+8|0;f[O>>2]=f[O>>2]|268435456;O=a+228|0;w=f[O>>2]|0;if(!w){M=L5b(40)|0;_Oa(M);f[O>>2]=M;W=M}else W=w;w=f[c+228>>2]|0;M=(w|0)==0?495864:w;if((M|0)==(W|0))jMa(36728);else{$Oa(W,M);X=f[i>>2]|0;break}}else X=V;while(0);if(!(X&536870912))Y=X;else{M=a+8|0;f[M>>2]=f[M>>2]|536870912;M=a+232|0;w=f[M>>2]|0;if(!w){O=L5b(32)|0;aPa(O);f[M>>2]=O;Z=O}else Z=w;w=f[c+232>>2]|0;bPa(Z,(w|0)==0?495912:w);Y=f[i>>2]|0}if(!(Y&1073741824))_=Y;else{w=a+8|0;f[w>>2]=f[w>>2]|1073741824;w=a+236|0;O=f[w>>2]|0;if(!O){M=L5b(24)|0;cPa(M);f[w>>2]=M;$=M}else $=O;O=f[c+236>>2]|0;M=(O|0)==0?495952:O;if((M|0)==($|0))jMa(37702);O=M+8|0;w=f[O>>2]|0;do if(w&255|0){if(!(w&1))aa=w;else{K=b[M+17>>0]|0;L=$+8|0;f[L>>2]=f[L>>2]|1;b[$+17>>0]=K;aa=f[O>>2]|0}if(!(aa&2))ba=aa;else{K=b[M+16>>0]|0;L=$+8|0;f[L>>2]=f[L>>2]|2;b[$+16>>0]=K;ba=f[O>>2]|0}if(!(ba&4))break;K=f[M+20>>2]|0;L=$+8|0;f[L>>2]=f[L>>2]|4;f[$+20>>2]=K}while(0);O=f[M+4>>2]|0;if(O&1|0)LPb(O&-2,$+4|0);_=f[i>>2]|0}if((_|0)<0){O=a+8|0;f[O>>2]=f[O>>2]|-2147483648;O=a+240|0;w=f[O>>2]|0;if(!w){K=L5b(68)|0;dPa(K);f[O>>2]=K;ca=K}else ca=w;w=f[c+240>>2]|0;K=(w|0)==0?496016:w;if((K|0)==(ca|0))jMa(38829);else{ePa(ca,K);break}}}while(0);ca=c+12|0;_=f[ca>>2]|0;do if(_&255){if(_&1|0){i=a+12|0;f[i>>2]=f[i>>2]|1;i=a+244|0;$=f[i>>2]|0;if(!$){ba=L5b(28)|0;fPa(ba);f[i>>2]=ba;da=ba}else da=$;$=f[c+244>>2]|0;ba=($|0)==0?496096:$;if((ba|0)==(da|0))jMa(39516);$=ba+8|0;i=f[$>>2]|0;if(i&255|0){if(!(i&1))ea=i;else{i=f[ba+20>>2]|0;aa=da+8|0;f[aa>>2]=f[aa>>2]|1;f[da+20>>2]=i;ea=f[$>>2]|0}if(!(ea&2))fa=ea;else{i=f[ba+24>>2]|0;aa=da+8|0;f[aa>>2]=f[aa>>2]|2;f[da+24>>2]=i;fa=f[$>>2]|0}if(fa&4|0){$=f[ba+16>>2]|0;i=da+8|0;f[i>>2]=f[i>>2]|4;f[da+16>>2]=$}}$=f[ba+4>>2]|0;if($&1|0)LPb($&-2,da+4|0)}if(f[ca>>2]&2|0){$=a+12|0;f[$>>2]=f[$>>2]|2;$=a+248|0;ba=f[$>>2]|0;if(!ba){i=L5b(24)|0;gPa(i);f[$>>2]=i;ga=i}else ga=ba;ba=f[c+248>>2]|0;i=(ba|0)==0?496256:ba;if((i|0)==(ga|0))jMa(41588);ba=i+8|0;$=f[ba>>2]|0;if($&255|0){if(!($&1))ha=$;else{$=f[i+16>>2]|0;aa=ga+8|0;f[aa>>2]=f[aa>>2]|1;f[ga+16>>2]=$;ha=f[ba>>2]|0}if(ha&2|0){ba=f[i+20>>2]|0;$=ga+8|0;f[$>>2]=f[$>>2]|2;f[ga+20>>2]=ba}}ba=f[i+4>>2]|0;if(ba&1|0)LPb(ba&-2,ga+4|0)}if(f[ca>>2]&4|0){ba=a+12|0;f[ba>>2]=f[ba>>2]|4;ba=a+252|0;i=f[ba>>2]|0;if(!i){$=L5b(20)|0;hPa($);f[ba>>2]=$;ia=$}else ia=i;i=f[c+252>>2]|0;$=(i|0)==0?496376:i;if(($|0)==(ia|0))jMa(42952);if(f[$+8>>2]&1|0){i=f[$+16>>2]|0;ba=ia+8|0;f[ba>>2]=f[ba>>2]|1;f[ia+16>>2]=i}i=f[$+4>>2]|0;if(i&1|0)LPb(i&-2,ia+4|0)}if(f[ca>>2]&8|0){i=a+12|0;f[i>>2]=f[i>>2]|8;i=a+256|0;$=f[i>>2]|0;if(!$){ba=L5b(24)|0;iPa(ba);f[i>>2]=ba;ja=ba}else ja=$;$=f[c+256>>2]|0;ba=($|0)==0?496456:$;if((ba|0)==(ja|0))jMa(43724);$=ba+8|0;i=f[$>>2]|0;do if(i&255|0){if(!(i&1))ka=i;else{aa=f[ba+16>>2]|0;Y=ja+8|0;f[Y>>2]=f[Y>>2]|1;f[ja+16>>2]=aa;ka=f[$>>2]|0}if(!(ka&2))break;aa=f[ba+20>>2]|0;Y=ja+8|0;f[Y>>2]=f[Y>>2]|2;f[ja+20>>2]=aa}while(0);$=f[ba+4>>2]|0;if($&1|0)LPb($&-2,ja+4|0)}$=f[ca>>2]|0;do if($&16){i=a+12|0;f[i>>2]=f[i>>2]|16;i=a+260|0;M=f[i>>2]|0;if(!M){aa=L5b(36)|0;jPa(aa);f[i>>2]=aa;la=aa}else la=M;M=f[c+260>>2]|0;aa=(M|0)==0?496408:M;if((aa|0)==(la|0))jMa(43317);else{kPa(la,aa);ma=f[ca>>2]|0;break}}else ma=$;while(0);do if(ma&32|0){$=a+12|0;f[$>>2]=f[$>>2]|32;$=a+264|0;ba=f[$>>2]|0;if(!ba){aa=L5b(20)|0;lPa(aa);f[$>>2]=aa;na=aa}else na=ba;ba=f[c+264>>2]|0;aa=(ba|0)==0?496488:ba;if((aa|0)==(na|0))jMa(44061);if(f[aa+8>>2]&1|0){ba=f[aa+16>>2]|0;$=na+8|0;f[$>>2]=f[$>>2]|1;f[na+16>>2]=ba}ba=f[aa+4>>2]|0;if(!(ba&1))break;LPb(ba&-2,na+4|0)}while(0);do if(f[ca>>2]&64|0){ba=a+12|0;f[ba>>2]=f[ba>>2]|64;ba=a+268|0;aa=f[ba>>2]|0;if(!aa){$=L5b(20)|0;mPa($);f[ba>>2]=$;oa=$}else oa=aa;aa=f[c+268>>2]|0;$=(aa|0)==0?496552:aa;if(($|0)==(oa|0))jMa(44685);if(f[$+8>>2]&1|0){aa=f[$+16>>2]|0;ba=oa+8|0;f[ba>>2]=f[ba>>2]|1;f[oa+16>>2]=aa}aa=f[$+4>>2]|0;if(!(aa&1))break;LPb(aa&-2,oa+4|0)}while(0);aa=f[ca>>2]|0;if(aa&128){$=a+12|0;f[$>>2]=f[$>>2]|128;$=a+272|0;ba=f[$>>2]|0;if(!ba){M=L5b(64)|0;nPa(M);f[$>>2]=M;pa=M}else pa=ba;ba=f[c+272>>2]|0;M=(ba|0)==0?496584:ba;if((M|0)==(pa|0))jMa(45459);else{oPa(pa,M);qa=f[ca>>2]|0;break}}else qa=aa}else qa=_;while(0);do if(qa&65280|0){do if(qa&256){_=a+12|0;f[_>>2]=f[_>>2]|256;_=a+276|0;pa=f[_>>2]|0;if(!pa){oa=L5b(44)|0;pPa(oa);f[_>>2]=oa;ra=oa}else ra=pa;pa=f[c+276>>2]|0;oa=(pa|0)==0?494552:pa;if((oa|0)==(ra|0))jMa(22061);else{qPa(ra,oa);sa=f[ca>>2]|0;break}}else sa=qa;while(0);if(sa&512|0){oa=a+12|0;f[oa>>2]=f[oa>>2]|512;oa=a+280|0;pa=f[oa>>2]|0;if(!pa){_=L5b(28)|0;rPa(_);f[oa>>2]=_;ta=_}else ta=pa;pa=f[c+280>>2]|0;_=(pa|0)==0?494608:pa;if((_|0)==(ta|0))jMa(22665);pa=_+8|0;oa=f[pa>>2]|0;do if(oa&255|0){if(!(oa&1))ua=oa;else{na=f[_+16>>2]|0;ma=ta+8|0;f[ma>>2]=f[ma>>2]|1;f[ta+16>>2]=na;ua=f[pa>>2]|0}if(!(ua&2))va=ua;else{na=f[_+24>>2]|0;ma=ta+8|0;f[ma>>2]=f[ma>>2]|2;f[ta+24>>2]=na;va=f[pa>>2]|0}if(!(va&4))break;na=b[_+20>>0]|0;ma=ta+8|0;f[ma>>2]=f[ma>>2]|4;b[ta+20>>0]=na}while(0);pa=f[_+4>>2]|0;if(pa&1|0)LPb(pa&-2,ta+4|0)}if(f[ca>>2]&1024|0){pa=a+12|0;f[pa>>2]=f[pa>>2]|1024;pa=a+284|0;oa=f[pa>>2]|0;if(!oa){na=L5b(196)|0;jOa(na);f[pa>>2]=na;wa=na}else wa=oa;oa=f[c+284>>2]|0;na=(oa|0)==0?497e3:oa;if((na|0)==(wa|0))jMa(52327);else{aOa(wa,na);break}}}while(0);wa=f[c+4>>2]|0;if(!(wa&1)){u=d;return}LPb(wa&-2,a+4|0);u=d;return}function DOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{CPa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Hza(h,i)|0;CPa(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function EOa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=113184;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=494648?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;f[a+24>>2]=1;u=c;return}function FOa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=113292;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=494688?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=1;u=c;return}function GOa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=113400;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=494728?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=1;f[a+20>>2]=1;u=c;return}function HOa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=113724;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=494840?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;b[a+16>>0]=0;n[a+20>>2]=1.0;u=c;return}function IOa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=113832;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==494872;g=a+16|0;h=g+48|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;d=a+64|0;e=a+108|0;g=d;h=g+40|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));b[d+40>>0]=0;f[e>>2]=1;b[a+112>>0]=1;f[a+116>>2]=1;u=c;return}function JOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=a+16|0;e=c+16|0;g=f[e>>2]|0;if(g|0){rza(d,(f[d>>2]|0)+g|0);Vac((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[e>>2]|0)}e=a+28|0;d=c+28|0;g=f[d>>2]|0;if(g|0){rza(e,(f[e>>2]|0)+g|0);Vac((f[a+36>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+36>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[d>>2]|0)}d=a+40|0;e=c+40|0;g=f[e>>2]|0;if(g|0){rza(d,(f[d>>2]|0)+g|0);Vac((f[a+48>>2]|0)+4+(f[d>>2]<<2)|0,(f[c+48>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[e>>2]|0)}e=a+52|0;d=c+52|0;g=f[d>>2]|0;if(g|0){rza(e,(f[e>>2]|0)+g|0);Vac((f[a+60>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+60>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[d>>2]|0)}d=c+8|0;e=f[d>>2]|0;if(e&255){if(!(e&1))h=e;else{g=f[c+72>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|1;f[a+72>>2]=g;h=f[d>>2]|0}if(!(h&2))j=h;else{h=b[c+112>>0]|0;g=a+8|0;f[g>>2]=f[g>>2]|2;b[a+112>>0]=h;j=f[d>>2]|0}if(!(j&64))k=j;else{j=f[c+76>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|64;f[a+76>>2]=j;k=f[d>>2]|0}if(!(k&128))l=k;else{k=f[c+80>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|128;f[a+80>>2]=k;l=f[d>>2]|0}}else l=e;if(l&65280){if(!(l&256))m=l;else{e=f[c+84>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|256;f[a+84>>2]=e;m=f[d>>2]|0}if(!(m&512))n=m;else{m=f[c+88>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|512;f[a+88>>2]=m;n=f[d>>2]|0}if(!(n&1024))o=n;else{n=f[c+92>>2]|0;m=a+8|0;f[m>>2]=f[m>>2]|1024;f[a+92>>2]=n;o=f[d>>2]|0}if(!(o&2048))p=o;else{o=f[c+96>>2]|0;n=a+8|0;f[n>>2]=f[n>>2]|2048;f[a+96>>2]=o;p=f[d>>2]|0}if(!(p&4096))q=p;else{p=f[c+116>>2]|0;o=a+8|0;f[o>>2]=f[o>>2]|4096;f[a+116>>2]=p;q=f[d>>2]|0}do if(q&8192){p=a+8|0;f[p>>2]=f[p>>2]|8192;p=a+64|0;o=f[p>>2]|0;if(!o){n=L5b(48)|0;GNa(n);f[p>>2]=n;r=n}else r=o;o=f[c+64>>2]|0;n=(o|0)==0?493544:o;if((n|0)==(r|0))jMa(8763);else{HNa(r,n);s=f[d>>2]|0;break}}else s=q;while(0);do if(s&16384){q=a+8|0;f[q>>2]=f[q>>2]|16384;q=a+68|0;r=f[q>>2]|0;if(!r){n=L5b(48)|0;GNa(n);f[q>>2]=n;t=n}else t=r;r=f[c+68>>2]|0;n=(r|0)==0?493544:r;if((n|0)==(t|0))jMa(8763);else{HNa(t,n);u=f[d>>2]|0;break}}else u=s;while(0);if(!(u&32768))v=u;else{u=f[c+100>>2]|0;s=a+8|0;f[s>>2]=f[s>>2]|32768;f[a+100>>2]=u;v=f[d>>2]|0}}else v=l;if(v&16711680|0){if(!(v&65536))w=v;else{v=f[c+108>>2]|0;l=a+8|0;f[l>>2]=f[l>>2]|65536;f[a+108>>2]=v;w=f[d>>2]|0}if(w&131072|0){w=b[c+104>>0]|0;d=a+8|0;f[d>>2]=f[d>>2]|131072;b[a+104>>0]=w}}w=f[c+4>>2]|0;if(!(w&1))return;LPb(w&-2,a+4|0);return}function KOa(a){a=a|0;var c=0,e=0;c=u;u=u+16|0;e=c;f[a>>2]=114048;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495040?(f[213033]|0)!=2:0){f[e>>2]=135812;f[e+4>>2]=41;b[e+8>>0]=0;Gpb(852132,e);hpb(e)}f[a+12>>2]=0;f[a+16>>2]=497760;f[a+20>>2]=497760;e=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;d[e+16>>1]=0;n[a+44>>2]=1.0;f[a+48>>2]=4;u=c;return}function LOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d+8|0;g=d+4|0;h=d;i=c+8|0;j=f[i>>2]|0;if(j&255){if(!(j&1))k=j;else{l=a+8|0;f[l>>2]=f[l>>2]|1;f[g>>2]=f[c+16>>2];f[e>>2]=f[g>>2];Anb(a+16|0,497760,e);k=f[i>>2]|0}if(!(k&2))m=k;else{k=f[c+24>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|2;f[a+24>>2]=k;m=f[i>>2]|0}if(!(m&4))n=m;else{m=f[c+28>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|4;f[a+28>>2]=m;n=f[i>>2]|0}if(!(n&8))o=n;else{n=f[c+32>>2]|0;m=a+8|0;f[m>>2]=f[m>>2]|8;f[a+32>>2]=n;o=f[i>>2]|0}if(!(o&16))p=o;else{o=f[c+44>>2]|0;n=a+8|0;f[n>>2]=f[n>>2]|16;f[a+44>>2]=o;p=f[i>>2]|0}if(!(p&32))q=p;else{p=a+8|0;f[p>>2]=f[p>>2]|32;f[h>>2]=f[c+20>>2];f[e>>2]=f[h>>2];Anb(a+20|0,497760,e);q=f[i>>2]|0}if(!(q&64))r=q;else{q=f[c+36>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|64;f[a+36>>2]=q;r=f[i>>2]|0}if(!(r&128))s=r;else{r=b[c+40>>0]|0;q=a+8|0;f[q>>2]=f[q>>2]|128;b[a+40>>0]=r;s=f[i>>2]|0}}else s=j;if(s&65280|0){if(!(s&256))t=s;else{s=b[c+41>>0]|0;j=a+8|0;f[j>>2]=f[j>>2]|256;b[a+41>>0]=s;t=f[i>>2]|0}if(t&512|0){t=f[c+48>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|512;f[a+48>>2]=t}}t=f[c+4>>2]|0;if(!(t&1)){u=d;return}LPb(t&-2,a+4|0);u=d;return}function MOa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=114372;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495192?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;n[a+16>>2]=.5;b[a+20>>0]=1;u=c;return}function NOa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=114480;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==495224;g=a+16|0;h=g+80|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;u=c;return}function OOa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;sPa(a+16|0,b+16|0);tPa(a+32|0,b+32|0);c=a+48|0;d=b+48|0;e=f[d>>2]|0;if(e|0){rza(c,(f[c>>2]|0)+e|0);Vac((f[a+56>>2]|0)+4+(f[c>>2]<<2)|0,(f[b+56>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[c>>2]=(f[c>>2]|0)+(f[d>>2]|0)}d=a+60|0;c=b+60|0;e=f[c>>2]|0;if(e|0){rza(d,(f[d>>2]|0)+e|0);Vac((f[a+68>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+68>>2]|0)+4|0,f[c>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[c>>2]|0)}c=a+72|0;d=b+72|0;e=f[d>>2]|0;if(e|0){rza(c,(f[c>>2]|0)+e|0);Vac((f[a+80>>2]|0)+4+(f[c>>2]<<2)|0,(f[b+80>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[c>>2]=(f[c>>2]|0)+(f[d>>2]|0)}d=a+84|0;c=b+84|0;e=f[c>>2]|0;if(e|0){rza(d,(f[d>>2]|0)+e|0);Vac((f[a+92>>2]|0)+4+(f[d>>2]<<2)|0,(f[b+92>>2]|0)+4|0,f[c>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[c>>2]|0)}c=f[b+4>>2]|0;if(!(c&1))return;LPb(c&-2,a+4|0);return}function POa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=114588;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=495328?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+28>>2]=1;b[a+32>>0]=1;u=c;return}function QOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+16|0;e=c+16|0;g=f[e>>2]|0;if(g|0){qza(d,(f[d>>2]|0)+g|0);Vac((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[e>>2]|0)}e=c+8|0;d=f[e>>2]|0;if(d&255|0){if(!(d&1))h=d;else{d=f[c+28>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+28>>2]=d;h=f[e>>2]|0}if(h&4|0){h=b[c+32>>0]|0;e=a+8|0;f[e>>2]=f[e>>2]|4;b[a+32>>0]=h}}h=f[c+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function ROa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=114912;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495456?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;n[a+16>>2]=0.0;n[a+20>>2]=-1.0;n[a+24>>2]=1.0;u=c;return}function SOa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=115128;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495528?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=497760;d=a+20|0;f[d>>2]=0;b[d+4>>0]=0;u=c;return}function TOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+4|0;g=d;if((c|0)==(a|0))jMa(32667);h=c+8|0;i=f[h>>2]|0;if(i&255|0){if(!(i&1))j=i;else{i=a+8|0;f[i>>2]=f[i>>2]|1;f[g>>2]=f[c+16>>2];f[e>>2]=f[g>>2];Anb(a+16|0,497760,e);j=f[h>>2]|0}if(!(j&2))k=j;else{j=f[c+20>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;f[a+20>>2]=j;k=f[h>>2]|0}if(k&4|0){k=b[c+24>>0]|0;h=a+8|0;f[h>>2]=f[h>>2]|4;b[a+24>>0]=k}}k=f[c+4>>2]|0;if(!(k&1)){u=d;return}LPb(k&-2,a+4|0);u=d;return}function UOa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=115344;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495600?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=1;u=c;return}function VOa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=115452;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495632?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=497760;f[a+20>>2]=497760;f[a+24>>2]=497760;d=a+28|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;n[a+48>>2]=1.0;f[a+52>>2]=1;b[a+56>>0]=1;u=c;return}function WOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d+4|0;i=d;j=c+8|0;k=f[j>>2]|0;if(k&255){if(!(k&1))l=k;else{m=a+8|0;f[m>>2]=f[m>>2]|1;f[g>>2]=f[c+16>>2];f[e>>2]=f[g>>2];Anb(a+16|0,497760,e);l=f[j>>2]|0}if(!(l&2))n=l;else{l=f[c+52>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|2;f[a+52>>2]=l;n=f[j>>2]|0}if(!(n&4))o=n;else{n=f[c+28>>2]|0;l=a+8|0;f[l>>2]=f[l>>2]|4;f[a+28>>2]=n;o=f[j>>2]|0}if(!(o&8))p=o;else{o=b[c+40>>0]|0;n=a+8|0;f[n>>2]=f[n>>2]|8;b[a+40>>0]=o;p=f[j>>2]|0}if(!(p&16))q=p;else{p=f[c+32>>2]|0;o=a+8|0;f[o>>2]=f[o>>2]|16;f[a+32>>2]=p;q=f[j>>2]|0}if(!(q&32))r=q;else{q=f[c+36>>2]|0;p=a+8|0;f[p>>2]=f[p>>2]|32;f[a+36>>2]=q;r=f[j>>2]|0}if(!(r&64))s=r;else{r=b[c+56>>0]|0;q=a+8|0;f[q>>2]=f[q>>2]|64;b[a+56>>0]=r;s=f[j>>2]|0}if(!(s&128))t=s;else{s=f[c+48>>2]|0;r=a+8|0;f[r>>2]=f[r>>2]|128;f[a+48>>2]=s;t=f[j>>2]|0}}else t=k;if(t&65280|0){if(!(t&256))v=t;else{t=a+8|0;f[t>>2]=f[t>>2]|256;f[h>>2]=f[c+20>>2];f[e>>2]=f[h>>2];Anb(a+20|0,497760,e);v=f[j>>2]|0}if(!(v&512))w=v;else{v=f[c+44>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|512;f[a+44>>2]=v;w=f[j>>2]|0}if(!(w&1024))x=w;else{w=b[c+41>>0]|0;v=a+8|0;f[v>>2]=f[v>>2]|1024;b[a+41>>0]=w;x=f[j>>2]|0}if(x&2048|0){x=a+8|0;f[x>>2]=f[x>>2]|2048;f[i>>2]=f[c+24>>2];f[e>>2]=f[i>>2];Anb(a+24|0,497760,e)}}e=f[c+4>>2]|0;if(!(e&1)){u=d;return}LPb(e&-2,a+4|0);u=d;return}function XOa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=115560;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495704?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=497760;u=c;return}function YOa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=115668;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495736?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;b[d+16>>0]=0;b[a+29>>0]=1;f[a+32>>2]=1;u=c;return}function ZOa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=c+8|0;e=f[d>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=f[c+24>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;f[a+24>>2]=e;g=f[d>>2]|0}if(!(g&2))i=g;else{g=b[c+29>>0]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;b[a+29>>0]=g;i=f[d>>2]|0}do if(i&4){g=a+8|0;f[g>>2]=f[g>>2]|4;g=a+16|0;e=f[g>>2]|0;if(!e){h=L5b(48)|0;GNa(h);f[g>>2]=h;j=h}else j=e;e=f[c+16>>2]|0;h=(e|0)==0?493544:e;if((h|0)==(j|0))jMa(8763);else{HNa(j,h);k=f[d>>2]|0;break}}else k=i;while(0);do if(k&8){i=a+8|0;f[i>>2]=f[i>>2]|8;i=a+20|0;j=f[i>>2]|0;if(!j){h=L5b(48)|0;GNa(h);f[i>>2]=h;l=h}else l=j;j=f[c+20>>2]|0;h=(j|0)==0?493544:j;if((h|0)==(l|0))jMa(8763);else{HNa(l,h);m=f[d>>2]|0;break}}else m=k;while(0);if(!(m&16))n=m;else{m=f[c+32>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|16;f[a+32>>2]=m;n=f[d>>2]|0}if(n&32|0){n=b[c+28>>0]|0;d=a+8|0;f[d>>2]=f[d>>2]|32;b[a+28>>0]=n}}n=f[c+4>>2]|0;if(!(n&1))return;LPb(n&-2,a+4|0);return}function _Oa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=115992;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495864?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=5;n[a+28>>2]=1.0;n[a+32>>2]=.75;n[a+36>>2]=1.0;u=c;return}function $Oa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=b+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[b+24>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+24>>2]=d;e=f[c>>2]|0}if(!(e&2))h=e;else{e=f[b+28>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+28>>2]=e;h=f[c>>2]|0}if(!(h&4))i=h;else{h=f[b+32>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|4;f[a+32>>2]=h;i=f[c>>2]|0}if(!(i&8))j=i;else{i=f[b+16>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|8;f[a+16>>2]=i;j=f[c>>2]|0}if(!(j&16))k=j;else{j=f[b+36>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|16;f[a+36>>2]=j;k=f[c>>2]|0}if(k&32|0){k=f[b+20>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|32;f[a+20>>2]=k}}k=f[b+4>>2]|0;if(!(k&1))return;LPb(k&-2,a+4|0);return}function aPa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=116100;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495912?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;u=c;return}function bPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;if((b|0)==(a|0))jMa(37271);c=b+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[b+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[c>>2]|0}if(!(e&2))h=e;else{e=f[b+20>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+20>>2]=e;h=f[c>>2]|0}if(!(h&4))i=h;else{h=f[b+24>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|4;f[a+24>>2]=h;i=f[c>>2]|0}if(i&8|0){i=f[b+28>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|8;f[a+28>>2]=i}}i=f[b+4>>2]|0;if(!(i&1))return;LPb(i&-2,a+4|0);return}function cPa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=116208;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495952?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;b[a+16>>0]=0;b[a+17>>0]=1;n[a+20>>2]=9.999999717180685e-10;u=c;return}function dPa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=116424;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496016?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}d=a+12|0;e=a+60|0;g=d;h=g+44|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));b[d+44>>0]=0;f[e>>2]=1;b[a+64>>0]=1;u=c;return}function ePa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=c+8|0;e=f[d>>2]|0;if(e&255){if(!(e&1))g=e;else{h=f[c+16>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|1;f[a+16>>2]=h;g=f[d>>2]|0}if(!(g&2))j=g;else{g=f[c+20>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|2;f[a+20>>2]=g;j=f[d>>2]|0}if(!(j&4))k=j;else{j=f[c+24>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|4;f[a+24>>2]=j;k=f[d>>2]|0}if(!(k&8))l=k;else{k=f[c+28>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|8;f[a+28>>2]=k;l=f[d>>2]|0}if(!(l&16))m=l;else{l=f[c+32>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|16;f[a+32>>2]=l;m=f[d>>2]|0}if(!(m&32))n=m;else{m=f[c+36>>2]|0;l=a+8|0;f[l>>2]=f[l>>2]|32;f[a+36>>2]=m;n=f[d>>2]|0}if(!(n&64))o=n;else{n=f[c+40>>2]|0;m=a+8|0;f[m>>2]=f[m>>2]|64;f[a+40>>2]=n;o=f[d>>2]|0}if(!(o&128))p=o;else{o=f[c+60>>2]|0;n=a+8|0;f[n>>2]=f[n>>2]|128;f[a+60>>2]=o;p=f[d>>2]|0}}else p=e;if(p&65280|0){if(!(p&256))q=p;else{p=f[c+44>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|256;f[a+44>>2]=p;q=f[d>>2]|0}if(!(q&512))r=q;else{q=f[c+48>>2]|0;p=a+8|0;f[p>>2]=f[p>>2]|512;f[a+48>>2]=q;r=f[d>>2]|0}if(!(r&1024))s=r;else{r=f[c+52>>2]|0;q=a+8|0;f[q>>2]=f[q>>2]|1024;f[a+52>>2]=r;s=f[d>>2]|0}if(!(s&2048))t=s;else{s=b[c+56>>0]|0;r=a+8|0;f[r>>2]=f[r>>2]|2048;b[a+56>>0]=s;t=f[d>>2]|0}if(t&4096|0){t=b[c+64>>0]|0;d=a+8|0;f[d>>2]=f[d>>2]|4096;b[a+64>>0]=t}}t=f[c+4>>2]|0;if(!(t&1))return;LPb(t&-2,a+4|0);return}function fPa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=116532;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496096?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;n[a+16>>2]=0.0;n[a+20>>2]=1.0;n[a+24>>2]=1.0;u=c;return}function gPa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=116964;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496256?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function hPa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=117288;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496376?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=0;u=c;return}function iPa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=117504;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496456?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;u=c;return}function jPa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=117396;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=496408?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+28>>2]=1;f[a+32>>2]=1;u=c;return}function kPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+16|0;d=b+16|0;e=f[d>>2]|0;if(e|0){rza(c,(f[c>>2]|0)+e|0);Vac((f[a+24>>2]|0)+4+(f[c>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[c>>2]=(f[c>>2]|0)+(f[d>>2]|0)}d=b+8|0;c=f[d>>2]|0;if(c&255|0){if(!(c&1))g=c;else{c=f[b+28>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|1;f[a+28>>2]=c;g=f[d>>2]|0}if(g&4|0){g=f[b+32>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|4;f[a+32>>2]=g}}g=f[b+4>>2]|0;if(!(g&1))return;LPb(g&-2,a+4|0);return}function lPa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=117612;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496488?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=0;u=c;return}function mPa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=117828;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496552?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;n[a+16>>2]=0.0;u=c;return}function nPa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=117936;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496584?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=497760;f[a+20>>2]=497760;f[a+24>>2]=f[213031];f[a+28>>2]=497760;d=a+32|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;n[a+48>>2]=1.0;n[a+52>>2]=.5;n[a+56>>2]=.5;n[a+60>>2]=.25;u=c;return}function oPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+32|0;e=d+16|0;g=d+12|0;h=d+8|0;i=d+4|0;j=d;k=c+8|0;l=f[k>>2]|0;if(l&255){if(!(l&1))m=l;else{n=a+8|0;f[n>>2]=f[n>>2]|1;f[g>>2]=f[c+16>>2];f[e>>2]=f[g>>2];Anb(a+16|0,497760,e);m=f[k>>2]|0}if(!(m&2))o=m;else{m=f[c+48>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|2;f[a+48>>2]=m;o=f[k>>2]|0}if(!(o&4))p=o;else{o=a+8|0;f[o>>2]=f[o>>2]|4;f[h>>2]=f[c+20>>2];f[e>>2]=f[h>>2];Anb(a+20|0,497760,e);p=f[k>>2]|0}if(!(p&8))q=p;else{p=f[c+32>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|8;f[a+32>>2]=p;q=f[k>>2]|0}if(!(q&16))r=q;else{q=f[c+36>>2]|0;p=a+8|0;f[p>>2]=f[p>>2]|16;f[a+36>>2]=q;r=f[k>>2]|0}if(!(r&32))s=r;else{r=b[c+40>>0]|0;q=a+8|0;f[q>>2]=f[q>>2]|32;b[a+40>>0]=r;s=f[k>>2]|0}if(!(s&64))t=s;else{s=f[c+52>>2]|0;r=a+8|0;f[r>>2]=f[r>>2]|64;f[a+52>>2]=s;t=f[k>>2]|0}if(!(t&128))v=t;else{t=f[c+56>>2]|0;s=a+8|0;f[s>>2]=f[s>>2]|128;f[a+56>>2]=t;v=f[k>>2]|0}}else v=l;if(v&65280|0){if(!(v&256))w=v;else{v=f[c+60>>2]|0;l=a+8|0;f[l>>2]=f[l>>2]|256;f[a+60>>2]=v;w=f[k>>2]|0}if(!(w&512))x=w;else{w=f[c+44>>2]|0;v=a+8|0;f[v>>2]=f[v>>2]|512;f[a+44>>2]=w;x=f[k>>2]|0}if(!(x&1024))y=x;else{x=a+8|0;f[x>>2]=f[x>>2]|1024;x=f[213031]|0;f[i>>2]=f[c+24>>2];f[e>>2]=f[i>>2];Anb(a+24|0,x,e);y=f[k>>2]|0}if(!(y&2048))z=y;else{y=b[c+41>>0]|0;x=a+8|0;f[x>>2]=f[x>>2]|2048;b[a+41>>0]=y;z=f[k>>2]|0}if(z&4096|0){z=a+8|0;f[z>>2]=f[z>>2]|4096;f[j>>2]=f[c+28>>2];f[e>>2]=f[j>>2];Anb(a+28|0,497760,e)}}e=f[c+4>>2]|0;if(!(e&1)){u=d;return}LPb(e&-2,a+4|0);u=d;return}function pPa(a){a=a|0;var c=0,e=0;c=u;u=u+16|0;e=c;f[a>>2]=112968;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=494552?(f[213033]|0)!=2:0){f[e>>2]=135812;f[e+4>>2]=41;b[e+8>>0]=0;Gpb(852132,e);hpb(e)}f[a+12>>2]=0;f[a+28>>2]=497760;e=a+32|0;f[e>>2]=0;d[e+4>>1]=0;b[e+6>>0]=0;n[a+40>>2]=1.0;u=c;return}function qPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+4|0;g=d;h=a+16|0;i=c+16|0;j=f[i>>2]|0;if(j|0){qza(h,(f[h>>2]|0)+j|0);Vac((f[a+24>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[i>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[i>>2]|0)}i=c+8|0;h=f[i>>2]|0;if(h&255|0){if(!(h&1))k=h;else{h=f[c+40>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|1;f[a+40>>2]=h;k=f[i>>2]|0}if(!(k&2))l=k;else{k=b[c+36>>0]|0;h=a+8|0;f[h>>2]=f[h>>2]|2;b[a+36>>0]=k;l=f[i>>2]|0}if(!(l&4))m=l;else{l=f[c+32>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|4;f[a+32>>2]=l;m=f[i>>2]|0}if(!(m&8))n=m;else{m=a+8|0;f[m>>2]=f[m>>2]|8;f[g>>2]=f[c+28>>2];f[e>>2]=f[g>>2];Anb(a+28|0,497760,e);n=f[i>>2]|0}if(!(n&32))o=n;else{n=b[c+37>>0]|0;e=a+8|0;f[e>>2]=f[e>>2]|32;b[a+37>>0]=n;o=f[i>>2]|0}if(o&64|0){o=b[c+38>>0]|0;i=a+8|0;f[i>>2]=f[i>>2]|64;b[a+38>>0]=o}}o=f[c+4>>2]|0;if(!(o&1)){u=d;return}LPb(o&-2,a+4|0);u=d;return}function rPa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=113076;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=494608?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=0;f[a+24>>2]=1;u=c;return}function sPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{yPa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=zPa(h,i)|0;yPa(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function tPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{uPa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=vPa(h,i)|0;uPa(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function uPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((a|0)==(b|0))jMa(2959);c=b+16|0;d=a+16|0;e=f[d>>2]|0;if(e|0){uFa(c,(f[c>>2]|0)+e|0);Vac((f[b+24>>2]|0)+8+(f[c>>2]<<3)|0,(f[a+24>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[c>>2]=(f[c>>2]|0)+(f[d>>2]|0)}d=f[a+4>>2]|0;if(!(d&1))return;LPb(d&-2,b+4|0);return}function vPa(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=wPa(b,c)|0;u=a;return d|0}function wPa(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(32)|0;fOa(b);c=b;return c|0}else{b=znb(a,18760,32)|0;fOa(b);xnb(a,b,1502);c=b;return c|0}return 0}function xPa(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function yPa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))jMa(8763);else{HNa(b,a);return}}function zPa(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=APa(b,c)|0;u=a;return d|0}function APa(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(48)|0;GNa(b);c=b;return c|0}else{b=znb(a,18888,48)|0;GNa(b);xnb(a,b,1503);c=b;return c|0}return 0}function BPa(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function CPa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))jMa(14743);else{DPa(b,a);return}}function DPa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;UDa(a+16|0,b+16|0);UDa(a+32|0,b+32|0);c=b+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[b+48>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+48>>2]=d;e=f[c>>2]|0}if(!(e&2))h=e;else{e=f[b+52>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+52>>2]=e;h=f[c>>2]|0}if(h&4|0){h=f[b+56>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|4;f[a+56>>2]=h}}h=f[b+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function EPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=a+8|0;c=f[b>>2]|0;if(c&7){if(c&1){d=f[a+20>>2]|0;if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}}else{e=0;g=c}if(!(g&2)){i=e;j=g}else{c=f[a+24>>2]|0;if((c|0)>=0)if(c>>>0<128){k=2;l=g}else{h=(iob(c)|0)+1|0;k=h;l=f[b>>2]|0}else{k=11;l=g}i=k+e|0;j=l}if(!(j&4))m=i;else{j=f[a+16>>2]|0;if((j|0)>=0)if(j>>>0<128)n=2;else n=(iob(j)|0)+1|0;else n=11;m=n+i|0}}else m=0;i=f[a+4>>2]|0;if(!(i&1)){o=m;p=a+12|0;f[p>>2]=o;return o|0}o=(dQb(i&-2)|0)+m|0;p=a+12|0;f[p>>2]=o;return o|0}function FPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;b=a+8|0;c=f[b>>2]|0;if(c&195){if(!(c&1)){d=0;e=c}else{g=f[a+72>>2]|0;if(g>>>0<128){h=1;i=c}else{j=iob(g)|0;h=j;i=f[b>>2]|0}d=h+1|0;e=i}i=e&2|0?d+2|0:d;if(!(e&64)){k=i;l=e}else{d=f[a+76>>2]|0;if(d>>>0<128){m=1;n=e}else{e=iob(d)|0;m=e;n=f[b>>2]|0}k=i+1+m|0;l=n}if(!(l&128)){o=k;p=l}else{n=f[a+80>>2]|0;if(n>>>0<128){q=1;r=l}else{l=iob(n)|0;q=l;r=f[b>>2]|0}o=k+1+q|0;p=r}}else{o=0;p=c}if(p&65280){if(!(p&256)){s=o;t=p}else{c=f[a+84>>2]|0;if(c>>>0<128){u=1;v=p}else{r=iob(c)|0;u=r;v=f[b>>2]|0}s=o+1+u|0;t=v}if(!(t&512)){w=s;x=t}else{v=f[a+88>>2]|0;if(v>>>0<128){y=1;z=t}else{t=iob(v)|0;y=t;z=f[b>>2]|0}w=s+1+y|0;x=z}if(!(x&1024)){A=w;B=x}else{z=f[a+92>>2]|0;if(z>>>0<128){C=1;D=x}else{x=iob(z)|0;C=x;D=f[b>>2]|0}A=w+1+C|0;B=D}if(!(B&2048)){E=A;F=B}else{D=f[a+96>>2]|0;if(D>>>0<128){G=1;H=B}else{B=iob(D)|0;G=B;H=f[b>>2]|0}E=A+1+G|0;F=H}if(!(F&4096)){I=E;J=F}else{H=f[a+116>>2]|0;if(H>>>0<128){K=1;L=F}else{F=iob(H)|0;K=F;L=f[b>>2]|0}I=E+1+K|0;J=L}if(!(J&8192)){M=I;N=J}else{J=INa(f[a+64>>2]|0)|0;if(J>>>0<128)O=1;else O=iob(J)|0;M=I+1+J+O|0;N=f[b>>2]|0}if(!(N&16384)){P=M;Q=N}else{N=INa(f[a+68>>2]|0)|0;if(N>>>0<128)R=1;else R=iob(N)|0;P=M+1+N+R|0;Q=f[b>>2]|0}if(!(Q&32768)){S=P;T=Q}else{R=f[a+100>>2]|0;if((R|0)>=0)if(R>>>0<128){U=2;V=Q}else{N=(iob(R)|0)+1|0;U=N;V=f[b>>2]|0}else{U=11;V=Q}S=U+P|0;T=V}}else{S=o;T=p}if(!(T&196608))W=S;else{if(!(T&65536)){X=S;Y=T}else{p=f[a+108>>2]|0;if((p|0)>=0)if(p>>>0<128){Z=3;_=T}else{o=(iob(p)|0)+2|0;Z=o;_=f[b>>2]|0}else{Z=12;_=T}X=Z+S|0;Y=_}W=Y&131072|0?X+3|0:X}X=a+16|0;Y=f[X>>2]|0;if(!Y){$=0;aa=0}else{_=a+24|0;S=0;Z=0;do{T=f[(f[_>>2]|0)+4+(Z<<2)>>2]|0;if(T>>>0<128)ba=1;else ba=iob(T)|0;S=ba+S|0;Z=Z+1|0}while((Z|0)!=(Y|0));$=S;aa=f[X>>2]|0}X=a+28|0;S=f[X>>2]|0;if(!S){ca=0;da=0}else{Y=a+36|0;Z=0;ba=0;do{_=f[(f[Y>>2]|0)+4+(Z<<2)>>2]|0;if(_>>>0<128)ea=1;else ea=iob(_)|0;ba=ea+ba|0;Z=Z+1|0}while((Z|0)!=(S|0));ca=ba;da=f[X>>2]|0}X=a+40|0;ba=f[X>>2]|0;if(!ba){fa=0;ga=0}else{S=a+48|0;Z=0;ea=0;do{Y=f[(f[S>>2]|0)+4+(Z<<2)>>2]|0;if(Y>>>0<128)ha=1;else ha=iob(Y)|0;ea=ha+ea|0;Z=Z+1|0}while((Z|0)!=(ba|0));fa=ea;ga=f[X>>2]|0}X=a+52|0;ea=f[X>>2]|0;if(!ea){ia=0;ja=0}else{ba=a+60|0;Z=0;ha=0;do{S=f[(f[ba>>2]|0)+4+(Z<<2)>>2]|0;if(S>>>0<128)ka=1;else ka=iob(S)|0;ha=ka+ha|0;Z=Z+1|0}while((Z|0)!=(ea|0));ia=ha;ja=f[X>>2]<<1}X=$+W+aa+ca+da+fa+ga+ia+ja|0;ja=f[a+4>>2]|0;if(!(ja&1)){la=X;ma=a+12|0;f[ma>>2]=la;return la|0}la=(dQb(ja&-2)|0)+X|0;ma=a+12|0;f[ma>>2]=la;return la|0}function GPa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;c=a+8|0;d=f[c>>2]|0;if(!(d&255)){e=0;g=d}else{if(!(d&1)){h=0;i=d}else{j=f[a+16>>2]|0;k=b[j+11>>0]|0;if(k<<24>>24<0){l=f[j+4>>2]|0;if(l>>>0<128){m=1;n=d;o=l}else{j=iob(l)|0;m=j;n=f[c>>2]|0;o=l}}else{m=1;n=d;o=k&255}h=o+1+m|0;i=n}if(!(i&2)){p=h;q=i}else{n=f[a+24>>2]|0;if(n>>>0<128){r=2;s=i}else{i=(iob(n)|0)+1|0;r=i;s=f[c>>2]|0}p=r+h|0;q=s}if(!(q&4)){t=p;u=q}else{s=f[a+28>>2]|0;if(s>>>0<128){v=2;w=q}else{q=(iob(s)|0)+1|0;v=q;w=f[c>>2]|0}t=v+p|0;u=w}if(!(u&8)){x=t;y=u}else{w=f[a+32>>2]|0;if((w|0)>=0)if(w>>>0<128){z=2;A=u}else{p=(iob(w)|0)+1|0;z=p;A=f[c>>2]|0}else{z=11;A=u}x=z+t|0;y=A}A=y&16|0?x+5|0:x;if(!(y&32)){B=A;C=y}else{x=f[a+20>>2]|0;t=b[x+11>>0]|0;if(t<<24>>24<0){z=f[x+4>>2]|0;if(z>>>0<128){D=1;E=y;F=z}else{x=iob(z)|0;D=x;E=f[c>>2]|0;F=z}}else{D=1;E=y;F=t&255}B=A+1+F+D|0;C=E}if(!(C&64)){G=B;H=C}else{E=f[a+36>>2]|0;if(E>>>0<128){I=2;J=C}else{C=(iob(E)|0)+1|0;I=C;J=f[c>>2]|0}G=I+B|0;H=J}e=H&128|0?G+2|0:G;g=H}if(g&768){H=g&256|0?e+2|0:e;if(!(g&512))K=H;else{g=f[a+48>>2]|0;if(g>>>0<128)L=2;else L=(iob(g)|0)+1|0;K=L+H|0}}else K=e;e=f[a+4>>2]|0;if(!(e&1)){M=K;N=a+12|0;f[N>>2]=M;return M|0}M=(dQb(e&-2)|0)+K|0;N=a+12|0;f[N>>2]=M;return M|0}function HPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=f[a+20>>2]|0;if(!b)c=0;else{d=a+28|0;e=b;g=0;while(1){h=INa(f[(f[d>>2]|0)+4+(g<<2)>>2]|0)|0;if(h>>>0<128)i=1;else i=iob(h)|0;j=h+e+i|0;g=g+1|0;if((g|0)==(b|0)){c=j;break}else e=j}}e=f[a+36>>2]|0;b=e+c|0;if(!e)k=b;else{c=a+44|0;g=0;i=b;while(1){b=f[(f[c>>2]|0)+4+(g<<2)>>2]|0;d=f[b+16>>2]|0;if(d){j=b+24|0;h=0;l=0;do{m=(f[j>>2]|0)+8+(l<<3)|0;h=(job(f[m>>2]|0,f[m+4>>2]|0)|0)+h|0;l=l+1|0}while((l|0)!=(d|0));if(h)if((h|0)>=0)if(h>>>0<128){n=2;o=h}else{n=(iob(h)|0)+1|0;o=h}else{n=11;o=h}else{n=0;o=0}}else{n=0;o=0}f[b+28>>2]=o;d=n+o|0;l=f[b+4>>2]|0;if(!(l&1))p=d;else p=(dQb(l&-2)|0)+d|0;f[b+12>>2]=p;if(p>>>0<128)q=1;else q=iob(p)|0;d=p+i+q|0;g=g+1|0;if((g|0)==(e|0)){k=d;break}else i=d}}i=a+48|0;e=f[i>>2]|0;if(!e){r=0;s=0}else{g=a+56|0;q=0;p=0;do{o=f[(f[g>>2]|0)+4+(p<<2)>>2]|0;if(o>>>0<128)t=1;else t=iob(o)|0;q=t+q|0;p=p+1|0}while((p|0)!=(e|0));r=q;s=f[i>>2]|0}i=a+60|0;q=f[i>>2]|0;if(!q){u=0;v=0}else{e=a+68|0;p=0;t=0;do{g=f[(f[e>>2]|0)+4+(p<<2)>>2]|0;if(g>>>0<128)w=1;else w=iob(g)|0;t=w+t|0;p=p+1|0}while((p|0)!=(q|0));u=t;v=f[i>>2]|0}i=a+72|0;t=f[i>>2]|0;if(!t){x=0;y=0}else{q=a+80|0;p=0;w=0;do{e=f[(f[q>>2]|0)+4+(p<<2)>>2]|0;if(e>>>0<128)z=1;else z=iob(e)|0;w=z+w|0;p=p+1|0}while((p|0)!=(t|0));x=w;y=f[i>>2]|0}i=a+84|0;w=f[i>>2]|0;if(!w){A=0;B=0}else{t=a+92|0;p=0;z=0;do{q=f[(f[t>>2]|0)+4+(p<<2)>>2]|0;if(q>>>0<128)C=1;else C=iob(q)|0;z=C+z|0;p=p+1|0}while((p|0)!=(w|0));A=z;B=f[i>>2]|0}i=r+k+s+u+v+x+y+A+B|0;B=f[a+4>>2]|0;if(!(B&1)){D=i;E=a+12|0;f[E>>2]=D;return D|0}D=(dQb(B&-2)|0)+i|0;E=a+12|0;f[E>>2]=D;return D|0}function IPa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+8|0;d=f[c>>2]|0;if(!(d&7))e=0;else{if(!(d&1)){g=0;h=d}else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;if(j<<24>>24<0){k=f[i+4>>2]|0;if(k>>>0<128){l=1;m=d;n=k}else{i=iob(k)|0;l=i;m=f[c>>2]|0;n=k}}else{l=1;m=d;n=j&255}g=n+1+l|0;h=m}if(!(h&2)){o=g;p=h}else{m=f[a+20>>2]|0;if(m>>>0<128){q=2;r=h}else{h=(iob(m)|0)+1|0;q=h;r=f[c>>2]|0}o=q+g|0;p=r}e=p&4|0?o+2|0:o}o=f[a+4>>2]|0;if(!(o&1)){s=e;t=a+12|0;f[t>>2]=s;return s|0}s=(dQb(o&-2)|0)+e|0;t=a+12|0;f[t>>2]=s;return s|0}function JPa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;c=a+8|0;d=f[c>>2]|0;if(!(d&255)){e=0;g=d}else{if(!(d&1)){h=0;i=d}else{j=f[a+16>>2]|0;k=b[j+11>>0]|0;if(k<<24>>24<0){l=f[j+4>>2]|0;if(l>>>0<128){m=1;n=d;o=l}else{j=iob(l)|0;m=j;n=f[c>>2]|0;o=l}}else{m=1;n=d;o=k&255}h=o+1+m|0;i=n}if(!(i&2)){p=h;q=i}else{n=f[a+52>>2]|0;if(n>>>0<128){r=1;s=i}else{i=iob(n)|0;r=i;s=f[c>>2]|0}p=h+1+r|0;q=s}if(!(q&4)){t=p;u=q}else{s=f[a+28>>2]|0;if(s>>>0<128){v=2;w=q}else{q=(iob(s)|0)+1|0;v=q;w=f[c>>2]|0}t=v+p|0;u=w}w=u&8|0?t+2|0:t;if(!(u&16)){x=w;y=u}else{t=f[a+32>>2]|0;if(t>>>0<128){z=2;A=u}else{u=(iob(t)|0)+1|0;z=u;A=f[c>>2]|0}x=z+w|0;y=A}if(!(y&32)){B=x;C=y}else{A=f[a+36>>2]|0;if(A>>>0<128){D=2;E=y}else{y=(iob(A)|0)+1|0;D=y;E=f[c>>2]|0}B=D+x|0;C=E}E=C&64|0?B+2|0:B;e=C&128|0?E+5|0:E;g=C}if(g&3840){if(!(g&256)){F=e;G=g}else{C=f[a+20>>2]|0;E=b[C+11>>0]|0;if(E<<24>>24<0){B=f[C+4>>2]|0;if(B>>>0<128){H=1;I=g;J=B}else{C=iob(B)|0;H=C;I=f[c>>2]|0;J=B}}else{H=1;I=g;J=E&255}F=e+1+J+H|0;G=I}if(!(G&512)){K=F;L=G}else{I=f[a+44>>2]|0;if(I>>>0<128){M=2;N=G}else{G=(iob(I)|0)+1|0;M=G;N=f[c>>2]|0}K=M+F|0;L=N}N=L&1024|0?K+2|0:K;if(!(L&2048))O=N;else{L=f[a+24>>2]|0;K=b[L+11>>0]|0;if(K<<24>>24<0){F=f[L+4>>2]|0;if(F>>>0<128){P=1;Q=F}else{P=iob(F)|0;Q=F}}else{P=1;Q=K&255}O=N+1+Q+P|0}}else O=e;e=f[a+4>>2]|0;if(!(e&1)){R=O;S=a+12|0;f[S>>2]=R;return R|0}R=(dQb(e&-2)|0)+O|0;S=a+12|0;f[S>>2]=R;return R|0}function KPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=a+8|0;c=f[b>>2]|0;if(!(c&63))d=0;else{if(c&1){e=f[a+24>>2]|0;if(e>>>0<128){g=2;h=c}else{i=(iob(e)|0)+1|0;g=i;h=f[b>>2]|0}}else{g=0;h=c}c=h&2|0?g+2|0:g;if(!(h&4)){j=c;k=h}else{h=INa(f[a+16>>2]|0)|0;if(h>>>0<128)l=1;else l=iob(h)|0;j=c+1+h+l|0;k=f[b>>2]|0}if(!(k&8)){m=j;n=k}else{k=INa(f[a+20>>2]|0)|0;if(k>>>0<128)o=1;else o=iob(k)|0;m=j+1+k+o|0;n=f[b>>2]|0}if(!(n&16)){p=m;q=n}else{o=f[a+32>>2]|0;if((o|0)>=0)if(o>>>0<128){r=2;s=n}else{k=(iob(o)|0)+1|0;r=k;s=f[b>>2]|0}else{r=11;s=n}p=r+m|0;q=s}d=q&32|0?p+2|0:p}p=f[a+4>>2]|0;if(!(p&1)){t=d;u=a+12|0;f[u>>2]=t;return t|0}t=(dQb(p&-2)|0)+d|0;u=a+12|0;f[u>>2]=t;return t|0}function LPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=a+8|0;c=f[b>>2]|0;if(c&63){if(c&1){d=f[a+24>>2]|0;if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}}else{e=0;g=c}c=g&2|0?e+5|0:e;e=g&4|0?c+5|0:c;if(!(g&8)){i=e;j=g}else{c=f[a+16>>2]|0;if((c|0)>=0)if(c>>>0<128){k=2;l=g}else{h=(iob(c)|0)+1|0;k=h;l=f[b>>2]|0}else{k=11;l=g}i=k+e|0;j=l}l=j&16|0?i+5|0:i;if(!(j&32))m=l;else{j=f[a+20>>2]|0;if((j|0)>=0)if(j>>>0<128)n=2;else n=(iob(j)|0)+1|0;else n=11;m=n+l|0}}else m=0;l=f[a+4>>2]|0;if(!(l&1)){o=m;p=a+12|0;f[p>>2]=o;return o|0}o=(dQb(l&-2)|0)+m|0;p=a+12|0;f[p>>2]=o;return o|0}function MPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=a+8|0;c=f[b>>2]|0;if(c&15){if(c&1){d=f[a+16>>2]|0;if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}}else{e=0;g=c}if(!(g&2)){i=e;j=g}else{c=f[a+20>>2]|0;if(c>>>0<128){k=2;l=g}else{g=(iob(c)|0)+1|0;k=g;l=f[b>>2]|0}i=k+e|0;j=l}if(!(j&4)){m=i;n=j}else{l=f[a+24>>2]|0;if(l>>>0<128){o=2;p=j}else{j=(iob(l)|0)+1|0;o=j;p=f[b>>2]|0}m=o+i|0;n=p}if(!(n&8))q=m;else{n=f[a+28>>2]|0;if(n>>>0<128)r=2;else r=(iob(n)|0)+1|0;q=r+m|0}}else q=0;m=f[a+4>>2]|0;if(!(m&1)){s=q;t=a+12|0;f[t>>2]=s;return s|0}s=(dQb(m&-2)|0)+q|0;t=a+12|0;f[t>>2]=s;return s|0}function NPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;b=a+8|0;c=f[b>>2]|0;if(c&255){if(!(c&1)){d=0;e=c}else{g=f[a+16>>2]|0;if((g|0)>=0)if(g>>>0<128){h=1;i=c}else{j=iob(g)|0;h=j;i=f[b>>2]|0}else{h=10;i=c}d=h+1|0;e=i}if(!(e&2)){k=d;l=e}else{i=f[a+20>>2]|0;if(i>>>0<128){m=1;n=e}else{e=iob(i)|0;m=e;n=f[b>>2]|0}k=d+1+m|0;l=n}if(!(l&4)){o=k;p=l}else{n=f[a+24>>2]|0;if(n>>>0<128){q=1;r=l}else{l=iob(n)|0;q=l;r=f[b>>2]|0}o=k+1+q|0;p=r}if(!(p&8)){s=o;t=p}else{r=f[a+28>>2]|0;if(r>>>0<128){u=1;v=p}else{p=iob(r)|0;u=p;v=f[b>>2]|0}s=o+1+u|0;t=v}if(!(t&16)){w=s;x=t}else{v=f[a+32>>2]|0;if(v>>>0<128){y=2;z=t}else{t=(iob(v)|0)+1|0;y=t;z=f[b>>2]|0}w=y+s|0;x=z}if(!(x&32)){A=w;B=x}else{z=f[a+36>>2]|0;if(z>>>0<128){C=2;D=x}else{x=(iob(z)|0)+1|0;C=x;D=f[b>>2]|0}A=C+w|0;B=D}if(!(B&64)){E=A;F=B}else{D=f[a+40>>2]|0;if(D>>>0<128){G=2;H=B}else{B=(iob(D)|0)+1|0;G=B;H=f[b>>2]|0}E=G+A|0;F=H}if(!(F&128)){I=E;J=F}else{H=f[a+60>>2]|0;if(H>>>0<128){K=2;L=F}else{F=(iob(H)|0)+1|0;K=F;L=f[b>>2]|0}I=K+E|0;J=L}}else{I=0;J=c}if(!(J&7936))M=I;else{if(!(J&256)){N=I;O=J}else{c=f[a+44>>2]|0;if(c>>>0<128){P=2;Q=J}else{J=(iob(c)|0)+1|0;P=J;Q=f[b>>2]|0}N=P+I|0;O=Q}if(!(O&512)){R=N;S=O}else{Q=f[a+48>>2]|0;if(Q>>>0<128){T=2;U=O}else{O=(iob(Q)|0)+1|0;T=O;U=f[b>>2]|0}R=T+N|0;S=U}if(!(S&1024)){V=R;W=S}else{U=f[a+52>>2]|0;if((U|0)>=0)if(U>>>0<128){X=2;Y=S}else{N=(iob(U)|0)+1|0;X=N;Y=f[b>>2]|0}else{X=11;Y=S}V=X+R|0;W=Y}Y=W&2048|0?V+2|0:V;M=W&4096|0?Y+2|0:Y}Y=f[a+4>>2]|0;if(!(Y&1)){Z=M;_=a+12|0;f[_>>2]=Z;return Z|0}Z=(dQb(Y&-2)|0)+M|0;_=a+12|0;f[_>>2]=Z;return Z|0}function OPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+8|0;c=f[b>>2]|0;if(c&5){if(c&1){d=f[a+28>>2]|0;if((d|0)>=0)if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}else{e=11;g=c}}else{e=0;g=c}if(!(g&4))i=e;else{g=f[a+32>>2]|0;if(g>>>0<128)j=2;else j=(iob(g)|0)+1|0;i=j+e|0}}else i=0;e=a+16|0;j=f[e>>2]|0;if(!j){k=0;l=0}else{g=a+24|0;c=0;b=0;do{h=f[(f[g>>2]|0)+4+(c<<2)>>2]|0;if(h>>>0<128)m=1;else m=iob(h)|0;b=m+b|0;c=c+1|0}while((c|0)!=(j|0));k=b;l=f[e>>2]|0}e=k+i+l|0;l=f[a+4>>2]|0;if(!(l&1)){n=e;o=a+12|0;f[o>>2]=n;return n|0}n=(dQb(l&-2)|0)+e|0;o=a+12|0;f[o>>2]=n;return n|0}function PPa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;c=a+8|0;d=f[c>>2]|0;if(!(d&255)){e=0;g=d}else{if(!(d&1)){h=0;i=d}else{j=f[a+16>>2]|0;k=b[j+11>>0]|0;if(k<<24>>24<0){l=f[j+4>>2]|0;if(l>>>0<128){m=1;n=d;o=l}else{j=iob(l)|0;m=j;n=f[c>>2]|0;o=l}}else{m=1;n=d;o=k&255}h=o+1+m|0;i=n}n=i&2|0?h+5|0:h;if(!(i&4)){p=n;q=i}else{h=f[a+20>>2]|0;m=b[h+11>>0]|0;if(m<<24>>24<0){o=f[h+4>>2]|0;if(o>>>0<128){r=1;s=i;t=o}else{h=iob(o)|0;r=h;s=f[c>>2]|0;t=o}}else{r=1;s=i;t=m&255}p=n+1+t+r|0;q=s}if(!(q&8)){u=p;v=q}else{s=f[a+32>>2]|0;if(s>>>0<128){w=2;x=q}else{q=(iob(s)|0)+1|0;w=q;x=f[c>>2]|0}u=w+p|0;v=x}if(!(v&16)){y=u;z=v}else{x=f[a+36>>2]|0;if(x>>>0<128){A=2;B=v}else{v=(iob(x)|0)+1|0;A=v;B=f[c>>2]|0}y=A+u|0;z=B}B=z&32|0?y+2|0:y;y=z&64|0?B+5|0:B;e=z&128|0?y+5|0:y;g=z}if(g&7936){z=g&256|0?e+5|0:e;if(!(g&512)){C=z;D=g}else{y=f[a+44>>2]|0;if(y>>>0<128){E=2;F=g}else{g=(iob(y)|0)+1|0;E=g;F=f[c>>2]|0}C=E+z|0;D=F}if(!(D&1024)){G=C;H=D}else{F=f[a+24>>2]|0;z=b[F+11>>0]|0;if(z<<24>>24<0){E=f[F+4>>2]|0;if(E>>>0<128){I=1;J=D;K=E}else{F=iob(E)|0;I=F;J=f[c>>2]|0;K=E}}else{I=1;J=D;K=z&255}G=C+1+K+I|0;H=J}J=H&2048|0?G+2|0:G;if(!(H&4096))L=J;else{H=f[a+28>>2]|0;G=b[H+11>>0]|0;if(G<<24>>24<0){I=f[H+4>>2]|0;if(I>>>0<128){M=1;N=I}else{M=iob(I)|0;N=I}}else{M=1;N=G&255}L=J+1+N+M|0}}else L=e;e=f[a+4>>2]|0;if(!(e&1)){O=L;P=a+12|0;f[P>>2]=O;return O|0}O=(dQb(e&-2)|0)+L|0;P=a+12|0;f[P>>2]=O;return O|0}function QPa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=a+8|0;d=f[c>>2]|0;if(!(d&111))e=0;else{g=(d&1|0?5:0)|d&2;if(!(d&4)){h=g;i=d}else{j=f[a+32>>2]|0;if(j>>>0<128){k=2;l=d}else{d=(iob(j)|0)+1|0;k=d;l=f[c>>2]|0}h=k+g|0;i=l}if(!(i&8)){m=h;n=i}else{l=f[a+28>>2]|0;g=b[l+11>>0]|0;if(g<<24>>24<0){k=f[l+4>>2]|0;if(k>>>0<128){o=1;p=i;q=k}else{l=iob(k)|0;o=l;p=f[c>>2]|0;q=k}}else{o=1;p=i;q=g&255}m=h+1+q+o|0;n=p}p=n&32|0?m+2|0:m;e=n&64|0?p+2|0:p}p=f[a+16>>2]|0;n=p+e+(p<<2)|0;p=f[a+4>>2]|0;if(!(p&1)){r=n;s=a+12|0;f[s>>2]=r;return r|0}r=(dQb(p&-2)|0)+n|0;s=a+12|0;f[s>>2]=r;return r|0}function RPa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+8|0;c=f[b>>2]|0;if(!(c&7))d=0;else{if(c&1){e=f[a+16>>2]|0;if((e|0)>=0)if(e>>>0<128){g=2;h=c}else{i=(iob(e)|0)+1|0;g=i;h=f[b>>2]|0}else{g=11;h=c}}else{g=0;h=c}if(!(h&2)){j=g;k=h}else{c=f[a+24>>2]|0;if((c|0)>=0)if(c>>>0<128){l=2;m=h}else{i=(iob(c)|0)+1|0;l=i;m=f[b>>2]|0}else{l=11;m=h}j=l+g|0;k=m}d=k&4|0?j+2|0:j}j=f[a+4>>2]|0;if(!(j&1)){n=d;o=a+12|0;f[o>>2]=n;return n|0}n=(dQb(j&-2)|0)+d|0;o=a+12|0;f[o>>2]=n;return n|0}function SPa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=a+8|0;d=f[c>>2]|0;if(d&7){if(d&1){e=f[a+48>>2]|0;if((e|0)>=0)if(e>>>0<128){g=2;h=d}else{i=(iob(e)|0)+1|0;g=i;h=f[c>>2]|0}else{g=11;h=d}}else{g=0;h=d}if(!(h&2)){j=g;k=h}else{d=f[a+52>>2]|0;if((d|0)>=0)if(d>>>0<128){l=2;m=h}else{i=(iob(d)|0)+1|0;l=i;m=f[c>>2]|0}else{l=11;m=h}j=l+g|0;k=m}if(!(k&4))n=j;else{k=f[a+56>>2]|0;if((k|0)>=0)if(k>>>0<128)o=2;else o=(iob(k)|0)+1|0;else o=11;n=o+j|0}}else n=0;j=a+20|0;o=f[j>>2]|0;k=o+n|0;if((o|0)>0){n=a+28|0;m=0;g=k;l=o;while(1){o=f[(f[n>>2]|0)+4+(m<<2)>>2]|0;h=b[o+11>>0]|0;if(h<<24>>24<0){c=f[o+4>>2]|0;if(c>>>0<128){p=1;q=c;r=l}else{o=iob(c)|0;p=o;q=c;r=f[j>>2]|0}}else{p=1;q=h&255;r=l}h=q+g+p|0;m=m+1|0;if((m|0)>=(r|0)){s=h;break}else{g=h;l=r}}}else s=k;k=a+36|0;r=f[k>>2]|0;l=r+s|0;if((r|0)>0){s=a+44|0;g=0;m=l;p=r;while(1){r=f[(f[s>>2]|0)+4+(g<<2)>>2]|0;q=b[r+11>>0]|0;if(q<<24>>24<0){j=f[r+4>>2]|0;if(j>>>0<128){t=1;u=j;v=p}else{r=iob(j)|0;t=r;u=j;v=f[k>>2]|0}}else{t=1;u=q&255;v=p}q=u+m+t|0;g=g+1|0;if((g|0)>=(v|0)){w=q;break}else{m=q;p=v}}}else w=l;l=f[a+4>>2]|0;if(!(l&1)){x=w;y=a+12|0;f[y>>2]=x;return x|0}x=(dQb(l&-2)|0)+w|0;y=a+12|0;f[y>>2]=x;return x|0}function TPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+20|0;i=a+16|0;j=c+32|0;k=c+12|0;l=c+28|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[e>>2]=o;f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=_nb(c,r)|0;f[e>>2]=o;if((o+-1|0)>>>0<127){p=o;q=6}else{s=o;q=27}}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{switch(p|0){case 0:{t=1;q=33;break a;break}case 8:break;default:{u=p;break b}}f[g>>2]=f[g>>2]|2;o=f[c>>2]|0;if(o>>>0<(f[d>>2]|0)>>>0){a=b[o>>0]|0;n=a&255;if(a<<24>>24>-1){f[h>>2]=n;a=o+1|0;f[c>>2]=a;v=a}else{w=n;q=11}}else{w=0;q=11}if((q|0)==11){q=0;n=Knb(c,w)|0;a=J;f[h>>2]=n;if(!((a|0)>-1|(a|0)==-1&n>>>0>4294967295)){t=0;q=33;break a}v=f[c>>2]|0}n=f[d>>2]|0;if(v>>>0>=n>>>0)continue a;if((b[v>>0]|0)!=16)continue a;a=v+1|0;f[c>>2]=a;x=a;y=n;break}case 2:{switch(p|0){case 0:{t=1;q=33;break a;break}case 16:break;default:{u=p;break b}}x=f[c>>2]|0;y=f[d>>2]|0;break}default:{s=p;q=27;break b}}f[g>>2]=f[g>>2]|1;if(x>>>0<y>>>0){n=b[x>>0]|0;a=n&255;if(n<<24>>24>-1){n=x+1|0;f[c>>2]=n;z=a;A=n;B=y}else{C=a;q=21}}else{C=0;q=21}if((q|0)==21){q=0;a=Knb(c,C)|0;n=J;if(!((n|0)>-1|(n|0)==-1&a>>>0>4294967295)){t=0;q=33;break a}z=a;A=f[c>>2]|0;B=f[d>>2]|0}f[i>>2]=z;if((A|0)!=(B|0))continue a;if(f[j>>2]|0){q=26;break a}if((f[k>>2]|0)==(f[l>>2]|0)){q=26;break a}else continue a}while(0);if((q|0)==27){q=0;if(!s){t=1;q=33;break}else u=s}if((u&7|0)==4){t=1;q=33;break}a=f[m>>2]|0;if(!(a&1))D=hBa(m)|0;else D=a&-2;if(!(ZPb(c,u,D)|0)){t=0;q=33;break}}if((q|0)==26){f[e>>2]=0;b[c+24>>0]=1;t=1;return t|0}else if((q|0)==33)return t|0;return 0}function UPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+72|0;l=a+112|0;m=e+8|0;n=a+16|0;o=a+20|0;p=a+24|0;q=a+28|0;r=a+32|0;s=a+36|0;t=a+116|0;v=a+40|0;w=a+44|0;x=a+48|0;y=a+64|0;z=e+4|0;A=a+68|0;B=e+4|0;C=a+76|0;D=a+80|0;E=a+84|0;F=a+88|0;G=a+92|0;H=a+96|0;I=a+100|0;K=a+4|0;L=a+108|0;M=a+104|0;N=e+8|0;O=a+52|0;P=a+56|0;Q=a+60|0;a=c+32|0;R=c+12|0;S=c+28|0;a:while(1){T=f[c>>2]|0;U=f[g>>2]|0;do if(T>>>0<U>>>0){V=b[T>>0]|0;W=V&255;if(V<<24>>24>0){X=W;Y=1}else{V=T+1|0;if(V>>>0>=U>>>0){Z=W;_=7;break}$=h[V>>0]|0;if((($^128)&W)>>>0<=127){Z=W;_=7;break}X=W+-128+($<<7)|0;Y=2}f[i>>2]=X;f[c>>2]=T+Y;aa=X;_=9}else{Z=0;_=7}while(0);if((_|0)==7){_=0;T=_nb(c,Z)|0;f[i>>2]=T;if((T+-1|0)>>>0<16383){aa=T;_=9}else{ba=T;_=257}}b:do if((_|0)==9){_=0;c:do switch(aa>>>3&536870911|0){case 1:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 8:break;default:{da=aa;break b}}f[j>>2]=f[j>>2]|1;T=f[c>>2]|0;if(T>>>0<(f[g>>2]|0)>>>0){U=b[T>>0]|0;$=U&255;if(U<<24>>24>-1){f[k>>2]=$;U=T+1|0;f[c>>2]=U;ea=U}else{fa=$;_=14}}else{fa=0;_=14}if((_|0)==14){_=0;$=Knb(c,fa)|0;U=J;f[k>>2]=$;if(!((U|0)>-1|(U|0)==-1&$>>>0>4294967295)){ca=0;_=263;break a}ea=f[c>>2]|0}$=f[g>>2]|0;if(ea>>>0>=$>>>0)continue a;if((b[ea>>0]|0)!=16)continue a;U=ea+1|0;f[c>>2]=U;ga=U;ha=$;_=21;break}case 2:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 16:break;default:{da=aa;break b}}ga=f[c>>2]|0;ha=f[g>>2]|0;_=21;break}case 3:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 24:{ia=f[c>>2]|0;ja=f[g>>2]|0;_=31;break c;break}case 26:{if(wQa(c,n)|0){_=47;break c}else{ca=0;_=263;break a}break}default:{da=aa;break b}}break}case 4:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 32:{ka=f[c>>2]|0;la=f[g>>2]|0;_=53;break c;break}case 34:{if(wQa(c,q)|0){_=69;break c}else{ca=0;_=263;break a}break}default:{da=aa;break b}}break}case 5:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 40:break;default:{da=aa;break b}}ma=f[c>>2]|0;na=f[g>>2]|0;_=75;break}case 6:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 48:{oa=f[c>>2]|0;pa=f[g>>2]|0;_=85;break c;break}case 50:{if(wQa(c,v)|0){_=101;break c}else{ca=0;_=263;break a}break}default:{da=aa;break b}}break}case 7:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 58:{_=106;break}default:{da=aa;break b}}break}case 8:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 66:{_=120;break}default:{da=aa;break b}}break}case 9:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 72:break;default:{da=aa;break b}}qa=f[c>>2]|0;ra=f[g>>2]|0;_=135;break}case 10:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 80:break;default:{da=aa;break b}}sa=f[c>>2]|0;ta=f[g>>2]|0;_=145;break}case 11:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 88:break;default:{da=aa;break b}}ua=f[c>>2]|0;va=f[g>>2]|0;_=155;break}case 12:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 96:break;default:{da=aa;break b}}wa=f[c>>2]|0;xa=f[g>>2]|0;_=165;break}case 13:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 104:break;default:{da=aa;break b}}ya=f[c>>2]|0;za=f[g>>2]|0;_=175;break}case 14:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 112:break;default:{da=aa;break b}}Aa=f[c>>2]|0;Ba=f[g>>2]|0;_=185;break}case 15:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 120:break;default:{da=aa;break b}}Ca=f[c>>2]|0;Da=f[g>>2]|0;_=195;break}case 16:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 128:break;default:{da=aa;break b}}$=f[g>>2]|0;Ea=f[c>>2]|0;Fa=$;Ga=$;_=211;break}case 17:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 136:break;default:{da=aa;break b}}$=f[g>>2]|0;Ha=f[c>>2]|0;Ia=$;Ja=$;_=222;break}case 18:{switch(aa|0){case 0:{ca=1;_=263;break a;break}case 144:{Ka=f[c>>2]|0;La=f[g>>2]|0;_=233;break c;break}case 146:{if(wQa(c,O)|0){_=250;break c}else{ca=0;_=263;break a}break}default:{da=aa;break b}}break}default:{ba=aa;_=257;break b}}while(0);if((_|0)==21){_=0;f[j>>2]=f[j>>2]|2;if(ga>>>0<ha>>>0?($=b[ga>>0]|0,$<<24>>24>-1):0){U=ga+1|0;f[c>>2]=U;Ma=$<<24>>24!=0;Na=U;Oa=ha}else{Lnb(e,c);U=e;if(!(b[m>>0]|0)){ca=0;_=263;break a}Ma=(f[U>>2]|0)!=0|(f[U+4>>2]|0)!=0;Na=f[c>>2]|0;Oa=f[g>>2]|0}b[l>>0]=Ma&1;if(Na>>>0>=Oa>>>0)continue a;if((b[Na>>0]|0)==24){Pa=Na;Qa=Oa;_=30}else continue a}d:while(1){switch(_|0){case 30:{_=0;U=Pa+1|0;f[c>>2]=U;ia=U;ja=Qa;_=31;continue d;break}case 31:{_=0;if(ia>>>0<ja>>>0){U=b[ia>>0]|0;$=U&255;if(U<<24>>24>-1){f[c>>2]=ia+1;Ra=$}else{Sa=$;_=34}}else{Sa=0;_=34}if((_|0)==34){_=0;$=Knb(c,Sa)|0;U=J;if((U|0)>-1|(U|0)==-1&$>>>0>4294967295)Ra=$;else{ca=0;_=263;break a}}$=f[n>>2]|0;if(($|0)==(f[o>>2]|0)){rza(n,$+1|0);Ta=f[n>>2]|0}else Ta=$;$=f[p>>2]|0;f[n>>2]=Ta+1;f[$+4+(Ta<<2)>>2]=Ra;U=(f[o>>2]|0)-(f[n>>2]|0)|0;if((U|0)>0){Ua=U;Va=$}else{_=47;continue d}while(1){$=f[c>>2]|0;U=f[g>>2]|0;if($>>>0>=U>>>0){_=47;continue d}if((b[$>>0]|0)!=24){_=47;continue d}T=$+1|0;f[c>>2]=T;if(T>>>0<U>>>0){U=b[T>>0]|0;T=U&255;if(U<<24>>24>-1){f[c>>2]=$+2;Wa=T;Xa=Va}else{Ya=T;_=42}}else{Ya=0;_=42}if((_|0)==42){_=0;T=Knb(c,Ya)|0;$=J;if(!(($|0)>-1|($|0)==-1&T>>>0>4294967295)){ca=0;_=263;break a}Wa=T;Xa=f[p>>2]|0}T=f[n>>2]|0;f[n>>2]=T+1;f[Xa+4+(T<<2)>>2]=Wa;if((Ua|0)>1){Ua=Ua+-1|0;Va=Xa}else{_=47;continue d}}break}case 47:{_=0;T=f[c>>2]|0;$=f[g>>2]|0;if(T>>>0>=$>>>0)continue a;if((b[T>>0]|0)==24){Pa=T;Qa=$;_=30;continue d}if((b[T>>0]|0)==32){Za=T;_a=$;_=52}else continue a;break}case 53:{_=0;if(ka>>>0<la>>>0){$=b[ka>>0]|0;T=$&255;if($<<24>>24>-1){f[c>>2]=ka+1;$a=T}else{ab=T;_=56}}else{ab=0;_=56}if((_|0)==56){_=0;T=Knb(c,ab)|0;$=J;if(($|0)>-1|($|0)==-1&T>>>0>4294967295)$a=T;else{ca=0;_=263;break a}}T=f[q>>2]|0;if((T|0)==(f[r>>2]|0)){rza(q,T+1|0);bb=f[q>>2]|0}else bb=T;T=f[s>>2]|0;f[q>>2]=bb+1;f[T+4+(bb<<2)>>2]=$a;$=(f[r>>2]|0)-(f[q>>2]|0)|0;if(($|0)>0){cb=$;db=T}else{_=69;continue d}while(1){T=f[c>>2]|0;$=f[g>>2]|0;if(T>>>0>=$>>>0){_=69;continue d}if((b[T>>0]|0)!=32){_=69;continue d}U=T+1|0;f[c>>2]=U;if(U>>>0<$>>>0){$=b[U>>0]|0;U=$&255;if($<<24>>24>-1){f[c>>2]=T+2;eb=U;fb=db}else{gb=U;_=64}}else{gb=0;_=64}if((_|0)==64){_=0;U=Knb(c,gb)|0;T=J;if(!((T|0)>-1|(T|0)==-1&U>>>0>4294967295)){ca=0;_=263;break a}eb=U;fb=f[s>>2]|0}U=f[q>>2]|0;f[q>>2]=U+1;f[fb+4+(U<<2)>>2]=eb;if((cb|0)>1){cb=cb+-1|0;db=fb}else{_=69;continue d}}break}case 69:{_=0;U=f[c>>2]|0;T=f[g>>2]|0;if(U>>>0>=T>>>0)continue a;if((b[U>>0]|0)==32){Za=U;_a=T;_=52}else{if((b[U>>0]|0)!=40)continue a;$=U+1|0;f[c>>2]=$;ma=$;na=T;_=75;continue d}break}case 75:{_=0;f[j>>2]=f[j>>2]|4096;if(ma>>>0<na>>>0){T=b[ma>>0]|0;$=T&255;if(T<<24>>24>-1){f[t>>2]=$;T=ma+1|0;f[c>>2]=T;hb=T;ib=na}else{jb=$;_=78}}else{jb=0;_=78}if((_|0)==78){_=0;$=Knb(c,jb)|0;T=J;f[t>>2]=$;if(!((T|0)>-1|(T|0)==-1&$>>>0>4294967295)){ca=0;_=263;break a}hb=f[c>>2]|0;ib=f[g>>2]|0}if(hb>>>0>=ib>>>0)continue a;if((b[hb>>0]|0)==48){kb=hb;lb=ib;_=84}else continue a;break}case 85:{_=0;if(oa>>>0<pa>>>0){$=b[oa>>0]|0;T=$&255;if($<<24>>24>-1){f[c>>2]=oa+1;mb=T}else{nb=T;_=88}}else{nb=0;_=88}if((_|0)==88){_=0;T=Knb(c,nb)|0;$=J;if(($|0)>-1|($|0)==-1&T>>>0>4294967295)mb=T;else{ca=0;_=263;break a}}T=f[v>>2]|0;if((T|0)==(f[w>>2]|0)){rza(v,T+1|0);ob=f[v>>2]|0}else ob=T;T=f[x>>2]|0;f[v>>2]=ob+1;f[T+4+(ob<<2)>>2]=mb;$=(f[w>>2]|0)-(f[v>>2]|0)|0;if(($|0)>0){pb=$;qb=T}else{_=101;continue d}while(1){T=f[c>>2]|0;$=f[g>>2]|0;if(T>>>0>=$>>>0){_=101;continue d}if((b[T>>0]|0)!=48){_=101;continue d}U=T+1|0;f[c>>2]=U;if(U>>>0<$>>>0){$=b[U>>0]|0;U=$&255;if($<<24>>24>-1){f[c>>2]=T+2;rb=U;sb=qb}else{tb=U;_=96}}else{tb=0;_=96}if((_|0)==96){_=0;U=Knb(c,tb)|0;T=J;if(!((T|0)>-1|(T|0)==-1&U>>>0>4294967295)){ca=0;_=263;break a}rb=U;sb=f[x>>2]|0}U=f[v>>2]|0;f[v>>2]=U+1;f[sb+4+(U<<2)>>2]=rb;if((pb|0)>1){pb=pb+-1|0;qb=sb}else{_=101;continue d}}break}case 101:{_=0;U=f[c>>2]|0;T=f[g>>2]|0;if(U>>>0>=T>>>0)continue a;if((b[U>>0]|0)==48){kb=U;lb=T;_=84}else{if((b[U>>0]|0)!=58)continue a;f[c>>2]=U+1;_=106;continue d}break}case 106:{_=0;f[j>>2]=f[j>>2]|8192;U=f[y>>2]|0;if(!U){T=L5b(48)|0;GNa(T);f[y>>2]=T;ub=T}else ub=U;U=f[c>>2]|0;if(U>>>0<(f[g>>2]|0)>>>0?(T=b[U>>0]|0,T<<24>>24>-1):0){f[c>>2]=U+1;vb=T&255}else{T=Znb(c)|0;if((T|0)>-1)vb=T;else{ca=0;_=263;break a}}Inb(e,c,vb);if((f[z>>2]|0)<0){_=114;break a}if(!(JNa(ub,c)|0)){_=114;break a}if(!(Onb(c,f[e>>2]|0)|0)){ca=0;_=263;break a}T=f[c>>2]|0;if(T>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[T>>0]|0)!=66)continue a;f[c>>2]=T+1;_=120;continue d;break}case 120:{_=0;f[j>>2]=f[j>>2]|16384;T=f[A>>2]|0;if(!T){U=L5b(48)|0;GNa(U);f[A>>2]=U;wb=U}else wb=T;T=f[c>>2]|0;if(T>>>0<(f[g>>2]|0)>>>0?(U=b[T>>0]|0,U<<24>>24>-1):0){f[c>>2]=T+1;xb=U&255}else{U=Znb(c)|0;if((U|0)>-1)xb=U;else{ca=0;_=263;break a}}Inb(e,c,xb);if((f[B>>2]|0)<0){_=128;break a}if(!(JNa(wb,c)|0)){_=128;break a}if(!(Onb(c,f[e>>2]|0)|0)){ca=0;_=263;break a}U=f[c>>2]|0;T=f[g>>2]|0;if(U>>>0>=T>>>0)continue a;if((b[U>>0]|0)!=72)continue a;$=U+1|0;f[c>>2]=$;qa=$;ra=T;_=135;continue d;break}case 135:{_=0;f[j>>2]=f[j>>2]|64;if(qa>>>0<ra>>>0){T=b[qa>>0]|0;$=T&255;if(T<<24>>24>-1){f[C>>2]=$;T=qa+1|0;f[c>>2]=T;yb=T;zb=ra}else{Ab=$;_=138}}else{Ab=0;_=138}if((_|0)==138){_=0;$=Knb(c,Ab)|0;T=J;f[C>>2]=$;if(!((T|0)>-1|(T|0)==-1&$>>>0>4294967295)){ca=0;_=263;break a}yb=f[c>>2]|0;zb=f[g>>2]|0}if(yb>>>0>=zb>>>0)continue a;if((b[yb>>0]|0)!=80)continue a;$=yb+1|0;f[c>>2]=$;sa=$;ta=zb;_=145;continue d;break}case 145:{_=0;f[j>>2]=f[j>>2]|128;if(sa>>>0<ta>>>0){$=b[sa>>0]|0;T=$&255;if($<<24>>24>-1){f[D>>2]=T;$=sa+1|0;f[c>>2]=$;Bb=$;Cb=ta}else{Db=T;_=148}}else{Db=0;_=148}if((_|0)==148){_=0;T=Knb(c,Db)|0;$=J;f[D>>2]=T;if(!(($|0)>-1|($|0)==-1&T>>>0>4294967295)){ca=0;_=263;break a}Bb=f[c>>2]|0;Cb=f[g>>2]|0}if(Bb>>>0>=Cb>>>0)continue a;if((b[Bb>>0]|0)!=88)continue a;T=Bb+1|0;f[c>>2]=T;ua=T;va=Cb;_=155;continue d;break}case 155:{_=0;f[j>>2]=f[j>>2]|256;if(ua>>>0<va>>>0){T=b[ua>>0]|0;$=T&255;if(T<<24>>24>-1){f[E>>2]=$;T=ua+1|0;f[c>>2]=T;Eb=T;Fb=va}else{Gb=$;_=158}}else{Gb=0;_=158}if((_|0)==158){_=0;$=Knb(c,Gb)|0;T=J;f[E>>2]=$;if(!((T|0)>-1|(T|0)==-1&$>>>0>4294967295)){ca=0;_=263;break a}Eb=f[c>>2]|0;Fb=f[g>>2]|0}if(Eb>>>0>=Fb>>>0)continue a;if((b[Eb>>0]|0)!=96)continue a;$=Eb+1|0;f[c>>2]=$;wa=$;xa=Fb;_=165;continue d;break}case 165:{_=0;f[j>>2]=f[j>>2]|512;if(wa>>>0<xa>>>0){$=b[wa>>0]|0;T=$&255;if($<<24>>24>-1){f[F>>2]=T;$=wa+1|0;f[c>>2]=$;Hb=$;Ib=xa}else{Jb=T;_=168}}else{Jb=0;_=168}if((_|0)==168){_=0;T=Knb(c,Jb)|0;$=J;f[F>>2]=T;if(!(($|0)>-1|($|0)==-1&T>>>0>4294967295)){ca=0;_=263;break a}Hb=f[c>>2]|0;Ib=f[g>>2]|0}if(Hb>>>0>=Ib>>>0)continue a;if((b[Hb>>0]|0)!=104)continue a;T=Hb+1|0;f[c>>2]=T;ya=T;za=Ib;_=175;continue d;break}case 175:{_=0;f[j>>2]=f[j>>2]|1024;if(ya>>>0<za>>>0){T=b[ya>>0]|0;$=T&255;if(T<<24>>24>-1){f[G>>2]=$;T=ya+1|0;f[c>>2]=T;Kb=T;Lb=za}else{Mb=$;_=178}}else{Mb=0;_=178}if((_|0)==178){_=0;$=Knb(c,Mb)|0;T=J;f[G>>2]=$;if(!((T|0)>-1|(T|0)==-1&$>>>0>4294967295)){ca=0;_=263;break a}Kb=f[c>>2]|0;Lb=f[g>>2]|0}if(Kb>>>0>=Lb>>>0)continue a;if((b[Kb>>0]|0)!=112)continue a;$=Kb+1|0;f[c>>2]=$;Aa=$;Ba=Lb;_=185;continue d;break}case 185:{_=0;f[j>>2]=f[j>>2]|2048;if(Aa>>>0<Ba>>>0){$=b[Aa>>0]|0;T=$&255;if($<<24>>24>-1){f[H>>2]=T;$=Aa+1|0;f[c>>2]=$;Nb=$;Ob=Ba}else{Pb=T;_=188}}else{Pb=0;_=188}if((_|0)==188){_=0;T=Knb(c,Pb)|0;$=J;f[H>>2]=T;if(!(($|0)>-1|($|0)==-1&T>>>0>4294967295)){ca=0;_=263;break a}Nb=f[c>>2]|0;Ob=f[g>>2]|0}if(Nb>>>0>=Ob>>>0)continue a;if((b[Nb>>0]|0)!=120)continue a;T=Nb+1|0;f[c>>2]=T;Ca=T;Da=Ob;_=195;continue d;break}case 195:{_=0;if(Ca>>>0<Da>>>0){T=b[Ca>>0]|0;$=T&255;if(T<<24>>24>-1){f[c>>2]=Ca+1;Qb=$}else{Rb=$;_=198}}else{Rb=0;_=198}if((_|0)==198){_=0;$=Knb(c,Rb)|0;T=J;if((T|0)>-1|(T|0)==-1&$>>>0>4294967295)Qb=$;else{ca=0;_=263;break a}}if(Qb>>>0<3){f[j>>2]=f[j>>2]|32768;f[I>>2]=Qb}else{$=f[K>>2]|0;if(!($&1))Sb=hBa(K)|0;else Sb=$&-2;NPb(Sb,15,Qb,((Qb|0)<0)<<31>>31)}$=f[g>>2]|0;T=f[c>>2]|0;U=T;if(($-T|0)<=1)continue a;if((b[U>>0]|0)!=-128)continue a;if((b[U+1>>0]|0)!=1)continue a;T=U+2|0;f[c>>2]=T;Ea=T;Fa=$;Ga=$;_=211;continue d;break}case 211:{_=0;f[j>>2]=f[j>>2]|65536;if(Ea>>>0<Fa>>>0){$=b[Ea>>0]|0;T=$&255;if($<<24>>24>-1){$=Ea+1|0;f[c>>2]=$;Tb=T;Ub=$;Vb=Ga;Wb=Fa}else{Xb=T;_=214}}else{Xb=0;_=214}if((_|0)==214){_=0;T=Knb(c,Xb)|0;$=J;if(!(($|0)>-1|($|0)==-1&T>>>0>4294967295)){ca=0;_=263;break a}$=f[g>>2]|0;Tb=T;Ub=f[c>>2]|0;Vb=$;Wb=$}f[L>>2]=Tb;$=Ub;if((Vb-Ub|0)<=1)continue a;if((b[$>>0]|0)!=-120)continue a;if((b[$+1>>0]|0)!=1)continue a;T=$+2|0;f[c>>2]=T;Ha=T;Ia=Wb;Ja=Vb;_=222;continue d;break}case 222:{_=0;f[j>>2]=f[j>>2]|131072;if(Ha>>>0<Ia>>>0?(T=b[Ha>>0]|0,T<<24>>24>-1):0){$=Ha+1|0;f[c>>2]=$;Yb=T<<24>>24!=0;Zb=$;_b=Ja;$b=Ia}else{Lnb(e,c);$=e;if(!(b[N>>0]|0)){ca=0;_=263;break a}T=f[g>>2]|0;Yb=(f[$>>2]|0)!=0|(f[$+4>>2]|0)!=0;Zb=f[c>>2]|0;_b=T;$b=T}b[M>>0]=Yb&1;T=Zb;if((_b-Zb|0)<=1)continue a;if((b[T>>0]|0)!=-112)continue a;if((b[T+1>>0]|0)==1){ac=T;bc=$b;_=232}else continue a;break}case 233:{_=0;if(Ka>>>0<La>>>0){T=b[Ka>>0]|0;$=T&255;if(T<<24>>24>-1){f[c>>2]=Ka+1;cc=$}else{dc=$;_=236}}else{dc=0;_=236}if((_|0)==236){_=0;$=Knb(c,dc)|0;T=J;if((T|0)>-1|(T|0)==-1&$>>>0>4294967295)cc=$;else{ca=0;_=263;break a}}$=f[O>>2]|0;if(($|0)==(f[P>>2]|0)){rza(O,$+1|0);ec=f[O>>2]|0}else ec=$;$=f[Q>>2]|0;f[O>>2]=ec+1;f[$+4+(ec<<2)>>2]=cc;T=(f[P>>2]|0)-(f[O>>2]|0)|0;if((T|0)>0){fc=T;gc=$}else{_=250;continue d}while(1){$=f[g>>2]|0;T=f[c>>2]|0;U=T;if(($-T|0)<=1){_=250;continue d}if((b[U>>0]|0)!=-112){_=250;continue d}if((b[U+1>>0]|0)!=1){_=250;continue d}T=U+2|0;f[c>>2]=T;if(T>>>0<$>>>0){$=b[T>>0]|0;T=$&255;if($<<24>>24>-1){f[c>>2]=U+3;hc=T;ic=gc}else{jc=T;_=245}}else{jc=0;_=245}if((_|0)==245){_=0;T=Knb(c,jc)|0;U=J;if(!((U|0)>-1|(U|0)==-1&T>>>0>4294967295)){ca=0;_=263;break a}hc=T;ic=f[Q>>2]|0}T=f[O>>2]|0;f[O>>2]=T+1;f[ic+4+(T<<2)>>2]=hc;if((fc|0)>1){fc=fc+-1|0;gc=ic}else{_=250;continue d}}break}case 250:{_=0;T=f[g>>2]|0;U=f[c>>2]|0;kc=U;lc=T;if((T-U|0)<=1)break d;if((b[kc>>0]|0)!=-112)break d;if((b[kc+1>>0]|0)==1){ac=kc;bc=lc;_=232}else break d;break}}if((_|0)==52){_=0;U=Za+1|0;f[c>>2]=U;ka=U;la=_a;_=53;continue}else if((_|0)==84){_=0;U=kb+1|0;f[c>>2]=U;oa=U;pa=lb;_=85;continue}else if((_|0)==232){_=0;U=ac+2|0;f[c>>2]=U;Ka=U;La=bc;_=233;continue}}if((kc|0)!=(lc|0))continue a;if(f[a>>2]|0){_=256;break a}if((f[R>>2]|0)==(f[S>>2]|0)){_=256;break a}else continue a}while(0);if((_|0)==257){_=0;if(!ba){ca=1;_=263;break}else da=ba}if((da&7|0)==4){ca=1;_=263;break}U=f[K>>2]|0;if(!(U&1))mc=hBa(K)|0;else mc=U&-2;if(!(ZPb(c,da,mc)|0)){ca=0;_=263;break}}if((_|0)==114){ca=0;u=d;return ca|0}else if((_|0)==128){ca=0;u=d;return ca|0}else if((_|0)==256){f[i>>2]=0;b[c+24>>0]=1;ca=1;u=d;return ca|0}else if((_|0)==263){u=d;return ca|0}return 0}function VPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+16|0;l=a+44|0;m=a+20|0;n=a+24|0;o=a+36|0;p=a+40|0;q=e+8|0;r=a+28|0;s=a+32|0;t=a+4|0;v=a+41|0;w=e+8|0;x=a+48|0;a=c+32|0;y=c+12|0;z=c+28|0;a:while(1){A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0){B=b[A>>0]|0;C=B&255;if(B<<24>>24>0){f[i>>2]=C;f[c>>2]=A+1;D=C;E=6}else{F=C;E=5}}else{F=0;E=5}if((E|0)==5){E=0;C=_nb(c,F)|0;f[i>>2]=C;if((C+-1|0)>>>0<127){D=C;E=6}else{G=C;E=107}}b:do if((E|0)==6){E=0;do switch(D>>>3&536870911|0){case 1:{switch(D|0){case 0:{H=1;E=113;break a;break}case 10:break;default:{I=D;break b}}f[j>>2]=f[j>>2]|1;C=f[k>>2]|0;if((C|0)==497760){jza(k,497760);K=f[k>>2]|0}else K=C;if(!(fqb(c,K)|0)){H=0;E=113;break a}C=f[c>>2]|0;A=f[g>>2]|0;if(C>>>0>=A>>>0)continue a;if((b[C>>0]|0)!=21)continue a;B=C+1|0;f[c>>2]=B;L=B;M=A;E=16;break}case 2:{switch(D|0){case 0:{H=1;E=113;break a;break}case 21:break;default:{I=D;break b}}L=f[c>>2]|0;M=f[g>>2]|0;E=16;break}case 3:{switch(D|0){case 0:{H=1;E=113;break a;break}case 26:{E=25;break}default:{I=D;break b}}break}case 4:{switch(D|0){case 0:{H=1;E=113;break a;break}case 32:break;default:{I=D;break b}}N=f[c>>2]|0;O=f[g>>2]|0;E=33;break}case 5:{switch(D|0){case 0:{H=1;E=113;break a;break}case 40:break;default:{I=D;break b}}P=f[c>>2]|0;Q=f[g>>2]|0;E=43;break}case 6:{switch(D|0){case 0:{H=1;E=113;break a;break}case 48:break;default:{I=D;break b}}R=f[c>>2]|0;S=f[g>>2]|0;E=53;break}case 7:{switch(D|0){case 0:{H=1;E=113;break a;break}case 56:break;default:{I=D;break b}}T=f[c>>2]|0;U=f[g>>2]|0;E=63;break}case 8:{switch(D|0){case 0:{H=1;E=113;break a;break}case 64:break;default:{I=D;break b}}V=f[c>>2]|0;W=f[g>>2]|0;E=73;break}case 9:{switch(D|0){case 0:{H=1;E=113;break a;break}case 72:break;default:{I=D;break b}}X=f[c>>2]|0;Y=f[g>>2]|0;E=88;break}case 10:{switch(D|0){case 0:{H=1;E=113;break a;break}case 80:break;default:{I=D;break b}}Z=f[c>>2]|0;_=f[g>>2]|0;break}default:{G=D;E=107;break b}}while(0);if((E|0)==16){E=0;f[j>>2]=f[j>>2]|16;if((M-L|0)>3){A=L;B=h[A>>0]|h[A+1>>0]<<8|h[A+2>>0]<<16|h[A+3>>0]<<24;f[e>>2]=B;A=L+4|0;f[c>>2]=A;$=B;aa=A}else{if(!(Xnb(c,e)|0)){E=20;break a}$=f[e>>2]|0;aa=f[c>>2]|0}f[l>>2]=$;if(aa>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[aa>>0]|0)!=26)continue a;f[c>>2]=aa+1;E=25}if((E|0)==25){E=0;f[j>>2]=f[j>>2]|32;A=f[m>>2]|0;if((A|0)==497760){jza(m,497760);ba=f[m>>2]|0}else ba=A;if(!(fqb(c,ba)|0)){H=0;E=113;break a}A=f[c>>2]|0;B=f[g>>2]|0;if(A>>>0>=B>>>0)continue a;if((b[A>>0]|0)!=32)continue a;C=A+1|0;f[c>>2]=C;N=C;O=B;E=33}if((E|0)==33){E=0;f[j>>2]=f[j>>2]|2;if(N>>>0<O>>>0){B=b[N>>0]|0;C=B&255;if(B<<24>>24>-1){f[n>>2]=C;B=N+1|0;f[c>>2]=B;ca=B;da=O}else{ea=C;E=36}}else{ea=0;E=36}if((E|0)==36){E=0;C=Knb(c,ea)|0;B=J;f[n>>2]=C;if(!((B|0)>-1|(B|0)==-1&C>>>0>4294967295)){H=0;E=113;break a}ca=f[c>>2]|0;da=f[g>>2]|0}if(ca>>>0>=da>>>0)continue a;if((b[ca>>0]|0)!=40)continue a;C=ca+1|0;f[c>>2]=C;P=C;Q=da;E=43}if((E|0)==43){E=0;f[j>>2]=f[j>>2]|64;if(P>>>0<Q>>>0){C=b[P>>0]|0;B=C&255;if(C<<24>>24>-1){f[o>>2]=B;C=P+1|0;f[c>>2]=C;fa=C;ga=Q}else{ha=B;E=46}}else{ha=0;E=46}if((E|0)==46){E=0;B=Knb(c,ha)|0;C=J;f[o>>2]=B;if(!((C|0)>-1|(C|0)==-1&B>>>0>4294967295)){H=0;E=113;break a}fa=f[c>>2]|0;ga=f[g>>2]|0}if(fa>>>0>=ga>>>0)continue a;if((b[fa>>0]|0)!=48)continue a;B=fa+1|0;f[c>>2]=B;R=B;S=ga;E=53}if((E|0)==53){E=0;f[j>>2]=f[j>>2]|128;if(R>>>0<S>>>0?(B=b[R>>0]|0,B<<24>>24>-1):0){C=R+1|0;f[c>>2]=C;ia=B<<24>>24!=0;ja=C;ka=S}else{Lnb(e,c);C=e;if(!(b[q>>0]|0)){H=0;E=113;break a}ia=(f[C>>2]|0)!=0|(f[C+4>>2]|0)!=0;ja=f[c>>2]|0;ka=f[g>>2]|0}b[p>>0]=ia&1;if(ja>>>0>=ka>>>0)continue a;if((b[ja>>0]|0)!=56)continue a;C=ja+1|0;f[c>>2]=C;T=C;U=ka;E=63}if((E|0)==63){E=0;f[j>>2]=f[j>>2]|4;if(T>>>0<U>>>0){C=b[T>>0]|0;B=C&255;if(C<<24>>24>-1){f[r>>2]=B;C=T+1|0;f[c>>2]=C;la=C;ma=U}else{na=B;E=66}}else{na=0;E=66}if((E|0)==66){E=0;B=Knb(c,na)|0;C=J;f[r>>2]=B;if(!((C|0)>-1|(C|0)==-1&B>>>0>4294967295)){H=0;E=113;break a}la=f[c>>2]|0;ma=f[g>>2]|0}if(la>>>0>=ma>>>0)continue a;if((b[la>>0]|0)!=64)continue a;B=la+1|0;f[c>>2]=B;V=B;W=ma;E=73}if((E|0)==73){E=0;if(V>>>0<W>>>0){B=b[V>>0]|0;C=B&255;if(B<<24>>24>-1){f[c>>2]=V+1;oa=C}else{pa=C;E=76}}else{pa=0;E=76}if((E|0)==76){E=0;C=Knb(c,pa)|0;B=J;if((B|0)>-1|(B|0)==-1&C>>>0>4294967295)oa=C;else{H=0;E=113;break a}}if(oa>>>0<2){f[j>>2]=f[j>>2]|8;f[s>>2]=oa}else{C=f[t>>2]|0;if(!(C&1))qa=hBa(t)|0;else qa=C&-2;NPb(qa,8,oa,((oa|0)<0)<<31>>31)}C=f[c>>2]|0;B=f[g>>2]|0;if(C>>>0>=B>>>0)continue a;if((b[C>>0]|0)!=72)continue a;A=C+1|0;f[c>>2]=A;X=A;Y=B;E=88}if((E|0)==88){E=0;f[j>>2]=f[j>>2]|256;if(X>>>0<Y>>>0?(B=b[X>>0]|0,B<<24>>24>-1):0){A=X+1|0;f[c>>2]=A;ra=B<<24>>24!=0;sa=A;ta=Y}else{Lnb(e,c);A=e;if(!(b[w>>0]|0)){H=0;E=113;break a}ra=(f[A>>2]|0)!=0|(f[A+4>>2]|0)!=0;sa=f[c>>2]|0;ta=f[g>>2]|0}b[v>>0]=ra&1;if(sa>>>0>=ta>>>0)continue a;if((b[sa>>0]|0)!=80)continue a;A=sa+1|0;f[c>>2]=A;Z=A;_=ta}f[j>>2]=f[j>>2]|512;if(Z>>>0<_>>>0){A=b[Z>>0]|0;B=A&255;if(A<<24>>24>-1){f[x>>2]=B;A=Z+1|0;f[c>>2]=A;ua=A;va=_}else{wa=B;E=101}}else{wa=0;E=101}if((E|0)==101){E=0;B=Knb(c,wa)|0;A=J;f[x>>2]=B;if(!((A|0)>-1|(A|0)==-1&B>>>0>4294967295)){H=0;E=113;break a}ua=f[c>>2]|0;va=f[g>>2]|0}if((ua|0)!=(va|0))continue a;if(f[a>>2]|0){E=106;break a}if((f[y>>2]|0)==(f[z>>2]|0)){E=106;break a}else continue a}while(0);if((E|0)==107){E=0;if(!G){H=1;E=113;break}else I=G}if((I&7|0)==4){H=1;E=113;break}B=f[t>>2]|0;if(!(B&1))xa=hBa(t)|0;else xa=B&-2;if(!(ZPb(c,I,xa)|0)){H=0;E=113;break}}if((E|0)==20){H=0;u=d;return H|0}else if((E|0)==106){f[i>>2]=0;b[c+24>>0]=1;H=1;u=d;return H|0}else if((E|0)==113){u=d;return H|0}return 0}function WPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+16|0;l=a+20|0;m=c+32|0;n=c+12|0;o=c+28|0;p=e+8|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[i>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[i>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=27}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=33;break a;break}case 13:break;default:{z=t;break b}}f[j>>2]=f[j>>2]|1;s=f[g>>2]|0;a=f[c>>2]|0;if((s-a|0)>3){r=a;A=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=A;r=a+4|0;f[c>>2]=r;B=A;C=r;D=s}else{if(!(Xnb(c,e)|0)){v=12;break a}B=f[e>>2]|0;C=f[c>>2]|0;D=f[g>>2]|0}f[k>>2]=B;if(C>>>0>=D>>>0)continue a;if((b[C>>0]|0)!=16)continue a;s=C+1|0;f[c>>2]=s;E=s;F=D;break}case 2:{switch(t|0){case 0:{y=1;v=33;break a;break}case 16:break;default:{z=t;break b}}E=f[c>>2]|0;F=f[g>>2]|0;break}default:{x=t;v=27;break b}}f[j>>2]=f[j>>2]|2;if(E>>>0<F>>>0?(s=b[E>>0]|0,s<<24>>24>-1):0){r=E+1|0;f[c>>2]=r;G=s<<24>>24!=0;H=r;I=F}else{Lnb(e,c);r=e;if(!(b[p>>0]|0)){y=0;v=33;break a}G=(f[r>>2]|0)!=0|(f[r+4>>2]|0)!=0;H=f[c>>2]|0;I=f[g>>2]|0}b[l>>0]=G&1;if((H|0)!=(I|0))continue a;if(f[m>>2]|0){v=26;break a}if((f[n>>2]|0)==(f[o>>2]|0)){v=26;break a}else continue a}while(0);if((v|0)==27){v=0;if(!x){y=1;v=33;break}else z=x}if((z&7|0)==4){y=1;v=33;break}r=f[q>>2]|0;if(!(r&1))J=hBa(q)|0;else J=r&-2;if(!(ZPb(c,z,J)|0)){y=0;v=33;break}}if((v|0)==12){y=0;u=d;return y|0}else if((v|0)==26){f[i>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==33){u=d;return y|0}return 0}function XPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+16|0;k=a+20|0;l=a+24|0;m=c+32|0;n=c+12|0;o=c+28|0;p=e+8|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[h>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[h>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=35}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=41;break a;break}case 10:break;default:{z=t;break b}}f[i>>2]=f[i>>2]|1;s=f[j>>2]|0;if((s|0)==497760){jza(j,497760);A=f[j>>2]|0}else A=s;if(!(fqb(c,A)|0)){y=0;v=41;break a}s=f[c>>2]|0;a=f[g>>2]|0;if(s>>>0>=a>>>0)continue a;if((b[s>>0]|0)!=16)continue a;r=s+1|0;f[c>>2]=r;B=r;C=a;v=16;break}case 2:{switch(t|0){case 0:{y=1;v=41;break a;break}case 16:break;default:{z=t;break b}}B=f[c>>2]|0;C=f[g>>2]|0;v=16;break}case 3:{switch(t|0){case 0:{y=1;v=41;break a;break}case 24:break;default:{z=t;break b}}D=f[c>>2]|0;E=f[g>>2]|0;break}default:{x=t;v=35;break b}}if((v|0)==16){v=0;f[i>>2]=f[i>>2]|2;if(B>>>0<C>>>0){a=b[B>>0]|0;r=a&255;if(a<<24>>24>-1){f[k>>2]=r;a=B+1|0;f[c>>2]=a;F=a;G=C}else{H=r;v=19}}else{H=0;v=19}if((v|0)==19){v=0;r=Knb(c,H)|0;a=J;f[k>>2]=r;if(!((a|0)>-1|(a|0)==-1&r>>>0>4294967295)){y=0;v=41;break a}F=f[c>>2]|0;G=f[g>>2]|0}if(F>>>0>=G>>>0)continue a;if((b[F>>0]|0)!=24)continue a;r=F+1|0;f[c>>2]=r;D=r;E=G}f[i>>2]=f[i>>2]|4;if(D>>>0<E>>>0?(r=b[D>>0]|0,r<<24>>24>-1):0){a=D+1|0;f[c>>2]=a;I=r<<24>>24!=0;K=a;L=E}else{Lnb(e,c);a=e;if(!(b[p>>0]|0)){y=0;v=41;break a}I=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0;K=f[c>>2]|0;L=f[g>>2]|0}b[l>>0]=I&1;if((K|0)!=(L|0))continue a;if(f[m>>2]|0){v=34;break a}if((f[n>>2]|0)==(f[o>>2]|0)){v=34;break a}else continue a}while(0);if((v|0)==35){v=0;if(!x){y=1;v=41;break}else z=x}if((z&7|0)==4){y=1;v=41;break}a=f[q>>2]|0;if(!(a&1))M=hBa(q)|0;else M=a&-2;if(!(ZPb(c,z,M)|0)){y=0;v=41;break}}if((v|0)==34){f[h>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==41){u=d;return y|0}return 0}function YPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+16|0;l=a+48|0;m=a+20|0;n=a+52|0;o=a+44|0;p=a+41|0;q=e+8|0;r=a+28|0;s=a+40|0;t=e+8|0;v=a+32|0;w=a+36|0;x=a+56|0;y=e+8|0;z=a+24|0;A=c+32|0;B=c+12|0;C=c+28|0;D=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){E=b[a>>0]|0;F=E&255;if(E<<24>>24>0){f[i>>2]=F;f[c>>2]=a+1;G=F;H=6}else{I=F;H=5}}else{I=0;H=5}if((H|0)==5){H=0;F=_nb(c,I)|0;f[i>>2]=F;if((F+-1|0)>>>0<127){G=F;H=6}else{K=F;H=119}}b:do if((H|0)==6){H=0;do switch(G>>>3&536870911|0){case 1:{switch(G|0){case 0:{L=1;H=125;break a;break}case 10:break;default:{M=G;break b}}f[j>>2]=f[j>>2]|1;F=f[k>>2]|0;if((F|0)==497760){jza(k,497760);N=f[k>>2]|0}else N=F;if(!(fqb(c,N)|0)){L=0;H=125;break a}F=f[c>>2]|0;a=f[g>>2]|0;if(F>>>0>=a>>>0)continue a;if((b[F>>0]|0)!=21)continue a;E=F+1|0;f[c>>2]=E;O=E;P=a;H=16;break}case 2:{switch(G|0){case 0:{L=1;H=125;break a;break}case 21:break;default:{M=G;break b}}O=f[c>>2]|0;P=f[g>>2]|0;H=16;break}case 3:{switch(G|0){case 0:{L=1;H=125;break a;break}case 26:{H=25;break}default:{M=G;break b}}break}case 4:{switch(G|0){case 0:{L=1;H=125;break a;break}case 32:break;default:{M=G;break b}}Q=f[c>>2]|0;R=f[g>>2]|0;H=33;break}case 5:{switch(G|0){case 0:{L=1;H=125;break a;break}case 40:break;default:{M=G;break b}}S=f[c>>2]|0;T=f[g>>2]|0;H=43;break}case 6:{switch(G|0){case 0:{L=1;H=125;break a;break}case 48:break;default:{M=G;break b}}U=f[c>>2]|0;V=f[g>>2]|0;H=53;break}case 7:{switch(G|0){case 0:{L=1;H=125;break a;break}case 56:break;default:{M=G;break b}}W=f[c>>2]|0;X=f[g>>2]|0;H=63;break}case 8:{switch(G|0){case 0:{L=1;H=125;break a;break}case 64:break;default:{M=G;break b}}Y=f[c>>2]|0;Z=f[g>>2]|0;H=73;break}case 9:{switch(G|0){case 0:{L=1;H=125;break a;break}case 72:break;default:{M=G;break b}}_=f[c>>2]|0;$=f[g>>2]|0;H=83;break}case 10:{switch(G|0){case 0:{L=1;H=125;break a;break}case 80:break;default:{M=G;break b}}aa=f[c>>2]|0;ba=f[g>>2]|0;H=93;break}case 11:{switch(G|0){case 0:{L=1;H=125;break a;break}case 88:break;default:{M=G;break b}}ca=f[c>>2]|0;da=f[g>>2]|0;H=103;break}case 12:{switch(G|0){case 0:{L=1;H=125;break a;break}case 98:break;default:{M=G;break b}}break}default:{K=G;H=119;break b}}while(0);if((H|0)==16){H=0;f[j>>2]=f[j>>2]|128;if((P-O|0)>3){a=O;E=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=E;a=O+4|0;f[c>>2]=a;ea=E;fa=a}else{if(!(Xnb(c,e)|0)){H=20;break a}ea=f[e>>2]|0;fa=f[c>>2]|0}f[l>>2]=ea;if(fa>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[fa>>0]|0)!=26)continue a;f[c>>2]=fa+1;H=25}if((H|0)==25){H=0;f[j>>2]=f[j>>2]|256;a=f[m>>2]|0;if((a|0)==497760){jza(m,497760);ga=f[m>>2]|0}else ga=a;if(!(fqb(c,ga)|0)){L=0;H=125;break a}a=f[c>>2]|0;E=f[g>>2]|0;if(a>>>0>=E>>>0)continue a;if((b[a>>0]|0)!=32)continue a;F=a+1|0;f[c>>2]=F;Q=F;R=E;H=33}if((H|0)==33){H=0;f[j>>2]=f[j>>2]|2;if(Q>>>0<R>>>0){E=b[Q>>0]|0;F=E&255;if(E<<24>>24>-1){f[n>>2]=F;E=Q+1|0;f[c>>2]=E;ha=E;ia=R}else{ja=F;H=36}}else{ja=0;H=36}if((H|0)==36){H=0;F=Knb(c,ja)|0;E=J;f[n>>2]=F;if(!((E|0)>-1|(E|0)==-1&F>>>0>4294967295)){L=0;H=125;break a}ha=f[c>>2]|0;ia=f[g>>2]|0}if(ha>>>0>=ia>>>0)continue a;if((b[ha>>0]|0)!=40)continue a;F=ha+1|0;f[c>>2]=F;S=F;T=ia;H=43}if((H|0)==43){H=0;f[j>>2]=f[j>>2]|512;if(S>>>0<T>>>0){F=b[S>>0]|0;E=F&255;if(F<<24>>24>-1){f[o>>2]=E;F=S+1|0;f[c>>2]=F;ka=F;la=T}else{ma=E;H=46}}else{ma=0;H=46}if((H|0)==46){H=0;E=Knb(c,ma)|0;F=J;f[o>>2]=E;if(!((F|0)>-1|(F|0)==-1&E>>>0>4294967295)){L=0;H=125;break a}ka=f[c>>2]|0;la=f[g>>2]|0}if(ka>>>0>=la>>>0)continue a;if((b[ka>>0]|0)!=48)continue a;E=ka+1|0;f[c>>2]=E;U=E;V=la;H=53}if((H|0)==53){H=0;f[j>>2]=f[j>>2]|1024;if(U>>>0<V>>>0?(E=b[U>>0]|0,E<<24>>24>-1):0){F=U+1|0;f[c>>2]=F;na=E<<24>>24!=0;oa=F;pa=V}else{Lnb(e,c);F=e;if(!(b[q>>0]|0)){L=0;H=125;break a}na=(f[F>>2]|0)!=0|(f[F+4>>2]|0)!=0;oa=f[c>>2]|0;pa=f[g>>2]|0}b[p>>0]=na&1;if(oa>>>0>=pa>>>0)continue a;if((b[oa>>0]|0)!=56)continue a;F=oa+1|0;f[c>>2]=F;W=F;X=pa;H=63}if((H|0)==63){H=0;f[j>>2]=f[j>>2]|4;if(W>>>0<X>>>0){F=b[W>>0]|0;E=F&255;if(F<<24>>24>-1){f[r>>2]=E;F=W+1|0;f[c>>2]=F;qa=F;ra=X}else{sa=E;H=66}}else{sa=0;H=66}if((H|0)==66){H=0;E=Knb(c,sa)|0;F=J;f[r>>2]=E;if(!((F|0)>-1|(F|0)==-1&E>>>0>4294967295)){L=0;H=125;break a}qa=f[c>>2]|0;ra=f[g>>2]|0}if(qa>>>0>=ra>>>0)continue a;if((b[qa>>0]|0)!=64)continue a;E=qa+1|0;f[c>>2]=E;Y=E;Z=ra;H=73}if((H|0)==73){H=0;f[j>>2]=f[j>>2]|8;if(Y>>>0<Z>>>0?(E=b[Y>>0]|0,E<<24>>24>-1):0){F=Y+1|0;f[c>>2]=F;ta=E<<24>>24!=0;ua=F;va=Z}else{Lnb(e,c);F=e;if(!(b[t>>0]|0)){L=0;H=125;break a}ta=(f[F>>2]|0)!=0|(f[F+4>>2]|0)!=0;ua=f[c>>2]|0;va=f[g>>2]|0}b[s>>0]=ta&1;if(ua>>>0>=va>>>0)continue a;if((b[ua>>0]|0)!=72)continue a;F=ua+1|0;f[c>>2]=F;_=F;$=va;H=83}if((H|0)==83){H=0;f[j>>2]=f[j>>2]|16;if(_>>>0<$>>>0){F=b[_>>0]|0;E=F&255;if(F<<24>>24>-1){f[v>>2]=E;F=_+1|0;f[c>>2]=F;wa=F;xa=$}else{ya=E;H=86}}else{ya=0;H=86}if((H|0)==86){H=0;E=Knb(c,ya)|0;F=J;f[v>>2]=E;if(!((F|0)>-1|(F|0)==-1&E>>>0>4294967295)){L=0;H=125;break a}wa=f[c>>2]|0;xa=f[g>>2]|0}if(wa>>>0>=xa>>>0)continue a;if((b[wa>>0]|0)!=80)continue a;E=wa+1|0;f[c>>2]=E;aa=E;ba=xa;H=93}if((H|0)==93){H=0;f[j>>2]=f[j>>2]|32;if(aa>>>0<ba>>>0){E=b[aa>>0]|0;F=E&255;if(E<<24>>24>-1){f[w>>2]=F;E=aa+1|0;f[c>>2]=E;za=E;Aa=ba}else{Ba=F;H=96}}else{Ba=0;H=96}if((H|0)==96){H=0;F=Knb(c,Ba)|0;E=J;f[w>>2]=F;if(!((E|0)>-1|(E|0)==-1&F>>>0>4294967295)){L=0;H=125;break a}za=f[c>>2]|0;Aa=f[g>>2]|0}if(za>>>0>=Aa>>>0)continue a;if((b[za>>0]|0)!=88)continue a;F=za+1|0;f[c>>2]=F;ca=F;da=Aa;H=103}if((H|0)==103){H=0;f[j>>2]=f[j>>2]|64;if(ca>>>0<da>>>0?(F=b[ca>>0]|0,F<<24>>24>-1):0){E=ca+1|0;f[c>>2]=E;Ca=F<<24>>24!=0;Da=E;Ea=da}else{Lnb(e,c);E=e;if(!(b[y>>0]|0)){L=0;H=125;break a}Ca=(f[E>>2]|0)!=0|(f[E+4>>2]|0)!=0;Da=f[c>>2]|0;Ea=f[g>>2]|0}b[x>>0]=Ca&1;if(Da>>>0>=Ea>>>0)continue a;if((b[Da>>0]|0)!=98)continue a;f[c>>2]=Da+1}f[j>>2]=f[j>>2]|2048;E=f[z>>2]|0;if((E|0)==497760){jza(z,497760);Fa=f[z>>2]|0}else Fa=E;if(!(fqb(c,Fa)|0)){L=0;H=125;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[A>>2]|0){H=118;break a}if((f[B>>2]|0)==(f[C>>2]|0)){H=118;break a}else continue a}while(0);if((H|0)==119){H=0;if(!K){L=1;H=125;break}else M=K}if((M&7|0)==4){L=1;H=125;break}E=f[D>>2]|0;if(!(E&1))Ga=hBa(D)|0;else Ga=E&-2;if(!(ZPb(c,M,Ga)|0)){L=0;H=125;break}}if((H|0)==20){L=0;u=d;return L|0}else if((H|0)==118){f[i>>2]=0;b[c+24>>0]=1;L=1;u=d;return L|0}else if((H|0)==125){u=d;return L|0}return 0}function ZPa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+16|0;i=c+32|0;j=c+12|0;k=c+28|0;l=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[e>>2]=n;f[c>>2]=a+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=_nb(c,q)|0;f[e>>2]=n;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}if((p|0)==6){p=0;if((o|0)==10){f[g>>2]=f[g>>2]|1;n=f[h>>2]|0;if((n|0)==497760){jza(h,497760);s=f[h>>2]|0}else s=n;if(!(fqb(c,s)|0)){t=0;p=19;break}if((f[c>>2]|0)!=(f[d>>2]|0))continue;if(f[i>>2]|0){p=13;break}if((f[j>>2]|0)==(f[k>>2]|0)){p=13;break}else continue}else r=o}if((r|0)==0|(r&7|0)==4){t=1;p=19;break}n=f[l>>2]|0;if(!(n&1))u=hBa(l)|0;else u=n&-2;if(!(ZPb(c,r,u)|0)){t=0;p=19;break}}if((p|0)==13){f[e>>2]=0;b[c+24>>0]=1;t=1;return t|0}else if((p|0)==19)return t|0;return 0}function _Pa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+24|0;k=a+29|0;l=e+8|0;m=a+16|0;n=e+4|0;o=a+20|0;p=e+4|0;q=a+32|0;r=a+28|0;s=c+32|0;t=c+12|0;v=c+28|0;w=e+8|0;x=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){y=b[a>>0]|0;z=y&255;if(y<<24>>24>0){f[h>>2]=z;f[c>>2]=a+1;A=z;B=6}else{C=z;B=5}}else{C=0;B=5}if((B|0)==5){B=0;z=_nb(c,C)|0;f[h>>2]=z;if((z+-1|0)>>>0<127){A=z;B=6}else{D=z;B=75}}b:do if((B|0)==6){B=0;switch(A>>>3&536870911|0){case 1:{switch(A|0){case 0:{E=1;B=81;break a;break}case 8:break;default:{F=A;break b}}f[i>>2]=f[i>>2]|1;z=f[c>>2]|0;if(z>>>0<(f[g>>2]|0)>>>0){a=b[z>>0]|0;y=a&255;if(a<<24>>24>-1){f[j>>2]=y;a=z+1|0;f[c>>2]=a;G=a}else{H=y;B=11}}else{H=0;B=11}if((B|0)==11){B=0;y=Knb(c,H)|0;a=J;f[j>>2]=y;if(!((a|0)>-1|(a|0)==-1&y>>>0>4294967295)){E=0;B=81;break a}G=f[c>>2]|0}y=f[g>>2]|0;if(G>>>0>=y>>>0)continue a;if((b[G>>0]|0)!=16)continue a;a=G+1|0;f[c>>2]=a;I=a;K=y;B=18;break}case 2:{switch(A|0){case 0:{E=1;B=81;break a;break}case 16:break;default:{F=A;break b}}I=f[c>>2]|0;K=f[g>>2]|0;B=18;break}case 3:{switch(A|0){case 0:{E=1;B=81;break a;break}case 26:{B=27;break}default:{F=A;break b}}break}case 4:{switch(A|0){case 0:{E=1;B=81;break a;break}case 34:{B=41;break}default:{F=A;break b}}break}case 5:{switch(A|0){case 0:{E=1;B=81;break a;break}case 40:break;default:{F=A;break b}}L=f[c>>2]|0;M=f[g>>2]|0;B=56;break}case 6:{switch(A|0){case 0:{E=1;B=81;break a;break}case 48:break;default:{F=A;break b}}N=f[c>>2]|0;O=f[g>>2]|0;break}default:{D=A;B=75;break b}}if((B|0)==18){B=0;f[i>>2]=f[i>>2]|2;if(I>>>0<K>>>0?(y=b[I>>0]|0,y<<24>>24>-1):0){a=I+1|0;f[c>>2]=a;P=y<<24>>24!=0;Q=a;R=K}else{Lnb(e,c);a=e;if(!(b[l>>0]|0)){E=0;B=81;break a}P=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0;Q=f[c>>2]|0;R=f[g>>2]|0}b[k>>0]=P&1;if(Q>>>0>=R>>>0)continue a;if((b[Q>>0]|0)!=26)continue a;f[c>>2]=Q+1;B=27}if((B|0)==27){B=0;f[i>>2]=f[i>>2]|4;a=f[m>>2]|0;if(!a){y=L5b(48)|0;GNa(y);f[m>>2]=y;S=y}else S=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(y=b[a>>0]|0,y<<24>>24>-1):0){f[c>>2]=a+1;T=y&255}else{y=Znb(c)|0;if((y|0)>-1)T=y;else{E=0;B=81;break a}}Inb(e,c,T);if((f[n>>2]|0)<0){B=35;break a}if(!(JNa(S,c)|0)){B=35;break a}if(!(Onb(c,f[e>>2]|0)|0)){E=0;B=81;break a}y=f[c>>2]|0;if(y>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[y>>0]|0)!=34)continue a;f[c>>2]=y+1;B=41}if((B|0)==41){B=0;f[i>>2]=f[i>>2]|8;y=f[o>>2]|0;if(!y){a=L5b(48)|0;GNa(a);f[o>>2]=a;U=a}else U=y;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(a=b[y>>0]|0,a<<24>>24>-1):0){f[c>>2]=y+1;V=a&255}else{a=Znb(c)|0;if((a|0)>-1)V=a;else{E=0;B=81;break a}}Inb(e,c,V);if((f[p>>2]|0)<0){B=49;break a}if(!(JNa(U,c)|0)){B=49;break a}if(!(Onb(c,f[e>>2]|0)|0)){E=0;B=81;break a}a=f[c>>2]|0;y=f[g>>2]|0;if(a>>>0>=y>>>0)continue a;if((b[a>>0]|0)!=40)continue a;z=a+1|0;f[c>>2]=z;L=z;M=y;B=56}if((B|0)==56){B=0;f[i>>2]=f[i>>2]|16;if(L>>>0<M>>>0){y=b[L>>0]|0;z=y&255;if(y<<24>>24>-1){y=L+1|0;f[c>>2]=y;W=z;X=y;Y=M}else{Z=z;B=59}}else{Z=0;B=59}if((B|0)==59){B=0;z=Knb(c,Z)|0;y=J;if(!((y|0)>-1|(y|0)==-1&z>>>0>4294967295)){E=0;B=81;break a}W=z;X=f[c>>2]|0;Y=f[g>>2]|0}f[q>>2]=W;if(X>>>0>=Y>>>0)continue a;if((b[X>>0]|0)!=48)continue a;z=X+1|0;f[c>>2]=z;N=z;O=Y}f[i>>2]=f[i>>2]|32;if(N>>>0<O>>>0?(z=b[N>>0]|0,z<<24>>24>-1):0){y=N+1|0;f[c>>2]=y;_=z<<24>>24!=0;$=y;aa=O}else{Lnb(e,c);y=e;if(!(b[w>>0]|0)){E=0;B=81;break a}_=(f[y>>2]|0)!=0|(f[y+4>>2]|0)!=0;$=f[c>>2]|0;aa=f[g>>2]|0}b[r>>0]=_&1;if(($|0)!=(aa|0))continue a;if(f[s>>2]|0){B=74;break a}if((f[t>>2]|0)==(f[v>>2]|0)){B=74;break a}else continue a}while(0);if((B|0)==75){B=0;if(!D){E=1;B=81;break}else F=D}if((F&7|0)==4){E=1;B=81;break}y=f[x>>2]|0;if(!(y&1))ba=hBa(x)|0;else ba=y&-2;if(!(ZPb(c,F,ba)|0)){E=0;B=81;break}}if((B|0)==35){E=0;u=d;return E|0}else if((B|0)==49){E=0;u=d;return E|0}else if((B|0)==74){f[h>>2]=0;b[c+24>>0]=1;E=1;u=d;return E|0}else if((B|0)==81){u=d;return E|0}return 0}function $Pa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+24|0;l=a+28|0;m=a+32|0;n=a+16|0;o=a+4|0;p=a+36|0;q=a+20|0;a=c+32|0;r=c+12|0;s=c+28|0;a:while(1){t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0){v=b[t>>0]|0;w=v&255;if(v<<24>>24>0){f[i>>2]=w;f[c>>2]=t+1;x=w;y=6}else{z=w;y=5}}else{z=0;y=5}if((y|0)==5){y=0;w=_nb(c,z)|0;f[i>>2]=w;if((w+-1|0)>>>0<127){x=w;y=6}else{A=w;y=77}}b:do if((y|0)==6){y=0;switch(x>>>3&536870911|0){case 1:{switch(x|0){case 0:{B=1;y=83;break a;break}case 8:break;default:{C=x;break b}}f[j>>2]=f[j>>2]|1;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0){t=b[w>>0]|0;v=t&255;if(t<<24>>24>-1){f[k>>2]=v;t=w+1|0;f[c>>2]=t;D=t}else{E=v;y=11}}else{E=0;y=11}if((y|0)==11){y=0;v=Knb(c,E)|0;t=J;f[k>>2]=v;if(!((t|0)>-1|(t|0)==-1&v>>>0>4294967295)){B=0;y=83;break a}D=f[c>>2]|0}v=f[g>>2]|0;if(D>>>0>=v>>>0)continue a;if((b[D>>0]|0)!=21)continue a;t=D+1|0;f[c>>2]=t;F=t;G=v;y=18;break}case 2:{switch(x|0){case 0:{B=1;y=83;break a;break}case 21:break;default:{C=x;break b}}F=f[c>>2]|0;G=f[g>>2]|0;y=18;break}case 3:{switch(x|0){case 0:{B=1;y=83;break a;break}case 29:break;default:{C=x;break b}}H=f[c>>2]|0;I=f[g>>2]|0;y=28;break}case 4:{switch(x|0){case 0:{B=1;y=83;break a;break}case 32:break;default:{C=x;break b}}K=f[c>>2]|0;L=f[g>>2]|0;y=38;break}case 5:{switch(x|0){case 0:{B=1;y=83;break a;break}case 45:break;default:{C=x;break b}}v=f[g>>2]|0;M=f[c>>2]|0;N=v;O=v;y=53;break}case 6:{switch(x|0){case 0:{B=1;y=83;break a;break}case 48:break;default:{C=x;break b}}P=f[c>>2]|0;Q=f[g>>2]|0;break}default:{A=x;y=77;break b}}if((y|0)==18){y=0;f[j>>2]=f[j>>2]|2;if((G-F|0)>3){v=F;t=h[v>>0]|h[v+1>>0]<<8|h[v+2>>0]<<16|h[v+3>>0]<<24;f[e>>2]=t;v=F+4|0;f[c>>2]=v;R=t;S=v}else{if(!(Xnb(c,e)|0)){y=22;break a}R=f[e>>2]|0;S=f[c>>2]|0}f[l>>2]=R;v=f[g>>2]|0;if(S>>>0>=v>>>0)continue a;if((b[S>>0]|0)!=29)continue a;t=S+1|0;f[c>>2]=t;H=t;I=v;y=28}if((y|0)==28){y=0;f[j>>2]=f[j>>2]|4;if((I-H|0)>3){v=H;t=h[v>>0]|h[v+1>>0]<<8|h[v+2>>0]<<16|h[v+3>>0]<<24;f[e>>2]=t;v=H+4|0;f[c>>2]=v;T=t;U=v}else{if(!(Xnb(c,e)|0)){y=32;break a}T=f[e>>2]|0;U=f[c>>2]|0}f[m>>2]=T;v=f[g>>2]|0;if(U>>>0>=v>>>0)continue a;if((b[U>>0]|0)!=32)continue a;t=U+1|0;f[c>>2]=t;K=t;L=v;y=38}if((y|0)==38){y=0;if(K>>>0<L>>>0){v=b[K>>0]|0;t=v&255;if(v<<24>>24>-1){f[c>>2]=K+1;V=t}else{W=t;y=41}}else{W=0;y=41}if((y|0)==41){y=0;t=Knb(c,W)|0;v=J;if((v|0)>-1|(v|0)==-1&t>>>0>4294967295)V=t;else{B=0;y=83;break a}}if(V>>>0<2){f[j>>2]=f[j>>2]|8;f[n>>2]=V}else{t=f[o>>2]|0;if(!(t&1))X=hBa(o)|0;else X=t&-2;NPb(X,4,V,((V|0)<0)<<31>>31)}t=f[c>>2]|0;v=f[g>>2]|0;if(t>>>0>=v>>>0)continue a;if((b[t>>0]|0)!=45)continue a;w=t+1|0;f[c>>2]=w;M=w;N=v;O=v;y=53}if((y|0)==53){y=0;f[j>>2]=f[j>>2]|16;if((N-M|0)>3){v=M;w=h[v>>0]|h[v+1>>0]<<8|h[v+2>>0]<<16|h[v+3>>0]<<24;f[e>>2]=w;v=M+4|0;f[c>>2]=v;Y=w;Z=v;_=O}else{if(!(Xnb(c,e)|0)){y=57;break a}Y=f[e>>2]|0;Z=f[c>>2]|0;_=f[g>>2]|0}f[p>>2]=Y;if(Z>>>0>=_>>>0)continue a;if((b[Z>>0]|0)!=48)continue a;v=Z+1|0;f[c>>2]=v;P=v;Q=_}if(P>>>0<Q>>>0){v=b[P>>0]|0;w=v&255;if(v<<24>>24>-1){f[c>>2]=P+1;$=w}else{aa=w;y=66}}else{aa=0;y=66}if((y|0)==66){y=0;w=Knb(c,aa)|0;v=J;if((v|0)>-1|(v|0)==-1&w>>>0>4294967295)$=w;else{B=0;y=83;break a}}if($>>>0<3){f[j>>2]=f[j>>2]|32;f[q>>2]=$}else{w=f[o>>2]|0;if(!(w&1))ba=hBa(o)|0;else ba=w&-2;NPb(ba,6,$,(($|0)<0)<<31>>31)}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[a>>2]|0){y=76;break a}if((f[r>>2]|0)==(f[s>>2]|0)){y=76;break a}else continue a}while(0);if((y|0)==77){y=0;if(!A){B=1;y=83;break}else C=A}if((C&7|0)==4){B=1;y=83;break}w=f[o>>2]|0;if(!(w&1))ca=hBa(o)|0;else ca=w&-2;if(!(ZPb(c,C,ca)|0)){B=0;y=83;break}}if((y|0)==22){B=0;u=d;return B|0}else if((y|0)==32){B=0;u=d;return B|0}else if((y|0)==57){B=0;u=d;return B|0}else if((y|0)==76){f[i>>2]=0;b[c+24>>0]=1;B=1;u=d;return B|0}else if((y|0)==83){u=d;return B|0}return 0}function aQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+16|0;k=a+4|0;l=a+32|0;m=a+60|0;n=a+20|0;o=a+36|0;p=a+40|0;q=a+44|0;r=a+48|0;s=a+24|0;t=a+28|0;v=a+52|0;w=a+56|0;x=e+8|0;y=a+64|0;a=c+32|0;z=c+12|0;A=c+28|0;B=e+8|0;a:while(1){C=f[c>>2]|0;if(C>>>0<(f[g>>2]|0)>>>0){D=b[C>>0]|0;E=D&255;if(D<<24>>24>0){f[h>>2]=E;f[c>>2]=C+1;F=E;G=6}else{H=E;G=5}}else{H=0;G=5}if((G|0)==5){G=0;E=_nb(c,H)|0;f[h>>2]=E;if((E+-1|0)>>>0<127){F=E;G=6}else{I=E;G=147}}b:do if((G|0)==6){G=0;do switch(F>>>3&536870911|0){case 1:{switch(F|0){case 0:{K=1;G=153;break a;break}case 8:break;default:{L=F;break b}}E=f[c>>2]|0;if(E>>>0<(f[g>>2]|0)>>>0){C=b[E>>0]|0;D=C&255;if(C<<24>>24>-1){f[c>>2]=E+1;M=D}else{N=D;G=11}}else{N=0;G=11}if((G|0)==11){G=0;D=Knb(c,N)|0;E=J;if((E|0)>-1|(E|0)==-1&D>>>0>4294967295)M=D;else{K=0;G=153;break a}}if(M>>>0<3){f[i>>2]=f[i>>2]|1;f[j>>2]=M}else{D=f[k>>2]|0;if(!(D&1))O=hBa(k)|0;else O=D&-2;NPb(O,1,M,((M|0)<0)<<31>>31)}D=f[c>>2]|0;E=f[g>>2]|0;if(D>>>0>=E>>>0)continue a;if((b[D>>0]|0)!=16)continue a;C=D+1|0;f[c>>2]=C;P=C;Q=E;G=23;break}case 2:{switch(F|0){case 0:{K=1;G=153;break a;break}case 16:break;default:{L=F;break b}}P=f[c>>2]|0;Q=f[g>>2]|0;G=23;break}case 3:{switch(F|0){case 0:{K=1;G=153;break a;break}case 24:break;default:{L=F;break b}}R=f[c>>2]|0;S=f[g>>2]|0;G=33;break}case 4:{switch(F|0){case 0:{K=1;G=153;break a;break}case 32:break;default:{L=F;break b}}T=f[c>>2]|0;U=f[g>>2]|0;G=43;break}case 5:{switch(F|0){case 0:{K=1;G=153;break a;break}case 40:break;default:{L=F;break b}}V=f[c>>2]|0;W=f[g>>2]|0;G=53;break}case 6:{switch(F|0){case 0:{K=1;G=153;break a;break}case 48:break;default:{L=F;break b}}X=f[c>>2]|0;Y=f[g>>2]|0;G=63;break}case 7:{switch(F|0){case 0:{K=1;G=153;break a;break}case 56:break;default:{L=F;break b}}Z=f[c>>2]|0;_=f[g>>2]|0;G=73;break}case 8:{switch(F|0){case 0:{K=1;G=153;break a;break}case 64:break;default:{L=F;break b}}$=f[c>>2]|0;aa=f[g>>2]|0;G=83;break}case 9:{switch(F|0){case 0:{K=1;G=153;break a;break}case 72:break;default:{L=F;break b}}ba=f[c>>2]|0;ca=f[g>>2]|0;G=93;break}case 10:{switch(F|0){case 0:{K=1;G=153;break a;break}case 80:break;default:{L=F;break b}}da=f[c>>2]|0;ea=f[g>>2]|0;G=103;break}case 11:{switch(F|0){case 0:{K=1;G=153;break a;break}case 88:break;default:{L=F;break b}}fa=f[c>>2]|0;ga=f[g>>2]|0;G=113;break}case 12:{switch(F|0){case 0:{K=1;G=153;break a;break}case 96:break;default:{L=F;break b}}ha=f[c>>2]|0;ia=f[g>>2]|0;G=128;break}case 13:{switch(F|0){case 0:{K=1;G=153;break a;break}case 104:break;default:{L=F;break b}}ja=f[c>>2]|0;ka=f[g>>2]|0;break}default:{I=F;G=147;break b}}while(0);if((G|0)==23){G=0;f[i>>2]=f[i>>2]|16;if(P>>>0<Q>>>0){E=b[P>>0]|0;C=E&255;if(E<<24>>24>-1){f[l>>2]=C;E=P+1|0;f[c>>2]=E;la=E;ma=Q}else{na=C;G=26}}else{na=0;G=26}if((G|0)==26){G=0;C=Knb(c,na)|0;E=J;f[l>>2]=C;if(!((E|0)>-1|(E|0)==-1&C>>>0>4294967295)){K=0;G=153;break a}la=f[c>>2]|0;ma=f[g>>2]|0}if(la>>>0>=ma>>>0)continue a;if((b[la>>0]|0)!=24)continue a;C=la+1|0;f[c>>2]=C;R=C;S=ma;G=33}if((G|0)==33){G=0;f[i>>2]=f[i>>2]|128;if(R>>>0<S>>>0){C=b[R>>0]|0;E=C&255;if(C<<24>>24>-1){f[m>>2]=E;C=R+1|0;f[c>>2]=C;oa=C;pa=S}else{qa=E;G=36}}else{qa=0;G=36}if((G|0)==36){G=0;E=Knb(c,qa)|0;C=J;f[m>>2]=E;if(!((C|0)>-1|(C|0)==-1&E>>>0>4294967295)){K=0;G=153;break a}oa=f[c>>2]|0;pa=f[g>>2]|0}if(oa>>>0>=pa>>>0)continue a;if((b[oa>>0]|0)!=32)continue a;E=oa+1|0;f[c>>2]=E;T=E;U=pa;G=43}if((G|0)==43){G=0;f[i>>2]=f[i>>2]|2;if(T>>>0<U>>>0){E=b[T>>0]|0;C=E&255;if(E<<24>>24>-1){f[n>>2]=C;E=T+1|0;f[c>>2]=E;ra=E;sa=U}else{ta=C;G=46}}else{ta=0;G=46}if((G|0)==46){G=0;C=Knb(c,ta)|0;E=J;f[n>>2]=C;if(!((E|0)>-1|(E|0)==-1&C>>>0>4294967295)){K=0;G=153;break a}ra=f[c>>2]|0;sa=f[g>>2]|0}if(ra>>>0>=sa>>>0)continue a;if((b[ra>>0]|0)!=40)continue a;C=ra+1|0;f[c>>2]=C;V=C;W=sa;G=53}if((G|0)==53){G=0;f[i>>2]=f[i>>2]|32;if(V>>>0<W>>>0){C=b[V>>0]|0;E=C&255;if(C<<24>>24>-1){f[o>>2]=E;C=V+1|0;f[c>>2]=C;ua=C;va=W}else{wa=E;G=56}}else{wa=0;G=56}if((G|0)==56){G=0;E=Knb(c,wa)|0;C=J;f[o>>2]=E;if(!((C|0)>-1|(C|0)==-1&E>>>0>4294967295)){K=0;G=153;break a}ua=f[c>>2]|0;va=f[g>>2]|0}if(ua>>>0>=va>>>0)continue a;if((b[ua>>0]|0)!=48)continue a;E=ua+1|0;f[c>>2]=E;X=E;Y=va;G=63}if((G|0)==63){G=0;f[i>>2]=f[i>>2]|64;if(X>>>0<Y>>>0){E=b[X>>0]|0;C=E&255;if(E<<24>>24>-1){f[p>>2]=C;E=X+1|0;f[c>>2]=E;xa=E;ya=Y}else{za=C;G=66}}else{za=0;G=66}if((G|0)==66){G=0;C=Knb(c,za)|0;E=J;f[p>>2]=C;if(!((E|0)>-1|(E|0)==-1&C>>>0>4294967295)){K=0;G=153;break a}xa=f[c>>2]|0;ya=f[g>>2]|0}if(xa>>>0>=ya>>>0)continue a;if((b[xa>>0]|0)!=56)continue a;C=xa+1|0;f[c>>2]=C;Z=C;_=ya;G=73}if((G|0)==73){G=0;f[i>>2]=f[i>>2]|256;if(Z>>>0<_>>>0){C=b[Z>>0]|0;E=C&255;if(C<<24>>24>-1){f[q>>2]=E;C=Z+1|0;f[c>>2]=C;Aa=C;Ba=_}else{Ca=E;G=76}}else{Ca=0;G=76}if((G|0)==76){G=0;E=Knb(c,Ca)|0;C=J;f[q>>2]=E;if(!((C|0)>-1|(C|0)==-1&E>>>0>4294967295)){K=0;G=153;break a}Aa=f[c>>2]|0;Ba=f[g>>2]|0}if(Aa>>>0>=Ba>>>0)continue a;if((b[Aa>>0]|0)!=64)continue a;E=Aa+1|0;f[c>>2]=E;$=E;aa=Ba;G=83}if((G|0)==83){G=0;f[i>>2]=f[i>>2]|512;if($>>>0<aa>>>0){E=b[$>>0]|0;C=E&255;if(E<<24>>24>-1){f[r>>2]=C;E=$+1|0;f[c>>2]=E;Da=E;Ea=aa}else{Fa=C;G=86}}else{Fa=0;G=86}if((G|0)==86){G=0;C=Knb(c,Fa)|0;E=J;f[r>>2]=C;if(!((E|0)>-1|(E|0)==-1&C>>>0>4294967295)){K=0;G=153;break a}Da=f[c>>2]|0;Ea=f[g>>2]|0}if(Da>>>0>=Ea>>>0)continue a;if((b[Da>>0]|0)!=72)continue a;C=Da+1|0;f[c>>2]=C;ba=C;ca=Ea;G=93}if((G|0)==93){G=0;f[i>>2]=f[i>>2]|4;if(ba>>>0<ca>>>0){C=b[ba>>0]|0;E=C&255;if(C<<24>>24>-1){f[s>>2]=E;C=ba+1|0;f[c>>2]=C;Ga=C;Ha=ca}else{Ia=E;G=96}}else{Ia=0;G=96}if((G|0)==96){G=0;E=Knb(c,Ia)|0;C=J;f[s>>2]=E;if(!((C|0)>-1|(C|0)==-1&E>>>0>4294967295)){K=0;G=153;break a}Ga=f[c>>2]|0;Ha=f[g>>2]|0}if(Ga>>>0>=Ha>>>0)continue a;if((b[Ga>>0]|0)!=80)continue a;E=Ga+1|0;f[c>>2]=E;da=E;ea=Ha;G=103}if((G|0)==103){G=0;f[i>>2]=f[i>>2]|8;if(da>>>0<ea>>>0){E=b[da>>0]|0;C=E&255;if(E<<24>>24>-1){f[t>>2]=C;E=da+1|0;f[c>>2]=E;Ja=E;Ka=ea}else{La=C;G=106}}else{La=0;G=106}if((G|0)==106){G=0;C=Knb(c,La)|0;E=J;f[t>>2]=C;if(!((E|0)>-1|(E|0)==-1&C>>>0>4294967295)){K=0;G=153;break a}Ja=f[c>>2]|0;Ka=f[g>>2]|0}if(Ja>>>0>=Ka>>>0)continue a;if((b[Ja>>0]|0)!=88)continue a;C=Ja+1|0;f[c>>2]=C;fa=C;ga=Ka;G=113}if((G|0)==113){G=0;if(fa>>>0<ga>>>0){C=b[fa>>0]|0;E=C&255;if(C<<24>>24>-1){f[c>>2]=fa+1;Ma=E}else{Na=E;G=116}}else{Na=0;G=116}if((G|0)==116){G=0;E=Knb(c,Na)|0;C=J;if((C|0)>-1|(C|0)==-1&E>>>0>4294967295)Ma=E;else{K=0;G=153;break a}}if(Ma>>>0<3){f[i>>2]=f[i>>2]|1024;f[v>>2]=Ma}else{E=f[k>>2]|0;if(!(E&1))Oa=hBa(k)|0;else Oa=E&-2;NPb(Oa,11,Ma,((Ma|0)<0)<<31>>31)}E=f[c>>2]|0;C=f[g>>2]|0;if(E>>>0>=C>>>0)continue a;if((b[E>>0]|0)!=96)continue a;D=E+1|0;f[c>>2]=D;ha=D;ia=C;G=128}if((G|0)==128){G=0;f[i>>2]=f[i>>2]|2048;if(ha>>>0<ia>>>0?(C=b[ha>>0]|0,C<<24>>24>-1):0){D=ha+1|0;f[c>>2]=D;Pa=C<<24>>24!=0;Qa=D;Ra=ia}else{Lnb(e,c);D=e;if(!(b[x>>0]|0)){K=0;G=153;break a}Pa=(f[D>>2]|0)!=0|(f[D+4>>2]|0)!=0;Qa=f[c>>2]|0;Ra=f[g>>2]|0}b[w>>0]=Pa&1;if(Qa>>>0>=Ra>>>0)continue a;if((b[Qa>>0]|0)!=104)continue a;D=Qa+1|0;f[c>>2]=D;ja=D;ka=Ra}f[i>>2]=f[i>>2]|4096;if(ja>>>0<ka>>>0?(D=b[ja>>0]|0,D<<24>>24>-1):0){C=ja+1|0;f[c>>2]=C;Sa=D<<24>>24!=0;Ta=C;Ua=ka}else{Lnb(e,c);C=e;if(!(b[B>>0]|0)){K=0;G=153;break a}Sa=(f[C>>2]|0)!=0|(f[C+4>>2]|0)!=0;Ta=f[c>>2]|0;Ua=f[g>>2]|0}b[y>>0]=Sa&1;if((Ta|0)!=(Ua|0))continue a;if(f[a>>2]|0){G=146;break a}if((f[z>>2]|0)==(f[A>>2]|0)){G=146;break a}else continue a}while(0);if((G|0)==147){G=0;if(!I){K=1;G=153;break}else L=I}if((L&7|0)==4){K=1;G=153;break}C=f[k>>2]|0;if(!(C&1))Va=hBa(k)|0;else Va=C&-2;if(!(ZPb(c,L,Va)|0)){K=0;G=153;break}}if((G|0)==146){f[h>>2]=0;b[c+24>>0]=1;K=1;u=d;return K|0}else if((G|0)==153){u=d;return K|0}return 0}function bQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+16|0;l=a+48|0;m=a+20|0;n=a+32|0;o=a+36|0;p=a+40|0;q=e+8|0;r=a+52|0;s=a+56|0;t=a+60|0;v=a+44|0;w=a+24|0;x=a+41|0;y=e+8|0;z=a+28|0;A=c+32|0;B=c+12|0;C=c+28|0;D=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){E=b[a>>0]|0;F=E&255;if(E<<24>>24>0){f[i>>2]=F;f[c>>2]=a+1;G=F;H=6}else{I=F;H=5}}else{I=0;H=5}if((H|0)==5){H=0;F=_nb(c,I)|0;f[i>>2]=F;if((F+-1|0)>>>0<127){G=F;H=6}else{K=F;H=126}}b:do if((H|0)==6){H=0;do switch(G>>>3&536870911|0){case 1:{switch(G|0){case 0:{L=1;H=132;break a;break}case 10:break;default:{M=G;break b}}f[j>>2]=f[j>>2]|1;F=f[k>>2]|0;if((F|0)==497760){jza(k,497760);N=f[k>>2]|0}else N=F;if(!(fqb(c,N)|0)){L=0;H=132;break a}F=f[c>>2]|0;a=f[g>>2]|0;if(F>>>0>=a>>>0)continue a;if((b[F>>0]|0)!=21)continue a;E=F+1|0;f[c>>2]=E;O=E;P=a;H=16;break}case 2:{switch(G|0){case 0:{L=1;H=132;break a;break}case 21:break;default:{M=G;break b}}O=f[c>>2]|0;P=f[g>>2]|0;H=16;break}case 3:{switch(G|0){case 0:{L=1;H=132;break a;break}case 26:{H=25;break}default:{M=G;break b}}break}case 4:{switch(G|0){case 0:{L=1;H=132;break a;break}case 32:break;default:{M=G;break b}}Q=f[g>>2]|0;R=f[c>>2]|0;H=33;break}case 5:{switch(G|0){case 0:{L=1;H=132;break a;break}case 40:break;default:{M=G;break b}}S=f[g>>2]|0;T=f[c>>2]|0;H=43;break}case 6:{switch(G|0){case 0:{L=1;H=132;break a;break}case 48:break;default:{M=G;break b}}U=f[g>>2]|0;V=f[c>>2]|0;H=53;break}case 7:{switch(G|0){case 0:{L=1;H=132;break a;break}case 61:break;default:{M=G;break b}}a=f[g>>2]|0;W=f[c>>2]|0;X=a;Y=a;H=63;break}case 8:{switch(G|0){case 0:{L=1;H=132;break a;break}case 69:break;default:{M=G;break b}}a=f[g>>2]|0;Z=f[c>>2]|0;_=a;$=a;H=73;break}case 9:{switch(G|0){case 0:{L=1;H=132;break a;break}case 77:break;default:{M=G;break b}}a=f[g>>2]|0;aa=f[c>>2]|0;ba=a;ca=a;H=83;break}case 10:{switch(G|0){case 0:{L=1;H=132;break a;break}case 80:break;default:{M=G;break b}}da=f[c>>2]|0;ea=f[g>>2]|0;H=93;break}case 11:{switch(G|0){case 0:{L=1;H=132;break a;break}case 90:{H=102;break}default:{M=G;break b}}break}case 12:{switch(G|0){case 0:{L=1;H=132;break a;break}case 96:break;default:{M=G;break b}}fa=f[c>>2]|0;ga=f[g>>2]|0;H=110;break}case 13:{switch(G|0){case 0:{L=1;H=132;break a;break}case 106:break;default:{M=G;break b}}break}default:{K=G;H=126;break b}}while(0);if((H|0)==16){H=0;f[j>>2]=f[j>>2]|2;if((P-O|0)>3){a=O;E=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=E;a=O+4|0;f[c>>2]=a;ha=E;ia=a}else{if(!(Xnb(c,e)|0)){H=20;break a}ha=f[e>>2]|0;ia=f[c>>2]|0}f[l>>2]=ha;if(ia>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[ia>>0]|0)!=26)continue a;f[c>>2]=ia+1;H=25}if((H|0)==25){H=0;f[j>>2]=f[j>>2]|4;a=f[m>>2]|0;if((a|0)==497760){jza(m,497760);ja=f[m>>2]|0}else ja=a;if(!(fqb(c,ja)|0)){L=0;H=132;break a}a=f[c>>2]|0;E=f[g>>2]|0;if(a>>>0>=E>>>0)continue a;if((b[a>>0]|0)!=32)continue a;F=a+1|0;f[c>>2]=F;Q=E;R=F;H=33}if((H|0)==33){H=0;f[j>>2]=f[j>>2]|8;if(R>>>0<Q>>>0){F=b[R>>0]|0;E=F&255;if(F<<24>>24>-1){f[n>>2]=E;F=R+1|0;f[c>>2]=F;ka=Q;la=F}else{ma=E;H=36}}else{ma=0;H=36}if((H|0)==36){H=0;E=Knb(c,ma)|0;F=J;f[n>>2]=E;if(!((F|0)>-1|(F|0)==-1&E>>>0>4294967295)){L=0;H=132;break a}ka=f[g>>2]|0;la=f[c>>2]|0}if(la>>>0>=ka>>>0)continue a;if((b[la>>0]|0)!=40)continue a;E=la+1|0;f[c>>2]=E;S=ka;T=E;H=43}if((H|0)==43){H=0;f[j>>2]=f[j>>2]|16;if(T>>>0<S>>>0){E=b[T>>0]|0;F=E&255;if(E<<24>>24>-1){f[o>>2]=F;E=T+1|0;f[c>>2]=E;na=S;oa=E}else{pa=F;H=46}}else{pa=0;H=46}if((H|0)==46){H=0;F=Knb(c,pa)|0;E=J;f[o>>2]=F;if(!((E|0)>-1|(E|0)==-1&F>>>0>4294967295)){L=0;H=132;break a}na=f[g>>2]|0;oa=f[c>>2]|0}if(oa>>>0>=na>>>0)continue a;if((b[oa>>0]|0)!=48)continue a;F=oa+1|0;f[c>>2]=F;U=na;V=F;H=53}if((H|0)==53){H=0;f[j>>2]=f[j>>2]|32;if(V>>>0<U>>>0?(F=b[V>>0]|0,F<<24>>24>-1):0){E=V+1|0;f[c>>2]=E;qa=F<<24>>24!=0;ra=U;sa=E}else{Lnb(e,c);E=e;if(!(b[q>>0]|0)){L=0;H=132;break a}qa=(f[E>>2]|0)!=0|(f[E+4>>2]|0)!=0;ra=f[g>>2]|0;sa=f[c>>2]|0}b[p>>0]=qa&1;if(sa>>>0>=ra>>>0)continue a;if((b[sa>>0]|0)!=61)continue a;E=sa+1|0;f[c>>2]=E;W=E;X=ra;Y=ra;H=63}if((H|0)==63){H=0;f[j>>2]=f[j>>2]|64;if((X-W|0)>3){E=W;F=h[E>>0]|h[E+1>>0]<<8|h[E+2>>0]<<16|h[E+3>>0]<<24;f[e>>2]=F;E=W+4|0;f[c>>2]=E;ta=F;ua=E;va=Y;wa=X}else{if(!(Xnb(c,e)|0)){H=67;break a}E=f[g>>2]|0;ta=f[e>>2]|0;ua=f[c>>2]|0;va=E;wa=E}f[r>>2]=ta;if(ua>>>0>=va>>>0)continue a;if((b[ua>>0]|0)!=69)continue a;E=ua+1|0;f[c>>2]=E;Z=E;_=wa;$=va;H=73}if((H|0)==73){H=0;f[j>>2]=f[j>>2]|128;if((_-Z|0)>3){E=Z;F=h[E>>0]|h[E+1>>0]<<8|h[E+2>>0]<<16|h[E+3>>0]<<24;f[e>>2]=F;E=Z+4|0;f[c>>2]=E;xa=F;ya=E;za=$;Aa=_}else{if(!(Xnb(c,e)|0)){H=77;break a}E=f[g>>2]|0;xa=f[e>>2]|0;ya=f[c>>2]|0;za=E;Aa=E}f[s>>2]=xa;if(ya>>>0>=za>>>0)continue a;if((b[ya>>0]|0)!=77)continue a;E=ya+1|0;f[c>>2]=E;aa=E;ba=Aa;ca=za;H=83}if((H|0)==83){H=0;f[j>>2]=f[j>>2]|256;if((ba-aa|0)>3){E=aa;F=h[E>>0]|h[E+1>>0]<<8|h[E+2>>0]<<16|h[E+3>>0]<<24;f[e>>2]=F;E=aa+4|0;f[c>>2]=E;Ba=F;Ca=E;Da=ca}else{if(!(Xnb(c,e)|0)){H=87;break a}Ba=f[e>>2]|0;Ca=f[c>>2]|0;Da=f[g>>2]|0}f[t>>2]=Ba;if(Ca>>>0>=Da>>>0)continue a;if((b[Ca>>0]|0)!=80)continue a;E=Ca+1|0;f[c>>2]=E;da=E;ea=Da;H=93}if((H|0)==93){H=0;f[j>>2]=f[j>>2]|512;if(da>>>0<ea>>>0){E=b[da>>0]|0;F=E&255;if(E<<24>>24>-1){f[v>>2]=F;E=da+1|0;f[c>>2]=E;Ea=E;Fa=ea}else{Ga=F;H=96}}else{Ga=0;H=96}if((H|0)==96){H=0;F=Knb(c,Ga)|0;E=J;f[v>>2]=F;if(!((E|0)>-1|(E|0)==-1&F>>>0>4294967295)){L=0;H=132;break a}Ea=f[c>>2]|0;Fa=f[g>>2]|0}if(Ea>>>0>=Fa>>>0)continue a;if((b[Ea>>0]|0)!=90)continue a;f[c>>2]=Ea+1;H=102}if((H|0)==102){H=0;f[j>>2]=f[j>>2]|1024;F=f[213031]|0;E=f[w>>2]|0;if((E|0)==(F|0)){jza(w,F);Ha=f[w>>2]|0}else Ha=E;if(!(fqb(c,Ha)|0)){L=0;H=132;break a}E=f[c>>2]|0;F=f[g>>2]|0;if(E>>>0>=F>>>0)continue a;if((b[E>>0]|0)!=96)continue a;a=E+1|0;f[c>>2]=a;fa=a;ga=F;H=110}if((H|0)==110){H=0;f[j>>2]=f[j>>2]|2048;if(fa>>>0<ga>>>0?(F=b[fa>>0]|0,F<<24>>24>-1):0){a=fa+1|0;f[c>>2]=a;Ia=F<<24>>24!=0;Ja=a;Ka=ga}else{Lnb(e,c);a=e;if(!(b[y>>0]|0)){L=0;H=132;break a}Ia=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0;Ja=f[c>>2]|0;Ka=f[g>>2]|0}b[x>>0]=Ia&1;if(Ja>>>0>=Ka>>>0)continue a;if((b[Ja>>0]|0)!=106)continue a;f[c>>2]=Ja+1}f[j>>2]=f[j>>2]|4096;a=f[z>>2]|0;if((a|0)==497760){jza(z,497760);La=f[z>>2]|0}else La=a;if(!(fqb(c,La)|0)){L=0;H=132;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[A>>2]|0){H=125;break a}if((f[B>>2]|0)==(f[C>>2]|0)){H=125;break a}else continue a}while(0);if((H|0)==126){H=0;if(!K){L=1;H=132;break}else M=K}if((M&7|0)==4){L=1;H=132;break}a=f[D>>2]|0;if(!(a&1))Ma=hBa(D)|0;else Ma=a&-2;if(!(ZPb(c,M,Ma)|0)){L=0;H=132;break}}if((H|0)==20){L=0;u=d;return L|0}else if((H|0)==67){L=0;u=d;return L|0}else if((H|0)==77){L=0;u=d;return L|0}else if((H|0)==87){L=0;u=d;return L|0}else if((H|0)==125){f[i>>2]=0;b[c+24>>0]=1;L=1;u=d;return L|0}else if((H|0)==132){u=d;return L|0}return 0}function cQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+20|0;l=a+24|0;m=a+16|0;n=c+32|0;o=c+12|0;p=c+28|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[i>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[i>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=37}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=43;break a;break}case 13:break;default:{z=t;break b}}f[j>>2]=f[j>>2]|1;s=f[g>>2]|0;a=f[c>>2]|0;if((s-a|0)>3){r=a;A=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=A;r=a+4|0;f[c>>2]=r;B=A;C=r;D=s;E=s}else{if(!(Xnb(c,e)|0)){v=12;break a}s=f[g>>2]|0;B=f[e>>2]|0;C=f[c>>2]|0;D=s;E=s}f[k>>2]=B;if(C>>>0>=D>>>0)continue a;if((b[C>>0]|0)!=21)continue a;s=C+1|0;f[c>>2]=s;F=s;G=E;H=D;v=18;break}case 2:{switch(t|0){case 0:{y=1;v=43;break a;break}case 21:break;default:{z=t;break b}}s=f[g>>2]|0;F=f[c>>2]|0;G=s;H=s;v=18;break}case 3:{switch(t|0){case 0:{y=1;v=43;break a;break}case 29:break;default:{z=t;break b}}s=f[g>>2]|0;I=s;J=f[c>>2]|0;K=s;break}default:{x=t;v=37;break b}}if((v|0)==18){v=0;f[j>>2]=f[j>>2]|2;if((G-F|0)>3){s=F;r=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[e>>2]=r;s=F+4|0;f[c>>2]=s;L=r;M=s;N=H;O=G}else{if(!(Xnb(c,e)|0)){v=22;break a}s=f[g>>2]|0;L=f[e>>2]|0;M=f[c>>2]|0;N=s;O=s}f[l>>2]=L;if(M>>>0>=N>>>0)continue a;if((b[M>>0]|0)!=29)continue a;s=M+1|0;f[c>>2]=s;I=N;J=s;K=O}f[j>>2]=f[j>>2]|4;if((K-J|0)>3){s=J;r=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[e>>2]=r;s=J+4|0;f[c>>2]=s;P=r;Q=s;R=I}else{if(!(Xnb(c,e)|0)){v=32;break a}P=f[e>>2]|0;Q=f[c>>2]|0;R=f[g>>2]|0}f[m>>2]=P;if((Q|0)!=(R|0))continue a;if(f[n>>2]|0){v=36;break a}if((f[o>>2]|0)==(f[p>>2]|0)){v=36;break a}else continue a}while(0);if((v|0)==37){v=0;if(!x){y=1;v=43;break}else z=x}if((z&7|0)==4){y=1;v=43;break}s=f[q>>2]|0;if(!(s&1))S=hBa(q)|0;else S=s&-2;if(!(ZPb(c,z,S)|0)){y=0;v=43;break}}if((v|0)==12){y=0;u=d;return y|0}else if((v|0)==22){y=0;u=d;return y|0}else if((v|0)==32){y=0;u=d;return y|0}else if((v|0)==36){f[i>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==43){u=d;return y|0}return 0}function dQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+16|0;i=a+20|0;j=a+24|0;k=a+28|0;l=c+32|0;m=c+12|0;n=c+28|0;o=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[e>>2]=q;f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=_nb(c,t)|0;f[e>>2]=q;if((q+-1|0)>>>0<127){r=q;s=6}else{u=q;s=47}}b:do if((s|0)==6){s=0;switch(r>>>3&536870911|0){case 1:{switch(r|0){case 0:{v=1;s=53;break a;break}case 8:break;default:{w=r;break b}}f[g>>2]=f[g>>2]|1;q=f[c>>2]|0;if(q>>>0<(f[d>>2]|0)>>>0){a=b[q>>0]|0;p=a&255;if(a<<24>>24>-1){f[h>>2]=p;a=q+1|0;f[c>>2]=a;x=a}else{y=p;s=11}}else{y=0;s=11}if((s|0)==11){s=0;p=Knb(c,y)|0;a=J;f[h>>2]=p;if(!((a|0)>-1|(a|0)==-1&p>>>0>4294967295)){v=0;s=53;break a}x=f[c>>2]|0}p=f[d>>2]|0;if(x>>>0>=p>>>0)continue a;if((b[x>>0]|0)!=16)continue a;a=x+1|0;f[c>>2]=a;z=a;A=p;s=18;break}case 2:{switch(r|0){case 0:{v=1;s=53;break a;break}case 16:break;default:{w=r;break b}}z=f[c>>2]|0;A=f[d>>2]|0;s=18;break}case 3:{switch(r|0){case 0:{v=1;s=53;break a;break}case 24:break;default:{w=r;break b}}B=f[c>>2]|0;C=f[d>>2]|0;s=28;break}case 4:{switch(r|0){case 0:{v=1;s=53;break a;break}case 32:break;default:{w=r;break b}}D=f[c>>2]|0;E=f[d>>2]|0;break}default:{u=r;s=47;break b}}if((s|0)==18){s=0;f[g>>2]=f[g>>2]|2;if(z>>>0<A>>>0){p=b[z>>0]|0;a=p&255;if(p<<24>>24>-1){f[i>>2]=a;p=z+1|0;f[c>>2]=p;F=p;G=A}else{H=a;s=21}}else{H=0;s=21}if((s|0)==21){s=0;a=Knb(c,H)|0;p=J;f[i>>2]=a;if(!((p|0)>-1|(p|0)==-1&a>>>0>4294967295)){v=0;s=53;break a}F=f[c>>2]|0;G=f[d>>2]|0}if(F>>>0>=G>>>0)continue a;if((b[F>>0]|0)!=24)continue a;a=F+1|0;f[c>>2]=a;B=a;C=G;s=28}if((s|0)==28){s=0;f[g>>2]=f[g>>2]|4;if(B>>>0<C>>>0){a=b[B>>0]|0;p=a&255;if(a<<24>>24>-1){f[j>>2]=p;a=B+1|0;f[c>>2]=a;I=a;K=C}else{L=p;s=31}}else{L=0;s=31}if((s|0)==31){s=0;p=Knb(c,L)|0;a=J;f[j>>2]=p;if(!((a|0)>-1|(a|0)==-1&p>>>0>4294967295)){v=0;s=53;break a}I=f[c>>2]|0;K=f[d>>2]|0}if(I>>>0>=K>>>0)continue a;if((b[I>>0]|0)!=32)continue a;p=I+1|0;f[c>>2]=p;D=p;E=K}f[g>>2]=f[g>>2]|8;if(D>>>0<E>>>0){p=b[D>>0]|0;a=p&255;if(p<<24>>24>-1){f[k>>2]=a;p=D+1|0;f[c>>2]=p;M=p;N=E}else{O=a;s=41}}else{O=0;s=41}if((s|0)==41){s=0;a=Knb(c,O)|0;p=J;f[k>>2]=a;if(!((p|0)>-1|(p|0)==-1&a>>>0>4294967295)){v=0;s=53;break a}M=f[c>>2]|0;N=f[d>>2]|0}if((M|0)!=(N|0))continue a;if(f[l>>2]|0){s=46;break a}if((f[m>>2]|0)==(f[n>>2]|0)){s=46;break a}else continue a}while(0);if((s|0)==47){s=0;if(!u){v=1;s=53;break}else w=u}if((w&7|0)==4){v=1;s=53;break}a=f[o>>2]|0;if(!(a&1))P=hBa(o)|0;else P=a&-2;if(!(ZPb(c,w,P)|0)){v=0;s=53;break}}if((s|0)==46){f[e>>2]=0;b[c+24>>0]=1;v=1;return v|0}else if((s|0)==53)return v|0;return 0}function eQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+16|0;k=e+8|0;l=a+24|0;m=a+20|0;n=c+32|0;o=c+12|0;p=c+28|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[h>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[h>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=37}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=43;break a;break}case 8:break;default:{z=t;break b}}f[i>>2]=f[i>>2]|1;s=f[c>>2]|0;a=f[g>>2]|0;if(s>>>0<a>>>0?(r=b[s>>0]|0,r<<24>>24>-1):0){A=s+1|0;f[c>>2]=A;B=r<<24>>24!=0;C=A;D=a}else{Lnb(e,c);a=e;if(!(b[k>>0]|0)){y=0;v=43;break a}B=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0;C=f[c>>2]|0;D=f[g>>2]|0}b[j>>0]=B&1;if(C>>>0>=D>>>0)continue a;if((b[C>>0]|0)!=16)continue a;a=C+1|0;f[c>>2]=a;E=a;F=D;v=18;break}case 2:{switch(t|0){case 0:{y=1;v=43;break a;break}case 16:break;default:{z=t;break b}}E=f[c>>2]|0;F=f[g>>2]|0;v=18;break}case 3:{switch(t|0){case 0:{y=1;v=43;break a;break}case 24:break;default:{z=t;break b}}G=f[c>>2]|0;H=f[g>>2]|0;break}default:{x=t;v=37;break b}}if((v|0)==18){v=0;f[i>>2]=f[i>>2]|2;if(E>>>0<F>>>0){a=b[E>>0]|0;A=a&255;if(a<<24>>24>-1){f[l>>2]=A;a=E+1|0;f[c>>2]=a;I=a;K=F}else{L=A;v=21}}else{L=0;v=21}if((v|0)==21){v=0;A=Knb(c,L)|0;a=J;f[l>>2]=A;if(!((a|0)>-1|(a|0)==-1&A>>>0>4294967295)){y=0;v=43;break a}I=f[c>>2]|0;K=f[g>>2]|0}if(I>>>0>=K>>>0)continue a;if((b[I>>0]|0)!=24)continue a;A=I+1|0;f[c>>2]=A;G=A;H=K}f[i>>2]=f[i>>2]|4;if(G>>>0<H>>>0){A=b[G>>0]|0;a=A&255;if(A<<24>>24>-1){A=G+1|0;f[c>>2]=A;M=a;N=A;O=H}else{P=a;v=31}}else{P=0;v=31}if((v|0)==31){v=0;a=Knb(c,P)|0;A=J;if(!((A|0)>-1|(A|0)==-1&a>>>0>4294967295)){y=0;v=43;break a}M=a;N=f[c>>2]|0;O=f[g>>2]|0}f[m>>2]=M;if((N|0)!=(O|0))continue a;if(f[n>>2]|0){v=36;break a}if((f[o>>2]|0)==(f[p>>2]|0)){v=36;break a}else continue a}while(0);if((v|0)==37){v=0;if(!x){y=1;v=43;break}else z=x}if((z&7|0)==4){y=1;v=43;break}a=f[q>>2]|0;if(!(a&1))Q=hBa(q)|0;else Q=a&-2;if(!(ZPb(c,z,Q)|0)){y=0;v=43;break}}if((v|0)==36){f[h>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==43){u=d;return y|0}return 0}function fQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+4|0;k=a+8|0;l=a+28|0;m=a+16|0;n=a+20|0;o=a+24|0;p=a+32|0;a=c+32|0;q=c+12|0;r=c+28|0;s=e+8|0;a:while(1){b:while(1){t=f[c>>2]|0;if(t>>>0<(f[g>>2]|0)>>>0){v=b[t>>0]|0;w=v&255;if(v<<24>>24>0){f[i>>2]=w;f[c>>2]=t+1;x=w;y=7}else{z=w;y=6}}else{z=0;y=6}if((y|0)==6){y=0;w=_nb(c,z)|0;f[i>>2]=w;if((w+-1|0)>>>0<127){x=w;y=7}else{A=w;y=54}}c:do if((y|0)==7){y=0;switch(x>>>3&536870911|0){case 1:{switch(x|0){case 0:{B=1;y=60;break a;break}case 8:{y=9;break b;break}default:{C=x;break c}}break}case 2:{switch(x|0){case 0:{B=1;y=60;break a;break}case 21:{y=23;break b;break}case 18:{y=38;break b;break}default:{C=x;break c}}break}case 3:{switch(x|0){case 0:{B=1;y=60;break a;break}case 24:{y=44;break b;break}default:{C=x;break c}}break}default:{A=x;y=54;break c}}}while(0);if((y|0)==54){y=0;if(!A){B=1;y=60;break a}else C=A}if((C&7|0)==4){B=1;y=60;break a}w=f[j>>2]|0;if(!(w&1))D=hBa(j)|0;else D=w&-2;if(!(ZPb(c,C,D)|0)){B=0;y=60;break a}}if((y|0)==9){y=0;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0){t=b[w>>0]|0;v=t&255;if(t<<24>>24>-1){f[c>>2]=w+1;E=v}else{F=v;y=12}}else{F=0;y=12}if((y|0)==12){y=0;v=Knb(c,F)|0;w=J;if((w|0)>-1|(w|0)==-1&v>>>0>4294967295)E=v;else{B=0;y=60;break}}if(E>>>0<3){f[k>>2]=f[k>>2]|1;f[l>>2]=E}else{v=f[j>>2]|0;if(!(v&1))G=hBa(j)|0;else G=v&-2;NPb(G,1,E,((E|0)<0)<<31>>31)}v=f[c>>2]|0;w=f[g>>2]|0;if(v>>>0>=w>>>0)continue;if((b[v>>0]|0)==21){H=w;I=v;y=22}else continue}else if((y|0)==23){y=0;K=g;L=f[c>>2]|0;M=f[g>>2]|0;y=24}else if((y|0)==38){y=0;if(DMa(c,m)|0)y=39;else{B=0;y=60;break}}else if((y|0)==44){y=0;N=f[c>>2]|0;O=f[g>>2]|0;y=45}while(1)if((y|0)==22){y=0;v=I+1|0;f[c>>2]=v;K=g;L=v;M=H;y=24;continue}else if((y|0)==24){y=0;if((M-L|0)>3){v=L;w=h[v>>0]|h[v+1>>0]<<8|h[v+2>>0]<<16|h[v+3>>0]<<24;f[e>>2]=w;f[c>>2]=L+4;P=w}else{if(!(Xnb(c,e)|0)){y=37;break a}P=f[e>>2]|0}w=f[m>>2]|0;if((w|0)==(f[n>>2]|0)){qza(m,w+1|0);Q=f[m>>2]|0}else Q=w;w=f[o>>2]|0;v=Q+1|0;f[m>>2]=v;f[w+4+(Q<<2)>>2]=P;t=f[c>>2]|0;R=(f[K>>2]|0)-t|0;if((R|0)<=0){y=39;continue}S=(f[n>>2]|0)-v|0;T=(R>>>0)/5|0;R=(T|0)<(S|0)?T:S;if((R|0)<=0){y=39;continue}S=0;T=t;t=v;while(1){if((b[T>>0]|0)!=21){U=S;break}v=T+1|0;V=h[v>>0]|h[v+1>>0]<<8|h[v+2>>0]<<16|h[v+3>>0]<<24;v=t;t=t+1|0;f[m>>2]=t;f[w+4+(v<<2)>>2]=V;V=S+1|0;if((V|0)>=(R|0)){U=V;break}else{S=V;T=T+5|0}}if((U|0)<=0){y=39;continue}Tnb(c,U*5|0)|0;y=39;continue}else if((y|0)==39){y=0;T=f[c>>2]|0;S=f[g>>2]|0;if(T>>>0>=S>>>0)continue a;if((b[T>>0]|0)==21){H=S;I=T;y=22;continue}if((b[T>>0]|0)!=24)continue a;R=T+1|0;f[c>>2]=R;N=R;O=S;y=45;continue}else if((y|0)==45){y=0;f[k>>2]=f[k>>2]|4;if(N>>>0<O>>>0){y=46;break}else{y=48;break}}if((y|0)==46){y=0;S=b[N>>0]|0;if(S<<24>>24>-1){R=N+1|0;f[c>>2]=R;W=S<<24>>24!=0;X=R;Y=O}else y=48}if((y|0)==48){y=0;Lnb(e,c);R=e;if(!(b[s>>0]|0)){B=0;y=60;break}W=(f[R>>2]|0)!=0|(f[R+4>>2]|0)!=0;X=f[c>>2]|0;Y=f[g>>2]|0}b[p>>0]=W&1;if((X|0)!=(Y|0))continue;if(f[a>>2]|0){y=53;break}if((f[q>>2]|0)==(f[r>>2]|0)){y=53;break}}if((y|0)==37){B=0;u=d;return B|0}else if((y|0)==53){f[i>>2]=0;b[c+24>>0]=1;B=1;u=d;return B|0}else if((y|0)==60){u=d;return B|0}return 0}function gQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+16|0;l=c+32|0;m=c+12|0;n=c+28|0;o=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[i>>2]=q;f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=_nb(c,t)|0;f[i>>2]=q;if((q+-1|0)>>>0<127){r=q;s=6}else v=q}if((s|0)==6){s=0;if((r|0)==13){f[j>>2]=f[j>>2]|1;q=f[g>>2]|0;a=f[c>>2]|0;if((q-a|0)>3){p=a;w=h[p>>0]|h[p+1>>0]<<8|h[p+2>>0]<<16|h[p+3>>0]<<24;f[e>>2]=w;p=a+4|0;f[c>>2]=p;x=w;y=p;z=q}else{if(!(Xnb(c,e)|0)){s=11;break}x=f[e>>2]|0;y=f[c>>2]|0;z=f[g>>2]|0}f[k>>2]=x;if((y|0)!=(z|0))continue;if(f[l>>2]|0){s=15;break}if((f[m>>2]|0)==(f[n>>2]|0)){s=15;break}else continue}else v=r}if((v|0)==0|(v&7|0)==4){A=1;s=21;break}q=f[o>>2]|0;if(!(q&1))B=hBa(o)|0;else B=q&-2;if(!(ZPb(c,v,B)|0)){A=0;s=21;break}}if((s|0)==11){A=0;u=d;return A|0}else if((s|0)==15){f[i>>2]=0;b[c+24>>0]=1;A=1;u=d;return A|0}else if((s|0)==21){u=d;return A|0}return 0}function hQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0;d=c+4|0;e=c+20|0;g=c+44|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=a+48|0;m=a+52|0;n=a+56|0;o=a+60|0;p=a+64|0;q=a+68|0;r=a+72|0;s=a+76|0;t=a+80|0;u=a+84|0;v=a+88|0;w=a+92|0;x=a+32|0;y=a+44|0;z=a+40|0;A=a+36|0;B=c+32|0;C=c+12|0;D=c+28|0;E=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){F=b[a>>0]|0;G=F&255;if(F<<24>>24>0){f[e>>2]=G;f[c>>2]=a+1;H=G;I=6}else{K=G;I=5}}else{K=0;I=5}if((I|0)==5){I=0;G=_nb(c,K)|0;f[e>>2]=G;if((G+-1|0)>>>0<127){H=G;I=6}else{L=G;I=130}}b:do if((I|0)==6){I=0;c:do switch(H>>>3&536870911|0){case 1:{switch(H|0){case 0:{M=1;I=136;break a;break}case 10:break;default:{N=H;break b}}G=f[g>>2]|0;f[g>>2]=G+-1;if((G|0)<=0){M=0;I=136;break a}while(1){G=f[i>>2]|0;do if(G){a=f[k>>2]|0;F=f[G>>2]|0;if((a|0)>=(F|0))if((F|0)==(f[j>>2]|0)){O=F;I=14;break}else{P=F;Q=G;I=15;break}else{f[k>>2]=a+1;R=f[G+4+(a<<2)>>2]|0;break}}else{O=f[j>>2]|0;I=14}while(0);if((I|0)==14){I=0;cpb(h,O+1|0);G=f[i>>2]|0;P=f[G>>2]|0;Q=G;I=15}if((I|0)==15){I=0;f[Q>>2]=P+1;G=zPa(0,f[h>>2]|0)|0;a=f[i>>2]|0;F=f[k>>2]|0;f[k>>2]=F+1;f[a+4+(F<<2)>>2]=G;R=G}G=Jnb(c)|0;if(!(JNa(R,c)|0)){M=0;I=136;break a}if(!(Pnb(c,G)|0)){M=0;I=136;break a}S=f[c>>2]|0;T=f[d>>2]|0;if(S>>>0>=T>>>0){I=19;break}if((b[S>>0]|0)!=10){I=22;break}f[c>>2]=S+1}if((I|0)==19){I=0;f[g>>2]=(f[g>>2]|0)+1;continue a}else if((I|0)==22){I=0;f[g>>2]=(f[g>>2]|0)+1;if((b[S>>0]|0)==16){U=S;V=T;I=25;break c}else continue a}break}case 2:{switch(H|0){case 0:{M=1;I=136;break a;break}case 16:{W=f[c>>2]|0;X=f[d>>2]|0;I=26;break c;break}case 18:{if(wQa(c,l)|0){I=42;break c}else{M=0;I=136;break a}break}default:{N=H;break b}}break}case 3:{switch(H|0){case 0:{M=1;I=136;break a;break}case 24:{Y=f[c>>2]|0;Z=f[d>>2]|0;I=48;break c;break}case 26:{if(wQa(c,o)|0){I=64;break c}else{M=0;I=136;break a}break}default:{N=H;break b}}break}case 4:{switch(H|0){case 0:{M=1;I=136;break a;break}case 32:{_=f[c>>2]|0;$=f[d>>2]|0;I=70;break c;break}case 34:{if(wQa(c,r)|0){I=86;break c}else{M=0;I=136;break a}break}default:{N=H;break b}}break}case 5:{switch(H|0){case 0:{M=1;I=136;break a;break}case 40:{aa=f[c>>2]|0;ba=f[d>>2]|0;I=92;break c;break}case 42:{if(wQa(c,u)|0){I=108;break c}else{M=0;I=136;break a}break}default:{N=H;break b}}break}case 6:{switch(H|0){case 0:{M=1;I=136;break a;break}case 50:{I=113;break}default:{N=H;break b}}break}default:{L=H;I=130;break b}}while(0);d:while(1){switch(I|0){case 25:{I=0;G=U+1|0;f[c>>2]=G;W=G;X=V;I=26;continue d;break}case 26:{I=0;if(W>>>0<X>>>0){G=b[W>>0]|0;F=G&255;if(G<<24>>24>-1){f[c>>2]=W+1;ca=F}else{da=F;I=29}}else{da=0;I=29}if((I|0)==29){I=0;F=Knb(c,da)|0;G=J;if((G|0)>-1|(G|0)==-1&F>>>0>4294967295)ca=F;else{M=0;I=136;break a}}F=f[l>>2]|0;if((F|0)==(f[m>>2]|0)){rza(l,F+1|0);ea=f[l>>2]|0}else ea=F;F=f[n>>2]|0;f[l>>2]=ea+1;f[F+4+(ea<<2)>>2]=ca;G=(f[m>>2]|0)-(f[l>>2]|0)|0;if((G|0)>0){fa=G;ga=F}else{I=42;continue d}while(1){F=f[c>>2]|0;G=f[d>>2]|0;if(F>>>0>=G>>>0){I=42;continue d}if((b[F>>0]|0)!=16){I=42;continue d}a=F+1|0;f[c>>2]=a;if(a>>>0<G>>>0){G=b[a>>0]|0;a=G&255;if(G<<24>>24>-1){f[c>>2]=F+2;ha=a;ia=ga}else{ja=a;I=37}}else{ja=0;I=37}if((I|0)==37){I=0;a=Knb(c,ja)|0;F=J;if(!((F|0)>-1|(F|0)==-1&a>>>0>4294967295)){M=0;I=136;break a}ha=a;ia=f[n>>2]|0}a=f[l>>2]|0;f[l>>2]=a+1;f[ia+4+(a<<2)>>2]=ha;if((fa|0)>1){fa=fa+-1|0;ga=ia}else{I=42;continue d}}break}case 42:{I=0;a=f[c>>2]|0;F=f[d>>2]|0;if(a>>>0>=F>>>0)continue a;if((b[a>>0]|0)==16){U=a;V=F;I=25;continue d}if((b[a>>0]|0)==24){ka=a;la=F;I=47}else continue a;break}case 48:{I=0;if(Y>>>0<Z>>>0){F=b[Y>>0]|0;a=F&255;if(F<<24>>24>-1){f[c>>2]=Y+1;ma=a}else{na=a;I=51}}else{na=0;I=51}if((I|0)==51){I=0;a=Knb(c,na)|0;F=J;if((F|0)>-1|(F|0)==-1&a>>>0>4294967295)ma=a;else{M=0;I=136;break a}}a=f[o>>2]|0;if((a|0)==(f[p>>2]|0)){rza(o,a+1|0);oa=f[o>>2]|0}else oa=a;a=f[q>>2]|0;f[o>>2]=oa+1;f[a+4+(oa<<2)>>2]=ma;F=(f[p>>2]|0)-(f[o>>2]|0)|0;if((F|0)>0){pa=F;qa=a}else{I=64;continue d}while(1){a=f[c>>2]|0;F=f[d>>2]|0;if(a>>>0>=F>>>0){I=64;continue d}if((b[a>>0]|0)!=24){I=64;continue d}G=a+1|0;f[c>>2]=G;if(G>>>0<F>>>0){F=b[G>>0]|0;G=F&255;if(F<<24>>24>-1){f[c>>2]=a+2;ra=G;sa=qa}else{ta=G;I=59}}else{ta=0;I=59}if((I|0)==59){I=0;G=Knb(c,ta)|0;a=J;if(!((a|0)>-1|(a|0)==-1&G>>>0>4294967295)){M=0;I=136;break a}ra=G;sa=f[q>>2]|0}G=f[o>>2]|0;f[o>>2]=G+1;f[sa+4+(G<<2)>>2]=ra;if((pa|0)>1){pa=pa+-1|0;qa=sa}else{I=64;continue d}}break}case 64:{I=0;G=f[c>>2]|0;a=f[d>>2]|0;if(G>>>0>=a>>>0)continue a;if((b[G>>0]|0)!=24)if((b[G>>0]|0)==32){ua=G;va=a;I=69}else continue a;else{ka=G;la=a;I=47}break}case 70:{I=0;if(_>>>0<$>>>0){a=b[_>>0]|0;G=a&255;if(a<<24>>24>-1){f[c>>2]=_+1;wa=G}else{xa=G;I=73}}else{xa=0;I=73}if((I|0)==73){I=0;G=Knb(c,xa)|0;a=J;if((a|0)>-1|(a|0)==-1&G>>>0>4294967295)wa=G;else{M=0;I=136;break a}}G=f[r>>2]|0;if((G|0)==(f[s>>2]|0)){rza(r,G+1|0);ya=f[r>>2]|0}else ya=G;G=f[t>>2]|0;f[r>>2]=ya+1;f[G+4+(ya<<2)>>2]=wa;a=(f[s>>2]|0)-(f[r>>2]|0)|0;if((a|0)>0){za=a;Aa=G}else{I=86;continue d}while(1){G=f[c>>2]|0;a=f[d>>2]|0;if(G>>>0>=a>>>0){I=86;continue d}if((b[G>>0]|0)!=32){I=86;continue d}F=G+1|0;f[c>>2]=F;if(F>>>0<a>>>0){a=b[F>>0]|0;F=a&255;if(a<<24>>24>-1){f[c>>2]=G+2;Ba=F;Ca=Aa}else{Da=F;I=81}}else{Da=0;I=81}if((I|0)==81){I=0;F=Knb(c,Da)|0;G=J;if(!((G|0)>-1|(G|0)==-1&F>>>0>4294967295)){M=0;I=136;break a}Ba=F;Ca=f[t>>2]|0}F=f[r>>2]|0;f[r>>2]=F+1;f[Ca+4+(F<<2)>>2]=Ba;if((za|0)>1){za=za+-1|0;Aa=Ca}else{I=86;continue d}}break}case 86:{I=0;F=f[c>>2]|0;G=f[d>>2]|0;if(F>>>0>=G>>>0)continue a;if((b[F>>0]|0)!=32)if((b[F>>0]|0)==40){Ea=F;Fa=G;I=91}else continue a;else{ua=F;va=G;I=69}break}case 92:{I=0;if(aa>>>0<ba>>>0){G=b[aa>>0]|0;F=G&255;if(G<<24>>24>-1){f[c>>2]=aa+1;Ga=F}else{Ha=F;I=95}}else{Ha=0;I=95}if((I|0)==95){I=0;F=Knb(c,Ha)|0;G=J;if((G|0)>-1|(G|0)==-1&F>>>0>4294967295)Ga=F;else{M=0;I=136;break a}}F=f[u>>2]|0;if((F|0)==(f[v>>2]|0)){rza(u,F+1|0);Ia=f[u>>2]|0}else Ia=F;F=f[w>>2]|0;f[u>>2]=Ia+1;f[F+4+(Ia<<2)>>2]=Ga;G=(f[v>>2]|0)-(f[u>>2]|0)|0;if((G|0)>0){Ja=G;Ka=F}else{I=108;continue d}while(1){F=f[c>>2]|0;G=f[d>>2]|0;if(F>>>0>=G>>>0){I=108;continue d}if((b[F>>0]|0)!=40){I=108;continue d}a=F+1|0;f[c>>2]=a;if(a>>>0<G>>>0){G=b[a>>0]|0;a=G&255;if(G<<24>>24>-1){f[c>>2]=F+2;La=a;Ma=Ka}else{Na=a;I=103}}else{Na=0;I=103}if((I|0)==103){I=0;a=Knb(c,Na)|0;F=J;if(!((F|0)>-1|(F|0)==-1&a>>>0>4294967295)){M=0;I=136;break a}La=a;Ma=f[w>>2]|0}a=f[u>>2]|0;f[u>>2]=a+1;f[Ma+4+(a<<2)>>2]=La;if((Ja|0)>1){Ja=Ja+-1|0;Ka=Ma}else{I=108;continue d}}break}case 108:{I=0;a=f[c>>2]|0;F=f[d>>2]|0;if(a>>>0>=F>>>0)continue a;if((b[a>>0]|0)==40){Ea=a;Fa=F;I=91}else{if((b[a>>0]|0)!=50)continue a;f[c>>2]=a+1;I=113;continue d}break}case 113:{I=0;a=f[g>>2]|0;f[g>>2]=a+-1;if((a|0)>0)break d;else{M=0;I=136;break a}break}}if((I|0)==47){I=0;a=ka+1|0;f[c>>2]=a;Y=a;Z=la;I=48;continue}else if((I|0)==69){I=0;a=ua+1|0;f[c>>2]=a;_=a;$=va;I=70;continue}else if((I|0)==91){I=0;a=Ea+1|0;f[c>>2]=a;aa=a;ba=Fa;I=92;continue}}while(1){a=f[y>>2]|0;do if(a){F=f[A>>2]|0;G=f[a>>2]|0;if((F|0)>=(G|0))if((G|0)==(f[z>>2]|0)){Oa=G;I=119;break}else{Pa=G;Qa=a;I=120;break}else{f[A>>2]=F+1;Ra=f[a+4+(F<<2)>>2]|0;break}}else{Oa=f[z>>2]|0;I=119}while(0);if((I|0)==119){I=0;cpb(x,Oa+1|0);a=f[y>>2]|0;Pa=f[a>>2]|0;Qa=a;I=120}if((I|0)==120){I=0;f[Qa>>2]=Pa+1;a=vPa(0,f[x>>2]|0)|0;F=f[y>>2]|0;G=f[A>>2]|0;f[A>>2]=G+1;f[F+4+(G<<2)>>2]=a;Ra=a}a=Jnb(c)|0;if(!(GLa(Ra,c)|0)){M=0;I=136;break a}if(!(Pnb(c,a)|0)){M=0;I=136;break a}Sa=f[c>>2]|0;Ta=f[d>>2]|0;if(Sa>>>0>=Ta>>>0)break;if((b[Sa>>0]|0)!=50)break;f[c>>2]=Sa+1}f[g>>2]=(f[g>>2]|0)+1;if((Sa|0)!=(Ta|0))continue a;if(f[B>>2]|0){I=129;break a}if((f[C>>2]|0)==(f[D>>2]|0)){I=129;break a}else continue a}while(0);if((I|0)==130){I=0;if(!L){M=1;I=136;break}else N=L}if((N&7|0)==4){M=1;I=136;break}a=f[E>>2]|0;if(!(a&1))Ua=hBa(E)|0;else Ua=a&-2;if(!(ZPb(c,N,Ua)|0)){M=0;I=136;break}}if((I|0)==129){f[e>>2]=0;b[c+24>>0]=1;M=1;return M|0}else if((I|0)==136)return M|0;return 0}function iQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+20|0;i=a+24|0;j=a+16|0;k=c+32|0;l=c+12|0;m=c+28|0;n=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){o=b[a>>0]|0;p=o&255;if(o<<24>>24>0){f[e>>2]=p;f[c>>2]=a+1;q=p;r=6}else{s=p;r=5}}else{s=0;r=5}if((r|0)==5){r=0;p=_nb(c,s)|0;f[e>>2]=p;if((p+-1|0)>>>0<127){q=p;r=6}else{t=p;r=37}}b:do if((r|0)==6){r=0;switch(q>>>3&536870911|0){case 1:{switch(q|0){case 0:{u=1;r=43;break a;break}case 8:break;default:{v=q;break b}}f[g>>2]=f[g>>2]|1;p=f[c>>2]|0;if(p>>>0<(f[d>>2]|0)>>>0){a=b[p>>0]|0;o=a&255;if(a<<24>>24>-1){f[h>>2]=o;a=p+1|0;f[c>>2]=a;w=a}else{x=o;r=11}}else{x=0;r=11}if((r|0)==11){r=0;o=Knb(c,x)|0;a=J;f[h>>2]=o;if(!((a|0)>-1|(a|0)==-1&o>>>0>4294967295)){u=0;r=43;break a}w=f[c>>2]|0}o=f[d>>2]|0;if(w>>>0>=o>>>0)continue a;if((b[w>>0]|0)!=16)continue a;a=w+1|0;f[c>>2]=a;y=a;z=o;r=18;break}case 2:{switch(q|0){case 0:{u=1;r=43;break a;break}case 16:break;default:{v=q;break b}}y=f[c>>2]|0;z=f[d>>2]|0;r=18;break}case 3:{switch(q|0){case 0:{u=1;r=43;break a;break}case 24:break;default:{v=q;break b}}A=f[c>>2]|0;B=f[d>>2]|0;break}default:{t=q;r=37;break b}}if((r|0)==18){r=0;f[g>>2]=f[g>>2]|2;if(y>>>0<z>>>0){o=b[y>>0]|0;a=o&255;if(o<<24>>24>-1){o=y+1|0;f[c>>2]=o;C=a;D=o;E=z}else{F=a;r=21}}else{F=0;r=21}if((r|0)==21){r=0;a=Knb(c,F)|0;o=J;if(!((o|0)>-1|(o|0)==-1&a>>>0>4294967295)){u=0;r=43;break a}C=a;D=f[c>>2]|0;E=f[d>>2]|0}f[i>>2]=C;if(D>>>0>=E>>>0)continue a;if((b[D>>0]|0)!=24)continue a;a=D+1|0;f[c>>2]=a;A=a;B=E}f[g>>2]=f[g>>2]|4;if(A>>>0<B>>>0){a=b[A>>0]|0;o=a&255;if(a<<24>>24>-1){a=A+1|0;f[c>>2]=a;G=o;H=a;I=B}else{K=o;r=31}}else{K=0;r=31}if((r|0)==31){r=0;o=Knb(c,K)|0;a=J;if(!((a|0)>-1|(a|0)==-1&o>>>0>4294967295)){u=0;r=43;break a}G=o;H=f[c>>2]|0;I=f[d>>2]|0}f[j>>2]=G;if((H|0)!=(I|0))continue a;if(f[k>>2]|0){r=36;break a}if((f[l>>2]|0)==(f[m>>2]|0)){r=36;break a}else continue a}while(0);if((r|0)==37){r=0;if(!t){u=1;r=43;break}else v=t}if((v&7|0)==4){u=1;r=43;break}o=f[n>>2]|0;if(!(o&1))L=hBa(n)|0;else L=o&-2;if(!(ZPb(c,v,L)|0)){u=0;r=43;break}}if((r|0)==36){f[e>>2]=0;b[c+24>>0]=1;u=1;return u|0}else if((r|0)==43)return u|0;return 0}function jQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+16|0;i=c+32|0;j=c+12|0;k=c+28|0;l=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[e>>2]=n;f[c>>2]=a+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=_nb(c,q)|0;f[e>>2]=n;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}if((p|0)==6){p=0;if((o|0)==8){n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){a=b[n>>0]|0;m=a&255;if(a<<24>>24>-1){f[c>>2]=n+1;s=m}else{t=m;p=10}}else{t=0;p=10}if((p|0)==10){p=0;m=Knb(c,t)|0;n=J;if((n|0)>-1|(n|0)==-1&m>>>0>4294967295)s=m;else{u=0;p=26;break}}if((s+-1|0)>>>0<2){f[g>>2]=f[g>>2]|1;f[h>>2]=s}else{m=f[l>>2]|0;if(!(m&1))v=hBa(l)|0;else v=m&-2;NPb(v,1,s,((s|0)<0)<<31>>31)}if((f[c>>2]|0)!=(f[d>>2]|0))continue;if(f[i>>2]|0){p=20;break}if((f[j>>2]|0)==(f[k>>2]|0)){p=20;break}else continue}else r=o}if((r|0)==0|(r&7|0)==4){u=1;p=26;break}m=f[l>>2]|0;if(!(m&1))w=hBa(l)|0;else w=m&-2;if(!(ZPb(c,r,w)|0)){u=0;p=26;break}}if((p|0)==20){f[e>>2]=0;b[c+24>>0]=1;u=1;return u|0}else if((p|0)==26)return u|0;return 0}function kQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+16|0;l=a+4|0;m=a+20|0;a=c+32|0;n=c+12|0;o=c+28|0;a:while(1){b:while(1){p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0){q=b[p>>0]|0;r=q&255;if(q<<24>>24>0){f[i>>2]=r;f[c>>2]=p+1;s=r;t=7}else{v=r;t=6}}else{v=0;t=6}if((t|0)==6){t=0;r=_nb(c,v)|0;f[i>>2]=r;if((r+-1|0)>>>0<127){s=r;t=7}else{w=r;t=33}}c:do if((t|0)==7){t=0;switch(s>>>3&536870911|0){case 1:break;case 2:{switch(s|0){case 0:{x=1;t=39;break a;break}case 16:{t=18;break b;break}default:{y=s;break c}}break}default:{w=s;t=33;break c}}switch(s|0){case 0:{x=1;t=39;break a;break}case 13:break;default:{y=s;break c}}f[j>>2]=f[j>>2]|1;r=f[g>>2]|0;p=f[c>>2]|0;if((r-p|0)>3){q=p;z=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;f[e>>2]=z;q=p+4|0;f[c>>2]=q;A=z;B=q;C=r}else{if(!(Xnb(c,e)|0)){t=13;break a}A=f[e>>2]|0;B=f[c>>2]|0;C=f[g>>2]|0}f[k>>2]=A;if(B>>>0>=C>>>0)continue b;if((b[B>>0]|0)==16){t=16;break b}else continue b}while(0);if((t|0)==33){t=0;if(!w){x=1;t=39;break a}else y=w}if((y&7|0)==4){x=1;t=39;break a}r=f[l>>2]|0;if(!(r&1))D=hBa(l)|0;else D=r&-2;if(!(ZPb(c,y,D)|0)){x=0;t=39;break a}}if((t|0)==16){t=0;r=B+1|0;f[c>>2]=r;E=r;F=C}else if((t|0)==18){t=0;E=f[c>>2]|0;F=f[g>>2]|0}if(E>>>0<F>>>0){r=b[E>>0]|0;q=r&255;if(r<<24>>24>-1){f[c>>2]=E+1;G=q}else{H=q;t=22}}else{H=0;t=22}if((t|0)==22){t=0;q=Knb(c,H)|0;r=J;if((r|0)>-1|(r|0)==-1&q>>>0>4294967295)G=q;else{x=0;t=39;break}}if(G>>>0<3){f[j>>2]=f[j>>2]|2;f[m>>2]=G}else{q=f[l>>2]|0;if(!(q&1))I=hBa(l)|0;else I=q&-2;NPb(I,2,G,((G|0)<0)<<31>>31)}if((f[c>>2]|0)!=(f[g>>2]|0))continue;if(f[a>>2]|0){t=32;break}if((f[n>>2]|0)==(f[o>>2]|0)){t=32;break}}if((t|0)==13){x=0;u=d;return x|0}else if((t|0)==32){f[i>>2]=0;b[c+24>>0]=1;x=1;u=d;return x|0}else if((t|0)==39){u=d;return x|0}return 0}function lQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+32|0;i=a+16|0;j=a+20|0;k=a+24|0;l=a+28|0;m=c+32|0;n=c+12|0;o=c+28|0;p=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){q=b[a>>0]|0;r=q&255;if(q<<24>>24>0){f[e>>2]=r;f[c>>2]=a+1;s=r;t=6}else{u=r;t=5}}else{u=0;t=5}if((t|0)==5){t=0;r=_nb(c,u)|0;f[e>>2]=r;if((r+-1|0)>>>0<127){s=r;t=6}else{v=r;t=49}}b:do if((t|0)==6){t=0;c:do switch(s>>>3&536870911|0){case 1:{switch(s|0){case 0:{w=1;t=55;break a;break}case 8:break;default:{x=s;break b}}f[g>>2]=f[g>>2]|4;r=f[c>>2]|0;if(r>>>0<(f[d>>2]|0)>>>0){a=b[r>>0]|0;q=a&255;if(a<<24>>24>-1){f[h>>2]=q;a=r+1|0;f[c>>2]=a;y=a}else{z=q;t=11}}else{z=0;t=11}if((t|0)==11){t=0;q=Knb(c,z)|0;a=J;f[h>>2]=q;if(!((a|0)>-1|(a|0)==-1&q>>>0>4294967295)){w=0;t=55;break a}y=f[c>>2]|0}q=f[d>>2]|0;if(y>>>0>=q>>>0)continue a;if((b[y>>0]|0)==16){A=y;B=q;t=17}else continue a;break}case 2:{switch(s|0){case 0:{w=1;t=55;break a;break}case 16:{C=f[c>>2]|0;D=f[d>>2]|0;t=18;break c;break}case 18:{if(wQa(c,i)|0){t=34;break c}else{w=0;t=55;break a}break}default:{x=s;break b}}break}case 3:{switch(s|0){case 0:{w=1;t=55;break a;break}case 24:break;default:{x=s;break b}}E=f[c>>2]|0;F=f[d>>2]|0;t=40;break}default:{v=s;t=49;break b}}while(0);d:while(1)if((t|0)==17){t=0;q=A+1|0;f[c>>2]=q;C=q;D=B;t=18;continue}else if((t|0)==18){t=0;if(C>>>0<D>>>0){q=b[C>>0]|0;a=q&255;if(q<<24>>24>-1){f[c>>2]=C+1;G=a}else{H=a;t=21}}else{H=0;t=21}if((t|0)==21){t=0;a=Knb(c,H)|0;q=J;if((q|0)>-1|(q|0)==-1&a>>>0>4294967295)G=a;else{w=0;t=55;break a}}a=f[i>>2]|0;if((a|0)==(f[j>>2]|0)){rza(i,a+1|0);I=f[i>>2]|0}else I=a;a=f[k>>2]|0;f[i>>2]=I+1;f[a+4+(I<<2)>>2]=G;q=(f[j>>2]|0)-(f[i>>2]|0)|0;if((q|0)>0){K=q;L=a}else{t=34;continue}while(1){a=f[c>>2]|0;q=f[d>>2]|0;if(a>>>0>=q>>>0){t=34;continue d}if((b[a>>0]|0)!=16){t=34;continue d}r=a+1|0;f[c>>2]=r;if(r>>>0<q>>>0){q=b[r>>0]|0;r=q&255;if(q<<24>>24>-1){f[c>>2]=a+2;M=r;N=L}else{O=r;t=29}}else{O=0;t=29}if((t|0)==29){t=0;r=Knb(c,O)|0;a=J;if(!((a|0)>-1|(a|0)==-1&r>>>0>4294967295)){w=0;t=55;break a}M=r;N=f[k>>2]|0}r=f[i>>2]|0;f[i>>2]=r+1;f[N+4+(r<<2)>>2]=M;if((K|0)>1){K=K+-1|0;L=N}else{t=34;continue d}}}else if((t|0)==34){t=0;r=f[c>>2]|0;a=f[d>>2]|0;if(r>>>0>=a>>>0)continue a;if((b[r>>0]|0)==16){A=r;B=a;t=17;continue}if((b[r>>0]|0)!=24)continue a;q=r+1|0;f[c>>2]=q;E=q;F=a;t=40;continue}else if((t|0)==40){t=0;f[g>>2]=f[g>>2]|1;if(E>>>0<F>>>0){t=41;break}else{P=0;t=43;break}}if((t|0)==41){t=0;a=b[E>>0]|0;q=a&255;if(a<<24>>24>-1){a=E+1|0;f[c>>2]=a;Q=q;R=a;S=F}else{P=q;t=43}}if((t|0)==43){t=0;q=Knb(c,P)|0;a=J;if(!((a|0)>-1|(a|0)==-1&q>>>0>4294967295)){w=0;t=55;break a}Q=q;R=f[c>>2]|0;S=f[d>>2]|0}f[l>>2]=Q;if((R|0)!=(S|0))continue a;if(f[m>>2]|0){t=48;break a}if((f[n>>2]|0)==(f[o>>2]|0)){t=48;break a}else continue a}while(0);if((t|0)==49){t=0;if(!v){w=1;t=55;break}else x=v}if((x&7|0)==4){w=1;t=55;break}q=f[p>>2]|0;if(!(q&1))T=hBa(p)|0;else T=q&-2;if(!(ZPb(c,x,T)|0)){w=0;t=55;break}}if((t|0)==48){f[e>>2]=0;b[c+24>>0]=1;w=1;return w|0}else if((t|0)==55)return w|0;return 0}function mQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+48|0;i=a+4|0;j=a+52|0;k=a+56|0;l=a+16|0;m=a+32|0;a=c+32|0;n=c+12|0;o=c+28|0;a:while(1){p=f[c>>2]|0;if(p>>>0<(f[d>>2]|0)>>>0){q=b[p>>0]|0;r=q&255;if(q<<24>>24>0){f[e>>2]=r;f[c>>2]=p+1;s=r;t=6}else{u=r;t=5}}else{u=0;t=5}if((t|0)==5){t=0;r=_nb(c,u)|0;f[e>>2]=r;if((r+-1|0)>>>0<127){s=r;t=6}else{v=r;t=55}}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{switch(s|0){case 0:{w=1;t=61;break a;break}case 8:break;default:{x=s;break b}}r=f[c>>2]|0;if(r>>>0<(f[d>>2]|0)>>>0){p=b[r>>0]|0;q=p&255;if(p<<24>>24>-1){f[c>>2]=r+1;y=q}else{z=q;t=11}}else{z=0;t=11}if((t|0)==11){t=0;q=Knb(c,z)|0;r=J;if((r|0)>-1|(r|0)==-1&q>>>0>4294967295)y=q;else{w=0;t=61;break a}}if(y>>>0<2){f[g>>2]=f[g>>2]|1;f[h>>2]=y}else{q=f[i>>2]|0;if(!(q&1))A=hBa(i)|0;else A=q&-2;NPb(A,1,y,((y|0)<0)<<31>>31)}q=f[c>>2]|0;r=f[d>>2]|0;if(q>>>0>=r>>>0)continue a;if((b[q>>0]|0)!=16)continue a;p=q+1|0;f[c>>2]=p;B=p;C=r;t=23;break}case 2:{switch(s|0){case 0:{w=1;t=61;break a;break}case 16:break;default:{x=s;break b}}B=f[c>>2]|0;C=f[d>>2]|0;t=23;break}case 3:{switch(s|0){case 0:{w=1;t=61;break a;break}case 24:break;default:{x=s;break b}}D=f[c>>2]|0;E=f[d>>2]|0;t=33;break}case 4:{switch(s|0){case 0:{w=1;t=61;break a;break}case 34:{t=42;break}default:{x=s;break b}}break}case 5:{switch(s|0){case 0:{w=1;t=61;break a;break}case 42:{t=48;break}default:{x=s;break b}}break}default:{v=s;t=55;break b}}if((t|0)==23){t=0;f[g>>2]=f[g>>2]|2;if(B>>>0<C>>>0){r=b[B>>0]|0;p=r&255;if(r<<24>>24>-1){r=B+1|0;f[c>>2]=r;F=p;G=r;H=C}else{I=p;t=26}}else{I=0;t=26}if((t|0)==26){t=0;p=Knb(c,I)|0;r=J;if(!((r|0)>-1|(r|0)==-1&p>>>0>4294967295)){w=0;t=61;break a}F=p;G=f[c>>2]|0;H=f[d>>2]|0}f[j>>2]=F;if(G>>>0>=H>>>0)continue a;if((b[G>>0]|0)!=24)continue a;p=G+1|0;f[c>>2]=p;D=p;E=H;t=33}if((t|0)==33){t=0;f[g>>2]=f[g>>2]|4;if(D>>>0<E>>>0){p=b[D>>0]|0;r=p&255;if(p<<24>>24>-1){p=D+1|0;f[c>>2]=p;K=r;L=p;M=E}else{N=r;t=36}}else{N=0;t=36}if((t|0)==36){t=0;r=Knb(c,N)|0;p=J;if(!((p|0)>-1|(p|0)==-1&r>>>0>4294967295)){w=0;t=61;break a}K=r;L=f[c>>2]|0;M=f[d>>2]|0}f[k>>2]=K;if(L>>>0>=M>>>0)continue a;if((b[L>>0]|0)==34){O=L;t=41}else continue a}while(1){if((t|0)==41){t=0;f[c>>2]=O+1;t=42;continue}else if((t|0)==42){t=0;if(!(fqb(c,mza(l)|0)|0)){w=0;t=61;break a}r=f[c>>2]|0;if(r>>>0>=(f[d>>2]|0)>>>0)continue a;if((b[r>>0]|0)==34){O=r;t=41;continue}if((b[r>>0]|0)==42)P=r;else continue a}else if((t|0)==48){t=0;if(!(fqb(c,mza(m)|0)|0)){w=0;t=61;break a}Q=f[c>>2]|0;R=f[d>>2]|0;if(Q>>>0>=R>>>0)break;if((b[Q>>0]|0)==42)P=Q;else break}f[c>>2]=P+1;t=48}if((Q|0)!=(R|0))continue a;if(f[a>>2]|0){t=54;break a}if((f[n>>2]|0)==(f[o>>2]|0)){t=54;break a}else continue a}while(0);if((t|0)==55){t=0;if(!v){w=1;t=61;break}else x=v}if((x&7|0)==4){w=1;t=61;break}r=f[i>>2]|0;if(!(r&1))S=hBa(i)|0;else S=r&-2;if(!(ZPb(c,x,S)|0)){w=0;t=61;break}}if((t|0)==54){f[e>>2]=0;b[c+24>>0]=1;w=1;return w|0}else if((t|0)==61)return w|0;return 0}function nQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+17|0;l=e+8|0;m=a+16|0;n=e+8|0;o=a+20|0;p=c+32|0;q=c+12|0;r=c+28|0;s=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){t=b[a>>0]|0;v=t&255;if(t<<24>>24>0){f[i>>2]=v;f[c>>2]=a+1;w=v;x=6}else{y=v;x=5}}else{y=0;x=5}if((x|0)==5){x=0;v=_nb(c,y)|0;f[i>>2]=v;if((v+-1|0)>>>0<127){w=v;x=6}else{z=v;x=37}}b:do if((x|0)==6){x=0;switch(w>>>3&536870911|0){case 1:{switch(w|0){case 0:{A=1;x=43;break a;break}case 8:break;default:{B=w;break b}}f[j>>2]=f[j>>2]|1;v=f[c>>2]|0;a=f[g>>2]|0;if(v>>>0<a>>>0?(t=b[v>>0]|0,t<<24>>24>-1):0){C=v+1|0;f[c>>2]=C;D=a;E=t<<24>>24!=0;F=C}else{Lnb(e,c);C=e;if(!(b[l>>0]|0)){A=0;x=43;break a}D=f[g>>2]|0;E=(f[C>>2]|0)!=0|(f[C+4>>2]|0)!=0;F=f[c>>2]|0}b[k>>0]=E&1;if(F>>>0>=D>>>0)continue a;if((b[F>>0]|0)!=16)continue a;C=F+1|0;f[c>>2]=C;G=D;H=C;x=18;break}case 2:{switch(w|0){case 0:{A=1;x=43;break a;break}case 16:break;default:{B=w;break b}}G=f[g>>2]|0;H=f[c>>2]|0;x=18;break}case 3:{switch(w|0){case 0:{A=1;x=43;break a;break}case 29:break;default:{B=w;break b}}C=f[g>>2]|0;I=C;J=f[c>>2]|0;K=C;break}default:{z=w;x=37;break b}}if((x|0)==18){x=0;f[j>>2]=f[j>>2]|2;if(H>>>0<G>>>0?(C=b[H>>0]|0,C<<24>>24>-1):0){t=H+1|0;f[c>>2]=t;L=C<<24>>24!=0;M=G;N=t}else{Lnb(e,c);t=e;if(!(b[n>>0]|0)){A=0;x=43;break a}L=(f[t>>2]|0)!=0|(f[t+4>>2]|0)!=0;M=f[g>>2]|0;N=f[c>>2]|0}b[m>>0]=L&1;if(N>>>0>=M>>>0)continue a;if((b[N>>0]|0)!=29)continue a;t=N+1|0;f[c>>2]=t;I=M;J=t;K=M}f[j>>2]=f[j>>2]|4;if((K-J|0)>3){t=J;C=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;f[e>>2]=C;t=J+4|0;f[c>>2]=t;O=C;P=t;Q=I}else{if(!(Xnb(c,e)|0)){x=32;break a}O=f[e>>2]|0;P=f[c>>2]|0;Q=f[g>>2]|0}f[o>>2]=O;if((P|0)!=(Q|0))continue a;if(f[p>>2]|0){x=36;break a}if((f[q>>2]|0)==(f[r>>2]|0)){x=36;break a}else continue a}while(0);if((x|0)==37){x=0;if(!z){A=1;x=43;break}else B=z}if((B&7|0)==4){A=1;x=43;break}t=f[s>>2]|0;if(!(t&1))R=hBa(s)|0;else R=t&-2;if(!(ZPb(c,B,R)|0)){A=0;x=43;break}}if((x|0)==32){A=0;u=d;return A|0}else if((x|0)==36){f[i>>2]=0;b[c+24>>0]=1;A=1;u=d;return A|0}else if((x|0)==43){u=d;return A|0}return 0}function oQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+40|0;l=a+36|0;m=e+8|0;n=a+32|0;o=a+28|0;p=a+16|0;q=a+20|0;r=a+24|0;s=a+37|0;t=e+8|0;v=a+38|0;w=c+32|0;x=c+12|0;y=c+28|0;z=e+8|0;A=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){B=b[a>>0]|0;C=B&255;if(B<<24>>24>0){f[i>>2]=C;f[c>>2]=a+1;D=C;E=6}else{F=C;E=5}}else{F=0;E=5}if((E|0)==5){E=0;C=_nb(c,F)|0;f[i>>2]=C;if((C+-1|0)>>>0<127){D=C;E=6}else{G=C;E=85}}b:do if((E|0)==6){E=0;c:do switch(D>>>3&536870911|0){case 1:{switch(D|0){case 0:{H=1;E=91;break a;break}case 13:break;default:{I=D;break b}}f[j>>2]=f[j>>2]|1;C=f[g>>2]|0;a=f[c>>2]|0;if((C-a|0)>3){B=a;K=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[e>>2]=K;B=a+4|0;f[c>>2]=B;L=K;M=B;N=C}else{if(!(Xnb(c,e)|0)){E=12;break a}L=f[e>>2]|0;M=f[c>>2]|0;N=f[g>>2]|0}f[k>>2]=L;if(M>>>0>=N>>>0)continue a;if((b[M>>0]|0)!=16)continue a;C=M+1|0;f[c>>2]=C;O=C;P=N;E=18;break}case 2:{switch(D|0){case 0:{H=1;E=91;break a;break}case 16:break;default:{I=D;break b}}O=f[c>>2]|0;P=f[g>>2]|0;E=18;break}case 3:{switch(D|0){case 0:{H=1;E=91;break a;break}case 24:break;default:{I=D;break b}}Q=f[c>>2]|0;R=f[g>>2]|0;E=28;break}case 4:{switch(D|0){case 0:{H=1;E=91;break a;break}case 34:{E=37;break}default:{I=D;break b}}break}case 5:{switch(D|0){case 0:{H=1;E=91;break a;break}case 45:{S=f[c>>2]|0;T=f[g>>2]|0;E=45;break c;break}case 42:{if(DMa(c,p)|0){E=60;break c}else{H=0;E=91;break a}break}default:{I=D;break b}}break}case 6:{switch(D|0){case 0:{H=1;E=91;break a;break}case 48:break;default:{I=D;break b}}U=f[c>>2]|0;V=f[g>>2]|0;E=66;break}case 7:{switch(D|0){case 0:{H=1;E=91;break a;break}case 56:break;default:{I=D;break b}}W=f[c>>2]|0;X=f[g>>2]|0;E=76;break}default:{G=D;E=85;break b}}while(0);if((E|0)==18){E=0;f[j>>2]=f[j>>2]|2;if(O>>>0<P>>>0?(C=b[O>>0]|0,C<<24>>24>-1):0){B=O+1|0;f[c>>2]=B;Y=C<<24>>24!=0;Z=B;_=P}else{Lnb(e,c);B=e;if(!(b[m>>0]|0)){H=0;E=91;break a}Y=(f[B>>2]|0)!=0|(f[B+4>>2]|0)!=0;Z=f[c>>2]|0;_=f[g>>2]|0}b[l>>0]=Y&1;if(Z>>>0>=_>>>0)continue a;if((b[Z>>0]|0)!=24)continue a;B=Z+1|0;f[c>>2]=B;Q=B;R=_;E=28}if((E|0)==28){E=0;f[j>>2]=f[j>>2]|4;if(Q>>>0<R>>>0){B=b[Q>>0]|0;C=B&255;if(B<<24>>24>-1){f[n>>2]=C;B=Q+1|0;f[c>>2]=B;$=B;aa=R}else{ba=C;E=31}}else{ba=0;E=31}if((E|0)==31){E=0;C=Knb(c,ba)|0;B=J;f[n>>2]=C;if(!((B|0)>-1|(B|0)==-1&C>>>0>4294967295)){H=0;E=91;break a}$=f[c>>2]|0;aa=f[g>>2]|0}if($>>>0>=aa>>>0)continue a;if((b[$>>0]|0)!=34)continue a;f[c>>2]=$+1;E=37}if((E|0)==37){E=0;f[j>>2]=f[j>>2]|8;C=f[o>>2]|0;if((C|0)==497760){jza(o,497760);ca=f[o>>2]|0}else ca=C;if(!(fqb(c,ca)|0)){H=0;E=91;break a}C=f[c>>2]|0;B=f[g>>2]|0;if(C>>>0>=B>>>0)continue a;if((b[C>>0]|0)==45){da=B;ea=C;E=44}else continue a}while(1)if((E|0)==44){E=0;C=ea+1|0;f[c>>2]=C;S=C;T=da;E=45;continue}else if((E|0)==45){E=0;if((T-S|0)>3){C=S;B=h[C>>0]|h[C+1>>0]<<8|h[C+2>>0]<<16|h[C+3>>0]<<24;f[e>>2]=B;f[c>>2]=S+4;fa=B}else{if(!(Xnb(c,e)|0)){E=58;break a}fa=f[e>>2]|0}B=f[p>>2]|0;if((B|0)==(f[q>>2]|0)){qza(p,B+1|0);ga=f[p>>2]|0}else ga=B;B=f[r>>2]|0;C=ga+1|0;f[p>>2]=C;f[B+4+(ga<<2)>>2]=fa;K=f[c>>2]|0;a=(f[g>>2]|0)-K|0;if((a|0)<=0){E=60;continue}ha=(f[q>>2]|0)-C|0;ia=(a>>>0)/5|0;a=(ia|0)<(ha|0)?ia:ha;if((a|0)<=0){E=60;continue}ha=0;ia=K;K=C;while(1){if((b[ia>>0]|0)!=45){ja=ha;break}C=ia+1|0;ka=h[C>>0]|h[C+1>>0]<<8|h[C+2>>0]<<16|h[C+3>>0]<<24;C=K;K=K+1|0;f[p>>2]=K;f[B+4+(C<<2)>>2]=ka;ka=ha+1|0;if((ka|0)>=(a|0)){ja=ka;break}else{ha=ka;ia=ia+5|0}}if((ja|0)<=0){E=60;continue}Tnb(c,ja*5|0)|0;E=60;continue}else if((E|0)==60){E=0;ia=f[c>>2]|0;ha=f[g>>2]|0;if(ia>>>0>=ha>>>0)continue a;if((b[ia>>0]|0)==45){da=ha;ea=ia;E=44;continue}if((b[ia>>0]|0)!=48)continue a;a=ia+1|0;f[c>>2]=a;U=a;V=ha;E=66;continue}else if((E|0)==66){E=0;f[j>>2]=f[j>>2]|32;if(U>>>0<V>>>0?(ha=b[U>>0]|0,ha<<24>>24>-1):0){a=U+1|0;f[c>>2]=a;la=ha<<24>>24!=0;ma=a;na=V}else{Lnb(e,c);a=e;if(!(b[t>>0]|0)){H=0;E=91;break a}la=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0;ma=f[c>>2]|0;na=f[g>>2]|0}b[s>>0]=la&1;if(ma>>>0>=na>>>0)continue a;if((b[ma>>0]|0)!=56)continue a;a=ma+1|0;f[c>>2]=a;W=a;X=na;E=76;continue}else if((E|0)==76){E=0;f[j>>2]=f[j>>2]|64;if(W>>>0<X>>>0){E=77;break}else{E=79;break}}if((E|0)==77){E=0;a=b[W>>0]|0;if(a<<24>>24>-1){ha=W+1|0;f[c>>2]=ha;oa=a<<24>>24!=0;pa=ha;qa=X}else E=79}if((E|0)==79){E=0;Lnb(e,c);ha=e;if(!(b[z>>0]|0)){H=0;E=91;break a}oa=(f[ha>>2]|0)!=0|(f[ha+4>>2]|0)!=0;pa=f[c>>2]|0;qa=f[g>>2]|0}b[v>>0]=oa&1;if((pa|0)!=(qa|0))continue a;if(f[w>>2]|0){E=84;break a}if((f[x>>2]|0)==(f[y>>2]|0)){E=84;break a}else continue a}while(0);if((E|0)==85){E=0;if(!G){H=1;E=91;break}else I=G}if((I&7|0)==4){H=1;E=91;break}ha=f[A>>2]|0;if(!(ha&1))ra=hBa(A)|0;else ra=ha&-2;if(!(ZPb(c,I,ra)|0)){H=0;E=91;break}}if((E|0)==12){H=0;u=d;return H|0}else if((E|0)==58){H=0;u=d;return H|0}else if((E|0)==84){f[i>>2]=0;b[c+24>>0]=1;H=1;u=d;return H|0}else if((E|0)==91){u=d;return H|0}return 0}function pQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+16|0;i=c+32|0;j=c+12|0;k=c+28|0;l=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[e>>2]=n;f[c>>2]=a+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=_nb(c,q)|0;f[e>>2]=n;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}if((p|0)==6){p=0;if((o|0)==8){n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){a=b[n>>0]|0;m=a&255;if(a<<24>>24>-1){f[c>>2]=n+1;s=m}else{t=m;p=10}}else{t=0;p=10}if((p|0)==10){p=0;m=Knb(c,t)|0;n=J;if((n|0)>-1|(n|0)==-1&m>>>0>4294967295)s=m;else{u=0;p=26;break}}if(s>>>0<3){f[g>>2]=f[g>>2]|1;f[h>>2]=s}else{m=f[l>>2]|0;if(!(m&1))v=hBa(l)|0;else v=m&-2;NPb(v,1,s,((s|0)<0)<<31>>31)}if((f[c>>2]|0)!=(f[d>>2]|0))continue;if(f[i>>2]|0){p=20;break}if((f[j>>2]|0)==(f[k>>2]|0)){p=20;break}else continue}else r=o}if((r|0)==0|(r&7|0)==4){u=1;p=26;break}m=f[l>>2]|0;if(!(m&1))w=hBa(l)|0;else w=m&-2;if(!(ZPb(c,r,w)|0)){u=0;p=26;break}}if((p|0)==20){f[e>>2]=0;b[c+24>>0]=1;u=1;return u|0}else if((p|0)==26)return u|0;return 0}function qQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+16|0;i=c+32|0;j=c+12|0;k=c+28|0;l=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){m=b[a>>0]|0;n=m&255;if(m<<24>>24>0){f[e>>2]=n;f[c>>2]=a+1;o=n;p=6}else{q=n;p=5}}else{q=0;p=5}if((p|0)==5){p=0;n=_nb(c,q)|0;f[e>>2]=n;if((n+-1|0)>>>0<127){o=n;p=6}else r=n}if((p|0)==6){p=0;if((o|0)==8){n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){a=b[n>>0]|0;m=a&255;if(a<<24>>24>-1){f[c>>2]=n+1;s=m}else{t=m;p=10}}else{t=0;p=10}if((p|0)==10){p=0;m=Knb(c,t)|0;n=J;if((n|0)>-1|(n|0)==-1&m>>>0>4294967295)s=m;else{u=0;p=26;break}}if(s>>>0<3){f[g>>2]=f[g>>2]|1;f[h>>2]=s}else{m=f[l>>2]|0;if(!(m&1))v=hBa(l)|0;else v=m&-2;NPb(v,1,s,((s|0)<0)<<31>>31)}if((f[c>>2]|0)!=(f[d>>2]|0))continue;if(f[i>>2]|0){p=20;break}if((f[j>>2]|0)==(f[k>>2]|0)){p=20;break}else continue}else r=o}if((r|0)==0|(r&7|0)==4){u=1;p=26;break}m=f[l>>2]|0;if(!(m&1))w=hBa(l)|0;else w=m&-2;if(!(ZPb(c,r,w)|0)){u=0;p=26;break}}if((p|0)==20){f[e>>2]=0;b[c+24>>0]=1;u=1;return u|0}else if((p|0)==26)return u|0;return 0}function rQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=c+4|0;e=c+20|0;g=a+4|0;h=a+8|0;i=a+16|0;j=a+20|0;a=c+32|0;k=c+12|0;l=c+28|0;a:while(1){b:while(1){m=f[c>>2]|0;if(m>>>0<(f[d>>2]|0)>>>0){n=b[m>>0]|0;o=n&255;if(n<<24>>24>0){f[e>>2]=o;f[c>>2]=m+1;p=o;q=7}else{r=o;q=6}}else{r=0;q=6}if((q|0)==6){q=0;o=_nb(c,r)|0;f[e>>2]=o;if((o+-1|0)>>>0<127){p=o;q=7}else{s=o;q=33}}c:do if((q|0)==7){q=0;switch(p>>>3&536870911|0){case 1:{switch(p|0){case 0:{t=1;q=39;break a;break}case 8:{q=9;break b;break}default:{u=p;break c}}break}case 2:{switch(p|0){case 0:{t=1;q=39;break a;break}case 16:{q=23;break b;break}default:{u=p;break c}}break}default:{s=p;q=33;break c}}}while(0);if((q|0)==33){q=0;if(!s){t=1;q=39;break a}else u=s}if((u&7|0)==4){t=1;q=39;break a}o=f[g>>2]|0;if(!(o&1))v=hBa(g)|0;else v=o&-2;if(!(ZPb(c,u,v)|0)){t=0;q=39;break a}}if((q|0)==9){q=0;o=f[c>>2]|0;if(o>>>0<(f[d>>2]|0)>>>0){m=b[o>>0]|0;n=m&255;if(m<<24>>24>-1){f[c>>2]=o+1;w=n}else{x=n;q=12}}else{x=0;q=12}if((q|0)==12){q=0;n=Knb(c,x)|0;o=J;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)w=n;else{t=0;q=39;break}}if(w>>>0<3){f[h>>2]=f[h>>2]|1;f[i>>2]=w}else{n=f[g>>2]|0;if(!(n&1))y=hBa(g)|0;else y=n&-2;NPb(y,1,w,((w|0)<0)<<31>>31)}n=f[c>>2]|0;o=f[d>>2]|0;if(n>>>0>=o>>>0)continue;if((b[n>>0]|0)!=16)continue;m=n+1|0;f[c>>2]=m;z=m;A=o}else if((q|0)==23){q=0;z=f[c>>2]|0;A=f[d>>2]|0}f[h>>2]=f[h>>2]|2;if(z>>>0<A>>>0){o=b[z>>0]|0;m=o&255;if(o<<24>>24>-1){o=z+1|0;f[c>>2]=o;B=m;C=o;D=A}else{E=m;q=27}}else{E=0;q=27}if((q|0)==27){q=0;m=Knb(c,E)|0;o=J;if(!((o|0)>-1|(o|0)==-1&m>>>0>4294967295)){t=0;q=39;break}B=m;C=f[c>>2]|0;D=f[d>>2]|0}f[j>>2]=B;if((C|0)!=(D|0))continue;if(f[a>>2]|0){q=32;break}if((f[k>>2]|0)==(f[l>>2]|0)){q=32;break}}if((q|0)==32){f[e>>2]=0;b[c+24>>0]=1;t=1;return t|0}else if((q|0)==39)return t|0;return 0}function sQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+20|0;l=a+16|0;m=c+32|0;n=c+12|0;o=c+28|0;p=e+8|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[i>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[i>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=27}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=33;break a;break}case 13:break;default:{z=t;break b}}f[j>>2]=f[j>>2]|1;s=f[g>>2]|0;a=f[c>>2]|0;if((s-a|0)>3){r=a;A=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=A;r=a+4|0;f[c>>2]=r;B=A;C=r;D=s}else{if(!(Xnb(c,e)|0)){v=12;break a}B=f[e>>2]|0;C=f[c>>2]|0;D=f[g>>2]|0}f[k>>2]=B;if(C>>>0>=D>>>0)continue a;if((b[C>>0]|0)!=16)continue a;s=C+1|0;f[c>>2]=s;E=s;F=D;break}case 2:{switch(t|0){case 0:{y=1;v=33;break a;break}case 16:break;default:{z=t;break b}}E=f[c>>2]|0;F=f[g>>2]|0;break}default:{x=t;v=27;break b}}f[j>>2]=f[j>>2]|2;if(E>>>0<F>>>0?(s=b[E>>0]|0,s<<24>>24>-1):0){r=E+1|0;f[c>>2]=r;G=s<<24>>24!=0;H=r;I=F}else{Lnb(e,c);r=e;if(!(b[p>>0]|0)){y=0;v=33;break a}G=(f[r>>2]|0)!=0|(f[r+4>>2]|0)!=0;H=f[c>>2]|0;I=f[g>>2]|0}b[l>>0]=G&1;if((H|0)!=(I|0))continue a;if(f[m>>2]|0){v=26;break a}if((f[n>>2]|0)==(f[o>>2]|0)){v=26;break a}else continue a}while(0);if((v|0)==27){v=0;if(!x){y=1;v=33;break}else z=x}if((z&7|0)==4){y=1;v=33;break}r=f[q>>2]|0;if(!(r&1))J=hBa(q)|0;else J=r&-2;if(!(ZPb(c,z,J)|0)){y=0;v=33;break}}if((v|0)==12){y=0;u=d;return y|0}else if((v|0)==26){f[i>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==33){u=d;return y|0}return 0}function tQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+20|0;l=a+24|0;m=a+16|0;n=c+32|0;o=c+12|0;p=c+28|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[i>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[i>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=37}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=43;break a;break}case 13:break;default:{z=t;break b}}f[j>>2]=f[j>>2]|1;s=f[g>>2]|0;a=f[c>>2]|0;if((s-a|0)>3){r=a;A=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=A;r=a+4|0;f[c>>2]=r;B=A;C=r;D=s;E=s}else{if(!(Xnb(c,e)|0)){v=12;break a}s=f[g>>2]|0;B=f[e>>2]|0;C=f[c>>2]|0;D=s;E=s}f[k>>2]=B;if(C>>>0>=D>>>0)continue a;if((b[C>>0]|0)!=21)continue a;s=C+1|0;f[c>>2]=s;F=s;G=E;H=D;v=18;break}case 2:{switch(t|0){case 0:{y=1;v=43;break a;break}case 21:break;default:{z=t;break b}}s=f[g>>2]|0;F=f[c>>2]|0;G=s;H=s;v=18;break}case 3:{switch(t|0){case 0:{y=1;v=43;break a;break}case 29:break;default:{z=t;break b}}s=f[g>>2]|0;I=s;J=f[c>>2]|0;K=s;break}default:{x=t;v=37;break b}}if((v|0)==18){v=0;f[j>>2]=f[j>>2]|2;if((G-F|0)>3){s=F;r=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[e>>2]=r;s=F+4|0;f[c>>2]=s;L=r;M=s;N=H;O=G}else{if(!(Xnb(c,e)|0)){v=22;break a}s=f[g>>2]|0;L=f[e>>2]|0;M=f[c>>2]|0;N=s;O=s}f[l>>2]=L;if(M>>>0>=N>>>0)continue a;if((b[M>>0]|0)!=29)continue a;s=M+1|0;f[c>>2]=s;I=N;J=s;K=O}f[j>>2]=f[j>>2]|4;if((K-J|0)>3){s=J;r=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[e>>2]=r;s=J+4|0;f[c>>2]=s;P=r;Q=s;R=I}else{if(!(Xnb(c,e)|0)){v=32;break a}P=f[e>>2]|0;Q=f[c>>2]|0;R=f[g>>2]|0}f[m>>2]=P;if((Q|0)!=(R|0))continue a;if(f[n>>2]|0){v=36;break a}if((f[o>>2]|0)==(f[p>>2]|0)){v=36;break a}else continue a}while(0);if((v|0)==37){v=0;if(!x){y=1;v=43;break}else z=x}if((z&7|0)==4){y=1;v=43;break}s=f[q>>2]|0;if(!(s&1))S=hBa(q)|0;else S=s&-2;if(!(ZPb(c,z,S)|0)){y=0;v=43;break}}if((v|0)==12){y=0;u=d;return y|0}else if((v|0)==22){y=0;u=d;return y|0}else if((v|0)==32){y=0;u=d;return y|0}else if((v|0)==36){f[i>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==43){u=d;return y|0}return 0}function uQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+16|0;k=a+20|0;l=e+8|0;m=a+4|0;n=a+24|0;a=c+32|0;o=c+12|0;p=c+28|0;a:while(1){b:while(1){q=f[c>>2]|0;if(q>>>0<(f[g>>2]|0)>>>0){r=b[q>>0]|0;s=r&255;if(r<<24>>24>0){f[h>>2]=s;f[c>>2]=q+1;t=s;v=7}else{w=s;v=6}}else{w=0;v=6}if((v|0)==6){v=0;s=_nb(c,w)|0;f[h>>2]=s;if((s+-1|0)>>>0<127){t=s;v=7}else{x=s;v=43}}c:do if((v|0)==7){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=49;break a;break}case 8:break;default:{z=t;break c}}f[i>>2]=f[i>>2]|1;s=f[c>>2]|0;q=f[g>>2]|0;if(s>>>0<q>>>0){r=b[s>>0]|0;A=r&255;if(r<<24>>24>-1){r=s+1|0;f[c>>2]=r;B=A;C=r;D=q}else{E=A;v=12}}else{E=0;v=12}if((v|0)==12){v=0;A=Knb(c,E)|0;q=J;if(!((q|0)>-1|(q|0)==-1&A>>>0>4294967295)){y=0;v=49;break a}B=A;C=f[c>>2]|0;D=f[g>>2]|0}f[j>>2]=B;if(C>>>0>=D>>>0)continue b;if((b[C>>0]|0)!=16)continue b;A=C+1|0;f[c>>2]=A;F=A;G=D;break}case 2:{switch(t|0){case 0:{y=1;v=49;break a;break}case 16:break;default:{z=t;break c}}F=f[c>>2]|0;G=f[g>>2]|0;break}case 3:{switch(t|0){case 0:{y=1;v=49;break a;break}case 24:{v=28;break b;break}default:{z=t;break c}}break}default:{x=t;v=43;break c}}f[i>>2]=f[i>>2]|4;if(F>>>0<G>>>0?(A=b[F>>0]|0,A<<24>>24>-1):0){q=F+1|0;f[c>>2]=q;H=A<<24>>24!=0;I=q;K=G}else{Lnb(e,c);q=e;if(!(b[l>>0]|0)){y=0;v=49;break a}H=(f[q>>2]|0)!=0|(f[q+4>>2]|0)!=0;I=f[c>>2]|0;K=f[g>>2]|0}b[k>>0]=H&1;if(I>>>0>=K>>>0)continue b;if((b[I>>0]|0)==24){v=26;break b}else continue b}while(0);if((v|0)==43){v=0;if(!x){y=1;v=49;break a}else z=x}if((z&7|0)==4){y=1;v=49;break a}q=f[m>>2]|0;if(!(q&1))L=hBa(m)|0;else L=q&-2;if(!(ZPb(c,z,L)|0)){y=0;v=49;break a}}if((v|0)==26){v=0;q=I+1|0;f[c>>2]=q;M=q;N=K}else if((v|0)==28){v=0;M=f[c>>2]|0;N=f[g>>2]|0}if(M>>>0<N>>>0){q=b[M>>0]|0;A=q&255;if(q<<24>>24>-1){f[c>>2]=M+1;O=A}else{P=A;v=32}}else{P=0;v=32}if((v|0)==32){v=0;A=Knb(c,P)|0;q=J;if((q|0)>-1|(q|0)==-1&A>>>0>4294967295)O=A;else{y=0;v=49;break}}if(O>>>0<4){f[i>>2]=f[i>>2]|2;f[n>>2]=O}else{A=f[m>>2]|0;if(!(A&1))Q=hBa(m)|0;else Q=A&-2;NPb(Q,3,O,((O|0)<0)<<31>>31)}if((f[c>>2]|0)!=(f[g>>2]|0))continue;if(f[a>>2]|0){v=42;break}if((f[o>>2]|0)==(f[p>>2]|0)){v=42;break}}if((v|0)==42){f[h>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==49){u=d;return y|0}return 0}function vQa(a){a=a|0;return a>>>0<2|0}function wQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[a>>2]|0;e=a+4|0;if(d>>>0<(f[e>>2]|0)>>>0?(g=b[d>>0]|0,g<<24>>24>-1):0){f[a>>2]=d+1;h=g&255}else{g=Znb(a)|0;if((g|0)>-1)h=g;else{i=0;return i|0}}g=Gnb(a,h)|0;a:do if((Qnb(a)|0)>0){h=c+4|0;d=c+8|0;while(1){j=f[a>>2]|0;if(j>>>0<(f[e>>2]|0)>>>0){k=b[j>>0]|0;l=k&255;if(k<<24>>24>-1){f[a>>2]=j+1;m=l}else{n=l;o=10}}else{n=0;o=10}if((o|0)==10){o=0;l=Knb(a,n)|0;j=J;if((j|0)>-1|(j|0)==-1&l>>>0>4294967295)m=l;else{i=0;break}}l=f[c>>2]|0;if((l|0)==(f[h>>2]|0)){rza(c,l+1|0);p=f[c>>2]|0}else p=l;l=f[d>>2]|0;f[c>>2]=p+1;f[l+4+(p<<2)>>2]=m;if((Qnb(a)|0)<=0)break a}return i|0}while(0);Hnb(a,g);i=1;return i|0}function xQa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(d&195|0){e=a+72|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[a+112>>0]=1}if(d&65280|0){e=a+84|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[a+116>>2]=1;if(d&8192|0?(d=f[a+64>>2]|0,d|0):0){e=d+8|0;g=f[e>>2]|0;if(g&255|0){h=d+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if(g&1|0?(g=f[213028]|0,h=f[d+16>>2]|0,(h|0)!=(g|0)):0)_5b(h,g)|0;n[d+40>>2]=1.0;n[d+44>>2]=1.0;f[d+36>>2]=-1}f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)GPb(d)}if(f[c>>2]&16384|0?(d=f[a+68>>2]|0,d|0):0){e=d+8|0;g=f[e>>2]|0;if(g&255|0){h=d+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if(g&1|0?(g=f[213028]|0,h=f[d+16>>2]|0,(h|0)!=(g|0)):0)_5b(h,g)|0;n[d+40>>2]=1.0;n[d+44>>2]=1.0;f[d+36>>2]=-1}f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)GPb(d)}}if(f[c>>2]&196608|0){f[a+108>>2]=1;b[a+104>>0]=0}f[a+16>>2]=0;f[a+28>>2]=0;f[a+40>>2]=0;f[a+52>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function yQa(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&255|0){e=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;b[e+16>>0]=0;do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);n[a+44>>2]=1.0;if(f[c>>2]&32|0?(g=f[a+20>>2]|0,(g|0)!=497760):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}}while(0);if(f[c>>2]&768|0){b[a+41>>0]=0;f[a+48>>2]=4}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function zQa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(!(d&255))e=d;else{g=a+28|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+12>>0]=0;do if(d&1|0?(g=f[a+16>>2]|0,(g|0)!=497760):0){h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);f[a+52>>2]=1;b[a+56>>0]=1;n[a+48>>2]=1.0;e=f[c>>2]|0}do if(e&3840|0){d=a+41|0;b[d>>0]=0;b[d+1>>0]=0;b[d+2>>0]=0;b[d+3>>0]=0;b[d+4>>0]=0;b[d+5>>0]=0;b[d+6>>0]=0;do if(e&256|0?(d=f[a+20>>2]|0,(d|0)!=497760):0){h=d+11|0;if((b[h>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[h>>0]=0;break}}while(0);if(f[c>>2]&2048|0?(h=f[a+24>>2]|0,(h|0)!=497760):0){d=h+11|0;if((b[d>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[d>>0]=0;break}}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function AQa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(d&63|0){e=a+24|0;f[e>>2]=0;b[e+4>>0]=0;b[a+29>>0]=1;if(d&4|0?(d=f[a+16>>2]|0,d|0):0){e=d+8|0;g=f[e>>2]|0;if(g&255|0){h=d+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if(g&1|0?(g=f[213028]|0,h=f[d+16>>2]|0,(h|0)!=(g|0)):0)_5b(h,g)|0;n[d+40>>2]=1.0;n[d+44>>2]=1.0;f[d+36>>2]=-1}f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)GPb(d)}if(f[c>>2]&8|0?(d=f[a+20>>2]|0,d|0):0){e=d+8|0;g=f[e>>2]|0;if(g&255|0){h=d+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if(g&1|0?(g=f[213028]|0,h=f[d+16>>2]|0,(h|0)!=(g|0)):0)_5b(h,g)|0;n[d+40>>2]=1.0;n[d+44>>2]=1.0;f[d+36>>2]=-1}f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)GPb(d)}f[a+32>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function BQa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+8|0;d=f[c>>2]|0;if(!(d&255))e=d;else{g=a+32|0;f[g>>2]=0;f[g+4>>2]=0;b[g+8>>0]=0;do if(d&1|0?(g=f[a+16>>2]|0,(g|0)!=497760):0){h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);n[a+48>>2]=1.0;do if(f[c>>2]&4|0?(d=f[a+20>>2]|0,(d|0)!=497760):0){h=d+11|0;if((b[h>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[h>>0]=0;break}}while(0);n[a+52>>2]=.5;n[a+56>>2]=.5;e=f[c>>2]|0}do if(e&7936|0){h=a+41|0;b[h>>0]=0;b[h+1>>0]=0;b[h+2>>0]=0;b[h+3>>0]=0;b[h+4>>0]=0;b[h+5>>0]=0;b[h+6>>0]=0;n[a+60>>2]=.25;if((e&1024|0)!=0?(h=f[213031]|0,d=f[a+24>>2]|0,(d|0)!=(h|0)):0){_5b(d,h)|0;i=f[c>>2]|0}else i=e;if(i&4096|0?(h=f[a+28>>2]|0,(h|0)!=497760):0){d=h+11|0;if((b[d>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[d>>0]=0;break}}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function CQa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=118152;Nac(a+4|0,0,156)|0;if((a|0)!=496696?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+160>>2]=497760;Nac(a+164|0,0,132)|0;u=c;return}function DQa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function EQa(a){a=a|0;var c=0,d=0;c=a+160|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)==496696)return;c=f[a+164>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+168>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+172>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+176>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+180>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+184>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+188>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+192>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+196>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+200>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+204>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+208>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+212>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+216>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+220>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+224>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+228>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+232>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+236>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+240>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+244>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+248>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+252>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+256>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+260>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+264>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+268>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+272>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+276>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+280>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+284>>2]|0;if(!c)return;bi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function FQa(a){a=a|0;var b=0,c=0;f[a>>2]=118044;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function GQa(a){a=a|0;var b=0,c=0;f[a>>2]=118044;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function HQa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function IQa(a,b){a=a|0;b=b|0;a=L5b(28)|0;VQa(a);if(!b)return a|0;WQa(b,a);return a|0}function JQa(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function KQa(a){a=a|0;return 1}function LQa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+16|0;i=a+4|0;j=a+20|0;k=a+24|0;a=c+32|0;l=c+12|0;m=c+28|0;a:while(1){b:while(1){c:while(1){n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){o=b[n>>0]|0;p=o&255;if(o<<24>>24>0){f[e>>2]=p;f[c>>2]=n+1;q=p;r=8}else{s=p;r=7}}else{s=0;r=7}if((r|0)==7){r=0;p=_nb(c,s)|0;f[e>>2]=p;if((p+-1|0)>>>0<127){q=p;r=8}else{t=p;r=49}}d:do if((r|0)==8){r=0;switch(q>>>3&536870911|0){case 1:{switch(q|0){case 0:{u=1;r=55;break a;break}case 8:break;default:{v=q;break d}}f[g>>2]=f[g>>2]|1;p=f[c>>2]|0;if(p>>>0<(f[d>>2]|0)>>>0){n=b[p>>0]|0;o=n&255;if(n<<24>>24>-1){f[h>>2]=o;n=p+1|0;f[c>>2]=n;w=n}else{x=o;r=13}}else{x=0;r=13}if((r|0)==13){r=0;o=Knb(c,x)|0;n=J;f[h>>2]=o;if(!((n|0)>-1|(n|0)==-1&o>>>0>4294967295)){u=0;r=55;break a}w=f[c>>2]|0}y=f[d>>2]|0;if(w>>>0>=y>>>0)continue c;if((b[w>>0]|0)==16){r=17;break c}else continue c;break}case 2:{switch(q|0){case 0:{u=1;r=55;break a;break}case 16:{r=19;break c;break}default:{v=q;break d}}break}case 6:{switch(q|0){case 0:{u=1;r=55;break a;break}case 48:{r=34;break b;break}default:{v=q;break d}}break}default:{t=q;r=49;break d}}}while(0);if((r|0)==49){r=0;if(!t){u=1;r=55;break a}else v=t}if((v&7|0)==4){u=1;r=55;break a}o=f[i>>2]|0;if(!(o&1))z=hBa(i)|0;else z=o&-2;if(!(ZPb(c,v,z)|0)){u=0;r=55;break a}}if((r|0)==17){r=0;o=w+1|0;f[c>>2]=o;A=o;B=y}else if((r|0)==19){r=0;A=f[c>>2]|0;B=f[d>>2]|0}if(A>>>0<B>>>0){o=b[A>>0]|0;n=o&255;if(o<<24>>24>-1){f[c>>2]=A+1;C=n}else{D=n;r=23}}else{D=0;r=23}if((r|0)==23){r=0;n=Knb(c,D)|0;o=J;if((o|0)>-1|(o|0)==-1&n>>>0>4294967295)C=n;else{u=0;r=55;break a}}if(C>>>0<3){f[g>>2]=f[g>>2]|2;f[j>>2]=C}else{n=f[i>>2]|0;if(!(n&1))E=hBa(i)|0;else E=n&-2;NPb(E,2,C,((C|0)<0)<<31>>31)}F=f[c>>2]|0;G=f[d>>2]|0;if(F>>>0>=G>>>0)continue;if((b[F>>0]|0)==48){r=32;break}}if((r|0)==32){r=0;n=F+1|0;f[c>>2]=n;H=n;I=G}else if((r|0)==34){r=0;H=f[c>>2]|0;I=f[d>>2]|0}if(H>>>0<I>>>0){n=b[H>>0]|0;o=n&255;if(n<<24>>24>-1){f[c>>2]=H+1;K=o}else{L=o;r=38}}else{L=0;r=38}if((r|0)==38){r=0;o=Knb(c,L)|0;n=J;if((n|0)>-1|(n|0)==-1&o>>>0>4294967295)K=o;else{u=0;r=55;break}}if(K>>>0<3){f[g>>2]=f[g>>2]|4;f[k>>2]=K}else{o=f[i>>2]|0;if(!(o&1))M=hBa(i)|0;else M=o&-2;NPb(M,6,K,((K|0)<0)<<31>>31)}if((f[c>>2]|0)!=(f[d>>2]|0))continue;if(f[a>>2]|0){r=48;break}if((f[l>>2]|0)==(f[m>>2]|0)){r=48;break}}if((r|0)==48){f[e>>2]=0;b[c+24>>0]=1;u=1;return u|0}else if((r|0)==55)return u|0;return 0}function MQa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=a+8|0;c=f[b>>2]|0;if(c&7){if(c&1){d=f[a+16>>2]|0;if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}}else{e=0;g=c}if(!(g&2)){i=e;j=g}else{c=f[a+20>>2]|0;if((c|0)>=0)if(c>>>0<128){k=2;l=g}else{h=(iob(c)|0)+1|0;k=h;l=f[b>>2]|0}else{k=11;l=g}i=k+e|0;j=l}if(!(j&4))m=i;else{j=f[a+24>>2]|0;if((j|0)>=0)if(j>>>0<128)n=2;else n=(iob(j)|0)+1|0;else n=11;m=n+i|0}}else m=0;i=f[a+4>>2]|0;if(!(i&1)){o=m;p=a+12|0;f[p>>2]=o;return o|0}o=(dQb(i&-2)|0)+m|0;p=a+12|0;f[p>>2]=o;return o|0}function NQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Opb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{Zpb(2,f[a+20>>2]|0,b);g=f[c>>2]|0}if(g&4|0)Zpb(6,f[a+24>>2]|0,b);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,b);return}function OQa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function PQa(a){a=a|0;return f[a+12>>2]|0}function QQa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=8;i=d+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=e}b[m>>0]=n;g=m+1|0;h=f[c>>2]|0}do if(!(h&2))o=g;else{m=f[a+20>>2]|0;b[g>>0]=16;n=g+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){e=m;i=n;while(1){b[i>>0]=e|128;j=e>>>7;d=i+1|0;if(e>>>0>16383){e=j;i=d}else{p=d;q=j;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}while(0);do if(!(f[c>>2]&4))r=o;else{p=f[a+24>>2]|0;b[o>>0]=48;q=o+1|0;if((p|0)<0){r=hob(p,((p|0)<0)<<31>>31,q)|0;break}if(p>>>0>127){g=p;h=q;while(1){b[h>>0]=g|128;i=g>>>7;e=h+1|0;if(g>>>0>16383){g=i;h=e}else{s=e;t=i;break}}}else{s=q;t=p}b[s>>0]=t;r=s+1|0}while(0);s=f[a+4>>2]|0;if(!(s&1)){u=r;return u|0}u=bQb(s&-2,r)|0;return u|0}function RQa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function SQa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((a|0)==(b|0))jMa(46329);c=T6b(b,23288,18904,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[b>>2]|0}if(!(e&2))h=e;else{e=f[c+20>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+20>>2]=e;h=f[b>>2]|0}if(h&4|0){h=f[c+24>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|4;f[a+24>>2]=h}}h=f[c+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function TQa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function UQa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213182];f[a+4>>2]=f[213183];u=c;return}function VQa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=118044;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496656?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;u=c;return}function WQa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function XQa(a){a=a|0;var b=0,c=0;f[a>>2]=117936;jRa(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function YQa(a){a=a|0;XQa(a);O5b(a);return}function ZQa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function _Qa(a,b){a=a|0;b=b|0;a=L5b(64)|0;nPa(a);if(!b)return a|0;iRa(b,a);return a|0}function $Qa(a){a=a|0;return 1}function aRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{$pb(1,f[a+16>>2]|0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{Wpb(2,+n[a+48>>2],c);h=f[d>>2]|0}if(!(h&4))i=h;else{$pb(3,f[a+20>>2]|0,c);i=f[d>>2]|0}if(!(i&8))j=i;else{Opb(4,f[a+32>>2]|0,c);j=f[d>>2]|0}if(!(j&16))k=j;else{Opb(5,f[a+36>>2]|0,c);k=f[d>>2]|0}if(!(k&32))l=k;else{Ypb(6,(b[a+40>>0]|0)!=0,c);l=f[d>>2]|0}if(!(l&64))m=l;else{Wpb(7,+n[a+52>>2],c);m=f[d>>2]|0}if(!(m&128))o=m;else{Wpb(8,+n[a+56>>2],c);o=f[d>>2]|0}if(!(o&256))p=o;else{Wpb(9,+n[a+60>>2],c);p=f[d>>2]|0}if(!(p&512))q=p;else{Opb(10,f[a+44>>2]|0,c);q=f[d>>2]|0}if(!(q&1024))r=q;else{$pb(11,f[a+24>>2]|0,c);r=f[d>>2]|0}if(!(r&2048))s=r;else{Ypb(12,(b[a+41>>0]|0)!=0,c);s=f[d>>2]|0}if(s&4096|0)$pb(13,f[a+28>>2]|0,c);s=f[a+4>>2]|0;if(!(s&1))return;aQb(s&-2,c);return}function bRa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function cRa(a){a=a|0;return f[a+12>>2]|0}function dRa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&2)){j=g;k=h}else{h=f[a+48>>2]|0;b[g>>0]=21;i=g+1|0;b[i>>0]=h;b[i+1>>0]=h>>8;b[i+2>>0]=h>>16;b[i+3>>0]=h>>24;j=g+5|0;k=f[c>>2]|0}if(!(k&4)){l=j;m=k}else{k=f[a+20>>2]|0;b[j>>0]=26;g=kob(k,j+1|0)|0;l=g;m=f[c>>2]|0}if(!(m&8)){n=l;o=m}else{m=f[a+32>>2]|0;b[l>>0]=32;g=l+1|0;if(m>>>0>127){l=m;j=g;while(1){b[j>>0]=l|128;k=l>>>7;h=j+1|0;if(l>>>0>16383){l=k;j=h}else{p=h;q=k;break}}}else{p=g;q=m}b[p>>0]=q;n=p+1|0;o=f[c>>2]|0}if(!(o&16)){r=n;s=o}else{o=f[a+36>>2]|0;b[n>>0]=40;p=n+1|0;if(o>>>0>127){n=o;q=p;while(1){b[q>>0]=n|128;m=n>>>7;g=q+1|0;if(n>>>0>16383){n=m;q=g}else{t=g;u=m;break}}}else{t=p;u=o}b[t>>0]=u;r=t+1|0;s=f[c>>2]|0}if(!(s&32)){v=r;w=s}else{s=b[a+40>>0]|0;b[r>>0]=48;b[r+1>>0]=s;v=r+2|0;w=f[c>>2]|0}if(!(w&64)){x=v;y=w}else{w=f[a+52>>2]|0;b[v>>0]=61;r=v+1|0;b[r>>0]=w;b[r+1>>0]=w>>8;b[r+2>>0]=w>>16;b[r+3>>0]=w>>24;x=v+5|0;y=f[c>>2]|0}if(!(y&128)){z=x;A=y}else{y=f[a+56>>2]|0;b[x>>0]=69;v=x+1|0;b[v>>0]=y;b[v+1>>0]=y>>8;b[v+2>>0]=y>>16;b[v+3>>0]=y>>24;z=x+5|0;A=f[c>>2]|0}if(!(A&256)){B=z;C=A}else{A=f[a+60>>2]|0;b[z>>0]=77;x=z+1|0;b[x>>0]=A;b[x+1>>0]=A>>8;b[x+2>>0]=A>>16;b[x+3>>0]=A>>24;B=z+5|0;C=f[c>>2]|0}if(!(C&512)){D=B;E=C}else{C=f[a+44>>2]|0;b[B>>0]=80;z=B+1|0;if(C>>>0>127){B=C;A=z;while(1){b[A>>0]=B|128;x=B>>>7;y=A+1|0;if(B>>>0>16383){B=x;A=y}else{F=y;G=x;break}}}else{F=z;G=C}b[F>>0]=G;D=F+1|0;E=f[c>>2]|0}if(!(E&1024)){H=D;I=E}else{E=f[a+24>>2]|0;b[D>>0]=90;F=kob(E,D+1|0)|0;H=F;I=f[c>>2]|0}if(!(I&2048)){J=H;K=I}else{I=b[a+41>>0]|0;b[H>>0]=96;b[H+1>>0]=I;J=H+2|0;K=f[c>>2]|0}if(!(K&4096))L=J;else{K=f[a+28>>2]|0;b[J>>0]=106;L=kob(K,J+1|0)|0}J=f[a+4>>2]|0;if(!(J&1)){M=L;return M|0}M=bQb(J&-2,L)|0;return M|0}function eRa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function fRa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(45441);c=T6b(b,23288,18920,0)|0;if(!c){cOb(b,a);return}else{oPa(a,c);return}}function gRa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function hRa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213180];f[a+4>>2]=f[213181];u=c;return}function iRa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function jRa(a){a=a|0;var c=0,d=0;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+20|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+24|0;d=f[c>>2]|0;if(!((d|0)==(f[213031]|0)|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+28|0;a=f[c>>2]|0;if((a|0)==497760|(a|0)==0){f[c>>2]=0;return}if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a);f[c>>2]=0;return}function kRa(a){a=a|0;var b=0,c=0;f[a>>2]=117828;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function lRa(a){a=a|0;var b=0,c=0;f[a>>2]=117828;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function mRa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function nRa(a,b){a=a|0;b=b|0;a=L5b(20)|0;mPa(a);if(!b)return a|0;zRa(b,a);return a|0}function oRa(a){a=a|0;var b=0;n[a+16>>2]=0.0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function pRa(a){a=a|0;return 1}function qRa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]&1|0?5:0;c=f[a+4>>2]|0;if(!(c&1)){d=b;e=a+12|0;f[e>>2]=d;return d|0}d=(dQb(c&-2)|0)+b|0;e=a+12|0;f[e>>2]=d;return d|0}function rRa(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)Wpb(1,+n[a+16>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function sRa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function tRa(a){a=a|0;return f[a+12>>2]|0}function uRa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=13;g=d+1|0;b[g>>0]=c;b[g+1>>0]=c>>8;b[g+2>>0]=c>>16;b[g+3>>0]=c>>24;e=d+5|0}d=f[a+4>>2]|0;if(!(d&1)){h=e;return h|0}h=bQb(d&-2,e)|0;return h|0}function vRa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function wRa(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))jMa(44667);c=T6b(b,23288,18936,0)|0;if(!c){cOb(b,a);return}if(f[c+8>>2]&1|0){b=f[c+16>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|1;f[a+16>>2]=b}b=f[c+4>>2]|0;if(!(b&1))return;LPb(b&-2,a+4|0);return}function xRa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function yRa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213178];f[a+4>>2]=f[213179];u=c;return}function zRa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function ARa(a){a=a|0;var b=0,c=0;f[a>>2]=117720;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function BRa(a){a=a|0;var b=0,c=0;f[a>>2]=117720;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function CRa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function DRa(a,b){a=a|0;b=b|0;a=L5b(24)|0;QRa(a);if(!b)return a|0;RRa(b,a);return a|0}function ERa(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&3|0){f[a+20>>2]=1;f[a+16>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function FRa(a){a=a|0;return 1}function GRa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+20|0;i=a+16|0;j=c+32|0;k=c+12|0;l=c+28|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[e>>2]=o;f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=_nb(c,r)|0;f[e>>2]=o;if((o+-1|0)>>>0<127){p=o;q=6}else{s=o;q=27}}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{switch(p|0){case 0:{t=1;q=33;break a;break}case 8:break;default:{u=p;break b}}f[g>>2]=f[g>>2]|1;o=f[c>>2]|0;a=f[d>>2]|0;if(o>>>0<a>>>0){n=b[o>>0]|0;v=n&255;if(n<<24>>24>-1){n=o+1|0;f[c>>2]=n;w=v;x=n;y=a}else{z=v;q=11}}else{z=0;q=11}if((q|0)==11){q=0;v=Knb(c,z)|0;a=J;if(!((a|0)>-1|(a|0)==-1&v>>>0>4294967295)){t=0;q=33;break a}w=v;x=f[c>>2]|0;y=f[d>>2]|0}f[h>>2]=w;if(x>>>0>=y>>>0)continue a;if((b[x>>0]|0)!=16)continue a;v=x+1|0;f[c>>2]=v;A=v;B=y;break}case 2:{switch(p|0){case 0:{t=1;q=33;break a;break}case 16:break;default:{u=p;break b}}A=f[c>>2]|0;B=f[d>>2]|0;break}default:{s=p;q=27;break b}}f[g>>2]=f[g>>2]|2;if(A>>>0<B>>>0){v=b[A>>0]|0;a=v&255;if(v<<24>>24>-1){v=A+1|0;f[c>>2]=v;C=a;D=v;E=B}else{F=a;q=21}}else{F=0;q=21}if((q|0)==21){q=0;a=Knb(c,F)|0;v=J;if(!((v|0)>-1|(v|0)==-1&a>>>0>4294967295)){t=0;q=33;break a}C=a;D=f[c>>2]|0;E=f[d>>2]|0}f[i>>2]=C;if((D|0)!=(E|0))continue a;if(f[j>>2]|0){q=26;break a}if((f[k>>2]|0)==(f[l>>2]|0)){q=26;break a}else continue a}while(0);if((q|0)==27){q=0;if(!s){t=1;q=33;break}else u=s}if((u&7|0)==4){t=1;q=33;break}a=f[m>>2]|0;if(!(a&1))G=hBa(m)|0;else G=a&-2;if(!(ZPb(c,u,G)|0)){t=0;q=33;break}}if((q|0)==26){f[e>>2]=0;b[c+24>>0]=1;t=1;return t|0}else if((q|0)==33)return t|0;return 0}function HRa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+8|0;c=f[b>>2]|0;if(c&3){if(c&1){d=f[a+20>>2]|0;if((d|0)>=0)if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}else{e=11;g=c}}else{e=0;g=c}if(!(g&2))i=e;else{g=f[a+16>>2]|0;if((g|0)>=0)if(g>>>0<128)j=2;else j=(iob(g)|0)+1|0;else j=11;i=j+e|0}}else i=0;e=f[a+4>>2]|0;if(!(e&1)){k=i;l=a+12|0;f[l>>2]=k;return k|0}k=(dQb(e&-2)|0)+i|0;l=a+12|0;f[l>>2]=k;return k|0}function IRa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Mpb(1,f[a+20>>2]|0,b);e=f[c>>2]|0}if(e&2|0)Mpb(2,f[a+16>>2]|0,b);e=f[a+4>>2]|0;if(!(e&1))return;aQb(e&-2,b);return}function JRa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function KRa(a){a=a|0;return f[a+12>>2]|0}function LRa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+20>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);do if(!(f[c>>2]&2))o=e;else{m=f[a+16>>2]|0;b[e>>0]=16;n=e+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){d=m;j=n;while(1){b[j>>0]=d|128;i=d>>>7;k=j+1|0;if(d>>>0>16383){d=i;j=k}else{p=k;q=i;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}while(0);p=f[a+4>>2]|0;if(!(p&1)){r=o;return r|0}r=bQb(p&-2,o)|0;return r|0}function MRa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function NRa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))jMa(44362);c=T6b(b,23288,18952,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+20>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+20>>2]=d;e=f[b>>2]|0}if(e&2|0){e=f[c+16>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|2;f[a+16>>2]=e}}e=f[c+4>>2]|0;if(!(e&1))return;LPb(e&-2,a+4|0);return}function ORa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function PRa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213176];f[a+4>>2]=f[213177];u=c;return}function QRa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=117720;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496520?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;u=c;return}function RRa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function SRa(a){a=a|0;var b=0,c=0;f[a>>2]=117612;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function TRa(a){a=a|0;var b=0,c=0;f[a>>2]=117612;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function URa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function VRa(a,b){a=a|0;b=b|0;a=L5b(20)|0;lPa(a);if(!b)return a|0;fSa(b,a);return a|0}function WRa(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function XRa(a){a=a|0;return 1}function YRa(a){a=a|0;var b=0,c=0,d=0,e=0;if(f[a+8>>2]&1){b=f[a+16>>2]|0;if((b|0)>=0)if(b>>>0<128)c=2;else c=(iob(b)|0)+1|0;else c=11}else c=0;b=f[a+4>>2]|0;if(!(b&1)){d=c;e=a+12|0;f[e>>2]=d;return d|0}d=(dQb(b&-2)|0)+c|0;e=a+12|0;f[e>>2]=d;return d|0}function ZRa(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)Zpb(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function _Ra(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function $Ra(a){a=a|0;return f[a+12>>2]|0}function aSa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;do if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=8;g=d+1|0;if((c|0)<0){e=hob(c,((c|0)<0)<<31>>31,g)|0;break}if(c>>>0>127){h=c;i=g;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=g;m=c}b[l>>0]=m;e=l+1|0}while(0);l=f[a+4>>2]|0;if(!(l&1)){n=e;return n|0}n=bQb(l&-2,e)|0;return n|0}function bSa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function cSa(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))jMa(44043);c=T6b(b,23288,18968,0)|0;if(!c){cOb(b,a);return}if(f[c+8>>2]&1|0){b=f[c+16>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|1;f[a+16>>2]=b}b=f[c+4>>2]|0;if(!(b&1))return;LPb(b&-2,a+4|0);return}function dSa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function eSa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213173];f[a+4>>2]=f[213174];u=c;return}function fSa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function gSa(a){a=a|0;var b=0,c=0;f[a>>2]=117504;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function hSa(a){a=a|0;var b=0,c=0;f[a>>2]=117504;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function iSa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function jSa(a,b){a=a|0;b=b|0;a=L5b(24)|0;iPa(a);if(!b)return a|0;vSa(b,a);return a|0}function kSa(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&3|0){f[a+16>>2]=0;f[a+20>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function lSa(a){a=a|0;return 1}function mSa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+8|0;c=f[b>>2]|0;if(c&3){if(c&1){d=f[a+16>>2]|0;if((d|0)>=0)if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}else{e=11;g=c}}else{e=0;g=c}if(!(g&2))i=e;else{g=f[a+20>>2]|0;if((g|0)>=0)if(g>>>0<128)j=2;else j=(iob(g)|0)+1|0;else j=11;i=j+e|0}}else i=0;e=f[a+4>>2]|0;if(!(e&1)){k=i;l=a+12|0;f[l>>2]=k;return k|0}k=(dQb(e&-2)|0)+i|0;l=a+12|0;f[l>>2]=k;return k|0}function nSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Zpb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(e&2|0)Mpb(2,f[a+20>>2]|0,b);e=f[a+4>>2]|0;if(!(e&1))return;aQb(e&-2,b);return}function oSa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function pSa(a){a=a|0;return f[a+12>>2]|0}function qSa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);do if(!(f[c>>2]&2))o=e;else{m=f[a+20>>2]|0;b[e>>0]=16;n=e+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){d=m;j=n;while(1){b[j>>0]=d|128;i=d>>>7;k=j+1|0;if(d>>>0>16383){d=i;j=k}else{p=k;q=i;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}while(0);p=f[a+4>>2]|0;if(!(p&1)){r=o;return r|0}r=bQb(p&-2,o)|0;return r|0}function rSa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function sSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))jMa(43706);c=T6b(b,23288,18984,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[b>>2]|0}if(e&2|0){e=f[c+20>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|2;f[a+20>>2]=e}}e=f[c+4>>2]|0;if(!(e&1))return;LPb(e&-2,a+4|0);return}function tSa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function uSa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213170];f[a+4>>2]=f[213171];u=c;return}function vSa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function wSa(a){a=a|0;var b=0,c=0;f[a>>2]=117396;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function xSa(a){a=a|0;var b=0,c=0;f[a>>2]=117396;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function ySa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function zSa(a,b){a=a|0;b=b|0;a=L5b(36)|0;jPa(a);if(!b)return a|0;KSa(b,a);return a|0}function ASa(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&5|0){f[a+28>>2]=1;f[a+32>>2]=1}f[a+16>>2]=0;f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function BSa(a){a=a|0;return 1}function CSa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;if(f[c>>2]&4|0)Opb(1,f[a+32>>2]|0,b);d=a+16|0;if((f[d>>2]|0)>0){e=a+24|0;g=0;do{Opb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)<(f[d>>2]|0))}if(f[c>>2]&1|0)Mpb(3,f[a+28>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function DSa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function ESa(a){a=a|0;return f[a+12>>2]|0}function FSa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+8|0;if(!(f[c>>2]&4))e=d;else{g=f[a+32>>2]|0;b[d>>0]=8;h=d+1|0;if(g>>>0>127){d=g;i=h;while(1){b[i>>0]=d|128;j=d>>>7;k=i+1|0;if(d>>>0>16383){d=j;i=k}else{l=k;m=j;break}}}else{l=h;m=g}b[l>>0]=m;e=l+1|0}l=a+16|0;if((f[l>>2]|0)>0){m=a+24|0;g=0;h=e;while(1){i=f[(f[m>>2]|0)+4+(g<<2)>>2]|0;b[h>>0]=16;d=h+1|0;if(i>>>0>127){j=i;k=d;while(1){b[k>>0]=j|128;n=j>>>7;o=k+1|0;if(j>>>0>16383){j=n;k=o}else{p=o;q=n;break}}}else{p=d;q=i}b[p>>0]=q;k=p+1|0;g=g+1|0;if((g|0)>=(f[l>>2]|0)){r=k;break}else h=k}}else r=e;do if(!(f[c>>2]&1))s=r;else{e=f[a+28>>2]|0;b[r>>0]=24;h=r+1|0;if((e|0)<0){s=hob(e,((e|0)<0)<<31>>31,h)|0;break}if(e>>>0>127){l=e;g=h;while(1){b[g>>0]=l|128;p=l>>>7;q=g+1|0;if(l>>>0>16383){l=p;g=q}else{t=q;u=p;break}}}else{t=h;u=e}b[t>>0]=u;s=t+1|0}while(0);t=f[a+4>>2]|0;if(!(t&1)){v=s;return v|0}v=bQb(t&-2,s)|0;return v|0}function GSa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function HSa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(43299);c=T6b(b,23288,19e3,0)|0;if(!c){cOb(b,a);return}else{kPa(a,c);return}}function ISa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function JSa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213168];f[a+4>>2]=f[213169];u=c;return}function KSa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function LSa(a){a=a|0;var b=0,c=0;f[a>>2]=117288;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function MSa(a){a=a|0;var b=0,c=0;f[a>>2]=117288;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function NSa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function OSa(a,b){a=a|0;b=b|0;a=L5b(20)|0;hPa(a);if(!b)return a|0;_Sa(b,a);return a|0}function PSa(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function QSa(a){a=a|0;return 1}function RSa(a){a=a|0;var b=0,c=0,d=0,e=0;if(f[a+8>>2]&1){b=f[a+16>>2]|0;if((b|0)>=0)if(b>>>0<128)c=2;else c=(iob(b)|0)+1|0;else c=11}else c=0;b=f[a+4>>2]|0;if(!(b&1)){d=c;e=a+12|0;f[e>>2]=d;return d|0}d=(dQb(b&-2)|0)+c|0;e=a+12|0;f[e>>2]=d;return d|0}function SSa(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)Zpb(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function TSa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function USa(a){a=a|0;return f[a+12>>2]|0}function VSa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;do if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=8;g=d+1|0;if((c|0)<0){e=hob(c,((c|0)<0)<<31>>31,g)|0;break}if(c>>>0>127){h=c;i=g;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=g;m=c}b[l>>0]=m;e=l+1|0}while(0);l=f[a+4>>2]|0;if(!(l&1)){n=e;return n|0}n=bQb(l&-2,e)|0;return n|0}function WSa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function XSa(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))jMa(42934);c=T6b(b,23288,19016,0)|0;if(!c){cOb(b,a);return}if(f[c+8>>2]&1|0){b=f[c+16>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|1;f[a+16>>2]=b}b=f[c+4>>2]|0;if(!(b&1))return;LPb(b&-2,a+4|0);return}function YSa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function ZSa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213165];f[a+4>>2]=f[213166];u=c;return}function _Sa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function $Sa(a){a=a|0;var b=0,c=0;f[a>>2]=117180;if((a|0)!=496328){b=f[a+16>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+20>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function aTa(a){a=a|0;$Sa(a);O5b(a);return}function bTa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function cTa(a,b){a=a|0;b=b|0;a=L5b(36)|0;qTa(a);if(!b)return a|0;rTa(b,a);return a|0}function dTa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(d&31|0){f[a+28>>2]=1;f[a+32>>2]=1;if(d&4|0?(d=f[a+16>>2]|0,d|0):0){e=d+8|0;g=f[e>>2]|0;if(g&255|0){h=d+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if(g&1|0?(g=f[213028]|0,h=f[d+16>>2]|0,(h|0)!=(g|0)):0)_5b(h,g)|0;n[d+40>>2]=1.0;n[d+44>>2]=1.0;f[d+36>>2]=-1}f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)GPb(d)}b[a+24>>0]=0;if(f[c>>2]&16|0?(d=f[a+20>>2]|0,d|0):0){e=d+8|0;g=f[e>>2]|0;if(g&255|0){h=d+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if(g&1|0?(g=f[213028]|0,h=f[d+16>>2]|0,(h|0)!=(g|0)):0)_5b(h,g)|0;n[d+40>>2]=1.0;n[d+44>>2]=1.0;f[d+36>>2]=-1}f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)GPb(d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function eTa(a){a=a|0;return 1}function fTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+28|0;k=a+32|0;l=a+16|0;m=e+4|0;n=a+24|0;o=e+8|0;p=a+20|0;q=e+4|0;r=c+32|0;s=c+12|0;t=c+28|0;v=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){w=b[a>>0]|0;x=w&255;if(w<<24>>24>0){f[h>>2]=x;f[c>>2]=a+1;y=x;z=6}else{A=x;z=5}}else{A=0;z=5}if((z|0)==5){z=0;x=_nb(c,A)|0;f[h>>2]=x;if((x+-1|0)>>>0<127){y=x;z=6}else{B=x;z=65}}b:do if((z|0)==6){z=0;switch(y>>>3&536870911|0){case 1:{switch(y|0){case 0:{C=1;z=71;break a;break}case 8:break;default:{D=y;break b}}f[i>>2]=f[i>>2]|1;x=f[c>>2]|0;a=f[g>>2]|0;if(x>>>0<a>>>0){w=b[x>>0]|0;E=w&255;if(w<<24>>24>-1){w=x+1|0;f[c>>2]=w;F=E;G=w;H=a}else{I=E;z=11}}else{I=0;z=11}if((z|0)==11){z=0;E=Knb(c,I)|0;a=J;if(!((a|0)>-1|(a|0)==-1&E>>>0>4294967295)){C=0;z=71;break a}F=E;G=f[c>>2]|0;H=f[g>>2]|0}f[j>>2]=F;if(G>>>0>=H>>>0)continue a;if((b[G>>0]|0)!=16)continue a;E=G+1|0;f[c>>2]=E;K=E;L=H;z=18;break}case 2:{switch(y|0){case 0:{C=1;z=71;break a;break}case 16:break;default:{D=y;break b}}K=f[c>>2]|0;L=f[g>>2]|0;z=18;break}case 3:{switch(y|0){case 0:{C=1;z=71;break a;break}case 26:{z=27;break}default:{D=y;break b}}break}case 4:{switch(y|0){case 0:{C=1;z=71;break a;break}case 32:break;default:{D=y;break b}}M=f[c>>2]|0;N=f[g>>2]|0;z=42;break}case 5:{switch(y|0){case 0:{C=1;z=71;break a;break}case 42:break;default:{D=y;break b}}break}default:{B=y;z=65;break b}}if((z|0)==18){z=0;f[i>>2]=f[i>>2]|2;if(K>>>0<L>>>0){E=b[K>>0]|0;a=E&255;if(E<<24>>24>-1){E=K+1|0;f[c>>2]=E;O=a;P=E;Q=L}else{R=a;z=21}}else{R=0;z=21}if((z|0)==21){z=0;a=Knb(c,R)|0;E=J;if(!((E|0)>-1|(E|0)==-1&a>>>0>4294967295)){C=0;z=71;break a}O=a;P=f[c>>2]|0;Q=f[g>>2]|0}f[k>>2]=O;if(P>>>0>=Q>>>0)continue a;if((b[P>>0]|0)!=26)continue a;f[c>>2]=P+1;z=27}if((z|0)==27){z=0;f[i>>2]=f[i>>2]|4;a=f[l>>2]|0;if(!a){E=L5b(48)|0;GNa(E);f[l>>2]=E;S=E}else S=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(E=b[a>>0]|0,E<<24>>24>-1):0){f[c>>2]=a+1;T=E&255}else{E=Znb(c)|0;if((E|0)>-1)T=E;else{C=0;z=71;break a}}Inb(e,c,T);if((f[m>>2]|0)<0){z=35;break a}if(!(JNa(S,c)|0)){z=35;break a}if(!(Onb(c,f[e>>2]|0)|0)){C=0;z=71;break a}E=f[c>>2]|0;a=f[g>>2]|0;if(E>>>0>=a>>>0)continue a;if((b[E>>0]|0)!=32)continue a;w=E+1|0;f[c>>2]=w;M=w;N=a;z=42}if((z|0)==42){z=0;f[i>>2]=f[i>>2]|8;if(M>>>0<N>>>0?(a=b[M>>0]|0,a<<24>>24>-1):0){w=M+1|0;f[c>>2]=w;U=a<<24>>24!=0;V=w;W=N}else{Lnb(e,c);w=e;if(!(b[o>>0]|0)){C=0;z=71;break a}U=(f[w>>2]|0)!=0|(f[w+4>>2]|0)!=0;V=f[c>>2]|0;W=f[g>>2]|0}b[n>>0]=U&1;if(V>>>0>=W>>>0)continue a;if((b[V>>0]|0)!=42)continue a;f[c>>2]=V+1}f[i>>2]=f[i>>2]|16;w=f[p>>2]|0;if(!w){a=L5b(48)|0;GNa(a);f[p>>2]=a;X=a}else X=w;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0?(a=b[w>>0]|0,a<<24>>24>-1):0){f[c>>2]=w+1;Y=a&255}else{a=Znb(c)|0;if((a|0)>-1)Y=a;else{C=0;z=71;break a}}Inb(e,c,Y);if((f[q>>2]|0)<0){z=59;break a}if(!(JNa(X,c)|0)){z=59;break a}if(!(Onb(c,f[e>>2]|0)|0)){C=0;z=71;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[r>>2]|0){z=64;break a}if((f[s>>2]|0)==(f[t>>2]|0)){z=64;break a}else continue a}while(0);if((z|0)==65){z=0;if(!B){C=1;z=71;break}else D=B}if((D&7|0)==4){C=1;z=71;break}a=f[v>>2]|0;if(!(a&1))Z=hBa(v)|0;else Z=a&-2;if(!(ZPb(c,D,Z)|0)){C=0;z=71;break}}if((z|0)==35){C=0;u=d;return C|0}else if((z|0)==59){C=0;u=d;return C|0}else if((z|0)==64){f[h>>2]=0;b[c+24>>0]=1;C=1;u=d;return C|0}else if((z|0)==71){u=d;return C|0}return 0}function gTa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=a+8|0;c=f[b>>2]|0;if(c&31){if(c&1){d=f[a+28>>2]|0;if((d|0)>=0)if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}else{e=11;g=c}}else{e=0;g=c}if(!(g&2)){i=e;j=g}else{c=f[a+32>>2]|0;if((c|0)>=0)if(c>>>0<128){k=2;l=g}else{h=(iob(c)|0)+1|0;k=h;l=f[b>>2]|0}else{k=11;l=g}i=k+e|0;j=l}if(!(j&4)){m=i;n=j}else{j=INa(f[a+16>>2]|0)|0;if(j>>>0<128)o=1;else o=iob(j)|0;m=i+1+j+o|0;n=f[b>>2]|0}b=n&8|0?m+2|0:m;if(!(n&16))p=b;else{n=INa(f[a+20>>2]|0)|0;if(n>>>0<128)q=1;else q=iob(n)|0;p=b+1+n+q|0}}else p=0;q=f[a+4>>2]|0;if(!(q&1)){r=p;s=a+12|0;f[s>>2]=r;return r|0}r=(dQb(q&-2)|0)+p|0;s=a+12|0;f[s>>2]=r;return r|0}function hTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Mpb(1,f[a+28>>2]|0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{Mpb(2,f[a+32>>2]|0,c);h=f[d>>2]|0}if(!(h&4))i=h;else{eqb(3,f[a+16>>2]|0,c);i=f[d>>2]|0}if(!(i&8))j=i;else{Ypb(4,(b[a+24>>0]|0)!=0,c);j=f[d>>2]|0}if(j&16|0)eqb(5,f[a+20>>2]|0,c);j=f[a+4>>2]|0;if(!(j&1))return;aQb(j&-2,c);return}function iTa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function jTa(a){a=a|0;return f[a+12>>2]|0}function kTa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+28>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);do if(!(f[c>>2]&2))o=e;else{m=f[a+32>>2]|0;b[e>>0]=16;n=e+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){d=m;j=n;while(1){b[j>>0]=d|128;i=d>>>7;k=j+1|0;if(d>>>0>16383){d=i;j=k}else{p=k;q=i;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}while(0);p=f[c>>2]|0;if(!(p&4)){r=o;s=p}else{p=f[a+16>>2]|0;b[o>>0]=26;q=o+1|0;o=f[p+12>>2]|0;if(o>>>0>127){e=o;j=q;while(1){b[j>>0]=e|128;d=e>>>7;g=j+1|0;if(e>>>0>16383){e=d;j=g}else{t=g;u=d;break}}}else{t=q;u=o}b[t>>0]=u;u=li[f[(f[p>>2]|0)+68>>2]&511](p,0,t+1|0)|0;r=u;s=f[c>>2]|0}if(!(s&8)){v=r;w=s}else{s=b[a+24>>0]|0;b[r>>0]=32;b[r+1>>0]=s;v=r+2|0;w=f[c>>2]|0}if(!(w&16))x=v;else{w=f[a+20>>2]|0;b[v>>0]=42;c=v+1|0;v=f[w+12>>2]|0;if(v>>>0>127){r=v;s=c;while(1){b[s>>0]=r|128;u=r>>>7;t=s+1|0;if(r>>>0>16383){r=u;s=t}else{y=t;z=u;break}}}else{y=c;z=v}b[y>>0]=z;x=li[f[(f[w>>2]|0)+68>>2]&511](w,0,y+1|0)|0}y=f[a+4>>2]|0;if(!(y&1)){A=x;return A|0}A=bQb(y&-2,x)|0;return A|0}function lTa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function mTa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(42472);c=T6b(b,23288,19032,0)|0;if(!c){cOb(b,a);return}else{pTa(a,c);return}}function nTa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function oTa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213163];f[a+4>>2]=f[213164];u=c;return}function pTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=c+8|0;e=f[d>>2]|0;do if(e&255|0){if(!(e&1))g=e;else{h=f[c+28>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|1;f[a+28>>2]=h;g=f[d>>2]|0}if(!(g&2))j=g;else{h=f[c+32>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|2;f[a+32>>2]=h;j=f[d>>2]|0}do if(j&4){h=a+8|0;f[h>>2]=f[h>>2]|4;h=a+16|0;i=f[h>>2]|0;if(!i){k=L5b(48)|0;GNa(k);f[h>>2]=k;l=k}else l=i;i=f[c+16>>2]|0;k=(i|0)==0?493544:i;if((k|0)==(l|0))jMa(8763);else{HNa(l,k);m=f[d>>2]|0;break}}else m=j;while(0);if(!(m&8))n=m;else{k=b[c+24>>0]|0;i=a+8|0;f[i>>2]=f[i>>2]|8;b[a+24>>0]=k;n=f[d>>2]|0}if(n&16|0){k=a+8|0;f[k>>2]=f[k>>2]|16;k=a+20|0;i=f[k>>2]|0;if(!i){h=L5b(48)|0;GNa(h);f[k>>2]=h;o=h}else o=i;i=f[c+20>>2]|0;h=(i|0)==0?493544:i;if((h|0)==(o|0))jMa(8763);else{HNa(o,h);break}}}while(0);o=f[c+4>>2]|0;if(!(o&1))return;LPb(o&-2,a+4|0);return}function qTa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=117180;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496328?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;b[d+12>>0]=0;f[a+28>>2]=1;f[a+32>>2]=1;u=c;return}function rTa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function sTa(a){a=a|0;var b=0,c=0;f[a>>2]=117072;if((a|0)!=496288?(b=f[a+16>>2]|0,b|0):0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function tTa(a){a=a|0;sTa(a);O5b(a);return}function uTa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function vTa(a,b){a=a|0;b=b|0;a=L5b(28)|0;JTa(a);if(!b)return a|0;KTa(b,a);return a|0}function wTa(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;c=f[b>>2]|0;if(c&7|0){if(((c&1|0?(c=f[a+16>>2]|0,c|0):0)?(f[c+16>>2]=0,f[c+8>>2]=0,d=f[c+4>>2]|0,d&1|0):0)?(c=d&-2,f[c>>2]|0):0)GPb(c);f[a+20>>2]=0;f[a+24>>2]=-1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function xTa(a){a=a|0;return 1}function yTa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+16|0;k=e+4|0;l=a+20|0;m=a+24|0;n=c+32|0;o=c+12|0;p=c+28|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[h>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[h>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=42}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=48;break a;break}case 10:break;default:{z=t;break b}}f[i>>2]=f[i>>2]|1;s=f[j>>2]|0;if(!s){a=L5b(32)|0;fOa(a);f[j>>2]=a;A=a}else A=s;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0?(a=b[s>>0]|0,a<<24>>24>-1):0){f[c>>2]=s+1;B=a&255}else{a=Znb(c)|0;if((a|0)>-1)B=a;else{y=0;v=48;break a}}Inb(e,c,B);if((f[k>>2]|0)<0){v=16;break a}if(!(GLa(A,c)|0)){v=16;break a}if(!(Onb(c,f[e>>2]|0)|0)){y=0;v=48;break a}a=f[c>>2]|0;s=f[g>>2]|0;if(a>>>0>=s>>>0)continue a;if((b[a>>0]|0)!=16)continue a;r=a+1|0;f[c>>2]=r;C=r;D=s;v=23;break}case 2:{switch(t|0){case 0:{y=1;v=48;break a;break}case 16:break;default:{z=t;break b}}C=f[c>>2]|0;D=f[g>>2]|0;v=23;break}case 3:{switch(t|0){case 0:{y=1;v=48;break a;break}case 24:break;default:{z=t;break b}}E=f[c>>2]|0;F=f[g>>2]|0;break}default:{x=t;v=42;break b}}if((v|0)==23){v=0;f[i>>2]=f[i>>2]|2;if(C>>>0<D>>>0){s=b[C>>0]|0;r=s&255;if(s<<24>>24>-1){s=C+1|0;f[c>>2]=s;G=r;H=s;I=D}else{K=r;v=26}}else{K=0;v=26}if((v|0)==26){v=0;r=Knb(c,K)|0;s=J;if(!((s|0)>-1|(s|0)==-1&r>>>0>4294967295)){y=0;v=48;break a}G=r;H=f[c>>2]|0;I=f[g>>2]|0}f[l>>2]=G;if(H>>>0>=I>>>0)continue a;if((b[H>>0]|0)!=24)continue a;r=H+1|0;f[c>>2]=r;E=r;F=I}f[i>>2]=f[i>>2]|4;if(E>>>0<F>>>0){r=b[E>>0]|0;s=r&255;if(r<<24>>24>-1){r=E+1|0;f[c>>2]=r;L=s;M=r;N=F}else{O=s;v=36}}else{O=0;v=36}if((v|0)==36){v=0;s=Knb(c,O)|0;r=J;if(!((r|0)>-1|(r|0)==-1&s>>>0>4294967295)){y=0;v=48;break a}L=s;M=f[c>>2]|0;N=f[g>>2]|0}f[m>>2]=L;if((M|0)!=(N|0))continue a;if(f[n>>2]|0){v=41;break a}if((f[o>>2]|0)==(f[p>>2]|0)){v=41;break a}else continue a}while(0);if((v|0)==42){v=0;if(!x){y=1;v=48;break}else z=x}if((z&7|0)==4){y=1;v=48;break}s=f[q>>2]|0;if(!(s&1))P=hBa(q)|0;else P=s&-2;if(!(ZPb(c,z,P)|0)){y=0;v=48;break}}if((v|0)==16){y=0;u=d;return y|0}else if((v|0)==41){f[h>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==48){u=d;return y|0}return 0}function zTa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=a+8|0;c=f[b>>2]|0;if(c&7){if(!(c&1)){d=0;e=c}else{c=f[a+16>>2]|0;g=f[c+16>>2]|0;if(g){h=c+24|0;i=0;j=0;do{k=(f[h>>2]|0)+8+(j<<3)|0;i=(job(f[k>>2]|0,f[k+4>>2]|0)|0)+i|0;j=j+1|0}while((j|0)!=(g|0));if(i)if((i|0)>=0)if(i>>>0<128){l=2;m=i}else{l=(iob(i)|0)+1|0;m=i}else{l=11;m=i}else{l=0;m=0}}else{l=0;m=0}f[c+28>>2]=m;i=l+m|0;m=f[c+4>>2]|0;if(!(m&1))n=i;else n=(dQb(m&-2)|0)+i|0;f[c+12>>2]=n;if(n>>>0<128)o=1;else o=iob(n)|0;d=n+1+o|0;e=f[b>>2]|0}if(!(e&2)){p=d;q=e}else{o=f[a+20>>2]|0;if((o|0)>=0)if(o>>>0<128){r=2;s=e}else{n=(iob(o)|0)+1|0;r=n;s=f[b>>2]|0}else{r=11;s=e}p=r+d|0;q=s}if(!(q&4))t=p;else{q=f[a+24>>2]|0;if((q|0)>=0)if(q>>>0<128)u=2;else u=(iob(q)|0)+1|0;else u=11;t=u+p|0}}else t=0;p=f[a+4>>2]|0;if(!(p&1)){v=t;w=a+12|0;f[w>>2]=v;return v|0}v=(dQb(p&-2)|0)+t|0;w=a+12|0;f[w>>2]=v;return v|0}function ATa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{eqb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{Mpb(2,f[a+20>>2]|0,b);g=f[c>>2]|0}if(g&4|0)Mpb(3,f[a+24>>2]|0,b);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,b);return}function BTa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function CTa(a){a=a|0;return f[a+12>>2]|0}function DTa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=d+1|0;d=f[e+12>>2]|0;if(d>>>0>127){j=d;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=d}b[n>>0]=o;o=li[f[(f[e>>2]|0)+68>>2]&511](e,0,n+1|0)|0;g=o;h=f[c>>2]|0}do if(!(h&2))p=g;else{o=f[a+20>>2]|0;b[g>>0]=16;n=g+1|0;if((o|0)<0){p=hob(o,((o|0)<0)<<31>>31,n)|0;break}if(o>>>0>127){e=o;d=n;while(1){b[d>>0]=e|128;i=e>>>7;k=d+1|0;if(e>>>0>16383){e=i;d=k}else{q=k;r=i;break}}}else{q=n;r=o}b[q>>0]=r;p=q+1|0}while(0);do if(!(f[c>>2]&4))s=p;else{q=f[a+24>>2]|0;b[p>>0]=24;r=p+1|0;if((q|0)<0){s=hob(q,((q|0)<0)<<31>>31,r)|0;break}if(q>>>0>127){g=q;h=r;while(1){b[h>>0]=g|128;d=g>>>7;e=h+1|0;if(g>>>0>16383){g=d;h=e}else{t=e;u=d;break}}}else{t=r;u=q}b[t>>0]=u;s=t+1|0}while(0);t=f[a+4>>2]|0;if(!(t&1)){v=s;return v|0}v=bQb(t&-2,s)|0;return v|0}function ETa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function FTa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(41960);c=T6b(b,23288,19048,0)|0;if(!c){cOb(b,a);return}else{ITa(a,c);return}}function GTa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function HTa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213161];f[a+4>>2]=f[213162];u=c;return}function ITa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=b+8|0;d=f[c>>2]|0;if(d&255|0){if(d&1|0){d=a+8|0;f[d>>2]=f[d>>2]|1;d=a+16|0;e=f[d>>2]|0;if(!e){g=L5b(32)|0;fOa(g);f[d>>2]=g;h=g}else h=e;e=f[b+16>>2]|0;g=(e|0)==0?493e3:e;if((g|0)==(h|0))jMa(2959);e=h+16|0;d=g+16|0;i=f[d>>2]|0;if(i|0){uFa(e,(f[e>>2]|0)+i|0);Vac((f[h+24>>2]|0)+8+(f[e>>2]<<3)|0,(f[g+24>>2]|0)+8|0,f[d>>2]<<3|0)|0;f[e>>2]=(f[e>>2]|0)+(f[d>>2]|0)}d=f[g+4>>2]|0;if(d&1|0)LPb(d&-2,h+4|0)}h=f[c>>2]|0;if(!(h&2))j=h;else{h=f[b+20>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+20>>2]=h;j=f[c>>2]|0}if(j&4|0){j=f[b+24>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|4;f[a+24>>2]=j}}j=f[b+4>>2]|0;if(!(j&1))return;LPb(j&-2,a+4|0);return}function JTa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=117072;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496288?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=-1;u=c;return}function KTa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function LTa(a){a=a|0;var b=0,c=0;f[a>>2]=116964;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function MTa(a){a=a|0;var b=0,c=0;f[a>>2]=116964;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function NTa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function OTa(a,b){a=a|0;b=b|0;a=L5b(24)|0;gPa(a);if(!b)return a|0;_Ta(b,a);return a|0}function PTa(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function QTa(a){a=a|0;return 1}function RTa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+8>>2]|0;if(b&3){c=b&1|0?5:0;if(!(b&2))d=c;else{b=f[a+20>>2]|0;if((b|0)>=0)if(b>>>0<128)e=2;else e=(iob(b)|0)+1|0;else e=11;d=e+c|0}}else d=0;c=f[a+4>>2]|0;if(!(c&1)){g=d;h=a+12|0;f[h>>2]=g;return g|0}g=(dQb(c&-2)|0)+d|0;h=a+12|0;f[h>>2]=g;return g|0}function STa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Wpb(1,+n[a+16>>2],b);e=f[c>>2]|0}if(e&2|0)Zpb(2,f[a+20>>2]|0,b);e=f[a+4>>2]|0;if(!(e&1))return;aQb(e&-2,b);return}function TTa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function UTa(a){a=a|0;return f[a+12>>2]|0}function VTa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=13;i=d+1|0;b[i>>0]=e;b[i+1>>0]=e>>8;b[i+2>>0]=e>>16;b[i+3>>0]=e>>24;g=d+5|0;h=f[c>>2]|0}do if(!(h&2))j=g;else{c=f[a+20>>2]|0;b[g>>0]=16;d=g+1|0;if((c|0)<0){j=hob(c,((c|0)<0)<<31>>31,d)|0;break}if(c>>>0>127){e=c;i=d;while(1){b[i>>0]=e|128;k=e>>>7;l=i+1|0;if(e>>>0>16383){e=k;i=l}else{m=l;n=k;break}}}else{m=d;n=c}b[m>>0]=n;j=m+1|0}while(0);m=f[a+4>>2]|0;if(!(m&1)){o=j;return o|0}o=bQb(m&-2,j)|0;return o|0}function WTa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function XTa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))jMa(41570);c=T6b(b,23288,19064,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[b>>2]|0}if(e&2|0){e=f[c+20>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|2;f[a+20>>2]=e}}e=f[c+4>>2]|0;if(!(e&1))return;LPb(e&-2,a+4|0);return}function YTa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function ZTa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213158];f[a+4>>2]=f[213159];u=c;return}function _Ta(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function $Ta(a){a=a|0;var b=0,c=0;f[a>>2]=116856;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function aUa(a){a=a|0;var b=0,c=0;f[a>>2]=116856;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function bUa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function cUa(a,b){a=a|0;b=b|0;a=L5b(28)|0;pUa(a);if(!b)return a|0;qUa(b,a);return a|0}function dUa(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){f[a+20>>2]=1;f[a+16>>2]=0;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function eUa(a){a=a|0;return 1}function fUa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+4|0;k=a+8|0;l=a+20|0;m=a+16|0;n=a+24|0;a=c+32|0;o=c+12|0;p=c+28|0;a:while(1){b:while(1){q=f[c>>2]|0;if(q>>>0<(f[g>>2]|0)>>>0){r=b[q>>0]|0;s=r&255;if(r<<24>>24>0){f[i>>2]=s;f[c>>2]=q+1;t=s;v=7}else{w=s;v=6}}else{w=0;v=6}if((v|0)==6){v=0;s=_nb(c,w)|0;f[i>>2]=s;if((s+-1|0)>>>0<127){t=s;v=7}else{x=s;v=43}}c:do if((v|0)==7){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=49;break a;break}case 8:{v=9;break b;break}default:{z=t;break c}}break}case 2:{switch(t|0){case 0:{y=1;v=49;break a;break}case 16:{v=23;break b;break}default:{z=t;break c}}break}case 3:{switch(t|0){case 0:{y=1;v=49;break a;break}case 29:{v=33;break b;break}default:{z=t;break c}}break}default:{x=t;v=43;break c}}}while(0);if((v|0)==43){v=0;if(!x){y=1;v=49;break a}else z=x}if((z&7|0)==4){y=1;v=49;break a}s=f[j>>2]|0;if(!(s&1))A=hBa(j)|0;else A=s&-2;if(!(ZPb(c,z,A)|0)){y=0;v=49;break a}}if((v|0)==9){v=0;s=f[c>>2]|0;if(s>>>0<(f[g>>2]|0)>>>0){q=b[s>>0]|0;r=q&255;if(q<<24>>24>-1){f[c>>2]=s+1;B=r}else{C=r;v=12}}else{C=0;v=12}if((v|0)==12){v=0;r=Knb(c,C)|0;s=J;if((s|0)>-1|(s|0)==-1&r>>>0>4294967295)B=r;else{y=0;v=49;break}}if((B+-1|0)>>>0<4){f[k>>2]=f[k>>2]|1;f[l>>2]=B}else{r=f[j>>2]|0;if(!(r&1))D=hBa(j)|0;else D=r&-2;NPb(D,1,B,((B|0)<0)<<31>>31)}r=f[c>>2]|0;s=f[g>>2]|0;if(r>>>0>=s>>>0)continue;if((b[r>>0]|0)!=16)continue;q=r+1|0;f[c>>2]=q;E=s;F=q;v=24}else if((v|0)==23){v=0;E=f[g>>2]|0;F=f[c>>2]|0;v=24}else if((v|0)==33){v=0;q=f[g>>2]|0;G=q;H=f[c>>2]|0;I=q}if((v|0)==24){v=0;f[k>>2]=f[k>>2]|2;if(F>>>0<E>>>0){q=b[F>>0]|0;s=q&255;if(q<<24>>24>-1){q=F+1|0;f[c>>2]=q;K=s;L=E;M=q}else{N=s;v=27}}else{N=0;v=27}if((v|0)==27){v=0;s=Knb(c,N)|0;q=J;if(!((q|0)>-1|(q|0)==-1&s>>>0>4294967295)){y=0;v=49;break}K=s;L=f[g>>2]|0;M=f[c>>2]|0}f[m>>2]=K;if(M>>>0>=L>>>0)continue;if((b[M>>0]|0)!=29)continue;s=M+1|0;f[c>>2]=s;G=L;H=s;I=L}f[k>>2]=f[k>>2]|4;if((I-H|0)>3){s=H;q=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[e>>2]=q;s=H+4|0;f[c>>2]=s;O=q;P=s;Q=G}else{if(!(Xnb(c,e)|0)){v=38;break}O=f[e>>2]|0;P=f[c>>2]|0;Q=f[g>>2]|0}f[n>>2]=O;if((P|0)!=(Q|0))continue;if(f[a>>2]|0){v=42;break}if((f[o>>2]|0)==(f[p>>2]|0)){v=42;break}}if((v|0)==38){y=0;u=d;return y|0}else if((v|0)==42){f[i>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==49){u=d;return y|0}return 0}function gUa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=a+8|0;c=f[b>>2]|0;if(!(c&7))d=0;else{if(c&1){e=f[a+20>>2]|0;if((e|0)>=0)if(e>>>0<128){g=2;h=c}else{i=(iob(e)|0)+1|0;g=i;h=f[b>>2]|0}else{g=11;h=c}}else{g=0;h=c}if(!(h&2)){j=g;k=h}else{c=f[a+16>>2]|0;if((c|0)>=0)if(c>>>0<128){l=2;m=h}else{i=(iob(c)|0)+1|0;l=i;m=f[b>>2]|0}else{l=11;m=h}j=l+g|0;k=m}d=k&4|0?j+5|0:j}j=f[a+4>>2]|0;if(!(j&1)){n=d;o=a+12|0;f[o>>2]=n;return n|0}n=(dQb(j&-2)|0)+d|0;o=a+12|0;f[o>>2]=n;return n|0}function hUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Zpb(1,f[a+20>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{Mpb(2,f[a+16>>2]|0,b);g=f[c>>2]|0}if(g&4|0)Wpb(3,+n[a+24>>2],b);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,b);return}function iUa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function jUa(a){a=a|0;return f[a+12>>2]|0}function kUa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+20>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);do if(!(f[c>>2]&2))o=e;else{m=f[a+16>>2]|0;b[e>>0]=16;n=e+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){d=m;j=n;while(1){b[j>>0]=d|128;i=d>>>7;k=j+1|0;if(d>>>0>16383){d=i;j=k}else{p=k;q=i;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}while(0);if(!(f[c>>2]&4))r=o;else{c=f[a+24>>2]|0;b[o>>0]=29;p=o+1|0;b[p>>0]=c;b[p+1>>0]=c>>8;b[p+2>>0]=c>>16;b[p+3>>0]=c>>24;r=o+5|0}o=f[a+4>>2]|0;if(!(o&1)){s=r;return s|0}s=bQb(o&-2,r)|0;return s|0}function lUa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function mUa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((a|0)==(b|0))jMa(41151);c=T6b(b,23288,19080,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+20>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+20>>2]=d;e=f[b>>2]|0}if(!(e&2))h=e;else{e=f[c+16>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+16>>2]=e;h=f[b>>2]|0}if(h&4|0){h=f[c+24>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|4;f[a+24>>2]=h}}h=f[c+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function nUa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function oUa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213155];f[a+4>>2]=f[213156];u=c;return}function pUa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=116856;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496216?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;n[a+24>>2]=1.0;u=c;return}function qUa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function rUa(a){a=a|0;var b=0,c=0;f[a>>2]=116748;if((a|0)!=496176){b=f[a+16>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+20>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function sUa(a){a=a|0;rUa(a);O5b(a);return}function tUa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function uUa(a,b){a=a|0;b=b|0;a=L5b(32)|0;IUa(a);if(!b)return a|0;JUa(b,a);return a|0}function vUa(a){a=a|0;var b=0,c=0,e=0,g=0,h=0;b=a+8|0;c=f[b>>2]|0;if(c&31|0){e=a+24|0;f[e>>2]=0;d[e+4>>1]=0;if(c&2|0?(c=f[a+16>>2]|0,c|0):0){e=c+8|0;g=f[e>>2]|0;if(g&255|0){h=c+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if(g&1|0?(g=f[213028]|0,h=f[c+16>>2]|0,(h|0)!=(g|0)):0)_5b(h,g)|0;n[c+40>>2]=1.0;n[c+44>>2]=1.0;f[c+36>>2]=-1}f[e>>2]=0;e=f[c+4>>2]|0;if(e&1|0?(c=e&-2,f[c>>2]|0):0)GPb(c)}if(f[b>>2]&4|0?(c=f[a+20>>2]|0,c|0):0){e=c+8|0;g=f[e>>2]|0;if(g&255|0){h=c+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if(g&1|0?(g=f[213028]|0,h=f[c+16>>2]|0,(h|0)!=(g|0)):0)_5b(h,g)|0;n[c+40>>2]=1.0;n[c+44>>2]=1.0;f[c+36>>2]=-1}f[e>>2]=0;e=f[c+4>>2]|0;if(e&1|0?(c=e&-2,f[c>>2]|0):0)GPb(c)}}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function wUa(a){a=a|0;return 1}function xUa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+24|0;k=a+16|0;l=e+4|0;m=a+20|0;n=e+4|0;o=a+28|0;p=e+8|0;q=a+29|0;r=c+32|0;s=c+12|0;t=c+28|0;v=e+8|0;w=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){x=b[a>>0]|0;y=x&255;if(x<<24>>24>0){f[h>>2]=y;f[c>>2]=a+1;z=y;A=6}else{B=y;A=5}}else{B=0;A=5}if((A|0)==5){A=0;y=_nb(c,B)|0;f[h>>2]=y;if((y+-1|0)>>>0<127){z=y;A=6}else{C=y;A=65}}b:do if((A|0)==6){A=0;switch(z>>>3&536870911|0){case 1:{switch(z|0){case 0:{D=1;A=71;break a;break}case 8:break;default:{E=z;break b}}f[i>>2]=f[i>>2]|1;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){a=b[y>>0]|0;x=a&255;if(a<<24>>24>-1){f[j>>2]=x;a=y+1|0;f[c>>2]=a;F=a}else{G=x;A=11}}else{G=0;A=11}if((A|0)==11){A=0;x=Knb(c,G)|0;a=J;f[j>>2]=x;if(!((a|0)>-1|(a|0)==-1&x>>>0>4294967295)){D=0;A=71;break a}F=f[c>>2]|0}if(F>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[F>>0]|0)!=18)continue a;f[c>>2]=F+1;A=17;break}case 2:{switch(z|0){case 0:{D=1;A=71;break a;break}case 18:{A=17;break}default:{E=z;break b}}break}case 3:{switch(z|0){case 0:{D=1;A=71;break a;break}case 26:{A=31;break}default:{E=z;break b}}break}case 4:{switch(z|0){case 0:{D=1;A=71;break a;break}case 32:break;default:{E=z;break b}}H=f[c>>2]|0;I=f[g>>2]|0;A=46;break}case 5:{switch(z|0){case 0:{D=1;A=71;break a;break}case 40:break;default:{E=z;break b}}K=f[c>>2]|0;L=f[g>>2]|0;break}default:{C=z;A=65;break b}}if((A|0)==17){A=0;f[i>>2]=f[i>>2]|2;x=f[k>>2]|0;if(!x){a=L5b(48)|0;GNa(a);f[k>>2]=a;M=a}else M=x;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(a=b[x>>0]|0,a<<24>>24>-1):0){f[c>>2]=x+1;N=a&255}else{a=Znb(c)|0;if((a|0)>-1)N=a;else{D=0;A=71;break a}}Inb(e,c,N);if((f[l>>2]|0)<0){A=25;break a}if(!(JNa(M,c)|0)){A=25;break a}if(!(Onb(c,f[e>>2]|0)|0)){D=0;A=71;break a}a=f[c>>2]|0;if(a>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[a>>0]|0)!=26)continue a;f[c>>2]=a+1;A=31}if((A|0)==31){A=0;f[i>>2]=f[i>>2]|4;a=f[m>>2]|0;if(!a){x=L5b(48)|0;GNa(x);f[m>>2]=x;O=x}else O=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(x=b[a>>0]|0,x<<24>>24>-1):0){f[c>>2]=a+1;P=x&255}else{x=Znb(c)|0;if((x|0)>-1)P=x;else{D=0;A=71;break a}}Inb(e,c,P);if((f[n>>2]|0)<0){A=39;break a}if(!(JNa(O,c)|0)){A=39;break a}if(!(Onb(c,f[e>>2]|0)|0)){D=0;A=71;break a}x=f[c>>2]|0;a=f[g>>2]|0;if(x>>>0>=a>>>0)continue a;if((b[x>>0]|0)!=32)continue a;y=x+1|0;f[c>>2]=y;H=y;I=a;A=46}if((A|0)==46){A=0;f[i>>2]=f[i>>2]|8;if(H>>>0<I>>>0?(a=b[H>>0]|0,a<<24>>24>-1):0){y=H+1|0;f[c>>2]=y;Q=a<<24>>24!=0;R=y;S=I}else{Lnb(e,c);y=e;if(!(b[p>>0]|0)){D=0;A=71;break a}Q=(f[y>>2]|0)!=0|(f[y+4>>2]|0)!=0;R=f[c>>2]|0;S=f[g>>2]|0}b[o>>0]=Q&1;if(R>>>0>=S>>>0)continue a;if((b[R>>0]|0)!=40)continue a;y=R+1|0;f[c>>2]=y;K=y;L=S}f[i>>2]=f[i>>2]|16;if(K>>>0<L>>>0?(y=b[K>>0]|0,y<<24>>24>-1):0){a=K+1|0;f[c>>2]=a;T=y<<24>>24!=0;U=a;V=L}else{Lnb(e,c);a=e;if(!(b[v>>0]|0)){D=0;A=71;break a}T=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0;U=f[c>>2]|0;V=f[g>>2]|0}b[q>>0]=T&1;if((U|0)!=(V|0))continue a;if(f[r>>2]|0){A=64;break a}if((f[s>>2]|0)==(f[t>>2]|0)){A=64;break a}else continue a}while(0);if((A|0)==65){A=0;if(!C){D=1;A=71;break}else E=C}if((E&7|0)==4){D=1;A=71;break}a=f[w>>2]|0;if(!(a&1))W=hBa(w)|0;else W=a&-2;if(!(ZPb(c,E,W)|0)){D=0;A=71;break}}if((A|0)==25){D=0;u=d;return D|0}else if((A|0)==39){D=0;u=d;return D|0}else if((A|0)==64){f[h>>2]=0;b[c+24>>0]=1;D=1;u=d;return D|0}else if((A|0)==71){u=d;return D|0}return 0}function yUa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=a+8|0;c=f[b>>2]|0;if(!(c&31))d=0;else{if(c&1){e=f[a+24>>2]|0;if(e>>>0<128){g=2;h=c}else{i=(iob(e)|0)+1|0;g=i;h=f[b>>2]|0}}else{g=0;h=c}if(!(h&2)){j=g;k=h}else{h=INa(f[a+16>>2]|0)|0;if(h>>>0<128)l=1;else l=iob(h)|0;j=g+1+h+l|0;k=f[b>>2]|0}if(!(k&4)){m=j;n=k}else{k=INa(f[a+20>>2]|0)|0;if(k>>>0<128)o=1;else o=iob(k)|0;m=j+1+k+o|0;n=f[b>>2]|0}b=n&8|0?m+2|0:m;d=n&16|0?b+2|0:b}b=f[a+4>>2]|0;if(!(b&1)){p=d;q=a+12|0;f[q>>2]=p;return p|0}p=(dQb(b&-2)|0)+d|0;q=a+12|0;f[q>>2]=p;return p|0}function zUa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Opb(1,f[a+24>>2]|0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{eqb(2,f[a+16>>2]|0,c);h=f[d>>2]|0}if(!(h&4))i=h;else{eqb(3,f[a+20>>2]|0,c);i=f[d>>2]|0}if(!(i&8))j=i;else{Ypb(4,(b[a+28>>0]|0)!=0,c);j=f[d>>2]|0}if(j&16|0)Ypb(5,(b[a+29>>0]|0)!=0,c);j=f[a+4>>2]|0;if(!(j&1))return;aQb(j&-2,c);return}function AUa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function BUa(a){a=a|0;return f[a+12>>2]|0}function CUa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+24>>2]|0;b[d>>0]=8;i=d+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=e}b[m>>0]=n;g=m+1|0;h=f[c>>2]|0}if(!(h&2)){o=g;p=h}else{h=f[a+16>>2]|0;b[g>>0]=18;m=g+1|0;g=f[h+12>>2]|0;if(g>>>0>127){n=g;e=m;while(1){b[e>>0]=n|128;i=n>>>7;j=e+1|0;if(n>>>0>16383){n=i;e=j}else{q=j;r=i;break}}}else{q=m;r=g}b[q>>0]=r;r=li[f[(f[h>>2]|0)+68>>2]&511](h,0,q+1|0)|0;o=r;p=f[c>>2]|0}if(!(p&4)){s=o;t=p}else{p=f[a+20>>2]|0;b[o>>0]=26;r=o+1|0;o=f[p+12>>2]|0;if(o>>>0>127){q=o;h=r;while(1){b[h>>0]=q|128;g=q>>>7;m=h+1|0;if(q>>>0>16383){q=g;h=m}else{u=m;v=g;break}}}else{u=r;v=o}b[u>>0]=v;v=li[f[(f[p>>2]|0)+68>>2]&511](p,0,u+1|0)|0;s=v;t=f[c>>2]|0}if(!(t&8)){w=s;x=t}else{t=b[a+28>>0]|0;b[s>>0]=32;b[s+1>>0]=t;w=s+2|0;x=f[c>>2]|0}if(!(x&16))y=w;else{x=b[a+29>>0]|0;b[w>>0]=40;b[w+1>>0]=x;y=w+2|0}w=f[a+4>>2]|0;if(!(w&1)){z=y;return z|0}z=bQb(w&-2,y)|0;return z|0}function DUa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function EUa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(40615);c=T6b(b,23288,19096,0)|0;if(!c){cOb(b,a);return}else{HUa(a,c);return}}function FUa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function GUa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213153];f[a+4>>2]=f[213154];u=c;return}function HUa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=c+8|0;e=f[d>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=f[c+24>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;f[a+24>>2]=e;g=f[d>>2]|0}do if(g&2){e=a+8|0;f[e>>2]=f[e>>2]|2;e=a+16|0;h=f[e>>2]|0;if(!h){i=L5b(48)|0;GNa(i);f[e>>2]=i;j=i}else j=h;h=f[c+16>>2]|0;i=(h|0)==0?493544:h;if((i|0)==(j|0))jMa(8763);else{HNa(j,i);k=f[d>>2]|0;break}}else k=g;while(0);do if(k&4){g=a+8|0;f[g>>2]=f[g>>2]|4;g=a+20|0;j=f[g>>2]|0;if(!j){i=L5b(48)|0;GNa(i);f[g>>2]=i;l=i}else l=j;j=f[c+20>>2]|0;i=(j|0)==0?493544:j;if((i|0)==(l|0))jMa(8763);else{HNa(l,i);m=f[d>>2]|0;break}}else m=k;while(0);if(!(m&8))n=m;else{m=b[c+28>>0]|0;k=a+8|0;f[k>>2]=f[k>>2]|8;b[a+28>>0]=m;n=f[d>>2]|0}if(n&16|0){n=b[c+29>>0]|0;d=a+8|0;f[d>>2]=f[d>>2]|16;b[a+29>>0]=n}}n=f[c+4>>2]|0;if(!(n&1))return;LPb(n&-2,a+4|0);return}function IUa(a){a=a|0;var c=0,e=0;c=u;u=u+16|0;e=c;f[a>>2]=116748;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496176?(f[213033]|0)!=2:0){f[e>>2]=135812;f[e+4>>2]=41;b[e+8>>0]=0;Gpb(852132,e);hpb(e)}e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;d[e+16>>1]=0;u=c;return}function JUa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function KUa(a){a=a|0;var b=0,c=0;f[a>>2]=116640;bVa(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function LUa(a){a=a|0;KUa(a);O5b(a);return}function MUa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function NUa(a,b){a=a|0;b=b|0;a=L5b(32)|0;$Ua(a);if(!b)return a|0;aVa(b,a);return a|0}function OUa(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(d&15|0){do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(f[c>>2]&2|0?(d=f[a+20>>2]|0,(d|0)!=497760):0){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);do if(f[c>>2]&4|0?(g=f[a+24>>2]|0,(g|0)!=497760):0){d=g+11|0;if((b[d>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[d>>0]=0;break}}while(0);b[a+28>>0]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function PUa(a){a=a|0;return 1}function QUa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+16|0;k=a+20|0;l=a+24|0;m=a+28|0;n=c+32|0;o=c+12|0;p=c+28|0;q=e+8|0;r=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){s=b[a>>0]|0;t=s&255;if(s<<24>>24>0){f[h>>2]=t;f[c>>2]=a+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=_nb(c,x)|0;f[h>>2]=t;if((t+-1|0)>>>0<127){v=t;w=6}else{y=t;w=39}}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{switch(v|0){case 0:{z=1;w=45;break a;break}case 10:break;default:{A=v;break b}}f[i>>2]=f[i>>2]|1;t=f[j>>2]|0;if((t|0)==497760){jza(j,497760);B=f[j>>2]|0}else B=t;if(!(fqb(c,B)|0)){z=0;w=45;break a}t=f[c>>2]|0;if(t>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[t>>0]|0)!=18)continue a;f[c>>2]=t+1;w=15;break}case 2:{switch(v|0){case 0:{z=1;w=45;break a;break}case 18:{w=15;break}default:{A=v;break b}}break}case 3:{switch(v|0){case 0:{z=1;w=45;break a;break}case 26:{w=22;break}default:{A=v;break b}}break}case 4:{switch(v|0){case 0:{z=1;w=45;break a;break}case 32:break;default:{A=v;break b}}C=f[c>>2]|0;D=f[g>>2]|0;break}default:{y=v;w=39;break b}}if((w|0)==15){w=0;f[i>>2]=f[i>>2]|2;t=f[k>>2]|0;if((t|0)==497760){jza(k,497760);E=f[k>>2]|0}else E=t;if(!(fqb(c,E)|0)){z=0;w=45;break a}t=f[c>>2]|0;if(t>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[t>>0]|0)!=26)continue a;f[c>>2]=t+1;w=22}if((w|0)==22){w=0;f[i>>2]=f[i>>2]|4;t=f[l>>2]|0;if((t|0)==497760){jza(l,497760);F=f[l>>2]|0}else F=t;if(!(fqb(c,F)|0)){z=0;w=45;break a}t=f[c>>2]|0;a=f[g>>2]|0;if(t>>>0>=a>>>0)continue a;if((b[t>>0]|0)!=32)continue a;s=t+1|0;f[c>>2]=s;C=s;D=a}f[i>>2]=f[i>>2]|8;if(C>>>0<D>>>0?(a=b[C>>0]|0,a<<24>>24>-1):0){s=C+1|0;f[c>>2]=s;G=a<<24>>24!=0;H=s;I=D}else{Lnb(e,c);s=e;if(!(b[q>>0]|0)){z=0;w=45;break a}G=(f[s>>2]|0)!=0|(f[s+4>>2]|0)!=0;H=f[c>>2]|0;I=f[g>>2]|0}b[m>>0]=G&1;if((H|0)!=(I|0))continue a;if(f[n>>2]|0){w=38;break a}if((f[o>>2]|0)==(f[p>>2]|0)){w=38;break a}else continue a}while(0);if((w|0)==39){w=0;if(!y){z=1;w=45;break}else A=y}if((A&7|0)==4){z=1;w=45;break}s=f[r>>2]|0;if(!(s&1))J=hBa(r)|0;else J=s&-2;if(!(ZPb(c,A,J)|0)){z=0;w=45;break}}if((w|0)==38){f[h>>2]=0;b[c+24>>0]=1;z=1;u=d;return z|0}else if((w|0)==45){u=d;return z|0}return 0}function RUa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+8|0;d=f[c>>2]|0;if(!(d&15))e=0;else{if(!(d&1)){g=0;h=d}else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;if(j<<24>>24<0){k=f[i+4>>2]|0;if(k>>>0<128){l=1;m=d;n=k}else{i=iob(k)|0;l=i;m=f[c>>2]|0;n=k}}else{l=1;m=d;n=j&255}g=n+1+l|0;h=m}if(!(h&2)){o=g;p=h}else{m=f[a+20>>2]|0;l=b[m+11>>0]|0;if(l<<24>>24<0){n=f[m+4>>2]|0;if(n>>>0<128){q=1;r=h;s=n}else{m=iob(n)|0;q=m;r=f[c>>2]|0;s=n}}else{q=1;r=h;s=l&255}o=g+1+s+q|0;p=r}if(!(p&4)){t=o;u=p}else{r=f[a+24>>2]|0;q=b[r+11>>0]|0;if(q<<24>>24<0){s=f[r+4>>2]|0;if(s>>>0<128){v=1;w=p;x=s}else{r=iob(s)|0;v=r;w=f[c>>2]|0;x=s}}else{v=1;w=p;x=q&255}t=o+1+x+v|0;u=w}e=u&8|0?t+2|0:t}t=f[a+4>>2]|0;if(!(t&1)){y=e;z=a+12|0;f[z>>2]=y;return y|0}y=(dQb(t&-2)|0)+e|0;z=a+12|0;f[z>>2]=y;return y|0}function SUa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{$pb(1,f[a+16>>2]|0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{$pb(2,f[a+20>>2]|0,c);h=f[d>>2]|0}if(!(h&4))i=h;else{$pb(3,f[a+24>>2]|0,c);i=f[d>>2]|0}if(i&8|0)Ypb(4,(b[a+28>>0]|0)!=0,c);i=f[a+4>>2]|0;if(!(i&1))return;aQb(i&-2,c);return}function TUa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function UUa(a){a=a|0;return f[a+12>>2]|0}function VUa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&2)){j=g;k=h}else{h=f[a+20>>2]|0;b[g>>0]=18;i=kob(h,g+1|0)|0;j=i;k=f[c>>2]|0}if(!(k&4)){l=j;m=k}else{k=f[a+24>>2]|0;b[j>>0]=26;i=kob(k,j+1|0)|0;l=i;m=f[c>>2]|0}if(!(m&8))n=l;else{m=b[a+28>>0]|0;b[l>>0]=32;b[l+1>>0]=m;n=l+2|0}l=f[a+4>>2]|0;if(!(l&1)){o=n;return o|0}o=bQb(l&-2,n)|0;return o|0}function WUa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function XUa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(39988);c=T6b(b,23288,19112,0)|0;if(!c){cOb(b,a);return}else{_Ua(a,c);return}}function YUa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function ZUa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213151];f[a+4>>2]=f[213152];u=c;return}function _Ua(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d+4|0;i=d;j=c+8|0;k=f[j>>2]|0;if(k&255|0){if(!(k&1))l=k;else{k=a+8|0;f[k>>2]=f[k>>2]|1;f[g>>2]=f[c+16>>2];f[e>>2]=f[g>>2];Anb(a+16|0,497760,e);l=f[j>>2]|0}if(!(l&2))m=l;else{l=a+8|0;f[l>>2]=f[l>>2]|2;f[h>>2]=f[c+20>>2];f[e>>2]=f[h>>2];Anb(a+20|0,497760,e);m=f[j>>2]|0}if(!(m&4))n=m;else{m=a+8|0;f[m>>2]=f[m>>2]|4;f[i>>2]=f[c+24>>2];f[e>>2]=f[i>>2];Anb(a+24|0,497760,e);n=f[j>>2]|0}if(n&8|0){n=b[c+28>>0]|0;j=a+8|0;f[j>>2]=f[j>>2]|8;b[a+28>>0]=n}}n=f[c+4>>2]|0;if(!(n&1)){u=d;return}LPb(n&-2,a+4|0);u=d;return}function $Ua(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=116640;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=496136?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=497760;f[a+20>>2]=497760;f[a+24>>2]=497760;b[a+28>>0]=0;u=c;return}function aVa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function bVa(a){a=a|0;var c=0,d=0;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+20|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+24|0;a=f[c>>2]|0;if((a|0)==497760|(a|0)==0){f[c>>2]=0;return}if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a);f[c>>2]=0;return}function cVa(a){a=a|0;var b=0,c=0;f[a>>2]=116532;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function dVa(a){a=a|0;var b=0,c=0;f[a>>2]=116532;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function eVa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function fVa(a,b){a=a|0;b=b|0;a=L5b(28)|0;fPa(a);if(!b)return a|0;rVa(b,a);return a|0}function gVa(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){n[a+20>>2]=1.0;n[a+24>>2]=1.0;n[a+16>>2]=0.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function hVa(a){a=a|0;return 1}function iVa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+8>>2]|0;if(!(b&7))c=0;else{d=b&1|0?5:0;e=b&2|0?d+5|0:d;c=b&4|0?e+5|0:e}e=f[a+4>>2]|0;if(!(e&1)){g=c;h=a+12|0;f[h>>2]=g;return g|0}g=(dQb(e&-2)|0)+c|0;h=a+12|0;f[h>>2]=g;return g|0}function jVa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Wpb(1,+n[a+20>>2],b);e=f[c>>2]|0}if(!(e&2))g=e;else{Wpb(2,+n[a+24>>2],b);g=f[c>>2]|0}if(g&4|0)Wpb(3,+n[a+16>>2],b);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,b);return}function kVa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function lVa(a){a=a|0;return f[a+12>>2]|0}function mVa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+20>>2]|0;b[d>>0]=13;i=d+1|0;b[i>>0]=e;b[i+1>>0]=e>>8;b[i+2>>0]=e>>16;b[i+3>>0]=e>>24;g=d+5|0;h=f[c>>2]|0}if(!(h&2)){j=g;k=h}else{h=f[a+24>>2]|0;b[g>>0]=21;d=g+1|0;b[d>>0]=h;b[d+1>>0]=h>>8;b[d+2>>0]=h>>16;b[d+3>>0]=h>>24;j=g+5|0;k=f[c>>2]|0}if(!(k&4))l=j;else{k=f[a+16>>2]|0;b[j>>0]=29;c=j+1|0;b[c>>0]=k;b[c+1>>0]=k>>8;b[c+2>>0]=k>>16;b[c+3>>0]=k>>24;l=j+5|0}j=f[a+4>>2]|0;if(!(j&1)){m=l;return m|0}m=bQb(j&-2,l)|0;return m|0}function nVa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function oVa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((a|0)==(b|0))jMa(39498);c=T6b(b,23288,19128,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+20>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+20>>2]=d;e=f[b>>2]|0}if(!(e&2))h=e;else{e=f[c+24>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+24>>2]=e;h=f[b>>2]|0}if(h&4|0){h=f[c+16>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|4;f[a+16>>2]=h}}h=f[c+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function pVa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function qVa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213149];f[a+4>>2]=f[213150];u=c;return}function rVa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function sVa(a){a=a|0;var b=0,c=0;f[a>>2]=116424;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function tVa(a){a=a|0;var b=0,c=0;f[a>>2]=116424;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function uVa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function vVa(a,b){a=a|0;b=b|0;a=L5b(68)|0;dPa(a);if(!b)return a|0;GVa(b,a);return a|0}function wVa(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(d&255|0){e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[a+60>>2]=1}if(d&7936|0){d=a+44|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;b[d+12>>0]=0;b[a+64>>0]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function xVa(a){a=a|0;return 1}function yVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Zpb(1,f[a+16>>2]|0,c);g=f[d>>2]|0}if(!(g&16))h=g;else{Opb(2,f[a+32>>2]|0,c);h=f[d>>2]|0}if(!(h&128))i=h;else{Opb(3,f[a+60>>2]|0,c);i=f[d>>2]|0}if(!(i&2))j=i;else{Opb(4,f[a+20>>2]|0,c);j=f[d>>2]|0}if(!(j&32))k=j;else{Opb(5,f[a+36>>2]|0,c);k=f[d>>2]|0}if(!(k&64))l=k;else{Opb(6,f[a+40>>2]|0,c);l=f[d>>2]|0}if(!(l&256))m=l;else{Opb(7,f[a+44>>2]|0,c);m=f[d>>2]|0}if(!(m&512))n=m;else{Opb(8,f[a+48>>2]|0,c);n=f[d>>2]|0}if(!(n&4))o=n;else{Opb(9,f[a+24>>2]|0,c);o=f[d>>2]|0}if(!(o&8))p=o;else{Opb(10,f[a+28>>2]|0,c);p=f[d>>2]|0}if(!(p&1024))q=p;else{Zpb(11,f[a+52>>2]|0,c);q=f[d>>2]|0}if(!(q&2048))r=q;else{Ypb(12,(b[a+56>>0]|0)!=0,c);r=f[d>>2]|0}if(r&4096|0)Ypb(13,(b[a+64>>0]|0)!=0,c);r=f[a+4>>2]|0;if(!(r&1))return;aQb(r&-2,c);return}function zVa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function AVa(a){a=a|0;return f[a+12>>2]|0}function BVa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);m=f[c>>2]|0;if(!(m&16)){o=e;p=m}else{m=f[a+32>>2]|0;b[e>>0]=16;n=e+1|0;if(m>>>0>127){e=m;d=n;while(1){b[d>>0]=e|128;j=e>>>7;i=d+1|0;if(e>>>0>16383){e=j;d=i}else{q=i;r=j;break}}}else{q=n;r=m}b[q>>0]=r;o=q+1|0;p=f[c>>2]|0}if(!(p&128)){s=o;t=p}else{p=f[a+60>>2]|0;b[o>>0]=24;q=o+1|0;if(p>>>0>127){o=p;r=q;while(1){b[r>>0]=o|128;m=o>>>7;n=r+1|0;if(o>>>0>16383){o=m;r=n}else{u=n;v=m;break}}}else{u=q;v=p}b[u>>0]=v;s=u+1|0;t=f[c>>2]|0}if(!(t&2)){w=s;x=t}else{t=f[a+20>>2]|0;b[s>>0]=32;u=s+1|0;if(t>>>0>127){s=t;v=u;while(1){b[v>>0]=s|128;p=s>>>7;q=v+1|0;if(s>>>0>16383){s=p;v=q}else{y=q;z=p;break}}}else{y=u;z=t}b[y>>0]=z;w=y+1|0;x=f[c>>2]|0}if(!(x&32)){A=w;B=x}else{x=f[a+36>>2]|0;b[w>>0]=40;y=w+1|0;if(x>>>0>127){w=x;z=y;while(1){b[z>>0]=w|128;t=w>>>7;u=z+1|0;if(w>>>0>16383){w=t;z=u}else{C=u;D=t;break}}}else{C=y;D=x}b[C>>0]=D;A=C+1|0;B=f[c>>2]|0}if(!(B&64)){E=A;F=B}else{B=f[a+40>>2]|0;b[A>>0]=48;C=A+1|0;if(B>>>0>127){A=B;D=C;while(1){b[D>>0]=A|128;x=A>>>7;y=D+1|0;if(A>>>0>16383){A=x;D=y}else{G=y;H=x;break}}}else{G=C;H=B}b[G>>0]=H;E=G+1|0;F=f[c>>2]|0}if(!(F&256)){I=E;J=F}else{F=f[a+44>>2]|0;b[E>>0]=56;G=E+1|0;if(F>>>0>127){E=F;H=G;while(1){b[H>>0]=E|128;B=E>>>7;C=H+1|0;if(E>>>0>16383){E=B;H=C}else{K=C;L=B;break}}}else{K=G;L=F}b[K>>0]=L;I=K+1|0;J=f[c>>2]|0}if(!(J&512)){M=I;N=J}else{J=f[a+48>>2]|0;b[I>>0]=64;K=I+1|0;if(J>>>0>127){I=J;L=K;while(1){b[L>>0]=I|128;F=I>>>7;G=L+1|0;if(I>>>0>16383){I=F;L=G}else{O=G;P=F;break}}}else{O=K;P=J}b[O>>0]=P;M=O+1|0;N=f[c>>2]|0}if(!(N&4)){Q=M;R=N}else{N=f[a+24>>2]|0;b[M>>0]=72;O=M+1|0;if(N>>>0>127){M=N;P=O;while(1){b[P>>0]=M|128;J=M>>>7;K=P+1|0;if(M>>>0>16383){M=J;P=K}else{S=K;T=J;break}}}else{S=O;T=N}b[S>>0]=T;Q=S+1|0;R=f[c>>2]|0}if(!(R&8)){U=Q;V=R}else{R=f[a+28>>2]|0;b[Q>>0]=80;S=Q+1|0;if(R>>>0>127){Q=R;T=S;while(1){b[T>>0]=Q|128;N=Q>>>7;O=T+1|0;if(Q>>>0>16383){Q=N;T=O}else{W=O;X=N;break}}}else{W=S;X=R}b[W>>0]=X;U=W+1|0;V=f[c>>2]|0}do if(!(V&1024))Y=U;else{W=f[a+52>>2]|0;b[U>>0]=88;X=U+1|0;if((W|0)<0){Y=hob(W,((W|0)<0)<<31>>31,X)|0;break}if(W>>>0>127){R=W;S=X;while(1){b[S>>0]=R|128;T=R>>>7;Q=S+1|0;if(R>>>0>16383){R=T;S=Q}else{Z=Q;_=T;break}}}else{Z=X;_=W}b[Z>>0]=_;Y=Z+1|0}while(0);Z=f[c>>2]|0;if(!(Z&2048)){$=Y;aa=Z}else{Z=b[a+56>>0]|0;b[Y>>0]=96;b[Y+1>>0]=Z;$=Y+2|0;aa=f[c>>2]|0}if(!(aa&4096))ba=$;else{aa=b[a+64>>0]|0;b[$>>0]=104;b[$+1>>0]=aa;ba=$+2|0}$=f[a+4>>2]|0;if(!($&1)){ca=ba;return ca|0}ca=bQb($&-2,ba)|0;return ca|0}function CVa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function DVa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(38811);c=T6b(b,23288,19144,0)|0;if(!c){cOb(b,a);return}else{ePa(a,c);return}}function EVa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function FVa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213145];f[a+4>>2]=f[213146];u=c;return}function GVa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function HVa(a){a=a|0;var b=0,c=0;f[a>>2]=116316;if((a|0)!=495984?(b=f[a+16>>2]|0,b|0):0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function IVa(a){a=a|0;HVa(a);O5b(a);return}function JVa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function KVa(a,b){a=a|0;b=b|0;a=L5b(20)|0;YVa(a);if(!b)return a|0;ZVa(b,a);return a|0}function LVa(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;if(((f[b>>2]&1|0?(c=f[a+16>>2]|0,c|0):0)?(f[c+16>>2]=0,f[c+8>>2]=0,d=f[c+4>>2]|0,d&1|0):0)?(c=d&-2,f[c>>2]|0):0)GPb(c);f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function MVa(a){a=a|0;return 1}function NVa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+16|0;k=e+4|0;l=c+32|0;m=c+12|0;n=c+28|0;o=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[h>>2]=q;f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=_nb(c,t)|0;f[h>>2]=q;if((q+-1|0)>>>0<127){r=q;s=6}else v=q}if((s|0)==6){s=0;if((r|0)==10){f[i>>2]=f[i>>2]|1;q=f[j>>2]|0;if(!q){a=L5b(32)|0;fOa(a);f[j>>2]=a;w=a}else w=q;q=f[c>>2]|0;if(q>>>0<(f[g>>2]|0)>>>0?(a=b[q>>0]|0,a<<24>>24>-1):0){f[c>>2]=q+1;x=a&255}else{a=Znb(c)|0;if((a|0)>-1)x=a;else{y=0;s=26;break}}Inb(e,c,x);if((f[k>>2]|0)<0){s=15;break}if(!(GLa(w,c)|0)){s=15;break}if(!(Onb(c,f[e>>2]|0)|0)){y=0;s=26;break}if((f[c>>2]|0)!=(f[g>>2]|0))continue;if(f[l>>2]|0){s=20;break}if((f[m>>2]|0)==(f[n>>2]|0)){s=20;break}else continue}else v=r}if((v|0)==0|(v&7|0)==4){y=1;s=26;break}a=f[o>>2]|0;if(!(a&1))z=hBa(o)|0;else z=a&-2;if(!(ZPb(c,v,z)|0)){y=0;s=26;break}}if((s|0)==15){y=0;u=d;return y|0}else if((s|0)==20){f[h>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((s|0)==26){u=d;return y|0}return 0}function OVa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if(!(f[a+8>>2]&1))b=0;else{c=f[a+16>>2]|0;d=f[c+16>>2]|0;if(d){e=c+24|0;g=0;h=0;do{i=(f[e>>2]|0)+8+(h<<3)|0;g=(job(f[i>>2]|0,f[i+4>>2]|0)|0)+g|0;h=h+1|0}while((h|0)!=(d|0));if(g)if((g|0)>=0)if(g>>>0<128){j=2;k=g}else{j=(iob(g)|0)+1|0;k=g}else{j=11;k=g}else{j=0;k=0}}else{j=0;k=0}f[c+28>>2]=k;g=j+k|0;k=f[c+4>>2]|0;if(!(k&1))l=g;else l=(dQb(k&-2)|0)+g|0;f[c+12>>2]=l;if(l>>>0<128)m=1;else m=iob(l)|0;b=l+1+m|0}m=f[a+4>>2]|0;if(!(m&1)){n=b;o=a+12|0;f[o>>2]=n;return n|0}n=(dQb(m&-2)|0)+b|0;o=a+12|0;f[o>>2]=n;return n|0}function PVa(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)eqb(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function QVa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function RVa(a){a=a|0;return f[a+12>>2]|0}function SVa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=10;g=d+1|0;d=f[c+12>>2]|0;if(d>>>0>127){h=d;i=g;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=g;m=d}b[l>>0]=m;e=li[f[(f[c>>2]|0)+68>>2]&511](c,0,l+1|0)|0}l=f[a+4>>2]|0;if(!(l&1)){n=e;return n|0}n=bQb(l&-2,e)|0;return n|0}function TVa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function UVa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(38027);c=T6b(b,23288,19160,0)|0;if(!c){cOb(b,a);return}else{XVa(a,c);return}}function VVa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function WVa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213143];f[a+4>>2]=f[213144];u=c;return}function XVa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if(f[b+8>>2]&1|0){c=a+8|0;f[c>>2]=f[c>>2]|1;c=a+16|0;d=f[c>>2]|0;if(!d){e=L5b(32)|0;fOa(e);f[c>>2]=e;g=e}else g=d;d=f[b+16>>2]|0;e=(d|0)==0?493e3:d;if((e|0)==(g|0))jMa(2959);d=g+16|0;c=e+16|0;h=f[c>>2]|0;if(h|0){uFa(d,(f[d>>2]|0)+h|0);Vac((f[g+24>>2]|0)+8+(f[d>>2]<<3)|0,(f[e+24>>2]|0)+8|0,f[c>>2]<<3|0)|0;f[d>>2]=(f[d>>2]|0)+(f[c>>2]|0)}c=f[e+4>>2]|0;if(c&1|0)LPb(c&-2,g+4|0)}g=f[b+4>>2]|0;if(!(g&1))return;LPb(g&-2,a+4|0);return}function YVa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=116316;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495984?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=0;u=c;return}function ZVa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function _Va(a){a=a|0;var b=0,c=0;f[a>>2]=116208;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function $Va(a){a=a|0;var b=0,c=0;f[a>>2]=116208;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function aWa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function bWa(a,b){a=a|0;b=b|0;a=L5b(24)|0;cPa(a);if(!b)return a|0;nWa(b,a);return a|0}function cWa(a){a=a|0;var c=0;c=a+8|0;if(f[c>>2]&7|0){b[a+17>>0]=1;b[a+16>>0]=0;n[a+20>>2]=9.999999717180685e-10}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function dWa(a){a=a|0;return 1}function eWa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+8>>2]|0;if(!(b&7))c=0;else{d=b<<1&2;e=b&2|0?d+2|0:d;c=b&4|0?e+5|0:e}e=f[a+4>>2]|0;if(!(e&1)){g=c;h=a+12|0;f[h>>2]=g;return g|0}g=(dQb(e&-2)|0)+c|0;h=a+12|0;f[h>>2]=g;return g|0}function fWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Ypb(1,(b[a+17>>0]|0)!=0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{Ypb(2,(b[a+16>>0]|0)!=0,c);h=f[d>>2]|0}if(h&4|0)Wpb(3,+n[a+20>>2],c);h=f[a+4>>2]|0;if(!(h&1))return;aQb(h&-2,c);return}function gWa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function hWa(a){a=a|0;return f[a+12>>2]|0}function iWa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=b[a+17>>0]|0;b[d>>0]=8;b[d+1>>0]=e;g=d+2|0;h=f[c>>2]|0}if(!(h&2)){i=g;j=h}else{h=b[a+16>>0]|0;b[g>>0]=16;b[g+1>>0]=h;i=g+2|0;j=f[c>>2]|0}if(!(j&4))k=i;else{j=f[a+20>>2]|0;b[i>>0]=29;c=i+1|0;b[c>>0]=j;b[c+1>>0]=j>>8;b[c+2>>0]=j>>16;b[c+3>>0]=j>>24;k=i+5|0}i=f[a+4>>2]|0;if(!(i&1)){l=k;return l|0}l=bQb(i&-2,k)|0;return l|0}function jWa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function kWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((a|0)==(c|0))jMa(37684);d=T6b(c,23288,19176,0)|0;if(!d){cOb(c,a);return}c=d+8|0;e=f[c>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=b[d+17>>0]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;b[a+17>>0]=e;g=f[c>>2]|0}if(!(g&2))i=g;else{g=b[d+16>>0]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;b[a+16>>0]=g;i=f[c>>2]|0}if(i&4|0){i=f[d+20>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|4;f[a+20>>2]=i}}i=f[d+4>>2]|0;if(!(i&1))return;LPb(i&-2,a+4|0);return}function lWa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function mWa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213141];f[a+4>>2]=f[213142];u=c;return}function nWa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function oWa(a){a=a|0;var b=0,c=0;f[a>>2]=116100;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function pWa(a){a=a|0;var b=0,c=0;f[a>>2]=116100;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function qWa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function rWa(a,b){a=a|0;b=b|0;a=L5b(32)|0;aPa(a);if(!b)return a|0;CWa(b,a);return a|0}function sWa(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function tWa(a){a=a|0;return 1}function uWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Opb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{Opb(2,f[a+20>>2]|0,b);g=f[c>>2]|0}if(!(g&4))h=g;else{Opb(3,f[a+24>>2]|0,b);h=f[c>>2]|0}if(h&8|0)Opb(4,f[a+28>>2]|0,b);h=f[a+4>>2]|0;if(!(h&1))return;aQb(h&-2,b);return}function vWa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function wWa(a){a=a|0;return f[a+12>>2]|0}function xWa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=8;i=d+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=e}b[m>>0]=n;g=m+1|0;h=f[c>>2]|0}if(!(h&2)){o=g;p=h}else{h=f[a+20>>2]|0;b[g>>0]=16;m=g+1|0;if(h>>>0>127){g=h;n=m;while(1){b[n>>0]=g|128;e=g>>>7;i=n+1|0;if(g>>>0>16383){g=e;n=i}else{q=i;r=e;break}}}else{q=m;r=h}b[q>>0]=r;o=q+1|0;p=f[c>>2]|0}if(!(p&4)){s=o;t=p}else{p=f[a+24>>2]|0;b[o>>0]=24;q=o+1|0;if(p>>>0>127){o=p;r=q;while(1){b[r>>0]=o|128;h=o>>>7;m=r+1|0;if(o>>>0>16383){o=h;r=m}else{u=m;v=h;break}}}else{u=q;v=p}b[u>>0]=v;s=u+1|0;t=f[c>>2]|0}if(!(t&8))w=s;else{t=f[a+28>>2]|0;b[s>>0]=32;c=s+1|0;if(t>>>0>127){s=t;u=c;while(1){b[u>>0]=s|128;v=s>>>7;p=u+1|0;if(s>>>0>16383){s=v;u=p}else{x=p;y=v;break}}}else{x=c;y=t}b[x>>0]=y;w=x+1|0}x=f[a+4>>2]|0;if(!(x&1)){z=w;return z|0}z=bQb(x&-2,w)|0;return z|0}function yWa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function zWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;if((a|0)==(b|0))jMa(37253);c=T6b(b,23288,19192,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[b>>2]|0}if(!(e&2))h=e;else{e=f[c+20>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+20>>2]=e;h=f[b>>2]|0}if(!(h&4))i=h;else{h=f[c+24>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|4;f[a+24>>2]=h;i=f[b>>2]|0}if(i&8|0){i=f[c+28>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|8;f[a+28>>2]=i}}i=f[c+4>>2]|0;if(!(i&1))return;LPb(i&-2,a+4|0);return}function AWa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function BWa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213139];f[a+4>>2]=f[213140];u=c;return}function CWa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function DWa(a){a=a|0;var b=0,c=0;f[a>>2]=115992;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function EWa(a){a=a|0;var b=0,c=0;f[a>>2]=115992;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function FWa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function GWa(a,b){a=a|0;b=b|0;a=L5b(40)|0;_Oa(a);if(!b)return a|0;RWa(b,a);return a|0}function HWa(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&63|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[a+24>>2]=5;n[a+28>>2]=1.0;n[a+32>>2]=.75;n[a+36>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function IWa(a){a=a|0;return 1}function JWa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Opb(1,f[a+24>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{Wpb(2,+n[a+28>>2],b);g=f[c>>2]|0}if(!(g&4))h=g;else{Wpb(3,+n[a+32>>2],b);h=f[c>>2]|0}if(!(h&8))i=h;else{Zpb(4,f[a+16>>2]|0,b);i=f[c>>2]|0}if(!(i&16))j=i;else{Wpb(5,+n[a+36>>2],b);j=f[c>>2]|0}if(j&32|0)Zpb(6,f[a+20>>2]|0,b);j=f[a+4>>2]|0;if(!(j&1))return;aQb(j&-2,b);return}function KWa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function LWa(a){a=a|0;return f[a+12>>2]|0}function MWa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+24>>2]|0;b[d>>0]=8;i=d+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=e}b[m>>0]=n;g=m+1|0;h=f[c>>2]|0}if(!(h&2)){o=g;p=h}else{h=f[a+28>>2]|0;b[g>>0]=21;m=g+1|0;b[m>>0]=h;b[m+1>>0]=h>>8;b[m+2>>0]=h>>16;b[m+3>>0]=h>>24;o=g+5|0;p=f[c>>2]|0}if(!(p&4)){q=o;r=p}else{p=f[a+32>>2]|0;b[o>>0]=29;g=o+1|0;b[g>>0]=p;b[g+1>>0]=p>>8;b[g+2>>0]=p>>16;b[g+3>>0]=p>>24;q=o+5|0;r=f[c>>2]|0}do if(!(r&8))s=q;else{o=f[a+16>>2]|0;b[q>>0]=32;p=q+1|0;if((o|0)<0){s=hob(o,((o|0)<0)<<31>>31,p)|0;break}if(o>>>0>127){g=o;h=p;while(1){b[h>>0]=g|128;m=g>>>7;n=h+1|0;if(g>>>0>16383){g=m;h=n}else{t=n;u=m;break}}}else{t=p;u=o}b[t>>0]=u;s=t+1|0}while(0);t=f[c>>2]|0;if(!(t&16)){v=s;w=t}else{t=f[a+36>>2]|0;b[s>>0]=45;u=s+1|0;b[u>>0]=t;b[u+1>>0]=t>>8;b[u+2>>0]=t>>16;b[u+3>>0]=t>>24;v=s+5|0;w=f[c>>2]|0}do if(!(w&32))x=v;else{c=f[a+20>>2]|0;b[v>>0]=48;s=v+1|0;if((c|0)<0){x=hob(c,((c|0)<0)<<31>>31,s)|0;break}if(c>>>0>127){t=c;u=s;while(1){b[u>>0]=t|128;q=t>>>7;r=u+1|0;if(t>>>0>16383){t=q;u=r}else{y=r;z=q;break}}}else{y=s;z=c}b[y>>0]=z;x=y+1|0}while(0);y=f[a+4>>2]|0;if(!(y&1)){A=x;return A|0}A=bQb(y&-2,x)|0;return A|0}function NWa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function OWa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(36710);c=T6b(b,23288,19208,0)|0;if(!c){cOb(b,a);return}else{$Oa(a,c);return}}function PWa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function QWa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213135];f[a+4>>2]=f[213136];u=c;return}function RWa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function SWa(a){a=a|0;var b=0,c=0;f[a>>2]=115884;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function TWa(a){a=a|0;var b=0,c=0;f[a>>2]=115884;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function UWa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function VWa(a,b){a=a|0;b=b|0;a=L5b(28)|0;gXa(a);if(!b)return a|0;hXa(b,a);return a|0}function WWa(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){n[a+20>>2]=-1.0;n[a+24>>2]=1.0;n[a+16>>2]=0.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function XWa(a){a=a|0;return 1}function YWa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+20|0;l=a+24|0;m=a+16|0;n=c+32|0;o=c+12|0;p=c+28|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[i>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[i>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=37}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=43;break a;break}case 13:break;default:{z=t;break b}}f[j>>2]=f[j>>2]|1;s=f[g>>2]|0;a=f[c>>2]|0;if((s-a|0)>3){r=a;A=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=A;r=a+4|0;f[c>>2]=r;B=A;C=r;D=s;E=s}else{if(!(Xnb(c,e)|0)){v=12;break a}s=f[g>>2]|0;B=f[e>>2]|0;C=f[c>>2]|0;D=s;E=s}f[k>>2]=B;if(C>>>0>=D>>>0)continue a;if((b[C>>0]|0)!=21)continue a;s=C+1|0;f[c>>2]=s;F=s;G=E;H=D;v=18;break}case 2:{switch(t|0){case 0:{y=1;v=43;break a;break}case 21:break;default:{z=t;break b}}s=f[g>>2]|0;F=f[c>>2]|0;G=s;H=s;v=18;break}case 3:{switch(t|0){case 0:{y=1;v=43;break a;break}case 29:break;default:{z=t;break b}}s=f[g>>2]|0;I=s;J=f[c>>2]|0;K=s;break}default:{x=t;v=37;break b}}if((v|0)==18){v=0;f[j>>2]=f[j>>2]|2;if((G-F|0)>3){s=F;r=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[e>>2]=r;s=F+4|0;f[c>>2]=s;L=r;M=s;N=H;O=G}else{if(!(Xnb(c,e)|0)){v=22;break a}s=f[g>>2]|0;L=f[e>>2]|0;M=f[c>>2]|0;N=s;O=s}f[l>>2]=L;if(M>>>0>=N>>>0)continue a;if((b[M>>0]|0)!=29)continue a;s=M+1|0;f[c>>2]=s;I=N;J=s;K=O}f[j>>2]=f[j>>2]|4;if((K-J|0)>3){s=J;r=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[e>>2]=r;s=J+4|0;f[c>>2]=s;P=r;Q=s;R=I}else{if(!(Xnb(c,e)|0)){v=32;break a}P=f[e>>2]|0;Q=f[c>>2]|0;R=f[g>>2]|0}f[m>>2]=P;if((Q|0)!=(R|0))continue a;if(f[n>>2]|0){v=36;break a}if((f[o>>2]|0)==(f[p>>2]|0)){v=36;break a}else continue a}while(0);if((v|0)==37){v=0;if(!x){y=1;v=43;break}else z=x}if((z&7|0)==4){y=1;v=43;break}s=f[q>>2]|0;if(!(s&1))S=hBa(q)|0;else S=s&-2;if(!(ZPb(c,z,S)|0)){y=0;v=43;break}}if((v|0)==12){y=0;u=d;return y|0}else if((v|0)==22){y=0;u=d;return y|0}else if((v|0)==32){y=0;u=d;return y|0}else if((v|0)==36){f[i>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==43){u=d;return y|0}return 0}function ZWa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+8>>2]|0;if(!(b&7))c=0;else{d=b&1|0?5:0;e=b&2|0?d+5|0:d;c=b&4|0?e+5|0:e}e=f[a+4>>2]|0;if(!(e&1)){g=c;h=a+12|0;f[h>>2]=g;return g|0}g=(dQb(e&-2)|0)+c|0;h=a+12|0;f[h>>2]=g;return g|0}function _Wa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Wpb(1,+n[a+20>>2],b);e=f[c>>2]|0}if(!(e&2))g=e;else{Wpb(2,+n[a+24>>2],b);g=f[c>>2]|0}if(g&4|0)Wpb(3,+n[a+16>>2],b);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,b);return}function $Wa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function aXa(a){a=a|0;return f[a+12>>2]|0}function bXa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+20>>2]|0;b[d>>0]=13;i=d+1|0;b[i>>0]=e;b[i+1>>0]=e>>8;b[i+2>>0]=e>>16;b[i+3>>0]=e>>24;g=d+5|0;h=f[c>>2]|0}if(!(h&2)){j=g;k=h}else{h=f[a+24>>2]|0;b[g>>0]=21;d=g+1|0;b[d>>0]=h;b[d+1>>0]=h>>8;b[d+2>>0]=h>>16;b[d+3>>0]=h>>24;j=g+5|0;k=f[c>>2]|0}if(!(k&4))l=j;else{k=f[a+16>>2]|0;b[j>>0]=29;c=j+1|0;b[c>>0]=k;b[c+1>>0]=k>>8;b[c+2>>0]=k>>16;b[c+3>>0]=k>>24;l=j+5|0}j=f[a+4>>2]|0;if(!(j&1)){m=l;return m|0}m=bQb(j&-2,l)|0;return m|0}function cXa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function dXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((a|0)==(b|0))jMa(36127);c=T6b(b,23288,19224,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+20>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+20>>2]=d;e=f[b>>2]|0}if(!(e&2))h=e;else{e=f[c+24>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+24>>2]=e;h=f[b>>2]|0}if(h&4|0){h=f[c+16>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|4;f[a+16>>2]=h}}h=f[c+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function eXa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function fXa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213133];f[a+4>>2]=f[213134];u=c;return}function gXa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=115884;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495824?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;n[a+16>>2]=0.0;n[a+20>>2]=-1.0;n[a+24>>2]=1.0;u=c;return}function hXa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function iXa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=115776;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(h);f[b>>2]=0;return}function jXa(a){a=a|0;iXa(a);O5b(a);return}function kXa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function lXa(a,b){a=a|0;b=b|0;a=L5b(32)|0;yXa(a);if(!b)return a|0;zXa(b,a);return a|0}function mXa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function nXa(a){a=a|0;return 1}function oXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=c+4|0;e=c+20|0;g=c+44|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=c+32|0;m=c+12|0;n=c+28|0;o=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[e>>2]=q;f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=_nb(c,t)|0;f[e>>2]=q;if((q+-1|0)>>>0<127){r=q;s=6}else u=q}if((s|0)==6){s=0;if((r|0)==10){q=f[g>>2]|0;f[g>>2]=q+-1;if((q|0)<=0){v=0;s=29;break}while(1){q=f[i>>2]|0;do if(q){a=f[k>>2]|0;p=f[q>>2]|0;if((a|0)>=(p|0))if((p|0)==(f[j>>2]|0)){w=p;s=13;break}else{x=p;y=q;s=14;break}else{f[k>>2]=a+1;z=f[q+4+(a<<2)>>2]|0;break}}else{w=f[j>>2]|0;s=13}while(0);if((s|0)==13){s=0;cpb(h,w+1|0);q=f[i>>2]|0;x=f[q>>2]|0;y=q;s=14}if((s|0)==14){s=0;f[y>>2]=x+1;q=vPa(0,f[h>>2]|0)|0;a=f[i>>2]|0;p=f[k>>2]|0;f[k>>2]=p+1;f[a+4+(p<<2)>>2]=q;z=q}q=Jnb(c)|0;if(!(GLa(z,c)|0)){v=0;s=29;break a}if(!(Pnb(c,q)|0)){v=0;s=29;break a}A=f[c>>2]|0;B=f[d>>2]|0;if(A>>>0>=B>>>0)break;if((b[A>>0]|0)!=10)break;f[c>>2]=A+1}f[g>>2]=(f[g>>2]|0)+1;if((A|0)!=(B|0))continue;if(f[l>>2]|0){s=23;break}if((f[m>>2]|0)==(f[n>>2]|0)){s=23;break}else continue}else u=r}if((u|0)==0|(u&7|0)==4){v=1;s=29;break}q=f[o>>2]|0;if(!(q&1))C=hBa(o)|0;else C=q&-2;if(!(ZPb(c,u,C)|0)){v=0;s=29;break}}if((s|0)==23){f[e>>2]=0;b[c+24>>0]=1;v=1;return v|0}else if((s|0)==29)return v|0;return 0}function pXa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=f[a+20>>2]|0;if(!b)c=0;else{d=a+28|0;e=0;g=b;while(1){h=f[(f[d>>2]|0)+4+(e<<2)>>2]|0;i=f[h+16>>2]|0;if(i){j=h+24|0;k=0;l=0;do{m=(f[j>>2]|0)+8+(l<<3)|0;k=(job(f[m>>2]|0,f[m+4>>2]|0)|0)+k|0;l=l+1|0}while((l|0)!=(i|0));if(k)if((k|0)>=0)if(k>>>0<128){n=2;o=k}else{n=(iob(k)|0)+1|0;o=k}else{n=11;o=k}else{n=0;o=0}}else{n=0;o=0}f[h+28>>2]=o;i=n+o|0;l=f[h+4>>2]|0;if(!(l&1))p=i;else p=(dQb(l&-2)|0)+i|0;f[h+12>>2]=p;if(p>>>0<128)q=1;else q=iob(p)|0;i=p+g+q|0;e=e+1|0;if((e|0)==(b|0)){c=i;break}else g=i}}g=f[a+4>>2]|0;if(!(g&1)){r=c;s=a+12|0;f[s>>2]=r;return r|0}r=(dQb(g&-2)|0)+c|0;s=a+12|0;f[s>>2]=r;return r|0}function qXa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eqb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function rXa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function sXa(a){a=a|0;return f[a+12>>2]|0}function tXa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+20>>2]|0;if(!c)e=d;else{g=a+28|0;h=0;i=d;while(1){d=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=10;j=i+1|0;k=f[d+12>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=j;q=k}b[p>>0]=q;m=li[f[(f[d>>2]|0)+68>>2]&511](d,0,p+1|0)|0;h=h+1|0;if((h|0)==(c|0)){e=m;break}else i=m}}i=f[a+4>>2]|0;if(!(i&1)){r=e;return r|0}r=bQb(i&-2,e)|0;return r|0}function uXa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function vXa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(35778);c=T6b(b,23288,19240,0)|0;if(!c){cOb(b,a);return}tPa(a+16|0,c+16|0);b=f[c+4>>2]|0;if(!(b&1))return;LPb(b&-2,a+4|0);return}function wXa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function xXa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213131];f[a+4>>2]=f[213132];u=c;return}function yXa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=115776;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=495784?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;u=c;return}function zXa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function AXa(a){a=a|0;var b=0,c=0;f[a>>2]=115668;if((a|0)!=495736){b=f[a+16>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+20>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function BXa(a){a=a|0;AXa(a);O5b(a);return}function CXa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function DXa(a,b){a=a|0;b=b|0;a=L5b(36)|0;YOa(a);if(!b)return a|0;NXa(b,a);return a|0}function EXa(a){a=a|0;return 1}function FXa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Opb(1,f[a+24>>2]|0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{Ypb(2,(b[a+29>>0]|0)!=0,c);h=f[d>>2]|0}if(!(h&4))i=h;else{eqb(3,f[a+16>>2]|0,c);i=f[d>>2]|0}if(!(i&8))j=i;else{eqb(4,f[a+20>>2]|0,c);j=f[d>>2]|0}if(!(j&16))k=j;else{Mpb(5,f[a+32>>2]|0,c);k=f[d>>2]|0}if(k&32|0)Ypb(6,(b[a+28>>0]|0)!=0,c);k=f[a+4>>2]|0;if(!(k&1))return;aQb(k&-2,c);return}function GXa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function HXa(a){a=a|0;return f[a+12>>2]|0}function IXa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+24>>2]|0;b[d>>0]=8;i=d+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=e}b[m>>0]=n;g=m+1|0;h=f[c>>2]|0}if(!(h&2)){o=g;p=h}else{h=b[a+29>>0]|0;b[g>>0]=16;b[g+1>>0]=h;o=g+2|0;p=f[c>>2]|0}if(!(p&4)){q=o;r=p}else{p=f[a+16>>2]|0;b[o>>0]=26;g=o+1|0;o=f[p+12>>2]|0;if(o>>>0>127){h=o;m=g;while(1){b[m>>0]=h|128;n=h>>>7;e=m+1|0;if(h>>>0>16383){h=n;m=e}else{s=e;t=n;break}}}else{s=g;t=o}b[s>>0]=t;t=li[f[(f[p>>2]|0)+68>>2]&511](p,0,s+1|0)|0;q=t;r=f[c>>2]|0}if(!(r&8)){u=q;v=r}else{r=f[a+20>>2]|0;b[q>>0]=34;t=q+1|0;q=f[r+12>>2]|0;if(q>>>0>127){s=q;p=t;while(1){b[p>>0]=s|128;o=s>>>7;g=p+1|0;if(s>>>0>16383){s=o;p=g}else{w=g;x=o;break}}}else{w=t;x=q}b[w>>0]=x;x=li[f[(f[r>>2]|0)+68>>2]&511](r,0,w+1|0)|0;u=x;v=f[c>>2]|0}do if(!(v&16))y=u;else{x=f[a+32>>2]|0;b[u>>0]=40;w=u+1|0;if((x|0)<0){y=hob(x,((x|0)<0)<<31>>31,w)|0;break}if(x>>>0>127){r=x;q=w;while(1){b[q>>0]=r|128;t=r>>>7;p=q+1|0;if(r>>>0>16383){r=t;q=p}else{z=p;A=t;break}}}else{z=w;A=x}b[z>>0]=A;y=z+1|0}while(0);if(!(f[c>>2]&32))B=y;else{c=b[a+28>>0]|0;b[y>>0]=48;b[y+1>>0]=c;B=y+2|0}y=f[a+4>>2]|0;if(!(y&1)){C=B;return C|0}C=bQb(y&-2,B)|0;return C|0}function JXa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function KXa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(35309);c=T6b(b,23288,19256,0)|0;if(!c){cOb(b,a);return}else{ZOa(a,c);return}}function LXa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function MXa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213129];f[a+4>>2]=f[213130];u=c;return}function NXa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function OXa(a){a=a|0;var c=0,d=0;f[a>>2]=115560;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(d);f[c>>2]=0;return}function PXa(a){a=a|0;OXa(a);O5b(a);return}function QXa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function RXa(a,b){a=a|0;b=b|0;a=L5b(20)|0;XOa(a);if(!b)return a|0;bYa(b,a);return a|0}function SXa(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0?(d=f[a+16>>2]|0,(d|0)!=497760):0){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function TXa(a){a=a|0;return 1}function UXa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if(!(f[a+8>>2]&1))c=0;else{d=f[a+16>>2]|0;e=b[d+11>>0]|0;if(e<<24>>24<0){g=f[d+4>>2]|0;if(g>>>0<128){h=1;i=g}else{h=iob(g)|0;i=g}}else{h=1;i=e&255}c=i+1+h|0}h=f[a+4>>2]|0;if(!(h&1)){j=c;k=a+12|0;f[k>>2]=j;return j|0}j=(dQb(h&-2)|0)+c|0;k=a+12|0;f[k>>2]=j;return j|0}function VXa(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)$pb(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function WXa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function XXa(a){a=a|0;return f[a+12>>2]|0}function YXa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=10;e=kob(c,d+1|0)|0}d=f[a+4>>2]|0;if(!(d&1)){g=e;return g|0}g=bQb(d&-2,e)|0;return g|0}function ZXa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function _Xa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c+4|0;e=c;if((a|0)==(b|0))jMa(34791);g=T6b(b,23288,19272,0)|0;if(!g){cOb(b,a);u=c;return}if(f[g+8>>2]&1|0){b=a+8|0;f[b>>2]=f[b>>2]|1;f[e>>2]=f[g+16>>2];f[d>>2]=f[e>>2];Anb(a+16|0,497760,d)}d=f[g+4>>2]|0;if(d&1|0)LPb(d&-2,a+4|0);u=c;return}function $Xa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function aYa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213127];f[a+4>>2]=f[213128];u=c;return}function bYa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function cYa(a){a=a|0;var b=0,c=0;f[a>>2]=115452;qYa(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function dYa(a){a=a|0;cYa(a);O5b(a);return}function eYa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function fYa(a,b){a=a|0;b=b|0;a=L5b(60)|0;VOa(a);if(!b)return a|0;pYa(b,a);return a|0}function gYa(a){a=a|0;return 1}function hYa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{$pb(1,f[a+16>>2]|0,c);g=f[d>>2]|0}if(!(g&128))h=g;else{Wpb(2,+n[a+48>>2],c);h=f[d>>2]|0}if(!(h&256))i=h;else{$pb(3,f[a+20>>2]|0,c);i=f[d>>2]|0}if(!(i&2))j=i;else{Opb(4,f[a+52>>2]|0,c);j=f[d>>2]|0}if(!(j&512))k=j;else{Opb(5,f[a+44>>2]|0,c);k=f[d>>2]|0}if(!(k&1024))l=k;else{Ypb(6,(b[a+41>>0]|0)!=0,c);l=f[d>>2]|0}if(!(l&4))m=l;else{Opb(7,f[a+28>>2]|0,c);m=f[d>>2]|0}if(!(m&8))o=m;else{Ypb(8,(b[a+40>>0]|0)!=0,c);o=f[d>>2]|0}if(!(o&16))p=o;else{Opb(9,f[a+32>>2]|0,c);p=f[d>>2]|0}if(!(p&32))q=p;else{Opb(10,f[a+36>>2]|0,c);q=f[d>>2]|0}if(!(q&64))r=q;else{Ypb(11,(b[a+56>>0]|0)!=0,c);r=f[d>>2]|0}if(r&2048|0)$pb(12,f[a+24>>2]|0,c);r=f[a+4>>2]|0;if(!(r&1))return;aQb(r&-2,c);return}function iYa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function jYa(a){a=a|0;return f[a+12>>2]|0}function kYa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&128)){j=g;k=h}else{h=f[a+48>>2]|0;b[g>>0]=21;i=g+1|0;b[i>>0]=h;b[i+1>>0]=h>>8;b[i+2>>0]=h>>16;b[i+3>>0]=h>>24;j=g+5|0;k=f[c>>2]|0}if(!(k&256)){l=j;m=k}else{k=f[a+20>>2]|0;b[j>>0]=26;g=kob(k,j+1|0)|0;l=g;m=f[c>>2]|0}if(!(m&2)){n=l;o=m}else{m=f[a+52>>2]|0;b[l>>0]=32;g=l+1|0;if(m>>>0>127){l=m;j=g;while(1){b[j>>0]=l|128;k=l>>>7;h=j+1|0;if(l>>>0>16383){l=k;j=h}else{p=h;q=k;break}}}else{p=g;q=m}b[p>>0]=q;n=p+1|0;o=f[c>>2]|0}if(!(o&512)){r=n;s=o}else{o=f[a+44>>2]|0;b[n>>0]=40;p=n+1|0;if(o>>>0>127){n=o;q=p;while(1){b[q>>0]=n|128;m=n>>>7;g=q+1|0;if(n>>>0>16383){n=m;q=g}else{t=g;u=m;break}}}else{t=p;u=o}b[t>>0]=u;r=t+1|0;s=f[c>>2]|0}if(!(s&1024)){v=r;w=s}else{s=b[a+41>>0]|0;b[r>>0]=48;b[r+1>>0]=s;v=r+2|0;w=f[c>>2]|0}if(!(w&4)){x=v;y=w}else{w=f[a+28>>2]|0;b[v>>0]=56;r=v+1|0;if(w>>>0>127){v=w;s=r;while(1){b[s>>0]=v|128;t=v>>>7;u=s+1|0;if(v>>>0>16383){v=t;s=u}else{z=u;A=t;break}}}else{z=r;A=w}b[z>>0]=A;x=z+1|0;y=f[c>>2]|0}if(!(y&8)){B=x;C=y}else{y=b[a+40>>0]|0;b[x>>0]=64;b[x+1>>0]=y;B=x+2|0;C=f[c>>2]|0}if(!(C&16)){D=B;E=C}else{C=f[a+32>>2]|0;b[B>>0]=72;x=B+1|0;if(C>>>0>127){B=C;y=x;while(1){b[y>>0]=B|128;z=B>>>7;A=y+1|0;if(B>>>0>16383){B=z;y=A}else{F=A;G=z;break}}}else{F=x;G=C}b[F>>0]=G;D=F+1|0;E=f[c>>2]|0}if(!(E&32)){H=D;I=E}else{E=f[a+36>>2]|0;b[D>>0]=80;F=D+1|0;if(E>>>0>127){D=E;G=F;while(1){b[G>>0]=D|128;C=D>>>7;x=G+1|0;if(D>>>0>16383){D=C;G=x}else{J=x;K=C;break}}}else{J=F;K=E}b[J>>0]=K;H=J+1|0;I=f[c>>2]|0}if(!(I&64)){L=H;M=I}else{I=b[a+56>>0]|0;b[H>>0]=88;b[H+1>>0]=I;L=H+2|0;M=f[c>>2]|0}if(!(M&2048))N=L;else{M=f[a+24>>2]|0;b[L>>0]=98;N=kob(M,L+1|0)|0}L=f[a+4>>2]|0;if(!(L&1)){O=N;return O|0}O=bQb(L&-2,N)|0;return O|0}function lYa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function mYa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(34093);c=T6b(b,23288,19288,0)|0;if(!c){cOb(b,a);return}else{WOa(a,c);return}}function nYa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function oYa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213125];f[a+4>>2]=f[213126];u=c;return}function pYa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function qYa(a){a=a|0;var c=0,d=0;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+20|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+24|0;a=f[c>>2]|0;if((a|0)==497760|(a|0)==0){f[c>>2]=0;return}if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a);f[c>>2]=0;return}function rYa(a){a=a|0;var b=0,c=0;f[a>>2]=115344;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function sYa(a){a=a|0;var b=0,c=0;f[a>>2]=115344;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function tYa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function uYa(a,b){a=a|0;b=b|0;a=L5b(20)|0;UOa(a);if(!b)return a|0;GYa(b,a);return a|0}function vYa(a){a=a|0;var b=0;f[a+16>>2]=1;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function wYa(a){a=a|0;return 1}function xYa(a){a=a|0;var b=0,c=0,d=0,e=0;if(f[a+8>>2]&1){b=f[a+16>>2]|0;if((b|0)>=0)if(b>>>0<128)c=2;else c=(iob(b)|0)+1|0;else c=11}else c=0;b=f[a+4>>2]|0;if(!(b&1)){d=c;e=a+12|0;f[e>>2]=d;return d|0}d=(dQb(b&-2)|0)+c|0;e=a+12|0;f[e>>2]=d;return d|0}function yYa(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)Zpb(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function zYa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function AYa(a){a=a|0;return f[a+12>>2]|0}function BYa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;do if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=8;g=d+1|0;if((c|0)<0){e=hob(c,((c|0)<0)<<31>>31,g)|0;break}if(c>>>0>127){h=c;i=g;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=g;m=c}b[l>>0]=m;e=l+1|0}while(0);l=f[a+4>>2]|0;if(!(l&1)){n=e;return n|0}n=bQb(l&-2,e)|0;return n|0}function CYa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function DYa(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))jMa(33368);c=T6b(b,23288,19304,0)|0;if(!c){cOb(b,a);return}if(f[c+8>>2]&1|0){b=f[c+16>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|1;f[a+16>>2]=b}b=f[c+4>>2]|0;if(!(b&1))return;LPb(b&-2,a+4|0);return}function EYa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function FYa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213122];f[a+4>>2]=f[213123];u=c;return}function GYa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function HYa(a){a=a|0;var c=0,d=0;f[a>>2]=115236;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(d);f[c>>2]=0;return}function IYa(a){a=a|0;HYa(a);O5b(a);return}function JYa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function KYa(a,b){a=a|0;b=b|0;a=L5b(20)|0;cOa(a);if(!b)return a|0;WYa(b,a);return a|0}function LYa(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;do if(f[c>>2]&1|0?(d=f[a+16>>2]|0,(d|0)!=497760):0){e=d+11|0;if((b[e>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[e>>0]=0;break}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function MYa(a){a=a|0;return 1}function NYa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if(!(f[a+8>>2]&1))c=0;else{d=f[a+16>>2]|0;e=b[d+11>>0]|0;if(e<<24>>24<0){g=f[d+4>>2]|0;if(g>>>0<128){h=1;i=g}else{h=iob(g)|0;i=g}}else{h=1;i=e&255}c=i+1+h|0}h=f[a+4>>2]|0;if(!(h&1)){j=c;k=a+12|0;f[k>>2]=j;return j|0}j=(dQb(h&-2)|0)+c|0;k=a+12|0;f[k>>2]=j;return j|0}function OYa(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)$pb(1,f[a+16>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function PYa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function QYa(a){a=a|0;return f[a+12>>2]|0}function RYa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=10;e=kob(c,d+1|0)|0}d=f[a+4>>2]|0;if(!(d&1)){g=e;return g|0}g=bQb(d&-2,e)|0;return g|0}function SYa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function TYa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c+4|0;e=c;if((a|0)==(b|0))jMa(33031);g=T6b(b,23288,19320,0)|0;if(!g){cOb(b,a);u=c;return}if(f[g+8>>2]&1|0){b=a+8|0;f[b>>2]=f[b>>2]|1;f[e>>2]=f[g+16>>2];f[d>>2]=f[e>>2];Anb(a+16|0,497760,d)}d=f[g+4>>2]|0;if(d&1|0)LPb(d&-2,a+4|0);u=c;return}function UYa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function VYa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213120];f[a+4>>2]=f[213121];u=c;return}function WYa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function XYa(a){a=a|0;var c=0,d=0;f[a>>2]=115128;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(d);f[c>>2]=0;return}function YYa(a){a=a|0;XYa(a);O5b(a);return}function ZYa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function _Ya(a,b){a=a|0;b=b|0;a=L5b(28)|0;SOa(a);if(!b)return a|0;jZa(b,a);return a|0}function $Ya(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if((d&7|0?(e=a+20|0,f[e>>2]=0,b[e+4>>0]=0,d&1|0):0)?(e=f[a+16>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function aZa(a){a=a|0;return 1}function bZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{$pb(1,f[a+16>>2]|0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{Opb(2,f[a+20>>2]|0,c);h=f[d>>2]|0}if(h&4|0)Ypb(3,(b[a+24>>0]|0)!=0,c);h=f[a+4>>2]|0;if(!(h&1))return;aQb(h&-2,c);return}function cZa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function dZa(a){a=a|0;return f[a+12>>2]|0}function eZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&2)){j=g;k=h}else{h=f[a+20>>2]|0;b[g>>0]=16;i=g+1|0;if(h>>>0>127){g=h;d=i;while(1){b[d>>0]=g|128;e=g>>>7;l=d+1|0;if(g>>>0>16383){g=e;d=l}else{m=l;n=e;break}}}else{m=i;n=h}b[m>>0]=n;j=m+1|0;k=f[c>>2]|0}if(!(k&4))o=j;else{k=b[a+24>>0]|0;b[j>>0]=24;b[j+1>>0]=k;o=j+2|0}j=f[a+4>>2]|0;if(!(j&1)){p=o;return p|0}p=bQb(j&-2,o)|0;return p|0}function fZa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function gZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+4|0;g=d;if((a|0)==(c|0))jMa(32649);h=T6b(c,23288,19336,0)|0;if(!h){cOb(c,a);u=d;return}c=h+8|0;i=f[c>>2]|0;if(i&255|0){if(!(i&1))j=i;else{i=a+8|0;f[i>>2]=f[i>>2]|1;f[g>>2]=f[h+16>>2];f[e>>2]=f[g>>2];Anb(a+16|0,497760,e);j=f[c>>2]|0}if(!(j&2))k=j;else{j=f[h+20>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;f[a+20>>2]=j;k=f[c>>2]|0}if(k&4|0){k=b[h+24>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|4;b[a+24>>0]=k}}k=f[h+4>>2]|0;if(k&1|0)LPb(k&-2,a+4|0);u=d;return}function hZa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function iZa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213118];f[a+4>>2]=f[213119];u=c;return}function jZa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function kZa(a){a=a|0;var b=0,c=0;f[a>>2]=115020;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function lZa(a){a=a|0;var b=0,c=0;f[a>>2]=115020;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function mZa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function nZa(a,b){a=a|0;b=b|0;a=L5b(24)|0;AZa(a);if(!b)return a|0;BZa(b,a);return a|0}function oZa(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&3|0){f[a+16>>2]=1;f[a+20>>2]=-1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function pZa(a){a=a|0;return 1}function qZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+16|0;i=a+20|0;j=c+32|0;k=c+12|0;l=c+28|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[e>>2]=o;f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=_nb(c,r)|0;f[e>>2]=o;if((o+-1|0)>>>0<127){p=o;q=6}else{s=o;q=27}}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{switch(p|0){case 0:{t=1;q=33;break a;break}case 8:break;default:{u=p;break b}}f[g>>2]=f[g>>2]|1;o=f[c>>2]|0;a=f[d>>2]|0;if(o>>>0<a>>>0){n=b[o>>0]|0;v=n&255;if(n<<24>>24>-1){n=o+1|0;f[c>>2]=n;w=v;x=n;y=a}else{z=v;q=11}}else{z=0;q=11}if((q|0)==11){q=0;v=Knb(c,z)|0;a=J;if(!((a|0)>-1|(a|0)==-1&v>>>0>4294967295)){t=0;q=33;break a}w=v;x=f[c>>2]|0;y=f[d>>2]|0}f[h>>2]=w;if(x>>>0>=y>>>0)continue a;if((b[x>>0]|0)!=16)continue a;v=x+1|0;f[c>>2]=v;A=v;B=y;break}case 2:{switch(p|0){case 0:{t=1;q=33;break a;break}case 16:break;default:{u=p;break b}}A=f[c>>2]|0;B=f[d>>2]|0;break}default:{s=p;q=27;break b}}f[g>>2]=f[g>>2]|2;if(A>>>0<B>>>0){v=b[A>>0]|0;a=v&255;if(v<<24>>24>-1){v=A+1|0;f[c>>2]=v;C=a;D=v;E=B}else{F=a;q=21}}else{F=0;q=21}if((q|0)==21){q=0;a=Knb(c,F)|0;v=J;if(!((v|0)>-1|(v|0)==-1&a>>>0>4294967295)){t=0;q=33;break a}C=a;D=f[c>>2]|0;E=f[d>>2]|0}f[i>>2]=C;if((D|0)!=(E|0))continue a;if(f[j>>2]|0){q=26;break a}if((f[k>>2]|0)==(f[l>>2]|0)){q=26;break a}else continue a}while(0);if((q|0)==27){q=0;if(!s){t=1;q=33;break}else u=s}if((u&7|0)==4){t=1;q=33;break}a=f[m>>2]|0;if(!(a&1))G=hBa(m)|0;else G=a&-2;if(!(ZPb(c,u,G)|0)){t=0;q=33;break}}if((q|0)==26){f[e>>2]=0;b[c+24>>0]=1;t=1;return t|0}else if((q|0)==33)return t|0;return 0}function rZa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+8|0;c=f[b>>2]|0;if(c&3){if(c&1){d=f[a+16>>2]|0;if((d|0)>=0)if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}else{e=11;g=c}}else{e=0;g=c}if(!(g&2))i=e;else{g=f[a+20>>2]|0;if((g|0)>=0)if(g>>>0<128)j=2;else j=(iob(g)|0)+1|0;else j=11;i=j+e|0}}else i=0;e=f[a+4>>2]|0;if(!(e&1)){k=i;l=a+12|0;f[l>>2]=k;return k|0}k=(dQb(e&-2)|0)+i|0;l=a+12|0;f[l>>2]=k;return k|0}function sZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Mpb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(e&2|0)Mpb(2,f[a+20>>2]|0,b);e=f[a+4>>2]|0;if(!(e&1))return;aQb(e&-2,b);return}function tZa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function uZa(a){a=a|0;return f[a+12>>2]|0}function vZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);do if(!(f[c>>2]&2))o=e;else{m=f[a+20>>2]|0;b[e>>0]=16;n=e+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){d=m;j=n;while(1){b[j>>0]=d|128;i=d>>>7;k=j+1|0;if(d>>>0>16383){d=i;j=k}else{p=k;q=i;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}while(0);p=f[a+4>>2]|0;if(!(p&1)){r=o;return r|0}r=bQb(p&-2,o)|0;return r|0}function wZa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function xZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))jMa(32235);c=T6b(b,23288,19352,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[b>>2]|0}if(e&2|0){e=f[c+20>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|2;f[a+20>>2]=e}}e=f[c+4>>2]|0;if(!(e&1))return;LPb(e&-2,a+4|0);return}function yZa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function zZa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213116];f[a+4>>2]=f[213117];u=c;return}function AZa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=115020;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495496?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=1;f[a+20>>2]=-1;u=c;return}function BZa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function CZa(a){a=a|0;var b=0,c=0;f[a>>2]=114912;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function DZa(a){a=a|0;var b=0,c=0;f[a>>2]=114912;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function EZa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function FZa(a,b){a=a|0;b=b|0;a=L5b(28)|0;ROa(a);if(!b)return a|0;RZa(b,a);return a|0}function GZa(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){n[a+20>>2]=-1.0;n[a+24>>2]=1.0;n[a+16>>2]=0.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function HZa(a){a=a|0;return 1}function IZa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+8>>2]|0;if(!(b&7))c=0;else{d=b&1|0?5:0;e=b&2|0?d+5|0:d;c=b&4|0?e+5|0:e}e=f[a+4>>2]|0;if(!(e&1)){g=c;h=a+12|0;f[h>>2]=g;return g|0}g=(dQb(e&-2)|0)+c|0;h=a+12|0;f[h>>2]=g;return g|0}function JZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Wpb(1,+n[a+20>>2],b);e=f[c>>2]|0}if(!(e&2))g=e;else{Wpb(2,+n[a+24>>2],b);g=f[c>>2]|0}if(g&4|0)Wpb(3,+n[a+16>>2],b);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,b);return}function KZa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function LZa(a){a=a|0;return f[a+12>>2]|0}function MZa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+20>>2]|0;b[d>>0]=13;i=d+1|0;b[i>>0]=e;b[i+1>>0]=e>>8;b[i+2>>0]=e>>16;b[i+3>>0]=e>>24;g=d+5|0;h=f[c>>2]|0}if(!(h&2)){j=g;k=h}else{h=f[a+24>>2]|0;b[g>>0]=21;d=g+1|0;b[d>>0]=h;b[d+1>>0]=h>>8;b[d+2>>0]=h>>16;b[d+3>>0]=h>>24;j=g+5|0;k=f[c>>2]|0}if(!(k&4))l=j;else{k=f[a+16>>2]|0;b[j>>0]=29;c=j+1|0;b[c>>0]=k;b[c+1>>0]=k>>8;b[c+2>>0]=k>>16;b[c+3>>0]=k>>24;l=j+5|0}j=f[a+4>>2]|0;if(!(j&1)){m=l;return m|0}m=bQb(j&-2,l)|0;return m|0}function NZa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function OZa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((a|0)==(b|0))jMa(31861);c=T6b(b,23288,19368,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+20>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+20>>2]=d;e=f[b>>2]|0}if(!(e&2))h=e;else{e=f[c+24>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+24>>2]=e;h=f[b>>2]|0}if(h&4|0){h=f[c+16>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|4;f[a+16>>2]=h}}h=f[c+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function PZa(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function QZa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213114];f[a+4>>2]=f[213115];u=c;return}function RZa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function SZa(a){a=a|0;var b=0,c=0;f[a>>2]=114804;if((a|0)!=495408){b=f[a+16>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+20>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function TZa(a){a=a|0;SZa(a);O5b(a);return}function UZa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function VZa(a,b){a=a|0;b=b|0;a=L5b(36)|0;h_a(a);if(!b)return a|0;i_a(b,a);return a|0}function WZa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(d&31|0){e=a+24|0;f[e>>2]=0;f[e+4>>2]=0;b[a+32>>0]=1;if(d&8|0?(d=f[a+16>>2]|0,d|0):0){e=d+8|0;g=f[e>>2]|0;if(g&255|0){h=d+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if(g&1|0?(g=f[213028]|0,h=f[d+16>>2]|0,(h|0)!=(g|0)):0)_5b(h,g)|0;n[d+40>>2]=1.0;n[d+44>>2]=1.0;f[d+36>>2]=-1}f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)GPb(d)}if(f[c>>2]&16|0?(d=f[a+20>>2]|0,d|0):0){e=d+8|0;g=f[e>>2]|0;if(g&255|0){h=d+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if(g&1|0?(g=f[213028]|0,h=f[d+16>>2]|0,(h|0)!=(g|0)):0)_5b(h,g)|0;n[d+40>>2]=1.0;n[d+44>>2]=1.0;f[d+36>>2]=-1}f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)GPb(d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function XZa(a){a=a|0;return 1}function YZa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+24|0;k=a+28|0;l=a+32|0;m=e+8|0;n=a+16|0;o=e+4|0;p=a+20|0;q=e+4|0;r=c+32|0;s=c+12|0;t=c+28|0;v=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){w=b[a>>0]|0;x=w&255;if(w<<24>>24>0){f[h>>2]=x;f[c>>2]=a+1;y=x;z=6}else{A=x;z=5}}else{A=0;z=5}if((z|0)==5){z=0;x=_nb(c,A)|0;f[h>>2]=x;if((x+-1|0)>>>0<127){y=x;z=6}else{B=x;z=65}}b:do if((z|0)==6){z=0;switch(y>>>3&536870911|0){case 1:{switch(y|0){case 0:{C=1;z=71;break a;break}case 8:break;default:{D=y;break b}}f[i>>2]=f[i>>2]|1;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0){a=b[x>>0]|0;w=a&255;if(a<<24>>24>-1){f[j>>2]=w;a=x+1|0;f[c>>2]=a;E=a}else{F=w;z=11}}else{F=0;z=11}if((z|0)==11){z=0;w=Knb(c,F)|0;a=J;f[j>>2]=w;if(!((a|0)>-1|(a|0)==-1&w>>>0>4294967295)){C=0;z=71;break a}E=f[c>>2]|0}w=f[g>>2]|0;if(E>>>0>=w>>>0)continue a;if((b[E>>0]|0)!=16)continue a;a=E+1|0;f[c>>2]=a;G=a;H=w;z=18;break}case 2:{switch(y|0){case 0:{C=1;z=71;break a;break}case 16:break;default:{D=y;break b}}G=f[c>>2]|0;H=f[g>>2]|0;z=18;break}case 3:{switch(y|0){case 0:{C=1;z=71;break a;break}case 24:break;default:{D=y;break b}}I=f[c>>2]|0;K=f[g>>2]|0;z=28;break}case 4:{switch(y|0){case 0:{C=1;z=71;break a;break}case 34:{z=37;break}default:{D=y;break b}}break}case 5:{switch(y|0){case 0:{C=1;z=71;break a;break}case 42:break;default:{D=y;break b}}break}default:{B=y;z=65;break b}}if((z|0)==18){z=0;f[i>>2]=f[i>>2]|2;if(G>>>0<H>>>0){w=b[G>>0]|0;a=w&255;if(w<<24>>24>-1){f[k>>2]=a;w=G+1|0;f[c>>2]=w;L=w;M=H}else{N=a;z=21}}else{N=0;z=21}if((z|0)==21){z=0;a=Knb(c,N)|0;w=J;f[k>>2]=a;if(!((w|0)>-1|(w|0)==-1&a>>>0>4294967295)){C=0;z=71;break a}L=f[c>>2]|0;M=f[g>>2]|0}if(L>>>0>=M>>>0)continue a;if((b[L>>0]|0)!=24)continue a;a=L+1|0;f[c>>2]=a;I=a;K=M;z=28}if((z|0)==28){z=0;f[i>>2]=f[i>>2]|4;if(I>>>0<K>>>0?(a=b[I>>0]|0,a<<24>>24>-1):0){w=I+1|0;f[c>>2]=w;O=a<<24>>24!=0;P=w;Q=K}else{Lnb(e,c);w=e;if(!(b[m>>0]|0)){C=0;z=71;break a}O=(f[w>>2]|0)!=0|(f[w+4>>2]|0)!=0;P=f[c>>2]|0;Q=f[g>>2]|0}b[l>>0]=O&1;if(P>>>0>=Q>>>0)continue a;if((b[P>>0]|0)!=34)continue a;f[c>>2]=P+1;z=37}if((z|0)==37){z=0;f[i>>2]=f[i>>2]|8;w=f[n>>2]|0;if(!w){a=L5b(48)|0;GNa(a);f[n>>2]=a;R=a}else R=w;w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0?(a=b[w>>0]|0,a<<24>>24>-1):0){f[c>>2]=w+1;S=a&255}else{a=Znb(c)|0;if((a|0)>-1)S=a;else{C=0;z=71;break a}}Inb(e,c,S);if((f[o>>2]|0)<0){z=45;break a}if(!(JNa(R,c)|0)){z=45;break a}if(!(Onb(c,f[e>>2]|0)|0)){C=0;z=71;break a}a=f[c>>2]|0;if(a>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[a>>0]|0)!=42)continue a;f[c>>2]=a+1}f[i>>2]=f[i>>2]|16;a=f[p>>2]|0;if(!a){w=L5b(48)|0;GNa(w);f[p>>2]=w;T=w}else T=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(w=b[a>>0]|0,w<<24>>24>-1):0){f[c>>2]=a+1;U=w&255}else{w=Znb(c)|0;if((w|0)>-1)U=w;else{C=0;z=71;break a}}Inb(e,c,U);if((f[q>>2]|0)<0){z=59;break a}if(!(JNa(T,c)|0)){z=59;break a}if(!(Onb(c,f[e>>2]|0)|0)){C=0;z=71;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[r>>2]|0){z=64;break a}if((f[s>>2]|0)==(f[t>>2]|0)){z=64;break a}else continue a}while(0);if((z|0)==65){z=0;if(!B){C=1;z=71;break}else D=B}if((D&7|0)==4){C=1;z=71;break}w=f[v>>2]|0;if(!(w&1))V=hBa(v)|0;else V=w&-2;if(!(ZPb(c,D,V)|0)){C=0;z=71;break}}if((z|0)==45){C=0;u=d;return C|0}else if((z|0)==59){C=0;u=d;return C|0}else if((z|0)==64){f[h>>2]=0;b[c+24>>0]=1;C=1;u=d;return C|0}else if((z|0)==71){u=d;return C|0}return 0}function ZZa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=a+8|0;c=f[b>>2]|0;if(c&31){if(c&1){d=f[a+24>>2]|0;if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}}else{e=0;g=c}if(!(g&2)){i=e;j=g}else{c=f[a+28>>2]|0;if(c>>>0<128){k=2;l=g}else{g=(iob(c)|0)+1|0;k=g;l=f[b>>2]|0}i=k+e|0;j=l}l=j&4|0?i+2|0:i;if(!(j&8)){m=l;n=j}else{j=INa(f[a+16>>2]|0)|0;if(j>>>0<128)o=1;else o=iob(j)|0;m=l+1+j+o|0;n=f[b>>2]|0}if(!(n&16))p=m;else{n=INa(f[a+20>>2]|0)|0;if(n>>>0<128)q=1;else q=iob(n)|0;p=m+1+n+q|0}}else p=0;q=f[a+4>>2]|0;if(!(q&1)){r=p;s=a+12|0;f[s>>2]=r;return r|0}r=(dQb(q&-2)|0)+p|0;s=a+12|0;f[s>>2]=r;return r|0}function _Za(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Opb(1,f[a+24>>2]|0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{Opb(2,f[a+28>>2]|0,c);h=f[d>>2]|0}if(!(h&4))i=h;else{Ypb(3,(b[a+32>>0]|0)!=0,c);i=f[d>>2]|0}if(!(i&8))j=i;else{eqb(4,f[a+16>>2]|0,c);j=f[d>>2]|0}if(j&16|0)eqb(5,f[a+20>>2]|0,c);j=f[a+4>>2]|0;if(!(j&1))return;aQb(j&-2,c);return}function $Za(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function a_a(a){a=a|0;return f[a+12>>2]|0}function b_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+24>>2]|0;b[d>>0]=8;i=d+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=e}b[m>>0]=n;g=m+1|0;h=f[c>>2]|0}if(!(h&2)){o=g;p=h}else{h=f[a+28>>2]|0;b[g>>0]=16;m=g+1|0;if(h>>>0>127){g=h;n=m;while(1){b[n>>0]=g|128;e=g>>>7;i=n+1|0;if(g>>>0>16383){g=e;n=i}else{q=i;r=e;break}}}else{q=m;r=h}b[q>>0]=r;o=q+1|0;p=f[c>>2]|0}if(!(p&4)){s=o;t=p}else{p=b[a+32>>0]|0;b[o>>0]=24;b[o+1>>0]=p;s=o+2|0;t=f[c>>2]|0}if(!(t&8)){u=s;v=t}else{t=f[a+16>>2]|0;b[s>>0]=34;o=s+1|0;s=f[t+12>>2]|0;if(s>>>0>127){p=s;q=o;while(1){b[q>>0]=p|128;r=p>>>7;h=q+1|0;if(p>>>0>16383){p=r;q=h}else{w=h;x=r;break}}}else{w=o;x=s}b[w>>0]=x;x=li[f[(f[t>>2]|0)+68>>2]&511](t,0,w+1|0)|0;u=x;v=f[c>>2]|0}if(!(v&16))y=u;else{v=f[a+20>>2]|0;b[u>>0]=42;c=u+1|0;u=f[v+12>>2]|0;if(u>>>0>127){x=u;w=c;while(1){b[w>>0]=x|128;t=x>>>7;s=w+1|0;if(x>>>0>16383){x=t;w=s}else{z=s;A=t;break}}}else{z=c;A=u}b[z>>0]=A;y=li[f[(f[v>>2]|0)+68>>2]&511](v,0,z+1|0)|0}z=f[a+4>>2]|0;if(!(z&1)){B=y;return B|0}B=bQb(z&-2,y)|0;return B|0}function c_a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function d_a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(31360);c=T6b(b,23288,19384,0)|0;if(!c){cOb(b,a);return}else{g_a(a,c);return}}function e_a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function f_a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213112];f[a+4>>2]=f[213113];u=c;return}function g_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=c+8|0;e=f[d>>2]|0;do if(e&255|0){if(!(e&1))g=e;else{h=f[c+24>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|1;f[a+24>>2]=h;g=f[d>>2]|0}if(!(g&2))j=g;else{h=f[c+28>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|2;f[a+28>>2]=h;j=f[d>>2]|0}if(!(j&4))k=j;else{h=b[c+32>>0]|0;i=a+8|0;f[i>>2]=f[i>>2]|4;b[a+32>>0]=h;k=f[d>>2]|0}do if(k&8){h=a+8|0;f[h>>2]=f[h>>2]|8;h=a+16|0;i=f[h>>2]|0;if(!i){l=L5b(48)|0;GNa(l);f[h>>2]=l;m=l}else m=i;i=f[c+16>>2]|0;l=(i|0)==0?493544:i;if((l|0)==(m|0))jMa(8763);else{HNa(m,l);n=f[d>>2]|0;break}}else n=k;while(0);if(n&16|0){l=a+8|0;f[l>>2]=f[l>>2]|16;l=a+20|0;i=f[l>>2]|0;if(!i){h=L5b(48)|0;GNa(h);f[l>>2]=h;o=h}else o=i;i=f[c+20>>2]|0;h=(i|0)==0?493544:i;if((h|0)==(o|0))jMa(8763);else{HNa(o,h);break}}}while(0);o=f[c+4>>2]|0;if(!(o&1))return;LPb(o&-2,a+4|0);return}function h_a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=114804;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495408?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;b[a+32>>0]=1;u=c;return}function i_a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function j_a(a){a=a|0;var b=0,c=0;f[a>>2]=114696;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function k_a(a){a=a|0;var b=0,c=0;f[a>>2]=114696;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function l_a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function m_a(a,b){a=a|0;b=b|0;a=L5b(20)|0;z_a(a);if(!b)return a|0;A_a(b,a);return a|0}function n_a(a){a=a|0;var b=0;n[a+16>>2]=1.0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function o_a(a){a=a|0;return 1}function p_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+16|0;l=c+32|0;m=c+12|0;n=c+28|0;o=a+4|0;while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[i>>2]=q;f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=_nb(c,t)|0;f[i>>2]=q;if((q+-1|0)>>>0<127){r=q;s=6}else v=q}if((s|0)==6){s=0;if((r|0)==13){f[j>>2]=f[j>>2]|1;q=f[g>>2]|0;a=f[c>>2]|0;if((q-a|0)>3){p=a;w=h[p>>0]|h[p+1>>0]<<8|h[p+2>>0]<<16|h[p+3>>0]<<24;f[e>>2]=w;p=a+4|0;f[c>>2]=p;x=w;y=p;z=q}else{if(!(Xnb(c,e)|0)){s=11;break}x=f[e>>2]|0;y=f[c>>2]|0;z=f[g>>2]|0}f[k>>2]=x;if((y|0)!=(z|0))continue;if(f[l>>2]|0){s=15;break}if((f[m>>2]|0)==(f[n>>2]|0)){s=15;break}else continue}else v=r}if((v|0)==0|(v&7|0)==4){A=1;s=21;break}q=f[o>>2]|0;if(!(q&1))B=hBa(o)|0;else B=q&-2;if(!(ZPb(c,v,B)|0)){A=0;s=21;break}}if((s|0)==11){A=0;u=d;return A|0}else if((s|0)==15){f[i>>2]=0;b[c+24>>0]=1;A=1;u=d;return A|0}else if((s|0)==21){u=d;return A|0}return 0}function q_a(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]&1|0?5:0;c=f[a+4>>2]|0;if(!(c&1)){d=b;e=a+12|0;f[e>>2]=d;return d|0}d=(dQb(c&-2)|0)+b|0;e=a+12|0;f[e>>2]=d;return d|0}function r_a(a,b){a=a|0;b=b|0;var c=0;if(f[a+8>>2]&1|0)Wpb(1,+n[a+16>>2],b);c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function s_a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function t_a(a){a=a|0;return f[a+12>>2]|0}function u_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;if(!(f[a+8>>2]&1))e=d;else{c=f[a+16>>2]|0;b[d>>0]=13;g=d+1|0;b[g>>0]=c;b[g+1>>0]=c>>8;b[g+2>>0]=c>>16;b[g+3>>0]=c>>24;e=d+5|0}d=f[a+4>>2]|0;if(!(d&1)){h=e;return h|0}h=bQb(d&-2,e)|0;return h|0}function v_a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function w_a(a,b){a=a|0;b=b|0;var c=0,d=0;if((a|0)==(b|0))jMa(30906);c=T6b(b,23288,19400,0)|0;if(!c){cOb(b,a);return}if(f[c+8>>2]&1|0){b=f[c+16>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|1;f[a+16>>2]=b}b=f[c+4>>2]|0;if(!(b&1))return;LPb(b&-2,a+4|0);return}function x_a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function y_a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213110];f[a+4>>2]=f[213111];u=c;return}function z_a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=114696;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495376?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;n[a+16>>2]=1.0;u=c;return}function A_a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function B_a(a){a=a|0;var b=0,c=0;f[a>>2]=114588;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function C_a(a){a=a|0;var b=0,c=0;f[a>>2]=114588;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function D_a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function E_a(a,b){a=a|0;b=b|0;a=L5b(36)|0;POa(a);if(!b)return a|0;Q_a(b,a);return a|0}function F_a(a){a=a|0;var c=0;c=a+8|0;if(f[c>>2]&5|0){f[a+28>>2]=1;b[a+32>>0]=1}f[a+16>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function G_a(a){a=a|0;return 1}function H_a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a+8|0;c=f[b>>2]|0;if(!(c&5))d=0;else{if(c&1){e=f[a+28>>2]|0;if((e|0)>=0)if(e>>>0<128){g=2;h=c}else{i=(iob(e)|0)+1|0;g=i;h=f[b>>2]|0}else{g=11;h=c}}else{g=0;h=c}d=h&4|0?g+2|0:g}g=f[a+16>>2]|0;h=g+d+(g<<2)|0;g=f[a+4>>2]|0;if(!(g&1)){j=h;k=a+12|0;f[k>>2]=j;return j|0}j=(dQb(g&-2)|0)+h|0;k=a+12|0;f[k>>2]=j;return j|0}function I_a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+8|0;if(f[d>>2]&1|0)Zpb(1,f[a+28>>2]|0,c);e=a+16|0;if((f[e>>2]|0)>0){g=a+24|0;h=0;do{Wpb(2,+n[(f[g>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)<(f[e>>2]|0))}if(f[d>>2]&4|0)Ypb(3,(b[a+32>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;aQb(d&-2,c);return}function J_a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function K_a(a){a=a|0;return f[a+12>>2]|0}function L_a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+28>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);m=a+16|0;if((f[m>>2]|0)>0){n=a+24|0;d=0;j=e;while(1){i=f[(f[n>>2]|0)+4+(d<<2)>>2]|0;b[j>>0]=21;k=j+1|0;b[k>>0]=i;b[k+1>>0]=i>>8;b[k+2>>0]=i>>16;b[k+3>>0]=i>>24;i=j+5|0;d=d+1|0;if((d|0)>=(f[m>>2]|0)){o=i;break}else j=i}}else o=e;if(!(f[c>>2]&4))p=o;else{c=b[a+32>>0]|0;b[o>>0]=24;b[o+1>>0]=c;p=o+2|0}o=f[a+4>>2]|0;if(!(o&1)){q=p;return q|0}q=bQb(o&-2,p)|0;return q|0}function M_a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function N_a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(30568);c=T6b(b,23288,19416,0)|0;if(!c){cOb(b,a);return}else{QOa(a,c);return}}function O_a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function P_a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213107];f[a+4>>2]=f[213108];u=c;return}function Q_a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function R_a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=114480;b=f[a+92>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+80>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+68>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+56>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+28|0;h=f[b>>2]|0;if(h|0?(f[a+16>>2]|0)==0:0){c=f[h>>2]|0;if((c|0)>0){d=0;do{e=f[h+4+(d<<2)>>2]|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(c|0));i=f[b>>2]|0}else i=h;O5b(i)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(i);f[b>>2]=0;return}function S_a(a){a=a|0;R_a(a);O5b(a);return}function T_a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function U_a(a,b){a=a|0;b=b|0;a=L5b(96)|0;NOa(a);if(!b)return a|0;d$a(b,a);return a|0}function V_a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}b=a+36|0;c=f[b>>2]|0;if((c|0)>0){e=f[a+44>>2]|0;d=0;do{g=f[e+4+(d<<2)>>2]|0;d=d+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((d|0)!=(c|0));f[b>>2]=0}f[a+48>>2]=0;f[a+60>>2]=0;f[a+72>>2]=0;f[a+84>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function W_a(a){a=a|0;return 1}function X_a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eqb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=a+48|0;if((f[c>>2]|0)>0){e=a+56|0;d=0;do{Opb(2,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)<(f[c>>2]|0))}c=a+60|0;if((f[c>>2]|0)>0){d=a+68|0;e=0;do{Opb(3,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)<(f[c>>2]|0))}c=a+72|0;if((f[c>>2]|0)>0){e=a+80|0;d=0;do{Opb(4,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)<(f[c>>2]|0))}c=a+84|0;if((f[c>>2]|0)>0){d=a+92|0;e=0;do{Opb(5,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)<(f[c>>2]|0))}c=f[a+36>>2]|0;if(c|0){e=a+44|0;d=0;do{eqb(6,f[(f[e>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function Y_a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function Z_a(a){a=a|0;return f[a+12>>2]|0}function __a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;c=f[a+20>>2]|0;if(!c)e=d;else{g=a+28|0;h=d;d=0;while(1){i=f[(f[g>>2]|0)+4+(d<<2)>>2]|0;b[h>>0]=10;j=h+1|0;k=f[i+12>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=j;q=k}b[p>>0]=q;m=li[f[(f[i>>2]|0)+68>>2]&511](i,0,p+1|0)|0;d=d+1|0;if((d|0)==(c|0)){e=m;break}else h=m}}h=a+48|0;if((f[h>>2]|0)>0){c=a+56|0;d=0;p=e;while(1){q=f[(f[c>>2]|0)+4+(d<<2)>>2]|0;b[p>>0]=16;g=p+1|0;if(q>>>0>127){m=q;l=g;while(1){b[l>>0]=m|128;n=m>>>7;o=l+1|0;if(m>>>0>16383){m=n;l=o}else{r=o;s=n;break}}}else{r=g;s=q}b[r>>0]=s;l=r+1|0;d=d+1|0;if((d|0)>=(f[h>>2]|0)){t=l;break}else p=l}}else t=e;e=a+60|0;if((f[e>>2]|0)>0){p=a+68|0;h=0;d=t;while(1){r=f[(f[p>>2]|0)+4+(h<<2)>>2]|0;b[d>>0]=24;s=d+1|0;if(r>>>0>127){c=r;l=s;while(1){b[l>>0]=c|128;m=c>>>7;i=l+1|0;if(c>>>0>16383){c=m;l=i}else{u=i;v=m;break}}}else{u=s;v=r}b[u>>0]=v;l=u+1|0;h=h+1|0;if((h|0)>=(f[e>>2]|0)){w=l;break}else d=l}}else w=t;t=a+72|0;if((f[t>>2]|0)>0){d=a+80|0;e=0;h=w;while(1){u=f[(f[d>>2]|0)+4+(e<<2)>>2]|0;b[h>>0]=32;v=h+1|0;if(u>>>0>127){p=u;l=v;while(1){b[l>>0]=p|128;c=p>>>7;q=l+1|0;if(p>>>0>16383){p=c;l=q}else{x=q;y=c;break}}}else{x=v;y=u}b[x>>0]=y;l=x+1|0;e=e+1|0;if((e|0)>=(f[t>>2]|0)){z=l;break}else h=l}}else z=w;w=a+84|0;if((f[w>>2]|0)>0){h=a+92|0;t=0;e=z;while(1){x=f[(f[h>>2]|0)+4+(t<<2)>>2]|0;b[e>>0]=40;y=e+1|0;if(x>>>0>127){d=x;l=y;while(1){b[l>>0]=d|128;p=d>>>7;r=l+1|0;if(d>>>0>16383){d=p;l=r}else{A=r;B=p;break}}}else{A=y;B=x}b[A>>0]=B;l=A+1|0;t=t+1|0;if((t|0)>=(f[w>>2]|0)){C=l;break}else e=l}}else C=z;z=f[a+36>>2]|0;if(!z)D=C;else{e=a+44|0;w=0;t=C;while(1){C=f[(f[e>>2]|0)+4+(w<<2)>>2]|0;b[t>>0]=50;A=t+1|0;B=f[C+12>>2]|0;if(B>>>0>127){h=B;l=A;while(1){b[l>>0]=h|128;d=h>>>7;u=l+1|0;if(h>>>0>16383){h=d;l=u}else{E=u;F=d;break}}}else{E=A;F=B}b[E>>0]=F;l=li[f[(f[C>>2]|0)+68>>2]&511](C,0,E+1|0)|0;w=w+1|0;if((w|0)==(z|0)){D=l;break}else t=l}}t=f[a+4>>2]|0;if(!(t&1)){G=D;return G|0}G=bQb(t&-2,D)|0;return G|0}function $_a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function a$a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(30018);c=T6b(b,23288,19432,0)|0;if(!c){cOb(b,a);return}else{OOa(a,c);return}}function b$a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function c$a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213105];f[a+4>>2]=f[213106];u=c;return}function d$a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function e$a(a){a=a|0;var b=0,c=0;f[a>>2]=114372;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function f$a(a){a=a|0;var b=0,c=0;f[a>>2]=114372;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function g$a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function h$a(a,b){a=a|0;b=b|0;a=L5b(24)|0;MOa(a);if(!b)return a|0;t$a(b,a);return a|0}function i$a(a){a=a|0;var c=0;c=a+8|0;if(f[c>>2]&3|0){n[a+16>>2]=.5;b[a+20>>0]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function j$a(a){a=a|0;return 1}function k$a(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(!(b&3))c=0;else c=(b&1|0?5:0)|b&2;b=f[a+4>>2]|0;if(!(b&1)){d=c;e=a+12|0;f[e>>2]=d;return d|0}d=(dQb(b&-2)|0)+c|0;e=a+12|0;f[e>>2]=d;return d|0}function l$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Wpb(1,+n[a+16>>2],c);g=f[d>>2]|0}if(g&2|0)Ypb(2,(b[a+20>>0]|0)!=0,c);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,c);return}function m$a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function n$a(a){a=a|0;return f[a+12>>2]|0}function o$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=13;i=d+1|0;b[i>>0]=e;b[i+1>>0]=e>>8;b[i+2>>0]=e>>16;b[i+3>>0]=e>>24;g=d+5|0;h=f[c>>2]|0}if(!(h&2))j=g;else{h=b[a+20>>0]|0;b[g>>0]=16;b[g+1>>0]=h;j=g+2|0}g=f[a+4>>2]|0;if(!(g&1)){k=j;return k|0}k=bQb(g&-2,j)|0;return k|0}function p$a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function q$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((a|0)==(c|0))jMa(29476);d=T6b(c,23288,19448,0)|0;if(!d){cOb(c,a);return}c=d+8|0;e=f[c>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=f[d+16>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;f[a+16>>2]=e;g=f[c>>2]|0}if(g&2|0){g=b[d+20>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|2;b[a+20>>0]=g}}g=f[d+4>>2]|0;if(!(g&1))return;LPb(g&-2,a+4|0);return}function r$a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function s$a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213103];f[a+4>>2]=f[213104];u=c;return}function t$a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function u$a(a){a=a|0;var b=0,c=0;f[a>>2]=114264;N$a(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function v$a(a){a=a|0;u$a(a);O5b(a);return}function w$a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function x$a(a,b){a=a|0;b=b|0;a=L5b(40)|0;L$a(a);if(!b)return a|0;M$a(b,a);return a|0}function y$a(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(d&63|0){do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(f[c>>2]&2|0?(d=f[a+20>>2]|0,(d|0)!=497760):0){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);do if(f[c>>2]&4|0?(g=f[a+24>>2]|0,(g|0)!=497760):0){d=g+11|0;if((b[d>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[d>>0]=0;break}}while(0);do if(f[c>>2]&8|0?(d=f[a+28>>2]|0,(d|0)!=497760):0){g=d+11|0;if((b[g>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[g>>0]=0;break}}while(0);do if(f[c>>2]&16|0?(g=f[a+32>>2]|0,(g|0)!=497760):0){d=g+11|0;if((b[d>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[d>>0]=0;break}}while(0);f[a+36>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function z$a(a){a=a|0;return 1}function A$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+16|0;i=a+20|0;j=a+24|0;k=a+28|0;l=a+32|0;m=a+36|0;n=c+32|0;o=c+12|0;p=c+28|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[e>>2]=s;f[c>>2]=a+1;t=s;u=6}else{v=s;u=5}}else{v=0;u=5}if((u|0)==5){u=0;s=_nb(c,v)|0;f[e>>2]=s;if((s+-1|0)>>>0<127){t=s;u=6}else{w=s;u=53}}b:do if((u|0)==6){u=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{x=1;u=59;break a;break}case 10:break;default:{y=t;break b}}f[g>>2]=f[g>>2]|1;s=f[h>>2]|0;if((s|0)==497760){jza(h,497760);z=f[h>>2]|0}else z=s;if(!(fqb(c,z)|0)){x=0;u=59;break a}s=f[c>>2]|0;if(s>>>0>=(f[d>>2]|0)>>>0)continue a;if((b[s>>0]|0)!=18)continue a;f[c>>2]=s+1;u=15;break}case 2:{switch(t|0){case 0:{x=1;u=59;break a;break}case 18:{u=15;break}default:{y=t;break b}}break}case 3:{switch(t|0){case 0:{x=1;u=59;break a;break}case 26:{u=22;break}default:{y=t;break b}}break}case 4:{switch(t|0){case 0:{x=1;u=59;break a;break}case 34:{u=29;break}default:{y=t;break b}}break}case 5:{switch(t|0){case 0:{x=1;u=59;break a;break}case 42:{u=36;break}default:{y=t;break b}}break}case 6:{switch(t|0){case 0:{x=1;u=59;break a;break}case 48:break;default:{y=t;break b}}A=f[c>>2]|0;B=f[d>>2]|0;break}default:{w=t;u=53;break b}}if((u|0)==15){u=0;f[g>>2]=f[g>>2]|2;s=f[i>>2]|0;if((s|0)==497760){jza(i,497760);C=f[i>>2]|0}else C=s;if(!(fqb(c,C)|0)){x=0;u=59;break a}s=f[c>>2]|0;if(s>>>0>=(f[d>>2]|0)>>>0)continue a;if((b[s>>0]|0)!=26)continue a;f[c>>2]=s+1;u=22}if((u|0)==22){u=0;f[g>>2]=f[g>>2]|4;s=f[j>>2]|0;if((s|0)==497760){jza(j,497760);D=f[j>>2]|0}else D=s;if(!(fqb(c,D)|0)){x=0;u=59;break a}s=f[c>>2]|0;if(s>>>0>=(f[d>>2]|0)>>>0)continue a;if((b[s>>0]|0)!=34)continue a;f[c>>2]=s+1;u=29}if((u|0)==29){u=0;f[g>>2]=f[g>>2]|8;s=f[k>>2]|0;if((s|0)==497760){jza(k,497760);E=f[k>>2]|0}else E=s;if(!(fqb(c,E)|0)){x=0;u=59;break a}s=f[c>>2]|0;if(s>>>0>=(f[d>>2]|0)>>>0)continue a;if((b[s>>0]|0)!=42)continue a;f[c>>2]=s+1;u=36}if((u|0)==36){u=0;f[g>>2]=f[g>>2]|16;s=f[l>>2]|0;if((s|0)==497760){jza(l,497760);F=f[l>>2]|0}else F=s;if(!(fqb(c,F)|0)){x=0;u=59;break a}s=f[c>>2]|0;a=f[d>>2]|0;if(s>>>0>=a>>>0)continue a;if((b[s>>0]|0)!=48)continue a;r=s+1|0;f[c>>2]=r;A=r;B=a}f[g>>2]=f[g>>2]|32;if(A>>>0<B>>>0){a=b[A>>0]|0;r=a&255;if(a<<24>>24>-1){f[m>>2]=r;a=A+1|0;f[c>>2]=a;G=a;H=B}else{I=r;u=47}}else{I=0;u=47}if((u|0)==47){u=0;r=Knb(c,I)|0;a=J;f[m>>2]=r;if(!((a|0)>-1|(a|0)==-1&r>>>0>4294967295)){x=0;u=59;break a}G=f[c>>2]|0;H=f[d>>2]|0}if((G|0)!=(H|0))continue a;if(f[n>>2]|0){u=52;break a}if((f[o>>2]|0)==(f[p>>2]|0)){u=52;break a}else continue a}while(0);if((u|0)==53){u=0;if(!w){x=1;u=59;break}else y=w}if((y&7|0)==4){x=1;u=59;break}r=f[q>>2]|0;if(!(r&1))K=hBa(q)|0;else K=r&-2;if(!(ZPb(c,y,K)|0)){x=0;u=59;break}}if((u|0)==52){f[e>>2]=0;b[c+24>>0]=1;x=1;return x|0}else if((u|0)==59)return x|0;return 0}function B$a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;c=a+8|0;d=f[c>>2]|0;if(d&63){if(!(d&1)){e=0;g=d}else{h=f[a+16>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&2)){n=e;o=g}else{l=f[a+20>>2]|0;k=b[l+11>>0]|0;if(k<<24>>24<0){m=f[l+4>>2]|0;if(m>>>0<128){p=1;q=g;r=m}else{l=iob(m)|0;p=l;q=f[c>>2]|0;r=m}}else{p=1;q=g;r=k&255}n=e+1+r+p|0;o=q}if(!(o&4)){s=n;t=o}else{q=f[a+24>>2]|0;p=b[q+11>>0]|0;if(p<<24>>24<0){r=f[q+4>>2]|0;if(r>>>0<128){u=1;v=o;w=r}else{q=iob(r)|0;u=q;v=f[c>>2]|0;w=r}}else{u=1;v=o;w=p&255}s=n+1+w+u|0;t=v}if(!(t&8)){x=s;y=t}else{v=f[a+28>>2]|0;u=b[v+11>>0]|0;if(u<<24>>24<0){w=f[v+4>>2]|0;if(w>>>0<128){z=1;A=t;B=w}else{v=iob(w)|0;z=v;A=f[c>>2]|0;B=w}}else{z=1;A=t;B=u&255}x=s+1+B+z|0;y=A}if(!(y&16)){C=x;D=y}else{A=f[a+32>>2]|0;z=b[A+11>>0]|0;if(z<<24>>24<0){B=f[A+4>>2]|0;if(B>>>0<128){E=1;F=y;G=B}else{A=iob(B)|0;E=A;F=f[c>>2]|0;G=B}}else{E=1;F=y;G=z&255}C=x+1+G+E|0;D=F}if(!(D&32))H=C;else{D=f[a+36>>2]|0;if(D>>>0<128)I=2;else I=(iob(D)|0)+1|0;H=I+C|0}}else H=0;C=f[a+4>>2]|0;if(!(C&1)){J=H;K=a+12|0;f[K>>2]=J;return J|0}J=(dQb(C&-2)|0)+H|0;K=a+12|0;f[K>>2]=J;return J|0}function C$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{$pb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{$pb(2,f[a+20>>2]|0,b);g=f[c>>2]|0}if(!(g&4))h=g;else{$pb(3,f[a+24>>2]|0,b);h=f[c>>2]|0}if(!(h&8))i=h;else{$pb(4,f[a+28>>2]|0,b);i=f[c>>2]|0}if(!(i&16))j=i;else{$pb(5,f[a+32>>2]|0,b);j=f[c>>2]|0}if(j&32|0)Opb(6,f[a+36>>2]|0,b);j=f[a+4>>2]|0;if(!(j&1))return;aQb(j&-2,b);return}function D$a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function E$a(a){a=a|0;return f[a+12>>2]|0}function F$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&2)){j=g;k=h}else{h=f[a+20>>2]|0;b[g>>0]=18;i=kob(h,g+1|0)|0;j=i;k=f[c>>2]|0}if(!(k&4)){l=j;m=k}else{k=f[a+24>>2]|0;b[j>>0]=26;i=kob(k,j+1|0)|0;l=i;m=f[c>>2]|0}if(!(m&8)){n=l;o=m}else{m=f[a+28>>2]|0;b[l>>0]=34;i=kob(m,l+1|0)|0;n=i;o=f[c>>2]|0}if(!(o&16)){p=n;q=o}else{o=f[a+32>>2]|0;b[n>>0]=42;i=kob(o,n+1|0)|0;p=i;q=f[c>>2]|0}if(!(q&32))r=p;else{q=f[a+36>>2]|0;b[p>>0]=48;c=p+1|0;if(q>>>0>127){p=q;i=c;while(1){b[i>>0]=p|128;n=p>>>7;o=i+1|0;if(p>>>0>16383){p=n;i=o}else{s=o;t=n;break}}}else{s=c;t=q}b[s>>0]=t;r=s+1|0}s=f[a+4>>2]|0;if(!(s&1)){u=r;return u|0}u=bQb(s&-2,r)|0;return u|0}function G$a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function H$a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(28867);c=T6b(b,23288,19464,0)|0;if(!c){cOb(b,a);return}else{K$a(a,c);return}}function I$a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function J$a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213101];f[a+4>>2]=f[213102];u=c;return}function K$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+32|0;d=c+20|0;e=c+16|0;g=c+12|0;h=c+8|0;i=c+4|0;j=c;k=b+8|0;l=f[k>>2]|0;if(l&255|0){if(!(l&1))m=l;else{l=a+8|0;f[l>>2]=f[l>>2]|1;f[e>>2]=f[b+16>>2];f[d>>2]=f[e>>2];Anb(a+16|0,497760,d);m=f[k>>2]|0}if(!(m&2))n=m;else{m=a+8|0;f[m>>2]=f[m>>2]|2;f[g>>2]=f[b+20>>2];f[d>>2]=f[g>>2];Anb(a+20|0,497760,d);n=f[k>>2]|0}if(!(n&4))o=n;else{n=a+8|0;f[n>>2]=f[n>>2]|4;f[h>>2]=f[b+24>>2];f[d>>2]=f[h>>2];Anb(a+24|0,497760,d);o=f[k>>2]|0}if(!(o&8))p=o;else{o=a+8|0;f[o>>2]=f[o>>2]|8;f[i>>2]=f[b+28>>2];f[d>>2]=f[i>>2];Anb(a+28|0,497760,d);p=f[k>>2]|0}if(!(p&16))q=p;else{p=a+8|0;f[p>>2]=f[p>>2]|16;f[j>>2]=f[b+32>>2];f[d>>2]=f[j>>2];Anb(a+32|0,497760,d);q=f[k>>2]|0}if(q&32|0){q=f[b+36>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|32;f[a+36>>2]=q}}q=f[b+4>>2]|0;if(!(q&1)){u=c;return}LPb(q&-2,a+4|0);u=c;return}function L$a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=114264;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495144?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=497760;f[a+20>>2]=497760;f[a+24>>2]=497760;f[a+28>>2]=497760;f[a+32>>2]=497760;f[a+36>>2]=0;u=c;return}function M$a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function N$a(a){a=a|0;var c=0,d=0;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+20|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+24|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+28|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+32|0;a=f[c>>2]|0;if((a|0)==497760|(a|0)==0){f[c>>2]=0;return}if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a);f[c>>2]=0;return}function O$a(a){a=a|0;var b=0,c=0;f[a>>2]=114156;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function P$a(a){a=a|0;var b=0,c=0;f[a>>2]=114156;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function Q$a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function R$a(a,b){a=a|0;b=b|0;a=L5b(28)|0;c0a(a);if(!b)return a|0;d0a(b,a);return a|0}function S$a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){n[a+20>>2]=.30000001192092896;f[a+16>>2]=0;n[a+24>>2]=1.0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function T$a(a){a=a|0;return 1}function U$a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+20|0;l=a+16|0;m=a+24|0;n=c+32|0;o=c+12|0;p=c+28|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[i>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[i>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=37}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=43;break a;break}case 13:break;default:{z=t;break b}}f[j>>2]=f[j>>2]|1;s=f[g>>2]|0;a=f[c>>2]|0;if((s-a|0)>3){r=a;A=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=A;r=a+4|0;f[c>>2]=r;B=s;C=A;D=r;E=s}else{if(!(Xnb(c,e)|0)){v=12;break a}s=f[g>>2]|0;B=s;C=f[e>>2]|0;D=f[c>>2]|0;E=s}f[k>>2]=C;if(D>>>0>=E>>>0)continue a;if((b[D>>0]|0)!=16)continue a;s=D+1|0;f[c>>2]=s;F=B;G=s;H=E;v=18;break}case 2:{switch(t|0){case 0:{y=1;v=43;break a;break}case 16:break;default:{z=t;break b}}s=f[g>>2]|0;F=s;G=f[c>>2]|0;H=s;v=18;break}case 3:{switch(t|0){case 0:{y=1;v=43;break a;break}case 29:break;default:{z=t;break b}}s=f[g>>2]|0;I=s;K=f[c>>2]|0;L=s;break}default:{x=t;v=37;break b}}if((v|0)==18){v=0;f[j>>2]=f[j>>2]|2;if(G>>>0<H>>>0){s=b[G>>0]|0;r=s&255;if(s<<24>>24>-1){s=G+1|0;f[c>>2]=s;M=r;N=F;O=s;P=H}else{Q=r;v=21}}else{Q=0;v=21}if((v|0)==21){v=0;r=Knb(c,Q)|0;s=J;if(!((s|0)>-1|(s|0)==-1&r>>>0>4294967295)){y=0;v=43;break a}s=f[g>>2]|0;M=r;N=s;O=f[c>>2]|0;P=s}f[l>>2]=M;if(O>>>0>=P>>>0)continue a;if((b[O>>0]|0)!=29)continue a;s=O+1|0;f[c>>2]=s;I=P;K=s;L=N}f[j>>2]=f[j>>2]|4;if((L-K|0)>3){s=K;r=h[s>>0]|h[s+1>>0]<<8|h[s+2>>0]<<16|h[s+3>>0]<<24;f[e>>2]=r;s=K+4|0;f[c>>2]=s;R=r;S=s;T=I}else{if(!(Xnb(c,e)|0)){v=32;break a}R=f[e>>2]|0;S=f[c>>2]|0;T=f[g>>2]|0}f[m>>2]=R;if((S|0)!=(T|0))continue a;if(f[n>>2]|0){v=36;break a}if((f[o>>2]|0)==(f[p>>2]|0)){v=36;break a}else continue a}while(0);if((v|0)==37){v=0;if(!x){y=1;v=43;break}else z=x}if((z&7|0)==4){y=1;v=43;break}s=f[q>>2]|0;if(!(s&1))U=hBa(q)|0;else U=s&-2;if(!(ZPb(c,z,U)|0)){y=0;v=43;break}}if((v|0)==12){y=0;u=d;return y|0}else if((v|0)==32){y=0;u=d;return y|0}else if((v|0)==36){f[i>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==43){u=d;return y|0}return 0}function V$a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=a+8|0;c=f[b>>2]|0;if(!(c&7))d=0;else{e=c&1|0?5:0;if(!(c&2)){g=e;h=c}else{i=f[a+16>>2]|0;if((i|0)>=0)if(i>>>0<128){j=2;k=c}else{l=(iob(i)|0)+1|0;j=l;k=f[b>>2]|0}else{j=11;k=c}g=j+e|0;h=k}d=h&4|0?g+5|0:g}g=f[a+4>>2]|0;if(!(g&1)){m=d;n=a+12|0;f[n>>2]=m;return m|0}m=(dQb(g&-2)|0)+d|0;n=a+12|0;f[n>>2]=m;return m|0}function W$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Wpb(1,+n[a+20>>2],b);e=f[c>>2]|0}if(!(e&2))g=e;else{Mpb(2,f[a+16>>2]|0,b);g=f[c>>2]|0}if(g&4|0)Wpb(3,+n[a+24>>2],b);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,b);return}function X$a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function Y$a(a){a=a|0;return f[a+12>>2]|0}function Z$a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+20>>2]|0;b[d>>0]=13;i=d+1|0;b[i>>0]=e;b[i+1>>0]=e>>8;b[i+2>>0]=e>>16;b[i+3>>0]=e>>24;g=d+5|0;h=f[c>>2]|0}do if(!(h&2))j=g;else{d=f[a+16>>2]|0;b[g>>0]=16;e=g+1|0;if((d|0)<0){j=hob(d,((d|0)<0)<<31>>31,e)|0;break}if(d>>>0>127){i=d;k=e;while(1){b[k>>0]=i|128;l=i>>>7;m=k+1|0;if(i>>>0>16383){i=l;k=m}else{n=m;o=l;break}}}else{n=e;o=d}b[n>>0]=o;j=n+1|0}while(0);if(!(f[c>>2]&4))p=j;else{c=f[a+24>>2]|0;b[j>>0]=29;n=j+1|0;b[n>>0]=c;b[n+1>>0]=c>>8;b[n+2>>0]=c>>16;b[n+3>>0]=c>>24;p=j+5|0}j=f[a+4>>2]|0;if(!(j&1)){q=p;return q|0}q=bQb(j&-2,p)|0;return q|0}function _$a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function $$a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((a|0)==(b|0))jMa(28273);c=T6b(b,23288,19480,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+20>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+20>>2]=d;e=f[b>>2]|0}if(!(e&2))h=e;else{e=f[c+16>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+16>>2]=e;h=f[b>>2]|0}if(h&4|0){h=f[c+24>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|4;f[a+24>>2]=h}}h=f[c+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function a0a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function b0a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213099];f[a+4>>2]=f[213100];u=c;return}function c0a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=114156;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=495104?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=0;n[a+20>>2]=.30000001192092896;n[a+24>>2]=1.0;u=c;return}function d0a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function e0a(a){a=a|0;var c=0,d=0;f[a>>2]=114048;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+20|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(d);f[c>>2]=0;return}function f0a(a){a=a|0;e0a(a);O5b(a);return}function g0a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function h0a(a,b){a=a|0;b=b|0;a=L5b(52)|0;KOa(a);if(!b)return a|0;r0a(b,a);return a|0}function i0a(a){a=a|0;return 1}function j0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{$pb(1,f[a+16>>2]|0,c);g=f[d>>2]|0}if(!(g&16))h=g;else{Wpb(2,+n[a+44>>2],c);h=f[d>>2]|0}if(!(h&32))i=h;else{$pb(3,f[a+20>>2]|0,c);i=f[d>>2]|0}if(!(i&2))j=i;else{Opb(4,f[a+24>>2]|0,c);j=f[d>>2]|0}if(!(j&64))k=j;else{Opb(5,f[a+36>>2]|0,c);k=f[d>>2]|0}if(!(k&128))l=k;else{Ypb(6,(b[a+40>>0]|0)!=0,c);l=f[d>>2]|0}if(!(l&4))m=l;else{Opb(7,f[a+28>>2]|0,c);m=f[d>>2]|0}if(!(m&8))o=m;else{Zpb(8,f[a+32>>2]|0,c);o=f[d>>2]|0}if(!(o&256))p=o;else{Ypb(9,(b[a+41>>0]|0)!=0,c);p=f[d>>2]|0}if(p&512|0)Opb(10,f[a+48>>2]|0,c);p=f[a+4>>2]|0;if(!(p&1))return;aQb(p&-2,c);return}function k0a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function l0a(a){a=a|0;return f[a+12>>2]|0}function m0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&16)){j=g;k=h}else{h=f[a+44>>2]|0;b[g>>0]=21;i=g+1|0;b[i>>0]=h;b[i+1>>0]=h>>8;b[i+2>>0]=h>>16;b[i+3>>0]=h>>24;j=g+5|0;k=f[c>>2]|0}if(!(k&32)){l=j;m=k}else{k=f[a+20>>2]|0;b[j>>0]=26;g=kob(k,j+1|0)|0;l=g;m=f[c>>2]|0}if(!(m&2)){n=l;o=m}else{m=f[a+24>>2]|0;b[l>>0]=32;g=l+1|0;if(m>>>0>127){l=m;j=g;while(1){b[j>>0]=l|128;k=l>>>7;h=j+1|0;if(l>>>0>16383){l=k;j=h}else{p=h;q=k;break}}}else{p=g;q=m}b[p>>0]=q;n=p+1|0;o=f[c>>2]|0}if(!(o&64)){r=n;s=o}else{o=f[a+36>>2]|0;b[n>>0]=40;p=n+1|0;if(o>>>0>127){n=o;q=p;while(1){b[q>>0]=n|128;m=n>>>7;g=q+1|0;if(n>>>0>16383){n=m;q=g}else{t=g;u=m;break}}}else{t=p;u=o}b[t>>0]=u;r=t+1|0;s=f[c>>2]|0}if(!(s&128)){v=r;w=s}else{s=b[a+40>>0]|0;b[r>>0]=48;b[r+1>>0]=s;v=r+2|0;w=f[c>>2]|0}if(!(w&4)){x=v;y=w}else{w=f[a+28>>2]|0;b[v>>0]=56;r=v+1|0;if(w>>>0>127){v=w;s=r;while(1){b[s>>0]=v|128;t=v>>>7;u=s+1|0;if(v>>>0>16383){v=t;s=u}else{z=u;A=t;break}}}else{z=r;A=w}b[z>>0]=A;x=z+1|0;y=f[c>>2]|0}do if(!(y&8))B=x;else{z=f[a+32>>2]|0;b[x>>0]=64;A=x+1|0;if((z|0)<0){B=hob(z,((z|0)<0)<<31>>31,A)|0;break}if(z>>>0>127){w=z;r=A;while(1){b[r>>0]=w|128;s=w>>>7;v=r+1|0;if(w>>>0>16383){w=s;r=v}else{C=v;D=s;break}}}else{C=A;D=z}b[C>>0]=D;B=C+1|0}while(0);C=f[c>>2]|0;if(!(C&256)){E=B;F=C}else{C=b[a+41>>0]|0;b[B>>0]=72;b[B+1>>0]=C;E=B+2|0;F=f[c>>2]|0}if(!(F&512))G=E;else{F=f[a+48>>2]|0;b[E>>0]=80;c=E+1|0;if(F>>>0>127){E=F;B=c;while(1){b[B>>0]=E|128;C=E>>>7;D=B+1|0;if(E>>>0>16383){E=C;B=D}else{H=D;I=C;break}}}else{H=c;I=F}b[H>>0]=I;G=H+1|0}H=f[a+4>>2]|0;if(!(H&1)){J=G;return J|0}J=bQb(H&-2,G)|0;return J|0}function n0a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function o0a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(27607);c=T6b(b,23288,19496,0)|0;if(!c){cOb(b,a);return}else{LOa(a,c);return}}function p0a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function q0a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213096];f[a+4>>2]=f[213097];u=c;return}function r0a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function s0a(a){a=a|0;var b=0,c=0;f[a>>2]=113940;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function t0a(a){a=a|0;var b=0,c=0;f[a>>2]=113940;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function u0a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function v0a(a,b){a=a|0;b=b|0;a=L5b(32)|0;I0a(a);if(!b)return a|0;J0a(b,a);return a|0}function w0a(a){a=a|0;var b=0;f[a+28>>2]=2;f[a+16>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function x0a(a){a=a|0;return 1}function y0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+28|0;i=a+16|0;j=a+20|0;k=a+24|0;l=c+32|0;m=c+12|0;n=c+28|0;o=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[e>>2]=q;f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=_nb(c,t)|0;f[e>>2]=q;if((q+-1|0)>>>0<127){r=q;s=6}else{u=q;s=40}}b:do if((s|0)==6){s=0;c:do switch(r>>>3&536870911|0){case 1:{switch(r|0){case 0:{v=1;s=46;break a;break}case 8:break;default:{w=r;break b}}f[g>>2]=f[g>>2]|1;q=f[c>>2]|0;a=f[d>>2]|0;if(q>>>0<a>>>0){p=b[q>>0]|0;x=p&255;if(p<<24>>24>-1){p=q+1|0;f[c>>2]=p;y=x;z=p;A=a}else{B=x;s=11}}else{B=0;s=11}if((s|0)==11){s=0;x=Knb(c,B)|0;a=J;if(!((a|0)>-1|(a|0)==-1&x>>>0>4294967295)){v=0;s=46;break a}y=x;z=f[c>>2]|0;A=f[d>>2]|0}f[h>>2]=y;if(z>>>0>=A>>>0)continue a;if((b[z>>0]|0)==16){C=z;D=A;s=17}else continue a;break}case 2:{switch(r|0){case 0:{v=1;s=46;break a;break}case 16:{E=f[c>>2]|0;F=f[d>>2]|0;s=18;break c;break}case 18:{if(wQa(c,i)|0){s=34;break c}else{v=0;s=46;break a}break}default:{w=r;break b}}break}default:{u=r;s=40;break b}}while(0);d:while(1)if((s|0)==17){s=0;x=C+1|0;f[c>>2]=x;E=x;F=D;s=18;continue}else if((s|0)==18){s=0;if(E>>>0<F>>>0){x=b[E>>0]|0;a=x&255;if(x<<24>>24>-1){f[c>>2]=E+1;G=a}else{H=a;s=21}}else{H=0;s=21}if((s|0)==21){s=0;a=Knb(c,H)|0;x=J;if((x|0)>-1|(x|0)==-1&a>>>0>4294967295)G=a;else{v=0;s=46;break a}}a=f[i>>2]|0;if((a|0)==(f[j>>2]|0)){rza(i,a+1|0);I=f[i>>2]|0}else I=a;a=f[k>>2]|0;f[i>>2]=I+1;f[a+4+(I<<2)>>2]=G;x=(f[j>>2]|0)-(f[i>>2]|0)|0;if((x|0)>0){K=x;L=a}else{s=34;continue}while(1){a=f[c>>2]|0;x=f[d>>2]|0;if(a>>>0>=x>>>0){s=34;continue d}if((b[a>>0]|0)!=16){s=34;continue d}p=a+1|0;f[c>>2]=p;if(p>>>0<x>>>0){x=b[p>>0]|0;p=x&255;if(x<<24>>24>-1){f[c>>2]=a+2;M=p;N=L}else{O=p;s=29}}else{O=0;s=29}if((s|0)==29){s=0;p=Knb(c,O)|0;a=J;if(!((a|0)>-1|(a|0)==-1&p>>>0>4294967295)){v=0;s=46;break a}M=p;N=f[k>>2]|0}p=f[i>>2]|0;f[i>>2]=p+1;f[N+4+(p<<2)>>2]=M;if((K|0)>1){K=K+-1|0;L=N}else{s=34;continue d}}}else if((s|0)==34){s=0;P=f[c>>2]|0;Q=f[d>>2]|0;if(P>>>0>=Q>>>0)break;if((b[P>>0]|0)==16){C=P;D=Q;s=17;continue}else break}if((P|0)!=(Q|0))continue a;if(f[l>>2]|0){s=39;break a}if((f[m>>2]|0)==(f[n>>2]|0)){s=39;break a}else continue a}while(0);if((s|0)==40){s=0;if(!u){v=1;s=46;break}else w=u}if((w&7|0)==4){v=1;s=46;break}p=f[o>>2]|0;if(!(p&1))R=hBa(o)|0;else R=p&-2;if(!(ZPb(c,w,R)|0)){v=0;s=46;break}}if((s|0)==39){f[e>>2]=0;b[c+24>>0]=1;v=1;return v|0}else if((s|0)==46)return v|0;return 0}function z0a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(f[a+8>>2]&1){b=f[a+28>>2]|0;if((b|0)>=0)if(b>>>0<128)c=2;else c=(iob(b)|0)+1|0;else c=11}else c=0;b=a+16|0;d=f[b>>2]|0;if(!d){e=0;g=0}else{h=a+24|0;i=0;j=0;do{k=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;if(k>>>0<128)l=1;else l=iob(k)|0;j=l+j|0;i=i+1|0}while((i|0)!=(d|0));e=j;g=f[b>>2]|0}b=e+c+g|0;g=f[a+4>>2]|0;if(!(g&1)){m=b;n=a+12|0;f[n>>2]=m;return m|0}m=(dQb(g&-2)|0)+b|0;n=a+12|0;f[n>>2]=m;return m|0}function A0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(f[a+8>>2]&1|0)Mpb(1,f[a+28>>2]|0,b);c=a+16|0;if((f[c>>2]|0)>0){d=a+24|0;e=0;do{Opb(2,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)<(f[c>>2]|0))}c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function B0a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function C0a(a){a=a|0;return f[a+12>>2]|0}function D0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;do if(!(f[a+8>>2]&1))e=d;else{c=f[a+28>>2]|0;b[d>>0]=8;g=d+1|0;if((c|0)<0){e=hob(c,((c|0)<0)<<31>>31,g)|0;break}if(c>>>0>127){h=c;i=g;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=g;m=c}b[l>>0]=m;e=l+1|0}while(0);l=a+16|0;if((f[l>>2]|0)>0){m=a+24|0;d=0;i=e;while(1){h=f[(f[m>>2]|0)+4+(d<<2)>>2]|0;b[i>>0]=16;j=i+1|0;if(h>>>0>127){k=h;n=j;while(1){b[n>>0]=k|128;o=k>>>7;p=n+1|0;if(k>>>0>16383){k=o;n=p}else{q=p;r=o;break}}}else{q=j;r=h}b[q>>0]=r;n=q+1|0;d=d+1|0;if((d|0)>=(f[l>>2]|0)){s=n;break}else i=n}}else s=e;e=f[a+4>>2]|0;if(!(e&1)){t=s;return t|0}t=bQb(e&-2,s)|0;return t|0}function E0a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function F0a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((a|0)==(b|0))jMa(26908);c=T6b(b,23288,19512,0)|0;if(!c){cOb(b,a);return}b=a+16|0;d=c+16|0;e=f[d>>2]|0;if(e|0){rza(b,(f[b>>2]|0)+e|0);Vac((f[a+24>>2]|0)+4+(f[b>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[b>>2]=(f[b>>2]|0)+(f[d>>2]|0)}if(f[c+8>>2]&1|0){d=f[c+28>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|1;f[a+28>>2]=d}d=f[c+4>>2]|0;if(!(d&1))return;LPb(d&-2,a+4|0);return}function G0a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function H0a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213094];f[a+4>>2]=f[213095];u=c;return}function I0a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=113940;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=495e3?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+28>>2]=2;u=c;return}function J0a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function K0a(a){a=a|0;var b=0,c=0;f[a>>2]=113832;if((a|0)!=494872){b=f[a+64>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+68>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b)}b=f[a+60>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+48>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+36>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function L0a(a){a=a|0;K0a(a);O5b(a);return}function M0a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function N0a(a,b){a=a|0;b=b|0;a=L5b(120)|0;IOa(a);if(!b)return a|0;X0a(b,a);return a|0}function O0a(a){a=a|0;return 1}function P0a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Opb(1,f[a+72>>2]|0,c);g=f[d>>2]|0}if(g&2|0)Ypb(2,(b[a+112>>0]|0)!=0,c);g=a+16|0;if((f[g>>2]|0)>0){e=a+24|0;h=0;do{Opb(3,f[(f[e>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)<(f[g>>2]|0))}g=a+28|0;if((f[g>>2]|0)>0){h=a+36|0;e=0;do{Opb(4,f[(f[h>>2]|0)+4+(e<<2)>>2]|0,c);e=e+1|0}while((e|0)<(f[g>>2]|0))}if(f[d>>2]&4096|0)Opb(5,f[a+116>>2]|0,c);g=a+40|0;if((f[g>>2]|0)>0){e=a+48|0;h=0;do{Opb(6,f[(f[e>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)<(f[g>>2]|0))}g=f[d>>2]|0;if(!(g&8192))i=g;else{eqb(7,f[a+64>>2]|0,c);i=f[d>>2]|0}if(!(i&16384))j=i;else{eqb(8,f[a+68>>2]|0,c);j=f[d>>2]|0}if(!(j&64))k=j;else{Opb(9,f[a+76>>2]|0,c);k=f[d>>2]|0}if(!(k&128))l=k;else{Opb(10,f[a+80>>2]|0,c);l=f[d>>2]|0}if(!(l&256))m=l;else{Opb(11,f[a+84>>2]|0,c);m=f[d>>2]|0}if(!(m&512))n=m;else{Opb(12,f[a+88>>2]|0,c);n=f[d>>2]|0}if(!(n&1024))o=n;else{Opb(13,f[a+92>>2]|0,c);o=f[d>>2]|0}if(!(o&2048))p=o;else{Opb(14,f[a+96>>2]|0,c);p=f[d>>2]|0}if(!(p&32768))q=p;else{Zpb(15,f[a+100>>2]|0,c);q=f[d>>2]|0}if(!(q&65536))r=q;else{Mpb(16,f[a+108>>2]|0,c);r=f[d>>2]|0}if(r&131072|0)Ypb(17,(b[a+104>>0]|0)!=0,c);r=a+52|0;if((f[r>>2]|0)>0){d=a+60|0;q=0;do{Opb(18,f[(f[d>>2]|0)+4+(q<<2)>>2]|0,c);q=q+1|0}while((q|0)<(f[r>>2]|0))}r=f[a+4>>2]|0;if(!(r&1))return;aQb(r&-2,c);return}function Q0a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function R0a(a){a=a|0;return f[a+12>>2]|0}function S0a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+72>>2]|0;b[d>>0]=8;i=d+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=e}b[m>>0]=n;g=m+1|0;h=f[c>>2]|0}if(!(h&2))o=g;else{h=b[a+112>>0]|0;b[g>>0]=16;b[g+1>>0]=h;o=g+2|0}g=a+16|0;if((f[g>>2]|0)>0){h=a+24|0;m=0;n=o;while(1){e=f[(f[h>>2]|0)+4+(m<<2)>>2]|0;b[n>>0]=24;i=n+1|0;if(e>>>0>127){j=e;d=i;while(1){b[d>>0]=j|128;k=j>>>7;l=d+1|0;if(j>>>0>16383){j=k;d=l}else{p=l;q=k;break}}}else{p=i;q=e}b[p>>0]=q;d=p+1|0;m=m+1|0;if((m|0)>=(f[g>>2]|0)){r=d;break}else n=d}}else r=o;o=a+28|0;if((f[o>>2]|0)>0){n=a+36|0;g=0;m=r;while(1){p=f[(f[n>>2]|0)+4+(g<<2)>>2]|0;b[m>>0]=32;q=m+1|0;if(p>>>0>127){h=p;d=q;while(1){b[d>>0]=h|128;j=h>>>7;k=d+1|0;if(h>>>0>16383){h=j;d=k}else{s=k;t=j;break}}}else{s=q;t=p}b[s>>0]=t;d=s+1|0;g=g+1|0;if((g|0)>=(f[o>>2]|0)){u=d;break}else m=d}}else u=r;if(!(f[c>>2]&4096))v=u;else{r=f[a+116>>2]|0;b[u>>0]=40;m=u+1|0;if(r>>>0>127){u=r;o=m;while(1){b[o>>0]=u|128;g=u>>>7;s=o+1|0;if(u>>>0>16383){u=g;o=s}else{w=s;x=g;break}}}else{w=m;x=r}b[w>>0]=x;v=w+1|0}w=a+40|0;if((f[w>>2]|0)>0){x=a+48|0;r=0;m=v;while(1){o=f[(f[x>>2]|0)+4+(r<<2)>>2]|0;b[m>>0]=48;u=m+1|0;if(o>>>0>127){g=o;s=u;while(1){b[s>>0]=g|128;t=g>>>7;n=s+1|0;if(g>>>0>16383){g=t;s=n}else{y=n;z=t;break}}}else{y=u;z=o}b[y>>0]=z;s=y+1|0;r=r+1|0;if((r|0)>=(f[w>>2]|0)){A=s;break}else m=s}}else A=v;v=f[c>>2]|0;if(!(v&8192)){B=A;C=v}else{v=f[a+64>>2]|0;b[A>>0]=58;m=A+1|0;A=f[v+12>>2]|0;if(A>>>0>127){w=A;r=m;while(1){b[r>>0]=w|128;y=w>>>7;z=r+1|0;if(w>>>0>16383){w=y;r=z}else{D=z;E=y;break}}}else{D=m;E=A}b[D>>0]=E;E=li[f[(f[v>>2]|0)+68>>2]&511](v,0,D+1|0)|0;B=E;C=f[c>>2]|0}if(!(C&16384)){F=B;G=C}else{C=f[a+68>>2]|0;b[B>>0]=66;E=B+1|0;B=f[C+12>>2]|0;if(B>>>0>127){D=B;v=E;while(1){b[v>>0]=D|128;A=D>>>7;m=v+1|0;if(D>>>0>16383){D=A;v=m}else{H=m;I=A;break}}}else{H=E;I=B}b[H>>0]=I;I=li[f[(f[C>>2]|0)+68>>2]&511](C,0,H+1|0)|0;F=I;G=f[c>>2]|0}if(!(G&64)){J=F;K=G}else{G=f[a+76>>2]|0;b[F>>0]=72;I=F+1|0;if(G>>>0>127){F=G;H=I;while(1){b[H>>0]=F|128;C=F>>>7;B=H+1|0;if(F>>>0>16383){F=C;H=B}else{L=B;M=C;break}}}else{L=I;M=G}b[L>>0]=M;J=L+1|0;K=f[c>>2]|0}if(!(K&128)){N=J;O=K}else{K=f[a+80>>2]|0;b[J>>0]=80;L=J+1|0;if(K>>>0>127){J=K;M=L;while(1){b[M>>0]=J|128;G=J>>>7;I=M+1|0;if(J>>>0>16383){J=G;M=I}else{P=I;Q=G;break}}}else{P=L;Q=K}b[P>>0]=Q;N=P+1|0;O=f[c>>2]|0}if(!(O&256)){R=N;S=O}else{O=f[a+84>>2]|0;b[N>>0]=88;P=N+1|0;if(O>>>0>127){N=O;Q=P;while(1){b[Q>>0]=N|128;K=N>>>7;L=Q+1|0;if(N>>>0>16383){N=K;Q=L}else{T=L;U=K;break}}}else{T=P;U=O}b[T>>0]=U;R=T+1|0;S=f[c>>2]|0}if(!(S&512)){V=R;W=S}else{S=f[a+88>>2]|0;b[R>>0]=96;T=R+1|0;if(S>>>0>127){R=S;U=T;while(1){b[U>>0]=R|128;O=R>>>7;P=U+1|0;if(R>>>0>16383){R=O;U=P}else{X=P;Y=O;break}}}else{X=T;Y=S}b[X>>0]=Y;V=X+1|0;W=f[c>>2]|0}if(!(W&1024)){Z=V;_=W}else{W=f[a+92>>2]|0;b[V>>0]=104;X=V+1|0;if(W>>>0>127){V=W;Y=X;while(1){b[Y>>0]=V|128;S=V>>>7;T=Y+1|0;if(V>>>0>16383){V=S;Y=T}else{$=T;aa=S;break}}}else{$=X;aa=W}b[$>>0]=aa;Z=$+1|0;_=f[c>>2]|0}if(!(_&2048)){ba=Z;ca=_}else{_=f[a+96>>2]|0;b[Z>>0]=112;$=Z+1|0;if(_>>>0>127){Z=_;aa=$;while(1){b[aa>>0]=Z|128;W=Z>>>7;X=aa+1|0;if(Z>>>0>16383){Z=W;aa=X}else{da=X;ea=W;break}}}else{da=$;ea=_}b[da>>0]=ea;ba=da+1|0;ca=f[c>>2]|0}do if(!(ca&32768))fa=ba;else{da=f[a+100>>2]|0;b[ba>>0]=120;ea=ba+1|0;if((da|0)<0){fa=hob(da,((da|0)<0)<<31>>31,ea)|0;break}if(da>>>0>127){_=da;$=ea;while(1){b[$>>0]=_|128;aa=_>>>7;Z=$+1|0;if(_>>>0>16383){_=aa;$=Z}else{ga=Z;ha=aa;break}}}else{ga=ea;ha=da}b[ga>>0]=ha;fa=ga+1|0}while(0);do if(!(f[c>>2]&65536))ia=fa;else{ga=f[a+108>>2]|0;b[fa>>0]=-128;b[fa+1>>0]=1;ha=fa+2|0;if((ga|0)<0){ia=hob(ga,((ga|0)<0)<<31>>31,ha)|0;break}if(ga>>>0>127){ba=ga;ca=ha;while(1){b[ca>>0]=ba|128;$=ba>>>7;_=ca+1|0;if(ba>>>0>16383){ba=$;ca=_}else{ja=_;ka=$;break}}}else{ja=ha;ka=ga}b[ja>>0]=ka;ia=ja+1|0}while(0);if(!(f[c>>2]&131072))la=ia;else{c=b[a+104>>0]|0;b[ia>>0]=-120;b[ia+1>>0]=1;b[ia+2>>0]=c;la=ia+3|0}ia=a+52|0;if((f[ia>>2]|0)>0){c=a+60|0;ja=0;ka=la;while(1){fa=f[(f[c>>2]|0)+4+(ja<<2)>>2]|0;b[ka>>0]=-112;b[ka+1>>0]=1;ca=ka+2|0;if(fa>>>0>127){ba=fa;da=ca;while(1){b[da>>0]=ba|128;ea=ba>>>7;$=da+1|0;if(ba>>>0>16383){ba=ea;da=$}else{ma=$;na=ea;break}}}else{ma=ca;na=fa}b[ma>>0]=na;da=ma+1|0;ja=ja+1|0;if((ja|0)>=(f[ia>>2]|0)){oa=da;break}else ka=da}}else oa=la;la=f[a+4>>2]|0;if(!(la&1)){pa=oa;return pa|0}pa=bQb(la&-2,oa)|0;return pa|0}function T0a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function U0a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(26044);c=T6b(b,23288,19528,0)|0;if(!c){cOb(b,a);return}else{JOa(a,c);return}}function V0a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function W0a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213091];f[a+4>>2]=f[213092];u=c;return}function X0a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function Y0a(a){a=a|0;var b=0,c=0;f[a>>2]=113724;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function Z0a(a){a=a|0;var b=0,c=0;f[a>>2]=113724;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function _0a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function $0a(a,b){a=a|0;b=b|0;a=L5b(24)|0;HOa(a);if(!b)return a|0;l1a(b,a);return a|0}function a1a(a){a=a|0;var c=0;c=a+8|0;if(f[c>>2]&3|0){n[a+20>>2]=1.0;b[a+16>>0]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function b1a(a){a=a|0;return 1}
function c1a(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(!(b&3))c=0;else c=(b&1|0?5:0)|b&2;b=f[a+4>>2]|0;if(!(b&1)){d=c;e=a+12|0;f[e>>2]=d;return d|0}d=(dQb(b&-2)|0)+c|0;e=a+12|0;f[e>>2]=d;return d|0}function d1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Wpb(1,+n[a+20>>2],c);g=f[d>>2]|0}if(g&2|0)Ypb(2,(b[a+16>>0]|0)!=0,c);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,c);return}function e1a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function f1a(a){a=a|0;return f[a+12>>2]|0}function g1a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+20>>2]|0;b[d>>0]=13;i=d+1|0;b[i>>0]=e;b[i+1>>0]=e>>8;b[i+2>>0]=e>>16;b[i+3>>0]=e>>24;g=d+5|0;h=f[c>>2]|0}if(!(h&2))j=g;else{h=b[a+16>>0]|0;b[g>>0]=16;b[g+1>>0]=h;j=g+2|0}g=f[a+4>>2]|0;if(!(g&1)){k=j;return k|0}k=bQb(g&-2,j)|0;return k|0}function h1a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function i1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((a|0)==(c|0))jMa(25040);d=T6b(c,23288,19544,0)|0;if(!d){cOb(c,a);return}c=d+8|0;e=f[c>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=f[d+20>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;f[a+20>>2]=e;g=f[c>>2]|0}if(g&2|0){g=b[d+16>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|2;b[a+16>>0]=g}}g=f[d+4>>2]|0;if(!(g&1))return;LPb(g&-2,a+4|0);return}function j1a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function k1a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213089];f[a+4>>2]=f[213090];u=c;return}function l1a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function m1a(a){a=a|0;var b=0,c=0;f[a>>2]=113616;if((a|0)!=494800?(b=f[a+16>>2]|0,b|0):0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function n1a(a){a=a|0;m1a(a);O5b(a);return}function o1a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function p1a(a,b){a=a|0;b=b|0;a=L5b(28)|0;D1a(a);if(!b)return a|0;E1a(b,a);return a|0}function q1a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+8|0;c=f[b>>2]|0;if((c&7|0?(f[a+20>>2]=1,f[a+24>>2]=1,c&4|0):0)?(c=f[a+16>>2]|0,c|0):0){d=c+8|0;e=f[d>>2]|0;if(e&255|0){g=c+20|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if(e&1|0?(e=f[213028]|0,g=f[c+16>>2]|0,(g|0)!=(e|0)):0)_5b(g,e)|0;n[c+40>>2]=1.0;n[c+44>>2]=1.0;f[c+36>>2]=-1}f[d>>2]=0;d=f[c+4>>2]|0;if(d&1|0?(c=d&-2,f[c>>2]|0):0)GPb(c)}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function r1a(a){a=a|0;return 1}function s1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+20|0;k=a+24|0;l=a+16|0;m=e+4|0;n=c+32|0;o=c+12|0;p=c+28|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[h>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[h>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=41}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=47;break a;break}case 8:break;default:{z=t;break b}}f[i>>2]=f[i>>2]|1;s=f[c>>2]|0;a=f[g>>2]|0;if(s>>>0<a>>>0){r=b[s>>0]|0;A=r&255;if(r<<24>>24>-1){r=s+1|0;f[c>>2]=r;B=A;C=r;D=a}else{E=A;v=11}}else{E=0;v=11}if((v|0)==11){v=0;A=Knb(c,E)|0;a=J;if(!((a|0)>-1|(a|0)==-1&A>>>0>4294967295)){y=0;v=47;break a}B=A;C=f[c>>2]|0;D=f[g>>2]|0}f[j>>2]=B;if(C>>>0>=D>>>0)continue a;if((b[C>>0]|0)!=16)continue a;A=C+1|0;f[c>>2]=A;F=A;G=D;v=18;break}case 2:{switch(t|0){case 0:{y=1;v=47;break a;break}case 16:break;default:{z=t;break b}}F=f[c>>2]|0;G=f[g>>2]|0;v=18;break}case 3:{switch(t|0){case 0:{y=1;v=47;break a;break}case 26:break;default:{z=t;break b}}break}default:{x=t;v=41;break b}}if((v|0)==18){v=0;f[i>>2]=f[i>>2]|2;if(F>>>0<G>>>0){A=b[F>>0]|0;a=A&255;if(A<<24>>24>-1){A=F+1|0;f[c>>2]=A;H=a;I=A;K=G}else{L=a;v=21}}else{L=0;v=21}if((v|0)==21){v=0;a=Knb(c,L)|0;A=J;if(!((A|0)>-1|(A|0)==-1&a>>>0>4294967295)){y=0;v=47;break a}H=a;I=f[c>>2]|0;K=f[g>>2]|0}f[k>>2]=H;if(I>>>0>=K>>>0)continue a;if((b[I>>0]|0)!=26)continue a;f[c>>2]=I+1}f[i>>2]=f[i>>2]|4;a=f[l>>2]|0;if(!a){A=L5b(48)|0;GNa(A);f[l>>2]=A;M=A}else M=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(A=b[a>>0]|0,A<<24>>24>-1):0){f[c>>2]=a+1;N=A&255}else{A=Znb(c)|0;if((A|0)>-1)N=A;else{y=0;v=47;break a}}Inb(e,c,N);if((f[m>>2]|0)<0){v=35;break a}if(!(JNa(M,c)|0)){v=35;break a}if(!(Onb(c,f[e>>2]|0)|0)){y=0;v=47;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[n>>2]|0){v=40;break a}if((f[o>>2]|0)==(f[p>>2]|0)){v=40;break a}else continue a}while(0);if((v|0)==41){v=0;if(!x){y=1;v=47;break}else z=x}if((z&7|0)==4){y=1;v=47;break}A=f[q>>2]|0;if(!(A&1))O=hBa(q)|0;else O=A&-2;if(!(ZPb(c,z,O)|0)){y=0;v=47;break}}if((v|0)==35){y=0;u=d;return y|0}else if((v|0)==40){f[h>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==47){u=d;return y|0}return 0}function t1a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=a+8|0;c=f[b>>2]|0;if(c&7){if(c&1){d=f[a+20>>2]|0;if((d|0)>=0)if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}else{e=11;g=c}}else{e=0;g=c}if(!(g&2)){i=e;j=g}else{c=f[a+24>>2]|0;if((c|0)>=0)if(c>>>0<128){k=2;l=g}else{h=(iob(c)|0)+1|0;k=h;l=f[b>>2]|0}else{k=11;l=g}i=k+e|0;j=l}if(!(j&4))m=i;else{j=INa(f[a+16>>2]|0)|0;if(j>>>0<128)n=1;else n=iob(j)|0;m=i+1+j+n|0}}else m=0;n=f[a+4>>2]|0;if(!(n&1)){o=m;p=a+12|0;f[p>>2]=o;return o|0}o=(dQb(n&-2)|0)+m|0;p=a+12|0;f[p>>2]=o;return o|0}function u1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Mpb(1,f[a+20>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{Mpb(2,f[a+24>>2]|0,b);g=f[c>>2]|0}if(g&4|0)eqb(3,f[a+16>>2]|0,b);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,b);return}function v1a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function w1a(a){a=a|0;return f[a+12>>2]|0}function x1a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+20>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);do if(!(f[c>>2]&2))o=e;else{m=f[a+24>>2]|0;b[e>>0]=16;n=e+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){d=m;j=n;while(1){b[j>>0]=d|128;i=d>>>7;k=j+1|0;if(d>>>0>16383){d=i;j=k}else{p=k;q=i;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}while(0);if(!(f[c>>2]&4))r=o;else{c=f[a+16>>2]|0;b[o>>0]=26;p=o+1|0;o=f[c+12>>2]|0;if(o>>>0>127){q=o;e=p;while(1){b[e>>0]=q|128;j=q>>>7;d=e+1|0;if(q>>>0>16383){q=j;e=d}else{s=d;t=j;break}}}else{s=p;t=o}b[s>>0]=t;r=li[f[(f[c>>2]|0)+68>>2]&511](c,0,s+1|0)|0}s=f[a+4>>2]|0;if(!(s&1)){u=r;return u|0}u=bQb(s&-2,r)|0;return u|0}function y1a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function z1a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(24649);c=T6b(b,23288,19560,0)|0;if(!c){cOb(b,a);return}else{C1a(a,c);return}}function A1a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function B1a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213087];f[a+4>>2]=f[213088];u=c;return}function C1a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=b+8|0;d=f[c>>2]|0;do if(d&255|0){if(!(d&1))e=d;else{g=f[b+20>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;f[a+20>>2]=g;e=f[c>>2]|0}if(!(e&2))i=e;else{g=f[b+24>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|2;f[a+24>>2]=g;i=f[c>>2]|0}if(i&4|0){g=a+8|0;f[g>>2]=f[g>>2]|4;g=a+16|0;h=f[g>>2]|0;if(!h){j=L5b(48)|0;GNa(j);f[g>>2]=j;k=j}else k=h;h=f[b+16>>2]|0;j=(h|0)==0?493544:h;if((j|0)==(k|0))jMa(8763);else{HNa(k,j);break}}}while(0);k=f[b+4>>2]|0;if(!(k&1))return;LPb(k&-2,a+4|0);return}function D1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=113616;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=494800?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=1;f[a+24>>2]=1;u=c;return}function E1a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function F1a(a){a=a|0;var b=0,c=0;f[a>>2]=113508;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function G1a(a){a=a|0;var b=0,c=0;f[a>>2]=113508;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function H1a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function I1a(a,b){a=a|0;b=b|0;a=L5b(28)|0;V1a(a);if(!b)return a|0;W1a(b,a);return a|0}function J1a(a){a=a|0;var c=0;c=a+8|0;if(f[c>>2]&7|0){b[a+16>>0]=0;n[a+20>>2]=.9990000128746033;n[a+24>>2]=9.999999747378752e-06}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function K1a(a){a=a|0;return 1}function L1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+16|0;l=e+8|0;m=a+20|0;n=a+24|0;o=c+32|0;p=c+12|0;q=c+28|0;r=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){s=b[a>>0]|0;t=s&255;if(s<<24>>24>0){f[i>>2]=t;f[c>>2]=a+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=_nb(c,x)|0;f[i>>2]=t;if((t+-1|0)>>>0<127){v=t;w=6}else{y=t;w=37}}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{switch(v|0){case 0:{z=1;w=43;break a;break}case 8:break;default:{A=v;break b}}f[j>>2]=f[j>>2]|1;t=f[c>>2]|0;a=f[g>>2]|0;if(t>>>0<a>>>0?(s=b[t>>0]|0,s<<24>>24>-1):0){B=t+1|0;f[c>>2]=B;C=a;D=s<<24>>24!=0;E=B}else{Lnb(e,c);B=e;if(!(b[l>>0]|0)){z=0;w=43;break a}C=f[g>>2]|0;D=(f[B>>2]|0)!=0|(f[B+4>>2]|0)!=0;E=f[c>>2]|0}b[k>>0]=D&1;if(E>>>0>=C>>>0)continue a;if((b[E>>0]|0)!=21)continue a;B=E+1|0;f[c>>2]=B;F=C;G=B;H=C;w=18;break}case 2:{switch(v|0){case 0:{z=1;w=43;break a;break}case 21:break;default:{A=v;break b}}B=f[g>>2]|0;F=B;G=f[c>>2]|0;H=B;w=18;break}case 3:{switch(v|0){case 0:{z=1;w=43;break a;break}case 29:break;default:{A=v;break b}}B=f[g>>2]|0;I=B;J=f[c>>2]|0;K=B;break}default:{y=v;w=37;break b}}if((w|0)==18){w=0;f[j>>2]=f[j>>2]|2;if((H-G|0)>3){B=G;s=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[e>>2]=s;B=G+4|0;f[c>>2]=B;L=H;M=s;N=B;O=F}else{if(!(Xnb(c,e)|0)){w=22;break a}B=f[g>>2]|0;L=B;M=f[e>>2]|0;N=f[c>>2]|0;O=B}f[m>>2]=M;if(N>>>0>=O>>>0)continue a;if((b[N>>0]|0)!=29)continue a;B=N+1|0;f[c>>2]=B;I=O;J=B;K=L}f[j>>2]=f[j>>2]|4;if((K-J|0)>3){B=J;s=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[e>>2]=s;B=J+4|0;f[c>>2]=B;P=s;Q=B;R=I}else{if(!(Xnb(c,e)|0)){w=32;break a}P=f[e>>2]|0;Q=f[c>>2]|0;R=f[g>>2]|0}f[n>>2]=P;if((Q|0)!=(R|0))continue a;if(f[o>>2]|0){w=36;break a}if((f[p>>2]|0)==(f[q>>2]|0)){w=36;break a}else continue a}while(0);if((w|0)==37){w=0;if(!y){z=1;w=43;break}else A=y}if((A&7|0)==4){z=1;w=43;break}B=f[r>>2]|0;if(!(B&1))S=hBa(r)|0;else S=B&-2;if(!(ZPb(c,A,S)|0)){z=0;w=43;break}}if((w|0)==22){z=0;u=d;return z|0}else if((w|0)==32){z=0;u=d;return z|0}else if((w|0)==36){f[i>>2]=0;b[c+24>>0]=1;z=1;u=d;return z|0}else if((w|0)==43){u=d;return z|0}return 0}function M1a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a+8>>2]|0;if(!(b&7))c=0;else{d=b<<1&2;e=b&2|0?d|5:d;c=b&4|0?e+5|0:e}e=f[a+4>>2]|0;if(!(e&1)){g=c;h=a+12|0;f[h>>2]=g;return g|0}g=(dQb(e&-2)|0)+c|0;h=a+12|0;f[h>>2]=g;return g|0}function N1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Ypb(1,(b[a+16>>0]|0)!=0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{Wpb(2,+n[a+20>>2],c);h=f[d>>2]|0}if(h&4|0)Wpb(3,+n[a+24>>2],c);h=f[a+4>>2]|0;if(!(h&1))return;aQb(h&-2,c);return}function O1a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function P1a(a){a=a|0;return f[a+12>>2]|0}function Q1a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=b[a+16>>0]|0;b[d>>0]=8;b[d+1>>0]=e;g=d+2|0;h=f[c>>2]|0}if(!(h&2)){i=g;j=h}else{h=f[a+20>>2]|0;b[g>>0]=21;d=g+1|0;b[d>>0]=h;b[d+1>>0]=h>>8;b[d+2>>0]=h>>16;b[d+3>>0]=h>>24;i=g+5|0;j=f[c>>2]|0}if(!(j&4))k=i;else{j=f[a+24>>2]|0;b[i>>0]=29;c=i+1|0;b[c>>0]=j;b[c+1>>0]=j>>8;b[c+2>>0]=j>>16;b[c+3>>0]=j>>24;k=i+5|0}i=f[a+4>>2]|0;if(!(i&1)){l=k;return l|0}l=bQb(i&-2,k)|0;return l|0}function R1a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function S1a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((a|0)==(c|0))jMa(24232);d=T6b(c,23288,19576,0)|0;if(!d){cOb(c,a);return}c=d+8|0;e=f[c>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=b[d+16>>0]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;b[a+16>>0]=e;g=f[c>>2]|0}if(!(g&2))i=g;else{g=f[d+20>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;f[a+20>>2]=g;i=f[c>>2]|0}if(i&4|0){i=f[d+24>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|4;f[a+24>>2]=i}}i=f[d+4>>2]|0;if(!(i&1))return;LPb(i&-2,a+4|0);return}function T1a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function U1a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213085];f[a+4>>2]=f[213086];u=c;return}function V1a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=113508;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=494760?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;b[a+16>>0]=0;n[a+20>>2]=.9990000128746033;n[a+24>>2]=9.999999747378752e-06;u=c;return}function W1a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function X1a(a){a=a|0;var b=0,c=0;f[a>>2]=113400;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function Y1a(a){a=a|0;var b=0,c=0;f[a>>2]=113400;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function Z1a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function _1a(a,b){a=a|0;b=b|0;a=L5b(24)|0;GOa(a);if(!b)return a|0;k2a(b,a);return a|0}function $1a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&3|0){f[a+16>>2]=1;f[a+20>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function a2a(a){a=a|0;return 1}function b2a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+8|0;c=f[b>>2]|0;if(c&3){if(c&1){d=f[a+16>>2]|0;if((d|0)>=0)if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}else{e=11;g=c}}else{e=0;g=c}if(!(g&2))i=e;else{g=f[a+20>>2]|0;if(g>>>0<128)j=2;else j=(iob(g)|0)+1|0;i=j+e|0}}else i=0;e=f[a+4>>2]|0;if(!(e&1)){k=i;l=a+12|0;f[l>>2]=k;return k|0}k=(dQb(e&-2)|0)+i|0;l=a+12|0;f[l>>2]=k;return k|0}function c2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(!(d&2))e=d;else{Opb(1,f[a+20>>2]|0,b);e=f[c>>2]|0}if(e&1|0)Mpb(2,f[a+16>>2]|0,b);e=f[a+4>>2]|0;if(!(e&1))return;aQb(e&-2,b);return}function d2a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function e2a(a){a=a|0;return f[a+12>>2]|0}function f2a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+8|0;e=f[c>>2]|0;if(!(e&2)){g=d;h=e}else{e=f[a+20>>2]|0;b[d>>0]=8;i=d+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=e}b[m>>0]=n;g=m+1|0;h=f[c>>2]|0}do if(!(h&1))o=g;else{c=f[a+16>>2]|0;b[g>>0]=16;m=g+1|0;if((c|0)<0){o=hob(c,((c|0)<0)<<31>>31,m)|0;break}if(c>>>0>127){n=c;e=m;while(1){b[e>>0]=n|128;i=n>>>7;j=e+1|0;if(n>>>0>16383){n=i;e=j}else{p=j;q=i;break}}}else{p=m;q=c}b[p>>0]=q;o=p+1|0}while(0);p=f[a+4>>2]|0;if(!(p&1)){r=o;return r|0}r=bQb(p&-2,o)|0;return r|0}function g2a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function h2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))jMa(23857);c=T6b(b,23288,19592,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[b>>2]|0}if(e&2|0){e=f[c+20>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|2;f[a+20>>2]=e}}e=f[c+4>>2]|0;if(!(e&1))return;LPb(e&-2,a+4|0);return}function i2a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function j2a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213083];f[a+4>>2]=f[213084];u=c;return}function k2a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function l2a(a){a=a|0;var b=0,c=0;f[a>>2]=113292;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function m2a(a){a=a|0;var b=0,c=0;f[a>>2]=113292;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function n2a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function o2a(a,b){a=a|0;b=b|0;a=L5b(28)|0;FOa(a);if(!b)return a|0;A2a(b,a);return a|0}function p2a(a){a=a|0;var b=0,c=0;b=a+8|0;if(f[b>>2]&7|0){c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[a+24>>2]=1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function q2a(a){a=a|0;return 1}function r2a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=a+8|0;c=f[b>>2]|0;if(c&7){d=c<<1&2;if(!(c&2)){e=d;g=c}else{h=f[a+24>>2]|0;if(h>>>0<128){i=2;j=c}else{c=(iob(h)|0)+1|0;i=c;j=f[b>>2]|0}e=i+d|0;g=j}if(!(g&4))k=e;else{g=f[a+20>>2]|0;if((g|0)>=0)if(g>>>0<128)l=2;else l=(iob(g)|0)+1|0;else l=11;k=l+e|0}}else k=0;e=f[a+4>>2]|0;if(!(e&1)){m=k;n=a+12|0;f[n>>2]=m;return m|0}m=(dQb(e&-2)|0)+k|0;n=a+12|0;f[n>>2]=m;return m|0}function s2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Ypb(1,(b[a+16>>0]|0)!=0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{Opb(2,f[a+24>>2]|0,c);h=f[d>>2]|0}if(h&4|0)Mpb(3,f[a+20>>2]|0,c);h=f[a+4>>2]|0;if(!(h&1))return;aQb(h&-2,c);return}function t2a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function u2a(a){a=a|0;return f[a+12>>2]|0}function v2a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=b[a+16>>0]|0;b[d>>0]=8;b[d+1>>0]=e;g=d+2|0;h=f[c>>2]|0}if(!(h&2)){i=g;j=h}else{h=f[a+24>>2]|0;b[g>>0]=16;d=g+1|0;if(h>>>0>127){g=h;e=d;while(1){b[e>>0]=g|128;k=g>>>7;l=e+1|0;if(g>>>0>16383){g=k;e=l}else{m=l;n=k;break}}}else{m=d;n=h}b[m>>0]=n;i=m+1|0;j=f[c>>2]|0}do if(!(j&4))o=i;else{c=f[a+20>>2]|0;b[i>>0]=24;m=i+1|0;if((c|0)<0){o=hob(c,((c|0)<0)<<31>>31,m)|0;break}if(c>>>0>127){n=c;h=m;while(1){b[h>>0]=n|128;d=n>>>7;e=h+1|0;if(n>>>0>16383){n=d;h=e}else{p=e;q=d;break}}}else{p=m;q=c}b[p>>0]=q;o=p+1|0}while(0);p=f[a+4>>2]|0;if(!(p&1)){r=o;return r|0}r=bQb(p&-2,o)|0;return r|0}function w2a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function x2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((a|0)==(c|0))jMa(23483);d=T6b(c,23288,19608,0)|0;if(!d){cOb(c,a);return}c=d+8|0;e=f[c>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=b[d+16>>0]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;b[a+16>>0]=e;g=f[c>>2]|0}if(!(g&2))i=g;else{g=f[d+24>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;f[a+24>>2]=g;i=f[c>>2]|0}if(i&4|0){i=f[d+20>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|4;f[a+20>>2]=i}}i=f[d+4>>2]|0;if(!(i&1))return;LPb(i&-2,a+4|0);return}function y2a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function z2a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213081];f[a+4>>2]=f[213082];u=c;return}function A2a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function B2a(a){a=a|0;var b=0,c=0;f[a>>2]=113184;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function C2a(a){a=a|0;var b=0,c=0;f[a>>2]=113184;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function D2a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function E2a(a,b){a=a|0;b=b|0;a=L5b(28)|0;EOa(a);if(!b)return a|0;P2a(b,a);return a|0}function F2a(a){a=a|0;var b=0;b=a+8|0;if(f[b>>2]&7|0){f[a+20>>2]=1;f[a+24>>2]=1;f[a+16>>2]=0}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function G2a(a){a=a|0;return 1}function H2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Opb(1,f[a+20>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{Mpb(2,f[a+24>>2]|0,b);g=f[c>>2]|0}if(g&4|0)Mpb(3,f[a+16>>2]|0,b);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,b);return}function I2a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function J2a(a){a=a|0;return f[a+12>>2]|0}function K2a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+20>>2]|0;b[d>>0]=8;i=d+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=e}b[m>>0]=n;g=m+1|0;h=f[c>>2]|0}do if(!(h&2))o=g;else{m=f[a+24>>2]|0;b[g>>0]=16;n=g+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){e=m;i=n;while(1){b[i>>0]=e|128;j=e>>>7;d=i+1|0;if(e>>>0>16383){e=j;i=d}else{p=d;q=j;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}while(0);do if(!(f[c>>2]&4))r=o;else{p=f[a+16>>2]|0;b[o>>0]=24;q=o+1|0;if((p|0)<0){r=hob(p,((p|0)<0)<<31>>31,q)|0;break}if(p>>>0>127){g=p;h=q;while(1){b[h>>0]=g|128;i=g>>>7;e=h+1|0;if(g>>>0>16383){g=i;h=e}else{s=e;t=i;break}}}else{s=q;t=p}b[s>>0]=t;r=s+1|0}while(0);s=f[a+4>>2]|0;if(!(s&1)){u=r;return u|0}u=bQb(s&-2,r)|0;return u|0}function L2a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function M2a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((a|0)==(b|0))jMa(23057);c=T6b(b,23288,19624,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+20>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+20>>2]=d;e=f[b>>2]|0}if(!(e&2))h=e;else{e=f[c+24>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+24>>2]=e;h=f[b>>2]|0}if(h&4|0){h=f[c+16>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|4;f[a+16>>2]=h}}h=f[c+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function N2a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function O2a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213079];f[a+4>>2]=f[213080];u=c;return}function P2a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function Q2a(a){a=a|0;var b=0,c=0;f[a>>2]=113076;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function R2a(a){a=a|0;var b=0,c=0;f[a>>2]=113076;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function S2a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function T2a(a,b){a=a|0;b=b|0;a=L5b(28)|0;rPa(a);if(!b)return a|0;c3a(b,a);return a|0}function U2a(a){a=a|0;var c=0,d=0;c=a+8|0;if(f[c>>2]&7|0){d=a+16|0;f[d>>2]=0;b[d+4>>0]=0;f[a+24>>2]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function V2a(a){a=a|0;return 1}function W2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Mpb(1,f[a+16>>2]|0,c);g=f[d>>2]|0}if(!(g&4))h=g;else{Ypb(2,(b[a+20>>0]|0)!=0,c);h=f[d>>2]|0}if(h&2|0)Zpb(3,f[a+24>>2]|0,c);h=f[a+4>>2]|0;if(!(h&1))return;aQb(h&-2,c);return}function X2a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function Y2a(a){a=a|0;return f[a+12>>2]|0}function Z2a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);m=f[c>>2]|0;if(!(m&4)){o=e;p=m}else{m=b[a+20>>0]|0;b[e>>0]=16;b[e+1>>0]=m;o=e+2|0;p=f[c>>2]|0}do if(!(p&2))q=o;else{c=f[a+24>>2]|0;b[o>>0]=24;e=o+1|0;if((c|0)<0){q=hob(c,((c|0)<0)<<31>>31,e)|0;break}if(c>>>0>127){m=c;n=e;while(1){b[n>>0]=m|128;d=m>>>7;j=n+1|0;if(m>>>0>16383){m=d;n=j}else{r=j;s=d;break}}}else{r=e;s=c}b[r>>0]=s;q=r+1|0}while(0);r=f[a+4>>2]|0;if(!(r&1)){t=q;return t|0}t=bQb(r&-2,q)|0;return t|0}function _2a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function $2a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((a|0)==(c|0))jMa(22647);d=T6b(c,23288,19640,0)|0;if(!d){cOb(c,a);return}c=d+8|0;e=f[c>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=f[d+16>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;f[a+16>>2]=e;g=f[c>>2]|0}if(!(g&2))i=g;else{g=f[d+24>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;f[a+24>>2]=g;i=f[c>>2]|0}if(i&4|0){i=b[d+20>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|4;b[a+20>>0]=i}}i=f[d+4>>2]|0;if(!(i&1))return;LPb(i&-2,a+4|0);return}function a3a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function b3a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213076];f[a+4>>2]=f[213077];u=c;return}function c3a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function d3a(a){a=a|0;var c=0,d=0;f[a>>2]=112968;c=a+28|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(d);f[c>>2]=0;return}function e3a(a){a=a|0;d3a(a);O5b(a);return}function f3a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function g3a(a,b){a=a|0;b=b|0;a=L5b(44)|0;pPa(a);if(!b)return a|0;r3a(b,a);return a|0}function h3a(a){a=a|0;var c=0,e=0,g=0,h=0;c=a+8|0;e=f[c>>2]|0;do if((e&111|0?(g=a+32|0,f[g>>2]=0,d[g+4>>1]=0,b[g+6>>0]=0,n[a+40>>2]=1.0,e&8|0):0)?(g=f[a+28>>2]|0,(g|0)!=497760):0){h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);f[a+16>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function i3a(a){a=a|0;return 1}function j3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Wpb(1,+n[a+40>>2],c);g=f[d>>2]|0}if(!(g&2))h=g;else{Ypb(2,(b[a+36>>0]|0)!=0,c);h=f[d>>2]|0}if(!(h&4))i=h;else{Opb(3,f[a+32>>2]|0,c);i=f[d>>2]|0}if(i&8|0)$pb(4,f[a+28>>2]|0,c);i=a+16|0;if((f[i>>2]|0)>0){h=a+24|0;g=0;do{Wpb(5,+n[(f[h>>2]|0)+4+(g<<2)>>2],c);g=g+1|0}while((g|0)<(f[i>>2]|0))}i=f[d>>2]|0;if(!(i&32))j=i;else{Ypb(6,(b[a+37>>0]|0)!=0,c);j=f[d>>2]|0}if(j&64|0)Ypb(7,(b[a+38>>0]|0)!=0,c);j=f[a+4>>2]|0;if(!(j&1))return;aQb(j&-2,c);return}function k3a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function l3a(a){a=a|0;return f[a+12>>2]|0}function m3a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+40>>2]|0;b[d>>0]=13;i=d+1|0;b[i>>0]=e;b[i+1>>0]=e>>8;b[i+2>>0]=e>>16;b[i+3>>0]=e>>24;g=d+5|0;h=f[c>>2]|0}if(!(h&2)){j=g;k=h}else{h=b[a+36>>0]|0;b[g>>0]=16;b[g+1>>0]=h;j=g+2|0;k=f[c>>2]|0}if(!(k&4)){l=j;m=k}else{k=f[a+32>>2]|0;b[j>>0]=24;g=j+1|0;if(k>>>0>127){j=k;h=g;while(1){b[h>>0]=j|128;d=j>>>7;e=h+1|0;if(j>>>0>16383){j=d;h=e}else{n=e;o=d;break}}}else{n=g;o=k}b[n>>0]=o;l=n+1|0;m=f[c>>2]|0}if(!(m&8))p=l;else{m=f[a+28>>2]|0;b[l>>0]=34;p=kob(m,l+1|0)|0}l=a+16|0;if((f[l>>2]|0)>0){m=a+24|0;n=0;o=p;while(1){k=f[(f[m>>2]|0)+4+(n<<2)>>2]|0;b[o>>0]=45;g=o+1|0;b[g>>0]=k;b[g+1>>0]=k>>8;b[g+2>>0]=k>>16;b[g+3>>0]=k>>24;k=o+5|0;n=n+1|0;if((n|0)>=(f[l>>2]|0)){q=k;break}else o=k}}else q=p;p=f[c>>2]|0;if(!(p&32)){r=q;s=p}else{p=b[a+37>>0]|0;b[q>>0]=48;b[q+1>>0]=p;r=q+2|0;s=f[c>>2]|0}if(!(s&64))t=r;else{s=b[a+38>>0]|0;b[r>>0]=56;b[r+1>>0]=s;t=r+2|0}r=f[a+4>>2]|0;if(!(r&1)){u=t;return u|0}u=bQb(r&-2,t)|0;return u|0}function n3a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function o3a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(22043);c=T6b(b,23288,19656,0)|0;if(!c){cOb(b,a);return}else{qPa(a,c);return}}function p3a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function q3a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213074];f[a+4>>2]=f[213075];u=c;return}function r3a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function s3a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f[a>>2]=112860;e4a(a);c=a+140|0;d=f[c>>2]|0;if(d|0?(f[a+128>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)bi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=a+124|0;i=f[c>>2]|0;if(i|0?(f[a+112>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;O5b(j)}f[c>>2]=0;c=f[a+108>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=a+96|0;j=f[c>>2]|0;if(j|0?(f[a+84>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;O5b(k)}f[c>>2]=0;c=a+80|0;k=f[c>>2]|0;if(k|0?(f[a+68>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)bi[f[(f[d>>2]|0)+4>>2]&2047](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;O5b(l)}f[c>>2]=0;c=f[a+64>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=a+52|0;l=f[c>>2]|0;if(l|0?(f[a+40>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0){if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);O5b(i)}j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;O5b(m)}f[c>>2]=0;c=a+36|0;m=f[c>>2]|0;if(m|0?(f[a+24>>2]|0)==0:0){l=f[m>>2]|0;if((l|0)>0){k=0;do{j=f[m+4+(k<<2)>>2]|0;if(j|0){if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);O5b(j)}k=k+1|0}while((k|0)!=(l|0));n=f[c>>2]|0}else n=m;O5b(n)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}n=a&-2;a=n;if((n|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(n);f[c>>2]=0;return}function t3a(a){a=a|0;s3a(a);O5b(a);return}function u3a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function v3a(a,b){a=a|0;b=b|0;a=L5b(372)|0;c4a(a);if(!b)return a|0;d4a(b,a);return a|0}function w3a(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=a+8|0;e=f[c>>2]|0;if(!(e&19))g=e;else{h=a+8|0;do if(e&1|0?(i=f[a+144>>2]|0,(i|0)!=497760):0){j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0;break}else{b[i>>0]=0;b[j>>0]=0;break}}while(0);do if(f[h>>2]&2|0?(e=f[a+148>>2]|0,(e|0)!=497760):0){j=e+11|0;if((b[j>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[j>>0]=0;break}}while(0);f[a+368>>2]=0;g=f[c>>2]|0}if(g&63488|0){h=a+8|0;if(g&2048|0?(g=f[a+152>>2]|0,g|0):0){j=g+8|0;e=f[j>>2]|0;do if((e&111|0?(i=g+32|0,f[i>>2]=0,d[i+4>>1]=0,b[i+6>>0]=0,n[g+40>>2]=1.0,e&8|0):0)?(i=f[g+28>>2]|0,(i|0)!=497760):0){k=i+11|0;if((b[k>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0;break}else{b[i>>0]=0;b[k>>0]=0;break}}while(0);f[g+16>>2]=0;f[j>>2]=0;j=f[g+4>>2]|0;if(j&1|0?(g=j&-2,f[g>>2]|0):0)GPb(g)}if(f[h>>2]&4096|0?(g=f[a+156>>2]|0,g|0):0){j=g+8|0;if(f[j>>2]&7|0){e=g+16|0;f[e>>2]=0;b[e+4>>0]=0;f[g+24>>2]=1}f[j>>2]=0;j=f[g+4>>2]|0;if(j&1|0?(g=j&-2,f[g>>2]|0):0)GPb(g)}if(f[h>>2]&8192|0?(g=f[a+160>>2]|0,g|0):0){j=g+8|0;if(f[j>>2]&7|0){f[g+20>>2]=1;f[g+24>>2]=1;f[g+16>>2]=0}f[j>>2]=0;j=f[g+4>>2]|0;if(j&1|0?(g=j&-2,f[g>>2]|0):0)GPb(g)}if(f[h>>2]&16384|0?(g=f[a+164>>2]|0,g|0):0){j=g+8|0;if(f[j>>2]&7|0){e=g+16|0;f[e>>2]=0;f[e+4>>2]=0;f[g+24>>2]=1}f[j>>2]=0;j=f[g+4>>2]|0;if(j&1|0?(g=j&-2,f[g>>2]|0):0)GPb(g)}if(f[h>>2]&32768|0?(h=f[a+168>>2]|0,h|0):0){g=h+8|0;if(f[g>>2]&7|0){b[h+16>>0]=0;n[h+20>>2]=.9990000128746033;n[h+24>>2]=9.999999747378752e-06}f[g>>2]=0;g=f[h+4>>2]|0;if(g&1|0?(h=g&-2,f[h>>2]|0):0)GPb(h)}}h=f[c>>2]|0;if(!(h&16711680))l=h;else{g=a+8|0;if((h&65536|0)!=0?(j=f[a+172>>2]|0,(j|0)!=0):0){q1a(j);m=f[g>>2]|0}else m=h;if(m&131072|0?(m=f[a+176>>2]|0,m|0):0){h=m+8|0;if(f[h>>2]&3|0){f[m+16>>2]=1;f[m+20>>2]=1}f[h>>2]=0;h=f[m+4>>2]|0;if(h&1|0?(m=h&-2,f[m>>2]|0):0)GPb(m)}if(f[g>>2]&262144|0?(m=f[a+180>>2]|0,m|0):0){h=m+8|0;if(f[h>>2]&3|0){n[m+20>>2]=1.0;b[m+16>>0]=0}f[h>>2]=0;h=f[m+4>>2]|0;if(h&1|0?(m=h&-2,f[m>>2]|0):0)GPb(m)}m=f[g>>2]|0;if((m&524288|0)!=0?(h=f[a+184>>2]|0,(h|0)!=0):0){xQa(h);o=f[g>>2]|0}else o=m;if(((o&1048576|0?(o=f[a+188>>2]|0,o|0):0)?(f[o+28>>2]=2,f[o+16>>2]=0,f[o+8>>2]=0,m=f[o+4>>2]|0,m&1|0):0)?(o=m&-2,f[o>>2]|0):0)GPb(o);o=f[g>>2]|0;if((o&2097152|0)!=0?(m=f[a+192>>2]|0,(m|0)!=0):0){yQa(m);p=f[g>>2]|0}else p=o;if((p&4194304|0)!=0?(o=f[a+196>>2]|0,(o|0)!=0):0){a4a(o);q=f[g>>2]|0}else q=p;if(q&8388608|0?(q=f[a+200>>2]|0,q|0):0){p=q+8|0;if(f[p>>2]&3|0){n[q+16>>2]=.5;b[q+20>>0]=1}f[p>>2]=0;p=f[q+4>>2]|0;if(p&1|0?(q=p&-2,f[q>>2]|0):0)GPb(q)}l=f[c>>2]|0}if(l>>>0>16777215){q=a+8|0;if(l&16777216|0?(l=f[a+204>>2]|0,l|0):0){p=l+20|0;g=f[p>>2]|0;if((g|0)>0){o=f[l+28>>2]|0;m=0;do{h=f[o+4+(m<<2)>>2]|0;m=m+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((m|0)!=(g|0));f[p>>2]=0}p=l+36|0;g=f[p>>2]|0;if((g|0)>0){m=f[l+44>>2]|0;o=0;do{h=f[m+4+(o<<2)>>2]|0;o=o+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((o|0)!=(g|0));f[p>>2]=0}f[l+48>>2]=0;f[l+60>>2]=0;f[l+72>>2]=0;f[l+84>>2]=0;f[l+8>>2]=0;p=f[l+4>>2]|0;if(p&1|0?(l=p&-2,f[l>>2]|0):0)GPb(l)}if(f[q>>2]&33554432|0?(l=f[a+208>>2]|0,l|0):0){p=l+8|0;if(f[p>>2]&5|0){f[l+28>>2]=1;b[l+32>>0]=1}f[l+16>>2]=0;f[p>>2]=0;p=f[l+4>>2]|0;if(p&1|0?(l=p&-2,f[l>>2]|0):0)GPb(l)}if(((f[q>>2]&67108864|0?(l=f[a+212>>2]|0,l|0):0)?(n[l+16>>2]=1.0,f[l+8>>2]=0,p=f[l+4>>2]|0,p&1|0):0)?(l=p&-2,f[l>>2]|0):0)GPb(l);l=f[q>>2]|0;if((l&134217728|0)!=0?(p=f[a+216>>2]|0,(p|0)!=0):0){WZa(p);r=f[q>>2]|0}else r=l;if(r&268435456|0?(r=f[a+220>>2]|0,r|0):0){l=r+8|0;if(f[l>>2]&7|0){n[r+20>>2]=-1.0;n[r+24>>2]=1.0;n[r+16>>2]=0.0}f[l>>2]=0;l=f[r+4>>2]|0;if(l&1|0?(r=l&-2,f[r>>2]|0):0)GPb(r)}if(f[q>>2]&536870912|0?(r=f[a+224>>2]|0,r|0):0){l=r+8|0;if(f[l>>2]&3|0){f[r+16>>2]=1;f[r+20>>2]=-1}f[l>>2]=0;l=f[r+4>>2]|0;if(l&1|0?(r=l&-2,f[r>>2]|0):0)GPb(r)}r=f[q>>2]|0;if(!(r&1073741824))s=r;else{r=f[a+228>>2]|0;if(r|0){l=r+8|0;p=f[l>>2]|0;do if((p&7|0?(g=r+20|0,f[g>>2]=0,b[g+4>>0]=0,p&1|0):0)?(g=f[r+16>>2]|0,(g|0)!=497760):0){o=g+11|0;if((b[o>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[o>>0]=0;break}}while(0);f[l>>2]=0;l=f[r+4>>2]|0;if(l&1|0?(r=l&-2,f[r>>2]|0):0)GPb(r)}s=f[q>>2]|0}if((s|0)<0?(s=f[a+232>>2]|0,s|0):0){q=s+8|0;do if(f[q>>2]&1|0?(r=f[s+16>>2]|0,(r|0)!=497760):0){l=r+11|0;if((b[l>>0]|0)<0){b[f[r>>2]>>0]=0;f[r+4>>2]=0;break}else{b[r>>0]=0;b[l>>0]=0;break}}while(0);f[q>>2]=0;q=f[s+4>>2]|0;if(q&1|0?(s=q&-2,f[s>>2]|0):0)GPb(s)}}s=a+12|0;q=f[s>>2]|0;if(q&255|0){if(((q&1|0?(q=f[a+236>>2]|0,q|0):0)?(f[q+16>>2]=1,f[q+8>>2]=0,l=f[q+4>>2]|0,l&1|0):0)?(q=l&-2,f[q>>2]|0):0)GPb(q);q=f[s>>2]|0;if((q&2|0)!=0?(l=f[a+240>>2]|0,(l|0)!=0):0){zQa(l);t=f[s>>2]|0}else t=q;if(t&4|0?(t=f[a+244>>2]|0,t|0):0){q=t+8|0;do if(f[q>>2]&1|0?(l=f[t+16>>2]|0,(l|0)!=497760):0){r=l+11|0;if((b[r>>0]|0)<0){b[f[l>>2]>>0]=0;f[l+4>>2]=0;break}else{b[l>>0]=0;b[r>>0]=0;break}}while(0);f[q>>2]=0;q=f[t+4>>2]|0;if(q&1|0?(t=q&-2,f[t>>2]|0):0)GPb(t)}t=f[s>>2]|0;if((t&8|0)!=0?(q=f[a+248>>2]|0,(q|0)!=0):0){AQa(q);u=f[s>>2]|0}else u=t;if(u&16|0?(u=f[a+252>>2]|0,u|0):0){t=u+20|0;q=f[t>>2]|0;if((q|0)>0){r=f[u+28>>2]|0;l=0;do{p=f[r+4+(l<<2)>>2]|0;l=l+1|0;bi[f[(f[p>>2]|0)+28>>2]&2047](p)}while((l|0)!=(q|0));f[t>>2]=0}f[u+8>>2]=0;t=f[u+4>>2]|0;if(t&1|0?(u=t&-2,f[u>>2]|0):0)GPb(u)}if(f[s>>2]&32|0?(u=f[a+256>>2]|0,u|0):0){t=u+8|0;if(f[t>>2]&7|0){n[u+20>>2]=-1.0;n[u+24>>2]=1.0;n[u+16>>2]=0.0}f[t>>2]=0;t=f[u+4>>2]|0;if(t&1|0?(u=t&-2,f[u>>2]|0):0)GPb(u)}if(f[s>>2]&64|0?(u=f[a+260>>2]|0,u|0):0){t=u+8|0;if(f[t>>2]&63|0){q=u+16|0;f[q>>2]=0;f[q+4>>2]=0;f[u+24>>2]=5;n[u+28>>2]=1.0;n[u+32>>2]=.75;n[u+36>>2]=1.0}f[t>>2]=0;t=f[u+4>>2]|0;if(t&1|0?(u=t&-2,f[u>>2]|0):0)GPb(u)}if(((f[s>>2]&128|0?(u=f[a+264>>2]|0,u|0):0)?(t=u+16|0,f[t>>2]=0,f[t+4>>2]=0,f[t+8>>2]=0,f[t+12>>2]=0,f[u+8>>2]=0,t=f[u+4>>2]|0,t&1|0):0)?(u=t&-2,f[u>>2]|0):0)GPb(u)}u=f[s>>2]|0;if(u&65280|0){if(u&256|0?(u=f[a+268>>2]|0,u|0):0){t=u+8|0;if(f[t>>2]&7|0){b[u+17>>0]=1;b[u+16>>0]=0;n[u+20>>2]=9.999999717180685e-10}f[t>>2]=0;t=f[u+4>>2]|0;if(t&1|0?(u=t&-2,f[u>>2]|0):0)GPb(u)}u=f[s>>2]|0;if((u&512|0)!=0?(t=f[a+272>>2]|0,(t|0)!=0):0){b4a(t);v=f[s>>2]|0}else v=u;if(((v&1024|0?(v=f[a+276>>2]|0,v|0):0)?(f[v+16>>2]=0,f[v+8>>2]=0,u=f[v+4>>2]|0,u&1|0):0)?(v=u&-2,f[v>>2]|0):0)GPb(v);if(f[s>>2]&2048|0?(v=f[a+280>>2]|0,v|0):0){u=v+8|0;if(((f[u>>2]&1|0?(t=f[v+16>>2]|0,t|0):0)?(f[t+16>>2]=0,f[t+8>>2]=0,q=f[t+4>>2]|0,q&1|0):0)?(t=q&-2,f[t>>2]|0):0)GPb(t);f[u>>2]=0;u=f[v+4>>2]|0;if(u&1|0?(v=u&-2,f[v>>2]|0):0)GPb(v)}if(f[s>>2]&4096|0?(v=f[a+284>>2]|0,v|0):0){u=v+8|0;t=f[u>>2]|0;if(t&255|0){q=v+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;f[v+60>>2]=1}if(t&7936|0){t=v+44|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;b[t+12>>0]=0;b[v+64>>0]=1}f[u>>2]=0;u=f[v+4>>2]|0;if(u&1|0?(v=u&-2,f[v>>2]|0):0)GPb(v)}if(f[s>>2]&8192|0?(v=f[a+288>>2]|0,v|0):0){u=v+8|0;if(f[u>>2]&7|0){n[v+20>>2]=1.0;n[v+24>>2]=1.0;n[v+16>>2]=0.0}f[u>>2]=0;u=f[v+4>>2]|0;if(u&1|0?(v=u&-2,f[v>>2]|0):0)GPb(v)}v=f[s>>2]|0;if((v&16384|0)!=0?(u=f[a+292>>2]|0,(u|0)!=0):0){tNa(u);w=f[s>>2]|0}else w=v;if(w&32768|0?(w=f[a+296>>2]|0,w|0):0){v=w+8|0;u=f[v>>2]|0;if(u&219|0){t=w+88|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;b[w+120>>0]=1;b[w+121>>0]=1}if(u&7936|0){u=w+104|0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=0;f[u+12>>2]=0;n[w+124>>2]=.5}f[w+16>>2]=0;f[w+28>>2]=0;f[w+40>>2]=0;f[w+52>>2]=0;f[w+64>>2]=0;f[w+76>>2]=0;f[v>>2]=0;v=f[w+4>>2]|0;if(v&1|0?(w=v&-2,f[w>>2]|0):0)GPb(w)}}w=f[s>>2]|0;if(!(w&16711680))x=w;else{if(w&65536|0?(w=f[a+300>>2]|0,w|0):0){v=w+8|0;if(f[v>>2]&231|0){f[w+40>>2]=16;f[w+44>>2]=16;f[w+48>>2]=16;f[w+52>>2]=6e3;f[w+56>>2]=300;n[w+60>>2]=.699999988079071}f[w+16>>2]=0;f[w+28>>2]=0;f[v>>2]=0;v=f[w+4>>2]|0;if(v&1|0?(w=v&-2,f[w>>2]|0):0)GPb(w)}if(((f[s>>2]&131072|0?(w=f[a+304>>2]|0,w|0):0)?(v=w+16|0,f[v>>2]=0,f[v+4>>2]=0,f[v+8>>2]=0,f[w+8>>2]=0,v=f[w+4>>2]|0,v&1|0):0)?(w=v&-2,f[w>>2]|0):0)GPb(w);w=f[s>>2]|0;if((w&262144|0)!=0?(v=f[a+308>>2]|0,(v|0)!=0):0){OUa(v);y=f[s>>2]|0}else y=w;if((y&524288|0)!=0?(w=f[a+312>>2]|0,(w|0)!=0):0){vUa(w);z=f[s>>2]|0}else z=y;if(z&1048576|0?(z=f[a+316>>2]|0,z|0):0){y=z+8|0;if(f[y>>2]&7|0){f[z+20>>2]=1;f[z+16>>2]=0;n[z+24>>2]=1.0}f[y>>2]=0;y=f[z+4>>2]|0;if(y&1|0?(z=y&-2,f[z>>2]|0):0)GPb(z)}if(((f[s>>2]&2097152|0?(z=f[a+320>>2]|0,z|0):0)?(y=z+16|0,f[y>>2]=0,f[y+4>>2]=0,f[z+8>>2]=0,y=f[z+4>>2]|0,y&1|0):0)?(z=y&-2,f[z>>2]|0):0)GPb(z);if(f[s>>2]&4194304|0?(z=f[a+324>>2]|0,z|0):0){y=z+8|0;w=f[y>>2]|0;if(w&7|0){do if(w&1|0){v=f[z+16>>2]|0;if(!v)break;f[v+16>>2]=0;f[v+8>>2]=0;u=f[v+4>>2]|0;if(!(u&1))break;v=u&-2;if(!(f[v>>2]|0))break;GPb(v)}while(0);f[z+20>>2]=0;f[z+24>>2]=-1}f[y>>2]=0;y=f[z+4>>2]|0;if(y&1|0?(z=y&-2,f[z>>2]|0):0)GPb(z)}do if(f[s>>2]&8388608|0?(z=f[a+328>>2]|0,z|0):0){y=z+8|0;if(f[y>>2]&7|0){w=z+16|0;f[w>>2]=0;f[w+4>>2]=0;n[z+24>>2]=1.0}f[y>>2]=0;y=f[z+4>>2]|0;if(y&1|0){z=y&-2;if(!(f[z>>2]|0))break;GPb(z)}}while(0);x=f[s>>2]|0}do if(x>>>0>16777215){if((x&16777216|0)!=0?(z=f[a+332>>2]|0,(z|0)!=0):0){dTa(z);A=f[s>>2]|0}else A=x;if(((A&33554432|0?(z=f[a+336>>2]|0,z|0):0)?(f[z+16>>2]=0,f[z+8>>2]=0,y=f[z+4>>2]|0,y&1|0):0)?(z=y&-2,f[z>>2]|0):0)GPb(z);if(f[s>>2]&67108864|0?(z=f[a+340>>2]|0,z|0):0){y=z+8|0;if(f[y>>2]&3|0){f[z+16>>2]=0;f[z+20>>2]=1}f[y>>2]=0;y=f[z+4>>2]|0;if(y&1|0?(z=y&-2,f[z>>2]|0):0)GPb(z)}if(((f[s>>2]&134217728|0?(z=f[a+344>>2]|0,z|0):0)?(y=z+16|0,f[y>>2]=0,f[y+4>>2]=0,f[y+8>>2]=0,f[z+8>>2]=0,y=f[z+4>>2]|0,y&1|0):0)?(z=y&-2,f[z>>2]|0):0)GPb(z);if(f[s>>2]&268435456|0?(z=f[a+348>>2]|0,z|0):0){y=z+8|0;if(f[y>>2]&5|0){f[z+28>>2]=1;f[z+32>>2]=1}f[z+16>>2]=0;f[y>>2]=0;y=f[z+4>>2]|0;if(y&1|0?(z=y&-2,f[z>>2]|0):0)GPb(z)}if(((f[s>>2]&536870912|0?(z=f[a+352>>2]|0,z|0):0)?(f[z+16>>2]=0,f[z+8>>2]=0,y=f[z+4>>2]|0,y&1|0):0)?(z=y&-2,f[z>>2]|0):0)GPb(z);z=f[s>>2]|0;if(!(z&1073741824))B=z;else{z=f[a+356>>2]|0;do if(z|0?(n[z+16>>2]=0.0,f[z+8>>2]=0,y=f[z+4>>2]|0,y&1|0):0){w=y&-2;if(!(f[w>>2]|0))break;GPb(w)}while(0);B=f[s>>2]|0}if((B|0)<0?(z=f[a+360>>2]|0,z|0):0){w=z+8|0;if(f[w>>2]&3|0){f[z+20>>2]=1;f[z+16>>2]=0}f[w>>2]=0;w=f[z+4>>2]|0;if(w&1|0){z=w&-2;if(!(f[z>>2]|0))break;GPb(z)}}}while(0);if(f[a+16>>2]&1|0?(B=f[a+364>>2]|0,B|0):0)BQa(B);B=a+28|0;s=f[B>>2]|0;if((s|0)>0){A=f[a+36>>2]|0;x=0;do{z=f[A+4+(x<<2)>>2]|0;x=x+1|0;w=z+11|0;if((b[w>>0]|0)<0){b[f[z>>2]>>0]=0;f[z+4>>2]=0}else{b[z>>0]=0;b[w>>0]=0}}while((x|0)!=(s|0));f[B>>2]=0}B=a+44|0;s=f[B>>2]|0;if((s|0)>0){x=f[a+52>>2]|0;A=0;do{w=f[x+4+(A<<2)>>2]|0;A=A+1|0;z=w+11|0;if((b[z>>0]|0)<0){b[f[w>>2]>>0]=0;f[w+4>>2]=0}else{b[w>>0]=0;b[z>>0]=0}}while((A|0)!=(s|0));f[B>>2]=0}f[a+56>>2]=0;B=a+72|0;s=f[B>>2]|0;if((s|0)>0){A=f[a+80>>2]|0;x=0;do{z=f[A+4+(x<<2)>>2]|0;x=x+1|0;bi[f[(f[z>>2]|0)+28>>2]&2047](z)}while((x|0)!=(s|0));f[B>>2]=0}B=a+88|0;s=f[B>>2]|0;if((s|0)>0){x=f[a+96>>2]|0;A=0;do{z=f[x+4+(A<<2)>>2]|0;A=A+1|0;bi[f[(f[z>>2]|0)+28>>2]&2047](z)}while((A|0)!=(s|0));f[B>>2]=0}f[a+100>>2]=0;B=a+116|0;s=f[B>>2]|0;if((s|0)>0){A=f[a+124>>2]|0;x=0;do{z=f[A+4+(x<<2)>>2]|0;x=x+1|0;bi[f[(f[z>>2]|0)+28>>2]&2047](z)}while((x|0)!=(s|0));f[B>>2]=0}B=a+132|0;s=f[B>>2]|0;if((s|0)>0){x=f[a+140>>2]|0;A=0;do{z=f[x+4+(A<<2)>>2]|0;A=A+1|0;bi[f[(f[z>>2]|0)+28>>2]&2047](z)}while((A|0)!=(s|0));f[B>>2]=0};f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function x3a(a){a=a|0;var b=0,c=0;if(f[a+12>>2]&131072|0?(b=f[a+304>>2]|0,!(di[f[(f[b>>2]|0)+32>>2]&1023](b)|0)):0){c=0;return c|0}c=1;return c|0}function y3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+144|0;l=a+148|0;m=a+24|0;n=a+40|0;o=a+56|0;p=a+60|0;q=a+64|0;r=c+44|0;s=a+68|0;t=a+80|0;v=a+76|0;w=a+72|0;x=a+84|0;y=a+96|0;z=a+92|0;A=a+88|0;B=a+112|0;C=a+124|0;D=a+120|0;E=a+116|0;F=a+128|0;G=a+140|0;H=a+136|0;I=a+132|0;K=a+368|0;L=a+4|0;M=a+100|0;N=a+104|0;O=a+108|0;P=e+8|0;Q=e+8|0;R=a+152|0;S=e+4|0;T=a+156|0;U=e+4|0;V=a+160|0;W=e+4|0;X=a+164|0;Y=e+4|0;Z=a+176|0;_=e+4|0;$=a+180|0;aa=e+4|0;ba=a+184|0;ca=e+4|0;da=a+192|0;ea=e+4|0;fa=a+200|0;ga=e+4|0;ha=a+204|0;ia=e+4|0;ja=a+208|0;ka=e+4|0;la=a+220|0;ma=e+4|0;na=a+228|0;oa=e+4|0;pa=a+232|0;qa=e+4|0;ra=a+12|0;sa=a+236|0;ta=e+4|0;ua=a+240|0;va=e+4|0;wa=a+244|0;xa=e+4|0;ya=a+248|0;za=e+4|0;Aa=a+260|0;Ba=e+4|0;Ca=a+264|0;Da=e+4|0;Ea=a+268|0;Fa=e+4|0;Ga=a+284|0;Ha=e+4|0;Ia=a+288|0;Ja=e+4|0;Ka=a+320|0;La=e+4|0;Ma=a+336|0;Na=e+4|0;Oa=a+340|0;Pa=e+4|0;Qa=a+348|0;Ra=e+4|0;Sa=a+352|0;Ta=e+4|0;Ua=a+356|0;Va=e+4|0;Wa=a+16|0;Xa=a+364|0;Ya=e+4|0;Za=a+308|0;_a=e+4|0;$a=a+292|0;ab=e+4|0;bb=a+344|0;cb=e+4|0;db=a+324|0;eb=e+4|0;fb=a+256|0;gb=e+4|0;hb=a+224|0;ib=e+4|0;jb=a+316|0;kb=e+4|0;lb=a+216|0;mb=e+4|0;nb=a+360|0;ob=e+4|0;pb=a+168|0;qb=e+4|0;rb=a+212|0;sb=e+4|0;tb=a+172|0;ub=e+4|0;vb=a+332|0;wb=e+4|0;xb=a+252|0;yb=e+4|0;zb=a+188|0;Ab=e+4|0;Bb=a+280|0;Cb=e+4|0;Db=a+312|0;Eb=e+4|0;Fb=a+196|0;Gb=e+4|0;Hb=a+276|0;Ib=e+4|0;Jb=a+272|0;Kb=e+4|0;Lb=a+296|0;Mb=e+4|0;Nb=a+300|0;Ob=e+4|0;Pb=a+304|0;Qb=e+4|0;Rb=a+328|0;a=e+4|0;Sb=c+32|0;Tb=c+12|0;Ub=c+28|0;a:while(1){Vb=f[c>>2]|0;Wb=f[g>>2]|0;do if(Vb>>>0<Wb>>>0){Xb=b[Vb>>0]|0;Yb=Xb&255;if(Xb<<24>>24>0){Zb=Yb;_b=1}else{Xb=Vb+1|0;if(Xb>>>0>=Wb>>>0){$b=Yb;ac=7;break}bc=h[Xb>>0]|0;if(((bc^128)&Yb)>>>0<=127){$b=Yb;ac=7;break}Zb=Yb+-128+(bc<<7)|0;_b=2}f[i>>2]=Zb;f[c>>2]=Vb+_b;cc=Zb;ac=9}else{$b=0;ac=7}while(0);if((ac|0)==7){ac=0;Vb=_nb(c,$b)|0;f[i>>2]=Vb;if((Vb+-1|0)>>>0<66133690){cc=Vb;ac=9}else{dc=Vb;ac=963}}b:do if((ac|0)==9){ac=0;Vb=cc>>>3&536870911;c:do if((Vb|0)>=121){if((Vb|0)<137)do switch(Vb|0){case 121:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 970:{ac=477;break c;break}default:{fc=cc;break b}}break}case 122:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 978:{ac=492;break c;break}default:{fc=cc;break b}}break}case 123:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 986:{ac=507;break c;break}default:{fc=cc;break b}}break}case 124:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 994:{ac=522;break c;break}default:{fc=cc;break b}}break}case 125:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1002:{ac=537;break c;break}default:{fc=cc;break b}}break}case 126:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1010:{ac=552;break c;break}default:{fc=cc;break b}}break}case 127:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1018:{ac=567;break c;break}default:{fc=cc;break b}}break}case 128:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1026:{ac=582;break c;break}default:{fc=cc;break b}}break}case 129:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1034:{ac=597;break c;break}default:{fc=cc;break b}}break}case 130:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1042:{ac=612;break c;break}default:{fc=cc;break b}}break}case 131:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1050:{ac=627;break c;break}default:{fc=cc;break b}}break}case 132:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1058:{ac=642;break c;break}default:{fc=cc;break b}}break}case 133:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1066:{ac=657;break c;break}default:{fc=cc;break b}}break}case 134:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1074:{ac=672;break c;break}default:{fc=cc;break b}}break}case 135:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1082:{ac=687;break c;break}default:{fc=cc;break b}}break}case 136:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1090:{ac=702;break c;break}default:{fc=cc;break b}}break}default:{dc=cc;ac=963;break b}}while(0);if((Vb|0)<145)switch(Vb|0){case 137:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1098:{ac=717;break c;break}default:{fc=cc;break b}}break}case 138:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1106:{ac=732;break c;break}default:{fc=cc;break b}}break}case 139:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1114:{ac=747;break c;break}default:{fc=cc;break b}}break}case 140:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1122:{ac=762;break c;break}default:{fc=cc;break b}}break}case 141:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1130:{ac=777;break c;break}default:{fc=cc;break b}}break}case 142:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1138:{ac=792;break c;break}default:{fc=cc;break b}}break}case 143:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1146:{ac=807;break c;break}default:{fc=cc;break b}}break}case 144:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1154:{ac=822;break c;break}default:{fc=cc;break b}}break}default:{dc=cc;ac=963;break b}}if((Vb|0)<149)switch(Vb|0){case 145:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1162:{ac=837;break c;break}default:{fc=cc;break b}}break}case 146:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1170:{ac=852;break c;break}default:{fc=cc;break b}}break}case 147:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1178:{ac=867;break c;break}default:{fc=cc;break b}}break}case 148:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1186:{ac=882;break c;break}default:{fc=cc;break b}}break}default:{dc=cc;ac=963;break b}}if((Vb|0)<201)switch(Vb|0){case 149:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1194:{ac=897;break c;break}default:{fc=cc;break b}}break}case 150:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1202:{ac=912;break c;break}default:{fc=cc;break b}}break}default:{dc=cc;ac=963;break b}}if((Vb|0)<10001){switch(Vb|0){case 201:break;default:{dc=cc;ac=963;break b}}switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 1610:{break c;break}default:{fc=cc;break b}}}if((Vb|0)<8266711){switch(Vb|0){case 10001:break;default:{dc=cc;ac=963;break b}}if((cc|0)<80010)switch(cc|0){case 0:{ec=1;ac=969;break a;break}default:{fc=cc;break b}}switch(cc|0){case 80010:break;default:{fc=cc;break b}}f[ra>>2]=f[ra>>2]|131072;Wb=f[Pb>>2]|0;if(!Wb){bc=L5b(28)|0;kMa(bc);f[Pb>>2]=bc;gc=bc}else gc=Wb;Wb=f[c>>2]|0;if(Wb>>>0<(f[g>>2]|0)>>>0?(bc=b[Wb>>0]|0,bc<<24>>24>-1):0){f[c>>2]=Wb+1;hc=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)hc=bc;else{ec=0;ac=969;break a}}Inb(e,c,hc);if((f[Qb>>2]|0)<0){ac=946;break a}if(!($La(gc,c)|0)){ac=946;break a}if(Onb(c,f[e>>2]|0)|0)continue a;else{ec=0;ac=969;break a}}switch(Vb|0){case 8266711:break;default:{dc=cc;ac=963;break b}}if((cc|0)<66133690)switch(cc|0){case 0:{ec=1;ac=969;break a;break}default:{fc=cc;break b}}switch(cc|0){case 66133690:break;default:{fc=cc;break b}}f[ra>>2]=f[ra>>2]|8388608;bc=f[Rb>>2]|0;if(!bc){Wb=L5b(28)|0;WMa(Wb);f[Rb>>2]=Wb;ic=Wb}else ic=bc;bc=f[c>>2]|0;if(bc>>>0<(f[g>>2]|0)>>>0?(Wb=b[bc>>0]|0,Wb<<24>>24>-1):0){f[c>>2]=bc+1;jc=Wb&255}else{Wb=Znb(c)|0;if((Wb|0)>-1)jc=Wb;else{ec=0;ac=969;break a}}Inb(e,c,jc);if((f[a>>2]|0)<0){ac=957;break a}if(!(MMa(ic,c)|0)){ac=957;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[Sb>>2]|0){ac=962;break a}if((f[Tb>>2]|0)==(f[Ub>>2]|0)){ac=962;break a}else continue a}else{d:do switch(Vb|0){case 1:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 10:break;default:{fc=cc;break b}}f[j>>2]=f[j>>2]|1;Wb=f[k>>2]|0;if((Wb|0)==497760){jza(k,497760);kc=f[k>>2]|0}else kc=Wb;if(!(fqb(c,kc)|0)){ec=0;ac=969;break a}Wb=f[c>>2]|0;if(Wb>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[Wb>>0]|0)!=18)continue a;f[c>>2]=Wb+1;ac=18;break}case 2:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 18:{ac=18;break}default:{fc=cc;break b}}break}case 3:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 26:{ac=25;break}default:{fc=cc;break b}}break}case 4:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 34:{ac=31;break}default:{fc=cc;break b}}break}case 5:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 45:{lc=f[c>>2]|0;mc=f[g>>2]|0;ac=38;break d;break}case 42:{if(DMa(c,o)|0){ac=53;break d}else{ec=0;ac=969;break a}break}default:{fc=cc;break b}}break}case 6:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 50:{ac=58;break}default:{fc=cc;break b}}break}case 7:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 58:break;default:{fc=cc;break b}}Wb=f[r>>2]|0;f[r>>2]=Wb+-1;if((Wb|0)>0)ac=76;else{ec=0;ac=969;break a}break}case 8:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 66:break;default:{fc=cc;break b}}Wb=f[r>>2]|0;f[r>>2]=Wb+-1;if((Wb|0)>0)ac=92;else{ec=0;ac=969;break a}break}case 9:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 74:break;default:{fc=cc;break b}}Wb=f[r>>2]|0;f[r>>2]=Wb+-1;if((Wb|0)>0)ac=108;else{ec=0;ac=969;break a}break}case 10:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 80:break;default:{fc=cc;break b}}nc=f[c>>2]|0;oc=f[g>>2]|0;ac=124;break}case 11:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 88:{pc=f[c>>2]|0;qc=f[g>>2]|0;ac=139;break d;break}case 90:{if(X3a(c,M)|0){ac=155;break d}else{ec=0;ac=969;break a}break}default:{fc=cc;break b}}break}case 100:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 802:{ac=162;break}default:{fc=cc;break b}}break}case 101:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 810:{ac=177;break}default:{fc=cc;break b}}break}case 102:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 818:{ac=192;break}default:{fc=cc;break b}}break}case 103:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 826:{ac=207;break}default:{fc=cc;break b}}break}case 104:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 834:{ac=222;break}default:{fc=cc;break b}}break}case 105:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 842:{ac=237;break}default:{fc=cc;break b}}break}case 106:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 850:{ac=252;break}default:{fc=cc;break b}}break}case 107:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 858:{ac=267;break}default:{fc=cc;break b}}break}case 108:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 866:{ac=282;break}default:{fc=cc;break b}}break}case 109:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 874:{ac=297;break}default:{fc=cc;break b}}break}case 110:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 882:{ac=312;break}default:{fc=cc;break b}}break}case 111:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 890:{ac=327;break}default:{fc=cc;break b}}break}case 112:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 898:{ac=342;break}default:{fc=cc;break b}}break}case 113:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 906:{ac=357;break}default:{fc=cc;break b}}break}case 114:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 914:{ac=372;break}default:{fc=cc;break b}}break}case 115:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 922:{ac=387;break}default:{fc=cc;break b}}break}case 116:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 930:{ac=402;break}default:{fc=cc;break b}}break}case 117:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 938:{ac=417;break}default:{fc=cc;break b}}break}case 118:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 946:{ac=432;break}default:{fc=cc;break b}}break}case 119:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 954:{ac=447;break}default:{fc=cc;break b}}break}case 120:{switch(cc|0){case 0:{ec=1;ac=969;break a;break}case 962:{ac=462;break}default:{fc=cc;break b}}break}default:{dc=cc;ac=963;break b}}while(0);if((ac|0)==18){ac=0;f[j>>2]=f[j>>2]|2;Wb=f[l>>2]|0;if((Wb|0)==497760){jza(l,497760);rc=f[l>>2]|0}else rc=Wb;if(!(fqb(c,rc)|0)){ec=0;ac=969;break a}Wb=f[c>>2]|0;if(Wb>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[Wb>>0]|0)==26){sc=Wb;ac=24}else continue a}e:while(1){switch(ac|0){case 24:{ac=0;f[c>>2]=sc+1;ac=25;continue e;break}case 25:{ac=0;if(!(fqb(c,mza(m)|0)|0)){ec=0;ac=969;break a}Wb=f[c>>2]|0;if(Wb>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[Wb>>0]|0)==26){sc=Wb;ac=24;continue e}if((b[Wb>>0]|0)==34){tc=Wb;ac=30}else continue a;break}case 31:{ac=0;if(!(fqb(c,mza(n)|0)|0)){ec=0;ac=969;break a}Wb=f[c>>2]|0;bc=f[g>>2]|0;if(Wb>>>0>=bc>>>0)continue a;if((b[Wb>>0]|0)!=34)if((b[Wb>>0]|0)==45){uc=bc;vc=Wb;ac=37}else continue a;else{tc=Wb;ac=30}break}case 38:{ac=0;if((mc-lc|0)>3){Wb=lc;bc=h[Wb>>0]|h[Wb+1>>0]<<8|h[Wb+2>>0]<<16|h[Wb+3>>0]<<24;f[e>>2]=bc;f[c>>2]=lc+4;wc=bc}else{if(!(Xnb(c,e)|0)){ac=51;break a}wc=f[e>>2]|0}bc=f[o>>2]|0;if((bc|0)==(f[p>>2]|0)){qza(o,bc+1|0);xc=f[o>>2]|0}else xc=bc;bc=f[q>>2]|0;Wb=xc+1|0;f[o>>2]=Wb;f[bc+4+(xc<<2)>>2]=wc;Yb=f[c>>2]|0;Xb=(f[g>>2]|0)-Yb|0;if((Xb|0)<=0){ac=53;continue e}yc=(f[p>>2]|0)-Wb|0;zc=(Xb>>>0)/5|0;Xb=(zc|0)<(yc|0)?zc:yc;if((Xb|0)<=0){ac=53;continue e}yc=0;zc=Yb;Yb=Wb;while(1){if((b[zc>>0]|0)!=45){Ac=yc;break}Wb=zc+1|0;Bc=h[Wb>>0]|h[Wb+1>>0]<<8|h[Wb+2>>0]<<16|h[Wb+3>>0]<<24;Wb=Yb;Yb=Yb+1|0;f[o>>2]=Yb;f[bc+4+(Wb<<2)>>2]=Bc;Bc=yc+1|0;if((Bc|0)>=(Xb|0)){Ac=Bc;break}else{yc=Bc;zc=zc+5|0}}if((Ac|0)<=0){ac=53;continue e}Tnb(c,Ac*5|0)|0;ac=53;continue e;break}case 53:{ac=0;zc=f[c>>2]|0;yc=f[g>>2]|0;if(zc>>>0>=yc>>>0)continue a;if((b[zc>>0]|0)==45){uc=yc;vc=zc;ac=37}else{if((b[zc>>0]|0)!=50)continue a;f[c>>2]=zc+1;ac=58;continue e}break}case 58:{ac=0;zc=f[r>>2]|0;f[r>>2]=zc+-1;if((zc|0)<=0){ec=0;ac=969;break a}while(1){zc=f[t>>2]|0;do if(zc){yc=f[w>>2]|0;Xb=f[zc>>2]|0;if((yc|0)>=(Xb|0))if((Xb|0)==(f[v>>2]|0)){Cc=Xb;ac=64;break}else{Dc=Xb;Ec=zc;ac=65;break}else{f[w>>2]=yc+1;Fc=f[zc+4+(yc<<2)>>2]|0;break}}else{Cc=f[v>>2]|0;ac=64}while(0);if((ac|0)==64){ac=0;cpb(s,Cc+1|0);zc=f[t>>2]|0;Dc=f[zc>>2]|0;Ec=zc;ac=65}if((ac|0)==65){ac=0;f[Ec>>2]=Dc+1;zc=Kza(0,f[s>>2]|0)|0;yc=f[t>>2]|0;Xb=f[w>>2]|0;f[w>>2]=Xb+1;f[yc+4+(Xb<<2)>>2]=zc;Fc=zc}zc=Jnb(c)|0;if(!(W3a(Fc,c)|0)){ec=0;ac=969;break a}if(!(Pnb(c,zc)|0)){ec=0;ac=969;break a}Gc=f[c>>2]|0;if(Gc>>>0>=(f[g>>2]|0)>>>0){ac=72;break e}if((b[Gc>>0]|0)!=50)break;f[c>>2]=Gc+1}if((b[Gc>>0]|0)==58){Hc=Gc;ac=75}else{ac=72;break e}break}case 76:{ac=0;zc=f[y>>2]|0;do if(zc){Xb=f[A>>2]|0;yc=f[zc>>2]|0;if((Xb|0)>=(yc|0))if((yc|0)==(f[z>>2]|0)){Ic=yc;ac=81;break}else{Jc=yc;Kc=zc;ac=82;break}else{f[A>>2]=Xb+1;Lc=f[zc+4+(Xb<<2)>>2]|0;break}}else{Ic=f[z>>2]|0;ac=81}while(0);if((ac|0)==81){ac=0;cpb(x,Ic+1|0);zc=f[y>>2]|0;Jc=f[zc>>2]|0;Kc=zc;ac=82}if((ac|0)==82){ac=0;f[Kc>>2]=Jc+1;zc=pza(0,f[x>>2]|0)|0;Xb=f[y>>2]|0;yc=f[A>>2]|0;f[A>>2]=yc+1;f[Xb+4+(yc<<2)>>2]=zc;Lc=zc}zc=Jnb(c)|0;if(!(hOa(Lc,c)|0)){ec=0;ac=969;break a}if(!(Pnb(c,zc)|0)){ec=0;ac=969;break a}zc=f[c>>2]|0;if(zc>>>0>=(f[g>>2]|0)>>>0){ac=88;break e}if((b[zc>>0]|0)!=58)if((b[zc>>0]|0)==66){Mc=zc;ac=91}else{ac=88;break e}else{Hc=zc;ac=75}break}case 92:{ac=0;zc=f[C>>2]|0;do if(zc){yc=f[E>>2]|0;Xb=f[zc>>2]|0;if((yc|0)>=(Xb|0))if((Xb|0)==(f[D>>2]|0)){Nc=Xb;ac=97;break}else{Oc=Xb;Pc=zc;ac=98;break}else{f[E>>2]=yc+1;Qc=f[zc+4+(yc<<2)>>2]|0;break}}else{Nc=f[D>>2]|0;ac=97}while(0);if((ac|0)==97){ac=0;cpb(B,Nc+1|0);zc=f[C>>2]|0;Oc=f[zc>>2]|0;Pc=zc;ac=98}if((ac|0)==98){ac=0;f[Pc>>2]=Oc+1;zc=Hza(0,f[B>>2]|0)|0;yc=f[C>>2]|0;Xb=f[E>>2]|0;f[E>>2]=Xb+1;f[yc+4+(Xb<<2)>>2]=zc;Qc=zc}zc=Jnb(c)|0;if(!(mQa(Qc,c)|0)){ec=0;ac=969;break a}if(!(Pnb(c,zc)|0)){ec=0;ac=969;break a}zc=f[c>>2]|0;if(zc>>>0>=(f[g>>2]|0)>>>0){ac=104;break e}if((b[zc>>0]|0)!=66)if((b[zc>>0]|0)==74){Rc=zc;ac=107}else{ac=104;break e}else{Mc=zc;ac=91}break}case 108:{ac=0;zc=f[G>>2]|0;do if(zc){Xb=f[I>>2]|0;yc=f[zc>>2]|0;if((Xb|0)>=(yc|0))if((yc|0)==(f[H>>2]|0)){Sc=yc;ac=113;break}else{Tc=yc;Uc=zc;ac=114;break}else{f[I>>2]=Xb+1;Vc=f[zc+4+(Xb<<2)>>2]|0;break}}else{Sc=f[H>>2]|0;ac=113}while(0);if((ac|0)==113){ac=0;cpb(F,Sc+1|0);zc=f[G>>2]|0;Tc=f[zc>>2]|0;Uc=zc;ac=114}if((ac|0)==114){ac=0;f[Uc>>2]=Tc+1;zc=Hza(0,f[F>>2]|0)|0;Xb=f[G>>2]|0;yc=f[I>>2]|0;f[I>>2]=yc+1;f[Xb+4+(yc<<2)>>2]=zc;Vc=zc}zc=Jnb(c)|0;if(!(mQa(Vc,c)|0)){ec=0;ac=969;break a}if(!(Pnb(c,zc)|0)){ec=0;ac=969;break a}zc=f[c>>2]|0;yc=f[g>>2]|0;if(zc>>>0>=yc>>>0){ac=118;break e}if((b[zc>>0]|0)==74){Rc=zc;ac=107}else{f[r>>2]=(f[r>>2]|0)+1;if((b[zc>>0]|0)!=80)continue a;Xb=zc+1|0;f[c>>2]=Xb;nc=Xb;oc=yc;ac=124;continue e}break}case 124:{ac=0;if(nc>>>0<oc>>>0){yc=b[nc>>0]|0;Xb=yc&255;if(yc<<24>>24>-1){f[c>>2]=nc+1;Wc=Xb}else{Xc=Xb;ac=127}}else{Xc=0;ac=127}if((ac|0)==127){ac=0;Xb=Knb(c,Xc)|0;yc=J;if((yc|0)>-1|(yc|0)==-1&Xb>>>0>4294967295)Wc=Xb;else{ec=0;ac=969;break a}}if(Wc>>>0<2){f[j>>2]=f[j>>2]|16;f[K>>2]=Wc}else{Xb=f[L>>2]|0;if(!(Xb&1))Yc=hBa(L)|0;else Yc=Xb&-2;NPb(Yc,10,Wc,((Wc|0)<0)<<31>>31)}Xb=f[c>>2]|0;yc=f[g>>2]|0;if(Xb>>>0>=yc>>>0)continue a;if((b[Xb>>0]|0)==88){Zc=Xb;_c=yc;ac=138}else continue a;break}case 139:{ac=0;if(pc>>>0<qc>>>0?(yc=b[pc>>0]|0,yc<<24>>24>-1):0){f[c>>2]=pc+1;$c=yc<<24>>24!=0}else{Lnb(e,c);yc=e;if(!(b[Q>>0]|0)){ec=0;ac=969;break a}else $c=(f[yc>>2]|0)!=0|(f[yc+4>>2]|0)!=0}yc=f[M>>2]|0;Xb=f[N>>2]|0;if((yc|0)==(Xb|0)){vFa(M,yc+1|0);ad=f[M>>2]|0;bd=f[N>>2]|0}else{ad=yc;bd=Xb}Xb=f[O>>2]|0;yc=ad+1|0;f[M>>2]=yc;b[Xb+4+ad>>0]=$c&1;zc=bd-yc|0;if((zc|0)>0){cd=zc;dd=yc;ed=Xb}else{ac=155;continue e}while(1){Xb=f[c>>2]|0;yc=f[g>>2]|0;if(Xb>>>0>=yc>>>0){ac=155;continue e}if((b[Xb>>0]|0)!=88){ac=155;continue e}zc=Xb+1|0;f[c>>2]=zc;if(zc>>>0<yc>>>0?(yc=b[zc>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Xb+2;fd=yc<<24>>24!=0;gd=dd;hd=ed}else{Lnb(e,c);yc=e;if(!(b[P>>0]|0)){ec=0;ac=969;break a}fd=(f[yc>>2]|0)!=0|(f[yc+4>>2]|0)!=0;gd=f[M>>2]|0;hd=f[O>>2]|0}yc=gd+1|0;f[M>>2]=yc;b[hd+4+gd>>0]=fd&1;if((cd|0)>1){cd=cd+-1|0;dd=yc;ed=hd}else{ac=155;continue e}}break}case 155:{ac=0;yc=f[c>>2]|0;Xb=f[g>>2]|0;zc=Xb;bc=yc;if(yc>>>0<Xb>>>0?(b[yc>>0]|0)==88:0){Zc=yc;_c=Xb;ac=138;break}if((zc-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-94)continue a;if((b[yc+1>>0]|0)!=6)continue a;f[c>>2]=yc+2;ac=162;continue e;break}case 162:{ac=0;f[j>>2]=f[j>>2]|2048;yc=f[R>>2]|0;if(!yc){bc=L5b(44)|0;pPa(bc);f[R>>2]=bc;id=bc}else id=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;jd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)jd=bc;else{ec=0;ac=969;break a}}Inb(e,c,jd);if((f[S>>2]|0)<0){ac=170;break a}if(!(oQa(id,c)|0)){ac=170;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-86)continue a;if((b[yc+1>>0]|0)!=6)continue a;f[c>>2]=yc+2;ac=177;continue e;break}case 177:{ac=0;f[j>>2]=f[j>>2]|4096;yc=f[T>>2]|0;if(!yc){bc=L5b(28)|0;rPa(bc);f[T>>2]=bc;kd=bc}else kd=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;ld=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)ld=bc;else{ec=0;ac=969;break a}}Inb(e,c,ld);if((f[U>>2]|0)<0){ac=185;break a}if(!(uQa(kd,c)|0)){ac=185;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-78)continue a;if((b[yc+1>>0]|0)!=6)continue a;f[c>>2]=yc+2;ac=192;continue e;break}case 192:{ac=0;f[j>>2]=f[j>>2]|8192;yc=f[V>>2]|0;if(!yc){bc=L5b(28)|0;EOa(bc);f[V>>2]=bc;md=bc}else md=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;nd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)nd=bc;else{ec=0;ac=969;break a}}Inb(e,c,nd);if((f[W>>2]|0)<0){ac=200;break a}if(!(iQa(md,c)|0)){ac=200;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-70)continue a;if((b[yc+1>>0]|0)!=6)continue a;f[c>>2]=yc+2;ac=207;continue e;break}case 207:{ac=0;f[j>>2]=f[j>>2]|16384;yc=f[X>>2]|0;if(!yc){bc=L5b(28)|0;FOa(bc);f[X>>2]=bc;od=bc}else od=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;pd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)pd=bc;else{ec=0;ac=969;break a}}Inb(e,c,pd);if((f[Y>>2]|0)<0){ac=215;break a}if(!(eQa(od,c)|0)){ac=215;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-62)continue a;if((b[yc+1>>0]|0)!=6)continue a;f[c>>2]=yc+2;ac=222;continue e;break}case 222:{ac=0;f[j>>2]=f[j>>2]|131072;yc=f[Z>>2]|0;if(!yc){bc=L5b(24)|0;GOa(bc);f[Z>>2]=bc;qd=bc}else qd=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;rd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)rd=bc;else{ec=0;ac=969;break a}}Inb(e,c,rd);if((f[_>>2]|0)<0){ac=230;break a}if(!(TPa(qd,c)|0)){ac=230;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-54)continue a;if((b[yc+1>>0]|0)!=6)continue a;f[c>>2]=yc+2;ac=237;continue e;break}case 237:{ac=0;f[j>>2]=f[j>>2]|262144;yc=f[$>>2]|0;if(!yc){bc=L5b(24)|0;HOa(bc);f[$>>2]=bc;sd=bc}else sd=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;td=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)td=bc;else{ec=0;ac=969;break a}}Inb(e,c,td);if((f[aa>>2]|0)<0){ac=245;break a}if(!(sQa(sd,c)|0)){ac=245;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-46)continue a;if((b[yc+1>>0]|0)!=6)continue a;f[c>>2]=yc+2;ac=252;continue e;break}case 252:{ac=0;f[j>>2]=f[j>>2]|524288;yc=f[ba>>2]|0;if(!yc){bc=L5b(120)|0;IOa(bc);f[ba>>2]=bc;ud=bc}else ud=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;vd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)vd=bc;else{ec=0;ac=969;break a}}Inb(e,c,vd);if((f[ca>>2]|0)<0){ac=260;break a}if(!(UPa(ud,c)|0)){ac=260;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-38)continue a;if((b[yc+1>>0]|0)!=6)continue a;f[c>>2]=yc+2;ac=267;continue e;break}case 267:{ac=0;f[j>>2]=f[j>>2]|2097152;yc=f[da>>2]|0;if(!yc){bc=L5b(52)|0;KOa(bc);f[da>>2]=bc;wd=bc}else wd=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;xd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)xd=bc;else{ec=0;ac=969;break a}}Inb(e,c,xd);if((f[ea>>2]|0)<0){ac=275;break a}if(!(VPa(wd,c)|0)){ac=275;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-30)continue a;if((b[yc+1>>0]|0)!=6)continue a;f[c>>2]=yc+2;ac=282;continue e;break}case 282:{ac=0;f[j>>2]=f[j>>2]|8388608;yc=f[fa>>2]|0;if(!yc){bc=L5b(24)|0;MOa(bc);f[fa>>2]=bc;yd=bc}else yd=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;zd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)zd=bc;else{ec=0;ac=969;break a}}Inb(e,c,zd);if((f[ga>>2]|0)<0){ac=290;break a}if(!(WPa(yd,c)|0)){ac=290;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-22)continue a;if((b[yc+1>>0]|0)!=6)continue a;f[c>>2]=yc+2;ac=297;continue e;break}case 297:{ac=0;f[j>>2]=f[j>>2]|16777216;yc=f[ha>>2]|0;if(!yc){bc=L5b(96)|0;NOa(bc);f[ha>>2]=bc;Ad=bc}else Ad=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;Bd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)Bd=bc;else{ec=0;ac=969;break a}}Inb(e,c,Bd);if((f[ia>>2]|0)<0){ac=305;break a}if(!(hQa(Ad,c)|0)){ac=305;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-14)continue a;if((b[yc+1>>0]|0)!=6)continue a;f[c>>2]=yc+2;ac=312;continue e;break}case 312:{ac=0;f[j>>2]=f[j>>2]|33554432;yc=f[ja>>2]|0;if(!yc){bc=L5b(36)|0;POa(bc);f[ja>>2]=bc;Cd=bc}else Cd=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;Dd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)Dd=bc;else{ec=0;ac=969;break a}}Inb(e,c,Dd);if((f[ka>>2]|0)<0){ac=320;break a}if(!(fQa(Cd,c)|0)){ac=320;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-6)continue a;if((b[yc+1>>0]|0)!=6)continue a;f[c>>2]=yc+2;ac=327;continue e;break}case 327:{ac=0;f[j>>2]=f[j>>2]|268435456;yc=f[la>>2]|0;if(!yc){bc=L5b(28)|0;ROa(bc);f[la>>2]=bc;Ed=bc}else Ed=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;Fd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)Fd=bc;else{ec=0;ac=969;break a}}Inb(e,c,Fd);if((f[ma>>2]|0)<0){ac=335;break a}if(!(tQa(Ed,c)|0)){ac=335;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-126)continue a;if((b[yc+1>>0]|0)!=7)continue a;f[c>>2]=yc+2;ac=342;continue e;break}case 342:{ac=0;f[j>>2]=f[j>>2]|1073741824;yc=f[na>>2]|0;if(!yc){bc=L5b(28)|0;SOa(bc);f[na>>2]=bc;Gd=bc}else Gd=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;Hd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)Hd=bc;else{ec=0;ac=969;break a}}Inb(e,c,Hd);if((f[oa>>2]|0)<0){ac=350;break a}if(!(XPa(Gd,c)|0)){ac=350;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-118)continue a;if((b[yc+1>>0]|0)!=7)continue a;f[c>>2]=yc+2;ac=357;continue e;break}case 357:{ac=0;f[j>>2]=f[j>>2]|-2147483648;yc=f[pa>>2]|0;if(!yc){bc=L5b(20)|0;cOa(bc);f[pa>>2]=bc;Id=bc}else Id=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;Jd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)Jd=bc;else{ec=0;ac=969;break a}}Inb(e,c,Jd);if((f[qa>>2]|0)<0){ac=365;break a}if(!(iOa(Id,c)|0)){ac=365;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-110)continue a;if((b[yc+1>>0]|0)!=7)continue a;f[c>>2]=yc+2;ac=372;continue e;break}case 372:{ac=0;f[ra>>2]=f[ra>>2]|1;yc=f[sa>>2]|0;if(!yc){bc=L5b(20)|0;UOa(bc);f[sa>>2]=bc;Kd=bc}else Kd=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;Ld=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)Ld=bc;else{ec=0;ac=969;break a}}Inb(e,c,Ld);if((f[ta>>2]|0)<0){ac=380;break a}if(!(jQa(Kd,c)|0)){ac=380;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-102)continue a;if((b[yc+1>>0]|0)!=7)continue a;f[c>>2]=yc+2;ac=387;continue e;break}case 387:{ac=0;f[ra>>2]=f[ra>>2]|2;yc=f[ua>>2]|0;if(!yc){bc=L5b(60)|0;VOa(bc);f[ua>>2]=bc;Md=bc}else Md=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;Nd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)Nd=bc;else{ec=0;ac=969;break a}}Inb(e,c,Nd);if((f[va>>2]|0)<0){ac=395;break a}if(!(YPa(Md,c)|0)){ac=395;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-94)continue a;if((b[yc+1>>0]|0)!=7)continue a;f[c>>2]=yc+2;ac=402;continue e;break}case 402:{ac=0;f[ra>>2]=f[ra>>2]|4;yc=f[wa>>2]|0;if(!yc){bc=L5b(20)|0;XOa(bc);f[wa>>2]=bc;Od=bc}else Od=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;Pd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)Pd=bc;else{ec=0;ac=969;break a}}Inb(e,c,Pd);if((f[xa>>2]|0)<0){ac=410;break a}if(!(ZPa(Od,c)|0)){ac=410;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-86)continue a;if((b[yc+1>>0]|0)!=7)continue a;f[c>>2]=yc+2;ac=417;continue e;break}case 417:{ac=0;f[ra>>2]=f[ra>>2]|8;yc=f[ya>>2]|0;if(!yc){bc=L5b(36)|0;YOa(bc);f[ya>>2]=bc;Qd=bc}else Qd=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;Rd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)Rd=bc;else{ec=0;ac=969;break a}}Inb(e,c,Rd);if((f[za>>2]|0)<0){ac=425;break a}if(!(_Pa(Qd,c)|0)){ac=425;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-78)continue a;if((b[yc+1>>0]|0)!=7)continue a;f[c>>2]=yc+2;ac=432;continue e;break}case 432:{ac=0;f[ra>>2]=f[ra>>2]|64;yc=f[Aa>>2]|0;if(!yc){bc=L5b(40)|0;_Oa(bc);f[Aa>>2]=bc;Sd=bc}else Sd=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;Td=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)Td=bc;else{ec=0;ac=969;break a}}Inb(e,c,Td);if((f[Ba>>2]|0)<0){ac=440;break a}if(!($Pa(Sd,c)|0)){ac=440;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-70)continue a;if((b[yc+1>>0]|0)!=7)continue a;f[c>>2]=yc+2;ac=447;continue e;break}case 447:{ac=0;f[ra>>2]=f[ra>>2]|128;yc=f[Ca>>2]|0;if(!yc){bc=L5b(32)|0;aPa(bc);f[Ca>>2]=bc;Ud=bc}else Ud=yc;yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;Vd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)Vd=bc;else{ec=0;ac=969;break a}}Inb(e,c,Vd);if((f[Da>>2]|0)<0){ac=455;break a}if(!(dQa(Ud,c)|0)){ac=455;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-62)continue a;if((b[yc+1>>0]|0)!=7)continue a;f[c>>2]=yc+2;ac=462;continue e;break}case 462:{ac=0;f[ra>>2]=f[ra>>2]|256;yc=f[Ea>>2]|0;if(!yc){ac=463;break e}else{Wd=yc;break e}break}}if((ac|0)==30){ac=0;f[c>>2]=tc+1;ac=31;continue}else if((ac|0)==37){ac=0;yc=vc+1|0;f[c>>2]=yc;lc=yc;mc=uc;ac=38;continue}else if((ac|0)==75){ac=0;f[c>>2]=Hc+1;ac=76;continue}else if((ac|0)==91){ac=0;f[c>>2]=Mc+1;ac=92;continue}else if((ac|0)==107){ac=0;f[c>>2]=Rc+1;ac=108;continue}else if((ac|0)==138){ac=0;yc=Zc+1|0;f[c>>2]=yc;pc=yc;qc=_c;ac=139;continue}}if((ac|0)==72){ac=0;f[r>>2]=(f[r>>2]|0)+1;continue a}else if((ac|0)==88){ac=0;f[r>>2]=(f[r>>2]|0)+1;continue a}else if((ac|0)==104){ac=0;f[r>>2]=(f[r>>2]|0)+1;continue a}else if((ac|0)==118){ac=0;f[r>>2]=(f[r>>2]|0)+1;continue a}else if((ac|0)==463){ac=0;yc=L5b(24)|0;cPa(yc);f[Ea>>2]=yc;Wd=yc}yc=f[c>>2]|0;if(yc>>>0<(f[g>>2]|0)>>>0?(bc=b[yc>>0]|0,bc<<24>>24>-1):0){f[c>>2]=yc+1;Xd=bc&255}else{bc=Znb(c)|0;if((bc|0)>-1)Xd=bc;else{ec=0;ac=969;break a}}Inb(e,c,Xd);if((f[Fa>>2]|0)<0){ac=470;break a}if(!(nQa(Wd,c)|0)){ac=470;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}bc=f[c>>2]|0;yc=bc;if(((f[g>>2]|0)-bc|0)<=1)continue a;if((b[yc>>0]|0)!=-54)continue a;if((b[yc+1>>0]|0)!=7)continue a;f[c>>2]=yc+2;ac=477}while(0);if((ac|0)==477){ac=0;f[ra>>2]=f[ra>>2]|4096;Vb=f[Ga>>2]|0;if(!Vb){yc=L5b(68)|0;dPa(yc);f[Ga>>2]=yc;Yd=yc}else Yd=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;Zd=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)Zd=yc;else{ec=0;ac=969;break a}}Inb(e,c,Zd);if((f[Ha>>2]|0)<0){ac=485;break a}if(!(aQa(Yd,c)|0)){ac=485;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-46)continue a;if((b[Vb+1>>0]|0)!=7)continue a;f[c>>2]=Vb+2;ac=492}if((ac|0)==492){ac=0;f[ra>>2]=f[ra>>2]|8192;Vb=f[Ia>>2]|0;if(!Vb){yc=L5b(28)|0;fPa(yc);f[Ia>>2]=yc;_d=yc}else _d=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;$d=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)$d=yc;else{ec=0;ac=969;break a}}Inb(e,c,$d);if((f[Ja>>2]|0)<0){ac=500;break a}if(!(cQa(_d,c)|0)){ac=500;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-38)continue a;if((b[Vb+1>>0]|0)!=7)continue a;f[c>>2]=Vb+2;ac=507}if((ac|0)==507){ac=0;f[ra>>2]=f[ra>>2]|2097152;Vb=f[Ka>>2]|0;if(!Vb){yc=L5b(24)|0;gPa(yc);f[Ka>>2]=yc;ae=yc}else ae=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;be=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)be=yc;else{ec=0;ac=969;break a}}Inb(e,c,be);if((f[La>>2]|0)<0){ac=515;break a}if(!(kQa(ae,c)|0)){ac=515;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-30)continue a;if((b[Vb+1>>0]|0)!=7)continue a;f[c>>2]=Vb+2;ac=522}if((ac|0)==522){ac=0;f[ra>>2]=f[ra>>2]|33554432;Vb=f[Ma>>2]|0;if(!Vb){yc=L5b(20)|0;hPa(yc);f[Ma>>2]=yc;ce=yc}else ce=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;de=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)de=yc;else{ec=0;ac=969;break a}}Inb(e,c,de);if((f[Na>>2]|0)<0){ac=530;break a}if(!(qQa(ce,c)|0)){ac=530;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-22)continue a;if((b[Vb+1>>0]|0)!=7)continue a;f[c>>2]=Vb+2;ac=537}if((ac|0)==537){ac=0;f[ra>>2]=f[ra>>2]|67108864;Vb=f[Oa>>2]|0;if(!Vb){yc=L5b(24)|0;iPa(yc);f[Oa>>2]=yc;ee=yc}else ee=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;fe=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)fe=yc;else{ec=0;ac=969;break a}}Inb(e,c,fe);if((f[Pa>>2]|0)<0){ac=545;break a}if(!(rQa(ee,c)|0)){ac=545;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-14)continue a;if((b[Vb+1>>0]|0)!=7)continue a;f[c>>2]=Vb+2;ac=552}if((ac|0)==552){ac=0;f[ra>>2]=f[ra>>2]|268435456;Vb=f[Qa>>2]|0;if(!Vb){yc=L5b(36)|0;jPa(yc);f[Qa>>2]=yc;ge=yc}else ge=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;he=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)he=yc;else{ec=0;ac=969;break a}}Inb(e,c,he);if((f[Ra>>2]|0)<0){ac=560;break a}if(!(lQa(ge,c)|0)){ac=560;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-6)continue a;if((b[Vb+1>>0]|0)!=7)continue a;f[c>>2]=Vb+2;ac=567}if((ac|0)==567){ac=0;f[ra>>2]=f[ra>>2]|536870912;Vb=f[Sa>>2]|0;if(!Vb){yc=L5b(20)|0;lPa(yc);f[Sa>>2]=yc;ie=yc}else ie=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;je=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)je=yc;else{ec=0;ac=969;break a}}Inb(e,c,je);if((f[Ta>>2]|0)<0){ac=575;break a}if(!(pQa(ie,c)|0)){ac=575;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-126)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=582}if((ac|0)==582){ac=0;f[ra>>2]=f[ra>>2]|1073741824;Vb=f[Ua>>2]|0;if(!Vb){yc=L5b(20)|0;mPa(yc);f[Ua>>2]=yc;ke=yc}else ke=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;le=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)le=yc;else{ec=0;ac=969;break a}}Inb(e,c,le);if((f[Va>>2]|0)<0){ac=590;break a}if(!(gQa(ke,c)|0)){ac=590;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-118)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=597}if((ac|0)==597){ac=0;f[Wa>>2]=f[Wa>>2]|1;Vb=f[Xa>>2]|0;if(!Vb){yc=L5b(64)|0;nPa(yc);f[Xa>>2]=yc;me=yc}else me=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;ne=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)ne=yc;else{ec=0;ac=969;break a}}Inb(e,c,ne);if((f[Ya>>2]|0)<0){ac=605;break a}if(!(bQa(me,c)|0)){ac=605;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-110)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=612}if((ac|0)==612){ac=0;f[ra>>2]=f[ra>>2]|262144;Vb=f[Za>>2]|0;if(!Vb){yc=L5b(32)|0;$Ua(yc);f[Za>>2]=yc;oe=yc}else oe=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;pe=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)pe=yc;else{ec=0;ac=969;break a}}Inb(e,c,pe);if((f[_a>>2]|0)<0){ac=620;break a}if(!(QUa(oe,c)|0)){ac=620;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-102)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=627}if((ac|0)==627){ac=0;f[ra>>2]=f[ra>>2]|16384;Vb=f[$a>>2]|0;if(!Vb){yc=L5b(24)|0;KNa(yc);f[$a>>2]=yc;qe=yc}else qe=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;re=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)re=yc;else{ec=0;ac=969;break a}}Inb(e,c,re);if((f[ab>>2]|0)<0){ac=635;break a}if(!(vNa(qe,c)|0)){ac=635;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-94)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=642}if((ac|0)==642){ac=0;f[ra>>2]=f[ra>>2]|134217728;Vb=f[bb>>2]|0;if(!Vb){yc=L5b(28)|0;VQa(yc);f[bb>>2]=yc;se=yc}else se=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;te=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)te=yc;else{ec=0;ac=969;break a}}Inb(e,c,te);if((f[cb>>2]|0)<0){ac=650;break a}if(!(LQa(se,c)|0)){ac=650;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-86)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=657}if((ac|0)==657){ac=0;f[ra>>2]=f[ra>>2]|4194304;Vb=f[db>>2]|0;if(!Vb){yc=L5b(28)|0;JTa(yc);f[db>>2]=yc;ue=yc}else ue=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;ve=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)ve=yc;else{ec=0;ac=969;break a}}Inb(e,c,ve);if((f[eb>>2]|0)<0){ac=665;break a}if(!(yTa(ue,c)|0)){ac=665;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-78)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=672}if((ac|0)==672){ac=0;f[ra>>2]=f[ra>>2]|32;Vb=f[fb>>2]|0;if(!Vb){yc=L5b(28)|0;gXa(yc);f[fb>>2]=yc;we=yc}else we=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;xe=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)xe=yc;else{ec=0;ac=969;break a}}Inb(e,c,xe);if((f[gb>>2]|0)<0){ac=680;break a}if(!(YWa(we,c)|0)){ac=680;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-70)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=687}if((ac|0)==687){ac=0;f[j>>2]=f[j>>2]|536870912;Vb=f[hb>>2]|0;if(!Vb){yc=L5b(24)|0;AZa(yc);f[hb>>2]=yc;ye=yc}else ye=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;ze=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)ze=yc;else{ec=0;ac=969;break a}}Inb(e,c,ze);if((f[ib>>2]|0)<0){ac=695;break a}if(!(qZa(ye,c)|0)){ac=695;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-62)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=702}if((ac|0)==702){ac=0;f[ra>>2]=f[ra>>2]|1048576;Vb=f[jb>>2]|0;if(!Vb){yc=L5b(28)|0;pUa(yc);f[jb>>2]=yc;Ae=yc}else Ae=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;Be=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)Be=yc;else{ec=0;ac=969;break a}}Inb(e,c,Be);if((f[kb>>2]|0)<0){ac=710;break a}if(!(fUa(Ae,c)|0)){ac=710;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-54)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=717}if((ac|0)==717){ac=0;f[j>>2]=f[j>>2]|134217728;Vb=f[lb>>2]|0;if(!Vb){yc=L5b(36)|0;h_a(yc);f[lb>>2]=yc;Ce=yc}else Ce=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;De=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)De=yc;else{ec=0;ac=969;break a}}Inb(e,c,De);if((f[mb>>2]|0)<0){ac=725;break a}if(!(YZa(Ce,c)|0)){ac=725;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-46)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=732}if((ac|0)==732){ac=0;f[ra>>2]=f[ra>>2]|-2147483648;Vb=f[nb>>2]|0;if(!Vb){yc=L5b(24)|0;QRa(yc);f[nb>>2]=yc;Ee=yc}else Ee=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;Fe=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)Fe=yc;else{ec=0;ac=969;break a}}Inb(e,c,Fe);if((f[ob>>2]|0)<0){ac=740;break a}if(!(GRa(Ee,c)|0)){ac=740;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-38)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=747}if((ac|0)==747){ac=0;f[j>>2]=f[j>>2]|32768;Vb=f[pb>>2]|0;if(!Vb){yc=L5b(28)|0;V1a(yc);f[pb>>2]=yc;Ge=yc}else Ge=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;He=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)He=yc;else{ec=0;ac=969;break a}}Inb(e,c,He);if((f[qb>>2]|0)<0){ac=755;break a}if(!(L1a(Ge,c)|0)){ac=755;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-30)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=762}if((ac|0)==762){ac=0;f[j>>2]=f[j>>2]|67108864;Vb=f[rb>>2]|0;if(!Vb){yc=L5b(20)|0;z_a(yc);f[rb>>2]=yc;Ie=yc}else Ie=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;Je=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)Je=yc;else{ec=0;ac=969;break a}}Inb(e,c,Je);if((f[sb>>2]|0)<0){ac=770;break a}if(!(p_a(Ie,c)|0)){ac=770;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-22)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=777}if((ac|0)==777){ac=0;f[j>>2]=f[j>>2]|65536;Vb=f[tb>>2]|0;if(!Vb){yc=L5b(28)|0;D1a(yc);f[tb>>2]=yc;Ke=yc}else Ke=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;Le=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)Le=yc;else{ec=0;ac=969;break a}}Inb(e,c,Le);if((f[ub>>2]|0)<0){ac=785;break a}if(!(s1a(Ke,c)|0)){ac=785;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-14)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=792}if((ac|0)==792){ac=0;f[ra>>2]=f[ra>>2]|16777216;Vb=f[vb>>2]|0;if(!Vb){yc=L5b(36)|0;qTa(yc);f[vb>>2]=yc;Me=yc}else Me=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;Ne=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)Ne=yc;else{ec=0;ac=969;break a}}Inb(e,c,Ne);if((f[wb>>2]|0)<0){ac=800;break a}if(!(fTa(Me,c)|0)){ac=800;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-6)continue a;if((b[Vb+1>>0]|0)!=8)continue a;f[c>>2]=Vb+2;ac=807}if((ac|0)==807){ac=0;f[ra>>2]=f[ra>>2]|16;Vb=f[xb>>2]|0;if(!Vb){yc=L5b(32)|0;yXa(yc);f[xb>>2]=yc;Oe=yc}else Oe=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;Pe=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)Pe=yc;else{ec=0;ac=969;break a}}Inb(e,c,Pe);if((f[yb>>2]|0)<0){ac=815;break a}if(!(oXa(Oe,c)|0)){ac=815;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-126)continue a;if((b[Vb+1>>0]|0)!=9)continue a;f[c>>2]=Vb+2;ac=822}if((ac|0)==822){ac=0;f[j>>2]=f[j>>2]|1048576;Vb=f[zb>>2]|0;if(!Vb){yc=L5b(32)|0;I0a(yc);f[zb>>2]=yc;Qe=yc}else Qe=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;Re=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)Re=yc;else{ec=0;ac=969;break a}}Inb(e,c,Re);if((f[Ab>>2]|0)<0){ac=830;break a}if(!(y0a(Qe,c)|0)){ac=830;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-118)continue a;if((b[Vb+1>>0]|0)!=9)continue a;f[c>>2]=Vb+2;ac=837}if((ac|0)==837){ac=0;f[ra>>2]=f[ra>>2]|2048;Vb=f[Bb>>2]|0;if(!Vb){yc=L5b(20)|0;YVa(yc);f[Bb>>2]=yc;Se=yc}else Se=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;Te=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)Te=yc;else{ec=0;ac=969;break a}}Inb(e,c,Te);if((f[Cb>>2]|0)<0){ac=845;break a}if(!(NVa(Se,c)|0)){ac=845;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-110)continue a;if((b[Vb+1>>0]|0)!=9)continue a;f[c>>2]=Vb+2;ac=852}if((ac|0)==852){ac=0;f[ra>>2]=f[ra>>2]|524288;Vb=f[Db>>2]|0;if(!Vb){yc=L5b(32)|0;IUa(yc);f[Db>>2]=yc;Ue=yc}else Ue=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;Ve=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)Ve=yc;else{ec=0;ac=969;break a}}Inb(e,c,Ve);if((f[Eb>>2]|0)<0){ac=860;break a}if(!(xUa(Ue,c)|0)){ac=860;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-102)continue a;if((b[Vb+1>>0]|0)!=9)continue a;f[c>>2]=Vb+2;ac=867}if((ac|0)==867){ac=0;f[j>>2]=f[j>>2]|4194304;Vb=f[Fb>>2]|0;if(!Vb){yc=L5b(52)|0;K3a(yc);f[Fb>>2]=yc;We=yc}else We=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;Xe=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)Xe=yc;else{ec=0;ac=969;break a}}Inb(e,c,Xe);if((f[Gb>>2]|0)<0){ac=875;break a}if(!(Y3a(We,c)|0)){ac=875;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-94)continue a;if((b[Vb+1>>0]|0)!=9)continue a;f[c>>2]=Vb+2;ac=882}if((ac|0)==882){ac=0;f[ra>>2]=f[ra>>2]|1024;Vb=f[Hb>>2]|0;if(!Vb){yc=L5b(28)|0;O3a(yc);f[Hb>>2]=yc;Ye=yc}else Ye=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;Ze=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)Ze=yc;else{ec=0;ac=969;break a}}Inb(e,c,Ze);if((f[Ib>>2]|0)<0){ac=890;break a}if(!(Z3a(Ye,c)|0)){ac=890;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-86)continue a;if((b[Vb+1>>0]|0)!=9)continue a;f[c>>2]=Vb+2;ac=897}if((ac|0)==897){ac=0;f[ra>>2]=f[ra>>2]|512;Vb=f[Jb>>2]|0;if(!Vb){yc=L5b(28)|0;M3a(yc);f[Jb>>2]=yc;_e=yc}else _e=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;$e=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)$e=yc;else{ec=0;ac=969;break a}}Inb(e,c,$e);if((f[Kb>>2]|0)<0){ac=905;break a}if(!(_3a(_e,c)|0)){ac=905;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-78)continue a;if((b[Vb+1>>0]|0)!=9)continue a;f[c>>2]=Vb+2;ac=912}if((ac|0)==912){ac=0;f[ra>>2]=f[ra>>2]|32768;Vb=f[Lb>>2]|0;if(!Vb){yc=L5b(128)|0;P3a(yc);f[Lb>>2]=yc;af=yc}else af=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;bf=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)bf=yc;else{ec=0;ac=969;break a}}Inb(e,c,bf);if((f[Mb>>2]|0)<0){ac=920;break a}if(!($3a(af,c)|0)){ac=920;break a}if(!(Onb(c,f[e>>2]|0)|0)){ec=0;ac=969;break a}yc=f[c>>2]|0;Vb=yc;if(((f[g>>2]|0)-yc|0)<=1)continue a;if((b[Vb>>0]|0)!=-54)continue a;if((b[Vb+1>>0]|0)!=12)continue a;f[c>>2]=Vb+2}f[ra>>2]=f[ra>>2]|65536;Vb=f[Nb>>2]|0;if(!Vb){yc=L5b(64)|0;EMa(yc);f[Nb>>2]=yc;cf=yc}else cf=Vb;Vb=f[c>>2]|0;if(Vb>>>0<(f[g>>2]|0)>>>0?(yc=b[Vb>>0]|0,yc<<24>>24>-1):0){f[c>>2]=Vb+1;df=yc&255}else{yc=Znb(c)|0;if((yc|0)>-1)df=yc;else{ec=0;ac=969;break a}}Inb(e,c,df);if((f[Ob>>2]|0)<0){ac=935;break a}if(!(sMa(cf,c)|0)){ac=935;break a}if(Onb(c,f[e>>2]|0)|0)continue a;else{ec=0;ac=969;break a}}while(0);if((ac|0)==963){ac=0;if(!dc){ec=1;ac=969;break}else fc=dc}if((fc&7|0)==4){ec=1;ac=969;break}yc=f[L>>2]|0;if(!(yc&1))ef=hBa(L)|0;else ef=yc&-2;if(!(ZPb(c,fc,ef)|0)){ec=0;ac=969;break}}switch(ac|0){case 51:{ec=0;u=d;return ec|0}case 170:{ec=0;u=d;return ec|0}case 185:{ec=0;u=d;return ec|0}case 200:{ec=0;u=d;return ec|0}case 215:{ec=0;u=d;return ec|0}case 230:{ec=0;u=d;return ec|0}case 245:{ec=0;u=d;return ec|0}case 260:{ec=0;u=d;return ec|0}case 275:{ec=0;u=d;return ec|0}case 290:{ec=0;u=d;return ec|0}case 305:{ec=0;u=d;return ec|0}case 320:{ec=0;u=d;return ec|0}case 335:{ec=0;u=d;return ec|0}case 350:{ec=0;u=d;return ec|0}case 365:{ec=0;u=d;return ec|0}case 380:{ec=0;u=d;return ec|0}case 395:{ec=0;u=d;return ec|0}case 410:{ec=0;u=d;return ec|0}case 425:{ec=0;u=d;return ec|0}case 440:{ec=0;u=d;return ec|0}case 455:{ec=0;u=d;return ec|0}case 470:{ec=0;u=d;return ec|0}case 485:{ec=0;u=d;return ec|0}case 500:{ec=0;u=d;return ec|0}case 515:{ec=0;u=d;return ec|0}case 530:{ec=0;u=d;return ec|0}case 545:{ec=0;u=d;return ec|0}case 560:{ec=0;u=d;return ec|0}case 575:{ec=0;u=d;return ec|0}case 590:{ec=0;u=d;return ec|0}case 605:{ec=0;u=d;return ec|0}case 620:{ec=0;u=d;return ec|0}case 635:{ec=0;u=d;return ec|0}case 650:{ec=0;u=d;return ec|0}case 665:{ec=0;u=d;return ec|0}case 680:{ec=0;u=d;return ec|0}case 695:{ec=0;u=d;return ec|0}case 710:{ec=0;u=d;return ec|0}case 725:{ec=0;u=d;return ec|0}case 740:{ec=0;u=d;return ec|0}case 755:{ec=0;u=d;return ec|0}case 770:{ec=0;u=d;return ec|0}case 785:{ec=0;u=d;return ec|0}case 800:{ec=0;u=d;return ec|0}case 815:{ec=0;u=d;return ec|0}case 830:{ec=0;u=d;return ec|0}case 845:{ec=0;u=d;return ec|0}case 860:{ec=0;u=d;return ec|0}case 875:{ec=0;u=d;return ec|0}case 890:{ec=0;u=d;return ec|0}case 905:{ec=0;u=d;return ec|0}case 920:{ec=0;u=d;return ec|0}case 935:{ec=0;u=d;return ec|0}case 946:{ec=0;u=d;return ec|0}case 957:{ec=0;u=d;return ec|0}case 962:{f[i>>2]=0;b[c+24>>0]=1;ec=1;u=d;return ec|0}case 969:{u=d;return ec|0}}return 0}function z3a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0;c=a+8|0;d=f[c>>2]|0;if(d&19){if(!(d&1)){e=0;g=d}else{h=f[a+144>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&2)){n=e;o=g}else{l=f[a+148>>2]|0;k=b[l+11>>0]|0;if(k<<24>>24<0){m=f[l+4>>2]|0;if(m>>>0<128){p=1;q=g;r=m}else{l=iob(m)|0;p=l;q=f[c>>2]|0;r=m}}else{p=1;q=g;r=k&255}n=e+1+r+p|0;o=q}if(!(o&16)){s=n;t=o}else{q=f[a+368>>2]|0;if((q|0)>=0)if(q>>>0<128){u=1;v=o}else{p=iob(q)|0;u=p;v=f[c>>2]|0}else{u=10;v=o}s=n+1+u|0;t=v}}else{s=0;t=d}if(t&63488){if(!(t&2048)){w=s;x=t}else{d=QPa(f[a+152>>2]|0)|0;if(d>>>0<128)y=1;else y=iob(d)|0;w=s+2+d+y|0;x=f[c>>2]|0}if(!(x&4096)){z=w;A=x}else{x=RPa(f[a+156>>2]|0)|0;if(x>>>0<128)B=1;else B=iob(x)|0;z=w+2+x+B|0;A=f[c>>2]|0}if(!(A&8192)){C=z;D=A}else{A=EPa(f[a+160>>2]|0)|0;if(A>>>0<128)E=1;else E=iob(A)|0;C=z+2+A+E|0;D=f[c>>2]|0}if(!(D&16384)){F=C;G=D}else{D=f[a+164>>2]|0;E=D+8|0;A=f[E>>2]|0;if(A&7){z=A<<1&2;if(!(A&2)){H=z;I=A}else{B=f[D+24>>2]|0;if(B>>>0<128){J=2;K=A}else{A=(iob(B)|0)+1|0;J=A;K=f[E>>2]|0}H=J+z|0;I=K}if(!(I&4))L=H;else{I=f[D+20>>2]|0;if((I|0)>=0)if(I>>>0<128)M=2;else M=(iob(I)|0)+1|0;else M=11;L=M+H|0}}else L=0;H=f[D+4>>2]|0;if(!(H&1))N=L;else N=(dQb(H&-2)|0)+L|0;f[D+12>>2]=N;if(N>>>0<128)O=1;else O=iob(N)|0;F=C+2+N+O|0;G=f[c>>2]|0}if(!(G&32768)){P=F;Q=G}else{G=f[a+168>>2]|0;O=f[G+8>>2]|0;if(!(O&7))R=0;else{N=O<<1&2;C=O&2|0?N|5:N;R=O&4|0?C+5|0:C}C=f[G+4>>2]|0;if(!(C&1))S=R;else S=(dQb(C&-2)|0)+R|0;f[G+12>>2]=S;if(S>>>0<128)T=1;else T=iob(S)|0;P=F+2+S+T|0;Q=f[c>>2]|0}}else{P=s;Q=t}if(Q&16711680){if(!(Q&65536)){U=P;V=Q}else{t=t1a(f[a+172>>2]|0)|0;if(t>>>0<128)W=1;else W=iob(t)|0;U=P+2+t+W|0;V=f[c>>2]|0}if(!(V&131072)){X=U;Y=V}else{V=f[a+176>>2]|0;W=V+8|0;t=f[W>>2]|0;if(t&3){if(t&1){s=f[V+16>>2]|0;if((s|0)>=0)if(s>>>0<128){Z=2;_=t}else{T=(iob(s)|0)+1|0;Z=T;_=f[W>>2]|0}else{Z=11;_=t}}else{Z=0;_=t}if(!(_&2))$=Z;else{_=f[V+20>>2]|0;if(_>>>0<128)aa=2;else aa=(iob(_)|0)+1|0;$=aa+Z|0}}else $=0;Z=f[V+4>>2]|0;if(!(Z&1))ba=$;else ba=(dQb(Z&-2)|0)+$|0;f[V+12>>2]=ba;if(ba>>>0<128)ca=1;else ca=iob(ba)|0;X=U+2+ba+ca|0;Y=f[c>>2]|0}if(!(Y&262144)){da=X;ea=Y}else{Y=f[a+180>>2]|0;ca=f[Y+8>>2]|0;ba=(ca&3|0)==0?0:(ca&1|0?5:0)|ca&2;ca=f[Y+4>>2]|0;if(!(ca&1))fa=ba;else fa=(dQb(ca&-2)|0)+ba|0;f[Y+12>>2]=fa;if(fa>>>0<128)ga=1;else ga=iob(fa)|0;da=X+2+fa+ga|0;ea=f[c>>2]|0}if(!(ea&524288)){ha=da;ia=ea}else{ea=FPa(f[a+184>>2]|0)|0;if(ea>>>0<128)ja=1;else ja=iob(ea)|0;ha=da+2+ea+ja|0;ia=f[c>>2]|0}if(!(ia&1048576)){ka=ha;la=ia}else{ia=f[a+188>>2]|0;if(f[ia+8>>2]&1){ja=f[ia+28>>2]|0;if((ja|0)>=0)if(ja>>>0<128)ma=2;else ma=(iob(ja)|0)+1|0;else ma=11}else ma=0;ja=ia+16|0;ea=f[ja>>2]|0;if(!ea){na=0;oa=0}else{da=ia+24|0;ga=0;fa=0;do{X=f[(f[da>>2]|0)+4+(ga<<2)>>2]|0;if(X>>>0<128)pa=1;else pa=iob(X)|0;fa=pa+fa|0;ga=ga+1|0}while((ga|0)!=(ea|0));na=fa;oa=f[ja>>2]|0}ja=oa+ma+na|0;na=f[ia+4>>2]|0;if(!(na&1))qa=ja;else qa=(dQb(na&-2)|0)+ja|0;f[ia+12>>2]=qa;if(qa>>>0<128)ra=1;else ra=iob(qa)|0;ka=ha+2+qa+ra|0;la=f[c>>2]|0}if(!(la&2097152)){sa=ka;ta=la}else{la=GPa(f[a+192>>2]|0)|0;if(la>>>0<128)ua=1;else ua=iob(la)|0;sa=ka+2+la+ua|0;ta=f[c>>2]|0}if(!(ta&4194304)){va=sa;wa=ta}else{ta=T3a(f[a+196>>2]|0)|0;if(ta>>>0<128)xa=1;else xa=iob(ta)|0;va=sa+2+ta+xa|0;wa=f[c>>2]|0}if(!(wa&8388608)){ya=va;za=wa}else{wa=f[a+200>>2]|0;xa=f[wa+8>>2]|0;ta=(xa&3|0)==0?0:(xa&1|0?5:0)|xa&2;xa=f[wa+4>>2]|0;if(!(xa&1))Aa=ta;else Aa=(dQb(xa&-2)|0)+ta|0;f[wa+12>>2]=Aa;if(Aa>>>0<128)Ba=1;else Ba=iob(Aa)|0;ya=va+2+Aa+Ba|0;za=f[c>>2]|0}}else{ya=P;za=Q}if(za>>>0>16777215){if(!(za&16777216)){Ca=ya;Da=za}else{za=HPa(f[a+204>>2]|0)|0;if(za>>>0<128)Ea=1;else Ea=iob(za)|0;Ca=ya+2+za+Ea|0;Da=f[c>>2]|0}if(!(Da&33554432)){Fa=Ca;Ga=Da}else{Da=f[a+208>>2]|0;Ea=Da+8|0;za=f[Ea>>2]|0;if(!(za&5))Ha=0;else{if(za&1){Q=f[Da+28>>2]|0;if((Q|0)>=0)if(Q>>>0<128){Ia=2;Ja=za}else{P=(iob(Q)|0)+1|0;Ia=P;Ja=f[Ea>>2]|0}else{Ia=11;Ja=za}}else{Ia=0;Ja=za}Ha=Ja&4|0?Ia+2|0:Ia}Ia=f[Da+16>>2]|0;Ja=Ia+Ha+(Ia<<2)|0;Ia=f[Da+4>>2]|0;if(!(Ia&1))Ka=Ja;else Ka=(dQb(Ia&-2)|0)+Ja|0;f[Da+12>>2]=Ka;if(Ka>>>0<128)La=1;else La=iob(Ka)|0;Fa=Ca+2+Ka+La|0;Ga=f[c>>2]|0}if(!(Ga&67108864)){Ma=Fa;Na=Ga}else{Ga=f[a+212>>2]|0;La=f[Ga+8>>2]&1|0?5:0;Ka=f[Ga+4>>2]|0;if(Ka&1){Ca=(dQb(Ka&-2)|0)+La|0;f[Ga+12>>2]=Ca;if(Ca>>>0<128){Oa=1;Pa=Ca}else{Oa=iob(Ca)|0;Pa=Ca}}else{f[Ga+12>>2]=La;Oa=1;Pa=La}Ma=Fa+2+Pa+Oa|0;Na=f[c>>2]|0}if(!(Na&134217728)){Qa=Ma;Ra=Na}else{Na=ZZa(f[a+216>>2]|0)|0;if(Na>>>0<128)Sa=1;else Sa=iob(Na)|0;Qa=Ma+2+Na+Sa|0;Ra=f[c>>2]|0}if(!(Ra&268435456)){Ta=Qa;Ua=Ra}else{Ra=f[a+220>>2]|0;Sa=f[Ra+8>>2]|0;if(!(Sa&7))Va=0;else{Na=Sa&1|0?5:0;Ma=Sa&2|0?Na+5|0:Na;Va=Sa&4|0?Ma+5|0:Ma}Ma=f[Ra+4>>2]|0;if(Ma&1){Sa=(dQb(Ma&-2)|0)+Va|0;f[Ra+12>>2]=Sa;if(Sa>>>0<128){Wa=1;Xa=Sa}else{Wa=iob(Sa)|0;Xa=Sa}}else{f[Ra+12>>2]=Va;Wa=1;Xa=Va}Ta=Qa+2+Xa+Wa|0;Ua=f[c>>2]|0}if(!(Ua&536870912)){Ya=Ta;Za=Ua}else{Ua=f[a+224>>2]|0;Wa=Ua+8|0;Xa=f[Wa>>2]|0;if(Xa&3){if(Xa&1){Qa=f[Ua+16>>2]|0;if((Qa|0)>=0)if(Qa>>>0<128){_a=2;$a=Xa}else{Va=(iob(Qa)|0)+1|0;_a=Va;$a=f[Wa>>2]|0}else{_a=11;$a=Xa}}else{_a=0;$a=Xa}if(!($a&2))ab=_a;else{$a=f[Ua+20>>2]|0;if(($a|0)>=0)if($a>>>0<128)bb=2;else bb=(iob($a)|0)+1|0;else bb=11;ab=bb+_a|0}}else ab=0;_a=f[Ua+4>>2]|0;if(!(_a&1))cb=ab;else cb=(dQb(_a&-2)|0)+ab|0;f[Ua+12>>2]=cb;if(cb>>>0<128)db=1;else db=iob(cb)|0;Ya=Ta+2+cb+db|0;Za=f[c>>2]|0}if(!(Za&1073741824)){eb=Ya;fb=Za}else{Za=IPa(f[a+228>>2]|0)|0;if(Za>>>0<128)gb=1;else gb=iob(Za)|0;eb=Ya+2+Za+gb|0;fb=f[c>>2]|0}if((fb|0)<0){fb=f[a+232>>2]|0;if(!(f[fb+8>>2]&1))hb=0;else{c=f[fb+16>>2]|0;gb=b[c+11>>0]|0;if(gb<<24>>24<0){Za=f[c+4>>2]|0;if(Za>>>0<128){ib=1;jb=Za}else{ib=iob(Za)|0;jb=Za}}else{ib=1;jb=gb&255}hb=jb+1+ib|0}ib=f[fb+4>>2]|0;if(!(ib&1))kb=hb;else kb=(dQb(ib&-2)|0)+hb|0;f[fb+12>>2]=kb;if(kb>>>0<128)lb=1;else lb=iob(kb)|0;mb=eb+2+kb+lb|0}else mb=eb}else mb=ya;ya=a+12|0;eb=f[ya>>2]|0;if(eb&255){if(!(eb&1)){nb=mb;ob=eb}else{lb=f[a+236>>2]|0;if(f[lb+8>>2]&1){kb=f[lb+16>>2]|0;if((kb|0)>=0)if(kb>>>0<128)pb=2;else pb=(iob(kb)|0)+1|0;else pb=11}else pb=0;kb=f[lb+4>>2]|0;if(!(kb&1))qb=pb;else qb=(dQb(kb&-2)|0)+pb|0;f[lb+12>>2]=qb;if(qb>>>0<128)rb=1;else rb=iob(qb)|0;nb=mb+2+qb+rb|0;ob=f[ya>>2]|0}if(!(ob&2)){sb=nb;tb=ob}else{ob=JPa(f[a+240>>2]|0)|0;if(ob>>>0<128)ub=1;else ub=iob(ob)|0;sb=nb+2+ob+ub|0;tb=f[ya>>2]|0}if(!(tb&4)){vb=sb;wb=tb}else{tb=f[a+244>>2]|0;if(!(f[tb+8>>2]&1))xb=0;else{ub=f[tb+16>>2]|0;ob=b[ub+11>>0]|0;if(ob<<24>>24<0){nb=f[ub+4>>2]|0;if(nb>>>0<128){yb=1;zb=nb}else{yb=iob(nb)|0;zb=nb}}else{yb=1;zb=ob&255}xb=zb+1+yb|0}yb=f[tb+4>>2]|0;if(!(yb&1))Ab=xb;else Ab=(dQb(yb&-2)|0)+xb|0;f[tb+12>>2]=Ab;if(Ab>>>0<128)Bb=1;else Bb=iob(Ab)|0;vb=sb+2+Ab+Bb|0;wb=f[ya>>2]|0}if(!(wb&8)){Cb=vb;Db=wb}else{wb=KPa(f[a+248>>2]|0)|0;if(wb>>>0<128)Eb=1;else Eb=iob(wb)|0;Cb=vb+2+wb+Eb|0;Db=f[ya>>2]|0}if(!(Db&16)){Fb=Cb;Gb=Db}else{Db=pXa(f[a+252>>2]|0)|0;if(Db>>>0<128)Hb=1;else Hb=iob(Db)|0;Fb=Cb+2+Db+Hb|0;Gb=f[ya>>2]|0}if(!(Gb&32)){Ib=Fb;Jb=Gb}else{Gb=f[a+256>>2]|0;Hb=f[Gb+8>>2]|0;if(!(Hb&7))Kb=0;else{Db=Hb&1|0?5:0;Cb=Hb&2|0?Db+5|0:Db;Kb=Hb&4|0?Cb+5|0:Cb}Cb=f[Gb+4>>2]|0;if(Cb&1){Hb=(dQb(Cb&-2)|0)+Kb|0;f[Gb+12>>2]=Hb;if(Hb>>>0<128){Lb=1;Mb=Hb}else{Lb=iob(Hb)|0;Mb=Hb}}else{f[Gb+12>>2]=Kb;Lb=1;Mb=Kb}Ib=Fb+2+Mb+Lb|0;Jb=f[ya>>2]|0}if(!(Jb&64)){Nb=Ib;Ob=Jb}else{Jb=LPa(f[a+260>>2]|0)|0;if(Jb>>>0<128)Pb=1;else Pb=iob(Jb)|0;Nb=Ib+2+Jb+Pb|0;Ob=f[ya>>2]|0}if(!(Ob&128)){Qb=Nb;Rb=Ob}else{Ob=MPa(f[a+264>>2]|0)|0;if(Ob>>>0<128)Sb=1;else Sb=iob(Ob)|0;Qb=Nb+2+Ob+Sb|0;Rb=f[ya>>2]|0}}else{Qb=mb;Rb=eb}if(Rb&65280){if(!(Rb&256)){Tb=Qb;Ub=Rb}else{eb=f[a+268>>2]|0;mb=f[eb+8>>2]|0;if(!(mb&7))Vb=0;else{Sb=mb<<1&2;Ob=mb&2|0?Sb+2|0:Sb;Vb=mb&4|0?Ob+5|0:Ob}Ob=f[eb+4>>2]|0;if(Ob&1){mb=(dQb(Ob&-2)|0)+Vb|0;f[eb+12>>2]=mb;if(mb>>>0<128){Wb=1;Xb=mb}else{Wb=iob(mb)|0;Xb=mb}}else{f[eb+12>>2]=Vb;Wb=1;Xb=Vb}Tb=Qb+2+Xb+Wb|0;Ub=f[ya>>2]|0}if(!(Ub&512)){Yb=Tb;Zb=Ub}else{Ub=f[a+272>>2]|0;Wb=Ub+8|0;Xb=f[Wb>>2]|0;if(!(Xb&15))_b=0;else{Vb=Xb<<1&2;if(!(Xb&2)){$b=Vb;ac=Xb}else{Xb=INa(f[Ub+16>>2]|0)|0;if(Xb>>>0<128)bc=1;else bc=iob(Xb)|0;$b=Xb+(Vb|1)+bc|0;ac=f[Wb>>2]|0}Wb=ac&4|0?$b+2|0:$b;_b=ac&8|0?Wb+5|0:Wb}Wb=f[Ub+4>>2]|0;if(!(Wb&1))cc=_b;else cc=(dQb(Wb&-2)|0)+_b|0;f[Ub+12>>2]=cc;if(cc>>>0<128)dc=1;else dc=iob(cc)|0;Yb=Tb+2+cc+dc|0;Zb=f[ya>>2]|0}if(!(Zb&1024)){ec=Yb;fc=Zb}else{Zb=f[a+276>>2]|0;dc=Zb+16|0;cc=f[dc>>2]|0;if(!cc){gc=0;hc=0}else{Tb=Zb+24|0;Ub=0;_b=0;do{Wb=f[(f[Tb>>2]|0)+4+(Ub<<2)>>2]|0;if(Wb>>>0<128)ic=1;else ic=iob(Wb)|0;_b=ic+_b|0;Ub=Ub+1|0}while((Ub|0)!=(cc|0));gc=_b;hc=f[dc>>2]|0}dc=gc+hc|0;hc=f[Zb+4>>2]|0;if(!(hc&1))jc=dc;else jc=(dQb(hc&-2)|0)+dc|0;f[Zb+12>>2]=jc;if(jc>>>0<128)kc=1;else kc=iob(jc)|0;ec=Yb+2+jc+kc|0;fc=f[ya>>2]|0}if(!(fc&2048)){lc=ec;mc=fc}else{fc=OVa(f[a+280>>2]|0)|0;if(fc>>>0<128)nc=1;else nc=iob(fc)|0;lc=ec+2+fc+nc|0;mc=f[ya>>2]|0}if(!(mc&4096)){oc=lc;pc=mc}else{mc=NPa(f[a+284>>2]|0)|0;if(mc>>>0<128)qc=1;else qc=iob(mc)|0;oc=lc+2+mc+qc|0;pc=f[ya>>2]|0}if(!(pc&8192)){rc=oc;sc=pc}else{pc=f[a+288>>2]|0;qc=f[pc+8>>2]|0;if(!(qc&7))tc=0;else{mc=qc&1|0?5:0;lc=qc&2|0?mc+5|0:mc;tc=qc&4|0?lc+5|0:lc}lc=f[pc+4>>2]|0;if(lc&1){qc=(dQb(lc&-2)|0)+tc|0;f[pc+12>>2]=qc;if(qc>>>0<128){uc=1;vc=qc}else{uc=iob(qc)|0;vc=qc}}else{f[pc+12>>2]=tc;uc=1;vc=tc}rc=oc+2+vc+uc|0;sc=f[ya>>2]|0}if(!(sc&16384)){wc=rc;xc=sc}else{sc=f[a+292>>2]|0;uc=sc+8|0;vc=f[uc>>2]|0;if(!(vc&3))yc=0;else{if(!(vc&1)){zc=0;Ac=vc}else{vc=INa(f[sc+16>>2]|0)|0;if(vc>>>0<128)Bc=1;else Bc=iob(vc)|0;zc=vc+1+Bc|0;Ac=f[uc>>2]|0}yc=Ac&2|0?zc+2|0:zc}zc=f[sc+4>>2]|0;if(!(zc&1))Cc=yc;else Cc=(dQb(zc&-2)|0)+yc|0;f[sc+12>>2]=Cc;if(Cc>>>0<128)Dc=1;else Dc=iob(Cc)|0;wc=rc+2+Cc+Dc|0;xc=f[ya>>2]|0}if(!(xc&32768)){Ec=wc;Fc=xc}else{xc=U3a(f[a+296>>2]|0)|0;if(xc>>>0<128)Gc=1;else Gc=iob(xc)|0;Ec=wc+2+xc+Gc|0;Fc=f[ya>>2]|0}}else{Ec=Qb;Fc=Rb}if(Fc&16711680){if(!(Fc&65536)){Hc=Ec;Ic=Fc}else{Rb=tMa(f[a+300>>2]|0)|0;if(Rb>>>0<128)Jc=1;else Jc=iob(Rb)|0;Hc=Ec+2+Rb+Jc|0;Ic=f[ya>>2]|0}if(!(Ic&131072)){Kc=Hc;Lc=Ic}else{Ic=aMa(f[a+304>>2]|0)|0;if(Ic>>>0<128)Mc=1;else Mc=iob(Ic)|0;Kc=Hc+3+Ic+Mc|0;Lc=f[ya>>2]|0}if(!(Lc&262144)){Nc=Kc;Oc=Lc}else{Lc=RUa(f[a+308>>2]|0)|0;if(Lc>>>0<128)Pc=1;else Pc=iob(Lc)|0;Nc=Kc+2+Lc+Pc|0;Oc=f[ya>>2]|0}if(!(Oc&524288)){Qc=Nc;Rc=Oc}else{Oc=yUa(f[a+312>>2]|0)|0;if(Oc>>>0<128)Sc=1;else Sc=iob(Oc)|0;Qc=Nc+2+Oc+Sc|0;Rc=f[ya>>2]|0}if(!(Rc&1048576)){Tc=Qc;Uc=Rc}else{Rc=gUa(f[a+316>>2]|0)|0;if(Rc>>>0<128)Vc=1;else Vc=iob(Rc)|0;Tc=Qc+2+Rc+Vc|0;Uc=f[ya>>2]|0}if(!(Uc&2097152)){Wc=Tc;Xc=Uc}else{Uc=f[a+320>>2]|0;Vc=f[Uc+8>>2]|0;if(Vc&3){Rc=Vc&1|0?5:0;if(!(Vc&2))Yc=Rc;else{Vc=f[Uc+20>>2]|0;do if((Vc|0)<0)Zc=11;else{if(Vc>>>0<128){Zc=2;break}Zc=(iob(Vc)|0)+1|0}while(0);Yc=Zc+Rc|0}}else Yc=0;Rc=f[Uc+4>>2]|0;if(!(Rc&1))_c=Yc;else _c=(dQb(Rc&-2)|0)+Yc|0;f[Uc+12>>2]=_c;if(_c>>>0<128)$c=1;else $c=iob(_c)|0;Wc=Tc+2+_c+$c|0;Xc=f[ya>>2]|0}if(!(Xc&4194304)){ad=Wc;bd=Xc}else{Xc=zTa(f[a+324>>2]|0)|0;if(Xc>>>0<128)cd=1;else cd=iob(Xc)|0;ad=Wc+2+Xc+cd|0;bd=f[ya>>2]|0}if(!(bd&8388608)){dd=ad;ed=bd}else{bd=f[a+328>>2]|0;cd=bd+8|0;Xc=f[cd>>2]|0;if(!(Xc&7))fd=0;else{do if(!(Xc&1)){gd=0;hd=Xc}else{Wc=f[bd+16>>2]|0;if(Wc>>>0<128){gd=2;hd=Xc;break}$c=(iob(Wc)|0)+1|0;gd=$c;hd=f[cd>>2]|0}while(0);if(!(hd&2)){id=gd;jd=hd}else{Xc=f[bd+20>>2]|0;if(Xc>>>0<128){kd=2;ld=hd}else{hd=(iob(Xc)|0)+1|0;kd=hd;ld=f[cd>>2]|0}id=kd+gd|0;jd=ld}fd=jd&4|0?id+5|0:id}id=f[bd+4>>2]|0;if(!(id&1))md=fd;else md=(dQb(id&-2)|0)+fd|0;f[bd+12>>2]=md;if(md>>>0<128)nd=1;else nd=iob(md)|0;dd=ad+4+md+nd|0;ed=f[ya>>2]|0}}else{dd=Ec;ed=Fc}if(ed>>>0>16777215){if(!(ed&16777216)){od=dd;pd=ed}else{ed=gTa(f[a+332>>2]|0)|0;if(ed>>>0<128)qd=1;else qd=iob(ed)|0;od=dd+2+ed+qd|0;pd=f[ya>>2]|0}if(!(pd&33554432)){rd=od;sd=pd}else{pd=f[a+336>>2]|0;if(f[pd+8>>2]&1){qd=f[pd+16>>2]|0;if((qd|0)>=0)if(qd>>>0<128)td=2;else td=(iob(qd)|0)+1|0;else td=11}else td=0;qd=f[pd+4>>2]|0;if(!(qd&1))ud=td;else ud=(dQb(qd&-2)|0)+td|0;f[pd+12>>2]=ud;if(ud>>>0<128)vd=1;else vd=iob(ud)|0;rd=od+2+ud+vd|0;sd=f[ya>>2]|0}if(!(sd&67108864)){wd=rd;xd=sd}else{sd=f[a+340>>2]|0;vd=sd+8|0;ud=f[vd>>2]|0;if(ud&3){if(ud&1){od=f[sd+16>>2]|0;if((od|0)>=0)if(od>>>0<128){yd=2;zd=ud}else{pd=(iob(od)|0)+1|0;yd=pd;zd=f[vd>>2]|0}else{yd=11;zd=ud}}else{yd=0;zd=ud}if(!(zd&2))Ad=yd;else{zd=f[sd+20>>2]|0;if((zd|0)>=0)if(zd>>>0<128)Bd=2;else Bd=(iob(zd)|0)+1|0;else Bd=11;Ad=Bd+yd|0}}else Ad=0;yd=f[sd+4>>2]|0;if(!(yd&1))Cd=Ad;else Cd=(dQb(yd&-2)|0)+Ad|0;f[sd+12>>2]=Cd;if(Cd>>>0<128)Dd=1;else Dd=iob(Cd)|0;wd=rd+2+Cd+Dd|0;xd=f[ya>>2]|0}if(!(xd&134217728)){Ed=wd;Fd=xd}else{xd=MQa(f[a+344>>2]|0)|0;if(xd>>>0<128)Gd=1;else Gd=iob(xd)|0;Ed=wd+2+xd+Gd|0;Fd=f[ya>>2]|0}if(!(Fd&268435456)){Hd=Ed;Id=Fd}else{Fd=OPa(f[a+348>>2]|0)|0;if(Fd>>>0<128)Jd=1;else Jd=iob(Fd)|0;Hd=Ed+2+Fd+Jd|0;Id=f[ya>>2]|0}if(!(Id&536870912)){Kd=Hd;Ld=Id}else{Id=f[a+352>>2]|0;if(f[Id+8>>2]&1){Jd=f[Id+16>>2]|0;if((Jd|0)>=0)if(Jd>>>0<128)Md=2;else Md=(iob(Jd)|0)+1|0;else Md=11}else Md=0;Jd=f[Id+4>>2]|0;if(!(Jd&1))Nd=Md;else Nd=(dQb(Jd&-2)|0)+Md|0;f[Id+12>>2]=Nd;if(Nd>>>0<128)Od=1;else Od=iob(Nd)|0;Kd=Hd+2+Nd+Od|0;Ld=f[ya>>2]|0}if(!(Ld&1073741824)){Pd=Kd;Qd=Ld}else{Ld=f[a+356>>2]|0;Od=f[Ld+8>>2]&1|0?5:0;Nd=f[Ld+4>>2]|0;if(Nd&1){Hd=(dQb(Nd&-2)|0)+Od|0;f[Ld+12>>2]=Hd;if(Hd>>>0<128){Rd=1;Sd=Hd}else{Rd=iob(Hd)|0;Sd=Hd}}else{f[Ld+12>>2]=Od;Rd=1;Sd=Od}Pd=Kd+2+Sd+Rd|0;Qd=f[ya>>2]|0}if((Qd|0)<0){Qd=f[a+360>>2]|0;ya=Qd+8|0;Rd=f[ya>>2]|0;do if(!(Rd&3))Td=0;else{do if(!(Rd&1)){Ud=0;Vd=Rd}else{Sd=f[Qd+20>>2]|0;if((Sd|0)<0){Ud=11;Vd=Rd;break}if(Sd>>>0<128){Ud=2;Vd=Rd;break}Kd=(iob(Sd)|0)+1|0;Ud=Kd;Vd=f[ya>>2]|0}while(0);if(!(Vd&2)){Td=Ud;break}Kd=f[Qd+16>>2]|0;do if((Kd|0)<0)Wd=11;else{if(Kd>>>0<128){Wd=2;break}Wd=(iob(Kd)|0)+1|0}while(0);Td=Wd+Ud|0}while(0);Ud=f[Qd+4>>2]|0;if(!(Ud&1))Xd=Td;else Xd=(dQb(Ud&-2)|0)+Td|0;f[Qd+12>>2]=Xd;if(Xd>>>0<128)Yd=1;else Yd=iob(Xd)|0;Zd=Pd+2+Xd+Yd|0}else Zd=Pd}else Zd=dd;if(!(f[a+16>>2]&1))_d=Zd;else{dd=PPa(f[a+364>>2]|0)|0;if(dd>>>0<128)$d=1;else $d=iob(dd)|0;_d=Zd+2+dd+$d|0}$d=a+28|0;dd=f[$d>>2]|0;Zd=dd+_d|0;if((dd|0)>0){_d=a+36|0;Pd=0;Yd=Zd;Xd=dd;while(1){dd=f[(f[_d>>2]|0)+4+(Pd<<2)>>2]|0;Qd=b[dd+11>>0]|0;if(Qd<<24>>24<0){Td=f[dd+4>>2]|0;if(Td>>>0<128){ae=1;be=Td;ce=Xd}else{dd=iob(Td)|0;ae=dd;be=Td;ce=f[$d>>2]|0}}else{ae=1;be=Qd&255;ce=Xd}Qd=be+Yd+ae|0;Pd=Pd+1|0;if((Pd|0)>=(ce|0)){de=Qd;break}else{Yd=Qd;Xd=ce}}}else de=Zd;Zd=a+44|0;ce=f[Zd>>2]|0;Xd=ce+de|0;if((ce|0)>0){de=a+52|0;Yd=0;Pd=Xd;ae=ce;while(1){ce=f[(f[de>>2]|0)+4+(Yd<<2)>>2]|0;be=b[ce+11>>0]|0;if(be<<24>>24<0){$d=f[ce+4>>2]|0;if($d>>>0<128){ee=1;fe=$d;ge=ae}else{ce=iob($d)|0;ee=ce;fe=$d;ge=f[Zd>>2]|0}}else{ee=1;fe=be&255;ge=ae}be=fe+Pd+ee|0;Yd=Yd+1|0;if((Yd|0)>=(ge|0)){he=be;break}else{Pd=be;ae=ge}}}else he=Xd;Xd=f[a+56>>2]|0;ge=f[a+72>>2]|0;ae=Xd+he+(Xd<<2)+ge|0;if(!ge)ie=ae;else{Xd=a+80|0;he=0;Pd=ae;while(1){ae=V3a(f[(f[Xd>>2]|0)+4+(he<<2)>>2]|0)|0;if(ae>>>0<128)je=1;else je=iob(ae)|0;Yd=ae+Pd+je|0;he=he+1|0;if((he|0)==(ge|0)){ie=Yd;break}else Pd=Yd}}Pd=f[a+88>>2]|0;ge=Pd+ie|0;if(!Pd)ke=ge;else{ie=a+96|0;he=0;je=ge;while(1){ge=gOa(f[(f[ie>>2]|0)+4+(he<<2)>>2]|0)|0;if(ge>>>0<128)le=1;else le=iob(ge)|0;Xd=ge+je+le|0;he=he+1|0;if((he|0)==(Pd|0)){ke=Xd;break}else je=Xd}}je=f[a+116>>2]|0;Pd=je+ke+(f[a+100>>2]<<1)|0;if(!je)me=Pd;else{ke=a+124|0;he=0;le=Pd;while(1){Pd=SPa(f[(f[ke>>2]|0)+4+(he<<2)>>2]|0)|0;if(Pd>>>0<128)ne=1;else ne=iob(Pd)|0;ie=Pd+le+ne|0;he=he+1|0;if((he|0)==(je|0)){me=ie;break}else le=ie}}le=f[a+132>>2]|0;je=le+me|0;if(!le)oe=je;else{me=a+140|0;he=0;ne=je;while(1){je=SPa(f[(f[me>>2]|0)+4+(he<<2)>>2]|0)|0;if(je>>>0<128)pe=1;else pe=iob(je)|0;ke=je+ne+pe|0;he=he+1|0;if((he|0)==(le|0)){oe=ke;break}else ne=ke}}ne=f[a+4>>2]|0;if(!(ne&1)){qe=oe;re=a+20|0;f[re>>2]=qe;return qe|0}qe=(dQb(ne&-2)|0)+oe|0;re=a+20|0;f[re>>2]=qe;return qe|0}function A3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{$pb(1,f[a+144>>2]|0,c);g=f[d>>2]|0}if(g&2|0)$pb(2,f[a+148>>2]|0,c);g=a+28|0;if((f[g>>2]|0)>0){e=a+36|0;h=0;do{_pb(3,f[(f[e>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)<(f[g>>2]|0))}g=a+44|0;if((f[g>>2]|0)>0){h=a+52|0;e=0;do{_pb(4,f[(f[h>>2]|0)+4+(e<<2)>>2]|0,c);e=e+1|0}while((e|0)<(f[g>>2]|0))}g=a+56|0;if((f[g>>2]|0)>0){e=a+64|0;h=0;do{Wpb(5,+n[(f[e>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)<(f[g>>2]|0))}g=f[a+72>>2]|0;if(g|0){h=a+80|0;e=0;do{eqb(6,f[(f[h>>2]|0)+4+(e<<2)>>2]|0,c);e=e+1|0}while((e|0)!=(g|0))}g=f[a+88>>2]|0;if(g|0){e=a+96|0;h=0;do{eqb(7,f[(f[e>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(g|0))}g=f[a+116>>2]|0;if(g|0){h=a+124|0;e=0;do{eqb(8,f[(f[h>>2]|0)+4+(e<<2)>>2]|0,c);e=e+1|0}while((e|0)!=(g|0))}g=f[a+132>>2]|0;if(g|0){e=a+140|0;h=0;do{eqb(9,f[(f[e>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(g|0))}if(f[d>>2]&16|0)Zpb(10,f[a+368>>2]|0,c);g=a+100|0;if((f[g>>2]|0)>0){h=a+108|0;e=0;do{Ypb(11,(b[(f[h>>2]|0)+4+e>>0]|0)!=0,c);e=e+1|0}while((e|0)<(f[g>>2]|0))}g=f[d>>2]|0;if(!(g&2048))i=g;else{eqb(100,f[a+152>>2]|0,c);i=f[d>>2]|0}if(!(i&4096))j=i;else{eqb(101,f[a+156>>2]|0,c);j=f[d>>2]|0}if(!(j&8192))k=j;else{eqb(102,f[a+160>>2]|0,c);k=f[d>>2]|0}if(!(k&16384))l=k;else{eqb(103,f[a+164>>2]|0,c);l=f[d>>2]|0}if(!(l&131072))m=l;else{eqb(104,f[a+176>>2]|0,c);m=f[d>>2]|0}if(!(m&262144))o=m;else{eqb(105,f[a+180>>2]|0,c);o=f[d>>2]|0}if(!(o&524288))p=o;else{eqb(106,f[a+184>>2]|0,c);p=f[d>>2]|0}if(!(p&2097152))q=p;else{eqb(107,f[a+192>>2]|0,c);q=f[d>>2]|0}if(!(q&8388608))r=q;else{eqb(108,f[a+200>>2]|0,c);r=f[d>>2]|0}if(!(r&16777216))s=r;else{eqb(109,f[a+204>>2]|0,c);s=f[d>>2]|0}if(!(s&33554432))t=s;else{eqb(110,f[a+208>>2]|0,c);t=f[d>>2]|0}if(!(t&268435456))u=t;else{eqb(111,f[a+220>>2]|0,c);u=f[d>>2]|0}if(!(u&1073741824))v=u;else{eqb(112,f[a+228>>2]|0,c);v=f[d>>2]|0}if((v|0)<0)eqb(113,f[a+232>>2]|0,c);v=a+12|0;u=f[v>>2]|0;if(!(u&1))w=u;else{eqb(114,f[a+236>>2]|0,c);w=f[v>>2]|0}if(!(w&2))x=w;else{eqb(115,f[a+240>>2]|0,c);x=f[v>>2]|0}if(!(x&4))y=x;else{eqb(116,f[a+244>>2]|0,c);y=f[v>>2]|0}if(!(y&8))z=y;else{eqb(117,f[a+248>>2]|0,c);z=f[v>>2]|0}if(!(z&64))A=z;else{eqb(118,f[a+260>>2]|0,c);A=f[v>>2]|0}if(!(A&128))B=A;else{eqb(119,f[a+264>>2]|0,c);B=f[v>>2]|0}if(!(B&256))C=B;else{eqb(120,f[a+268>>2]|0,c);C=f[v>>2]|0}if(!(C&4096))D=C;else{eqb(121,f[a+284>>2]|0,c);D=f[v>>2]|0}if(!(D&8192))E=D;else{eqb(122,f[a+288>>2]|0,c);E=f[v>>2]|0}if(!(E&2097152))F=E;else{eqb(123,f[a+320>>2]|0,c);F=f[v>>2]|0}if(!(F&33554432))G=F;else{eqb(124,f[a+336>>2]|0,c);G=f[v>>2]|0}if(!(G&67108864))H=G;else{eqb(125,f[a+340>>2]|0,c);H=f[v>>2]|0}if(!(H&268435456))I=H;else{eqb(126,f[a+348>>2]|0,c);I=f[v>>2]|0}if(!(I&536870912))J=I;else{eqb(127,f[a+352>>2]|0,c);J=f[v>>2]|0}if(J&1073741824|0)eqb(128,f[a+356>>2]|0,c);if(f[a+16>>2]&1|0)eqb(129,f[a+364>>2]|0,c);J=f[v>>2]|0;if(!(J&262144))K=J;else{eqb(130,f[a+308>>2]|0,c);K=f[v>>2]|0}if(!(K&16384))L=K;else{eqb(131,f[a+292>>2]|0,c);L=f[v>>2]|0}if(!(L&134217728))M=L;else{eqb(132,f[a+344>>2]|0,c);M=f[v>>2]|0}if(!(M&4194304))N=M;else{eqb(133,f[a+324>>2]|0,c);N=f[v>>2]|0}if(N&32|0)eqb(134,f[a+256>>2]|0,c);if(f[d>>2]&536870912|0)eqb(135,f[a+224>>2]|0,c);if(f[v>>2]&1048576|0)eqb(136,f[a+316>>2]|0,c);if(f[d>>2]&134217728|0)eqb(137,f[a+216>>2]|0,c);if((f[v>>2]|0)<0)eqb(138,f[a+360>>2]|0,c);N=f[d>>2]|0;if(!(N&32768))O=N;else{eqb(139,f[a+168>>2]|0,c);O=f[d>>2]|0}if(!(O&67108864))P=O;else{eqb(140,f[a+212>>2]|0,c);P=f[d>>2]|0}if(P&65536|0)eqb(141,f[a+172>>2]|0,c);P=f[v>>2]|0;if(!(P&16777216))Q=P;else{eqb(142,f[a+332>>2]|0,c);Q=f[v>>2]|0}if(Q&16|0)eqb(143,f[a+252>>2]|0,c);if(f[d>>2]&1048576|0)eqb(144,f[a+188>>2]|0,c);Q=f[v>>2]|0;if(!(Q&2048))R=Q;else{eqb(145,f[a+280>>2]|0,c);R=f[v>>2]|0}if(R&524288|0)eqb(146,f[a+312>>2]|0,c);if(f[d>>2]&4194304|0)eqb(147,f[a+196>>2]|0,c);d=f[v>>2]|0;if(!(d&1024))S=d;else{eqb(148,f[a+276>>2]|0,c);S=f[v>>2]|0}if(!(S&512))T=S;else{eqb(149,f[a+272>>2]|0,c);T=f[v>>2]|0}if(!(T&32768))U=T;else{eqb(150,f[a+296>>2]|0,c);U=f[v>>2]|0}if(!(U&65536))V=U;else{eqb(201,f[a+300>>2]|0,c);V=f[v>>2]|0}if(!(V&131072))W=V;else{eqb(10001,f[a+304>>2]|0,c);W=f[v>>2]|0}if(W&8388608|0)eqb(8266711,f[a+328>>2]|0,c);W=f[a+4>>2]|0;if(!(W&1))return;aQb(W&-2,c);return}function B3a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function C3a(a){a=a|0;return f[a+20>>2]|0}function D3a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+144>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&2))j=g;else{h=f[a+148>>2]|0;b[g>>0]=18;j=kob(h,g+1|0)|0}g=a+28|0;if((f[g>>2]|0)>0){h=a+36|0;i=0;d=j;while(1){e=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[d>>0]=26;k=kob(e,d+1|0)|0;i=i+1|0;if((i|0)>=(f[g>>2]|0)){l=k;break}else d=k}}else l=j;j=a+44|0;if((f[j>>2]|0)>0){d=a+52|0;g=0;i=l;while(1){h=f[(f[d>>2]|0)+4+(g<<2)>>2]|0;b[i>>0]=34;k=kob(h,i+1|0)|0;g=g+1|0;if((g|0)>=(f[j>>2]|0)){m=k;break}else i=k}}else m=l;l=a+56|0;if((f[l>>2]|0)>0){i=a+64|0;j=0;g=m;while(1){d=f[(f[i>>2]|0)+4+(j<<2)>>2]|0;b[g>>0]=45;k=g+1|0;b[k>>0]=d;b[k+1>>0]=d>>8;b[k+2>>0]=d>>16;b[k+3>>0]=d>>24;d=g+5|0;j=j+1|0;if((j|0)>=(f[l>>2]|0)){n=d;break}else g=d}}else n=m;m=f[a+72>>2]|0;if(!m)o=n;else{g=a+80|0;l=0;j=n;while(1){n=f[(f[g>>2]|0)+4+(l<<2)>>2]|0;b[j>>0]=50;i=j+1|0;d=f[n+12>>2]|0;if(d>>>0>127){k=d;h=i;while(1){b[h>>0]=k|128;e=k>>>7;p=h+1|0;if(k>>>0>16383){k=e;h=p}else{q=p;r=e;break}}}else{q=i;r=d}b[q>>0]=r;h=li[f[(f[n>>2]|0)+68>>2]&511](n,0,q+1|0)|0;l=l+1|0;if((l|0)==(m|0)){o=h;break}else j=h}}j=f[a+88>>2]|0;if(!j)s=o;else{m=a+96|0;l=0;q=o;while(1){o=f[(f[m>>2]|0)+4+(l<<2)>>2]|0;b[q>>0]=58;r=q+1|0;g=f[o+12>>2]|0;if(g>>>0>127){h=g;k=r;while(1){b[k>>0]=h|128;e=h>>>7;p=k+1|0;if(h>>>0>16383){h=e;k=p}else{t=p;u=e;break}}}else{t=r;u=g}b[t>>0]=u;k=li[f[(f[o>>2]|0)+68>>2]&511](o,0,t+1|0)|0;l=l+1|0;if((l|0)==(j|0)){s=k;break}else q=k}}q=f[a+116>>2]|0;if(!q)v=s;else{j=a+124|0;l=0;t=s;while(1){s=f[(f[j>>2]|0)+4+(l<<2)>>2]|0;b[t>>0]=66;u=t+1|0;m=f[s+12>>2]|0;if(m>>>0>127){k=m;h=u;while(1){b[h>>0]=k|128;n=k>>>7;d=h+1|0;if(k>>>0>16383){k=n;h=d}else{w=d;x=n;break}}}else{w=u;x=m}b[w>>0]=x;h=li[f[(f[s>>2]|0)+68>>2]&511](s,0,w+1|0)|0;l=l+1|0;if((l|0)==(q|0)){v=h;break}else t=h}}t=f[a+132>>2]|0;if(!t)y=v;else{q=a+140|0;l=0;w=v;while(1){v=f[(f[q>>2]|0)+4+(l<<2)>>2]|0;b[w>>0]=74;x=w+1|0;j=f[v+12>>2]|0;if(j>>>0>127){h=j;k=x;while(1){b[k>>0]=h|128;o=h>>>7;g=k+1|0;if(h>>>0>16383){h=o;k=g}else{z=g;A=o;break}}}else{z=x;A=j}b[z>>0]=A;k=li[f[(f[v>>2]|0)+68>>2]&511](v,0,z+1|0)|0;l=l+1|0;if((l|0)==(t|0)){y=k;break}else w=k}}do if(!(f[c>>2]&16))B=y;else{w=f[a+368>>2]|0;b[y>>0]=80;t=y+1|0;if((w|0)<0){B=hob(w,((w|0)<0)<<31>>31,t)|0;break}if(w>>>0>127){l=w;z=t;while(1){b[z>>0]=l|128;A=l>>>7;q=z+1|0;if(l>>>0>16383){l=A;z=q}else{C=q;D=A;break}}}else{C=t;D=w}b[C>>0]=D;B=C+1|0}while(0);C=a+100|0;if((f[C>>2]|0)>0){D=a+108|0;y=0;z=B;while(1){l=b[(f[D>>2]|0)+4+y>>0]|0;b[z>>0]=88;b[z+1>>0]=l;l=z+2|0;y=y+1|0;if((y|0)>=(f[C>>2]|0)){E=l;break}else z=l}}else E=B;B=f[c>>2]|0;if(!(B&2048)){F=E;G=B}else{B=f[a+152>>2]|0;b[E>>0]=-94;b[E+1>>0]=6;z=E+2|0;E=f[B+12>>2]|0;if(E>>>0>127){C=E;y=z;while(1){b[y>>0]=C|128;D=C>>>7;l=y+1|0;if(C>>>0>16383){C=D;y=l}else{H=l;I=D;break}}}else{H=z;I=E}b[H>>0]=I;I=li[f[(f[B>>2]|0)+68>>2]&511](B,0,H+1|0)|0;F=I;G=f[c>>2]|0}if(!(G&4096)){J=F;K=G}else{G=f[a+156>>2]|0;b[F>>0]=-86;b[F+1>>0]=6;I=F+2|0;F=f[G+12>>2]|0;if(F>>>0>127){H=F;B=I;while(1){b[B>>0]=H|128;E=H>>>7;z=B+1|0;if(H>>>0>16383){H=E;B=z}else{L=z;M=E;break}}}else{L=I;M=F}b[L>>0]=M;M=li[f[(f[G>>2]|0)+68>>2]&511](G,0,L+1|0)|0;J=M;K=f[c>>2]|0}if(!(K&8192)){N=J;O=K}else{K=f[a+160>>2]|0;b[J>>0]=-78;b[J+1>>0]=6;M=J+2|0;J=f[K+12>>2]|0;if(J>>>0>127){L=J;G=M;while(1){b[G>>0]=L|128;F=L>>>7;I=G+1|0;if(L>>>0>16383){L=F;G=I}else{P=I;Q=F;break}}}else{P=M;Q=J}b[P>>0]=Q;Q=li[f[(f[K>>2]|0)+68>>2]&511](K,0,P+1|0)|0;N=Q;O=f[c>>2]|0}if(!(O&16384)){R=N;S=O}else{O=f[a+164>>2]|0;b[N>>0]=-70;b[N+1>>0]=6;Q=N+2|0;N=f[O+12>>2]|0;if(N>>>0>127){P=N;K=Q;while(1){b[K>>0]=P|128;J=P>>>7;M=K+1|0;if(P>>>0>16383){P=J;K=M}else{T=M;U=J;break}}}else{T=Q;U=N}b[T>>0]=U;U=li[f[(f[O>>2]|0)+68>>2]&511](O,0,T+1|0)|0;R=U;S=f[c>>2]|0}if(!(S&131072)){V=R;W=S}else{S=f[a+176>>2]|0;b[R>>0]=-62;b[R+1>>0]=6;U=R+2|0;R=f[S+12>>2]|0;if(R>>>0>127){T=R;O=U;while(1){b[O>>0]=T|128;N=T>>>7;Q=O+1|0;if(T>>>0>16383){T=N;O=Q}else{X=Q;Y=N;break}}}else{X=U;Y=R}b[X>>0]=Y;Y=li[f[(f[S>>2]|0)+68>>2]&511](S,0,X+1|0)|0;V=Y;W=f[c>>2]|0}if(!(W&262144)){Z=V;_=W}else{W=f[a+180>>2]|0;b[V>>0]=-54;b[V+1>>0]=6;Y=V+2|0;V=f[W+12>>2]|0;if(V>>>0>127){X=V;S=Y;while(1){b[S>>0]=X|128;R=X>>>7;U=S+1|0;if(X>>>0>16383){X=R;S=U}else{$=U;aa=R;break}}}else{$=Y;aa=V}b[$>>0]=aa;aa=li[f[(f[W>>2]|0)+68>>2]&511](W,0,$+1|0)|0;Z=aa;_=f[c>>2]|0}if(!(_&524288)){ba=Z;ca=_}else{_=f[a+184>>2]|0;b[Z>>0]=-46;b[Z+1>>0]=6;aa=Z+2|0;Z=f[_+12>>2]|0;if(Z>>>0>127){$=Z;W=aa;while(1){b[W>>0]=$|128;V=$>>>7;Y=W+1|0;if($>>>0>16383){$=V;W=Y}else{da=Y;ea=V;break}}}else{da=aa;ea=Z}b[da>>0]=ea;ea=li[f[(f[_>>2]|0)+68>>2]&511](_,0,da+1|0)|0;ba=ea;ca=f[c>>2]|0}if(!(ca&2097152)){fa=ba;ga=ca}else{ca=f[a+192>>2]|0;b[ba>>0]=-38;b[ba+1>>0]=6;ea=ba+2|0;ba=f[ca+12>>2]|0;if(ba>>>0>127){da=ba;_=ea;while(1){b[_>>0]=da|128;Z=da>>>7;aa=_+1|0;if(da>>>0>16383){da=Z;_=aa}else{ha=aa;ia=Z;break}}}else{ha=ea;ia=ba}b[ha>>0]=ia;ia=li[f[(f[ca>>2]|0)+68>>2]&511](ca,0,ha+1|0)|0;fa=ia;ga=f[c>>2]|0}if(!(ga&8388608)){ja=fa;ka=ga}else{ga=f[a+200>>2]|0;b[fa>>0]=-30;b[fa+1>>0]=6;ia=fa+2|0;fa=f[ga+12>>2]|0;if(fa>>>0>127){ha=fa;ca=ia;while(1){b[ca>>0]=ha|128;ba=ha>>>7;ea=ca+1|0;if(ha>>>0>16383){ha=ba;ca=ea}else{la=ea;ma=ba;break}}}else{la=ia;ma=fa}b[la>>0]=ma;ma=li[f[(f[ga>>2]|0)+68>>2]&511](ga,0,la+1|0)|0;ja=ma;ka=f[c>>2]|0}if(!(ka&16777216)){na=ja;oa=ka}else{ka=f[a+204>>2]|0;b[ja>>0]=-22;b[ja+1>>0]=6;ma=ja+2|0;ja=f[ka+12>>2]|0;if(ja>>>0>127){la=ja;ga=ma;while(1){b[ga>>0]=la|128;fa=la>>>7;ia=ga+1|0;if(la>>>0>16383){la=fa;ga=ia}else{pa=ia;qa=fa;break}}}else{pa=ma;qa=ja}b[pa>>0]=qa;qa=li[f[(f[ka>>2]|0)+68>>2]&511](ka,0,pa+1|0)|0;na=qa;oa=f[c>>2]|0}if(!(oa&33554432)){ra=na;sa=oa}else{oa=f[a+208>>2]|0;b[na>>0]=-14;b[na+1>>0]=6;qa=na+2|0;na=f[oa+12>>2]|0;if(na>>>0>127){pa=na;ka=qa;while(1){b[ka>>0]=pa|128;ja=pa>>>7;ma=ka+1|0;if(pa>>>0>16383){pa=ja;ka=ma}else{ta=ma;ua=ja;break}}}else{ta=qa;ua=na}b[ta>>0]=ua;ua=li[f[(f[oa>>2]|0)+68>>2]&511](oa,0,ta+1|0)|0;ra=ua;sa=f[c>>2]|0}if(!(sa&268435456)){va=ra;wa=sa}else{sa=f[a+220>>2]|0;b[ra>>0]=-6;b[ra+1>>0]=6;ua=ra+2|0;ra=f[sa+12>>2]|0;if(ra>>>0>127){ta=ra;oa=ua;while(1){b[oa>>0]=ta|128;na=ta>>>7;qa=oa+1|0;if(ta>>>0>16383){ta=na;oa=qa}else{xa=qa;ya=na;break}}}else{xa=ua;ya=ra}b[xa>>0]=ya;ya=li[f[(f[sa>>2]|0)+68>>2]&511](sa,0,xa+1|0)|0;va=ya;wa=f[c>>2]|0}if(!(wa&1073741824)){za=va;Aa=wa}else{wa=f[a+228>>2]|0;b[va>>0]=-126;b[va+1>>0]=7;ya=va+2|0;va=f[wa+12>>2]|0;if(va>>>0>127){xa=va;sa=ya;while(1){b[sa>>0]=xa|128;ra=xa>>>7;ua=sa+1|0;if(xa>>>0>16383){xa=ra;sa=ua}else{Ba=ua;Ca=ra;break}}}else{Ba=ya;Ca=va}b[Ba>>0]=Ca;Ca=li[f[(f[wa>>2]|0)+68>>2]&511](wa,0,Ba+1|0)|0;za=Ca;Aa=f[c>>2]|0}if((Aa|0)<0){Aa=f[a+232>>2]|0;b[za>>0]=-118;b[za+1>>0]=7;Ca=za+2|0;Ba=f[Aa+12>>2]|0;if(Ba>>>0>127){wa=Ba;va=Ca;while(1){b[va>>0]=wa|128;ya=wa>>>7;sa=va+1|0;if(wa>>>0>16383){wa=ya;va=sa}else{Da=sa;Ea=ya;break}}}else{Da=Ca;Ea=Ba}b[Da>>0]=Ea;Fa=li[f[(f[Aa>>2]|0)+68>>2]&511](Aa,0,Da+1|0)|0}else Fa=za;za=a+12|0;Da=f[za>>2]|0;if(!(Da&1)){Ga=Fa;Ha=Da}else{Da=f[a+236>>2]|0;b[Fa>>0]=-110;b[Fa+1>>0]=7;Aa=Fa+2|0;Fa=f[Da+12>>2]|0;if(Fa>>>0>127){Ea=Fa;Ba=Aa;while(1){b[Ba>>0]=Ea|128;Ca=Ea>>>7;va=Ba+1|0;if(Ea>>>0>16383){Ea=Ca;Ba=va}else{Ia=va;Ja=Ca;break}}}else{Ia=Aa;Ja=Fa}b[Ia>>0]=Ja;Ja=li[f[(f[Da>>2]|0)+68>>2]&511](Da,0,Ia+1|0)|0;Ga=Ja;Ha=f[za>>2]|0}if(!(Ha&2)){Ka=Ga;La=Ha}else{Ha=f[a+240>>2]|0;b[Ga>>0]=-102;b[Ga+1>>0]=7;Ja=Ga+2|0;Ga=f[Ha+12>>2]|0;if(Ga>>>0>127){Ia=Ga;Da=Ja;while(1){b[Da>>0]=Ia|128;Fa=Ia>>>7;Aa=Da+1|0;if(Ia>>>0>16383){Ia=Fa;Da=Aa}else{Ma=Aa;Na=Fa;break}}}else{Ma=Ja;Na=Ga}b[Ma>>0]=Na;Na=li[f[(f[Ha>>2]|0)+68>>2]&511](Ha,0,Ma+1|0)|0;Ka=Na;La=f[za>>2]|0}if(!(La&4)){Oa=Ka;Pa=La}else{La=f[a+244>>2]|0;b[Ka>>0]=-94;b[Ka+1>>0]=7;Na=Ka+2|0;Ka=f[La+12>>2]|0;if(Ka>>>0>127){Ma=Ka;Ha=Na;while(1){b[Ha>>0]=Ma|128;Ga=Ma>>>7;Ja=Ha+1|0;if(Ma>>>0>16383){Ma=Ga;Ha=Ja}else{Qa=Ja;Ra=Ga;break}}}else{Qa=Na;Ra=Ka}b[Qa>>0]=Ra;Ra=li[f[(f[La>>2]|0)+68>>2]&511](La,0,Qa+1|0)|0;Oa=Ra;Pa=f[za>>2]|0}if(!(Pa&8)){Sa=Oa;Ta=Pa}else{Pa=f[a+248>>2]|0;b[Oa>>0]=-86;b[Oa+1>>0]=7;Ra=Oa+2|0;Oa=f[Pa+12>>2]|0;if(Oa>>>0>127){Qa=Oa;La=Ra;while(1){b[La>>0]=Qa|128;Ka=Qa>>>7;Na=La+1|0;if(Qa>>>0>16383){Qa=Ka;La=Na}else{Ua=Na;Va=Ka;break}}}else{Ua=Ra;Va=Oa}b[Ua>>0]=Va;Va=li[f[(f[Pa>>2]|0)+68>>2]&511](Pa,0,Ua+1|0)|0;Sa=Va;Ta=f[za>>2]|0}if(!(Ta&64)){Wa=Sa;Xa=Ta}else{Ta=f[a+260>>2]|0;b[Sa>>0]=-78;b[Sa+1>>0]=7;Va=Sa+2|0;Sa=f[Ta+12>>2]|0;if(Sa>>>0>127){Ua=Sa;Pa=Va;while(1){b[Pa>>0]=Ua|128;Oa=Ua>>>7;Ra=Pa+1|0;if(Ua>>>0>16383){Ua=Oa;Pa=Ra}else{Ya=Ra;Za=Oa;break}}}else{Ya=Va;Za=Sa}b[Ya>>0]=Za;Za=li[f[(f[Ta>>2]|0)+68>>2]&511](Ta,0,Ya+1|0)|0;Wa=Za;Xa=f[za>>2]|0}if(!(Xa&128)){_a=Wa;$a=Xa}else{Xa=f[a+264>>2]|0;b[Wa>>0]=-70;b[Wa+1>>0]=7;Za=Wa+2|0;Wa=f[Xa+12>>2]|0;if(Wa>>>0>127){Ya=Wa;Ta=Za;while(1){b[Ta>>0]=Ya|128;Sa=Ya>>>7;Va=Ta+1|0;if(Ya>>>0>16383){Ya=Sa;Ta=Va}else{ab=Va;bb=Sa;break}}}else{ab=Za;bb=Wa}b[ab>>0]=bb;bb=li[f[(f[Xa>>2]|0)+68>>2]&511](Xa,0,ab+1|0)|0;_a=bb;$a=f[za>>2]|0}if(!($a&256)){cb=_a;db=$a}else{$a=f[a+268>>2]|0;b[_a>>0]=-62;b[_a+1>>0]=7;bb=_a+2|0;_a=f[$a+12>>2]|0;if(_a>>>0>127){ab=_a;Xa=bb;while(1){b[Xa>>0]=ab|128;Wa=ab>>>7;Za=Xa+1|0;if(ab>>>0>16383){ab=Wa;Xa=Za}else{eb=Za;fb=Wa;break}}}else{eb=bb;fb=_a}b[eb>>0]=fb;fb=li[f[(f[$a>>2]|0)+68>>2]&511]($a,0,eb+1|0)|0;cb=fb;db=f[za>>2]|0}if(!(db&4096)){gb=cb;hb=db}else{db=f[a+284>>2]|0;b[cb>>0]=-54;b[cb+1>>0]=7;fb=cb+2|0;cb=f[db+12>>2]|0;if(cb>>>0>127){eb=cb;$a=fb;while(1){b[$a>>0]=eb|128;_a=eb>>>7;bb=$a+1|0;if(eb>>>0>16383){eb=_a;$a=bb}else{ib=bb;jb=_a;break}}}else{ib=fb;jb=cb}b[ib>>0]=jb;jb=li[f[(f[db>>2]|0)+68>>2]&511](db,0,ib+1|0)|0;gb=jb;hb=f[za>>2]|0}if(!(hb&8192)){kb=gb;lb=hb}else{hb=f[a+288>>2]|0;b[gb>>0]=-46;b[gb+1>>0]=7;jb=gb+2|0;gb=f[hb+12>>2]|0;if(gb>>>0>127){ib=gb;db=jb;while(1){b[db>>0]=ib|128;cb=ib>>>7;fb=db+1|0;if(ib>>>0>16383){ib=cb;db=fb}else{mb=fb;nb=cb;break}}}else{mb=jb;nb=gb}b[mb>>0]=nb;nb=li[f[(f[hb>>2]|0)+68>>2]&511](hb,0,mb+1|0)|0;kb=nb;lb=f[za>>2]|0}if(!(lb&2097152)){ob=kb;pb=lb}else{lb=f[a+320>>2]|0;b[kb>>0]=-38;b[kb+1>>0]=7;nb=kb+2|0;kb=f[lb+12>>2]|0;if(kb>>>0>127){mb=kb;hb=nb;while(1){b[hb>>0]=mb|128;gb=mb>>>7;jb=hb+1|0;if(mb>>>0>16383){mb=gb;hb=jb}else{qb=jb;rb=gb;break}}}else{qb=nb;rb=kb}b[qb>>0]=rb;rb=li[f[(f[lb>>2]|0)+68>>2]&511](lb,0,qb+1|0)|0;ob=rb;pb=f[za>>2]|0}if(!(pb&33554432)){sb=ob;tb=pb}else{pb=f[a+336>>2]|0;b[ob>>0]=-30;b[ob+1>>0]=7;rb=ob+2|0;ob=f[pb+12>>2]|0;if(ob>>>0>127){qb=ob;lb=rb;while(1){b[lb>>0]=qb|128;kb=qb>>>7;nb=lb+1|0;if(qb>>>0>16383){qb=kb;lb=nb}else{ub=nb;vb=kb;break}}}else{ub=rb;vb=ob}b[ub>>0]=vb;vb=li[f[(f[pb>>2]|0)+68>>2]&511](pb,0,ub+1|0)|0;sb=vb;tb=f[za>>2]|0}if(!(tb&67108864)){wb=sb;xb=tb}else{tb=f[a+340>>2]|0;b[sb>>0]=-22;b[sb+1>>0]=7;vb=sb+2|0;sb=f[tb+12>>2]|0;if(sb>>>0>127){ub=sb;pb=vb;while(1){b[pb>>0]=ub|128;ob=ub>>>7;rb=pb+1|0;if(ub>>>0>16383){ub=ob;pb=rb}else{yb=rb;zb=ob;break}}}else{yb=vb;zb=sb}b[yb>>0]=zb;zb=li[f[(f[tb>>2]|0)+68>>2]&511](tb,0,yb+1|0)|0;wb=zb;xb=f[za>>2]|0}if(!(xb&268435456)){Ab=wb;Bb=xb}else{xb=f[a+348>>2]|0;b[wb>>0]=-14;b[wb+1>>0]=7;zb=wb+2|0;wb=f[xb+12>>2]|0;if(wb>>>0>127){yb=wb;tb=zb;while(1){b[tb>>0]=yb|128;sb=yb>>>7;vb=tb+1|0;if(yb>>>0>16383){yb=sb;tb=vb}else{Cb=vb;Db=sb;break}}}else{Cb=zb;Db=wb}b[Cb>>0]=Db;Db=li[f[(f[xb>>2]|0)+68>>2]&511](xb,0,Cb+1|0)|0;Ab=Db;Bb=f[za>>2]|0}if(!(Bb&536870912)){Eb=Ab;Fb=Bb}else{Bb=f[a+352>>2]|0;b[Ab>>0]=-6;b[Ab+1>>0]=7;Db=Ab+2|0;Ab=f[Bb+12>>2]|0;if(Ab>>>0>127){Cb=Ab;xb=Db;while(1){b[xb>>0]=Cb|128;wb=Cb>>>7;zb=xb+1|0;if(Cb>>>0>16383){Cb=wb;xb=zb}else{Gb=zb;Hb=wb;break}}}else{Gb=Db;Hb=Ab}b[Gb>>0]=Hb;Hb=li[f[(f[Bb>>2]|0)+68>>2]&511](Bb,0,Gb+1|0)|0;Eb=Hb;Fb=f[za>>2]|0}if(!(Fb&1073741824))Ib=Eb;else{Fb=f[a+356>>2]|0;b[Eb>>0]=-126;b[Eb+1>>0]=8;Hb=Eb+2|0;Eb=f[Fb+12>>2]|0;if(Eb>>>0>127){Gb=Eb;Bb=Hb;while(1){b[Bb>>0]=Gb|128;Ab=Gb>>>7;Db=Bb+1|0;if(Gb>>>0>16383){Gb=Ab;Bb=Db}else{Jb=Db;Kb=Ab;break}}}else{Jb=Hb;Kb=Eb}b[Jb>>0]=Kb;Ib=li[f[(f[Fb>>2]|0)+68>>2]&511](Fb,0,Jb+1|0)|0}if(!(f[a+16>>2]&1))Lb=Ib;else{Jb=f[a+364>>2]|0;b[Ib>>0]=-118;b[Ib+1>>0]=8;Fb=Ib+2|0;Ib=f[Jb+12>>2]|0;if(Ib>>>0>127){Kb=Ib;Eb=Fb;while(1){b[Eb>>0]=Kb|128;Hb=Kb>>>7;Bb=Eb+1|0;if(Kb>>>0>16383){Kb=Hb;Eb=Bb}else{Mb=Bb;Nb=Hb;break}}}else{Mb=Fb;Nb=Ib}b[Mb>>0]=Nb;Lb=li[f[(f[Jb>>2]|0)+68>>2]&511](Jb,0,Mb+1|0)|0}Mb=f[za>>2]|0;if(!(Mb&262144)){Ob=Lb;Pb=Mb}else{Mb=f[a+308>>2]|0;b[Lb>>0]=-110;b[Lb+1>>0]=8;Jb=Lb+2|0;Lb=f[Mb+12>>2]|0;if(Lb>>>0>127){Nb=Lb;Ib=Jb;while(1){b[Ib>>0]=Nb|128;Fb=Nb>>>7;Eb=Ib+1|0;if(Nb>>>0>16383){Nb=Fb;Ib=Eb}else{Qb=Eb;Rb=Fb;break}}}else{Qb=Jb;Rb=Lb}b[Qb>>0]=Rb;Rb=li[f[(f[Mb>>2]|0)+68>>2]&511](Mb,0,Qb+1|0)|0;Ob=Rb;Pb=f[za>>2]|0}if(!(Pb&16384)){Sb=Ob;Tb=Pb}else{Pb=f[a+292>>2]|0;b[Ob>>0]=-102;b[Ob+1>>0]=8;Rb=Ob+2|0;Ob=f[Pb+12>>2]|0;if(Ob>>>0>127){Qb=Ob;Mb=Rb;while(1){b[Mb>>0]=Qb|128;Lb=Qb>>>7;Jb=Mb+1|0;if(Qb>>>0>16383){Qb=Lb;Mb=Jb}else{Ub=Jb;Vb=Lb;break}}}else{Ub=Rb;Vb=Ob}b[Ub>>0]=Vb;Vb=li[f[(f[Pb>>2]|0)+68>>2]&511](Pb,0,Ub+1|0)|0;Sb=Vb;Tb=f[za>>2]|0}if(!(Tb&134217728)){Wb=Sb;Xb=Tb}else{Tb=f[a+344>>2]|0;b[Sb>>0]=-94;b[Sb+1>>0]=8;Vb=Sb+2|0;Sb=f[Tb+12>>2]|0;if(Sb>>>0>127){Ub=Sb;Pb=Vb;while(1){b[Pb>>0]=Ub|128;Ob=Ub>>>7;Rb=Pb+1|0;if(Ub>>>0>16383){Ub=Ob;Pb=Rb}else{Yb=Rb;Zb=Ob;break}}}else{Yb=Vb;Zb=Sb}b[Yb>>0]=Zb;Zb=li[f[(f[Tb>>2]|0)+68>>2]&511](Tb,0,Yb+1|0)|0;Wb=Zb;Xb=f[za>>2]|0}if(!(Xb&4194304)){_b=Wb;$b=Xb}else{Xb=f[a+324>>2]|0;b[Wb>>0]=-86;b[Wb+1>>0]=8;Zb=Wb+2|0;Wb=f[Xb+12>>2]|0;if(Wb>>>0>127){Yb=Wb;Tb=Zb;while(1){b[Tb>>0]=Yb|128;Sb=Yb>>>7;Vb=Tb+1|0;if(Yb>>>0>16383){Yb=Sb;Tb=Vb}else{ac=Vb;bc=Sb;break}}}else{ac=Zb;bc=Wb}b[ac>>0]=bc;bc=li[f[(f[Xb>>2]|0)+68>>2]&511](Xb,0,ac+1|0)|0;_b=bc;$b=f[za>>2]|0}if(!($b&32))cc=_b;else{$b=f[a+256>>2]|0;b[_b>>0]=-78;b[_b+1>>0]=8;bc=_b+2|0;_b=f[$b+12>>2]|0;if(_b>>>0>127){ac=_b;Xb=bc;while(1){b[Xb>>0]=ac|128;Wb=ac>>>7;Zb=Xb+1|0;if(ac>>>0>16383){ac=Wb;Xb=Zb}else{dc=Zb;ec=Wb;break}}}else{dc=bc;ec=_b}b[dc>>0]=ec;cc=li[f[(f[$b>>2]|0)+68>>2]&511]($b,0,dc+1|0)|0}if(!(f[c>>2]&536870912))fc=cc;else{dc=f[a+224>>2]|0;b[cc>>0]=-70;b[cc+1>>0]=8;$b=cc+2|0;cc=f[dc+12>>2]|0;if(cc>>>0>127){ec=cc;_b=$b;while(1){b[_b>>0]=ec|128;bc=ec>>>7;Xb=_b+1|0;if(ec>>>0>16383){ec=bc;_b=Xb}else{gc=Xb;hc=bc;break}}}else{gc=$b;hc=cc}b[gc>>0]=hc;fc=li[f[(f[dc>>2]|0)+68>>2]&511](dc,0,gc+1|0)|0}if(!(f[za>>2]&1048576))ic=fc;else{gc=f[a+316>>2]|0;b[fc>>0]=-62;b[fc+1>>0]=8;dc=fc+2|0;fc=f[gc+12>>2]|0;if(fc>>>0>127){hc=fc;cc=dc;while(1){b[cc>>0]=hc|128;$b=hc>>>7;_b=cc+1|0;if(hc>>>0>16383){hc=$b;cc=_b}else{jc=_b;kc=$b;break}}}else{jc=dc;kc=fc}b[jc>>0]=kc;ic=li[f[(f[gc>>2]|0)+68>>2]&511](gc,0,jc+1|0)|0}if(!(f[c>>2]&134217728))lc=ic;else{jc=f[a+216>>2]|0;b[ic>>0]=-54;b[ic+1>>0]=8;gc=ic+2|0;ic=f[jc+12>>2]|0;if(ic>>>0>127){kc=ic;fc=gc;while(1){b[fc>>0]=kc|128;dc=kc>>>7;cc=fc+1|0;if(kc>>>0>16383){kc=dc;fc=cc}else{mc=cc;nc=dc;break}}}else{mc=gc;nc=ic}b[mc>>0]=nc;lc=li[f[(f[jc>>2]|0)+68>>2]&511](jc,0,mc+1|0)|0}if((f[za>>2]|0)<0){mc=f[a+360>>2]|0;b[lc>>0]=-46;b[lc+1>>0]=8;jc=lc+2|0;nc=f[mc+12>>2]|0;if(nc>>>0>127){ic=nc;gc=jc;while(1){b[gc>>0]=ic|128;fc=ic>>>7;kc=gc+1|0;if(ic>>>0>16383){ic=fc;gc=kc}else{oc=kc;pc=fc;break}}}else{oc=jc;pc=nc}b[oc>>0]=pc;qc=li[f[(f[mc>>2]|0)+68>>2]&511](mc,0,oc+1|0)|0}else qc=lc;lc=f[c>>2]|0;if(!(lc&32768)){rc=qc;sc=lc}else{lc=f[a+168>>2]|0;b[qc>>0]=-38;b[qc+1>>0]=8;oc=qc+2|0;qc=f[lc+12>>2]|0;if(qc>>>0>127){mc=qc;pc=oc;while(1){b[pc>>0]=mc|128;nc=mc>>>7;jc=pc+1|0;if(mc>>>0>16383){mc=nc;pc=jc}else{tc=jc;uc=nc;break}}}else{tc=oc;uc=qc}b[tc>>0]=uc;uc=li[f[(f[lc>>2]|0)+68>>2]&511](lc,0,tc+1|0)|0;rc=uc;sc=f[c>>2]|0}if(!(sc&67108864)){vc=rc;wc=sc}else{sc=f[a+212>>2]|0;b[rc>>0]=-30;b[rc+1>>0]=8;uc=rc+2|0;rc=f[sc+12>>2]|0;if(rc>>>0>127){tc=rc;lc=uc;while(1){b[lc>>0]=tc|128;qc=tc>>>7;oc=lc+1|0;if(tc>>>0>16383){tc=qc;lc=oc}else{xc=oc;yc=qc;break}}}else{xc=uc;yc=rc}b[xc>>0]=yc;yc=li[f[(f[sc>>2]|0)+68>>2]&511](sc,0,xc+1|0)|0;vc=yc;wc=f[c>>2]|0}if(!(wc&65536))zc=vc;else{wc=f[a+172>>2]|0;b[vc>>0]=-22;b[vc+1>>0]=8;yc=vc+2|0;vc=f[wc+12>>2]|0;if(vc>>>0>127){xc=vc;sc=yc;while(1){b[sc>>0]=xc|128;rc=xc>>>7;uc=sc+1|0;if(xc>>>0>16383){xc=rc;sc=uc}else{Ac=uc;Bc=rc;break}}}else{Ac=yc;Bc=vc}b[Ac>>0]=Bc;zc=li[f[(f[wc>>2]|0)+68>>2]&511](wc,0,Ac+1|0)|0}Ac=f[za>>2]|0;if(!(Ac&16777216)){Cc=zc;Dc=Ac}else{Ac=f[a+332>>2]|0;b[zc>>0]=-14;b[zc+1>>0]=8;wc=zc+2|0;zc=f[Ac+12>>2]|0;if(zc>>>0>127){Bc=zc;vc=wc;while(1){b[vc>>0]=Bc|128;yc=Bc>>>7;sc=vc+1|0;if(Bc>>>0>16383){Bc=yc;vc=sc}else{Ec=sc;Fc=yc;break}}}else{Ec=wc;Fc=zc}b[Ec>>0]=Fc;Fc=li[f[(f[Ac>>2]|0)+68>>2]&511](Ac,0,Ec+1|0)|0;Cc=Fc;Dc=f[za>>2]|0}if(!(Dc&16))Gc=Cc;else{Dc=f[a+252>>2]|0;b[Cc>>0]=-6;b[Cc+1>>0]=8;Fc=Cc+2|0;Cc=f[Dc+12>>2]|0;if(Cc>>>0>127){Ec=Cc;Ac=Fc;while(1){b[Ac>>0]=Ec|128;zc=Ec>>>7;wc=Ac+1|0;if(Ec>>>0>16383){Ec=zc;Ac=wc}else{Hc=wc;Ic=zc;break}}}else{Hc=Fc;Ic=Cc}b[Hc>>0]=Ic;Gc=li[f[(f[Dc>>2]|0)+68>>2]&511](Dc,0,Hc+1|0)|0}if(!(f[c>>2]&1048576))Jc=Gc;else{Hc=f[a+188>>2]|0;b[Gc>>0]=-126;b[Gc+1>>0]=9;Dc=Gc+2|0;Gc=f[Hc+12>>2]|0;if(Gc>>>0>127){Ic=Gc;Cc=Dc;while(1){b[Cc>>0]=Ic|128;Fc=Ic>>>7;Ac=Cc+1|0;if(Ic>>>0>16383){Ic=Fc;Cc=Ac}else{Kc=Ac;Lc=Fc;break}}}else{Kc=Dc;Lc=Gc}b[Kc>>0]=Lc;Jc=li[f[(f[Hc>>2]|0)+68>>2]&511](Hc,0,Kc+1|0)|0}Kc=f[za>>2]|0;if(!(Kc&2048)){Mc=Jc;Nc=Kc}else{Kc=f[a+280>>2]|0;b[Jc>>0]=-118;b[Jc+1>>0]=9;Hc=Jc+2|0;Jc=f[Kc+12>>2]|0;if(Jc>>>0>127){Lc=Jc;Gc=Hc;while(1){b[Gc>>0]=Lc|128;Dc=Lc>>>7;Cc=Gc+1|0;if(Lc>>>0>16383){Lc=Dc;Gc=Cc}else{Oc=Cc;Pc=Dc;break}}}else{Oc=Hc;Pc=Jc}b[Oc>>0]=Pc;Pc=li[f[(f[Kc>>2]|0)+68>>2]&511](Kc,0,Oc+1|0)|0;Mc=Pc;Nc=f[za>>2]|0}if(!(Nc&524288))Qc=Mc;else{Nc=f[a+312>>2]|0;b[Mc>>0]=-110;b[Mc+1>>0]=9;Pc=Mc+2|0;Mc=f[Nc+12>>2]|0;if(Mc>>>0>127){Oc=Mc;Kc=Pc;while(1){b[Kc>>0]=Oc|128;Jc=Oc>>>7;Hc=Kc+1|0;if(Oc>>>0>16383){Oc=Jc;Kc=Hc}else{Rc=Hc;Sc=Jc;break}}}else{Rc=Pc;Sc=Mc}b[Rc>>0]=Sc;Qc=li[f[(f[Nc>>2]|0)+68>>2]&511](Nc,0,Rc+1|0)|0}if(!(f[c>>2]&4194304))Tc=Qc;else{c=f[a+196>>2]|0;b[Qc>>0]=-102;b[Qc+1>>0]=9;Rc=Qc+2|0;Qc=f[c+12>>2]|0;if(Qc>>>0>127){Nc=Qc;Sc=Rc;while(1){b[Sc>>0]=Nc|128;Mc=Nc>>>7;Pc=Sc+1|0;if(Nc>>>0>16383){Nc=Mc;Sc=Pc}else{Uc=Pc;Vc=Mc;break}}}else{Uc=Rc;Vc=Qc}b[Uc>>0]=Vc;Tc=li[f[(f[c>>2]|0)+68>>2]&511](c,0,Uc+1|0)|0}Uc=f[za>>2]|0;if(!(Uc&1024)){Wc=Tc;Xc=Uc}else{Uc=f[a+276>>2]|0;b[Tc>>0]=-94;b[Tc+1>>0]=9;c=Tc+2|0;Tc=f[Uc+12>>2]|0;if(Tc>>>0>127){Vc=Tc;Qc=c;while(1){b[Qc>>0]=Vc|128;Rc=Vc>>>7;Sc=Qc+1|0;if(Vc>>>0>16383){Vc=Rc;Qc=Sc}else{Yc=Sc;Zc=Rc;break}}}else{Yc=c;Zc=Tc}b[Yc>>0]=Zc;Zc=li[f[(f[Uc>>2]|0)+68>>2]&511](Uc,0,Yc+1|0)|0;Wc=Zc;Xc=f[za>>2]|0}if(!(Xc&512)){_c=Wc;$c=Xc}else{Xc=f[a+272>>2]|0;b[Wc>>0]=-86;b[Wc+1>>0]=9;Zc=Wc+2|0;Wc=f[Xc+12>>2]|0;if(Wc>>>0>127){Yc=Wc;Uc=Zc;while(1){b[Uc>>0]=Yc|128;Tc=Yc>>>7;c=Uc+1|0;if(Yc>>>0>16383){Yc=Tc;Uc=c}else{ad=c;bd=Tc;break}}}else{ad=Zc;bd=Wc}b[ad>>0]=bd;bd=li[f[(f[Xc>>2]|0)+68>>2]&511](Xc,0,ad+1|0)|0;_c=bd;$c=f[za>>2]|0}if(!($c&32768)){cd=_c;dd=$c}else{$c=f[a+296>>2]|0;b[_c>>0]=-78;b[_c+1>>0]=9;bd=_c+2|0;_c=f[$c+12>>2]|0;if(_c>>>0>127){ad=_c;Xc=bd;while(1){b[Xc>>0]=ad|128;Wc=ad>>>7;Zc=Xc+1|0;if(ad>>>0>16383){ad=Wc;Xc=Zc}else{ed=Zc;fd=Wc;break}}}else{ed=bd;fd=_c}b[ed>>0]=fd;fd=li[f[(f[$c>>2]|0)+68>>2]&511]($c,0,ed+1|0)|0;cd=fd;dd=f[za>>2]|0}if(!(dd&65536)){gd=cd;hd=dd}else{dd=f[a+300>>2]|0;b[cd>>0]=-54;b[cd+1>>0]=12;fd=cd+2|0;cd=f[dd+12>>2]|0;if(cd>>>0>127){ed=cd;$c=fd;while(1){b[$c>>0]=ed|128;_c=ed>>>7;bd=$c+1|0;if(ed>>>0>16383){ed=_c;$c=bd}else{id=bd;jd=_c;break}}}else{id=fd;jd=cd}b[id>>0]=jd;jd=li[f[(f[dd>>2]|0)+68>>2]&511](dd,0,id+1|0)|0;gd=jd;hd=f[za>>2]|0}if(!(hd&131072)){kd=gd;ld=hd}else{hd=f[a+304>>2]|0;b[gd>>0]=-118;b[gd+1>>0]=-15;b[gd+2>>0]=4;jd=gd+3|0;gd=f[hd+12>>2]|0;if(gd>>>0>127){id=gd;dd=jd;while(1){b[dd>>0]=id|128;cd=id>>>7;fd=dd+1|0;if(id>>>0>16383){id=cd;dd=fd}else{md=fd;nd=cd;break}}}else{md=jd;nd=gd}b[md>>0]=nd;nd=li[f[(f[hd>>2]|0)+68>>2]&511](hd,0,md+1|0)|0;kd=nd;ld=f[za>>2]|0}if(!(ld&8388608))od=kd;else{ld=f[a+328>>2]|0;b[kd>>0]=-70;b[kd+1>>0]=-67;b[kd+2>>0]=-60;b[kd+3>>0]=31;za=kd+4|0;kd=f[ld+12>>2]|0;if(kd>>>0>127){nd=kd;md=za;while(1){b[md>>0]=nd|128;hd=nd>>>7;gd=md+1|0;if(nd>>>0>16383){nd=hd;md=gd}else{pd=gd;qd=hd;break}}}else{pd=za;qd=kd}b[pd>>0]=qd;od=li[f[(f[ld>>2]|0)+68>>2]&511](ld,0,pd+1|0)|0}pd=f[a+4>>2]|0;if(!(pd&1)){rd=od;return rd|0}rd=bQb(pd&-2,od)|0;return rd|0}function E3a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function F3a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(18427);c=T6b(b,23288,19672,0)|0;if(!c){cOb(b,a);return}else{I3a(a,c);return}}function G3a(a,b){a=a|0;b=b|0;f[a+20>>2]=b;return}function H3a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213072];f[a+4>>2]=f[213073];u=c;return}function I3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0;d=u;u=u+16|0;e=d+12|0;g=d;h=d+8|0;i=d+4|0;UDa(a+24|0,c+24|0);UDa(a+40|0,c+40|0);j=a+56|0;k=c+56|0;l=f[k>>2]|0;if(l|0){qza(j,(f[j>>2]|0)+l|0);Vac((f[a+64>>2]|0)+4+(f[j>>2]<<2)|0,(f[c+64>>2]|0)+4|0,f[k>>2]<<2|0)|0;f[j>>2]=(f[j>>2]|0)+(f[k>>2]|0)}J3a(a+68|0,c+68|0);bOa(a+84|0,c+84|0);k=a+100|0;j=c+100|0;l=f[j>>2]|0;if(l|0){vFa(k,(f[k>>2]|0)+l|0);Vac((f[k>>2]|0)+((f[a+108>>2]|0)+4)|0,(f[c+108>>2]|0)+4|0,f[j>>2]|0)|0;f[k>>2]=(f[k>>2]|0)+(f[j>>2]|0)}DOa(a+112|0,c+112|0);DOa(a+128|0,c+128|0);j=c+8|0;k=f[j>>2]|0;if(k&255){if(!(k&1))m=k;else{l=a+8|0;f[l>>2]=f[l>>2]|1;f[h>>2]=f[c+144>>2];f[e>>2]=f[h>>2];Anb(a+144|0,497760,e);m=f[j>>2]|0}if(!(m&2))n=m;else{m=a+8|0;f[m>>2]=f[m>>2]|2;f[i>>2]=f[c+148>>2];f[e>>2]=f[i>>2];Anb(a+148|0,497760,e);n=f[j>>2]|0}if(!(n&16))o=n;else{n=f[c+368>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|16;f[a+368>>2]=n;o=f[j>>2]|0}}else o=k;if(o&522240|0){do if(o&2048){k=a+8|0;f[k>>2]=f[k>>2]|2048;k=a+152|0;n=f[k>>2]|0;if(!n){i=L5b(44)|0;pPa(i);f[k>>2]=i;p=i}else p=n;n=f[c+152>>2]|0;i=(n|0)==0?494552:n;if((i|0)==(p|0))jMa(22061);else{qPa(p,i);q=f[j>>2]|0;break}}else q=o;while(0);if(q&4096|0){q=a+8|0;f[q>>2]=f[q>>2]|4096;q=a+156|0;o=f[q>>2]|0;if(!o){p=L5b(28)|0;rPa(p);f[q>>2]=p;r=p}else r=o;o=f[c+156>>2]|0;p=(o|0)==0?494608:o;if((p|0)==(r|0))jMa(22665);o=p+8|0;q=f[o>>2]|0;if(q&255|0){if(!(q&1))s=q;else{q=f[p+16>>2]|0;i=r+8|0;f[i>>2]=f[i>>2]|1;f[r+16>>2]=q;s=f[o>>2]|0}if(!(s&2))t=s;else{s=f[p+24>>2]|0;q=r+8|0;f[q>>2]=f[q>>2]|2;f[r+24>>2]=s;t=f[o>>2]|0}if(t&4|0){t=b[p+20>>0]|0;o=r+8|0;f[o>>2]=f[o>>2]|4;b[r+20>>0]=t}}t=f[p+4>>2]|0;if(t&1|0)LPb(t&-2,r+4|0)}if(f[j>>2]&8192|0){r=a+8|0;f[r>>2]=f[r>>2]|8192;r=a+160|0;t=f[r>>2]|0;if(!t){p=L5b(28)|0;EOa(p);f[r>>2]=p;v=p}else v=t;t=f[c+160>>2]|0;p=(t|0)==0?494648:t;if((p|0)==(v|0))jMa(23075);t=p+8|0;r=f[t>>2]|0;if(r&255|0){if(!(r&1))w=r;else{r=f[p+20>>2]|0;o=v+8|0;f[o>>2]=f[o>>2]|1;f[v+20>>2]=r;w=f[t>>2]|0}if(!(w&2))x=w;else{w=f[p+24>>2]|0;r=v+8|0;f[r>>2]=f[r>>2]|2;f[v+24>>2]=w;x=f[t>>2]|0}if(x&4|0){x=f[p+16>>2]|0;t=v+8|0;f[t>>2]=f[t>>2]|4;f[v+16>>2]=x}}x=f[p+4>>2]|0;if(x&1|0)LPb(x&-2,v+4|0)}if(f[j>>2]&16384|0){v=a+8|0;f[v>>2]=f[v>>2]|16384;v=a+164|0;x=f[v>>2]|0;if(!x){p=L5b(28)|0;FOa(p);f[v>>2]=p;y=p}else y=x;x=f[c+164>>2]|0;p=(x|0)==0?494688:x;if((p|0)==(y|0))jMa(23501);x=p+8|0;v=f[x>>2]|0;if(v&255|0){if(!(v&1))z=v;else{v=b[p+16>>0]|0;t=y+8|0;f[t>>2]=f[t>>2]|1;b[y+16>>0]=v;z=f[x>>2]|0}if(!(z&2))A=z;else{z=f[p+24>>2]|0;v=y+8|0;f[v>>2]=f[v>>2]|2;f[y+24>>2]=z;A=f[x>>2]|0}if(A&4|0){A=f[p+20>>2]|0;x=y+8|0;f[x>>2]=f[x>>2]|4;f[y+20>>2]=A}}A=f[p+4>>2]|0;if(A&1|0)LPb(A&-2,y+4|0)}if(f[j>>2]&32768|0){y=a+8|0;f[y>>2]=f[y>>2]|32768;y=a+168|0;A=f[y>>2]|0;if(!A){p=L5b(28)|0;V1a(p);f[y>>2]=p;B=p}else B=A;A=f[c+168>>2]|0;p=(A|0)==0?494760:A;if((p|0)==(B|0))jMa(24250);A=p+8|0;y=f[A>>2]|0;if(y&255|0){if(!(y&1))C=y;else{y=b[p+16>>0]|0;x=B+8|0;f[x>>2]=f[x>>2]|1;b[B+16>>0]=y;C=f[A>>2]|0}if(!(C&2))D=C;else{C=f[p+20>>2]|0;y=B+8|0;f[y>>2]=f[y>>2]|2;f[B+20>>2]=C;D=f[A>>2]|0}if(D&4|0){D=f[p+24>>2]|0;A=B+8|0;f[A>>2]=f[A>>2]|4;f[B+24>>2]=D}}D=f[p+4>>2]|0;if(D&1|0)LPb(D&-2,B+4|0)}}B=f[j>>2]|0;if(!(B&16711680))E=B;else{do if(B&65536){D=a+8|0;f[D>>2]=f[D>>2]|65536;D=a+172|0;p=f[D>>2]|0;if(!p){A=L5b(28)|0;D1a(A);f[D>>2]=A;F=A}else F=p;p=f[c+172>>2]|0;A=(p|0)==0?494800:p;if((A|0)==(F|0))jMa(24667);else{C1a(F,A);G=f[j>>2]|0;break}}else G=B;while(0);if(G&131072|0){G=a+8|0;f[G>>2]=f[G>>2]|131072;G=a+176|0;B=f[G>>2]|0;if(!B){F=L5b(24)|0;GOa(F);f[G>>2]=F;H=F}else H=B;B=f[c+176>>2]|0;F=(B|0)==0?494728:B;if((F|0)==(H|0))jMa(23875);B=F+8|0;G=f[B>>2]|0;if(G&255|0){if(!(G&1))I=G;else{G=f[F+16>>2]|0;A=H+8|0;f[A>>2]=f[A>>2]|1;f[H+16>>2]=G;I=f[B>>2]|0}if(I&2|0){I=f[F+20>>2]|0;B=H+8|0;f[B>>2]=f[B>>2]|2;f[H+20>>2]=I}}I=f[F+4>>2]|0;if(I&1|0)LPb(I&-2,H+4|0)}if(f[j>>2]&262144|0){H=a+8|0;f[H>>2]=f[H>>2]|262144;H=a+180|0;I=f[H>>2]|0;if(!I){F=L5b(24)|0;HOa(F);f[H>>2]=F;J=F}else J=I;I=f[c+180>>2]|0;F=(I|0)==0?494840:I;if((F|0)==(J|0))jMa(25058);I=F+8|0;H=f[I>>2]|0;if(H&255|0){if(!(H&1))K=H;else{H=f[F+20>>2]|0;B=J+8|0;f[B>>2]=f[B>>2]|1;f[J+20>>2]=H;K=f[I>>2]|0}if(K&2|0){K=b[F+16>>0]|0;I=J+8|0;f[I>>2]=f[I>>2]|2;b[J+16>>0]=K}}K=f[F+4>>2]|0;if(K&1|0)LPb(K&-2,J+4|0)}J=f[j>>2]|0;do if(J&524288){K=a+8|0;f[K>>2]=f[K>>2]|524288;K=a+184|0;F=f[K>>2]|0;if(!F){I=L5b(120)|0;IOa(I);f[K>>2]=I;L=I}else L=F;F=f[c+184>>2]|0;I=(F|0)==0?494872:F;if((I|0)==(L|0))jMa(26062);else{JOa(L,I);M=f[j>>2]|0;break}}else M=J;while(0);if(M&1048576|0){M=a+8|0;f[M>>2]=f[M>>2]|1048576;M=a+188|0;J=f[M>>2]|0;if(!J){L=L5b(32)|0;I0a(L);f[M>>2]=L;N=L}else N=J;J=f[c+188>>2]|0;L=(J|0)==0?495e3:J;if((L|0)==(N|0))jMa(26926);J=N+16|0;M=L+16|0;I=f[M>>2]|0;if(I|0){rza(J,(f[J>>2]|0)+I|0);Vac((f[N+24>>2]|0)+4+(f[J>>2]<<2)|0,(f[L+24>>2]|0)+4|0,f[M>>2]<<2|0)|0;f[J>>2]=(f[J>>2]|0)+(f[M>>2]|0)}if(f[L+8>>2]&1|0){M=f[L+28>>2]|0;J=N+8|0;f[J>>2]=f[J>>2]|1;f[N+28>>2]=M}M=f[L+4>>2]|0;if(M&1|0)LPb(M&-2,N+4|0)}N=f[j>>2]|0;do if(N&2097152){M=a+8|0;f[M>>2]=f[M>>2]|2097152;M=a+192|0;L=f[M>>2]|0;if(!L){J=L5b(52)|0;KOa(J);f[M>>2]=J;O=J}else O=L;L=f[c+192>>2]|0;J=(L|0)==0?495040:L;if((J|0)==(O|0))jMa(27625);else{LOa(O,J);P=f[j>>2]|0;break}}else P=N;while(0);do if(P&4194304){N=a+8|0;f[N>>2]=f[N>>2]|4194304;N=a+196|0;O=f[N>>2]|0;if(!O){J=L5b(52)|0;K3a(J);f[N>>2]=J;Q=J}else Q=O;O=f[c+196>>2]|0;J=(O|0)==0?493416:O;if((J|0)==(Q|0))jMa(7168);else{L3a(Q,J);R=f[j>>2]|0;break}}else R=P;while(0);if(R&8388608|0){R=a+8|0;f[R>>2]=f[R>>2]|8388608;R=a+200|0;P=f[R>>2]|0;if(!P){Q=L5b(24)|0;MOa(Q);f[R>>2]=Q;S=Q}else S=P;P=f[c+200>>2]|0;Q=(P|0)==0?495192:P;if((Q|0)==(S|0))jMa(29494);P=Q+8|0;R=f[P>>2]|0;do if(R&255|0){if(!(R&1))T=R;else{J=f[Q+16>>2]|0;O=S+8|0;f[O>>2]=f[O>>2]|1;f[S+16>>2]=J;T=f[P>>2]|0}if(!(T&2))break;J=b[Q+20>>0]|0;O=S+8|0;f[O>>2]=f[O>>2]|2;b[S+20>>0]=J}while(0);T=f[Q+4>>2]|0;if(T&1|0)LPb(T&-2,S+4|0)}E=f[j>>2]|0}if(E>>>0>16777215){do if(E&16777216){S=a+8|0;f[S>>2]=f[S>>2]|16777216;S=a+204|0;T=f[S>>2]|0;if(!T){Q=L5b(96)|0;NOa(Q);f[S>>2]=Q;U=Q}else U=T;T=f[c+204>>2]|0;Q=(T|0)==0?495224:T;if((Q|0)==(U|0))jMa(30036);else{OOa(U,Q);V=f[j>>2]|0;break}}else V=E;while(0);do if(V&33554432){E=a+8|0;f[E>>2]=f[E>>2]|33554432;E=a+208|0;U=f[E>>2]|0;if(!U){Q=L5b(36)|0;POa(Q);f[E>>2]=Q;W=Q}else W=U;U=f[c+208>>2]|0;Q=(U|0)==0?495328:U;if((Q|0)==(W|0))jMa(30586);else{QOa(W,Q);X=f[j>>2]|0;break}}else X=V;while(0);if(X&67108864|0){X=a+8|0;f[X>>2]=f[X>>2]|67108864;X=a+212|0;V=f[X>>2]|0;if(!V){W=L5b(20)|0;z_a(W);f[X>>2]=W;Y=W}else Y=V;V=f[c+212>>2]|0;W=(V|0)==0?495376:V;if((W|0)==(Y|0))jMa(30924);if(f[W+8>>2]&1|0){V=f[W+16>>2]|0;X=Y+8|0;f[X>>2]=f[X>>2]|1;f[Y+16>>2]=V}V=f[W+4>>2]|0;if(V&1|0)LPb(V&-2,Y+4|0)}Y=f[j>>2]|0;do if(Y&134217728){V=a+8|0;f[V>>2]=f[V>>2]|134217728;V=a+216|0;W=f[V>>2]|0;if(!W){X=L5b(36)|0;h_a(X);f[V>>2]=X;Z=X}else Z=W;W=f[c+216>>2]|0;X=(W|0)==0?495408:W;if((X|0)==(Z|0))jMa(31378);else{g_a(Z,X);_=f[j>>2]|0;break}}else _=Y;while(0);if(_&268435456|0){_=a+8|0;f[_>>2]=f[_>>2]|268435456;_=a+220|0;Y=f[_>>2]|0;if(!Y){Z=L5b(28)|0;ROa(Z);f[_>>2]=Z;$=Z}else $=Y;Y=f[c+220>>2]|0;Z=(Y|0)==0?495456:Y;if((Z|0)==($|0))jMa(31879);Y=Z+8|0;_=f[Y>>2]|0;if(_&255|0){if(!(_&1))aa=_;else{_=f[Z+20>>2]|0;X=$+8|0;f[X>>2]=f[X>>2]|1;f[$+20>>2]=_;aa=f[Y>>2]|0}if(!(aa&2))ba=aa;else{aa=f[Z+24>>2]|0;_=$+8|0;f[_>>2]=f[_>>2]|2;f[$+24>>2]=aa;ba=f[Y>>2]|0}if(ba&4|0){ba=f[Z+16>>2]|0;Y=$+8|0;f[Y>>2]=f[Y>>2]|4;f[$+16>>2]=ba}}ba=f[Z+4>>2]|0;if(ba&1|0)LPb(ba&-2,$+4|0)}if(f[j>>2]&536870912|0){$=a+8|0;f[$>>2]=f[$>>2]|536870912;$=a+224|0;ba=f[$>>2]|0;if(!ba){Z=L5b(24)|0;AZa(Z);f[$>>2]=Z;ca=Z}else ca=ba;ba=f[c+224>>2]|0;Z=(ba|0)==0?495496:ba;if((Z|0)==(ca|0))jMa(32253);ba=Z+8|0;$=f[ba>>2]|0;if($&255|0){if(!($&1))da=$;else{$=f[Z+16>>2]|0;Y=ca+8|0;f[Y>>2]=f[Y>>2]|1;f[ca+16>>2]=$;da=f[ba>>2]|0}if(da&2|0){da=f[Z+20>>2]|0;ba=ca+8|0;f[ba>>2]=f[ba>>2]|2;f[ca+20>>2]=da}}da=f[Z+4>>2]|0;if(da&1|0)LPb(da&-2,ca+4|0)}ca=f[j>>2]|0;if(!(ca&1073741824))ea=ca;else{ca=a+8|0;f[ca>>2]=f[ca>>2]|1073741824;ca=a+228|0;da=f[ca>>2]|0;if(!da){Z=L5b(28)|0;SOa(Z);f[ca>>2]=Z;fa=Z}else fa=da;da=f[c+228>>2]|0;TOa(fa,(da|0)==0?495528:da);ea=f[j>>2]|0}if((ea|0)<0){ea=a+8|0;f[ea>>2]=f[ea>>2]|-2147483648;ea=a+232|0;j=f[ea>>2]|0;if(!j){da=L5b(20)|0;cOa(da);f[ea>>2]=da;ga=da}else ga=j;j=f[c+232>>2]|0;da=(j|0)==0?495568:j;if((da|0)==(ga|0))jMa(33049);if(f[da+8>>2]&1|0){j=ga+8|0;f[j>>2]=f[j>>2]|1;f[g>>2]=f[da+16>>2];f[e>>2]=f[g>>2];Anb(ga+16|0,497760,e)}j=f[da+4>>2]|0;if(j&1|0)LPb(j&-2,ga+4|0)}}ga=c+12|0;j=f[ga>>2]|0;if(j&255){if(j&1|0){da=a+12|0;f[da>>2]=f[da>>2]|1;da=a+236|0;ea=f[da>>2]|0;if(!ea){fa=L5b(20)|0;UOa(fa);f[da>>2]=fa;ha=fa}else ha=ea;ea=f[c+236>>2]|0;fa=(ea|0)==0?495600:ea;if((fa|0)==(ha|0))jMa(33386);if(f[fa+8>>2]&1|0){ea=f[fa+16>>2]|0;da=ha+8|0;f[da>>2]=f[da>>2]|1;f[ha+16>>2]=ea}ea=f[fa+4>>2]|0;if(ea&1|0)LPb(ea&-2,ha+4|0)}ha=f[ga>>2]|0;do if(ha&2){ea=a+12|0;f[ea>>2]=f[ea>>2]|2;ea=a+240|0;fa=f[ea>>2]|0;if(!fa){da=L5b(60)|0;VOa(da);f[ea>>2]=da;ia=da}else ia=fa;fa=f[c+240>>2]|0;da=(fa|0)==0?495632:fa;if((da|0)==(ia|0))jMa(34111);else{WOa(ia,da);ja=f[ga>>2]|0;break}}else ja=ha;while(0);if(!(ja&4))ka=ja;else{ja=a+12|0;f[ja>>2]=f[ja>>2]|4;ja=a+244|0;ha=f[ja>>2]|0;if(!ha){ia=L5b(20)|0;XOa(ia);f[ja>>2]=ia;la=ia}else la=ha;ha=f[c+244>>2]|0;ia=(ha|0)==0?495704:ha;if((ia|0)==(la|0))jMa(34809);if(f[ia+8>>2]&1|0){ha=la+8|0;f[ha>>2]=f[ha>>2]|1;f[g>>2]=f[ia+16>>2];f[e>>2]=f[g>>2];Anb(la+16|0,497760,e)}e=f[ia+4>>2]|0;if(e&1|0)LPb(e&-2,la+4|0);ka=f[ga>>2]|0}do if(ka&8){la=a+12|0;f[la>>2]=f[la>>2]|8;la=a+248|0;e=f[la>>2]|0;if(!e){ia=L5b(36)|0;YOa(ia);f[la>>2]=ia;ma=ia}else ma=e;e=f[c+248>>2]|0;ia=(e|0)==0?495736:e;if((ia|0)==(ma|0))jMa(35327);else{ZOa(ma,ia);na=f[ga>>2]|0;break}}else na=ka;while(0);if(na&16|0){na=a+12|0;f[na>>2]=f[na>>2]|16;na=a+252|0;ka=f[na>>2]|0;if(!ka){ma=L5b(32)|0;yXa(ma);f[na>>2]=ma;oa=ma}else oa=ka;ka=f[c+252>>2]|0;ma=(ka|0)==0?495784:ka;if((ma|0)==(oa|0))jMa(35796);tPa(oa+16|0,ma+16|0);ka=f[ma+4>>2]|0;if(ka&1|0)LPb(ka&-2,oa+4|0)}if(f[ga>>2]&32|0){oa=a+12|0;f[oa>>2]=f[oa>>2]|32;oa=a+256|0;ka=f[oa>>2]|0;if(!ka){ma=L5b(28)|0;gXa(ma);f[oa>>2]=ma;pa=ma}else pa=ka;ka=f[c+256>>2]|0;ma=(ka|0)==0?495824:ka;if((ma|0)==(pa|0))jMa(36145);ka=ma+8|0;oa=f[ka>>2]|0;do if(oa&255|0){if(!(oa&1))qa=oa;else{na=f[ma+20>>2]|0;ia=pa+8|0;f[ia>>2]=f[ia>>2]|1;f[pa+20>>2]=na;qa=f[ka>>2]|0}if(!(qa&2))ra=qa;else{na=f[ma+24>>2]|0;ia=pa+8|0;f[ia>>2]=f[ia>>2]|2;f[pa+24>>2]=na;ra=f[ka>>2]|0}if(!(ra&4))break;na=f[ma+16>>2]|0;ia=pa+8|0;f[ia>>2]=f[ia>>2]|4;f[pa+16>>2]=na}while(0);ra=f[ma+4>>2]|0;if(ra&1|0)LPb(ra&-2,pa+4|0)}pa=f[ga>>2]|0;do if(pa&64){ra=a+12|0;f[ra>>2]=f[ra>>2]|64;ra=a+260|0;ma=f[ra>>2]|0;if(!ma){ka=L5b(40)|0;_Oa(ka);f[ra>>2]=ka;sa=ka}else sa=ma;ma=f[c+260>>2]|0;ka=(ma|0)==0?495864:ma;if((ka|0)==(sa|0))jMa(36728);else{$Oa(sa,ka);ta=f[ga>>2]|0;break}}else ta=pa;while(0);if(!(ta&128))ua=ta;else{ta=a+12|0;f[ta>>2]=f[ta>>2]|128;ta=a+264|0;pa=f[ta>>2]|0;if(!pa){sa=L5b(32)|0;aPa(sa);f[ta>>2]=sa;va=sa}else va=pa;pa=f[c+264>>2]|0;bPa(va,(pa|0)==0?495912:pa);ua=f[ga>>2]|0}}else ua=j;do if(ua&65280){if(ua&256|0){j=a+12|0;f[j>>2]=f[j>>2]|256;j=a+268|0;pa=f[j>>2]|0;if(!pa){va=L5b(24)|0;cPa(va);f[j>>2]=va;wa=va}else wa=pa;pa=f[c+268>>2]|0;va=(pa|0)==0?495952:pa;if((va|0)==(wa|0))jMa(37702);pa=va+8|0;j=f[pa>>2]|0;if(j&255|0){if(!(j&1))xa=j;else{j=b[va+17>>0]|0;sa=wa+8|0;f[sa>>2]=f[sa>>2]|1;b[wa+17>>0]=j;xa=f[pa>>2]|0}if(!(xa&2))ya=xa;else{j=b[va+16>>0]|0;sa=wa+8|0;f[sa>>2]=f[sa>>2]|2;b[wa+16>>0]=j;ya=f[pa>>2]|0}if(ya&4|0){pa=f[va+20>>2]|0;j=wa+8|0;f[j>>2]=f[j>>2]|4;f[wa+20>>2]=pa}}pa=f[va+4>>2]|0;if(pa&1|0)LPb(pa&-2,wa+4|0)}pa=f[ga>>2]|0;do if(pa&512){va=a+12|0;f[va>>2]=f[va>>2]|512;va=a+272|0;j=f[va>>2]|0;if(!j){sa=L5b(28)|0;M3a(sa);f[va>>2]=sa;za=sa}else za=j;j=f[c+272>>2]|0;sa=(j|0)==0?493240:j;if((sa|0)==(za|0))jMa(5051);else{N3a(za,sa);Aa=f[ga>>2]|0;break}}else Aa=pa;while(0);if(Aa&1024|0){pa=a+12|0;f[pa>>2]=f[pa>>2]|1024;pa=a+276|0;sa=f[pa>>2]|0;if(!sa){j=L5b(28)|0;O3a(j);f[pa>>2]=j;Ba=j}else Ba=sa;sa=f[c+276>>2]|0;j=(sa|0)==0?493200:sa;if((j|0)==(Ba|0))jMa(4659);sa=Ba+16|0;pa=j+16|0;va=f[pa>>2]|0;if(va|0){rza(sa,(f[sa>>2]|0)+va|0);Vac((f[Ba+24>>2]|0)+4+(f[sa>>2]<<2)|0,(f[j+24>>2]|0)+4|0,f[pa>>2]<<2|0)|0;f[sa>>2]=(f[sa>>2]|0)+(f[pa>>2]|0)}pa=f[j+4>>2]|0;if(pa&1|0)LPb(pa&-2,Ba+4|0)}pa=f[ga>>2]|0;do if(pa&2048){j=a+12|0;f[j>>2]=f[j>>2]|2048;j=a+280|0;sa=f[j>>2]|0;if(!sa){va=L5b(20)|0;YVa(va);f[j>>2]=va;Ca=va}else Ca=sa;sa=f[c+280>>2]|0;va=(sa|0)==0?495984:sa;if((va|0)==(Ca|0))jMa(38045);else{XVa(Ca,va);Da=f[ga>>2]|0;break}}else Da=pa;while(0);do if(Da&4096){pa=a+12|0;f[pa>>2]=f[pa>>2]|4096;pa=a+284|0;va=f[pa>>2]|0;if(!va){sa=L5b(68)|0;dPa(sa);f[pa>>2]=sa;Ea=sa}else Ea=va;va=f[c+284>>2]|0;sa=(va|0)==0?496016:va;if((sa|0)==(Ea|0))jMa(38829);else{ePa(Ea,sa);Fa=f[ga>>2]|0;break}}else Fa=Da;while(0);if(Fa&8192|0){sa=a+12|0;f[sa>>2]=f[sa>>2]|8192;sa=a+288|0;va=f[sa>>2]|0;if(!va){pa=L5b(28)|0;fPa(pa);f[sa>>2]=pa;Ga=pa}else Ga=va;va=f[c+288>>2]|0;pa=(va|0)==0?496096:va;if((pa|0)==(Ga|0))jMa(39516);va=pa+8|0;sa=f[va>>2]|0;do if(sa&255|0){if(!(sa&1))Ha=sa;else{j=f[pa+20>>2]|0;ta=Ga+8|0;f[ta>>2]=f[ta>>2]|1;f[Ga+20>>2]=j;Ha=f[va>>2]|0}if(!(Ha&2))Ia=Ha;else{j=f[pa+24>>2]|0;ta=Ga+8|0;f[ta>>2]=f[ta>>2]|2;f[Ga+24>>2]=j;Ia=f[va>>2]|0}if(!(Ia&4))break;j=f[pa+16>>2]|0;ta=Ga+8|0;f[ta>>2]=f[ta>>2]|4;f[Ga+16>>2]=j}while(0);va=f[pa+4>>2]|0;if(va&1|0)LPb(va&-2,Ga+4|0)}va=f[ga>>2]|0;do if(va&16384){sa=a+12|0;f[sa>>2]=f[sa>>2]|16384;sa=a+292|0;j=f[sa>>2]|0;if(!j){ta=L5b(24)|0;KNa(ta);f[sa>>2]=ta;Ja=ta}else Ja=j;j=f[c+292>>2]|0;ta=(j|0)==0?497208:j;if((ta|0)==(Ja|0))jMa(53927);else{FNa(Ja,ta);Ka=f[ga>>2]|0;break}}else Ka=va;while(0);if(Ka&32768){va=a+12|0;f[va>>2]=f[va>>2]|32768;va=a+296|0;pa=f[va>>2]|0;if(!pa){ta=L5b(128)|0;P3a(ta);f[va>>2]=ta;La=ta}else La=pa;pa=f[c+296>>2]|0;ta=(pa|0)==0?493280:pa;if((ta|0)==(La|0))jMa(6064);else{Q3a(La,ta);Ma=f[ga>>2]|0;break}}else Ma=Ka}else Ma=ua;while(0);if(!(Ma&16711680))Na=Ma;else{do if(Ma&65536){ua=a+12|0;f[ua>>2]=f[ua>>2]|65536;ua=a+300|0;Ka=f[ua>>2]|0;if(!Ka){La=L5b(64)|0;EMa(La);f[ua>>2]=La;Oa=La}else Oa=Ka;Ka=f[c+300>>2]|0;La=(Ka|0)==0?497336:Ka;if((La|0)==(Oa|0))jMa(55659);else{CMa(Oa,La);Pa=f[ga>>2]|0;break}}else Pa=Ma;while(0);if(Pa&131072|0){Pa=a+12|0;f[Pa>>2]=f[Pa>>2]|131072;Pa=a+304|0;Ma=f[Pa>>2]|0;if(!Ma){Oa=L5b(28)|0;kMa(Oa);f[Pa>>2]=Oa;Qa=Oa}else Qa=Ma;Ma=f[c+304>>2]|0;Oa=(Ma|0)==0?497408:Ma;if((Oa|0)==(Qa|0))jMa(56250);Ma=Oa+8|0;Pa=f[Ma>>2]|0;if(Pa&255|0){if(!(Pa&1))Ra=Pa;else{Pa=f[Oa+16>>2]|0;La=Qa+8|0;f[La>>2]=f[La>>2]|1;f[Qa+16>>2]=Pa;Ra=f[Ma>>2]|0}if(!(Ra&2))Sa=Ra;else{Ra=f[Oa+20>>2]|0;Pa=Qa+8|0;f[Pa>>2]=f[Pa>>2]|2;f[Qa+20>>2]=Ra;Sa=f[Ma>>2]|0}if(Sa&4|0){Sa=f[Oa+24>>2]|0;Ma=Qa+8|0;f[Ma>>2]=f[Ma>>2]|4;f[Qa+24>>2]=Sa}}Sa=f[Oa+4>>2]|0;if(Sa&1|0)LPb(Sa&-2,Qa+4|0)}Qa=f[ga>>2]|0;do if(Qa&262144){Sa=a+12|0;f[Sa>>2]=f[Sa>>2]|262144;Sa=a+308|0;Oa=f[Sa>>2]|0;if(!Oa){Ma=L5b(32)|0;$Ua(Ma);f[Sa>>2]=Ma;Ta=Ma}else Ta=Oa;Oa=f[c+308>>2]|0;Ma=(Oa|0)==0?496136:Oa;if((Ma|0)==(Ta|0))jMa(40006);else{_Ua(Ta,Ma);Ua=f[ga>>2]|0;break}}else Ua=Qa;while(0);do if(Ua&524288){Qa=a+12|0;f[Qa>>2]=f[Qa>>2]|524288;Qa=a+312|0;Ta=f[Qa>>2]|0;if(!Ta){Ma=L5b(32)|0;IUa(Ma);f[Qa>>2]=Ma;Va=Ma}else Va=Ta;Ta=f[c+312>>2]|0;Ma=(Ta|0)==0?496176:Ta;if((Ma|0)==(Va|0))jMa(40633);else{HUa(Va,Ma);Wa=f[ga>>2]|0;break}}else Wa=Ua;while(0);if(Wa&1048576|0){Wa=a+12|0;f[Wa>>2]=f[Wa>>2]|1048576;Wa=a+316|0;Ua=f[Wa>>2]|0;if(!Ua){Va=L5b(28)|0;pUa(Va);f[Wa>>2]=Va;Xa=Va}else Xa=Ua;Ua=f[c+316>>2]|0;Va=(Ua|0)==0?496216:Ua;if((Va|0)==(Xa|0))jMa(41169);Ua=Va+8|0;Wa=f[Ua>>2]|0;do if(Wa&255|0){if(!(Wa&1))Ya=Wa;else{Ma=f[Va+20>>2]|0;Ta=Xa+8|0;f[Ta>>2]=f[Ta>>2]|1;f[Xa+20>>2]=Ma;Ya=f[Ua>>2]|0}if(!(Ya&2))Za=Ya;else{Ma=f[Va+16>>2]|0;Ta=Xa+8|0;f[Ta>>2]=f[Ta>>2]|2;f[Xa+16>>2]=Ma;Za=f[Ua>>2]|0}if(!(Za&4))break;Ma=f[Va+24>>2]|0;Ta=Xa+8|0;f[Ta>>2]=f[Ta>>2]|4;f[Xa+24>>2]=Ma}while(0);Za=f[Va+4>>2]|0;if(Za&1|0)LPb(Za&-2,Xa+4|0)}do if(f[ga>>2]&2097152|0){Xa=a+12|0;f[Xa>>2]=f[Xa>>2]|2097152;Xa=a+320|0;Za=f[Xa>>2]|0;if(!Za){Va=L5b(24)|0;gPa(Va);f[Xa>>2]=Va;_a=Va}else _a=Za;Za=f[c+320>>2]|0;Va=(Za|0)==0?496256:Za;if((Va|0)==(_a|0))jMa(41588);Za=Va+8|0;Xa=f[Za>>2]|0;do if(Xa&255|0){if(!(Xa&1))$a=Xa;else{Ua=f[Va+16>>2]|0;Ya=_a+8|0;f[Ya>>2]=f[Ya>>2]|1;f[_a+16>>2]=Ua;$a=f[Za>>2]|0}if(!($a&2))break;Ua=f[Va+20>>2]|0;Ya=_a+8|0;f[Ya>>2]=f[Ya>>2]|2;f[_a+20>>2]=Ua}while(0);Za=f[Va+4>>2]|0;if(!(Za&1))break;LPb(Za&-2,_a+4|0)}while(0);_a=f[ga>>2]|0;do if(_a&4194304){$a=a+12|0;f[$a>>2]=f[$a>>2]|4194304;$a=a+324|0;Za=f[$a>>2]|0;if(!Za){Xa=L5b(28)|0;JTa(Xa);f[$a>>2]=Xa;ab=Xa}else ab=Za;Za=f[c+324>>2]|0;Xa=(Za|0)==0?496288:Za;if((Xa|0)==(ab|0))jMa(41978);else{ITa(ab,Xa);bb=f[ga>>2]|0;break}}else bb=_a;while(0);do if(bb&8388608|0){_a=a+12|0;f[_a>>2]=f[_a>>2]|8388608;_a=a+328|0;ab=f[_a>>2]|0;if(!ab){Xa=L5b(28)|0;WMa(Xa);f[_a>>2]=Xa;cb=Xa}else cb=ab;ab=f[c+328>>2]|0;Xa=(ab|0)==0?497296:ab;if((Xa|0)==(cb|0))jMa(55061);ab=Xa+8|0;_a=f[ab>>2]|0;do if(_a&255|0){if(!(_a&1))db=_a;else{Za=f[Xa+16>>2]|0;$a=cb+8|0;f[$a>>2]=f[$a>>2]|1;f[cb+16>>2]=Za;db=f[ab>>2]|0}if(!(db&2))eb=db;else{Za=f[Xa+20>>2]|0;$a=cb+8|0;f[$a>>2]=f[$a>>2]|2;f[cb+20>>2]=Za;eb=f[ab>>2]|0}if(!(eb&4))break;Za=f[Xa+24>>2]|0;$a=cb+8|0;f[$a>>2]=f[$a>>2]|4;f[cb+24>>2]=Za}while(0);ab=f[Xa+4>>2]|0;if(!(ab&1))break;LPb(ab&-2,cb+4|0)}while(0);Na=f[ga>>2]|0}do if(Na>>>0>16777215){do if(Na&16777216){cb=a+12|0;f[cb>>2]=f[cb>>2]|16777216;cb=a+332|0;eb=f[cb>>2]|0;if(!eb){db=L5b(36)|0;qTa(db);f[cb>>2]=db;fb=db}else fb=eb;eb=f[c+332>>2]|0;db=(eb|0)==0?496328:eb;if((db|0)==(fb|0))jMa(42490);else{pTa(fb,db);gb=f[ga>>2]|0;break}}else gb=Na;while(0);if(gb&33554432|0){Xa=a+12|0;f[Xa>>2]=f[Xa>>2]|33554432;Xa=a+336|0;db=f[Xa>>2]|0;if(!db){eb=L5b(20)|0;hPa(eb);f[Xa>>2]=eb;hb=eb}else hb=db;db=f[c+336>>2]|0;eb=(db|0)==0?496376:db;if((eb|0)==(hb|0))jMa(42952);if(f[eb+8>>2]&1|0){db=f[eb+16>>2]|0;Xa=hb+8|0;f[Xa>>2]=f[Xa>>2]|1;f[hb+16>>2]=db}db=f[eb+4>>2]|0;if(db&1|0)LPb(db&-2,hb+4|0)}if(f[ga>>2]&67108864|0){db=a+12|0;f[db>>2]=f[db>>2]|67108864;db=a+340|0;eb=f[db>>2]|0;if(!eb){Xa=L5b(24)|0;iPa(Xa);f[db>>2]=Xa;ib=Xa}else ib=eb;eb=f[c+340>>2]|0;Xa=(eb|0)==0?496456:eb;if((Xa|0)==(ib|0))jMa(43724);eb=Xa+8|0;db=f[eb>>2]|0;do if(db&255|0){if(!(db&1))jb=db;else{cb=f[Xa+16>>2]|0;bb=ib+8|0;f[bb>>2]=f[bb>>2]|1;f[ib+16>>2]=cb;jb=f[eb>>2]|0}if(!(jb&2))break;cb=f[Xa+20>>2]|0;bb=ib+8|0;f[bb>>2]=f[bb>>2]|2;f[ib+20>>2]=cb}while(0);eb=f[Xa+4>>2]|0;if(eb&1|0)LPb(eb&-2,ib+4|0)}if(f[ga>>2]&134217728|0){eb=a+12|0;f[eb>>2]=f[eb>>2]|134217728;eb=a+344|0;db=f[eb>>2]|0;if(!db){cb=L5b(28)|0;VQa(cb);f[eb>>2]=cb;kb=cb}else kb=db;db=f[c+344>>2]|0;cb=(db|0)==0?496656:db;if((cb|0)==(kb|0))jMa(46347);db=cb+8|0;eb=f[db>>2]|0;do if(eb&255|0){if(!(eb&1))lb=eb;else{bb=f[cb+16>>2]|0;ab=kb+8|0;f[ab>>2]=f[ab>>2]|1;f[kb+16>>2]=bb;lb=f[db>>2]|0}if(!(lb&2))mb=lb;else{bb=f[cb+20>>2]|0;ab=kb+8|0;f[ab>>2]=f[ab>>2]|2;f[kb+20>>2]=bb;mb=f[db>>2]|0}if(!(mb&4))break;bb=f[cb+24>>2]|0;ab=kb+8|0;f[ab>>2]=f[ab>>2]|4;f[kb+24>>2]=bb}while(0);db=f[cb+4>>2]|0;if(db&1|0)LPb(db&-2,kb+4|0)}db=f[ga>>2]|0;do if(db&268435456){eb=a+12|0;f[eb>>2]=f[eb>>2]|268435456;eb=a+348|0;Xa=f[eb>>2]|0;if(!Xa){bb=L5b(36)|0;jPa(bb);f[eb>>2]=bb;nb=bb}else nb=Xa;Xa=f[c+348>>2]|0;bb=(Xa|0)==0?496408:Xa;if((bb|0)==(nb|0))jMa(43317);else{kPa(nb,bb);ob=f[ga>>2]|0;break}}else ob=db;while(0);do if(ob&536870912|0){db=a+12|0;f[db>>2]=f[db>>2]|536870912;db=a+352|0;cb=f[db>>2]|0;if(!cb){bb=L5b(20)|0;lPa(bb);f[db>>2]=bb;pb=bb}else pb=cb;cb=f[c+352>>2]|0;bb=(cb|0)==0?496488:cb;if((bb|0)==(pb|0))jMa(44061);if(f[bb+8>>2]&1|0){cb=f[bb+16>>2]|0;db=pb+8|0;f[db>>2]=f[db>>2]|1;f[pb+16>>2]=cb}cb=f[bb+4>>2]|0;if(!(cb&1))break;LPb(cb&-2,pb+4|0)}while(0);cb=f[ga>>2]|0;if(!(cb&1073741824))qb=cb;else{cb=a+12|0;f[cb>>2]=f[cb>>2]|1073741824;cb=a+356|0;bb=f[cb>>2]|0;if(!bb){db=L5b(20)|0;mPa(db);f[cb>>2]=db;rb=db}else rb=bb;bb=f[c+356>>2]|0;db=(bb|0)==0?496552:bb;if((db|0)==(rb|0))jMa(44685);if(f[db+8>>2]&1|0){bb=f[db+16>>2]|0;cb=rb+8|0;f[cb>>2]=f[cb>>2]|1;f[rb+16>>2]=bb}bb=f[db+4>>2]|0;if(bb&1|0)LPb(bb&-2,rb+4|0);qb=f[ga>>2]|0}if((qb|0)<0){bb=a+12|0;f[bb>>2]=f[bb>>2]|-2147483648;bb=a+360|0;db=f[bb>>2]|0;if(!db){cb=L5b(24)|0;QRa(cb);f[bb>>2]=cb;sb=cb}else sb=db;db=f[c+360>>2]|0;cb=(db|0)==0?496520:db;if((cb|0)==(sb|0))jMa(44380);db=cb+8|0;bb=f[db>>2]|0;do if(bb&255|0){if(!(bb&1))tb=bb;else{Xa=f[cb+20>>2]|0;eb=sb+8|0;f[eb>>2]=f[eb>>2]|1;f[sb+20>>2]=Xa;tb=f[db>>2]|0}if(!(tb&2))break;Xa=f[cb+16>>2]|0;eb=sb+8|0;f[eb>>2]=f[eb>>2]|2;f[sb+16>>2]=Xa}while(0);db=f[cb+4>>2]|0;if(!(db&1))break;LPb(db&-2,sb+4|0)}}while(0);do if(f[c+16>>2]&1|0){sb=a+16|0;f[sb>>2]=f[sb>>2]|1;sb=a+364|0;tb=f[sb>>2]|0;if(!tb){qb=L5b(64)|0;nPa(qb);f[sb>>2]=qb;ub=qb}else ub=tb;tb=f[c+364>>2]|0;qb=(tb|0)==0?496584:tb;if((qb|0)==(ub|0))jMa(45459);else{oPa(ub,qb);break}}while(0);ub=f[c+4>>2]|0;if(!(ub&1)){u=d;return}LPb(ub&-2,a+4|0);u=d;return}function J3a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{R3a(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Kza(h,i)|0;R3a(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function K3a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=111888;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=493416?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[a+40>>2]=-1;f[a+44>>2]=1;b[a+48>>0]=1;b[a+49>>0]=1;u=c;return}function L3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=c+8|0;e=f[d>>2]|0;if(e&255){if(!(e&1))g=e;else{h=f[c+24>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|1;f[a+24>>2]=h;g=f[d>>2]|0}if(!(g&2))j=g;else{g=b[c+48>>0]|0;h=a+8|0;f[h>>2]=f[h>>2]|2;b[a+48>>0]=g;j=f[d>>2]|0}if(!(j&4))k=j;else{j=f[c+28>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|4;f[a+28>>2]=j;k=f[d>>2]|0}if(k&8|0){k=a+8|0;f[k>>2]=f[k>>2]|8;k=a+16|0;j=f[k>>2]|0;if(!j){g=L5b(28)|0;c0a(g);f[k>>2]=g;l=g}else l=j;j=f[c+16>>2]|0;g=(j|0)==0?495104:j;if((g|0)==(l|0))jMa(28291);j=g+8|0;k=f[j>>2]|0;if(k&255|0){if(!(k&1))m=k;else{k=f[g+20>>2]|0;h=l+8|0;f[h>>2]=f[h>>2]|1;f[l+20>>2]=k;m=f[j>>2]|0}if(!(m&2))n=m;else{m=f[g+16>>2]|0;k=l+8|0;f[k>>2]=f[k>>2]|2;f[l+16>>2]=m;n=f[j>>2]|0}if(n&4|0){n=f[g+24>>2]|0;j=l+8|0;f[j>>2]=f[j>>2]|4;f[l+24>>2]=n}}n=f[g+4>>2]|0;if(n&1|0)LPb(n&-2,l+4|0)}l=f[d>>2]|0;do if(l&16){n=a+8|0;f[n>>2]=f[n>>2]|16;n=a+20|0;g=f[n>>2]|0;if(!g){j=L5b(40)|0;L$a(j);f[n>>2]=j;o=j}else o=g;g=f[c+20>>2]|0;j=(g|0)==0?495144:g;if((j|0)==(o|0))jMa(28885);else{K$a(o,j);p=f[d>>2]|0;break}}else p=l;while(0);if(!(p&32))q=p;else{p=f[c+44>>2]|0;l=a+8|0;f[l>>2]=f[l>>2]|32;f[a+44>>2]=p;q=f[d>>2]|0}if(!(q&64))r=q;else{q=b[c+32>>0]|0;p=a+8|0;f[p>>2]=f[p>>2]|64;b[a+32>>0]=q;r=f[d>>2]|0}if(!(r&128))s=r;else{r=f[c+40>>2]|0;q=a+8|0;f[q>>2]=f[q>>2]|128;f[a+40>>2]=r;s=f[d>>2]|0}}else s=e;if(s&65280|0){if(!(s&256))t=s;else{s=f[c+36>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|256;f[a+36>>2]=s;t=f[d>>2]|0}if(t&512|0){t=b[c+49>>0]|0;d=a+8|0;f[d>>2]=f[d>>2]|512;b[a+49>>0]=t}}t=f[c+4>>2]|0;if(!(t&1))return;LPb(t&-2,a+4|0);return}function M3a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=111672;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=493240?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=0;b[a+20>>0]=1;b[a+21>>0]=1;n[a+24>>2]=1.000000013351432e-10;u=c;return}function N3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=c+8|0;e=f[d>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=b[c+20>>0]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;b[a+20>>0]=e;g=f[d>>2]|0}do if(g&2){e=a+8|0;f[e>>2]=f[e>>2]|2;e=a+16|0;h=f[e>>2]|0;if(!h){i=L5b(48)|0;GNa(i);f[e>>2]=i;j=i}else j=h;h=f[c+16>>2]|0;i=(h|0)==0?493544:h;if((i|0)==(j|0))jMa(8763);else{HNa(j,i);k=f[d>>2]|0;break}}else k=g;while(0);if(!(k&4))l=k;else{k=b[c+21>>0]|0;g=a+8|0;f[g>>2]=f[g>>2]|4;b[a+21>>0]=k;l=f[d>>2]|0}if(l&8|0){l=f[c+24>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|8;f[a+24>>2]=l}}l=f[c+4>>2]|0;if(!(l&1))return;LPb(l&-2,a+4|0);return}function O3a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=111564;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=493200?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;u=c;return}function P3a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=111780;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==493280;g=a+16|0;h=g+72|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;d=a+88|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;b[a+120>>0]=1;b[a+121>>0]=1;n[a+124>>2]=.5;u=c;return}function Q3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+16|0;e=c+16|0;g=f[e>>2]|0;if(g|0){qza(d,(f[d>>2]|0)+g|0);Vac((f[a+24>>2]|0)+4+(f[d>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[e>>2]|0)}e=a+28|0;d=c+28|0;g=f[d>>2]|0;if(g|0){qza(e,(f[e>>2]|0)+g|0);Vac((f[a+36>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+36>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[d>>2]|0)}d=a+40|0;e=c+40|0;g=f[e>>2]|0;if(g|0){qza(d,(f[d>>2]|0)+g|0);Vac((f[a+48>>2]|0)+4+(f[d>>2]<<2)|0,(f[c+48>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[e>>2]|0)}e=a+52|0;d=c+52|0;g=f[d>>2]|0;if(g|0){qza(e,(f[e>>2]|0)+g|0);Vac((f[a+60>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+60>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[d>>2]|0)}d=a+64|0;e=c+64|0;g=f[e>>2]|0;if(g|0){qza(d,(f[d>>2]|0)+g|0);Vac((f[a+72>>2]|0)+4+(f[d>>2]<<2)|0,(f[c+72>>2]|0)+4|0,f[e>>2]<<2|0)|0;f[d>>2]=(f[d>>2]|0)+(f[e>>2]|0)}e=a+76|0;d=c+76|0;g=f[d>>2]|0;if(g|0){qza(e,(f[e>>2]|0)+g|0);Vac((f[a+84>>2]|0)+4+(f[e>>2]<<2)|0,(f[c+84>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[e>>2]=(f[e>>2]|0)+(f[d>>2]|0)}d=c+8|0;e=f[d>>2]|0;if(e&255){if(!(e&1))h=e;else{g=f[c+88>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|1;f[a+88>>2]=g;h=f[d>>2]|0}if(!(h&2))j=h;else{h=f[c+92>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|2;f[a+92>>2]=h;j=f[d>>2]|0}if(!(j&8))k=j;else{j=b[c+120>>0]|0;h=a+8|0;f[h>>2]=f[h>>2]|8;b[a+120>>0]=j;k=f[d>>2]|0}if(!(k&16))l=k;else{k=b[c+121>>0]|0;j=a+8|0;f[j>>2]=f[j>>2]|16;b[a+121>>0]=k;l=f[d>>2]|0}if(!(l&64))m=l;else{l=f[c+96>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|64;f[a+96>>2]=l;m=f[d>>2]|0}if(!(m&128))n=m;else{m=f[c+100>>2]|0;l=a+8|0;f[l>>2]=f[l>>2]|128;f[a+100>>2]=m;n=f[d>>2]|0}}else n=e;if(n&65280|0){if(!(n&256))o=n;else{n=f[c+104>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|256;f[a+104>>2]=n;o=f[d>>2]|0}if(!(o&512))p=o;else{o=f[c+108>>2]|0;n=a+8|0;f[n>>2]=f[n>>2]|512;f[a+108>>2]=o;p=f[d>>2]|0}if(!(p&1024))q=p;else{p=f[c+112>>2]|0;o=a+8|0;f[o>>2]=f[o>>2]|1024;f[a+112>>2]=p;q=f[d>>2]|0}if(!(q&2048))r=q;else{q=f[c+116>>2]|0;p=a+8|0;f[p>>2]=f[p>>2]|2048;f[a+116>>2]=q;r=f[d>>2]|0}if(r&4096|0){r=f[c+124>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|4096;f[a+124>>2]=r}}r=f[c+4>>2]|0;if(!(r&1))return;LPb(r&-2,a+4|0);return}function R3a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))jMa(15341);else{S3a(b,a);return}}function S3a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c+4|0;e=c;g=b+8|0;h=f[g>>2]|0;if(h&255|0){if(!(h&1))i=h;else{h=a+8|0;f[h>>2]=f[h>>2]|1;f[e>>2]=f[b+16>>2];f[d>>2]=f[e>>2];Anb(a+16|0,497760,d);i=f[g>>2]|0}if(!(i&2))j=i;else{i=f[b+20>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+20>>2]=i;j=f[g>>2]|0}if(!(j&4))k=j;else{j=f[b+24>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|4;f[a+24>>2]=j;k=f[g>>2]|0}if(k&8|0){k=f[b+28>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|8;f[a+28>>2]=k}}k=f[b+4>>2]|0;if(!(k&1)){u=c;return}LPb(k&-2,a+4|0);u=c;return}function T3a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;b=a+8|0;c=f[b>>2]|0;if(c&255){if(!(c&1)){d=0;e=c}else{g=f[a+24>>2]|0;if(g>>>0<128){h=1;i=c}else{j=iob(g)|0;h=j;i=f[b>>2]|0}d=h+1|0;e=i}i=e&2|0?d+2|0:d;if(!(e&4)){k=i;l=e}else{d=f[a+28>>2]|0;if((d|0)>=0)if(d>>>0<128){m=1;n=e}else{h=iob(d)|0;m=h;n=f[b>>2]|0}else{m=10;n=e}k=i+1+m|0;l=n}if(!(l&8)){o=k;p=l}else{l=f[a+16>>2]|0;n=l+8|0;m=f[n>>2]|0;if(!(m&7))q=0;else{i=m&1|0?5:0;if(!(m&2)){r=i;s=m}else{e=f[l+16>>2]|0;if((e|0)>=0)if(e>>>0<128){t=2;u=m}else{h=(iob(e)|0)+1|0;t=h;u=f[n>>2]|0}else{t=11;u=m}r=t+i|0;s=u}q=s&4|0?r+5|0:r}r=f[l+4>>2]|0;if(!(r&1))v=q;else v=(dQb(r&-2)|0)+q|0;f[l+12>>2]=v;if(v>>>0<128)w=1;else w=iob(v)|0;o=k+1+v+w|0;p=f[b>>2]|0}if(!(p&16)){x=o;y=p}else{p=B$a(f[a+20>>2]|0)|0;if(p>>>0<128)z=1;else z=iob(p)|0;x=o+1+p+z|0;y=f[b>>2]|0}if(!(y&32)){A=x;B=y}else{z=f[a+44>>2]|0;if((z|0)>=0)if(z>>>0<128){C=2;D=y}else{p=(iob(z)|0)+1|0;C=p;D=f[b>>2]|0}else{C=11;D=y}A=C+x|0;B=D}D=B&64|0?A+2|0:A;if(!(B&128)){E=D;F=B}else{A=f[a+40>>2]|0;if((A|0)>=0)if(A>>>0<128){G=2;H=B}else{x=(iob(A)|0)+1|0;G=x;H=f[b>>2]|0}else{G=11;H=B}E=G+D|0;F=H}}else{E=0;F=c}if(!(F&768))I=E;else{c=F&256|0?E+5|0:E;I=F&512|0?c+2|0:c}c=f[a+4>>2]|0;if(!(c&1)){J=I;K=a+12|0;f[K>>2]=J;return J|0}J=(dQb(c&-2)|0)+I|0;K=a+12|0;f[K>>2]=J;return J|0}function U3a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=a+8|0;c=f[b>>2]|0;if(c&219){d=c&1|0?5:0;e=c&2|0?d+5|0:d;d=c&8|0?e+2|0:e;e=c&16|0?d+2|0:d;if(!(c&64)){g=e;h=c}else{d=f[a+96>>2]|0;if(d>>>0<128){i=2;j=c}else{k=(iob(d)|0)+1|0;i=k;j=f[b>>2]|0}g=i+e|0;h=j}if(!(h&128)){l=g;m=h}else{j=f[a+100>>2]|0;if(j>>>0<128){n=2;o=h}else{h=(iob(j)|0)+1|0;n=h;o=f[b>>2]|0}l=n+g|0;m=o}}else{l=0;m=c}if(!(m&7936))p=l;else{if(!(m&256)){q=l;r=m}else{c=f[a+104>>2]|0;if(c>>>0<128){s=2;t=m}else{m=(iob(c)|0)+1|0;s=m;t=f[b>>2]|0}q=s+l|0;r=t}t=r&512|0?q+5|0:q;q=r&1024|0?t+5|0:t;t=r&2048|0?q+5|0:q;p=r&4096|0?t+5|0:t}t=f[a+16>>2]|0;r=f[a+28>>2]|0;q=f[a+40>>2]|0;l=f[a+52>>2]|0;s=f[a+64>>2]|0;b=f[a+76>>2]|0;m=t+p+r+q+l+(b<<2)+(b+s<<1)+(r+t+q+l+s<<2)|0;s=f[a+4>>2]|0;if(!(s&1)){u=m;v=a+12|0;f[v>>2]=u;return u|0}u=(dQb(s&-2)|0)+m|0;v=a+12|0;f[v>>2]=u;return u|0}function V3a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+8|0;d=f[c>>2]|0;if(!(d&15))e=0;else{if(!(d&1)){g=0;h=d}else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;if(j<<24>>24<0){k=f[i+4>>2]|0;if(k>>>0<128){l=1;m=d;n=k}else{i=iob(k)|0;l=i;m=f[c>>2]|0;n=k}}else{l=1;m=d;n=j&255}g=n+1+l|0;h=m}if(!(h&2)){o=g;p=h}else{m=f[a+20>>2]|0;if((m|0)>=0)if(m>>>0<128){q=2;r=h}else{l=(iob(m)|0)+1|0;q=l;r=f[c>>2]|0}else{q=11;r=h}o=q+g|0;p=r}r=p&4|0?o+5|0:o;e=p&8|0?r+5|0:r}r=f[a+4>>2]|0;if(!(r&1)){s=e;t=a+12|0;f[t>>2]=s;return s|0}s=(dQb(r&-2)|0)+e|0;t=a+12|0;f[t>>2]=s;return s|0}function W3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+16|0;l=a+20|0;m=a+4|0;n=a+24|0;o=a+28|0;a=c+32|0;p=c+12|0;q=c+28|0;a:while(1){r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){s=b[r>>0]|0;t=s&255;if(s<<24>>24>0){f[i>>2]=t;f[c>>2]=r+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=_nb(c,x)|0;f[i>>2]=t;if((t+-1|0)>>>0<127){v=t;w=6}else{y=t;w=50}}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{switch(v|0){case 0:{z=1;w=56;break a;break}case 10:break;default:{A=v;break b}}f[j>>2]=f[j>>2]|1;t=f[k>>2]|0;if((t|0)==497760){jza(k,497760);B=f[k>>2]|0}else B=t;if(!(fqb(c,B)|0)){z=0;w=56;break a}t=f[c>>2]|0;r=f[g>>2]|0;if(t>>>0>=r>>>0)continue a;if((b[t>>0]|0)!=16)continue a;s=t+1|0;f[c>>2]=s;C=s;D=r;w=16;break}case 2:{switch(v|0){case 0:{z=1;w=56;break a;break}case 16:break;default:{A=v;break b}}C=f[c>>2]|0;D=f[g>>2]|0;w=16;break}case 3:{switch(v|0){case 0:{z=1;w=56;break a;break}case 29:break;default:{A=v;break b}}r=f[g>>2]|0;E=r;F=f[c>>2]|0;G=r;w=31;break}case 4:{switch(v|0){case 0:{z=1;w=56;break a;break}case 37:break;default:{A=v;break b}}r=f[g>>2]|0;H=r;I=f[c>>2]|0;K=r;break}default:{y=v;w=50;break b}}if((w|0)==16){w=0;if(C>>>0<D>>>0){r=b[C>>0]|0;s=r&255;if(r<<24>>24>-1){f[c>>2]=C+1;L=s}else{M=s;w=19}}else{M=0;w=19}if((w|0)==19){w=0;s=Knb(c,M)|0;r=J;if((r|0)>-1|(r|0)==-1&s>>>0>4294967295)L=s;else{z=0;w=56;break a}}if(L>>>0<2){f[j>>2]=f[j>>2]|2;f[l>>2]=L}else{s=f[m>>2]|0;if(!(s&1))N=hBa(m)|0;else N=s&-2;NPb(N,2,L,((L|0)<0)<<31>>31)}s=f[c>>2]|0;r=f[g>>2]|0;if(s>>>0>=r>>>0)continue a;if((b[s>>0]|0)!=29)continue a;t=s+1|0;f[c>>2]=t;E=r;F=t;G=r;w=31}if((w|0)==31){w=0;f[j>>2]=f[j>>2]|4;if((G-F|0)>3){r=F;t=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=t;r=F+4|0;f[c>>2]=r;O=G;P=t;Q=r;R=E}else{if(!(Xnb(c,e)|0)){w=35;break a}r=f[g>>2]|0;O=r;P=f[e>>2]|0;Q=f[c>>2]|0;R=r}f[n>>2]=P;if(Q>>>0>=R>>>0)continue a;if((b[Q>>0]|0)!=37)continue a;r=Q+1|0;f[c>>2]=r;H=R;I=r;K=O}f[j>>2]=f[j>>2]|8;if((K-I|0)>3){r=I;t=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[e>>2]=t;r=I+4|0;f[c>>2]=r;S=t;T=r;U=H}else{if(!(Xnb(c,e)|0)){w=45;break a}S=f[e>>2]|0;T=f[c>>2]|0;U=f[g>>2]|0}f[o>>2]=S;if((T|0)!=(U|0))continue a;if(f[a>>2]|0){w=49;break a}if((f[p>>2]|0)==(f[q>>2]|0)){w=49;break a}else continue a}while(0);if((w|0)==50){w=0;if(!y){z=1;w=56;break}else A=y}if((A&7|0)==4){z=1;w=56;break}r=f[m>>2]|0;if(!(r&1))V=hBa(m)|0;else V=r&-2;if(!(ZPb(c,A,V)|0)){z=0;w=56;break}}if((w|0)==35){z=0;u=d;return z|0}else if((w|0)==45){z=0;u=d;return z|0}else if((w|0)==49){f[i>>2]=0;b[c+24>>0]=1;z=1;u=d;return z|0}else if((w|0)==56){u=d;return z|0}return 0}function X3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=a+4|0;if(g>>>0<(f[h>>2]|0)>>>0?(i=b[g>>0]|0,i<<24>>24>-1):0){f[a>>2]=g+1;j=i&255}else{i=Znb(a)|0;if((i|0)>-1)j=i;else{k=0;u=d;return k|0}}i=Gnb(a,j)|0;a:do if((Qnb(a)|0)>0){j=c+4|0;g=c+8|0;l=e+8|0;while(1){m=f[a>>2]|0;if(m>>>0<(f[h>>2]|0)>>>0?(n=b[m>>0]|0,n<<24>>24>-1):0){f[a>>2]=m+1;o=n<<24>>24!=0}else{Lnb(e,a);n=e;if(!(b[l>>0]|0)){k=0;break}else o=(f[n>>2]|0)!=0|(f[n+4>>2]|0)!=0}n=f[c>>2]|0;if((n|0)==(f[j>>2]|0)){vFa(c,n+1|0);p=f[c>>2]|0}else p=n;n=f[g>>2]|0;f[c>>2]=p+1;b[n+4+p>>0]=o&1;if((Qnb(a)|0)<=0)break a}u=d;return k|0}while(0);Hnb(a,i);k=1;u=d;return k|0}function Y3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+24|0;l=a+48|0;m=e+8|0;n=a+28|0;o=a+16|0;p=e+4|0;q=a+20|0;r=e+4|0;s=a+44|0;t=a+4|0;v=a+40|0;w=a+32|0;x=e+8|0;y=a+36|0;z=a+49|0;a=c+32|0;A=c+12|0;B=c+28|0;C=e+8|0;a:while(1){D=f[c>>2]|0;if(D>>>0<(f[g>>2]|0)>>>0){E=b[D>>0]|0;F=E&255;if(E<<24>>24>0){f[i>>2]=F;f[c>>2]=D+1;G=F;H=6}else{I=F;H=5}}else{I=0;H=5}if((H|0)==5){H=0;F=_nb(c,I)|0;f[i>>2]=F;if((F+-1|0)>>>0<127){G=F;H=6}else{K=F;H=120}}b:do if((H|0)==6){H=0;do switch(G>>>3&536870911|0){case 1:{switch(G|0){case 0:{L=1;H=126;break a;break}case 8:break;default:{M=G;break b}}f[j>>2]=f[j>>2]|1;F=f[c>>2]|0;if(F>>>0<(f[g>>2]|0)>>>0){D=b[F>>0]|0;E=D&255;if(D<<24>>24>-1){f[k>>2]=E;D=F+1|0;f[c>>2]=D;N=D}else{O=E;H=11}}else{O=0;H=11}if((H|0)==11){H=0;E=Knb(c,O)|0;D=J;f[k>>2]=E;if(!((D|0)>-1|(D|0)==-1&E>>>0>4294967295)){L=0;H=126;break a}N=f[c>>2]|0}E=f[g>>2]|0;if(N>>>0>=E>>>0)continue a;if((b[N>>0]|0)!=16)continue a;D=N+1|0;f[c>>2]=D;P=D;Q=E;H=18;break}case 2:{switch(G|0){case 0:{L=1;H=126;break a;break}case 16:break;default:{M=G;break b}}P=f[c>>2]|0;Q=f[g>>2]|0;H=18;break}case 3:{switch(G|0){case 0:{L=1;H=126;break a;break}case 24:break;default:{M=G;break b}}R=f[c>>2]|0;S=f[g>>2]|0;H=28;break}case 4:{switch(G|0){case 0:{L=1;H=126;break a;break}case 34:{H=37;break}default:{M=G;break b}}break}case 5:{switch(G|0){case 0:{L=1;H=126;break a;break}case 42:{H=51;break}default:{M=G;break b}}break}case 6:{switch(G|0){case 0:{L=1;H=126;break a;break}case 48:break;default:{M=G;break b}}T=f[c>>2]|0;U=f[g>>2]|0;H=66;break}case 7:{switch(G|0){case 0:{L=1;H=126;break a;break}case 56:break;default:{M=G;break b}}V=f[g>>2]|0;W=f[c>>2]|0;H=81;break}case 8:{switch(G|0){case 0:{L=1;H=126;break a;break}case 64:break;default:{M=G;break b}}X=f[g>>2]|0;Y=f[c>>2]|0;H=91;break}case 9:{switch(G|0){case 0:{L=1;H=126;break a;break}case 77:break;default:{M=G;break b}}E=f[g>>2]|0;Z=f[c>>2]|0;_=E;$=E;H=101;break}case 10:{switch(G|0){case 0:{L=1;H=126;break a;break}case 80:break;default:{M=G;break b}}aa=f[c>>2]|0;ba=f[g>>2]|0;break}default:{K=G;H=120;break b}}while(0);if((H|0)==18){H=0;f[j>>2]=f[j>>2]|2;if(P>>>0<Q>>>0?(E=b[P>>0]|0,E<<24>>24>-1):0){D=P+1|0;f[c>>2]=D;ca=E<<24>>24!=0;da=D;ea=Q}else{Lnb(e,c);D=e;if(!(b[m>>0]|0)){L=0;H=126;break a}ca=(f[D>>2]|0)!=0|(f[D+4>>2]|0)!=0;da=f[c>>2]|0;ea=f[g>>2]|0}b[l>>0]=ca&1;if(da>>>0>=ea>>>0)continue a;if((b[da>>0]|0)!=24)continue a;D=da+1|0;f[c>>2]=D;R=D;S=ea;H=28}if((H|0)==28){H=0;f[j>>2]=f[j>>2]|4;if(R>>>0<S>>>0){D=b[R>>0]|0;E=D&255;if(D<<24>>24>-1){D=R+1|0;f[c>>2]=D;fa=E;ga=D;ha=S}else{ia=E;H=31}}else{ia=0;H=31}if((H|0)==31){H=0;E=Knb(c,ia)|0;D=J;if(!((D|0)>-1|(D|0)==-1&E>>>0>4294967295)){L=0;H=126;break a}fa=E;ga=f[c>>2]|0;ha=f[g>>2]|0}f[n>>2]=fa;if(ga>>>0>=ha>>>0)continue a;if((b[ga>>0]|0)!=34)continue a;f[c>>2]=ga+1;H=37}if((H|0)==37){H=0;f[j>>2]=f[j>>2]|8;E=f[o>>2]|0;if(!E){D=L5b(28)|0;c0a(D);f[o>>2]=D;ja=D}else ja=E;E=f[c>>2]|0;if(E>>>0<(f[g>>2]|0)>>>0?(D=b[E>>0]|0,D<<24>>24>-1):0){f[c>>2]=E+1;ka=D&255}else{D=Znb(c)|0;if((D|0)>-1)ka=D;else{L=0;H=126;break a}}Inb(e,c,ka);if((f[p>>2]|0)<0){H=45;break a}if(!(U$a(ja,c)|0)){H=45;break a}if(!(Onb(c,f[e>>2]|0)|0)){L=0;H=126;break a}D=f[c>>2]|0;if(D>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[D>>0]|0)!=42)continue a;f[c>>2]=D+1;H=51}if((H|0)==51){H=0;f[j>>2]=f[j>>2]|16;D=f[q>>2]|0;if(!D){E=L5b(40)|0;L$a(E);f[q>>2]=E;la=E}else la=D;D=f[c>>2]|0;if(D>>>0<(f[g>>2]|0)>>>0?(E=b[D>>0]|0,E<<24>>24>-1):0){f[c>>2]=D+1;ma=E&255}else{E=Znb(c)|0;if((E|0)>-1)ma=E;else{L=0;H=126;break a}}Inb(e,c,ma);if((f[r>>2]|0)<0){H=59;break a}if(!(A$a(la,c)|0)){H=59;break a}if(!(Onb(c,f[e>>2]|0)|0)){L=0;H=126;break a}E=f[c>>2]|0;D=f[g>>2]|0;if(E>>>0>=D>>>0)continue a;if((b[E>>0]|0)!=48)continue a;F=E+1|0;f[c>>2]=F;T=F;U=D;H=66}if((H|0)==66){H=0;if(T>>>0<U>>>0){D=b[T>>0]|0;F=D&255;if(D<<24>>24>-1){f[c>>2]=T+1;na=F}else{oa=F;H=69}}else{oa=0;H=69}if((H|0)==69){H=0;F=Knb(c,oa)|0;D=J;if((D|0)>-1|(D|0)==-1&F>>>0>4294967295)na=F;else{L=0;H=126;break a}}if((na+-1|0)>>>0<2){f[j>>2]=f[j>>2]|32;f[s>>2]=na}else{F=f[t>>2]|0;if(!(F&1))pa=hBa(t)|0;else pa=F&-2;NPb(pa,6,na,((na|0)<0)<<31>>31)}F=f[c>>2]|0;D=f[g>>2]|0;if(F>>>0>=D>>>0)continue a;if((b[F>>0]|0)!=56)continue a;E=F+1|0;f[c>>2]=E;V=D;W=E;H=81}if((H|0)==81){H=0;f[j>>2]=f[j>>2]|128;if(W>>>0<V>>>0){E=b[W>>0]|0;D=E&255;if(E<<24>>24>-1){E=W+1|0;f[c>>2]=E;qa=D;ra=V;sa=E}else{ta=D;H=84}}else{ta=0;H=84}if((H|0)==84){H=0;D=Knb(c,ta)|0;E=J;if(!((E|0)>-1|(E|0)==-1&D>>>0>4294967295)){L=0;H=126;break a}qa=D;ra=f[g>>2]|0;sa=f[c>>2]|0}f[v>>2]=qa;if(sa>>>0>=ra>>>0)continue a;if((b[sa>>0]|0)!=64)continue a;D=sa+1|0;f[c>>2]=D;X=ra;Y=D;H=91}if((H|0)==91){H=0;f[j>>2]=f[j>>2]|64;if(Y>>>0<X>>>0?(D=b[Y>>0]|0,D<<24>>24>-1):0){E=Y+1|0;f[c>>2]=E;ua=D<<24>>24!=0;va=X;wa=E}else{Lnb(e,c);E=e;if(!(b[x>>0]|0)){L=0;H=126;break a}ua=(f[E>>2]|0)!=0|(f[E+4>>2]|0)!=0;va=f[g>>2]|0;wa=f[c>>2]|0}b[w>>0]=ua&1;if(wa>>>0>=va>>>0)continue a;if((b[wa>>0]|0)!=77)continue a;E=wa+1|0;f[c>>2]=E;Z=E;_=va;$=va;H=101}if((H|0)==101){H=0;f[j>>2]=f[j>>2]|256;if((_-Z|0)>3){E=Z;D=h[E>>0]|h[E+1>>0]<<8|h[E+2>>0]<<16|h[E+3>>0]<<24;f[e>>2]=D;E=Z+4|0;f[c>>2]=E;xa=D;ya=E;za=$}else{if(!(Xnb(c,e)|0)){H=105;break a}xa=f[e>>2]|0;ya=f[c>>2]|0;za=f[g>>2]|0}f[y>>2]=xa;if(ya>>>0>=za>>>0)continue a;if((b[ya>>0]|0)!=80)continue a;E=ya+1|0;f[c>>2]=E;aa=E;ba=za}f[j>>2]=f[j>>2]|512;if(aa>>>0<ba>>>0?(E=b[aa>>0]|0,E<<24>>24>-1):0){D=aa+1|0;f[c>>2]=D;Aa=E<<24>>24!=0;Ba=D;Ca=ba}else{Lnb(e,c);D=e;if(!(b[C>>0]|0)){L=0;H=126;break a}Aa=(f[D>>2]|0)!=0|(f[D+4>>2]|0)!=0;Ba=f[c>>2]|0;Ca=f[g>>2]|0}b[z>>0]=Aa&1;if((Ba|0)!=(Ca|0))continue a;if(f[a>>2]|0){H=119;break a}if((f[A>>2]|0)==(f[B>>2]|0)){H=119;break a}else continue a}while(0);if((H|0)==120){H=0;if(!K){L=1;H=126;break}else M=K}if((M&7|0)==4){L=1;H=126;break}D=f[t>>2]|0;if(!(D&1))Da=hBa(t)|0;else Da=D&-2;if(!(ZPb(c,M,Da)|0)){L=0;H=126;break}}if((H|0)==45){L=0;u=d;return L|0}else if((H|0)==59){L=0;u=d;return L|0}else if((H|0)==105){L=0;u=d;return L|0}else if((H|0)==119){f[i>>2]=0;b[c+24>>0]=1;L=1;u=d;return L|0}else if((H|0)==126){u=d;return L|0}return 0}function Z3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=c+4|0;e=c+20|0;g=a+16|0;h=a+20|0;i=a+24|0;j=c+32|0;k=c+12|0;l=c+28|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[e>>2]=o;f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=_nb(c,r)|0;f[e>>2]=o;if((o+-1|0)>>>0<127){p=o;q=6}else{s=o;q=32}}b:do if((q|0)==6){q=0;if((p&-8|0)==8){switch(p|0){case 0:{t=1;q=38;break a;break}case 8:{u=f[c>>2]|0;v=f[d>>2]|0;break}case 10:{if(wQa(c,g)|0)q=25;else{t=0;q=38;break a}break}default:{w=p;break b}}c:while(1){if((q|0)==25){q=0;x=f[c>>2]|0;y=f[d>>2]|0;if(x>>>0>=y>>>0)break;if((b[x>>0]|0)!=8)break;o=x+1|0;f[c>>2]=o;u=o;v=y}if(u>>>0<v>>>0){o=b[u>>0]|0;a=o&255;if(o<<24>>24>-1){f[c>>2]=u+1;z=a}else{A=a;q=12}}else{A=0;q=12}if((q|0)==12){q=0;a=Knb(c,A)|0;o=J;if((o|0)>-1|(o|0)==-1&a>>>0>4294967295)z=a;else{t=0;q=38;break a}}a=f[g>>2]|0;if((a|0)==(f[h>>2]|0)){rza(g,a+1|0);B=f[g>>2]|0}else B=a;a=f[i>>2]|0;f[g>>2]=B+1;f[a+4+(B<<2)>>2]=z;o=(f[h>>2]|0)-(f[g>>2]|0)|0;if((o|0)>0){C=o;D=a}else{q=25;continue}while(1){a=f[c>>2]|0;o=f[d>>2]|0;if(a>>>0>=o>>>0){q=25;continue c}if((b[a>>0]|0)!=8){q=25;continue c}n=a+1|0;f[c>>2]=n;if(n>>>0<o>>>0){o=b[n>>0]|0;n=o&255;if(o<<24>>24>-1){f[c>>2]=a+2;E=n;F=D}else{G=n;q=20}}else{G=0;q=20}if((q|0)==20){q=0;n=Knb(c,G)|0;a=J;if(!((a|0)>-1|(a|0)==-1&n>>>0>4294967295)){t=0;q=38;break a}E=n;F=f[i>>2]|0}n=f[g>>2]|0;f[g>>2]=n+1;f[F+4+(n<<2)>>2]=E;if((C|0)>1){C=C+-1|0;D=F}else{q=25;continue c}}}if((x|0)!=(y|0))continue a;if(f[j>>2]|0){q=31;break a}if((f[k>>2]|0)==(f[l>>2]|0)){q=31;break a}else continue a}else{s=p;q=32}}while(0);if((q|0)==32){q=0;if(!s){t=1;q=38;break}else w=s}if((w&7|0)==4){t=1;q=38;break}n=f[m>>2]|0;if(!(n&1))H=hBa(m)|0;else H=n&-2;if(!(ZPb(c,w,H)|0)){t=0;q=38;break}}if((q|0)==31){f[e>>2]=0;b[c+24>>0]=1;t=1;return t|0}else if((q|0)==38)return t|0;return 0}function _3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+20|0;l=e+8|0;m=a+16|0;n=e+4|0;o=a+21|0;p=e+8|0;q=a+24|0;r=c+32|0;s=c+12|0;t=c+28|0;v=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){w=b[a>>0]|0;x=w&255;if(w<<24>>24>0){f[i>>2]=x;f[c>>2]=a+1;y=x;z=6}else{A=x;z=5}}else{A=0;z=5}if((z|0)==5){z=0;x=_nb(c,A)|0;f[i>>2]=x;if((x+-1|0)>>>0<127){y=x;z=6}else{B=x;z=51}}b:do if((z|0)==6){z=0;switch(y>>>3&536870911|0){case 1:{switch(y|0){case 0:{C=1;z=57;break a;break}case 8:break;default:{D=y;break b}}f[j>>2]=f[j>>2]|1;x=f[c>>2]|0;a=f[g>>2]|0;if(x>>>0<a>>>0?(w=b[x>>0]|0,w<<24>>24>-1):0){E=x+1|0;f[c>>2]=E;F=w<<24>>24!=0;G=E;H=a}else{Lnb(e,c);a=e;if(!(b[l>>0]|0)){C=0;z=57;break a}F=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0;G=f[c>>2]|0;H=f[g>>2]|0}b[k>>0]=F&1;if(G>>>0>=H>>>0)continue a;if((b[G>>0]|0)!=18)continue a;f[c>>2]=G+1;z=17;break}case 2:{switch(y|0){case 0:{C=1;z=57;break a;break}case 18:{z=17;break}default:{D=y;break b}}break}case 3:{switch(y|0){case 0:{C=1;z=57;break a;break}case 24:break;default:{D=y;break b}}I=f[g>>2]|0;J=f[c>>2]|0;z=32;break}case 4:{switch(y|0){case 0:{C=1;z=57;break a;break}case 37:break;default:{D=y;break b}}a=f[g>>2]|0;K=f[c>>2]|0;L=a;M=a;break}default:{B=y;z=51;break b}}if((z|0)==17){z=0;f[j>>2]=f[j>>2]|2;a=f[m>>2]|0;if(!a){E=L5b(48)|0;GNa(E);f[m>>2]=E;N=E}else N=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(E=b[a>>0]|0,E<<24>>24>-1):0){f[c>>2]=a+1;O=E&255}else{E=Znb(c)|0;if((E|0)>-1)O=E;else{C=0;z=57;break a}}Inb(e,c,O);if((f[n>>2]|0)<0){z=25;break a}if(!(JNa(N,c)|0)){z=25;break a}if(!(Onb(c,f[e>>2]|0)|0)){C=0;z=57;break a}E=f[c>>2]|0;a=f[g>>2]|0;if(E>>>0>=a>>>0)continue a;if((b[E>>0]|0)!=24)continue a;w=E+1|0;f[c>>2]=w;I=a;J=w;z=32}if((z|0)==32){z=0;f[j>>2]=f[j>>2]|4;if(J>>>0<I>>>0?(w=b[J>>0]|0,w<<24>>24>-1):0){a=J+1|0;f[c>>2]=a;P=w<<24>>24!=0;Q=I;R=a}else{Lnb(e,c);a=e;if(!(b[p>>0]|0)){C=0;z=57;break a}P=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0;Q=f[g>>2]|0;R=f[c>>2]|0}b[o>>0]=P&1;if(R>>>0>=Q>>>0)continue a;if((b[R>>0]|0)!=37)continue a;a=R+1|0;f[c>>2]=a;K=a;L=Q;M=Q}f[j>>2]=f[j>>2]|8;if((L-K|0)>3){a=K;w=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=w;a=K+4|0;f[c>>2]=a;S=w;T=a;U=M}else{if(!(Xnb(c,e)|0)){z=46;break a}S=f[e>>2]|0;T=f[c>>2]|0;U=f[g>>2]|0}f[q>>2]=S;if((T|0)!=(U|0))continue a;if(f[r>>2]|0){z=50;break a}if((f[s>>2]|0)==(f[t>>2]|0)){z=50;break a}else continue a}while(0);if((z|0)==51){z=0;if(!B){C=1;z=57;break}else D=B}if((D&7|0)==4){C=1;z=57;break}a=f[v>>2]|0;if(!(a&1))V=hBa(v)|0;else V=a&-2;if(!(ZPb(c,D,V)|0)){C=0;z=57;break}}if((z|0)==25){C=0;u=d;return C|0}else if((z|0)==46){C=0;u=d;return C|0}else if((z|0)==50){f[i>>2]=0;b[c+24>>0]=1;C=1;u=d;return C|0}else if((z|0)==57){u=d;return C|0}return 0}function $3a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+88|0;l=a+92|0;m=a+16|0;n=a+20|0;o=a+24|0;p=a+120|0;q=e+8|0;r=a+121|0;s=e+8|0;t=a+28|0;v=a+32|0;w=a+36|0;x=a+96|0;y=a+100|0;z=a+104|0;A=a+108|0;B=a+112|0;C=a+116|0;D=a+124|0;E=a+40|0;F=a+44|0;G=a+48|0;H=a+52|0;I=a+56|0;K=a+60|0;L=a+64|0;M=a+68|0;N=a+72|0;O=a+76|0;P=a+80|0;Q=a+84|0;R=c+32|0;S=c+12|0;T=c+28|0;U=a+4|0;a:while(1){a=f[c>>2]|0;V=f[g>>2]|0;do if(a>>>0<V>>>0){W=b[a>>0]|0;X=W&255;if(W<<24>>24>0){Y=X;Z=1}else{W=a+1|0;if(W>>>0>=V>>>0){_=X;$=7;break}aa=h[W>>0]|0;if(((aa^128)&X)>>>0<=127){_=X;$=7;break}Y=X+-128+(aa<<7)|0;Z=2}f[i>>2]=Y;f[c>>2]=a+Z;ba=Y;$=9}else{_=0;$=7}while(0);if(($|0)==7){$=0;a=_nb(c,_)|0;f[i>>2]=a;if((a+-1|0)>>>0<16383){ba=a;$=9}else{ca=a;$=255}}b:do if(($|0)==9){$=0;c:do switch(ba>>>3&536870911|0){case 1:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 13:break;default:{ea=ba;break b}}f[j>>2]=f[j>>2]|1;a=f[g>>2]|0;V=f[c>>2]|0;if((a-V|0)>3){aa=V;X=h[aa>>0]|h[aa+1>>0]<<8|h[aa+2>>0]<<16|h[aa+3>>0]<<24;f[e>>2]=X;aa=V+4|0;f[c>>2]=aa;fa=a;ga=X;ha=aa;ia=a}else{if(!(Xnb(c,e)|0)){$=15;break a}a=f[g>>2]|0;fa=a;ga=f[e>>2]|0;ha=f[c>>2]|0;ia=a}f[k>>2]=ga;if(ha>>>0>=ia>>>0)continue a;if((b[ha>>0]|0)!=21)continue a;a=ha+1|0;f[c>>2]=a;ja=ia;ka=a;la=fa;$=21;break}case 2:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 21:break;default:{ea=ba;break b}}a=f[g>>2]|0;ja=a;ka=f[c>>2]|0;la=a;$=21;break}case 3:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 29:{ma=f[c>>2]|0;na=f[g>>2]|0;$=31;break c;break}case 26:{if(DMa(c,m)|0){$=46;break c}else{da=0;$=261;break a}break}default:{ea=ba;break b}}break}case 4:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 32:break;default:{ea=ba;break b}}a=f[g>>2]|0;oa=f[c>>2]|0;pa=a;qa=a;$=52;break}case 5:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 40:break;default:{ea=ba;break b}}a=f[g>>2]|0;ra=f[c>>2]|0;sa=a;ta=a;$=62;break}case 6:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 53:{ua=f[c>>2]|0;va=f[g>>2]|0;$=72;break c;break}case 50:{if(DMa(c,t)|0){$=87;break c}else{da=0;$=261;break a}break}default:{ea=ba;break b}}break}case 7:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 56:break;default:{ea=ba;break b}}a=f[g>>2]|0;wa=f[c>>2]|0;xa=a;ya=a;$=93;break}case 8:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 64:break;default:{ea=ba;break b}}a=f[g>>2]|0;za=f[c>>2]|0;Aa=a;Ba=a;$=103;break}case 9:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 72:break;default:{ea=ba;break b}}a=f[g>>2]|0;Ca=f[c>>2]|0;Da=a;Ea=a;$=113;break}case 10:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 85:break;default:{ea=ba;break b}}a=f[g>>2]|0;Fa=f[c>>2]|0;Ga=a;Ha=a;$=123;break}case 11:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 93:break;default:{ea=ba;break b}}a=f[g>>2]|0;Ia=f[c>>2]|0;Ja=a;Ka=a;$=133;break}case 12:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 101:break;default:{ea=ba;break b}}a=f[g>>2]|0;La=f[c>>2]|0;Ma=a;Na=a;$=143;break}case 13:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 109:break;default:{ea=ba;break b}}a=f[g>>2]|0;Oa=f[c>>2]|0;Pa=a;Qa=a;$=153;break}case 14:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 117:{Ra=f[c>>2]|0;Sa=f[g>>2]|0;$=163;break c;break}case 114:{if(DMa(c,E)|0){$=178;break c}else{da=0;$=261;break a}break}default:{ea=ba;break b}}break}case 15:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 125:{Ta=f[c>>2]|0;Ua=f[g>>2]|0;$=184;break c;break}case 122:{if(DMa(c,H)|0){$=199;break c}else{da=0;$=261;break a}break}default:{ea=ba;break b}}break}case 16:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 133:{Va=f[c>>2]|0;Wa=f[g>>2]|0;$=207;break c;break}case 130:{if(DMa(c,L)|0){$=223;break c}else{da=0;$=261;break a}break}default:{ea=ba;break b}}break}case 17:{switch(ba|0){case 0:{da=1;$=261;break a;break}case 141:{Xa=f[c>>2]|0;Ya=f[g>>2]|0;$=232;break c;break}case 138:{if(DMa(c,O)|0){$=248;break c}else{da=0;$=261;break a}break}default:{ea=ba;break b}}break}default:{ca=ba;$=255;break b}}while(0);if(($|0)==21){$=0;f[j>>2]=f[j>>2]|2;if((la-ka|0)>3){a=ka;aa=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=aa;a=ka+4|0;f[c>>2]=a;Za=la;_a=aa;$a=a;ab=ja}else{if(!(Xnb(c,e)|0)){$=25;break a}a=f[g>>2]|0;Za=a;_a=f[e>>2]|0;$a=f[c>>2]|0;ab=a}f[l>>2]=_a;if($a>>>0>=ab>>>0)continue a;if((b[$a>>0]|0)==29){bb=$a;cb=Za;$=30}else continue a}d:while(1){switch($|0){case 30:{$=0;a=bb+1|0;f[c>>2]=a;ma=a;na=cb;$=31;continue d;break}case 31:{$=0;if((na-ma|0)>3){a=ma;aa=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=aa;f[c>>2]=ma+4;db=aa}else{if(!(Xnb(c,e)|0)){$=44;break a}db=f[e>>2]|0}aa=f[m>>2]|0;if((aa|0)==(f[n>>2]|0)){qza(m,aa+1|0);eb=f[m>>2]|0}else eb=aa;aa=f[o>>2]|0;a=eb+1|0;f[m>>2]=a;f[aa+4+(eb<<2)>>2]=db;X=f[c>>2]|0;V=(f[g>>2]|0)-X|0;if((V|0)<=0){$=46;continue d}W=(f[n>>2]|0)-a|0;fb=(V>>>0)/5|0;V=(fb|0)<(W|0)?fb:W;if((V|0)<=0){$=46;continue d}W=0;fb=X;X=a;while(1){if((b[fb>>0]|0)!=29){gb=W;break}a=fb+1|0;hb=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=X;X=X+1|0;f[m>>2]=X;f[aa+4+(a<<2)>>2]=hb;hb=W+1|0;if((hb|0)>=(V|0)){gb=hb;break}else{W=hb;fb=fb+5|0}}if((gb|0)<=0){$=46;continue d}Tnb(c,gb*5|0)|0;$=46;continue d;break}case 46:{$=0;fb=f[c>>2]|0;W=f[g>>2]|0;V=W;if(fb>>>0>=W>>>0)continue a;if((b[fb>>0]|0)==29){bb=fb;cb=V;$=30;continue d}if((b[fb>>0]|0)!=32)continue a;aa=fb+1|0;f[c>>2]=aa;oa=aa;pa=W;qa=V;$=52;continue d;break}case 52:{$=0;f[j>>2]=f[j>>2]|8;if(oa>>>0<pa>>>0?(V=b[oa>>0]|0,V<<24>>24>-1):0){W=oa+1|0;f[c>>2]=W;ib=V<<24>>24!=0;jb=W;kb=pa;lb=qa}else{Lnb(e,c);W=e;if(!(b[q>>0]|0)){da=0;$=261;break a}V=f[g>>2]|0;ib=(f[W>>2]|0)!=0|(f[W+4>>2]|0)!=0;jb=f[c>>2]|0;kb=V;lb=V}b[p>>0]=ib&1;if(jb>>>0>=kb>>>0)continue a;if((b[jb>>0]|0)!=40)continue a;V=jb+1|0;f[c>>2]=V;ra=V;sa=kb;ta=lb;$=62;continue d;break}case 62:{$=0;f[j>>2]=f[j>>2]|16;if(ra>>>0<sa>>>0?(V=b[ra>>0]|0,V<<24>>24>-1):0){W=ra+1|0;f[c>>2]=W;mb=V<<24>>24!=0;nb=W;ob=sa;pb=ta}else{Lnb(e,c);W=e;if(!(b[s>>0]|0)){da=0;$=261;break a}V=f[g>>2]|0;mb=(f[W>>2]|0)!=0|(f[W+4>>2]|0)!=0;nb=f[c>>2]|0;ob=V;pb=V}b[r>>0]=mb&1;if(nb>>>0>=ob>>>0)continue a;if((b[nb>>0]|0)==53){qb=nb;rb=pb;$=71}else continue a;break}case 72:{$=0;if((va-ua|0)>3){V=ua;W=h[V>>0]|h[V+1>>0]<<8|h[V+2>>0]<<16|h[V+3>>0]<<24;f[e>>2]=W;f[c>>2]=ua+4;sb=W}else{if(!(Xnb(c,e)|0)){$=85;break a}sb=f[e>>2]|0}W=f[t>>2]|0;if((W|0)==(f[v>>2]|0)){qza(t,W+1|0);tb=f[t>>2]|0}else tb=W;W=f[w>>2]|0;V=tb+1|0;f[t>>2]=V;f[W+4+(tb<<2)>>2]=sb;aa=f[c>>2]|0;fb=(f[g>>2]|0)-aa|0;if((fb|0)<=0){$=87;continue d}X=(f[v>>2]|0)-V|0;hb=(fb>>>0)/5|0;fb=(hb|0)<(X|0)?hb:X;if((fb|0)<=0){$=87;continue d}X=0;hb=aa;aa=V;while(1){if((b[hb>>0]|0)!=53){ub=X;break}V=hb+1|0;a=h[V>>0]|h[V+1>>0]<<8|h[V+2>>0]<<16|h[V+3>>0]<<24;V=aa;aa=aa+1|0;f[t>>2]=aa;f[W+4+(V<<2)>>2]=a;a=X+1|0;if((a|0)>=(fb|0)){ub=a;break}else{X=a;hb=hb+5|0}}if((ub|0)<=0){$=87;continue d}Tnb(c,ub*5|0)|0;$=87;continue d;break}case 87:{$=0;hb=f[c>>2]|0;X=f[g>>2]|0;fb=X;if(hb>>>0>=X>>>0)continue a;if((b[hb>>0]|0)==53){qb=hb;rb=fb;$=71}else{if((b[hb>>0]|0)!=56)continue a;W=hb+1|0;f[c>>2]=W;wa=W;xa=X;ya=fb;$=93;continue d}break}case 93:{$=0;f[j>>2]=f[j>>2]|64;if(wa>>>0<xa>>>0){fb=b[wa>>0]|0;X=fb&255;if(fb<<24>>24>-1){f[x>>2]=X;fb=wa+1|0;f[c>>2]=fb;vb=fb;wb=xa;xb=ya}else{yb=X;$=96}}else{yb=0;$=96}if(($|0)==96){$=0;X=Knb(c,yb)|0;fb=J;f[x>>2]=X;if(!((fb|0)>-1|(fb|0)==-1&X>>>0>4294967295)){da=0;$=261;break a}X=f[g>>2]|0;vb=f[c>>2]|0;wb=X;xb=X}if(vb>>>0>=wb>>>0)continue a;if((b[vb>>0]|0)!=64)continue a;X=vb+1|0;f[c>>2]=X;za=X;Aa=wb;Ba=xb;$=103;continue d;break}case 103:{$=0;f[j>>2]=f[j>>2]|128;if(za>>>0<Aa>>>0){X=b[za>>0]|0;fb=X&255;if(X<<24>>24>-1){f[y>>2]=fb;X=za+1|0;f[c>>2]=X;zb=X;Ab=Aa;Bb=Ba}else{Cb=fb;$=106}}else{Cb=0;$=106}if(($|0)==106){$=0;fb=Knb(c,Cb)|0;X=J;f[y>>2]=fb;if(!((X|0)>-1|(X|0)==-1&fb>>>0>4294967295)){da=0;$=261;break a}fb=f[g>>2]|0;zb=f[c>>2]|0;Ab=fb;Bb=fb}if(zb>>>0>=Ab>>>0)continue a;if((b[zb>>0]|0)!=72)continue a;fb=zb+1|0;f[c>>2]=fb;Ca=fb;Da=Ab;Ea=Bb;$=113;continue d;break}case 113:{$=0;f[j>>2]=f[j>>2]|256;if(Ca>>>0<Da>>>0){fb=b[Ca>>0]|0;X=fb&255;if(fb<<24>>24>-1){f[z>>2]=X;fb=Ca+1|0;f[c>>2]=fb;Db=fb;Eb=Da;Fb=Ea}else{Gb=X;$=116}}else{Gb=0;$=116}if(($|0)==116){$=0;X=Knb(c,Gb)|0;fb=J;f[z>>2]=X;if(!((fb|0)>-1|(fb|0)==-1&X>>>0>4294967295)){da=0;$=261;break a}X=f[g>>2]|0;Db=f[c>>2]|0;Eb=X;Fb=X}if(Db>>>0>=Eb>>>0)continue a;if((b[Db>>0]|0)!=85)continue a;X=Db+1|0;f[c>>2]=X;Fa=X;Ga=Fb;Ha=Eb;$=123;continue d;break}case 123:{$=0;f[j>>2]=f[j>>2]|512;if((Ga-Fa|0)>3){X=Fa;fb=h[X>>0]|h[X+1>>0]<<8|h[X+2>>0]<<16|h[X+3>>0]<<24;f[e>>2]=fb;X=Fa+4|0;f[c>>2]=X;Hb=fb;Ib=X;Jb=Ha;Kb=Ga}else{if(!(Xnb(c,e)|0)){$=127;break a}X=f[g>>2]|0;Hb=f[e>>2]|0;Ib=f[c>>2]|0;Jb=X;Kb=X}f[A>>2]=Hb;if(Ib>>>0>=Jb>>>0)continue a;if((b[Ib>>0]|0)!=93)continue a;X=Ib+1|0;f[c>>2]=X;Ia=X;Ja=Kb;Ka=Jb;$=133;continue d;break}case 133:{$=0;f[j>>2]=f[j>>2]|1024;if((Ja-Ia|0)>3){X=Ia;fb=h[X>>0]|h[X+1>>0]<<8|h[X+2>>0]<<16|h[X+3>>0]<<24;f[e>>2]=fb;X=Ia+4|0;f[c>>2]=X;Lb=fb;Mb=X;Nb=Ka;Ob=Ja}else{if(!(Xnb(c,e)|0)){$=137;break a}X=f[g>>2]|0;Lb=f[e>>2]|0;Mb=f[c>>2]|0;Nb=X;Ob=X}f[B>>2]=Lb;if(Mb>>>0>=Nb>>>0)continue a;if((b[Mb>>0]|0)!=101)continue a;X=Mb+1|0;f[c>>2]=X;La=X;Ma=Ob;Na=Nb;$=143;continue d;break}case 143:{$=0;f[j>>2]=f[j>>2]|2048;if((Ma-La|0)>3){X=La;fb=h[X>>0]|h[X+1>>0]<<8|h[X+2>>0]<<16|h[X+3>>0]<<24;f[e>>2]=fb;X=La+4|0;f[c>>2]=X;Pb=fb;Qb=X;Rb=Na;Sb=Ma}else{if(!(Xnb(c,e)|0)){$=147;break a}X=f[g>>2]|0;Pb=f[e>>2]|0;Qb=f[c>>2]|0;Rb=X;Sb=X}f[C>>2]=Pb;if(Qb>>>0>=Rb>>>0)continue a;if((b[Qb>>0]|0)!=109)continue a;X=Qb+1|0;f[c>>2]=X;Oa=X;Pa=Sb;Qa=Rb;$=153;continue d;break}case 153:{$=0;f[j>>2]=f[j>>2]|4096;if((Pa-Oa|0)>3){X=Oa;fb=h[X>>0]|h[X+1>>0]<<8|h[X+2>>0]<<16|h[X+3>>0]<<24;f[e>>2]=fb;X=Oa+4|0;f[c>>2]=X;Tb=fb;Ub=X;Vb=Qa;Wb=Pa}else{if(!(Xnb(c,e)|0)){$=157;break a}X=f[g>>2]|0;Tb=f[e>>2]|0;Ub=f[c>>2]|0;Vb=X;Wb=X}f[D>>2]=Tb;if(Ub>>>0>=Vb>>>0)continue a;if((b[Ub>>0]|0)==117){Xb=Ub;Yb=Wb;$=162}else continue a;break}case 163:{$=0;if((Sa-Ra|0)>3){X=Ra;fb=h[X>>0]|h[X+1>>0]<<8|h[X+2>>0]<<16|h[X+3>>0]<<24;f[e>>2]=fb;f[c>>2]=Ra+4;Zb=fb}else{if(!(Xnb(c,e)|0)){$=176;break a}Zb=f[e>>2]|0}fb=f[E>>2]|0;if((fb|0)==(f[F>>2]|0)){qza(E,fb+1|0);_b=f[E>>2]|0}else _b=fb;fb=f[G>>2]|0;X=_b+1|0;f[E>>2]=X;f[fb+4+(_b<<2)>>2]=Zb;W=f[c>>2]|0;hb=(f[g>>2]|0)-W|0;if((hb|0)<=0){$=178;continue d}aa=(f[F>>2]|0)-X|0;a=(hb>>>0)/5|0;hb=(a|0)<(aa|0)?a:aa;if((hb|0)<=0){$=178;continue d}aa=0;a=W;W=X;while(1){if((b[a>>0]|0)!=117){$b=aa;break}X=a+1|0;V=h[X>>0]|h[X+1>>0]<<8|h[X+2>>0]<<16|h[X+3>>0]<<24;X=W;W=W+1|0;f[E>>2]=W;f[fb+4+(X<<2)>>2]=V;V=aa+1|0;if((V|0)>=(hb|0)){$b=V;break}else{aa=V;a=a+5|0}}if(($b|0)<=0){$=178;continue d}Tnb(c,$b*5|0)|0;$=178;continue d;break}case 178:{$=0;a=f[c>>2]|0;aa=f[g>>2]|0;hb=aa;if(a>>>0>=aa>>>0)continue a;if((b[a>>0]|0)!=117)if((b[a>>0]|0)==125){ac=a;bc=hb;$=183}else continue a;else{Xb=a;Yb=hb;$=162}break}case 184:{$=0;if((Ua-Ta|0)>3){hb=Ta;a=h[hb>>0]|h[hb+1>>0]<<8|h[hb+2>>0]<<16|h[hb+3>>0]<<24;f[e>>2]=a;f[c>>2]=Ta+4;cc=a}else{if(!(Xnb(c,e)|0)){$=197;break a}cc=f[e>>2]|0}a=f[H>>2]|0;if((a|0)==(f[I>>2]|0)){qza(H,a+1|0);dc=f[H>>2]|0}else dc=a;a=f[K>>2]|0;hb=dc+1|0;f[H>>2]=hb;f[a+4+(dc<<2)>>2]=cc;aa=f[c>>2]|0;fb=(f[g>>2]|0)-aa|0;if((fb|0)<=0){$=199;continue d}W=(f[I>>2]|0)-hb|0;V=(fb>>>0)/5|0;fb=(V|0)<(W|0)?V:W;if((fb|0)<=0){$=199;continue d}W=0;V=aa;aa=hb;while(1){if((b[V>>0]|0)!=125){ec=W;break}hb=V+1|0;X=h[hb>>0]|h[hb+1>>0]<<8|h[hb+2>>0]<<16|h[hb+3>>0]<<24;hb=aa;aa=aa+1|0;f[H>>2]=aa;f[a+4+(hb<<2)>>2]=X;X=W+1|0;if((X|0)>=(fb|0)){ec=X;break}else{W=X;V=V+5|0}}if((ec|0)<=0){$=199;continue d}Tnb(c,ec*5|0)|0;$=199;continue d;break}case 199:{$=0;V=f[c>>2]|0;W=f[g>>2]|0;fb=W;a=V;if(V>>>0<W>>>0?(b[V>>0]|0)==125:0){ac=V;bc=fb;$=183;break}if((fb-a|0)<=1)continue a;if((b[V>>0]|0)!=-123)continue a;if((b[V+1>>0]|0)==1){fc=V;gc=fb;$=206}else continue a;break}case 207:{$=0;if((Wa-Va|0)>3){fb=Va;V=h[fb>>0]|h[fb+1>>0]<<8|h[fb+2>>0]<<16|h[fb+3>>0]<<24;f[e>>2]=V;f[c>>2]=Va+4;hc=V}else{if(!(Xnb(c,e)|0)){$=221;break a}hc=f[e>>2]|0}V=f[L>>2]|0;if((V|0)==(f[M>>2]|0)){qza(L,V+1|0);ic=f[L>>2]|0}else ic=V;V=f[N>>2]|0;fb=ic+1|0;f[L>>2]=fb;f[V+4+(ic<<2)>>2]=hc;a=f[c>>2]|0;W=(f[g>>2]|0)-a|0;if((W|0)<=0){$=223;continue d}aa=(f[M>>2]|0)-fb|0;X=(W>>>0)/6|0;W=(X|0)<(aa|0)?X:aa;if((W|0)<=0){$=223;continue d}aa=0;X=a;a=fb;while(1){if((b[X>>0]|0)!=-123){jc=aa;break}if((b[X+1>>0]|0)!=1){jc=aa;break}fb=X+2|0;hb=h[fb>>0]|h[fb+1>>0]<<8|h[fb+2>>0]<<16|h[fb+3>>0]<<24;fb=a;a=a+1|0;f[L>>2]=a;f[V+4+(fb<<2)>>2]=hb;hb=aa+1|0;if((hb|0)>=(W|0)){jc=hb;break}else{aa=hb;X=X+6|0}}if((jc|0)<=0){$=223;continue d}Tnb(c,jc*6|0)|0;$=223;continue d;break}case 223:{$=0;X=f[g>>2]|0;aa=f[c>>2]|0;W=aa;if((X-aa|0)<=1)continue a;aa=b[W>>0]|0;if(aa<<24>>24==-123){if((b[W+1>>0]|0)==1){fc=W;gc=X;$=206;break}kc=b[W>>0]|0}else kc=aa;if(kc<<24>>24!=-115)continue a;if((b[W+1>>0]|0)==1){lc=W;mc=X;$=231}else continue a;break}case 232:{$=0;if((Ya-Xa|0)>3){X=Xa;W=h[X>>0]|h[X+1>>0]<<8|h[X+2>>0]<<16|h[X+3>>0]<<24;f[e>>2]=W;f[c>>2]=Xa+4;nc=W}else{if(!(Xnb(c,e)|0)){$=246;break a}nc=f[e>>2]|0}W=f[O>>2]|0;if((W|0)==(f[P>>2]|0)){qza(O,W+1|0);oc=f[O>>2]|0}else oc=W;W=f[Q>>2]|0;X=oc+1|0;f[O>>2]=X;f[W+4+(oc<<2)>>2]=nc;aa=f[c>>2]|0;V=(f[g>>2]|0)-aa|0;if((V|0)<=0){$=248;continue d}a=(f[P>>2]|0)-X|0;hb=(V>>>0)/6|0;V=(hb|0)<(a|0)?hb:a;if((V|0)<=0){$=248;continue d}a=0;hb=aa;aa=X;while(1){if((b[hb>>0]|0)!=-115){pc=a;break}if((b[hb+1>>0]|0)!=1){pc=a;break}X=hb+2|0;fb=h[X>>0]|h[X+1>>0]<<8|h[X+2>>0]<<16|h[X+3>>0]<<24;X=aa;aa=aa+1|0;f[O>>2]=aa;f[W+4+(X<<2)>>2]=fb;fb=a+1|0;if((fb|0)>=(V|0)){pc=fb;break}else{a=fb;hb=hb+6|0}}if((pc|0)<=0){$=248;continue d}Tnb(c,pc*6|0)|0;$=248;continue d;break}case 248:{$=0;hb=f[g>>2]|0;a=f[c>>2]|0;qc=a;rc=hb;if((hb-a|0)<=1)break d;if((b[qc>>0]|0)!=-115)break d;if((b[qc+1>>0]|0)==1){lc=qc;mc=hb;$=231}else break d;break}}if(($|0)==71){$=0;hb=qb+1|0;f[c>>2]=hb;ua=hb;va=rb;$=72;continue}else if(($|0)==162){$=0;hb=Xb+1|0;f[c>>2]=hb;Ra=hb;Sa=Yb;$=163;continue}else if(($|0)==183){$=0;hb=ac+1|0;f[c>>2]=hb;Ta=hb;Ua=bc;$=184;continue}else if(($|0)==206){$=0;hb=fc+2|0;f[c>>2]=hb;Va=hb;Wa=gc;$=207;continue}else if(($|0)==231){$=0;hb=lc+2|0;f[c>>2]=hb;Xa=hb;Ya=mc;$=232;continue}}if((qc|0)!=(rc|0))continue a;if(f[R>>2]|0){$=254;break a}if((f[S>>2]|0)==(f[T>>2]|0)){$=254;break a}else continue a}while(0);if(($|0)==255){$=0;if(!ca){da=1;$=261;break}else ea=ca}if((ea&7|0)==4){da=1;$=261;break}hb=f[U>>2]|0;if(!(hb&1))sc=hBa(U)|0;else sc=hb&-2;if(!(ZPb(c,ea,sc)|0)){da=0;$=261;break}}switch($|0){case 15:{da=0;u=d;return da|0}case 25:{da=0;u=d;return da|0}case 44:{da=0;u=d;return da|0}case 85:{da=0;u=d;return da|0}case 127:{da=0;u=d;return da|0}case 137:{da=0;u=d;return da|0}case 147:{da=0;u=d;return da|0}case 157:{da=0;u=d;return da|0}case 176:{da=0;u=d;return da|0}case 197:{da=0;u=d;return da|0}case 221:{da=0;u=d;return da|0}case 246:{da=0;u=d;return da|0}case 254:{f[i>>2]=0;b[c+24>>0]=1;da=1;u=d;return da|0}case 261:{u=d;return da|0}}return 0}function a4a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(!(d&255))e=d;else{g=a+24|0;f[g>>2]=0;f[g+4>>2]=0;b[g+8>>0]=0;b[a+48>>0]=1;if(d&8|0?(d=f[a+16>>2]|0,d|0):0){g=d+8|0;if(f[g>>2]&7|0){n[d+20>>2]=.30000001192092896;f[d+16>>2]=0;n[d+24>>2]=1.0}f[g>>2]=0;g=f[d+4>>2]|0;if(g&1|0?(d=g&-2,f[d>>2]|0):0)GPb(d)}d=f[c>>2]|0;if((d&16|0)!=0?(g=f[a+20>>2]|0,(g|0)!=0):0){y$a(g);h=f[c>>2]|0}else h=d;f[a+44>>2]=1;f[a+40>>2]=-1;e=h}if(e&768|0){n[a+36>>2]=0.0;b[a+49>>0]=1}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function b4a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(d&15|0){b[a+20>>0]=1;if(d&2|0?(d=f[a+16>>2]|0,d|0):0){e=d+8|0;g=f[e>>2]|0;if(g&255|0){h=d+20|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if(g&1|0?(g=f[213028]|0,h=f[d+16>>2]|0,(h|0)!=(g|0)):0)_5b(h,g)|0;n[d+40>>2]=1.0;n[d+44>>2]=1.0;f[d+36>>2]=-1}f[e>>2]=0;e=f[d+4>>2]|0;if(e&1|0?(d=e&-2,f[d>>2]|0):0)GPb(d)}b[a+21>>0]=1;n[a+24>>2]=1.000000013351432e-10}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function c4a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=112860;e=a+4|0;g=(a|0)==494168;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;e=a+24|0;h=e+120|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(h|0));if(!g?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+20>>2]=0;f[a+144>>2]=497760;f[a+148>>2]=497760;Nac(a+152|0,0,220)|0;u=c;return}function d4a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function e4a(a){a=a|0;var c=0,d=0;c=a+144|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+148|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)==494168)return;c=f[a+152>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+156>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+160>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+164>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+168>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+172>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+176>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+180>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+184>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+188>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+192>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+196>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+200>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+204>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+208>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+212>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+216>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+220>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+224>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+228>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+232>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+236>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+240>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+244>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+248>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+252>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+256>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+260>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+264>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+268>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+272>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+276>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+280>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+284>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+288>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+292>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+296>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+300>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+304>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+308>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+312>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+316>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+320>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+324>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+328>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+332>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+336>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+340>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+344>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+348>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+352>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+356>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+360>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+364>>2]|0;if(!c)return;bi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function f4a(a){a=a|0;var c=0,d=0;f[a>>2]=112752;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(d);f[c>>2]=0;return}function g4a(a){a=a|0;f4a(a);O5b(a);return}function h4a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function i4a(a,b){a=a|0;b=b|0;a=L5b(32)|0;t4a(a);if(!b)return a|0;u4a(b,a);return a|0}function j4a(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(d&15|0){do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);f[a+20>>2]=0;n[a+24>>2]=1.0;n[a+28>>2]=1.0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function k4a(a){a=a|0;return 1}function l4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{$pb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{Zpb(2,f[a+20>>2]|0,b);g=f[c>>2]|0}if(!(g&4))h=g;else{Wpb(3,+n[a+24>>2],b);h=f[c>>2]|0}if(h&8|0)Wpb(4,+n[a+28>>2],b);h=f[a+4>>2]|0;if(!(h&1))return;aQb(h&-2,b);return}function m4a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function n4a(a){a=a|0;return f[a+12>>2]|0}function o4a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}do if(!(h&2))j=g;else{i=f[a+20>>2]|0;b[g>>0]=16;d=g+1|0;if((i|0)<0){j=hob(i,((i|0)<0)<<31>>31,d)|0;break}if(i>>>0>127){e=i;k=d;while(1){b[k>>0]=e|128;l=e>>>7;m=k+1|0;if(e>>>0>16383){e=l;k=m}else{n=m;o=l;break}}}else{n=d;o=i}b[n>>0]=o;j=n+1|0}while(0);n=f[c>>2]|0;if(!(n&4)){p=j;q=n}else{n=f[a+24>>2]|0;b[j>>0]=29;o=j+1|0;b[o>>0]=n;b[o+1>>0]=n>>8;b[o+2>>0]=n>>16;b[o+3>>0]=n>>24;p=j+5|0;q=f[c>>2]|0}if(!(q&8))r=p;else{q=f[a+28>>2]|0;b[p>>0]=37;c=p+1|0;b[c>>0]=q;b[c+1>>0]=q>>8;b[c+2>>0]=q>>16;b[c+3>>0]=q>>24;r=p+5|0}p=f[a+4>>2]|0;if(!(p&1)){s=r;return s|0}s=bQb(p&-2,r)|0;return s|0}function p4a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function q4a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(15323);c=T6b(b,23288,19688,0)|0;if(!c){cOb(b,a);return}else{S3a(a,c);return}}function r4a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function s4a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213069];f[a+4>>2]=f[213070];u=c;return}function t4a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=112752;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=494128?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=497760;f[a+20>>2]=0;n[a+24>>2]=1.0;n[a+28>>2]=1.0;u=c;return}function u4a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function v4a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;f[a>>2]=112644;c=a+44|0;d=f[c>>2]|0;if(d|0?(f[a+32>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);O5b(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=a+28|0;i=f[c>>2]|0;if(i|0?(f[a+16>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0){if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);O5b(g)}e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;O5b(j)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}j=a&-2;a=j;if((j|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(j);f[c>>2]=0;return}function w4a(a){a=a|0;v4a(a);O5b(a);return}function x4a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function y4a(a,b){a=a|0;b=b|0;a=L5b(60)|0;J4a(a);if(!b)return a|0;K4a(b,a);return a|0}function z4a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+48|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;c=a+20|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+28>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+36|0;d=f[c>>2]|0;if((d|0)>0){g=f[a+44>>2]|0;e=0;do{i=f[g+4+(e<<2)>>2]|0;e=e+1|0;h=i+11|0;if((b[h>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[h>>0]=0}}while((e|0)!=(d|0));f[c>>2]=0}f[a+8>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function A4a(a){a=a|0;return 1}function B4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Zpb(1,f[a+48>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{Mpb(2,f[a+52>>2]|0,b);g=f[c>>2]|0}if(g&4|0)Mpb(3,f[a+56>>2]|0,b);g=a+20|0;if((f[g>>2]|0)>0){c=a+28|0;e=0;do{_pb(4,f[(f[c>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)<(f[g>>2]|0))}g=a+36|0;if((f[g>>2]|0)>0){e=a+44|0;c=0;do{_pb(5,f[(f[e>>2]|0)+4+(c<<2)>>2]|0,b);c=c+1|0}while((c|0)<(f[g>>2]|0))}g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,b);return}function C4a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function D4a(a){a=a|0;return f[a+12>>2]|0}function E4a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+48>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);do if(!(f[c>>2]&2))o=e;else{m=f[a+52>>2]|0;b[e>>0]=16;n=e+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){d=m;j=n;while(1){b[j>>0]=d|128;i=d>>>7;k=j+1|0;if(d>>>0>16383){d=i;j=k}else{p=k;q=i;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}while(0);do if(!(f[c>>2]&4))r=o;else{p=f[a+56>>2]|0;b[o>>0]=24;q=o+1|0;if((p|0)<0){r=hob(p,((p|0)<0)<<31>>31,q)|0;break}if(p>>>0>127){e=p;j=q;while(1){b[j>>0]=e|128;d=e>>>7;g=j+1|0;if(e>>>0>16383){e=d;j=g}else{s=g;t=d;break}}}else{s=q;t=p}b[s>>0]=t;r=s+1|0}while(0);s=a+20|0;if((f[s>>2]|0)>0){t=a+28|0;o=0;c=r;while(1){j=f[(f[t>>2]|0)+4+(o<<2)>>2]|0;b[c>>0]=34;e=kob(j,c+1|0)|0;o=o+1|0;if((o|0)>=(f[s>>2]|0)){u=e;break}else c=e}}else u=r;r=a+36|0;if((f[r>>2]|0)>0){c=a+44|0;s=0;o=u;while(1){t=f[(f[c>>2]|0)+4+(s<<2)>>2]|0;b[o>>0]=42;e=kob(t,o+1|0)|0;s=s+1|0;if((s|0)>=(f[r>>2]|0)){v=e;break}else o=e}}else v=u;u=f[a+4>>2]|0;if(!(u&1)){w=v;return w|0}w=bQb(u&-2,v)|0;return w|0}function F4a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function G4a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(14725);c=T6b(b,23288,19704,0)|0;if(!c){cOb(b,a);return}else{DPa(a,c);return}}function H4a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function I4a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213067];f[a+4>>2]=f[213068];u=c;return}function J4a(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=112644;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;if((a|0)!=494056?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;u=c;return}function K4a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function L4a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=112536;c=a+28|0;d=f[c>>2]|0;if(d|0?(f[a+16>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);O5b(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(i);f[c>>2]=0;return}function M4a(a){a=a|0;L4a(a);O5b(a);return}function N4a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function O4a(a,b){a=a|0;b=b|0;a=L5b(40)|0;$4a(a);if(!b)return a|0;a5a(b,a);return a|0}function P4a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;if(f[c>>2]&3|0){f[a+36>>2]=1;f[a+32>>2]=0}d=a+20|0;e=f[d>>2]|0;if((e|0)>0){g=f[a+28>>2]|0;h=0;do{i=f[g+4+(h<<2)>>2]|0;h=h+1|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[j>>0]=0}}while((h|0)!=(e|0));f[d>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function Q4a(a){a=a|0;return 1}function R4a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=c+4|0;e=c+20|0;g=a+4|0;h=a+8|0;i=a+36|0;j=a+32|0;k=a+16|0;a=c+32|0;l=c+12|0;m=c+28|0;a:while(1){b:while(1){n=f[c>>2]|0;if(n>>>0<(f[d>>2]|0)>>>0){o=b[n>>0]|0;p=o&255;if(o<<24>>24>0){f[e>>2]=p;f[c>>2]=n+1;q=p;r=7}else{s=p;r=6}}else{s=0;r=6}if((r|0)==6){r=0;p=_nb(c,s)|0;f[e>>2]=p;if((p+-1|0)>>>0<127){q=p;r=7}else{t=p;r=40}}c:do if((r|0)==7){r=0;switch(q>>>3&536870911|0){case 1:{switch(q|0){case 0:{u=1;r=46;break a;break}case 8:{r=9;break b;break}default:{v=q;break c}}break}case 2:{switch(q|0){case 0:{u=1;r=46;break a;break}case 16:{r=23;break b;break}default:{v=q;break c}}break}case 3:{switch(q|0){case 0:{u=1;r=46;break a;break}case 26:{break b;break}default:{v=q;break c}}break}default:{t=q;r=40;break c}}}while(0);if((r|0)==40){r=0;if(!t){u=1;r=46;break a}else v=t}if((v&7|0)==4){u=1;r=46;break a}p=f[g>>2]|0;if(!(p&1))w=hBa(g)|0;else w=p&-2;if(!(ZPb(c,v,w)|0)){u=0;r=46;break a}}if((r|0)==9){r=0;p=f[c>>2]|0;if(p>>>0<(f[d>>2]|0)>>>0){n=b[p>>0]|0;o=n&255;if(n<<24>>24>-1){f[c>>2]=p+1;x=o}else{y=o;r=12}}else{y=0;r=12}if((r|0)==12){r=0;o=Knb(c,y)|0;p=J;if((p|0)>-1|(p|0)==-1&o>>>0>4294967295)x=o;else{u=0;r=46;break}}if(x>>>0<2){f[h>>2]=f[h>>2]|1;f[i>>2]=x}else{o=f[g>>2]|0;if(!(o&1))z=hBa(g)|0;else z=o&-2;NPb(z,1,x,((x|0)<0)<<31>>31)}o=f[c>>2]|0;p=f[d>>2]|0;if(o>>>0>=p>>>0)continue;if((b[o>>0]|0)!=16)continue;n=o+1|0;f[c>>2]=n;A=n;B=p;r=24}else if((r|0)==23){r=0;A=f[c>>2]|0;B=f[d>>2]|0;r=24}if((r|0)==24){r=0;f[h>>2]=f[h>>2]|2;if(A>>>0<B>>>0){p=b[A>>0]|0;n=p&255;if(p<<24>>24>-1){p=A+1|0;f[c>>2]=p;C=n;D=p;E=B}else{F=n;r=27}}else{F=0;r=27}if((r|0)==27){r=0;n=Knb(c,F)|0;p=J;if(!((p|0)>-1|(p|0)==-1&n>>>0>4294967295)){u=0;r=46;break}C=n;D=f[c>>2]|0;E=f[d>>2]|0}f[j>>2]=C;if(D>>>0>=E>>>0)continue;if((b[D>>0]|0)==26){G=D;r=32}else continue}while(1){if((r|0)==32){r=0;f[c>>2]=G+1}if(!(fqb(c,mza(k)|0)|0)){u=0;r=46;break a}G=f[c>>2]|0;H=f[d>>2]|0;if(G>>>0>=H>>>0)break;if((b[G>>0]|0)!=26)break;else r=32}if((G|0)!=(H|0))continue;if(f[a>>2]|0){r=39;break}if((f[l>>2]|0)==(f[m>>2]|0)){r=39;break}}if((r|0)==39){f[e>>2]=0;b[c+24>>0]=1;u=1;return u|0}else if((r|0)==46)return u|0;return 0}function S4a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+8|0;d=f[c>>2]|0;if(d&3){if(d&1){e=f[a+36>>2]|0;if((e|0)>=0)if(e>>>0<128){g=2;h=d}else{i=(iob(e)|0)+1|0;g=i;h=f[c>>2]|0}else{g=11;h=d}}else{g=0;h=d}if(!(h&2))j=g;else{h=f[a+32>>2]|0;if((h|0)>=0)if(h>>>0<128)k=2;else k=(iob(h)|0)+1|0;else k=11;j=k+g|0}}else j=0;g=a+20|0;k=f[g>>2]|0;h=k+j|0;if((k|0)>0){j=a+28|0;d=0;c=h;i=k;while(1){k=f[(f[j>>2]|0)+4+(d<<2)>>2]|0;e=b[k+11>>0]|0;if(e<<24>>24<0){l=f[k+4>>2]|0;if(l>>>0<128){m=1;n=l;o=i}else{k=iob(l)|0;m=k;n=l;o=f[g>>2]|0}}else{m=1;n=e&255;o=i}e=n+c+m|0;d=d+1|0;if((d|0)>=(o|0)){p=e;break}else{c=e;i=o}}}else p=h;h=f[a+4>>2]|0;if(!(h&1)){q=p;r=a+12|0;f[r>>2]=q;return q|0}q=(dQb(h&-2)|0)+p|0;r=a+12|0;f[r>>2]=q;return q|0}function T4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Zpb(1,f[a+36>>2]|0,b);e=f[c>>2]|0}if(e&2|0)Mpb(2,f[a+32>>2]|0,b);e=a+20|0;if((f[e>>2]|0)>0){c=a+28|0;d=0;do{_pb(3,f[(f[c>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)<(f[e>>2]|0))}e=f[a+4>>2]|0;if(!(e&1))return;aQb(e&-2,b);return}function U4a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function V4a(a){a=a|0;return f[a+12>>2]|0}function W4a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+36>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);do if(!(f[c>>2]&2))o=e;else{m=f[a+32>>2]|0;b[e>>0]=16;n=e+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){d=m;j=n;while(1){b[j>>0]=d|128;i=d>>>7;k=j+1|0;if(d>>>0>16383){d=i;j=k}else{p=k;q=i;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}while(0);p=a+20|0;if((f[p>>2]|0)>0){q=a+28|0;e=0;c=o;while(1){j=f[(f[q>>2]|0)+4+(e<<2)>>2]|0;b[c>>0]=26;d=kob(j,c+1|0)|0;e=e+1|0;if((e|0)>=(f[p>>2]|0)){r=d;break}else c=d}}else r=o;o=f[a+4>>2]|0;if(!(o&1)){s=r;return s|0}s=bQb(o&-2,r)|0;return s|0}function X4a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Y4a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))jMa(14167);c=T6b(b,23288,19720,0)|0;if(!c){cOb(b,a);return}UDa(a+16|0,c+16|0);b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+36>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+36>>2]=d;e=f[b>>2]|0}if(e&2|0){e=f[c+32>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|2;f[a+32>>2]=e}}e=f[c+4>>2]|0;if(!(e&1))return;LPb(e&-2,a+4|0);return}function Z4a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function _4a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213065];f[a+4>>2]=f[213066];u=c;return}function $4a(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=112536;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=494008?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+32>>2]=0;f[a+36>>2]=1;u=c;return}function a5a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function b5a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=112428;c=a+32|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+28|0;d=f[c>>2]|0;if(d|0?(f[a+16>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)bi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(i);f[c>>2]=0;return}function c5a(a){a=a|0;b5a(a);O5b(a);return}function d5a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function e5a(a,b){a=a|0;b=b|0;a=L5b(44)|0;s5a(a);if(!b)return a|0;t5a(b,a);return a|0}function f5a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+8|0;d=f[c>>2]|0;do if((d&11|0?(e=a+36|0,f[e>>2]=0,f[e+4>>2]=0,d&2|0):0)?(e=f[a+32>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);d=a+20|0;g=f[d>>2]|0;if((g|0)>0){e=f[a+28>>2]|0;h=0;do{i=f[e+4+(h<<2)>>2]|0;h=h+1|0;bi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((h|0)!=(g|0));f[d>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function g5a(a){a=a|0;return 1}function h5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+36|0;i=a+32|0;j=c+44|0;k=a+16|0;l=a+28|0;m=a+24|0;n=a+20|0;o=a+40|0;p=c+32|0;q=c+12|0;r=c+28|0;s=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){t=b[a>>0]|0;u=t&255;if(t<<24>>24>0){f[e>>2]=u;f[c>>2]=a+1;v=u;w=6}else{x=u;w=5}}else{x=0;w=5}if((w|0)==5){w=0;u=_nb(c,x)|0;f[e>>2]=u;if((u+-1|0)>>>0<127){v=u;w=6}else{y=u;w=51}}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 1:{switch(v|0){case 0:{z=1;w=57;break a;break}case 8:break;default:{A=v;break b}}f[g>>2]=f[g>>2]|1;u=f[c>>2]|0;a=f[d>>2]|0;if(u>>>0<a>>>0){t=b[u>>0]|0;B=t&255;if(t<<24>>24>-1){t=u+1|0;f[c>>2]=t;C=B;D=t;E=a}else{F=B;w=11}}else{F=0;w=11}if((w|0)==11){w=0;B=Knb(c,F)|0;a=J;if(!((a|0)>-1|(a|0)==-1&B>>>0>4294967295)){z=0;w=57;break a}C=B;D=f[c>>2]|0;E=f[d>>2]|0}f[h>>2]=C;if(D>>>0>=E>>>0)continue a;if((b[D>>0]|0)!=18)continue a;f[c>>2]=D+1;w=17;break}case 2:{switch(v|0){case 0:{z=1;w=57;break a;break}case 18:{w=17;break}default:{A=v;break b}}break}case 3:{switch(v|0){case 0:{z=1;w=57;break a;break}case 26:{w=24;break}default:{A=v;break b}}break}case 4:{switch(v|0){case 0:{z=1;w=57;break a;break}case 32:break;default:{A=v;break b}}G=f[c>>2]|0;H=f[d>>2]|0;break}default:{y=v;w=51;break b}}if((w|0)==17){w=0;f[g>>2]=f[g>>2]|2;B=f[i>>2]|0;if((B|0)==497760){jza(i,497760);I=f[i>>2]|0}else I=B;if(!(fqb(c,I)|0)){z=0;w=57;break a}B=f[c>>2]|0;if(B>>>0>=(f[d>>2]|0)>>>0)continue a;if((b[B>>0]|0)!=26)continue a;f[c>>2]=B+1;w=24}if((w|0)==24){w=0;B=f[j>>2]|0;f[j>>2]=B+-1;if((B|0)<=0){z=0;w=57;break a}while(1){B=f[l>>2]|0;do if(B){a=f[n>>2]|0;t=f[B>>2]|0;if((a|0)>=(t|0))if((t|0)==(f[m>>2]|0)){K=t;w=30;break}else{L=t;M=B;w=31;break}else{f[n>>2]=a+1;N=f[B+4+(a<<2)>>2]|0;break}}else{K=f[m>>2]|0;w=30}while(0);if((w|0)==30){w=0;cpb(k,K+1|0);B=f[l>>2]|0;L=f[B>>2]|0;M=B;w=31}if((w|0)==31){w=0;f[M>>2]=L+1;B=pza(0,f[k>>2]|0)|0;a=f[l>>2]|0;t=f[n>>2]|0;f[n>>2]=t+1;f[a+4+(t<<2)>>2]=B;N=B}B=Jnb(c)|0;if(!(hOa(N,c)|0)){z=0;w=57;break a}if(!(Pnb(c,B)|0)){z=0;w=57;break a}O=f[c>>2]|0;P=f[d>>2]|0;if(O>>>0>=P>>>0){w=35;break}if((b[O>>0]|0)!=26)break;f[c>>2]=O+1}if((w|0)==35){w=0;f[j>>2]=(f[j>>2]|0)+1;continue a}f[j>>2]=(f[j>>2]|0)+1;if((b[O>>0]|0)!=32)continue a;B=O+1|0;f[c>>2]=B;G=B;H=P}f[g>>2]=f[g>>2]|8;if(G>>>0<H>>>0){B=b[G>>0]|0;t=B&255;if(B<<24>>24>-1){B=G+1|0;f[c>>2]=B;Q=t;R=B;S=H}else{T=t;w=45}}else{T=0;w=45}if((w|0)==45){w=0;t=Knb(c,T)|0;B=J;if(!((B|0)>-1|(B|0)==-1&t>>>0>4294967295)){z=0;w=57;break a}Q=t;R=f[c>>2]|0;S=f[d>>2]|0}f[o>>2]=Q;if((R|0)!=(S|0))continue a;if(f[p>>2]|0){w=50;break a}if((f[q>>2]|0)==(f[r>>2]|0)){w=50;break a}else continue a}while(0);if((w|0)==51){w=0;if(!y){z=1;w=57;break}else A=y}if((A&7|0)==4){z=1;w=57;break}t=f[s>>2]|0;if(!(t&1))U=hBa(s)|0;else U=t&-2;if(!(ZPb(c,A,U)|0)){z=0;w=57;break}}if((w|0)==50){f[e>>2]=0;b[c+24>>0]=1;z=1;return z|0}else if((w|0)==57)return z|0;return 0}function i5a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+8|0;d=f[c>>2]|0;if(d&11){if(d&1){e=f[a+36>>2]|0;if((e|0)>=0)if(e>>>0<128){g=2;h=d}else{i=(iob(e)|0)+1|0;g=i;h=f[c>>2]|0}else{g=11;h=d}}else{g=0;h=d}if(!(h&2)){j=g;k=h}else{d=f[a+32>>2]|0;i=b[d+11>>0]|0;if(i<<24>>24<0){e=f[d+4>>2]|0;if(e>>>0<128){l=1;m=h;n=e}else{d=iob(e)|0;l=d;m=f[c>>2]|0;n=e}}else{l=1;m=h;n=i&255}j=g+1+n+l|0;k=m}if(!(k&8))o=j;else{k=f[a+40>>2]|0;if((k|0)>=0)if(k>>>0<128)p=2;else p=(iob(k)|0)+1|0;else p=11;o=p+j|0}}else o=0;j=f[a+20>>2]|0;p=j+o|0;if(!j)q=p;else{o=a+28|0;k=0;m=p;while(1){p=gOa(f[(f[o>>2]|0)+4+(k<<2)>>2]|0)|0;if(p>>>0<128)r=1;else r=iob(p)|0;l=p+m+r|0;k=k+1|0;if((k|0)==(j|0)){q=l;break}else m=l}}m=f[a+4>>2]|0;if(!(m&1)){s=q;t=a+12|0;f[t>>2]=s;return s|0}s=(dQb(m&-2)|0)+q|0;t=a+12|0;f[t>>2]=s;return s|0}function j5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Mpb(1,f[a+36>>2]|0,b);e=f[c>>2]|0}if(e&2|0)$pb(2,f[a+32>>2]|0,b);e=f[a+20>>2]|0;if(e|0){d=a+28|0;g=0;do{eqb(3,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(e|0))}if(f[c>>2]&8|0)Mpb(4,f[a+40>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function k5a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function l5a(a){a=a|0;return f[a+12>>2]|0}function m5a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+36>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);if(!(f[c>>2]&2))o=e;else{m=f[a+32>>2]|0;b[e>>0]=18;o=kob(m,e+1|0)|0}e=f[a+20>>2]|0;if(!e)p=o;else{m=a+28|0;n=0;d=o;while(1){o=f[(f[m>>2]|0)+4+(n<<2)>>2]|0;b[d>>0]=26;j=d+1|0;i=f[o+12>>2]|0;if(i>>>0>127){k=i;l=j;while(1){b[l>>0]=k|128;q=k>>>7;r=l+1|0;if(k>>>0>16383){k=q;l=r}else{s=r;t=q;break}}}else{s=j;t=i}b[s>>0]=t;l=li[f[(f[o>>2]|0)+68>>2]&511](o,0,s+1|0)|0;n=n+1|0;if((n|0)==(e|0)){p=l;break}else d=l}}do if(!(f[c>>2]&8))u=p;else{d=f[a+40>>2]|0;b[p>>0]=32;e=p+1|0;if((d|0)<0){u=hob(d,((d|0)<0)<<31>>31,e)|0;break}if(d>>>0>127){n=d;s=e;while(1){b[s>>0]=n|128;t=n>>>7;m=s+1|0;if(n>>>0>16383){n=t;s=m}else{v=m;w=t;break}}}else{v=e;w=d}b[v>>0]=w;u=v+1|0}while(0);v=f[a+4>>2]|0;if(!(v&1)){x=u;return x|0}x=bQb(v&-2,u)|0;return x|0}function n5a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function o5a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(13675);c=T6b(b,23288,19736,0)|0;if(!c){cOb(b,a);return}else{r5a(a,c);return}}function p5a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function q5a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213063];f[a+4>>2]=f[213064];u=c;return}function r5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c+4|0;e=c;bOa(a+16|0,b+16|0);g=b+8|0;h=f[g>>2]|0;if(h&255|0){if(!(h&1))i=h;else{h=f[b+36>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|1;f[a+36>>2]=h;i=f[g>>2]|0}if(!(i&2))k=i;else{i=a+8|0;f[i>>2]=f[i>>2]|2;f[e>>2]=f[b+32>>2];f[d>>2]=f[e>>2];Anb(a+32|0,497760,d);k=f[g>>2]|0}if(k&8|0){k=f[b+40>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|8;f[a+40>>2]=k}}k=f[b+4>>2]|0;if(!(k&1)){u=c;return}LPb(k&-2,a+4|0);u=c;return}function s5a(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=112428;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=493952?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+32>>2]=497760;d=a+36|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function t5a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function u5a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=112320;f6a(a);c=f[a+84>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=f[a+72>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=a+60|0;d=f[c>>2]|0;if(d|0?(f[a+48>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)bi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=a+44|0;i=f[c>>2]|0;if(i|0?(f[a+32>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;O5b(j)}f[c>>2]=0;c=a+28|0;j=f[c>>2]|0;if(j|0?(f[a+16>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0){if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);O5b(e)}d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;O5b(k)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}k=a&-2;a=k;if((k|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(k);f[c>>2]=0;return}function v5a(a){a=a|0;u5a(a);O5b(a);return}function w5a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function x5a(a,b){a=a|0;b=b|0;a=L5b(232)|0;d6a(a);if(!b)return a|0;e6a(b,a);return a|0}function y5a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;if(d&87|0){e=a+8|0;do if(d&1|0?(g=f[a+88>>2]|0,(g|0)!=497760):0){h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);d=f[e>>2]|0;if((d&2|0)!=0?(h=f[a+112>>2]|0,(h|0)!=0):0){c6a(h);i=f[e>>2]|0}else i=d;do if(i&4|0?(d=f[a+92>>2]|0,(d|0)!=497760):0){h=d+11|0;if((b[h>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;break}else{b[d>>0]=0;b[h>>0]=0;break}}while(0);i=f[e>>2]|0;if((i&16|0)!=0?(h=f[a+116>>2]|0,(h|0)!=0):0){c6a(h);j=f[e>>2]|0}else j=i;if(j&64|0?(j=f[a+120>>2]|0,j|0):0){i=j+8|0;if(f[i>>2]&3|0){f[j+36>>2]=1;f[j+32>>2]=0}e=j+20|0;h=f[e>>2]|0;if((h|0)>0){d=f[j+28>>2]|0;g=0;do{k=f[d+4+(g<<2)>>2]|0;g=g+1|0;l=k+11|0;if((b[l>>0]|0)<0){b[f[k>>2]>>0]=0;f[k+4>>2]=0}else{b[k>>0]=0;b[l>>0]=0}}while((g|0)!=(h|0));f[e>>2]=0}f[i>>2]=0;i=f[j+4>>2]|0;if(i&1|0?(j=i&-2,f[j>>2]|0):0)GPb(j)}}j=f[c>>2]|0;if(j&65024|0){i=a+124|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;b[a+160>>0]=0;b[a+188>>0]=1;f[a+180>>2]=1}if(j&16711680){i=a+140|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[a+184>>2]=1;i=a+8|0;do if(j&131072|0?(e=f[a+96>>2]|0,(e|0)!=497760):0){h=e+11|0;if((b[h>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[h>>0]=0;break}}while(0);h=f[i>>2]|0;if((h&4194304|0)!=0?(i=f[213029]|0,e=f[a+100>>2]|0,(e|0)!=(i|0)):0){_5b(e,i)|0;m=f[c>>2]|0}else m=h}else m=j;if(m>>>0>33554431){j=a+164|0;f[j>>2]=0;f[j+4>>2]=0;n[a+192>>2]=-1.0;do if(m&134217728|0?(j=f[a+104>>2]|0,(j|0)!=497760):0){h=j+11|0;if((b[h>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0;break}else{b[j>>0]=0;b[h>>0]=0;break}}while(0);b[a+161>>0]=0;f[a+196>>2]=1;f[a+200>>2]=1}m=f[a+12>>2]|0;if(m&255|0){h=a+208|0;f[h>>2]=-1;f[h+4>>2]=-1;if(m&2|0?(m=f[213030]|0,h=f[a+108>>2]|0,(h|0)!=(m|0)):0)_5b(h,m)|0;n[a+216>>2]=9.99999993922529e-09;n[a+220>>2]=.9990000128746033;n[a+176>>2]=.9900000095367432;b[a+162>>0]=0;b[a+189>>0]=1;f[a+172>>2]=0}m=a+20|0;h=f[m>>2]|0;if((h|0)>0){j=f[a+28>>2]|0;i=0;do{e=f[j+4+(i<<2)>>2]|0;i=i+1|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0}else{b[e>>0]=0;b[g>>0]=0}}while((i|0)!=(h|0));f[m>>2]=0}m=a+36|0;h=f[m>>2]|0;if((h|0)>0){i=f[a+44>>2]|0;j=0;do{g=f[i+4+(j<<2)>>2]|0;j=j+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((j|0)!=(h|0));f[m>>2]=0}m=a+52|0;h=f[m>>2]|0;if((h|0)>0){j=f[a+60>>2]|0;i=0;do{g=f[j+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((i|0)!=(h|0));f[m>>2]=0}f[a+64>>2]=0;f[a+76>>2]=0;m=c;f[m>>2]=0;f[m+4>>2]=0;m=f[a+4>>2]|0;if(!(m&1))return;a=m&-2;if(!(f[a>>2]|0))return;GPb(a);return}function z5a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=a+8|0;c=f[b>>2]|0;do if(c&2){d=f[a+112>>2]|0;if(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0){e=f[b>>2]|0;break}else{g=0;return g|0}}else e=c;while(0);if(e&16|0?(e=f[a+116>>2]|0,!(di[f[(f[e>>2]|0)+32>>2]&1023](e)|0)):0){g=0;return g|0}e=a+44|0;c=f[a+36>>2]|0;while(1){if((c|0)<=0){g=1;h=9;break}c=c+-1|0;a=f[(f[e>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){g=0;h=9;break}}if((h|0)==9)return g|0;return 0}function A5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+92|0;l=a+16|0;m=a+64|0;n=a+68|0;o=a+72|0;p=a+124|0;q=a+128|0;r=a+132|0;s=a+136|0;t=a+96|0;v=a+140|0;w=a+144|0;x=a+148|0;y=a+152|0;z=a+156|0;A=a+164|0;B=a+104|0;C=a+161|0;D=e+8|0;E=a+200|0;F=a+4|0;G=a+168|0;H=a+160|0;I=e+8|0;K=a+12|0;L=a+208|0;M=e+8|0;N=a+116|0;O=e+4|0;P=c+44|0;Q=a+32|0;R=a+44|0;S=a+40|0;T=a+36|0;U=a+162|0;V=e+8|0;W=a+88|0;X=a+112|0;Y=e+4|0;Z=a+120|0;_=e+4|0;$=a+48|0;aa=a+60|0;ba=a+56|0;ca=a+52|0;da=a+189|0;ea=e+8|0;fa=a+100|0;ga=a+172|0;ha=a+216|0;ia=a+188|0;ja=e+8|0;ka=a+180|0;la=a+76|0;ma=a+80|0;na=a+84|0;oa=a+192|0;pa=a+184|0;qa=a+196|0;ra=a+176|0;sa=a+220|0;ta=a+108|0;a=c+32|0;ua=c+12|0;va=c+28|0;a:while(1){wa=f[c>>2]|0;xa=f[g>>2]|0;do if(wa>>>0<xa>>>0){ya=b[wa>>0]|0;za=ya&255;if(ya<<24>>24>0){Aa=za;Ba=1}else{ya=wa+1|0;if(ya>>>0>=xa>>>0){Ca=za;Da=7;break}Ea=h[ya>>0]|0;if(((Ea^128)&za)>>>0<=127){Ca=za;Da=7;break}Aa=za+-128+(Ea<<7)|0;Ba=2}f[i>>2]=Aa;f[c>>2]=wa+Ba;Fa=Aa;Da=9}else{Ca=0;Da=7}while(0);if((Da|0)==7){Da=0;wa=_nb(c,Ca)|0;f[i>>2]=wa;if((wa+-1|0)>>>0<16383){Fa=wa;Da=9}else{Ga=wa;Da=484}}b:do if((Da|0)==9){Da=0;c:do switch(Fa>>>3&536870911|0){case 1:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 10:break;default:{Ia=Fa;break b}}f[j>>2]=f[j>>2]|4;wa=f[k>>2]|0;if((wa|0)==497760){jza(k,497760);Ja=f[k>>2]|0}else Ja=wa;if(!(fqb(c,Ja)|0)){Ha=0;Da=490;break a}wa=f[c>>2]|0;if(wa>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[wa>>0]|0)==18){Ka=wa;Da=17}else continue a;break}case 2:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 18:{Da=18;break}default:{Ia=Fa;break b}}break}case 3:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 24:{La=f[c>>2]|0;Ma=f[g>>2]|0;Da=25;break c;break}case 26:{if(a6a(c,m)|0){Da=41;break c}else{Ha=0;Da=490;break a}break}default:{Ia=Fa;break b}}break}case 4:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 32:break;default:{Ia=Fa;break b}}Na=f[g>>2]|0;Oa=f[c>>2]|0;Da=47;break}case 5:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 45:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;Pa=wa;Qa=f[c>>2]|0;Ra=wa;Da=57;break}case 6:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 48:break;default:{Ia=Fa;break b}}Sa=f[c>>2]|0;Ta=f[g>>2]|0;Da=67;break}case 7:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 56:break;default:{Ia=Fa;break b}}Ua=f[c>>2]|0;Va=f[g>>2]|0;Da=77;break}case 8:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 66:{Da=86;break}default:{Ia=Fa;break b}}break}case 9:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 77:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;Wa=wa;Xa=f[c>>2]|0;Ya=wa;Da=94;break}case 10:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 85:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;Za=wa;_a=f[c>>2]|0;$a=wa;Da=104;break}case 11:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 93:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;ab=wa;bb=f[c>>2]|0;cb=wa;Da=114;break}case 12:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 101:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;db=wa;eb=f[c>>2]|0;fb=wa;Da=124;break}case 13:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 104:break;default:{Ia=Fa;break b}}gb=f[c>>2]|0;hb=f[g>>2]|0;Da=134;break}case 14:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 112:break;default:{Ia=Fa;break b}}ib=f[c>>2]|0;jb=f[g>>2]|0;Da=144;break}case 15:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 122:{Da=153;break}default:{Ia=Fa;break b}}break}case 16:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 128:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;kb=wa;lb=f[c>>2]|0;mb=wa;Da=162;break}case 17:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 136:break;default:{Ia=Fa;break b}}nb=f[c>>2]|0;ob=f[g>>2]|0;Da=173;break}case 18:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 144:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;pb=wa;qb=f[c>>2]|0;rb=wa;Da=189;break}case 19:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 152:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;sb=wa;tb=f[c>>2]|0;ub=wa;Da=200;break}case 20:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 160:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;vb=wa;wb=f[c>>2]|0;xb=wa;Da=211;break}case 21:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 170:{Da=221;break}default:{Ia=Fa;break b}}break}case 22:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 178:{Da=236;break}default:{Ia=Fa;break b}}break}case 23:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 184:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;yb=wa;zb=f[c>>2]|0;Ab=wa;Da=256;break}case 24:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 194:{Da=266;break}default:{Ia=Fa;break b}}break}case 25:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 202:{Da=274;break}default:{Ia=Fa;break b}}break}case 26:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 210:{Da=289;break}default:{Ia=Fa;break b}}break}case 27:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 218:{Da=304;break}default:{Ia=Fa;break b}}break}case 28:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 224:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;Bb=wa;Cb=f[c>>2]|0;Db=wa;Da=324;break}case 29:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 234:{Da=334;break}default:{Ia=Fa;break b}}break}case 30:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 240:break;default:{Ia=Fa;break b}}Eb=f[c>>2]|0;Fb=f[g>>2]|0;Da=343;break}case 31:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 253:break;default:{Ia=Fa;break b}}Gb=f[g>>2]|0;Hb=f[c>>2]|0;Da=359;break}case 32:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 256:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;Ib=wa;Jb=f[c>>2]|0;Kb=wa;Da=370;break}case 33:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 264:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;Lb=wa;Mb=f[c>>2]|0;Nb=wa;Da=381;break}case 34:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 272:{Ob=f[c>>2]|0;Pb=f[g>>2]|0;Da=392;break c;break}case 274:{if(a6a(c,la)|0){Da=409;break c}else{Ha=0;Da=490;break a}break}default:{Ia=Fa;break b}}break}case 35:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 285:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;Qb=f[c>>2]|0;Rb=wa;Sb=wa;Da=418;break}case 36:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 288:break;default:{Ia=Fa;break b}}wa=f[g>>2]|0;Tb=f[c>>2]|0;Ub=wa;Vb=wa;Da=429;break}case 37:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 296:break;default:{Ia=Fa;break b}}Wb=f[c>>2]|0;Xb=f[g>>2]|0;Da=440;break}case 38:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 309:break;default:{Ia=Fa;break b}}Yb=f[c>>2]|0;Zb=f[g>>2]|0;Da=456;break}case 39:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 317:break;default:{Ia=Fa;break b}}_b=f[c>>2]|0;$b=f[g>>2]|0;Da=467;break}case 40:{switch(Fa|0){case 0:{Ha=1;Da=490;break a;break}case 322:{Da=477;break}default:{Ia=Fa;break b}}break}default:{Ga=Fa;Da=484;break b}}while(0);d:while(1){switch(Da|0){case 17:{Da=0;f[c>>2]=Ka+1;Da=18;continue d;break}case 18:{Da=0;if(!(fqb(c,mza(l)|0)|0)){Ha=0;Da=490;break a}wa=f[c>>2]|0;xa=f[g>>2]|0;if(wa>>>0>=xa>>>0)continue a;if((b[wa>>0]|0)==18){Ka=wa;Da=17;continue d}if((b[wa>>0]|0)==24){ac=wa;bc=xa;Da=24}else continue a;break}case 25:{Da=0;if(La>>>0<Ma>>>0){xa=b[La>>0]|0;wa=xa&255;if(xa<<24>>24>-1){f[c>>2]=La+1;cc=wa}else{dc=wa;Da=28}}else{dc=0;Da=28}if((Da|0)==28){Da=0;wa=Knb(c,dc)|0;xa=J;if((xa|0)>-1|(xa|0)==-1&wa>>>0>4294967295)cc=wa;else{Ha=0;Da=490;break a}}wa=f[m>>2]|0;if((wa|0)==(f[n>>2]|0)){nza(m,wa+1|0);ec=f[m>>2]|0}else ec=wa;wa=f[o>>2]|0;f[m>>2]=ec+1;f[wa+4+(ec<<2)>>2]=cc;xa=(f[n>>2]|0)-(f[m>>2]|0)|0;if((xa|0)>0){fc=xa;gc=wa}else{Da=41;continue d}while(1){wa=f[c>>2]|0;xa=f[g>>2]|0;if(wa>>>0>=xa>>>0){Da=41;continue d}if((b[wa>>0]|0)!=24){Da=41;continue d}Ea=wa+1|0;f[c>>2]=Ea;if(Ea>>>0<xa>>>0){xa=b[Ea>>0]|0;Ea=xa&255;if(xa<<24>>24>-1){f[c>>2]=wa+2;hc=Ea;ic=gc}else{jc=Ea;Da=36}}else{jc=0;Da=36}if((Da|0)==36){Da=0;Ea=Knb(c,jc)|0;wa=J;if(!((wa|0)>-1|(wa|0)==-1&Ea>>>0>4294967295)){Ha=0;Da=490;break a}hc=Ea;ic=f[o>>2]|0}Ea=f[m>>2]|0;f[m>>2]=Ea+1;f[ic+4+(Ea<<2)>>2]=hc;if((fc|0)>1){fc=fc+-1|0;gc=ic}else{Da=41;continue d}}break}case 41:{Da=0;Ea=f[c>>2]|0;wa=f[g>>2]|0;if(Ea>>>0>=wa>>>0)continue a;if((b[Ea>>0]|0)==24){ac=Ea;bc=wa;Da=24}else{if((b[Ea>>0]|0)!=32)continue a;xa=Ea+1|0;f[c>>2]=xa;Na=wa;Oa=xa;Da=47;continue d}break}case 47:{Da=0;f[j>>2]=f[j>>2]|512;if(Oa>>>0<Na>>>0){xa=b[Oa>>0]|0;wa=xa&255;if(xa<<24>>24>-1){xa=Oa+1|0;f[c>>2]=xa;kc=wa;lc=Na;mc=xa}else{nc=wa;Da=50}}else{nc=0;Da=50}if((Da|0)==50){Da=0;wa=Knb(c,nc)|0;xa=J;if(!((xa|0)>-1|(xa|0)==-1&wa>>>0>4294967295)){Ha=0;Da=490;break a}kc=wa;lc=f[g>>2]|0;mc=f[c>>2]|0}f[p>>2]=kc;if(mc>>>0>=lc>>>0)continue a;if((b[mc>>0]|0)!=45)continue a;wa=mc+1|0;f[c>>2]=wa;Pa=lc;Qa=wa;Ra=lc;Da=57;continue d;break}case 57:{Da=0;f[j>>2]=f[j>>2]|4096;if((Ra-Qa|0)>3){wa=Qa;xa=h[wa>>0]|h[wa+1>>0]<<8|h[wa+2>>0]<<16|h[wa+3>>0]<<24;f[e>>2]=xa;wa=Qa+4|0;f[c>>2]=wa;oc=xa;pc=wa;qc=Pa}else{if(!(Xnb(c,e)|0)){Da=61;break a}oc=f[e>>2]|0;pc=f[c>>2]|0;qc=f[g>>2]|0}f[q>>2]=oc;if(pc>>>0>=qc>>>0)continue a;if((b[pc>>0]|0)!=48)continue a;wa=pc+1|0;f[c>>2]=wa;Sa=wa;Ta=qc;Da=67;continue d;break}case 67:{Da=0;f[j>>2]=f[j>>2]|8192;if(Sa>>>0<Ta>>>0){wa=b[Sa>>0]|0;xa=wa&255;if(wa<<24>>24>-1){wa=Sa+1|0;f[c>>2]=wa;rc=xa;sc=wa;tc=Ta}else{uc=xa;Da=70}}else{uc=0;Da=70}if((Da|0)==70){Da=0;xa=Knb(c,uc)|0;wa=J;if(!((wa|0)>-1|(wa|0)==-1&xa>>>0>4294967295)){Ha=0;Da=490;break a}rc=xa;sc=f[c>>2]|0;tc=f[g>>2]|0}f[r>>2]=rc;if(sc>>>0>=tc>>>0)continue a;if((b[sc>>0]|0)!=56)continue a;xa=sc+1|0;f[c>>2]=xa;Ua=xa;Va=tc;Da=77;continue d;break}case 77:{Da=0;f[j>>2]=f[j>>2]|32768;if(Ua>>>0<Va>>>0){xa=b[Ua>>0]|0;wa=xa&255;if(xa<<24>>24>-1){xa=Ua+1|0;f[c>>2]=xa;vc=wa;wc=xa;xc=Va}else{yc=wa;Da=80}}else{yc=0;Da=80}if((Da|0)==80){Da=0;wa=Knb(c,yc)|0;xa=J;if(!((xa|0)>-1|(xa|0)==-1&wa>>>0>4294967295)){Ha=0;Da=490;break a}vc=wa;wc=f[c>>2]|0;xc=f[g>>2]|0}f[s>>2]=vc;if(wc>>>0>=xc>>>0)continue a;if((b[wc>>0]|0)!=66)continue a;f[c>>2]=wc+1;Da=86;continue d;break}case 86:{Da=0;f[j>>2]=f[j>>2]|131072;wa=f[t>>2]|0;if((wa|0)==497760){jza(t,497760);zc=f[t>>2]|0}else zc=wa;if(!(fqb(c,zc)|0)){Ha=0;Da=490;break a}wa=f[c>>2]|0;xa=f[g>>2]|0;if(wa>>>0>=xa>>>0)continue a;if((b[wa>>0]|0)!=77)continue a;Ea=wa+1|0;f[c>>2]=Ea;Wa=xa;Xa=Ea;Ya=xa;Da=94;continue d;break}case 94:{Da=0;f[j>>2]=f[j>>2]|262144;if((Ya-Xa|0)>3){xa=Xa;Ea=h[xa>>0]|h[xa+1>>0]<<8|h[xa+2>>0]<<16|h[xa+3>>0]<<24;f[e>>2]=Ea;xa=Xa+4|0;f[c>>2]=xa;Ac=Ya;Bc=Ea;Cc=xa;Dc=Wa}else{if(!(Xnb(c,e)|0)){Da=98;break a}xa=f[g>>2]|0;Ac=xa;Bc=f[e>>2]|0;Cc=f[c>>2]|0;Dc=xa}f[v>>2]=Bc;if(Cc>>>0>=Dc>>>0)continue a;if((b[Cc>>0]|0)!=85)continue a;xa=Cc+1|0;f[c>>2]=xa;Za=Dc;_a=xa;$a=Ac;Da=104;continue d;break}case 104:{Da=0;f[j>>2]=f[j>>2]|524288;if(($a-_a|0)>3){xa=_a;Ea=h[xa>>0]|h[xa+1>>0]<<8|h[xa+2>>0]<<16|h[xa+3>>0]<<24;f[e>>2]=Ea;xa=_a+4|0;f[c>>2]=xa;Ec=$a;Fc=Ea;Gc=xa;Hc=Za}else{if(!(Xnb(c,e)|0)){Da=108;break a}xa=f[g>>2]|0;Ec=xa;Fc=f[e>>2]|0;Gc=f[c>>2]|0;Hc=xa}f[w>>2]=Fc;if(Gc>>>0>=Hc>>>0)continue a;if((b[Gc>>0]|0)!=93)continue a;xa=Gc+1|0;f[c>>2]=xa;ab=Hc;bb=xa;cb=Ec;Da=114;continue d;break}case 114:{Da=0;f[j>>2]=f[j>>2]|1048576;if((cb-bb|0)>3){xa=bb;Ea=h[xa>>0]|h[xa+1>>0]<<8|h[xa+2>>0]<<16|h[xa+3>>0]<<24;f[e>>2]=Ea;xa=bb+4|0;f[c>>2]=xa;Ic=cb;Jc=Ea;Kc=xa;Lc=ab}else{if(!(Xnb(c,e)|0)){Da=118;break a}xa=f[g>>2]|0;Ic=xa;Jc=f[e>>2]|0;Kc=f[c>>2]|0;Lc=xa}f[x>>2]=Jc;if(Kc>>>0>=Lc>>>0)continue a;if((b[Kc>>0]|0)!=101)continue a;xa=Kc+1|0;f[c>>2]=xa;db=Lc;eb=xa;fb=Ic;Da=124;continue d;break}case 124:{Da=0;f[j>>2]=f[j>>2]|2097152;if((fb-eb|0)>3){xa=eb;Ea=h[xa>>0]|h[xa+1>>0]<<8|h[xa+2>>0]<<16|h[xa+3>>0]<<24;f[e>>2]=Ea;xa=eb+4|0;f[c>>2]=xa;Mc=Ea;Nc=xa;Oc=db}else{if(!(Xnb(c,e)|0)){Da=128;break a}Mc=f[e>>2]|0;Nc=f[c>>2]|0;Oc=f[g>>2]|0}f[y>>2]=Mc;if(Nc>>>0>=Oc>>>0)continue a;if((b[Nc>>0]|0)!=104)continue a;xa=Nc+1|0;f[c>>2]=xa;gb=xa;hb=Oc;Da=134;continue d;break}case 134:{Da=0;f[j>>2]=f[j>>2]|8388608;if(gb>>>0<hb>>>0){xa=b[gb>>0]|0;Ea=xa&255;if(xa<<24>>24>-1){xa=gb+1|0;f[c>>2]=xa;Pc=Ea;Qc=xa;Rc=hb}else{Sc=Ea;Da=137}}else{Sc=0;Da=137}if((Da|0)==137){Da=0;Ea=Knb(c,Sc)|0;xa=J;if(!((xa|0)>-1|(xa|0)==-1&Ea>>>0>4294967295)){Ha=0;Da=490;break a}Pc=Ea;Qc=f[c>>2]|0;Rc=f[g>>2]|0}f[z>>2]=Pc;if(Qc>>>0>=Rc>>>0)continue a;if((b[Qc>>0]|0)!=112)continue a;Ea=Qc+1|0;f[c>>2]=Ea;ib=Ea;jb=Rc;Da=144;continue d;break}case 144:{Da=0;f[j>>2]=f[j>>2]|67108864;if(ib>>>0<jb>>>0){Ea=b[ib>>0]|0;xa=Ea&255;if(Ea<<24>>24>-1){Ea=ib+1|0;f[c>>2]=Ea;Tc=xa;Uc=Ea;Vc=jb}else{Wc=xa;Da=147}}else{Wc=0;Da=147}if((Da|0)==147){Da=0;xa=Knb(c,Wc)|0;Ea=J;if(!((Ea|0)>-1|(Ea|0)==-1&xa>>>0>4294967295)){Ha=0;Da=490;break a}Tc=xa;Uc=f[c>>2]|0;Vc=f[g>>2]|0}f[A>>2]=Tc;if(Uc>>>0>=Vc>>>0)continue a;if((b[Uc>>0]|0)!=122)continue a;f[c>>2]=Uc+1;Da=153;continue d;break}case 153:{Da=0;f[j>>2]=f[j>>2]|134217728;xa=f[B>>2]|0;if((xa|0)==497760){jza(B,497760);Xc=f[B>>2]|0}else Xc=xa;if(!(fqb(c,Xc)|0)){Ha=0;Da=490;break a}xa=f[g>>2]|0;Ea=f[c>>2]|0;wa=Ea;if((xa-Ea|0)<=1)continue a;if((b[wa>>0]|0)!=-128)continue a;if((b[wa+1>>0]|0)!=1)continue a;Ea=wa+2|0;f[c>>2]=Ea;kb=xa;lb=Ea;mb=xa;Da=162;continue d;break}case 162:{Da=0;f[j>>2]=f[j>>2]|268435456;if(lb>>>0<mb>>>0?(xa=b[lb>>0]|0,xa<<24>>24>-1):0){Ea=lb+1|0;f[c>>2]=Ea;Yc=xa<<24>>24!=0;Zc=mb;_c=Ea;$c=kb}else{Lnb(e,c);Ea=e;if(!(b[D>>0]|0)){Ha=0;Da=490;break a}xa=f[g>>2]|0;Yc=(f[Ea>>2]|0)!=0|(f[Ea+4>>2]|0)!=0;Zc=xa;_c=f[c>>2]|0;$c=xa}b[C>>0]=Yc&1;xa=_c;if(($c-_c|0)<=1)continue a;if((b[xa>>0]|0)!=-120)continue a;if((b[xa+1>>0]|0)!=1)continue a;Ea=xa+2|0;f[c>>2]=Ea;nb=Ea;ob=Zc;Da=173;continue d;break}case 173:{Da=0;if(nb>>>0<ob>>>0){Ea=b[nb>>0]|0;xa=Ea&255;if(Ea<<24>>24>-1){f[c>>2]=nb+1;ad=xa}else{bd=xa;Da=176}}else{bd=0;Da=176}if((Da|0)==176){Da=0;xa=Knb(c,bd)|0;Ea=J;if((Ea|0)>-1|(Ea|0)==-1&xa>>>0>4294967295)ad=xa;else{Ha=0;Da=490;break a}}if(ad>>>0<2){f[j>>2]=f[j>>2]|1073741824;f[E>>2]=ad}else{xa=f[F>>2]|0;if(!(xa&1))cd=hBa(F)|0;else cd=xa&-2;NPb(cd,17,ad,((ad|0)<0)<<31>>31)}xa=f[g>>2]|0;Ea=f[c>>2]|0;wa=Ea;if((xa-Ea|0)<=1)continue a;if((b[wa>>0]|0)!=-112)continue a;if((b[wa+1>>0]|0)!=1)continue a;Ea=wa+2|0;f[c>>2]=Ea;pb=xa;qb=Ea;rb=xa;Da=189;continue d;break}case 189:{Da=0;f[j>>2]=f[j>>2]|-2147483648;if(qb>>>0<rb>>>0){xa=b[qb>>0]|0;Ea=xa&255;if(xa<<24>>24>-1){xa=qb+1|0;f[c>>2]=xa;dd=Ea;ed=rb;fd=xa;gd=pb}else{hd=Ea;Da=192}}else{hd=0;Da=192}if((Da|0)==192){Da=0;Ea=Knb(c,hd)|0;xa=J;if(!((xa|0)>-1|(xa|0)==-1&Ea>>>0>4294967295)){Ha=0;Da=490;break a}xa=f[g>>2]|0;dd=Ea;ed=xa;fd=f[c>>2]|0;gd=xa}f[G>>2]=dd;xa=fd;if((gd-fd|0)<=1)continue a;if((b[xa>>0]|0)!=-104)continue a;if((b[xa+1>>0]|0)!=1)continue a;Ea=xa+2|0;f[c>>2]=Ea;sb=gd;tb=Ea;ub=ed;Da=200;continue d;break}case 200:{Da=0;f[j>>2]=f[j>>2]|1024;if(tb>>>0<ub>>>0?(Ea=b[tb>>0]|0,Ea<<24>>24>-1):0){xa=tb+1|0;f[c>>2]=xa;id=Ea<<24>>24!=0;jd=ub;kd=xa;ld=sb}else{Lnb(e,c);xa=e;if(!(b[I>>0]|0)){Ha=0;Da=490;break a}Ea=f[g>>2]|0;id=(f[xa>>2]|0)!=0|(f[xa+4>>2]|0)!=0;jd=Ea;kd=f[c>>2]|0;ld=Ea}b[H>>0]=id&1;Ea=kd;if((ld-kd|0)<=1)continue a;if((b[Ea>>0]|0)!=-96)continue a;if((b[Ea+1>>0]|0)!=1)continue a;xa=Ea+2|0;f[c>>2]=xa;vb=ld;wb=xa;xb=jd;Da=211;continue d;break}case 211:{Da=0;f[K>>2]=f[K>>2]|1;if(wb>>>0<xb>>>0?(xa=b[wb>>0]|0,xa<<24>>24>-1):0){Ea=wb+1|0;f[c>>2]=Ea;md=xa&255;nd=0;od=Ea;pd=vb}else{Lnb(e,c);Ea=e;if(!(b[M>>0]|0)){Ha=0;Da=490;break a}md=f[Ea>>2]|0;nd=f[Ea+4>>2]|0;od=f[c>>2]|0;pd=f[g>>2]|0}Ea=L;f[Ea>>2]=md;f[Ea+4>>2]=nd;Ea=od;if((pd-od|0)<=1)continue a;if((b[Ea>>0]|0)!=-86)continue a;if((b[Ea+1>>0]|0)!=1)continue a;f[c>>2]=Ea+2;Da=221;continue d;break}case 221:{Da=0;f[j>>2]=f[j>>2]|16;Ea=f[N>>2]|0;if(!Ea){xa=L5b(104)|0;N5a(xa);f[N>>2]=xa;qd=xa}else qd=Ea;Ea=f[c>>2]|0;if(Ea>>>0<(f[g>>2]|0)>>>0?(xa=b[Ea>>0]|0,xa<<24>>24>-1):0){f[c>>2]=Ea+1;rd=xa&255}else{xa=Znb(c)|0;if((xa|0)>-1)rd=xa;else{Ha=0;Da=490;break a}}Inb(e,c,rd);if((f[O>>2]|0)<0){Da=229;break a}if(!(b6a(qd,c)|0)){Da=229;break a}if(!(Onb(c,f[e>>2]|0)|0)){Ha=0;Da=490;break a}xa=f[c>>2]|0;Ea=xa;if(((f[g>>2]|0)-xa|0)<=1)continue a;if((b[Ea>>0]|0)!=-78)continue a;if((b[Ea+1>>0]|0)!=1)continue a;f[c>>2]=Ea+2;Da=236;continue d;break}case 236:{Da=0;Ea=f[P>>2]|0;f[P>>2]=Ea+-1;if((Ea|0)<=0){Ha=0;Da=490;break a}while(1){Ea=f[R>>2]|0;do if(Ea){xa=f[T>>2]|0;wa=f[Ea>>2]|0;if((xa|0)>=(wa|0))if((wa|0)==(f[S>>2]|0)){sd=wa;Da=242;break}else{td=wa;ud=Ea;Da=243;break}else{f[T>>2]=xa+1;vd=f[Ea+4+(xa<<2)>>2]|0;break}}else{sd=f[S>>2]|0;Da=242}while(0);if((Da|0)==242){Da=0;cpb(Q,sd+1|0);Ea=f[R>>2]|0;td=f[Ea>>2]|0;ud=Ea;Da=243}if((Da|0)==243){Da=0;f[ud>>2]=td+1;Ea=Y5a(0,f[Q>>2]|0)|0;xa=f[R>>2]|0;wa=f[T>>2]|0;f[T>>2]=wa+1;f[xa+4+(wa<<2)>>2]=Ea;vd=Ea}Ea=Jnb(c)|0;if(!(b6a(vd,c)|0)){Ha=0;Da=490;break a}if(!(Pnb(c,Ea)|0)){Ha=0;Da=490;break a}wd=f[g>>2]|0;Ea=f[c>>2]|0;xd=Ea;if((wd-Ea|0)<=1){Da=250;break d}if((b[xd>>0]|0)!=-78)break;if((b[xd+1>>0]|0)!=1)break;f[c>>2]=xd+2}f[P>>2]=(f[P>>2]|0)+1;if((b[xd>>0]|0)!=-72)continue a;if((b[xd+1>>0]|0)!=1)continue a;Ea=xd+2|0;f[c>>2]=Ea;yb=wd;zb=Ea;Ab=wd;Da=256;continue d;break}case 256:{Da=0;f[K>>2]=f[K>>2]|32;if(zb>>>0<Ab>>>0?(Ea=b[zb>>0]|0,Ea<<24>>24>-1):0){wa=zb+1|0;f[c>>2]=wa;yd=Ea<<24>>24!=0;zd=wa;Ad=yb}else{Lnb(e,c);wa=e;if(!(b[V>>0]|0)){Ha=0;Da=490;break a}yd=(f[wa>>2]|0)!=0|(f[wa+4>>2]|0)!=0;zd=f[c>>2]|0;Ad=f[g>>2]|0}b[U>>0]=yd&1;wa=zd;if((Ad-zd|0)<=1)continue a;if((b[wa>>0]|0)!=-62)continue a;if((b[wa+1>>0]|0)!=1)continue a;f[c>>2]=wa+2;Da=266;continue d;break}case 266:{Da=0;f[j>>2]=f[j>>2]|1;wa=f[W>>2]|0;if((wa|0)==497760){jza(W,497760);Bd=f[W>>2]|0}else Bd=wa;if(!(fqb(c,Bd)|0)){Ha=0;Da=490;break a}wa=f[c>>2]|0;Ea=wa;if(((f[g>>2]|0)-wa|0)<=1)continue a;if((b[Ea>>0]|0)!=-54)continue a;if((b[Ea+1>>0]|0)!=1)continue a;f[c>>2]=Ea+2;Da=274;continue d;break}case 274:{Da=0;f[j>>2]=f[j>>2]|2;Ea=f[X>>2]|0;if(!Ea){wa=L5b(104)|0;N5a(wa);f[X>>2]=wa;Cd=wa}else Cd=Ea;Ea=f[c>>2]|0;if(Ea>>>0<(f[g>>2]|0)>>>0?(wa=b[Ea>>0]|0,wa<<24>>24>-1):0){f[c>>2]=Ea+1;Dd=wa&255}else{wa=Znb(c)|0;if((wa|0)>-1)Dd=wa;else{Ha=0;Da=490;break a}}Inb(e,c,Dd);if((f[Y>>2]|0)<0){Da=282;break a}if(!(b6a(Cd,c)|0)){Da=282;break a}if(!(Onb(c,f[e>>2]|0)|0)){Ha=0;Da=490;break a}wa=f[c>>2]|0;Ea=wa;if(((f[g>>2]|0)-wa|0)<=1)continue a;if((b[Ea>>0]|0)!=-46)continue a;if((b[Ea+1>>0]|0)!=1)continue a;f[c>>2]=Ea+2;Da=289;continue d;break}case 289:{Da=0;f[j>>2]=f[j>>2]|64;Ea=f[Z>>2]|0;if(!Ea){wa=L5b(40)|0;$4a(wa);f[Z>>2]=wa;Ed=wa}else Ed=Ea;Ea=f[c>>2]|0;if(Ea>>>0<(f[g>>2]|0)>>>0?(wa=b[Ea>>0]|0,wa<<24>>24>-1):0){f[c>>2]=Ea+1;Fd=wa&255}else{wa=Znb(c)|0;if((wa|0)>-1)Fd=wa;else{Ha=0;Da=490;break a}}Inb(e,c,Fd);if((f[_>>2]|0)<0){Da=297;break a}if(!(R4a(Ed,c)|0)){Da=297;break a}if(!(Onb(c,f[e>>2]|0)|0)){Ha=0;Da=490;break a}wa=f[c>>2]|0;Ea=wa;if(((f[g>>2]|0)-wa|0)<=1)continue a;if((b[Ea>>0]|0)!=-38)continue a;if((b[Ea+1>>0]|0)!=1)continue a;f[c>>2]=Ea+2;Da=304;continue d;break}case 304:{Da=0;Ea=f[P>>2]|0;f[P>>2]=Ea+-1;if((Ea|0)<=0){Ha=0;Da=490;break a}while(1){Ea=f[aa>>2]|0;do if(Ea){wa=f[ca>>2]|0;xa=f[Ea>>2]|0;if((wa|0)>=(xa|0))if((xa|0)==(f[ba>>2]|0)){Gd=xa;Da=310;break}else{Hd=xa;Id=Ea;Da=311;break}else{f[ca>>2]=wa+1;Jd=f[Ea+4+(wa<<2)>>2]|0;break}}else{Gd=f[ba>>2]|0;Da=310}while(0);if((Da|0)==310){Da=0;cpb($,Gd+1|0);Ea=f[aa>>2]|0;Hd=f[Ea>>2]|0;Id=Ea;Da=311}if((Da|0)==311){Da=0;f[Id>>2]=Hd+1;Ea=U5a(0,f[$>>2]|0)|0;wa=f[aa>>2]|0;xa=f[ca>>2]|0;f[ca>>2]=xa+1;f[wa+4+(xa<<2)>>2]=Ea;Jd=Ea}Ea=Jnb(c)|0;if(!(R4a(Jd,c)|0)){Ha=0;Da=490;break a}if(!(Pnb(c,Ea)|0)){Ha=0;Da=490;break a}Kd=f[g>>2]|0;Ea=f[c>>2]|0;Ld=Ea;if((Kd-Ea|0)<=1){Da=318;break d}if((b[Ld>>0]|0)!=-38)break;if((b[Ld+1>>0]|0)!=1)break;f[c>>2]=Ld+2}f[P>>2]=(f[P>>2]|0)+1;if((b[Ld>>0]|0)!=-32)continue a;if((b[Ld+1>>0]|0)!=1)continue a;Ea=Ld+2|0;f[c>>2]=Ea;Bb=Kd;Cb=Ea;Db=Kd;Da=324;continue d;break}case 324:{Da=0;f[K>>2]=f[K>>2]|64;if(Cb>>>0<Db>>>0?(Ea=b[Cb>>0]|0,Ea<<24>>24>-1):0){xa=Cb+1|0;f[c>>2]=xa;Md=Ea<<24>>24!=0;Nd=xa;Od=Bb}else{Lnb(e,c);xa=e;if(!(b[ea>>0]|0)){Ha=0;Da=490;break a}Md=(f[xa>>2]|0)!=0|(f[xa+4>>2]|0)!=0;Nd=f[c>>2]|0;Od=f[g>>2]|0}b[da>>0]=Md&1;xa=Nd;if((Od-Nd|0)<=1)continue a;if((b[xa>>0]|0)!=-22)continue a;if((b[xa+1>>0]|0)!=1)continue a;f[c>>2]=xa+2;Da=334;continue d;break}case 334:{Da=0;f[j>>2]=f[j>>2]|4194304;xa=f[213029]|0;Ea=f[fa>>2]|0;if((Ea|0)==(xa|0)){jza(fa,xa);Pd=f[fa>>2]|0}else Pd=Ea;if(!(fqb(c,Pd)|0)){Ha=0;Da=490;break a}Ea=f[g>>2]|0;xa=f[c>>2]|0;wa=xa;if((Ea-xa|0)<=1)continue a;if((b[wa>>0]|0)!=-16)continue a;if((b[wa+1>>0]|0)!=1)continue a;xa=wa+2|0;f[c>>2]=xa;Eb=xa;Fb=Ea;Da=343;continue d;break}case 343:{Da=0;if(Eb>>>0<Fb>>>0){Ea=b[Eb>>0]|0;xa=Ea&255;if(Ea<<24>>24>-1){f[c>>2]=Eb+1;Qd=xa}else{Rd=xa;Da=346}}else{Rd=0;Da=346}if((Da|0)==346){Da=0;xa=Knb(c,Rd)|0;Ea=J;if((Ea|0)>-1|(Ea|0)==-1&xa>>>0>4294967295)Qd=xa;else{Ha=0;Da=490;break a}}if(Qd>>>0<6){f[K>>2]=f[K>>2]|128;f[ga>>2]=Qd}else{xa=f[F>>2]|0;if(!(xa&1))Sd=hBa(F)|0;else Sd=xa&-2;NPb(Sd,30,Qd,((Qd|0)<0)<<31>>31)}xa=f[g>>2]|0;Ea=f[c>>2]|0;wa=Ea;if((xa-Ea|0)<=1)continue a;if((b[wa>>0]|0)!=-3)continue a;if((b[wa+1>>0]|0)!=1)continue a;Ea=wa+2|0;f[c>>2]=Ea;Gb=xa;Hb=Ea;Da=359;continue d;break}case 359:{Da=0;f[K>>2]=f[K>>2]|4;if((Gb-Hb|0)>3){Ea=Hb;xa=h[Ea>>0]|h[Ea+1>>0]<<8|h[Ea+2>>0]<<16|h[Ea+3>>0]<<24;f[e>>2]=xa;Ea=Hb+4|0;f[c>>2]=Ea;Td=Gb;Ud=xa;Vd=Ea}else{if(!(Xnb(c,e)|0)){Da=363;break a}Td=f[g>>2]|0;Ud=f[e>>2]|0;Vd=f[c>>2]|0}f[ha>>2]=Ud;Ea=Vd;if((Td-Vd|0)<=1)continue a;if((b[Ea>>0]|0)!=-128)continue a;if((b[Ea+1>>0]|0)!=2)continue a;xa=Ea+2|0;f[c>>2]=xa;Ib=Td;Jb=xa;Kb=Td;Da=370;continue d;break}case 370:{Da=0;f[j>>2]=f[j>>2]|2048;if(Jb>>>0<Kb>>>0?(xa=b[Jb>>0]|0,xa<<24>>24>-1):0){Ea=Jb+1|0;f[c>>2]=Ea;Wd=xa<<24>>24!=0;Xd=Kb;Yd=Ea;Zd=Ib}else{Lnb(e,c);Ea=e;if(!(b[ja>>0]|0)){Ha=0;Da=490;break a}xa=f[g>>2]|0;Wd=(f[Ea>>2]|0)!=0|(f[Ea+4>>2]|0)!=0;Xd=xa;Yd=f[c>>2]|0;Zd=xa}b[ia>>0]=Wd&1;xa=Yd;if((Zd-Yd|0)<=1)continue a;if((b[xa>>0]|0)!=-120)continue a;if((b[xa+1>>0]|0)!=2)continue a;Ea=xa+2|0;f[c>>2]=Ea;Lb=Zd;Mb=Ea;Nb=Xd;Da=381;continue d;break}case 381:{Da=0;f[j>>2]=f[j>>2]|16384;if(Mb>>>0<Nb>>>0){Ea=b[Mb>>0]|0;xa=Ea&255;if(Ea<<24>>24>-1){Ea=Mb+1|0;f[c>>2]=Ea;_d=xa;$d=Nb;ae=Ea;be=Lb}else{ce=xa;Da=384}}else{ce=0;Da=384}if((Da|0)==384){Da=0;xa=Knb(c,ce)|0;Ea=J;if(!((Ea|0)>-1|(Ea|0)==-1&xa>>>0>4294967295)){Ha=0;Da=490;break a}Ea=f[g>>2]|0;_d=xa;$d=Ea;ae=f[c>>2]|0;be=Ea}f[ka>>2]=_d;Ea=ae;if((be-ae|0)<=1)continue a;if((b[Ea>>0]|0)!=-112)continue a;if((b[Ea+1>>0]|0)==2){de=Ea;ee=$d;Da=391}else continue a;break}case 392:{Da=0;if(Ob>>>0<Pb>>>0){Ea=b[Ob>>0]|0;xa=Ea&255;if(Ea<<24>>24>-1){f[c>>2]=Ob+1;fe=xa}else{ge=xa;Da=395}}else{ge=0;Da=395}if((Da|0)==395){Da=0;xa=Knb(c,ge)|0;Ea=J;if((Ea|0)>-1|(Ea|0)==-1&xa>>>0>4294967295)fe=xa;else{Ha=0;Da=490;break a}}xa=f[la>>2]|0;if((xa|0)==(f[ma>>2]|0)){nza(la,xa+1|0);he=f[la>>2]|0}else he=xa;xa=f[na>>2]|0;f[la>>2]=he+1;f[xa+4+(he<<2)>>2]=fe;Ea=(f[ma>>2]|0)-(f[la>>2]|0)|0;if((Ea|0)>0){ie=Ea;je=xa}else{Da=409;continue d}while(1){xa=f[g>>2]|0;Ea=f[c>>2]|0;wa=Ea;if((xa-Ea|0)<=1){Da=409;continue d}if((b[wa>>0]|0)!=-112){Da=409;continue d}if((b[wa+1>>0]|0)!=2){Da=409;continue d}Ea=wa+2|0;f[c>>2]=Ea;if(Ea>>>0<xa>>>0){xa=b[Ea>>0]|0;Ea=xa&255;if(xa<<24>>24>-1){f[c>>2]=wa+3;ke=Ea;le=je}else{me=Ea;Da=404}}else{me=0;Da=404}if((Da|0)==404){Da=0;Ea=Knb(c,me)|0;wa=J;if(!((wa|0)>-1|(wa|0)==-1&Ea>>>0>4294967295)){Ha=0;Da=490;break a}ke=Ea;le=f[na>>2]|0}Ea=f[la>>2]|0;f[la>>2]=Ea+1;f[le+4+(Ea<<2)>>2]=ke;if((ie|0)>1){ie=ie+-1|0;je=le}else{Da=409;continue d}}break}case 409:{Da=0;Ea=f[g>>2]|0;wa=f[c>>2]|0;xa=wa;za=Ea;if((Ea-wa|0)<=1)continue a;wa=b[xa>>0]|0;if(wa<<24>>24==-112){if((b[xa+1>>0]|0)==2){de=xa;ee=za;Da=391;break}ne=b[xa>>0]|0}else ne=wa;if(ne<<24>>24!=-99)continue a;if((b[xa+1>>0]|0)!=2)continue a;wa=xa+2|0;f[c>>2]=wa;Qb=wa;Rb=Ea;Sb=za;Da=418;continue d;break}case 418:{Da=0;f[j>>2]=f[j>>2]|33554432;if((Rb-Qb|0)>3){za=Qb;Ea=h[za>>0]|h[za+1>>0]<<8|h[za+2>>0]<<16|h[za+3>>0]<<24;f[e>>2]=Ea;za=Qb+4|0;f[c>>2]=za;oe=Ea;pe=za;qe=Rb;re=Sb}else{if(!(Xnb(c,e)|0)){Da=422;break a}za=f[g>>2]|0;oe=f[e>>2]|0;pe=f[c>>2]|0;qe=za;re=za}f[oa>>2]=oe;za=pe;if((qe-pe|0)<=1)continue a;if((b[za>>0]|0)!=-96)continue a;if((b[za+1>>0]|0)!=2)continue a;Ea=za+2|0;f[c>>2]=Ea;Tb=Ea;Ub=re;Vb=qe;Da=429;continue d;break}case 429:{Da=0;f[j>>2]=f[j>>2]|65536;if(Tb>>>0<Ub>>>0){Ea=b[Tb>>0]|0;za=Ea&255;if(Ea<<24>>24>-1){Ea=Tb+1|0;f[c>>2]=Ea;se=za;te=Ea;ue=Vb;ve=Ub}else{we=za;Da=432}}else{we=0;Da=432}if((Da|0)==432){Da=0;za=Knb(c,we)|0;Ea=J;if(!((Ea|0)>-1|(Ea|0)==-1&za>>>0>4294967295)){Ha=0;Da=490;break a}Ea=f[g>>2]|0;se=za;te=f[c>>2]|0;ue=Ea;ve=Ea}f[pa>>2]=se;Ea=te;if((ue-te|0)<=1)continue a;if((b[Ea>>0]|0)!=-88)continue a;if((b[Ea+1>>0]|0)!=2)continue a;za=Ea+2|0;f[c>>2]=za;Wb=za;Xb=ve;Da=440;continue d;break}case 440:{Da=0;if(Wb>>>0<Xb>>>0){za=b[Wb>>0]|0;Ea=za&255;if(za<<24>>24>-1){f[c>>2]=Wb+1;xe=Ea}else{ye=Ea;Da=443}}else{ye=0;Da=443}if((Da|0)==443){Da=0;Ea=Knb(c,ye)|0;za=J;if((za|0)>-1|(za|0)==-1&Ea>>>0>4294967295)xe=Ea;else{Ha=0;Da=490;break a}}if(xe>>>0<2){f[j>>2]=f[j>>2]|536870912;f[qa>>2]=xe}else{Ea=f[F>>2]|0;if(!(Ea&1))ze=hBa(F)|0;else ze=Ea&-2;NPb(ze,37,xe,((xe|0)<0)<<31>>31)}Ea=f[g>>2]|0;za=f[c>>2]|0;wa=za;if((Ea-za|0)<=1)continue a;if((b[wa>>0]|0)!=-75)continue a;if((b[wa+1>>0]|0)!=2)continue a;za=wa+2|0;f[c>>2]=za;Yb=za;Zb=Ea;Da=456;continue d;break}case 456:{Da=0;f[K>>2]=f[K>>2]|16;if((Zb-Yb|0)>3){Ea=Yb;za=h[Ea>>0]|h[Ea+1>>0]<<8|h[Ea+2>>0]<<16|h[Ea+3>>0]<<24;f[e>>2]=za;Ea=Yb+4|0;f[c>>2]=Ea;Ae=za;Be=Ea;Ce=Zb}else{if(!(Xnb(c,e)|0)){Da=460;break a}Ae=f[e>>2]|0;Be=f[c>>2]|0;Ce=f[g>>2]|0}f[ra>>2]=Ae;Ea=Be;if((Ce-Be|0)<=1)continue a;if((b[Ea>>0]|0)!=-67)continue a;if((b[Ea+1>>0]|0)!=2)continue a;za=Ea+2|0;f[c>>2]=za;_b=za;$b=Ce;Da=467;continue d;break}case 467:{Da=0;f[K>>2]=f[K>>2]|8;if(($b-_b|0)>3){za=_b;Ea=h[za>>0]|h[za+1>>0]<<8|h[za+2>>0]<<16|h[za+3>>0]<<24;f[e>>2]=Ea;za=_b+4|0;f[c>>2]=za;De=Ea;Ee=za;Fe=$b}else{if(!(Xnb(c,e)|0)){Da=471;break a}De=f[e>>2]|0;Ee=f[c>>2]|0;Fe=f[g>>2]|0}f[sa>>2]=De;za=Ee;if((Fe-Ee|0)<=1)continue a;if((b[za>>0]|0)!=-62)continue a;if((b[za+1>>0]|0)!=2)continue a;f[c>>2]=za+2;Da=477;continue d;break}case 477:{Da=0;f[K>>2]=f[K>>2]|2;Ge=f[213030]|0;za=f[ta>>2]|0;if((za|0)==(Ge|0)){Da=478;break d}else{He=za;break d}break}}if((Da|0)==24){Da=0;za=ac+1|0;f[c>>2]=za;La=za;Ma=bc;Da=25;continue}else if((Da|0)==391){Da=0;za=de+2|0;f[c>>2]=za;Ob=za;Pb=ee;Da=392;continue}}if((Da|0)==250){Da=0;f[P>>2]=(f[P>>2]|0)+1;continue a}else if((Da|0)==318){Da=0;f[P>>2]=(f[P>>2]|0)+1;continue a}else if((Da|0)==478){Da=0;jza(ta,Ge);He=f[ta>>2]|0}if(!(fqb(c,He)|0)){Ha=0;Da=490;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[a>>2]|0){Da=483;break a}if((f[ua>>2]|0)==(f[va>>2]|0)){Da=483;break a}else continue a}while(0);if((Da|0)==484){Da=0;if(!Ga){Ha=1;Da=490;break}else Ia=Ga}if((Ia&7|0)==4){Ha=1;Da=490;break}za=f[F>>2]|0;if(!(za&1))Ie=hBa(F)|0;else Ie=za&-2;if(!(ZPb(c,Ia,Ie)|0)){Ha=0;Da=490;break}}switch(Da|0){case 61:{Ha=0;u=d;return Ha|0}case 98:{Ha=0;u=d;return Ha|0}case 108:{Ha=0;u=d;return Ha|0}case 118:{Ha=0;u=d;return Ha|0}case 128:{Ha=0;u=d;return Ha|0}case 229:{Ha=0;u=d;return Ha|0}case 282:{Ha=0;u=d;return Ha|0}case 297:{Ha=0;u=d;return Ha|0}case 363:{Ha=0;u=d;return Ha|0}case 422:{Ha=0;u=d;return Ha|0}case 460:{Ha=0;u=d;return Ha|0}case 471:{Ha=0;u=d;return Ha|0}case 483:{f[i>>2]=0;b[c+24>>0]=1;Ha=1;u=d;return Ha|0}case 490:{u=d;return Ha|0}}return 0}function B5a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0;c=a+8|0;d=f[c>>2]|0;if(d&87){if(!(d&1)){e=0;g=d}else{h=f[a+88>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+2+k|0;g=l}if(!(g&2)){n=e;o=g}else{g=$5a(f[a+112>>2]|0)|0;if(g>>>0<128)p=1;else p=iob(g)|0;n=e+2+g+p|0;o=f[c>>2]|0}if(!(o&4)){q=n;r=o}else{p=f[a+92>>2]|0;g=b[p+11>>0]|0;if(g<<24>>24<0){e=f[p+4>>2]|0;if(e>>>0<128){s=1;t=o;u=e}else{p=iob(e)|0;s=p;t=f[c>>2]|0;u=e}}else{s=1;t=o;u=g&255}q=n+1+u+s|0;r=t}if(!(r&16)){v=q;w=r}else{r=$5a(f[a+116>>2]|0)|0;if(r>>>0<128)x=1;else x=iob(r)|0;v=q+2+r+x|0;w=f[c>>2]|0}if(!(w&64)){y=v;z=w}else{w=S4a(f[a+120>>2]|0)|0;if(w>>>0<128)A=1;else A=iob(w)|0;y=v+2+w+A|0;z=f[c>>2]|0}}else{y=0;z=d}if(z&65024){if(!(z&512)){B=y;C=z}else{d=f[a+124>>2]|0;if((d|0)>=0)if(d>>>0<128){D=1;E=z}else{A=iob(d)|0;D=A;E=f[c>>2]|0}else{D=10;E=z}B=y+1+D|0;C=E}E=C&1024|0?B+3|0:B;B=C&2048|0?E+3|0:E;E=C&4096|0?B+5|0:B;if(!(C&8192)){F=E;G=C}else{B=f[a+132>>2]|0;if((B|0)>=0)if(B>>>0<128){H=1;I=C}else{D=iob(B)|0;H=D;I=f[c>>2]|0}else{H=10;I=C}F=E+1+H|0;G=I}if(!(G&16384)){J=F;K=G}else{I=f[a+180>>2]|0;if((I|0)>=0)if(I>>>0<128){L=1;M=G}else{H=iob(I)|0;L=H;M=f[c>>2]|0}else{L=10;M=G}J=F+2+L|0;K=M}if(!(K&32768)){N=J;O=K}else{M=f[a+136>>2]|0;if((M|0)>=0)if(M>>>0<128){P=1;Q=K}else{L=iob(M)|0;P=L;Q=f[c>>2]|0}else{P=10;Q=K}N=J+1+P|0;O=Q}}else{N=y;O=z}if(O&16711680){if(!(O&65536)){R=N;S=O}else{z=f[a+184>>2]|0;if((z|0)>=0)if(z>>>0<128){T=1;U=O}else{y=iob(z)|0;T=y;U=f[c>>2]|0}else{T=10;U=O}R=N+2+T|0;S=U}if(!(S&131072)){V=R;W=S}else{U=f[a+96>>2]|0;T=b[U+11>>0]|0;if(T<<24>>24<0){y=f[U+4>>2]|0;if(y>>>0<128){X=1;Y=S;Z=y}else{U=iob(y)|0;X=U;Y=f[c>>2]|0;Z=y}}else{X=1;Y=S;Z=T&255}V=R+1+Z+X|0;W=Y}Y=W&262144|0?V+5|0:V;V=W&524288|0?Y+5|0:Y;Y=W&1048576|0?V+5|0:V;V=W&2097152|0?Y+5|0:Y;if(!(W&4194304)){_=V;$=W}else{Y=f[a+100>>2]|0;X=b[Y+11>>0]|0;if(X<<24>>24<0){Z=f[Y+4>>2]|0;if(Z>>>0<128){aa=1;ba=W;ca=Z}else{Y=iob(Z)|0;aa=Y;ba=f[c>>2]|0;ca=Z}}else{aa=1;ba=W;ca=X&255}_=V+2+ca+aa|0;$=ba}if(!($&8388608)){da=_;ea=$}else{ba=f[a+156>>2]|0;if((ba|0)>=0)if(ba>>>0<128){fa=1;ga=$}else{aa=iob(ba)|0;fa=aa;ga=f[c>>2]|0}else{fa=10;ga=$}da=_+1+fa|0;ea=ga}}else{da=N;ea=O}if(ea>>>0>33554431){O=ea&33554432|0?da+6|0:da;if(!(ea&67108864)){ha=O;ia=ea}else{N=f[a+164>>2]|0;if((N|0)>=0)if(N>>>0<128){ja=1;ka=ea}else{ga=iob(N)|0;ja=ga;ka=f[c>>2]|0}else{ja=10;ka=ea}ha=O+1+ja|0;ia=ka}if(!(ia&134217728)){la=ha;ma=ia}else{ka=f[a+104>>2]|0;ja=b[ka+11>>0]|0;if(ja<<24>>24<0){O=f[ka+4>>2]|0;if(O>>>0<128){na=1;oa=ia;pa=O}else{ka=iob(O)|0;na=ka;oa=f[c>>2]|0;pa=O}}else{na=1;oa=ia;pa=ja&255}la=ha+1+pa+na|0;ma=oa}oa=ma&268435456|0?la+3|0:la;if(!(ma&536870912)){qa=oa;ra=ma}else{la=f[a+196>>2]|0;if((la|0)>=0)if(la>>>0<128){sa=1;ta=ma}else{na=iob(la)|0;sa=na;ta=f[c>>2]|0}else{sa=10;ta=ma}qa=oa+2+sa|0;ra=ta}if(!(ra&1073741824)){ua=qa;va=ra}else{ta=f[a+200>>2]|0;if((ta|0)>=0)if(ta>>>0<128){wa=1;xa=ra}else{sa=iob(ta)|0;wa=sa;xa=f[c>>2]|0}else{wa=10;xa=ra}ua=qa+2+wa|0;va=xa}if((va|0)<0){va=f[a+168>>2]|0;if((va|0)>=0)if(va>>>0<128)ya=1;else ya=iob(va)|0;else ya=10;za=ua+2+ya|0}else za=ua}else za=da;da=a+12|0;ua=f[da>>2]|0;if(ua&255){if(!(ua&1)){Aa=za;Ba=ua}else{ua=a+208|0;ya=za+2+(job(f[ua>>2]|0,f[ua+4>>2]|0)|0)|0;Aa=ya;Ba=f[da>>2]|0}if(!(Ba&2)){Ca=Aa;Da=Ba}else{ya=f[a+108>>2]|0;ua=b[ya+11>>0]|0;if(ua<<24>>24<0){va=f[ya+4>>2]|0;if(va>>>0<128){Ea=1;Fa=Ba;Ga=va}else{ya=iob(va)|0;Ea=ya;Fa=f[da>>2]|0;Ga=va}}else{Ea=1;Fa=Ba;Ga=ua&255}Ca=Aa+2+Ga+Ea|0;Da=Fa}Fa=Da&4|0?Ca+6|0:Ca;Ca=Da&8|0?Fa+6|0:Fa;Fa=Da&16|0?Ca+6|0:Ca;Ca=Da&32|0?Fa+3|0:Fa;Fa=Da&64|0?Ca+3|0:Ca;if(!(Da&128))Ha=Fa;else{Da=f[a+172>>2]|0;if((Da|0)>=0)if(Da>>>0<128)Ia=1;else Ia=iob(Da)|0;else Ia=10;Ha=Fa+2+Ia|0}}else Ha=za;za=a+20|0;Ia=f[za>>2]|0;Fa=Ia+Ha|0;if((Ia|0)>0){Ha=a+28|0;Da=0;Ca=Fa;Ea=Ia;while(1){Ia=f[(f[Ha>>2]|0)+4+(Da<<2)>>2]|0;Ga=b[Ia+11>>0]|0;if(Ga<<24>>24<0){Aa=f[Ia+4>>2]|0;if(Aa>>>0<128){Ja=1;Ka=Aa;La=Ea}else{Ia=iob(Aa)|0;Ja=Ia;Ka=Aa;La=f[za>>2]|0}}else{Ja=1;Ka=Ga&255;La=Ea}Ga=Ka+Ca+Ja|0;Da=Da+1|0;if((Da|0)>=(La|0)){Ma=Ga;break}else{Ca=Ga;Ea=La}}}else Ma=Fa;Fa=f[a+36>>2]|0;La=(Fa<<1)+Ma|0;if(!Fa)Na=La;else{Ma=a+44|0;Ea=0;Ca=La;while(1){La=$5a(f[(f[Ma>>2]|0)+4+(Ea<<2)>>2]|0)|0;if(La>>>0<128)Oa=1;else Oa=iob(La)|0;Da=La+Ca+Oa|0;Ea=Ea+1|0;if((Ea|0)==(Fa|0)){Na=Da;break}else Ca=Da}}Ca=f[a+52>>2]|0;Fa=(Ca<<1)+Na|0;if(!Ca)Pa=Fa;else{Na=a+60|0;Ea=0;Oa=Fa;while(1){Fa=S4a(f[(f[Na>>2]|0)+4+(Ea<<2)>>2]|0)|0;if(Fa>>>0<128)Qa=1;else Qa=iob(Fa)|0;Ma=Fa+Oa+Qa|0;Ea=Ea+1|0;if((Ea|0)==(Ca|0)){Pa=Ma;break}else Oa=Ma}}Oa=a+64|0;Ca=f[Oa>>2]|0;if(!Ca){Ra=0;Sa=0}else{Ea=a+72|0;Qa=0;Na=0;do{Ma=f[(f[Ea>>2]|0)+4+(Qa<<2)>>2]|0;if((Ma|0)>=0)if(Ma>>>0<128)Ta=1;else Ta=iob(Ma)|0;else Ta=10;Na=Ta+Na|0;Qa=Qa+1|0}while((Qa|0)!=(Ca|0));Ra=Na;Sa=f[Oa>>2]|0}Oa=a+76|0;Na=f[Oa>>2]|0;if(!Na){Ua=0;Va=0}else{Ca=a+84|0;Qa=0;Ta=0;do{Ea=f[(f[Ca>>2]|0)+4+(Ta<<2)>>2]|0;if((Ea|0)>=0)if(Ea>>>0<128)Wa=1;else Wa=iob(Ea)|0;else Wa=10;Qa=Wa+Qa|0;Ta=Ta+1|0}while((Ta|0)!=(Na|0));Ua=Qa;Va=f[Oa>>2]<<1}Oa=Ra+Pa+Sa+Ua+Va|0;Va=f[a+4>>2]|0;if(!(Va&1)){Xa=Oa;Ya=a+224|0;f[Ya>>2]=Xa;return Xa|0}Xa=(dQb(Va&-2)|0)+Oa|0;Ya=a+224|0;f[Ya>>2]=Xa;return Xa|0}function C5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=a+8|0;if(f[d>>2]&4|0)$pb(1,f[a+92>>2]|0,c);e=a+20|0;if((f[e>>2]|0)>0){g=a+28|0;h=0;do{_pb(2,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)<(f[e>>2]|0))}e=a+64|0;if((f[e>>2]|0)>0){h=a+72|0;g=0;do{Mpb(3,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)<(f[e>>2]|0))}e=f[d>>2]|0;if(!(e&512))i=e;else{Mpb(4,f[a+124>>2]|0,c);i=f[d>>2]|0}if(!(i&4096))j=i;else{Wpb(5,+n[a+128>>2],c);j=f[d>>2]|0}if(!(j&8192))k=j;else{Mpb(6,f[a+132>>2]|0,c);k=f[d>>2]|0}if(!(k&32768))l=k;else{Mpb(7,f[a+136>>2]|0,c);l=f[d>>2]|0}if(!(l&131072))m=l;else{$pb(8,f[a+96>>2]|0,c);m=f[d>>2]|0}if(!(m&262144))o=m;else{Wpb(9,+n[a+140>>2],c);o=f[d>>2]|0}if(!(o&524288))p=o;else{Wpb(10,+n[a+144>>2],c);p=f[d>>2]|0}if(!(p&1048576))q=p;else{Wpb(11,+n[a+148>>2],c);q=f[d>>2]|0}if(!(q&2097152))r=q;else{Wpb(12,+n[a+152>>2],c);r=f[d>>2]|0}if(!(r&8388608))s=r;else{Mpb(13,f[a+156>>2]|0,c);s=f[d>>2]|0}if(!(s&67108864))t=s;else{Mpb(14,f[a+164>>2]|0,c);t=f[d>>2]|0}if(!(t&134217728))u=t;else{$pb(15,f[a+104>>2]|0,c);u=f[d>>2]|0}if(!(u&268435456))v=u;else{Ypb(16,(b[a+161>>0]|0)!=0,c);v=f[d>>2]|0}if(!(v&1073741824))w=v;else{Zpb(17,f[a+200>>2]|0,c);w=f[d>>2]|0}if((w|0)<0){Mpb(18,f[a+168>>2]|0,c);x=f[d>>2]|0}else x=w;if(x&1024|0)Ypb(19,(b[a+160>>0]|0)!=0,c);x=a+12|0;if(f[x>>2]&1|0){w=a+208|0;Npb(20,f[w>>2]|0,f[w+4>>2]|0,c)}if(f[d>>2]&16|0)eqb(21,f[a+116>>2]|0,c);w=f[a+36>>2]|0;if(w|0){v=a+44|0;u=0;do{eqb(22,f[(f[v>>2]|0)+4+(u<<2)>>2]|0,c);u=u+1|0}while((u|0)!=(w|0))}if(f[x>>2]&32|0)Ypb(23,(b[a+162>>0]|0)!=0,c);w=f[d>>2]|0;if(!(w&1))y=w;else{$pb(24,f[a+88>>2]|0,c);y=f[d>>2]|0}if(!(y&2))z=y;else{eqb(25,f[a+112>>2]|0,c);z=f[d>>2]|0}if(z&64|0)eqb(26,f[a+120>>2]|0,c);z=f[a+52>>2]|0;if(z|0){y=a+60|0;w=0;do{eqb(27,f[(f[y>>2]|0)+4+(w<<2)>>2]|0,c);w=w+1|0}while((w|0)!=(z|0))}if(f[x>>2]&64|0)Ypb(28,(b[a+189>>0]|0)!=0,c);if(f[d>>2]&4194304|0)$pb(29,f[a+100>>2]|0,c);z=f[x>>2]|0;if(!(z&128))A=z;else{Zpb(30,f[a+172>>2]|0,c);A=f[x>>2]|0}if(A&4|0)Wpb(31,+n[a+216>>2],c);A=f[d>>2]|0;if(!(A&2048))B=A;else{Ypb(32,(b[a+188>>0]|0)!=0,c);B=f[d>>2]|0}if(B&16384|0)Mpb(33,f[a+180>>2]|0,c);B=a+76|0;if((f[B>>2]|0)>0){A=a+84|0;z=0;do{Mpb(34,f[(f[A>>2]|0)+4+(z<<2)>>2]|0,c);z=z+1|0}while((z|0)<(f[B>>2]|0))}B=f[d>>2]|0;if(!(B&33554432))C=B;else{Wpb(35,+n[a+192>>2],c);C=f[d>>2]|0}if(!(C&65536))D=C;else{Mpb(36,f[a+184>>2]|0,c);D=f[d>>2]|0}if(D&536870912|0)Zpb(37,f[a+196>>2]|0,c);D=f[x>>2]|0;if(!(D&16))E=D;else{Wpb(38,+n[a+176>>2],c);E=f[x>>2]|0}if(!(E&8))F=E;else{Wpb(39,+n[a+220>>2],c);F=f[x>>2]|0}if(F&2|0)$pb(40,f[a+108>>2]|0,c);F=f[a+4>>2]|0;if(!(F&1))return;aQb(F&-2,c);return}function D5a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function E5a(a){a=a|0;return f[a+224>>2]|0}function F5a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;c=a+8|0;if(!(f[c>>2]&4))e=d;else{g=f[a+92>>2]|0;b[d>>0]=10;e=kob(g,d+1|0)|0}d=a+20|0;if((f[d>>2]|0)>0){g=a+28|0;h=0;i=e;while(1){j=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=18;k=kob(j,i+1|0)|0;h=h+1|0;if((h|0)>=(f[d>>2]|0)){l=k;break}else i=k}}else l=e;e=a+64|0;if((f[e>>2]|0)>0){i=a+72|0;d=0;h=l;while(1){g=f[(f[i>>2]|0)+4+(d<<2)>>2]|0;b[h>>0]=24;k=h+1|0;if((g|0)<0)m=hob(g,((g|0)<0)<<31>>31,k)|0;else{if(g>>>0>127){j=g;n=k;while(1){b[n>>0]=j|128;o=j>>>7;p=n+1|0;if(j>>>0>16383){j=o;n=p}else{q=p;r=o;break}}}else{q=k;r=g}b[q>>0]=r;m=q+1|0}d=d+1|0;if((d|0)>=(f[e>>2]|0)){s=m;break}else h=m}}else s=l;do if(!(f[c>>2]&512))t=s;else{l=f[a+124>>2]|0;b[s>>0]=32;m=s+1|0;if((l|0)<0){t=hob(l,((l|0)<0)<<31>>31,m)|0;break}if(l>>>0>127){h=l;e=m;while(1){b[e>>0]=h|128;d=h>>>7;q=e+1|0;if(h>>>0>16383){h=d;e=q}else{u=q;v=d;break}}}else{u=m;v=l}b[u>>0]=v;t=u+1|0}while(0);u=f[c>>2]|0;if(!(u&4096)){w=t;x=u}else{u=f[a+128>>2]|0;b[t>>0]=45;v=t+1|0;b[v>>0]=u;b[v+1>>0]=u>>8;b[v+2>>0]=u>>16;b[v+3>>0]=u>>24;w=t+5|0;x=f[c>>2]|0}do if(!(x&8192))y=w;else{t=f[a+132>>2]|0;b[w>>0]=48;u=w+1|0;if((t|0)<0){y=hob(t,((t|0)<0)<<31>>31,u)|0;break}if(t>>>0>127){v=t;s=u;while(1){b[s>>0]=v|128;e=v>>>7;h=s+1|0;if(v>>>0>16383){v=e;s=h}else{z=h;A=e;break}}}else{z=u;A=t}b[z>>0]=A;y=z+1|0}while(0);do if(!(f[c>>2]&32768))B=y;else{z=f[a+136>>2]|0;b[y>>0]=56;A=y+1|0;if((z|0)<0){B=hob(z,((z|0)<0)<<31>>31,A)|0;break}if(z>>>0>127){w=z;x=A;while(1){b[x>>0]=w|128;s=w>>>7;v=x+1|0;if(w>>>0>16383){w=s;x=v}else{C=v;D=s;break}}}else{C=A;D=z}b[C>>0]=D;B=C+1|0}while(0);C=f[c>>2]|0;if(!(C&131072)){E=B;F=C}else{C=f[a+96>>2]|0;b[B>>0]=66;D=kob(C,B+1|0)|0;E=D;F=f[c>>2]|0}if(!(F&262144)){G=E;H=F}else{F=f[a+140>>2]|0;b[E>>0]=77;D=E+1|0;b[D>>0]=F;b[D+1>>0]=F>>8;b[D+2>>0]=F>>16;b[D+3>>0]=F>>24;G=E+5|0;H=f[c>>2]|0}if(!(H&524288)){I=G;J=H}else{H=f[a+144>>2]|0;b[G>>0]=85;E=G+1|0;b[E>>0]=H;b[E+1>>0]=H>>8;b[E+2>>0]=H>>16;b[E+3>>0]=H>>24;I=G+5|0;J=f[c>>2]|0}if(!(J&1048576)){K=I;L=J}else{J=f[a+148>>2]|0;b[I>>0]=93;G=I+1|0;b[G>>0]=J;b[G+1>>0]=J>>8;b[G+2>>0]=J>>16;b[G+3>>0]=J>>24;K=I+5|0;L=f[c>>2]|0}if(!(L&2097152)){M=K;N=L}else{L=f[a+152>>2]|0;b[K>>0]=101;I=K+1|0;b[I>>0]=L;b[I+1>>0]=L>>8;b[I+2>>0]=L>>16;b[I+3>>0]=L>>24;M=K+5|0;N=f[c>>2]|0}do if(!(N&8388608))O=M;else{K=f[a+156>>2]|0;b[M>>0]=104;L=M+1|0;if((K|0)<0){O=hob(K,((K|0)<0)<<31>>31,L)|0;break}if(K>>>0>127){I=K;J=L;while(1){b[J>>0]=I|128;G=I>>>7;H=J+1|0;if(I>>>0>16383){I=G;J=H}else{P=H;Q=G;break}}}else{P=L;Q=K}b[P>>0]=Q;O=P+1|0}while(0);do if(!(f[c>>2]&67108864))R=O;else{P=f[a+164>>2]|0;b[O>>0]=112;Q=O+1|0;if((P|0)<0){R=hob(P,((P|0)<0)<<31>>31,Q)|0;break}if(P>>>0>127){M=P;N=Q;while(1){b[N>>0]=M|128;J=M>>>7;I=N+1|0;if(M>>>0>16383){M=J;N=I}else{S=I;T=J;break}}}else{S=Q;T=P}b[S>>0]=T;R=S+1|0}while(0);S=f[c>>2]|0;if(!(S&134217728)){U=R;V=S}else{S=f[a+104>>2]|0;b[R>>0]=122;T=kob(S,R+1|0)|0;U=T;V=f[c>>2]|0}if(!(V&268435456)){W=U;X=V}else{V=b[a+161>>0]|0;b[U>>0]=-128;b[U+1>>0]=1;b[U+2>>0]=V;W=U+3|0;X=f[c>>2]|0}if(!(X&1073741824)){Y=W;Z=X}else{X=f[a+200>>2]|0;b[W>>0]=-120;b[W+1>>0]=1;U=W+2|0;if((X|0)<0)_=hob(X,((X|0)<0)<<31>>31,U)|0;else{if(X>>>0>127){W=X;V=U;while(1){b[V>>0]=W|128;T=W>>>7;R=V+1|0;if(W>>>0>16383){W=T;V=R}else{$=R;aa=T;break}}}else{$=U;aa=X}b[$>>0]=aa;_=$+1|0}Y=_;Z=f[c>>2]|0}do if((Z|0)<0){_=f[a+168>>2]|0;b[Y>>0]=-112;b[Y+1>>0]=1;$=Y+2|0;if((_|0)<0){ba=hob(_,((_|0)<0)<<31>>31,$)|0;break}if(_>>>0>127){aa=_;X=$;while(1){b[X>>0]=aa|128;U=aa>>>7;V=X+1|0;if(aa>>>0>16383){aa=U;X=V}else{ca=V;da=U;break}}}else{ca=$;da=_}b[ca>>0]=da;ba=ca+1|0}else ba=Y;while(0);if(!(f[c>>2]&1024))ea=ba;else{Y=b[a+160>>0]|0;b[ba>>0]=-104;b[ba+1>>0]=1;b[ba+2>>0]=Y;ea=ba+3|0}ba=a+12|0;if(!(f[ba>>2]&1))fa=ea;else{Y=a+208|0;ca=f[Y>>2]|0;da=f[Y+4>>2]|0;b[ea>>0]=-96;b[ea+1>>0]=1;fa=hob(ca,da,ea+2|0)|0}if(!(f[c>>2]&16))ga=fa;else{ea=f[a+116>>2]|0;b[fa>>0]=-86;b[fa+1>>0]=1;da=fa+2|0;fa=f[ea+12>>2]|0;if(fa>>>0>127){ca=fa;Y=da;while(1){b[Y>>0]=ca|128;Z=ca>>>7;X=Y+1|0;if(ca>>>0>16383){ca=Z;Y=X}else{ha=X;ia=Z;break}}}else{ha=da;ia=fa}b[ha>>0]=ia;ga=li[f[(f[ea>>2]|0)+68>>2]&511](ea,0,ha+1|0)|0}ha=f[a+36>>2]|0;if(!ha)ja=ga;else{ea=a+44|0;ia=0;fa=ga;while(1){ga=f[(f[ea>>2]|0)+4+(ia<<2)>>2]|0;b[fa>>0]=-78;b[fa+1>>0]=1;da=fa+2|0;Y=f[ga+12>>2]|0;if(Y>>>0>127){ca=Y;Z=da;while(1){b[Z>>0]=ca|128;X=ca>>>7;aa=Z+1|0;if(ca>>>0>16383){ca=X;Z=aa}else{ka=aa;la=X;break}}}else{ka=da;la=Y}b[ka>>0]=la;Z=li[f[(f[ga>>2]|0)+68>>2]&511](ga,0,ka+1|0)|0;ia=ia+1|0;if((ia|0)==(ha|0)){ja=Z;break}else fa=Z}}if(!(f[ba>>2]&32))ma=ja;else{fa=b[a+162>>0]|0;b[ja>>0]=-72;b[ja+1>>0]=1;b[ja+2>>0]=fa;ma=ja+3|0}ja=f[c>>2]|0;if(!(ja&1)){na=ma;oa=ja}else{ja=f[a+88>>2]|0;b[ma>>0]=-62;b[ma+1>>0]=1;fa=kob(ja,ma+2|0)|0;na=fa;oa=f[c>>2]|0}if(!(oa&2)){pa=na;qa=oa}else{oa=f[a+112>>2]|0;b[na>>0]=-54;b[na+1>>0]=1;fa=na+2|0;na=f[oa+12>>2]|0;if(na>>>0>127){ma=na;ja=fa;while(1){b[ja>>0]=ma|128;ha=ma>>>7;ia=ja+1|0;if(ma>>>0>16383){ma=ha;ja=ia}else{ra=ia;sa=ha;break}}}else{ra=fa;sa=na}b[ra>>0]=sa;sa=li[f[(f[oa>>2]|0)+68>>2]&511](oa,0,ra+1|0)|0;pa=sa;qa=f[c>>2]|0}if(!(qa&64))ta=pa;else{qa=f[a+120>>2]|0;b[pa>>0]=-46;b[pa+1>>0]=1;sa=pa+2|0;pa=f[qa+12>>2]|0;if(pa>>>0>127){ra=pa;oa=sa;while(1){b[oa>>0]=ra|128;na=ra>>>7;fa=oa+1|0;if(ra>>>0>16383){ra=na;oa=fa}else{ua=fa;va=na;break}}}else{ua=sa;va=pa}b[ua>>0]=va;ta=li[f[(f[qa>>2]|0)+68>>2]&511](qa,0,ua+1|0)|0}ua=f[a+52>>2]|0;if(!ua)wa=ta;else{qa=a+60|0;va=0;pa=ta;while(1){ta=f[(f[qa>>2]|0)+4+(va<<2)>>2]|0;b[pa>>0]=-38;b[pa+1>>0]=1;sa=pa+2|0;oa=f[ta+12>>2]|0;if(oa>>>0>127){ra=oa;na=sa;while(1){b[na>>0]=ra|128;fa=ra>>>7;ja=na+1|0;if(ra>>>0>16383){ra=fa;na=ja}else{xa=ja;ya=fa;break}}}else{xa=sa;ya=oa}b[xa>>0]=ya;na=li[f[(f[ta>>2]|0)+68>>2]&511](ta,0,xa+1|0)|0;va=va+1|0;if((va|0)==(ua|0)){wa=na;break}else pa=na}}if(!(f[ba>>2]&64))za=wa;else{pa=b[a+189>>0]|0;b[wa>>0]=-32;b[wa+1>>0]=1;b[wa+2>>0]=pa;za=wa+3|0}if(!(f[c>>2]&4194304))Aa=za;else{wa=f[a+100>>2]|0;b[za>>0]=-22;b[za+1>>0]=1;Aa=kob(wa,za+2|0)|0}do if(!(f[ba>>2]&128))Ba=Aa;else{za=f[a+172>>2]|0;b[Aa>>0]=-16;b[Aa+1>>0]=1;wa=Aa+2|0;if((za|0)<0){Ba=hob(za,((za|0)<0)<<31>>31,wa)|0;break}if(za>>>0>127){pa=za;ua=wa;while(1){b[ua>>0]=pa|128;va=pa>>>7;xa=ua+1|0;if(pa>>>0>16383){pa=va;ua=xa}else{Ca=xa;Da=va;break}}}else{Ca=wa;Da=za}b[Ca>>0]=Da;Ba=Ca+1|0}while(0);if(!(f[ba>>2]&4))Ea=Ba;else{Ca=f[a+216>>2]|0;b[Ba>>0]=-3;b[Ba+1>>0]=1;Da=Ba+2|0;b[Da>>0]=Ca;b[Da+1>>0]=Ca>>8;b[Da+2>>0]=Ca>>16;b[Da+3>>0]=Ca>>24;Ea=Ba+6|0}Ba=f[c>>2]|0;if(!(Ba&2048)){Fa=Ea;Ga=Ba}else{Ba=b[a+188>>0]|0;b[Ea>>0]=-128;b[Ea+1>>0]=2;b[Ea+2>>0]=Ba;Fa=Ea+3|0;Ga=f[c>>2]|0}do if(!(Ga&16384))Ha=Fa;else{Ea=f[a+180>>2]|0;b[Fa>>0]=-120;b[Fa+1>>0]=2;Ba=Fa+2|0;if((Ea|0)<0){Ha=hob(Ea,((Ea|0)<0)<<31>>31,Ba)|0;break}if(Ea>>>0>127){Ca=Ea;Da=Ba;while(1){b[Da>>0]=Ca|128;Aa=Ca>>>7;ua=Da+1|0;if(Ca>>>0>16383){Ca=Aa;Da=ua}else{Ia=ua;Ja=Aa;break}}}else{Ia=Ba;Ja=Ea}b[Ia>>0]=Ja;Ha=Ia+1|0}while(0);Ia=a+76|0;if((f[Ia>>2]|0)>0){Ja=a+84|0;Fa=0;Ga=Ha;while(1){Da=f[(f[Ja>>2]|0)+4+(Fa<<2)>>2]|0;b[Ga>>0]=-112;b[Ga+1>>0]=2;Ca=Ga+2|0;if((Da|0)<0)Ka=hob(Da,((Da|0)<0)<<31>>31,Ca)|0;else{if(Da>>>0>127){za=Da;wa=Ca;while(1){b[wa>>0]=za|128;Aa=za>>>7;ua=wa+1|0;if(za>>>0>16383){za=Aa;wa=ua}else{La=ua;Ma=Aa;break}}}else{La=Ca;Ma=Da}b[La>>0]=Ma;Ka=La+1|0}Fa=Fa+1|0;if((Fa|0)>=(f[Ia>>2]|0)){Na=Ka;break}else Ga=Ka}}else Na=Ha;Ha=f[c>>2]|0;if(!(Ha&33554432)){Oa=Na;Pa=Ha}else{Ha=f[a+192>>2]|0;b[Na>>0]=-99;b[Na+1>>0]=2;Ka=Na+2|0;b[Ka>>0]=Ha;b[Ka+1>>0]=Ha>>8;b[Ka+2>>0]=Ha>>16;b[Ka+3>>0]=Ha>>24;Oa=Na+6|0;Pa=f[c>>2]|0}do if(!(Pa&65536))Qa=Oa;else{Na=f[a+184>>2]|0;b[Oa>>0]=-96;b[Oa+1>>0]=2;Ha=Oa+2|0;if((Na|0)<0){Qa=hob(Na,((Na|0)<0)<<31>>31,Ha)|0;break}if(Na>>>0>127){Ka=Na;Ga=Ha;while(1){b[Ga>>0]=Ka|128;Ia=Ka>>>7;Fa=Ga+1|0;if(Ka>>>0>16383){Ka=Ia;Ga=Fa}else{Ra=Fa;Sa=Ia;break}}}else{Ra=Ha;Sa=Na}b[Ra>>0]=Sa;Qa=Ra+1|0}while(0);do if(!(f[c>>2]&536870912))Ta=Qa;else{Ra=f[a+196>>2]|0;b[Qa>>0]=-88;b[Qa+1>>0]=2;Sa=Qa+2|0;if((Ra|0)<0){Ta=hob(Ra,((Ra|0)<0)<<31>>31,Sa)|0;break}if(Ra>>>0>127){Oa=Ra;Pa=Sa;while(1){b[Pa>>0]=Oa|128;Ga=Oa>>>7;Ka=Pa+1|0;if(Oa>>>0>16383){Oa=Ga;Pa=Ka}else{Ua=Ka;Va=Ga;break}}}else{Ua=Sa;Va=Ra}b[Ua>>0]=Va;Ta=Ua+1|0}while(0);Ua=f[ba>>2]|0;if(!(Ua&16)){Wa=Ta;Xa=Ua}else{Ua=f[a+176>>2]|0;b[Ta>>0]=-75;b[Ta+1>>0]=2;Va=Ta+2|0;b[Va>>0]=Ua;b[Va+1>>0]=Ua>>8;b[Va+2>>0]=Ua>>16;b[Va+3>>0]=Ua>>24;Wa=Ta+6|0;Xa=f[ba>>2]|0}if(!(Xa&8)){Ya=Wa;Za=Xa}else{Xa=f[a+220>>2]|0;b[Wa>>0]=-67;b[Wa+1>>0]=2;Ta=Wa+2|0;b[Ta>>0]=Xa;b[Ta+1>>0]=Xa>>8;b[Ta+2>>0]=Xa>>16;b[Ta+3>>0]=Xa>>24;Ya=Wa+6|0;Za=f[ba>>2]|0}if(!(Za&2))_a=Ya;else{Za=f[a+108>>2]|0;b[Ya>>0]=-62;b[Ya+1>>0]=2;_a=kob(Za,Ya+2|0)|0}Ya=f[a+4>>2]|0;if(!(Ya&1)){$a=_a;return $a|0}$a=bQb(Ya&-2,_a)|0;return $a|0}function G5a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function H5a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(11839);c=T6b(b,23288,19752,0)|0;if(!c){cOb(b,a);return}else{K5a(a,c);return}}function I5a(a,b){a=a|0;b=b|0;f[a+224>>2]=b;return}function J5a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213058];f[a+4>>2]=f[213059];u=c;return}function K5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=u;u=u+32|0;e=d+24|0;g=d+20|0;h=d+16|0;i=d+12|0;j=d+8|0;k=d+4|0;l=d;UDa(a+16|0,c+16|0);L5a(a+32|0,c+32|0);M5a(a+48|0,c+48|0);m=a+64|0;n=c+64|0;o=f[n>>2]|0;if(o|0){nza(m,(f[m>>2]|0)+o|0);Vac((f[a+72>>2]|0)+4+(f[m>>2]<<2)|0,(f[c+72>>2]|0)+4|0,f[n>>2]<<2|0)|0;f[m>>2]=(f[m>>2]|0)+(f[n>>2]|0)}n=a+76|0;m=c+76|0;o=f[m>>2]|0;if(o|0){nza(n,(f[n>>2]|0)+o|0);Vac((f[a+84>>2]|0)+4+(f[n>>2]<<2)|0,(f[c+84>>2]|0)+4|0,f[m>>2]<<2|0)|0;f[n>>2]=(f[n>>2]|0)+(f[m>>2]|0)}m=c+8|0;n=f[m>>2]|0;if(n&255|0){if(!(n&1))p=n;else{n=a+8|0;f[n>>2]=f[n>>2]|1;f[g>>2]=f[c+88>>2];f[e>>2]=f[g>>2];Anb(a+88|0,497760,e);p=f[m>>2]|0}do if(p&2){g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+112|0;n=f[g>>2]|0;if(!n){o=L5b(104)|0;N5a(o);f[g>>2]=o;q=o}else q=n;n=f[c+112>>2]|0;o=(n|0)==0?493600:n;if((o|0)==(q|0))jMa(9641);else{O5a(q,o);r=f[m>>2]|0;break}}else r=p;while(0);if(!(r&4))s=r;else{r=a+8|0;f[r>>2]=f[r>>2]|4;f[h>>2]=f[c+92>>2];f[e>>2]=f[h>>2];Anb(a+92|0,497760,e);s=f[m>>2]|0}do if(s&16){h=a+8|0;f[h>>2]=f[h>>2]|16;h=a+116|0;r=f[h>>2]|0;if(!r){p=L5b(104)|0;N5a(p);f[h>>2]=p;t=p}else t=r;r=f[c+116>>2]|0;p=(r|0)==0?493600:r;if((p|0)==(t|0))jMa(9641);else{O5a(t,p);v=f[m>>2]|0;break}}else v=s;while(0);if(v&64|0){v=a+8|0;f[v>>2]=f[v>>2]|64;v=a+120|0;s=f[v>>2]|0;if(!s){t=L5b(40)|0;$4a(t);f[v>>2]=t;w=t}else w=s;s=f[c+120>>2]|0;t=(s|0)==0?494008:s;if((t|0)==(w|0))jMa(14185);UDa(w+16|0,t+16|0);s=t+8|0;v=f[s>>2]|0;if(v&255|0){if(!(v&1))x=v;else{v=f[t+36>>2]|0;p=w+8|0;f[p>>2]=f[p>>2]|1;f[w+36>>2]=v;x=f[s>>2]|0}if(x&2|0){x=f[t+32>>2]|0;s=w+8|0;f[s>>2]=f[s>>2]|2;f[w+32>>2]=x}}x=f[t+4>>2]|0;if(x&1|0)LPb(x&-2,w+4|0)}}w=f[m>>2]|0;if(w&130560){if(!(w&512))y=w;else{x=f[c+124>>2]|0;t=a+8|0;f[t>>2]=f[t>>2]|512;f[a+124>>2]=x;y=f[m>>2]|0}if(!(y&1024))z=y;else{y=b[c+160>>0]|0;x=a+8|0;f[x>>2]=f[x>>2]|1024;b[a+160>>0]=y;z=f[m>>2]|0}if(!(z&2048))A=z;else{z=b[c+188>>0]|0;y=a+8|0;f[y>>2]=f[y>>2]|2048;b[a+188>>0]=z;A=f[m>>2]|0}if(!(A&4096))B=A;else{A=f[c+128>>2]|0;z=a+8|0;f[z>>2]=f[z>>2]|4096;f[a+128>>2]=A;B=f[m>>2]|0}if(!(B&8192))C=B;else{B=f[c+132>>2]|0;A=a+8|0;f[A>>2]=f[A>>2]|8192;f[a+132>>2]=B;C=f[m>>2]|0}if(!(C&16384))D=C;else{C=f[c+180>>2]|0;B=a+8|0;f[B>>2]=f[B>>2]|16384;f[a+180>>2]=C;D=f[m>>2]|0}if(!(D&32768))E=D;else{D=f[c+136>>2]|0;C=a+8|0;f[C>>2]=f[C>>2]|32768;f[a+136>>2]=D;E=f[m>>2]|0}}else E=w;if(E&16711680){if(!(E&65536))F=E;else{w=f[c+184>>2]|0;D=a+8|0;f[D>>2]=f[D>>2]|65536;f[a+184>>2]=w;F=f[m>>2]|0}if(!(F&131072))G=F;else{F=a+8|0;f[F>>2]=f[F>>2]|131072;f[i>>2]=f[c+96>>2];f[e>>2]=f[i>>2];Anb(a+96|0,497760,e);G=f[m>>2]|0}if(!(G&262144))H=G;else{G=f[c+140>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|262144;f[a+140>>2]=G;H=f[m>>2]|0}if(!(H&524288))I=H;else{H=f[c+144>>2]|0;G=a+8|0;f[G>>2]=f[G>>2]|524288;f[a+144>>2]=H;I=f[m>>2]|0}if(!(I&1048576))J=I;else{I=f[c+148>>2]|0;H=a+8|0;f[H>>2]=f[H>>2]|1048576;f[a+148>>2]=I;J=f[m>>2]|0}if(!(J&2097152))K=J;else{J=f[c+152>>2]|0;I=a+8|0;f[I>>2]=f[I>>2]|2097152;f[a+152>>2]=J;K=f[m>>2]|0}if(!(K&4194304))L=K;else{K=a+8|0;f[K>>2]=f[K>>2]|4194304;K=f[213029]|0;f[j>>2]=f[c+100>>2];f[e>>2]=f[j>>2];Anb(a+100|0,K,e);L=f[m>>2]|0}if(!(L&8388608))M=L;else{L=f[c+156>>2]|0;K=a+8|0;f[K>>2]=f[K>>2]|8388608;f[a+156>>2]=L;M=f[m>>2]|0}}else M=E;if(M>>>0>33554431){if(!(M&33554432))N=M;else{M=f[c+192>>2]|0;E=a+8|0;f[E>>2]=f[E>>2]|33554432;f[a+192>>2]=M;N=f[m>>2]|0}if(!(N&67108864))O=N;else{N=f[c+164>>2]|0;M=a+8|0;f[M>>2]=f[M>>2]|67108864;f[a+164>>2]=N;O=f[m>>2]|0}if(!(O&134217728))P=O;else{O=a+8|0;f[O>>2]=f[O>>2]|134217728;f[k>>2]=f[c+104>>2];f[e>>2]=f[k>>2];Anb(a+104|0,497760,e);P=f[m>>2]|0}if(!(P&268435456))Q=P;else{P=b[c+161>>0]|0;k=a+8|0;f[k>>2]=f[k>>2]|268435456;b[a+161>>0]=P;Q=f[m>>2]|0}if(!(Q&536870912))R=Q;else{Q=f[c+196>>2]|0;P=a+8|0;f[P>>2]=f[P>>2]|536870912;f[a+196>>2]=Q;R=f[m>>2]|0}if(!(R&1073741824))S=R;else{R=f[c+200>>2]|0;Q=a+8|0;f[Q>>2]=f[Q>>2]|1073741824;f[a+200>>2]=R;S=f[m>>2]|0}if((S|0)<0){S=f[c+168>>2]|0;m=a+8|0;f[m>>2]=f[m>>2]|-2147483648;f[a+168>>2]=S}}S=c+12|0;m=f[S>>2]|0;if(m&255|0){if(!(m&1))T=m;else{m=c+208|0;R=f[m>>2]|0;Q=f[m+4>>2]|0;m=a+12|0;f[m>>2]=f[m>>2]|1;m=a+208|0;f[m>>2]=R;f[m+4>>2]=Q;T=f[S>>2]|0}if(!(T&2))U=T;else{T=a+12|0;f[T>>2]=f[T>>2]|2;T=f[213030]|0;f[l>>2]=f[c+108>>2];f[e>>2]=f[l>>2];Anb(a+108|0,T,e);U=f[S>>2]|0}if(!(U&4))V=U;else{U=f[c+216>>2]|0;e=a+12|0;f[e>>2]=f[e>>2]|4;f[a+216>>2]=U;V=f[S>>2]|0}if(!(V&8))W=V;else{V=f[c+220>>2]|0;U=a+12|0;f[U>>2]=f[U>>2]|8;f[a+220>>2]=V;W=f[S>>2]|0}if(!(W&16))X=W;else{W=f[c+176>>2]|0;V=a+12|0;f[V>>2]=f[V>>2]|16;f[a+176>>2]=W;X=f[S>>2]|0}if(!(X&32))Y=X;else{X=b[c+162>>0]|0;W=a+12|0;f[W>>2]=f[W>>2]|32;b[a+162>>0]=X;Y=f[S>>2]|0}if(!(Y&64))Z=Y;else{Y=b[c+189>>0]|0;X=a+12|0;f[X>>2]=f[X>>2]|64;b[a+189>>0]=Y;Z=f[S>>2]|0}if(Z&128|0){Z=f[c+172>>2]|0;S=a+12|0;f[S>>2]=f[S>>2]|128;f[a+172>>2]=Z}}Z=f[c+4>>2]|0;if(!(Z&1)){u=d;return}LPb(Z&-2,a+4|0);u=d;return}function L5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{X5a(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Y5a(h,i)|0;X5a(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function M5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{T5a(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=U5a(h,i)|0;T5a(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function N5a(a){a=a|0;var c=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;e=c;f[a>>2]=112212;f[a+4>>2]=0;f[a+8>>2]=0;g=(a|0)==493600;h=a+16|0;i=h+76|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));if(!g?(f[213033]|0)!=2:0){f[e>>2]=135812;f[e+4>>2]=41;b[e+8>>0]=0;Gpb(852132,e);hpb(e)}f[a+12>>2]=0;f[a+92>>2]=497760;f[a+96>>2]=0;d[a+100>>1]=0;u=c;return}function O5a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d+4|0;g=d;UDa(a+16|0,c+16|0);tPa(a+32|0,c+32|0);h=a+48|0;i=c+48|0;j=f[i>>2]|0;if(j|0){nza(h,(f[h>>2]|0)+j|0);Vac((f[a+56>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+56>>2]|0)+4|0,f[i>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[i>>2]|0)}P5a(a+60|0,c+60|0);Q5a(a+76|0,c+76|0);i=c+8|0;h=f[i>>2]|0;if(h&255|0){if(!(h&1))k=h;else{h=a+8|0;f[h>>2]=f[h>>2]|1;f[g>>2]=f[c+92>>2];f[e>>2]=f[g>>2];Anb(a+92|0,497760,e);k=f[i>>2]|0}if(!(k&16))l=k;else{k=b[c+100>>0]|0;e=a+8|0;f[e>>2]=f[e>>2]|16;b[a+100>>0]=k;l=f[i>>2]|0}if(l&32|0){l=a+8|0;f[l>>2]=f[l>>2]|32;l=a+96|0;k=f[l>>2]|0;if(!k){e=L5b(40)|0;$4a(e);f[l>>2]=e;m=e}else m=k;k=f[c+96>>2]|0;e=(k|0)==0?494008:k;if((e|0)==(m|0))jMa(14185);UDa(m+16|0,e+16|0);k=e+8|0;l=f[k>>2]|0;if(l&255|0){if(!(l&1))n=l;else{l=f[e+36>>2]|0;g=m+8|0;f[g>>2]=f[g>>2]|1;f[m+36>>2]=l;n=f[k>>2]|0}if(n&2|0){n=f[e+32>>2]|0;k=m+8|0;f[k>>2]=f[k>>2]|2;f[m+32>>2]=n}}n=f[e+4>>2]|0;if(n&1|0)LPb(n&-2,m+4|0)}if(f[i>>2]&64|0){i=b[c+101>>0]|0;m=a+8|0;f[m>>2]=f[m>>2]|64;b[a+101>>0]=i}}i=f[c+4>>2]|0;if(!(i&1)){u=d;return}LPb(i&-2,a+4|0);u=d;return}function P5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{S5a(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Fza(h,i)|0;S5a(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function Q5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{R5a(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=kza(h,i)|0;R5a(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function R5a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))jMa(48612);else{COa(b,a);return}}function S5a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))jMa(18445);else{I3a(b,a);return}}function T5a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))jMa(14185);UDa(b+16|0,a+16|0);c=a+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[a+36>>2]|0;g=b+8|0;f[g>>2]=f[g>>2]|1;f[b+36>>2]=d;e=f[c>>2]|0}if(e&2|0){e=f[a+32>>2]|0;c=b+8|0;f[c>>2]=f[c>>2]|2;f[b+32>>2]=e}}e=f[a+4>>2]|0;if(!(e&1))return;LPb(e&-2,b+4|0);return}function U5a(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=V5a(b,c)|0;u=a;return d|0}function V5a(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(40)|0;$4a(b);c=b;return c|0}else{b=znb(a,19720,40)|0;$4a(b);xnb(a,b,1504);c=b;return c|0}return 0}function W5a(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function X5a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))jMa(9641);else{O5a(b,a);return}}function Y5a(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=Z5a(b,c)|0;u=a;return d|0}function Z5a(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(104)|0;N5a(b);c=b;return c|0}else{b=znb(a,19768,104)|0;N5a(b);xnb(a,b,1505);c=b;return c|0}return 0}function _5a(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function $5a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;c=a+8|0;d=f[c>>2]|0;if(!(d&113))e=0;else{if(!(d&1)){g=0;h=d}else{i=f[a+92>>2]|0;j=b[i+11>>0]|0;if(j<<24>>24<0){k=f[i+4>>2]|0;if(k>>>0<128){l=1;m=d;n=k}else{i=iob(k)|0;l=i;m=f[c>>2]|0;n=k}}else{l=1;m=d;n=j&255}g=n+1+l|0;h=m}m=h&16|0?g+2|0:g;if(!(h&32)){o=m;p=h}else{h=S4a(f[a+96>>2]|0)|0;if(h>>>0<128)q=1;else q=iob(h)|0;o=m+1+h+q|0;p=f[c>>2]|0}e=p&64|0?o+2|0:o}o=a+20|0;p=f[o>>2]|0;c=p+e|0;if((p|0)>0){e=a+28|0;q=0;h=c;m=p;while(1){p=f[(f[e>>2]|0)+4+(q<<2)>>2]|0;g=b[p+11>>0]|0;if(g<<24>>24<0){l=f[p+4>>2]|0;if(l>>>0<128){r=1;s=l;t=m}else{p=iob(l)|0;r=p;s=l;t=f[o>>2]|0}}else{r=1;s=g&255;t=m}g=s+h+r|0;q=q+1|0;if((q|0)>=(t|0)){u=g;break}else{h=g;m=t}}}else u=c;c=f[a+36>>2]|0;t=c+u|0;if(!c)v=t;else{u=a+44|0;m=0;h=t;while(1){t=f[(f[u>>2]|0)+4+(m<<2)>>2]|0;q=f[t+16>>2]|0;if(q){r=t+24|0;s=0;o=0;do{e=(f[r>>2]|0)+8+(o<<3)|0;s=(job(f[e>>2]|0,f[e+4>>2]|0)|0)+s|0;o=o+1|0}while((o|0)!=(q|0));if(s)if((s|0)>=0)if(s>>>0<128){w=2;x=s}else{w=(iob(s)|0)+1|0;x=s}else{w=11;x=s}else{w=0;x=0}}else{w=0;x=0}f[t+28>>2]=x;q=w+x|0;o=f[t+4>>2]|0;if(!(o&1))y=q;else y=(dQb(o&-2)|0)+q|0;f[t+12>>2]=y;if(y>>>0<128)z=1;else z=iob(y)|0;q=y+h+z|0;m=m+1|0;if((m|0)==(c|0)){v=q;break}else h=q}}h=a+48|0;c=f[h>>2]|0;if(!c){A=0;B=0}else{m=a+56|0;z=0;y=0;do{x=f[(f[m>>2]|0)+4+(z<<2)>>2]|0;if((x|0)>=0)if(x>>>0<128)C=1;else C=iob(x)|0;else C=10;y=C+y|0;z=z+1|0}while((z|0)!=(c|0));A=y;B=f[h>>2]|0}h=f[a+64>>2]|0;y=A+v+B+(h<<1)|0;if(!h)D=y;else{B=a+72|0;v=0;A=y;while(1){y=z3a(f[(f[B>>2]|0)+4+(v<<2)>>2]|0)|0;if(y>>>0<128)E=1;else E=iob(y)|0;c=y+A+E|0;v=v+1|0;if((v|0)==(h|0)){D=c;break}else A=c}}A=f[a+80>>2]|0;h=A+D|0;if(!A)F=h;else{D=a+88|0;v=0;E=h;while(1){h=tOa(f[(f[D>>2]|0)+4+(v<<2)>>2]|0)|0;if(h>>>0<128)G=1;else G=iob(h)|0;B=h+E+G|0;v=v+1|0;if((v|0)==(A|0)){F=B;break}else E=B}}E=f[a+4>>2]|0;if(!(E&1)){H=F;I=a+12|0;f[I>>2]=H;return H|0}H=(dQb(E&-2)|0)+F|0;I=a+12|0;f[I>>2]=H;return H|0}function a6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[a>>2]|0;e=a+4|0;if(d>>>0<(f[e>>2]|0)>>>0?(g=b[d>>0]|0,g<<24>>24>-1):0){f[a>>2]=d+1;h=g&255}else{g=Znb(a)|0;if((g|0)>-1)h=g;else{i=0;return i|0}}g=Gnb(a,h)|0;a:do if((Qnb(a)|0)>0){h=c+4|0;d=c+8|0;while(1){j=f[a>>2]|0;if(j>>>0<(f[e>>2]|0)>>>0){k=b[j>>0]|0;l=k&255;if(k<<24>>24>-1){f[a>>2]=j+1;m=l}else{n=l;o=10}}else{n=0;o=10}if((o|0)==10){o=0;l=Knb(a,n)|0;j=J;if((j|0)>-1|(j|0)==-1&l>>>0>4294967295)m=l;else{i=0;break}}l=f[c>>2]|0;if((l|0)==(f[h>>2]|0)){nza(c,l+1|0);p=f[c>>2]|0}else p=l;l=f[d>>2]|0;f[c>>2]=p+1;f[l+4+(p<<2)>>2]=m;if((Qnb(a)|0)<=0)break a}return i|0}while(0);Hnb(a,g);i=1;return i|0}function b6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+92|0;l=c+44|0;m=a+76|0;n=a+88|0;o=a+84|0;p=a+80|0;q=a+16|0;r=a+48|0;s=a+52|0;t=a+56|0;v=a+100|0;w=e+8|0;x=a+96|0;y=e+4|0;z=a+101|0;A=e+8|0;B=a+32|0;C=a+44|0;D=a+40|0;E=a+36|0;F=a+60|0;G=a+72|0;H=a+68|0;I=a+64|0;K=c+32|0;L=c+12|0;M=c+28|0;N=a+4|0;a:while(1){a=f[c>>2]|0;O=f[g>>2]|0;do if(a>>>0<O>>>0){P=b[a>>0]|0;Q=P&255;if(P<<24>>24>0){R=Q;S=1}else{P=a+1|0;if(P>>>0>=O>>>0){T=Q;U=7;break}V=h[P>>0]|0;if(((V^128)&Q)>>>0<=127){T=Q;U=7;break}R=Q+-128+(V<<7)|0;S=2}f[i>>2]=R;f[c>>2]=a+S;W=R;U=9}else{T=0;U=7}while(0);if((U|0)==7){U=0;a=_nb(c,T)|0;f[i>>2]=a;if((a+-1|0)>>>0<16383){W=a;U=9}else{X=a;U=133}}b:do if((U|0)==9){U=0;c:do switch(W>>>3&536870911|0){case 1:{switch(W|0){case 0:{Y=1;U=139;break a;break}case 10:break;default:{Z=W;break b}}f[j>>2]=f[j>>2]|1;a=f[k>>2]|0;if((a|0)==497760){jza(k,497760);_=f[k>>2]|0}else _=a;if(!(fqb(c,_)|0)){Y=0;U=139;break a}a=f[c>>2]|0;if(a>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[a>>0]|0)!=18)continue a;f[c>>2]=a+1;U=18;break}case 2:{switch(W|0){case 0:{Y=1;U=139;break a;break}case 18:{U=18;break}default:{Z=W;break b}}break}case 3:{switch(W|0){case 0:{Y=1;U=139;break a;break}case 26:{U=35;break}default:{Z=W;break b}}break}case 4:{switch(W|0){case 0:{Y=1;U=139;break a;break}case 32:{$=f[c>>2]|0;aa=f[g>>2]|0;U=42;break c;break}case 34:{if(a6a(c,r)|0){U=58;break c}else{Y=0;U=139;break a}break}default:{Z=W;break b}}break}case 5:{switch(W|0){case 0:{Y=1;U=139;break a;break}case 40:break;default:{Z=W;break b}}ba=f[c>>2]|0;ca=f[g>>2]|0;U=64;break}case 6:{switch(W|0){case 0:{Y=1;U=139;break a;break}case 50:{U=73;break}default:{Z=W;break b}}break}case 7:{switch(W|0){case 0:{Y=1;U=139;break a;break}case 56:break;default:{Z=W;break b}}da=f[c>>2]|0;ea=f[g>>2]|0;U=88;break}case 8:{switch(W|0){case 0:{Y=1;U=139;break a;break}case 66:{U=97;break}default:{Z=W;break b}}break}case 100:{switch(W|0){case 0:{Y=1;U=139;break a;break}case 802:break;default:{Z=W;break b}}a=f[l>>2]|0;f[l>>2]=a+-1;if((a|0)>0)U=117;else{Y=0;U=139;break a}break}default:{X=W;U=133;break b}}while(0);do if((U|0)==18){U=0;a=f[l>>2]|0;f[l>>2]=a+-1;if((a|0)<=0){Y=0;U=139;break a}while(1){a=f[n>>2]|0;do if(a){O=f[p>>2]|0;V=f[a>>2]|0;if((O|0)>=(V|0))if((V|0)==(f[o>>2]|0)){fa=V;U=24;break}else{ga=V;ha=a;U=25;break}else{f[p>>2]=O+1;ia=f[a+4+(O<<2)>>2]|0;break}}else{fa=f[o>>2]|0;U=24}while(0);if((U|0)==24){U=0;cpb(m,fa+1|0);a=f[n>>2]|0;ga=f[a>>2]|0;ha=a;U=25}if((U|0)==25){U=0;f[ha>>2]=ga+1;a=kza(0,f[m>>2]|0)|0;O=f[n>>2]|0;V=f[p>>2]|0;f[p>>2]=V+1;f[O+4+(V<<2)>>2]=a;ia=a}a=Jnb(c)|0;if(!(sOa(ia,c)|0)){Y=0;U=139;break a}if(!(Pnb(c,a)|0)){Y=0;U=139;break a}ja=f[c>>2]|0;if(ja>>>0>=(f[g>>2]|0)>>>0){U=29;break}if((b[ja>>0]|0)!=18){U=32;break}f[c>>2]=ja+1}if((U|0)==29){U=0;f[l>>2]=(f[l>>2]|0)+1;continue a}else if((U|0)==32){U=0;f[l>>2]=(f[l>>2]|0)+1;if((b[ja>>0]|0)==26){ka=ja;U=34;break}else continue a}}while(0);d:while(1){if((U|0)==34){U=0;f[c>>2]=ka+1;U=35;continue}else if((U|0)==35){U=0;if(!(fqb(c,mza(q)|0)|0)){Y=0;U=139;break a}a=f[c>>2]|0;V=f[g>>2]|0;if(a>>>0>=V>>>0)continue a;if((b[a>>0]|0)==26){ka=a;U=34;continue}if((b[a>>0]|0)==32){la=a;ma=V;U=41}else continue a}else if((U|0)==42){U=0;if($>>>0<aa>>>0){V=b[$>>0]|0;a=V&255;if(V<<24>>24>-1){f[c>>2]=$+1;na=a}else{oa=a;U=45}}else{oa=0;U=45}if((U|0)==45){U=0;a=Knb(c,oa)|0;V=J;if((V|0)>-1|(V|0)==-1&a>>>0>4294967295)na=a;else{Y=0;U=139;break a}}a=f[r>>2]|0;if((a|0)==(f[s>>2]|0)){nza(r,a+1|0);pa=f[r>>2]|0}else pa=a;a=f[t>>2]|0;f[r>>2]=pa+1;f[a+4+(pa<<2)>>2]=na;V=(f[s>>2]|0)-(f[r>>2]|0)|0;if((V|0)>0){qa=V;ra=a}else{U=58;continue}while(1){a=f[c>>2]|0;V=f[g>>2]|0;if(a>>>0>=V>>>0){U=58;continue d}if((b[a>>0]|0)!=32){U=58;continue d}O=a+1|0;f[c>>2]=O;if(O>>>0<V>>>0){V=b[O>>0]|0;O=V&255;if(V<<24>>24>-1){f[c>>2]=a+2;sa=O;ta=ra}else{ua=O;U=53}}else{ua=0;U=53}if((U|0)==53){U=0;O=Knb(c,ua)|0;a=J;if(!((a|0)>-1|(a|0)==-1&O>>>0>4294967295)){Y=0;U=139;break a}sa=O;ta=f[t>>2]|0}O=f[r>>2]|0;f[r>>2]=O+1;f[ta+4+(O<<2)>>2]=sa;if((qa|0)>1){qa=qa+-1|0;ra=ta}else{U=58;continue d}}}else if((U|0)==58){U=0;O=f[c>>2]|0;a=f[g>>2]|0;if(O>>>0>=a>>>0)continue a;if((b[O>>0]|0)==32){la=O;ma=a;U=41}else{if((b[O>>0]|0)!=40)continue a;V=O+1|0;f[c>>2]=V;ba=V;ca=a;U=64;continue}}else if((U|0)==64){U=0;f[j>>2]=f[j>>2]|16;if(ba>>>0<ca>>>0?(a=b[ba>>0]|0,a<<24>>24>-1):0){V=ba+1|0;f[c>>2]=V;va=a<<24>>24!=0;wa=V;xa=ca}else{Lnb(e,c);V=e;if(!(b[w>>0]|0)){Y=0;U=139;break a}va=(f[V>>2]|0)!=0|(f[V+4>>2]|0)!=0;wa=f[c>>2]|0;xa=f[g>>2]|0}b[v>>0]=va&1;if(wa>>>0>=xa>>>0)continue a;if((b[wa>>0]|0)!=50)continue a;f[c>>2]=wa+1;U=73;continue}else if((U|0)==73){U=0;f[j>>2]=f[j>>2]|32;V=f[x>>2]|0;if(!V){a=L5b(40)|0;$4a(a);f[x>>2]=a;ya=a}else ya=V;V=f[c>>2]|0;if(V>>>0<(f[g>>2]|0)>>>0?(a=b[V>>0]|0,a<<24>>24>-1):0){f[c>>2]=V+1;za=a&255}else{a=Znb(c)|0;if((a|0)>-1)za=a;else{Y=0;U=139;break a}}Inb(e,c,za);if((f[y>>2]|0)<0){U=81;break a}if(!(R4a(ya,c)|0)){U=81;break a}if(!(Onb(c,f[e>>2]|0)|0)){Y=0;U=139;break a}a=f[c>>2]|0;V=f[g>>2]|0;if(a>>>0>=V>>>0)continue a;if((b[a>>0]|0)!=56)continue a;O=a+1|0;f[c>>2]=O;da=O;ea=V;U=88;continue}else if((U|0)==88){U=0;f[j>>2]=f[j>>2]|64;if(da>>>0<ea>>>0?(V=b[da>>0]|0,V<<24>>24>-1):0){O=da+1|0;f[c>>2]=O;Aa=V<<24>>24!=0;Ba=O;Ca=ea}else{Lnb(e,c);O=e;if(!(b[A>>0]|0)){Y=0;U=139;break a}Aa=(f[O>>2]|0)!=0|(f[O+4>>2]|0)!=0;Ba=f[c>>2]|0;Ca=f[g>>2]|0}b[z>>0]=Aa&1;if(Ba>>>0>=Ca>>>0)continue a;if((b[Ba>>0]|0)!=66)continue a;f[c>>2]=Ba+1;U=97;continue}else if((U|0)==97){U=0;O=f[l>>2]|0;f[l>>2]=O+-1;if((O|0)<=0){Y=0;U=139;break a}while(1){O=f[C>>2]|0;do if(O){V=f[E>>2]|0;a=f[O>>2]|0;if((V|0)>=(a|0))if((a|0)==(f[D>>2]|0)){Da=a;U=103;break}else{Ea=a;Fa=O;U=104;break}else{f[E>>2]=V+1;Ga=f[O+4+(V<<2)>>2]|0;break}}else{Da=f[D>>2]|0;U=103}while(0);if((U|0)==103){U=0;cpb(B,Da+1|0);O=f[C>>2]|0;Ea=f[O>>2]|0;Fa=O;U=104}if((U|0)==104){U=0;f[Fa>>2]=Ea+1;O=vPa(0,f[B>>2]|0)|0;V=f[C>>2]|0;a=f[E>>2]|0;f[E>>2]=a+1;f[V+4+(a<<2)>>2]=O;Ga=O}O=Jnb(c)|0;if(!(GLa(Ga,c)|0)){Y=0;U=139;break a}if(!(Pnb(c,O)|0)){Y=0;U=139;break a}Ha=f[c>>2]|0;Ia=f[g>>2]|0;if(Ha>>>0>=Ia>>>0)break;if((b[Ha>>0]|0)!=66)break;f[c>>2]=Ha+1}if((Ia-Ha|0)<=1){U=113;break}if((b[Ha>>0]|0)!=-94){U=113;break}if((b[Ha+1>>0]|0)==6){Ja=Ha;U=116}else{U=113;break}}else if((U|0)==117){U=0;O=f[G>>2]|0;do if(O){a=f[I>>2]|0;V=f[O>>2]|0;if((a|0)>=(V|0))if((V|0)==(f[H>>2]|0)){Ka=V;U=122;break}else{La=V;Ma=O;U=123;break}else{f[I>>2]=a+1;Na=f[O+4+(a<<2)>>2]|0;break}}else{Ka=f[H>>2]|0;U=122}while(0);if((U|0)==122){U=0;cpb(F,Ka+1|0);O=f[G>>2]|0;La=f[O>>2]|0;Ma=O;U=123}if((U|0)==123){U=0;f[Ma>>2]=La+1;O=Fza(0,f[F>>2]|0)|0;a=f[G>>2]|0;V=f[I>>2]|0;f[I>>2]=V+1;f[a+4+(V<<2)>>2]=O;Na=O}O=Jnb(c)|0;if(!(y3a(Na,c)|0)){Y=0;U=139;break a}if(!(Pnb(c,O)|0)){Y=0;U=139;break a}O=f[g>>2]|0;V=f[c>>2]|0;Oa=V;Pa=O;if((O-V|0)<=1)break;if((b[Oa>>0]|0)!=-94)break;if((b[Oa+1>>0]|0)==6){Ja=Oa;U=116}else break}if((U|0)==41){U=0;V=la+1|0;f[c>>2]=V;$=V;aa=ma;U=42;continue}else if((U|0)==116){U=0;f[c>>2]=Ja+2;U=117;continue}}if((U|0)==113){U=0;f[l>>2]=(f[l>>2]|0)+1;continue a}f[l>>2]=(f[l>>2]|0)+1;if((Oa|0)!=(Pa|0))continue a;if(f[K>>2]|0){U=132;break a}if((f[L>>2]|0)==(f[M>>2]|0)){U=132;break a}else continue a}while(0);if((U|0)==133){U=0;if(!X){Y=1;U=139;break}else Z=X}if((Z&7|0)==4){Y=1;U=139;break}V=f[N>>2]|0;if(!(V&1))Qa=hBa(N)|0;else Qa=V&-2;if(!(ZPb(c,Z,Qa)|0)){Y=0;U=139;break}}if((U|0)==81){Y=0;u=d;return Y|0}else if((U|0)==132){f[i>>2]=0;b[c+24>>0]=1;Y=1;u=d;return Y|0}else if((U|0)==139){u=d;return Y|0}return 0}function c6a(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;e=f[c>>2]|0;if(e&113|0){d[a+100>>1]=0;do if(e&1|0?(g=f[a+92>>2]|0,(g|0)!=497760):0){h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(f[c>>2]&32|0?(e=f[a+96>>2]|0,e|0):0){h=e+8|0;if(f[h>>2]&3|0){f[e+36>>2]=1;f[e+32>>2]=0}g=e+20|0;i=f[g>>2]|0;if((i|0)>0){j=f[e+28>>2]|0;k=0;do{l=f[j+4+(k<<2)>>2]|0;k=k+1|0;m=l+11|0;if((b[m>>0]|0)<0){b[f[l>>2]>>0]=0;f[l+4>>2]=0}else{b[l>>0]=0;b[m>>0]=0}}while((k|0)!=(i|0));f[g>>2]=0}f[h>>2]=0;h=f[e+4>>2]|0;if(h&1|0?(e=h&-2,f[e>>2]|0):0)GPb(e)}}e=a+20|0;h=f[e>>2]|0;if((h|0)>0){g=f[a+28>>2]|0;i=0;do{k=f[g+4+(i<<2)>>2]|0;i=i+1|0;j=k+11|0;if((b[j>>0]|0)<0){b[f[k>>2]>>0]=0;f[k+4>>2]=0}else{b[k>>0]=0;b[j>>0]=0}}while((i|0)!=(h|0));f[e>>2]=0}e=a+36|0;h=f[e>>2]|0;if((h|0)>0){i=f[a+44>>2]|0;g=0;do{j=f[i+4+(g<<2)>>2]|0;g=g+1|0;bi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((g|0)!=(h|0));f[e>>2]=0}f[a+48>>2]=0;e=a+64|0;h=f[e>>2]|0;if((h|0)>0){g=f[a+72>>2]|0;i=0;do{j=f[g+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((i|0)!=(h|0));f[e>>2]=0}e=a+80|0;h=f[e>>2]|0;if((h|0)>0){i=f[a+88>>2]|0;g=0;do{j=f[i+4+(g<<2)>>2]|0;g=g+1|0;bi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((g|0)!=(h|0));f[e>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function d6a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=112320;e=(a|0)==493712;g=a+4|0;h=g+84|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+88>>2]=497760;f[a+92>>2]=497760;f[a+96>>2]=497760;f[a+100>>2]=f[213029];f[a+104>>2]=497760;f[a+108>>2]=f[213030];d=a+176|0;g=a+112|0;h=g+64|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));n[d>>2]=.9900000095367432;f[a+180>>2]=1;f[a+184>>2]=1;b[a+188>>0]=1;b[a+189>>0]=1;n[a+192>>2]=-1.0;f[a+196>>2]=1;f[a+200>>2]=1;d=a+208|0;f[d>>2]=-1;f[d+4>>2]=-1;n[a+216>>2]=9.99999993922529e-09;n[a+220>>2]=.9990000128746033;f[a+224>>2]=0;u=c;return}function e6a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function f6a(a){a=a|0;var c=0,d=0;c=a+88|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+92|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+96|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+100|0;d=f[c>>2]|0;if(!((d|0)==(f[213029]|0)|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+104|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+108|0;d=f[c>>2]|0;if(!((d|0)==(f[213030]|0)|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)==493712)return;c=f[a+112>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+116>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+120>>2]|0;if(!c)return;bi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function g6a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;f[a>>2]=112212;c=a+92|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)!=493600?(c=f[a+96>>2]|0,c|0):0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+88|0;d=f[c>>2]|0;if(d|0?(f[a+76>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)bi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=a+72|0;i=f[c>>2]|0;if(i|0?(f[a+60>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;O5b(j)}f[c>>2]=0;c=f[a+56>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=a+44|0;j=f[c>>2]|0;if(j|0?(f[a+32>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;O5b(k)}f[c>>2]=0;c=a+28|0;k=f[c>>2]|0;if(k|0?(f[a+16>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;O5b(l)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}l=a&-2;a=l;if((l|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(l);f[c>>2]=0;return}function h6a(a){a=a|0;g6a(a);O5b(a);return}function i6a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function j6a(a,b){a=a|0;b=b|0;a=L5b(104)|0;N5a(a);if(!b)return a|0;t6a(b,a);return a|0}function k6a(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+72|0;c=f[a+64>>2]|0;while(1){if((c|0)<=0){d=1;e=4;break}c=c+-1|0;a=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){d=0;e=4;break}}if((e|0)==4)return d|0;return 0}function l6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+8|0;if(f[d>>2]&1|0)$pb(1,f[a+92>>2]|0,c);e=f[a+80>>2]|0;if(e|0){g=a+88|0;h=0;do{eqb(2,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(e|0))}e=a+20|0;if((f[e>>2]|0)>0){h=a+28|0;g=0;do{_pb(3,f[(f[h>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)<(f[e>>2]|0))}e=a+48|0;if((f[e>>2]|0)>0){g=a+56|0;h=0;do{Mpb(4,f[(f[g>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)<(f[e>>2]|0))}e=f[d>>2]|0;if(!(e&16))i=e;else{Ypb(5,(b[a+100>>0]|0)!=0,c);i=f[d>>2]|0}if(!(i&32))j=i;else{eqb(6,f[a+96>>2]|0,c);j=f[d>>2]|0}if(j&64|0)Ypb(7,(b[a+101>>0]|0)!=0,c);j=f[a+36>>2]|0;if(j|0){d=a+44|0;i=0;do{eqb(8,f[(f[d>>2]|0)+4+(i<<2)>>2]|0,c);i=i+1|0}while((i|0)!=(j|0))}j=f[a+64>>2]|0;if(j|0){i=a+72|0;d=0;do{eqb(100,f[(f[i>>2]|0)+4+(d<<2)>>2]|0,c);d=d+1|0}while((d|0)!=(j|0))}j=f[a+4>>2]|0;if(!(j&1))return;aQb(j&-2,c);return}function m6a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function n6a(a){a=a|0;return f[a+12>>2]|0}function o6a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;c=a+8|0;if(!(f[c>>2]&1))e=d;else{g=f[a+92>>2]|0;b[d>>0]=10;e=kob(g,d+1|0)|0}d=f[a+80>>2]|0;if(!d)h=e;else{g=a+88|0;i=0;j=e;while(1){e=f[(f[g>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=18;k=j+1|0;l=f[e+292>>2]|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=li[f[(f[e>>2]|0)+68>>2]&511](e,0,q+1|0)|0;i=i+1|0;if((i|0)==(d|0)){h=n;break}else j=n}}j=a+20|0;if((f[j>>2]|0)>0){d=a+28|0;i=0;q=h;while(1){r=f[(f[d>>2]|0)+4+(i<<2)>>2]|0;b[q>>0]=26;g=kob(r,q+1|0)|0;i=i+1|0;if((i|0)>=(f[j>>2]|0)){s=g;break}else q=g}}else s=h;h=a+48|0;if((f[h>>2]|0)>0){q=a+56|0;j=0;i=s;while(1){d=f[(f[q>>2]|0)+4+(j<<2)>>2]|0;b[i>>0]=32;g=i+1|0;if((d|0)<0)t=hob(d,((d|0)<0)<<31>>31,g)|0;else{if(d>>>0>127){r=d;n=g;while(1){b[n>>0]=r|128;m=r>>>7;o=n+1|0;if(r>>>0>16383){r=m;n=o}else{u=o;v=m;break}}}else{u=g;v=d}b[u>>0]=v;t=u+1|0}j=j+1|0;if((j|0)>=(f[h>>2]|0)){w=t;break}else i=t}}else w=s;s=f[c>>2]|0;if(!(s&16)){x=w;y=s}else{s=b[a+100>>0]|0;b[w>>0]=40;b[w+1>>0]=s;x=w+2|0;y=f[c>>2]|0}if(!(y&32)){z=x;A=y}else{y=f[a+96>>2]|0;b[x>>0]=50;w=x+1|0;x=f[y+12>>2]|0;if(x>>>0>127){s=x;t=w;while(1){b[t>>0]=s|128;i=s>>>7;h=t+1|0;if(s>>>0>16383){s=i;t=h}else{B=h;C=i;break}}}else{B=w;C=x}b[B>>0]=C;C=li[f[(f[y>>2]|0)+68>>2]&511](y,0,B+1|0)|0;z=C;A=f[c>>2]|0}if(!(A&64))D=z;else{A=b[a+101>>0]|0;b[z>>0]=56;b[z+1>>0]=A;D=z+2|0}z=f[a+36>>2]|0;if(!z)E=D;else{A=a+44|0;c=0;C=D;while(1){D=f[(f[A>>2]|0)+4+(c<<2)>>2]|0;b[C>>0]=66;B=C+1|0;y=f[D+12>>2]|0;if(y>>>0>127){x=y;w=B;while(1){b[w>>0]=x|128;t=x>>>7;s=w+1|0;if(x>>>0>16383){x=t;w=s}else{F=s;G=t;break}}}else{F=B;G=y}b[F>>0]=G;w=li[f[(f[D>>2]|0)+68>>2]&511](D,0,F+1|0)|0;c=c+1|0;if((c|0)==(z|0)){E=w;break}else C=w}}C=f[a+64>>2]|0;if(!C)H=E;else{z=a+72|0;c=0;F=E;while(1){E=f[(f[z>>2]|0)+4+(c<<2)>>2]|0;b[F>>0]=-94;b[F+1>>0]=6;G=F+2|0;A=f[E+20>>2]|0;if(A>>>0>127){w=A;x=G;while(1){b[x>>0]=w|128;d=w>>>7;g=x+1|0;if(w>>>0>16383){w=d;x=g}else{I=g;J=d;break}}}else{I=G;J=A}b[I>>0]=J;x=li[f[(f[E>>2]|0)+68>>2]&511](E,0,I+1|0)|0;c=c+1|0;if((c|0)==(C|0)){H=x;break}else F=x}}F=f[a+4>>2]|0;if(!(F&1)){K=H;return K|0}K=bQb(F&-2,H)|0;return K|0}function p6a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function q6a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(9623);c=T6b(b,23288,19768,0)|0;if(!c){cOb(b,a);return}else{O5a(a,c);return}}function r6a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function s6a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213056];f[a+4>>2]=f[213057];u=c;return}function t6a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function u6a(a){a=a|0;var c=0,d=0;f[a>>2]=112104;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==(f[213028]|0)|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(d);f[c>>2]=0;return}function v6a(a){a=a|0;u6a(a);O5b(a);return}function w6a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function x6a(a,b){a=a|0;b=b|0;a=L5b(48)|0;GNa(a);if(!b)return a|0;I6a(b,a);return a|0}function y6a(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;c=f[b>>2]|0;if(c&255|0){d=a+20|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if(c&1|0?(c=f[213028]|0,d=f[a+16>>2]|0,(d|0)!=(c|0)):0)_5b(d,c)|0;n[a+40>>2]=1.0;n[a+44>>2]=1.0;f[a+36>>2]=-1}f[b>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function z6a(a){a=a|0;return 1}function A6a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{$pb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{Wpb(2,+n[a+20>>2],b);g=f[c>>2]|0}if(!(g&4))h=g;else{Wpb(3,+n[a+24>>2],b);h=f[c>>2]|0}if(!(h&8))i=h;else{Wpb(4,+n[a+40>>2],b);i=f[c>>2]|0}if(!(i&16))j=i;else{Wpb(5,+n[a+28>>2],b);j=f[c>>2]|0}if(!(j&32))k=j;else{Wpb(6,+n[a+44>>2],b);k=f[c>>2]|0}if(!(k&64))l=k;else{Mpb(7,f[a+36>>2]|0,b);l=f[c>>2]|0}if(l&128|0)Zpb(8,f[a+32>>2]|0,b);l=f[a+4>>2]|0;if(!(l&1))return;aQb(l&-2,b);return}function B6a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function C6a(a){a=a|0;return f[a+12>>2]|0}function D6a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&2)){j=g;k=h}else{h=f[a+20>>2]|0;b[g>>0]=21;i=g+1|0;b[i>>0]=h;b[i+1>>0]=h>>8;b[i+2>>0]=h>>16;b[i+3>>0]=h>>24;j=g+5|0;k=f[c>>2]|0}if(!(k&4)){l=j;m=k}else{k=f[a+24>>2]|0;b[j>>0]=29;g=j+1|0;b[g>>0]=k;b[g+1>>0]=k>>8;b[g+2>>0]=k>>16;b[g+3>>0]=k>>24;l=j+5|0;m=f[c>>2]|0}if(!(m&8)){n=l;o=m}else{m=f[a+40>>2]|0;b[l>>0]=37;j=l+1|0;b[j>>0]=m;b[j+1>>0]=m>>8;b[j+2>>0]=m>>16;b[j+3>>0]=m>>24;n=l+5|0;o=f[c>>2]|0}if(!(o&16)){p=n;q=o}else{o=f[a+28>>2]|0;b[n>>0]=45;l=n+1|0;b[l>>0]=o;b[l+1>>0]=o>>8;b[l+2>>0]=o>>16;b[l+3>>0]=o>>24;p=n+5|0;q=f[c>>2]|0}if(!(q&32)){r=p;s=q}else{q=f[a+44>>2]|0;b[p>>0]=53;n=p+1|0;b[n>>0]=q;b[n+1>>0]=q>>8;b[n+2>>0]=q>>16;b[n+3>>0]=q>>24;r=p+5|0;s=f[c>>2]|0}do if(!(s&64))t=r;else{p=f[a+36>>2]|0;b[r>>0]=56;q=r+1|0;if((p|0)<0){t=hob(p,((p|0)<0)<<31>>31,q)|0;break}if(p>>>0>127){n=p;o=q;while(1){b[o>>0]=n|128;l=n>>>7;m=o+1|0;if(n>>>0>16383){n=l;o=m}else{u=m;v=l;break}}}else{u=q;v=p}b[u>>0]=v;t=u+1|0}while(0);do if(!(f[c>>2]&128))w=t;else{u=f[a+32>>2]|0;b[t>>0]=64;v=t+1|0;if((u|0)<0){w=hob(u,((u|0)<0)<<31>>31,v)|0;break}if(u>>>0>127){r=u;s=v;while(1){b[s>>0]=r|128;o=r>>>7;n=s+1|0;if(r>>>0>16383){r=o;s=n}else{x=n;y=o;break}}}else{x=v;y=u}b[x>>0]=y;w=x+1|0}while(0);x=f[a+4>>2]|0;if(!(x&1)){z=w;return z|0}z=bQb(x&-2,w)|0;return z|0}function E6a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function F6a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(8745);c=T6b(b,23288,18888,0)|0;if(!c){cOb(b,a);return}else{HNa(a,c);return}}function G6a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function H6a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213053];f[a+4>>2]=f[213054];u=c;return}function I6a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function J6a(a){a=a|0;var c=0,d=0;f[a>>2]=111996;c=a+28|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(d);f[c>>2]=0;return}function K6a(a){a=a|0;J6a(a);O5b(a);return}function L6a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function M6a(a,b){a=a|0;b=b|0;a=L5b(52)|0;_6a(a);if(!b)return a|0;$6a(b,a);return a|0}function N6a(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if((d&95|0?(e=a+32|0,f[e>>2]=0,f[e+4>>2]=0,f[e+8>>2]=0,f[e+12>>2]=0,b[e+16>>0]=0,d&8|0):0)?(e=f[a+28>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);f[a+16>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function O6a(a){a=a|0;return 1}function P6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+8|0;k=a+32|0;l=a+36|0;m=a+40|0;n=a+28|0;o=a+44|0;p=a+16|0;q=a+20|0;r=a+24|0;s=a+48|0;t=c+32|0;v=c+12|0;w=c+28|0;x=e+8|0;y=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){z=b[a>>0]|0;A=z&255;if(z<<24>>24>0){f[i>>2]=A;f[c>>2]=a+1;B=A;C=6}else{D=A;C=5}}else{D=0;C=5}if((C|0)==5){C=0;A=_nb(c,D)|0;f[i>>2]=A;if((A+-1|0)>>>0<127){B=A;C=6}else{E=A;C=85}}b:do if((C|0)==6){C=0;c:do switch(B>>>3&536870911|0){case 1:{switch(B|0){case 0:{F=1;C=91;break a;break}case 8:break;default:{G=B;break b}}f[j>>2]=f[j>>2]|1;A=f[c>>2]|0;a=f[g>>2]|0;if(A>>>0<a>>>0){z=b[A>>0]|0;H=z&255;if(z<<24>>24>-1){z=A+1|0;f[c>>2]=z;I=H;K=z;L=a}else{M=H;C=11}}else{M=0;C=11}if((C|0)==11){C=0;H=Knb(c,M)|0;a=J;if(!((a|0)>-1|(a|0)==-1&H>>>0>4294967295)){F=0;C=91;break a}I=H;K=f[c>>2]|0;L=f[g>>2]|0}f[k>>2]=I;if(K>>>0>=L>>>0)continue a;if((b[K>>0]|0)!=16)continue a;H=K+1|0;f[c>>2]=H;N=H;O=L;C=18;break}case 2:{switch(B|0){case 0:{F=1;C=91;break a;break}case 16:break;default:{G=B;break b}}N=f[c>>2]|0;O=f[g>>2]|0;C=18;break}case 3:{switch(B|0){case 0:{F=1;C=91;break a;break}case 24:break;default:{G=B;break b}}P=f[c>>2]|0;Q=f[g>>2]|0;C=28;break}case 4:{switch(B|0){case 0:{F=1;C=91;break a;break}case 34:{C=37;break}default:{G=B;break b}}break}case 5:{switch(B|0){case 0:{F=1;C=91;break a;break}case 40:break;default:{G=B;break b}}R=f[g>>2]|0;S=f[c>>2]|0;C=45;break}case 6:{switch(B|0){case 0:{F=1;C=91;break a;break}case 53:{T=f[c>>2]|0;U=f[g>>2]|0;C=55;break c;break}case 50:{if(DMa(c,p)|0){C=70;break c}else{F=0;C=91;break a}break}default:{G=B;break b}}break}case 7:{switch(B|0){case 0:{F=1;C=91;break a;break}case 56:break;default:{G=B;break b}}V=f[c>>2]|0;W=f[g>>2]|0;C=76;break}default:{E=B;C=85;break b}}while(0);if((C|0)==18){C=0;f[j>>2]=f[j>>2]|2;if(N>>>0<O>>>0){H=b[N>>0]|0;a=H&255;if(H<<24>>24>-1){H=N+1|0;f[c>>2]=H;X=a;Y=H;Z=O}else{_=a;C=21}}else{_=0;C=21}if((C|0)==21){C=0;a=Knb(c,_)|0;H=J;if(!((H|0)>-1|(H|0)==-1&a>>>0>4294967295)){F=0;C=91;break a}X=a;Y=f[c>>2]|0;Z=f[g>>2]|0}f[l>>2]=X;if(Y>>>0>=Z>>>0)continue a;if((b[Y>>0]|0)!=24)continue a;a=Y+1|0;f[c>>2]=a;P=a;Q=Z;C=28}if((C|0)==28){C=0;f[j>>2]=f[j>>2]|4;if(P>>>0<Q>>>0){a=b[P>>0]|0;H=a&255;if(a<<24>>24>-1){a=P+1|0;f[c>>2]=a;$=H;aa=a;ba=Q}else{ca=H;C=31}}else{ca=0;C=31}if((C|0)==31){C=0;H=Knb(c,ca)|0;a=J;if(!((a|0)>-1|(a|0)==-1&H>>>0>4294967295)){F=0;C=91;break a}$=H;aa=f[c>>2]|0;ba=f[g>>2]|0}f[m>>2]=$;if(aa>>>0>=ba>>>0)continue a;if((b[aa>>0]|0)!=34)continue a;f[c>>2]=aa+1;C=37}if((C|0)==37){C=0;f[j>>2]=f[j>>2]|8;H=f[n>>2]|0;if((H|0)==497760){jza(n,497760);da=f[n>>2]|0}else da=H;if(!(fqb(c,da)|0)){F=0;C=91;break a}H=f[c>>2]|0;a=f[g>>2]|0;if(H>>>0>=a>>>0)continue a;if((b[H>>0]|0)!=40)continue a;z=H+1|0;f[c>>2]=z;R=a;S=z;C=45}if((C|0)==45){C=0;f[j>>2]=f[j>>2]|16;if(S>>>0<R>>>0){z=b[S>>0]|0;a=z&255;if(z<<24>>24>-1){z=S+1|0;f[c>>2]=z;ea=a;fa=R;ga=z}else{ha=a;C=48}}else{ha=0;C=48}if((C|0)==48){C=0;a=Knb(c,ha)|0;z=J;if(!((z|0)>-1|(z|0)==-1&a>>>0>4294967295)){F=0;C=91;break a}ea=a;fa=f[g>>2]|0;ga=f[c>>2]|0}f[o>>2]=ea;if(ga>>>0>=fa>>>0)continue a;if((b[ga>>0]|0)==53){ia=fa;ja=ga;C=54}else continue a}while(1)if((C|0)==54){C=0;a=ja+1|0;f[c>>2]=a;T=a;U=ia;C=55;continue}else if((C|0)==55){C=0;if((U-T|0)>3){a=T;z=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;f[e>>2]=z;f[c>>2]=T+4;ka=z}else{if(!(Xnb(c,e)|0)){C=68;break a}ka=f[e>>2]|0}z=f[p>>2]|0;if((z|0)==(f[q>>2]|0)){qza(p,z+1|0);la=f[p>>2]|0}else la=z;z=f[r>>2]|0;a=la+1|0;f[p>>2]=a;f[z+4+(la<<2)>>2]=ka;H=f[c>>2]|0;A=(f[g>>2]|0)-H|0;if((A|0)<=0){C=70;continue}ma=(f[q>>2]|0)-a|0;na=(A>>>0)/5|0;A=(na|0)<(ma|0)?na:ma;if((A|0)<=0){C=70;continue}ma=0;na=H;H=a;while(1){if((b[na>>0]|0)!=53){oa=ma;break}a=na+1|0;pa=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=H;H=H+1|0;f[p>>2]=H;f[z+4+(a<<2)>>2]=pa;pa=ma+1|0;if((pa|0)>=(A|0)){oa=pa;break}else{ma=pa;na=na+5|0}}if((oa|0)<=0){C=70;continue}Tnb(c,oa*5|0)|0;C=70;continue}else if((C|0)==70){C=0;na=f[c>>2]|0;ma=f[g>>2]|0;if(na>>>0>=ma>>>0)continue a;if((b[na>>0]|0)==53){ia=ma;ja=na;C=54;continue}if((b[na>>0]|0)!=56)continue a;A=na+1|0;f[c>>2]=A;V=A;W=ma;C=76;continue}else if((C|0)==76){C=0;f[j>>2]=f[j>>2]|64;if(V>>>0<W>>>0){C=77;break}else{C=79;break}}if((C|0)==77){C=0;ma=b[V>>0]|0;if(ma<<24>>24>-1){A=V+1|0;f[c>>2]=A;qa=ma<<24>>24!=0;ra=A;sa=W}else C=79}if((C|0)==79){C=0;Lnb(e,c);A=e;if(!(b[x>>0]|0)){F=0;C=91;break a}qa=(f[A>>2]|0)!=0|(f[A+4>>2]|0)!=0;ra=f[c>>2]|0;sa=f[g>>2]|0}b[s>>0]=qa&1;if((ra|0)!=(sa|0))continue a;if(f[t>>2]|0){C=84;break a}if((f[v>>2]|0)==(f[w>>2]|0)){C=84;break a}else continue a}while(0);if((C|0)==85){C=0;if(!E){F=1;C=91;break}else G=E}if((G&7|0)==4){F=1;C=91;break}A=f[y>>2]|0;if(!(A&1))ta=hBa(y)|0;else ta=A&-2;if(!(ZPb(c,G,ta)|0)){F=0;C=91;break}}if((C|0)==68){F=0;u=d;return F|0}else if((C|0)==84){f[i>>2]=0;b[c+24>>0]=1;F=1;u=d;return F|0}else if((C|0)==91){u=d;return F|0}return 0}function Q6a(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+8|0;d=f[c>>2]|0;if(!(d&95))e=0;else{if(d&1){g=f[a+32>>2]|0;if((g|0)>=0)if(g>>>0<128){h=2;i=d}else{j=(iob(g)|0)+1|0;h=j;i=f[c>>2]|0}else{h=11;i=d}}else{h=0;i=d}if(!(i&2)){k=h;l=i}else{d=f[a+36>>2]|0;if((d|0)>=0)if(d>>>0<128){m=2;n=i}else{j=(iob(d)|0)+1|0;m=j;n=f[c>>2]|0}else{m=11;n=i}k=m+h|0;l=n}if(!(l&4)){o=k;p=l}else{n=f[a+40>>2]|0;if((n|0)>=0)if(n>>>0<128){q=2;r=l}else{h=(iob(n)|0)+1|0;q=h;r=f[c>>2]|0}else{q=11;r=l}o=q+k|0;p=r}if(!(p&8)){s=o;t=p}else{r=f[a+28>>2]|0;k=b[r+11>>0]|0;if(k<<24>>24<0){q=f[r+4>>2]|0;if(q>>>0<128){u=1;v=p;w=q}else{r=iob(q)|0;u=r;v=f[c>>2]|0;w=q}}else{u=1;v=p;w=k&255}s=o+1+w+u|0;t=v}if(!(t&16)){x=s;y=t}else{v=f[a+44>>2]|0;if((v|0)>=0)if(v>>>0<128){z=2;A=t}else{u=(iob(v)|0)+1|0;z=u;A=f[c>>2]|0}else{z=11;A=t}x=z+s|0;y=A}e=y&64|0?x+2|0:x}x=f[a+16>>2]|0;y=x+e+(x<<2)|0;x=f[a+4>>2]|0;if(!(x&1)){B=y;C=a+12|0;f[C>>2]=B;return B|0}B=(dQb(x&-2)|0)+y|0;C=a+12|0;f[C>>2]=B;return B|0}function R6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Mpb(1,f[a+32>>2]|0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{Mpb(2,f[a+36>>2]|0,c);h=f[d>>2]|0}if(!(h&4))i=h;else{Mpb(3,f[a+40>>2]|0,c);i=f[d>>2]|0}if(!(i&8))j=i;else{bqb(4,f[a+28>>2]|0,c);j=f[d>>2]|0}if(j&16|0)Mpb(5,f[a+44>>2]|0,c);j=a+16|0;if((f[j>>2]|0)>0){i=a+24|0;h=0;do{Wpb(6,+n[(f[i>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)<(f[j>>2]|0))}if(f[d>>2]&64|0)Ypb(7,(b[a+48>>0]|0)!=0,c);d=f[a+4>>2]|0;if(!(d&1))return;aQb(d&-2,c);return}function S6a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function T6a(a){a=a|0;return f[a+12>>2]|0}function U6a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+32>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);do if(!(f[c>>2]&2))o=e;else{m=f[a+36>>2]|0;b[e>>0]=16;n=e+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){d=m;j=n;while(1){b[j>>0]=d|128;i=d>>>7;k=j+1|0;if(d>>>0>16383){d=i;j=k}else{p=k;q=i;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}while(0);do if(!(f[c>>2]&4))r=o;else{p=f[a+40>>2]|0;b[o>>0]=24;q=o+1|0;if((p|0)<0){r=hob(p,((p|0)<0)<<31>>31,q)|0;break}if(p>>>0>127){e=p;j=q;while(1){b[j>>0]=e|128;d=e>>>7;g=j+1|0;if(e>>>0>16383){e=d;j=g}else{s=g;t=d;break}}}else{s=q;t=p}b[s>>0]=t;r=s+1|0}while(0);s=f[c>>2]|0;if(!(s&8)){u=r;v=s}else{s=f[a+28>>2]|0;b[r>>0]=34;t=kob(s,r+1|0)|0;u=t;v=f[c>>2]|0}do if(!(v&16))w=u;else{t=f[a+44>>2]|0;b[u>>0]=40;r=u+1|0;if((t|0)<0){w=hob(t,((t|0)<0)<<31>>31,r)|0;break}if(t>>>0>127){s=t;o=r;while(1){b[o>>0]=s|128;j=s>>>7;e=o+1|0;if(s>>>0>16383){s=j;o=e}else{x=e;y=j;break}}}else{x=r;y=t}b[x>>0]=y;w=x+1|0}while(0);x=a+16|0;if((f[x>>2]|0)>0){y=a+24|0;u=0;v=w;while(1){o=f[(f[y>>2]|0)+4+(u<<2)>>2]|0;b[v>>0]=53;s=v+1|0;b[s>>0]=o;b[s+1>>0]=o>>8;b[s+2>>0]=o>>16;b[s+3>>0]=o>>24;o=v+5|0;u=u+1|0;if((u|0)>=(f[x>>2]|0)){z=o;break}else v=o}}else z=w;if(!(f[c>>2]&64))A=z;else{c=b[a+48>>0]|0;b[z>>0]=56;b[z+1>>0]=c;A=z+2|0}z=f[a+4>>2]|0;if(!(z&1)){B=A;return B|0}B=bQb(z&-2,A)|0;return B|0}function V6a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function W6a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(7963);c=T6b(b,23288,19784,0)|0;if(!c){cOb(b,a);return}else{Z6a(a,c);return}}function X6a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Y6a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213051];f[a+4>>2]=f[213052];u=c;return}function Z6a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+4|0;g=d;h=a+16|0;i=c+16|0;j=f[i>>2]|0;if(j|0){qza(h,(f[h>>2]|0)+j|0);Vac((f[a+24>>2]|0)+4+(f[h>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[i>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[i>>2]|0)}i=c+8|0;h=f[i>>2]|0;if(h&255|0){if(!(h&1))k=h;else{h=f[c+32>>2]|0;j=a+8|0;f[j>>2]=f[j>>2]|1;f[a+32>>2]=h;k=f[i>>2]|0}if(!(k&2))l=k;else{k=f[c+36>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|2;f[a+36>>2]=k;l=f[i>>2]|0}if(!(l&4))m=l;else{l=f[c+40>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|4;f[a+40>>2]=l;m=f[i>>2]|0}if(!(m&8))n=m;else{m=a+8|0;f[m>>2]=f[m>>2]|8;f[g>>2]=f[c+28>>2];f[e>>2]=f[g>>2];Anb(a+28|0,497760,e);n=f[i>>2]|0}if(!(n&16))o=n;else{n=f[c+44>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|16;f[a+44>>2]=n;o=f[i>>2]|0}if(o&64|0){o=b[c+48>>0]|0;i=a+8|0;f[i>>2]=f[i>>2]|64;b[a+48>>0]=o}}o=f[c+4>>2]|0;if(!(o&1)){u=d;return}LPb(o&-2,a+4|0);u=d;return}function _6a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=111996;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=493480?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+28>>2]=497760;d=a+32|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;b[d+16>>0]=0;u=c;return}function $6a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function a7a(a){a=a|0;var b=0,c=0;f[a>>2]=111888;if((a|0)!=493416){b=f[a+16>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+20>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b)}b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function b7a(a){a=a|0;a7a(a);O5b(a);return}function c7a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function d7a(a,b){a=a|0;b=b|0;a=L5b(52)|0;K3a(a);if(!b)return a|0;n7a(b,a);return a|0}function e7a(a){a=a|0;return 1}function f7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Opb(1,f[a+24>>2]|0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{Ypb(2,(b[a+48>>0]|0)!=0,c);h=f[d>>2]|0}if(!(h&4))i=h;else{Mpb(3,f[a+28>>2]|0,c);i=f[d>>2]|0}if(!(i&8))j=i;else{eqb(4,f[a+16>>2]|0,c);j=f[d>>2]|0}if(!(j&16))k=j;else{eqb(5,f[a+20>>2]|0,c);k=f[d>>2]|0}if(!(k&32))l=k;else{Zpb(6,f[a+44>>2]|0,c);l=f[d>>2]|0}if(!(l&128))m=l;else{Mpb(7,f[a+40>>2]|0,c);m=f[d>>2]|0}if(!(m&64))o=m;else{Ypb(8,(b[a+32>>0]|0)!=0,c);o=f[d>>2]|0}if(!(o&256))p=o;else{Wpb(9,+n[a+36>>2],c);p=f[d>>2]|0}if(p&512|0)Ypb(10,(b[a+49>>0]|0)!=0,c);p=f[a+4>>2]|0;if(!(p&1))return;aQb(p&-2,c);return}function g7a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function h7a(a){a=a|0;return f[a+12>>2]|0}function i7a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+24>>2]|0;b[d>>0]=8;i=d+1|0;if(e>>>0>127){d=e;j=i;while(1){b[j>>0]=d|128;k=d>>>7;l=j+1|0;if(d>>>0>16383){d=k;j=l}else{m=l;n=k;break}}}else{m=i;n=e}b[m>>0]=n;g=m+1|0;h=f[c>>2]|0}if(!(h&2)){o=g;p=h}else{h=b[a+48>>0]|0;b[g>>0]=16;b[g+1>>0]=h;o=g+2|0;p=f[c>>2]|0}do if(!(p&4))q=o;else{g=f[a+28>>2]|0;b[o>>0]=24;h=o+1|0;if((g|0)<0){q=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){m=g;n=h;while(1){b[n>>0]=m|128;e=m>>>7;i=n+1|0;if(m>>>0>16383){m=e;n=i}else{r=i;s=e;break}}}else{r=h;s=g}b[r>>0]=s;q=r+1|0}while(0);r=f[c>>2]|0;if(!(r&8)){t=q;u=r}else{r=f[a+16>>2]|0;b[q>>0]=34;s=q+1|0;q=f[r+12>>2]|0;if(q>>>0>127){o=q;p=s;while(1){b[p>>0]=o|128;n=o>>>7;m=p+1|0;if(o>>>0>16383){o=n;p=m}else{v=m;w=n;break}}}else{v=s;w=q}b[v>>0]=w;w=li[f[(f[r>>2]|0)+68>>2]&511](r,0,v+1|0)|0;t=w;u=f[c>>2]|0}if(!(u&16)){x=t;y=u}else{u=f[a+20>>2]|0;b[t>>0]=42;w=t+1|0;t=f[u+12>>2]|0;if(t>>>0>127){v=t;r=w;while(1){b[r>>0]=v|128;q=v>>>7;s=r+1|0;if(v>>>0>16383){v=q;r=s}else{z=s;A=q;break}}}else{z=w;A=t}b[z>>0]=A;A=li[f[(f[u>>2]|0)+68>>2]&511](u,0,z+1|0)|0;x=A;y=f[c>>2]|0}do if(!(y&32))B=x;else{A=f[a+44>>2]|0;b[x>>0]=48;z=x+1|0;if((A|0)<0){B=hob(A,((A|0)<0)<<31>>31,z)|0;break}if(A>>>0>127){u=A;t=z;while(1){b[t>>0]=u|128;w=u>>>7;r=t+1|0;if(u>>>0>16383){u=w;t=r}else{C=r;D=w;break}}}else{C=z;D=A}b[C>>0]=D;B=C+1|0}while(0);do if(!(f[c>>2]&128))E=B;else{C=f[a+40>>2]|0;b[B>>0]=56;D=B+1|0;if((C|0)<0){E=hob(C,((C|0)<0)<<31>>31,D)|0;break}if(C>>>0>127){x=C;y=D;while(1){b[y>>0]=x|128;t=x>>>7;u=y+1|0;if(x>>>0>16383){x=t;y=u}else{F=u;G=t;break}}}else{F=D;G=C}b[F>>0]=G;E=F+1|0}while(0);F=f[c>>2]|0;if(!(F&64)){H=E;I=F}else{F=b[a+32>>0]|0;b[E>>0]=64;b[E+1>>0]=F;H=E+2|0;I=f[c>>2]|0}if(!(I&256)){J=H;K=I}else{I=f[a+36>>2]|0;b[H>>0]=77;E=H+1|0;b[E>>0]=I;b[E+1>>0]=I>>8;b[E+2>>0]=I>>16;b[E+3>>0]=I>>24;J=H+5|0;K=f[c>>2]|0}if(!(K&512))L=J;else{K=b[a+49>>0]|0;b[J>>0]=80;b[J+1>>0]=K;L=J+2|0}J=f[a+4>>2]|0;if(!(J&1)){M=L;return M|0}M=bQb(J&-2,L)|0;return M|0}function j7a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function k7a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(7150);c=T6b(b,23288,19800,0)|0;if(!c){cOb(b,a);return}else{L3a(a,c);return}}function l7a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function m7a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213049];f[a+4>>2]=f[213050];u=c;return}function n7a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function o7a(a){a=a|0;var b=0,c=0;f[a>>2]=111780;b=f[a+84>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+72>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+60>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+48>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+36>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function p7a(a){a=a|0;o7a(a);O5b(a);return}function q7a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function r7a(a,b){a=a|0;b=b|0;a=L5b(128)|0;P3a(a);if(!b)return a|0;C7a(b,a);return a|0}function s7a(a){a=a|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(d&219|0){e=a+88|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;b[a+120>>0]=1;b[a+121>>0]=1}if(d&7936|0){d=a+104|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;n[a+124>>2]=.5}f[a+16>>2]=0;f[a+28>>2]=0;f[a+40>>2]=0;f[a+52>>2]=0;f[a+64>>2]=0;f[a+76>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function t7a(a){a=a|0;return 1}function u7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Wpb(1,+n[a+88>>2],c);g=f[d>>2]|0}if(g&2|0)Wpb(2,+n[a+92>>2],c);g=a+16|0;if((f[g>>2]|0)>0){e=a+24|0;h=0;do{Wpb(3,+n[(f[e>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)<(f[g>>2]|0))}g=f[d>>2]|0;if(!(g&8))i=g;else{Ypb(4,(b[a+120>>0]|0)!=0,c);i=f[d>>2]|0}if(i&16|0)Ypb(5,(b[a+121>>0]|0)!=0,c);i=a+28|0;if((f[i>>2]|0)>0){g=a+36|0;h=0;do{Wpb(6,+n[(f[g>>2]|0)+4+(h<<2)>>2],c);h=h+1|0}while((h|0)<(f[i>>2]|0))}i=f[d>>2]|0;if(!(i&64))j=i;else{Opb(7,f[a+96>>2]|0,c);j=f[d>>2]|0}if(!(j&128))k=j;else{Opb(8,f[a+100>>2]|0,c);k=f[d>>2]|0}if(!(k&256))l=k;else{Opb(9,f[a+104>>2]|0,c);l=f[d>>2]|0}if(!(l&512))m=l;else{Wpb(10,+n[a+108>>2],c);m=f[d>>2]|0}if(!(m&1024))o=m;else{Wpb(11,+n[a+112>>2],c);o=f[d>>2]|0}if(!(o&2048))p=o;else{Wpb(12,+n[a+116>>2],c);p=f[d>>2]|0}if(p&4096|0)Wpb(13,+n[a+124>>2],c);p=a+40|0;if((f[p>>2]|0)>0){d=a+48|0;o=0;do{Wpb(14,+n[(f[d>>2]|0)+4+(o<<2)>>2],c);o=o+1|0}while((o|0)<(f[p>>2]|0))}p=a+52|0;if((f[p>>2]|0)>0){o=a+60|0;d=0;do{Wpb(15,+n[(f[o>>2]|0)+4+(d<<2)>>2],c);d=d+1|0}while((d|0)<(f[p>>2]|0))}p=a+64|0;if((f[p>>2]|0)>0){d=a+72|0;o=0;do{Wpb(16,+n[(f[d>>2]|0)+4+(o<<2)>>2],c);o=o+1|0}while((o|0)<(f[p>>2]|0))}p=a+76|0;if((f[p>>2]|0)>0){o=a+84|0;d=0;do{Wpb(17,+n[(f[o>>2]|0)+4+(d<<2)>>2],c);d=d+1|0}while((d|0)<(f[p>>2]|0))}p=f[a+4>>2]|0;if(!(p&1))return;aQb(p&-2,c);return}function v7a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function w7a(a){a=a|0;return f[a+12>>2]|0}function x7a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+88>>2]|0;b[d>>0]=13;i=d+1|0;b[i>>0]=e;b[i+1>>0]=e>>8;b[i+2>>0]=e>>16;b[i+3>>0]=e>>24;g=d+5|0;h=f[c>>2]|0}if(!(h&2))j=g;else{h=f[a+92>>2]|0;b[g>>0]=21;d=g+1|0;b[d>>0]=h;b[d+1>>0]=h>>8;b[d+2>>0]=h>>16;b[d+3>>0]=h>>24;j=g+5|0}g=a+16|0;if((f[g>>2]|0)>0){h=a+24|0;d=0;e=j;while(1){i=f[(f[h>>2]|0)+4+(d<<2)>>2]|0;b[e>>0]=29;k=e+1|0;b[k>>0]=i;b[k+1>>0]=i>>8;b[k+2>>0]=i>>16;b[k+3>>0]=i>>24;i=e+5|0;d=d+1|0;if((d|0)>=(f[g>>2]|0)){l=i;break}else e=i}}else l=j;j=f[c>>2]|0;if(!(j&8)){m=l;n=j}else{j=b[a+120>>0]|0;b[l>>0]=32;b[l+1>>0]=j;m=l+2|0;n=f[c>>2]|0}if(!(n&16))o=m;else{n=b[a+121>>0]|0;b[m>>0]=40;b[m+1>>0]=n;o=m+2|0}m=a+28|0;if((f[m>>2]|0)>0){n=a+36|0;l=0;j=o;while(1){e=f[(f[n>>2]|0)+4+(l<<2)>>2]|0;b[j>>0]=53;g=j+1|0;b[g>>0]=e;b[g+1>>0]=e>>8;b[g+2>>0]=e>>16;b[g+3>>0]=e>>24;e=j+5|0;l=l+1|0;if((l|0)>=(f[m>>2]|0)){p=e;break}else j=e}}else p=o;o=f[c>>2]|0;if(!(o&64)){q=p;r=o}else{o=f[a+96>>2]|0;b[p>>0]=56;j=p+1|0;if(o>>>0>127){p=o;m=j;while(1){b[m>>0]=p|128;l=p>>>7;n=m+1|0;if(p>>>0>16383){p=l;m=n}else{s=n;t=l;break}}}else{s=j;t=o}b[s>>0]=t;q=s+1|0;r=f[c>>2]|0}if(!(r&128)){u=q;v=r}else{r=f[a+100>>2]|0;b[q>>0]=64;s=q+1|0;if(r>>>0>127){q=r;t=s;while(1){b[t>>0]=q|128;o=q>>>7;j=t+1|0;if(q>>>0>16383){q=o;t=j}else{w=j;x=o;break}}}else{w=s;x=r}b[w>>0]=x;u=w+1|0;v=f[c>>2]|0}if(!(v&256)){y=u;z=v}else{v=f[a+104>>2]|0;b[u>>0]=72;w=u+1|0;if(v>>>0>127){u=v;x=w;while(1){b[x>>0]=u|128;r=u>>>7;s=x+1|0;if(u>>>0>16383){u=r;x=s}else{A=s;B=r;break}}}else{A=w;B=v}b[A>>0]=B;y=A+1|0;z=f[c>>2]|0}if(!(z&512)){C=y;D=z}else{z=f[a+108>>2]|0;b[y>>0]=85;A=y+1|0;b[A>>0]=z;b[A+1>>0]=z>>8;b[A+2>>0]=z>>16;b[A+3>>0]=z>>24;C=y+5|0;D=f[c>>2]|0}if(!(D&1024)){E=C;F=D}else{D=f[a+112>>2]|0;b[C>>0]=93;y=C+1|0;b[y>>0]=D;b[y+1>>0]=D>>8;b[y+2>>0]=D>>16;b[y+3>>0]=D>>24;E=C+5|0;F=f[c>>2]|0}if(!(F&2048)){G=E;H=F}else{F=f[a+116>>2]|0;b[E>>0]=101;C=E+1|0;b[C>>0]=F;b[C+1>>0]=F>>8;b[C+2>>0]=F>>16;b[C+3>>0]=F>>24;G=E+5|0;H=f[c>>2]|0}if(!(H&4096))I=G;else{H=f[a+124>>2]|0;b[G>>0]=109;c=G+1|0;b[c>>0]=H;b[c+1>>0]=H>>8;b[c+2>>0]=H>>16;b[c+3>>0]=H>>24;I=G+5|0}G=a+40|0;if((f[G>>2]|0)>0){H=a+48|0;c=0;E=I;while(1){F=f[(f[H>>2]|0)+4+(c<<2)>>2]|0;b[E>>0]=117;C=E+1|0;b[C>>0]=F;b[C+1>>0]=F>>8;b[C+2>>0]=F>>16;b[C+3>>0]=F>>24;F=E+5|0;c=c+1|0;if((c|0)>=(f[G>>2]|0)){J=F;break}else E=F}}else J=I;I=a+52|0;if((f[I>>2]|0)>0){E=a+60|0;G=0;c=J;while(1){H=f[(f[E>>2]|0)+4+(G<<2)>>2]|0;b[c>>0]=125;F=c+1|0;b[F>>0]=H;b[F+1>>0]=H>>8;b[F+2>>0]=H>>16;b[F+3>>0]=H>>24;H=c+5|0;G=G+1|0;if((G|0)>=(f[I>>2]|0)){K=H;break}else c=H}}else K=J;J=a+64|0;if((f[J>>2]|0)>0){c=a+72|0;I=0;G=K;while(1){E=f[(f[c>>2]|0)+4+(I<<2)>>2]|0;b[G>>0]=-123;b[G+1>>0]=1;H=G+2|0;b[H>>0]=E;b[H+1>>0]=E>>8;b[H+2>>0]=E>>16;b[H+3>>0]=E>>24;E=G+6|0;I=I+1|0;if((I|0)>=(f[J>>2]|0)){L=E;break}else G=E}}else L=K;K=a+76|0;if((f[K>>2]|0)>0){G=a+84|0;J=0;I=L;while(1){c=f[(f[G>>2]|0)+4+(J<<2)>>2]|0;b[I>>0]=-115;b[I+1>>0]=1;E=I+2|0;b[E>>0]=c;b[E+1>>0]=c>>8;b[E+2>>0]=c>>16;b[E+3>>0]=c>>24;c=I+6|0;J=J+1|0;if((J|0)>=(f[K>>2]|0)){M=c;break}else I=c}}else M=L;L=f[a+4>>2]|0;if(!(L&1)){N=M;return N|0}N=bQb(L&-2,M)|0;return N|0}function y7a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function z7a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(6046);c=T6b(b,23288,19816,0)|0;if(!c){cOb(b,a);return}else{Q3a(a,c);return}}function A7a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function B7a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213046];f[a+4>>2]=f[213047];u=c;return}function C7a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function D7a(a){a=a|0;var b=0,c=0;f[a>>2]=111672;if((a|0)!=493240?(b=f[a+16>>2]|0,b|0):0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function E7a(a){a=a|0;D7a(a);O5b(a);return}function F7a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function G7a(a,b){a=a|0;b=b|0;a=L5b(28)|0;M3a(a);if(!b)return a|0;R7a(b,a);return a|0}function H7a(a){a=a|0;return 1}function I7a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a+8|0;c=f[b>>2]|0;if(!(c&15))d=0;else{e=c<<1&2;if(!(c&2)){g=e;h=c}else{c=INa(f[a+16>>2]|0)|0;if(c>>>0<128)i=1;else i=iob(c)|0;g=(e|1)+c+i|0;h=f[b>>2]|0}b=h&4|0?g+2|0:g;d=h&8|0?b+5|0:b}b=f[a+4>>2]|0;if(!(b&1)){j=d;k=a+12|0;f[k>>2]=j;return j|0}j=(dQb(b&-2)|0)+d|0;k=a+12|0;f[k>>2]=j;return j|0}function J7a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Ypb(1,(b[a+20>>0]|0)!=0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{eqb(2,f[a+16>>2]|0,c);h=f[d>>2]|0}if(!(h&4))i=h;else{Ypb(3,(b[a+21>>0]|0)!=0,c);i=f[d>>2]|0}if(i&8|0)Wpb(4,+n[a+24>>2],c);i=f[a+4>>2]|0;if(!(i&1))return;aQb(i&-2,c);return}function K7a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function L7a(a){a=a|0;return f[a+12>>2]|0}function M7a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=b[a+20>>0]|0;b[d>>0]=8;b[d+1>>0]=e;g=d+2|0;h=f[c>>2]|0}if(!(h&2)){i=g;j=h}else{h=f[a+16>>2]|0;b[g>>0]=18;d=g+1|0;g=f[h+12>>2]|0;if(g>>>0>127){e=g;k=d;while(1){b[k>>0]=e|128;l=e>>>7;m=k+1|0;if(e>>>0>16383){e=l;k=m}else{n=m;o=l;break}}}else{n=d;o=g}b[n>>0]=o;o=li[f[(f[h>>2]|0)+68>>2]&511](h,0,n+1|0)|0;i=o;j=f[c>>2]|0}if(!(j&4)){p=i;q=j}else{j=b[a+21>>0]|0;b[i>>0]=24;b[i+1>>0]=j;p=i+2|0;q=f[c>>2]|0}if(!(q&8))r=p;else{q=f[a+24>>2]|0;b[p>>0]=37;c=p+1|0;b[c>>0]=q;b[c+1>>0]=q>>8;b[c+2>>0]=q>>16;b[c+3>>0]=q>>24;r=p+5|0}p=f[a+4>>2]|0;if(!(p&1)){s=r;return s|0}s=bQb(p&-2,r)|0;return s|0}function N7a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function O7a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(5033);c=T6b(b,23288,19832,0)|0;if(!c){cOb(b,a);return}else{N3a(a,c);return}}function P7a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Q7a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213044];f[a+4>>2]=f[213045];u=c;return}function R7a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function S7a(a){a=a|0;var b=0,c=0;f[a>>2]=111564;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function T7a(a){a=a|0;var b=0,c=0;f[a>>2]=111564;b=f[a+24>>2]|0;if(b|0?(f[b>>2]|0)==0:0)O5b(b);b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function U7a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function V7a(a,b){a=a|0;b=b|0;a=L5b(28)|0;O3a(a);if(!b)return a|0;f8a(b,a);return a|0}function W7a(a){a=a|0;var b=0;f[a+16>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function X7a(a){a=a|0;return 1}function Y7a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=a+16|0;c=f[b>>2]|0;if(!c){d=0;e=0}else{g=a+24|0;h=0;i=0;do{j=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;if(j>>>0<128)k=1;else k=iob(j)|0;i=k+i|0;h=h+1|0}while((h|0)!=(c|0));d=i;e=f[b>>2]|0}b=e+d|0;d=f[a+4>>2]|0;if(!(d&1)){l=b;m=a+12|0;f[m>>2]=l;return l|0}l=(dQb(d&-2)|0)+b|0;m=a+12|0;f[m>>2]=l;return l|0}function Z7a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+16|0;if((f[c>>2]|0)>0){d=a+24|0;e=0;do{Opb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)<(f[c>>2]|0))}c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function _7a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function $7a(a){a=a|0;return f[a+12>>2]|0}function a8a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+16|0;if((f[c>>2]|0)>0){e=a+24|0;g=0;h=d;while(1){i=f[(f[e>>2]|0)+4+(g<<2)>>2]|0;b[h>>0]=8;j=h+1|0;if(i>>>0>127){k=i;l=j;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=j;p=i}b[o>>0]=p;l=o+1|0;g=g+1|0;if((g|0)>=(f[c>>2]|0)){q=l;break}else h=l}}else q=d;d=f[a+4>>2]|0;if(!(d&1)){r=q;return r|0}r=bQb(d&-2,q)|0;return r|0}function b8a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function c8a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((a|0)==(b|0))jMa(4641);c=T6b(b,23288,19848,0)|0;if(!c){cOb(b,a);return}b=a+16|0;d=c+16|0;e=f[d>>2]|0;if(e|0){rza(b,(f[b>>2]|0)+e|0);Vac((f[a+24>>2]|0)+4+(f[b>>2]<<2)|0,(f[c+24>>2]|0)+4|0,f[d>>2]<<2|0)|0;f[b>>2]=(f[b>>2]|0)+(f[d>>2]|0)}d=f[c+4>>2]|0;if(!(d&1))return;LPb(d&-2,a+4|0);return}function d8a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function e8a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213042];f[a+4>>2]=f[213043];u=c;return}function f8a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function g8a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=111456;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(h);f[b>>2]=0;return}function h8a(a){a=a|0;g8a(a);O5b(a);return}function i8a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function j8a(a,b){a=a|0;b=b|0;a=L5b(32)|0;w8a(a);if(!b)return a|0;x8a(b,a);return a|0}function k8a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function l8a(a){a=a|0;return 1}function m8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=c+4|0;e=c+20|0;g=c+44|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=c+32|0;m=c+12|0;n=c+28|0;o=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[e>>2]=q;f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=_nb(c,t)|0;f[e>>2]=q;if((q+-1|0)>>>0<127){r=q;s=6}else u=q}if((s|0)==6){s=0;if((r|0)==10){q=f[g>>2]|0;f[g>>2]=q+-1;if((q|0)<=0){v=0;s=29;break}while(1){q=f[i>>2]|0;do if(q){a=f[k>>2]|0;p=f[q>>2]|0;if((a|0)>=(p|0))if((p|0)==(f[j>>2]|0)){w=p;s=13;break}else{x=p;y=q;s=14;break}else{f[k>>2]=a+1;z=f[q+4+(a<<2)>>2]|0;break}}else{w=f[j>>2]|0;s=13}while(0);if((s|0)==13){s=0;cpb(h,w+1|0);q=f[i>>2]|0;x=f[q>>2]|0;y=q;s=14}if((s|0)==14){s=0;f[y>>2]=x+1;q=pza(0,f[h>>2]|0)|0;a=f[i>>2]|0;p=f[k>>2]|0;f[k>>2]=p+1;f[a+4+(p<<2)>>2]=q;z=q}q=Jnb(c)|0;if(!(hOa(z,c)|0)){v=0;s=29;break a}if(!(Pnb(c,q)|0)){v=0;s=29;break a}A=f[c>>2]|0;B=f[d>>2]|0;if(A>>>0>=B>>>0)break;if((b[A>>0]|0)!=10)break;f[c>>2]=A+1}f[g>>2]=(f[g>>2]|0)+1;if((A|0)!=(B|0))continue;if(f[l>>2]|0){s=23;break}if((f[m>>2]|0)==(f[n>>2]|0)){s=23;break}else continue}else u=r}if((u|0)==0|(u&7|0)==4){v=1;s=29;break}q=f[o>>2]|0;if(!(q&1))C=hBa(o)|0;else C=q&-2;if(!(ZPb(c,u,C)|0)){v=0;s=29;break}}if((s|0)==23){f[e>>2]=0;b[c+24>>0]=1;v=1;return v|0}else if((s|0)==29)return v|0;return 0}function n8a(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+20>>2]|0;if(!b)c=0;else{d=a+28|0;e=0;g=b;while(1){h=gOa(f[(f[d>>2]|0)+4+(e<<2)>>2]|0)|0;if(h>>>0<128)i=1;else i=iob(h)|0;j=h+g+i|0;e=e+1|0;if((e|0)==(b|0)){c=j;break}else g=j}}g=f[a+4>>2]|0;if(!(g&1)){k=c;l=a+12|0;f[l>>2]=k;return k|0}k=(dQb(g&-2)|0)+c|0;l=a+12|0;f[l>>2]=k;return k|0}function o8a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eqb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function p8a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function q8a(a){a=a|0;return f[a+12>>2]|0}function r8a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+20>>2]|0;if(!c)e=d;else{g=a+28|0;h=0;i=d;while(1){d=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=10;j=i+1|0;k=f[d+12>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=j;q=k}b[p>>0]=q;m=li[f[(f[d>>2]|0)+68>>2]&511](d,0,p+1|0)|0;h=h+1|0;if((h|0)==(c|0)){e=m;break}else i=m}}i=f[a+4>>2]|0;if(!(i&1)){r=e;return r|0}r=bQb(i&-2,e)|0;return r|0}function s8a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function t8a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(4348);c=T6b(b,23288,19864,0)|0;if(!c){cOb(b,a);return}bOa(a+16|0,c+16|0);b=f[c+4>>2]|0;if(!(b&1))return;LPb(b&-2,a+4|0);return}function u8a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function v8a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213040];f[a+4>>2]=f[213041];u=c;return}function w8a(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=111456;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=493160?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;u=c;return}function x8a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function y8a(a){a=a|0;var c=0,d=0;f[a>>2]=111348;c=a+80|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)!=493040?(c=f[a+84>>2]|0,c|0):0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+72>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=f[a+56>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=f[a+40>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(d);f[c>>2]=0;return}function z8a(a){a=a|0;y8a(a);O5b(a);return}function A8a(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function B8a(a,b){a=a|0;b=b|0;a=L5b(108)|0;M8a(a);if(!b)return a|0;N8a(b,a);return a|0}function C8a(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if(d&225|0){e=a+88|0;f[e>>2]=0;f[e+4>>2]=0;if(((d&1|0?(e=f[a+84>>2]|0,e|0):0)?(f[e+16>>2]=0,f[e+8>>2]=0,g=f[e+4>>2]|0,g&1|0):0)?(e=g&-2,f[e>>2]|0):0)GPb(e);if(f[c>>2]&64|0?(e=f[a+80>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);d=a+96|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[a+16>>2]=0;f[a+32>>2]=0;f[a+48>>2]=0;f[a+64>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function D8a(a){a=a|0;return 1}function E8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=a+8|0;e=f[d>>2]|0;if(!(e&128))g=e;else{Mpb(1,f[a+92>>2]|0,c);g=f[d>>2]|0}if(!(g&256))h=g;else{Mpb(2,f[a+96>>2]|0,c);h=f[d>>2]|0}if(!(h&512))i=h;else{Mpb(3,f[a+100>>2]|0,c);i=f[d>>2]|0}if(i&1024|0)Mpb(4,f[a+104>>2]|0,c);i=a+16|0;if((f[i>>2]|0)>0){h=c+8|0;if((f[h>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=42;f[g>>2]=(f[g>>2]|0)+1;g=(f[h>>2]|0)+-1|0;f[h>>2]=g;j=g}else{fob(c,42);j=f[h>>2]|0}g=f[a+28>>2]|0;if((j|0)>4){j=c+4|0;e=f[j>>2]|0;if(g>>>0>127){k=g;l=e;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=e;p=g}b[o>>0]=p;p=o+1-e|0;f[j>>2]=(f[j>>2]|0)+p;f[h>>2]=(f[h>>2]|0)-p}else fob(c,g);if((f[i>>2]|0)>0){g=a+24|0;p=0;do{dob(c,f[(f[g>>2]|0)+4+(p<<2)>>2]|0);p=p+1|0}while((p|0)<(f[i>>2]|0))}}i=a+32|0;if((f[i>>2]|0)>0){p=c+8|0;if((f[p>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=50;f[g>>2]=(f[g>>2]|0)+1;g=(f[p>>2]|0)+-1|0;f[p>>2]=g;q=g}else{fob(c,50);q=f[p>>2]|0}g=f[a+44>>2]|0;if((q|0)>4){q=c+4|0;h=f[q>>2]|0;if(g>>>0>127){j=g;e=h;while(1){b[e>>0]=j|128;o=j>>>7;l=e+1|0;if(j>>>0>16383){j=o;e=l}else{r=l;s=o;break}}}else{r=h;s=g}b[r>>0]=s;s=r+1-h|0;f[q>>2]=(f[q>>2]|0)+s;f[p>>2]=(f[p>>2]|0)-s}else fob(c,g);if((f[i>>2]|0)>0){g=a+40|0;s=0;do{dob(c,f[(f[g>>2]|0)+4+(s<<2)>>2]|0);s=s+1|0}while((s|0)<(f[i>>2]|0))}}if(f[d>>2]&1|0)eqb(7,f[a+84>>2]|0,c);i=a+48|0;if((f[i>>2]|0)>0){s=c+8|0;if((f[s>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=66;f[g>>2]=(f[g>>2]|0)+1;g=(f[s>>2]|0)+-1|0;f[s>>2]=g;t=g}else{fob(c,66);t=f[s>>2]|0}g=f[a+60>>2]|0;if((t|0)>4){t=c+4|0;p=f[t>>2]|0;if(g>>>0>127){q=g;h=p;while(1){b[h>>0]=q|128;r=q>>>7;e=h+1|0;if(q>>>0>16383){q=r;h=e}else{u=e;v=r;break}}}else{u=p;v=g}b[u>>0]=v;v=u+1-p|0;f[t>>2]=(f[t>>2]|0)+v;f[s>>2]=(f[s>>2]|0)-v}else fob(c,g);if((f[i>>2]|0)>0){g=a+56|0;v=0;do{s=(f[g>>2]|0)+8+(v<<3)|0;eob(c,f[s>>2]|0,f[s+4>>2]|0);v=v+1|0}while((v|0)<(f[i>>2]|0))}}i=a+64|0;if((f[i>>2]|0)>0){v=c+8|0;if((f[v>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=74;f[g>>2]=(f[g>>2]|0)+1;g=(f[v>>2]|0)+-1|0;f[v>>2]=g;w=g}else{fob(c,74);w=f[v>>2]|0}g=f[a+76>>2]|0;if((w|0)>4){w=c+4|0;s=f[w>>2]|0;if(g>>>0>127){t=g;p=s;while(1){b[p>>0]=t|128;u=t>>>7;h=p+1|0;if(t>>>0>16383){t=u;p=h}else{x=h;y=u;break}}}else{x=s;y=g}b[x>>0]=y;y=x+1-s|0;f[w>>2]=(f[w>>2]|0)+y;f[v>>2]=(f[v>>2]|0)-y}else fob(c,g);if((f[i>>2]|0)>0){g=a+72|0;y=0;do{v=(f[g>>2]|0)+8+(y<<3)|0;eob(c,f[v>>2]|0,f[v+4>>2]|0);y=y+1|0}while((y|0)<(f[i>>2]|0))}}i=f[d>>2]|0;if(!(i&32))z=i;else{Zpb(10,f[a+88>>2]|0,c);z=f[d>>2]|0}if(z&64|0)bqb(12,f[a+80>>2]|0,c);z=f[a+4>>2]|0;if(!(z&1))return;aQb(z&-2,c);return}function F8a(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function G8a(a){a=a|0;return f[a+12>>2]|0}function H8a(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;c=a+8|0;do if(!(f[c>>2]&128))e=d;else{g=f[a+92>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);do if(!(f[c>>2]&256))o=e;else{m=f[a+96>>2]|0;b[e>>0]=16;n=e+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){d=m;j=n;while(1){b[j>>0]=d|128;i=d>>>7;k=j+1|0;if(d>>>0>16383){d=i;j=k}else{q=k;r=i;break}}}else{q=n;r=m}b[q>>0]=r;o=q+1|0}while(0);do if(!(f[c>>2]&512))t=o;else{q=f[a+100>>2]|0;b[o>>0]=24;r=o+1|0;if((q|0)<0){t=hob(q,((q|0)<0)<<31>>31,r)|0;break}if(q>>>0>127){e=q;j=r;while(1){b[j>>0]=e|128;d=e>>>7;g=j+1|0;if(e>>>0>16383){e=d;j=g}else{u=g;v=d;break}}}else{u=r;v=q}b[u>>0]=v;t=u+1|0}while(0);do if(!(f[c>>2]&1024))w=t;else{u=f[a+104>>2]|0;b[t>>0]=32;v=t+1|0;if((u|0)<0){w=hob(u,((u|0)<0)<<31>>31,v)|0;break}if(u>>>0>127){o=u;j=v;while(1){b[j>>0]=o|128;e=o>>>7;m=j+1|0;if(o>>>0>16383){o=e;j=m}else{x=m;y=e;break}}}else{x=v;y=u}b[x>>0]=y;w=x+1|0}while(0);x=a+16|0;if((f[x>>2]|0)>0){b[w>>0]=42;y=w+1|0;t=f[a+28>>2]|0;if(t>>>0>127){j=t;o=y;while(1){b[o>>0]=j|128;q=j>>>7;r=o+1|0;if(j>>>0>16383){j=q;o=r}else{z=r;A=q;break}}}else{z=y;A=t}b[z>>0]=A;A=z+1|0;if((f[x>>2]|0)>0){z=a+24|0;t=0;y=A;while(1){o=f[(f[z>>2]|0)+4+(t<<2)>>2]|0;b[y>>0]=o;b[y+1>>0]=o>>8;b[y+2>>0]=o>>16;b[y+3>>0]=o>>24;o=y+4|0;t=t+1|0;if((t|0)>=(f[x>>2]|0)){B=o;break}else y=o}}else B=A}else B=w;w=a+32|0;if((f[w>>2]|0)>0){b[B>>0]=50;A=B+1|0;y=f[a+44>>2]|0;if(y>>>0>127){x=y;t=A;while(1){b[t>>0]=x|128;z=x>>>7;o=t+1|0;if(x>>>0>16383){x=z;t=o}else{C=o;D=z;break}}}else{C=A;D=y}b[C>>0]=D;D=C+1|0;if((f[w>>2]|0)>0){C=a+40|0;y=0;A=D;while(1){t=f[(f[C>>2]|0)+4+(y<<2)>>2]|0;b[A>>0]=t;b[A+1>>0]=t>>8;b[A+2>>0]=t>>16;b[A+3>>0]=t>>24;t=A+4|0;y=y+1|0;if((y|0)>=(f[w>>2]|0)){E=t;break}else A=t}}else E=D}else E=B;if(!(f[c>>2]&1))F=E;else{B=f[a+84>>2]|0;b[E>>0]=58;D=E+1|0;E=f[B+12>>2]|0;if(E>>>0>127){A=E;w=D;while(1){b[w>>0]=A|128;y=A>>>7;C=w+1|0;if(A>>>0>16383){A=y;w=C}else{G=C;H=y;break}}}else{G=D;H=E}b[G>>0]=H;F=li[f[(f[B>>2]|0)+68>>2]&511](B,0,G+1|0)|0}G=a+48|0;if((f[G>>2]|0)>0){b[F>>0]=66;B=F+1|0;H=f[a+60>>2]|0;if(H>>>0>127){E=H;D=B;while(1){b[D>>0]=E|128;w=E>>>7;A=D+1|0;if(E>>>0>16383){E=w;D=A}else{I=A;J=w;break}}}else{I=B;J=H}b[I>>0]=J;J=I+1|0;if((f[G>>2]|0)>0){I=a+56|0;H=0;B=J;while(1){p[s>>3]=+p[(f[I>>2]|0)+8+(H<<3)>>3];b[B>>0]=b[s>>0];b[B+1>>0]=b[s+1>>0];b[B+2>>0]=b[s+2>>0];b[B+3>>0]=b[s+3>>0];b[B+4>>0]=b[s+4>>0];b[B+5>>0]=b[s+5>>0];b[B+6>>0]=b[s+6>>0];b[B+7>>0]=b[s+7>>0];D=B+8|0;H=H+1|0;if((H|0)>=(f[G>>2]|0)){K=D;break}else B=D}}else K=J}else K=F;F=a+64|0;if((f[F>>2]|0)>0){b[K>>0]=74;J=K+1|0;B=f[a+76>>2]|0;if(B>>>0>127){G=B;H=J;while(1){b[H>>0]=G|128;I=G>>>7;D=H+1|0;if(G>>>0>16383){G=I;H=D}else{L=D;M=I;break}}}else{L=J;M=B}b[L>>0]=M;M=L+1|0;if((f[F>>2]|0)>0){L=a+72|0;B=0;J=M;while(1){p[s>>3]=+p[(f[L>>2]|0)+8+(B<<3)>>3];b[J>>0]=b[s>>0];b[J+1>>0]=b[s+1>>0];b[J+2>>0]=b[s+2>>0];b[J+3>>0]=b[s+3>>0];b[J+4>>0]=b[s+4>>0];b[J+5>>0]=b[s+5>>0];b[J+6>>0]=b[s+6>>0];b[J+7>>0]=b[s+7>>0];H=J+8|0;B=B+1|0;if((B|0)>=(f[F>>2]|0)){N=H;break}else J=H}}else N=M}else N=K;do if(!(f[c>>2]&32))O=N;else{K=f[a+88>>2]|0;b[N>>0]=80;M=N+1|0;if((K|0)<0){O=hob(K,((K|0)<0)<<31>>31,M)|0;break}if(K>>>0>127){J=K;F=M;while(1){b[F>>0]=J|128;B=J>>>7;L=F+1|0;if(J>>>0>16383){J=B;F=L}else{P=L;Q=B;break}}}else{P=M;Q=K}b[P>>0]=Q;O=P+1|0}while(0);if(!(f[c>>2]&64))R=O;else{c=f[a+80>>2]|0;b[O>>0]=98;R=kob(c,O+1|0)|0}O=f[a+4>>2]|0;if(!(O&1)){S=R;return S|0}S=bQb(O&-2,R)|0;return S|0}function I8a(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function J8a(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))jMa(3710);c=T6b(b,23288,19880,0)|0;if(!c){cOb(b,a);return}else{eOa(a,c);return}}function K8a(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function L8a(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213035]|0)!=2){f[d>>2]=135812;f[d+4>>2]=39;b[d+8>>0]=0;Gpb(852140,d);hpb(d)}f[a>>2]=f[213038];f[a+4>>2]=f[213039];u=c;return}function M8a(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=111348;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=0;f[a+48>>2]=0;f[a+52>>2]=0;f[a+56>>2]=0;f[a+64>>2]=0;f[a+68>>2]=0;f[a+72>>2]=0;if((a|0)!=493040?(f[213033]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=41;b[d+8>>0]=0;Gpb(852132,d);hpb(d)}f[a+12>>2]=0;f[a+80>>2]=497760;d=a+84|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;u=c;return}function N8a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function O8a(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function P8a(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213034]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=40;b[c+8>>0]=0;Gpb(852136,c);hpb(c);u=a;return}function Q8a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);eOa(a,b);return}function R8a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);HNa(a,b);return}function S8a(a,b){a=a|0;b=b|0;var c=0,e=0,g=0;f[a>>2]=112212;c=a+92|0;e=a+4|0;g=e+88|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[c>>2]=497760;f[a+96>>2]=0;d[a+100>>1]=0;O5a(a,b);return}function T8a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);O5a(a,b);return}function U8a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);DPa(a,b);return}function V8a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);qPa(a,b);return}function W8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((c|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);d=c+8|0;e=f[d>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=f[c+16>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;f[a+16>>2]=e;g=f[d>>2]|0}if(!(g&2))i=g;else{g=f[c+24>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;f[a+24>>2]=g;i=f[d>>2]|0}if(i&4|0){i=b[c+20>>0]|0;d=a+8|0;f[d>>2]=f[d>>2]|4;b[a+20>>0]=i}}i=f[c+4>>2]|0;if(!(i&1))return;LPb(i&-2,a+4|0);return}function X8a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);c=b+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[b+20>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+20>>2]=d;e=f[c>>2]|0}if(!(e&2))h=e;else{e=f[b+24>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+24>>2]=e;h=f[c>>2]|0}if(h&4|0){h=f[b+16>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|4;f[a+16>>2]=h}}h=f[b+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function Y8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((c|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);d=c+8|0;e=f[d>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=b[c+16>>0]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;b[a+16>>0]=e;g=f[d>>2]|0}if(!(g&2))i=g;else{g=f[c+24>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;f[a+24>>2]=g;i=f[d>>2]|0}if(i&4|0){i=f[c+20>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|4;f[a+20>>2]=i}}i=f[c+4>>2]|0;if(!(i&1))return;LPb(i&-2,a+4|0);return}function Z8a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);c=b+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[b+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[c>>2]|0}if(e&2|0){e=f[b+20>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|2;f[a+20>>2]=e}}e=f[b+4>>2]|0;if(!(e&1))return;LPb(e&-2,a+4|0);return}function _8a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((c|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);d=c+8|0;e=f[d>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=f[c+20>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;f[a+20>>2]=e;g=f[d>>2]|0}if(g&2|0){g=b[c+16>>0]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;b[a+16>>0]=g}}g=f[c+4>>2]|0;if(!(g&1))return;LPb(g&-2,a+4|0);return}function $8a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);JOa(a,b);return}function a9a(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=114048;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=497760;f[a+20>>2]=497760;c=a+24|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;d[c+16>>1]=0;n[a+44>>2]=1.0;f[a+48>>2]=4;LOa(a,b);return}function b9a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);LOa(a,b);return}function c9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((c|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);d=c+8|0;e=f[d>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=f[c+16>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;f[a+16>>2]=e;g=f[d>>2]|0}if(g&2|0){g=b[c+20>>0]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;b[a+20>>0]=g}}g=f[c+4>>2]|0;if(!(g&1))return;LPb(g&-2,a+4|0);return}function d9a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);OOa(a,b);return}function e9a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);QOa(a,b);return}function f9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);c=b+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[b+20>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+20>>2]=d;e=f[c>>2]|0}if(!(e&2))h=e;else{e=f[b+24>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+24>>2]=e;h=f[c>>2]|0}if(h&4|0){h=f[b+16>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|4;f[a+16>>2]=h}}h=f[b+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function g9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+4|0;g=d;if((c|0)==(a|0)){u=d;return}bi[f[(f[a>>2]|0)+28>>2]&2047](a);h=c+8|0;i=f[h>>2]|0;if(i&255|0){if(!(i&1))j=i;else{i=a+8|0;f[i>>2]=f[i>>2]|1;f[g>>2]=f[c+16>>2];f[e>>2]=f[g>>2];Anb(a+16|0,497760,e);j=f[h>>2]|0}if(!(j&2))k=j;else{j=f[c+20>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;f[a+20>>2]=j;k=f[h>>2]|0}if(k&4|0){k=b[c+24>>0]|0;h=a+8|0;f[h>>2]=f[h>>2]|4;b[a+24>>0]=k}}k=f[c+4>>2]|0;if(k&1|0)LPb(k&-2,a+4|0);u=d;return}function h9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c+4|0;e=c;if((b|0)==(a|0)){u=c;return}bi[f[(f[a>>2]|0)+28>>2]&2047](a);if(f[b+8>>2]&1|0){g=a+8|0;f[g>>2]=f[g>>2]|1;f[e>>2]=f[b+16>>2];f[d>>2]=f[e>>2];Anb(a+16|0,497760,d)}d=f[b+4>>2]|0;if(d&1|0)LPb(d&-2,a+4|0);u=c;return}function i9a(a,b){a=a|0;b=b|0;var c=0,d=0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);if(f[b+8>>2]&1|0){c=f[b+16>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|1;f[a+16>>2]=c}c=f[b+4>>2]|0;if(!(c&1))return;LPb(c&-2,a+4|0);return}function j9a(a,c){a=a|0;c=c|0;var d=0;f[a>>2]=115452;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=497760;f[a+20>>2]=497760;f[a+24>>2]=497760;d=a+28|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;n[a+48>>2]=1.0;f[a+52>>2]=1;b[a+56>>0]=1;WOa(a,c);return}function k9a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);WOa(a,b);return}function l9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c+4|0;e=c;if((b|0)==(a|0)){u=c;return}bi[f[(f[a>>2]|0)+28>>2]&2047](a);if(f[b+8>>2]&1|0){g=a+8|0;f[g>>2]=f[g>>2]|1;f[e>>2]=f[b+16>>2];f[d>>2]=f[e>>2];Anb(a+16|0,497760,d)}d=f[b+4>>2]|0;if(d&1|0)LPb(d&-2,a+4|0);u=c;return}function m9a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);ZOa(a,b);return}function n9a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);$Oa(a,b);return}function o9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);c=b+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[b+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[c>>2]|0}if(!(e&2))h=e;else{e=f[b+20>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+20>>2]=e;h=f[c>>2]|0}if(!(h&4))i=h;else{h=f[b+24>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|4;f[a+24>>2]=h;i=f[c>>2]|0}if(i&8|0){i=f[b+28>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|8;f[a+28>>2]=i}}i=f[b+4>>2]|0;if(!(i&1))return;LPb(i&-2,a+4|0);return}function p9a(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((c|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);d=c+8|0;e=f[d>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=b[c+17>>0]|0;h=a+8|0;f[h>>2]=f[h>>2]|1;b[a+17>>0]=e;g=f[d>>2]|0}if(!(g&2))i=g;else{g=b[c+16>>0]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;b[a+16>>0]=g;i=f[d>>2]|0}if(i&4|0){i=f[c+20>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|4;f[a+20>>2]=i}}i=f[c+4>>2]|0;if(!(i&1))return;LPb(i&-2,a+4|0);return}function q9a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);ePa(a,b);return}function r9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);c=b+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[b+20>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+20>>2]=d;e=f[c>>2]|0}if(!(e&2))h=e;else{e=f[b+24>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|2;f[a+24>>2]=e;h=f[c>>2]|0}if(h&4|0){h=f[b+16>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|4;f[a+16>>2]=h}}h=f[b+4>>2]|0;if(!(h&1))return;LPb(h&-2,a+4|0);return}function s9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);c=b+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[b+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[c>>2]|0}if(e&2|0){e=f[b+20>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|2;f[a+20>>2]=e}}e=f[b+4>>2]|0;if(!(e&1))return;LPb(e&-2,a+4|0);return}function t9a(a,b){a=a|0;b=b|0;var c=0,d=0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);if(f[b+8>>2]&1|0){c=f[b+16>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|1;f[a+16>>2]=c}c=f[b+4>>2]|0;if(!(c&1))return;LPb(c&-2,a+4|0);return}function u9a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);kPa(a,b);return}function v9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);c=b+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[b+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[c>>2]|0}if(e&2|0){e=f[b+20>>2]|0;c=a+8|0;f[c>>2]=f[c>>2]|2;f[a+20>>2]=e}}e=f[b+4>>2]|0;if(!(e&1))return;LPb(e&-2,a+4|0);return}function w9a(a,b){a=a|0;b=b|0;var c=0,d=0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);if(f[b+8>>2]&1|0){c=f[b+16>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|1;f[a+16>>2]=c}c=f[b+4>>2]|0;if(!(c&1))return;LPb(c&-2,a+4|0);return}function x9a(a,b){a=a|0;b=b|0;var c=0,d=0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);if(f[b+8>>2]&1|0){c=f[b+16>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|1;f[a+16>>2]=c}c=f[b+4>>2]|0;if(!(c&1))return;LPb(c&-2,a+4|0);return}function y9a(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=117936;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=497760;f[a+20>>2]=497760;f[a+24>>2]=f[213031];f[a+28>>2]=497760;c=a+32|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;n[a+48>>2]=1.0;n[a+52>>2]=.5;n[a+56>>2]=.5;n[a+60>>2]=.25;oPa(a,b);return}function z9a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);oPa(a,b);return}function A9a(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);COa(a,b);return}function B9a(){var a=0,b=0,c=0;a=f[213206]|0;if(!a){b=L5b(4)|0;NO(b);f[213206]=b;c=b}else c=a;f[213205]=c;return}function C9a(){var a=0,b=0;a=f[213206]|0;if(a|0){b=a;return b|0}a=L5b(4)|0;NO(a);f[213206]=a;b=a;return b|0}function D9a(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;a=u;u=u+16|0;c=a+8|0;d=a;dQ(c,118900);if((b[497448]|0)==0?Cac(497448)|0:0){b[1122454]=1;zd(1506,1122454,x|0)|0}f[d>>2]=0;f[d+4>>2]=0;e=aD(d,5)|0;b[e>>0]=b[410749]|0;b[e+1>>0]=b[410750]|0;b[e+2>>0]=b[410751]|0;b[e+3>>0]=b[410752]|0;b[e+4>>0]=b[410753]|0;Mwa(d,990);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,5)|0;b[e>>0]=b[410755]|0;b[e+1>>0]=b[410756]|0;b[e+2>>0]=b[410757]|0;b[e+3>>0]=b[410758]|0;b[e+4>>0]=b[410759]|0;Mwa(d,991);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,6)|0;b[e>>0]=b[411848]|0;b[e+1>>0]=b[411849]|0;b[e+2>>0]=b[411850]|0;b[e+3>>0]=b[411851]|0;b[e+4>>0]=b[411852]|0;b[e+5>>0]=b[411853]|0;Mwa(d,992);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,7)|0;b[e>>0]=b[410761]|0;b[e+1>>0]=b[410762]|0;b[e+2>>0]=b[410763]|0;b[e+3>>0]=b[410764]|0;b[e+4>>0]=b[410765]|0;b[e+5>>0]=b[410766]|0;b[e+6>>0]=b[410767]|0;Mwa(d,993);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,7)|0;b[e>>0]=b[410769]|0;b[e+1>>0]=b[410770]|0;b[e+2>>0]=b[410771]|0;b[e+3>>0]=b[410772]|0;b[e+4>>0]=b[410773]|0;b[e+5>>0]=b[410774]|0;b[e+6>>0]=b[410775]|0;Mwa(d,994);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,21)|0;g=410777;h=e+21|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Mwa(d,995);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,11)|0;g=411994;h=e+11|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Mwa(d,996);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,13)|0;g=410799;h=e+13|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Mwa(d,997);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,7)|0;b[i>>0]=b[411904]|0;b[i+1>>0]=b[411905]|0;b[i+2>>0]=b[411906]|0;b[i+3>>0]=b[411907]|0;b[i+4>>0]=b[411908]|0;b[i+5>>0]=b[411909]|0;b[i+6>>0]=b[411910]|0;Mwa(d,998);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,10)|0;g=410813;h=e+10|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Mwa(d,998);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,12)|0;g=410824;h=e+12|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Mwa(d,998);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,3)|0;b[i>>0]=b[410837]|0;b[i+1>>0]=b[410838]|0;b[i+2>>0]=b[410839]|0;Mwa(d,999);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,12)|0;g=410841;h=e+12|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Mwa(d,1e3);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,7)|0;b[i>>0]=b[410854]|0;b[i+1>>0]=b[410855]|0;b[i+2>>0]=b[410856]|0;b[i+3>>0]=b[410857]|0;b[i+4>>0]=b[410858]|0;b[i+5>>0]=b[410859]|0;b[i+6>>0]=b[410860]|0;Mwa(d,1001);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,3)|0;b[i>>0]=b[410862]|0;b[i+1>>0]=b[410863]|0;b[i+2>>0]=b[410864]|0;Mwa(d,1002);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,4)|0;b[i>>0]=82;b[i+1>>0]=101;b[i+2>>0]=76;b[i+3>>0]=85;Mwa(d,1003);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,5)|0;b[i>>0]=b[410866]|0;b[i+1>>0]=b[410867]|0;b[i+2>>0]=b[410868]|0;b[i+3>>0]=b[410869]|0;b[i+4>>0]=b[410870]|0;Mwa(d,1004);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,13)|0;g=410872;h=e+13|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Mwa(d,1005);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,5)|0;b[i>>0]=b[410886]|0;b[i+1>>0]=b[410887]|0;b[i+2>>0]=b[410888]|0;b[i+3>>0]=b[410889]|0;b[i+4>>0]=b[410890]|0;Mwa(d,1005);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,7)|0;b[i>>0]=b[410892]|0;b[i+1>>0]=b[410893]|0;b[i+2>>0]=b[410894]|0;b[i+3>>0]=b[410895]|0;b[i+4>>0]=b[410896]|0;b[i+5>>0]=b[410897]|0;b[i+6>>0]=b[410898]|0;Mwa(d,1006);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,4)|0;b[i>>0]=84;b[i+1>>0]=97;b[i+2>>0]=110;b[i+3>>0]=72;Mwa(d,1007);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,3)|0;b[i>>0]=b[410900]|0;b[i+1>>0]=b[410901]|0;b[i+2>>0]=b[410902]|0;Mwa(d,1008);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,4)|0;b[i>>0]=66;b[i+1>>0]=78;b[i+2>>0]=76;b[i+3>>0]=76;Mwa(d,1009);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,6)|0;b[i>>0]=b[410904]|0;b[i+1>>0]=b[410905]|0;b[i+2>>0]=b[410906]|0;b[i+3>>0]=b[410907]|0;b[i+4>>0]=b[410908]|0;b[i+5>>0]=b[410909]|0;Mwa(d,1010);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,5)|0;b[i>>0]=b[433229]|0;b[i+1>>0]=b[433230]|0;b[i+2>>0]=b[433231]|0;b[i+3>>0]=b[433232]|0;b[i+4>>0]=b[433233]|0;Mwa(d,1011);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,9)|0;g=411943;h=e+9|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Mwa(d,1012);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,9)|0;g=410911;h=e+9|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Mwa(d,1013);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,7)|0;b[i>>0]=b[410921]|0;b[i+1>>0]=b[410922]|0;b[i+2>>0]=b[410923]|0;b[i+3>>0]=b[410924]|0;b[i+4>>0]=b[410925]|0;b[i+5>>0]=b[410926]|0;b[i+6>>0]=b[410927]|0;Mwa(d,1014);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,8)|0;j=i;b[j>>0]=73;b[j+1>>0]=100;b[j+2>>0]=101;b[j+3>>0]=110;j=i+4|0;b[j>>0]=116;b[j+1>>0]=105;b[j+2>>0]=116;b[j+3>>0]=121;Mwa(d,1014);bD(d);f[d>>2]=0;f[d+4>>2]=0;j=aD(d,7)|0;b[j>>0]=b[410929]|0;b[j+1>>0]=b[410930]|0;b[j+2>>0]=b[410931]|0;b[j+3>>0]=b[410932]|0;b[j+4>>0]=b[410933]|0;b[j+5>>0]=b[410934]|0;b[j+6>>0]=b[410935]|0;Mwa(d,1014);bD(d);f[d>>2]=0;f[d+4>>2]=0;j=aD(d,4)|0;b[j>>0]=67;b[j+1>>0]=114;b[j+2>>0]=111;b[j+3>>0]=112;Mwa(d,1015);bD(d);f[d>>2]=0;f[d+4>>2]=0;j=aD(d,7)|0;b[j>>0]=b[410937]|0;b[j+1>>0]=b[410938]|0;b[j+2>>0]=b[410939]|0;b[j+3>>0]=b[410940]|0;b[j+4>>0]=b[410941]|0;b[j+5>>0]=b[410942]|0;b[j+6>>0]=b[410943]|0;Mwa(d,1016);bD(d);f[d>>2]=0;f[d+4>>2]=0;j=aD(d,7)|0;b[j>>0]=b[411791]|0;b[j+1>>0]=b[411792]|0;b[j+2>>0]=b[411793]|0;b[j+3>>0]=b[411794]|0;b[j+4>>0]=b[411795]|0;b[j+5>>0]=b[411796]|0;b[j+6>>0]=b[411797]|0;Mwa(d,1017);bD(d);f[d>>2]=0;f[d+4>>2]=0;j=aD(d,8)|0;i=j;b[i>>0]=80;b[i+1>>0]=114;b[i+2>>0]=105;b[i+3>>0]=111;i=j+4|0;b[i>>0]=114;b[i+1>>0]=66;b[i+2>>0]=111;b[i+3>>0]=120;Mwa(d,1018);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,17)|0;g=410945;h=e+17|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Mwa(d,1018);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,5)|0;b[i>>0]=b[411821]|0;b[i+1>>0]=b[411822]|0;b[i+2>>0]=b[411823]|0;b[i+3>>0]=b[411824]|0;b[i+4>>0]=b[411825]|0;Mwa(d,1019);bD(d);f[d>>2]=0;f[d+4>>2]=0;i=aD(d,6)|0;b[i>>0]=b[411757]|0;b[i+1>>0]=b[411758]|0;b[i+2>>0]=b[411759]|0;b[i+3>>0]=b[411760]|0;b[i+4>>0]=b[411761]|0;b[i+5>>0]=b[411762]|0;Mwa(d,1020);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,15)|0;g=431508;h=e+15|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Mwa(d,1021);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,13)|0;g=410963;h=e+13|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Mwa(d,1022);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,9)|0;g=410977;h=e+9|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));Mwa(d,1022);bD(d);f[d>>2]=0;f[d+4>>2]=0;g=aD(d,5)|0;b[g>>0]=b[410987]|0;b[g+1>>0]=b[410988]|0;b[g+2>>0]=b[410989]|0;b[g+3>>0]=b[410990]|0;b[g+4>>0]=b[410991]|0;Mwa(d,1023);bD(d);f[d>>2]=0;f[d+4>>2]=0;g=aD(d,7)|0;b[g>>0]=b[410993]|0;b[g+1>>0]=b[410994]|0;b[g+2>>0]=b[410995]|0;b[g+3>>0]=b[410996]|0;b[g+4>>0]=b[410997]|0;b[g+5>>0]=b[410998]|0;b[g+6>>0]=b[410999]|0;Mwa(d,1024);bD(d);f[d>>2]=0;f[d+4>>2]=0;g=aD(d,8)|0;e=g;b[e>>0]=80;b[e+1>>0]=114;b[e+2>>0]=111;b[e+3>>0]=112;e=g+4|0;b[e>>0]=111;b[e+1>>0]=115;b[e+2>>0]=97;b[e+3>>0]=108;Mwa(d,1025);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,5)|0;b[e>>0]=b[411001]|0;b[e+1>>0]=b[411002]|0;b[e+2>>0]=b[411003]|0;b[e+3>>0]=b[411004]|0;b[e+4>>0]=b[411005]|0;Mwa(d,1026);bD(d);f[d>>2]=0;f[d+4>>2]=0;e=aD(d,4)|0;b[e>>0]=76;b[e+1>>0]=83;b[e+2>>0]=84;b[e+3>>0]=77;Mwa(d,1027);bD(d);if(!(f[c+4>>2]|0)){u=a;return}u=a;return}function E9a(a){a=a|0;b[a>>0]=0;Fpb();return}function F9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Xeb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function G9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;cbb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function H9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;zkb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function I9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Ofb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function J9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Okb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function K9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Xhb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function L9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Cbb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function M9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;$bb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function N9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Wkb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function O9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Nab(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function P9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;qeb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Q9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;sgb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function R9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Dhb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function S9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;eib(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function T9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;sib(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function U9a(a,b){a=a|0;b=b|0;ikb(a,b);return}function V9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Uib(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function W9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Gib(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function X9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;gjb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Y9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Ijb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function Z9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;ujb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function _9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Wjb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function $9a(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Jdb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function aab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;zdb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function bab(a,b){a=a|0;b=b|0;whb(a,b);return}function cab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;pcb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function dab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;kfb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function eab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;kdb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function fab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Heb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function gab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;$cb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function hab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Zfb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function iab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Egb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function jab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;kbb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function kab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;tbb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function lab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Kcb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function mab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Afb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function nab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Lhb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function oab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;Zdb(d,b);b=f[d>>2]|0;f[a>>2]=b;f[a+4>>2]=f[d+4>>2];a=b;if(!b){e=d;g=a}else{b=a+4|0;f[b>>2]=(f[b>>2]|0)+1;e=d;g=f[d>>2]|0}if(!g){f[e>>2]=0;u=c;return}d=g+4|0;b=f[d>>2]|0;f[d>>2]=b+-1;if((b|0)!=1){f[e>>2]=0;u=c;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);f[e>>2]=0;u=c;return}function pab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0.0,_b=0,$b=0,ac=0,bc=0;d=u;u=u+624|0;e=d+592|0;g=d+400|0;h=d+388|0;i=d+352|0;j=d+304|0;k=d+376|0;l=d+364|0;m=d+16|0;n=d+340|0;o=d+328|0;p=d+316|0;q=d+292|0;r=d+280|0;s=d+268|0;t=d+256|0;v=d+244|0;w=d+172|0;x=d+232|0;y=d+220|0;z=d+208|0;A=d+196|0;B=d+184|0;C=d+160|0;D=d+148|0;E=d+136|0;F=d+124|0;G=d+112|0;H=d+100|0;I=d;J=d+88|0;K=d+76|0;L=d+64|0;M=d+52|0;N=d+40|0;O=d+28|0;P=g+108|0;Q=g+8|0;f[g>>2]=18252;f[P>>2]=18272;f[g+4>>2]=0;RXb(g+108|0,Q);f[g+180>>2]=0;f[g+184>>2]=-1;f[g>>2]=106336;f[P>>2]=106356;Tza(Q);R=g+72|0;if((f[R>>2]|0)==0?(S=YUb(a,411132)|0,f[R>>2]=S,(S|0)!=0):0){f[g+96>>2]=8;QXb(g+(f[(f[g>>2]|0)+-12>>2]|0)|0,0)}else{S=g+(f[(f[g>>2]|0)+-12>>2]|0)|0;QXb(S,f[S+16>>2]|4)}if(!(f[R>>2]|0)){T=0;f[g>>2]=106336;f[P>>2]=106356;Uza(Q);rXb(g,106368);AWb(P);u=d;return T|0};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;R=h+11|0;S=h+4|0;a=e+11|0;U=e+11|0;V=e+4|0;W=j+11|0;X=i+11|0;Z=i+4|0;_=j+11|0;$=c+48|0;aa=c+36|0;ba=c+40|0;ca=c+40|0;da=c+44|0;ea=e+4|0;fa=i+11|0;ga=i+4|0;ha=e+11|0;ia=e+4|0;ja=0;ka=-1;a:while(1){TXb(e,g+(f[(f[g>>2]|0)+-12>>2]|0)|0);la=xZb(e,855500)|0;ma=Uh[f[(f[la>>2]|0)+28>>2]&1023](la,10)|0;yZb(e);la=qab(g,h,ma)|0;ma=(f[la+(f[(f[la>>2]|0)+-12>>2]|0)+16>>2]&5|0)!=0;if(!((ma?0:0)&1|(ma?0:1507)))break;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;ma=b[R>>0]|0;la=f[S>>2]|0;if((ma<<24>>24<0?la:ma&255)|0){na=0;oa=ma;ma=la;while(1){la=b[(oa<<24>>24<0?f[h>>2]|0:h)+na>>0]|0;if((la+-33&255)<90){l6b(e,la);pa=b[R>>0]|0;qa=f[S>>2]|0}else{pa=oa;qa=ma}na=na+1|0;if(na>>>0>=(pa<<24>>24<0?qa:pa&255)>>>0)break;else{oa=pa;ma=qa}}}_5b(h,e)|0;if((b[a>>0]|0)<0)O5b(f[e>>2]|0);ma=b[R>>0]|0;oa=ma<<24>>24<0;na=f[S>>2]|0;la=oa?na:ma&255;if(!la){ra=ka;sa=ja;ka=ra;ja=sa;continue}ta=f[h>>2]|0;switch(b[(oa?ta:h)>>0]|0){case 59:case 35:case 0:{ra=ka;sa=ja;ka=ra;ja=sa;continue a;break}case 91:{if((la|0)==5){if(!(u6b(h,0,-1,411134,5)|0)){ra=ka;ja=1;ka=ra;continue a}ua=b[R>>0]|0;va=f[h>>2]|0;wa=f[S>>2]|0}else{ua=ma;va=ta;wa=na}na=ka+1|0;ta=ua<<24>>24<0;ma=ta?va:h;la=ta?wa:ua&255;ta=ma+la|0;oa=ta;xa=ma;b:do if((la|0)<1)ya=ta;else{za=ma;Aa=la;while(1){Ba=xTb(za,93,Aa)|0;if(!Ba){ya=ta;break b}if((b[Ba>>0]|0)==93){ya=Ba;break b}za=Ba+1|0;Aa=oa-za|0;if((Aa|0)<1){ya=ta;break}}}while(0);oa=(ya|0)==(ta|0)?-2:ya-xa+-1|0;if(oa>>>0>=la>>>0){f[e>>2]=0;f[ia>>2]=0;Ca=aD(e,29)|0;Da=411140;Ea=Ca+29|0;do{b[Ca>>0]=b[Da>>0]|0;Ca=Ca+1|0;Da=Da+1|0}while((Ca|0)<(Ea|0));bO(-215,e,411170,411193,380);bD(e)}Y5b(e,h,1,oa,h);la=f[ba>>2]|0;do if(la){xa=ca;ta=la;ma=la;while(1){Aa=f[ta+16>>2]|0;if((na|0)<(Aa|0)){za=f[ta>>2]|0;if(!za){Fa=44;break}else{Ga=ta;Ha=za}}else{if((Aa|0)>(ka|0)){Fa=48;break}Ia=ta+4|0;Aa=f[Ia>>2]|0;if(!Aa){Fa=47;break}else{Ga=Ia;Ha=Aa}}xa=Ga;ta=Ha;ma=Ha}if((Fa|0)==44){Fa=0;Ja=ta;Ka=ta;Fa=50;break}else if((Fa|0)==47){Fa=0;Ja=Ia;Ka=ta;Fa=50;break}else if((Fa|0)==48){Fa=0;La=xa;Ma=ta;Na=ma;Fa=49;break}}else{La=ba;Ma=ba;Na=la;Fa=49}while(0);if((Fa|0)==49){Fa=0;if(!Na){Ja=La;Ka=Ma;Fa=50}else Oa=Na}if((Fa|0)==50){Fa=0;la=L5b(32)|0;f[la+16>>2]=na;oa=la+24|0;f[oa>>2]=0;f[la+28>>2]=0;f[la+20>>2]=oa;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=Ka;f[Ja>>2]=la;oa=f[f[aa>>2]>>2]|0;if(!oa)Pa=la;else{f[aa>>2]=oa;Pa=f[Ja>>2]|0}mP(f[ca>>2]|0,Pa);f[da>>2]=(f[da>>2]|0)+1;Oa=la}f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[fa>>0]=4;f[i>>2]=1701869940;b[ga>>0]=0;_5b(sab(Oa+20|0,i)|0,e)|0;if((b[fa>>0]|0)<0)O5b(f[i>>2]|0);if((b[ha>>0]|0)<0)O5b(f[e>>2]|0);ja=0;ka=na;continue a;break}default:{}}la=s6b(h,61,0)|0;oa=b[R>>0]|0;if(la>>>0>=(oa<<24>>24<0?f[S>>2]|0:oa&255)>>>0){f[e>>2]=0;f[ea>>2]=0;Ca=aD(e,29)|0;Da=411272;Ea=Ca+29|0;do{b[Ca>>0]=b[Da>>0]|0;Ca=Ca+1|0;Da=Da+1|0}while((Ca|0)<(Ea|0));bO(-215,e,411170,411193,388);bD(e);if((la|0)==-1){ra=ka;sa=ja;ka=ra;ja=sa;continue}}Y5b(e,h,0,la,h);na=la+1|0;oa=b[R>>0]|0;Y5b(i,h,na,(oa<<24>>24<0?f[S>>2]|0:oa&255)-na|0,h);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;na=b[U>>0]|0;oa=f[V>>2]|0;if((na<<24>>24<0?oa:na&255)|0){Aa=0;za=na;na=oa;while(1){oa=b[(za<<24>>24<0?f[e>>2]|0:e)+Aa>>0]|0;if((oa+-33&255)<90){l6b(j,oa);Qa=b[U>>0]|0;Ra=f[V>>2]|0}else{Qa=za;Ra=na}Aa=Aa+1|0;if(Aa>>>0>=(Qa<<24>>24<0?Ra:Qa&255)>>>0)break;else{za=Qa;na=Ra}}}_5b(e,j)|0;if((b[W>>0]|0)<0)O5b(f[j>>2]|0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;na=b[X>>0]|0;za=f[Z>>2]|0;if((na<<24>>24<0?za:na&255)|0){Aa=0;la=na;na=za;while(1){za=b[(la<<24>>24<0?f[i>>2]|0:i)+Aa>>0]|0;if((za+-33&255)<90){l6b(j,za);Sa=b[X>>0]|0;Ta=f[Z>>2]|0}else{Sa=la;Ta=na}Aa=Aa+1|0;if(Aa>>>0>=(Sa<<24>>24<0?Ta:Sa&255)>>>0)break;else{la=Sa;na=Ta}}}_5b(i,j)|0;if((b[_>>0]|0)<0)O5b(f[j>>2]|0);na=b[U>>0]|0;la=b[X>>0]|0;Aa=la<<24>>24<0;if(!((na<<24>>24<0?f[V>>2]|0:na&255)|0)){if(Aa){O5b(f[i>>2]|0);Ua=b[U>>0]|0}else Ua=na;if(Ua<<24>>24<0)O5b(f[e>>2]|0);ra=ka;sa=ja;ka=ra;ja=sa;continue}if(!((Aa?f[Z>>2]|0:la&255)|0)){if(Aa){O5b(f[i>>2]|0);Va=b[U>>0]|0}else Va=na;if(Va<<24>>24<0)O5b(f[e>>2]|0);ra=ka;sa=ja;ka=ra;ja=sa;continue}if(ja)_5b(sab($,e)|0,i)|0;else{na=f[ba>>2]|0;do if(na){Aa=ca;la=na;za=na;while(1){oa=f[la+16>>2]|0;if((ka|0)<(oa|0)){Ba=f[la>>2]|0;if(!Ba){Fa=80;break}else{Wa=la;Xa=Ba}}else{if((oa|0)>=(ka|0)){Fa=84;break}Ya=la+4|0;oa=f[Ya>>2]|0;if(!oa){Fa=83;break}else{Wa=Ya;Xa=oa}}Aa=Wa;la=Xa;za=Xa}if((Fa|0)==80){Fa=0;Za=la;_a=la;Fa=86;break}else if((Fa|0)==83){Fa=0;Za=Ya;_a=la;Fa=86;break}else if((Fa|0)==84){Fa=0;$a=Aa;ab=la;bb=za;Fa=85;break}}else{$a=ba;ab=ba;bb=na;Fa=85}while(0);if((Fa|0)==85){Fa=0;if(!bb){Za=$a;_a=ab;Fa=86}else cb=bb}if((Fa|0)==86){Fa=0;na=L5b(32)|0;f[na+16>>2]=ka;ma=na+24|0;f[ma>>2]=0;f[na+28>>2]=0;f[na+20>>2]=ma;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=_a;f[Za>>2]=na;ma=f[f[aa>>2]>>2]|0;if(!ma)db=na;else{f[aa>>2]=ma;db=f[Za>>2]|0}mP(f[ca>>2]|0,db);f[da>>2]=(f[da>>2]|0)+1;cb=na}_5b(sab(cb+20|0,e)|0,i)|0}if((b[X>>0]|0)<0)O5b(f[i>>2]|0);if((b[U>>0]|0)<0)O5b(f[e>>2]|0);ra=ka;sa=ja;ka=ra;ja=sa}if((b[R>>0]|0)<0)O5b(f[h>>2]|0);R=(f[da>>2]|0)+-1|0;sa=f[ba>>2]|0;do if(sa){ja=ca;ra=sa;ka=sa;while(1){U=f[ra+16>>2]|0;if((R|0)<(U|0)){X=f[ra>>2]|0;if(!X){Fa=14;break}else{eb=ra;fb=X}}else{if((U|0)>=(R|0)){Fa=18;break}gb=ra+4|0;U=f[gb>>2]|0;if(!U){Fa=17;break}else{eb=gb;fb=U}}ja=eb;ra=fb;ka=fb}if((Fa|0)==14){hb=ra;ib=ra;Fa=20;break}else if((Fa|0)==17){hb=gb;ib=ra;Fa=20;break}else if((Fa|0)==18){jb=ja;kb=ra;lb=ka;Fa=19;break}}else{jb=ba;kb=ba;lb=sa;Fa=19}while(0);if((Fa|0)==19)if(!lb){hb=jb;ib=kb;Fa=20}else mb=lb;if((Fa|0)==20){lb=L5b(32)|0;f[lb+16>>2]=R;R=lb+24|0;f[R>>2]=0;f[lb+28>>2]=0;f[lb+20>>2]=R;f[lb>>2]=0;f[lb+4>>2]=0;f[lb+8>>2]=ib;f[hb>>2]=lb;ib=f[f[aa>>2]>>2]|0;if(!ib)nb=lb;else{f[aa>>2]=ib;nb=f[hb>>2]|0}mP(f[ca>>2]|0,nb);f[da>>2]=(f[da>>2]|0)+1;mb=lb}f[h+8>>2]=0;lb=h+11|0;b[lb>>0]=7;b[h>>0]=b[430313]|0;b[h+1>>0]=b[430314]|0;b[h+2>>0]=b[430315]|0;b[h+3>>0]=b[430316]|0;b[h+4>>0]=b[430317]|0;b[h+5>>0]=b[430318]|0;b[h+6>>0]=b[430319]|0;b[h+7>>0]=0;X5b(e,sab(mb+20|0,h)|0);if((b[lb>>0]|0)<0)O5b(f[h>>2]|0);tab(h,e);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;lb=k+11|0;b[lb>>0]=5;b[k>>0]=b[434730]|0;b[k+1>>0]=b[434731]|0;b[k+2>>0]=b[434732]|0;b[k+3>>0]=b[434733]|0;b[k+4>>0]=b[434734]|0;b[k+5>>0]=0;mb=uab($,k,416)|0;f[c>>2]=mb;if((b[lb>>0]|0)<0)O5b(f[k>>2]|0);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;k=l+11|0;b[k>>0]=6;b[l>>0]=b[434884]|0;b[l+1>>0]=b[434885]|0;b[l+2>>0]=b[434886]|0;b[l+3>>0]=b[434887]|0;b[l+4>>0]=b[434888]|0;b[l+5>>0]=b[434889]|0;b[l+6>>0]=0;lb=uab($,l,416)|0;mb=c+4|0;f[mb>>2]=lb;if((b[k>>0]|0)<0)O5b(f[l>>2]|0);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;l=m+11|0;b[l>>0]=8;k=m;f[k>>2]=1851877475;f[k+4>>2]=1936483694;b[m+8>>0]=0;k=uab($,m,3)|0;$=c+8|0;f[$>>2]=k;if((b[l>>0]|0)<0)O5b(f[m>>2]|0);if(!(((f[c>>2]|0)>0?(f[mb>>2]|0)>0:0)?(f[$>>2]|0)>0:0)){f[i>>2]=0;f[i+4>>2]=0;Ca=aD(i,54)|0;Da=411302;Ea=Ca+54|0;do{b[Ca>>0]=b[Da>>0]|0;Ca=Ca+1|0;Da=Da+1|0}while((Ca|0)<(Ea|0));bO(-215,i,411170,411193,409);bD(i)}mb=f[h>>2]|0;if(mb|0){m=h+4|0;l=f[m>>2]|0;if((l|0)!=(mb|0))f[m>>2]=l+(~((l+-4-mb|0)>>>2)<<2);O5b(mb)}if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);mb=f[$>>2]|0;$=c+24|0;l=f[da>>2]|0;da=c+28|0;m=f[da>>2]|0;k=f[$>>2]|0;lb=m-k>>2;nb=k;k=m;if(l>>>0<=lb>>>0){if(l>>>0<lb>>>0?(m=nb+(l<<2)|0,(k|0)!=(m|0)):0)f[da>>2]=k+(~((k+-4-m|0)>>>2)<<2)}else HC($,l-lb|0);f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;lb=n+11|0;b[lb>>0]=4;f[n>>2]=1635017060;b[n+4>>0]=0;f[e>>2]=c;f[e+4>>2]=0;c=e+8|0;X5b(c,n);f[e+20>>2]=0;l=e+24|0;f[l>>2]=0;f[e+28>>2]=0;if((b[lb>>0]|0)<0)O5b(f[n>>2]|0);n=f[aa>>2]|0;if((n|0)!=(ba|0)){aa=i+11|0;lb=i+4|0;m=h+11|0;k=h+4|0;da=o+11|0;nb=o+4|0;ca=p+11|0;hb=p+3|0;ib=q+11|0;R=q+6|0;kb=r+11|0;jb=r+7|0;sa=s+11|0;gb=s+10|0;fb=t+11|0;eb=t+6|0;U=v+8|0;X=v+4|0;cb=v+11|0;db=i+11|0;Za=i+4|0;_a=x+11|0;bb=x+7|0;ab=j+4|0;$a=j+4|0;Ya=j+4|0;Xa=j+4|0;Wa=w+11|0;Va=w+4|0;Z=y+11|0;Ua=y+4|0;V=z+11|0;_=z+6|0;Ta=A+11|0;Sa=A+3|0;W=B+11|0;Ra=B+6|0;Qa=C+11|0;S=i+11|0;ea=i+4|0;ha=j+4|0;fa=j+4|0;Oa=D+11|0;ga=D+6|0;Pa=E+11|0;Ja=E+6|0;Ka=F+11|0;Na=F+6|0;Ma=G+11|0;La=G+7|0;Ia=H+11|0;Ha=H+3|0;Ga=I+11|0;ia=I+8|0;ya=J+11|0;ua=J+7|0;wa=L+11|0;va=L+4|0;a=M+11|0;qa=K+11|0;pa=K+4|0;na=N+11|0;ma=N+7|0;ta=O+11|0;xa=i+11|0;oa=i+4|0;Ba=j+4|0;ob=j+4|0;pb=w+4|0;qb=i+4|0;rb=j+11|0;sb=j+4|0;tb=p+4|0;ub=r+8|0;vb=x+8|0;wb=A+4|0;xb=G+8|0;yb=H+4|0;zb=J+8|0;Ab=N+8|0;Bb=mb;mb=-1;Cb=n;while(1){mb=mb+1|0;n=Cb+20|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[aa>>0]=4;f[i>>2]=1701869940;b[lb>>0]=0;X5b(h,sab(n,i)|0);if((b[aa>>0]|0)<0)O5b(f[i>>2]|0);Db=b[m>>0]|0;Eb=f[k>>2]|0;do if(((Db<<24>>24<0?Eb:Db&255)|0)==13){if(u6b(h,0,-1,411357,13)|0){Fb=b[m>>0]|0;Gb=f[k>>2]|0;Fa=183;break};f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;b[da>>0]=4;f[o>>2]=1702521203;b[nb>>0]=0;Hb=uab(n,o,-1)|0;if((b[da>>0]|0)<0)O5b(f[o>>2]|0);Ib=tb;f[Ib>>2]=0;f[Ib+4>>2]=0;b[ca>>0]=3;b[p>>0]=b[418063]|0;b[p+1>>0]=b[418064]|0;b[p+2>>0]=b[418065]|0;b[hb>>0]=0;Ib=uab(n,p,0)|0;if((b[ca>>0]|0)<0)O5b(f[p>>2]|0);f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;b[ib>>0]=6;b[q>>0]=b[418067]|0;b[q+1>>0]=b[418068]|0;b[q+2>>0]=b[418069]|0;b[q+3>>0]=b[418070]|0;b[q+4>>0]=b[418071]|0;b[q+5>>0]=b[418072]|0;b[R>>0]=0;Jb=uab(n,q,1)|0;if((b[ib>>0]|0)<0)O5b(f[q>>2]|0);f[ub>>2]=0;b[kb>>0]=7;b[r>>0]=b[411371]|0;b[r+1>>0]=b[411372]|0;b[r+2>>0]=b[411373]|0;b[r+3>>0]=b[411374]|0;b[r+4>>0]=b[411375]|0;b[r+5>>0]=b[411376]|0;b[r+6>>0]=b[411377]|0;b[jb>>0]=0;Kb=uab(n,r,-1)|0;if((b[kb>>0]|0)<0)O5b(f[r>>2]|0);b[sa>>0]=10;Ca=s;Da=411379;Ea=Ca+10|0;do{b[Ca>>0]=b[Da>>0]|0;Ca=Ca+1|0;Da=Da+1|0}while((Ca|0)<(Ea|0));b[gb>>0]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;b[fb>>0]=6;b[t>>0]=b[411390]|0;b[t+1>>0]=b[411391]|0;b[t+2>>0]=b[411392]|0;b[t+3>>0]=b[411393]|0;b[t+4>>0]=b[411394]|0;b[t+5>>0]=b[411395]|0;b[eb>>0]=0;vab(i,n,s,t);if((b[fb>>0]|0)<0)O5b(f[t>>2]|0);if((b[sa>>0]|0)<0)O5b(f[s>>2]|0);f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;za=L5b(16)|0;f[v>>2]=za;f[U>>2]=-2147483632;f[X>>2]=15;Ca=za;Da=411397;Ea=Ca+15|0;do{b[Ca>>0]=b[Da>>0]|0;Ca=Ca+1|0;Da=Da+1|0}while((Ca|0)<(Ea|0));b[za+15>>0]=0;la=(uab(n,v,0)|0)==1;if((b[cb>>0]|0)<0)O5b(f[v>>2]|0);Aa=b[db>>0]|0;Lb=f[Za>>2]|0;do if(((Aa<<24>>24<0?Lb:Aa&255)|0)==6){if(!(u6b(i,0,-1,411390,6)|0))break;Mb=b[db>>0]|0;Nb=f[Za>>2]|0;Fa=163}else{Mb=Aa;Nb=Lb;Fa=163}while(0);do if((Fa|0)==163){Fa=0;if(((Mb<<24>>24<0?Nb:Mb&255)|0)==5?(u6b(i,0,-1,411413,5)|0)==0:0)break;dua(w,411419,i);f[j>>2]=0;f[Xa>>2]=0;Lb=b[Wa>>0]|0;Aa=Lb<<24>>24<0?f[Va>>2]|0:Lb&255;if(Aa|0){Lb=aD(j,Aa)|0;Vac(Lb|0,((b[Wa>>0]|0)<0?f[w>>2]|0:w)|0,Aa|0)|0}bO(-212,j,411170,411193,436);bD(j);if((b[Wa>>0]|0)<0)O5b(f[w>>2]|0)}while(0);f[vb>>2]=0;b[_a>>0]=7;b[x>>0]=b[411444]|0;b[x+1>>0]=b[411445]|0;b[x+2>>0]=b[411446]|0;b[x+3>>0]=b[411447]|0;b[x+4>>0]=b[411448]|0;b[x+5>>0]=b[411449]|0;b[x+6>>0]=b[411450]|0;b[bb>>0]=0;Aa=uab(n,x,0)|0;if((b[_a>>0]|0)<0)O5b(f[x>>2]|0);if((Aa|0)==1){f[j>>2]=0;f[ab>>2]=0;Ca=aD(j,54)|0;Da=411452;Ea=Ca+54|0;do{b[Ca>>0]=b[Da>>0]|0;Ca=Ca+1|0;Da=Da+1|0}while((Ca|0)<(Ea|0));bO(-213,j,411170,411193,439);bD(j)}Aa=(Hb|0)<3?0:Ib;if(!((Hb|0)>0&(Kb|0)>0)){f[j>>2]=0;f[Ya>>2]=0;Ca=aD(j,30)|0;Da=411507;Ea=Ca+30|0;do{b[Ca>>0]=b[Da>>0]|0;Ca=Ca+1|0;Da=Da+1|0}while((Ca|0)<(Ea|0));bO(-215,j,411170,411193,444);bD(j)}if((Bb|0)<=0){f[j>>2]=0;f[$a>>2]=0;Ca=aD(j,20)|0;Da=411538;Ea=Ca+20|0;do{b[Ca>>0]=b[Da>>0]|0;Ca=Ca+1|0;Da=Da+1|0}while((Ca|0)<(Ea|0));bO(-215,j,411170,411193,445);bD(j)}Ib=b[db>>0]|0;if(((Ib<<24>>24<0?f[Za>>2]|0:Ib&255)|0)==5)Ob=(u6b(i,0,-1,411413,5)|0)==0;else Ob=0;wab(e,Hb,Aa,Jb,Kb,Bb,la&1,Ob&1);if((b[db>>0]|0)<0)O5b(f[i>>2]|0);Pb=Kb}else{Fb=Db;Gb=Eb;Fa=183}while(0);c:do if((Fa|0)==183){Fa=0;do if(((Fb<<24>>24<0?Gb:Fb&255)|0)==7){if(u6b(h,0,-1,411559,7)|0){Qb=b[m>>0]|0;Rb=f[k>>2]|0;break};f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;b[Z>>0]=4;f[y>>2]=1702521203;b[Ua>>0]=0;Eb=uab(n,y,2)|0;if((b[Z>>0]|0)<0)O5b(f[y>>2]|0);f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;b[V>>0]=6;b[z>>0]=b[418067]|0;b[z+1>>0]=b[418068]|0;b[z+2>>0]=b[418069]|0;b[z+3>>0]=b[418070]|0;b[z+4>>0]=b[418071]|0;b[z+5>>0]=b[418072]|0;b[_>>0]=0;Db=uab(n,z,2)|0;if((b[V>>0]|0)<0)O5b(f[z>>2]|0);ka=wb;f[ka>>2]=0;f[ka+4>>2]=0;b[Ta>>0]=3;b[A>>0]=b[418063]|0;b[A+1>>0]=b[418064]|0;b[A+2>>0]=b[418065]|0;b[Sa>>0]=0;ka=uab(n,A,0)|0;if((b[Ta>>0]|0)<0)O5b(f[A>>2]|0);xab(e,Eb,ka,Db);Pb=Bb;break c}else{Qb=Fb;Rb=Gb}while(0);do if(((Qb<<24>>24<0?Rb:Qb&255)|0)==5){if(u6b(h,0,-1,411567,5)|0){Sb=b[m>>0]|0;Tb=f[k>>2]|0;break};f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;b[W>>0]=6;b[B>>0]=b[411573]|0;b[B+1>>0]=b[411574]|0;b[B+2>>0]=b[411575]|0;b[B+3>>0]=b[411576]|0;b[B+4>>0]=b[411577]|0;b[B+5>>0]=b[411578]|0;b[Ra>>0]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;vab(i,n,B,C);if((b[Qa>>0]|0)<0)O5b(f[C>>2]|0);if((b[W>>0]|0)<0)O5b(f[B>>2]|0);Kb=b[S>>0]|0;if(!((Kb<<24>>24<0?f[ea>>2]|0:Kb&255)|0)){f[j>>2]=0;f[ha>>2]=0;Ca=aD(j,22)|0;Da=411580;Ea=Ca+22|0;do{b[Ca>>0]=b[Da>>0]|0;Ca=Ca+1|0;Da=Da+1|0}while((Ca|0)<(Ea|0));bO(-215,j,411170,411193,462);bD(j)}yab(j,i);Kb=f[j>>2]|0;la=(f[fa>>2]|0)-Kb>>2;Jb=Kb;do if(!la){Ub=0;Vb=0;Fa=207}else{Kb=f[$>>2]|0;Aa=0;Hb=0;do{Db=Jb+(Aa<<2)|0;ka=(f[Db>>2]|0)+mb|0;f[Db>>2]=ka;Hb=(f[Kb+(ka<<2)>>2]|0)+Hb|0;Aa=Aa+1|0}while(Aa>>>0<la>>>0);if((la|0)!=1){Ub=Hb;Vb=la;Fa=207;break}zab(e,f[Jb>>2]|0);Wb=Hb}while(0);if((Fa|0)==207){Fa=0;Aab(e,Vb,Jb);Wb=Ub}la=f[j>>2]|0;if(la|0){Aa=f[fa>>2]|0;if((Aa|0)!=(la|0))f[fa>>2]=Aa+(~((Aa+-4-la|0)>>>2)<<2);O5b(la)}if((b[S>>0]|0)<0)O5b(f[i>>2]|0);Pb=Wb;break c}else{Sb=Qb;Tb=Rb}while(0);do if(((Sb<<24>>24<0?Tb:Sb&255)|0)==5){if(u6b(h,0,-1,411603,5)|0){Xb=b[m>>0]|0;Yb=f[k>>2]|0;break};f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;b[Oa>>0]=6;b[D>>0]=b[418067]|0;b[D+1>>0]=b[418068]|0;b[D+2>>0]=b[418069]|0;b[D+3>>0]=b[418070]|0;b[D+4>>0]=b[418071]|0;b[D+5>>0]=b[418072]|0;b[ga>>0]=0;la=uab(n,D,2)|0;if((b[Oa>>0]|0)<0)O5b(f[D>>2]|0);Bab(e,la);Pb=Y(Y(la,Bb)|0,la)|0;break c}else{Xb=Sb;Yb=Tb}while(0);do if(((Xb<<24>>24<0?Yb:Xb&255)|0)==6){if(u6b(h,0,-1,411609,6)|0)break;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;b[Pa>>0]=6;b[E>>0]=b[430291]|0;b[E+1>>0]=b[430292]|0;b[E+2>>0]=b[430293]|0;b[E+3>>0]=b[430294]|0;b[E+4>>0]=b[430295]|0;b[E+5>>0]=b[430296]|0;b[Ja>>0]=0;Zb=+Cab(n,E,1.0000000474974513e-03);if((b[Pa>>0]|0)<0)O5b(f[E>>2]|0);f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;b[Ka>>0]=6;b[F>>0]=b[430298]|0;b[F+1>>0]=b[430299]|0;b[F+2>>0]=b[430300]|0;b[F+3>>0]=b[430301]|0;b[F+4>>0]=b[430302]|0;b[F+5>>0]=b[430303]|0;b[Na>>0]=0;la=uab(n,F,4)|0;if((b[Ka>>0]|0)<0)O5b(f[F>>2]|0);f[xb>>2]=0;b[Ma>>0]=7;b[G>>0]=b[430305]|0;b[G+1>>0]=b[430306]|0;b[G+2>>0]=b[430307]|0;b[G+3>>0]=b[430308]|0;b[G+4>>0]=b[430309]|0;b[G+5>>0]=b[430310]|0;b[G+6>>0]=b[430311]|0;b[La>>0]=0;Aa=uab(n,G,-1)|0;if((b[Ma>>0]|0)<0)O5b(f[G>>2]|0);Kb=yb;f[Kb>>2]=0;f[Kb+4>>2]=0;b[Ia>>0]=3;b[H>>0]=b[411616]|0;b[H+1>>0]=b[411617]|0;b[H+2>>0]=b[411618]|0;b[Ha>>0]=0;Kb=uab(n,H,-1)|0;if((b[Ia>>0]|0)<0)O5b(f[H>>2]|0);f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;b[Ga>>0]=8;ka=I;f[ka>>2]=1935764579;f[ka+4>>2]=2020173427;b[ia>>0]=0;ka=uab(n,I,0)|0;if((b[Ga>>0]|0)<0)O5b(f[I>>2]|0);f[zb>>2]=0;b[ya>>0]=7;b[J>>0]=b[430334]|0;b[J+1>>0]=b[430335]|0;b[J+2>>0]=b[430336]|0;b[J+3>>0]=b[430337]|0;b[J+4>>0]=b[430338]|0;b[J+5>>0]=b[430339]|0;b[J+6>>0]=b[430340]|0;b[ua>>0]=0;Db=(uab(n,J,0)|0)==1;if((b[ya>>0]|0)<0)O5b(f[J>>2]|0);f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;b[wa>>0]=4;f[L>>2]=1701147252;b[va>>0]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;vab(K,n,L,M);Eb=b[qa>>0]|0;ra=Eb<<24>>24<0;ja=((ra?f[pa>>2]|0:Eb&255)|0)!=0;if(ra)O5b(f[K>>2]|0);if((b[a>>0]|0)<0)O5b(f[M>>2]|0);if((b[wa>>0]|0)<0)O5b(f[L>>2]|0);f[Ab>>2]=0;b[na>>0]=7;b[N>>0]=b[430313]|0;b[N+1>>0]=b[430314]|0;b[N+2>>0]=b[430315]|0;b[N+3>>0]=b[430316]|0;b[N+4>>0]=b[430317]|0;b[N+5>>0]=b[430318]|0;b[N+6>>0]=b[430319]|0;b[ma>>0]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;vab(i,n,N,O);if((b[ta>>0]|0)<0)O5b(f[O>>2]|0);if((b[na>>0]|0)<0)O5b(f[N>>2]|0);ra=b[xa>>0]|0;if(!((ra<<24>>24<0?f[oa>>2]|0:ra&255)|0)){f[j>>2]=0;f[Ba>>2]=0;Ca=aD(j,23)|0;Da=411620;Ea=Ca+23|0;do{b[Ca>>0]=b[Da>>0]|0;Ca=Ca+1|0;Da=Da+1|0}while((Ca|0)<(Ea|0));bO(-215,j,411170,411193,494);bD(j)}tab(j,i);if(!((Aa|0)>0&(Kb|0)>0?(Kb<<1|0)==((f[ob>>2]|0)-(f[j>>2]|0)>>2|0):0)){f[w>>2]=0;f[pb>>2]=0;Ca=aD(w,79)|0;Da=411644;Ea=Ca+79|0;do{b[Ca>>0]=b[Da>>0]|0;Ca=Ca+1|0;Da=Da+1|0}while((Ca|0)<(Ea|0));bO(-215,w,411170,411193,497);bD(w)}Dab(e);Eab(e,Zb,la,Aa,Kb,ka,Db&1,ja&1,f[j>>2]|0);Jb=f[j>>2]|0;if(Jb|0){ra=f[ob>>2]|0;if((ra|0)!=(Jb|0))f[ob>>2]=ra+(~((ra+-4-Jb|0)>>>2)<<2);O5b(Jb)}if((b[xa>>0]|0)<0)O5b(f[i>>2]|0);Pb=Bb;break c}while(0);dua(j,411724,h);f[i>>2]=0;f[qb>>2]=0;Jb=b[rb>>0]|0;ra=Jb<<24>>24<0?f[sb>>2]|0:Jb&255;if(ra|0){Jb=aD(i,ra)|0;Vac(Jb|0,((b[rb>>0]|0)<0?f[j>>2]|0:j)|0,ra|0)|0}bO(-212,i,411170,411193,503);bD(i);if((b[rb>>0]|0)<0)O5b(f[j>>2]|0);Pb=Bb}while(0);f[(f[$>>2]|0)+(mb<<2)>>2]=Pb;if((b[m>>0]|0)<0)O5b(f[h>>2]|0);n=f[Cb+4>>2]|0;do if(!n){ra=Cb+8|0;Jb=f[ra>>2]|0;if((f[Jb>>2]|0)==(Cb|0)){_b=Jb;break}else $b=ra;do{ra=f[$b>>2]|0;$b=ra+8|0;Jb=f[$b>>2]|0}while((f[Jb>>2]|0)!=(ra|0));_b=Jb}else{Jb=n;while(1){ra=f[Jb>>2]|0;if(!ra)break;else Jb=ra}_b=Jb}while(0);if((_b|0)==(ba|0))break;else{Bb=Pb;Cb=_b}}}_b=e+20|0;e=f[_b>>2]|0;if(e|0){Cb=f[l>>2]|0;if((Cb|0)==(e|0))ac=e;else{Pb=Cb;while(1){Cb=Pb+-12|0;f[l>>2]=Cb;if((b[Cb+11>>0]|0)<0){O5b(f[Cb>>2]|0);bc=f[l>>2]|0}else bc=Cb;if((bc|0)==(e|0))break;else Pb=bc}ac=f[_b>>2]|0}O5b(ac)}if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);T=1;f[g>>2]=106336;f[P>>2]=106356;Uza(Q);rXb(g,106368);AWb(P);u=d;return T|0}function qab(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;YXb(g,a,1);if(!(b[g>>0]|0)){u=e;return a|0}g=c+11|0;if((b[g>>0]|0)<0){b[f[c>>2]>>0]=0;i=c+4|0;f[i>>2]=0;j=i}else{b[c>>0]=0;b[g>>0]=0;j=c+4|0}i=0;while(1){k=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;l=k+12|0;m=f[l>>2]|0;if((m|0)==(f[k+16>>2]|0)){n=di[f[(f[k>>2]|0)+40>>2]&1023](k)|0;if((n|0)==-1){o=i;p=2;break}else q=n}else{f[l>>2]=m+1;q=h[m>>0]|0}m=i+1|0;l=q&255;if(l<<24>>24==d<<24>>24){o=m;p=0;break}l6b(c,l);if((b[g>>0]|0)<0&(f[j>>2]|0)==-17){o=m;p=4;break}else i=m}i=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(i,f[i+16>>2]|((o|0)==0?p|4:p));u=e;return a|0}function rab(a){a=a|0;return}function sab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=Jab(a,d,b)|0;g=f[e>>2]|0;if(g|0){h=g;i=h+28|0;u=c;return i|0}g=L5b(40)|0;X5b(g+16|0,b);b=g+28|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=b;f[e>>2]=g;b=f[f[a>>2]>>2]|0;if(!b)j=g;else{f[a>>2]=b;j=f[e>>2]|0}mP(f[a+4>>2]|0,j);j=a+8|0;f[j>>2]=(f[j>>2]|0)+1;h=g;i=h+28|0;u=c;return i|0}function tab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+320|0;e=d+168|0;g=d+152|0;h=d+8|0;i=d;f[a>>2]=0;j=a+4|0;f[j>>2]=0;f[a+8>>2]=0;k=e+64|0;l=e+8|0;f[l>>2]=106096;m=e+12|0;f[e>>2]=18124;f[k>>2]=18144;f[e+4>>2]=0;RXb(e+64|0,m);f[e+136>>2]=0;f[e+140>>2]=-1;f[e>>2]=106076;f[k>>2]=106116;f[l>>2]=106096;WXb(m);f[m>>2]=43284;l=e+44|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[e+60>>2]=24;qP(m,c);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=h+64|0;m=h+8|0;l=h+12|0;k=h+4|0;n=h+64|0;o=h+136|0;p=h+140|0;q=h+44|0;r=h+60|0;s=a+8|0;while(1){t=qab(e,g,44)|0;v=(f[t+(f[(f[t>>2]|0)+-12>>2]|0)+16>>2]&5|0)!=0;if(!((v?0:0)&1|(v?0:1507)))break;f[m>>2]=106096;f[h>>2]=18124;f[c>>2]=18144;f[k>>2]=0;RXb(n,l);f[o>>2]=0;f[p>>2]=-1;f[h>>2]=106076;f[c>>2]=106116;f[m>>2]=106096;WXb(l);f[l>>2]=43284;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[r>>2]=24;qP(l,g);cYb(h,i)|0;v=f[j>>2]|0;if((v|0)==(f[s>>2]|0))upa(a,i);else{f[v>>2]=f[i>>2];f[j>>2]=v+4}kya(h)}if((b[g+11>>0]|0)>=0){kya(e);u=d;return}O5b(f[g>>2]|0);kya(e);u=d;return}function uab(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+160|0;e=d;g=d+8|0;f[e>>2]=c;h=Hab(a,b)|0;if((h|0)==(a+4|0)){i=c;u=d;return i|0}c=g+64|0;a=g+8|0;f[a>>2]=106096;b=g+12|0;f[g>>2]=18124;f[c>>2]=18144;f[g+4>>2]=0;RXb(g+64|0,b);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=106076;f[c>>2]=106116;f[a>>2]=106096;WXb(b);f[b>>2]=43284;a=g+44|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[g+60>>2]=24;qP(b,h+28|0);aYb(g,e)|0;kya(g);i=f[e>>2]|0;u=d;return i|0}function vab(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+144|0;g=e;h=Hab(b,c)|0;if((h|0)==(b+4|0)){X5b(a,d);u=e;return}b=g+64|0;c=g+8|0;f[c>>2]=106096;i=g+12|0;f[g>>2]=18124;f[b>>2]=18144;f[g+4>>2]=0;RXb(g+64|0,i);f[g+136>>2]=0;f[g+140>>2]=-1;f[g>>2]=106076;f[b>>2]=106116;f[c>>2]=106096;WXb(i);f[i>>2]=43284;c=g+44|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[g+60>>2]=24;qP(i,h+28|0);MU(g,d)|0;kya(g);X5b(a,d);u=e;return}function wab(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;h=u;u=u+320|0;k=h+56|0;l=h+40|0;m=h;o=h+272|0;p=h+196|0;q=h+184|0;r=h+176|0;s=h+96|0;t=h+68|0;v=h+88|0;w=h+80|0;Iab(o,a,c,d,e,g);f[p+40>>2]=0;f[p+44>>2]=0;g=p+40|0;e=p+36|0;d=p;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[e>>2]=g;g=p+48|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;g=a+4|0;f[m>>2]=f[g>>2];hO(r,411920,m);e=f[r>>2]|0;x=f[r+4>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;if(x>>>0>4294967279)V5b(q);if(x>>>0<11){b[q+11>>0]=x;if(!x)y=q;else{z=q;A=6}}else{B=x+16&-16;C=L5b(B)|0;f[q>>2]=C;f[q+8>>2]=B|-2147483648;f[q+4>>2]=x;z=C;A=6}if((A|0)==6){Vac(z|0,e|0,x|0)|0;y=z}b[y+x>>0]=0;bD(r);r=(i|0)!=0;if(!r){f[m>>2]=0;f[m+4>>2]=0;d=aD(m,9)|0;D=434144;c=d+9|0;do{b[d>>0]=b[D>>0]|0;d=d+1|0;D=D+1|0}while((d|0)<(c|0));b[s>>0]=1;$wa(o,m,s)|0;bD(m)}_5b(p,q)|0;i=o+32|0;x=f[i>>2]|0;y=o+36|0;z=f[y>>2]|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;if(z>>>0>4294967279)V5b(m);if(z>>>0<11){b[m+11>>0]=z;if(!z)E=m;else{F=m;A=14}}else{e=z+16&-16;C=L5b(e)|0;f[m>>2]=C;f[m+8>>2]=e|-2147483648;f[m+4>>2]=z;F=C;A=14}if((A|0)==14){Vac(F|0,x|0,z|0)|0;E=F}b[E+z>>0]=0;_5b(p+12|0,m)|0;if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);Fab(p+36|0,o)|0;cwa(p+48|0,f[o+12>>2]|0,f[o+16>>2]|0);z=p+60|0;E=o+24|0;bD(z);F=f[E>>2]|0;if(!F)G=0;else{x=F+-4|0;f[x>>2]=(f[x>>2]|0)+1;G=f[E>>2]|0}f[z>>2]=G;f[p+64>>2]=f[o+28>>2];G=p+68|0;bD(G);z=f[i>>2]|0;if(!z)H=0;else{E=z+-4|0;f[E>>2]=(f[E>>2]|0)+1;H=f[i>>2]|0}f[G>>2]=H;f[p+72>>2]=f[y>>2];y=a+8|0;H=p+28|0;G=f[H>>2]|0;if((G|0)==(f[p+32>>2]|0))JT(p+24|0,y);else{X5b(G,y);f[H>>2]=(f[H>>2]|0)+12}_5b(y,q)|0;H=f[a>>2]|0;G=H+16|0;i=f[G>>2]|0;if((i|0)==(f[H+20>>2]|0))Gab(H+12|0,p);else{_ta(i,p);f[G>>2]=(f[G>>2]|0)+76}if(r){f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=m+4;r=m+12|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;G=m+24|0;bD(G);d=aD(G,14)|0;D=411928;c=d+14|0;do{b[d>>0]=b[D>>0]|0;d=d+1|0;D=D+1|0}while((d|0)<(c|0));i=m+32|0;bD(i);d=aD(i,9)|0;D=411943;c=d+9|0;do{b[d>>0]=b[D>>0]|0;d=d+1|0;D=D+1|0}while((d|0)<(c|0));f[s>>2]=0;f[s+4>>2]=0;d=aD(s,10)|0;D=422223;c=d+10|0;do{b[d>>0]=b[D>>0]|0;d=d+1|0;D=D+1|0}while((d|0)<(c|0));b[t>>0]=1;$wa(m,s,t)|0;bD(s);f[s>>2]=0;f[s+4>>2]=0;H=aD(s,8)|0;E=H;b[E>>0]=104;b[E+1>>0]=97;b[E+2>>0]=115;b[E+3>>0]=95;E=H+4|0;b[E>>0]=98;b[E+1>>0]=105;b[E+2>>0]=97;b[E+3>>0]=115;b[t>>0]=1;$wa(m,s,t)|0;bD(s);f[s>>2]=0;f[s+4>>2]=0;E=aD(s,3)|0;b[E>>0]=b[433709]|0;b[E+1>>0]=b[433710]|0;b[E+2>>0]=b[433711]|0;n[t>>2]=9.999999974752427e-07;Zwa(m,s,t)|0;bD(s);f[s+40>>2]=0;f[s+44>>2]=0;E=s+40|0;H=s+36|0;d=s;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[H>>2]=E;E=s+48|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[E+16>>2]=0;f[E+20>>2]=0;f[E+24>>2]=0;f[l>>2]=f[g>>2];hO(v,411953,l);E=f[v>>2]|0;H=f[v+4>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;if(H>>>0>4294967279)V5b(t);if(H>>>0<11){b[t+11>>0]=H;if(!H)I=t;else{J=t;A=33}}else{z=H+16&-16;x=L5b(z)|0;f[t>>2]=x;f[t+8>>2]=z|-2147483648;f[t+4>>2]=H;J=x;A=33}if((A|0)==33){Vac(J|0,E|0,H|0)|0;I=J}b[I+H>>0]=0;bD(v);_5b(s,t)|0;v=f[i>>2]|0;H=m+36|0;I=f[H>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;if(I>>>0>4294967279)V5b(l);if(I>>>0<11){b[l+11>>0]=I;if(!I)K=l;else{L=l;A=39}}else{J=I+16&-16;E=L5b(J)|0;f[l>>2]=E;f[l+8>>2]=J|-2147483648;f[l+4>>2]=I;L=E;A=39}if((A|0)==39){Vac(L|0,v|0,I|0)|0;K=L}b[K+I>>0]=0;_5b(s+12|0,l)|0;if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);Fab(s+36|0,m)|0;cwa(s+48|0,f[r>>2]|0,f[m+16>>2]|0);r=s+60|0;bD(r);l=f[G>>2]|0;if(!l)M=0;else{I=l+-4|0;f[I>>2]=(f[I>>2]|0)+1;M=f[G>>2]|0}f[r>>2]=M;f[s+64>>2]=f[m+28>>2];M=s+68|0;bD(M);r=f[i>>2]|0;if(!r)N=0;else{G=r+-4|0;f[G>>2]=(f[G>>2]|0)+1;N=f[i>>2]|0}f[M>>2]=N;f[s+72>>2]=f[H>>2];H=s+28|0;N=f[H>>2]|0;if((N|0)==(f[s+32>>2]|0))JT(s+24|0,y);else{X5b(N,y);f[H>>2]=(f[H>>2]|0)+12}_5b(y,t)|0;H=f[a>>2]|0;N=H+16|0;M=f[N>>2]|0;if((M|0)==(f[H+20>>2]|0))Gab(H+12|0,s);else{_ta(M,s);f[N>>2]=(f[N>>2]|0)+76}if((b[t+11>>0]|0)<0)O5b(f[t>>2]|0);Zta(s);fua(m)}if(j|0){f[m+4>>2]=0;f[m+8>>2]=0;f[m>>2]=m+4;j=m+12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[s>>2]=0;f[s+4>>2]=0;d=aD(s,14)|0;D=435388;c=d+14|0;do{b[d>>0]=b[D>>0]|0;d=d+1|0;D=D+1|0}while((d|0)<(c|0));n[t>>2]=.10000000149011612;Zwa(m,s,t)|0;bD(s);N=m+24|0;bD(N);d=aD(N,9)|0;D=411959;c=d+9|0;do{b[d>>0]=b[D>>0]|0;d=d+1|0;D=D+1|0}while((d|0)<(c|0));D=m+32|0;bD(D);M=aD(D,4)|0;b[M>>0]=82;b[M+1>>0]=101;b[M+2>>0]=76;b[M+3>>0]=85;f[s+40>>2]=0;f[s+44>>2]=0;M=s+40|0;H=s+36|0;d=s;c=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(c|0));f[H>>2]=M;M=s+48|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;f[M+16>>2]=0;f[M+20>>2]=0;f[M+24>>2]=0;f[k>>2]=f[g>>2];hO(w,411969,k);M=f[w>>2]|0;H=f[w+4>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;if(H>>>0>4294967279)V5b(t);if(H>>>0<11){b[t+11>>0]=H;if(!H)O=t;else{P=t;A=61}}else{d=H+16&-16;c=L5b(d)|0;f[t>>2]=c;f[t+8>>2]=d|-2147483648;f[t+4>>2]=H;P=c;A=61}if((A|0)==61){Vac(P|0,M|0,H|0)|0;O=P}b[O+H>>0]=0;bD(w);_5b(s,t)|0;w=f[D>>2]|0;H=m+36|0;O=f[H>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(O>>>0>4294967279)V5b(k);if(O>>>0<11){b[k+11>>0]=O;if(!O)Q=k;else{R=k;A=67}}else{P=O+16&-16;M=L5b(P)|0;f[k>>2]=M;f[k+8>>2]=P|-2147483648;f[k+4>>2]=O;R=M;A=67}if((A|0)==67){Vac(R|0,w|0,O|0)|0;Q=R}b[Q+O>>0]=0;_5b(s+12|0,k)|0;if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);Fab(s+36|0,m)|0;cwa(s+48|0,f[j>>2]|0,f[m+16>>2]|0);j=s+60|0;bD(j);k=f[N>>2]|0;if(!k)S=0;else{O=k+-4|0;f[O>>2]=(f[O>>2]|0)+1;S=f[N>>2]|0}f[j>>2]=S;f[s+64>>2]=f[m+28>>2];S=s+68|0;bD(S);j=f[D>>2]|0;if(!j)T=0;else{N=j+-4|0;f[N>>2]=(f[N>>2]|0)+1;T=f[D>>2]|0}f[S>>2]=T;f[s+72>>2]=f[H>>2];H=s+28|0;T=f[H>>2]|0;if((T|0)==(f[s+32>>2]|0))JT(s+24|0,y);else{X5b(T,y);f[H>>2]=(f[H>>2]|0)+12}_5b(y,t)|0;H=f[a>>2]|0;T=H+16|0;S=f[T>>2]|0;if((S|0)==(f[H+20>>2]|0))Gab(H+12|0,s);else{_ta(S,s);f[T>>2]=(f[T>>2]|0)+76}if((b[t+11>>0]|0)<0)O5b(f[t>>2]|0);Zta(s);fua(m)}f[g>>2]=(f[g>>2]|0)+1;g=a+24|0;m=f[g>>2]|0;if((m|0)==(f[a+28>>2]|0))JT(a+20|0,y);else{X5b(m,y);f[g>>2]=(f[g>>2]|0)+12}if((b[q+11>>0]|0)>=0){Zta(p);fua(o);u=h;return}O5b(f[q>>2]|0);Zta(p);fua(o);u=h;return}function xab(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+160|0;h=g;i=g+112|0;j=g+36|0;k=g+24|0;l=g+16|0;f[i+4>>2]=0;f[i+8>>2]=0;f[i>>2]=i+4;m=i+12|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[j>>2]=0;f[j+4>>2]=0;n=aD(j,4)|0;b[n>>0]=112;b[n+1>>0]=111;b[n+2>>0]=111;b[n+3>>0]=108;f[k>>2]=0;f[k+4>>2]=0;n=aD(k,3)|0;b[n>>0]=b[442370]|0;b[n+1>>0]=b[442371]|0;b[n+2>>0]=b[442372]|0;Nya(i,j,k)|0;bD(k);bD(j);f[j>>2]=0;f[j+4>>2]=0;n=aD(j,11)|0;o=442358;p=n+11|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));f[k>>2]=c;Wwa(i,j,k)|0;bD(j);f[j>>2]=0;f[j+4>>2]=0;c=aD(j,3)|0;b[c>>0]=b[418063]|0;b[c+1>>0]=b[418064]|0;b[c+2>>0]=b[418065]|0;f[k>>2]=d;Wwa(i,j,k)|0;bD(j);f[j>>2]=0;f[j+4>>2]=0;d=aD(j,6)|0;b[d>>0]=b[418067]|0;b[d+1>>0]=b[418068]|0;b[d+2>>0]=b[418069]|0;b[d+3>>0]=b[418070]|0;b[d+4>>0]=b[418071]|0;b[d+5>>0]=b[418072]|0;f[k>>2]=e;Wwa(i,j,k)|0;bD(j);f[j>>2]=0;f[j+4>>2]=0;e=aD(j,8)|0;d=e;b[d>>0]=112;b[d+1>>0]=97;b[d+2>>0]=100;b[d+3>>0]=95;d=e+4|0;b[d>>0]=109;b[d+1>>0]=111;b[d+2>>0]=100;b[d+3>>0]=101;f[k>>2]=0;f[k+4>>2]=0;d=aD(k,4)|0;b[d>>0]=83;b[d+1>>0]=65;b[d+2>>0]=77;b[d+3>>0]=69;Nya(i,j,k)|0;bD(k);bD(j);d=i+24|0;bD(d);n=aD(d,12)|0;o=411891;p=n+12|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));o=i+32|0;bD(o);e=aD(o,7)|0;b[e>>0]=b[411904]|0;b[e+1>>0]=b[411905]|0;b[e+2>>0]=b[411906]|0;b[e+3>>0]=b[411907]|0;b[e+4>>0]=b[411908]|0;b[e+5>>0]=b[411909]|0;b[e+6>>0]=b[411910]|0;f[j+40>>2]=0;f[j+44>>2]=0;e=j+40|0;c=j+36|0;n=j;p=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(p|0));f[c>>2]=e;e=j+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;e=a+4|0;f[h>>2]=f[e>>2];hO(l,411912,h);c=f[l>>2]|0;n=f[l+4>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(n>>>0>4294967279)V5b(k);if(n>>>0<11){b[k+11>>0]=n;if(!n)q=k;else{r=k;s=6}}else{p=n+16&-16;t=L5b(p)|0;f[k>>2]=t;f[k+8>>2]=p|-2147483648;f[k+4>>2]=n;r=t;s=6}if((s|0)==6){Vac(r|0,c|0,n|0)|0;q=r}b[q+n>>0]=0;bD(l);_5b(j,k)|0;l=f[o>>2]|0;n=i+36|0;q=f[n>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(q>>>0>4294967279)V5b(h);if(q>>>0<11){b[h+11>>0]=q;if(!q)v=h;else{w=h;s=12}}else{r=q+16&-16;c=L5b(r)|0;f[h>>2]=c;f[h+8>>2]=r|-2147483648;f[h+4>>2]=q;w=c;s=12}if((s|0)==12){Vac(w|0,l|0,q|0)|0;v=w}b[v+q>>0]=0;_5b(j+12|0,h)|0;if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);Fab(j+36|0,i)|0;cwa(j+48|0,f[m>>2]|0,f[i+16>>2]|0);m=j+60|0;bD(m);h=f[d>>2]|0;if(!h)x=0;else{q=h+-4|0;f[q>>2]=(f[q>>2]|0)+1;x=f[d>>2]|0}f[m>>2]=x;f[j+64>>2]=f[i+28>>2];x=j+68|0;bD(x);m=f[o>>2]|0;if(!m)y=0;else{d=m+-4|0;f[d>>2]=(f[d>>2]|0)+1;y=f[o>>2]|0}f[x>>2]=y;f[j+72>>2]=f[n>>2];n=a+8|0;y=j+28|0;x=f[y>>2]|0;if((x|0)==(f[j+32>>2]|0))JT(j+24|0,n);else{X5b(x,n);f[y>>2]=(f[y>>2]|0)+12}_5b(n,k)|0;y=f[a>>2]|0;x=y+16|0;o=f[x>>2]|0;if((o|0)==(f[y+20>>2]|0))Gab(y+12|0,j);else{_ta(o,j);f[x>>2]=(f[x>>2]|0)+76}f[e>>2]=(f[e>>2]|0)+1;e=a+24|0;x=f[e>>2]|0;if((x|0)==(f[a+28>>2]|0))JT(a+20|0,n);else{X5b(x,n);f[e>>2]=(f[e>>2]|0)+12}if((b[k+11>>0]|0)>=0){Zta(j);fua(i);u=g;return}O5b(f[k>>2]|0);Zta(j);fua(i);u=g;return}function yab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+320|0;e=d+168|0;g=d+152|0;h=d+8|0;i=d;f[a>>2]=0;j=a+4|0;f[j>>2]=0;f[a+8>>2]=0;k=e+64|0;l=e+8|0;f[l>>2]=106096;m=e+12|0;f[e>>2]=18124;f[k>>2]=18144;f[e+4>>2]=0;RXb(e+64|0,m);f[e+136>>2]=0;f[e+140>>2]=-1;f[e>>2]=106076;f[k>>2]=106116;f[l>>2]=106096;WXb(m);f[m>>2]=43284;l=e+44|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[e+60>>2]=24;qP(m,c);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;c=h+64|0;m=h+8|0;l=h+12|0;k=h+4|0;n=h+64|0;o=h+136|0;p=h+140|0;q=h+44|0;r=h+60|0;s=a+8|0;while(1){t=qab(e,g,44)|0;v=(f[t+(f[(f[t>>2]|0)+-12>>2]|0)+16>>2]&5|0)!=0;if(!((v?0:0)&1|(v?0:1507)))break;f[m>>2]=106096;f[h>>2]=18124;f[c>>2]=18144;f[k>>2]=0;RXb(n,l);f[o>>2]=0;f[p>>2]=-1;f[h>>2]=106076;f[c>>2]=106116;f[m>>2]=106096;WXb(l);f[l>>2]=43284;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[r>>2]=24;qP(l,g);aYb(h,i)|0;v=f[j>>2]|0;if((v|0)==(f[s>>2]|0))IO(a,i);else{f[v>>2]=f[i>>2];f[j>>2]=v+4}kya(h)}if((b[g+11>>0]|0)>=0){kya(e);u=d;return}O5b(f[g>>2]|0);kya(e);u=d;return}function zab(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+160|0;e=d;g=d+112|0;h=d+36|0;i=d+24|0;j=d+16|0;f[g+4>>2]=0;f[g+8>>2]=0;f[g>>2]=g+4;k=g+12|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;l=g+24|0;bD(l);m=aD(l,13)|0;n=411865;o=m+13|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));n=g+32|0;bD(n);p=aD(n,8)|0;q=p;b[q>>0]=73;b[q+1>>0]=100;b[q+2>>0]=101;b[q+3>>0]=110;q=p+4|0;b[q>>0]=116;b[q+1>>0]=105;b[q+2>>0]=116;b[q+3>>0]=121;f[h+40>>2]=0;f[h+44>>2]=0;q=h+40|0;p=h+36|0;m=h;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[p>>2]=q;q=h+48|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;q=a+4|0;f[e>>2]=f[q>>2];hO(j,411879,e);p=f[j>>2]|0;m=f[j+4>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(m>>>0>4294967279)V5b(i);if(m>>>0<11){b[i+11>>0]=m;if(!m)r=i;else{s=i;t=6}}else{o=m+16&-16;v=L5b(o)|0;f[i>>2]=v;f[i+8>>2]=o|-2147483648;f[i+4>>2]=m;s=v;t=6}if((t|0)==6){Vac(s|0,p|0,m|0)|0;r=s}b[r+m>>0]=0;bD(j);_5b(h,i)|0;j=f[n>>2]|0;m=g+36|0;r=f[m>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(r>>>0>4294967279)V5b(e);if(r>>>0<11){b[e+11>>0]=r;if(!r)w=e;else{x=e;t=12}}else{s=r+16&-16;p=L5b(s)|0;f[e>>2]=p;f[e+8>>2]=s|-2147483648;f[e+4>>2]=r;x=p;t=12}if((t|0)==12){Vac(x|0,j|0,r|0)|0;w=x}b[w+r>>0]=0;_5b(h+12|0,e)|0;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);Fab(h+36|0,g)|0;cwa(h+48|0,f[k>>2]|0,f[g+16>>2]|0);k=h+60|0;bD(k);e=f[l>>2]|0;if(!e)y=0;else{r=e+-4|0;f[r>>2]=(f[r>>2]|0)+1;y=f[l>>2]|0}f[k>>2]=y;f[h+64>>2]=f[g+28>>2];y=h+68|0;bD(y);k=f[n>>2]|0;if(!k)z=0;else{l=k+-4|0;f[l>>2]=(f[l>>2]|0)+1;z=f[n>>2]|0}f[y>>2]=z;f[h+72>>2]=f[m>>2];m=a+20|0;z=a+24|0;y=f[m>>2]|0;if((((f[z>>2]|0)-y|0)/12|0)>>>0<=c>>>0)d4b(m);n=y+(c*12|0)|0;c=h+28|0;y=f[c>>2]|0;if((y|0)==(f[h+32>>2]|0))JT(h+24|0,n);else{X5b(y,n);f[c>>2]=(f[c>>2]|0)+12}c=a+8|0;_5b(c,i)|0;n=f[a>>2]|0;y=n+16|0;l=f[y>>2]|0;if((l|0)==(f[n+20>>2]|0))Gab(n+12|0,h);else{_ta(l,h);f[y>>2]=(f[y>>2]|0)+76}f[q>>2]=(f[q>>2]|0)+1;q=f[z>>2]|0;if((q|0)==(f[a+28>>2]|0))JT(m,c);else{X5b(q,c);f[z>>2]=(f[z>>2]|0)+12}if((b[i+11>>0]|0)>=0){Zta(h);fua(g);u=d;return}O5b(f[i>>2]|0);Zta(h);fua(g);u=d;return}
function b$(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;k=u;u=u+96|0;l=k+88|0;m=k+56|0;o=k+48|0;q=k;dQ(o,49584);r=j?2:0;switch(h|0){case 0:{f[q>>2]=i;f[q+4>>2]=r;h=q+8|0;f[h>>2]=13273;s=q+12|0;f[s>>2]=-6296;t=q+16|0;f[t>>2]=-2042;f[q+20>>2]=-3970;f[q+24>>2]=7684;f[q+28>>2]=170;v=q+32|0;f[v>>2]=228;w=q+36|0;f[w>>2]=-836;x=q+40|0;f[x>>2]=4331;if(!j){f[h>>2]=228;f[v>>2]=13273;f[s>>2]=-836;f[w>>2]=-6296;f[t>>2]=4331;f[x>>2]=-2042}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=49612;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=q;RQ(l,m,+(Y(g,e)|0)*.0000152587890625);break}case 2:{f[q>>2]=i;f[q+4>>2]=r;x=q+8|0;f[x>>2]=13273;t=q+12|0;f[t>>2]=-6296;w=q+16|0;f[w>>2]=-2042;f[q+20>>2]=-3970;f[q+24>>2]=7684;f[q+28>>2]=170;s=q+32|0;f[s>>2]=228;v=q+36|0;f[v>>2]=-836;h=q+40|0;f[h>>2]=4331;if(!j){f[x>>2]=228;f[s>>2]=13273;f[t>>2]=-836;f[v>>2]=-6296;f[w>>2]=4331;f[h>>2]=-2042}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=49632;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=q;RQ(l,m,+(Y(g,e)|0)*.0000152587890625);break}default:{f[q>>2]=i;f[q+4>>2]=r;y=+p[61396];r=q+8|0;n[r>>2]=y;z=+p[61397];i=q+12|0;n[i>>2]=z;A=+p[61398];h=q+16|0;n[h>>2]=A;n[q+20>>2]=+p[61399];n[q+24>>2]=+p[61400];n[q+28>>2]=+p[61401];B=+p[61402];w=q+32|0;n[w>>2]=B;C=+p[61403];v=q+36|0;n[v>>2]=C;D=+p[61404];t=q+40|0;n[t>>2]=D;if(!j){n[r>>2]=B;n[w>>2]=y;n[i>>2]=C;n[v>>2]=z;n[h>>2]=D;n[t>>2]=A}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=49652;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=q;RQ(l,m,+(Y(g,e)|0)*.0000152587890625)}}if(!(f[o+4>>2]|0)){u=k;return}u=k;return}function c$(a){a=a|0;O5b(a);return}function d$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;dQ(d,49664);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;a=e;while(1){e$(f[j>>2]|0,b,l,f[k>>2]|0);a=a+1|0;if((a|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function e$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0.0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0.0;e=f[a>>2]|0;g=+n[a+8>>2];h=+n[a+12>>2];i=+n[a+16>>2];j=+n[a+20>>2];k=+n[a+24>>2];l=+n[a+28>>2];m=+n[a+32>>2];o=+n[a+36>>2];p=+n[a+40>>2];a=d*3|0;if((d|0)<=0)return;if((e|0)==4){d=0;q=c;while(1){r=+n[b+(d<<2)>>2];s=+n[b+(d+1<<2)>>2];t=+n[b+(d+2<<2)>>2];n[q>>2]=g*r+h*s+i*t;n[q+4>>2]=j*r+k*s+l*t;n[q+8>>2]=m*r+o*s+p*t;n[q+12>>2]=1.0;d=d+3|0;if((d|0)>=(a|0))break;else q=q+16|0}return}else{q=0;d=c;while(1){t=+n[b+(q<<2)>>2];s=+n[b+(q+1<<2)>>2];r=+n[b+(q+2<<2)>>2];n[d>>2]=g*t+h*s+i*r;n[d+4>>2]=j*t+k*s+l*r;n[d+8>>2]=m*t+o*s+p*r;q=q+3|0;if((q|0)>=(a|0))break;else d=d+(e<<2)|0}return}}function f$(a){a=a|0;O5b(a);return}function g$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;dQ(d,49684);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;a=e;while(1){h$(f[j>>2]|0,b,l,f[k>>2]|0);a=a+1|0;if((a|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function h$(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=f[a>>2]|0;h=f[a+8>>2]|0;i=f[a+12>>2]|0;k=f[a+16>>2]|0;l=f[a+20>>2]|0;m=f[a+24>>2]|0;n=f[a+28>>2]|0;o=f[a+32>>2]|0;p=f[a+36>>2]|0;q=f[a+40>>2]|0;a=e*3|0;if((e|0)<=0)return;if((g|0)==4){e=0;r=c;while(1){s=j[b+(e<<1)>>1]|0;t=Y(s,h)|0;u=j[b+(e+1<<1)>>1]|0;v=Y(u,i)|0;w=j[b+(e+2<<1)>>1]|0;x=t+2048+v+(Y(w,k)|0)>>12;v=(Y(s,l)|0)+2048+(Y(u,m)|0)+(Y(w,n)|0)>>12;t=(Y(s,o)|0)+2048+(Y(u,p)|0)+(Y(w,q)|0)>>12;d[r>>1]=x>>>0<65536?x:(x|0)>0?65535:0;d[r+2>>1]=v>>>0<65536?v:(v|0)>0?65535:0;d[r+4>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[r+6>>1]=-1;e=e+3|0;if((e|0)>=(a|0))break;else r=r+8|0}return}else{r=0;e=c;while(1){c=j[b+(r<<1)>>1]|0;t=Y(c,h)|0;v=j[b+(r+1<<1)>>1]|0;x=Y(v,i)|0;w=j[b+(r+2<<1)>>1]|0;u=t+2048+x+(Y(w,k)|0)>>12;x=(Y(c,l)|0)+2048+(Y(v,m)|0)+(Y(w,n)|0)>>12;t=(Y(c,o)|0)+2048+(Y(v,p)|0)+(Y(w,q)|0)>>12;d[e>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[e+2>>1]=x>>>0<65536?x:(x|0)>0?65535:0;d[e+4>>1]=t>>>0<65536?t:(t|0)>0?65535:0;r=r+3|0;if((r|0)>=(a|0))break;else e=e+(g<<1)|0}return}}function i$(a){a=a|0;O5b(a);return}function j$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;dQ(d,49704);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;a=e;while(1){k$(f[j>>2]|0,b,l,f[k>>2]|0);a=a+1|0;if((a|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function k$(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=f[a>>2]|0;i=f[a+8>>2]|0;j=f[a+12>>2]|0;k=f[a+16>>2]|0;l=f[a+20>>2]|0;m=f[a+24>>2]|0;n=f[a+28>>2]|0;o=f[a+32>>2]|0;p=f[a+36>>2]|0;q=f[a+40>>2]|0;a=e*3|0;if((e|0)<=0)return;if((g|0)==4){e=0;r=d;while(1){s=h[c+e>>0]|0;t=Y(s,i)|0;u=h[c+(e+1)>>0]|0;v=Y(u,j)|0;w=h[c+(e+2)>>0]|0;x=t+2048+v+(Y(w,k)|0)>>12;v=(Y(s,l)|0)+2048+(Y(u,m)|0)+(Y(w,n)|0)>>12;t=(Y(s,o)|0)+2048+(Y(u,p)|0)+(Y(w,q)|0)>>12;b[r>>0]=x>>>0<256?x:(x|0)>0?255:0;b[r+1>>0]=v>>>0<256?v:(v|0)>0?255:0;b[r+2>>0]=t>>>0<256?t:(t|0)>0?255:0;b[r+3>>0]=-1;e=e+3|0;if((e|0)>=(a|0))break;else r=r+4|0}return}else{r=0;e=d;while(1){d=h[c+r>>0]|0;t=Y(d,i)|0;v=h[c+(r+1)>>0]|0;x=Y(v,j)|0;w=h[c+(r+2)>>0]|0;u=t+2048+x+(Y(w,k)|0)>>12;x=(Y(d,l)|0)+2048+(Y(v,m)|0)+(Y(w,n)|0)>>12;t=(Y(d,o)|0)+2048+(Y(v,p)|0)+(Y(w,q)|0)>>12;b[e>>0]=u>>>0<256?u:(u|0)>0?255:0;b[e+1>>0]=x>>>0<256?x:(x|0)>0?255:0;b[e+2>>0]=t>>>0<256?t:(t|0)>0?255:0;r=r+3|0;if((r|0)>=(a|0))break;else e=e+g|0}return}}function l$(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;o=u;u=u+64|0;p=o+56|0;q=o+24|0;r=o+16|0;s=o;dQ(r,49724);t=(i|0)==5?360:l?256:180;l=k?2:0;k=(i|0)==0;do if(!m)if(k){f[s>>2]=j;f[s+4>>2]=3;f[s+8>>2]=l;n[s+12>>2]=+(t|0)/360.0;f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=49792;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=s;RQ(p,q,+(Y(h,g)|0)*.0000152587890625);break}else{f[s>>2]=j;f[s+4>>2]=l;n[s+8>>2]=+(t|0)/360.0;f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=49812;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=s;RQ(p,q,+(Y(h,g)|0)*.0000152587890625);break}else{if(!k){f[s>>2]=j;f[s+4>>2]=l;n[s+8>>2]=+(t|0);f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=49772;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=s;RQ(p,q,+(Y(h,g)|0)*.0000152587890625);break}f[s>>2]=j;f[s+4>>2]=l;f[s+8>>2]=t;switch(t&511){case 256:case 180:break;default:{f[p>>2]=0;f[p+4>>2]=0;i=aD(p,30)|0;v=223136;w=i+30|0;do{b[i>>0]=b[v>>0]|0;i=i+1|0;v=v+1|0}while((i|0)<(w|0));bO(-215,p,223167,217660,4489);bD(p)}}f[p>>2]=0;f[p+4>>2]=h;f[q>>2]=49752;f[q+4>>2]=a;f[q+8>>2]=c;f[q+12>>2]=d;f[q+16>>2]=e;f[q+20>>2]=g;f[q+24>>2]=s;RQ(p,q,+(Y(h,g)|0)*.0000152587890625)}while(0);if(!(f[r+4>>2]|0)){u=o;return}u=o;return}function m$(a){a=a|0;O5b(a);return}function n$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0;c=u;u=u+16|0;d=c;dQ(d,49824);e=f[b>>2]|0;g=f[b+4>>2]|0;a:do if((e|0)<(g|0)){b=f[a+8>>2]|0;h=f[a+16>>2]|0;i=a+24|0;j=f[a+20>>2]|0;k=j*3|0;if((j|0)<=0){j=e;while(1){j=j+1|0;if((j|0)>=(g|0))break a}}j=(f[a+12>>2]|0)+(Y(h,e)|0)|0;l=j;j=(f[a+4>>2]|0)+(Y(b,e)|0)|0;m=e;while(1){o=f[i>>2]|0;p=f[o+4>>2]|0;q=f[o>>2]|0;r=p^2;s=o+8|0;o=j;t=0;while(1){v=+n[o+(p<<2)>>2];w=+n[o+4>>2];x=+n[o+(r<<2)>>2];y=x<w?w:x;z=y<v?v:y;y=x>w?w:x;A=y>v?v:y;y=z-A;B=z+A;C=B*.5;if(y>1.1920928955078125e-07){D=y/(C<.5?B:2.0-z-A);A=60.0/y;do if(!(z==x))if(z==w){E=(v-x)*A+120.0;break}else{E=(x-w)*A+240.0;break}else E=(w-v)*A;while(0);if(E<0.0){F=D;G=E+360.0}else{F=D;G=E}}else{F=0.0;G=0.0}n[l+(t<<2)>>2]=G*+n[s>>2];n[l+(t+1<<2)>>2]=C;n[l+(t+2<<2)>>2]=F;t=t+3|0;if((t|0)>=(k|0))break;else o=o+(q<<2)|0}m=m+1|0;if((m|0)>=(g|0))break;else{l=l+h|0;j=j+b|0}}}while(0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function o$(a){a=a|0;O5b(a);return}function p$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,49844);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){q$(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function q$(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0;g=u;u=u+3072|0;i=g;j=f[a>>2]|0;if((e|0)<=0){u=g;return}k=a+8|0;l=a+4|0;m=a+12|0;a=d;d=0;o=c;while(1){c=e-d|0;p=((c|0)<256?c:256)*3|0;q=(c|0)>0;if(q){c=0;r=o;do{n[i+(c<<2)>>2]=+(h[r>>0]|0)*.003921568859368563;n[i+(c+1<<2)>>2]=+(h[r+1>>0]|0)*.003921568859368563;n[i+(c+2<<2)>>2]=+(h[r+2>>0]|0)*.003921568859368563;c=c+3|0;r=r+j|0}while((c|0)<(p|0));c=f[k>>2]|0;s=f[l>>2]|0;if(q){t=c^2;v=i;w=0;while(1){x=+n[v+(c<<2)>>2];y=+n[v+4>>2];z=+n[v+(t<<2)>>2];A=z<y?y:z;B=A<x?x:A;A=z>y?y:z;C=A>x?x:A;A=B-C;D=B+C;E=D*.5;if(A>1.1920928955078125e-07){F=A/(E<.5?D:2.0-B-C);C=60.0/A;do if(!(B==z))if(B==y){G=(x-z)*C+120.0;break}else{G=(z-y)*C+240.0;break}else G=(y-x)*C;while(0);if(G<0.0){H=F;I=G+360.0}else{H=F;I=G}}else{H=0.0;I=0.0}n[i+(w<<2)>>2]=I*+n[m>>2];n[i+(w+1<<2)>>2]=E;n[i+(w+2<<2)>>2]=H;w=w+3|0;if((w|0)>=(p|0))break;else v=v+(s<<2)|0}if(q){s=0;do{v=LVb(+n[i+(s<<2)>>2])|0;b[a+s>>0]=v>>>0<256?v:(v|0)>0?255:0;v=s+1|0;w=LVb(+n[i+(v<<2)>>2]*255.0)|0;b[a+v>>0]=w>>>0<256?w:(w|0)>0?255:0;w=s+2|0;v=LVb(+n[i+(w<<2)>>2]*255.0)|0;b[a+w>>0]=v>>>0<256?v:(v|0)>0?255:0;s=s+3|0}while((s|0)<(p|0));J=r}else J=r}else J=r}else J=o;d=d+256|0;if((d|0)>=(e|0))break;else{a=a+768|0;o=J}}u=g;return}function r$(a){a=a|0;O5b(a);return}function s$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0;c=u;u=u+16|0;d=c;dQ(d,49864);e=f[b>>2]|0;g=f[b+4>>2]|0;a:do if((e|0)<(g|0)){b=f[a+8>>2]|0;h=f[a+16>>2]|0;i=a+24|0;j=f[a+20>>2]|0;k=j*3|0;if((j|0)<=0){j=e;while(1){j=j+1|0;if((j|0)>=(g|0))break a}}j=(f[a+12>>2]|0)+(Y(h,e)|0)|0;l=j;j=(f[a+4>>2]|0)+(Y(b,e)|0)|0;m=e;while(1){o=f[i>>2]|0;p=f[o+4>>2]|0;q=f[o>>2]|0;r=+n[o+8>>2]*2.7777778450399637e-03;o=p^2;s=j;t=0;while(1){v=+n[s+(p<<2)>>2];w=+n[s+4>>2];x=+n[s+(o<<2)>>2];y=x<w?w:x;z=y<v?v:y;y=x>w?w:x;A=z-(y>v?v:y);y=A/(+L(+z)+1.1920928955078125e-07);B=60.0/(A+1.1920928955078125e-07);do if(!(z==x))if(z==w){C=(v-x)*B+120.0;break}else{C=(x-w)*B+240.0;break}else C=(w-v)*B;while(0);n[l+(t<<2)>>2]=r*(C<0.0?C+360.0:C);n[l+(t+1<<2)>>2]=y;n[l+(t+2<<2)>>2]=z;t=t+3|0;if((t|0)>=(k|0))break;else s=s+(q<<2)|0}m=m+1|0;if((m|0)>=(g|0))break;else{l=l+h|0;j=j+b|0}}}while(0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function t$(a){a=a|0;O5b(a);return}function u$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,49884);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){v$(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function v$(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=f[a+4>>2]|0;i=f[a>>2]|0;j=f[a+8>>2]|0;a=(j|0)==180?503692:504716;k=e*3|0;if(!(b[1120379]|0)){f[126179]=0;f[125923]=0;f[126435]=0;l=1;do{m=+(l|0);n=MVb(1044480.0/m)|0;f[505740+(l<<2)>>2]=n;o=m*6.0;n=MVb(737280.0/o)|0;f[503692+(l<<2)>>2]=n;n=MVb(1048576.0/o)|0;f[504716+(l<<2)>>2]=n;l=l+1|0}while((l|0)!=256);b[1120379]=1}if((e|0)<=0)return;e=g^2;l=c;c=0;while(1){n=h[l+g>>0]|0;p=h[l+1>>0]|0;q=h[l+e>>0]|0;r=p-n|0;s=r+256|0;if(s>>>0<769)t=h[259297+s>>0]|0;else t=0;s=t+n|0;u=q-s+256|0;if(u>>>0<769)v=h[259297+u>>0]|0;else v=0;u=v+s|0;s=n-p+256|0;if(s>>>0<769)w=h[259297+s>>0]|0;else w=0;s=n-w|0;x=s-q+256|0;if(x>>>0<769)y=h[259297+x>>0]|0;else y=0;x=y-s+u|0;s=(x>>>0<256?x:(x|0)>0?255:0)&255;x=((Y(s,f[505740+(u<<2)>>2]|0)|0)+2048|0)>>>12;z=(Y((u|0)==(q|0)?r:(u|0)==(p|0)?n-q+(s<<1)|0:q-p+(s<<2)|0,f[a+(s<<2)>>2]|0)|0)+2048>>12;s=((z|0)<0?j:0)+z|0;b[d+c>>0]=s>>>0<256?s:(s|0)>0?255:0;b[d+(c+1)>>0]=x;b[d+(c+2)>>0]=u;c=c+3|0;if((c|0)>=(k|0))break;else l=l+i|0}return}function w$(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0;m=u;u=u+64|0;o=m+56|0;p=m+24|0;q=m+16|0;r=m;dQ(q,49904);s=(h|0)==5?360:k?255:180;k=j?2:0;j=(h|0)==0;do if(l)if(j){f[r>>2]=i;f[r+4>>2]=3;f[r+8>>2]=k;n[r+12>>2]=6.0/+(s|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=49932;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=r;RQ(o,p,+(Y(g,e)|0)*.0000152587890625);break}else{f[r>>2]=i;f[r+4>>2]=k;n[r+8>>2]=6.0/+(s|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=49952;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=r;RQ(o,p,+(Y(g,e)|0)*.0000152587890625);break}else if(j){f[r>>2]=i;f[r+4>>2]=3;f[r+8>>2]=k;n[r+12>>2]=6.0/+(s|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=49972;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=r;RQ(o,p,+(Y(g,e)|0)*.0000152587890625);break}else{f[r>>2]=i;f[r+4>>2]=k;n[r+8>>2]=6.0/+(s|0);f[o>>2]=0;f[o+4>>2]=g;f[p>>2]=49992;f[p+4>>2]=a;f[p+8>>2]=b;f[p+12>>2]=c;f[p+16>>2]=d;f[p+20>>2]=e;f[p+24>>2]=r;RQ(o,p,+(Y(g,e)|0)*.0000152587890625);break}while(0);if(!(f[q+4>>2]|0)){u=m;return}u=m;return}function x$(a){a=a|0;O5b(a);return}function y$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;dQ(d,50004);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;a=e;while(1){z$(f[j>>2]|0,b,l,f[k>>2]|0);a=a+1|0;if((a|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function z$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=f[a>>2]|0;j=+n[a+8>>2];a=d*3|0;if((d|0)<=0){u=e;return}d=h^2;k=g+4|0;l=g+8|0;m=g+12|0;if((i|0)==4){o=0;p=c;while(1){q=+n[b+(o<<2)>>2];r=+n[b+(o+1<<2)>>2];s=+n[b+(o+2<<2)>>2];if(s==0.0){t=r;v=r;w=r}else{if(!(r<=.5))x=r+s-r*s;else x=r*(s+1.0);s=r*2.0-x;r=j*q;if(!(r<0.0))if(!(r>=6.0))y=r;else{q=r;while(1){z=q+-6.0;if(!(z>=6.0)){y=z;break}else q=z}}else{q=r;while(1){z=q+6.0;if(z<0.0)q=z;else{y=z;break}}}A=~~y;B=A-(+(A|0)>y&1)|0;q=y-+(B|0);n[g>>2]=x;n[k>>2]=s;r=x-s;n[l>>2]=s+r*(1.0-q);n[m>>2]=s+r*q;t=+n[g+(f[50024+(B*12|0)+8>>2]<<2)>>2];v=+n[g+(f[50024+(B*12|0)+4>>2]<<2)>>2];w=+n[g+(f[50024+(B*12|0)>>2]<<2)>>2]}n[p+(h<<2)>>2]=w;n[p+4>>2]=v;n[p+(d<<2)>>2]=t;n[p+12>>2]=1.0;o=o+3|0;if((o|0)>=(a|0))break;else p=p+16|0}u=e;return}else{p=0;o=c;while(1){t=+n[b+(p<<2)>>2];v=+n[b+(p+1<<2)>>2];w=+n[b+(p+2<<2)>>2];if(w==0.0){C=v;D=v;E=v}else{if(!(v<=.5))F=v+w-v*w;else F=v*(w+1.0);w=v*2.0-F;v=j*t;if(!(v<0.0))if(!(v>=6.0))G=v;else{t=v;while(1){x=t+-6.0;if(!(x>=6.0)){G=x;break}else t=x}}else{t=v;while(1){s=t+6.0;if(s<0.0)t=s;else{G=s;break}}}c=~~G;B=c-(+(c|0)>G&1)|0;t=G-+(B|0);n[g>>2]=F;n[k>>2]=w;v=F-w;n[l>>2]=w+v*(1.0-t);n[m>>2]=w+v*t;C=+n[g+(f[50024+(B*12|0)+8>>2]<<2)>>2];D=+n[g+(f[50024+(B*12|0)+4>>2]<<2)>>2];E=+n[g+(f[50024+(B*12|0)>>2]<<2)>>2]}n[o+(h<<2)>>2]=E;n[o+4>>2]=D;n[o+(d<<2)>>2]=C;p=p+3|0;if((p|0)>=(a|0))break;else o=o+(i<<2)|0}u=e;return}}function A$(a){a=a|0;O5b(a);return}function B$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,50096);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){C$(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function C$(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+3072|0;i=g;j=f[a>>2]|0;if((e|0)<=0){u=g;return}k=a+4|0;a=(j|0)==4;l=d;d=0;m=c;while(1){c=e-d|0;o=(c|0)<256?c:256;p=o*3|0;q=(c|0)>0;if(q){c=0;do{n[i+(c<<2)>>2]=+(h[m+c>>0]|0);r=c+1|0;n[i+(r<<2)>>2]=+(h[m+r>>0]|0)*.003921568859368563;r=c+2|0;n[i+(r<<2)>>2]=+(h[m+r>>0]|0)*.003921568859368563;c=c+3|0}while((c|0)<(p|0));z$(k,i,i,o);if(q)if(a){c=0;r=l;while(1){s=LVb(+n[i+(c<<2)>>2]*255.0)|0;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=LVb(+n[i+(c+1<<2)>>2]*255.0)|0;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=LVb(+n[i+(c+2<<2)>>2]*255.0)|0;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+3>>0]=-1;c=c+3|0;s=r+4|0;if((c|0)>=(p|0)){t=s;break}else r=s}}else{r=0;c=l;while(1){q=LVb(+n[i+(r<<2)>>2]*255.0)|0;b[c>>0]=q>>>0<256?q:(q|0)>0?255:0;q=LVb(+n[i+(r+1<<2)>>2]*255.0)|0;b[c+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=LVb(+n[i+(r+2<<2)>>2]*255.0)|0;b[c+2>>0]=q>>>0<256?q:(q|0)>0?255:0;r=r+3|0;q=c+j|0;if((r|0)>=(p|0)){t=q;break}else c=q}}else t=l}else{z$(k,i,i,o);t=l}d=d+256|0;if((d|0)>=(e|0))break;else{l=t;m=m+768|0}}u=g;return}function D$(a){a=a|0;O5b(a);return}function E$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,50116);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){F$(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function F$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0;e=u;u=u+16|0;g=e;h=f[a+4>>2]|0;i=f[a>>2]|0;j=+n[a+8>>2];a=d*3|0;if((d|0)<=0){u=e;return}d=h^2;k=g+4|0;l=g+8|0;m=g+12|0;if((i|0)==4){o=c;p=0;while(1){q=+n[b+(p+1<<2)>>2];r=+n[b+(p+2<<2)>>2];if(q==0.0){s=r;t=r;v=r}else{w=j*+n[b+(p<<2)>>2];if(!(w<0.0))if(!(w>=6.0))x=w;else{y=w;while(1){z=y+-6.0;if(!(z>=6.0)){x=z;break}else y=z}}else{y=w;while(1){z=y+6.0;if(z<0.0)y=z;else{x=z;break}}}A=~~x;B=A-(+(A|0)>x&1)|0;A=B>>>0>5;y=A?0.0:x-+(B|0);C=A?0:B;n[g>>2]=r;n[k>>2]=r*(1.0-q);n[l>>2]=r*(1.0-q*y);n[m>>2]=r*(1.0-q*(1.0-y));s=+n[g+(f[50136+(C*12|0)+8>>2]<<2)>>2];t=+n[g+(f[50136+(C*12|0)+4>>2]<<2)>>2];v=+n[g+(f[50136+(C*12|0)>>2]<<2)>>2]}n[o+(h<<2)>>2]=v;n[o+4>>2]=t;n[o+(d<<2)>>2]=s;n[o+12>>2]=1.0;p=p+3|0;if((p|0)>=(a|0))break;else o=o+16|0}u=e;return}else{o=c;c=0;while(1){s=+n[b+(c+1<<2)>>2];t=+n[b+(c+2<<2)>>2];if(s==0.0){D=t;E=t;F=t}else{v=j*+n[b+(c<<2)>>2];if(!(v<0.0))if(!(v>=6.0))G=v;else{x=v;while(1){y=x+-6.0;if(!(y>=6.0)){G=y;break}else x=y}}else{x=v;while(1){q=x+6.0;if(q<0.0)x=q;else{G=q;break}}}p=~~G;C=p-(+(p|0)>G&1)|0;p=C>>>0>5;x=p?0.0:G-+(C|0);B=p?0:C;n[g>>2]=t;n[k>>2]=t*(1.0-s);n[l>>2]=t*(1.0-s*x);n[m>>2]=t*(1.0-s*(1.0-x));D=+n[g+(f[50136+(B*12|0)+8>>2]<<2)>>2];E=+n[g+(f[50136+(B*12|0)+4>>2]<<2)>>2];F=+n[g+(f[50136+(B*12|0)>>2]<<2)>>2]}n[o+(h<<2)>>2]=F;n[o+4>>2]=E;n[o+(d<<2)>>2]=D;c=c+3|0;if((c|0)>=(a|0))break;else o=o+(i<<2)|0}u=e;return}}function G$(a){a=a|0;O5b(a);return}function H$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,50208);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){I$(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function I$(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+3072|0;i=g;j=f[a>>2]|0;if((e|0)<=0){u=g;return}k=a+4|0;a=(j|0)==4;l=d;d=0;m=c;while(1){c=e-d|0;o=(c|0)<256?c:256;p=o*3|0;q=(c|0)>0;if(q){c=0;do{n[i+(c<<2)>>2]=+(h[m+c>>0]|0);r=c+1|0;n[i+(r<<2)>>2]=+(h[m+r>>0]|0)*.003921568859368563;r=c+2|0;n[i+(r<<2)>>2]=+(h[m+r>>0]|0)*.003921568859368563;c=c+3|0}while((c|0)<(p|0));F$(k,i,i,o);if(q)if(a){c=0;r=l;while(1){s=LVb(+n[i+(c<<2)>>2]*255.0)|0;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=LVb(+n[i+(c+1<<2)>>2]*255.0)|0;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=LVb(+n[i+(c+2<<2)>>2]*255.0)|0;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+3>>0]=-1;c=c+3|0;s=r+4|0;if((c|0)>=(p|0)){t=s;break}else r=s}}else{r=0;c=l;while(1){q=LVb(+n[i+(r<<2)>>2]*255.0)|0;b[c>>0]=q>>>0<256?q:(q|0)>0?255:0;q=LVb(+n[i+(r+1<<2)>>2]*255.0)|0;b[c+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=LVb(+n[i+(r+2<<2)>>2]*255.0)|0;b[c+2>>0]=q>>>0<256?q:(q|0)>0?255:0;r=r+3|0;q=c+j|0;if((r|0)>=(p|0)){t=q;break}else c=q}}else t=l}else{F$(k,i,i,o);t=l}d=d+256|0;if((d|0)>=(e|0))break;else{l=t;m=m+768|0}}u=g;return}function J$(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0;n=u;u=u+128|0;o=n+112|0;p=n+80|0;q=n+72|0;r=n;dQ(q,50228);s=k?2:0;k=(i|0)==0;do if(l)if(k){K$(r,j,s,0,0,m);f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=50256;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;RQ(o,p,+(Y(h,g)|0)*.0000152587890625);break}else{L$(r,j,s,0,0,m);f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=50276;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;RQ(o,p,+(Y(h,g)|0)*.0000152587890625);break}else if(k){f[r>>2]=j;M$(r+4|0,3,s,0,0,m);f[r+56>>2]=j;f[r+60>>2]=s;N$();b[r+64>>0]=m&1;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=50296;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;RQ(o,p,+(Y(h,g)|0)*.0000152587890625);break}else{M$(r,j,s,0,0,m);f[r+52>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=50316;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;RQ(o,p,+(Y(h,g)|0)*.0000152587890625);break}while(0);if(!(f[q+4>>2]|0)){u=n;return}u=n;return}function K$(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;i=u;u=u+80|0;j=i+56|0;k=i+32|0;l=i+24|0;m=i+16|0;o=i+8|0;q=i;f[a>>2]=c;b[a+40>>0]=h&1;N$();f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[122810];f[j+4>>2]=f[122811];f[j+8>>2]=f[122812];f[j+12>>2]=f[122813];f[j+16>>2]=f[122814];f[j+20>>2]=f[122815]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}if((b[491504]|0)==0?Cac(491504)|0:0)gmb(491512,4096);if((f[12602]|0)<=0){u=i;return}g=(e|0)==0;h=d^2;c=k+8|0;r=k+16|0;s=l+4|0;t=k+8|0;v=k+16|0;w=0;do{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;x=w*3|0;if(g){y=491096+(x<<3)|0;if((y|0)!=(k|0)){z=y;y=f[z+4>>2]|0;A=k;f[A>>2]=f[z>>2];f[A+4>>2]=y}y=x+1|0;A=491096+(y<<3)|0;if((A|0)!=(c|0)){z=A;A=f[z+4>>2]|0;B=c;f[B>>2]=f[z>>2];f[B+4>>2]=A}A=491096+(x+2<<3)|0;if((A|0)==(r|0))C=y;else{B=A;A=f[B+4>>2]|0;z=r;f[z>>2]=f[B>>2];f[z+4>>2]=A;C=y}}else{p[k>>3]=+n[e+(x<<2)>>2];y=x+1|0;p[t>>3]=+n[e+(y<<2)>>2];p[v>>3]=+n[e+(x+2<<2)>>2];C=y}smb(m,491512,k);y=j+(w<<3)|0;tmb(l,m,y);A=kmb(l)|0;f[a+4+(x+h<<2)>>2]=A;smb(o,491512,c);tmb(l,o,y);A=kmb(l)|0;z=a+4+(C<<2)|0;f[z>>2]=A;smb(q,491512,r);tmb(l,q,y);y=kmb(l)|0;f[a+4+(x+d<<2)>>2]=y;y=f[a+4+(x<<2)>>2]|0;if(!((((y|0)>-1?(A=f[z>>2]|0,(A|0)>-1):0)?(z=f[a+4+(x+2<<2)>>2]|0,(z|0)>-1):0)?(A+y+z|0)<8192:0)){f[l>>2]=0;f[s>>2]=0;z=aD(l,128)|0;y=225565;A=z+128|0;do{b[z>>0]=b[y>>0]|0;z=z+1|0;y=y+1|0}while((z|0)<(A|0));bO(-215,l,225694,217660,6378);bD(l)}w=w+1|0}while((w|0)<(f[12602]|0));u=i;return}function L$(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;i=u;u=u+128|0;j=i+116|0;k=i+64|0;l=i+40|0;m=i+32|0;o=i+24|0;q=i+104|0;r=i+96|0;t=i+16|0;v=i+8|0;w=i;x=i+92|0;y=i+88|0;f[a>>2]=c;c=a+40|0;b[c>>0]=h&1;h=a+44|0;f[h>>2]=d;f[j>>2]=3;N$();d=(e|0)!=0;z=(g|0)!=0;if(d|z)A=0;else A=b[c>>0]|0;b[a+41>>0]=A;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;if(z){p[k>>3]=+n[g>>2];p[k+8>>3]=+n[g+4>>2];p[k+16>>3]=+n[g+8>>2]}else{f[k>>2]=f[122810];f[k+4>>2]=f[122811];f[k+8>>2]=f[122812];f[k+12>>2]=f[122813];f[k+16>>2]=f[122814];f[k+20>>2]=f[122815]}g=m;f[g>>2]=0;f[g+4>>2]=1072693248;tmb(l,m,k);m=l+8|0;f[m>>2]=0;f[m+4>>2]=1072693248;m=o;f[m>>2]=0;f[m+4>>2]=1072693248;tmb(l+16|0,o,k+16|0);if((f[j>>2]|0)<=0){u=i;return}k=q+4|0;o=q+8|0;m=r+4|0;g=0;do{f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;z=l+(g<<3)|0;A=g*3|0;if(d){p[t>>3]=+n[e+(A<<2)>>2];smb(v,z,t);nmb(r,v);f[q>>2]=f[r>>2];c=A+1|0;p[t>>3]=+n[e+(c<<2)>>2];smb(v,z,t);nmb(r,v);f[k>>2]=f[r>>2];p[t>>3]=+n[e+(A+2<<2)>>2];smb(v,z,t);nmb(r,v);f[o>>2]=f[r>>2];B=c}else{smb(w,z,491096+(A<<3)|0);nmb(r,w);f[q>>2]=f[r>>2];c=A+1|0;smb(w,z,491096+(c<<3)|0);nmb(r,w);f[k>>2]=f[r>>2];smb(w,z,491096+(A+2<<3)|0);nmb(r,w);f[o>>2]=f[r>>2];B=c}c=f[q>>2]|0;f[a+4+((f[h>>2]^2)+A<<2)>>2]=c;z=f[k>>2]|0;f[a+4+(B<<2)>>2]=z;C=f[o>>2]|0;f[a+4+((f[h>>2]|0)+A<<2)>>2]=C;A=!((f[s>>2]=c,+n[s>>2])>=0.0);c=A|!((f[s>>2]=z,+n[s>>2])>=0.0);if(!(!(c|!((f[s>>2]=C,+n[s>>2])>=0.0))?(Zlb(x,q,k),Zlb(y,x,o),Xlb(r,1024),emb(y,r)|0):0)){f[r>>2]=0;f[m>>2]=0;C=aD(r,93)|0;c=225305;z=C+93|0;do{b[C>>0]=b[c>>0]|0;C=C+1|0;c=c+1|0}while((C|0)<(z|0));bO(-215,r,225399,217660,6454);bD(r)}g=g+1|0}while((g|0)<(f[j>>2]|0));u=i;return}function M$(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+128|0;j=i+112|0;k=i+48|0;l=i+100|0;m=i+104|0;o=i+96|0;q=i+40|0;r=i+92|0;s=i+32|0;t=i+24|0;v=i+16|0;w=i+8|0;x=i;y=i+88|0;z=i+84|0;A=i+80|0;B=i+76|0;C=i+72|0;f[a>>2]=c;b[a+48>>0]=h&1;N$();f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[j>>2]=0;a:do if((f[j>>2]|0)<3){if(g|0)while(1){p[k+(f[j>>2]<<3)>>3]=+n[g+(f[j>>2]<<2)>>2];f[j>>2]=(f[j>>2]|0)+1;if((f[j>>2]|0)>=3)break a}do{h=491240+(f[j>>2]<<3)|0;c=k+(f[j>>2]<<3)|0;if((h|0)!=(c|0)){D=h;h=f[D+4>>2]|0;E=c;f[E>>2]=f[D>>2];f[E+4>>2]=h}f[j>>2]=(f[j>>2]|0)+1}while((f[j>>2]|0)<3)}while(0);f[j>>2]=0;if((f[j>>2]|0)<3){g=(e|0)==0;h=(d|0)==0;d=m+4|0;do{E=(f[j>>2]|0)*3|0;if(g){n[a+4+((f[j>>2]|0)*3<<2)>>2]=+p[491096+(E<<3)>>3];n[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2]=+p[491096+(((f[j>>2]|0)*3|0)+1<<3)>>3];n[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2]=+p[491096+(((f[j>>2]|0)*3|0)+2<<3)>>3]}else{f[a+4+((f[j>>2]|0)*3<<2)>>2]=f[e+(E<<2)>>2];f[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2]=f[e+(((f[j>>2]|0)*3|0)+1<<2)>>2];f[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2]=f[e+(((f[j>>2]|0)*3|0)+2<<2)>>2]}if(h){E=a+4+((f[j>>2]|0)*3<<2)|0;D=a+4+(((f[j>>2]|0)*3|0)+2<<2)|0;c=f[E>>2]|0;f[E>>2]=f[D>>2];f[D>>2]=c}if(!(((+n[a+4+((f[j>>2]|0)*3<<2)>>2]>=0.0?+n[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2]>=0.0:0)?+n[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2]>=0.0:0)?(f[l>>2]=f[a+4+((f[j>>2]|0)*3<<2)>>2],f[m>>2]=f[a+4+(((f[j>>2]|0)*3|0)+1<<2)>>2],Zlb(o,l,m),f[q>>2]=f[a+4+(((f[j>>2]|0)*3|0)+2<<2)>>2],Zlb(r,o,q),n[s>>2]=1.5,emb(r,s)|0):0)){f[m>>2]=0;f[d>>2]=0;Vac(aD(m,158)|0,224945,158)|0;bO(-215,m,225104,217660,7532);bD(m)}f[j>>2]=(f[j>>2]|0)+1}while((f[j>>2]|0)<3)}j=k+8|0;gmb(s,15);smb(q,j,s);omb(t,k,q);gmb(w,3);smb(v,k+16|0,w);omb(x,t,v);nmb(m,x);f[y>>2]=1065353216;f[v>>2]=872415232;x=dmb(m,v)|0;f[s>>2]=f[(x?m:v)>>2];cmb(q,y,s);f[m>>2]=f[q>>2];Xlb(q,52);bmb(z,m,q);nmb(s,k);bmb(A,z,s);f[a+40>>2]=f[A>>2];Xlb(q,117);bmb(B,m,q);nmb(s,j);bmb(C,B,s);f[a+44>>2]=f[C>>2];C=q;f[C>>2]=0;f[C+4>>2]=1072693248;if(umb(j,q)|0){u=i;return}f[q>>2]=0;f[q+4>>2]=0;j=aD(q,31)|0;C=225117;a=j+31|0;do{b[j>>0]=b[C>>0]|0;j=j+1|0;C=C+1|0}while((j|0)<(a|0));bO(-215,q,225104,217660,7546);bD(q);u=i;return}function N$(){var a=0,c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0;a=u;u=u+14928|0;c=a+120|0;e=a+80|0;g=a+56|0;h=a+48|0;i=a+40|0;j=a+14912|0;k=a+32|0;l=a+24|0;m=a+16|0;o=a+14908|0;p=a+14904|0;q=a+14900|0;r=a+14896|0;s=a+14892|0;t=a+14888|0;v=a+14884|0;w=a+14880|0;x=a+14876|0;y=a+14872|0;z=a+14868|0;A=a+14864|0;B=a+14860|0;C=a+14856|0;D=a+14852|0;E=a+14848|0;F=a+14844|0;G=a+14840|0;H=a+13792|0;I=a+13784|0;K=a+12736|0;L=a+12732|0;M=a+12728|0;N=a+12724|0;O=a+12720|0;P=a+12716|0;Q=a+12712|0;R=a+12708|0;S=a+12704|0;T=a+12700|0;U=a+12696|0;V=a+12692|0;W=a+12688|0;X=a+12684|0;Z=a+12676|0;_=a+12664|0;$=a+12652|0;aa=a+12644|0;ba=a+12632|0;ca=a+12620|0;da=a+12612|0;ea=a+12596|0;fa=a+12588|0;ga=a+12580|0;ha=a+12572|0;ia=a+12564|0;ja=a+12560|0;ka=a+12552|0;la=a+12544|0;ma=a+12540|0;na=a+12532|0;oa=a+12528|0;pa=a+12524|0;qa=a+12520|0;ra=a+12516|0;sa=a+12512|0;ta=a+12508|0;ua=a+12504|0;va=a+12500|0;wa=a+12496|0;xa=a+12492|0;ya=a+12488|0;za=a+12484|0;Aa=a+12480|0;Ba=a+12476|0;Ca=a+12472|0;Da=a+8372|0;Ea=a+4272|0;Fa=a+172|0;Ga=a+168|0;Ha=a+12680|0;Ia=a+12672|0;Ja=a+12668|0;Ka=a+12660|0;La=a+12656|0;Ma=a+12648|0;Na=a+12640|0;Oa=a+12636|0;Pa=a+12628|0;Qa=a+12624|0;Ra=a+12616|0;Sa=a+12608|0;Ta=a+12604|0;Ua=a+12600|0;Va=a+12592|0;Wa=a+12584|0;Xa=a+12576|0;Ya=a+12568|0;Za=a+164|0;_a=a+8|0;$a=a;ab=a+12556|0;bb=a+160|0;cb=a+12548|0;db=a+156|0;eb=a+12536|0;if(b[1120380]|0){u=a;return}Nac(Da|0,0,4100)|0;Nac(Ea|0,0,4100)|0;Nac(Fa|0,0,4100)|0;f[Ha>>2]=1065353216;f[c>>2]=f[125873];cmb(Ga,Ha,c);Ha=0;do{Xlb(e,Ha);bmb(c,Ga,e);if(emb(c,503520)|0)wmb(e,c,503524,503528);else Amb(e,c);fb=Da+(Ha<<2)|0;if((e|0)!=(fb|0))f[fb>>2]=f[e>>2];Ha=Ha+1|0}while((Ha|0)!=1025);Ha=W$(Da)|0;f[126699]=Ha;f[Ia>>2]=1065353216;n[e>>2]=1024.0;cmb(c,Ia,e);f[Ga>>2]=f[c>>2];Ia=0;do{Xlb(e,Ia);bmb(c,Ga,e);f[Ja>>2]=f[c>>2];X$(e,Ja);Ha=Ea+(Ia<<2)|0;if((e|0)!=(Ha|0))f[Ha>>2]=f[e>>2];f[Ka>>2]=f[c>>2];Y$(e,Ka);Ha=Fa+(Ia<<2)|0;if((e|0)!=(Ha|0))f[Ha>>2]=f[e>>2];Ia=Ia+1|0}while((Ia|0)!=1025);Ia=W$(Ea)|0;f[126698]=Ia;Ia=W$(Fa)|0;f[126708]=Ia;if((b[491360]|0)==0?Cac(491360)|0:0)Xlb(506836,2040);Ia=0;do{Xlb(La,Ia);cmb(c,La,503532);f[Ma>>2]=f[c>>2];X$(g,Ma);bmb(e,506836,g);Fa=(jmb(e)|0)&65535;d[922964+(Ia<<1)>>1]=Fa;d[923476+(Ia<<1)>>1]=Ia<<3;Ia=Ia+1|0}while((Ia|0)!=256);if((b[491368]|0)==0?Cac(491368)|0:0){f[Na>>2]=1065353216;Xlb(c,4096);cmb(506840,Na,c)}Na=0;do{Xlb(e,Na);bmb(c,506840,e);f[Oa>>2]=f[c>>2];Y$(g,Oa);bmb(e,503532,g);Ia=(jmb(e)|0)&65535;d[923988+(Na<<1)>>1]=Ia;bmb(e,503532,c);Ia=(imb(e)|0)&65535;d[932180+(Na<<1)>>1]=Ia;Na=Na+1|0}while((Na|0)!=4096);if((b[491376]|0)==0?Cac(491376)|0:0)n[126711]=1.0/(+n[125883]*8.0);if((b[491384]|0)==0?Cac(491384)|0:0)Xlb(506848,32768);Na=0;do{Xlb(e,Na);bmb(c,506844,e);if(emb(c,503520)|0)wmb(g,c,503524,503528);else Amb(g,c);bmb(e,506848,g);Oa=(jmb(e)|0)&65535;d[940372+(Na<<1)>>1]=Oa;Na=Na+1|0}while((Na|0)!=3072);Na=0;do{if((Na|0)<21){Xlb(Pa,Y(Na,2949120)|0);Xlb(e,414613);cmb(c,Pa,e);Oa=jmb(c)|0;Xlb(Qa,16384);Xlb(Ra,16);Xlb(g,116);cmb(Sa,Ra,g);Xlb(Ta,Na*5|0);Xlb(i,1479);cmb(h,Ta,i);Zlb(e,Sa,h);bmb(c,Qa,e);gb=Oa;hb=jmb(c)|0}else{Xlb(Ua,Y(Na,1638400)|0);Xlb(e,29580);cmb(Va,Ua,e);Xlb(Wa,262144);Xlb(h,116);cmb(g,Wa,h);Zlb(c,Va,g);Oa=jmb(c)|0;bmb(Xa,c,c);bmb(Ya,Xa,c);Xlb(g,268435456);cmb(e,Ya,g);gb=jmb(e)|0;hb=Oa}Oa=Na<<1;d[946516+(Oa<<1)>>1]=gb;d[946516+((Oa|1)<<1)>>1]=hb;Na=Na+1|0}while((Na|0)!=256);Na=TC(147456)|0;hb=-8145;do{if((hb|0)<3391)ib=((hb*108|0)/841|0)+-290|0;else ib=(Y((Y(hb,hb)|0)>>>14,hb)|0)/16384|0;f[Na+(hb+8145<<2)>>2]=ib;hb=hb+1|0}while((hb|0)!=28719);f[126713]=Na;gmb(e,15);smb(c,491248,e);omb(_a,491240,c);gmb(h,3);smb(g,491256,h);omb($a,_a,g);nmb(Za,$a);f[ab>>2]=1065353216;f[g>>2]=872415232;$a=dmb(Za,g)|0;f[e>>2]=f[($a?Za:g)>>2];cmb(c,ab,e);f[Za>>2]=f[c>>2];Xlb(c,52);bmb(cb,Za,c);nmb(e,491240);bmb(bb,cb,e);Xlb(c,117);bmb(eb,Za,c);nmb(e,491248);bmb(db,eb,e);f[e>>2]=1065353216;Xlb(g,4);cmb(c,e,g);eb=TC(262144)|0;Za=TC(262144)|0;cb=TC(524288)|0;ab=0;do{Xlb(h,ab*100|0);cmb(g,h,503532);$a=ab<<8;_a=0;do{Xlb(j,_a);bmb(k,j,503504);cmb(l,k,503532);Zlb(i,l,503496);Xlb(o,9);bmb(q,g,bb);Zlb(p,i,q);bmb(m,o,p);Xlb(q,16);bmb(p,m,q);Na=jmb(p)|0;f[eb+(_a+$a<<2)>>2]=Na;_a=_a+1|0}while((_a|0)!=256);jb=0;do{Xlb(r,jb);bmb(s,r,503516);cmb(t,s,503532);Zlb(i,t,503508);bmb(q,g,db);Zlb(p,i,q);cmb(m,c,p);_a=dmb(m,c)|0;Na=f[c>>2]|0;if(_a)f[m>>2]=Na;f[p>>2]=Na^-2147483648;if(emb(m,p)|0)f[m>>2]=f[c>>2]^-2147483648;Xlb(q,16777216);bmb(p,m,q);Na=jmb(p)|0;_a=jb+$a|0;f[Za+(_a<<2)>>2]=Na;hb=Y(Na,ab)|0;Na=cbc(hb|0,((hb|0)<0)<<31>>31|0,249600,0)|0;hb=cb+(_a<<3)|0;f[hb>>2]=Na;f[hb+4>>2]=J;jb=jb+1|0}while((jb|0)!=256);ab=ab+1|0}while((ab|0)!=256);f[126714]=eb;f[126715]=Za;f[126716]=cb;cb=c;Za=cb+36|0;do{f[cb>>2]=0;cb=cb+4|0}while((cb|0)<(Za|0));cb=e;Za=cb+36|0;do{f[cb>>2]=0;cb=cb+4|0}while((cb|0)<(Za|0));cb=h;f[cb>>2]=0;f[cb+4>>2]=1072693248;tmb(g,h,491240);h=g+8|0;f[h>>2]=0;f[h+4>>2]=1072693248;h=i;f[h>>2]=0;f[h+4>>2]=1072693248;tmb(g+16|0,i,491256);i=0;do{h=i*3|0;cb=491096+(h<<3)|0;nmb(j,cb);Za=h+2|0;eb=e+(Za<<2)|0;if((j|0)!=(eb|0))f[eb>>2]=f[j>>2];eb=h+1|0;ab=491096+(eb<<3)|0;nmb(j,ab);jb=e+(eb<<2)|0;if((j|0)!=(jb|0))f[jb>>2]=f[j>>2];jb=491096+(Za<<3)|0;nmb(j,jb);$a=e+(h<<2)|0;if((j|0)!=($a|0))f[$a>>2]=f[j>>2];$a=g+(i<<3)|0;smb(k,jb,$a);nmb(j,k);jb=c+(h<<2)|0;if((j|0)!=(jb|0))f[jb>>2]=f[j>>2];smb(l,ab,$a);nmb(j,l);ab=c+(eb<<2)|0;if((j|0)!=(ab|0))f[ab>>2]=f[j>>2];smb(m,cb,$a);nmb(j,m);$a=c+(Za<<2)|0;if((j|0)!=($a|0))f[$a>>2]=f[j>>2];i=i+1|0}while((i|0)!=3);f[j>>2]=f[c>>2];f[o>>2]=f[c+4>>2];f[p>>2]=f[c+8>>2];f[q>>2]=f[c+12>>2];f[r>>2]=f[c+16>>2];f[s>>2]=f[c+20>>2];f[t>>2]=f[c+24>>2];f[v>>2]=f[c+28>>2];f[w>>2]=f[c+32>>2];f[x>>2]=f[e>>2];f[y>>2]=f[e+4>>2];f[z>>2]=f[e+8>>2];f[A>>2]=f[e+12>>2];f[B>>2]=f[e+16>>2];f[C>>2]=f[e+20>>2];f[D>>2]=f[e+24>>2];f[E>>2]=f[e+28>>2];f[F>>2]=f[e+32>>2];if((b[491392]|0)==0?Cac(491392)|0:0)Xlb(506868,32);if((b[491400]|0)==0?Cac(491400)|0:0)Xlb(506872,116);if((b[491408]|0)==0?Cac(491408)|0:0)Xlb(506876,16);if((b[491416]|0)==0?Cac(491416)|0:0)Xlb(506880,500);if((b[491424]|0)==0?Cac(491424)|0:0)Xlb(506884,200);if((b[491432]|0)==0?Cac(491432)|0:0)Xlb(506888,100);if((b[491440]|0)==0?Cac(491440)|0:0)Xlb(506892,128);if((b[491448]|0)==0?Cac(491448)|0:0)Xlb(506896,256);if((b[491456]|0)==0?Cac(491456)|0:0)Xlb(506900,16384);if((b[491464]|0)==0?Cac(491464)|0:0){Xlb(G,24389);Xlb(H,27);cmb(506904,G,H)}if((b[491472]|0)==0?Cac(491472)|0:0){Xlb(I,9);Xlb(H,4);cmb(506908,I,H)}if((b[491480]|0)==0?Cac(491480)|0:0)Xlb(506912,15);if((b[491488]|0)==0?Cac(491488)|0:0)Xlb(506916,3);I=H+8|0;G=H+4|0;f[G>>2]=107811;e=N5b(215622)|0;f[H>>2]=e;e=K+8|0;f[K>>2]=e;c=K+4|0;f[c>>2]=107811;i=N5b(215622)|0;f[K>>2]=i;i=0;do{m=i*3|0;l=0;do{k=(l*99|0)+m|0;g=0;do{$a=k+(g*3267|0)|0;Xlb(M,i);cmb(L,M,506868);Xlb(O,l);cmb(N,O,506868);Xlb(Q,g);cmb(P,Q,506868);f[S>>2]=f[L>>2];X$(R,S);f[L>>2]=f[R>>2];f[T>>2]=f[N>>2];X$(R,T);f[N>>2]=f[R>>2];f[U>>2]=f[P>>2];X$(R,U);f[P>>2]=f[R>>2];bmb(V,L,j);bmb(W,N,o);Zlb(X,V,W);bmb(Z,P,p);Zlb(R,X,Z);bmb(_,L,q);bmb(Z,N,r);Zlb($,_,Z);bmb(aa,P,s);Zlb(W,$,aa);bmb(ba,L,t);bmb(aa,N,v);Zlb(ca,ba,aa);bmb(da,P,w);Zlb(Z,ca,da);if(dmb(R,503520)|0)Amb(aa,R);else wmb(aa,R,503524,503528);if(dmb(W,503520)|0)Amb(da,W);else wmb(da,W,503524,503528);if(dmb(Z,503520)|0)Amb(ea,Z);else wmb(ea,Z,503524,503528);if(dmb(W,503520)|0){bmb(ga,506872,da);amb(fa,ga,506876)}else bmb(fa,506904,W);amb(ia,aa,da);bmb(ha,506880,ia);amb(ja,da,ea);bmb(ia,506884,ja);bmb(ka,506900,fa);cmb(ja,ka,506888);Za=(jmb(ja)|0)&65535;d[(f[H>>2]|0)+($a<<1)>>1]=Za;Zlb(la,ha,506892);bmb(ma,506900,la);cmb(ja,ma,506896);Za=(jmb(ja)|0)&65535;cb=$a+1|0;d[(f[H>>2]|0)+(cb<<1)>>1]=Za;Zlb(la,ia,506892);bmb(na,506900,la);cmb(ja,na,506896);Za=(jmb(ja)|0)&65535;ab=$a+2|0;d[(f[H>>2]|0)+(ab<<1)>>1]=Za;bmb(oa,L,x);bmb(W,N,y);Zlb(pa,oa,W);bmb(Z,P,z);Zlb(R,pa,Z);bmb(qa,L,A);bmb(Z,N,B);Zlb(ra,qa,Z);bmb(aa,P,C);Zlb(W,ra,aa);bmb(sa,L,D);bmb(aa,N,E);Zlb(ta,sa,aa);bmb(da,P,F);Zlb(Z,ta,da);if(emb(W,503520)|0)wmb(aa,W,503524,503528);else Amb(aa,W);bmb(ua,aa,506872);amb(da,ua,506876);f[aa>>2]=f[da>>2];Xlb(va,52);bmb(ha,506912,W);Zlb(wa,R,ha);bmb(ia,506916,Z);Zlb(fa,wa,ia);n[ja>>2]=1.1920928955078125e-07;Za=dmb(fa,ja)|0;f[ea>>2]=f[(Za?fa:ja)>>2];cmb(da,va,ea);bmb(xa,R,da);amb(fa,xa,bb);bmb(ea,aa,fa);bmb(ya,506908,W);bmb(za,ya,da);amb(ha,za,db);bmb(fa,aa,ha);bmb(Aa,506900,aa);cmb(ha,Aa,506888);Za=(jmb(ha)|0)&65535;d[(f[K>>2]|0)+($a<<1)>>1]=Za;amb(ia,ea,503496);bmb(Ba,506900,ia);cmb(ha,Ba,503504);Za=(jmb(ha)|0)&65535;d[(f[K>>2]|0)+(cb<<1)>>1]=Za;amb(ia,fa,503508);bmb(Ca,506900,ia);cmb(ha,Ca,503516);Za=(jmb(ha)|0)&65535;d[(f[K>>2]|0)+(ab<<1)>>1]=Za;g=g+1|0}while((g|0)<33);l=l+1|0}while((l|0)<33);i=i+1|0}while((i|0)<33);i=TC(1724976)|0;ha=TC(1724976)|0;Ca=f[H>>2]|0;ia=f[K>>2]|0;fa=0;do{Ba=fa*24|0;ea=0;do{Aa=(ea*792|0)+Ba|0;aa=ea;ea=ea+1|0;db=((ea|0)<32?ea:32)*99|0;za=aa*99|0;aa=0;do{da=Aa+(aa*26136|0)|0;ya=aa*3267|0;aa=aa+1|0;W=((aa|0)<32?aa:32)*3267|0;bb=0;do{xa=bb+fa|0;R=((xa|0)<32?xa:32)*3|0;xa=da+(bb<<2)|0;va=R+za|0;ja=va+ya|0;d[i+(xa<<1)>>1]=d[Ca+(ja<<1)>>1]|0;wa=ja+1|0;Z=xa+8|0;d[i+(Z<<1)>>1]=d[Ca+(wa<<1)>>1]|0;ua=ja+2|0;ta=xa+16|0;d[i+(ta<<1)>>1]=d[Ca+(ua<<1)>>1]|0;d[ha+(xa<<1)>>1]=d[ia+(ja<<1)>>1]|0;d[ha+(Z<<1)>>1]=d[ia+(wa<<1)>>1]|0;d[ha+(ta<<1)>>1]=d[ia+(ua<<1)>>1]|0;ua=va+W|0;va=xa|1;d[i+(va<<1)>>1]=d[Ca+(ua<<1)>>1]|0;ta=ua+1|0;wa=va+8|0;d[i+(wa<<1)>>1]=d[Ca+(ta<<1)>>1]|0;Z=ua+2|0;ja=va+16|0;d[i+(ja<<1)>>1]=d[Ca+(Z<<1)>>1]|0;d[ha+(va<<1)>>1]=d[ia+(ua<<1)>>1]|0;d[ha+(wa<<1)>>1]=d[ia+(ta<<1)>>1]|0;d[ha+(ja<<1)>>1]=d[ia+(Z<<1)>>1]|0;Z=R+db|0;R=xa|2;ja=Z+ya|0;d[i+(R<<1)>>1]=d[Ca+(ja<<1)>>1]|0;ta=ja+1|0;wa=R+8|0;d[i+(wa<<1)>>1]=d[Ca+(ta<<1)>>1]|0;ua=ja+2|0;va=R+16|0;d[i+(va<<1)>>1]=d[Ca+(ua<<1)>>1]|0;d[ha+(R<<1)>>1]=d[ia+(ja<<1)>>1]|0;d[ha+(wa<<1)>>1]=d[ia+(ta<<1)>>1]|0;d[ha+(va<<1)>>1]=d[ia+(ua<<1)>>1]|0;ua=Z+W|0;Z=xa|3;d[i+(Z<<1)>>1]=d[Ca+(ua<<1)>>1]|0;xa=ua+1|0;va=Z+8|0;d[i+(va<<1)>>1]=d[Ca+(xa<<1)>>1]|0;ta=ua+2|0;wa=Z+16|0;d[i+(wa<<1)>>1]=d[Ca+(ta<<1)>>1]|0;d[ha+(Z<<1)>>1]=d[ia+(ua<<1)>>1]|0;d[ha+(va<<1)>>1]=d[ia+(xa<<1)>>1]|0;d[ha+(wa<<1)>>1]=d[ia+(ta<<1)>>1]|0;bb=bb+1|0}while((bb|0)!=2)}while((aa|0)!=33)}while((ea|0)!=33);fa=fa+1|0}while((fa|0)!=33);fa=i;i=ha;ha=f[K>>2]|0;if((ha|0)!=(e|0)){if(ha|0)P5b(ha);f[K>>2]=e;f[c>>2]=520}c=f[H>>2]|0;if((c|0)!=(I|0)){if(c|0)P5b(c);f[H>>2]=I;f[G>>2]=520}f[122838]=fa;f[122839]=i;i=0;do{fa=i<<3;G=16-i<<16>>16;I=0;do{H=(I<<7)+fa|0;c=16-I<<16>>16;e=Y(c,G)|0;K=Y(I,G)|0;ha=Y(c,i)|0;c=Y(I,i)|0;ia=0;do{Ca=857428+(H+(ia<<11)<<1)|0;ea=16-ia<<16>>16;Ba=(Y(ea,e)|0)&65535;d[Ca>>1]=Ba;Ba=(Y(ia,e)|0)&65535;d[Ca+2>>1]=Ba;Ba=(Y(ea,K)|0)&65535;d[Ca+4>>1]=Ba;Ba=(Y(ia,K)|0)&65535;d[Ca+6>>1]=Ba;Ba=(Y(ea,ha)|0)&65535;d[Ca+8>>1]=Ba;Ba=(Y(ia,ha)|0)&65535;d[Ca+10>>1]=Ba;Ba=(Y(ea,c)|0)&65535;d[Ca+12>>1]=Ba;Ba=(Y(ia,c)|0)&65535;d[Ca+14>>1]=Ba;ia=ia+1|0}while((ia|0)!=16);I=I+1|0}while((I|0)!=16);i=i+1|0}while((i|0)!=16);b[1120380]=1;u=a;return}function O$(a){a=a|0;O5b(a);return}function P$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,50328);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){Q$(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function Q$(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0;g=u;u=u+32|0;h=g+16|0;i=g+12|0;j=g+8|0;k=g+4|0;l=g;m=f[a>>2]|0;o=b[a+48>>0]|0?f[126698]|0:0;p=+n[a+4>>2];q=+n[a+8>>2];r=+n[a+12>>2];t=+n[a+16>>2];v=+n[a+20>>2];w=+n[a+24>>2];x=+n[a+28>>2];y=+n[a+32>>2];z=+n[a+36>>2];A=e*3|0;if((e|0)<=0){u=g;return}e=(o|0)==0;B=f[126699]|0;C=a+40|0;D=a+44|0;a=c;c=0;while(1){E=f[a>>2]|0;f[h>>2]=E;F=f[a+4>>2]|0;f[i>>2]=F;G=f[a+8>>2]|0;f[j>>2]=G;n[k>>2]=0.0;H=(f[s>>2]=E,+n[s>>2])<0.0?k:h;n[l>>2]=1.0;E=f[(+n[H>>2]>1.0?l:H)>>2]|0;f[h>>2]=E;n[k>>2]=0.0;H=(f[s>>2]=F,+n[s>>2])<0.0?k:i;n[l>>2]=1.0;F=f[(+n[H>>2]>1.0?l:H)>>2]|0;f[i>>2]=F;n[k>>2]=0.0;H=(f[s>>2]=G,+n[s>>2])<0.0?k:j;n[l>>2]=1.0;G=f[(+n[H>>2]>1.0?l:H)>>2]|0;f[j>>2]=G;I=(f[s>>2]=E,+n[s>>2]);J=(f[s>>2]=F,+n[s>>2]);K=(f[s>>2]=G,+n[s>>2]);if(e){L=K;M=J;N=I}else{O=I*1024.0;G=~~O;F=(G|0)>0?G:0;G=(F|0)<1023?F:1023;I=O-+(G|0);F=o+(G<<2<<2)|0;O=+n[F>>2]+I*(+n[F+4>>2]+I*(+n[F+8>>2]+ +n[F+12>>2]*I));n[h>>2]=O;I=J*1024.0;F=~~I;G=(F|0)>0?F:0;F=(G|0)<1023?G:1023;J=I-+(F|0);G=o+(F<<2<<2)|0;I=+n[G>>2]+J*(+n[G+4>>2]+J*(+n[G+8>>2]+ +n[G+12>>2]*J));n[i>>2]=I;J=K*1024.0;G=~~J;F=(G|0)>0?G:0;G=(F|0)<1023?F:1023;K=J-+(G|0);F=o+(G<<2<<2)|0;J=+n[F>>2]+K*(+n[F+4>>2]+K*(+n[F+8>>2]+ +n[F+12>>2]*K));n[j>>2]=J;L=J;M=I;N=O}O=p*N+q*M+r*L;I=t*N+v*M+w*L;J=+n[125873]*I;F=~~J;G=(F|0)>0?F:0;F=(G|0)<1023?G:1023;K=J-+(F|0);G=B+(F<<2<<2)|0;J=(+n[G>>2]+K*(+n[G+4>>2]+K*(+n[G+8>>2]+ +n[G+12>>2]*K)))*116.0+-16.0;K=(x*N+y*M+z*L)*3.0+(O+I*15.0);P=52.0/(K<1.1920928955078125e-07?1.1920928955078125e-07:K);K=(O*P-+n[C>>2])*J;O=(I*2.25*P-+n[D>>2])*J;n[d+(c<<2)>>2]=J;n[d+(c+1<<2)>>2]=K;n[d+(c+2<<2)>>2]=O;c=c+3|0;if((c|0)>=(A|0))break;else a=a+(m<<2)|0}u=g;return}function R$(a){a=a|0;O5b(a);return}function S$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,50348);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){T$(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function T$(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0;g=u;u=u+3104|0;i=g;j=g+3088|0;k=g+3092|0;l=g+3084|0;m=g+3080|0;o=g+3076|0;p=g+3072|0;if(b[a+64>>0]|0){U$(a+56|0,c,d,e);u=g;return}q=f[a>>2]|0;if((e|0)>0){r=a+4|0;a=c;c=d;d=0;while(1){s=e-d|0;t=(s|0)<256?s:256;if((b[491304]|0)==0?Cac(491304)|0:0){f[j>>2]=1065353216;cmb(506804,j,503532)}v=t*3|0;w=(s|0)>0;if(w){x=+n[126701];s=0;y=a;while(1){n[i+(s<<2)>>2]=+(h[y>>0]|0)*x;n[i+(s+1<<2)>>2]=+(h[y+1>>0]|0)*x;n[i+(s+2<<2)>>2]=+(h[y+2>>0]|0)*x;s=s+3|0;z=y+q|0;if((s|0)>=(v|0)){A=z;break}else y=z}}else A=a;Q$(r,i,i,t);if((b[491312]|0)==0?Cac(491312)|0:0){Xlb(k,100);cmb(506808,503532,k)}if((b[491320]|0)==0?Cac(491320)|0:0)cmb(506812,503532,503504);if((b[491328]|0)==0?Cac(491328)|0:0)cmb(506816,503532,503516);if((b[491336]|0)==0?Cac(491336)|0:0){f[l>>2]=f[125874]^-2147483648;bmb(m,l,503532);cmb(506820,m,503504)}if((b[491344]|0)==0?Cac(491344)|0:0){f[o>>2]=f[125877]^-2147483648;bmb(p,o,503532);cmb(506824,p,503516)}if(w){y=0;do{s=LVb(+n[i+(y<<2)>>2]*+n[126702])|0;b[c+y>>0]=s>>>0<256?s:(s|0)>0?255:0;s=y+1|0;z=LVb(+n[i+(s<<2)>>2]*+n[126703]+ +n[126705])|0;b[c+s>>0]=z>>>0<256?z:(z|0)>0?255:0;z=y+2|0;s=LVb(+n[i+(z<<2)>>2]*+n[126704]+ +n[126706])|0;b[c+z>>0]=s>>>0<256?s:(s|0)>0?255:0;y=y+3|0}while((y|0)<(v|0))}d=d+256|0;if((d|0)>=(e|0))break;else{a=A;c=c+768|0}}}u=g;return}function U$(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;i=g+8|0;j=g+4|0;k=g;l=f[a>>2]|0;m=f[a+4>>2]|0;a=e*3|0;if((e|0)<=0){u=g;return}e=m^2;n=0;o=c;while(1){V$((h[o+m>>0]|0)<<6,(h[o+1>>0]|0)<<6,(h[o+e>>0]|0)<<6,f[122839]|0,i,j,k);c=f[i>>2]|0;p=(c|0)/64|0;b[d+n>>0]=p>>>0<256?p:(c|0)>63?255:0;c=f[j>>2]|0;p=(c|0)/64|0;b[d+(n+1)>>0]=p>>>0<256?p:(c|0)>63?255:0;c=f[k>>2]|0;p=(c|0)/64|0;b[d+(n+2)>>0]=p>>>0<256?p:(c|0)>63?255:0;n=n+3|0;if((n|0)>=(a|0))break;else o=o+l|0}u=g;return}function V$(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;j=u;u=u+96|0;k=j+64|0;l=j+32|0;m=j;n=e+(((b>>9)*792|0)+((a>>9)*24|0)+((c>>9)*26136|0)<<1)|0;f[k>>2]=d[n>>1];f[l>>2]=d[n+16>>1];f[m>>2]=d[n+32>>1];e=k+4|0;f[e>>2]=d[n+2>>1];o=l+4|0;f[o>>2]=d[n+18>>1];p=m+4|0;f[p>>2]=d[n+34>>1];q=k+8|0;f[q>>2]=d[n+4>>1];r=l+8|0;f[r>>2]=d[n+20>>1];s=m+8|0;f[s>>2]=d[n+36>>1];t=k+12|0;f[t>>2]=d[n+6>>1];v=l+12|0;f[v>>2]=d[n+22>>1];w=m+12|0;f[w>>2]=d[n+38>>1];x=k+16|0;f[x>>2]=d[n+8>>1];y=l+16|0;f[y>>2]=d[n+24>>1];z=m+16|0;f[z>>2]=d[n+40>>1];A=k+20|0;f[A>>2]=d[n+10>>1];B=l+20|0;f[B>>2]=d[n+26>>1];C=m+20|0;f[C>>2]=d[n+42>>1];D=k+24|0;f[D>>2]=d[n+12>>1];E=l+24|0;f[E>>2]=d[n+28>>1];F=m+24|0;f[F>>2]=d[n+44>>1];G=d[n+14>>1]|0;f[k+28>>2]=G;H=l+28|0;f[H>>2]=d[n+30>>1];I=m+28|0;f[I>>2]=d[n+46>>1];n=b<<2&1920|a>>>2&120|c<<6&30720;c=d[857428+(n<<1)>>1]|0;a=d[857428+((n|1)<<1)>>1]|0;b=d[857428+((n|2)<<1)>>1]|0;J=d[857428+((n|3)<<1)>>1]|0;K=d[857428+((n|4)<<1)>>1]|0;L=d[857428+((n|5)<<1)>>1]|0;M=d[857428+((n|6)<<1)>>1]|0;N=d[857428+((n|7)<<1)>>1]|0;n=Y(c,f[k>>2]|0)|0;k=(Y(a,f[e>>2]|0)|0)+n|0;n=k+(Y(b,f[q>>2]|0)|0)|0;q=n+(Y(J,f[t>>2]|0)|0)|0;t=q+(Y(K,f[x>>2]|0)|0)|0;x=t+(Y(L,f[A>>2]|0)|0)|0;A=x+(Y(M,f[D>>2]|0)|0)+(Y(N,G)|0)|0;f[g>>2]=A;A=Y(f[l>>2]|0,c)|0;l=(Y(f[o>>2]|0,a)|0)+A|0;A=l+(Y(f[r>>2]|0,b)|0)|0;r=A+(Y(f[v>>2]|0,J)|0)|0;v=r+(Y(f[y>>2]|0,K)|0)|0;y=v+(Y(f[B>>2]|0,L)|0)|0;B=y+(Y(f[E>>2]|0,M)|0)|0;E=B+(Y(f[H>>2]|0,N)|0)|0;f[h>>2]=E;E=Y(f[m>>2]|0,c)|0;c=(Y(f[p>>2]|0,a)|0)+E|0;E=c+(Y(f[s>>2]|0,b)|0)|0;b=E+(Y(f[w>>2]|0,J)|0)|0;J=b+(Y(f[z>>2]|0,K)|0)|0;K=J+(Y(L,f[C>>2]|0)|0)|0;C=K+(Y(M,f[F>>2]|0)|0)|0;F=C+(Y(N,f[I>>2]|0)|0)|0;f[i>>2]=F;f[g>>2]=(f[g>>2]|0)+2048>>12;f[h>>2]=(f[h>>2]|0)+2048>>12;f[i>>2]=(f[i>>2]|0)+2048>>12;u=j;return}function W$(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;b=u;u=u+64|0;c=b+56|0;d=b+52|0;e=b+48|0;g=b+44|0;h=b+40|0;i=b+36|0;j=b+32|0;k=b+24|0;l=b+20|0;m=b+28|0;o=b+16|0;p=b+12|0;q=b+4|0;r=b+8|0;s=b;t=TC(16384)|0;Xlb(c,2);Xlb(d,3);Xlb(e,4);Xlb(g,0);n[t+4>>2]=0.0;n[t>>2]=0.0;v=1;do{w=v;v=v+1|0;bmb(i,a+(w<<2)|0,c);amb(j,a+(v<<2)|0,i);x=w+-1|0;Zlb(k,j,a+(x<<2)|0);bmb(h,k,d);f[l>>2]=1065353216;y=x<<2;amb(m,e,t+(y<<2)|0);cmb(i,l,m);x=w<<2;w=t+(x<<2)|0;if((i|0)!=(w|0))f[w>>2]=f[i>>2];amb(o,h,t+((y|1)<<2)|0);bmb(m,o,i);y=t+((x|1)<<2)|0;if((m|0)!=(y|0))f[y>>2]=f[m>>2]}while((v|0)!=1024);v=0;do{o=1024-v|0;l=o+-1|0;e=l<<2;k=t+((e|1)<<2)|0;j=t+(e<<2)|0;bmb(i,j,g);amb(h,k,i);y=a+(l<<2)|0;amb(p,a+(o<<2)|0,y);bmb(q,h,c);Zlb(r,g,q);cmb(m,r,d);amb(i,p,m);amb(s,g,h);cmb(m,s,d);if((y|0)!=(j|0))f[j>>2]=f[y>>2];if((i|0)!=(k|0))f[k>>2]=f[i>>2];k=t+((e|2)<<2)|0;if((h|0)!=(k|0))f[k>>2]=f[h>>2];k=t+((e|3)<<2)|0;if((m|0)!=(k|0))f[k>>2]=f[m>>2];f[g>>2]=f[h>>2];v=v+1|0}while((v|0)!=1024);u=b;return t|0}function X$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+48|0;d=c+40|0;e=c+24|0;g=c+32|0;h=c+8|0;i=c+16|0;j=c;Ylb(d,b);if(vmb(d,491264)|0){tmb(e,d,491280);nmb(a,e);u=c;return}else{omb(h,d,491296);d=j;f[d>>2]=0;f[d+4>>2]=1072693248;omb(i,j,491296);tmb(g,h,i);zmb(e,g,491288);nmb(a,e);u=c;return}}function Y$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+64|0;d=c+56|0;e=c+40|0;g=c+48|0;h=c+24|0;i=c+16|0;j=c+32|0;k=c+8|0;l=c;Ylb(d,b);if(vmb(d,491272)|0){smb(e,d,491280);nmb(a,e);u=c;return}else{b=h;f[b>>2]=0;f[b+4>>2]=1072693248;tmb(g,h,491288);zmb(i,d,g);g=k;f[g>>2]=0;f[g+4>>2]=1072693248;omb(j,k,491296);smb(l,i,j);rmb(e,l,491296);nmb(a,e);u=c;return}}function Z$(a){a=a|0;O5b(a);return}function _$(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,50368);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){$$(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function $$(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0;g=u;u=u+32|0;h=g+16|0;i=g+12|0;j=g+8|0;k=g+4|0;l=g;m=f[a>>2]|0;o=f[a+44>>2]|0;p=b[a+40>>0]|0?f[126698]|0:0;q=+n[a+4>>2];r=+n[a+8>>2];s=+n[a+12>>2];t=+n[a+16>>2];v=+n[a+20>>2];w=+n[a+24>>2];x=+n[a+28>>2];y=+n[a+32>>2];z=+n[a+36>>2];A=e*3|0;if((b[a+41>>0]|0)!=0&(e|0)>0){e=o^2;a=f[122838]|0;B=0;C=c;while(1){D=+n[C+(o<<2)>>2];if(!(D<0.0))if(D>1.0)E=1.0;else E=D;else E=0.0;D=+n[C+4>>2];if(!(D<0.0))if(D>1.0)F=1.0;else F=D;else F=0.0;D=+n[C+(e<<2)>>2];if(!(D<0.0))if(D>1.0)G=1.0;else G=D;else G=0.0;H=LVb(E*16384.0)|0;I=LVb(F*16384.0)|0;V$(H,I,LVb(G*16384.0)|0,a,h,i,j);D=+(f[i>>2]|0)*.00006103515625;J=+(f[j>>2]|0)*.00006103515625;n[d+(B<<2)>>2]=+(f[h>>2]|0)*.00006103515625*100.0;n[d+(B+1<<2)>>2]=D*256.0+-128.0;n[d+(B+2<<2)>>2]=J*256.0+-128.0;I=B+3|0;H=C+(m<<2)|0;if((I|0)<(A|0)){B=I;C=H}else{K=H;L=I;break}}}else{K=c;L=0}if((b[491496]|0)==0?Cac(491496)|0:0){Xlb(k,16);Xlb(h,116);cmb(l,k,h);f[126730]=f[l>>2]}if((L|0)>=(A|0)){u=g;return}l=(p|0)==0;h=L;L=K;while(1){G=+n[L>>2];if(!(G<0.0))if(G>1.0)M=1.0;else M=G;else M=0.0;G=+n[L+4>>2];if(!(G<0.0))if(G>1.0)N=1.0;else N=G;else N=0.0;G=+n[L+8>>2];if(!(G<0.0))if(G>1.0)O=1.0;else O=G;else O=0.0;if(l){P=M;Q=N;R=O}else{G=M*1024.0;K=~~G;k=(K|0)>0?K:0;K=(k|0)<1023?k:1023;F=G-+(K|0);k=p+(K<<2<<2)|0;G=N*1024.0;K=~~G;c=(K|0)>0?K:0;K=(c|0)<1023?c:1023;E=G-+(K|0);c=p+(K<<2<<2)|0;G=O*1024.0;K=~~G;C=(K|0)>0?K:0;K=(C|0)<1023?C:1023;J=G-+(K|0);C=p+(K<<2<<2)|0;P=+n[k>>2]+F*(+n[k+4>>2]+F*(F*+n[k+12>>2]+ +n[k+8>>2]));Q=+n[c>>2]+E*(+n[c+4>>2]+E*(E*+n[c+12>>2]+ +n[c+8>>2]));R=+n[C>>2]+J*(+n[C+4>>2]+J*(J*+n[C+12>>2]+ +n[C+8>>2]))}J=s*R+(r*Q+q*P);E=w*R+(v*Q+t*P);F=z*R+(y*Q+x*P);if(J>.008856000378727913)S=+RO(J);else S=J*7.7870001792907715+ +n[126730];C=E>.008856000378727913;if(C)T=+RO(E);else T=E*7.7870001792907715+ +n[126730];if(F>.008856000378727913)U=+RO(F);else U=F*7.7870001792907715+ +n[126730];n[d+(h<<2)>>2]=C?T*116.0+-16.0:E*903.2999877929688;n[d+(h+1<<2)>>2]=(S-T)*500.0;n[d+(h+2<<2)>>2]=(T-U)*200.0;h=h+3|0;if((h|0)>=(A|0))break;else L=L+(m<<2)|0}u=g;return}function a0(a){a=a|0;O5b(a);return}function b0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;dQ(d,50388);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;a=e;while(1){c0(f[j>>2]|0,b,l,f[k>>2]|0);a=a+1|0;if((a|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function c0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=b[a+40>>0]|0?922964:923476;i=f[a>>2]|0;k=f[a+4>>2]|0;l=f[a+8>>2]|0;m=f[a+12>>2]|0;n=f[a+16>>2]|0;o=f[a+20>>2]|0;p=f[a+24>>2]|0;q=f[a+28>>2]|0;r=f[a+32>>2]|0;s=f[a+36>>2]|0;a=e*3|0;if((e|0)>0){t=0;u=c}else return;while(1){c=j[g+(h[u>>0]<<1)>>1]|0;e=j[g+(h[u+1>>0]<<1)>>1]|0;v=j[g+(h[u+2>>0]<<1)>>1]|0;w=940372+((Y(c,k)|0)+2048+(Y(e,l)|0)+(Y(v,m)|0)>>12<<1)|0;x=940372+((Y(c,n)|0)+2048+(Y(e,o)|0)+(Y(v,p)|0)>>12<<1)|0;y=j[x>>1]|0;x=940372+((Y(c,q)|0)+2048+(Y(e,r)|0)+(Y(v,s)|0)>>12<<1)|0;v=(y*296|0)+-1320550>>15;e=(((j[w>>1]|0)-y|0)*500|0)+4210688>>15;w=((y-(j[x>>1]|0)|0)*200|0)+4210688>>15;b[d+t>>0]=v>>>0<256?v:(v|0)>0?255:0;b[d+(t+1)>>0]=e>>>0<256?e:(e|0)>0?255:0;b[d+(t+2)>>0]=w>>>0<256?w:(w|0)>0?255:0;t=t+3|0;if((t|0)>=(a|0))break;else u=u+i|0}return}function d0(a,c,d,e,g,h,i,j,k,l,m){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0;n=u;u=u+160|0;o=n+144|0;p=n+112|0;q=n+104|0;r=n;dQ(q,50412);s=k?2:0;k=(i|0)==0;do if(l)if(k){e0(r,3,s,0,0,m);f0(r+56|0,j,s,0,0,m);f[r+100>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=50440;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;RQ(o,p,+(Y(h,g)|0)*.0000152587890625);break}else{e0(r,j,s,0,0,m);f[r+56>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=50460;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;RQ(o,p,+(Y(h,g)|0)*.0000152587890625);break}else if(k){f[r>>2]=j;g0(r+4|0,j,s,0,0,m);h0(r+56|0,j,s,0,0,m);b[r+100>>0]=1;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=50480;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;RQ(o,p,+(Y(h,g)|0)*.0000152587890625);break}else{g0(r,j,s,0,0,m);f[r+52>>2]=j;f[o>>2]=0;f[o+4>>2]=h;f[p>>2]=50500;f[p+4>>2]=a;f[p+8>>2]=c;f[p+12>>2]=d;f[p+16>>2]=e;f[p+20>>2]=g;f[p+24>>2]=r;RQ(o,p,+(Y(h,g)|0)*.0000152587890625);break}while(0);if(!(f[q+4>>2]|0)){u=n;return}u=n;return}function e0(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+96|0;j=i+48|0;k=i+24|0;l=i+16|0;m=i+8|0;o=i;q=i+80|0;r=i+76|0;s=i+72|0;f[a>>2]=c;b[a+40>>0]=h&1;h=a+52|0;f[h>>2]=d;N$();f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[122810];f[j+4>>2]=f[122811];f[j+8>>2]=f[122812];f[j+12>>2]=f[122813];f[j+16>>2]=f[122814];f[j+20>>2]=f[122815]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}g=k+8|0;d=k+16|0;if(e|0){c=k+8|0;t=k+16|0;p[k>>3]=+n[e>>2];p[c>>3]=+n[e+12>>2];p[t>>3]=+n[e+24>>2];smb(l,k,j);n[a+4+((f[h>>2]^2)*3<<2)>>2]=+p[l>>3];smb(m,g,j);n[a+16>>2]=+p[m>>3];smb(o,d,j);n[a+4+((f[h>>2]|0)*3<<2)>>2]=+p[o>>3];p[k>>3]=+n[e+4>>2];p[c>>3]=+n[e+16>>2];p[t>>3]=+n[e+28>>2];v=j+8|0;smb(l,k,v);n[a+4+(((f[h>>2]^2)*3|0)+1<<2)>>2]=+p[l>>3];smb(m,g,v);n[a+20>>2]=+p[m>>3];smb(o,d,v);n[a+4+(((f[h>>2]|0)*3|0)+1<<2)>>2]=+p[o>>3];p[k>>3]=+n[e+8>>2];p[c>>3]=+n[e+20>>2];p[t>>3]=+n[e+32>>2];e=j+16|0;smb(l,k,e);n[a+4+(((f[h>>2]^2)*3|0)+2<<2)>>2]=+p[l>>3];smb(m,g,e);n[a+24>>2]=+p[m>>3];smb(o,d,e);n[a+4+(((f[h>>2]|0)*3|0)+2<<2)>>2]=+p[o>>3];Xlb(q,8);w=f[q>>2]|0;x=a+44|0;f[x>>2]=w;Xlb(r,6);Xlb(k,29);cmb(s,r,k);y=f[s>>2]|0;z=a+48|0;f[z>>2]=y;u=i;return}e=0;do{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;t=491168+(e<<3)|0;if((t|0)!=(k|0)){c=t;t=f[c+4>>2]|0;v=k;f[v>>2]=f[c>>2];f[v+4>>2]=t}t=e+3|0;v=491168+(t<<3)|0;if((v|0)!=(g|0)){c=v;v=f[c+4>>2]|0;A=g;f[A>>2]=f[c>>2];f[A+4>>2]=v}v=491168+(e+6<<3)|0;if((v|0)!=(d|0)){A=v;v=f[A+4>>2]|0;c=d;f[c>>2]=f[A>>2];f[c+4>>2]=v}v=j+(e<<3)|0;smb(l,k,v);n[a+4+(((f[h>>2]^2)*3|0)+e<<2)>>2]=+p[l>>3];smb(m,g,v);n[a+4+(t<<2)>>2]=+p[m>>3];smb(o,d,v);n[a+4+(((f[h>>2]|0)*3|0)+e<<2)>>2]=+p[o>>3];e=e+1|0}while((e|0)!=3);Xlb(q,8);w=f[q>>2]|0;x=a+44|0;f[x>>2]=w;Xlb(r,6);Xlb(k,29);cmb(s,r,k);y=f[s>>2]|0;z=a+48|0;f[z>>2]=y;u=i;return}function f0(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+80|0;j=i+56|0;k=i+32|0;l=i+24|0;m=i+16|0;o=i+8|0;q=i;f[a>>2]=c;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[122810];f[j+4>>2]=f[122811];f[j+8>>2]=f[122812];f[j+12>>2]=f[122813];f[j+16>>2]=f[122814];f[j+20>>2]=f[122815]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}if((b[491560]|0)==0?Cac(491560)|0:0)gmb(491568,4096);g=d*3|0;c=k+8|0;r=k+16|0;s=(d^2)*3|0;if(e|0){d=k+8|0;t=k+16|0;v=0;do{p[k>>3]=+n[e+(v<<2)>>2];w=v+3|0;p[d>>3]=+n[e+(w<<2)>>2];p[t>>3]=+n[e+(v+6<<2)>>2];smb(m,491568,k);x=j+(v<<3)|0;smb(l,m,x);y=kmb(l)|0;f[a+4+(v+g<<2)>>2]=y;smb(o,491568,c);smb(l,o,x);y=kmb(l)|0;f[a+4+(w<<2)>>2]=y;smb(q,491568,r);smb(l,q,x);x=kmb(l)|0;f[a+4+(v+s<<2)>>2]=x;v=v+1|0}while((v|0)!=3);z=h?923988:932180;A=a+40|0;f[A>>2]=z;u=i;return}v=0;do{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;e=491168+(v<<3)|0;if((e|0)!=(k|0)){t=e;e=f[t+4>>2]|0;d=k;f[d>>2]=f[t>>2];f[d+4>>2]=e}e=v+3|0;d=491168+(e<<3)|0;if((d|0)!=(c|0)){t=d;d=f[t+4>>2]|0;x=c;f[x>>2]=f[t>>2];f[x+4>>2]=d}d=491168+(v+6<<3)|0;if((d|0)!=(r|0)){x=d;d=f[x+4>>2]|0;t=r;f[t>>2]=f[x>>2];f[t+4>>2]=d}smb(m,491568,k);d=j+(v<<3)|0;smb(l,m,d);t=kmb(l)|0;f[a+4+(v+g<<2)>>2]=t;smb(o,491568,c);smb(l,o,d);t=kmb(l)|0;f[a+4+(e<<2)>>2]=t;smb(q,491568,r);smb(l,q,d);d=kmb(l)|0;f[a+4+(v+s<<2)>>2]=d;v=v+1|0}while((v|0)!=3);z=h?923988:932180;A=a+40|0;f[A>>2]=z;u=i;return}function g0(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+112|0;j=i+48|0;k=i+100|0;l=i+40|0;m=i+24|0;o=i+32|0;q=i+16|0;r=i+8|0;s=i;t=i+96|0;v=i+92|0;w=i+88|0;x=i+84|0;y=i+80|0;z=i+76|0;A=i+72|0;f[a>>2]=c;b[a+48>>0]=h&1;N$();f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;if(!g){f[j>>2]=f[122810];f[j+4>>2]=f[122811];f[j+8>>2]=f[122812];f[j+12>>2]=f[122813];f[j+16>>2]=f[122814];f[j+20>>2]=f[122815]}else{p[j>>3]=+n[g>>2];p[j+8>>3]=+n[g+4>>2];p[j+16>>3]=+n[g+8>>2]}g=(d^2)*3|0;h=d*3|0;if(!e){nmb(k,491168);d=f[k>>2]|0;nmb(k,491192);c=f[k>>2]|0;nmb(k,491216);B=f[k>>2]|0;f[a+4+(g<<2)>>2]=d;f[a+16>>2]=c;f[a+4+(h<<2)>>2]=B;nmb(k,491176);B=f[k>>2]|0;nmb(k,491200);c=f[k>>2]|0;nmb(k,491224);d=f[k>>2]|0;f[a+4+(g+1<<2)>>2]=B;f[a+20>>2]=c;f[a+4+(h+1<<2)>>2]=d;nmb(k,491184);d=f[k>>2]|0;nmb(k,491208);c=f[k>>2]|0;nmb(k,491232);C=f[k>>2]|0;D=c;E=d}else{d=f[e+12>>2]|0;c=f[e+24>>2]|0;f[a+4+(g<<2)>>2]=f[e>>2];f[a+16>>2]=d;f[a+4+(h<<2)>>2]=c;c=f[e+16>>2]|0;d=f[e+28>>2]|0;f[a+4+(g+1<<2)>>2]=f[e+4>>2];f[a+20>>2]=c;f[a+4+(h+1<<2)>>2]=d;C=f[e+32>>2]|0;D=f[e+20>>2]|0;E=f[e+8>>2]|0}f[a+4+(g+2<<2)>>2]=E;f[a+24>>2]=D;f[a+4+(h+2<<2)>>2]=C;C=j+8|0;gmb(m,15);smb(l,C,m);omb(o,j,l);gmb(r,3);smb(q,j+16|0,r);omb(s,o,q);nmb(k,s);f[t>>2]=1065353216;f[q>>2]=872415232;s=dmb(k,q)|0;f[m>>2]=f[(s?k:q)>>2];cmb(l,t,m);f[k>>2]=f[l>>2];Xlb(v,52);bmb(w,v,k);nmb(l,j);bmb(x,w,l);f[a+40>>2]=f[x>>2];Xlb(y,117);bmb(z,y,k);nmb(l,C);bmb(A,z,l);f[a+44>>2]=f[A>>2];A=l;f[A>>2]=0;f[A+4>>2]=1072693248;if(umb(C,l)|0){u=i;return}f[l>>2]=0;f[l+4>>2]=0;C=aD(l,31)|0;A=225117;a=C+31|0;do{b[C>>0]=b[A>>0]|0;C=C+1|0;A=A+1|0}while((C|0)<(a|0));bO(-215,l,226120,217660,7871);bD(l);u=i;return}function h0(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0;g=u;u=u+32|0;i=g+8|0;j=g;f[a>>2]=c;N$();if((b[491544]|0)==0?Cac(491544)|0:0)gmb(491552,4096);c=d*3|0;k=i+8|0;l=i+16|0;m=(d^2)*3|0;if(!e){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;d=491168;o=f[d+4>>2]|0;q=i;f[q>>2]=f[d>>2];f[q+4>>2]=o;o=491192;q=f[o+4>>2]|0;d=k;f[d>>2]=f[o>>2];f[d+4>>2]=q;q=491216;d=f[q+4>>2]|0;o=l;f[o>>2]=f[q>>2];f[o+4>>2]=d;smb(j,491552,i);d=kmb(j)|0;f[a+4+(c<<2)>>2]=d;smb(j,491552,k);d=kmb(j)|0;f[a+16>>2]=d;smb(j,491552,l);d=kmb(j)|0;f[a+4+(m<<2)>>2]=d;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;d=491176;o=f[d+4>>2]|0;q=i;f[q>>2]=f[d>>2];f[q+4>>2]=o;o=491200;q=f[o+4>>2]|0;d=k;f[d>>2]=f[o>>2];f[d+4>>2]=q;q=491224;d=f[q+4>>2]|0;o=l;f[o>>2]=f[q>>2];f[o+4>>2]=d;smb(j,491552,i);d=kmb(j)|0;f[a+4+(c+1<<2)>>2]=d;smb(j,491552,k);d=kmb(j)|0;f[a+20>>2]=d;smb(j,491552,l);d=kmb(j)|0;f[a+4+(m+1<<2)>>2]=d;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;d=491184;o=f[d+4>>2]|0;q=i;f[q>>2]=f[d>>2];f[q+4>>2]=o;o=491208;q=f[o+4>>2]|0;d=k;f[d>>2]=f[o>>2];f[d+4>>2]=q;q=491232;d=f[q+4>>2]|0;o=l;f[o>>2]=f[q>>2];f[o+4>>2]=d;smb(j,491552,i);d=kmb(j)|0;f[a+4+(c+2<<2)>>2]=d;smb(j,491552,k);d=kmb(j)|0;f[a+24>>2]=d;smb(j,491552,l);d=kmb(j)|0;f[a+4+(m+2<<2)>>2]=d;r=h?923988:932180;s=a+40|0;f[s>>2]=r;u=g;return}else{p[i>>3]=+n[e>>2];d=i+8|0;p[d>>3]=+n[e+12>>2];o=i+16|0;p[o>>3]=+n[e+24>>2];smb(j,491552,i);q=kmb(j)|0;f[a+4+(c<<2)>>2]=q;smb(j,491552,k);q=kmb(j)|0;f[a+16>>2]=q;smb(j,491552,l);q=kmb(j)|0;f[a+4+(m<<2)>>2]=q;p[i>>3]=+n[e+4>>2];p[d>>3]=+n[e+16>>2];p[o>>3]=+n[e+28>>2];smb(j,491552,i);q=kmb(j)|0;f[a+4+(c+1<<2)>>2]=q;smb(j,491552,k);q=kmb(j)|0;f[a+20>>2]=q;smb(j,491552,l);q=kmb(j)|0;f[a+4+(m+1<<2)>>2]=q;p[i>>3]=+n[e+8>>2];p[d>>3]=+n[e+20>>2];p[o>>3]=+n[e+32>>2];smb(j,491552,i);i=kmb(j)|0;f[a+4+(c+2<<2)>>2]=i;smb(j,491552,k);k=kmb(j)|0;f[a+24>>2]=k;smb(j,491552,l);l=kmb(j)|0;f[a+4+(m+2<<2)>>2]=l;r=h?923988:932180;s=a+40|0;f[s>>2]=r;u=g;return}}function i0(a){a=a|0;O5b(a);return}function j0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,50512);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){k0(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function k0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0.0,r=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0;g=u;u=u+32|0;h=g+16|0;i=g+12|0;j=g+8|0;k=g+4|0;l=g;m=f[a>>2]|0;o=b[a+48>>0]|0?f[126708]|0:0;p=+n[a+4>>2];q=+n[a+8>>2];r=+n[a+12>>2];t=+n[a+16>>2];v=+n[a+20>>2];w=+n[a+24>>2];x=+n[a+28>>2];y=+n[a+32>>2];z=+n[a+36>>2];A=+n[a+40>>2];B=+n[a+44>>2];a=e*3|0;if((e|0)<=0){u=g;return}e=(o|0)==0;C=(m|0)==4;D=d;d=0;while(1){E=+n[c+(d<<2)>>2];if(!(E>=8.0))F=E*.001107051968574524;else{G=(E+16.0)*.008620689623057842;F=G*(G*G)}G=(+n[c+(d+1<<2)>>2]+A*E)*3.0;H=.25/(B*E+ +n[c+(d+2<<2)>>2]);I=H>.25?.25:H;H=I<-.25?-.25:I;I=H*(G*(F*3.0));J=((E*156.0-G)*H+-5.0)*F;H=r*J+(q*F+p*I);n[h>>2]=H;G=w*J+(v*F+t*I);n[i>>2]=G;E=z*J+(y*F+x*I);n[j>>2]=E;n[k>>2]=0.0;K=H<0.0?k:h;n[l>>2]=1.0;L=f[(+n[K>>2]>1.0?l:K)>>2]|0;f[h>>2]=L;n[k>>2]=0.0;K=G<0.0?k:i;n[l>>2]=1.0;M=f[(+n[K>>2]>1.0?l:K)>>2]|0;f[i>>2]=M;n[k>>2]=0.0;K=E<0.0?k:j;n[l>>2]=1.0;N=f[(+n[K>>2]>1.0?l:K)>>2]|0;f[j>>2]=N;if(e)O=L;else{E=(f[s>>2]=N,+n[s>>2]);G=(f[s>>2]=M,+n[s>>2]);H=(f[s>>2]=L,+n[s>>2])*1024.0;L=~~H;M=(L|0)>0?L:0;L=(M|0)<1023?M:1023;I=H-+(L|0);M=o+(L<<2<<2)|0;H=+n[M>>2]+I*(+n[M+4>>2]+I*(+n[M+8>>2]+ +n[M+12>>2]*I));n[h>>2]=H;I=G*1024.0;M=~~I;L=(M|0)>0?M:0;M=(L|0)<1023?L:1023;G=I-+(M|0);L=o+(M<<2<<2)|0;n[i>>2]=+n[L>>2]+G*(+n[L+4>>2]+G*(+n[L+8>>2]+ +n[L+12>>2]*G));G=E*1024.0;L=~~G;M=(L|0)>0?L:0;L=(M|0)<1023?M:1023;E=G-+(L|0);M=o+(L<<2<<2)|0;n[j>>2]=+n[M>>2]+E*(+n[M+4>>2]+E*(+n[M+8>>2]+ +n[M+12>>2]*E));O=(n[s>>2]=H,f[s>>2]|0)}f[D>>2]=O;f[D+4>>2]=f[i>>2];f[D+8>>2]=f[j>>2];if(C)n[D+12>>2]=1.0;d=d+3|0;if((d|0)>=(a|0))break;else D=D+(m<<2)|0}u=g;return}function l0(a){a=a|0;O5b(a);return}function m0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,50532);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){n0(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function n0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;g=u;u=u+3088|0;i=g;j=g+3072|0;if(b[a+100>>0]|0){o0(a+56|0,c,d,e);u=g;return}k=f[a>>2]|0;if((b[491520]|0)==0?Cac(491520)|0:0){Xlb(j,100);cmb(506940,j,503532)}if((b[491528]|0)==0?Cac(491528)|0:0)cmb(506944,503504,503532);if((b[491536]|0)==0?Cac(491536)|0:0)cmb(506948,503516,503532);if((e|0)>0){j=a+4|0;a=(k|0)==4;l=c;c=d;d=0;m=~e;while(1){o=(Y((m|0)>-257?m:-257,-3)|0)+-19|0;p=((o|0)>16?o:16)+-1&-16;o=p+16|0;q=e-d|0;r=(q|0)<256?q:256;s=+n[126735];t=+n[126736];v=+n[126737];w=+n[125874];x=+n[125877];q=r*3|0;y=q+-48|0;if((y|0)>0){z=0;while(1){A=l+z|0;B=b[A+4>>0]|0;C=b[A+5>>0]|0;D=b[A+6>>0]|0;E=b[A+7>>0]|0;F=b[A+8>>0]|0;G=b[A+9>>0]|0;H=b[A+10>>0]|0;I=b[A+11>>0]|0;J=b[A+12>>0]|0;K=b[A+13>>0]|0;L=b[A+14>>0]|0;M=b[A+15>>0]|0;N=i+(z<<2)|0;O=w+t*+(h[A+1>>0]|0);P=x+v*+(h[A+2>>0]|0);Q=s*+(h[A+3>>0]|0)+0.0;n[N>>2]=s*+(h[A>>0]|0)+0.0;n[N+4>>2]=O;n[N+8>>2]=P;n[N+12>>2]=Q;n[N+16>>2]=w+t*+(B&255);n[N+20>>2]=x+v*+(C&255);n[N+24>>2]=s*+(D&255)+0.0;n[N+28>>2]=w+t*+(E&255);n[N+32>>2]=x+v*+(F&255);n[N+36>>2]=s*+(G&255)+0.0;n[N+40>>2]=w+t*+(H&255);n[N+44>>2]=x+v*+(I&255);n[N+48>>2]=s*+(J&255)+0.0;n[N+52>>2]=w+t*+(K&255);n[N+56>>2]=x+v*+(L&255);n[N+60>>2]=s*+(M&255)+0.0;M=A+16|0;L=b[M+4>>0]|0;K=b[M+5>>0]|0;J=b[M+6>>0]|0;I=b[M+7>>0]|0;H=b[M+8>>0]|0;G=b[M+9>>0]|0;F=b[M+10>>0]|0;E=b[M+11>>0]|0;D=b[M+12>>0]|0;C=b[M+13>>0]|0;B=b[M+14>>0]|0;R=b[M+15>>0]|0;Q=x+v*+(h[M+1>>0]|0);P=s*+(h[M+2>>0]|0)+0.0;O=w+t*+(h[M+3>>0]|0);n[N+64>>2]=w+t*+(h[M>>0]|0);n[N+68>>2]=Q;n[N+72>>2]=P;n[N+76>>2]=O;n[N+80>>2]=x+v*+(L&255);n[N+84>>2]=s*+(K&255)+0.0;n[N+88>>2]=w+t*+(J&255);n[N+92>>2]=x+v*+(I&255);n[N+96>>2]=s*+(H&255)+0.0;n[N+100>>2]=w+t*+(G&255);n[N+104>>2]=x+v*+(F&255);n[N+108>>2]=s*+(E&255)+0.0;n[N+112>>2]=w+t*+(D&255);n[N+116>>2]=x+v*+(C&255);n[N+120>>2]=s*+(B&255)+0.0;n[N+124>>2]=w+t*+(R&255);R=A+32|0;A=b[R+4>>0]|0;B=b[R+5>>0]|0;C=b[R+6>>0]|0;D=b[R+7>>0]|0;E=b[R+8>>0]|0;F=b[R+9>>0]|0;G=b[R+10>>0]|0;H=b[R+11>>0]|0;I=b[R+12>>0]|0;J=b[R+13>>0]|0;K=b[R+14>>0]|0;L=b[R+15>>0]|0;O=s*+(h[R+1>>0]|0)+0.0;P=w+t*+(h[R+2>>0]|0);Q=x+v*+(h[R+3>>0]|0);n[N+128>>2]=x+v*+(h[R>>0]|0);n[N+132>>2]=O;n[N+136>>2]=P;n[N+140>>2]=Q;n[N+144>>2]=s*+(A&255)+0.0;n[N+148>>2]=w+t*+(B&255);n[N+152>>2]=x+v*+(C&255);n[N+156>>2]=s*+(D&255)+0.0;n[N+160>>2]=w+t*+(E&255);n[N+164>>2]=x+v*+(F&255);n[N+168>>2]=s*+(G&255)+0.0;n[N+172>>2]=w+t*+(H&255);n[N+176>>2]=x+v*+(I&255);n[N+180>>2]=s*+(J&255)+0.0;n[N+184>>2]=w+t*+(K&255);n[N+188>>2]=x+v*+(L&255);L=z+48|0;if((L|0)<(y|0))z=L;else{S=L;break}}}else S=0;if((S|0)<(q|0)){v=+n[126735];x=+n[126736];t=+n[125874];w=+n[126737];s=+n[125877];z=S;do{n[i+(z<<2)>>2]=+(h[l+z>>0]|0)*v;y=z+1|0;n[i+(y<<2)>>2]=+(h[l+y>>0]|0)*x+t;y=z+2|0;n[i+(y<<2)>>2]=+(h[l+y>>0]|0)*w+s;z=z+3|0}while((z|0)<(q|0))}k0(j,i,i,r);z=q+-16|0;if((q|0)>16){y=c+16|0;L=c;N=0;while(1){K=i+(N<<2)|0;s=+n[K+16>>2];w=+n[K+20>>2];t=+n[K+24>>2];x=+n[K+28>>2];v=+n[K+32>>2];Q=+n[K+36>>2];P=+n[K+40>>2];O=+n[K+44>>2];T=+n[K+48>>2];U=+n[K+52>>2];V=+n[K+56>>2];W=+n[K+60>>2];X=+n[K+4>>2]*255.0;Z=+n[K+8>>2]*255.0;_=+n[K+12>>2]*255.0;J=LVb(+n[K>>2]*255.0)|0;K=LVb(X)|0;I=LVb(Z)|0;H=LVb(_)|0;G=LVb(s*255.0)|0;F=LVb(w*255.0)|0;E=LVb(t*255.0)|0;D=LVb(x*255.0)|0;C=LVb(v*255.0)|0;B=LVb(Q*255.0)|0;A=LVb(P*255.0)|0;R=LVb(O*255.0)|0;M=LVb(T*255.0)|0;$=LVb(U*255.0)|0;aa=LVb(V*255.0)|0;ba=LVb(W*255.0)|0;ca=((J+32768|0)>>>0<65536?J:(J|0)>0?32767:32768)&65535;J=((C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768)&65535;C=((K+32768|0)>>>0<65536?K:(K|0)>0?32767:32768)&65535;K=((B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768)&65535;B=((I+32768|0)>>>0<65536?I:(I|0)>0?32767:32768)&65535;I=((A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768)&65535;A=((H+32768|0)>>>0<65536?H:(H|0)>0?32767:32768)&65535;H=((R+32768|0)>>>0<65536?R:(R|0)>0?32767:32768)&65535;R=((G+32768|0)>>>0<65536?G:(G|0)>0?32767:32768)&65535;G=((M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768)&65535;M=((F+32768|0)>>>0<65536?F:(F|0)>0?32767:32768)&65535;F=(($+32768|0)>>>0<65536?$:($|0)>0?32767:32768)&65535;$=((E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768)&65535;E=((aa+32768|0)>>>0<65536?aa:(aa|0)>0?32767:32768)&65535;aa=((D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768)&65535;D=((ba+32768|0)>>>0<65536?ba:(ba|0)>0?32767:32768)&65535;b[L>>0]=ca>>>0<255?ca:255;b[L+1>>0]=C>>>0<255?C:255;b[L+2>>0]=B>>>0<255?B:255;b[L+3>>0]=A>>>0<255?A:255;b[L+4>>0]=R>>>0<255?R:255;b[L+5>>0]=M>>>0<255?M:255;b[L+6>>0]=$>>>0<255?$:255;b[L+7>>0]=aa>>>0<255?aa:255;b[L+8>>0]=J>>>0<255?J:255;b[L+9>>0]=K>>>0<255?K:255;b[L+10>>0]=I>>>0<255?I:255;b[L+11>>0]=H>>>0<255?H:255;b[L+12>>0]=G>>>0<255?G:255;b[L+13>>0]=F>>>0<255?F:255;b[L+14>>0]=E>>>0<255?E:255;b[L+15>>0]=D>>>0<255?D:255;N=N+16|0;if((N|0)>=(z|0))break;else L=L+16|0}da=y+p|0;ea=o}else{da=c;ea=0}if((ea|0)<(q|0))if(a){L=da;z=ea;while(1){N=LVb(+n[i+(z<<2)>>2]*255.0)|0;b[L>>0]=N>>>0<256?N:(N|0)>0?255:0;N=LVb(+n[i+(z+1<<2)>>2]*255.0)|0;b[L+1>>0]=N>>>0<256?N:(N|0)>0?255:0;N=LVb(+n[i+(z+2<<2)>>2]*255.0)|0;b[L+2>>0]=N>>>0<256?N:(N|0)>0?255:0;b[L+3>>0]=-1;z=z+3|0;N=L+4|0;if((z|0)>=(q|0)){fa=N;break}else L=N}}else{L=da;z=ea;while(1){o=LVb(+n[i+(z<<2)>>2]*255.0)|0;b[L>>0]=o>>>0<256?o:(o|0)>0?255:0;o=LVb(+n[i+(z+1<<2)>>2]*255.0)|0;b[L+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=LVb(+n[i+(z+2<<2)>>2]*255.0)|0;b[L+2>>0]=o>>>0<256?o:(o|0)>0?255:0;z=z+3|0;o=L+k|0;if((z|0)>=(q|0)){fa=o;break}else L=o}}else fa=da;d=d+256|0;if((d|0)>=(e|0))break;else{l=l+768|0;c=fa;m=m+256|0}}}u=g;return}function o0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g+8|0;i=g+4|0;j=g;k=f[a>>2]|0;l=e*3|0;if((e|0)<=0){u=g;return}if((k|0)==4){e=0;m=d;while(1){p0(a,b[c+e>>0]|0,b[c+(e+1)>>0]|0,b[c+(e+2)>>0]|0,h,i,j);n=f[j>>2]|0;b[m>>0]=n>>>0<256?n:(n|0)>0?255:0;n=f[i>>2]|0;b[m+1>>0]=n>>>0<256?n:(n|0)>0?255:0;n=f[h>>2]|0;b[m+2>>0]=n>>>0<256?n:(n|0)>0?255:0;b[m+3>>0]=-1;e=e+3|0;if((e|0)>=(l|0))break;else m=m+4|0}u=g;return}else{m=0;e=d;while(1){p0(a,b[c+m>>0]|0,b[c+(m+1)>>0]|0,b[c+(m+2)>>0]|0,h,i,j);d=f[j>>2]|0;b[e>>0]=d>>>0<256?d:(d|0)>0?255:0;d=f[i>>2]|0;b[e+1>>0]=d>>>0<256?d:(d|0)>0?255:0;d=f[h>>2]|0;b[e+2>>0]=d>>>0<256?d:(d|0)>0?255:0;m=m+3|0;if((m|0)>=(l|0))break;else e=e+k|0}u=g;return}}function p0(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=b&255;b=d[946516+(k<<1<<1)>>1]|0;l=k<<8;k=f[(f[126714]|0)+((l|c&255)<<2)>>2]|0;c=e&255|l;l=f[(f[126715]|0)+(c<<2)>>2]|0;e=cbc(l|0,((l|0)<0)<<31>>31|0,k|0,((k|0)<0)<<31>>31|0)|0;k=J;l=abc(e|0,k|0,16384,0)|0;m=b&65535;n=Y(l,m)|0;l=(n|0)/16384|0;o=(f[126716]|0)+(c<<3)|0;c=f[o>>2]|0;p=f[o+4>>2]|0;o=cbc(e|0,k|0,-85,-1)|0;k=Kac(o|0,J|0,c|0,p|0)|0;p=abc(k|0,J|0,16384,0)|0;k=Kac(p|0,J|0,-20889600,-1)|0;p=cbc(k|0,J|0,b&65535|0,0)|0;b=abc(p|0,J|0,16384,0)|0;p=((b|0)/256|0)+((b|0)/65536|0)|0;b=(n|0)>16383?((l|0)<32768?l:32768):0;l=(p|0)>0?((p|0)<32768?p:32768):0;p=f[a+16>>2]|0;n=f[a+20>>2]|0;k=f[a+24>>2]|0;c=f[a+28>>2]|0;o=f[a+32>>2]|0;e=f[a+36>>2]|0;q=(Y(f[a+8>>2]|0,m)|0)+8192+(Y(b,f[a+4>>2]|0)|0)+(Y(l,f[a+12>>2]|0)|0)>>14;f[g>>2]=q;q=(Y(n,m)|0)+8192+(Y(b,p)|0)+(Y(l,k)|0)>>14;f[h>>2]=q;q=(Y(c,b)|0)+8192+(Y(o,m)|0)+(Y(l,e)|0)>>14;f[i>>2]=q;q=f[g>>2]|0;f[g>>2]=(q|0)>0?((q|0)<4095?q:4095):0;q=f[h>>2]|0;f[h>>2]=(q|0)>0?((q|0)<4095?q:4095):0;q=f[i>>2]|0;f[i>>2]=(q|0)>0?((q|0)<4095?q:4095):0;q=f[a+40>>2]|0;f[g>>2]=j[q+(f[g>>2]<<1)>>1];f[h>>2]=j[q+(f[h>>2]<<1)>>1];f[i>>2]=j[q+(f[i>>2]<<1)>>1];return}function q0(a){a=a|0;O5b(a);return}function r0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,50552);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){s0(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function s0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0;g=f[a>>2]|0;h=b[a+40>>0]|0?f[126708]|0:0;i=+n[a+4>>2];j=+n[a+8>>2];k=+n[a+12>>2];l=+n[a+16>>2];m=+n[a+20>>2];o=+n[a+24>>2];p=+n[a+28>>2];q=+n[a+32>>2];r=+n[a+36>>2];s=e*3|0;if((e|0)<=0)return;e=a+44|0;t=a+48|0;a=(h|0)==0;u=(g|0)==4;v=d;d=0;while(1){w=+n[c+(d<<2)>>2];if(!(w<=+n[e>>2])){x=(w+16.0)/116.0;y=x;z=x*(x*x)}else{x=w/903.2999877929688;y=x*7.7870001792907715+.13793103396892548;z=x}x=+n[c+(d+1<<2)>>2]/500.0+y;w=y-+n[c+(d+2<<2)>>2]/200.0;A=+n[t>>2];if(!(x<=A))B=x*(x*x);else B=(x+-.13793103396892548)/7.7870001792907715;if(!(w<=A))C=w*(w*w);else C=(w+-.13793103396892548)/7.7870001792907715;w=j*z+i*B+k*C;A=m*z+l*B+o*C;x=q*z+p*B+r*C;D=w<0.0?0.0:w>1.0?1.0:w;w=A<0.0?0.0:A>1.0?1.0:A;A=x<0.0?0.0:x>1.0?1.0:x;if(a){E=A;F=w;G=D}else{x=D*1024.0;H=~~x;I=(H|0)>0?H:0;H=(I|0)<1023?I:1023;D=x-+(H|0);I=h+(H<<2<<2)|0;x=w*1024.0;H=~~x;J=(H|0)>0?H:0;H=(J|0)<1023?J:1023;w=x-+(H|0);J=h+(H<<2<<2)|0;x=A*1024.0;H=~~x;K=(H|0)>0?H:0;H=(K|0)<1023?K:1023;A=x-+(H|0);K=h+(H<<2<<2)|0;E=+n[K>>2]+A*(+n[K+4>>2]+A*(A*+n[K+12>>2]+ +n[K+8>>2]));F=+n[J>>2]+w*(+n[J+4>>2]+w*(w*+n[J+12>>2]+ +n[J+8>>2]));G=+n[I>>2]+D*(+n[I+4>>2]+D*(D*+n[I+12>>2]+ +n[I+8>>2]))}n[v>>2]=G;n[v+4>>2]=F;n[v+8>>2]=E;if(u)n[v+12>>2]=1.0;d=d+3|0;if((d|0)>=(s|0))break;else v=v+(g<<2)|0}return}function t0(a){a=a|0;O5b(a);return}function u0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,50572);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){v0((f[j>>2]|0)+56|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function v0(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=u;u=u+16|0;h=g+8|0;i=g+4|0;j=g;k=f[a>>2]|0;l=e*3|0;if((e|0)<=0){u=g;return}if((k|0)==4){e=0;m=d;while(1){w0(a,b[c+e>>0]|0,b[c+(e+1)>>0]|0,b[c+(e+2)>>0]|0,h,i,j);n=f[j>>2]|0;b[m>>0]=n>>>0<256?n:(n|0)>0?255:0;n=f[i>>2]|0;b[m+1>>0]=n>>>0<256?n:(n|0)>0?255:0;n=f[h>>2]|0;b[m+2>>0]=n>>>0<256?n:(n|0)>0?255:0;b[m+3>>0]=-1;e=e+3|0;if((e|0)>=(l|0))break;else m=m+4|0}u=g;return}else{m=0;e=d;while(1){w0(a,b[c+m>>0]|0,b[c+(m+1)>>0]|0,b[c+(m+2)>>0]|0,h,i,j);d=f[j>>2]|0;b[e>>0]=d>>>0<256?d:(d|0)>0?255:0;d=f[i>>2]|0;b[e+1>>0]=d>>>0<256?d:(d|0)>0?255:0;d=f[h>>2]|0;b[e+2>>0]=d>>>0<256?d:(d|0)>0?255:0;m=m+3|0;if((m|0)>=(l|0))break;else e=e+k|0}u=g;return}}function w0(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0;i=(b&255)<<1;b=j[946516+((i|1)<<1)>>1]|0;k=f[126713]|0;l=f[k+(((((c&255)*268435|0)+128|0)>>>13)+-4194+b+8145<<2)>>2]|0;c=f[k+(10484-((((d&255)*41943|0)+16|0)>>>9)+b+8145<<2)>>2]|0;b=j[946516+(i<<1)>>1]|0;i=f[a+16>>2]|0;d=f[a+20>>2]|0;k=f[a+24>>2]|0;m=f[a+28>>2]|0;n=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(Y(f[a+4>>2]|0,l)|0)+8192+(Y(f[a+8>>2]|0,b)|0)+(Y(f[a+12>>2]|0,c)|0)>>14;f[e>>2]=p;p=(Y(i,l)|0)+8192+(Y(d,b)|0)+(Y(k,c)|0)>>14;f[g>>2]=p;p=(Y(m,l)|0)+8192+(Y(n,b)|0)+(Y(o,c)|0)>>14;f[h>>2]=p;p=f[e>>2]|0;f[e>>2]=(p|0)>0?((p|0)<4095?p:4095):0;p=f[g>>2]|0;f[g>>2]=(p|0)>0?((p|0)<4095?p:4095):0;p=f[h>>2]|0;f[h>>2]=(p|0)>0?((p|0)<4095?p:4095):0;p=f[a+40>>2]|0;f[e>>2]=j[p+(f[e>>2]<<1)>>1];f[g>>2]=j[p+(f[g>>2]<<1)>>1];f[h>>2]=j[p+(f[h>>2]<<1)>>1];return}function x0(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;m=u;u=u+48|0;n=m+16|0;o=m+8|0;p=m;dQ(p,50612);switch((k?20:0)+(j*100|0)+l|0){case 300:{f[n>>2]=50640;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;y0(n,o)}break}case 301:{f[n>>2]=50660;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;z0(n,o)}break}case 320:{f[n>>2]=50680;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;A0(n,o)}break}case 321:{f[n>>2]=50700;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;B0(n,o)}break}case 400:{f[n>>2]=50720;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;C0(n,o)}break}case 401:{f[n>>2]=50740;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;D0(n,o)}break}case 420:{f[n>>2]=50760;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;E0(n,o)}break}case 421:{f[n>>2]=50780;f[n+4>>2]=e;f[n+8>>2]=g;f[n+12>>2]=h;f[n+16>>2]=a;f[n+20>>2]=c;f[n+24>>2]=d;if((Y(i,h)|0)>76799){f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=(i|0)/2|0;F0(n,o)}break}default:{f[n>>2]=0;f[n+4>>2]=0;o=aD(n,41)|0;i=226549;h=o+41|0;do{b[o>>0]=b[i>>0]|0;o=o+1|0;i=i+1|0}while((o|0)<(h|0));bO(-206,n,226591,217660,10858);bD(n)}}if(!(f[p+4>>2]|0)){u=m;return}u=m;return}function y0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=(h[m+o>>0]|0)+-128|0;s=o|1;t=(h[m+s>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[d+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[d+s>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+3>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+s>>0]|0)+-16|0;s=Y((a|0)>0?a:0,1220542)|0;a=s+u>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+v>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+t>>20;b[r+3>>0]=a>>>0<256?a:(a|0)>0?255:0;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+6|0;r=r+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function z0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=o|1;s=(h[m+a>>0]|0)+-128|0;t=(h[m+o>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(s,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(s,2116026)|0)+524288|0;s=(h[d+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[d+a>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+3>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[p+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[p+a>>0]|0)+-16|0;a=Y((s|0)>0?s:0,1220542)|0;s=a+u>>20;b[r+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+v>>20;b[r+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+t>>20;b[r+3>>0]=s>>>0<256?s:(s|0)>0?255:0;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+6|0;r=r+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function A0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=(h[m+o>>0]|0)+-128|0;s=o|1;t=(h[m+s>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[d+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[d+s>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+3>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=(h[p+s>>0]|0)+-16|0;s=Y((a|0)>0?a:0,1220542)|0;a=s+u>>20;b[r+3>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+v>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+t>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+6|0;r=r+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function B0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=o|1;s=(h[m+a>>0]|0)+-128|0;t=(h[m+o>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(s,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(s,2116026)|0)+524288|0;s=(h[d+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[d+a>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+3>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[p+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=(h[p+a>>0]|0)+-16|0;a=Y((s|0)>0?s:0,1220542)|0;s=a+u>>20;b[r+3>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+v>>20;b[r+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+t>>20;b[r+5>>0]=s>>>0<256?s:(s|0)>0?255:0;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+6|0;r=r+6|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function C0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=(h[m+o>>0]|0)+-128|0;s=o|1;t=(h[m+s>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[d+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q>>0]=a>>>0<256?a:(a|0)>0?255:0;b[q+3>>0]=-1;a=(h[d+s>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+6>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+4>>0]=a>>>0<256?a:(a|0)>0?255:0;b[q+7>>0]=-1;a=(h[p+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+3>>0]=-1;a=(h[p+s>>0]|0)+-16|0;s=Y((a|0)>0?a:0,1220542)|0;a=s+u>>20;b[r+6>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+v>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+t>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+7>>0]=-1;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+8|0;r=r+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function D0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=o|1;s=(h[m+a>>0]|0)+-128|0;t=(h[m+o>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(s,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(s,2116026)|0)+524288|0;s=(h[d+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+3>>0]=-1;s=(h[d+a>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+6>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+4>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+7>>0]=-1;s=(h[p+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+3>>0]=-1;s=(h[p+a>>0]|0)+-16|0;a=Y((s|0)>0?s:0,1220542)|0;s=a+u>>20;b[r+6>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+v>>20;b[r+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+t>>20;b[r+4>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+7>>0]=-1;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+8|0;r=r+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function E0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=(h[m+o>>0]|0)+-128|0;s=o|1;t=(h[m+s>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(a,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(a,2116026)|0)+524288|0;a=(h[d+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+2>>0]=a>>>0<256?a:(a|0)>0?255:0;b[q+3>>0]=-1;a=(h[d+s>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[q+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[q+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[q+6>>0]=a>>>0<256?a:(a|0)>0?255:0;b[q+7>>0]=-1;a=(h[p+o>>0]|0)+-16|0;w=Y((a|0)>0?a:0,1220542)|0;a=w+u>>20;b[r>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+v>>20;b[r+1>>0]=a>>>0<256?a:(a|0)>0?255:0;a=w+t>>20;b[r+2>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+3>>0]=-1;a=(h[p+s>>0]|0)+-16|0;s=Y((a|0)>0?a:0,1220542)|0;a=s+u>>20;b[r+4>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+v>>20;b[r+5>>0]=a>>>0<256?a:(a|0)>0?255:0;a=s+t>>20;b[r+6>>0]=a>>>0<256?a:(a|0)>0?255:0;b[r+7>>0]=-1;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+8|0;r=r+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function F0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]<<1;e=f[c+4>>2]<<1;c=a+24|0;g=f[c>>2]|0;i=Y(g,d)|0;if((d|0)>=(e|0))return;j=a+4|0;k=a+8|0;l=a+12|0;m=(f[a+20>>2]|0)+(i>>>1)|0;n=d;d=(f[a+16>>2]|0)+i|0;i=g;g=f[l>>2]|0;while(1){a=f[j>>2]|0;o=f[k>>2]|0;p=d+i|0;if((g|0)>0){q=a+(Y(o,n)|0)|0;r=a+(Y(o,n|1)|0)|0;o=0;while(1){a=o|1;s=(h[m+a>>0]|0)+-128|0;t=(h[m+o>>0]|0)+-128|0;u=(Y(t,1673527)|0)+524288|0;v=(Y(s,-409993)|0)+524288+(Y(t,-852492)|0)|0;t=(Y(s,2116026)|0)+524288|0;s=(h[d+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+2>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+3>>0]=-1;s=(h[d+a>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[q+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[q+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[q+6>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+7>>0]=-1;s=(h[p+o>>0]|0)+-16|0;w=Y((s|0)>0?s:0,1220542)|0;s=w+u>>20;b[r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+v>>20;b[r+1>>0]=s>>>0<256?s:(s|0)>0?255:0;s=w+t>>20;b[r+2>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+3>>0]=-1;s=(h[p+a>>0]|0)+-16|0;a=Y((s|0)>0?s:0,1220542)|0;s=a+u>>20;b[r+4>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+v>>20;b[r+5>>0]=s>>>0<256?s:(s|0)>0?255:0;s=a+t>>20;b[r+6>>0]=s>>>0<256?s:(s|0)>0?255:0;b[r+7>>0]=-1;o=o+2|0;x=f[l>>2]|0;if((o|0)>=(x|0))break;else{q=q+8|0;r=r+8|0}}y=x;z=f[c>>2]|0}else{y=g;z=i}n=n+2|0;if((n|0)>=(e|0))break;else{m=m+z|0;d=d+(z<<1)|0;i=z;g=y}}return}function G0(a){a=a|0;O5b(a);return}function H0(a){a=a|0;O5b(a);return}function I0(a){a=a|0;O5b(a);return}function J0(a){a=a|0;O5b(a);return}function K0(a){a=a|0;O5b(a);return}function L0(a){a=a|0;O5b(a);return}function M0(a){a=a|0;O5b(a);return}function N0(a){a=a|0;O5b(a);return}function O0(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;l=u;u=u+64|0;m=l+16|0;n=l+8|0;o=l;dQ(o,50792);p=a+(Y(h,c)|0)|0;q=(h|0)%4|0;r=a+(Y(((h|0)/4|0)+h|0,c)|0)+(Y((q|0)/2|0,(g|0)/2|0)|0)|0;s=(q|0)==2;q=(k|0)==1;k=q?r:p;t=q?p:r;r=s&q&1;p=s&(q^1)&1;switch(((i*10|0)+-30+(j?2:0)|0)>>>1&2147483647|0){case 0:{f[m>>2]=50820;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=t;f[m+28>>2]=c;f[m+32>>2]=r;f[m+36>>2]=p;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;RQ(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;P0(m,n)}break}case 1:{f[m>>2]=50840;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=t;f[m+28>>2]=c;f[m+32>>2]=r;f[m+36>>2]=p;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;RQ(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;Q0(m,n)}break}case 5:{f[m>>2]=50860;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=t;f[m+28>>2]=c;f[m+32>>2]=r;f[m+36>>2]=p;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;RQ(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;R0(m,n)}break}case 6:{f[m>>2]=50880;f[m+4>>2]=d;f[m+8>>2]=e;f[m+12>>2]=g;f[m+16>>2]=a;f[m+20>>2]=k;f[m+24>>2]=t;f[m+28>>2]=c;f[m+32>>2]=r;f[m+36>>2]=p;if((Y(h,g)|0)>76799){f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;RQ(n,m,-1.0)}else{f[n>>2]=0;f[n+4>>2]=(h|0)/2|0;S0(m,n)}break}default:{f[m>>2]=0;f[m+4>>2]=0;n=aD(m,41)|0;h=226549;g=n+41|0;do{b[n>>0]=b[h>>0]|0;n=n+1|0;h=h+1|0}while((n|0)<(g|0));bO(-206,m,227154,217660,10885);bD(m)}}if(!(f[o+4>>2]|0)){u=l;return}u=l;return}function P0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=p;v=i;w=s;x=o;y=r;z=l;A=k;B=n;C=2}else{D=p;E=i;F=l;G=o;H=r;I=s;J=n;K=k}while(1){if((C|0)==2){C=0;D=t;E=v;F=z+1|0;G=x+1|0;H=y+(f[e+((z&1)<<2)>>2]|0)|0;I=w+(f[e+((x&1)<<2)>>2]|0)|0;J=B;K=A}if((E|0)>=(j|0))break;k=f[a+4>>2]|0;n=f[a+8>>2]|0;s=D+J|0;if((K|0)>1){r=k+(Y(n,E)|0)|0;o=k+(Y(n,E|1)|0)|0;n=0;while(1){k=(h[H+n>>0]|0)+-128|0;l=(h[I+n>>0]|0)+-128|0;i=(Y(l,1673527)|0)+524288|0;p=(Y(k,-409993)|0)+524288+(Y(l,-852492)|0)|0;l=(Y(k,2116026)|0)+524288|0;k=n<<1;g=(h[D+k>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+i>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+l>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=k|1;q=(h[D+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+i>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+l>>20;b[r+3>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+k>>0]|0)+-16|0;k=Y((q|0)>0?q:0,1220542)|0;q=k+i>>20;b[o+2>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+p>>20;b[o+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+l>>20;b[o>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+i>>20;b[o+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[o+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+l>>20;b[o+3>>0]=q>>>0<256?q:(q|0)>0?255:0;n=n+1|0;M=f[c>>2]|0;if((n|0)>=((M|0)/2|0|0))break;else{r=r+6|0;o=o+6|0}}N=M;O=f[m>>2]|0}else{N=K;O=J}t=D+(O<<1)|0;v=E+2|0;w=I;x=G;y=H;z=F;A=N;B=O;C=2}u=d;return}function Q0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=p;v=i;w=s;x=o;y=r;z=l;A=k;B=n;C=2}else{D=p;E=i;F=l;G=o;H=r;I=s;J=n;K=k}while(1){if((C|0)==2){C=0;D=t;E=v;F=z+1|0;G=x+1|0;H=y+(f[e+((z&1)<<2)>>2]|0)|0;I=w+(f[e+((x&1)<<2)>>2]|0)|0;J=B;K=A}if((E|0)>=(j|0))break;k=f[a+4>>2]|0;n=f[a+8>>2]|0;s=D+J|0;if((K|0)>1){r=k+(Y(n,E)|0)|0;o=k+(Y(n,E|1)|0)|0;n=0;while(1){k=(h[H+n>>0]|0)+-128|0;l=(h[I+n>>0]|0)+-128|0;i=(Y(l,1673527)|0)+524288|0;p=(Y(k,-409993)|0)+524288+(Y(l,-852492)|0)|0;l=(Y(k,2116026)|0)+524288|0;k=n<<1;g=(h[D+k>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+i>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+l>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;g=k|1;q=(h[D+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+i>>20;b[r+3>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+l>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+k>>0]|0)+-16|0;k=Y((q|0)>0?q:0,1220542)|0;q=k+i>>20;b[o>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+p>>20;b[o+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+l>>20;b[o+2>>0]=q>>>0<256?q:(q|0)>0?255:0;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+i>>20;b[o+3>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[o+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+l>>20;b[o+5>>0]=q>>>0<256?q:(q|0)>0?255:0;n=n+1|0;M=f[c>>2]|0;if((n|0)>=((M|0)/2|0|0))break;else{r=r+6|0;o=o+6|0}}N=M;O=f[m>>2]|0}else{N=K;O=J}t=D+(O<<1)|0;v=E+2|0;w=I;x=G;y=H;z=F;A=N;B=O;C=2}u=d;return}function R0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=p;v=i;w=s;x=o;y=r;z=l;A=k;B=n;C=2}else{D=p;E=i;F=l;G=o;H=r;I=s;J=n;K=k}while(1){if((C|0)==2){C=0;D=t;E=v;F=z+1|0;G=x+1|0;H=y+(f[e+((z&1)<<2)>>2]|0)|0;I=w+(f[e+((x&1)<<2)>>2]|0)|0;J=B;K=A}if((E|0)>=(j|0))break;k=f[a+4>>2]|0;n=f[a+8>>2]|0;s=D+J|0;if((K|0)>1){r=k+(Y(n,E)|0)|0;o=k+(Y(n,E|1)|0)|0;n=0;while(1){k=(h[H+n>>0]|0)+-128|0;l=(h[I+n>>0]|0)+-128|0;i=(Y(l,1673527)|0)+524288|0;p=(Y(k,-409993)|0)+524288+(Y(l,-852492)|0)|0;l=(Y(k,2116026)|0)+524288|0;k=n<<1;g=(h[D+k>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+i>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+l>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;b[r+3>>0]=-1;g=k|1;q=(h[D+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+i>>20;b[r+6>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+l>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;b[r+7>>0]=-1;q=(h[s+k>>0]|0)+-16|0;k=Y((q|0)>0?q:0,1220542)|0;q=k+i>>20;b[o+2>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+p>>20;b[o+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+l>>20;b[o>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+3>>0]=-1;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+i>>20;b[o+6>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[o+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+l>>20;b[o+4>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+7>>0]=-1;n=n+1|0;M=f[c>>2]|0;if((n|0)>=((M|0)/2|0|0))break;else{r=r+8|0;o=o+8|0}}N=M;O=f[m>>2]|0}else{N=K;O=J}t=D+(O<<1)|0;v=E+2|0;w=I;x=G;y=H;z=F;A=N;B=O;C=2}u=d;return}function S0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;i=g<<1;j=f[c+4>>2]<<1;c=a+12|0;k=f[c>>2]|0;l=(k|0)/2|0;f[e>>2]=l;m=a+28|0;n=f[m>>2]|0;f[e+4>>2]=n-l;l=f[a+32>>2]|0;o=f[a+36>>2]|0;p=(f[a+16>>2]|0)+(Y(n,i)|0)|0;q=Y((g|0)/2|0,n)|0;r=(f[a+20>>2]|0)+q|0;s=(f[a+24>>2]|0)+q|0;if(((g|0)%2|0|0)==1){t=p;v=i;w=s;x=o;y=r;z=l;A=k;B=n;C=2}else{D=p;E=i;F=l;G=o;H=r;I=s;J=n;K=k}while(1){if((C|0)==2){C=0;D=t;E=v;F=z+1|0;G=x+1|0;H=y+(f[e+((z&1)<<2)>>2]|0)|0;I=w+(f[e+((x&1)<<2)>>2]|0)|0;J=B;K=A}if((E|0)>=(j|0))break;k=f[a+4>>2]|0;n=f[a+8>>2]|0;s=D+J|0;if((K|0)>1){r=k+(Y(n,E)|0)|0;o=k+(Y(n,E|1)|0)|0;n=0;while(1){k=(h[H+n>>0]|0)+-128|0;l=(h[I+n>>0]|0)+-128|0;i=(Y(l,1673527)|0)+524288|0;p=(Y(k,-409993)|0)+524288+(Y(l,-852492)|0)|0;l=(Y(k,2116026)|0)+524288|0;k=n<<1;g=(h[D+k>>0]|0)+-16|0;q=Y((g|0)>0?g:0,1220542)|0;g=q+i>>20;b[r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+p>>20;b[r+1>>0]=g>>>0<256?g:(g|0)>0?255:0;g=q+l>>20;b[r+2>>0]=g>>>0<256?g:(g|0)>0?255:0;b[r+3>>0]=-1;g=k|1;q=(h[D+g>>0]|0)+-16|0;L=Y((q|0)>0?q:0,1220542)|0;q=L+i>>20;b[r+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+p>>20;b[r+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=L+l>>20;b[r+6>>0]=q>>>0<256?q:(q|0)>0?255:0;b[r+7>>0]=-1;q=(h[s+k>>0]|0)+-16|0;k=Y((q|0)>0?q:0,1220542)|0;q=k+i>>20;b[o>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+p>>20;b[o+1>>0]=q>>>0<256?q:(q|0)>0?255:0;q=k+l>>20;b[o+2>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+3>>0]=-1;q=(h[s+g>>0]|0)+-16|0;g=Y((q|0)>0?q:0,1220542)|0;q=g+i>>20;b[o+4>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+p>>20;b[o+5>>0]=q>>>0<256?q:(q|0)>0?255:0;q=g+l>>20;b[o+6>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+7>>0]=-1;n=n+1|0;M=f[c>>2]|0;if((n|0)>=((M|0)/2|0|0))break;else{r=r+8|0;o=o+8|0}}N=M;O=f[m>>2]|0}else{N=K;O=J}t=D+(O<<1)|0;v=E+2|0;w=I;x=G;y=H;z=F;A=N;B=O;C=2}u=d;return}function T0(a){a=a|0;O5b(a);return}function U0(a){a=a|0;O5b(a);return}function V0(a){a=a|0;O5b(a);return}function W0(a){a=a|0;O5b(a);return}function X0(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=u;u=u+64|0;m=l+48|0;n=l;o=l+8|0;dQ(n,50892);p=d+(Y(h,e)|0)|0;f[o>>2]=50920;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=p;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;b[o+36>>0]=j&1;b[o+37>>0]=(k|0)==2&1;b[o+38>>0]=0;if((Y(h,g)|0)>76799){f[m>>2]=0;f[m+4>>2]=(h|0)/2|0;RQ(m,o,-1.0)}else{f[m>>2]=0;f[m+4>>2]=(h|0)/2|0;Y0(o,m)}if(!(f[n+4>>2]|0)){u=l;return}u=l;return}function Y0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=f[a+24>>2]|0;e=f[a+32>>2]|0;g=f[c>>2]|0;i=c+4|0;c=f[i>>2]|0;if((g|0)>=(c|0))return;j=a+4|0;k=a+8|0;l=a+36|0;m=a+12|0;n=a+20|0;o=a+38|0;p=a+16|0;q=(d|0)/2|0;r=(f[a+28>>2]|0)/2|0;s=a+37|0;a=Y(e,d)|0;d=(a|0)>0;t=e<<1;u=g;g=c;while(1){c=f[j>>2]|0;v=f[k>>2]|0;w=u<<1;x=c+(Y(v,w)|0)|0;y=x;z=x+1|0;A=x+2|0;x=c+(Y(v,w|1)|0)|0;v=x;c=x+1|0;B=x+2|0;x=(b[l>>0]|0)==0;C=f[n>>2]|0;D=(f[m>>2]|0)+(Y(C,w)|0)|0;w=f[p>>2]|0;if(!(b[o>>0]|0)){E=u+r|0;F=w+(Y(C,(u|0)/2|0)|0)+(Y((u|0)%2|0,q)|0)|0;G=w+(Y(C,(E|0)/2|0)|0)+(Y((E|0)%2|0,q)|0)|0}else{E=w+(Y(C,u)|0)|0;F=E;G=E+1|0}E=F;C=G;w=(b[s>>0]|0)==0;if(d){H=x?A:y;I=x?y:A;A=x?B:v;y=x?v:B;B=w?E:C;v=w?C:E;E=0;C=0;while(1){w=h[H+E>>0]|0;x=h[z+E>>0]|0;J=h[I+E>>0]|0;K=E+e|0;L=(w*269484|0)+17301504+(x*528482|0)+(J*102760|0)|0;M=((h[H+K>>0]|0)*269484|0)+17301504+((h[z+K>>0]|0)*528482|0)+((h[I+K>>0]|0)*102760|0)|0;N=((h[A+E>>0]|0)*269484|0)+17301504+((h[c+E>>0]|0)*528482|0)+((h[y+E>>0]|0)*102760|0)|0;O=((h[A+K>>0]|0)*269484|0)+17301504+((h[c+K>>0]|0)*528482|0)+((h[y+K>>0]|0)*102760|0)|0;K=L>>>20;P=C<<1;b[D+P>>0]=L>>>0<268435456?K:K|0?255:0;K=M>>>20;L=P|1;b[D+L>>0]=M>>>0<268435456?K:K|0?255:0;K=N>>>20;b[D+((f[n>>2]|0)+P)>>0]=N>>>0<268435456?K:K|0?255:0;K=O>>>20;b[D+(L+(f[n>>2]|0))>>0]=O>>>0<268435456?K:K|0?255:0;K=(Y(w,-155188)|0)+134742016+(Y(x,-305135)|0)+(J*460324|0)|0;O=(w*460324|0)+134742016+(Y(x,-385875)|0)+(Y(J,-74448)|0)|0;J=K>>20;K=O>>20;O=(b[o>>0]|0)==0?C:P;b[B+O>>0]=J>>>0<256?J:(J|0)>0?255:0;b[v+O>>0]=K>>>0<256?K:(K|0)>0?255:0;E=E+t|0;if((E|0)>=(a|0))break;else C=C+1|0}Q=f[i>>2]|0}else Q=g;u=u+1|0;if((u|0)>=(Q|0))break;else g=Q}return}function Z0(a){a=a|0;O5b(a);return}function _0(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0;m=u;u=u+48|0;n=m+16|0;o=m+8|0;p=m;dQ(p,50932);do switch((j?200:0)+(i*1e3|0)+(k*10|0)+l|0){case 3e3:{f[n>>2]=50960;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;$0(n,o)}break}case 3001:{f[n>>2]=50980;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;a1(n,o)}break}case 3010:{f[n>>2]=51e3;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;b1(n,o)}break}case 3200:{f[n>>2]=51020;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;c1(n,o)}break}case 3201:{f[n>>2]=51040;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;d1(n,o)}break}case 3210:{f[n>>2]=51060;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;e1(n,o)}break}case 4e3:{f[n>>2]=51080;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;f1(n,o)}break}case 4001:{f[n>>2]=51100;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;g1(n,o)}break}case 4010:{f[n>>2]=51120;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;h1(n,o)}break}case 4200:{f[n>>2]=51140;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;i1(n,o)}break}case 4201:{f[n>>2]=51160;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;j1(n,o)}break}case 4210:{f[n>>2]=51180;f[n+4>>2]=d;f[n+8>>2]=e;f[n+12>>2]=a;f[n+16>>2]=c;f[n+20>>2]=g;if((Y(h,g)|0)>76799){f[o>>2]=0;f[o+4>>2]=h;RQ(o,n,-1.0)}else{f[o>>2]=0;f[o+4>>2]=h;k1(n,o)}break}default:{f[n>>2]=0;f[n+4>>2]=0;q=aD(n,41)|0;r=226549;s=q+41|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-206,n,227554,217660,10935);bD(n)}}while(0);if(!(f[p+4>>2]|0)){u=m;return}u=m;return}function $0(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|1)>>0]|0)+-128|0;p=(h[d+(n|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function a1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+n>>0]|0)+-128|0;p=(h[d+(n|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(n|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function b1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|3)>>0]|0)+-128|0;p=(h[d+(n|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function c1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|1)>>0]|0)+-128|0;p=(h[d+(n|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function d1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+n>>0]|0)+-128|0;p=(h[d+(n|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(n|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function e1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|3)>>0]|0)+-128|0;p=(h[d+(n|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+3>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+6|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function f1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|1)>>0]|0)+-128|0;p=(h[d+(n|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function g1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+n>>0]|0)+-128|0;p=(h[d+(n|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(n|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function h1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|3)>>0]|0)+-128|0;p=(h[d+(n|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function i1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|1)>>0]|0)+-128|0;p=(h[d+(n|3)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function j1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+n>>0]|0)+-128|0;p=(h[d+(n|2)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+(n|1)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|3)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function k1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=a+16|0;if((d|0)>=(e|0))return;g=f[c>>2]|0;i=(f[a+12>>2]|0)+(Y(g,d)|0)|0;j=a+4|0;k=a+8|0;l=a+20|0;a=d;d=i;i=g;g=f[l>>2]|0;while(1){if((g|0)>0){m=(f[j>>2]|0)+(Y(f[k>>2]|0,a)|0)|0;n=0;while(1){o=(h[d+(n|3)>>0]|0)+-128|0;p=(h[d+(n|1)>>0]|0)+-128|0;q=(Y(p,1673527)|0)+524288|0;r=(Y(o,-409993)|0)+524288+(Y(p,-852492)|0)|0;p=(Y(o,2116026)|0)+524288|0;o=(h[d+n>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+1>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+2>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+3>>0]=-1;o=(h[d+(n|2)>>0]|0)+-16|0;s=Y((o|0)>0?o:0,1220542)|0;o=s+q>>20;b[m+4>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+r>>20;b[m+5>>0]=o>>>0<256?o:(o|0)>0?255:0;o=s+p>>20;b[m+6>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+7>>0]=-1;n=n+4|0;t=f[l>>2]|0;if((n|0)>=(t<<1|0))break;else m=m+8|0}u=t;v=f[c>>2]|0}else{u=g;v=i}a=a+1|0;if((a|0)==(e|0))break;else{d=d+v|0;i=v;g=u}}return}function l1(a){a=a|0;O5b(a);return}function m1(a){a=a|0;O5b(a);return}function n1(a){a=a|0;O5b(a);return}function o1(a){a=a|0;O5b(a);return}function p1(a){a=a|0;O5b(a);return}function q1(a){a=a|0;O5b(a);return}function r1(a){a=a|0;O5b(a);return}function s1(a){a=a|0;O5b(a);return}function t1(a){a=a|0;O5b(a);return}function u1(a){a=a|0;O5b(a);return}function v1(a){a=a|0;O5b(a);return}function w1(a){a=a|0;O5b(a);return}function x1(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+64|0;i=h+40|0;j=h+8|0;k=h;dQ(k,51192);f[i>>2]=0;f[i+4>>2]=g;f[j>>2]=51220;f[j+4>>2]=a;f[j+8>>2]=b;f[j+12>>2]=c;f[j+16>>2]=d;f[j+20>>2]=e;f[j+24>>2]=h+48;RQ(i,j,+(Y(g,e)|0)*.0000152587890625);if(!(f[k+4>>2]|0)){u=h;return}u=h;return}function y1(a){a=a|0;O5b(a);return}function z1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;dQ(e,51232);g=f[c>>2]|0;i=a+8|0;j=a+16|0;k=c+4|0;c=f[k>>2]|0;if((g|0)<(c|0)){l=f[j>>2]|0;m=(f[a+12>>2]|0)+(Y(l,g)|0)|0;n=f[i>>2]|0;o=a+20|0;p=m;m=(f[a+4>>2]|0)+(Y(n,g)|0)|0;a=g;g=c;c=l;l=n;while(1){n=f[o>>2]|0;if((n|0)>0){q=p;r=0;s=m;while(1){t=b[s+1>>0]|0;v=b[s+2>>0]|0;w=b[s+3>>0]|0;x=w&255;y=((((Y(x,h[s>>0]|0)|0)+128|0)>>>0)/255|0)&255;b[q>>0]=y;y=((((Y(x,t&255)|0)+128|0)>>>0)/255|0)&255;b[q+1>>0]=y;y=((((Y(x,v&255)|0)+128|0)>>>0)/255|0)&255;b[q+2>>0]=y;b[q+3>>0]=w;r=r+1|0;if((r|0)==(n|0))break;else{q=q+4|0;s=s+4|0}}z=f[i>>2]|0;A=f[j>>2]|0;B=f[k>>2]|0}else{z=l;A=c;B=g}a=a+1|0;if((a|0)>=(B|0))break;else{p=p+A|0;m=m+z|0;g=B;c=A;l=z}}}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function A1(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+64|0;i=h+40|0;j=h+8|0;k=h;dQ(k,51252);f[i>>2]=0;f[i+4>>2]=g;f[j>>2]=51280;f[j+4>>2]=a;f[j+8>>2]=b;f[j+12>>2]=c;f[j+16>>2]=d;f[j+20>>2]=e;f[j+24>>2]=h+48;RQ(i,j,+(Y(g,e)|0)*.0000152587890625);if(!(f[k+4>>2]|0)){u=h;return}u=h;return}function B1(a){a=a|0;O5b(a);return}function C1(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+16|0;e=d;dQ(e,51292);g=f[c>>2]|0;i=a+8|0;j=a+16|0;k=c+4|0;c=f[k>>2]|0;if((g|0)<(c|0)){l=f[j>>2]|0;m=(f[a+12>>2]|0)+(Y(l,g)|0)|0;n=f[i>>2]|0;o=a+20|0;p=m;m=(f[a+4>>2]|0)+(Y(n,g)|0)|0;a=g;g=c;c=l;l=n;while(1){n=f[o>>2]|0;if((n|0)>0){q=p;r=0;s=m;while(1){t=b[s+3>>0]|0;v=t&255;if(!(t<<24>>24)){b[q>>0]=0;w=0;x=0}else{y=b[s+2>>0]|0;z=b[s+1>>0]|0;A=(t&255)>>>1&255;b[q>>0]=((((h[s>>0]|0)*255|0)+A|0)>>>0)/(v>>>0)|0;w=(((((z&255)*255|0)+A|0)>>>0)/(v>>>0)|0)&255;x=((((y&255)*255|0)+A|0)>>>0)/(v>>>0)|0}b[q+1>>0]=w;b[q+2>>0]=x;b[q+3>>0]=t;r=r+1|0;if((r|0)==(n|0))break;else{q=q+4|0;s=s+4|0}}B=f[i>>2]|0;C=f[j>>2]|0;D=f[k>>2]|0}else{B=l;C=c;D=g}a=a+1|0;if((a|0)>=(D|0))break;else{p=p+C|0;m=m+B|0;g=D;c=C;l=B}}}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function D1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0;g=u;u=u+416|0;h=g+8|0;i=g;j=g+408|0;k=g+352|0;l=g+288|0;m=g+344|0;n=g+280|0;o=g+272|0;p=g+264|0;q=g+256|0;r=g+248|0;s=g+240|0;t=g+232|0;v=g+224|0;w=g+216|0;x=g+208|0;y=g+200|0;z=g+192|0;A=g+184|0;B=g+176|0;C=g+168|0;D=g+160|0;E=g+152|0;F=g+96|0;G=g+88|0;H=g+80|0;I=g+72|0;J=g+64|0;dQ(j,51312);K=BL(a,-1)|0;L=K>>>3;M=L&511;N=M+1|0;O=K&7;f[k>>2]=1124007936;P=k+4|0;Q=k+8|0;R=k+40|0;S=P;T=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(T|0));f[R>>2]=Q;U=k+48|0;V=k+44|0;f[V>>2]=U;f[U>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;W=l+4|0;X=l+8|0;Z=l+40|0;S=W;T=S+36|0;do{f[S>>2]=0;S=S+4|0}while((S|0)<(T|0));f[Z>>2]=X;_=l+48|0;$=l+44|0;f[$>>2]=_;f[_>>2]=0;f[l+52>>2]=0;aa=a+4|0;ba=c+4|0;if((f[aa>>2]|0)!=(f[ba>>2]|0)){do if((yM(a)|0)==65536){ca=f[aa>>2]|0;f[h>>2]=f[ca>>2];da=h+4|0;ea=ca+4|0;f[da>>2]=f[ea>>2];fa=h+8|0;f[fa>>2]=f[ca+8>>2];f[h+12>>2]=f[ca+12>>2];f[h+16>>2]=f[ca+16>>2];f[h+20>>2]=f[ca+20>>2];f[h+24>>2]=f[ca+24>>2];f[h+28>>2]=f[ca+28>>2];f[h+32>>2]=f[ca+32>>2];ga=h+36|0;ha=f[ca+36>>2]|0;f[ga>>2]=ha;f[h+40>>2]=fa;fa=h+48|0;ia=h+44|0;f[ia>>2]=fa;f[fa>>2]=0;f[h+52>>2]=0;if(ha|0){fa=ha+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[ca+44>>2]|0;fa=f[ia>>2]|0;f[fa>>2]=f[ea>>2];f[fa+4>>2]=f[ea+4>>2];ja=ga;break}else{f[da>>2]=0;jL(h,ca);ja=ga;break}}else{yL(h,a,-1);ja=h+36|0}while(0);aa=f[ja>>2]|0;if(aa|0){ga=aa+12|0;f[ga>>2]=(f[ga>>2]|0)+1}ga=k+36|0;aa=f[ga>>2]|0;if(aa|0?(ca=aa+12|0,aa=f[ca>>2]|0,f[ca>>2]=aa+-1,(aa|0)==1):0)kL(k);f[ga>>2]=0;aa=k+16|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[P>>2]|0)>0){ca=f[R>>2]|0;da=0;do{f[ca+(da<<2)>>2]=0;da=da+1|0;ka=f[P>>2]|0}while((da|0)<(ka|0));f[k>>2]=f[h>>2];if((ka|0)<3)la=20;else la=22}else{f[k>>2]=f[h>>2];la=20}if((la|0)==20){ka=f[h+4>>2]|0;if((ka|0)<3){f[P>>2]=ka;f[Q>>2]=f[h+8>>2];f[k+12>>2]=f[h+12>>2];ka=f[h+44>>2]|0;da=f[V>>2]|0;f[da>>2]=f[ka>>2];f[da+4>>2]=f[ka+4>>2]}else la=22}if((la|0)==22)jL(k,h);ka=h+16|0;f[aa>>2]=f[ka>>2];f[k+20>>2]=f[h+20>>2];f[k+24>>2]=f[h+24>>2];f[k+28>>2]=f[h+28>>2];f[k+32>>2]=f[h+32>>2];aa=f[ja>>2]|0;f[ga>>2]=aa;if(aa|0?(ga=aa+12|0,aa=f[ga>>2]|0,f[ga>>2]=aa+-1,(aa|0)==1):0)kL(h);f[ja>>2]=0;ja=h+4|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[ja>>2]|0)>0){ka=f[h+40>>2]|0;aa=0;do{f[ka+(aa<<2)>>2]=0;aa=aa+1|0}while((aa|0)<(f[ja>>2]|0))}ja=f[h+44>>2]|0;if((ja|0)!=(h+48|0))UC(ja)}else{ja=h+8|0;f[ja>>2]=0;f[ja+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=k;JM(a,h)}ja=f[R>>2]|0;aa=f[ja+4>>2]|0;ka=f[ja>>2]|0;ja=(O|0)==0;ga=K&255;switch(ga&7){case 0:case 2:case 5:break;default:{f[h>>2]=0;f[h+4>>2]=0;S=aD(h,38)|0;ma=228771;T=S+38|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11073);bD(h)}}do switch(d|0){case 5:case 4:case 3:case 1:case 2:case 0:{if((L&510|0)!=2){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,20)|0;ma=228819;T=S+20|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11079);bD(h)}K=(d|0)==5|(d|2|0)==2?4:3;f[m>>2]=aa;f[m+4>>2]=ka;vM(c,m,O|(K<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){da=f[ba>>2]|0;f[h>>2]=f[da>>2];ca=h+4|0;ea=da+4|0;f[ca>>2]=f[ea>>2];fa=h+8|0;f[fa>>2]=f[da+8>>2];f[h+12>>2]=f[da+12>>2];f[h+16>>2]=f[da+16>>2];f[h+20>>2]=f[da+20>>2];f[h+24>>2]=f[da+24>>2];f[h+28>>2]=f[da+28>>2];f[h+32>>2]=f[da+32>>2];ia=h+36|0;ha=f[da+36>>2]|0;f[ia>>2]=ha;f[h+40>>2]=fa;fa=h+48|0;na=h+44|0;f[na>>2]=fa;f[fa>>2]=0;f[h+52>>2]=0;if(ha|0){fa=ha+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[da+44>>2]|0;fa=f[na>>2]|0;f[fa>>2]=f[ea>>2];f[fa+4>>2]=f[ea+4>>2];oa=ia;break}else{f[ca>>2]=0;jL(h,da);oa=ia;break}}else{yL(h,c,-1);oa=h+36|0}while(0);ia=f[oa>>2]|0;if(ia|0){da=ia+12|0;f[da>>2]=(f[da>>2]|0)+1}da=l+36|0;ia=f[da>>2]|0;if(ia|0?(ca=ia+12|0,ia=f[ca>>2]|0,f[ca>>2]=ia+-1,(ia|0)==1):0)kL(l);f[da>>2]=0;ia=l+16|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[W>>2]|0)>0){ca=f[Z>>2]|0;ea=0;do{f[ca+(ea<<2)>>2]=0;ea=ea+1|0;pa=f[W>>2]|0}while((ea|0)<(pa|0));f[l>>2]=f[h>>2];if((pa|0)<3)la=54;else la=56}else{f[l>>2]=f[h>>2];la=54}if((la|0)==54){ea=f[h+4>>2]|0;if((ea|0)<3){f[W>>2]=ea;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ea=f[h+44>>2]|0;ca=f[$>>2]|0;f[ca>>2]=f[ea>>2];f[ca+4>>2]=f[ea+4>>2]}else la=56}if((la|0)==56)jL(l,h);ea=h+16|0;f[ia>>2]=f[ea>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ca=f[oa>>2]|0;f[da>>2]=ca;if(ca|0?(fa=ca+12|0,ca=f[fa>>2]|0,f[fa>>2]=ca+-1,(ca|0)==1):0)kL(h);f[oa>>2]=0;ca=h+4|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[ca>>2]|0)>0){ea=f[h+40>>2]|0;fa=0;do{f[ea+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[ca>>2]|0))}ca=f[h+44>>2]|0;if((ca|0)!=(h+48|0))UC(ca);ca=f[k+16>>2]|0;fa=f[U>>2]|0;ea=f[ia>>2]|0;da=f[_>>2]|0;na=f[k+12>>2]|0;ha=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{qa=0;break}default:qa=1}RZ(ca,fa,ea,da,na,ha,O,N,K,qa);break}case 27:case 17:case 26:case 16:case 23:case 13:case 22:case 12:{if(!(ja&(L&510|0)==2)){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,36)|0;ma=228840;T=S+36|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11089);bD(h)}switch(d|0){case 12:case 13:case 16:{ra=6;break}default:ra=(d|0)==17?6:5}f[n>>2]=aa;f[n+4>>2]=ka;vM(c,n,8,-1,0,0);do if((yM(c)|0)==65536){K=f[ba>>2]|0;f[h>>2]=f[K>>2];ia=h+4|0;ha=K+4|0;f[ia>>2]=f[ha>>2];na=h+8|0;f[na>>2]=f[K+8>>2];f[h+12>>2]=f[K+12>>2];f[h+16>>2]=f[K+16>>2];f[h+20>>2]=f[K+20>>2];f[h+24>>2]=f[K+24>>2];f[h+28>>2]=f[K+28>>2];f[h+32>>2]=f[K+32>>2];da=h+36|0;ea=f[K+36>>2]|0;f[da>>2]=ea;f[h+40>>2]=na;na=h+48|0;fa=h+44|0;f[fa>>2]=na;f[na>>2]=0;f[h+52>>2]=0;if(ea|0){na=ea+12|0;f[na>>2]=(f[na>>2]|0)+1}if((f[ha>>2]|0)<3){ha=f[K+44>>2]|0;na=f[fa>>2]|0;f[na>>2]=f[ha>>2];f[na+4>>2]=f[ha+4>>2];sa=da;break}else{f[ia>>2]=0;jL(h,K);sa=da;break}}else{yL(h,c,-1);sa=h+36|0}while(0);da=f[sa>>2]|0;if(da|0){K=da+12|0;f[K>>2]=(f[K>>2]|0)+1}K=l+36|0;da=f[K>>2]|0;if(da|0?(ia=da+12|0,da=f[ia>>2]|0,f[ia>>2]=da+-1,(da|0)==1):0)kL(l);f[K>>2]=0;da=l+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[W>>2]|0)>0){ia=f[Z>>2]|0;ha=0;do{f[ia+(ha<<2)>>2]=0;ha=ha+1|0;ta=f[W>>2]|0}while((ha|0)<(ta|0));f[l>>2]=f[h>>2];if((ta|0)<3)la=89;else la=91}else{f[l>>2]=f[h>>2];la=89}if((la|0)==89){ha=f[h+4>>2]|0;if((ha|0)<3){f[W>>2]=ha;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ha=f[h+44>>2]|0;ia=f[$>>2]|0;f[ia>>2]=f[ha>>2];f[ia+4>>2]=f[ha+4>>2]}else la=91}if((la|0)==91)jL(l,h);ha=h+16|0;f[da>>2]=f[ha>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ia=f[sa>>2]|0;f[K>>2]=ia;if(ia|0?(na=ia+12|0,ia=f[na>>2]|0,f[na>>2]=ia+-1,(ia|0)==1):0)kL(h);f[sa>>2]=0;ia=h+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ia>>2]|0)>0){ha=f[h+40>>2]|0;na=0;do{f[ha+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[ia>>2]|0))}ia=f[h+44>>2]|0;if((ia|0)!=(h+48|0))UC(ia);ia=f[k+16>>2]|0;na=f[U>>2]|0;ha=f[da>>2]|0;K=f[_>>2]|0;fa=f[k+12>>2]|0;ea=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{ua=0;break}default:ua=1}$Z(ia,na,ha,K,fa,ea,N,ua,ra);break}case 29:case 19:case 28:case 18:case 25:case 15:case 24:case 14:{if((e|0)<1){ea=d+-18|0;if(ea>>>0<12)va=(3075>>>(ea&4095)&1)+3&4095;else va=3}else va=e;if(!(ja&((N|0)==2&(va+-3|0)>>>0<2))){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,48)|0;ma=228877;T=S+48|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11101);bD(h)}switch(d|0){case 14:case 15:case 18:{wa=6;break}default:wa=(d|0)==19?6:5}f[o>>2]=aa;f[o+4>>2]=ka;vM(c,o,(va<<3)+-8|O,-1,0,0);do if((yM(c)|0)==65536){da=f[ba>>2]|0;f[h>>2]=f[da>>2];ea=h+4|0;fa=da+4|0;f[ea>>2]=f[fa>>2];K=h+8|0;f[K>>2]=f[da+8>>2];f[h+12>>2]=f[da+12>>2];f[h+16>>2]=f[da+16>>2];f[h+20>>2]=f[da+20>>2];f[h+24>>2]=f[da+24>>2];f[h+28>>2]=f[da+28>>2];f[h+32>>2]=f[da+32>>2];ha=h+36|0;na=f[da+36>>2]|0;f[ha>>2]=na;f[h+40>>2]=K;K=h+48|0;ia=h+44|0;f[ia>>2]=K;f[K>>2]=0;f[h+52>>2]=0;if(na|0){K=na+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[fa>>2]|0)<3){fa=f[da+44>>2]|0;K=f[ia>>2]|0;f[K>>2]=f[fa>>2];f[K+4>>2]=f[fa+4>>2];xa=ha;break}else{f[ea>>2]=0;jL(h,da);xa=ha;break}}else{yL(h,c,-1);xa=h+36|0}while(0);ha=f[xa>>2]|0;if(ha|0){da=ha+12|0;f[da>>2]=(f[da>>2]|0)+1}da=l+36|0;ha=f[da>>2]|0;if(ha|0?(ea=ha+12|0,ha=f[ea>>2]|0,f[ea>>2]=ha+-1,(ha|0)==1):0)kL(l);f[da>>2]=0;ha=l+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[W>>2]|0)>0){ea=f[Z>>2]|0;fa=0;do{f[ea+(fa<<2)>>2]=0;fa=fa+1|0;ya=f[W>>2]|0}while((fa|0)<(ya|0));f[l>>2]=f[h>>2];if((ya|0)<3)la=127;else la=129}else{f[l>>2]=f[h>>2];la=127}if((la|0)==127){fa=f[h+4>>2]|0;if((fa|0)<3){f[W>>2]=fa;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];fa=f[h+44>>2]|0;ea=f[$>>2]|0;f[ea>>2]=f[fa>>2];f[ea+4>>2]=f[fa+4>>2]}else la=129}if((la|0)==129)jL(l,h);fa=h+16|0;f[ha>>2]=f[fa>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ea=f[xa>>2]|0;f[da>>2]=ea;if(ea|0?(K=ea+12|0,ea=f[K>>2]|0,f[K>>2]=ea+-1,(ea|0)==1):0)kL(h);f[xa>>2]=0;ea=h+4|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[ea>>2]|0)>0){fa=f[h+40>>2]|0;K=0;do{f[fa+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[ea>>2]|0))}ea=f[h+44>>2]|0;if((ea|0)!=(h+48|0))UC(ea);ea=f[k+16>>2]|0;K=f[U>>2]|0;fa=f[ha>>2]|0;da=f[_>>2]|0;ia=f[k+12>>2]|0;na=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{za=0;break}default:za=1}d_(ea,K,fa,da,ia,na,va,za,wa);break}case 11:case 7:case 10:case 6:{if((L&510|0)!=2){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,20)|0;ma=228819;T=S+20|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11111);bD(h)}f[p>>2]=aa;f[p+4>>2]=ka;vM(c,p,O,-1,0,0);do if((yM(c)|0)==65536){ha=f[ba>>2]|0;f[h>>2]=f[ha>>2];na=h+4|0;ia=ha+4|0;f[na>>2]=f[ia>>2];da=h+8|0;f[da>>2]=f[ha+8>>2];f[h+12>>2]=f[ha+12>>2];f[h+16>>2]=f[ha+16>>2];f[h+20>>2]=f[ha+20>>2];f[h+24>>2]=f[ha+24>>2];f[h+28>>2]=f[ha+28>>2];f[h+32>>2]=f[ha+32>>2];fa=h+36|0;K=f[ha+36>>2]|0;f[fa>>2]=K;f[h+40>>2]=da;da=h+48|0;ea=h+44|0;f[ea>>2]=da;f[da>>2]=0;f[h+52>>2]=0;if(K|0){da=K+12|0;f[da>>2]=(f[da>>2]|0)+1}if((f[ia>>2]|0)<3){ia=f[ha+44>>2]|0;da=f[ea>>2]|0;f[da>>2]=f[ia>>2];f[da+4>>2]=f[ia+4>>2];Aa=fa;break}else{f[na>>2]=0;jL(h,ha);Aa=fa;break}}else{yL(h,c,-1);Aa=h+36|0}while(0);fa=f[Aa>>2]|0;if(fa|0){ha=fa+12|0;f[ha>>2]=(f[ha>>2]|0)+1}ha=l+36|0;fa=f[ha>>2]|0;if(fa|0?(na=fa+12|0,fa=f[na>>2]|0,f[na>>2]=fa+-1,(fa|0)==1):0)kL(l);f[ha>>2]=0;fa=l+16|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[W>>2]|0)>0){na=f[Z>>2]|0;ia=0;do{f[na+(ia<<2)>>2]=0;ia=ia+1|0;Ba=f[W>>2]|0}while((ia|0)<(Ba|0));f[l>>2]=f[h>>2];if((Ba|0)<3)la=160;else la=162}else{f[l>>2]=f[h>>2];la=160}if((la|0)==160){ia=f[h+4>>2]|0;if((ia|0)<3){f[W>>2]=ia;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ia=f[h+44>>2]|0;na=f[$>>2]|0;f[na>>2]=f[ia>>2];f[na+4>>2]=f[ia+4>>2]}else la=162}if((la|0)==162)jL(l,h);ia=h+16|0;f[fa>>2]=f[ia>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];na=f[Aa>>2]|0;f[ha>>2]=na;if(na|0?(da=na+12|0,na=f[da>>2]|0,f[da>>2]=na+-1,(na|0)==1):0)kL(h);f[Aa>>2]=0;na=h+4|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[na>>2]|0)>0){ia=f[h+40>>2]|0;da=0;do{f[ia+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[na>>2]|0))}na=f[h+44>>2]|0;if((na|0)!=(h+48|0))UC(na);na=f[k+16>>2]|0;da=f[U>>2]|0;ia=f[fa>>2]|0;ha=f[_>>2]|0;ea=f[k+12>>2]|0;K=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Ca=0;break}default:Ca=1}h_(na,da,ia,ha,ea,K,O,N,Ca);break}case 31:case 21:{if(!(ja&(N|0)==2)){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,22)|0;ma=228926;T=S+22|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11119);bD(h)}fa=(d|0)==21?6:5;f[q>>2]=aa;f[q+4>>2]=ka;vM(c,q,0,-1,0,0);do if((yM(c)|0)==65536){K=f[ba>>2]|0;f[h>>2]=f[K>>2];ea=h+4|0;ha=K+4|0;f[ea>>2]=f[ha>>2];ia=h+8|0;f[ia>>2]=f[K+8>>2];f[h+12>>2]=f[K+12>>2];f[h+16>>2]=f[K+16>>2];f[h+20>>2]=f[K+20>>2];f[h+24>>2]=f[K+24>>2];f[h+28>>2]=f[K+28>>2];f[h+32>>2]=f[K+32>>2];da=h+36|0;na=f[K+36>>2]|0;f[da>>2]=na;f[h+40>>2]=ia;ia=h+48|0;ca=h+44|0;f[ca>>2]=ia;f[ia>>2]=0;f[h+52>>2]=0;if(na|0){ia=na+12|0;f[ia>>2]=(f[ia>>2]|0)+1}if((f[ha>>2]|0)<3){ha=f[K+44>>2]|0;ia=f[ca>>2]|0;f[ia>>2]=f[ha>>2];f[ia+4>>2]=f[ha+4>>2];Da=da;break}else{f[ea>>2]=0;jL(h,K);Da=da;break}}else{yL(h,c,-1);Da=h+36|0}while(0);da=f[Da>>2]|0;if(da|0){K=da+12|0;f[K>>2]=(f[K>>2]|0)+1}K=l+36|0;da=f[K>>2]|0;if(da|0?(ea=da+12|0,da=f[ea>>2]|0,f[ea>>2]=da+-1,(da|0)==1):0)kL(l);f[K>>2]=0;da=l+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[W>>2]|0)>0){ea=f[Z>>2]|0;ha=0;do{f[ea+(ha<<2)>>2]=0;ha=ha+1|0;Ea=f[W>>2]|0}while((ha|0)<(Ea|0));f[l>>2]=f[h>>2];if((Ea|0)<3)la=193;else la=195}else{f[l>>2]=f[h>>2];la=193}if((la|0)==193){ha=f[h+4>>2]|0;if((ha|0)<3){f[W>>2]=ha;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ha=f[h+44>>2]|0;ea=f[$>>2]|0;f[ea>>2]=f[ha>>2];f[ea+4>>2]=f[ha+4>>2]}else la=195}if((la|0)==195)jL(l,h);ha=h+16|0;f[da>>2]=f[ha>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ea=f[Da>>2]|0;f[K>>2]=ea;if(ea|0?(ia=ea+12|0,ea=f[ia>>2]|0,f[ia>>2]=ea+-1,(ea|0)==1):0)kL(h);f[Da>>2]=0;ea=h+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ea>>2]|0)>0){ha=f[h+40>>2]|0;ia=0;do{f[ha+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[ea>>2]|0))}ea=f[h+44>>2]|0;if((ea|0)!=(h+48|0))UC(ea);v_(f[k+16>>2]|0,f[U>>2]|0,f[da>>2]|0,f[_>>2]|0,f[k+12>>2]|0,f[Q>>2]|0,fa);break}case 9:case 8:{ea=(e|0)<1?((d|0)==9?4:3):e;if(!((ea+-3|0)>>>0<2&(M|0)==0)){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,34)|0;ma=266398;T=S+34|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11128);bD(h)}f[r>>2]=aa;f[r+4>>2]=ka;vM(c,r,O|(ea<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){fa=f[ba>>2]|0;f[h>>2]=f[fa>>2];da=h+4|0;ia=fa+4|0;f[da>>2]=f[ia>>2];ha=h+8|0;f[ha>>2]=f[fa+8>>2];f[h+12>>2]=f[fa+12>>2];f[h+16>>2]=f[fa+16>>2];f[h+20>>2]=f[fa+20>>2];f[h+24>>2]=f[fa+24>>2];f[h+28>>2]=f[fa+28>>2];f[h+32>>2]=f[fa+32>>2];K=h+36|0;ca=f[fa+36>>2]|0;f[K>>2]=ca;f[h+40>>2]=ha;ha=h+48|0;na=h+44|0;f[na>>2]=ha;f[ha>>2]=0;f[h+52>>2]=0;if(ca|0){ha=ca+12|0;f[ha>>2]=(f[ha>>2]|0)+1}if((f[ia>>2]|0)<3){ia=f[fa+44>>2]|0;ha=f[na>>2]|0;f[ha>>2]=f[ia>>2];f[ha+4>>2]=f[ia+4>>2];Fa=K;break}else{f[da>>2]=0;jL(h,fa);Fa=K;break}}else{yL(h,c,-1);Fa=h+36|0}while(0);K=f[Fa>>2]|0;if(K|0){fa=K+12|0;f[fa>>2]=(f[fa>>2]|0)+1}fa=l+36|0;K=f[fa>>2]|0;if(K|0?(da=K+12|0,K=f[da>>2]|0,f[da>>2]=K+-1,(K|0)==1):0)kL(l);f[fa>>2]=0;K=l+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[W>>2]|0)>0){da=f[Z>>2]|0;ia=0;do{f[da+(ia<<2)>>2]=0;ia=ia+1|0;Ga=f[W>>2]|0}while((ia|0)<(Ga|0));f[l>>2]=f[h>>2];if((Ga|0)<3)la=224;else la=226}else{f[l>>2]=f[h>>2];la=224}if((la|0)==224){ia=f[h+4>>2]|0;if((ia|0)<3){f[W>>2]=ia;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ia=f[h+44>>2]|0;da=f[$>>2]|0;f[da>>2]=f[ia>>2];f[da+4>>2]=f[ia+4>>2]}else la=226}if((la|0)==226)jL(l,h);ia=h+16|0;f[K>>2]=f[ia>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];da=f[Fa>>2]|0;f[fa>>2]=da;if(da|0?(ha=da+12|0,da=f[ha>>2]|0,f[ha>>2]=da+-1,(da|0)==1):0)kL(h);f[Fa>>2]=0;da=h+4|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[da>>2]|0)>0){ia=f[h+40>>2]|0;ha=0;do{f[ia+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[da>>2]|0))}da=f[h+44>>2]|0;if((da|0)!=(h+48|0))UC(da);o_(f[k+16>>2]|0,f[U>>2]|0,f[K>>2]|0,f[_>>2]|0,f[k+12>>2]|0,f[Q>>2]|0,O,ea);break}case 30:case 20:{if(M|O|0){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,22)|0;ma=228949;T=S+22|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11135);bD(h)}ea=(d|0)==20?6:5;f[s>>2]=aa;f[s+4>>2]=ka;vM(c,s,8,-1,0,0);do if((yM(c)|0)==65536){K=f[ba>>2]|0;f[h>>2]=f[K>>2];da=h+4|0;ha=K+4|0;f[da>>2]=f[ha>>2];ia=h+8|0;f[ia>>2]=f[K+8>>2];f[h+12>>2]=f[K+12>>2];f[h+16>>2]=f[K+16>>2];f[h+20>>2]=f[K+20>>2];f[h+24>>2]=f[K+24>>2];f[h+28>>2]=f[K+28>>2];f[h+32>>2]=f[K+32>>2];fa=h+36|0;na=f[K+36>>2]|0;f[fa>>2]=na;f[h+40>>2]=ia;ia=h+48|0;ca=h+44|0;f[ca>>2]=ia;f[ia>>2]=0;f[h+52>>2]=0;if(na|0){ia=na+12|0;f[ia>>2]=(f[ia>>2]|0)+1}if((f[ha>>2]|0)<3){ha=f[K+44>>2]|0;ia=f[ca>>2]|0;f[ia>>2]=f[ha>>2];f[ia+4>>2]=f[ha+4>>2];Ha=fa;break}else{f[da>>2]=0;jL(h,K);Ha=fa;break}}else{yL(h,c,-1);Ha=h+36|0}while(0);fa=f[Ha>>2]|0;if(fa|0){K=fa+12|0;f[K>>2]=(f[K>>2]|0)+1}K=l+36|0;fa=f[K>>2]|0;if(fa|0?(da=fa+12|0,fa=f[da>>2]|0,f[da>>2]=fa+-1,(fa|0)==1):0)kL(l);f[K>>2]=0;fa=l+16|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[W>>2]|0)>0){da=f[Z>>2]|0;ha=0;do{f[da+(ha<<2)>>2]=0;ha=ha+1|0;Ia=f[W>>2]|0}while((ha|0)<(Ia|0));f[l>>2]=f[h>>2];if((Ia|0)<3)la=255;else la=257}else{f[l>>2]=f[h>>2];la=255}if((la|0)==255){ha=f[h+4>>2]|0;if((ha|0)<3){f[W>>2]=ha;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ha=f[h+44>>2]|0;da=f[$>>2]|0;f[da>>2]=f[ha>>2];f[da+4>>2]=f[ha+4>>2]}else la=257}if((la|0)==257)jL(l,h);ha=h+16|0;f[fa>>2]=f[ha>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];da=f[Ha>>2]|0;f[K>>2]=da;if(da|0?(ia=da+12|0,da=f[ia>>2]|0,f[ia>>2]=da+-1,(da|0)==1):0)kL(h);f[Ha>>2]=0;da=h+4|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[da>>2]|0)>0){ha=f[h+40>>2]|0;ia=0;do{f[ha+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[da>>2]|0))}da=f[h+44>>2]|0;if((da|0)!=(h+48|0))UC(da);y_(f[k+16>>2]|0,f[U>>2]|0,f[fa>>2]|0,f[_>>2]|0,f[k+12>>2]|0,f[Q>>2]|0,ea);break}case 83:case 82:case 37:case 36:{if((L&510|0)!=2){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,20)|0;ma=228819;T=S+20|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11144);bD(h)}f[t>>2]=aa;f[t+4>>2]=ka;vM(c,t,O|16,-1,0,0);do if((yM(c)|0)==65536){ea=f[ba>>2]|0;f[h>>2]=f[ea>>2];fa=h+4|0;da=ea+4|0;f[fa>>2]=f[da>>2];ia=h+8|0;f[ia>>2]=f[ea+8>>2];f[h+12>>2]=f[ea+12>>2];f[h+16>>2]=f[ea+16>>2];f[h+20>>2]=f[ea+20>>2];f[h+24>>2]=f[ea+24>>2];f[h+28>>2]=f[ea+28>>2];f[h+32>>2]=f[ea+32>>2];ha=h+36|0;K=f[ea+36>>2]|0;f[ha>>2]=K;f[h+40>>2]=ia;ia=h+48|0;ca=h+44|0;f[ca>>2]=ia;f[ia>>2]=0;f[h+52>>2]=0;if(K|0){ia=K+12|0;f[ia>>2]=(f[ia>>2]|0)+1}if((f[da>>2]|0)<3){da=f[ea+44>>2]|0;ia=f[ca>>2]|0;f[ia>>2]=f[da>>2];f[ia+4>>2]=f[da+4>>2];Ja=ha;break}else{f[fa>>2]=0;jL(h,ea);Ja=ha;break}}else{yL(h,c,-1);Ja=h+36|0}while(0);ha=f[Ja>>2]|0;if(ha|0){ea=ha+12|0;f[ea>>2]=(f[ea>>2]|0)+1}ea=l+36|0;ha=f[ea>>2]|0;if(ha|0?(fa=ha+12|0,ha=f[fa>>2]|0,f[fa>>2]=ha+-1,(ha|0)==1):0)kL(l);f[ea>>2]=0;ha=l+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[W>>2]|0)>0){fa=f[Z>>2]|0;da=0;do{f[fa+(da<<2)>>2]=0;da=da+1|0;Ka=f[W>>2]|0}while((da|0)<(Ka|0));f[l>>2]=f[h>>2];if((Ka|0)<3)la=286;else la=288}else{f[l>>2]=f[h>>2];la=286}if((la|0)==286){da=f[h+4>>2]|0;if((da|0)<3){f[W>>2]=da;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];da=f[h+44>>2]|0;fa=f[$>>2]|0;f[fa>>2]=f[da>>2];f[fa+4>>2]=f[da+4>>2]}else la=288}if((la|0)==288)jL(l,h);da=h+16|0;f[ha>>2]=f[da>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];fa=f[Ja>>2]|0;f[ea>>2]=fa;if(fa|0?(ia=fa+12|0,fa=f[ia>>2]|0,f[ia>>2]=fa+-1,(fa|0)==1):0)kL(h);f[Ja>>2]=0;fa=h+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[fa>>2]|0)>0){da=f[h+40>>2]|0;ia=0;do{f[da+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[fa>>2]|0))}fa=f[h+44>>2]|0;if((fa|0)!=(h+48|0))UC(fa);fa=f[k+16>>2]|0;ia=f[U>>2]|0;da=f[ha>>2]|0;ea=f[_>>2]|0;ca=f[k+12>>2]|0;K=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{La=0;break}default:La=1}B_(fa,ia,da,ea,ca,K,O,N,La,(d|1|0)==37);break}case 85:case 84:case 39:case 38:{K=(e|0)<1?3:e;if(!((K+-3|0)>>>0<2&(N|0)==3)){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,34)|0;ma=228972;T=S+34|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11154);bD(h)}f[v>>2]=aa;f[v+4>>2]=ka;vM(c,v,O|(K<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){ha=f[ba>>2]|0;f[h>>2]=f[ha>>2];ca=h+4|0;ea=ha+4|0;f[ca>>2]=f[ea>>2];da=h+8|0;f[da>>2]=f[ha+8>>2];f[h+12>>2]=f[ha+12>>2];f[h+16>>2]=f[ha+16>>2];f[h+20>>2]=f[ha+20>>2];f[h+24>>2]=f[ha+24>>2];f[h+28>>2]=f[ha+28>>2];f[h+32>>2]=f[ha+32>>2];ia=h+36|0;fa=f[ha+36>>2]|0;f[ia>>2]=fa;f[h+40>>2]=da;da=h+48|0;na=h+44|0;f[na>>2]=da;f[da>>2]=0;f[h+52>>2]=0;if(fa|0){da=fa+12|0;f[da>>2]=(f[da>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[ha+44>>2]|0;da=f[na>>2]|0;f[da>>2]=f[ea>>2];f[da+4>>2]=f[ea+4>>2];Ma=ia;break}else{f[ca>>2]=0;jL(h,ha);Ma=ia;break}}else{yL(h,c,-1);Ma=h+36|0}while(0);ia=f[Ma>>2]|0;if(ia|0){ha=ia+12|0;f[ha>>2]=(f[ha>>2]|0)+1}ha=l+36|0;ia=f[ha>>2]|0;if(ia|0?(ca=ia+12|0,ia=f[ca>>2]|0,f[ca>>2]=ia+-1,(ia|0)==1):0)kL(l);f[ha>>2]=0;ia=l+16|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[W>>2]|0)>0){ca=f[Z>>2]|0;ea=0;do{f[ca+(ea<<2)>>2]=0;ea=ea+1|0;Na=f[W>>2]|0}while((ea|0)<(Na|0));f[l>>2]=f[h>>2];if((Na|0)<3)la=319;else la=321}else{f[l>>2]=f[h>>2];la=319}if((la|0)==319){ea=f[h+4>>2]|0;if((ea|0)<3){f[W>>2]=ea;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ea=f[h+44>>2]|0;ca=f[$>>2]|0;f[ca>>2]=f[ea>>2];f[ca+4>>2]=f[ea+4>>2]}else la=321}if((la|0)==321)jL(l,h);ea=h+16|0;f[ia>>2]=f[ea>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ca=f[Ma>>2]|0;f[ha>>2]=ca;if(ca|0?(da=ca+12|0,ca=f[da>>2]|0,f[da>>2]=ca+-1,(ca|0)==1):0)kL(h);f[Ma>>2]=0;ca=h+4|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[ca>>2]|0)>0){ea=f[h+40>>2]|0;da=0;do{f[ea+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[ca>>2]|0))}ca=f[h+44>>2]|0;if((ca|0)!=(h+48|0))UC(ca);ca=f[k+16>>2]|0;da=f[U>>2]|0;ea=f[ia>>2]|0;ha=f[_>>2]|0;na=f[k+12>>2]|0;fa=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Oa=0;break}default:Oa=1}K_(ca,da,ea,ha,na,fa,O,K,Oa,(d|1|0)==39);break}case 33:case 32:{if((L&510|0)!=2){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,20)|0;ma=228819;T=S+20|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11162);bD(h)}f[w>>2]=aa;f[w+4>>2]=ka;vM(c,w,O|16,-1,0,0);do if((yM(c)|0)==65536){K=f[ba>>2]|0;f[h>>2]=f[K>>2];ia=h+4|0;fa=K+4|0;f[ia>>2]=f[fa>>2];na=h+8|0;f[na>>2]=f[K+8>>2];f[h+12>>2]=f[K+12>>2];f[h+16>>2]=f[K+16>>2];f[h+20>>2]=f[K+20>>2];f[h+24>>2]=f[K+24>>2];f[h+28>>2]=f[K+28>>2];f[h+32>>2]=f[K+32>>2];ha=h+36|0;ea=f[K+36>>2]|0;f[ha>>2]=ea;f[h+40>>2]=na;na=h+48|0;da=h+44|0;f[da>>2]=na;f[na>>2]=0;f[h+52>>2]=0;if(ea|0){na=ea+12|0;f[na>>2]=(f[na>>2]|0)+1}if((f[fa>>2]|0)<3){fa=f[K+44>>2]|0;na=f[da>>2]|0;f[na>>2]=f[fa>>2];f[na+4>>2]=f[fa+4>>2];Pa=ha;break}else{f[ia>>2]=0;jL(h,K);Pa=ha;break}}else{yL(h,c,-1);Pa=h+36|0}while(0);ha=f[Pa>>2]|0;if(ha|0){K=ha+12|0;f[K>>2]=(f[K>>2]|0)+1}K=l+36|0;ha=f[K>>2]|0;if(ha|0?(ia=ha+12|0,ha=f[ia>>2]|0,f[ia>>2]=ha+-1,(ha|0)==1):0)kL(l);f[K>>2]=0;ha=l+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[W>>2]|0)>0){ia=f[Z>>2]|0;fa=0;do{f[ia+(fa<<2)>>2]=0;fa=fa+1|0;Qa=f[W>>2]|0}while((fa|0)<(Qa|0));f[l>>2]=f[h>>2];if((Qa|0)<3)la=352;else la=354}else{f[l>>2]=f[h>>2];la=352}if((la|0)==352){fa=f[h+4>>2]|0;if((fa|0)<3){f[W>>2]=fa;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];fa=f[h+44>>2]|0;ia=f[$>>2]|0;f[ia>>2]=f[fa>>2];f[ia+4>>2]=f[fa+4>>2]}else la=354}if((la|0)==354)jL(l,h);fa=h+16|0;f[ha>>2]=f[fa>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ia=f[Pa>>2]|0;f[K>>2]=ia;if(ia|0?(na=ia+12|0,ia=f[na>>2]|0,f[na>>2]=ia+-1,(ia|0)==1):0)kL(h);f[Pa>>2]=0;ia=h+4|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[ia>>2]|0)>0){fa=f[h+40>>2]|0;na=0;do{f[fa+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[ia>>2]|0))}ia=f[h+44>>2]|0;if((ia|0)!=(h+48|0))UC(ia);ia=f[k+16>>2]|0;na=f[U>>2]|0;fa=f[ha>>2]|0;K=f[_>>2]|0;da=f[k+12>>2]|0;ea=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Ra=0;break}default:Ra=1}U_(ia,na,fa,K,da,ea,O,N,Ra);break}case 35:case 34:{ea=(e|0)<1?3:e;if(!((ea+-3|0)>>>0<2&(N|0)==3)){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,34)|0;ma=228972;T=S+34|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11170);bD(h)}f[x>>2]=aa;f[x+4>>2]=ka;vM(c,x,O|(ea<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){ha=f[ba>>2]|0;f[h>>2]=f[ha>>2];da=h+4|0;K=ha+4|0;f[da>>2]=f[K>>2];fa=h+8|0;f[fa>>2]=f[ha+8>>2];f[h+12>>2]=f[ha+12>>2];f[h+16>>2]=f[ha+16>>2];f[h+20>>2]=f[ha+20>>2];f[h+24>>2]=f[ha+24>>2];f[h+28>>2]=f[ha+28>>2];f[h+32>>2]=f[ha+32>>2];na=h+36|0;ia=f[ha+36>>2]|0;f[na>>2]=ia;f[h+40>>2]=fa;fa=h+48|0;ca=h+44|0;f[ca>>2]=fa;f[fa>>2]=0;f[h+52>>2]=0;if(ia|0){fa=ia+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[K>>2]|0)<3){K=f[ha+44>>2]|0;fa=f[ca>>2]|0;f[fa>>2]=f[K>>2];f[fa+4>>2]=f[K+4>>2];Sa=na;break}else{f[da>>2]=0;jL(h,ha);Sa=na;break}}else{yL(h,c,-1);Sa=h+36|0}while(0);na=f[Sa>>2]|0;if(na|0){ha=na+12|0;f[ha>>2]=(f[ha>>2]|0)+1}ha=l+36|0;na=f[ha>>2]|0;if(na|0?(da=na+12|0,na=f[da>>2]|0,f[da>>2]=na+-1,(na|0)==1):0)kL(l);f[ha>>2]=0;na=l+16|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[W>>2]|0)>0){da=f[Z>>2]|0;K=0;do{f[da+(K<<2)>>2]=0;K=K+1|0;Ta=f[W>>2]|0}while((K|0)<(Ta|0));f[l>>2]=f[h>>2];if((Ta|0)<3)la=385;else la=387}else{f[l>>2]=f[h>>2];la=385}if((la|0)==385){K=f[h+4>>2]|0;if((K|0)<3){f[W>>2]=K;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];K=f[h+44>>2]|0;da=f[$>>2]|0;f[da>>2]=f[K>>2];f[da+4>>2]=f[K+4>>2]}else la=387}if((la|0)==387)jL(l,h);K=h+16|0;f[na>>2]=f[K>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];da=f[Sa>>2]|0;f[ha>>2]=da;if(da|0?(fa=da+12|0,da=f[fa>>2]|0,f[fa>>2]=da+-1,(da|0)==1):0)kL(h);f[Sa>>2]=0;da=h+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[da>>2]|0)>0){K=f[h+40>>2]|0;fa=0;do{f[K+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[da>>2]|0))}da=f[h+44>>2]|0;if((da|0)!=(h+48|0))UC(da);da=f[k+16>>2]|0;fa=f[U>>2]|0;K=f[na>>2]|0;ha=f[_>>2]|0;ca=f[k+12>>2]|0;ia=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Ua=0;break}default:Ua=1}b$(da,fa,K,ha,ca,ia,O,ea,Ua);break}case 69:case 68:case 53:case 52:case 67:case 66:case 41:case 40:{if((L&510|0)==2)switch(ga&7){case 0:case 5:break;default:la=401}else la=401;if((la|0)==401){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,52)|0;ma=229007;T=S+52|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11178);bD(h)}f[y>>2]=aa;f[y+4>>2]=ka;vM(c,y,O|16,-1,0,0);do if((yM(c)|0)==65536){ea=f[ba>>2]|0;f[h>>2]=f[ea>>2];na=h+4|0;ia=ea+4|0;f[na>>2]=f[ia>>2];ca=h+8|0;f[ca>>2]=f[ea+8>>2];f[h+12>>2]=f[ea+12>>2];f[h+16>>2]=f[ea+16>>2];f[h+20>>2]=f[ea+20>>2];f[h+24>>2]=f[ea+24>>2];f[h+28>>2]=f[ea+28>>2];f[h+32>>2]=f[ea+32>>2];ha=h+36|0;K=f[ea+36>>2]|0;f[ha>>2]=K;f[h+40>>2]=ca;ca=h+48|0;fa=h+44|0;f[fa>>2]=ca;f[ca>>2]=0;f[h+52>>2]=0;if(K|0){ca=K+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[ia>>2]|0)<3){ia=f[ea+44>>2]|0;ca=f[fa>>2]|0;f[ca>>2]=f[ia>>2];f[ca+4>>2]=f[ia+4>>2];Va=ha;break}else{f[na>>2]=0;jL(h,ea);Va=ha;break}}else{yL(h,c,-1);Va=h+36|0}while(0);ha=f[Va>>2]|0;if(ha|0){ea=ha+12|0;f[ea>>2]=(f[ea>>2]|0)+1}ea=l+36|0;ha=f[ea>>2]|0;if(ha|0?(na=ha+12|0,ha=f[na>>2]|0,f[na>>2]=ha+-1,(ha|0)==1):0)kL(l);f[ea>>2]=0;ha=l+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[W>>2]|0)>0){na=f[Z>>2]|0;ia=0;do{f[na+(ia<<2)>>2]=0;ia=ia+1|0;Wa=f[W>>2]|0}while((ia|0)<(Wa|0));f[l>>2]=f[h>>2];if((Wa|0)<3)la=419;else la=421}else{f[l>>2]=f[h>>2];la=419}if((la|0)==419){ia=f[h+4>>2]|0;if((ia|0)<3){f[W>>2]=ia;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ia=f[h+44>>2]|0;na=f[$>>2]|0;f[na>>2]=f[ia>>2];f[na+4>>2]=f[ia+4>>2]}else la=421}if((la|0)==421)jL(l,h);ia=h+16|0;f[ha>>2]=f[ia>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];na=f[Va>>2]|0;f[ea>>2]=na;if(na|0?(ca=na+12|0,na=f[ca>>2]|0,f[ca>>2]=na+-1,(na|0)==1):0)kL(h);f[Va>>2]=0;na=h+4|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[na>>2]|0)>0){ia=f[h+40>>2]|0;ca=0;do{f[ia+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[na>>2]|0))}na=f[h+44>>2]|0;if((na|0)!=(h+48|0))UC(na);na=f[k+16>>2]|0;ca=f[U>>2]|0;ia=f[ha>>2]|0;ea=f[_>>2]|0;fa=f[k+12>>2]|0;K=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Xa=0;break}default:Xa=1}da=d+-40|0;l$(na,ca,ia,ea,fa,K,O,N,Xa,(d+-66|0)>>>0<8,da>>>0<32&(-872366077>>>da&1|0)!=0);break}case 73:case 72:case 61:case 60:case 71:case 70:case 55:case 54:{da=(e|0)<1?3:e;if((da+-3|0)>>>0<2&(N|0)==3)switch(ga&7){case 0:case 5:break;default:la=435}else la=435;if((la|0)==435){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,64)|0;ma=229060;T=S+64|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11188);bD(h)}f[z>>2]=aa;f[z+4>>2]=ka;vM(c,z,O|(da<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){ha=f[ba>>2]|0;f[h>>2]=f[ha>>2];K=h+4|0;fa=ha+4|0;f[K>>2]=f[fa>>2];ea=h+8|0;f[ea>>2]=f[ha+8>>2];f[h+12>>2]=f[ha+12>>2];f[h+16>>2]=f[ha+16>>2];f[h+20>>2]=f[ha+20>>2];f[h+24>>2]=f[ha+24>>2];f[h+28>>2]=f[ha+28>>2];f[h+32>>2]=f[ha+32>>2];ia=h+36|0;ca=f[ha+36>>2]|0;f[ia>>2]=ca;f[h+40>>2]=ea;ea=h+48|0;na=h+44|0;f[na>>2]=ea;f[ea>>2]=0;f[h+52>>2]=0;if(ca|0){ea=ca+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[fa>>2]|0)<3){fa=f[ha+44>>2]|0;ea=f[na>>2]|0;f[ea>>2]=f[fa>>2];f[ea+4>>2]=f[fa+4>>2];Ya=ia;break}else{f[K>>2]=0;jL(h,ha);Ya=ia;break}}else{yL(h,c,-1);Ya=h+36|0}while(0);ia=f[Ya>>2]|0;if(ia|0){ha=ia+12|0;f[ha>>2]=(f[ha>>2]|0)+1}ha=l+36|0;ia=f[ha>>2]|0;if(ia|0?(K=ia+12|0,ia=f[K>>2]|0,f[K>>2]=ia+-1,(ia|0)==1):0)kL(l);f[ha>>2]=0;ia=l+16|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[W>>2]|0)>0){K=f[Z>>2]|0;fa=0;do{f[K+(fa<<2)>>2]=0;fa=fa+1|0;Za=f[W>>2]|0}while((fa|0)<(Za|0));f[l>>2]=f[h>>2];if((Za|0)<3)la=453;else la=455}else{f[l>>2]=f[h>>2];la=453}if((la|0)==453){fa=f[h+4>>2]|0;if((fa|0)<3){f[W>>2]=fa;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];fa=f[h+44>>2]|0;K=f[$>>2]|0;f[K>>2]=f[fa>>2];f[K+4>>2]=f[fa+4>>2]}else la=455}if((la|0)==455)jL(l,h);fa=h+16|0;f[ia>>2]=f[fa>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];K=f[Ya>>2]|0;f[ha>>2]=K;if(K|0?(ea=K+12|0,K=f[ea>>2]|0,f[ea>>2]=K+-1,(K|0)==1):0)kL(h);f[Ya>>2]=0;K=h+4|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[K>>2]|0)>0){fa=f[h+40>>2]|0;ea=0;do{f[fa+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[K>>2]|0))}K=f[h+44>>2]|0;if((K|0)!=(h+48|0))UC(K);K=f[k+16>>2]|0;ea=f[U>>2]|0;fa=f[ia>>2]|0;ha=f[_>>2]|0;na=f[k+12>>2]|0;ca=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{_a=0;break}default:_a=1}$a=d+-40|0;w$(K,ea,fa,ha,na,ca,O,da,_a,(d+-66|0)>>>0<8,$a>>>0<32&(-872366077>>>$a&1|0)!=0);break}case 77:case 76:case 51:case 50:case 75:case 74:case 45:case 44:{if((L&510|0)==2)switch(ga&7){case 0:case 5:break;default:la=469}else la=469;if((la|0)==469){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,52)|0;ma=229007;T=S+52|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11197);bD(h)}f[A>>2]=aa;f[A+4>>2]=ka;vM(c,A,O|16,-1,0,0);do if((yM(c)|0)==65536){da=f[ba>>2]|0;f[h>>2]=f[da>>2];ia=h+4|0;$a=da+4|0;f[ia>>2]=f[$a>>2];ca=h+8|0;f[ca>>2]=f[da+8>>2];f[h+12>>2]=f[da+12>>2];f[h+16>>2]=f[da+16>>2];f[h+20>>2]=f[da+20>>2];f[h+24>>2]=f[da+24>>2];f[h+28>>2]=f[da+28>>2];f[h+32>>2]=f[da+32>>2];na=h+36|0;ha=f[da+36>>2]|0;f[na>>2]=ha;f[h+40>>2]=ca;ca=h+48|0;fa=h+44|0;f[fa>>2]=ca;f[ca>>2]=0;f[h+52>>2]=0;if(ha|0){ca=ha+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[$a>>2]|0)<3){$a=f[da+44>>2]|0;ca=f[fa>>2]|0;f[ca>>2]=f[$a>>2];f[ca+4>>2]=f[$a+4>>2];ab=na;break}else{f[ia>>2]=0;jL(h,da);ab=na;break}}else{yL(h,c,-1);ab=h+36|0}while(0);na=f[ab>>2]|0;if(na|0){da=na+12|0;f[da>>2]=(f[da>>2]|0)+1}da=l+36|0;na=f[da>>2]|0;if(na|0?(ia=na+12|0,na=f[ia>>2]|0,f[ia>>2]=na+-1,(na|0)==1):0)kL(l);f[da>>2]=0;na=l+16|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[W>>2]|0)>0){ia=f[Z>>2]|0;$a=0;do{f[ia+($a<<2)>>2]=0;$a=$a+1|0;bb=f[W>>2]|0}while(($a|0)<(bb|0));f[l>>2]=f[h>>2];if((bb|0)<3)la=487;else la=489}else{f[l>>2]=f[h>>2];la=487}if((la|0)==487){$a=f[h+4>>2]|0;if(($a|0)<3){f[W>>2]=$a;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];$a=f[h+44>>2]|0;ia=f[$>>2]|0;f[ia>>2]=f[$a>>2];f[ia+4>>2]=f[$a+4>>2]}else la=489}if((la|0)==489)jL(l,h);$a=h+16|0;f[na>>2]=f[$a>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ia=f[ab>>2]|0;f[da>>2]=ia;if(ia|0?(ca=ia+12|0,ia=f[ca>>2]|0,f[ca>>2]=ia+-1,(ia|0)==1):0)kL(h);f[ab>>2]=0;ia=h+4|0;f[$a>>2]=0;f[$a+4>>2]=0;f[$a+8>>2]=0;f[$a+12>>2]=0;if((f[ia>>2]|0)>0){$a=f[h+40>>2]|0;ca=0;do{f[$a+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[ia>>2]|0))}ia=f[h+44>>2]|0;if((ia|0)!=(h+48|0))UC(ia);ia=f[k+16>>2]|0;ca=f[U>>2]|0;$a=f[na>>2]|0;da=f[_>>2]|0;fa=f[k+12>>2]|0;ha=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{cb=0;break}default:cb=1}switch(d|0){case 75:case 74:case 45:case 44:case 79:case 78:case 57:case 56:{db=1;break}default:db=0}ea=d+-44|0;if(ea>>>0<16)eb=((-3901&65535)>>>(ea&65535)&1)!=0;else eb=0;J$(ia,ca,$a,da,fa,ha,O,N,cb,db,eb);break}case 81:case 80:case 59:case 58:case 79:case 78:case 57:case 56:{ha=(e|0)<1?3:e;if((ha+-3|0)>>>0<2&(N|0)==3)switch(ga&7){case 0:case 5:break;default:la=507}else la=507;if((la|0)==507){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,64)|0;ma=229060;T=S+64|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11207);bD(h)}f[B>>2]=aa;f[B+4>>2]=ka;vM(c,B,O|(ha<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){na=f[ba>>2]|0;f[h>>2]=f[na>>2];fa=h+4|0;da=na+4|0;f[fa>>2]=f[da>>2];$a=h+8|0;f[$a>>2]=f[na+8>>2];f[h+12>>2]=f[na+12>>2];f[h+16>>2]=f[na+16>>2];f[h+20>>2]=f[na+20>>2];f[h+24>>2]=f[na+24>>2];f[h+28>>2]=f[na+28>>2];f[h+32>>2]=f[na+32>>2];ca=h+36|0;ia=f[na+36>>2]|0;f[ca>>2]=ia;f[h+40>>2]=$a;$a=h+48|0;ea=h+44|0;f[ea>>2]=$a;f[$a>>2]=0;f[h+52>>2]=0;if(ia|0){$a=ia+12|0;f[$a>>2]=(f[$a>>2]|0)+1}if((f[da>>2]|0)<3){da=f[na+44>>2]|0;$a=f[ea>>2]|0;f[$a>>2]=f[da>>2];f[$a+4>>2]=f[da+4>>2];fb=ca;break}else{f[fa>>2]=0;jL(h,na);fb=ca;break}}else{yL(h,c,-1);fb=h+36|0}while(0);ca=f[fb>>2]|0;if(ca|0){na=ca+12|0;f[na>>2]=(f[na>>2]|0)+1}na=l+36|0;ca=f[na>>2]|0;if(ca|0?(fa=ca+12|0,ca=f[fa>>2]|0,f[fa>>2]=ca+-1,(ca|0)==1):0)kL(l);f[na>>2]=0;ca=l+16|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[W>>2]|0)>0){fa=f[Z>>2]|0;da=0;do{f[fa+(da<<2)>>2]=0;da=da+1|0;gb=f[W>>2]|0}while((da|0)<(gb|0));f[l>>2]=f[h>>2];if((gb|0)<3)la=525;else la=527}else{f[l>>2]=f[h>>2];la=525}if((la|0)==525){da=f[h+4>>2]|0;if((da|0)<3){f[W>>2]=da;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];da=f[h+44>>2]|0;fa=f[$>>2]|0;f[fa>>2]=f[da>>2];f[fa+4>>2]=f[da+4>>2]}else la=527}if((la|0)==527)jL(l,h);da=h+16|0;f[ca>>2]=f[da>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];fa=f[fb>>2]|0;f[na>>2]=fa;if(fa|0?($a=fa+12|0,fa=f[$a>>2]|0,f[$a>>2]=fa+-1,(fa|0)==1):0)kL(h);f[fb>>2]=0;fa=h+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[fa>>2]|0)>0){da=f[h+40>>2]|0;$a=0;do{f[da+($a<<2)>>2]=0;$a=$a+1|0}while(($a|0)<(f[fa>>2]|0))}fa=f[h+44>>2]|0;if((fa|0)!=(h+48|0))UC(fa);fa=f[k+16>>2]|0;$a=f[U>>2]|0;da=f[ca>>2]|0;na=f[_>>2]|0;ea=f[k+12>>2]|0;ia=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{hb=0;break}default:hb=1}switch(d|0){case 75:case 74:case 45:case 44:case 79:case 78:case 57:case 56:{ib=1;break}default:ib=0}K=d+-44|0;if(K>>>0<16)jb=((-3901&65535)>>>(K&65535)&1)!=0;else jb=0;d0(fa,$a,da,na,ea,ia,O,ha,hb,ib,jb);break}case 142:case 141:case 140:case 139:case 138:case 137:case 136:case 135:case 65:case 64:case 63:case 62:case 49:case 48:case 47:case 46:case 89:case 88:case 87:case 86:{f[h+8>>2]=0;f[h+12>>2]=0;f[h>>2]=16842752;f[h+4>>2]=k;Fla(h,c,d,e);break}case 94:case 95:case 96:case 97:case 90:case 91:case 92:case 93:{ia=(e|0)<1?((d+-94|0)>>>0<4?4:3):e;ea=d+-92|0;if(ea>>>0<6)kb=51>>>(ea&63)&63;else kb=0;ea=kb&1;if((ia+-3|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,20)|0;ma=229125;T=S+20|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11228);bD(h)}if(!((aa&1|0)==0?!((ka|0)%3|0|O|0):0)){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,53)|0;ma=229146;T=S+53|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11229);bD(h)}f[C>>2]=aa;f[C+4>>2]=(ka<<1|0)/3|0;vM(c,C,O|(ia<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){ha=f[ba>>2]|0;f[h>>2]=f[ha>>2];ca=h+4|0;na=ha+4|0;f[ca>>2]=f[na>>2];da=h+8|0;f[da>>2]=f[ha+8>>2];f[h+12>>2]=f[ha+12>>2];f[h+16>>2]=f[ha+16>>2];f[h+20>>2]=f[ha+20>>2];f[h+24>>2]=f[ha+24>>2];f[h+28>>2]=f[ha+28>>2];f[h+32>>2]=f[ha+32>>2];$a=h+36|0;fa=f[ha+36>>2]|0;f[$a>>2]=fa;f[h+40>>2]=da;da=h+48|0;K=h+44|0;f[K>>2]=da;f[da>>2]=0;f[h+52>>2]=0;if(fa|0){da=fa+12|0;f[da>>2]=(f[da>>2]|0)+1}if((f[na>>2]|0)<3){na=f[ha+44>>2]|0;da=f[K>>2]|0;f[da>>2]=f[na>>2];f[da+4>>2]=f[na+4>>2];lb=$a;break}else{f[ca>>2]=0;jL(h,ha);lb=$a;break}}else{yL(h,c,-1);lb=h+36|0}while(0);$a=f[lb>>2]|0;if($a|0){ha=$a+12|0;f[ha>>2]=(f[ha>>2]|0)+1}ha=l+36|0;$a=f[ha>>2]|0;if($a|0?(ca=$a+12|0,$a=f[ca>>2]|0,f[ca>>2]=$a+-1,($a|0)==1):0)kL(l);f[ha>>2]=0;$a=l+16|0;f[$a>>2]=0;f[$a+4>>2]=0;f[$a+8>>2]=0;f[$a+12>>2]=0;if((f[W>>2]|0)>0){ca=f[Z>>2]|0;na=0;do{f[ca+(na<<2)>>2]=0;na=na+1|0;mb=f[W>>2]|0}while((na|0)<(mb|0));f[l>>2]=f[h>>2];if((mb|0)<3)la=568;else la=570}else{f[l>>2]=f[h>>2];la=568}if((la|0)==568){na=f[h+4>>2]|0;if((na|0)<3){f[W>>2]=na;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];na=f[h+44>>2]|0;ca=f[$>>2]|0;f[ca>>2]=f[na>>2];f[ca+4>>2]=f[na+4>>2]}else la=570}if((la|0)==570)jL(l,h);na=h+16|0;f[$a>>2]=f[na>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ca=f[lb>>2]|0;f[ha>>2]=ca;if(ca|0?(da=ca+12|0,ca=f[da>>2]|0,f[da>>2]=ca+-1,(ca|0)==1):0)kL(h);f[lb>>2]=0;ca=h+4|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[ca>>2]|0)>0){na=f[h+40>>2]|0;da=0;do{f[na+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[ca>>2]|0))}ca=f[h+44>>2]|0;if((ca|0)!=(h+48|0))UC(ca);ca=f[k+16>>2]|0;da=f[U>>2]|0;na=f[$a>>2]|0;ha=f[_>>2]|0;K=f[l+12>>2]|0;fa=f[X>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{nb=0;break}default:nb=1}dQ(h,50592);x0(ca,ca+(Y(fa,da)|0)|0,da,na,ha,K,fa,ia,nb,ea);break}case 104:case 105:case 100:case 101:case 102:case 103:case 98:case 99:{fa=(e|0)<1?((d+-102|0)>>>0<4?4:3):e;K=d+-98|0;if(K>>>0<6)ob=51>>>(K&63)&63;else ob=0;K=ob&1;if((fa+-3|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,20)|0;ma=229125;T=S+20|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11241);bD(h)}if(!((aa&1|0)==0?!((ka|0)%3|0|O|0):0)){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,53)|0;ma=229146;T=S+53|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11242);bD(h)}f[D>>2]=aa;f[D+4>>2]=(ka<<1|0)/3|0;vM(c,D,O|(fa<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){ea=f[ba>>2]|0;f[h>>2]=f[ea>>2];ia=h+4|0;$a=ea+4|0;f[ia>>2]=f[$a>>2];ha=h+8|0;f[ha>>2]=f[ea+8>>2];f[h+12>>2]=f[ea+12>>2];f[h+16>>2]=f[ea+16>>2];f[h+20>>2]=f[ea+20>>2];f[h+24>>2]=f[ea+24>>2];f[h+28>>2]=f[ea+28>>2];f[h+32>>2]=f[ea+32>>2];na=h+36|0;da=f[ea+36>>2]|0;f[na>>2]=da;f[h+40>>2]=ha;ha=h+48|0;ca=h+44|0;f[ca>>2]=ha;f[ha>>2]=0;f[h+52>>2]=0;if(da|0){ha=da+12|0;f[ha>>2]=(f[ha>>2]|0)+1}if((f[$a>>2]|0)<3){$a=f[ea+44>>2]|0;ha=f[ca>>2]|0;f[ha>>2]=f[$a>>2];f[ha+4>>2]=f[$a+4>>2];pb=na;break}else{f[ia>>2]=0;jL(h,ea);pb=na;break}}else{yL(h,c,-1);pb=h+36|0}while(0);na=f[pb>>2]|0;if(na|0){ea=na+12|0;f[ea>>2]=(f[ea>>2]|0)+1}ea=l+36|0;na=f[ea>>2]|0;if(na|0?(ia=na+12|0,na=f[ia>>2]|0,f[ia>>2]=na+-1,(na|0)==1):0)kL(l);f[ea>>2]=0;na=l+16|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[W>>2]|0)>0){ia=f[Z>>2]|0;$a=0;do{f[ia+($a<<2)>>2]=0;$a=$a+1|0;qb=f[W>>2]|0}while(($a|0)<(qb|0));f[l>>2]=f[h>>2];if((qb|0)<3)la=608;else la=610}else{f[l>>2]=f[h>>2];la=608}if((la|0)==608){$a=f[h+4>>2]|0;if(($a|0)<3){f[W>>2]=$a;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];$a=f[h+44>>2]|0;ia=f[$>>2]|0;f[ia>>2]=f[$a>>2];f[ia+4>>2]=f[$a+4>>2]}else la=610}if((la|0)==610)jL(l,h);$a=h+16|0;f[na>>2]=f[$a>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ia=f[pb>>2]|0;f[ea>>2]=ia;if(ia|0?(ha=ia+12|0,ia=f[ha>>2]|0,f[ha>>2]=ia+-1,(ia|0)==1):0)kL(h);f[pb>>2]=0;ia=h+4|0;f[$a>>2]=0;f[$a+4>>2]=0;f[$a+8>>2]=0;f[$a+12>>2]=0;if((f[ia>>2]|0)>0){$a=f[h+40>>2]|0;ha=0;do{f[$a+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[ia>>2]|0))}ia=f[h+44>>2]|0;if((ia|0)!=(h+48|0))UC(ia);ia=f[k+16>>2]|0;ha=f[U>>2]|0;$a=f[na>>2]|0;ea=f[_>>2]|0;ca=f[l+12>>2]|0;da=f[X>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{rb=0;break}default:rb=1}O0(ia,ha,$a,ea,ca,da,fa,rb,K);break}case 106:{da=(e|0)>1?e:1;if((e|0)>=2){f[h>>2]=0;f[h+4>>2]=0;ca=aD(h,8)|0;ea=ca;b[ea>>0]=100;b[ea+1>>0]=99;b[ea+2>>0]=110;b[ea+3>>0]=32;ea=ca+4|0;b[ea>>0]=61;b[ea+1>>0]=61;b[ea+2>>0]=32;b[ea+3>>0]=49;bO(-215,h,228810,217660,11253);bD(h)}if(!((aa&1|0)==0?!((ka|0)%3|0|O|0):0)){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,53)|0;ma=229146;T=S+53|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11254);bD(h)}K=(ka<<1|0)/3|0;f[E>>2]=aa;f[E+4>>2]=K;vM(c,E,O|(da<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){fa=f[ba>>2]|0;f[h>>2]=f[fa>>2];na=h+4|0;ea=fa+4|0;f[na>>2]=f[ea>>2];ca=h+8|0;f[ca>>2]=f[fa+8>>2];f[h+12>>2]=f[fa+12>>2];f[h+16>>2]=f[fa+16>>2];f[h+20>>2]=f[fa+20>>2];f[h+24>>2]=f[fa+24>>2];f[h+28>>2]=f[fa+28>>2];f[h+32>>2]=f[fa+32>>2];$a=h+36|0;ha=f[fa+36>>2]|0;f[$a>>2]=ha;f[h+40>>2]=ca;ca=h+48|0;ia=h+44|0;f[ia>>2]=ca;f[ca>>2]=0;f[h+52>>2]=0;if(ha|0){ca=ha+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[ea>>2]|0)<3){ea=f[fa+44>>2]|0;ca=f[ia>>2]|0;f[ca>>2]=f[ea>>2];f[ca+4>>2]=f[ea+4>>2];sb=$a;break}else{f[na>>2]=0;jL(h,fa);sb=$a;break}}else{yL(h,c,-1);sb=h+36|0}while(0);da=f[sb>>2]|0;if(da|0){$a=da+12|0;f[$a>>2]=(f[$a>>2]|0)+1}$a=l+36|0;da=f[$a>>2]|0;if(da|0?(fa=da+12|0,da=f[fa>>2]|0,f[fa>>2]=da+-1,(da|0)==1):0)kL(l);f[$a>>2]=0;da=l+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[W>>2]|0)>0){fa=f[Z>>2]|0;na=0;do{f[fa+(na<<2)>>2]=0;na=na+1|0;tb=f[W>>2]|0}while((na|0)<(tb|0));f[l>>2]=f[h>>2];if((tb|0)<3)la=644;else la=646}else{f[l>>2]=f[h>>2];la=644}if((la|0)==644){na=f[h+4>>2]|0;if((na|0)<3){f[W>>2]=na;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];na=f[h+44>>2]|0;fa=f[$>>2]|0;f[fa>>2]=f[na>>2];f[fa+4>>2]=f[na+4>>2]}else la=646}if((la|0)==646)jL(l,h);na=h+16|0;f[da>>2]=f[na>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];fa=f[sb>>2]|0;f[$a>>2]=fa;if(fa|0?(ea=fa+12|0,fa=f[ea>>2]|0,f[ea>>2]=fa+-1,(fa|0)==1):0)kL(h);f[sb>>2]=0;fa=h+4|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[fa>>2]|0)>0){na=f[h+40>>2]|0;ea=0;do{f[na+(ea<<2)>>2]=0;ea=ea+1|0}while((ea|0)<(f[fa>>2]|0))}fa=f[h+44>>2]|0;if((fa|0)!=(h+48|0))UC(fa);f[h>>2]=-2147483648;f[h+4>>2]=2147483647;f[i>>2]=0;f[i+4>>2]=K;lL(F,k,i,h);fa=h+8|0;f[fa>>2]=0;f[fa+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=l;SP(F,h);fa=F+36|0;ea=f[fa>>2]|0;if(ea|0?(na=ea+12|0,ea=f[na>>2]|0,f[na>>2]=ea+-1,(ea|0)==1):0)kL(F);f[fa>>2]=0;fa=F+16|0;ea=F+4|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[ea>>2]|0)>0){fa=f[F+40>>2]|0;na=0;do{f[fa+(na<<2)>>2]=0;na=na+1|0}while((na|0)<(f[ea>>2]|0))}ea=f[F+44>>2]|0;if((ea|0)!=(F+48|0))UC(ea);break}case 130:case 129:case 128:case 127:case 134:case 133:case 132:case 131:{ea=(e|0)>1?e:1;na=(d+-127|0)>>>0<4?1:2;if(!(ja&(L&510|0)==2)){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,36)|0;ma=228840;T=S+36|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11273);bD(h)}if((e|0)>=2){f[h>>2]=0;f[h+4>>2]=0;fa=aD(h,8)|0;K=fa;b[K>>0]=100;b[K+1>>0]=99;b[K+2>>0]=110;b[K+3>>0]=32;K=fa+4|0;b[K>>0]=61;b[K+1>>0]=61;b[K+2>>0]=32;b[K+3>>0]=49;bO(-215,h,228810,217660,11274);bD(h)}if((ka|aa)&1|0){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,39)|0;ma=229200;T=S+39|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11275);bD(h)}f[G>>2]=aa;f[G+4>>2]=((ka|0)/2|0)*3;vM(c,G,O|(ea<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){K=f[ba>>2]|0;f[h>>2]=f[K>>2];fa=h+4|0;$a=K+4|0;f[fa>>2]=f[$a>>2];da=h+8|0;f[da>>2]=f[K+8>>2];f[h+12>>2]=f[K+12>>2];f[h+16>>2]=f[K+16>>2];f[h+20>>2]=f[K+20>>2];f[h+24>>2]=f[K+24>>2];f[h+28>>2]=f[K+28>>2];f[h+32>>2]=f[K+32>>2];ca=h+36|0;ia=f[K+36>>2]|0;f[ca>>2]=ia;f[h+40>>2]=da;da=h+48|0;ha=h+44|0;f[ha>>2]=da;f[da>>2]=0;f[h+52>>2]=0;if(ia|0){da=ia+12|0;f[da>>2]=(f[da>>2]|0)+1}if((f[$a>>2]|0)<3){$a=f[K+44>>2]|0;da=f[ha>>2]|0;f[da>>2]=f[$a>>2];f[da+4>>2]=f[$a+4>>2];ub=ca;break}else{f[fa>>2]=0;jL(h,K);ub=ca;break}}else{yL(h,c,-1);ub=h+36|0}while(0);ea=f[ub>>2]|0;if(ea|0){ca=ea+12|0;f[ca>>2]=(f[ca>>2]|0)+1}ca=l+36|0;ea=f[ca>>2]|0;if(ea|0?(K=ea+12|0,ea=f[K>>2]|0,f[K>>2]=ea+-1,(ea|0)==1):0)kL(l);f[ca>>2]=0;ea=l+16|0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[W>>2]|0)>0){K=f[Z>>2]|0;fa=0;do{f[K+(fa<<2)>>2]=0;fa=fa+1|0;vb=f[W>>2]|0}while((fa|0)<(vb|0));f[l>>2]=f[h>>2];if((vb|0)<3)la=686;else la=688}else{f[l>>2]=f[h>>2];la=686}if((la|0)==686){fa=f[h+4>>2]|0;if((fa|0)<3){f[W>>2]=fa;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];fa=f[h+44>>2]|0;K=f[$>>2]|0;f[K>>2]=f[fa>>2];f[K+4>>2]=f[fa+4>>2]}else la=688}if((la|0)==688)jL(l,h);fa=h+16|0;f[ea>>2]=f[fa>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];K=f[ub>>2]|0;f[ca>>2]=K;if(K|0?($a=K+12|0,K=f[$a>>2]|0,f[$a>>2]=K+-1,(K|0)==1):0)kL(h);f[ub>>2]=0;K=h+4|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[K>>2]|0)>0){fa=f[h+40>>2]|0;$a=0;do{f[fa+($a<<2)>>2]=0;$a=$a+1|0}while(($a|0)<(f[K>>2]|0))}K=f[h+44>>2]|0;if((K|0)!=(h+48|0))UC(K);K=f[k+16>>2]|0;$a=f[U>>2]|0;fa=f[ea>>2]|0;ca=f[_>>2]|0;da=f[k+12>>2]|0;ha=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{wb=0;break}default:wb=1}X0(K,$a,fa,ca,da,ha,N,wb,na);break}case 122:case 121:case 120:case 119:case 118:case 117:case 116:case 115:case 112:case 111:case 108:case 107:{if((e|0)<1){ha=d+-111|0;if(ha>>>0<12)xb=(3843>>>(ha&4095)&1)+3&4095;else xb=3}else xb=e;ha=d+-107|0;if(ha>>>0<6)yb=51>>>(ha&63)&63;else yb=0;ha=yb&1;da=d+-117|0;if(da>>>0<6)zb=51>>>(da&63)&63;else zb=0;da=zb&1;if((xb+-3|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,20)|0;ma=229125;T=S+20|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11290);bD(h)}if(!(ja&(N|0)==2)){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,22)|0;ma=228926;T=S+22|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11291);bD(h)}f[H>>2]=aa;f[H+4>>2]=ka;vM(c,H,(xb<<3)+-8|0,-1,0,0);do if((yM(c)|0)==65536){na=f[ba>>2]|0;f[h>>2]=f[na>>2];ea=h+4|0;ca=na+4|0;f[ea>>2]=f[ca>>2];fa=h+8|0;f[fa>>2]=f[na+8>>2];f[h+12>>2]=f[na+12>>2];f[h+16>>2]=f[na+16>>2];f[h+20>>2]=f[na+20>>2];f[h+24>>2]=f[na+24>>2];f[h+28>>2]=f[na+28>>2];f[h+32>>2]=f[na+32>>2];$a=h+36|0;K=f[na+36>>2]|0;f[$a>>2]=K;f[h+40>>2]=fa;fa=h+48|0;ia=h+44|0;f[ia>>2]=fa;f[fa>>2]=0;f[h+52>>2]=0;if(K|0){fa=K+12|0;f[fa>>2]=(f[fa>>2]|0)+1}if((f[ca>>2]|0)<3){ca=f[na+44>>2]|0;fa=f[ia>>2]|0;f[fa>>2]=f[ca>>2];f[fa+4>>2]=f[ca+4>>2];Ab=$a;break}else{f[ea>>2]=0;jL(h,na);Ab=$a;break}}else{yL(h,c,-1);Ab=h+36|0}while(0);$a=f[Ab>>2]|0;if($a|0){na=$a+12|0;f[na>>2]=(f[na>>2]|0)+1}na=l+36|0;$a=f[na>>2]|0;if($a|0?(ea=$a+12|0,$a=f[ea>>2]|0,f[ea>>2]=$a+-1,($a|0)==1):0)kL(l);f[na>>2]=0;$a=l+16|0;f[$a>>2]=0;f[$a+4>>2]=0;f[$a+8>>2]=0;f[$a+12>>2]=0;if((f[W>>2]|0)>0){ea=f[Z>>2]|0;ca=0;do{f[ea+(ca<<2)>>2]=0;ca=ca+1|0;Bb=f[W>>2]|0}while((ca|0)<(Bb|0));f[l>>2]=f[h>>2];if((Bb|0)<3)la=728;else la=730}else{f[l>>2]=f[h>>2];la=728}if((la|0)==728){ca=f[h+4>>2]|0;if((ca|0)<3){f[W>>2]=ca;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ca=f[h+44>>2]|0;ea=f[$>>2]|0;f[ea>>2]=f[ca>>2];f[ea+4>>2]=f[ca+4>>2]}else la=730}if((la|0)==730)jL(l,h);ca=h+16|0;f[$a>>2]=f[ca>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ea=f[Ab>>2]|0;f[na>>2]=ea;if(ea|0?(fa=ea+12|0,ea=f[fa>>2]|0,f[fa>>2]=ea+-1,(ea|0)==1):0)kL(h);f[Ab>>2]=0;ea=h+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[ea>>2]|0)>0){ca=f[h+40>>2]|0;fa=0;do{f[ca+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[ea>>2]|0))}ea=f[h+44>>2]|0;if((ea|0)!=(h+48|0))UC(ea);ea=f[k+16>>2]|0;fa=f[U>>2]|0;ca=f[$a>>2]|0;na=f[_>>2]|0;ia=f[k+12>>2]|0;K=f[Q>>2]|0;switch(d|0){case 134:case 132:case 130:case 128:case 122:case 118:case 120:case 116:case 112:case 108:case 72:case 70:case 60:case 54:case 76:case 74:case 50:case 44:case 80:case 78:case 58:case 56:case 95:case 91:case 97:case 93:case 105:case 101:case 103:case 99:case 68:case 66:case 52:case 40:case 34:case 32:case 84:case 38:case 82:case 36:case 10:case 6:case 28:case 18:case 24:case 14:case 26:case 16:case 22:case 12:case 1:case 0:{Cb=0;break}default:Cb=1}_0(ea,fa,ca,na,ia,K,xb,Cb,da,ha);break}case 124:case 123:{if((e|0)>=2){f[h>>2]=0;f[h+4>>2]=0;K=aD(h,8)|0;ia=K;b[ia>>0]=100;b[ia+1>>0]=99;b[ia+2>>0]=110;b[ia+3>>0]=32;ia=K+4|0;b[ia>>0]=61;b[ia+1>>0]=61;b[ia+2>>0]=32;b[ia+3>>0]=49;bO(-215,h,228810,217660,11301);bD(h)}if(!(ja&(N|0)==2)){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,22)|0;ma=228926;T=S+22|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11302);bD(h)}ha=k+36|0;da=f[ha>>2]|0;if(da|0?($a=da+12|0,da=f[$a>>2]|0,f[$a>>2]=da+-1,(da|0)==1):0)kL(k);f[ha>>2]=0;ha=k+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[P>>2]|0)>0){ha=f[R>>2]|0;da=0;do{f[ha+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[P>>2]|0))}JI(a,c,(d|0)==123&1);break}case 125:{da=(e|0)<1?4:e;if(!(ja&((da|0)==4&(N|0)==4))){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,34)|0;ma=229240;T=S+34|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11310);bD(h)}f[I>>2]=aa;f[I+4>>2]=ka;vM(c,I,O|(da<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){ha=f[ba>>2]|0;f[h>>2]=f[ha>>2];$a=h+4|0;ia=ha+4|0;f[$a>>2]=f[ia>>2];K=h+8|0;f[K>>2]=f[ha+8>>2];f[h+12>>2]=f[ha+12>>2];f[h+16>>2]=f[ha+16>>2];f[h+20>>2]=f[ha+20>>2];f[h+24>>2]=f[ha+24>>2];f[h+28>>2]=f[ha+28>>2];f[h+32>>2]=f[ha+32>>2];na=h+36|0;ca=f[ha+36>>2]|0;f[na>>2]=ca;f[h+40>>2]=K;K=h+48|0;fa=h+44|0;f[fa>>2]=K;f[K>>2]=0;f[h+52>>2]=0;if(ca|0){K=ca+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[ia>>2]|0)<3){ia=f[ha+44>>2]|0;K=f[fa>>2]|0;f[K>>2]=f[ia>>2];f[K+4>>2]=f[ia+4>>2];Db=na;break}else{f[$a>>2]=0;jL(h,ha);Db=na;break}}else{yL(h,c,-1);Db=h+36|0}while(0);da=f[Db>>2]|0;if(da|0){na=da+12|0;f[na>>2]=(f[na>>2]|0)+1}na=l+36|0;da=f[na>>2]|0;if(da|0?(ha=da+12|0,da=f[ha>>2]|0,f[ha>>2]=da+-1,(da|0)==1):0)kL(l);f[na>>2]=0;da=l+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[W>>2]|0)>0){ha=f[Z>>2]|0;$a=0;do{f[ha+($a<<2)>>2]=0;$a=$a+1|0;Eb=f[W>>2]|0}while(($a|0)<(Eb|0));f[l>>2]=f[h>>2];if((Eb|0)<3)la=772;else la=774}else{f[l>>2]=f[h>>2];la=772}if((la|0)==772){$a=f[h+4>>2]|0;if(($a|0)<3){f[W>>2]=$a;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];$a=f[h+44>>2]|0;ha=f[$>>2]|0;f[ha>>2]=f[$a>>2];f[ha+4>>2]=f[$a+4>>2]}else la=774}if((la|0)==774)jL(l,h);$a=h+16|0;f[da>>2]=f[$a>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];ha=f[Db>>2]|0;f[na>>2]=ha;if(ha|0?(ia=ha+12|0,ha=f[ia>>2]|0,f[ia>>2]=ha+-1,(ha|0)==1):0)kL(h);f[Db>>2]=0;ha=h+4|0;f[$a>>2]=0;f[$a+4>>2]=0;f[$a+8>>2]=0;f[$a+12>>2]=0;if((f[ha>>2]|0)>0){$a=f[h+40>>2]|0;ia=0;do{f[$a+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[ha>>2]|0))}ha=f[h+44>>2]|0;if((ha|0)!=(h+48|0))UC(ha);x1(f[k+16>>2]|0,f[U>>2]|0,f[da>>2]|0,f[_>>2]|0,f[k+12>>2]|0,f[Q>>2]|0);break}case 126:{ha=(e|0)<1?4:e;if(!(ja&((ha|0)==4&(N|0)==4))){f[h>>2]=0;f[h+4>>2]=0;S=aD(h,34)|0;ma=229240;T=S+34|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-215,h,228810,217660,11317);bD(h)}f[J>>2]=aa;f[J+4>>2]=ka;vM(c,J,O|(ha<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){da=f[ba>>2]|0;f[h>>2]=f[da>>2];ia=h+4|0;$a=da+4|0;f[ia>>2]=f[$a>>2];na=h+8|0;f[na>>2]=f[da+8>>2];f[h+12>>2]=f[da+12>>2];f[h+16>>2]=f[da+16>>2];f[h+20>>2]=f[da+20>>2];f[h+24>>2]=f[da+24>>2];f[h+28>>2]=f[da+28>>2];f[h+32>>2]=f[da+32>>2];K=h+36|0;fa=f[da+36>>2]|0;f[K>>2]=fa;f[h+40>>2]=na;na=h+48|0;ca=h+44|0;f[ca>>2]=na;f[na>>2]=0;f[h+52>>2]=0;if(fa|0){na=fa+12|0;f[na>>2]=(f[na>>2]|0)+1}if((f[$a>>2]|0)<3){$a=f[da+44>>2]|0;na=f[ca>>2]|0;f[na>>2]=f[$a>>2];f[na+4>>2]=f[$a+4>>2];Fb=K;break}else{f[ia>>2]=0;jL(h,da);Fb=K;break}}else{yL(h,c,-1);Fb=h+36|0}while(0);ha=f[Fb>>2]|0;if(ha|0){K=ha+12|0;f[K>>2]=(f[K>>2]|0)+1}K=l+36|0;ha=f[K>>2]|0;if(ha|0?(da=ha+12|0,ha=f[da>>2]|0,f[da>>2]=ha+-1,(ha|0)==1):0)kL(l);f[K>>2]=0;ha=l+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[W>>2]|0)>0){da=f[Z>>2]|0;ia=0;do{f[da+(ia<<2)>>2]=0;ia=ia+1|0;Gb=f[W>>2]|0}while((ia|0)<(Gb|0));f[l>>2]=f[h>>2];if((Gb|0)<3)la=803;else la=805}else{f[l>>2]=f[h>>2];la=803}if((la|0)==803){ia=f[h+4>>2]|0;if((ia|0)<3){f[W>>2]=ia;f[X>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];ia=f[h+44>>2]|0;da=f[$>>2]|0;f[da>>2]=f[ia>>2];f[da+4>>2]=f[ia+4>>2]}else la=805}if((la|0)==805)jL(l,h);ia=h+16|0;f[ha>>2]=f[ia>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];da=f[Fb>>2]|0;f[K>>2]=da;if(da|0?($a=da+12|0,da=f[$a>>2]|0,f[$a>>2]=da+-1,(da|0)==1):0)kL(h);f[Fb>>2]=0;da=h+4|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[da>>2]|0)>0){ia=f[h+40>>2]|0;$a=0;do{f[ia+($a<<2)>>2]=0;$a=$a+1|0}while(($a|0)<(f[da>>2]|0))}da=f[h+44>>2]|0;if((da|0)!=(h+48|0))UC(da);A1(f[k+16>>2]|0,f[U>>2]|0,f[ha>>2]|0,f[_>>2]|0,f[k+12>>2]|0,f[Q>>2]|0);break}default:{f[h>>2]=0;f[h+4>>2]=0;S=aD(h,41)|0;ma=226549;T=S+41|0;do{b[S>>0]=b[ma>>0]|0;S=S+1|0;ma=ma+1|0}while((S|0)<(T|0));bO(-206,h,228810,217660,11323);bD(h)}}while(0);h=l+36|0;ma=f[h>>2]|0;if(ma|0?(S=ma+12|0,ma=f[S>>2]|0,f[S>>2]=ma+-1,(ma|0)==1):0)kL(l);f[h>>2]=0;h=l+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[W>>2]|0)>0){h=f[Z>>2]|0;Z=0;do{f[h+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[W>>2]|0))}W=f[$>>2]|0;if((W|0)!=(_|0))UC(W);W=k+36|0;_=f[W>>2]|0;if(_|0?($=_+12|0,_=f[$>>2]|0,f[$>>2]=_+-1,(_|0)==1):0)kL(k);f[W>>2]=0;W=k+16|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[P>>2]|0)>0){W=f[R>>2]|0;R=0;do{f[W+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[P>>2]|0))}P=f[V>>2]|0;if((P|0)!=(U|0))UC(P);if(!(f[j+4>>2]|0)){u=g;return}u=g;return}function E1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+208|0;g=e+144|0;h=e+88|0;i=e+32|0;j=e+16|0;k=e;tL(g,a,0,1,0,0);tL(h,c,0,1,0,0);f[i>>2]=f[h>>2];c=i+4|0;a=h+4|0;l=f[a>>2]|0;f[c>>2]=l;m=i+8|0;f[m>>2]=f[h+8>>2];f[i+12>>2]=f[h+12>>2];n=i+16|0;o=h+16|0;f[n>>2]=f[o>>2];f[i+20>>2]=f[h+20>>2];f[i+24>>2]=f[h+24>>2];f[i+28>>2]=f[h+28>>2];f[i+32>>2]=f[h+32>>2];p=i+36|0;q=h+36|0;r=f[q>>2]|0;f[p>>2]=r;s=i+40|0;f[s>>2]=m;m=i+48|0;t=i+44|0;f[t>>2]=m;f[m>>2]=0;f[i+52>>2]=0;if(!r)v=l;else{l=r+12|0;f[l>>2]=(f[l>>2]|0)+1;v=f[a>>2]|0}if((v|0)<3){v=f[h+44>>2]|0;l=f[t>>2]|0;f[l>>2]=f[v>>2];f[l+4>>2]=f[v+4>>2]}else{f[c>>2]=0;jL(i,h)}v=f[i>>2]|0;if(!((v^f[g>>2])&7))w=v;else{f[j>>2]=0;f[j+4>>2]=0;x=aD(j,26)|0;y=229328;z=x+26|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,j,229355,217660,11331);bD(j);w=f[i>>2]|0}f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=g;v=k+8|0;f[v>>2]=0;f[v+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=i;D1(j,k,d,(w>>>3&511)+1|0);if((f[n>>2]|0)!=(f[o>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;x=aD(j,21)|0;y=229366;z=x+21|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,j,229355,217660,11334);bD(j)}j=f[p>>2]|0;if(j|0?(y=j+12|0,j=f[y>>2]|0,f[y>>2]=j+-1,(j|0)==1):0)kL(i);f[p>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[c>>2]|0)>0){n=f[s>>2]|0;s=0;do{f[n+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[c>>2]|0))}c=f[t>>2]|0;if((c|0)!=(m|0))UC(c);c=f[q>>2]|0;if(c|0?(m=c+12|0,c=f[m>>2]|0,f[m>>2]=c+-1,(c|0)==1):0)kL(h);f[q>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[a>>2]|0)>0){o=f[h+40>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))UC(a);a=g+36|0;h=f[a>>2]|0;if(h|0?(q=h+12|0,h=f[q>>2]|0,f[q>>2]=h+-1,(h|0)==1):0)kL(g);f[a>>2]=0;a=g+16|0;h=g+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[h>>2]|0)>0){a=f[g+40>>2]|0;q=0;do{f[a+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return}UC(h);u=e;return}function F1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+144|0;h=g+128|0;i=g+72|0;j=g+64|0;k=g+8|0;l=g;dQ(h,51332);if(!e){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,29)|0;n=229388;o=m+29|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,229418,229426,1342);bD(i)}do if((yM(a)|0)==65536){n=f[a+4>>2]|0;f[i>>2]=f[n>>2];m=i+4|0;o=n+4|0;f[m>>2]=f[o>>2];p=i+8|0;f[p>>2]=f[n+8>>2];f[i+12>>2]=f[n+12>>2];f[i+16>>2]=f[n+16>>2];f[i+20>>2]=f[n+20>>2];f[i+24>>2]=f[n+24>>2];f[i+28>>2]=f[n+28>>2];f[i+32>>2]=f[n+32>>2];q=f[n+36>>2]|0;f[i+36>>2]=q;f[i+40>>2]=p;p=i+48|0;r=i+44|0;f[r>>2]=p;f[p>>2]=0;f[i+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[n+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[m>>2]=0;jL(i,n);break}}else yL(i,a,-1);while(0);a=f[d>>2]|0;n=f[d+4>>2]|0;if(!(Y(n,a)|0)){s=((f[i+12>>2]|0)+1|0)/2|0;t=((f[i+8>>2]|0)+1|0)/2|0}else{s=a;t=n}f[j>>2]=s;f[j+4>>2]=t;vM(c,j,f[i>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){j=f[c+4>>2]|0;f[k>>2]=f[j>>2];t=k+4|0;s=j+4|0;f[t>>2]=f[s>>2];n=k+8|0;f[n>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];a=k+16|0;f[a>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];d=f[j+36>>2]|0;f[k+36>>2]=d;f[k+40>>2]=n;n=k+48|0;m=k+44|0;f[m>>2]=n;f[n>>2]=0;f[k+52>>2]=0;if(d|0){n=d+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[s>>2]|0)<3){s=f[j+44>>2]|0;n=f[m>>2]|0;f[n>>2]=f[s>>2];f[n+4>>2]=f[s+4>>2];v=a;break}else{f[t>>2]=0;jL(k,j);v=a;break}}else{yL(k,c,-1);v=k+16|0}while(0);c=i+16|0;switch(f[i>>2]&7){case 0:{w=243;break}case 3:{w=244;break}case 2:{w=245;break}case 5:{w=246;break}case 6:{w=247;break}default:{f[l>>2]=0;f[l+4>>2]=0;bO(-210,l,229418,229426,1383);bD(l)}}_h[w&255](i,k,e);e=k+36|0;w=f[e>>2]|0;if(w|0?(l=w+12|0,w=f[l>>2]|0,f[l>>2]=w+-1,(w|0)==1):0)kL(k);f[e>>2]=0;e=k+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[e>>2]|0)>0){v=f[k+40>>2]|0;w=0;do{f[v+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[e>>2]|0))}e=f[k+44>>2]|0;if((e|0)!=(k+48|0))UC(e);e=i+36|0;k=f[e>>2]|0;if(k|0?(w=k+12|0,k=f[w>>2]|0,f[w>>2]=k+-1,(k|0)==1):0)kL(i);f[e>>2]=0;e=i+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[e>>2]|0)>0){c=f[i+40>>2]|0;k=0;do{f[c+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[e>>2]|0))}e=f[i+44>>2]|0;if((e|0)!=(i+48|0))UC(e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function G1(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;g=u;u=u+30816|0;h=g+29744|0;i=g+15408|0;j=g+1072|0;k=g+8|0;l=g;m=a+16|0;if(f[m>>2]|0){n=f[a+4>>2]|0;if((n|0)<3)o=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{p=f[a+40>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(n|0)){o=s;break}else r=s}}if((n|0)==0|(o|0)==0)t=7}else t=7;if((t|0)==7){f[h>>2]=0;f[h+4>>2]=0;t=aD(h,13)|0;o=229499;n=t+13|0;do{b[t>>0]=b[o>>0]|0;t=t+1|0;o=o+1|0}while((t|0)<(n|0));bO(-215,h,229513,229426,858);bD(h)}o=f[a+40>>2]|0;t=f[o+4>>2]|0;n=f[o>>2]|0;o=f[c+40>>2]|0;r=f[o+4>>2]|0;q=f[o>>2]|0;o=(f[a>>2]|0)>>>3;p=(o&511)+1|0;s=Y(p,r)|0;v=s+15&-16;w=(v*5|0)+16|0;x=h+8|0;f[h>>2]=x;y=h+4|0;f[y>>2]=w;if(w>>>0>264){z=N5b(w>>>0>1073741823?-1:w<<2)|0;f[h>>2]=z;A=z}else A=x;z=A+15&-16;A=k+8|0;f[k>>2]=A;w=k+4|0;f[w>>2]=s;if(s>>>0>264){B=N5b(s>>>0>1073741823?-1:s<<2)|0;f[k>>2]=B;C=B}else C=A;if(!(((t|0)>0&(n|0)>0?(B=(r<<1)-t|0,(((B|0)>-1?B:0-B|0)|0)<3):0)?(B=(q<<1)-n|0,(((B|0)>-1?B:0-B|0)|0)<3):0)){f[l>>2]=0;f[l+4>>2]=0;Vac(aD(l,129)|0,229522,129)|0;bO(-215,l,229513,229426,873);bD(l)}l=((t+-3|0)/2|0)+1|0;B=(r|0)<(l|0)?r:l;l=(B<<1)+-2|0;r=0;do{D=Y(ZP(r+-2|0,t,e)|0,p)|0;E=Y(ZP(l+r|0,t,e)|0,p)|0;F=Y(r,p)|0;G=0;do{H=G+F|0;f[i+(H<<2)>>2]=G+D;f[j+(H<<2)>>2]=G+E;G=G+1|0}while((G|0)!=(p|0));r=r+1|0}while((r|0)<7);r=Y(p,B)|0;B=(s|0)>0;if(B){t=p<<1;l=0;do{G=(Y(t,(l|0)/(p|0)|0)|0)+((l|0)%(p|0)|0)|0;f[C+(l<<2)>>2]=G;l=l+1|0}while((l|0)!=(s|0))}if((q|0)>0){l=c+16|0;t=c+44|0;c=a+44|0;a=o&65535;o=p<<1;G=p*3|0;E=p<<2;D=-2;F=0;while(1){H=(f[l>>2]|0)+(Y(f[f[t>>2]>>2]|0,F)|0)|0;I=F<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=z+((Y((L+2|0)%5|0,v)|0)<<2)|0;N=ZP(L,n,e)|0;O=(f[m>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=p;P=i;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{f[M+(R<<2)>>2]=((d[O+(f[P+(R+G<<2)>>2]<<1)>>1]|0)+(d[O+(f[P+(R+p<<2)>>2]<<1)>>1]|0)<<2)+((d[O+(f[P+(R+o<<2)>>2]<<1)>>1]|0)*6|0)+(d[O+(f[P+(R<<2)>>2]<<1)>>1]|0)+(d[O+(f[P+(R+E<<2)>>2]<<1)>>1]|0);R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(s|0))break;switch(a&511){case 0:{if((S|0)<(r|0)){R=S;do{T=R<<1;f[M+(R<<2)>>2]=(d[O+(T+-2<<1)>>1]|0)+((d[O+(T<<1)>>1]|0)*6|0)+((d[O+((T|1)<<1)>>1]|0)+(d[O+(T+-1<<1)>>1]|0)<<2)+(d[O+(T+2<<1)>>1]|0);R=R+1|0}while((R|0)<(r|0));U=r}else U=S;break}case 2:{if((S|0)<(r|0)){R=S;while(1){T=O+(R<<1<<1)|0;V=(d[T+-10>>1]|0)+((d[T+2>>1]|0)*6|0)+((d[T+8>>1]|0)+(d[T+-4>>1]|0)<<2)+(d[T+14>>1]|0)|0;W=(d[T+-8>>1]|0)+((d[T+4>>1]|0)*6|0)+((d[T+10>>1]|0)+(d[T+-2>>1]|0)<<2)+(d[T+16>>1]|0)|0;f[M+(R<<2)>>2]=(d[T+-12>>1]|0)+((d[T>>1]|0)*6|0)+((d[T+6>>1]|0)+(d[T+-6>>1]|0)<<2)+(d[T+12>>1]|0);f[M+(R+1<<2)>>2]=V;f[M+(R+2<<2)>>2]=W;W=R+3|0;if((W|0)<(r|0))R=W;else{U=W;break}}}else U=S;break}case 3:{if((S|0)<(r|0)){R=S;while(1){W=O+(R<<1<<1)|0;V=(d[W+-14>>1]|0)+((d[W+2>>1]|0)*6|0)+((d[W+10>>1]|0)+(d[W+-6>>1]|0)<<2)+(d[W+18>>1]|0)|0;f[M+(R<<2)>>2]=(d[W+-16>>1]|0)+((d[W>>1]|0)*6|0)+((d[W+8>>1]|0)+(d[W+-8>>1]|0)<<2)+(d[W+16>>1]|0);f[M+(R+1<<2)>>2]=V;V=(d[W+-10>>1]|0)+((d[W+6>>1]|0)*6|0)+((d[W+14>>1]|0)+(d[W+-2>>1]|0)<<2)+(d[W+22>>1]|0)|0;f[M+(R+2<<2)>>2]=(d[W+-12>>1]|0)+((d[W+4>>1]|0)*6|0)+((d[W+12>>1]|0)+(d[W+-4>>1]|0)<<2)+(d[W+20>>1]|0);f[M+(R+3<<2)>>2]=V;V=R+4|0;if((V|0)<(r|0))R=V;else{U=V;break}}}else U=S;break}default:if((S|0)<(r|0)){R=S;do{V=f[C+(R<<2)>>2]|0;f[M+(R<<2)>>2]=(d[O+(V-o<<1)>>1]|0)+((d[O+(V<<1)>>1]|0)*6|0)+((d[O+(V+p<<1)>>1]|0)+(d[O+(V-p<<1)>>1]|0)<<2)+(d[O+(V+o<<1)>>1]|0);R=R+1|0}while((R|0)<(r|0));U=r}else U=S}N=s;P=j+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=z+((Y((I|0)%5|0,v)|0)<<2)|0;Q=z+((Y((I|1|0)%5|0,v)|0)<<2)|0;P=z+((Y((J|0)%5|0,v)|0)<<2)|0;N=z+((Y((I+3|0)%5|0,v)|0)<<2)|0;O=z+((Y((I+4|0)%5|0,v)|0)<<2)|0;if(B){M=0;do{d[H+(M<<1)>>1]=(((f[P+(M<<2)>>2]|0)*6|0)+128+(f[L+(M<<2)>>2]|0)+((f[N+(M<<2)>>2]|0)+(f[Q+(M<<2)>>2]|0)<<2)+(f[O+(M<<2)>>2]|0)|0)>>>8;M=M+1|0}while((M|0)!=(s|0))}F=F+1|0;if((F|0)>=(q|0))break;else D=K}}K=f[k>>2]|0;if((K|0)!=(A|0)){if(K|0)P5b(K);f[k>>2]=A;f[w>>2]=264}w=f[h>>2]|0;if((w|0)==(x|0)){u=g;return}if(w|0)P5b(w);f[h>>2]=x;f[y>>2]=264;u=g;return}function H1(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;g=u;u=u+30816|0;h=g+29744|0;i=g+15408|0;k=g+1072|0;l=g+8|0;m=g;n=a+16|0;if(f[n>>2]|0){o=f[a+4>>2]|0;if((o|0)<3)p=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{q=f[a+40>>2]|0;r=0;s=1;while(1){t=Y(f[q+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(o|0)){p=t;break}else s=t}}if((o|0)==0|(p|0)==0)v=7}else v=7;if((v|0)==7){f[h>>2]=0;f[h+4>>2]=0;v=aD(h,13)|0;p=229499;o=v+13|0;do{b[v>>0]=b[p>>0]|0;v=v+1|0;p=p+1|0}while((v|0)<(o|0));bO(-215,h,229513,229426,858);bD(h)}p=f[a+40>>2]|0;v=f[p+4>>2]|0;o=f[p>>2]|0;p=f[c+40>>2]|0;s=f[p+4>>2]|0;r=f[p>>2]|0;p=(f[a>>2]|0)>>>3;q=(p&511)+1|0;t=Y(q,s)|0;w=t+15&-16;x=(w*5|0)+16|0;y=h+8|0;f[h>>2]=y;z=h+4|0;f[z>>2]=x;if(x>>>0>264){A=N5b(x>>>0>1073741823?-1:x<<2)|0;f[h>>2]=A;B=A}else B=y;A=B+15&-16;B=l+8|0;f[l>>2]=B;x=l+4|0;f[x>>2]=t;if(t>>>0>264){C=N5b(t>>>0>1073741823?-1:t<<2)|0;f[l>>2]=C;D=C}else D=B;if(!(((v|0)>0&(o|0)>0?(C=(s<<1)-v|0,(((C|0)>-1?C:0-C|0)|0)<3):0)?(C=(r<<1)-o|0,(((C|0)>-1?C:0-C|0)|0)<3):0)){f[m>>2]=0;f[m+4>>2]=0;Vac(aD(m,129)|0,229522,129)|0;bO(-215,m,229513,229426,873);bD(m)}m=((v+-3|0)/2|0)+1|0;C=(s|0)<(m|0)?s:m;m=(C<<1)+-2|0;s=0;do{E=Y(ZP(s+-2|0,v,e)|0,q)|0;F=Y(ZP(m+s|0,v,e)|0,q)|0;G=Y(s,q)|0;H=0;do{I=H+G|0;f[i+(I<<2)>>2]=H+E;f[k+(I<<2)>>2]=H+F;H=H+1|0}while((H|0)!=(q|0));s=s+1|0}while((s|0)<7);s=Y(q,C)|0;C=(t|0)>0;if(C){v=q<<1;m=0;do{H=(Y(v,(m|0)/(q|0)|0)|0)+((m|0)%(q|0)|0)|0;f[D+(m<<2)>>2]=H;m=m+1|0}while((m|0)!=(t|0))}if((r|0)>0){m=c+16|0;v=c+44|0;c=a+44|0;a=p&65535;p=q<<1;H=q*3|0;F=q<<2;E=-2;G=0;while(1){I=(f[m>>2]|0)+(Y(f[f[v>>2]>>2]|0,G)|0)|0;J=G<<1;K=J+2|0;if((E|0)>(K|0))L=E;else{M=E;while(1){N=A+((Y((M+2|0)%5|0,w)|0)<<2)|0;O=ZP(M,o,e)|0;P=(f[n>>2]|0)+(Y(f[f[c>>2]>>2]|0,O)|0)|0;O=q;Q=i;R=0;while(1){if((R|0)<(O|0)){S=R;do{f[N+(S<<2)>>2]=((j[P+(f[Q+(S+H<<2)>>2]<<1)>>1]|0)+(j[P+(f[Q+(S+q<<2)>>2]<<1)>>1]|0)<<2)+((j[P+(f[Q+(S+p<<2)>>2]<<1)>>1]|0)*6|0)+(j[P+(f[Q+(S<<2)>>2]<<1)>>1]|0)+(j[P+(f[Q+(S+F<<2)>>2]<<1)>>1]|0);S=S+1|0}while((S|0)!=(O|0));T=O}else T=R;if((T|0)==(t|0))break;switch(a&511){case 0:{if((T|0)<(s|0)){S=T;do{U=S<<1;f[N+(S<<2)>>2]=(j[P+(U+-2<<1)>>1]|0)+((j[P+(U<<1)>>1]|0)*6|0)+((j[P+((U|1)<<1)>>1]|0)+(j[P+(U+-1<<1)>>1]|0)<<2)+(j[P+(U+2<<1)>>1]|0);S=S+1|0}while((S|0)<(s|0));V=s}else V=T;break}case 2:{if((T|0)<(s|0)){S=T;while(1){U=P+(S<<1<<1)|0;W=(j[U+-10>>1]|0)+((j[U+2>>1]|0)*6|0)+((j[U+8>>1]|0)+(j[U+-4>>1]|0)<<2)+(j[U+14>>1]|0)|0;X=(j[U+-8>>1]|0)+((j[U+4>>1]|0)*6|0)+((j[U+10>>1]|0)+(j[U+-2>>1]|0)<<2)+(j[U+16>>1]|0)|0;f[N+(S<<2)>>2]=(j[U+-12>>1]|0)+((j[U>>1]|0)*6|0)+((j[U+6>>1]|0)+(j[U+-6>>1]|0)<<2)+(j[U+12>>1]|0);f[N+(S+1<<2)>>2]=W;f[N+(S+2<<2)>>2]=X;X=S+3|0;if((X|0)<(s|0))S=X;else{V=X;break}}}else V=T;break}case 3:{if((T|0)<(s|0)){S=T;while(1){X=P+(S<<1<<1)|0;W=(j[X+-14>>1]|0)+((j[X+2>>1]|0)*6|0)+((j[X+10>>1]|0)+(j[X+-6>>1]|0)<<2)+(j[X+18>>1]|0)|0;f[N+(S<<2)>>2]=(j[X+-16>>1]|0)+((j[X>>1]|0)*6|0)+((j[X+8>>1]|0)+(j[X+-8>>1]|0)<<2)+(j[X+16>>1]|0);f[N+(S+1<<2)>>2]=W;W=(j[X+-10>>1]|0)+((j[X+6>>1]|0)*6|0)+((j[X+14>>1]|0)+(j[X+-2>>1]|0)<<2)+(j[X+22>>1]|0)|0;f[N+(S+2<<2)>>2]=(j[X+-12>>1]|0)+((j[X+4>>1]|0)*6|0)+((j[X+12>>1]|0)+(j[X+-4>>1]|0)<<2)+(j[X+20>>1]|0);f[N+(S+3<<2)>>2]=W;W=S+4|0;if((W|0)<(s|0))S=W;else{V=W;break}}}else V=T;break}default:if((T|0)<(s|0)){S=T;do{W=f[D+(S<<2)>>2]|0;f[N+(S<<2)>>2]=(j[P+(W-p<<1)>>1]|0)+((j[P+(W<<1)>>1]|0)*6|0)+((j[P+(W+q<<1)>>1]|0)+(j[P+(W-q<<1)>>1]|0)<<2)+(j[P+(W+p<<1)>>1]|0);S=S+1|0}while((S|0)<(s|0));V=s}else V=T}O=t;Q=k+(0-V<<2)|0;R=V}R=M+1|0;if((M|0)<(K|0))M=R;else{L=R;break}}}M=A+((Y((J|0)%5|0,w)|0)<<2)|0;R=A+((Y((J|1|0)%5|0,w)|0)<<2)|0;Q=A+((Y((K|0)%5|0,w)|0)<<2)|0;O=A+((Y((J+3|0)%5|0,w)|0)<<2)|0;P=A+((Y((J+4|0)%5|0,w)|0)<<2)|0;if(C){N=0;do{d[I+(N<<1)>>1]=(((f[Q+(N<<2)>>2]|0)*6|0)+128+(f[M+(N<<2)>>2]|0)+((f[O+(N<<2)>>2]|0)+(f[R+(N<<2)>>2]|0)<<2)+(f[P+(N<<2)>>2]|0)|0)>>>8;N=N+1|0}while((N|0)!=(t|0))}G=G+1|0;if((G|0)>=(r|0))break;else E=L}}L=f[l>>2]|0;if((L|0)!=(B|0)){if(L|0)P5b(L);f[l>>2]=B;f[x>>2]=264}x=f[h>>2]|0;if((x|0)==(y|0)){u=g;return}if(x|0)P5b(x);f[h>>2]=y;f[z>>2]=264;u=g;return}function I1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0;e=u;u=u+30816|0;g=e+29744|0;h=e+15408|0;i=e+1072|0;j=e+8|0;k=e;l=a+16|0;if(f[l>>2]|0){m=f[a+4>>2]|0;if((m|0)<3)o=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{p=f[a+40>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(m|0)){o=s;break}else r=s}}if((m|0)==0|(o|0)==0)t=7}else t=7;if((t|0)==7){f[g>>2]=0;f[g+4>>2]=0;t=aD(g,13)|0;o=229499;m=t+13|0;do{b[t>>0]=b[o>>0]|0;t=t+1|0;o=o+1|0}while((t|0)<(m|0));bO(-215,g,229513,229426,858);bD(g)}o=f[a+40>>2]|0;t=f[o+4>>2]|0;m=f[o>>2]|0;o=f[c+40>>2]|0;r=f[o+4>>2]|0;q=f[o>>2]|0;o=(f[a>>2]|0)>>>3;p=(o&511)+1|0;s=Y(p,r)|0;v=s+15&-16;w=(v*5|0)+16|0;x=g+8|0;f[g>>2]=x;y=g+4|0;f[y>>2]=w;if(w>>>0>264){z=N5b(w>>>0>1073741823?-1:w<<2)|0;f[g>>2]=z;A=z}else A=x;z=A+15&-16;A=j+8|0;f[j>>2]=A;w=j+4|0;f[w>>2]=s;if(s>>>0>264){B=N5b(s>>>0>1073741823?-1:s<<2)|0;f[j>>2]=B;C=B}else C=A;if(!(((t|0)>0&(m|0)>0?(B=(r<<1)-t|0,(((B|0)>-1?B:0-B|0)|0)<3):0)?(B=(q<<1)-m|0,(((B|0)>-1?B:0-B|0)|0)<3):0)){f[k>>2]=0;f[k+4>>2]=0;Vac(aD(k,129)|0,229522,129)|0;bO(-215,k,229513,229426,873);bD(k)}k=((t+-3|0)/2|0)+1|0;B=(r|0)<(k|0)?r:k;k=(B<<1)+-2|0;r=0;do{D=Y(ZP(r+-2|0,t,d)|0,p)|0;E=Y(ZP(k+r|0,t,d)|0,p)|0;F=Y(r,p)|0;G=0;do{H=G+F|0;f[h+(H<<2)>>2]=G+D;f[i+(H<<2)>>2]=G+E;G=G+1|0}while((G|0)!=(p|0));r=r+1|0}while((r|0)<7);r=Y(p,B)|0;B=(s|0)>0;if(B){t=p<<1;k=0;do{G=(Y(t,(k|0)/(p|0)|0)|0)+((k|0)%(p|0)|0)|0;f[C+(k<<2)>>2]=G;k=k+1|0}while((k|0)!=(s|0))}if((q|0)>0){k=c+16|0;t=c+44|0;c=a+44|0;a=o&65535;o=p<<1;G=p*3|0;E=p<<2;D=-2;F=0;while(1){H=(f[k>>2]|0)+(Y(f[f[t>>2]>>2]|0,F)|0)|0;I=F<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=z+((Y((L+2|0)%5|0,v)|0)<<2)|0;N=ZP(L,m,d)|0;O=(f[l>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=p;P=h;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{n[M+(R<<2)>>2]=+n[O+(f[P+(R<<2)>>2]<<2)>>2]+(+n[O+(f[P+(R+o<<2)>>2]<<2)>>2]*6.0+(+n[O+(f[P+(R+p<<2)>>2]<<2)>>2]+ +n[O+(f[P+(R+G<<2)>>2]<<2)>>2])*4.0)+ +n[O+(f[P+(R+E<<2)>>2]<<2)>>2];R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(s|0))break;switch(a&511){case 0:{if((S|0)<(r|0)){R=S;do{T=R<<1;n[M+(R<<2)>>2]=+n[O+(T+2<<2)>>2]+(+n[O+(T+-2<<2)>>2]+(+n[O+(T<<2)>>2]*6.0+(+n[O+(T+-1<<2)>>2]+ +n[O+((T|1)<<2)>>2])*4.0));R=R+1|0}while((R|0)<(r|0));U=r}else U=S;break}case 2:{if((S|0)<(r|0)){R=S;while(1){T=O+(R<<1<<2)|0;V=+n[T+28>>2]+(+n[T+-20>>2]+(+n[T+4>>2]*6.0+(+n[T+-8>>2]+ +n[T+16>>2])*4.0));W=+n[T+32>>2]+(+n[T+-16>>2]+(+n[T+8>>2]*6.0+(+n[T+-4>>2]+ +n[T+20>>2])*4.0));n[M+(R<<2)>>2]=+n[T+24>>2]+(+n[T+-24>>2]+(+n[T>>2]*6.0+(+n[T+-12>>2]+ +n[T+12>>2])*4.0));n[M+(R+1<<2)>>2]=V;n[M+(R+2<<2)>>2]=W;T=R+3|0;if((T|0)<(r|0))R=T;else{U=T;break}}}else U=S;break}case 3:{if((S|0)<(r|0)){R=S;while(1){T=O+(R<<1<<2)|0;W=+n[T+36>>2]+(+n[T+-28>>2]+(+n[T+4>>2]*6.0+(+n[T+-12>>2]+ +n[T+20>>2])*4.0));n[M+(R<<2)>>2]=+n[T+32>>2]+(+n[T+-32>>2]+(+n[T>>2]*6.0+(+n[T+-16>>2]+ +n[T+16>>2])*4.0));n[M+(R+1<<2)>>2]=W;W=+n[T+44>>2]+(+n[T+-20>>2]+(+n[T+12>>2]*6.0+(+n[T+-4>>2]+ +n[T+28>>2])*4.0));n[M+(R+2<<2)>>2]=+n[T+40>>2]+(+n[T+-24>>2]+(+n[T+8>>2]*6.0+(+n[T+-8>>2]+ +n[T+24>>2])*4.0));n[M+(R+3<<2)>>2]=W;T=R+4|0;if((T|0)<(r|0))R=T;else{U=T;break}}}else U=S;break}default:if((S|0)<(r|0)){R=S;do{T=f[C+(R<<2)>>2]|0;n[M+(R<<2)>>2]=+n[O+(T+o<<2)>>2]+(+n[O+(T-o<<2)>>2]+(+n[O+(T<<2)>>2]*6.0+(+n[O+(T-p<<2)>>2]+ +n[O+(T+p<<2)>>2])*4.0));R=R+1|0}while((R|0)<(r|0));U=r}else U=S}N=s;P=i+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=z+((Y((I|0)%5|0,v)|0)<<2)|0;Q=z+((Y((I|1|0)%5|0,v)|0)<<2)|0;P=z+((Y((J|0)%5|0,v)|0)<<2)|0;N=z+((Y((I+3|0)%5|0,v)|0)<<2)|0;O=z+((Y((I+4|0)%5|0,v)|0)<<2)|0;if(B){M=0;do{n[H+(M<<2)>>2]=(+n[O+(M<<2)>>2]+(+n[L+(M<<2)>>2]+(+n[P+(M<<2)>>2]*6.0+(+n[Q+(M<<2)>>2]+ +n[N+(M<<2)>>2])*4.0)))*.00390625;M=M+1|0}while((M|0)!=(s|0))}F=F+1|0;if((F|0)>=(q|0))break;else D=K}}K=f[j>>2]|0;if((K|0)!=(A|0)){if(K|0)P5b(K);f[j>>2]=A;f[w>>2]=264}w=f[g>>2]|0;if((w|0)==(x|0)){u=e;return}if(w|0)P5b(w);f[g>>2]=x;f[y>>2]=264;u=e;return}function J1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0;e=u;u=u+30848|0;g=e;h=e+16504|0;i=e+2168|0;j=e+1104|0;k=e+1096|0;l=a+16|0;if(f[l>>2]|0){m=f[a+4>>2]|0;if((m|0)<3)n=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{o=f[a+40>>2]|0;q=0;r=1;while(1){s=Y(f[o+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(m|0)){n=s;break}else r=s}}if((m|0)==0|(n|0)==0)t=7}else t=7;if((t|0)==7){f[g>>2]=0;f[g+4>>2]=0;t=aD(g,13)|0;n=229499;m=t+13|0;do{b[t>>0]=b[n>>0]|0;t=t+1|0;n=n+1|0}while((t|0)<(m|0));bO(-215,g,229513,229426,858);bD(g)}n=f[a+40>>2]|0;t=f[n+4>>2]|0;m=f[n>>2]|0;n=f[c+40>>2]|0;r=f[n+4>>2]|0;q=f[n>>2]|0;n=(f[a>>2]|0)>>>3;o=(n&511)+1|0;s=Y(o,r)|0;v=s+15&-16;w=(v*5|0)+16|0;x=g+8|0;f[g>>2]=x;y=g+4|0;f[y>>2]=w;if(w>>>0>136){z=N5b(w>>>0>536870911?-1:w<<3)|0;f[g>>2]=z;A=z}else A=x;z=A+15&-16;A=j+8|0;f[j>>2]=A;w=j+4|0;f[w>>2]=s;if(s>>>0>264){B=N5b(s>>>0>1073741823?-1:s<<2)|0;f[j>>2]=B;C=B}else C=A;if(!(((t|0)>0&(m|0)>0?(B=(r<<1)-t|0,(((B|0)>-1?B:0-B|0)|0)<3):0)?(B=(q<<1)-m|0,(((B|0)>-1?B:0-B|0)|0)<3):0)){f[k>>2]=0;f[k+4>>2]=0;Vac(aD(k,129)|0,229522,129)|0;bO(-215,k,229513,229426,873);bD(k)}k=((t+-3|0)/2|0)+1|0;B=(r|0)<(k|0)?r:k;k=(B<<1)+-2|0;r=0;do{D=Y(ZP(r+-2|0,t,d)|0,o)|0;E=Y(ZP(k+r|0,t,d)|0,o)|0;F=Y(r,o)|0;G=0;do{H=G+F|0;f[h+(H<<2)>>2]=G+D;f[i+(H<<2)>>2]=G+E;G=G+1|0}while((G|0)!=(o|0));r=r+1|0}while((r|0)<7);r=Y(o,B)|0;B=(s|0)>0;if(B){t=o<<1;k=0;do{G=(Y(t,(k|0)/(o|0)|0)|0)+((k|0)%(o|0)|0)|0;f[C+(k<<2)>>2]=G;k=k+1|0}while((k|0)!=(s|0))}if((q|0)>0){k=c+16|0;t=c+44|0;c=a+44|0;a=n&65535;n=o<<1;G=o*3|0;E=o<<2;D=-2;F=0;while(1){H=(f[k>>2]|0)+(Y(f[f[t>>2]>>2]|0,F)|0)|0;I=F<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=z+((Y((L+2|0)%5|0,v)|0)<<3)|0;N=ZP(L,m,d)|0;O=(f[l>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=o;P=h;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{p[M+(R<<3)>>3]=+p[O+(f[P+(R<<2)>>2]<<3)>>3]+(+p[O+(f[P+(R+n<<2)>>2]<<3)>>3]*6.0+(+p[O+(f[P+(R+o<<2)>>2]<<3)>>3]+ +p[O+(f[P+(R+G<<2)>>2]<<3)>>3])*4.0)+ +p[O+(f[P+(R+E<<2)>>2]<<3)>>3];R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(s|0))break;switch(a&511){case 0:{if((S|0)<(r|0)){R=S;do{T=R<<1;p[M+(R<<3)>>3]=+p[O+(T+2<<3)>>3]+(+p[O+(T+-2<<3)>>3]+(+p[O+(T<<3)>>3]*6.0+(+p[O+(T+-1<<3)>>3]+ +p[O+((T|1)<<3)>>3])*4.0));R=R+1|0}while((R|0)<(r|0));U=r}else U=S;break}case 2:{if((S|0)<(r|0)){R=S;while(1){T=O+(R<<1<<3)|0;V=+p[T+56>>3]+(+p[T+-40>>3]+(+p[T+8>>3]*6.0+(+p[T+-16>>3]+ +p[T+32>>3])*4.0));W=+p[T+64>>3]+(+p[T+-32>>3]+(+p[T+16>>3]*6.0+(+p[T+-8>>3]+ +p[T+40>>3])*4.0));p[M+(R<<3)>>3]=+p[T+48>>3]+(+p[T+-48>>3]+(+p[T>>3]*6.0+(+p[T+-24>>3]+ +p[T+24>>3])*4.0));p[M+(R+1<<3)>>3]=V;p[M+(R+2<<3)>>3]=W;T=R+3|0;if((T|0)<(r|0))R=T;else{U=T;break}}}else U=S;break}case 3:{if((S|0)<(r|0)){R=S;while(1){T=O+(R<<1<<3)|0;W=+p[T+72>>3]+(+p[T+-56>>3]+(+p[T+8>>3]*6.0+(+p[T+-24>>3]+ +p[T+40>>3])*4.0));p[M+(R<<3)>>3]=+p[T+64>>3]+(+p[T+-64>>3]+(+p[T>>3]*6.0+(+p[T+-32>>3]+ +p[T+32>>3])*4.0));p[M+(R+1<<3)>>3]=W;W=+p[T+88>>3]+(+p[T+-40>>3]+(+p[T+24>>3]*6.0+(+p[T+-8>>3]+ +p[T+56>>3])*4.0));p[M+(R+2<<3)>>3]=+p[T+80>>3]+(+p[T+-48>>3]+(+p[T+16>>3]*6.0+(+p[T+-16>>3]+ +p[T+48>>3])*4.0));p[M+(R+3<<3)>>3]=W;T=R+4|0;if((T|0)<(r|0))R=T;else{U=T;break}}}else U=S;break}default:if((S|0)<(r|0)){R=S;do{T=f[C+(R<<2)>>2]|0;p[M+(R<<3)>>3]=+p[O+(T+n<<3)>>3]+(+p[O+(T-n<<3)>>3]+(+p[O+(T<<3)>>3]*6.0+(+p[O+(T-o<<3)>>3]+ +p[O+(T+o<<3)>>3])*4.0));R=R+1|0}while((R|0)<(r|0));U=r}else U=S}N=s;P=i+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=z+((Y((I|0)%5|0,v)|0)<<3)|0;Q=z+((Y((I|1|0)%5|0,v)|0)<<3)|0;P=z+((Y((J|0)%5|0,v)|0)<<3)|0;N=z+((Y((I+3|0)%5|0,v)|0)<<3)|0;O=z+((Y((I+4|0)%5|0,v)|0)<<3)|0;if(B){M=0;do{p[H+(M<<3)>>3]=(+p[O+(M<<3)>>3]+(+p[L+(M<<3)>>3]+(+p[P+(M<<3)>>3]*6.0+(+p[Q+(M<<3)>>3]+ +p[N+(M<<3)>>3])*4.0)))*.00390625;M=M+1|0}while((M|0)!=(s|0))}F=F+1|0;if((F|0)>=(q|0))break;else D=K}}K=f[j>>2]|0;if((K|0)!=(A|0)){if(K|0)P5b(K);f[j>>2]=A;f[w>>2]=264}w=f[g>>2]|0;if((w|0)==(x|0)){u=e;return}if(w|0)P5b(w);f[g>>2]=x;f[y>>2]=136;u=e;return}function K1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;e=u;u=u+30816|0;g=e+29744|0;i=e+15408|0;j=e+1072|0;k=e+8|0;l=e;m=a+16|0;if(f[m>>2]|0){n=f[a+4>>2]|0;if((n|0)<3)o=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{p=f[a+40>>2]|0;q=0;r=1;while(1){s=Y(f[p+(q<<2)>>2]|0,r)|0;q=q+1|0;if((q|0)==(n|0)){o=s;break}else r=s}}if((n|0)==0|(o|0)==0)t=7}else t=7;if((t|0)==7){f[g>>2]=0;f[g+4>>2]=0;t=aD(g,13)|0;o=229499;n=t+13|0;do{b[t>>0]=b[o>>0]|0;t=t+1|0;o=o+1|0}while((t|0)<(n|0));bO(-215,g,229513,229426,858);bD(g)}o=f[a+40>>2]|0;t=f[o+4>>2]|0;n=f[o>>2]|0;o=f[c+40>>2]|0;r=f[o+4>>2]|0;q=f[o>>2]|0;o=(f[a>>2]|0)>>>3;p=(o&511)+1|0;s=Y(p,r)|0;v=s+15&-16;w=(v*5|0)+16|0;x=g+8|0;f[g>>2]=x;y=g+4|0;f[y>>2]=w;if(w>>>0>264){z=N5b(w>>>0>1073741823?-1:w<<2)|0;f[g>>2]=z;A=z}else A=x;z=A+15&-16;A=k+8|0;f[k>>2]=A;w=k+4|0;f[w>>2]=s;if(s>>>0>264){B=N5b(s>>>0>1073741823?-1:s<<2)|0;f[k>>2]=B;C=B}else C=A;if(!(((t|0)>0&(n|0)>0?(B=(r<<1)-t|0,(((B|0)>-1?B:0-B|0)|0)<3):0)?(B=(q<<1)-n|0,(((B|0)>-1?B:0-B|0)|0)<3):0)){f[l>>2]=0;f[l+4>>2]=0;Vac(aD(l,129)|0,229522,129)|0;bO(-215,l,229513,229426,873);bD(l)}l=((t+-3|0)/2|0)+1|0;B=(r|0)<(l|0)?r:l;l=(B<<1)+-2|0;r=0;do{D=Y(ZP(r+-2|0,t,d)|0,p)|0;E=Y(ZP(l+r|0,t,d)|0,p)|0;F=Y(r,p)|0;G=0;do{H=G+F|0;f[i+(H<<2)>>2]=G+D;f[j+(H<<2)>>2]=G+E;G=G+1|0}while((G|0)!=(p|0));r=r+1|0}while((r|0)<7);r=Y(p,B)|0;B=(s|0)>0;if(B){t=p<<1;l=0;do{G=(Y(t,(l|0)/(p|0)|0)|0)+((l|0)%(p|0)|0)|0;f[C+(l<<2)>>2]=G;l=l+1|0}while((l|0)!=(s|0))}if((q|0)>0){l=c+16|0;t=c+44|0;c=a+44|0;a=o&65535;o=p<<1;G=p*3|0;E=p<<2;D=-2;F=0;while(1){H=(f[l>>2]|0)+(Y(f[f[t>>2]>>2]|0,F)|0)|0;I=F<<1;J=I+2|0;if((D|0)>(J|0))K=D;else{L=D;while(1){M=z+((Y((L+2|0)%5|0,v)|0)<<2)|0;N=ZP(L,n,d)|0;O=(f[m>>2]|0)+(Y(f[f[c>>2]>>2]|0,N)|0)|0;N=p;P=i;Q=0;while(1){if((Q|0)<(N|0)){R=Q;do{f[M+(R<<2)>>2]=((h[O+(f[P+(R+G<<2)>>2]|0)>>0]|0)+(h[O+(f[P+(R+p<<2)>>2]|0)>>0]|0)<<2)+((h[O+(f[P+(R+o<<2)>>2]|0)>>0]|0)*6|0)+(h[O+(f[P+(R<<2)>>2]|0)>>0]|0)+(h[O+(f[P+(R+E<<2)>>2]|0)>>0]|0);R=R+1|0}while((R|0)!=(N|0));S=N}else S=Q;if((S|0)==(s|0))break;switch(a&511){case 0:{if((S|0)<(r|0)){R=S;do{T=R<<1;f[M+(R<<2)>>2]=(h[O+(T+-2)>>0]|0)+((h[O+T>>0]|0)*6|0)+((h[O+(T|1)>>0]|0)+(h[O+(T+-1)>>0]|0)<<2)+(h[O+(T+2)>>0]|0);R=R+1|0}while((R|0)<(r|0));U=r}else U=S;break}case 2:{if((S|0)<(r|0)){R=S;while(1){T=O+(R<<1)|0;V=(h[T+-5>>0]|0)+((h[T+1>>0]|0)*6|0)+((h[T+4>>0]|0)+(h[T+-2>>0]|0)<<2)+(h[T+7>>0]|0)|0;W=(h[T+-4>>0]|0)+((h[T+2>>0]|0)*6|0)+((h[T+5>>0]|0)+(h[T+-1>>0]|0)<<2)+(h[T+8>>0]|0)|0;f[M+(R<<2)>>2]=(h[T+-6>>0]|0)+((h[T>>0]|0)*6|0)+((h[T+3>>0]|0)+(h[T+-3>>0]|0)<<2)+(h[T+6>>0]|0);f[M+(R+1<<2)>>2]=V;f[M+(R+2<<2)>>2]=W;W=R+3|0;if((W|0)<(r|0))R=W;else{U=W;break}}}else U=S;break}case 3:{if((S|0)<(r|0)){R=S;while(1){W=O+(R<<1)|0;V=(h[W+-7>>0]|0)+((h[W+1>>0]|0)*6|0)+((h[W+5>>0]|0)+(h[W+-3>>0]|0)<<2)+(h[W+9>>0]|0)|0;f[M+(R<<2)>>2]=(h[W+-8>>0]|0)+((h[W>>0]|0)*6|0)+((h[W+4>>0]|0)+(h[W+-4>>0]|0)<<2)+(h[W+8>>0]|0);f[M+(R+1<<2)>>2]=V;V=(h[W+-5>>0]|0)+((h[W+3>>0]|0)*6|0)+((h[W+7>>0]|0)+(h[W+-1>>0]|0)<<2)+(h[W+11>>0]|0)|0;f[M+(R+2<<2)>>2]=(h[W+-6>>0]|0)+((h[W+2>>0]|0)*6|0)+((h[W+6>>0]|0)+(h[W+-2>>0]|0)<<2)+(h[W+10>>0]|0);f[M+(R+3<<2)>>2]=V;V=R+4|0;if((V|0)<(r|0))R=V;else{U=V;break}}}else U=S;break}default:if((S|0)<(r|0)){R=S;do{V=f[C+(R<<2)>>2]|0;f[M+(R<<2)>>2]=(h[O+(V-o)>>0]|0)+((h[O+V>>0]|0)*6|0)+((h[O+(V+p)>>0]|0)+(h[O+(V-p)>>0]|0)<<2)+(h[O+(V+o)>>0]|0);R=R+1|0}while((R|0)<(r|0));U=r}else U=S}N=s;P=j+(0-U<<2)|0;Q=U}Q=L+1|0;if((L|0)<(J|0))L=Q;else{K=Q;break}}}L=z+((Y((I|0)%5|0,v)|0)<<2)|0;Q=z+((Y((I|1|0)%5|0,v)|0)<<2)|0;P=z+((Y((J|0)%5|0,v)|0)<<2)|0;N=z+((Y((I+3|0)%5|0,v)|0)<<2)|0;O=z+((Y((I+4|0)%5|0,v)|0)<<2)|0;if(B){M=0;do{b[H+M>>0]=(((f[P+(M<<2)>>2]|0)*6|0)+128+(f[L+(M<<2)>>2]|0)+((f[N+(M<<2)>>2]|0)+(f[Q+(M<<2)>>2]|0)<<2)+(f[O+(M<<2)>>2]|0)|0)>>>8;M=M+1|0}while((M|0)!=(s|0))}F=F+1|0;if((F|0)>=(q|0))break;else D=K}}K=f[k>>2]|0;if((K|0)!=(A|0)){if(K|0)P5b(K);f[k>>2]=A;f[w>>2]=264}w=f[g>>2]|0;if((w|0)==(x|0)){u=e;return}if(w|0)P5b(w);f[g>>2]=x;f[y>>2]=264;u=e;return}function L1(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+144|0;h=g+128|0;i=g+72|0;j=g+64|0;k=g+8|0;l=g;dQ(h,51352);if((e|0)!=4){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,28)|0;n=229713;o=m+28|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,229742,229426,1454);bD(i)}do if((yM(a)|0)==65536){n=f[a+4>>2]|0;f[i>>2]=f[n>>2];m=i+4|0;o=n+4|0;f[m>>2]=f[o>>2];p=i+8|0;f[p>>2]=f[n+8>>2];f[i+12>>2]=f[n+12>>2];f[i+16>>2]=f[n+16>>2];f[i+20>>2]=f[n+20>>2];f[i+24>>2]=f[n+24>>2];f[i+28>>2]=f[n+28>>2];f[i+32>>2]=f[n+32>>2];q=f[n+36>>2]|0;f[i+36>>2]=q;f[i+40>>2]=p;p=i+48|0;r=i+44|0;f[r>>2]=p;f[p>>2]=0;f[i+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[n+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[m>>2]=0;jL(i,n);break}}else yL(i,a,-1);while(0);a=f[d>>2]|0;n=f[d+4>>2]|0;if(!(Y(n,a)|0)){s=f[i+12>>2]<<1;t=f[i+8>>2]<<1}else{s=a;t=n}f[j>>2]=s;f[j+4>>2]=t;vM(c,j,f[i>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){j=f[c+4>>2]|0;f[k>>2]=f[j>>2];t=k+4|0;s=j+4|0;f[t>>2]=f[s>>2];n=k+8|0;f[n>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];a=f[j+36>>2]|0;f[k+36>>2]=a;f[k+40>>2]=n;n=k+48|0;d=k+44|0;f[d>>2]=n;f[n>>2]=0;f[k+52>>2]=0;if(a|0){n=a+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[s>>2]|0)<3){s=f[j+44>>2]|0;n=f[d>>2]|0;f[n>>2]=f[s>>2];f[n+4>>2]=f[s+4>>2];break}else{f[t>>2]=0;jL(k,j);break}}else yL(k,c,-1);while(0);switch(f[i>>2]&7){case 0:{v=248;break}case 3:{v=249;break}case 2:{v=250;break}case 5:{v=251;break}case 6:{v=252;break}default:{f[l>>2]=0;f[l+4>>2]=0;bO(-210,l,229742,229426,1491);bD(l)}}_h[v&255](i,k,e);e=k+36|0;v=f[e>>2]|0;if(v|0?(l=v+12|0,v=f[l>>2]|0,f[l>>2]=v+-1,(v|0)==1):0)kL(k);f[e>>2]=0;e=k+16|0;v=k+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[v>>2]|0)>0){e=f[k+40>>2]|0;l=0;do{f[e+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[v>>2]|0))}v=f[k+44>>2]|0;if((v|0)!=(k+48|0))UC(v);v=i+36|0;k=f[v>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)kL(i);f[v>>2]=0;v=i+16|0;k=i+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[k>>2]|0)>0){v=f[i+40>>2]|0;l=0;do{f[v+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)!=(i+48|0))UC(k);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function M1(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=u;u=u+2144|0;g=e+1072|0;h=e+8|0;i=e;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[c+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=((f[a>>2]|0)>>>3&511)+1|0;o=(Y(j,m+1|0)|0)+15&-16;p=(o*3|0)+16|0;q=g+8|0;f[g>>2]=q;r=g+4|0;f[r>>2]=p;if(p>>>0>264){s=N5b(p>>>0>1073741823?-1:p<<2)|0;f[g>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(j,k)|0;p=h+8|0;f[h>>2]=p;v=h+4|0;f[v>>2]=t;if(t>>>0>264){w=N5b(t>>>0>1073741823?-1:t<<2)|0;f[h>>2]=w;x=w}else x=p;w=m-(k<<1)|0;if(!((((w|0)>-1?w:0-w|0)|0)==((m|0)%2|0|0)?(w=n-(l<<1)|0,(((w|0)>-1?w:0-w|0)|0)==((n|0)%2|0|0)):0)){f[i>>2]=0;f[i+4>>2]=0;w=aD(i,119)|0;k=229748;y=w+119|0;do{b[w>>0]=b[k>>0]|0;w=w+1|0;k=k+1|0}while((w|0)<(y|0));bO(-215,i,229868,229426,996);bD(i)}i=Y(j,m)|0;if((t|0)>0){m=j<<1;k=0;do{w=(Y(m,(k|0)/(j|0)|0)|0)+((k|0)%(j|0)|0)|0;f[x+(k<<2)>>2]=w;k=k+1|0}while((k|0)!=(t|0))}if((l|0)>0){k=c+16|0;m=c+44|0;w=n+-1|0;y=(i|0)>0;z=l<<1;A=a+16|0;B=a+44|0;a=(t|0)==(j|0);C=t-j|0;D=(i|0)>(t<<1|0);t=c+12|0;E=(j|0)<(C|0);F=-1;G=0;while(1){H=G<<1;I=f[k>>2]|0;J=f[f[m>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(w|0)<(L|0)?w:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,o)|0)<<2)|0;O=(ZP(J<<1,z,4)|0)/2|0;P=(f[A>>2]|0)+(Y(f[f[B>>2]>>2]|0,O)|0)|0;if(!a){if(D){O=0;do{Q=f[x+(O<<2)>>2]|0;R=d[P+(O<<1)>>1]|0;S=d[P+(O+j<<1)>>1]|0;f[N+(Q<<2)>>2]=(S<<1)+(R*6|0);f[N+(Q+j<<2)>>2]=S+R<<2;R=O+C|0;S=f[x+(R<<2)>>2]|0;Q=d[P+(R<<1)>>1]|0;T=Q<<3;f[N+(S<<2)>>2]=(Q*7|0)+(d[P+(R-j<<1)>>1]|0);f[N+(S+j<<2)>>2]=T;f[N+(O+-1+(f[t>>2]|0)<<2)>>2]=T;O=O+1|0}while((O|0)!=(j|0))}else{O=0;do{T=f[x+(O<<2)>>2]|0;S=d[P+(O<<1)>>1]|0;R=d[P+(O+j<<1)>>1]|0;f[N+(T<<2)>>2]=(R<<1)+(S*6|0);f[N+(T+j<<2)>>2]=R+S<<2;S=O+C|0;R=f[x+(S<<2)>>2]|0;T=d[P+(S<<1)>>1]|0;f[N+(R<<2)>>2]=(T*7|0)+(d[P+(S-j<<1)>>1]|0);f[N+(R+j<<2)>>2]=T<<3;O=O+1|0}while((O|0)!=(j|0))}if(E){O=j;do{T=f[x+(O<<2)>>2]|0;R=d[P+(O<<1)>>1]|0;S=d[P+(O+j<<1)>>1]|0;f[N+(T<<2)>>2]=(R*6|0)+(d[P+(O-j<<1)>>1]|0)+S;f[N+(T+j<<2)>>2]=S+R<<2;O=O+1|0}while((O|0)!=(C|0))}}else{O=0;do{R=d[P+(O<<1)>>1]<<3;f[N+(O+j<<2)>>2]=R;f[N+(O<<2)>>2]=R;O=O+1|0}while((O|0)!=(j|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,o)|0)<<2)|0;O=s+((Y((G|0)%3|0,o)|0)<<2)|0;N=s+((Y((L+2|0)%3|0,o)|0)<<2)|0;if(y){P=0;do{R=f[O+(P<<2)>>2]|0;S=f[N+(P<<2)>>2]|0;T=((R*6|0)+32+S+(f[J+(P<<2)>>2]|0)|0)>>>6&65535;d[H+(P<<1)>>1]=((S+R<<2)+32|0)>>>6;d[K+(P<<1)>>1]=T;P=P+1|0}while((P|0)!=(i|0))}if((G|0)>=(l|0)){U=z;break}else F=M}}else U=l<<1;if((n|0)>(U|0)?(n=f[c+16>>2]|0,l=f[f[c+44>>2]>>2]|0,c=n+(Y(l,U+-2|0)|0)|0,M=n+(Y(l,U)|0)|0,(i|0)>0):0){U=0;do{d[M+(U<<1)>>1]=d[c+(U<<1)>>1]|0;U=U+1|0}while((U|0)!=(i|0))}i=f[h>>2]|0;if((i|0)!=(p|0)){if(i|0)P5b(i);f[h>>2]=p;f[v>>2]=264}v=f[g>>2]|0;if((v|0)==(q|0)){u=e;return}if(v|0)P5b(v);f[g>>2]=q;f[r>>2]=264;u=e;return}function N1(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;e=u;u=u+2144|0;g=e+1072|0;h=e+8|0;i=e;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[c+40>>2]|0;n=f[k+4>>2]|0;o=f[k>>2]|0;k=((f[a>>2]|0)>>>3&511)+1|0;p=(Y(k,n+1|0)|0)+15&-16;q=(p*3|0)+16|0;r=g+8|0;f[g>>2]=r;s=g+4|0;f[s>>2]=q;if(q>>>0>264){t=N5b(q>>>0>1073741823?-1:q<<2)|0;f[g>>2]=t;v=t}else v=r;t=v+15&-16;v=Y(k,l)|0;q=h+8|0;f[h>>2]=q;w=h+4|0;f[w>>2]=v;if(v>>>0>264){x=N5b(v>>>0>1073741823?-1:v<<2)|0;f[h>>2]=x;y=x}else y=q;x=n-(l<<1)|0;if(!((((x|0)>-1?x:0-x|0)|0)==((n|0)%2|0|0)?(x=o-(m<<1)|0,(((x|0)>-1?x:0-x|0)|0)==((o|0)%2|0|0)):0)){f[i>>2]=0;f[i+4>>2]=0;x=aD(i,119)|0;l=229748;z=x+119|0;do{b[x>>0]=b[l>>0]|0;x=x+1|0;l=l+1|0}while((x|0)<(z|0));bO(-215,i,229868,229426,996);bD(i)}i=Y(k,n)|0;if((v|0)>0){n=k<<1;l=0;do{x=(Y(n,(l|0)/(k|0)|0)|0)+((l|0)%(k|0)|0)|0;f[y+(l<<2)>>2]=x;l=l+1|0}while((l|0)!=(v|0))}if((m|0)>0){l=c+16|0;n=c+44|0;x=o+-1|0;z=(i|0)>0;A=m<<1;B=a+16|0;C=a+44|0;a=(v|0)==(k|0);D=v-k|0;E=(i|0)>(v<<1|0);v=c+12|0;F=(k|0)<(D|0);G=-1;H=0;while(1){I=H<<1;J=f[l>>2]|0;K=f[f[n>>2]>>2]|0;L=J+(Y(K,I)|0)|0;M=I|1;I=J+(Y(K,(x|0)<(M|0)?x:M)|0)|0;M=H;H=H+1|0;if((G|0)>(H|0))N=G;else{K=G;while(1){J=K+1|0;O=t+((Y((J|0)%3|0,p)|0)<<2)|0;P=(ZP(K<<1,A,4)|0)/2|0;Q=(f[B>>2]|0)+(Y(f[f[C>>2]>>2]|0,P)|0)|0;if(!a){if(E){P=0;do{R=f[y+(P<<2)>>2]|0;S=j[Q+(P<<1)>>1]|0;T=j[Q+(P+k<<1)>>1]|0;f[O+(R<<2)>>2]=(T<<1)+(S*6|0);f[O+(R+k<<2)>>2]=T+S<<2;S=P+D|0;T=f[y+(S<<2)>>2]|0;R=j[Q+(S<<1)>>1]|0;U=R<<3;f[O+(T<<2)>>2]=(R*7|0)+(j[Q+(S-k<<1)>>1]|0);f[O+(T+k<<2)>>2]=U;f[O+(P+-1+(f[v>>2]|0)<<2)>>2]=U;P=P+1|0}while((P|0)!=(k|0))}else{P=0;do{U=f[y+(P<<2)>>2]|0;T=j[Q+(P<<1)>>1]|0;S=j[Q+(P+k<<1)>>1]|0;f[O+(U<<2)>>2]=(S<<1)+(T*6|0);f[O+(U+k<<2)>>2]=S+T<<2;T=P+D|0;S=f[y+(T<<2)>>2]|0;U=j[Q+(T<<1)>>1]|0;f[O+(S<<2)>>2]=(U*7|0)+(j[Q+(T-k<<1)>>1]|0);f[O+(S+k<<2)>>2]=U<<3;P=P+1|0}while((P|0)!=(k|0))}if(F){P=k;do{U=f[y+(P<<2)>>2]|0;S=j[Q+(P<<1)>>1]|0;T=j[Q+(P+k<<1)>>1]|0;f[O+(U<<2)>>2]=(S*6|0)+(j[Q+(P-k<<1)>>1]|0)+T;f[O+(U+k<<2)>>2]=T+S<<2;P=P+1|0}while((P|0)!=(D|0))}}else{P=0;do{S=(j[Q+(P<<1)>>1]|0)<<3;f[O+(P+k<<2)>>2]=S;f[O+(P<<2)>>2]=S;P=P+1|0}while((P|0)!=(k|0))}if((K|0)>(M|0)){N=J;break}else K=J}}K=t+((Y((M|0)%3|0,p)|0)<<2)|0;P=t+((Y((H|0)%3|0,p)|0)<<2)|0;O=t+((Y((M+2|0)%3|0,p)|0)<<2)|0;if(z){Q=0;do{S=f[P+(Q<<2)>>2]|0;T=f[O+(Q<<2)>>2]|0;U=((S*6|0)+32+T+(f[K+(Q<<2)>>2]|0)|0)>>>6&65535;d[I+(Q<<1)>>1]=((T+S<<2)+32|0)>>>6;d[L+(Q<<1)>>1]=U;Q=Q+1|0}while((Q|0)!=(i|0))}if((H|0)>=(m|0)){V=A;break}else G=N}}else V=m<<1;if((o|0)>(V|0)?(o=f[c+16>>2]|0,m=f[f[c+44>>2]>>2]|0,c=o+(Y(m,V+-2|0)|0)|0,N=o+(Y(m,V)|0)|0,(i|0)>0):0){V=0;do{d[N+(V<<1)>>1]=d[c+(V<<1)>>1]|0;V=V+1|0}while((V|0)!=(i|0))}i=f[h>>2]|0;if((i|0)!=(q|0)){if(i|0)P5b(i);f[h>>2]=q;f[w>>2]=264}w=f[g>>2]|0;if((w|0)==(r|0)){u=e;return}if(w|0)P5b(w);f[g>>2]=r;f[s>>2]=264;u=e;return}function O1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0;d=u;u=u+2144|0;e=d+1072|0;g=d+8|0;h=d;i=f[a+40>>2]|0;j=f[i+4>>2]|0;k=f[i>>2]|0;i=f[c+40>>2]|0;l=f[i+4>>2]|0;m=f[i>>2]|0;i=((f[a>>2]|0)>>>3&511)+1|0;o=(Y(i,l+1|0)|0)+15&-16;p=(o*3|0)+16|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=p;if(p>>>0>264){s=N5b(p>>>0>1073741823?-1:p<<2)|0;f[e>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(i,j)|0;p=g+8|0;f[g>>2]=p;v=g+4|0;f[v>>2]=t;if(t>>>0>264){w=N5b(t>>>0>1073741823?-1:t<<2)|0;f[g>>2]=w;x=w}else x=p;w=l-(j<<1)|0;if(!((((w|0)>-1?w:0-w|0)|0)==((l|0)%2|0|0)?(w=m-(k<<1)|0,(((w|0)>-1?w:0-w|0)|0)==((m|0)%2|0|0)):0)){f[h>>2]=0;f[h+4>>2]=0;w=aD(h,119)|0;j=229748;y=w+119|0;do{b[w>>0]=b[j>>0]|0;w=w+1|0;j=j+1|0}while((w|0)<(y|0));bO(-215,h,229868,229426,996);bD(h)}h=Y(i,l)|0;if((t|0)>0){l=i<<1;j=0;do{w=(Y(l,(j|0)/(i|0)|0)|0)+((j|0)%(i|0)|0)|0;f[x+(j<<2)>>2]=w;j=j+1|0}while((j|0)!=(t|0))}if((k|0)>0){j=c+16|0;l=c+44|0;w=m+-1|0;y=(h|0)>0;z=k<<1;A=a+16|0;B=a+44|0;a=(t|0)==(i|0);C=t-i|0;D=(h|0)>(t<<1|0);t=c+12|0;E=(i|0)<(C|0);F=-1;G=0;while(1){H=G<<1;I=f[j>>2]|0;J=f[f[l>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(w|0)<(L|0)?w:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,o)|0)<<2)|0;O=(ZP(J<<1,z,4)|0)/2|0;P=(f[A>>2]|0)+(Y(f[f[B>>2]>>2]|0,O)|0)|0;if(!a){O=f[t>>2]|0;if(D){Q=0;do{R=f[x+(Q<<2)>>2]|0;S=+n[P+(Q<<2)>>2];T=+n[P+(Q+i<<2)>>2];n[N+(R<<2)>>2]=S*6.0+T*2.0;n[N+(R+i<<2)>>2]=(S+T)*4.0;R=Q+C|0;U=f[x+(R<<2)>>2]|0;T=+n[P+(R<<2)>>2];S=T*8.0;n[N+(U<<2)>>2]=+n[P+(R-i<<2)>>2]+T*7.0;n[N+(U+i<<2)>>2]=S;n[N+(Q+-1+O<<2)>>2]=S;Q=Q+1|0}while((Q|0)!=(i|0))}else{Q=0;do{O=f[x+(Q<<2)>>2]|0;S=+n[P+(Q<<2)>>2];T=+n[P+(Q+i<<2)>>2];n[N+(O<<2)>>2]=S*6.0+T*2.0;n[N+(O+i<<2)>>2]=(S+T)*4.0;O=Q+C|0;U=f[x+(O<<2)>>2]|0;T=+n[P+(O<<2)>>2];n[N+(U<<2)>>2]=+n[P+(O-i<<2)>>2]+T*7.0;n[N+(U+i<<2)>>2]=T*8.0;Q=Q+1|0}while((Q|0)!=(i|0))}if(E){Q=i;do{U=f[x+(Q<<2)>>2]|0;T=+n[P+(Q<<2)>>2];S=+n[P+(Q+i<<2)>>2];n[N+(U<<2)>>2]=S+(+n[P+(Q-i<<2)>>2]+T*6.0);n[N+(U+i<<2)>>2]=(T+S)*4.0;Q=Q+1|0}while((Q|0)!=(C|0))}}else{Q=0;do{S=+n[P+(Q<<2)>>2]*8.0;n[N+(Q+i<<2)>>2]=S;n[N+(Q<<2)>>2]=S;Q=Q+1|0}while((Q|0)!=(i|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,o)|0)<<2)|0;Q=s+((Y((G|0)%3|0,o)|0)<<2)|0;N=s+((Y((L+2|0)%3|0,o)|0)<<2)|0;if(y){P=0;do{S=+n[Q+(P<<2)>>2];T=+n[N+(P<<2)>>2];V=(T+(S*6.0+ +n[J+(P<<2)>>2]))*.015625;n[H+(P<<2)>>2]=(S+T)*4.0*.015625;n[K+(P<<2)>>2]=V;P=P+1|0}while((P|0)!=(h|0))}if((G|0)>=(k|0)){W=z;break}else F=M}}else W=k<<1;if((m|0)>(W|0)?(m=f[c+16>>2]|0,k=f[f[c+44>>2]>>2]|0,c=m+(Y(k,W+-2|0)|0)|0,M=m+(Y(k,W)|0)|0,(h|0)>0):0){W=0;do{f[M+(W<<2)>>2]=f[c+(W<<2)>>2];W=W+1|0}while((W|0)!=(h|0))}h=f[g>>2]|0;if((h|0)!=(p|0)){if(h|0)P5b(h);f[g>>2]=p;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(q|0)){u=d;return}if(v|0)P5b(v);f[e>>2]=q;f[r>>2]=264;u=d;return}function P1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0;d=u;u=u+2176|0;e=d;g=d+1104|0;h=d+1096|0;i=f[a+40>>2]|0;j=f[i+4>>2]|0;k=f[i>>2]|0;i=f[c+40>>2]|0;l=f[i+4>>2]|0;m=f[i>>2]|0;i=((f[a>>2]|0)>>>3&511)+1|0;n=(Y(i,l+1|0)|0)+15&-16;o=(n*3|0)+16|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=o;if(o>>>0>136){s=N5b(o>>>0>536870911?-1:o<<3)|0;f[e>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(i,j)|0;o=g+8|0;f[g>>2]=o;v=g+4|0;f[v>>2]=t;if(t>>>0>264){w=N5b(t>>>0>1073741823?-1:t<<2)|0;f[g>>2]=w;x=w}else x=o;w=l-(j<<1)|0;if(!((((w|0)>-1?w:0-w|0)|0)==((l|0)%2|0|0)?(w=m-(k<<1)|0,(((w|0)>-1?w:0-w|0)|0)==((m|0)%2|0|0)):0)){f[h>>2]=0;f[h+4>>2]=0;w=aD(h,119)|0;j=229748;y=w+119|0;do{b[w>>0]=b[j>>0]|0;w=w+1|0;j=j+1|0}while((w|0)<(y|0));bO(-215,h,229868,229426,996);bD(h)}h=Y(i,l)|0;if((t|0)>0){l=i<<1;j=0;do{w=(Y(l,(j|0)/(i|0)|0)|0)+((j|0)%(i|0)|0)|0;f[x+(j<<2)>>2]=w;j=j+1|0}while((j|0)!=(t|0))}if((k|0)>0){j=c+16|0;l=c+44|0;w=m+-1|0;y=(h|0)>0;z=k<<1;A=a+16|0;B=a+44|0;a=(t|0)==(i|0);C=t-i|0;D=(h|0)>(t<<1|0);t=c+12|0;E=(i|0)<(C|0);F=-1;G=0;while(1){H=G<<1;I=f[j>>2]|0;J=f[f[l>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(w|0)<(L|0)?w:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,n)|0)<<3)|0;O=(ZP(J<<1,z,4)|0)/2|0;P=(f[A>>2]|0)+(Y(f[f[B>>2]>>2]|0,O)|0)|0;if(!a){O=f[t>>2]|0;if(D){Q=0;do{R=f[x+(Q<<2)>>2]|0;S=+p[P+(Q<<3)>>3];T=+p[P+(Q+i<<3)>>3];p[N+(R<<3)>>3]=S*6.0+T*2.0;p[N+(R+i<<3)>>3]=(S+T)*4.0;R=Q+C|0;U=f[x+(R<<2)>>2]|0;T=+p[P+(R<<3)>>3];S=T*8.0;p[N+(U<<3)>>3]=+p[P+(R-i<<3)>>3]+T*7.0;p[N+(U+i<<3)>>3]=S;p[N+(Q+-1+O<<3)>>3]=S;Q=Q+1|0}while((Q|0)!=(i|0))}else{Q=0;do{O=f[x+(Q<<2)>>2]|0;S=+p[P+(Q<<3)>>3];T=+p[P+(Q+i<<3)>>3];p[N+(O<<3)>>3]=S*6.0+T*2.0;p[N+(O+i<<3)>>3]=(S+T)*4.0;O=Q+C|0;U=f[x+(O<<2)>>2]|0;T=+p[P+(O<<3)>>3];p[N+(U<<3)>>3]=+p[P+(O-i<<3)>>3]+T*7.0;p[N+(U+i<<3)>>3]=T*8.0;Q=Q+1|0}while((Q|0)!=(i|0))}if(E){Q=i;do{U=f[x+(Q<<2)>>2]|0;T=+p[P+(Q<<3)>>3];S=+p[P+(Q+i<<3)>>3];p[N+(U<<3)>>3]=S+(+p[P+(Q-i<<3)>>3]+T*6.0);p[N+(U+i<<3)>>3]=(T+S)*4.0;Q=Q+1|0}while((Q|0)!=(C|0))}}else{Q=0;do{S=+p[P+(Q<<3)>>3]*8.0;p[N+(Q+i<<3)>>3]=S;p[N+(Q<<3)>>3]=S;Q=Q+1|0}while((Q|0)!=(i|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,n)|0)<<3)|0;Q=s+((Y((G|0)%3|0,n)|0)<<3)|0;N=s+((Y((L+2|0)%3|0,n)|0)<<3)|0;if(y){P=0;do{S=+p[Q+(P<<3)>>3];T=+p[N+(P<<3)>>3];V=(T+(S*6.0+ +p[J+(P<<3)>>3]))*.015625;p[H+(P<<3)>>3]=(S+T)*4.0*.015625;p[K+(P<<3)>>3]=V;P=P+1|0}while((P|0)!=(h|0))}if((G|0)>=(k|0)){W=z;break}else F=M}}else W=k<<1;if((m|0)>(W|0)?(m=f[c+16>>2]|0,k=f[f[c+44>>2]>>2]|0,c=m+(Y(k,W+-2|0)|0)|0,M=m+(Y(k,W)|0)|0,(h|0)>0):0){W=0;do{p[M+(W<<3)>>3]=+p[c+(W<<3)>>3];W=W+1|0}while((W|0)!=(h|0))}h=f[g>>2]|0;if((h|0)!=(o|0)){if(h|0)P5b(h);f[g>>2]=o;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(q|0)){u=d;return}if(v|0)P5b(v);f[e>>2]=q;f[r>>2]=136;u=d;return}function Q1(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=u;u=u+2144|0;e=d+1072|0;g=d+8|0;i=d;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[c+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=((f[a>>2]|0)>>>3&511)+1|0;o=(Y(j,m+1|0)|0)+15&-16;p=(o*3|0)+16|0;q=e+8|0;f[e>>2]=q;r=e+4|0;f[r>>2]=p;if(p>>>0>264){s=N5b(p>>>0>1073741823?-1:p<<2)|0;f[e>>2]=s;t=s}else t=q;s=t+15&-16;t=Y(j,k)|0;p=g+8|0;f[g>>2]=p;v=g+4|0;f[v>>2]=t;if(t>>>0>264){w=N5b(t>>>0>1073741823?-1:t<<2)|0;f[g>>2]=w;x=w}else x=p;w=m-(k<<1)|0;if(!((((w|0)>-1?w:0-w|0)|0)==((m|0)%2|0|0)?(w=n-(l<<1)|0,(((w|0)>-1?w:0-w|0)|0)==((n|0)%2|0|0)):0)){f[i>>2]=0;f[i+4>>2]=0;w=aD(i,119)|0;k=229748;y=w+119|0;do{b[w>>0]=b[k>>0]|0;w=w+1|0;k=k+1|0}while((w|0)<(y|0));bO(-215,i,229868,229426,996);bD(i)}i=Y(j,m)|0;if((t|0)>0){m=j<<1;k=0;do{w=(Y(m,(k|0)/(j|0)|0)|0)+((k|0)%(j|0)|0)|0;f[x+(k<<2)>>2]=w;k=k+1|0}while((k|0)!=(t|0))}if((l|0)>0){k=c+16|0;m=c+44|0;w=n+-1|0;y=(i|0)>0;z=l<<1;A=a+16|0;B=a+44|0;a=(t|0)==(j|0);C=t-j|0;D=(i|0)>(t<<1|0);t=c+12|0;E=(j|0)<(C|0);F=-1;G=0;while(1){H=G<<1;I=f[k>>2]|0;J=f[f[m>>2]>>2]|0;K=I+(Y(J,H)|0)|0;L=H|1;H=I+(Y(J,(w|0)<(L|0)?w:L)|0)|0;L=G;G=G+1|0;if((F|0)>(G|0))M=F;else{J=F;while(1){I=J+1|0;N=s+((Y((I|0)%3|0,o)|0)<<2)|0;O=(ZP(J<<1,z,4)|0)/2|0;P=(f[A>>2]|0)+(Y(f[f[B>>2]>>2]|0,O)|0)|0;if(!a){if(D){O=0;do{Q=f[x+(O<<2)>>2]|0;R=h[P+O>>0]|0;S=h[P+(O+j)>>0]|0;f[N+(Q<<2)>>2]=(S<<1)+(R*6|0);f[N+(Q+j<<2)>>2]=S+R<<2;R=O+C|0;S=f[x+(R<<2)>>2]|0;Q=h[P+R>>0]|0;T=Q<<3;f[N+(S<<2)>>2]=(Q*7|0)+(h[P+(R-j)>>0]|0);f[N+(S+j<<2)>>2]=T;f[N+(O+-1+(f[t>>2]|0)<<2)>>2]=T;O=O+1|0}while((O|0)!=(j|0))}else{O=0;do{T=f[x+(O<<2)>>2]|0;S=h[P+O>>0]|0;R=h[P+(O+j)>>0]|0;f[N+(T<<2)>>2]=(R<<1)+(S*6|0);f[N+(T+j<<2)>>2]=R+S<<2;S=O+C|0;R=f[x+(S<<2)>>2]|0;T=h[P+S>>0]|0;f[N+(R<<2)>>2]=(T*7|0)+(h[P+(S-j)>>0]|0);f[N+(R+j<<2)>>2]=T<<3;O=O+1|0}while((O|0)!=(j|0))}if(E){O=j;do{T=f[x+(O<<2)>>2]|0;R=h[P+O>>0]|0;S=h[P+(O+j)>>0]|0;f[N+(T<<2)>>2]=(R*6|0)+(h[P+(O-j)>>0]|0)+S;f[N+(T+j<<2)>>2]=S+R<<2;O=O+1|0}while((O|0)!=(C|0))}}else{O=0;do{R=(h[P+O>>0]|0)<<3;f[N+(O+j<<2)>>2]=R;f[N+(O<<2)>>2]=R;O=O+1|0}while((O|0)!=(j|0))}if((J|0)>(L|0)){M=I;break}else J=I}}J=s+((Y((L|0)%3|0,o)|0)<<2)|0;O=s+((Y((G|0)%3|0,o)|0)<<2)|0;N=s+((Y((L+2|0)%3|0,o)|0)<<2)|0;if(y){P=0;do{R=f[O+(P<<2)>>2]|0;S=f[N+(P<<2)>>2]|0;T=((R*6|0)+32+S+(f[J+(P<<2)>>2]|0)|0)>>>6&255;b[H+P>>0]=((S+R<<2)+32|0)>>>6;b[K+P>>0]=T;P=P+1|0}while((P|0)!=(i|0))}if((G|0)>=(l|0)){U=z;break}else F=M}}else U=l<<1;if((n|0)>(U|0)?(n=f[c+16>>2]|0,l=f[f[c+44>>2]>>2]|0,c=n+(Y(l,U+-2|0)|0)|0,M=n+(Y(l,U)|0)|0,(i|0)>0):0){U=0;do{b[M+U>>0]=b[c+U>>0]|0;U=U+1|0}while((U|0)!=(i|0))}i=f[g>>2]|0;if((i|0)!=(p|0)){if(i|0)P5b(i);f[g>>2]=p;f[v>>2]=264}v=f[e>>2]|0;if((v|0)==(q|0)){u=d;return}if(v|0)P5b(v);f[e>>2]=q;f[r>>2]=264;u=d;return}function R1(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;i=+i;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0;k=u;u=u+144|0;l=k+128|0;m=k+72|0;n=k+56|0;o=k;dQ(l,51372);do if((yM(a)|0)==65536){p=f[a+4>>2]|0;f[m>>2]=f[p>>2];q=m+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=m+8|0;f[s>>2]=f[p+8>>2];f[m+12>>2]=f[p+12>>2];f[m+16>>2]=f[p+16>>2];f[m+20>>2]=f[p+20>>2];f[m+24>>2]=f[p+24>>2];f[m+28>>2]=f[p+28>>2];f[m+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[m+36>>2]=t;f[m+40>>2]=s;s=m+48|0;v=m+44|0;f[v>>2]=s;f[s>>2]=0;f[m+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;jL(m,p);break}}else yL(m,a,-1);while(0);f[n>>2]=0;a=n+4|0;f[a>>2]=0;f[n+8>>2]=0;w=c;c=d;if(g==0.0&h==0.0)S1(m,w,c,e,n,2147483647,i,j);else{p=MVb(g)|0;T1(m,w,c,e,p,MVb(h)|0,n,2147483647,i,j)}f[o>>2]=1124024333;p=o+4|0;f[p>>2]=2;e=o+8|0;q=f[a>>2]|0;r=f[n>>2]|0;s=q-r|0;f[e>>2]=s>>3;f[o+12>>2]=1;v=o+16|0;t=o+40|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;f[t>>2]=e;e=o+48|0;x=o+44|0;f[x>>2]=e;f[e>>2]=0;y=o+52|0;f[y>>2]=0;z=r;if((z|0)!=(q|0)){f[y>>2]=8;f[e>>2]=8;f[v>>2]=z;f[o+20>>2]=z;z=r+s|0;f[o+24>>2]=z;f[o+28>>2]=z}SP(o,b);b=o+36|0;z=f[b>>2]|0;if(z|0?(s=z+12|0,z=f[s>>2]|0,f[s>>2]=z+-1,(z|0)==1):0)kL(o);f[b>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[p>>2]|0)>0){v=f[t>>2]|0;t=0;do{f[v+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[p>>2]|0))}p=f[x>>2]|0;if((p|0)!=(e|0))UC(p);p=f[n>>2]|0;if(p|0){n=f[a>>2]|0;if((n|0)!=(p|0))f[a>>2]=n+(~((n+-8-p|0)>>>3)<<3);O5b(p)}p=m+36|0;n=f[p>>2]|0;if(n|0?(a=n+12|0,n=f[a>>2]|0,f[a>>2]=n+-1,(n|0)==1):0)kL(m);f[p>>2]=0;p=m+16|0;n=m+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[n>>2]|0)>0){p=f[m+40>>2]|0;a=0;do{f[p+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))UC(n);if(!(f[l+4>>2]|0)){u=k;return}u=k;return}function S1(a,c,d,e,g,h,i,j){a=a|0;c=+c;d=+d;e=e|0;g=g|0;h=h|0;i=+i;j=+j;var k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,Q=0,R=0,S=0,T=0,U=0;k=u;u=u+3216|0;l=k;m=k+2152|0;o=k+2136|0;p=k+1072|0;q=k+8|0;r=1.0/c;if(f[a>>2]&4095|0){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,55)|0;t=229934;v=s+55|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,l,230088,230005,87);bD(l)}w=f[a+16>>2]|0;x=f[a+48>>2]|0;y=f[a+12>>2]|0;z=f[a+8>>2]|0;if(j<i){f[l>>2]=0;f[l+4>>2]=0;s=aD(l,40)|0;t=230107;v=s+40|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-5,l,230088,230005,95);bD(l)}t=MVb((j-i)/d)|0;s=LVb(+(z+y<<1|1|0)/c)|0;v=t+2|0;a=s+2|0;A=Y(a,v)|0;B=m+8|0;f[m>>2]=B;C=m+4|0;f[C>>2]=A;if(A>>>0>264){D=N5b(A>>>0>1073741823?-1:A<<2)|0;f[m>>2]=D;E=D}else E=B;f[o>>2]=0;D=o+4|0;f[D>>2]=0;f[o+8>>2]=0;A=p+8|0;f[p>>2]=A;F=p+4|0;G=t>>>0>264;f[F>>2]=t;if(G){H=N5b(t>>>0>1073741823?-1:t<<2)|0;f[p>>2]=H;I=H}else I=A;H=q+8|0;f[q>>2]=H;J=q+4|0;f[J>>2]=t;if(G){G=N5b(t>>>0>1073741823?-1:t<<2)|0;f[q>>2]=G;K=G}else K=H;Nac(E|0,0,Y(v<<2,a)|0)|0;j=i;v=(t|0)>0;if(v){i=r;r=j;G=0;while(1){L=r;M=i*+P(+L);n[I+(G<<2)>>2]=M;M=i*+O(+L);n[K+(G<<2)>>2]=M;G=G+1|0;if((G|0)==(t|0))break;else r=r+d}}if((z|0)>0?(G=((s+-1|0)/2|0)+1|0,(y|0)>0):0){N=0;do{Q=Y(N,x)|0;r=+(N|0);if(v){R=0;do{if(b[w+(R+Q)>>0]|0){i=+(R|0);S=0;do{T=S;S=S+1|0;U=E+(G+(Y(S,a)|0)+(LVb(i*+n[K+(T<<2)>>2]+r*+n[I+(T<<2)>>2])|0)<<2)|0;f[U>>2]=(f[U>>2]|0)+1}while((S|0)!=(t|0))}R=R+1|0}while((R|0)!=(y|0))}N=N+1|0}while((N|0)!=(z|0))}if((s|0)>0?(z=-2-s|0,N=o+8|0,v):0){v=0;do{y=0;do{y=y+1|0;I=(Y(y,a)|0)+v|0;K=I+1|0;f[l>>2]=K;G=f[E+(K<<2)>>2]|0;do if(((((G|0)>(e|0)?(G|0)>(f[E+(I<<2)>>2]|0):0)?(G|0)>=(f[E+(I+2<<2)>>2]|0):0)?(G|0)>(f[E+(z+K<<2)>>2]|0):0)?(G|0)>=(f[E+(a+K<<2)>>2]|0):0){w=f[D>>2]|0;if((w|0)==(f[N>>2]|0)){IO(o,l);break}else{f[w>>2]=K;f[D>>2]=w+4;break}}while(0)}while((y|0)<(t|0));v=v+1|0}while((v|0)<(s|0))}v=f[o>>2]|0;t=f[D>>2]|0;f[l>>2]=E;W1(v,t,l);t=f[o>>2]|0;v=(f[D>>2]|0)-t>>2;E=(v|0)<(h|0)?v:h;r=1.0/+(a|0);a:do if((E|0)>0){i=+(s+-1|0)*.5;h=l+4|0;v=g+4|0;N=g+8|0;z=0;e=t;while(1){y=f[e+(z<<2)>>2]|0;M=r*+(y|0);K=~~M;G=K-(+(K|0)>M&1)|0;M=(+(y+-1-(Y(G,a)|0)|0)-i)*c;n[l>>2]=M;n[h>>2]=j+ +(G+-1|0)*d;G=f[v>>2]|0;if((G|0)==(f[N>>2]|0))V1(g,l);else{n[G>>2]=M;f[G+4>>2]=f[h>>2];f[v>>2]=G+8}G=z+1|0;if((G|0)>=(E|0))break a;z=G;e=f[o>>2]|0}}while(0);E=f[q>>2]|0;if((E|0)!=(H|0)){if(E|0)P5b(E);f[q>>2]=H;f[J>>2]=264}J=f[p>>2]|0;if((J|0)!=(A|0)){if(J|0)P5b(J);f[p>>2]=A;f[F>>2]=264}F=f[o>>2]|0;if(F|0){o=f[D>>2]|0;if((o|0)!=(F|0))f[D>>2]=o+(~((o+-4-F|0)>>>2)<<2);O5b(F)}F=f[m>>2]|0;if((F|0)==(B|0)){u=k;return}if(F|0)P5b(F);f[m>>2]=B;f[C>>2]=264;u=k;return}function T1(a,c,d,e,g,i,j,k,l,m){a=a|0;c=+c;d=+d;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;o=u;u=u+96|0;p=o+72|0;q=o+60|0;r=o+48|0;s=o+36|0;t=o+24|0;v=o+12|0;w=o;x=Y(i,g)|0;f[p>>2]=0;y=p+4|0;f[y>>2]=0;f[p+8>>2]=0;if(f[a>>2]&4095|0){f[q>>2]=0;f[q+4>>2]=0;z=aD(q,55)|0;A=229934;B=z+55|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,q,229990,230005,225);bD(q)}if((k|0)<=0){f[q>>2]=0;f[q+4>>2]=0;z=aD(q,12)|0;A=230075;B=z+12|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,q,229990,230005,226);bD(q)}A=(e|0)<255?e:255;e=f[a+16>>2]|0;z=f[a+48>>2]|0;B=f[a+12>>2]|0;C=f[a+8>>2]|0;D=1.0/c;E=1.0/d;F=+(g|0);G=c/F;H=d/+(i|0);I=1.0/G;J=1.0/H;K=+(B|0);N=+(C|0);P=D*+M(+(K*K+N*N));g=~~P;Q=g-(+(g|0)>P&1)|0;P=E;N=P*6.283185307179586;g=~~N;R=g-(+(g|0)>N&1)|0;f[q>>2]=A;n[q+4>>2]=-1.0;n[q+8>>2]=0.0;g=f[y>>2]|0;S=p+8|0;if((g|0)==(f[S>>2]|0))U1(p,q);else{f[g>>2]=f[q>>2];f[g+4>>2]=f[q+4>>2];f[g+8>>2]=f[q+8>>2];f[y>>2]=(f[y>>2]|0)+12}g=Y(i*5|0,R)|0;f[q>>2]=0;T=q+4|0;f[T>>2]=0;f[q+8>>2]=0;if(!g)U=0;else{if(g>>>0>1073741823)c4b(q);V=g<<2;W=L5b(V)|0;f[q>>2]=W;X=W+(g<<2)|0;f[q+8>>2]=X;Nac(W|0,0,V|0)|0;f[T>>2]=X;X=0;do{N=+O(+(H*+(X|0)*.20000000298023224));n[W+(X<<2)>>2]=N;X=X+1|0}while((X|0)!=(g|0));U=W}W=Y(Q,R)|0;f[r>>2]=0;g=r+4|0;f[g>>2]=0;f[r+8>>2]=0;if(!W)Z=0;else{if((W|0)<0)c4b(r);X=L5b(W)|0;f[g>>2]=X;f[r>>2]=X;f[r+8>>2]=X+W;V=W;_=X;do{b[_>>0]=0;_=(f[g>>2]|0)+1|0;f[g>>2]=_;V=V+-1|0}while((V|0)!=0);Z=f[r>>2]|0}V=(C|0)>0;if(V&(B|0)>0){_=0;X=0;while(1){$=Y(_,z)|0;aa=0;ba=X;do{ba=((b[e+(aa+$)>>0]|0)!=0&1)+ba|0;aa=aa+1|0}while((aa|0)!=(B|0));_=_+1|0;if((_|0)==(C|0)){ca=ba;break}else X=ba}}else ca=0;f[s>>2]=0;X=s+4|0;f[X>>2]=0;f[s+8>>2]=0;_=(ca|0)==0;do if(!_)if(ca>>>0>1073741823)c4b(s);else{aa=ca<<2;$=L5b(aa)|0;f[s>>2]=$;da=$+(ca<<2)|0;f[s+8>>2]=da;Nac($|0,0,aa|0)|0;f[X>>2]=da;ea=$;break}else ea=0;while(0);f[t>>2]=0;$=t+4|0;f[$>>2]=0;f[t+8>>2]=0;if(_){fa=0;ga=0}else{_=ca<<2;da=L5b(_)|0;f[t>>2]=da;aa=da+(ca<<2)|0;f[t+8>>2]=aa;Nac(da|0,0,_|0)|0;f[$>>2]=aa;fa=da;ga=da}if(V){V=(B|0)>0;da=0;aa=0;while(1){if(V){_=Y(aa,z)|0;N=+(aa|0)+.5;K=N;ha=K*K;ia=0;ja=da;while(1){if(b[e+(ia+_)>>0]|0){f[ea+(ja<<2)>>2]=ia;f[fa+(ja<<2)>>2]=aa;ka=ja+1|0;K=+(ia|0)+.5;la=+L(+(+gP(N,K)*.01745329238474369));ma=K;K=+M(+(ha+ma*ma));ma=D*K;na=P*(la+1.5707963267948966);oa=~~na;pa=Z+(oa-(+(oa|0)>na&1))|0;b[pa>>0]=(b[pa>>0]|0)+1<<24>>24;na=c/K;K=na<d?na:d;na=E*K;qa=3.141592653589793/K;pa=~~qa;oa=pa-(+(pa|0)>qa&1)|0;if((oa|0)>1){qa=E*(la+K);la=-1.5707963705062866;pa=-1;ra=1;while(1){la=K+la;sa=~~qa;ta=pa;pa=(Y(~~(ma*+O(+la)),R)|0)+(sa-(+(sa|0)>qa&1))|0;sa=Z+pa|0;b[sa>>0]=((pa|0)!=(ta|0)&1)+(h[sa>>0]|0);ra=ra+1|0;if((ra|0)==(oa|0)){ua=ka;break}else qa=na+qa}}else ua=ka}else ua=ja;ia=ia+1|0;if((ia|0)>=(B|0)){va=ua;break}else ja=ua}}else va=da;aa=aa+1|0;if((aa|0)>=(C|0))break;else da=va}}va=(Q|0)>0;if(va&(R|0)>0){da=0;C=0;while(1){aa=Y(da,R)|0;ua=0;B=C;do{B=((h[Z+(ua+aa)>>0]|0)>(A|0)&1)+B|0;ua=ua+1|0}while((ua|0)!=(R|0));da=da+1|0;if((da|0)==(Q|0)){wa=B;break}else C=B}}else wa=0;if((wa*100|0)>(W|0)){S1(a,c,d,A,j,k,l,m);xa=fa;ya=ga}else{ga=x+2|0;f[v>>2]=0;a=v+4|0;f[a>>2]=0;f[v+8>>2]=0;if(!ga)za=0;else{if((x|0)<-2)c4b(v);W=L5b(ga)|0;f[a>>2]=W;f[v>>2]=W;f[v+8>>2]=W+ga;wa=ga;ga=W;do{b[ga>>0]=0;ga=(f[a>>2]|0)+1|0;f[a>>2]=ga;wa=wa+-1|0}while((wa|0)!=0);za=f[v>>2]|0}wa=za+1|0;if(va){va=(R|0)>0;za=(ca|0)>0;m=J;ga=(i|0)>0;W=(x|0)>0;C=w+4|0;da=w+8|0;ua=0;while(1){if(va){aa=Y(ua,R)|0;J=+(ua|0);l=F*J;E=J*c;e=0;do{do if((h[Z+(e+aa)>>0]|0)>(A|0)){Nac(wa|0,0,x|0)|0;a:do if(za){z=Y(e,i)|0;if(ga)Aa=0;else{V=0;while(1){+gP(+(f[fa+(V<<2)>>2]|0)+.5,+(f[ea+(V<<2)>>2]|0)+.5);V=V+1|0;if((V|0)>=(ca|0))break a}}do{J=+(f[fa+(Aa<<2)>>2]|0)+.5;P=+(f[ea+(Aa<<2)>>2]|0)+.5;D=P;ha=J;N=I*+M(+(ha*ha+D*D));D=m*(+L(+(+gP(J,P)*.01745329238474369))+1.5707963267948966);V=~~D;ja=(z-V+(+(V|0)>D&1)|0)*5|0;V=0;while(1){D=N*+n[U+(((ja|0)>-1?ja:0-ja|0)<<2)>>2]-l;ia=~~D;_=(Y(ia-(+(ia|0)>D&1)|0,i)|0)+V|0;ia=_>>31&~_^_;_=wa+(((ia|0)>=(x|0)?ia^x:0)^ia)|0;b[_>>0]=(b[_>>0]|0)+1<<24>>24;V=V+1|0;if((V|0)==(i|0))break;else ja=ja+5|0}Aa=Aa+1|0}while((Aa|0)<(ca|0))}while(0);if(!W)break;N=+(e|0)*d;z=f[y>>2]|0;ja=f[p>>2]|0;V=0;_=ja;ia=z;ba=ja;ja=z;while(1){z=ia-_|0;oa=((z|0)/12|0)+-1|0;if((z|0)>=12){ra=b[wa+V>>0]|0;if((f[ba+(oa*12|0)>>2]|0)<(ra&255|0)){Ba=ra;Ca=70}else{Da=ja;Ea=ba;Fa=ba;Ga=ia}}else{Ba=b[wa+V>>0]|0;Ca=70}if((Ca|0)==70){Ca=0;f[w>>2]=Ba&255;n[C>>2]=E+G*+((V|0)/(i|0)|0|0);n[da>>2]=N+H*+((V|0)%(i|0)|0|0)+-1.5707963705062866;if((ja|0)==(f[S>>2]|0))U1(p,w);else{f[ja>>2]=f[w>>2];f[ja+4>>2]=f[w+4>>2];f[ja+8>>2]=f[w+8>>2];f[y>>2]=(f[y>>2]|0)+12}b:do if((z|0)>0){ra=oa;while(1){pa=f[p>>2]|0;sa=pa+(ra*12|0)|0;if((f[sa>>2]|0)>(f[w>>2]|0)){Ha=ra;break b}ta=pa+((ra+1|0)*12|0)|0;f[ta>>2]=f[sa>>2];f[ta+4>>2]=f[sa+4>>2];f[ta+8>>2]=f[sa+8>>2];sa=ra+-1|0;if((ra|0)>0)ra=sa;else{Ha=sa;break}}}else Ha=oa;while(0);oa=(f[p>>2]|0)+((Ha+1|0)*12|0)|0;f[oa>>2]=f[w>>2];f[oa+4>>2]=f[w+4>>2];f[oa+8>>2]=f[w+8>>2];oa=f[y>>2]|0;z=f[p>>2]|0;ra=oa;if(((oa-z|0)/12|0|0)>(k|0)){sa=ra+-12|0;f[y>>2]=sa;Ia=sa;Ja=sa}else{Ia=ra;Ja=oa}Da=Ia;Ea=z;Fa=z;Ga=Ja}V=V+1|0;if((V|0)>=(x|0))break;else{_=Fa;ia=Ga;ba=Ea;ja=Da}}}while(0);e=e+1|0}while((e|0)<(R|0))}ua=ua+1|0;if((ua|0)>=(Q|0)){Ka=y;La=p;break}}}else{Ka=y;La=p}Q=f[Ka>>2]|0;ua=f[La>>2]|0;if((Q|0)!=(ua|0)){R=w+4|0;Da=j+4|0;Ea=j+8|0;Ga=0;Fa=ua;ua=Q;while(1){Q=Fa;if(+n[Q+(Ga*12|0)+4>>2]<0.0){Ma=Fa;Na=ua}else{x=f[Q+(Ga*12|0)+4>>2]|0;Ja=f[Q+(Ga*12|0)+8>>2]|0;f[w>>2]=x;f[R>>2]=Ja;Ja=f[Da>>2]|0;if((Ja|0)==(f[Ea>>2]|0)){V1(j,w);Oa=f[Ka>>2]|0;Pa=f[La>>2]|0}else{f[Ja>>2]=x;f[Ja+4>>2]=f[R>>2];f[Da>>2]=Ja+8;Oa=ua;Pa=Fa}Ma=Pa;Na=Oa}Ga=Ga+1|0;if(Ga>>>0>=((Na-Ma|0)/12|0)>>>0)break;else{Fa=Ma;ua=Na}}}Na=f[v>>2]|0;if(Na|0){if((f[a>>2]|0)!=(Na|0))f[a>>2]=Na;O5b(Na)}Na=f[t>>2]|0;xa=Na;ya=Na}if(xa|0){Na=f[$>>2]|0;if((Na|0)!=(xa|0))f[$>>2]=Na+(~((Na+-4-xa|0)>>>2)<<2);O5b(ya)}ya=f[s>>2]|0;if(ya|0){s=f[X>>2]|0;if((s|0)!=(ya|0))f[X>>2]=s+(~((s+-4-ya|0)>>>2)<<2);O5b(ya)}ya=f[r>>2]|0;if(ya|0){if((f[g>>2]|0)!=(ya|0))f[g>>2]=ya;O5b(ya)}ya=f[q>>2]|0;if(ya|0){q=f[T>>2]|0;if((q|0)!=(ya|0))f[T>>2]=q+(~((q+-4-ya|0)>>>2)<<2);O5b(ya)}ya=f[p>>2]|0;if(!ya){u=o;return}p=f[y>>2]|0;if((p|0)!=(ya|0))f[y>>2]=p+(~(((p+-12-ya|0)>>>0)/12|0)*12|0);O5b(ya);u=o;return}function U1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=(e|0)/12|0;h=g+1|0;if(h>>>0>357913941)c4b(a);i=a+8|0;j=((f[i>>2]|0)-d|0)/12|0;k=j<<1;l=j>>>0<178956970?(k>>>0<h>>>0?h:k):357913941;do if(l)if(l>>>0>357913941){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l*12|0)|0;break}else m=0;while(0);k=m+(g*12|0)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];b=k+(((e|0)/-12|0)*12|0)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+12;f[i>>2]=m+(l*12|0);if(!d)return;O5b(d);return}function V1(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)c4b(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=ze(8)|0;T5b(l,477177);f[l>>2]=149528;If(l|0,25408,1411)}else{n=L5b(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=j;j=l;do{m=j;j=j+-8|0;k=n;n=n+-8|0;f[j>>2]=f[n>>2];f[m+-4>>2]=f[k+-4>>2]}while((n|0)!=(i|0));o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;O5b(e);return}function W1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>2;switch(k|0){case 2:{l=5;break a;break}case 3:{l=7;break a;break}case 4:{l=15;break a;break}case 5:{l=16;break a;break}case 1:case 0:{l=63;break a;break}default:{}}if((j|0)<124){l=18;break a}m=h+(((k|0)/2|0)<<2)|0;do if((j|0)<=3996){n=f[m>>2]|0;o=f[h>>2]|0;p=f[c>>2]|0;q=f[p+(n<<2)>>2]|0;r=p+(o<<2)|0;s=f[r>>2]|0;t=f[e>>2]|0;u=f[p+(t<<2)>>2]|0;v=(u|0)>(q|0)|(t|0)<(n|0)&(u|0)==(q|0);if(!((q|0)>(s|0)|(n|0)<(o|0)&(q|0)==(s|0))){if(!v){w=0;x=p;break}f[m>>2]=t;f[e>>2]=n;s=f[m>>2]|0;q=f[h>>2]|0;u=f[p+(s<<2)>>2]|0;y=f[p+(q<<2)>>2]|0;if(!((u|0)>(y|0)|(s|0)<(q|0)&(u|0)==(y|0))){w=1;x=p;break}f[h>>2]=s;f[m>>2]=q;w=2;x=p;break}if(v){f[h>>2]=t;f[e>>2]=o;w=1;x=p;break}f[h>>2]=n;f[m>>2]=o;n=f[e>>2]|0;t=f[p+(n<<2)>>2]|0;v=f[r>>2]|0;if((t|0)>(v|0)|(n|0)<(o|0)&(t|0)==(v|0)){f[m>>2]=n;f[e>>2]=o;w=2;x=p}else{w=1;x=p}}else{p=(k|0)/4|0;o=Y1(h,h+(p<<2)|0,m,m+(p<<2)|0,e,c)|0;w=o;x=f[c>>2]|0}while(0);z=f[h>>2]|0;k=f[m>>2]|0;j=f[x+(z<<2)>>2]|0;o=f[x+(k<<2)>>2]|0;if((j|0)>(o|0)|(z|0)<(k|0)&(j|0)==(o|0)){A=e;B=w;break}o=f[c>>2]|0;j=o+(k<<2)|0;C=e;while(1){C=C+-4|0;if((h|0)==(C|0))break;D=f[C>>2]|0;p=f[o+(D<<2)>>2]|0;n=f[j>>2]|0;if((p|0)>(n|0)|(D|0)<(k|0)&(p|0)==(n|0)){l=45;break b}}k=h+4|0;j=f[e>>2]|0;n=f[o+(z<<2)>>2]|0;p=f[o+(j<<2)>>2]|0;if((n|0)>(p|0)|(z|0)<(j|0)&(n|0)==(p|0))E=k;else{if((k|0)==(e|0)){l=63;break a}else F=k;while(1){G=f[F>>2]|0;k=f[o+(G<<2)>>2]|0;if((n|0)>(k|0)|(z|0)<(G|0)&(n|0)==(k|0))break;k=F+4|0;if((k|0)==(e|0)){l=63;break a}else F=k}f[F>>2]=j;f[e>>2]=G;E=F+4|0}if((E|0)==(e|0)){l=63;break a}n=f[c>>2]|0;o=e;k=E;while(1){p=f[h>>2]|0;v=f[n+(p<<2)>>2]|0;t=k;while(1){H=f[t>>2]|0;r=f[n+(H<<2)>>2]|0;I=t+4|0;if((v|0)>(r|0)|(p|0)<(H|0)&(v|0)==(r|0)){J=o;break}else t=I}do{J=J+-4|0;K=f[J>>2]|0;r=f[n+(K<<2)>>2]|0}while((v|0)>(r|0)|(p|0)<(K|0)&(v|0)==(r|0));if(t>>>0>=J>>>0){h=t;continue b}f[t>>2]=K;f[J>>2]=H;o=J;k=I}}if((l|0)==45){l=0;f[h>>2]=D;f[C>>2]=z;A=C;B=w+1|0}k=h+4|0;c:do if(k>>>0<A>>>0){o=f[c>>2]|0;n=m;j=A;v=k;p=B;while(1){r=f[n>>2]|0;q=f[o+(r<<2)>>2]|0;s=v;while(1){L=f[s>>2]|0;y=f[o+(L<<2)>>2]|0;M=s+4|0;if((y|0)>(q|0)|(L|0)<(r|0)&(y|0)==(q|0))s=M;else{N=j;break}}do{N=N+-4|0;O=f[N>>2]|0;t=f[o+(O<<2)>>2]|0}while(!((t|0)>(q|0)|(O|0)<(r|0)&(t|0)==(q|0)));if(s>>>0>N>>>0){P=n;Q=p;R=s;break c}f[s>>2]=O;f[N>>2]=L;n=(n|0)==(s|0)?N:n;j=N;v=M;p=p+1|0}}else{P=m;Q=B;R=k}while(0);if((R|0)!=(P|0)?(k=f[P>>2]|0,p=f[R>>2]|0,v=f[c>>2]|0,j=f[v+(k<<2)>>2]|0,n=f[v+(p<<2)>>2]|0,(j|0)>(n|0)|(k|0)<(p|0)&(j|0)==(n|0)):0){f[R>>2]=k;f[P>>2]=p;S=Q+1|0}else S=Q;if(!S){T=_1(h,R,c)|0;p=R+4|0;if(_1(p,a,c)|0){l=62;break}if(T){g=p;continue}}p=R;if((p-i|0)>=(b-p|0)){l=61;break}W1(h,R,c);g=R+4|0}if((l|0)==61){l=0;W1(R+4|0,a,c);d=h;a=R;continue}else if((l|0)==62){l=0;if(T){l=63;break}else{d=h;a=R;continue}}}if((l|0)==5){R=f[e>>2]|0;d=f[h>>2]|0;T=f[c>>2]|0;i=f[T+(R<<2)>>2]|0;S=f[T+(d<<2)>>2]|0;if(!((i|0)>(S|0)|(R|0)<(d|0)&(i|0)==(S|0)))return;f[h>>2]=R;f[e>>2]=d;return}else if((l|0)==7){d=h+4|0;R=f[d>>2]|0;S=f[h>>2]|0;i=f[c>>2]|0;T=f[i+(R<<2)>>2]|0;Q=i+(S<<2)|0;P=f[Q>>2]|0;B=f[e>>2]|0;m=f[i+(B<<2)>>2]|0;M=(m|0)>(T|0)|(B|0)<(R|0)&(m|0)==(T|0);if(!((T|0)>(P|0)|(R|0)<(S|0)&(T|0)==(P|0))){if(!M)return;f[d>>2]=B;f[e>>2]=R;P=f[d>>2]|0;T=f[h>>2]|0;m=f[i+(P<<2)>>2]|0;N=f[i+(T<<2)>>2]|0;if(!((m|0)>(N|0)|(P|0)<(T|0)&(m|0)==(N|0)))return;f[h>>2]=P;f[d>>2]=T;return}if(M){f[h>>2]=B;f[e>>2]=S;return}f[h>>2]=R;f[d>>2]=S;R=f[e>>2]|0;B=f[i+(R<<2)>>2]|0;i=f[Q>>2]|0;if(!((B|0)>(i|0)|(R|0)<(S|0)&(B|0)==(i|0)))return;f[d>>2]=R;f[e>>2]=S;return}else if((l|0)==15){X1(h,h+4|0,h+8|0,e,c)|0;return}else if((l|0)==16){Y1(h,h+4|0,h+8|0,h+12|0,e,c)|0;return}else if((l|0)==18){Z1(h,a,c);return}else if((l|0)==63)return}function X1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=f[b>>2]|0;h=f[a>>2]|0;i=f[e>>2]|0;e=f[i+(g<<2)>>2]|0;j=i+(h<<2)|0;k=f[j>>2]|0;l=f[c>>2]|0;m=f[i+(l<<2)>>2]|0;n=(m|0)>(e|0)|(l|0)<(g|0)&(m|0)==(e|0);do if((e|0)>(k|0)|(g|0)<(h|0)&(e|0)==(k|0)){if(n){f[a>>2]=l;f[c>>2]=h;o=1;p=h;break}f[a>>2]=g;f[b>>2]=h;m=f[c>>2]|0;q=f[i+(m<<2)>>2]|0;r=f[j>>2]|0;if((q|0)>(r|0)|(m|0)<(h|0)&(q|0)==(r|0)){f[b>>2]=m;f[c>>2]=h;o=2;p=h}else{o=1;p=m}}else if(n){f[b>>2]=l;f[c>>2]=g;m=f[b>>2]|0;r=f[a>>2]|0;q=f[i+(m<<2)>>2]|0;s=f[i+(r<<2)>>2]|0;if((q|0)>(s|0)|(m|0)<(r|0)&(q|0)==(s|0)){f[a>>2]=m;f[b>>2]=r;o=2;p=f[c>>2]|0}else{o=1;p=g}}else{o=0;p=l}while(0);l=f[d>>2]|0;g=f[i+(l<<2)>>2]|0;n=f[i+(p<<2)>>2]|0;if(!((g|0)>(n|0)|(l|0)<(p|0)&(g|0)==(n|0))){t=o;return t|0}f[c>>2]=l;f[d>>2]=p;p=f[c>>2]|0;d=f[b>>2]|0;l=f[i+(p<<2)>>2]|0;n=f[i+(d<<2)>>2]|0;if(!((l|0)>(n|0)|(p|0)<(d|0)&(l|0)==(n|0))){t=o+1|0;return t|0}f[b>>2]=p;f[c>>2]=d;d=f[b>>2]|0;c=f[a>>2]|0;p=f[i+(d<<2)>>2]|0;n=f[i+(c<<2)>>2]|0;if(!((p|0)>(n|0)|(d|0)<(c|0)&(p|0)==(n|0))){t=o+2|0;return t|0}f[a>>2]=d;f[b>>2]=c;t=o+3|0;return t|0}function Y1(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=X1(a,b,c,d,g)|0;i=f[e>>2]|0;j=f[d>>2]|0;k=f[g>>2]|0;g=f[k+(i<<2)>>2]|0;l=f[k+(j<<2)>>2]|0;if(!((g|0)>(l|0)|(i|0)<(j|0)&(g|0)==(l|0))){m=h;return m|0}f[d>>2]=i;f[e>>2]=j;j=f[d>>2]|0;e=f[c>>2]|0;i=f[k+(j<<2)>>2]|0;l=f[k+(e<<2)>>2]|0;if(!((i|0)>(l|0)|(j|0)<(e|0)&(i|0)==(l|0))){m=h+1|0;return m|0}f[c>>2]=j;f[d>>2]=e;e=f[c>>2]|0;d=f[b>>2]|0;j=f[k+(e<<2)>>2]|0;l=f[k+(d<<2)>>2]|0;if(!((j|0)>(l|0)|(e|0)<(d|0)&(j|0)==(l|0))){m=h+2|0;return m|0}f[b>>2]=e;f[c>>2]=d;d=f[b>>2]|0;c=f[a>>2]|0;e=f[k+(d<<2)>>2]|0;l=f[k+(c<<2)>>2]|0;if(!((e|0)>(l|0)|(d|0)<(c|0)&(e|0)==(l|0))){m=h+3|0;return m|0}f[a>>2]=d;f[b>>2]=c;m=h+4|0;return m|0}function Z1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=a+8|0;e=a+4|0;g=f[e>>2]|0;h=f[a>>2]|0;i=f[c>>2]|0;j=f[i+(g<<2)>>2]|0;k=i+(h<<2)|0;l=f[k>>2]|0;m=f[d>>2]|0;n=i+(m<<2)|0;o=f[n>>2]|0;p=(o|0)>(j|0)|(m|0)<(g|0)&(o|0)==(j|0);do if((j|0)>(l|0)|(g|0)<(h|0)&(j|0)==(l|0)){if(p){f[a>>2]=m;f[d>>2]=h;q=h;break}f[a>>2]=g;f[e>>2]=h;o=f[n>>2]|0;r=f[k>>2]|0;if((o|0)>(r|0)|(m|0)<(h|0)&(o|0)==(r|0)){f[e>>2]=m;f[d>>2]=h;q=h}else q=m}else if(p){f[e>>2]=m;f[d>>2]=g;r=f[n>>2]|0;o=f[k>>2]|0;if((r|0)>(o|0)|(m|0)<(h|0)&(r|0)==(o|0)){f[a>>2]=m;f[e>>2]=h;q=g}else q=g}else q=m;while(0);m=a+12|0;if((m|0)==(b|0))return;else{s=m;t=d;u=i;v=q}while(1){q=f[s>>2]|0;i=f[u+(q<<2)>>2]|0;d=f[u+(v<<2)>>2]|0;if((i|0)>(d|0)|(q|0)<(v|0)&(i|0)==(d|0)){d=f[c>>2]|0;i=d+(q<<2)|0;m=t;g=s;h=v;while(1){f[g>>2]=h;if((m|0)==(a|0)){w=a;break}e=m+-4|0;h=f[e>>2]|0;k=f[i>>2]|0;n=f[d+(h<<2)>>2]|0;if(!((k|0)>(n|0)|(q|0)<(h|0)&(k|0)==(n|0))){w=m;break}else{n=m;m=e;g=n}}f[w>>2]=q;x=d}else x=u;g=s+4|0;if((g|0)==(b|0))break;m=f[s>>2]|0;h=s;s=g;u=x;v=m;t=h}return}function _1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=f[c>>2]|0;i=f[h+(e<<2)>>2]|0;j=f[h+(g<<2)>>2]|0;if(!((i|0)>(j|0)|(e|0)<(g|0)&(i|0)==(j|0))){k=1;return k|0}f[a>>2]=e;f[d>>2]=g;k=1;return k|0}case 3:{g=a+4|0;d=b+-4|0;e=f[g>>2]|0;j=f[a>>2]|0;i=f[c>>2]|0;h=f[i+(e<<2)>>2]|0;l=i+(j<<2)|0;m=f[l>>2]|0;n=f[d>>2]|0;o=f[i+(n<<2)>>2]|0;p=(o|0)>(h|0)|(n|0)<(e|0)&(o|0)==(h|0);if(!((h|0)>(m|0)|(e|0)<(j|0)&(h|0)==(m|0))){if(!p){k=1;return k|0}f[g>>2]=n;f[d>>2]=e;m=f[g>>2]|0;h=f[a>>2]|0;o=f[i+(m<<2)>>2]|0;q=f[i+(h<<2)>>2]|0;if(!((o|0)>(q|0)|(m|0)<(h|0)&(o|0)==(q|0))){k=1;return k|0}f[a>>2]=m;f[g>>2]=h;k=1;return k|0}if(p){f[a>>2]=n;f[d>>2]=j;k=1;return k|0}f[a>>2]=e;f[g>>2]=j;e=f[d>>2]|0;n=f[i+(e<<2)>>2]|0;i=f[l>>2]|0;if(!((n|0)>(i|0)|(e|0)<(j|0)&(n|0)==(i|0))){k=1;return k|0}f[g>>2]=e;f[d>>2]=j;k=1;return k|0}case 4:{X1(a,a+4|0,a+8|0,b+-4|0,c)|0;k=1;return k|0}case 5:{Y1(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;k=1;return k|0}case 1:case 0:{k=1;return k|0}default:{j=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;i=f[c>>2]|0;n=f[i+(e<<2)>>2]|0;l=i+(g<<2)|0;p=f[l>>2]|0;h=f[j>>2]|0;m=i+(h<<2)|0;q=f[m>>2]|0;o=(q|0)>(n|0)|(h|0)<(e|0)&(q|0)==(n|0);do if((n|0)>(p|0)|(e|0)<(g|0)&(n|0)==(p|0)){if(o){f[a>>2]=h;f[j>>2]=g;r=g;break}f[a>>2]=e;f[d>>2]=g;q=f[m>>2]|0;s=f[l>>2]|0;if((q|0)>(s|0)|(h|0)<(g|0)&(q|0)==(s|0)){f[d>>2]=h;f[j>>2]=g;r=g}else r=h}else if(o){f[d>>2]=h;f[j>>2]=e;s=f[m>>2]|0;q=f[l>>2]|0;if((s|0)>(q|0)|(h|0)<(g|0)&(s|0)==(q|0)){f[a>>2]=h;f[d>>2]=g;r=e}else r=e}else r=h;while(0);h=a+12|0;a:do if((h|0)==(b|0)){t=1;u=0}else{e=h;g=0;d=j;l=i;m=r;while(1){o=f[e>>2]|0;p=f[l+(o<<2)>>2]|0;n=f[l+(m<<2)>>2]|0;if((p|0)>(n|0)|(o|0)<(m|0)&(p|0)==(n|0)){n=f[c>>2]|0;p=n+(o<<2)|0;q=d;s=e;v=m;while(1){f[s>>2]=v;if((q|0)==(a|0)){w=a;break}x=q+-4|0;v=f[x>>2]|0;y=f[p>>2]|0;z=f[n+(v<<2)>>2]|0;if(!((y|0)>(z|0)|(o|0)<(v|0)&(y|0)==(z|0))){w=q;break}else{z=q;q=x;s=z}}f[w>>2]=o;s=g+1|0;if((s|0)==8){t=0;u=(e+4|0)==(b|0);break a}else{A=s;B=n}}else{A=g;B=l}s=e+4|0;if((s|0)==(b|0)){t=1;u=0;break a}q=f[e>>2]|0;v=e;e=s;g=A;l=B;m=q;d=v}}while(0);k=u|t;return k|0}}return 0}function $1(a,b,c,d,e,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;g=+g;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;i=u;u=u+144|0;j=i+128|0;k=i+72|0;l=i+56|0;m=i;dQ(j,51392);do if((yM(a)|0)==65536){n=f[a+4>>2]|0;f[k>>2]=f[n>>2];o=k+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=k+8|0;f[q>>2]=f[n+8>>2];f[k+12>>2]=f[n+12>>2];f[k+16>>2]=f[n+16>>2];f[k+20>>2]=f[n+20>>2];f[k+24>>2]=f[n+24>>2];f[k+28>>2]=f[n+28>>2];f[k+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[k+36>>2]=r;f[k+40>>2]=q;q=k+48|0;s=k+44|0;f[s>>2]=q;f[q>>2]=0;f[k+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;jL(k,n);break}}else yL(k,a,-1);while(0);f[l>>2]=0;a=l+4|0;f[a>>2]=0;f[l+8>>2]=0;n=MVb(g)|0;a2(k,c,d,e,n,MVb(h)|0,l,2147483647);f[m>>2]=1124024348;n=m+4|0;f[n>>2]=2;e=m+8|0;o=f[a>>2]|0;p=f[l>>2]|0;q=o-p|0;f[e>>2]=q>>4;f[m+12>>2]=1;s=m+16|0;r=m+40|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[s+16>>2]=0;f[s+20>>2]=0;f[r>>2]=e;e=m+48|0;t=m+44|0;f[t>>2]=e;f[e>>2]=0;v=m+52|0;f[v>>2]=0;w=p;if((w|0)!=(o|0)){f[v>>2]=16;f[e>>2]=16;f[s>>2]=w;f[m+20>>2]=w;w=p+q|0;f[m+24>>2]=w;f[m+28>>2]=w}SP(m,b);b=m+36|0;w=f[b>>2]|0;if(w|0?(q=w+12|0,w=f[q>>2]|0,f[q>>2]=w+-1,(w|0)==1):0)kL(m);f[b>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[n>>2]|0)>0){s=f[r>>2]|0;r=0;do{f[s+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[n>>2]|0))}n=f[t>>2]|0;if((n|0)!=(e|0))UC(n);n=f[l>>2]|0;if(n|0){l=f[a>>2]|0;if((l|0)!=(n|0))f[a>>2]=l+(~((l+-16-n|0)>>>4)<<4);O5b(n)}n=k+36|0;l=f[n>>2]|0;if(l|0?(a=l+12|0,l=f[a>>2]|0,f[a>>2]=l+-1,(l|0)==1):0)kL(k);f[n>>2]=0;n=k+16|0;l=k+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[l>>2]|0)>0){n=f[k+40>>2]|0;a=0;do{f[n+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))UC(l);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function a2(a,c,d,e,g,h,i,j){a=a|0;c=+c;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;k=u;u=u+416|0;l=k+392|0;m=k+384|0;o=k+328|0;p=k;q=k+272|0;r=k+256|0;s=k+240|0;t=k+224|0;f[m>>2]=0;v=m+4|0;f[v>>2]=0;w=1.0/c;if(f[a>>2]&4095|0){f[l>>2]=0;f[l+4>>2]=0;x=aD(l,57)|0;y=230246;z=x+57|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,l,230304,230005,425);bD(l)}y=f[a+12>>2]|0;A=f[a+8>>2]|0;B=d;C=MVb(3.141592653589793/B)|0;D=LVb(+(A+y<<1|1|0)/c)|0;QS(p,C,D,4);f[o>>2]=1124007936;E=o+4|0;F=o+8|0;G=o+40|0;x=E;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[G>>2]=F;F=o+48|0;H=o+44|0;f[H>>2]=F;f[F>>2]=0;f[o+52>>2]=0;I=f[p>>2]|0;th[f[(f[I>>2]|0)+12>>2]&511](I,p,o,-1);Wi(p);f[q>>2]=1124007936;p=q+4|0;I=q+8|0;K=q+40|0;x=p;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[K>>2]=I;I=q+48|0;x=q+44|0;f[x>>2]=I;f[I>>2]=0;f[q+52>>2]=0;f[l>>2]=A;f[l+4>>2]=y;hL(q,2,l,0);z=C<<1;f[l>>2]=0;M=l+4|0;f[M>>2]=0;f[l+8>>2]=0;if(C){if(z>>>0>1073741823)c4b(l);N=C<<3;Q=L5b(N)|0;f[l>>2]=Q;R=Q+(z<<2)|0;f[l+8>>2]=R;Nac(Q|0,0,N|0)|0;f[M>>2]=R;R=(C|0)>0;if(R){c=w;N=0;do{w=B*+(N|0);d=c*+O(+w);z=N<<1;n[Q+(z<<2)>>2]=d;d=c*+P(+w);n[Q+((z|1)<<2)>>2]=d;N=N+1|0}while((N|0)!=(C|0));S=R;T=Q}else{S=0;T=Q}}else{S=0;T=0}Q=q+16|0;R=f[Q>>2]|0;f[r>>2]=0;N=r+4|0;f[N>>2]=0;f[r+8>>2]=0;f[v>>2]=0;do if((A|0)>0){z=a+16|0;U=a+44|0;V=r+8|0;if((y|0)>0){W=R;X=0}else{Z=0;do Z=Z+1|0;while((Z|0)<(A|0));f[m>>2]=0;f[v>>2]=Z;_=0;$=0;aa=0;break}while(1){ba=(f[z>>2]|0)+(Y(f[f[U>>2]>>2]|0,X)|0)|0;ca=W+(Y(f[f[x>>2]>>2]|0,X)|0)|0;f[m>>2]=0;da=0;do{ea=ca+da|0;do if(b[ba+da>>0]|0){b[ea>>0]=1;fa=f[N>>2]|0;if((fa|0)==(f[V>>2]|0)){b2(r,m);break}else{f[fa>>2]=f[m>>2];f[fa+4>>2]=f[v>>2];f[N>>2]=fa+8;break}}else b[ea>>0]=0;while(0);da=(f[m>>2]|0)+1|0;f[m>>2]=da}while((da|0)<(y|0));da=(f[v>>2]|0)+1|0;f[v>>2]=da;if((da|0)>=(A|0))break;W=f[Q>>2]|0;X=da}V=f[r>>2]|0;_=V;$=f[N>>2]|0;aa=V}else{_=0;$=0;aa=0}while(0);X=$-_|0;a:do if((X|0)>0){_=e+-1|0;$=o+16|0;W=(D+-1|0)/2|0;v=s+8|0;m=s+12|0;a=s+4|0;V=t+4|0;U=t+8|0;z=t+12|0;Z=i+4|0;da=i+8|0;ba=S^1;ca=X>>>3;ea=-1;fa=-1;ga=aa;while(1){ha=cbc(ea|0,0,-130063606,0)|0;ia=Kac(ha|0,J|0,fa|0,0)|0;ha=J;ja=(ia>>>0)%(ca>>>0)|0;ka=f[ga+(ja<<3)>>2]|0;la=f[ga+(ja<<3)+4>>2]|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;ma=f[$>>2]|0;na=ca+-1|0;f[ga+(ja<<3)>>2]=f[ga+(na<<3)>>2];f[ga+(ja<<3)+4>>2]=f[ga+(na<<3)+4>>2];ja=R+((Y(la,y)|0)+ka)|0;if(!((b[ja>>0]|0)==0|ba)){c=+(ka|0);B=+(la|0);ja=_;oa=0;pa=0;qa=ma;while(1){ma=oa<<1;ra=qa+((LVb(c*+n[T+(ma<<2)>>2]+B*+n[T+((ma|1)<<2)>>2])|0)+W<<2)|0;ma=f[ra>>2]|0;sa=ma+1|0;f[ra>>2]=sa;ra=(ja|0)>(ma|0);pa=ra?pa:oa;ja=ra?ja:sa;oa=oa+1|0;if((oa|0)==(C|0))break;else qa=qa+(D<<2)|0}if((ja|0)>=(e|0)){qa=pa<<1;B=+n[T+((qa|1)<<2)>>2];c=+n[T+(qa<<2)>>2];d=+L(+-B);w=+L(+c);if(d>w){ta=0;ua=LVb(c*65536.0/d)|0;va=B<-0.0?1:-1;wa=la<<16|32768;xa=ka}else{ta=1;ua=c>0.0?1:-1;va=LVb(B*-65536.0/w)|0;wa=la;xa=ka<<16|32768}qa=0-va|0;oa=0-ua|0;sa=wa>>16;ra=xa>>16;if(((ta?ra:xa)|0)>=0){ma=f[a>>2]|0;ya=f[s>>2]|0;b:do if(ta){za=ra;Aa=ya;Ba=wa;Ca=ma;Da=xa;Ea=0;while(1){if(!((Ba|0)<(A|0)&((za|0)<(y|0)&(Ba|0)>-1))){Fa=Aa;Ga=Ca;break b}Ha=R+(Y(Ba,y)|0)+za|0;if(!(b[Ha>>0]|0))if((Ea|0)<(h|0)){Ia=Aa;Ja=Ca;Ka=Ea+1|0}else{Fa=Aa;Ga=Ca;break b}else{Ia=za;Ja=Ba;Ka=0}Da=Da+va|0;za=Da>>16;if((za|0)<0){Fa=Ia;Ga=Ja;break}else{Aa=Ia;Ba=Ba+ua|0;Ca=Ja;Ea=Ka}}}else{Ea=xa;Ca=ya;Ba=sa;Aa=ma;za=wa;Da=0;while(1){if(!((Ba|0)<(A|0)&((Ea|0)<(y|0)&(Ba|0)>-1))){Fa=Ca;Ga=Aa;break b}Ha=R+(Y(Ba,y)|0)+Ea|0;if(!(b[Ha>>0]|0))if((Da|0)<(h|0)){La=Ca;Ma=Aa;Na=Da+1|0}else{Fa=Ca;Ga=Aa;break b}else{La=Ea;Ma=Ba;Na=0}Ea=Ea+va|0;Ha=za+ua|0;if((Ea|0)<0){Fa=La;Ga=Ma;break}else{Ca=La;Ba=Ha>>16;Aa=Ma;za=Ha;Da=Na}}}while(0);f[a>>2]=Ga;f[s>>2]=Fa;ma=f[m>>2]|0;ya=f[v>>2]|0;c:do if(ta){ka=ra;la=ya;pa=wa;ja=ma;Da=xa;za=0;while(1){if(!((pa|0)<(A|0)&((ka|0)<(y|0)&(pa|0)>-1))){Oa=la;Pa=ja;break c}Aa=R+(Y(pa,y)|0)+ka|0;if(!(b[Aa>>0]|0))if((za|0)<(h|0)){Qa=la;Ra=ja;Sa=za+1|0}else{Oa=la;Pa=ja;break c}else{Qa=ka;Ra=pa;Sa=0}Da=Da-va|0;ka=Da>>16;if((ka|0)<0){Oa=Qa;Pa=Ra;break}else{la=Qa;pa=pa-ua|0;ja=Ra;za=Sa}}}else{za=xa;ja=ya;pa=sa;la=ma;ka=wa;Da=0;while(1){if(!((pa|0)<(A|0)&((za|0)<(y|0)&(pa|0)>-1))){Oa=ja;Pa=la;break c}Aa=R+(Y(pa,y)|0)+za|0;if(!(b[Aa>>0]|0))if((Da|0)<(h|0)){Ta=ja;Ua=la;Va=Da+1|0}else{Oa=ja;Pa=la;break c}else{Ta=za;Ua=pa;Va=0}za=za-va|0;Aa=ka-ua|0;if((za|0)<0){Oa=Ta;Pa=Ua;break}else{ja=Ta;pa=Aa>>16;la=Ua;ka=Aa;Da=Va}}}while(0);f[m>>2]=Pa;f[v>>2]=Oa}ma=(f[v>>2]|0)-(f[s>>2]|0)|0;if((((ma|0)>-1?ma:0-ma|0)|0)<(g|0)){ma=(f[m>>2]|0)-(f[a>>2]|0)|0;Wa=(((ma|0)>-1?ma:0-ma|0)|0)>=(g|0)}else Wa=1;ma=Wa&S;sa=0;do{ya=(sa|0)==1;ra=ya?qa:va;Da=ya?oa:ua;ya=s+(sa<<3)|0;ka=s+(sa<<3)+4|0;d:do if(ta){la=wa;pa=xa;while(1){ja=pa>>16;za=R+(Y(la,y)|0)+ja|0;if(b[za>>0]|0){if(ma){w=+(ja|0);B=+(la|0);Aa=0;Ba=f[$>>2]|0;while(1){Ca=Aa<<1;Ea=Ba+((LVb(w*+n[T+(Ca<<2)>>2]+B*+n[T+((Ca|1)<<2)>>2])|0)+W<<2)|0;f[Ea>>2]=(f[Ea>>2]|0)+-1;Aa=Aa+1|0;if((Aa|0)==(C|0))break;else Ba=Ba+(D<<2)|0}}b[za>>0]=0}if((la|0)==(f[ka>>2]|0)?(ja|0)==(f[ya>>2]|0):0)break d;la=la+Da|0;pa=pa+ra|0}}else{if(Wa){Xa=wa;Ya=xa}else{pa=f[ka>>2]|0;la=f[ya>>2]|0;Ba=wa;Aa=xa;while(1){Ea=Ba>>16;Ca=R+(Y(Ea,y)|0)+Aa|0;if(b[Ca>>0]|0)b[Ca>>0]=0;if((Ea|0)==(pa|0)&(Aa|0)==(la|0))break d;Ba=Ba+Da|0;Aa=Aa+ra|0}}while(1){Aa=Xa>>16;Ba=R+(Y(Aa,y)|0)+Ya|0;if(b[Ba>>0]|0){if(S){B=+(Ya|0);w=+(Aa|0);la=0;pa=f[$>>2]|0;while(1){Ea=la<<1;Ca=pa+((LVb(B*+n[T+(Ea<<2)>>2]+w*+n[T+((Ea|1)<<2)>>2])|0)+W<<2)|0;f[Ca>>2]=(f[Ca>>2]|0)+-1;la=la+1|0;if((la|0)==(C|0))break;else pa=pa+(D<<2)|0}}b[Ba>>0]=0}if((Aa|0)==(f[ka>>2]|0)?(Ya|0)==(f[ya>>2]|0):0)break d;Xa=Xa+Da|0;Ya=Ya+ra|0}}while(0);sa=sa+1|0}while((sa|0)!=2);if(Wa){sa=f[s>>2]|0;ma=f[a>>2]|0;oa=f[v>>2]|0;qa=f[m>>2]|0;f[t>>2]=sa;f[V>>2]=ma;f[U>>2]=oa;f[z>>2]=qa;qa=f[Z>>2]|0;if((qa|0)==(f[da>>2]|0)){HZ(i,t);Za=f[Z>>2]|0}else{f[qa>>2]=sa;f[qa+4>>2]=f[V>>2];f[qa+8>>2]=f[U>>2];f[qa+12>>2]=f[z>>2];sa=qa+16|0;f[Z>>2]=sa;Za=sa}if((Za-(f[i>>2]|0)>>4|0)>=(j|0))break}}}if((ca|0)<=1)break a;ca=na;ea=ia;fa=ha;ga=f[r>>2]|0}}while(0);j=f[r>>2]|0;if(j|0){r=f[N>>2]|0;if((r|0)!=(j|0))f[N>>2]=r+(~((r+-8-j|0)>>>3)<<3);O5b(j)}j=f[l>>2]|0;if(j|0){l=f[M>>2]|0;if((l|0)!=(j|0))f[M>>2]=l+(~((l+-4-j|0)>>>2)<<2);O5b(j)}j=q+36|0;l=f[j>>2]|0;if(l|0?(M=l+12|0,l=f[M>>2]|0,f[M>>2]=l+-1,(l|0)==1):0)kL(q);f[j>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[p>>2]|0)>0){Q=f[K>>2]|0;K=0;do{f[Q+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[p>>2]|0))}p=f[x>>2]|0;if((p|0)!=(I|0))UC(p);p=o+36|0;I=f[p>>2]|0;if(I|0?(x=I+12|0,I=f[x>>2]|0,f[x>>2]=I+-1,(I|0)==1):0)kL(o);f[p>>2]=0;p=o+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[E>>2]|0)>0){p=f[G>>2]|0;G=0;do{f[p+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[E>>2]|0))}E=f[H>>2]|0;if((E|0)==(F|0)){u=k;return}UC(E);u=k;return}function b2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)c4b(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=ze(8)|0;T5b(l,477177);f[l>>2]=149528;If(l|0,25408,1411)}else{n=L5b(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=j;j=l;while(1){m=n;n=n+-8|0;f[j+-8>>2]=f[n>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-8|0}o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;O5b(e);return}function c2(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;i=i|0;d2(a,b,c,d,e,f,g,h,i,-1);return}function d2(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=+i;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;m=u;u=u+576|0;o=m;p=m+520|0;q=m+488|0;r=m+432|0;s=m+376|0;t=m+320|0;v=m+312|0;w=m+300|0;x=m+288|0;y=m+232|0;z=m+176|0;A=m+80|0;B=m+24|0;C=m+16|0;dQ(C,51412);if(!(HM(a)|0)?(BL(a,-1)|0)==0:0){if((yM(a)|0)!=65536?(yM(a)|0)!=655360:0)D=5}else D=5;if((D|0)==5){f[o>>2]=0;f[o+4>>2]=0;E=aD(o,116)|0;F=230411;G=E+116|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-215,o,230528,230005,1494);bD(o)}if((((yM(c)|0)!=65536?(yM(c)|0)!=196608:0)?(yM(c)|0)!=786432:0)?(yM(c)|0)!=917504:0){f[o>>2]=0;f[o+4>>2]=0;E=aD(o,39)|0;F=230541;G=E+39|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-215,o,230528,230005,1495);bD(o)}if(e<=0.0|g<=0.0|h<=0.0|i<=0.0){f[o>>2]=0;f[o+4>>2]=0;E=aD(o,76)|0;F=230581;G=E+76|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-211,o,230528,230005,1498);bD(o)}H=MVb(h)|0;I=MVb(i)|0;J=MVb(3.0)|0;K=(j|0)>0?j:0;j=(l|0)<0?2147483647:l;if((k|0)<1){l=BM(a,-1)|0;L=CM(a,-1)|0;M=(l|0)<(L|0)?L:l}else M=(K|0)<(k|0)?k:K+2|0;if((d|0)==3){i=e;e=g;switch(J|0){case 3:case 5:case 7:case -1:break;default:{f[o>>2]=0;f[o+4>>2]=0;E=aD(o,73)|0;F=230658;G=E+73|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-215,o,230732,230005,1397);bD(o)}}g=i<1.0?1.0:i;i=1.0/g;f[r>>2]=1124007936;d=r+4|0;k=r+8|0;l=r+40|0;E=d;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[l>>2]=k;L=r+48|0;N=r+44|0;f[N>>2]=L;f[L>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;O=s+4|0;P=s+8|0;Q=s+40|0;E=O;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[Q>>2]=P;P=s+48|0;R=s+44|0;f[R>>2]=P;f[P>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;S=t+4|0;T=t+8|0;U=t+40|0;E=S;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[U>>2]=T;T=t+48|0;V=t+44|0;f[V>>2]=T;f[T>>2]=0;f[t+52>>2]=0;W=o+8|0;f[W>>2]=0;f[W+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=s;z2(a,o,3,1,0,J,1.0,0.0,1);W=o+8|0;f[W>>2]=0;f[W+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=t;z2(a,o,3,0,1,J,1.0,0.0,1);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=s;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=t;J=q+8|0;f[J>>2]=0;f[J+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=r;J=(H|0)/2|0;V4(o,p,q,+(((J|0)>1?J:1)|0),+(H|0),0);NO(v);H=SQ()|0;J=(H|0)>1;f[w>>2]=0;a=w+4|0;f[a>>2]=0;f[w+8>>2]=0;f[x>>2]=0;W=x+4|0;f[W>>2]=0;f[x+8>>2]=0;X=f[k>>2]|0;f[o>>2]=0;f[o+4>>2]=X;f[p>>2]=51440;f[p+4>>2]=r;f[p+8>>2]=s;f[p+12>>2]=t;f[p+16>>2]=K;f[p+20>>2]=M;n[p+24>>2]=i;f[p+28>>2]=w;f[p+32>>2]=x;f[p+48>>2]=v;h=i*+(f[r+12>>2]|0);k=~~h;Z=(+(k|0)<h&1)+k|0;f[p+36>>2]=Z;h=i*+(X|0);X=~~h;f[p+40>>2]=(+(X|0)<h&1)+X;f[p+44>>2]=Z+2;RQ(o,p,+(((H|0)>1?H:1)|0));H=f[x>>2]|0;if((H|0)==(f[W>>2]|0))_=H;else{H=f[w>>2]|0;f[y>>2]=1124007936;Z=y+4|0;X=y+8|0;k=y+40|0;E=Z;G=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(G|0));f[k>>2]=X;$=y+48|0;aa=y+44|0;f[aa>>2]=$;f[$>>2]=0;f[y+52>>2]=0;ba=o+8|0;f[ba>>2]=0;f[ba+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=y;SP(H,o);H=f[w>>2]|0;if((((f[a>>2]|0)-H|0)/56|0)>>>0>1){ba=o+8|0;ca=o+12|0;da=o+4|0;ea=p+8|0;fa=p+12|0;ga=p+4|0;ha=q+8|0;ia=q+4|0;ja=1;ka=H;do{f[ba>>2]=0;f[ca>>2]=0;f[o>>2]=16842752;f[da>>2]=y;f[ea>>2]=0;f[fa>>2]=0;f[p>>2]=16842752;f[ga>>2]=ka+(ja*56|0);H=ha;f[H>>2]=0;f[H+4>>2]=0;f[q>>2]=33619968;f[ia>>2]=y;VD(o,p,q,UM()|0,-1);ja=ja+1|0;ka=f[w>>2]|0}while(ja>>>0<(((f[a>>2]|0)-ka|0)/56|0)>>>0)}f[p>>2]=0;ka=p+4|0;f[ka>>2]=0;f[p+8>>2]=0;a=f[X>>2]|0;f[o>>2]=1;f[o+4>>2]=a+-1;f[q>>2]=51460;f[q+4>>2]=y;f[q+8>>2]=p;f[q+12>>2]=I;f[q+28>>2]=v;X=y+12|0;f[q+16>>2]=f[X>>2];f[q+20>>2]=a;ja=y+16|0;f[q+24>>2]=f[ja>>2];RQ(o,q,J?+((a+-2|0)/4|0|0):1.0);a=f[ka>>2]|0;ia=f[p>>2]|0;ha=a-ia|0;ga=ha>>2;fa=ia;if(!ga)la=fa;else{f[o>>2]=f[ja>>2];W1(fa,a,o);f[q>>2]=0;a=q+4|0;f[a>>2]=0;f[q+8>>2]=0;fa=q+8|0;ia=L5b(3072)|0;ea=ia;f[q>>2]=ea;f[a>>2]=ea;f[fa>>2]=ia+3072;do if(!j){h=e*e;a:do if((ha|0)>0){da=o+4|0;ca=o+8|0;ba=0;H=ea;ma=ea;na=ia;oa=ia;while(1){pa=f[(f[p>>2]|0)+(ba<<2)>>2]|0;qa=f[X>>2]|0;ra=(pa|0)/(qa|0)|0;i=+(pa-(Y(ra,qa)|0)|0);sa=+(ra|0);if((H|0)!=(ma|0)){ra=(H-na|0)/12|0;qa=0;pa=1;do{ta=i-+n[na+(qa*12|0)>>2];ua=sa-+n[na+(qa*12|0)+4>>2];va=!(ta*ta+ua*ua<h);pa=pa&va;qa=qa+1|0}while(qa>>>0<ra>>>0&va);if(!pa){wa=H;xa=ma}else D=32}else D=32;if((D|0)==32){D=0;ua=g*(i+.5);n[o>>2]=ua;n[da>>2]=g*(sa+.5);n[ca>>2]=0.0;if((oa|0)==(f[fa>>2]|0)){e2(q,o);ya=f[a>>2]|0;za=f[q>>2]|0}else{n[oa>>2]=ua;f[oa+4>>2]=f[da>>2];f[oa+8>>2]=f[ca>>2];ra=oa+12|0;f[a>>2]=ra;ya=ra;za=ma}wa=ya;xa=za}ra=ba+1|0;if((ra|0)>=(ga|0)){Aa=xa;Ba=wa;break a}ba=ra;H=wa;ma=xa;na=xa;oa=wa}}else{Aa=ea;Ba=ea}while(0);oa=Ba-Aa|0;if(!oa){Ca=h;D=63}else{aM(c,1,(oa|0)/12|0,21,-1,0,0);oa=f[q>>2]|0;na=(f[a>>2]|0)-oa|0;ma=(na|0)/12|0;H=oa;f[z>>2]=1124007957;ba=z+4|0;f[ba>>2]=2;ca=z+8|0;f[ca>>2]=1;da=z+12|0;f[da>>2]=ma;ra=z+16|0;f[ra>>2]=H;qa=z+20|0;f[qa>>2]=H;va=z+24|0;Da=z+28|0;Ea=z+40|0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;f[Ea>>2]=ca;Fa=z+48|0;Ga=z+44|0;f[Ga>>2]=Fa;f[z+52>>2]=0;f[Fa>>2]=0;if((oa|0)==0&(na|0)!=0){f[o>>2]=0;f[o+4>>2]=0;E=aD(o,26)|0;F=426262;G=E+26|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-215,o,426289,431198,500);bD(o);Ha=f[da>>2]|0;Ia=f[z>>2]|0;Ja=f[Ga>>2]|0;Ka=f[qa>>2]|0}else{Ha=ma;Ia=1124007957;Ja=Fa;Ka=H}na=Ha*12|0;f[z>>2]=Ia|16384;f[Ja>>2]=na;f[Ja+4>>2]=12;oa=Ka+(Y(f[ca>>2]|0,na)|0)|0;f[Da>>2]=oa;f[va>>2]=oa+(0-na)+na;do if((yM(c)|0)==65536){na=f[c+4>>2]|0;f[A>>2]=f[na>>2];oa=A+4|0;La=na+4|0;f[oa>>2]=f[La>>2];Ma=A+8|0;f[Ma>>2]=f[na+8>>2];f[A+12>>2]=f[na+12>>2];f[A+16>>2]=f[na+16>>2];f[A+20>>2]=f[na+20>>2];f[A+24>>2]=f[na+24>>2];f[A+28>>2]=f[na+28>>2];f[A+32>>2]=f[na+32>>2];Na=f[na+36>>2]|0;f[A+36>>2]=Na;f[A+40>>2]=Ma;Ma=A+48|0;Oa=A+44|0;f[Oa>>2]=Ma;f[Ma>>2]=0;f[A+52>>2]=0;if(Na|0){Ma=Na+12|0;f[Ma>>2]=(f[Ma>>2]|0)+1}if((f[La>>2]|0)<3){La=f[na+44>>2]|0;Ma=f[Oa>>2]|0;f[Ma>>2]=f[La>>2];f[Ma+4>>2]=f[La+4>>2];break}else{f[oa>>2]=0;jL(A,na);break}}else yL(A,c,-1);while(0);va=o+8|0;f[va>>2]=0;f[va+4>>2]=0;f[o>>2]=-1040121856;f[o+4>>2]=A;SP(z,o);va=A+36|0;Da=f[va>>2]|0;if(Da|0?(ca=Da+12|0,Da=f[ca>>2]|0,f[ca>>2]=Da+-1,(Da|0)==1):0)kL(A);f[va>>2]=0;va=A+16|0;Da=A+4|0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=0;f[va+12>>2]=0;if((f[Da>>2]|0)>0){va=f[A+40>>2]|0;ca=0;do{f[va+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[Da>>2]|0))}Da=f[A+44>>2]|0;if((Da|0)!=(A+48|0))UC(Da);Da=z+36|0;ca=f[Da>>2]|0;do if(ca|0){va=ca+12|0;H=f[va>>2]|0;f[va>>2]=H+-1;if((H|0)!=1)break;kL(z)}while(0);f[Da>>2]=0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;if((f[ba>>2]|0)>0){ca=f[Ea>>2]|0;H=0;do{f[ca+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[ba>>2]|0))}ba=f[Ga>>2]|0;if((ba|0)==(Fa|0)){D=87;break}UC(ba);D=87}}else{Ca=e;D=63}while(0);do if((D|0)==63){f[o>>2]=0;f[o+4>>2]=ga;f2(A,x,p,q,f[X>>2]|0,j,I,K,M,Ca,g,v);RQ(o,A,J?+(ga|0):1.0);g2(A);z=f[q>>2]|0;Ka=(f[a>>2]|0)-z|0;if(!Ka)Pa=z;else{aM(c,1,(Ka|0)/12|0,21,-1,0,0);Ka=f[q>>2]|0;z=(f[a>>2]|0)-Ka|0;Ja=B+4|0;f[Ja>>2]=2;Ia=B+8|0;f[Ia>>2]=1;f[B+12>>2]=(z|0)/12|0;Ha=B+16|0;f[Ha>>2]=Ka;f[B+20>>2]=Ka;Aa=B+24|0;Ba=B+40|0;ea=Aa+8|0;f[ea>>2]=0;f[ea+4>>2]=0;f[Ba>>2]=Ia;Ia=B+48|0;ea=B+44|0;f[ea>>2]=Ia;f[B>>2]=1124024341;f[Ia>>2]=z;f[B+52>>2]=12;wa=Ka+z|0;f[B+28>>2]=wa;f[Aa>>2]=wa+(0-z)+z;do if((yM(c)|0)==65536){z=f[c+4>>2]|0;f[A>>2]=f[z>>2];wa=A+4|0;Aa=z+4|0;f[wa>>2]=f[Aa>>2];Ka=A+8|0;f[Ka>>2]=f[z+8>>2];f[A+12>>2]=f[z+12>>2];f[A+16>>2]=f[z+16>>2];f[A+20>>2]=f[z+20>>2];f[A+24>>2]=f[z+24>>2];f[A+28>>2]=f[z+28>>2];f[A+32>>2]=f[z+32>>2];xa=f[z+36>>2]|0;f[A+36>>2]=xa;f[A+40>>2]=Ka;Ka=A+48|0;za=A+44|0;f[za>>2]=Ka;f[Ka>>2]=0;f[A+52>>2]=0;if(xa|0){Ka=xa+12|0;f[Ka>>2]=(f[Ka>>2]|0)+1}if((f[Aa>>2]|0)<3){Aa=f[z+44>>2]|0;Ka=f[za>>2]|0;f[Ka>>2]=f[Aa>>2];f[Ka+4>>2]=f[Aa+4>>2];break}else{f[wa>>2]=0;jL(A,z);break}}else yL(A,c,-1);while(0);Fa=o+8|0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[o>>2]=-1040121856;f[o+4>>2]=A;SP(B,o);Fa=A+36|0;Ga=f[Fa>>2]|0;if(Ga|0?(z=Ga+12|0,Ga=f[z>>2]|0,f[z>>2]=Ga+-1,(Ga|0)==1):0)kL(A);f[Fa>>2]=0;Fa=A+16|0;Ga=A+4|0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=0;f[Fa+12>>2]=0;if((f[Ga>>2]|0)>0){Fa=f[A+40>>2]|0;z=0;do{f[Fa+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[Ga>>2]|0))}Ga=f[A+44>>2]|0;if((Ga|0)!=(A+48|0))UC(Ga);Ga=B+36|0;z=f[Ga>>2]|0;do if(z|0){Fa=z+12|0;wa=f[Fa>>2]|0;f[Fa>>2]=wa+-1;if((wa|0)!=1)break;kL(B)}while(0);f[Ga>>2]=0;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=0;f[Ha+12>>2]=0;if((f[Ja>>2]|0)>0){z=f[Ba>>2]|0;wa=0;do{f[z+(wa<<2)>>2]=0;wa=wa+1|0}while((wa|0)<(f[Ja>>2]|0))}Ja=f[ea>>2]|0;if((Ja|0)==(Ia|0)){D=87;break}UC(Ja);D=87}}while(0);if((D|0)==87)Pa=f[q>>2]|0;if(Pa|0){q=f[a>>2]|0;if((q|0)!=(Pa|0))f[a>>2]=q+(~(((q+-12-Pa|0)>>>0)/12|0)*12|0);O5b(Pa)}la=f[p>>2]|0}if(la|0){p=f[ka>>2]|0;if((p|0)!=(la|0))f[ka>>2]=p+(~((p+-4-la|0)>>>2)<<2);O5b(la)}la=y+36|0;p=f[la>>2]|0;if(p|0?(ka=p+12|0,p=f[ka>>2]|0,f[ka>>2]=p+-1,(p|0)==1):0)kL(y);f[la>>2]=0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[Z>>2]|0)>0){ja=f[k>>2]|0;k=0;do{f[ja+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[Z>>2]|0))}Z=f[aa>>2]|0;if((Z|0)!=($|0))UC(Z);_=f[x>>2]|0}if(_|0){x=f[W>>2]|0;if((x|0)!=(_|0))f[W>>2]=x+(~((x+-8-_|0)>>>3)<<3);O5b(_)}et(w);OO(v);v=t+36|0;w=f[v>>2]|0;if(w|0?(_=w+12|0,w=f[_>>2]|0,f[_>>2]=w+-1,(w|0)==1):0)kL(t);f[v>>2]=0;v=t+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[S>>2]|0)>0){v=f[U>>2]|0;U=0;do{f[v+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[S>>2]|0))}S=f[V>>2]|0;if((S|0)!=(T|0))UC(S);S=s+36|0;T=f[S>>2]|0;if(T|0?(V=T+12|0,T=f[V>>2]|0,f[V>>2]=T+-1,(T|0)==1):0)kL(s);f[S>>2]=0;S=s+16|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[O>>2]|0)>0){S=f[Q>>2]|0;Q=0;do{f[S+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[O>>2]|0))}O=f[R>>2]|0;if((O|0)!=(P|0))UC(O);O=r+36|0;P=f[O>>2]|0;if(P|0?(R=P+12|0,P=f[R>>2]|0,f[R>>2]=P+-1,(P|0)==1):0)kL(r);f[O>>2]=0;O=r+16|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[d>>2]|0)>0){O=f[l>>2]|0;l=0;do{f[O+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[d>>2]|0))}d=f[N>>2]|0;if((d|0)!=(L|0))UC(d)}else{f[o>>2]=0;f[o+4>>2]=0;E=aD(o,69)|0;F=230753;G=E+69|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-5,o,230528,230005,1520);bD(o)}if(!(f[C+4>>2]|0)){u=m;return}u=m;return}function e2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/12|0;h=g+1|0;i=e;j=d;if(h>>>0>357913941)c4b(a);d=a+8|0;k=((f[d>>2]|0)-e|0)/12|0;l=k<<1;m=k>>>0<178956970?(l>>>0<h>>>0?h:l):357913941;do if(m)if(m>>>0>357913941){l=ze(8)|0;T5b(l,477177);f[l>>2]=149528;If(l|0,25408,1411)}else{n=L5b(m*12|0)|0;break}else n=0;while(0);l=n+(g*12|0)|0;h=n+(m*12|0)|0;f[l>>2]=f[b>>2];f[n+(g*12|0)+4>>2]=f[b+4>>2];f[n+(g*12|0)+8>>2]=f[b+8>>2];b=l+12|0;if((j|0)==(i|0))o=l;else{g=j;j=l;while(1){l=j+-12|0;n=g;g=g+-12|0;f[l>>2]=f[g>>2];f[j+-8>>2]=f[n+-8>>2];f[j+-4>>2]=f[n+-4>>2];if((g|0)==(i|0)){o=l;break}else j=l}}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;O5b(e);return}function f2(a,c,d,e,g,h,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;o=o|0;var p=0,q=0,r=0.0,s=0,t=0,v=0,w=0;p=u;u=u+16|0;q=p;f[a>>2]=51480;f[a+4>>2]=c;f[a+8>>2]=d;f[a+12>>2]=e;f[a+16>>2]=g;f[a+20>>2]=h;f[a+24>>2]=i;f[a+28>>2]=j;f[a+32>>2]=k;n[a+40>>2]=m;i=a+60|0;h=a+64|0;g=a+68|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[a+92>>2]=o;r=+(j|0);n[a+52>>2]=r*r;r=+(k|0);n[a+56>>2]=r*r;r=m<l?l:m;n[a+36>>2]=r*r;f[a+44>>2]=(f[c+4>>2]|0)-(f[c>>2]|0)>>3;c=(f[d+4>>2]|0)-(f[d>>2]|0)|0;d=c>>2;f[a+48>>2]=d;f[a+84>>2]=-1;b[a+88>>0]=0;b[a+89>>0]=0;k=L5b(1280)|0;j=k;f[a+72>>2]=j;f[a+76>>2]=j;f[a+80>>2]=k+1280;k=d+1|0;f[q>>2]=0;a=q+4|0;f[a>>2]=0;j=q+8|0;f[j>>2]=0;if(k){if((c|0)<-4)c4b(q);c=(d>>>5)+1|0;d=L5b(c<<2)|0;f[q>>2]=d;f[j>>2]=c;f[a>>2]=k;c=k>>>5;Nac(d|0,0,c<<2|0)|0;j=k-(c<<5)|0;o=d+(c<<2)|0;if(!j){s=d;t=k;v=d}else{f[o>>2]=f[o>>2]&~(-1>>>(32-j|0));s=d;t=k;v=d}}else{s=0;t=0;v=0}if((i|0)!=(q|0)){do if(t)if((t|0)<0)c4b(i);else{q=(t+-1|0)>>>5;d=q+1|0;k=L5b(d<<2)|0;f[i>>2]=k;f[h>>2]=0;f[g>>2]=d;Vac(k|0,v|0,(q<<2)+4|0)|0;w=f[a>>2]|0;break}else w=0;while(0);f[h>>2]=w}if(!s){u=p;return}O5b(v);u=p;return}function g2(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=51480;QO(f[a+92>>2]|0);b=f[a+72>>2]|0;if(b|0){c=a+76|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~(((d+-20-b|0)>>>0)/20|0)*20|0);O5b(b)}b=f[a+60>>2]|0;if(!b)return;O5b(b);return}function h2(a){a=a|0;g2(a);O5b(a);return}function i2(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0,La=0.0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0.0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0.0,rb=0.0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;d=u;u=u+288|0;e=d+260|0;g=d+248|0;h=d+192|0;i=d+136|0;j=d+80|0;k=d+64|0;l=d+8|0;m=d;o=a+88|0;if(b[o>>0]|0){u=d;return}p=a+28|0;q=a+40|0;r=LVb(+((f[a+32>>2]|0)-(f[p>>2]|0)|0)/+n[q>>2]*10.0)|0;f[g>>2]=0;s=g+4|0;f[s>>2]=0;f[g+8>>2]=0;do if(r|0)if(r>>>0>1073741823)c4b(g);else{t=r<<2;v=L5b(t)|0;f[g>>2]=v;w=v+(r<<2)|0;f[g+8>>2]=w;Nac(v|0,0,t|0)|0;f[s>>2]=w;break}while(0);w=a+44|0;t=f[w>>2]|0;f[h>>2]=1124007936;v=h+4|0;x=h+8|0;y=h+40|0;z=v;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[y>>2]=x;x=h+48|0;B=h+44|0;f[B>>2]=x;f[x>>2]=0;f[h+52>>2]=0;f[e>>2]=1;C=e+4|0;f[C>>2]=t;hL(h,2,e,5);t=f[w>>2]|0;f[i>>2]=1124007936;D=i+4|0;E=i+8|0;F=i+40|0;z=D;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[F>>2]=E;E=i+48|0;z=i+44|0;f[z>>2]=E;f[E>>2]=0;f[i+52>>2]=0;f[e>>2]=1;f[C>>2]=t;hL(i,2,e,5);t=h+16|0;C=f[t>>2]|0;A=i+16|0;G=f[A>>2]|0;H=a+48|0;I=f[c>>2]|0;J=c+4|0;c=f[J>>2]|0;K=(c|0)==(f[H>>2]|0);L=(I|0)==0&K;if(K)b[a+89>>0]=1;a:do if((I|0)<(c|0)){K=a+8|0;M=a+16|0;N=a+12|0;O=a+36|0;P=a+4|0;Q=a+52|0;R=a+56|0;S=k+4|0;T=e+4|0;U=m+4|0;V=e+4|0;W=k+8|0;X=k+12|0;Z=k+4|0;_=e+8|0;$=e+4|0;aa=l+36|0;ba=l+16|0;ca=l+4|0;da=l+40|0;ea=l+44|0;fa=l+48|0;ga=r+-1|0;ha=j+36|0;ia=j+16|0;ja=j+4|0;ka=j+40|0;la=j+44|0;ma=j+48|0;na=a+24|0;oa=e+4|0;pa=e+8|0;qa=a+20|0;ra=a+92|0;sa=a+60|0;ta=a+84|0;ua=a+72|0;va=e+4|0;wa=e+8|0;xa=e+12|0;ya=e+16|0;za=a+76|0;Aa=a+80|0;Ba=a+89|0;Ca=(r|0)<2;Da=I;b:while(1){if(b[o>>0]|0)break a;Ea=f[(f[f[K>>2]>>2]|0)+(Da<<2)>>2]|0;Fa=f[M>>2]|0;Ga=(Ea|0)/(Fa|0)|0;Ha=+(Ea-(Y(Ga,Fa)|0)|0)+.5;Ia=+n[q>>2];Ja=Ia*Ha;Ha=Ia*(+(Ga|0)+.5);Ga=f[N>>2]|0;Fa=f[Ga>>2]|0;Ea=(f[Ga+4>>2]|0)-Fa|0;Ga=(Ea|0)/12|0;Ka=Fa;c:do if((Ea|0)>0){Ia=+n[O>>2];Fa=0;while(1){La=+n[Ka+(Fa*12|0)>>2]-Ja;Ma=+n[Ka+(Fa*12|0)+4>>2]-Ha;Fa=Fa+1|0;if(La*La+Ma*Ma<Ia){Na=0;break c}if((Fa|0)>=(Ga|0)){Na=1;break}}}else Na=1;while(0);if(b[o>>0]|0)break a;if(Na){Ka=f[w>>2]|0;if((Ka|0)>0){Ea=0;Fa=0;while(1){Oa=f[f[P>>2]>>2]|0;Ia=Ja-+(f[Oa+(Ea<<3)>>2]|0);Ma=Ha-+(f[Oa+(Ea<<3)+4>>2]|0);La=Ia*Ia+Ma*Ma;if(+n[Q>>2]<=La?La<=+n[R>>2]:0){n[C+(Fa<<2)>>2]=La;Pa=Fa+1|0}else Pa=Fa;Ea=Ea+1|0;if((Ea|0)>=(Ka|0)){Qa=Pa;break}else Fa=Pa}}else Qa=0;if(b[o>>0]|0)break a;if(Qa){f[k>>2]=0;f[S>>2]=Qa;f[e>>2]=-2147483648;f[T>>2]=2147483647;lL(j,i,e,k);f[m>>2]=0;f[U>>2]=Qa;f[e>>2]=-2147483648;f[V>>2]=2147483647;lL(l,h,e,m);f[W>>2]=0;f[X>>2]=0;f[k>>2]=16842752;f[Z>>2]=l;Fa=_;f[Fa>>2]=0;f[Fa+4>>2]=0;f[e>>2]=33619968;f[$>>2]=j;dP(k,e);Fa=f[aa>>2]|0;if(Fa|0?(Ka=Fa+12|0,Fa=f[Ka>>2]|0,f[Ka>>2]=Fa+-1,(Fa|0)==1):0)kL(l);f[aa>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[ca>>2]|0)>0){Fa=f[da>>2]|0;Ka=0;do{f[Fa+(Ka<<2)>>2]=0;Ka=Ka+1|0}while((Ka|0)<(f[ca>>2]|0))}Ka=f[ea>>2]|0;if((Ka|0)!=(fa|0))UC(Ka);Ka=f[g>>2]|0;Fa=(f[s>>2]|0)-Ka|0;if((Fa|0)>0)Nac(Ka|0,0,Fa|0)|0;if((Qa|0)>0){La=+n[q>>2];Fa=f[g>>2]|0;Ka=0;do{Ea=LVb((+n[G+(Ka<<2)>>2]-+(f[p>>2]|0))/La*10.0)|0;Oa=(Ea|0)<(ga|0)?Ea:ga;Ea=Fa+(((Oa|0)>0?Oa:0)<<2)|0;f[Ea>>2]=(f[Ea>>2]|0)+1;Ka=Ka+1|0}while((Ka|0)!=(Qa|0))}Ka=b[o>>0]|0;d:do if(Ka<<24>>24!=0|Ca){Ra=Ka&255;Sa=0.0;Ta=0}else{Fa=f[g>>2]|0;La=0.0;Ea=0;Oa=r;while(1){Ua=Oa+-1|0;Ma=+(Ea|0);e:do if(!(La<1.1920928955078125e-07)){Va=Oa;Wa=Ua;while(1){Xa=f[Fa+(Wa<<2)>>2]|0;if(Xa){do if((Wa|0)>-1){Ya=Va+-10|0;Za=Wa+-1|0;if((Wa|0)>(Ya|0)&(Wa|0)!=0){_a=Za;$a=Xa}else{ab=Xa;bb=Za;break}while(1){Za=(f[Fa+(_a<<2)>>2]|0)+$a|0;cb=_a+-1|0;if((_a|0)>(Ya|0)&(_a|0)>0){_a=cb;$a=Za}else{ab=Za;bb=cb;break}}}else{ab=0;bb=Wa}while(0);Ia=+(bb+Wa|0)*.5/10.0*+n[q>>2]+ +(f[p>>2]|0);if(!(La*+(ab|0)>=Ma*Ia))db=bb;else{eb=ab;fb=bb;gb=Ia;break e}}else db=Wa;if((db|0)>1){Va=db;Wa=db+-1|0}else{Ra=0;Sa=La;Ta=Ea;break d}}}else{Wa=Oa;Va=Ua;while(1){Xa=f[Fa+(Va<<2)>>2]|0;if(Xa){do if((Va|0)>-1){Ya=Wa+-10|0;cb=Va+-1|0;if((Va|0)>(Ya|0)&(Va|0)!=0){hb=cb;ib=Xa}else{jb=Xa;kb=cb;break}while(1){cb=(f[Fa+(hb<<2)>>2]|0)+ib|0;Za=hb+-1|0;if((hb|0)>(Ya|0)&(hb|0)>0){hb=Za;ib=cb}else{jb=cb;kb=Za;break}}}else{jb=0;kb=Va}while(0);Ia=+(kb+Va|0)*.5/10.0*+n[q>>2]+ +(f[p>>2]|0);if((jb|0)<(Ea|0)?!(La*+(jb|0)>=Ma*Ia):0)lb=kb;else{eb=jb;fb=kb;gb=Ia;break e}}else lb=Va;if((lb|0)>1){Wa=lb;Va=lb+-1|0}else{Ra=0;Sa=La;Ta=Ea;break d}}}while(0);if((fb|0)>1){La=gb;Ea=eb;Oa=fb}else{Ra=0;Sa=gb;Ta=eb;break}}}while(0);Ka=f[ha>>2]|0;do if(Ka|0){Oa=Ka+12|0;Ea=f[Oa>>2]|0;f[Oa>>2]=Ea+-1;if((Ea|0)!=1)break;kL(j)}while(0);f[ha>>2]=0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[ja>>2]|0)>0){Ka=f[ka>>2]|0;Ea=0;do{f[Ka+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[ja>>2]|0))}Ea=f[la>>2]|0;if((Ea|0)!=(ma|0))UC(Ea);if(!Ra){mb=Sa;nb=Ta}else break a}else{mb=0.0;nb=0}}else{mb=0.0;nb=0}if(L){if((nb|0)>(f[na>>2]|0)){Ea=f[N>>2]|0;n[e>>2]=Ja;n[oa>>2]=Ha;n[pa>>2]=mb;Ka=Ea+4|0;Oa=f[Ka>>2]|0;if((Oa|0)==(f[Ea+8>>2]|0))e2(Ea,e);else{n[Oa>>2]=Ja;f[Oa+4>>2]=f[oa>>2];f[Oa+8>>2]=f[pa>>2];f[Ka>>2]=Oa+12}Oa=f[N>>2]|0;if((((f[Oa+4>>2]|0)-(f[Oa>>2]|0)|0)/12|0)>>>0>=(f[qa>>2]|0)>>>0)break a}}else{PO(f[ra>>2]|0);if(b[o>>0]|0){ob=69;break}Oa=(f[sa>>2]|0)+(Da>>>5<<2)|0;f[Oa>>2]=f[Oa>>2]|1<<(Da&31);f:do if((nb|0)>(f[na>>2]|0)){Oa=(f[ta>>2]|0)+1|0;Ka=f[sa>>2]|0;if(1<<(Oa&31)&f[Ka+(Oa>>>5<<2)>>2]|0)do{f[ta>>2]=(f[ta>>2]|0)+1;Oa=(f[ta>>2]|0)+1|0}while((1<<(Oa&31)&f[Ka+(Oa>>>5<<2)>>2]|0)!=0);n[e>>2]=Ja;n[va>>2]=Ha;n[wa>>2]=mb;f[xa>>2]=Da;f[ya>>2]=Ga;Ka=f[za>>2]|0;if((Ka|0)==(f[Aa>>2]|0))j2(ua,e);else{n[Ka>>2]=Ja;f[Ka+4>>2]=f[va>>2];f[Ka+8>>2]=f[wa>>2];Oa=xa;Ea=f[Oa+4>>2]|0;Fa=Ka+12|0;f[Fa>>2]=f[Oa>>2];f[Fa+4>>2]=Ea;f[za>>2]=(f[za>>2]|0)+20}if(((Da|0)<=(f[ta>>2]|0)?(Ea=f[ua>>2]|0,Fa=f[za>>2]|0,f[e>>2]=556,l2(Ea,Fa,e),Fa=f[za>>2]|0,Ea=f[ua>>2]|0,Oa=Fa-Ea|0,(Oa|0)>0):0)?(Ka=Ea,Ea=(Oa>>>0)/20|0,Oa=Ea+-1|0,(f[Ka+(Oa*20|0)+12>>2]|0)<=(f[ta>>2]|0)):0){Ua=Ea;Ea=Oa;Oa=Ka;Ka=Fa;while(1){La=+n[Oa+(Ea*20|0)>>2];Ma=+n[Oa+(Ea*20|0)+4>>2];Fa=f[Oa+(Ea*20|0)+16>>2]|0;Va=f[N>>2]|0;Wa=Va+4|0;Xa=f[Wa>>2]|0;Ya=f[Va>>2]|0;Za=(Xa-Ya|0)/12|0;cb=Ya;Ya=Xa;g:do if((Fa|0)<(Za|0)){Ia=+n[O>>2];pb=Fa;while(1){qb=+n[cb+(pb*12|0)>>2]-La;rb=+n[cb+(pb*12|0)+4>>2]-Ma;pb=pb+1|0;if(qb*qb+rb*rb<Ia){sb=Ka;break g}if((pb|0)>=(Za|0)){ob=84;break}}}else ob=84;while(0);if((ob|0)==84){ob=0;Za=Oa+(Ea*20|0)|0;if((Ya|0)==(f[Va+8>>2]|0))e2(Va,Za);else{f[Xa>>2]=f[Za>>2];f[Ya+4>>2]=f[Oa+(Ea*20|0)+4>>2];f[Ya+8>>2]=f[Oa+(Ea*20|0)+8>>2];f[Wa>>2]=Ya+12}Za=f[N>>2]|0;if((((f[Za+4>>2]|0)-(f[Za>>2]|0)|0)/12|0)>>>0>=(f[qa>>2]|0)>>>0){ob=89;break b}sb=f[za>>2]|0}Ka=sb+-20|0;f[za>>2]=Ka;if((Ua|0)<=1)break f;Oa=f[ua>>2]|0;Za=Ea+-1|0;if((f[Oa+(Za*20|0)+12>>2]|0)>(f[ta>>2]|0))break;else{cb=Ea;Ea=Za;Ua=cb}}}}while(0);h:do if(b[Ba>>0]|0?(Ga=f[ua>>2]|0,Ua=f[za>>2]|0,(Ga|0)!=(Ua|0)):0){Ea=(f[ta>>2]|0)+1|0;Oa=f[sa>>2]|0;Ka=f[ta>>2]|0;if(!(1<<(Ea&31)&f[Oa+(Ea>>>5<<2)>>2]))tb=Ka;else{Ea=Ka;while(1){f[ta>>2]=Ea+1;Ka=(f[ta>>2]|0)+1|0;cb=f[ta>>2]|0;if(!(1<<(Ka&31)&f[Oa+(Ka>>>5<<2)>>2])){tb=cb;break}else Ea=cb}}if((tb|0)==((f[H>>2]|0)+-1|0)?(f[e>>2]=556,l2(Ga,Ua,e),Ea=f[ua>>2]|0,Oa=(f[za>>2]|0)-Ea|0,(Oa|0)>0):0){cb=(Oa>>>0)/20|0;Oa=Ea;Ea=f[N>>2]|0;while(1){Ka=cb+-1|0;Ja=+n[Oa+(Ka*20|0)>>2];Ha=+n[Oa+(Ka*20|0)+4>>2];Za=f[Oa+(Ka*20|0)+16>>2]|0;Fa=Ea+4|0;pb=f[Fa>>2]|0;ub=f[Ea>>2]|0;vb=(pb-ub|0)/12|0;wb=ub;ub=pb;i:do if((Za|0)<(vb|0)){Ma=+n[O>>2];xb=Za;while(1){La=+n[wb+(xb*12|0)>>2]-Ja;Ia=+n[wb+(xb*12|0)+4>>2]-Ha;xb=xb+1|0;if(La*La+Ia*Ia<Ma){yb=Ea;break i}if((xb|0)>=(vb|0)){ob=103;break}}}else ob=103;while(0);if((ob|0)==103){ob=0;vb=Oa+(Ka*20|0)|0;if((ub|0)==(f[Ea+8>>2]|0))e2(Ea,vb);else{f[pb>>2]=f[vb>>2];f[ub+4>>2]=f[Oa+(Ka*20|0)+4>>2];f[ub+8>>2]=f[Oa+(Ka*20|0)+8>>2];f[Fa>>2]=ub+12}vb=f[N>>2]|0;if((((f[vb+4>>2]|0)-(f[vb>>2]|0)|0)/12|0)>>>0<(f[qa>>2]|0)>>>0)yb=vb;else{ob=109;break b}}if((cb|0)<=1)break h;cb=Ka;Oa=f[ua>>2]|0;Ea=yb}}}while(0);QO(f[ra>>2]|0)}Da=Da+1|0;if((Da|0)>=(f[J>>2]|0))break a}if((ob|0)==69){QO(f[ra>>2]|0);break}else if((ob|0)==89){b[o>>0]=1;QO(f[ra>>2]|0);break}else if((ob|0)==109){b[o>>0]=1;QO(f[ra>>2]|0);break}}while(0);o=i+36|0;ob=f[o>>2]|0;if(ob|0?(J=ob+12|0,ob=f[J>>2]|0,f[J>>2]=ob+-1,(ob|0)==1):0)kL(i);f[o>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[D>>2]|0)>0){A=f[F>>2]|0;F=0;do{f[A+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[D>>2]|0))}D=f[z>>2]|0;if((D|0)!=(E|0))UC(D);D=h+36|0;E=f[D>>2]|0;if(E|0?(z=E+12|0,E=f[z>>2]|0,f[z>>2]=E+-1,(E|0)==1):0)kL(h);f[D>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[v>>2]|0)>0){t=f[y>>2]|0;y=0;do{f[t+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[v>>2]|0))}v=f[B>>2]|0;if((v|0)!=(x|0))UC(v);v=f[g>>2]|0;if(v|0){g=f[s>>2]|0;if((g|0)!=(v|0))f[s>>2]=g+(~((g+-4-v|0)>>>2)<<2);O5b(v)}u=d;return}function j2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/20|0;h=g+1|0;i=e;j=d;if(h>>>0>214748364)c4b(a);k=a+8|0;l=((f[k>>2]|0)-e|0)/20|0;e=l<<1;m=l>>>0<107374182?(e>>>0<h>>>0?h:e):214748364;do if(m)if(m>>>0>214748364){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{n=L5b(m*20|0)|0;break}else n=0;while(0);e=n+(g*20|0)|0;h=e;l=n+(m*20|0)|0;f[e>>2]=f[b>>2];f[n+(g*20|0)+4>>2]=f[b+4>>2];f[n+(g*20|0)+8>>2]=f[b+8>>2];m=b+12|0;b=f[m+4>>2]|0;o=n+(g*20|0)+12|0;f[o>>2]=f[m>>2];f[o+4>>2]=b;b=e+20|0;if((j|0)==(i|0)){p=h;q=d}else{d=j;j=h;h=e;do{e=d;d=d+-20|0;f[h+-20>>2]=f[d>>2];f[h+-16>>2]=f[e+-16>>2];f[h+-12>>2]=f[e+-12>>2];o=e+-8|0;e=f[o+4>>2]|0;m=h+-8|0;f[m>>2]=f[o>>2];f[m+4>>2]=e;h=j+-20|0;j=h}while((d|0)!=(i|0));p=j;q=f[a>>2]|0}f[a>>2]=p;f[c>>2]=b;f[k>>2]=l;if(!q)return;O5b(q);return}function k2(a,b){a=a|0;b=b|0;return (f[a+12>>2]|0)>(f[b+12>>2]|0)|0}function l2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=u;u=u+32|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-20|0;i=a+-16|0;j=a+-12|0;k=a+-8|0;l=g;while(1){m=l;b:while(1){n=m;o=b-n|0;switch((o|0)/20|0|0){case 2:{p=5;break a;break}case 3:{p=7;break a;break}case 4:{p=8;break a;break}case 5:{p=12;break a;break}case 1:case 0:{p=56;break a;break}default:{}}if((o|0)<140){p=14;break a}q=m+(((o>>>0)/40|0)*20|0)|0;if((o|0)>19980){r=(o>>>0)/80|0;s=n2(m,m+(r*20|0)|0,q,q+(r*20|0)|0,h,c)|0}else s=m2(m,q,h,c)|0;if(Uh[f[c>>2]&1023](m,q)|0){t=h;v=s;break}else w=h;while(1){x=w+-20|0;if((m|0)==(x|0))break;if(Uh[f[c>>2]&1023](x,q)|0){p=39;break b}else w=x}r=m+20|0;if(Uh[f[c>>2]&1023](m,h)|0)y=r;else{if((r|0)==(h|0)){p=56;break a}else z=r;while(1){if(Uh[f[c>>2]&1023](m,z)|0)break;r=z+20|0;if((r|0)==(h|0)){p=56;break a}else z=r}r=f[z>>2]|0;o=f[z+4>>2]|0;A=f[z+8>>2]|0;B=z+12|0;C=f[B>>2]|0;D=f[B+4>>2]|0;f[z>>2]=f[h>>2];f[z+4>>2]=f[h+4>>2];f[z+8>>2]=f[h+8>>2];f[z+12>>2]=f[h+12>>2];f[z+16>>2]=f[h+16>>2];f[h>>2]=r;f[i>>2]=o;f[j>>2]=A;A=k;f[A>>2]=C;f[A+4>>2]=D;y=z+20|0}if((y|0)==(h|0)){p=56;break a}else{E=h;F=y}while(1){D=F;while(1){G=D+20|0;if(Uh[f[c>>2]&1023](m,D)|0){H=E;break}else D=G}while(1){I=H+-20|0;if(Uh[f[c>>2]&1023](m,I)|0)H=I;else break}if(D>>>0>=I>>>0){m=D;continue b}A=f[D>>2]|0;C=f[D+4>>2]|0;o=f[D+8>>2]|0;r=D+12|0;B=f[r>>2]|0;J=f[r+4>>2]|0;f[D>>2]=f[I>>2];f[D+4>>2]=f[I+4>>2];f[D+8>>2]=f[I+8>>2];f[D+12>>2]=f[I+12>>2];f[D+16>>2]=f[I+16>>2];f[I>>2]=A;f[H+-16>>2]=C;f[H+-12>>2]=o;o=H+-8|0;f[o>>2]=B;f[o+4>>2]=J;E=I;F=G}}if((p|0)==39){p=0;J=f[m>>2]|0;o=f[m+4>>2]|0;B=f[m+8>>2]|0;C=m+12|0;A=f[C>>2]|0;r=f[C+4>>2]|0;f[m>>2]=f[x>>2];f[m+4>>2]=f[x+4>>2];f[m+8>>2]=f[x+8>>2];f[m+12>>2]=f[x+12>>2];f[m+16>>2]=f[x+16>>2];f[x>>2]=J;f[w+-16>>2]=o;f[w+-12>>2]=B;B=w+-8|0;f[B>>2]=A;f[B+4>>2]=r;t=x;v=s+1|0}r=m+20|0;c:do if(r>>>0<t>>>0){B=q;A=t;o=r;J=v;while(1){C=o;while(1){K=C+20|0;if(Uh[f[c>>2]&1023](C,B)|0)C=K;else{L=A;break}}while(1){M=L+-20|0;if(Uh[f[c>>2]&1023](M,B)|0)break;else L=M}if(C>>>0>M>>>0){N=B;O=J;P=C;break c}D=f[C>>2]|0;Q=f[C+4>>2]|0;R=f[C+8>>2]|0;S=C+12|0;T=f[S>>2]|0;U=f[S+4>>2]|0;f[C>>2]=f[M>>2];f[C+4>>2]=f[M+4>>2];f[C+8>>2]=f[M+8>>2];f[C+12>>2]=f[M+12>>2];f[C+16>>2]=f[M+16>>2];f[M>>2]=D;f[L+-16>>2]=Q;f[L+-12>>2]=R;R=L+-8|0;f[R>>2]=T;f[R+4>>2]=U;B=(B|0)==(C|0)?M:B;A=M;o=K;J=J+1|0}}else{N=q;O=v;P=r}while(0);if((P|0)!=(N|0)?Uh[f[c>>2]&1023](N,P)|0:0){r=f[P>>2]|0;J=f[P+4>>2]|0;o=f[P+8>>2]|0;A=P+12|0;B=f[A>>2]|0;U=f[A+4>>2]|0;f[P>>2]=f[N>>2];f[P+4>>2]=f[N+4>>2];f[P+8>>2]=f[N+8>>2];f[P+12>>2]=f[N+12>>2];f[P+16>>2]=f[N+16>>2];f[N>>2]=r;f[N+4>>2]=J;f[N+8>>2]=o;o=N+12|0;f[o>>2]=B;f[o+4>>2]=U;V=O+1|0}else V=O;if(!V){W=o2(m,P,c)|0;U=P+20|0;if(o2(U,a,c)|0){p=55;break}if(W){l=U;continue}}U=P;if((U-n|0)>=(b-U|0)){p=54;break}l2(m,P,c);l=P+20|0}if((p|0)==54){p=0;l2(P+20|0,a,c);g=m;a=P;continue}else if((p|0)==55){p=0;if(W){p=56;break}else{g=m;a=P;continue}}}if((p|0)==5){if(!(Uh[f[c>>2]&1023](h,m)|0)){u=d;return}P=f[m>>2]|0;g=f[m+4>>2]|0;W=f[m+8>>2]|0;n=m+12|0;V=f[n>>2]|0;O=f[n+4>>2]|0;f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[m+8>>2]=f[h+8>>2];f[m+12>>2]=f[h+12>>2];f[m+16>>2]=f[h+16>>2];f[h>>2]=P;f[i>>2]=g;f[j>>2]=W;W=k;f[W>>2]=V;f[W+4>>2]=O;u=d;return}else if((p|0)==7){m2(m,m+20|0,h,c)|0;u=d;return}else if((p|0)==8){O=m+20|0;W=m+40|0;m2(m,O,W,c)|0;if(!(Uh[f[c>>2]&1023](h,W)|0)){u=d;return}V=f[W>>2]|0;g=m+44|0;P=f[g>>2]|0;n=m+48|0;N=f[n>>2]|0;v=m+52|0;q=v;K=f[q>>2]|0;M=f[q+4>>2]|0;f[W>>2]=f[h>>2];f[W+4>>2]=f[h+4>>2];f[W+8>>2]=f[h+8>>2];f[W+12>>2]=f[h+12>>2];f[W+16>>2]=f[h+16>>2];f[h>>2]=V;f[i>>2]=P;f[j>>2]=N;N=k;f[N>>2]=K;f[N+4>>2]=M;if(!(Uh[f[c>>2]&1023](W,O)|0)){u=d;return}M=f[O>>2]|0;N=m+24|0;K=f[N>>2]|0;k=m+28|0;j=f[k>>2]|0;P=m+32|0;i=P;V=f[i>>2]|0;q=f[i+4>>2]|0;f[O>>2]=f[W>>2];f[O+4>>2]=f[W+4>>2];f[O+8>>2]=f[W+8>>2];f[O+12>>2]=f[W+12>>2];f[O+16>>2]=f[W+16>>2];f[W>>2]=M;f[g>>2]=K;f[n>>2]=j;j=v;f[j>>2]=V;f[j+4>>2]=q;if(!(Uh[f[c>>2]&1023](O,m)|0)){u=d;return}q=f[m>>2]|0;j=f[m+4>>2]|0;V=f[m+8>>2]|0;v=m+12|0;n=f[v>>2]|0;K=f[v+4>>2]|0;f[m>>2]=f[O>>2];f[m+4>>2]=f[O+4>>2];f[m+8>>2]=f[O+8>>2];f[m+12>>2]=f[O+12>>2];f[m+16>>2]=f[O+16>>2];f[O>>2]=q;f[N>>2]=j;f[k>>2]=V;V=P;f[V>>2]=n;f[V+4>>2]=K;u=d;return}else if((p|0)==12){n2(m,m+20|0,m+40|0,m+60|0,h,c)|0;u=d;return}else if((p|0)==14){h=m+40|0;m2(m,m+20|0,h,c)|0;K=m+60|0;if((K|0)==(a|0)){u=d;return}V=e+4|0;n=e+8|0;P=e+12|0;k=K;K=h;while(1){if(Uh[f[c>>2]&1023](k,K)|0){f[e>>2]=f[k>>2];f[V>>2]=f[k+4>>2];f[n>>2]=f[k+8>>2];h=k+12|0;j=f[h+4>>2]|0;N=P;f[N>>2]=f[h>>2];f[N+4>>2]=j;j=K;N=k;while(1){f[N>>2]=f[j>>2];f[N+4>>2]=f[j+4>>2];f[N+8>>2]=f[j+8>>2];f[N+12>>2]=f[j+12>>2];f[N+16>>2]=f[j+16>>2];if((j|0)==(m|0))break;h=j+-20|0;if(Uh[f[c>>2]&1023](e,h)|0){q=j;j=h;N=q}else break}f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];f[j+16>>2]=f[e+16>>2]}N=k+20|0;if((N|0)==(a|0))break;else{q=k;k=N;K=q}}u=d;return}else if((p|0)==56){u=d;return}}function m2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=Uh[f[d>>2]&1023](b,a)|0;g=Uh[f[d>>2]&1023](c,b)|0;if(!e){if(!g){h=0;return h|0}e=f[b>>2]|0;i=b+4|0;j=f[i>>2]|0;k=b+8|0;l=f[k>>2]|0;m=b+12|0;n=m;o=f[n>>2]|0;p=f[n+4>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[c>>2]=e;f[c+4>>2]=j;f[c+8>>2]=l;l=c+12|0;f[l>>2]=o;f[l+4>>2]=p;if(!(Uh[f[d>>2]&1023](b,a)|0)){h=1;return h|0}p=f[a>>2]|0;l=f[a+4>>2]|0;o=f[a+8>>2]|0;j=a+12|0;e=f[j>>2]|0;n=f[j+4>>2]|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[b>>2]=p;f[i>>2]=l;f[k>>2]=o;o=m;f[o>>2]=e;f[o+4>>2]=n;h=2;return h|0}n=f[a>>2]|0;o=f[a+4>>2]|0;e=f[a+8>>2]|0;m=a+12|0;k=f[m>>2]|0;l=f[m+4>>2]|0;if(g){f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[c>>2]=n;f[c+4>>2]=o;f[c+8>>2]=e;g=c+12|0;f[g>>2]=k;f[g+4>>2]=l;h=1;return h|0};f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[b>>2]=n;n=b+4|0;f[n>>2]=o;o=b+8|0;f[o>>2]=e;e=b+12|0;a=e;f[a>>2]=k;f[a+4>>2]=l;if(!(Uh[f[d>>2]&1023](c,b)|0)){h=1;return h|0}d=f[b>>2]|0;l=f[n>>2]|0;n=f[o>>2]|0;o=e;e=f[o>>2]|0;a=f[o+4>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[c>>2]=d;f[c+4>>2]=l;f[c+8>>2]=n;n=c+12|0;f[n>>2]=e;f[n+4>>2]=a;h=2;return h|0}function n2(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=m2(a,b,c,g)|0;if(Uh[f[g>>2]&1023](d,c)|0){i=f[c>>2]|0;j=c+4|0;k=f[j>>2]|0;l=c+8|0;m=f[l>>2]|0;n=c+12|0;o=n;p=f[o>>2]|0;q=f[o+4>>2]|0;f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[c+16>>2]=f[d+16>>2];f[d>>2]=i;f[d+4>>2]=k;f[d+8>>2]=m;m=d+12|0;f[m>>2]=p;f[m+4>>2]=q;q=h+1|0;if(Uh[f[g>>2]&1023](c,b)|0){m=f[b>>2]|0;p=b+4|0;k=f[p>>2]|0;i=b+8|0;o=f[i>>2]|0;r=b+12|0;s=r;t=f[s>>2]|0;u=f[s+4>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[c>>2]=m;f[j>>2]=k;f[l>>2]=o;o=n;f[o>>2]=t;f[o+4>>2]=u;if(Uh[f[g>>2]&1023](b,a)|0){u=f[a>>2]|0;o=f[a+4>>2]|0;t=f[a+8>>2]|0;n=a+12|0;l=f[n>>2]|0;k=f[n+4>>2]|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[b>>2]=u;f[p>>2]=o;f[i>>2]=t;t=r;f[t>>2]=l;f[t+4>>2]=k;v=h+3|0}else v=h+2|0}else v=q}else v=h;if(!(Uh[f[g>>2]&1023](e,d)|0)){w=v;return w|0}h=f[d>>2]|0;q=d+4|0;k=f[q>>2]|0;t=d+8|0;l=f[t>>2]|0;r=d+12|0;i=r;o=f[i>>2]|0;p=f[i+4>>2]|0;f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];f[d+12>>2]=f[e+12>>2];f[d+16>>2]=f[e+16>>2];f[e>>2]=h;f[e+4>>2]=k;f[e+8>>2]=l;l=e+12|0;f[l>>2]=o;f[l+4>>2]=p;if(!(Uh[f[g>>2]&1023](d,c)|0)){w=v+1|0;return w|0}p=f[c>>2]|0;l=c+4|0;o=f[l>>2]|0;e=c+8|0;k=f[e>>2]|0;h=c+12|0;i=h;u=f[i>>2]|0;n=f[i+4>>2]|0;f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[c+16>>2]=f[d+16>>2];f[d>>2]=p;f[q>>2]=o;f[t>>2]=k;k=r;f[k>>2]=u;f[k+4>>2]=n;if(!(Uh[f[g>>2]&1023](c,b)|0)){w=v+2|0;return w|0}n=f[b>>2]|0;k=b+4|0;u=f[k>>2]|0;r=b+8|0;t=f[r>>2]|0;o=b+12|0;q=o;p=f[q>>2]|0;d=f[q+4>>2]|0;f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[c>>2]=n;f[l>>2]=u;f[e>>2]=t;t=h;f[t>>2]=p;f[t+4>>2]=d;if(!(Uh[f[g>>2]&1023](b,a)|0)){w=v+3|0;return w|0}g=f[a>>2]|0;d=f[a+4>>2]|0;t=f[a+8>>2]|0;p=a+12|0;h=f[p>>2]|0;e=f[p+4>>2]|0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[b>>2]=g;f[k>>2]=d;f[r>>2]=t;t=o;f[t>>2]=h;f[t+4>>2]=e;w=v+4|0;return w|0}function o2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+32|0;e=d;switch((b-a|0)/20|0|0){case 2:{g=b+-20|0;if(!(Uh[f[c>>2]&1023](g,a)|0)){h=1;u=d;return h|0}i=f[a>>2]|0;j=f[a+4>>2]|0;k=f[a+8>>2]|0;l=a+12|0;m=f[l>>2]|0;n=f[l+4>>2]|0;f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[a+16>>2]=f[g+16>>2];f[g>>2]=i;f[b+-16>>2]=j;f[b+-12>>2]=k;k=b+-8|0;f[k>>2]=m;f[k+4>>2]=n;h=1;u=d;return h|0}case 3:{m2(a,a+20|0,b+-20|0,c)|0;h=1;u=d;return h|0}case 4:{n=a+20|0;k=a+40|0;m=b+-20|0;m2(a,n,k,c)|0;if(!(Uh[f[c>>2]&1023](m,k)|0)){h=1;u=d;return h|0}j=f[k>>2]|0;i=a+44|0;g=f[i>>2]|0;l=a+48|0;o=f[l>>2]|0;p=a+52|0;q=p;r=f[q>>2]|0;s=f[q+4>>2]|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];f[k+12>>2]=f[m+12>>2];f[k+16>>2]=f[m+16>>2];f[m>>2]=j;f[b+-16>>2]=g;f[b+-12>>2]=o;o=b+-8|0;f[o>>2]=r;f[o+4>>2]=s;if(!(Uh[f[c>>2]&1023](k,n)|0)){h=1;u=d;return h|0}s=f[n>>2]|0;o=a+24|0;r=f[o>>2]|0;g=a+28|0;j=f[g>>2]|0;m=a+32|0;q=m;t=f[q>>2]|0;v=f[q+4>>2]|0;f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];f[n+8>>2]=f[k+8>>2];f[n+12>>2]=f[k+12>>2];f[n+16>>2]=f[k+16>>2];f[k>>2]=s;f[i>>2]=r;f[l>>2]=j;j=p;f[j>>2]=t;f[j+4>>2]=v;if(!(Uh[f[c>>2]&1023](n,a)|0)){h=1;u=d;return h|0}v=f[a>>2]|0;j=f[a+4>>2]|0;t=f[a+8>>2]|0;p=a+12|0;l=f[p>>2]|0;r=f[p+4>>2]|0;f[a>>2]=f[n>>2];f[a+4>>2]=f[n+4>>2];f[a+8>>2]=f[n+8>>2];f[a+12>>2]=f[n+12>>2];f[a+16>>2]=f[n+16>>2];f[n>>2]=v;f[o>>2]=j;f[g>>2]=t;t=m;f[t>>2]=l;f[t+4>>2]=r;h=1;u=d;return h|0}case 5:{n2(a,a+20|0,a+40|0,a+60|0,b+-20|0,c)|0;h=1;u=d;return h|0}case 1:case 0:{h=1;u=d;return h|0}default:{r=a+40|0;m2(a,a+20|0,r,c)|0;t=a+60|0;a:do if((t|0)==(b|0)){w=1;x=0}else{l=e+4|0;m=e+8|0;g=e+12|0;j=t;o=0;v=r;while(1){if(Uh[f[c>>2]&1023](j,v)|0){f[e>>2]=f[j>>2];f[l>>2]=f[j+4>>2];f[m>>2]=f[j+8>>2];n=j+12|0;p=f[n+4>>2]|0;i=g;f[i>>2]=f[n>>2];f[i+4>>2]=p;p=v;i=j;while(1){f[i>>2]=f[p>>2];f[i+4>>2]=f[p+4>>2];f[i+8>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];f[i+16>>2]=f[p+16>>2];if((p|0)==(a|0))break;n=p+-20|0;if(Uh[f[c>>2]&1023](e,n)|0){s=p;p=n;i=s}else break}f[p>>2]=f[e>>2];f[p+4>>2]=f[e+4>>2];f[p+8>>2]=f[e+8>>2];f[p+12>>2]=f[e+12>>2];f[p+16>>2]=f[e+16>>2];i=o+1|0;if((i|0)==8){w=0;x=(j+20|0)==(b|0);break a}else y=i}else y=o;i=j+20|0;if((i|0)==(b|0)){w=1;x=0;break}else{s=j;j=i;o=y;v=s}}}while(0);h=x|w;u=d;return h|0}}return 0}function p2(a){a=a|0;O5b(a);return}function q2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=u;u=u+48|0;d=c+32|0;e=c+28|0;g=c+24|0;h=c+12|0;i=c+8|0;j=c+4|0;k=c;l=f[b>>2]|0;m=f[b+4>>2]|0;f[h>>2]=0;b=h+4|0;f[b>>2]=0;f[h+8>>2]=0;n=(l|0)==1?(m|0)==((f[(f[a+4>>2]|0)+8>>2]|0)+-1|0):0;o=(l|0)>1?l:1;l=(f[a+20>>2]|0)+-1|0;p=(m|0)<(l|0)?m:l;do if((o|0)<(p|0)){l=a+16|0;m=a+24|0;q=a+12|0;r=h+8|0;s=o;t=f[l>>2]|0;while(1){v=Y(t,s)|0;w=v+1|0;f[d>>2]=w;if((t+-1|0)>1){x=1;y=t;z=v;v=w;while(1){w=f[m>>2]|0;A=f[w+(v<<2)>>2]|0;do if(((((A|0)>(f[q>>2]|0)?(A|0)>(f[w+(z<<2)>>2]|0):0)?(A|0)>=(f[w+(z+2<<2)>>2]|0):0)?(A|0)>(f[w+(v-y<<2)>>2]|0):0)?(A|0)>=(f[w+(y+v<<2)>>2]|0):0){B=f[b>>2]|0;if((B|0)==(f[r>>2]|0)){IO(h,d);break}else{f[B>>2]=v;f[b>>2]=B+4;break}}while(0);x=x+1|0;z=f[d>>2]|0;v=z+1|0;f[d>>2]=v;w=f[l>>2]|0;if((x|0)>=(w+-1|0)){C=w;break}else y=w}}else C=t;s=s+1|0;if((s|0)>=(p|0))break;else t=C}t=f[h>>2]|0;s=f[b>>2]|0;if((t|0)!=(s|0)){if(!n){l=f[a+28>>2]|0;PO(l);r=f[a+8>>2]|0;f[i>>2]=f[r+4>>2];f[j>>2]=f[h>>2];f[k>>2]=f[b>>2];f[g>>2]=f[i>>2];f[e>>2]=f[j>>2];f[d>>2]=f[k>>2];s2(r,g,e,d)|0;QO(l);D=19;break}l=f[a+8>>2]|0;if((l|0)==(h|0))D=19;else{r2(l,t,s);D=19}}else E=t}else D=19;while(0);if((D|0)==19)E=f[h>>2]|0;if(!E){u=c;return}h=f[b>>2]|0;if((h|0)!=(E|0))f[b>>2]=h+(~((h+-4-E|0)>>>2)<<2);O5b(E);u=c;return}function r2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=c;e=b;g=d-e|0;h=g>>2;i=a+8|0;j=f[i>>2]|0;k=f[a>>2]|0;l=k;if(h>>>0<=j-k>>2>>>0){m=a+4|0;n=(f[m>>2]|0)-k>>2;o=h>>>0>n>>>0;p=o?b+(n<<2)|0:c;c=p;n=c-e|0;e=n>>2;if(e|0)Xac(k|0,b|0,n|0)|0;n=l+(e<<2)|0;if(o){o=d-c|0;if((o|0)<=0)return;Vac(f[m>>2]|0,p|0,o|0)|0;f[m>>2]=(f[m>>2]|0)+(o>>>2<<2);return}else{o=f[m>>2]|0;if((o|0)==(n|0))return;f[m>>2]=o+(~((o+-4-n|0)>>>2)<<2);return}}n=k;if(!k)q=j;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(l|0))f[j>>2]=o+(~((o+-4-k|0)>>>2)<<2);O5b(n);f[i>>2]=0;f[j>>2]=0;f[a>>2]=0;q=0}if(h>>>0>1073741823)c4b(a);j=q>>1;n=q>>2>>>0<536870911?(j>>>0<h>>>0?h:j):1073741823;if(n>>>0>1073741823)c4b(a);j=L5b(n<<2)|0;h=a+4|0;f[h>>2]=j;f[a>>2]=j;f[i>>2]=j+(n<<2);if((g|0)<=0)return;Vac(j|0,b|0,g|0)|0;f[h>>2]=j+(g>>>2<<2);return}function s2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=e+(h>>2<<2)|0;i=f[c>>2]|0;j=f[d>>2]|0;d=j-i|0;k=d>>2;l=j;if((d|0)<=0){m=b;return m|0}d=a+8|0;n=f[d>>2]|0;o=a+4|0;p=f[o>>2]|0;q=p;if((k|0)<=(n-q>>2|0)){r=b;s=q-r|0;t=s>>2;if((k|0)>(t|0)){u=i+(t<<2)|0;t=u;if((u|0)==(l|0))v=p;else{w=l+-4-t|0;x=u;u=p;while(1){f[u>>2]=f[x>>2];x=x+4|0;if((x|0)==(l|0))break;else u=u+4|0}u=p+((w>>>2)+1<<2)|0;f[o>>2]=u;v=u}if((s|0)>0){y=t;z=v}else{m=b;return m|0}}else{y=j;z=p}j=z-(b+(k<<2))|0;v=j>>2;t=b+(v<<2)|0;if(t>>>0<p>>>0){s=(p+(0-v<<2)+~r|0)>>>2;r=t;t=z;while(1){f[t>>2]=f[r>>2];r=r+4|0;if(r>>>0>=p>>>0)break;else t=t+4|0}f[o>>2]=z+(s+1<<2)}if(!v)A=i;else{Xac(z+(0-v<<2)|0,b|0,j|0)|0;A=f[c>>2]|0}c=y-A|0;if(!c){m=b;return m|0}Xac(b|0,A|0,c|0)|0;m=b;return m|0}c=(q-g>>2)+k|0;if(c>>>0>1073741823)c4b(a);k=n-g|0;g=k>>1;n=k>>2>>>0<536870911?(g>>>0<c>>>0?c:g):1073741823;g=b;c=h>>2;do if(n)if(n>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{B=L5b(n<<2)|0;break}else B=0;while(0);k=B+(c<<2)|0;A=B+(n<<2)|0;n=i;if((n|0)==(l|0))C=k;else{B=((l+-4-i|0)>>>2)+1|0;i=n;n=k;while(1){f[n>>2]=f[i>>2];i=i+4|0;if((i|0)==(l|0))break;else n=n+4|0}C=k+(B<<2)|0}B=k+(0-c<<2)|0;if((h|0)>0)Vac(B|0,e|0,h|0)|0;h=q-g|0;if((h|0)>0){Vac(C|0,b|0,h|0)|0;D=C+(h>>>2<<2)|0}else D=C;f[a>>2]=B;f[o>>2]=D;f[d>>2]=A;if(!e){m=k;return m|0}O5b(e);m=k;return m|0}function t2(a){a=a|0;O5b(a);return}function u2(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;e=u;u=u+128|0;g=e+120|0;h=e;i=e+112|0;j=e+56|0;k=e+36|0;l=e+52|0;m=e+48|0;o=e+32|0;p=a+40|0;q=(f[p>>2]|0)+2|0;r=a+36|0;s=(f[r>>2]|0)+2|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[j>>2]=1124007936;t=j+4|0;v=j+8|0;w=j+40|0;x=t;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[w>>2]=v;x=j+48|0;y=j+44|0;f[y>>2]=x;f[x>>2]=0;f[j+52>>2]=0;f[g>>2]=q;f[g+4>>2]=s;hL(j,2,g,4);UP(j,h)|0;s=j+16|0;q=f[s>>2]|0;f[k>>2]=0;z=k+4|0;f[z>>2]=0;f[k+8>>2]=0;A=k+8|0;B=L5b(2048)|0;C=B;f[k>>2]=C;f[z>>2]=C;f[A>>2]=B+2048;B=f[c>>2]|0;C=f[c+4>>2]|0;c=a+4|0;D=f[c>>2]|0;E=f[D+12>>2]|0;if((f[D>>2]&16384|0)!=0?(f[f[a+8>>2]>>2]&16384|0)!=0:0){F=(f[f[a+12>>2]>>2]&16384|0)!=0;G=Y(F?C-B|0:1,E)|0;H=F?B+1|0:C;I=G}else{H=C;I=E}a:do if((B|0)<(H|0)){E=a+8|0;C=a+12|0;G=(I|0)>0;F=g+4|0;J=a+24|0;K=a+16|0;L=a+20|0;N=a+44|0;O=B;P=D;while(1){Q=(f[P+16>>2]|0)+(Y(f[f[P+44>>2]>>2]|0,O)|0)|0;R=f[E>>2]|0;S=(f[R+16>>2]|0)+(Y(f[f[R+44>>2]>>2]|0,O)|0)|0;R=f[C>>2]|0;T=(f[R+16>>2]|0)+(Y(f[f[R+44>>2]>>2]|0,O)|0)|0;if(G){R=0;do{b:do if((R|0)<(I|0)){U=R;while(1){if(b[Q+U>>0]|0){V=U;break b}W=U+1|0;if((W|0)<(I|0))U=W;else{V=W;break}}}else V=R;while(0);if(((V|0)!=(I|0)?(U=d[S+(V<<1)>>1]|0,X=+(U<<16>>16),W=d[T+(V<<1)>>1]|0,Z=+(W<<16>>16),(W|U)<<16>>16):0)?(_=+M(+(X*X+Z*Z)),!(_<1.0)):0){U=f[(f[c>>2]|0)+12>>2]|0;W=(V|0)%(U|0)|0;$=((V|0)/(U|0)|0)+O|0;f[g>>2]=W;f[F>>2]=$;U=f[z>>2]|0;if((U|0)==(f[A>>2]|0))b2(k,g);else{f[U>>2]=W;f[U+4>>2]=$;f[z>>2]=U+8}aa=+n[J>>2];U=LVb(X*aa*1024.0/_)|0;$=LVb(Z*aa*1024.0/_)|0;W=LVb(aa*+(f[g>>2]|0)*1024.0)|0;ba=LVb(aa*+(f[F>>2]|0)*1024.0)|0;ca=f[K>>2]|0;da=f[L>>2]|0;if((ca|0)>(da|0)){ea=ca;fa=da}else{ga=ca;ha=(Y(ca,$)|0)+ba|0;ia=(Y(ca,U)|0)+W|0;ca=da;while(1){da=ia>>10;ja=ha>>10;if(da>>>0>=(f[r>>2]|0)>>>0){ka=ca;break}if(ja>>>0>=(f[p>>2]|0)>>>0){ka=ca;break}la=q+((Y(f[N>>2]|0,ja)|0)+da<<2)|0;f[la>>2]=(f[la>>2]|0)+1;la=f[L>>2]|0;if((ga|0)<(la|0)){ga=ga+1|0;ha=ha+$|0;ia=ia+U|0;ca=la}else{ka=la;break}}ea=f[K>>2]|0;fa=ka}c:do if((ea|0)<=(fa|0)){ca=ea;ia=(Y(ea,0-$|0)|0)+ba|0;ha=(Y(ea,0-U|0)|0)+W|0;while(1){ga=ha>>10;la=ia>>10;if(ga>>>0>=(f[r>>2]|0)>>>0)break c;if(la>>>0>=(f[p>>2]|0)>>>0)break c;da=q+((Y(f[N>>2]|0,la)|0)+ga<<2)|0;f[da>>2]=(f[da>>2]|0)+1;if((ca|0)<(f[L>>2]|0)){ca=ca+1|0;ia=ia-$|0;ha=ha-U|0}else break}}while(0)}R=V+1|0}while((R|0)<(I|0))}R=O+1|0;if((R|0)>=(H|0))break a;O=R;P=f[c>>2]|0}}while(0);c=f[a+48>>2]|0;PO(c);H=f[a+28>>2]|0;I=H+4|0;V=f[I>>2]|0;if((V|0)==(f[H+8>>2]|0))v2(H,j);else{f[V>>2]=f[j>>2];H=V+4|0;f[H>>2]=f[t>>2];q=V+8|0;f[q>>2]=f[v>>2];f[V+12>>2]=f[j+12>>2];f[V+16>>2]=f[s>>2];f[V+20>>2]=f[j+20>>2];f[V+24>>2]=f[j+24>>2];f[V+28>>2]=f[j+28>>2];f[V+32>>2]=f[j+32>>2];v=f[j+36>>2]|0;f[V+36>>2]=v;f[V+40>>2]=q;q=V+48|0;p=V+44|0;f[p>>2]=q;f[q>>2]=0;f[V+52>>2]=0;if(v|0){q=v+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[t>>2]|0)<3){q=f[y>>2]|0;v=f[p>>2]|0;f[v>>2]=f[q>>2];f[v+4>>2]=f[q+4>>2]}else{f[H>>2]=0;jL(V,j)}f[I>>2]=(f[I>>2]|0)+56}I=f[a+32>>2]|0;f[l>>2]=f[I+4>>2];f[m>>2]=f[k>>2];f[o>>2]=f[z>>2];f[i>>2]=f[l>>2];f[h>>2]=f[m>>2];f[g>>2]=f[o>>2];w2(I,i,h,g)|0;QO(c);c=f[k>>2]|0;if(c|0){k=f[z>>2]|0;if((k|0)!=(c|0))f[z>>2]=k+(~((k+-8-c|0)>>>3)<<3);O5b(c)}c=j+36|0;k=f[c>>2]|0;if(k|0?(z=k+12|0,k=f[z>>2]|0,f[z>>2]=k+-1,(k|0)==1):0)kL(j);f[c>>2]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[t>>2]|0)>0){s=f[w>>2]|0;w=0;do{f[s+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[t>>2]|0))}t=f[y>>2]|0;if((t|0)==(x|0)){u=e;return}UC(t);u=e;return}function v2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+32|0;d=c;e=f[a>>2]|0;g=((f[a+4>>2]|0)-e|0)/56|0;h=g+1|0;if(h>>>0>76695844)c4b(a);i=((f[a+8>>2]|0)-e|0)/56|0;e=i<<1;j=i>>>0<38347922?(e>>>0<h>>>0?h:e):76695844;f[d+12>>2]=0;f[d+16>>2]=a+8;do if(j)if(j>>>0>76695844){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{k=L5b(j*56|0)|0;break}else k=0;while(0);f[d>>2]=k;e=k+(g*56|0)|0;h=d+8|0;f[h>>2]=e;f[d+4>>2]=e;f[d+12>>2]=k+(j*56|0);f[e>>2]=f[b>>2];j=k+(g*56|0)+4|0;i=b+4|0;l=f[i>>2]|0;f[j>>2]=l;m=k+(g*56|0)+8|0;f[m>>2]=f[b+8>>2];f[k+(g*56|0)+12>>2]=f[b+12>>2];f[k+(g*56|0)+16>>2]=f[b+16>>2];f[k+(g*56|0)+20>>2]=f[b+20>>2];f[k+(g*56|0)+24>>2]=f[b+24>>2];f[k+(g*56|0)+28>>2]=f[b+28>>2];f[k+(g*56|0)+32>>2]=f[b+32>>2];n=f[b+36>>2]|0;f[k+(g*56|0)+36>>2]=n;f[k+(g*56|0)+40>>2]=m;m=k+(g*56|0)+48|0;o=k+(g*56|0)+44|0;f[o>>2]=m;f[m>>2]=0;f[k+(g*56|0)+52>>2]=0;if(!n)p=l;else{l=n+12|0;f[l>>2]=(f[l>>2]|0)+1;p=f[i>>2]|0}if((p|0)<3){p=f[b+44>>2]|0;i=f[o>>2]|0;f[i>>2]=f[p>>2];f[i+4>>2]=f[p+4>>2];q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;$s(a,d);at(d);u=c;return}else{f[j>>2]=0;jL(e,b);q=f[h>>2]|0;r=q+56|0;f[h>>2]=r;$s(a,d);at(d);u=c;return}}function w2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=h>>3;i=e+(b<<3)|0;j=f[c>>2]|0;c=f[d>>2]|0;d=c-j|0;k=d>>3;l=j;m=c;if((d|0)<=0){n=i;return n|0}d=a+8|0;o=f[d>>2]|0;p=a+4|0;q=f[p>>2]|0;r=q;if((k|0)<=(o-r>>3|0)){s=i;t=r-s|0;u=t>>3;if((k|0)>(u|0)){v=l+(u<<3)|0;u=v;if((v|0)==(m|0))w=q;else{x=m+-8-u|0;y=v;v=q;while(1){f[v>>2]=f[y>>2];f[v+4>>2]=f[y+4>>2];y=y+8|0;if((y|0)==(m|0))break;else v=v+8|0}v=q+((x>>>3)+1<<3)|0;f[p>>2]=v;w=v}if((t|0)>0){z=u;A=w}else{n=i;return n|0}}else{z=c;A=q}c=A-(i+(k<<3))>>3;w=i+(c<<3)|0;if(w>>>0<q>>>0){u=(q+(0-c<<3)+~s|0)>>>3;s=w;t=A;while(1){f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];s=s+8|0;if(s>>>0>=q>>>0)break;else t=t+8|0}f[p>>2]=A+(u+1<<3)}if(c|0){c=w;w=A;do{A=c;c=c+-8|0;u=w;w=w+-8|0;f[w>>2]=f[c>>2];f[u+-4>>2]=f[A+-4>>2]}while((c|0)!=(i|0))}c=z;if((l|0)==(c|0)){n=i;return n|0}else{B=i;C=l}while(1){f[B>>2]=f[C>>2];f[B+4>>2]=f[C+4>>2];C=C+8|0;if((C|0)==(c|0)){n=i;break}else B=B+8|0}return n|0}B=(r-g>>3)+k|0;if(B>>>0>536870911)c4b(a);k=o-g|0;o=k>>2;r=k>>3>>>0<268435455?(o>>>0<B>>>0?B:o):536870911;o=i;B=h>>3;do if(r)if(r>>>0>536870911){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{D=L5b(r<<3)|0;break}else D=0;while(0);h=D+(B<<3)|0;B=D+(r<<3)|0;if((l|0)==(m|0))E=h;else{r=((m+-8-j|0)>>>3)+1|0;j=l;l=h;while(1){f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];j=j+8|0;if((j|0)==(m|0))break;else l=l+8|0}E=h+(r<<3)|0}if(!b)F=h;else{b=i+-8-g|0;g=i;r=h;while(1){l=g;g=g+-8|0;f[r+-8>>2]=f[g>>2];f[r+-4>>2]=f[l+-4>>2];if((g|0)==(e|0))break;else r=r+-8|0}F=h+(~(b>>>3)<<3)|0}b=F;if((q|0)==(i|0))G=E;else{F=q+-8-o|0;o=i;i=E;while(1){f[i>>2]=f[o>>2];f[i+4>>2]=f[o+4>>2];o=o+8|0;if((o|0)==(q|0))break;else i=i+8|0}G=E+((F>>>3)+1<<3)|0}f[a>>2]=b;f[p>>2]=G;f[d>>2]=B;if(!e){n=h;return n|0}O5b(e);n=h;return n|0}function x2(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;i=u;u=u+208|0;j=i+144|0;k=i+88|0;l=i+72|0;m=i+16|0;n=i;if((h+-5|0)>>>0>=2){f[j>>2]=0;f[j+4>>2]=0;o=aD(j,24)|0;p=240554;q=o+24|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,j,231223,231056,61);bD(j)}aM(a,3,1,h,-1,1,0);aM(c,3,1,h,-1,1,0);do if((yM(a)|0)==65536){r=f[a+4>>2]|0;f[j>>2]=f[r>>2];s=j+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=j+8|0;f[v>>2]=f[r+8>>2];f[j+12>>2]=f[r+12>>2];f[j+16>>2]=f[r+16>>2];f[j+20>>2]=f[r+20>>2];f[j+24>>2]=f[r+24>>2];f[j+28>>2]=f[r+28>>2];f[j+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[j+36>>2]=w;f[j+40>>2]=v;v=j+48|0;x=j+44|0;f[x>>2]=v;f[v>>2]=0;f[j+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;jL(j,r);break}}else yL(j,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];r=k+4|0;s=a+4|0;f[r>>2]=f[s>>2];t=k+8|0;f[t>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];v=f[a+36>>2]|0;f[k+36>>2]=v;f[k+40>>2]=t;t=k+48|0;x=k+44|0;f[x>>2]=t;f[t>>2]=0;f[k+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[a+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;jL(k,a);break}}else yL(k,c,-1);while(0);if(!((e|d|0)>-1&(e+d|0)==1)){f[l>>2]=0;f[l+4>>2]=0;o=aD(l,32)|0;p=231240;q=o+32|0;do{b[o>>0]=b[p>>0]|0;o=o+1|0;p=p+1|0}while((o|0)<(q|0));bO(-215,l,231223,231056,67);bD(l)}p=m+4|0;o=m+8|0;q=m+12|0;c=m+16|0;a=m+20|0;r=m+24|0;s=m+28|0;t=m+40|0;x=m+48|0;v=m+44|0;w=n+8|0;y=n+4|0;z=m+36|0;A=l+4|0;B=l+8|0;if(g){g=r+8|0;C=m+52|0;switch(d|0){case 0:{D=3;E=10;F=3;G=42;break}case 1:{D=1;E=0;F=-1;G=42;break}default:{}}if((G|0)==42){f[l>>2]=F;f[A>>2]=E;f[B>>2]=D}D=f[j+8>>2]|0;E=f[j+12>>2]|0;f[p>>2]=2;f[o>>2]=D;f[q>>2]=E;f[c>>2]=l;f[a>>2]=l;F=g;f[F>>2]=0;f[F+4>>2]=0;f[t>>2]=o;f[v>>2]=x;F=E<<2;f[m>>2]=1124024324;f[x>>2]=F;f[C>>2]=4;E=l+(Y(D,F)|0)|0;f[s>>2]=E;f[r>>2]=E+(0-F)+F;F=w;f[F>>2]=0;f[F+4>>2]=0;f[n>>2]=33619968;f[y>>2]=j;OJ(m,n,h,(d|0)==1?1.0:.03125,0.0);F=f[z>>2]|0;if(F|0?(E=F+12|0,F=f[E>>2]|0,f[E>>2]=F+-1,(F|0)==1):0)kL(m);f[z>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){F=f[t>>2]|0;E=0;do{f[F+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[p>>2]|0))}E=f[v>>2]|0;if((E|0)!=(x|0))UC(E);switch(e|0){case 0:{H=3;I=10;J=3;G=73;break}case 1:{H=1;I=0;J=-1;G=73;break}default:{}}if((G|0)==73){f[l>>2]=J;f[A>>2]=I;f[B>>2]=H}H=f[k+8>>2]|0;I=f[k+12>>2]|0;f[p>>2]=2;f[o>>2]=H;f[q>>2]=I;f[c>>2]=l;f[a>>2]=l;J=g;f[J>>2]=0;f[J+4>>2]=0;f[t>>2]=o;f[v>>2]=x;J=I<<2;f[m>>2]=1124024324;f[x>>2]=J;f[C>>2]=4;C=l+(Y(H,J)|0)|0;f[s>>2]=C;f[r>>2]=C+(0-J)+J;J=w;f[J>>2]=0;f[J+4>>2]=0;f[n>>2]=33619968;f[y>>2]=k;OJ(m,n,h,(e|0)==1?1.0:.03125,0.0);J=f[z>>2]|0;if(J|0?(C=J+12|0,J=f[C>>2]|0,f[C>>2]=J+-1,(J|0)==1):0)kL(m);f[z>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){J=f[t>>2]|0;C=0;do{f[J+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[p>>2]|0))}C=f[v>>2]|0;if((C|0)!=(x|0))UC(C)}else{switch(d|0){case 0:{K=3;L=10;M=3;G=23;break}case 1:{K=1;L=0;M=-1;G=23;break}default:{}}if((G|0)==23){f[l>>2]=M;f[A>>2]=L;f[B>>2]=K}K=f[j+8>>2]|0;L=f[j+12>>2]|0;f[p>>2]=2;f[o>>2]=K;f[q>>2]=L;f[c>>2]=l;f[a>>2]=l;M=r+8|0;f[M>>2]=0;f[M+4>>2]=0;f[t>>2]=o;f[v>>2]=x;M=L<<2;f[m>>2]=1124024324;f[x>>2]=M;L=m+52|0;f[L>>2]=4;d=l+(Y(K,M)|0)|0;f[s>>2]=d;f[r>>2]=d+(0-M)+M;M=w;f[M>>2]=0;f[M+4>>2]=0;f[n>>2]=33619968;f[y>>2]=j;OJ(m,n,h,1.0,0.0);M=f[z>>2]|0;if(M|0?(d=M+12|0,M=f[d>>2]|0,f[d>>2]=M+-1,(M|0)==1):0)kL(m);f[z>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){M=f[t>>2]|0;d=0;do{f[M+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[p>>2]|0))}d=f[v>>2]|0;if((d|0)!=(x|0))UC(d);switch(e|0){case 0:{N=3;O=10;P=3;G=62;break}case 1:{N=1;O=0;P=-1;G=62;break}default:{}}if((G|0)==62){f[l>>2]=P;f[A>>2]=O;f[B>>2]=N}N=f[k+8>>2]|0;B=f[k+12>>2]|0;f[p>>2]=2;f[o>>2]=N;f[q>>2]=B;f[c>>2]=l;f[a>>2]=l;a=r+8|0;f[a>>2]=0;f[a+4>>2]=0;f[t>>2]=o;f[v>>2]=x;o=B<<2;f[m>>2]=1124024324;f[x>>2]=o;f[L>>2]=4;L=l+(Y(N,o)|0)|0;f[s>>2]=L;f[r>>2]=L+(0-o)+o;o=w;f[o>>2]=0;f[o+4>>2]=0;f[n>>2]=33619968;f[y>>2]=k;OJ(m,n,h,1.0,0.0);h=f[z>>2]|0;if(h|0?(n=h+12|0,h=f[n>>2]|0,f[n>>2]=h+-1,(h|0)==1):0)kL(m);f[z>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[t>>2]|0;t=0;do{f[c+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[p>>2]|0))}p=f[v>>2]|0;if((p|0)!=(x|0))UC(p)}p=k+36|0;x=f[p>>2]|0;if(x|0?(v=x+12|0,x=f[v>>2]|0,f[v>>2]=x+-1,(x|0)==1):0)kL(k);f[p>>2]=0;p=k+16|0;x=k+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[x>>2]|0)>0){p=f[k+40>>2]|0;v=0;do{f[p+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[x>>2]|0))}x=f[k+44>>2]|0;if((x|0)!=(k+48|0))UC(x);x=j+36|0;k=f[x>>2]|0;if(k|0?(v=k+12|0,k=f[v>>2]|0,f[v>>2]=k+-1,(k|0)==1):0)kL(j);f[x>>2]=0;x=j+16|0;k=j+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[k>>2]|0)>0){x=f[j+40>>2]|0;v=0;do{f[x+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)==(j+48|0)){u=i;return}UC(k);u=i;return}function y2(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0;j=u;u=u+208|0;k=j+184|0;l=j+128|0;m=j+72|0;n=j+56|0;o=j;p=(g|0)==1;q=(d|0)>0&p?3:g;r=(e|0)>0&p?3:g;if((i+-5|0)>>>0>=2){f[k>>2]=0;f[k+4>>2]=0;s=aD(k,24)|0;t=240554;v=s+24|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,k,231040,231056,96);bD(k)}aM(a,q,1,i,-1,1,0);aM(c,r,1,i,-1,1,0);do if((yM(a)|0)==65536){p=f[a+4>>2]|0;f[l>>2]=f[p>>2];w=l+4|0;x=p+4|0;f[w>>2]=f[x>>2];y=l+8|0;f[y>>2]=f[p+8>>2];f[l+12>>2]=f[p+12>>2];f[l+16>>2]=f[p+16>>2];f[l+20>>2]=f[p+20>>2];f[l+24>>2]=f[p+24>>2];f[l+28>>2]=f[p+28>>2];f[l+32>>2]=f[p+32>>2];z=f[p+36>>2]|0;f[l+36>>2]=z;f[l+40>>2]=y;y=l+48|0;A=l+44|0;f[A>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[p+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;jL(l,p);break}}else yL(l,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[m>>2]=f[a>>2];p=m+4|0;w=a+4|0;f[p>>2]=f[w>>2];x=m+8|0;f[x>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[m+36>>2]=y;f[m+40>>2]=x;x=m+48|0;A=m+44|0;f[A>>2]=x;f[x>>2]=0;f[m+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[a+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[p>>2]=0;jL(m,a);break}}else yL(m,c,-1);while(0);if((g|0)>31|(g&1|0)==0){f[k>>2]=0;f[k+4>>2]=0;s=aD(k,50)|0;t=231126;v=s+50|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-211,k,231040,231056,104);bD(k)}g=((q|0)<(r|0)?r:q)+1|0;f[n>>2]=0;c=n+4|0;f[c>>2]=0;f[n+8>>2]=0;do if(g|0)if(g>>>0>1073741823)c4b(n);else{a=g<<2;p=L5b(a)|0;f[n>>2]=p;w=p+(g<<2)|0;f[n+8>>2]=w;Nac(p|0,0,a|0)|0;f[c>>2]=w;break}while(0);if(!((e|d|0)>-1&(e+d|0)>0)){f[k>>2]=0;f[k+4>>2]=0;s=aD(k,31)|0;t=231177;v=s+31|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,k,231040,231056,107);bD(k)}g=o+4|0;w=o+8|0;a=o+12|0;p=o+16|0;x=o+20|0;A=o+24|0;y=o+28|0;z=o+40|0;B=o+48|0;C=o+44|0;D=o+52|0;E=k+4|0;F=k+8|0;G=k+4|0;H=o+36|0;I=k+4|0;J=0;do{K=(J|0)==0;L=K?l:m;M=K?d:e;N=K?q:r;if((N|0)<=(M|0)){f[k>>2]=0;f[I>>2]=0;s=aD(k,13)|0;t=231209;v=s+13|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,k,231040,231056,115);bD(k)}switch(N|0){case 1:{K=f[n>>2]|0;O=0;P=K;Q=K;R=52;break}case 3:{do if(M){K=f[n>>2]|0;if((M|0)==1){f[K>>2]=-1;S=0;T=K;U=K;break}else{f[K>>2]=1;S=-2;T=K;U=K;break}}else{K=f[n>>2]|0;f[K>>2]=1;S=2;T=K;U=K}while(0);f[T+4>>2]=S;O=2;P=T;Q=U;R=52;break}default:{K=f[n>>2]|0;V=1;W=0;while(1){f[K+(W<<2)>>2]=V;if((W|0)<(N|0)){V=0;W=W+1|0}else break}W=N+~M|0;if((W|0)>0){V=f[n>>2]|0;if((N|0)<1)X=V;else{Z=0;do{_=f[V>>2]|0;$=_;aa=1;ba=_;while(1){_=f[V+(aa<<2)>>2]|0;f[V+(aa+-1<<2)>>2]=$;if((aa|0)==(N|0))break;else{$=ba+_|0;aa=aa+1|0;ba=_}}Z=Z+1|0}while((Z|0)!=(W|0));X=V}}else X=K;if((M|0)>0){V=f[n>>2]|0;if((N|0)<1)ca=V;else{W=0;do{Z=f[V>>2]|0;ba=0-Z|0;aa=1;$=Z;while(1){Z=f[V+(aa<<2)>>2]|0;f[V+(aa+-1<<2)>>2]=ba;if((aa|0)==(N|0))break;else{ba=$-Z|0;aa=aa+1|0;$=Z}}W=W+1|0}while((W|0)!=(M|0));ca=V}}else ca=X}}if((R|0)==52){R=0;f[P+(O<<2)>>2]=1;ca=Q}V=f[L+8>>2]|0;W=f[L+12>>2]|0;f[o>>2]=1124007940;f[g>>2]=2;f[w>>2]=V;f[a>>2]=W;f[p>>2]=ca;f[x>>2]=ca;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[z>>2]=w;f[C>>2]=B;f[D>>2]=0;f[B>>2]=0;if((Y(W,V)|0)!=0&(ca|0)==0){f[k>>2]=0;f[E>>2]=0;s=aD(k,26)|0;t=426262;v=s+26|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,k,426289,431198,500);bD(k);da=f[a>>2]|0;ea=f[o>>2]|0;fa=f[C>>2]|0;ga=f[x>>2]|0}else{da=W;ea=1124007940;fa=B;ga=ca}V=da<<2;f[o>>2]=ea|16384;f[fa>>2]=V;f[fa+4>>2]=4;K=ga+(Y(f[w>>2]|0,V)|0)|0;f[y>>2]=K;f[A>>2]=K+(0-V)+V;if(h)ha=1.0/+(1<<N+~M|0);else ha=1.0;V=F;f[V>>2]=0;f[V+4>>2]=0;f[k>>2]=33619968;f[G>>2]=L;OJ(o,k,i,ha,0.0);V=f[H>>2]|0;if(V|0?(K=V+12|0,V=f[K>>2]|0,f[K>>2]=V+-1,(V|0)==1):0)kL(o);f[H>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[g>>2]|0)>0){V=f[z>>2]|0;K=0;do{f[V+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[g>>2]|0))}K=f[C>>2]|0;if((K|0)!=(B|0))UC(K);J=J+1|0}while((J|0)<2);J=f[n>>2]|0;if(J|0){n=f[c>>2]|0;if((n|0)!=(J|0))f[c>>2]=n+(~((n+-4-J|0)>>>2)<<2);O5b(J)}J=m+36|0;n=f[J>>2]|0;if(n|0?(c=n+12|0,n=f[c>>2]|0,f[c>>2]=n+-1,(n|0)==1):0)kL(m);f[J>>2]=0;J=m+16|0;n=m+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[n>>2]|0)>0){J=f[m+40>>2]|0;c=0;do{f[J+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))UC(n);n=l+36|0;m=f[n>>2]|0;if(m|0?(c=m+12|0,m=f[c>>2]|0,f[c>>2]=m+-1,(m|0)==1):0)kL(l);f[n>>2]=0;n=l+16|0;m=l+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[m>>2]|0)>0){n=f[l+40>>2]|0;c=0;do{f[n+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)==(l+48|0)){u=j;return}UC(m);u=j;return}function z2(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=u;u=u+336|0;l=k+280|0;m=k+272|0;n=k+264|0;o=k+200|0;p=k+208|0;q=k+144|0;r=k+88|0;s=k+80|0;t=k+72|0;v=k+56|0;w=k+40|0;x=k+16|0;y=k;z=k+32|0;f[m>>2]=c;dQ(n,51492);A=BL(a,-1)|0;B=A&7;if((c|0)<0){f[m>>2]=B;C=B}else C=c;AL(o,a,-1);vM(b,o,C&7|A&4088,-1,0,0);A=(C|0)<(B|0)?B:C;C=(A|0)>5?A:5;f[p>>2]=1124007936;A=p+4|0;B=p+8|0;o=p+40|0;c=A;D=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(D|0));f[o>>2]=B;B=p+48|0;E=p+44|0;f[E>>2]=B;f[B>>2]=0;f[p+52>>2]=0;f[q>>2]=1124007936;F=q+4|0;G=q+8|0;H=q+40|0;c=F;D=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(D|0));f[H>>2]=G;G=q+48|0;c=q+44|0;f[c>>2]=G;f[G>>2]=0;f[q+52>>2]=0;D=l+8|0;f[D>>2]=0;f[D+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=p;D=r+8|0;f[D>>2]=0;f[D+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=q;if((g|0)<1)x2(l,r,d,e,0,C);else y2(l,r,d,e,g,0,C);do if(h!=1.0)if(!d){C=l+8|0;f[C>>2]=0;f[C+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=p;OJ(p,l,-1,h,0.0);break}else{C=l+8|0;f[C>>2]=0;f[C+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=q;OJ(q,l,-1,h,0.0);break}while(0);do if((yM(a)|0)==65536){d=f[a+4>>2]|0;f[l>>2]=f[d>>2];C=l+4|0;g=d+4|0;f[C>>2]=f[g>>2];e=l+8|0;f[e>>2]=f[d+8>>2];f[l+12>>2]=f[d+12>>2];f[l+16>>2]=f[d+16>>2];f[l+20>>2]=f[d+20>>2];f[l+24>>2]=f[d+24>>2];f[l+28>>2]=f[d+28>>2];f[l+32>>2]=f[d+32>>2];D=f[d+36>>2]|0;f[l+36>>2]=D;f[l+40>>2]=e;e=l+48|0;I=l+44|0;f[I>>2]=e;f[e>>2]=0;f[l+52>>2]=0;if(D|0){e=D+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[g>>2]|0)<3){g=f[d+44>>2]|0;e=f[I>>2]|0;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];break}else{f[C>>2]=0;jL(l,d);break}}else yL(l,a,-1);while(0);do if((yM(b)|0)==65536){a=f[b+4>>2]|0;f[r>>2]=f[a>>2];d=r+4|0;C=a+4|0;f[d>>2]=f[C>>2];g=r+8|0;f[g>>2]=f[a+8>>2];f[r+12>>2]=f[a+12>>2];f[r+16>>2]=f[a+16>>2];f[r+20>>2]=f[a+20>>2];f[r+24>>2]=f[a+24>>2];f[r+28>>2]=f[a+28>>2];f[r+32>>2]=f[a+32>>2];e=f[a+36>>2]|0;f[r+36>>2]=e;f[r+40>>2]=g;g=r+48|0;I=r+44|0;f[I>>2]=g;f[g>>2]=0;f[r+52>>2]=0;if(e|0){g=e+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[C>>2]|0)<3){C=f[a+44>>2]|0;g=f[I>>2]|0;f[g>>2]=f[C>>2];f[g+4>>2]=f[C+4>>2];break}else{f[d>>2]=0;jL(r,a);break}}else yL(r,b,-1);while(0);f[s>>2]=0;f[s+4>>2]=0;b=f[l+8>>2]|0;f[t>>2]=f[l+12>>2];f[t+4>>2]=b;if(!(j&16))uL(l,t,s);s=l+16|0;t=l+44|0;b=r+16|0;a=r+44|0;f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=l;d=w+8|0;f[d>>2]=0;f[d+4>>2]=0;f[w>>2]=33619968;f[w+4>>2]=r;d=f[m>>2]|0;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=p;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=q;f[z>>2]=-1;f[z+4>>2]=-1;Nda(v,w,d,x,y,z,i,j);j=r+36|0;z=f[j>>2]|0;if(z|0?(y=z+12|0,z=f[y>>2]|0,f[y>>2]=z+-1,(z|0)==1):0)kL(r);f[j>>2]=0;j=r+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[j>>2]|0)>0){b=f[r+40>>2]|0;z=0;do{f[b+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[j>>2]|0))}j=f[a>>2]|0;if((j|0)!=(r+48|0))UC(j);j=l+36|0;r=f[j>>2]|0;if(r|0?(a=r+12|0,r=f[a>>2]|0,f[a>>2]=r+-1,(r|0)==1):0)kL(l);f[j>>2]=0;j=l+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[j>>2]|0)>0){s=f[l+40>>2]|0;r=0;do{f[s+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[j>>2]|0))}j=f[t>>2]|0;if((j|0)!=(l+48|0))UC(j);j=q+36|0;l=f[j>>2]|0;if(l|0?(t=l+12|0,l=f[t>>2]|0,f[t>>2]=l+-1,(l|0)==1):0)kL(q);f[j>>2]=0;j=q+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[F>>2]|0)>0){j=f[H>>2]|0;H=0;do{f[j+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[F>>2]|0))}F=f[c>>2]|0;if((F|0)!=(G|0))UC(F);F=p+36|0;G=f[F>>2]|0;if(G|0?(c=G+12|0,G=f[c>>2]|0,f[c>>2]=G+-1,(G|0)==1):0)kL(p);f[F>>2]=0;F=p+16|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[A>>2]|0)>0){F=f[o>>2]|0;o=0;do{f[F+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[A>>2]|0))}A=f[E>>2]|0;if((A|0)!=(B|0))UC(A);if(!(f[n+4>>2]|0)){u=k;return}u=k;return}function A2(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;j=u;u=u+336|0;k=j+280|0;l=j+272|0;m=j+264|0;n=j+200|0;o=j+208|0;p=j+144|0;q=j+88|0;r=j+80|0;s=j+72|0;t=j+56|0;v=j+40|0;w=j+16|0;x=j;y=j+32|0;f[l>>2]=c;dQ(m,51512);z=BL(a,-1)|0;A=z&7;if((c|0)<0){f[l>>2]=A;B=A}else B=c;AL(n,a,-1);vM(b,n,B&7|z&4088,-1,0,0);z=(B|0)<(A|0)?A:B;B=(z|0)>5?z:5;f[o>>2]=1124007936;z=o+4|0;A=o+8|0;n=o+40|0;c=z;C=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(C|0));f[n>>2]=A;A=o+48|0;D=o+44|0;f[D>>2]=A;f[A>>2]=0;f[o+52>>2]=0;f[p>>2]=1124007936;E=p+4|0;F=p+8|0;G=p+40|0;c=E;C=c+36|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(C|0));f[G>>2]=F;F=p+48|0;c=p+44|0;f[c>>2]=F;f[F>>2]=0;f[p+52>>2]=0;C=k+8|0;f[C>>2]=0;f[C+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=o;C=q+8|0;f[C>>2]=0;f[C+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=p;x2(k,q,d,e,0,B);do if(g!=1.0)if(!d){B=k+8|0;f[B>>2]=0;f[B+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=o;OJ(o,k,-1,g,0.0);break}else{B=k+8|0;f[B>>2]=0;f[B+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=p;OJ(p,k,-1,g,0.0);break}while(0);do if((yM(a)|0)==65536){d=f[a+4>>2]|0;f[k>>2]=f[d>>2];B=k+4|0;e=d+4|0;f[B>>2]=f[e>>2];C=k+8|0;f[C>>2]=f[d+8>>2];f[k+12>>2]=f[d+12>>2];f[k+16>>2]=f[d+16>>2];f[k+20>>2]=f[d+20>>2];f[k+24>>2]=f[d+24>>2];f[k+28>>2]=f[d+28>>2];f[k+32>>2]=f[d+32>>2];H=f[d+36>>2]|0;f[k+36>>2]=H;f[k+40>>2]=C;C=k+48|0;I=k+44|0;f[I>>2]=C;f[C>>2]=0;f[k+52>>2]=0;if(H|0){C=H+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[e>>2]|0)<3){e=f[d+44>>2]|0;C=f[I>>2]|0;f[C>>2]=f[e>>2];f[C+4>>2]=f[e+4>>2];break}else{f[B>>2]=0;jL(k,d);break}}else yL(k,a,-1);while(0);do if((yM(b)|0)==65536){a=f[b+4>>2]|0;f[q>>2]=f[a>>2];d=q+4|0;B=a+4|0;f[d>>2]=f[B>>2];e=q+8|0;f[e>>2]=f[a+8>>2];f[q+12>>2]=f[a+12>>2];f[q+16>>2]=f[a+16>>2];f[q+20>>2]=f[a+20>>2];f[q+24>>2]=f[a+24>>2];f[q+28>>2]=f[a+28>>2];f[q+32>>2]=f[a+32>>2];C=f[a+36>>2]|0;f[q+36>>2]=C;f[q+40>>2]=e;e=q+48|0;I=q+44|0;f[I>>2]=e;f[e>>2]=0;f[q+52>>2]=0;if(C|0){e=C+12|0;f[e>>2]=(f[e>>2]|0)+1}if((f[B>>2]|0)<3){B=f[a+44>>2]|0;e=f[I>>2]|0;f[e>>2]=f[B>>2];f[e+4>>2]=f[B+4>>2];break}else{f[d>>2]=0;jL(q,a);break}}else yL(q,b,-1);while(0);f[r>>2]=0;f[r+4>>2]=0;b=f[k+8>>2]|0;f[s>>2]=f[k+12>>2];f[s+4>>2]=b;if(!(i&16))uL(k,s,r);r=k+16|0;s=k+44|0;b=q+16|0;a=q+44|0;f[t+8>>2]=0;f[t+12>>2]=0;f[t>>2]=16842752;f[t+4>>2]=k;d=v+8|0;f[d>>2]=0;f[d+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=q;d=f[l>>2]|0;f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=16842752;f[w+4>>2]=o;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=p;f[y>>2]=-1;f[y+4>>2]=-1;Nda(t,v,d,w,x,y,h,i);i=q+36|0;y=f[i>>2]|0;if(y|0?(x=y+12|0,y=f[x>>2]|0,f[x>>2]=y+-1,(y|0)==1):0)kL(q);f[i>>2]=0;i=q+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[i>>2]|0)>0){b=f[q+40>>2]|0;y=0;do{f[b+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[i>>2]|0))}i=f[a>>2]|0;if((i|0)!=(q+48|0))UC(i);i=k+36|0;q=f[i>>2]|0;if(q|0?(a=q+12|0,q=f[a>>2]|0,f[a>>2]=q+-1,(q|0)==1):0)kL(k);f[i>>2]=0;i=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[i>>2]|0)>0){r=f[k+40>>2]|0;q=0;do{f[r+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[i>>2]|0))}i=f[s>>2]|0;if((i|0)!=(k+48|0))UC(i);i=p+36|0;k=f[i>>2]|0;if(k|0?(s=k+12|0,k=f[s>>2]|0,f[s>>2]=k+-1,(k|0)==1):0)kL(p);f[i>>2]=0;i=p+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[E>>2]|0)>0){i=f[G>>2]|0;G=0;do{f[i+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[E>>2]|0))}E=f[c>>2]|0;if((E|0)!=(F|0))UC(E);E=o+36|0;F=f[E>>2]|0;if(F|0?(c=F+12|0,F=f[c>>2]|0,f[c>>2]=F+-1,(F|0)==1):0)kL(o);f[E>>2]=0;E=o+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[z>>2]|0)>0){E=f[n>>2]|0;n=0;do{f[E+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[z>>2]|0))}z=f[D>>2]|0;if((z|0)!=(A|0))UC(z);if(!(f[m+4>>2]|0)){u=j;return}u=j;return}function B2(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;i=u;u=u+624|0;j=i+600|0;k=i+528|0;l=i;m=i+520|0;n=i+496|0;o=i+512|0;p=i+504|0;q=i+432|0;r=i+376|0;s=i+312|0;t=i+256|0;v=i+248|0;w=i+240|0;x=i+232|0;y=i+488|0;z=i+224|0;A=i+368|0;B=i+168|0;C=i+112|0;D=i+56|0;f[m>>2]=c;dQ(n,51532);E=BL(a,-1)|0;F=E&7;G=E>>>3&511;H=G+1|0;if((c|0)<0){f[m>>2]=F;I=F}else I=c;AL(o,a,-1);c=G<<3;vM(b,o,I&7|c,-1,0,0);if((d|2|0)==3){o=(d|0)==3;J=k;G=51552;K=J+72|0;do{f[J>>2]=f[G>>2];J=J+4|0;G=G+4|0}while((J|0)<(K|0));L=o&1;o=k+(L*36|0)|0;M=l+4|0;f[M>>2]=2;N=l+8|0;f[N>>2]=3;f[l+12>>2]=3;O=l+16|0;f[O>>2]=o;f[l+20>>2]=o;o=l+24|0;P=l+40|0;Q=o+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[P>>2]=N;N=l+48|0;Q=l+44|0;f[Q>>2]=N;f[l>>2]=1124024325;f[N>>2]=12;f[l+52>>2]=4;f[l+28>>2]=k+(L*36|0)+36;f[o>>2]=k+(L*36|0)+36;o=e!=1.0;if(o){R=j+8|0;f[R>>2]=0;f[R+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=l;OJ(l,j,-1,e,0.0);R=l+36|0;S=f[R>>2]|0;if((S|0)!=0?(T=S+12|0,S=f[T>>2]|0,f[T>>2]=S+-1,(S|0)==1):0){kL(l);U=R}else U=R}else U=l+36|0;f[U>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[M>>2]|0)>0){O=f[P>>2]|0;P=0;do{f[O+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[M>>2]|0))}M=f[Q>>2]|0;if((M|0)!=(N|0))UC(M);J=k;G=51552;K=J+72|0;do{f[J>>2]=f[G>>2];J=J+4|0;G=G+4|0}while((J|0)<(K|0));G=k+(L*36|0)|0;M=l+4|0;f[M>>2]=2;N=l+8|0;f[N>>2]=3;f[l+12>>2]=3;Q=l+16|0;f[Q>>2]=G;f[l+20>>2]=G;G=l+24|0;P=l+40|0;O=G+8|0;f[O>>2]=0;f[O+4>>2]=0;f[P>>2]=N;N=l+48|0;O=l+44|0;f[O>>2]=N;f[l>>2]=1124024325;f[N>>2]=12;f[l+52>>2]=4;f[l+28>>2]=k+(L*36|0)+36;f[G>>2]=k+(L*36|0)+36;if(o){o=j+8|0;f[o>>2]=0;f[o+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=l;OJ(l,j,-1,e,0.0)}o=f[m>>2]|0;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=l;f[p>>2]=-1;f[p+4>>2]=-1;Mda(a,b,o,j,p,g,h);p=l+36|0;o=f[p>>2]|0;if(o|0?(L=o+12|0,o=f[L>>2]|0,f[L>>2]=o+-1,(o|0)==1):0)kL(l);f[p>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[M>>2]|0)>0){Q=f[P>>2]|0;P=0;do{f[Q+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[M>>2]|0))}M=f[O>>2]|0;if((M|0)!=(N|0))UC(M)}else{M=(I|0)<(F|0)?F:I;I=(M|0)>5?M:5;M=((d|0)<6&(F|0)==0?3:F>>>0<6?5:6)|c;f[q>>2]=1124007936;c=q+4|0;N=q+8|0;O=q+40|0;J=c;K=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(K|0));f[O>>2]=N;P=q+48|0;Q=q+44|0;f[Q>>2]=P;f[P>>2]=0;f[q+52>>2]=0;f[r>>2]=1124007936;p=r+4|0;o=r+8|0;L=r+40|0;J=p;K=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(K|0));f[L>>2]=o;o=r+48|0;G=r+44|0;f[G>>2]=o;f[o>>2]=0;f[r+52>>2]=0;U=j+8|0;f[U>>2]=0;f[U+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=q;U=k+8|0;f[U>>2]=0;f[U+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=r;y2(j,k,2,0,d,0,I);do if((yM(a)|0)==65536){I=f[a+4>>2]|0;f[s>>2]=f[I>>2];d=s+4|0;U=I+4|0;f[d>>2]=f[U>>2];R=s+8|0;f[R>>2]=f[I+8>>2];f[s+12>>2]=f[I+12>>2];f[s+16>>2]=f[I+16>>2];f[s+20>>2]=f[I+20>>2];f[s+24>>2]=f[I+24>>2];f[s+28>>2]=f[I+28>>2];f[s+32>>2]=f[I+32>>2];S=f[I+36>>2]|0;f[s+36>>2]=S;f[s+40>>2]=R;R=s+48|0;T=s+44|0;f[T>>2]=R;f[R>>2]=0;f[s+52>>2]=0;if(S|0){R=S+12|0;f[R>>2]=(f[R>>2]|0)+1}if((f[U>>2]|0)<3){U=f[I+44>>2]|0;R=f[T>>2]|0;f[R>>2]=f[U>>2];f[R+4>>2]=f[U+4>>2];break}else{f[d>>2]=0;jL(s,I);break}}else yL(s,a,-1);while(0);do if((yM(b)|0)==65536){a=f[b+4>>2]|0;f[t>>2]=f[a>>2];I=t+4|0;d=a+4|0;f[I>>2]=f[d>>2];U=t+8|0;f[U>>2]=f[a+8>>2];f[t+12>>2]=f[a+12>>2];f[t+16>>2]=f[a+16>>2];f[t+20>>2]=f[a+20>>2];f[t+24>>2]=f[a+24>>2];f[t+28>>2]=f[a+28>>2];f[t+32>>2]=f[a+32>>2];R=f[a+36>>2]|0;f[t+36>>2]=R;f[t+40>>2]=U;U=t+48|0;T=t+44|0;f[T>>2]=U;f[U>>2]=0;f[t+52>>2]=0;if(R|0){U=R+12|0;f[U>>2]=(f[U>>2]|0)+1}if((f[d>>2]|0)<3){d=f[a+44>>2]|0;U=f[T>>2]|0;f[U>>2]=f[d>>2];f[U+4>>2]=f[d+4>>2];break}else{f[I>>2]=0;jL(t,a);break}}else yL(t,b,-1);while(0);f[v>>2]=0;f[v+4>>2]=0;b=s+12|0;a=s+8|0;I=f[a>>2]|0;f[w>>2]=f[b>>2];f[w+4>>2]=I;if(!(h&16))uL(s,w,v);I=h&-17;f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=q;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=r;f[y>>2]=-1;f[y+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;hca(x,E,M,j,k,y,0.0,I,I,l);f[j+8>>2]=0;f[j+12>>2]=0;f[j>>2]=16842752;f[j+4>>2]=r;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=q;f[A>>2]=-1;f[A+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;hca(z,E,M,j,k,A,0.0,I,I,l);I=x+4|0;A=f[I>>2]|0;E=Dg[f[(f[A>>2]|0)+12>>2]&127](A,s,w,v)|0;A=z+4|0;y=f[A>>2]|0;Dg[f[(f[y>>2]|0)+12>>2]&127](y,s,w,v)|0;v=s+16|0;w=s+44|0;y=(f[v>>2]|0)+(Y(f[f[w>>2]>>2]|0,E)|0)|0;E=f[b>>2]|0;h=Y(E,H<<(47696>>>(F<<1)&3))|0;F=f[a>>2]|0;H=h>>>0>16384?1:16384/(h>>>0)|0;h=(F|0)<(H|0)?F:H;H=(f[N>>2]|0)+-1+h|0;f[B>>2]=1124007936;F=B+4|0;d=B+8|0;U=B+40|0;J=F;K=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(K|0));f[U>>2]=d;T=B+48|0;R=B+44|0;f[R>>2]=T;f[T>>2]=0;f[B+52>>2]=0;f[j>>2]=H;H=j+4|0;f[H>>2]=E;hL(B,2,j,M);E=h+-1+(f[N>>2]|0)|0;N=f[b>>2]|0;f[C>>2]=1124007936;b=C+4|0;S=C+8|0;V=C+40|0;J=b;K=J+36|0;do{f[J>>2]=0;J=J+4|0}while((J|0)<(K|0));f[V>>2]=S;J=C+48|0;K=C+44|0;f[K>>2]=J;f[J>>2]=0;f[C+52>>2]=0;f[j>>2]=E;f[H>>2]=N;hL(C,2,j,M);if((f[a>>2]|0)>0){M=s+48|0;N=B+16|0;H=C+16|0;E=j+4|0;W=k+4|0;X=j+8|0;Z=j+12|0;_=j+4|0;$=k+8|0;aa=k+12|0;ba=k+4|0;ca=l+8|0;da=l+4|0;ea=j+8|0;fa=j+4|0;ga=D+36|0;ha=D+16|0;ia=D+4|0;ja=D+40|0;ka=D+44|0;la=D+48|0;ma=y;y=0;na=f[M>>2]|0;while(1){oa=f[I>>2]|0;Xf[f[(f[oa>>2]|0)+16>>2]&127](oa,ma,na,h,f[N>>2]|0,f[T>>2]|0)|0;oa=f[A>>2]|0;pa=Xf[f[(f[oa>>2]|0)+16>>2]&127](oa,ma,f[M>>2]|0,h,f[H>>2]|0,f[J>>2]|0)|0;if((pa|0)>0){oa=pa+y|0;f[j>>2]=y;f[E>>2]=oa;f[k>>2]=-2147483648;f[W>>2]=2147483647;lL(D,t,j,k);f[S>>2]=pa;f[d>>2]=pa;f[X>>2]=0;f[Z>>2]=0;f[j>>2]=16842752;f[_>>2]=B;f[$>>2]=0;f[aa>>2]=0;f[k>>2]=16842752;f[ba>>2]=C;qa=ca;f[qa>>2]=0;f[qa+4>>2]=0;f[l>>2]=33619968;f[da>>2]=B;VD(j,k,l,UM()|0,-1);qa=ea;f[qa>>2]=0;f[qa+4>>2]=0;f[j>>2]=33619968;f[fa>>2]=D;OJ(B,j,f[m>>2]|0,e,g);qa=f[ga>>2]|0;if(qa|0?(ra=qa+12|0,qa=f[ra>>2]|0,f[ra>>2]=qa+-1,(qa|0)==1):0)kL(D);f[ga>>2]=0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[ia>>2]|0)>0){qa=f[ja>>2]|0;ra=0;do{f[qa+(ra<<2)>>2]=0;ra=ra+1|0}while((ra|0)<(f[ia>>2]|0))}ra=f[ka>>2]|0;if((ra|0)!=(la|0))UC(ra);sa=oa}else sa=pa+y|0;na=f[M>>2]|0;ma=ma+(Y(na,h)|0)|0;if((sa|0)>=(f[a>>2]|0))break;else y=sa}}sa=C+36|0;y=f[sa>>2]|0;if(y|0?(a=y+12|0,y=f[a>>2]|0,f[a>>2]=y+-1,(y|0)==1):0)kL(C);f[sa>>2]=0;sa=C+16|0;f[sa>>2]=0;f[sa+4>>2]=0;f[sa+8>>2]=0;f[sa+12>>2]=0;if((f[b>>2]|0)>0){sa=f[V>>2]|0;V=0;do{f[sa+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[b>>2]|0))}b=f[K>>2]|0;if((b|0)!=(J|0))UC(b);b=B+36|0;J=f[b>>2]|0;if(J|0?(K=J+12|0,J=f[K>>2]|0,f[K>>2]=J+-1,(J|0)==1):0)kL(B);f[b>>2]=0;b=B+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[F>>2]|0)>0){b=f[U>>2]|0;U=0;do{f[b+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[F>>2]|0))}F=f[R>>2]|0;if((F|0)!=(T|0))UC(F);F=f[z>>2]|0;if(F|0?(z=F+4|0,T=f[z>>2]|0,f[z>>2]=T+-1,(T|0)==1):0)bi[f[(f[F>>2]|0)+8>>2]&2047](F);F=f[x>>2]|0;if(F|0?(x=F+4|0,T=f[x>>2]|0,f[x>>2]=T+-1,(T|0)==1):0)bi[f[(f[F>>2]|0)+8>>2]&2047](F);F=t+36|0;T=f[F>>2]|0;if(T|0?(x=T+12|0,T=f[x>>2]|0,f[x>>2]=T+-1,(T|0)==1):0)kL(t);f[F>>2]=0;F=t+16|0;T=t+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[T>>2]|0)>0){F=f[t+40>>2]|0;x=0;do{f[F+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[T>>2]|0))}T=f[t+44>>2]|0;if((T|0)!=(t+48|0))UC(T);T=s+36|0;t=f[T>>2]|0;do if(t|0){x=t+12|0;F=f[x>>2]|0;f[x>>2]=F+-1;if((F|0)!=1)break;kL(s)}while(0);f[T>>2]=0;T=s+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[T>>2]|0)>0){v=f[s+40>>2]|0;t=0;do{f[v+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[T>>2]|0))}T=f[w>>2]|0;if((T|0)!=(s+48|0))UC(T);T=r+36|0;s=f[T>>2]|0;do if(s|0){w=s+12|0;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)!=1)break;kL(r)}while(0);f[T>>2]=0;T=r+16|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[p>>2]|0)>0){T=f[L>>2]|0;L=0;do{f[T+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[p>>2]|0))}p=f[G>>2]|0;if((p|0)!=(o|0))UC(p);p=q+36|0;o=f[p>>2]|0;do if(o|0){G=o+12|0;L=f[G>>2]|0;f[G>>2]=L+-1;if((L|0)!=1)break;kL(q)}while(0);f[p>>2]=0;p=q+16|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[c>>2]|0)>0){p=f[O>>2]|0;O=0;do{f[p+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[c>>2]|0))}c=f[Q>>2]|0;if((c|0)!=(P|0))UC(c)}if(!(f[n+4>>2]|0)){u=i;return}u=i;return}function C2(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;m=u;u=u+432|0;o=m+48|0;q=m+424|0;r=m+368|0;s=m+312|0;t=m+256|0;v=m+32|0;w=m+176|0;x=m+120|0;y=m+64|0;z=m+248|0;A=m;B=m+192|0;dQ(q,51624);if(!((d|0)>-1&(e>0.0&g>=0.0))){f[o>>2]=0;f[o+4>>2]=0;C=aD(o,55)|0;D=231506;E=C+55|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,o,231562,231582,365);bD(o)}do if(!(HM(h)|0)){if((BL(h,-1)|0)==0?DM(h,a)|0:0)break;f[o>>2]=0;f[o+4>>2]=0;C=aD(o,102)|0;D=231660;E=C+102|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,o,231562,231582,366);bD(o)}while(0);do if((yM(a)|0)==65536){D=f[a+4>>2]|0;f[r>>2]=f[D>>2];F=r+4|0;G=D+4|0;f[F>>2]=f[G>>2];H=r+8|0;f[H>>2]=f[D+8>>2];f[r+12>>2]=f[D+12>>2];I=r+16|0;f[I>>2]=f[D+16>>2];f[r+20>>2]=f[D+20>>2];f[r+24>>2]=f[D+24>>2];f[r+28>>2]=f[D+28>>2];f[r+32>>2]=f[D+32>>2];J=f[D+36>>2]|0;f[r+36>>2]=J;f[r+40>>2]=H;H=r+48|0;K=r+44|0;f[K>>2]=H;f[H>>2]=0;f[r+52>>2]=0;if(J|0){H=J+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[D+44>>2]|0;H=f[K>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];L=I;break}else{f[F>>2]=0;jL(r,D);L=I;break}}else{yL(r,a,-1);L=r+16|0}while(0);f[s>>2]=1124007936;a=s+4|0;I=s+8|0;D=s+40|0;C=a;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[D>>2]=I;I=s+48|0;F=s+44|0;f[F>>2]=I;f[I>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;G=t+4|0;H=t+8|0;K=t+40|0;C=G;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[K>>2]=H;H=t+48|0;J=t+44|0;f[J>>2]=H;f[H>>2]=0;f[t+52>>2]=0;if(f[L>>2]|0){M=f[r+4>>2]|0;if((M|0)<3)N=Y(f[r+12>>2]|0,f[r+8>>2]|0)|0;else{O=f[r+40>>2]|0;P=0;Q=1;while(1){R=Y(f[O+(P<<2)>>2]|0,Q)|0;P=P+1|0;if((P|0)==(M|0)){N=R;break}else Q=R}}if(!((M|0)==0|(N|0)==0)){if(k){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=r;k=v+8|0;f[k>>2]=0;f[k+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=s;wea(o,v,i,j,l,4)}else{f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=r;k=v+8|0;f[k>>2]=0;f[k+4>>2]=0;f[v>>2]=33619968;f[v+4>>2]=s;uea(o,v,i,j,4)}p[v>>3]=0.0;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=s;KG(o,0,v,0,0,h);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=s;j=w+8|0;f[j>>2]=0;f[j+4>>2]=0;f[w>>2]=33619968;f[w+4>>2]=s;+nea(o,w,+p[v>>3]*e,0.0,3);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=s;v=w+8|0;f[v>>2]=0;f[v+4>>2]=0;f[w>>2]=33619968;f[w+4>>2]=t;f[y>>2]=1124007936;v=y+4|0;j=y+8|0;i=y+40|0;C=v;E=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(E|0));f[i>>2]=j;j=y+48|0;C=y+44|0;f[C>>2]=j;f[j>>2]=0;f[y+52>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x>>2]=16842752;f[x+4>>2]=y;f[z>>2]=-1;f[z+4>>2]=-1;p[A>>3]=1797693134862315708145274.0e284;p[A+8>>3]=1797693134862315708145274.0e284;p[A+16>>3]=1797693134862315708145274.0e284;p[A+24>>3]=1797693134862315708145274.0e284;Bla(o,w,x,z,1,0,A);z=y+36|0;E=f[z>>2]|0;if(E|0?(k=E+12|0,E=f[k>>2]|0,f[k>>2]=E+-1,(E|0)==1):0)kL(y);f[z>>2]=0;z=y+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[v>>2]|0)>0){z=f[i>>2]|0;i=0;do{f[z+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[v>>2]|0))}v=f[C>>2]|0;if((v|0)!=(j|0))UC(v);v=f[r+40>>2]|0;j=f[v+4>>2]|0;C=f[v>>2]|0;f[w>>2]=0;v=w+4|0;f[v>>2]=0;f[w+8>>2]=0;do if((yM(h)|0)==65536){i=f[h+4>>2]|0;f[x>>2]=f[i>>2];z=x+4|0;E=i+4|0;f[z>>2]=f[E>>2];k=x+8|0;f[k>>2]=f[i+8>>2];f[x+12>>2]=f[i+12>>2];f[x+16>>2]=f[i+16>>2];f[x+20>>2]=f[i+20>>2];f[x+24>>2]=f[i+24>>2];f[x+28>>2]=f[i+28>>2];f[x+32>>2]=f[i+32>>2];N=f[i+36>>2]|0;f[x+36>>2]=N;f[x+40>>2]=k;k=x+48|0;M=x+44|0;f[M>>2]=k;f[k>>2]=0;f[x+52>>2]=0;if(N|0){k=N+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[E>>2]|0)<3){E=f[i+44>>2]|0;k=f[M>>2]|0;f[k>>2]=f[E>>2];f[k+4>>2]=f[E+4>>2];break}else{f[z>>2]=0;jL(x,i);break}}else yL(x,h,-1);while(0);h=C+-1|0;if((h|0)>1?(C=s+16|0,i=t+16|0,z=x+16|0,E=j+-1|0,j=w+8|0,k=x+44|0,(E|0)>1):0){M=1;do{N=(f[C>>2]|0)+(Y(f[f[F>>2]>>2]|0,M)|0)|0;Q=(f[i>>2]|0)+(Y(f[f[J>>2]>>2]|0,M)|0)|0;P=f[z>>2]|0;if((P|0)!=0?(O=P+(Y(f[f[k>>2]>>2]|0,M)|0)|0,(O|0)!=0):0){P=1;do{R=N+(P<<2)|0;e=+n[R>>2];do if(e!=0.0){if(!(e==+n[Q+(P<<2)>>2]))break;if(!(b[O+P>>0]|0))break;f[o>>2]=R;S=f[v>>2]|0;if((S|0)==(f[j>>2]|0))D2(w,o);else{f[S>>2]=R;f[v>>2]=(f[v>>2]|0)+4}}while(0);P=P+1|0}while((P|0)<(E|0))}else{T=1;U=52}if((U|0)==52)while(1){U=0;P=N+(T<<2)|0;e=+n[P>>2];do if(e!=0.0){if(!(e==+n[Q+(T<<2)>>2]))break;f[o>>2]=P;O=f[v>>2]|0;if((O|0)==(f[j>>2]|0))D2(w,o);else{f[O>>2]=P;f[v>>2]=(f[v>>2]|0)+4}}while(0);T=T+1|0;if((T|0)>=(E|0))break;else U=52}M=M+1|0}while((M|0)<(h|0))}f[y>>2]=0;h=y+4|0;f[h>>2]=0;f[y+8>>2]=0;M=f[v>>2]|0;E=f[w>>2]|0;T=M-E>>2;do if(!T)$L(c);else{E2(E,M,o);if(!(g>=1.0)){j=s+16|0;k=o+4|0;z=y+8|0;if((d|0)>0){i=0;do{C=(f[(f[w>>2]|0)+(i<<2)>>2]|0)-(f[j>>2]|0)|0;Q=f[I>>2]|0;N=(C>>>0)/(Q>>>0)|0;e=+((C-(Y(N,Q)|0)|0)>>>2|0);l=+(N|0);n[o>>2]=e;n[k>>2]=l;N=f[h>>2]|0;if((N|0)==(f[z>>2]|0))F2(y,o);else{n[N>>2]=e;n[N+4>>2]=l;f[h>>2]=N+8}i=i+1|0}while((i|0)!=(d|0)&i>>>0<T>>>0)}else{i=0;do{N=(f[(f[w>>2]|0)+(i<<2)>>2]|0)-(f[j>>2]|0)|0;Q=f[I>>2]|0;C=(N>>>0)/(Q>>>0)|0;l=+((N-(Y(C,Q)|0)|0)>>>2|0);e=+(C|0);n[o>>2]=l;n[k>>2]=e;C=f[h>>2]|0;if((C|0)==(f[z>>2]|0))F2(y,o);else{n[C>>2]=l;n[C+4>>2]=e;f[h>>2]=C+8}i=i+1|0}while(i>>>0<T>>>0)}}else{i=f[r+12>>2]|0;z=f[r+8>>2]|0;k=MVb(g)|0;j=(i+-1+k|0)/(k|0)|0;i=(z+-1+k|0)/(k|0)|0;G2(o,Y(i,j)|0);e=g*g;z=s+16|0;C=j+-1|0;Q=i+-1|0;i=A+4|0;N=A+4|0;P=y+8|0;O=(d|0)>0;R=0;S=0;while(1){V=(f[(f[w>>2]|0)+(R<<2)>>2]|0)-(f[z>>2]|0)|0;W=f[I>>2]|0;X=(V>>>0)/(W>>>0)|0;Z=(V-(Y(X,W)|0)|0)>>>2;W=(Z|0)/(k|0)|0;V=(X|0)/(k|0)|0;_=W+-1|0;$=V+-1|0;aa=W+1|0;ba=V+1|0;ca=(_|0)>0?_:0;_=($|0)>0?$:0;$=(aa|0)<(C|0)?aa:C;aa=(ba|0)<(Q|0)?ba:Q;do if((_|0)<=(aa|0)){ba=f[o>>2]|0;l=+(Z|0);da=+(X|0);if((ca|0)>($|0)){ea=l;fa=da;ga=ba;U=80;break}else{ha=_;ia=1}a:while(1){ja=Y(ha,j)|0;ka=ca;la=ia;while(1){ma=ka+ja|0;na=f[ba+(ma*12|0)+4>>2]|0;oa=f[ba+(ma*12|0)>>2]|0;ma=oa;if((na|0)==(oa|0))pa=la;else{qa=na-oa>>3;oa=0;na=la;while(1){ra=l-+n[ma+(oa<<3)>>2];sa=da-+n[ma+(oa<<3)+4>>2];ta=ra*ra+sa*sa<e;ua=na&(ta^1);oa=oa+1|0;if(ta){U=79;break a}if(oa>>>0>=qa>>>0){pa=ua;break}else na=ua}}if((ka|0)<($|0)){ka=ka+1|0;la=pa}else break}if((ha|0)<(aa|0)){ha=ha+1|0;ia=pa}else{U=72;break}}if((U|0)==72){U=0;if(pa){ea=l;fa=da;ga=ba;U=80;break}else{va=S;break}}else if((U|0)==79){U=0;if(ua){ea=l;fa=da;ga=ba;U=80;break}else{va=S;break}}}else{ea=+(Z|0);fa=+(X|0);ga=f[o>>2]|0;U=80}while(0);if((U|0)==80){U=0;X=(Y(V,j)|0)+W|0;n[A>>2]=ea;n[i>>2]=fa;Z=ga+(X*12|0)+4|0;aa=f[Z>>2]|0;if((aa|0)==(f[ga+(X*12|0)+8>>2]|0))F2(ga+(X*12|0)|0,A);else{n[aa>>2]=ea;n[aa+4>>2]=fa;f[Z>>2]=aa+8}n[A>>2]=ea;n[N>>2]=fa;aa=f[h>>2]|0;if((aa|0)==(f[P>>2]|0))F2(y,A);else{n[aa>>2]=ea;n[aa+4>>2]=fa;f[h>>2]=aa+8}aa=S+1|0;if(O&(aa|0)==(d|0))break;else va=aa}R=R+1|0;if(R>>>0>=T>>>0)break;else S=va}S=f[o>>2]|0;if(S|0){R=o+4|0;O=f[R>>2]|0;if((O|0)==(S|0))wa=S;else{P=O;while(1){O=P+-12|0;f[R>>2]=O;N=f[O>>2]|0;if(!N)xa=O;else{O=P+-8|0;i=f[O>>2]|0;if((i|0)!=(N|0))f[O>>2]=i+(~((i+-8-N|0)>>>3)<<3);O5b(N);xa=f[R>>2]|0}if((xa|0)==(S|0))break;else P=xa}wa=f[o>>2]|0}O5b(wa)}}f[B>>2]=1124024333;P=B+4|0;f[P>>2]=2;S=B+8|0;R=f[h>>2]|0;N=f[y>>2]|0;i=R-N|0;f[S>>2]=i>>3;f[B+12>>2]=1;O=B+16|0;j=B+40|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;f[O+16>>2]=0;f[O+20>>2]=0;f[j>>2]=S;S=B+48|0;Q=B+44|0;f[Q>>2]=S;f[S>>2]=0;C=B+52|0;f[C>>2]=0;k=N;if((k|0)!=(R|0)){f[C>>2]=8;f[S>>2]=8;f[O>>2]=k;f[B+20>>2]=k;k=N+i|0;f[B+24>>2]=k;f[B+28>>2]=k}if(MM(c)|0)ya=BL(c,-1)|0;else ya=5;OJ(B,c,ya,1.0,0.0);k=B+36|0;i=f[k>>2]|0;do if(i|0){N=i+12|0;C=f[N>>2]|0;f[N>>2]=C+-1;if((C|0)!=1)break;kL(B)}while(0);f[k>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[P>>2]|0)>0){i=f[j>>2]|0;C=0;do{f[i+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[P>>2]|0))}P=f[Q>>2]|0;if((P|0)==(S|0))break;UC(P)}while(0);B=f[y>>2]|0;if(B|0){y=f[h>>2]|0;if((y|0)!=(B|0))f[h>>2]=y+(~((y+-8-B|0)>>>3)<<3);O5b(B)}B=x+36|0;y=f[B>>2]|0;if(y|0?(h=y+12|0,y=f[h>>2]|0,f[h>>2]=y+-1,(y|0)==1):0)kL(x);f[B>>2]=0;B=x+16|0;y=x+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[y>>2]|0)>0){B=f[x+40>>2]|0;h=0;do{f[B+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[y>>2]|0))}y=f[x+44>>2]|0;if((y|0)!=(x+48|0))UC(y);y=f[w>>2]|0;if(y|0){w=f[v>>2]|0;if((w|0)!=(y|0))f[v>>2]=w+(~((w+-4-y|0)>>>2)<<2);O5b(y)}}else U=20}else U=20;if((U|0)==20)$L(c);c=t+36|0;U=f[c>>2]|0;if(U|0?(y=U+12|0,U=f[y>>2]|0,f[y>>2]=U+-1,(U|0)==1):0)kL(t);f[c>>2]=0;c=t+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[G>>2]|0)>0){c=f[K>>2]|0;K=0;do{f[c+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[G>>2]|0))}G=f[J>>2]|0;if((G|0)!=(H|0))UC(G);G=s+36|0;H=f[G>>2]|0;if(H|0?(J=H+12|0,H=f[J>>2]|0,f[J>>2]=H+-1,(H|0)==1):0)kL(s);f[G>>2]=0;G=s+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[a>>2]|0)>0){G=f[D>>2]|0;D=0;do{f[G+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[a>>2]|0))}a=f[F>>2]|0;if((a|0)!=(I|0))UC(a);a=r+36|0;I=f[a>>2]|0;if(I|0?(F=I+12|0,I=f[F>>2]|0,f[F>>2]=I+-1,(I|0)==1):0)kL(r);f[a>>2]=0;a=r+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[a>>2]|0)>0){L=f[r+40>>2]|0;I=0;do{f[L+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[a>>2]|0))}a=f[r+44>>2]|0;if((a|0)!=(r+48|0))UC(a);if(!(f[q+4>>2]|0)){u=m;return}u=m;return}function D2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function E2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>2;switch(k|0){case 2:{l=5;break a;break}case 3:{l=8;break a;break}case 4:{l=24;break a;break}case 5:{l=25;break a;break}case 1:case 0:{l=89;break a;break}default:{}}if((j|0)<124){l=27;break a}m=h+(((k|0)/2|0)<<2)|0;do if((j|0)>3996){o=(k|0)/4|0;p=I2(h,h+(o<<2)|0,m,m+(o<<2)|0,e,c)|0}else{o=f[m>>2]|0;q=f[h>>2]|0;r=+n[o>>2];s=+n[q>>2];t=o;u=q;if(!(r>s))if(r<s)v=0;else v=o>>>0>q>>>0;else v=1;w=f[e>>2]|0;x=+n[w>>2];y=w;if(!(x>r))if(x<r)z=0;else z=w>>>0>o>>>0;else z=1;if(!v){if(!z){p=0;break}f[m>>2]=y;f[e>>2]=t;o=f[m>>2]|0;w=f[h>>2]|0;r=+n[o>>2];x=+n[w>>2];A=w;B=o;if(!(r>x)?o>>>0<=w>>>0|r<x:0){p=1;break}f[h>>2]=B;f[m>>2]=A;p=2;break}if(z){f[h>>2]=y;f[e>>2]=u;p=1;break}f[h>>2]=t;f[m>>2]=u;t=f[e>>2]|0;x=+n[t>>2];y=t;if(!(x>s)?t>>>0<=q>>>0|x<s:0){p=1;break}f[m>>2]=y;f[e>>2]=u;p=2}while(0);C=f[h>>2]|0;k=f[m>>2]|0;s=+n[C>>2];x=+n[k>>2];if(s>x){D=e;E=p;break}if(C>>>0<=k>>>0|s<x)F=e;else{D=e;E=p;break}while(1){F=F+-4|0;if((h|0)==(F|0))break;G=f[F>>2]|0;r=+n[G>>2];if(r>x){l=67;break b}if(!(G>>>0<=k>>>0|r<x)){l=67;break b}}k=h+4|0;j=f[e>>2]|0;x=+n[j>>2];u=j;if(!(s>x)?C>>>0<=j>>>0|s<x:0){if((k|0)==(e|0)){l=89;break a}else H=k;while(1){I=f[H>>2]|0;x=+n[I>>2];if(s>x)break;if(!(C>>>0<=I>>>0|s<x))break;j=H+4|0;if((j|0)==(e|0)){l=89;break a}else H=j}f[H>>2]=u;f[e>>2]=I;J=H+4|0}else J=k;if((J|0)==(e|0)){l=89;break a}else{K=e;L=J}while(1){j=f[h>>2]|0;y=f[L>>2]|0;s=+n[j>>2];x=+n[y>>2];c:do if(s>x)M=L;else{q=L;r=x;t=y;while(1){if(!(j>>>0<=t>>>0|s<r)){M=q;break c}A=q+4|0;t=f[A>>2]|0;r=+n[t>>2];if(s>r){M=A;break}else q=A}}while(0);y=K;while(1){q=y;y=y+-4|0;N=f[y>>2]|0;x=+n[N>>2];if(s>x){y=y;continue}if(j>>>0<=N>>>0|s<x)break}if(M>>>0>=y>>>0){h=M;continue b}j=f[M>>2]|0;f[M>>2]=N;f[y>>2]=j;K=y;L=M+4|0}}if((l|0)==67){l=0;f[h>>2]=G;f[F>>2]=C;D=F;E=p+1|0}k=h+4|0;d:do if(k>>>0<D>>>0){u=m;j=D;q=k;t=E;while(1){A=f[u>>2]|0;s=+n[A>>2];B=q;while(1){O=f[B>>2]|0;x=+n[O>>2];if(!(x>s)?O>>>0<=A>>>0|x<s:0)break;B=B+4|0}y=O;w=j;do{w=w+-4|0;P=f[w>>2]|0;x=+n[P>>2];if(x>s)break}while(P>>>0<=A>>>0|x<s);if(B>>>0>w>>>0){Q=u;R=t;S=B;break d}f[B>>2]=P;f[w>>2]=y;u=(u|0)==(B|0)?w:u;j=w;q=B+4|0;t=t+1|0}}else{Q=m;R=E;S=k}while(0);do if((S|0)==(Q|0))T=R;else{k=f[Q>>2]|0;t=f[S>>2]|0;s=+n[k>>2];x=+n[t>>2];q=t;j=k;if(!(s>x)?!(k>>>0>t>>>0&!(s<x)):0){T=R;break}f[S>>2]=j;f[Q>>2]=q;T=R+1|0}while(0);if(!T){U=K2(h,S,c)|0;q=S+4|0;if(K2(q,a,c)|0){l=88;break}if(U){g=q;continue}}q=S;if((q-i|0)>=(b-q|0)){l=87;break}E2(h,S,c);g=S+4|0}if((l|0)==87){l=0;E2(S+4|0,a,c);d=h;a=S;continue}else if((l|0)==88){l=0;if(U){l=89;break}else{d=h;a=S;continue}}}if((l|0)==5){S=f[e>>2]|0;d=f[h>>2]|0;x=+n[S>>2];s=+n[d>>2];U=d;i=S;if(!(x>s)?S>>>0<=d>>>0|x<s:0)return;f[h>>2]=i;f[e>>2]=U;return}else if((l|0)==8){U=h+4|0;i=f[U>>2]|0;d=f[h>>2]|0;s=+n[i>>2];x=+n[d>>2];S=i;T=d;if(!(s>x))if(s<x)V=0;else V=i>>>0>d>>>0;else V=1;R=f[e>>2]|0;r=+n[R>>2];Q=R;if(!(r>s))if(r<s)W=0;else W=R>>>0>i>>>0;else W=1;if(!V){if(!W)return;f[U>>2]=Q;f[e>>2]=S;V=f[U>>2]|0;i=f[h>>2]|0;s=+n[V>>2];r=+n[i>>2];R=i;E=V;if(!(s>r)?V>>>0<=i>>>0|s<r:0)return;f[h>>2]=E;f[U>>2]=R;return}if(W){f[h>>2]=Q;f[e>>2]=T;return}f[h>>2]=S;f[U>>2]=T;S=f[e>>2]|0;r=+n[S>>2];Q=S;if(!(r>x)?S>>>0<=d>>>0|r<x:0)return;f[U>>2]=Q;f[e>>2]=T;return}else if((l|0)==24){H2(h,h+4|0,h+8|0,e,c)|0;return}else if((l|0)==25){I2(h,h+4|0,h+8|0,h+12|0,e,c)|0;return}else if((l|0)==27){J2(h,a,c);return}else if((l|0)==89)return}function F2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)c4b(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>2;m=k>>3>>>0<268435455?(l>>>0<h>>>0?h:l):536870911;do if(m)if(m>>>0>536870911){l=ze(8)|0;T5b(l,477177);f[l>>2]=149528;If(l|0,25408,1411)}else{n=L5b(m<<3)|0;break}else n=0;while(0);l=n+(g<<3)|0;h=n+(m<<3)|0;f[l>>2]=f[b>>2];f[n+(g<<3)+4>>2]=f[b+4>>2];b=l+8|0;if((j|0)==(i|0))o=l;else{g=j+-8-e|0;n=j;j=l;do{m=j;j=j+-8|0;k=n;n=n+-8|0;f[j>>2]=f[n>>2];f[m+-4>>2]=f[k+-4>>2]}while((n|0)!=(i|0));o=l+(~(g>>>3)<<3)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;O5b(e);return}function G2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>357913941)c4b(a);d=b*12|0;e=L5b(d)|0;f[a>>2]=e;g=e+(b*12|0)|0;f[a+8>>2]=g;Nac(e|0,0,d|0)|0;f[c>>2]=g;return}function H2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[b>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h>i))if(h<i)l=0;else l=e>>>0>g>>>0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o>h))if(o<h)q=0;else q=m>>>0>e>>>0;else q=1;do if(!l)if(q){f[b>>2]=p;f[c>>2]=j;r=f[b>>2]|0;s=f[a>>2]|0;h=+n[r>>2];o=+n[s>>2];t=s;u=r;if(!(h>o)?r>>>0<=s>>>0|h<o:0){v=1;w=e;x=j;break}f[a>>2]=u;f[b>>2]=t;t=f[c>>2]|0;v=2;w=t;x=t}else{v=0;w=m;x=p}else{if(q){f[a>>2]=p;f[c>>2]=k;v=1;w=g;x=k;break}f[a>>2]=j;f[b>>2]=k;t=f[c>>2]|0;o=+n[t>>2];u=t;if(!(o>i)?t>>>0<=g>>>0|o<i:0){v=1;w=t;x=u;break}f[b>>2]=u;f[c>>2]=k;v=2;w=g;x=k}while(0);k=f[d>>2]|0;i=+n[k>>2];o=+n[w>>2];g=k;if(!(i>o)?k>>>0<=w>>>0|i<o:0){y=v;return y|0}f[c>>2]=g;f[d>>2]=x;x=f[c>>2]|0;d=f[b>>2]|0;o=+n[x>>2];i=+n[d>>2];g=d;w=x;if(!(o>i)?x>>>0<=d>>>0|o<i:0){y=v+1|0;return y|0}f[b>>2]=w;f[c>>2]=g;g=f[b>>2]|0;c=f[a>>2]|0;i=+n[g>>2];o=+n[c>>2];w=c;d=g;if(!(i>o)?!(g>>>0>c>>>0&!(i<o)):0){y=v+2|0;return y|0}f[a>>2]=d;f[b>>2]=w;y=v+3|0;return y|0}function I2(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0.0,k=0.0,l=0,m=0,o=0;h=H2(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=+n[g>>2];k=+n[i>>2];l=i;m=g;if(!(j>k)?g>>>0<=i>>>0|j<k:0){o=h;return o|0}f[d>>2]=m;f[e>>2]=l;l=f[d>>2]|0;e=f[c>>2]|0;k=+n[l>>2];j=+n[e>>2];m=e;i=l;if(!(k>j)?l>>>0<=e>>>0|k<j:0){o=h+1|0;return o|0}f[c>>2]=i;f[d>>2]=m;m=f[c>>2]|0;d=f[b>>2]|0;j=+n[m>>2];k=+n[d>>2];i=d;e=m;if(!(j>k)?m>>>0<=d>>>0|j<k:0){o=h+2|0;return o|0}f[b>>2]=e;f[c>>2]=i;i=f[b>>2]|0;c=f[a>>2]|0;k=+n[i>>2];j=+n[c>>2];e=c;d=i;if(!(k>j)?!(i>>>0>c>>>0&!(k<j)):0){o=h+3|0;return o|0}f[a>>2]=d;f[b>>2]=e;o=h+4|0;return o|0}function J2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h>i))if(h<i)l=0;else l=e>>>0>g>>>0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o>h))if(o<h)q=0;else q=m>>>0>e>>>0;else q=1;do if(!l)if(q){f[d>>2]=p;f[c>>2]=j;if(!(o>i)?m>>>0<=g>>>0|o<i:0){r=j;s=e;break}f[a>>2]=p;f[d>>2]=k;r=j;s=e}else{r=p;s=m}else{if(q){f[a>>2]=p;f[c>>2]=k;r=k;s=g;break}f[a>>2]=j;f[d>>2]=k;if(!(o>i)?m>>>0<=g>>>0|o<i:0){r=p;s=m;break}f[d>>2]=p;f[c>>2]=k;r=k;s=g}while(0);g=a+12|0;if((g|0)==(b|0))return;else{t=g;u=c;v=s;w=r}while(1){r=f[t>>2]|0;i=+n[r>>2];o=+n[v>>2];s=r;if(!(!(i>o)?r>>>0<=v>>>0|i<o:0)){f[t>>2]=w;a:do if((u|0)==(a|0))x=u;else{c=u;g=u;while(1){k=g;g=c+-4|0;p=f[g>>2]|0;o=+n[p>>2];d=p;if(!(i>o)?r>>>0<=p>>>0|i<o:0){x=k;break a}f[k>>2]=d;if((g|0)==(a|0)){x=g;break}else c=g}}while(0);f[x>>2]=s}r=t+4|0;if((r|0)==(b|0))break;g=f[t>>2]|0;c=t;t=r;v=g;w=g;u=c}return}function K2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=g;k=e;if(!(h>i)?e>>>0<=g>>>0|h<i:0){l=1;return l|0}f[a>>2]=k;f[d>>2]=j;l=1;return l|0}case 3:{j=a+4|0;d=b+-4|0;k=f[j>>2]|0;g=f[a>>2]|0;i=+n[k>>2];h=+n[g>>2];e=k;m=g;if(!(i>h))if(i<h)o=0;else o=k>>>0>g>>>0;else o=1;p=f[d>>2]|0;q=+n[p>>2];r=p;if(!(q>i))if(q<i)s=0;else s=p>>>0>k>>>0;else s=1;if(!o){if(!s){l=1;return l|0}f[j>>2]=r;f[d>>2]=e;o=f[j>>2]|0;k=f[a>>2]|0;i=+n[o>>2];q=+n[k>>2];p=k;t=o;if(!(i>q)?o>>>0<=k>>>0|i<q:0){l=1;return l|0}f[a>>2]=t;f[j>>2]=p;l=1;return l|0}if(s){f[a>>2]=r;f[d>>2]=m;l=1;return l|0}f[a>>2]=e;f[j>>2]=m;e=f[d>>2]|0;q=+n[e>>2];r=e;if(!(q>h)?e>>>0<=g>>>0|q<h:0){l=1;return l|0}f[j>>2]=r;f[d>>2]=m;l=1;return l|0}case 4:{H2(a,a+4|0,a+8|0,b+-4|0,c)|0;l=1;return l|0}case 5:{I2(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;l=1;return l|0}case 1:case 0:{l=1;return l|0}default:{c=a+8|0;m=a+4|0;d=f[m>>2]|0;r=f[a>>2]|0;h=+n[d>>2];q=+n[r>>2];j=d;g=r;if(!(h>q))if(h<q)u=0;else u=d>>>0>r>>>0;else u=1;e=f[c>>2]|0;i=+n[e>>2];s=e;if(!(i>h))if(i<h)v=0;else v=e>>>0>d>>>0;else v=1;do if(!u)if(v){f[m>>2]=s;f[c>>2]=j;if(!(i>q)?e>>>0<=r>>>0|i<q:0){w=d;break}f[a>>2]=s;f[m>>2]=g;w=d}else w=e;else{if(v){f[a>>2]=s;f[c>>2]=g;w=r;break}f[a>>2]=j;f[m>>2]=g;if(!(i>q)?e>>>0<=r>>>0|i<q:0){w=e;break}f[m>>2]=s;f[c>>2]=g;w=r}while(0);r=a+12|0;a:do if((r|0)==(b|0)){x=1;y=0}else{g=r;s=0;m=c;e=w;while(1){j=f[g>>2]|0;q=+n[j>>2];i=+n[e>>2];v=j;if(!(q>i)?j>>>0<=e>>>0|q<i:0)z=s;else{f[g>>2]=f[m>>2];b:do if((m|0)==(a|0))A=m;else{d=m;u=m;while(1){p=u;u=d+-4|0;t=f[u>>2]|0;i=+n[t>>2];k=t;if(!(q>i)?j>>>0<=t>>>0|q<i:0){A=p;break b}f[p>>2]=k;if((u|0)==(a|0)){A=u;break}else d=u}}while(0);f[A>>2]=v;j=s+1|0;if((j|0)==8){x=0;y=(g+4|0)==(b|0);break a}else z=j}j=g+4|0;if((j|0)==(b|0)){x=1;y=0;break a}u=f[g>>2]|0;d=g;g=j;s=z;e=u;m=d}}while(0);l=y|x;return l|0}}return 0}function L2(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;C2(a,b,c,d,e,f,g,3,h,i);return}function M2(){$V(507044,231874,713,1474,557,278,714);zd(1467,507044,x|0)|0;return}function N2(a){a=a|0;var b=0;if((a|0)!=0?(f[a>>2]&-65536|0)==1111818240:0)b=(f[a+4>>2]|0)!=0;else b=0;return b&1|0}function O2(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;if(!a){f[d>>2]=0;f[d+4>>2]=0;bO(-27,d,232374,231932,2903);bD(d)}e=f[a>>2]|0;if(!e){u=c;return}if((f[e>>2]&-65536|0)==1111818240?(g=e+4|0,(f[g>>2]|0)!=0):0)h=g;else{f[d>>2]=0;f[d+4>>2]=0;g=aD(d,24)|0;i=232073;j=g+24|0;do{b[g>>0]=b[i>>0]|0;g=g+1|0;i=i+1|0}while((g|0)<(j|0));bO(-5,d,232374,231932,2910);bD(d);h=e+4|0}f[a>>2]=0;a=f[h>>2]|0;if((a|0)!=0?(f[a>>2]&-65536|0)==1111752704:0)vQ(h);else{yQ(a);f[h>>2]=0}h=e+264|0;a=f[h>>2]|0;if(a|0){WC(a);f[h>>2]=0}WC(e);u=c;return}function P2(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+272|0;e=d+136|0;g=d+8|0;h=d;i=VC(544)|0;j=MV(a,c,365923)|0;a:do if(!j)k=0;else switch(f[j>>2]&7){case 1:{k=f[j+8>>2]|0;break a;break}case 2:{k=MVb(+p[j+8>>3])|0;break a;break}default:{k=2147483647;break a}}while(0);j=MV(a,c,232265)|0;b:do if(!j)l=0;else switch(f[j>>2]&7){case 1:{l=f[j+8>>2]|0;break b;break}case 2:{l=MVb(+p[j+8>>3])|0;break b;break}default:{l=2147483647;break b}}while(0);j=MV(a,c,232276)|0;c:do if(!j)m=0;else switch(f[j>>2]&7){case 1:{m=f[j+8>>2]|0;break c;break}case 2:{m=MVb(+p[j+8>>3])|0;break c;break}default:{m=2147483647;break c}}while(0);j=(l|0)!=0;l=(m|0)!=0;f[i>>2]=k|(j?1024:0)|(l?2048:0)|1111818240;do if(!k){m=VV(a,MV(a,c,232288)|0,0)|0;f[e>>2]=m;if(((m|0)!=0?(f[m>>2]&-65536|0)==1111687168:0)?(f[m+16>>2]|0)!=0:0){n=m;o=m}else{f[h>>2]=0;f[h+4>>2]=0;q=aD(h,16)|0;r=232297;s=q+16|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-2,h,232314,231932,4008);bD(h);m=f[e>>2]|0;n=m;o=m}m=f[n+4>>2]|0;if((m|0)>0){t=n+4|0;v=0;do{f[g+(v<<2)>>2]=f[n+20+(v<<3)>>2];v=v+1|0;w=f[t>>2]|0}while((v|0)<(w|0));x=w}else x=m;v=i+268|0;mQ(v,x,g,f[n>>2]|0,f[n+16>>2]|0)|0;f[i+4>>2]=v;f[i+276>>2]=f[n+8>>2];d:do if(o|0){v=f[o>>2]&-65536;if((v|0)>=1111687168){switch(v|0){case 1111687168:break;default:break d}if(!(f[o+16>>2]|0))break;t=f[o+8>>2]|0;if(!t)break;f[t>>2]=(f[t>>2]|0)+1;break}switch(v|0){case 1111621632:break;default:break d}if((((f[o+24>>2]|0)>0?(f[o+20>>2]|0)>0:0)?f[o+16>>2]|0:0)?(v=f[o+8>>2]|0,v|0):0)f[v>>2]=(f[v>>2]|0)+1}while(0);kQ(e)}else{m=VV(a,MV(a,c,232292)|0,0)|0;f[i+4>>2]=m;if(m|0?(f[m>>2]&-65536|0)==1111752704:0)break;f[e>>2]=0;f[e+4>>2]=0;q=aD(e,22)|0;r=232326;s=q+22|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-2,e,232314,231932,4029);bD(e)}while(0);if(!l){u=d;return i|0}l=CQ(f[i+4>>2]|0,e)|0;o=(l|0)>0;if(o){n=0;x=0;while(1){k=n+1+(f[e+(x<<2)>>2]|0)|0;x=x+1|0;if((x|0)==(l|0)){y=k;break}else n=k}}else y=0;n=MV(a,c,430291)|0;if(!n){f[h>>2]=0;f[h+4>>2]=0;q=aD(h,24)|0;r=232349;s=q+24|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-2,h,232314,231932,4046);bD(h)}PV(a,n,g);if(!j){j=VC(y+l<<2)|0;y=i+264|0;f[y>>2]=j;if(o?(n=j+(l<<2)|0,f[j>>2]=n,QV(a,g,(f[e>>2]|0)+1|0,n,476473),(l|0)!=1):0){j=n;n=e;h=1;do{j=j+((f[n>>2]|0)+1<<2)|0;f[(f[y>>2]|0)+(h<<2)>>2]=j;n=e+(h<<2)|0;QV(a,g,(f[n>>2]|0)+1|0,j,476473);h=h+1|0}while((h|0)!=(l|0))}}else{if(o){o=i+8|0;h=0;do{QV(a,g,2,o+(h<<3)|0,476473);h=h+1|0}while((h|0)!=(l|0))}f[i+264>>2]=0}u=d;return i|0}function Q2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+176|0;e=d+160|0;g=d+8|0;h=d+152|0;i=d+144|0;j=d+136|0;k=d;f[h>>2]=0;f[h+4>>2]=0;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];xV(a,b,6,231874,e);b=f[c>>2]|0;h=b&1024;l=(h|0)==0;m=b&2048;n=(m|0)==0;RV(a,365923,b&1);RV(a,232265,h>>>10);RV(a,232276,m>>>11);m=c+4|0;h=f[m>>2]|0;if((h|0)!=0?(f[h>>2]&-65536|0)==1111752704:0){f[j>>2]=0;f[j+4>>2]=0;f[e>>2]=f[j>>2];f[e+4>>2]=f[j+4>>2];bW(a,232292,h,e)}else{f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];bW(a,232288,c+268|0,e)}if(n){uT(a);u=d;return}n=CQ(f[m>>2]|0,g)|0;f[k>>2]=0;f[k+4>>2]=0;f[e>>2]=f[k>>2];f[e+4>>2]=f[k+4>>2];xV(a,430291,13,0,e);e=(n|0)>0;if(l){if(e){l=c+264|0;k=0;do{yV(a,f[(f[l>>2]|0)+(k<<2)>>2]|0,(f[g+(k<<2)>>2]|0)+1|0,476473);k=k+1|0}while((k|0)!=(n|0))}}else if(e){e=c+8|0;c=0;do{yV(a,e+(c<<3)|0,2,476473);c=c+1|0}while((c|0)!=(n|0))}uT(a);uT(a);u=d;return}function R2(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[c>>2]=0;S2(a,c);u=b;return f[c>>2]|0}function S2(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+256|0;e=d+128|0;g=d;if(!c){f[e>>2]=0;f[e+4>>2]=0;h=aD(e,34)|0;i=231886;j=h+34|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-27,e,231921,231932,3293);bD(e)}k=f[c>>2]|0;do if(((a|0)!=0?(f[a>>2]&-65536|0)==1111818240:0)?(l=a+4|0,m=f[l>>2]|0,(m|0)!=0):0){if(k|0){if((f[k>>2]&-65536|0)!=1111818240){n=9;break}if(!(f[k+4>>2]|0)){n=9;break}}o=l;p=m;q=e;n=11}else n=9;while(0);if((n|0)==9){f[e>>2]=0;f[e+4>>2]=0;h=aD(e,27)|0;i=232006;j=h+27|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-5,e,231921,231932,3298);bD(e);i=a+4|0;h=f[i>>2]|0;if(!h){r=i;s=0;t=e}else{o=i;p=h;q=e;n=11}}if((n|0)==11){r=o;s=(f[p>>2]&-65536|0)==1111752704;t=q}q=CQ(f[r>>2]|0,e)|0;do if(k){t=f[k+4>>2]|0;if(!t){if(s){n=22;break}}else if(s^(f[t>>2]&-65536|0)==1111752704){n=22;break}if((q|0)!=(CQ(t,g)|0)){n=22;break}a:do if((q|0)>0){t=0;while(1){if((f[e+(t<<2)>>2]|0)!=(f[g+(t<<2)>>2]|0)){v=t;break a}p=t+1|0;if((p|0)<(q|0))t=p;else{v=p;break}}}else v=0;while(0);if((v|0)==(q|0))w=k;else n=22}else n=22;while(0);if((n|0)==22){O2(c);n=T2(q,e,s&1,0,0)|0;f[c>>2]=n;w=n}n=f[a>>2]|0;if(!(n&2048)){x=f[r>>2]|0;y=w+4|0;z=f[y>>2]|0;$P(x,z,0);u=d;return}if(!(n&1024))A=f[a+264>>2]|0;else{if((q|0)>0){c=0;do{f[g+(c<<2)>>2]=a+8+(c<<3);c=c+1|0}while((c|0)!=(q|0))}A=g}U2(w,A,n>>>10&1);x=f[r>>2]|0;y=w+4|0;z=f[y>>2]|0;$P(x,z,0);u=d;return}function T2(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;if(a>>>0>32){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,36)|0;k=232171;l=j+36|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-19,i,232208,231932,2844);bD(i)}if(!c){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,20)|0;k=232221;l=j+20|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-9,i,232208,231932,2847);bD(i)}m=VC(544)|0;f[m>>2]=((g|0)==0?1111818240:1111819264)|d&1;f[m+264>>2]=0;n=m+4|0;f[n>>2]=0;switch(d|0){case 0:{d=m+268|0;o=mQ(d,a,c,5,0)|0;f[n>>2]=o;iQ(d);break}case 1:{d=uQ(a,c,5)|0;f[n>>2]=d;break}default:{f[i>>2]=0;f[i+4>>2]=0;j=aD(i,22)|0;k=232242;l=j+22|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-5,i,232208,231932,2863);bD(i)}}if(!e){u=h;return m|0}U2(m,e,g);u=h;return m|0}function U2(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0;e=u;u=u+144|0;g=e+8|0;h=e;if(!c){f[h>>2]=0;f[h+4>>2]=0;i=aD(h,19)|0;j=232034;k=i+19|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-27,h,232054,231932,3363);bD(h)}if(((a|0)!=0?(f[a>>2]&-65536|0)==1111818240:0)?(l=f[a+4>>2]|0,(l|0)!=0):0)m=l;else{f[h>>2]=0;f[h+4>>2]=0;i=aD(h,24)|0;j=232073;k=i+24|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-5,h,232054,231932,3366);bD(h);m=f[a+4>>2]|0}l=CQ(m,g)|0;m=(l|0)>0;if(m){o=0;p=0;while(1){q=o+1+(f[g+(p<<2)>>2]|0)|0;p=p+1|0;if((p|0)==(l|0)){r=q;break}else o=q}}else r=0;if(d|0){if(m){d=h+4|0;o=0;do{p=c+(o<<2)|0;q=f[p>>2]|0;if(!q){f[h>>2]=0;f[d>>2]=0;i=aD(h,32)|0;j=232098;k=i+32|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-27,h,232054,231932,3377);bD(h);s=f[p>>2]|0}else s=q;f[a+8+(o<<3)>>2]=f[s>>2];f[a+8+(o<<3)+4>>2]=f[s+4>>2];o=o+1|0}while((o|0)<(l|0))}t=f[a>>2]|3072;v=a;f[v>>2]=t;u=e;return}o=a+264|0;s=f[o>>2]|0;if(!s){d=VC(r+l<<2)|0;f[o>>2]=d;w=d}else w=s;if(m){m=h+4|0;s=h+4|0;d=w+(l<<2)|0;w=0;while(1){r=c+(w<<2)|0;if(!(f[r>>2]|0)){f[h>>2]=0;f[m>>2]=0;i=aD(h,32)|0;j=232098;k=i+32|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-27,h,232054,231932,3401);bD(h)}q=g+(w<<2)|0;p=f[q>>2]|0;if((p|0)<0)x=p;else{y=-3402823466385288598117041.0e14;z=0;A=p;while(1){B=y;y=+n[(f[r>>2]|0)+(z<<2)>>2];if(!(y<=B))C=A;else{f[h>>2]=0;f[s>>2]=0;i=aD(h,39)|0;j=232131;k=i+39|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-211,h,232054,231932,3407);bD(h);C=f[q>>2]|0}n[d+(z<<2)>>2]=y;if((z|0)>=(C|0)){x=C;break}else{z=z+1|0;A=C}}}f[(f[o>>2]|0)+(w<<2)>>2]=d;w=w+1|0;if((w|0)>=(l|0))break;else d=d+(x+1<<2)|0}}t=f[a>>2]&-3073|2048;v=a;f[v>>2]=t;u=e;return}function V2(a,c,d,e,g,i,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0.0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0;q=u;u=u+1568|0;r=q;s=q+536|0;t=q+408|0;v=q+344|0;w=q+288|0;x=q+352|0;y=q+232|0;z=q+176|0;A=q+160|0;B=q+148|0;C=q+136|0;D=q+128|0;dQ(v,51644);do if((yM(e)|0)==65536){E=f[e+4>>2]|0;f[w>>2]=f[E>>2];F=w+4|0;G=E+4|0;f[F>>2]=f[G>>2];H=w+8|0;f[H>>2]=f[E+8>>2];f[w+12>>2]=f[E+12>>2];f[w+16>>2]=f[E+16>>2];f[w+20>>2]=f[E+20>>2];f[w+24>>2]=f[E+24>>2];f[w+28>>2]=f[E+28>>2];f[w+32>>2]=f[E+32>>2];I=f[E+36>>2]|0;f[w+36>>2]=I;f[w+40>>2]=H;H=w+48|0;J=w+44|0;f[J>>2]=H;f[H>>2]=0;f[w+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[E+44>>2]|0;H=f[J>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];break}else{f[F>>2]=0;jL(w,E);break}}else yL(w,e,-1);while(0);e=(i|0)>0;if(!(e&(k|0)!=0)){f[r>>2]=0;f[r+4>>2]=0;K=aD(r,20)|0;L=232388;M=K+20|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));bO(-215,r,232409,231932,1457);bD(r)}do if((yM(g)|0)==65536){E=f[g+4>>2]|0;f[x>>2]=f[E>>2];F=x+4|0;G=E+4|0;f[F>>2]=f[G>>2];H=x+8|0;f[H>>2]=f[E+8>>2];f[x+12>>2]=f[E+12>>2];J=x+16|0;f[J>>2]=f[E+16>>2];f[x+20>>2]=f[E+20>>2];f[x+24>>2]=f[E+24>>2];f[x+28>>2]=f[E+28>>2];f[x+32>>2]=f[E+32>>2];I=x+36|0;N=f[E+36>>2]|0;f[I>>2]=N;f[x+40>>2]=H;H=x+48|0;O=x+44|0;f[O>>2]=H;f[H>>2]=0;f[x+52>>2]=0;if(N|0){H=N+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[E+44>>2]|0;H=f[O>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];P=O;Q=I;R=J;break}else{f[F>>2]=0;jL(x,E);P=O;Q=I;R=J;break}}else{yL(x,g,-1);P=x+44|0;Q=x+36|0;R=x+16|0}while(0);J=f[R>>2]|0;I=f[Q>>2]|0;if(I|0?(O=I+12|0,I=f[O>>2]|0,f[O>>2]=I+-1,(I|0)==1):0)kL(x);f[Q>>2]=0;Q=x+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[Q>>2]|0)>0){R=f[x+40>>2]|0;I=0;do{f[R+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[Q>>2]|0))}Q=f[P>>2]|0;if((Q|0)!=(x+48|0))UC(Q);wL(g,i,k,5,-1,0,0);do if((yM(g)|0)==65536){k=f[g+4>>2]|0;f[y>>2]=f[k>>2];Q=y+4|0;x=k+4|0;f[Q>>2]=f[x>>2];P=y+8|0;f[P>>2]=f[k+8>>2];I=y+12|0;f[I>>2]=f[k+12>>2];R=y+16|0;f[R>>2]=f[k+16>>2];O=y+20|0;f[O>>2]=f[k+20>>2];E=y+24|0;f[E>>2]=f[k+24>>2];F=y+28|0;f[F>>2]=f[k+28>>2];G=y+32|0;f[G>>2]=f[k+32>>2];H=y+36|0;N=f[k+36>>2]|0;f[H>>2]=N;f[y+40>>2]=P;S=y+48|0;T=y+44|0;f[T>>2]=S;f[S>>2]=0;f[y+52>>2]=0;if(N|0){S=N+12|0;f[S>>2]=(f[S>>2]|0)+1}if((f[x>>2]|0)<3){x=f[k+44>>2]|0;S=f[T>>2]|0;f[S>>2]=f[x>>2];f[S+4>>2]=f[x+4>>2];U=R;V=y;W=Q;X=P;Z=I;_=O;$=E;aa=F;ba=G;ca=H;da=H;break}else{f[Q>>2]=0;jL(y,k);U=R;V=y;W=Q;X=P;Z=I;_=O;$=E;aa=F;ba=G;ca=H;da=H;break}}else{yL(y,g,-1);H=y+36|0;U=y+16|0;V=y;W=y+4|0;X=y+8|0;Z=y+12|0;_=y+20|0;$=y+24|0;aa=y+28|0;ba=y+32|0;ca=H;da=H}while(0);g=f[U>>2]|0;f[z>>2]=f[V>>2];V=z+4|0;H=f[W>>2]|0;f[V>>2]=H;G=z+8|0;f[G>>2]=f[X>>2];f[z+12>>2]=f[Z>>2];Z=z+16|0;f[Z>>2]=g;f[z+20>>2]=f[_>>2];f[z+24>>2]=f[$>>2];f[z+28>>2]=f[aa>>2];f[z+32>>2]=f[ba>>2];ba=z+36|0;aa=f[da>>2]|0;f[ba>>2]=aa;da=z+40|0;f[da>>2]=G;G=z+48|0;$=z+44|0;f[$>>2]=G;f[G>>2]=0;f[z+52>>2]=0;if(!aa)ea=H;else{H=aa+12|0;f[H>>2]=(f[H>>2]|0)+1;ea=f[W>>2]|0}if((ea|0)<3){ea=f[y+44>>2]|0;H=f[$>>2]|0;f[H>>2]=f[ea>>2];f[H+4>>2]=f[ea+4>>2]}else{f[V>>2]=0;jL(z,y)}f[z>>2]=f[z>>2]&-4096|4;if((J|0)==(g|0)&o){o=r+8|0;f[o>>2]=0;f[o+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=z;OJ(y,r,4,1.0,0.0)}else{f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[r+28>>2]=0;UP(y,r)|0}f[A>>2]=0;o=A+4|0;f[o>>2]=0;f[A+8>>2]=0;f[B>>2]=0;g=B+4|0;f[g>>2]=0;f[B+8>>2]=0;f[C>>2]=0;J=C+4|0;f[J>>2]=0;f[C+8>>2]=0;f[D>>2]=0;ea=D+4|0;f[ea>>2]=0;H=w+16|0;if(f[H>>2]|0){aa=f[w+4>>2]|0;if((aa|0)<3)fa=Y(f[w+12>>2]|0,f[w+8>>2]|0)|0;else{_=f[w+40>>2]|0;X=0;F=1;while(1){E=Y(f[_+(X<<2)>>2]|0,F)|0;X=X+1|0;if((X|0)==(aa|0)){fa=E;break}else F=E}}if(!((aa|0)==0|(fa|0)==0)?f[w>>2]&4095|0:0){f[r>>2]=0;f[r+4>>2]=0;K=aD(r,72)|0;L=232418;M=K+72|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));bO(-215,r,232409,231932,1484);bD(r)}}fa=y+40|0;W2(a,c,d,w,i,f[fa>>2]|0,l,m,A,B,D,C);d=m?f[C>>2]|0:0;switch(f[a>>2]&7){case 0:{a=f[D>>2]|0;c=f[ea>>2]|0;aa=f[A>>2]|0;F=f[B>>2]|0;X=f[Z>>2]|0;_=f[aa+(i<<2)>>2]|0;E=f[F+((i<<1|1)<<2)>>2]|0;f[r>>2]=0;O=r+4|0;f[O>>2]=0;f[r+8>>2]=0;f[s>>2]=1123876864;f[s+4>>2]=0;X2(z,s,i,l,d,m,0,r);I=f[r>>2]|0;switch(i|0){case 1:{P=f[F>>2]|0;Q=f[F+4>>2]|0;Nac(s|0,0,1024)|0;a:do if(!c)ga=0;else{R=f[aa>>2]|0;k=(P|0)==1;x=P<<1;S=(a|0)<4;T=a+-4|0;if((a|0)<=0){N=a&-4;ha=Y(P,N)|0;ia=_;ja=R;ka=c;while(1){ka=ka+-1|0;do if(!ia){do if(k){if(S){la=0;ma=ja;break}else{na=0;oa=ja}while(1){pa=h[ja+(na|1)>>0]|0;qa=s+(h[oa>>0]<<2)|0;f[qa>>2]=(f[qa>>2]|0)+1;qa=s+(pa<<2)|0;f[qa>>2]=(f[qa>>2]|0)+1;qa=h[ja+(na|3)>>0]|0;pa=s+(h[ja+(na|2)>>0]<<2)|0;f[pa>>2]=(f[pa>>2]|0)+1;pa=s+(qa<<2)|0;f[pa>>2]=(f[pa>>2]|0)+1;pa=na+4|0;if((pa|0)>(T|0))break;else{na=pa;oa=ja+pa|0}}la=N;ma=ja+N|0}else{if(S){la=0;ma=ja;break}else{ra=ja;sa=0}while(1){pa=h[ra+P>>0]|0;qa=s+(h[ra>>0]<<2)|0;f[qa>>2]=(f[qa>>2]|0)+1;qa=s+(pa<<2)|0;f[qa>>2]=(f[qa>>2]|0)+1;qa=ra+x|0;pa=h[qa+P>>0]|0;ta=s+(h[qa>>0]<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;ta=s+(pa<<2)|0;f[ta>>2]=(f[ta>>2]|0)+1;sa=sa+4|0;if((sa|0)>(T|0))break;else ra=qa+x|0}la=N;ma=ja+ha|0}while(0);if((a|0)<=(la|0)){ua=ma;break}qa=Y(P,a-la|0)|0;ta=ma;pa=la;while(1){va=s+(h[ta>>0]<<2)|0;f[va>>2]=(f[va>>2]|0)+1;pa=pa+1|0;if((pa|0)==(a|0))break;else ta=ta+P|0}ua=ma+qa|0}else ua=ja;while(0);if(!ka){ga=0;break a}else{ia=ia+E|0;ja=ua+Q|0}}}ja=Y(a,P)|0;ia=a&-4;ka=Y(P,ia)|0;ha=_;N=R;ta=c;while(1){ta=ta+-1|0;do if(!ha){do if(k){if(S){wa=0;xa=N;break}else{ya=0;za=N}while(1){pa=h[N+(ya|1)>>0]|0;va=s+(h[za>>0]<<2)|0;f[va>>2]=(f[va>>2]|0)+1;va=s+(pa<<2)|0;f[va>>2]=(f[va>>2]|0)+1;va=h[N+(ya|3)>>0]|0;pa=s+(h[N+(ya|2)>>0]<<2)|0;f[pa>>2]=(f[pa>>2]|0)+1;pa=s+(va<<2)|0;f[pa>>2]=(f[pa>>2]|0)+1;pa=ya+4|0;if((pa|0)>(T|0))break;else{ya=pa;za=N+pa|0}}wa=ia;xa=N+ia|0}else{if(S){wa=0;xa=N;break}else{Aa=N;Ba=0}while(1){pa=h[Aa+P>>0]|0;va=s+(h[Aa>>0]<<2)|0;f[va>>2]=(f[va>>2]|0)+1;va=s+(pa<<2)|0;f[va>>2]=(f[va>>2]|0)+1;va=Aa+x|0;pa=h[va+P>>0]|0;Ca=s+(h[va>>0]<<2)|0;f[Ca>>2]=(f[Ca>>2]|0)+1;Ca=s+(pa<<2)|0;f[Ca>>2]=(f[Ca>>2]|0)+1;Ba=Ba+4|0;if((Ba|0)>(T|0))break;else Aa=va+x|0}wa=ia;xa=N+ka|0}while(0);if((a|0)<=(wa|0)){Da=xa;break}qa=Y(P,a-wa|0)|0;va=xa;Ca=wa;while(1){pa=s+(h[va>>0]<<2)|0;f[pa>>2]=(f[pa>>2]|0)+1;Ca=Ca+1|0;if((Ca|0)==(a|0))break;else va=va+P|0}Da=xa+qa|0}else{va=N;Ca=0;while(1){if(b[ha+Ca>>0]|0){pa=s+(h[va>>0]<<2)|0;f[pa>>2]=(f[pa>>2]|0)+1}Ca=Ca+1|0;if((Ca|0)==(a|0))break;else va=va+P|0}Da=N+ja|0}while(0);if(!ta){ga=0;break}else{ha=ha+E|0;N=Da+Q|0}}}while(0);do{Q=f[I+(ga<<2)>>2]|0;Da=X+Q|0;if(Q>>>0<1073741824)f[Da>>2]=(f[Da>>2]|0)+(f[s+(ga<<2)>>2]|0);ga=ga+1|0}while((ga|0)!=256);Ea=145;break}case 2:{ga=f[F>>2]|0;Da=f[F+4>>2]|0;Q=f[F+8>>2]|0;P=f[F+12>>2]|0;if((c|0)!=0&(a|0)>0){xa=a+-1|0;wa=Y(ga,xa)|0;Aa=Y(Q,xa)|0;xa=f[aa>>2]|0;Ba=f[aa+4>>2]|0;za=_;ya=c;while(1){ya=ya+-1|0;if(!za){ua=xa;ma=Ba;la=0;while(1){ra=(f[I+((h[ma>>0]|256)<<2)>>2]|0)+(f[I+(h[ua>>0]<<2)>>2]|0)|0;if(ra>>>0<1073741824){sa=X+ra|0;f[sa>>2]=(f[sa>>2]|0)+1}la=la+1|0;if((la|0)==(a|0))break;else{ua=ua+ga|0;ma=ma+Q|0}}}else{ma=xa;ua=Ba;la=0;while(1){do if(b[za+la>>0]|0){sa=(f[I+((h[ua>>0]|256)<<2)>>2]|0)+(f[I+(h[ma>>0]<<2)>>2]|0)|0;if(sa>>>0>=1073741824)break;ra=X+sa|0;f[ra>>2]=(f[ra>>2]|0)+1}while(0);la=la+1|0;if((la|0)==(a|0))break;else{ma=ma+ga|0;ua=ua+Q|0}}}if(!ya){Ea=144;break}else{xa=xa+wa+ga+Da|0;Ba=Ba+Aa+Q+P|0;za=za+E|0}}}else Ea=144;break}case 3:{za=f[F>>2]|0;P=f[F+4>>2]|0;Q=f[F+8>>2]|0;Aa=f[F+12>>2]|0;Ba=f[F+16>>2]|0;Da=f[F+20>>2]|0;if((c|0)!=0&(a|0)>0){ga=a+-1|0;wa=Y(Ba,ga)|0;xa=Y(Q,ga)|0;ya=Y(za,ga)|0;ga=f[aa+8>>2]|0;ua=f[aa+4>>2]|0;ma=f[aa>>2]|0;la=_;ra=c;while(1){ra=ra+-1|0;if(!la){sa=ga;oa=ua;na=ma;N=0;while(1){ha=(f[I+((h[oa>>0]|256)<<2)>>2]|0)+(f[I+(h[na>>0]<<2)>>2]|0)+(f[I+((h[sa>>0]|512)<<2)>>2]|0)|0;if(ha>>>0<1073741824){ta=X+ha|0;f[ta>>2]=(f[ta>>2]|0)+1}N=N+1|0;if((N|0)==(a|0))break;else{sa=sa+Ba|0;oa=oa+Q|0;na=na+za|0}}}else{na=ga;oa=ua;sa=ma;N=0;while(1){do if(b[la+N>>0]|0){ta=(f[I+((h[oa>>0]|256)<<2)>>2]|0)+(f[I+(h[sa>>0]<<2)>>2]|0)+(f[I+((h[na>>0]|512)<<2)>>2]|0)|0;if(ta>>>0>=1073741824)break;ha=X+ta|0;f[ha>>2]=(f[ha>>2]|0)+1}while(0);N=N+1|0;if((N|0)==(a|0))break;else{na=na+Ba|0;oa=oa+Q|0;sa=sa+za|0}}}if(!ra){Ea=144;break}else{ga=ga+wa+Ba+Da|0;ua=ua+xa+Q+Aa|0;ma=ma+ya+za+P|0;la=la+E|0}}}else Ea=144;break}default:if(!c)Ea=144;else{la=(i|0)==0;P=(a|0)>0;za=_;_=c;while(1){_=_+-1|0;do if(!za)if(P){if(e)Fa=0;else{if(!la)break;c=0;ya=f[X>>2]|0;do{ya=ya+1|0;c=c+1|0}while((c|0)!=(a|0));f[X>>2]=ya;Ea=141;break}do{c=0;ma=X;while(1){Aa=aa+(c<<2)|0;Q=f[Aa>>2]|0;xa=f[I+((h[Q>>0]|c<<8)<<2)>>2]|0;if(xa>>>0>1073741823){Ga=c;Ha=ma;break}ua=ma+xa|0;f[Aa>>2]=Q+(f[F+(c<<1<<2)>>2]|0);Q=c+1|0;if((Q|0)<(i|0)){c=Q;ma=ua}else{Ga=Q;Ha=ua;break}}do if((Ga|0)==(i|0))f[Ha>>2]=(f[Ha>>2]|0)+1;else{if((Ga|0)<(i|0))Ia=Ga;else break;do{ma=aa+(Ia<<2)|0;f[ma>>2]=(f[ma>>2]|0)+(f[F+(Ia<<1<<2)>>2]|0);Ia=Ia+1|0}while((Ia|0)!=(i|0))}while(0);Fa=Fa+1|0}while((Fa|0)!=(a|0));Ea=141}else Ea=141;else if(P){if(e)Ja=0;else{if(!la)break;ya=0;ma=f[X>>2]|0;do{ma=ma+1|0;ya=ya+1|0}while((ya|0)!=(a|0));f[X>>2]=ma;Ea=141;break}while(1){b:do if(!(b[za+Ja>>0]|0)){Ka=0;La=X}else{ya=0;c=X;while(1){ua=aa+(ya<<2)|0;Q=f[ua>>2]|0;Aa=f[I+((h[Q>>0]|ya<<8)<<2)>>2]|0;if(Aa>>>0>1073741823){Ka=ya;La=c;break b}xa=c+Aa|0;f[ua>>2]=Q+(f[F+(ya<<1<<2)>>2]|0);Q=ya+1|0;if((Q|0)<(i|0)){ya=Q;c=xa}else{Ka=Q;La=xa;break}}}while(0);do if((Ka|0)==(i|0))f[La>>2]=(f[La>>2]|0)+1;else{if((Ka|0)<(i|0))Ma=Ka;else break;do{c=aa+(Ma<<2)|0;f[c>>2]=(f[c>>2]|0)+(f[F+(Ma<<1<<2)>>2]|0);Ma=Ma+1|0}while((Ma|0)!=(i|0))}while(0);Ja=Ja+1|0;if((Ja|0)==(a|0)){Ea=141;break}}}else Ea=141;while(0);if((Ea|0)==141?(Ea=0,e):0){ma=0;do{c=aa+(ma<<2)|0;f[c>>2]=(f[c>>2]|0)+(f[F+((ma<<1|1)<<2)>>2]|0);ma=ma+1|0}while((ma|0)!=(i|0))}if(!_){Ea=144;break}else za=za+E|0}}}if((Ea|0)==144?I|0:0)Ea=145;if((Ea|0)==145){E=f[O>>2]|0;if((E|0)!=(I|0))f[O>>2]=E+(~((E+-4-I|0)>>>2)<<2);O5b(I)}break}case 2:{I=f[D>>2]|0;E=f[ea>>2]|0;O=f[A>>2]|0;za=f[B>>2]|0;_=f[Z>>2]|0;F=f[O+(i<<2)>>2]|0;aa=f[za+((i<<1|1)<<2)>>2]|0;a=i<<2;if(e){Ja=f[$>>2]|0;Vac(s|0,f[da>>2]|0,a|0)|0;Vac(t|0,Ja|0,a|0)|0}c:do if(!m){if(!l){f[r>>2]=0;f[r+4>>2]=0;K=aD(r,55)|0;L=232491;M=K+55|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));bO(-5,r,232547,231932,989);bD(r);break}if(e)Vac(r|0,l|0,a|0)|0;if(E|0){Ja=(I|0)>0;Ma=(i|0)==0;Ka=(i|0)==0;La=F;X=E;while(1){X=X+-1|0;d:do if(Ja)if(!La){if(e)Na=0;else{la=0;while(1){if(Ma)f[_>>2]=(f[_>>2]|0)+1;la=la+1|0;if((la|0)==(I|0))break d}}do{la=_;P=0;while(1){Fa=O+(P<<2)|0;Ia=f[Fa>>2]|0;Oa=+(j[Ia>>1]|0);Ga=f[r+(P<<2)>>2]|0;Ha=f[s+(P<<2)>>2]|0;ma=-1;while(1){c=ma+1|0;if(!(Oa>=+n[Ga+(c<<2)>>2])){Pa=ma;break}if((c|0)<(Ha|0))ma=c;else{Pa=c;break}}if(Pa>>>0>=Ha>>>0){Qa=la;Ra=P;break}f[Fa>>2]=Ia+(f[za+(P<<1<<2)>>2]<<1);ma=la+(Y(f[t+(P<<2)>>2]|0,Pa)|0)|0;Ga=P+1|0;if((Ga|0)<(i|0)){la=ma;P=Ga}else{Qa=ma;Ra=Ga;break}}do if((Ra|0)==(i|0))f[Qa>>2]=(f[Qa>>2]|0)+1;else{if((Ra|0)<(i|0))Sa=Ra;else break;do{P=O+(Sa<<2)|0;f[P>>2]=(f[P>>2]|0)+(f[za+(Sa<<1<<2)>>2]<<1);Sa=Sa+1|0}while((Sa|0)!=(i|0))}while(0);Na=Na+1|0}while((Na|0)!=(I|0))}else{if(e)Ta=0;else{Ia=0;while(1){if(Ka)f[_>>2]=(f[_>>2]|0)+1;Ia=Ia+1|0;if((Ia|0)==(I|0))break d}}do{e:do if(!(b[La+Ta>>0]|0)){Ua=_;Va=0}else{Ia=_;Fa=0;while(1){Ha=O+(Fa<<2)|0;P=f[Ha>>2]|0;Oa=+(j[P>>1]|0);la=f[r+(Fa<<2)>>2]|0;Ga=f[s+(Fa<<2)>>2]|0;ma=-1;while(1){c=ma+1|0;if(!(Oa>=+n[la+(c<<2)>>2])){Wa=ma;break}if((c|0)<(Ga|0))ma=c;else{Wa=c;break}}if(Wa>>>0>=Ga>>>0){Ua=Ia;Va=Fa;break e}f[Ha>>2]=P+(f[za+(Fa<<1<<2)>>2]<<1);ma=Ia+(Y(f[t+(Fa<<2)>>2]|0,Wa)|0)|0;la=Fa+1|0;if((la|0)<(i|0)){Ia=ma;Fa=la}else{Ua=ma;Va=la;break}}}while(0);do if((Va|0)==(i|0))f[Ua>>2]=(f[Ua>>2]|0)+1;else{if((Va|0)<(i|0))Xa=Va;else break;do{Fa=O+(Xa<<2)|0;f[Fa>>2]=(f[Fa>>2]|0)+(f[za+(Xa<<1<<2)>>2]<<1);Xa=Xa+1|0}while((Xa|0)!=(i|0))}while(0);Ta=Ta+1|0}while((Ta|0)!=(I|0))}while(0);if(e){Fa=0;do{Ia=O+(Fa<<2)|0;f[Ia>>2]=(f[Ia>>2]|0)+(f[za+((Fa<<1|1)<<2)>>2]<<1);Fa=Fa+1|0}while((Fa|0)!=(i|0))}if(!X)break;else La=La+aa|0}}}else switch(i|0){case 1:{Oa=+p[d>>3];Ya=+p[d+8>>3];La=f[s>>2]|0;X=f[za>>2]|0;Ka=f[za+4>>2]|0;if(!E)break c;if((I|0)<=0)break c;Ma=Y(X,I+-1|0)|0;Ja=F;Fa=f[O>>2]|0;Ia=E;while(1){Ia=Ia+-1|0;if(!Ja){la=0;ma=Fa;while(1){Za=Ya+Oa*+(j[ma>>1]|0);c=~~Za;ya=c-(+(c|0)>Za&1)|0;c=_+(ya<<2)|0;if(ya>>>0<La>>>0)f[c>>2]=(f[c>>2]|0)+1;la=la+1|0;if((la|0)==(I|0))break;else ma=ma+(X<<1)|0}}else{ma=0;la=Fa;while(1){do if(b[Ja+ma>>0]|0){Za=Ya+Oa*+(j[la>>1]|0);c=~~Za;ya=c-(+(c|0)>Za&1)|0;c=_+(ya<<2)|0;if(ya>>>0>=La>>>0)break;f[c>>2]=(f[c>>2]|0)+1}while(0);ma=ma+1|0;if((ma|0)==(I|0))break;else la=la+(X<<1)|0}}if(!Ia)break;else{Ja=Ja+aa|0;Fa=Fa+(Ma<<1)+(X<<1)+(Ka<<1)|0}}break}case 2:{Oa=+p[d>>3];Ya=+p[d+8>>3];Za=+p[d+16>>3];_a=+p[d+24>>3];Ka=f[s>>2]|0;X=f[s+4>>2]|0;Ma=f[za>>2]|0;Fa=f[za+4>>2]|0;Ja=f[za+8>>2]|0;Ia=f[za+12>>2]|0;La=f[t>>2]|0;if(!((E|0)!=0&(I|0)>0))break c;la=I+-1|0;ma=Y(Ma,la)|0;c=Y(Ja,la)|0;la=f[O>>2]|0;ya=f[O+4>>2]|0;xa=F;Q=E;while(1){Q=Q+-1|0;if(!xa){ua=la;Aa=ya;Da=0;while(1){$a=Ya+Oa*+(j[ua>>1]|0);Ba=~~$a;wa=Ba-(+(Ba|0)>$a&1)|0;$a=_a+Za*+(j[Aa>>1]|0);Ba=~~$a;ga=Ba-(+(Ba|0)>$a&1)|0;Ba=_+(Y(wa,La)|0)+(ga<<2)|0;if(wa>>>0<Ka>>>0&ga>>>0<X>>>0)f[Ba>>2]=(f[Ba>>2]|0)+1;Da=Da+1|0;if((Da|0)==(I|0))break;else{ua=ua+(Ma<<1)|0;Aa=Aa+(Ja<<1)|0}}}else{Aa=la;ua=ya;Da=0;while(1){do if(b[xa+Da>>0]|0){$a=Ya+Oa*+(j[Aa>>1]|0);Ba=~~$a;ga=Ba-(+(Ba|0)>$a&1)|0;$a=_a+Za*+(j[ua>>1]|0);Ba=~~$a;wa=Ba-(+(Ba|0)>$a&1)|0;Ba=_+(Y(ga,La)|0)+(wa<<2)|0;if(!(ga>>>0<Ka>>>0&wa>>>0<X>>>0))break;f[Ba>>2]=(f[Ba>>2]|0)+1}while(0);Da=Da+1|0;if((Da|0)==(I|0))break;else{Aa=Aa+(Ma<<1)|0;ua=ua+(Ja<<1)|0}}}if(!Q)break;else{la=la+(ma<<1)+(Ma<<1)+(Fa<<1)|0;ya=ya+(c<<1)+(Ja<<1)+(Ia<<1)|0;xa=xa+aa|0}}break}case 3:{Za=+p[d>>3];_a=+p[d+8>>3];Oa=+p[d+16>>3];Ya=+p[d+24>>3];$a=+p[d+32>>3];ab=+p[d+40>>3];xa=f[s>>2]|0;Ia=f[s+4>>2]|0;Ja=f[s+8>>2]|0;c=f[za>>2]|0;ya=f[za+4>>2]|0;Fa=f[za+8>>2]|0;Ma=f[za+12>>2]|0;ma=f[za+16>>2]|0;la=f[za+20>>2]|0;Q=f[t>>2]|0;X=f[t+4>>2]|0;if(!E)break c;Ka=(I|0)>0;La=Y(I,c)|0;ua=Y(I,Fa)|0;Aa=Y(I,ma)|0;Da=f[O>>2]|0;Ba=f[O+4>>2]|0;wa=f[O+8>>2]|0;ga=F;ra=E;while(1){ra=ra+-1|0;do if(!ga){if(!Ka){bb=Da;cb=Ba;db=wa;break}sa=Ba+(ua<<1)|0;oa=Da;na=Ba;N=wa;ha=0;while(1){eb=_a+Za*+(j[oa>>1]|0);ta=~~eb;ja=ta-(+(ta|0)>eb&1)|0;eb=Ya+Oa*+(j[na>>1]|0);ta=~~eb;ka=ta-(+(ta|0)>eb&1)|0;eb=ab+$a*+(j[N>>1]|0);ta=~~eb;ia=ta-(+(ta|0)>eb&1)|0;ta=_+(Y(ja,Q)|0)+(Y(ka,X)|0)+(ia<<2)|0;if(ja>>>0<xa>>>0&ka>>>0<Ia>>>0&ia>>>0<Ja>>>0)f[ta>>2]=(f[ta>>2]|0)+1;ha=ha+1|0;if((ha|0)==(I|0))break;else{oa=oa+(c<<1)|0;na=na+(Fa<<1)|0;N=N+(ma<<1)|0}}bb=Da+(La<<1)|0;cb=sa;db=wa+(Aa<<1)|0}else{if(!Ka){bb=Da;cb=Ba;db=wa;break}N=Ba+(ua<<1)|0;na=Da;oa=Ba;ha=wa;ta=0;while(1){do if(b[ga+ta>>0]|0){eb=_a+Za*+(j[na>>1]|0);ia=~~eb;ka=ia-(+(ia|0)>eb&1)|0;eb=Ya+Oa*+(j[oa>>1]|0);ia=~~eb;ja=ia-(+(ia|0)>eb&1)|0;eb=ab+$a*+(j[ha>>1]|0);ia=~~eb;x=ia-(+(ia|0)>eb&1)|0;ia=_+(Y(ka,Q)|0)+(Y(ja,X)|0)+(x<<2)|0;if(!(ka>>>0<xa>>>0&ja>>>0<Ia>>>0&x>>>0<Ja>>>0))break;f[ia>>2]=(f[ia>>2]|0)+1}while(0);ta=ta+1|0;if((ta|0)==(I|0))break;else{na=na+(c<<1)|0;oa=oa+(Fa<<1)|0;ha=ha+(ma<<1)|0}}bb=Da+(La<<1)|0;cb=N;db=wa+(Aa<<1)|0}while(0);if(!ra)break;else{Da=bb+(ya<<1)|0;Ba=cb+(Ma<<1)|0;wa=db+(la<<1)|0;ga=ga+aa|0}}break}default:{if(!E)break c;ga=(i|0)==0;la=(I|0)>0;wa=F;Ma=E;while(1){Ma=Ma+-1|0;do if(!wa){if(!la){Ea=224;break}if(e)fb=0;else{if(!ga)break;Ba=0;ya=f[_>>2]|0;do{ya=ya+1|0;Ba=Ba+1|0}while((Ba|0)!=(I|0));f[_>>2]=ya;Ea=224;break}do{Ba=_;N=0;while(1){Da=O+(N<<2)|0;ra=f[Da>>2]|0;Aa=N<<1;$a=+(j[ra>>1]|0)*+p[d+(Aa<<3)>>3]+ +p[d+((Aa|1)<<3)>>3];La=~~$a;ma=La-(+(La|0)>$a&1)|0;if(ma>>>0>=(f[s+(N<<2)>>2]|0)>>>0){gb=Ba;hb=N;break}f[Da>>2]=ra+(f[za+(Aa<<2)>>2]<<1);Aa=Ba+(Y(f[t+(N<<2)>>2]|0,ma)|0)|0;ma=N+1|0;if((ma|0)<(i|0)){Ba=Aa;N=ma}else{gb=Aa;hb=ma;break}}do if((hb|0)==(i|0))f[gb>>2]=(f[gb>>2]|0)+1;else{if((hb|0)<(i|0))ib=hb;else break;do{N=O+(ib<<2)|0;f[N>>2]=(f[N>>2]|0)+(f[za+(ib<<1<<2)>>2]<<1);ib=ib+1|0}while((ib|0)!=(i|0))}while(0);fb=fb+1|0}while((fb|0)!=(I|0));Ea=224}else{if(!la){Ea=224;break}if(e)jb=0;else{if(!ga)break;ya=0;N=f[_>>2]|0;do{N=N+1|0;ya=ya+1|0}while((ya|0)!=(I|0));f[_>>2]=N;Ea=224;break}while(1){f:do if(!(b[wa+jb>>0]|0)){kb=_;lb=0}else{ya=_;Ba=0;while(1){ma=O+(Ba<<2)|0;Aa=f[ma>>2]|0;ra=Ba<<1;$a=+(j[Aa>>1]|0)*+p[d+(ra<<3)>>3]+ +p[d+((ra|1)<<3)>>3];Da=~~$a;La=Da-(+(Da|0)>$a&1)|0;if(La>>>0>=(f[s+(Ba<<2)>>2]|0)>>>0){kb=ya;lb=Ba;break f}f[ma>>2]=Aa+(f[za+(ra<<2)>>2]<<1);ra=ya+(Y(f[t+(Ba<<2)>>2]|0,La)|0)|0;La=Ba+1|0;if((La|0)<(i|0)){ya=ra;Ba=La}else{kb=ra;lb=La;break}}}while(0);do if((lb|0)==(i|0))f[kb>>2]=(f[kb>>2]|0)+1;else{if((lb|0)<(i|0))mb=lb;else break;do{Ba=O+(mb<<2)|0;f[Ba>>2]=(f[Ba>>2]|0)+(f[za+(mb<<1<<2)>>2]<<1);mb=mb+1|0}while((mb|0)!=(i|0))}while(0);jb=jb+1|0;if((jb|0)==(I|0)){Ea=224;break}}}while(0);do if((Ea|0)==224){Ea=0;if(e)nb=0;else break;do{N=O+(nb<<2)|0;f[N>>2]=(f[N>>2]|0)+(f[za+((nb<<1|1)<<2)>>2]<<1);nb=nb+1|0}while((nb|0)!=(i|0))}while(0);if(!Ma)break;else wa=wa+aa|0}}}while(0);break}case 5:{aa=f[D>>2]|0;D=f[ea>>2]|0;ea=f[A>>2]|0;nb=f[B>>2]|0;za=f[Z>>2]|0;O=f[ea+(i<<2)>>2]|0;I=f[nb+((i<<1|1)<<2)>>2]|0;jb=i<<2;if(e){mb=f[$>>2]|0;Vac(s|0,f[da>>2]|0,jb|0)|0;Vac(t|0,mb|0,jb|0)|0}g:do if(!m){if(!l){f[r>>2]=0;f[r+4>>2]=0;K=aD(r,55)|0;L=232491;M=K+55|0;do{b[K>>0]=b[L>>0]|0;K=K+1|0;L=L+1|0}while((K|0)<(M|0));bO(-5,r,232547,231932,989);bD(r);break}if(e)Vac(r|0,l|0,jb|0)|0;if(D|0){mb=(aa|0)>0;lb=(i|0)==0;kb=(i|0)==0;_=O;fb=D;while(1){fb=fb+-1|0;h:do if(mb)if(!_){if(e)ob=0;else{ib=0;while(1){if(lb)f[za>>2]=(f[za>>2]|0)+1;ib=ib+1|0;if((ib|0)==(aa|0))break h}}do{ib=za;hb=0;while(1){gb=ea+(hb<<2)|0;E=f[gb>>2]|0;$a=+n[E>>2];F=f[r+(hb<<2)>>2]|0;db=f[s+(hb<<2)>>2]|0;cb=-1;while(1){bb=cb+1|0;if(!($a>=+n[F+(bb<<2)>>2])){pb=cb;break}if((bb|0)<(db|0))cb=bb;else{pb=bb;break}}if(pb>>>0>=db>>>0){qb=ib;rb=hb;break}f[gb>>2]=E+(f[nb+(hb<<1<<2)>>2]<<2);cb=ib+(Y(f[t+(hb<<2)>>2]|0,pb)|0)|0;F=hb+1|0;if((F|0)<(i|0)){ib=cb;hb=F}else{qb=cb;rb=F;break}}do if((rb|0)==(i|0))f[qb>>2]=(f[qb>>2]|0)+1;else{if((rb|0)<(i|0))sb=rb;else break;do{hb=ea+(sb<<2)|0;f[hb>>2]=(f[hb>>2]|0)+(f[nb+(sb<<1<<2)>>2]<<2);sb=sb+1|0}while((sb|0)!=(i|0))}while(0);ob=ob+1|0}while((ob|0)!=(aa|0))}else{if(e)tb=0;else{E=0;while(1){if(kb)f[za>>2]=(f[za>>2]|0)+1;E=E+1|0;if((E|0)==(aa|0))break h}}do{i:do if(!(b[_+tb>>0]|0)){ub=za;vb=0}else{E=za;gb=0;while(1){db=ea+(gb<<2)|0;hb=f[db>>2]|0;$a=+n[hb>>2];ib=f[r+(gb<<2)>>2]|0;F=f[s+(gb<<2)>>2]|0;cb=-1;while(1){bb=cb+1|0;if(!($a>=+n[ib+(bb<<2)>>2])){wb=cb;break}if((bb|0)<(F|0))cb=bb;else{wb=bb;break}}if(wb>>>0>=F>>>0){ub=E;vb=gb;break i}f[db>>2]=hb+(f[nb+(gb<<1<<2)>>2]<<2);cb=E+(Y(f[t+(gb<<2)>>2]|0,wb)|0)|0;ib=gb+1|0;if((ib|0)<(i|0)){E=cb;gb=ib}else{ub=cb;vb=ib;break}}}while(0);do if((vb|0)==(i|0))f[ub>>2]=(f[ub>>2]|0)+1;else{if((vb|0)<(i|0))xb=vb;else break;do{gb=ea+(xb<<2)|0;f[gb>>2]=(f[gb>>2]|0)+(f[nb+(xb<<1<<2)>>2]<<2);xb=xb+1|0}while((xb|0)!=(i|0))}while(0);tb=tb+1|0}while((tb|0)!=(aa|0))}while(0);if(e){gb=0;do{E=ea+(gb<<2)|0;f[E>>2]=(f[E>>2]|0)+(f[nb+((gb<<1|1)<<2)>>2]<<2);gb=gb+1|0}while((gb|0)!=(i|0))}if(!fb)break;else _=_+I|0}}}else switch(i|0){case 1:{$a=+p[d>>3];ab=+p[d+8>>3];_=f[s>>2]|0;fb=f[nb>>2]|0;kb=f[nb+4>>2]|0;if(!D)break g;if((aa|0)<=0)break g;lb=Y(fb,aa+-1|0)|0;mb=O;gb=f[ea>>2]|0;E=D;while(1){E=E+-1|0;if(!mb){ib=0;cb=gb;while(1){Oa=ab+$a*+n[cb>>2];P=~~Oa;Ha=P-(+(P|0)>Oa&1)|0;P=za+(Ha<<2)|0;if(Ha>>>0<_>>>0)f[P>>2]=(f[P>>2]|0)+1;ib=ib+1|0;if((ib|0)==(aa|0))break;else cb=cb+(fb<<2)|0}}else{cb=0;ib=gb;while(1){do if(b[mb+cb>>0]|0){Oa=ab+$a*+n[ib>>2];P=~~Oa;Ha=P-(+(P|0)>Oa&1)|0;P=za+(Ha<<2)|0;if(Ha>>>0>=_>>>0)break;f[P>>2]=(f[P>>2]|0)+1}while(0);cb=cb+1|0;if((cb|0)==(aa|0))break;else ib=ib+(fb<<2)|0}}if(!E)break;else{mb=mb+I|0;gb=gb+(lb<<2)+(fb<<2)+(kb<<2)|0}}break}case 2:{$a=+p[d>>3];ab=+p[d+8>>3];Oa=+p[d+16>>3];Ya=+p[d+24>>3];kb=f[s>>2]|0;fb=f[s+4>>2]|0;lb=f[nb>>2]|0;gb=f[nb+4>>2]|0;mb=f[nb+8>>2]|0;E=f[nb+12>>2]|0;_=f[t>>2]|0;if(!((D|0)!=0&(aa|0)>0))break g;ib=aa+-1|0;cb=Y(lb,ib)|0;P=Y(mb,ib)|0;ib=f[ea>>2]|0;Ha=f[ea+4>>2]|0;Ga=O;bb=D;while(1){bb=bb+-1|0;if(!Ga){Ta=ib;Xa=Ha;Va=0;while(1){Za=ab+$a*+n[Ta>>2];Ua=~~Za;Wa=Ua-(+(Ua|0)>Za&1)|0;Za=Ya+Oa*+n[Xa>>2];Ua=~~Za;Na=Ua-(+(Ua|0)>Za&1)|0;Ua=za+(Y(Wa,_)|0)+(Na<<2)|0;if(Wa>>>0<kb>>>0&Na>>>0<fb>>>0)f[Ua>>2]=(f[Ua>>2]|0)+1;Va=Va+1|0;if((Va|0)==(aa|0))break;else{Ta=Ta+(lb<<2)|0;Xa=Xa+(mb<<2)|0}}}else{Xa=ib;Ta=Ha;Va=0;while(1){do if(b[Ga+Va>>0]|0){Za=ab+$a*+n[Xa>>2];Ua=~~Za;Na=Ua-(+(Ua|0)>Za&1)|0;Za=Ya+Oa*+n[Ta>>2];Ua=~~Za;Wa=Ua-(+(Ua|0)>Za&1)|0;Ua=za+(Y(Na,_)|0)+(Wa<<2)|0;if(!(Na>>>0<kb>>>0&Wa>>>0<fb>>>0))break;f[Ua>>2]=(f[Ua>>2]|0)+1}while(0);Va=Va+1|0;if((Va|0)==(aa|0))break;else{Xa=Xa+(lb<<2)|0;Ta=Ta+(mb<<2)|0}}}if(!bb)break;else{ib=ib+(cb<<2)+(lb<<2)+(gb<<2)|0;Ha=Ha+(P<<2)+(mb<<2)+(E<<2)|0;Ga=Ga+I|0}}break}case 3:{Oa=+p[d>>3];Ya=+p[d+8>>3];$a=+p[d+16>>3];ab=+p[d+24>>3];Za=+p[d+32>>3];_a=+p[d+40>>3];Ga=f[s>>2]|0;E=f[s+4>>2]|0;mb=f[s+8>>2]|0;P=f[nb>>2]|0;Ha=f[nb+4>>2]|0;gb=f[nb+8>>2]|0;lb=f[nb+12>>2]|0;cb=f[nb+16>>2]|0;ib=f[nb+20>>2]|0;bb=f[t>>2]|0;fb=f[t+4>>2]|0;if(!D)break g;kb=(aa|0)>0;_=Y(aa,P)|0;Ta=Y(aa,gb)|0;Xa=Y(aa,cb)|0;Va=f[ea>>2]|0;Ua=f[ea+4>>2]|0;Wa=f[ea+8>>2]|0;Na=O;Sa=D;while(1){Sa=Sa+-1|0;do if(!Na){if(!kb){yb=Va;zb=Ua;Ab=Wa;break}Ra=Ua+(Ta<<2)|0;Qa=Va;Pa=Ua;a=Wa;wa=0;while(1){eb=Ya+Oa*+n[Qa>>2];Ma=~~eb;ga=Ma-(+(Ma|0)>eb&1)|0;eb=ab+$a*+n[Pa>>2];Ma=~~eb;la=Ma-(+(Ma|0)>eb&1)|0;eb=_a+Za*+n[a>>2];Ma=~~eb;N=Ma-(+(Ma|0)>eb&1)|0;Ma=za+(Y(ga,bb)|0)+(Y(la,fb)|0)+(N<<2)|0;if(ga>>>0<Ga>>>0&la>>>0<E>>>0&N>>>0<mb>>>0)f[Ma>>2]=(f[Ma>>2]|0)+1;wa=wa+1|0;if((wa|0)==(aa|0))break;else{Qa=Qa+(P<<2)|0;Pa=Pa+(gb<<2)|0;a=a+(cb<<2)|0}}yb=Va+(_<<2)|0;zb=Ra;Ab=Wa+(Xa<<2)|0}else{if(!kb){yb=Va;zb=Ua;Ab=Wa;break}a=Ua+(Ta<<2)|0;Pa=Va;Qa=Ua;wa=Wa;Ma=0;while(1){do if(b[Na+Ma>>0]|0){eb=Ya+Oa*+n[Pa>>2];N=~~eb;la=N-(+(N|0)>eb&1)|0;eb=ab+$a*+n[Qa>>2];N=~~eb;ga=N-(+(N|0)>eb&1)|0;eb=_a+Za*+n[wa>>2];N=~~eb;Ba=N-(+(N|0)>eb&1)|0;N=za+(Y(la,bb)|0)+(Y(ga,fb)|0)+(Ba<<2)|0;if(!(la>>>0<Ga>>>0&ga>>>0<E>>>0&Ba>>>0<mb>>>0))break;f[N>>2]=(f[N>>2]|0)+1}while(0);Ma=Ma+1|0;if((Ma|0)==(aa|0))break;else{Pa=Pa+(P<<2)|0;Qa=Qa+(gb<<2)|0;wa=wa+(cb<<2)|0}}yb=Va+(_<<2)|0;zb=a;Ab=Wa+(Xa<<2)|0}while(0);if(!Sa)break;else{Va=yb+(Ha<<2)|0;Ua=zb+(lb<<2)|0;Wa=Ab+(ib<<2)|0;Na=Na+I|0}}break}default:{if(!D)break g;Na=(i|0)==0;ib=(aa|0)>0;Wa=O;lb=D;while(1){lb=lb+-1|0;do if(!Wa){if(!ib){Ea=345;break}if(e)Bb=0;else{if(!Na)break;Ua=0;Ha=f[za>>2]|0;do{Ha=Ha+1|0;Ua=Ua+1|0}while((Ua|0)!=(aa|0));f[za>>2]=Ha;Ea=345;break}do{Ua=za;a=0;while(1){Va=ea+(a<<2)|0;Sa=f[Va>>2]|0;Xa=a<<1;Za=+n[Sa>>2]*+p[d+(Xa<<3)>>3]+ +p[d+((Xa|1)<<3)>>3];_=~~Za;cb=_-(+(_|0)>Za&1)|0;if(cb>>>0>=(f[s+(a<<2)>>2]|0)>>>0){Cb=Ua;Db=a;break}f[Va>>2]=Sa+(f[nb+(Xa<<2)>>2]<<2);Xa=Ua+(Y(f[t+(a<<2)>>2]|0,cb)|0)|0;cb=a+1|0;if((cb|0)<(i|0)){Ua=Xa;a=cb}else{Cb=Xa;Db=cb;break}}do if((Db|0)==(i|0))f[Cb>>2]=(f[Cb>>2]|0)+1;else{if((Db|0)<(i|0))Eb=Db;else break;do{a=ea+(Eb<<2)|0;f[a>>2]=(f[a>>2]|0)+(f[nb+(Eb<<1<<2)>>2]<<2);Eb=Eb+1|0}while((Eb|0)!=(i|0))}while(0);Bb=Bb+1|0}while((Bb|0)!=(aa|0));Ea=345}else{if(!ib){Ea=345;break}if(e)Fb=0;else{if(!Na)break;Ha=0;a=f[za>>2]|0;do{a=a+1|0;Ha=Ha+1|0}while((Ha|0)!=(aa|0));f[za>>2]=a;Ea=345;break}while(1){j:do if(!(b[Wa+Fb>>0]|0)){Gb=za;Hb=0}else{Ha=za;Ua=0;while(1){cb=ea+(Ua<<2)|0;Xa=f[cb>>2]|0;Sa=Ua<<1;Za=+n[Xa>>2]*+p[d+(Sa<<3)>>3]+ +p[d+((Sa|1)<<3)>>3];Va=~~Za;_=Va-(+(Va|0)>Za&1)|0;if(_>>>0>=(f[s+(Ua<<2)>>2]|0)>>>0){Gb=Ha;Hb=Ua;break j}f[cb>>2]=Xa+(f[nb+(Sa<<2)>>2]<<2);Sa=Ha+(Y(f[t+(Ua<<2)>>2]|0,_)|0)|0;_=Ua+1|0;if((_|0)<(i|0)){Ha=Sa;Ua=_}else{Gb=Sa;Hb=_;break}}}while(0);do if((Hb|0)==(i|0))f[Gb>>2]=(f[Gb>>2]|0)+1;else{if((Hb|0)<(i|0))Ib=Hb;else break;do{Ua=ea+(Ib<<2)|0;f[Ua>>2]=(f[Ua>>2]|0)+(f[nb+(Ib<<1<<2)>>2]<<2);Ib=Ib+1|0}while((Ib|0)!=(i|0))}while(0);Fb=Fb+1|0;if((Fb|0)==(aa|0)){Ea=345;break}}}while(0);do if((Ea|0)==345){Ea=0;if(e)Jb=0;else break;do{a=ea+(Jb<<2)|0;f[a>>2]=(f[a>>2]|0)+(f[nb+((Jb<<1|1)<<2)>>2]<<2);Jb=Jb+1|0}while((Jb|0)!=(i|0))}while(0);if(!lb)break;else Wa=Wa+I|0}}}while(0);break}default:{f[r>>2]=0;f[r+4>>2]=0;bO(-210,r,232409,231932,1498);bD(r)}}I=r+8|0;f[I>>2]=0;f[I+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=y;OJ(z,r,5,1.0,0.0);r=f[C>>2]|0;if(r|0){C=f[J>>2]|0;if((C|0)!=(r|0))f[J>>2]=C+(~((C+-8-r|0)>>>3)<<3);O5b(r)}r=f[B>>2]|0;if(r|0){B=f[g>>2]|0;if((B|0)!=(r|0))f[g>>2]=B+(~((B+-4-r|0)>>>2)<<2);O5b(r)}r=f[A>>2]|0;if(r|0){A=f[o>>2]|0;if((A|0)!=(r|0))f[o>>2]=A+(~((A+-4-r|0)>>>2)<<2);O5b(r)}r=f[ba>>2]|0;if(r|0?(A=r+12|0,r=f[A>>2]|0,f[A>>2]=r+-1,(r|0)==1):0)kL(z);f[ba>>2]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[V>>2]|0)>0){Z=f[da>>2]|0;da=0;do{f[Z+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[V>>2]|0))}V=f[$>>2]|0;if((V|0)!=(G|0))UC(V);V=f[ca>>2]|0;if(V|0?(G=V+12|0,V=f[G>>2]|0,f[G>>2]=V+-1,(V|0)==1):0)kL(y);f[ca>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[W>>2]|0)>0){U=f[fa>>2]|0;fa=0;do{f[U+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[W>>2]|0))}W=f[y+44>>2]|0;if((W|0)!=(y+48|0))UC(W);W=w+36|0;y=f[W>>2]|0;do if(y|0){fa=y+12|0;U=f[fa>>2]|0;f[fa>>2]=U+-1;if((U|0)!=1)break;kL(w)}while(0);f[W>>2]=0;W=w+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[W>>2]|0)>0){H=f[w+40>>2]|0;y=0;do{f[H+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[W>>2]|0))}W=f[w+44>>2]|0;if((W|0)!=(w+48|0))UC(W);if(!(f[v+4>>2]|0)){u=q;return}u=q;return}function W2(a,c,d,e,g,h,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0.0,$=0.0;q=u;u=u+16|0;r=q;s=(d|0)!=0;if(!(s|(c|0)==(g|0))){f[r>>2]=0;f[r+4>>2]=0;t=aD(r,32)|0;v=232581;w=t+32|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,r,232614,231932,128);bD(r)}x=f[a+40>>2]|0;y=f[x>>2]|0;f[m>>2]=f[x+4>>2];x=m+4|0;f[x>>2]=y;y=f[a>>2]|0;z=y&7;A=1212424721>>>(y<<2&28)&15;y=g+1|0;B=k+4|0;C=f[B>>2]|0;D=f[k>>2]|0;E=C-D>>2;F=D;D=C;if(y>>>0<=E>>>0){if(y>>>0<E>>>0?(C=F+(y<<2)|0,(D|0)!=(C|0)):0)f[B>>2]=D+(~((D+-4-C|0)>>>2)<<2)}else Y2(k,y-E|0);E=y<<1;y=l+4|0;C=f[y>>2]|0;D=f[l>>2]|0;B=C-D>>2;F=D;D=C;if(E>>>0<=B>>>0){if(E>>>0<B>>>0?(C=F+(E<<2)|0,(D|0)!=(C|0)):0)f[y>>2]=D+(~((D+-4-C|0)>>>2)<<2)}else HC(l,E-B|0);B=(g|0)>0;if(B){E=r+4|0;C=(c|0)>0;D=r+4|0;y=r+4|0;F=r+4|0;G=0;H=1;while(1){a:do if(!s)if(!(f[a+(G*56|0)>>2]&4088)){I=G;J=0}else{f[r>>2]=0;f[F>>2]=0;t=aD(r,25)|0;v=232632;w=t+25|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,r,232614,231932,143);bD(r);I=G;J=0}else{K=f[d+(G<<2)>>2]|0;if((K|0)<=-1){f[r>>2]=0;f[E>>2]=0;L=aD(r,6)|0;b[L>>0]=b[232658]|0;b[L+1>>0]=b[232659]|0;b[L+2>>0]=b[232660]|0;b[L+3>>0]=b[232661]|0;b[L+4>>0]=b[232662]|0;b[L+5>>0]=b[232663]|0;bO(-215,r,232614,231932,148);bD(r)}if(C){L=0;M=K;while(1){N=(f[a+(L*56|0)>>2]|0)>>>3&511;if((M|0)<=(N|0)){I=L;J=M;break a}O=M+-1-N|0;N=L+1|0;if((N|0)<(c|0)){L=N;M=O}else{P=N;Q=O;break}}}else{P=0;Q=K}f[r>>2]=0;f[D>>2]=0;t=aD(r,11)|0;v=232665;w=t+11|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,r,232614,231932,152);bD(r);I=P;J=Q}while(0);K=a+(I*56|0)|0;M=f[a+(I*56|0)+40>>2]|0;if(((f[M>>2]|0)==(f[x>>2]|0)?(f[M+4>>2]|0)==(f[m>>2]|0):0)?(M=f[K>>2]|0,(M&7|0)==(z|0)):0)R=M;else{f[r>>2]=0;f[y>>2]=0;t=aD(r,56)|0;v=232677;w=t+56|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,r,232614,231932,155);bD(r);R=f[K>>2]|0}M=H&(R&16384|0)!=0;L=(f[a+(I*56|0)+16>>2]|0)+(Y(J,A)|0)|0;f[(f[k>>2]|0)+(G<<2)>>2]=L;L=(R>>>3&511)+1|0;O=G<<1;N=f[l>>2]|0;f[N+(O<<2)>>2]=L;S=(((f[a+(I*56|0)+48>>2]|0)>>>0)/(A>>>0)|0)-(Y(L,f[m>>2]|0)|0)|0;f[N+((O|1)<<2)>>2]=S;G=G+1|0;if((G|0)>=(g|0)){T=M;break}else H=M}}else T=1;H=e+16|0;do if(!(f[H>>2]|0)){if(T)U=42}else{G=f[e+4>>2]|0;if((G|0)<3)V=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{A=f[e+40>>2]|0;I=0;a=1;while(1){R=Y(f[A+(I<<2)>>2]|0,a)|0;I=I+1|0;if((I|0)==(G|0)){V=R;break}else a=R}}if((G|0)==0|(V|0)==0)if(T){U=42;break}else break;a=f[e+40>>2]|0;if(!(((f[a>>2]|0)==(f[x>>2]|0)?(f[a+4>>2]|0)==(f[m>>2]|0):0)?!(f[e>>2]&4088|0):0)){f[r>>2]=0;f[r+4>>2]=0;t=aD(r,45)|0;v=232734;w=t+45|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,r,232614,231932,165);bD(r)}if(T)W=(f[e>>2]&16384|0)!=0;else W=0;f[(f[k>>2]|0)+(g<<2)>>2]=f[H>>2];G=g<<1;a=f[l>>2]|0;f[a+(G<<2)>>2]=1;f[a+((G|1)<<2)>>2]=((f[e+48>>2]|0)>>>0)/((1212424721>>>(f[e>>2]<<2&28)&15)>>>0)|0;if(W)U=42}while(0);if((U|0)==42){U=Y(f[m>>2]|0,f[x>>2]|0)|0;f[m>>2]=U;f[x>>2]=1}if(!i){if(z|0){f[r>>2]=0;f[r+4>>2]=0;t=aD(r,10)|0;v=359571;w=t+10|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,r,232614,231932,182);bD(r)}z=g<<1;x=o+4|0;U=f[x>>2]|0;m=f[o>>2]|0;W=U-m>>3;e=m;m=U;if(z>>>0<=W>>>0){if(z>>>0<W>>>0?(U=e+(z<<3)|0,(m|0)!=(U|0)):0)f[x>>2]=m+(~((m+-8-U|0)>>>3)<<3)}else Z2(o,z-W|0);if(!B){u=q;return}W=f[o>>2]|0;z=0;do{U=z<<1;p[W+(U<<3)>>3]=+(f[h+(z<<2)>>2]|0)*.00390625;p[W+((U|1)<<3)>>3]=0.0;z=z+1|0}while((z|0)!=(g|0));u=q;return}if(!j){if(!B){u=q;return}j=r+4|0;z=0;do{W=f[h+(z<<2)>>2]|0;if(W|0){U=i+(z<<2)|0;m=0;do{x=f[U>>2]|0;e=m;m=m+1|0;if(!(+n[x+(e<<2)>>2]<+n[x+(m<<2)>>2])){f[r>>2]=0;f[j>>2]=0;t=aD(r,29)|0;v=232821;w=t+29|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,r,232614,231932,209);bD(r)}}while(m>>>0<W>>>0)}z=z+1|0}while((z|0)<(g|0));u=q;return}z=g<<1;j=o+4|0;W=f[j>>2]|0;m=f[o>>2]|0;U=W-m>>3;x=m;m=W;if(z>>>0<=U>>>0){if(z>>>0<U>>>0?(W=x+(z<<3)|0,(m|0)!=(W|0)):0)f[j>>2]=m+(~((m+-8-W|0)>>>3)<<3)}else Z2(o,z-U|0);if(!B){u=q;return}B=r+4|0;U=0;do{z=i+(U<<2)|0;W=f[z>>2]|0;if((W|0)!=0?(X=+n[W>>2],Z=+n[W+4>>2],X<Z):0){_=X;$=Z}else{f[r>>2]=0;f[B>>2]=0;t=aD(r,40)|0;v=232780;w=t+40|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,r,232614,231932,196);bD(r);W=f[z>>2]|0;_=+n[W>>2];$=+n[W+4>>2]}Z=_;X=+(f[h+(U<<2)>>2]|0)/($-Z);W=U<<1;m=f[o>>2]|0;p[m+(W<<3)>>3]=X;p[m+((W|1)<<3)>>3]=-(Z*X);U=U+1|0}while((U|0)<(g|0));u=q;return}function X2(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;k=u;u=u+16|0;l=k;m=d<<8;o=j+4|0;q=f[o>>2]|0;r=f[j>>2]|0;s=q-r>>2;t=r;r=q;if(m>>>0<=s>>>0)if(m>>>0<s>>>0?(q=t+(m<<2)|0,(r|0)!=(q|0)):0){f[o>>2]=r+(~((r+-4-q|0)>>>2)<<2);v=t}else v=t;else{UN(j,m-s|0);v=f[j>>2]|0}if(h){if((d|0)<=0){u=k;return}h=f[c+4>>2]|0;j=(h|0)==0;s=f[a+40>>2]|0;m=f[a+44>>2]|0;if(i)w=0;else{t=0;do{q=t<<1;x=+p[g+(q<<3)>>3];y=+p[g+((q|1)<<3)>>3];q=f[s+(t<<2)>>2]|0;r=f[m+(t<<2)>>2]|0;o=t<<8;z=0;do{A=y+x*+(z|0);B=~~A;C=B-(+(B|0)>A&1)|0;B=Y(C,r)|0;f[v+(z+o<<2)>>2]=C>>>0<q>>>0?B:1073741824;z=z+1|0}while((z|0)!=256);t=t+1|0}while((t|0)!=(d|0));u=k;return}do{t=w<<1;x=+p[g+(t<<3)>>3];y=+p[g+((t|1)<<3)>>3];if(j)D=0;else D=f[h+48+(w<<2)>>2]|0;t=w<<8;m=0;do{A=y+x*+(m|0);s=~~A;z=s-(+(s|0)>A&1)|0;f[v+(m+t<<2)>>2]=z>>>0<D>>>0?z:1073741824;m=m+1|0}while((m|0)!=256);w=w+1|0}while((w|0)!=(d|0));u=k;return}if(!e){f[l>>2]=0;f[l+4>>2]=0;w=aD(l,55)|0;D=232491;h=w+55|0;do{b[w>>0]=b[D>>0]|0;w=w+1|0;D=D+1|0}while((w|0)<(h|0));bO(-5,l,232557,231932,116);bD(l);u=k;return}if((d|0)<=0){u=k;return}l=f[c+4>>2]|0;c=(l|0)==0;D=f[a+40>>2]|0;w=f[a+44>>2]|0;if(i)E=0;else{i=0;do{a=f[e+(i<<2)>>2]|0;x=+n[a>>2];h=~~x;j=(+(h|0)<x&1)+h|0;h=f[D+(i<<2)>>2]|0;g=f[w+(i<<2)>>2]|0;m=i<<8;t=1073741824;z=(j|0)<256?j:256;j=-1;s=0;while(1){if((s|0)<(z|0)){q=s;do{f[v+(q+m<<2)>>2]=t;q=q+1|0}while((q|0)!=(z|0));F=z}else F=s;q=j+1|0;if(q>>>0>=h>>>0)break;x=+n[a+(j+2<<2)>>2];o=~~x;r=(+(o|0)<x&1)+o|0;t=Y(q,g)|0;z=(r|0)<256?r:256;j=q;s=F}if((F|0)<256){s=F;do{f[v+(s+m<<2)>>2]=1073741824;s=s+1|0}while((s|0)!=256)}i=i+1|0}while((i|0)!=(d|0));u=k;return}do{i=f[e+(E<<2)>>2]|0;x=+n[i>>2];F=~~x;w=(+(F|0)<x&1)+F|0;if(c)G=0;else G=f[l+48+(E<<2)>>2]|0;F=E<<8;D=1073741824;s=(w|0)<256?w:256;w=-1;m=0;while(1){if((m|0)<(s|0)){j=m;do{f[v+(j+F<<2)>>2]=D;j=j+1|0}while((j|0)!=(s|0));H=s}else H=m;j=w+1|0;if(j>>>0>=G>>>0)break;x=+n[i+(w+2<<2)>>2];z=~~x;g=(+(z|0)<x&1)+z|0;D=j;s=(g|0)<256?g:256;w=j;m=H}if((H|0)<256){m=H;do{f[v+(m+F<<2)>>2]=1073741824;m=m+1|0}while((m|0)!=256)}E=E+1|0}while((E|0)!=(d|0));u=k;return}function Y2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)c4b(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)Vac(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;O5b(d);return}function Z2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>3>>>0>=b>>>0){Nac(g|0,0,b<<3|0)|0;f[e>>2]=g+(b<<3);return}h=f[a>>2]|0;i=g-h|0;g=i>>3;j=g+b|0;if(j>>>0>536870911)c4b(a);k=d-h|0;d=k>>2;l=k>>3>>>0<268435455?(d>>>0<j>>>0?j:d):536870911;do if(l)if(l>>>0>536870911){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);d=m+(g<<3)|0;Nac(d|0,0,b<<3|0)|0;j=d+(0-g<<3)|0;if((i|0)>0)Vac(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<3);f[c>>2]=m+(l<<3);if(!h)return;O5b(h);return}function _2(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;j=u;u=u+1664|0;k=j+1648|0;l=j+1520|0;m=j+56|0;n=j;dQ(k,51664);o=(f[g+4>>2]|0)-(f[g>>2]|0)|0;p=o>>2;q=(f[h+4>>2]|0)-(f[h>>2]|0)|0;r=q>>2;s=(f[c+4>>2]|0)-(f[c>>2]|0)>>2;t=EM(a,-1)|0;v=(t|0)>0;if(!((o|0)>0&v)){f[l>>2]=0;f[l+4>>2]=0;w=aD(l,23)|0;x=232975;y=w+23|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,l,232409,231932,1780);bD(l)}do if((r|0)!=(o>>1|0)){if((r|0)==0?(FM(a,0)|0)==0:0)break;f[l>>2]=0;f[l+4>>2]=0;w=aD(l,51)|0;x=232999;y=w+51|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,l,232409,231932,1781);bD(l)}while(0);o=(s|0)==0;if(!(o|(s|0)==(p|0))){f[l>>2]=0;f[l+4>>2]=0;w=aD(l,23)|0;x=233051;y=w+23|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,l,232409,231932,1782);bD(l)}if((q|0)>0?(x=(r|0)/2|0,(q|0)>4):0){q=f[h>>2]|0;h=0;do{f[l+(h<<2)>>2]=q+(h<<1<<2);h=h+1|0}while((h|0)<(x|0))}FI(m,t);if(v){v=n+4|0;x=n+8|0;h=n+12|0;q=n+16|0;w=n+20|0;y=n+24|0;s=n+28|0;z=n+32|0;A=n+36|0;B=n+40|0;C=n+48|0;D=n+44|0;E=0;do{yL(n,a,E);F=f[m>>2]|0;G=F+(E*56|0)|0;if((G|0)!=(n|0)){H=f[A>>2]|0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}I=F+(E*56|0)+36|0;H=f[I>>2]|0;if(H|0?(J=H+12|0,H=f[J>>2]|0,f[J>>2]=H+-1,(H|0)==1):0)kL(G);f[I>>2]=0;H=F+(E*56|0)+16|0;J=F+(E*56|0)+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[J>>2]|0)>0){K=f[F+(E*56|0)+40>>2]|0;L=0;do{f[K+(L<<2)>>2]=0;L=L+1|0;M=f[J>>2]|0}while((L|0)<(M|0));f[G>>2]=f[n>>2];if((M|0)<3)N=27;else N=29}else{f[G>>2]=f[n>>2];N=27}if((N|0)==27){N=0;L=f[v>>2]|0;if((L|0)<3){f[J>>2]=L;f[F+(E*56|0)+8>>2]=f[x>>2];f[F+(E*56|0)+12>>2]=f[h>>2];L=f[D>>2]|0;K=f[F+(E*56|0)+44>>2]|0;f[K>>2]=f[L>>2];f[K+4>>2]=f[L+4>>2]}else N=29}if((N|0)==29){N=0;jL(G,n)}f[H>>2]=f[q>>2];f[F+(E*56|0)+20>>2]=f[w>>2];f[F+(E*56|0)+24>>2]=f[y>>2];f[F+(E*56|0)+28>>2]=f[s>>2];f[F+(E*56|0)+32>>2]=f[z>>2];f[I>>2]=f[A>>2]}L=f[A>>2]|0;if(L|0?(K=L+12|0,L=f[K>>2]|0,f[K>>2]=L+-1,(L|0)==1):0)kL(n);f[A>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[v>>2]|0)>0){L=f[B>>2]|0;K=0;do{f[L+(K<<2)>>2]=0;K=K+1|0}while((K|0)<(f[v>>2]|0))}K=f[D>>2]|0;if((K|0)!=(C|0))UC(K);E=E+1|0}while((E|0)<(t|0));O=m}else O=m;V2(f[O>>2]|0,t,o?0:f[c>>2]|0,d,e,p,f[g>>2]|0,r|0?l:0,1,i);GI(m);if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function $2(a,c,e,g,i,k,l,m){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=+l;m=m|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0,Xa=0,Ya=0,Za=0;o=u;u=u+688|0;q=o+560|0;r=o+304|0;s=o+176|0;t=o+168|0;v=o+104|0;w=o+88|0;x=o+76|0;y=o+64|0;z=o+56|0;A=o+160|0;B=o;dQ(t,51684);do if((yM(g)|0)==65536){C=f[g+4>>2]|0;f[v>>2]=f[C>>2];D=v+4|0;E=C+4|0;f[D>>2]=f[E>>2];F=v+8|0;f[F>>2]=f[C+8>>2];f[v+12>>2]=f[C+12>>2];f[v+16>>2]=f[C+16>>2];f[v+20>>2]=f[C+20>>2];f[v+24>>2]=f[C+24>>2];f[v+28>>2]=f[C+28>>2];f[v+32>>2]=f[C+32>>2];G=f[C+36>>2]|0;f[v+36>>2]=G;f[v+40>>2]=F;F=v+48|0;H=v+44|0;f[H>>2]=F;f[F>>2]=0;f[v+52>>2]=0;if(G|0){F=G+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[E>>2]|0)<3){E=f[C+44>>2]|0;F=f[H>>2]|0;f[F>>2]=f[E>>2];f[F+4>>2]=f[E+4>>2];I=D;break}else{f[D>>2]=0;jL(v,C);I=D;break}}else{yL(v,g,-1);I=v+4|0}while(0);f[w>>2]=0;g=w+4|0;f[g>>2]=0;f[w+8>>2]=0;f[x>>2]=0;D=x+4|0;f[D>>2]=0;f[x+8>>2]=0;f[y>>2]=0;C=y+4|0;f[C>>2]=0;f[y+8>>2]=0;f[z>>2]=0;E=z+4|0;f[E>>2]=0;F=f[I>>2]|0;if((F|0)!=2)if((F|0)>0){J=F;K=11}else{L=0;M=F;K=17}else{J=(f[(f[v+40>>2]|0)+4>>2]|0)==1?1:2;K=11}if((K|0)==11)if(f[v+16>>2]|0){if((F|0)<3)N=Y(f[v+12>>2]|0,f[v+8>>2]|0)|0;else{H=f[v+40>>2]|0;G=0;O=1;while(1){P=Y(f[H+(G<<2)>>2]|0,O)|0;G=G+1|0;if((G|0)==(F|0)){N=P;break}else O=P}}if(!((F|0)==0|(N|0)==0)){Q=1;R=J}else{L=1;M=J;K=17}}else{L=1;M=J;K=17}if((K|0)==17){f[q>>2]=0;f[q+4>>2]=0;S=aD(q,25)|0;T=233224;U=S+25|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));bO(-215,q,233250,231932,2111);bD(q);Q=L;R=M}M=f[a+40>>2]|0;L=f[M>>2]|0;f[A>>2]=f[M+4>>2];f[A+4>>2]=L;vM(i,A,f[a>>2]&7,-1,0,0);do if((yM(i)|0)==65536){A=f[i+4>>2]|0;f[B>>2]=f[A>>2];L=B+4|0;M=A+4|0;f[L>>2]=f[M>>2];J=B+8|0;f[J>>2]=f[A+8>>2];f[B+12>>2]=f[A+12>>2];f[B+16>>2]=f[A+16>>2];f[B+20>>2]=f[A+20>>2];f[B+24>>2]=f[A+24>>2];f[B+28>>2]=f[A+28>>2];f[B+32>>2]=f[A+32>>2];N=f[A+36>>2]|0;f[B+36>>2]=N;f[B+40>>2]=J;J=B+48|0;F=B+44|0;f[F>>2]=J;f[J>>2]=0;f[B+52>>2]=0;if(N|0){J=N+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[M>>2]|0)<3){M=f[A+44>>2]|0;J=f[F>>2]|0;f[J>>2]=f[M>>2];f[J+4>>2]=f[M+4>>2];break}else{f[L>>2]=0;jL(B,A);break}}else yL(B,i,-1);while(0);i=v+40|0;W2(a,c,e,B,R,f[i>>2]|0,k,m,w,x,z,y);e=m?f[y>>2]|0:0;switch(f[a>>2]&7){case 0:{a=f[z>>2]|0;c=f[E>>2]|0;V=l;A=f[w>>2]|0;L=f[x>>2]|0;M=f[v+16>>2]|0;J=f[A+(R<<2)>>2]|0;F=f[L+((R<<1|1)<<2)>>2]|0;f[q>>2]=0;N=q+4|0;f[N>>2]=0;f[q+8>>2]=0;f[r>>2]=1123876864;f[r+4>>2]=0;X2(v,r,R,k,e,m,0,q);O=f[q>>2]|0;switch(R|0){case 1:{G=f[L>>2]|0;H=f[L+4>>2]|0;Nac(r|0,0,256)|0;P=f[A>>2]|0;W=0;do{X=f[O+(W<<2)>>2]|0;if(X>>>0<1073741824){Z=LVb(V*+n[M+X>>2])|0;b[r+W>>0]=Z>>>0<256?Z:(Z|0)>0?255:0}W=W+1|0}while((W|0)!=256);W=c+-1|0;a:do if(c|0){Z=G<<1;X=(a|0)<4;_=a+-4|0;if((G|0)==1){if(X){$=(a|0)>0;aa=J;ba=P;ca=W;while(1){if($){da=0;ea=ba;while(1){b[aa+da>>0]=b[r+(h[ea>>0]|0)>>0]|0;da=da+1|0;if((da|0)==(a|0))break;else ea=ea+1|0}fa=ba+a|0}else fa=ba;if(!ca)break a;else{aa=aa+F|0;ba=fa+H|0;ca=ca+-1|0}}}ca=a&-4;ba=(ca|0)<(a|0);aa=J;$=P;ea=W;while(1){da=0;ga=$;while(1){ha=da|1;ia=b[r+(h[$+ha>>0]|0)>>0]|0;b[aa+da>>0]=b[r+(h[ga>>0]|0)>>0]|0;b[aa+ha>>0]=ia;ia=da|2;ha=da|3;ja=b[r+(h[$+ha>>0]|0)>>0]|0;b[aa+ia>>0]=b[r+(h[$+ia>>0]|0)>>0]|0;b[aa+ha>>0]=ja;ja=da+4|0;if((ja|0)>(_|0))break;else{da=ja;ga=$+ja|0}}if(ba){ga=ca;da=$+ca|0;while(1){b[aa+ga>>0]=b[r+(h[da>>0]|0)>>0]|0;ga=ga+1|0;if((ga|0)==(a|0)){ka=a;break}else da=da+1|0}}else ka=ca;if(!ea)break;else{aa=aa+F|0;$=$+ka+H|0;ea=ea+-1|0}}}else{if(X){ea=Y(a,G)|0;$=(a|0)>0;aa=J;ca=P;ba=W;while(1){if($){da=0;ga=ca;while(1){b[aa+da>>0]=b[r+(h[ga>>0]|0)>>0]|0;da=da+1|0;if((da|0)==(a|0))break;else ga=ga+G|0}la=ca+ea|0}else la=ca;if(!ba)break a;else{aa=aa+F|0;ca=la+H|0;ba=ba+-1|0}}}ba=a&-4;ca=Y(G,ba)|0;aa=Y(a,G)|0;ea=(ba|0)<(a|0);$=J;X=P;ga=W;while(1){da=0;ja=X;while(1){ha=b[r+(h[ja+G>>0]|0)>>0]|0;b[$+da>>0]=b[r+(h[ja>>0]|0)>>0]|0;b[$+(da|1)>>0]=ha;ha=ja+Z|0;ia=b[r+(h[ha+G>>0]|0)>>0]|0;b[$+(da|2)>>0]=b[r+(h[ha>>0]|0)>>0]|0;b[$+(da|3)>>0]=ia;da=da+4|0;if((da|0)>(_|0))break;else ja=ha+Z|0}if(ea){ja=ba;da=X+ca|0;while(1){b[$+ja>>0]=b[r+(h[da>>0]|0)>>0]|0;ja=ja+1|0;if((ja|0)==(a|0)){ma=aa;break}else da=da+G|0}}else ma=ca;if(!ga)break;else{$=$+F|0;X=X+ma+H|0;ga=ga+-1|0}}}}while(0);break}case 2:{H=f[L>>2]|0;ma=f[L+4>>2]|0;G=f[L+8>>2]|0;W=f[L+12>>2]|0;if((c|0)!=0&(a|0)>0){P=Y(a,H)|0;la=Y(a,G)|0;ka=f[A>>2]|0;fa=f[A+4>>2]|0;ga=J;X=c;while(1){$=ka+P|0;ca=ka;aa=fa;ba=0;while(1){ea=(f[O+((h[aa>>0]|0|256)<<2)>>2]|0)+(f[O+((h[ca>>0]|0)<<2)>>2]|0)|0;if(ea>>>0<1073741824){Z=LVb(V*+n[M+ea>>2])|0;na=(Z>>>0<256?Z:(Z|0)>0?255:0)&255}else na=0;b[ga+ba>>0]=na;ba=ba+1|0;if((ba|0)==(a|0))break;else{ca=ca+H|0;aa=aa+G|0}}X=X+-1|0;if(!X)break;else{ka=$+ma|0;fa=fa+la+W|0;ga=ga+F|0}}}break}case 3:{ga=f[L>>2]|0;W=f[L+4>>2]|0;la=f[L+8>>2]|0;fa=f[L+12>>2]|0;ma=f[L+16>>2]|0;ka=f[L+20>>2]|0;if((c|0)!=0&(a|0)>0){X=Y(a,ga)|0;G=Y(a,la)|0;H=Y(a,ma)|0;na=f[A+8>>2]|0;P=f[A+4>>2]|0;aa=f[A>>2]|0;ca=J;ba=c;while(1){ba=ba+-1|0;Z=P+G|0;ea=na;_=P;da=aa;ja=0;while(1){ha=(f[O+((h[_>>0]|0|256)<<2)>>2]|0)+(f[O+((h[da>>0]|0)<<2)>>2]|0)+(f[O+((h[ea>>0]|0|512)<<2)>>2]|0)|0;if(ha>>>0<1073741824){ia=LVb(V*+n[M+ha>>2])|0;oa=(ia>>>0<256?ia:(ia|0)>0?255:0)&255}else oa=0;b[ca+ja>>0]=oa;ja=ja+1|0;if((ja|0)==(a|0))break;else{ea=ea+ma|0;_=_+la|0;da=da+ga|0}}if(!ba)break;else{na=na+H+ka|0;P=Z+fa|0;aa=aa+X+W|0;ca=ca+F|0}}}break}default:if(c|0){ca=(R|0)==0;W=(a|0)>0;X=J;aa=c;c=0;while(1){fa=J+(Y(F,c)|0)|0;aa=aa+-1|0;b:do if(W){if(!Q)if(ca){P=0;while(1){ka=LVb(V*+n[M>>2])|0;b[X+P>>0]=ka>>>0<256?ka:(ka|0)>0?255:0;P=P+1|0;if((P|0)==(a|0)){K=89;break b}}}else{Nac(fa|0,0,a|0)|0;break}else pa=0;do{P=M;ka=0;while(1){H=A+(ka<<2)|0;na=f[H>>2]|0;ba=f[O+((h[na>>0]|0|ka<<8)<<2)>>2]|0;if(ba>>>0>1073741823){qa=P;ra=ka;break}ga=P+ba|0;f[H>>2]=na+(f[L+(ka<<1<<2)>>2]|0);na=ka+1|0;if((na|0)<(R|0)){P=ga;ka=na}else{qa=ga;ra=na;break}}if((ra|0)!=(R|0)){b[X+pa>>0]=0;if((ra|0)<(R|0)){ka=ra;do{P=A+(ka<<2)|0;f[P>>2]=(f[P>>2]|0)+(f[L+(ka<<1<<2)>>2]|0);ka=ka+1|0}while((ka|0)!=(R|0))}}else{ka=LVb(V*+n[qa>>2])|0;b[X+pa>>0]=ka>>>0<256?ka:(ka|0)>0?255:0}pa=pa+1|0}while((pa|0)!=(a|0));K=89}else K=89;while(0);if((K|0)==89?(K=0,Q):0){fa=0;do{Z=A+(fa<<2)|0;f[Z>>2]=(f[Z>>2]|0)+(f[L+((fa<<1|1)<<2)>>2]|0);fa=fa+1|0}while((fa|0)!=(R|0))}if(!aa)break;else{X=X+F|0;c=c+1|0}}}}c=f[q>>2]|0;if(c|0){F=f[N>>2]|0;if((F|0)!=(c|0))f[N>>2]=F+(~((F+-4-c|0)>>>2)<<2);O5b(c)}break}case 2:{c=f[z>>2]|0;F=f[E>>2]|0;V=l;N=f[w>>2]|0;X=f[x>>2]|0;aa=f[v+16>>2]|0;L=f[N+(R<<2)>>2]|0;A=f[X+((R<<1|1)<<2)>>2]|0;a=R<<2;if(Q){pa=f[v+44>>2]|0;Vac(r|0,f[i>>2]|0,a|0)|0;Vac(s|0,pa|0,a|0)|0}c:do if(!m){if(!k){f[q>>2]=0;f[q+4>>2]=0;S=aD(q,55)|0;T=232491;U=S+55|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));bO(-5,q,233266,231932,1969);bD(q);break}if(Q)Vac(q|0,k|0,a|0)|0;if(F|0){pa=(c|0)>0;qa=(R|0)==0;ra=c<<1;O=L;M=F;ca=0;while(1){W=L+((Y(A,ca)|0)<<1)|0;M=M+-1|0;d:do if(pa){if(Q)sa=0;else{if(!qa){Nac(W|0,0,ra|0)|0;break}J=LVb(V*+n[aa>>2])|0;fa=(J>>>0<65536?J:(J|0)>0?65535:0)&65535;J=0;while(1){d[O+(J<<1)>>1]=fa;J=J+1|0;if((J|0)==(c|0)){K=163;break d}}}do{J=aa;fa=0;while(1){Z=N+(fa<<2)|0;ka=f[Z>>2]|0;ta=+(j[ka>>1]|0);P=f[q+(fa<<2)>>2]|0;na=f[r+(fa<<2)>>2]|0;ga=-1;while(1){H=ga+1|0;if(!(ta>=+n[P+(H<<2)>>2])){ua=ga;break}if((H|0)<(na|0))ga=H;else{ua=H;break}}if(ua>>>0>=na>>>0){va=J;wa=fa;break}f[Z>>2]=ka+(f[X+(fa<<1<<2)>>2]<<1);ga=J+(Y(f[s+(fa<<2)>>2]|0,ua)|0)|0;P=fa+1|0;if((P|0)<(R|0)){J=ga;fa=P}else{va=ga;wa=P;break}}if((wa|0)!=(R|0)){d[O+(sa<<1)>>1]=0;if((wa|0)<(R|0)){fa=wa;do{J=N+(fa<<2)|0;f[J>>2]=(f[J>>2]|0)+(f[X+(fa<<1<<2)>>2]<<1);fa=fa+1|0}while((fa|0)!=(R|0))}}else{fa=LVb(V*+n[va>>2])|0;d[O+(sa<<1)>>1]=fa>>>0<65536?fa:(fa|0)>0?65535:0}sa=sa+1|0}while((sa|0)!=(c|0));K=163}else K=163;while(0);if((K|0)==163?(K=0,Q):0){W=0;do{fa=N+(W<<2)|0;f[fa>>2]=(f[fa>>2]|0)+(f[X+((W<<1|1)<<2)>>2]<<1);W=W+1|0}while((W|0)!=(R|0))}if(!M)break;else{O=O+(A<<1)|0;ca=ca+1|0}}}}else switch(R|0){case 1:{ta=+p[e>>3];xa=+p[e+8>>3];ca=f[r>>2]|0;O=f[X>>2]|0;M=f[X+4>>2]|0;if(!F)break c;if((c|0)<=0)break c;ra=Y(c,O)|0;qa=L;pa=f[N>>2]|0;W=F;while(1){W=W+-1|0;fa=0;J=pa;while(1){ya=xa+ta*+(j[J>>1]|0);P=~~ya;ga=P-(+(P|0)>ya&1)|0;if(ga>>>0<ca>>>0){P=LVb(V*+n[aa+(ga<<2)>>2])|0;za=(P>>>0<65536?P:(P|0)>0?65535:0)&65535}else za=0;d[qa+(fa<<1)>>1]=za;fa=fa+1|0;if((fa|0)==(c|0))break;else J=J+(O<<1)|0}if(!W)break;else{qa=qa+(A<<1)|0;pa=pa+(ra<<1)+(M<<1)|0}}break}case 2:{ta=+p[e>>3];xa=+p[e+8>>3];ya=+p[e+16>>3];Aa=+p[e+24>>3];M=f[r>>2]|0;ra=f[r+4>>2]|0;pa=f[X>>2]|0;qa=f[X+4>>2]|0;W=f[X+8>>2]|0;O=f[X+12>>2]|0;ca=f[s>>2]|0;if(!((c|0)>0&(F|0)!=0))break c;J=Y(c,pa)|0;fa=Y(c,W)|0;P=f[N>>2]|0;ga=f[N+4>>2]|0;H=L;ba=F;while(1){la=P+(J<<1)|0;ma=0;oa=P;G=ga;while(1){Ba=xa+ta*+(j[oa>>1]|0);da=~~Ba;_=da-(+(da|0)>Ba&1)|0;Ba=Aa+ya*+(j[G>>1]|0);da=~~Ba;ea=da-(+(da|0)>Ba&1)|0;if(_>>>0<M>>>0&ea>>>0<ra>>>0){da=aa+(Y(_,ca)|0)+(ea<<2)|0;ea=LVb(V*+n[da>>2])|0;Ca=(ea>>>0<65536?ea:(ea|0)>0?65535:0)&65535}else Ca=0;d[H+(ma<<1)>>1]=Ca;ma=ma+1|0;if((ma|0)==(c|0))break;else{oa=oa+(pa<<1)|0;G=G+(W<<1)|0}}ba=ba+-1|0;if(!ba)break;else{P=la+(qa<<1)|0;ga=ga+(fa<<1)+(O<<1)|0;H=H+(A<<1)|0}}break}case 3:{ya=+p[e>>3];Aa=+p[e+8>>3];ta=+p[e+16>>3];xa=+p[e+24>>3];Ba=+p[e+32>>3];Da=+p[e+40>>3];H=f[r>>2]|0;O=f[r+4>>2]|0;fa=f[r+8>>2]|0;ga=f[X>>2]|0;qa=f[X+4>>2]|0;P=f[X+8>>2]|0;ba=f[X+12>>2]|0;W=f[X+16>>2]|0;pa=f[X+20>>2]|0;ca=f[s>>2]|0;ra=f[s+4>>2]|0;if(!((c|0)>0&(F|0)!=0))break c;M=Y(c,ga)|0;J=Y(c,P)|0;G=Y(c,W)|0;oa=f[N>>2]|0;ma=f[N+4>>2]|0;ea=f[N+8>>2]|0;da=L;_=F;while(1){_=_+-1|0;ja=ma+(J<<1)|0;$=oa;ia=ma;ha=ea;Ea=0;while(1){Fa=Aa+ya*+(j[$>>1]|0);Ga=~~Fa;Ha=Ga-(+(Ga|0)>Fa&1)|0;Fa=xa+ta*+(j[ia>>1]|0);Ga=~~Fa;Ia=Ga-(+(Ga|0)>Fa&1)|0;Fa=Da+Ba*+(j[ha>>1]|0);Ga=~~Fa;Ja=Ga-(+(Ga|0)>Fa&1)|0;if(Ha>>>0<H>>>0&Ia>>>0<O>>>0&Ja>>>0<fa>>>0){Ga=aa+(Y(Ha,ca)|0)+(Y(Ia,ra)|0)+(Ja<<2)|0;Ja=LVb(V*+n[Ga>>2])|0;Ka=(Ja>>>0<65536?Ja:(Ja|0)>0?65535:0)&65535}else Ka=0;d[da+(Ea<<1)>>1]=Ka;Ea=Ea+1|0;if((Ea|0)==(c|0))break;else{$=$+(ga<<1)|0;ia=ia+(P<<1)|0;ha=ha+(W<<1)|0}}if(!_)break;else{oa=oa+(M<<1)+(qa<<1)|0;ma=ja+(ba<<1)|0;ea=ea+(G<<1)+(pa<<1)|0;da=da+(A<<1)|0}}break}default:{if(!F)break c;da=(k|0)==0;pa=(c|0)>0;G=L;ea=F;while(1){ea=ea+-1|0;if(pa){ba=0;do{e:do if(Q){if(da){ma=aa;qa=0;while(1){M=N+(qa<<2)|0;oa=f[M>>2]|0;_=qa<<1;Ba=+(j[oa>>1]|0)*+p[e+(_<<3)>>3]+ +p[e+((_|1)<<3)>>3];W=~~Ba;P=W-(+(W|0)>Ba&1)|0;if(P>>>0>=(f[r+(qa<<2)>>2]|0)>>>0){La=ma;Ma=qa;break e}f[M>>2]=oa+(f[X+(_<<2)>>2]<<1);_=ma+(Y(f[s+(qa<<2)>>2]|0,P)|0)|0;P=qa+1|0;if((P|0)<(R|0)){ma=_;qa=P}else{La=_;Ma=P;break e}}}else{Na=aa;Oa=0}while(1){qa=N+(Oa<<2)|0;ma=f[qa>>2]|0;P=d[ma>>1]|0;_=Oa<<1;Ba=+(P&65535)*+p[e+(_<<3)>>3]+ +p[e+((_|1)<<3)>>3];oa=~~Ba;M=oa-(+(oa|0)>Ba&1)|0;if(M>>>0>=(f[r+(Oa<<2)>>2]|0)>>>0){La=Na;Ma=Oa;break e}if(+(P&65535)>=+n[(f[k+(Oa<<2)>>2]|0)+4>>2]){La=Na;Ma=Oa;break e}f[qa>>2]=ma+(f[X+(_<<2)>>2]<<1);_=Na+(Y(f[s+(Oa<<2)>>2]|0,M)|0)|0;M=Oa+1|0;if((M|0)<(R|0)){Na=_;Oa=M}else{La=_;Ma=M;break}}}else{La=aa;Ma=0}while(0);if((Ma|0)!=(R|0)){d[G+(ba<<1)>>1]=0;if((Ma|0)<(R|0)){M=Ma;do{_=N+(M<<2)|0;f[_>>2]=(f[_>>2]|0)+(f[X+(M<<1<<2)>>2]<<1);M=M+1|0}while((M|0)!=(R|0))}}else{M=LVb(V*+n[La>>2])|0;d[G+(ba<<1)>>1]=M>>>0<65536?M:(M|0)>0?65535:0}ba=ba+1|0}while((ba|0)!=(c|0))}if(Q){ba=0;do{ja=N+(ba<<2)|0;f[ja>>2]=(f[ja>>2]|0)+(f[X+((ba<<1|1)<<2)>>2]<<1);ba=ba+1|0}while((ba|0)!=(R|0))}if(!ea)break;else G=G+(A<<1)|0}}}while(0);break}case 5:{A=f[z>>2]|0;z=f[E>>2]|0;V=l;E=f[w>>2]|0;X=f[x>>2]|0;N=f[v+16>>2]|0;c=f[E+(R<<2)>>2]|0;La=f[X+((R<<1|1)<<2)>>2]|0;Ma=R<<2;if(Q){aa=f[v+44>>2]|0;Vac(r|0,f[i>>2]|0,Ma|0)|0;Vac(s|0,aa|0,Ma|0)|0}f:do if(!m){if(!k){f[q>>2]=0;f[q+4>>2]=0;S=aD(q,55)|0;T=232491;U=S+55|0;do{b[S>>0]=b[T>>0]|0;S=S+1|0;T=T+1|0}while((S|0)<(U|0));bO(-5,q,233266,231932,1969);bD(q);break}if(Q)Vac(q|0,k|0,Ma|0)|0;if(z|0){aa=(A|0)>0;Oa=(R|0)==0;Na=A<<2;F=c;L=z;Ka=0;while(1){Ca=c+((Y(La,Ka)|0)<<2)|0;L=L+-1|0;g:do if(aa){if(!Q)if(Oa){za=0;while(1){n[F+(za<<2)>>2]=V*+n[N>>2];za=za+1|0;if((za|0)==(A|0)){K=234;break g}}}else{Nac(Ca|0,0,Na|0)|0;break}else Pa=0;do{za=N;sa=0;while(1){va=E+(sa<<2)|0;wa=f[va>>2]|0;l=+n[wa>>2];ua=f[q+(sa<<2)>>2]|0;a=f[r+(sa<<2)>>2]|0;G=-1;while(1){ea=G+1|0;if(!(l>=+n[ua+(ea<<2)>>2])){Qa=G;break}if((ea|0)<(a|0))G=ea;else{Qa=ea;break}}if(Qa>>>0>=a>>>0){Ra=za;Sa=sa;break}f[va>>2]=wa+(f[X+(sa<<1<<2)>>2]<<2);G=za+(Y(f[s+(sa<<2)>>2]|0,Qa)|0)|0;ua=sa+1|0;if((ua|0)<(R|0)){za=G;sa=ua}else{Ra=G;Sa=ua;break}}if((Sa|0)!=(R|0)){n[F+(Pa<<2)>>2]=0.0;if((Sa|0)<(R|0)){sa=Sa;do{za=E+(sa<<2)|0;f[za>>2]=(f[za>>2]|0)+(f[X+(sa<<1<<2)>>2]<<2);sa=sa+1|0}while((sa|0)!=(R|0))}}else n[F+(Pa<<2)>>2]=V*+n[Ra>>2];Pa=Pa+1|0}while((Pa|0)!=(A|0));K=234}else K=234;while(0);if((K|0)==234?(K=0,Q):0){Ca=0;do{sa=E+(Ca<<2)|0;f[sa>>2]=(f[sa>>2]|0)+(f[X+((Ca<<1|1)<<2)>>2]<<2);Ca=Ca+1|0}while((Ca|0)!=(R|0))}if(!L)break;else{F=F+(La<<2)|0;Ka=Ka+1|0}}}}else switch(R|0){case 1:{l=+p[e>>3];Ba=+p[e+8>>3];Ka=f[r>>2]|0;F=f[X>>2]|0;L=f[X+4>>2]|0;if(!z)break f;if((A|0)<=0)break f;Na=Y(A,F)|0;Oa=c;aa=f[E>>2]|0;Ca=z;while(1){Ca=Ca+-1|0;sa=0;za=aa;while(1){Da=Ba+l*+n[za>>2];ua=~~Da;G=ua-(+(ua|0)>Da&1)|0;if(G>>>0<Ka>>>0)Ta=V*+n[N+(G<<2)>>2];else Ta=0.0;n[Oa+(sa<<2)>>2]=Ta;sa=sa+1|0;if((sa|0)==(A|0))break;else za=za+(F<<2)|0}if(!Ca)break;else{Oa=Oa+(La<<2)|0;aa=aa+(Na<<2)+(L<<2)|0}}break}case 2:{l=+p[e>>3];Ba=+p[e+8>>3];Da=+p[e+16>>3];ta=+p[e+24>>3];L=f[r>>2]|0;Na=f[r+4>>2]|0;aa=f[X>>2]|0;Oa=f[X+4>>2]|0;Ca=f[X+8>>2]|0;F=f[X+12>>2]|0;Ka=f[s>>2]|0;if(!((A|0)>0&(z|0)!=0))break f;za=Y(A,aa)|0;sa=Y(A,Ca)|0;G=f[E>>2]|0;ua=f[E+4>>2]|0;ka=c;Z=z;while(1){na=G+(za<<2)|0;ea=0;da=G;pa=ua;while(1){xa=Ba+l*+n[da>>2];ba=~~xa;ja=ba-(+(ba|0)>xa&1)|0;xa=ta+Da*+n[pa>>2];ba=~~xa;M=ba-(+(ba|0)>xa&1)|0;if(ja>>>0<L>>>0&M>>>0<Na>>>0){ba=N+(Y(ja,Ka)|0)+(M<<2)|0;Ua=V*+n[ba>>2]}else Ua=0.0;n[ka+(ea<<2)>>2]=Ua;ea=ea+1|0;if((ea|0)==(A|0))break;else{da=da+(aa<<2)|0;pa=pa+(Ca<<2)|0}}Z=Z+-1|0;if(!Z)break;else{G=na+(Oa<<2)|0;ua=ua+(sa<<2)+(F<<2)|0;ka=ka+(La<<2)|0}}break}case 3:{Da=+p[e>>3];ta=+p[e+8>>3];l=+p[e+16>>3];Ba=+p[e+24>>3];xa=+p[e+32>>3];ya=+p[e+40>>3];ka=f[r>>2]|0;F=f[r+4>>2]|0;sa=f[r+8>>2]|0;ua=f[X>>2]|0;Oa=f[X+4>>2]|0;G=f[X+8>>2]|0;Z=f[X+12>>2]|0;Ca=f[X+16>>2]|0;aa=f[X+20>>2]|0;Ka=f[s>>2]|0;Na=f[s+4>>2]|0;if(!((A|0)>0&(z|0)!=0))break f;L=Y(A,ua)|0;za=Y(A,G)|0;pa=Y(A,Ca)|0;da=f[E>>2]|0;ea=f[E+4>>2]|0;ba=f[E+8>>2]|0;M=c;ja=z;while(1){ja=ja+-1|0;_=ea+(za<<2)|0;ma=da;qa=ea;P=ba;oa=0;while(1){Aa=ta+Da*+n[ma>>2];W=~~Aa;ga=W-(+(W|0)>Aa&1)|0;Aa=Ba+l*+n[qa>>2];W=~~Aa;ra=W-(+(W|0)>Aa&1)|0;Aa=ya+xa*+n[P>>2];W=~~Aa;ca=W-(+(W|0)>Aa&1)|0;if(ga>>>0<ka>>>0&ra>>>0<F>>>0&ca>>>0<sa>>>0){W=N+(Y(ga,Ka)|0)+(Y(ra,Na)|0)+(ca<<2)|0;Va=V*+n[W>>2]}else Va=0.0;n[M+(oa<<2)>>2]=Va;oa=oa+1|0;if((oa|0)==(A|0))break;else{ma=ma+(ua<<2)|0;qa=qa+(G<<2)|0;P=P+(Ca<<2)|0}}if(!ja)break;else{da=da+(L<<2)+(Oa<<2)|0;ea=_+(Z<<2)|0;ba=ba+(pa<<2)+(aa<<2)|0;M=M+(La<<2)|0}}break}default:{if(!z)break f;M=(k|0)==0;aa=(A|0)>0;pa=c;ba=z;while(1){ba=ba+-1|0;if(aa){Z=0;do{h:do if(Q){if(M){ea=N;Oa=0;while(1){L=E+(Oa<<2)|0;da=f[L>>2]|0;ja=Oa<<1;xa=+n[da>>2]*+p[e+(ja<<3)>>3]+ +p[e+((ja|1)<<3)>>3];Ca=~~xa;G=Ca-(+(Ca|0)>xa&1)|0;if(G>>>0>=(f[r+(Oa<<2)>>2]|0)>>>0){Wa=ea;Xa=Oa;break h}f[L>>2]=da+(f[X+(ja<<2)>>2]<<2);ja=ea+(Y(f[s+(Oa<<2)>>2]|0,G)|0)|0;G=Oa+1|0;if((G|0)<(R|0)){ea=ja;Oa=G}else{Wa=ja;Xa=G;break h}}}else{Ya=N;Za=0}while(1){Oa=E+(Za<<2)|0;ea=f[Oa>>2]|0;xa=+n[ea>>2];G=Za<<1;ya=xa*+p[e+(G<<3)>>3]+ +p[e+((G|1)<<3)>>3];ja=~~ya;da=ja-(+(ja|0)>ya&1)|0;if(da>>>0>=(f[r+(Za<<2)>>2]|0)>>>0){Wa=Ya;Xa=Za;break h}if(xa>=+n[(f[k+(Za<<2)>>2]|0)+4>>2]){Wa=Ya;Xa=Za;break h}f[Oa>>2]=ea+(f[X+(G<<2)>>2]<<2);G=Ya+(Y(f[s+(Za<<2)>>2]|0,da)|0)|0;da=Za+1|0;if((da|0)<(R|0)){Ya=G;Za=da}else{Wa=G;Xa=da;break}}}else{Wa=N;Xa=0}while(0);if((Xa|0)!=(R|0)){n[pa+(Z<<2)>>2]=0.0;if((Xa|0)<(R|0)){da=Xa;do{G=E+(da<<2)|0;f[G>>2]=(f[G>>2]|0)+(f[X+(da<<1<<2)>>2]<<2);da=da+1|0}while((da|0)!=(R|0))}}else n[pa+(Z<<2)>>2]=V*+n[Wa>>2];Z=Z+1|0}while((Z|0)!=(A|0))}if(Q){Z=0;do{_=E+(Z<<2)|0;f[_>>2]=(f[_>>2]|0)+(f[X+((Z<<1|1)<<2)>>2]<<2);Z=Z+1|0}while((Z|0)!=(R|0))}if(!ba)break;else pa=pa+(La<<2)|0}}}while(0);break}default:{f[q>>2]=0;f[q+4>>2]=0;bO(-210,q,233250,231932,2126);bD(q)}}q=B+36|0;La=f[q>>2]|0;if(La|0?(R=La+12|0,La=f[R>>2]|0,f[R>>2]=La+-1,(La|0)==1):0)kL(B);f[q>>2]=0;q=B+16|0;La=B+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[La>>2]|0)>0){q=f[B+40>>2]|0;R=0;do{f[q+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[La>>2]|0))}La=f[B+44>>2]|0;if((La|0)!=(B+48|0))UC(La);La=f[y>>2]|0;if(La|0){y=f[C>>2]|0;if((y|0)!=(La|0))f[C>>2]=y+(~((y+-8-La|0)>>>3)<<3);O5b(La)}La=f[x>>2]|0;if(La|0){x=f[D>>2]|0;if((x|0)!=(La|0))f[D>>2]=x+(~((x+-4-La|0)>>>2)<<2);O5b(La)}La=f[w>>2]|0;if(La|0){w=f[g>>2]|0;if((w|0)!=(La|0))f[g>>2]=w+(~((w+-4-La|0)>>>2)<<2);O5b(La)}La=v+36|0;w=f[La>>2]|0;if(w|0?(g=w+12|0,w=f[g>>2]|0,f[g>>2]=w+-1,(w|0)==1):0)kL(v);f[La>>2]=0;La=v+16|0;f[La>>2]=0;f[La+4>>2]=0;f[La+8>>2]=0;f[La+12>>2]=0;if((f[I>>2]|0)>0){La=f[i>>2]|0;i=0;do{f[La+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[I>>2]|0))}I=f[v+44>>2]|0;if((I|0)!=(v+48|0))UC(I);if(!(f[t+4>>2]|0)){u=o;return}u=o;return}function a3(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;i=u;u=u+3696|0;j=i+3688|0;k=i+3632|0;l=i+3576|0;m=i+1520|0;n=i+56|0;o=i;dQ(j,51704);do if((yM(d)|0)==65536){p=f[d+4>>2]|0;f[k>>2]=f[p>>2];q=k+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=k+8|0;f[s>>2]=f[p+8>>2];f[k+12>>2]=f[p+12>>2];f[k+16>>2]=f[p+16>>2];f[k+20>>2]=f[p+20>>2];f[k+24>>2]=f[p+24>>2];f[k+28>>2]=f[p+28>>2];f[k+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[k+36>>2]=t;f[k+40>>2]=s;s=k+48|0;v=k+44|0;f[v>>2]=s;f[s>>2]=0;f[k+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];w=k;break}else{f[q>>2]=0;jL(k,p);w=k;break}}else{yL(k,d,-1);w=k}while(0);f[l>>2]=1124007936;p=l+4|0;q=l+8|0;r=l+40|0;s=p;v=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(v|0));f[r>>2]=q;t=l+48|0;x=l+44|0;f[x>>2]=t;f[t>>2]=0;f[l+52>>2]=0;y=f[w>>2]|0;z=y>>>3&511;A=z+1|0;if(z){if(!(y&16384)){f[m>>2]=0;f[m+4>>2]=0;s=aD(m,17)|0;B=233395;v=s+17|0;do{b[s>>0]=b[B>>0]|0;s=s+1|0;B=B+1|0}while((s|0)<(v|0));bO(-215,m,233250,231932,2468);bD(m);C=f[w>>2]|0}else C=y;y=f[k+4>>2]|0;Vac(m|0,f[k+40>>2]|0,y<<2|0)|0;f[m+(y<<2)>>2]=A;oL(n,y+1|0,m,C&7,f[k+16>>2]|0,0);C=n+36|0;y=f[C>>2]|0;if(y|0){A=y+12|0;f[A>>2]=(f[A>>2]|0)+1}A=l+36|0;y=f[A>>2]|0;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)kL(l);f[A>>2]=0;y=l+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[p>>2]|0)>0){z=f[r>>2]|0;D=0;do{f[z+(D<<2)>>2]=0;D=D+1|0;E=f[p>>2]|0}while((D|0)<(E|0));f[l>>2]=f[n>>2];if((E|0)<3)F=21;else F=23}else{f[l>>2]=f[n>>2];F=21}if((F|0)==21){E=f[n+4>>2]|0;if((E|0)<3){f[p>>2]=E;f[q>>2]=f[n+8>>2];f[l+12>>2]=f[n+12>>2];E=f[n+44>>2]|0;D=f[x>>2]|0;f[D>>2]=f[E>>2];f[D+4>>2]=f[E+4>>2]}else F=23}if((F|0)==23)jL(l,n);E=n+16|0;f[y>>2]=f[E>>2];f[l+20>>2]=f[n+20>>2];f[l+24>>2]=f[n+24>>2];f[l+28>>2]=f[n+28>>2];f[l+32>>2]=f[n+32>>2];y=f[C>>2]|0;f[A>>2]=y;if(y|0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0)kL(n);f[C>>2]=0;C=n+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[C>>2]|0)>0){E=f[n+40>>2]|0;y=0;do{f[E+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[C>>2]|0))}C=f[n+44>>2]|0;if((C|0)!=(n+48|0))UC(C)}else{C=k+36|0;y=f[C>>2]|0;if(y){E=y+12|0;f[E>>2]=(f[E>>2]|0)+1;E=l+36|0;y=f[E>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){kL(l);G=E}else G=E}else G=l+36|0;f[G>>2]=0;E=l+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[p>>2]|0)>0){y=f[r>>2]|0;A=0;do{f[y+(A<<2)>>2]=0;A=A+1|0;H=f[p>>2]|0}while((A|0)<(H|0));f[l>>2]=f[w>>2];if((H|0)<3)F=43;else F=45}else{f[l>>2]=f[w>>2];F=43}if((F|0)==43){w=f[k+4>>2]|0;if((w|0)<3){f[p>>2]=w;f[q>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];w=f[k+44>>2]|0;H=f[x>>2]|0;f[H>>2]=f[w>>2];f[H+4>>2]=f[w+4>>2]}else F=45}if((F|0)==45)jL(l,k);f[E>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];f[G>>2]=f[C>>2]}C=(f[q>>2]|0)==1;q=(f[l+12>>2]|0)==1;G=C|q;E=f[p>>2]|0;w=(f[g+4>>2]|0)-(f[g>>2]|0)|0;H=w>>2;A=(f[c+4>>2]|0)-(f[c>>2]|0)>>2;y=EM(a,-1)|0;D=(y|0)>0;if(!D){f[m>>2]=0;f[m+4>>2]=0;s=aD(m,11)|0;B=233413;v=s+11|0;do{b[s>>0]=b[B>>0]|0;s=s+1|0;B=B+1|0}while((s|0)<(v|0));bO(-215,m,233250,231932,2481);bD(m)}do if((H|0)!=(E<<1|0)?(H|0)!=2|(C|q)^1:0){if((H|0)==0?(FM(a,0)|0)==0:0)break;f[m>>2]=0;f[m+4>>2]=0;s=aD(m,72)|0;B=233425;v=s+72|0;do{b[s>>0]=b[B>>0]|0;s=s+1|0;B=B+1|0}while((s|0)<(v|0));bO(-215,m,233250,231932,2482);bD(m)}while(0);q=(A|0)==0;if(!(q|(A|0)==(E|0))?(A|0)!=1|G^1:0){f[m>>2]=0;f[m+4>>2]=0;s=aD(m,44)|0;B=233498;v=s+44|0;do{b[s>>0]=b[B>>0]|0;s=s+1|0;B=B+1|0}while((s|0)<(v|0));bO(-215,m,233250,231932,2483);bD(m)}if((w|0)>0?(B=(H|0)/2|0,(w|0)>4):0){w=f[g>>2]|0;g=0;do{f[m+(g<<2)>>2]=w+(g<<1<<2);g=g+1|0}while((g|0)<(B|0))}FI(n,y);if(D){D=o+4|0;B=o+8|0;g=o+12|0;w=o+16|0;s=o+20|0;v=o+24|0;G=o+28|0;A=o+32|0;E=o+36|0;C=o+40|0;z=o+48|0;I=o+44|0;J=0;do{yL(o,a,J);K=f[n>>2]|0;L=K+(J*56|0)|0;if((L|0)!=(o|0)){M=f[E>>2]|0;if(M|0){N=M+12|0;f[N>>2]=(f[N>>2]|0)+1}N=K+(J*56|0)+36|0;M=f[N>>2]|0;if(M|0?(O=M+12|0,M=f[O>>2]|0,f[O>>2]=M+-1,(M|0)==1):0)kL(L);f[N>>2]=0;M=K+(J*56|0)+16|0;O=K+(J*56|0)+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[O>>2]|0)>0){P=f[K+(J*56|0)+40>>2]|0;Q=0;do{f[P+(Q<<2)>>2]=0;Q=Q+1|0;R=f[O>>2]|0}while((Q|0)<(R|0));f[L>>2]=f[o>>2];if((R|0)<3)F=75;else F=77}else{f[L>>2]=f[o>>2];F=75}if((F|0)==75){F=0;Q=f[D>>2]|0;if((Q|0)<3){f[O>>2]=Q;f[K+(J*56|0)+8>>2]=f[B>>2];f[K+(J*56|0)+12>>2]=f[g>>2];Q=f[I>>2]|0;P=f[K+(J*56|0)+44>>2]|0;f[P>>2]=f[Q>>2];f[P+4>>2]=f[Q+4>>2]}else F=77}if((F|0)==77){F=0;jL(L,o)}f[M>>2]=f[w>>2];f[K+(J*56|0)+20>>2]=f[s>>2];f[K+(J*56|0)+24>>2]=f[v>>2];f[K+(J*56|0)+28>>2]=f[G>>2];f[K+(J*56|0)+32>>2]=f[A>>2];f[N>>2]=f[E>>2]}Q=f[E>>2]|0;if(Q|0?(P=Q+12|0,Q=f[P>>2]|0,f[P>>2]=Q+-1,(Q|0)==1):0)kL(o);f[E>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[D>>2]|0)>0){Q=f[C>>2]|0;P=0;do{f[Q+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[D>>2]|0))}P=f[I>>2]|0;if((P|0)!=(z|0))UC(P);J=J+1|0}while((J|0)<(y|0));S=n}else S=n;$2(f[S>>2]|0,y,q?0:f[c>>2]|0,d,e,H|0?m:0,h,1);GI(n);n=l+36|0;m=f[n>>2]|0;if(m|0?(H=m+12|0,m=f[H>>2]|0,f[H>>2]=m+-1,(m|0)==1):0)kL(l);f[n>>2]=0;n=l+16|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[p>>2]|0)>0){n=f[r>>2]|0;r=0;do{f[n+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[p>>2]|0))}p=f[x>>2]|0;if((p|0)!=(t|0))UC(p);p=k+36|0;t=f[p>>2]|0;if(t|0?(x=t+12|0,t=f[x>>2]|0,f[x>>2]=t+-1,(t|0)==1):0)kL(k);f[p>>2]=0;p=k+16|0;t=k+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[t>>2]|0)>0){p=f[k+40>>2]|0;x=0;do{f[p+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[t>>2]|0))}t=f[k+44>>2]|0;if((t|0)!=(k+48|0))UC(t);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}
function Cma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+32|0;e=d;switch(b-a>>5|0){case 2:{g=b+-32|0;h=f[g>>2]|0;i=f[a>>2]|0;if((h|0)==(i|0)){j=b+-24|0;k=f[j>>2]|0;l=f[j+4>>2]|0;j=a+8|0;m=f[j>>2]|0;n=f[j+4>>2]|0;if((k|0)==(m|0)&(l|0)==(n|0)){j=b+-16|0;o=a+16|0;p=f[j+4>>2]|0;q=f[o+4>>2]|0;r=f[j>>2]|0;s=f[o>>2]|0}else{p=l;q=n;r=k;s=m}if(!((p|0)<(q|0)|(p|0)==(q|0)&r>>>0<s>>>0)){t=1;u=d;return t|0}}else if((h|0)>=(i|0)){t=1;u=d;return t|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[e+16>>2]=f[a+16>>2];f[e+20>>2]=f[a+20>>2];f[e+24>>2]=f[a+24>>2];f[e+28>>2]=f[a+28>>2];f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2];f[a+8>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[a+16>>2]=f[g+16>>2];f[a+20>>2]=f[g+20>>2];f[a+24>>2]=f[g+24>>2];f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];f[g+16>>2]=f[e+16>>2];f[g+20>>2]=f[e+20>>2];f[g+24>>2]=f[e+24>>2];t=1;u=d;return t|0}case 3:{zma(a,a+32|0,b+-32|0,c)|0;t=1;u=d;return t|0}case 4:{Ama(a,a+32|0,a+64|0,b+-32|0,c)|0;t=1;u=d;return t|0}case 5:{Bma(a,a+32|0,a+64|0,a+96|0,b+-32|0,c)|0;t=1;u=d;return t|0}case 1:case 0:{t=1;u=d;return t|0}default:{g=a+64|0;zma(a,a+32|0,g,c)|0;c=a+96|0;a:do if((c|0)==(b|0)){v=1;w=0}else{i=c;h=0;s=g;while(1){r=f[i>>2]|0;q=f[s>>2]|0;if((r|0)==(q|0)){p=i+8|0;m=f[p>>2]|0;k=f[p+4>>2]|0;p=s+8|0;n=f[p>>2]|0;l=f[p+4>>2]|0;if((m|0)==(n|0)&(k|0)==(l|0)){p=i+16|0;o=s+16|0;x=f[p+4>>2]|0;y=f[o+4>>2]|0;z=f[p>>2]|0;A=f[o>>2]|0}else{x=k;y=l;z=m;A=n}if((x|0)<(y|0)|(x|0)==(y|0)&z>>>0<A>>>0){B=m;C=k;D=19}else E=h}else if((r|0)<(q|0)){q=i+8|0;B=f[q>>2]|0;C=f[q+4>>2]|0;D=19}else E=h;if((D|0)==19){D=0;q=f[i+4>>2]|0;k=i+16|0;m=f[k>>2]|0;n=f[k+4>>2]|0;k=i+24|0;l=f[k+4>>2]|0;o=e;f[o>>2]=f[k>>2];f[o+4>>2]=l;f[i>>2]=f[s>>2];f[i+4>>2]=f[s+4>>2];f[i+8>>2]=f[s+8>>2];f[i+12>>2]=f[s+12>>2];f[i+16>>2]=f[s+16>>2];f[i+20>>2]=f[s+20>>2];f[i+24>>2]=f[s+24>>2];b:do if((s|0)==(a|0))F=a;else{l=s;while(1){o=l;l=l+-32|0;k=f[l>>2]|0;if((r|0)==(k|0)){p=o+-24|0;j=f[p>>2]|0;G=f[p+4>>2]|0;if((B|0)==(j|0)&(C|0)==(G|0)){p=o+-16|0;H=n;I=f[p+4>>2]|0;J=m;K=f[p>>2]|0}else{H=C;I=G;J=B;K=j}if(!((H|0)<(I|0)|(H|0)==(I|0)&J>>>0<K>>>0)){F=o;break b}}else if((r|0)>=(k|0)){F=o;break b};f[o>>2]=f[l>>2];f[o+4>>2]=f[l+4>>2];f[o+8>>2]=f[l+8>>2];f[o+12>>2]=f[l+12>>2];f[o+16>>2]=f[l+16>>2];f[o+20>>2]=f[l+20>>2];f[o+24>>2]=f[l+24>>2];if((l|0)==(a|0)){F=a;break}}}while(0);f[F>>2]=r;f[F+4>>2]=q;l=F+8|0;f[l>>2]=B;f[l+4>>2]=C;l=F+16|0;f[l>>2]=m;f[l+4>>2]=n;f[F+24>>2]=f[e>>2];l=h+1|0;if((l|0)==8){v=0;w=(i+32|0)==(b|0);break a}else E=l}l=i+32|0;if((l|0)==(b|0)){v=1;w=0;break}else{o=i;i=l;h=E;s=o}}}while(0);t=w|v;u=d;return t|0}}return 0}function Dma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>5>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>134217727){g=ze(8)|0;T5b(g,477177);f[g>>2]=149528;If(g|0,25408,1411)}g=(f[e>>2]|0)-d|0;h=g>>5;i=L5b(b<<5)|0;j=i+(h<<5)|0;k=j+(0-h<<5)|0;if((g|0)>0)Vac(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<5);if(!d)return;O5b(d);return}function Ema(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;j=u;u=u+160|0;k=j+152|0;l=j+96|0;m=j+64|0;n=j;dQ(k,61096);do if((yM(a)|0)==65536){o=f[a+4>>2]|0;f[l>>2]=f[o>>2];p=l+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=l+8|0;f[r>>2]=f[o+8>>2];f[l+12>>2]=f[o+12>>2];f[l+16>>2]=f[o+16>>2];f[l+20>>2]=f[o+20>>2];f[l+24>>2]=f[o+24>>2];f[l+28>>2]=f[o+28>>2];f[l+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[l+36>>2]=s;f[l+40>>2]=r;r=l+48|0;t=l+44|0;f[t>>2]=r;f[r>>2]=0;f[l+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;jL(l,o);break}}else yL(l,a,-1);while(0);if((h|0)==16)v=(f[l>>2]&7|0)==0?16:8;else v=h;if((g|0)>=32768){f[m>>2]=0;f[m+4>>2]=0;w=aD(m,26)|0;x=267592;y=w+26|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,m,267619,267135,1856);bD(m)}if(i>>>0>=17){f[m>>2]=0;f[m+4>>2]=0;w=aD(m,31)|0;x=267392;y=w+31|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,m,267619,267135,1857);bD(m)}xM(e,m,f[l>>2]&4095,0);e=f[c>>2]|0;x=((e|0)<0)<<31>>31;w=f[c+4>>2]|0;c=((w|0)<0)<<31>>31;y=n;f[y>>2]=e;f[y+4>>2]=x;y=n+8|0;f[y>>2]=w;f[y+4>>2]=c;y=f[d>>2]|0;h=((y|0)<0)<<31>>31;a=n+16|0;f[a>>2]=y;f[a+4>>2]=h;a=n+24|0;f[a>>2]=w;f[a+4>>2]=c;c=f[d+4>>2]|0;d=((c|0)<0)<<31>>31;a=n+32|0;f[a>>2]=y;f[a+4>>2]=h;h=n+40|0;f[h>>2]=c;f[h+4>>2]=d;h=n+48|0;f[h>>2]=e;f[h+4>>2]=x;x=n+56|0;f[x>>2]=c;f[x+4>>2]=d;if((g|0)>-1)uma(l,n,4,1,m,g,v,i);else pma(l,n,4,m,v,i);i=l+36|0;v=f[i>>2]|0;if(v|0?(m=v+12|0,v=f[m>>2]|0,f[m>>2]=v+-1,(v|0)==1):0)kL(l);f[i>>2]=0;i=l+16|0;v=l+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[v>>2]|0)>0){i=f[l+40>>2]|0;m=0;do{f[i+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[v>>2]|0))}v=f[l+44>>2]|0;if((v|0)!=(l+48|0))UC(v);if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function Fma(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;j=u;u=u+144|0;k=j+128|0;l=j+72|0;m=j+32|0;n=j+16|0;o=j;p=j+64|0;dQ(k,61116);do if((yM(a)|0)==65536){q=f[a+4>>2]|0;f[l>>2]=f[q>>2];r=l+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=l+8|0;f[t>>2]=f[q+8>>2];f[l+12>>2]=f[q+12>>2];f[l+16>>2]=f[q+16>>2];f[l+20>>2]=f[q+20>>2];f[l+24>>2]=f[q+24>>2];f[l+28>>2]=f[q+28>>2];f[l+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[l+36>>2]=v;f[l+40>>2]=t;t=l+48|0;w=l+44|0;f[w>>2]=t;f[t>>2]=0;f[l+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;jL(l,q);break}}else yL(l,a,-1);while(0);if((h|0)==16)x=(f[l>>2]&7|0)==0?16:8;else x=h;if(!((i|0)<17&((g|0)<32768&(i|d|0)>-1))){f[m>>2]=0;f[m+4>>2]=0;h=aD(m,76)|0;a=267711;q=h+76|0;do{b[h>>0]=b[a>>0]|0;h=h+1|0;a=a+1|0}while((h|0)<(q|0));bO(-215,m,267788,267135,1902);bD(m)}xM(e,m,f[l>>2]&4095,0);if((i|0)>0|((g|0)>1|(x|0)!=8)){e=f[c>>2]|0;a=f[c+4>>2]|0;h=16-i|0;i=$ac(e|0,((e|0)<0)<<31>>31|0,h|0)|0;e=J;q=$ac(a|0,((a|0)<0)<<31>>31|0,h|0)|0;a=J;r=$ac(d|0,((d|0)<0)<<31>>31|0,h|0)|0;h=J;s=n;f[s>>2]=i;f[s+4>>2]=e;e=n+8|0;f[e>>2]=q;f[e+4>>2]=a;a=o;f[a>>2]=r;f[a+4>>2]=h;a=o+8|0;f[a>>2]=r;f[a+4>>2]=h;rma(l,n,o,0,0,360,m,g,x)}else{f[p>>2]=f[c>>2];f[p+4>>2]=f[c+4>>2];qma(l,p,d,m,g>>>31)}g=l+36|0;m=f[g>>2]|0;if(m|0?(d=m+12|0,m=f[d>>2]|0,f[d>>2]=m+-1,(m|0)==1):0)kL(l);f[g>>2]=0;g=l+16|0;m=l+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[m>>2]|0)>0){g=f[l+40>>2]|0;d=0;do{f[g+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))UC(m);if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function Gma(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;m=u;u=u+128|0;n=m+120|0;o=m+64|0;p=m+32|0;q=m+16|0;r=m;dQ(n,61136);do if((yM(a)|0)==65536){s=f[a+4>>2]|0;f[o>>2]=f[s>>2];t=o+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=o+8|0;f[w>>2]=f[s+8>>2];f[o+12>>2]=f[s+12>>2];f[o+16>>2]=f[s+16>>2];f[o+20>>2]=f[s+20>>2];f[o+24>>2]=f[s+24>>2];f[o+28>>2]=f[s+28>>2];f[o+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[o+36>>2]=x;f[o+40>>2]=w;w=o+48|0;y=o+44|0;f[y>>2]=w;f[w>>2]=0;f[o+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;jL(o,s);break}}else yL(o,a,-1);while(0);if((k|0)==16)z=(f[o>>2]&7|0)==0?16:8;else z=k;if(!((f[d>>2]|0)>-1?(l|0)<17&((j|0)<32768?(f[d+4>>2]|l|0)>-1:0):0)){f[p>>2]=0;f[p+4>>2]=0;k=aD(p,100)|0;a=267872;s=k+100|0;do{b[k>>0]=b[a>>0]|0;k=k+1|0;a=a+1|0}while((k|0)<(s|0));bO(-215,p,267973,267135,1934);bD(p)}xM(i,p,f[o>>2]&4095,0);i=MVb(e)|0;a=MVb(g)|0;k=MVb(h)|0;s=f[c>>2]|0;t=f[c+4>>2]|0;c=f[d>>2]|0;v=f[d+4>>2]|0;d=16-l|0;l=$ac(s|0,((s|0)<0)<<31>>31|0,d|0)|0;s=J;w=$ac(t|0,((t|0)<0)<<31>>31|0,d|0)|0;t=J;y=$ac(c|0,((c|0)<0)<<31>>31|0,d|0)|0;c=J;x=$ac(v|0,((v|0)<0)<<31>>31|0,d|0)|0;d=q;f[d>>2]=l;f[d+4>>2]=s;s=q+8|0;f[s>>2]=w;f[s+4>>2]=t;t=r;f[t>>2]=y;f[t+4>>2]=c;c=r+8|0;f[c>>2]=x;f[c+4>>2]=J;rma(o,q,r,i,a,k,p,j,z);z=o+36|0;j=f[z>>2]|0;if(j|0?(p=j+12|0,j=f[p>>2]|0,f[p>>2]=j+-1,(j|0)==1):0)kL(o);f[z>>2]=0;z=o+16|0;j=o+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[j>>2]|0)>0){z=f[o+40>>2]|0;p=0;do{f[z+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[j>>2]|0))}j=f[o+44>>2]|0;if((j|0)!=(o+48|0))UC(j);if(!(f[n+4>>2]|0)){u=m;return}u=m;return}function Hma(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0;h=u;u=u+128|0;i=h+120|0;j=h+64|0;k=h+32|0;l=h+16|0;m=h;dQ(i,61156);do if((yM(a)|0)==65536){o=f[a+4>>2]|0;f[j>>2]=f[o>>2];p=j+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=j+8|0;f[r>>2]=f[o+8>>2];f[j+12>>2]=f[o+12>>2];f[j+16>>2]=f[o+16>>2];f[j+20>>2]=f[o+20>>2];f[j+24>>2]=f[o+24>>2];f[j+28>>2]=f[o+28>>2];f[j+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[j+36>>2]=s;f[j+40>>2]=r;r=j+48|0;t=j+44|0;f[t>>2]=r;f[r>>2]=0;f[j+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;jL(j,o);break}}else yL(j,a,-1);while(0);if((g|0)==16)v=(f[j>>2]&7|0)==0?16:8;else v=g;g=c+8|0;if(!(+n[g>>2]>=0.0?((e|0)<32768?+n[c+12>>2]>=0.0:0):0)){f[k>>2]=0;f[k+4>>2]=0;a=aD(k,73)|0;o=268084;p=a+73|0;do{b[a>>0]=b[o>>0]|0;a=a+1|0;o=o+1|0}while((a|0)<(p|0));bO(-215,k,267973,267135,1964);bD(k)}xM(d,k,f[j>>2]&4095,0);d=LVb(+n[c+16>>2])|0;w=+n[c>>2];o=LVb(w)|0;x=+n[c+4>>2];a=LVb(x)|0;p=$ac(o|0,((o|0)<0)<<31>>31|0,16)|0;q=J;r=LVb((w-+(o|0))*65536.0)|0;o=Kac(r|0,((r|0)<0)<<31>>31|0,p|0,q|0)|0;q=J;p=$ac(a|0,((a|0)<0)<<31>>31|0,16)|0;r=J;t=LVb((x-+(a|0))*65536.0)|0;a=Kac(t|0,((t|0)<0)<<31>>31|0,p|0,r|0)|0;r=J;x=+n[g>>2];g=LVb(x)|0;w=+n[c+12>>2];c=LVb(w)|0;p=$ac(g|0,((g|0)<0)<<31>>31|0,15)|0;t=J;s=LVb((x-+(g|0))*32768.0)|0;g=Kac(s|0,((s|0)<0)<<31>>31|0,p|0,t|0)|0;t=J;p=$ac(c|0,((c|0)<0)<<31>>31|0,15)|0;s=J;y=LVb((w-+(c|0))*32768.0)|0;c=Kac(y|0,((y|0)<0)<<31>>31|0,p|0,s|0)|0;s=l;f[s>>2]=o;f[s+4>>2]=q;q=l+8|0;f[q>>2]=a;f[q+4>>2]=r;r=m;f[r>>2]=g;f[r+4>>2]=t;t=m+8|0;f[t>>2]=c;f[t+4>>2]=J;rma(j,l,m,d,0,360,k,e,v);v=j+36|0;e=f[v>>2]|0;if(e|0?(k=e+12|0,e=f[k>>2]|0,f[k>>2]=e+-1,(e|0)==1):0)kL(j);f[v>>2]=0;v=j+16|0;e=j+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[e>>2]|0)>0){v=f[j+40>>2]|0;k=0;do{f[v+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[e>>2]|0))}e=f[j+44>>2]|0;if((e|0)!=(j+48|0))UC(e);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function Ima(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;m=u;u=u+128|0;n=m+120|0;o=m+64|0;p=m+16|0;q=m+48|0;r=m;dQ(n,61176);s=c+4|0;if(f[s>>2]|0){do if((yM(a)|0)==65536){t=f[a+4>>2]|0;f[o>>2]=f[t>>2];v=o+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=o+8|0;f[x>>2]=f[t+8>>2];f[o+12>>2]=f[t+12>>2];f[o+16>>2]=f[t+16>>2];f[o+20>>2]=f[t+20>>2];f[o+24>>2]=f[t+24>>2];f[o+28>>2]=f[t+28>>2];f[o+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[o+36>>2]=y;f[o+40>>2]=x;x=o+48|0;z=o+44|0;f[z>>2]=x;f[x>>2]=0;f[o+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[v>>2]=0;jL(o,t);break}}else yL(o,a,-1);while(0);a=Jma(e)|0;xM(i,p,f[o>>2]&4095,0);i=0-(f[a>>2]&15)|0;t=MVb(g*65536.0)|0;if((k|0)==16)A=(f[o>>2]&7|0)==0?16:8;else A=k;k=l?0-t|0:t;l=f[d>>2]|0;v=$ac(l|0,((l|0)<0)<<31>>31|0,16)|0;l=J;w=f[d+4>>2]|0;d=$ac(w|0,((w|0)<0)<<31>>31|0,16)|0;w=Y(k,i)|0;i=Kac(d|0,J|0,w|0,((w|0)<0)<<31>>31|0)|0;w=J;f[q>>2]=0;d=q+4|0;f[d>>2]=0;f[q+8>>2]=0;x=q+8|0;z=L5b(16384)|0;y=z;f[q>>2]=y;f[d>>2]=y;f[x>>2]=z+16384;if((f[s>>2]|0)>0){y=(e|0)==3;e=((t|0)<0)<<31>>31;B=((k|0)<0)<<31>>31;C=r+8|0;D=v;v=l;l=0;while(1){E=f[c>>2]|0;F=b[E+l>>0]|0;G=F&255;a:do if(y&F<<24>>24<0){switch(F<<24>>24){case -48:{H=l+1|0;I=b[E+H>>0]|0;if((I+112&255)<48){K=175;L=(I&255)+-17|0;M=127;N=H;break a}else{O=I;P=H}break}case -47:{H=l+1|0;I=b[E+H>>0]|0;if(I<<24>>24<0&(I&255)<144){K=191;L=(I&255)+47|0;M=175;N=H;break a}else{O=I;P=H}break}default:{if((F&255)<=191){K=127;L=63;M=32;N=l;break a}H=l+1|0;I=(b[E+H>>0]|0)==0?l:H;if((F&255)<=223){K=127;L=63;M=32;N=I;break a}H=I+1|0;Q=(b[E+H>>0]|0)==0?I:H;if((F&255)<=239){K=127;L=63;M=32;N=Q;break a}H=Q+1|0;I=(b[E+H>>0]|0)==0?Q:H;if((F&255)<=247){K=127;L=63;M=32;N=I;break a}H=I+1|0;Q=(b[E+H>>0]|0)==0?I:H;if((F&255)<=251){K=127;L=63;M=32;N=Q;break a}H=Q+1|0;K=127;L=63;M=32;N=(b[E+H>>0]|0)==0?Q:H;break a}}K=127;L=63;M=32;N=O<<24>>24==0?l:P}else{K=127;L=G;M=32;N=l}while(0);G=f[66856+(f[a+(((L|0)<(M|0)|(L|0)>=(K|0)?32:L+-31|0)<<2)>>2]<<2)>>2]|0;E=(h[G>>0]|0)+-82|0;F=(h[G+1>>0]|0)+-82|0;H=cbc(F|0,((F|0)<0)<<31>>31|0,t|0,e|0)|0;F=J;Q=cbc(E|0,((E|0)<0)<<31>>31|0,t|0,e|0)|0;E=Jac(D|0,v|0,Q|0,J|0)|0;Q=J;I=f[d>>2]|0;R=f[q>>2]|0;S=I;if(!((I|0)==(R|0)|(S|0)==(R|0)))f[d>>2]=S+(~((S+-16-R|0)>>>4)<<4);R=G+2|0;b:while(1){G=b[R>>0]|0;switch(G<<24>>24){case 0:case 32:break;default:{S=(G&255)+-82|0;I=(h[R+1>>0]|0)+-82|0;T=Kac(cbc(S|0,((S|0)<0)<<31>>31|0,t|0,e|0)|0,J|0,E|0,Q|0)|0;S=J;U=Kac(i|0,w|0,cbc(I|0,((I|0)<0)<<31>>31|0,k|0,B|0)|0,J|0)|0;I=J;V=r;f[V>>2]=T;f[V+4>>2]=S;V=C;f[V>>2]=U;f[V+4>>2]=I;V=f[d>>2]|0;if((V|0)==(f[x>>2]|0))sma(q,r);else{W=V;f[W>>2]=T;f[W+4>>2]=S;S=V+8|0;f[S>>2]=U;f[S+4>>2]=I;f[d>>2]=V+16}R=R+2|0;continue b}}V=f[q>>2]|0;I=(f[d>>2]|0)-V>>4;if(I>>>0>1){uma(o,V,I,0,p,j,A,16);X=b[R>>0]|0}else X=G;if(!(X<<24>>24))break;G=R+1|0;I=f[d>>2]|0;V=f[q>>2]|0;S=I;if((I|0)==(V|0)|(S|0)==(V|0)){R=G;continue}f[d>>2]=S+(~((S+-16-V|0)>>>4)<<4);R=G}D=Kac(E|0,Q|0,H|0,F|0)|0;l=N+1|0;if((l|0)>=(f[s>>2]|0))break;else v=J}v=f[q>>2]|0;if(v|0){Z=v;_=v;$=14}}else{Z=z;_=z;$=14}if(($|0)==14){$=f[d>>2]|0;if(($|0)!=(Z|0))f[d>>2]=$+(~(($+-16-Z|0)>>>4)<<4);O5b(_)}_=o+36|0;Z=f[_>>2]|0;if(Z|0?($=Z+12|0,Z=f[$>>2]|0,f[$>>2]=Z+-1,(Z|0)==1):0)kL(o);f[_>>2]=0;_=o+16|0;Z=o+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Z>>2]|0)>0){_=f[o+40>>2]|0;$=0;do{f[_+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[Z>>2]|0))}Z=f[o+44>>2]|0;if((Z|0)!=(o+48|0))UC(Z)}if(!(f[n+4>>2]|0)){u=m;return}u=m;return}function Jma(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;e=(a&16|0)!=0;switch(a&15){case 0:{g=65676;break}case 1:{g=e?61196:61580;break}case 2:{g=65292;break}case 3:{g=e?61964:62348;break}case 4:{g=e?62988:63372;break}case 5:{g=e?63756:64140;break}case 6:{g=64908;break}case 7:{g=64524;break}default:{f[d>>2]=0;f[d+4>>2]=0;e=aD(d,17)|0;a=268244;h=e+17|0;do{b[e>>0]=b[a>>0]|0;e=e+1|0;a=a+1|0}while((e|0)<(h|0));bO(-211,d,268262,267135,2218);bD(d);g=0}}u=c;return g|0}function Kma(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0.0,ma=0.0;l=u;u=u+368|0;m=l+312|0;n=l+96|0;o=l+64|0;q=l+304|0;r=l+248|0;s=l+192|0;t=l+160|0;v=l+148|0;w=l+136|0;x=l+32|0;y=l;z=l+128|0;dQ(q,66060);do if((yM(a)|0)==65536){A=f[a+4>>2]|0;f[r>>2]=f[A>>2];B=r+4|0;C=A+4|0;f[B>>2]=f[C>>2];D=r+8|0;f[D>>2]=f[A+8>>2];f[r+12>>2]=f[A+12>>2];f[r+16>>2]=f[A+16>>2];f[r+20>>2]=f[A+20>>2];f[r+24>>2]=f[A+24>>2];f[r+28>>2]=f[A+28>>2];f[r+32>>2]=f[A+32>>2];E=f[A+36>>2]|0;f[r+36>>2]=E;f[r+40>>2]=D;D=r+48|0;F=r+44|0;f[F>>2]=D;f[D>>2]=0;f[r+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[A+44>>2]|0;D=f[F>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[B>>2]=0;jL(r,A);break}}else yL(r,a,-1);while(0);do if((yM(i)|0)==65536){a=f[i+4>>2]|0;f[s>>2]=f[a>>2];A=s+4|0;B=a+4|0;f[A>>2]=f[B>>2];C=s+8|0;f[C>>2]=f[a+8>>2];f[s+12>>2]=f[a+12>>2];f[s+16>>2]=f[a+16>>2];f[s+20>>2]=f[a+20>>2];f[s+24>>2]=f[a+24>>2];f[s+28>>2]=f[a+28>>2];f[s+32>>2]=f[a+32>>2];D=f[a+36>>2]|0;f[s+36>>2]=D;f[s+40>>2]=C;C=s+48|0;F=s+44|0;f[F>>2]=C;f[C>>2]=0;f[s+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[a+44>>2]|0;C=f[F>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];break}else{f[A>>2]=0;jL(s,a);break}}else yL(s,i,-1);while(0);i=f[r+8>>2]|0;a=r+4|0;A=(f[a>>2]|0)==1?1:f[r+12>>2]|0;B=f[r>>2]|0;C=B&4095;F=r+16|0;D=f[F>>2]|0;E=Y((B>>>3&511)+1<<(47696>>>(C<<1&14)&3),A)|0;f[t>>2]=C|1111638016;C=t+4|0;f[C>>2]=E;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=D;f[t+20>>2]=i;f[t+24>>2]=A;A=r+44|0;f[C>>2]=f[f[A>>2]>>2];f[t>>2]=B&20479|1111621632;B=EM(c,-1)|0;f[v>>2]=0;C=v+4|0;f[C>>2]=0;f[v+8>>2]=0;f[w>>2]=0;i=w+4|0;f[i>>2]=0;f[w+8>>2]=0;if(B|0){Lma(v,B);D=f[i>>2]|0;E=f[w>>2]|0;G=(D-E|0)/20|0;H=E;E=D;if(B>>>0<=G>>>0){if(B>>>0<G>>>0?(D=H+(B*20|0)|0,(E|0)!=(D|0)):0)f[i>>2]=E+(~(((E+-20-D|0)>>>0)/20|0)*20|0)}else Mma(w,B-G|0);G=f[v>>2]|0;D=0;do{f[G+(D*56|0)+52>>2]=0;D=D+1|0}while((D|0)!=(B|0));D=(d|0)>-1;if(D){if((B|0)<=(d|0)){f[m>>2]=0;f[m+4>>2]=0;I=aD(m,41)|0;J=268373;K=I+41|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));bO(-215,m,268415,267135,2495);bD(m)}L=d;M=d+1|0}else{L=0;M=B}d=M>>>0>L>>>0;if(d){G=c+4|0;E=m+4|0;H=m+8|0;N=m+12|0;O=m+16|0;P=m+20|0;Q=m+24|0;R=m+28|0;S=m+32|0;T=m+36|0;U=m+40|0;V=m+48|0;W=m+44|0;X=m+52|0;Z=n+4|0;_=L;do{do if((_|0)<0&(yM(c)|0)==65536){$=f[G>>2]|0;f[m>>2]=f[$>>2];aa=$+4|0;f[E>>2]=f[aa>>2];f[H>>2]=f[$+8>>2];f[N>>2]=f[$+12>>2];f[O>>2]=f[$+16>>2];f[P>>2]=f[$+20>>2];f[Q>>2]=f[$+24>>2];f[R>>2]=f[$+28>>2];f[S>>2]=f[$+32>>2];ba=f[$+36>>2]|0;f[T>>2]=ba;f[U>>2]=H;f[W>>2]=V;f[V>>2]=0;f[X>>2]=0;if(ba|0){ca=ba+12|0;f[ca>>2]=(f[ca>>2]|0)+1}if((f[aa>>2]|0)<3){aa=f[$+44>>2]|0;ca=f[W>>2]|0;f[ca>>2]=f[aa>>2];f[ca+4>>2]=f[aa+4>>2];break}else{f[E>>2]=0;jL(m,$);break}}else yL(m,c,_);while(0);if(f[O>>2]|0){$=f[E>>2]|0;if(($|0)<3)da=Y(f[N>>2]|0,f[H>>2]|0)|0;else{aa=f[U>>2]|0;ca=0;ba=1;while(1){ea=Y(f[aa+(ca<<2)>>2]|0,ba)|0;ca=ca+1|0;if((ca|0)==($|0)){da=ea;break}else ba=ea}}if(!(($|0)==0|(da|0)==0)){ba=wM(m,2,4,1)|0;if((ba|0)<=0){f[n>>2]=0;f[Z>>2]=0;I=aD(n,11)|0;J=268428;K=I+11|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));bO(-215,n,268415,267135,2506);bD(n)}OW(20492,56,8,f[O>>2]|0,ba,(f[v>>2]|0)+(_*56|0)|0,(f[w>>2]|0)+(_*20|0)|0)|0}}$=f[T>>2]|0;if($|0?(ca=$+12|0,$=f[ca>>2]|0,f[ca>>2]=$+-1,($|0)==1):0)kL(m);f[T>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[E>>2]|0)>0){$=f[U>>2]|0;ca=0;do{f[$+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[E>>2]|0))}ca=f[W>>2]|0;if((ca|0)!=(V|0))UC(ca);_=_+1|0}while(_>>>0<M>>>0)}_=s+16|0;V=f[_>>2]|0;do if(V){W=f[s+4>>2]|0;E=(W|0)<3;if(E)fa=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;else{U=f[s+40>>2]|0;O=0;T=1;while(1){Z=Y(f[U+(O<<2)>>2]|0,T)|0;O=O+1|0;if((O|0)==(W|0)){fa=Z;break}else T=Z}}if(!((j|0)==0|((W|0)==0|(fa|0)==0))){T=M-L|0;if(E)ga=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;else{O=f[s+40>>2]|0;U=0;Z=1;while(1){da=Y(f[O+(U<<2)>>2]|0,Z)|0;U=U+1|0;if((U|0)==(W|0)){ga=da;break}else Z=da}}if((ga|0)==(B|0)?(f[s>>2]&4095|0)==28:0)ha=V;else{f[m>>2]=0;f[m+4>>2]=0;I=aD(m,95)|0;J=268440;K=I+95|0;do{b[I>>0]=b[J>>0]|0;I=I+1|0;J=J+1|0}while((I|0)<(K|0));bO(-215,m,268415,267135,2520);bD(m);ha=f[_>>2]|0}if((T|0)!=(B|0)){Z=f[ha+(L<<4)+8>>2]|0;if((Z|0)<=-1)break;Nma(c,B,ha,Z,v,w);W=f[v>>2]|0;f[W+(L*56|0)+20>>2]=W+(Z*56|0);break}if(d){Z=f[v>>2]|0;W=L;do{U=f[ha+(W<<4)>>2]|0;O=f[ha+(W<<4)+4>>2]|0;E=f[ha+(W<<4)+8>>2]|0;da=f[ha+(W<<4)+12>>2]|0;f[Z+(W*56|0)+12>>2]=U>>>0<B>>>0?Z+(U*56|0)|0:0;f[Z+(W*56|0)+8>>2]=O>>>0<B>>>0?Z+(O*56|0)|0:0;f[Z+(W*56|0)+20>>2]=E>>>0<B>>>0?Z+(E*56|0)|0:0;f[Z+(W*56|0)+16>>2]=da>>>0<B>>>0?Z+(da*56|0)|0:0;W=W+1|0}while((W|0)!=(M|0))}}else ia=60}else ia=60;while(0);if((ia|0)==60?d:0){d=M+-1|0;ia=f[v>>2]|0;B=L;do{ha=B;B=B+1|0;f[ia+(ha*56|0)+12>>2]=ha>>>0<d>>>0?ia+(B*56|0)|0:0;f[ia+(ha*56|0)+8>>2]=ha>>>0>L>>>0?ia+((ha+-1|0)*56|0)|0:0}while((B|0)!=(M|0))}M=(f[v>>2]|0)+(L*56|0)|0;ja=+p[e>>3];p[x>>3]=ja;ka=+p[e+8>>3];p[x+8>>3]=ka;la=+p[e+16>>3];p[x+16>>3]=la;ma=+p[e+24>>3];p[x+24>>3]=ma;p[y>>3]=ja;p[y+8>>3]=ka;p[y+16>>3]=la;p[y+24>>3]=ma;f[z>>2]=f[k>>2];f[z+4>>2]=f[k+4>>2];f[o>>2]=f[x>>2];f[o+4>>2]=f[x+4>>2];f[o+8>>2]=f[x+8>>2];f[o+12>>2]=f[x+12>>2];f[o+16>>2]=f[x+16>>2];f[o+20>>2]=f[x+20>>2];f[o+24>>2]=f[x+24>>2];f[o+28>>2]=f[x+28>>2];f[n>>2]=f[y>>2];f[n+4>>2]=f[y+4>>2];f[n+8>>2]=f[y+8>>2];f[n+12>>2]=f[y+12>>2];f[n+16>>2]=f[y+16>>2];f[n+20>>2]=f[y+20>>2];f[n+24>>2]=f[y+24>>2];f[n+28>>2]=f[y+28>>2];f[m>>2]=f[z>>2];f[m+4>>2]=f[z+4>>2];Oma(t,M,o,n,D?0-j|0:j,g,h,m);m=f[w>>2]|0;if(m|0){w=f[i>>2]|0;if((w|0)!=(m|0))f[i>>2]=w+(~(((w+-20-m|0)>>>0)/20|0)*20|0);O5b(m)}}m=f[v>>2]|0;if(m|0){v=f[C>>2]|0;if((v|0)!=(m|0))f[C>>2]=v+(~(((v+-56-m|0)>>>0)/56|0)*56|0);O5b(m)}m=s+36|0;v=f[m>>2]|0;if(v|0?(C=v+12|0,v=f[C>>2]|0,f[C>>2]=v+-1,(v|0)==1):0)kL(s);f[m>>2]=0;m=s+16|0;v=s+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[v>>2]|0)>0){m=f[s+40>>2]|0;C=0;do{f[m+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[v>>2]|0))}v=f[s+44>>2]|0;if((v|0)!=(s+48|0))UC(v);v=r+36|0;s=f[v>>2]|0;if(s|0?(C=s+12|0,s=f[C>>2]|0,f[C>>2]=s+-1,(s|0)==1):0)kL(r);f[v>>2]=0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[a>>2]|0)>0){F=f[r+40>>2]|0;v=0;do{f[F+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[a>>2]|0))}a=f[A>>2]|0;if((a|0)!=(r+48|0))UC(a);if(!(f[q+4>>2]|0)){u=l;return}u=l;return}function Lma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/56|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+56|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/56|0;g=i+b|0;if(g>>>0>76695844)c4b(a);l=(d-h|0)/56|0;h=l<<1;d=l>>>0<38347922?(h>>>0<g>>>0?g:h):76695844;do if(d)if(d>>>0>76695844){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{m=L5b(d*56|0)|0;break}else m=0;while(0);h=m+(i*56|0)|0;i=m+(d*56|0)|0;d=b;b=h;m=h;do{j=b;k=j+56|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+56|0;m=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;j=h+(((b|0)/-56|0)*56|0)|0;if((b|0)>0)Vac(j|0,d|0,b|0)|0;f[a>>2]=j;f[e>>2]=m;f[c>>2]=i;if(!d)return;O5b(d);return}function Mma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/20|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;i=(f[e>>2]|0)+20|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/20|0;g=i+b|0;if(g>>>0>214748364)c4b(a);j=(d-h|0)/20|0;h=j<<1;d=j>>>0<107374182?(h>>>0<g>>>0?g:h):214748364;do if(d)if(d>>>0>214748364){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d*20|0)|0;break}else k=0;while(0);h=k+(i*20|0)|0;i=k+(d*20|0)|0;d=b;b=h;k=h;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;b=k+20|0;k=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;g=h+(((b|0)/-20|0)*20|0)|0;if((b|0)>0)Vac(g|0,d|0,b|0)|0;f[a>>2]=g;f[e>>2]=k;f[c>>2]=i;if(!d)return;O5b(d);return}function Nma(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+64|0;i=h;if((d|0)<=-1){u=h;return}j=i+16|0;k=i+4|0;l=i+8|0;m=i+12|0;n=i+36|0;o=i+40|0;p=i+44|0;q=i+48|0;r=d;do{yL(i,a,r);d=f[j>>2]|0;s=f[k>>2]|0;if(!d)t=0;else{if((s|0)<3)v=Y(f[m>>2]|0,f[l>>2]|0)|0;else{w=f[o>>2]|0;x=0;y=1;while(1){z=Y(f[w+(x<<2)>>2]|0,y)|0;x=x+1|0;if((x|0)==(s|0)){v=z;break}else y=z}}t=(s|0)==0|(v|0)==0?0:d}if((s|0)<3)A=Y(f[m>>2]|0,f[l>>2]|0)|0;else{y=f[o>>2]|0;x=0;w=1;while(1){z=Y(f[y+(x<<2)>>2]|0,w)|0;x=x+1|0;if((x|0)==(s|0)){A=z;break}else w=z}}OW(20492,56,8,t,A,(f[e>>2]|0)+(r*56|0)|0,(f[g>>2]|0)+(r*20|0)|0)|0;w=c+(r<<4)|0;s=f[w>>2]|0;x=f[c+(r<<4)+4>>2]|0;y=f[c+(r<<4)+8>>2]|0;d=f[c+(r<<4)+12>>2]|0;z=f[e>>2]|0;f[z+(r*56|0)+12>>2]=(s|0)>-1&(s|0)<(b|0)?z+(s*56|0)|0:0;s=f[e>>2]|0;f[s+(r*56|0)+8>>2]=(x|0)>-1&(x|0)<(b|0)?s+(x*56|0)|0:0;x=(y|0)>-1;s=f[e>>2]|0;f[s+(r*56|0)+20>>2]=x&(y|0)<(b|0)?s+(y*56|0)|0:0;s=f[e>>2]|0;f[s+(r*56|0)+16>>2]=(d|0)>-1&(d|0)<(b|0)?s+(d*56|0)|0:0;if(x)Nma(a,b,c,y,e,g);y=f[n>>2]|0;if(y|0?(x=y+12|0,y=f[x>>2]|0,f[x>>2]=y+-1,(y|0)==1):0)kL(i);f[n>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[k>>2]|0)>0){y=f[o>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[k>>2]|0))}x=f[p>>2]|0;if((x|0)!=(q|0))UC(x);r=f[w>>2]|0}while((r|0)>-1);u=h;return}function Oma(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0;l=u;u=u+384|0;m=l+368|0;n=l+356|0;o=l+344|0;q=l+208|0;r=l+176|0;s=l+288|0;t=l+144|0;v=l+112|0;w=l+256|0;x=l+80|0;y=l+96|0;z=l+64|0;A=l+48|0;B=l+32|0;C=l+248|0;D=l+16|0;E=l;F=l+240|0;f[n>>2]=0;G=n+4|0;f[G>>2]=0;f[n+8>>2]=0;f[o>>2]=0;H=o+4|0;f[H>>2]=0;f[o+8>>2]=0;I=+p[d+8>>3];J=+p[d+16>>3];K=+p[d+24>>3];p[q>>3]=+p[d>>3];p[q+8>>3]=I;p[q+16>>3]=J;p[q+24>>3]=K;K=+p[e+8>>3];J=+p[e+16>>3];I=+p[e+24>>3];p[r>>3]=+p[e>>3];p[r+8>>3]=K;p[r+16>>3]=J;p[r+24>>3]=I;tL(s,a,0,1,0,0);a=f[k>>2]|0;e=f[k+4>>2]|0;if((j|0)==16)L=(f[s>>2]&7|0)==0?16:8;else L=j;if(c|0){if((i|0)>=32768){f[w>>2]=0;f[w+4>>2]=0;M=aD(w,26)|0;N=267592;O=M+26|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));bO(-215,w,268536,267135,2579);bD(w)}xM(q,t,f[s>>2]&4095,0);xM(r,v,f[s>>2]&4095,0);r=(g|0)>-2147483646?g:-2147483646;g=(r|0)==2147483647?2147483646:r;r=c+12|0;if((g|0)<0){q=f[r>>2]|0;f[r>>2]=0;P=1-g|0;Q=q}else{P=g;Q=0}kX(m,c,P);P=w+12|0;c=x+4|0;g=(i|0)<0;q=w+20|0;j=x+8|0;k=o+8|0;d=(i|0)>-1;R=D+8|0;S=E+8|0;T=x+8|0;U=F+4|0;V=x+4|0;W=y+8|0;X=z+8|0;Y=x+8|0;Z=A+8|0;_=B+8|0;$=C+4|0;while(1){aa=lX(m)|0;if(!aa)break;ba=f[aa+24>>2]|0;ca=f[aa>>2]|0;da=ca&4095;ea=(ca&32768|0)==0?t:v;MW(aa,w,0);if(!(f[P>>2]|0)){f[x>>2]=0;f[c>>2]=0;M=aD(x,16)|0;N=268551;O=M+16|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));bO(-215,x,268536,267135,2603);bD(x)}if(g?(ca=f[H>>2]|0,fa=f[o>>2]|0,ga=ca,!((ca|0)==(fa|0)|(ga|0)==(fa|0))):0)f[H>>2]=ga+(~((ga+-16-fa|0)>>>4)<<4);fa=f[aa>>2]|0;do if((fa&12288|0)==4096){if(!((fa&16384|0)==0?1:(f[aa+28>>2]|0)!=1)){ga=aa+56|0;ca=f[ga>>2]|0;ha=aa+60|0;ia=f[ha>>2]|0;ja=f[P>>2]|0;if(!ja)ka=0;else ka=b[ja>>0]|0;la=ka&255;ma=ca+a|0;na=ia+e|0;a:do if((ba|0)>0){if(d){oa=la;pa=0;qa=ma;ra=ca;sa=ia;ta=na;ua=ja;while(1){va=b[ua>>0]|0;wa=ua+1|0;f[P>>2]=wa;if(wa>>>0>=(f[q>>2]|0)>>>0)VW(w,1);wa=va<<24>>24;if(va<<24>>24==oa<<24>>24){xa=oa;ya=qa;za=ta}else{Aa=y;f[Aa>>2]=qa;f[Aa+4>>2]=((qa|0)<0)<<31>>31;Aa=W;f[Aa>>2]=ta;f[Aa+4>>2]=((ta|0)<0)<<31>>31;Aa=z;f[Aa>>2]=ra;f[Aa+4>>2]=((ra|0)<0)<<31>>31;Aa=X;f[Aa>>2]=sa;f[Aa+4>>2]=((sa|0)<0)<<31>>31;lma(s,y,z,ea,i,L,2,0);xa=va;ya=ra;za=sa}va=pa+1|0;if((va|0)>=(ba|0)){Ba=ya;Ca=za;break a}oa=xa;pa=va;qa=ya;ra=(f[66080+(wa<<3)>>2]|0)+ra|0;sa=(f[66080+(wa<<3)+4>>2]|0)+sa|0;ta=za;ua=f[P>>2]|0}}else{Da=la;Ea=0;Fa=ma;Ga=ca;Ha=ia;Ia=na;Ja=ja}while(1){ua=b[Ja>>0]|0;ta=Ja+1|0;f[P>>2]=ta;if(ta>>>0>=(f[q>>2]|0)>>>0)VW(w,1);ta=ua<<24>>24;if(ua<<24>>24==Da<<24>>24){Ka=Da;La=Fa;Ma=Ia}else{sa=((Ga|0)<0)<<31>>31;ra=((Ha|0)<0)<<31>>31;qa=x;f[qa>>2]=Ga;f[qa+4>>2]=sa;qa=Y;f[qa>>2]=Ha;f[qa+4>>2]=ra;qa=f[H>>2]|0;if((qa|0)==(f[k>>2]|0))sma(o,x);else{pa=qa;f[pa>>2]=Ga;f[pa+4>>2]=sa;sa=qa+8|0;f[sa>>2]=Ha;f[sa+4>>2]=ra;f[H>>2]=qa+16}Ka=ua;La=Ga;Ma=Ha}ua=Ea+1|0;if((ua|0)>=(ba|0)){Ba=La;Ca=Ma;break a}Da=Ka;Ea=ua;Fa=La;Ga=(f[66080+(ta<<3)>>2]|0)+Ga|0;Ha=(f[66080+(ta<<3)+4>>2]|0)+Ha|0;Ia=Ma;Ja=f[P>>2]|0}}else{Ba=ma;Ca=na}while(0);if(d){na=A;f[na>>2]=Ba;f[na+4>>2]=((Ba|0)<0)<<31>>31;na=Z;f[na>>2]=Ca;f[na+4>>2]=((Ca|0)<0)<<31>>31;na=(f[ga>>2]|0)+a|0;ma=(f[ha>>2]|0)+e|0;ja=B;f[ja>>2]=na;f[ja+4>>2]=((na|0)<0)<<31>>31;na=_;f[na>>2]=ma;f[na+4>>2]=((ma|0)<0)<<31>>31;lma(s,A,B,ea,i,L,2,0);break}else{ma=f[o>>2]|0;na=(f[H>>2]|0)-ma>>4;f[C>>2]=a;f[$>>2]=e;vma(s,ma,na,n,t,L,0,C);break}}if((fa&4094|0)==12){if((da|0)==12)Na=fa;else{f[x>>2]=0;f[V>>2]=0;M=aD(x,54)|0;N=268568;O=M+54|0;do{b[M>>0]=b[N>>0]|0;M=M+1|0;N=N+1|0}while((M|0)<(O|0));bO(-215,x,268536,267135,2646);bD(x);Na=f[aa>>2]|0}ha=ba-(Na>>>14&1^1)|0;ga=f[P>>2]|0;na=ga;ma=na;ja=h[ma>>0]|h[ma+1>>0]<<8|h[ma+2>>0]<<16|h[ma+3>>0]<<24;ma=na+4|0;na=h[ma>>0]|h[ma+1>>0]<<8|h[ma+2>>0]<<16|h[ma+3>>0]<<24;ma=ga+8|0;f[P>>2]=ma;if(ma>>>0>=(f[q>>2]|0)>>>0)VW(w,1);ma=ja+a|0;ja=na+e|0;if(g){na=((ma|0)<0)<<31>>31;ga=((ja|0)<0)<<31>>31;ia=x;f[ia>>2]=ma;f[ia+4>>2]=na;ia=j;f[ia>>2]=ja;f[ia+4>>2]=ga;ia=f[H>>2]|0;if((ia|0)==(f[k>>2]|0))sma(o,x);else{ca=ia;f[ca>>2]=ma;f[ca+4>>2]=na;na=ia+8|0;f[na>>2]=ja;f[na+4>>2]=ga;f[H>>2]=ia+16}}b:do if((ha|0)>0){if(d){ia=0;ga=ma;na=ja;while(1){ca=f[P>>2]|0;la=ca;ta=la;ua=h[ta>>0]|h[ta+1>>0]<<8|h[ta+2>>0]<<16|h[ta+3>>0]<<24;ta=la+4|0;la=h[ta>>0]|h[ta+1>>0]<<8|h[ta+2>>0]<<16|h[ta+3>>0]<<24;ta=ca+8|0;f[P>>2]=ta;if(ta>>>0>=(f[q>>2]|0)>>>0)VW(w,1);ta=ga;ga=ua+a|0;ua=D;f[ua>>2]=ta;f[ua+4>>2]=((ta|0)<0)<<31>>31;ta=R;f[ta>>2]=na;f[ta+4>>2]=((na|0)<0)<<31>>31;na=la+e|0;la=E;f[la>>2]=ga;f[la+4>>2]=((ga|0)<0)<<31>>31;la=S;f[la>>2]=na;f[la+4>>2]=((na|0)<0)<<31>>31;lma(s,D,E,ea,i,L,2,0);ia=ia+1|0;if((ia|0)>=(ha|0))break b}}else Oa=0;do{ia=f[P>>2]|0;na=ia;ga=na;la=h[ga>>0]|h[ga+1>>0]<<8|h[ga+2>>0]<<16|h[ga+3>>0]<<24;ga=na+4|0;na=h[ga>>0]|h[ga+1>>0]<<8|h[ga+2>>0]<<16|h[ga+3>>0]<<24;ga=ia+8|0;f[P>>2]=ga;if(ga>>>0>=(f[q>>2]|0)>>>0)VW(w,1);ga=la+a|0;la=na+e|0;na=((ga|0)<0)<<31>>31;ia=((la|0)<0)<<31>>31;ta=x;f[ta>>2]=ga;f[ta+4>>2]=na;ta=T;f[ta>>2]=la;f[ta+4>>2]=ia;ta=f[H>>2]|0;if((ta|0)==(f[k>>2]|0))sma(o,x);else{ua=ta;f[ua>>2]=ga;f[ua+4>>2]=na;na=ta+8|0;f[na>>2]=la;f[na+4>>2]=ia;f[H>>2]=ta+16}Oa=Oa+1|0}while((Oa|0)<(ha|0))}while(0);if(g){ha=f[o>>2]|0;ja=(f[H>>2]|0)-ha>>4;f[F>>2]=0;f[U>>2]=0;vma(s,ha,ja,n,t,L,0,F)}}}while(0)}if(g)wma(s,n,t);if(Q|0)f[r>>2]=Q}Q=s+36|0;r=f[Q>>2]|0;if(r|0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0)kL(s);f[Q>>2]=0;Q=s+16|0;r=s+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[r>>2]|0)>0){Q=f[s+40>>2]|0;t=0;do{f[Q+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[r>>2]|0))}r=f[s+44>>2]|0;if((r|0)!=(s+48|0))UC(r);r=f[o>>2]|0;if(r|0){o=f[H>>2]|0;if((o|0)!=(r|0))f[H>>2]=o+(~((o+-16-r|0)>>>4)<<4);O5b(r)}r=f[n>>2]|0;if(!r){u=l;return}n=f[G>>2]|0;if((n|0)!=(r|0))f[G>>2]=n+(~((n+-32-r|0)>>>5)<<5);O5b(r);u=l;return}function Pma(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0,g=0,h=0;d=f[c>>2]|0;e=f[c+4>>2]|0;c=L5b(136)|0;FY(c);f[c>>2]=66152;p[c+8>>3]=b;f[c+16>>2]=d;f[c+20>>2]=e;f[c+24>>2]=1124007936;e=c+32|0;d=c+64|0;g=c+28|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[d>>2]=e;e=c+72|0;f[c+68>>2]=e;f[e>>2]=0;f[c+76>>2]=0;f[c+80>>2]=1124007936;e=c+88|0;d=c+120|0;g=c+84|0;h=g+36|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[d>>2]=e;e=c+128|0;f[c+124>>2]=e;f[e>>2]=0;f[c+132>>2]=0;e=L5b(16)|0;d=e+4|0;f[d>>2]=1;f[e>>2]=66216;f[e+8>>2]=c;f[a>>2]=e;f[a+4>>2]=c;f[d>>2]=(f[d>>2]|0)+1;c=f[d>>2]|0;f[d>>2]=c+-1;if((c|0)!=1)return;bi[f[(f[e>>2]|0)+8>>2]&2047](e);return}function Qma(a){a=a|0;O5b(a);return}function Rma(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Sma(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=66152;b=a+80|0;c=a+116|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+96|0;b=a+84|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+120>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+124>>2]|0;if((b|0)!=(a+128|0))UC(b);b=a+24|0;d=a+60|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+40|0;b=a+28|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+64>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+68>>2]|0;if((b|0)==(a+72|0)){xY(a);return}UC(b);xY(a);return}function Tma(a){a=a|0;Sma(a);O5b(a);return}function Uma(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;e=u;u=u+272|0;g=e+248|0;h=e+240|0;i=e+56|0;j=e+232|0;k=e+224|0;l=e+216|0;m=e+208|0;o=e+144|0;q=e+80|0;r=e;s=e+72|0;t=e+152|0;v=e+88|0;dQ(h,66228);if(BL(c,-1)|0?(BL(c,-1)|0)!=2:0){f[g>>2]=0;f[g+4>>2]=0;w=aD(g,116)|0;x=268820;y=w+116|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,g,440399,268937,360);bD(g)}z=(BL(c,-1)|0)==0;A=z?256:65536;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;AL(j,c,-1);z=a+16|0;if(!((f[j>>2]|0)%(f[z>>2]|0)|0)){AL(k,c,-1);j=a+20|0;B=f[j>>2]|0;if(!((f[k+4>>2]|0)%(B|0)|0)){AL(l,c,-1);k=f[l>>2]|0;l=f[z>>2]|0;AL(m,c,-1);C=(f[m+4>>2]|0)/(f[j>>2]|0)|0;m=c;D=f[m+4>>2]|0;E=i;f[E>>2]=f[m>>2];f[E+4>>2]=D;f[i+8>>2]=f[c+8>>2];F=f[c+12>>2]|0;G=(k|0)/(l|0)|0;H=C}else{I=j;J=B;K=8}}else{B=a+20|0;I=B;J=f[B>>2]|0;K=8}if((K|0)==8){K=a+24|0;B=g+8|0;f[B>>2]=0;f[B+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=K;AL(o,c,-1);B=f[o+4>>2]|0;o=f[I>>2]|0;j=f[z>>2]|0;AL(q,c,-1);C=f[q>>2]|0;q=f[z>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[r+24>>2]=0;f[r+28>>2]=0;_P(c,g,0,J-((B|0)%(o|0)|0)|0,0,j-((C|0)%(q|0)|0)|0,4,r);q=f[a+64>>2]|0;C=(f[q+4>>2]|0)/(f[z>>2]|0)|0;j=(f[q>>2]|0)/(f[I>>2]|0)|0;f[i>>2]=16842752;f[i+4>>2]=K;f[i+8>>2]=0;F=0;G=C;H=j}f[i+12>>2]=F;F=Y(H,G)|0;L=+(A+-1|0)/+(F|0);M=+p[a+8>>3];if(M>0.0){j=~~(M*+(F|0)/+(A|0));N=(j|0)>1?j:1}else N=0;do if((yM(c)|0)==65536){j=f[c+4>>2]|0;f[r>>2]=f[j>>2];F=r+4|0;C=j+4|0;f[F>>2]=f[C>>2];K=r+8|0;f[K>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];f[r+16>>2]=f[j+16>>2];f[r+20>>2]=f[j+20>>2];f[r+24>>2]=f[j+24>>2];f[r+28>>2]=f[j+28>>2];f[r+32>>2]=f[j+32>>2];I=f[j+36>>2]|0;f[r+36>>2]=I;q=r+40|0;f[q>>2]=K;K=r+48|0;o=r+44|0;f[o>>2]=K;f[K>>2]=0;f[r+52>>2]=0;if(I|0){K=I+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[C>>2]|0)<3){C=f[j+44>>2]|0;K=f[o>>2]|0;f[K>>2]=f[C>>2];f[K+4>>2]=f[C+4>>2];O=q;P=r;break}else{f[F>>2]=0;jL(r,j);O=q;P=r;break}}else{yL(r,c,-1);O=r+40|0;P=r}while(0);q=f[O>>2]|0;j=f[q>>2]|0;f[s>>2]=f[q+4>>2];f[s+4>>2]=j;vM(d,s,f[P>>2]&4095,-1,0,0);do if((yM(d)|0)==65536){s=f[d+4>>2]|0;f[t>>2]=f[s>>2];j=t+4|0;q=s+4|0;f[j>>2]=f[q>>2];F=t+8|0;f[F>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];f[t+32>>2]=f[s+32>>2];C=f[s+36>>2]|0;f[t+36>>2]=C;f[t+40>>2]=F;F=t+48|0;K=t+44|0;f[K>>2]=F;f[F>>2]=0;f[t+52>>2]=0;if(C|0){F=C+12|0;f[F>>2]=(f[F>>2]|0)+1}if((f[q>>2]|0)<3){q=f[s+44>>2]|0;F=f[K>>2]|0;f[F>>2]=f[q>>2];f[F+4>>2]=f[q+4>>2];break}else{f[j>>2]=0;jL(t,s);break}}else yL(t,d,-1);while(0);do if((yM(i)|0)==65536){d=f[i+4>>2]|0;f[v>>2]=f[d>>2];s=v+4|0;j=d+4|0;f[s>>2]=f[j>>2];q=v+8|0;f[q>>2]=f[d+8>>2];f[v+12>>2]=f[d+12>>2];f[v+16>>2]=f[d+16>>2];f[v+20>>2]=f[d+20>>2];f[v+24>>2]=f[d+24>>2];f[v+28>>2]=f[d+28>>2];f[v+32>>2]=f[d+32>>2];F=f[d+36>>2]|0;f[v+36>>2]=F;f[v+40>>2]=q;q=v+48|0;K=v+44|0;f[K>>2]=q;f[q>>2]=0;f[v+52>>2]=0;if(F|0){q=F+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[j>>2]|0)<3){j=f[d+44>>2]|0;q=f[K>>2]|0;f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];break}else{f[s>>2]=0;jL(v,d);break}}else yL(v,i,-1);while(0);i=a+80|0;d=f[z>>2]|0;s=a+20|0;j=f[s>>2]|0;q=Y(j,d)|0;d=(BL(c,-1)|0)&4095;j=a+84|0;if(!(((((f[j>>2]|0)<3?(f[a+88>>2]|0)==(q|0):0)?(f[a+92>>2]|0)==(A|0):0)?(f[i>>2]&4095|0)==(d|0):0)?(f[a+96>>2]|0)!=0:0)){f[g>>2]=q;f[g+4>>2]=A;hL(i,2,g,d)}do if(!(BL(c,-1)|0)){d=L5b(136)|0;f[d>>2]=66256;A=d+4|0;f[A>>2]=f[v>>2];q=d+8|0;K=v+4|0;F=f[K>>2]|0;f[q>>2]=F;C=d+12|0;f[C>>2]=f[v+8>>2];f[d+16>>2]=f[v+12>>2];f[d+20>>2]=f[v+16>>2];f[d+24>>2]=f[v+20>>2];f[d+28>>2]=f[v+24>>2];f[d+32>>2]=f[v+28>>2];f[d+36>>2]=f[v+32>>2];o=f[v+36>>2]|0;f[d+40>>2]=o;f[d+44>>2]=C;C=d+52|0;I=d+48|0;f[I>>2]=C;f[C>>2]=0;f[d+56>>2]=0;if(!o)Q=F;else{F=o+12|0;f[F>>2]=(f[F>>2]|0)+1;Q=f[K>>2]|0}if((Q|0)<3){K=f[v+44>>2]|0;F=f[I>>2]|0;f[F>>2]=f[K>>2];f[F+4>>2]=f[K+4>>2]}else{f[q>>2]=0;jL(A,v)}A=d+60|0;f[A>>2]=f[i>>2];q=d+64|0;K=f[j>>2]|0;f[q>>2]=K;F=d+68|0;f[F>>2]=f[a+88>>2];f[d+72>>2]=f[a+92>>2];f[d+76>>2]=f[a+96>>2];f[d+80>>2]=f[a+100>>2];f[d+84>>2]=f[a+104>>2];f[d+88>>2]=f[a+108>>2];f[d+92>>2]=f[a+112>>2];I=f[a+116>>2]|0;f[d+96>>2]=I;f[d+100>>2]=F;F=d+108|0;o=d+104|0;f[o>>2]=F;f[F>>2]=0;f[d+112>>2]=0;if(!I)R=K;else{K=I+12|0;f[K>>2]=(f[K>>2]|0)+1;R=f[j>>2]|0}if((R|0)<3){K=f[a+124>>2]|0;I=f[o>>2]|0;f[I>>2]=f[K>>2];f[I+4>>2]=f[K+4>>2]}else{f[q>>2]=0;jL(A,i)}f[d+116>>2]=G;f[d+120>>2]=H;f[d+124>>2]=f[z>>2];f[d+128>>2]=N;n[d+132>>2]=L;A=L5b(16)|0;q=A+4|0;f[q>>2]=1;f[A>>2]=66276;f[A+8>>2]=d;K=A;I=d;f[q>>2]=(f[q>>2]|0)+1;d=f[q>>2]|0;f[q>>2]=d+-1;if((d|0)==1){bi[f[(f[A>>2]|0)+8>>2]&2047](A);S=K;T=I}else{S=K;T=I}}else{if((BL(c,-1)|0)!=2){f[g>>2]=0;f[g+4>>2]=0;w=aD(g,16)|0;x=269007;y=w+16|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-5,g,440399,268937,425);bD(g);S=0;T=0;break}I=L5b(136)|0;f[I>>2]=66296;K=I+4|0;f[K>>2]=f[v>>2];A=I+8|0;d=v+4|0;q=f[d>>2]|0;f[A>>2]=q;o=I+12|0;f[o>>2]=f[v+8>>2];f[I+16>>2]=f[v+12>>2];f[I+20>>2]=f[v+16>>2];f[I+24>>2]=f[v+20>>2];f[I+28>>2]=f[v+24>>2];f[I+32>>2]=f[v+28>>2];f[I+36>>2]=f[v+32>>2];F=f[v+36>>2]|0;f[I+40>>2]=F;f[I+44>>2]=o;o=I+52|0;C=I+48|0;f[C>>2]=o;f[o>>2]=0;f[I+56>>2]=0;if(!F)U=q;else{q=F+12|0;f[q>>2]=(f[q>>2]|0)+1;U=f[d>>2]|0}if((U|0)<3){d=f[v+44>>2]|0;q=f[C>>2]|0;f[q>>2]=f[d>>2];f[q+4>>2]=f[d+4>>2]}else{f[A>>2]=0;jL(K,v)}K=I+60|0;f[K>>2]=f[i>>2];A=I+64|0;d=f[j>>2]|0;f[A>>2]=d;q=I+68|0;f[q>>2]=f[a+88>>2];f[I+72>>2]=f[a+92>>2];f[I+76>>2]=f[a+96>>2];f[I+80>>2]=f[a+100>>2];f[I+84>>2]=f[a+104>>2];f[I+88>>2]=f[a+108>>2];f[I+92>>2]=f[a+112>>2];C=f[a+116>>2]|0;f[I+96>>2]=C;f[I+100>>2]=q;q=I+108|0;F=I+104|0;f[F>>2]=q;f[q>>2]=0;f[I+112>>2]=0;if(!C)V=d;else{d=C+12|0;f[d>>2]=(f[d>>2]|0)+1;V=f[j>>2]|0}if((V|0)<3){d=f[a+124>>2]|0;C=f[F>>2]|0;f[C>>2]=f[d>>2];f[C+4>>2]=f[d+4>>2]}else{f[A>>2]=0;jL(K,i)}f[I+116>>2]=G;f[I+120>>2]=H;f[I+124>>2]=f[z>>2];f[I+128>>2]=N;n[I+132>>2]=L;K=L5b(16)|0;A=K+4|0;f[A>>2]=1;f[K>>2]=66316;f[K+8>>2]=I;d=K;C=I;f[A>>2]=(f[A>>2]|0)+1;I=f[A>>2]|0;f[A>>2]=I+-1;if((I|0)==1){bi[f[(f[K>>2]|0)+8>>2]&2047](K);S=d;T=C}else{S=d;T=C}}while(0);N=Y(f[s>>2]|0,f[z>>2]|0)|0;f[g>>2]=0;f[g+4>>2]=N;RQ(g,T,-1.0);do if(!(BL(c,-1)|0)){T=L5b(1268)|0;f[T>>2]=66336;N=T+4|0;f[N>>2]=f[P>>2];V=T+8|0;U=r+4|0;x=f[U>>2]|0;f[V>>2]=x;w=T+12|0;y=r+8|0;f[w>>2]=f[y>>2];R=r+12|0;f[T+16>>2]=f[R>>2];f[T+20>>2]=f[r+16>>2];f[T+24>>2]=f[r+20>>2];f[T+28>>2]=f[r+24>>2];f[T+32>>2]=f[r+28>>2];f[T+36>>2]=f[r+32>>2];Q=f[r+36>>2]|0;f[T+40>>2]=Q;f[T+44>>2]=w;w=T+52|0;C=T+48|0;f[C>>2]=w;f[w>>2]=0;f[T+56>>2]=0;if(!Q)W=x;else{x=Q+12|0;f[x>>2]=(f[x>>2]|0)+1;W=f[U>>2]|0}if((W|0)<3){U=f[r+44>>2]|0;x=f[C>>2]|0;f[x>>2]=f[U>>2];f[x+4>>2]=f[U+4>>2]}else{f[V>>2]=0;jL(N,r)}N=T+60|0;f[N>>2]=f[t>>2];V=T+64|0;U=t+4|0;x=f[U>>2]|0;f[V>>2]=x;C=T+68|0;f[C>>2]=f[t+8>>2];f[T+72>>2]=f[t+12>>2];f[T+76>>2]=f[t+16>>2];f[T+80>>2]=f[t+20>>2];f[T+84>>2]=f[t+24>>2];f[T+88>>2]=f[t+28>>2];f[T+92>>2]=f[t+32>>2];Q=f[t+36>>2]|0;f[T+96>>2]=Q;f[T+100>>2]=C;C=T+108|0;w=T+104|0;f[w>>2]=C;f[C>>2]=0;f[T+112>>2]=0;if(!Q)X=x;else{x=Q+12|0;f[x>>2]=(f[x>>2]|0)+1;X=f[U>>2]|0}if((X|0)<3){U=f[t+44>>2]|0;x=f[w>>2]|0;f[x>>2]=f[U>>2];f[x+4>>2]=f[U+4>>2]}else{f[V>>2]=0;jL(N,t)}N=T+116|0;f[N>>2]=f[i>>2];V=T+120|0;U=f[j>>2]|0;f[V>>2]=U;x=T+124|0;f[x>>2]=f[a+88>>2];f[T+128>>2]=f[a+92>>2];f[T+132>>2]=f[a+96>>2];f[T+136>>2]=f[a+100>>2];f[T+140>>2]=f[a+104>>2];f[T+144>>2]=f[a+108>>2];f[T+148>>2]=f[a+112>>2];w=f[a+116>>2]|0;f[T+152>>2]=w;f[T+156>>2]=x;x=T+164|0;Q=T+160|0;f[Q>>2]=x;f[x>>2]=0;f[T+168>>2]=0;if(!w)Z=U;else{U=w+12|0;f[U>>2]=(f[U>>2]|0)+1;Z=f[j>>2]|0}if((Z|0)<3){U=f[a+124>>2]|0;w=f[Q>>2]|0;f[w>>2]=f[U>>2];f[w+4>>2]=f[U+4>>2]}else{f[V>>2]=0;jL(N,i)}f[T+172>>2]=G;f[T+176>>2]=H;N=T+180|0;V=f[z>>2]|0;f[N>>2]=V;f[T+184>>2]=f[s>>2];U=T+188|0;w=T+196|0;f[U>>2]=w;Q=f[R>>2]|0;R=Q<<2;f[T+192>>2]=R;if(R>>>0>264){C=N5b(R>>>0>1073741823?-1:R<<2)|0;f[U>>2]=C;_=C}else _=w;f[T+1252>>2]=_;w=_+(Q<<2)|0;f[T+1256>>2]=w;C=w+(Q<<2)|0;f[T+1260>>2]=C;U=C+(Q<<2)|0;f[T+1264>>2]=U;R=f[x>>2]|0;L=1.0/+(G|0);a:do if((Q|0)>0){x=Q+-1|0;d=0;K=V;while(1){M=L*+(d|0)+-.5;I=~~M;A=I-(+(I|0)>M&1)|0;I=A+1|0;$=M-+(A|0);n[C+(d<<2)>>2]=$;n[U+(d<<2)>>2]=1.0-$;F=K+-1|0;q=Y((A|0)>0?A:0,R)|0;f[_+(d<<2)>>2]=q;q=Y((F|0)<(I|0)?F:I,R)|0;f[w+(d<<2)>>2]=q;if((d|0)==(x|0))break a;d=d+1|0;K=f[N>>2]|0}}while(0);N=L5b(16)|0;w=N+4|0;f[w>>2]=1;f[N>>2]=66356;f[N+8>>2]=T;R=N;U=T;f[w>>2]=(f[w>>2]|0)+1;C=f[w>>2]|0;f[w>>2]=C+-1;if((C|0)==1){bi[f[(f[N>>2]|0)+8>>2]&2047](N);aa=y;ba=R;ca=U}else{aa=y;ba=R;ca=U}}else{if((BL(c,-1)|0)!=2){aa=r+8|0;ba=0;ca=0;break}U=L5b(1268)|0;f[U>>2]=66376;R=U+4|0;f[R>>2]=f[P>>2];N=U+8|0;C=r+4|0;w=f[C>>2]|0;f[N>>2]=w;V=U+12|0;Q=r+8|0;f[V>>2]=f[Q>>2];K=r+12|0;f[U+16>>2]=f[K>>2];f[U+20>>2]=f[r+16>>2];f[U+24>>2]=f[r+20>>2];f[U+28>>2]=f[r+24>>2];f[U+32>>2]=f[r+28>>2];f[U+36>>2]=f[r+32>>2];d=f[r+36>>2]|0;f[U+40>>2]=d;f[U+44>>2]=V;V=U+52|0;x=U+48|0;f[x>>2]=V;f[V>>2]=0;f[U+56>>2]=0;if(!d)da=w;else{w=d+12|0;f[w>>2]=(f[w>>2]|0)+1;da=f[C>>2]|0}if((da|0)<3){C=f[r+44>>2]|0;w=f[x>>2]|0;f[w>>2]=f[C>>2];f[w+4>>2]=f[C+4>>2]}else{f[N>>2]=0;jL(R,r)}R=U+60|0;f[R>>2]=f[t>>2];N=U+64|0;C=t+4|0;w=f[C>>2]|0;f[N>>2]=w;x=U+68|0;f[x>>2]=f[t+8>>2];f[U+72>>2]=f[t+12>>2];f[U+76>>2]=f[t+16>>2];f[U+80>>2]=f[t+20>>2];f[U+84>>2]=f[t+24>>2];f[U+88>>2]=f[t+28>>2];f[U+92>>2]=f[t+32>>2];d=f[t+36>>2]|0;f[U+96>>2]=d;f[U+100>>2]=x;x=U+108|0;V=U+104|0;f[V>>2]=x;f[x>>2]=0;f[U+112>>2]=0;if(!d)ea=w;else{w=d+12|0;f[w>>2]=(f[w>>2]|0)+1;ea=f[C>>2]|0}if((ea|0)<3){C=f[t+44>>2]|0;w=f[V>>2]|0;f[w>>2]=f[C>>2];f[w+4>>2]=f[C+4>>2]}else{f[N>>2]=0;jL(R,t)}R=U+116|0;f[R>>2]=f[i>>2];N=U+120|0;C=f[j>>2]|0;f[N>>2]=C;w=U+124|0;f[w>>2]=f[a+88>>2];f[U+128>>2]=f[a+92>>2];f[U+132>>2]=f[a+96>>2];f[U+136>>2]=f[a+100>>2];f[U+140>>2]=f[a+104>>2];f[U+144>>2]=f[a+108>>2];f[U+148>>2]=f[a+112>>2];V=f[a+116>>2]|0;f[U+152>>2]=V;f[U+156>>2]=w;w=U+164|0;d=U+160|0;f[d>>2]=w;f[w>>2]=0;f[U+168>>2]=0;if(!V)fa=C;else{C=V+12|0;f[C>>2]=(f[C>>2]|0)+1;fa=f[j>>2]|0}if((fa|0)<3){C=f[a+124>>2]|0;V=f[d>>2]|0;f[V>>2]=f[C>>2];f[V+4>>2]=f[C+4>>2]}else{f[N>>2]=0;jL(R,i)}f[U+172>>2]=G;f[U+176>>2]=H;R=U+180|0;N=f[z>>2]|0;f[R>>2]=N;f[U+184>>2]=f[s>>2];C=U+188|0;V=U+196|0;f[C>>2]=V;d=f[K>>2]|0;K=d<<2;f[U+192>>2]=K;if(K>>>0>264){x=N5b(K>>>0>1073741823?-1:K<<2)|0;f[C>>2]=x;ga=x}else ga=V;f[U+1252>>2]=ga;V=ga+(d<<2)|0;f[U+1256>>2]=V;x=V+(d<<2)|0;f[U+1260>>2]=x;C=x+(d<<2)|0;f[U+1264>>2]=C;K=(f[w>>2]|0)>>>1;L=1.0/+(G|0);b:do if((d|0)>0){w=d+-1|0;q=0;I=N;while(1){$=L*+(q|0)+-.5;F=~~$;A=F-(+(F|0)>$&1)|0;F=A+1|0;M=$-+(A|0);n[x+(q<<2)>>2]=M;n[C+(q<<2)>>2]=1.0-M;o=I+-1|0;B=Y((A|0)>0?A:0,K)|0;f[ga+(q<<2)>>2]=B;B=Y((o|0)<(F|0)?o:F,K)|0;f[V+(q<<2)>>2]=B;if((q|0)==(w|0))break b;q=q+1|0;I=f[R>>2]|0}}while(0);R=L5b(16)|0;V=R+4|0;f[V>>2]=1;f[R>>2]=66396;f[R+8>>2]=U;K=R;C=U;f[V>>2]=(f[V>>2]|0)+1;x=f[V>>2]|0;f[V>>2]=x+-1;if((x|0)==1){bi[f[(f[R>>2]|0)+8>>2]&2047](R);aa=Q;ba=K;ca=C}else{aa=Q;ba=K;ca=C}}while(0);ga=f[aa>>2]|0;f[g>>2]=0;f[g+4>>2]=ga;RQ(g,ca,-1.0);ca=ba;if(ba|0?(g=ca+4|0,ga=f[g>>2]|0,f[g>>2]=ga+-1,(ga|0)==1):0)bi[f[(f[ba>>2]|0)+8>>2]&2047](ca);ca=S;if(S|0?(ba=ca+4|0,ga=f[ba>>2]|0,f[ba>>2]=ga+-1,(ga|0)==1):0)bi[f[(f[S>>2]|0)+8>>2]&2047](ca);ca=v+36|0;S=f[ca>>2]|0;if(S|0?(ga=S+12|0,S=f[ga>>2]|0,f[ga>>2]=S+-1,(S|0)==1):0)kL(v);f[ca>>2]=0;ca=v+16|0;S=v+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[S>>2]|0)>0){ca=f[v+40>>2]|0;ga=0;do{f[ca+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[S>>2]|0))}S=f[v+44>>2]|0;if((S|0)!=(v+48|0))UC(S);S=t+36|0;v=f[S>>2]|0;if(v|0?(ga=v+12|0,v=f[ga>>2]|0,f[ga>>2]=v+-1,(v|0)==1):0)kL(t);f[S>>2]=0;S=t+16|0;v=t+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[v>>2]|0)>0){S=f[t+40>>2]|0;ga=0;do{f[S+(ga<<2)>>2]=0;ga=ga+1|0}while((ga|0)<(f[v>>2]|0))}v=f[t+44>>2]|0;if((v|0)!=(t+48|0))UC(v);v=r+36|0;t=f[v>>2]|0;if(t|0?(ga=t+12|0,t=f[ga>>2]|0,f[ga>>2]=t+-1,(t|0)==1):0)kL(r);f[v>>2]=0;v=r+16|0;t=r+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[t>>2]|0)>0){v=f[O>>2]|0;O=0;do{f[v+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[t>>2]|0))}t=f[r+44>>2]|0;if((t|0)!=(r+48|0))UC(t);if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function Vma(a,b){a=a|0;b=+b;p[a+8>>3]=b;return}function Wma(a){a=a|0;return +(+p[a+8>>3])}function Xma(a,b){a=a|0;b=b|0;f[a+16>>2]=f[b>>2];f[a+20>>2]=f[b+4>>2];return}function Yma(a,b){a=a|0;b=b|0;var c=0;c=f[b+20>>2]|0;f[a>>2]=f[b+16>>2];f[a+4>>2]=c;return}function Zma(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+24|0;c=a+60|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+40|0;b=a+28|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+64>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=a+80|0;d=a+116|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+96|0;b=a+84|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)<=0)return;d=f[a+120>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0));return}function _ma(a){a=a|0;O5b(a);return}function $ma(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ana(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=66376;b=a+188|0;c=f[b>>2]|0;d=a+196|0;if((c|0)!=(d|0)){if(c|0)P5b(c);f[b>>2]=d;f[a+192>>2]=264}d=a+116|0;b=a+152|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(d);f[b>>2]=0;b=a+132|0;d=a+120|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+156>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+160>>2]|0;if((d|0)!=(a+164|0))UC(d);d=a+60|0;c=a+96|0;b=f[c>>2]|0;if(b|0?(e=b+12|0,b=f[e>>2]|0,f[e>>2]=b+-1,(b|0)==1):0)kL(d);f[c>>2]=0;c=a+76|0;d=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[a+100>>2]|0;b=0;do{f[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[d>>2]|0))}d=f[a+104>>2]|0;if((d|0)!=(a+108|0))UC(d);d=a+4|0;b=a+40|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(d);f[b>>2]=0;b=a+20|0;d=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+44>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+48>>2]|0;if((d|0)==(a+52|0))return;UC(d);return}function bna(a){a=a|0;ana(a);O5b(a);return}function cna(a,b){a=a|0;b=b|0;var c=0.0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0.0,F=0.0;c=1.0/+(f[a+176>>2]|0);e=f[b>>2]|0;g=f[b+4>>2]|0;if((e|0)>=(g|0))return;b=f[a+20>>2]|0;h=f[f[a+48>>2]>>2]|0;i=f[a+76>>2]|0;k=f[f[a+104>>2]>>2]|0;l=(f[a+184>>2]|0)+-1|0;m=f[a+180>>2]|0;o=f[a+132>>2]|0;p=f[f[a+160>>2]>>2]|0;q=f[a+16>>2]|0;if((q|0)<=0)return;r=f[a+1252>>2]|0;s=f[a+1256>>2]|0;t=f[a+1264>>2]|0;u=f[a+1260>>2]|0;a=e;do{e=b+(Y(h,a)|0)|0;v=i+(Y(k,a)|0)|0;w=c*+(a|0)+-.5;x=~~w;y=x-(+(x|0)>w&1)|0;x=y+1|0;z=w-+(y|0);w=1.0-z;A=o+(Y(Y(m,(y|0)>0?y:0)|0,p)|0)|0;y=o+(Y(Y((l|0)<(x|0)?l:x,m)|0,p)|0)|0;x=0;do{B=j[e+(x<<1)>>1]|0;C=(f[r+(x<<2)>>2]|0)+B|0;D=(f[s+(x<<2)>>2]|0)+B|0;E=+n[t+(x<<2)>>2];F=+n[u+(x<<2)>>2];B=LVb(w*(+(j[A+(C<<1)>>1]|0)*E+ +(j[A+(D<<1)>>1]|0)*F)+z*(E*+(j[y+(C<<1)>>1]|0)+F*+(j[y+(D<<1)>>1]|0)))|0;d[v+(x<<1)>>1]=B>>>0<65536?B:(B|0)>0?65535:0;x=x+1|0}while((x|0)<(q|0));a=a+1|0}while((a|0)<(g|0));return}function dna(a){a=a|0;O5b(a);return}function ena(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fna(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=66336;b=a+188|0;c=f[b>>2]|0;d=a+196|0;if((c|0)!=(d|0)){if(c|0)P5b(c);f[b>>2]=d;f[a+192>>2]=264}d=a+116|0;b=a+152|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(d);f[b>>2]=0;b=a+132|0;d=a+120|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+156>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+160>>2]|0;if((d|0)!=(a+164|0))UC(d);d=a+60|0;c=a+96|0;b=f[c>>2]|0;if(b|0?(e=b+12|0,b=f[e>>2]|0,f[e>>2]=b+-1,(b|0)==1):0)kL(d);f[c>>2]=0;c=a+76|0;d=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[a+100>>2]|0;b=0;do{f[c+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[d>>2]|0))}d=f[a+104>>2]|0;if((d|0)!=(a+108|0))UC(d);d=a+4|0;b=a+40|0;c=f[b>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(d);f[b>>2]=0;b=a+20|0;d=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[d>>2]|0)>0){b=f[a+44>>2]|0;c=0;do{f[b+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[a+48>>2]|0;if((d|0)==(a+52|0))return;UC(d);return}function gna(a){a=a|0;fna(a);O5b(a);return}function hna(a,c){a=a|0;c=c|0;var d=0.0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0;d=1.0/+(f[a+176>>2]|0);e=f[c>>2]|0;g=c+4|0;c=f[g>>2]|0;if((e|0)>=(c|0))return;i=a+20|0;j=a+48|0;k=a+76|0;l=a+104|0;m=a+184|0;o=a+180|0;p=a+132|0;q=a+160|0;r=a+16|0;s=a+1252|0;t=a+1256|0;u=a+1264|0;v=a+1260|0;a=e;e=c;c=f[r>>2]|0;while(1){w=(f[i>>2]|0)+(Y(f[f[j>>2]>>2]|0,a)|0)|0;x=(f[k>>2]|0)+(Y(f[f[l>>2]>>2]|0,a)|0)|0;y=d*+(a|0)+-.5;z=~~y;A=z-(+(z|0)>y&1)|0;z=A+1|0;B=y-+(A|0);y=1.0-B;C=(f[m>>2]|0)+-1|0;D=f[o>>2]|0;E=Y(D,(A|0)>0?A:0)|0;A=f[p>>2]|0;F=f[f[q>>2]>>2]|0;G=A+(Y(E,F)|0)|0;E=A+(Y(Y((C|0)<(z|0)?C:z,D)|0,F)|0)|0;if((c|0)>0){F=0;do{D=h[w+F>>0]|0;z=(f[(f[s>>2]|0)+(F<<2)>>2]|0)+D|0;C=(f[(f[t>>2]|0)+(F<<2)>>2]|0)+D|0;H=+n[(f[u>>2]|0)+(F<<2)>>2];I=+n[(f[v>>2]|0)+(F<<2)>>2];D=LVb(y*(+(h[G+z>>0]|0)*H+ +(h[G+C>>0]|0)*I)+B*(H*+(h[E+z>>0]|0)+I*+(h[E+C>>0]|0)))|0;b[x+F>>0]=D>>>0<256?D:(D|0)>0?255:0;F=F+1|0;J=f[r>>2]|0}while((F|0)<(J|0));K=J;L=f[g>>2]|0}else{K=c;L=e}a=a+1|0;if((a|0)>=(L|0))break;else{e=L;c=K}}return}function ina(a){a=a|0;O5b(a);return}function jna(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function kna(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=66296;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function lna(a){a=a|0;kna(a);O5b(a);return}function mna(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0;c=u;u=u+262224|0;e=c+262200|0;g=c+262144|0;h=c;i=f[b>>2]|0;k=(f[a+108>>2]|0)>>>1;l=b+4|0;if((i|0)>=(f[l>>2]|0)){u=c;return}b=a+124|0;m=a+116|0;o=a+120|0;p=e+4|0;q=e+8|0;r=e+12|0;s=a+4|0;t=a+52|0;v=g+16|0;w=g+44|0;x=a+128|0;y=a+132|0;z=g+36|0;A=g+4|0;B=g+40|0;C=g+48|0;D=(f[a+76>>2]|0)+(Y(f[f[a+104>>2]>>2]|0,i)|0)|0;a=i;while(1){i=f[b>>2]|0;E=f[m>>2]|0;F=Y(E,(a|0)%(i|0)|0)|0;f[e>>2]=F;F=f[o>>2]|0;G=Y(F,(a|0)/(i|0)|0)|0;f[p>>2]=G;f[q>>2]=E;f[r>>2]=F;nL(g,s,e);Nac(h|0,0,262144)|0;F=f[r>>2]|0;E=(f[t>>2]|0)>>>1;G=f[v>>2]|0;i=F+-1|0;a:do if(F|0){H=f[q>>2]|0;I=H+-4|0;if((H|0)<4){J=(H|0)>0;K=G;L=i;while(1){if(J){M=0;do{N=h+((j[K+(M<<1)>>1]|0)<<2)|0;f[N>>2]=(f[N>>2]|0)+1;M=M+1|0}while((M|0)!=(H|0))}if(!L)break a;else{K=K+(E<<1)|0;L=L+-1|0}}}L=H&-4;K=(L|0)<(H|0);J=G;M=i;while(1){N=0;do{O=j[J+((N|1)<<1)>>1]|0;P=h+((j[J+(N<<1)>>1]|0)<<2)|0;f[P>>2]=(f[P>>2]|0)+1;P=h+(O<<2)|0;f[P>>2]=(f[P>>2]|0)+1;P=j[J+((N|3)<<1)>>1]|0;O=h+((j[J+((N|2)<<1)>>1]|0)<<2)|0;f[O>>2]=(f[O>>2]|0)+1;O=h+(P<<2)|0;f[O>>2]=(f[O>>2]|0)+1;N=N+4|0}while((N|0)<=(I|0));if(K){N=L;do{O=h+((j[J+(N<<1)>>1]|0)<<2)|0;f[O>>2]=(f[O>>2]|0)+1;N=N+1|0}while((N|0)!=(H|0))}if(!M)break;else{J=J+(E<<1)|0;M=M+-1|0}}}while(0);E=f[x>>2]|0;if((E|0)>0){i=0;G=0;while(1){F=h+(i<<2)|0;M=f[F>>2]|0;if((M|0)>(E|0)){f[F>>2]=E;Q=M+G-E|0}else Q=G;i=i+1|0;if((i|0)==65536)break;else G=Q}G=(Q|0)/65536|0;i=G<<16;E=0;do{M=h+(E<<2)|0;f[M>>2]=(f[M>>2]|0)+G;E=E+1|0}while((E|0)!=65536);E=Q-i|0;if(E|0?(G=65536/(E|0)|0,M=(G|0)>1?G:1,(E|0)>0):0){G=0;F=E;while(1){E=h+(G<<2)|0;f[E>>2]=(f[E>>2]|0)+1;G=G+M|0;if(!((F|0)>1&(G|0)<65536))break;else F=F+-1|0}}}R=+n[y>>2];F=0;G=0;do{F=(f[h+(G<<2)>>2]|0)+F|0;M=LVb(R*+(F|0))|0;d[D+(G<<1)>>1]=M>>>0<65536?M:(M|0)>0?65535:0;G=G+1|0}while((G|0)!=65536);G=f[z>>2]|0;if(G|0?(F=G+12|0,G=f[F>>2]|0,f[F>>2]=G+-1,(G|0)==1):0)kL(g);f[z>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[A>>2]|0)>0){G=f[B>>2]|0;F=0;do{f[G+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[A>>2]|0))}F=f[w>>2]|0;if((F|0)!=(C|0))UC(F);a=a+1|0;if((a|0)>=(f[l>>2]|0))break;else D=D+(k<<1)|0}u=c;return}function nna(a){a=a|0;O5b(a);return}function ona(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function pna(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=66256;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function qna(a){a=a|0;pna(a);O5b(a);return}function rna(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=u;u=u+1104|0;e=d+1080|0;g=d+1024|0;i=d;j=f[c>>2]|0;k=f[a+108>>2]|0;l=c+4|0;if((j|0)>=(f[l>>2]|0)){u=d;return}c=a+124|0;m=a+116|0;o=a+120|0;p=e+4|0;q=e+8|0;r=e+12|0;s=a+4|0;t=a+52|0;v=g+16|0;w=g+44|0;x=a+128|0;y=a+132|0;z=g+36|0;A=g+4|0;B=g+40|0;C=g+48|0;D=(f[a+76>>2]|0)+(Y(f[f[a+104>>2]>>2]|0,j)|0)|0;a=j;while(1){j=f[c>>2]|0;E=f[m>>2]|0;F=Y(E,(a|0)%(j|0)|0)|0;f[e>>2]=F;F=f[o>>2]|0;G=Y(F,(a|0)/(j|0)|0)|0;f[p>>2]=G;f[q>>2]=E;f[r>>2]=F;nL(g,s,e);Nac(i|0,0,1024)|0;F=f[r>>2]|0;E=f[t>>2]|0;if(F|0){G=f[q>>2]|0;j=(G|0)<4;H=G+-4|0;I=f[v>>2]|0;J=F;while(1){J=J+-1|0;if(j)K=0;else{F=0;while(1){L=h[I+(F|1)>>0]|0;M=i+((h[I+F>>0]|0)<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=i+(L<<2)|0;f[M>>2]=(f[M>>2]|0)+1;M=h[I+(F|3)>>0]|0;L=i+((h[I+(F|2)>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=i+(M<<2)|0;f[L>>2]=(f[L>>2]|0)+1;L=F+4|0;if((L|0)>(H|0)){K=L;break}else F=L}}if((K|0)<(G|0)){F=K;do{L=i+((h[I+F>>0]|0)<<2)|0;f[L>>2]=(f[L>>2]|0)+1;F=F+1|0}while((F|0)!=(G|0))}if(!J)break;else I=I+E|0}}E=f[x>>2]|0;if((E|0)>0){I=0;J=0;while(1){G=i+(I<<2)|0;H=f[G>>2]|0;if((H|0)>(E|0)){f[G>>2]=E;N=H+J-E|0}else N=J;I=I+1|0;if((I|0)==256)break;else J=N}J=(N|0)/256|0;I=J<<8;E=0;do{H=i+(E<<2)|0;f[H>>2]=(f[H>>2]|0)+J;E=E+1|0}while((E|0)!=256);E=N-I|0;if((E|0)!=0?(J=256/(E|0)|0,H=(J|0)>1?J:1,(E|0)>0):0){J=0;G=E;while(1){E=i+(J<<2)|0;f[E>>2]=(f[E>>2]|0)+1;J=J+H|0;if(!((G|0)>1&(J|0)<256)){O=0;P=0;break}else G=G+-1|0}}else{O=0;P=0}}else{O=0;P=0}do{O=(f[i+(P<<2)>>2]|0)+O|0;G=LVb(+n[y>>2]*+(O|0))|0;b[D+P>>0]=G>>>0<256?G:(G|0)>0?255:0;P=P+1|0}while((P|0)!=256);G=f[z>>2]|0;if(G|0?(J=G+12|0,G=f[J>>2]|0,f[J>>2]=G+-1,(G|0)==1):0)kL(g);f[z>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[A>>2]|0)>0){G=f[B>>2]|0;J=0;do{f[G+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[A>>2]|0))}J=f[w>>2]|0;if((J|0)!=(C|0))UC(J);a=a+1|0;if((a|0)>=(f[l>>2]|0))break;else D=D+k|0}u=d;return}function sna(){var a=0;if(((((tna(1,0)|0)!=0?(tna(1,1)|0)!=0:0)?(tna(2,0)|0)!=0:0)?(tna(2,1)|0)!=0:0)?(tna(4,0)|0)!=0:0)a=(tna(4,1)|0)!=0&1;else a=0;b[1120397]=a;return}function tna(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;e=u;u=u+1072|0;g=e+1064|0;h=e;switch(a|0){case 1:{i=834996;k=1111412;l=2;break}case 2:{i=507316;k=947572;l=4;break}case 4:{i=572852;k=980340;l=8;break}default:{f[g>>2]=0;f[g+4>>2]=0;m=aD(g,38)|0;o=269756;p=m+38|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));bO(-5,g,269795,269810,224);bD(g);i=0;k=0;l=0}}q=1120398+a|0;if(b[q>>0]|0){r=i;s=k;t=c?s:r;u=e;return t|0}v=h+8|0;f[h>>2]=v;w=h+4|0;f[w>>2]=256;switch(a|0){case 1:{a=0;x=v;while(1){y=+(a|0)*.03125;n[x>>2]=1.0-y;n[x+4>>2]=y;a=a+1|0;if((a|0)==32)break;else x=x+8|0}break}case 2:{x=0;a=v;while(1){y=+(x|0)*.03125;z=y+1.0;A=z*(z*(3.75-z*.75)+-6.0)+3.0;n[a>>2]=A;z=y*(y*(y*1.25+-2.25))+1.0;n[a+4>>2]=z;B=1.0-y;y=B*(B*(B*1.25+-2.25))+1.0;n[a+8>>2]=y;n[a+12>>2]=1.0-A-z-y;x=x+1|0;if((x|0)==32)break;else a=a+16|0}break}case 4:{a=0;x=v;while(1){y=+(a|0)*.03125;if(y<1.1920928955078125e-07){f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;f[x+16>>2]=0;f[x+20>>2]=0;f[x+24>>2]=0;f[x+28>>2]=0;C=1.0}else{z=y+3.0;y=-z*3.141592653589793*.25;A=+P(+y);B=+O(+y);D=B*0.0;E=(A+D)/(y*y);y=-(z+-1.0)*3.141592653589793*.25;F=A*-.7071067811865476;G=B*-.7071067811865476;H=(F+G)/(y*y);y=-(z+-2.0)*3.141592653589793*.25;I=A*0.0;J=(I+B)/(y*y);y=-(z+-3.0)*3.141592653589793*.25;K=A*.7071067811865476;L=(K+G)/(y*y);y=-(z+-4.0)*3.141592653589793*.25;G=(D-A)/(y*y);y=-(z+-5.0)*3.141592653589793*.25;A=B*.7071067811865476;D=(K+A)/(y*y);y=-(z+-6.0)*3.141592653589793*.25;K=(I-B)/(y*y);y=-(z+-7.0)*3.141592653589793*.25;z=(F+A)/(y*y);y=1.0/(z+(K+(D+(G+(L+(J+(H+(E+0.0))))))));n[x>>2]=E*y;n[x+4>>2]=H*y;n[x+8>>2]=J*y;n[x+16>>2]=G*y;n[x+20>>2]=D*y;n[x+24>>2]=K*y;n[x+28>>2]=z*y;C=L*y}n[x+12>>2]=C;a=a+1|0;if((a|0)==32)break;else x=x+32|0}break}default:{f[g>>2]=0;f[g+4>>2]=0;m=aD(g,28)|0;o=269882;p=m+28|0;do{b[m>>0]=b[o>>0]|0;m=m+1|0;o=o+1|0}while((m|0)<(p|0));bO(-5,g,269911,269810,207);bD(g)}}g=(l|0)==0;o=f[h>>2]|0;m=Y(l,l)|0;p=l>>>1;x=m<<5;a=m<<10;M=i+(a<<2)|0;N=Y(p,l)|0;Q=p+N|0;R=p+1|0;S=R+N|0;T=Y(R,l)|0;U=p+T|0;V=R+T|0;T=0;W=i;i=k;while(1){X=T<<5;Z=(T|0)<16&1;_=Y(T,l)|0;$=0;aa=W;W=W+(x<<2)|0;ba=i;while(1){ca=$+X|0;b[1120406+(ca<<1)>>0]=($|0)<16&1;b[1120406+(ca<<1)+1>>0]=Z;if(!g){ca=Y($,l)|0;da=0;ea=0;while(1){C=+n[o+(ea+_<<2)>>2];fa=Y(ea,l)|0;ga=0;ha=da;do{y=C*+n[o+(ga+ca<<2)>>2];ia=ga+fa|0;n[aa+(ia<<2)>>2]=y;ja=LVb(y*32768.0)|0;ka=(ja+32768|0)>>>0<65536?ja:(ja|0)>0?32767:32768;d[ba+(ia<<1)>>1]=ka;ha=(ka<<16>>16)+ha|0;ga=ga+1|0}while((ga|0)<(l|0));ea=ea+1|0;if((ea|0)>=(l|0))break;else da=ha}if((ha|0)!=32768){la=ha;ma=34}}else{la=0;ma=34}if((ma|0)==34){ma=0;da=d[ba+(Q<<1)>>1]|0;ea=d[ba+(S<<1)>>1]|0;ca=ea<<16>>16<da<<16>>16;ga=ca?p:ea<<16>>16>da<<16>>16?R:p;da=ca?R:p;ca=d[ba+(U<<1)>>1]|0;if(ca<<16>>16<(d[ba+(N+da<<1)>>1]|0)){na=p;oa=R;pa=ga;qa=p}else{ea=ca<<16>>16>(d[ba+(N+ga<<1)>>1]|0);na=da;oa=p;pa=ea?p:ga;qa=ea?R:p}ea=d[ba+(V<<1)>>1]|0;ga=ba+((Y(oa,l)|0)+na<<1)|0;if(ea<<16>>16<(d[ga>>1]|0)){ra=R;sa=R;ta=pa;ua=qa}else{ga=ba+((Y(qa,l)|0)+pa<<1)|0;da=ea<<16>>16>(d[ga>>1]|0);ra=na;sa=oa;ta=da?R:pa;ua=da?R:qa}if((la|0)<32768){da=(Y(ua,l)|0)+ta|0;va=d[ba+(da<<1)>>1]|0;wa=da}else{da=(Y(sa,l)|0)+ra|0;va=j[ba+(da<<1)>>1]|0;wa=da}d[ba+(wa<<1)>>1]=-32768-la+va}$=$+1|0;if(($|0)==32)break;else{aa=aa+(m<<2)|0;ba=ba+(m<<1)|0}}T=T+1|0;if((T|0)==32)break;else i=i+(x<<1)|0}x=Y(Y(l,-1024)|0,l)|0;l=M+(x<<2)|0;M=k+(a<<1)+(x<<1)|0;b[q>>0]=1;q=f[h>>2]|0;if((q|0)!=(v|0)){if(q|0)P5b(q);f[h>>2]=v;f[w>>2]=264}r=l;s=M;t=c?s:r;u=e;return t|0}function una(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;j=u;u=u+384|0;k=j;l=j+368|0;m=j+360|0;n=j+304|0;o=j+240|0;q=j+184|0;r=j+296|0;s=j+128|0;t=j+72|0;dQ(l,66408);AL(m,d,-1);if((Y(f[m+4>>2]|0,f[m>>2]|0)|0)<=0){f[k>>2]=0;f[k+4>>2]=0;v=aD(k,23)|0;w=269926;x=v+23|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,k,269950,269810,1728);bD(k)}if(!(HM(e)|0)?(AL(k,e,-1),AL(n,d,-1),!((f[k>>2]|0)==(f[n>>2]|0)?(f[k+4>>2]|0)==(f[n+4>>2]|0):0)):0){f[k>>2]=0;f[k+4>>2]=0;v=aD(k,47)|0;w=269956;x=v+47|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,k,269950,269810,1729);bD(k)}do if((yM(a)|0)==65536){m=f[a+4>>2]|0;f[n>>2]=f[m>>2];y=n+4|0;z=m+4|0;f[y>>2]=f[z>>2];A=n+8|0;f[A>>2]=f[m+8>>2];f[n+12>>2]=f[m+12>>2];f[n+16>>2]=f[m+16>>2];f[n+20>>2]=f[m+20>>2];f[n+24>>2]=f[m+24>>2];f[n+28>>2]=f[m+28>>2];f[n+32>>2]=f[m+32>>2];B=f[m+36>>2]|0;f[n+36>>2]=B;f[n+40>>2]=A;A=n+48|0;C=n+44|0;f[C>>2]=A;f[A>>2]=0;f[n+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[m+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(n,m);break}}else yL(n,a,-1);while(0);do if((yM(d)|0)==65536){m=f[d+4>>2]|0;f[o>>2]=f[m>>2];y=o+4|0;z=m+4|0;f[y>>2]=f[z>>2];A=o+8|0;f[A>>2]=f[m+8>>2];f[o+12>>2]=f[m+12>>2];f[o+16>>2]=f[m+16>>2];f[o+20>>2]=f[m+20>>2];f[o+24>>2]=f[m+24>>2];f[o+28>>2]=f[m+28>>2];f[o+32>>2]=f[m+32>>2];C=f[m+36>>2]|0;f[o+36>>2]=C;f[o+40>>2]=A;A=o+48|0;B=o+44|0;f[B>>2]=A;f[A>>2]=0;f[o+52>>2]=0;if(C|0){A=C+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[m+44>>2]|0;A=f[B>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(o,m);break}}else yL(o,d,-1);while(0);do if((yM(e)|0)==65536){d=f[e+4>>2]|0;f[q>>2]=f[d>>2];m=q+4|0;y=d+4|0;f[m>>2]=f[y>>2];z=q+8|0;f[z>>2]=f[d+8>>2];f[q+12>>2]=f[d+12>>2];f[q+16>>2]=f[d+16>>2];f[q+20>>2]=f[d+20>>2];f[q+24>>2]=f[d+24>>2];f[q+28>>2]=f[d+28>>2];f[q+32>>2]=f[d+32>>2];A=f[d+36>>2]|0;f[q+36>>2]=A;f[q+40>>2]=z;z=q+48|0;B=q+44|0;f[B>>2]=z;f[z>>2]=0;f[q+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[d+44>>2]|0;z=f[B>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[m>>2]=0;jL(q,d);break}}else yL(q,e,-1);while(0);e=o+40|0;d=f[e>>2]|0;m=f[d>>2]|0;f[r>>2]=f[d+4>>2];f[r+4>>2]=m;vM(c,r,f[n>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){r=f[c+4>>2]|0;f[s>>2]=f[r>>2];m=s+4|0;d=r+4|0;f[m>>2]=f[d>>2];y=s+8|0;f[y>>2]=f[r+8>>2];z=s+12|0;f[z>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];f[s+32>>2]=f[r+32>>2];B=f[r+36>>2]|0;f[s+36>>2]=B;f[s+40>>2]=y;y=s+48|0;A=s+44|0;f[A>>2]=y;f[y>>2]=0;f[s+52>>2]=0;if(B|0){y=B+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[d>>2]|0)<3){d=f[r+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[d>>2];f[y+4>>2]=f[d+4>>2];D=z;break}else{f[m>>2]=0;jL(s,r);D=z;break}}else{yL(s,c,-1);D=s+12|0}while(0);if(!((((f[D>>2]|0)<32767?(f[s+8>>2]|0)<32767:0)?(f[n+12>>2]|0)<32767:0)?(f[n+8>>2]|0)<32767:0)){f[k>>2]=0;f[k+4>>2]=0;v=aD(k,80)|0;w=270004;x=v+80|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,k,269950,269810,1749);bD(k)}c=s+16|0;z=n+16|0;if((f[c>>2]|0)==(f[z>>2]|0)){f[t>>2]=1124007936;r=t+4|0;m=t+8|0;d=t+40|0;v=r;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[d>>2]=m;y=t+48|0;A=t+44|0;f[A>>2]=y;f[y>>2]=0;f[t+52>>2]=0;B=k+8|0;f[B>>2]=0;f[B+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=t;SP(n,k);B=t+36|0;C=f[B>>2]|0;if(C|0){E=C+12|0;f[E>>2]=(f[E>>2]|0)+1}E=n+36|0;C=f[E>>2]|0;if(C|0?(F=C+12|0,C=f[F>>2]|0,f[F>>2]=C+-1,(C|0)==1):0)kL(n);f[E>>2]=0;C=n+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[C>>2]|0)>0){F=f[n+40>>2]|0;G=0;do{f[F+(G<<2)>>2]=0;G=G+1|0;H=f[C>>2]|0}while((G|0)<(H|0));f[n>>2]=f[t>>2];if((H|0)<3)I=50;else I=52}else{f[n>>2]=f[t>>2];I=50}if((I|0)==50){H=f[r>>2]|0;if((H|0)<3){f[C>>2]=H;f[n+8>>2]=f[m>>2];f[n+12>>2]=f[t+12>>2];m=f[A>>2]|0;H=f[n+44>>2]|0;f[H>>2]=f[m>>2];f[H+4>>2]=f[m+4>>2]}else I=52}if((I|0)==52)jL(n,t);m=t+16|0;f[z>>2]=f[m>>2];f[n+20>>2]=f[t+20>>2];f[n+24>>2]=f[t+24>>2];f[n+28>>2]=f[t+28>>2];f[n+32>>2]=f[t+32>>2];H=f[B>>2]|0;f[E>>2]=H;if(H|0?(E=H+12|0,H=f[E>>2]|0,f[E>>2]=H+-1,(H|0)==1):0)kL(t);f[B>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[r>>2]|0)>0){m=f[d>>2]|0;d=0;do{f[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[r>>2]|0))}r=f[A>>2]|0;if((r|0)!=(y|0))UC(r)}r=(g|0)==3?1:g;g=f[n>>2]&7;y=(g|0)==0;switch(r|0){case 0:{A=f[66428+(g<<2)>>2]|0;if((g|0)==7){f[k>>2]=0;f[k+4>>2]=0;v=aD(k,11)|0;w=270085;x=v+11|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,k,269950,269810,1809);bD(k);J=0;K=A;L=0}else{J=0;K=A;L=0}break}case 1:{M=f[66460+(g<<2)>>2]|0;I=71;break}case 2:{A=f[66492+(g<<2)>>2]|0;if((GM(a,-1)|0)<5){M=A;I=71}else{f[k>>2]=0;f[k+4>>2]=0;v=aD(k,20)|0;w=270097;x=v+20|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,k,269950,269810,1817);bD(k);M=A;I=71}break}case 4:{A=f[66524+(g<<2)>>2]|0;if((GM(a,-1)|0)<5){M=A;I=71}else{f[k>>2]=0;f[k+4>>2]=0;v=aD(k,20)|0;w=270097;x=v+20|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,k,269950,269810,1821);bD(k);M=A;I=71}break}default:{f[k>>2]=0;f[k+4>>2]=0;v=aD(k,28)|0;w=269882;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-5,k,269950,269810,1824);bD(k);I=72}}if((I|0)==71)if(!M)I=72;else{N=M;I=73}if((I|0)==72){f[k>>2]=0;f[k+4>>2]=0;v=aD(k,10)|0;w=270118;x=v+10|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,k,269950,269810,1825);bD(k);N=0;I=73}if((I|0)==73){J=tna(r,y)|0;K=0;L=N}N=o;y=q;r=f[o>>2]|0;w=r&4095;v=(w|0)==11;x=f[q>>2]|0;if(v)if((x&4094|0)!=2?(f[q+16>>2]|0)!=0:0){M=f[q+4>>2]|0;if((M|0)<3)O=Y(f[q+12>>2]|0,f[q+8>>2]|0)|0;else{A=f[q+40>>2]|0;a=0;g=1;while(1){d=Y(f[A+(a<<2)>>2]|0,g)|0;a=a+1|0;if((a|0)==(M|0)){O=d;break}else g=d}}if(!((M|0)==0|(O|0)==0))I=82;else I=90}else I=90;else I=82;do if((I|0)==82){O=x&4095;if((O|0)==11){if((r&4094|0)==2){I=90;break}if(!(f[o+16>>2]|0)){I=90;break}M=f[o+4>>2]|0;if((M|0)<3)P=Y(f[o+12>>2]|0,f[o+8>>2]|0)|0;else{g=f[e>>2]|0;a=0;A=1;while(1){d=Y(f[g+(a<<2)>>2]|0,A)|0;a=a+1|0;if((a|0)==(M|0)){P=d;break}else A=d}}if((M|0)==0|(P|0)==0){I=90;break}}switch(r&4095){case 11:case 13:{if(f[q+16>>2]|0){A=f[q+4>>2]|0;if((A|0)<3)Q=Y(f[q+12>>2]|0,f[q+8>>2]|0)|0;else{a=f[q+40>>2]|0;g=0;d=1;while(1){m=Y(f[a+(g<<2)>>2]|0,d)|0;g=g+1|0;if((g|0)==(A|0)){Q=m;break}else d=m}}if(!((A|0)==0|(Q|0)==0))I=98;else R=r}else R=r;break}default:I=98}if((I|0)==98)if((w|0)==5&(O|0)==5)R=r;else{f[k>>2]=0;f[k+4>>2]=0;Vac(aD(k,258)|0,270129,258)|0;bO(-215,k,269950,269810,1840);bD(k);R=f[o>>2]|0}S=(R&4088|0)==0;T=y;U=N}while(0);if((I|0)==90){S=0;T=v?y:N;U=v?N:y}f[k>>2]=66564;f[k+4>>2]=n;f[k+8>>2]=s;f[k+12>>2]=U;f[k+16>>2]=T;f[k+20>>2]=h;p[k+24>>3]=+p[i>>3];p[k+32>>3]=+p[i+8>>3];p[k+40>>3]=+p[i+16>>3];p[k+48>>3]=+p[i+24>>3];f[k+56>>2]=S&1;f[k+60>>2]=K;f[k+64>>2]=L;f[k+68>>2]=J;J=f[s+8>>2]|0;f[t>>2]=0;f[t+4>>2]=J;L=s+4|0;K=f[L>>2]|0;if((K|0)<3)V=Y(f[D>>2]|0,J)|0;else{J=f[s+40>>2]|0;D=0;S=1;while(1){i=Y(f[J+(D<<2)>>2]|0,S)|0;D=D+1|0;if((D|0)==(K|0)){V=i;break}else S=i}}RQ(t,k,+(V>>>0)*.0000152587890625);V=s+36|0;k=f[V>>2]|0;if(k|0?(t=k+12|0,k=f[t>>2]|0,f[t>>2]=k+-1,(k|0)==1):0)kL(s);f[V>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[L>>2]|0)>0){c=f[s+40>>2]|0;V=0;do{f[c+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[L>>2]|0))}L=f[s+44>>2]|0;if((L|0)!=(s+48|0))UC(L);L=q+36|0;s=f[L>>2]|0;if(s|0?(V=s+12|0,s=f[V>>2]|0,f[V>>2]=s+-1,(s|0)==1):0)kL(q);f[L>>2]=0;L=q+16|0;s=q+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[s>>2]|0)>0){L=f[q+40>>2]|0;V=0;do{f[L+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[s>>2]|0))}s=f[q+44>>2]|0;if((s|0)!=(q+48|0))UC(s);s=o+36|0;q=f[s>>2]|0;if(q|0?(V=q+12|0,q=f[V>>2]|0,f[V>>2]=q+-1,(q|0)==1):0)kL(o);f[s>>2]=0;s=o+16|0;q=o+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[q>>2]|0)>0){s=f[e>>2]|0;e=0;do{f[s+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[q>>2]|0))}q=f[o+44>>2]|0;if((q|0)!=(o+48|0))UC(q);q=n+36|0;o=f[q>>2]|0;do if(o|0){e=o+12|0;s=f[e>>2]|0;f[e>>2]=s+-1;if((s|0)!=1)break;kL(n)}while(0);f[q>>2]=0;q=n+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[q>>2]|0)>0){z=f[n+40>>2]|0;o=0;do{f[z+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[q>>2]|0))}q=f[n+44>>2]|0;if((q|0)!=(n+48|0))UC(q);if(!(f[l+4>>2]|0)){u=j;return}u=j;return}function vna(a){a=a|0;O5b(a);return}function wna(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0;c=u;u=u+416|0;e=c+352|0;g=c+296|0;i=c+240|0;k=c+184|0;l=c+72|0;m=c+16|0;o=c+128|0;p=c;q=a+8|0;r=f[q>>2]|0;s=f[r+8>>2]|0;t=a+12|0;v=f[f[t>>2]>>2]&7;w=16384/(((s|0)<128?s:128)|0)|0;x=f[r+12>>2]|0;r=(x|0)<(w|0)?x:w;w=16384/(r|0)|0;x=(s|0)<(w|0)?s:w;f[g>>2]=1124007936;w=g+4|0;s=g+8|0;y=g+40|0;z=w;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[y>>2]=s;s=g+48|0;B=g+44|0;f[B>>2]=s;f[s>>2]=0;f[g+52>>2]=0;f[e>>2]=x;C=e+4|0;f[C>>2]=r;hL(g,2,e,11);f[i>>2]=1124007936;D=i+4|0;E=i+8|0;F=i+40|0;z=D;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[F>>2]=E;E=i+48|0;z=i+44|0;f[z>>2]=E;f[E>>2]=0;f[i+52>>2]=0;A=a+60|0;if(!(f[A>>2]|0)){f[e>>2]=x;f[C>>2]=r;hL(i,2,e,2)}C=f[b>>2]|0;G=b+4|0;if((C|0)<(f[G>>2]|0)){b=k+4|0;H=k+8|0;I=k+12|0;J=l+4|0;K=l+8|0;L=l+12|0;M=m+4|0;N=m+8|0;O=m+12|0;P=a+64|0;Q=a+4|0;R=a+68|0;S=a+20|0;T=a+24|0;U=l+36|0;V=l+16|0;W=l+4|0;X=l+40|0;Z=l+44|0;_=l+48|0;$=k+16|0;aa=k+44|0;ba=a+16|0;ca=p+4|0;da=p+8|0;ea=p+12|0;fa=m+36|0;ga=k+36|0;ha=k+4|0;ia=k+40|0;ja=m+4|0;ka=m+8|0;la=k+8|0;ma=m+12|0;na=k+12|0;oa=m+44|0;pa=m+16|0;qa=m+20|0;ra=k+20|0;sa=m+24|0;ta=k+24|0;ua=m+28|0;va=k+28|0;wa=m+32|0;xa=k+32|0;ya=m+40|0;za=m+48|0;Aa=a+56|0;a=k+48|0;Ba=e+36|0;Ca=e+16|0;Da=e+4|0;Ea=e+40|0;Fa=e+44|0;Ga=e+48|0;Ha=m+4|0;Ia=m+8|0;Ja=m+12|0;Ka=l+36|0;La=l+4|0;Ma=l+8|0;Na=l+12|0;Oa=l+44|0;Pa=l+16|0;Qa=l+20|0;Ra=l+24|0;Sa=l+28|0;Ta=l+32|0;Ua=l+40|0;Va=l+48|0;Wa=(v|0)==5;v=l+4|0;Xa=l+8|0;Ya=l+12|0;Za=m+8|0;_a=m+4|0;$a=o+36|0;ab=o+16|0;bb=o+4|0;cb=o+40|0;db=o+44|0;eb=o+48|0;fb=C;C=f[q>>2]|0;while(1){gb=f[C+12>>2]|0;if((gb|0)>0){hb=0;ib=gb;gb=C;while(1){jb=(f[G>>2]|0)-fb|0;kb=(jb|0)<(x|0)?jb:x;jb=ib-hb|0;lb=(jb|0)<(r|0)?jb:r;f[k>>2]=hb;f[b>>2]=fb;f[H>>2]=lb;f[I>>2]=kb;nL(e,gb,k);f[l>>2]=0;f[J>>2]=0;f[K>>2]=lb;f[L>>2]=kb;nL(k,g,l);if(!(f[A>>2]|0)){f[m>>2]=0;f[M>>2]=0;f[N>>2]=lb;f[O>>2]=kb;nL(l,i,m);if((kb|0)>0){jb=(lb|0)>0;mb=hb<<1;nb=0;do{ob=(f[$>>2]|0)+(Y(f[f[aa>>2]>>2]|0,nb)|0)|0;pb=(f[V>>2]|0)+(Y(f[f[Z>>2]>>2]|0,nb)|0)|0;qb=f[t>>2]|0;do if((f[qb>>2]&4095|0)==11?(f[f[ba>>2]>>2]&4094|0)==2:0){f[p>>2]=hb;f[ca>>2]=fb;f[da>>2]=lb;f[ea>>2]=kb;nL(m,qb,p);rb=f[fa>>2]|0;if(rb|0){sb=rb+12|0;f[sb>>2]=(f[sb>>2]|0)+1}sb=f[ga>>2]|0;if(sb|0?(rb=sb+12|0,sb=f[rb>>2]|0,f[rb>>2]=sb+-1,(sb|0)==1):0)kL(k);f[ga>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[ha>>2]|0)>0){sb=f[ia>>2]|0;rb=0;do{f[sb+(rb<<2)>>2]=0;rb=rb+1|0;tb=f[ha>>2]|0}while((rb|0)<(tb|0));f[k>>2]=f[m>>2];if((tb|0)<3)ub=73;else ub=75}else{f[k>>2]=f[m>>2];ub=73}if((ub|0)==73){ub=0;rb=f[ja>>2]|0;if((rb|0)<3){f[ha>>2]=rb;f[la>>2]=f[ka>>2];f[na>>2]=f[ma>>2];rb=f[oa>>2]|0;sb=f[aa>>2]|0;f[sb>>2]=f[rb>>2];f[sb+4>>2]=f[rb+4>>2]}else ub=75}if((ub|0)==75){ub=0;jL(k,m)}f[$>>2]=f[pa>>2];f[ra>>2]=f[qa>>2];f[ta>>2]=f[sa>>2];f[va>>2]=f[ua>>2];f[xa>>2]=f[wa>>2];rb=f[fa>>2]|0;f[ga>>2]=rb;do if(rb|0){sb=rb+12|0;vb=f[sb>>2]|0;f[sb>>2]=vb+-1;if((vb|0)!=1)break;kL(m)}while(0);f[fa>>2]=0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[ja>>2]|0)>0){rb=f[ya>>2]|0;vb=0;do{f[rb+(vb<<2)>>2]=0;vb=vb+1|0}while((vb|0)<(f[ja>>2]|0))}vb=f[oa>>2]|0;if((vb|0)!=(za|0))UC(vb);vb=f[ba>>2]|0;rb=(f[vb+16>>2]|0)+(Y(f[f[vb+44>>2]>>2]|0,nb+fb|0)|0)+(hb<<1)|0;if(jb)wb=0;else break;do{d[pb+(wb<<1)>>1]=d[rb+(wb<<1)>>1]&1023;wb=wb+1|0}while((wb|0)<(lb|0))}else ub=86;while(0);do if((ub|0)==86){ub=0;rb=nb+fb|0;vb=(f[qb+16>>2]|0)+(Y(f[f[qb+44>>2]>>2]|0,rb)|0)|0;if(!(f[Aa>>2]|0)){sb=vb+(mb<<2)|0;if(jb)xb=0;else break;do{yb=xb<<1;zb=LVb(+n[sb+(yb<<2)>>2]*32.0)|0;Ab=yb|1;Bb=LVb(+n[sb+(Ab<<2)>>2]*32.0)|0;Cb=zb>>5;d[ob+(yb<<1)>>1]=(Cb+32768|0)>>>0<65536?Cb:(Cb|0)>0?32767:32768;Cb=Bb>>5;d[ob+(Ab<<1)>>1]=(Cb+32768|0)>>>0<65536?Cb:(Cb|0)>0?32767:32768;d[pb+(xb<<1)>>1]=Bb<<5&992|zb&31;xb=xb+1|0}while((xb|0)<(lb|0))}else{sb=vb+(hb<<2)|0;zb=f[ba>>2]|0;Bb=(f[zb+16>>2]|0)+(Y(f[f[zb+44>>2]>>2]|0,rb)|0)+(hb<<2)|0;if(jb)Db=0;else break;do{zb=LVb(+n[sb+(Db<<2)>>2]*32.0)|0;Cb=LVb(+n[Bb+(Db<<2)>>2]*32.0)|0;Ab=zb>>5;yb=Db<<1;d[ob+(yb<<1)>>1]=(Ab+32768|0)>>>0<65536?Ab:(Ab|0)>0?32767:32768;Ab=Cb>>5;d[ob+((yb|1)<<1)>>1]=(Ab+32768|0)>>>0<65536?Ab:(Ab|0)>0?32767:32768;d[pb+(Db<<1)>>1]=Cb<<5&992|zb&31;Db=Db+1|0}while((Db|0)<(lb|0))}}while(0);nb=nb+1|0}while((nb|0)<(kb|0))}Qh[f[P>>2]&127](f[Q>>2]|0,e,k,l,f[R>>2]|0,f[S>>2]|0,T);nb=f[U>>2]|0;if(nb|0?(jb=nb+12|0,nb=f[jb>>2]|0,f[jb>>2]=nb+-1,(nb|0)==1):0)kL(l);f[U>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[W>>2]|0)>0){nb=f[X>>2]|0;jb=0;do{f[nb+(jb<<2)>>2]=0;jb=jb+1|0}while((jb|0)<(f[W>>2]|0))}jb=f[Z>>2]|0;if((jb|0)!=(_|0))UC(jb)}else{jb=f[t>>2]|0;do if((f[jb>>2]&4095|0)==11){nb=f[ba>>2]|0;if(f[nb+16>>2]|0){mb=f[nb+4>>2]|0;if((mb|0)<3)Eb=Y(f[nb+12>>2]|0,f[nb+8>>2]|0)|0;else{pb=f[nb+40>>2]|0;nb=0;ob=1;while(1){qb=Y(f[pb+(nb<<2)>>2]|0,ob)|0;nb=nb+1|0;if((nb|0)==(mb|0)){Eb=qb;break}else ob=qb}}if(!((mb|0)==0|(Eb|0)==0)){ub=36;break}}f[m>>2]=hb;f[Ha>>2]=fb;f[Ia>>2]=lb;f[Ja>>2]=kb;nL(l,jb,m);ob=f[Ka>>2]|0;if(ob|0){nb=ob+12|0;f[nb>>2]=(f[nb>>2]|0)+1}nb=f[ga>>2]|0;if(nb|0?(ob=nb+12|0,nb=f[ob>>2]|0,f[ob>>2]=nb+-1,(nb|0)==1):0)kL(k);f[ga>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[ha>>2]|0)>0){nb=f[ia>>2]|0;ob=0;do{f[nb+(ob<<2)>>2]=0;ob=ob+1|0;Fb=f[ha>>2]|0}while((ob|0)<(Fb|0));f[k>>2]=f[l>>2];if((Fb|0)<3)ub=24;else ub=26}else{f[k>>2]=f[l>>2];ub=24}if((ub|0)==24){ub=0;ob=f[La>>2]|0;if((ob|0)<3){f[ha>>2]=ob;f[la>>2]=f[Ma>>2];f[na>>2]=f[Na>>2];ob=f[Oa>>2]|0;nb=f[aa>>2]|0;f[nb>>2]=f[ob>>2];f[nb+4>>2]=f[ob+4>>2]}else ub=26}if((ub|0)==26){ub=0;jL(k,l)}f[$>>2]=f[Pa>>2];f[ra>>2]=f[Qa>>2];f[ta>>2]=f[Ra>>2];f[va>>2]=f[Sa>>2];f[xa>>2]=f[Ta>>2];ob=f[Ka>>2]|0;f[ga>>2]=ob;if(ob|0?(nb=ob+12|0,ob=f[nb>>2]|0,f[nb>>2]=ob+-1,(ob|0)==1):0)kL(l);f[Ka>>2]=0;f[Pa>>2]=0;f[Pa+4>>2]=0;f[Pa+8>>2]=0;f[Pa+12>>2]=0;if((f[La>>2]|0)>0){ob=f[Ua>>2]|0;nb=0;do{f[ob+(nb<<2)>>2]=0;nb=nb+1|0}while((nb|0)<(f[La>>2]|0))}nb=f[Oa>>2]|0;if((nb|0)!=(Va|0))UC(nb)}else ub=36;while(0);a:do if((ub|0)==36){ub=0;if(!Wa){if((kb|0)<=0)break;nb=f[$>>2]|0;ob=f[jb+16>>2]|0;mb=hb<<1;pb=f[ba>>2]|0;qb=f[pb+16>>2]|0;if((lb|0)<=0)break;Bb=f[f[aa>>2]>>2]|0;sb=f[f[jb+44>>2]>>2]|0;rb=f[f[pb+44>>2]>>2]|0;pb=0;while(1){vb=nb+(Y(Bb,pb)|0)|0;zb=pb+fb|0;Cb=ob+(Y(sb,zb)|0)+(mb<<1)|0;Ab=qb+(Y(rb,zb)|0)+(hb<<1)|0;zb=0;do{yb=d[Ab+(zb<<1)>>1]&1023;Gb=zb<<1;d[vb+(Gb<<1)>>1]=(h[1120406+(yb<<1)>>0]|0)+(j[Cb+(Gb<<1)>>1]|0);Hb=Gb|1;d[vb+(Hb<<1)>>1]=(h[1120406+(yb<<1)+1>>0]|0)+(j[Cb+(Hb<<1)>>1]|0);zb=zb+1|0}while((zb|0)<(lb|0));pb=pb+1|0;if((pb|0)>=(kb|0))break a}}if(f[Aa>>2]|0){if((kb|0)<=0)break;pb=f[$>>2]|0;rb=f[f[aa>>2]>>2]|0;qb=f[jb+16>>2]|0;mb=f[f[jb+44>>2]>>2]|0;sb=f[ba>>2]|0;ob=f[sb+16>>2]|0;Bb=f[f[sb+44>>2]>>2]|0;if((lb|0)>0)Ib=0;else break;while(1){sb=pb+(Y(rb,Ib)|0)|0;nb=Ib+fb|0;zb=qb+(Y(mb,nb)|0)+(hb<<2)|0;Cb=ob+(Y(Bb,nb)|0)+(hb<<2)|0;nb=0;do{vb=LVb(+n[zb+(nb<<2)>>2])|0;Ab=nb<<1;d[sb+(Ab<<1)>>1]=(vb+32768|0)>>>0<65536?vb:(vb|0)>0?32767:32768;vb=LVb(+n[Cb+(nb<<2)>>2])|0;d[sb+((Ab|1)<<1)>>1]=(vb+32768|0)>>>0<65536?vb:(vb|0)>0?32767:32768;nb=nb+1|0}while((nb|0)<(lb|0));Ib=Ib+1|0;if((Ib|0)>=(kb|0))break a}}f[l>>2]=hb;f[v>>2]=fb;f[Xa>>2]=lb;f[Ya>>2]=kb;nL(o,jb,l);Bb=Za;f[Bb>>2]=0;f[Bb+4>>2]=0;f[m>>2]=33619968;f[_a>>2]=k;OJ(o,m,f[k>>2]&7,1.0,0.0);Bb=f[$a>>2]|0;if(Bb|0?(ob=Bb+12|0,Bb=f[ob>>2]|0,f[ob>>2]=Bb+-1,(Bb|0)==1):0)kL(o);f[$a>>2]=0;f[ab>>2]=0;f[ab+4>>2]=0;f[ab+8>>2]=0;f[ab+12>>2]=0;if((f[bb>>2]|0)>0){Bb=f[cb>>2]|0;ob=0;do{f[Bb+(ob<<2)>>2]=0;ob=ob+1|0}while((ob|0)<(f[bb>>2]|0))}ob=f[db>>2]|0;if((ob|0)!=(eb|0))UC(ob)}while(0);uh[f[A>>2]&255](f[Q>>2]|0,e,k,f[S>>2]|0,T)}jb=f[ga>>2]|0;if(jb|0?(kb=jb+12|0,jb=f[kb>>2]|0,f[kb>>2]=jb+-1,(jb|0)==1):0)kL(k);f[ga>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[ha>>2]|0)>0){jb=f[ia>>2]|0;kb=0;do{f[jb+(kb<<2)>>2]=0;kb=kb+1|0}while((kb|0)<(f[ha>>2]|0))}kb=f[aa>>2]|0;if((kb|0)!=(a|0))UC(kb);kb=f[Ba>>2]|0;if(kb|0?(jb=kb+12|0,kb=f[jb>>2]|0,f[jb>>2]=kb+-1,(kb|0)==1):0)kL(e);f[Ba>>2]=0;f[Ca>>2]=0;f[Ca+4>>2]=0;f[Ca+8>>2]=0;f[Ca+12>>2]=0;if((f[Da>>2]|0)>0){kb=f[Ea>>2]|0;jb=0;do{f[kb+(jb<<2)>>2]=0;jb=jb+1|0}while((jb|0)<(f[Da>>2]|0))}jb=f[Fa>>2]|0;if((jb|0)!=(Ga|0))UC(jb);hb=hb+r|0;jb=f[q>>2]|0;ib=f[jb+12>>2]|0;if((ib|0)<=(hb|0)){Jb=jb;break}else gb=jb}}else Jb=C;fb=fb+x|0;if((fb|0)>=(f[G>>2]|0))break;else C=Jb}}Jb=i+36|0;C=f[Jb>>2]|0;if(C|0?(G=C+12|0,C=f[G>>2]|0,f[G>>2]=C+-1,(C|0)==1):0)kL(i);f[Jb>>2]=0;Jb=i+16|0;f[Jb>>2]=0;f[Jb+4>>2]=0;f[Jb+8>>2]=0;f[Jb+12>>2]=0;if((f[D>>2]|0)>0){Jb=f[F>>2]|0;F=0;do{f[Jb+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[D>>2]|0))}D=f[z>>2]|0;if((D|0)!=(E|0))UC(D);D=g+36|0;E=f[D>>2]|0;if(E|0?(z=E+12|0,E=f[z>>2]|0,f[z>>2]=E+-1,(E|0)==1):0)kL(g);f[D>>2]=0;D=g+16|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[w>>2]|0)>0){D=f[y>>2]|0;y=0;do{f[D+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[w>>2]|0))}w=f[B>>2]|0;if((w|0)==(s|0)){u=c;return}UC(w);u=c;return}function xna(a,c,e,g,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;m=u;u=u+576|0;n=m+64|0;o=m+32|0;q=m;r=f[a+40>>2]|0;s=f[r+4>>2]|0;t=f[r>>2]|0;r=f[c+40>>2]|0;v=f[r+4>>2]|0;w=f[r>>2]|0;r=(f[a>>2]|0)>>>3;x=(r&511)+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=MVb(+p[l+((a&3)<<3)>>3])|0;b[n+a>>0]=A>>>0<256?A:(A|0)>0?255:0;a=a+1|0}while((a|0)!=(x|0));a=(k|0)!=5?k:4;l=s+-7|0;A=(l|0)>0?l:0;l=t+-7|0;B=(l|0)>0?l:0;if((f[c>>2]&16384|0)!=0?(f[e>>2]&16384|0)!=0:0){l=(f[g>>2]&16384|0)!=0;C=Y(l?w:1,v)|0;if(l){D=C;E=1}else{F=C;G=6}}else{F=v;G=6}if((G|0)==6)if((w|0)>0){D=F;E=w}else{u=m;return}w=c+16|0;F=c+44|0;c=e+16|0;v=e+44|0;e=g+16|0;C=g+44|0;g=(D|0)>0;l=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(k|0)==5;k=(a|0)==0;P=o+4|0;Q=o+8|0;R=o+12|0;S=o+16|0;T=o+20|0;U=o+24|0;V=o+28|0;W=(r|-512)^511;r=q+4|0;X=q+8|0;Z=q+12|0;_=q+16|0;$=q+20|0;aa=q+24|0;ba=q+28|0;ca=0;da=y;while(1){y=f[w>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[c>>2]|0)+(Y(f[f[v>>2]>>2]|0,ca)|0)|0;ga=(f[e>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(g){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(x,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=i+(j[ga+(ia<<1)>>1]<<6<<1)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+(Y(la,z)|0)+(Y(oa,x)|0)|0;while(1){ta=0;ua=0;va=sa;wa=qa;while(1){xa=Y(d[wa>>1]|0,h[va>>0]|0)|0;ya=Y(d[wa+2>>1]|0,h[va+x>>0]|0)|0;za=Y(d[wa+4>>1]|0,h[va+l>>0]|0)|0;Aa=Y(d[wa+6>>1]|0,h[va+H>>0]|0)|0;Ba=Y(d[wa+8>>1]|0,h[va+I>>0]|0)|0;Ca=Y(d[wa+10>>1]|0,h[va+J>>0]|0)|0;Da=Y(d[wa+12>>1]|0,h[va+K>>0]|0)|0;ua=xa+ua+ya+za+Aa+Ba+Ca+Da+(Y(d[wa+14>>1]|0,h[va+L>>0]|0)|0)|0;ta=ta+1|0;if((ta|0)==8)break;else{va=va+z|0;wa=wa+16|0}}wa=ua+16384>>15;b[ha+ra>>0]=wa>>>0<256?wa:(wa|0)>0?255:0;ra=ra+1|0;if((ra|0)==(x|0)){Ea=ja;break}else sa=sa+M+N|0}}else{if(O?!(na>>>0<s>>>0&pa>>>0<t>>>0):0)Fa=ja;else G=19;do if((G|0)==19){G=0;if(k?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(s|0)&(la|0)<(t|0)^1:0){Vac(ka|0,n|0,x|0)|0;Fa=ja;break}sa=Y(ZP(oa,s,a)|0,x)|0;f[o>>2]=sa;ra=ZP(la,t,a)|0;f[q>>2]=ra;ra=Y(ZP(na+-2|0,s,a)|0,x)|0;f[P>>2]=ra;wa=ZP(pa+-2|0,t,a)|0;f[r>>2]=wa;wa=Y(ZP(na+-1|0,s,a)|0,x)|0;f[Q>>2]=wa;va=ZP(pa+-1|0,t,a)|0;f[X>>2]=va;va=Y(ZP(na,s,a)|0,x)|0;f[R>>2]=va;ta=ZP(pa,t,a)|0;f[Z>>2]=ta;ta=Y(ZP(na+1|0,s,a)|0,x)|0;f[S>>2]=ta;Da=ZP(pa+1|0,t,a)|0;f[_>>2]=Da;Da=Y(ZP(na+2|0,s,a)|0,x)|0;f[T>>2]=Da;Ca=ZP(pa+2|0,t,a)|0;f[$>>2]=Ca;Ca=Y(ZP(na+3|0,s,a)|0,x)|0;f[U>>2]=Ca;Ba=ZP(pa+3|0,t,a)|0;f[aa>>2]=Ba;Ba=Y(ZP(na+4|0,s,a)|0,x)|0;f[V>>2]=Ba;Aa=ZP(pa+4|0,t,a)|0;f[ba>>2]=Aa;Aa=0;za=ja;ya=sa;sa=ra;ra=wa;wa=va;va=ta;ta=Da;Da=Ca;Ca=Ba;while(1){Ba=h[n+Aa>>0]|0;xa=Ba<<15;Ga=(sa|0)>-1;Ha=(ra|0)>-1;Ia=(wa|0)>-1;Ja=(va|0)>-1;Ka=(ta|0)>-1;La=(Da|0)>-1;Ma=(Ca|0)>-1;if((ya|0)>-1){Na=0;Oa=xa;Pa=qa;while(1){Qa=f[q+(Na<<2)>>2]|0;Ra=za+(Y(Qa,z)|0)|0;do if((Qa|0)<0)Sa=Oa;else{Ta=(Y((h[Ra+ya>>0]|0)-Ba|0,d[Pa>>1]|0)|0)+Oa|0;if(Ga)Ua=(Y((h[Ra+sa>>0]|0)-Ba|0,d[Pa+2>>1]|0)|0)+Ta|0;else Ua=Ta;if(Ha)Va=(Y((h[Ra+ra>>0]|0)-Ba|0,d[Pa+4>>1]|0)|0)+Ua|0;else Va=Ua;if(Ia)Wa=(Y((h[Ra+wa>>0]|0)-Ba|0,d[Pa+6>>1]|0)|0)+Va|0;else Wa=Va;if(Ja)Xa=(Y((h[Ra+va>>0]|0)-Ba|0,d[Pa+8>>1]|0)|0)+Wa|0;else Xa=Wa;if(Ka)Ya=(Y((h[Ra+ta>>0]|0)-Ba|0,d[Pa+10>>1]|0)|0)+Xa|0;else Ya=Xa;if(La)Za=(Y((h[Ra+Da>>0]|0)-Ba|0,d[Pa+12>>1]|0)|0)+Ya|0;else Za=Ya;if(!Ma){Sa=Za;break}Sa=(Y((h[Ra+Ca>>0]|0)-Ba|0,d[Pa+14>>1]|0)|0)+Za|0}while(0);Na=Na+1|0;if((Na|0)==8){_a=Sa;break}else{Oa=Sa;Pa=Pa+16|0}}}else{Pa=0;Oa=xa;Na=qa;while(1){Ra=f[q+(Pa<<2)>>2]|0;Qa=za+(Y(Ra,z)|0)|0;do if((Ra|0)<0)$a=Oa;else{if(Ga)ab=(Y((h[Qa+sa>>0]|0)-Ba|0,d[Na+2>>1]|0)|0)+Oa|0;else ab=Oa;if(Ha)bb=(Y((h[Qa+ra>>0]|0)-Ba|0,d[Na+4>>1]|0)|0)+ab|0;else bb=ab;if(Ia)cb=(Y((h[Qa+wa>>0]|0)-Ba|0,d[Na+6>>1]|0)|0)+bb|0;else cb=bb;if(Ja)db=(Y((h[Qa+va>>0]|0)-Ba|0,d[Na+8>>1]|0)|0)+cb|0;else db=cb;if(Ka)eb=(Y((h[Qa+ta>>0]|0)-Ba|0,d[Na+10>>1]|0)|0)+db|0;else eb=db;if(La)fb=(Y((h[Qa+Da>>0]|0)-Ba|0,d[Na+12>>1]|0)|0)+eb|0;else fb=eb;if(!Ma){$a=fb;break}$a=(Y((h[Qa+Ca>>0]|0)-Ba|0,d[Na+14>>1]|0)|0)+fb|0}while(0);Pa=Pa+1|0;if((Pa|0)==8){_a=$a;break}else{Oa=$a;Na=Na+16|0}}}Na=_a+16384>>15;b[ha+Aa>>0]=Na>>>0<256?Na:(Na|0)>0?255:0;Na=Aa+1|0;if((Na|0)==(x|0))break;Aa=Na;za=za+1|0;ya=f[o>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;Da=f[U>>2]|0;Ca=f[V>>2]|0}Fa=ja+x+W|0}while(0);Ea=Fa}ia=ia+1|0;if((ia|0)==(D|0)){gb=Ea;break}else{ha=ha+x|0;ja=Ea}}}else gb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=gb}u=m;return}function yna(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+1088|0;l=k+64|0;m=k+32|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=MVb(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=0;da=y;while(1){y=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,ca)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(e){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(q,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ia<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+((Y(la,z)|0)<<1)+((Y(oa,x)|0)<<1)|0;while(1){ta=0;ua=0.0;va=sa;wa=qa;while(1){ua=ua+(+(j[va>>1]|0)*+n[wa>>2]+ +(j[va+(x<<1)>>1]|0)*+n[wa+4>>2]+ +(j[va+(i<<1)>>1]|0)*+n[wa+8>>2]+ +(j[va+(H<<1)>>1]|0)*+n[wa+12>>2]+ +(j[va+(I<<1)>>1]|0)*+n[wa+16>>2]+ +(j[va+(J<<1)>>1]|0)*+n[wa+20>>2]+ +(j[va+(K<<1)>>1]|0)*+n[wa+24>>2]+ +(j[va+(L<<1)>>1]|0)*+n[wa+28>>2]);ta=ta+1|0;if((ta|0)==8)break;else{va=va+(z<<1)|0;wa=wa+32|0}}wa=LVb(ua)|0;d[ha+(ra<<1)>>1]=wa>>>0<65536?wa:(wa|0)>0?65535:0;ra=ra+1|0;if((ra|0)==(x|0)){xa=ja;break}else sa=sa+(M<<1)+(N<<1)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ja;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){Vac(ka|0,l|0,q|0)|0;ya=ja;break}sa=Y(ZP(oa,r,a)|0,x)|0;f[m>>2]=sa;ra=ZP(la,s,a)|0;f[o>>2]=ra;ra=Y(ZP(na+-2|0,r,a)|0,x)|0;f[P>>2]=ra;wa=ZP(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(ZP(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;va=ZP(pa+-1|0,s,a)|0;f[X>>2]=va;va=Y(ZP(na,r,a)|0,x)|0;f[R>>2]=va;ta=ZP(pa,s,a)|0;f[Z>>2]=ta;ta=Y(ZP(na+1|0,r,a)|0,x)|0;f[S>>2]=ta;za=ZP(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(ZP(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=ZP(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(ZP(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=ZP(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(ZP(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=ZP(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=0;Da=ja;Ea=sa;sa=ra;ra=wa;wa=va;va=ta;ta=za;za=Aa;Aa=Ba;while(1){Fa=+(j[l+(Ca<<1)>>1]|0);Ba=(sa|0)>-1;Ga=(ra|0)>-1;Ha=(wa|0)>-1;Ia=(va|0)>-1;Ja=(ta|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ea|0)>-1){Ma=0;Na=Fa;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Da+((Y(Pa,z)|0)<<1)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+ +n[Oa>>2]*(+(j[Qa+(Ea<<1)>>1]|0)-Fa);if(Ba)Ta=Sa+ +n[Oa+4>>2]*(+(j[Qa+(sa<<1)>>1]|0)-Fa);else Ta=Sa;if(Ga)Ua=Ta+ +n[Oa+8>>2]*(+(j[Qa+(ra<<1)>>1]|0)-Fa);else Ua=Ta;if(Ha)Va=Ua+ +n[Oa+12>>2]*(+(j[Qa+(wa<<1)>>1]|0)-Fa);else Va=Ua;if(Ia)Wa=Va+ +n[Oa+16>>2]*(+(j[Qa+(va<<1)>>1]|0)-Fa);else Wa=Va;if(Ja)Xa=Wa+ +n[Oa+20>>2]*(+(j[Qa+(ta<<1)>>1]|0)-Fa);else Xa=Wa;if(Ka)Ya=Xa+ +n[Oa+24>>2]*(+(j[Qa+(za<<1)>>1]|0)-Fa);else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+ +n[Oa+28>>2]*(+(j[Qa+(Aa<<1)>>1]|0)-Fa)}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Fa;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Da+((Y(Qa,z)|0)<<1)|0;do if((Qa|0)<0)_a=Na;else{if(Ba)$a=Na+ +n[Ma+4>>2]*(+(j[Pa+(sa<<1)>>1]|0)-Fa);else $a=Na;if(Ga)ab=$a+ +n[Ma+8>>2]*(+(j[Pa+(ra<<1)>>1]|0)-Fa);else ab=$a;if(Ha)bb=ab+ +n[Ma+12>>2]*(+(j[Pa+(wa<<1)>>1]|0)-Fa);else bb=ab;if(Ia)cb=bb+ +n[Ma+16>>2]*(+(j[Pa+(va<<1)>>1]|0)-Fa);else cb=bb;if(Ja)db=cb+ +n[Ma+20>>2]*(+(j[Pa+(ta<<1)>>1]|0)-Fa);else db=cb;if(Ka)eb=db+ +n[Ma+24>>2]*(+(j[Pa+(za<<1)>>1]|0)-Fa);else eb=db;if(!La){_a=eb;break}_a=eb+ +n[Ma+28>>2]*(+(j[Pa+(Aa<<1)>>1]|0)-Fa)}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}Ma=LVb(Za)|0;d[ha+(Ca<<1)>>1]=Ma>>>0<65536?Ma:(Ma|0)>0?65535:0;Ma=Ca+1|0;if((Ma|0)==(x|0))break;Ca=Ma;Da=Da+2|0;Ea=f[m>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0}ya=ja+(x<<1)+(W<<1)|0}while(0);xa=ya}ia=ia+1|0;if((ia|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<1)|0;ja=xa}}}else fb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=fb}u=k;return}function zna(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+1088|0;l=k+64|0;m=k+32|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=MVb(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=0;da=y;while(1){y=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,ca)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(e){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(q,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ia<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+((Y(la,z)|0)<<1)+((Y(oa,x)|0)<<1)|0;while(1){ta=0;ua=0.0;va=sa;wa=qa;while(1){ua=ua+(+(d[va>>1]|0)*+n[wa>>2]+ +(d[va+(x<<1)>>1]|0)*+n[wa+4>>2]+ +(d[va+(i<<1)>>1]|0)*+n[wa+8>>2]+ +(d[va+(H<<1)>>1]|0)*+n[wa+12>>2]+ +(d[va+(I<<1)>>1]|0)*+n[wa+16>>2]+ +(d[va+(J<<1)>>1]|0)*+n[wa+20>>2]+ +(d[va+(K<<1)>>1]|0)*+n[wa+24>>2]+ +(d[va+(L<<1)>>1]|0)*+n[wa+28>>2]);ta=ta+1|0;if((ta|0)==8)break;else{va=va+(z<<1)|0;wa=wa+32|0}}wa=LVb(ua)|0;d[ha+(ra<<1)>>1]=(wa+32768|0)>>>0<65536?wa:(wa|0)>0?32767:32768;ra=ra+1|0;if((ra|0)==(x|0)){xa=ja;break}else sa=sa+(M<<1)+(N<<1)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ja;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){Vac(ka|0,l|0,q|0)|0;ya=ja;break}sa=Y(ZP(oa,r,a)|0,x)|0;f[m>>2]=sa;ra=ZP(la,s,a)|0;f[o>>2]=ra;ra=Y(ZP(na+-2|0,r,a)|0,x)|0;f[P>>2]=ra;wa=ZP(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(ZP(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;va=ZP(pa+-1|0,s,a)|0;f[X>>2]=va;va=Y(ZP(na,r,a)|0,x)|0;f[R>>2]=va;ta=ZP(pa,s,a)|0;f[Z>>2]=ta;ta=Y(ZP(na+1|0,r,a)|0,x)|0;f[S>>2]=ta;za=ZP(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(ZP(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=ZP(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(ZP(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=ZP(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(ZP(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=ZP(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=0;Da=ja;Ea=sa;sa=ra;ra=wa;wa=va;va=ta;ta=za;za=Aa;Aa=Ba;while(1){Fa=+(d[l+(Ca<<1)>>1]|0);Ba=(sa|0)>-1;Ga=(ra|0)>-1;Ha=(wa|0)>-1;Ia=(va|0)>-1;Ja=(ta|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ea|0)>-1){Ma=0;Na=Fa;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Da+((Y(Pa,z)|0)<<1)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+ +n[Oa>>2]*(+(d[Qa+(Ea<<1)>>1]|0)-Fa);if(Ba)Ta=Sa+ +n[Oa+4>>2]*(+(d[Qa+(sa<<1)>>1]|0)-Fa);else Ta=Sa;if(Ga)Ua=Ta+ +n[Oa+8>>2]*(+(d[Qa+(ra<<1)>>1]|0)-Fa);else Ua=Ta;if(Ha)Va=Ua+ +n[Oa+12>>2]*(+(d[Qa+(wa<<1)>>1]|0)-Fa);else Va=Ua;if(Ia)Wa=Va+ +n[Oa+16>>2]*(+(d[Qa+(va<<1)>>1]|0)-Fa);else Wa=Va;if(Ja)Xa=Wa+ +n[Oa+20>>2]*(+(d[Qa+(ta<<1)>>1]|0)-Fa);else Xa=Wa;if(Ka)Ya=Xa+ +n[Oa+24>>2]*(+(d[Qa+(za<<1)>>1]|0)-Fa);else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+ +n[Oa+28>>2]*(+(d[Qa+(Aa<<1)>>1]|0)-Fa)}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Fa;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Da+((Y(Qa,z)|0)<<1)|0;do if((Qa|0)<0)_a=Na;else{if(Ba)$a=Na+ +n[Ma+4>>2]*(+(d[Pa+(sa<<1)>>1]|0)-Fa);else $a=Na;if(Ga)ab=$a+ +n[Ma+8>>2]*(+(d[Pa+(ra<<1)>>1]|0)-Fa);else ab=$a;if(Ha)bb=ab+ +n[Ma+12>>2]*(+(d[Pa+(wa<<1)>>1]|0)-Fa);else bb=ab;if(Ia)cb=bb+ +n[Ma+16>>2]*(+(d[Pa+(va<<1)>>1]|0)-Fa);else cb=bb;if(Ja)db=cb+ +n[Ma+20>>2]*(+(d[Pa+(ta<<1)>>1]|0)-Fa);else db=cb;if(Ka)eb=db+ +n[Ma+24>>2]*(+(d[Pa+(za<<1)>>1]|0)-Fa);else eb=db;if(!La){_a=eb;break}_a=eb+ +n[Ma+28>>2]*(+(d[Pa+(Aa<<1)>>1]|0)-Fa)}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}Ma=LVb(Za)|0;d[ha+(Ca<<1)>>1]=(Ma+32768|0)>>>0<65536?Ma:(Ma|0)>0?32767:32768;Ma=Ca+1|0;if((Ma|0)==(x|0))break;Ca=Ma;Da=Da+2|0;Ea=f[m>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0}ya=ja+(x<<1)+(W<<1)|0}while(0);xa=ya}ia=ia+1|0;if((ia|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<1)|0;ja=xa}}}else fb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=fb}u=k;return}function Ana(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+2112|0;l=k+64|0;m=k+32|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>2;a=0;do{n[l+(a<<2)>>2]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<2)+4|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=0;da=y;while(1){y=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,ca)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(e){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(q,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ia<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+((Y(la,z)|0)<<2)+((Y(oa,x)|0)<<2)|0;while(1){ta=0;ua=0.0;va=sa;wa=qa;while(1){ua=ua+(+n[va>>2]*+n[wa>>2]+ +n[va+(x<<2)>>2]*+n[wa+4>>2]+ +n[va+(i<<2)>>2]*+n[wa+8>>2]+ +n[va+(H<<2)>>2]*+n[wa+12>>2]+ +n[va+(I<<2)>>2]*+n[wa+16>>2]+ +n[va+(J<<2)>>2]*+n[wa+20>>2]+ +n[va+(K<<2)>>2]*+n[wa+24>>2]+ +n[va+(L<<2)>>2]*+n[wa+28>>2]);ta=ta+1|0;if((ta|0)==8)break;else{va=va+(z<<2)|0;wa=wa+32|0}}n[ha+(ra<<2)>>2]=ua;ra=ra+1|0;if((ra|0)==(x|0)){xa=ja;break}else sa=sa+(M<<2)+(N<<2)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ja;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){Vac(ka|0,l|0,q|0)|0;ya=ja;break}sa=Y(ZP(oa,r,a)|0,x)|0;f[m>>2]=sa;ra=ZP(la,s,a)|0;f[o>>2]=ra;ra=Y(ZP(na+-2|0,r,a)|0,x)|0;f[P>>2]=ra;wa=ZP(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(ZP(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;va=ZP(pa+-1|0,s,a)|0;f[X>>2]=va;va=Y(ZP(na,r,a)|0,x)|0;f[R>>2]=va;ta=ZP(pa,s,a)|0;f[Z>>2]=ta;ta=Y(ZP(na+1|0,r,a)|0,x)|0;f[S>>2]=ta;za=ZP(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(ZP(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=ZP(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(ZP(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=ZP(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(ZP(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=ZP(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=0;Da=ja;Ea=sa;sa=ra;ra=wa;wa=va;va=ta;ta=za;za=Aa;Aa=Ba;while(1){Fa=+n[l+(Ca<<2)>>2];Ba=(sa|0)>-1;Ga=(ra|0)>-1;Ha=(wa|0)>-1;Ia=(va|0)>-1;Ja=(ta|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ea|0)>-1){Ma=0;Na=Fa;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Da+((Y(Pa,z)|0)<<2)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+(+n[Qa+(Ea<<2)>>2]-Fa)*+n[Oa>>2];if(Ba)Ta=Sa+(+n[Qa+(sa<<2)>>2]-Fa)*+n[Oa+4>>2];else Ta=Sa;if(Ga)Ua=Ta+(+n[Qa+(ra<<2)>>2]-Fa)*+n[Oa+8>>2];else Ua=Ta;if(Ha)Va=Ua+(+n[Qa+(wa<<2)>>2]-Fa)*+n[Oa+12>>2];else Va=Ua;if(Ia)Wa=Va+(+n[Qa+(va<<2)>>2]-Fa)*+n[Oa+16>>2];else Wa=Va;if(Ja)Xa=Wa+(+n[Qa+(ta<<2)>>2]-Fa)*+n[Oa+20>>2];else Xa=Wa;if(Ka)Ya=Xa+(+n[Qa+(za<<2)>>2]-Fa)*+n[Oa+24>>2];else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+(+n[Qa+(Aa<<2)>>2]-Fa)*+n[Oa+28>>2]}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Fa;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Da+((Y(Qa,z)|0)<<2)|0;do if((Qa|0)<0)_a=Na;else{if(Ba)$a=Na+(+n[Pa+(sa<<2)>>2]-Fa)*+n[Ma+4>>2];else $a=Na;if(Ga)ab=$a+(+n[Pa+(ra<<2)>>2]-Fa)*+n[Ma+8>>2];else ab=$a;if(Ha)bb=ab+(+n[Pa+(wa<<2)>>2]-Fa)*+n[Ma+12>>2];else bb=ab;if(Ia)cb=bb+(+n[Pa+(va<<2)>>2]-Fa)*+n[Ma+16>>2];else cb=bb;if(Ja)db=cb+(+n[Pa+(ta<<2)>>2]-Fa)*+n[Ma+20>>2];else db=cb;if(Ka)eb=db+(+n[Pa+(za<<2)>>2]-Fa)*+n[Ma+24>>2];else eb=db;if(!La){_a=eb;break}_a=eb+(+n[Pa+(Aa<<2)>>2]-Fa)*+n[Ma+28>>2]}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}n[ha+(Ca<<2)>>2]=Za;Ma=Ca+1|0;if((Ma|0)==(x|0))break;Ca=Ma;Da=Da+4|0;Ea=f[m>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0}ya=ja+(x<<2)+(W<<2)|0}while(0);xa=ya}ia=ia+1|0;if((ia|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<2)|0;ja=xa}}}else fb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=fb}u=k;return}function Bna(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0,Pa=0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0;k=u;u=u+4160|0;l=k;m=k+4128|0;o=k+4096|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>3;a=0;do{p[l+(a<<3)>>3]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-7|0;A=(i|0)>0?i:0;i=s+-7|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=x<<2;J=x*5|0;K=x*6|0;L=x*7|0;M=z<<3;N=1-M|0;O=(h|0)==5;h=(a|0)==0;P=m+4|0;Q=m+8|0;R=m+12|0;S=m+16|0;T=m+20|0;U=m+24|0;V=m+28|0;W=(q|-512)^511;q=(w<<3)+8|0;w=o+4|0;X=o+8|0;Z=o+12|0;_=o+16|0;$=o+20|0;aa=o+24|0;ba=o+28|0;ca=0;da=y;while(1){y=f[v>>2]|0;ea=Y(f[f[F>>2]>>2]|0,ca)|0;fa=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,ca)|0)|0;ga=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,ca)|0)|0;if(e){ha=y+ea|0;ia=0;ja=da;while(1){ka=y+(ea+(Y(q,ia)|0))|0;la=ia<<1;ma=d[fa+(la<<1)>>1]|0;na=ma<<16>>16;oa=na+-3|0;pa=d[fa+((la|1)<<1)>>1]|0;la=pa+-3|0;qa=g+(j[ga+(ia<<1)>>1]<<6<<2)|0;if(oa>>>0<A>>>0&la>>>0<B>>>0){ra=0;sa=ja+((Y(la,z)|0)<<3)+((Y(oa,x)|0)<<3)|0;while(1){ta=0;ua=0.0;va=sa;wa=qa;while(1){ua=ua+(+p[va>>3]*+n[wa>>2]+ +p[va+(x<<3)>>3]*+n[wa+4>>2]+ +p[va+(i<<3)>>3]*+n[wa+8>>2]+ +p[va+(H<<3)>>3]*+n[wa+12>>2]+ +p[va+(I<<3)>>3]*+n[wa+16>>2]+ +p[va+(J<<3)>>3]*+n[wa+20>>2]+ +p[va+(K<<3)>>3]*+n[wa+24>>2]+ +p[va+(L<<3)>>3]*+n[wa+28>>2]);ta=ta+1|0;if((ta|0)==8)break;else{va=va+(z<<3)|0;wa=wa+32|0}}p[ha+(ra<<3)>>3]=ua;ra=ra+1|0;if((ra|0)==(x|0)){xa=ja;break}else sa=sa+(M<<3)+(N<<3)|0}}else{if(O?!(na>>>0<r>>>0&pa>>>0<s>>>0):0)ya=ja;else G=19;do if((G|0)==19){G=0;if(h?(pa+5|0)<1|ma<<16>>16>-5&(oa|0)<(r|0)&(la|0)<(s|0)^1:0){Vac(ka|0,l|0,q|0)|0;ya=ja;break}sa=Y(ZP(oa,r,a)|0,x)|0;f[m>>2]=sa;ra=ZP(la,s,a)|0;f[o>>2]=ra;ra=Y(ZP(na+-2|0,r,a)|0,x)|0;f[P>>2]=ra;wa=ZP(pa+-2|0,s,a)|0;f[w>>2]=wa;wa=Y(ZP(na+-1|0,r,a)|0,x)|0;f[Q>>2]=wa;va=ZP(pa+-1|0,s,a)|0;f[X>>2]=va;va=Y(ZP(na,r,a)|0,x)|0;f[R>>2]=va;ta=ZP(pa,s,a)|0;f[Z>>2]=ta;ta=Y(ZP(na+1|0,r,a)|0,x)|0;f[S>>2]=ta;za=ZP(pa+1|0,s,a)|0;f[_>>2]=za;za=Y(ZP(na+2|0,r,a)|0,x)|0;f[T>>2]=za;Aa=ZP(pa+2|0,s,a)|0;f[$>>2]=Aa;Aa=Y(ZP(na+3|0,r,a)|0,x)|0;f[U>>2]=Aa;Ba=ZP(pa+3|0,s,a)|0;f[aa>>2]=Ba;Ba=Y(ZP(na+4|0,r,a)|0,x)|0;f[V>>2]=Ba;Ca=ZP(pa+4|0,s,a)|0;f[ba>>2]=Ca;Ca=0;Da=ja;Ea=sa;sa=ra;ra=wa;wa=va;va=ta;ta=za;za=Aa;Aa=Ba;while(1){Fa=+p[l+(Ca<<3)>>3];Ba=(sa|0)>-1;Ga=(ra|0)>-1;Ha=(wa|0)>-1;Ia=(va|0)>-1;Ja=(ta|0)>-1;Ka=(za|0)>-1;La=(Aa|0)>-1;if((Ea|0)>-1){Ma=0;Na=Fa;Oa=qa;while(1){Pa=f[o+(Ma<<2)>>2]|0;Qa=Da+((Y(Pa,z)|0)<<3)|0;do if((Pa|0)<0)Ra=Na;else{Sa=Na+(+p[Qa+(Ea<<3)>>3]-Fa)*+n[Oa>>2];if(Ba)Ta=Sa+(+p[Qa+(sa<<3)>>3]-Fa)*+n[Oa+4>>2];else Ta=Sa;if(Ga)Ua=Ta+(+p[Qa+(ra<<3)>>3]-Fa)*+n[Oa+8>>2];else Ua=Ta;if(Ha)Va=Ua+(+p[Qa+(wa<<3)>>3]-Fa)*+n[Oa+12>>2];else Va=Ua;if(Ia)Wa=Va+(+p[Qa+(va<<3)>>3]-Fa)*+n[Oa+16>>2];else Wa=Va;if(Ja)Xa=Wa+(+p[Qa+(ta<<3)>>3]-Fa)*+n[Oa+20>>2];else Xa=Wa;if(Ka)Ya=Xa+(+p[Qa+(za<<3)>>3]-Fa)*+n[Oa+24>>2];else Ya=Xa;if(!La){Ra=Ya;break}Ra=Ya+(+p[Qa+(Aa<<3)>>3]-Fa)*+n[Oa+28>>2]}while(0);Ma=Ma+1|0;if((Ma|0)==8){Za=Ra;break}else{Na=Ra;Oa=Oa+32|0}}}else{Oa=0;Na=Fa;Ma=qa;while(1){Qa=f[o+(Oa<<2)>>2]|0;Pa=Da+((Y(Qa,z)|0)<<3)|0;do if((Qa|0)<0)_a=Na;else{if(Ba)$a=Na+(+p[Pa+(sa<<3)>>3]-Fa)*+n[Ma+4>>2];else $a=Na;if(Ga)ab=$a+(+p[Pa+(ra<<3)>>3]-Fa)*+n[Ma+8>>2];else ab=$a;if(Ha)bb=ab+(+p[Pa+(wa<<3)>>3]-Fa)*+n[Ma+12>>2];else bb=ab;if(Ia)cb=bb+(+p[Pa+(va<<3)>>3]-Fa)*+n[Ma+16>>2];else cb=bb;if(Ja)db=cb+(+p[Pa+(ta<<3)>>3]-Fa)*+n[Ma+20>>2];else db=cb;if(Ka)eb=db+(+p[Pa+(za<<3)>>3]-Fa)*+n[Ma+24>>2];else eb=db;if(!La){_a=eb;break}_a=eb+(+p[Pa+(Aa<<3)>>3]-Fa)*+n[Ma+28>>2]}while(0);Oa=Oa+1|0;if((Oa|0)==8){Za=_a;break}else{Na=_a;Ma=Ma+32|0}}}p[ha+(Ca<<3)>>3]=Za;Ma=Ca+1|0;if((Ma|0)==(x|0))break;Ca=Ma;Da=Da+8|0;Ea=f[m>>2]|0;sa=f[P>>2]|0;ra=f[Q>>2]|0;wa=f[R>>2]|0;va=f[S>>2]|0;ta=f[T>>2]|0;za=f[U>>2]|0;Aa=f[V>>2]|0}ya=ja+(x<<3)+(W<<3)|0}while(0);xa=ya}ia=ia+1|0;if((ia|0)==(D|0)){fb=xa;break}else{ha=ha+(x<<3)|0;ja=xa}}}else fb=da;ca=ca+1|0;if((ca|0)==(E|0))break;else da=fb}u=k;return}function Cna(a,c,e,g,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0;m=u;u=u+544|0;n=m+32|0;o=m+16|0;q=m;r=f[a+40>>2]|0;s=f[r+4>>2]|0;t=f[r>>2]|0;r=f[c+40>>2]|0;v=f[r+4>>2]|0;w=f[r>>2]|0;r=(f[a>>2]|0)>>>3;x=(r&511)+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=MVb(+p[l+((a&3)<<3)>>3])|0;b[n+a>>0]=A>>>0<256?A:(A|0)>0?255:0;a=a+1|0}while((a|0)!=(x|0));a=(k|0)!=5?k:4;l=s+-3|0;A=(l|0)>0?l:0;l=t+-3|0;B=(l|0)>0?l:0;if((f[c>>2]&16384|0)!=0?(f[e>>2]&16384|0)!=0:0){l=(f[g>>2]&16384|0)!=0;C=Y(l?w:1,v)|0;if(l){D=C;E=1}else{F=C;G=6}}else{F=v;G=6}if((G|0)==6)if((w|0)>0){D=F;E=w}else{u=m;return}w=c+16|0;F=c+44|0;c=e+16|0;v=e+44|0;e=g+16|0;C=g+44|0;g=(D|0)>0;l=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(k|0)==5;k=(a|0)==0;K=o+4|0;L=o+8|0;M=o+12|0;N=(r|-512)^511;r=q+4|0;O=q+8|0;P=q+12|0;Q=0;R=y;while(1){y=f[w>>2]|0;S=Y(f[f[F>>2]>>2]|0,Q)|0;T=(f[c>>2]|0)+(Y(f[f[v>>2]>>2]|0,Q)|0)|0;U=(f[e>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;if(g){V=y+S|0;W=0;X=R;while(1){Z=y+(S+(Y(x,W)|0))|0;_=W<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=i+(j[U+(W<<1)>>1]<<4<<1)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=ca+2|0;ea=ca+4|0;fa=ca+6|0;ga=ca+8|0;ha=ca+10|0;ia=ca+12|0;ja=ca+14|0;ka=ca+16|0;la=ca+18|0;ma=ca+20|0;na=ca+22|0;oa=ca+24|0;pa=ca+26|0;qa=ca+28|0;ra=ca+30|0;sa=0;ta=X+(Y(_,z)|0)+(Y(aa,x)|0)|0;while(1){ua=Y(d[ca>>1]|0,h[ta>>0]|0)|0;va=Y(d[da>>1]|0,h[ta+x>>0]|0)|0;wa=Y(d[ea>>1]|0,h[ta+l>>0]|0)|0;xa=Y(d[fa>>1]|0,h[ta+H>>0]|0)|0;ya=ta+z|0;za=Y(d[ga>>1]|0,h[ya>>0]|0)|0;Aa=Y(d[ha>>1]|0,h[ya+x>>0]|0)|0;Ba=Y(d[ia>>1]|0,h[ya+l>>0]|0)|0;Ca=Y(d[ja>>1]|0,h[ya+H>>0]|0)|0;Da=ya+z|0;ya=Y(d[ka>>1]|0,h[Da>>0]|0)|0;Ea=Y(d[la>>1]|0,h[Da+x>>0]|0)|0;Fa=Y(d[ma>>1]|0,h[Da+l>>0]|0)|0;Ga=Y(d[na>>1]|0,h[Da+H>>0]|0)|0;Ha=Da+z|0;Da=Y(d[oa>>1]|0,h[Ha>>0]|0)|0;Ia=Y(d[pa>>1]|0,h[Ha+x>>0]|0)|0;Ja=Y(d[qa>>1]|0,h[Ha+l>>0]|0)|0;Ka=ua+16384+va+wa+xa+za+Aa+Ba+Ca+ya+Ea+Fa+Ga+Da+Ia+Ja+(Y(d[ra>>1]|0,h[Ha+H>>0]|0)|0)>>15;b[V+sa>>0]=Ka>>>0<256?Ka:(Ka|0)>0?255:0;sa=sa+1|0;if((sa|0)==(x|0)){La=X;break}else ta=Ha+I|0}}else{if(J?!($>>>0<s>>>0&ba>>>0<t>>>0):0)Ma=X;else G=17;do if((G|0)==17){G=0;if(k?(ba+3|0)<1|((ba|0)>(t|0)|(($|0)>(s|0)|($+3|0)<1)):0){Vac(Z|0,n|0,x|0)|0;Ma=X;break}ta=Y(ZP(aa,s,a)|0,x)|0;f[o>>2]=ta;sa=ZP(_,t,a)|0;f[q>>2]=sa;sa=Y(ZP($,s,a)|0,x)|0;f[K>>2]=sa;ra=ZP(ba,t,a)|0;f[r>>2]=ra;ra=Y(ZP($+1|0,s,a)|0,x)|0;f[L>>2]=ra;qa=ZP(ba+1|0,t,a)|0;f[O>>2]=qa;qa=Y(ZP($+2|0,s,a)|0,x)|0;f[M>>2]=qa;pa=ZP(ba+2|0,t,a)|0;f[P>>2]=pa;pa=ca+8|0;oa=pa+8|0;na=oa+8|0;ma=na+2|0;la=na+4|0;ka=na+6|0;ja=oa+2|0;ia=oa+4|0;ha=oa+6|0;ga=pa+2|0;fa=pa+4|0;ea=pa+6|0;da=ca+2|0;Ha=ca+4|0;Ka=ca+6|0;Ja=ca+8|0;Ia=Ja+8|0;Da=Ia+8|0;Ga=Da+2|0;Fa=Da+4|0;Ea=Da+6|0;Da=Ia+2|0;ya=Ia+4|0;Ca=Ia+6|0;Ia=Ja+2|0;Ba=Ja+4|0;Aa=Ja+6|0;Ja=ca+2|0;za=ca+4|0;xa=ca+6|0;wa=ca+8|0;va=ca+16|0;ua=ca+24|0;Na=ua+4|0;Oa=ua+6|0;ua=va+4|0;Pa=va+6|0;va=wa+4|0;Qa=wa+6|0;wa=ca+4|0;Ra=ca+6|0;Sa=0;Ta=X;Ua=ta;ta=sa;sa=ra;ra=qa;while(1){qa=h[n+Sa>>0]|0;Va=qa<<15;Wa=(ta|0)>-1;Xa=(sa|0)>-1;Ya=(ra|0)>-1;Za=f[q>>2]|0;_a=Ta+(Y(Za,z)|0)|0;$a=(Za|0)<0;do if((Ua|0)>-1){if(!$a){Za=(Y((h[_a+Ua>>0]|0)-qa|0,d[ca>>1]|0)|0)+Va|0;if(Wa)ab=(Y((h[_a+ta>>0]|0)-qa|0,d[da>>1]|0)|0)+Za|0;else ab=Za;if(Xa)bb=(Y((h[_a+sa>>0]|0)-qa|0,d[Ha>>1]|0)|0)+ab|0;else bb=ab;if(Ya)cb=(Y((h[_a+ra>>0]|0)-qa|0,d[Ka>>1]|0)|0)+bb|0;else cb=bb}else cb=Va;Za=f[r>>2]|0;db=Ta+(Y(Za,z)|0)|0;if((Za|0)>=0){Za=(Y((h[db+Ua>>0]|0)-qa|0,d[pa>>1]|0)|0)+cb|0;if(Wa)eb=(Y((h[db+ta>>0]|0)-qa|0,d[ga>>1]|0)|0)+Za|0;else eb=Za;if(Xa)fb=(Y((h[db+sa>>0]|0)-qa|0,d[fa>>1]|0)|0)+eb|0;else fb=eb;if(Ya)gb=(Y((h[db+ra>>0]|0)-qa|0,d[ea>>1]|0)|0)+fb|0;else gb=fb}else gb=cb;db=f[O>>2]|0;Za=Ta+(Y(db,z)|0)|0;if((db|0)>=0){db=(Y((h[Za+Ua>>0]|0)-qa|0,d[oa>>1]|0)|0)+gb|0;if(Wa)hb=(Y((h[Za+ta>>0]|0)-qa|0,d[ja>>1]|0)|0)+db|0;else hb=db;if(Xa)ib=(Y((h[Za+sa>>0]|0)-qa|0,d[ia>>1]|0)|0)+hb|0;else ib=hb;if(Ya)jb=(Y((h[Za+ra>>0]|0)-qa|0,d[ha>>1]|0)|0)+ib|0;else jb=ib}else jb=gb;Za=f[P>>2]|0;db=Ta+(Y(Za,z)|0)|0;if((Za|0)>=0){Za=(Y((h[db+Ua>>0]|0)-qa|0,d[na>>1]|0)|0)+jb|0;if(Wa)kb=(Y((h[db+ta>>0]|0)-qa|0,d[ma>>1]|0)|0)+Za|0;else kb=Za;if(Xa)lb=(Y((h[db+sa>>0]|0)-qa|0,d[la>>1]|0)|0)+kb|0;else lb=kb;if(Ya)mb=(Y((h[db+ra>>0]|0)-qa|0,d[ka>>1]|0)|0)+lb|0;else mb=lb}else mb=jb}else if(Wa){if(!$a){db=(Y((h[_a+ta>>0]|0)-qa|0,d[Ja>>1]|0)|0)+Va|0;if(Xa)nb=(Y((h[_a+sa>>0]|0)-qa|0,d[za>>1]|0)|0)+db|0;else nb=db;if(Ya)ob=(Y((h[_a+ra>>0]|0)-qa|0,d[xa>>1]|0)|0)+nb|0;else ob=nb}else ob=Va;db=f[r>>2]|0;Za=Ta+(Y(db,z)|0)|0;if((db|0)>=0){db=(Y((h[Za+ta>>0]|0)-qa|0,d[Ia>>1]|0)|0)+ob|0;if(Xa)pb=(Y((h[Za+sa>>0]|0)-qa|0,d[Ba>>1]|0)|0)+db|0;else pb=db;if(Ya)qb=(Y((h[Za+ra>>0]|0)-qa|0,d[Aa>>1]|0)|0)+pb|0;else qb=pb}else qb=ob;Za=f[O>>2]|0;db=Ta+(Y(Za,z)|0)|0;do if((Za|0)<0)rb=qb;else{sb=(Y((h[db+ta>>0]|0)-qa|0,d[Da>>1]|0)|0)+qb|0;if(Xa)tb=(Y((h[db+sa>>0]|0)-qa|0,d[ya>>1]|0)|0)+sb|0;else tb=sb;if(!Ya){rb=tb;break}rb=(Y((h[db+ra>>0]|0)-qa|0,d[Ca>>1]|0)|0)+tb|0}while(0);db=f[P>>2]|0;Za=Ta+(Y(db,z)|0)|0;if((db|0)<0){mb=rb;break}db=(Y((h[Za+ta>>0]|0)-qa|0,d[Ga>>1]|0)|0)+rb|0;if(Xa)ub=(Y((h[Za+sa>>0]|0)-qa|0,d[Fa>>1]|0)|0)+db|0;else ub=db;if(!Ya){mb=ub;break}mb=(Y((h[Za+ra>>0]|0)-qa|0,d[Ea>>1]|0)|0)+ub|0;break}else{if(!$a){if(Xa)vb=(Y((h[_a+sa>>0]|0)-qa|0,d[wa>>1]|0)|0)+Va|0;else vb=Va;if(Ya)wb=(Y((h[_a+ra>>0]|0)-qa|0,d[Ra>>1]|0)|0)+vb|0;else wb=vb}else wb=Va;Za=f[r>>2]|0;db=Ta+(Y(Za,z)|0)|0;if((Za|0)>=0){if(Xa)xb=(Y((h[db+sa>>0]|0)-qa|0,d[va>>1]|0)|0)+wb|0;else xb=wb;if(Ya)yb=(Y((h[db+ra>>0]|0)-qa|0,d[Qa>>1]|0)|0)+xb|0;else yb=xb}else yb=wb;db=f[O>>2]|0;Za=Ta+(Y(db,z)|0)|0;do if((db|0)<0)zb=yb;else{if(Xa)Ab=(Y((h[Za+sa>>0]|0)-qa|0,d[ua>>1]|0)|0)+yb|0;else Ab=yb;if(!Ya){zb=Ab;break}zb=(Y((h[Za+ra>>0]|0)-qa|0,d[Pa>>1]|0)|0)+Ab|0}while(0);Za=f[P>>2]|0;db=Ta+(Y(Za,z)|0)|0;if((Za|0)<0){mb=zb;break}if(Xa)Bb=(Y((h[db+sa>>0]|0)-qa|0,d[Na>>1]|0)|0)+zb|0;else Bb=zb;if(!Ya){mb=Bb;break}mb=(Y((h[db+ra>>0]|0)-qa|0,d[Oa>>1]|0)|0)+Bb|0;break}while(0);qa=mb+16384>>15;b[V+Sa>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;qa=Sa+1|0;if((qa|0)==(x|0))break;Sa=qa;Ta=Ta+1|0;Ua=f[o>>2]|0;ta=f[K>>2]|0;sa=f[L>>2]|0;ra=f[M>>2]|0}Ma=X+x+N|0}while(0);La=Ma}W=W+1|0;if((W|0)==(D|0)){Cb=La;break}else{V=V+x|0;X=La}}}else Cb=R;Q=Q+1|0;if((Q|0)==(E|0))break;else R=Cb}u=m;return}function Dna(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0;k=u;u=u+1056|0;l=k+32|0;m=k+16|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=MVb(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-3|0;A=(i|0)>0?i:0;i=s+-3|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(h|0)==5;h=(a|0)==0;K=m+4|0;L=m+8|0;M=m+12|0;N=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;O=o+8|0;P=o+12|0;Q=0;R=y;while(1){y=f[v>>2]|0;S=Y(f[f[F>>2]>>2]|0,Q)|0;T=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,Q)|0)|0;U=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;if(e){V=y+S|0;W=0;X=R;while(1){Z=y+(S+(Y(q,W)|0))|0;_=W<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=g+(j[U+(W<<1)>>1]<<4<<2)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=X+((Y(_,z)|0)<<1)+((Y(aa,x)|0)<<1)|0;ea=+n[ca>>2];fa=+n[ca+4>>2];ga=+n[ca+8>>2];ha=+n[ca+12>>2];ia=+n[ca+16>>2];ja=+n[ca+20>>2];ka=+n[ca+24>>2];la=+n[ca+28>>2];ma=+n[ca+32>>2];na=+n[ca+36>>2];oa=+n[ca+40>>2];pa=+n[ca+44>>2];qa=+n[ca+48>>2];ra=+n[ca+52>>2];sa=+n[ca+56>>2];ta=+n[ca+60>>2];ua=0;va=da;while(1){da=va+(z<<1)|0;wa=da+(z<<1)|0;xa=wa+(z<<1)|0;ya=LVb(+(j[va>>1]|0)*ea+ +(j[va+(x<<1)>>1]|0)*fa+ +(j[va+(i<<1)>>1]|0)*ga+ +(j[va+(H<<1)>>1]|0)*ha+(+(j[da>>1]|0)*ia+ +(j[da+(x<<1)>>1]|0)*ja+ +(j[da+(i<<1)>>1]|0)*ka+ +(j[da+(H<<1)>>1]|0)*la)+(+(j[wa>>1]|0)*ma+ +(j[wa+(x<<1)>>1]|0)*na+ +(j[wa+(i<<1)>>1]|0)*oa+ +(j[wa+(H<<1)>>1]|0)*pa)+(+(j[xa>>1]|0)*qa+ +(j[xa+(x<<1)>>1]|0)*ra+ +(j[xa+(i<<1)>>1]|0)*sa+ +(j[xa+(H<<1)>>1]|0)*ta))|0;d[V+(ua<<1)>>1]=ya>>>0<65536?ya:(ya|0)>0?65535:0;ua=ua+1|0;if((ua|0)==(x|0)){za=X;break}else va=xa+(I<<1)|0}}else{if(J?!($>>>0<r>>>0&ba>>>0<s>>>0):0)Aa=X;else G=17;do if((G|0)==17){G=0;if(h?(ba+3|0)<1|((ba|0)>(s|0)|(($|0)>(r|0)|($+3|0)<1)):0){Vac(Z|0,l|0,q|0)|0;Aa=X;break}va=Y(ZP(aa,r,a)|0,x)|0;f[m>>2]=va;ua=ZP(_,s,a)|0;f[o>>2]=ua;xa=Y(ZP($,r,a)|0,x)|0;f[K>>2]=xa;ya=ZP(ba,s,a)|0;f[w>>2]=ya;wa=Y(ZP($+1|0,r,a)|0,x)|0;f[L>>2]=wa;da=ZP(ba+1|0,s,a)|0;f[O>>2]=da;Ba=Y(ZP($+2|0,r,a)|0,x)|0;f[M>>2]=Ba;Ca=ZP(ba+2|0,s,a)|0;f[P>>2]=Ca;Da=Y(ua,z)|0;Ea=(ua|0)<0;Fa=ca+16|0;Ga=Y(ya,z)|0;Ha=(ya|0)<0;Ia=Fa+16|0;Ja=Y(da,z)|0;Ka=(da|0)<0;La=Ia+16|0;Ma=Y(Ca,z)|0;Na=(Ca|0)<0;Oa=La+4|0;Pa=La+8|0;Qa=La+12|0;La=Ia+4|0;Ra=Ia+8|0;Sa=Ia+12|0;Ia=Fa+4|0;Ta=Fa+8|0;Ua=Fa+12|0;Fa=ca+4|0;Va=ca+8|0;Wa=ca+12|0;Xa=Y(ua,z)|0;Ya=(ua|0)<0;ua=ca+16|0;Za=Y(ya,z)|0;_a=(ya|0)<0;ya=ca+32|0;$a=Y(da,z)|0;ab=(da|0)<0;da=ca+48|0;bb=Y(Ca,z)|0;cb=(Ca|0)<0;Ca=da+8|0;db=da+12|0;da=ya+8|0;eb=ya+12|0;ya=ua+8|0;fb=ua+12|0;ua=ca+8|0;gb=ca+12|0;hb=0;ib=X;jb=va;va=xa;xa=wa;wa=Ba;while(1){ta=+(j[l+(hb<<1)>>1]|0);Ba=(va|0)>-1;kb=(xa|0)>-1;lb=(wa|0)>-1;do if((jb|0)<=-1)if(Ba){mb=ib+(Da<<1)|0;if(!Ea){sa=ta+ +n[Fa>>2]*(+(j[mb+(va<<1)>>1]|0)-ta);if(kb)nb=sa+ +n[Va>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else nb=sa;if(lb)ob=nb+ +n[Wa>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else ob=nb}else ob=ta;mb=ib+(Ga<<1)|0;if(!Ha){sa=ob+ +n[Ia>>2]*(+(j[mb+(va<<1)>>1]|0)-ta);if(kb)pb=sa+ +n[Ta>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else pb=sa;if(lb)qb=pb+ +n[Ua>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else qb=pb}else qb=ob;mb=ib+(Ja<<1)|0;do if(Ka)rb=qb;else{sa=qb+ +n[La>>2]*(+(j[mb+(va<<1)>>1]|0)-ta);if(kb)sb=sa+ +n[Ra>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else sb=sa;if(!lb){rb=sb;break}rb=sb+ +n[Sa>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=ib+(Ma<<1)|0;if(Na){tb=rb;break}sa=rb+ +n[Oa>>2]*(+(j[mb+(va<<1)>>1]|0)-ta);if(kb)ub=sa+ +n[Pa>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else ub=sa;if(!lb){tb=ub;break}tb=ub+ +n[Qa>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);break}else{mb=ib+(Xa<<1)|0;if(!Ya){if(kb)vb=ta+ +n[ua>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else vb=ta;if(lb)wb=vb+ +n[gb>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else wb=vb}else wb=ta;mb=ib+(Za<<1)|0;if(!_a){if(kb)xb=wb+ +n[ya>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else xb=wb;if(lb)yb=xb+ +n[fb>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);else yb=xb}else yb=wb;mb=ib+($a<<1)|0;do if(ab)zb=yb;else{if(kb)Ab=yb+ +n[da>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else Ab=yb;if(!lb){zb=Ab;break}zb=Ab+ +n[eb>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=ib+(bb<<1)|0;if(cb){tb=zb;break}if(kb)Bb=zb+ +n[Ca>>2]*(+(j[mb+(xa<<1)>>1]|0)-ta);else Bb=zb;if(!lb){tb=Bb;break}tb=Bb+ +n[db>>2]*(+(j[mb+(wa<<1)>>1]|0)-ta);break}else{mb=0;sa=ta;Cb=ca;while(1){Db=f[o+(mb<<2)>>2]|0;Eb=ib+((Y(Db,z)|0)<<1)|0;if((Db|0)>=0){ra=sa+ +n[Cb>>2]*(+(j[Eb+(jb<<1)>>1]|0)-ta);if(Ba)Fb=ra+ +n[Cb+4>>2]*(+(j[Eb+(va<<1)>>1]|0)-ta);else Fb=ra;if(kb)Gb=Fb+ +n[Cb+8>>2]*(+(j[Eb+(xa<<1)>>1]|0)-ta);else Gb=Fb;if(lb)Hb=Gb+ +n[Cb+12>>2]*(+(j[Eb+(wa<<1)>>1]|0)-ta);else Hb=Gb}else Hb=sa;mb=mb+1|0;if((mb|0)==4){tb=Hb;break}else{sa=Hb;Cb=Cb+16|0}}}while(0);lb=LVb(tb)|0;d[V+(hb<<1)>>1]=lb>>>0<65536?lb:(lb|0)>0?65535:0;lb=hb+1|0;if((lb|0)==(x|0))break;hb=lb;ib=ib+2|0;jb=f[m>>2]|0;va=f[K>>2]|0;xa=f[L>>2]|0;wa=f[M>>2]|0}Aa=X+(x<<1)+(N<<1)|0}while(0);za=Aa}W=W+1|0;if((W|0)==(D|0)){Ib=za;break}else{V=V+(x<<1)|0;X=za}}}else Ib=R;Q=Q+1|0;if((Q|0)==(E|0))break;else R=Ib}u=k;return}function Ena(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0;k=u;u=u+1056|0;l=k+32|0;m=k+16|0;o=k;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>1;a=0;do{A=MVb(+p[i+((a&3)<<3)>>3])|0;d[l+(a<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-3|0;A=(i|0)>0?i:0;i=s+-3|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(h|0)==5;h=(a|0)==0;K=m+4|0;L=m+8|0;M=m+12|0;N=(q|-512)^511;q=(w<<1)+2|0;w=o+4|0;O=o+8|0;P=o+12|0;Q=0;R=y;while(1){y=f[v>>2]|0;S=Y(f[f[F>>2]>>2]|0,Q)|0;T=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,Q)|0)|0;U=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;if(e){V=y+S|0;W=0;X=R;while(1){Z=y+(S+(Y(q,W)|0))|0;_=W<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=g+(j[U+(W<<1)>>1]<<4<<2)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=X+((Y(_,z)|0)<<1)+((Y(aa,x)|0)<<1)|0;ea=+n[ca>>2];fa=+n[ca+4>>2];ga=+n[ca+8>>2];ha=+n[ca+12>>2];ia=+n[ca+16>>2];ja=+n[ca+20>>2];ka=+n[ca+24>>2];la=+n[ca+28>>2];ma=+n[ca+32>>2];na=+n[ca+36>>2];oa=+n[ca+40>>2];pa=+n[ca+44>>2];qa=+n[ca+48>>2];ra=+n[ca+52>>2];sa=+n[ca+56>>2];ta=+n[ca+60>>2];ua=0;va=da;while(1){da=va+(z<<1)|0;wa=da+(z<<1)|0;xa=wa+(z<<1)|0;ya=LVb(+(d[va>>1]|0)*ea+ +(d[va+(x<<1)>>1]|0)*fa+ +(d[va+(i<<1)>>1]|0)*ga+ +(d[va+(H<<1)>>1]|0)*ha+(+(d[da>>1]|0)*ia+ +(d[da+(x<<1)>>1]|0)*ja+ +(d[da+(i<<1)>>1]|0)*ka+ +(d[da+(H<<1)>>1]|0)*la)+(+(d[wa>>1]|0)*ma+ +(d[wa+(x<<1)>>1]|0)*na+ +(d[wa+(i<<1)>>1]|0)*oa+ +(d[wa+(H<<1)>>1]|0)*pa)+(+(d[xa>>1]|0)*qa+ +(d[xa+(x<<1)>>1]|0)*ra+ +(d[xa+(i<<1)>>1]|0)*sa+ +(d[xa+(H<<1)>>1]|0)*ta))|0;d[V+(ua<<1)>>1]=(ya+32768|0)>>>0<65536?ya:(ya|0)>0?32767:32768;ua=ua+1|0;if((ua|0)==(x|0)){za=X;break}else va=xa+(I<<1)|0}}else{if(J?!($>>>0<r>>>0&ba>>>0<s>>>0):0)Aa=X;else G=17;do if((G|0)==17){G=0;if(h?(ba+3|0)<1|((ba|0)>(s|0)|(($|0)>(r|0)|($+3|0)<1)):0){Vac(Z|0,l|0,q|0)|0;Aa=X;break}va=Y(ZP(aa,r,a)|0,x)|0;f[m>>2]=va;ua=ZP(_,s,a)|0;f[o>>2]=ua;xa=Y(ZP($,r,a)|0,x)|0;f[K>>2]=xa;ya=ZP(ba,s,a)|0;f[w>>2]=ya;wa=Y(ZP($+1|0,r,a)|0,x)|0;f[L>>2]=wa;da=ZP(ba+1|0,s,a)|0;f[O>>2]=da;Ba=Y(ZP($+2|0,r,a)|0,x)|0;f[M>>2]=Ba;Ca=ZP(ba+2|0,s,a)|0;f[P>>2]=Ca;Da=Y(ua,z)|0;Ea=(ua|0)<0;Fa=ca+16|0;Ga=Y(ya,z)|0;Ha=(ya|0)<0;Ia=Fa+16|0;Ja=Y(da,z)|0;Ka=(da|0)<0;La=Ia+16|0;Ma=Y(Ca,z)|0;Na=(Ca|0)<0;Oa=La+4|0;Pa=La+8|0;Qa=La+12|0;La=Ia+4|0;Ra=Ia+8|0;Sa=Ia+12|0;Ia=Fa+4|0;Ta=Fa+8|0;Ua=Fa+12|0;Fa=ca+4|0;Va=ca+8|0;Wa=ca+12|0;Xa=Y(ua,z)|0;Ya=(ua|0)<0;ua=ca+16|0;Za=Y(ya,z)|0;_a=(ya|0)<0;ya=ca+32|0;$a=Y(da,z)|0;ab=(da|0)<0;da=ca+48|0;bb=Y(Ca,z)|0;cb=(Ca|0)<0;Ca=da+8|0;db=da+12|0;da=ya+8|0;eb=ya+12|0;ya=ua+8|0;fb=ua+12|0;ua=ca+8|0;gb=ca+12|0;hb=0;ib=X;jb=va;va=xa;xa=wa;wa=Ba;while(1){ta=+(d[l+(hb<<1)>>1]|0);Ba=(va|0)>-1;kb=(xa|0)>-1;lb=(wa|0)>-1;do if((jb|0)<=-1)if(Ba){mb=ib+(Da<<1)|0;if(!Ea){sa=ta+ +n[Fa>>2]*(+(d[mb+(va<<1)>>1]|0)-ta);if(kb)nb=sa+ +n[Va>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else nb=sa;if(lb)ob=nb+ +n[Wa>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else ob=nb}else ob=ta;mb=ib+(Ga<<1)|0;if(!Ha){sa=ob+ +n[Ia>>2]*(+(d[mb+(va<<1)>>1]|0)-ta);if(kb)pb=sa+ +n[Ta>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else pb=sa;if(lb)qb=pb+ +n[Ua>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else qb=pb}else qb=ob;mb=ib+(Ja<<1)|0;do if(Ka)rb=qb;else{sa=qb+ +n[La>>2]*(+(d[mb+(va<<1)>>1]|0)-ta);if(kb)sb=sa+ +n[Ra>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else sb=sa;if(!lb){rb=sb;break}rb=sb+ +n[Sa>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=ib+(Ma<<1)|0;if(Na){tb=rb;break}sa=rb+ +n[Oa>>2]*(+(d[mb+(va<<1)>>1]|0)-ta);if(kb)ub=sa+ +n[Pa>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else ub=sa;if(!lb){tb=ub;break}tb=ub+ +n[Qa>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);break}else{mb=ib+(Xa<<1)|0;if(!Ya){if(kb)vb=ta+ +n[ua>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else vb=ta;if(lb)wb=vb+ +n[gb>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else wb=vb}else wb=ta;mb=ib+(Za<<1)|0;if(!_a){if(kb)xb=wb+ +n[ya>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else xb=wb;if(lb)yb=xb+ +n[fb>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);else yb=xb}else yb=wb;mb=ib+($a<<1)|0;do if(ab)zb=yb;else{if(kb)Ab=yb+ +n[da>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else Ab=yb;if(!lb){zb=Ab;break}zb=Ab+ +n[eb>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta)}while(0);mb=ib+(bb<<1)|0;if(cb){tb=zb;break}if(kb)Bb=zb+ +n[Ca>>2]*(+(d[mb+(xa<<1)>>1]|0)-ta);else Bb=zb;if(!lb){tb=Bb;break}tb=Bb+ +n[db>>2]*(+(d[mb+(wa<<1)>>1]|0)-ta);break}else{mb=0;sa=ta;Cb=ca;while(1){Db=f[o+(mb<<2)>>2]|0;Eb=ib+((Y(Db,z)|0)<<1)|0;if((Db|0)>=0){ra=sa+ +n[Cb>>2]*(+(d[Eb+(jb<<1)>>1]|0)-ta);if(Ba)Fb=ra+ +n[Cb+4>>2]*(+(d[Eb+(va<<1)>>1]|0)-ta);else Fb=ra;if(kb)Gb=Fb+ +n[Cb+8>>2]*(+(d[Eb+(xa<<1)>>1]|0)-ta);else Gb=Fb;if(lb)Hb=Gb+ +n[Cb+12>>2]*(+(d[Eb+(wa<<1)>>1]|0)-ta);else Hb=Gb}else Hb=sa;mb=mb+1|0;if((mb|0)==4){tb=Hb;break}else{sa=Hb;Cb=Cb+16|0}}}while(0);lb=LVb(tb)|0;d[V+(hb<<1)>>1]=(lb+32768|0)>>>0<65536?lb:(lb|0)>0?32767:32768;lb=hb+1|0;if((lb|0)==(x|0))break;hb=lb;ib=ib+2|0;jb=f[m>>2]|0;va=f[K>>2]|0;xa=f[L>>2]|0;wa=f[M>>2]|0}Aa=X+(x<<1)+(N<<1)|0}while(0);za=Aa}W=W+1|0;if((W|0)==(D|0)){Ib=za;break}else{V=V+(x<<1)|0;X=za}}}else Ib=R;Q=Q+1|0;if((Q|0)==(E|0))break;else R=Ib}u=k;return}function Fna(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0,pb=0,qb=0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0;k=u;u=u+2064|0;l=k+16|0;m=k;o=f[a+40>>2]|0;q=f[o+4>>2]|0;r=f[o>>2]|0;o=f[b+40>>2]|0;s=f[o+4>>2]|0;t=f[o>>2]|0;o=(f[a>>2]|0)>>>3;v=o&511;w=v+1|0;x=f[a+16>>2]|0;y=(f[a+48>>2]|0)>>>2;a=0;do{n[l+(a<<2)>>2]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(w|0));a=(h|0)!=5?h:4;i=q+-3|0;z=(i|0)>0?i:0;i=r+-3|0;A=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;B=Y(i?t:1,s)|0;if(i){C=B;D=1}else{E=B;F=6}}else{E=s;F=6}if((F|0)==6)if((t|0)>0){C=E;D=t}else{u=k;return}t=b+16|0;E=b+44|0;b=c+16|0;s=c+44|0;c=e+16|0;B=e+44|0;e=(C|0)>0;i=w<<1;G=w*3|0;H=(Y(y,-3)|0)+1|0;I=(h|0)==5;h=(a|0)==0;J=m+4|0;K=m+8|0;L=m+12|0;M=(o|-512)^511;o=(v<<2)+4|0;v=0;N=x;while(1){x=f[t>>2]|0;O=Y(f[f[E>>2]>>2]|0,v)|0;P=(f[b>>2]|0)+(Y(f[f[s>>2]>>2]|0,v)|0)|0;Q=(f[c>>2]|0)+(Y(f[f[B>>2]>>2]|0,v)|0)|0;if(e){R=x+O|0;S=0;T=N;while(1){U=x+(O+(Y(o,S)|0))|0;V=S<<1;W=d[P+(V<<1)>>1]|0;X=W+-1|0;Z=d[P+((V|1)<<1)>>1]|0;V=Z+-1|0;_=g+(j[Q+(S<<1)>>1]<<4<<2)|0;if(X>>>0<z>>>0&V>>>0<A>>>0){$=_+4|0;aa=_+8|0;ba=_+12|0;ca=_+16|0;da=_+20|0;ea=_+24|0;fa=_+28|0;ga=_+32|0;ha=_+36|0;ia=_+40|0;ja=_+44|0;ka=_+48|0;la=_+52|0;ma=_+56|0;na=_+60|0;oa=0;pa=T+((Y(V,y)|0)<<2)+((Y(X,w)|0)<<2)|0;while(1){qa=pa+(y<<2)|0;ra=qa+(y<<2)|0;sa=ra+(y<<2)|0;n[R+(oa<<2)>>2]=+n[pa>>2]*+n[_>>2]+ +n[pa+(w<<2)>>2]*+n[$>>2]+ +n[pa+(i<<2)>>2]*+n[aa>>2]+ +n[pa+(G<<2)>>2]*+n[ba>>2]+(+n[qa>>2]*+n[ca>>2]+ +n[qa+(w<<2)>>2]*+n[da>>2]+ +n[qa+(i<<2)>>2]*+n[ea>>2]+ +n[qa+(G<<2)>>2]*+n[fa>>2])+(+n[ra>>2]*+n[ga>>2]+ +n[ra+(w<<2)>>2]*+n[ha>>2]+ +n[ra+(i<<2)>>2]*+n[ia>>2]+ +n[ra+(G<<2)>>2]*+n[ja>>2])+(+n[sa>>2]*+n[ka>>2]+ +n[sa+(w<<2)>>2]*+n[la>>2]+ +n[sa+(i<<2)>>2]*+n[ma>>2]+ +n[sa+(G<<2)>>2]*+n[na>>2]);oa=oa+1|0;if((oa|0)==(w|0)){ta=T;break}else pa=sa+(H<<2)|0}}else{if(I?!(W>>>0<q>>>0&Z>>>0<r>>>0):0)ua=T;else F=17;do if((F|0)==17){F=0;if(h?(Z+3|0)<1|((Z|0)>(r|0)|((W|0)>(q|0)|(W+3|0)<1)):0){Vac(U|0,l|0,o|0)|0;ua=T;break}pa=Y(ZP(X,q,a)|0,w)|0;f[m>>2]=pa;oa=ZP(V,r,a)|0;na=Y(ZP(W,q,a)|0,w)|0;f[J>>2]=na;ma=ZP(Z,r,a)|0;la=Y(ZP(W+1|0,q,a)|0,w)|0;f[K>>2]=la;ka=ZP(Z+1|0,r,a)|0;ja=Y(ZP(W+2|0,q,a)|0,w)|0;f[L>>2]=ja;ia=ZP(Z+2|0,r,a)|0;ha=Y(oa,y)|0;ga=(oa|0)<0;fa=_+16|0;ea=Y(ma,y)|0;da=(ma|0)<0;ca=fa+16|0;ba=Y(ka,y)|0;aa=(ka|0)<0;$=ca+16|0;sa=Y(ia,y)|0;ra=(ia|0)<0;qa=$+4|0;va=$+8|0;wa=$+12|0;xa=ca+4|0;ya=ca+8|0;za=ca+12|0;Aa=fa+4|0;Ba=fa+8|0;Ca=fa+12|0;Da=_+4|0;Ea=_+8|0;Fa=_+12|0;Ga=Y(oa,y)|0;Ha=(oa|0)<0;Ia=_+16|0;Ja=Y(ma,y)|0;Ka=(ma|0)<0;La=Ia+16|0;Ma=Y(ka,y)|0;Na=(ka|0)<0;Oa=La+16|0;Pa=Y(ia,y)|0;Qa=(ia|0)<0;Ra=Oa+4|0;Sa=Oa+8|0;Ta=Oa+12|0;Oa=La+4|0;Ua=La+8|0;Va=La+12|0;La=Ia+4|0;Wa=Ia+8|0;Xa=Ia+12|0;Ia=_+4|0;Ya=_+8|0;Za=_+12|0;_a=Y(oa,y)|0;$a=(oa|0)<0;oa=_+16|0;ab=Y(ma,y)|0;bb=(ma|0)<0;ma=_+32|0;cb=Y(ka,y)|0;db=(ka|0)<0;ka=_+48|0;eb=Y(ia,y)|0;fb=(ia|0)<0;ia=ka+8|0;gb=ka+12|0;ka=ma+8|0;hb=ma+12|0;ma=oa+8|0;ib=oa+12|0;oa=_+8|0;jb=_+12|0;kb=0;lb=T;mb=pa;pa=na;na=la;la=ja;while(1){nb=+n[l+(kb<<2)>>2];ja=(pa|0)>-1;ob=(na|0)>-1;pb=(la|0)>-1;do if((mb|0)>-1){qb=lb+(ha<<2)|0;if(!ga){rb=nb+(+n[qb+(mb<<2)>>2]-nb)*+n[_>>2];if(ja)sb=rb+(+n[qb+(pa<<2)>>2]-nb)*+n[Da>>2];else sb=rb;if(ob)tb=sb+(+n[qb+(na<<2)>>2]-nb)*+n[Ea>>2];else tb=sb;if(pb)ub=tb+(+n[qb+(la<<2)>>2]-nb)*+n[Fa>>2];else ub=tb}else ub=nb;qb=lb+(ea<<2)|0;if(!da){rb=ub+(+n[qb+(mb<<2)>>2]-nb)*+n[fa>>2];if(ja)vb=rb+(+n[qb+(pa<<2)>>2]-nb)*+n[Aa>>2];else vb=rb;if(ob)wb=vb+(+n[qb+(na<<2)>>2]-nb)*+n[Ba>>2];else wb=vb;if(pb)xb=wb+(+n[qb+(la<<2)>>2]-nb)*+n[Ca>>2];else xb=wb}else xb=ub;qb=lb+(ba<<2)|0;if(!aa){rb=xb+(+n[qb+(mb<<2)>>2]-nb)*+n[ca>>2];if(ja)yb=rb+(+n[qb+(pa<<2)>>2]-nb)*+n[xa>>2];else yb=rb;if(ob)zb=yb+(+n[qb+(na<<2)>>2]-nb)*+n[ya>>2];else zb=yb;if(pb)Ab=zb+(+n[qb+(la<<2)>>2]-nb)*+n[za>>2];else Ab=zb}else Ab=xb;qb=lb+(sa<<2)|0;if(!ra){rb=Ab+(+n[qb+(mb<<2)>>2]-nb)*+n[$>>2];if(ja)Bb=rb+(+n[qb+(pa<<2)>>2]-nb)*+n[qa>>2];else Bb=rb;if(ob)Cb=Bb+(+n[qb+(na<<2)>>2]-nb)*+n[va>>2];else Cb=Bb;if(pb)Db=Cb+(+n[qb+(la<<2)>>2]-nb)*+n[wa>>2];else Db=Cb}else Db=Ab}else if(ja){qb=lb+(Ga<<2)|0;if(!Ha){rb=nb+(+n[qb+(pa<<2)>>2]-nb)*+n[Ia>>2];if(ob)Eb=rb+(+n[qb+(na<<2)>>2]-nb)*+n[Ya>>2];else Eb=rb;if(pb)Fb=Eb+(+n[qb+(la<<2)>>2]-nb)*+n[Za>>2];else Fb=Eb}else Fb=nb;qb=lb+(Ja<<2)|0;if(!Ka){rb=Fb+(+n[qb+(pa<<2)>>2]-nb)*+n[La>>2];if(ob)Gb=rb+(+n[qb+(na<<2)>>2]-nb)*+n[Wa>>2];else Gb=rb;if(pb)Hb=Gb+(+n[qb+(la<<2)>>2]-nb)*+n[Xa>>2];else Hb=Gb}else Hb=Fb;qb=lb+(Ma<<2)|0;do if(Na)Ib=Hb;else{rb=Hb+(+n[qb+(pa<<2)>>2]-nb)*+n[Oa>>2];if(ob)Jb=rb+(+n[qb+(na<<2)>>2]-nb)*+n[Ua>>2];else Jb=rb;if(!pb){Ib=Jb;break}Ib=Jb+(+n[qb+(la<<2)>>2]-nb)*+n[Va>>2]}while(0);qb=lb+(Pa<<2)|0;if(Qa){Db=Ib;break}rb=Ib+(+n[qb+(pa<<2)>>2]-nb)*+n[Ra>>2];if(ob)Kb=rb+(+n[qb+(na<<2)>>2]-nb)*+n[Sa>>2];else Kb=rb;if(!pb){Db=Kb;break}Db=Kb+(+n[qb+(la<<2)>>2]-nb)*+n[Ta>>2];break}else{qb=lb+(_a<<2)|0;if(!$a){if(ob)Lb=nb+(+n[qb+(na<<2)>>2]-nb)*+n[oa>>2];else Lb=nb;if(pb)Mb=Lb+(+n[qb+(la<<2)>>2]-nb)*+n[jb>>2];else Mb=Lb}else Mb=nb;qb=lb+(ab<<2)|0;if(!bb){if(ob)Nb=Mb+(+n[qb+(na<<2)>>2]-nb)*+n[ma>>2];else Nb=Mb;if(pb)Ob=Nb+(+n[qb+(la<<2)>>2]-nb)*+n[ib>>2];else Ob=Nb}else Ob=Mb;qb=lb+(cb<<2)|0;do if(db)Pb=Ob;else{if(ob)Qb=Ob+(+n[qb+(na<<2)>>2]-nb)*+n[ka>>2];else Qb=Ob;if(!pb){Pb=Qb;break}Pb=Qb+(+n[qb+(la<<2)>>2]-nb)*+n[hb>>2]}while(0);qb=lb+(eb<<2)|0;if(fb){Db=Pb;break}if(ob)Rb=Pb+(+n[qb+(na<<2)>>2]-nb)*+n[ia>>2];else Rb=Pb;if(!pb){Db=Rb;break}Db=Rb+(+n[qb+(la<<2)>>2]-nb)*+n[gb>>2];break}while(0);n[R+(kb<<2)>>2]=Db;pb=kb+1|0;if((pb|0)==(w|0))break;kb=pb;lb=lb+4|0;mb=f[m>>2]|0;pa=f[J>>2]|0;na=f[K>>2]|0;la=f[L>>2]|0}ua=T+(w<<2)+(M<<2)|0}while(0);ta=ua}S=S+1|0;if((S|0)==(C|0)){Sb=ta;break}else{R=R+(w<<2)|0;T=ta}}}else Sb=N;v=v+1|0;if((v|0)==(D|0))break;else N=Sb}u=k;return}function Gna(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0;k=u;u=u+4128|0;l=k;m=k+4112|0;o=k+4096|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[b+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=(f[a+48>>2]|0)>>>3;a=0;do{p[l+(a<<3)>>3]=+p[i+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=(h|0)!=5?h:4;i=r+-3|0;A=(i|0)>0?i:0;i=s+-3|0;B=(i|0)>0?i:0;if((f[b>>2]&16384|0)!=0?(f[c>>2]&16384|0)!=0:0){i=(f[e>>2]&16384|0)!=0;C=Y(i?v:1,t)|0;if(i){D=C;E=1}else{F=C;G=6}}else{F=t;G=6}if((G|0)==6)if((v|0)>0){D=F;E=v}else{u=k;return}v=b+16|0;F=b+44|0;b=c+16|0;t=c+44|0;c=e+16|0;C=e+44|0;e=(D|0)>0;i=x<<1;H=x*3|0;I=(Y(z,-3)|0)+1|0;J=(h|0)==5;h=(a|0)==0;K=m+4|0;L=m+8|0;M=m+12|0;N=(q|-512)^511;q=(w<<3)+8|0;w=o+4|0;O=o+8|0;P=o+12|0;Q=0;R=y;while(1){y=f[v>>2]|0;S=Y(f[f[F>>2]>>2]|0,Q)|0;T=(f[b>>2]|0)+(Y(f[f[t>>2]>>2]|0,Q)|0)|0;U=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;if(e){V=y+S|0;W=0;X=R;while(1){Z=y+(S+(Y(q,W)|0))|0;_=W<<1;$=d[T+(_<<1)>>1]|0;aa=$+-1|0;ba=d[T+((_|1)<<1)>>1]|0;_=ba+-1|0;ca=g+(j[U+(W<<1)>>1]<<4<<2)|0;if(aa>>>0<A>>>0&_>>>0<B>>>0){da=X+((Y(_,z)|0)<<3)+((Y(aa,x)|0)<<3)|0;ea=+n[ca>>2];fa=+n[ca+4>>2];ga=+n[ca+8>>2];ha=+n[ca+12>>2];ia=+n[ca+16>>2];ja=+n[ca+20>>2];ka=+n[ca+24>>2];la=+n[ca+28>>2];ma=+n[ca+32>>2];na=+n[ca+36>>2];oa=+n[ca+40>>2];pa=+n[ca+44>>2];qa=+n[ca+48>>2];ra=+n[ca+52>>2];sa=+n[ca+56>>2];ta=+n[ca+60>>2];ua=0;va=da;while(1){da=va+(z<<3)|0;wa=da+(z<<3)|0;xa=wa+(z<<3)|0;p[V+(ua<<3)>>3]=+p[va>>3]*ea+ +p[va+(x<<3)>>3]*fa+ +p[va+(i<<3)>>3]*ga+ +p[va+(H<<3)>>3]*ha+(+p[da>>3]*ia+ +p[da+(x<<3)>>3]*ja+ +p[da+(i<<3)>>3]*ka+ +p[da+(H<<3)>>3]*la)+(+p[wa>>3]*ma+ +p[wa+(x<<3)>>3]*na+ +p[wa+(i<<3)>>3]*oa+ +p[wa+(H<<3)>>3]*pa)+(+p[xa>>3]*qa+ +p[xa+(x<<3)>>3]*ra+ +p[xa+(i<<3)>>3]*sa+ +p[xa+(H<<3)>>3]*ta);ua=ua+1|0;if((ua|0)==(x|0)){ya=X;break}else va=xa+(I<<3)|0}}else{if(J?!($>>>0<r>>>0&ba>>>0<s>>>0):0)za=X;else G=17;do if((G|0)==17){G=0;if(h?(ba+3|0)<1|((ba|0)>(s|0)|(($|0)>(r|0)|($+3|0)<1)):0){Vac(Z|0,l|0,q|0)|0;za=X;break}va=Y(ZP(aa,r,a)|0,x)|0;f[m>>2]=va;ua=ZP(_,s,a)|0;f[o>>2]=ua;xa=Y(ZP($,r,a)|0,x)|0;f[K>>2]=xa;wa=ZP(ba,s,a)|0;f[w>>2]=wa;da=Y(ZP($+1|0,r,a)|0,x)|0;f[L>>2]=da;Aa=ZP(ba+1|0,s,a)|0;f[O>>2]=Aa;Ba=Y(ZP($+2|0,r,a)|0,x)|0;f[M>>2]=Ba;Ca=ZP(ba+2|0,s,a)|0;f[P>>2]=Ca;Da=Y(ua,z)|0;Ea=(ua|0)<0;Fa=ca+16|0;Ga=Y(wa,z)|0;Ha=(wa|0)<0;Ia=Fa+16|0;Ja=Y(Aa,z)|0;Ka=(Aa|0)<0;La=Ia+16|0;Ma=Y(Ca,z)|0;Na=(Ca|0)<0;Oa=La+4|0;Pa=La+8|0;Qa=La+12|0;La=Ia+4|0;Ra=Ia+8|0;Sa=Ia+12|0;Ia=Fa+4|0;Ta=Fa+8|0;Ua=Fa+12|0;Fa=ca+4|0;Va=ca+8|0;Wa=ca+12|0;Xa=Y(ua,z)|0;Ya=(ua|0)<0;ua=ca+16|0;Za=Y(wa,z)|0;_a=(wa|0)<0;wa=ca+32|0;$a=Y(Aa,z)|0;ab=(Aa|0)<0;Aa=ca+48|0;bb=Y(Ca,z)|0;cb=(Ca|0)<0;Ca=Aa+8|0;db=Aa+12|0;Aa=wa+8|0;eb=wa+12|0;wa=ua+8|0;fb=ua+12|0;ua=ca+8|0;gb=ca+12|0;hb=0;ib=X;jb=va;va=xa;xa=da;da=Ba;while(1){ta=+p[l+(hb<<3)>>3];Ba=(va|0)>-1;kb=(xa|0)>-1;lb=(da|0)>-1;do if((jb|0)<=-1)if(Ba){mb=ib+(Da<<3)|0;if(!Ea){sa=ta+(+p[mb+(va<<3)>>3]-ta)*+n[Fa>>2];if(kb)nb=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Va>>2];else nb=sa;if(lb)ob=nb+(+p[mb+(da<<3)>>3]-ta)*+n[Wa>>2];else ob=nb}else ob=ta;mb=ib+(Ga<<3)|0;if(!Ha){sa=ob+(+p[mb+(va<<3)>>3]-ta)*+n[Ia>>2];if(kb)pb=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Ta>>2];else pb=sa;if(lb)qb=pb+(+p[mb+(da<<3)>>3]-ta)*+n[Ua>>2];else qb=pb}else qb=ob;mb=ib+(Ja<<3)|0;do if(Ka)rb=qb;else{sa=qb+(+p[mb+(va<<3)>>3]-ta)*+n[La>>2];if(kb)sb=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Ra>>2];else sb=sa;if(!lb){rb=sb;break}rb=sb+(+p[mb+(da<<3)>>3]-ta)*+n[Sa>>2]}while(0);mb=ib+(Ma<<3)|0;if(Na){tb=rb;break}sa=rb+(+p[mb+(va<<3)>>3]-ta)*+n[Oa>>2];if(kb)ub=sa+(+p[mb+(xa<<3)>>3]-ta)*+n[Pa>>2];else ub=sa;if(!lb){tb=ub;break}tb=ub+(+p[mb+(da<<3)>>3]-ta)*+n[Qa>>2];break}else{mb=ib+(Xa<<3)|0;if(!Ya){if(kb)vb=ta+(+p[mb+(xa<<3)>>3]-ta)*+n[ua>>2];else vb=ta;if(lb)wb=vb+(+p[mb+(da<<3)>>3]-ta)*+n[gb>>2];else wb=vb}else wb=ta;mb=ib+(Za<<3)|0;if(!_a){if(kb)xb=wb+(+p[mb+(xa<<3)>>3]-ta)*+n[wa>>2];else xb=wb;if(lb)yb=xb+(+p[mb+(da<<3)>>3]-ta)*+n[fb>>2];else yb=xb}else yb=wb;mb=ib+($a<<3)|0;do if(ab)zb=yb;else{if(kb)Ab=yb+(+p[mb+(xa<<3)>>3]-ta)*+n[Aa>>2];else Ab=yb;if(!lb){zb=Ab;break}zb=Ab+(+p[mb+(da<<3)>>3]-ta)*+n[eb>>2]}while(0);mb=ib+(bb<<3)|0;if(cb){tb=zb;break}if(kb)Bb=zb+(+p[mb+(xa<<3)>>3]-ta)*+n[Ca>>2];else Bb=zb;if(!lb){tb=Bb;break}tb=Bb+(+p[mb+(da<<3)>>3]-ta)*+n[db>>2];break}else{mb=0;sa=ta;Cb=ca;while(1){Db=f[o+(mb<<2)>>2]|0;Eb=ib+((Y(Db,z)|0)<<3)|0;if((Db|0)>=0){ra=sa+(+p[Eb+(jb<<3)>>3]-ta)*+n[Cb>>2];if(Ba)Fb=ra+(+p[Eb+(va<<3)>>3]-ta)*+n[Cb+4>>2];else Fb=ra;if(kb)Gb=Fb+(+p[Eb+(xa<<3)>>3]-ta)*+n[Cb+8>>2];else Gb=Fb;if(lb)Hb=Gb+(+p[Eb+(da<<3)>>3]-ta)*+n[Cb+12>>2];else Hb=Gb}else Hb=sa;mb=mb+1|0;if((mb|0)==4){tb=Hb;break}else{sa=Hb;Cb=Cb+16|0}}}while(0);p[V+(hb<<3)>>3]=tb;lb=hb+1|0;if((lb|0)==(x|0))break;hb=lb;ib=ib+8|0;jb=f[m>>2]|0;va=f[K>>2]|0;xa=f[L>>2]|0;da=f[M>>2]|0}za=X+(x<<3)+(N<<3)|0}while(0);ya=za}W=W+1|0;if((W|0)==(D|0)){Ib=ya;break}else{V=V+(x<<3)|0;X=ya}}}else Ib=R;Q=Q+1|0;if((Q|0)==(E|0))break;else R=Ib}u=k;return}function Hna(a,c,e,g,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0;m=u;u=u+528|0;n=m+8|0;o=m;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=MVb(+p[l+((a&3)<<3)>>3])|0;b[n+a>>0]=A>>>0<256?A:(A|0)>0?255:0;a=a+1|0}while((a|0)!=(x|0));a=r+-1|0;l=(a|0)>0?a:0;A=s+-1|0;B=(A|0)>0?A:0;if((Y(s,r)|0)<=0){f[o>>2]=0;f[o+4>>2]=0;C=aD(o,16)|0;D=270408;E=C+16|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,o,270425,269810,662);bD(o)}if((v|0)<=0){u=m;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(k|0)==5;G=F&(x|0)!=3;H=(w|0)==0;w=(k|0)==0;I=(k|0)==1;J=q&65535;q=z+1|0;K=z+2|0;L=z+3|0;M=z+4|0;N=z+5|0;O=z+6|0;P=z+7|0;Q=0;do{R=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,Q)|0)|0;S=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,Q)|0)|0;if(!g){T=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,Q)|0)|0;U=0;V=0;W=0;while(1){do if((W|0)<(t|0)){X=W<<1;if((d[R+(X<<1)>>1]|0)>>>0>=l>>>0)if(V){Z=18;break}else{_=T;$=W;aa=U;ba=0;break}else{ca=(d[R+((X|1)<<1)>>1]|0)>>>0<B>>>0;Z=16;break}}else{ca=V^1;Z=16}while(0);do if((Z|0)==16){Z=0;if(V^ca)if(ca){if(G){_=T+(Y(W-U|0,x)|0)|0;$=W;aa=W;ba=1;break}X=(W|0)>(U|0);if(H){if(!X){_=T;$=U;aa=W;ba=1;break}da=W-U|0;ea=U;fa=T;while(1){ga=ea<<1;ha=d[R+(ga<<1)>>1]|0;ia=ha<<16>>16;ja=d[R+((ga|1)<<1)>>1]|0;ga=ja<<16>>16;do if(w)if(ja<<16>>16<-1|ha<<16>>16>-2&(ia|0)<(r|0)&(ga|0)<(s|0)^1){ka=b[n>>0]|0;break}else{la=i+(j[S+(ea<<1)>>1]<<2<<1)|0;Z=49;break}else{ma=i+(j[S+(ea<<1)>>1]<<2<<1)|0;if(I){na=ha<<16>>16>-1?((ia|0)<(r|0)?ia:a):0;oa=ia+1|0;pa=ha<<16>>16>-2?((oa|0)<(r|0)?oa:a):0;oa=ga+1|0;qa=Y(ja<<16>>16>-1?((ga|0)<(s|0)?ga:A):0,z)|0;ra=Y(ja<<16>>16>-2?((oa|0)<(s|0)?oa:A):0,z)|0;sa=y+(ra+pa)|0;ta=y+(ra+na)|0;ua=y+(qa+pa)|0;va=y+(qa+na)|0;wa=ma;Z=50}else{la=ma;Z=49}}while(0);if((Z|0)==49){Z=0;ja=ZP(ia,r,k)|0;ha=ZP(ia+1|0,r,k)|0;ma=ZP(ga,s,k)|0;na=ZP(ga+1|0,s,k)|0;qa=Y(ma,z)|0;pa=Y(na,z)|0;sa=(na|ha|0)>-1?y+(pa+ha)|0:n;ta=(na|ja|0)>-1?y+(pa+ja)|0:n;ua=(ma|ha|0)>-1?y+(qa+ha)|0:n;va=(ma|ja|0)>-1?y+(qa+ja)|0:n;wa=la;Z=50}if((Z|0)==50){Z=0;ja=Y(d[wa>>1]|0,h[va>>0]|0)|0;qa=Y(d[wa+2>>1]|0,h[ua>>0]|0)|0;ma=Y(d[wa+4>>1]|0,h[ta>>0]|0)|0;ha=ja+16384+qa+ma+(Y(d[wa+6>>1]|0,h[sa>>0]|0)|0)>>15;ka=(ha>>>0<256?ha:(ha|0)>0?255:0)&255}b[fa>>0]=ka;ea=ea+1|0;if((ea|0)==(W|0))break;else fa=fa+1|0}_=T+da|0;$=W;aa=W;ba=1;break}if(X){fa=Y(x,W+-1-U|0)|0;ea=U;ha=T;while(1){ma=ea<<1;qa=d[R+(ma<<1)>>1]|0;ja=qa<<16>>16;pa=d[R+((ma|1)<<1)>>1]|0;ma=pa<<16>>16;do if(w)if(pa<<16>>16<-1|qa<<16>>16>-2&(ja|0)<(r|0)&(ma|0)<(s|0)^1){na=0;do{b[ha+na>>0]=b[n+na>>0]|0;na=na+1|0}while((na|0)!=(x|0))}else{xa=i+(j[S+(ea<<1)>>1]<<2<<1)|0;Z=58;break}else{na=i+(j[S+(ea<<1)>>1]<<2<<1)|0;if(I){ra=ja+1|0;oa=ma+1|0;ya=y+(Y(pa<<16>>16>-1?((ma|0)<(s|0)?ma:A):0,z)|0)|0;za=Y(qa<<16>>16>-1?((ja|0)<(r|0)?ja:a):0,x)|0;Aa=Y(qa<<16>>16>-2?((ra|0)<(r|0)?ra:a):0,x)|0;ra=y+(Y(pa<<16>>16>-2?((oa|0)<(s|0)?oa:A):0,z)|0)|0;Ba=ra+Aa|0;Ca=ra+za|0;Da=ya+Aa|0;Ea=ya+za|0;Fa=na;Z=61}else{xa=na;Z=58}}while(0);do if((Z|0)==58){Z=0;if(F?!(ja>>>0<a>>>0&ma>>>0<A>>>0):0)break;pa=ZP(ja,r,k)|0;qa=ZP(ja+1|0,r,k)|0;ga=ZP(ma,s,k)|0;ia=ZP(ma+1|0,s,k)|0;na=y+(Y(ga,z)|0)|0;za=Y(pa,x)|0;ya=Y(qa,x)|0;Aa=y+(Y(ia,z)|0)|0;Ba=(ia|qa|0)>-1?Aa+ya|0:n;Ca=(ia|pa|0)>-1?Aa+za|0:n;Da=(ga|qa|0)>-1?na+ya|0:n;Ea=(ga|pa|0)>-1?na+za|0:n;Fa=xa;Z=61}while(0);if((Z|0)==61){Z=0;ma=Fa+2|0;ja=Fa+4|0;za=Fa+6|0;na=0;do{pa=Y(d[Fa>>1]|0,h[Ea+na>>0]|0)|0;ga=Y(d[ma>>1]|0,h[Da+na>>0]|0)|0;ya=Y(d[ja>>1]|0,h[Ca+na>>0]|0)|0;qa=pa+16384+ga+ya+(Y(d[za>>1]|0,h[Ba+na>>0]|0)|0)>>15;b[ha+na>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;na=na+1|0}while((na|0)!=(x|0))}ea=ea+1|0;if((ea|0)==(W|0))break;else ha=ha+x|0}_=T+x+fa|0;$=W;aa=W;ba=1}else{_=T;$=U;aa=W;ba=1}}else Z=18;else{_=T;$=W;aa=U;ba=V}}while(0);a:do if((Z|0)==18){Z=0;switch(J&511){case 0:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}ha=W-U|0;ea=T;X=U;while(1){da=X<<1;na=i+(j[S+(X<<1)>>1]<<2<<1)|0;za=y+(Y(d[R+((da|1)<<1)>>1]|0,z)|0)+(d[R+(da<<1)>>1]|0)|0;da=Y(d[na>>1]|0,h[za>>0]|0)|0;ja=Y(d[na+2>>1]|0,h[za+1>>0]|0)|0;ma=Y(d[na+4>>1]|0,h[za+z>>0]|0)|0;qa=da+16384+ja+ma+(Y(d[na+6>>1]|0,h[za+q>>0]|0)|0)>>15;b[ea>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;X=X+1|0;if((X|0)==(W|0))break;else ea=ea+1|0}_=T+ha|0;$=W;aa=W;ba=0;break a;break}case 1:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}ea=W-U<<1;X=T;fa=U;while(1){qa=fa<<1;za=i+(j[S+(fa<<1)>>1]<<2<<1)|0;na=y+(Y(d[R+((qa|1)<<1)>>1]|0,z)|0)+(d[R+(qa<<1)>>1]<<1)|0;qa=d[za>>1]|0;ma=Y(qa,h[na>>0]|0)|0;ja=d[za+2>>1]|0;da=Y(ja,h[na+2>>0]|0)|0;ya=d[za+4>>1]|0;ga=Y(ya,h[na+z>>0]|0)|0;pa=d[za+6>>1]|0;za=Y(pa,h[na+K>>0]|0)|0;Aa=Y(h[na+1>>0]|0,qa)|0;qa=Y(h[na+3>>0]|0,ja)|0;ja=Y(h[na+q>>0]|0,ya)|0;ya=Y(h[na+L>>0]|0,pa)|0;pa=ma+16384+da+ga+za>>15;b[X>>0]=pa>>>0<256?pa:(pa|0)>0?255:0;pa=Aa+16384+qa+ja+ya>>15;b[X+1>>0]=pa>>>0<256?pa:(pa|0)>0?255:0;fa=fa+1|0;if((fa|0)==(W|0))break;else X=X+2|0}_=T+ea|0;$=W;aa=W;ba=0;break a;break}case 2:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}X=(W-U|0)*3|0;fa=T;ha=U;while(1){pa=ha<<1;ya=i+(j[S+(ha<<1)>>1]<<2<<1)|0;ja=y+(Y(d[R+((pa|1)<<1)>>1]|0,z)|0)+((d[R+(pa<<1)>>1]|0)*3|0)|0;pa=d[ya>>1]|0;qa=Y(pa,h[ja>>0]|0)|0;Aa=d[ya+2>>1]|0;za=Y(Aa,h[ja+3>>0]|0)|0;ga=d[ya+4>>1]|0;da=Y(ga,h[ja+z>>0]|0)|0;ma=d[ya+6>>1]|0;ya=Y(ma,h[ja+L>>0]|0)|0;na=Y(h[ja+1>>0]|0,pa)|0;ia=Y(h[ja+4>>0]|0,Aa)|0;ra=Y(h[ja+q>>0]|0,ga)|0;oa=Y(h[ja+M>>0]|0,ma)|0;Ga=Y(h[ja+2>>0]|0,pa)|0;pa=Y(h[ja+5>>0]|0,Aa)|0;Aa=Y(h[ja+K>>0]|0,ga)|0;ga=Y(h[ja+N>>0]|0,ma)|0;ma=qa+16384+za+da+ya>>15;b[fa>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ma=na+16384+ia+ra+oa>>15;b[fa+1>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ma=Ga+16384+pa+Aa+ga>>15;b[fa+2>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ha=ha+1|0;if((ha|0)==(W|0))break;else fa=fa+3|0}_=T+X|0;$=W;aa=W;ba=0;break a;break}case 3:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}fa=W-U<<2;ha=U;ea=T;while(1){ma=ha<<1;ga=i+(j[S+(ha<<1)>>1]<<2<<1)|0;Aa=y+(Y(d[R+((ma|1)<<1)>>1]|0,z)|0)+(d[R+(ma<<1)>>1]<<2)|0;ma=d[ga>>1]|0;pa=Y(ma,h[Aa>>0]|0)|0;Ga=ga+2|0;oa=d[Ga>>1]|0;ra=Y(oa,h[Aa+4>>0]|0)|0;ia=ga+4|0;na=d[ia>>1]|0;ya=Y(na,h[Aa+z>>0]|0)|0;da=ga+6|0;za=d[da>>1]|0;qa=Y(za,h[Aa+M>>0]|0)|0;ja=Y(h[Aa+1>>0]|0,ma)|0;ma=Y(h[Aa+5>>0]|0,oa)|0;oa=Y(h[Aa+q>>0]|0,na)|0;na=Y(h[Aa+N>>0]|0,za)|0;za=pa+16384+ra+ya+qa>>15;b[ea>>0]=za>>>0<256?za:(za|0)>0?255:0;za=ja+16384+ma+oa+na>>15;b[ea+1>>0]=za>>>0<256?za:(za|0)>0?255:0;za=d[ga>>1]|0;ga=Y(za,h[Aa+2>>0]|0)|0;na=d[Ga>>1]|0;Ga=Y(na,h[Aa+6>>0]|0)|0;oa=d[ia>>1]|0;ia=Y(oa,h[Aa+K>>0]|0)|0;ma=d[da>>1]|0;da=Y(ma,h[Aa+O>>0]|0)|0;ja=Y(h[Aa+3>>0]|0,za)|0;za=Y(h[Aa+7>>0]|0,na)|0;na=Y(h[Aa+L>>0]|0,oa)|0;oa=Y(h[Aa+P>>0]|0,ma)|0;ma=ga+16384+Ga+ia+da>>15;b[ea+2>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ma=ja+16384+za+na+oa>>15;b[ea+3>>0]=ma>>>0<256?ma:(ma|0)>0?255:0;ha=ha+1|0;if((ha|0)==(W|0))break;else ea=ea+4|0}_=T+fa|0;$=W;aa=W;ba=0;break a;break}default:{if((W|0)<=(U|0)){_=T;$=U;aa=W;ba=0;break a}ea=Y(x,W+-1-U|0)|0;ha=U;X=T;while(1){ma=ha<<1;oa=i+(j[S+(ha<<1)>>1]<<2<<1)|0;na=y+(Y(d[R+((ma|1)<<1)>>1]|0,z)|0)+(Y(d[R+(ma<<1)>>1]|0,x)|0)|0;ma=oa+2|0;za=oa+4|0;ja=oa+6|0;da=0;do{ia=Y(d[oa>>1]|0,h[na+da>>0]|0)|0;Ga=Y(d[ma>>1]|0,h[na+(da+x)>>0]|0)|0;ga=da+z|0;Aa=Y(d[za>>1]|0,h[na+ga>>0]|0)|0;qa=ia+16384+Ga+Aa+(Y(d[ja>>1]|0,h[na+(ga+x)>>0]|0)|0)>>15;b[X+da>>0]=qa>>>0<256?qa:(qa|0)>0?255:0;da=da+1|0}while((da|0)!=(x|0));ha=ha+1|0;if((ha|0)==(W|0))break;else X=X+x|0}_=T+x+ea|0;$=W;aa=W;ba=0;break a}}}while(0);if(($|0)<(t|0)){T=_;U=aa;V=ba;W=$+1|0}else break}}Q=Q+1|0}while((Q|0)!=(v|0));u=m;return}function Ina(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+1040|0;m=l+8|0;o=l;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=MVb(+p[k+((a&3)<<3)>>3])|0;d[m+(a<<1)>>1]=A>>>0<65536?A:(A|0)>0?65535:0;a=a+1|0}while((a|0)!=(x|0));a=z>>>1;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((Y(s,r)|0)<=0){f[o>>2]=0;f[o+4>>2]=0;C=aD(o,16)|0;D=270408;E=C+16|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,o,270425,269810,662);bD(o)}if((v|0)<=0){u=l;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<1)+2|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((X|0)<(t|0)){Z=X<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(W){_=18;break}else{$=U;aa=X;ba=V;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=W^1;_=16}while(0);do if((_|0)==16){_=0;if(W^da)if(da){if(G){$=U+((Y(X-V|0,x)|0)<<1)|0;aa=X;ba=X;ca=1;break}Z=(X|0)>(V|0);if(H){if(!Z){$=U;aa=V;ba=X;ca=1;break}ea=X-V|0;fa=V;ga=U;while(1){ha=fa<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=d[m>>1]|0;break}else{ma=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=y+(sa+qa<<1)|0;ua=d[y+(sa+oa<<1)>>1]|0;va=d[y+(ra+qa<<1)>>1]|0;wa=d[y+(ra+oa<<1)>>1]|0;xa=na;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=ZP(ja,r,i)|0;ia=ZP(ja+1|0,r,i)|0;na=ZP(ha,s,i)|0;oa=ZP(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<1)|0;else ya=m;ra=d[ya>>1]|0;if((na|ia|0)>-1)za=y+((Y(na,a)|0)+ia<<1)|0;else za=m;na=d[za>>1]|0;if((oa|ka|0)>-1)Aa=y+((Y(oa,a)|0)+ka<<1)|0;else Aa=m;ka=d[Aa>>1]|0;if((oa|ia|0)<=-1){ta=m;ua=ka;va=na;wa=ra;xa=ma;_=57;break}ta=y+((Y(oa,a)|0)+ia<<1)|0;ua=ka;va=na;wa=ra;xa=ma;_=57}while(0);if((_|0)==57){_=0;ha=LVb(+(wa&65535)*+n[xa>>2]+ +(va&65535)*+n[xa+4>>2]+ +(ua&65535)*+n[xa+8>>2]+ +(j[ta>>1]|0)*+n[xa+12>>2])|0;la=(ha>>>0<65536?ha:(ha|0)>0?65535:0)&65535}d[ga>>1]=la;fa=fa+1|0;if((fa|0)==(X|0))break;else ga=ga+2|0}$=U+(ea<<1)|0;aa=X;ba=X;ca=1;break}if(Z){ga=U+(x<<1)+(Y(R,X+-1-V|0)|0)|0;fa=V;ha=U;while(1){ja=fa<<1;ra=d[S+(ja<<1)>>1]|0;na=ra<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ra<<16>>16>-2&(na|0)<(r|0)&(ja|0)<(s|0)^1){ia=0;do{d[ha+(ia<<1)>>1]=d[m+(ia<<1)>>1]|0;ia=ia+1|0}while((ia|0)!=(x|0))}else{Ba=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=65;break}else{ia=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=na+1|0;qa=ja+1|0;sa=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<1)|0;pa=Y(ra<<16>>16>-1?((na|0)<(r|0)?na:z):0,x)|0;Ca=Y(ra<<16>>16>-2?((oa|0)<(r|0)?oa:z):0,x)|0;oa=y+((Y(ka<<16>>16>-2?((qa|0)<(s|0)?qa:A):0,a)|0)<<1)|0;Da=oa+(Ca<<1)|0;Ea=oa+(pa<<1)|0;Fa=sa+(Ca<<1)|0;Ga=sa+(pa<<1)|0;Ha=ia;_=75}else{Ba=ia;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(na>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=ZP(na,r,i)|0;ra=ZP(na+1|0,r,i)|0;ia=ZP(ja,s,i)|0;pa=ZP(ja+1|0,s,i)|0;if((ia|ka|0)>-1)Ia=y+((Y(ia,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ia=m;if((ia|ra|0)>-1)Ja=y+((Y(ia,a)|0)<<1)+((Y(ra,x)|0)<<1)|0;else Ja=m;if((pa|ka|0)>-1)Ka=y+((Y(pa,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ka=m;if((pa|ra|0)<=-1){Da=m;Ea=Ka;Fa=Ja;Ga=Ia;Ha=Ba;_=75;break}Da=y+((Y(pa,a)|0)<<1)+((Y(ra,x)|0)<<1)|0;Ea=Ka;Fa=Ja;Ga=Ia;Ha=Ba;_=75}while(0);if((_|0)==75){_=0;La=+n[Ha>>2];Ma=+n[Ha+4>>2];Na=+n[Ha+8>>2];Oa=+n[Ha+12>>2];ja=0;do{na=LVb(+(j[Ga+(ja<<1)>>1]|0)*La+ +(j[Fa+(ja<<1)>>1]|0)*Ma+ +(j[Ea+(ja<<1)>>1]|0)*Na+ +(j[Da+(ja<<1)>>1]|0)*Oa)|0;d[ha+(ja<<1)>>1]=na>>>0<65536?na:(na|0)>0?65535:0;ja=ja+1|0}while((ja|0)!=(x|0))}fa=fa+1|0;if((fa|0)==(X|0))break;else ha=ha+(x<<1)|0}$=ga;aa=X;ba=X;ca=1}else{$=U;aa=V;ba=X;ca=1}}else _=18;else{$=U;aa=X;ba=V;ca=W}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ha=X-V|0;fa=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1)|0;ea=LVb(+(j[na>>1]|0)*+n[ja>>2]+ +(j[na+2>>1]|0)*+n[ja+4>>2]+ +(j[na+(a<<1)>>1]|0)*+n[ja+8>>2]+ +(j[na+(q<<1)>>1]|0)*+n[ja+12>>2])|0;d[fa>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;Z=Z+1|0;if((Z|0)==(X|0))break;else fa=fa+2|0}$=U+(ha<<1)|0;aa=X;ba=X;ca=0;break a;break}case 1:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=X-V<<1;Z=U;ga=V;while(1){ea=ga<<1;ja=h+(j[T+(ga<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1<<1)|0;Oa=+n[ja>>2];Na=+n[ja+4>>2];Ma=+n[ja+8>>2];La=+n[ja+12>>2];Pa=Oa*+(j[na+2>>1]|0)+Na*+(j[na+6>>1]|0)+Ma*+(j[na+(q<<1)>>1]|0)+La*+(j[na+(M<<1)>>1]|0);ja=LVb(+(j[na>>1]|0)*Oa+ +(j[na+4>>1]|0)*Na+ +(j[na+(a<<1)>>1]|0)*Ma+ +(j[na+(L<<1)>>1]|0)*La)|0;d[Z>>1]=ja>>>0<65536?ja:(ja|0)>0?65535:0;ja=LVb(Pa)|0;d[Z+2>>1]=ja>>>0<65536?ja:(ja|0)>0?65535:0;ga=ga+1|0;if((ga|0)==(X|0))break;else Z=Z+4|0}$=U+(fa<<1)|0;aa=X;ba=X;ca=0;break a;break}case 2:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}Z=(X-V|0)*3|0;ga=U;ha=V;while(1){ja=ha<<1;na=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<1)+((d[S+(ja<<1)>>1]|0)*3<<1)|0;Pa=+n[na>>2];La=+n[na+4>>2];Ma=+n[na+8>>2];Na=+n[na+12>>2];Oa=Pa*+(j[ea+2>>1]|0)+La*+(j[ea+8>>1]|0)+Ma*+(j[ea+(q<<1)>>1]|0)+Na*+(j[ea+(N<<1)>>1]|0);Qa=Pa*+(j[ea+4>>1]|0)+La*+(j[ea+10>>1]|0)+Ma*+(j[ea+(L<<1)>>1]|0)+Na*+(j[ea+(O<<1)>>1]|0);na=LVb(+(j[ea>>1]|0)*Pa+ +(j[ea+6>>1]|0)*La+ +(j[ea+(a<<1)>>1]|0)*Ma+ +(j[ea+(M<<1)>>1]|0)*Na)|0;d[ga>>1]=na>>>0<65536?na:(na|0)>0?65535:0;na=LVb(Oa)|0;d[ga+2>>1]=na>>>0<65536?na:(na|0)>0?65535:0;na=LVb(Qa)|0;d[ga+4>>1]=na>>>0<65536?na:(na|0)>0?65535:0;ha=ha+1|0;if((ha|0)==(X|0))break;else ga=ga+6|0}$=U+(Z<<1)|0;aa=X;ba=X;ca=0;break a;break}case 3:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ga=X-V<<2;ha=V;fa=U;while(1){na=ha<<1;ea=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((na|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(na<<1)>>1]<<2<<1)|0;Qa=+n[ea>>2];Oa=+n[ea+4>>2];Na=+n[ea+8>>2];Ma=+n[ea+12>>2];La=Qa*+(j[ja+2>>1]|0)+Oa*+(j[ja+10>>1]|0)+Na*+(j[ja+(q<<1)>>1]|0)+Ma*+(j[ja+(O<<1)>>1]|0);ea=LVb(+(j[ja>>1]|0)*Qa+ +(j[ja+8>>1]|0)*Oa+ +(j[ja+(a<<1)>>1]|0)*Na+ +(j[ja+(N<<1)>>1]|0)*Ma)|0;d[fa>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;ea=LVb(La)|0;d[fa+2>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;La=Qa*+(j[ja+6>>1]|0)+Oa*+(j[ja+14>>1]|0)+Na*+(j[ja+(M<<1)>>1]|0)+Ma*+(j[ja+(Q<<1)>>1]|0);ea=LVb(+(j[ja+4>>1]|0)*Qa+ +(j[ja+12>>1]|0)*Oa+ +(j[ja+(L<<1)>>1]|0)*Na+ +(j[ja+(P<<1)>>1]|0)*Ma)|0;d[fa+4>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;ea=LVb(La)|0;d[fa+6>>1]=ea>>>0<65536?ea:(ea|0)>0?65535:0;ha=ha+1|0;if((ha|0)==(X|0))break;else fa=fa+8|0}$=U+(ga<<1)|0;aa=X;ba=X;ca=0;break a;break}default:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=U+(x<<1)+(Y(R,X+-1-V|0)|0)|0;ha=V;Z=U;while(1){ea=ha<<1;ja=h+(j[T+(ha<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<1)|0;La=+n[ja>>2];Ma=+n[ja+4>>2];Na=+n[ja+8>>2];Oa=+n[ja+12>>2];ja=0;do{ea=ja+a|0;ra=LVb(+(j[na+(ja<<1)>>1]|0)*La+ +(j[na+(ja+x<<1)>>1]|0)*Ma+ +(j[na+(ea<<1)>>1]|0)*Na+ +(j[na+(ea+x<<1)>>1]|0)*Oa)|0;d[Z+(ja<<1)>>1]=ra>>>0<65536?ra:(ra|0)>0?65535:0;ja=ja+1|0}while((ja|0)!=(x|0));ha=ha+1|0;if((ha|0)==(X|0))break;else Z=Z+(x<<1)|0}$=fa;aa=X;ba=X;ca=0;break a}}}while(0);if((aa|0)<(t|0)){U=$;V=ba;W=ca;X=aa+1|0}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function Jna(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+1040|0;m=l+8|0;o=l;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{A=MVb(+p[k+((a&3)<<3)>>3])|0;d[m+(a<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;a=a+1|0}while((a|0)!=(x|0));a=z>>>1;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((Y(s,r)|0)<=0){f[o>>2]=0;f[o+4>>2]=0;C=aD(o,16)|0;D=270408;E=C+16|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,o,270425,269810,662);bD(o)}if((v|0)<=0){u=l;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<1)+2|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((X|0)<(t|0)){Z=X<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(W){_=18;break}else{$=U;aa=X;ba=V;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=W^1;_=16}while(0);do if((_|0)==16){_=0;if(W^da)if(da){if(G){$=U+((Y(X-V|0,x)|0)<<1)|0;aa=X;ba=X;ca=1;break}Z=(X|0)>(V|0);if(H){if(!Z){$=U;aa=V;ba=X;ca=1;break}ea=X-V|0;fa=V;ga=U;while(1){ha=fa<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=d[m>>1]|0;break}else{ma=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=y+(sa+qa<<1)|0;ua=d[y+(sa+oa<<1)>>1]|0;va=d[y+(ra+qa<<1)>>1]|0;wa=d[y+(ra+oa<<1)>>1]|0;xa=na;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=ZP(ja,r,i)|0;ia=ZP(ja+1|0,r,i)|0;na=ZP(ha,s,i)|0;oa=ZP(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<1)|0;else ya=m;ra=d[ya>>1]|0;if((na|ia|0)>-1)za=y+((Y(na,a)|0)+ia<<1)|0;else za=m;na=d[za>>1]|0;if((oa|ka|0)>-1)Aa=y+((Y(oa,a)|0)+ka<<1)|0;else Aa=m;ka=d[Aa>>1]|0;if((oa|ia|0)<=-1){ta=m;ua=ka;va=na;wa=ra;xa=ma;_=57;break}ta=y+((Y(oa,a)|0)+ia<<1)|0;ua=ka;va=na;wa=ra;xa=ma;_=57}while(0);if((_|0)==57){_=0;ha=LVb(+(wa<<16>>16)*+n[xa>>2]+ +(va<<16>>16)*+n[xa+4>>2]+ +(ua<<16>>16)*+n[xa+8>>2]+ +(d[ta>>1]|0)*+n[xa+12>>2])|0;la=((ha+32768|0)>>>0<65536?ha:(ha|0)>0?32767:32768)&65535}d[ga>>1]=la;fa=fa+1|0;if((fa|0)==(X|0))break;else ga=ga+2|0}$=U+(ea<<1)|0;aa=X;ba=X;ca=1;break}if(Z){ga=U+(x<<1)+(Y(R,X+-1-V|0)|0)|0;fa=V;ha=U;while(1){ja=fa<<1;ra=d[S+(ja<<1)>>1]|0;na=ra<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ra<<16>>16>-2&(na|0)<(r|0)&(ja|0)<(s|0)^1){ia=0;do{d[ha+(ia<<1)>>1]=d[m+(ia<<1)>>1]|0;ia=ia+1|0}while((ia|0)!=(x|0))}else{Ba=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=65;break}else{ia=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=na+1|0;qa=ja+1|0;sa=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<1)|0;pa=Y(ra<<16>>16>-1?((na|0)<(r|0)?na:z):0,x)|0;Ca=Y(ra<<16>>16>-2?((oa|0)<(r|0)?oa:z):0,x)|0;oa=y+((Y(ka<<16>>16>-2?((qa|0)<(s|0)?qa:A):0,a)|0)<<1)|0;Da=oa+(Ca<<1)|0;Ea=oa+(pa<<1)|0;Fa=sa+(Ca<<1)|0;Ga=sa+(pa<<1)|0;Ha=ia;_=75}else{Ba=ia;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(na>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=ZP(na,r,i)|0;ra=ZP(na+1|0,r,i)|0;ia=ZP(ja,s,i)|0;pa=ZP(ja+1|0,s,i)|0;if((ia|ka|0)>-1)Ia=y+((Y(ia,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ia=m;if((ia|ra|0)>-1)Ja=y+((Y(ia,a)|0)<<1)+((Y(ra,x)|0)<<1)|0;else Ja=m;if((pa|ka|0)>-1)Ka=y+((Y(pa,a)|0)<<1)+((Y(ka,x)|0)<<1)|0;else Ka=m;if((pa|ra|0)<=-1){Da=m;Ea=Ka;Fa=Ja;Ga=Ia;Ha=Ba;_=75;break}Da=y+((Y(pa,a)|0)<<1)+((Y(ra,x)|0)<<1)|0;Ea=Ka;Fa=Ja;Ga=Ia;Ha=Ba;_=75}while(0);if((_|0)==75){_=0;La=+n[Ha>>2];Ma=+n[Ha+4>>2];Na=+n[Ha+8>>2];Oa=+n[Ha+12>>2];ja=0;do{na=LVb(+(d[Ga+(ja<<1)>>1]|0)*La+ +(d[Fa+(ja<<1)>>1]|0)*Ma+ +(d[Ea+(ja<<1)>>1]|0)*Na+ +(d[Da+(ja<<1)>>1]|0)*Oa)|0;d[ha+(ja<<1)>>1]=(na+32768|0)>>>0<65536?na:(na|0)>0?32767:32768;ja=ja+1|0}while((ja|0)!=(x|0))}fa=fa+1|0;if((fa|0)==(X|0))break;else ha=ha+(x<<1)|0}$=ga;aa=X;ba=X;ca=1}else{$=U;aa=V;ba=X;ca=1}}else _=18;else{$=U;aa=X;ba=V;ca=W}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ha=X-V|0;fa=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1)|0;ea=LVb(+(d[na>>1]|0)*+n[ja>>2]+ +(d[na+2>>1]|0)*+n[ja+4>>2]+ +(d[na+(a<<1)>>1]|0)*+n[ja+8>>2]+ +(d[na+(q<<1)>>1]|0)*+n[ja+12>>2])|0;d[fa>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;Z=Z+1|0;if((Z|0)==(X|0))break;else fa=fa+2|0}$=U+(ha<<1)|0;aa=X;ba=X;ca=0;break a;break}case 1:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=X-V<<1;Z=U;ga=V;while(1){ea=ga<<1;ja=h+(j[T+(ga<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(ea<<1)>>1]<<1<<1)|0;Oa=+n[ja>>2];Na=+n[ja+4>>2];Ma=+n[ja+8>>2];La=+n[ja+12>>2];Pa=Oa*+(d[na+2>>1]|0)+Na*+(d[na+6>>1]|0)+Ma*+(d[na+(q<<1)>>1]|0)+La*+(d[na+(M<<1)>>1]|0);ja=LVb(+(d[na>>1]|0)*Oa+ +(d[na+4>>1]|0)*Na+ +(d[na+(a<<1)>>1]|0)*Ma+ +(d[na+(L<<1)>>1]|0)*La)|0;d[Z>>1]=(ja+32768|0)>>>0<65536?ja:(ja|0)>0?32767:32768;ja=LVb(Pa)|0;d[Z+2>>1]=(ja+32768|0)>>>0<65536?ja:(ja|0)>0?32767:32768;ga=ga+1|0;if((ga|0)==(X|0))break;else Z=Z+4|0}$=U+(fa<<1)|0;aa=X;ba=X;ca=0;break a;break}case 2:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}Z=(X-V|0)*3|0;ga=U;ha=V;while(1){ja=ha<<1;na=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<1)+((d[S+(ja<<1)>>1]|0)*3<<1)|0;Pa=+n[na>>2];La=+n[na+4>>2];Ma=+n[na+8>>2];Na=+n[na+12>>2];Oa=Pa*+(d[ea+2>>1]|0)+La*+(d[ea+8>>1]|0)+Ma*+(d[ea+(q<<1)>>1]|0)+Na*+(d[ea+(N<<1)>>1]|0);Qa=Pa*+(d[ea+4>>1]|0)+La*+(d[ea+10>>1]|0)+Ma*+(d[ea+(L<<1)>>1]|0)+Na*+(d[ea+(O<<1)>>1]|0);na=LVb(+(d[ea>>1]|0)*Pa+ +(d[ea+6>>1]|0)*La+ +(d[ea+(a<<1)>>1]|0)*Ma+ +(d[ea+(M<<1)>>1]|0)*Na)|0;d[ga>>1]=(na+32768|0)>>>0<65536?na:(na|0)>0?32767:32768;na=LVb(Oa)|0;d[ga+2>>1]=(na+32768|0)>>>0<65536?na:(na|0)>0?32767:32768;na=LVb(Qa)|0;d[ga+4>>1]=(na+32768|0)>>>0<65536?na:(na|0)>0?32767:32768;ha=ha+1|0;if((ha|0)==(X|0))break;else ga=ga+6|0}$=U+(Z<<1)|0;aa=X;ba=X;ca=0;break a;break}case 3:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ga=X-V<<2;ha=V;fa=U;while(1){na=ha<<1;ea=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((na|1)<<1)>>1]|0,a)|0)<<1)+(d[S+(na<<1)>>1]<<2<<1)|0;Qa=+n[ea>>2];Oa=+n[ea+4>>2];Na=+n[ea+8>>2];Ma=+n[ea+12>>2];La=Qa*+(d[ja+2>>1]|0)+Oa*+(d[ja+10>>1]|0)+Na*+(d[ja+(q<<1)>>1]|0)+Ma*+(d[ja+(O<<1)>>1]|0);ea=LVb(+(d[ja>>1]|0)*Qa+ +(d[ja+8>>1]|0)*Oa+ +(d[ja+(a<<1)>>1]|0)*Na+ +(d[ja+(N<<1)>>1]|0)*Ma)|0;d[fa>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;ea=LVb(La)|0;d[fa+2>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;La=Qa*+(d[ja+6>>1]|0)+Oa*+(d[ja+14>>1]|0)+Na*+(d[ja+(M<<1)>>1]|0)+Ma*+(d[ja+(Q<<1)>>1]|0);ea=LVb(+(d[ja+4>>1]|0)*Qa+ +(d[ja+12>>1]|0)*Oa+ +(d[ja+(L<<1)>>1]|0)*Na+ +(d[ja+(P<<1)>>1]|0)*Ma)|0;d[fa+4>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;ea=LVb(La)|0;d[fa+6>>1]=(ea+32768|0)>>>0<65536?ea:(ea|0)>0?32767:32768;ha=ha+1|0;if((ha|0)==(X|0))break;else fa=fa+8|0}$=U+(ga<<1)|0;aa=X;ba=X;ca=0;break a;break}default:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=U+(x<<1)+(Y(R,X+-1-V|0)|0)|0;ha=V;Z=U;while(1){ea=ha<<1;ja=h+(j[T+(ha<<1)>>1]<<2<<2)|0;na=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<1)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<1)|0;La=+n[ja>>2];Ma=+n[ja+4>>2];Na=+n[ja+8>>2];Oa=+n[ja+12>>2];ja=0;do{ea=ja+a|0;ra=LVb(+(d[na+(ja<<1)>>1]|0)*La+ +(d[na+(ja+x<<1)>>1]|0)*Ma+ +(d[na+(ea<<1)>>1]|0)*Na+ +(d[na+(ea+x<<1)>>1]|0)*Oa)|0;d[Z+(ja<<1)>>1]=(ra+32768|0)>>>0<65536?ra:(ra|0)>0?32767:32768;ja=ja+1|0}while((ja|0)!=(x|0));ha=ha+1|0;if((ha|0)==(X|0))break;else Z=Z+(x<<1)|0}$=fa;aa=X;ba=X;ca=0;break a}}}while(0);if((aa|0)<(t|0)){U=$;V=ba;W=ca;X=aa+1|0}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function Kna(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+2064|0;m=l+8|0;o=l;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{n[m+(a<<2)>>2]=+p[k+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=z>>>2;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((Y(s,r)|0)<=0){f[o>>2]=0;f[o+4>>2]=0;C=aD(o,16)|0;D=270408;E=C+16|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,o,270425,269810,662);bD(o)}if((v|0)<=0){u=l;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<2)+4|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((X|0)<(t|0)){Z=X<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(W){_=18;break}else{$=U;aa=X;ba=V;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=W^1;_=16}while(0);do if((_|0)==16){_=0;if(W^da)if(da){if(G){$=U+((Y(X-V|0,x)|0)<<2)|0;aa=X;ba=X;ca=1;break}Z=(X|0)>(V|0);if(H){if(!Z){$=U;aa=V;ba=X;ca=1;break}ea=X-V|0;fa=V;ga=U;while(1){ha=fa<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=+n[m>>2];break}else{ma=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=y+(sa+qa<<2)|0;ua=+n[y+(sa+oa<<2)>>2];va=+n[y+(ra+qa<<2)>>2];wa=+n[y+(ra+oa<<2)>>2];xa=na;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=ZP(ja,r,i)|0;ia=ZP(ja+1|0,r,i)|0;na=ZP(ha,s,i)|0;oa=ZP(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<2)|0;else ya=m;za=+n[ya>>2];if((na|ia|0)>-1)Aa=y+((Y(na,a)|0)+ia<<2)|0;else Aa=m;Ba=+n[Aa>>2];if((oa|ka|0)>-1)Ca=y+((Y(oa,a)|0)+ka<<2)|0;else Ca=m;Da=+n[Ca>>2];if((oa|ia|0)<=-1){ta=m;ua=Da;va=Ba;wa=za;xa=ma;_=57;break}ta=y+((Y(oa,a)|0)+ia<<2)|0;ua=Da;va=Ba;wa=za;xa=ma;_=57}while(0);if((_|0)==57){_=0;la=wa*+n[xa>>2]+va*+n[xa+4>>2]+ua*+n[xa+8>>2]+ +n[ta>>2]*+n[xa+12>>2]}n[ga>>2]=la;fa=fa+1|0;if((fa|0)==(X|0))break;else ga=ga+4|0}$=U+(ea<<2)|0;aa=X;ba=X;ca=1;break}if(Z){ga=U+(x<<2)+(Y(R,X+-1-V|0)|0)|0;fa=V;ha=U;while(1){ja=fa<<1;ia=d[S+(ja<<1)>>1]|0;oa=ia<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(oa|0)<(r|0)&(ja|0)<(s|0)^1){na=0;do{f[ha+(na<<2)>>2]=f[m+(na<<2)>>2];na=na+1|0}while((na|0)!=(x|0))}else{Ea=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=65;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){ra=oa+1|0;qa=ja+1|0;sa=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<2)|0;pa=Y(ia<<16>>16>-1?((oa|0)<(r|0)?oa:z):0,x)|0;Fa=Y(ia<<16>>16>-2?((ra|0)<(r|0)?ra:z):0,x)|0;ra=y+((Y(ka<<16>>16>-2?((qa|0)<(s|0)?qa:A):0,a)|0)<<2)|0;Ga=ra+(Fa<<2)|0;Ha=ra+(pa<<2)|0;Ia=sa+(Fa<<2)|0;Ja=sa+(pa<<2)|0;Ka=na;_=75}else{Ea=na;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(oa>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=ZP(oa,r,i)|0;ia=ZP(oa+1|0,r,i)|0;na=ZP(ja,s,i)|0;pa=ZP(ja+1|0,s,i)|0;if((na|ka|0)>-1)La=y+((Y(na,a)|0)<<2)+((Y(ka,x)|0)<<2)|0;else La=m;if((na|ia|0)>-1)Ma=y+((Y(na,a)|0)<<2)+((Y(ia,x)|0)<<2)|0;else Ma=m;if((pa|ka|0)>-1)Na=y+((Y(pa,a)|0)<<2)+((Y(ka,x)|0)<<2)|0;else Na=m;if((pa|ia|0)<=-1){Ga=m;Ha=Na;Ia=Ma;Ja=La;Ka=Ea;_=75;break}Ga=y+((Y(pa,a)|0)<<2)+((Y(ia,x)|0)<<2)|0;Ha=Na;Ia=Ma;Ja=La;Ka=Ea;_=75}while(0);if((_|0)==75){_=0;ja=Ka+4|0;oa=Ka+8|0;ia=Ka+12|0;pa=0;do{n[ha+(pa<<2)>>2]=+n[Ja+(pa<<2)>>2]*+n[Ka>>2]+ +n[Ia+(pa<<2)>>2]*+n[ja>>2]+ +n[Ha+(pa<<2)>>2]*+n[oa>>2]+ +n[Ga+(pa<<2)>>2]*+n[ia>>2];pa=pa+1|0}while((pa|0)!=(x|0))}fa=fa+1|0;if((fa|0)==(X|0))break;else ha=ha+(x<<2)|0}$=ga;aa=X;ba=X;ca=1}else{$=U;aa=V;ba=X;ca=1}}else _=18;else{$=U;aa=X;ba=V;ca=W}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ha=X-V|0;fa=U;Z=V;while(1){ea=Z<<1;pa=h+(j[T+(Z<<1)>>1]<<2<<2)|0;ia=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<2)+(d[S+(ea<<1)>>1]<<2)|0;n[fa>>2]=+n[ia>>2]*+n[pa>>2]+ +n[ia+4>>2]*+n[pa+4>>2]+ +n[ia+(a<<2)>>2]*+n[pa+8>>2]+ +n[ia+(q<<2)>>2]*+n[pa+12>>2];Z=Z+1|0;if((Z|0)==(X|0))break;else fa=fa+4|0}$=U+(ha<<2)|0;aa=X;ba=X;ca=0;break a;break}case 1:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=X-V<<1;Z=U;ga=V;while(1){pa=ga<<1;ia=h+(j[T+(ga<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((pa|1)<<1)>>1]|0,a)|0)<<2)+(d[S+(pa<<1)>>1]<<1<<2)|0;za=+n[ia>>2];Ba=+n[ia+4>>2];Da=+n[ia+8>>2];Oa=+n[ia+12>>2];Pa=za*+n[ea+4>>2]+Ba*+n[ea+12>>2]+Da*+n[ea+(q<<2)>>2]+Oa*+n[ea+(M<<2)>>2];n[Z>>2]=+n[ea>>2]*za+ +n[ea+8>>2]*Ba+ +n[ea+(a<<2)>>2]*Da+ +n[ea+(L<<2)>>2]*Oa;n[Z+4>>2]=Pa;ga=ga+1|0;if((ga|0)==(X|0))break;else Z=Z+8|0}$=U+(fa<<2)|0;aa=X;ba=X;ca=0;break a;break}case 2:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}Z=(X-V|0)*3|0;ga=U;ha=V;while(1){ea=ha<<1;ia=h+(j[T+(ha<<1)>>1]<<2<<2)|0;pa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<2)+((d[S+(ea<<1)>>1]|0)*3<<2)|0;Pa=+n[ia>>2];Oa=+n[ia+4>>2];Da=+n[ia+8>>2];Ba=+n[ia+12>>2];za=Pa*+n[pa+4>>2]+Oa*+n[pa+16>>2]+Da*+n[pa+(q<<2)>>2]+Ba*+n[pa+(N<<2)>>2];Qa=Pa*+n[pa+8>>2]+Oa*+n[pa+20>>2]+Da*+n[pa+(L<<2)>>2]+Ba*+n[pa+(O<<2)>>2];n[ga>>2]=+n[pa>>2]*Pa+ +n[pa+12>>2]*Oa+ +n[pa+(a<<2)>>2]*Da+ +n[pa+(M<<2)>>2]*Ba;n[ga+4>>2]=za;n[ga+8>>2]=Qa;ha=ha+1|0;if((ha|0)==(X|0))break;else ga=ga+12|0}$=U+(Z<<2)|0;aa=X;ba=X;ca=0;break a;break}case 3:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ga=X-V<<2;ha=V;fa=U;while(1){pa=ha<<1;ia=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((pa|1)<<1)>>1]|0,a)|0)<<2)+(d[S+(pa<<1)>>1]<<2<<2)|0;Qa=+n[ia>>2];pa=ia+4|0;za=+n[pa>>2];oa=ia+8|0;Ba=+n[oa>>2];ja=ia+12|0;Da=+n[ja>>2];Oa=Qa*+n[ea+4>>2]+za*+n[ea+20>>2]+Ba*+n[ea+(q<<2)>>2]+Da*+n[ea+(O<<2)>>2];n[fa>>2]=+n[ea>>2]*Qa+ +n[ea+16>>2]*za+ +n[ea+(a<<2)>>2]*Ba+ +n[ea+(N<<2)>>2]*Da;n[fa+4>>2]=Oa;Oa=+n[ia>>2];Da=+n[pa>>2];Ba=+n[oa>>2];za=+n[ja>>2];Qa=Oa*+n[ea+12>>2]+Da*+n[ea+28>>2]+Ba*+n[ea+(M<<2)>>2]+za*+n[ea+(Q<<2)>>2];n[fa+8>>2]=+n[ea+8>>2]*Oa+ +n[ea+24>>2]*Da+ +n[ea+(L<<2)>>2]*Ba+ +n[ea+(P<<2)>>2]*za;n[fa+12>>2]=Qa;ha=ha+1|0;if((ha|0)==(X|0))break;else fa=fa+16|0}$=U+(ga<<2)|0;aa=X;ba=X;ca=0;break a;break}default:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=U+(x<<2)+(Y(R,X+-1-V|0)|0)|0;ha=V;Z=U;while(1){ea=ha<<1;ja=h+(j[T+(ha<<1)>>1]<<2<<2)|0;oa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<2)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<2)|0;ea=ja+4|0;pa=ja+8|0;ia=ja+12|0;ka=0;do{na=ka+a|0;n[Z+(ka<<2)>>2]=+n[oa+(ka<<2)>>2]*+n[ja>>2]+ +n[oa+(ka+x<<2)>>2]*+n[ea>>2]+ +n[oa+(na<<2)>>2]*+n[pa>>2]+ +n[oa+(na+x<<2)>>2]*+n[ia>>2];ka=ka+1|0}while((ka|0)!=(x|0));ha=ha+1|0;if((ha|0)==(X|0))break;else Z=Z+(x<<2)|0}$=fa;aa=X;ba=X;ca=0;break a}}}while(0);if((aa|0)<(t|0)){U=$;V=ba;W=ca;X=aa+1|0}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function Lna(a,c,e,g,h,i,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0;l=u;u=u+4112|0;m=l;o=l+4096|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[c+40>>2]|0;t=f[q+4>>2]|0;v=f[q>>2]|0;q=(f[a>>2]|0)>>>3;w=q&511;x=w+1|0;y=f[a+16>>2]|0;z=f[a+48>>2]|0;a=0;do{p[m+(a<<3)>>3]=+p[k+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(x|0));a=z>>>3;z=r+-1|0;k=(z|0)>0?z:0;A=s+-1|0;B=(A|0)>0?A:0;if((Y(s,r)|0)<=0){f[o>>2]=0;f[o+4>>2]=0;C=aD(o,16)|0;D=270408;E=C+16|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,o,270425,269810,662);bD(o)}if((v|0)<=0){u=l;return}o=c+16|0;D=c+44|0;c=e+16|0;C=e+44|0;e=g+16|0;E=g+44|0;g=(t|0)<0;F=(i|0)==5;G=F&(x|0)!=3;H=(w|0)==0;I=(i|0)==0;J=(i|0)==1;K=q&65535;q=a+1|0;L=a+2|0;M=a+3|0;N=a+4|0;O=a+5|0;P=a+6|0;Q=a+7|0;R=(w<<3)+8|0;w=0;do{S=(f[c>>2]|0)+(Y(f[f[C>>2]>>2]|0,w)|0)|0;T=(f[e>>2]|0)+(Y(f[f[E>>2]>>2]|0,w)|0)|0;if(!g){U=(f[o>>2]|0)+(Y(f[f[D>>2]>>2]|0,w)|0)|0;V=0;W=0;X=0;while(1){do if((X|0)<(t|0)){Z=X<<1;if((d[S+(Z<<1)>>1]|0)>>>0>=k>>>0)if(W){_=18;break}else{$=U;aa=X;ba=V;ca=0;break}else{da=(d[S+((Z|1)<<1)>>1]|0)>>>0<B>>>0;_=16;break}}else{da=W^1;_=16}while(0);do if((_|0)==16){_=0;if(W^da)if(da){if(G){$=U+((Y(X-V|0,x)|0)<<3)|0;aa=X;ba=X;ca=1;break}Z=(X|0)>(V|0);if(H){if(!Z){$=U;aa=V;ba=X;ca=1;break}ea=X-V|0;fa=V;ga=U;while(1){ha=fa<<1;ia=d[S+(ha<<1)>>1]|0;ja=ia<<16>>16;ka=d[S+((ha|1)<<1)>>1]|0;ha=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(ja|0)<(r|0)&(ha|0)<(s|0)^1){la=+p[m>>3];break}else{ma=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=49;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){oa=ia<<16>>16>-1?((ja|0)<(r|0)?ja:z):0;pa=ja+1|0;qa=ia<<16>>16>-2?((pa|0)<(r|0)?pa:z):0;pa=ha+1|0;ra=Y(ka<<16>>16>-1?((ha|0)<(s|0)?ha:A):0,a)|0;sa=Y(ka<<16>>16>-2?((pa|0)<(s|0)?pa:A):0,a)|0;ta=y+(sa+qa<<3)|0;ua=+p[y+(sa+oa<<3)>>3];va=+p[y+(ra+qa<<3)>>3];wa=+p[y+(ra+oa<<3)>>3];xa=na;_=57}else{ma=na;_=49}}while(0);do if((_|0)==49){_=0;ka=ZP(ja,r,i)|0;ia=ZP(ja+1|0,r,i)|0;na=ZP(ha,s,i)|0;oa=ZP(ha+1|0,s,i)|0;if((na|ka|0)>-1)ya=y+((Y(na,a)|0)+ka<<3)|0;else ya=m;za=+p[ya>>3];if((na|ia|0)>-1)Aa=y+((Y(na,a)|0)+ia<<3)|0;else Aa=m;Ba=+p[Aa>>3];if((oa|ka|0)>-1)Ca=y+((Y(oa,a)|0)+ka<<3)|0;else Ca=m;Da=+p[Ca>>3];if((oa|ia|0)<=-1){ta=m;ua=Da;va=Ba;wa=za;xa=ma;_=57;break}ta=y+((Y(oa,a)|0)+ia<<3)|0;ua=Da;va=Ba;wa=za;xa=ma;_=57}while(0);if((_|0)==57){_=0;la=wa*+n[xa>>2]+va*+n[xa+4>>2]+ua*+n[xa+8>>2]+ +p[ta>>3]*+n[xa+12>>2]}p[ga>>3]=la;fa=fa+1|0;if((fa|0)==(X|0))break;else ga=ga+8|0}$=U+(ea<<3)|0;aa=X;ba=X;ca=1;break}if(Z){ga=U+(x<<3)+(Y(R,X+-1-V|0)|0)|0;fa=V;ha=U;while(1){ja=fa<<1;ia=d[S+(ja<<1)>>1]|0;oa=ia<<16>>16;ka=d[S+((ja|1)<<1)>>1]|0;ja=ka<<16>>16;do if(I)if(ka<<16>>16<-1|ia<<16>>16>-2&(oa|0)<(r|0)&(ja|0)<(s|0)^1){na=0;do{p[ha+(na<<3)>>3]=+p[m+(na<<3)>>3];na=na+1|0}while((na|0)!=(x|0))}else{Ea=h+(j[T+(fa<<1)>>1]<<2<<2)|0;_=65;break}else{na=h+(j[T+(fa<<1)>>1]<<2<<2)|0;if(J){ra=oa+1|0;qa=ja+1|0;sa=y+((Y(ka<<16>>16>-1?((ja|0)<(s|0)?ja:A):0,a)|0)<<3)|0;pa=Y(ia<<16>>16>-1?((oa|0)<(r|0)?oa:z):0,x)|0;Fa=Y(ia<<16>>16>-2?((ra|0)<(r|0)?ra:z):0,x)|0;ra=y+((Y(ka<<16>>16>-2?((qa|0)<(s|0)?qa:A):0,a)|0)<<3)|0;Ga=ra+(Fa<<3)|0;Ha=ra+(pa<<3)|0;Ia=sa+(Fa<<3)|0;Ja=sa+(pa<<3)|0;Ka=na;_=75}else{Ea=na;_=65}}while(0);do if((_|0)==65){_=0;if(F?!(oa>>>0<z>>>0&ja>>>0<A>>>0):0)break;ka=ZP(oa,r,i)|0;ia=ZP(oa+1|0,r,i)|0;na=ZP(ja,s,i)|0;pa=ZP(ja+1|0,s,i)|0;if((na|ka|0)>-1)La=y+((Y(na,a)|0)<<3)+((Y(ka,x)|0)<<3)|0;else La=m;if((na|ia|0)>-1)Ma=y+((Y(na,a)|0)<<3)+((Y(ia,x)|0)<<3)|0;else Ma=m;if((pa|ka|0)>-1)Na=y+((Y(pa,a)|0)<<3)+((Y(ka,x)|0)<<3)|0;else Na=m;if((pa|ia|0)<=-1){Ga=m;Ha=Na;Ia=Ma;Ja=La;Ka=Ea;_=75;break}Ga=y+((Y(pa,a)|0)<<3)+((Y(ia,x)|0)<<3)|0;Ha=Na;Ia=Ma;Ja=La;Ka=Ea;_=75}while(0);if((_|0)==75){_=0;za=+n[Ka>>2];Ba=+n[Ka+4>>2];Da=+n[Ka+8>>2];Oa=+n[Ka+12>>2];ja=0;do{p[ha+(ja<<3)>>3]=+p[Ja+(ja<<3)>>3]*za+ +p[Ia+(ja<<3)>>3]*Ba+ +p[Ha+(ja<<3)>>3]*Da+ +p[Ga+(ja<<3)>>3]*Oa;ja=ja+1|0}while((ja|0)!=(x|0))}fa=fa+1|0;if((fa|0)==(X|0))break;else ha=ha+(x<<3)|0}$=ga;aa=X;ba=X;ca=1}else{$=U;aa=V;ba=X;ca=1}}else _=18;else{$=U;aa=X;ba=V;ca=W}}while(0);a:do if((_|0)==18){_=0;switch(K&511){case 0:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ha=X-V|0;fa=U;Z=V;while(1){ea=Z<<1;ja=h+(j[T+(Z<<1)>>1]<<2<<2)|0;oa=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<3)+(d[S+(ea<<1)>>1]<<3)|0;p[fa>>3]=+p[oa>>3]*+n[ja>>2]+ +p[oa+8>>3]*+n[ja+4>>2]+ +p[oa+(a<<3)>>3]*+n[ja+8>>2]+ +p[oa+(q<<3)>>3]*+n[ja+12>>2];Z=Z+1|0;if((Z|0)==(X|0))break;else fa=fa+8|0}$=U+(ha<<3)|0;aa=X;ba=X;ca=0;break a;break}case 1:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=X-V<<1;Z=U;ga=V;while(1){ja=ga<<1;oa=h+(j[T+(ga<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<3)+(d[S+(ja<<1)>>1]<<1<<3)|0;Oa=+n[oa>>2];Da=+n[oa+4>>2];Ba=+n[oa+8>>2];za=+n[oa+12>>2];Pa=Oa*+p[ea+8>>3]+Da*+p[ea+24>>3]+Ba*+p[ea+(q<<3)>>3]+za*+p[ea+(M<<3)>>3];p[Z>>3]=+p[ea>>3]*Oa+ +p[ea+16>>3]*Da+ +p[ea+(a<<3)>>3]*Ba+ +p[ea+(L<<3)>>3]*za;p[Z+8>>3]=Pa;ga=ga+1|0;if((ga|0)==(X|0))break;else Z=Z+16|0}$=U+(fa<<3)|0;aa=X;ba=X;ca=0;break a;break}case 2:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}Z=(X-V|0)*3|0;ga=U;ha=V;while(1){ea=ha<<1;oa=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<3)+((d[S+(ea<<1)>>1]|0)*3<<3)|0;Pa=+n[oa>>2];za=+n[oa+4>>2];Ba=+n[oa+8>>2];Da=+n[oa+12>>2];Oa=Pa*+p[ja+8>>3]+za*+p[ja+32>>3]+Ba*+p[ja+(q<<3)>>3]+Da*+p[ja+(N<<3)>>3];Qa=Pa*+p[ja+16>>3]+za*+p[ja+40>>3]+Ba*+p[ja+(L<<3)>>3]+Da*+p[ja+(O<<3)>>3];p[ga>>3]=+p[ja>>3]*Pa+ +p[ja+24>>3]*za+ +p[ja+(a<<3)>>3]*Ba+ +p[ja+(M<<3)>>3]*Da;p[ga+8>>3]=Oa;p[ga+16>>3]=Qa;ha=ha+1|0;if((ha|0)==(X|0))break;else ga=ga+24|0}$=U+(Z<<3)|0;aa=X;ba=X;ca=0;break a;break}case 3:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}ga=X-V<<2;ha=V;fa=U;while(1){ja=ha<<1;oa=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ea=y+((Y(d[S+((ja|1)<<1)>>1]|0,a)|0)<<3)+(d[S+(ja<<1)>>1]<<2<<3)|0;Qa=+n[oa>>2];Oa=+n[oa+4>>2];Da=+n[oa+8>>2];Ba=+n[oa+12>>2];za=Qa*+p[ea+8>>3]+Oa*+p[ea+40>>3]+Da*+p[ea+(q<<3)>>3]+Ba*+p[ea+(O<<3)>>3];p[fa>>3]=+p[ea>>3]*Qa+ +p[ea+32>>3]*Oa+ +p[ea+(a<<3)>>3]*Da+ +p[ea+(N<<3)>>3]*Ba;p[fa+8>>3]=za;za=Qa*+p[ea+24>>3]+Oa*+p[ea+56>>3]+Da*+p[ea+(M<<3)>>3]+Ba*+p[ea+(Q<<3)>>3];p[fa+16>>3]=+p[ea+16>>3]*Qa+ +p[ea+48>>3]*Oa+ +p[ea+(L<<3)>>3]*Da+ +p[ea+(P<<3)>>3]*Ba;p[fa+24>>3]=za;ha=ha+1|0;if((ha|0)==(X|0))break;else fa=fa+32|0}$=U+(ga<<3)|0;aa=X;ba=X;ca=0;break a;break}default:{if((X|0)<=(V|0)){$=U;aa=V;ba=X;ca=0;break a}fa=U+(x<<3)+(Y(R,X+-1-V|0)|0)|0;ha=V;Z=U;while(1){ea=ha<<1;oa=h+(j[T+(ha<<1)>>1]<<2<<2)|0;ja=y+((Y(d[S+((ea|1)<<1)>>1]|0,a)|0)<<3)+((Y(d[S+(ea<<1)>>1]|0,x)|0)<<3)|0;za=+n[oa>>2];Ba=+n[oa+4>>2];Da=+n[oa+8>>2];Oa=+n[oa+12>>2];oa=0;do{ea=oa+a|0;p[Z+(oa<<3)>>3]=+p[ja+(oa<<3)>>3]*za+ +p[ja+(oa+x<<3)>>3]*Ba+ +p[ja+(ea<<3)>>3]*Da+ +p[ja+(ea+x<<3)>>3]*Oa;oa=oa+1|0}while((oa|0)!=(x|0));ha=ha+1|0;if((ha|0)==(X|0))break;else Z=Z+(x<<3)|0}$=fa;aa=X;ba=X;ca=0;break a}}}while(0);if((aa|0)<(t|0)){U=$;V=ba;W=ca;X=aa+1|0}else break}}w=w+1|0}while((w|0)!=(v|0));u=l;return}function Mna(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+512|0;j=i;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[c+40>>2]|0;n=f[k+4>>2]|0;o=f[k>>2]|0;k=(f[a>>2]|0)>>>3&511;q=k+1|0;r=f[a+16>>2]|0;s=f[a+48>>2]|0;a=0;do{t=MVb(+p[h+((a&3)<<3)>>3])|0;b[j+a>>0]=t>>>0<256?t:(t|0)>0?255:0;a=a+1|0}while((a|0)!=(q|0));if(f[c>>2]&16384){a=(f[e>>2]&16384|0)!=0;h=Y(a?o:1,n)|0;if(a){v=h;w=1}else{x=h;y=5}}else{x=n;y=5}if((y|0)==5)if((o|0)>0){v=x;w=o}else{u=i;return}o=c+16|0;x=c+44|0;c=e+16|0;n=e+44|0;e=(k|0)==0;k=(v|0)>0;h=l+-1|0;a=m+-1|0;t=(q|0)==3;z=(q|0)==4;A=(g|0)==5;B=0;do{C=(f[o>>2]|0)+(Y(f[f[x>>2]>>2]|0,B)|0)|0;D=(f[c>>2]|0)+(Y(f[f[n>>2]>>2]|0,B)|0)|0;a:do if(e){if(k)switch(g|0){case 1:{E=0;do{F=E<<1;G=d[D+(F<<1)>>1]|0;H=G<<16>>16;I=d[D+((F|1)<<1)>>1]|0;F=I<<16>>16;if(H>>>0<l>>>0&F>>>0<m>>>0){J=F;K=H}else{J=I<<16>>16>-1?((F|0)<(m|0)?F:a):0;K=G<<16>>16>-1?((H|0)<(l|0)?H:h):0}H=r+((Y(J,s)|0)+K)|0;b[C+E>>0]=b[H>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}case 0:{E=0;do{H=E<<1;G=d[D+(H<<1)>>1]|0;F=d[D+((H|1)<<1)>>1]|0;H=r+((Y(F,s)|0)+G)|0;b[C+E>>0]=b[(G>>>0<l>>>0&F>>>0<m>>>0?H:j)>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}default:{E=0;do{H=E<<1;F=d[D+(H<<1)>>1]|0;G=d[D+((H|1)<<1)>>1]|0;if(!(F>>>0<l>>>0&G>>>0<m>>>0)){if(!A){H=ZP(F,l,g)|0;L=H;M=ZP(G,m,g)|0;y=28}}else{L=F;M=G;y=28}if((y|0)==28){y=0;G=r+((Y(M,s)|0)+L)|0;b[C+E>>0]=b[G>>0]|0}E=E+1|0}while((E|0)!=(v|0))}}}else if(k){if(A){E=0;G=C;while(1){F=E<<1;H=d[D+(F<<1)>>1]|0;I=d[D+((F|1)<<1)>>1]|0;do if(H>>>0<l>>>0&I>>>0<m>>>0){F=r+(Y(I,s)|0)|0;if(t){N=F+(H*3|0)|0;b[G>>0]=b[N>>0]|0;b[G+1>>0]=b[N+1>>0]|0;b[G+2>>0]=b[N+2>>0]|0;break}if(z){N=F+(H<<2)|0;b[G>>0]=b[N>>0]|0;b[G+1>>0]=b[N+1>>0]|0;b[G+2>>0]=b[N+2>>0]|0;b[G+3>>0]=b[N+3>>0]|0;break}N=F+(Y(H,q)|0)|0;F=0;do{b[G+F>>0]=b[N+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}while(0);E=E+1|0;if((E|0)==(v|0))break a;else G=G+q|0}}else{O=0;P=C}while(1){G=O<<1;E=d[D+(G<<1)>>1]|0;H=E<<16>>16;I=d[D+((G|1)<<1)>>1]|0;G=I<<16>>16;b:do if(H>>>0<l>>>0&G>>>0<m>>>0){F=r+(Y(G,s)|0)|0;if(t){N=F+(H*3|0)|0;b[P>>0]=b[N>>0]|0;b[P+1>>0]=b[N+1>>0]|0;b[P+2>>0]=b[N+2>>0]|0;break}if(z){N=F+(H<<2)|0;b[P>>0]=b[N>>0]|0;b[P+1>>0]=b[N+1>>0]|0;b[P+2>>0]=b[N+2>>0]|0;b[P+3>>0]=b[N+3>>0]|0;break}N=F+(Y(H,q)|0)|0;F=0;do{b[P+F>>0]=b[N+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}else{switch(g|0){case 5:{break b;break}case 1:{Q=r+(Y(I<<16>>16>-1?((G|0)<(m|0)?G:a):0,s)|0)+(Y(E<<16>>16>-1?((H|0)<(l|0)?H:h):0,q)|0)|0;break}case 0:{Q=j;break}default:{F=ZP(H,l,g)|0;Q=r+(Y(ZP(G,m,g)|0,s)|0)+(Y(F,q)|0)|0}}F=0;do{b[P+F>>0]=b[Q+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}while(0);O=O+1|0;if((O|0)==(v|0))break;else P=P+q|0}}while(0);B=B+1|0}while((B|0)!=(w|0));u=i;return}function Nna(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+512|0;j=i;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=f[c+40>>2]|0;n=f[k+4>>2]|0;o=f[k>>2]|0;k=(f[a>>2]|0)>>>3&511;q=k+1|0;r=f[a+16>>2]|0;s=f[a+48>>2]|0;a=0;do{t=MVb(+p[h+((a&3)<<3)>>3])|0;b[j+a>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;a=a+1|0}while((a|0)!=(q|0));if(f[c>>2]&16384){a=(f[e>>2]&16384|0)!=0;h=Y(a?o:1,n)|0;if(a){v=h;w=1}else{x=h;y=5}}else{x=n;y=5}if((y|0)==5)if((o|0)>0){v=x;w=o}else{u=i;return}o=c+16|0;x=c+44|0;c=e+16|0;n=e+44|0;e=(k|0)==0;k=(v|0)>0;h=l+-1|0;a=m+-1|0;t=(q|0)==3;z=(q|0)==4;A=(g|0)==5;B=0;do{C=(f[o>>2]|0)+(Y(f[f[x>>2]>>2]|0,B)|0)|0;D=(f[c>>2]|0)+(Y(f[f[n>>2]>>2]|0,B)|0)|0;a:do if(e){if(k)switch(g|0){case 1:{E=0;do{F=E<<1;G=d[D+(F<<1)>>1]|0;H=G<<16>>16;I=d[D+((F|1)<<1)>>1]|0;F=I<<16>>16;if(H>>>0<l>>>0&F>>>0<m>>>0){J=F;K=H}else{J=I<<16>>16>-1?((F|0)<(m|0)?F:a):0;K=G<<16>>16>-1?((H|0)<(l|0)?H:h):0}H=r+((Y(J,s)|0)+K)|0;b[C+E>>0]=b[H>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}case 0:{E=0;do{H=E<<1;G=d[D+(H<<1)>>1]|0;F=d[D+((H|1)<<1)>>1]|0;H=r+((Y(F,s)|0)+G)|0;b[C+E>>0]=b[(G>>>0<l>>>0&F>>>0<m>>>0?H:j)>>0]|0;E=E+1|0}while((E|0)!=(v|0));break}default:{E=0;do{H=E<<1;F=d[D+(H<<1)>>1]|0;G=d[D+((H|1)<<1)>>1]|0;if(!(F>>>0<l>>>0&G>>>0<m>>>0)){if(!A){H=ZP(F,l,g)|0;L=H;M=ZP(G,m,g)|0;y=28}}else{L=F;M=G;y=28}if((y|0)==28){y=0;G=r+((Y(M,s)|0)+L)|0;b[C+E>>0]=b[G>>0]|0}E=E+1|0}while((E|0)!=(v|0))}}}else if(k){if(A){E=0;G=C;while(1){F=E<<1;H=d[D+(F<<1)>>1]|0;I=d[D+((F|1)<<1)>>1]|0;do if(H>>>0<l>>>0&I>>>0<m>>>0){F=r+(Y(I,s)|0)|0;if(t){N=F+(H*3|0)|0;b[G>>0]=b[N>>0]|0;b[G+1>>0]=b[N+1>>0]|0;b[G+2>>0]=b[N+2>>0]|0;break}if(z){N=F+(H<<2)|0;b[G>>0]=b[N>>0]|0;b[G+1>>0]=b[N+1>>0]|0;b[G+2>>0]=b[N+2>>0]|0;b[G+3>>0]=b[N+3>>0]|0;break}N=F+(Y(H,q)|0)|0;F=0;do{b[G+F>>0]=b[N+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}while(0);E=E+1|0;if((E|0)==(v|0))break a;else G=G+q|0}}else{O=0;P=C}while(1){G=O<<1;E=d[D+(G<<1)>>1]|0;H=E<<16>>16;I=d[D+((G|1)<<1)>>1]|0;G=I<<16>>16;b:do if(H>>>0<l>>>0&G>>>0<m>>>0){F=r+(Y(G,s)|0)|0;if(t){N=F+(H*3|0)|0;b[P>>0]=b[N>>0]|0;b[P+1>>0]=b[N+1>>0]|0;b[P+2>>0]=b[N+2>>0]|0;break}if(z){N=F+(H<<2)|0;b[P>>0]=b[N>>0]|0;b[P+1>>0]=b[N+1>>0]|0;b[P+2>>0]=b[N+2>>0]|0;b[P+3>>0]=b[N+3>>0]|0;break}N=F+(Y(H,q)|0)|0;F=0;do{b[P+F>>0]=b[N+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}else{switch(g|0){case 5:{break b;break}case 1:{Q=r+(Y(I<<16>>16>-1?((G|0)<(m|0)?G:a):0,s)|0)+(Y(E<<16>>16>-1?((H|0)<(l|0)?H:h):0,q)|0)|0;break}case 0:{Q=j;break}default:{F=ZP(H,l,g)|0;Q=r+(Y(ZP(G,m,g)|0,s)|0)+(Y(F,q)|0)|0}}F=0;do{b[P+F>>0]=b[Q+F>>0]|0;F=F+1|0}while((F|0)!=(q|0))}while(0);O=O+1|0;if((O|0)==(v|0))break;else P=P+q|0}}while(0);B=B+1|0}while((B|0)!=(w|0));u=i;return}function Ona(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+1024|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{s=MVb(+p[g+((a&3)<<3)>>3])|0;d[i+(a<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+1|0}while((a|0)!=(o|0));a=r>>>1;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((n|0)>0){t=w;v=n}else{u=h;return}n=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;r=l+-1|0;s=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[w>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=E;J=G}else{I=H<<16>>16>-1?((E|0)<(l|0)?E:r):0;J=F<<16>>16>-1?((G|0)<(k|0)?G:g):0}G=q+((Y(I,a)|0)+J<<1)|0;d[B+(D<<1)>>1]=d[G>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}case 0:{D=0;do{G=D<<1;F=d[C+(G<<1)>>1]|0;E=d[C+((G|1)<<1)>>1]|0;if(F>>>0<k>>>0&E>>>0<l>>>0)K=q+((Y(E,a)|0)+F<<1)|0;else K=i;d[B+(D<<1)>>1]=d[K>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}default:{D=0;do{F=D<<1;E=d[C+(F<<1)>>1]|0;G=d[C+((F|1)<<1)>>1]|0;if(!(E>>>0<k>>>0&G>>>0<l>>>0)){if(!z){F=ZP(E,k,e)|0;L=F;M=ZP(G,l,e)|0;x=30}}else{L=E;M=G;x=30}if((x|0)==30){x=0;G=q+((Y(M,a)|0)+L<<1)|0;d[B+(D<<1)>>1]=d[G>>1]|0}D=D+1|0}while((D|0)!=(t|0))}}}else if(j){if(z){D=0;G=B;while(1){E=D<<1;F=d[C+(E<<1)>>1]|0;H=d[C+((E|1)<<1)>>1]|0;do if(F>>>0<k>>>0&H>>>0<l>>>0){E=q+((Y(H,a)|0)<<1)|0;if(s){N=E+(F*3<<1)|0;d[G>>1]=d[N>>1]|0;d[G+2>>1]=d[N+2>>1]|0;d[G+4>>1]=d[N+4>>1]|0;break}if(y){N=E+(F<<2<<1)|0;d[G>>1]=d[N>>1]|0;d[G+2>>1]=d[N+2>>1]|0;d[G+4>>1]=d[N+4>>1]|0;d[G+6>>1]=d[N+6>>1]|0;break}N=E+((Y(F,o)|0)<<1)|0;E=0;do{d[G+(E<<1)>>1]=d[N+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}while(0);D=D+1|0;if((D|0)==(t|0))break a;else G=G+(o<<1)|0}}else{O=0;P=B}while(1){G=O<<1;D=d[C+(G<<1)>>1]|0;F=D<<16>>16;H=d[C+((G|1)<<1)>>1]|0;G=H<<16>>16;b:do if(F>>>0<k>>>0&G>>>0<l>>>0){E=q+((Y(G,a)|0)<<1)|0;if(s){N=E+(F*3<<1)|0;d[P>>1]=d[N>>1]|0;d[P+2>>1]=d[N+2>>1]|0;d[P+4>>1]=d[N+4>>1]|0;break}if(y){N=E+(F<<2<<1)|0;d[P>>1]=d[N>>1]|0;d[P+2>>1]=d[N+2>>1]|0;d[P+4>>1]=d[N+4>>1]|0;d[P+6>>1]=d[N+6>>1]|0;break}N=E+((Y(F,o)|0)<<1)|0;E=0;do{d[P+(E<<1)>>1]=d[N+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(H<<16>>16>-1?((G|0)<(l|0)?G:r):0,a)|0)<<1)+((Y(D<<16>>16>-1?((F|0)<(k|0)?F:g):0,o)|0)<<1)|0;break}case 0:{Q=i;break}default:{E=ZP(F,k,e)|0;Q=q+((Y(ZP(G,l,e)|0,a)|0)<<1)+((Y(E,o)|0)<<1)|0}}E=0;do{d[P+(E<<1)>>1]=d[Q+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}while(0);O=O+1|0;if((O|0)==(t|0))break;else P=P+(o<<1)|0}}while(0);A=A+1|0}while((A|0)!=(v|0));u=h;return}function Pna(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+1024|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{s=MVb(+p[g+((a&3)<<3)>>3])|0;d[i+(a<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;a=a+1|0}while((a|0)!=(o|0));a=r>>>1;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((n|0)>0){t=w;v=n}else{u=h;return}n=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;r=l+-1|0;s=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[w>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=E;J=G}else{I=H<<16>>16>-1?((E|0)<(l|0)?E:r):0;J=F<<16>>16>-1?((G|0)<(k|0)?G:g):0}G=q+((Y(I,a)|0)+J<<1)|0;d[B+(D<<1)>>1]=d[G>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}case 0:{D=0;do{G=D<<1;F=d[C+(G<<1)>>1]|0;E=d[C+((G|1)<<1)>>1]|0;if(F>>>0<k>>>0&E>>>0<l>>>0)K=q+((Y(E,a)|0)+F<<1)|0;else K=i;d[B+(D<<1)>>1]=d[K>>1]|0;D=D+1|0}while((D|0)!=(t|0));break}default:{D=0;do{F=D<<1;E=d[C+(F<<1)>>1]|0;G=d[C+((F|1)<<1)>>1]|0;if(!(E>>>0<k>>>0&G>>>0<l>>>0)){if(!z){F=ZP(E,k,e)|0;L=F;M=ZP(G,l,e)|0;x=30}}else{L=E;M=G;x=30}if((x|0)==30){x=0;G=q+((Y(M,a)|0)+L<<1)|0;d[B+(D<<1)>>1]=d[G>>1]|0}D=D+1|0}while((D|0)!=(t|0))}}}else if(j){if(z){D=0;G=B;while(1){E=D<<1;F=d[C+(E<<1)>>1]|0;H=d[C+((E|1)<<1)>>1]|0;do if(F>>>0<k>>>0&H>>>0<l>>>0){E=q+((Y(H,a)|0)<<1)|0;if(s){N=E+(F*3<<1)|0;d[G>>1]=d[N>>1]|0;d[G+2>>1]=d[N+2>>1]|0;d[G+4>>1]=d[N+4>>1]|0;break}if(y){N=E+(F<<2<<1)|0;d[G>>1]=d[N>>1]|0;d[G+2>>1]=d[N+2>>1]|0;d[G+4>>1]=d[N+4>>1]|0;d[G+6>>1]=d[N+6>>1]|0;break}N=E+((Y(F,o)|0)<<1)|0;E=0;do{d[G+(E<<1)>>1]=d[N+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}while(0);D=D+1|0;if((D|0)==(t|0))break a;else G=G+(o<<1)|0}}else{O=0;P=B}while(1){G=O<<1;D=d[C+(G<<1)>>1]|0;F=D<<16>>16;H=d[C+((G|1)<<1)>>1]|0;G=H<<16>>16;b:do if(F>>>0<k>>>0&G>>>0<l>>>0){E=q+((Y(G,a)|0)<<1)|0;if(s){N=E+(F*3<<1)|0;d[P>>1]=d[N>>1]|0;d[P+2>>1]=d[N+2>>1]|0;d[P+4>>1]=d[N+4>>1]|0;break}if(y){N=E+(F<<2<<1)|0;d[P>>1]=d[N>>1]|0;d[P+2>>1]=d[N+2>>1]|0;d[P+4>>1]=d[N+4>>1]|0;d[P+6>>1]=d[N+6>>1]|0;break}N=E+((Y(F,o)|0)<<1)|0;E=0;do{d[P+(E<<1)>>1]=d[N+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(H<<16>>16>-1?((G|0)<(l|0)?G:r):0,a)|0)<<1)+((Y(D<<16>>16>-1?((F|0)<(k|0)?F:g):0,o)|0)<<1)|0;break}case 0:{Q=i;break}default:{E=ZP(F,k,e)|0;Q=q+((Y(ZP(G,l,e)|0,a)|0)<<1)+((Y(E,o)|0)<<1)|0}}E=0;do{d[P+(E<<1)>>1]=d[Q+(E<<1)>>1]|0;E=E+1|0}while((E|0)!=(o|0))}while(0);O=O+1|0;if((O|0)==(t|0))break;else P=P+(o<<1)|0}}while(0);A=A+1|0}while((A|0)!=(v|0));u=h;return}function Qna(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+2048|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{s=MVb(+p[g+((a&3)<<3)>>3])|0;f[i+(a<<2)>>2]=s;a=a+1|0}while((a|0)!=(o|0));a=r>>>2;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((n|0)>0){t=w;v=n}else{u=h;return}n=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;r=l+-1|0;s=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[w>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=E;J=G}else{I=H<<16>>16>-1?((E|0)<(l|0)?E:r):0;J=F<<16>>16>-1?((G|0)<(k|0)?G:g):0}G=q+((Y(I,a)|0)+J<<2)|0;f[B+(D<<2)>>2]=f[G>>2];D=D+1|0}while((D|0)!=(t|0));break}case 0:{D=0;do{G=D<<1;F=d[C+(G<<1)>>1]|0;E=d[C+((G|1)<<1)>>1]|0;if(F>>>0<k>>>0&E>>>0<l>>>0)K=q+((Y(E,a)|0)+F<<2)|0;else K=i;f[B+(D<<2)>>2]=f[K>>2];D=D+1|0}while((D|0)!=(t|0));break}default:{D=0;do{F=D<<1;E=d[C+(F<<1)>>1]|0;G=d[C+((F|1)<<1)>>1]|0;if(!(E>>>0<k>>>0&G>>>0<l>>>0)){if(!z){F=ZP(E,k,e)|0;L=F;M=ZP(G,l,e)|0;x=30}}else{L=E;M=G;x=30}if((x|0)==30){x=0;G=q+((Y(M,a)|0)+L<<2)|0;f[B+(D<<2)>>2]=f[G>>2]}D=D+1|0}while((D|0)!=(t|0))}}}else if(j){if(z){D=0;G=B;while(1){E=D<<1;F=d[C+(E<<1)>>1]|0;H=d[C+((E|1)<<1)>>1]|0;do if(F>>>0<k>>>0&H>>>0<l>>>0){E=q+((Y(H,a)|0)<<2)|0;if(s){N=E+(F*3<<2)|0;f[G>>2]=f[N>>2];f[G+4>>2]=f[N+4>>2];f[G+8>>2]=f[N+8>>2];break}if(y){N=E+(F<<2<<2)|0;f[G>>2]=f[N>>2];f[G+4>>2]=f[N+4>>2];f[G+8>>2]=f[N+8>>2];f[G+12>>2]=f[N+12>>2];break}N=E+((Y(F,o)|0)<<2)|0;E=0;do{f[G+(E<<2)>>2]=f[N+(E<<2)>>2];E=E+1|0}while((E|0)!=(o|0))}while(0);D=D+1|0;if((D|0)==(t|0))break a;else G=G+(o<<2)|0}}else{O=0;P=B}while(1){G=O<<1;D=d[C+(G<<1)>>1]|0;F=D<<16>>16;H=d[C+((G|1)<<1)>>1]|0;G=H<<16>>16;b:do if(F>>>0<k>>>0&G>>>0<l>>>0){E=q+((Y(G,a)|0)<<2)|0;if(s){N=E+(F*3<<2)|0;f[P>>2]=f[N>>2];f[P+4>>2]=f[N+4>>2];f[P+8>>2]=f[N+8>>2];break}if(y){N=E+(F<<2<<2)|0;f[P>>2]=f[N>>2];f[P+4>>2]=f[N+4>>2];f[P+8>>2]=f[N+8>>2];f[P+12>>2]=f[N+12>>2];break}N=E+((Y(F,o)|0)<<2)|0;E=0;do{f[P+(E<<2)>>2]=f[N+(E<<2)>>2];E=E+1|0}while((E|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(H<<16>>16>-1?((G|0)<(l|0)?G:r):0,a)|0)<<2)+((Y(D<<16>>16>-1?((F|0)<(k|0)?F:g):0,o)|0)<<2)|0;break}case 0:{Q=i;break}default:{E=ZP(F,k,e)|0;Q=q+((Y(ZP(G,l,e)|0,a)|0)<<2)+((Y(E,o)|0)<<2)|0}}E=0;do{f[P+(E<<2)>>2]=f[Q+(E<<2)>>2];E=E+1|0}while((E|0)!=(o|0))}while(0);O=O+1|0;if((O|0)==(t|0))break;else P=P+(o<<2)|0}}while(0);A=A+1|0}while((A|0)!=(v|0));u=h;return}function Rna(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=u;u=u+2048|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;o=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;q=j+1|0;r=f[a+16>>2]|0;s=f[a+48>>2]|0;a=0;do{n[i+(a<<2)>>2]=+p[g+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(q|0));a=s>>>2;if(f[b>>2]&16384){s=(f[c>>2]&16384|0)!=0;g=Y(s?o:1,m)|0;if(s){t=g;v=1}else{w=g;x=5}}else{w=m;x=5}if((x|0)==5)if((o|0)>0){t=w;v=o}else{u=h;return}o=b+16|0;w=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(t|0)>0;g=k+-1|0;s=l+-1|0;y=(q|0)==3;z=(q|0)==4;A=(e|0)==5;B=0;do{C=(f[o>>2]|0)+(Y(f[f[w>>2]>>2]|0,B)|0)|0;D=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,B)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{E=0;do{F=E<<1;G=d[D+(F<<1)>>1]|0;H=G<<16>>16;I=d[D+((F|1)<<1)>>1]|0;F=I<<16>>16;if(H>>>0<k>>>0&F>>>0<l>>>0){J=F;K=H}else{J=I<<16>>16>-1?((F|0)<(l|0)?F:s):0;K=G<<16>>16>-1?((H|0)<(k|0)?H:g):0}H=r+((Y(J,a)|0)+K<<2)|0;f[C+(E<<2)>>2]=f[H>>2];E=E+1|0}while((E|0)!=(t|0));break}case 0:{E=0;do{H=E<<1;G=d[D+(H<<1)>>1]|0;F=d[D+((H|1)<<1)>>1]|0;if(G>>>0<k>>>0&F>>>0<l>>>0)L=r+((Y(F,a)|0)+G<<2)|0;else L=i;f[C+(E<<2)>>2]=f[L>>2];E=E+1|0}while((E|0)!=(t|0));break}default:{E=0;do{G=E<<1;F=d[D+(G<<1)>>1]|0;H=d[D+((G|1)<<1)>>1]|0;if(!(F>>>0<k>>>0&H>>>0<l>>>0)){if(!A){G=ZP(F,k,e)|0;M=G;N=ZP(H,l,e)|0;x=30}}else{M=F;N=H;x=30}if((x|0)==30){x=0;H=r+((Y(N,a)|0)+M<<2)|0;f[C+(E<<2)>>2]=f[H>>2]}E=E+1|0}while((E|0)!=(t|0))}}}else if(j){if(A){E=0;H=C;while(1){F=E<<1;G=d[D+(F<<1)>>1]|0;I=d[D+((F|1)<<1)>>1]|0;do if(G>>>0<k>>>0&I>>>0<l>>>0){F=r+((Y(I,a)|0)<<2)|0;if(y){O=F+(G*3<<2)|0;f[H>>2]=f[O>>2];f[H+4>>2]=f[O+4>>2];f[H+8>>2]=f[O+8>>2];break}if(z){O=F+(G<<2<<2)|0;f[H>>2]=f[O>>2];f[H+4>>2]=f[O+4>>2];f[H+8>>2]=f[O+8>>2];f[H+12>>2]=f[O+12>>2];break}O=F+((Y(G,q)|0)<<2)|0;F=0;do{f[H+(F<<2)>>2]=f[O+(F<<2)>>2];F=F+1|0}while((F|0)!=(q|0))}while(0);E=E+1|0;if((E|0)==(t|0))break a;else H=H+(q<<2)|0}}else{P=0;Q=C}while(1){H=P<<1;E=d[D+(H<<1)>>1]|0;G=E<<16>>16;I=d[D+((H|1)<<1)>>1]|0;H=I<<16>>16;b:do if(G>>>0<k>>>0&H>>>0<l>>>0){F=r+((Y(H,a)|0)<<2)|0;if(y){O=F+(G*3<<2)|0;f[Q>>2]=f[O>>2];f[Q+4>>2]=f[O+4>>2];f[Q+8>>2]=f[O+8>>2];break}if(z){O=F+(G<<2<<2)|0;f[Q>>2]=f[O>>2];f[Q+4>>2]=f[O+4>>2];f[Q+8>>2]=f[O+8>>2];f[Q+12>>2]=f[O+12>>2];break}O=F+((Y(G,q)|0)<<2)|0;F=0;do{f[Q+(F<<2)>>2]=f[O+(F<<2)>>2];F=F+1|0}while((F|0)!=(q|0))}else{switch(e|0){case 5:{break b;break}case 1:{R=r+((Y(I<<16>>16>-1?((H|0)<(l|0)?H:s):0,a)|0)<<2)+((Y(E<<16>>16>-1?((G|0)<(k|0)?G:g):0,q)|0)<<2)|0;break}case 0:{R=i;break}default:{F=ZP(G,k,e)|0;R=r+((Y(ZP(H,l,e)|0,a)|0)<<2)+((Y(F,q)|0)<<2)|0}}F=0;do{f[Q+(F<<2)>>2]=f[R+(F<<2)>>2];F=F+1|0}while((F|0)!=(q|0))}while(0);P=P+1|0;if((P|0)==(t|0))break;else Q=Q+(q<<2)|0}}while(0);B=B+1|0}while((B|0)!=(v|0));u=h;return}function Sna(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+4096|0;i=h;j=f[a+40>>2]|0;k=f[j+4>>2]|0;l=f[j>>2]|0;j=f[b+40>>2]|0;m=f[j+4>>2]|0;n=f[j>>2]|0;j=(f[a>>2]|0)>>>3&511;o=j+1|0;q=f[a+16>>2]|0;r=f[a+48>>2]|0;a=0;do{p[i+(a<<3)>>3]=+p[g+((a&3)<<3)>>3];a=a+1|0}while((a|0)!=(o|0));a=r>>>3;if(f[b>>2]&16384){r=(f[c>>2]&16384|0)!=0;g=Y(r?n:1,m)|0;if(r){s=g;t=1}else{v=g;w=5}}else{v=m;w=5}if((w|0)==5)if((n|0)>0){s=v;t=n}else{u=h;return}n=b+16|0;v=b+44|0;b=c+16|0;m=c+44|0;c=(j|0)==0;j=(s|0)>0;g=k+-1|0;r=l+-1|0;x=(o|0)==3;y=(o|0)==4;z=(e|0)==5;A=0;do{B=(f[n>>2]|0)+(Y(f[f[v>>2]>>2]|0,A)|0)|0;C=(f[b>>2]|0)+(Y(f[f[m>>2]>>2]|0,A)|0)|0;a:do if(c){if(j)switch(e|0){case 1:{D=0;do{E=D<<1;F=d[C+(E<<1)>>1]|0;G=F<<16>>16;H=d[C+((E|1)<<1)>>1]|0;E=H<<16>>16;if(G>>>0<k>>>0&E>>>0<l>>>0){I=E;J=G}else{I=H<<16>>16>-1?((E|0)<(l|0)?E:r):0;J=F<<16>>16>-1?((G|0)<(k|0)?G:g):0}G=q+((Y(I,a)|0)+J<<3)|0;p[B+(D<<3)>>3]=+p[G>>3];D=D+1|0}while((D|0)!=(s|0));break}case 0:{D=0;do{G=D<<1;F=d[C+(G<<1)>>1]|0;E=d[C+((G|1)<<1)>>1]|0;if(F>>>0<k>>>0&E>>>0<l>>>0)K=q+((Y(E,a)|0)+F<<3)|0;else K=i;p[B+(D<<3)>>3]=+p[K>>3];D=D+1|0}while((D|0)!=(s|0));break}default:{D=0;do{F=D<<1;E=d[C+(F<<1)>>1]|0;G=d[C+((F|1)<<1)>>1]|0;if(!(E>>>0<k>>>0&G>>>0<l>>>0)){if(!z){F=ZP(E,k,e)|0;L=F;M=ZP(G,l,e)|0;w=30}}else{L=E;M=G;w=30}if((w|0)==30){w=0;G=q+((Y(M,a)|0)+L<<3)|0;p[B+(D<<3)>>3]=+p[G>>3]}D=D+1|0}while((D|0)!=(s|0))}}}else if(j){if(z){D=0;G=B;while(1){E=D<<1;F=d[C+(E<<1)>>1]|0;H=d[C+((E|1)<<1)>>1]|0;do if(F>>>0<k>>>0&H>>>0<l>>>0){E=q+((Y(H,a)|0)<<3)|0;if(x){N=E+(F*3<<3)|0;p[G>>3]=+p[N>>3];p[G+8>>3]=+p[N+8>>3];p[G+16>>3]=+p[N+16>>3];break}if(y){N=E+(F<<2<<3)|0;p[G>>3]=+p[N>>3];p[G+8>>3]=+p[N+8>>3];p[G+16>>3]=+p[N+16>>3];p[G+24>>3]=+p[N+24>>3];break}N=E+((Y(F,o)|0)<<3)|0;E=0;do{p[G+(E<<3)>>3]=+p[N+(E<<3)>>3];E=E+1|0}while((E|0)!=(o|0))}while(0);D=D+1|0;if((D|0)==(s|0))break a;else G=G+(o<<3)|0}}else{O=0;P=B}while(1){G=O<<1;D=d[C+(G<<1)>>1]|0;F=D<<16>>16;H=d[C+((G|1)<<1)>>1]|0;G=H<<16>>16;b:do if(F>>>0<k>>>0&G>>>0<l>>>0){E=q+((Y(G,a)|0)<<3)|0;if(x){N=E+(F*3<<3)|0;p[P>>3]=+p[N>>3];p[P+8>>3]=+p[N+8>>3];p[P+16>>3]=+p[N+16>>3];break}if(y){N=E+(F<<2<<3)|0;p[P>>3]=+p[N>>3];p[P+8>>3]=+p[N+8>>3];p[P+16>>3]=+p[N+16>>3];p[P+24>>3]=+p[N+24>>3];break}N=E+((Y(F,o)|0)<<3)|0;E=0;do{p[P+(E<<3)>>3]=+p[N+(E<<3)>>3];E=E+1|0}while((E|0)!=(o|0))}else{switch(e|0){case 5:{break b;break}case 1:{Q=q+((Y(H<<16>>16>-1?((G|0)<(l|0)?G:r):0,a)|0)<<3)+((Y(D<<16>>16>-1?((F|0)<(k|0)?F:g):0,o)|0)<<3)|0;break}case 0:{Q=i;break}default:{E=ZP(F,k,e)|0;Q=q+((Y(ZP(G,l,e)|0,a)|0)<<3)+((Y(E,o)|0)<<3)|0}}E=0;do{p[P+(E<<3)>>3]=+p[Q+(E<<3)>>3];E=E+1|0}while((E|0)!=(o|0))}while(0);O=O+1|0;if((O|0)==(s|0))break;else P=P+(o<<3)|0}}while(0);A=A+1|0}while((A|0)!=(t|0));u=h;return}function Tna(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0;o=u;u=u+1408|0;q=o+1352|0;r=o+1288|0;s=o+1296|0;t=o+208|0;v=o+224|0;w=o+216|0;x=o+32|0;y=o;f[r>>2]=d;f[r+4>>2]=e;JF(q,r,a,b,c);f[t>>2]=i;f[t+4>>2]=j;JF(s,t,a,g,h);h=s+12|0;g=f[h>>2]|0;a=g<<1;t=v+8|0;f[v>>2]=t;j=v+4|0;f[j>>2]=a;if(a>>>0>264){i=N5b(a>>>0>1073741823?-1:a<<2)|0;f[v>>2]=i;z=i}else z=t;i=z+(g<<2)|0;if((g|0)>0){A=+p[k>>3];B=+p[k+24>>3];g=f[h>>2]|0;a=0;do{C=+(a|0);c=MVb(C*A*1024.0)|0;f[z+(a<<2)>>2]=c;c=MVb(C*B*1024.0)|0;f[i+(a<<2)>>2]=c;a=a+1|0}while((a|0)<(g|0))}g=s+8|0;a=f[g>>2]|0;f[w>>2]=0;f[w+4>>2]=a;B=+p[n+8>>3];A=+p[n+16>>3];C=+p[n+24>>3];p[y>>3]=+p[n>>3];p[y+8>>3]=B;p[y+16>>3]=A;p[y+24>>3]=C;Una(x,q,s,l,m,y,z,i,k);k=s+4|0;i=f[k>>2]|0;if((i|0)<3)D=Y(f[h>>2]|0,f[g>>2]|0)|0;else{g=f[s+40>>2]|0;h=0;z=1;while(1){y=Y(f[g+(h<<2)>>2]|0,z)|0;h=h+1|0;if((h|0)==(i|0)){D=y;break}else z=y}}RQ(w,x,+(D>>>0)*.0000152587890625);Vna(x);x=f[v>>2]|0;if((x|0)!=(t|0)){if(x|0)P5b(x);f[v>>2]=t;f[j>>2]=264}j=s+36|0;t=f[j>>2]|0;if(t|0?(v=t+12|0,t=f[v>>2]|0,f[v>>2]=t+-1,(t|0)==1):0)kL(s);f[j>>2]=0;j=s+16|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[k>>2]|0)>0){j=f[s+40>>2]|0;t=0;do{f[j+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[k>>2]|0))}k=f[s+44>>2]|0;if((k|0)!=(s+48|0))UC(k);k=q+36|0;s=f[k>>2]|0;if(s|0?(t=s+12|0,s=f[t>>2]|0,f[t>>2]=s+-1,(s|0)==1):0)kL(q);f[k>>2]=0;k=q+16|0;s=q+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[s>>2]|0)>0){k=f[q+40>>2]|0;t=0;do{f[k+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[s>>2]|0))}s=f[q+44>>2]|0;if((s|0)==(q+48|0)){u=o;return}UC(s);u=o;return}function Una(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0;f[a>>2]=66584;k=a+4|0;f[k>>2]=f[b>>2];l=a+8|0;m=b+4|0;f[l>>2]=f[m>>2];n=a+12|0;f[n>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];o=f[b+36>>2]|0;f[a+40>>2]=o;f[a+44>>2]=n;n=a+52|0;q=a+48|0;f[q>>2]=n;f[n>>2]=0;f[a+56>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[b+44>>2]|0;n=f[q>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[l>>2]=0;jL(k,b)}b=a+60|0;f[b>>2]=f[c>>2];k=a+64|0;l=c+4|0;f[k>>2]=f[l>>2];m=a+68|0;f[m>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];n=f[c+36>>2]|0;f[a+96>>2]=n;f[a+100>>2]=m;m=a+108|0;q=a+104|0;f[q>>2]=m;f[m>>2]=0;f[a+112>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[c+44>>2]|0;m=f[q>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];r=a+116|0;f[r>>2]=d;s=a+120|0;f[s>>2]=e;t=+p[g>>3];u=a+128|0;p[u>>3]=t;v=g+8|0;w=+p[v>>3];x=a+136|0;p[x>>3]=w;y=g+16|0;z=+p[y>>3];A=a+144|0;p[A>>3]=z;B=g+24|0;C=+p[B>>3];D=a+152|0;p[D>>3]=C;E=a+160|0;f[E>>2]=h;F=a+164|0;f[F>>2]=i;G=a+168|0;f[G>>2]=j;return}else{f[k>>2]=0;jL(b,c);r=a+116|0;f[r>>2]=d;s=a+120|0;f[s>>2]=e;t=+p[g>>3];u=a+128|0;p[u>>3]=t;v=g+8|0;w=+p[v>>3];x=a+136|0;p[x>>3]=w;y=g+16|0;z=+p[y>>3];A=a+144|0;p[A>>3]=z;B=g+24|0;C=+p[B>>3];D=a+152|0;p[D>>3]=C;E=a+160|0;f[E>>2]=h;F=a+164|0;f[F>>2]=i;G=a+168|0;f[G>>2]=j;return}}function Vna(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=66584;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Wna(a){a=a|0;Vna(a);O5b(a);return}function Xna(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;c=u;u=u+24912|0;e=c+8520|0;g=c+328|0;h=c+272|0;i=c+216|0;j=c+160|0;k=c+104|0;l=c+88|0;m=c+72|0;n=c+56|0;o=c;q=a+116|0;r=(f[q>>2]|0)==0?512:16;s=a+60|0;t=f[a+68>>2]|0;v=4096/(((t|0)<32?t:32)|0)|0;w=a+72|0;x=f[w>>2]|0;y=(x|0)<(v|0)?x:v;v=4096/(y|0)|0;x=(t|0)<(v|0)?t:v;v=f[b>>2]|0;t=b+4|0;if((v|0)>=(f[t>>2]|0)){u=c;return}b=h+4|0;z=h+8|0;A=h+12|0;B=h+16|0;C=h+20|0;D=h+24|0;E=h+28|0;F=h+40|0;G=h+48|0;H=h+44|0;I=i+4|0;J=i+8|0;K=i+40|0;L=i+48|0;M=i+44|0;N=i+52|0;O=k+4|0;P=k+8|0;Q=k+12|0;R=a+4|0;S=k+8|0;T=k+12|0;U=k+4|0;V=l+8|0;W=l+4|0;X=m+8|0;Z=m+12|0;_=m+4|0;$=o+4|0;aa=o+8|0;ba=o+40|0;ca=o+48|0;da=o+44|0;ea=o+52|0;fa=n+8|0;ga=n+12|0;ha=n+4|0;ia=a+120|0;ja=a+128|0;ka=o+36|0;la=o+16|0;ma=j+36|0;na=j+16|0;oa=j+4|0;pa=j+40|0;qa=j+44|0;ra=j+48|0;sa=i+36|0;ta=i+16|0;ua=h+36|0;va=k+4|0;wa=k+8|0;xa=k+12|0;ya=k+16|0;za=k+20|0;Aa=k+24|0;Ba=k+28|0;Ca=k+40|0;Da=k+48|0;Ea=k+44|0;Fa=l+8|0;Ga=l+12|0;Ha=l+4|0;Ia=m+8|0;Ja=m+4|0;Ka=n+8|0;La=n+12|0;Ma=n+4|0;Na=o+8|0;Oa=o+12|0;Pa=o+4|0;Qa=k+36|0;Ra=a+168|0;Sa=a+160|0;Ta=a+164|0;a=D+8|0;Ua=h+52|0;Va=Aa+8|0;Wa=k+52|0;Xa=v;v=f[w>>2]|0;while(1){if((v|0)>0){Ya=0;Za=v;while(1){_a=Za-Ya|0;$a=(_a|0)<(y|0)?_a:y;_a=(f[t>>2]|0)-Xa|0;ab=(_a|0)<(x|0)?_a:x;f[b>>2]=2;f[z>>2]=ab;f[A>>2]=$a;f[B>>2]=e;f[C>>2]=e;_a=a;f[_a>>2]=0;f[_a+4>>2]=0;f[F>>2]=z;f[H>>2]=G;_a=$a<<2;f[h>>2]=1124024331;f[G>>2]=_a;f[Ua>>2]=4;bb=e+(Y(ab,_a)|0)|0;f[E>>2]=bb;f[D>>2]=bb+(0-_a)+_a;f[i>>2]=1124007936;_a=I;bb=_a+36|0;do{f[_a>>2]=0;_a=_a+4|0}while((_a|0)<(bb|0));f[K>>2]=J;f[M>>2]=L;f[L>>2]=0;f[N>>2]=0;f[k>>2]=Ya;f[O>>2]=Xa;f[P>>2]=$a;f[Q>>2]=ab;nL(j,s,k);if((ab|0)>0){cb=f[Ra>>2]|0;db=+p[cb+8>>3];eb=+p[cb+16>>3];fb=+p[cb+32>>3];gb=+p[cb+40>>3];cb=f[q>>2]|0;hb=(cb|0)==0;ib=($a|0)>0;jb=0;do{kb=Y(jb,$a)|0;lb=e+(kb<<1<<1)|0;mb=+(jb+Xa|0);nb=(MVb((mb*db+eb)*1024.0)|0)+r|0;ob=(MVb((mb*fb+gb)*1024.0)|0)+r|0;if(hb){if(ib){pb=f[Sa>>2]|0;qb=f[Ta>>2]|0;rb=0;do{sb=rb+Ya|0;tb=(f[pb+(sb<<2)>>2]|0)+nb>>10;ub=(f[qb+(sb<<2)>>2]|0)+ob>>10;sb=rb<<1;d[lb+(sb<<1)>>1]=(tb+32768|0)>>>0<65536?tb:(tb|0)>0?32767:32768;d[lb+((sb|1)<<1)>>1]=(ub+32768|0)>>>0<65536?ub:(ub|0)>0?32767:32768;rb=rb+1|0}while((rb|0)<($a|0))}}else{rb=g+(kb<<1)|0;if(ib){qb=f[Sa>>2]|0;pb=f[Ta>>2]|0;ub=0;do{sb=ub+Ya|0;tb=(f[qb+(sb<<2)>>2]|0)+nb|0;vb=(f[pb+(sb<<2)>>2]|0)+ob|0;sb=tb>>10;wb=ub<<1;d[lb+(wb<<1)>>1]=(sb+32768|0)>>>0<65536?sb:(sb|0)>0?32767:32768;sb=vb>>10;d[lb+((wb|1)<<1)>>1]=(sb+32768|0)>>>0<65536?sb:(sb|0)>0?32767:32768;d[rb+(ub<<1)>>1]=vb&992|tb>>>5&31;ub=ub+1|0}while((ub|0)<($a|0))}}jb=jb+1|0}while((jb|0)<(ab|0));xb=cb}else xb=f[q>>2]|0;if(!xb){f[S>>2]=0;f[T>>2]=0;f[k>>2]=16842752;f[U>>2]=R;cb=V;f[cb>>2]=0;f[cb+4>>2]=0;f[l>>2]=33619968;f[W>>2]=j;f[X>>2]=0;f[Z>>2]=0;f[m>>2]=16842752;f[_>>2]=h;f[o>>2]=1124007936;_a=$;bb=_a+36|0;do{f[_a>>2]=0;_a=_a+4|0}while((_a|0)<(bb|0));f[ba>>2]=aa;f[da>>2]=ca;f[ca>>2]=0;f[ea>>2]=0;f[fa>>2]=0;f[ga>>2]=0;f[n>>2]=16842752;f[ha>>2]=o;una(k,l,m,n,0,f[ia>>2]|0,ja);_a=f[ka>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)kL(o);f[ka>>2]=0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[$>>2]|0)>0){_a=f[ba>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[$>>2]|0))}bb=f[da>>2]|0;if((bb|0)!=(ca|0))UC(bb)}else{f[va>>2]=2;f[wa>>2]=ab;f[xa>>2]=$a;f[ya>>2]=g;f[za>>2]=g;bb=Va;f[bb>>2]=0;f[bb+4>>2]=0;f[Ca>>2]=wa;f[Ea>>2]=Da;bb=$a<<1;f[k>>2]=1124024322;f[Da>>2]=bb;f[Wa>>2]=2;_a=g+(Y(ab,bb)|0)|0;f[Ba>>2]=_a;f[Aa>>2]=_a+(0-bb)+bb;f[Fa>>2]=0;f[Ga>>2]=0;f[l>>2]=16842752;f[Ha>>2]=R;bb=Ia;f[bb>>2]=0;f[bb+4>>2]=0;f[m>>2]=33619968;f[Ja>>2]=j;f[Ka>>2]=0;f[La>>2]=0;f[n>>2]=16842752;f[Ma>>2]=h;f[Na>>2]=0;f[Oa>>2]=0;f[o>>2]=16842752;f[Pa>>2]=k;una(l,m,n,o,xb,f[ia>>2]|0,ja);bb=f[Qa>>2]|0;if(bb|0?(_a=bb+12|0,bb=f[_a>>2]|0,f[_a>>2]=bb+-1,(bb|0)==1):0)kL(k);f[Qa>>2]=0;f[ya>>2]=0;f[ya+4>>2]=0;f[ya+8>>2]=0;f[ya+12>>2]=0;if((f[va>>2]|0)>0){bb=f[Ca>>2]|0;_a=0;do{f[bb+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[va>>2]|0))}_a=f[Ea>>2]|0;if((_a|0)!=(Da|0))UC(_a)}_a=f[ma>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)kL(j);f[ma>>2]=0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[oa>>2]|0)>0){_a=f[pa>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[oa>>2]|0))}bb=f[qa>>2]|0;if((bb|0)!=(ra|0))UC(bb);bb=f[sa>>2]|0;if(bb|0?(_a=bb+12|0,bb=f[_a>>2]|0,f[_a>>2]=bb+-1,(bb|0)==1):0)kL(i);f[sa>>2]=0;f[ta>>2]=0;f[ta+4>>2]=0;f[ta+8>>2]=0;f[ta+12>>2]=0;if((f[I>>2]|0)>0){bb=f[K>>2]|0;_a=0;do{f[bb+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[I>>2]|0))}_a=f[M>>2]|0;if((_a|0)!=(L|0))UC(_a);_a=f[ua>>2]|0;if(_a|0?(bb=_a+12|0,_a=f[bb>>2]|0,f[bb>>2]=_a+-1,(_a|0)==1):0)kL(h);f[ua>>2]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[b>>2]|0)>0){_a=f[F>>2]|0;bb=0;do{f[_a+(bb<<2)>>2]=0;bb=bb+1|0}while((bb|0)<(f[b>>2]|0))}bb=f[H>>2]|0;if((bb|0)!=(G|0))UC(bb);Ya=Ya+y|0;bb=f[w>>2]|0;if((bb|0)<=(Ya|0)){yb=bb;break}else Za=bb}}else yb=v;Xa=Xa+x|0;if((Xa|0)>=(f[t>>2]|0))break;else v=yb}u=c;return}function Yna(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0;j=u;u=u+304|0;k=j;l=j+296|0;m=j+240|0;n=j+176|0;o=j+232|0;q=j+120|0;r=j+64|0;s=j+48|0;dQ(l,66596);t=g&7;a:do if((GM(a,-1)|0)>=5){switch(g&7){case 2:case 4:break;default:break a}f[k>>2]=0;f[k+4>>2]=0;v=aD(k,89)|0;w=270554;x=v+89|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,k,270644,269810,2677);bD(k)}while(0);do if((yM(a)|0)==65536){y=f[a+4>>2]|0;f[m>>2]=f[y>>2];z=m+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=m+8|0;f[B>>2]=f[y+8>>2];f[m+12>>2]=f[y+12>>2];f[m+16>>2]=f[y+16>>2];f[m+20>>2]=f[y+20>>2];f[m+24>>2]=f[y+24>>2];f[m+28>>2]=f[y+28>>2];f[m+32>>2]=f[y+32>>2];C=f[y+36>>2]|0;f[m+36>>2]=C;f[m+40>>2]=B;B=m+48|0;D=m+44|0;f[D>>2]=B;f[B>>2]=0;f[m+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;jL(m,y);break}}else yL(m,a,-1);while(0);do if((yM(d)|0)==65536){a=f[d+4>>2]|0;f[n>>2]=f[a>>2];y=n+4|0;z=a+4|0;f[y>>2]=f[z>>2];A=n+8|0;f[A>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];B=f[a+36>>2]|0;f[n+36>>2]=B;f[n+40>>2]=A;A=n+48|0;D=n+44|0;f[D>>2]=A;f[A>>2]=0;f[n+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;A=f[D>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(n,a);break}}else yL(n,d,-1);while(0);d=f[e>>2]|0;a=f[e+4>>2]|0;if(!(Y(a,d)|0)){e=f[m+40>>2]|0;E=f[e>>2]|0;F=f[e+4>>2]|0}else{E=a;F=d}f[o>>2]=F;f[o+4>>2]=E;vM(c,o,f[m>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){o=f[c+4>>2]|0;f[q>>2]=f[o>>2];E=q+4|0;F=o+4|0;f[E>>2]=f[F>>2];d=q+8|0;f[d>>2]=f[o+8>>2];f[q+12>>2]=f[o+12>>2];f[q+16>>2]=f[o+16>>2];f[q+20>>2]=f[o+20>>2];f[q+24>>2]=f[o+24>>2];f[q+28>>2]=f[o+28>>2];f[q+32>>2]=f[o+32>>2];a=f[o+36>>2]|0;f[q+36>>2]=a;f[q+40>>2]=d;d=q+48|0;e=q+44|0;f[e>>2]=d;f[d>>2]=0;f[q+52>>2]=0;if(a|0){d=a+12|0;f[d>>2]=(f[d>>2]|0)+1}if((f[F>>2]|0)<3){F=f[o+44>>2]|0;d=f[e>>2]|0;f[d>>2]=f[F>>2];f[d+4>>2]=f[F+4>>2];break}else{f[E>>2]=0;jL(q,o);break}}else yL(q,c,-1);while(0);c=m+12|0;if(!((f[c>>2]|0)>0?(f[m+8>>2]|0)>0:0)){f[k>>2]=0;f[k+4>>2]=0;v=aD(k,28)|0;w=270655;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,k,270644,269810,2691);bD(k)}o=q+16|0;E=m+16|0;if((f[o>>2]|0)==(f[E>>2]|0)){f[r>>2]=1124007936;F=r+4|0;d=r+8|0;e=r+40|0;v=F;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[e>>2]=d;a=r+48|0;y=r+44|0;f[y>>2]=a;f[a>>2]=0;f[r+52>>2]=0;z=k+8|0;f[z>>2]=0;f[z+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=r;SP(m,k);z=r+36|0;A=f[z>>2]|0;if(A|0){D=A+12|0;f[D>>2]=(f[D>>2]|0)+1}D=m+36|0;A=f[D>>2]|0;if(A|0?(B=A+12|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0)kL(m);f[D>>2]=0;A=m+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[A>>2]|0)>0){B=f[m+40>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0;G=f[A>>2]|0}while((C|0)<(G|0));f[m>>2]=f[r>>2];if((G|0)<3)H=41;else H=43}else{f[m>>2]=f[r>>2];H=41}if((H|0)==41){G=f[F>>2]|0;if((G|0)<3){f[A>>2]=G;f[m+8>>2]=f[d>>2];f[c>>2]=f[r+12>>2];d=f[y>>2]|0;G=f[m+44>>2]|0;f[G>>2]=f[d>>2];f[G+4>>2]=f[d+4>>2]}else H=43}if((H|0)==43)jL(m,r);H=r+16|0;f[E>>2]=f[H>>2];f[m+20>>2]=f[r+20>>2];f[m+24>>2]=f[r+24>>2];f[m+28>>2]=f[r+28>>2];f[m+32>>2]=f[r+32>>2];d=f[z>>2]|0;f[D>>2]=d;if(d|0?(D=d+12|0,d=f[D>>2]|0,f[D>>2]=d+-1,(d|0)==1):0)kL(r);f[z>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[F>>2]|0)>0){H=f[e>>2]|0;e=0;do{f[H+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[F>>2]|0))}F=f[y>>2]|0;if((F|0)!=(a|0))UC(F)}v=k;x=v+48|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));F=r+4|0;f[F>>2]=2;a=r+8|0;f[a>>2]=2;f[r+12>>2]=3;y=r+16|0;f[y>>2]=k;f[r+20>>2]=k;e=r+24|0;H=r+40|0;z=e+8|0;f[z>>2]=0;f[z+4>>2]=0;f[H>>2]=a;a=r+48|0;z=r+44|0;f[z>>2]=a;f[r>>2]=1124024326;f[a>>2]=24;f[r+52>>2]=8;f[r+28>>2]=k+48;f[e>>2]=k+48;e=(t|0)==3?1:t;if((((f[n>>2]&4095)+-5|0)>>>0<2?(f[n+8>>2]|0)==2:0)?(f[n+12>>2]|0)==3:0)I=1124024326;else{f[s>>2]=0;f[s+4>>2]=0;v=aD(s,66)|0;w=270684;x=v+66|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,s,270644,269810,2700);bD(s);I=f[r>>2]|0}w=s+8|0;f[w>>2]=0;f[w+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=r;OJ(n,s,I&4095,1.0,0.0);if(!(g&16)){J=+p[k>>3];g=k+32|0;K=+p[g>>3];I=k+8|0;L=+p[I>>3];s=k+24|0;M=+p[s>>3];N=J*K-L*M;O=N!=0.0?1.0/N:0.0;N=K*O;K=J*O;p[k>>3]=N;J=-O;O=L*J;p[I>>3]=O;L=M*J;p[s>>3]=L;p[g>>3]=K;g=k+16|0;J=+p[g>>3];s=k+40|0;M=+p[s>>3];p[g>>3]=-(N*J)-O*M;p[s>>3]=-(J*L)-K*M}s=m+48|0;g=q+48|0;Tna(f[m>>2]&4095,f[E>>2]|0,f[s>>2]|0,f[c>>2]|0,f[m+8>>2]|0,f[o>>2]|0,f[g>>2]|0,f[q+12>>2]|0,f[q+8>>2]|0,k,e,h,i);i=r+36|0;h=f[i>>2]|0;if(h|0?(e=h+12|0,h=f[e>>2]|0,f[e>>2]=h+-1,(h|0)==1):0)kL(r);f[i>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[F>>2]|0)>0){y=f[H>>2]|0;H=0;do{f[y+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[F>>2]|0))}F=f[z>>2]|0;if((F|0)!=(a|0))UC(F);F=q+36|0;a=f[F>>2]|0;if(a|0?(z=a+12|0,a=f[z>>2]|0,f[z>>2]=a+-1,(a|0)==1):0)kL(q);f[F>>2]=0;F=q+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[F>>2]|0)>0){o=f[q+40>>2]|0;a=0;do{f[o+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[F>>2]|0))}F=f[q+44>>2]|0;if((F|0)!=(g|0))UC(F);F=n+36|0;g=f[F>>2]|0;if(g|0?(q=g+12|0,g=f[q>>2]|0,f[q>>2]=g+-1,(g|0)==1):0)kL(n);f[F>>2]=0;F=n+16|0;g=n+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[g>>2]|0)>0){F=f[n+40>>2]|0;q=0;do{f[F+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[g>>2]|0))}g=f[n+44>>2]|0;if((g|0)!=(n+48|0))UC(g);g=m+36|0;n=f[g>>2]|0;do if(n|0){q=n+12|0;F=f[q>>2]|0;f[q>>2]=F+-1;if((F|0)!=1)break;kL(m)}while(0);f[g>>2]=0;g=m+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[g>>2]|0)>0){E=f[m+40>>2]|0;n=0;do{f[E+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[g>>2]|0))}g=f[m+44>>2]|0;if((g|0)!=(s|0))UC(g);if(!(f[l+4>>2]|0)){u=j;return}u=j;return}function Zna(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0;o=u;u=u+336|0;q=o+272|0;r=o+208|0;s=o+216|0;t=o+192|0;v=o+200|0;w=o+32|0;x=o;f[r>>2]=d;f[r+4>>2]=e;JF(q,r,a,b,c);f[t>>2]=i;f[t+4>>2]=j;JF(s,t,a,g,h);h=s+8|0;g=f[h>>2]|0;f[v>>2]=0;f[v+4>>2]=g;y=+p[n+8>>3];z=+p[n+16>>3];A=+p[n+24>>3];p[x>>3]=+p[n>>3];p[x+8>>3]=y;p[x+16>>3]=z;p[x+24>>3]=A;_na(w,q,s,k,l,m,x);x=s+4|0;m=f[x>>2]|0;if((m|0)<3)B=Y(f[s+12>>2]|0,f[h>>2]|0)|0;else{h=f[s+40>>2]|0;l=0;k=1;while(1){n=Y(f[h+(l<<2)>>2]|0,k)|0;l=l+1|0;if((l|0)==(m|0)){B=n;break}else k=n}}RQ(v,w,+(B>>>0)*.0000152587890625);$na(w);w=s+36|0;B=f[w>>2]|0;if(B|0?(v=B+12|0,B=f[v>>2]|0,f[v>>2]=B+-1,(B|0)==1):0)kL(s);f[w>>2]=0;w=s+16|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[s+40>>2]|0;B=0;do{f[w+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[x>>2]|0))}x=f[s+44>>2]|0;if((x|0)!=(s+48|0))UC(x);x=q+36|0;s=f[x>>2]|0;if(s|0?(B=s+12|0,s=f[B>>2]|0,f[B>>2]=s+-1,(s|0)==1):0)kL(q);f[x>>2]=0;x=q+16|0;s=q+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[s>>2]|0)>0){x=f[q+40>>2]|0;B=0;do{f[x+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[s>>2]|0))}s=f[q+44>>2]|0;if((s|0)==(q+48|0)){u=o;return}UC(s);u=o;return}function _na(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0.0,z=0,A=0,B=0.0,C=0;f[a>>2]=66624;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;jL(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;q=a+120|0;f[q>>2]=e;r=a+124|0;f[r>>2]=g;s=+p[h>>3];t=a+128|0;p[t>>3]=s;u=h+8|0;v=+p[u>>3];w=a+136|0;p[w>>3]=v;x=h+16|0;y=+p[x>>3];z=a+144|0;p[z>>3]=y;A=h+24|0;B=+p[A>>3];C=a+152|0;p[C>>3]=B;return}else{f[i>>2]=0;jL(b,c);o=a+116|0;f[o>>2]=d;q=a+120|0;f[q>>2]=e;r=a+124|0;f[r>>2]=g;s=+p[h>>3];t=a+128|0;p[t>>3]=s;u=h+8|0;v=+p[u>>3];w=a+136|0;p[w>>3]=v;x=h+16|0;y=+p[x>>3];z=a+144|0;p[z>>3]=y;A=h+24|0;B=+p[A>>3];C=a+152|0;p[C>>3]=B;return}}function $na(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=66624;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function aoa(a){a=a|0;$na(a);O5b(a);return}function boa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0,pb=0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0,vb=0.0,wb=0.0,xb=0.0,yb=0,zb=0,Ab=0,Bb=0,Cb=0;c=u;u=u+6480|0;e=c+2376|0;g=c+328|0;h=c+272|0;i=c+216|0;j=c+160|0;k=c+104|0;l=c+88|0;m=c+72|0;n=c+56|0;o=c;q=a+60|0;r=f[a+72>>2]|0;s=f[a+68>>2]|0;t=1024/(((s|0)<16?s:16)|0)|0;v=(r|0)<(t|0)?r:t;t=1024/(v|0)|0;w=(s|0)<(t|0)?s:t;t=f[b>>2]|0;s=b+4|0;if((t|0)>=(f[s>>2]|0)){u=c;return}b=(r|0)>0;x=h+4|0;y=h+8|0;z=h+12|0;A=h+16|0;B=h+20|0;C=h+24|0;D=h+28|0;E=h+40|0;F=h+48|0;G=h+44|0;H=i+4|0;I=i+8|0;J=i+40|0;K=i+48|0;L=i+44|0;M=i+52|0;N=k+4|0;O=k+8|0;P=k+12|0;Q=a+120|0;R=a+4|0;S=k+8|0;T=k+12|0;U=k+4|0;V=l+8|0;W=l+4|0;X=m+8|0;Z=m+12|0;_=m+4|0;$=o+4|0;aa=o+8|0;ba=o+40|0;ca=o+48|0;da=o+44|0;ea=o+52|0;fa=n+8|0;ga=n+12|0;ha=n+4|0;ia=a+124|0;ja=a+128|0;ka=o+36|0;la=o+16|0;ma=j+36|0;na=j+16|0;oa=j+4|0;pa=j+40|0;qa=j+44|0;ra=j+48|0;sa=i+36|0;ta=i+16|0;ua=h+36|0;va=k+4|0;wa=k+8|0;xa=k+12|0;ya=k+16|0;za=k+20|0;Aa=k+24|0;Ba=k+28|0;Ca=k+40|0;Da=k+48|0;Ea=k+44|0;Fa=l+8|0;Ga=l+12|0;Ha=l+4|0;Ia=m+8|0;Ja=m+4|0;Ka=n+8|0;La=n+12|0;Ma=n+4|0;Na=o+8|0;Oa=o+12|0;Pa=o+4|0;Qa=k+36|0;Ra=a+116|0;a=C+8|0;Sa=h+52|0;Ta=Aa+8|0;Ua=k+52|0;Va=t;do{if(b){t=0;do{Wa=r-t|0;Xa=(Wa|0)<(v|0)?Wa:v;Wa=(f[s>>2]|0)-Va|0;Ya=(Wa|0)<(w|0)?Wa:w;f[x>>2]=2;f[y>>2]=Ya;f[z>>2]=Xa;f[A>>2]=e;f[B>>2]=e;Wa=a;f[Wa>>2]=0;f[Wa+4>>2]=0;f[E>>2]=y;f[G>>2]=F;Wa=Xa<<2;f[h>>2]=1124024331;f[F>>2]=Wa;f[Sa>>2]=4;Za=e+(Y(Ya,Wa)|0)|0;f[D>>2]=Za;f[C>>2]=Za+(0-Wa)+Wa;f[i>>2]=1124007936;Wa=H;Za=Wa+36|0;do{f[Wa>>2]=0;Wa=Wa+4|0}while((Wa|0)<(Za|0));f[J>>2]=I;f[L>>2]=K;f[K>>2]=0;f[M>>2]=0;f[k>>2]=t;f[N>>2]=Va;f[O>>2]=Xa;f[P>>2]=Ya;nL(j,q,k);_a=f[Q>>2]|0;$a=(_a|0)==0;if((Ya|0)>0){ab=f[Ra>>2]|0;bb=+p[ab>>3];cb=+(t|0);db=cb*bb;eb=+p[ab+8>>3];fb=+p[ab+16>>3];gb=+p[ab+24>>3];hb=cb*gb;ib=+p[ab+32>>3];jb=+p[ab+40>>3];kb=+p[ab+48>>3];lb=cb*kb;cb=+p[ab+56>>3];mb=+p[ab+64>>3];ab=(Xa|0)>0;nb=0;do{ob=Y(nb,Xa)|0;pb=e+(ob<<1<<1)|0;qb=+(nb+Va|0);rb=fb+(db+qb*eb);sb=jb+(hb+qb*ib);tb=mb+(lb+qb*cb);if($a){if(ab){ub=0;do{qb=+(ub|0);vb=tb+qb*kb;wb=vb!=0.0?1.0/vb:0.0;vb=wb*(rb+qb*bb);xb=vb<2147483647.0?vb:2147483647.0;vb=wb*(sb+qb*gb);qb=vb<2147483647.0?vb:2147483647.0;yb=MVb(xb>-2147483648.0?xb:-2147483648.0)|0;zb=MVb(qb>-2147483648.0?qb:-2147483648.0)|0;Ab=ub<<1;d[pb+(Ab<<1)>>1]=(yb+32768|0)>>>0<65536?yb:(yb|0)>0?32767:32768;d[pb+((Ab|1)<<1)>>1]=(zb+32768|0)>>>0<65536?zb:(zb|0)>0?32767:32768;ub=ub+1|0}while((ub|0)<(Xa|0))}}else{ub=g+(ob<<1)|0;if(ab){zb=0;do{qb=+(zb|0);xb=tb+qb*kb;vb=xb!=0.0?32.0/xb:0.0;xb=vb*(rb+qb*bb);wb=xb<2147483647.0?xb:2147483647.0;xb=vb*(sb+qb*gb);qb=xb<2147483647.0?xb:2147483647.0;Ab=MVb(wb>-2147483648.0?wb:-2147483648.0)|0;yb=MVb(qb>-2147483648.0?qb:-2147483648.0)|0;Bb=Ab>>5;Cb=zb<<1;d[pb+(Cb<<1)>>1]=(Bb+32768|0)>>>0<65536?Bb:(Bb|0)>0?32767:32768;Bb=yb>>5;d[pb+((Cb|1)<<1)>>1]=(Bb+32768|0)>>>0<65536?Bb:(Bb|0)>0?32767:32768;d[ub+(zb<<1)>>1]=yb<<5&992|Ab&31;zb=zb+1|0}while((zb|0)<(Xa|0))}}nb=nb+1|0}while((nb|0)<(Ya|0))}if($a){f[S>>2]=0;f[T>>2]=0;f[k>>2]=16842752;f[U>>2]=R;nb=V;f[nb>>2]=0;f[nb+4>>2]=0;f[l>>2]=33619968;f[W>>2]=j;f[X>>2]=0;f[Z>>2]=0;f[m>>2]=16842752;f[_>>2]=h;f[o>>2]=1124007936;Wa=$;Za=Wa+36|0;do{f[Wa>>2]=0;Wa=Wa+4|0}while((Wa|0)<(Za|0));f[ba>>2]=aa;f[da>>2]=ca;f[ca>>2]=0;f[ea>>2]=0;f[fa>>2]=0;f[ga>>2]=0;f[n>>2]=16842752;f[ha>>2]=o;una(k,l,m,n,0,f[ia>>2]|0,ja);Wa=f[ka>>2]|0;if(Wa|0?(Za=Wa+12|0,Wa=f[Za>>2]|0,f[Za>>2]=Wa+-1,(Wa|0)==1):0)kL(o);f[ka>>2]=0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[$>>2]|0)>0){Wa=f[ba>>2]|0;Za=0;do{f[Wa+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[$>>2]|0))}Za=f[da>>2]|0;if((Za|0)!=(ca|0))UC(Za)}else{f[va>>2]=2;f[wa>>2]=Ya;f[xa>>2]=Xa;f[ya>>2]=g;f[za>>2]=g;Za=Ta;f[Za>>2]=0;f[Za+4>>2]=0;f[Ca>>2]=wa;f[Ea>>2]=Da;Za=Xa<<1;f[k>>2]=1124024322;f[Da>>2]=Za;f[Ua>>2]=2;Wa=g+(Y(Ya,Za)|0)|0;f[Ba>>2]=Wa;f[Aa>>2]=Wa+(0-Za)+Za;f[Fa>>2]=0;f[Ga>>2]=0;f[l>>2]=16842752;f[Ha>>2]=R;Za=Ia;f[Za>>2]=0;f[Za+4>>2]=0;f[m>>2]=33619968;f[Ja>>2]=j;f[Ka>>2]=0;f[La>>2]=0;f[n>>2]=16842752;f[Ma>>2]=h;f[Na>>2]=0;f[Oa>>2]=0;f[o>>2]=16842752;f[Pa>>2]=k;una(l,m,n,o,_a,f[ia>>2]|0,ja);Za=f[Qa>>2]|0;if(Za|0?(Wa=Za+12|0,Za=f[Wa>>2]|0,f[Wa>>2]=Za+-1,(Za|0)==1):0)kL(k);f[Qa>>2]=0;f[ya>>2]=0;f[ya+4>>2]=0;f[ya+8>>2]=0;f[ya+12>>2]=0;if((f[va>>2]|0)>0){Za=f[Ca>>2]|0;Wa=0;do{f[Za+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[va>>2]|0))}Wa=f[Ea>>2]|0;if((Wa|0)!=(Da|0))UC(Wa)}Wa=f[ma>>2]|0;if(Wa|0?(Za=Wa+12|0,Wa=f[Za>>2]|0,f[Za>>2]=Wa+-1,(Wa|0)==1):0)kL(j);f[ma>>2]=0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[oa>>2]|0)>0){Wa=f[pa>>2]|0;Za=0;do{f[Wa+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[oa>>2]|0))}Za=f[qa>>2]|0;if((Za|0)!=(ra|0))UC(Za);Za=f[sa>>2]|0;if(Za|0?(Wa=Za+12|0,Za=f[Wa>>2]|0,f[Wa>>2]=Za+-1,(Za|0)==1):0)kL(i);f[sa>>2]=0;f[ta>>2]=0;f[ta+4>>2]=0;f[ta+8>>2]=0;f[ta+12>>2]=0;if((f[H>>2]|0)>0){Za=f[J>>2]|0;Wa=0;do{f[Za+(Wa<<2)>>2]=0;Wa=Wa+1|0}while((Wa|0)<(f[H>>2]|0))}Wa=f[L>>2]|0;if((Wa|0)!=(K|0))UC(Wa);Wa=f[ua>>2]|0;if(Wa|0?(Za=Wa+12|0,Wa=f[Za>>2]|0,f[Za>>2]=Wa+-1,(Wa|0)==1):0)kL(h);f[ua>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[x>>2]|0)>0){Wa=f[E>>2]|0;Za=0;do{f[Wa+(Za<<2)>>2]=0;Za=Za+1|0}while((Za|0)<(f[x>>2]|0))}Za=f[G>>2]|0;if((Za|0)!=(F|0))UC(Za);t=t+v|0}while((r|0)>(t|0))}Va=Va+w|0}while((Va|0)<(f[s>>2]|0));u=c;return}function coa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;j=u;u=u+352|0;k=j;l=j+336|0;m=j+280|0;n=j+216|0;o=j+272|0;p=j+160|0;q=j+104|0;r=j+88|0;s=j+72|0;dQ(l,66636);if(!(EM(a,-1)|0)){f[k>>2]=0;f[k+4>>2]=0;t=aD(k,16)|0;v=270870;w=t+16|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,k,270887,269810,2978);bD(k)}do if((yM(a)|0)==65536){x=f[a+4>>2]|0;f[m>>2]=f[x>>2];y=m+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=m+8|0;f[A>>2]=f[x+8>>2];f[m+12>>2]=f[x+12>>2];f[m+16>>2]=f[x+16>>2];f[m+20>>2]=f[x+20>>2];f[m+24>>2]=f[x+24>>2];f[m+28>>2]=f[x+28>>2];f[m+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[m+36>>2]=B;f[m+40>>2]=A;A=m+48|0;C=m+44|0;f[C>>2]=A;f[A>>2]=0;f[m+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(m,x);break}}else yL(m,a,-1);while(0);do if((yM(d)|0)==65536){a=f[d+4>>2]|0;f[n>>2]=f[a>>2];x=n+4|0;y=a+4|0;f[x>>2]=f[y>>2];z=n+8|0;f[z>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];A=f[a+36>>2]|0;f[n+36>>2]=A;f[n+40>>2]=z;z=n+48|0;C=n+44|0;f[C>>2]=z;f[z>>2]=0;f[n+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[a+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;jL(n,a);break}}else yL(n,d,-1);while(0);d=f[e>>2]|0;a=f[e+4>>2]|0;if(!(Y(a,d)|0)){e=f[m+40>>2]|0;D=f[e>>2]|0;E=f[e+4>>2]|0}else{D=a;E=d}f[o>>2]=E;f[o+4>>2]=D;vM(c,o,f[m>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){o=f[c+4>>2]|0;f[p>>2]=f[o>>2];D=p+4|0;E=o+4|0;f[D>>2]=f[E>>2];d=p+8|0;f[d>>2]=f[o+8>>2];f[p+12>>2]=f[o+12>>2];a=p+16|0;f[a>>2]=f[o+16>>2];f[p+20>>2]=f[o+20>>2];f[p+24>>2]=f[o+24>>2];f[p+28>>2]=f[o+28>>2];f[p+32>>2]=f[o+32>>2];e=f[o+36>>2]|0;f[p+36>>2]=e;f[p+40>>2]=d;d=p+48|0;x=p+44|0;f[x>>2]=d;f[d>>2]=0;f[p+52>>2]=0;if(e|0){d=e+12|0;f[d>>2]=(f[d>>2]|0)+1}if((f[E>>2]|0)<3){E=f[o+44>>2]|0;d=f[x>>2]|0;f[d>>2]=f[E>>2];f[d+4>>2]=f[E+4>>2];F=a;break}else{f[D>>2]=0;jL(p,o);F=a;break}}else{yL(p,c,-1);F=p+16|0}while(0);c=m+16|0;if((f[F>>2]|0)==(f[c>>2]|0)){f[q>>2]=1124007936;a=q+4|0;o=q+8|0;D=q+40|0;t=a;w=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(w|0));f[D>>2]=o;E=q+48|0;d=q+44|0;f[d>>2]=E;f[E>>2]=0;f[q+52>>2]=0;x=k+8|0;f[x>>2]=0;f[x+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=q;SP(m,k);x=q+36|0;e=f[x>>2]|0;if(e|0){y=e+12|0;f[y>>2]=(f[y>>2]|0)+1}y=m+36|0;e=f[y>>2]|0;if(e|0?(z=e+12|0,e=f[z>>2]|0,f[z>>2]=e+-1,(e|0)==1):0)kL(m);f[y>>2]=0;e=m+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[e>>2]|0)>0){z=f[m+40>>2]|0;C=0;do{f[z+(C<<2)>>2]=0;C=C+1|0;G=f[e>>2]|0}while((C|0)<(G|0));f[m>>2]=f[q>>2];if((G|0)<3)H=37;else H=39}else{f[m>>2]=f[q>>2];H=37}if((H|0)==37){G=f[a>>2]|0;if((G|0)<3){f[e>>2]=G;f[m+8>>2]=f[o>>2];f[m+12>>2]=f[q+12>>2];o=f[d>>2]|0;G=f[m+44>>2]|0;f[G>>2]=f[o>>2];f[G+4>>2]=f[o+4>>2]}else H=39}if((H|0)==39)jL(m,q);H=q+16|0;f[c>>2]=f[H>>2];f[m+20>>2]=f[q+20>>2];f[m+24>>2]=f[q+24>>2];f[m+28>>2]=f[q+28>>2];f[m+32>>2]=f[q+32>>2];o=f[x>>2]|0;f[y>>2]=o;if(o|0?(y=o+12|0,o=f[y>>2]|0,f[y>>2]=o+-1,(o|0)==1):0)kL(q);f[x>>2]=0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[a>>2]|0)>0){H=f[D>>2]|0;D=0;do{f[H+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[a>>2]|0))}a=f[d>>2]|0;if((a|0)!=(E|0))UC(a)}a=q+4|0;f[a>>2]=2;E=q+8|0;f[E>>2]=3;f[q+12>>2]=3;d=q+16|0;f[d>>2]=k;f[q+20>>2]=k;D=q+24|0;H=q+40|0;x=D+8|0;f[x>>2]=0;f[x+4>>2]=0;f[H>>2]=E;E=q+48|0;x=q+44|0;f[x>>2]=E;f[q>>2]=1124024326;f[E>>2]=24;f[q+52>>2]=8;f[q+28>>2]=k+72;f[D>>2]=k+72;k=g&7;D=(k|0)==3?1:k;if((((f[n>>2]&4095)+-5|0)>>>0<2?(f[n+8>>2]|0)==3:0)?(f[n+12>>2]|0)==3:0)I=1124024326;else{f[r>>2]=0;f[r+4>>2]=0;t=aD(r,66)|0;v=270903;w=t+66|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,r,270887,269810,3002);bD(r);I=f[q>>2]|0}v=r+8|0;f[v>>2]=0;f[v+4>>2]=0;f[r>>2]=33619968;f[r+4>>2]=q;OJ(n,r,I&4095,1.0,0.0);if(!(g&16)){f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=q;g=s+8|0;f[g>>2]=0;f[g+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=q;+aT(r,s,0)}s=m+48|0;r=p+48|0;Zna(f[m>>2]&4095,f[c>>2]|0,f[s>>2]|0,f[m+12>>2]|0,f[m+8>>2]|0,f[F>>2]|0,f[r>>2]|0,f[p+12>>2]|0,f[p+8>>2]|0,f[d>>2]|0,D,h,i);i=q+36|0;h=f[i>>2]|0;if(h|0?(D=h+12|0,h=f[D>>2]|0,f[D>>2]=h+-1,(h|0)==1):0)kL(q);f[i>>2]=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[a>>2]|0)>0){d=f[H>>2]|0;H=0;do{f[d+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[a>>2]|0))}a=f[x>>2]|0;if((a|0)!=(E|0))UC(a);a=p+36|0;E=f[a>>2]|0;if(E|0?(x=E+12|0,E=f[x>>2]|0,f[x>>2]=E+-1,(E|0)==1):0)kL(p);f[a>>2]=0;a=p+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[a>>2]|0)>0){F=f[p+40>>2]|0;E=0;do{f[F+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[a>>2]|0))}a=f[p+44>>2]|0;if((a|0)!=(r|0))UC(a);a=n+36|0;r=f[a>>2]|0;if(r|0?(p=r+12|0,r=f[p>>2]|0,f[p>>2]=r+-1,(r|0)==1):0)kL(n);f[a>>2]=0;a=n+16|0;r=n+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[r>>2]|0)>0){a=f[n+40>>2]|0;p=0;do{f[a+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[r>>2]|0))}r=f[n+44>>2]|0;if((r|0)!=(n+48|0))UC(r);r=m+36|0;n=f[r>>2]|0;if(n|0?(p=n+12|0,n=f[p>>2]|0,f[p>>2]=n+-1,(n|0)==1):0)kL(m);f[r>>2]=0;r=m+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[r>>2]|0)>0){c=f[m+40>>2]|0;n=0;do{f[c+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[r>>2]|0))}r=f[m+44>>2]|0;if((r|0)!=(s|0))UC(r);if(!(f[l+4>>2]|0)){u=j;return}u=j;return}function doa(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,g=0,h=0,i=0.0,j=0.0,k=0,l=0,m=0,o=0,q=0.0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(h,66656);i=c*.017453292519943295;c=+O(+i)*d;j=+P(+i)*d;f[a>>2]=1124007936;k=a+8|0;l=a+40|0;m=a+4|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[l>>2]=k;k=a+48|0;f[a+44>>2]=k;f[k>>2]=0;f[a+52>>2]=0;f[g>>2]=2;f[g+4>>2]=3;hL(a,2,g,6);g=f[a+16>>2]|0;p[g>>3]=c;p[g+8>>3]=j;d=1.0-c;i=+n[b>>2];q=+n[b+4>>2];p[g+16>>3]=d*i-j*q;p[g+24>>3]=-j;p[g+32>>3]=c;p[g+40>>3]=j*i+d*q;if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function eoa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0;e=u;u=u+800|0;g=e+64|0;h=e+792|0;i=e+736|0;j=e;k=e+680|0;l=e+624|0;m=e+608|0;o=e+592|0;q=e+576|0;dQ(h,66676);f[a>>2]=1124007936;r=a+8|0;s=a+40|0;t=a+4|0;v=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(v|0));f[s>>2]=r;r=a+48|0;f[a+44>>2]=r;f[r>>2]=0;f[a+52>>2]=0;f[g>>2]=3;f[g+4>>2]=3;hL(a,2,g,6);r=a+16|0;a=f[r>>2]|0;f[i>>2]=1124007942;s=i+4|0;f[s>>2]=2;w=i+8|0;f[w>>2]=8;x=i+12|0;f[x>>2]=1;y=i+16|0;f[y>>2]=a;z=i+20|0;f[z>>2]=a;A=i+24|0;B=i+28|0;C=i+40|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[C>>2]=w;D=i+48|0;E=i+44|0;f[E>>2]=D;f[i+52>>2]=0;f[D>>2]=0;if(!a){f[g>>2]=0;f[g+4>>2]=0;t=aD(g,26)|0;F=426262;v=t+26|0;do{b[t>>0]=b[F>>0]|0;t=t+1|0;F=F+1|0}while((t|0)<(v|0));bO(-215,g,426289,431198,500);bD(g);G=f[x>>2]|0;H=f[i>>2]|0;I=f[E>>2]|0;J=f[z>>2]|0}else{G=1;H=1124007942;I=D;J=a}a=G<<3;f[i>>2]=H|16384;f[I>>2]=a;f[I+4>>2]=8;I=J+(Y(f[w>>2]|0,a)|0)|0;f[B>>2]=I;f[A>>2]=I+(0-a)+a;a=k+4|0;f[a>>2]=2;I=k+8|0;f[I>>2]=8;f[k+12>>2]=8;A=k+16|0;f[A>>2]=g;f[k+20>>2]=g;B=k+24|0;w=k+40|0;J=B+8|0;f[J>>2]=0;f[J+4>>2]=0;f[w>>2]=I;I=k+48|0;J=k+44|0;f[J>>2]=I;f[k>>2]=1124024326;f[I>>2]=64;f[k+52>>2]=8;f[k+28>>2]=g+512;f[B>>2]=g+512;B=l+4|0;f[B>>2]=2;H=l+8|0;f[H>>2]=8;f[l+12>>2]=1;G=l+16|0;f[G>>2]=j;f[l+20>>2]=j;z=l+24|0;x=l+40|0;F=z+8|0;f[F>>2]=0;f[F+4>>2]=0;f[x>>2]=H;H=l+48|0;F=l+44|0;f[F>>2]=H;f[l>>2]=1124024326;f[H>>2]=8;f[l+52>>2]=8;f[l+28>>2]=j+64;f[z>>2]=j+64;z=0;do{K=+n[c+(z<<3)>>2];L=K;t=z+4|0;p[g+(t<<6)+24>>3]=L;p[g+(z<<6)>>3]=L;L=+n[c+(z<<3)+4>>2];M=L;p[g+(t<<6)+32>>3]=M;p[g+(z<<6)+8>>3]=M;p[g+(t<<6)+40>>3]=1.0;p[g+(z<<6)+16>>3]=1.0;v=g+(t<<6)|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;v=g+(z<<6)+24|0;M=-K;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;K=+n[d+(z<<3)>>2];p[g+(z<<6)+48>>3]=K*M;N=-L;p[g+(z<<6)+56>>3]=K*N;L=+n[d+(z<<3)+4>>2];p[g+(t<<6)+48>>3]=L*M;p[g+(t<<6)+56>>3]=L*N;p[j+(z<<3)>>3]=K;p[j+(t<<3)>>3]=L;z=z+1|0}while((z|0)!=4);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=k;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=l;z=q+8|0;f[z>>2]=0;f[z+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=i;jT(m,o,q,1)|0;p[(f[r>>2]|0)+64>>3]=1.0;r=l+36|0;q=f[r>>2]|0;if(q|0?(o=q+12|0,q=f[o>>2]|0,f[o>>2]=q+-1,(q|0)==1):0)kL(l);f[r>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[B>>2]|0)>0){G=f[x>>2]|0;x=0;do{f[G+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[B>>2]|0))}B=f[F>>2]|0;if((B|0)!=(H|0))UC(B);B=k+36|0;H=f[B>>2]|0;if(H|0?(F=H+12|0,H=f[F>>2]|0,f[F>>2]=H+-1,(H|0)==1):0)kL(k);f[B>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[a>>2]|0)>0){A=f[w>>2]|0;w=0;do{f[A+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[a>>2]|0))}a=f[J>>2]|0;if((a|0)!=(I|0))UC(a);a=i+36|0;I=f[a>>2]|0;if(I|0?(J=I+12|0,I=f[J>>2]|0,f[J>>2]=I+-1,(I|0)==1):0)kL(i);f[a>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[s>>2]|0)>0){y=f[C>>2]|0;C=0;do{f[y+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[s>>2]|0))}s=f[E>>2]|0;if((s|0)!=(D|0))UC(s);if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function foa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;e=u;u=u+560|0;g=e+48|0;h=e+496|0;i=e;j=e+440|0;k=e+384|0;l=e+368|0;m=e+352|0;o=e+336|0;f[a>>2]=1124007936;q=a+8|0;r=a+40|0;s=a+4|0;t=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));f[r>>2]=q;q=a+48|0;f[a+44>>2]=q;f[q>>2]=0;f[a+52>>2]=0;f[g>>2]=2;f[g+4>>2]=3;hL(a,2,g,6);q=f[a+16>>2]|0;f[h>>2]=1124007942;a=h+4|0;f[a>>2]=2;r=h+8|0;f[r>>2]=6;v=h+12|0;f[v>>2]=1;w=h+16|0;f[w>>2]=q;x=h+20|0;f[x>>2]=q;y=h+24|0;z=h+28|0;A=h+40|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;f[A>>2]=r;B=h+48|0;C=h+44|0;f[C>>2]=B;f[h+52>>2]=0;f[B>>2]=0;if(!q){f[g>>2]=0;f[g+4>>2]=0;s=aD(g,26)|0;D=426262;t=s+26|0;do{b[s>>0]=b[D>>0]|0;s=s+1|0;D=D+1|0}while((s|0)<(t|0));bO(-215,g,426289,431198,500);bD(g);E=f[v>>2]|0;F=f[h>>2]|0;G=f[C>>2]|0;H=f[x>>2]|0}else{E=1;F=1124007942;G=B;H=q}q=E<<3;f[h>>2]=F|16384;f[G>>2]=q;f[G+4>>2]=8;G=H+(Y(f[r>>2]|0,q)|0)|0;f[z>>2]=G;f[y>>2]=G+(0-q)+q;q=j+4|0;f[q>>2]=2;G=j+8|0;f[G>>2]=6;f[j+12>>2]=6;y=j+16|0;f[y>>2]=g;f[j+20>>2]=g;z=j+24|0;r=j+40|0;H=z+8|0;f[H>>2]=0;f[H+4>>2]=0;f[r>>2]=G;G=j+48|0;H=j+44|0;f[H>>2]=G;f[j>>2]=1124024326;f[G>>2]=48;f[j+52>>2]=8;f[j+28>>2]=g+288;f[z>>2]=g+288;z=k+4|0;f[z>>2]=2;F=k+8|0;f[F>>2]=6;f[k+12>>2]=1;E=k+16|0;f[E>>2]=i;f[k+20>>2]=i;x=k+24|0;v=k+40|0;D=x+8|0;f[D>>2]=0;f[D+4>>2]=0;f[v>>2]=F;F=k+48|0;D=k+44|0;f[D>>2]=F;f[k>>2]=1124024326;f[F>>2]=8;f[k+52>>2]=8;f[k+28>>2]=i+48;f[x>>2]=i+48;I=+n[c>>2];p[g+72>>3]=I;p[g>>3]=I;I=+n[c+4>>2];p[g+80>>3]=I;p[g+8>>3]=I;p[g+88>>3]=1.0;p[g+16>>3]=1.0;s=g+24|0;t=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));p[i>>3]=+n[d>>2];p[i+8>>3]=+n[d+4>>2];I=+n[c+8>>2];p[g+168>>3]=I;p[g+96>>3]=I;I=+n[c+12>>2];p[g+176>>3]=I;p[g+104>>3]=I;p[g+184>>3]=1.0;p[g+112>>3]=1.0;x=d+8|0;s=g+120|0;t=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));p[i+16>>3]=+n[x>>2];p[i+24>>3]=+n[d+12>>2];I=+n[c+16>>2];p[g+264>>3]=I;p[g+192>>3]=I;I=+n[c+20>>2];p[g+272>>3]=I;p[g+200>>3]=I;p[g+280>>3]=1.0;p[g+208>>3]=1.0;c=d+16|0;s=g+216|0;t=s+48|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(t|0));p[i+32>>3]=+n[c>>2];p[i+40>>3]=+n[d+20>>2];f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=j;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=k;d=o+8|0;f[d>>2]=0;f[d+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=h;jT(l,m,o,0)|0;o=k+36|0;m=f[o>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)kL(k);f[o>>2]=0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[z>>2]|0)>0){E=f[v>>2]|0;v=0;do{f[E+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[z>>2]|0))}z=f[D>>2]|0;if((z|0)!=(F|0))UC(z);z=j+36|0;F=f[z>>2]|0;if(F|0?(D=F+12|0,F=f[D>>2]|0,f[D>>2]=F+-1,(F|0)==1):0)kL(j);f[z>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[q>>2]|0)>0){y=f[r>>2]|0;r=0;do{f[y+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[q>>2]|0))}q=f[H>>2]|0;if((q|0)!=(G|0))UC(q);q=h+36|0;G=f[q>>2]|0;if(G|0?(H=G+12|0,G=f[H>>2]|0,f[H>>2]=G+-1,(G|0)==1):0)kL(h);f[q>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[a>>2]|0)>0){w=f[A>>2]|0;A=0;do{f[w+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[a>>2]|0))}a=f[C>>2]|0;if((a|0)==(B|0)){u=e;return}UC(a);u=e;return}function goa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+128|0;g=e+64|0;h=e+8|0;i=e;do if((yM(c)|0)==65536){j=f[c+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;jL(g,j);break}}else yL(g,c,-1);while(0);do if((yM(d)|0)==65536){c=f[d+4>>2]|0;f[h>>2]=f[c>>2];j=h+4|0;k=c+4|0;f[j>>2]=f[k>>2];l=h+8|0;f[l>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];f[h+16>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[h+32>>2]=f[c+32>>2];m=f[c+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=l;l=h+48|0;o=h+44|0;f[o>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[c+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;jL(h,c);break}}else yL(h,d,-1);while(0);if(!((wM(g,2,5,1)|0)==4?(wM(h,2,5,1)|0)==4:0)){f[i>>2]=0;f[i+4>>2]=0;d=aD(i,56)|0;c=271191;j=d+56|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(j|0));bO(-215,i,271248,269810,3232);bD(i)}i=g+16|0;c=h+16|0;eoa(a,f[i>>2]|0,f[c>>2]|0);a=h+36|0;d=f[a>>2]|0;if(d|0?(j=d+12|0,d=f[j>>2]|0,f[j>>2]=d+-1,(d|0)==1):0)kL(h);f[a>>2]=0;a=h+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[h+40>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))UC(a);a=g+36|0;h=f[a>>2]|0;if(h|0?(d=h+12|0,h=f[d>>2]|0,f[d>>2]=h+-1,(h|0)==1):0)kL(g);f[a>>2]=0;a=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[g+40>>2]|0;h=0;do{f[i+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)==(g+48|0)){u=e;return}UC(a);u=e;return}function hoa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+128|0;g=e+64|0;h=e+8|0;i=e;do if((yM(c)|0)==65536){j=f[c+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;jL(g,j);break}}else yL(g,c,-1);while(0);do if((yM(d)|0)==65536){c=f[d+4>>2]|0;f[h>>2]=f[c>>2];j=h+4|0;k=c+4|0;f[j>>2]=f[k>>2];l=h+8|0;f[l>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];f[h+16>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[h+32>>2]=f[c+32>>2];m=f[c+36>>2]|0;f[h+36>>2]=m;f[h+40>>2]=l;l=h+48|0;o=h+44|0;f[o>>2]=l;f[l>>2]=0;f[h+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[c+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;jL(h,c);break}}else yL(h,d,-1);while(0);if(!((wM(g,2,5,1)|0)==3?(wM(h,2,5,1)|0)==3:0)){f[i>>2]=0;f[i+4>>2]=0;d=aD(i,56)|0;c=271272;j=d+56|0;do{b[d>>0]=b[c>>0]|0;d=d+1|0;c=c+1|0}while((d|0)<(j|0));bO(-215,i,271329,269810,3239);bD(i)}i=g+16|0;c=h+16|0;foa(a,f[i>>2]|0,f[c>>2]|0);a=h+36|0;d=f[a>>2]|0;if(d|0?(j=d+12|0,d=f[j>>2]|0,f[j>>2]=d+-1,(d|0)==1):0)kL(h);f[a>>2]=0;a=h+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[h+40>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))UC(a);a=g+36|0;h=f[a>>2]|0;if(h|0?(d=h+12|0,h=f[d>>2]|0,f[d>>2]=h+-1,(h|0)==1):0)kL(g);f[a>>2]=0;a=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[g+40>>2]|0;h=0;do{f[i+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)==(g+48|0)){u=e;return}UC(a);u=e;return}function ioa(a){a=a|0;O5b(a);return}function joa(a){a=a|0;NQ(a+12|0,f[a+8>>2]|0);if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function koa(a){a=a|0;Nac(a|0,0,192)|0;return}function loa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0,Sb=0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0,ac=0.0;e=u;u=u+1344|0;g=e+264|0;h=e+256|0;i=e+320|0;j=e+248|0;k=e+192|0;l=e+136|0;m=e+8|0;o=e+120|0;q=e+104|0;r=e;s=e+88|0;dQ(h,66716);t=BL(c,-1)|0;v=t&7;w=t&4088;AL(j,c,-1);if((f[j>>2]|0)>=1?(x=j+4|0,(f[x>>2]|0)>=1):0){do if((yM(c)|0)==65536){y=f[c+4>>2]|0;f[k>>2]=f[y>>2];z=k+4|0;A=y+4|0;f[z>>2]=f[A>>2];B=k+8|0;f[B>>2]=f[y+8>>2];f[k+12>>2]=f[y+12>>2];f[k+16>>2]=f[y+16>>2];f[k+20>>2]=f[y+20>>2];f[k+24>>2]=f[y+24>>2];f[k+28>>2]=f[y+28>>2];f[k+32>>2]=f[y+32>>2];C=f[y+36>>2]|0;f[k+36>>2]=C;f[k+40>>2]=B;B=k+48|0;D=k+44|0;f[D>>2]=B;f[B>>2]=0;f[k+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[y+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;jL(k,y);break}}else yL(k,c,-1);while(0);if((v|1|0)==5&(wM(k,2,-1,1)|0)>-1){Nac(a|0,0,192)|0;c=wM(k,2,-1,1)|0;y=f[k>>2]|0;z=(y&7|0)==5;A=f[k+16>>2]|0;if((y&6|0)!=4){f[g>>2]=0;f[g+4>>2]=0;E=aD(g,44)|0;F=271408;G=E+44|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-215,g,271453,271468,101);bD(g)}if(c|0){y=c+-1|0;if(z){H=+n[A+(y<<3)+4>>2];I=+n[A+(y<<3)>>2]}else{H=+(f[A+(y<<3)+4>>2]|0);I=+(f[A+(y<<3)>>2]|0)}J=I*I;K=H*H;if((c|0)>0)if(z){z=0;N=0.0;O=0.0;P=K;Q=J;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;X=0.0;Z=0.0;_=I;$=H;while(1){aa=_;_=+n[A+(z<<3)>>2];ba=$;$=+n[A+(z<<3)+4>>2];ca=Q;Q=_*_;da=P;P=$*$;ea=aa*$-ba*_;fa=aa+_;ga=ba+$;ha=N+ea;ia=fa*ea;ja=O+ia;ka=ga*ea;la=R+ka;ma=S+ea*(Q+aa*fa);na=Z+ea*(aa*(ba+ga)+_*($+ga));oa=X+ea*(P+ba*ga);pa=W+(ca+Q)*ia;ia=T+(da+P)*ka;ka=V+ea*(ca*(ba*3.0+$)+aa*(_*2.0)*ga+Q*(ba+$*3.0));ga=U+ea*(P*(aa+_*3.0)+(da*(aa*3.0+_)+fa*(ba*($*2.0))));z=z+1|0;if((z|0)==(c|0)){qa=ha;ra=ja;sa=la;ta=ma;ua=ia;va=ga;wa=ka;xa=pa;ya=oa;za=na;break}else{N=ha;O=ja;R=la;S=ma;T=ia;U=ga;V=ka;W=pa;X=oa;Z=na}}}else{z=0;Z=0.0;X=0.0;W=K;K=J;J=0.0;V=0.0;U=0.0;T=0.0;S=0.0;R=0.0;O=0.0;N=0.0;$=I;I=H;while(1){H=$;$=+(f[A+(z<<3)>>2]|0);_=I;I=+(f[A+(z<<3)+4>>2]|0);P=K;K=$*$;Q=W;W=I*I;na=H*I-_*$;oa=H+$;pa=_+I;ka=Z+na;ga=oa*na;ia=X+ga;ma=pa*na;la=J+ma;ja=V+na*(K+H*oa);ha=N+na*(H*(_+pa)+$*(I+pa));ba=O+na*(W+_*pa);fa=R+(P+K)*ga;ga=U+(Q+W)*ma;ma=S+na*(P*(_*3.0+I)+H*($*2.0)*pa+K*(_+I*3.0));pa=T+na*(W*(H+$*3.0)+(Q*(H*3.0+$)+oa*(_*(I*2.0))));z=z+1|0;if((z|0)==(c|0)){qa=ka;ra=ia;sa=la;ta=ja;ua=ga;va=pa;wa=ma;xa=fa;ya=ba;za=ha;break}else{Z=ka;X=ia;J=la;V=ja;U=ga;T=pa;S=ma;R=fa;O=ba;N=ha}}}else{qa=0.0;ra=0.0;sa=0.0;ta=0.0;ua=0.0;va=0.0;wa=0.0;xa=0.0;ya=0.0;za=0.0}if(+L(+qa)>1.1920928955078125e-07){c=qa>0.0;N=c?.16666666666666666:-.16666666666666666;O=c?.08333333333333333:-.08333333333333333;R=c?.05:-.05;S=c?.016666666666666666:-.016666666666666666;T=qa*(c?.5:-.5);p[a>>3]=T;qa=ra*N;p[a+8>>3]=qa;ra=sa*N;p[a+16>>3]=ra;N=ta*O;p[a+24>>3]=N;ta=za*(c?.041666666666666664:-.041666666666666664);p[a+32>>3]=ta;za=ya*O;p[a+40>>3]=za;O=xa*R;p[a+48>>3]=O;xa=wa*S;p[a+56>>3]=xa;wa=va*S;p[a+64>>3]=wa;S=ua*R;p[a+72>>3]=S;c=+L(+T)>2.220446049250313e-16;R=1.0/T;T=c?R:0.0;ua=c?ra*R:0.0;va=c?qa*R:0.0;R=qa*va;ya=N-R;N=qa*ua;qa=ta-N;ta=ra*ua;sa=za-ta;p[a+80>>3]=ya;p[a+88>>3]=qa;p[a+96>>3]=sa;za=O-va*(R+ya*3.0);p[a+104>>3]=za;R=qa+qa;O=xa-va*(ra*va+R)-ua*ya;p[a+112>>3]=O;ra=wa-ua*(N+R)-va*sa;p[a+120>>3]=ra;va=S-ua*(ta+sa*3.0);p[a+128>>3]=va;ta=T*T;ua=ta*+M(+(+L(+T)));p[a+136>>3]=ta*ya;p[a+144>>3]=ta*qa;p[a+152>>3]=ta*sa;p[a+160>>3]=za*ua;p[a+168>>3]=O*ua;p[a+176>>3]=ra*ua;p[a+184>>3]=va*ua}}}else{if(w|0){f[g>>2]=0;f[g+4>>2]=0;E=aD(g,43)|0;F=271540;G=E+43|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-5,g,271584,271468,678);bD(g)}a:do if((v|0)==0|d)Aa=985;else switch(t&7){case 2:{Aa=986;break a;break}case 3:{Aa=987;break a;break}case 5:{Aa=988;break a;break}case 6:{Aa=989;break a;break}default:{f[g>>2]=0;f[g+4>>2]=0;bO(-210,g,271584,271468,693);bD(g);Aa=0;break a}}while(0);f[g>>2]=f[k>>2];t=g+4|0;v=k+4|0;F=f[v>>2]|0;f[t>>2]=F;E=g+8|0;f[E>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];G=g+16|0;f[G>>2]=f[k+16>>2];f[g+20>>2]=f[k+20>>2];f[g+24>>2]=f[k+24>>2];f[g+28>>2]=f[k+28>>2];f[g+32>>2]=f[k+32>>2];w=g+36|0;c=f[k+36>>2]|0;f[w>>2]=c;z=g+40|0;f[z>>2]=E;E=g+48|0;A=g+44|0;f[A>>2]=E;f[E>>2]=0;f[g+52>>2]=0;if(!c)Ba=F;else{F=c+12|0;f[F>>2]=(f[F>>2]|0)+1;Ba=f[v>>2]|0}if((Ba|0)<3){Ba=f[k+44>>2]|0;v=f[A>>2]|0;f[v>>2]=f[Ba>>2];f[v+4>>2]=f[Ba+4>>2]}else{f[t>>2]=0;jL(g,k)}Ba=f[x>>2]|0;if((Ba|0)>0){v=m+4|0;F=m+8|0;c=m+12|0;y=m+4|0;B=m+8|0;D=m+12|0;C=m+16|0;Ca=m+20|0;Da=m+24|0;Ea=m+28|0;Fa=m+40|0;Ga=m+48|0;Ha=m+44|0;Ia=m+52|0;Ja=o+8|0;Ka=o+12|0;La=o+4|0;Ma=q+8|0;Na=q+12|0;Oa=q+4|0;Pa=s+8|0;Qa=s+4|0;Ra=m+36|0;Sa=l+36|0;Ta=l+16|0;Ua=l+4|0;Va=l+40|0;Wa=l+8|0;Xa=l+12|0;Ya=l+44|0;Za=l+20|0;_a=l+24|0;$a=l+28|0;ab=m+32|0;bb=l+32|0;cb=m+8|0;db=m+16|0;eb=m+24|0;fb=m+32|0;gb=m+40|0;hb=m+48|0;ib=m+56|0;jb=m+64|0;kb=m+72|0;lb=l+48|0;mb=Da+8|0;nb=0;ua=0.0;va=0.0;ra=0.0;O=0.0;za=0.0;sa=0.0;ta=0.0;qa=0.0;ya=0.0;T=0.0;ob=Ba;Ba=f[j>>2]|0;while(1){pb=ob-nb|0;qb=(pb|0)<32?pb:32;if((Ba|0)>0){S=+(nb|0);pb=0;R=ua;N=va;wa=ra;xa=O;U=za;V=sa;J=ta;X=qa;Z=ya;I=T;rb=Ba;do{sb=rb-pb|0;tb=(sb|0)<32?sb:32;f[m>>2]=pb;f[v>>2]=nb;f[F>>2]=tb;f[c>>2]=qb;nL(l,g,m);if(d){f[y>>2]=2;f[B>>2]=qb;f[D>>2]=tb;f[C>>2]=i;f[Ca>>2]=i;sb=mb;f[sb>>2]=0;f[sb+4>>2]=0;f[Fa>>2]=B;f[Ha>>2]=Ga;f[m>>2]=1124024320;f[Ga>>2]=tb;f[Ia>>2]=1;sb=i+(Y(qb,tb)|0)|0;f[Ea>>2]=sb;f[Da>>2]=sb+(0-tb)+tb;f[Ja>>2]=0;f[Ka>>2]=0;f[o>>2]=16842752;f[La>>2]=l;p[r>>3]=0.0;f[q>>2]=-1056833530;f[Oa>>2]=r;f[Ma>>2]=1;f[Na>>2]=1;tb=Pa;f[tb>>2]=0;f[tb+4>>2]=0;f[s>>2]=33619968;f[Qa>>2]=m;rF(o,q,s,5);tb=f[Ra>>2]|0;if(tb|0){sb=tb+12|0;f[sb>>2]=(f[sb>>2]|0)+1}sb=f[Sa>>2]|0;do if(sb|0){tb=sb+12|0;ub=f[tb>>2]|0;f[tb>>2]=ub+-1;if((ub|0)!=1)break;kL(l)}while(0);f[Sa>>2]=0;f[Ta>>2]=0;f[Ta+4>>2]=0;f[Ta+8>>2]=0;f[Ta+12>>2]=0;if((f[Ua>>2]|0)>0){sb=f[Va>>2]|0;ub=0;do{f[sb+(ub<<2)>>2]=0;ub=ub+1|0;vb=f[Ua>>2]|0}while((ub|0)<(vb|0));f[l>>2]=f[m>>2];if((vb|0)<3)wb=62;else wb=64}else{f[l>>2]=f[m>>2];wb=62}do if((wb|0)==62){wb=0;ub=f[y>>2]|0;if((ub|0)>=3){wb=64;break}f[Ua>>2]=ub;f[Wa>>2]=f[B>>2];f[Xa>>2]=f[D>>2];ub=f[Ha>>2]|0;sb=f[Ya>>2]|0;f[sb>>2]=f[ub>>2];f[sb+4>>2]=f[ub+4>>2]}while(0);if((wb|0)==64){wb=0;jL(l,m)}f[Ta>>2]=f[C>>2];f[Za>>2]=f[Ca>>2];f[_a>>2]=f[Da>>2];f[$a>>2]=f[Ea>>2];f[bb>>2]=f[ab>>2];ub=f[Ra>>2]|0;f[Sa>>2]=ub;do if(ub|0){sb=ub+12|0;tb=f[sb>>2]|0;f[sb>>2]=tb+-1;if((tb|0)!=1)break;kL(m)}while(0);f[Ra>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[y>>2]|0)>0){ub=f[Fa>>2]|0;tb=0;do{f[ub+(tb<<2)>>2]=0;tb=tb+1|0}while((tb|0)<(f[y>>2]|0))}tb=f[Ha>>2]|0;if((tb|0)!=(Ga|0))UC(tb)}zh[Aa&2047](l,m);$=+p[m>>3];if(d){W=$*.00392156862745098;p[m>>3]=W;K=+p[cb>>3]*.00392156862745098;p[cb>>3]=K;ha=+p[db>>3]*.00392156862745098;p[db>>3]=ha;ba=+p[eb>>3]*.00392156862745098;p[eb>>3]=ba;fa=+p[fb>>3]*.00392156862745098;p[fb>>3]=fa;ma=+p[gb>>3]*.00392156862745098;p[gb>>3]=ma;pa=+p[hb>>3]*.00392156862745098;p[hb>>3]=pa;ga=+p[ib>>3]*.00392156862745098;p[ib>>3]=ga;ja=+p[jb>>3]*.00392156862745098;p[jb>>3]=ja;la=+p[kb>>3]*.00392156862745098;p[kb>>3]=la;xb=W;yb=K;zb=ha;Ab=ba;Bb=fa;Cb=ma;Db=pa;Eb=ga;Fb=ja;Gb=la}else{xb=$;yb=+p[cb>>3];zb=+p[db>>3];Ab=+p[eb>>3];Bb=+p[fb>>3];Cb=+p[gb>>3];Db=+p[hb>>3];Eb=+p[ib>>3];Fb=+p[jb>>3];Gb=+p[kb>>3]}$=+(pb|0);la=$*xb;ja=S*xb;R=R+xb;ga=yb+la;I=I+ga;pa=ja+zb;N=N+pa;wa=wa+(Ab+$*(la+yb*2.0));ma=$*pa;pa=S*yb;xa=xa+(pa+(Bb+ma));U=U+(Cb+S*(ja+zb*2.0));V=V+(Db+$*(Ab*3.0+$*(la+yb*3.0)));J=J+(S*Ab+(Eb+$*(ma+(pa+Bb)*2.0)));X=X+($*Cb+(Fb+S*(S*ga+($*zb+Bb)*2.0)));Z=Z+(S*(S*(ja+zb*3.0)+Cb*3.0)+Gb);tb=f[Sa>>2]|0;do if(tb|0){ub=tb+12|0;sb=f[ub>>2]|0;f[ub>>2]=sb+-1;if((sb|0)!=1)break;kL(l)}while(0);f[Sa>>2]=0;f[Ta>>2]=0;f[Ta+4>>2]=0;f[Ta+8>>2]=0;f[Ta+12>>2]=0;if((f[Ua>>2]|0)>0){tb=f[Va>>2]|0;sb=0;do{f[tb+(sb<<2)>>2]=0;sb=sb+1|0}while((sb|0)<(f[Ua>>2]|0))}sb=f[Ya>>2]|0;if((sb|0)!=(lb|0))UC(sb);pb=pb+32|0;rb=f[j>>2]|0}while((rb|0)>(pb|0));Hb=R;Ib=N;Jb=wa;Kb=xa;Lb=U;Mb=V;Nb=J;Ob=X;Pb=Z;Qb=I;Rb=f[x>>2]|0;Sb=rb}else{Hb=ua;Ib=va;Jb=ra;Kb=O;Lb=za;Mb=sa;Nb=ta;Ob=qa;Pb=ya;Qb=T;Rb=ob;Sb=Ba}nb=nb+32|0;if((Rb|0)<=(nb|0)){Tb=Hb;Ub=Ib;Vb=Jb;Wb=Kb;Xb=Lb;Yb=Mb;Zb=Nb;_b=Ob;$b=Pb;ac=Qb;break}else{ua=Hb;va=Ib;ra=Jb;O=Kb;za=Lb;sa=Mb;ta=Nb;qa=Ob;ya=Pb;T=Qb;ob=Rb;Ba=Sb}}}else{Tb=0.0;Ub=0.0;Vb=0.0;Wb=0.0;Xb=0.0;Yb=0.0;Zb=0.0;_b=0.0;$b=0.0;ac=0.0}Sb=+L(+Tb)>2.220446049250313e-16;Qb=1.0/Tb;T=Sb?Qb:0.0;Pb=Sb?Ub*Qb:0.0;ya=Sb?ac*Qb:0.0;Qb=ac*ya;Ob=Vb-Qb;qa=ac*Pb;Nb=Wb-qa;ta=Ub*Pb;Mb=Xb-ta;sa=Yb-ya*(Qb+Ob*3.0);Qb=Nb+Nb;Lb=Zb-ya*(Ub*ya+Qb)-Pb*Ob;za=_b-Pb*(qa+Qb)-ya*Mb;ya=$b-Pb*(ta+Mb*3.0);ta=T*T;Pb=+M(+(+L(+T)))*ta;p[a>>3]=Tb;p[a+8>>3]=ac;p[a+16>>3]=Ub;p[a+24>>3]=Vb;p[a+32>>3]=Wb;p[a+40>>3]=Xb;p[a+48>>3]=Yb;p[a+56>>3]=Zb;p[a+64>>3]=_b;p[a+72>>3]=$b;p[a+80>>3]=Ob;p[a+88>>3]=Nb;p[a+96>>3]=Mb;p[a+104>>3]=sa;p[a+112>>3]=Lb;p[a+120>>3]=za;p[a+128>>3]=ya;p[a+136>>3]=ta*Ob;p[a+144>>3]=ta*Nb;p[a+152>>3]=ta*Mb;p[a+160>>3]=Pb*sa;p[a+168>>3]=Pb*Lb;p[a+176>>3]=Pb*za;p[a+184>>3]=Pb*ya;Sb=f[w>>2]|0;if(Sb|0?(Ba=Sb+12|0,Sb=f[Ba>>2]|0,f[Ba>>2]=Sb+-1,(Sb|0)==1):0)kL(g);f[w>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[t>>2]|0)>0){G=f[z>>2]|0;z=0;do{f[G+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[t>>2]|0))}t=f[A>>2]|0;if((t|0)!=(E|0))UC(t)}t=k+36|0;E=f[t>>2]|0;if(E|0?(A=E+12|0,E=f[A>>2]|0,f[A>>2]=E+-1,(E|0)==1):0)kL(k);f[t>>2]=0;t=k+16|0;E=k+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[E>>2]|0)>0){t=f[k+40>>2]|0;A=0;do{f[t+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[E>>2]|0))}E=f[k+44>>2]|0;if((E|0)!=(k+48|0))UC(E)}else Nac(a|0,0,192)|0;if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function moa(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0;c=f[a+40>>2]|0;e=f[c+4>>2]|0;g=f[c>>2]|0;if((g|0)>0?(c=f[a+16>>2]|0,h=f[f[a+44>>2]>>2]|0,(e|0)>0):0){a=0;i=0;j=0;k=0;l=0;m=0;n=0;o=0;q=0;r=0;s=0;t=0;u=0;v=0;w=0;x=0;y=0;z=0;A=0;B=0;C=0;do{D=c+(Y(h,a)|0)|0;E=0;F=0;G=0;H=0;I=0;K=0;do{L=d[D+(H<<1)>>1]|0;M=Y(L,H)|0;G=L+G|0;F=M+F|0;L=Y(M,H)|0;E=L+E|0;M=Y(L,H)|0;I=Kac(M|0,((M|0)<0)<<31>>31|0,I|0,K|0)|0;K=J;H=H+1|0}while((H|0)!=(e|0));H=Y(G,a)|0;D=Y(a,a)|0;M=((H|0)<0)<<31>>31;L=cbc(H|0,M|0,D|0,0)|0;z=Kac(z|0,A|0,L|0,J|0)|0;A=J;L=((F|0)<0)<<31>>31;N=cbc(F|0,L|0,D|0,0)|0;B=Kac(B|0,C|0,N|0,J|0)|0;C=J;N=((E|0)<0)<<31>>31;O=cbc(E|0,N|0,a|0,((a|0)<0)<<31>>31|0)|0;i=Kac(i|0,j|0,O|0,J|0)|0;j=J;k=Kac(k|0,l|0,I|0,K|0)|0;l=J;O=Y(G,D)|0;m=Kac(m|0,n|0,O|0,((O|0)<0)<<31>>31|0)|0;n=J;O=Y(F,a)|0;o=Kac(o|0,q|0,O|0,((O|0)<0)<<31>>31|0)|0;q=J;r=Kac(r|0,s|0,E|0,N|0)|0;s=J;t=Kac(t|0,u|0,H|0,M|0)|0;u=J;v=Kac(v|0,w|0,F|0,L|0)|0;w=J;x=Kac(x|0,y|0,G|0,((G|0)<0)<<31>>31|0)|0;y=J;a=a+1|0}while((a|0)!=(g|0));P=+(x>>>0)+4294967296.0*+(y|0);Q=+(v>>>0)+4294967296.0*+(w|0);R=+(t>>>0)+4294967296.0*+(u|0);S=+(r>>>0)+4294967296.0*+(s|0);T=+(o>>>0)+4294967296.0*+(q|0);U=+(m>>>0)+4294967296.0*+(n|0);V=+(k>>>0)+4294967296.0*+(l|0);W=+(i>>>0)+4294967296.0*+(j|0);X=+(B>>>0)+4294967296.0*+(C|0);Z=+(z>>>0)+4294967296.0*+(A|0)}else{P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;X=0.0;Z=0.0}p[b>>3]=P;p[b+8>>3]=Q;p[b+16>>3]=R;p[b+24>>3]=S;p[b+32>>3]=T;p[b+40>>3]=U;p[b+48>>3]=V;p[b+56>>3]=W;p[b+64>>3]=X;p[b+72>>3]=Z;return}function noa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0;c=u;u=u+80|0;d=c;e=f[a+40>>2]|0;g=f[e+4>>2]|0;h=f[e>>2]|0;e=d;i=e+80|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(i|0));if((h|0)<=0){e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}k=f[a+16>>2]|0;l=f[f[a+44>>2]>>2]|0;a=d+72|0;m=d+64|0;o=d+56|0;q=d+48|0;r=d+40|0;s=d+32|0;t=d+24|0;v=d+16|0;w=d+8|0;if((g|0)>0){x=0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;while(1){I=k+(Y(l,x)|0)|0;J=0.0;K=0.0;L=0.0;M=0.0;N=0;do{O=+n[I+(N<<2)>>2];P=+(N|0);Q=P*O;M=M+O;L=L+Q;O=P*Q;K=K+O;J=J+P*O;N=N+1|0}while((N|0)!=(g|0));O=+(x|0);P=O*M;Q=+(Y(x,x)|0);R=Q*P+y;S=Q*L+z;T=O*K+A;U=J+B;V=Q*M+C;Q=O*L+D;O=K+E;W=P+F;P=L+G;X=M+H;x=x+1|0;if((x|0)==(h|0)){Z=R;_=S;$=T;aa=U;ba=V;ca=Q;da=O;ea=W;fa=P;ga=X;break}else{y=R;z=S;A=T;B=U;C=V;D=Q;E=O;F=W;G=P;H=X}}}else{x=0;H=0.0;G=0.0;F=0.0;E=0.0;D=0.0;C=0.0;while(1){B=+(x|0)*0.0;A=+(Y(x,x)|0);z=A*B+H;y=A*0.0;A=y+G;X=B+F;P=y+E;y=B+D;W=B+C;x=x+1|0;if((x|0)==(h|0)){Z=z;_=A;$=X;aa=0.0;ba=P;ca=y;da=0.0;ea=W;fa=0.0;ga=0.0;break}else{H=z;G=A;F=X;E=P;D=y;C=W}}}p[a>>3]=Z;p[m>>3]=_;p[o>>3]=$;p[q>>3]=aa;p[r>>3]=ba;p[s>>3]=ca;p[t>>3]=da;p[v>>3]=ea;p[w>>3]=fa;p[d>>3]=ga;e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}function ooa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0;c=u;u=u+80|0;d=c;e=f[a+40>>2]|0;g=f[e+4>>2]|0;h=f[e>>2]|0;e=d;i=e+80|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(i|0));if((h|0)<=0){e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}k=f[a+16>>2]|0;l=f[f[a+44>>2]>>2]|0;a=d+72|0;m=d+64|0;n=d+56|0;o=d+48|0;q=d+40|0;r=d+32|0;s=d+24|0;t=d+16|0;v=d+8|0;if((g|0)>0){w=0;x=0.0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;while(1){H=k+(Y(l,w)|0)|0;I=0.0;J=0.0;K=0.0;L=0.0;M=0;do{N=+p[H+(M<<3)>>3];O=+(M|0);P=O*N;L=L+N;K=K+P;N=O*P;J=J+N;I=I+O*N;M=M+1|0}while((M|0)!=(g|0));N=+(w|0);O=N*L;P=+(Y(w,w)|0);Q=P*O+x;R=P*K+y;S=N*J+z;T=I+A;U=P*L+B;P=N*K+C;N=J+D;V=O+E;O=K+F;W=L+G;w=w+1|0;if((w|0)==(h|0)){X=Q;Z=R;_=S;$=T;aa=U;ba=P;ca=N;da=V;ea=O;fa=W;break}else{x=Q;y=R;z=S;A=T;B=U;C=P;D=N;E=V;F=O;G=W}}}else{w=0;G=0.0;F=0.0;E=0.0;D=0.0;C=0.0;B=0.0;while(1){A=+(w|0)*0.0;z=+(Y(w,w)|0);y=z*A+G;x=z*0.0;z=x+F;W=A+E;O=x+D;x=A+C;V=A+B;w=w+1|0;if((w|0)==(h|0)){X=y;Z=z;_=W;$=0.0;aa=O;ba=x;ca=0.0;da=V;ea=0.0;fa=0.0;break}else{G=y;F=z;E=W;D=O;C=x;B=V}}}p[a>>3]=X;p[m>>3]=Z;p[n>>3]=_;p[o>>3]=$;p[q>>3]=aa;p[r>>3]=ba;p[s>>3]=ca;p[t>>3]=da;p[v>>3]=ea;p[d>>3]=fa;e=b;j=d;i=e+80|0;do{f[e>>2]=f[j>>2];e=e+4|0;j=j+4|0}while((e|0)<(i|0));u=c;return}function poa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;c=f[a+40>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;if((e|0)>0?(c=f[a+16>>2]|0,g=f[f[a+44>>2]>>2]|0,(d|0)>0):0){a=0;i=0;j=0;k=0;l=0;m=0;n=0;o=0;q=0;r=0;s=0;do{t=c+(Y(g,a)|0)|0;u=0;v=0;w=0;x=0;y=0;do{z=h[t+y>>0]|0;A=Y(z,y)|0;x=z+x|0;w=A+w|0;z=Y(A,y)|0;v=z+v|0;u=(Y(z,y)|0)+u|0;y=y+1|0}while((y|0)!=(d|0));y=Y(x,a)|0;t=Y(a,a)|0;i=i+(Y(y,t)|0)|0;j=j+(Y(w,t)|0)|0;k=k+(Y(v,a)|0)|0;l=l+u|0;m=m+(Y(x,t)|0)|0;n=n+(Y(w,a)|0)|0;o=o+v|0;q=q+y|0;r=r+w|0;s=s+x|0;a=a+1|0}while((a|0)!=(e|0));B=+(s|0);C=+(r|0);D=+(q|0);E=+(o|0);F=+(n|0);G=+(m|0);H=+(l|0);I=+(k|0);J=+(j|0);K=+(i|0)}else{B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;I=0.0;J=0.0;K=0.0}p[b>>3]=B;p[b+8>>3]=C;p[b+16>>3]=D;p[b+24>>3]=E;p[b+32>>3]=F;p[b+40>>3]=G;p[b+48>>3]=H;p[b+56>>3]=I;p[b+64>>3]=J;p[b+72>>3]=K;return}function qoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0;c=f[a+40>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;if((e|0)>0?(c=f[a+16>>2]|0,g=f[f[a+44>>2]>>2]|0,(d|0)>0):0){a=0;h=0;i=0;k=0;l=0;m=0;n=0;o=0;q=0;r=0;s=0;t=0;u=0;v=0;w=0;x=0;y=0;z=0;A=0;B=0;C=0;do{D=c+(Y(g,a)|0)|0;E=0;F=0;G=0;H=0;I=0;K=0;do{L=j[D+(H<<1)>>1]|0;M=Y(L,H)|0;G=L+G|0;F=M+F|0;L=Y(M,H)|0;E=L+E|0;M=Y(L,H)|0;I=Kac(M|0,((M|0)<0)<<31>>31|0,I|0,K|0)|0;K=J;H=H+1|0}while((H|0)!=(d|0));H=Y(G,a)|0;D=Y(a,a)|0;M=((H|0)<0)<<31>>31;L=cbc(H|0,M|0,D|0,0)|0;z=Kac(z|0,A|0,L|0,J|0)|0;A=J;L=((F|0)<0)<<31>>31;N=cbc(F|0,L|0,D|0,0)|0;B=Kac(B|0,C|0,N|0,J|0)|0;C=J;N=((E|0)<0)<<31>>31;O=cbc(E|0,N|0,a|0,((a|0)<0)<<31>>31|0)|0;h=Kac(h|0,i|0,O|0,J|0)|0;i=J;k=Kac(k|0,l|0,I|0,K|0)|0;l=J;O=Y(G,D)|0;m=Kac(m|0,n|0,O|0,((O|0)<0)<<31>>31|0)|0;n=J;O=Y(F,a)|0;o=Kac(o|0,q|0,O|0,((O|0)<0)<<31>>31|0)|0;q=J;r=Kac(r|0,s|0,E|0,N|0)|0;s=J;t=Kac(t|0,u|0,H|0,M|0)|0;u=J;v=Kac(v|0,w|0,F|0,L|0)|0;w=J;x=Kac(x|0,y|0,G|0,((G|0)<0)<<31>>31|0)|0;y=J;a=a+1|0}while((a|0)!=(e|0));P=+(x>>>0)+4294967296.0*+(y|0);Q=+(v>>>0)+4294967296.0*+(w|0);R=+(t>>>0)+4294967296.0*+(u|0);S=+(r>>>0)+4294967296.0*+(s|0);T=+(o>>>0)+4294967296.0*+(q|0);U=+(m>>>0)+4294967296.0*+(n|0);V=+(k>>>0)+4294967296.0*+(l|0);W=+(h>>>0)+4294967296.0*+(i|0);X=+(B>>>0)+4294967296.0*+(C|0);Z=+(z>>>0)+4294967296.0*+(A|0)}else{P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;X=0.0;Z=0.0}p[b>>3]=P;p[b+8>>3]=Q;p[b+16>>3]=R;p[b+24>>3]=S;p[b+32>>3]=T;p[b+40>>3]=U;p[b+48>>3]=V;p[b+56>>3]=W;p[b+64>>3]=X;p[b+72>>3]=Z;return}function roa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0.0,i=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0.0;c=u;u=u+16|0;d=c;dQ(d,66736);e=a+160|0;g=a+176|0;h=+p[e>>3]+ +p[g>>3];i=a+168|0;j=a+184|0;k=+p[i>>3]+ +p[j>>3];l=h*h;m=k*k;n=a+144|0;o=+p[n>>3]*4.0;q=+p[a+136>>3];r=+p[a+152>>3];s=q-r;p[b>>3]=q+r;p[b+8>>3]=s*s+o*+p[n>>3];p[b+24>>3]=l+m;p[b+40>>3]=k*(h*o)+(l-m)*s;s=h*(l-m*3.0);h=k*(l*3.0-m);m=+p[e>>3]-+p[g>>3]*3.0;l=+p[i>>3]*3.0-+p[j>>3];p[b+16>>3]=m*m+l*l;p[b+32>>3]=s*m+h*l;p[b+48>>3]=s*l-h*m;if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function soa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0;i=u;u=u+1568|0;j=i+528|0;k=i+472|0;l=i+232|0;m=i+448|0;o=i+392|0;p=i+336|0;q=i+464|0;r=i+280|0;s=i+456|0;t=i;v=i+8|0;w=i+264|0;dQ(m,66756);do if((yM(a)|0)==65536){x=f[a+4>>2]|0;f[o>>2]=f[x>>2];y=o+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=o+8|0;f[A>>2]=f[x+8>>2];f[o+12>>2]=f[x+12>>2];f[o+16>>2]=f[x+16>>2];f[o+20>>2]=f[x+20>>2];f[o+24>>2]=f[x+24>>2];f[o+28>>2]=f[x+28>>2];f[o+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[o+36>>2]=B;f[o+40>>2]=A;A=o+48|0;C=o+44|0;f[C>>2]=A;f[A>>2]=0;f[o+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(o,x);break}}else yL(o,a,-1);while(0);f[p>>2]=1124007936;a=p+4|0;x=p+8|0;y=p+40|0;z=a;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[y>>2]=x;C=p+48|0;B=p+44|0;f[B>>2]=C;f[C>>2]=0;f[p+52>>2]=0;D=PM(d)|0;if(f[o>>2]&4095|0){f[j>>2]=0;f[j+4>>2]=0;z=aD(j,55)|0;E=271684;A=z+55|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));bO(-215,j,271740,271758,720);bD(j)}F=o+40|0;G=f[F>>2]|0;H=f[G>>2]|0;f[q>>2]=f[G+4>>2];f[q+4>>2]=H;vM(c,q,5,-1,0,0);do if((yM(c)|0)==65536){q=f[c+4>>2]|0;f[r>>2]=f[q>>2];H=r+4|0;G=q+4|0;f[H>>2]=f[G>>2];I=r+8|0;f[I>>2]=f[q+8>>2];f[r+12>>2]=f[q+12>>2];f[r+16>>2]=f[q+16>>2];f[r+20>>2]=f[q+20>>2];f[r+24>>2]=f[q+24>>2];f[r+28>>2]=f[q+28>>2];f[r+32>>2]=f[q+32>>2];J=f[q+36>>2]|0;f[r+36>>2]=J;f[r+40>>2]=I;I=r+48|0;K=r+44|0;f[K>>2]=I;f[I>>2]=0;f[r+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[G>>2]|0)<3){G=f[q+44>>2]|0;I=f[K>>2]|0;f[I>>2]=f[G>>2];f[I+4>>2]=f[G+4>>2];break}else{f[H>>2]=0;jL(r,q);break}}else yL(r,c,-1);while(0);a:do if(D){if((h|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;z=aD(j,62)|0;E=271835;A=z+62|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));bO(-215,j,271740,271758,727);bD(j)}c=f[F>>2]|0;q=f[c>>2]|0;f[s>>2]=f[c+4>>2];f[s+4>>2]=q;vM(d,s,4,-1,0,0);do if((yM(d)|0)==65536){q=f[d+4>>2]|0;f[j>>2]=f[q>>2];c=j+4|0;H=q+4|0;f[c>>2]=f[H>>2];G=j+8|0;f[G>>2]=f[q+8>>2];f[j+12>>2]=f[q+12>>2];f[j+16>>2]=f[q+16>>2];f[j+20>>2]=f[q+20>>2];f[j+24>>2]=f[q+24>>2];f[j+28>>2]=f[q+28>>2];f[j+32>>2]=f[q+32>>2];I=j+36|0;K=f[q+36>>2]|0;f[I>>2]=K;f[j+40>>2]=G;G=j+48|0;J=j+44|0;f[J>>2]=G;f[G>>2]=0;f[j+52>>2]=0;if(K|0){G=K+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[H>>2]|0)<3){H=f[q+44>>2]|0;G=f[J>>2]|0;f[G>>2]=f[H>>2];f[G+4>>2]=f[H+4>>2];L=I;break}else{f[c>>2]=0;jL(j,q);L=I;break}}else{yL(j,d,-1);L=j+36|0}while(0);I=f[L>>2]|0;if(I|0){q=I+12|0;f[q>>2]=(f[q>>2]|0)+1}q=p+36|0;I=f[q>>2]|0;if(I|0?(c=I+12|0,I=f[c>>2]|0,f[c>>2]=I+-1,(I|0)==1):0)kL(p);f[q>>2]=0;I=p+16|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[a>>2]|0)>0){c=f[y>>2]|0;H=0;do{f[c+(H<<2)>>2]=0;H=H+1|0;M=f[a>>2]|0}while((H|0)<(M|0));f[p>>2]=f[j>>2];if((M|0)<3)N=37;else N=39}else{f[p>>2]=f[j>>2];N=37}if((N|0)==37){H=f[j+4>>2]|0;if((H|0)<3){f[a>>2]=H;f[x>>2]=f[j+8>>2];f[p+12>>2]=f[j+12>>2];H=f[j+44>>2]|0;c=f[B>>2]|0;f[c>>2]=f[H>>2];f[c+4>>2]=f[H+4>>2]}else N=39}if((N|0)==39)jL(p,j);H=j+16|0;f[I>>2]=f[H>>2];f[p+20>>2]=f[j+20>>2];f[p+24>>2]=f[j+24>>2];f[p+28>>2]=f[j+28>>2];f[p+32>>2]=f[j+32>>2];c=f[L>>2]|0;f[q>>2]=c;if(c|0?(G=c+12|0,c=f[G>>2]|0,f[G>>2]=c+-1,(c|0)==1):0)kL(j);f[L>>2]=0;c=j+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[c>>2]|0)>0){H=f[j+40>>2]|0;G=0;do{f[H+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[c>>2]|0))}c=f[j+44>>2]|0;if((c|0)!=(j+48|0))UC(c);c=t;f[c>>2]=0;f[c+4>>2]=0;O=5;P=t}else{c=t;f[c>>2]=0;f[c+4>>2]=0;switch(g|0){case 0:case 3:case 5:{O=g;P=t;break a;break}default:{}}f[j>>2]=0;f[j+4>>2]=0;z=aD(j,41)|0;E=271898;A=z+41|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));bO(-201,j,271740,271758,737);bD(j);O=g;P=t}while(0);t=(e|0)==1;if((e|2|0)!=3){P=(e|0)==2&D?5:O;if(!P){O=f[F>>2]|0;g=f[r+40>>2]|0;if(!((f[O>>2]|0)==(f[g>>2]|0)?(f[O+4>>2]|0)==(f[g+4>>2]|0):0)){f[j>>2]=0;f[j+4>>2]=0;z=aD(j,24)|0;E=271940;A=z+24|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));bO(-215,j,271965,271758,560);bD(j)}if(!((f[o>>2]&4095|0)==0?(f[r>>2]&4095|0)==5:0)){f[j>>2]=0;f[j+4>>2]=0;z=aD(j,114)|0;E=271979;A=z+114|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));bO(-215,j,271965,271758,562);bD(j)}g=o+8|0;O=f[g>>2]|0;L=o+12|0;x=f[L>>2]|0;M=O<<1;d=O*3|0;s=(O*12|0)+4+(O<<3)|0;c=x<<3;G=s>>>0<c>>>0?c:s;s=j+8|0;f[j>>2]=s;c=j+4|0;f[c>>2]=G;if(G>>>0>1032){H=N5b(G)|0;f[j>>2]=H;Q=H}else Q=s;H=Q+(M<<2)+3&-4;G=H;q=H;H=(O|0)>0;if(H){I=0;do{R=+(Y(I,I)|0);n[Q+(I<<2)>>2]=R;I=I+1|0}while((I|0)!=(O|0))}if((O|0)<(M|0)){I=O;do{n[Q+(I<<2)>>2]=999999986991104.0;I=I+1|0}while((I|0)!=(M|0))}if(H){H=(M|0)>1?M:1;Nac(q|0,0,H<<2|0)|0;S=H}else S=0;if((S|0)<=(d|0)){H=S;while(1){f[G+(H<<2)>>2]=H-M;if((H|0)<(d|0))H=H+1|0;else break}}f[k>>2]=0;f[k+4>>2]=x;f[l>>2]=66784;f[l+4>>2]=o;f[l+8>>2]=r;H=f[g>>2]|0;f[l+12>>2]=G+(H<<1<<2)+4;f[l+16>>2]=Q;G=f[o+4>>2]|0;if((G|0)<3)T=Y(f[L>>2]|0,H)|0;else{H=f[F>>2]|0;L=0;g=1;while(1){d=Y(f[H+(L<<2)>>2]|0,g)|0;L=L+1|0;if((L|0)==(G|0)){T=d;break}else g=d}}RQ(k,l,+(T>>>0)*.0000152587890625);T=Q+(x<<2)|0;n[Q>>2]=0.0;n[T>>2]=0.0;if((x|0)>1){g=1;do{n[T+(g<<2)>>2]=.5/+(g|0);R=+(Y(g,g)|0);n[Q+(g<<2)>>2]=R;g=g+1|0}while((g|0)!=(x|0))}f[k>>2]=0;f[k+4>>2]=O;f[l>>2]=66804;f[l+4>>2]=r;f[l+8>>2]=Q;f[l+12>>2]=T;RQ(k,l,-1.0);T=f[j>>2]|0;if((T|0)!=(s|0)){if(T|0)P5b(T);f[j>>2]=s;f[c>>2]=1032}}else{U=P;N=80}}else{U=D?5:3;N=80}if((N|0)==80){switch(e|0){case 3:{V=0;break}case 2:case 1:{N=82;break}default:{f[j>>2]=0;f[j+4>>2]=0;z=aD(j,73)|0;E=272094;A=z+73|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));bO(-215,j,271740,271758,780);bD(j);N=82}}if((N|0)==82)V=t?1:2;switch(V+(U*10|0)|0){case 30:{W=65536.0;X=65536.0;Z=0.0;break}case 31:{W=65536.0;X=131072.0;Z=0.0;break}case 32:{W=62586.87890625;X=89738.4453125;Z=0.0;break}case 50:{W=65536.0;X=65536.0;Z=131072.0;break}case 51:{W=65536.0;X=131072.0;Z=196608.0;break}case 52:{W=65536.0;X=91750.3984375;Z=143976.03125;break}default:{f[j>>2]=0;f[j+4>>2]=0;z=aD(j,19)|0;E=272168;A=z+19|0;do{b[z>>0]=b[E>>0]|0;z=z+1|0;E=E+1|0}while((z|0)<(A|0));bO(-5,j,272188,271758,441);bD(j);W=0.0;X=0.0;Z=0.0}}E=f[F>>2]|0;V=(U|0)==3;U=V?2:4;t=(f[E>>2]|0)+U|0;N=(f[E+4>>2]|0)+U|0;f[k>>2]=1124007936;U=k+4|0;E=k+8|0;e=k+40|0;z=U;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[e>>2]=E;E=k+48|0;P=k+44|0;f[P>>2]=E;f[E>>2]=0;f[k+52>>2]=0;f[j>>2]=t;f[j+4>>2]=N;hL(k,2,j,4);b:do if(D){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;f[j>>2]=-1056833530;f[j+4>>2]=l;f[j+8>>2]=1;f[j+12>>2]=4;VP(p,j,UM()|0)|0;if(!h){IS(v,o,0.0);f[j>>2]=1124007936;N=j+4|0;t=j+8|0;c=j+40|0;z=N;A=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(A|0));f[c>>2]=t;s=j+48|0;T=j+44|0;f[T>>2]=s;f[s>>2]=0;f[j+52>>2]=0;Q=f[v>>2]|0;th[f[(f[Q>>2]|0)+12>>2]&511](Q,v,j,-1);Wi(v);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=j;Q=w+8|0;f[Q>>2]=0;f[Q+4>>2]=0;f[w>>2]=33619968;f[w+4>>2]=p;I3(l,w,8,4,0)|0;Q=j+36|0;O=f[Q>>2]|0;if(O|0?(x=O+12|0,O=f[x>>2]|0,f[x>>2]=O+-1,(O|0)==1):0)kL(j);f[Q>>2]=0;Q=j+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[N>>2]|0)>0){Q=f[c>>2]|0;O=0;do{f[Q+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[N>>2]|0))}N=f[T>>2]|0;if((N|0)!=(s|0))UC(N)}else{N=o+8|0;if((f[N>>2]|0)>0){O=o+12|0;Q=f[o+16>>2]|0;c=f[o+44>>2]|0;t=f[p+16>>2]|0;x=0;g=1;G=f[O>>2]|0;while(1){L=Q+(Y(f[c>>2]|0,x)|0)|0;H=t+(Y(f[f[B>>2]>>2]|0,x)|0)|0;if((G|0)>0){d=0;M=g;S=G;while(1){if(!(b[L+d>>0]|0)){f[H+(d<<2)>>2]=M;_=M+1|0;$=f[O>>2]|0}else{_=M;$=S}d=d+1|0;if((d|0)>=($|0)){aa=_;ba=$;break}else{M=_;S=$}}}else{aa=g;ba=G}x=x+1|0;if((x|0)>=(f[N>>2]|0))break;else{g=aa;G=ba}}}}G=LVb(W)|0;g=LVb(X)|0;N=LVb(Z)|0;x=f[o+16>>2]|0;O=f[k+16>>2]|0;t=f[P>>2]|0;c=f[r+16>>2]|0;Q=f[p+16>>2]|0;s=f[o+48>>2]|0;T=(f[E>>2]|0)>>>2;S=(f[r+48>>2]|0)>>>2;M=(f[C>>2]|0)>>>2;d=f[F>>2]|0;H=f[d+4>>2]|0;L=f[d>>2]|0;d=f[e>>2]|0;q=f[d+4>>2]|0;I=f[d>>2]|0;if((q|0)>0){d=O+(Y(f[t>>2]|0,I+-1|0)|0)|0;J=0;do{f[O+(J<<2)>>2]=536870911;f[d+(J<<2)>>2]=536870911;J=J+1|0}while((J|0)!=(q|0));J=f[t>>2]|0;d=O+J|0;K=O+(Y(J,I+-2|0)|0)|0;J=0;do{f[d+(J<<2)>>2]=536870911;f[K+(J<<2)>>2]=536870911;J=J+1|0}while((J|0)!=(q|0))}if((L|0)>0){q=(H|0)>0;J=T<<1;K=M<<1;d=~K;I=1-K|0;t=-2-M|0;ca=~M;da=1-M|0;ea=2-M|0;fa=H+1|0;ga=0;do{ha=Y(ga,s)|0;ia=O+((Y(ga+2|0,T)|0)<<2)+8|0;ja=Y(ga,M)|0;f[ia+(H<<2)>>2]=536870911;f[ia+-4>>2]=536870911;f[ia+(fa<<2)>>2]=536870911;f[ia+-8>>2]=536870911;ka=x+ha|0;ha=Q+(ja<<2)|0;if(q){ja=0;do{if(!(b[ka+ja>>0]|0)){la=0;ma=ia}else{na=ja-J|0;oa=(f[ia+(na+-1<<2)>>2]|0)+N|0;if((oa|0)<536870911){pa=oa;qa=f[ha+(ja+d<<2)>>2]|0}else{pa=536870911;qa=0}oa=(f[ia+(na+1<<2)>>2]|0)+N|0;if((pa|0)>(oa|0)){ra=oa;sa=f[ha+(I+ja<<2)>>2]|0}else{ra=pa;sa=qa}oa=ja-T|0;na=(f[ia+(oa+-2<<2)>>2]|0)+N|0;if((ra|0)>(na|0)){ta=na;ua=f[ha+(t+ja<<2)>>2]|0}else{ta=ra;ua=sa}na=(f[ia+(oa+-1<<2)>>2]|0)+g|0;if((ta|0)>(na|0)){va=na;wa=f[ha+(ja+ca<<2)>>2]|0}else{va=ta;wa=ua}na=(f[ia+(oa<<2)>>2]|0)+G|0;if((va|0)>(na|0)){xa=na;ya=f[ha+(ja-M<<2)>>2]|0}else{xa=va;ya=wa}na=(f[ia+(oa+1<<2)>>2]|0)+g|0;if((xa|0)>(na|0)){za=na;Aa=f[ha+(da+ja<<2)>>2]|0}else{za=xa;Aa=ya}na=(f[ia+(oa+2<<2)>>2]|0)+N|0;if((za|0)>(na|0)){Ba=na;Ca=f[ha+(ea+ja<<2)>>2]|0}else{Ba=za;Ca=Aa}na=ja+-1|0;oa=(f[ia+(na<<2)>>2]|0)+G|0;if((Ba|0)>(oa|0)){Da=oa;Ea=f[ha+(na<<2)>>2]|0}else{Da=Ba;Ea=Ca}f[ia+(ja<<2)>>2]=Da;la=Ea;ma=ha}f[ma+(ja<<2)>>2]=la;ja=ja+1|0}while((ja|0)!=(H|0))}ga=ga+1|0}while((ga|0)!=(L|0));ga=J+-1|0;ea=K+-1|0;da=M+2|0;if(q){ca=L;do{t=ca;ca=ca+-1|0;I=c+((Y(ca,S)|0)<<2)|0;d=O+((Y(t+1|0,T)|0)<<2)+8|0;x=Q+((Y(ca,M)|0)<<2)|0;fa=H;do{s=fa;fa=fa+-1|0;ja=d+(fa<<2)|0;ha=f[ja>>2]|0;ia=x+(fa<<2)|0;if((ha|0)>(G|0)){ka=(f[d+(s+J<<2)>>2]|0)+N|0;na=(ha|0)>(ka|0);oa=na?ka:ha;ka=(f[d+(ga+fa<<2)>>2]|0)+N|0;Fa=(oa|0)>(ka|0);Ga=Fa?ka:oa;oa=fa+T|0;ka=(f[d+(oa+2<<2)>>2]|0)+N|0;Ha=(Ga|0)>(ka|0);Ia=Ha?ka:Ga;Ga=(f[d+(s+T<<2)>>2]|0)+g|0;ka=(Ia|0)>(Ga|0);Ja=ka?Ga:Ia;Ia=(f[d+(oa<<2)>>2]|0)+G|0;Ga=(Ja|0)>(Ia|0);Ka=fa+M|0;La=Ga?Ia:Ja;Ja=(f[d+(oa+-1<<2)>>2]|0)+g|0;Ia=(La|0)>(Ja|0);Ma=Ia?Ja:La;La=(f[d+(oa+-2<<2)>>2]|0)+N|0;oa=(Ma|0)>(La|0);Ja=oa?La:Ma;Ma=(f[d+(s<<2)>>2]|0)+G|0;La=(Ja|0)>(Ma|0);Na=La?Ma:Ja;Ja=f[(La?x+(s<<2)|0:oa?x+(Ka+-2<<2)|0:Ia?x+(Ka+-1<<2)|0:Ga?x+(Ka<<2)|0:ka?x+(s+M<<2)|0:Ha?x+(da+fa<<2)|0:Fa?x+(ea+fa<<2)|0:na?x+(s+K<<2)|0:ia)>>2]|0;f[ja>>2]=Na;f[ia>>2]=Ja;Oa=Na}else Oa=ha;n[I+(fa<<2)>>2]=+(Oa|0)*.0000152587890625}while((s|0)>1)}while((t|0)>1)}}}else{K=LVb(W)|0;ea=LVb(X)|0;if(V){da=f[o+16>>2]|0;M=f[k+16>>2]|0;G=f[r+16>>2]|0;N=f[o+48>>2]|0;g=(f[E>>2]|0)>>>2;T=(f[r+48>>2]|0)>>>2;ga=f[F>>2]|0;J=f[ga+4>>2]|0;H=f[ga>>2]|0;ga=f[e>>2]|0;ca=f[ga+4>>2]|0;if((ca|0)>0){Q=M+(Y(f[f[P>>2]>>2]|0,(f[ga>>2]|0)+-1|0)|0)|0;ga=0;do{f[M+(ga<<2)>>2]=536870911;f[Q+(ga<<2)>>2]=536870911;ga=ga+1|0}while((ga|0)!=(ca|0))}if((H|0)<=0)break;ca=(J|0)>0;if(ca){ga=0;do{Q=Y(ga,N)|0;ga=ga+1|0;O=M+((Y(ga,g)|0)<<2)+4|0;f[O+(J<<2)>>2]=536870911;f[O+-4>>2]=536870911;S=da+Q|0;Q=0;c=536870911;while(1){if(!(b[S+Q>>0]|0))Pa=0;else{L=Q-g|0;q=(f[O+(L+-1<<2)>>2]|0)+ea|0;fa=(f[O+(L<<2)>>2]|0)+K|0;I=(q|0)>(fa|0)?fa:q;q=(f[O+(L+1<<2)>>2]|0)+ea|0;L=(I|0)>(q|0)?q:I;I=c+K|0;Pa=(L|0)>(I|0)?I:L}f[O+(Q<<2)>>2]=Pa;Q=Q+1|0;if((Q|0)==(J|0))break;else c=Pa}}while((ga|0)!=(H|0))}else{ga=0;do{ga=ga+1|0;da=M+((Y(ga,g)|0)<<2)+4|0;f[da+(J<<2)>>2]=536870911;f[da+-4>>2]=536870911}while((ga|0)!=(H|0))}if(ca)Qa=H;else break;while(1){ga=Qa;Qa=Qa+-1|0;da=G+((Y(Qa,T)|0)<<2)|0;N=M+((Y(ga,g)|0)<<2)+4|0;c=J;do{Q=c;c=c+-1|0;O=N+(c<<2)|0;S=f[O>>2]|0;if((S|0)>(K|0)){t=c+g|0;L=(f[N+(Q+g<<2)>>2]|0)+ea|0;I=(S|0)>(L|0)?L:S;L=(f[N+(t<<2)>>2]|0)+K|0;q=(I|0)>(L|0)?L:I;I=(f[N+(t+-1<<2)>>2]|0)+ea|0;t=(q|0)>(I|0)?I:q;q=(f[N+(Q<<2)>>2]|0)+K|0;I=(t|0)>(q|0)?q:t;f[O>>2]=I;Ra=I}else Ra=S;n[da+(c<<2)>>2]=+(Ra|0)*.0000152587890625}while((Q|0)>1);if((ga|0)<=1)break b}}g=LVb(Z)|0;J=f[o+16>>2]|0;M=f[k+16>>2]|0;T=f[P>>2]|0;G=f[r+16>>2]|0;H=f[o+48>>2]|0;ca=(f[E>>2]|0)>>>2;c=(f[r+48>>2]|0)>>>2;da=f[F>>2]|0;N=f[da+4>>2]|0;Q=f[da>>2]|0;da=f[e>>2]|0;S=f[da+4>>2]|0;I=f[da>>2]|0;if((S|0)>0){da=M+(Y(f[T>>2]|0,I+-1|0)|0)|0;O=0;do{f[M+(O<<2)>>2]=536870911;f[da+(O<<2)>>2]=536870911;O=O+1|0}while((O|0)!=(S|0));O=f[T>>2]|0;da=M+O|0;t=M+(Y(O,I+-2|0)|0)|0;O=0;do{f[da+(O<<2)>>2]=536870911;f[t+(O<<2)>>2]=536870911;O=O+1|0}while((O|0)!=(S|0))}if((Q|0)>0){S=(N|0)>0;O=ca<<1;t=N+1|0;if(S){da=0;do{I=Y(da,H)|0;T=M+((Y(da+2|0,ca)|0)<<2)+8|0;f[T+(N<<2)>>2]=536870911;f[T+-4>>2]=536870911;f[T+(t<<2)>>2]=536870911;f[T+-8>>2]=536870911;q=J+I|0;I=0;do{if(!(b[q+I>>0]|0))Sa=0;else{L=I-O|0;fa=(f[T+(L+-1<<2)>>2]|0)+g|0;x=(f[T+(L+1<<2)>>2]|0)+g|0;L=(fa|0)>(x|0)?x:fa;fa=I-ca|0;x=(f[T+(fa+-2<<2)>>2]|0)+g|0;d=(L|0)>(x|0)?x:L;L=(f[T+(fa+-1<<2)>>2]|0)+ea|0;x=(d|0)>(L|0)?L:d;d=(f[T+(fa<<2)>>2]|0)+K|0;L=(x|0)>(d|0)?d:x;x=(f[T+(fa+1<<2)>>2]|0)+ea|0;d=(L|0)>(x|0)?x:L;L=(f[T+(fa+2<<2)>>2]|0)+g|0;fa=(d|0)>(L|0)?L:d;d=(f[T+(I+-1<<2)>>2]|0)+K|0;Sa=(fa|0)>(d|0)?d:fa}f[T+(I<<2)>>2]=Sa;I=I+1|0}while((I|0)!=(N|0));da=da+1|0}while((da|0)!=(Q|0))}else{da=0;do{J=M+((Y(da+2|0,ca)|0)<<2)+8|0;f[J+(N<<2)>>2]=536870911;f[J+-4>>2]=536870911;f[J+(t<<2)>>2]=536870911;f[J+-8>>2]=536870911;da=da+1|0}while((da|0)!=(Q|0))}da=O+-1|0;if(S){t=Q;do{J=t;t=t+-1|0;H=G+((Y(t,c)|0)<<2)|0;I=M+((Y(J+1|0,ca)|0)<<2)+8|0;T=N;do{q=T;T=T+-1|0;ga=I+(T<<2)|0;fa=f[ga>>2]|0;if((fa|0)>(K|0)){d=(f[I+(q+O<<2)>>2]|0)+g|0;L=(fa|0)>(d|0)?d:fa;d=(f[I+(da+T<<2)>>2]|0)+g|0;x=(L|0)>(d|0)?d:L;L=T+ca|0;d=(f[I+(L+2<<2)>>2]|0)+g|0;s=(x|0)>(d|0)?d:x;x=(f[I+(q+ca<<2)>>2]|0)+ea|0;d=(s|0)>(x|0)?x:s;s=(f[I+(L<<2)>>2]|0)+K|0;x=(d|0)>(s|0)?s:d;d=(f[I+(L+-1<<2)>>2]|0)+ea|0;s=(x|0)>(d|0)?d:x;x=(f[I+(L+-2<<2)>>2]|0)+g|0;L=(s|0)>(x|0)?x:s;s=(f[I+(q<<2)>>2]|0)+K|0;x=(L|0)>(s|0)?s:L;f[ga>>2]=x;Ta=x}else Ta=fa;n[H+(T<<2)>>2]=+(Ta|0)*.0000152587890625}while((q|0)>1)}while((J|0)>1)}}}while(0);Ta=k+36|0;Sa=f[Ta>>2]|0;if(Sa|0?(Ra=Sa+12|0,Sa=f[Ra>>2]|0,f[Ra>>2]=Sa+-1,(Sa|0)==1):0)kL(k);f[Ta>>2]=0;Ta=k+16|0;f[Ta>>2]=0;f[Ta+4>>2]=0;f[Ta+8>>2]=0;f[Ta+12>>2]=0;if((f[U>>2]|0)>0){Ta=f[e>>2]|0;e=0;do{f[Ta+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[U>>2]|0))}U=f[P>>2]|0;if((U|0)!=(E|0))UC(U)}U=r+36|0;E=f[U>>2]|0;if(E|0?(P=E+12|0,E=f[P>>2]|0,f[P>>2]=E+-1,(E|0)==1):0)kL(r);f[U>>2]=0;U=r+16|0;E=r+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[E>>2]|0)>0){U=f[r+40>>2]|0;P=0;do{f[U+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[E>>2]|0))}E=f[r+44>>2]|0;if((E|0)!=(r+48|0))UC(E);E=p+36|0;r=f[E>>2]|0;if(r|0?(P=r+12|0,r=f[P>>2]|0,f[P>>2]=r+-1,(r|0)==1):0)kL(p);f[E>>2]=0;E=p+16|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[a>>2]|0)>0){E=f[y>>2]|0;y=0;do{f[E+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[a>>2]|0))}a=f[B>>2]|0;if((a|0)!=(C|0))UC(a);a=o+36|0;C=f[a>>2]|0;if(C|0?(B=C+12|0,C=f[B>>2]|0,f[B>>2]=C+-1,(C|0)==1):0)kL(o);f[a>>2]=0;a=o+16|0;C=o+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[C>>2]|0)>0){a=f[F>>2]|0;F=0;do{f[a+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[C>>2]|0))}C=f[o+44>>2]|0;if((C|0)!=(o+48|0))UC(C);if(!(f[m+4>>2]|0)){u=i;return}u=i;return}function toa(a){a=a|0;O5b(a);return}function uoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0,F=0.0;c=u;u=u+1040|0;d=c;e=f[b>>2]|0;g=f[b+4>>2]|0;b=f[a+4>>2]|0;h=f[b+12>>2]|0;i=(h*12|0)+24|0;j=d+8|0;f[d>>2]=j;k=d+4|0;f[k>>2]=i;if(i>>>0>1032){l=N5b(i)|0;f[d>>2]=l;m=l}else m=j;l=m+(h<<2)|0;i=l+(h<<2)+4+3&-4;a:do if((e|0)<(g|0)){o=f[b+16>>2]|0;p=f[b+44>>2]|0;q=l+4|0;r=(h|0)>0;s=a+8|0;if((h|0)<=1){t=e;while(1){v=o+(Y(f[p>>2]|0,t)|0)|0;f[i>>2]=0;n[l>>2]=-999999986991104.0;n[q>>2]=999999986991104.0;f[m>>2]=f[v>>2];if(r){w=f[s>>2]|0;x=0;y=0;while(1){z=+(x|0);A=y;while(1){B=A+1|0;if(+n[l+(B<<2)>>2]<z)A=B;else break}B=f[i+(A<<2)>>2]|0;C=x-B|0;z=+M(+(+n[w+(((C|0)>-1?C:0-C|0)<<2)>>2]+ +n[m+(B<<2)>>2]));n[v+(x<<2)>>2]=z;x=x+1|0;if((x|0)==(h|0))break;else y=A}}t=t+1|0;if((t|0)==(g|0))break a}}t=f[s>>2]|0;y=f[a+12>>2]|0;x=e;do{v=o+(Y(f[p>>2]|0,x)|0)|0;f[i>>2]=0;n[l>>2]=-999999986991104.0;n[q>>2]=999999986991104.0;f[m>>2]=f[v>>2];w=0;B=1;do{z=+n[v+(B<<2)>>2];n[m+(B<<2)>>2]=z;D=z+ +n[t+(B<<2)>>2];C=w;while(1){E=f[i+(C<<2)>>2]|0;F=(D-+n[v+(E<<2)>>2]-+n[t+(E<<2)>>2])*+n[y+(B-E<<2)>>2];if(F>+n[l+(C<<2)>>2])break;else C=C+-1|0}w=C+1|0;f[i+(w<<2)>>2]=B;n[l+(w<<2)>>2]=F;n[l+(C+2<<2)>>2]=999999986991104.0;B=B+1|0}while((B|0)!=(h|0));if(r){B=0;w=0;while(1){D=+(B|0);A=w;while(1){E=A+1|0;if(+n[l+(E<<2)>>2]<D)A=E;else break}C=f[i+(A<<2)>>2]|0;E=B-C|0;D=+M(+(+n[t+(((E|0)>-1?E:0-E|0)<<2)>>2]+ +n[m+(C<<2)>>2]));n[v+(B<<2)>>2]=D;B=B+1|0;if((B|0)==(h|0))break;else w=A}}x=x+1|0}while((x|0)!=(g|0))}while(0);if((m|0)==(j|0)){u=c;return}P5b(m);f[d>>2]=j;f[k>>2]=1032;u=c;return}function voa(a){a=a|0;O5b(a);return}function woa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+1072|0;e=d;g=f[c>>2]|0;h=f[c+4>>2]|0;c=f[a+4>>2]|0;i=f[c+8>>2]|0;j=f[c+48>>2]|0;k=f[a+8>>2]|0;l=(f[k+48>>2]|0)>>>2;m=e+8|0;f[e>>2]=m;n=e+4|0;f[n>>2]=i;if(i>>>0>264){o=N5b(i>>>0>1073741823?-1:i<<2)|0;f[e>>2]=o;p=o}else p=m;if((g|0)<(h|0)?(o=i+-1|0,q=a+12|0,r=a+16|0,a=0-j|0,(i|0)>0):0){j=f[c+16>>2]|0;s=f[c+44>>2]|0;c=f[k+16>>2]|0;k=g;do{g=o;t=j+(Y(f[s>>2]|0,o)|0)+k|0;v=o;while(1){v=b[t>>0]|0?v+1|0:0;f[p+(g<<2)>>2]=v;if((g|0)<=0)break;else{g=g+-1|0;t=t+a|0}}t=f[q>>2]|0;g=f[r>>2]|0;v=c+(k<<2)|0;w=0;x=o;while(1){y=p+(w<<2)|0;x=x+1-(f[t+(x-(f[y>>2]|0)<<2)>>2]|0)|0;f[y>>2]=x;f[v>>2]=f[g+(x<<2)>>2];w=w+1|0;if((w|0)==(i|0))break;else v=v+(l<<2)|0}k=k+1|0}while((k|0)!=(h|0))}if((p|0)==(m|0)){u=d;return}P5b(p);f[e>>2]=m;f[n>>2]=264;u=d;return}function xoa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;i=u;u=u+400|0;j=i+144|0;k=i+136|0;l=i+128|0;m=i+72|0;n=i+64|0;o=i+8|0;p=i;dQ(p,66816);if((d|0)==1&(g|0)==0){dQ(l,66836);do if((yM(a)|0)==65536){l=f[a+4>>2]|0;f[m>>2]=f[l>>2];g=m+4|0;q=l+4|0;f[g>>2]=f[q>>2];r=m+8|0;f[r>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];s=f[l+36>>2]|0;f[m+36>>2]=s;f[m+40>>2]=r;r=m+48|0;t=m+44|0;f[t>>2]=r;f[r>>2]=0;f[m+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[l+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];v=m;break}else{f[g>>2]=0;jL(m,l);v=m;break}}else{yL(m,a,-1);v=m}while(0);if(f[v>>2]&4095|0){f[j>>2]=0;f[j+4>>2]=0;w=aD(j,55)|0;x=271684;y=w+55|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,j,272336,271758,688);bD(j)}l=m+40|0;g=f[l>>2]|0;q=f[g>>2]|0;f[n>>2]=f[g+4>>2];f[n+4>>2]=q;vM(c,n,0,-1,0,0);do if((yM(c)|0)==65536){n=f[c+4>>2]|0;f[o>>2]=f[n>>2];q=o+4|0;g=n+4|0;f[q>>2]=f[g>>2];r=o+8|0;f[r>>2]=f[n+8>>2];f[o+12>>2]=f[n+12>>2];t=o+16|0;f[t>>2]=f[n+16>>2];f[o+20>>2]=f[n+20>>2];f[o+24>>2]=f[n+24>>2];f[o+28>>2]=f[n+28>>2];f[o+32>>2]=f[n+32>>2];s=f[n+36>>2]|0;f[o+36>>2]=s;f[o+40>>2]=r;r=o+48|0;z=o+44|0;f[z>>2]=r;f[r>>2]=0;f[o+52>>2]=0;if(s|0){A=s+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[g>>2]|0)<3){g=f[n+44>>2]|0;A=f[z>>2]|0;f[A>>2]=f[g>>2];f[A+4>>2]=f[g+4>>2];B=t;C=r;break}else{f[q>>2]=0;jL(o,n);B=t;C=r;break}}else{yL(o,c,-1);B=o+16|0;C=o+48|0}while(0);r=f[m+12>>2]|0;t=f[m+8>>2]|0;n=m+16|0;q=f[n>>2]|0;g=f[B>>2]|0;A=m+48|0;z=f[A>>2]|0;s=f[C>>2]|0;if(!((f[v>>2]&4095|0)==0?!(f[o>>2]&4095|0):0)){f[k>>2]=0;f[k+4>>2]=0;w=aD(k,114)|0;x=272360;y=w+114|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,k,272475,271758,617);bD(k)}v=f[l>>2]|0;D=o+40|0;E=f[D>>2]|0;if((f[v>>2]|0)==(f[E>>2]|0)?(f[v+4>>2]|0)==(f[E+4>>2]|0):0)F=0;else{f[k>>2]=0;f[k+4>>2]=0;w=aD(k,24)|0;x=271940;y=w+24|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,k,272475,271758,618);bD(k);F=0}do{k=F;F=F+1|0;b[j+k>>0]=F>>>0<256?F:(k>>>31)+255|0}while((F|0)!=256);F=((b[q>>0]|0)!=0)<<31>>31;b[g>>0]=F;k=(r|0)>1;if(k){x=1;w=F;do{if(!(b[q+x>>0]|0))G=0;else G=h[j+(w&255)>>0]|0;w=G&255;b[g+x>>0]=w;x=x+1|0}while((x|0)!=(r|0))}do if((t|0)>1){x=0-s|0;w=Y(s,t+-1|0)|0;if(k){H=1;I=g;J=q}else{G=1;F=g;y=q;do{y=y+z|0;F=F+s|0;if(!(b[y>>0]|0))K=0;else K=h[j+(h[F+x>>0]|0)>>0]|0;b[F>>0]=K;G=G+1|0}while((G|0)!=(t|0));L=g+w|0;break}do{J=J+z|0;I=I+s|0;if(!(b[J>>0]|0))M=0;else M=h[j+(h[I+x>>0]|0)>>0]|0;b[I>>0]=M;G=M;F=1;while(1){if(!(b[J+F>>0]|0))N=0;else{y=h[I+(F-s)>>0]|0;N=h[j+((G|0)>(y|0)?y:G)>>0]|0}b[I+F>>0]=N;F=F+1|0;if((F|0)==(r|0))break;else G=N}H=H+1|0}while((H|0)!=(t|0));L=g+w|0}else L=g;while(0);g=r+-1|0;H=r+-2|0;r=(H|0)>-1;if(r){N=h[L+g>>0]|0;I=H;while(1){J=h[j+N>>0]|0;M=L+I|0;z=J-(h[M>>0]|0)+256|0;if(z>>>0<769)O=h[259297+z>>0]|0;else O=0;N=J-O|0;b[M>>0]=N;if((I|0)<=0)break;else I=I+-1|0}}I=t+-2|0;a:do if((I|0)>-1){t=0-s|0;N=s+g|0;if(r){P=I;Q=L}else{O=I;M=L;while(1){M=M+t|0;J=b[j+(h[M+N>>0]|0)>>0]|0;z=M+g|0;K=b[z>>0]|0;b[z>>0]=(J&255)>(K&255)?K:J;if((O|0)<=0)break a;else O=O+-1|0}}while(1){Q=Q+t|0;O=b[j+(h[Q+N>>0]|0)>>0]|0;M=Q+g|0;w=b[M>>0]|0;J=(O&255)>(w&255)?w:O;b[M>>0]=J;M=J&255;J=H;while(1){O=h[Q+(J+s)>>0]|0;w=b[j+(M>>>0>O>>>0?O:M)>>0]|0;O=Q+J|0;K=b[O>>0]|0;z=(w&255)>(K&255)?K:w;b[O>>0]=z;if((J|0)>0){M=z&255;J=J+-1|0}else break}if((P|0)<=0)break;else P=P+-1|0}}while(0);P=o+36|0;Q=f[P>>2]|0;if(Q|0?(j=Q+12|0,Q=f[j>>2]|0,f[j>>2]=Q+-1,(Q|0)==1):0)kL(o);f[P>>2]=0;P=o+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[P>>2]|0)>0){B=f[D>>2]|0;D=0;do{f[B+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[P>>2]|0))}P=f[o+44>>2]|0;if((P|0)!=(C|0))UC(P);P=m+36|0;C=f[P>>2]|0;if(C|0?(o=C+12|0,C=f[o>>2]|0,f[o>>2]=C+-1,(C|0)==1):0)kL(m);f[P>>2]=0;P=m+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[P>>2]|0)>0){n=f[l>>2]|0;l=0;do{f[n+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[P>>2]|0))}P=f[m+44>>2]|0;if((P|0)!=(A|0))UC(P)}else soa(a,c,UM()|0,d,e,1);if(!(f[p+4>>2]|0)){u=i;return}u=i;return}function yoa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=80068;b=a+268|0;c=a+304|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+284|0;b=a+272|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+308>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+312>>2]|0;if((b|0)!=(a+316|0))UC(b);b=a+212|0;d=a+248|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+228|0;b=a+216|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+252>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+256>>2]|0;if((b|0)!=(a+260|0))UC(b);b=a+156|0;c=a+192|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+172|0;b=a+160|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+196>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+200>>2]|0;if((b|0)!=(a+204|0))UC(b);b=a+100|0;d=a+136|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+116|0;b=a+104|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+140>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+144>>2]|0;if((b|0)!=(a+148|0))UC(b);b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+16>>2]|0;if(b|0){d=a+20|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~(((c+-12-b|0)>>>0)/12|0)*12|0);O5b(b)}b=f[a+4>>2]|0;if(!b)return;c=a+8|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~(((a+-44-b|0)>>>0)/44|0)*44|0);O5b(b);return}function zoa(a){a=a|0;yoa(a);O5b(a);return}function Aoa(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;j=u;u=u+2208|0;k=j+1136|0;l=j+1072|0;m=j+1064|0;o=j+1080|0;q=j;r=a+324|0;f[r>>2]=c;s=a+52|0;f[s>>2]=f[i>>2];t=a+56|0;f[t>>2]=f[i+4>>2];i=a+28|0;b[i>>0]=h&1;h=f[(f[c>>2]|0)+52>>2]|0;f[l>>2]=f[e>>2];v=e+4|0;f[l+4>>2]=f[v>>2];f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];Wg[h&127](c,d,a+212|0,a+268|0,l,m);m=f[v>>2]|0;f[a+92>>2]=f[e>>2];f[a+96>>2]=m;m=f[r>>2]|0;e=f[m+4>>2]|0;f[a+44>>2]=e;v=f[m+8>>2]|0;f[a+48>>2]=v;l=f[m+12>>2]|0;d=f[m+16>>2]|0;c=f[m+20>>2]|0;h=f[m+24>>2]|0;g=f[m+28>>2]|0;w=f[m+32>>2]|0;x=f[m+36>>2]|0;m=Y(d,l)|0;y=a+60|0;f[y>>2]=((e-l|0)/(c|0)|0)+1;e=a+64|0;f[e>>2]=((v-d|0)/(h|0)|0)+1;z=(l|0)/(g|0)|0;A=(d|0)/(w|0)|0;B=a+68|0;f[B>>2]=z;C=a+72|0;f[C>>2]=A;D=Y(Y(z,x)|0,A)|0;A=a+76|0;f[A>>2]=D;do if(b[i>>0]|0){z=(((f[a+224>>2]|0)-l|0)/(f[s>>2]|0)|0)+1|0;E=((v|0)/(f[t>>2]|0)|0)+1|0;F=a+100|0;G=Y(z,D)|0;if(!(((((f[a+104>>2]|0)<3?(f[a+108>>2]|0)==(E|0):0)?(f[a+112>>2]|0)==(G|0):0)?(f[F>>2]&4095|0)==5:0)?(f[a+116>>2]|0)!=0:0)){f[k>>2]=E;f[k+4>>2]=G;hL(F,2,k,5)}F=a+156|0;if(!(((((f[a+160>>2]|0)<3?(f[a+164>>2]|0)==(E|0):0)?(f[a+168>>2]|0)==(z|0):0)?(f[F>>2]&4095|0)==0:0)?(f[a+172>>2]|0)!=0:0)){f[k>>2]=E;f[k+4>>2]=z;hL(F,2,k,0)}F=f[a+108>>2]|0;z=a+32|0;E=a+36|0;G=f[E>>2]|0;H=f[z>>2]|0;I=G-H>>2;J=H;H=G;if(F>>>0<=I>>>0){if(F>>>0<I>>>0?(G=J+(F<<2)|0,(H|0)!=(G|0)):0)f[E>>2]=H+(~((H+-4-G|0)>>>2)<<2);if(!F)break}else HC(z,F-I|0);Nac(f[z>>2]|0,-1,F<<2|0)|0}while(0);f[o>>2]=1124007936;D=o+4|0;t=o+8|0;v=o+40|0;s=D;i=s+36|0;do{f[s>>2]=0;s=s+4|0}while((s|0)<(i|0));f[v>>2]=t;t=o+48|0;F=o+44|0;f[F>>2]=t;f[t>>2]=0;f[o+52>>2]=0;f[k>>2]=d;f[k+4>>2]=l;hL(o,2,k,5);z=f[r>>2]|0;K=+p[z+48>>3];if(K>0.0)L=K;else L=+((f[z+16>>2]|0)+(f[z+12>>2]|0)|0)*.125;K=L;L=1.0/(K*K*2.0);z=k+8|0;f[k>>2]=z;r=k+4|0;f[r>>2]=d;if(d>>>0>264){I=N5b(d>>>0>1073741823?-1:d<<2)|0;f[k>>2]=I;M=I}else M=z;I=q+8|0;f[q>>2]=I;G=q+4|0;f[G>>2]=l;if(l>>>0>264){H=N5b(l>>>0>1073741823?-1:l<<2)|0;f[q>>2]=H;N=H}else N=I;K=+(d|0)*.5;O=+(l|0)*.5;H=(d|0)>0;if(H){E=0;do{P=+(E|0)-K;n[M+(E<<2)>>2]=P*P;E=E+1|0}while((E|0)!=(d|0))}E=(l|0)>0;if(E){J=0;do{K=+(J|0)-O;n[N+(J<<2)>>2]=K*K;J=J+1|0}while((J|0)!=(l|0))}if(H?(J=f[o+16>>2]|0,E):0){Q=f[f[F>>2]>>2]|0;R=0;do{S=M+(R<<2)|0;T=J+(Y(Q,R)|0)|0;U=0;do{O=+V(+-(L*(+n[S>>2]+ +n[N+(U<<2)>>2])));n[T+(U<<2)>>2]=O;U=U+1|0}while((U|0)!=(l|0));R=R+1|0}while((R|0)!=(d|0))}if((N|0)==(I|0))W=M;else{P5b(N);N=f[k>>2]|0;f[q>>2]=I;f[G>>2]=264;W=N}if((W|0)!=(z|0)){if(W|0)P5b(W);f[k>>2]=z;f[r>>2]=264}r=a+16|0;z=Y(f[e>>2]|0,f[y>>2]|0)|0;k=a+20|0;W=f[k>>2]|0;N=f[r>>2]|0;G=(W-N|0)/12|0;I=N;N=W;if(z>>>0<=G>>>0){if(z>>>0<G>>>0?(W=I+(z*12|0)|0,(N|0)!=(W|0)):0)f[k>>2]=N+(~(((N+-12-W|0)>>>0)/12|0)*12|0)}else Coa(r,z-G|0);G=a+4|0;z=m*3|0;W=a+8|0;N=f[W>>2]|0;k=f[G>>2]|0;I=(N-k|0)/44|0;q=k;k=N;if(z>>>0<=I>>>0){if(z>>>0<I>>>0?(N=q+(z*44|0)|0,(k|0)!=(N|0)):0)f[W>>2]=k+(~(((k+-44-N|0)>>>0)/44|0)*44|0)}else Doa(G,z-I|0);I=a+88|0;f[I>>2]=0;z=a+84|0;f[z>>2]=0;N=a+80|0;f[N>>2]=0;if(E){L=+(g|0);O=+(w|0);w=m<<1;g=a+224|0;E=a+280|0;a=f[o+16>>2]|0;k=f[F>>2]|0;W=0;do{if(H){K=(+(W|0)+.5)/L+-.5;q=~~K;M=q-(+(q|0)>K&1)|0;q=M+1|0;P=K-+(M|0);K=1.0-P;R=0;do{X=(+(R|0)+.5)/O+-.5;Q=~~X;J=Q-(+(Q|0)>X&1)|0;Q=J+1|0;Z=X-+(J|0);U=f[B>>2]|0;T=M>>>0<U>>>0;do if(T&q>>>0<U>>>0){S=f[C>>2]|0;_=J>>>0<S>>>0;if(_&Q>>>0<S>>>0){$=f[I>>2]|0;f[I>>2]=$+1;aa=$+w|0;$=f[G>>2]|0;ba=Y((Y(S,M)|0)+J|0,x)|0;f[$+(aa*44|0)+8>>2]=ba;X=1.0-Z;n[$+(aa*44|0)+24>>2]=K*X;ba=Y((Y(f[C>>2]|0,q)|0)+J|0,x)|0;f[$+(aa*44|0)+12>>2]=ba;n[$+(aa*44|0)+28>>2]=P*X;ba=Y((Y(f[C>>2]|0,M)|0)+Q|0,x)|0;f[$+(aa*44|0)+16>>2]=ba;n[$+(aa*44|0)+32>>2]=K*Z;ba=Y((Y(f[C>>2]|0,q)|0)+Q|0,x)|0;f[$+(aa*44|0)+20>>2]=ba;ca=$+(aa*44|0)|0;da=3;ea=P*Z;break}else{aa=f[z>>2]|0;f[z>>2]=aa+1;$=aa+m|0;aa=f[G>>2]|0;X=_?1.0-Z:Z;ba=_?J:Q;_=Y(ba+(Y(S,M)|0)|0,x)|0;f[aa+($*44|0)+8>>2]=_;n[aa+($*44|0)+24>>2]=K*X;_=Y((Y(f[C>>2]|0,q)|0)+ba|0,x)|0;f[aa+($*44|0)+12>>2]=_;n[aa+($*44|0)+28>>2]=P*X;f[aa+($*44|0)+20>>2]=0;f[aa+($*44|0)+16>>2]=0;n[aa+($*44|0)+36>>2]=0.0;ca=aa+($*44|0)|0;da=2;ea=0.0;break}}else{X=T?K:P;$=T?M:q;aa=f[C>>2]|0;_=J>>>0<aa>>>0;if(_&Q>>>0<aa>>>0){ba=f[z>>2]|0;f[z>>2]=ba+1;S=ba+m|0;ba=f[G>>2]|0;fa=Y((Y(aa,$)|0)+J|0,x)|0;f[ba+(S*44|0)+8>>2]=fa;n[ba+(S*44|0)+24>>2]=(1.0-Z)*X;fa=Y((Y(f[C>>2]|0,$)|0)+Q|0,x)|0;f[ba+(S*44|0)+12>>2]=fa;n[ba+(S*44|0)+28>>2]=Z*X;f[ba+(S*44|0)+20>>2]=0;f[ba+(S*44|0)+16>>2]=0;n[ba+(S*44|0)+36>>2]=0.0;ca=ba+(S*44|0)|0;da=2;ea=0.0;break}else{S=f[N>>2]|0;f[N>>2]=S+1;ba=f[G>>2]|0;fa=Y((_?J:Q)+(Y(aa,$)|0)|0,x)|0;f[ba+(S*44|0)+8>>2]=fa;n[ba+(S*44|0)+24>>2]=X*(_?1.0-Z:Z);f[ba+(S*44|0)+20>>2]=0;f[ba+(S*44|0)+16>>2]=0;f[ba+(S*44|0)+12>>2]=0;n[ba+(S*44|0)+36>>2]=0.0;n[ba+(S*44|0)+32>>2]=0.0;ca=ba+(S*44|0)|0;da=1;ea=0.0;break}}while(0);n[ca+24+(da<<2)>>2]=ea;Q=(Y(f[g>>2]|0,R)|0)+W<<1;f[ca>>2]=Q;Q=(Y(f[E>>2]|0,R)|0)+W<<1;f[ca+4>>2]=Q;Q=a+(Y(f[k>>2]|0,R)|0)+(W<<2)|0;f[ca+40>>2]=f[Q>>2];R=R+1|0}while((R|0)!=(d|0))}W=W+1|0}while((W|0)!=(l|0));l=f[z>>2]|0;if((l|0)>0){W=0;do{d=f[G>>2]|0;s=d+(((f[N>>2]|0)+W|0)*44|0)|0;ga=d+((W+m|0)*44|0)|0;i=s+44|0;do{f[s>>2]=f[ga>>2];s=s+4|0;ga=ga+4|0}while((s|0)<(i|0));W=W+1|0;d=f[z>>2]|0}while((W|0)<(d|0));ha=d}else ha=l}else ha=0;l=f[I>>2]|0;if((l|0)>0){W=m<<1;m=f[G>>2]|0;s=m+(((f[N>>2]|0)+ha|0)*44|0)|0;ga=m+(W*44|0)|0;i=s+44|0;do{f[s>>2]=f[ga>>2];s=s+4|0;ga=ga+4|0}while((s|0)<(i|0));m=f[I>>2]|0;if((m|0)>1){d=1;do{ca=f[G>>2]|0;s=ca+(((f[N>>2]|0)+d+(f[z>>2]|0)|0)*44|0)|0;ga=ca+((d+W|0)*44|0)|0;i=s+44|0;do{f[s>>2]=f[ga>>2];s=s+4|0;ga=ga+4|0}while((s|0)<(i|0));d=d+1|0;ca=f[I>>2]|0}while((d|0)<(ca|0));ia=ca}else ia=m;ja=ia;ka=f[z>>2]|0}else{ja=l;ka=ha}ha=ka+(f[N>>2]|0)|0;f[z>>2]=ha;f[I>>2]=ha+ja;ja=f[y>>2]|0;if((ja|0)>0?(y=f[e>>2]|0,(y|0)>0):0){e=f[r>>2]|0;r=f[A>>2]|0;A=0;do{ha=Y(A,c)|0;I=Y(y,A)|0;z=0;do{N=I+z|0;ka=Y(r,N)|0;f[e+(N*12|0)>>2]=ka;ka=Y(z,h)|0;f[e+(N*12|0)+4>>2]=ha;f[e+(N*12|0)+8>>2]=ka;z=z+1|0}while((z|0)<(y|0));A=A+1|0}while((A|0)<(ja|0))}ja=o+36|0;A=f[ja>>2]|0;if(A|0?(y=A+12|0,A=f[y>>2]|0,f[y>>2]=A+-1,(A|0)==1):0)kL(o);f[ja>>2]=0;ja=o+16|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[D>>2]|0)>0){ja=f[v>>2]|0;v=0;do{f[ja+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[D>>2]|0))}D=f[F>>2]|0;if((D|0)==(t|0)){u=j;return}UC(D);u=j;return}function Boa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,q=0,r=0.0,t=0.0,v=0,w=0,x=0,y=0.0,z=0;c=u;u=u+16|0;d=c+4|0;e=c;g=f[a+76>>2]|0;h=g+-4|0;i=0;j=0.0;k=0.0;l=0.0;m=0.0;do{o=+n[b+(i<<2)>>2];j=j+o*o;o=+n[b+((i|1)<<2)>>2];k=k+o*o;o=+n[b+((i|2)<<2)>>2];l=l+o*o;o=+n[b+((i|3)<<2)>>2];m=m+o*o;i=i+4|0}while(i>>>0<=h>>>0);o=m+l+(k+j);if(i>>>0<g>>>0){j=o;q=i;while(1){k=+n[b+(q<<2)>>2];l=j+k*k;q=q+1|0;if((q|0)==(g|0)){r=l;break}else j=l}}else r=o;o=1.0/(+(g>>>0)*.10000000149011612+ +M(+r));r=+p[(f[a+324>>2]|0)+64>>3];n[d>>2]=r;a=0;j=0.0;l=0.0;k=0.0;m=0.0;do{q=b+(a<<2)|0;t=o*+n[q>>2];n[e>>2]=t;i=f[(r<t?d:e)>>2]|0;f[q>>2]=i;q=b+((a|1)<<2)|0;t=o*+n[q>>2];n[e>>2]=t;v=f[(r<t?d:e)>>2]|0;f[q>>2]=v;q=b+((a|2)<<2)|0;t=o*+n[q>>2];n[e>>2]=t;w=f[(r<t?d:e)>>2]|0;f[q>>2]=w;q=b+((a|3)<<2)|0;t=o*+n[q>>2];n[e>>2]=t;x=f[(r<t?d:e)>>2]|0;f[q>>2]=x;t=(f[s>>2]=i,+n[s>>2]);j=j+t*t;t=(f[s>>2]=v,+n[s>>2]);l=l+t*t;t=(f[s>>2]=w,+n[s>>2]);k=k+t*t;t=(f[s>>2]=x,+n[s>>2]);m=m+t*t;a=a+4|0}while(a>>>0<=h>>>0);t=m+k+(l+j);if(a>>>0<g>>>0){j=t;h=a;while(1){a=b+(h<<2)|0;l=o*+n[a>>2];n[e>>2]=l;x=f[(r<l?d:e)>>2]|0;f[a>>2]=x;l=(f[s>>2]=x,+n[s>>2]);k=j+l*l;h=h+1|0;if((h|0)==(g|0)){y=k;break}else j=k}}else y=t;t=1.0/(+M(+y)+1.0000000474974513e-03);if(!g){u=c;return}else z=0;do{h=b+(z<<2)|0;n[h>>2]=t*+n[h>>2];z=z+1|0}while((z|0)!=(g|0));u=c;return}function Coa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(((d-g|0)/12|0)>>>0>=b>>>0){Nac(g|0,0,b*12|0)|0;f[e>>2]=h+(b*12|0);return}i=f[a>>2]|0;j=(g-i|0)/12|0;g=j+b|0;k=i;if(g>>>0>357913941)c4b(a);l=(d-i|0)/12|0;d=l<<1;m=l>>>0<178956970?(d>>>0<g>>>0?g:d):357913941;do if(m)if(m>>>0>357913941){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{n=L5b(m*12|0)|0;break}else n=0;while(0);d=n+(j*12|0)|0;j=n+(m*12|0)|0;Nac(d|0,0,b*12|0)|0;m=d+(b*12|0)|0;if((h|0)==(k|0)){o=d;p=i}else{i=h;h=d;do{d=i;i=i+-12|0;f[h+-12>>2]=f[i>>2];f[h+-8>>2]=f[d+-8>>2];f[h+-4>>2]=f[d+-4>>2];h=h+-12|0}while((i|0)!=(k|0));o=h;p=f[a>>2]|0}f[a>>2]=o;f[e>>2]=m;f[c>>2]=j;if(!p)return;O5b(p);return}function Doa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/44|0)>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+44|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/44|0;g=i+b|0;if(g>>>0>97612893)c4b(a);l=(d-h|0)/44|0;h=l<<1;d=l>>>0<48806446?(h>>>0<g>>>0?g:h):97612893;do if(d)if(d>>>0>97612893){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{m=L5b(d*44|0)|0;break}else m=0;while(0);h=m+(i*44|0)|0;i=m+(d*44|0)|0;d=b;b=h;m=h;do{j=b;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+44|0;m=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;j=h+(((b|0)/-44|0)*44|0)|0;if((b|0)>0)Vac(j|0,d|0,b|0)|0;f[a>>2]=j;f[e>>2]=m;f[c>>2]=i;if(!d)return;O5b(d);return}function Eoa(a){a=a|0;var b=0,c=0;f[a>>2]=80092;hI(a+88|0);b=f[a+76>>2]|0;if(!b)return;c=a+80|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);O5b(b);return}function Foa(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=80092;hI(a+88|0);b=f[a+76>>2]|0;if(!b){O5b(a);return}c=a+80|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);O5b(a);return}function Goa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0;d=u;u=u+128|0;e=d+112|0;g=d+56|0;h=d;do if((yM(c)|0)==65536){i=f[c+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];f[g+16>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[g+36>>2]=m;f[g+40>>2]=l;l=g+48|0;o=g+44|0;f[o>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];break}else{f[j>>2]=0;jL(g,i);break}}else yL(g,c,-1);while(0);c=a+76|0;i=e+8|0;f[i>>2]=0;f[i+4>>2]=0;f[e>>2]=-2113732603;f[e+4>>2]=c;OJ(g,e,5,1.0,0.0);i=g+36|0;j=f[i>>2]|0;if(j|0?(k=j+12|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)kL(g);f[i>>2]=0;i=g+16|0;j=g+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[j>>2]|0)>0){i=f[g+40>>2]|0;k=0;do{f[i+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[j>>2]|0))}j=f[g+44>>2]|0;if((j|0)!=(g+48|0))UC(j);j=a+80|0;g=(f[j>>2]|0)-(f[c>>2]|0)>>2;k=$oa(a)|0;if(!((g|0)==(k+1|0)|((g|0)==0|(g|0)==(k|0)))){f[e>>2]=0;f[e+4>>2]=0;p=aD(e,19)|0;k=350559;q=p+19|0;do{b[p>>0]=b[k>>0]|0;p=p+1|0;k=k+1|0}while((p|0)<(q|0));bO(-215,e,350579,348385,117);bD(e)}k=(f[j>>2]|0)-(f[c>>2]|0)>>2;f[h>>2]=1124007936;g=h+4|0;i=h+8|0;l=h+40|0;p=g;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[l>>2]=i;i=h+48|0;p=h+44|0;f[p>>2]=i;f[i>>2]=0;f[h+52>>2]=0;f[e>>2]=1;f[e+4>>2]=k;hL(h,2,e,5);k=f[a+12>>2]|0;q=f[a+16>>2]|0;o=Y(Y((k|0)/(f[a+28>>2]|0)|0,f[a+36>>2]|0)|0,(q|0)/(f[a+32>>2]|0)|0)|0;m=f[a+20>>2]|0;r=f[a+24>>2]|0;s=((f[a+4>>2]|0)-k+m|0)/(m|0)|0;m=((f[a+8>>2]|0)-q+r|0)/(r|0)|0;if((m|0)>0?(r=f[h+16>>2]|0,q=(o|0)==0,(s|0)>0):0){k=f[c>>2]|0;t=0;do{v=Y(t,s)|0;if(!q){w=0;do{x=k+((Y((Y(w,m)|0)+t|0,o)|0)<<2)|0;y=r+((Y(w+v|0,o)|0)<<2)|0;z=0;do{f[y+(z<<2)>>2]=f[x+(z<<2)>>2];z=z+1|0}while((z|0)!=(o|0));w=w+1|0}while((w|0)!=(s|0))}t=t+1|0}while((t|0)!=(m|0))}m=$oa(a)|0;t=f[c>>2]|0;if((f[j>>2]|0)-t>>2>>>0>m>>>0)A=+n[t+(m<<2)>>2];else A=0.0;n[a+136>>2]=A;m=e+8|0;f[m>>2]=0;f[m+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=a+88;SP(h,e);e=h+36|0;a=f[e>>2]|0;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)kL(h);f[e>>2]=0;e=h+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[g>>2]|0)>0){e=f[l>>2]|0;l=0;do{f[e+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[g>>2]|0))}g=f[p>>2]|0;if((g|0)==(i|0)){u=d;return}UC(g);u=d;return}function Hoa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+192|0;e=d+140|0;g=d+96|0;h=d+8|0;i=d+88|0;j=d+80|0;k=d+72|0;l=d+64|0;m=d+56|0;n=d;if((uW(c)|0)!=6){o=0;u=d;return o|0}jW(i,c,350407);kW(h,f[i>>2]|0,f[i+4>>2]|0,0);i=h+20|0;p=f[i>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=p;vW(e,a+4|0,0);p=mW(h)|0;q=f[h+20>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=q;vW(e,a+8|0,0);mW(p)|0;jW(j,c,350415);kW(e,f[j>>2]|0,f[j+4>>2]|0,0);j=h;p=e;q=j+44|0;do{f[j>>2]=f[p>>2];j=j+4|0;p=p+4|0}while((j|0)<(q|0));r=f[i>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=r;vW(e,a+12|0,0);r=mW(h)|0;s=f[h+20>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=s;vW(e,a+16|0,0);mW(r)|0;jW(k,c,350425);kW(e,f[k>>2]|0,f[k+4>>2]|0,0);j=h;p=e;q=j+44|0;do{f[j>>2]=f[p>>2];j=j+4|0;p=p+4|0}while((j|0)<(q|0));k=f[i>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=k;vW(e,a+20|0,0);k=mW(h)|0;r=f[h+20>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=r;vW(e,a+24|0,0);mW(k)|0;jW(l,c,350541);kW(e,f[l>>2]|0,f[l+4>>2]|0,0);j=h;p=e;q=j+44|0;do{f[j>>2]=f[p>>2];j=j+4|0;p=p+4|0}while((j|0)<(q|0));l=f[i>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=l;vW(e,a+28|0,0);l=mW(h)|0;i=f[h+20>>2]|0;f[e>>2]=f[h>>2];f[e+4>>2]=i;vW(e,a+32|0,0);mW(l)|0;jW(e,c,350437);vW(e,a+36|0,0);jW(e,c,350443);vW(e,a+40|0,0);jW(e,c,350550);xW(e,a+48|0,0.0);jW(e,c,350457);vW(e,a+56|0,0);jW(e,c,350475);xW(e,a+64|0,0.0);jW(g,c,350490);vW(g,e,0);b[a+72>>0]=(f[e>>2]|0)!=0&1;jW(e,c,350506);vW(e,a+140|0,0);jW(m,c,350514);if(!(f[m+4>>2]|0))b[a+144>>0]=0;else{jW(g,c,350514);vW(g,e,0);b[a+144>>0]=(f[e>>2]|0)!=0&1}jW(n,c,350529);if((uW(n)|0)==5?(c=a+76|0,kW(g,f[n>>2]|0,f[n+4>>2]|0,0),f[e>>2]=g,lpa(e,c,2147483647),g=(f[a+80>>2]|0)-(f[c>>2]|0)>>2,c=$oa(a)|0,!((g|0)==(c+1|0)|((g|0)==0|(g|0)==(c|0)))):0){f[e>>2]=0;f[e+4>>2]=0;j=aD(e,19)|0;p=350559;q=j+19|0;do{b[j>>0]=b[p>>0]|0;j=j+1|0;p=p+1|0}while((j|0)<(q|0));bO(-215,e,363731,348385,167);bD(e)}o=1;u=d;return o|0}function Ioa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0.0,r=0,s=0;e=u;u=u+16|0;g=e+8|0;i=e;if(f[d+4>>2]|0)gW(c,d)|0;f[g>>2]=0;f[g+4>>2]=0;d=aD(g,27)|0;j=350379;k=d+27|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));l=gW(c,g)|0;bD(g);f[g>>2]=0;f[g+4>>2]=0;m=aD(g,7)|0;b[m>>0]=b[350407]|0;b[m+1>>0]=b[350408]|0;b[m+2>>0]=b[350409]|0;b[m+3>>0]=b[350410]|0;b[m+4>>0]=b[350411]|0;b[m+5>>0]=b[350412]|0;b[m+6>>0]=b[350413]|0;m=gW(l,g)|0;bD(g);l=jpa(m,a+4|0)|0;f[g>>2]=0;f[g+4>>2]=0;d=aD(g,9)|0;j=350415;k=d+9|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));m=gW(l,g)|0;bD(g);l=jpa(m,a+12|0)|0;f[g>>2]=0;f[g+4>>2]=0;d=aD(g,11)|0;j=350425;k=d+11|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));m=gW(l,g)|0;bD(g);l=jpa(m,a+20|0)|0;f[g>>2]=0;f[g+4>>2]=0;m=aD(g,8)|0;n=m;b[n>>0]=99;b[n+1>>0]=101;b[n+2>>0]=108;b[n+3>>0]=108;n=m+4|0;b[n>>0]=83;b[n+1>>0]=105;b[n+2>>0]=122;b[n+3>>0]=101;n=gW(l,g)|0;bD(g);l=jpa(n,a+28|0)|0;f[g>>2]=0;f[g+4>>2]=0;n=aD(g,5)|0;b[n>>0]=b[350437]|0;b[n+1>>0]=b[350438]|0;b[n+2>>0]=b[350439]|0;b[n+3>>0]=b[350440]|0;b[n+4>>0]=b[350441]|0;n=gW(l,g)|0;bD(g);l=a+36|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](n)|0){m=c+32|0;if((f[m>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=aD(g,30)|0;j=363892;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));bO(-2,g,489622,363923,1181);bD(g)}oW(n,c+12|0,f[l>>2]|0);if(f[m>>2]&4|0)f[m>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=aD(g,13)|0;j=350443;k=d+13|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));m=gW(n,g)|0;bD(g);n=a+40|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=aD(g,30)|0;j=363892;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));bO(-2,g,489622,363923,1181);bD(g)}oW(m,c+12|0,f[n>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}f[g>>2]=0;f[g+4>>2]=0;l=aD(g,8)|0;n=l;b[n>>0]=119;b[n+1>>0]=105;b[n+2>>0]=110;b[n+3>>0]=83;n=l+4|0;b[n>>0]=105;b[n+1>>0]=103;b[n+2>>0]=109;b[n+3>>0]=97;n=gW(m,g)|0;bD(g);o=+p[a+48>>3];if(o>0.0)q=o;else q=+((f[a+16>>2]|0)+(f[a+12>>2]|0)|0)*.125;if(di[f[(f[c>>2]|0)+12>>2]&1023](n)|0){m=c+32|0;if((f[m>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=aD(g,30)|0;j=363892;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));bO(-2,g,489622,363923,1181);bD(g)}qW(n,c+12|0,q);if(f[m>>2]&4|0)f[m>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=aD(g,17)|0;j=350457;k=d+17|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));m=gW(n,g)|0;bD(g);n=a+56|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=aD(g,30)|0;j=363892;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));bO(-2,g,489622,363923,1181);bD(g)}oW(m,c+12|0,f[n>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=aD(g,14)|0;j=350475;k=d+14|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));l=gW(m,g)|0;bD(g);m=a+64|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](l)|0){n=c+32|0;if((f[n>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=aD(g,30)|0;j=363892;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));bO(-2,g,489622,363923,1181);bD(g)}qW(l,c+12|0,+p[m>>3]);if(f[n>>2]&4|0)f[n>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=aD(g,15)|0;j=350490;k=d+15|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));n=gW(l,g)|0;bD(g);l=a+72|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](n)|0){m=c+32|0;if((f[m>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=aD(g,30)|0;j=363892;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));bO(-2,g,489622,363923,1181);bD(g)}oW(n,c+12|0,h[l>>0]|0);if(f[m>>2]&4|0)f[m>>2]=6}f[g>>2]=0;f[g+4>>2]=0;m=aD(g,7)|0;b[m>>0]=b[350506]|0;b[m+1>>0]=b[350507]|0;b[m+2>>0]=b[350508]|0;b[m+3>>0]=b[350509]|0;b[m+4>>0]=b[350510]|0;b[m+5>>0]=b[350511]|0;b[m+6>>0]=b[350512]|0;m=gW(n,g)|0;bD(g);n=a+140|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](m)|0){l=c+32|0;if((f[l>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=aD(g,30)|0;j=363892;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));bO(-2,g,489622,363923,1181);bD(g)}oW(m,c+12|0,f[n>>2]|0);if(f[l>>2]&4|0)f[l>>2]=6}f[g>>2]=0;f[g+4>>2]=0;d=aD(g,14)|0;j=350514;k=d+14|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));l=gW(m,g)|0;bD(g);m=a+144|0;if(di[f[(f[c>>2]|0)+12>>2]&1023](l)|0){n=c+32|0;if((f[n>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=aD(g,30)|0;j=363892;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));bO(-2,g,489622,363923,1181);bD(g)}oW(l,c+12|0,h[m>>0]|0);if(f[n>>2]&4|0)f[n>>2]=6}n=a+76|0;if((f[n>>2]|0)==(f[a+80>>2]|0)){f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=aD(g,1)|0;b[s>>0]=125;gW(c,g)|0;bD(g);u=e;return}f[g>>2]=0;f[g+4>>2]=0;d=aD(g,11)|0;j=350529;k=d+11|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));a=gW(c,g)|0;bD(g);if(!(di[f[(f[c>>2]|0)+12>>2]&1023](a)|0)){f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=aD(g,1)|0;b[s>>0]=125;gW(c,g)|0;bD(g);u=e;return}m=c+32|0;if((f[m>>2]|0)==6){f[g>>2]=0;f[g+4>>2]=0;d=aD(g,30)|0;j=363892;k=d+30|0;do{b[d>>0]=b[j>>0]|0;d=d+1|0;j=j+1|0}while((d|0)<(k|0));bO(-2,g,489622,363923,1181);bD(g)}f[g>>2]=0;f[g+4>>2]=0;sW(i,a,c+12|0,13,g);bD(g);f[g>>2]=a;kpa(g,n);tW(i);if(!(f[m>>2]&4)){f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=aD(g,1)|0;b[s>>0]=125;gW(c,g)|0;bD(g);u=e;return}f[m>>2]=6;f[g>>2]=0;r=g+4|0;f[r>>2]=0;s=aD(g,1)|0;b[s>>0]=125;gW(c,g)|0;bD(g);u=e;return}function Joa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+144|0;e=d+136|0;g=d+88|0;h=d+44|0;i=d+8|0;j=d;f[e>>2]=0;f[e+4>>2]=0;dW(i,b,0,e);bD(e);if(f[c+4>>2]|0){iW(j,i,c);k=f[a>>2]|0;l=k+12|0;m=f[l>>2]|0;n=Uh[m&1023](a,j)|0;nT(i);u=d;return n|0}fW(e,i,0);c=e+4|0;kW(g,f[e>>2]|0,f[c>>2]|0,0);b=f[e>>2]|0;o=f[c>>2]|0;kW(h,b,o,lW(e)|0);e=f[g>>2]|0;o=e;if((((e|0)==(f[h>>2]|0)?(f[g+4>>2]|0)==(f[h+4>>2]|0):0)?(f[g+20>>2]|0)==(f[h+20>>2]|0):0)?(f[g+40>>2]|0)==(f[h+40>>2]|0):0){f[j>>2]=0;f[j+4>>2]=0}else{h=f[g+20>>2]|0;f[j>>2]=o;f[j+4>>2]=h}k=f[a>>2]|0;l=k+12|0;m=f[l>>2]|0;n=Uh[m&1023](a,j)|0;nT(i);u=d;return n|0}function Koa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+8|0;g=d;f[g>>2]=0;f[g+4>>2]=0;dW(e,b,1,g);bD(g);h=f[(f[a>>2]|0)+16>>2]|0;i=f[c+4>>2]|0;if(i){j=f[c>>2]|0;f[g>>2]=j;f[g+4>>2]=i;if(j|0){i=j+-4|0;f[i>>2]=(f[i>>2]|0)+1}}else XV(g,b);_h[h&255](a,e,g);bD(g);nT(e);u=d;return}function Loa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;f[c+4>>2]=f[a+4>>2];f[c+8>>2]=f[a+8>>2];f[c+12>>2]=f[a+12>>2];f[c+16>>2]=f[a+16>>2];f[c+20>>2]=f[a+20>>2];f[c+24>>2]=f[a+24>>2];f[c+28>>2]=f[a+28>>2];f[c+32>>2]=f[a+32>>2];f[c+36>>2]=f[a+36>>2];f[c+40>>2]=f[a+40>>2];p[c+48>>3]=+p[a+48>>3];f[c+56>>2]=f[a+56>>2];p[c+64>>3]=+p[a+64>>3];b[c+72>>0]=b[a+72>>0]|0;if((c|0)==(a|0)){d=a+140|0;e=f[d>>2]|0;g=c+140|0;f[g>>2]=e;h=a+144|0;i=b[h>>0]|0;j=c+144|0;b[j>>0]=i;return}IA(c+76|0,f[a+76>>2]|0,f[a+80>>2]|0);d=a+140|0;e=f[d>>2]|0;g=c+140|0;f[g>>2]=e;h=a+144|0;i=b[h>>0]|0;j=c+144|0;b[j>>0]=i;return}function Moa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=u;u=u+416|0;i=h+408|0;j=h+400|0;k=h+392|0;l=h+336|0;m=h+8|0;n=h;dQ(i,80376);o=f[d>>2]|0;p=d+4|0;q=f[p>>2]|0;if(!(q|o)){r=f[a+28>>2]|0;f[d>>2]=r;s=f[a+32>>2]|0;f[p>>2]=s;t=r;v=s}else{t=o;v=q}q=f[a+20>>2]|0;o=(t|0)<(q|0);s=o?q:t;r=o?t:q;if((r|0)>0){q=s;t=r;while(1){r=(q|0)%(t|0)|0;if((r|0)>0){o=t;t=r;q=o}else{w=t;break}}}else w=s;s=f[a+24>>2]|0;t=(v|0)<(s|0);q=t?s:v;o=t?v:s;if((o|0)>0){s=q;v=o;while(1){o=(s|0)%(v|0)|0;if((o|0)>0){t=v;v=o;s=t}else{x=v;break}}}else x=q;f[j>>2]=w;w=j+4|0;f[w>>2]=x;AL(k,b,-1);x=g+4|0;q=(f[x>>2]|0)-(f[g>>2]|0)>>3;v=f[e>>2]|0;s=f[j>>2]|0;t=s+-1+((v|0)>0?v:0)&0-s;f[e>>2]=t;s=e+4|0;v=f[s>>2]|0;o=f[w>>2]|0;w=o+-1+((v|0)>0?v:0)&0-o;f[s>>2]=w;o=(t<<1)+(f[k>>2]|0)|0;t=(w<<1)+(f[k+4>>2]|0)|0;do if((yM(b)|0)==65536){k=f[b+4>>2]|0;f[l>>2]=f[k>>2];w=l+4|0;v=k+4|0;f[w>>2]=f[v>>2];r=l+8|0;f[r>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[l+16>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];y=f[k+36>>2]|0;f[l+36>>2]=y;f[l+40>>2]=r;r=l+48|0;z=l+44|0;f[z>>2]=r;f[r>>2]=0;f[l+52>>2]=0;if(y|0){r=y+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[v>>2]|0)<3){v=f[k+44>>2]|0;r=f[z>>2]|0;f[r>>2]=f[v>>2];f[r+4>>2]=f[v+4>>2];break}else{f[w>>2]=0;jL(l,k);break}}else yL(l,b,-1);while(0);b=(q|0)==0;_oa(m,a,l,e,e,b,j);if(b)A=Y(((t-(f[m+48>>2]|0)|0)/(f[p>>2]|0)|0)+1|0,((o-(f[m+44>>2]|0)|0)/(f[d>>2]|0)|0)+1|0)|0;else A=q;q=f[m+16>>2]|0;t=Y(f[m+64>>2]|0,f[m+60>>2]|0)|0;b=f[m+76>>2]|0;j=$oa(a)|0;k=Y(j,A)|0;w=c+4|0;v=f[w>>2]|0;r=f[c>>2]|0;z=v-r>>2;y=r;r=v;if(k>>>0<=z>>>0){if(k>>>0<z>>>0?(v=y+(k<<2)|0,(r|0)!=(v|0)):0)f[w>>2]=r+(~((r+-4-v|0)>>>2)<<2)}else ipa(c,k-z|0);if(A|0?(z=m+44|0,k=l+12|0,v=a+4|0,r=l+8|0,w=a+8|0,a=n+4|0,y=b<<2,(t|0)>0):0){b=0;do{B=Y(b,j)|0;C=(f[c>>2]|0)+(B<<2)|0;B=f[g>>2]|0;if((B|0)!=(f[x>>2]|0)){D=f[B+(b<<3)>>2]|0;E=f[B+(b<<3)+4>>2]|0;B=f[e>>2]|0;if((((D|0)>=(0-B|0)?(D|0)<=((f[k>>2]|0)+B-(f[v>>2]|0)|0):0)?(B=f[s>>2]|0,(E|0)>=(0-B|0)):0)?(E|0)<=((f[r>>2]|0)+B-(f[w>>2]|0)|0):0){F=D;G=E;H=33}}else{E=f[d>>2]|0;D=((o-(f[z>>2]|0)|0)/(E|0)|0)+1|0;B=(b|0)/(D|0)|0;I=Y(b-(Y(D,B)|0)|0,E)|0;E=Y(f[p>>2]|0,B)|0;F=I-(f[e>>2]|0)|0;G=E-(f[s>>2]|0)|0;H=33}if((H|0)==33){H=0;E=0;do{I=(f[q+(E*12|0)+8>>2]|0)+G|0;B=C+(f[q+(E*12|0)>>2]<<2)|0;f[n>>2]=(f[q+(E*12|0)+4>>2]|0)+F;f[a>>2]=I;I=bpa(m,n,B)|0;if((I|0)!=(B|0))Vac(B|0,I|0,y|0)|0;E=E+1|0}while((E|0)<(t|0))}b=b+1|0}while(b>>>0<A>>>0)}yoa(m);m=l+36|0;A=f[m>>2]|0;if(A|0?(b=A+12|0,A=f[b>>2]|0,f[b>>2]=A+-1,(A|0)==1):0)kL(l);f[m>>2]=0;m=l+16|0;A=l+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[A>>2]|0)>0){m=f[l+40>>2]|0;b=0;do{f[m+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[A>>2]|0))}A=f[l+44>>2]|0;if((A|0)!=(l+48|0))UC(A);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function Noa(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0.0;k=u;u=u+384|0;l=k+376|0;m=k+368|0;o=k+40|0;q=k+24|0;r=k+16|0;s=k;t=k+8|0;dQ(l,80356);v=f[d>>2]|0;w=d+4|0;x=f[w>>2]|0;if((x|0)!=(v|0))f[w>>2]=x+(~((x+-8-v|0)>>>3)<<3);v=f[e>>2]|0;x=e+4|0;y=f[x>>2]|0;if((y|0)!=(v|0))f[x>>2]=y+(~((y+-8-v|0)>>>3)<<3);v=a+76|0;y=a+80|0;if((f[v>>2]|0)!=(f[y>>2]|0)){z=f[h>>2]|0;A=h+4|0;B=f[A>>2]|0;if(!(B|z)){C=f[a+28>>2]|0;f[h>>2]=C;D=f[a+32>>2]|0;f[A>>2]=D;E=C;F=D}else{E=z;F=B}B=f[a+20>>2]|0;z=(E|0)<(B|0);D=z?B:E;C=z?E:B;if((C|0)>0){B=D;E=C;while(1){C=(B|0)%(E|0)|0;if((C|0)>0){z=E;E=C;B=z}else{G=E;break}}}else G=D;D=f[a+24>>2]|0;E=(F|0)<(D|0);B=E?D:F;z=E?F:D;if((z|0)>0){D=B;F=z;while(1){z=(D|0)%(F|0)|0;if((z|0)>0){E=F;F=z;D=E}else{H=F;break}}}else H=B;f[m>>2]=G;B=m+4|0;f[B>>2]=H;F=j+4|0;D=(f[F>>2]|0)-(f[j>>2]|0)>>3;E=f[i>>2]|0;z=G+-1+((E|0)>0?E:0)&0-G;f[i>>2]=z;G=i+4|0;E=f[G>>2]|0;C=H+-1+((E|0)>0?E:0)&0-H;f[G>>2]=C;H=c+12|0;E=(z<<1)+(f[H>>2]|0)|0;z=c+8|0;I=(C<<1)+(f[z>>2]|0)|0;C=(D|0)==0;_oa(o,a,c,i,i,C,m);if(C)J=Y(((I-(f[o+48>>2]|0)|0)/(f[A>>2]|0)|0)+1|0,((E-(f[o+44>>2]|0)|0)/(f[h>>2]|0)|0)+1|0)|0;else J=D;D=f[o+16>>2]|0;I=Y(f[o+64>>2]|0,f[o+60>>2]|0)|0;C=f[o+76>>2]|0;c=$oa(a)|0;K=f[v>>2]|0;if((f[y>>2]|0)-K>>2>>>0>c>>>0)L=+n[K+(c<<2)>>2];else L=0.0;M=L;f[q>>2]=0;c=q+4|0;f[c>>2]=0;f[q+8>>2]=0;do if(C)if(C>>>0>1073741823)c4b(q);else{K=C<<2;y=L5b(K)|0;f[q>>2]=y;N=y+(C<<2)|0;f[q+8>>2]=N;Nac(y|0,0,K|0)|0;f[c>>2]=N;O=y;P=y;break}else{O=0;P=0}while(0);if(!J){Q=P;R=O}else{O=r+4|0;P=o+44|0;y=s+4|0;N=(I|0)>0;K=t+4|0;S=C+-4|0;T=(C|0)<4;U=d+8|0;V=e+8|0;W=a+4|0;X=a+8|0;a=C&-4;Z=(C|0)>0;_=(a|0)<(C|0);$=0;do{f[r>>2]=0;f[O>>2]=0;aa=f[j>>2]|0;do if((aa|0)!=(f[F>>2]|0)){ba=f[aa+($<<3)>>2]|0;f[r>>2]=ba;ca=f[aa+($<<3)+4>>2]|0;f[O>>2]=ca;da=f[i>>2]|0;if((((ba|0)>=(0-da|0)?(ba|0)<=((f[H>>2]|0)+da-(f[W>>2]|0)|0):0)?(da=f[G>>2]|0,(ca|0)>=(0-da|0)):0)?(ca|0)<=((f[z>>2]|0)+da-(f[X>>2]|0)|0):0)ea=35}else{da=f[h>>2]|0;ca=((E-(f[P>>2]|0)|0)/(da|0)|0)+1|0;ba=($|0)/(ca|0)|0;fa=Y($-(Y(ca,ba)|0)|0,da)|0;da=Y(f[A>>2]|0,ba)|0;ba=fa-(f[i>>2]|0)|0;fa=da-(f[G>>2]|0)|0;f[r>>2]=ba;f[O>>2]=fa;if(((ba|0)%(f[m>>2]|0)|0|0)==0?((fa|0)%(f[B>>2]|0)|0|0)==0:0){ea=35;break}f[s>>2]=0;f[y>>2]=0;fa=aD(s,65)|0;ba=350031;da=fa+65|0;do{b[fa>>0]=b[ba>>0]|0;fa=fa+1|0;ba=ba+1|0}while((fa|0)<(da|0));bO(-215,s,350097,348385,1708);bD(s);ea=35}while(0);if((ea|0)==35){ea=0;p[s>>3]=M;aa=f[v>>2]|0;do if(N)if(T){ba=0;fa=aa;while(1){da=(f[D+(ba*12|0)+8>>2]|0)+(f[O>>2]|0)|0;f[t>>2]=(f[D+(ba*12|0)+4>>2]|0)+(f[r>>2]|0);f[K>>2]=da;da=bpa(o,t,f[q>>2]|0)|0;if(Z){ca=0;L=+p[s>>3];do{L=L+ +n[da+(ca<<2)>>2]*+n[fa+(ca<<2)>>2];ca=ca+1|0}while((ca|0)!=(C|0));p[s>>3]=L}ba=ba+1|0;if((ba|0)>=(I|0))break;else fa=fa+(C<<2)|0}ga=+p[s>>3];break}else{fa=0;ba=aa;while(1){ca=(f[D+(fa*12|0)+8>>2]|0)+(f[O>>2]|0)|0;f[t>>2]=(f[D+(fa*12|0)+4>>2]|0)+(f[r>>2]|0);f[K>>2]=ca;ca=bpa(o,t,f[q>>2]|0)|0;da=0;ha=+p[s>>3];do{ia=da|1;ja=da|2;ka=da|3;ha=ha+(+n[ca+(da<<2)>>2]*+n[ba+(da<<2)>>2]+ +n[ca+(ia<<2)>>2]*+n[ba+(ia<<2)>>2]+ +n[ca+(ja<<2)>>2]*+n[ba+(ja<<2)>>2]+ +n[ca+(ka<<2)>>2]*+n[ba+(ka<<2)>>2]);da=da+4|0}while((da|0)<=(S|0));p[s>>3]=ha;if(_){da=a;L=ha;do{L=L+ +n[ca+(da<<2)>>2]*+n[ba+(da<<2)>>2];da=da+1|0}while((da|0)!=(C|0));p[s>>3]=L;la=L}else la=ha;fa=fa+1|0;if((fa|0)>=(I|0)){ga=la;break}else ba=ba+(C<<2)|0}}else ga=M;while(0);do if(ga>=g){aa=f[w>>2]|0;if((aa|0)==(f[U>>2]|0))b2(d,r);else{f[aa>>2]=f[r>>2];f[aa+4>>2]=f[O>>2];f[w>>2]=aa+8}aa=f[x>>2]|0;if((aa|0)==(f[V>>2]|0)){apa(e,s);break}else{p[aa>>3]=+p[s>>3];f[x>>2]=aa+8;break}}while(0)}$=$+1|0}while($>>>0<J>>>0);J=f[q>>2]|0;Q=J;R=J}if(Q|0){J=f[c>>2]|0;if((J|0)!=(Q|0))f[c>>2]=J+(~((J+-4-Q|0)>>>2)<<2);O5b(R)}yoa(o)}if(!(f[l+4>>2]|0)){u=k;return}u=k;return}function Ooa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i+8|0;m=i;dQ(j,80336);f[k>>2]=0;n=k+4|0;f[n>>2]=0;f[k+8>>2]=0;o=f[(f[a>>2]|0)+36>>2]|0;f[l>>2]=f[e>>2];f[l+4>>2]=f[e+4>>2];f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];Tf[o&7](a,b,c,k,d,l,m,h);h=f[k>>2]|0;if(h|0){k=f[n>>2]|0;if((k|0)!=(h|0))f[n>>2]=k+(~((k+-8-h|0)>>>3)<<3);O5b(h)}if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function Poa(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0;l=u;u=u+288|0;m=l+272|0;n=l+112|0;o=l+264|0;q=l+252|0;r=l+240|0;s=l+228|0;t=l+216|0;v=l+204|0;w=l+200|0;x=l+144|0;y=l+136|0;z=l;A=l+128|0;B=l+120|0;dQ(m,80276);p[n>>3]=1.0;AL(o,b,-1);f[q>>2]=0;C=q+4|0;f[C>>2]=0;f[q+8>>2]=0;D=a+140|0;a:do if((f[D>>2]|0)>0){E=q+8|0;F=a+4|0;G=o+4|0;H=a+8|0;if(!(i<=1.0)){I=0;J=0;K=1.0;L=0}else{apa(q,n);M=0;break}while(1){if((I|0)==(J|0))apa(q,n);else{p[I>>3]=K;f[C>>2]=I+8}N=+p[n>>3];O=MVb(+(f[o>>2]|0)/N)|0;if((O|0)<(f[F>>2]|0)){M=L;break a}O=MVb(+(f[G>>2]|0)/N)|0;if((O|0)<(f[H>>2]|0)){M=L;break a}P=N*i;p[n>>3]=P;O=L+1|0;if((O|0)>=(f[D>>2]|0)){M=O;break a}I=f[C>>2]|0;J=f[E>>2]|0;K=P;L=O}}else M=0;while(0);L=(M|0)>1?M:1;M=f[C>>2]|0;J=f[q>>2]|0;I=M-J>>3;D=J;J=M;if(L>>>0<=I>>>0){if(L>>>0<I>>>0?(M=D+(L<<3)|0,(J|0)!=(M|0)):0)f[C>>2]=J+(~((J+-8-M|0)>>>3)<<3)}else Z2(q,L-I|0);I=g+4|0;if(!(f[I>>2]|f[g>>2])){f[g>>2]=f[a+20>>2];f[I>>2]=f[a+24>>2]}f[r>>2]=0;I=r+4|0;f[I>>2]=0;f[r+8>>2]=0;f[s>>2]=0;L=s+4|0;f[L>>2]=0;f[s+8>>2]=0;f[t>>2]=0;M=t+4|0;f[M>>2]=0;f[t+8>>2]=0;f[v>>2]=0;J=v+4|0;f[J>>2]=0;f[v+8>>2]=0;NO(w);do if((yM(b)|0)==65536){D=f[b+4>>2]|0;f[x>>2]=f[D>>2];n=x+4|0;E=D+4|0;f[n>>2]=f[E>>2];H=x+8|0;f[H>>2]=f[D+8>>2];f[x+12>>2]=f[D+12>>2];f[x+16>>2]=f[D+16>>2];f[x+20>>2]=f[D+20>>2];f[x+24>>2]=f[D+24>>2];f[x+28>>2]=f[D+28>>2];f[x+32>>2]=f[D+32>>2];G=f[D+36>>2]|0;f[x+36>>2]=G;f[x+40>>2]=H;H=x+48|0;F=x+44|0;f[F>>2]=H;f[H>>2]=0;f[x+52>>2]=0;if(G|0){H=G+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[E>>2]|0)<3){E=f[D+44>>2]|0;H=f[F>>2]|0;f[H>>2]=f[E>>2];f[H+4>>2]=f[E+4>>2];break}else{f[n>>2]=0;jL(x,D);break}}else yL(x,b,-1);while(0);b=f[q>>2]|0;D=(f[C>>2]|0)-b>>3;f[y>>2]=0;f[y+4>>2]=D;cpa(z,a,x,e,g,h,b,r,w,t,s);RQ(y,z,-1.0);y=f[s>>2]|0;b=f[L>>2]|0;if((y|0)!=(b|0)){h=v+8|0;g=y;do{y=f[J>>2]|0;if((y|0)==(f[h>>2]|0))apa(v,g);else{p[y>>3]=+p[g>>3];f[J>>2]=y+8}g=g+8|0}while((g|0)!=(b|0))}b=f[c>>2]|0;g=c+4|0;h=f[g>>2]|0;if((h|0)==(b|0))Q=b;else{y=h+(~((h+-16-b|0)>>>4)<<4)|0;f[g>>2]=y;Q=y}y=f[r>>2]|0;b=f[I>>2]|0;b:do if((y|0)!=(b|0)){h=c+8|0;D=Q;n=y;while(1){if((D|0)==(f[h>>2]|0))Zoa(c,n);else{f[D>>2]=f[n>>2];f[D+4>>2]=f[n+4>>2];f[D+8>>2]=f[n+8>>2];f[D+12>>2]=f[n+12>>2];f[g>>2]=D+16}E=n+16|0;if((E|0)==(b|0))break b;D=f[g>>2]|0;n=E}}while(0);g=f[d>>2]|0;b=d+4|0;y=f[b>>2]|0;if((y|0)==(g|0))R=g;else{Q=y+(~((y+-8-g|0)>>>3)<<3)|0;f[b>>2]=Q;R=Q}Q=f[t>>2]|0;g=f[M>>2]|0;c:do if((Q|0)!=(g|0)){y=d+8|0;n=Q;D=R;while(1){if((D|0)==(f[y>>2]|0))apa(d,n);else{p[D>>3]=+p[n>>3];f[b>>2]=D+8}h=n+8|0;if((h|0)==(g|0))break c;n=h;D=f[b>>2]|0}}while(0);if(k){f[A>>2]=f[a+4>>2];f[A+4>>2]=f[a+8>>2];yra(c,d,v,j,A)}else dpa(0,c,d,~~j,.2);f[B>>2]=f[o>>2];f[B+4>>2]=f[o+4>>2];Pra(B,c,0,d);f[z>>2]=80304;d=z+8|0;c=z+44|0;B=f[c>>2]|0;if(B|0?(o=B+12|0,B=f[o>>2]|0,f[o>>2]=B+-1,(B|0)==1):0)kL(d);f[c>>2]=0;c=z+24|0;d=z+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[d>>2]|0)>0){c=f[z+48>>2]|0;B=0;do{f[c+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[d>>2]|0))}d=f[z+52>>2]|0;if((d|0)!=(z+56|0))UC(d);d=x+36|0;z=f[d>>2]|0;if(z|0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0)kL(x);f[d>>2]=0;d=x+16|0;z=x+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[z>>2]|0)>0){d=f[x+40>>2]|0;B=0;do{f[d+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[z>>2]|0))}z=f[x+44>>2]|0;if((z|0)!=(x+48|0))UC(z);OO(w);w=f[v>>2]|0;if(w|0){v=f[J>>2]|0;if((v|0)!=(w|0))f[J>>2]=v+(~((v+-8-w|0)>>>3)<<3);O5b(w)}w=f[t>>2]|0;if(w|0){t=f[M>>2]|0;if((t|0)!=(w|0))f[M>>2]=t+(~((t+-8-w|0)>>>3)<<3);O5b(w)}w=f[s>>2]|0;if(w|0){s=f[L>>2]|0;if((s|0)!=(w|0))f[L>>2]=s+(~((s+-8-w|0)>>>3)<<3);O5b(w)}w=f[r>>2]|0;if(w|0){r=f[I>>2]|0;if((r|0)!=(w|0))f[I>>2]=r+(~((r+-16-w|0)>>>4)<<4);O5b(w)}w=f[q>>2]|0;if(w|0){q=f[C>>2]|0;if((q|0)!=(w|0))f[C>>2]=q+(~((q+-8-w|0)>>>3)<<3);O5b(w)}if(!(f[m+4>>2]|0)){u=l;return}u=l;return}function Qoa(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=+h;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k+8|0;o=k;dQ(l,80256);f[m>>2]=0;p=m+4|0;f[p>>2]=0;f[m+8>>2]=0;q=f[(f[a>>2]|0)+44>>2]|0;f[n>>2]=f[e>>2];f[n+4>>2]=f[e+4>>2];f[o>>2]=f[g>>2];f[o+4>>2]=f[g+4>>2];tg[q&3](a,b,c,m,d,n,o,h,i,j);j=f[m>>2]|0;if(j|0){m=f[p>>2]|0;if((m|0)!=(j|0))f[p>>2]=m+(~((m+-8-j|0)>>>3)<<3);O5b(j)}if(!(f[l+4>>2]|0)){u=k;return}u=k;return}function Roa(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0;j=u;u=u+2496|0;k=j+2480|0;l=j+2472|0;m=j+2464|0;o=j+2456|0;p=j+2400|0;q=j+1336|0;r=j+272|0;s=j+216|0;t=j+160|0;v=j+104|0;w=j+48|0;x=j+32|0;y=j+16|0;z=j;dQ(l,80236);switch(f[c>>2]&4095){case 16:case 0:break;default:{f[k>>2]=0;f[k+4>>2]=0;A=aD(k,74)|0;B=349089;C=A+74|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,k,349164,348385,241);bD(k)}}D=f[c+12>>2]|0;E=f[g>>2]|0;F=f[i>>2]|0;G=E+D+F|0;H=g+4|0;I=(f[H>>2]|0)+(f[c+8>>2]|0)+(f[i+4>>2]|0)|0;if(!(((((f[d+4>>2]|0)<3?(f[d+8>>2]|0)==(I|0):0)?(f[d+12>>2]|0)==(G|0):0)?(f[d>>2]&4095|0)==13:0)?(f[d+16>>2]|0)!=0:0)){f[k>>2]=I;f[k+4>>2]=G;hL(d,2,k,13)}if(!(((((f[e+4>>2]|0)<3?(f[e+8>>2]|0)==(I|0):0)?(f[e+12>>2]|0)==(G|0):0)?(f[e>>2]&4095|0)==8:0)?(f[e+16>>2]|0)!=0:0)){f[k>>2]=I;f[k+4>>2]=G;hL(e,2,k,8)}f[m>>2]=0;i=m+4|0;f[i>>2]=0;f[o>>2]=0;J=o+4|0;f[J>>2]=0;uL(c,m,o);K=(f[c>>2]|0)>>>3&511;f[p>>2]=1124007936;L=p+4|0;N=p+8|0;O=p+40|0;A=L;C=A+36|0;do{f[A>>2]=0;A=A+4|0}while((A|0)<(C|0));f[O>>2]=N;N=p+48|0;P=p+44|0;f[P>>2]=N;f[N>>2]=0;f[p+52>>2]=0;f[k>>2]=1;f[k+4>>2]=256;hL(p,2,k,5);Q=p+16|0;R=f[Q>>2]|0;if(!(b[a+72>>0]|0)){S=0;do{n[R+(S<<2)>>2]=+(S|0);S=S+1|0}while((S|0)!=256)}else{S=0;do{T=+M(+(+(S|0)));n[R+(S<<2)>>2]=T;S=S+1|0}while((S|0)!=256)}S=G+4+I|0;U=q+8|0;f[q>>2]=U;V=q+4|0;f[V>>2]=S;if(S>>>0>264){W=N5b(S>>>0>1073741823?-1:S<<2)|0;f[q>>2]=W;X=W}else X=U;W=X+4|0;S=W+(G<<2)+8|0;if((G|0)>=-1){Z=-1;while(1){_=ZP(Z-(f[g>>2]|0)+(f[o>>2]|0)|0,f[m>>2]|0,4)|0;f[W+(Z<<2)>>2]=_-(f[o>>2]|0);if((Z|0)<(G|0))Z=Z+1|0;else break}}if((I|0)>=-1){Z=-1;while(1){o=ZP(Z-(f[H>>2]|0)+(f[J>>2]|0)|0,f[i>>2]|0,4)|0;f[S+(Z<<2)>>2]=o-(f[J>>2]|0);if((Z|0)<(I|0))Z=Z+1|0;else break}}Z=G<<2;J=r+8|0;f[r>>2]=J;i=r+4|0;f[i>>2]=Z;if(Z>>>0>264){H=N5b(Z>>>0>1073741823?-1:Z<<2)|0;f[r>>2]=H;$=H}else $=J;H=s+4|0;f[H>>2]=2;Z=s+8|0;f[Z>>2]=1;f[s+12>>2]=G;o=s+16|0;f[o>>2]=$;f[s+20>>2]=$;m=s+24|0;g=s+40|0;_=m+8|0;f[_>>2]=0;f[_+4>>2]=0;f[g>>2]=Z;_=s+48|0;aa=s+44|0;f[aa>>2]=_;ba=(G|0)!=0;ca=G<<2;f[s>>2]=1124024325;f[_>>2]=ca;f[s+52>>2]=4;da=$+(Y(f[Z>>2]|0,ca)|0)|0;f[s+28>>2]=da;f[m>>2]=da+(0-ca)+ca;ca=$+(G<<2)|0;f[t>>2]=1124007941;da=t+4|0;f[da>>2]=2;m=t+8|0;f[m>>2]=1;Z=t+12|0;f[Z>>2]=G;ea=t+16|0;f[ea>>2]=ca;fa=t+20|0;f[fa>>2]=ca;ga=t+24|0;ha=t+28|0;ia=t+40|0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;f[ia>>2]=m;ja=t+48|0;ka=t+44|0;f[ka>>2]=ja;f[t+52>>2]=0;f[ja>>2]=0;if(ba&(ca|0)==0){f[k>>2]=0;f[k+4>>2]=0;A=aD(k,26)|0;B=426262;C=A+26|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,k,426289,431198,500);bD(k);la=f[Z>>2]|0;ma=f[t>>2]|0;na=f[ka>>2]|0;oa=f[fa>>2]|0}else{la=G;ma=1124007941;na=ja;oa=ca}ca=la<<2;f[t>>2]=ma|16384;f[na>>2]=ca;f[na+4>>2]=4;na=oa+(Y(f[m>>2]|0,ca)|0)|0;f[ha>>2]=na;f[ga>>2]=na+(0-ca)+ca;ca=G<<1;na=$+(ca<<2)|0;f[v>>2]=1124007941;ga=v+4|0;f[ga>>2]=2;ha=v+8|0;f[ha>>2]=1;m=v+12|0;f[m>>2]=G;oa=v+16|0;f[oa>>2]=na;ma=v+20|0;f[ma>>2]=na;la=v+24|0;fa=v+28|0;Z=v+40|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;f[Z>>2]=ha;pa=v+48|0;qa=v+44|0;f[qa>>2]=pa;f[v+52>>2]=0;f[pa>>2]=0;if(ba&(na|0)==0){f[k>>2]=0;f[k+4>>2]=0;A=aD(k,26)|0;B=426262;C=A+26|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,k,426289,431198,500);bD(k);ra=f[m>>2]|0;sa=f[v>>2]|0;ta=f[qa>>2]|0;ua=f[ma>>2]|0}else{ra=G;sa=1124007941;ta=pa;ua=na}na=ra<<2;f[v>>2]=sa|16384;f[ta>>2]=na;f[ta+4>>2]=4;ta=ua+(Y(f[ha>>2]|0,na)|0)|0;f[fa>>2]=ta;f[la>>2]=ta+(0-na)+na;na=G*3|0;ta=$+(na<<2)|0;f[w>>2]=1124007941;la=w+4|0;f[la>>2]=2;fa=w+8|0;f[fa>>2]=1;ha=w+12|0;f[ha>>2]=G;ua=w+16|0;f[ua>>2]=ta;sa=w+20|0;f[sa>>2]=ta;ra=w+24|0;ma=w+28|0;m=w+40|0;f[ra>>2]=0;f[ra+4>>2]=0;f[ra+8>>2]=0;f[ra+12>>2]=0;f[m>>2]=fa;va=w+48|0;wa=w+44|0;f[wa>>2]=va;f[w+52>>2]=0;f[va>>2]=0;if(ba&(ta|0)==0){f[k>>2]=0;f[k+4>>2]=0;A=aD(k,26)|0;B=426262;C=A+26|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,k,426289,431198,500);bD(k);xa=f[ha>>2]|0;ya=f[w>>2]|0;za=f[wa>>2]|0;Aa=f[sa>>2]|0}else{xa=G;ya=1124007941;za=va;Aa=ta}ta=xa<<2;f[w>>2]=ya|16384;f[za>>2]=ta;f[za+4>>2]=4;za=Aa+(Y(f[fa>>2]|0,ta)|0)|0;f[ma>>2]=za;f[ra>>2]=za+(0-ta)+ta;if((K|0)==2&(G|0)>-2){ta=F+E+D+1|0;D=0;while(1){E=X+(D<<2)|0;f[E>>2]=(f[E>>2]|0)*3;if((D|0)==(ta|0))break;else D=D+1|0}}D=a+36|0;T=+(f[D>>2]|0)/(b[a+144>>0]|0?6.283185307179586:3.141592653589793);if((I|0)>0){a=c+16|0;ta=c+44|0;X=c+48|0;c=d+16|0;E=d+44|0;d=e+16|0;F=e+44|0;e=(K|0)==0;K=k+8|0;za=k+12|0;ra=k+4|0;ma=x+8|0;fa=x+12|0;Aa=x+4|0;ya=y+8|0;xa=y+4|0;sa=z+8|0;ha=z+4|0;ba=(G|0)>0;Ba=k+4|0;Ca=0;do{Da=f[a>>2]|0;Ea=Da+(Y(f[f[ta>>2]>>2]|0,f[S+(Ca<<2)>>2]|0)|0)|0;Fa=f[X>>2]|0;Ga=Da+(Y(f[S+(Ca+-1<<2)>>2]|0,Fa)|0)|0;Ha=Ca;Ca=Ca+1|0;Ia=Da+(Y(f[S+(Ca<<2)>>2]|0,Fa)|0)|0;Fa=(f[c>>2]|0)+(Y(f[f[E>>2]>>2]|0,Ha)|0)|0;Da=(f[d>>2]|0)+(Y(f[f[F>>2]>>2]|0,Ha)|0)|0;if(e){if(ba){Ha=0;Ja=f[W>>2]|0;do{Ka=Ha;Ha=Ha+1|0;La=Ja;Ja=f[W+(Ha<<2)>>2]|0;n[$+(Ka<<2)>>2]=+n[R+(h[Ea+Ja>>0]<<2)>>2]-+n[R+(h[Ea+(f[W+(Ka+-1<<2)>>2]|0)>>0]<<2)>>2];n[$+(Ka+G<<2)>>2]=+n[R+(h[Ia+La>>0]<<2)>>2]-+n[R+(h[Ga+La>>0]<<2)>>2]}while((Ha|0)!=(G|0))}}else if(ba){Ha=0;Ja=f[W>>2]|0;do{La=Ha;Ha=Ha+1|0;Ka=Ja;Ja=f[W+(Ha<<2)>>2]|0;Ma=Ea+Ja|0;Na=Ea+(f[W+(La+-1<<2)>>2]|0)|0;Oa=+n[R+(h[Ma+2>>0]<<2)>>2]-+n[R+(h[Na+2>>0]<<2)>>2];Pa=Ka+2|0;Qa=+n[R+(h[Ia+Pa>>0]<<2)>>2]-+n[R+(h[Ga+Pa>>0]<<2)>>2];Ra=Oa*Oa+Qa*Qa;Sa=+n[R+(h[Ma+1>>0]<<2)>>2]-+n[R+(h[Na+1>>0]<<2)>>2];Pa=Ka+1|0;Ta=+n[R+(h[Ia+Pa>>0]<<2)>>2]-+n[R+(h[Ga+Pa>>0]<<2)>>2];Ua=Sa*Sa+Ta*Ta;Pa=Ra<Ua;Va=+n[R+(h[Ma>>0]<<2)>>2]-+n[R+(h[Na>>0]<<2)>>2];Wa=+n[R+(h[Ia+Ka>>0]<<2)>>2]-+n[R+(h[Ga+Ka>>0]<<2)>>2];Ka=(Pa?Ua:Ra)<Va*Va+Wa*Wa;n[$+(La<<2)>>2]=Ka?Va:Pa?Sa:Oa;n[$+(La+G<<2)>>2]=Ka?Wa:Pa?Ta:Qa}while((Ha|0)!=(G|0))}f[K>>2]=0;f[za>>2]=0;f[k>>2]=16842752;f[ra>>2]=s;f[ma>>2]=0;f[fa>>2]=0;f[x>>2]=16842752;f[Aa>>2]=t;Ha=ya;f[Ha>>2]=0;f[Ha+4>>2]=0;f[y>>2]=33619968;f[xa>>2]=v;Ha=sa;f[Ha>>2]=0;f[Ha+4>>2]=0;f[z>>2]=33619968;f[ha>>2]=w;TO(k,x,y,z,0);if(ba){Ha=0;do{Qa=+n[$+(Ha+ca<<2)>>2];Ta=T*+n[$+(Ha+na<<2)>>2]+-.5;Ga=~~Ta;Ia=Ga-(+(Ga|0)>Ta&1)|0;Wa=Ta-+(Ia|0);Ga=Ha<<1;n[Fa+(Ga<<2)>>2]=Qa*(1.0-Wa);Ea=Ga|1;n[Fa+(Ea<<2)>>2]=Qa*Wa;Ja=f[D>>2]|0;if((Ia|0)<0)Xa=Ia+Ja|0;else Xa=Ia-((Ia|0)<(Ja|0)?0:Ja)|0;if(Xa>>>0>=Ja>>>0){f[k>>2]=0;f[Ba>>2]=0;A=aD(k,32)|0;B=349180;C=A+32|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,k,349164,348385,543);bD(k)}b[Da+Ga>>0]=Xa;Ja=Xa+1|0;b[Da+Ea>>0]=(Ja|0)<(f[D>>2]|0)?Ja&255:0;Ha=Ha+1|0}while((Ha|0)<(G|0))}}while((Ca|0)<(I|0))}I=w+36|0;Ca=f[I>>2]|0;if(Ca|0?(G=Ca+12|0,Ca=f[G>>2]|0,f[G>>2]=Ca+-1,(Ca|0)==1):0)kL(w);f[I>>2]=0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=0;f[ua+12>>2]=0;if((f[la>>2]|0)>0){ua=f[m>>2]|0;m=0;do{f[ua+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[la>>2]|0))}la=f[wa>>2]|0;if((la|0)!=(va|0))UC(la);la=v+36|0;va=f[la>>2]|0;if(va|0?(wa=va+12|0,va=f[wa>>2]|0,f[wa>>2]=va+-1,(va|0)==1):0)kL(v);f[la>>2]=0;f[oa>>2]=0;f[oa+4>>2]=0;f[oa+8>>2]=0;f[oa+12>>2]=0;if((f[ga>>2]|0)>0){oa=f[Z>>2]|0;Z=0;do{f[oa+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[ga>>2]|0))}ga=f[qa>>2]|0;if((ga|0)!=(pa|0))UC(ga);ga=t+36|0;pa=f[ga>>2]|0;do if(pa|0){qa=pa+12|0;Z=f[qa>>2]|0;f[qa>>2]=Z+-1;if((Z|0)!=1)break;kL(t)}while(0);f[ga>>2]=0;f[ea>>2]=0;f[ea+4>>2]=0;f[ea+8>>2]=0;f[ea+12>>2]=0;if((f[da>>2]|0)>0){ea=f[ia>>2]|0;ia=0;do{f[ea+(ia<<2)>>2]=0;ia=ia+1|0}while((ia|0)<(f[da>>2]|0))}da=f[ka>>2]|0;if((da|0)!=(ja|0))UC(da);da=s+36|0;ja=f[da>>2]|0;do if(ja|0){ka=ja+12|0;ia=f[ka>>2]|0;f[ka>>2]=ia+-1;if((ia|0)!=1)break;kL(s)}while(0);f[da>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[H>>2]|0)>0){o=f[g>>2]|0;g=0;do{f[o+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[H>>2]|0))}H=f[aa>>2]|0;if((H|0)!=(_|0))UC(H);H=f[r>>2]|0;if((H|0)!=(J|0)){if(H|0)P5b(H);f[r>>2]=J;f[i>>2]=264}i=f[q>>2]|0;if((i|0)!=(U|0)){if(i|0)P5b(i);f[q>>2]=U;f[V>>2]=264}V=p+36|0;U=f[V>>2]|0;do if(U|0){q=U+12|0;i=f[q>>2]|0;f[q>>2]=i+-1;if((i|0)!=1)break;kL(p)}while(0);f[V>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[L>>2]|0)>0){Q=f[O>>2]|0;O=0;do{f[Q+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[L>>2]|0))}L=f[P>>2]|0;if((L|0)!=(N|0))UC(L);if(!(f[l+4>>2]|0)){u=j;return}u=j;return}function Soa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0;j=u;u=u+384|0;k=j+376|0;l=j+368|0;m=j+40|0;o=j+24|0;q=j+16|0;r=j;s=j+8|0;dQ(k,80216);t=f[d>>2]|0;v=d+4|0;w=f[v>>2]|0;if((w|0)!=(t|0))f[v>>2]=w+(~((w+-8-t|0)>>>3)<<3);t=f[e>>2]|0;w=e+4|0;x=f[w>>2]|0;if((x|0)!=(t|0))f[w>>2]=x+(~((x+-8-t|0)>>>3)<<3);t=a+76|0;x=a+80|0;if((f[t>>2]|0)!=(f[x>>2]|0)?(y=f[c>>2]|0,z=f[c+4>>2]|0,A=z,B=y,(y|0)!=(z|0)):0){z=f[h>>2]|0;y=h+4|0;C=f[y>>2]|0;if(!(C|z)){D=f[a+28>>2]|0;f[h>>2]=D;E=f[a+32>>2]|0;f[y>>2]=E;F=D;G=E}else{F=z;G=C}C=f[a+20>>2]|0;z=(F|0)<(C|0);E=z?C:F;D=z?F:C;if((D|0)>0){C=E;F=D;while(1){D=(C|0)%(F|0)|0;if((D|0)>0){z=F;F=D;C=z}else{H=F;break}}}else H=E;E=f[a+24>>2]|0;F=(G|0)<(E|0);C=F?E:G;z=F?G:E;if((z|0)>0){E=C;G=z;while(1){z=(E|0)%(G|0)|0;if((z|0)>0){F=G;G=z;E=F}else{I=G;break}}}else I=C;f[l>>2]=H;f[l+4>>2]=I;C=A-B>>3;B=f[i>>2]|0;A=H+-1+((B|0)>0?B:0)&0-H;f[i>>2]=A;H=i+4|0;B=f[H>>2]|0;G=I+-1+((B|0)>0?B:0)&0-I;f[H>>2]=G;I=b+12|0;B=(A<<1)+(f[I>>2]|0)|0;A=b+8|0;E=(G<<1)+(f[A>>2]|0)|0;_oa(m,a,b,i,i,1,l);if(!C)J=Y(((E-(f[m+48>>2]|0)|0)/(f[y>>2]|0)|0)+1|0,((B-(f[m+44>>2]|0)|0)/(f[h>>2]|0)|0)+1|0)|0;else J=C;C=f[m+16>>2]|0;h=Y(f[m+64>>2]|0,f[m+60>>2]|0)|0;B=f[m+76>>2]|0;y=$oa(a)|0;E=f[t>>2]|0;if((f[x>>2]|0)-E>>2>>>0>y>>>0)K=+n[E+(y<<2)>>2];else K=0.0;L=K;f[o>>2]=0;y=o+4|0;f[y>>2]=0;f[o+8>>2]=0;do if(B)if(B>>>0>1073741823)c4b(o);else{E=B<<2;x=L5b(E)|0;f[o>>2]=x;l=x+(B<<2)|0;f[o+8>>2]=l;Nac(x|0,0,E|0)|0;f[y>>2]=l;M=x;N=x;break}else{M=0;N=0}while(0);if(!J){O=N;P=M}else{M=q+4|0;N=e+8|0;x=a+4|0;l=a+8|0;a=(h|0)>0;E=s+4|0;b=B+-4|0;G=(B|0)<4;F=d+8|0;z=B&-4;D=(B|0)>0;Q=(z|0)<(B|0);R=0;do{f[q>>2]=0;f[M>>2]=0;S=f[c>>2]|0;T=f[S+(R<<3)>>2]|0;f[q>>2]=T;U=f[S+(R<<3)+4>>2]|0;f[M>>2]=U;S=f[i>>2]|0;if((((T|0)>=(0-S|0)?(T|0)<=((f[I>>2]|0)+S-(f[x>>2]|0)|0):0)?(S=f[H>>2]|0,(U|0)>=(0-S|0)):0)?(U|0)<=((f[A>>2]|0)+S-(f[l>>2]|0)|0):0){p[r>>3]=L;S=f[t>>2]|0;a:do if(a){if(G){V=0;W=S;X=T;Z=U;while(1){_=(f[C+(V*12|0)+8>>2]|0)+Z|0;f[s>>2]=(f[C+(V*12|0)+4>>2]|0)+X;f[E>>2]=_;_=bpa(m,s,f[o>>2]|0)|0;if(D){$=0;K=+p[r>>3];do{K=K+ +n[_+($<<2)>>2]*+n[W+($<<2)>>2];$=$+1|0}while(($|0)!=(B|0));p[r>>3]=K}$=V+1|0;if(($|0)>=(h|0))break a;V=$;W=W+(B<<2)|0;X=f[q>>2]|0;Z=f[M>>2]|0}}else{aa=0;ba=S;ca=T;da=U}while(1){Z=(f[C+(aa*12|0)+8>>2]|0)+da|0;f[s>>2]=(f[C+(aa*12|0)+4>>2]|0)+ca;f[E>>2]=Z;Z=bpa(m,s,f[o>>2]|0)|0;X=0;ea=+p[r>>3];do{W=X|1;V=X|2;$=X|3;ea=ea+(+n[Z+(X<<2)>>2]*+n[ba+(X<<2)>>2]+ +n[Z+(W<<2)>>2]*+n[ba+(W<<2)>>2]+ +n[Z+(V<<2)>>2]*+n[ba+(V<<2)>>2]+ +n[Z+($<<2)>>2]*+n[ba+($<<2)>>2]);X=X+4|0}while((X|0)<=(b|0));p[r>>3]=ea;if(Q){X=z;K=ea;do{K=K+ +n[Z+(X<<2)>>2]*+n[ba+(X<<2)>>2];X=X+1|0}while((X|0)!=(B|0));p[r>>3]=K}X=aa+1|0;if((X|0)>=(h|0))break a;aa=X;ba=ba+(B<<2)|0;ca=f[q>>2]|0;da=f[M>>2]|0}}while(0);U=f[w>>2]|0;if((U|0)==(f[N>>2]|0))apa(e,r);else{p[U>>3]=+p[r>>3];f[w>>2]=U+8}do if(+p[r>>3]>=g){U=f[v>>2]|0;if((U|0)==(f[F>>2]|0)){b2(d,q);break}else{f[U>>2]=f[q>>2];f[U+4>>2]=f[M>>2];f[v>>2]=U+8;break}}while(0)}else{p[r>>3]=-10.0;U=f[w>>2]|0;if((U|0)==(f[N>>2]|0))apa(e,r);else{p[U>>3]=-10.0;f[w>>2]=U+8}}R=R+1|0}while(R>>>0<J>>>0);J=f[o>>2]|0;O=J;P=J}if(O|0){J=f[y>>2]|0;if((J|0)!=(O|0))f[y>>2]=J+(~((J+-4-O|0)>>>2)<<2);O5b(P)}yoa(m)}if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function Toa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=u;u=u+144|0;i=h+128|0;j=h+116|0;k=h+112|0;l=h+104|0;m=h;n=h+96|0;dQ(i,80156);f[j>>2]=0;o=j+4|0;f[o>>2]=0;f[j+8>>2]=0;NO(k);p=(f[d+4>>2]|0)-(f[d>>2]|0)>>5;f[l>>2]=0;f[l+4>>2]=p;f[n>>2]=8;f[n+4>>2]=8;Uoa(m,a,b,e,n,d,j,k);RQ(l,m,-1.0);f[m>>2]=80184;l=m+8|0;d=m+44|0;n=f[d>>2]|0;if(n|0?(b=n+12|0,n=f[b>>2]|0,f[b>>2]=n+-1,(n|0)==1):0)kL(l);f[d>>2]=0;d=m+24|0;l=m+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[l>>2]|0)>0){d=f[m+48>>2]|0;n=0;do{f[d+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}l=f[m+52>>2]|0;if((l|0)!=(m+56|0))UC(l);l=f[o>>2]|0;m=f[j>>2]|0;n=l-m>>4;d=c+4|0;b=f[d>>2]|0;a=f[c>>2]|0;p=b-a>>4;q=a;a=b;b=m;m=l;if(n>>>0<=p>>>0)if(n>>>0<p>>>0?(l=q+(n<<4)|0,(a|0)!=(l|0)):0){f[d>>2]=a+(~((a+-16-l|0)>>>4)<<4);r=b;s=m}else{r=b;s=m}else{Voa(c,n-p|0);r=f[j>>2]|0;s=f[o>>2]|0}if((r|0)!=(s|0)){p=r;r=f[c>>2]|0;while(1){f[r>>2]=f[p>>2];f[r+4>>2]=f[p+4>>2];f[r+8>>2]=f[p+8>>2];f[r+12>>2]=f[p+12>>2];p=p+16|0;if((p|0)==(s|0))break;else r=r+16|0}}vra(c,g,.2);OO(k);k=f[j>>2]|0;if(k|0){j=f[o>>2]|0;if((j|0)!=(k|0))f[o>>2]=j+(~((j+-16-k|0)>>>4)<<4);O5b(k)}if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function Uoa(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f[a>>2]=80184;j=a+8|0;f[j>>2]=1124007936;k=a+12|0;l=a+16|0;m=a+48|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;n=a+56|0;o=a+52|0;f[o>>2]=n;f[n>>2]=0;f[a+60>>2]=0;n=a+76|0;f[n>>2]=0;q=a+80|0;f[q>>2]=0;f[a+4>>2]=b;if((j|0)==(c|0)){r=a+64|0;p[r>>3]=d;s=f[e>>2]|0;f[n>>2]=s;t=e+4|0;u=f[t>>2]|0;f[q>>2]=u;v=a+72|0;f[v>>2]=g;w=a+84|0;f[w>>2]=h;x=a+88|0;f[x>>2]=i;return}b=c+36|0;y=f[b>>2]|0;if(y){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1;z=a+44|0;y=f[z>>2]|0;if((y|0)!=0?(A=y+12|0,y=f[A>>2]|0,f[A>>2]=y+-1,(y|0)==1):0){kL(j);B=z}else B=z}else B=a+44|0;f[B>>2]=0;z=a+24|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[k>>2]|0)>0){y=f[m>>2]|0;m=0;do{f[y+(m<<2)>>2]=0;m=m+1|0;C=f[k>>2]|0}while((m|0)<(C|0));f[j>>2]=f[c>>2];if((C|0)<3)D=12;else D=14}else{f[j>>2]=f[c>>2];D=12}if((D|0)==12){C=f[c+4>>2]|0;if((C|0)<3){f[k>>2]=C;f[l>>2]=f[c+8>>2];f[a+20>>2]=f[c+12>>2];l=f[c+44>>2]|0;C=f[o>>2]|0;f[C>>2]=f[l>>2];f[C+4>>2]=f[l+4>>2]}else D=14}if((D|0)==14)jL(j,c);f[z>>2]=f[c+16>>2];f[a+28>>2]=f[c+20>>2];f[a+32>>2]=f[c+24>>2];f[a+36>>2]=f[c+28>>2];f[a+40>>2]=f[c+32>>2];f[B>>2]=f[b>>2];r=a+64|0;p[r>>3]=d;s=f[e>>2]|0;f[n>>2]=s;t=e+4|0;u=f[t>>2]|0;f[q>>2]=u;v=a+72|0;f[v>>2]=g;w=a+84|0;f[w>>2]=h;x=a+88|0;f[x>>2]=i;return}function Voa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)c4b(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=h;g=k+(d<<4)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-16-j|0;j=b;b=h;while(1){n=j;j=j+-16|0;f[b+-16>>2]=f[j>>2];f[b+-12>>2]=f[n+-12>>2];f[b+-8>>2]=f[n+-8>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-16|0}l=h+(~(i>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;O5b(m);return}function Woa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=80184;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0))return;UC(b);return}function Xoa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=80184;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0)){O5b(a);return}UC(b);O5b(a);return}function Yoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;c=u;u=u+256|0;d=c+232|0;e=c+224|0;g=c+168|0;h=c+104|0;i=c+160|0;j=c+48|0;k=c+40|0;l=c+24|0;m=c+16|0;n=c+8|0;o=c;dQ(e,80196);q=f[b>>2]|0;r=f[b+4>>2]|0;b=a+8|0;s=a+20|0;t=a+72|0;v=+p[f[f[t>>2]>>2]>>3];w=+(f[s>>2]|0)/v;x=~~w;y=(+(x|0)<w&1)+x|0;x=a+16|0;w=+(f[x>>2]|0)/v;z=~~w;A=(+(z|0)<w&1)+z|0;z=f[b>>2]&4095;f[g>>2]=1124007936;B=g+4|0;C=g+8|0;D=g+40|0;E=B;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[D>>2]=C;C=g+48|0;E=g+44|0;f[E>>2]=C;f[C>>2]=0;f[g+52>>2]=0;f[d>>2]=A;f[d+4>>2]=y;hL(g,2,d,z);f[d>>2]=0;z=d+4|0;f[z>>2]=0;f[d+8>>2]=0;if((q|0)<(r|0)){y=i+4|0;A=g+16|0;F=a+48|0;G=k+4|0;H=a+24|0;I=a+56|0;J=j+36|0;K=h+36|0;L=h+16|0;M=h+4|0;N=h+40|0;O=j+4|0;P=j+8|0;Q=h+8|0;R=j+12|0;S=h+12|0;T=j+44|0;U=h+44|0;V=j+16|0;W=j+20|0;X=h+20|0;Y=j+24|0;Z=h+24|0;_=j+28|0;$=h+28|0;aa=j+32|0;ba=h+32|0;ca=j+40|0;da=j+48|0;ea=a+4|0;fa=a+64|0;ga=n+4|0;ha=a+76|0;ia=o+4|0;ja=a+80|0;ka=a+88|0;la=h+48|0;ma=a+84|0;a=j+4|0;na=j+8|0;oa=j+12|0;pa=j+8|0;qa=j+12|0;ra=j+4|0;sa=l+8|0;ta=l+4|0;ua=m+4|0;va=q;do{w=+p[(f[f[t>>2]>>2]|0)+(va<<5)>>3];q=MVb(+(f[s>>2]|0)/w)|0;wa=MVb(+(f[x>>2]|0)/w)|0;f[i>>2]=q;f[y>>2]=wa;JF(h,i,f[b>>2]&4095,f[A>>2]|0,0);xa=f[F>>2]|0;if((wa|0)==(f[xa>>2]|0)?(q|0)==(f[xa+4>>2]|0):0){f[k>>2]=q;f[G>>2]=wa;JF(j,k,f[b>>2]&4095,f[H>>2]|0,f[I>>2]|0);xa=f[J>>2]|0;if(xa|0){ya=xa+12|0;f[ya>>2]=(f[ya>>2]|0)+1}ya=f[K>>2]|0;if(ya|0?(xa=ya+12|0,ya=f[xa>>2]|0,f[xa>>2]=ya+-1,(ya|0)==1):0)kL(h);f[K>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[M>>2]|0)>0){ya=f[N>>2]|0;xa=0;do{f[ya+(xa<<2)>>2]=0;xa=xa+1|0;za=f[M>>2]|0}while((xa|0)<(za|0));f[h>>2]=f[j>>2];if((za|0)<3)Aa=14;else Aa=16}else{f[h>>2]=f[j>>2];Aa=14}if((Aa|0)==14){Aa=0;xa=f[O>>2]|0;if((xa|0)<3){f[M>>2]=xa;f[Q>>2]=f[P>>2];f[S>>2]=f[R>>2];xa=f[T>>2]|0;ya=f[U>>2]|0;f[ya>>2]=f[xa>>2];f[ya+4>>2]=f[xa+4>>2]}else Aa=16}if((Aa|0)==16){Aa=0;jL(h,j)}f[L>>2]=f[V>>2];f[X>>2]=f[W>>2];f[Z>>2]=f[Y>>2];f[$>>2]=f[_>>2];f[ba>>2]=f[aa>>2];xa=f[J>>2]|0;f[K>>2]=xa;if(xa|0?(ya=xa+12|0,xa=f[ya>>2]|0,f[ya>>2]=xa+-1,(xa|0)==1):0)kL(j);f[J>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[O>>2]|0)>0){xa=f[ca>>2]|0;ya=0;do{f[xa+(ya<<2)>>2]=0;ya=ya+1|0}while((ya|0)<(f[O>>2]|0))}ya=f[T>>2]|0;if((ya|0)!=(da|0))UC(ya)}else{f[pa>>2]=0;f[qa>>2]=0;f[j>>2]=16842752;f[ra>>2]=b;ya=sa;f[ya>>2]=0;f[ya+4>>2]=0;f[l>>2]=33619968;f[ta>>2]=h;f[m>>2]=q;f[ua>>2]=wa;Lia(j,l,m,0.0,0.0,5)}ya=f[ea>>2]|0;xa=f[(f[ya>>2]|0)+56>>2]|0;Ba=f[f[t>>2]>>2]|0;v=+p[fa>>3];f[n>>2]=0;f[ga>>2]=0;f[o>>2]=f[ha>>2];f[ia>>2]=f[ja>>2];Mh[xa&7](ya,h,Ba+(va<<5)+8|0,d,Ba+(va<<5)+20|0,v,n,o);Ba=f[ea>>2]|0;ya=MVb(w*+(f[Ba+4>>2]|0))|0;xa=MVb(w*+(f[Ba+8>>2]|0))|0;PO(f[ka>>2]|0);Ba=f[z>>2]|0;Ca=f[d>>2]|0;if((Ba|0)!=(Ca|0)){Da=0;Ea=Ca;Ca=Ba;while(1){Ba=Ea;Fa=f[ma>>2]|0;Ga=MVb(w*+(f[Ba+(Da<<3)>>2]|0))|0;Ha=MVb(w*+(f[Ba+(Da<<3)+4>>2]|0))|0;f[j>>2]=Ga;f[a>>2]=Ha;f[na>>2]=ya;f[oa>>2]=xa;Ba=Fa+4|0;Ia=f[Ba>>2]|0;if((Ia|0)==(f[Fa+8>>2]|0)){Zoa(Fa,j);Ja=f[d>>2]|0;Ka=f[z>>2]|0}else{f[Ia>>2]=Ga;f[Ia+4>>2]=Ha;f[Ia+8>>2]=ya;f[Ia+12>>2]=xa;f[Ba>>2]=Ia+16;Ja=Ea;Ka=Ca}Da=Da+1|0;if(Da>>>0>=Ka-Ja>>3>>>0)break;else{Ea=Ja;Ca=Ka}}}QO(f[ka>>2]|0);Ca=f[K>>2]|0;if(Ca|0?(Ea=Ca+12|0,Ca=f[Ea>>2]|0,f[Ea>>2]=Ca+-1,(Ca|0)==1):0)kL(h);f[K>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[M>>2]|0)>0){Ca=f[N>>2]|0;Ea=0;do{f[Ca+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[M>>2]|0))}Ea=f[U>>2]|0;if((Ea|0)!=(la|0))UC(Ea);va=va+1|0}while((va|0)<(r|0));r=f[d>>2]|0;if(r|0){d=f[z>>2]|0;if((d|0)!=(r|0))f[z>>2]=d+(~((d+-8-r|0)>>>3)<<3);O5b(r)}}r=g+36|0;d=f[r>>2]|0;if(d|0?(z=d+12|0,d=f[z>>2]|0,f[z>>2]=d+-1,(d|0)==1):0)kL(g);f[r>>2]=0;r=g+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[B>>2]|0)>0){r=f[D>>2]|0;D=0;do{f[r+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[B>>2]|0))}B=f[E>>2]|0;if((B|0)!=(C|0))UC(B);if(!(f[e+4>>2]|0)){u=c;return}u=c;return}function Zoa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)c4b(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=ze(8)|0;T5b(l,477177);f[l>>2]=149528;If(l|0,25408,1411)}else{n=L5b(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;while(1){m=n;n=n+-16|0;f[j+-16>>2]=f[n>>2];f[j+-12>>2]=f[m+-12>>2];f[j+-8>>2]=f[m+-8>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;O5b(e);return}function _oa(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;f[a>>2]=80068;i=a+4|0;j=a+32|0;f[a+92>>2]=0;f[a+96>>2]=0;k=a+100|0;l=a+108|0;m=a+140|0;n=a+104|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;n=j;o=n+44|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=a+148|0;f[a+144>>2]=l;f[l>>2]=0;f[a+152>>2]=0;f[k>>2]=1124007941;k=a+156|0;l=a+164|0;m=a+196|0;n=a+160|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;l=a+204|0;f[a+200>>2]=l;f[l>>2]=0;f[a+208>>2]=0;f[k>>2]=1124007936;f[a+212>>2]=1124007936;k=a+220|0;l=a+252|0;n=a+216|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[l>>2]=k;k=a+260|0;f[a+256>>2]=k;f[k>>2]=0;f[a+264>>2]=0;f[a+268>>2]=1124007936;k=a+276|0;l=a+308|0;n=a+272|0;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[l>>2]=k;k=a+316|0;f[a+312>>2]=k;f[k>>2]=0;f[a+320>>2]=0;Qh[f[(f[a>>2]|0)+8>>2]&127](a,b,c,d,e,g,h);return}function $oa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;c=u;u=u+16|0;d=c;e=a+12|0;g=f[e>>2]|0;h=a+28|0;if(((g|0)%(f[h>>2]|0)|0|0)==0?((f[a+16>>2]|0)%(f[a+32>>2]|0)|0|0)==0:0)i=g;else{f[d>>2]=0;f[d+4>>2]=0;j=aD(d,80)|0;k=348692;l=j+80|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,d,348773,348385,90);bD(d);i=f[e>>2]|0}g=a+4|0;m=f[g>>2]|0;n=a+20|0;o=f[n>>2]|0;if(((m-i|0)%(o|0)|0|0)==0?(p=f[a+8>>2]|0,q=f[a+16>>2]|0,r=f[a+24>>2]|0,((p-q|0)%(r|0)|0|0)==0):0){s=i;t=q;v=m;w=o;x=p;y=r}else{f[d>>2]=0;f[d+4>>2]=0;j=aD(d,123)|0;k=348791;l=j+123|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,d,348773,348385,92);bD(d);s=f[e>>2]|0;t=f[a+16>>2]|0;v=f[g>>2]|0;w=f[n>>2]|0;x=f[a+8>>2]|0;y=f[a+24>>2]|0}n=Y((s|0)/(f[h>>2]|0)|0,f[a+36>>2]|0)|0;h=Y(Y(Y(n,(t|0)/(f[a+32>>2]|0)|0)|0,((v-s|0)/(w|0)|0)+1|0)|0,((x-t|0)/(y|0)|0)+1|0)|0;u=c;return h|0}function apa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;p[k>>3]=+p[b>>3];b=k+(0-g<<3)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;O5b(d);return}function bpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0,H=0.0,I=0.0,J=0;e=u;u=u+96|0;g=e;i=e+88|0;j=e+32|0;k=f[a+96>>2]|0;l=(f[c>>2]|0)+(f[a+92>>2]|0)|0;f[c>>2]=l;m=c+4|0;o=(f[m>>2]|0)+k|0;f[m>>2]=o;do if(b[a+28>>0]|0){k=a+52|0;p=f[k>>2]|0;if(((l|0)%(p|0)|0|0)==0?(q=f[a+56>>2]|0,((o|0)%(q|0)|0|0)==0):0){r=p;s=l;t=q;v=o}else{f[g>>2]=0;f[g+4>>2]=0;q=aD(g,63)|0;p=348619;w=q+63|0;do{b[q>>0]=b[p>>0]|0;q=q+1|0;p=p+1|0}while((q|0)<(w|0));bO(-215,g,348683,348385,875);bD(g);r=f[k>>2]|0;s=f[c>>2]|0;t=f[a+56>>2]|0;v=f[m>>2]|0}p=(s|0)/(r|0)|0;q=((v|0)/(t|0)|0|0)%(f[a+108>>2]|0)|0;w=a+32|0;if((v|0)!=(f[(f[w>>2]|0)+(q<<2)>>2]|0)){f[g>>2]=q;f[g+4>>2]=q+1;f[i>>2]=-2147483648;f[i+4>>2]=2147483647;lL(j,a+156|0,g,i);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;f[g+24>>2]=0;f[g+28>>2]=0;UP(j,g)|0;f[(f[w>>2]|0)+(q<<2)>>2]=f[m>>2];w=j+36|0;x=f[w>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)kL(j);f[w>>2]=0;w=j+16|0;x=j+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[x>>2]|0)>0){w=f[j+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[j+44>>2]|0;if((x|0)!=(j+48|0))UC(x)}x=(f[a+116>>2]|0)+(Y(f[f[a+144>>2]>>2]|0,q)|0)|0;y=a+76|0;w=x+((Y(f[y>>2]|0,p)|0)<<2)|0;x=(f[a+172>>2]|0)+(Y(f[f[a+200>>2]>>2]|0,q)|0)+p|0;if(!(b[x>>0]|0)){b[x>>0]=1;z=w;A=y;B=f[c>>2]|0;C=f[m>>2]|0;break}else{D=w;u=e;return D|0}}else{z=d;A=a+76|0;B=l;C=o}while(0);o=f[a+80>>2]|0;l=f[a+84>>2]|0;d=f[a+88>>2]|0;m=B<<1;B=(f[a+228>>2]|0)+(Y(f[f[a+256>>2]>>2]|0,C)|0)+(m<<2)|0;c=(f[a+284>>2]|0)+(Y(f[f[a+312>>2]>>2]|0,C)|0)+m|0;Nac(z|0,0,f[A>>2]<<2|0)|0;A=f[a+4>>2]|0;if((o|0)>0){m=0;do{C=B+(f[A+(m*44|0)>>2]<<2)|0;E=+n[A+(m*44|0)+40>>2]*+n[A+(m*44|0)+24>>2];j=c+(f[A+(m*44|0)+4>>2]|0)|0;g=z+(f[A+(m*44|0)+8>>2]<<2)|0;i=g+(h[j>>0]<<2)|0;v=g+(h[j+1>>0]<<2)|0;F=+n[v>>2]+E*+n[C+4>>2];n[i>>2]=+n[i>>2]+E*+n[C>>2];n[v>>2]=F;m=m+1|0}while((m|0)!=(o|0));G=o}else G=0;if((G|0)<(l|0)){o=G;do{m=B+(f[A+(o*44|0)>>2]<<2)|0;F=+n[m>>2];E=+n[m+4>>2];m=c+(f[A+(o*44|0)+4>>2]|0)|0;v=h[m>>0]|0;C=h[m+1>>0]|0;m=z+(f[A+(o*44|0)+8>>2]<<2)|0;i=A+(o*44|0)+40|0;H=+n[i>>2]*+n[A+(o*44|0)+24>>2];j=m+(v<<2)|0;g=m+(C<<2)|0;I=+n[g>>2]+E*H;n[j>>2]=+n[j>>2]+F*H;n[g>>2]=I;g=z+(f[A+(o*44|0)+12>>2]<<2)|0;I=+n[i>>2]*+n[A+(o*44|0)+28>>2];i=g+(v<<2)|0;v=g+(C<<2)|0;H=+n[v>>2]+E*I;n[i>>2]=+n[i>>2]+F*I;n[v>>2]=H;o=o+1|0}while((o|0)!=(l|0));J=l}else J=G;if((J|0)<(d|0)){G=J;do{J=B+(f[A+(G*44|0)>>2]<<2)|0;H=+n[J>>2];I=+n[J+4>>2];J=c+(f[A+(G*44|0)+4>>2]|0)|0;l=h[J>>0]|0;o=h[J+1>>0]|0;J=z+(f[A+(G*44|0)+8>>2]<<2)|0;v=A+(G*44|0)+40|0;F=+n[v>>2]*+n[A+(G*44|0)+24>>2];i=J+(l<<2)|0;C=J+(o<<2)|0;E=+n[C>>2]+I*F;n[i>>2]=+n[i>>2]+H*F;n[C>>2]=E;C=z+(f[A+(G*44|0)+12>>2]<<2)|0;E=+n[v>>2]*+n[A+(G*44|0)+28>>2];i=C+(l<<2)|0;J=C+(o<<2)|0;F=+n[J>>2]+I*E;n[i>>2]=+n[i>>2]+H*E;n[J>>2]=F;J=z+(f[A+(G*44|0)+16>>2]<<2)|0;F=+n[v>>2]*+n[A+(G*44|0)+32>>2];i=J+(l<<2)|0;C=J+(o<<2)|0;E=+n[C>>2]+I*F;n[i>>2]=+n[i>>2]+H*F;n[C>>2]=E;C=z+(f[A+(G*44|0)+20>>2]<<2)|0;E=+n[v>>2]*+n[A+(G*44|0)+36>>2];v=C+(l<<2)|0;l=C+(o<<2)|0;F=+n[l>>2]+I*E;n[v>>2]=+n[v>>2]+H*E;n[l>>2]=F;G=G+1|0}while((G|0)!=(d|0))}zh[f[(f[a>>2]|0)+12>>2]&2047](a,z);D=z;u=e;return D|0}function cpa(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;f[a>>2]=80304;m=a+8|0;f[m>>2]=1124007936;n=a+12|0;o=a+16|0;q=a+48|0;r=n;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=o;r=a+56|0;s=a+52|0;f[s>>2]=r;f[r>>2]=0;f[a+60>>2]=0;r=a+72|0;t=a+76|0;u=a+80|0;v=a+84|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[a+4>>2]=b;if((m|0)==(c|0)){w=a+64|0;p[w>>3]=d;x=f[e>>2]|0;f[r>>2]=x;y=e+4|0;z=f[y>>2]|0;f[t>>2]=z;A=f[g>>2]|0;f[u>>2]=A;B=g+4|0;C=f[B>>2]|0;f[v>>2]=C;D=a+88|0;f[D>>2]=h;E=a+92|0;f[E>>2]=i;F=a+96|0;f[F>>2]=k;G=a+100|0;f[G>>2]=l;H=a+104|0;f[H>>2]=j;return}b=c+36|0;I=f[b>>2]|0;if(I){J=I+12|0;f[J>>2]=(f[J>>2]|0)+1;J=a+44|0;I=f[J>>2]|0;if((I|0)!=0?(K=I+12|0,I=f[K>>2]|0,f[K>>2]=I+-1,(I|0)==1):0){kL(m);L=J}else L=J}else L=a+44|0;f[L>>2]=0;J=a+24|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[n>>2]|0)>0){I=f[q>>2]|0;q=0;do{f[I+(q<<2)>>2]=0;q=q+1|0;M=f[n>>2]|0}while((q|0)<(M|0));f[m>>2]=f[c>>2];if((M|0)<3)N=12;else N=14}else{f[m>>2]=f[c>>2];N=12}if((N|0)==12){M=f[c+4>>2]|0;if((M|0)<3){f[n>>2]=M;f[o>>2]=f[c+8>>2];f[a+20>>2]=f[c+12>>2];o=f[c+44>>2]|0;M=f[s>>2]|0;f[M>>2]=f[o>>2];f[M+4>>2]=f[o+4>>2]}else N=14}if((N|0)==14)jL(m,c);f[J>>2]=f[c+16>>2];f[a+28>>2]=f[c+20>>2];f[a+32>>2]=f[c+24>>2];f[a+36>>2]=f[c+28>>2];f[a+40>>2]=f[c+32>>2];f[L>>2]=f[b>>2];w=a+64|0;p[w>>3]=d;x=f[e>>2]|0;f[r>>2]=x;y=e+4|0;z=f[y>>2]|0;f[t>>2]=z;A=f[g>>2]|0;f[u>>2]=A;B=g+4|0;C=f[B>>2]|0;f[v>>2]=C;D=a+88|0;f[D>>2]=h;E=a+92|0;f[E>>2]=i;F=a+96|0;f[F>>2]=k;G=a+100|0;f[G>>2]=l;H=a+104|0;f[H>>2]=j;return}function dpa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;a=u;u=u+96|0;h=a+16|0;i=a+88|0;j=a+72|0;k=a+8|0;l=a+60|0;m=a+48|0;n=a+32|0;o=a;dQ(i,80316);if((e|0)>=1?(q=f[c>>2]|0,r=c+4|0,s=f[r>>2]|0,(q|0)!=(s|0)):0){t=d+4|0;if((s-q>>4|0)!=((f[t>>2]|0)-(f[d>>2]|0)>>3|0)){f[h>>2]=0;f[h+4>>2]=0;q=aD(h,33)|0;s=349448;v=q+33|0;do{b[q>>0]=b[s>>0]|0;q=q+1|0;s=s+1|0}while((q|0)<(v|0));bO(-215,h,349482,348385,3793);bD(h)}f[j>>2]=0;s=j+4|0;f[s>>2]=0;f[j+8>>2]=0;p[k>>3]=g;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];k=epa(c,j,h)|0;f[h>>2]=0;q=h+4|0;f[q>>2]=0;f[h+8>>2]=0;v=(k|0)==0;do if(!v)if(k>>>0>134217727)c4b(h);else{w=k<<5;x=L5b(w)|0;f[h>>2]=x;f[h+8>>2]=x+(k<<5);Nac(x|0,0,w|0)|0;f[q>>2]=x+w;y=x;break}else y=0;while(0);f[l>>2]=0;x=l+4|0;f[x>>2]=0;f[l+8>>2]=0;if(v)z=0;else{w=k<<2;A=L5b(w)|0;f[l>>2]=A;B=A+(k<<2)|0;f[l+8>>2]=B;Nac(A|0,0,w|0)|0;f[x>>2]=B;z=A}f[m>>2]=0;A=m+4|0;f[A>>2]=0;f[m+8>>2]=0;if(v){C=0;D=0}else{v=L5b(k<<3)|0;f[A>>2]=v;f[m>>2]=v;B=v+(k<<3)|0;f[m+8>>2]=B;w=k;E=v;while(1){p[E>>3]=-1797693134862315708145274.0e284;w=w+-1|0;if(!w)break;else E=E+8|0}f[A>>2]=B;C=v;D=v}v=f[j>>2]|0;B=(f[s>>2]|0)-v|0;E=B>>2;w=v;if((B|0)>0){B=0;do{v=f[w+(B<<2)>>2]|0;F=f[c>>2]|0;G=y+(v<<5)|0;p[G>>3]=+(f[F+(B<<4)>>2]|0)+ +p[G>>3];G=y+(v<<5)+8|0;p[G>>3]=+(f[F+(B<<4)+4>>2]|0)+ +p[G>>3];G=y+(v<<5)+16|0;p[G>>3]=+(f[F+(B<<4)+8>>2]|0)+ +p[G>>3];G=y+(v<<5)+24|0;p[G>>3]=+(f[F+(B<<4)+12>>2]|0)+ +p[G>>3];G=D+(v<<3)|0;H=+p[G>>3];I=+p[(f[d>>2]|0)+(B<<3)>>3];p[G>>3]=H<I?I:H;G=z+(v<<2)|0;f[G>>2]=(f[G>>2]|0)+1;B=B+1|0}while((B|0)<(E|0))}E=(k|0)>0;if(E){B=0;do{w=y+(B<<5)|0;G=y+(B<<5)+8|0;v=y+(B<<5)+16|0;F=y+(B<<5)+24|0;H=1.0/+(f[z+(B<<2)>>2]|0);I=+p[G>>3]*H;J=+p[v>>3]*H;K=+p[F>>3]*H;p[w>>3]=+p[w>>3]*H;p[G>>3]=I;p[v>>3]=J;p[F>>3]=K;B=B+1|0}while((B|0)!=(k|0))}B=f[c>>2]|0;F=f[r>>2]|0;if((F|0)!=(B|0))f[r>>2]=F+(~((F+-16-B|0)>>>4)<<4);B=f[d>>2]|0;F=f[t>>2]|0;if((F|0)!=(B|0))f[t>>2]=F+(~((F+-8-B|0)>>>3)<<3);if(E){E=n+4|0;B=n+8|0;F=n+12|0;v=c+8|0;G=d+8|0;w=f[l>>2]|0;L=f[m>>2]|0;M=0;N=y;y=z;z=D;while(1){O=MVb(+p[N+(M<<5)>>3])|0;P=MVb(+p[N+(M<<5)+8>>3])|0;Q=MVb(+p[N+(M<<5)+16>>3])|0;R=MVb(+p[N+(M<<5)+24>>3])|0;f[n>>2]=O;f[E>>2]=P;f[B>>2]=Q;f[F>>2]=R;S=f[y+(M<<2)>>2]|0;p[o>>3]=+p[z+(M<<3)>>3];do if((S|0)>(e|0)){T=f[h>>2]|0;U=Q+O|0;V=R+P|0;W=(S|0)>3?S:3;a:do if((S|0)<3){X=0;while(1){do if((X|0)!=(M|0)?(f[y+(X<<2)>>2]|0)>(e|0):0){Y=MVb(+p[T+(X<<5)>>3])|0;Z=MVb(+p[T+(X<<5)+8>>3])|0;_=MVb(+p[T+(X<<5)+16>>3])|0;$=MVb(+p[T+(X<<5)+24>>3])|0;aa=MVb(+(_|0)*g)|0;ba=MVb(+($|0)*g)|0;if((O|0)<(Y-aa|0)|(P|0)<(Z-ba|0))break;if((U|0)>(_+Y+aa|0))break;if((V|0)<=($+Z+ba|0)){ca=X;break a}}while(0);ba=X+1|0;if((ba|0)<(k|0))X=ba;else{ca=ba;break}}}else{X=0;while(1){ba=f[y+(X<<2)>>2]|0;do if((X|0)!=(M|0)&(ba|0)>(e|0)){Z=MVb(+p[T+(X<<5)>>3])|0;$=MVb(+p[T+(X<<5)+8>>3])|0;aa=MVb(+p[T+(X<<5)+16>>3])|0;Y=MVb(+p[T+(X<<5)+24>>3])|0;_=MVb(+(aa|0)*g)|0;da=MVb(+(Y|0)*g)|0;if((O|0)<(Z-_|0)|(P|0)<($-da|0))break;if((U|0)>(aa+Z+_|0))break;if((ba|0)>(W|0)?(V|0)<=(Y+$+da|0):0){ca=X;break a}}while(0);ba=X+1|0;if((ba|0)<(k|0))X=ba;else{ca=ba;break}}}while(0);if((ca|0)==(k|0)){V=f[r>>2]|0;if((V|0)==(f[v>>2]|0))Zoa(c,n);else{f[V>>2]=O;f[V+4>>2]=P;f[V+8>>2]=Q;f[V+12>>2]=R;f[r>>2]=V+16}V=f[t>>2]|0;if((V|0)==(f[G>>2]|0)){apa(d,o);break}else{p[V>>3]=+p[o>>3];f[t>>2]=V+8;break}}}while(0);R=M+1|0;if((R|0)>=(k|0))break;M=R;N=f[h>>2]|0;y=w;z=L}L=f[m>>2]|0;ea=L;fa=L}else{ea=D;fa=C}if(ea|0){C=f[A>>2]|0;if((C|0)!=(ea|0))f[A>>2]=C+(~((C+-8-ea|0)>>>3)<<3);O5b(fa)}fa=f[l>>2]|0;if(fa|0){l=f[x>>2]|0;if((l|0)!=(fa|0))f[x>>2]=l+(~((l+-4-fa|0)>>>2)<<2);O5b(fa)}fa=f[h>>2]|0;if(fa|0){h=f[q>>2]|0;if((h|0)!=(fa|0))f[q>>2]=h+(~((h+-32-fa|0)>>>5)<<5);O5b(fa)}fa=f[j>>2]|0;if(fa|0){j=f[s>>2]|0;if((j|0)!=(fa|0))f[s>>2]=j+(~((j+-4-fa|0)>>>2)<<2);O5b(fa)}}if(!(f[i+4>>2]|0)){u=a;return}u=a;return}function epa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=u;u=u+32|0;g=e+8|0;h=e;i=f[a>>2]|0;j=(f[a+4>>2]|0)-i|0;a=j>>4;k=i;i=j>>3;f[g>>2]=0;l=g+4|0;f[l>>2]=0;f[g+8>>2]=0;do if(i)if(i>>>0>1073741823)c4b(g);else{m=j>>1;n=L5b(m)|0;f[g>>2]=n;o=n+(i<<2)|0;f[g+8>>2]=o;Nac(n|0,0,m|0)|0;f[l>>2]=o;q=n;break}else q=0;while(0);i=(j|0)>0;if(i){j=0;do{f[q+(j<<3)>>2]=-1;f[q+(j<<3)+4>>2]=0;j=j+1|0}while((j|0)<(a|0));if(i){j=h+4|0;n=0;do{o=n;while(1){m=f[q+(o<<3)>>2]|0;if((m|0)>-1)o=m;else break}m=k+(n<<4)+8|0;r=k+(n<<4)+12|0;s=k+(n<<4)|0;t=k+(n<<4)+4|0;v=q+(n<<3)|0;w=0;x=o;while(1){if(((((n|0)!=(w|0)?(y=f[k+(w<<4)+8>>2]|0,z=f[m>>2]|0,A=f[k+(w<<4)+12>>2]|0,B=f[r>>2]|0,C=+p[d>>3]*+(((B|0)>(A|0)?A:B)+((z|0)>(y|0)?y:z)|0)*.5,D=f[s>>2]|0,E=f[k+(w<<4)>>2]|0,F=D-E|0,+(((F|0)>-1?F:0-F|0)|0)<=C):0)?(F=f[t>>2]|0,G=f[k+(w<<4)+4>>2]|0,H=F-G|0,+(((H|0)>-1?H:0-H|0)|0)<=C):0)?(H=z-y+D-E|0,+(((H|0)>-1?H:0-H|0)|0)<=C):0)?(H=B-A+F-G|0,+(((H|0)>-1?H:0-H|0)|0)<=C):0){H=w;while(1){I=q+(H<<3)|0;G=f[I>>2]|0;if((G|0)>-1)H=G;else break}if((H|0)!=(x|0)){G=f[q+(x<<3)+4>>2]|0;F=q+(H<<3)+4|0;A=f[F>>2]|0;if((G|0)>(A|0)){f[I>>2]=x;J=x}else{f[q+(x<<3)>>2]=H;f[F>>2]=((G|0)==(A|0)&1)+A;J=H}if((f[q+(J<<3)>>2]|0)>=0){f[h>>2]=0;f[j>>2]=0;A=aD(h,23)|0;G=349498;F=A+23|0;do{b[A>>0]=b[G>>0]|0;A=A+1|0;G=G+1|0}while((A|0)<(F|0));bO(-215,h,349522,349532,490);bD(h)}G=q+(w<<3)|0;A=f[G>>2]|0;if((A|0)>-1){F=A;A=G;do{f[A>>2]=J;A=q+(F<<3)|0;F=f[A>>2]|0}while((F|0)>-1)}F=f[v>>2]|0;if((F|0)>-1){A=v;G=F;do{f[A>>2]=J;A=q+(G<<3)|0;G=f[A>>2]|0}while((G|0)>-1);K=J}else K=J}else K=x}else K=x;w=w+1|0;if((w|0)>=(a|0))break;else x=K}n=n+1|0}while((n|0)<(a|0))}}n=c+4|0;K=f[n>>2]|0;J=f[c>>2]|0;h=K-J>>2;j=J;J=K;if(a>>>0<=h>>>0){if(a>>>0<h>>>0?(K=j+(a<<2)|0,(J|0)!=(K|0)):0)f[n>>2]=J+(~((J+-4-K|0)>>>2)<<2)}else HC(c,a-h|0);if(i){i=f[c>>2]|0;c=0;h=0;while(1){K=h;while(1){J=f[q+(K<<3)>>2]|0;if((J|0)>-1)K=J;else break}J=q+(K<<3)+4|0;n=f[J>>2]|0;if((n|0)>-1){j=~c;f[J>>2]=j;L=c+1|0;M=j}else{L=c;M=n}f[i+(h<<2)>>2]=~M;h=h+1|0;if((h|0)>=(a|0)){N=L;break}else c=L}}else N=0;L=f[g>>2]|0;if(!L){u=e;return N|0}g=f[l>>2]|0;if((g|0)!=(L|0))f[l>>2]=g+(~((g+-4-L|0)>>>2)<<2);O5b(L);u=e;return N|0}function fpa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=80304;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0))return;UC(b);return}function gpa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=80304;b=a+8|0;c=a+44|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+24|0;b=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+48>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+52>>2]|0;if((b|0)==(a+56|0)){O5b(a);return}UC(b);O5b(a);return}function hpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0;c=u;u=u+272|0;d=c+248|0;e=c+192|0;g=c+176|0;h=c;i=c+112|0;j=c+168|0;k=c+56|0;l=c+48|0;m=c+32|0;n=c+24|0;o=c+16|0;q=c+8|0;r=f[b>>2]|0;s=f[b+4>>2]|0;do if((r|0)<=0)if((s|0)>1){t=+p[(f[a+88>>2]|0)+(r+1<<3)>>3];break}else{b=f[a+20>>2]|0;v=f[a+16>>2]|0;t=+(((b|0)<(v|0)?v:b)|0);break}else t=+p[(f[a+88>>2]|0)+(r<<3)>>3];while(0);b=a+8|0;v=a+20|0;w=+(f[v>>2]|0)/t;x=~~w;y=(+(x|0)<w&1)+x|0;x=a+16|0;w=+(f[x>>2]|0)/t;z=~~w;A=(+(z|0)<w&1)+z|0;z=f[b>>2]&4095;f[e>>2]=1124007936;B=e+4|0;C=e+8|0;D=e+40|0;E=B;F=E+36|0;do{f[E>>2]=0;E=E+4|0}while((E|0)<(F|0));f[D>>2]=C;C=e+48|0;E=e+44|0;f[E>>2]=C;f[C>>2]=0;f[e+52>>2]=0;f[d>>2]=A;f[d+4>>2]=y;hL(e,2,d,z);f[d>>2]=0;z=d+4|0;f[z>>2]=0;f[d+8>>2]=0;f[g>>2]=0;y=g+4|0;f[y>>2]=0;f[g+8>>2]=0;if((r|0)<(s|0)){A=a+88|0;F=j+4|0;G=e+16|0;H=a+48|0;I=l+4|0;J=a+24|0;K=a+56|0;L=k+36|0;M=i+36|0;N=i+16|0;O=i+4|0;P=i+40|0;Q=k+4|0;R=k+8|0;S=i+8|0;T=k+12|0;U=i+12|0;V=k+44|0;W=i+44|0;X=k+16|0;Y=k+20|0;Z=i+20|0;_=k+24|0;$=i+24|0;aa=k+28|0;ba=i+28|0;ca=k+32|0;da=i+32|0;ea=k+40|0;fa=k+48|0;ga=a+4|0;ha=a+64|0;ia=a+72|0;ja=o+4|0;ka=a+76|0;la=a+80|0;ma=q+4|0;na=a+84|0;oa=k+4|0;pa=k+8|0;qa=a+104|0;ra=a+96|0;sa=i+48|0;ta=a+92|0;ua=k+4|0;va=k+8|0;wa=k+12|0;xa=a+100|0;a=k+8|0;ya=k+12|0;za=k+4|0;Aa=m+8|0;Ba=m+4|0;Ca=n+4|0;Da=r;do{w=+p[(f[A>>2]|0)+(Da<<3)>>3];p[h>>3]=w;r=MVb(+(f[v>>2]|0)/w)|0;Ea=MVb(+(f[x>>2]|0)/w)|0;f[j>>2]=r;f[F>>2]=Ea;JF(i,j,f[b>>2]&4095,f[G>>2]|0,0);Fa=f[H>>2]|0;if((Ea|0)==(f[Fa>>2]|0)?(r|0)==(f[Fa+4>>2]|0):0){f[l>>2]=r;f[I>>2]=Ea;JF(k,l,f[b>>2]&4095,f[J>>2]|0,f[K>>2]|0);Fa=f[L>>2]|0;if(Fa|0){Ga=Fa+12|0;f[Ga>>2]=(f[Ga>>2]|0)+1}Ga=f[M>>2]|0;if(Ga|0?(Fa=Ga+12|0,Ga=f[Fa>>2]|0,f[Fa>>2]=Ga+-1,(Ga|0)==1):0)kL(i);f[M>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[O>>2]|0)>0){Ga=f[P>>2]|0;Fa=0;do{f[Ga+(Fa<<2)>>2]=0;Fa=Fa+1|0;Ha=f[O>>2]|0}while((Fa|0)<(Ha|0));f[i>>2]=f[k>>2];if((Ha|0)<3)Ia=19;else Ia=21}else{f[i>>2]=f[k>>2];Ia=19}if((Ia|0)==19){Ia=0;Fa=f[Q>>2]|0;if((Fa|0)<3){f[O>>2]=Fa;f[S>>2]=f[R>>2];f[U>>2]=f[T>>2];Fa=f[V>>2]|0;Ga=f[W>>2]|0;f[Ga>>2]=f[Fa>>2];f[Ga+4>>2]=f[Fa+4>>2]}else Ia=21}if((Ia|0)==21){Ia=0;jL(i,k)}f[N>>2]=f[X>>2];f[Z>>2]=f[Y>>2];f[$>>2]=f[_>>2];f[ba>>2]=f[aa>>2];f[da>>2]=f[ca>>2];Fa=f[L>>2]|0;f[M>>2]=Fa;if(Fa|0?(Ga=Fa+12|0,Fa=f[Ga>>2]|0,f[Ga>>2]=Fa+-1,(Fa|0)==1):0)kL(k);f[L>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Q>>2]|0)>0){Fa=f[ea>>2]|0;Ga=0;do{f[Fa+(Ga<<2)>>2]=0;Ga=Ga+1|0}while((Ga|0)<(f[Q>>2]|0))}Ga=f[V>>2]|0;if((Ga|0)!=(fa|0))UC(Ga)}else{f[a>>2]=0;f[ya>>2]=0;f[k>>2]=16842752;f[za>>2]=b;Ga=Aa;f[Ga>>2]=0;f[Ga+4>>2]=0;f[m>>2]=33619968;f[Ba>>2]=i;f[n>>2]=r;f[Ca>>2]=Ea;Lia(k,m,n,0.0,0.0,5)}Ga=f[ga>>2]|0;Fa=f[(f[Ga>>2]|0)+36>>2]|0;w=+p[ha>>3];f[o>>2]=f[ia>>2];f[ja>>2]=f[ka>>2];f[q>>2]=f[la>>2];f[ma>>2]=f[na>>2];f[k>>2]=0;f[oa>>2]=0;f[pa>>2]=0;Tf[Fa&7](Ga,i,d,g,w,o,q,k);Ga=f[k>>2]|0;if(Ga|0){Fa=f[oa>>2]|0;if((Fa|0)!=(Ga|0))f[oa>>2]=Fa+(~((Fa+-8-Ga|0)>>>3)<<3);O5b(Ga)}Ga=f[ga>>2]|0;w=+p[h>>3];Fa=MVb(+(f[Ga+4>>2]|0)*w)|0;Ja=MVb(w*+(f[Ga+8>>2]|0))|0;PO(f[qa>>2]|0);Ga=f[d>>2]|0;if((f[z>>2]|0)!=(Ga|0)){Ka=0;La=Ga;do{Ga=La;Ma=f[ta>>2]|0;w=+p[h>>3];Na=MVb(+(f[Ga+(Ka<<3)>>2]|0)*w)|0;Oa=MVb(w*+(f[Ga+(Ka<<3)+4>>2]|0))|0;f[k>>2]=Na;f[ua>>2]=Oa;f[va>>2]=Fa;f[wa>>2]=Ja;Ga=Ma+4|0;Pa=f[Ga>>2]|0;if((Pa|0)==(f[Ma+8>>2]|0))Zoa(Ma,k);else{f[Pa>>2]=Na;f[Pa+4>>2]=Oa;f[Pa+8>>2]=Fa;f[Pa+12>>2]=Ja;f[Ga>>2]=Pa+16}Pa=f[xa>>2]|0;do if(Pa|0){Ga=Pa+4|0;Oa=f[Ga>>2]|0;if((Oa|0)==(f[Pa+8>>2]|0)){apa(Pa,h);break}else{p[Oa>>3]=+p[h>>3];f[Ga>>2]=Oa+8;break}}while(0);Ka=Ka+1|0;La=f[d>>2]|0}while(Ka>>>0<(f[z>>2]|0)-La>>3>>>0)}QO(f[qa>>2]|0);if(f[ra>>2]|0?(f[g>>2]|0)!=(f[y>>2]|0):0){PO(f[qa>>2]|0);La=f[z>>2]|0;Ka=f[d>>2]|0;if((La|0)!=(Ka|0)){Ja=0;Fa=Ka;Ka=La;while(1){La=f[ra>>2]|0;Ea=(f[g>>2]|0)+(Ja<<3)|0;r=La+4|0;Pa=f[r>>2]|0;if((Pa|0)==(f[La+8>>2]|0)){apa(La,Ea);Qa=f[d>>2]|0;Ra=f[z>>2]|0}else{p[Pa>>3]=+p[Ea>>3];f[r>>2]=Pa+8;Qa=Fa;Ra=Ka}Ja=Ja+1|0;if(Ja>>>0>=Ra-Qa>>3>>>0)break;else{Fa=Qa;Ka=Ra}}}QO(f[qa>>2]|0)}Ka=f[M>>2]|0;if(Ka|0?(Fa=Ka+12|0,Ka=f[Fa>>2]|0,f[Fa>>2]=Ka+-1,(Ka|0)==1):0)kL(i);f[M>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[O>>2]|0)>0){Ka=f[P>>2]|0;Fa=0;do{f[Ka+(Fa<<2)>>2]=0;Fa=Fa+1|0}while((Fa|0)<(f[O>>2]|0))}Fa=f[W>>2]|0;if((Fa|0)!=(sa|0))UC(Fa);Da=Da+1|0}while((Da|0)<(s|0));s=f[g>>2]|0;if(s|0){g=f[y>>2]|0;if((g|0)!=(s|0))f[y>>2]=g+(~((g+-8-s|0)>>>3)<<3);O5b(s)}}s=f[d>>2]|0;if(s|0){d=f[z>>2]|0;if((d|0)!=(s|0))f[z>>2]=d+(~((d+-8-s|0)>>>3)<<3);O5b(s)}s=e+36|0;d=f[s>>2]|0;if(d|0?(z=d+12|0,d=f[z>>2]|0,f[z>>2]=d+-1,(d|0)==1):0)kL(e);f[s>>2]=0;s=e+16|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[B>>2]|0)>0){s=f[D>>2]|0;D=0;do{f[s+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[B>>2]|0))}B=f[E>>2]|0;if((B|0)==(C|0)){u=c;return}UC(B);u=c;return}function ipa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){Nac(g|0,0,b<<2|0)|0;f[e>>2]=g+(b<<2);return}h=f[a>>2]|0;i=g-h|0;g=i>>2;j=g+b|0;if(j>>>0>1073741823)c4b(a);k=d-h|0;d=k>>1;l=k>>2>>>0<536870911?(d>>>0<j>>>0?j:d):1073741823;do if(l)if(l>>>0>1073741823){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);d=m+(g<<2)|0;Nac(d|0,0,b<<2|0)|0;j=d+(0-g<<2)|0;if((i|0)>0)Vac(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=d+(b<<2);f[c>>2]=m+(l<<2);if(!h)return;O5b(h);return}function jpa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+8|0;g=d;if(!(di[f[(f[a>>2]|0)+12>>2]&1023](a)|0)){u=d;return a|0}h=a+32|0;if((f[h>>2]|0)==6){f[e>>2]=0;f[e+4>>2]=0;i=aD(e,30)|0;j=363892;k=i+30|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-2,e,489622,363923,1181);bD(e)}f[g>>2]=0;f[g+4>>2]=0;sW(e,a,a+12|0,13,g);bD(g);rW(a,f[c>>2]|0);rW(a,f[c+4>>2]|0);tW(e);if(!(f[h>>2]&4)){u=d;return a|0}f[h>>2]=6;u=d;return a|0}function kpa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d+8|0;g=d;b[e>>0]=49;b[e+1>>0]=102;b[e+2>>0]=0;h=f[a>>2]|0;f[g>>2]=0;f[g+4>>2]=0;a=kUb(e)|0;if(a|0)Vac(aD(g,a)|0,e|0,a|0)|0;a=f[c>>2]|0;e=f[c+4>>2]|0;hW(h,g,(a|0)==(e|0)?0:a,e-a|0);bD(g);u=d;return}function lpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+16|0;g=e+8|0;h=e;i=f[a>>2]|0;j=f[i+40>>2]|0;b[g>>0]=49;b[g+1>>0]=102;b[g+2>>0]=0;k=j>>>0>d>>>0?d:j;j=c+4|0;d=f[j>>2]|0;l=f[c>>2]|0;m=d-l>>2;n=l;l=d;if(k>>>0<=m>>>0)if(k>>>0<m>>>0?(d=n+(k<<2)|0,(l|0)!=(d|0)):0){f[j>>2]=l+(~((l+-4-d|0)>>>2)<<2);o=i}else o=i;else{ipa(c,k-m|0);o=f[a>>2]|0}f[h>>2]=0;f[h+4>>2]=0;a=kUb(g)|0;if(!a){p=f[c>>2]|0;q=f[j>>2]|0;r=(p|0)==(q|0);s=r?0:p;t=k<<2;nW(o,h,s,t)|0;bD(h);u=e;return}Vac(aD(h,a)|0,g|0,a|0)|0;p=f[c>>2]|0;q=f[j>>2]|0;r=(p|0)==(q|0);s=r?0:p;t=k<<2;nW(o,h,s,t)|0;bD(h);u=e;return}function mpa(){$V(851420,350615,715,1475,558,279,716);zd(1467,851420,x|0)|0;return}function npa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;if(b[491608]|0){c=f[20099]|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d|0)==(e|0);h=g&1;return h|0}if(!(Cac(491608)|0)){c=f[20099]|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d|0)==(e|0);h=g&1;return h|0}f[122904]=80092;f[122905]=64;f[122906]=128;f[122907]=16;f[122908]=16;f[122909]=8;f[122910]=8;f[122911]=8;f[122912]=8;f[122913]=9;f[122914]=1;p[61458]=-1.0;f[122918]=0;p[61460]=.2;b[491688]=1;f[122923]=0;f[122924]=0;f[122925]=0;f[122926]=1124007936;f[122927]=0;f[122928]=0;f[122929]=0;f[122930]=0;f[122931]=0;f[122932]=0;f[122933]=0;f[122934]=491712;f[122935]=491744;f[122937]=0;f[122936]=0;n[122938]=-1.0;f[122939]=64;b[491760]=0;zd(651,491616,x|0)|0;c=f[20099]|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d|0)==(e|0);h=g&1;return h|0}function opa(a){a=a|0;var b=0;if(!a)return;b=f[a>>2]|0;if(!b)return;bi[f[(f[b>>2]|0)+4>>2]&2047](b);f[a>>2]=0;return}function ppa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[e>>2]=a;f[e+4>>2]=c;c=L5b(152)|0;f[c>>2]=80092;f[c+4>>2]=64;f[c+8>>2]=128;f[c+12>>2]=16;f[c+16>>2]=16;f[c+20>>2]=8;f[c+24>>2]=8;f[c+28>>2]=8;f[c+32>>2]=8;f[c+36>>2]=9;f[c+40>>2]=1;p[c+48>>3]=-1.0;f[c+56>>2]=0;p[c+64>>3]=.2;b[c+72>>0]=1;f[c+76>>2]=0;f[c+80>>2]=0;f[c+84>>2]=0;f[c+88>>2]=1124007936;a=c+92|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[c+120>>2]=c+96;a=c+128|0;f[c+124>>2]=a;f[c+132>>2]=0;f[a>>2]=0;n[c+136>>2]=-1.0;f[c+140>>2]=64;b[c+144>>0]=0;if(Hoa(c,e)|0){g=c;u=d;return g|0}bi[f[(f[c>>2]|0)+4>>2]&2047](c);g=0;u=d;return g|0}function qpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;d=u;u=u+48|0;e=d+8|0;g=d;if(!((a|0)!=0&(c|0)!=0)){u=d;return}eW(e,a,0);a=f[(f[c>>2]|0)+16>>2]|0;f[g>>2]=0;f[g+4>>2]=0;if(b|0?(h=kUb(b)|0,h|0):0)Vac(aD(g,h)|0,b|0,h|0)|0;_h[a&255](c,e,g);bD(g);nT(e);u=d;return}function rpa(a){a=a|0;var b=0,c=0,d=0;if(!a){b=0;return b|0}c=L5b(152)|0;f[c>>2]=80092;d=c+4|0;f[c+76>>2]=0;f[c+80>>2]=0;f[c+84>>2]=0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[d+28>>2]=0;f[c+88>>2]=1124007936;d=c+92|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;f[c+120>>2]=c+96;d=c+128|0;f[c+124>>2]=d;f[c+132>>2]=0;f[d>>2]=0;zh[f[(f[a>>2]|0)+28>>2]&2047](a,c);b=c;return b|0}function spa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=0;b=a+4|0;f[b>>2]=0;f[a+8>>2]=0;c=L5b(15124)|0;f[b>>2]=c;f[a>>2]=c;d=c+15124|0;f[a+8>>2]=d;a=80400;e=c;while(1){f[e>>2]=f[a>>2];a=a+4|0;if((a|0)==95524)break;else e=e+4|0}f[b>>2]=d;return}function tpa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=0;b=a+4|0;f[b>>2]=0;f[a+8>>2]=0;c=L5b(7924)|0;f[b>>2]=c;f[a>>2]=c;d=c+7924|0;f[a+8>>2]=d;a=95524;e=c;while(1){f[e>>2]=f[a>>2];a=a+4|0;if((a|0)==103448)break;else e=e+4|0}f[b>>2]=d;return}function upa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function vpa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=103456;b=a+348|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+352>>2]=0;hI(a+300|0);hI(a+252|0);hI(a+204|0);hI(a+156|0);b=a+100|0;c=a+136|0;e=f[c>>2]|0;if(e|0?(d=e+12|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)kL(b);f[c>>2]=0;c=a+116|0;b=a+104|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+140>>2]|0;e=0;do{f[c+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[b>>2]|0))}b=f[a+144>>2]|0;if((b|0)!=(a+148|0))UC(b);b=a+44|0;e=a+80|0;c=f[e>>2]|0;if(c|0?(d=c+12|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0)kL(b);f[e>>2]=0;e=a+60|0;b=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[b>>2]|0)>0){e=f[a+84>>2]|0;c=0;do{f[e+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+88>>2]|0;if((b|0)==(a+92|0))return;UC(b);return}function wpa(a){a=a|0;vpa(a);O5b(a);return}function xpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;f[a+8>>2]=f[c>>2];f[a+12>>2]=f[c+4>>2];c=a+24|0;b=a+348|0;d=a+352|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;c=f[d>>2]|0;if(c|0){a=f[c>>2]|0;e=c+4|0;c=f[e>>2]|0;if((c|0)==(a|0))return 1;f[e>>2]=c+(~(((c+-20-a|0)>>>0)/20|0)*20|0);return 1}a=L5b(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=L5b(16)|0;e=c+4|0;f[e>>2]=1;f[c>>2]=103536;f[c+8>>2]=a;f[e>>2]=(f[e>>2]|0)+1;g=f[b>>2]|0;f[b>>2]=c;f[d>>2]=a;if(g|0?(a=g+4|0,d=f[a>>2]|0,f[a>>2]=d+-1,(d|0)==1):0)bi[f[(f[g>>2]|0)+8>>2]&2047](g);g=f[e>>2]|0;f[e>>2]=g+-1;if((g|0)!=1)return 1;bi[f[(f[c>>2]|0)+8>>2]&2047](c);return 1}function ypa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;return}function zpa(a){a=a|0;return -1}function Apa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;e=u;u=u+224|0;g=e+176|0;h=e+168|0;i=e+152|0;j=e+160|0;k=e+144|0;l=e+80|0;m=e+136|0;o=e+16|0;p=e;q=e+72|0;dQ(h,103508);AL(i,c,-1);f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];i=Jpa(a,j,d)|0;d=a+352|0;j=f[d>>2]|0;r=f[j+4>>2]|0;s=f[j>>2]|0;t=r-s|0;v=(t|0)/20|0;if(!t)w=0;else{if((r|0)==(s|0))d4b(j);j=s;s=f[j+8>>2]|0;r=a+100|0;t=a+112|0;x=(f[j+4>>2]|0)+15&-16;j=f[t>>2]|0;y=(j|0)<(x|0)?x:j;j=a+108|0;x=f[j>>2]|0;z=(x|0)<(s|0)?s:x;f[k>>2]=z;if(i){bi[f[(f[a>>2]|0)+48>>2]&2047](a);Kpa(f[d>>2]|0,a+300|0)}do if((yM(c)|0)==655360?(Y(f[a+28>>2]|0,f[a+24>>2]|0)|0)>0:0){i=a+204|0;x=Y(f[a+40>>2]|0,f[a+20>>2]|0)|0;s=f[a+16>>2]|0;if(!(((((f[a+208>>2]|0)<3?(f[a+212>>2]|0)==(x|0):0)?(f[a+216>>2]|0)==(s|0):0)?(f[i>>2]&4095|0)==4:0)?(f[a+228>>2]|0)!=0:0)){f[g>>2]=x;f[g+4>>2]=s;eI(i,2,g,4,0)}i=a+156|0;if(!(((((f[a+160>>2]|0)<3?(f[a+164>>2]|0)==(z|0):0)?(f[a+168>>2]|0)==(y|0):0)?(f[i>>2]&4095|0)==0:0)?(f[a+180>>2]|0)!=0:0)){f[g>>2]=z;f[g+4>>2]=y;eI(i,2,g,0,0)}s=l+4|0;x=l+8|0;A=l+12|0;B=l+8|0;C=l+4|0;D=g+32|0;E=m+4|0;F=l+8|0;G=l+12|0;H=l+4|0;I=0;while(1){J=f[d>>2]|0;K=f[J>>2]|0;if((((f[J+4>>2]|0)-K|0)/20|0)>>>0<=I>>>0){L=22;break}M=K;K=(f[M+(I*20|0)+4>>2]|0)+-1|0;N=(f[M+(I*20|0)+8>>2]|0)+-1|0;f[l>>2]=0;f[s>>2]=0;f[x>>2]=K;f[A>>2]=N;dI(g,i,l);N=B;f[N>>2]=0;f[N+4>>2]=0;f[l>>2]=34209792;f[C>>2]=g;N=f[D>>2]|0;K=f[N>>2]|0;f[m>>2]=f[N+4>>2];f[E>>2]=K;O=1.0/+n[M+(I*20|0)>>2];Lia(c,l,m,O,O,5);M=f[(f[a>>2]|0)+44>>2]|0;f[F>>2]=0;f[G>>2]=0;f[l>>2]=17432576;f[H>>2]=g;_h[M&255](a,I,l);hI(g);I=I+1|0;if(I>>>0>=v>>>0){L=24;break}}if((L|0)==22)d4b(J);else if((L|0)==24){f[a+4>>2]=2;break}}else L=25;while(0);if((L|0)==25){do if((yM(c)|0)==65536){J=f[c+4>>2]|0;f[l>>2]=f[J>>2];m=l+4|0;z=J+4|0;f[m>>2]=f[z>>2];I=l+8|0;f[I>>2]=f[J+8>>2];f[l+12>>2]=f[J+12>>2];f[l+16>>2]=f[J+16>>2];f[l+20>>2]=f[J+20>>2];f[l+24>>2]=f[J+24>>2];f[l+28>>2]=f[J+28>>2];f[l+32>>2]=f[J+32>>2];H=f[J+36>>2]|0;f[l+36>>2]=H;f[l+40>>2]=I;I=l+48|0;G=l+44|0;f[G>>2]=I;f[I>>2]=0;f[l+52>>2]=0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[z>>2]|0)<3){z=f[J+44>>2]|0;I=f[G>>2]|0;f[I>>2]=f[z>>2];f[I+4>>2]=f[z+4>>2];break}else{f[m>>2]=0;jL(l,J);break}}else yL(l,c,-1);while(0);c=a+44|0;J=Y(f[a+40>>2]|0,f[a+20>>2]|0)|0;m=f[a+16>>2]|0;if(!(((((f[a+48>>2]|0)<3?(f[a+52>>2]|0)==(J|0):0)?(f[a+56>>2]|0)==(m|0):0)?(f[c>>2]&4095|0)==4:0)?(f[a+60>>2]|0)!=0:0)){f[g>>2]=J;f[g+4>>2]=m;hL(c,2,g,4)}c=f[k>>2]|0;if(!(((((f[a+104>>2]|0)<3?(f[j>>2]|0)==(c|0):0)?(f[t>>2]|0)==(y|0):0)?(f[r>>2]&4095|0)==0:0)?(f[a+116>>2]|0)!=0:0)){f[g>>2]=c;f[g+4>>2]=y;hL(r,2,g,0)}r=a+116|0;y=o+4|0;c=o+8|0;t=o+12|0;j=o+16|0;k=o+20|0;m=o+24|0;J=o+28|0;z=o+40|0;I=o+48|0;G=o+44|0;H=o+52|0;F=g+4|0;E=g+8|0;D=g+12|0;C=g+4|0;B=p+8|0;i=p+4|0;A=q+4|0;x=g+8|0;s=g+12|0;M=g+4|0;K=o+36|0;N=0;do{P=f[d>>2]|0;Q=f[P>>2]|0;if((((f[P+4>>2]|0)-Q|0)/20|0)>>>0<=N>>>0){L=46;break}R=Q;Q=(f[R+(N*20|0)+8>>2]|0)+-1|0;S=(f[R+(N*20|0)+4>>2]|0)+-1|0;T=f[r>>2]|0;f[o>>2]=1124007936;f[y>>2]=2;f[c>>2]=Q;f[t>>2]=S;f[j>>2]=T;f[k>>2]=T;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[z>>2]=c;f[G>>2]=I;f[H>>2]=0;f[I>>2]=0;if((T|0)==0&(Y(S,Q)|0)!=0){f[g>>2]=0;f[F>>2]=0;Q=aD(g,26)|0;U=426262;V=Q+26|0;do{b[Q>>0]=b[U>>0]|0;Q=Q+1|0;U=U+1|0}while((Q|0)<(V|0));bO(-215,g,426289,431198,500);bD(g);W=f[o>>2]|0;X=f[t>>2]|0;Z=f[G>>2]|0;_=f[k>>2]|0;$=f[z>>2]|0}else{W=1124007936;X=S;Z=I;_=T;$=c}f[o>>2]=W|16384;f[Z>>2]=X;f[Z+4>>2]=1;U=_+(Y(f[c>>2]|0,X)|0)|0;f[J>>2]=U;f[m>>2]=U+(0-X)+X;f[E>>2]=0;f[D>>2]=0;f[g>>2]=16842752;f[C>>2]=l;U=B;f[U>>2]=0;f[U+4>>2]=0;f[p>>2]=33619968;f[i>>2]=o;U=f[$>>2]|0;f[q>>2]=f[$+4>>2];f[A>>2]=U;O=1.0/+n[R+(N*20|0)>>2];Lia(g,p,q,O,O,5);U=f[(f[a>>2]|0)+44>>2]|0;f[x>>2]=0;f[s>>2]=0;f[g>>2]=16842752;f[M>>2]=o;_h[U&255](a,N,g);U=f[K>>2]|0;if(U|0?(Q=U+12|0,U=f[Q>>2]|0,f[Q>>2]=U+-1,(U|0)==1):0)kL(o);f[K>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[y>>2]|0)>0){U=f[z>>2]|0;Q=0;do{f[U+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[y>>2]|0))}Q=f[G>>2]|0;if((Q|0)!=(I|0))UC(Q);N=N+1|0}while(N>>>0<v>>>0);if((L|0)==46)d4b(P);f[a+4>>2]=1;a=l+36|0;P=f[a>>2]|0;if(P|0?(L=P+12|0,P=f[L>>2]|0,f[L>>2]=P+-1,(P|0)==1):0)kL(l);f[a>>2]=0;a=l+16|0;P=l+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[P>>2]|0)>0){a=f[l+40>>2]|0;L=0;do{f[a+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[P>>2]|0))}P=f[l+44>>2]|0;if((P|0)!=(l+48|0))UC(P)}w=1}if(!(f[h+4>>2]|0)){u=e;return w|0}u=e;return w|0}function Bpa(a,b,c){a=a|0;b=b|0;c=c|0;return 1}function Cpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;e=a+4|0;if(!(f[e>>2]&2)){g=d+8|0;f[g>>2]=0;f[g+4>>2]=0;f[d>>2]=34209792;f[d+4>>2]=a+204;SP(a+44|0,d);f[e>>2]=f[e>>2]|2}e=f[b>>2]|0;d=b+4|0;while(1){g=f[d>>2]|0;if((g|0)==(e|0))break;h=g+-48|0;f[d>>2]=h;hI(h)}h=a+300|0;g=b+8|0;if((e|0)==(f[g>>2]|0)){Ipa(b,h);i=f[d>>2]|0}else{f[e>>2]=f[h>>2];j=e+4|0;k=a+304|0;f[j>>2]=f[k>>2];l=e+8|0;f[l>>2]=f[a+308>>2];f[e+12>>2]=f[a+312>>2];f[e+16>>2]=f[a+316>>2];f[e+20>>2]=f[a+320>>2];m=f[a+324>>2]|0;f[e+24>>2]=m;f[e+28>>2]=f[a+328>>2];f[e+32>>2]=l;l=e+40|0;n=e+36|0;f[n>>2]=l;f[e+44>>2]=0;f[l>>2]=0;if(m|0){l=m+8|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[a+336>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;gI(e,h)}h=(f[d>>2]|0)+48|0;f[d>>2]=h;i=h}h=a+204|0;if((i|0)==(f[g>>2]|0)){Ipa(b,h);o=f[d>>2]|0}else{f[i>>2]=f[h>>2];e=i+4|0;j=a+208|0;f[e>>2]=f[j>>2];k=i+8|0;f[k>>2]=f[a+212>>2];f[i+12>>2]=f[a+216>>2];f[i+16>>2]=f[a+220>>2];f[i+20>>2]=f[a+224>>2];l=f[a+228>>2]|0;f[i+24>>2]=l;f[i+28>>2]=f[a+232>>2];f[i+32>>2]=k;k=i+40|0;n=i+36|0;f[n>>2]=k;f[i+44>>2]=0;f[k>>2]=0;if(l|0){k=l+8|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[a+240>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[e>>2]=0;gI(i,h)}h=(f[d>>2]|0)+48|0;f[d>>2]=h;o=h}h=a+252|0;if((o|0)==(f[g>>2]|0)){Ipa(b,h);u=c;return}f[o>>2]=f[h>>2];b=o+4|0;g=a+256|0;f[b>>2]=f[g>>2];i=o+8|0;f[i>>2]=f[a+260>>2];f[o+12>>2]=f[a+264>>2];f[o+16>>2]=f[a+268>>2];f[o+20>>2]=f[a+272>>2];e=f[a+276>>2]|0;f[o+24>>2]=e;f[o+28>>2]=f[a+280>>2];f[o+32>>2]=i;i=o+40|0;j=o+36|0;f[j>>2]=i;f[o+44>>2]=0;f[i>>2]=0;if(e|0){i=e+8|0;f[i>>2]=(f[i>>2]|0)+1}if((f[g>>2]|0)<3){g=f[a+288>>2]|0;a=f[j>>2]|0;f[a>>2]=f[g>>2];f[a+4>>2]=f[g+4>>2]}else{f[b>>2]=0;gI(o,h)}f[d>>2]=(f[d>>2]|0)+48;u=c;return}function Dpa(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+16|0;c=b;d=a+4|0;if(f[d>>2]&1|0){u=b;return}e=c+8|0;f[e>>2]=0;f[e+4>>2]=0;f[c>>2]=33619968;f[c+4>>2]=a+44;oI(a+204|0,c);f[d>>2]=f[d>>2]|1;u=b;return}function Epa(a,b){a=a|0;b=b|0;return 0.0}function Fpa(a,b){a=a|0;b=b|0;return 0}function Gpa(a,b,c){a=a|0;b=b|0;c=c|0;return}function Hpa(a){a=a|0;return}function Ipa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[a>>2]|0;e=((f[c>>2]|0)-d|0)/48|0;g=e+1|0;if(g>>>0>89478485)c4b(a);h=a+8|0;i=((f[h>>2]|0)-d|0)/48|0;d=i<<1;j=i>>>0<44739242?(d>>>0<g>>>0?g:d):89478485;do if(j)if(j>>>0>89478485){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{k=L5b(j*48|0)|0;break}else k=0;while(0);d=k+(e*48|0)|0;g=d;i=k+(j*48|0)|0;f[d>>2]=f[b>>2];j=k+(e*48|0)+4|0;l=b+4|0;m=f[l>>2]|0;f[j>>2]=m;n=k+(e*48|0)+8|0;f[n>>2]=f[b+8>>2];f[k+(e*48|0)+12>>2]=f[b+12>>2];f[k+(e*48|0)+16>>2]=f[b+16>>2];f[k+(e*48|0)+20>>2]=f[b+20>>2];o=f[b+24>>2]|0;f[k+(e*48|0)+24>>2]=o;f[k+(e*48|0)+28>>2]=f[b+28>>2];f[k+(e*48|0)+32>>2]=n;n=k+(e*48|0)+40|0;p=k+(e*48|0)+36|0;f[p>>2]=n;f[k+(e*48|0)+44>>2]=0;f[n>>2]=0;if(!o)q=m;else{m=o+8|0;f[m>>2]=(f[m>>2]|0)+1;q=f[l>>2]|0}if((q|0)<3){q=f[b+36>>2]|0;l=f[p>>2]|0;f[l>>2]=f[q>>2];f[l+4>>2]=f[q+4>>2]}else{f[j>>2]=0;gI(d,b)}b=d+48|0;j=f[a>>2]|0;q=f[c>>2]|0;if((q|0)==(j|0)){r=g;s=j;t=q}else{l=q;q=g;g=d;do{d=g+-48|0;p=l;l=l+-48|0;f[d>>2]=f[l>>2];m=g+-44|0;o=p+-44|0;f[m>>2]=f[o>>2];n=g+-40|0;f[n>>2]=f[p+-40>>2];f[g+-36>>2]=f[p+-36>>2];f[g+-32>>2]=f[p+-32>>2];f[g+-28>>2]=f[p+-28>>2];e=f[p+-24>>2]|0;f[g+-24>>2]=e;f[g+-20>>2]=f[p+-20>>2];f[g+-16>>2]=n;n=g+-8|0;k=g+-12|0;f[k>>2]=n;f[g+-4>>2]=0;f[n>>2]=0;if(e|0){n=e+8|0;f[n>>2]=(f[n>>2]|0)+1}if((f[o>>2]|0)<3){o=f[p+-12>>2]|0;p=f[k>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2]}else{f[m>>2]=0;gI(d,l)}g=q+-48|0;q=g}while((l|0)!=(j|0));r=q;s=f[a>>2]|0;t=f[c>>2]|0}f[a>>2]=r;f[c>>2]=b;f[h>>2]=i;i=s;h=t;while(1){t=h;if((t|0)==(i|0))break;b=t+-48|0;hI(b);h=b}if(!s)return;O5b(s);return}function Jpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;d=a+348|0;e=a+352|0;if(!(f[e>>2]|0)){g=L5b(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=L5b(16)|0;i=h+4|0;f[i>>2]=1;f[h>>2]=103536;f[h+8>>2]=g;f[i>>2]=(f[i>>2]|0)+1;j=f[d>>2]|0;f[d>>2]=h;f[e>>2]=g;if(j|0?(g=j+4|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)bi[f[(f[j>>2]|0)+8>>2]&2047](j);j=f[i>>2]|0;f[i>>2]=j+-1;if((j|0)==1)bi[f[(f[h>>2]|0)+8>>2]&2047](h)}h=f[c>>2]|0;j=(f[c+4>>2]|0)-h>>2;i=f[e>>2]|0;d=i+4|0;g=f[d>>2]|0;k=f[i>>2]|0;l=(g-k|0)/20|0;m=k;k=g;g=h;if(j>>>0<=l>>>0)if(j>>>0<l>>>0?(h=m+(j*20|0)|0,(k|0)!=(h|0)):0){f[d>>2]=k+(~(((k+-20-h|0)>>>0)/20|0)*20|0);o=g}else o=g;else{Lpa(i,j-l|0);o=f[c>>2]|0}i=a+16|0;g=f[i>>2]|0;h=a+20|0;a=f[h>>2]|0;k=(LVb(+(f[b>>2]|0)/+n[o>>2])|0)+62&-32;o=(g|0)<(k|0);f[i>>2]=o?k:g;g=(j|0)!=(l|0)|o;if(!j){p=g;q=0;r=0;s=a;t=q+r|0;u=(s|0)<(t|0);v=u?t:s;f[h>>2]=v;w=(v|0)!=(a|0);x=p|w;return x|0}o=f[e>>2]|0;e=f[o>>2]|0;l=((f[o+4>>2]|0)-e|0)/20|0;k=e;e=f[c>>2]|0;c=b+4|0;d=0;m=g;g=0;y=0;z=0;while(1){if(l>>>0<=d>>>0){A=15;break}B=k+(d*20|0)|0;if(!m){C=+n[e+(d<<2)>>2];if(+L(+(+n[B>>2]-C))>C*1.1920928955078125e-05){D=1;E=B;F=C}else{D=0;E=B;F=C}}else{D=1;E=B;F=+n[e+(d<<2)>>2]}B=LVb(+(f[b>>2]|0)/F)|0;G=LVb(+(f[c>>2]|0)/F)|0;f[k+(d*20|0)+16>>2]=F>=2.0?1:2;n[E>>2]=F;H=B+1|0;B=G+1|0;f[k+(d*20|0)+4>>2]=H;f[k+(d*20|0)+8>>2]=B;G=(d|0)==0?B:g;I=f[i>>2]|0;J=(H+y|0)>(I|0);K=J?0:y;z=(J?G:0)+z|0;g=J?B:G;G=(Y(z,I)|0)+K|0;f[k+(d*20|0)+12>>2]=G;d=d+1|0;if(d>>>0>=j>>>0)break;else{m=D;y=K+H|0}}if((A|0)==15)d4b(o);p=D;q=g;r=z;s=f[h>>2]|0;t=q+r|0;u=(s|0)<(t|0);v=u?t:s;f[h>>2]=v;w=(v|0)!=(a|0);x=p|w;return x|0}function Kpa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+80|0;e=d+56|0;g=d;h=f[a>>2]|0;i=a+4|0;j=f[i>>2]|0;if((h|0)==(j|0)){k=c+24|0;l=f[k>>2]|0;if(l|0?(m=l+8|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)iI(c);l=c+4|0;if((f[l>>2]|0)>0){m=f[c+32>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}f[k>>2]=0;o=f[a>>2]|0;p=f[i>>2]|0}else{o=h;p=j}j=p-o|0;p=o;f[g>>2]=1124007936;h=g+4|0;f[h>>2]=2;i=g+8|0;f[i>>2]=1;a=g+12|0;f[a>>2]=j;k=g+16|0;f[k>>2]=p;l=g+20|0;f[l>>2]=p;n=g+24|0;m=g+28|0;q=g+40|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[q>>2]=i;r=g+48|0;s=g+44|0;f[s>>2]=r;f[g+52>>2]=0;f[r>>2]=0;if((o|0)==0&(j|0)!=0){f[e>>2]=0;f[e+4>>2]=0;o=aD(e,26)|0;t=426262;v=o+26|0;do{b[o>>0]=b[t>>0]|0;o=o+1|0;t=t+1|0}while((o|0)<(v|0));bO(-215,e,426289,431198,500);bD(e);w=f[g>>2]|16384;x=f[a>>2]|0;y=f[s>>2]|0;z=f[l>>2]|0}else{w=1124024320;x=j;y=r;z=p}f[g>>2]=w;f[y>>2]=x;f[y+4>>2]=1;y=z+(Y(f[i>>2]|0,x)|0)|0;f[m>>2]=y;f[n>>2]=y+(0-x)+x;x=e+8|0;f[x>>2]=0;f[x+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=c;SP(g,e);e=g+36|0;c=f[e>>2]|0;if(c|0?(x=c+12|0,c=f[x>>2]|0,f[x>>2]=c+-1,(c|0)==1):0)kL(g);f[e>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[h>>2]|0)>0){k=f[q>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[h>>2]|0))}h=f[s>>2]|0;if((h|0)==(r|0)){u=d;return}UC(h);u=d;return}function Lpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/20|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;i=(f[e>>2]|0)+20|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/20|0;g=i+b|0;if(g>>>0>214748364)c4b(a);j=(d-h|0)/20|0;h=j<<1;d=j>>>0<107374182?(h>>>0<g>>>0?g:h):214748364;do if(d)if(d>>>0>214748364){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d*20|0)|0;break}else k=0;while(0);h=k+(i*20|0)|0;i=h;g=k+(d*20|0)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;b=k+20|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;if((b|0)==(g|0)){l=i;m=g}else{j=b;b=i;i=h;do{h=j;j=j+-20|0;f[i+-20>>2]=f[j>>2];f[i+-16>>2]=f[h+-16>>2];f[i+-12>>2]=f[h+-12>>2];n=h+-8|0;h=f[n+4>>2]|0;o=i+-8|0;f[o>>2]=f[n>>2];f[o+4>>2]=h;i=b+-20|0;b=i}while((j|0)!=(g|0));l=b;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;O5b(m);return}function Mpa(a){a=a|0;O5b(a);return}function Npa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~(((e+-20-c|0)>>>0)/20|0)*20|0);O5b(c)}O5b(b)}bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Opa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=103556;b=a+372|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+376>>2]=0;b=a+364|0;c=f[b>>2]|0;if(c|0?(e=c+4|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+368>>2]=0;b=a+356|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;g=a+360|0;f[g>>2]=0;vpa(a);return}d=c+4|0;e=f[d>>2]|0;f[d>>2]=e+-1;if((e|0)!=1){f[b>>2]=0;g=a+360|0;f[g>>2]=0;vpa(a);return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;g=a+360|0;f[g>>2]=0;vpa(a);return}function Ppa(a){a=a|0;Opa(a);O5b(a);return}function Qpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+64|0;g=e+8|0;h=e+16|0;i=e;f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];xpa(a,0,g)|0;g=lW(c)|0;d=(g|0)==0;if(d){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,5)|0;b[j>>0]=b[351361]|0;b[j+1>>0]=b[351362]|0;b[j+2>>0]=b[351363]|0;b[j+3>>0]=b[351364]|0;b[j+4>>0]=b[351365]|0;bO(-215,h,363731,350849,585);bD(h)}j=a+356|0;k=a+360|0;if(!(f[k>>2]|0)){l=L5b(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;m=L5b(16)|0;n=m+4|0;f[n>>2]=1;f[m>>2]=103676;f[m+8>>2]=l;f[n>>2]=(f[n>>2]|0)+1;o=f[j>>2]|0;f[j>>2]=m;f[k>>2]=l;if(o|0?(l=o+4|0,j=f[l>>2]|0,f[l>>2]=j+-1,(j|0)==1):0)bi[f[(f[o>>2]|0)+8>>2]&2047](o);o=f[n>>2]|0;f[n>>2]=o+-1;if((o|0)==1)bi[f[(f[m>>2]|0)+8>>2]&2047](m)}m=a+364|0;o=a+368|0;if(!(f[o>>2]|0)){n=L5b(12)|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;j=L5b(16)|0;l=j+4|0;f[l>>2]=1;f[j>>2]=103696;f[j+8>>2]=n;f[l>>2]=(f[l>>2]|0)+1;p=f[m>>2]|0;f[m>>2]=j;f[o>>2]=n;if(p|0?(n=p+4|0,o=f[n>>2]|0,f[n>>2]=o+-1,(o|0)==1):0)bi[f[(f[p>>2]|0)+8>>2]&2047](p);p=f[l>>2]|0;f[l>>2]=p+-1;if((p|0)==1)bi[f[(f[j>>2]|0)+8>>2]&2047](j)}j=a+372|0;p=a+376|0;if(!(f[p>>2]|0)){l=L5b(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;o=L5b(16)|0;n=o+4|0;f[n>>2]=1;f[o>>2]=103696;f[o+8>>2]=l;f[n>>2]=(f[n>>2]|0)+1;m=f[j>>2]|0;f[j>>2]=o;f[p>>2]=l;if(m|0?(l=m+4|0,p=f[l>>2]|0,f[l>>2]=p+-1,(p|0)==1):0)bi[f[(f[m>>2]|0)+8>>2]&2047](m);m=f[n>>2]|0;f[n>>2]=m+-1;if((m|0)==1)bi[f[(f[o>>2]|0)+8>>2]&2047](o)}o=f[k>>2]|0;m=o+4|0;n=f[m>>2]|0;p=f[o>>2]|0;l=n-p>>6;j=p;p=n;if(g>>>0<=l>>>0){if(g>>>0<l>>>0?(n=j+(g<<6)|0,(p|0)!=(n|0)):0)f[m>>2]=p+(~((p+-64-n|0)>>>6)<<6)}else dqa(o,g-l|0);kW(h,f[c>>2]|0,f[c+4>>2]|0,0);c=a+380|0;b[c>>0]=0;l=f[k>>2]|0;f[a+16>>2]=0;f[a+20>>2]=0;k=a+252|0;o=a+276|0;n=f[o>>2]|0;if(n|0?(p=n+8|0,n=f[p>>2]|0,f[p>>2]=n+-1,(n|0)==1):0)iI(k);k=a+256|0;if((f[k>>2]|0)>0){n=f[a+284>>2]|0;p=0;do{f[n+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[k>>2]|0))}f[o>>2]=0;if(d){q=b[c>>0]|0;r=q<<24>>24!=0;s=r?3:2;t=a+40|0;f[t>>2]=s;v=a+8|0;w=f[v>>2]|0;x=w+-2|0;y=a+12|0;z=f[y>>2]|0;A=z+-2|0;B=a+408|0;f[B>>2]=1;C=a+412|0;f[C>>2]=1;D=a+416|0;f[D>>2]=x;E=a+420|0;f[E>>2]=A;F=a+24|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;u=e;return 1}d=h+20|0;o=i+4|0;k=0;do{p=(f[l>>2]|0)+(k<<6)|0;n=f[d>>2]|0;f[i>>2]=f[h>>2];f[o>>2]=n;eqa(p,i)|0;if(b[(f[l>>2]|0)+(k<<6)>>0]|0)b[c>>0]=1;k=k+1|0;mW(h)|0}while((k|0)!=(g|0));q=b[c>>0]|0;r=q<<24>>24!=0;s=r?3:2;t=a+40|0;f[t>>2]=s;v=a+8|0;w=f[v>>2]|0;x=w+-2|0;y=a+12|0;z=f[y>>2]|0;A=z+-2|0;B=a+408|0;f[B>>2]=1;C=a+412|0;f[C>>2]=1;D=a+416|0;f[D>>2]=x;E=a+420|0;f[E>>2]=A;F=a+24|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;u=e;return 1}function Rpa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0;d=L5b(436)|0;e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[d+44>>2]=1124007936;e=d+52|0;g=d+84|0;h=d+48|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=d+92|0;f[d+88>>2]=e;f[e>>2]=0;f[d+96>>2]=0;f[d+100>>2]=1124007936;e=d+108|0;g=d+140|0;h=d+104|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;e=d+148|0;f[d+144>>2]=e;f[e>>2]=0;f[d+152>>2]=0;f[d+156>>2]=1124007936;e=d+160|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d+188>>2]=d+164;e=d+196|0;f[d+192>>2]=e;f[d+200>>2]=0;f[e>>2]=0;f[d+204>>2]=1124007936;e=d+208|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d+236>>2]=d+212;e=d+244|0;f[d+240>>2]=e;f[d+248>>2]=0;f[e>>2]=0;f[d+252>>2]=1124007936;e=d+256|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d+284>>2]=d+260;e=d+292|0;f[d+288>>2]=e;f[d+296>>2]=0;f[e>>2]=0;f[d+300>>2]=1124007936;e=d+304|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[d+332>>2]=d+308;e=d+340|0;f[d+336>>2]=e;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[d>>2]=103556;e=d+356|0;g=d+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;h=d+392|0;i=h+40|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=4;f[d+28>>2]=2;f[d+32>>2]=0;f[d+36>>2]=0;f[d+40>>2]=0;f[d+384>>2]=0;f[d+388>>2]=0;n[d+432>>2]=0.0;g=d+380|0;b[g>>0]=0;h=L5b(16)|0;i=h+4|0;f[i>>2]=1;f[h>>2]=103656;f[h+8>>2]=d;j=h;k=d;aqa(d,c)|0;l=f[c+356>>2]|0;m=f[c+360>>2]|0;if(l|0){o=l+4|0;f[o>>2]=(f[o>>2]|0)+1}o=f[e>>2]|0;f[e>>2]=l;f[d+360>>2]=m;if(o|0?(m=o+4|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)bi[f[(f[o>>2]|0)+8>>2]&2047](o);o=d+364|0;l=f[c+364>>2]|0;m=f[c+368>>2]|0;if(l|0){e=l+4|0;f[e>>2]=(f[e>>2]|0)+1}e=f[o>>2]|0;f[o>>2]=l;f[d+368>>2]=m;if(e|0?(m=e+4|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)bi[f[(f[e>>2]|0)+8>>2]&2047](e);e=d+372|0;l=f[c+372>>2]|0;m=f[c+376>>2]|0;if(l|0){o=l+4|0;f[o>>2]=(f[o>>2]|0)+1}o=f[e>>2]|0;f[e>>2]=l;f[d+376>>2]=m;if(o|0?(m=o+4|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)bi[f[(f[o>>2]|0)+8>>2]&2047](o);o=c+380|0;f[g>>2]=f[o>>2];f[g+4>>2]=f[o+4>>2];f[g+8>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[d+408>>2]=f[c+408>>2];f[d+412>>2]=f[c+412>>2];f[d+416>>2]=f[c+416>>2];f[d+420>>2]=f[c+420>>2];o=d+424|0;d=c+424|0;f[o>>2]=f[d>>2];f[o+4>>2]=f[d+4>>2];f[o+8>>2]=f[d+8>>2];f[a>>2]=j;f[a+4>>2]=k;f[i>>2]=(f[i>>2]|0)+1;k=f[i>>2]|0;f[i>>2]=k+-1;if((k|0)!=1)return;bi[f[(f[h>>2]|0)+8>>2]&2047](h);return}function Spa(a){a=a|0;return 0}function Tpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0.0,l=0.0;d=$pa(a,c)|0;c=f[b>>2]|0;if((c|0)<0){e=0;return e|0}g=f[b+4>>2]|0;if((g|0)<0){e=0;return e|0}if(((f[a+8>>2]|0)+c|0)>=(f[d+4>>2]|0)){e=0;return e|0}if(((f[a+12>>2]|0)+g|0)>=(f[d+8>>2]|0)){e=0;return e|0}b=(f[a+60>>2]|0)+(Y(f[f[a+88>>2]>>2]|0,g)|0)+(c<<2)|0;c=b+(f[d+12>>2]<<2)|0;f[a+424>>2]=c;d=c+(f[a+388>>2]<<2)|0;b=f[a+392>>2]|0;g=f[a+396>>2]|0;h=f[a+400>>2]|0;i=f[a+404>>2]|0;j=+(Y(f[a+420>>2]|0,f[a+416>>2]|0)|0);k=+((f[c+(b<<2)>>2]|0)-(f[c+(g<<2)>>2]|0)-(f[c+(h<<2)>>2]|0)+(f[c+(i<<2)>>2]|0)|0);l=+(((f[d+(b<<2)>>2]|0)-(f[d+(g<<2)>>2]|0)-(f[d+(h<<2)>>2]|0)+(f[d+(i<<2)>>2]|0)|0)>>>0)*j-k*k;if(l>0.0){k=1.0/+M(+l);n[a+432>>2]=k;e=j*k<.1;return e|0}else{n[a+432>>2]=1.0;e=0;return e|0}return 0}function Upa(a,b){a=a|0;b=b|0;return +(+_pa(a,b))}function Vpa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+256|0;g=e+240|0;i=e+184|0;j=e+128|0;k=e+72|0;l=e+56|0;m=e+24|0;n=e;o=e+48|0;p=e+40|0;q=e+16|0;dQ(g,103628);r=f[a+352>>2]|0;s=f[r>>2]|0;if((((f[r+4>>2]|0)-s|0)/20|0)>>>0<=c>>>0)d4b(r);r=s;s=a+380|0;t=a+16|0;v=(Y(f[a+20>>2]|0,f[t>>2]|0)|0)<<h[s>>0];w=a+388|0;f[w>>2]=v;if((yM(d)|0)!=655360){v=r+(c*20|0)+4|0;f[o>>2]=f[v>>2];x=r+(c*20|0)+8|0;f[o+4>>2]=f[x>>2];y=a+92|0;JF(i,o,4,(f[a+60>>2]|0)+(f[r+(c*20|0)+12>>2]<<2)|0,f[y>>2]|0);f[p>>2]=f[v>>2];f[p+4>>2]=f[x>>2];o=i+16|0;z=i+44|0;JF(j,p,4,(f[o>>2]|0)+(f[w>>2]<<2)|0,f[y>>2]|0);if(b[s>>0]|0){f[q>>2]=f[v>>2];f[q+4>>2]=f[x>>2];JF(k,q,4,(f[o>>2]|0)+(f[a+384>>2]<<2)|0,f[y>>2]|0);y=l+8|0;f[y>>2]=0;f[y+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=i;y=m+8|0;f[y>>2]=0;f[y+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=j;y=n+8|0;f[y>>2]=0;f[y+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=k;C3(d,l,m,n,4,4);y=k+36|0;q=f[y>>2]|0;if(q|0?(x=q+12|0,q=f[x>>2]|0,f[x>>2]=q+-1,(q|0)==1):0)kL(k);f[y>>2]=0;y=k+16|0;q=k+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[q>>2]|0)>0){y=f[k+40>>2]|0;x=0;do{f[y+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[q>>2]|0))}q=f[k+44>>2]|0;if((q|0)!=(k+48|0))UC(q)}else{q=k+8|0;f[q>>2]=0;f[q+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=i;q=l+8|0;f[q>>2]=0;f[q+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;C3(d,k,l,UM()|0,4,4)}q=j+36|0;x=f[q>>2]|0;if(x|0?(y=x+12|0,x=f[y>>2]|0,f[y>>2]=x+-1,(x|0)==1):0)kL(j);f[q>>2]=0;q=j+16|0;x=j+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[x>>2]|0)>0){q=f[j+40>>2]|0;y=0;do{f[q+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[j+44>>2]|0;if((x|0)!=(j+48|0))UC(x);x=i+36|0;y=f[x>>2]|0;if(y|0?(q=y+12|0,y=f[q>>2]|0,f[q>>2]=y+-1,(y|0)==1):0)kL(i);f[x>>2]=0;x=i+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[x>>2]|0)>0){o=f[i+40>>2]|0;y=0;do{f[o+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[z>>2]|0;if((x|0)!=(i+48|0))UC(x)}else{x=f[r+(c*20|0)+12>>2]|0;z=f[t>>2]|0;y=(x|0)%(z|0)|0;o=(x|0)/(z|0)|0;x=f[w>>2]|0;w=a+204|0;q=r+(c*20|0)+4|0;v=f[q>>2]|0;p=r+(c*20|0)+8|0;c=f[p>>2]|0;f[j>>2]=y;f[j+4>>2]=o;f[j+8>>2]=v;f[j+12>>2]=c;dI(i,w,j);c=f[q>>2]|0;v=f[p>>2]|0;f[k>>2]=y;f[k+4>>2]=((x|0)/(z|0)|0)+o;f[k+8>>2]=c;f[k+12>>2]=v;dI(j,w,k);f[j>>2]=f[j>>2]&-8|4;do if(!(b[s>>0]|0)){v=j+24|0;c=f[v>>2]|0;z=k+8|0;f[z>>2]=0;f[z+4>>2]=0;f[k>>2]=34209792;f[k+4>>2]=i;z=l+8|0;f[z>>2]=0;f[z+4>>2]=0;f[l>>2]=34209792;f[l+4>>2]=j;C3(d,k,l,UM()|0,4,4);if(((f[v>>2]|0)==(c|0)?(c=f[j+32>>2]|0,(f[c>>2]|0)==(f[p>>2]|0)?(f[c+4>>2]|0)==(f[q>>2]|0):0):0)?(f[j>>2]&4095|0)==4:0)break;f[k>>2]=0;f[k+4>>2]=0;c=aD(k,56)|0;v=351006;z=c+56|0;do{b[c>>0]=b[v>>0]|0;c=c+1|0;v=v+1|0}while((c|0)<(z|0));bO(-215,k,351063,350849,659);bD(k)}else{v=((f[a+384>>2]|0)/(f[t>>2]|0)|0)+o|0;c=f[q>>2]|0;z=f[p>>2]|0;f[l>>2]=y;f[l+4>>2]=v;f[l+8>>2]=c;f[l+12>>2]=z;dI(k,w,l);z=l+8|0;f[z>>2]=0;f[z+4>>2]=0;f[l>>2]=34209792;f[l+4>>2]=i;z=m+8|0;f[z>>2]=0;f[z+4>>2]=0;f[m>>2]=34209792;f[m+4>>2]=j;z=n+8|0;f[z>>2]=0;f[z+4>>2]=0;f[n>>2]=34209792;f[n+4>>2]=k;C3(d,l,m,n,4,4);hI(k)}while(0);hI(j);hI(i)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Wpa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;dQ(d,103608);e=f[a+16>>2]|0;if(b[a+380>>0]|0){g=Y(f[a+20>>2]|0,e)|0;f[a+384>>2]=g}g=f[a+408>>2]|0;h=f[a+412>>2]|0;i=Y(h,e)|0;f[a+392>>2]=i+g;j=(f[a+416>>2]|0)+g|0;f[a+396>>2]=j+i;i=Y((f[a+420>>2]|0)+h|0,e)|0;f[a+400>>2]=i+g;f[a+404>>2]=j+i;i=f[a+360>>2]|0;j=(f[i+4>>2]|0)-(f[i>>2]|0)>>6;g=a+368|0;h=f[g>>2]|0;k=h+4|0;l=f[k>>2]|0;m=f[h>>2]|0;n=l-m>>6;o=m;m=l;if(j>>>0<=n>>>0){if(j>>>0<n>>>0?(l=o+(j<<6)|0,(m|0)!=(l|0)):0)f[k>>2]=m+(~((m+-64-l|0)>>>6)<<6);l=f[h>>2]|0;m=a+428|0;f[m>>2]=l;if(!j)p=1;else{q=l;r=m;s=9}}else{Xpa(h,j-n|0);n=f[f[g>>2]>>2]|0;g=a+428|0;f[g>>2]=n;q=n;r=g;s=9}if((s|0)==9){s=a+384|0;Ypa(q,f[i>>2]|0,e,f[s>>2]|0);if((j|0)==1)p=0;else{q=1;do{Ypa((f[r>>2]|0)+(q<<6)|0,(f[i>>2]|0)+(q<<6)|0,e,f[s>>2]|0);q=q+1|0}while((q|0)!=(j|0));p=0}}q=a+376|0;s=f[q>>2]|0;r=s+4|0;g=f[r>>2]|0;n=f[s>>2]|0;h=g-n>>6;m=n;n=g;if(j>>>0<=h>>>0)if(j>>>0<h>>>0?(g=m+(j<<6)|0,(n|0)!=(g|0)):0){f[r>>2]=n+(~((n+-64-g|0)>>>6)<<6);t=s}else t=s;else{Xpa(s,j-h|0);t=f[q>>2]|0}a:do if(p)v=t;else{h=a+32|0;s=a+384|0;g=0;n=t;while(1){r=f[n>>2]|0;if((f[n+4>>2]|0)-r>>6>>>0<=g>>>0)break;m=f[h>>2]|0;Ypa(r+(g<<6)|0,(f[i>>2]|0)+(g<<6)|0,(m|0)>0?m:e,f[s>>2]|0);g=g+1|0;m=f[q>>2]|0;if(g>>>0>=j>>>0){v=m;break a}else n=m}d4b(n)}while(0);Zpa(v,a+252|0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function Xpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>6>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+60|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+64|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>6;g=i+b|0;if(g>>>0>67108863)c4b(a);l=d-h|0;h=l>>5;d=l>>6>>>0<33554431?(h>>>0<g>>>0?g:h):67108863;do if(d)if(d>>>0>67108863){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{m=L5b(d<<6)|0;break}else m=0;while(0);h=m+(i<<6)|0;i=m+(d<<6)|0;d=b;b=h;m=h;do{j=b;k=j+60|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+64|0;m=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;j=h+(0-(b>>6)<<6)|0;if((b|0)>0)Vac(j|0,d|0,b|0)|0;f[a>>2]=j;f[e>>2]=m;f[c>>2]=i;if(!d)return;O5b(d);return}function Ypa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f[a+48>>2]=f[c+20>>2];g=c+24|0;f[a+52>>2]=f[c+40>>2];h=c+44|0;f[a+56>>2]=f[c+60>>2];i=c+4|0;j=f[i>>2]|0;if(!(b[c>>0]|0)){k=c+8|0;l=(Y(f[k>>2]|0,d)|0)+j|0;f[a>>2]=l;l=c+12|0;m=(f[l>>2]|0)+(f[i>>2]|0)+(Y(f[k>>2]|0,d)|0)|0;f[a+4>>2]=m;m=c+16|0;n=(Y((f[m>>2]|0)+(f[k>>2]|0)|0,d)|0)+(f[i>>2]|0)|0;f[a+8>>2]=n;n=(f[l>>2]|0)+(f[i>>2]|0)+(Y((f[m>>2]|0)+(f[k>>2]|0)|0,d)|0)|0;f[a+12>>2]=n;n=c+28|0;k=(Y(f[n>>2]|0,d)|0)+(f[g>>2]|0)|0;f[a+16>>2]=k;k=c+32|0;m=(f[k>>2]|0)+(f[g>>2]|0)+(Y(f[n>>2]|0,d)|0)|0;f[a+20>>2]=m;m=c+36|0;l=(Y((f[m>>2]|0)+(f[n>>2]|0)|0,d)|0)+(f[g>>2]|0)|0;f[a+24>>2]=l;l=(f[k>>2]|0)+(f[g>>2]|0)+(Y((f[m>>2]|0)+(f[n>>2]|0)|0,d)|0)|0;f[a+28>>2]=l;l=c+48|0;n=(Y(f[l>>2]|0,d)|0)+(f[h>>2]|0)|0;f[a+32>>2]=n;n=c+52|0;m=(f[n>>2]|0)+(f[h>>2]|0)+(Y(f[l>>2]|0,d)|0)|0;f[a+36>>2]=m;m=c+56|0;k=(Y((f[m>>2]|0)+(f[l>>2]|0)|0,d)|0)+(f[h>>2]|0)|0;f[a+40>>2]=k;o=(f[n>>2]|0)+(f[h>>2]|0)|0;p=f[l>>2]|0;q=f[m>>2]|0;r=q+p|0;s=Y(r,d)|0;t=s+o|0;u=a+44|0;f[u>>2]=t;return}else{m=c+8|0;l=j+e+(Y(f[m>>2]|0,d)|0)|0;f[a>>2]=l;l=c+16|0;j=f[l>>2]|0;n=(f[i>>2]|0)+e-j+(Y((f[m>>2]|0)+j|0,d)|0)|0;f[a+4>>2]=n;n=c+12|0;j=f[n>>2]|0;k=(f[i>>2]|0)+e+j+(Y((f[m>>2]|0)+j|0,d)|0)|0;f[a+8>>2]=k;k=f[n>>2]|0;n=f[l>>2]|0;l=(f[i>>2]|0)+e+k-n+(Y(n+k+(f[m>>2]|0)|0,d)|0)|0;f[a+12>>2]=l;l=c+28|0;m=(f[g>>2]|0)+e+(Y(f[l>>2]|0,d)|0)|0;f[a+16>>2]=m;m=c+36|0;k=f[m>>2]|0;n=(f[g>>2]|0)+e-k+(Y((f[l>>2]|0)+k|0,d)|0)|0;f[a+20>>2]=n;n=c+32|0;k=f[n>>2]|0;i=(f[g>>2]|0)+e+k+(Y((f[l>>2]|0)+k|0,d)|0)|0;f[a+24>>2]=i;i=f[n>>2]|0;n=f[m>>2]|0;m=(f[g>>2]|0)+e+i-n+(Y(n+i+(f[l>>2]|0)|0,d)|0)|0;f[a+28>>2]=m;m=c+48|0;l=(f[h>>2]|0)+e+(Y(f[m>>2]|0,d)|0)|0;f[a+32>>2]=l;l=c+56|0;i=f[l>>2]|0;n=(f[h>>2]|0)+e-i+(Y((f[m>>2]|0)+i|0,d)|0)|0;f[a+36>>2]=n;n=c+52|0;c=f[n>>2]|0;i=(f[h>>2]|0)+e+c+(Y((f[m>>2]|0)+c|0,d)|0)|0;f[a+40>>2]=i;i=f[n>>2]|0;n=f[l>>2]|0;o=(f[h>>2]|0)+e+i-n|0;p=(f[m>>2]|0)+i|0;q=n;r=q+p|0;s=Y(r,d)|0;t=s+o|0;u=a+44|0;f[u>>2]=t;return}}function Zpa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+80|0;e=d+56|0;g=d;h=f[a>>2]|0;i=a+4|0;j=f[i>>2]|0;if((h|0)==(j|0)){k=c+24|0;l=f[k>>2]|0;if(l|0?(m=l+8|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)iI(c);l=c+4|0;if((f[l>>2]|0)>0){m=f[c+32>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}f[k>>2]=0;o=f[a>>2]|0;p=f[i>>2]|0}else{o=h;p=j}j=p-o|0;p=o;f[g>>2]=1124007936;h=g+4|0;f[h>>2]=2;i=g+8|0;f[i>>2]=1;a=g+12|0;f[a>>2]=j;k=g+16|0;f[k>>2]=p;l=g+20|0;f[l>>2]=p;n=g+24|0;m=g+28|0;q=g+40|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[q>>2]=i;r=g+48|0;s=g+44|0;f[s>>2]=r;f[g+52>>2]=0;f[r>>2]=0;if((o|0)==0&(j|0)!=0){f[e>>2]=0;f[e+4>>2]=0;o=aD(e,26)|0;t=426262;v=o+26|0;do{b[o>>0]=b[t>>0]|0;o=o+1|0;t=t+1|0}while((o|0)<(v|0));bO(-215,e,426289,431198,500);bD(e);w=f[g>>2]|16384;x=f[a>>2]|0;y=f[s>>2]|0;z=f[l>>2]|0}else{w=1124024320;x=j;y=r;z=p}f[g>>2]=w;f[y>>2]=x;f[y+4>>2]=1;y=z+(Y(f[i>>2]|0,x)|0)|0;f[m>>2]=y;f[n>>2]=y+(0-x)+x;x=e+8|0;f[x>>2]=0;f[x+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=c;SP(g,e);e=g+36|0;c=f[e>>2]|0;if(c|0?(x=c+12|0,c=f[x>>2]|0,f[x>>2]=c+-1,(c|0)==1):0)kL(g);f[e>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[h>>2]|0)>0){k=f[q>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[h>>2]|0))}h=f[s>>2]|0;if((h|0)==(r|0)){u=d;return}UC(h);u=d;return}function _pa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0.0,g=0.0,h=0.0,i=0,j=0.0,k=0.0;c=f[a+428>>2]|0;d=f[a+424>>2]|0;e=+n[c+(b<<6)+48>>2]*+((f[d+(f[c+(b<<6)>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+4>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+8>>2]<<2)>>2]|0)+(f[d+(f[c+(b<<6)+12>>2]<<2)>>2]|0)|0)+ +n[c+(b<<6)+52>>2]*+((f[d+(f[c+(b<<6)+16>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+20>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+24>>2]<<2)>>2]|0)+(f[d+(f[c+(b<<6)+28>>2]<<2)>>2]|0)|0);g=+n[c+(b<<6)+56>>2];if(!(g!=0.0)){h=e;i=a+432|0;j=+n[i>>2];k=h*j;return +k}h=e+g*+((f[d+(f[c+(b<<6)+32>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+36>>2]<<2)>>2]|0)-(f[d+(f[c+(b<<6)+40>>2]<<2)>>2]|0)+(f[d+(f[c+(b<<6)+44>>2]<<2)>>2]|0)|0);i=a+432|0;j=+n[i>>2];k=h*j;return +k}function $pa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;if((c|0)>-1?(g=f[a+352>>2]|0,h=f[g+4>>2]|0,i=f[g>>2]|0,((h-i|0)/20|0|0)>(c|0)):0){j=i;k=h;l=g}else{f[e>>2]=0;f[e+4>>2]=0;g=aD(e,50)|0;h=351144;i=g+50|0;do{b[g>>0]=b[h>>0]|0;g=g+1|0;h=h+1|0}while((g|0)<(i|0));bO(-215,e,351195,351208,46);bD(e);e=f[a+352>>2]|0;j=f[e>>2]|0;k=f[e+4>>2]|0;l=e}if(((k-j|0)/20|0)>>>0>c>>>0){u=d;return j+(c*20|0)|0}else d4b(l);return 0}function aqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[a+36>>2]=f[b+36>>2];f[a+40>>2]=f[b+40>>2];c=a+44|0;d=b+44|0;e=(a|0)==(b|0);do if(!e){g=b+80|0;h=f[g>>2]|0;if(h|0){i=h+12|0;f[i>>2]=(f[i>>2]|0)+1}i=a+80|0;h=f[i>>2]|0;if(h|0?(j=h+12|0,h=f[j>>2]|0,f[j>>2]=h+-1,(h|0)==1):0)kL(c);f[i>>2]=0;h=a+60|0;j=a+48|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[j>>2]|0)>0){k=f[a+84>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0;m=f[j>>2]|0}while((l|0)<(m|0));f[c>>2]=f[d>>2];if((m|0)<3)n=12;else n=14}else{f[c>>2]=f[d>>2];n=12}if((n|0)==12){l=f[b+48>>2]|0;if((l|0)<3){f[j>>2]=l;f[a+52>>2]=f[b+52>>2];f[a+56>>2]=f[b+56>>2];l=f[b+88>>2]|0;k=f[a+88>>2]|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2]}else n=14}if((n|0)==14)jL(c,d);f[h>>2]=f[b+60>>2];f[a+64>>2]=f[b+64>>2];f[a+68>>2]=f[b+68>>2];f[a+72>>2]=f[b+72>>2];f[a+76>>2]=f[b+76>>2];f[i>>2]=f[g>>2];l=a+100|0;k=b+100|0;if(!e){o=b+136|0;p=f[o>>2]|0;if(p|0){q=p+12|0;f[q>>2]=(f[q>>2]|0)+1}q=a+136|0;p=f[q>>2]|0;if(p|0?(r=p+12|0,p=f[r>>2]|0,f[r>>2]=p+-1,(p|0)==1):0)kL(l);f[q>>2]=0;p=a+116|0;r=a+104|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[r>>2]|0)>0){s=f[a+140>>2]|0;t=0;do{f[s+(t<<2)>>2]=0;t=t+1|0;u=f[r>>2]|0}while((t|0)<(u|0));f[l>>2]=f[k>>2];if((u|0)<3)n=26;else n=28}else{f[l>>2]=f[k>>2];n=26}if((n|0)==26){t=f[b+104>>2]|0;if((t|0)<3){f[r>>2]=t;f[a+108>>2]=f[b+108>>2];f[a+112>>2]=f[b+112>>2];t=f[b+144>>2]|0;s=f[a+144>>2]|0;f[s>>2]=f[t>>2];f[s+4>>2]=f[t+4>>2]}else n=28}if((n|0)==28)jL(l,k);f[p>>2]=f[b+116>>2];f[a+120>>2]=f[b+120>>2];f[a+124>>2]=f[b+124>>2];f[a+128>>2]=f[b+128>>2];f[a+132>>2]=f[b+132>>2];f[q>>2]=f[o>>2];t=a+156|0;s=b+156|0;if(!e){g=b+180|0;i=f[g>>2]|0;if(i|0){h=i+8|0;f[h>>2]=(f[h>>2]|0)+1}h=a+180|0;i=f[h>>2]|0;if(i|0?(j=i+8|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)iI(t);i=a+160|0;if((f[i>>2]|0)>0){j=f[a+188>>2]|0;v=0;do{f[j+(v<<2)>>2]=0;v=v+1|0;w=f[i>>2]|0}while((v|0)<(w|0));f[h>>2]=0;f[t>>2]=f[s>>2];if((w|0)<3)n=40;else n=42}else{f[h>>2]=0;f[t>>2]=f[s>>2];n=40}if((n|0)==40){v=f[b+160>>2]|0;if((v|0)<3){f[i>>2]=v;f[a+164>>2]=f[b+164>>2];f[a+168>>2]=f[b+168>>2];v=f[b+192>>2]|0;j=f[a+192>>2]|0;f[j>>2]=f[v>>2];f[j+4>>2]=f[v+4>>2]}else n=42}if((n|0)==42)gI(t,s);f[a+172>>2]=f[b+172>>2];v=a+176|0;if(!(f[v>>2]|0))f[v>>2]=f[b+176>>2];f[h>>2]=f[g>>2];f[a+184>>2]=f[b+184>>2];v=a+204|0;j=b+204|0;if(!e){o=b+228|0;q=f[o>>2]|0;if(q|0){p=q+8|0;f[p>>2]=(f[p>>2]|0)+1}p=a+228|0;q=f[p>>2]|0;if(q|0?(k=q+8|0,q=f[k>>2]|0,f[k>>2]=q+-1,(q|0)==1):0)iI(v);q=a+208|0;if((f[q>>2]|0)>0){k=f[a+236>>2]|0;l=0;do{f[k+(l<<2)>>2]=0;l=l+1|0;x=f[q>>2]|0}while((l|0)<(x|0));f[p>>2]=0;f[v>>2]=f[j>>2];if((x|0)<3)n=56;else n=58}else{f[p>>2]=0;f[v>>2]=f[j>>2];n=56}if((n|0)==56){l=f[b+208>>2]|0;if((l|0)<3){f[q>>2]=l;f[a+212>>2]=f[b+212>>2];f[a+216>>2]=f[b+216>>2];l=f[b+240>>2]|0;k=f[a+240>>2]|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2]}else n=58}if((n|0)==58)gI(v,j);f[a+220>>2]=f[b+220>>2];l=a+224|0;if(!(f[l>>2]|0))f[l>>2]=f[b+224>>2];f[p>>2]=f[o>>2];f[a+232>>2]=f[b+232>>2];l=a+252|0;k=b+252|0;if(!e){g=b+276|0;h=f[g>>2]|0;if(h|0){s=h+8|0;f[s>>2]=(f[s>>2]|0)+1}s=a+276|0;h=f[s>>2]|0;do if(h|0){t=h+8|0;i=f[t>>2]|0;f[t>>2]=i+-1;if((i|0)!=1)break;iI(l)}while(0);h=a+256|0;if((f[h>>2]|0)>0){o=f[a+284>>2]|0;p=0;do{f[o+(p<<2)>>2]=0;p=p+1|0;y=f[h>>2]|0}while((p|0)<(y|0));f[s>>2]=0;f[l>>2]=f[k>>2];if((y|0)<3)n=72;else n=74}else{f[s>>2]=0;f[l>>2]=f[k>>2];n=72}do if((n|0)==72){p=f[b+256>>2]|0;if((p|0)>=3){n=74;break}f[h>>2]=p;f[a+260>>2]=f[b+260>>2];f[a+264>>2]=f[b+264>>2];p=f[b+288>>2]|0;o=f[a+288>>2]|0;f[o>>2]=f[p>>2];f[o+4>>2]=f[p+4>>2]}while(0);if((n|0)==74)gI(l,k);f[a+268>>2]=f[b+268>>2];h=a+272|0;if(!(f[h>>2]|0))f[h>>2]=f[b+272>>2];f[s>>2]=f[g>>2];f[a+280>>2]=f[b+280>>2];h=a+300|0;p=b+300|0;if(e)break;o=b+324|0;j=f[o>>2]|0;if(j|0){v=j+8|0;f[v>>2]=(f[v>>2]|0)+1}v=a+324|0;j=f[v>>2]|0;do if(j|0){q=j+8|0;i=f[q>>2]|0;f[q>>2]=i+-1;if((i|0)!=1)break;iI(h)}while(0);j=a+304|0;if((f[j>>2]|0)>0){g=f[a+332>>2]|0;s=0;do{f[g+(s<<2)>>2]=0;s=s+1|0;z=f[j>>2]|0}while((s|0)<(z|0));f[v>>2]=0;f[h>>2]=f[p>>2];if((z|0)<3)n=88;else n=90}else{f[v>>2]=0;f[h>>2]=f[p>>2];n=88}do if((n|0)==88){s=f[b+304>>2]|0;if((s|0)>=3){n=90;break}f[j>>2]=s;f[a+308>>2]=f[b+308>>2];f[a+312>>2]=f[b+312>>2];s=f[b+336>>2]|0;g=f[a+336>>2]|0;f[g>>2]=f[s>>2];f[g+4>>2]=f[s+4>>2]}while(0);if((n|0)==90)gI(h,p);f[a+316>>2]=f[b+316>>2];j=a+320|0;if(!(f[j>>2]|0))f[j>>2]=f[b+320>>2];f[v>>2]=f[o>>2];f[a+328>>2]=f[b+328>>2]}}}}}while(0);n=a+348|0;z=f[b+348>>2]|0;e=f[b+352>>2]|0;if(z|0){b=z+4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[n>>2]|0;f[n>>2]=z;f[a+352>>2]=e;if(!b)return a|0;e=b+4|0;z=f[e>>2]|0;f[e>>2]=z+-1;if((z|0)!=1)return a|0;bi[f[(f[b>>2]|0)+8>>2]&2047](b);return a|0}function bqa(a){a=a|0;O5b(a);return}function cqa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function dqa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>6>>>0>=c>>>0){i=c;j=h;do{b[j>>0]=0;k=j+4|0;l=k+60|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));j=(f[g>>2]|0)+64|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>6;h=j+c|0;if(h>>>0>67108863)c4b(a);m=e-i|0;i=m>>5;e=m>>6>>>0<33554431?(i>>>0<h>>>0?h:i):67108863;do if(e)if(e>>>0>67108863){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{n=L5b(e<<6)|0;break}else n=0;while(0);i=n+(j<<6)|0;j=i;h=n+(e<<6)|0;e=c;c=j;n=i;do{b[n>>0]=0;k=n+4|0;l=k+60|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));n=c+64|0;c=n;e=e+-1|0}while((e|0)!=0);e=h;h=f[a>>2]|0;n=f[g>>2]|0;k=h;if((n|0)==(h|0)){o=j;p=k}else{j=n+-64-k|0;k=n;n=i;while(1){l=k;k=k+-64|0;b[n+-64>>0]=b[k>>0]|0;f[n+-60>>2]=f[l+-60>>2];f[n+-56>>2]=f[l+-56>>2];f[n+-52>>2]=f[l+-52>>2];f[n+-48>>2]=f[l+-48>>2];f[n+-44>>2]=f[l+-44>>2];f[n+-40>>2]=f[l+-40>>2];f[n+-36>>2]=f[l+-36>>2];f[n+-32>>2]=f[l+-32>>2];f[n+-28>>2]=f[l+-28>>2];f[n+-24>>2]=f[l+-24>>2];f[n+-20>>2]=f[l+-20>>2];f[n+-16>>2]=f[l+-16>>2];f[n+-12>>2]=f[l+-12>>2];f[n+-8>>2]=f[l+-8>>2];f[n+-4>>2]=f[l+-4>>2];if((k|0)==(h|0))break;else n=n+-64|0}o=i+(~(j>>>6)<<6)|0;p=f[a>>2]|0}f[a>>2]=o;f[g>>2]=c;f[d>>2]=e;if(!p)return;O5b(p);return}function eqa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+160|0;e=d+152|0;g=d+136|0;h=d+88|0;i=d+44|0;j=d;k=d+144|0;jW(g,c,355092);l=g+4|0;kW(h,f[g>>2]|0,f[l>>2]|0,0);m=f[g>>2]|0;n=f[l>>2]|0;kW(i,m,n,lW(g)|0);g=a+4|0;n=g+60|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(n|0));g=h+40|0;n=h+4|0;m=i+4|0;l=h+20|0;o=i+20|0;p=i+40|0;q=j+20|0;r=e+4|0;s=e+4|0;t=e+4|0;v=e+4|0;w=e+4|0;x=0;while(1){y=f[h>>2]|0;if((((y|0)==(f[i>>2]|0)?(f[n>>2]|0)==(f[m>>2]|0):0)?(f[l>>2]|0)==(f[o>>2]|0):0)?(f[g>>2]|0)==(f[p>>2]|0):0)break;kW(j,y,f[l>>2]|0,0);y=f[q>>2]|0;f[e>>2]=f[j>>2];f[r>>2]=y;vW(e,a+4+(x*20|0)|0,0);y=mW(j)|0;z=f[j+20>>2]|0;f[e>>2]=f[j>>2];f[s>>2]=z;vW(e,a+4+(x*20|0)+4|0,0);z=mW(y)|0;y=f[j+20>>2]|0;f[e>>2]=f[j>>2];f[t>>2]=y;vW(e,a+4+(x*20|0)+8|0,0);y=mW(z)|0;z=f[j+20>>2]|0;f[e>>2]=f[j>>2];f[v>>2]=z;vW(e,a+4+(x*20|0)+12|0,0);z=mW(y)|0;y=f[j+20>>2]|0;f[e>>2]=f[j>>2];f[w>>2]=y;wW(e,a+4+(x*20|0)+16|0,0.0);mW(z)|0;mW(h)|0;x=x+1|0}jW(k,c,355098);vW(k,e,0);b[a>>0]=(f[e>>2]|0)!=0&1;u=d;return 1}function fqa(a){a=a|0;O5b(a);return}function gqa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-64-c|0)>>>6)<<6);O5b(c)}O5b(b)}bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function hqa(a){a=a|0;O5b(a);return}function iqa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-64-c|0)>>>6)<<6);O5b(c)}O5b(b)}bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function jqa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=103716;b=a+372|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+376>>2]=0;b=a+364|0;c=f[b>>2]|0;if(c|0?(e=c+4|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+368>>2]=0;b=a+356|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;g=a+360|0;f[g>>2]=0;vpa(a);return}d=c+4|0;e=f[d>>2]|0;f[d>>2]=e+-1;if((e|0)!=1){f[b>>2]=0;g=a+360|0;f[g>>2]=0;vpa(a);return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;g=a+360|0;f[g>>2]=0;vpa(a);return}function kqa(a){a=a|0;jqa(a);O5b(a);return}function lqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+112|0;e=d+56|0;g=d+64|0;h=d+8|0;i=d;f[e>>2]=f[c>>2];f[e+4>>2]=f[c+4>>2];xpa(a,0,e)|0;e=a+356|0;c=a+360|0;if(!(f[c>>2]|0)){j=L5b(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;k=L5b(16)|0;l=k+4|0;f[l>>2]=1;f[k>>2]=103796;f[k+8>>2]=j;f[l>>2]=(f[l>>2]|0)+1;m=f[e>>2]|0;f[e>>2]=k;f[c>>2]=j;if(m|0?(j=m+4|0,e=f[j>>2]|0,f[j>>2]=e+-1,(e|0)==1):0)bi[f[(f[m>>2]|0)+8>>2]&2047](m);m=f[l>>2]|0;f[l>>2]=m+-1;if((m|0)==1)bi[f[(f[k>>2]|0)+8>>2]&2047](k)}k=a+364|0;m=a+368|0;if(!(f[m>>2]|0)){l=L5b(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=L5b(16)|0;j=e+4|0;f[j>>2]=1;f[e>>2]=103816;f[e+8>>2]=l;f[j>>2]=(f[j>>2]|0)+1;n=f[k>>2]|0;f[k>>2]=e;f[m>>2]=l;if(n|0?(l=n+4|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)bi[f[(f[n>>2]|0)+8>>2]&2047](n);n=f[j>>2]|0;f[j>>2]=n+-1;if((n|0)==1)bi[f[(f[e>>2]|0)+8>>2]&2047](e)}e=a+372|0;n=a+376|0;if(!(f[n>>2]|0)){j=L5b(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;m=L5b(16)|0;l=m+4|0;f[l>>2]=1;f[m>>2]=103816;f[m+8>>2]=j;f[l>>2]=(f[l>>2]|0)+1;k=f[e>>2]|0;f[e>>2]=m;f[n>>2]=j;if(k|0?(j=k+4|0,n=f[j>>2]|0,f[j>>2]=n+-1,(n|0)==1):0)bi[f[(f[k>>2]|0)+8>>2]&2047](k);k=f[l>>2]|0;f[l>>2]=k+-1;if((k|0)==1)bi[f[(f[m>>2]|0)+8>>2]&2047](m)}m=f[c>>2]|0;k=lW(b)|0;l=m+4|0;n=f[l>>2]|0;j=f[m>>2]|0;e=n-j>>4;o=j;j=n;if(k>>>0<=e>>>0){if(k>>>0<e>>>0?(n=o+(k<<4)|0,(j|0)!=(n|0)):0)f[l>>2]=j+(~((j+-16-n|0)>>>4)<<4)}else Bqa(m,k-e|0);f[a+380>>2]=0;e=b+4|0;kW(g,f[b>>2]|0,f[e>>2]|0,0);k=f[b>>2]|0;m=f[e>>2]|0;kW(h,k,m,lW(b)|0);b=f[c>>2]|0;c=g+40|0;m=g+4|0;k=h+4|0;e=g+20|0;n=h+20|0;j=h+40|0;l=i+4|0;o=0;while(1){p=f[g>>2]|0;q=p;if((((p|0)==(f[h>>2]|0)?(f[m>>2]|0)==(f[k>>2]|0):0)?(f[e>>2]|0)==(f[n>>2]|0):0)?(f[c>>2]|0)==(f[j>>2]|0):0)break;p=(f[b>>2]|0)+(o<<4)|0;r=f[e>>2]|0;f[i>>2]=q;f[l>>2]=r;Cqa(p,i)|0;mW(g)|0;o=o+1|0}f[a+40>>2]=1;o=a+24|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;u=d;return 1}function mqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=L5b(388)|0;uqa(c);d=L5b(16)|0;e=d+4|0;f[e>>2]=1;f[d>>2]=103776;f[d+8>>2]=c;g=d;h=c;aqa(c,b)|0;i=c+356|0;j=f[b+356>>2]|0;k=f[b+360>>2]|0;if(j|0){l=j+4|0;f[l>>2]=(f[l>>2]|0)+1}l=f[i>>2]|0;f[i>>2]=j;f[c+360>>2]=k;if(l|0?(k=l+4|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)bi[f[(f[l>>2]|0)+8>>2]&2047](l);l=c+364|0;j=f[b+364>>2]|0;k=f[b+368>>2]|0;if(j|0){i=j+4|0;f[i>>2]=(f[i>>2]|0)+1}i=f[l>>2]|0;f[l>>2]=j;f[c+368>>2]=k;if(i|0?(k=i+4|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)bi[f[(f[i>>2]|0)+8>>2]&2047](i);i=c+372|0;j=f[b+372>>2]|0;k=f[b+376>>2]|0;if(j|0){l=j+4|0;f[l>>2]=(f[l>>2]|0)+1}l=f[i>>2]|0;f[i>>2]=j;f[c+376>>2]=k;if(l|0?(k=l+4|0,j=f[k>>2]|0,f[k>>2]=j+-1,(j|0)==1):0)bi[f[(f[l>>2]|0)+8>>2]&2047](l);l=b+380|0;b=f[l+4>>2]|0;j=c+380|0;f[j>>2]=f[l>>2];f[j+4>>2]=b;f[a>>2]=g;f[a+4>>2]=h;f[e>>2]=(f[e>>2]|0)+1;h=f[e>>2]|0;f[e>>2]=h+-1;if((h|0)!=1)return;bi[f[(f[d>>2]|0)+8>>2]&2047](d);return}function nqa(a){a=a|0;return 1}function oqa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if((d|0)>-1?(h=f[a+352>>2]|0,i=f[h+4>>2]|0,j=f[h>>2]|0,((i-j|0)/20|0|0)>(d|0)):0){k=j;l=i;m=h}else{f[g>>2]=0;f[g+4>>2]=0;h=aD(g,50)|0;i=351144;j=h+50|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-215,g,351628,350849,868);bD(g);g=f[a+352>>2]|0;k=f[g>>2]|0;l=f[g+4>>2]|0;m=g}if(((l-k|0)/20|0)>>>0<=d>>>0)d4b(m);m=k;k=f[c>>2]|0;if((k|0)<0){n=0;u=e;return n|0}l=f[c+4>>2]|0;if((l|0)<0){n=0;u=e;return n|0}if(((f[a+8>>2]|0)+k|0)>=(f[m+(d*20|0)+4>>2]|0)){n=0;u=e;return n|0}if(((f[a+12>>2]|0)+l|0)>=(f[m+(d*20|0)+8>>2]|0)){n=0;u=e;return n|0}c=(f[a+60>>2]|0)+(Y(f[f[a+88>>2]>>2]|0,l)|0)+(k<<2)|0;f[a+384>>2]=c+(f[m+(d*20|0)+12>>2]<<2);n=1;u=e;return n|0}function pqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+380>>2]|0;d=f[a+384>>2]|0;a=f[d+(f[c+(b<<6)+20>>2]<<2)>>2]|0;e=f[d+(f[c+(b<<6)+24>>2]<<2)>>2]|0;g=f[d+(f[c+(b<<6)+36>>2]<<2)>>2]|0;h=f[d+(f[c+(b<<6)+40>>2]<<2)>>2]|0;i=a-e-g+h|0;j=f[d+(f[c+(b<<6)+4>>2]<<2)>>2]|0;k=f[d+(f[c+(b<<6)+16>>2]<<2)>>2]|0;l=f[d+(f[c+(b<<6)+8>>2]<<2)>>2]|0;m=f[d+(f[c+(b<<6)+28>>2]<<2)>>2]|0;n=f[d+(f[c+(b<<6)+44>>2]<<2)>>2]|0;o=f[d+(f[c+(b<<6)+56>>2]<<2)>>2]|0;p=f[d+(f[c+(b<<6)+52>>2]<<2)>>2]|0;q=f[d+(f[c+(b<<6)+32>>2]<<2)>>2]|0;return ((e-a+j-l|0)>=(i|0)?64:0)|(((f[d+(f[c+(b<<6)>>2]<<2)>>2]|0)+a-j-k|0)>=(i|0)?128:0)|((l-e-(f[d+(f[c+(b<<6)+12>>2]<<2)>>2]|0)+m|0)>=(i|0)?32:0)|((e-h-m+n|0)>=(i|0)?16:0)|((h-n-o+(f[d+(f[c+(b<<6)+60>>2]<<2)>>2]|0)|0)>=(i|0)?8:0)|((g-h+o-p|0)>=(i|0)?4:0)|(g-a+k-q|0)>=(i|0)|((p-g+q-(f[d+(f[c+(b<<6)+48>>2]<<2)>>2]|0)|0)>=(i|0)?2:0)|0}function qqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+80|0;e=d+24|0;g=d+8|0;h=d;i=f[a+352>>2]|0;j=f[i>>2]|0;if((((f[i+4>>2]|0)-j|0)/20|0)>>>0<=b>>>0)d4b(i);i=j;if((yM(c)|0)==655360){j=f[i+(b*20|0)+12>>2]|0;k=f[a+16>>2]|0;l=f[i+(b*20|0)+4>>2]|0;m=f[i+(b*20|0)+8>>2]|0;f[g>>2]=(j|0)%(k|0)|0;f[g+4>>2]=(j|0)/(k|0)|0;f[g+8>>2]=l;f[g+12>>2]=m;dI(e,a+204|0,g);m=g+8|0;f[m>>2]=0;f[m+4>>2]=0;f[g>>2]=34209792;f[g+4>>2]=e;m=UM()|0;C3(c,g,m,UM()|0,4,-1);hI(e);u=d;return}f[h>>2]=f[i+(b*20|0)+4>>2];f[h+4>>2]=f[i+(b*20|0)+8>>2];JF(e,h,4,(f[a+60>>2]|0)+(f[i+(b*20|0)+12>>2]<<2)|0,f[a+92>>2]|0);a=g+8|0;f[a>>2]=0;f[a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=e;a=UM()|0;C3(c,g,a,UM()|0,4,-1);a=e+36|0;g=f[a>>2]|0;if(g|0?(c=g+12|0,g=f[c>>2]|0,f[c>>2]=g+-1,(g|0)==1):0)kL(e);f[a>>2]=0;a=e+16|0;g=e+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[g>>2]|0)>0){a=f[e+40>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[g>>2]|0))}g=f[e+44>>2]|0;if((g|0)!=(e+48|0))UC(g);u=d;return}function rqa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=f[a+16>>2]|0;c=f[a+360>>2]|0;d=(f[c+4>>2]|0)-(f[c>>2]|0)>>4;e=a+368|0;g=f[e>>2]|0;h=g+4|0;i=f[h>>2]|0;j=f[g>>2]|0;k=i-j>>6;l=j;j=i;if(d>>>0<=k>>>0){if(d>>>0<k>>>0?(i=l+(d<<6)|0,(j|0)!=(i|0)):0)f[h>>2]=j+(~((j+-64-i|0)>>>6)<<6);i=f[g>>2]|0;f[a+380>>2]=i;if(!d){m=g;n=a+252|0;tqa(m,n);return}else{o=i;p=g}}else{sqa(g,d-k|0);k=f[e>>2]|0;e=f[k>>2]|0;f[a+380>>2]=e;o=e;p=k}k=o;o=f[c>>2]|0;c=0;do{e=f[o+(c<<4)>>2]|0;g=f[o+(c<<4)+4>>2]|0;i=f[o+(c<<4)+8>>2]|0;j=f[o+(c<<4)+12>>2]|0;h=Y(g,b)|0;f[k+(c<<6)>>2]=h+e;l=i+e|0;f[k+(c<<6)+4>>2]=l+h;q=Y(j+g|0,b)|0;f[k+(c<<6)+16>>2]=q+e;f[k+(c<<6)+20>>2]=q+l;r=(i<<1)+e|0;f[k+(c<<6)+8>>2]=r+h;s=r+i|0;f[k+(c<<6)+12>>2]=s+h;f[k+(c<<6)+24>>2]=q+r;f[k+(c<<6)+28>>2]=s+q;q=(j<<1)+g|0;g=Y(q,b)|0;f[k+(c<<6)+40>>2]=g+r;f[k+(c<<6)+44>>2]=g+s;h=Y(q+j|0,b)|0;f[k+(c<<6)+56>>2]=h+r;f[k+(c<<6)+60>>2]=h+s;f[k+(c<<6)+32>>2]=g+e;f[k+(c<<6)+36>>2]=g+l;f[k+(c<<6)+48>>2]=h+e;f[k+(c<<6)+52>>2]=h+l;c=c+1|0}while((c|0)!=(d|0));m=p;n=a+252|0;tqa(m,n);return}function sqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>6>>>0>=b>>>0){h=b;i=g;do{j=i;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));i=(f[e>>2]|0)+64|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>6;g=i+b|0;if(g>>>0>67108863)c4b(a);l=d-h|0;h=l>>5;d=l>>6>>>0<33554431?(h>>>0<g>>>0?g:h):67108863;do if(d)if(d>>>0>67108863){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{m=L5b(d<<6)|0;break}else m=0;while(0);h=m+(i<<6)|0;i=m+(d<<6)|0;d=b;b=h;m=h;do{j=b;k=j+64|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));b=m+64|0;m=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;j=h+(0-(b>>6)<<6)|0;if((b|0)>0)Vac(j|0,d|0,b|0)|0;f[a>>2]=j;f[e>>2]=m;f[c>>2]=i;if(!d)return;O5b(d);return}function tqa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+80|0;e=d+56|0;g=d;h=f[a>>2]|0;i=a+4|0;j=f[i>>2]|0;if((h|0)==(j|0)){k=c+24|0;l=f[k>>2]|0;if(l|0?(m=l+8|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)iI(c);l=c+4|0;if((f[l>>2]|0)>0){m=f[c+32>>2]|0;n=0;do{f[m+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}f[k>>2]=0;o=f[a>>2]|0;p=f[i>>2]|0}else{o=h;p=j}j=p-o|0;p=o;f[g>>2]=1124007936;h=g+4|0;f[h>>2]=2;i=g+8|0;f[i>>2]=1;a=g+12|0;f[a>>2]=j;k=g+16|0;f[k>>2]=p;l=g+20|0;f[l>>2]=p;n=g+24|0;m=g+28|0;q=g+40|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[q>>2]=i;r=g+48|0;s=g+44|0;f[s>>2]=r;f[g+52>>2]=0;f[r>>2]=0;if((o|0)==0&(j|0)!=0){f[e>>2]=0;f[e+4>>2]=0;o=aD(e,26)|0;t=426262;v=o+26|0;do{b[o>>0]=b[t>>0]|0;o=o+1|0;t=t+1|0}while((o|0)<(v|0));bO(-215,e,426289,431198,500);bD(e);w=f[g>>2]|16384;x=f[a>>2]|0;y=f[s>>2]|0;z=f[l>>2]|0}else{w=1124024320;x=j;y=r;z=p}f[g>>2]=w;f[y>>2]=x;f[y+4>>2]=1;y=z+(Y(f[i>>2]|0,x)|0)|0;f[m>>2]=y;f[n>>2]=y+(0-x)+x;x=e+8|0;f[x>>2]=0;f[x+4>>2]=0;f[e>>2]=34209792;f[e+4>>2]=c;SP(g,e);e=g+36|0;c=f[e>>2]|0;if(c|0?(x=c+12|0,c=f[x>>2]|0,f[x>>2]=c+-1,(c|0)==1):0)kL(g);f[e>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[h>>2]|0)>0){k=f[q>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[h>>2]|0))}h=f[s>>2]|0;if((h|0)==(r|0)){u=d;return}UC(h);u=d;return}function uqa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;f[a+44>>2]=1124007936;b=a+52|0;c=a+84|0;d=a+48|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+92|0;f[a+88>>2]=b;f[b>>2]=0;f[a+96>>2]=0;f[a+100>>2]=1124007936;b=a+108|0;c=a+140|0;d=a+104|0;e=d+36|0;do{f[d>>2]=0;d=d+4|0}while((d|0)<(e|0));f[c>>2]=b;b=a+148|0;f[a+144>>2]=b;f[b>>2]=0;f[a+152>>2]=0;f[a+156>>2]=1124007936;b=a+160|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+188>>2]=a+164;b=a+196|0;f[a+192>>2]=b;f[a+200>>2]=0;f[b>>2]=0;f[a+204>>2]=1124007936;b=a+208|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+236>>2]=a+212;b=a+244|0;f[a+240>>2]=b;f[a+248>>2]=0;f[b>>2]=0;f[a+252>>2]=1124007936;b=a+256|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+284>>2]=a+260;b=a+292|0;f[a+288>>2]=b;f[a+296>>2]=0;f[b>>2]=0;f[a+300>>2]=1124007936;b=a+304|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[a+332>>2]=a+308;b=a+340|0;f[a+336>>2]=b;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[a>>2]=103716;b=a+356|0;c=a+364|0;d=a+368|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;e=L5b(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=L5b(16)|0;h=g+4|0;f[h>>2]=1;f[g>>2]=103796;f[g+8>>2]=e;f[h>>2]=(f[h>>2]|0)+1;i=f[b>>2]|0;f[b>>2]=g;f[a+360>>2]=e;if(i|0?(e=i+4|0,b=f[e>>2]|0,f[e>>2]=b+-1,(b|0)==1):0)bi[f[(f[i>>2]|0)+8>>2]&2047](i);i=f[h>>2]|0;f[h>>2]=i+-1;if((i|0)==1)bi[f[(f[g>>2]|0)+8>>2]&2047](g);g=L5b(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;i=L5b(16)|0;h=i+4|0;f[h>>2]=1;f[i>>2]=103816;f[i+8>>2]=g;f[h>>2]=(f[h>>2]|0)+1;b=f[c>>2]|0;f[c>>2]=i;f[d>>2]=g;if(b|0?(g=b+4|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)bi[f[(f[b>>2]|0)+8>>2]&2047](b);b=f[h>>2]|0;f[h>>2]=b+-1;if((b|0)==1)bi[f[(f[i>>2]|0)+8>>2]&2047](i);i=L5b(12)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b=L5b(16)|0;h=b+4|0;f[h>>2]=1;f[b>>2]=103536;f[b+8>>2]=i;d=a+348|0;f[h>>2]=(f[h>>2]|0)+1;g=f[d>>2]|0;f[d>>2]=b;f[a+352>>2]=i;if(g|0?(i=g+4|0,d=f[i>>2]|0,f[i>>2]=d+-1,(d|0)==1):0)bi[f[(f[g>>2]|0)+8>>2]&2047](g);g=f[h>>2]|0;f[h>>2]=g+-1;if((g|0)!=1){j=a+380|0;f[j>>2]=0;k=a+384|0;f[k>>2]=0;return}bi[f[(f[b>>2]|0)+8>>2]&2047](b);j=a+380|0;f[j>>2]=0;k=a+384|0;f[k>>2]=0;return}function vqa(a){a=a|0;O5b(a);return}function wqa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xqa(a){a=a|0;O5b(a);return}function yqa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-64-c|0)>>>6)<<6);O5b(c)}O5b(b)}bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function zqa(a){a=a|0;O5b(a);return}function Aqa(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+8>>2]|0;if(b|0){c=f[b>>2]|0;if(c|0){d=b+4|0;e=f[d>>2]|0;if((e|0)!=(c|0))f[d>>2]=e+(~((e+-16-c|0)>>>4)<<4);O5b(c)}O5b(b)}bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Bqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>4>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;i=(f[e>>2]|0)+16|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>4;g=i+b|0;if(g>>>0>268435455)c4b(a);j=d-h|0;h=j>>3;d=j>>4>>>0<134217727?(h>>>0<g>>>0?g:h):268435455;do if(d)if(d>>>0>268435455){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<4)|0;break}else k=0;while(0);h=k+(i<<4)|0;i=h;g=k+(d<<4)|0;d=b;b=h;k=i;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;b=k+16|0;k=b;d=d+-1|0}while((d|0)!=0);d=g;g=f[a>>2]|0;b=f[e>>2]|0;j=g;if((b|0)==(g|0)){l=i;m=j}else{i=b+-16-j|0;j=b;b=h;while(1){n=j;j=j+-16|0;f[b+-16>>2]=f[j>>2];f[b+-12>>2]=f[n+-12>>2];f[b+-8>>2]=f[n+-8>>2];f[b+-4>>2]=f[n+-4>>2];if((j|0)==(g|0))break;else b=b+-16|0}l=h+(~(i>>>4)<<4)|0;m=f[a>>2]|0}f[a>>2]=l;f[e>>2]=k;f[c>>2]=d;if(!m)return;O5b(m);return}function Cqa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+64|0;d=c+56|0;e=c+48|0;g=c;jW(e,b,351948);kW(g,f[e>>2]|0,f[e+4>>2]|0,0);e=f[g+20>>2]|0;f[d>>2]=f[g>>2];f[d+4>>2]=e;vW(d,a,0);e=mW(g)|0;b=f[g+20>>2]|0;f[d>>2]=f[g>>2];f[d+4>>2]=b;vW(d,a+4|0,0);b=mW(e)|0;e=f[g+20>>2]|0;f[d>>2]=f[g>>2];f[d+4>>2]=e;vW(d,a+8|0,0);e=mW(b)|0;b=f[g+20>>2]|0;f[d>>2]=f[g>>2];f[d+4>>2]=b;vW(d,a+12|0,0);mW(e)|0;u=c;return 1}function Dqa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=103836;OO(a+416|0);hI(a+368|0);hI(a+320|0);hI(a+272|0);hI(a+224|0);hI(a+176|0);hI(a+128|0);b=a+120|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+124>>2]=0;b=a+112|0;c=f[b>>2]|0;if(c|0?(e=c+4|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+116>>2]=0;b=a+104|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+108>>2]=0;gra(a+4|0);xY(a);return}function Eqa(a){a=a|0;Dqa(a);O5b(a);return}function Fqa(a,b){a=a|0;b=b|0;hra(a,b)|0;return}function Gqa(a){a=a|0;var b=0;if(f[a+116>>2]|0){b=0;return b|0}b=(f[a+32>>2]|0)==(f[a+36>>2]|0);return b|0}
function ATb(a,c,d,e,g,i){a=a|0;c=+c;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;j=u;u=u+560|0;k=j+8|0;l=j;m=j+524|0;n=m;o=j+512|0;f[l>>2]=0;p=o+12|0;BTb(c)|0;if((J|0)<0){q=-c;r=1;s=483218}else{q=c;r=(g&2049|0)!=0&1;s=(g&2048|0)==0?((g&1|0)==0?483219:483224):483221}BTb(q)|0;t=J&2146435072;do if(t>>>0<2146435072|(t|0)==2146435072&0<0){c=+CTb(q,l)*2.0;v=c!=0.0;if(v)f[l>>2]=(f[l>>2]|0)+-1;w=i|32;if((w|0)==97){x=i&32;y=(x|0)==0?s:s+9|0;z=r|2;A=12-e|0;do if(!(e>>>0>11|(A|0)==0)){B=8.0;C=A;do{C=C+-1|0;B=B*16.0}while((C|0)!=0);if((b[y>>0]|0)==45){D=-(B+(-c-B));break}else{D=c+B-B;break}}else D=c;while(0);A=f[l>>2]|0;C=(A|0)<0?0-A|0:A;E=vTb(C,((C|0)<0)<<31>>31,p)|0;if((E|0)==(p|0)){C=o+11|0;b[C>>0]=48;F=C}else F=E;b[F+-1>>0]=(A>>31&2)+43;A=F+-2|0;b[A>>0]=i+15;E=(e|0)<1;C=(g&8|0)==0;G=m;H=D;while(1){I=~~H;K=G+1|0;b[G>>0]=h[483249+I>>0]|x;H=(H-+(I|0))*16.0;if((K-n|0)==1?!(C&(E&H==0.0)):0){b[K>>0]=46;L=G+2|0}else L=K;if(!(H!=0.0))break;else G=L}G=L-n|0;E=p-A|0;C=(e|0)!=0&(G+-2|0)<(e|0)?e+2|0:G;x=E+z+C|0;yTb(a,32,d,x,g);qTb(a,y,z);yTb(a,48,d,x,g^65536);qTb(a,m,G);yTb(a,48,C-G|0,0,0);qTb(a,A,E);yTb(a,32,d,x,g^8192);M=x;break}x=(e|0)<0?6:e;if(v){E=(f[l>>2]|0)+-28|0;f[l>>2]=E;N=c*268435456.0;O=E}else{N=c;O=f[l>>2]|0}E=(O|0)<0?k:k+288|0;G=E;H=N;do{C=~~H>>>0;f[G>>2]=C;G=G+4|0;H=(H-+(C>>>0))*1.0e9}while(H!=0.0);if((O|0)>0){v=E;A=G;z=O;while(1){y=(z|0)<29?z:29;C=A+-4|0;if(C>>>0>=v>>>0){K=C;C=0;do{I=$ac(f[K>>2]|0,0,y|0)|0;P=Kac(I|0,J|0,C|0,0)|0;I=J;Q=Yac(P|0,I|0,1e9,0)|0;f[K>>2]=Q;C=Uac(P|0,I|0,1e9,0)|0;K=K+-4|0}while(K>>>0>=v>>>0);if(C){K=v+-4|0;f[K>>2]=C;R=K}else R=v}else R=v;K=A;while(1){if(K>>>0<=R>>>0)break;I=K+-4|0;if(!(f[I>>2]|0))K=I;else break}C=(f[l>>2]|0)-y|0;f[l>>2]=C;if((C|0)>0){v=R;A=K;z=C}else{S=R;T=K;U=C;break}}}else{S=E;T=G;U=O}if((U|0)<0){z=((x+25|0)/9|0)+1|0;A=(w|0)==102;v=S;C=T;I=U;while(1){P=0-I|0;Q=(P|0)<9?P:9;if(v>>>0<C>>>0){P=(1<<Q)+-1|0;V=1e9>>>Q;W=0;X=v;do{Z=f[X>>2]|0;f[X>>2]=(Z>>>Q)+W;W=Y(Z&P,V)|0;X=X+4|0}while(X>>>0<C>>>0);X=(f[v>>2]|0)==0?v+4|0:v;if(!W){_=X;$=C}else{f[C>>2]=W;_=X;$=C+4|0}}else{_=(f[v>>2]|0)==0?v+4|0:v;$=C}X=A?E:_;V=($-X>>2|0)>(z|0)?X+(z<<2)|0:$;I=(f[l>>2]|0)+Q|0;f[l>>2]=I;if((I|0)>=0){aa=_;ba=V;break}else{v=_;C=V}}}else{aa=S;ba=T}C=E;if(aa>>>0<ba>>>0){v=(C-aa>>2)*9|0;I=f[aa>>2]|0;if(I>>>0<10)ca=v;else{z=v;v=10;while(1){v=v*10|0;A=z+1|0;if(I>>>0<v>>>0){ca=A;break}else z=A}}}else ca=0;z=(w|0)==103;v=(x|0)!=0;I=x-((w|0)!=102?ca:0)+((v&z)<<31>>31)|0;if((I|0)<(((ba-C>>2)*9|0)+-9|0)){A=I+9216|0;I=E+4+(((A|0)/9|0)+-1024<<2)|0;G=((A|0)%9|0)+1|0;if((G|0)<9){A=G;G=10;while(1){V=G*10|0;A=A+1|0;if((A|0)==9){da=V;break}else G=V}}else da=10;G=f[I>>2]|0;A=(G>>>0)%(da>>>0)|0;w=(I+4|0)==(ba|0);if(!(w&(A|0)==0)){B=(((G>>>0)/(da>>>0)|0)&1|0)==0?9007199254740992.0:9007199254740994.0;V=(da|0)/2|0;H=A>>>0<V>>>0?.5:w&(A|0)==(V|0)?1.0:1.5;if(!r){ea=H;fa=B}else{V=(b[s>>0]|0)==45;ea=V?-H:H;fa=V?-B:B}V=G-A|0;f[I>>2]=V;if(fa+ea!=fa){A=V+da|0;f[I>>2]=A;if(A>>>0>999999999){A=aa;V=I;while(1){G=V+-4|0;f[V>>2]=0;if(G>>>0<A>>>0){w=A+-4|0;f[w>>2]=0;ga=w}else ga=A;w=(f[G>>2]|0)+1|0;f[G>>2]=w;if(w>>>0>999999999){A=ga;V=G}else{ha=ga;ia=G;break}}}else{ha=aa;ia=I}V=(C-ha>>2)*9|0;A=f[ha>>2]|0;if(A>>>0<10){ja=ia;ka=V;la=ha}else{G=V;V=10;while(1){V=V*10|0;w=G+1|0;if(A>>>0<V>>>0){ja=ia;ka=w;la=ha;break}else G=w}}}else{ja=I;ka=ca;la=aa}}else{ja=I;ka=ca;la=aa}G=ja+4|0;ma=ka;na=ba>>>0>G>>>0?G:ba;oa=la}else{ma=ca;na=ba;oa=aa}G=na;while(1){if(G>>>0<=oa>>>0){pa=0;break}V=G+-4|0;if(!(f[V>>2]|0))G=V;else{pa=1;break}}I=0-ma|0;do if(z){V=((v^1)&1)+x|0;if((V|0)>(ma|0)&(ma|0)>-5){qa=i+-1|0;ra=V+-1-ma|0}else{qa=i+-2|0;ra=V+-1|0}V=g&8;if(!V){if(pa?(A=f[G+-4>>2]|0,(A|0)!=0):0)if(!((A>>>0)%10|0)){w=0;X=10;while(1){X=X*10|0;P=w+1|0;if((A>>>0)%(X>>>0)|0|0){sa=P;break}else w=P}}else sa=0;else sa=9;w=((G-C>>2)*9|0)+-9|0;if((qa|32|0)==102){X=w-sa|0;A=(X|0)>0?X:0;ta=qa;ua=(ra|0)<(A|0)?ra:A;va=0;break}else{A=w+ma-sa|0;w=(A|0)>0?A:0;ta=qa;ua=(ra|0)<(w|0)?ra:w;va=0;break}}else{ta=qa;ua=ra;va=V}}else{ta=i;ua=x;va=g&8}while(0);x=ua|va;C=(x|0)!=0&1;v=(ta|32|0)==102;if(v){wa=0;xa=(ma|0)>0?ma:0}else{z=(ma|0)<0?I:ma;w=vTb(z,((z|0)<0)<<31>>31,p)|0;z=p;if((z-w|0)<2){A=w;while(1){X=A+-1|0;b[X>>0]=48;if((z-X|0)<2)A=X;else{ya=X;break}}}else ya=w;b[ya+-1>>0]=(ma>>31&2)+43;A=ya+-2|0;b[A>>0]=ta;wa=A;xa=z-A|0}A=r+1+ua+C+xa|0;yTb(a,32,d,A,g);qTb(a,s,r);yTb(a,48,d,A,g^65536);if(v){I=oa>>>0>E>>>0?E:oa;X=m+9|0;Q=X;W=m+8|0;P=I;do{K=vTb(f[P>>2]|0,0,X)|0;if((P|0)==(I|0))if((K|0)==(X|0)){b[W>>0]=48;za=W}else za=K;else if(K>>>0>m>>>0){Nac(m|0,48,K-n|0)|0;y=K;while(1){Z=y+-1|0;if(Z>>>0>m>>>0)y=Z;else{za=Z;break}}}else za=K;qTb(a,za,Q-za|0);P=P+4|0}while(P>>>0<=E>>>0);if(x|0)qTb(a,489392,1);if(P>>>0<G>>>0&(ua|0)>0){E=ua;Q=P;while(1){W=vTb(f[Q>>2]|0,0,X)|0;if(W>>>0>m>>>0){Nac(m|0,48,W-n|0)|0;I=W;while(1){v=I+-1|0;if(v>>>0>m>>>0)I=v;else{Aa=v;break}}}else Aa=W;qTb(a,Aa,(E|0)<9?E:9);Q=Q+4|0;I=E+-9|0;if(!(Q>>>0<G>>>0&(E|0)>9)){Ba=I;break}else E=I}}else Ba=ua;yTb(a,48,Ba+9|0,9,0)}else{E=pa?G:oa+4|0;if((ua|0)>-1){Q=m+9|0;X=(va|0)==0;P=Q;x=0-n|0;I=m+8|0;K=ua;v=oa;while(1){C=vTb(f[v>>2]|0,0,Q)|0;if((C|0)==(Q|0)){b[I>>0]=48;Ca=I}else Ca=C;do if((v|0)==(oa|0)){C=Ca+1|0;qTb(a,Ca,1);if(X&(K|0)<1){Da=C;break}qTb(a,489392,1);Da=C}else{if(Ca>>>0<=m>>>0){Da=Ca;break}Nac(m|0,48,Ca+x|0)|0;C=Ca;while(1){z=C+-1|0;if(z>>>0>m>>>0)C=z;else{Da=z;break}}}while(0);W=P-Da|0;qTb(a,Da,(K|0)>(W|0)?W:K);C=K-W|0;v=v+4|0;if(!(v>>>0<E>>>0&(C|0)>-1)){Ea=C;break}else K=C}}else Ea=ua;yTb(a,48,Ea+18|0,18,0);qTb(a,wa,p-wa|0)}yTb(a,32,d,A,g^8192);M=A}else{K=(i&32|0)!=0;E=r+3|0;yTb(a,32,d,E,g&-65537);qTb(a,s,r);qTb(a,q!=q|0.0!=0.0?(K?485166:483245):K?483237:483241,3);yTb(a,32,d,E,g^8192);M=E}while(0);u=j;return ((M|0)<(d|0)?d:M)|0}function BTb(a){a=+a;var b=0;p[s>>3]=a;b=f[s>>2]|0;J=f[s+4>>2]|0;return b|0}function CTb(a,b){a=+a;b=b|0;return +(+DTb(a,b))}function DTb(a,b){a=+a;b=b|0;var c=0,d=0,e=0,g=0.0,h=0.0,i=0,j=0.0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;e=Sac(c|0,d|0,52)|0;switch(e&2047){case 0:{if(a!=0.0){g=+DTb(a*18446744073709551616.0,b);h=g;i=(f[b>>2]|0)+-64|0}else{h=a;i=0}f[b>>2]=i;j=h;break}case 2047:{j=a;break}default:{f[b>>2]=(e&2047)+-1022;f[s>>2]=c;f[s+4>>2]=d&-2146435073|1071644672;j=+p[s>>3]}}return +j}function ETb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;do if(a){if(c>>>0<128){b[a>>0]=c;e=1;break}d=(FTb()|0)+188|0;if(!(f[f[d>>2]>>2]|0))if((c&-128|0)==57216){b[a>>0]=c;e=1;break}else{d=ZSb()|0;f[d>>2]=84;e=-1;break}if(c>>>0<2048){b[a>>0]=c>>>6|192;b[a+1>>0]=c&63|128;e=2;break}if(c>>>0<55296|(c&-8192|0)==57344){b[a>>0]=c>>>12|224;b[a+1>>0]=c>>>6&63|128;b[a+2>>0]=c&63|128;e=3;break}if((c+-65536|0)>>>0<1048576){b[a>>0]=c>>>18|240;b[a+1>>0]=c>>>12&63|128;b[a+2>>0]=c>>>6&63|128;b[a+3>>0]=c&63|128;e=4;break}else{d=ZSb()|0;f[d>>2]=84;e=-1;break}}else e=1;while(0);return e|0}function FTb(){return $Sb()|0}function GTb(){return $Sb()|0}function HTb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0;d=0;while(1){if((h[483265+d>>0]|0)==(a|0)){e=2;break}g=d+1|0;if((g|0)==87){i=483353;j=87;e=5;break}else d=g}if((e|0)==2)if(!d)k=483353;else{i=483353;j=d;e=5}if((e|0)==5)while(1){e=0;d=i;do{a=d;d=d+1|0}while((b[a>>0]|0)!=0);j=j+-1|0;if(!j){k=d;break}else{i=d;e=5}}return ITb(k,f[c+20>>2]|0)|0}function ITb(a,b){a=a|0;b=b|0;return JTb(a,b)|0}function JTb(a,b){a=a|0;b=b|0;var c=0;if(!b)c=0;else c=KTb(f[b>>2]|0,f[b+4>>2]|0,a)|0;return (c|0?c:a)|0}function KTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=(f[a>>2]|0)+1794895138|0;g=LTb(f[a+8>>2]|0,e)|0;h=LTb(f[a+12>>2]|0,e)|0;i=LTb(f[a+16>>2]|0,e)|0;a:do if((g>>>0<c>>>2>>>0?(j=c-(g<<2)|0,h>>>0<j>>>0&i>>>0<j>>>0):0)?((i|h)&3|0)==0:0){j=h>>>2;k=i>>>2;l=0;m=g;while(1){n=m>>>1;o=l+n|0;p=o<<1;q=p+j|0;r=LTb(f[a+(q<<2)>>2]|0,e)|0;s=LTb(f[a+(q+1<<2)>>2]|0,e)|0;if(!(s>>>0<c>>>0&r>>>0<(c-s|0)>>>0)){t=0;break a}if(b[a+(s+r)>>0]|0){t=0;break a}r=gTb(d,a+s|0)|0;if(!r)break;s=(r|0)<0;if((m|0)==1){t=0;break a}else{l=s?l:o;m=s?n:m-n|0}}m=p+k|0;l=LTb(f[a+(m<<2)>>2]|0,e)|0;j=LTb(f[a+(m+1<<2)>>2]|0,e)|0;if(j>>>0<c>>>0&l>>>0<(c-j|0)>>>0)t=(b[a+(j+l)>>0]|0)==0?a+j|0:0;else t=0}else t=0;while(0);return t|0}function LTb(a,b){a=a|0;b=b|0;var c=0;c=Zac(a|0)|0;return ((b|0)==0?a:c)|0}function MTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=d+16|0;g=f[e>>2]|0;if(!g)if(!(NTb(d)|0)){h=f[e>>2]|0;i=5}else j=0;else{h=g;i=5}a:do if((i|0)==5){g=d+20|0;e=f[g>>2]|0;k=e;if((h-e|0)>>>0<c>>>0){j=li[f[d+36>>2]&511](d,a,c)|0;break}b:do if((b[d+75>>0]|0)>-1){e=c;while(1){if(!e){l=0;m=a;n=c;o=k;break b}p=e+-1|0;if((b[a+p>>0]|0)==10)break;else e=p}p=li[f[d+36>>2]&511](d,a,e)|0;if(p>>>0<e>>>0){j=p;break a}l=e;m=a+e|0;n=c-e|0;o=f[g>>2]|0}else{l=0;m=a;n=c;o=k}while(0);Vac(o|0,m|0,n|0)|0;f[g>>2]=(f[g>>2]|0)+n;j=l+n|0}while(0);return j|0}function NTb(a){a=a|0;var c=0,d=0,e=0;c=a+74|0;d=b[c>>0]|0;b[c>>0]=d+255|d;d=f[a>>2]|0;if(!(d&8)){f[a+8>>2]=0;f[a+4>>2]=0;c=f[a+44>>2]|0;f[a+28>>2]=c;f[a+20>>2]=c;f[a+16>>2]=c+(f[a+48>>2]|0);e=0}else{f[a>>2]=d|32;e=-1}return e|0}function OTb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=PTb(a,b,e)|0;u=d;return c|0}function PTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0.0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0;e=u;u=u+288|0;g=e+8|0;i=e+17|0;j=e;k=e+16|0;if((f[a+76>>2]|0)>-1)l=jTb(a)|0;else l=0;m=b[c>>0]|0;a:do if(m<<24>>24){o=a+4|0;q=a+100|0;r=a+108|0;s=a+8|0;t=i+10|0;v=i+33|0;w=g+4|0;x=i+46|0;y=i+94|0;z=i+1|0;A=i+1|0;B=c;C=0;D=0;E=0;F=0;G=m;b:while(1){c:do if(!(QTb(G&255)|0)){H=G<<24>>24==37;d:do if(H){I=B+1|0;K=b[I>>0]|0;e:do switch(K<<24>>24){case 37:{break d;break}case 42:{L=0;M=B+2|0;break}default:{N=(K&255)+-48|0;if(N>>>0<10?(b[B+2>>0]|0)==36:0){L=TTb(d,N)|0;M=B+3|0;break e}N=(f[d>>2]|0)+(4-1)&~(4-1);O=f[N>>2]|0;f[d>>2]=N+4;L=O;M=I}}while(0);I=b[M>>0]|0;K=I&255;if((K+-48|0)>>>0<10){O=0;N=M;P=K;while(1){K=(O*10|0)+-48+P|0;Q=N+1|0;R=b[Q>>0]|0;P=R&255;if((P+-48|0)>>>0>=10){S=K;T=Q;U=R;break}else{O=K;N=Q}}}else{S=0;T=M;U=I}N=U<<24>>24==109;O=(L|0)!=0;P=N?0:E;Q=N?0:F;K=N?T+1|0:T;V=O&N;N=K+1|0;switch(b[K>>0]|0){case 104:{R=(b[N>>0]|0)==104;W=R?-2:-1;X=R?K+2|0:N;break}case 108:{R=(b[N>>0]|0)==108;W=R?3:1;X=R?K+2|0:N;break}case 106:{W=3;X=N;break}case 116:case 122:{W=1;X=N;break}case 76:{W=2;X=N;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{W=0;X=K;break}default:{Y=P;Z=Q;_=V;$=137;break b}}K=h[X>>0]|0;N=(K&47|0)==3;R=N?K|32:K;K=N?1:W;N=R&255;switch(N<<24>>24){case 99:{aa=(S|0)>1?S:1;ba=C;break}case 91:{aa=S;ba=C;break}case 110:{UTb(L,K,C,((C|0)<0)<<31>>31);ca=X;da=D;ea=C;fa=P;ga=Q;break c;break}default:{RTb(a,0);do{ha=f[o>>2]|0;if(ha>>>0<(f[q>>2]|0)>>>0){f[o>>2]=ha+1;ia=h[ha>>0]|0}else ia=STb(a)|0}while((QTb(ia)|0)!=0);if(!(f[q>>2]|0))ja=f[o>>2]|0;else{I=(f[o>>2]|0)+-1|0;f[o>>2]=I;ja=I}aa=S;ba=(f[r>>2]|0)+C+ja-(f[s>>2]|0)|0}}RTb(a,aa);I=f[o>>2]|0;ha=f[q>>2]|0;if(I>>>0<ha>>>0){f[o>>2]=I+1;ka=ha}else{if((STb(a)|0)<0){Y=P;Z=Q;_=V;$=137;break b}ka=f[q>>2]|0}if(ka|0)f[o>>2]=(f[o>>2]|0)+-1;f:do switch(N<<24>>24){case 91:case 99:case 115:{ha=(R|0)==99;g:do if((R|16|0)==115){Nac(z|0,-1,256)|0;b[i>>0]=0;if((R|0)==115){b[v>>0]=0;b[t>>0]=0;b[t+1>>0]=0;b[t+2>>0]=0;b[t+3>>0]=0;b[t+4>>0]=0;la=X}else la=X}else{I=X+1|0;ma=(b[I>>0]|0)==94;na=ma&1;oa=ma?X+2|0:I;Nac(A|0,ma&1|0,256)|0;b[i>>0]=0;switch(b[oa>>0]|0){case 45:{pa=x;$=64;break}case 93:{pa=y;$=64;break}default:{qa=oa;ra=(na^1)&255}}if(($|0)==64){$=0;ma=(na^1)&255;b[pa>>0]=ma;qa=oa+1|0;ra=ma}ma=qa;while(1){oa=b[ma>>0]|0;h:do switch(oa<<24>>24){case 0:{Y=P;Z=Q;_=V;$=137;break b;break}case 93:{la=ma;break g;break}case 45:{na=ma+1|0;I=b[na>>0]|0;switch(I<<24>>24){case 93:case 0:{sa=ma;ta=45;break h;break}default:{}}ua=b[ma+-1>>0]|0;if((ua&255)<(I&255)){va=ua&255;do{va=va+1|0;b[i+va>>0]=ra;ua=b[na>>0]|0}while((va|0)<(ua&255|0));sa=na;ta=ua}else{sa=na;ta=I}break}default:{sa=ma;ta=oa}}while(0);b[i+((ta&255)+1)>>0]=ra;ma=sa+1|0}}while(0);ma=ha?aa+1|0:31;oa=(K|0)==1;i:do if(oa){if(V){va=OSb(ma<<2)|0;if(!va){Y=0;Z=0;_=1;$=137;break b}else wa=va}else wa=L;f[g>>2]=0;f[w>>2]=0;va=ma;ua=0;xa=wa;j:while(1){ya=(xa|0)==0;za=ua;while(1){k:while(1){Aa=f[o>>2]|0;if(Aa>>>0<(f[q>>2]|0)>>>0){f[o>>2]=Aa+1;Ba=h[Aa>>0]|0}else Ba=STb(a)|0;if(!(b[i+(Ba+1)>>0]|0))break j;b[k>>0]=Ba;switch(VTb(j,k,1,g)|0){case -1:{Y=0;Z=xa;_=V;$=137;break b;break}case -2:break;default:break k}}if(ya)Ca=za;else{f[xa+(za<<2)>>2]=f[j>>2];Ca=za+1|0}if(V&(Ca|0)==(va|0))break;else za=Ca}ya=va<<1|1;I=QSb(xa,ya<<2)|0;if(!I){Y=0;Z=xa;_=1;$=137;break b}else{na=va;va=ya;xa=I;ua=na}}if(!(WTb(g)|0)){Y=0;Z=xa;_=V;$=137;break b}else{Da=za;Ea=0;Fa=xa;Ga=xa}}else{if(V){ua=OSb(ma)|0;if(!ua){Y=0;Z=0;_=1;$=137;break b}else{Ha=ma;Ia=0;Ja=ua}while(1){ua=Ia;do{va=f[o>>2]|0;if(va>>>0<(f[q>>2]|0)>>>0){f[o>>2]=va+1;Ka=h[va>>0]|0}else Ka=STb(a)|0;if(!(b[i+(Ka+1)>>0]|0)){Da=ua;Ea=Ja;Fa=0;Ga=0;break i}b[Ja+ua>>0]=Ka;ua=ua+1|0}while((ua|0)!=(Ha|0));ua=Ha<<1|1;va=QSb(Ja,ua)|0;if(!va){Y=Ja;Z=0;_=1;$=137;break b}else{na=Ha;Ha=ua;Ja=va;Ia=na}}}if(!L){xa=ka;while(1){na=f[o>>2]|0;if(na>>>0<xa>>>0){f[o>>2]=na+1;La=h[na>>0]|0}else La=STb(a)|0;if(!(b[i+(La+1)>>0]|0)){Da=0;Ea=0;Fa=0;Ga=0;break i}xa=f[q>>2]|0}}else{xa=0;na=ka;while(1){va=f[o>>2]|0;if(va>>>0<na>>>0){f[o>>2]=va+1;Ma=h[va>>0]|0}else Ma=STb(a)|0;if(!(b[i+(Ma+1)>>0]|0)){Da=xa;Ea=L;Fa=0;Ga=0;break i}b[L+xa>>0]=Ma;xa=xa+1|0;na=f[q>>2]|0}}}while(0);if(!(f[q>>2]|0))Na=f[o>>2]|0;else{ma=(f[o>>2]|0)+-1|0;f[o>>2]=ma;Na=ma}ma=Na-(f[s>>2]|0)+(f[r>>2]|0)|0;if(!ma){Oa=Ea;Pa=Ga;$=139;break b}if(!((ma|0)==(aa|0)|ha^1)){Oa=Ea;Pa=Ga;$=139;break b}do if(V)if(oa){f[L>>2]=Fa;break}else{f[L>>2]=Ea;break}while(0);if(ha){Qa=la;Ra=Ea;Sa=Ga}else{if(Fa|0)f[Fa+(Da<<2)>>2]=0;if(!Ea){Qa=la;Ra=0;Sa=Ga;break f}b[Ea+Da>>0]=0;Qa=la;Ra=Ea;Sa=Ga}break}case 120:case 88:case 112:{Ta=16;$=125;break}case 111:{Ta=8;$=125;break}case 117:case 100:{Ta=10;$=125;break}case 105:{Ta=0;$=125;break}case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{Ua=+YTb(a,K,0);if((f[r>>2]|0)==((f[s>>2]|0)-(f[o>>2]|0)|0)){Oa=P;Pa=Q;$=139;break b}if(!L){Qa=X;Ra=P;Sa=Q}else switch(K|0){case 0:{n[L>>2]=Ua;Qa=X;Ra=P;Sa=Q;break f;break}case 1:{p[L>>3]=Ua;Qa=X;Ra=P;Sa=Q;break f;break}case 2:{p[L>>3]=Ua;Qa=X;Ra=P;Sa=Q;break f;break}default:{Qa=X;Ra=P;Sa=Q;break f}}break}default:{Qa=X;Ra=P;Sa=Q}}while(0);do if(($|0)==125){$=0;N=XTb(a,Ta,0,-1,-1)|0;if((f[r>>2]|0)==((f[s>>2]|0)-(f[o>>2]|0)|0)){Oa=P;Pa=Q;$=139;break b}if(O&(R|0)==112){f[L>>2]=N;Qa=X;Ra=P;Sa=Q;break}else{UTb(L,K,N,J);Qa=X;Ra=P;Sa=Q;break}}while(0);ca=Qa;da=(O&1)+D|0;ea=(f[r>>2]|0)+ba+(f[o>>2]|0)-(f[s>>2]|0)|0;fa=Ra;ga=Sa;break c}while(0);Q=B+(H&1)|0;RTb(a,0);P=f[o>>2]|0;if(P>>>0<(f[q>>2]|0)>>>0){f[o>>2]=P+1;Va=h[P>>0]|0}else Va=STb(a)|0;if((Va|0)!=(h[Q>>0]|0)){$=22;break b}ca=Q;da=D;ea=C+1|0;fa=E;ga=F}else{Q=B;while(1){P=Q+1|0;if(!(QTb(h[P>>0]|0)|0))break;else Q=P}RTb(a,0);do{H=f[o>>2]|0;if(H>>>0<(f[q>>2]|0)>>>0){f[o>>2]=H+1;Wa=h[H>>0]|0}else Wa=STb(a)|0}while((QTb(Wa)|0)!=0);if(!(f[q>>2]|0))Xa=f[o>>2]|0;else{H=(f[o>>2]|0)+-1|0;f[o>>2]=H;Xa=H}ca=Q;da=D;ea=(f[r>>2]|0)+C+Xa-(f[s>>2]|0)|0;fa=E;ga=F}while(0);B=ca+1|0;G=b[B>>0]|0;if(!(G<<24>>24)){Ya=da;break a}else{C=ea;D=da;E=fa;F=ga}}if(($|0)==22){if(f[q>>2]|0)f[o>>2]=(f[o>>2]|0)+-1;if((D|0)!=0|(Va|0)>-1){Ya=D;break}else{Za=0;_a=E;$a=F;$=138}}else if(($|0)==137){C=_&1;if(!D){Za=C;_a=Y;$a=Z;$=138}else{ab=C;bb=D;cb=Y;db=Z}}else if(($|0)==139){ab=V&1;bb=D;cb=Oa;db=Pa}if(($|0)==138){ab=Za;bb=-1;cb=_a;db=$a}if(!ab)Ya=bb;else{PSb(cb);PSb(db);Ya=bb}}else Ya=0;while(0);if(l|0)kTb(a);u=e;return Ya|0}function QTb(a){a=a|0;return ((a|0)==32|(a+-9|0)>>>0<5)&1|0}function RTb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;f[a+104>>2]=b;c=f[a+8>>2]|0;d=f[a+4>>2]|0;e=c-d|0;f[a+108>>2]=e;f[a+100>>2]=(b|0)!=0&(e|0)>(b|0)?d+b|0:c;return}function STb(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+104|0;d=f[c>>2]|0;if((d|0)!=0?(f[a+108>>2]|0)>=(d|0):0)e=4;else{d=mTb(a)|0;if((d|0)>=0){g=f[c>>2]|0;c=a+8|0;if(g){i=f[c>>2]|0;j=f[a+4>>2]|0;k=a+108|0;l=g-(f[k>>2]|0)|0;g=i;if((i-j|0)<(l|0)){m=k;n=g;o=g;p=j}else{m=k;n=j+(l+-1)|0;o=g;p=j}}else{j=f[c>>2]|0;m=a+108|0;n=j;o=j;p=f[a+4>>2]|0}f[a+100>>2]=n;if(o|0)f[m>>2]=o+1-p+(f[m>>2]|0);m=p+-1|0;if((h[m>>0]|0|0)==(d|0))q=d;else{b[m>>0]=d;q=d}}else e=4}if((e|0)==4){f[a+100>>2]=0;q=-1}return q|0}function TTb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[d>>2]=f[a>>2];a=b;while(1){b=(f[d>>2]|0)+(4-1)&~(4-1);e=f[b>>2]|0;f[d>>2]=b+4;if(a>>>0>1)a=a+-1|0;else break}u=c;return e|0}function UTb(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0;a:do if(a|0)switch(c|0){case -2:{b[a>>0]=e;break a;break}case -1:{d[a>>1]=e;break a;break}case 0:{f[a>>2]=e;break a;break}case 1:{f[a>>2]=e;break a;break}case 3:{h=a;f[h>>2]=e;f[h+4>>2]=g;break a;break}default:break a}while(0);return}function VTb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+16|0;h=g;i=(e|0)==0?854420:e;e=f[i>>2]|0;a:do if(!c)if(!e)j=0;else k=17;else{l=(a|0)==0?h:a;if(!d)j=-2;else{if(!e){m=b[c>>0]|0;if(m<<24>>24>-1){f[l>>2]=m&255;j=m<<24>>24!=0&1;break}m=(hUb()|0)+188|0;n=b[c>>0]|0;if(!(f[f[m>>2]>>2]|0)){f[l>>2]=n<<24>>24&57343;j=1;break}m=(n&255)+-194|0;if(m>>>0>50){k=17;break}n=f[142100+(m<<2)>>2]|0;m=d+-1|0;if(!m)o=n;else{p=c+1|0;q=n;r=m;k=11}}else{p=c;q=e;r=d;k=11}b:do if((k|0)==11){m=b[p>>0]|0;n=(m&255)>>>3;if((n+-16|n+(q>>26))>>>0>7){k=17;break a}else{s=p;t=q;v=r;w=m}while(1){s=s+1|0;t=(w&255)+-128|t<<6;v=v+-1|0;if((t|0)>=0)break;if(!v){o=t;break b}w=b[s>>0]|0;if((w&-64)<<24>>24!=-128){k=17;break a}}f[i>>2]=0;f[l>>2]=t;j=d-v|0;break a}while(0);f[i>>2]=o;j=-2}}while(0);if((k|0)==17){f[i>>2]=0;i=ZSb()|0;f[i>>2]=84;j=-1}u=g;return j|0}function WTb(a){a=a|0;var b=0;if(!a)b=1;else b=(f[a>>2]|0)==0;return b&1|0}function XTb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;a:do if(c>>>0>36){i=ZSb()|0;f[i>>2]=22;j=0;k=0}else{i=a+4|0;l=a+100|0;do{m=f[i>>2]|0;if(m>>>0<(f[l>>2]|0)>>>0){f[i>>2]=m+1;n=h[m>>0]|0}else n=STb(a)|0}while((QTb(n)|0)!=0);b:do switch(n|0){case 43:case 45:{m=((n|0)==45)<<31>>31;o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[i>>2]=o+1;p=m;q=h[o>>0]|0;break b}else{p=m;q=STb(a)|0;break b}break}default:{p=0;q=n}}while(0);m=(c|0)==0;do if((c|16|0)==16&(q|0)==48){o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[i>>2]=o+1;r=h[o>>0]|0}else r=STb(a)|0;if((r|32|0)!=120)if(m){s=r;t=8;u=46;break}else{v=r;w=c;u=32;break}o=f[i>>2]|0;if(o>>>0<(f[l>>2]|0)>>>0){f[i>>2]=o+1;x=h[o>>0]|0}else x=STb(a)|0;if((h[485171+x>>0]|0)>15){o=(f[l>>2]|0)!=0;if(o)f[i>>2]=(f[i>>2]|0)+-1;if(!d){RTb(a,0);j=0;k=0;break a}if(!o){j=0;k=0;break a}f[i>>2]=(f[i>>2]|0)+-1;j=0;k=0;break a}else{s=x;t=16;u=46}}else{o=m?10:c;if((h[485171+q>>0]|0)>>>0<o>>>0){v=q;w=o;u=32}else{if(f[l>>2]|0)f[i>>2]=(f[i>>2]|0)+-1;RTb(a,0);o=ZSb()|0;f[o>>2]=22;j=0;k=0;break a}}while(0);c:do if((u|0)==32)if((w|0)==10){m=v+-48|0;if(m>>>0<10){o=0;y=m;do{o=(o*10|0)+y|0;m=f[i>>2]|0;if(m>>>0<(f[l>>2]|0)>>>0){f[i>>2]=m+1;z=h[m>>0]|0}else z=STb(a)|0;y=z+-48|0}while(y>>>0<10&o>>>0<429496729);A=z;B=o;C=0}else{A=v;B=0;C=0}y=A+-48|0;if(y>>>0<10){m=A;D=B;E=C;F=y;while(1){y=cbc(D|0,E|0,10,0)|0;G=J;H=((F|0)<0)<<31>>31;I=~H;if(G>>>0>I>>>0|(G|0)==(I|0)&y>>>0>~F>>>0){K=10;L=m;M=D;N=E;u=72;break c}D=Kac(y|0,G|0,F|0,H|0)|0;E=J;H=f[i>>2]|0;if(H>>>0<(f[l>>2]|0)>>>0){f[i>>2]=H+1;O=h[H>>0]|0}else O=STb(a)|0;F=O+-48|0;if(!(F>>>0<10&(E>>>0<429496729|(E|0)==429496729&D>>>0<2576980378)))break;else m=O}if(F>>>0>9){P=p;Q=E;R=D}else{K=10;L=O;M=D;N=E;u=72}}else{P=p;Q=C;R=B}}else{s=v;t=w;u=46}while(0);d:do if((u|0)==46){if(!(t+-1&t)){m=b[485427+((t*23|0)>>>5&7)>>0]|0;o=b[485171+s>>0]|0;H=o&255;if(H>>>0<t>>>0){G=0;y=H;do{G=y|G<<m;H=f[i>>2]|0;if(H>>>0<(f[l>>2]|0)>>>0){f[i>>2]=H+1;S=h[H>>0]|0}else S=STb(a)|0;T=b[485171+S>>0]|0;y=T&255}while(G>>>0<134217728&y>>>0<t>>>0);U=S;V=T;W=0;X=G}else{U=s;V=o;W=0;X=0}y=Sac(-1,-1,m|0)|0;E=J;if((V&255)>>>0>=t>>>0|(W>>>0>E>>>0|(W|0)==(E|0)&X>>>0>y>>>0)){K=t;L=U;M=X;N=W;u=72;break}else{Z=X;_=W;$=V}while(1){D=$ac(Z|0,_|0,m|0)|0;F=J;H=$&255|D;D=f[i>>2]|0;if(D>>>0<(f[l>>2]|0)>>>0){f[i>>2]=D+1;aa=h[D>>0]|0}else aa=STb(a)|0;$=b[485171+aa>>0]|0;if(($&255)>>>0>=t>>>0|(F>>>0>E>>>0|(F|0)==(E|0)&H>>>0>y>>>0)){K=t;L=aa;M=H;N=F;u=72;break d}else{Z=H;_=F}}}y=b[485171+s>>0]|0;E=y&255;if(E>>>0<t>>>0){m=0;o=E;do{m=o+(Y(m,t)|0)|0;E=f[i>>2]|0;if(E>>>0<(f[l>>2]|0)>>>0){f[i>>2]=E+1;ba=h[E>>0]|0}else ba=STb(a)|0;ca=b[485171+ba>>0]|0;o=ca&255}while(m>>>0<119304647&o>>>0<t>>>0);da=ba;ea=ca;fa=m;ga=0}else{da=s;ea=y;fa=0;ga=0}if((ea&255)>>>0<t>>>0){o=Uac(-1,-1,t|0,0)|0;E=J;G=da;F=ga;H=fa;D=ea;while(1){if(F>>>0>E>>>0|(F|0)==(E|0)&H>>>0>o>>>0){K=t;L=G;M=H;N=F;u=72;break d}I=cbc(H|0,F|0,t|0,0)|0;ha=J;ia=D&255;if(ha>>>0>4294967295|(ha|0)==-1&I>>>0>~ia>>>0){K=t;L=G;M=H;N=F;u=72;break d}ja=Kac(ia|0,0,I|0,ha|0)|0;ha=J;I=f[i>>2]|0;if(I>>>0<(f[l>>2]|0)>>>0){f[i>>2]=I+1;ka=h[I>>0]|0}else ka=STb(a)|0;D=b[485171+ka>>0]|0;if((D&255)>>>0>=t>>>0){K=t;L=ka;M=ja;N=ha;u=72;break}else{G=ka;F=ha;H=ja}}}else{K=t;L=da;M=fa;N=ga;u=72}}while(0);if((u|0)==72)if((h[485171+L>>0]|0)>>>0<K>>>0){do{H=f[i>>2]|0;if(H>>>0<(f[l>>2]|0)>>>0){f[i>>2]=H+1;la=h[H>>0]|0}else la=STb(a)|0}while((h[485171+la>>0]|0)>>>0<K>>>0);H=ZSb()|0;f[H>>2]=34;P=(e&1|0)==0&0==0?p:0;Q=g;R=e}else{P=p;Q=N;R=M}if(f[l>>2]|0)f[i>>2]=(f[i>>2]|0)+-1;if(!(Q>>>0<g>>>0|(Q|0)==(g|0)&R>>>0<e>>>0)){if(!((e&1|0)!=0|0!=0|(P|0)!=0)){H=ZSb()|0;f[H>>2]=34;H=Kac(e|0,g|0,-1,-1)|0;j=J;k=H;break}if(Q>>>0>g>>>0|(Q|0)==(g|0)&R>>>0>e>>>0){H=ZSb()|0;f[H>>2]=34;j=g;k=e;break}}H=((P|0)<0)<<31>>31;F=Jac(R^P|0,Q^H|0,P|0,H|0)|0;j=J;k=F}while(0);J=j;return k|0}function YTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0,F=0;switch(c|0){case 0:{e=-149;g=24;i=4;break}case 1:{e=-1074;g=53;i=4;break}case 2:{e=-1074;g=53;i=4;break}default:j=0.0}a:do if((i|0)==4){c=a+4|0;k=a+100|0;do{l=f[c>>2]|0;if(l>>>0<(f[k>>2]|0)>>>0){f[c>>2]=l+1;m=h[l>>0]|0}else m=STb(a)|0}while((QTb(m)|0)!=0);b:do switch(m|0){case 43:case 45:{l=1-(((m|0)==45&1)<<1)|0;n=f[c>>2]|0;if(n>>>0<(f[k>>2]|0)>>>0){f[c>>2]=n+1;o=h[n>>0]|0;p=l;break b}else{o=STb(a)|0;p=l;break b}break}default:{o=m;p=1}}while(0);l=0;n=o;while(1){if((n|32|0)!=(b[485157+l>>0]|0)){q=l;r=n;break}do if(l>>>0<7){s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;t=h[s>>0]|0;break}else{t=STb(a)|0;break}}else t=n;while(0);s=l+1|0;if(s>>>0<8){l=s;n=t}else{q=s;r=t;break}}c:do switch(q|0){case 8:break;case 3:{i=23;break}default:{n=(d|0)!=0;if(n&q>>>0>3)if((q|0)==8)break c;else{i=23;break c}d:do if(!q){l=0;s=r;while(1){if((s|32|0)!=(b[485166+l>>0]|0)){u=l;v=s;break d}do if(l>>>0<2){w=f[c>>2]|0;if(w>>>0<(f[k>>2]|0)>>>0){f[c>>2]=w+1;x=h[w>>0]|0;break}else{x=STb(a)|0;break}}else x=s;while(0);w=l+1|0;if(w>>>0<3){l=w;s=x}else{u=w;v=x;break}}}else{u=q;v=r}while(0);switch(u|0){case 3:{s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;y=h[s>>0]|0}else y=STb(a)|0;if((y|0)==40)z=1;else{if(!(f[k>>2]|0)){j=C;break a}f[c>>2]=(f[c>>2]|0)+-1;j=C;break a}while(1){s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;A=h[s>>0]|0}else A=STb(a)|0;if(!((A+-48|0)>>>0<10|(A+-65|0)>>>0<26)?!((A|0)==95|(A+-97|0)>>>0<26):0)break;z=z+1|0}if((A|0)==41){j=C;break a}s=(f[k>>2]|0)==0;if(!s)f[c>>2]=(f[c>>2]|0)+-1;if(!n){l=ZSb()|0;f[l>>2]=22;RTb(a,0);j=0.0;break a}if(!z){j=C;break a}else B=z;while(1){B=B+-1|0;if(!s)f[c>>2]=(f[c>>2]|0)+-1;if(!B){j=C;break a}}break}case 0:{if((v|0)==48){s=f[c>>2]|0;if(s>>>0<(f[k>>2]|0)>>>0){f[c>>2]=s+1;E=h[s>>0]|0}else E=STb(a)|0;if((E|32|0)==120){j=+ZTb(a,g,e,p,d);break a}if(!(f[k>>2]|0))F=48;else{f[c>>2]=(f[c>>2]|0)+-1;F=48}}else F=v;j=+_Tb(a,F,g,e,p,d);break a;break}default:{if(f[k>>2]|0)f[c>>2]=(f[c>>2]|0)+-1;s=ZSb()|0;f[s>>2]=22;RTb(a,0);j=0.0;break a}}}}while(0);if((i|0)==23){s=(f[k>>2]|0)==0;if(!s)f[c>>2]=(f[c>>2]|0)+-1;if((d|0)!=0&q>>>0>3){n=q;do{if(!s)f[c>>2]=(f[c>>2]|0)+-1;n=n+-1|0}while(n>>>0>3)}}j=+(p|0)*D}while(0);return +j}function ZTb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0.0,S=0,T=0.0,U=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0,ea=0.0;g=a+4|0;i=f[g>>2]|0;j=a+100|0;if(i>>>0<(f[j>>2]|0)>>>0){f[g>>2]=i+1;k=h[i>>0]|0;l=0}else{k=STb(a)|0;l=0}a:while(1){switch(k|0){case 46:{m=8;break a;break}case 48:break;default:{n=0;o=0;p=1.0;q=0.0;r=0;s=k;t=l;u=0;v=0;w=0;x=0;break a}}i=f[g>>2]|0;if(i>>>0<(f[j>>2]|0)>>>0){f[g>>2]=i+1;k=h[i>>0]|0;l=1;continue}else{k=STb(a)|0;l=1;continue}}if((m|0)==8){k=f[g>>2]|0;if(k>>>0<(f[j>>2]|0)>>>0){f[g>>2]=k+1;y=h[k>>0]|0}else y=STb(a)|0;if((y|0)==48){k=0;i=0;while(1){z=f[g>>2]|0;if(z>>>0<(f[j>>2]|0)>>>0){f[g>>2]=z+1;A=h[z>>0]|0}else A=STb(a)|0;z=Kac(k|0,i|0,-1,-1)|0;B=J;if((A|0)==48){k=z;i=B}else{n=1;o=0;p=1.0;q=0.0;r=0;s=A;t=1;u=B;v=0;w=0;x=z;break}}}else{n=1;o=0;p=1.0;q=0.0;r=0;s=y;t=l;u=0;v=0;w=0;x=0}}while(1){l=s+-48|0;y=(s|0)==46;if(l>>>0>=10?!(y|((s|32)+-97|0)>>>0<6):0){C=s;break}if(y)if(!n){D=1;E=o;F=p;G=q;H=r;I=t;K=w;L=v;M=w;N=v}else{C=46;break}else{y=(s|0)>57?(s|32)+-87|0:l;do if(!((v|0)<0|(v|0)==0&w>>>0<8))if((v|0)<0|(v|0)==0&w>>>0<14){O=p*.0625;P=o;Q=O;R=q+O*+(y|0);S=r;break}else{l=(o|0)!=0|(y|0)==0;P=l?o:1;Q=p;R=l?q:q+p*.5;S=r;break}else{P=o;Q=p;R=q;S=y+(r<<4)|0}while(0);y=Kac(w|0,v|0,1,0)|0;D=n;E=P;F=Q;G=R;H=S;I=1;K=x;L=u;M=y;N=J}y=f[g>>2]|0;if(y>>>0<(f[j>>2]|0)>>>0){f[g>>2]=y+1;n=D;o=E;p=F;q=G;r=H;s=h[y>>0]|0;t=I;u=L;v=N;w=M;x=K;continue}else{n=D;o=E;p=F;q=G;r=H;s=STb(a)|0;t=I;u=L;v=N;w=M;x=K;continue}}do if(!t){K=f[j>>2]|0;M=(K|0)!=0;if(M)f[g>>2]=(f[g>>2]|0)+-1;if(e){if(M)f[g>>2]=(f[g>>2]|0)+-1;if(!((n|0)==0|(K|0)==0))f[g>>2]=(f[g>>2]|0)+-1}else RTb(a,0);T=+(d|0)*0.0}else{K=(n|0)==0;M=K?w:x;N=K?v:u;if((v|0)<0|(v|0)==0&w>>>0<8){K=r;L=w;I=v;while(1){s=K<<4;L=Kac(L|0,I|0,1,0)|0;I=J;if(!((I|0)<0|(I|0)==0&L>>>0<8)){U=s;break}else K=s}}else U=r;if((C|32|0)==112){K=$Tb(a,e)|0;L=J;if((K|0)==0&(L|0)==-2147483648){if(!e){RTb(a,0);T=0.0;break}if(!(f[j>>2]|0)){V=0;W=0}else{f[g>>2]=(f[g>>2]|0)+-1;V=0;W=0}}else{V=K;W=L}}else if(!(f[j>>2]|0)){V=0;W=0}else{f[g>>2]=(f[g>>2]|0)+-1;V=0;W=0}L=$ac(M|0,N|0,2)|0;K=Kac(L|0,J|0,-32,-1)|0;L=Kac(K|0,J|0,V|0,W|0)|0;K=J;if(!U){T=+(d|0)*0.0;break}I=0-c|0;s=((I|0)<0)<<31>>31;if((K|0)>(s|0)|(K|0)==(s|0)&L>>>0>I>>>0){I=ZSb()|0;f[I>>2]=34;T=+(d|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}I=c+-106|0;s=((I|0)<0)<<31>>31;if((K|0)<(s|0)|(K|0)==(s|0)&L>>>0<I>>>0){I=ZSb()|0;f[I>>2]=34;T=+(d|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if((U|0)>-1){G=q;I=U;s=L;H=K;while(1){E=!(G>=.5);o=I<<1|(E^1)&1;F=G+(E?G:G+-1.0);E=Kac(s|0,H|0,-1,-1)|0;D=J;if((o|0)>-1){G=F;I=o;s=E;H=D}else{X=F;Y=o;Z=E;_=D;break}}}else{X=q;Y=U;Z=L;_=K}H=((b|0)<0)<<31>>31;s=Jac(32,0,c|0,((c|0)<0)<<31>>31|0)|0;I=Kac(s|0,J|0,Z|0,_|0)|0;s=J;if((H|0)>(s|0)|(H|0)==(s|0)&b>>>0>I>>>0)if((I|0)>0){$=I;m=59}else{aa=0;ba=84;m=61}else{$=b;m=59}if((m|0)==59)if(($|0)<53){aa=$;ba=84-$|0;m=61}else{ca=0.0;da=$;ea=+(d|0)}if((m|0)==61){G=+(d|0);ca=+bUb(+aUb(1.0,ba),G);da=aa;ea=G}I=(Y&1|0)==0&(X!=0.0&(da|0)<32);G=ea*(I?0.0:X)+(ca+ea*+(((I&1)+Y|0)>>>0))-ca;if(!(G!=0.0)){I=ZSb()|0;f[I>>2]=34}T=+dUb(G,Z)}while(0);return +T}function _Tb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0.0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0;i=u;u=u+512|0;j=i;k=d+c|0;l=0-k|0;m=a+4|0;n=a+100|0;o=b;b=0;a:while(1){switch(o|0){case 46:{p=6;break a;break}case 48:break;default:{q=0;r=o;s=b;t=0;v=0;break a}}w=f[m>>2]|0;if(w>>>0<(f[n>>2]|0)>>>0){f[m>>2]=w+1;o=h[w>>0]|0;b=1;continue}else{o=STb(a)|0;b=1;continue}}if((p|0)==6){o=f[m>>2]|0;if(o>>>0<(f[n>>2]|0)>>>0){f[m>>2]=o+1;x=h[o>>0]|0}else x=STb(a)|0;if((x|0)==48){o=0;w=0;while(1){y=Kac(o|0,w|0,-1,-1)|0;z=J;A=f[m>>2]|0;if(A>>>0<(f[n>>2]|0)>>>0){f[m>>2]=A+1;B=h[A>>0]|0}else B=STb(a)|0;if((B|0)==48){o=y;w=z}else{q=1;r=B;s=1;t=y;v=z;break}}}else{q=1;r=x;s=b;t=0;v=0}}f[j>>2]=0;b=r+-48|0;x=(r|0)==46;b:do if(x|b>>>0<10){B=j+496|0;w=0;o=0;z=0;y=q;A=s;C=r;D=x;E=b;F=t;G=v;H=0;I=0;c:while(1){do if(D)if(!y){K=w;M=o;N=1;O=z;P=A;Q=H;R=I;S=H;T=I}else break c;else{U=Kac(H|0,I|0,1,0)|0;V=J;W=(C|0)!=48;if((o|0)>=125){if(!W){K=w;M=o;N=y;O=z;P=A;Q=F;R=G;S=U;T=V;break}f[B>>2]=f[B>>2]|1;K=w;M=o;N=y;O=z;P=A;Q=F;R=G;S=U;T=V;break}X=j+(o<<2)|0;if(!w)Z=E;else Z=C+-48+((f[X>>2]|0)*10|0)|0;f[X>>2]=Z;X=w+1|0;_=(X|0)==9;K=_?0:X;M=(_&1)+o|0;N=y;O=W?U:z;P=1;Q=F;R=G;S=U;T=V}while(0);V=f[m>>2]|0;if(V>>>0<(f[n>>2]|0)>>>0){f[m>>2]=V+1;$=h[V>>0]|0}else $=STb(a)|0;E=$+-48|0;D=($|0)==46;if(!(D|E>>>0<10)){aa=K;ba=M;ca=O;da=N;ea=$;fa=P;ga=Q;ha=S;ia=R;ja=T;p=29;break b}else{w=K;o=M;z=O;y=N;A=P;C=$;F=Q;G=R;H=S;I=T}}ka=w;la=o;ma=z;na=H;oa=I;pa=F;qa=G;ra=(A|0)!=0;p=37}else{aa=0;ba=0;ca=0;da=q;ea=r;fa=s;ga=t;ha=0;ia=v;ja=0;p=29}while(0);do if((p|0)==29){v=(da|0)==0;t=v?ha:ga;s=v?ja:ia;v=(fa|0)!=0;if(!(v&(ea|32|0)==101))if((ea|0)>-1){ka=aa;la=ba;ma=ca;na=ha;oa=ja;pa=t;qa=s;ra=v;p=37;break}else{sa=aa;ta=ba;ua=ca;va=ha;wa=ja;xa=v;ya=t;za=s;p=39;break}v=$Tb(a,g)|0;r=J;if((v|0)==0&(r|0)==-2147483648){if(!g){RTb(a,0);Aa=0.0;break}if(!(f[n>>2]|0)){Ba=0;Ca=0}else{f[m>>2]=(f[m>>2]|0)+-1;Ba=0;Ca=0}}else{Ba=v;Ca=r}r=Kac(Ba|0,Ca|0,t|0,s|0)|0;Da=aa;Ea=ba;Fa=ca;Ga=r;Ha=ha;Ia=J;Ja=ja;p=41}while(0);if((p|0)==37)if(f[n>>2]|0){f[m>>2]=(f[m>>2]|0)+-1;if(ra){Da=ka;Ea=la;Fa=ma;Ga=pa;Ha=na;Ia=qa;Ja=oa;p=41}else p=40}else{sa=ka;ta=la;ua=ma;va=na;wa=oa;xa=ra;ya=pa;za=qa;p=39}if((p|0)==39)if(xa){Da=sa;Ea=ta;Fa=ua;Ga=ya;Ha=va;Ia=za;Ja=wa;p=41}else p=40;do if((p|0)==40){wa=ZSb()|0;f[wa>>2]=22;RTb(a,0);Aa=0.0}else if((p|0)==41){wa=f[j>>2]|0;if(!wa){Aa=+(e|0)*0.0;break}if(((Ja|0)<0|(Ja|0)==0&Ha>>>0<10)&((Ga|0)==(Ha|0)&(Ia|0)==(Ja|0))?(c|0)>30|(wa>>>c|0)==0:0){Aa=+(e|0)*+(wa>>>0);break}wa=(d|0)/-2|0;za=((wa|0)<0)<<31>>31;if((Ia|0)>(za|0)|(Ia|0)==(za|0)&Ga>>>0>wa>>>0){wa=ZSb()|0;f[wa>>2]=34;Aa=+(e|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}wa=d+-106|0;za=((wa|0)<0)<<31>>31;if((Ia|0)<(za|0)|(Ia|0)==(za|0)&Ga>>>0<wa>>>0){wa=ZSb()|0;f[wa>>2]=34;Aa=+(e|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if(!Da)Ka=Ea;else{if((Da|0)<9){wa=j+(Ea<<2)|0;za=Da;va=f[wa>>2]|0;do{va=va*10|0;za=za+1|0}while((za|0)!=9);f[wa>>2]=va}Ka=Ea+1|0}if((Fa|0)<9?(Fa|0)<=(Ga|0)&(Ga|0)<18:0){za=f[j>>2]|0;if((Ga|0)==9){Aa=+(e|0)*+(za>>>0);break}if((Ga|0)<9){Aa=+(e|0)*+(za>>>0)/+(f[142304+(8-Ga<<2)>>2]|0);break}A=c+27+(Y(Ga,-3)|0)|0;if((A|0)>30|(za>>>A|0)==0){Aa=+(e|0)*+(za>>>0)*+(f[142304+(Ga+-10<<2)>>2]|0);break}}za=(Ga|0)%9|0;if(!za){La=0;Ma=Ka;Na=0;Oa=Ga}else{A=(Ga|0)>-1?za:za+9|0;za=f[142304+(8-A<<2)>>2]|0;if(Ka){G=1e9/(za|0)|0;F=0;I=0;H=Ga;z=0;do{o=j+(z<<2)|0;w=f[o>>2]|0;ya=((w>>>0)/(za>>>0)|0)+F|0;f[o>>2]=ya;F=Y(G,(w>>>0)%(za>>>0)|0)|0;w=(z|0)==(I|0)&(ya|0)==0;H=w?H+-9|0:H;I=w?I+1&127:I;z=z+1|0}while((z|0)!=(Ka|0));if(!F){Pa=I;Qa=Ka;Ra=H}else{f[j+(Ka<<2)>>2]=F;Pa=I;Qa=Ka+1|0;Ra=H}}else{Pa=0;Qa=0;Ra=Ga}La=0;Ma=Qa;Na=Pa;Oa=9-A+Ra|0}d:while(1){z=(Oa|0)<18;za=(Oa|0)==18;G=j+(Na<<2)|0;va=La;wa=Ma;while(1){if(!z){if(!za){Sa=va;Ta=Na;Ua=Oa;Va=wa;break d}if((f[G>>2]|0)>>>0>=9007199){Sa=va;Ta=Na;Ua=18;Va=wa;break d}}w=0;Wa=wa;ya=wa+127|0;while(1){o=ya&127;ua=j+(o<<2)|0;ta=$ac(f[ua>>2]|0,0,29)|0;sa=Kac(ta|0,J|0,w|0,0)|0;ta=J;if(ta>>>0>0|(ta|0)==0&sa>>>0>1e9){xa=Uac(sa|0,ta|0,1e9,0)|0;qa=Yac(sa|0,ta|0,1e9,0)|0;Xa=xa;Ya=qa}else{Xa=0;Ya=sa}f[ua>>2]=Ya;ua=(o|0)==(Na|0);Wa=(Ya|0)==0&(((o|0)!=(Wa+127&127|0)|ua)^1)?o:Wa;if(ua)break;else{w=Xa;ya=o+-1|0}}va=va+-29|0;if(Xa|0)break;else wa=Wa}wa=Na+127&127;G=Wa+127&127;za=j+((Wa+126&127)<<2)|0;if((wa|0)==(Wa|0)){f[za>>2]=f[za>>2]|f[j+(G<<2)>>2];Za=G}else Za=Wa;f[j+(wa<<2)>>2]=Xa;La=va;Ma=Za;Na=wa;Oa=Oa+9|0}e:while(1){A=Va+1&127;H=j+((Va+127&127)<<2)|0;I=Sa;F=Ta;wa=Ua;while(1){G=(wa|0)==18;za=(wa|0)>27?9:1;_a=I;$a=F;while(1){z=0;while(1){ya=z+$a&127;if((ya|0)==(Va|0)){ab=2;p=88;break}w=f[j+(ya<<2)>>2]|0;ya=f[142336+(z<<2)>>2]|0;if(w>>>0<ya>>>0){ab=2;p=88;break}if(w>>>0>ya>>>0)break;ya=z+1|0;if((ya|0)<2)z=ya;else{ab=ya;p=88;break}}if((p|0)==88?(p=0,G&(ab|0)==2):0){bb=0.0;cb=0;db=Va;break e}eb=za+_a|0;if(($a|0)==(Va|0)){_a=eb;$a=Va}else break}G=(1<<za)+-1|0;z=1e9>>>za;fb=0;gb=$a;hb=wa;ya=$a;do{w=j+(ya<<2)|0;o=f[w>>2]|0;ua=(o>>>za)+fb|0;f[w>>2]=ua;fb=Y(o&G,z)|0;o=(ya|0)==(gb|0)&(ua|0)==0;hb=o?hb+-9|0:hb;gb=o?gb+1&127:gb;ya=ya+1&127}while((ya|0)!=(Va|0));if(!fb){I=eb;F=gb;wa=hb;continue}if((A|0)!=(gb|0))break;f[H>>2]=f[H>>2]|1;I=eb;F=gb;wa=hb}f[j+(Va<<2)>>2]=fb;Sa=eb;Ta=gb;Ua=hb;Va=A}while(1){wa=cb+$a&127;F=db+1&127;if((wa|0)==(db|0)){f[j+(F+-1<<2)>>2]=0;ib=F}else ib=db;bb=bb*1.0e9+ +((f[j+(wa<<2)>>2]|0)>>>0);cb=cb+1|0;if((cb|0)==2)break;else db=ib}jb=+(e|0);kb=jb*bb;wa=_a+53|0;F=wa-d|0;I=(F|0)<(c|0);H=I?((F|0)>0?F:0):c;if((H|0)<53){lb=+bUb(+aUb(1.0,105-H|0),kb);mb=+cUb(kb,+aUb(1.0,53-H|0));nb=lb;ob=mb;pb=lb+(kb-mb)}else{nb=0.0;ob=0.0;pb=kb}va=$a+2&127;if((va|0)!=(ib|0)){ya=f[j+(va<<2)>>2]|0;do if(ya>>>0>=5e8){if((ya|0)!=5e8){qb=jb*.75+ob;break}if(($a+3&127|0)==(ib|0)){qb=jb*.5+ob;break}else{qb=jb*.75+ob;break}}else{if((ya|0)==0?($a+3&127|0)==(ib|0):0){qb=ob;break}qb=jb*.25+ob}while(0);if((53-H|0)>1?!(+cUb(qb,1.0)!=0.0):0)rb=qb+1.0;else rb=qb}else rb=ob;jb=pb+rb-nb;do if((wa&2147483647|0)>(-2-k|0)){ya=!(+L(+jb)>=9007199254740992.0);va=((ya^1)&1)+_a|0;kb=ya?jb:jb*.5;if((va+50|0)<=(l|0)?!(rb!=0.0&(I&((H|0)!=(F|0)|ya))):0){sb=kb;tb=va;break}ya=ZSb()|0;f[ya>>2]=34;sb=kb;tb=va}else{sb=jb;tb=_a}while(0);Aa=+dUb(sb,tb)}while(0);u=i;return +Aa}function $Tb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=a+4|0;d=f[c>>2]|0;e=a+100|0;if(d>>>0<(f[e>>2]|0)>>>0){f[c>>2]=d+1;g=h[d>>0]|0}else g=STb(a)|0;switch(g|0){case 43:case 45:{d=(g|0)==45&1;i=f[c>>2]|0;if(i>>>0<(f[e>>2]|0)>>>0){f[c>>2]=i+1;j=h[i>>0]|0}else j=STb(a)|0;if((b|0)!=0&(j+-48|0)>>>0>9?(f[e>>2]|0)!=0:0){f[c>>2]=(f[c>>2]|0)+-1;k=d;l=j}else{k=d;l=j}break}default:{k=0;l=g}}if((l+-48|0)>>>0>9)if(!(f[e>>2]|0)){m=-2147483648;n=0}else{f[c>>2]=(f[c>>2]|0)+-1;m=-2147483648;n=0}else{g=0;j=l;while(1){g=j+-48+(g*10|0)|0;l=f[c>>2]|0;if(l>>>0<(f[e>>2]|0)>>>0){f[c>>2]=l+1;o=h[l>>0]|0}else o=STb(a)|0;if(!((o+-48|0)>>>0<10&(g|0)<214748364))break;else j=o}j=((g|0)<0)<<31>>31;if((o+-48|0)>>>0<10){l=o;d=g;b=j;while(1){i=cbc(d|0,b|0,10,0)|0;p=J;q=Kac(l|0,((l|0)<0)<<31>>31|0,-48,-1)|0;r=Kac(q|0,J|0,i|0,p|0)|0;p=J;i=f[c>>2]|0;if(i>>>0<(f[e>>2]|0)>>>0){f[c>>2]=i+1;s=h[i>>0]|0}else s=STb(a)|0;if((s+-48|0)>>>0<10&((p|0)<21474836|(p|0)==21474836&r>>>0<2061584302)){l=s;d=r;b=p}else{t=s;u=r;v=p;break}}}else{t=o;u=g;v=j}j=f[e>>2]|0;if((t+-48|0)>>>0<10){t=j;while(1){g=f[c>>2]|0;if(g>>>0<t>>>0){f[c>>2]=g+1;w=h[g>>0]|0;x=t}else{g=STb(a)|0;w=g;x=f[e>>2]|0}if((w+-48|0)>>>0<10)t=x;else{y=x;break}}}else y=j;if(y|0)f[c>>2]=(f[c>>2]|0)+-1;c=(k|0)!=0;k=Jac(0,0,u|0,v|0)|0;m=c?J:v;n=c?k:u}J=m;return n|0}function aUb(a,b){a=+a;b=b|0;var c=0.0,d=0,e=0,g=0,h=0.0,i=0;if((b|0)<=1023)if((b|0)<-1022){c=a*2.2250738585072014e-308;d=b+1022|0;e=(d|0)<-1022;g=b+2044|0;h=e?c*2.2250738585072014e-308:c;i=e?((g|0)>-1022?g:-1022):d}else{h=a;i=b}else{c=a*8988465674311579538646525.0e283;d=b+-1023|0;g=(d|0)>1023;e=b+-2046|0;h=g?c*8988465674311579538646525.0e283:c;i=g?((e|0)<1023?e:1023):d}d=$ac(i+1023|0,0,52)|0;i=J;f[s>>2]=d;f[s+4>>2]=i;return +(h*+p[s>>3])}function bUb(a,b){a=+a;b=+b;return +(+gUb(a,b))}function cUb(a,b){a=+a;b=+b;return +(+eUb(a,b))}function dUb(a,b){a=+a;b=b|0;return +(+aUb(a,b))}function eUb(a,b){a=+a;b=+b;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0.0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;p[s>>3]=b;e=f[s>>2]|0;g=f[s+4>>2]|0;h=Sac(c|0,d|0,52)|0;i=h&2047;h=Sac(e|0,g|0,52)|0;j=h&2047;h=d&-2147483648;k=$ac(e|0,g|0,1)|0;l=J;a:do if(!((k|0)==0&(l|0)==0)?(m=fUb(b)|0,n=J&2147483647,!((i|0)==2047|(n>>>0>2146435072|(n|0)==2146435072&m>>>0>0))):0){m=$ac(c|0,d|0,1)|0;n=J;if(!(n>>>0>l>>>0|(n|0)==(l|0)&m>>>0>k>>>0))return +((m|0)==(k|0)&(n|0)==(l|0)?a*0.0:a);if(!i){n=$ac(c|0,d|0,12)|0;m=J;if((m|0)>-1|(m|0)==-1&n>>>0>4294967295){o=0;q=n;n=m;while(1){m=o+-1|0;q=$ac(q|0,n|0,1)|0;n=J;if(!((n|0)>-1|(n|0)==-1&q>>>0>4294967295)){r=m;break}else o=m}}else r=0;o=$ac(c|0,d|0,1-r|0)|0;t=r;u=o;v=J}else{t=i;u=c;v=d&1048575|1048576}if(!j){o=$ac(e|0,g|0,12)|0;q=J;if((q|0)>-1|(q|0)==-1&o>>>0>4294967295){n=0;m=o;o=q;while(1){q=n+-1|0;m=$ac(m|0,o|0,1)|0;o=J;if(!((o|0)>-1|(o|0)==-1&m>>>0>4294967295)){w=q;break}else n=q}}else w=0;n=$ac(e|0,g|0,1-w|0)|0;x=w;y=n;z=J}else{x=j;y=e;z=g&1048575|1048576}n=Jac(u|0,v|0,y|0,z|0)|0;m=J;o=(m|0)>-1|(m|0)==-1&n>>>0>4294967295;b:do if((t|0)>(x|0)){q=t;A=m;B=o;C=u;D=v;E=n;while(1){if(B)if((E|0)==0&(A|0)==0)break;else{F=E;G=A}else{F=C;G=D}H=$ac(F|0,G|0,1)|0;I=J;K=q+-1|0;L=Jac(H|0,I|0,y|0,z|0)|0;M=J;N=(M|0)>-1|(M|0)==-1&L>>>0>4294967295;if((K|0)>(x|0)){q=K;A=M;B=N;C=H;D=I;E=L}else{O=K;P=N;Q=L;R=M;S=H;T=I;break b}}U=a*0.0;break a}else{O=t;P=o;Q=n;R=m;S=u;T=v}while(0);if(P)if((Q|0)==0&(R|0)==0){U=a*0.0;break}else{V=R;W=Q}else{V=T;W=S}if(V>>>0<1048576|(V|0)==1048576&W>>>0<0){m=O;n=W;o=V;while(1){E=$ac(n|0,o|0,1)|0;D=J;C=m+-1|0;if(D>>>0<1048576|(D|0)==1048576&E>>>0<0){m=C;n=E;o=D}else{X=C;Y=E;Z=D;break}}}else{X=O;Y=W;Z=V}if((X|0)>0){o=Kac(Y|0,Z|0,0,-1048576)|0;n=J;m=$ac(X|0,0,52)|0;_=n|J;$=o|m}else{m=Sac(Y|0,Z|0,1-X|0)|0;_=J;$=m}f[s>>2]=$;f[s+4>>2]=_|h;U=+p[s>>3]}else aa=3;while(0);if((aa|0)==3){ba=a*b;U=ba/ba}return +U}function fUb(a){a=+a;var b=0;p[s>>3]=a;b=f[s>>2]|0;J=f[s+4>>2]|0;return b|0}function gUb(a,b){a=+a;b=+b;var c=0,d=0,e=0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;p[s>>3]=b;e=f[s+4>>2]&-2147483648|d&2147483647;f[s>>2]=c;f[s+4>>2]=e;return +(+p[s>>3])}function hUb(){return $Sb()|0}function iUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;g=c&255;b[e>>0]=g;i=a+16|0;j=f[i>>2]|0;if(!j)if(!(NTb(a)|0)){k=f[i>>2]|0;l=4}else m=-1;else{k=j;l=4}do if((l|0)==4){j=a+20|0;i=f[j>>2]|0;if(i>>>0<k>>>0?(n=c&255,(n|0)!=(b[a+75>>0]|0)):0){f[j>>2]=i+1;b[i>>0]=g;m=n;break}if((li[f[a+36>>2]&511](a,e,1)|0)==1)m=h[e>>0]|0;else m=-1}while(0);u=d;return m|0}function jUb(a,b){a=a|0;b=b|0;var c=0;c=kUb(a)|0;return ((lUb(a,1,c,b)|0)!=(c|0))<<31>>31|0}function kUb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a;a:do if(!(c&3)){d=a;e=4}else{g=a;h=c;while(1){if(!(b[g>>0]|0)){i=h;break a}j=g+1|0;h=j;if(!(h&3)){d=j;e=4;break}else g=j}}while(0);if((e|0)==4){e=d;while(1){k=f[e>>2]|0;if(!((k&-2139062144^-2139062144)&k+-16843009))e=e+4|0;else break}if(!((k&255)<<24>>24))l=e;else{k=e;while(1){e=k+1|0;if(!(b[e>>0]|0)){l=e;break}else k=e}}i=l}return i-c|0}function lUb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=Y(c,b)|0;g=(b|0)==0?0:c;if((f[d+76>>2]|0)>-1){c=(jTb(d)|0)==0;h=MTb(a,e,d)|0;if(c)i=h;else{kTb(d);i=h}}else i=MTb(a,e,d)|0;if((i|0)==(e|0))j=g;else j=(i>>>0)/(b>>>0)|0;return j|0}function mUb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+128|0;h=g+124|0;i=g;j=i;k=142344;l=j+124|0;do{f[j>>2]=f[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(l|0));if((c+-1|0)>>>0>2147483646)if(!c){m=h;n=1;o=4}else{h=ZSb()|0;f[h>>2]=75;p=-1}else{m=a;n=c;o=4}if((o|0)==4){o=-2-m|0;c=n>>>0>o>>>0?o:n;f[i+48>>2]=c;n=i+20|0;f[n>>2]=m;f[i+44>>2]=m;o=m+c|0;m=i+16|0;f[m>>2]=o;f[i+28>>2]=o;o=oTb(i,d,e)|0;if(!c)p=o;else{c=f[n>>2]|0;b[c+(((c|0)==(f[m>>2]|0))<<31>>31)>>0]=0;p=o}}u=g;return p|0}function nUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=a+20|0;e=f[d>>2]|0;g=(f[a+16>>2]|0)-e|0;a=g>>>0>c>>>0?c:g;Vac(e|0,b|0,a|0)|0;f[d>>2]=(f[d>>2]|0)+a;return c|0}function oUb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=Y(d,c)|0;h=(c|0)==0?0:d;if((f[e+76>>2]|0)>-1)i=jTb(e)|0;else i=0;d=e+74|0;j=b[d>>0]|0;b[d>>0]=j+255|j;j=e+4|0;d=f[j>>2]|0;k=(f[e+8>>2]|0)-d|0;l=k>>>0<g>>>0?k:g;if((k|0)>0){Vac(a|0,d|0,l|0)|0;f[j>>2]=d+l;m=g-l|0;n=a+l|0}else{m=g;n=a}a:do if(!m)o=13;else{a=e+32|0;l=m;d=n;while(1){if(nTb(e)|0)break;j=li[f[a>>2]&511](e,d,l)|0;if((j+1|0)>>>0<2)break;k=l-j|0;if(!k){o=13;break a}else{l=k;d=d+j|0}}if(i|0)kTb(e);p=((g-l|0)>>>0)/(c>>>0)|0}while(0);if((o|0)==13)if(!i)p=h;else{kTb(e);p=h}return p|0}function pUb(a){a=a|0;var b=0,c=0,d=0;if(!(f[a>>2]&128))b=1;else b=(f[a+20>>2]|0)>>>0>(f[a+28>>2]|0)>>>0?2:1;c=li[f[a+40>>2]&511](a,0,b)|0;if((c|0)<0)d=c;else d=c-(f[a+8>>2]|0)+(f[a+4>>2]|0)+(f[a+20>>2]|0)-(f[a+28>>2]|0)|0;return d|0}function qUb(a){a=a|0;var b=0,c=0,d=0;if((f[a+76>>2]|0)>-1){b=(jTb(a)|0)==0;c=pUb(a)|0;if(b)d=c;else d=c}else d=pUb(a)|0;return d|0}function rUb(a){a=a|0;return qUb(a)|0}function sUb(){$e(854424);return 854432}function tUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+64|0;e=d+40|0;g=d+24|0;h=d+16|0;i=d;j=d+56|0;k=b[c>>0]|0;if(xTb(485436,k<<24>>24,4)|0){l=OSb(1156)|0;if(!l)m=0;else{n=l;o=n+124|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));if(!(uUb(c,43)|0))f[l>>2]=k<<24>>24==114?8:4;if(!(uUb(c,101)|0))p=k;else{f[i>>2]=a;f[i+4>>2]=2;f[i+8>>2]=1;Yc(221,i|0)|0;p=b[c>>0]|0}if(p<<24>>24==97){f[h>>2]=a;f[h+4>>2]=3;p=Yc(221,h|0)|0;if(!(p&1024)){f[g>>2]=a;f[g+4>>2]=4;f[g+8>>2]=p|1024;Yc(221,g|0)|0}g=f[l>>2]|128;f[l>>2]=g;q=g}else q=f[l>>2]|0;f[l+60>>2]=a;f[l+44>>2]=l+132;f[l+48>>2]=1024;g=l+75|0;b[g>>0]=-1;if((q&8|0)==0?(f[e>>2]=a,f[e+4>>2]=21523,f[e+8>>2]=j,(ue(54,e|0)|0)==0):0)b[g>>0]=10;f[l+32>>2]=208;f[l+36>>2]=206;f[l+40>>2]=207;f[l+12>>2]=583;if(!(f[213584]|0))f[l+76>>2]=-1;vUb(l)|0;m=l}}else{l=ZSb()|0;f[l>>2]=22;m=0}u=d;return m|0}function uUb(a,c){a=a|0;c=c|0;var d=0;d=xUb(a,c)|0;return ((b[d>>0]|0)==(c&255)<<24>>24?d:0)|0}function vUb(a){a=a|0;var b=0,c=0;b=sUb()|0;f[a+56>>2]=f[b>>2];c=f[b>>2]|0;if(c|0)f[c+52>>2]=a;f[b>>2]=a;wUb();return a|0}function wUb(){Cf(854424);return}function xUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=c&255;a:do if(!d)e=a+(kUb(a)|0)|0;else{if(!(a&3))g=a;else{h=c&255;i=a;while(1){j=b[i>>0]|0;if(j<<24>>24==0?1:j<<24>>24==h<<24>>24){e=i;break a}j=i+1|0;if(!(j&3)){g=j;break}else i=j}}i=Y(d,16843009)|0;h=f[g>>2]|0;b:do if(!((h&-2139062144^-2139062144)&h+-16843009)){j=g;k=h;while(1){l=k^i;if((l&-2139062144^-2139062144)&l+-16843009|0){m=j;break b}l=j+4|0;k=f[l>>2]|0;if((k&-2139062144^-2139062144)&k+-16843009|0){m=l;break}else j=l}}else m=g;while(0);i=c&255;h=m;while(1){j=b[h>>0]|0;if(j<<24>>24==0?1:j<<24>>24==i<<24>>24){e=h;break}else h=h+1|0}}while(0);return e|0}function yUb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;if((f[a+76>>2]|0)>-1)b=jTb(a)|0;else b=0;zUb(a);c=(f[a>>2]&1|0)!=0;if(!c){d=sUb()|0;e=f[a+52>>2]|0;g=a+56|0;if(e|0)f[e+56>>2]=f[g>>2];h=f[g>>2]|0;if(h|0)f[h+52>>2]=e;if((f[d>>2]|0)==(a|0))f[d>>2]=h;wUb()}h=AUb(a)|0;d=di[f[a+12>>2]&1023](a)|0|h;h=f[a+92>>2]|0;if(h|0)PSb(h);if(c){if(b|0)kTb(a)}else PSb(a);return d|0}function zUb(a){a=a|0;var b=0,c=0,d=0;if(f[a+68>>2]|0){b=f[a+116>>2]|0;c=a+112|0;if(b|0)f[b+112>>2]=f[c>>2];a=f[c>>2]|0;if(!a)d=(CUb()|0)+232|0;else d=a+116|0;f[d>>2]=b}return}function AUb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;do if(a){if((f[a+76>>2]|0)<=-1){b=BUb(a)|0;break}c=(jTb(a)|0)==0;d=BUb(a)|0;if(c)b=d;else{kTb(a);b=d}}else{if(!(f[35506]|0))e=0;else e=AUb(f[35506]|0)|0;d=sUb()|0;c=f[d>>2]|0;if(!c)g=e;else{d=c;c=e;while(1){if((f[d+76>>2]|0)>-1)h=jTb(d)|0;else h=0;if((f[d+20>>2]|0)>>>0>(f[d+28>>2]|0)>>>0)i=BUb(d)|0|c;else i=c;if(h|0)kTb(d);d=f[d+56>>2]|0;if(!d){g=i;break}else c=i}}wUb();b=g}while(0);return b|0}function BUb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=a+20|0;c=a+28|0;if((f[b>>2]|0)>>>0>(f[c>>2]|0)>>>0?(li[f[a+36>>2]&511](a,0,0)|0,(f[b>>2]|0)==0):0)d=-1;else{e=a+4|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]|0;if(g>>>0<i>>>0)li[f[a+40>>2]&511](a,g-i|0,1)|0;f[a+16>>2]=0;f[c>>2]=0;f[b>>2]=0;f[h>>2]=0;f[e>>2]=0;d=0}return d|0}function CUb(){return $Sb()|0}function DUb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;if((f[a+76>>2]|0)>=0?(jTb(a)|0)!=0:0){b=a+4|0;c=f[b>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[b>>2]=c+1;d=h[c>>0]|0}else d=mTb(a)|0;e=d}else g=3;do if((g|0)==3){d=a+4|0;c=f[d>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[d>>2]=c+1;e=h[c>>0]|0;break}else{e=mTb(a)|0;break}}while(0);return e|0}function EUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=oTb(a,b,e)|0;u=d;return c|0}function FUb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;a:do if(!c)i=0;else{do if(d|0){j=(a|0)==0?g:a;k=b[c>>0]|0;if(k<<24>>24>-1){f[j>>2]=k&255;i=k<<24>>24!=0&1;break a}k=(HUb()|0)+188|0;l=b[c>>0]|0;if(!(f[f[k>>2]>>2]|0)){f[j>>2]=l<<24>>24&57343;i=1;break a}k=(l&255)+-194|0;if(k>>>0<=50){l=c+1|0;m=f[142100+(k<<2)>>2]|0;if(d>>>0<4?m&-2147483648>>>((d*6|0)+-6|0)|0:0)break;k=h[l>>0]|0;l=k>>>3;if((l+-16|l+(m>>26))>>>0<=7){l=k+-128|m<<6;if((l|0)>=0){f[j>>2]=l;i=2;break a}m=(h[c+2>>0]|0)+-128|0;if(m>>>0<=63){k=m|l<<6;if((k|0)>=0){f[j>>2]=k;i=3;break a}l=(h[c+3>>0]|0)+-128|0;if(l>>>0<=63){f[j>>2]=l|k<<6;i=4;break a}}}}}while(0);k=ZSb()|0;f[k>>2]=84;i=-1}while(0);u=e;return i|0}function GUb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=mUb(a,b,c,g)|0;u=e;return d|0}function HUb(){return $Sb()|0}function IUb(a){a=a|0;var b=0;b=a;while(1)if(!(f[b>>2]|0))break;else b=b+4|0;return b-a>>2|0}function JUb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+16|0;g=e;a:do if(!a){h=f[c>>2]|0;i=f[h>>2]|0;if(!i)j=0;else{k=h;h=0;l=i;while(1){if(l>>>0>127){i=ETb(g,l,0)|0;if((i|0)==-1){j=-1;break a}else m=i}else m=1;i=m+h|0;k=k+4|0;l=f[k>>2]|0;if(!l){j=i;break}else h=i}}}else{b:do if(d>>>0>3){h=a;l=d;k=f[c>>2]|0;while(1){i=f[k>>2]|0;if((i+-1|0)>>>0>126){if(!i)break;n=ETb(h,i,0)|0;if((n|0)==-1){j=-1;break a}o=h+n|0;p=l-n|0;q=k}else{b[h>>0]=i;o=h+1|0;p=l+-1|0;q=f[c>>2]|0}k=q+4|0;f[c>>2]=k;if(p>>>0<=3){r=o;s=p;break b}else{h=o;l=p}}b[h>>0]=0;f[c>>2]=0;j=d-l|0;break a}else{r=a;s=d}while(0);if(s){k=r;i=s;n=f[c>>2]|0;while(1){t=f[n>>2]|0;if((t+-1|0)>>>0>126){if(!t){v=19;break}w=ETb(g,t,0)|0;if((w|0)==-1){j=-1;break a}if(i>>>0<w>>>0){v=22;break}ETb(k,f[n>>2]|0,0)|0;x=k+w|0;y=i-w|0;z=n}else{b[k>>0]=t;x=k+1|0;y=i+-1|0;z=f[c>>2]|0}n=z+4|0;f[c>>2]=n;if(!y){j=d;break a}else{k=x;i=y}}if((v|0)==19){b[k>>0]=0;f[c>>2]=0;j=d-i|0;break}else if((v|0)==22){j=d-i|0;break}}else j=d}while(0);u=e;return j|0}function KUb(a,b){a=a|0;b=b|0;LUb(a,b)|0;return a|0}function LUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=c;a:do if(!((d^a)&3)){if(!(d&3)){e=c;g=a}else{h=c;i=a;while(1){j=b[h>>0]|0;b[i>>0]=j;if(!(j<<24>>24)){k=i;break a}j=h+1|0;l=i+1|0;if(!(j&3)){e=j;g=l;break}else{h=j;i=l}}}i=f[e>>2]|0;if(!((i&-2139062144^-2139062144)&i+-16843009)){h=g;l=e;j=i;while(1){i=l+4|0;m=h+4|0;f[h>>2]=j;j=f[i>>2]|0;if((j&-2139062144^-2139062144)&j+-16843009|0){n=i;o=m;break}else{h=m;l=i}}}else{n=e;o=g}p=n;q=o;r=8}else{p=c;q=a;r=8}while(0);if((r|0)==8){r=b[p>>0]|0;b[q>>0]=r;if(!(r<<24>>24))k=q;else{r=q;q=p;while(1){q=q+1|0;p=r+1|0;a=b[q>>0]|0;b[p>>0]=a;if(!(a<<24>>24)){k=p;break}else r=p}}}return k|0}function MUb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;if((f[d+76>>2]|0)>-1)e=jTb(d)|0;else e=0;g=c+-1|0;i=(g|0)!=0;if((c|0)<2){c=d+74|0;j=b[c>>0]|0;b[c>>0]=j+255|j;if(e|0)kTb(d);if(i)k=0;else{b[a>>0]=0;k=a}}else{a:do if(i){j=d+4|0;c=d+8|0;l=g;m=a;while(1){n=f[j>>2]|0;o=n;p=(f[c>>2]|0)-o|0;q=xTb(n,10,p)|0;r=(q|0)==0;s=r?p:1-o+q|0;q=s>>>0<l>>>0?s:l;Vac(m|0,n|0,q|0)|0;n=(f[j>>2]|0)+q|0;f[j>>2]=n;t=m+q|0;s=l-q|0;if(!(r&(s|0)!=0)){u=t;v=17;break a}if(n>>>0>=(f[c>>2]|0)>>>0){r=mTb(d)|0;if((r|0)<0)break;else w=r}else{f[j>>2]=n+1;w=h[n>>0]|0}l=s+-1|0;s=t+1|0;b[t>>0]=w;if(!((l|0)!=0&(w&255|0)!=10)){u=s;v=17;break a}else m=s}if((t|0)!=(a|0)?(f[d>>2]&16|0)!=0:0){u=t;v=17}else x=0}else{u=a;v=17}while(0);if((v|0)==17)if(!a)x=0;else{b[u>>0]=0;x=a}if(!e)k=x;else{kTb(d);k=x}}return k|0}function NUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;do if((a|0)!=-1){if((f[c+76>>2]|0)>-1)d=jTb(c)|0;else d=0;e=c+4|0;g=f[e>>2]|0;if(!g){nTb(c)|0;h=f[e>>2]|0;i=(d|0)!=0;if(!h)j=i;else{k=h;l=i;m=7}}else{k=g;l=(d|0)!=0;m=7}if((m|0)==7)if(k>>>0>((f[c+44>>2]|0)+-8|0)>>>0){g=k+-1|0;f[e>>2]=g;b[g>>0]=a;f[c>>2]=f[c>>2]&-17;if(!l){n=a;break}kTb(c);n=a;break}else j=l;if(j){kTb(c);n=-1}else n=-1}else n=-1;while(0);return n|0}function OUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+128|0;e=d;g=e;h=g+124|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e+32>>2]=281;f[e+44>>2]=a;f[e+76>>2]=-1;f[e+84>>2]=a;a=PTb(e,b,c)|0;u=d;return a|0}function PUb(a,b,c){a=a|0;b=b|0;c=c|0;return QUb(a,b,c)|0}function QUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+84|0;e=f[d>>2]|0;g=c+256|0;h=xTb(e,0,g)|0;i=(h|0)==0?g:h-e|0;h=i>>>0<c>>>0?i:c;Vac(b|0,e|0,h|0)|0;f[a+4>>2]=e+h;b=e+i|0;f[a+8>>2]=b;f[d>>2]=b;return h|0}function RUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=OUb(a,b,e)|0;u=d;return c|0}function SUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a&255;e=a&255;if((f[c+76>>2]|0)>=0?(jTb(c)|0)!=0:0){if((e|0)!=(b[c+75>>0]|0)?(g=c+20|0,h=f[g>>2]|0,h>>>0<(f[c+16>>2]|0)>>>0):0){f[g>>2]=h+1;b[h>>0]=d;i=e}else i=iUb(c,a)|0;kTb(c);j=i}else k=3;do if((k|0)==3){if((e|0)!=(b[c+75>>0]|0)?(i=c+20|0,h=f[i>>2]|0,h>>>0<(f[c+16>>2]|0)>>>0):0){f[i>>2]=h+1;b[h>>0]=d;j=e;break}j=iUb(c,a)|0}while(0);return j|0}function TUb(a,b,c){a=a|0;b=b|0;c=c|0;return mUb(a,2147483647,b,c)|0}function UUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if((f[a+76>>2]|0)>-1){d=(jTb(a)|0)==0;e=VUb(a,b,c)|0;if(d)g=e;else{kTb(a);g=e}}else g=VUb(a,b,c)|0;return g|0}function VUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if((c|0)==1)d=b-(f[a+8>>2]|0)+(f[a+4>>2]|0)|0;else d=b;b=a+20|0;e=a+28|0;if((f[b>>2]|0)>>>0>(f[e>>2]|0)>>>0?(li[f[a+36>>2]&511](a,0,0)|0,(f[b>>2]|0)==0):0)g=-1;else{f[a+16>>2]=0;f[e>>2]=0;f[b>>2]=0;if((li[f[a+40>>2]&511](a,d,c)|0)<0)g=-1;else{f[a+8>>2]=0;f[a+4>>2]=0;f[a>>2]=f[a>>2]&-17;g=0}}return g|0}function WUb(a){a=a|0;var b=0,c=0,d=0;b=(kUb(a)|0)+1|0;c=OSb(b)|0;if(!c)d=0;else{Vac(c|0,a|0,b|0)|0;d=c}return d|0}function XUb(a){a=a|0;var c=0,d=0,e=0,f=0;c=(uUb(a,43)|0)==0;d=b[a>>0]|0;e=c?d<<24>>24!=114&1:2;c=(uUb(a,120)|0)==0;f=c?e:e|128;e=(uUb(a,101)|0)==0;a=e?f:f|524288;f=d<<24>>24==114?a:a|64;a=d<<24>>24==119?f|512:f;return (d<<24>>24==97?a|1024:a)|0}function YUb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+32|0;g=d+16|0;h=d;if(xTb(485436,b[c>>0]|0,4)|0){i=XUb(c)|0;f[h>>2]=a;f[h+4>>2]=i|32768;f[h+8>>2]=438;a=YSb(ke(5,h|0)|0)|0;if((a|0)>=0){if(i&524288|0){f[g>>2]=a;f[g+4>>2]=2;f[g+8>>2]=1;Yc(221,g|0)|0}g=tUb(a,c)|0;if(!g){f[e>>2]=a;je(6,e|0)|0;j=0}else j=g}else j=0}else{g=ZSb()|0;f[g>>2]=22;j=0}u=d;return j|0}function ZUb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=mUb(0,0,b,e)|0;if((g|0)>=0?(e=g+1|0,g=OSb(e)|0,f[a>>2]=g,(g|0)!=0):0)h=mUb(g,e,b,c)|0;else h=-1;u=d;return h|0}function _Ub(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;c=TUb(a,b,e)|0;u=d;return c|0}function $Ub(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+1040|0;h=g+8|0;i=g;j=f[b>>2]|0;f[i>>2]=j;k=(a|0)!=0;l=k?d:256;d=k?a:h;a=j;a:do if((l|0)!=0&(j|0)!=0){m=0;n=c;o=l;p=d;q=a;while(1){r=n>>>2;s=r>>>0>=o>>>0;if(!(n>>>0>131|s)){t=p;v=m;w=n;x=o;y=q;break a}z=s?o:r;A=n-z|0;r=aVb(p,i,z,e)|0;if((r|0)==-1)break;z=(p|0)==(h|0);s=o-(z?0:r)|0;B=z?p:p+(r<<2)|0;z=r+m|0;r=f[i>>2]|0;if((s|0)!=0&(r|0)!=0){m=z;n=A;o=s;p=B;q=r}else{t=B;v=z;w=A;x=s;y=r;break a}}t=p;v=-1;w=A;x=0;y=f[i>>2]|0}else{t=d;v=0;w=c;x=l;y=a}while(0);b:do if((y|0)!=0?(x|0)!=0&(w|0)!=0:0){a=v;l=w;c=t;d=x;A=y;while(1){C=VTb(c,A,l,e)|0;if((C+2|0)>>>0<3)break;A=(f[i>>2]|0)+C|0;f[i>>2]=A;l=l-C|0;d=d+-1|0;h=a+1|0;if(!((d|0)!=0&(l|0)!=0)){D=h;break b}else{a=h;c=c+4|0}}switch(C|0){case -1:{D=-1;break b;break}case 0:{f[i>>2]=0;D=a;break b;break}default:{f[e>>2]=0;D=a;break b}}}else D=v;while(0);if(k)f[b>>2]=f[i>>2];u=g;return D|0}function aVb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;g=f[c>>2]|0;if((e|0)!=0?(i=f[e>>2]|0,(i|0)!=0):0)if(!a){j=i;k=g;l=d;m=25}else{f[e>>2]=0;n=i;o=a;p=d;q=g;m=43}else m=5;a:do if((m|0)==5){i=(bVb()|0)+188|0;e=(a|0)!=0;if(f[f[i>>2]>>2]|0)if(e){r=a;s=d;t=g;m=15;break}else{u=g;v=d;m=14;break}if(!e){w=kUb(g)|0;m=59;break}b:do if(!d)x=g;else{e=g;i=a;y=d;while(1){z=b[e>>0]|0;if(!(z<<24>>24))break;A=e+1|0;f[i>>2]=z<<24>>24&57343;z=y+-1|0;if(!z){x=A;break b}else{e=A;i=i+4|0;y=z}}f[i>>2]=0;f[c>>2]=0;w=d-y|0;m=59;break a}while(0);f[c>>2]=x;w=d;m=59}while(0);c:while(1){d:do if((m|0)==14){m=0;x=u;g=v;while(1){e=b[x>>0]|0;if(((e&255)+-1|0)>>>0<127?(x&3|0)==0:0){z=f[x>>2]|0;A=z&255;if(!((z+-16843009|z)&-2139062144)){z=x;B=g;do{z=z+4|0;B=B+-4|0;C=f[z>>2]|0}while(!((C+-16843009|C)&-2139062144|0));D=z;E=B;F=C&255}else{D=x;E=g;F=A}}else{D=x;E=g;F=e}G=F&255;if((G+-1|0)>>>0>=127)break;x=D+1|0;g=E+-1|0}g=G+-194|0;if(g>>>0>50){H=D;I=a;J=E;m=53}else{j=f[142100+(g<<2)>>2]|0;k=D+1|0;l=E;m=25;continue c}}else if((m|0)==15){m=0;e:do if(!s)K=t;else{g=r;x=s;y=t;while(1){i=b[y>>0]|0;do if(((i&255)+-1|0)>>>0<127?x>>>0>4&(y&3|0)==0:0){L=g;M=x;N=y;while(1){O=f[N>>2]|0;if((O+-16843009|O)&-2139062144|0){m=38;break}f[L>>2]=O&255;f[L+4>>2]=h[N+1>>0];f[L+8>>2]=h[N+2>>0];P=N+4|0;Q=L+16|0;f[L+12>>2]=h[N+3>>0];R=M+-4|0;if(R>>>0>4){L=Q;M=R;N=P}else{m=37;break}}if((m|0)==37){m=0;S=Q;T=R;U=P;V=b[P>>0]|0;break}else if((m|0)==38){m=0;S=L;T=M;U=N;V=O&255;break}}else{S=g;T=x;U=y;V=i}while(0);W=V&255;if((W+-1|0)>>>0>=127)break;i=U+1|0;f[S>>2]=W;x=T+-1|0;if(!x){K=i;break e}else{g=S+4|0;y=i}}y=W+-194|0;if(y>>>0>50){H=U;I=S;J=T;m=53;break d}n=f[142100+(y<<2)>>2]|0;o=S;p=T;q=U+1|0;m=43;continue c}while(0);f[c>>2]=K;w=d;m=59;continue c}else if((m|0)==25){m=0;y=(h[k>>0]|0)>>>3;if((y+-16|y+(j>>26))>>>0>7){X=a;Y=j;Z=k;_=l;m=52}else{y=k+1|0;if(j&33554432){if((b[y>>0]&-64)<<24>>24!=-128){X=a;Y=j;Z=k;_=l;m=52;break}g=k+2|0;if(!(j&524288))$=g;else{if((b[g>>0]&-64)<<24>>24!=-128){X=a;Y=j;Z=k;_=l;m=52;break}$=k+3|0}}else $=y;u=$;v=l+-1|0;m=14;continue c}}else if((m|0)==43){m=0;y=h[q>>0]|0;g=y>>>3;if((g+-16|g+(n>>26))>>>0>7){X=o;Y=n;Z=q;_=p;m=52}else{g=q+1|0;x=y+-128|n<<6;do if((x|0)<0){y=(h[g>>0]|0)+-128|0;if(y>>>0>63){aa=q+-1|0;ba=o;break d}e=q+2|0;A=y|x<<6;if((A|0)<0){y=(h[e>>0]|0)+-128|0;if(y>>>0>63){aa=q+-1|0;ba=o;break d}else{ca=q+3|0;da=y|A<<6;break}}else{ca=e;da=A}}else{ca=g;da=x}while(0);f[o>>2]=da;r=o+4|0;s=p+-1|0;t=ca;m=15;continue c}}else if((m|0)==59){m=0;return w|0}while(0);if((m|0)==52){m=0;x=Z+-1|0;if(!Y){H=x;I=X;J=_;m=53}else{aa=x;ba=X}}if((m|0)==53){m=0;if(!(b[H>>0]|0)){if(I|0){f[I>>2]=0;f[c>>2]=0}w=d-J|0;m=59;continue}else{aa=H;ba=I}}x=ZSb()|0;f[x>>2]=84;if(!ba){w=-1;m=59;continue}f[c>>2]=aa;w=-1;m=59}return 0}function bVb(){return $Sb()|0}function cVb(a){a=a|0;var b=0;if((f[a+76>>2]|0)>-1){b=(jTb(a)|0)==0;VUb(a,0,0)|0;f[a>>2]=f[a>>2]&-33;if(!b)kTb(a)}else{VUb(a,0,0)|0;f[a>>2]=f[a>>2]&-33}return}function dVb(a,b,c){a=a|0;b=b|0;c=c|0;return UUb(a,b,c)|0}function eVb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fVb(a,b,c,-1,0)|0;return d|0}function fVb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+128|0;h=g;f[h>>2]=0;i=h+4|0;f[i>>2]=a;f[h+44>>2]=a;j=h+8|0;f[j>>2]=(a|0)<0?-1:a+2147483647|0;f[h+76>>2]=-1;RTb(h,0);k=XTb(h,c,1,d,e)|0;if(b|0)f[b>>2]=a+((f[i>>2]|0)+(f[h+108>>2]|0)-(f[j>>2]|0));u=g;return k|0}function gVb(a){a=a|0;var b=0;b=(hVb(a)|0)==0;return (b?a:a|32)|0}function hVb(a){a=a|0;return (a+-65|0)>>>0<26|0}function iVb(a){a=a|0;var b=0;b=(jVb(a)|0)==0;return (b?a:a&95)|0}function jVb(a){a=a|0;return (a+-97|0)>>>0<26|0}function kVb(a,b){a=a|0;b=b|0;return (a+-48|0)>>>0<10|0}function lVb(a){a=a|0;if(mVb(a)|0)PSb(a);return}function mVb(a){a=a|0;return (a|0)!=142076&((a|0)!=0&(a|0)!=854396)&1|0}function nVb(a,b){a=a|0;b=b|0;return -1|0}function oVb(a){a=a|0;var b=0,c=0;b=(pVb()|0)+188|0;c=f[b>>2]|0;if(a|0)f[b>>2]=(a|0)==(-1|0)?854372:a;return ((c|0)==854372?-1:c)|0}function pVb(){return $Sb()|0}function qVb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+272|0;e=d+8|0;g=d;do if(!(b[c>>0]|0)){h=He(485440)|0;if(h|0?b[h>>0]|0:0){i=h;break}h=He(485447+(a*12|0)|0)|0;if(h|0?b[h>>0]|0:0){i=h;break}h=He(485519)|0;if(h|0?b[h>>0]|0:0){i=h;break}i=485524}else i=c;while(0);c=0;a:while(1){switch(b[i+c>>0]|0){case 47:case 0:{j=c;break a;break}default:{}}h=c+1|0;if(h>>>0<15)c=h;else{j=h;break}}c=b[i>>0]|0;if(c<<24>>24!=46?(b[i+j>>0]|0)==0:0)if(c<<24>>24==67){k=i;l=15}else{m=i;l=16}else{k=485524;l=15}if((l|0)==15)if(!(b[k+1>>0]|0)){n=k;l=18}else{m=k;l=16}b:do if((l|0)==16)if((gTb(m,485524)|0)!=0?(gTb(m,485532)|0)!=0:0){k=f[213609]|0;if(k|0){i=k;do{if(!(gTb(m,i+8|0)|0)){o=i;break b}i=f[i+24>>2]|0}while((i|0)!=0)}$e(854440);i=f[213609]|0;c:do if(i|0){k=i;while(1){if(!(gTb(m,k+8|0)|0))break;c=f[k+24>>2]|0;if(!c)break c;else k=c}Cf(854440);o=k;break b}while(0);d:do if(((f[213585]|0)==0?(i=He(485538)|0,(i|0)!=0):0)?(b[i>>0]|0)!=0:0){c=254-j|0;h=j+1|0;p=i;while(1){i=xUb(p,58)|0;q=b[i>>0]|0;r=((q<<24>>24!=0)<<31>>31)+(i-p)|0;if(r>>>0<c>>>0){Vac(e|0,p|0,r|0)|0;s=e+r|0;b[s>>0]=47;Vac(s+1|0,m|0,j|0)|0;b[e+(h+r)>>0]=0;t=Of(e|0,g|0)|0;if(t|0)break;v=b[i>>0]|0}else v=q;p=i+(v<<24>>24!=0&1)|0;if(!(b[p>>0]|0)){l=41;break d}}p=OSb(28)|0;h=f[g>>2]|0;if(!p){rVb(t,h)|0;l=41;break}else{f[p>>2]=t;f[p+4>>2]=h;h=p+8|0;Vac(h|0,m|0,j|0)|0;b[h+j>>0]=0;f[p+24>>2]=f[213609];f[213609]=p;w=p;break}}else l=41;while(0);if((l|0)==41){p=OSb(28)|0;if(!p)w=p;else{f[p>>2]=f[35507];f[p+4>>2]=f[35508];h=p+8|0;Vac(h|0,m|0,j|0)|0;b[h+j>>0]=0;f[p+24>>2]=f[213609];f[213609]=p;w=p}}Cf(854440);o=(a|0)==0&(w|0)==0?142028:w}else{n=m;l=18}while(0);do if((l|0)==18){if((a|0)==0?(b[n+1>>0]|0)==46:0){o=142028;break}o=0}while(0);u=d;return o|0}function rVb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;sVb();f[d>>2]=a;f[d+4>>2]=b;b=YSb($d(91,d|0)|0)|0;u=c;return b|0}function sVb(){return}function tVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;if(!d)e=0;else{f=b[a>>0]|0;g=f&255;h=b[c>>0]|0;i=h&255;a:do if(!(f<<24>>24)){j=i;k=g}else{l=a;m=d;n=c;o=f;p=i;q=g;r=h;while(1){m=m+-1|0;if(!(o<<24>>24==r<<24>>24&((m|0)!=0&r<<24>>24!=0))){j=p;k=q;break a}l=l+1|0;n=n+1|0;o=b[l>>0]|0;s=o&255;r=b[n>>0]|0;t=r&255;if(!(o<<24>>24)){j=t;k=s;break}else{p=t;q=s}}}while(0);e=k-j|0}return e|0}function uVb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return d|0}function vVb(a,b){a=a|0;b=b|0;return wVb(a)|0}function wVb(a){a=a|0;return ((a+-48|0)>>>0<10|((a|32)+-97|0)>>>0<6)&1|0}function xVb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(c|0){d=c;c=b;b=a;while(1){d=d+-1|0;f[b>>2]=f[c>>2];if(!d)break;else{c=c+4|0;b=b+4|0}}}return a|0}function yVb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d;a:do if(!(mVb(c)|0)){g=(c|0)==0;h=0;i=0;do{j=(1<<i&a|0)!=0;if(g|j)k=qVb(i,j?b:1124530)|0;else k=f[c+(i<<2)>>2]|0;h=((k|0)!=0&1)+h|0;f[e+(i<<2)>>2]=k;i=i+1|0}while((i|0)!=6);switch(h|0){case 0:{l=854396;break a;break}case 1:{if((f[e>>2]|0)==142028){l=142076;break a}break}default:{}}l=c}else{i=0;do{if(1<<i&a|0){g=qVb(i,b)|0;f[c+(i<<2)>>2]=g}i=i+1|0}while((i|0)!=6);l=c}while(0);u=d;return l|0}function zVb(a){a=a|0;return 0}function AVb(a){a=+a;var b=0,c=0,d=0,e=0,g=0.0,h=0.0,i=0,j=0.0,k=0.0,l=0,m=0,n=0.0,o=0.0;p[s>>3]=a;b=f[s+4>>2]|0;c=b&2147483647;d=Sac(f[s>>2]|0,b|0,63)|0;do if(c>>>0>1078159481){b=BVb(a)|0;e=J&2147483647;if(!(e>>>0>2146435072|(e|0)==2146435072&b>>>0>0))if(!d)if(a>709.782712893384)g=a*8988465674311579538646525.0e283;else{h=.5;i=12}else g=-1.0;else g=a}else{if(c>>>0<=1071001154)if(c>>>0<1016070144){g=a;break}else{j=a;k=0.0;l=0;i=15;break}b=(d|0)!=0;if(c>>>0>=1072734898){h=b?-.5:.5;i=12;break}if(b){m=-1;n=a+.6931471803691238;o=-1.9082149292705877e-10;i=13;break}else{m=1;n=a+-.6931471803691238;o=1.9082149292705877e-10;i=13;break}}while(0);if((i|0)==12){c=~~(a*1.4426950408889634+h);h=+(c|0);m=c;n=a-h*.6931471803691238;o=h*1.9082149292705877e-10;i=13}if((i|0)==13){h=n-o;j=h;k=n-h-o;l=m;i=15}a:do if((i|0)==15){o=j*.5;h=j*o;n=h*(h*(h*(h*(4.008217827329362e-06-h*2.0109921818362437e-07)+-7.93650757867488e-05)+1.5873015872548146e-03)+-.03333333333333313)+1.0;a=3.0-o*n;o=h*((n-a)/(6.0-j*a));if(!l){g=j-(j*o-h);break}a=j*(o-k)-k-h;switch(l|0){case -1:{g=(j-a)*.5+-.5;break a;break}case 1:{if(j<-.25){g=(a-(j+.5))*-2.0;break a}else{g=(j-a)*2.0+1.0;break a}break}default:{m=$ac(l+1023|0,0,52)|0;c=J;f[s>>2]=m;f[s+4>>2]=c;h=+p[s>>3];if(l>>>0>56){o=j-a+1.0;g=((l|0)==1024?o*2.0*8988465674311579538646525.0e283:h*o)+-1.0;break a}else{c=$ac(1023-l|0,0,52)|0;m=J;d=(l|0)<20;f[s>>2]=c;f[s+4>>2]=m;o=+p[s>>3];g=h*((d?1.0-o:1.0)+(j-(d?a:o+a)));break a}}}}while(0);return +g}function BVb(a){a=+a;var b=0;p[s>>3]=a;b=f[s>>2]|0;J=f[s+4>>2]|0;return b|0}function CVb(a){a=a|0;return 0}function DVb(a){a=a|0;return 0}function EVb(a){a=+a;var b=0,c=0,d=0.0,e=0.0;b=(n[s>>2]=a,f[s>>2]|0);if((b&2130706432)>>>0<=1249902592){c=(b|0)<0;d=(c?8388608.0:-8388608.0)+((c?-8388608.0:8388608.0)+a);if(d==0.0)e=c?-0.0:0.0;else e=d}else e=a;return +e}function FVb(a){a=+a;var b=0,c=0,d=0.0,e=0.0;p[s>>3]=a;b=f[s+4>>2]|0;c=b&2146435072;if(!(c>>>0>1126170624|(c|0)==1126170624&0>0)){c=(b|0)<0;d=(c?4503599627370496.0:-4503599627370496.0)+((c?-4503599627370496.0:4503599627370496.0)+a);if(d==0.0)e=c?-0.0:0.0;else e=d}else e=a;return +e}function GVb(a){a=+a;var b=0,c=0,d=0.0,e=0.0;b=(n[s>>2]=a,f[s>>2]|0);c=b&2147483647;a=(f[s>>2]=c,+n[s>>2]);do if(c>>>0>1057791828)if(c>>>0>1092616192){d=0.0/a+1.0;break}else{d=1.0-2.0/(+HVb(a*2.0)+2.0);break}else{if(c>>>0>1048757624){e=+HVb(a*2.0);d=e/(e+2.0);break}if(c>>>0>8388607){e=+HVb(a*-2.0);d=-e/(e+2.0)}else d=a}while(0);return +((b|0)<0?-d:d)}function HVb(a){a=+a;var b=0,c=0,d=0,e=0.0,g=0.0,h=0,i=0.0,j=0.0,k=0,l=0,m=0.0,o=0.0;b=(n[s>>2]=a,f[s>>2]|0);c=b&2147483647;d=b>>>31;do if(c>>>0>1100331075)if(c>>>0<=2139095040)if(!d)if(a>88.7216796875)e=a*1701411834604692317316873.0e14;else{g=.5;h=12}else e=-1.0;else e=a;else{if(c>>>0<=1051816472)if(c>>>0<855638016){e=a;break}else{i=a;j=0.0;k=0;h=15;break}b=(d|0)!=0;if(c>>>0>=1065686418){g=b?-.5:.5;h=12;break}if(b){l=-1;m=a+.6931381225585938;o=-9.05800061445916e-06;h=13;break}else{l=1;m=a+-.6931381225585938;o=9.05800061445916e-06;h=13;break}}while(0);if((h|0)==12){c=~~(a*1.4426950216293335+g);g=+(c|0);l=c;m=a-g*.6931381225585938;o=g*9.05800061445916e-06;h=13}if((h|0)==13){g=m-o;i=g;j=m-g-o;k=l;h=15}a:do if((h|0)==15){o=i*.5;g=i*o;m=g*(g*1.5807170420885086e-03+-.03333321213722229)+1.0;a=3.0-o*m;o=g*((m-a)/(6.0-i*a));if(!k){e=i-(i*o-g);break}a=i*(o-j)-j-g;switch(k|0){case -1:{e=(i-a)*.5+-.5;break a;break}case 1:{if(i<-.25){e=(a-(i+.5))*-2.0;break a}else{e=(i-a)*2.0+1.0;break a}break}default:{g=(f[s>>2]=(k<<23)+1065353216,+n[s>>2]);if(k>>>0>56){o=i-a+1.0;e=((k|0)==128?o*2.0*1701411834604692317316873.0e14:g*o)+-1.0;break a}else{l=(k|0)<23;o=(f[s>>2]=127-k<<23,+n[s>>2]);e=g*((l?1.0-o:1.0)+(i-(l?a:o+a)));break a}}}}while(0);return +e}function IVb(a,b){a=+a;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0;p[s>>3]=a;c=f[s>>2]|0;d=f[s+4>>2]|0;e=Sac(c|0,d|0,52)|0;g=e&2047;e=g+-1023|0;if((e|0)>51){p[b>>3]=a;f[s>>2]=0;f[s+4>>2]=d&-2147483648;return +((c|0)==0&(d&1048575|0)==0|(e|0)!=1024?+p[s>>3]:a)}do if(g>>>0>=1023){h=Sac(-1,1048575,e|0)|0;i=J;if((h&c|0)==0&(i&d|0)==0){p[b>>3]=a;f[s>>2]=0;f[s+4>>2]=d&-2147483648;j=+p[s>>3];break}else{k=c&~h;h=d&~i;f[s>>2]=k;f[s+4>>2]=h;l=+p[s>>3];i=b;f[i>>2]=k;f[i+4>>2]=h;j=a-l;break}}else{h=b;f[h>>2]=0;f[h+4>>2]=d&-2147483648;j=a}while(0);return +j}function JVb(a){a=+a;var b=0,c=0,d=0,e=0.0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,t=0.0;p[s>>3]=a;b=f[s>>2]|0;c=f[s+4>>2]|0;d=(c|0)<0;do if(d|c>>>0<1048576){if((b|0)==0&(c&2147483647|0)==0){e=-1.0/(a*a);break}if(d){e=(a-a)/0.0;break}else{p[s>>3]=a*18014398509481984.0;g=f[s+4>>2]|0;h=-1077;i=g;j=f[s>>2]|0;k=g;l=9;break}}else if(c>>>0<=2146435071)if((b|0)==0&0==0&(c|0)==1072693248)e=0.0;else{h=-1023;i=c;j=b;k=c;l=9}else e=a;while(0);if((l|0)==9){l=i+614242|0;f[s>>2]=j;f[s+4>>2]=(l&1048575)+1072079006;a=+p[s>>3]+-1.0;m=a*(a*.5);n=a/(a+2.0);o=n*n;q=o*o;p[s>>3]=a-m;j=f[s+4>>2]|0;f[s>>2]=0;f[s+4>>2]=j;r=+p[s>>3];t=a-r-m+n*(m+(q*(q*(q*.15313837699209373+.22222198432149784)+.3999999999940942)+o*(q*(q*(q*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)));q=r*.4342944818781689;o=+(h+(l>>>20)|0);m=o*.30102999566361177;n=m+q;e=n+(q+(m-n)+(t*.4342944818781689+(o*3.694239077158931e-13+(r+t)*2.5082946711645275e-11)))}return +e}function KVb(a){a=+a;var b=0,c=0,d=0.0,e=0.0;p[s>>3]=a;b=f[s+4>>2]|0;c=b&2147483647;f[s>>2]=f[s>>2];f[s+4>>2]=c;a=+p[s>>3];do if(c>>>0>1071748074)if(c>>>0>1077149696){d=1.0-0.0/a;break}else{d=1.0-2.0/(+AVb(a*2.0)+2.0);break}else{if(c>>>0>1070618798){e=+AVb(a*2.0);d=e/(e+2.0);break}if(c>>>0>1048575){e=+AVb(a*-2.0);d=-e/(e+2.0)}else d=a}while(0);return +((b|0)<0?-d:d)}function LVb(a){a=+a;return ~~+EVb(a)|0}function MVb(a){a=+a;var b=0,c=0.0;b=CVb(32)|0;c=+FVb(a);return ~~c|0}function NVb(a,b){a=a|0;b=b|0;return +(+OVb(a,b,0))}function OVb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0;d=u;u=u+128|0;e=d;g=e;h=g+124|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=e+4|0;f[g>>2]=a;h=e+8|0;f[h>>2]=-1;f[e+44>>2]=a;f[e+76>>2]=-1;RTb(e,0);i=+YTb(e,c,1);c=(f[g>>2]|0)-(f[h>>2]|0)+(f[e+108>>2]|0)|0;if(b|0)f[b>>2]=c|0?a+c|0:a;u=d;return +i}function PVb(a,b){a=a|0;b=b|0;return +(+OVb(a,b,1))}function QVb(a,b){a=a|0;b=b|0;return +(+OVb(a,b,2))}function RVb(a,b,c){a=a|0;b=b|0;c=c|0;return +(+NVb(a,b))}function SVb(a,b,c){a=a|0;b=b|0;c=c|0;return +(+PVb(a,b))}function TVb(a,b,c){a=a|0;b=b|0;c=c|0;return +(+QVb(a,b))}function UVb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fVb(a,b,c,-1,-1)|0;return d|0}function VVb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fVb(a,b,c,0,-2147483648)|0;return d|0}function WVb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=fVb(a,b,c,-2147483648,0)|0;return d|0}function XVb(a,b,c){a=a|0;b=b|0;c=c|0;YVb(a,b,c)|0;return a|0}function YVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=c;do if(!((e^a)&3)){g=(d|0)!=0;a:do if(g&(e&3|0)!=0){h=d;i=c;j=a;while(1){k=b[i>>0]|0;b[j>>0]=k;if(!(k<<24>>24)){l=h;m=i;n=j;break a}k=h+-1|0;o=i+1|0;p=j+1|0;q=(k|0)!=0;if(q&(o&3|0)!=0){h=k;i=o;j=p}else{r=k;s=o;t=p;u=q;v=5;break}}}else{r=d;s=c;t=a;u=g;v=5}while(0);if((v|0)==5)if(u){l=r;m=s;n=t}else{w=t;x=0;break}if(!(b[m>>0]|0)){w=n;x=l}else{b:do if(l>>>0>3){g=n;j=m;i=l;while(1){h=f[j>>2]|0;if((h&-2139062144^-2139062144)&h+-16843009|0){y=j;z=g;A=i;break b}f[g>>2]=h;h=i+-4|0;q=j+4|0;p=g+4|0;if(h>>>0>3){g=p;j=q;i=h}else{y=q;z=p;A=h;break}}}else{y=m;z=n;A=l}while(0);B=y;C=z;D=A;v=11}}else{B=c;C=a;D=d;v=11}while(0);c:do if((v|0)==11)if(!D){w=C;x=0}else{d=B;a=C;c=D;while(1){A=b[d>>0]|0;b[a>>0]=A;if(!(A<<24>>24)){w=a;x=c;break c}c=c+-1|0;A=a+1|0;if(!c){w=A;x=0;break}else{d=d+1|0;a=A}}}while(0);Nac(w|0,0,x|0)|0;return w|0}function ZVb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;a:do if(!d)e=0;else{f=a;g=d;h=c;while(1){i=b[f>>0]|0;j=b[h>>0]|0;if(i<<24>>24!=j<<24>>24)break;g=g+-1|0;if(!g){e=0;break a}else{f=f+1|0;h=h+1|0}}e=(i&255)-(j&255)|0}while(0);return e|0}function _Vb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;e=c&255;c=d;while(1){if(!c){f=0;break}c=c+-1|0;d=a+c|0;if((b[d>>0]|0)==e<<24>>24){f=d;break}}return f|0}function $Vb(a,b){a=a|0;b=b|0;return _Vb(a,b,(kUb(a)|0)+1|0)|0}function aWb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(c|0){d=c;c=a;while(1){d=d+-1|0;f[c>>2]=b;if(!d)break;else c=c+4|0}}return a|0}function bWb(a,c){a=a|0;c=c|0;var d=0,e=0,f=0;d=b[c>>0]|0;do if(d<<24>>24){e=uUb(a,d<<24>>24)|0;if(e)if(b[c+1>>0]|0)if(b[e+1>>0]|0){if(!(b[c+2>>0]|0)){f=cWb(e,c)|0;break}if(b[e+2>>0]|0){if(!(b[c+3>>0]|0)){f=dWb(e,c)|0;break}if(b[e+3>>0]|0)if(!(b[c+4>>0]|0)){f=eWb(e,c)|0;break}else{f=fWb(e,c)|0;break}else f=0}else f=0}else f=0;else f=e;else f=0}else f=a;while(0);return f|0}function cWb(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;d=(h[c>>0]|0)<<8|(h[c+1>>0]|0);c=h[a>>0]|0;e=a;while(1){a=e+1|0;f=b[a>>0]|0;if(!(f<<24>>24)){g=0;break}c=f&255|c<<8&65280;if((c|0)==(d|0)){g=e;break}else e=a}return g|0}function dWb(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0;d=(h[c+1>>0]|0)<<16|(h[c>>0]|0)<<24|(h[c+2>>0]|0)<<8;c=a+2|0;e=b[c>>0]|0;f=(h[a+1>>0]|0)<<16|(h[a>>0]|0)<<24|(e&255)<<8;a=e<<24>>24!=0;if((f|0)==(d|0)|a^1){g=c;i=a}else{a=c;c=f;while(1){f=a+1|0;e=b[f>>0]|0;c=(e&255|c)<<8;j=e<<24>>24!=0;if((c|0)==(d|0)|j^1){g=f;i=j;break}else a=f}}return (i?g+-2|0:0)|0}function eWb(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0;d=(h[c+1>>0]|0)<<16|(h[c>>0]|0)<<24|(h[c+2>>0]|0)<<8|(h[c+3>>0]|0);c=a+3|0;e=b[c>>0]|0;f=e&255|((h[a+1>>0]|0)<<16|(h[a>>0]|0)<<24|(h[a+2>>0]|0)<<8);a=e<<24>>24!=0;if((f|0)==(d|0)|a^1){g=a;i=c}else{a=c;c=f;while(1){f=a+1|0;e=b[f>>0]|0;c=e&255|c<<8;j=e<<24>>24!=0;if((c|0)==(d|0)|j^1){g=j;i=f;break}else a=f}}return (g?i+-3|0:0)|0}function fWb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;d=u;u=u+1056|0;e=d+1024|0;g=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;f[e+24>>2]=0;f[e+28>>2]=0;h=b[c>>0]|0;a:do if(h<<24>>24){i=0;j=h;k=h&255;while(1){if(!(b[a+i>>0]|0)){l=0;break a}m=e+(((j&255)>>>5&255)<<2)|0;f[m>>2]=f[m>>2]|1<<(j&31);i=i+1|0;f[g+(k<<2)>>2]=i;m=b[c+i>>0]|0;if(!(m<<24>>24))break;else{j=m;k=m&255}}k=i>>>0>1;if(k){j=0;m=-1;n=1;b:while(1){o=1;p=j;q=n;while(1){r=p;s=q;c:while(1){t=1;v=s;while(1){w=b[c+(t+m)>>0]|0;x=b[c+v>>0]|0;if(w<<24>>24!=x<<24>>24)break c;if((t|0)==(o|0))break;t=t+1|0;y=t+r|0;if(y>>>0>=i>>>0){z=o;A=m;break b}else v=y}t=o+r|0;s=t+1|0;if(s>>>0>=i>>>0){z=o;A=m;break b}else r=t}s=v-m|0;if((w&255)<=(x&255))break;q=v+1|0;if(q>>>0>=i>>>0){z=s;A=m;break b}else{o=s;p=v}}n=r+2|0;if(n>>>0>=i>>>0){z=1;A=r;break}else{j=r+1|0;m=r}}if(k){m=0;j=-1;n=1;while(1){p=1;o=m;q=n;while(1){B=o;s=q;d:while(1){t=1;C=s;while(1){D=b[c+(t+j)>>0]|0;E=b[c+C>>0]|0;if(D<<24>>24!=E<<24>>24)break d;if((t|0)==(p|0))break;t=t+1|0;y=t+B|0;if(y>>>0>=i>>>0){F=z;G=A;H=i;I=p;J=j;K=27;break a}else C=y}t=p+B|0;s=t+1|0;if(s>>>0>=i>>>0){F=z;G=A;H=i;I=p;J=j;K=27;break a}else B=t}s=C-j|0;if((D&255)>=(E&255))break;q=C+1|0;if(q>>>0>=i>>>0){F=z;G=A;H=i;I=s;J=j;K=27;break a}else{p=s;o=C}}n=B+2|0;if(n>>>0>=i>>>0){F=z;G=A;H=i;I=1;J=B;K=27;break}else{m=B+1|0;j=B}}}else{F=z;G=A;H=i;I=1;J=-1;K=27}}else{F=1;G=-1;H=i;I=1;J=-1;K=27}}else{F=1;G=-1;H=0;I=1;J=-1;K=27}while(0);e:do if((K|0)==27){A=(J+1|0)>>>0>(G+1|0)>>>0;z=A?I:F;B=A?J:G;A=B+1|0;if(!(ZVb(c,c+z|0,A)|0)){L=H-z|0;M=z}else{z=H-B+-1|0;L=0;M=(B>>>0>z>>>0?B:z)+1|0}z=H|63;C=H+-1|0;E=(L|0)!=0;D=H-M|0;r=a;v=0;x=a;while(1){w=r;do if((x-w|0)>>>0<H>>>0){h=xTb(x,0,z)|0;if(h)if((h-w|0)>>>0<H>>>0){l=0;break e}else{N=h;break}else{N=x+z|0;break}}else N=x;while(0);w=b[r+C>>0]|0;f:do if(!(1<<(w&31)&f[e+(((w&255)>>>5&255)<<2)>>2])){O=0;P=H}else{h=H-(f[g+((w&255)<<2)>>2]|0)|0;if(h|0){O=0;P=E&(v|0)!=0&h>>>0<M>>>0?D:h;break}h=A>>>0>v>>>0?A:v;j=b[c+h>>0]|0;g:do if(!(j<<24>>24))Q=A;else{m=h;n=j;while(1){if(n<<24>>24!=(b[r+m>>0]|0))break;k=m+1|0;n=b[c+k>>0]|0;if(!(n<<24>>24)){Q=A;break g}else m=k}O=0;P=m-B|0;break f}while(0);while(1){if(Q>>>0<=v>>>0){l=r;break e}Q=Q+-1|0;if((b[c+Q>>0]|0)!=(b[r+Q>>0]|0)){O=L;P=M;break}}}while(0);r=r+P|0;v=O;x=N}}while(0);u=d;return l|0}function gWb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if(a-b>>2>>>0>=c>>>0){if(c|0){d=b;e=a;g=c;while(1){g=g+-1|0;f[e>>2]=f[d>>2];if(!g)break;else{d=d+4|0;e=e+4|0}}}}else{e=c;do{e=e+-1|0;f[a+(e<<2)>>2]=f[b+(e<<2)>>2]}while((e|0)!=0)}return a|0}function hWb(a,b,c){a=a|0;b=b|0;c=c|0;return VTb(0,a,b,c|0?c:854448)|0}function iWb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+272|0;g=e+8|0;h=e;i=f[b>>2]|0;f[h>>2]=i;j=(a|0)!=0;k=j?d:256;d=j?a:g;a=i;a:do if((k|0)!=0&(i|0)!=0){l=0;m=c;n=k;o=d;p=a;while(1){q=m>>>0>=n>>>0;if(!(q|m>>>0>32)){r=o;s=l;t=m;v=n;w=p;break a}x=q?n:m;y=m-x|0;q=JUb(o,h,x,0)|0;if((q|0)==-1)break;x=(o|0)==(g|0);z=n-(x?0:q)|0;A=x?o:o+q|0;x=q+l|0;q=f[h>>2]|0;if((z|0)!=0&(q|0)!=0){l=x;m=y;n=z;o=A;p=q}else{r=A;s=x;t=y;v=z;w=q;break a}}r=o;s=-1;t=y;v=0;w=f[h>>2]|0}else{r=d;s=0;t=c;v=k;w=a}while(0);b:do if((w|0)!=0?(v|0)!=0&(t|0)!=0:0){a=s;k=t;c=r;d=v;y=w;while(1){B=ETb(c,f[y>>2]|0,0)|0;if((B+1|0)>>>0<2)break;y=(f[h>>2]|0)+4|0;f[h>>2]=y;k=k+-1|0;d=d-B|0;g=B+a|0;if(!((d|0)!=0&(k|0)!=0)){C=g;break b}else{a=g;c=c+B|0}}if(!B){f[h>>2]=0;C=a}else C=-1}else C=s;while(0);if(j)f[b>>2]=f[h>>2];u=e;return C|0}function jWb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=a;f[e+4>>2]=b;f[e+8>>2]=c;c=YSb(gf(4,e|0)|0)|0;u=d;return c|0}function kWb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=a;f[e+4>>2]=b;f[e+8>>2]=c;c=YSb(ge(3,e|0)|0)|0;u=d;return c|0}function lWb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=UVb(a,b,c)|0;return d|0}function mWb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=VVb(a,b,c)|0;return d|0}function nWb(){return 142468}function oWb(){return 142472}function pWb(){return 144012}function qWb(){var a=0;a=(rWb()|0)+188|0;return (f[f[a>>2]>>2]|0?4:1)|0}function rWb(){return $Sb()|0}function sWb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=b-i|0;k=j>>2;l=h+4|0;switch(k|0){case 1:case 0:{break a;break}case 2:{m=5;break a;break}case 3:{m=7;break a;break}case 4:{m=8;break a;break}case 5:{m=9;break a;break}default:{}}if((j|0)<124){m=11;break a}n=h+(((k|0)/2|0)<<2)|0;if((j|0)>3996){j=(k|0)/4|0;o=vWb(h,h+(j<<2)|0,n,n+(j<<2)|0,e,c)|0}else o=tWb(h,n,e,c)|0;p=f[h>>2]|0;j=f[n>>2]|0;if((p|0)<(j|0)){q=e;r=o;break}else s=e;while(1){s=s+-4|0;if((h|0)==(s|0))break;t=f[s>>2]|0;if((t|0)<(j|0)){m=28;break b}}j=f[e>>2]|0;if((p|0)<(j|0))u=l;else{k=l;while(1){if((k|0)==(e|0))break a;v=f[k>>2]|0;w=k+4|0;if((p|0)<(v|0))break;else k=w}f[k>>2]=j;f[e>>2]=v;u=w}if((u|0)==(e|0))break a;else{x=e;y=u}while(1){z=f[h>>2]|0;A=y;while(1){B=f[A>>2]|0;C=A+4|0;if((z|0)<(B|0)){D=x;break}else A=C}do{D=D+-4|0;E=f[D>>2]|0}while((z|0)<(E|0));if(A>>>0>=D>>>0){h=A;continue b}f[A>>2]=E;f[D>>2]=B;x=D;y=C}}if((m|0)==28){m=0;f[h>>2]=t;f[s>>2]=p;q=s;r=o+1|0}c:do if(l>>>0<q>>>0){j=n;k=q;z=l;F=r;while(1){G=f[j>>2]|0;H=z;while(1){I=f[H>>2]|0;J=H+4|0;if((I|0)<(G|0))H=J;else{K=k;break}}do{K=K+-4|0;L=f[K>>2]|0}while((L|0)>=(G|0));if(H>>>0>K>>>0){M=j;N=F;O=H;break c}f[H>>2]=L;f[K>>2]=I;j=(j|0)==(H|0)?K:j;k=K;z=J;F=F+1|0}}else{M=n;N=r;O=l}while(0);if((O|0)!=(M|0)?(F=f[M>>2]|0,z=f[O>>2]|0,(F|0)<(z|0)):0){f[O>>2]=F;f[M>>2]=z;P=N+1|0}else P=N;if(!P){Q=xWb(h,O,c)|0;z=O+4|0;if(xWb(z,a,c)|0){m=45;break}if(Q){g=z;continue}else R=z}else R=O+4|0;z=O;if((z-i|0)>=(b-z|0)){m=44;break}sWb(h,O,c);g=R}if((m|0)==44){m=0;sWb(R,a,c);d=h;a=O;continue}else if((m|0)==45){m=0;if(Q)break;else{d=h;a=O;continue}}}if((m|0)==5){O=f[e>>2]|0;d=f[h>>2]|0;if((O|0)<(d|0)){f[h>>2]=O;f[e>>2]=d}}else if((m|0)==7)tWb(h,l,e,c)|0;else if((m|0)==8)uWb(h,l,h+8|0,e,c)|0;else if((m|0)==9)vWb(h,l,h+8|0,h+12|0,e,c)|0;else if((m|0)==11)wWb(h,a,c);return}function tWb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;d=f[b>>2]|0;e=f[a>>2]|0;g=f[c>>2]|0;h=(g|0)<(d|0);do if((d|0)<(e|0)){if(h){f[a>>2]=g;f[c>>2]=e;i=1;break}f[a>>2]=d;f[b>>2]=e;j=f[c>>2]|0;if((j|0)<(e|0)){f[b>>2]=j;f[c>>2]=e;i=2}else i=1}else if(h){f[b>>2]=g;f[c>>2]=d;j=f[b>>2]|0;k=f[a>>2]|0;if((j|0)<(k|0)){f[a>>2]=j;f[b>>2]=k;i=2}else i=1}else i=0;while(0);return i|0}function uWb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=tWb(a,b,c,e)|0;e=f[d>>2]|0;h=f[c>>2]|0;if((e|0)<(h|0)){f[c>>2]=e;f[d>>2]=h;h=g+1|0;d=f[c>>2]|0;e=f[b>>2]|0;if((d|0)<(e|0)){f[b>>2]=d;f[c>>2]=e;e=f[b>>2]|0;c=f[a>>2]|0;if((e|0)<(c|0)){f[a>>2]=e;f[b>>2]=c;i=g+3|0}else i=g+2|0}else i=h}else i=g;return i|0}function vWb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=uWb(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;if((g|0)<(i|0)){f[d>>2]=g;f[e>>2]=i;i=h+1|0;e=f[d>>2]|0;g=f[c>>2]|0;if((e|0)<(g|0)){f[c>>2]=e;f[d>>2]=g;g=h+2|0;d=f[c>>2]|0;e=f[b>>2]|0;if((d|0)<(e|0)){f[b>>2]=d;f[c>>2]=e;e=f[b>>2]|0;c=f[a>>2]|0;if((e|0)<(c|0)){f[a>>2]=e;f[b>>2]=c;j=h+4|0}else j=h+3|0}else j=g}else j=i}else j=h;return j|0}function wWb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;tWb(a,a+4|0,d,c)|0;c=a+12|0;e=d;while(1){if((c|0)==(b|0))break;d=f[c>>2]|0;g=f[e>>2]|0;if((d|0)<(g|0)){h=e;i=c;j=g;while(1){f[i>>2]=j;if((h|0)==(a|0)){k=a;break}g=h+-4|0;j=f[g>>2]|0;if((d|0)>=(j|0)){k=h;break}else{l=h;h=g;i=l}}f[k>>2]=d}i=c;c=c+4|0;e=i}return}function xWb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=a+4|0;e=b+-4|0;g=a+8|0;switch(b-a>>2|0){case 1:case 0:{h=1;break}case 2:{i=f[e>>2]|0;j=f[a>>2]|0;if((i|0)<(j|0)){f[a>>2]=i;f[e>>2]=j;h=1}else h=1;break}case 3:{tWb(a,d,e,c)|0;h=1;break}case 4:{uWb(a,d,g,e,c)|0;h=1;break}case 5:{vWb(a,d,g,a+12|0,e,c)|0;h=1;break}default:{tWb(a,d,g,c)|0;c=a+12|0;d=0;e=g;while(1){if((c|0)==(b|0)){k=1;l=0;break}g=f[c>>2]|0;j=f[e>>2]|0;if((g|0)<(j|0)){i=e;m=c;n=j;while(1){f[m>>2]=n;if((i|0)==(a|0)){o=a;break}j=i+-4|0;n=f[j>>2]|0;if((g|0)>=(n|0)){o=i;break}else{p=i;i=j;m=p}}f[o>>2]=g;m=d+1|0;if((m|0)==8){k=0;l=(c+4|0)==(b|0);break}else q=m}else q=d;m=c;c=c+4|0;d=q;e=m}h=l|k}}return h|0}function yWb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=u;u=u+16|0;c=b;d=b+8|0;e=b+4|0;f[d>>2]=a;do if(a>>>0>=212){g=(a>>>0)/210|0;h=g*210|0;f[e>>2]=a-h;i=0;j=g;g=(zWb(145744,145936,e,c)|0)-145744>>2;k=h;a:while(1){l=(f[145744+(g<<2)>>2]|0)+k|0;h=5;while(1){if(h>>>0>=47){m=211;n=i;o=8;break}p=f[145552+(h<<2)>>2]|0;q=(l>>>0)/(p>>>0)|0;if(q>>>0<p>>>0){o=106;break a}if((l|0)==(Y(q,p)|0)){r=i;break}else h=h+1|0}b:do if((o|0)==8){c:while(1){o=0;h=(l>>>0)/(m>>>0)|0;do if(h>>>0>=m>>>0)if((l|0)!=(Y(h,m)|0)){p=m+10|0;q=(l>>>0)/(p>>>0)|0;if(q>>>0>=p>>>0)if((l|0)!=(Y(q,p)|0)){q=m+12|0;s=(l>>>0)/(q>>>0)|0;if(s>>>0>=q>>>0)if((l|0)!=(Y(s,q)|0)){s=m+16|0;t=(l>>>0)/(s>>>0)|0;if(t>>>0>=s>>>0)if((l|0)!=(Y(t,s)|0)){t=m+18|0;v=(l>>>0)/(t>>>0)|0;if(v>>>0>=t>>>0)if((l|0)!=(Y(v,t)|0)){v=m+22|0;w=(l>>>0)/(v>>>0)|0;if(w>>>0>=v>>>0)if((l|0)!=(Y(w,v)|0)){w=m+28|0;x=(l>>>0)/(w>>>0)|0;if(x>>>0>=w>>>0)if((l|0)==(Y(x,w)|0)){y=w;z=9;A=n}else{x=m+30|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+36|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+40|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+42|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+46|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+52|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+58|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+60|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+66|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+70|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+72|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+78|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+82|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+88|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+96|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+100|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+102|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+106|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+108|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+112|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+120|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+126|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+130|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+136|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+138|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+142|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+148|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+150|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+156|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+162|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+166|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+168|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+172|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+178|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+180|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+186|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+190|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+192|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+196|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+198|0;B=(l>>>0)/(x>>>0)|0;if(B>>>0<x>>>0){y=x;z=1;A=l;break}if((l|0)==(Y(B,x)|0)){y=x;z=9;A=n;break}x=m+208|0;B=(l>>>0)/(x>>>0)|0;C=B>>>0<x>>>0;D=(l|0)==(Y(B,x)|0);y=C|D?x:m+210|0;z=C?1:D?9:0;A=C?l:n}else{y=w;z=1;A=l}}else{y=v;z=9;A=n}else{y=v;z=1;A=l}}else{y=t;z=9;A=n}else{y=t;z=1;A=l}}else{y=s;z=9;A=n}else{y=s;z=1;A=l}}else{y=q;z=9;A=n}else{y=q;z=1;A=l}}else{y=p;z=9;A=n}else{y=p;z=1;A=l}}else{y=m;z=9;A=n}else{y=m;z=1;A=l}while(0);switch(z&15){case 9:{r=A;break b;break}case 0:{m=y;n=A;o=8;break}default:break c}}if(!z)r=A;else{o=107;break a}}while(0);h=g+1|0;p=(h|0)==48;q=(p&1)+j|0;i=r;j=q;g=p?0:h;k=q*210|0}if((o|0)==106){f[d>>2]=l;E=l;break}else if((o|0)==107){f[d>>2]=l;E=A;break}}else{k=zWb(145552,145744,d,c)|0;E=f[k>>2]|0}while(0);u=b;return E|0}function zWb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;d=f[c>>2]|0;c=a;e=b-a>>2;while(1){if(!e)break;a=(e|0)/2|0;b=c+(a<<2)|0;g=(f[b>>2]|0)>>>0<d>>>0;c=g?b+4|0:c;e=g?e+-1-a|0:a}return c|0}function AWb(a){a=a|0;BWb(a);return}function BWb(a){a=a|0;f[a>>2]=145944;CWb(a,0);yZb(a+28|0);PSb(f[a+32>>2]|0);PSb(f[a+36>>2]|0);PSb(f[a+48>>2]|0);PSb(f[a+60>>2]|0);return}function CWb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+32|0;d=a+36|0;e=f[a+40>>2]|0;while(1){if(!e)break;g=e+-1|0;_h[f[(f[c>>2]|0)+(g<<2)>>2]&255](b,a,f[(f[d>>2]|0)+(g<<2)>>2]|0);e=g}return}function DWb(a){a=a|0;BWb(a);O5b(a);return}function EWb(a){a=a|0;BWb(a);return}function FWb(a){a=a|0;f[a>>2]=145960;yZb(a+4|0);return}function GWb(a){a=a|0;FWb(a);O5b(a);return}function HWb(a,b){a=a|0;b=b|0;return}function IWb(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function JWb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;g=a;f[g>>2]=0;f[g+4>>2]=0;g=a+8|0;f[g>>2]=-1;f[g+4>>2]=-1;return}function KWb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=a;f[d>>2]=0;f[d+4>>2]=0;d=a+8|0;f[d>>2]=-1;f[d+4>>2]=-1;return}function LWb(a){a=a|0;return 0}function MWb(a){a=a|0;return 0}function NWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;TWb()|0;e=a+12|0;g=a+16|0;h=c;c=0;while(1){if((c|0)>=(d|0))break;i=f[e>>2]|0;j=f[g>>2]|0;if(i>>>0<j>>>0){k=j-i|0;j=d-c|0;l=(j|0)<(k|0)?j:k;VWb(h,i,l)|0;f[e>>2]=(f[e>>2]|0)+l;h=h+l|0;c=l+c|0;continue}l=di[f[(f[a>>2]|0)+40>>2]&1023](a)|0;if((l|0)==-1)break;i=WWb(l)|0;b[h>>0]=i;h=h+1|0;c=c+1|0}return c|0}function OWb(a){a=a|0;return TWb()|0}function PWb(a){a=a|0;var c=0,d=0;c=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0;if((c|0)==(TWb()|0))d=TWb()|0;else{c=a+12|0;a=f[c>>2]|0;f[c>>2]=a+1;d=UWb(b[a>>0]|0)|0}return d|0}function QWb(a,b){a=a|0;b=b|0;return TWb()|0}function RWb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=TWb()|0;g=a+24|0;h=a+28|0;i=c;c=0;while(1){if((c|0)>=(d|0))break;j=f[g>>2]|0;k=f[h>>2]|0;if(j>>>0<k>>>0){l=k-j|0;k=d-c|0;m=(k|0)<(l|0)?k:l;VWb(j,i,m)|0;f[g>>2]=(f[g>>2]|0)+m;i=i+m|0;c=m+c|0;continue}m=f[(f[a>>2]|0)+52>>2]|0;j=UWb(b[i>>0]|0)|0;if((Uh[m&1023](a,j)|0)==(e|0))break;i=i+1|0;c=c+1|0}return c|0}function SWb(a,b){a=a|0;b=b|0;return TWb()|0}function TWb(){return -1}function UWb(a){a=a|0;return a&255|0}function VWb(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)Vac(a|0,b|0,c|0)|0;return a|0}function WWb(a){a=a|0;return a&255|0}function XWb(a){a=a|0;f[a>>2]=146024;yZb(a+4|0);return}function YWb(a){a=a|0;XWb(a);O5b(a);return}function ZWb(a,b){a=a|0;b=b|0;return}function _Wb(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function $Wb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;g=a;f[g>>2]=0;f[g+4>>2]=0;g=a+8|0;f[g>>2]=-1;f[g+4>>2]=-1;return}function aXb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=a;f[d>>2]=0;f[d+4>>2]=0;d=a+8|0;f[d>>2]=-1;f[d+4>>2]=-1;return}function bXb(a){a=a|0;return 0}function cXb(a){a=a|0;return 0}function dXb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;jXb()|0;d=a+12|0;e=a+16|0;g=b;b=0;while(1){if((b|0)>=(c|0))break;h=f[d>>2]|0;i=f[e>>2]|0;if(h>>>0<i>>>0){j=i-h>>2;i=c-b|0;k=(i|0)<(j|0)?i:j;lXb(g,h,k)|0;f[d>>2]=(f[d>>2]|0)+(k<<2);g=g+(k<<2)|0;b=k+b|0;continue}k=di[f[(f[a>>2]|0)+40>>2]&1023](a)|0;if((k|0)==-1)break;h=mXb(k)|0;f[g>>2]=h;g=g+4|0;b=b+1|0}return b|0}function eXb(a){a=a|0;return jXb()|0}function fXb(a){a=a|0;var b=0,c=0;b=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0;if((b|0)==(jXb()|0))c=jXb()|0;else{b=a+12|0;a=f[b>>2]|0;f[b>>2]=a+4;c=kXb(f[a>>2]|0)|0}return c|0}function gXb(a,b){a=a|0;b=b|0;return jXb()|0}function hXb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=jXb()|0;e=a+24|0;g=a+28|0;h=b;b=0;while(1){if((b|0)>=(c|0))break;i=f[e>>2]|0;j=f[g>>2]|0;if(i>>>0<j>>>0){k=j-i>>2;j=c-b|0;l=(j|0)<(k|0)?j:k;lXb(i,h,l)|0;f[e>>2]=(f[e>>2]|0)+(l<<2);h=h+(l<<2)|0;b=l+b|0;continue}l=f[(f[a>>2]|0)+52>>2]|0;i=kXb(f[h>>2]|0)|0;if((Uh[l&1023](a,i)|0)==(d|0))break;h=h+4|0;b=b+1|0}return b|0}function iXb(a,b){a=a|0;b=b|0;return jXb()|0}function jXb(){return -1}function kXb(a){a=a|0;return a|0}function lXb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!c)d=a;else{xVb(a,b,c)|0;d=a}return d|0}function mXb(a){a=a|0;return a|0}function nXb(a){a=a|0;rXb(a,146120);AWb(a+8|0);return}function oXb(a){a=a|0;nXb(a);O5b(a);return}function pXb(a){a=a|0;nXb(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function qXb(a){a=a|0;oXb(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function rXb(a,b){a=a|0;b=b|0;return}function sXb(a){a=a|0;wXb(a,146168);EWb(a+8|0);return}function tXb(a){a=a|0;sXb(a);O5b(a);return}function uXb(a){a=a|0;sXb(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function vXb(a){a=a|0;tXb(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function wXb(a,b){a=a|0;b=b|0;return}function xXb(a){a=a|0;BXb(a,146176);AWb(a+4|0);return}function yXb(a){a=a|0;xXb(a);O5b(a);return}function zXb(a){a=a|0;xXb(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function AXb(a){a=a|0;yXb(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function BXb(a,b){a=a|0;b=b|0;return}function CXb(a){a=a|0;GXb(a,146224);EWb(a+4|0);return}function DXb(a){a=a|0;CXb(a);O5b(a);return}function EXb(a){a=a|0;CXb(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function FXb(a){a=a|0;DXb(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function GXb(a,b){a=a|0;b=b|0;return}function HXb(a){a=a|0;NXb(a,146292);AWb(a+12|0);return}function IXb(a){a=a|0;HXb(a);O5b(a);return}function JXb(a){a=a|0;HXb(a+-8|0);return}function KXb(a){a=a|0;IXb(a+-8|0);return}function LXb(a){a=a|0;HXb(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function MXb(a){a=a|0;IXb(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function NXb(a,b){a=a|0;b=b|0;BXb(a+8|0,b+12|0);rXb(a,b+4|0);return}function OXb(a){a=a|0;return kUb(a)|0}function PXb(a,c){a=a|0;c=c|0;b[a>>0]=b[c>>0]|0;return}function QXb(a,b){a=a|0;b=b|0;f[a+16>>2]=(f[a+24>>2]|0)==0|b;return}function RXb(a,b){a=a|0;b=b|0;var c=0;f[a+24>>2]=b;f[a+16>>2]=(b|0)==0&1;f[a+20>>2]=0;f[a+4>>2]=4098;f[a+12>>2]=0;f[a+8>>2]=6;b=a+28|0;c=a+32|0;a=c+40|0;do{f[c>>2]=0;c=c+4|0}while((c|0)<(a|0));B5b(b);return}function SXb(a,b){a=a|0;b=b|0;return (a|0)==(b|0)|0}function TXb(a,b){a=a|0;b=b|0;z5b(a,b+28|0);return}function UXb(a,b){a=a|0;b=b|0;return (a|0)==(b|0)|0}function VXb(a,b){a=a|0;b=b|0;return a<<24>>24==b<<24>>24|0}function WXb(a){a=a|0;var b=0;f[a>>2]=145960;B5b(a+4|0);b=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;return}function XXb(a){a=a|0;var b=0;f[a>>2]=146024;B5b(a+4|0);b=a+8|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;return}function YXb(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+16|0;h=g;b[a>>0]=0;i=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;j=f[i+16>>2]|0;if(!j){k=f[i+72>>2]|0;if(k|0)ZXb(k)|0;do if(!e?(k=c+(f[(f[c>>2]|0)+-12>>2]|0)|0,f[k+4>>2]&4096|0):0){TXb(h,k);k=xZb(h,855500)|0;yZb(h);l=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+24>>2]|0;m=k+8|0;k=l;n=(l|0)==0;o=k+12|0;p=k+16|0;q=l;while(1){if(n){r=0;s=0;break}t=f[o>>2]|0;if((t|0)==(f[p>>2]|0))v=di[f[(f[q>>2]|0)+36>>2]&1023](k)|0;else v=UWb(b[t>>0]|0)|0;t=SXb(v,TWb()|0)|0;w=t?0:l;if(t){r=0;s=0;break}t=w;x=t+12|0;y=f[x>>2]|0;z=t+16|0;if((y|0)==(f[z>>2]|0))A=di[f[(f[w>>2]|0)+36>>2]&1023](t)|0;else A=UWb(b[y>>0]|0)|0;if((A&255)<<24>>24<=-1){r=t;s=l;break}if(!(d[(f[m>>2]|0)+(A<<24>>24<<1)>>1]&8192)){r=t;s=l;break}y=f[x>>2]|0;if((y|0)==(f[z>>2]|0)){di[f[(f[w>>2]|0)+40>>2]&1023](t)|0;continue}else{f[x>>2]=y+1;UWb(b[y>>0]|0)|0;continue}}if(s|0){l=f[r+12>>2]|0;if((l|0)==(f[r+16>>2]|0))B=di[f[(f[s>>2]|0)+36>>2]&1023](r)|0;else B=UWb(b[l>>0]|0)|0;if(!(SXb(B,TWb()|0)|0))break}l=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;QXb(l,f[l+16>>2]|6)}while(0);b[a>>0]=(f[c+(f[(f[c>>2]|0)+-12>>2]|0)+16>>2]|0)==0&1}else QXb(i,j|4);u=g;return}function ZXb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;if(f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0){_Xb(d,a);if(b[d>>0]|0?(e=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0,(di[f[(f[e>>2]|0)+24>>2]&1023](e)|0)==-1):0){e=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(e,f[e+16>>2]|1)}$Xb(d)}u=c;return a|0}function _Xb(a,c){a=a|0;c=c|0;var d=0;b[a>>0]=0;f[a+4>>2]=c;d=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;if(!(f[d+16>>2]|0)){c=f[d+72>>2]|0;if(c|0)ZXb(c)|0;b[a>>0]=1}return}function $Xb(a){a=a|0;var b=0,c=0;b=a+4|0;a=f[b>>2]|0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;if((((f[c+24>>2]|0?(f[c+16>>2]|0)==0:0)?f[c+4>>2]&8192|0:0)?!(fd()|0):0)?(c=f[b>>2]|0,a=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+24>>2]|0,(di[f[(f[a>>2]|0)+24>>2]&1023](a)|0)==-1):0){a=f[b>>2]|0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(b,f[b+16>>2]|1)}return}function aYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+32|0;e=d+24|0;g=d+20|0;h=d+16|0;i=d+12|0;j=d+28|0;k=d+8|0;l=d+4|0;m=d;YXb(j,a,0);if(b[j>>0]|0){f[k>>2]=0;TXb(m,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);j=xZb(m,855524)|0;n=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;o=f[(f[j>>2]|0)+16>>2]|0;f[h>>2]=f[n+24>>2];f[i>>2]=0;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];Xf[o&127](j,g,e,n,k,l)|0;yZb(m);f[c>>2]=f[l>>2];l=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(l,f[l+16>>2]|f[k>>2])}u=d;return a|0}function bYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+20|0;g=d+16|0;h=d+12|0;i=d+8|0;j=d+24|0;k=d+4|0;l=d;YXb(j,a,0);if(b[j>>0]|0){f[k>>2]=0;TXb(l,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);j=xZb(l,855524)|0;m=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;n=f[(f[j>>2]|0)+28>>2]|0;f[h>>2]=f[m+24>>2];f[i>>2]=0;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];Xf[n&127](j,g,e,m,k,c)|0;yZb(l);l=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(l,f[l+16>>2]|f[k>>2])}u=d;return a|0}function cYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d+20|0;g=d+16|0;h=d+12|0;i=d+8|0;j=d+24|0;k=d+4|0;l=d;YXb(j,a,0);if(b[j>>0]|0){f[k>>2]=0;TXb(l,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);j=xZb(l,855524)|0;m=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;n=f[(f[j>>2]|0)+40>>2]|0;f[h>>2]=f[m+24>>2];f[i>>2]=0;f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];Xf[n&127](j,g,e,m,k,c)|0;yZb(l);l=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(l,f[l+16>>2]|f[k>>2])}u=d;return a|0}function dYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;h=a+4|0;f[h>>2]=0;YXb(g,a,1);i=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;if(b[g>>0]|0){g=f[i+24>>2]|0;j=li[f[(f[g>>2]|0)+32>>2]&511](g,c,d)|0;f[h>>2]=j;if((j|0)!=(d|0)){d=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(d,f[d+16>>2]|6)}}else QXb(i,f[i+16>>2]|4);u=e;return a|0}function eYb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;if(f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0){fYb(d,a);if(b[d>>0]|0?(e=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0,(di[f[(f[e>>2]|0)+24>>2]&1023](e)|0)==-1):0){e=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(e,f[e+16>>2]|1)}gYb(d)}u=c;return a|0}function fYb(a,c){a=a|0;c=c|0;var d=0;b[a>>0]=0;f[a+4>>2]=c;d=c+(f[(f[c>>2]|0)+-12>>2]|0)|0;if(!(f[d+16>>2]|0)){c=f[d+72>>2]|0;if(c|0)eYb(c)|0;b[a>>0]=1}return}function gYb(a){a=a|0;var b=0,c=0;b=a+4|0;a=f[b>>2]|0;c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;if((((f[c+24>>2]|0?(f[c+16>>2]|0)==0:0)?f[c+4>>2]&8192|0:0)?!(fd()|0):0)?(c=f[b>>2]|0,a=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+24>>2]|0,(di[f[(f[a>>2]|0)+24>>2]&1023](a)|0)==-1):0){a=f[b>>2]|0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(b,f[b+16>>2]|1)}return}function hYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;_Xb(h,a);if(b[h>>0]|0){TXb(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=xZb(e,855556)|0;yZb(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=TWb()|0;m=j+76|0;if(SXb(l,f[m>>2]|0)|0){TXb(e,j);l=xZb(e,855500)|0;n=Uh[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;yZb(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+12>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(nh[m&127](i,e,j,o&255,c)|0)){c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(c,f[c+16>>2]|5)}}$Xb(h);u=d;return a|0}function iYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;_Xb(h,a);if(b[h>>0]|0){TXb(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=xZb(e,855556)|0;yZb(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=TWb()|0;m=j+76|0;if(SXb(l,f[m>>2]|0)|0){TXb(e,j);l=xZb(e,855500)|0;n=Uh[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;yZb(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+16>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(nh[m&127](i,e,j,o&255,c)|0)){c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(c,f[c+16>>2]|5)}}$Xb(h);u=d;return a|0}function jYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;_Xb(h,a);if(b[h>>0]|0){TXb(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=xZb(e,855556)|0;yZb(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=TWb()|0;m=j+76|0;if(SXb(l,f[m>>2]|0)|0){TXb(e,j);l=xZb(e,855500)|0;n=Uh[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;yZb(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+24>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(nh[m&127](i,e,j,o&255,c)|0)){c=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(c,f[c+16>>2]|5)}}$Xb(h);u=d;return a|0}function kYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+16|0;g=e+12|0;h=e+8|0;i=e;_Xb(i,a);if(b[i>>0]|0){TXb(g,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);j=xZb(g,855556)|0;yZb(g);k=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;l=f[k+24>>2]|0;m=TWb()|0;n=k+76|0;if(SXb(m,f[n>>2]|0)|0){TXb(g,k);m=xZb(g,855500)|0;o=Uh[f[(f[m>>2]|0)+28>>2]&1023](m,32)|0;yZb(g);m=o<<24>>24;f[n>>2]=m;p=m}else p=f[n>>2]|0;n=f[(f[j>>2]|0)+20>>2]|0;f[h>>2]=l;f[g>>2]=f[h>>2];if(!(Xf[n&127](j,g,k,p&255,c,d)|0)){d=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(d,f[d+16>>2]|5)}}$Xb(i);u=e;return a|0}function lYb(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d;_Xb(h,a);if(b[h>>0]|0){TXb(e,a+(f[(f[a>>2]|0)+-12>>2]|0)|0);i=xZb(e,855556)|0;yZb(e);j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;k=f[j+24>>2]|0;l=TWb()|0;m=j+76|0;if(SXb(l,f[m>>2]|0)|0){TXb(e,j);l=xZb(e,855500)|0;n=Uh[f[(f[l>>2]|0)+28>>2]&1023](l,32)|0;yZb(e);l=n<<24>>24;f[m>>2]=l;o=l}else o=f[m>>2]|0;m=f[(f[i>>2]|0)+32>>2]|0;f[g>>2]=k;f[e>>2]=f[g>>2];if(!(rh[m&7](i,e,j,o&255,c)|0)){o=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(o,f[o+16>>2]|5)}}$Xb(h);u=d;return a|0}function mYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;_Xb(e,a);do if(b[e>>0]|0){g=f[a+(f[(f[a>>2]|0)+-12>>2]|0)+24>>2]|0;h=g;if(g|0){i=h+24|0;j=f[i>>2]|0;if((j|0)==(f[h+28>>2]|0)){k=f[(f[g>>2]|0)+52>>2]|0;g=UWb(c)|0;l=Uh[k&1023](h,g)|0}else{f[i>>2]=j+1;b[j>>0]=c;l=UWb(c)|0}if(!(SXb(l,TWb()|0)|0))break}j=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;QXb(j,f[j+16>>2]|1)}while(0);$Xb(e);u=d;return a|0}function nYb(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=f[b>>2]|1;return}function oYb(){qYb();return}function pYb(){return}function qYb(){rYb(0);zd(1539,1124528,x|0)|0;return}function rYb(a){a=a|0;var b=0;a=f[35442]|0;tYb(855132,a,855188);f[213613]=146092;f[213615]=146112;f[213614]=0;RXb(854460,855132);f[213633]=0;b=TWb()|0;f[213634]=b;uYb(855196,a,855252);f[213635]=146140;f[213637]=146160;f[213636]=0;RXb(854548,855196);f[213655]=0;a=jXb()|0;f[213656]=a;a=f[35474]|0;vYb(855260,a,855308);f[213657]=8220;f[213658]=8240;RXb(854632,855260);f[213676]=0;b=TWb()|0;f[213677]=b;wYb(855316,a,855364);f[213678]=146196;f[213679]=146216;RXb(854716,855316);f[213697]=0;a=jXb()|0;f[213698]=a;a=f[35349]|0;vYb(855372,a,855420);f[213699]=8220;f[213700]=8240;RXb(854800,855372);f[213718]=0;b=TWb()|0;f[213719]=b;b=f[854796+(f[(f[213699]|0)+-12>>2]|0)+24>>2]|0;f[213741]=8220;f[213742]=8240;RXb(854968,b);f[213760]=0;b=TWb()|0;f[213761]=b;wYb(855428,a,855476);f[213720]=146196;f[213721]=146216;RXb(854884,855428);f[213739]=0;a=jXb()|0;f[213740]=a;a=f[854880+(f[(f[213720]|0)+-12>>2]|0)+24>>2]|0;f[213762]=146196;f[213763]=146216;RXb(855052,a);f[213781]=0;a=jXb()|0;f[213782]=a;f[854452+(f[(f[213613]|0)+-12>>2]|0)+72>>2]=854628;f[854540+(f[(f[213635]|0)+-12>>2]|0)+72>>2]=854712;a=854796+(f[(f[213699]|0)+-12>>2]|0)+4|0;f[a>>2]=f[a>>2]|8192;a=854880+(f[(f[213720]|0)+-12>>2]|0)+4|0;f[a>>2]=f[a>>2]|8192;f[854796+(f[(f[213699]|0)+-12>>2]|0)+72>>2]=854628;f[854880+(f[(f[213720]|0)+-12>>2]|0)+72>>2]=854712;return}function sYb(a){a=a|0;ZXb(854628)|0;eYb(854712)|0;ZXb(854964)|0;eYb(855048)|0;return}function tYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;WXb(a);f[a>>2]=146520;f[a+32>>2]=c;f[a+40>>2]=d;d=TWb()|0;f[a+48>>2]=d;b[a+52>>0]=0;d=f[(f[a>>2]|0)+8>>2]|0;z5b(g,a+4|0);zh[d&2047](a,g);yZb(g);u=e;return}function uYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;XXb(a);f[a>>2]=146456;f[a+32>>2]=c;f[a+40>>2]=d;d=jXb()|0;f[a+48>>2]=d;b[a+52>>0]=0;d=f[(f[a>>2]|0)+8>>2]|0;z5b(g,a+4|0);zh[d&2047](a,g);yZb(g);u=e;return}function vYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;WXb(a);f[a>>2]=146392;f[a+32>>2]=c;z5b(g,a+4|0);c=xZb(g,857292)|0;yZb(g);f[a+36>>2]=c;f[a+40>>2]=d;d=(di[f[(f[c>>2]|0)+28>>2]&1023](c)|0)&1;b[a+44>>0]=d;u=e;return}function wYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;XXb(a);f[a>>2]=146328;f[a+32>>2]=c;z5b(g,a+4|0);c=xZb(g,857300)|0;yZb(g);f[a+36>>2]=c;f[a+40>>2]=d;d=(di[f[(f[c>>2]|0)+28>>2]&1023](c)|0)&1;b[a+44>>0]=d;u=e;return}function xYb(a){a=a|0;XWb(a);return}function yYb(a){a=a|0;xYb(a);O5b(a);return}function zYb(a,c){a=a|0;c=c|0;var d=0;di[f[(f[a>>2]|0)+24>>2]&1023](a)|0;d=xZb(c,857300)|0;f[a+36>>2]=d;c=(di[f[(f[d>>2]|0)+28>>2]&1023](d)|0)&1;b[a+44>>0]=c;return}function AYb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+16|0;c=b+8|0;d=b;e=a+36|0;g=a+40|0;h=c+8|0;i=c;j=a+32|0;a:while(1){a=f[e>>2]|0;k=nh[f[(f[a>>2]|0)+20>>2]&127](a,f[g>>2]|0,c,h,d)|0;a=(f[d>>2]|0)-i|0;if((lUb(c,1,a,f[j>>2]|0)|0)!=(a|0)){l=-1;break}switch(k|0){case 1:break;case 2:{l=-1;break a;break}default:{m=4;break a}}}if((m|0)==4)l=((AUb(f[j>>2]|0)|0)!=0)<<31>>31;u=b;return l|0}function BYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a:do if(!(b[a+44>>0]|0)){e=0;g=c;while(1){if((e|0)>=(d|0)){h=e;break a}i=f[(f[a>>2]|0)+52>>2]|0;j=kXb(f[g>>2]|0)|0;k=Uh[i&1023](a,j)|0;if((k|0)==(jXb()|0)){h=e;break a}e=e+1|0;g=g+4|0}}else h=lUb(c,4,d,f[a+32>>2]|0)|0;while(0);return h|0}function CYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;do if(!(UXb(c,jXb()|0)|0)){j=mXb(c)|0;f[g>>2]=j;j=a+32|0;if(b[a+44>>0]|0){if((lUb(g,4,1,f[j>>2]|0)|0)==1){k=15;break}l=jXb()|0;break}f[h>>2]=e;m=g+4|0;n=a+36|0;o=a+40|0;p=e+8|0;q=e;r=g;while(1){s=f[n>>2]|0;t=Di[f[(f[s>>2]|0)+12>>2]&15](s,f[o>>2]|0,r,m,i,e,p,h)|0;s=(t|0)==1;if((f[i>>2]|0)==(r|0)){k=14;break}if((t|0)==3)if((lUb(r,1,1,f[j>>2]|0)|0)==1)v=r;else{k=14;break}else{if((t|1|0)!=1){k=14;break}t=(f[h>>2]|0)-q|0;if((lUb(e,1,t,f[j>>2]|0)|0)!=(t|0)){k=14;break}v=s?f[i>>2]|0:r}if(s)r=v;else{k=13;break}}if((k|0)==13){k=15;break}else if((k|0)==14){l=jXb()|0;break}}else k=15;while(0);if((k|0)==15)l=DYb(c)|0;u=d;return l|0}function DYb(a){a=a|0;var b=0;if(UXb(a,jXb()|0)|0)b=~(jXb()|0);else b=a;return b|0}function EYb(a){a=a|0;FWb(a);return}function FYb(a){a=a|0;EYb(a);O5b(a);return}function GYb(a,c){a=a|0;c=c|0;var d=0;di[f[(f[a>>2]|0)+24>>2]&1023](a)|0;d=xZb(c,857292)|0;f[a+36>>2]=d;c=(di[f[(f[d>>2]|0)+28>>2]&1023](d)|0)&1;b[a+44>>0]=c;return}function HYb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+16|0;c=b+8|0;d=b;e=a+36|0;g=a+40|0;h=c+8|0;i=c;j=a+32|0;a:while(1){a=f[e>>2]|0;k=nh[f[(f[a>>2]|0)+20>>2]&127](a,f[g>>2]|0,c,h,d)|0;a=(f[d>>2]|0)-i|0;if((lUb(c,1,a,f[j>>2]|0)|0)!=(a|0)){l=-1;break}switch(k|0){case 1:break;case 2:{l=-1;break a;break}default:{m=4;break a}}}if((m|0)==4)l=((AUb(f[j>>2]|0)|0)!=0)<<31>>31;u=b;return l|0}function IYb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a:do if(!(b[a+44>>0]|0)){e=0;g=c;while(1){if((e|0)>=(d|0)){h=e;break a}i=f[(f[a>>2]|0)+52>>2]|0;j=UWb(b[g>>0]|0)|0;k=Uh[i&1023](a,j)|0;if((k|0)==(TWb()|0)){h=e;break a}e=e+1|0;g=g+1|0}}else h=lUb(c,1,d,f[a+32>>2]|0)|0;while(0);return h|0}function JYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;do if(!(SXb(c,TWb()|0)|0)){j=WWb(c)|0;b[g>>0]=j;j=a+32|0;if(b[a+44>>0]|0){if((lUb(g,1,1,f[j>>2]|0)|0)==1){k=15;break}l=TWb()|0;break}f[h>>2]=e;m=g+1|0;n=a+36|0;o=a+40|0;p=e+8|0;q=e;r=g;while(1){s=f[n>>2]|0;t=Di[f[(f[s>>2]|0)+12>>2]&15](s,f[o>>2]|0,r,m,i,e,p,h)|0;s=(t|0)==1;if((f[i>>2]|0)==(r|0)){k=14;break}if((t|0)==3)if((lUb(r,1,1,f[j>>2]|0)|0)==1)v=r;else{k=14;break}else{if((t|1|0)!=1){k=14;break}t=(f[h>>2]|0)-q|0;if((lUb(e,1,t,f[j>>2]|0)|0)!=(t|0)){k=14;break}v=s?f[i>>2]|0:r}if(s)r=v;else{k=13;break}}if((k|0)==13){k=15;break}else if((k|0)==14){l=TWb()|0;break}}else k=15;while(0);if((k|0)==15)l=KYb(c)|0;u=d;return l|0}function KYb(a){a=a|0;var b=0;if(SXb(a,TWb()|0)|0)b=~(TWb()|0);else b=a;return b|0}function LYb(a){a=a|0;XWb(a);return}function MYb(a){a=a|0;LYb(a);O5b(a);return}function NYb(a,c){a=a|0;c=c|0;var d=0,e=0;d=xZb(c,857300)|0;c=a+36|0;f[c>>2]=d;e=di[f[(f[d>>2]|0)+24>>2]&1023](d)|0;d=a+44|0;f[d>>2]=e;e=f[c>>2]|0;c=(di[f[(f[e>>2]|0)+28>>2]&1023](e)|0)&1;b[a+53>>0]=c;if((f[d>>2]|0)>8)S0b(486037);else return}function OYb(a){a=a|0;return RYb(a,0)|0}function PYb(a){a=a|0;return RYb(a,1)|0}function QYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;j=UXb(c,jXb()|0)|0;k=a+52|0;l=(b[k>>0]|0)!=0;m=a+48|0;do if(j)if(l)n=c;else{o=f[m>>2]|0;p=((UXb(o,jXb()|0)|0)^1)&1;b[k>>0]=p;n=o}else{if(l){o=mXb(f[m>>2]|0)|0;f[h>>2]=o;o=f[a+36>>2]|0;switch(Di[f[(f[o>>2]|0)+12>>2]&15](o,f[a+40>>2]|0,h,h+4|0,i,e,e+8|0,g)|0){case 1:case 2:{q=10;break}case 3:{b[e>>0]=f[m>>2];f[g>>2]=e+1;q=7;break}default:q=7}a:do if((q|0)==7){o=a+32|0;while(1){p=f[g>>2]|0;if(p>>>0<=e>>>0){r=1;s=0;break a}t=p+-1|0;f[g>>2]=t;if((NUb(b[t>>0]|0,f[o>>2]|0)|0)==-1){q=10;break}}}while(0);if((q|0)==10){r=0;s=jXb()|0}if(!r){n=s;break}}f[m>>2]=c;b[k>>0]=1;n=c}while(0);u=d;return n|0}function RYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;j=a+52|0;k=a+48|0;if(b[j>>0]|0){l=f[k>>2]|0;if(c){m=jXb()|0;f[k>>2]=m;b[j>>0]=0;n=l}else n=l}else{l=f[a+44>>2]|0;j=(l|0)>1?l:1;l=a+32|0;m=0;while(1){if((m|0)>=(j|0)){o=9;break}p=DUb(f[l>>2]|0)|0;if((p|0)==-1){o=8;break}b[e+m>>0]=p;m=m+1|0}if((o|0)==8)q=jXb()|0;else if((o|0)==9){do if(!(b[a+53>>0]|0)){m=a+40|0;p=a+36|0;r=g+4|0;s=j;a:while(1){t=f[m>>2]|0;v=t;w=f[v>>2]|0;x=f[v+4>>2]|0;v=f[p>>2]|0;y=e+s|0;switch(Di[f[(f[v>>2]|0)+16>>2]&15](v,t,e,y,h,g,r,i)|0){case 3:{o=16;break a;break}case 2:{o=18;break a;break}case 1:break;default:break a}t=f[m>>2]|0;f[t>>2]=w;f[t+4>>2]=x;if((s|0)==8){o=18;break}x=DUb(f[l>>2]|0)|0;if((x|0)==-1){o=18;break}b[y>>0]=x;s=s+1|0}if((o|0)==16)f[g>>2]=b[e>>0];else if((o|0)==18){z=jXb()|0;break}A=s;o=19}else{f[g>>2]=b[e>>0];A=j;o=19}while(0);b:do if((o|0)==19){c:do if(c){j=kXb(f[g>>2]|0)|0;f[k>>2]=j}else{j=A;do{if((j|0)<=0)break c;j=j+-1|0;i=kXb(b[e+j>>0]|0)|0}while((NUb(i,f[l>>2]|0)|0)!=-1);z=jXb()|0;break b}while(0);z=kXb(f[g>>2]|0)|0}while(0);q=z}n=q}u=d;return n|0}function SYb(a){a=a|0;FWb(a);return}function TYb(a){a=a|0;SYb(a);O5b(a);return}function UYb(a,c){a=a|0;c=c|0;var d=0,e=0;d=xZb(c,857292)|0;c=a+36|0;f[c>>2]=d;e=di[f[(f[d>>2]|0)+24>>2]&1023](d)|0;d=a+44|0;f[d>>2]=e;e=f[c>>2]|0;c=(di[f[(f[e>>2]|0)+28>>2]&1023](e)|0)&1;b[a+53>>0]=c;if((f[d>>2]|0)>8)S0b(486037);else return}function VYb(a){a=a|0;return YYb(a,0)|0}function WYb(a){a=a|0;return YYb(a,1)|0}function XYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+32|0;e=d+16|0;g=d+4|0;h=d+8|0;i=d;j=SXb(c,TWb()|0)|0;k=a+52|0;l=(b[k>>0]|0)!=0;m=a+48|0;do if(j)if(l)n=c;else{o=f[m>>2]|0;p=((SXb(o,TWb()|0)|0)^1)&1;b[k>>0]=p;n=o}else{if(l){o=WWb(f[m>>2]|0)|0;b[h>>0]=o;o=f[a+36>>2]|0;switch(Di[f[(f[o>>2]|0)+12>>2]&15](o,f[a+40>>2]|0,h,h+1|0,i,e,e+8|0,g)|0){case 1:case 2:{q=10;break}case 3:{b[e>>0]=f[m>>2];f[g>>2]=e+1;q=7;break}default:q=7}a:do if((q|0)==7){o=a+32|0;while(1){p=f[g>>2]|0;if(p>>>0<=e>>>0){r=1;s=0;break a}t=p+-1|0;f[g>>2]=t;if((NUb(b[t>>0]|0,f[o>>2]|0)|0)==-1){q=10;break}}}while(0);if((q|0)==10){r=0;s=TWb()|0}if(!r){n=s;break}}f[m>>2]=c;b[k>>0]=1;n=c}while(0);u=d;return n|0}function YYb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;j=a+52|0;k=a+48|0;if(b[j>>0]|0){l=f[k>>2]|0;if(c){m=TWb()|0;f[k>>2]=m;b[j>>0]=0;n=l}else n=l}else{l=f[a+44>>2]|0;j=(l|0)>1?l:1;l=a+32|0;m=0;while(1){if((m|0)>=(j|0)){o=9;break}p=DUb(f[l>>2]|0)|0;if((p|0)==-1){o=8;break}b[e+m>>0]=p;m=m+1|0}if((o|0)==8)q=TWb()|0;else if((o|0)==9){do if(!(b[a+53>>0]|0)){m=a+40|0;p=a+36|0;r=g+1|0;s=j;a:while(1){t=f[m>>2]|0;v=t;w=f[v>>2]|0;x=f[v+4>>2]|0;v=f[p>>2]|0;y=e+s|0;switch(Di[f[(f[v>>2]|0)+16>>2]&15](v,t,e,y,h,g,r,i)|0){case 3:{o=16;break a;break}case 2:{o=18;break a;break}case 1:break;default:break a}t=f[m>>2]|0;f[t>>2]=w;f[t+4>>2]=x;if((s|0)==8){o=18;break}x=DUb(f[l>>2]|0)|0;if((x|0)==-1){o=18;break}b[y>>0]=x;s=s+1|0}if((o|0)==16)b[g>>0]=b[e>>0]|0;else if((o|0)==18){z=TWb()|0;break}A=s;o=19}else{b[g>>0]=b[e>>0]|0;A=j;o=19}while(0);b:do if((o|0)==19){c:do if(c){j=UWb(b[g>>0]|0)|0;f[k>>2]=j}else{j=A;do{if((j|0)<=0)break c;j=j+-1|0;i=UWb(b[e+j>>0]|0)|0}while((NUb(i,f[l>>2]|0)|0)!=-1);z=TWb()|0;break b}while(0);z=UWb(b[g>>0]|0)|0}while(0);q=z}n=q}u=d;return n|0}function ZYb(a){a=a|0;dZb(a);return}function _Yb(a){a=a|0;ZYb(a);O5b(a);return}function $Yb(a){a=a|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function aZb(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=e;e=c;while(1){if((a|0)==(f|0)){g=7;break}if((e|0)==(d|0)){h=-1;break}c=b[e>>0]|0;i=b[a>>0]|0;if(c<<24>>24<i<<24>>24){h=-1;break}if(i<<24>>24<c<<24>>24){h=1;break}a=a+1|0;e=e+1|0}if((g|0)==7)h=(e|0)!=(d|0)&1;return h|0}function bZb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;g=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=e-d|0;if(h>>>0>4294967279)V5b(a);if(h>>>0<11){b[a+11>>0]=h;i=a}else{j=h+16&-16;k=L5b(j)|0;f[a>>2]=k;f[a+8>>2]=j|-2147483648;f[a+4>>2]=h;i=k}k=d;d=i;while(1){if((k|0)==(e|0))break;PXb(d,k);k=k+1|0;d=d+1|0}b[g>>0]=0;PXb(i+h|0,g);u=c;return}function cZb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;a=0;e=c;while(1){if((e|0)==(d|0))break;c=(b[e>>0]|0)+(a<<4)|0;f=c&-268435456;a=(f>>>24|f)^c;e=e+1|0}return a|0}function dZb(a){a=a|0;return}function eZb(a){a=a|0;dZb(a);return}function fZb(a){a=a|0;eZb(a);O5b(a);return}function gZb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a=d;d=b;while(1){if((a|0)==(e|0)){g=7;break}if((d|0)==(c|0)){h=-1;break}b=f[d>>2]|0;i=f[a>>2]|0;if((b|0)<(i|0)){h=-1;break}if((i|0)<(b|0)){h=1;break}a=a+4|0;d=d+4|0}if((g|0)==7)h=(d|0)!=(c|0)&1;return h|0}function hZb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;g=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=e-d>>2;if(h>>>0>1073741807)V5b(a);do if(h>>>0>=2){i=h+4&-4;if(i>>>0>1073741823)Re();else{j=L5b(i<<2)|0;f[a>>2]=j;f[a+8>>2]=i|-2147483648;f[a+4>>2]=h;k=d;l=j;break}}else{b[a+8+3>>0]=h;k=d;l=a}while(0);while(1){if((k|0)==(e|0))break;jZb(l,k);k=k+4|0;l=l+4|0}f[g>>2]=0;jZb(l,g);u=c;return}function iZb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=0;d=b;while(1){if((d|0)==(c|0))break;b=(f[d>>2]|0)+(a<<4)|0;e=b&-268435456;a=(e>>>24|e)^b;d=d+4|0}return a|0}function jZb(a,b){a=a|0;b=b|0;f[a>>2]=f[b>>2];return}function kZb(a){a=a|0;dZb(a);return}function lZb(a){a=a|0;dZb(a);O5b(a);return}function mZb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=u;u=u+48|0;j=i+40|0;k=i+16|0;l=i+8|0;m=i+12|0;n=i+4|0;o=i;if(!(f[e+4>>2]&1)){f[l>>2]=-1;p=f[(f[a>>2]|0)+16>>2]|0;f[m>>2]=f[c>>2];f[n>>2]=f[d>>2];f[k>>2]=f[m>>2];f[j>>2]=f[n>>2];n=Xf[p&127](a,k,j,e,g,l)|0;f[c>>2]=n;switch(f[l>>2]|0){case 0:{b[h>>0]=0;break}case 1:{b[h>>0]=1;break}default:{b[h>>0]=1;f[g>>2]=4}}q=f[c>>2]|0}else{TXb(j,e);l=xZb(j,855500)|0;yZb(j);TXb(j,e);e=xZb(j,855516)|0;yZb(j);zh[f[(f[e>>2]|0)+24>>2]&2047](k,e);zh[f[(f[e>>2]|0)+28>>2]&2047](k+12|0,e);f[o>>2]=f[d>>2];d=k+24|0;f[j>>2]=f[o>>2];o=(d_b(c,j,k,d,l,g,1)|0)==(k|0)&1;b[h>>0]=o;o=f[c>>2]|0;c=d;do{c=c+-12|0;Z5b(c)}while((c|0)!=(k|0));q=o}u=i;return q|0}function nZb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=b_b(a,j,i,d,e,g)|0;u=h;return l|0}function oZb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=$Zb(a,j,i,d,e,g)|0;u=h;return l|0}function pZb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=ZZb(a,j,i,d,e,g)|0;u=h;return l|0}function qZb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=XZb(a,j,i,d,e,g)|0;u=h;return l|0}function rZb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=VZb(a,j,i,d,e,g)|0;u=h;return l|0}function sZb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=RZb(a,j,i,d,e,g)|0;u=h;return l|0}function tZb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=PZb(a,j,i,d,e,g)|0;u=h;return l|0}function uZb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=NZb(a,j,i,d,e,g)|0;u=h;return l|0}function vZb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=IZb(a,j,i,d,e,g)|0;u=h;return l|0}function wZb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;a=u;u=u+240|0;i=a;j=a+204|0;k=a+192|0;l=a+180|0;m=a+176|0;n=a+16|0;o=a+8|0;p=a+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[k+(q<<2)>>2]=0;q=q+1|0}TXb(l,e);e=xZb(l,855500)|0;Dg[f[(f[e>>2]|0)+32>>2]&127](e,486185,486211,j)|0;yZb(l);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;q=l+8|0;if((b[e>>0]|0)<0)r=(f[q>>2]&2147483647)+-1|0;else r=10;e6b(l,r,0);r=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=r;f[o>>2]=n;f[p>>2]=0;s=l+4|0;t=f[c>>2]|0;v=r;r=t;w=t;a:while(1){if(r){t=f[r+12>>2]|0;if((t|0)==(f[r+16>>2]|0))x=di[f[(f[r>>2]|0)+36>>2]&1023](r)|0;else x=UWb(b[t>>0]|0)|0;if(SXb(x,TWb()|0)|0){f[c>>2]=0;y=0;z=0;A=1}else{y=r;z=w;A=0}}else{y=0;z=0;A=1}t=f[d>>2]|0;do if(t){B=f[t+12>>2]|0;if((B|0)==(f[t+16>>2]|0))C=di[f[(f[t>>2]|0)+36>>2]&1023](t)|0;else C=UWb(b[B>>0]|0)|0;if(!(SXb(C,TWb()|0)|0))if(A){D=t;break}else{E=v;F=t;break a}else{f[d>>2]=0;G=22;break}}else G=22;while(0);if((G|0)==22){G=0;if(A){E=v;F=0;break}else D=0}t=b[e>>0]|0;B=t<<24>>24<0?f[s>>2]|0:t&255;if((f[m>>2]|0)==(v+B|0)){e6b(l,B<<1,0);if((b[e>>0]|0)<0)H=(f[q>>2]&2147483647)+-1|0;else H=10;e6b(l,H,0);t=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=t+B;I=t}else I=v;t=y+12|0;B=f[t>>2]|0;J=y+16|0;if((B|0)==(f[J>>2]|0))K=di[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else K=UWb(b[B>>0]|0)|0;if(zZb(K&255,16,I,m,p,0,k,n,o,j)|0){E=I;F=D;break}B=f[t>>2]|0;if((B|0)==(f[J>>2]|0)){di[f[(f[y>>2]|0)+40>>2]&1023](y)|0;v=I;r=y;w=z;continue}else{f[t>>2]=B+1;UWb(b[B>>0]|0)|0;v=I;r=y;w=z;continue}}e6b(l,(f[m>>2]|0)-E|0,0);E=(b[e>>0]|0)<0?f[l>>2]|0:l;e=AZb()|0;f[i>>2]=h;if((BZb(E,e,486218,i)|0)!=1)f[g>>2]=4;if(y){i=f[y+12>>2]|0;if((i|0)==(f[y+16>>2]|0))L=di[f[(f[z>>2]|0)+36>>2]&1023](y)|0;else L=UWb(b[i>>0]|0)|0;if(SXb(L,TWb()|0)|0){f[c>>2]=0;M=1}else M=0}else M=1;do if(F){L=f[F+12>>2]|0;if((L|0)==(f[F+16>>2]|0))N=di[f[(f[F>>2]|0)+36>>2]&1023](F)|0;else N=UWb(b[L>>0]|0)|0;if(!(SXb(N,TWb()|0)|0))if(M)break;else{G=51;break}else{f[d>>2]=0;G=49;break}}else G=49;while(0);if((G|0)==49?M:0)G=51;if((G|0)==51)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(l);Z5b(k);u=a;return g|0}function xZb(a,b){a=a|0;b=b|0;var c=0;c=f[a>>2]|0;return DZb(c,CZb(b)|0)|0}function yZb(a){a=a|0;I5b(f[a>>2]|0)|0;return}function zZb(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=f[e>>2]|0;n=(m|0)==(d|0);do if(n){o=(b[l+24>>0]|0)==a<<24>>24;if(!o?(b[l+25>>0]|0)!=a<<24>>24:0){p=5;break}f[e>>2]=d+1;b[d>>0]=o?43:45;f[g>>2]=0;q=0}else p=5;while(0);a:do if((p|0)==5){o=b[i+11>>0]|0;if(a<<24>>24==h<<24>>24?((o<<24>>24<0?f[i+4>>2]|0:o&255)|0)!=0:0){o=f[k>>2]|0;if((o-j|0)>=160){q=0;break}r=f[g>>2]|0;f[k>>2]=o+4;f[o>>2]=r;f[g>>2]=0;q=0;break}r=l+26|0;o=0;while(1){s=l+o|0;if((o|0)==26){t=r;break}if((b[s>>0]|0)==a<<24>>24){t=s;break}else o=o+1|0}o=t-l|0;if((o|0)>23)q=-1;else{r=486185+o|0;switch(c|0){case 10:case 8:{if((o|0)>=(c|0)){q=-1;break a}break}case 16:{if((o|0)>=22){if(n){q=-1;break a}if((m-d|0)>=3){q=-1;break a}if((b[m+-1>>0]|0)!=48){q=-1;break a}f[g>>2]=0;o=b[r>>0]|0;f[e>>2]=m+1;b[m>>0]=o;q=0;break a}break}default:{}}o=b[r>>0]|0;f[e>>2]=m+1;b[m>>0]=o;f[g>>2]=(f[g>>2]|0)+1;q=0}}while(0);return q|0}function AZb(){var a=0;if((b[499344]|0)==0?Cac(499344)|0:0){a=yVb(2147483647,486221,0)|0;f[213877]=a}return f[213877]|0}function BZb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=oVb(b)|0;b=OUb(a,c,g)|0;if(d|0)oVb(d)|0;u=e;return b|0}function CZb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+48|0;c=b+32|0;d=b+24|0;e=b;g=b+16|0;f[g>>2]=1540;f[g+4>>2]=0;f[c>>2]=f[g>>2];f[c+4>>2]=f[g+4>>2];FZb(e,c,a);if((f[a>>2]|0)!=-1){f[c>>2]=e;f[d>>2]=c;K5b(a,d,1541)}u=b;return (f[a+4>>2]|0)+-1|0}function DZb(a,b){a=a|0;b=b|0;return f[(f[a+8>>2]|0)+(b<<2)>>2]|0}function EZb(a){a=a|0;var b=0;b=f[213878]|0;f[213878]=b+1;f[a+4>>2]=b+1;return}function FZb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[b>>2]|0;e=f[b+4>>2]|0;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=e;return}function GZb(a){a=a|0;HZb(f[f[a>>2]>>2]|0);return}function HZb(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=f[a+8>>2]|0;d=(f[a>>2]|0)+(c>>1)|0;if(!(c&1))e=b;else e=f[(f[d>>2]|0)+b>>2]|0;bi[e&2047](d);return}function IZb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+240|0;i=a+200|0;j=a+199|0;k=a+198|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+197|0;t=a+196|0;JZb(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;e6b(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=di[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else B=UWb(b[y>>0]|0)|0;if(SXb(B,TWb()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=di[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else G=UWb(b[F>>0]|0)|0;if(!(SXb(G,TWb()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[n>>2]|0)==(z+F|0)){e6b(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;e6b(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=di[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else O=UWb(b[F>>0]|0)|0;if(KZb(O&255,s,t,M,n,b[j>>0]|0,b[k>>0]|0,l,o,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){di[f[(f[C>>2]|0)+40>>2]&1023](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+1;UWb(b[F>>0]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+LZb(I,f[n>>2]|0,g);p[h>>3]=P;MZb(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=di[f[(f[D>>2]|0)+36>>2]&1023](C)|0;else Q=UWb(b[q>>0]|0)|0;if(SXb(Q,TWb()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=di[f[(f[J>>2]|0)+36>>2]&1023](J)|0;else S=UWb(b[Q>>0]|0)|0;if(!(SXb(S,TWb()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(m);Z5b(l);u=a;return g|0}function JZb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;TXb(i,c);c=xZb(i,855500)|0;Dg[f[(f[c>>2]|0)+32>>2]&127](c,486185,486217,d)|0;d=xZb(i,855516)|0;c=di[f[(f[d>>2]|0)+12>>2]&1023](d)|0;b[e>>0]=c;c=di[f[(f[d>>2]|0)+16>>2]&1023](d)|0;b[g>>0]=c;zh[f[(f[d>>2]|0)+20>>2]&2047](a,d);yZb(i);u=h;return}function KZb(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0;o=k;a:do if(a<<24>>24==h<<24>>24)if(b[c>>0]|0){b[c>>0]=0;k=f[g>>2]|0;f[g>>2]=k+1;b[k>>0]=46;k=b[j+11>>0]|0;if(((k<<24>>24<0?f[j+4>>2]|0:k&255)|0)!=0?(k=f[l>>2]|0,(k-o|0)<160):0){p=f[m>>2]|0;f[l>>2]=k+4;f[k>>2]=p;q=0}else q=0}else q=-1;else{if(a<<24>>24==i<<24>>24?(p=b[j+11>>0]|0,(p<<24>>24<0?f[j+4>>2]|0:p&255)|0):0){if(!(b[c>>0]|0)){q=-1;break}p=f[l>>2]|0;if((p-o|0)>=160){q=0;break}k=f[m>>2]|0;f[l>>2]=p+4;f[p>>2]=k;f[m>>2]=0;q=0;break}k=n+32|0;p=0;while(1){r=n+p|0;if((p|0)==32){s=k;break}if((b[r>>0]|0)==a<<24>>24){s=r;break}else p=p+1|0}p=s-n|0;if((p|0)>31)q=-1;else{k=b[486185+p>>0]|0;switch(p|0){case 24:case 25:{r=f[g>>2]|0;if((r|0)!=(e|0)?(b[r+-1>>0]&95)!=(b[d>>0]&127):0){q=-1;break a}f[g>>2]=r+1;b[r>>0]=k;q=0;break a;break}case 23:case 22:{b[d>>0]=80;r=f[g>>2]|0;f[g>>2]=r+1;b[r>>0]=k;q=0;break a;break}default:{r=k&95;if((((r|0)==(b[d>>0]|0)?(b[d>>0]=r|128,b[c>>0]|0):0)?(b[c>>0]=0,r=b[j+11>>0]|0,(r<<24>>24<0?f[j+4>>2]|0:r&255)|0):0)?(r=f[l>>2]|0,(r-o|0)<160):0){t=f[m>>2]|0;f[l>>2]=r+4;f[r>>2]=t}t=f[g>>2]|0;f[g>>2]=t+1;b[t>>0]=k;if((p|0)>21){q=0;break a}f[m>>2]=(f[m>>2]|0)+1;q=0;break a}}}}while(0);return q|0}function LZb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0;d=u;u=u+16|0;e=d;if((a|0)==(b|0)){f[c>>2]=4;g=0.0}else{h=ZSb()|0;i=f[h>>2]|0;h=ZSb()|0;f[h>>2]=0;j=+TVb(a,e,AZb()|0);a=ZSb()|0;h=f[a>>2]|0;if(!h){a=ZSb()|0;f[a>>2]=i}if((f[e>>2]|0)==(b|0))if((h|0)==34){k=j;l=6}else m=j;else{k=0.0;l=6}if((l|0)==6){f[c>>2]=4;m=k}g=m}u=d;return +g}function MZb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=b[a+11>>0]|0;h=g<<24>>24<0;i=a+4|0;j=f[i>>2]|0;k=g&255;do if((h?j:k)|0){if((c|0)==(d|0))l=j;else{g=d;m=c;while(1){n=g+-4|0;if(m>>>0>=n>>>0)break;o=f[m>>2]|0;f[m>>2]=f[n>>2];f[n>>2]=o;g=n;m=m+4|0}l=f[i>>2]|0}m=h?f[a>>2]|0:a;g=d+-4|0;n=m+(h?l:k)|0;o=c;p=m;while(1){q=b[p>>0]|0;r=q<<24>>24>0&q<<24>>24!=127;if(o>>>0>=g>>>0)break;if(r?(q<<24>>24|0)!=(f[o>>2]|0):0){s=10;break}o=o+4|0;p=(n-p|0)>1?p+1|0:p}if((s|0)==10){f[e>>2]=4;break}if(r?((f[g>>2]|0)+-1|0)>>>0>=q<<24>>24>>>0:0)f[e>>2]=4}while(0);return}function NZb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+240|0;i=a+200|0;j=a+199|0;k=a+198|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+197|0;t=a+196|0;JZb(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;e6b(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=di[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else B=UWb(b[y>>0]|0)|0;if(SXb(B,TWb()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=di[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else G=UWb(b[F>>0]|0)|0;if(!(SXb(G,TWb()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[n>>2]|0)==(z+F|0)){e6b(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;e6b(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=di[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else O=UWb(b[F>>0]|0)|0;if(KZb(O&255,s,t,M,n,b[j>>0]|0,b[k>>0]|0,l,o,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){di[f[(f[C>>2]|0)+40>>2]&1023](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+1;UWb(b[F>>0]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+OZb(I,f[n>>2]|0,g);p[h>>3]=P;MZb(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=di[f[(f[D>>2]|0)+36>>2]&1023](C)|0;else Q=UWb(b[q>>0]|0)|0;if(SXb(Q,TWb()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=di[f[(f[J>>2]|0)+36>>2]&1023](J)|0;else S=UWb(b[Q>>0]|0)|0;if(!(SXb(S,TWb()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(m);Z5b(l);u=a;return g|0}function OZb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0;d=u;u=u+16|0;e=d;if((a|0)==(b|0)){f[c>>2]=4;g=0.0}else{h=ZSb()|0;i=f[h>>2]|0;h=ZSb()|0;f[h>>2]=0;j=+SVb(a,e,AZb()|0);a=ZSb()|0;h=f[a>>2]|0;if(!h){a=ZSb()|0;f[a>>2]=i}if((f[e>>2]|0)==(b|0))if((h|0)==34){k=j;l=6}else m=j;else{k=0.0;l=6}if((l|0)==6){f[c>>2]=4;m=k}g=m}u=d;return +g}function PZb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+240|0;i=a+200|0;j=a+199|0;k=a+198|0;l=a+184|0;m=a+172|0;o=a+168|0;p=a+8|0;q=a+4|0;r=a;s=a+197|0;t=a+196|0;JZb(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;e6b(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=w;f[q>>2]=p;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=di[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else B=UWb(b[y>>0]|0)|0;if(SXb(B,TWb()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=di[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else G=UWb(b[F>>0]|0)|0;if(!(SXb(G,TWb()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[o>>2]|0)==(z+F|0)){e6b(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;e6b(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=di[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else O=UWb(b[F>>0]|0)|0;if(KZb(O&255,s,t,M,o,b[j>>0]|0,b[k>>0]|0,l,p,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){di[f[(f[C>>2]|0)+40>>2]&1023](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+1;UWb(b[F>>0]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-p|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+QZb(I,f[o>>2]|0,g);n[h>>2]=P;MZb(l,p,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=di[f[(f[D>>2]|0)+36>>2]&1023](C)|0;else Q=UWb(b[q>>0]|0)|0;if(SXb(Q,TWb()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=di[f[(f[J>>2]|0)+36>>2]&1023](J)|0;else S=UWb(b[Q>>0]|0)|0;if(!(SXb(S,TWb()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(m);Z5b(l);u=a;return g|0}function QZb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0.0,h=0,i=0,j=0.0,k=0.0,l=0,m=0.0;d=u;u=u+16|0;e=d;if((a|0)==(b|0)){f[c>>2]=4;g=0.0}else{h=ZSb()|0;i=f[h>>2]|0;h=ZSb()|0;f[h>>2]=0;j=+RVb(a,e,AZb()|0);a=ZSb()|0;h=f[a>>2]|0;if(!h){a=ZSb()|0;f[a>>2]=i}if((f[e>>2]|0)==(b|0))if((h|0)==34){k=j;l=6}else m=j;else{k=0.0;l=6}if((l|0)==6){f[c>>2]=4;m=k}g=m}u=d;return +g}function RZb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=SZb(e)|0;TZb(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;e6b(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=di[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=UWb(b[v>>0]|0)|0;if(SXb(y,TWb()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=di[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=UWb(b[C>>0]|0)|0;if(!(SXb(D,TWb()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){e6b(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;e6b(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;K=v}else K=w;v=z+12|0;C=f[v>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=di[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else M=UWb(b[C>>0]|0)|0;if(zZb(M&255,q,K,m,p,b[j>>0]|0,k,n,o,i)|0){F=K;G=E;break}C=f[v>>2]|0;if((C|0)==(f[L>>2]|0)){di[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=K;s=z;x=A;continue}else{f[v>>2]=C+1;UWb(b[C>>0]|0)|0;w=K;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=UZb(F,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=s;f[q+4>>2]=J;MZb(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=di[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else N=UWb(b[o>>0]|0)|0;if(SXb(N,TWb()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=di[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else P=UWb(b[N>>0]|0)|0;if(!(SXb(P,TWb()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(l);Z5b(k);u=a;return g|0}function SZb(a){a=a|0;var b=0;switch(f[a+4>>2]&74){case 64:{b=8;break}case 8:{b=16;break}case 0:{b=0;break}default:b=10}return b|0}function TZb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;TXb(h,c);c=xZb(h,855500)|0;Dg[f[(f[c>>2]|0)+32>>2]&127](c,486185,486211,d)|0;d=xZb(h,855516)|0;c=di[f[(f[d>>2]|0)+16>>2]&1023](d)|0;b[e>>0]=c;zh[f[(f[d>>2]|0)+20>>2]&2047](a,d);yZb(h);u=g;return}function UZb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0;j=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;j=0;break}k=ZSb()|0;l=f[k>>2]|0;k=ZSb()|0;f[k>>2]=0;k=lWb(a,h,e,AZb()|0)|0;m=J;n=ZSb()|0;o=f[n>>2]|0;if(!o){n=ZSb()|0;f[n>>2]=l}if((f[h>>2]|0)==(c|0))if((o|0)==34){p=-1;q=-1;r=8}else{s=k;t=m}else{p=0;q=0;r=8}if((r|0)==8){f[d>>2]=4;s=p;t=q}i=t;j=s}while(0);J=i;u=g;return j|0}function VZb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=SZb(e)|0;TZb(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;e6b(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=di[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=UWb(b[v>>0]|0)|0;if(SXb(y,TWb()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=di[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=UWb(b[C>>0]|0)|0;if(!(SXb(D,TWb()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){e6b(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;e6b(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=di[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else L=UWb(b[C>>0]|0)|0;if(zZb(L&255,q,J,m,p,b[j>>0]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){di[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+1;UWb(b[C>>0]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=WZb(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;MZb(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=di[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else M=UWb(b[o>>0]|0)|0;if(SXb(M,TWb()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=di[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else O=UWb(b[M>>0]|0)|0;if(!(SXb(O,TWb()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(l);Z5b(k);u=a;return g|0}function WZb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;break}j=ZSb()|0;k=f[j>>2]|0;j=ZSb()|0;f[j>>2]=0;j=lWb(a,h,e,AZb()|0)|0;l=J;m=ZSb()|0;n=f[m>>2]|0;if(!n){m=ZSb()|0;f[m>>2]=k}do if((f[h>>2]|0)==(c|0))if(l>>>0>0|(l|0)==0&j>>>0>4294967295|(n|0)==34){f[d>>2]=4;o=-1;break}else{o=j;break}else{f[d>>2]=4;o=0}while(0);i=o}while(0);u=g;return i|0}function XZb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=SZb(e)|0;TZb(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;e6b(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=di[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=UWb(b[v>>0]|0)|0;if(SXb(y,TWb()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=di[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=UWb(b[C>>0]|0)|0;if(!(SXb(D,TWb()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){e6b(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;e6b(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=di[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else L=UWb(b[C>>0]|0)|0;if(zZb(L&255,q,J,m,p,b[j>>0]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){di[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+1;UWb(b[C>>0]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=YZb(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;MZb(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=di[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else M=UWb(b[o>>0]|0)|0;if(SXb(M,TWb()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=di[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else O=UWb(b[M>>0]|0)|0;if(!(SXb(O,TWb()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(l);Z5b(k);u=a;return g|0}function YZb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;break}j=ZSb()|0;k=f[j>>2]|0;j=ZSb()|0;f[j>>2]=0;j=lWb(a,h,e,AZb()|0)|0;l=J;m=ZSb()|0;n=f[m>>2]|0;if(!n){m=ZSb()|0;f[m>>2]=k}do if((f[h>>2]|0)==(c|0))if(l>>>0>0|(l|0)==0&j>>>0>4294967295|(n|0)==34){f[d>>2]=4;o=-1;break}else{o=j;break}else{f[d>>2]=4;o=0}while(0);i=o}while(0);u=g;return i|0}function ZZb(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+224|0;j=a+198|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;p=a+4|0;q=a;r=SZb(g)|0;TZb(l,g,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[m+(g<<2)>>2]=0;g=g+1|0}g=m+11|0;s=m+8|0;if((b[g>>0]|0)<0)t=(f[s>>2]&2147483647)+-1|0;else t=10;e6b(m,t,0);t=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=t;f[p>>2]=o;f[q>>2]=0;v=m+4|0;w=f[c>>2]|0;x=t;t=w;y=w;a:while(1){if(t){w=f[t+12>>2]|0;if((w|0)==(f[t+16>>2]|0))z=di[f[(f[t>>2]|0)+36>>2]&1023](t)|0;else z=UWb(b[w>>0]|0)|0;if(SXb(z,TWb()|0)|0){f[c>>2]=0;A=0;B=0;C=1}else{A=t;B=y;C=0}}else{A=0;B=0;C=1}w=f[e>>2]|0;do if(w){D=f[w+12>>2]|0;if((D|0)==(f[w+16>>2]|0))E=di[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else E=UWb(b[D>>0]|0)|0;if(!(SXb(E,TWb()|0)|0))if(C){F=w;break}else{G=x;H=w;break a}else{f[e>>2]=0;I=19;break}}else I=19;while(0);if((I|0)==19){I=0;if(C){G=x;H=0;break}else F=0}w=b[g>>0]|0;D=w<<24>>24<0?f[v>>2]|0:w&255;if((f[n>>2]|0)==(x+D|0)){e6b(m,D<<1,0);if((b[g>>0]|0)<0)J=(f[s>>2]&2147483647)+-1|0;else J=10;e6b(m,J,0);w=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w+D;K=w}else K=x;w=A+12|0;D=f[w>>2]|0;L=A+16|0;if((D|0)==(f[L>>2]|0))M=di[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else M=UWb(b[D>>0]|0)|0;if(zZb(M&255,r,K,n,q,b[k>>0]|0,l,o,p,j)|0){G=K;H=F;break}D=f[w>>2]|0;if((D|0)==(f[L>>2]|0)){di[f[(f[A>>2]|0)+40>>2]&1023](A)|0;x=K;t=A;y=B;continue}else{f[w>>2]=D+1;UWb(b[D>>0]|0)|0;x=K;t=A;y=B;continue}}y=b[l+11>>0]|0;if((y<<24>>24<0?f[l+4>>2]|0:y&255)|0?(y=f[p>>2]|0,(y-o|0)<160):0){t=f[q>>2]|0;f[p>>2]=y+4;f[y>>2]=t}t=_Zb(G,f[n>>2]|0,h,r)|0;d[i>>1]=t;MZb(l,o,f[p>>2]|0,h);if(A){p=f[A+12>>2]|0;if((p|0)==(f[A+16>>2]|0))N=di[f[(f[B>>2]|0)+36>>2]&1023](A)|0;else N=UWb(b[p>>0]|0)|0;if(SXb(N,TWb()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(H){N=f[H+12>>2]|0;if((N|0)==(f[H+16>>2]|0))P=di[f[(f[H>>2]|0)+36>>2]&1023](H)|0;else P=UWb(b[N>>0]|0)|0;if(!(SXb(P,TWb()|0)|0))if(O)break;else{I=49;break}else{f[e>>2]=0;I=47;break}}else I=47;while(0);if((I|0)==47?O:0)I=49;if((I|0)==49)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;Z5b(m);Z5b(l);u=a;return h|0}function _Zb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;do if((a|0)==(c|0)){f[d>>2]=4;i=0}else{if((b[a>>0]|0)==45){f[d>>2]=4;i=0;break}j=ZSb()|0;k=f[j>>2]|0;j=ZSb()|0;f[j>>2]=0;j=lWb(a,h,e,AZb()|0)|0;l=J;m=ZSb()|0;n=f[m>>2]|0;if(!n){m=ZSb()|0;f[m>>2]=k}do if((f[h>>2]|0)==(c|0))if(l>>>0>0|(l|0)==0&j>>>0>65535|(n|0)==34){f[d>>2]=4;o=-1;break}else{o=j&65535;break}else{f[d>>2]=4;o=0}while(0);i=o}while(0);u=g;return i|0}function $Zb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=SZb(e)|0;TZb(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;e6b(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=di[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=UWb(b[v>>0]|0)|0;if(SXb(y,TWb()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=di[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=UWb(b[C>>0]|0)|0;if(!(SXb(D,TWb()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){e6b(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;e6b(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;K=v}else K=w;v=z+12|0;C=f[v>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=di[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else M=UWb(b[C>>0]|0)|0;if(zZb(M&255,q,K,m,p,b[j>>0]|0,k,n,o,i)|0){F=K;G=E;break}C=f[v>>2]|0;if((C|0)==(f[L>>2]|0)){di[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=K;s=z;x=A;continue}else{f[v>>2]=C+1;UWb(b[C>>0]|0)|0;w=K;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=a_b(F,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=s;f[q+4>>2]=J;MZb(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=di[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else N=UWb(b[o>>0]|0)|0;if(SXb(N,TWb()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=di[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else P=UWb(b[N>>0]|0)|0;if(!(SXb(P,TWb()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(l);Z5b(k);u=a;return g|0}function a_b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if((a|0)==(b|0)){f[c>>2]=4;h=0;i=0}else{j=ZSb()|0;k=f[j>>2]|0;j=ZSb()|0;f[j>>2]=0;j=mWb(a,g,d,AZb()|0)|0;d=J;a=ZSb()|0;l=f[a>>2]|0;if(!l){a=ZSb()|0;f[a>>2]=k}if((f[g>>2]|0)==(b|0))if((l|0)==34){f[c>>2]=4;l=(d|0)>0|(d|0)==0&j>>>0>0;m=l?-1:0;n=l?2147483647:-2147483648}else{m=j;n=d}else{f[c>>2]=4;m=0;n=0}h=n;i=m}J=h;u=e;return i|0}function b_b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+224|0;i=a+198|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=SZb(e)|0;TZb(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;e6b(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=di[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=UWb(b[v>>0]|0)|0;if(SXb(y,TWb()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=di[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=UWb(b[C>>0]|0)|0;if(!(SXb(D,TWb()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){e6b(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;e6b(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=di[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else L=UWb(b[C>>0]|0)|0;if(zZb(L&255,q,J,m,p,b[j>>0]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){di[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+1;UWb(b[C>>0]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=c_b(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;MZb(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=di[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else M=UWb(b[o>>0]|0)|0;if(SXb(M,TWb()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=di[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else O=UWb(b[M>>0]|0)|0;if(!(SXb(O,TWb()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(l);Z5b(k);u=a;return g|0}function c_b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;if((a|0)==(b|0)){f[c>>2]=4;h=0}else{i=ZSb()|0;j=f[i>>2]|0;i=ZSb()|0;f[i>>2]=0;i=mWb(a,g,d,AZb()|0)|0;d=J;a=ZSb()|0;k=f[a>>2]|0;if(!k){a=ZSb()|0;f[a>>2]=j}a:do if((f[g>>2]|0)==(b|0)){do if((k|0)==34){f[c>>2]=4;if((d|0)>0|(d|0)==0&i>>>0>0){l=2147483647;break a}}else{if((d|0)<-1|(d|0)==-1&i>>>0<2147483648){f[c>>2]=4;break}if((d|0)>0|(d|0)==0&i>>>0>2147483647){f[c>>2]=4;l=2147483647;break a}else{l=i;break a}}while(0);l=-2147483648}else{f[c>>2]=4;l=0}while(0);h=l}u=e;return h|0}function d_b(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;j=u;u=u+112|0;k=j;l=(e-d|0)/12|0;if(l>>>0>100){m=OSb(l)|0;if(!m)Q5b();else{n=m;o=m}}else{n=k;o=0}k=l;l=d;m=n;p=0;while(1){if((l|0)==(e|0))break;q=b[l+11>>0]|0;if(q<<24>>24<0)r=f[l+4>>2]|0;else r=q&255;if(!r){b[m>>0]=2;s=k+-1|0;t=p+1|0}else{b[m>>0]=1;s=k;t=p}k=s;l=l+12|0;m=m+1|0;p=t}t=0;m=k;k=p;a:while(1){p=f[a>>2]|0;do if(p){l=f[p+12>>2]|0;if((l|0)==(f[p+16>>2]|0))v=di[f[(f[p>>2]|0)+36>>2]&1023](p)|0;else v=UWb(b[l>>0]|0)|0;if(SXb(v,TWb()|0)|0){f[a>>2]=0;w=1;break}else{w=(f[a>>2]|0)==0;break}}else w=1;while(0);p=f[c>>2]|0;if(p){l=f[p+12>>2]|0;if((l|0)==(f[p+16>>2]|0))x=di[f[(f[p>>2]|0)+36>>2]&1023](p)|0;else x=UWb(b[l>>0]|0)|0;if(SXb(x,TWb()|0)|0){f[c>>2]=0;y=0;z=1}else{y=p;z=0}}else{y=0;z=1}A=f[a>>2]|0;if(!((m|0)!=0&(w^z)))break;p=f[A+12>>2]|0;if((p|0)==(f[A+16>>2]|0))B=di[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else B=UWb(b[p>>0]|0)|0;p=B&255;if(i)C=p;else C=Uh[f[(f[g>>2]|0)+12>>2]&1023](g,p)|0;p=t+1|0;l=d;s=0;r=n;q=k;D=m;while(1){if((l|0)==(e|0))break;do if((b[r>>0]|0)==1){E=l+11|0;if((b[E>>0]|0)<0)F=f[l>>2]|0;else F=l;G=b[F+t>>0]|0;if(i)H=G;else H=Uh[f[(f[g>>2]|0)+12>>2]&1023](g,G)|0;G=D+-1|0;if(C<<24>>24!=H<<24>>24){b[r>>0]=0;I=s;J=q;K=G;break}L=b[E>>0]|0;if(L<<24>>24<0)M=f[l+4>>2]|0;else M=L&255;if((M|0)==(p|0)){b[r>>0]=2;I=1;J=q+1|0;K=G}else{I=1;J=q;K=D}}else{I=s;J=q;K=D}while(0);l=l+12|0;s=I;r=r+1|0;q=J;D=K}if(!s){t=p;m=D;k=q;continue}r=f[a>>2]|0;l=r+12|0;G=f[l>>2]|0;if((G|0)==(f[r+16>>2]|0))di[f[(f[r>>2]|0)+40>>2]&1023](r)|0;else{f[l>>2]=G+1;UWb(b[G>>0]|0)|0}if((q+D|0)>>>0>1){N=d;O=n;P=q}else{t=p;m=D;k=q;continue}while(1){if((N|0)==(e|0)){t=p;m=D;k=P;continue a}if((b[O>>0]|0)==2){G=b[N+11>>0]|0;if(G<<24>>24<0)Q=f[N+4>>2]|0;else Q=G&255;if((Q|0)!=(p|0)){b[O>>0]=0;R=P+-1|0}else R=P}else R=P;N=N+12|0;O=O+1|0;P=R}}do if(A){R=f[A+12>>2]|0;if((R|0)==(f[A+16>>2]|0))S=di[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else S=UWb(b[R>>0]|0)|0;if(SXb(S,TWb()|0)|0){f[a>>2]=0;T=1;break}else{T=(f[a>>2]|0)==0;break}}else T=1;while(0);do if(y){a=f[y+12>>2]|0;if((a|0)==(f[y+16>>2]|0))U=di[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else U=UWb(b[a>>0]|0)|0;if(!(SXb(U,TWb()|0)|0))if(T){V=d;W=n;break}else{X=77;break}else{f[c>>2]=0;X=41;break}}else X=41;while(0);if((X|0)==41)if(T)X=77;else{V=d;W=n}if((X|0)==77){f[h>>2]=f[h>>2]|2;V=d;W=n}while(1){if((V|0)==(e|0)){X=81;break}if((b[W>>0]|0)==2){Y=V;break}V=V+12|0;W=W+1|0}if((X|0)==81){f[h>>2]=f[h>>2]|4;Y=e}PSb(o);u=j;return Y|0}function e_b(a){a=a|0;dZb(a);return}function f_b(a){a=a|0;dZb(a);O5b(a);return}function g_b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;i=u;u=u+48|0;j=i+40|0;k=i+16|0;l=i+8|0;m=i+12|0;n=i+4|0;o=i;if(!(f[e+4>>2]&1)){f[l>>2]=-1;p=f[(f[a>>2]|0)+16>>2]|0;f[m>>2]=f[c>>2];f[n>>2]=f[d>>2];f[k>>2]=f[m>>2];f[j>>2]=f[n>>2];n=Xf[p&127](a,k,j,e,g,l)|0;f[c>>2]=n;switch(f[l>>2]|0){case 0:{b[h>>0]=0;break}case 1:{b[h>>0]=1;break}default:{b[h>>0]=1;f[g>>2]=4}}q=f[c>>2]|0}else{TXb(j,e);l=xZb(j,855532)|0;yZb(j);TXb(j,e);e=xZb(j,855540)|0;yZb(j);zh[f[(f[e>>2]|0)+24>>2]&2047](k,e);zh[f[(f[e>>2]|0)+28>>2]&2047](k+12|0,e);f[o>>2]=f[d>>2];d=k+24|0;f[j>>2]=f[o>>2];o=(E_b(c,j,k,d,l,g,1)|0)==(k|0)&1;b[h>>0]=o;o=f[c>>2]|0;c=d;do{c=c+-12|0;v6b(c)}while((c|0)!=(k|0));q=o}u=i;return q|0}function h_b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=D_b(a,j,i,d,e,g)|0;u=h;return l|0}function i_b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=C_b(a,j,i,d,e,g)|0;u=h;return l|0}function j_b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=B_b(a,j,i,d,e,g)|0;u=h;return l|0}function k_b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=A_b(a,j,i,d,e,g)|0;u=h;return l|0}function l_b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=z_b(a,j,i,d,e,g)|0;u=h;return l|0}function m_b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=x_b(a,j,i,d,e,g)|0;u=h;return l|0}function n_b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=w_b(a,j,i,d,e,g)|0;u=h;return l|0}function o_b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=v_b(a,j,i,d,e,g)|0;u=h;return l|0}function p_b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=s_b(a,j,i,d,e,g)|0;u=h;return l|0}function q_b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;a=u;u=u+320|0;i=a;j=a+208|0;k=a+192|0;l=a+180|0;m=a+176|0;n=a+16|0;o=a+8|0;p=a+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[k+(q<<2)>>2]=0;q=q+1|0}TXb(l,e);e=xZb(l,855532)|0;Dg[f[(f[e>>2]|0)+48>>2]&127](e,486185,486211,j)|0;yZb(l);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;q=l+8|0;if((b[e>>0]|0)<0)r=(f[q>>2]&2147483647)+-1|0;else r=10;e6b(l,r,0);r=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=r;f[o>>2]=n;f[p>>2]=0;s=l+4|0;t=f[c>>2]|0;v=r;r=t;w=t;a:while(1){if(r){t=f[r+12>>2]|0;if((t|0)==(f[r+16>>2]|0))x=di[f[(f[r>>2]|0)+36>>2]&1023](r)|0;else x=kXb(f[t>>2]|0)|0;if(UXb(x,jXb()|0)|0){f[c>>2]=0;y=0;z=0;A=1}else{y=r;z=w;A=0}}else{y=0;z=0;A=1}t=f[d>>2]|0;do if(t){B=f[t+12>>2]|0;if((B|0)==(f[t+16>>2]|0))C=di[f[(f[t>>2]|0)+36>>2]&1023](t)|0;else C=kXb(f[B>>2]|0)|0;if(!(UXb(C,jXb()|0)|0))if(A){D=t;break}else{E=v;F=t;break a}else{f[d>>2]=0;G=22;break}}else G=22;while(0);if((G|0)==22){G=0;if(A){E=v;F=0;break}else D=0}t=b[e>>0]|0;B=t<<24>>24<0?f[s>>2]|0:t&255;if((f[m>>2]|0)==(v+B|0)){e6b(l,B<<1,0);if((b[e>>0]|0)<0)H=(f[q>>2]&2147483647)+-1|0;else H=10;e6b(l,H,0);t=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=t+B;I=t}else I=v;t=y+12|0;B=f[t>>2]|0;J=y+16|0;if((B|0)==(f[J>>2]|0))K=di[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else K=kXb(f[B>>2]|0)|0;if(r_b(K,16,I,m,p,0,k,n,o,j)|0){E=I;F=D;break}B=f[t>>2]|0;if((B|0)==(f[J>>2]|0)){di[f[(f[y>>2]|0)+40>>2]&1023](y)|0;v=I;r=y;w=z;continue}else{f[t>>2]=B+4;kXb(f[B>>2]|0)|0;v=I;r=y;w=z;continue}}e6b(l,(f[m>>2]|0)-E|0,0);E=(b[e>>0]|0)<0?f[l>>2]|0:l;e=AZb()|0;f[i>>2]=h;if((BZb(E,e,486218,i)|0)!=1)f[g>>2]=4;if(y){i=f[y+12>>2]|0;if((i|0)==(f[y+16>>2]|0))L=di[f[(f[z>>2]|0)+36>>2]&1023](y)|0;else L=kXb(f[i>>2]|0)|0;if(UXb(L,jXb()|0)|0){f[c>>2]=0;M=1}else M=0}else M=1;do if(F){L=f[F+12>>2]|0;if((L|0)==(f[F+16>>2]|0))N=di[f[(f[F>>2]|0)+36>>2]&1023](F)|0;else N=kXb(f[L>>2]|0)|0;if(!(UXb(N,jXb()|0)|0))if(M)break;else{G=51;break}else{f[d>>2]=0;G=49;break}}else G=49;while(0);if((G|0)==49?M:0)G=51;if((G|0)==51)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(l);Z5b(k);u=a;return g|0}function r_b(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=f[e>>2]|0;n=(m|0)==(d|0);do if(n){o=(f[l+96>>2]|0)==(a|0);if(!o?(f[l+100>>2]|0)!=(a|0):0){p=5;break}f[e>>2]=d+1;b[d>>0]=o?43:45;f[g>>2]=0;q=0}else p=5;while(0);a:do if((p|0)==5){o=b[i+11>>0]|0;if((a|0)==(h|0)?((o<<24>>24<0?f[i+4>>2]|0:o&255)|0)!=0:0){o=f[k>>2]|0;if((o-j|0)>=160){q=0;break}r=f[g>>2]|0;f[k>>2]=o+4;f[o>>2]=r;f[g>>2]=0;q=0;break}r=l+104|0;o=0;while(1){s=l+(o<<2)|0;if((o|0)==26){t=r;break}if((f[s>>2]|0)==(a|0)){t=s;break}else o=o+1|0}o=t-l|0;r=o>>2;if((o|0)>92)q=-1;else{s=486185+r|0;switch(c|0){case 10:case 8:{if((r|0)>=(c|0)){q=-1;break a}break}case 16:{if((o|0)>=88){if(n){q=-1;break a}if((m-d|0)>=3){q=-1;break a}if((b[m+-1>>0]|0)!=48){q=-1;break a}f[g>>2]=0;o=b[s>>0]|0;f[e>>2]=m+1;b[m>>0]=o;q=0;break a}break}default:{}}o=b[s>>0]|0;f[e>>2]=m+1;b[m>>0]=o;f[g>>2]=(f[g>>2]|0)+1;q=0}}while(0);return q|0}function s_b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+352|0;i=a+208|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+337|0;t=a+336|0;t_b(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;e6b(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=di[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else B=kXb(f[y>>2]|0)|0;if(UXb(B,jXb()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=di[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else G=kXb(f[F>>2]|0)|0;if(!(UXb(G,jXb()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[n>>2]|0)==(z+F|0)){e6b(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;e6b(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=di[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else O=kXb(f[F>>2]|0)|0;if(u_b(O,s,t,M,n,f[j>>2]|0,f[k>>2]|0,l,o,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){di[f[(f[C>>2]|0)+40>>2]&1023](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+4;kXb(f[F>>2]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+LZb(I,f[n>>2]|0,g);p[h>>3]=P;MZb(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=di[f[(f[D>>2]|0)+36>>2]&1023](C)|0;else Q=kXb(f[q>>2]|0)|0;if(UXb(Q,jXb()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=di[f[(f[J>>2]|0)+36>>2]&1023](J)|0;else S=kXb(f[Q>>2]|0)|0;if(!(UXb(S,jXb()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(m);Z5b(l);u=a;return g|0}function t_b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;TXb(h,b);b=xZb(h,855532)|0;Dg[f[(f[b>>2]|0)+48>>2]&127](b,486185,486217,c)|0;c=xZb(h,855540)|0;b=di[f[(f[c>>2]|0)+12>>2]&1023](c)|0;f[d>>2]=b;b=di[f[(f[c>>2]|0)+16>>2]&1023](c)|0;f[e>>2]=b;zh[f[(f[c>>2]|0)+20>>2]&2047](a,c);yZb(h);u=g;return}function u_b(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0;o=k;a:do if((a|0)==(h|0))if(b[c>>0]|0){b[c>>0]=0;k=f[g>>2]|0;f[g>>2]=k+1;b[k>>0]=46;k=b[j+11>>0]|0;if(((k<<24>>24<0?f[j+4>>2]|0:k&255)|0)!=0?(k=f[l>>2]|0,(k-o|0)<160):0){p=f[m>>2]|0;f[l>>2]=k+4;f[k>>2]=p;q=0}else q=0}else q=-1;else{if((a|0)==(i|0)?(p=b[j+11>>0]|0,(p<<24>>24<0?f[j+4>>2]|0:p&255)|0):0){if(!(b[c>>0]|0)){q=-1;break}p=f[l>>2]|0;if((p-o|0)>=160){q=0;break}k=f[m>>2]|0;f[l>>2]=p+4;f[p>>2]=k;f[m>>2]=0;q=0;break}k=n+128|0;p=0;while(1){r=n+(p<<2)|0;if((p|0)==32){s=k;break}if((f[r>>2]|0)==(a|0)){s=r;break}else p=p+1|0}p=s-n|0;k=p>>2;if((p|0)<=124){r=b[486185+k>>0]|0;switch(k|0){case 24:case 25:{k=f[g>>2]|0;if((k|0)!=(e|0)?(b[k+-1>>0]&95)!=(b[d>>0]&127):0){q=-1;break a}f[g>>2]=k+1;b[k>>0]=r;q=0;break a;break}case 23:case 22:{b[d>>0]=80;break}default:{k=r&95;if((((k|0)==(b[d>>0]|0)?(b[d>>0]=k|128,b[c>>0]|0):0)?(b[c>>0]=0,k=b[j+11>>0]|0,(k<<24>>24<0?f[j+4>>2]|0:k&255)|0):0)?(k=f[l>>2]|0,(k-o|0)<160):0){t=f[m>>2]|0;f[l>>2]=k+4;f[k>>2]=t}}}t=f[g>>2]|0;f[g>>2]=t+1;b[t>>0]=r;if((p|0)>84)q=0;else{f[m>>2]=(f[m>>2]|0)+1;q=0}}else q=-1}while(0);return q|0}function v_b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+352|0;i=a+208|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;q=a+4|0;r=a;s=a+337|0;t=a+336|0;t_b(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;e6b(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w;f[q>>2]=o;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=di[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else B=kXb(f[y>>2]|0)|0;if(UXb(B,jXb()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=di[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else G=kXb(f[F>>2]|0)|0;if(!(UXb(G,jXb()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[n>>2]|0)==(z+F|0)){e6b(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;e6b(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=di[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else O=kXb(f[F>>2]|0)|0;if(u_b(O,s,t,M,n,f[j>>2]|0,f[k>>2]|0,l,o,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){di[f[(f[C>>2]|0)+40>>2]&1023](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+4;kXb(f[F>>2]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-o|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+OZb(I,f[n>>2]|0,g);p[h>>3]=P;MZb(l,o,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=di[f[(f[D>>2]|0)+36>>2]&1023](C)|0;else Q=kXb(f[q>>2]|0)|0;if(UXb(Q,jXb()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=di[f[(f[J>>2]|0)+36>>2]&1023](J)|0;else S=kXb(f[Q>>2]|0)|0;if(!(UXb(S,jXb()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(m);Z5b(l);u=a;return g|0}function w_b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0;a=u;u=u+352|0;i=a+208|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;o=a+168|0;p=a+8|0;q=a+4|0;r=a;s=a+337|0;t=a+336|0;t_b(l,e,i,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[m+(e<<2)>>2]=0;e=e+1|0}e=m+11|0;v=m+8|0;if((b[e>>0]|0)<0)w=(f[v>>2]&2147483647)+-1|0;else w=10;e6b(m,w,0);w=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=w;f[q>>2]=p;f[r>>2]=0;b[s>>0]=1;b[t>>0]=69;x=m+4|0;y=f[c>>2]|0;z=w;w=y;A=y;a:while(1){if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))B=di[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else B=kXb(f[y>>2]|0)|0;if(UXb(B,jXb()|0)|0){f[c>>2]=0;C=0;D=0;E=1}else{C=w;D=A;E=0}}else{C=0;D=0;E=1}y=f[d>>2]|0;do if(y){F=f[y+12>>2]|0;if((F|0)==(f[y+16>>2]|0))G=di[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else G=kXb(f[F>>2]|0)|0;if(!(UXb(G,jXb()|0)|0))if(E){H=y;break}else{I=z;J=y;break a}else{f[d>>2]=0;K=19;break}}else K=19;while(0);if((K|0)==19){K=0;if(E){I=z;J=0;break}else H=0}y=b[e>>0]|0;F=y<<24>>24<0?f[x>>2]|0:y&255;if((f[o>>2]|0)==(z+F|0)){e6b(m,F<<1,0);if((b[e>>0]|0)<0)L=(f[v>>2]&2147483647)+-1|0;else L=10;e6b(m,L,0);y=(b[e>>0]|0)<0?f[m>>2]|0:m;f[o>>2]=y+F;M=y}else M=z;y=C+12|0;F=f[y>>2]|0;N=C+16|0;if((F|0)==(f[N>>2]|0))O=di[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else O=kXb(f[F>>2]|0)|0;if(u_b(O,s,t,M,o,f[j>>2]|0,f[k>>2]|0,l,p,q,r,i)|0){I=M;J=H;break}F=f[y>>2]|0;if((F|0)==(f[N>>2]|0)){di[f[(f[C>>2]|0)+40>>2]&1023](C)|0;z=M;w=C;A=D;continue}else{f[y>>2]=F+4;kXb(f[F>>2]|0)|0;z=M;w=C;A=D;continue}}A=b[l+11>>0]|0;if(!((b[s>>0]|0)==0?1:((A<<24>>24<0?f[l+4>>2]|0:A&255)|0)==0)?(A=f[q>>2]|0,(A-p|0)<160):0){s=f[r>>2]|0;f[q>>2]=A+4;f[A>>2]=s}P=+QZb(I,f[o>>2]|0,g);n[h>>2]=P;MZb(l,p,f[q>>2]|0,g);if(C){q=f[C+12>>2]|0;if((q|0)==(f[C+16>>2]|0))Q=di[f[(f[D>>2]|0)+36>>2]&1023](C)|0;else Q=kXb(f[q>>2]|0)|0;if(UXb(Q,jXb()|0)|0){f[c>>2]=0;R=1}else R=0}else R=1;do if(J){Q=f[J+12>>2]|0;if((Q|0)==(f[J+16>>2]|0))S=di[f[(f[J>>2]|0)+36>>2]&1023](J)|0;else S=kXb(f[Q>>2]|0)|0;if(!(UXb(S,jXb()|0)|0))if(R)break;else{K=49;break}else{f[d>>2]=0;K=47;break}}else K=47;while(0);if((K|0)==47?R:0)K=49;if((K|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(m);Z5b(l);u=a;return g|0}function x_b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=SZb(e)|0;y_b(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;e6b(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=di[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=kXb(f[v>>2]|0)|0;if(UXb(y,jXb()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=di[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=kXb(f[C>>2]|0)|0;if(!(UXb(D,jXb()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){e6b(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;e6b(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;K=v}else K=w;v=z+12|0;C=f[v>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=di[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else M=kXb(f[C>>2]|0)|0;if(r_b(M,q,K,m,p,f[j>>2]|0,k,n,o,i)|0){F=K;G=E;break}C=f[v>>2]|0;if((C|0)==(f[L>>2]|0)){di[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=K;s=z;x=A;continue}else{f[v>>2]=C+4;kXb(f[C>>2]|0)|0;w=K;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=UZb(F,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=s;f[q+4>>2]=J;MZb(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=di[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else N=kXb(f[o>>2]|0)|0;if(UXb(N,jXb()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=di[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else P=kXb(f[N>>2]|0)|0;if(!(UXb(P,jXb()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(l);Z5b(k);u=a;return g|0}function y_b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;TXb(g,b);b=xZb(g,855532)|0;Dg[f[(f[b>>2]|0)+48>>2]&127](b,486185,486211,c)|0;c=xZb(g,855540)|0;b=di[f[(f[c>>2]|0)+16>>2]&1023](c)|0;f[d>>2]=b;zh[f[(f[c>>2]|0)+20>>2]&2047](a,c);yZb(g);u=e;return}function z_b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=SZb(e)|0;y_b(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;e6b(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=di[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=kXb(f[v>>2]|0)|0;if(UXb(y,jXb()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=di[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=kXb(f[C>>2]|0)|0;if(!(UXb(D,jXb()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){e6b(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;e6b(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=di[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else L=kXb(f[C>>2]|0)|0;if(r_b(L,q,J,m,p,f[j>>2]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){di[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+4;kXb(f[C>>2]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=WZb(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;MZb(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=di[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else M=kXb(f[o>>2]|0)|0;if(UXb(M,jXb()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=di[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else O=kXb(f[M>>2]|0)|0;if(!(UXb(O,jXb()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(l);Z5b(k);u=a;return g|0}function A_b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=SZb(e)|0;y_b(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;e6b(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=di[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=kXb(f[v>>2]|0)|0;if(UXb(y,jXb()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=di[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=kXb(f[C>>2]|0)|0;if(!(UXb(D,jXb()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){e6b(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;e6b(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=di[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else L=kXb(f[C>>2]|0)|0;if(r_b(L,q,J,m,p,f[j>>2]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){di[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+4;kXb(f[C>>2]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=YZb(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;MZb(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=di[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else M=kXb(f[o>>2]|0)|0;if(UXb(M,jXb()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=di[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else O=kXb(f[M>>2]|0)|0;if(!(UXb(O,jXb()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(l);Z5b(k);u=a;return g|0}function B_b(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+304|0;j=a+200|0;k=a+196|0;l=a+184|0;m=a+172|0;n=a+168|0;o=a+8|0;p=a+4|0;q=a;r=SZb(g)|0;y_b(l,g,j,k);f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[m+(g<<2)>>2]=0;g=g+1|0}g=m+11|0;s=m+8|0;if((b[g>>0]|0)<0)t=(f[s>>2]&2147483647)+-1|0;else t=10;e6b(m,t,0);t=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=t;f[p>>2]=o;f[q>>2]=0;v=m+4|0;w=f[c>>2]|0;x=t;t=w;y=w;a:while(1){if(t){w=f[t+12>>2]|0;if((w|0)==(f[t+16>>2]|0))z=di[f[(f[t>>2]|0)+36>>2]&1023](t)|0;else z=kXb(f[w>>2]|0)|0;if(UXb(z,jXb()|0)|0){f[c>>2]=0;A=0;B=0;C=1}else{A=t;B=y;C=0}}else{A=0;B=0;C=1}w=f[e>>2]|0;do if(w){D=f[w+12>>2]|0;if((D|0)==(f[w+16>>2]|0))E=di[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else E=kXb(f[D>>2]|0)|0;if(!(UXb(E,jXb()|0)|0))if(C){F=w;break}else{G=x;H=w;break a}else{f[e>>2]=0;I=19;break}}else I=19;while(0);if((I|0)==19){I=0;if(C){G=x;H=0;break}else F=0}w=b[g>>0]|0;D=w<<24>>24<0?f[v>>2]|0:w&255;if((f[n>>2]|0)==(x+D|0)){e6b(m,D<<1,0);if((b[g>>0]|0)<0)J=(f[s>>2]&2147483647)+-1|0;else J=10;e6b(m,J,0);w=(b[g>>0]|0)<0?f[m>>2]|0:m;f[n>>2]=w+D;K=w}else K=x;w=A+12|0;D=f[w>>2]|0;L=A+16|0;if((D|0)==(f[L>>2]|0))M=di[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else M=kXb(f[D>>2]|0)|0;if(r_b(M,r,K,n,q,f[k>>2]|0,l,o,p,j)|0){G=K;H=F;break}D=f[w>>2]|0;if((D|0)==(f[L>>2]|0)){di[f[(f[A>>2]|0)+40>>2]&1023](A)|0;x=K;t=A;y=B;continue}else{f[w>>2]=D+4;kXb(f[D>>2]|0)|0;x=K;t=A;y=B;continue}}y=b[l+11>>0]|0;if((y<<24>>24<0?f[l+4>>2]|0:y&255)|0?(y=f[p>>2]|0,(y-o|0)<160):0){t=f[q>>2]|0;f[p>>2]=y+4;f[y>>2]=t}t=_Zb(G,f[n>>2]|0,h,r)|0;d[i>>1]=t;MZb(l,o,f[p>>2]|0,h);if(A){p=f[A+12>>2]|0;if((p|0)==(f[A+16>>2]|0))N=di[f[(f[B>>2]|0)+36>>2]&1023](A)|0;else N=kXb(f[p>>2]|0)|0;if(UXb(N,jXb()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(H){N=f[H+12>>2]|0;if((N|0)==(f[H+16>>2]|0))P=di[f[(f[H>>2]|0)+36>>2]&1023](H)|0;else P=kXb(f[N>>2]|0)|0;if(!(UXb(P,jXb()|0)|0))if(O)break;else{I=49;break}else{f[e>>2]=0;I=47;break}}else I=47;while(0);if((I|0)==47?O:0)I=49;if((I|0)==49)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;Z5b(m);Z5b(l);u=a;return h|0}function C_b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=SZb(e)|0;y_b(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;e6b(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=di[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=kXb(f[v>>2]|0)|0;if(UXb(y,jXb()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=di[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=kXb(f[C>>2]|0)|0;if(!(UXb(D,jXb()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){e6b(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;e6b(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;K=v}else K=w;v=z+12|0;C=f[v>>2]|0;L=z+16|0;if((C|0)==(f[L>>2]|0))M=di[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else M=kXb(f[C>>2]|0)|0;if(r_b(M,q,K,m,p,f[j>>2]|0,k,n,o,i)|0){F=K;G=E;break}C=f[v>>2]|0;if((C|0)==(f[L>>2]|0)){di[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=K;s=z;x=A;continue}else{f[v>>2]=C+4;kXb(f[C>>2]|0)|0;w=K;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=a_b(F,f[m>>2]|0,g,q)|0;q=h;f[q>>2]=s;f[q+4>>2]=J;MZb(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))N=di[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else N=kXb(f[o>>2]|0)|0;if(UXb(N,jXb()|0)|0){f[c>>2]=0;O=1}else O=0}else O=1;do if(G){N=f[G+12>>2]|0;if((N|0)==(f[G+16>>2]|0))P=di[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else P=kXb(f[N>>2]|0)|0;if(!(UXb(P,jXb()|0)|0))if(O)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?O:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(l);Z5b(k);u=a;return g|0}function D_b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;a=u;u=u+304|0;i=a+200|0;j=a+196|0;k=a+184|0;l=a+172|0;m=a+168|0;n=a+8|0;o=a+4|0;p=a;q=SZb(e)|0;y_b(k,e,i,j);f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;e=0;while(1){if((e|0)==3)break;f[l+(e<<2)>>2]=0;e=e+1|0}e=l+11|0;r=l+8|0;if((b[e>>0]|0)<0)s=(f[r>>2]&2147483647)+-1|0;else s=10;e6b(l,s,0);s=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=s;f[o>>2]=n;f[p>>2]=0;t=l+4|0;v=f[c>>2]|0;w=s;s=v;x=v;a:while(1){if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))y=di[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else y=kXb(f[v>>2]|0)|0;if(UXb(y,jXb()|0)|0){f[c>>2]=0;z=0;A=0;B=1}else{z=s;A=x;B=0}}else{z=0;A=0;B=1}v=f[d>>2]|0;do if(v){C=f[v+12>>2]|0;if((C|0)==(f[v+16>>2]|0))D=di[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else D=kXb(f[C>>2]|0)|0;if(!(UXb(D,jXb()|0)|0))if(B){E=v;break}else{F=w;G=v;break a}else{f[d>>2]=0;H=19;break}}else H=19;while(0);if((H|0)==19){H=0;if(B){F=w;G=0;break}else E=0}v=b[e>>0]|0;C=v<<24>>24<0?f[t>>2]|0:v&255;if((f[m>>2]|0)==(w+C|0)){e6b(l,C<<1,0);if((b[e>>0]|0)<0)I=(f[r>>2]&2147483647)+-1|0;else I=10;e6b(l,I,0);v=(b[e>>0]|0)<0?f[l>>2]|0:l;f[m>>2]=v+C;J=v}else J=w;v=z+12|0;C=f[v>>2]|0;K=z+16|0;if((C|0)==(f[K>>2]|0))L=di[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else L=kXb(f[C>>2]|0)|0;if(r_b(L,q,J,m,p,f[j>>2]|0,k,n,o,i)|0){F=J;G=E;break}C=f[v>>2]|0;if((C|0)==(f[K>>2]|0)){di[f[(f[z>>2]|0)+40>>2]&1023](z)|0;w=J;s=z;x=A;continue}else{f[v>>2]=C+4;kXb(f[C>>2]|0)|0;w=J;s=z;x=A;continue}}x=b[k+11>>0]|0;if((x<<24>>24<0?f[k+4>>2]|0:x&255)|0?(x=f[o>>2]|0,(x-n|0)<160):0){s=f[p>>2]|0;f[o>>2]=x+4;f[x>>2]=s}s=c_b(F,f[m>>2]|0,g,q)|0;f[h>>2]=s;MZb(k,n,f[o>>2]|0,g);if(z){o=f[z+12>>2]|0;if((o|0)==(f[z+16>>2]|0))M=di[f[(f[A>>2]|0)+36>>2]&1023](z)|0;else M=kXb(f[o>>2]|0)|0;if(UXb(M,jXb()|0)|0){f[c>>2]=0;N=1}else N=0}else N=1;do if(G){M=f[G+12>>2]|0;if((M|0)==(f[G+16>>2]|0))O=di[f[(f[G>>2]|0)+36>>2]&1023](G)|0;else O=kXb(f[M>>2]|0)|0;if(!(UXb(O,jXb()|0)|0))if(N)break;else{H=49;break}else{f[d>>2]=0;H=47;break}}else H=47;while(0);if((H|0)==47?N:0)H=49;if((H|0)==49)f[g>>2]=f[g>>2]|2;g=f[c>>2]|0;Z5b(l);Z5b(k);u=a;return g|0}function E_b(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;j=u;u=u+112|0;k=j;l=(e-d|0)/12|0;if(l>>>0>100){m=OSb(l)|0;if(!m)Q5b();else{n=m;o=m}}else{n=k;o=0}k=0;m=l;l=d;p=n;while(1){if((l|0)==(e|0))break;q=b[l+8+3>>0]|0;if(q<<24>>24<0)r=f[l+4>>2]|0;else r=q&255;if(!r){b[p>>0]=2;s=k+1|0;t=m+-1|0}else{b[p>>0]=1;s=k;t=m}k=s;m=t;l=l+12|0;p=p+1|0}p=0;l=k;k=m;a:while(1){m=f[a>>2]|0;do if(m){t=f[m+12>>2]|0;if((t|0)==(f[m+16>>2]|0))v=di[f[(f[m>>2]|0)+36>>2]&1023](m)|0;else v=kXb(f[t>>2]|0)|0;if(UXb(v,jXb()|0)|0){f[a>>2]=0;w=1;break}else{w=(f[a>>2]|0)==0;break}}else w=1;while(0);m=f[c>>2]|0;if(m){t=f[m+12>>2]|0;if((t|0)==(f[m+16>>2]|0))x=di[f[(f[m>>2]|0)+36>>2]&1023](m)|0;else x=kXb(f[t>>2]|0)|0;if(UXb(x,jXb()|0)|0){f[c>>2]=0;y=0;z=1}else{y=m;z=0}}else{y=0;z=1}A=f[a>>2]|0;if(!((k|0)!=0&(w^z)))break;m=f[A+12>>2]|0;if((m|0)==(f[A+16>>2]|0))B=di[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else B=kXb(f[m>>2]|0)|0;if(i)C=B;else C=Uh[f[(f[g>>2]|0)+28>>2]&1023](g,B)|0;m=p+1|0;t=d;s=0;r=n;q=l;D=k;while(1){if((t|0)==(e|0))break;do if((b[r>>0]|0)==1){E=t+8+3|0;if((b[E>>0]|0)<0)F=f[t>>2]|0;else F=t;G=f[F+(p<<2)>>2]|0;if(i)H=G;else H=Uh[f[(f[g>>2]|0)+28>>2]&1023](g,G)|0;G=D+-1|0;if((C|0)!=(H|0)){b[r>>0]=0;I=s;J=q;K=G;break}L=b[E>>0]|0;if(L<<24>>24<0)M=f[t+4>>2]|0;else M=L&255;if((M|0)==(m|0)){b[r>>0]=2;I=1;J=q+1|0;K=G}else{I=1;J=q;K=D}}else{I=s;J=q;K=D}while(0);t=t+12|0;s=I;r=r+1|0;q=J;D=K}if(!s){p=m;l=q;k=D;continue}r=f[a>>2]|0;t=r+12|0;G=f[t>>2]|0;if((G|0)==(f[r+16>>2]|0))di[f[(f[r>>2]|0)+40>>2]&1023](r)|0;else{f[t>>2]=G+4;kXb(f[G>>2]|0)|0}if((q+D|0)>>>0>1){N=d;O=n;P=q}else{p=m;l=q;k=D;continue}while(1){if((N|0)==(e|0)){p=m;l=P;k=D;continue a}if((b[O>>0]|0)==2){G=b[N+8+3>>0]|0;if(G<<24>>24<0)Q=f[N+4>>2]|0;else Q=G&255;if((Q|0)!=(m|0)){b[O>>0]=0;R=P+-1|0}else R=P}else R=P;N=N+12|0;O=O+1|0;P=R}}do if(A){R=f[A+12>>2]|0;if((R|0)==(f[A+16>>2]|0))S=di[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else S=kXb(f[R>>2]|0)|0;if(UXb(S,jXb()|0)|0){f[a>>2]=0;T=1;break}else{T=(f[a>>2]|0)==0;break}}else T=1;while(0);do if(y){a=f[y+12>>2]|0;if((a|0)==(f[y+16>>2]|0))U=di[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else U=kXb(f[a>>2]|0)|0;if(!(UXb(U,jXb()|0)|0))if(T){V=d;W=n;break}else{X=77;break}else{f[c>>2]=0;X=41;break}}else X=41;while(0);if((X|0)==41)if(T)X=77;else{V=d;W=n}if((X|0)==77){f[h>>2]=f[h>>2]|2;V=d;W=n}while(1){if((V|0)==(e|0)){X=81;break}if((b[W>>0]|0)==2){Y=V;break}V=V+12|0;W=W+1|0}if((X|0)==81){f[h>>2]=f[h>>2]|4;Y=e}PSb(o);u=j;return Y|0}function F_b(a){a=a|0;dZb(a);return}function G_b(a){a=a|0;dZb(a);O5b(a);return}function H_b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=u;u=u+16|0;i=h+4|0;j=h;if(!(f[d+4>>2]&1)){k=f[(f[a>>2]|0)+24>>2]|0;f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];l=nh[k&127](a,i,d,e,g&1)|0}else{TXb(i,d);d=xZb(i,855516)|0;yZb(i);e=f[d>>2]|0;if(g)zh[f[e+24>>2]&2047](i,d);else zh[f[e+28>>2]&2047](i,d);d=i+11|0;e=b[d>>0]|0;if(e<<24>>24<0){m=e;n=f[i>>2]|0;o=8}else{p=i;q=e}while(1){if((o|0)==8){o=0;p=n;q=m}e=q<<24>>24<0;if((p|0)==((e?f[i>>2]|0:i)+(e?f[i+4>>2]|0:q&255)|0))break;e=b[p>>0]|0;g=f[c>>2]|0;if(g|0){a=g+24|0;k=f[a>>2]|0;if((k|0)==(f[g+28>>2]|0)){j=f[(f[g>>2]|0)+52>>2]|0;r=UWb(e)|0;s=Uh[j&1023](g,r)|0}else{f[a>>2]=k+1;b[k>>0]=e;s=UWb(e)|0}if(SXb(s,TWb()|0)|0)f[c>>2]=0}m=b[d>>0]|0;n=p+1|0;o=8}o=f[c>>2]|0;Z5b(i);l=o}u=h;return l|0}function I_b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+64|0;h=a;i=a+52|0;j=a+39|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[486436]|0;b[i+1>>0]=b[486437]|0;b[i+2>>0]=b[486438]|0;b[i+3>>0]=b[486439]|0;b[i+4>>0]=b[486440]|0;b[i+5>>0]=b[486441]|0;U_b(i+1|0,490368,1,f[d+4>>2]|0);o=AZb()|0;f[h>>2]=g;g=j+(P_b(j,13,o,i,h)|0)|0;i=Q_b(j,g,d)|0;TXb(h,d);V_b(j,i,g,k,l,m,h);yZb(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=uP(h,k,c,l,d,e)|0;u=a;return n|0}function J_b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+96|0;h=a+8|0;i=a;j=a+71|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;U_b(i+1|0,490373,1,f[c+4>>2]|0);o=AZb()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(P_b(j,23,o,i,h)|0)|0;i=Q_b(j,g,c)|0;TXb(h,c);V_b(j,i,g,k,l,m,h);yZb(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=uP(h,k,b,l,c,d)|0;u=a;return n|0}function K_b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+64|0;h=a;i=a+52|0;j=a+40|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[486436]|0;b[i+1>>0]=b[486437]|0;b[i+2>>0]=b[486438]|0;b[i+3>>0]=b[486439]|0;b[i+4>>0]=b[486440]|0;b[i+5>>0]=b[486441]|0;U_b(i+1|0,490368,0,f[d+4>>2]|0);o=AZb()|0;f[h>>2]=g;g=j+(P_b(j,12,o,i,h)|0)|0;i=Q_b(j,g,d)|0;TXb(h,d);V_b(j,i,g,k,l,m,h);yZb(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=uP(h,k,c,l,d,e)|0;u=a;return n|0}function L_b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+96|0;h=a+8|0;i=a;j=a+71|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;U_b(i+1|0,490373,0,f[c+4>>2]|0);o=AZb()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(P_b(j,23,o,i,h)|0)|0;i=Q_b(j,g,c)|0;TXb(h,c);V_b(j,i,g,k,l,m,h);yZb(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=uP(h,k,b,l,c,d)|0;u=a;return n|0}function M_b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;a=u;u=u+176|0;g=a+72|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+134|0;n=a+68|0;o=a+76|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=R_b(l+1|0,1124530,f[c+4>>2]|0)|0;f[n>>2]=m;v=AZb()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=P_b(m,30,v,l,k)|0}else{p[j>>3]=e;w=P_b(m,30,v,l,j)|0}if((w|0)>29){j=AZb()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=S_b(n,j,l,i)|0}else{p[h>>3]=e;x=S_b(n,j,l,h)|0}h=f[n>>2]|0;if(!h)Q5b();else{y=x;z=h;A=h}}else{y=w;z=0;A=f[n>>2]|0}n=A+y|0;w=Q_b(A,n,c)|0;if((A|0)!=(m|0)){m=OSb(y<<1)|0;if(!m)Q5b();else{B=m;C=m}}else{B=o;C=0}TXb(g,c);T_b(A,w,n,B,q,r,g);yZb(g);f[s>>2]=f[b>>2];b=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=uP(g,B,b,q,c,d)|0;PSb(C);PSb(z);u=a;return s|0}function N_b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;a=u;u=u+176|0;g=a+72|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+134|0;n=a+68|0;o=a+76|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=R_b(l+1|0,486434,f[c+4>>2]|0)|0;f[n>>2]=m;v=AZb()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=P_b(m,30,v,l,k)|0}else{p[j>>3]=e;w=P_b(m,30,v,l,j)|0}if((w|0)>29){j=AZb()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=S_b(n,j,l,i)|0}else{p[h>>3]=e;x=S_b(n,j,l,h)|0}h=f[n>>2]|0;if(!h)Q5b();else{y=x;z=h;A=h}}else{y=w;z=0;A=f[n>>2]|0}n=A+y|0;w=Q_b(A,n,c)|0;if((A|0)!=(m|0)){m=OSb(y<<1)|0;if(!m)Q5b();else{B=m;C=m}}else{B=o;C=0}TXb(g,c);T_b(A,w,n,B,q,r,g);yZb(g);f[s>>2]=f[b>>2];b=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=uP(g,B,b,q,c,d)|0;PSb(C);PSb(z);u=a;return s|0}function O_b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+80|0;h=a;i=a+68|0;j=a+48|0;k=a+8|0;l=a+4|0;b[i>>0]=b[486428]|0;b[i+1>>0]=b[486429]|0;b[i+2>>0]=b[486430]|0;b[i+3>>0]=b[486431]|0;b[i+4>>0]=b[486432]|0;b[i+5>>0]=b[486433]|0;m=AZb()|0;f[h>>2]=g;g=P_b(j,20,m,i,h)|0;i=j+g|0;m=Q_b(j,i,d)|0;TXb(h,d);n=xZb(h,855500)|0;yZb(h);Dg[f[(f[n>>2]|0)+32>>2]&127](n,j,i,k)|0;n=k+g|0;f[l>>2]=f[c>>2];f[h>>2]=f[l>>2];l=uP(h,k,(m|0)==(i|0)?n:k+(m-j)|0,n,d,e)|0;u=a;return l|0}function P_b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;f[h>>2]=e;e=oVb(c)|0;c=mUb(a,b,d,h)|0;if(e|0)oVb(e)|0;u=g;return c|0}function Q_b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;a:do switch((f[d+4>>2]&176)<<24>>24){case 16:{e=b[a>>0]|0;g=a+1|0;switch(e<<24>>24){case 43:case 45:{h=g;break a;break}default:{}}if((c-a|0)>1&e<<24>>24==48){switch(b[g>>0]|0){case 88:case 120:break;default:{i=6;break a}}h=a+2|0}else i=6;break}case 32:{h=c;break}default:i=6}while(0);if((i|0)==6)h=a;return h|0}function R_b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;if(!(d&2048))e=a;else{b[a>>0]=43;e=a+1|0}if(!(d&1024))f=e;else{b[e>>0]=35;f=e+1|0}e=d&260;a=(d&16384|0)!=0;d=(e|0)==260;if(d){g=0;h=f}else{b[f>>0]=46;b[f+1>>0]=42;g=1;h=f+2|0}f=c;c=h;while(1){h=b[f>>0]|0;if(!(h<<24>>24))break;b[c>>0]=h;f=f+1|0;c=c+1|0}a:do switch(e&511){case 4:{i=a?70:102;break}case 256:{i=a?69:101;break}default:if(d){i=a?65:97;break a}else{i=a?71:103;break a}}while(0);b[c>>0]=i;return g|0}function S_b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e;f[g>>2]=d;d=oVb(b)|0;b=ZUb(a,c,g)|0;if(d|0)oVb(d)|0;u=e;return b|0}function T_b(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=u;u=u+16|0;k=j;l=xZb(i,855500)|0;m=xZb(i,855516)|0;zh[f[(f[m>>2]|0)+20>>2]&2047](k,m);f[h>>2]=e;i=b[a>>0]|0;switch(i<<24>>24){case 43:case 45:{n=Uh[f[(f[l>>2]|0)+28>>2]&1023](l,i)|0;i=f[h>>2]|0;f[h>>2]=i+1;b[i>>0]=n;o=a+1|0;break}default:o=a}n=d;a:do if((n-o|0)>1?(b[o>>0]|0)==48:0){i=o+1|0;switch(b[i>>0]|0){case 88:case 120:break;default:{p=o;q=10;break a}}r=Uh[f[(f[l>>2]|0)+28>>2]&1023](l,48)|0;s=f[h>>2]|0;f[h>>2]=s+1;b[s>>0]=r;r=o+2|0;s=Uh[f[(f[l>>2]|0)+28>>2]&1023](l,b[i>>0]|0)|0;i=f[h>>2]|0;f[h>>2]=i+1;b[i>>0]=s;s=r;while(1){if(s>>>0>=d>>>0){t=r;v=s;break a}i=b[s>>0]|0;if(!(vVb(i,AZb()|0)|0)){t=r;v=s;break a}s=s+1|0}}else{p=o;q=10}while(0);b:do if((q|0)==10)while(1){q=0;if(p>>>0>=d>>>0){t=o;v=p;break b}s=b[p>>0]|0;if(!(kVb(s,AZb()|0)|0)){t=o;v=p;break b}p=p+1|0;q=10}while(0);p=k+11|0;o=b[p>>0]|0;s=k+4|0;r=t;i=a;c:do if((o<<24>>24<0?f[s>>2]|0:o&255)|0){d:do if((t|0)!=(v|0)){a=v;w=t;while(1){x=a+-1|0;if(w>>>0>=x>>>0)break d;y=b[w>>0]|0;b[w>>0]=b[x>>0]|0;b[x>>0]=y;a=x;w=w+1|0}}while(0);w=di[f[(f[m>>2]|0)+16>>2]&1023](m)|0;a=t;x=0;y=0;while(1){if(a>>>0>=v>>>0)break;z=b[((b[p>>0]|0)<0?f[k>>2]|0:k)+y>>0]|0;if(z<<24>>24>0&(x|0)==(z<<24>>24|0)){z=f[h>>2]|0;f[h>>2]=z+1;b[z>>0]=w;z=b[p>>0]|0;A=(y>>>0<((z<<24>>24<0?f[s>>2]|0:z&255)+-1|0)>>>0&1)+y|0;B=0}else{A=y;B=x}z=Uh[f[(f[l>>2]|0)+28>>2]&1023](l,b[a>>0]|0)|0;C=f[h>>2]|0;f[h>>2]=C+1;b[C>>0]=z;a=a+1|0;x=B+1|0;y=A}y=e+(r-i)|0;x=f[h>>2]|0;if((y|0)==(x|0))D=l;else{a=x;x=y;while(1){y=a+-1|0;if(x>>>0>=y>>>0){D=l;break c}w=b[x>>0]|0;b[x>>0]=b[y>>0]|0;b[y>>0]=w;a=y;x=x+1|0}}}else{Dg[f[(f[l>>2]|0)+32>>2]&127](l,t,v,f[h>>2]|0)|0;f[h>>2]=(f[h>>2]|0)+(v-r);D=l}while(0);r=v;while(1){if(r>>>0>=d>>>0){E=r;break}v=b[r>>0]|0;F=r+1|0;if(v<<24>>24==46){q=29;break}t=Uh[f[(f[D>>2]|0)+28>>2]&1023](l,v)|0;v=f[h>>2]|0;f[h>>2]=v+1;b[v>>0]=t;r=F}if((q|0)==29){q=di[f[(f[m>>2]|0)+12>>2]&1023](m)|0;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=q;E=F}Dg[f[(f[l>>2]|0)+32>>2]&127](l,E,d,f[h>>2]|0)|0;l=(f[h>>2]|0)+(n-E)|0;f[h>>2]=l;f[g>>2]=(c|0)==(d|0)?l:e+(c-i)|0;Z5b(k);u=j;return}function U_b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;if(!(e&2048))f=a;else{b[a>>0]=43;f=a+1|0}if(!(e&512)){g=c;h=f}else{b[f>>0]=35;g=c;h=f+1|0}while(1){f=b[g>>0]|0;if(!(f<<24>>24))break;b[h>>0]=f;g=g+1|0;h=h+1|0}switch(e&74){case 64:{i=111;break}case 8:{i=e&16384|0?88:120;break}default:i=d?100:117}b[h>>0]=i;return}function V_b(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;j=u;u=u+16|0;k=j;l=xZb(i,855500)|0;m=xZb(i,855516)|0;zh[f[(f[m>>2]|0)+20>>2]&2047](k,m);i=k+11|0;n=b[i>>0]|0;o=k+4|0;p=a;q=d;if((n<<24>>24<0?f[o>>2]|0:n&255)|0){f[h>>2]=e;n=b[a>>0]|0;switch(n<<24>>24){case 43:case 45:{r=Uh[f[(f[l>>2]|0)+28>>2]&1023](l,n)|0;n=f[h>>2]|0;f[h>>2]=n+1;b[n>>0]=r;s=a+1|0;break}default:s=a}a:do if((q-s|0)>1?(b[s>>0]|0)==48:0){r=s+1|0;switch(b[r>>0]|0){case 88:case 120:break;default:{t=s;break a}}n=Uh[f[(f[l>>2]|0)+28>>2]&1023](l,48)|0;v=f[h>>2]|0;f[h>>2]=v+1;b[v>>0]=n;n=Uh[f[(f[l>>2]|0)+28>>2]&1023](l,b[r>>0]|0)|0;r=f[h>>2]|0;f[h>>2]=r+1;b[r>>0]=n;t=s+2|0}else t=s;while(0);b:do if((t|0)!=(d|0)){s=d;n=t;while(1){r=s+-1|0;if(n>>>0>=r>>>0)break b;v=b[n>>0]|0;b[n>>0]=b[r>>0]|0;b[r>>0]=v;s=r;n=n+1|0}}while(0);n=di[f[(f[m>>2]|0)+16>>2]&1023](m)|0;m=t;s=0;r=0;while(1){if(m>>>0>=d>>>0)break;v=b[((b[i>>0]|0)<0?f[k>>2]|0:k)+s>>0]|0;if(v<<24>>24!=0&(r|0)==(v<<24>>24|0)){v=f[h>>2]|0;f[h>>2]=v+1;b[v>>0]=n;v=b[i>>0]|0;w=(s>>>0<((v<<24>>24<0?f[o>>2]|0:v&255)+-1|0)>>>0&1)+s|0;x=0}else{w=s;x=r}v=Uh[f[(f[l>>2]|0)+28>>2]&1023](l,b[m>>0]|0)|0;y=f[h>>2]|0;f[h>>2]=y+1;b[y>>0]=v;m=m+1|0;s=w;r=x+1|0}x=e+(t-p)|0;t=f[h>>2]|0;if((x|0)==(t|0))z=x;else{r=t;t=x;while(1){x=r+-1|0;if(t>>>0>=x>>>0)break;w=b[t>>0]|0;b[t>>0]=b[x>>0]|0;b[x>>0]=w;r=x;t=t+1|0}z=f[h>>2]|0}}else{Dg[f[(f[l>>2]|0)+32>>2]&127](l,a,d,e)|0;a=e+(q-p)|0;f[h>>2]=a;z=a}f[g>>2]=(c|0)==(d|0)?z:e+(c-p)|0;Z5b(k);u=j;return}function W_b(a){a=a|0;dZb(a);return}function X_b(a){a=a|0;dZb(a);O5b(a);return}function Y_b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=u;u=u+16|0;i=h+4|0;j=h;if(!(f[d+4>>2]&1)){k=f[(f[a>>2]|0)+24>>2]|0;f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];l=nh[k&127](a,i,d,e,g&1)|0}else{TXb(i,d);d=xZb(i,855540)|0;yZb(i);e=f[d>>2]|0;if(g)zh[f[e+24>>2]&2047](i,d);else zh[f[e+28>>2]&2047](i,d);d=i+8+3|0;e=b[d>>0]|0;g=f[i>>2]|0;a=i+4|0;k=e<<24>>24<0?g:i;j=e;e=g;while(1){g=j<<24>>24<0;if((k|0)==((g?e:i)+((g?f[a>>2]|0:j&255)<<2)|0))break;g=f[k>>2]|0;m=f[c>>2]|0;if(m|0){n=m+24|0;o=f[n>>2]|0;if((o|0)==(f[m+28>>2]|0)){p=f[(f[m>>2]|0)+52>>2]|0;q=kXb(g)|0;r=Uh[p&1023](m,q)|0}else{f[n>>2]=o+4;f[o>>2]=g;r=kXb(g)|0}if(UXb(r,jXb()|0)|0)f[c>>2]=0}k=k+4|0;j=b[d>>0]|0;e=f[i>>2]|0}e=f[c>>2]|0;v6b(i);l=e}u=h;return l|0}function Z_b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+128|0;h=a;i=a+122|0;j=a+108|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[486436]|0;b[i+1>>0]=b[486437]|0;b[i+2>>0]=b[486438]|0;b[i+3>>0]=b[486439]|0;b[i+4>>0]=b[486440]|0;b[i+5>>0]=b[486441]|0;U_b(i+1|0,490368,1,f[d+4>>2]|0);o=AZb()|0;f[h>>2]=g;g=j+(P_b(j,13,o,i,h)|0)|0;i=Q_b(j,g,d)|0;TXb(h,d);h$b(j,i,g,k,l,m,h);yZb(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=e$b(h,k,c,l,d,e)|0;u=a;return n|0}function __b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+224|0;h=a+8|0;i=a;j=a+200|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;U_b(i+1|0,490373,1,f[c+4>>2]|0);o=AZb()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(P_b(j,23,o,i,h)|0)|0;i=Q_b(j,g,c)|0;TXb(h,c);h$b(j,i,g,k,l,m,h);yZb(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=e$b(h,k,b,l,c,d)|0;u=a;return n|0}function $_b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+128|0;h=a;i=a+112|0;j=a+100|0;k=a+16|0;l=a+12|0;m=a+4|0;n=a+8|0;b[i>>0]=b[486436]|0;b[i+1>>0]=b[486437]|0;b[i+2>>0]=b[486438]|0;b[i+3>>0]=b[486439]|0;b[i+4>>0]=b[486440]|0;b[i+5>>0]=b[486441]|0;U_b(i+1|0,490368,0,f[d+4>>2]|0);o=AZb()|0;f[h>>2]=g;g=j+(P_b(j,12,o,i,h)|0)|0;i=Q_b(j,g,d)|0;TXb(h,d);h$b(j,i,g,k,l,m,h);yZb(h);f[n>>2]=f[c>>2];c=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=e$b(h,k,c,l,d,e)|0;u=a;return n|0}function a$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=u;u=u+224|0;h=a+8|0;i=a;j=a+200|0;k=a+28|0;l=a+24|0;m=a+16|0;n=a+20|0;o=i;f[o>>2]=37;f[o+4>>2]=0;U_b(i+1|0,490373,0,f[c+4>>2]|0);o=AZb()|0;p=h;f[p>>2]=e;f[p+4>>2]=g;g=j+(P_b(j,23,o,i,h)|0)|0;i=Q_b(j,g,c)|0;TXb(h,c);h$b(j,i,g,k,l,m,h);yZb(h);f[n>>2]=f[b>>2];b=f[l>>2]|0;l=f[m>>2]|0;f[h>>2]=f[n>>2];n=e$b(h,k,b,l,c,d)|0;u=a;return n|0}function b$b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+336|0;g=a+300|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+304|0;n=a+296|0;o=a+68|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=R_b(l+1|0,1124530,f[c+4>>2]|0)|0;f[n>>2]=m;v=AZb()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=P_b(m,30,v,l,k)|0}else{p[j>>3]=e;w=P_b(m,30,v,l,j)|0}if((w|0)>29){j=AZb()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=S_b(n,j,l,i)|0}else{p[h>>3]=e;x=S_b(n,j,l,h)|0}h=f[n>>2]|0;if(!h)Q5b();else{y=x;z=h;A=h}}else{y=w;z=0;A=f[n>>2]|0}n=A+y|0;w=Q_b(A,n,c)|0;do if((A|0)!=(m|0)){h=OSb(y<<3)|0;if(!h)Q5b();else{B=h;C=0;D=h;break}}else{B=o;C=1;D=0}while(0);TXb(g,c);g$b(A,w,n,B,q,r,g);yZb(g);f[s>>2]=f[b>>2];n=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=e$b(g,B,n,q,c,d)|0;f[b>>2]=s;if(!C)PSb(D);PSb(z);u=a;return s|0}function c$b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+336|0;g=a+300|0;h=a+48|0;i=a+32|0;j=a+24|0;k=a+8|0;l=a;m=a+304|0;n=a+296|0;o=a+68|0;q=a+64|0;r=a+60|0;s=a+56|0;t=l;f[t>>2]=37;f[t+4>>2]=0;t=R_b(l+1|0,486434,f[c+4>>2]|0)|0;f[n>>2]=m;v=AZb()|0;if(t){f[k>>2]=f[c+8>>2];p[k+8>>3]=e;w=P_b(m,30,v,l,k)|0}else{p[j>>3]=e;w=P_b(m,30,v,l,j)|0}if((w|0)>29){j=AZb()|0;if(t){f[i>>2]=f[c+8>>2];p[i+8>>3]=e;x=S_b(n,j,l,i)|0}else{p[h>>3]=e;x=S_b(n,j,l,h)|0}h=f[n>>2]|0;if(!h)Q5b();else{y=x;z=h;A=h}}else{y=w;z=0;A=f[n>>2]|0}n=A+y|0;w=Q_b(A,n,c)|0;do if((A|0)!=(m|0)){h=OSb(y<<3)|0;if(!h)Q5b();else{B=h;C=0;D=h;break}}else{B=o;C=1;D=0}while(0);TXb(g,c);g$b(A,w,n,B,q,r,g);yZb(g);f[s>>2]=f[b>>2];n=f[q>>2]|0;q=f[r>>2]|0;f[g>>2]=f[s>>2];s=e$b(g,B,n,q,c,d)|0;f[b>>2]=s;if(!C)PSb(D);PSb(z);u=a;return s|0}function d$b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;a=u;u=u+192|0;h=a;i=a+176|0;j=a+156|0;k=a+4|0;l=a+152|0;b[i>>0]=b[486428]|0;b[i+1>>0]=b[486429]|0;b[i+2>>0]=b[486430]|0;b[i+3>>0]=b[486431]|0;b[i+4>>0]=b[486432]|0;b[i+5>>0]=b[486433]|0;m=AZb()|0;f[h>>2]=g;g=P_b(j,20,m,i,h)|0;i=j+g|0;m=Q_b(j,i,d)|0;TXb(h,d);n=xZb(h,855532)|0;yZb(h);Dg[f[(f[n>>2]|0)+48>>2]&127](n,j,i,k)|0;n=k+(g<<2)|0;f[l>>2]=f[c>>2];f[h>>2]=f[l>>2];l=e$b(h,k,(m|0)==(i|0)?n:k+(m-j<<2)|0,n,d,e)|0;u=a;return l|0}function e$b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;i=u;u=u+16|0;j=i+12|0;k=i;l=f[a>>2]|0;a:do if(!l)m=0;else{n=e;o=c;p=n-o>>2;q=g+12|0;r=f[q>>2]|0;s=(r|0)>(p|0)?r-p|0:0;p=d;r=p-o|0;o=r>>2;if((r|0)>0?(li[f[(f[l>>2]|0)+48>>2]&511](l,c,o)|0)!=(o|0):0){f[a>>2]=0;m=0;break}do if((s|0)>0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(s>>>0>1073741807)V5b(k);do if(s>>>0>=2){o=s+4&2147483644;if(o>>>0>1073741823)Re();else{r=L5b(o<<2)|0;f[k>>2]=r;t=k+8|0;f[t>>2]=o|-2147483648;f[k+4>>2]=s;v=r;w=t+3|0;x=k;break}}else{t=k+8+3|0;b[t>>0]=s;v=k;w=t;x=k}while(0);f$b(v,s,h)|0;f[j>>2]=0;jZb(v+(s<<2)|0,j);if((li[f[(f[l>>2]|0)+48>>2]&511](l,(b[w>>0]|0)<0?f[k>>2]|0:x,s)|0)==(s|0)){v6b(k);break}else{f[a>>2]=0;v6b(k);m=0;break a}}while(0);s=n-p|0;t=s>>2;if((s|0)>0?(li[f[(f[l>>2]|0)+48>>2]&511](l,d,t)|0)!=(t|0):0){f[a>>2]=0;m=0;break}f[q>>2]=0;m=l}while(0);u=i;return m|0}function f$b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!b)d=a;else{aWb(a,c,b)|0;d=a}return d|0}function g$b(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;j=u;u=u+16|0;k=j;l=xZb(i,855532)|0;m=xZb(i,855540)|0;zh[f[(f[m>>2]|0)+20>>2]&2047](k,m);f[h>>2]=e;i=b[a>>0]|0;switch(i<<24>>24){case 43:case 45:{n=Uh[f[(f[l>>2]|0)+44>>2]&1023](l,i)|0;i=f[h>>2]|0;f[h>>2]=i+4;f[i>>2]=n;o=a+1|0;break}default:o=a}n=d;a:do if((n-o|0)>1?(b[o>>0]|0)==48:0){i=o+1|0;switch(b[i>>0]|0){case 88:case 120:break;default:{p=o;q=10;break a}}r=Uh[f[(f[l>>2]|0)+44>>2]&1023](l,48)|0;s=f[h>>2]|0;f[h>>2]=s+4;f[s>>2]=r;r=o+2|0;s=Uh[f[(f[l>>2]|0)+44>>2]&1023](l,b[i>>0]|0)|0;i=f[h>>2]|0;f[h>>2]=i+4;f[i>>2]=s;s=r;while(1){if(s>>>0>=d>>>0){t=r;v=s;break a}i=b[s>>0]|0;if(!(vVb(i,AZb()|0)|0)){t=r;v=s;break a}s=s+1|0}}else{p=o;q=10}while(0);b:do if((q|0)==10)while(1){q=0;if(p>>>0>=d>>>0){t=o;v=p;break b}s=b[p>>0]|0;if(!(kVb(s,AZb()|0)|0)){t=o;v=p;break b}p=p+1|0;q=10}while(0);p=k+11|0;o=b[p>>0]|0;s=k+4|0;r=t;i=a;c:do if((o<<24>>24<0?f[s>>2]|0:o&255)|0){d:do if((t|0)!=(v|0)){a=v;w=t;while(1){x=a+-1|0;if(w>>>0>=x>>>0)break d;y=b[w>>0]|0;b[w>>0]=b[x>>0]|0;b[x>>0]=y;a=x;w=w+1|0}}while(0);w=di[f[(f[m>>2]|0)+16>>2]&1023](m)|0;a=t;x=0;y=0;while(1){if(a>>>0>=v>>>0)break;z=b[p>>0]|0;A=z<<24>>24<0;B=b[(A?f[k>>2]|0:k)+x>>0]|0;if(B<<24>>24>0&(y|0)==(B<<24>>24|0)){B=f[h>>2]|0;f[h>>2]=B+4;f[B>>2]=w;C=(x>>>0<((A?f[s>>2]|0:z&255)+-1|0)>>>0&1)+x|0;D=0}else{C=x;D=y}z=Uh[f[(f[l>>2]|0)+44>>2]&1023](l,b[a>>0]|0)|0;A=f[h>>2]|0;f[h>>2]=A+4;f[A>>2]=z;a=a+1|0;x=C;y=D+1|0}y=e+(r-i<<2)|0;x=f[h>>2]|0;if((y|0)==(x|0)){E=l;F=y}else{a=x;w=y;while(1){y=a+-4|0;if(w>>>0>=y>>>0){E=l;F=x;break c}z=f[w>>2]|0;f[w>>2]=f[y>>2];f[y>>2]=z;a=y;w=w+4|0}}}else{Dg[f[(f[l>>2]|0)+48>>2]&127](l,t,v,f[h>>2]|0)|0;w=(f[h>>2]|0)+(v-r<<2)|0;f[h>>2]=w;E=l;F=w}while(0);r=v;v=F;while(1){if(r>>>0>=d>>>0){G=r;H=v;break}F=b[r>>0]|0;I=r+1|0;if(F<<24>>24==46){q=29;break}t=Uh[f[(f[E>>2]|0)+44>>2]&1023](l,F)|0;F=f[h>>2]|0;D=F+4|0;f[h>>2]=D;f[F>>2]=t;r=I;v=D}if((q|0)==29){q=di[f[(f[m>>2]|0)+12>>2]&1023](m)|0;m=f[h>>2]|0;v=m+4|0;f[h>>2]=v;f[m>>2]=q;G=I;H=v}Dg[f[(f[l>>2]|0)+48>>2]&127](l,G,d,H)|0;H=(f[h>>2]|0)+(n-G<<2)|0;f[h>>2]=H;f[g>>2]=(c|0)==(d|0)?H:e+(c-i<<2)|0;Z5b(k);u=j;return}function h$b(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;j=u;u=u+16|0;k=j;l=xZb(i,855532)|0;m=xZb(i,855540)|0;zh[f[(f[m>>2]|0)+20>>2]&2047](k,m);i=k+11|0;n=b[i>>0]|0;o=k+4|0;p=a;q=d;if((n<<24>>24<0?f[o>>2]|0:n&255)|0){f[h>>2]=e;n=b[a>>0]|0;switch(n<<24>>24){case 43:case 45:{r=Uh[f[(f[l>>2]|0)+44>>2]&1023](l,n)|0;n=f[h>>2]|0;f[h>>2]=n+4;f[n>>2]=r;s=a+1|0;break}default:s=a}a:do if((q-s|0)>1?(b[s>>0]|0)==48:0){r=s+1|0;switch(b[r>>0]|0){case 88:case 120:break;default:{t=s;break a}}n=Uh[f[(f[l>>2]|0)+44>>2]&1023](l,48)|0;v=f[h>>2]|0;f[h>>2]=v+4;f[v>>2]=n;n=Uh[f[(f[l>>2]|0)+44>>2]&1023](l,b[r>>0]|0)|0;r=f[h>>2]|0;f[h>>2]=r+4;f[r>>2]=n;t=s+2|0}else t=s;while(0);b:do if((t|0)!=(d|0)){s=d;n=t;while(1){r=s+-1|0;if(n>>>0>=r>>>0)break b;v=b[n>>0]|0;b[n>>0]=b[r>>0]|0;b[r>>0]=v;s=r;n=n+1|0}}while(0);n=di[f[(f[m>>2]|0)+16>>2]&1023](m)|0;m=t;s=0;r=0;while(1){if(m>>>0>=d>>>0)break;v=b[i>>0]|0;w=v<<24>>24<0;x=b[(w?f[k>>2]|0:k)+s>>0]|0;if(x<<24>>24!=0&(r|0)==(x<<24>>24|0)){x=f[h>>2]|0;f[h>>2]=x+4;f[x>>2]=n;y=(s>>>0<((w?f[o>>2]|0:v&255)+-1|0)>>>0&1)+s|0;z=0}else{y=s;z=r}v=Uh[f[(f[l>>2]|0)+44>>2]&1023](l,b[m>>0]|0)|0;w=f[h>>2]|0;f[h>>2]=w+4;f[w>>2]=v;m=m+1|0;s=y;r=z+1|0}z=e+(t-p<<2)|0;t=f[h>>2]|0;if((z|0)==(t|0))A=z;else{r=t;t=z;while(1){z=r+-4|0;if(t>>>0>=z>>>0)break;y=f[t>>2]|0;f[t>>2]=f[z>>2];f[z>>2]=y;r=z;t=t+4|0}A=f[h>>2]|0}}else{Dg[f[(f[l>>2]|0)+48>>2]&127](l,a,d,e)|0;a=e+(q-p<<2)|0;f[h>>2]=a;A=a}f[g>>2]=(c|0)==(d|0)?A:e+(c-p<<2)|0;Z5b(k);u=j;return}function i$b(a){a=a|0;dZb(a);return}function j$b(a){a=a|0;dZb(a);O5b(a);return}function k$b(a){a=a|0;return 2}function l$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=G$b(a,j,i,d,e,g,486959,486967)|0;u=h;return l|0}function m$b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i+12|0;k=i+8|0;l=i+4|0;m=i;n=a+8|0;o=di[f[(f[n>>2]|0)+20>>2]&1023](n)|0;f[l>>2]=f[c>>2];f[m>>2]=f[d>>2];d=b[o+11>>0]|0;c=d<<24>>24<0;n=c?f[o>>2]|0:o;p=n+(c?f[o+4>>2]|0:d&255)|0;f[k>>2]=f[l>>2];f[j>>2]=f[m>>2];m=G$b(a,k,j,e,g,h,n,p)|0;u=i;return m|0}function n$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;TXb(i,d);d=xZb(i,855500)|0;yZb(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];E$b(a,g+24|0,b,i,e,d);u=h;return f[b>>2]|0}function o$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;TXb(i,d);d=xZb(i,855500)|0;yZb(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];F$b(a,g+16|0,b,i,e,d);u=h;return f[b>>2]|0}function p$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;TXb(i,d);d=xZb(i,855500)|0;yZb(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];R$b(a,g+20|0,b,i,e,d);u=h;return f[b>>2]|0}function q$b(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;j=u;u=u+144|0;k=j+128|0;l=j+112|0;m=j+124|0;n=j+120|0;o=j+116|0;p=j+108|0;q=j+104|0;r=j+100|0;s=j+96|0;t=j+92|0;v=j+88|0;w=j+84|0;x=j+80|0;y=j+76|0;z=j+72|0;A=j+68|0;B=j+64|0;C=j+60|0;D=j+56|0;E=j+52|0;F=j+48|0;G=j+44|0;H=j+40|0;I=j+36|0;J=j+32|0;K=j+28|0;L=j+24|0;M=j+20|0;N=j+16|0;O=j+12|0;P=j+8|0;Q=j+4|0;R=j;f[g>>2]=0;TXb(k,e);S=xZb(k,855500)|0;yZb(k);T=h+8|0;U=h+20|0;V=h+16|0;W=h+24|0;X=a+8|0;do switch(i<<24>>24|0){case 65:case 97:{f[m>>2]=f[d>>2];f[k>>2]=f[m>>2];E$b(a,W,c,k,g,S);Y=26;break}case 104:case 66:case 98:{f[n>>2]=f[d>>2];f[k>>2]=f[n>>2];F$b(a,V,c,k,g,S);Y=26;break}case 99:{Z=di[f[(f[X>>2]|0)+12>>2]&1023](X)|0;f[o>>2]=f[c>>2];f[p>>2]=f[d>>2];_=b[Z+11>>0]|0;$=_<<24>>24<0;aa=$?f[Z>>2]|0:Z;ba=aa+($?f[Z+4>>2]|0:_&255)|0;f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];_=G$b(a,l,k,e,g,h,aa,ba)|0;f[c>>2]=_;Y=26;break}case 101:case 100:{f[q>>2]=f[d>>2];f[k>>2]=f[q>>2];H$b(a,h+12|0,c,k,g,S);Y=26;break}case 68:{f[r>>2]=f[c>>2];f[s>>2]=f[d>>2];f[l>>2]=f[r>>2];f[k>>2]=f[s>>2];_=G$b(a,l,k,e,g,h,486919,486927)|0;f[c>>2]=_;Y=26;break}case 70:{f[t>>2]=f[c>>2];f[v>>2]=f[d>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];_=G$b(a,l,k,e,g,h,486927,486935)|0;f[c>>2]=_;Y=26;break}case 72:{f[w>>2]=f[d>>2];f[k>>2]=f[w>>2];I$b(a,T,c,k,g,S);Y=26;break}case 73:{f[x>>2]=f[d>>2];f[k>>2]=f[x>>2];J$b(a,T,c,k,g,S);Y=26;break}case 106:{f[y>>2]=f[d>>2];f[k>>2]=f[y>>2];K$b(a,h+28|0,c,k,g,S);Y=26;break}case 109:{f[z>>2]=f[d>>2];f[k>>2]=f[z>>2];L$b(a,V,c,k,g,S);Y=26;break}case 77:{f[A>>2]=f[d>>2];f[k>>2]=f[A>>2];M$b(a,h+4|0,c,k,g,S);Y=26;break}case 116:case 110:{f[B>>2]=f[d>>2];f[k>>2]=f[B>>2];N$b(a,c,k,g,S);Y=26;break}case 112:{f[C>>2]=f[d>>2];f[k>>2]=f[C>>2];O$b(a,T,c,k,g,S);Y=26;break}case 114:{f[D>>2]=f[c>>2];f[E>>2]=f[d>>2];f[l>>2]=f[D>>2];f[k>>2]=f[E>>2];_=G$b(a,l,k,e,g,h,486935,486946)|0;f[c>>2]=_;Y=26;break}case 82:{f[F>>2]=f[c>>2];f[G>>2]=f[d>>2];f[l>>2]=f[F>>2];f[k>>2]=f[G>>2];_=G$b(a,l,k,e,g,h,486946,486951)|0;f[c>>2]=_;Y=26;break}case 83:{f[H>>2]=f[d>>2];f[k>>2]=f[H>>2];P$b(a,h,c,k,g,S);Y=26;break}case 84:{f[I>>2]=f[c>>2];f[J>>2]=f[d>>2];f[l>>2]=f[I>>2];f[k>>2]=f[J>>2];_=G$b(a,l,k,e,g,h,486951,486959)|0;f[c>>2]=_;Y=26;break}case 119:{f[K>>2]=f[d>>2];f[k>>2]=f[K>>2];Q$b(a,W,c,k,g,S);Y=26;break}case 120:{_=f[(f[a>>2]|0)+20>>2]|0;f[L>>2]=f[c>>2];f[M>>2]=f[d>>2];f[l>>2]=f[L>>2];f[k>>2]=f[M>>2];ca=Xf[_&127](a,l,k,e,g,h)|0;break}case 88:{_=di[f[(f[X>>2]|0)+24>>2]&1023](X)|0;f[N>>2]=f[c>>2];f[O>>2]=f[d>>2];ba=b[_+11>>0]|0;aa=ba<<24>>24<0;Z=aa?f[_>>2]|0:_;$=Z+(aa?f[_+4>>2]|0:ba&255)|0;f[l>>2]=f[N>>2];f[k>>2]=f[O>>2];ba=G$b(a,l,k,e,g,h,Z,$)|0;f[c>>2]=ba;Y=26;break}case 121:{f[P>>2]=f[d>>2];f[k>>2]=f[P>>2];R$b(a,U,c,k,g,S);Y=26;break}case 89:{f[Q>>2]=f[d>>2];f[k>>2]=f[Q>>2];S$b(a,U,c,k,g,S);Y=26;break}case 37:{f[R>>2]=f[d>>2];f[k>>2]=f[R>>2];T$b(a,c,k,g,S);Y=26;break}default:{f[g>>2]=f[g>>2]|4;Y=26}}while(0);if((Y|0)==26)ca=f[c>>2]|0;u=j;return ca|0}function r$b(a){a=a|0;if((b[499416]|0)==0?Cac(499416)|0:0){C$b();f[214093]=856204}return f[214093]|0}function s$b(a){a=a|0;if((b[499400]|0)==0?Cac(499400)|0:0){A$b();f[214050]=855912}return f[214050]|0}function t$b(a){a=a|0;if((b[499384]|0)==0?Cac(499384)|0:0){y$b();f[213977]=855620}return f[213977]|0}function u$b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[499376]|0)==0?Cac(499376)|0:0){f[213902]=0;f[213903]=0;f[213904]=0;d=OXb(486677)|0;if(d>>>0>4294967279)V5b(855608);if(d>>>0<11){b[855619]=d;e=855608}else{g=d+16&-16;h=L5b(g)|0;f[213902]=h;f[213904]=g|-2147483648;f[213903]=d;e=h}VWb(e,486677,d)|0;b[c>>0]=0;PXb(e+d|0,c);zd(1483,855608,x|0)|0}u=a;return 855608}function v$b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[499368]|0)==0?Cac(499368)|0:0){f[213899]=0;f[213900]=0;f[213901]=0;d=OXb(486665)|0;if(d>>>0>4294967279)V5b(855596);if(d>>>0<11){b[855607]=d;e=855596}else{g=d+16&-16;h=L5b(g)|0;f[213899]=h;f[213901]=g|-2147483648;f[213900]=d;e=h}VWb(e,486665,d)|0;b[c>>0]=0;PXb(e+d|0,c);zd(1483,855596,x|0)|0}u=a;return 855596}function w$b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[499360]|0)==0?Cac(499360)|0:0){f[213896]=0;f[213897]=0;f[213898]=0;d=OXb(486656)|0;if(d>>>0>4294967279)V5b(855584);if(d>>>0<11){b[855595]=d;e=855584}else{g=d+16&-16;h=L5b(g)|0;f[213896]=h;f[213898]=g|-2147483648;f[213897]=d;e=h}VWb(e,486656,d)|0;b[c>>0]=0;PXb(e+d|0,c);zd(1483,855584,x|0)|0}u=a;return 855584}function x$b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[499352]|0)==0?Cac(499352)|0:0){f[213893]=0;f[213894]=0;f[213895]=0;d=OXb(486647)|0;if(d>>>0>4294967279)V5b(855572);if(d>>>0<11){b[855583]=d;e=855572}else{g=d+16&-16;h=L5b(g)|0;f[213893]=h;f[213895]=g|-2147483648;f[213894]=d;e=h}VWb(e,486647,d)|0;b[c>>0]=0;PXb(e+d|0,c);zd(1483,855572,x|0)|0}u=a;return 855572}function y$b(){var a=0,c=0;if((b[499392]|0)==0?Cac(499392)|0:0){a=855620;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=855908);zd(1542,0,x|0)|0}d6b(855620,486698)|0;d6b(855632,486701)|0;return}function z$b(a){a=a|0;a=855908;do{a=a+-12|0;Z5b(a)}while((a|0)!=855620);return}function A$b(){var a=0,c=0;if((b[499408]|0)==0?Cac(499408)|0:0){a=855912;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=856200);zd(1543,0,x|0)|0}d6b(855912,486704)|0;d6b(855924,486712)|0;d6b(855936,486721)|0;d6b(855948,486727)|0;d6b(855960,486733)|0;d6b(855972,486737)|0;d6b(855984,486742)|0;d6b(855996,486747)|0;d6b(856008,486754)|0;d6b(856020,486764)|0;d6b(856032,486772)|0;d6b(856044,486781)|0;d6b(856056,486790)|0;d6b(856068,486794)|0;d6b(856080,486798)|0;d6b(856092,486802)|0;d6b(856104,486733)|0;d6b(856116,486806)|0;d6b(856128,486810)|0;d6b(856140,486814)|0;d6b(856152,486818)|0;d6b(856164,486822)|0;d6b(856176,486826)|0;d6b(856188,486830)|0;return}function B$b(a){a=a|0;a=856200;do{a=a+-12|0;Z5b(a)}while((a|0)!=855912);return}function C$b(){var a=0,c=0;if((b[499424]|0)==0?Cac(499424)|0:0){a=856204;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=856372);zd(1544,0,x|0)|0}d6b(856204,486834)|0;d6b(856216,486841)|0;d6b(856228,486848)|0;d6b(856240,486856)|0;d6b(856252,486866)|0;d6b(856264,486875)|0;d6b(856276,486882)|0;d6b(856288,486891)|0;d6b(856300,486895)|0;d6b(856312,486899)|0;d6b(856324,486903)|0;d6b(856336,486907)|0;d6b(856348,486911)|0;d6b(856360,486915)|0;return}function D$b(a){a=a|0;a=856372;do{a=a+-12|0;Z5b(a)}while((a|0)!=856204);return}function E$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=di[f[f[k>>2]>>2]&1023](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(d_b(c,i,a,a+168|0,g,e,0)|0)-a|0;if((j|0)<168)f[b>>2]=((j|0)/12|0|0)%7|0;u=h;return}function F$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=di[f[(f[k>>2]|0)+4>>2]&1023](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(d_b(c,i,a,a+288|0,g,e,0)|0)-a|0;if((j|0)<288)f[b>>2]=((j|0)/12|0|0)%12|0;u=h;return}function G$b(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;l=u;u=u+16|0;m=l+12|0;n=l+8|0;o=l+4|0;p=l;TXb(m,g);q=xZb(m,855500)|0;yZb(m);f[h>>2]=0;r=q+8|0;s=j;j=0;a:while(1){t=(s|0)!=(k|0);v=j;while(1){w=f[c>>2]|0;if(!(t&(v|0)==0)){x=w;break a}y=w;if(w){z=f[w+12>>2]|0;if((z|0)==(f[w+16>>2]|0))A=di[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else A=UWb(b[z>>0]|0)|0;if(SXb(A,TWb()|0)|0){f[c>>2]=0;B=0;C=1;D=0}else{B=w;C=0;D=y}}else{B=0;C=1;D=y}y=f[e>>2]|0;w=y;do if(y){z=f[y+12>>2]|0;if((z|0)==(f[y+16>>2]|0))E=di[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else E=UWb(b[z>>0]|0)|0;if(!(SXb(E,TWb()|0)|0))if(C){F=y;G=w;break}else{H=61;break a}else{f[e>>2]=0;I=0;H=16;break}}else{I=w;H=16}while(0);if((H|0)==16){H=0;if(C){H=61;break a}else{F=0;G=I}}if((li[f[(f[q>>2]|0)+36>>2]&511](q,b[s>>0]|0,0)|0)<<24>>24==37){H=19;break}w=b[s>>0]|0;if(w<<24>>24>-1?(J=f[r>>2]|0,d[J+(w<<24>>24<<1)>>1]&8192):0){K=s;H=27;break}L=B+12|0;w=f[L>>2]|0;M=B+16|0;if((w|0)==(f[M>>2]|0))N=di[f[(f[B>>2]|0)+36>>2]&1023](B)|0;else N=UWb(b[w>>0]|0)|0;w=Uh[f[(f[q>>2]|0)+12>>2]&1023](q,N&255)|0;if(w<<24>>24==(Uh[f[(f[q>>2]|0)+12>>2]&1023](q,b[s>>0]|0)|0)<<24>>24){H=57;break}f[h>>2]=4;v=4}b:do if((H|0)==19){H=0;v=s+1|0;if((v|0)==(k|0)){H=61;break a}t=li[f[(f[q>>2]|0)+36>>2]&511](q,b[v>>0]|0,0)|0;switch(t<<24>>24){case 48:case 69:{w=s+2|0;if((w|0)==(k|0)){H=61;break a}O=t;P=li[f[(f[q>>2]|0)+36>>2]&511](q,b[w>>0]|0,0)|0;Q=v;break}default:{O=0;P=t;Q=s}}t=f[(f[a>>2]|0)+36>>2]|0;f[o>>2]=D;f[p>>2]=G;f[n>>2]=f[o>>2];f[m>>2]=f[p>>2];v=Di[t&15](a,n,m,g,h,i,P,O)|0;f[c>>2]=v;R=Q+2|0}else if((H|0)==27){while(1){H=0;v=K+1|0;if((v|0)==(k|0)){S=k;break}t=b[v>>0]|0;if(t<<24>>24<=-1){S=v;break}if(!(d[J+(t<<24>>24<<1)>>1]&8192)){S=v;break}else{K=v;H=27}}v=B;t=F;w=F;while(1){if(v){y=f[v+12>>2]|0;if((y|0)==(f[v+16>>2]|0))T=di[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else T=UWb(b[y>>0]|0)|0;if(SXb(T,TWb()|0)|0){f[c>>2]=0;U=1;V=0}else{U=0;V=v}}else{U=1;V=0}do if(w){y=f[w+12>>2]|0;if((y|0)==(f[w+16>>2]|0))W=di[f[(f[w>>2]|0)+36>>2]&1023](w)|0;else W=UWb(b[y>>0]|0)|0;if(!(SXb(W,TWb()|0)|0))if(U^(t|0)==0){X=t;Y=t;break}else{R=S;break b}else{f[e>>2]=0;Z=0;H=43;break}}else{Z=t;H=43}while(0);if((H|0)==43){H=0;if(U){R=S;break b}else{X=Z;Y=0}}y=V+12|0;z=f[y>>2]|0;_=V+16|0;if((z|0)==(f[_>>2]|0))$=di[f[(f[V>>2]|0)+36>>2]&1023](V)|0;else $=UWb(b[z>>0]|0)|0;if(($&255)<<24>>24<=-1){R=S;break b}if(!(d[(f[r>>2]|0)+($<<24>>24<<1)>>1]&8192)){R=S;break b}z=f[y>>2]|0;if((z|0)==(f[_>>2]|0)){di[f[(f[V>>2]|0)+40>>2]&1023](V)|0;v=V;t=X;w=Y;continue}else{f[y>>2]=z+1;UWb(b[z>>0]|0)|0;v=V;t=X;w=Y;continue}}}else if((H|0)==57){H=0;w=s+1|0;t=f[L>>2]|0;if((t|0)==(f[M>>2]|0)){di[f[(f[B>>2]|0)+40>>2]&1023](B)|0;R=w;break}else{f[L>>2]=t+1;UWb(b[t>>0]|0)|0;R=w;break}}while(0);s=R;j=f[h>>2]|0}if((H|0)==61){f[h>>2]=4;x=B}if(x){B=f[x+12>>2]|0;if((B|0)==(f[x+16>>2]|0))aa=di[f[(f[x>>2]|0)+36>>2]&1023](x)|0;else aa=UWb(b[B>>0]|0)|0;if(SXb(aa,TWb()|0)|0){f[c>>2]=0;ba=0;ca=1}else{ba=x;ca=0}}else{ba=0;ca=1}x=f[e>>2]|0;do if(x){c=f[x+12>>2]|0;if((c|0)==(f[x+16>>2]|0))da=di[f[(f[x>>2]|0)+36>>2]&1023](x)|0;else da=UWb(b[c>>0]|0)|0;if(!(SXb(da,TWb()|0)|0))if(ca)break;else{H=76;break}else{f[e>>2]=0;H=74;break}}else H=74;while(0);if((H|0)==74?ca:0)H=76;if((H|0)==76)f[h>>2]=f[h>>2]|2;u=l;return ba|0}function H$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=U$b(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<31&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function I$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=U$b(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<24&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function J$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=U$b(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<12&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function K$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=U$b(c,h,e,g,3)|0;g=f[e>>2]|0;if((i|0)<366&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function L$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=U$b(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<13&(g&4|0)==0)f[b>>2]=i+-1;else f[e>>2]=g|4;u=a;return}function M$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=U$b(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<60&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function N$b(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=h+8|0;a:while(1){h=f[c>>2]|0;do if(h){i=f[h+12>>2]|0;if((i|0)==(f[h+16>>2]|0))j=di[f[(f[h>>2]|0)+36>>2]&1023](h)|0;else j=UWb(b[i>>0]|0)|0;if(SXb(j,TWb()|0)|0){f[c>>2]=0;k=1;break}else{k=(f[c>>2]|0)==0;break}}else k=1;while(0);h=f[e>>2]|0;do if(h){i=f[h+12>>2]|0;if((i|0)==(f[h+16>>2]|0))l=di[f[(f[h>>2]|0)+36>>2]&1023](h)|0;else l=UWb(b[i>>0]|0)|0;if(!(SXb(l,TWb()|0)|0))if(k){m=h;break}else{n=h;break a}else{f[e>>2]=0;o=15;break}}else o=15;while(0);if((o|0)==15){o=0;if(k){n=0;break}else m=0}h=f[c>>2]|0;i=f[h+12>>2]|0;if((i|0)==(f[h+16>>2]|0))p=di[f[(f[h>>2]|0)+36>>2]&1023](h)|0;else p=UWb(b[i>>0]|0)|0;if((p&255)<<24>>24<=-1){n=m;break}if(!(d[(f[a>>2]|0)+(p<<24>>24<<1)>>1]&8192)){n=m;break}i=f[c>>2]|0;h=i+12|0;q=f[h>>2]|0;if((q|0)==(f[i+16>>2]|0)){di[f[(f[i>>2]|0)+40>>2]&1023](i)|0;continue}else{f[h>>2]=q+1;UWb(b[q>>0]|0)|0;continue}}m=f[c>>2]|0;do if(m){p=f[m+12>>2]|0;if((p|0)==(f[m+16>>2]|0))r=di[f[(f[m>>2]|0)+36>>2]&1023](m)|0;else r=UWb(b[p>>0]|0)|0;if(SXb(r,TWb()|0)|0){f[c>>2]=0;s=1;break}else{s=(f[c>>2]|0)==0;break}}else s=1;while(0);do if(n){c=f[n+12>>2]|0;if((c|0)==(f[n+16>>2]|0))t=di[f[(f[n>>2]|0)+36>>2]&1023](n)|0;else t=UWb(b[c>>0]|0)|0;if(!(SXb(t,TWb()|0)|0))if(s)break;else{o=40;break}else{f[e>>2]=0;o=38;break}}else o=38;while(0);if((o|0)==38?s:0)o=40;if((o|0)==40)f[g>>2]=f[g>>2]|2;return}function O$b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+16|0;j=i+4|0;k=i;l=a+8|0;a=di[f[(f[l>>2]|0)+8>>2]&1023](l)|0;l=b[a+11>>0]|0;if(l<<24>>24<0)m=f[a+4>>2]|0;else m=l&255;l=b[a+12+11>>0]|0;if(l<<24>>24<0)n=f[a+16>>2]|0;else n=l&255;do if((m|0)!=(0-n|0)){f[k>>2]=f[e>>2];f[j>>2]=f[k>>2];l=(d_b(d,j,a,a+24|0,h,g,0)|0)-a|0;o=f[c>>2]|0;if((o|0)==12&(l|0)==0){f[c>>2]=0;break}if((o|0)<12&(l|0)==12)f[c>>2]=o+12}else f[g>>2]=f[g>>2]|4;while(0);u=i;return}function P$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=U$b(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<61&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function Q$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=U$b(c,h,e,g,1)|0;g=f[e>>2]|0;if((i|0)<7&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function R$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=U$b(c,h,e,g,4)|0;if(!(f[e>>2]&4)){if((i|0)<69)j=i+2e3|0;else j=(i|0)<100?i+1900|0:i;f[b>>2]=j+-1900}u=a;return}function S$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=U$b(c,h,e,g,4)|0;if(!(f[e>>2]&4))f[b>>2]=i+-1900;u=a;return}function T$b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=f[c>>2]|0;do if(a){h=f[a+12>>2]|0;if((h|0)==(f[a+16>>2]|0))i=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0;else i=UWb(b[h>>0]|0)|0;if(SXb(i,TWb()|0)|0){f[c>>2]=0;j=1;break}else{j=(f[c>>2]|0)==0;break}}else j=1;while(0);i=f[d>>2]|0;do if(i){a=f[i+12>>2]|0;if((a|0)==(f[i+16>>2]|0))k=di[f[(f[i>>2]|0)+36>>2]&1023](i)|0;else k=UWb(b[a>>0]|0)|0;if(!(SXb(k,TWb()|0)|0))if(j){l=i;m=16;break}else{n=6;m=38;break}else{f[d>>2]=0;m=14;break}}else m=14;while(0);if((m|0)==14)if(j){n=6;m=38}else{l=0;m=16}a:do if((m|0)==16){j=f[c>>2]|0;i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))o=di[f[(f[j>>2]|0)+36>>2]&1023](j)|0;else o=UWb(b[i>>0]|0)|0;if((li[f[(f[g>>2]|0)+36>>2]&511](g,o&255,0)|0)<<24>>24==37){i=f[c>>2]|0;j=i+12|0;k=f[j>>2]|0;if((k|0)==(f[i+16>>2]|0))di[f[(f[i>>2]|0)+40>>2]&1023](i)|0;else{f[j>>2]=k+1;UWb(b[k>>0]|0)|0}k=f[c>>2]|0;do if(k){j=f[k+12>>2]|0;if((j|0)==(f[k+16>>2]|0))p=di[f[(f[k>>2]|0)+36>>2]&1023](k)|0;else p=UWb(b[j>>0]|0)|0;if(SXb(p,TWb()|0)|0){f[c>>2]=0;q=1;break}else{q=(f[c>>2]|0)==0;break}}else q=1;while(0);do if(l|0){k=f[l+12>>2]|0;if((k|0)==(f[l+16>>2]|0))r=di[f[(f[l>>2]|0)+36>>2]&1023](l)|0;else r=UWb(b[k>>0]|0)|0;if(!(SXb(r,TWb()|0)|0))if(q)break a;else{n=2;m=38;break a}else{f[d>>2]=0;break}}while(0);if(q){n=2;m=38}}else{n=4;m=38}}while(0);if((m|0)==38)f[e>>2]=f[e>>2]|n;return}function U$b(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=f[a>>2]|0;do if(i){j=f[i+12>>2]|0;if((j|0)==(f[i+16>>2]|0))k=di[f[(f[i>>2]|0)+36>>2]&1023](i)|0;else k=UWb(b[j>>0]|0)|0;if(SXb(k,TWb()|0)|0){f[a>>2]=0;l=1;break}else{l=(f[a>>2]|0)==0;break}}else l=1;while(0);k=f[c>>2]|0;do if(k){i=f[k+12>>2]|0;if((i|0)==(f[k+16>>2]|0))m=di[f[(f[k>>2]|0)+36>>2]&1023](k)|0;else m=UWb(b[i>>0]|0)|0;if(!(SXb(m,TWb()|0)|0))if(l){n=k;o=17;break}else{o=16;break}else{f[c>>2]=0;o=14;break}}else o=14;while(0);if((o|0)==14)if(l)o=16;else{n=0;o=17}a:do if((o|0)==16){f[e>>2]=f[e>>2]|6;p=0}else if((o|0)==17){l=f[a>>2]|0;k=f[l+12>>2]|0;if((k|0)==(f[l+16>>2]|0))q=di[f[(f[l>>2]|0)+36>>2]&1023](l)|0;else q=UWb(b[k>>0]|0)|0;k=q&255;if(k<<24>>24>-1?(l=g+8|0,d[(f[l>>2]|0)+(q<<24>>24<<1)>>1]&2048):0){m=(li[f[(f[g>>2]|0)+36>>2]&511](g,k,0)|0)<<24>>24;k=f[a>>2]|0;i=k+12|0;j=f[i>>2]|0;if((j|0)==(f[k+16>>2]|0)){di[f[(f[k>>2]|0)+40>>2]&1023](k)|0;r=m;s=h;t=n;u=n}else{f[i>>2]=j+1;UWb(b[j>>0]|0)|0;r=m;s=h;t=n;u=n}while(1){v=r+-48|0;m=s+-1|0;j=f[a>>2]|0;do if(j){i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))w=di[f[(f[j>>2]|0)+36>>2]&1023](j)|0;else w=UWb(b[i>>0]|0)|0;if(SXb(w,TWb()|0)|0){f[a>>2]=0;x=1;break}else{x=(f[a>>2]|0)==0;break}}else x=1;while(0);do if(u){j=f[u+12>>2]|0;if((j|0)==(f[u+16>>2]|0))y=di[f[(f[u>>2]|0)+36>>2]&1023](u)|0;else y=UWb(b[j>>0]|0)|0;if(SXb(y,TWb()|0)|0){f[c>>2]=0;z=0;A=1;B=0;break}else{z=t;A=(t|0)==0;B=t;break}}else{z=t;A=1;B=0}while(0);C=f[a>>2]|0;if(!((s|0)>1&(x^A)))break;j=f[C+12>>2]|0;if((j|0)==(f[C+16>>2]|0))D=di[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else D=UWb(b[j>>0]|0)|0;j=D&255;if(j<<24>>24<=-1){p=v;break a}if(!(d[(f[l>>2]|0)+(D<<24>>24<<1)>>1]&2048)){p=v;break a}i=((li[f[(f[g>>2]|0)+36>>2]&511](g,j,0)|0)<<24>>24)+(v*10|0)|0;j=f[a>>2]|0;k=j+12|0;E=f[k>>2]|0;if((E|0)==(f[j+16>>2]|0)){di[f[(f[j>>2]|0)+40>>2]&1023](j)|0;r=i;s=m;t=z;u=B;continue}else{f[k>>2]=E+1;UWb(b[E>>0]|0)|0;r=i;s=m;t=z;u=B;continue}}do if(C){l=f[C+12>>2]|0;if((l|0)==(f[C+16>>2]|0))F=di[f[(f[C>>2]|0)+36>>2]&1023](C)|0;else F=UWb(b[l>>0]|0)|0;if(SXb(F,TWb()|0)|0){f[a>>2]=0;G=1;break}else{G=(f[a>>2]|0)==0;break}}else G=1;while(0);do if(z){l=f[z+12>>2]|0;if((l|0)==(f[z+16>>2]|0))H=di[f[(f[z>>2]|0)+36>>2]&1023](z)|0;else H=UWb(b[l>>0]|0)|0;if(!(SXb(H,TWb()|0)|0))if(G){p=v;break a}else break;else{f[c>>2]=0;o=62;break}}else o=62;while(0);if((o|0)==62?!G:0){p=v;break}f[e>>2]=f[e>>2]|2;p=v;break}f[e>>2]=f[e>>2]|4;p=0}while(0);return p|0}function V$b(a){a=a|0;dZb(a);return}function W$b(a){a=a|0;dZb(a);O5b(a);return}function X$b(a){a=a|0;return 2}function Y$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h+12|0;j=h+8|0;k=h+4|0;l=h;f[k>>2]=f[b>>2];f[l>>2]=f[c>>2];f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];l=s0b(a,j,i,d,e,g,148288,148320)|0;u=h;return l|0}function Z$b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+16|0;j=i+12|0;k=i+8|0;l=i+4|0;m=i;n=a+8|0;o=di[f[(f[n>>2]|0)+20>>2]&1023](n)|0;f[l>>2]=f[c>>2];f[m>>2]=f[d>>2];d=b[o+8+3>>0]|0;c=d<<24>>24<0;n=c?f[o>>2]|0:o;p=n+((c?f[o+4>>2]|0:d&255)<<2)|0;f[k>>2]=f[l>>2];f[j>>2]=f[m>>2];m=s0b(a,k,j,e,g,h,n,p)|0;u=i;return m|0}function _$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;TXb(i,d);d=xZb(i,855532)|0;yZb(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];q0b(a,g+24|0,b,i,e,d);u=h;return f[b>>2]|0}function $$b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;TXb(i,d);d=xZb(i,855532)|0;yZb(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];r0b(a,g+16|0,b,i,e,d);u=h;return f[b>>2]|0}function a0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h+4|0;j=h;TXb(i,d);d=xZb(i,855532)|0;yZb(i);f[j>>2]=f[c>>2];f[i>>2]=f[j>>2];D0b(a,g+20|0,b,i,e,d);u=h;return f[b>>2]|0}function b0b(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;j=u;u=u+144|0;k=j+128|0;l=j+112|0;m=j+124|0;n=j+120|0;o=j+116|0;p=j+108|0;q=j+104|0;r=j+100|0;s=j+96|0;t=j+92|0;v=j+88|0;w=j+84|0;x=j+80|0;y=j+76|0;z=j+72|0;A=j+68|0;B=j+64|0;C=j+60|0;D=j+56|0;E=j+52|0;F=j+48|0;G=j+44|0;H=j+40|0;I=j+36|0;J=j+32|0;K=j+28|0;L=j+24|0;M=j+20|0;N=j+16|0;O=j+12|0;P=j+8|0;Q=j+4|0;R=j;f[g>>2]=0;TXb(k,e);S=xZb(k,855532)|0;yZb(k);T=h+8|0;U=h+20|0;V=h+16|0;W=h+24|0;X=a+8|0;do switch(i<<24>>24|0){case 65:case 97:{f[m>>2]=f[d>>2];f[k>>2]=f[m>>2];q0b(a,W,c,k,g,S);Y=26;break}case 104:case 66:case 98:{f[n>>2]=f[d>>2];f[k>>2]=f[n>>2];r0b(a,V,c,k,g,S);Y=26;break}case 99:{Z=di[f[(f[X>>2]|0)+12>>2]&1023](X)|0;f[o>>2]=f[c>>2];f[p>>2]=f[d>>2];_=b[Z+8+3>>0]|0;$=_<<24>>24<0;aa=$?f[Z>>2]|0:Z;ba=aa+(($?f[Z+4>>2]|0:_&255)<<2)|0;f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];_=s0b(a,l,k,e,g,h,aa,ba)|0;f[c>>2]=_;Y=26;break}case 101:case 100:{f[q>>2]=f[d>>2];f[k>>2]=f[q>>2];t0b(a,h+12|0,c,k,g,S);Y=26;break}case 68:{f[r>>2]=f[c>>2];f[s>>2]=f[d>>2];f[l>>2]=f[r>>2];f[k>>2]=f[s>>2];_=s0b(a,l,k,e,g,h,148128,148160)|0;f[c>>2]=_;Y=26;break}case 70:{f[t>>2]=f[c>>2];f[v>>2]=f[d>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];_=s0b(a,l,k,e,g,h,148160,148192)|0;f[c>>2]=_;Y=26;break}case 72:{f[w>>2]=f[d>>2];f[k>>2]=f[w>>2];u0b(a,T,c,k,g,S);Y=26;break}case 73:{f[x>>2]=f[d>>2];f[k>>2]=f[x>>2];v0b(a,T,c,k,g,S);Y=26;break}case 106:{f[y>>2]=f[d>>2];f[k>>2]=f[y>>2];w0b(a,h+28|0,c,k,g,S);Y=26;break}case 109:{f[z>>2]=f[d>>2];f[k>>2]=f[z>>2];x0b(a,V,c,k,g,S);Y=26;break}case 77:{f[A>>2]=f[d>>2];f[k>>2]=f[A>>2];y0b(a,h+4|0,c,k,g,S);Y=26;break}case 116:case 110:{f[B>>2]=f[d>>2];f[k>>2]=f[B>>2];z0b(a,c,k,g,S);Y=26;break}case 112:{f[C>>2]=f[d>>2];f[k>>2]=f[C>>2];A0b(a,T,c,k,g,S);Y=26;break}case 114:{f[D>>2]=f[c>>2];f[E>>2]=f[d>>2];f[l>>2]=f[D>>2];f[k>>2]=f[E>>2];_=s0b(a,l,k,e,g,h,148192,148236)|0;f[c>>2]=_;Y=26;break}case 82:{f[F>>2]=f[c>>2];f[G>>2]=f[d>>2];f[l>>2]=f[F>>2];f[k>>2]=f[G>>2];_=s0b(a,l,k,e,g,h,148236,148256)|0;f[c>>2]=_;Y=26;break}case 83:{f[H>>2]=f[d>>2];f[k>>2]=f[H>>2];B0b(a,h,c,k,g,S);Y=26;break}case 84:{f[I>>2]=f[c>>2];f[J>>2]=f[d>>2];f[l>>2]=f[I>>2];f[k>>2]=f[J>>2];_=s0b(a,l,k,e,g,h,148256,148288)|0;f[c>>2]=_;Y=26;break}case 119:{f[K>>2]=f[d>>2];f[k>>2]=f[K>>2];C0b(a,W,c,k,g,S);Y=26;break}case 120:{_=f[(f[a>>2]|0)+20>>2]|0;f[L>>2]=f[c>>2];f[M>>2]=f[d>>2];f[l>>2]=f[L>>2];f[k>>2]=f[M>>2];ca=Xf[_&127](a,l,k,e,g,h)|0;break}case 88:{_=di[f[(f[X>>2]|0)+24>>2]&1023](X)|0;f[N>>2]=f[c>>2];f[O>>2]=f[d>>2];ba=b[_+8+3>>0]|0;aa=ba<<24>>24<0;Z=aa?f[_>>2]|0:_;$=Z+((aa?f[_+4>>2]|0:ba&255)<<2)|0;f[l>>2]=f[N>>2];f[k>>2]=f[O>>2];ba=s0b(a,l,k,e,g,h,Z,$)|0;f[c>>2]=ba;Y=26;break}case 121:{f[P>>2]=f[d>>2];f[k>>2]=f[P>>2];D0b(a,U,c,k,g,S);Y=26;break}case 89:{f[Q>>2]=f[d>>2];f[k>>2]=f[Q>>2];E0b(a,U,c,k,g,S);Y=26;break}case 37:{f[R>>2]=f[d>>2];f[k>>2]=f[R>>2];F0b(a,c,k,g,S);Y=26;break}default:{f[g>>2]=f[g>>2]|4;Y=26}}while(0);if((Y|0)==26)ca=f[c>>2]|0;u=j;return ca|0}function c0b(a){a=a|0;if((b[499496]|0)==0?Cac(499496)|0:0){o0b();f[214296]=857016}return f[214296]|0}function d0b(a){a=a|0;if((b[499480]|0)==0?Cac(499480)|0:0){m0b();f[214253]=856724}return f[214253]|0}function e0b(a){a=a|0;if((b[499464]|0)==0?Cac(499464)|0:0){k0b();f[214180]=856432}return f[214180]|0}function f0b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[499456]|0)==0?Cac(499456)|0:0){f[214105]=0;f[214106]=0;f[214107]=0;d=j0b(147160)|0;if(d>>>0>1073741807)V5b(856420);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)Re();else{g=L5b(e<<2)|0;f[214105]=g;f[214107]=e|-2147483648;f[214106]=d;h=g;break}}else{b[856431]=d;h=856420}while(0);lXb(h,147160,d)|0;f[c>>2]=0;jZb(h+(d<<2)|0,c);zd(1545,856420,x|0)|0}u=a;return 856420}function g0b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[499448]|0)==0?Cac(499448)|0:0){f[214102]=0;f[214103]=0;f[214104]=0;d=j0b(147112)|0;if(d>>>0>1073741807)V5b(856408);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)Re();else{g=L5b(e<<2)|0;f[214102]=g;f[214104]=e|-2147483648;f[214103]=d;h=g;break}}else{b[856419]=d;h=856408}while(0);lXb(h,147112,d)|0;f[c>>2]=0;jZb(h+(d<<2)|0,c);zd(1545,856408,x|0)|0}u=a;return 856408}function h0b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[499440]|0)==0?Cac(499440)|0:0){f[214099]=0;f[214100]=0;f[214101]=0;d=j0b(147076)|0;if(d>>>0>1073741807)V5b(856396);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)Re();else{g=L5b(e<<2)|0;f[214099]=g;f[214101]=e|-2147483648;f[214100]=d;h=g;break}}else{b[856407]=d;h=856396}while(0);lXb(h,147076,d)|0;f[c>>2]=0;jZb(h+(d<<2)|0,c);zd(1545,856396,x|0)|0}u=a;return 856396}function i0b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;a=u;u=u+16|0;c=a;if((b[499432]|0)==0?Cac(499432)|0:0){f[214096]=0;f[214097]=0;f[214098]=0;d=j0b(147040)|0;if(d>>>0>1073741807)V5b(856384);do if(d>>>0>=2){e=d+4&-4;if(e>>>0>1073741823)Re();else{g=L5b(e<<2)|0;f[214096]=g;f[214098]=e|-2147483648;f[214097]=d;h=g;break}}else{b[856395]=d;h=856384}while(0);lXb(h,147040,d)|0;f[c>>2]=0;jZb(h+(d<<2)|0,c);zd(1545,856384,x|0)|0}u=a;return 856384}function j0b(a){a=a|0;return IUb(a)|0}function k0b(){var a=0,c=0;if((b[499472]|0)==0?Cac(499472)|0:0){a=856432;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=856720);zd(1546,0,x|0)|0}A6b(856432,147244)|0;A6b(856444,147256)|0;return}function l0b(a){a=a|0;a=856720;do{a=a+-12|0;v6b(a)}while((a|0)!=856432);return}function m0b(){var a=0,c=0;if((b[499488]|0)==0?Cac(499488)|0:0){a=856724;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=857012);zd(1547,0,x|0)|0}A6b(856724,147268)|0;A6b(856736,147300)|0;A6b(856748,147336)|0;A6b(856760,147360)|0;A6b(856772,147384)|0;A6b(856784,147400)|0;A6b(856796,147420)|0;A6b(856808,147440)|0;A6b(856820,147468)|0;A6b(856832,147508)|0;A6b(856844,147540)|0;A6b(856856,147576)|0;A6b(856868,147612)|0;A6b(856880,147628)|0;A6b(856892,147644)|0;A6b(856904,147660)|0;A6b(856916,147384)|0;A6b(856928,147676)|0;A6b(856940,147692)|0;A6b(856952,147708)|0;A6b(856964,147724)|0;A6b(856976,147740)|0;A6b(856988,147756)|0;A6b(857e3,147772)|0;return}function n0b(a){a=a|0;a=857012;do{a=a+-12|0;v6b(a)}while((a|0)!=856724);return}function o0b(){var a=0,c=0;if((b[499504]|0)==0?Cac(499504)|0:0){a=857016;do{f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}a=a+12|0}while((a|0)!=857184);zd(1548,0,x|0)|0}A6b(857016,147788)|0;A6b(857028,147816)|0;A6b(857040,147844)|0;A6b(857052,147876)|0;A6b(857064,147916)|0;A6b(857076,147952)|0;A6b(857088,147980)|0;A6b(857100,148016)|0;A6b(857112,148032)|0;A6b(857124,148048)|0;A6b(857136,148064)|0;A6b(857148,148080)|0;A6b(857160,148096)|0;A6b(857172,148112)|0;return}function p0b(a){a=a|0;a=857184;do{a=a+-12|0;v6b(a)}while((a|0)!=857016);return}function q0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=di[f[f[k>>2]>>2]&1023](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(E_b(c,i,a,a+168|0,g,e,0)|0)-a|0;if((j|0)<168)f[b>>2]=((j|0)/12|0|0)%7|0;u=h;return}function r0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h+4|0;j=h;k=a+8|0;a=di[f[(f[k>>2]|0)+4>>2]&1023](k)|0;f[j>>2]=f[d>>2];f[i>>2]=f[j>>2];j=(E_b(c,i,a,a+288|0,g,e,0)|0)-a|0;if((j|0)<288)f[b>>2]=((j|0)/12|0|0)%12|0;u=h;return}function s0b(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;j=u;u=u+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;TXb(k,d);o=xZb(k,855532)|0;yZb(k);f[e>>2]=0;p=h;h=0;a:while(1){q=(p|0)!=(i|0);r=h;while(1){s=f[b>>2]|0;if(!(q&(r|0)==0)){t=s;break a}v=s;if(s){w=f[s+12>>2]|0;if((w|0)==(f[s+16>>2]|0))x=di[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else x=kXb(f[w>>2]|0)|0;if(UXb(x,jXb()|0)|0){f[b>>2]=0;y=0;z=1;A=0}else{y=s;z=0;A=v}}else{y=0;z=1;A=v}v=f[c>>2]|0;s=v;do if(v){w=f[v+12>>2]|0;if((w|0)==(f[v+16>>2]|0))B=di[f[(f[v>>2]|0)+36>>2]&1023](v)|0;else B=kXb(f[w>>2]|0)|0;if(!(UXb(B,jXb()|0)|0))if(z){C=v;D=s;break}else{E=58;break a}else{f[c>>2]=0;F=0;E=16;break}}else{F=s;E=16}while(0);if((E|0)==16){E=0;if(z){E=58;break a}else{C=0;D=F}}if((li[f[(f[o>>2]|0)+52>>2]&511](o,f[p>>2]|0,0)|0)<<24>>24==37){E=19;break}if(li[f[(f[o>>2]|0)+12>>2]&511](o,8192,f[p>>2]|0)|0){G=p;E=26;break}H=y+12|0;s=f[H>>2]|0;I=y+16|0;if((s|0)==(f[I>>2]|0))J=di[f[(f[y>>2]|0)+36>>2]&1023](y)|0;else J=kXb(f[s>>2]|0)|0;s=Uh[f[(f[o>>2]|0)+28>>2]&1023](o,J)|0;if((s|0)==(Uh[f[(f[o>>2]|0)+28>>2]&1023](o,f[p>>2]|0)|0)){E=54;break}f[e>>2]=4;r=4}b:do if((E|0)==19){E=0;r=p+4|0;if((r|0)==(i|0)){E=58;break a}q=li[f[(f[o>>2]|0)+52>>2]&511](o,f[r>>2]|0,0)|0;switch(q<<24>>24){case 48:case 69:{s=p+8|0;if((s|0)==(i|0)){E=58;break a}K=q;L=li[f[(f[o>>2]|0)+52>>2]&511](o,f[s>>2]|0,0)|0;M=r;break}default:{K=0;L=q;M=p}}q=f[(f[a>>2]|0)+36>>2]|0;f[m>>2]=A;f[n>>2]=D;f[l>>2]=f[m>>2];f[k>>2]=f[n>>2];r=Di[q&15](a,l,k,d,e,g,L,K)|0;f[b>>2]=r;N=M+8|0}else if((E|0)==26){while(1){E=0;r=G+4|0;if((r|0)==(i|0)){O=i;break}if(li[f[(f[o>>2]|0)+12>>2]&511](o,8192,f[r>>2]|0)|0){G=r;E=26}else{O=r;break}}r=y;q=C;s=C;while(1){if(r){v=f[r+12>>2]|0;if((v|0)==(f[r+16>>2]|0))P=di[f[(f[r>>2]|0)+36>>2]&1023](r)|0;else P=kXb(f[v>>2]|0)|0;if(UXb(P,jXb()|0)|0){f[b>>2]=0;Q=1;R=0}else{Q=0;R=r}}else{Q=1;R=0}do if(s){v=f[s+12>>2]|0;if((v|0)==(f[s+16>>2]|0))S=di[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else S=kXb(f[v>>2]|0)|0;if(!(UXb(S,jXb()|0)|0))if(Q^(q|0)==0){T=q;U=q;break}else{N=O;break b}else{f[c>>2]=0;V=0;E=41;break}}else{V=q;E=41}while(0);if((E|0)==41){E=0;if(Q){N=O;break b}else{T=V;U=0}}v=R+12|0;w=f[v>>2]|0;W=R+16|0;if((w|0)==(f[W>>2]|0))X=di[f[(f[R>>2]|0)+36>>2]&1023](R)|0;else X=kXb(f[w>>2]|0)|0;if(!(li[f[(f[o>>2]|0)+12>>2]&511](o,8192,X)|0)){N=O;break b}w=f[v>>2]|0;if((w|0)==(f[W>>2]|0)){di[f[(f[R>>2]|0)+40>>2]&1023](R)|0;r=R;q=T;s=U;continue}else{f[v>>2]=w+4;kXb(f[w>>2]|0)|0;r=R;q=T;s=U;continue}}}else if((E|0)==54){E=0;s=p+4|0;q=f[H>>2]|0;if((q|0)==(f[I>>2]|0)){di[f[(f[y>>2]|0)+40>>2]&1023](y)|0;N=s;break}else{f[H>>2]=q+4;kXb(f[q>>2]|0)|0;N=s;break}}while(0);p=N;h=f[e>>2]|0}if((E|0)==58){f[e>>2]=4;t=y}if(t){y=f[t+12>>2]|0;if((y|0)==(f[t+16>>2]|0))Y=di[f[(f[t>>2]|0)+36>>2]&1023](t)|0;else Y=kXb(f[y>>2]|0)|0;if(UXb(Y,jXb()|0)|0){f[b>>2]=0;Z=0;_=1}else{Z=t;_=0}}else{Z=0;_=1}t=f[c>>2]|0;do if(t){b=f[t+12>>2]|0;if((b|0)==(f[t+16>>2]|0))$=di[f[(f[t>>2]|0)+36>>2]&1023](t)|0;else $=kXb(f[b>>2]|0)|0;if(!(UXb($,jXb()|0)|0))if(_)break;else{E=73;break}else{f[c>>2]=0;E=71;break}}else E=71;while(0);if((E|0)==71?_:0)E=73;if((E|0)==73)f[e>>2]=f[e>>2]|2;u=j;return Z|0}function t0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=G0b(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<31&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function u0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=G0b(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<24&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function v0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=G0b(c,h,e,g,2)|0;g=f[e>>2]|0;if((i+-1|0)>>>0<12&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function w0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=G0b(c,h,e,g,3)|0;g=f[e>>2]|0;if((i|0)<366&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function x0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=G0b(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<13&(g&4|0)==0)f[b>>2]=i+-1;else f[e>>2]=g|4;u=a;return}function y0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=G0b(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<60&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function z0b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a:while(1){a=f[b>>2]|0;do if(a){g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))h=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0;else h=kXb(f[g>>2]|0)|0;if(UXb(h,jXb()|0)|0){f[b>>2]=0;i=1;break}else{i=(f[b>>2]|0)==0;break}}else i=1;while(0);a=f[c>>2]|0;do if(a){g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))j=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0;else j=kXb(f[g>>2]|0)|0;if(!(UXb(j,jXb()|0)|0))if(i){k=a;break}else{l=a;break a}else{f[c>>2]=0;m=15;break}}else m=15;while(0);if((m|0)==15){m=0;if(i){l=0;break}else k=0}a=f[b>>2]|0;g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))n=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0;else n=kXb(f[g>>2]|0)|0;if(!(li[f[(f[e>>2]|0)+12>>2]&511](e,8192,n)|0)){l=k;break}g=f[b>>2]|0;a=g+12|0;o=f[a>>2]|0;if((o|0)==(f[g+16>>2]|0)){di[f[(f[g>>2]|0)+40>>2]&1023](g)|0;continue}else{f[a>>2]=o+4;kXb(f[o>>2]|0)|0;continue}}k=f[b>>2]|0;do if(k){n=f[k+12>>2]|0;if((n|0)==(f[k+16>>2]|0))p=di[f[(f[k>>2]|0)+36>>2]&1023](k)|0;else p=kXb(f[n>>2]|0)|0;if(UXb(p,jXb()|0)|0){f[b>>2]=0;q=1;break}else{q=(f[b>>2]|0)==0;break}}else q=1;while(0);do if(l){b=f[l+12>>2]|0;if((b|0)==(f[l+16>>2]|0))r=di[f[(f[l>>2]|0)+36>>2]&1023](l)|0;else r=kXb(f[b>>2]|0)|0;if(!(UXb(r,jXb()|0)|0))if(q)break;else{m=39;break}else{f[c>>2]=0;m=37;break}}else m=37;while(0);if((m|0)==37?q:0)m=39;if((m|0)==39)f[d>>2]=f[d>>2]|2;return}function A0b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=u;u=u+16|0;j=i+4|0;k=i;l=a+8|0;a=di[f[(f[l>>2]|0)+8>>2]&1023](l)|0;l=b[a+8+3>>0]|0;if(l<<24>>24<0)m=f[a+4>>2]|0;else m=l&255;l=b[a+20+3>>0]|0;if(l<<24>>24<0)n=f[a+16>>2]|0;else n=l&255;do if((m|0)!=(0-n|0)){f[k>>2]=f[e>>2];f[j>>2]=f[k>>2];l=(E_b(d,j,a,a+24|0,h,g,0)|0)-a|0;o=f[c>>2]|0;if((o|0)==12&(l|0)==0){f[c>>2]=0;break}if((o|0)<12&(l|0)==12)f[c>>2]=o+12}else f[g>>2]=f[g>>2]|4;while(0);u=i;return}function B0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=G0b(c,h,e,g,2)|0;g=f[e>>2]|0;if((i|0)<61&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function C0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=G0b(c,h,e,g,1)|0;g=f[e>>2]|0;if((i|0)<7&(g&4|0)==0)f[b>>2]=i;else f[e>>2]=g|4;u=a;return}function D0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=G0b(c,h,e,g,4)|0;if(!(f[e>>2]&4)){if((i|0)<69)j=i+2e3|0;else j=(i|0)<100?i+1900|0:i;f[b>>2]=j+-1900}u=a;return}function E0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=u;u=u+16|0;h=a+4|0;i=a;f[i>>2]=f[d>>2];f[h>>2]=f[i>>2];i=G0b(c,h,e,g,4)|0;if(!(f[e>>2]&4))f[b>>2]=i+-1900;u=a;return}function F0b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=f[b>>2]|0;do if(a){g=f[a+12>>2]|0;if((g|0)==(f[a+16>>2]|0))h=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0;else h=kXb(f[g>>2]|0)|0;if(UXb(h,jXb()|0)|0){f[b>>2]=0;i=1;break}else{i=(f[b>>2]|0)==0;break}}else i=1;while(0);h=f[c>>2]|0;do if(h){a=f[h+12>>2]|0;if((a|0)==(f[h+16>>2]|0))j=di[f[(f[h>>2]|0)+36>>2]&1023](h)|0;else j=kXb(f[a>>2]|0)|0;if(!(UXb(j,jXb()|0)|0))if(i){k=h;l=16;break}else{m=6;l=38;break}else{f[c>>2]=0;l=14;break}}else l=14;while(0);if((l|0)==14)if(i){m=6;l=38}else{k=0;l=16}a:do if((l|0)==16){i=f[b>>2]|0;h=f[i+12>>2]|0;if((h|0)==(f[i+16>>2]|0))n=di[f[(f[i>>2]|0)+36>>2]&1023](i)|0;else n=kXb(f[h>>2]|0)|0;if((li[f[(f[e>>2]|0)+52>>2]&511](e,n,0)|0)<<24>>24==37){h=f[b>>2]|0;i=h+12|0;j=f[i>>2]|0;if((j|0)==(f[h+16>>2]|0))di[f[(f[h>>2]|0)+40>>2]&1023](h)|0;else{f[i>>2]=j+4;kXb(f[j>>2]|0)|0}j=f[b>>2]|0;do if(j){i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))o=di[f[(f[j>>2]|0)+36>>2]&1023](j)|0;else o=kXb(f[i>>2]|0)|0;if(UXb(o,jXb()|0)|0){f[b>>2]=0;p=1;break}else{p=(f[b>>2]|0)==0;break}}else p=1;while(0);do if(k|0){j=f[k+12>>2]|0;if((j|0)==(f[k+16>>2]|0))q=di[f[(f[k>>2]|0)+36>>2]&1023](k)|0;else q=kXb(f[j>>2]|0)|0;if(!(UXb(q,jXb()|0)|0))if(p)break a;else{m=2;l=38;break a}else{f[c>>2]=0;break}}while(0);if(p){m=2;l=38}}else{m=4;l=38}}while(0);if((l|0)==38)f[d>>2]=f[d>>2]|m;return}function G0b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=f[a>>2]|0;do if(g){h=f[g+12>>2]|0;if((h|0)==(f[g+16>>2]|0))i=di[f[(f[g>>2]|0)+36>>2]&1023](g)|0;else i=kXb(f[h>>2]|0)|0;if(UXb(i,jXb()|0)|0){f[a>>2]=0;j=1;break}else{j=(f[a>>2]|0)==0;break}}else j=1;while(0);i=f[b>>2]|0;do if(i){g=f[i+12>>2]|0;if((g|0)==(f[i+16>>2]|0))k=di[f[(f[i>>2]|0)+36>>2]&1023](i)|0;else k=kXb(f[g>>2]|0)|0;if(!(UXb(k,jXb()|0)|0))if(j){l=i;m=17;break}else{m=16;break}else{f[b>>2]=0;m=14;break}}else m=14;while(0);if((m|0)==14)if(j)m=16;else{l=0;m=17}a:do if((m|0)==16){f[c>>2]=f[c>>2]|6;n=0}else if((m|0)==17){j=f[a>>2]|0;i=f[j+12>>2]|0;if((i|0)==(f[j+16>>2]|0))o=di[f[(f[j>>2]|0)+36>>2]&1023](j)|0;else o=kXb(f[i>>2]|0)|0;if(!(li[f[(f[d>>2]|0)+12>>2]&511](d,2048,o)|0)){f[c>>2]=f[c>>2]|4;n=0;break}i=(li[f[(f[d>>2]|0)+52>>2]&511](d,o,0)|0)<<24>>24;j=f[a>>2]|0;k=j+12|0;g=f[k>>2]|0;if((g|0)==(f[j+16>>2]|0)){di[f[(f[j>>2]|0)+40>>2]&1023](j)|0;p=i;q=e;r=l;s=l}else{f[k>>2]=g+4;kXb(f[g>>2]|0)|0;p=i;q=e;r=l;s=l}while(1){t=p+-48|0;i=q+-1|0;g=f[a>>2]|0;do if(g){k=f[g+12>>2]|0;if((k|0)==(f[g+16>>2]|0))u=di[f[(f[g>>2]|0)+36>>2]&1023](g)|0;else u=kXb(f[k>>2]|0)|0;if(UXb(u,jXb()|0)|0){f[a>>2]=0;v=1;break}else{v=(f[a>>2]|0)==0;break}}else v=1;while(0);do if(s){g=f[s+12>>2]|0;if((g|0)==(f[s+16>>2]|0))w=di[f[(f[s>>2]|0)+36>>2]&1023](s)|0;else w=kXb(f[g>>2]|0)|0;if(UXb(w,jXb()|0)|0){f[b>>2]=0;x=0;y=1;z=0;break}else{x=r;y=(r|0)==0;z=r;break}}else{x=r;y=1;z=0}while(0);A=f[a>>2]|0;if(!((q|0)>1&(v^y)))break;g=f[A+12>>2]|0;if((g|0)==(f[A+16>>2]|0))B=di[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else B=kXb(f[g>>2]|0)|0;if(!(li[f[(f[d>>2]|0)+12>>2]&511](d,2048,B)|0)){n=t;break a}g=((li[f[(f[d>>2]|0)+52>>2]&511](d,B,0)|0)<<24>>24)+(t*10|0)|0;k=f[a>>2]|0;j=k+12|0;h=f[j>>2]|0;if((h|0)==(f[k+16>>2]|0)){di[f[(f[k>>2]|0)+40>>2]&1023](k)|0;p=g;q=i;r=x;s=z;continue}else{f[j>>2]=h+4;kXb(f[h>>2]|0)|0;p=g;q=i;r=x;s=z;continue}}do if(A){g=f[A+12>>2]|0;if((g|0)==(f[A+16>>2]|0))C=di[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else C=kXb(f[g>>2]|0)|0;if(UXb(C,jXb()|0)|0){f[a>>2]=0;D=1;break}else{D=(f[a>>2]|0)==0;break}}else D=1;while(0);do if(x){g=f[x+12>>2]|0;if((g|0)==(f[x+16>>2]|0))E=di[f[(f[x>>2]|0)+36>>2]&1023](x)|0;else E=kXb(f[g>>2]|0)|0;if(!(UXb(E,jXb()|0)|0))if(D){n=t;break a}else break;else{f[b>>2]=0;m=60;break}}else m=60;while(0);if((m|0)==60?!D:0){n=t;break}f[c>>2]=f[c>>2]|2;n=t}while(0);return n|0}function H0b(a){a=a|0;M0b(a+8|0);dZb(a);return}function I0b(a){a=a|0;M0b(a+8|0);dZb(a);O5b(a);return}function J0b(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;e=u;u=u+112|0;d=e+4|0;j=e;f[j>>2]=d+100;K0b(a+8|0,d,j,g,h,i);i=f[j>>2]|0;j=d;d=f[c>>2]|0;while(1){if((j|0)==(i|0))break;c=b[j>>0]|0;if(!d)k=0;else{h=d+24|0;g=f[h>>2]|0;if((g|0)==(f[d+28>>2]|0)){a=f[(f[d>>2]|0)+52>>2]|0;l=UWb(c)|0;m=Uh[a&1023](d,l)|0}else{f[h>>2]=g+1;b[g>>0]=c;m=UWb(c)|0}c=SXb(m,TWb()|0)|0;k=c?0:d}j=j+1|0;d=k}u=e;return d|0}function K0b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=u;u=u+16|0;j=i;b[j>>0]=37;k=j+1|0;b[k>>0]=g;l=j+2|0;b[l>>0]=h;b[j+3>>0]=0;if(h<<24>>24){b[k>>0]=h;b[l>>0]=g}g=L0b(c,f[d>>2]|0)|0;l=c+(of(c|0,g|0,j|0,e|0,f[a>>2]|0)|0)|0;f[d>>2]=l;u=i;return}function L0b(a,b){a=a|0;b=b|0;return b-a|0}function M0b(a){a=a|0;var b=0;b=f[a>>2]|0;if((b|0)!=(AZb()|0))lVb(f[a>>2]|0);return}function N0b(a){a=a|0;M0b(a+8|0);dZb(a);return}function O0b(a){a=a|0;M0b(a+8|0);dZb(a);O5b(a);return}function P0b(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;d=u;u=u+416|0;c=d+8|0;i=d;f[i>>2]=c+400;Q0b(a+8|0,c,i,e,g,h);h=f[i>>2]|0;i=c;c=f[b>>2]|0;while(1){if((i|0)==(h|0))break;b=f[i>>2]|0;if(!c)j=0;else{g=c+24|0;e=f[g>>2]|0;if((e|0)==(f[c+28>>2]|0)){a=f[(f[c>>2]|0)+52>>2]|0;k=kXb(b)|0;l=Uh[a&1023](c,k)|0}else{f[g>>2]=e+4;f[e>>2]=b;l=kXb(b)|0}b=UXb(l,jXb()|0)|0;j=b?0:c}i=i+4|0;c=j}u=d;return c|0}function Q0b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+128|0;i=h+16|0;j=h+12|0;k=h;l=h+8|0;f[j>>2]=i+100;K0b(a,i,j,d,e,g);g=k;f[g>>2]=0;f[g+4>>2]=0;f[l>>2]=i;i=R0b(b,f[c>>2]|0)|0;g=oVb(f[a>>2]|0)|0;a=aVb(b,l,i,k)|0;if(g|0)oVb(g)|0;if((a|0)==-1)S0b(0);else{f[c>>2]=b+(a<<2);u=h;return}}function R0b(a,b){a=a|0;b=b|0;return b-a>>2|0}function S0b(a){a=a|0;Re()}function T0b(a){a=a|0;dZb(a);return}function U0b(a){a=a|0;dZb(a);O5b(a);return}function V0b(a){a=a|0;return 127}function W0b(a){a=a|0;return 127}function X0b(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function Y0b(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function Z0b(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function _0b(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=1;c1b(a,1,45)|0;b[d>>0]=0;PXb(a+1|0,d);u=c;return}function $0b(a){a=a|0;return 0}function a1b(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function b1b(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function c1b(a,b,c){a=a|0;b=b|0;c=c|0;if(b|0)Nac(a|0,(UWb(c)|0)&255|0,b|0)|0;return a|0}function d1b(a){a=a|0;dZb(a);return}function e1b(a){a=a|0;dZb(a);O5b(a);return}function f1b(a){a=a|0;return 127}function g1b(a){a=a|0;return 127}function h1b(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function i1b(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function j1b(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function k1b(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=1;c1b(a,1,45)|0;b[d>>0]=0;PXb(a+1|0,d);u=c;return}function l1b(a){a=a|0;return 0}function m1b(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function n1b(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function o1b(a){a=a|0;dZb(a);return}function p1b(a){a=a|0;dZb(a);O5b(a);return}function q1b(a){a=a|0;return 2147483647}function r1b(a){a=a|0;return 2147483647}function s1b(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function t1b(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function u1b(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function v1b(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+8+3>>0]=1;f$b(a,1,45)|0;f[d>>2]=0;jZb(a+4|0,d);u=c;return}function w1b(a){a=a|0;return 0}function x1b(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function y1b(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function z1b(a){a=a|0;dZb(a);return}function A1b(a){a=a|0;dZb(a);O5b(a);return}function B1b(a){a=a|0;return 2147483647}function C1b(a){a=a|0;return 2147483647}function D1b(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function E1b(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function F1b(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}return}function G1b(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+8+3>>0]=1;f$b(a,1,45)|0;f[d>>2]=0;jZb(a+4|0,d);u=c;return}function H1b(a){a=a|0;return 0}function I1b(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function J1b(a,c){a=a|0;c=c|0;b[a>>0]=2;b[a+1>>0]=3;b[a+2>>0]=0;b[a+3>>0]=4;return}function K1b(a){a=a|0;dZb(a);return}function L1b(a){a=a|0;dZb(a);O5b(a);return}function M1b(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+240|0;j=a+24|0;k=a;l=a+140|0;m=a+16|0;n=a+12|0;o=a+8|0;p=a+136|0;q=a+4|0;r=a+36|0;f[m>>2]=l;s=m+4|0;f[s>>2]=1549;TXb(o,g);t=xZb(o,855500)|0;b[p>>0]=0;f[q>>2]=f[d>>2];v=f[g+4>>2]|0;f[j>>2]=f[q>>2];if(P1b(c,j,e,o,v,h,p,t,m,n,l+100|0)|0){Dg[f[(f[t>>2]|0)+32>>2]&127](t,487484,487494,j)|0;t=f[n>>2]|0;l=f[m>>2]|0;v=t-l|0;e=l;l=t;if((v|0)>98){t=OSb(v+2|0)|0;if(!t)Q5b();else{w=t;x=t}}else{w=r;x=0}if(!(b[p>>0]|0))y=w;else{b[w>>0]=45;y=w+1|0}w=j+10|0;p=j;t=e;e=y;y=l;while(1){if(t>>>0>=y>>>0)break;l=b[t>>0]|0;v=j;while(1){if((v|0)==(w|0)){z=w;break}if((b[v>>0]|0)==l<<24>>24){z=v;break}v=v+1|0}b[e>>0]=b[487484+(z-p)>>0]|0;t=t+1|0;e=e+1|0;y=f[n>>2]|0}b[e>>0]=0;f[k>>2]=i;if((RUb(r,487495,k)|0)!=1)S0b(0);if(x|0)PSb(x)}x=f[c>>2]|0;do if(x){k=f[x+12>>2]|0;if((k|0)==(f[x+16>>2]|0))A=di[f[(f[x>>2]|0)+36>>2]&1023](x)|0;else A=UWb(b[k>>0]|0)|0;if(SXb(A,TWb()|0)|0){f[c>>2]=0;B=1;break}else{B=(f[c>>2]|0)==0;break}}else B=1;while(0);A=f[d>>2]|0;do if(A){x=f[A+12>>2]|0;if((x|0)==(f[A+16>>2]|0))C=di[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else C=UWb(b[x>>0]|0)|0;if(!(SXb(C,TWb()|0)|0))if(B)break;else{D=34;break}else{f[d>>2]=0;D=32;break}}else D=32;while(0);if((D|0)==32?B:0)D=34;if((D|0)==34)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;yZb(o);o=f[m>>2]|0;f[m>>2]=0;if(o|0)bi[f[s>>2]&2047](o);u=a;return h|0}function N1b(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;a=u;u=u+144|0;j=a+24|0;k=a+32|0;l=a+16|0;m=a+8|0;n=a;o=a+28|0;p=a+4|0;f[l>>2]=k;q=l+4|0;f[q>>2]=1549;TXb(n,g);r=xZb(n,855500)|0;b[o>>0]=0;s=f[d>>2]|0;f[p>>2]=s;t=f[g+4>>2]|0;f[j>>2]=f[p>>2];p=s;if(P1b(c,j,e,n,t,h,o,r,l,m,k+100|0)|0){k=i+11|0;if((b[k>>0]|0)<0){t=f[i>>2]|0;b[j>>0]=0;PXb(t,j);f[i+4>>2]=0}else{b[j>>0]=0;PXb(i,j);b[k>>0]=0}if(b[o>>0]|0)l6b(i,Uh[f[(f[r>>2]|0)+28>>2]&1023](r,45)|0);o=Uh[f[(f[r>>2]|0)+28>>2]&1023](r,48)|0;r=f[m>>2]|0;m=r+-1|0;k=f[l>>2]|0;while(1){if(k>>>0>=m>>>0)break;if((b[k>>0]|0)!=o<<24>>24)break;k=k+1|0}pU(i,k,r)|0}r=f[c>>2]|0;do if(r){k=f[r+12>>2]|0;if((k|0)==(f[r+16>>2]|0))v=di[f[(f[r>>2]|0)+36>>2]&1023](r)|0;else v=UWb(b[k>>0]|0)|0;if(SXb(v,TWb()|0)|0){f[c>>2]=0;w=1;break}else{w=(f[c>>2]|0)==0;break}}else w=1;while(0);do if(s){v=f[p+12>>2]|0;if((v|0)==(f[p+16>>2]|0))x=di[f[(f[s>>2]|0)+36>>2]&1023](p)|0;else x=UWb(b[v>>0]|0)|0;if(!(SXb(x,TWb()|0)|0))if(w)break;else{y=27;break}else{f[d>>2]=0;y=25;break}}else y=25;while(0);if((y|0)==25?w:0)y=27;if((y|0)==27)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;yZb(n);n=f[l>>2]|0;f[l>>2]=0;if(n|0)bi[f[q>>2]&2047](n);u=a;return h|0}function O1b(a){a=a|0;return}function P1b(a,c,e,g,i,j,k,l,m,n,o){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0;p=u;u=u+512|0;q=p+88|0;r=p+96|0;s=p+80|0;t=p+72|0;v=p+68|0;w=p+500|0;x=p+497|0;y=p+496|0;z=p+56|0;A=p+44|0;B=p+32|0;C=p+20|0;D=p+8|0;E=p+4|0;F=p;f[q>>2]=o;f[s>>2]=r;o=s+4|0;f[o>>2]=1549;f[t>>2]=r;f[v>>2]=r+400;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[z+(r<<2)>>2]=0;r=r+1|0}f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[A+(r<<2)>>2]=0;r=r+1|0}f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[B+(r<<2)>>2]=0;r=r+1|0}f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[C+(r<<2)>>2]=0;r=r+1|0}f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;r=0;while(1){if((r|0)==3)break;f[D+(r<<2)>>2]=0;r=r+1|0}Q1b(e,g,w,x,y,z,A,B,C,E);f[n>>2]=f[m>>2];g=l+8|0;l=B+11|0;e=B+4|0;r=C+11|0;G=C+4|0;H=(i&512|0)!=0;i=A+11|0;I=A+4|0;J=D+11|0;K=D+4|0;L=w+3|0;M=z+11|0;N=z+4|0;O=0;P=0;a:while(1){Q=(O|0)!=0;if(P>>>0>=4){R=234;break}S=f[a>>2]|0;do if(S){T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))U=di[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else U=UWb(b[T>>0]|0)|0;if(SXb(U,TWb()|0)|0){f[a>>2]=0;V=1;break}else{V=(f[a>>2]|0)==0;break}}else V=1;while(0);S=f[c>>2]|0;do if(S){T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))W=di[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else W=UWb(b[T>>0]|0)|0;if(!(SXb(W,TWb()|0)|0))if(V){X=S;break}else{R=234;break a}else{f[c>>2]=0;R=31;break}}else R=31;while(0);if((R|0)==31){R=0;if(V){R=234;break}else X=0}S=(P|0)!=3;b:do switch(b[w+P>>0]|0){case 1:{if(S){T=f[a>>2]|0;Y=f[T+12>>2]|0;if((Y|0)==(f[T+16>>2]|0))Z=di[f[(f[T>>2]|0)+36>>2]&1023](T)|0;else Z=UWb(b[Y>>0]|0)|0;if((Z&255)<<24>>24<=-1){R=44;break a}if(!(d[(f[g>>2]|0)+(Z<<24>>24<<1)>>1]&8192)){R=44;break a}Y=f[a>>2]|0;T=Y+12|0;_=f[T>>2]|0;if((_|0)==(f[Y+16>>2]|0))$=di[f[(f[Y>>2]|0)+40>>2]&1023](Y)|0;else{f[T>>2]=_+1;$=UWb(b[_>>0]|0)|0}l6b(D,$&255);aa=X;ba=X;R=46}else ca=O;break}case 0:{if(S){aa=X;ba=X;R=46}else ca=O;break}case 3:{_=b[l>>0]|0;T=_<<24>>24<0?f[e>>2]|0:_&255;_=b[r>>0]|0;Y=_<<24>>24<0?f[G>>2]|0:_&255;if((T|0)==(0-Y|0))ca=O;else{_=(T|0)==0;T=f[a>>2]|0;da=f[T+12>>2]|0;ea=(da|0)==(f[T+16>>2]|0);if(_|(Y|0)==0){if(ea)fa=di[f[(f[T>>2]|0)+36>>2]&1023](T)|0;else fa=UWb(b[da>>0]|0)|0;Y=fa&255;if(_){if(Y<<24>>24!=(b[((b[r>>0]|0)<0?f[C>>2]|0:C)>>0]|0)){ca=O;break b}_=f[a>>2]|0;ga=_+12|0;ha=f[ga>>2]|0;if((ha|0)==(f[_+16>>2]|0))di[f[(f[_>>2]|0)+40>>2]&1023](_)|0;else{f[ga>>2]=ha+1;UWb(b[ha>>0]|0)|0}b[k>>0]=1;ha=b[r>>0]|0;ca=(ha<<24>>24<0?f[G>>2]|0:ha&255)>>>0>1?C:O;break b}if(Y<<24>>24!=(b[((b[l>>0]|0)<0?f[B>>2]|0:B)>>0]|0)){b[k>>0]=1;ca=O;break b}Y=f[a>>2]|0;ha=Y+12|0;ga=f[ha>>2]|0;if((ga|0)==(f[Y+16>>2]|0))di[f[(f[Y>>2]|0)+40>>2]&1023](Y)|0;else{f[ha>>2]=ga+1;UWb(b[ga>>0]|0)|0}ga=b[l>>0]|0;ca=(ga<<24>>24<0?f[e>>2]|0:ga&255)>>>0>1?B:O;break b}if(ea)ia=di[f[(f[T>>2]|0)+36>>2]&1023](T)|0;else ia=UWb(b[da>>0]|0)|0;da=f[a>>2]|0;T=da+12|0;ea=f[T>>2]|0;ga=(ea|0)==(f[da+16>>2]|0);if((ia&255)<<24>>24==(b[((b[l>>0]|0)<0?f[B>>2]|0:B)>>0]|0)){if(ga)di[f[(f[da>>2]|0)+40>>2]&1023](da)|0;else{f[T>>2]=ea+1;UWb(b[ea>>0]|0)|0}T=b[l>>0]|0;ca=(T<<24>>24<0?f[e>>2]|0:T&255)>>>0>1?B:O;break b}if(ga)ja=di[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else ja=UWb(b[ea>>0]|0)|0;if((ja&255)<<24>>24!=(b[((b[r>>0]|0)<0?f[C>>2]|0:C)>>0]|0)){R=103;break a}ea=f[a>>2]|0;da=ea+12|0;ga=f[da>>2]|0;if((ga|0)==(f[ea+16>>2]|0))di[f[(f[ea>>2]|0)+40>>2]&1023](ea)|0;else{f[da>>2]=ga+1;UWb(b[ga>>0]|0)|0}b[k>>0]=1;ga=b[r>>0]|0;ca=(ga<<24>>24<0?f[G>>2]|0:ga&255)>>>0>1?C:O}break}case 2:{if(!(P>>>0<2|Q)?!(H|(P|0)==2&(b[L>>0]|0)!=0):0){ca=0;break b}ga=b[i>>0]|0;da=ga<<24>>24<0;ea=f[A>>2]|0;T=da?ea:A;ha=T;c:do if((P|0)!=0?(h[w+(P+-1)>>0]|0)<2:0){Y=T+(da?f[I>>2]|0:ga&255)|0;_=ha;while(1){ka=_;if((ka|0)==(Y|0))break;la=b[ka>>0]|0;if(la<<24>>24<=-1)break;if(!(d[(f[g>>2]|0)+(la<<24>>24<<1)>>1]&8192))break;_=ka+1|0}Y=_-ha|0;ka=b[J>>0]|0;la=ka<<24>>24<0;ma=la?f[K>>2]|0:ka&255;if(Y>>>0<=ma>>>0){ka=(la?f[D>>2]|0:D)+ma|0;ma=T;la=ka+(0-Y)|0;while(1){if((la|0)==(ka|0)){na=X;oa=_;pa=ga;qa=ea;ra=X;break c}if((b[la>>0]|0)!=(b[ma>>0]|0)){na=X;oa=ha;pa=ga;qa=ea;ra=X;break c}ma=ma+1|0;la=la+1|0}}else{na=X;oa=ha;pa=ga;qa=ea;ra=X}}else{na=X;oa=ha;pa=ga;qa=ea;ra=X}while(0);d:while(1){ea=pa<<24>>24<0;ga=(ea?qa:A)+(ea?f[I>>2]|0:pa&255)|0;ea=oa;if((ea|0)==(ga|0)){sa=ga;break}ga=f[a>>2]|0;do if(ga){ha=f[ga+12>>2]|0;if((ha|0)==(f[ga+16>>2]|0))ta=di[f[(f[ga>>2]|0)+36>>2]&1023](ga)|0;else ta=UWb(b[ha>>0]|0)|0;if(SXb(ta,TWb()|0)|0){f[a>>2]=0;ua=1;break}else{ua=(f[a>>2]|0)==0;break}}else ua=1;while(0);do if(ra){ga=f[ra+12>>2]|0;if((ga|0)==(f[ra+16>>2]|0))va=di[f[(f[ra>>2]|0)+36>>2]&1023](ra)|0;else va=UWb(b[ga>>0]|0)|0;if(!(SXb(va,TWb()|0)|0))if(ua^(na|0)==0){wa=na;xa=na;break}else{sa=ea;break d}else{f[c>>2]=0;ya=0;R=132;break}}else{ya=na;R=132}while(0);if((R|0)==132){R=0;if(ua){sa=ea;break}else{wa=ya;xa=0}}ga=f[a>>2]|0;ha=f[ga+12>>2]|0;if((ha|0)==(f[ga+16>>2]|0))za=di[f[(f[ga>>2]|0)+36>>2]&1023](ga)|0;else za=UWb(b[ha>>0]|0)|0;if((za&255)<<24>>24!=(b[ea>>0]|0)){sa=ea;break}ha=f[a>>2]|0;ga=ha+12|0;T=f[ga>>2]|0;if((T|0)==(f[ha+16>>2]|0))di[f[(f[ha>>2]|0)+40>>2]&1023](ha)|0;else{f[ga>>2]=T+1;UWb(b[T>>0]|0)|0}na=wa;oa=ea+1|0;pa=b[i>>0]|0;qa=f[A>>2]|0;ra=xa}if(H?(T=b[i>>0]|0,ga=T<<24>>24<0,(sa|0)!=((ga?f[A>>2]|0:A)+(ga?f[I>>2]|0:T&255)|0)):0){R=144;break a}else ca=O;break}case 4:{T=0;ga=X;ha=X;e:while(1){da=f[a>>2]|0;do if(da){la=f[da+12>>2]|0;if((la|0)==(f[da+16>>2]|0))Aa=di[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else Aa=UWb(b[la>>0]|0)|0;if(SXb(Aa,TWb()|0)|0){f[a>>2]=0;Ba=1;break}else{Ba=(f[a>>2]|0)==0;break}}else Ba=1;while(0);do if(ha){da=f[ha+12>>2]|0;if((da|0)==(f[ha+16>>2]|0))Ca=di[f[(f[ha>>2]|0)+36>>2]&1023](ha)|0;else Ca=UWb(b[da>>0]|0)|0;if(!(SXb(Ca,TWb()|0)|0))if(Ba^(ga|0)==0){Da=ga;Ea=ga;break}else{Fa=ga;break e}else{f[c>>2]=0;Ga=0;R=158;break}}else{Ga=ga;R=158}while(0);if((R|0)==158){R=0;if(Ba){Fa=Ga;break}else{Da=Ga;Ea=0}}da=f[a>>2]|0;ea=f[da+12>>2]|0;if((ea|0)==(f[da+16>>2]|0))Ha=di[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else Ha=UWb(b[ea>>0]|0)|0;ea=Ha&255;if(ea<<24>>24>-1?(d[(f[g>>2]|0)+(Ha<<24>>24<<1)>>1]&2048)!=0:0){da=f[n>>2]|0;if((da|0)==(f[q>>2]|0)){R1b(m,n,q);Ia=f[n>>2]|0}else Ia=da;f[n>>2]=Ia+1;b[Ia>>0]=ea;Ja=T+1|0}else{da=b[M>>0]|0;if(!(ea<<24>>24==(b[y>>0]|0)&(T|0?((da<<24>>24<0?f[N>>2]|0:da&255)|0)!=0:0))){Fa=Da;break}da=f[t>>2]|0;if((da|0)==(f[v>>2]|0)){S1b(s,t,v);Ka=f[t>>2]|0}else Ka=da;f[t>>2]=Ka+4;f[Ka>>2]=T;Ja=0}da=f[a>>2]|0;ea=da+12|0;la=f[ea>>2]|0;if((la|0)==(f[da+16>>2]|0)){di[f[(f[da>>2]|0)+40>>2]&1023](da)|0;T=Ja;ga=Da;ha=Ea;continue}else{f[ea>>2]=la+1;UWb(b[la>>0]|0)|0;T=Ja;ga=Da;ha=Ea;continue}}ha=f[t>>2]|0;if(T|0?(f[s>>2]|0)!=(ha|0):0){if((ha|0)==(f[v>>2]|0)){S1b(s,t,v);La=f[t>>2]|0}else La=ha;f[t>>2]=La+4;f[La>>2]=T}f:do if((f[E>>2]|0)>0){ha=f[a>>2]|0;do if(ha){ga=f[ha+12>>2]|0;if((ga|0)==(f[ha+16>>2]|0))Ma=di[f[(f[ha>>2]|0)+36>>2]&1023](ha)|0;else Ma=UWb(b[ga>>0]|0)|0;if(SXb(Ma,TWb()|0)|0){f[a>>2]=0;Na=1;break}else{Na=(f[a>>2]|0)==0;break}}else Na=1;while(0);do if(Fa){ha=f[Fa+12>>2]|0;if((ha|0)==(f[Fa+16>>2]|0))Oa=di[f[(f[Fa>>2]|0)+36>>2]&1023](Fa)|0;else Oa=UWb(b[ha>>0]|0)|0;if(!(SXb(Oa,TWb()|0)|0))if(Na){Pa=Fa;break}else{R=232;break a}else{f[c>>2]=0;R=193;break}}else R=193;while(0);if((R|0)==193){R=0;if(Na){R=232;break a}else Pa=0}ha=f[a>>2]|0;ga=f[ha+12>>2]|0;if((ga|0)==(f[ha+16>>2]|0))Qa=di[f[(f[ha>>2]|0)+36>>2]&1023](ha)|0;else Qa=UWb(b[ga>>0]|0)|0;if((Qa&255)<<24>>24!=(b[x>>0]|0)){R=232;break a}ga=f[a>>2]|0;ha=ga+12|0;la=f[ha>>2]|0;if((la|0)==(f[ga+16>>2]|0)){di[f[(f[ga>>2]|0)+40>>2]&1023](ga)|0;Ra=Pa;Sa=Pa}else{f[ha>>2]=la+1;UWb(b[la>>0]|0)|0;Ra=Pa;Sa=Pa}while(1){if((f[E>>2]|0)<=0)break f;la=f[a>>2]|0;do if(la){ha=f[la+12>>2]|0;if((ha|0)==(f[la+16>>2]|0))Ta=di[f[(f[la>>2]|0)+36>>2]&1023](la)|0;else Ta=UWb(b[ha>>0]|0)|0;if(SXb(Ta,TWb()|0)|0){f[a>>2]=0;Ua=1;break}else{Ua=(f[a>>2]|0)==0;break}}else Ua=1;while(0);do if(Sa){la=f[Sa+12>>2]|0;if((la|0)==(f[Sa+16>>2]|0))Va=di[f[(f[Sa>>2]|0)+36>>2]&1023](Sa)|0;else Va=UWb(b[la>>0]|0)|0;if(!(SXb(Va,TWb()|0)|0))if(Ua^(Ra|0)==0){Wa=Ra;Xa=Ra;break}else{R=232;break a}else{f[c>>2]=0;Ya=0;R=216;break}}else{Ya=Ra;R=216}while(0);if((R|0)==216){R=0;if(Ua){R=232;break a}else{Wa=Ya;Xa=0}}la=f[a>>2]|0;ha=f[la+12>>2]|0;if((ha|0)==(f[la+16>>2]|0))Za=di[f[(f[la>>2]|0)+36>>2]&1023](la)|0;else Za=UWb(b[ha>>0]|0)|0;if((Za&255)<<24>>24<=-1){R=232;break a}if(!(d[(f[g>>2]|0)+(Za<<24>>24<<1)>>1]&2048)){R=232;break a}if((f[n>>2]|0)==(f[q>>2]|0))R1b(m,n,q);ha=f[a>>2]|0;la=f[ha+12>>2]|0;if((la|0)==(f[ha+16>>2]|0))_a=di[f[(f[ha>>2]|0)+36>>2]&1023](ha)|0;else _a=UWb(b[la>>0]|0)|0;la=f[n>>2]|0;f[n>>2]=la+1;b[la>>0]=_a;f[E>>2]=(f[E>>2]|0)+-1;la=f[a>>2]|0;ha=la+12|0;ga=f[ha>>2]|0;if((ga|0)==(f[la+16>>2]|0)){di[f[(f[la>>2]|0)+40>>2]&1023](la)|0;Ra=Wa;Sa=Xa;continue}else{f[ha>>2]=ga+1;UWb(b[ga>>0]|0)|0;Ra=Wa;Sa=Xa;continue}}}while(0);if((f[n>>2]|0)==(f[m>>2]|0)){R=232;break a}else ca=O;break}default:ca=O}while(0);g:do if((R|0)==46)while(1){R=0;S=f[a>>2]|0;do if(S){T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))$a=di[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else $a=UWb(b[T>>0]|0)|0;if(SXb($a,TWb()|0)|0){f[a>>2]=0;ab=1;break}else{ab=(f[a>>2]|0)==0;break}}else ab=1;while(0);do if(ba){S=f[ba+12>>2]|0;if((S|0)==(f[ba+16>>2]|0))bb=di[f[(f[ba>>2]|0)+36>>2]&1023](ba)|0;else bb=UWb(b[S>>0]|0)|0;if(!(SXb(bb,TWb()|0)|0))if(ab^(aa|0)==0){cb=aa;db=aa;break}else{ca=O;break g}else{f[c>>2]=0;eb=0;R=59;break}}else{eb=aa;R=59}while(0);if((R|0)==59){R=0;if(ab){ca=O;break g}else{cb=eb;db=0}}S=f[a>>2]|0;T=f[S+12>>2]|0;if((T|0)==(f[S+16>>2]|0))fb=di[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else fb=UWb(b[T>>0]|0)|0;if((fb&255)<<24>>24<=-1){ca=O;break g}if(!(d[(f[g>>2]|0)+(fb<<24>>24<<1)>>1]&8192)){ca=O;break g}T=f[a>>2]|0;S=T+12|0;ga=f[S>>2]|0;if((ga|0)==(f[T+16>>2]|0))gb=di[f[(f[T>>2]|0)+40>>2]&1023](T)|0;else{f[S>>2]=ga+1;gb=UWb(b[ga>>0]|0)|0}l6b(D,gb&255);aa=cb;ba=db;R=46}while(0);O=ca;P=P+1|0}h:do if((R|0)==44){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==103){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==144){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==232){f[j>>2]=f[j>>2]|4;hb=0}else if((R|0)==234){i:do if(Q){P=O+11|0;ca=O+4|0;db=1;j:while(1){ba=b[P>>0]|0;if(ba<<24>>24<0)ib=f[ca>>2]|0;else ib=ba&255;if(db>>>0>=ib>>>0)break i;ba=f[a>>2]|0;do if(ba){cb=f[ba+12>>2]|0;if((cb|0)==(f[ba+16>>2]|0))jb=di[f[(f[ba>>2]|0)+36>>2]&1023](ba)|0;else jb=UWb(b[cb>>0]|0)|0;if(SXb(jb,TWb()|0)|0){f[a>>2]=0;kb=1;break}else{kb=(f[a>>2]|0)==0;break}}else kb=1;while(0);ba=f[c>>2]|0;do if(ba){cb=f[ba+12>>2]|0;if((cb|0)==(f[ba+16>>2]|0))lb=di[f[(f[ba>>2]|0)+36>>2]&1023](ba)|0;else lb=UWb(b[cb>>0]|0)|0;if(!(SXb(lb,TWb()|0)|0))if(kb)break;else break j;else{f[c>>2]=0;R=253;break}}else R=253;while(0);if((R|0)==253?(R=0,kb):0)break;ba=f[a>>2]|0;cb=f[ba+12>>2]|0;if((cb|0)==(f[ba+16>>2]|0))mb=di[f[(f[ba>>2]|0)+36>>2]&1023](ba)|0;else mb=UWb(b[cb>>0]|0)|0;if((b[P>>0]|0)<0)nb=f[O>>2]|0;else nb=O;if((mb&255)<<24>>24!=(b[nb+db>>0]|0))break;cb=db+1|0;ba=f[a>>2]|0;aa=ba+12|0;gb=f[aa>>2]|0;if((gb|0)==(f[ba+16>>2]|0)){di[f[(f[ba>>2]|0)+40>>2]&1023](ba)|0;db=cb;continue}else{f[aa>>2]=gb+1;UWb(b[gb>>0]|0)|0;db=cb;continue}}f[j>>2]=f[j>>2]|4;hb=0;break h}while(0);db=f[s>>2]|0;P=f[t>>2]|0;if((db|0)!=(P|0)){f[F>>2]=0;MZb(z,db,P,F);if(!(f[F>>2]|0)){hb=1;break}else{f[j>>2]=f[j>>2]|4;hb=0;break}}else hb=1}while(0);Z5b(D);Z5b(C);Z5b(B);Z5b(A);Z5b(z);z=f[s>>2]|0;f[s>>2]=0;if(z|0)bi[f[o>>2]&2047](z);u=p;return hb|0}function Q1b(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=xZb(c,857220)|0;zh[f[(f[a>>2]|0)+44>>2]&2047](n,a);p=f[n>>2]|0;b[d>>0]=p;b[d+1>>0]=p>>8;b[d+2>>0]=p>>16;b[d+3>>0]=p>>24;zh[f[(f[a>>2]|0)+32>>2]&2047](o,a);p=k+11|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;b[n>>0]=0;PXb(q,n);f[k+4>>2]=0;r=k}else{b[n>>0]=0;PXb(k,n);b[p>>0]=0;r=k}c6b(k,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}Z5b(o);zh[f[(f[a>>2]|0)+28>>2]&2047](o,a);r=j+11|0;if((b[r>>0]|0)<0){p=f[j>>2]|0;b[n>>0]=0;PXb(p,n);f[j+4>>2]=0;s=j}else{b[n>>0]=0;PXb(j,n);b[r>>0]=0;s=j}c6b(j,0);f[s>>2]=f[o>>2];f[s+4>>2]=f[o+4>>2];f[s+8>>2]=f[o+8>>2];s=0;while(1){if((s|0)==3)break;f[o+(s<<2)>>2]=0;s=s+1|0}Z5b(o);s=di[f[(f[a>>2]|0)+12>>2]&1023](a)|0;b[e>>0]=s;s=di[f[(f[a>>2]|0)+16>>2]&1023](a)|0;b[g>>0]=s;zh[f[(f[a>>2]|0)+20>>2]&2047](o,a);s=h+11|0;if((b[s>>0]|0)<0){r=f[h>>2]|0;b[n>>0]=0;PXb(r,n);f[h+4>>2]=0;t=h}else{b[n>>0]=0;PXb(h,n);b[s>>0]=0;t=h}c6b(h,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}Z5b(o);zh[f[(f[a>>2]|0)+24>>2]&2047](o,a);t=i+11|0;if((b[t>>0]|0)<0){s=f[i>>2]|0;b[n>>0]=0;PXb(s,n);f[i+4>>2]=0;v=i}else{b[n>>0]=0;PXb(i,n);b[t>>0]=0;v=i}c6b(i,0);f[v>>2]=f[o>>2];f[v+4>>2]=f[o+4>>2];f[v+8>>2]=f[o+8>>2];v=0;while(1){if((v|0)==3)break;f[o+(v<<2)>>2]=0;v=v+1|0}Z5b(o);w=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0}else{a=xZb(c,857212)|0;zh[f[(f[a>>2]|0)+44>>2]&2047](n,a);c=f[n>>2]|0;b[d>>0]=c;b[d+1>>0]=c>>8;b[d+2>>0]=c>>16;b[d+3>>0]=c>>24;zh[f[(f[a>>2]|0)+32>>2]&2047](o,a);c=k+11|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;b[n>>0]=0;PXb(d,n);f[k+4>>2]=0;x=k}else{b[n>>0]=0;PXb(k,n);b[c>>0]=0;x=k}c6b(k,0);f[x>>2]=f[o>>2];f[x+4>>2]=f[o+4>>2];f[x+8>>2]=f[o+8>>2];x=0;while(1){if((x|0)==3)break;f[o+(x<<2)>>2]=0;x=x+1|0}Z5b(o);zh[f[(f[a>>2]|0)+28>>2]&2047](o,a);x=j+11|0;if((b[x>>0]|0)<0){k=f[j>>2]|0;b[n>>0]=0;PXb(k,n);f[j+4>>2]=0;y=j}else{b[n>>0]=0;PXb(j,n);b[x>>0]=0;y=j}c6b(j,0);f[y>>2]=f[o>>2];f[y+4>>2]=f[o+4>>2];f[y+8>>2]=f[o+8>>2];y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}Z5b(o);y=di[f[(f[a>>2]|0)+12>>2]&1023](a)|0;b[e>>0]=y;y=di[f[(f[a>>2]|0)+16>>2]&1023](a)|0;b[g>>0]=y;zh[f[(f[a>>2]|0)+20>>2]&2047](o,a);y=h+11|0;if((b[y>>0]|0)<0){g=f[h>>2]|0;b[n>>0]=0;PXb(g,n);f[h+4>>2]=0;z=h}else{b[n>>0]=0;PXb(h,n);b[y>>0]=0;z=h}c6b(h,0);f[z>>2]=f[o>>2];f[z+4>>2]=f[o+4>>2];f[z+8>>2]=f[o+8>>2];z=0;while(1){if((z|0)==3)break;f[o+(z<<2)>>2]=0;z=z+1|0}Z5b(o);zh[f[(f[a>>2]|0)+24>>2]&2047](o,a);z=i+11|0;if((b[z>>0]|0)<0){h=f[i>>2]|0;b[n>>0]=0;PXb(h,n);f[i+4>>2]=0;A=i}else{b[n>>0]=0;PXb(i,n);b[z>>0]=0;A=i}c6b(i,0);f[A>>2]=f[o>>2];f[A+4>>2]=f[o+4>>2];f[A+8>>2]=f[o+8>>2];A=0;while(1){if((A|0)==3)break;f[o+(A<<2)>>2]=0;A=A+1|0}Z5b(o);w=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0}f[l>>2]=w;u=m;return}function R1b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=(f[d>>2]|0)!=1549;g=f[a>>2]|0;h=(f[c>>2]|0)-g|0;i=h>>>0<2147483647?h<<1:-1;h=(i|0)==0?1:i;i=(f[b>>2]|0)-g|0;j=QSb(e?g:0,h)|0;if(!j)Q5b();if(!e){e=f[a>>2]|0;f[a>>2]=j;if(!e)k=j;else{bi[f[d>>2]&2047](e);k=f[a>>2]|0}}else{f[a>>2]=j;k=j}f[d>>2]=1550;f[b>>2]=k+i;f[c>>2]=(f[a>>2]|0)+h;return}function S1b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=(f[d>>2]|0)!=1549;g=f[a>>2]|0;h=(f[c>>2]|0)-g|0;i=h>>>0<2147483647?h<<1:-1;h=(i|0)==0?4:i;i=(f[b>>2]|0)-g>>2;j=QSb(e?g:0,h)|0;if(!j)Q5b();if(!e){e=f[a>>2]|0;f[a>>2]=j;if(!e)k=j;else{bi[f[d>>2]&2047](e);k=f[a>>2]|0}}else{f[a>>2]=j;k=j}f[d>>2]=1550;f[b>>2]=k+(i<<2);f[c>>2]=(f[a>>2]|0)+(h>>>2<<2);return}function T1b(a){a=a|0;dZb(a);return}function U1b(a){a=a|0;dZb(a);O5b(a);return}function V1b(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+576|0;j=a+424|0;k=a;l=a+24|0;m=a+16|0;n=a+12|0;o=a+8|0;p=a+564|0;q=a+4|0;r=a+464|0;f[m>>2]=l;s=m+4|0;f[s>>2]=1549;TXb(o,g);t=xZb(o,855532)|0;b[p>>0]=0;f[q>>2]=f[d>>2];v=f[g+4>>2]|0;f[j>>2]=f[q>>2];if(X1b(c,j,e,o,v,h,p,t,m,n,l+400|0)|0){Dg[f[(f[t>>2]|0)+48>>2]&127](t,487594,487604,j)|0;t=f[n>>2]|0;l=f[m>>2]|0;v=t-l|0;e=l;l=t;if((v|0)>392){t=OSb((v>>>2)+2|0)|0;if(!t)Q5b();else{w=t;x=t}}else{w=r;x=0}if(!(b[p>>0]|0))y=w;else{b[w>>0]=45;y=w+1|0}w=j+40|0;p=j;t=e;e=y;y=l;while(1){if(t>>>0>=y>>>0)break;l=f[t>>2]|0;v=j;while(1){if((v|0)==(w|0)){z=w;break}if((f[v>>2]|0)==(l|0)){z=v;break}v=v+4|0}b[e>>0]=b[487594+(z-p>>2)>>0]|0;t=t+4|0;e=e+1|0;y=f[n>>2]|0}b[e>>0]=0;f[k>>2]=i;if((RUb(r,487495,k)|0)!=1)S0b(0);if(x|0)PSb(x)}x=f[c>>2]|0;do if(x){k=f[x+12>>2]|0;if((k|0)==(f[x+16>>2]|0))A=di[f[(f[x>>2]|0)+36>>2]&1023](x)|0;else A=kXb(f[k>>2]|0)|0;if(UXb(A,jXb()|0)|0){f[c>>2]=0;B=1;break}else{B=(f[c>>2]|0)==0;break}}else B=1;while(0);A=f[d>>2]|0;do if(A){x=f[A+12>>2]|0;if((x|0)==(f[A+16>>2]|0))C=di[f[(f[A>>2]|0)+36>>2]&1023](A)|0;else C=kXb(f[x>>2]|0)|0;if(!(UXb(C,jXb()|0)|0))if(B)break;else{D=34;break}else{f[d>>2]=0;D=32;break}}else D=32;while(0);if((D|0)==32?B:0)D=34;if((D|0)==34)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;yZb(o);o=f[m>>2]|0;f[m>>2]=0;if(o|0)bi[f[s>>2]&2047](o);u=a;return h|0}function W1b(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;a=u;u=u+432|0;j=a+424|0;k=a+24|0;l=a+16|0;m=a+8|0;n=a;o=a+428|0;p=a+4|0;f[l>>2]=k;q=l+4|0;f[q>>2]=1549;TXb(n,g);r=xZb(n,855532)|0;b[o>>0]=0;s=f[d>>2]|0;f[p>>2]=s;t=f[g+4>>2]|0;f[j>>2]=f[p>>2];p=s;if(X1b(c,j,e,n,t,h,o,r,l,m,k+400|0)|0){k=i+8+3|0;if((b[k>>0]|0)<0){t=f[i>>2]|0;f[j>>2]=0;jZb(t,j);f[i+4>>2]=0}else{f[j>>2]=0;jZb(i,j);b[k>>0]=0}if(b[o>>0]|0)D6b(i,Uh[f[(f[r>>2]|0)+44>>2]&1023](r,45)|0);o=Uh[f[(f[r>>2]|0)+44>>2]&1023](r,48)|0;r=f[m>>2]|0;m=r+-4|0;k=f[l>>2]|0;while(1){if(k>>>0>=m>>>0)break;if((f[k>>2]|0)!=(o|0))break;k=k+4|0}Y1b(i,k,r)|0}r=f[c>>2]|0;do if(r){k=f[r+12>>2]|0;if((k|0)==(f[r+16>>2]|0))v=di[f[(f[r>>2]|0)+36>>2]&1023](r)|0;else v=kXb(f[k>>2]|0)|0;if(UXb(v,jXb()|0)|0){f[c>>2]=0;w=1;break}else{w=(f[c>>2]|0)==0;break}}else w=1;while(0);do if(s){v=f[p+12>>2]|0;if((v|0)==(f[p+16>>2]|0))x=di[f[(f[s>>2]|0)+36>>2]&1023](p)|0;else x=kXb(f[v>>2]|0)|0;if(!(UXb(x,jXb()|0)|0))if(w)break;else{y=27;break}else{f[d>>2]=0;y=25;break}}else y=25;while(0);if((y|0)==25?w:0)y=27;if((y|0)==27)f[h>>2]=f[h>>2]|2;h=f[c>>2]|0;yZb(n);n=f[l>>2]|0;f[l>>2]=0;if(n|0)bi[f[q>>2]&2047](n);u=a;return h|0}function X1b(a,c,d,e,g,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0;o=u;u=u+512|0;p=o+96|0;q=o+104|0;r=o+88|0;s=o+80|0;t=o+76|0;v=o+504|0;w=o+72|0;x=o+68|0;y=o+56|0;z=o+44|0;A=o+32|0;B=o+20|0;C=o+8|0;D=o+4|0;E=o;f[p>>2]=n;f[r>>2]=q;n=r+4|0;f[n>>2]=1549;f[s>>2]=q;f[t>>2]=q+400;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[y+(q<<2)>>2]=0;q=q+1|0}f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[z+(q<<2)>>2]=0;q=q+1|0}f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[A+(q<<2)>>2]=0;q=q+1|0}f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[B+(q<<2)>>2]=0;q=q+1|0}f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;q=0;while(1){if((q|0)==3)break;f[C+(q<<2)>>2]=0;q=q+1|0}_1b(d,e,v,w,x,y,z,A,B,D);f[m>>2]=f[l>>2];e=A+8+3|0;d=A+4|0;q=B+8+3|0;F=B+4|0;G=(g&512|0)!=0;g=z+8+3|0;H=z+4|0;I=C+8+3|0;J=C+4|0;K=v+3|0;L=y+11|0;M=y+4|0;N=0;O=0;a:while(1){P=(N|0)!=0;if(O>>>0>=4){Q=229;break}R=f[a>>2]|0;do if(R){S=f[R+12>>2]|0;if((S|0)==(f[R+16>>2]|0))T=di[f[(f[R>>2]|0)+36>>2]&1023](R)|0;else T=kXb(f[S>>2]|0)|0;if(UXb(T,jXb()|0)|0){f[a>>2]=0;U=1;break}else{U=(f[a>>2]|0)==0;break}}else U=1;while(0);R=f[c>>2]|0;do if(R){S=f[R+12>>2]|0;if((S|0)==(f[R+16>>2]|0))V=di[f[(f[R>>2]|0)+36>>2]&1023](R)|0;else V=kXb(f[S>>2]|0)|0;if(!(UXb(V,jXb()|0)|0))if(U){W=R;break}else{Q=229;break a}else{f[c>>2]=0;Q=31;break}}else Q=31;while(0);if((Q|0)==31){Q=0;if(U){Q=229;break}else W=0}R=(O|0)!=3;b:do switch(b[v+O>>0]|0){case 1:{if(R){S=f[a>>2]|0;X=f[S+12>>2]|0;if((X|0)==(f[S+16>>2]|0))Y=di[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else Y=kXb(f[X>>2]|0)|0;if(!(li[f[(f[k>>2]|0)+12>>2]&511](k,8192,Y)|0)){Q=43;break a}X=f[a>>2]|0;S=X+12|0;Z=f[S>>2]|0;if((Z|0)==(f[X+16>>2]|0))_=di[f[(f[X>>2]|0)+40>>2]&1023](X)|0;else{f[S>>2]=Z+4;_=kXb(f[Z>>2]|0)|0}D6b(C,_);$=W;aa=W;Q=45}else ba=N;break}case 0:{if(R){$=W;aa=W;Q=45}else ba=N;break}case 3:{Z=b[e>>0]|0;S=Z<<24>>24<0?f[d>>2]|0:Z&255;Z=b[q>>0]|0;X=Z<<24>>24<0?f[F>>2]|0:Z&255;if((S|0)==(0-X|0))ba=N;else{Z=(S|0)==0;S=f[a>>2]|0;ca=f[S+12>>2]|0;da=(ca|0)==(f[S+16>>2]|0);if(Z|(X|0)==0){if(da)ea=di[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else ea=kXb(f[ca>>2]|0)|0;if(Z){if((ea|0)!=(f[((b[q>>0]|0)<0?f[B>>2]|0:B)>>2]|0)){ba=N;break b}Z=f[a>>2]|0;X=Z+12|0;fa=f[X>>2]|0;if((fa|0)==(f[Z+16>>2]|0))di[f[(f[Z>>2]|0)+40>>2]&1023](Z)|0;else{f[X>>2]=fa+4;kXb(f[fa>>2]|0)|0}b[j>>0]=1;fa=b[q>>0]|0;ba=(fa<<24>>24<0?f[F>>2]|0:fa&255)>>>0>1?B:N;break b}if((ea|0)!=(f[((b[e>>0]|0)<0?f[A>>2]|0:A)>>2]|0)){b[j>>0]=1;ba=N;break b}fa=f[a>>2]|0;X=fa+12|0;Z=f[X>>2]|0;if((Z|0)==(f[fa+16>>2]|0))di[f[(f[fa>>2]|0)+40>>2]&1023](fa)|0;else{f[X>>2]=Z+4;kXb(f[Z>>2]|0)|0}Z=b[e>>0]|0;ba=(Z<<24>>24<0?f[d>>2]|0:Z&255)>>>0>1?A:N;break b}if(da)ga=di[f[(f[S>>2]|0)+36>>2]&1023](S)|0;else ga=kXb(f[ca>>2]|0)|0;ca=f[a>>2]|0;S=ca+12|0;da=f[S>>2]|0;Z=(da|0)==(f[ca+16>>2]|0);if((ga|0)==(f[((b[e>>0]|0)<0?f[A>>2]|0:A)>>2]|0)){if(Z)di[f[(f[ca>>2]|0)+40>>2]&1023](ca)|0;else{f[S>>2]=da+4;kXb(f[da>>2]|0)|0}S=b[e>>0]|0;ba=(S<<24>>24<0?f[d>>2]|0:S&255)>>>0>1?A:N;break b}if(Z)ha=di[f[(f[ca>>2]|0)+36>>2]&1023](ca)|0;else ha=kXb(f[da>>2]|0)|0;if((ha|0)!=(f[((b[q>>0]|0)<0?f[B>>2]|0:B)>>2]|0)){Q=101;break a}da=f[a>>2]|0;ca=da+12|0;Z=f[ca>>2]|0;if((Z|0)==(f[da+16>>2]|0))di[f[(f[da>>2]|0)+40>>2]&1023](da)|0;else{f[ca>>2]=Z+4;kXb(f[Z>>2]|0)|0}b[j>>0]=1;Z=b[q>>0]|0;ba=(Z<<24>>24<0?f[F>>2]|0:Z&255)>>>0>1?B:N}break}case 2:{if(!(O>>>0<2|P)?!(G|(O|0)==2&(b[K>>0]|0)!=0):0){ba=0;break b}Z=b[g>>0]|0;ca=f[z>>2]|0;da=Z<<24>>24<0?ca:z;c:do if((O|0)!=0?(h[v+(O+-1)>>0]|0)<2:0){S=da;X=Z;fa=ca;while(1){ia=X<<24>>24<0;ja=S;if((ja|0)==((ia?fa:z)+((ia?f[H>>2]|0:X&255)<<2)|0)){ka=X;la=fa;break}if(!(li[f[(f[k>>2]|0)+12>>2]&511](k,8192,f[ja>>2]|0)|0)){Q=108;break}S=ja+4|0;X=b[g>>0]|0;fa=f[z>>2]|0}if((Q|0)==108){Q=0;ka=b[g>>0]|0;la=f[z>>2]|0}fa=ka<<24>>24<0?la:z;X=fa;ja=S-X>>2;ia=b[I>>0]|0;ma=ia<<24>>24<0;na=ma?f[J>>2]|0:ia&255;if(ja>>>0>na>>>0){oa=W;pa=X;qa=ka;ra=la;sa=W}else{ia=(ma?f[C>>2]|0:C)+(na<<2)|0;na=fa;fa=ia+(0-ja<<2)|0;while(1){if((fa|0)==(ia|0)){oa=W;pa=S;qa=ka;ra=la;sa=W;break c}if((f[fa>>2]|0)!=(f[na>>2]|0)){oa=W;pa=X;qa=ka;ra=la;sa=W;break c}na=na+4|0;fa=fa+4|0}}}else{oa=W;pa=da;qa=Z;ra=ca;sa=W}while(0);d:while(1){ca=qa<<24>>24<0;Z=(ca?ra:z)+((ca?f[H>>2]|0:qa&255)<<2)|0;ca=pa;if((ca|0)==(Z|0)){ta=Z;break}Z=f[a>>2]|0;do if(Z){da=f[Z+12>>2]|0;if((da|0)==(f[Z+16>>2]|0))ua=di[f[(f[Z>>2]|0)+36>>2]&1023](Z)|0;else ua=kXb(f[da>>2]|0)|0;if(UXb(ua,jXb()|0)|0){f[a>>2]=0;va=1;break}else{va=(f[a>>2]|0)==0;break}}else va=1;while(0);do if(sa){Z=f[sa+12>>2]|0;if((Z|0)==(f[sa+16>>2]|0))wa=di[f[(f[sa>>2]|0)+36>>2]&1023](sa)|0;else wa=kXb(f[Z>>2]|0)|0;if(!(UXb(wa,jXb()|0)|0))if(va^(oa|0)==0){xa=oa;ya=oa;break}else{ta=ca;break d}else{f[c>>2]=0;za=0;Q=129;break}}else{za=oa;Q=129}while(0);if((Q|0)==129){Q=0;if(va){ta=ca;break}else{xa=za;ya=0}}Z=f[a>>2]|0;da=f[Z+12>>2]|0;if((da|0)==(f[Z+16>>2]|0))Aa=di[f[(f[Z>>2]|0)+36>>2]&1023](Z)|0;else Aa=kXb(f[da>>2]|0)|0;if((Aa|0)!=(f[ca>>2]|0)){ta=ca;break}da=f[a>>2]|0;Z=da+12|0;fa=f[Z>>2]|0;if((fa|0)==(f[da+16>>2]|0))di[f[(f[da>>2]|0)+40>>2]&1023](da)|0;else{f[Z>>2]=fa+4;kXb(f[fa>>2]|0)|0}oa=xa;pa=ca+4|0;qa=b[g>>0]|0;ra=f[z>>2]|0;sa=ya}if(G?(fa=b[g>>0]|0,Z=fa<<24>>24<0,(ta|0)!=((Z?f[z>>2]|0:z)+((Z?f[H>>2]|0:fa&255)<<2)|0)):0){Q=141;break a}else ba=N;break}case 4:{fa=0;Z=W;da=W;e:while(1){na=f[a>>2]|0;do if(na){X=f[na+12>>2]|0;if((X|0)==(f[na+16>>2]|0))Ba=di[f[(f[na>>2]|0)+36>>2]&1023](na)|0;else Ba=kXb(f[X>>2]|0)|0;if(UXb(Ba,jXb()|0)|0){f[a>>2]=0;Ca=1;break}else{Ca=(f[a>>2]|0)==0;break}}else Ca=1;while(0);do if(da){na=f[da+12>>2]|0;if((na|0)==(f[da+16>>2]|0))Da=di[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else Da=kXb(f[na>>2]|0)|0;if(!(UXb(Da,jXb()|0)|0))if(Ca^(Z|0)==0){Ea=Z;Fa=Z;break}else{Ga=Z;break e}else{f[c>>2]=0;Ha=0;Q=155;break}}else{Ha=Z;Q=155}while(0);if((Q|0)==155){Q=0;if(Ca){Ga=Ha;break}else{Ea=Ha;Fa=0}}na=f[a>>2]|0;ca=f[na+12>>2]|0;if((ca|0)==(f[na+16>>2]|0))Ia=di[f[(f[na>>2]|0)+36>>2]&1023](na)|0;else Ia=kXb(f[ca>>2]|0)|0;if(li[f[(f[k>>2]|0)+12>>2]&511](k,2048,Ia)|0){ca=f[m>>2]|0;if((ca|0)==(f[p>>2]|0)){$1b(l,m,p);Ja=f[m>>2]|0}else Ja=ca;f[m>>2]=Ja+4;f[Ja>>2]=Ia;Ka=fa+1|0}else{ca=b[L>>0]|0;if(!((Ia|0)==(f[x>>2]|0)&(fa|0?((ca<<24>>24<0?f[M>>2]|0:ca&255)|0)!=0:0))){Ga=Ea;break}ca=f[s>>2]|0;if((ca|0)==(f[t>>2]|0)){S1b(r,s,t);La=f[s>>2]|0}else La=ca;f[s>>2]=La+4;f[La>>2]=fa;Ka=0}ca=f[a>>2]|0;na=ca+12|0;X=f[na>>2]|0;if((X|0)==(f[ca+16>>2]|0)){di[f[(f[ca>>2]|0)+40>>2]&1023](ca)|0;fa=Ka;Z=Ea;da=Fa;continue}else{f[na>>2]=X+4;kXb(f[X>>2]|0)|0;fa=Ka;Z=Ea;da=Fa;continue}}da=f[s>>2]|0;if(fa|0?(f[r>>2]|0)!=(da|0):0){if((da|0)==(f[t>>2]|0)){S1b(r,s,t);Ma=f[s>>2]|0}else Ma=da;f[s>>2]=Ma+4;f[Ma>>2]=fa}f:do if((f[D>>2]|0)>0){da=f[a>>2]|0;do if(da){Z=f[da+12>>2]|0;if((Z|0)==(f[da+16>>2]|0))Na=di[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else Na=kXb(f[Z>>2]|0)|0;if(UXb(Na,jXb()|0)|0){f[a>>2]=0;Oa=1;break}else{Oa=(f[a>>2]|0)==0;break}}else Oa=1;while(0);do if(Ga){da=f[Ga+12>>2]|0;if((da|0)==(f[Ga+16>>2]|0))Pa=di[f[(f[Ga>>2]|0)+36>>2]&1023](Ga)|0;else Pa=kXb(f[da>>2]|0)|0;if(!(UXb(Pa,jXb()|0)|0))if(Oa){Qa=Ga;break}else{Q=227;break a}else{f[c>>2]=0;Q=189;break}}else Q=189;while(0);if((Q|0)==189){Q=0;if(Oa){Q=227;break a}else Qa=0}da=f[a>>2]|0;Z=f[da+12>>2]|0;if((Z|0)==(f[da+16>>2]|0))Ra=di[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else Ra=kXb(f[Z>>2]|0)|0;if((Ra|0)!=(f[w>>2]|0)){Q=227;break a}Z=f[a>>2]|0;da=Z+12|0;X=f[da>>2]|0;if((X|0)==(f[Z+16>>2]|0)){di[f[(f[Z>>2]|0)+40>>2]&1023](Z)|0;Sa=Qa;Ta=Qa}else{f[da>>2]=X+4;kXb(f[X>>2]|0)|0;Sa=Qa;Ta=Qa}while(1){if((f[D>>2]|0)<=0)break f;X=f[a>>2]|0;do if(X){da=f[X+12>>2]|0;if((da|0)==(f[X+16>>2]|0))Ua=di[f[(f[X>>2]|0)+36>>2]&1023](X)|0;else Ua=kXb(f[da>>2]|0)|0;if(UXb(Ua,jXb()|0)|0){f[a>>2]=0;Va=1;break}else{Va=(f[a>>2]|0)==0;break}}else Va=1;while(0);do if(Ta){X=f[Ta+12>>2]|0;if((X|0)==(f[Ta+16>>2]|0))Wa=di[f[(f[Ta>>2]|0)+36>>2]&1023](Ta)|0;else Wa=kXb(f[X>>2]|0)|0;if(!(UXb(Wa,jXb()|0)|0))if(Va^(Sa|0)==0){Xa=Sa;Ya=Sa;break}else{Q=227;break a}else{f[c>>2]=0;Za=0;Q=212;break}}else{Za=Sa;Q=212}while(0);if((Q|0)==212){Q=0;if(Va){Q=227;break a}else{Xa=Za;Ya=0}}X=f[a>>2]|0;da=f[X+12>>2]|0;if((da|0)==(f[X+16>>2]|0))_a=di[f[(f[X>>2]|0)+36>>2]&1023](X)|0;else _a=kXb(f[da>>2]|0)|0;if(!(li[f[(f[k>>2]|0)+12>>2]&511](k,2048,_a)|0)){Q=227;break a}if((f[m>>2]|0)==(f[p>>2]|0))$1b(l,m,p);da=f[a>>2]|0;X=f[da+12>>2]|0;if((X|0)==(f[da+16>>2]|0))$a=di[f[(f[da>>2]|0)+36>>2]&1023](da)|0;else $a=kXb(f[X>>2]|0)|0;X=f[m>>2]|0;f[m>>2]=X+4;f[X>>2]=$a;f[D>>2]=(f[D>>2]|0)+-1;X=f[a>>2]|0;da=X+12|0;Z=f[da>>2]|0;if((Z|0)==(f[X+16>>2]|0)){di[f[(f[X>>2]|0)+40>>2]&1023](X)|0;Sa=Xa;Ta=Ya;continue}else{f[da>>2]=Z+4;kXb(f[Z>>2]|0)|0;Sa=Xa;Ta=Ya;continue}}}while(0);if((f[m>>2]|0)==(f[l>>2]|0)){Q=227;break a}else ba=N;break}default:ba=N}while(0);g:do if((Q|0)==45)while(1){Q=0;R=f[a>>2]|0;do if(R){fa=f[R+12>>2]|0;if((fa|0)==(f[R+16>>2]|0))ab=di[f[(f[R>>2]|0)+36>>2]&1023](R)|0;else ab=kXb(f[fa>>2]|0)|0;if(UXb(ab,jXb()|0)|0){f[a>>2]=0;bb=1;break}else{bb=(f[a>>2]|0)==0;break}}else bb=1;while(0);do if(aa){R=f[aa+12>>2]|0;if((R|0)==(f[aa+16>>2]|0))cb=di[f[(f[aa>>2]|0)+36>>2]&1023](aa)|0;else cb=kXb(f[R>>2]|0)|0;if(!(UXb(cb,jXb()|0)|0))if(bb^($|0)==0){db=$;eb=$;break}else{ba=N;break g}else{f[c>>2]=0;fb=0;Q=58;break}}else{fb=$;Q=58}while(0);if((Q|0)==58){Q=0;if(bb){ba=N;break g}else{db=fb;eb=0}}R=f[a>>2]|0;fa=f[R+12>>2]|0;if((fa|0)==(f[R+16>>2]|0))gb=di[f[(f[R>>2]|0)+36>>2]&1023](R)|0;else gb=kXb(f[fa>>2]|0)|0;if(!(li[f[(f[k>>2]|0)+12>>2]&511](k,8192,gb)|0)){ba=N;break g}fa=f[a>>2]|0;R=fa+12|0;Z=f[R>>2]|0;if((Z|0)==(f[fa+16>>2]|0))hb=di[f[(f[fa>>2]|0)+40>>2]&1023](fa)|0;else{f[R>>2]=Z+4;hb=kXb(f[Z>>2]|0)|0}D6b(C,hb);$=db;aa=eb;Q=45}while(0);N=ba;O=O+1|0}h:do if((Q|0)==43){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==101){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==141){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==227){f[i>>2]=f[i>>2]|4;ib=0}else if((Q|0)==229){i:do if(P){O=N+8+3|0;ba=N+4|0;eb=1;j:while(1){aa=b[O>>0]|0;if(aa<<24>>24<0)jb=f[ba>>2]|0;else jb=aa&255;if(eb>>>0>=jb>>>0)break i;aa=f[a>>2]|0;do if(aa){db=f[aa+12>>2]|0;if((db|0)==(f[aa+16>>2]|0))kb=di[f[(f[aa>>2]|0)+36>>2]&1023](aa)|0;else kb=kXb(f[db>>2]|0)|0;if(UXb(kb,jXb()|0)|0){f[a>>2]=0;lb=1;break}else{lb=(f[a>>2]|0)==0;break}}else lb=1;while(0);aa=f[c>>2]|0;do if(aa){db=f[aa+12>>2]|0;if((db|0)==(f[aa+16>>2]|0))mb=di[f[(f[aa>>2]|0)+36>>2]&1023](aa)|0;else mb=kXb(f[db>>2]|0)|0;if(!(UXb(mb,jXb()|0)|0))if(lb)break;else break j;else{f[c>>2]=0;Q=248;break}}else Q=248;while(0);if((Q|0)==248?(Q=0,lb):0)break;aa=f[a>>2]|0;db=f[aa+12>>2]|0;if((db|0)==(f[aa+16>>2]|0))nb=di[f[(f[aa>>2]|0)+36>>2]&1023](aa)|0;else nb=kXb(f[db>>2]|0)|0;if((b[O>>0]|0)<0)ob=f[N>>2]|0;else ob=N;if((nb|0)!=(f[ob+(eb<<2)>>2]|0))break;db=eb+1|0;aa=f[a>>2]|0;$=aa+12|0;hb=f[$>>2]|0;if((hb|0)==(f[aa+16>>2]|0)){di[f[(f[aa>>2]|0)+40>>2]&1023](aa)|0;eb=db;continue}else{f[$>>2]=hb+4;kXb(f[hb>>2]|0)|0;eb=db;continue}}f[i>>2]=f[i>>2]|4;ib=0;break h}while(0);eb=f[r>>2]|0;O=f[s>>2]|0;if((eb|0)!=(O|0)){f[E>>2]=0;MZb(y,eb,O,E);if(!(f[E>>2]|0)){ib=1;break}else{f[i>>2]=f[i>>2]|4;ib=0;break}}else ib=1}while(0);v6b(C);v6b(B);v6b(A);v6b(z);Z5b(y);y=f[r>>2]|0;f[r>>2]=0;if(y|0)bi[f[n>>2]&2047](y);u=o;return ib|0}function Y1b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e+12|0;h=e;i=a+8|0;j=i+3|0;k=b[j>>0]|0;l=k<<24>>24<0;if(l){m=f[a+4>>2]|0;n=(f[i>>2]&2147483647)+-1|0}else{m=k&255;n=1}i=d-c>>2;do if(i|0){if(l){o=f[a>>2]|0;p=o;q=f[a+4>>2]|0;r=o}else{p=a;q=k&255;r=a}if(Z1b(c,r,p+(q<<2)|0)|0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(i>>>0>1073741807)V5b(h);do if(i>>>0>=2){o=i+4&-4;if(o>>>0>1073741823)Re();else{s=L5b(o<<2)|0;f[h>>2]=s;f[h+8>>2]=o|-2147483648;f[h+4>>2]=i;t=c;v=s;break}}else{b[h+8+3>>0]=i;t=c;v=h}while(0);while(1){if((t|0)==(d|0))break;jZb(v,t);t=t+4|0;v=v+4|0}f[g>>2]=0;jZb(v,g);s=b[h+8+3>>0]|0;o=s<<24>>24<0;C6b(a,o?f[h>>2]|0:h,o?f[h+4>>2]|0:s&255)|0;v6b(h);break}s=m+i|0;if((n-m|0)>>>0<i>>>0)B6b(a,n,s-n|0,m,m,0,0);if((b[j>>0]|0)<0)w=f[a>>2]|0;else w=a;o=w+(m<<2)|0;x=c;while(1){if((x|0)==(d|0))break;jZb(o,x);o=o+4|0;x=x+4|0}f[g>>2]=0;jZb(o,g);if((b[j>>0]|0)<0){f[a+4>>2]=s;break}else{b[j>>0]=s;break}}while(0);u=e;return a|0}function Z1b(a,b,c){a=a|0;b=b|0;c=c|0;return b>>>0<=a>>>0&a>>>0<c>>>0|0}function _1b(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=xZb(c,857236)|0;zh[f[(f[a>>2]|0)+44>>2]&2047](n,a);p=f[n>>2]|0;b[d>>0]=p;b[d+1>>0]=p>>8;b[d+2>>0]=p>>16;b[d+3>>0]=p>>24;zh[f[(f[a>>2]|0)+32>>2]&2047](o,a);p=k+8+3|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;f[n>>2]=0;jZb(q,n);f[k+4>>2]=0}else{f[n>>2]=0;jZb(k,n);b[p>>0]=0}z6b(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}v6b(o);zh[f[(f[a>>2]|0)+28>>2]&2047](o,a);p=j+8+3|0;if((b[p>>0]|0)<0){q=f[j>>2]|0;f[n>>2]=0;jZb(q,n);f[j+4>>2]=0}else{f[n>>2]=0;jZb(j,n);b[p>>0]=0}z6b(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}v6b(o);p=di[f[(f[a>>2]|0)+12>>2]&1023](a)|0;f[e>>2]=p;p=di[f[(f[a>>2]|0)+16>>2]&1023](a)|0;f[g>>2]=p;zh[f[(f[a>>2]|0)+20>>2]&2047](o,a);p=h+11|0;if((b[p>>0]|0)<0){q=f[h>>2]|0;b[n>>0]=0;PXb(q,n);f[h+4>>2]=0;r=h}else{b[n>>0]=0;PXb(h,n);b[p>>0]=0;r=h}c6b(h,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}Z5b(o);zh[f[(f[a>>2]|0)+24>>2]&2047](o,a);r=i+8+3|0;if((b[r>>0]|0)<0){p=f[i>>2]|0;f[n>>2]=0;jZb(p,n);f[i+4>>2]=0}else{f[n>>2]=0;jZb(i,n);b[r>>0]=0}z6b(i,0);f[i>>2]=f[o>>2];f[i+4>>2]=f[o+4>>2];f[i+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}v6b(o);s=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0}else{a=xZb(c,857228)|0;zh[f[(f[a>>2]|0)+44>>2]&2047](n,a);c=f[n>>2]|0;b[d>>0]=c;b[d+1>>0]=c>>8;b[d+2>>0]=c>>16;b[d+3>>0]=c>>24;zh[f[(f[a>>2]|0)+32>>2]&2047](o,a);c=k+8+3|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;f[n>>2]=0;jZb(d,n);f[k+4>>2]=0}else{f[n>>2]=0;jZb(k,n);b[c>>0]=0}z6b(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];k=0;while(1){if((k|0)==3)break;f[o+(k<<2)>>2]=0;k=k+1|0}v6b(o);zh[f[(f[a>>2]|0)+28>>2]&2047](o,a);k=j+8+3|0;if((b[k>>0]|0)<0){c=f[j>>2]|0;f[n>>2]=0;jZb(c,n);f[j+4>>2]=0}else{f[n>>2]=0;jZb(j,n);b[k>>0]=0}z6b(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];j=0;while(1){if((j|0)==3)break;f[o+(j<<2)>>2]=0;j=j+1|0}v6b(o);j=di[f[(f[a>>2]|0)+12>>2]&1023](a)|0;f[e>>2]=j;j=di[f[(f[a>>2]|0)+16>>2]&1023](a)|0;f[g>>2]=j;zh[f[(f[a>>2]|0)+20>>2]&2047](o,a);j=h+11|0;if((b[j>>0]|0)<0){g=f[h>>2]|0;b[n>>0]=0;PXb(g,n);f[h+4>>2]=0;t=h}else{b[n>>0]=0;PXb(h,n);b[j>>0]=0;t=h}c6b(h,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}Z5b(o);zh[f[(f[a>>2]|0)+24>>2]&2047](o,a);t=i+8+3|0;if((b[t>>0]|0)<0){h=f[i>>2]|0;f[n>>2]=0;jZb(h,n);f[i+4>>2]=0}else{f[n>>2]=0;jZb(i,n);b[t>>0]=0}z6b(i,0);f[i>>2]=f[o>>2];f[i+4>>2]=f[o+4>>2];f[i+8>>2]=f[o+8>>2];i=0;while(1){if((i|0)==3)break;f[o+(i<<2)>>2]=0;i=i+1|0}v6b(o);s=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0}f[l>>2]=s;u=m;return}function $1b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+4|0;e=(f[d>>2]|0)!=1549;g=f[a>>2]|0;h=(f[c>>2]|0)-g|0;i=h>>>0<2147483647?h<<1:-1;h=(i|0)==0?4:i;i=(f[b>>2]|0)-g>>2;j=QSb(e?g:0,h)|0;if(!j)Q5b();if(!e){e=f[a>>2]|0;f[a>>2]=j;if(!e)k=j;else{bi[f[d>>2]&2047](e);k=f[a>>2]|0}}else{f[a>>2]=j;k=j}f[d>>2]=1550;f[b>>2]=k+(i<<2);f[c>>2]=(f[a>>2]|0)+(h>>>2<<2);return}function a2b(a){a=a|0;dZb(a);return}function b2b(a){a=a|0;dZb(a);O5b(a);return}function c2b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;a=u;u=u+384|0;i=a+8|0;j=a;k=a+284|0;l=a+72|0;m=a+184|0;n=a+68|0;o=a+180|0;q=a+177|0;r=a+176|0;s=a+56|0;t=a+44|0;v=a+32|0;w=a+28|0;x=a+76|0;y=a+24|0;z=a+16|0;A=a+20|0;f[l>>2]=k;p[i>>3]=h;B=GUb(k,100,487700,i)|0;if(B>>>0>99){k=AZb()|0;p[j>>3]=h;C=S_b(l,k,487700,j)|0;j=f[l>>2]|0;if(!j)Q5b();k=OSb(C)|0;if(!k)Q5b();else{D=k;E=C;F=k;G=j}}else{D=m;E=B;F=0;G=0}TXb(n,e);B=xZb(n,855500)|0;m=f[l>>2]|0;Dg[f[(f[B>>2]|0)+32>>2]&127](B,m,m+E|0,D)|0;if(!E)H=0;else H=(b[f[l>>2]>>0]|0)==45;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[s+(l<<2)>>2]=0;l=l+1|0}f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[t+(l<<2)>>2]=0;l=l+1|0}f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[v+(l<<2)>>2]=0;l=l+1|0}e2b(d,H,n,o,q,r,s,t,v,w);d=f[w>>2]|0;if((E|0)>(d|0)){w=b[v+11>>0]|0;l=b[t+11>>0]|0;I=1;J=(w<<24>>24<0?f[v+4>>2]|0:w&255)+(E-d<<1)|0;K=l<<24>>24<0?f[t+4>>2]|0:l&255}else{l=b[v+11>>0]|0;w=b[t+11>>0]|0;I=2;J=w<<24>>24<0?f[t+4>>2]|0:w&255;K=l<<24>>24<0?f[v+4>>2]|0:l&255}l=K+d+J+I|0;if(l>>>0>100){I=OSb(l)|0;if(!I)Q5b();else{L=I;M=I}}else{L=x;M=0}f2b(L,y,z,f[e+4>>2]|0,D,D+E|0,B,H,o,b[q>>0]|0,b[r>>0]|0,s,t,v,d);f[A>>2]=f[c>>2];c=f[y>>2]|0;y=f[z>>2]|0;f[i>>2]=f[A>>2];A=uP(i,L,c,y,e,g)|0;if(M|0)PSb(M);Z5b(v);Z5b(t);Z5b(s);yZb(n);if(F|0)PSb(F);if(G|0)PSb(G);u=a;return A|0}function d2b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;a=u;u=u+176|0;i=a+56|0;j=a+52|0;k=a+164|0;l=a+161|0;m=a+160|0;n=a+40|0;o=a+28|0;p=a+16|0;q=a+12|0;r=a+60|0;s=a+8|0;t=a+4|0;v=a;TXb(j,e);w=xZb(j,855500)|0;x=h+11|0;y=b[x>>0]|0;z=y<<24>>24<0;A=h+4|0;if(!((z?f[A>>2]|0:y&255)|0))B=0;else{y=b[(z?f[h>>2]|0:h)>>0]|0;B=y<<24>>24==(Uh[f[(f[w>>2]|0)+28>>2]&1023](w,45)|0)<<24>>24};f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[n+(y<<2)>>2]=0;y=y+1|0}f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[p+(y<<2)>>2]=0;y=y+1|0}e2b(d,B,j,k,l,m,n,o,p,q);d=b[x>>0]|0;x=d<<24>>24<0;y=x?f[A>>2]|0:d&255;d=f[q>>2]|0;if((y|0)>(d|0)){q=b[p+11>>0]|0;A=b[o+11>>0]|0;C=1;D=(q<<24>>24<0?f[p+4>>2]|0:q&255)+(y-d<<1)|0;E=A<<24>>24<0?f[o+4>>2]|0:A&255}else{A=b[p+11>>0]|0;q=b[o+11>>0]|0;C=2;D=q<<24>>24<0?f[o+4>>2]|0:q&255;E=A<<24>>24<0?f[p+4>>2]|0:A&255}A=E+d+D+C|0;if(A>>>0>100){C=OSb(A)|0;if(!C)Q5b();else{F=C;G=C}}else{F=r;G=0}r=x?f[h>>2]|0:h;f2b(F,s,t,f[e+4>>2]|0,r,r+y|0,w,B,k,b[l>>0]|0,b[m>>0]|0,n,o,p,d);f[v>>2]=f[c>>2];c=f[s>>2]|0;s=f[t>>2]|0;f[i>>2]=f[v>>2];v=uP(i,F,c,s,e,g)|0;if(G|0)PSb(G);Z5b(p);Z5b(o);Z5b(n);yZb(j);u=a;return v|0}function e2b(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=xZb(d,857220)|0;if(c){zh[f[(f[a>>2]|0)+44>>2]&2047](n,a);p=f[n>>2]|0;b[e>>0]=p;b[e+1>>0]=p>>8;b[e+2>>0]=p>>16;b[e+3>>0]=p>>24;zh[f[(f[a>>2]|0)+32>>2]&2047](o,a);p=k+11|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;b[n>>0]=0;PXb(q,n);f[k+4>>2]=0;r=k}else{b[n>>0]=0;PXb(k,n);b[p>>0]=0;r=k}c6b(k,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}Z5b(o);s=a}else{zh[f[(f[a>>2]|0)+40>>2]&2047](n,a);r=f[n>>2]|0;b[e>>0]=r;b[e+1>>0]=r>>8;b[e+2>>0]=r>>16;b[e+3>>0]=r>>24;zh[f[(f[a>>2]|0)+28>>2]&2047](o,a);r=k+11|0;if((b[r>>0]|0)<0){p=f[k>>2]|0;b[n>>0]=0;PXb(p,n);f[k+4>>2]=0;t=k}else{b[n>>0]=0;PXb(k,n);b[r>>0]=0;t=k}c6b(k,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}Z5b(o);s=a}t=di[f[(f[a>>2]|0)+12>>2]&1023](a)|0;b[g>>0]=t;t=di[f[(f[a>>2]|0)+16>>2]&1023](a)|0;b[h>>0]=t;zh[f[(f[s>>2]|0)+20>>2]&2047](o,a);t=i+11|0;if((b[t>>0]|0)<0){r=f[i>>2]|0;b[n>>0]=0;PXb(r,n);f[i+4>>2]=0;v=i}else{b[n>>0]=0;PXb(i,n);b[t>>0]=0;v=i}c6b(i,0);f[v>>2]=f[o>>2];f[v+4>>2]=f[o+4>>2];f[v+8>>2]=f[o+8>>2];v=0;while(1){if((v|0)==3)break;f[o+(v<<2)>>2]=0;v=v+1|0}Z5b(o);zh[f[(f[s>>2]|0)+24>>2]&2047](o,a);s=j+11|0;if((b[s>>0]|0)<0){v=f[j>>2]|0;b[n>>0]=0;PXb(v,n);f[j+4>>2]=0;w=j}else{b[n>>0]=0;PXb(j,n);b[s>>0]=0;w=j}c6b(j,0);f[w>>2]=f[o>>2];f[w+4>>2]=f[o+4>>2];f[w+8>>2]=f[o+8>>2];w=0;while(1){if((w|0)==3)break;f[o+(w<<2)>>2]=0;w=w+1|0}Z5b(o);x=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0}else{a=xZb(d,857212)|0;if(c){zh[f[(f[a>>2]|0)+44>>2]&2047](n,a);c=f[n>>2]|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;zh[f[(f[a>>2]|0)+32>>2]&2047](o,a);c=k+11|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;b[n>>0]=0;PXb(d,n);f[k+4>>2]=0;y=k}else{b[n>>0]=0;PXb(k,n);b[c>>0]=0;y=k}c6b(k,0);f[y>>2]=f[o>>2];f[y+4>>2]=f[o+4>>2];f[y+8>>2]=f[o+8>>2];y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}Z5b(o);z=a}else{zh[f[(f[a>>2]|0)+40>>2]&2047](n,a);y=f[n>>2]|0;b[e>>0]=y;b[e+1>>0]=y>>8;b[e+2>>0]=y>>16;b[e+3>>0]=y>>24;zh[f[(f[a>>2]|0)+28>>2]&2047](o,a);y=k+11|0;if((b[y>>0]|0)<0){e=f[k>>2]|0;b[n>>0]=0;PXb(e,n);f[k+4>>2]=0;A=k}else{b[n>>0]=0;PXb(k,n);b[y>>0]=0;A=k}c6b(k,0);f[A>>2]=f[o>>2];f[A+4>>2]=f[o+4>>2];f[A+8>>2]=f[o+8>>2];A=0;while(1){if((A|0)==3)break;f[o+(A<<2)>>2]=0;A=A+1|0}Z5b(o);z=a}A=di[f[(f[a>>2]|0)+12>>2]&1023](a)|0;b[g>>0]=A;A=di[f[(f[a>>2]|0)+16>>2]&1023](a)|0;b[h>>0]=A;zh[f[(f[z>>2]|0)+20>>2]&2047](o,a);A=i+11|0;if((b[A>>0]|0)<0){h=f[i>>2]|0;b[n>>0]=0;PXb(h,n);f[i+4>>2]=0;B=i}else{b[n>>0]=0;PXb(i,n);b[A>>0]=0;B=i}c6b(i,0);f[B>>2]=f[o>>2];f[B+4>>2]=f[o+4>>2];f[B+8>>2]=f[o+8>>2];B=0;while(1){if((B|0)==3)break;f[o+(B<<2)>>2]=0;B=B+1|0}Z5b(o);zh[f[(f[z>>2]|0)+24>>2]&2047](o,a);z=j+11|0;if((b[z>>0]|0)<0){B=f[j>>2]|0;b[n>>0]=0;PXb(B,n);f[j+4>>2]=0;C=j}else{b[n>>0]=0;PXb(j,n);b[z>>0]=0;C=j}c6b(j,0);f[C>>2]=f[o>>2];f[C+4>>2]=f[o+4>>2];f[C+8>>2]=f[o+8>>2];C=0;while(1){if((C|0)==3)break;f[o+(C<<2)>>2]=0;C=C+1|0}Z5b(o);x=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0}f[l>>2]=x;u=m;return}function f2b(a,c,e,g,h,i,j,k,l,m,n,o,p,q,r){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;f[e>>2]=a;s=q+11|0;t=q+4|0;u=p+11|0;v=p+4|0;w=(g&512|0)==0;x=j+8|0;y=(r|0)>0;z=o+11|0;A=o+4|0;B=0;C=h;while(1){if((B|0)==4)break;a:do switch(b[l+B>>0]|0){case 0:{f[c>>2]=f[e>>2];D=C;break}case 1:{f[c>>2]=f[e>>2];h=Uh[f[(f[j>>2]|0)+28>>2]&1023](j,32)|0;E=f[e>>2]|0;f[e>>2]=E+1;b[E>>0]=h;D=C;break}case 3:{h=b[s>>0]|0;E=h<<24>>24<0;if(!((E?f[t>>2]|0:h&255)|0))D=C;else{h=b[(E?f[q>>2]|0:q)>>0]|0;E=f[e>>2]|0;f[e>>2]=E+1;b[E>>0]=h;D=C}break}case 2:{h=b[u>>0]|0;E=h<<24>>24<0;F=E?f[v>>2]|0:h&255;if(w|(F|0)==0)D=C;else{h=E?f[p>>2]|0:p;E=h+F|0;F=f[e>>2]|0;G=h;while(1){if((G|0)==(E|0))break;b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}f[e>>2]=F;D=C}break}case 4:{G=f[e>>2]|0;E=k?C+1|0:C;h=E;while(1){if(h>>>0>=i>>>0)break;H=b[h>>0]|0;if(H<<24>>24<=-1)break;if(!(d[(f[x>>2]|0)+(H<<24>>24<<1)>>1]&2048))break;h=h+1|0}if(y){F=r;H=h;while(1){I=(F|0)>0;if(!(H>>>0>E>>>0&I))break;J=H+-1|0;K=b[J>>0]|0;L=f[e>>2]|0;f[e>>2]=L+1;b[L>>0]=K;F=F+-1|0;H=J}if(I)M=Uh[f[(f[j>>2]|0)+28>>2]&1023](j,48)|0;else M=0;J=F;while(1){N=f[e>>2]|0;f[e>>2]=N+1;if((J|0)<=0)break;b[N>>0]=M;J=J+-1|0}b[N>>0]=m;O=H}else O=h;b:do if((O|0)==(E|0)){J=Uh[f[(f[j>>2]|0)+28>>2]&1023](j,48)|0;F=f[e>>2]|0;f[e>>2]=F+1;b[F>>0]=J}else{J=b[z>>0]|0;F=J<<24>>24<0;if(!((F?f[A>>2]|0:J&255)|0)){P=-1;Q=0;R=0;S=O}else{P=b[(F?f[o>>2]|0:o)>>0]|0;Q=0;R=0;S=O}while(1){if((S|0)==(E|0))break b;if((R|0)==(P|0)){F=f[e>>2]|0;f[e>>2]=F+1;b[F>>0]=n;F=Q+1|0;J=b[z>>0]|0;K=J<<24>>24<0;if(F>>>0<(K?f[A>>2]|0:J&255)>>>0){J=b[(K?f[o>>2]|0:o)+F>>0]|0;T=J<<24>>24==127?-1:J<<24>>24;U=F;V=0}else{T=R;U=F;V=0}}else{T=P;U=Q;V=R}F=S+-1|0;J=b[F>>0]|0;K=f[e>>2]|0;f[e>>2]=K+1;b[K>>0]=J;P=T;Q=U;R=V+1|0;S=F}}while(0);h=f[e>>2]|0;if((G|0)==(h|0))D=E;else{H=h;h=G;while(1){F=H+-1|0;if(h>>>0>=F>>>0){D=E;break a}J=b[h>>0]|0;b[h>>0]=b[F>>0]|0;b[F>>0]=J;H=F;h=h+1|0}}break}default:D=C}while(0);B=B+1|0;C=D}D=b[s>>0]|0;s=D<<24>>24<0;C=s?f[t>>2]|0:D&255;if(C>>>0>1){D=s?f[q>>2]|0:q;q=D+C|0;C=f[e>>2]|0;s=D;while(1){D=s+1|0;if((D|0)==(q|0))break;b[C>>0]=b[D>>0]|0;C=C+1|0;s=D}f[e>>2]=C}switch((g&176)<<24>>24){case 32:{f[c>>2]=f[e>>2];break}case 16:break;default:f[c>>2]=a}return}function g2b(a){a=a|0;dZb(a);return}function h2b(a){a=a|0;dZb(a);O5b(a);return}function i2b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;a=u;u=u+1008|0;i=a+8|0;j=a;k=a+896|0;l=a+888|0;m=a+488|0;n=a+480|0;o=a+892|0;q=a+476|0;r=a+472|0;s=a+460|0;t=a+448|0;v=a+436|0;w=a+432|0;x=a+32|0;y=a+24|0;z=a+16|0;A=a+20|0;f[l>>2]=k;p[i>>3]=h;B=GUb(k,100,487700,i)|0;if(B>>>0>99){k=AZb()|0;p[j>>3]=h;C=S_b(l,k,487700,j)|0;j=f[l>>2]|0;if(!j)Q5b();k=OSb(C<<2)|0;if(!k)Q5b();else{D=k;E=C;F=k;G=j}}else{D=m;E=B;F=0;G=0}TXb(n,e);B=xZb(n,855532)|0;m=f[l>>2]|0;Dg[f[(f[B>>2]|0)+48>>2]&127](B,m,m+E|0,D)|0;if(!E)H=0;else H=(b[f[l>>2]>>0]|0)==45;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[s+(l<<2)>>2]=0;l=l+1|0}f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[t+(l<<2)>>2]=0;l=l+1|0}f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;l=0;while(1){if((l|0)==3)break;f[v+(l<<2)>>2]=0;l=l+1|0}k2b(d,H,n,o,q,r,s,t,v,w);d=f[w>>2]|0;if((E|0)>(d|0)){w=b[v+8+3>>0]|0;l=b[t+8+3>>0]|0;I=1;J=(w<<24>>24<0?f[v+4>>2]|0:w&255)+(E-d<<1)|0;K=l<<24>>24<0?f[t+4>>2]|0:l&255}else{l=b[v+8+3>>0]|0;w=b[t+8+3>>0]|0;I=2;J=w<<24>>24<0?f[t+4>>2]|0:w&255;K=l<<24>>24<0?f[v+4>>2]|0:l&255}l=K+d+J+I|0;if(l>>>0>100){I=OSb(l<<2)|0;if(!I)Q5b();else{L=I;M=I}}else{L=x;M=0}l2b(L,y,z,f[e+4>>2]|0,D,D+(E<<2)|0,B,H,o,f[q>>2]|0,f[r>>2]|0,s,t,v,d);f[A>>2]=f[c>>2];c=f[y>>2]|0;y=f[z>>2]|0;f[i>>2]=f[A>>2];A=e$b(i,L,c,y,e,g)|0;if(M|0)PSb(M);v6b(v);v6b(t);Z5b(s);yZb(n);if(F|0)PSb(F);if(G|0)PSb(G);u=a;return A|0}function j2b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;a=u;u=u+480|0;i=a+468|0;j=a+464|0;k=a+472|0;l=a+460|0;m=a+456|0;n=a+444|0;o=a+432|0;p=a+420|0;q=a+416|0;r=a+16|0;s=a+8|0;t=a+4|0;v=a;TXb(j,e);w=xZb(j,855532)|0;x=h+8+3|0;y=b[x>>0]|0;z=y<<24>>24<0;A=h+4|0;if(!((z?f[A>>2]|0:y&255)|0))B=0;else{y=f[(z?f[h>>2]|0:h)>>2]|0;B=(y|0)==(Uh[f[(f[w>>2]|0)+44>>2]&1023](w,45)|0)};f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[n+(y<<2)>>2]=0;y=y+1|0}f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[o+(y<<2)>>2]=0;y=y+1|0}f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;y=0;while(1){if((y|0)==3)break;f[p+(y<<2)>>2]=0;y=y+1|0}k2b(d,B,j,k,l,m,n,o,p,q);d=b[x>>0]|0;x=d<<24>>24<0;y=x?f[A>>2]|0:d&255;d=f[q>>2]|0;if((y|0)>(d|0)){q=b[p+8+3>>0]|0;A=b[o+8+3>>0]|0;C=1;D=(q<<24>>24<0?f[p+4>>2]|0:q&255)+(y-d<<1)|0;E=A<<24>>24<0?f[o+4>>2]|0:A&255}else{A=b[p+8+3>>0]|0;q=b[o+8+3>>0]|0;C=2;D=q<<24>>24<0?f[o+4>>2]|0:q&255;E=A<<24>>24<0?f[p+4>>2]|0:A&255}A=E+d+D+C|0;if(A>>>0>100){C=OSb(A<<2)|0;if(!C)Q5b();else{F=C;G=C}}else{F=r;G=0}r=x?f[h>>2]|0:h;l2b(F,s,t,f[e+4>>2]|0,r,r+(y<<2)|0,w,B,k,f[l>>2]|0,f[m>>2]|0,n,o,p,d);f[v>>2]=f[c>>2];c=f[s>>2]|0;s=f[t>>2]|0;f[i>>2]=f[v>>2];v=e$b(i,F,c,s,e,g)|0;if(G|0)PSb(G);v6b(p);v6b(o);Z5b(n);yZb(j);u=a;return v|0}function k2b(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=u;u=u+16|0;n=m+12|0;o=m;if(a){a=xZb(d,857236)|0;if(c){zh[f[(f[a>>2]|0)+44>>2]&2047](n,a);p=f[n>>2]|0;b[e>>0]=p;b[e+1>>0]=p>>8;b[e+2>>0]=p>>16;b[e+3>>0]=p>>24;zh[f[(f[a>>2]|0)+32>>2]&2047](o,a);p=k+8+3|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;f[n>>2]=0;jZb(q,n);f[k+4>>2]=0}else{f[n>>2]=0;jZb(k,n);b[p>>0]=0}z6b(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}v6b(o)}else{zh[f[(f[a>>2]|0)+40>>2]&2047](n,a);p=f[n>>2]|0;b[e>>0]=p;b[e+1>>0]=p>>8;b[e+2>>0]=p>>16;b[e+3>>0]=p>>24;zh[f[(f[a>>2]|0)+28>>2]&2047](o,a);p=k+8+3|0;if((b[p>>0]|0)<0){q=f[k>>2]|0;f[n>>2]=0;jZb(q,n);f[k+4>>2]=0}else{f[n>>2]=0;jZb(k,n);b[p>>0]=0}z6b(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];p=0;while(1){if((p|0)==3)break;f[o+(p<<2)>>2]=0;p=p+1|0}v6b(o)}p=di[f[(f[a>>2]|0)+12>>2]&1023](a)|0;f[g>>2]=p;p=di[f[(f[a>>2]|0)+16>>2]&1023](a)|0;f[h>>2]=p;zh[f[(f[a>>2]|0)+20>>2]&2047](o,a);p=i+11|0;if((b[p>>0]|0)<0){q=f[i>>2]|0;b[n>>0]=0;PXb(q,n);f[i+4>>2]=0;r=i}else{b[n>>0]=0;PXb(i,n);b[p>>0]=0;r=i}c6b(i,0);f[r>>2]=f[o>>2];f[r+4>>2]=f[o+4>>2];f[r+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}Z5b(o);zh[f[(f[a>>2]|0)+24>>2]&2047](o,a);r=j+8+3|0;if((b[r>>0]|0)<0){p=f[j>>2]|0;f[n>>2]=0;jZb(p,n);f[j+4>>2]=0}else{f[n>>2]=0;jZb(j,n);b[r>>0]=0}z6b(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];r=0;while(1){if((r|0)==3)break;f[o+(r<<2)>>2]=0;r=r+1|0}v6b(o);s=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0}else{a=xZb(d,857228)|0;if(c){zh[f[(f[a>>2]|0)+44>>2]&2047](n,a);c=f[n>>2]|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;zh[f[(f[a>>2]|0)+32>>2]&2047](o,a);c=k+8+3|0;if((b[c>>0]|0)<0){d=f[k>>2]|0;f[n>>2]=0;jZb(d,n);f[k+4>>2]=0}else{f[n>>2]=0;jZb(k,n);b[c>>0]=0}z6b(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];c=0;while(1){if((c|0)==3)break;f[o+(c<<2)>>2]=0;c=c+1|0}v6b(o)}else{zh[f[(f[a>>2]|0)+40>>2]&2047](n,a);c=f[n>>2]|0;b[e>>0]=c;b[e+1>>0]=c>>8;b[e+2>>0]=c>>16;b[e+3>>0]=c>>24;zh[f[(f[a>>2]|0)+28>>2]&2047](o,a);c=k+8+3|0;if((b[c>>0]|0)<0){e=f[k>>2]|0;f[n>>2]=0;jZb(e,n);f[k+4>>2]=0}else{f[n>>2]=0;jZb(k,n);b[c>>0]=0}z6b(k,0);f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2];f[k+8>>2]=f[o+8>>2];k=0;while(1){if((k|0)==3)break;f[o+(k<<2)>>2]=0;k=k+1|0}v6b(o)}k=di[f[(f[a>>2]|0)+12>>2]&1023](a)|0;f[g>>2]=k;k=di[f[(f[a>>2]|0)+16>>2]&1023](a)|0;f[h>>2]=k;zh[f[(f[a>>2]|0)+20>>2]&2047](o,a);k=i+11|0;if((b[k>>0]|0)<0){h=f[i>>2]|0;b[n>>0]=0;PXb(h,n);f[i+4>>2]=0;t=i}else{b[n>>0]=0;PXb(i,n);b[k>>0]=0;t=i}c6b(i,0);f[t>>2]=f[o>>2];f[t+4>>2]=f[o+4>>2];f[t+8>>2]=f[o+8>>2];t=0;while(1){if((t|0)==3)break;f[o+(t<<2)>>2]=0;t=t+1|0}Z5b(o);zh[f[(f[a>>2]|0)+24>>2]&2047](o,a);t=j+8+3|0;if((b[t>>0]|0)<0){i=f[j>>2]|0;f[n>>2]=0;jZb(i,n);f[j+4>>2]=0}else{f[n>>2]=0;jZb(j,n);b[t>>0]=0}z6b(j,0);f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[j+8>>2]=f[o+8>>2];j=0;while(1){if((j|0)==3)break;f[o+(j<<2)>>2]=0;j=j+1|0}v6b(o);s=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0}f[l>>2]=s;u=m;return}function l2b(a,c,d,e,g,h,i,j,k,l,m,n,o,p,q){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;f[d>>2]=a;r=p+8+3|0;s=p+4|0;t=o+8+3|0;u=o+4|0;v=(e&512|0)==0;w=(q|0)>0;x=n+11|0;y=n+4|0;z=0;A=g;while(1){if((z|0)==4)break;a:do switch(b[k+z>>0]|0){case 0:{f[c>>2]=f[d>>2];B=A;break}case 1:{f[c>>2]=f[d>>2];g=Uh[f[(f[i>>2]|0)+44>>2]&1023](i,32)|0;C=f[d>>2]|0;f[d>>2]=C+4;f[C>>2]=g;B=A;break}case 3:{g=b[r>>0]|0;C=g<<24>>24<0;if(!((C?f[s>>2]|0:g&255)|0))B=A;else{g=f[(C?f[p>>2]|0:p)>>2]|0;C=f[d>>2]|0;f[d>>2]=C+4;f[C>>2]=g;B=A}break}case 2:{g=b[t>>0]|0;C=g<<24>>24<0;D=C?f[u>>2]|0:g&255;if(v|(D|0)==0)B=A;else{g=C?f[o>>2]|0:o;C=g+(D<<2)|0;E=f[d>>2]|0;F=E;G=g;while(1){if((G|0)==(C|0))break;f[F>>2]=f[G>>2];F=F+4|0;G=G+4|0}f[d>>2]=E+(D<<2);B=A}break}case 4:{G=f[d>>2]|0;F=j?A+4|0:A;C=F;while(1){if(C>>>0>=h>>>0)break;if(!(li[f[(f[i>>2]|0)+12>>2]&511](i,2048,f[C>>2]|0)|0))break;C=C+4|0}if(w){D=q;E=C;while(1){H=(D|0)>0;if(!(E>>>0>F>>>0&H))break;g=E+-4|0;I=f[g>>2]|0;J=f[d>>2]|0;f[d>>2]=J+4;f[J>>2]=I;D=D+-1|0;E=g}if(H)K=Uh[f[(f[i>>2]|0)+44>>2]&1023](i,48)|0;else K=0;g=D;I=f[d>>2]|0;while(1){L=I+4|0;if((g|0)<=0)break;f[I>>2]=K;g=g+-1|0;I=L}f[d>>2]=L;f[I>>2]=l;M=E}else M=C;if((M|0)==(F|0)){g=Uh[f[(f[i>>2]|0)+44>>2]&1023](i,48)|0;D=f[d>>2]|0;J=D+4|0;f[d>>2]=J;f[D>>2]=g;N=J}else{J=b[x>>0]|0;g=J<<24>>24<0;D=J&255;if(!((g?f[y>>2]|0:D)|0)){O=-1;P=0;Q=0;R=M}else{O=b[(g?f[n>>2]|0:n)>>0]|0;P=0;Q=0;R=M}while(1){if((R|0)==(F|0))break;J=f[d>>2]|0;if((Q|0)==(O|0)){S=J+4|0;f[d>>2]=S;f[J>>2]=m;T=P+1|0;if(T>>>0<(g?f[y>>2]|0:D)>>>0){U=b[(g?f[n>>2]|0:n)+T>>0]|0;V=U<<24>>24==127?-1:U<<24>>24;W=T;X=0;Y=S}else{V=Q;W=T;X=0;Y=S}}else{V=O;W=P;X=Q;Y=J}J=R+-4|0;S=f[J>>2]|0;f[d>>2]=Y+4;f[Y>>2]=S;O=V;P=W;Q=X+1|0;R=J}N=f[d>>2]|0}if((G|0)==(N|0))B=F;else{g=N;D=G;while(1){C=g+-4|0;if(D>>>0>=C>>>0){B=F;break a}E=f[D>>2]|0;f[D>>2]=f[C>>2];f[C>>2]=E;g=C;D=D+4|0}}break}default:B=A}while(0);z=z+1|0;A=B}B=b[r>>0]|0;r=B<<24>>24<0;A=r?f[s>>2]|0:B&255;if(A>>>0>1){B=r?f[p>>2]|0:p;p=B+4|0;r=B+(A<<2)|0;A=f[d>>2]|0;B=r-p|0;s=A;z=p;while(1){if((z|0)==(r|0))break;f[s>>2]=f[z>>2];s=s+4|0;z=z+4|0}f[d>>2]=A+(B>>>2<<2)}switch((e&176)<<24>>24){case 32:{f[c>>2]=f[d>>2];break}case 16:break;default:f[c>>2]=a}return}function m2b(a){a=a|0;dZb(a);return}function n2b(a){a=a|0;dZb(a);O5b(a);return}function o2b(a,c,d){a=a|0;c=c|0;d=d|0;d=nVb((b[c+11>>0]|0)<0?f[c>>2]|0:c,1)|0;return d>>>((d|0)!=(-1|0)&1)|0}function p2b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;i=c;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;j=0;while(1){if((j|0)==3)break;f[i+(j<<2)>>2]=0;j=j+1|0}j=b[h+11>>0]|0;k=j<<24>>24<0;l=k?f[h>>2]|0:h;m=l+(k?f[h+4>>2]|0:j&255)|0;j=l;while(1){if(j>>>0>=m>>>0)break;l6b(i,b[j>>0]|0);j=j+1|0}j=(b[i+11>>0]|0)<0?f[i>>2]|0:i;m=uVb((d|0)==-1?-1:d<<1,e,g,j)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[a+(g<<2)>>2]=0;g=g+1|0}g=j+(kUb(m)|0)|0;m=j;while(1){if(m>>>0>=g>>>0)break;l6b(a,b[m>>0]|0);m=m+1|0}Z5b(i);u=c;return}function q2b(a,b){a=a|0;b=b|0;return}function r2b(a){a=a|0;dZb(a);return}function s2b(a){a=a|0;dZb(a);O5b(a);return}function t2b(a,c,d){a=a|0;c=c|0;d=d|0;d=nVb((b[c+11>>0]|0)<0?f[c>>2]|0:c,1)|0;return d>>>((d|0)!=(-1|0)&1)|0}function u2b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+176|0;i=c+168|0;j=c+40|0;k=c+36|0;l=c+32|0;m=c;n=c+24|0;o=c+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;p=0;while(1){if((p|0)==3)break;f[m+(p<<2)>>2]=0;p=p+1|0}f[n+4>>2]=0;f[n>>2]=148776;p=b[h+8+3>>0]|0;q=p<<24>>24<0;r=q?f[h>>2]|0:h;s=r+((q?f[h+4>>2]|0:p&255)<<2)|0;p=j+32|0;h=r;r=0;while(1){if(!((r|0)!=2&h>>>0<s>>>0))break;f[l>>2]=h;q=Di[f[(f[n>>2]|0)+12>>2]&15](n,i,h,s,l,j,p,k)|0;if((q|0)==2?1:(f[l>>2]|0)==(h|0)){t=7;break}else v=j;while(1){if(v>>>0>=(f[k>>2]|0)>>>0)break;l6b(m,b[v>>0]|0);v=v+1|0}h=f[l>>2]|0;r=q}if((t|0)==7)S0b(0);dZb(n);n=(b[m+11>>0]|0)<0?f[m>>2]|0:m;r=uVb((d|0)==-1?-1:d<<1,e,g,n)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=0;while(1){if((g|0)==3)break;f[a+(g<<2)>>2]=0;g=g+1|0}f[o+4>>2]=0;f[o>>2]=148824;g=n+(kUb(r)|0)|0;r=g;e=j+128|0;d=n;n=0;while(1){if(!((n|0)!=2&d>>>0<g>>>0)){t=21;break}f[l>>2]=d;h=Di[f[(f[o>>2]|0)+16>>2]&15](o,i,d,(r-d|0)>32?d+32|0:g,l,j,e,k)|0;if((h|0)==2?1:(f[l>>2]|0)==(d|0)){t=17;break}else w=j;while(1){if(w>>>0>=(f[k>>2]|0)>>>0)break;D6b(a,f[w>>2]|0);w=w+4|0}d=f[l>>2]|0;n=h}if((t|0)==17)S0b(0);else if((t|0)==21){dZb(o);Z5b(m);u=c;return}}function v2b(a,b){a=a|0;b=b|0;return}function w2b(a){a=a|0;dZb(a);O5b(a);return}function x2b(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=G2b(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function y2b(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=F2b(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function z2b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f[e>>2]=c;return 3}function A2b(a){a=a|0;return 0}function B2b(a){a=a|0;return 0}function C2b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return E2b(c,d,e,1114111,0)|0}function D2b(a){a=a|0;return 4}function E2b(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=c;i=a;if(((g-i|0)>2&(f&4|0)!=0?(b[a>>0]|0)==-17:0)?(b[a+1>>0]|0)==-69:0){j=0;k=(b[a+2>>0]|0)==-65?a+3|0:a}else{j=0;k=a}a:while(1){if(!(j>>>0<d>>>0&k>>>0<c>>>0)){l=30;break}a=b[k>>0]|0;f=a&255;m=k+1|0;do if(a<<24>>24>-1)if(f>>>0>e>>>0){l=30;break a}else n=m;else{if((a&255)<194){l=30;break a}o=k+2|0;p=k;q=g-p|0;if((a&255)<224){if((q|0)<2){l=30;break a}r=h[m>>0]|0;if((r&192|0)!=128){l=30;break a}if((r&63|f<<6&1984)>>>0>e>>>0){l=30;break a}else{n=o;break}}r=k+3|0;if((a&255)<240){if((q|0)<3){l=30;break a}s=b[o>>0]|0;t=h[m>>0]|0;u=t&224;switch(a<<24>>24){case -32:{if((u|0)!=160){v=p;break a}break}case -19:{if((u|0)!=128){v=p;break a}break}default:if((t&192|0)!=128){v=p;break a}}u=s&255;if((u&192|0)!=128){l=30;break a}if((t<<6&4032|f<<12&61440|u&63)>>>0>e>>>0){l=30;break a}else{n=r;break}}if((q|0)<4|(a&255)>244){l=30;break a}q=b[m>>0]|0;u=b[o>>0]|0;o=b[r>>0]|0;r=q&255;switch(a<<24>>24){case -16:{if((q+112&255)>=48){v=p;break a}break}case -12:{if((r&240|0)!=128){v=p;break a}break}default:if((r&192|0)!=128){v=p;break a}}p=u&255;if((p&192|0)!=128){l=30;break a}u=o&255;if((u&192|0)!=128){l=30;break a}if((r<<12&258048|f<<18&1835008|p<<6&4032|u&63)>>>0>e>>>0){l=30;break a}else n=k+4|0}while(0);j=j+1|0;k=n}if((l|0)==30)v=k;return v-i|0}function F2b(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f[d>>2]=a;f[i>>2]=e;e=c;if((((k&4|0?(k=f[d>>2]|0,(e-k|0)>2):0)?(b[k>>0]|0)==-17:0)?(b[k+1>>0]|0)==-69:0)?(b[k+2>>0]|0)==-65:0)f[d>>2]=k+3;a:while(1){k=f[d>>2]|0;if(k>>>0>=c>>>0){l=0;break}a=f[i>>2]|0;if(a>>>0>=g>>>0){l=1;break}m=b[k>>0]|0;n=m&255;o=k+1|0;do if(m<<24>>24>-1){if(n>>>0>j>>>0){l=2;break a}f[a>>2]=n;p=o}else{if((m&255)<194){l=2;break a}q=k+2|0;r=e-k|0;if((m&255)<224){if((r|0)<2){l=1;break a}s=h[o>>0]|0;if((s&192|0)!=128){l=2;break a}t=s&63|n<<6&1984;if(t>>>0>j>>>0){l=2;break a}f[a>>2]=t;p=q;break}t=k+3|0;if((m&255)<240){if((r|0)<3){l=1;break a}s=b[q>>0]|0;u=h[o>>0]|0;v=u&224;switch(m<<24>>24){case -32:{if((v|0)!=160){l=2;break a}break}case -19:{if((v|0)!=128){l=2;break a}break}default:if((u&192|0)!=128){l=2;break a}}v=s&255;if((v&192|0)!=128){l=2;break a}s=u<<6&4032|n<<12&61440|v&63;if(s>>>0>j>>>0){l=2;break a}f[a>>2]=s;p=t;break}if((m&255)>=245){l=2;break a}if((r|0)<4){l=1;break a}r=b[o>>0]|0;s=b[q>>0]|0;q=b[t>>0]|0;t=r&255;switch(m<<24>>24){case -16:{if((r+112&255)>=48){l=2;break a}break}case -12:{if((t&240|0)!=128){l=2;break a}break}default:if((t&192|0)!=128){l=2;break a}}r=s&255;if((r&192|0)!=128){l=2;break a}s=q&255;if((s&192|0)!=128){l=2;break a}q=t<<12&258048|n<<18&1835008|r<<6&4032|s&63;if(q>>>0>j>>>0){l=2;break a}f[a>>2]=q;p=k+4|0}while(0);f[d>>2]=p;f[i>>2]=(f[i>>2]|0)+4}return l|0}function G2b(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;f[d>>2]=a;f[h>>2]=e;a=g;if(j&2)if((a-e|0)<3)k=1;else{f[h>>2]=e+1;b[e>>0]=-17;e=f[h>>2]|0;f[h>>2]=e+1;b[e>>0]=-69;e=f[h>>2]|0;f[h>>2]=e+1;b[e>>0]=-65;l=4}else l=4;a:do if((l|0)==4){e=f[d>>2]|0;while(1){if(e>>>0>=c>>>0){k=0;break a}j=f[e>>2]|0;if(j>>>0>i>>>0|(j&-2048|0)==55296){k=2;break a}do if(j>>>0>=128){g=(j&63|128)&255;if(j>>>0<2048){m=f[h>>2]|0;if((a-m|0)<2){k=1;break a}f[h>>2]=m+1;b[m>>0]=j>>>6|192;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=g;break}m=f[h>>2]|0;n=a-m|0;o=m+1|0;p=(j>>>6&63|128)&255;if(j>>>0<65536){if((n|0)<3){k=1;break a}f[h>>2]=o;b[m>>0]=j>>>12|224;q=f[h>>2]|0;f[h>>2]=q+1;b[q>>0]=p;q=f[h>>2]|0;f[h>>2]=q+1;b[q>>0]=g;break}else{if((n|0)<4){k=1;break a}f[h>>2]=o;b[m>>0]=j>>>18|240;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=j>>>12&63|128;m=f[h>>2]|0;f[h>>2]=m+1;b[m>>0]=p;p=f[h>>2]|0;f[h>>2]=p+1;b[p>>0]=g;break}}else{g=f[h>>2]|0;if((a-g|0)<1){k=1;break a}f[h>>2]=g+1;b[g>>0]=j}while(0);j=(f[d>>2]|0)+4|0;f[d>>2]=j;e=j}}while(0);return k|0}function H2b(a){a=a|0;dZb(a);O5b(a);return}function I2b(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;f[e>>2]=c;f[i>>2]=g;return 3}function J2b(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;f[e>>2]=c;f[i>>2]=g;return 3}function K2b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f[e>>2]=c;return 3}function L2b(a){a=a|0;return 1}function M2b(a){a=a|0;return 1}function N2b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;return (b>>>0<e>>>0?b:e)|0}function O2b(a){a=a|0;return 1}function P2b(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=u;u=u+16|0;l=k;m=k+8|0;n=d;while(1){if((n|0)==(e|0)){o=e;break}if(!(f[n>>2]|0)){o=n;break}n=n+4|0}f[j>>2]=h;f[g>>2]=d;n=i;p=a+8|0;a=d;d=h;h=o;a:while(1){if((d|0)==(i|0)|(a|0)==(e|0)){q=a;r=35;break}o=c;s=f[o+4>>2]|0;t=l;f[t>>2]=f[o>>2];f[t+4>>2]=s;s=oVb(f[p>>2]|0)|0;t=iWb(d,g,h-a>>2,n-d|0,c)|0;if(s|0)oVb(s)|0;switch(t|0){case -1:{r=10;break a;break}case 0:{v=1;r=32;break a;break}default:{}}s=(f[j>>2]|0)+t|0;f[j>>2]=s;if((s|0)==(i|0)){r=33;break}if((h|0)==(e|0)){w=e;x=s;y=f[g>>2]|0}else{s=oVb(f[p>>2]|0)|0;t=ETb(m,0,c)|0;if(s|0)oVb(s)|0;if((t|0)==-1){z=2;r=31;break}if(t>>>0>(n-(f[j>>2]|0)|0)>>>0){z=1;r=31;break}else{A=m;B=t}while(1){if(!B)break;t=b[A>>0]|0;s=f[j>>2]|0;f[j>>2]=s+1;b[s>>0]=t;A=A+1|0;B=B+-1|0}t=(f[g>>2]|0)+4|0;f[g>>2]=t;s=t;while(1){if((s|0)==(e|0)){C=e;break}if(!(f[s>>2]|0)){C=s;break}s=s+4|0}w=C;x=f[j>>2]|0;y=t}a=y;d=x;h=w}if((r|0)==10){f[j>>2]=d;w=a;a=d;while(1){if((w|0)==(f[g>>2]|0))break;d=f[w>>2]|0;h=oVb(f[p>>2]|0)|0;x=ETb(a,d,l)|0;if(h|0)oVb(h)|0;if((x|0)==-1)break;h=(f[j>>2]|0)+x|0;f[j>>2]=h;w=w+4|0;a=h}f[g>>2]=w;v=2;r=32}else if((r|0)==31){v=z;r=32}else if((r|0)==33){q=f[g>>2]|0;r=35}if((r|0)==32)D=v;else if((r|0)==35)D=(q|0)!=(e|0)&1;u=k;return D|0}function Q2b(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;k=u;u=u+16|0;l=k;m=d;while(1){if((m|0)==(e|0)){n=e;break}if(!(b[m>>0]|0)){n=m;break}m=m+1|0}f[j>>2]=h;f[g>>2]=d;m=i;o=a+8|0;a=d;d=h;h=n;while(1){if((d|0)==(i|0)|(a|0)==(e|0)){p=a;q=32;break}n=c;r=f[n+4>>2]|0;s=l;f[s>>2]=f[n>>2];f[s+4>>2]=r;t=h;r=oVb(f[o>>2]|0)|0;s=$Ub(d,g,t-a|0,m-d>>2,c)|0;if(r|0)oVb(r)|0;if((s|0)==-1){v=a;w=d;q=10;break}r=(f[j>>2]|0)+(s<<2)|0;f[j>>2]=r;if((r|0)==(i|0)){q=29;break}s=f[g>>2]|0;if((h|0)==(e|0)){x=e;y=r;z=s}else{n=oVb(f[o>>2]|0)|0;A=VTb(r,s,1,c)|0;if(n|0)oVb(n)|0;if(A|0){B=2;q=28;break}f[j>>2]=(f[j>>2]|0)+4;A=(f[g>>2]|0)+1|0;f[g>>2]=A;n=A;while(1){if((n|0)==(e|0)){C=e;break}if(!(b[n>>0]|0)){C=n;break}n=n+1|0}x=C;y=f[j>>2]|0;z=A}a=z;d=y;h=x}do if((q|0)==10){a:while(1){q=0;f[j>>2]=w;if((v|0)==(f[g>>2]|0)){q=18;break}x=oVb(f[o>>2]|0)|0;h=VTb(w,v,t-v|0,l)|0;if(x|0)oVb(x)|0;switch(h|0){case -1:{q=15;break a;break}case -2:{q=16;break a;break}case 0:{D=1;break}default:D=h}v=v+D|0;w=(f[j>>2]|0)+4|0;q=10}if((q|0)==15){f[g>>2]=v;B=2;q=28;break}else if((q|0)==16){f[g>>2]=v;B=1;q=28;break}else if((q|0)==18){f[g>>2]=v;B=(v|0)!=(e|0)&1;q=28;break}}else if((q|0)==29){p=f[g>>2]|0;q=32}while(0);if((q|0)==28)E=B;else if((q|0)==32)E=(p|0)!=(e|0)&1;u=k;return E|0}function R2b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+16|0;i=h;f[g>>2]=d;d=oVb(f[a+8>>2]|0)|0;a=ETb(i,0,c)|0;if(d|0)oVb(d)|0;a:do switch(a|0){case 0:case -1:{j=2;break}default:{d=a+-1|0;if(d>>>0>(e-(f[g>>2]|0)|0)>>>0)j=1;else{c=i;k=d;while(1){if(!k){j=0;break a}d=b[c>>0]|0;l=f[g>>2]|0;f[g>>2]=l+1;b[l>>0]=d;c=c+1|0;k=k+-1|0}}}}while(0);u=h;return j|0}function S2b(a){a=a|0;var b=0,c=0,d=0;b=a+8|0;a=oVb(f[b>>2]|0)|0;c=FUb(0,0,4)|0;if(a|0)oVb(a)|0;if(!c){c=f[b>>2]|0;if(!c)d=1;else{b=oVb(c)|0;c=qWb()|0;if(b|0)oVb(b)|0;return (c|0)==1|0}}else d=-1;return d|0}function T2b(a){a=a|0;return 0}function U2b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=d;h=a+8|0;a=0;i=0;j=c;a:while(1){if((j|0)==(d|0)|a>>>0>=e>>>0)break;c=oVb(f[h>>2]|0)|0;k=hWb(j,g-j|0,b)|0;if(c|0)oVb(c)|0;switch(k|0){case -2:case -1:{break a;break}case 0:{l=1;break}default:l=k}a=a+1|0;i=l+i|0;j=j+l|0}return i|0}function V2b(a){a=a|0;var b=0,c=0;b=f[a+8>>2]|0;if(b){a=oVb(b)|0;b=qWb()|0;if(!a)c=b;else{oVb(a)|0;c=b}}else c=1;return c|0}function W2b(a){a=a|0;var b=0,c=0;f[a>>2]=148872;b=a+8|0;c=f[b>>2]|0;if((c|0)!=(AZb()|0))lVb(f[b>>2]|0);dZb(a);return}function X2b(a){a=a|0;W2b(a);O5b(a);return}function Y2b(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=f3b(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function Z2b(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;b=u;u=u+16|0;a=b+4|0;j=b;f[a>>2]=c;f[j>>2]=g;k=e3b(c,d,a,g,h,j,1114111,0)|0;f[e>>2]=f[a>>2];f[i>>2]=f[j>>2];u=b;return k|0}function _2b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f[e>>2]=c;return 3}function $2b(a){a=a|0;return 0}function a3b(a){a=a|0;return 0}function b3b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return d3b(c,d,e,1114111,0)|0}function c3b(a){a=a|0;return 4}function d3b(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=c;i=a;if(((g-i|0)>2&(f&4|0)!=0?(b[a>>0]|0)==-17:0)?(b[a+1>>0]|0)==-69:0){j=0;k=(b[a+2>>0]|0)==-65?a+3|0:a}else{j=0;k=a}a:while(1){if(!(j>>>0<d>>>0&k>>>0<c>>>0)){l=31;break}a=b[k>>0]|0;f=a&255;if(f>>>0>e>>>0){l=31;break}m=k+1|0;do if(a<<24>>24<=-1){if((a&255)<194){l=31;break a}n=k+2|0;o=k;p=g-o|0;if((a&255)<224){if((p|0)<2){l=31;break a}q=h[m>>0]|0;if((q&192|0)!=128){l=31;break a}if((q&63|f<<6&1984)>>>0>e>>>0){l=31;break a}else{r=j;s=n;break}}q=k+3|0;if((a&255)<240){if((p|0)<3){l=31;break a}t=b[n>>0]|0;u=h[m>>0]|0;v=u&224;switch(a<<24>>24){case -32:{if((v|0)!=160){w=o;break a}break}case -19:{if((v|0)!=128){w=o;break a}break}default:if((u&192|0)!=128){w=o;break a}}v=t&255;if((v&192|0)!=128){l=31;break a}if((u<<6&4032|f<<12&61440|v&63)>>>0>e>>>0){l=31;break a}else{r=j;s=q;break}}if((a&255)>=245){l=31;break a}if((d-j|0)>>>0<2|(p|0)<4){l=31;break a}p=b[m>>0]|0;v=b[n>>0]|0;n=b[q>>0]|0;q=p&255;switch(a<<24>>24){case -16:{if((p+112&255)>=48){w=o;break a}break}case -12:{if((q&240|0)!=128){w=o;break a}break}default:if((q&192|0)!=128){w=o;break a}}o=v&255;if((o&192|0)!=128){l=31;break a}v=n&255;if((v&192|0)!=128){l=31;break a}if((q<<12&258048|f<<18&1835008|o<<6&4032|v&63)>>>0>e>>>0){l=31;break a}else{r=j+1|0;s=k+4|0}}else{r=j;s=m}while(0);j=r+1|0;k=s}if((l|0)==31)w=k;return w-i|0}function e3b(a,c,e,g,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f[e>>2]=a;f[j>>2]=g;g=c;if((((l&4|0?(l=f[e>>2]|0,(g-l|0)>2):0)?(b[l>>0]|0)==-17:0)?(b[l+1>>0]|0)==-69:0)?(b[l+2>>0]|0)==-65:0)f[e>>2]=l+3;l=i;a:while(1){a=f[e>>2]|0;m=a>>>0<c>>>0;if(!m){n=40;break}o=f[j>>2]|0;if(o>>>0>=i>>>0){n=40;break}p=b[a>>0]|0;q=p&255;if(q>>>0>k>>>0){r=2;break}s=a+1|0;do if(p<<24>>24>-1){d[o>>1]=p&255;t=s}else{if((p&255)<194){r=2;break a}u=g-a|0;v=a+2|0;if((p&255)<224){if((u|0)<2){r=1;break a}w=h[s>>0]|0;if((w&192|0)!=128){r=2;break a}x=w&63|q<<6&1984;if(x>>>0>k>>>0){r=2;break a}d[o>>1]=x;t=v;break}x=a+3|0;if((p&255)<240){if((u|0)<3){r=1;break a}w=b[v>>0]|0;y=h[s>>0]|0;z=y&224;switch(p<<24>>24){case -32:{if((z|0)!=160){r=2;break a}break}case -19:{if((z|0)!=128){r=2;break a}break}default:if((y&192|0)!=128){r=2;break a}}z=w&255;if((z&192|0)!=128){r=2;break a}w=y<<6&4032|q<<12|z&63;if((w&65535)>>>0>k>>>0){r=2;break a}d[o>>1]=w;t=x;break}if((p&255)>=245){r=2;break a}if((u|0)<4){r=1;break a}u=b[s>>0]|0;w=b[v>>0]|0;v=b[x>>0]|0;x=u&255;switch(p<<24>>24){case -16:{if((u+112&255)>=48){r=2;break a}break}case -12:{if((x&240|0)!=128){r=2;break a}break}default:if((x&192|0)!=128){r=2;break a}}u=w&255;if((u&192|0)!=128){r=2;break a}w=v&255;if((w&192|0)!=128){r=2;break a}if((l-o|0)<4){r=1;break a}v=q&7;z=u<<6;y=w&63;if((x<<12&258048|v<<18|z&4032|y)>>>0>k>>>0){r=2;break a}d[o>>1]=x<<2&60|u>>>4&3|((x>>>4&3|v<<2)<<6)+16320|55296;v=o+2|0;f[j>>2]=v;d[v>>1]=y|z&960|56320;t=(f[e>>2]|0)+4|0}while(0);f[e>>2]=t;f[j>>2]=(f[j>>2]|0)+2}if((n|0)==40)r=m&1;return r|0}function f3b(a,c,e,g,h,i,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[e>>2]=a;f[i>>2]=g;a=h;if(l&2)if((a-g|0)<3)m=1;else{f[i>>2]=g+1;b[g>>0]=-17;g=f[i>>2]|0;f[i>>2]=g+1;b[g>>0]=-69;g=f[i>>2]|0;f[i>>2]=g+1;b[g>>0]=-65;n=4}else n=4;a:do if((n|0)==4){g=c;l=f[e>>2]|0;while(1){if(l>>>0>=c>>>0){m=0;break a}h=d[l>>1]|0;o=h&65535;if(o>>>0>k>>>0){m=2;break a}do if((h&65535)<128){p=f[i>>2]|0;if((a-p|0)<1){m=1;break a}f[i>>2]=p+1;b[p>>0]=h}else{p=o&63;q=(p|128)&255;if((h&65535)<2048){r=f[i>>2]|0;if((a-r|0)<2){m=1;break a}f[i>>2]=r+1;b[r>>0]=o>>>6|192;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=q;break}r=(o>>>12|224)&255;s=(o>>>6&63|128)&255;if((h&65535)<55296){t=f[i>>2]|0;if((a-t|0)<3){m=1;break a}f[i>>2]=t+1;b[t>>0]=r;t=f[i>>2]|0;f[i>>2]=t+1;b[t>>0]=s;t=f[i>>2]|0;f[i>>2]=t+1;b[t>>0]=q;break}if((h&65535)>=56320){if((h&65535)<57344){m=2;break a}t=f[i>>2]|0;if((a-t|0)<3){m=1;break a}f[i>>2]=t+1;b[t>>0]=r;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=s;s=f[i>>2]|0;f[i>>2]=s+1;b[s>>0]=q;break}if((g-l|0)<4){m=1;break a}q=l+2|0;s=j[q>>1]|0;if((s&64512|0)!=56320){m=2;break a}if((a-(f[i>>2]|0)|0)<4){m=1;break a}r=o&960;if(((r<<10)+65536|p<<10|s&1023)>>>0>k>>>0){m=2;break a}f[e>>2]=q;q=(r>>>6)+1|0;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=q>>>2|240;r=f[i>>2]|0;f[i>>2]=r+1;b[r>>0]=o>>>2&15|q<<4&48|128;q=f[i>>2]|0;f[i>>2]=q+1;b[q>>0]=o<<4&48|s>>>6&15|128;q=f[i>>2]|0;f[i>>2]=q+1;b[q>>0]=s&63|128}while(0);o=(f[e>>2]|0)+2|0;f[e>>2]=o;l=o}}while(0);return m|0}function g3b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;f[a>>2]=148920;b=a+8|0;c=a+12|0;d=0;while(1){e=f[b>>2]|0;if(d>>>0>=(f[c>>2]|0)-e>>2>>>0)break;g=f[e+(d<<2)>>2]|0;if(g|0)I5b(g)|0;d=d+1|0}Z5b(a+144|0);i3b(b);dZb(a);return}function h3b(a){a=a|0;g3b(a);O5b(a);return}function i3b(a){a=a|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;do if(c|0){d=a+4|0;e=f[d>>2]|0;while(1){if((e|0)==(c|0))break;g=e+-4|0;f[d>>2]=g;e=g}if((a+16|0)==(c|0)){b[a+128>>0]=0;break}else{O5b(c);break}}while(0);return}function j3b(a){a=a|0;var c=0;f[a>>2]=148940;c=f[a+8>>2]|0;if(c|0?b[a+12>>0]|0:0)P5b(c);dZb(a);return}function k3b(a){a=a|0;j3b(a);O5b(a);return}function l3b(a,b){a=a|0;b=b|0;var c=0;if(b<<24>>24>-1){a=(u3b()|0)+((b&255)<<2)|0;c=f[a>>2]&255}else c=b;return c|0}function m3b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;a=c;while(1){if((a|0)==(d|0))break;c=b[a>>0]|0;if(c<<24>>24>-1){e=u3b()|0;g=f[e+(b[a>>0]<<2)>>2]&255}else g=c;b[a>>0]=g;a=a+1|0}return d|0}function n3b(a,b){a=a|0;b=b|0;var c=0;if(b<<24>>24>-1){a=(t3b()|0)+(b<<24>>24<<2)|0;c=f[a>>2]&255}else c=b;return c|0}function o3b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;a=c;while(1){if((a|0)==(d|0))break;c=b[a>>0]|0;if(c<<24>>24>-1){e=t3b()|0;g=f[e+(b[a>>0]<<2)>>2]&255}else g=c;b[a>>0]=g;a=a+1|0}return d|0}function p3b(a,b){a=a|0;b=b|0;return b|0}function q3b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;a=e;e=c;while(1){if((e|0)==(d|0))break;b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}return d|0}function r3b(a,b,c){a=a|0;b=b|0;c=c|0;return (b<<24>>24>-1?b:c)|0}function s3b(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;a=f;f=c;while(1){if((f|0)==(d|0))break;c=b[f>>0]|0;b[a>>0]=c<<24>>24>-1?c:e;a=a+1|0;f=f+1|0}return d|0}function t3b(){var a=0;a=pWb()|0;return f[a>>2]|0}function u3b(){var a=0;a=oWb()|0;return f[a>>2]|0}function v3b(){var a=0;a=nWb()|0;return f[a>>2]|0}function w3b(a){a=a|0;f[a>>2]=148992;Z5b(a+12|0);dZb(a);return}function x3b(a){a=a|0;w3b(a);O5b(a);return}function y3b(a){a=a|0;return b[a+8>>0]|0}function z3b(a){a=a|0;return b[a+9>>0]|0}function A3b(a,b){a=a|0;b=b|0;X5b(a,b+12|0);return}function B3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=OXb(490309)|0;if(e>>>0>4294967279)V5b(a);if(e>>>0<11){b[a+11>>0]=e;g=a}else{h=e+16&-16;i=L5b(h)|0;f[a>>2]=i;f[a+8>>2]=h|-2147483648;f[a+4>>2]=e;g=i}VWb(g,490309,e)|0;b[d>>0]=0;PXb(g+e|0,d);u=c;return}function C3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=OXb(490303)|0;if(e>>>0>4294967279)V5b(a);if(e>>>0<11){b[a+11>>0]=e;g=a}else{h=e+16&-16;i=L5b(h)|0;f[a>>2]=i;f[a+8>>2]=h|-2147483648;f[a+4>>2]=e;g=i}VWb(g,490303,e)|0;b[d>>0]=0;PXb(g+e|0,d);u=c;return}function D3b(a){a=a|0;f[a>>2]=149032;Z5b(a+16|0);dZb(a);return}function E3b(a){a=a|0;D3b(a);O5b(a);return}function F3b(a){a=a|0;return f[a+8>>2]|0}function G3b(a){a=a|0;return f[a+12>>2]|0}function H3b(a,b){a=a|0;b=b|0;X5b(a,b+16|0);return}function I3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=j0b(149088)|0;if(e>>>0>1073741807)V5b(a);do if(e>>>0>=2){g=e+4&-4;if(g>>>0>1073741823)Re();else{h=L5b(g<<2)|0;f[a>>2]=h;f[a+8>>2]=g|-2147483648;f[a+4>>2]=e;i=h;break}}else{b[a+8+3>>0]=e;i=a}while(0);lXb(i,149088,e)|0;f[d>>2]=0;jZb(i+(e<<2)|0,d);u=c;return}function J3b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=j0b(149064)|0;if(e>>>0>1073741807)V5b(a);do if(e>>>0>=2){g=e+4&-4;if(g>>>0>1073741823)Re();else{h=L5b(g<<2)|0;f[a>>2]=h;f[a+8>>2]=g|-2147483648;f[a+4>>2]=e;i=h;break}}else{b[a+8+3>>0]=e;i=a}while(0);lXb(i,149064,e)|0;f[d>>2]=0;jZb(i+(e<<2)|0,d);u=c;return}function K3b(a){a=a|0;dZb(a);O5b(a);return}function L3b(a){a=a|0;dZb(a);O5b(a);return}function M3b(a,b,c){a=a|0;b=b|0;c=c|0;var e=0;if(c>>>0<128){a=(v3b()|0)+(c<<1)|0;e=(d[a>>1]&b)<<16>>16!=0}else e=0;return e|0}function N3b(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0;a=e;e=b;while(1){if((e|0)==(c|0))break;if((f[e>>2]|0)>>>0<128){b=v3b()|0;g=j[b+(f[e>>2]<<1)>>1]|0}else g=0;d[a>>1]=g;a=a+2|0;e=e+4|0}return c|0}function O3b(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0;a=c;while(1){if((a|0)==(e|0)){g=e;break}if((f[a>>2]|0)>>>0<128?(c=v3b()|0,(d[c+(f[a>>2]<<1)>>1]&b)<<16>>16):0){g=a;break}a=a+4|0}return g|0}function P3b(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0;a=c;while(1){if((a|0)==(e|0)){g=e;break}if((f[a>>2]|0)>>>0>=128){g=a;break}c=v3b()|0;if(!((d[c+(f[a>>2]<<1)>>1]&b)<<16>>16)){g=a;break}a=a+4|0}return g|0}function Q3b(a,b){a=a|0;b=b|0;var c=0;if(b>>>0<128){a=(u3b()|0)+(b<<2)|0;c=f[a>>2]|0}else c=b;return c|0}function R3b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=b;while(1){if((a|0)==(c|0))break;b=f[a>>2]|0;if(b>>>0<128){d=u3b()|0;e=f[d+(f[a>>2]<<2)>>2]|0}else e=b;f[a>>2]=e;a=a+4|0}return c|0}function S3b(a,b){a=a|0;b=b|0;var c=0;if(b>>>0<128){a=(t3b()|0)+(b<<2)|0;c=f[a>>2]|0}else c=b;return c|0}function T3b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;a=b;while(1){if((a|0)==(c|0))break;b=f[a>>2]|0;if(b>>>0<128){d=t3b()|0;e=f[d+(f[a>>2]<<2)>>2]|0}else e=b;f[a>>2]=e;a=a+4|0}return c|0}function U3b(a,b){a=a|0;b=b|0;return b<<24>>24|0}function V3b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;a=e;e=c;while(1){if((e|0)==(d|0))break;f[a>>2]=b[e>>0];a=a+4|0;e=e+1|0}return d|0}function W3b(a,b,c){a=a|0;b=b|0;c=c|0;return (b>>>0<128?b&255:c)|0}function X3b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;a=(d-c|0)>>>2;h=g;g=c;while(1){if((g|0)==(d|0))break;i=f[g>>2]|0;b[h>>0]=i>>>0<128?i&255:e;h=h+1|0;g=g+4|0}return c+(a<<2)|0}function Y3b(a){a=a|0;dZb(a);O5b(a);return}function Z3b(a){a=a|0;dZb(a);O5b(a);return}function _3b(a){a=a|0;dZb(a);O5b(a);return}function $3b(a){a=a|0;f[a>>2]=149348;return}function a4b(a){a=a|0;f[a>>2]=149384;return}function b4b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;f[a+4>>2]=e+-1;f[a>>2]=148940;e=a+8|0;f[e>>2]=c;b[a+12>>0]=d&1;if(!c){c=v3b()|0;f[e>>2]=c}return}function c4b(a){a=a|0;Re()}function d4b(a){a=a|0;Re()}function e4b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a+4>>2]=c+-1;f[a>>2]=148920;c=a+8|0;f4b(c,28);g=a+144|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=OXb(486221)|0;if(h>>>0>4294967279)V5b(g);if(h>>>0<11){b[g+11>>0]=h;i=g}else{j=h+16&-16;k=L5b(j)|0;f[g>>2]=k;f[a+152>>2]=j|-2147483648;f[a+148>>2]=h;i=k}VWb(i,486221,h)|0;b[e>>0]=0;PXb(i+h|0,e);e=f[c>>2]|0;c=a+12|0;h=f[c>>2]|0;while(1){if((h|0)==(e|0))break;i=h+-4|0;f[c>>2]=i;h=i}g4b();h4b(a,499512);i4b();j4b(a,499520);k4b();l4b(a,499528);m4b();n4b(a,499544);o4b();p4b(a,499552);q4b();r4b(a,499560);s4b();t4b(a,499576);u4b();v4b(a,499584);w4b();x4b(a,499592);y4b();z4b(a,499616);A4b();B4b(a,499648);C4b();D4b(a,499656);E4b();F4b(a,499664);G4b();H4b(a,499672);I4b();J4b(a,499680);K4b();L4b(a,499688);M4b();N4b(a,499696);O4b();P4b(a,499704);Q4b();R4b(a,499712);S4b();T4b(a,499720);U4b();V4b(a,499728);W4b();X4b(a,499736);Y4b();Z4b(a,499744);_4b();$4b(a,499760);a5b();b5b(a,499776);c5b();d5b(a,499792);e5b();f5b(a,499808);g5b();h5b(a,499816);u=d;return}function f4b(a,c){a=a|0;c=c|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+128>>0]=0;if(c|0){u5b(a,c);l5b(a,c)}return}function g4b(){f[124879]=0;f[124878]=146584;return}function h4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(855484)|0);return}function i4b(){f[124881]=0;f[124880]=146616;return}function j4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(855492)|0);return}function k4b(){b4b(499528,0,0,1);return}function l4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(855500)|0);return}function m4b(){f[124887]=0;f[124886]=149136;return}function n4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(855532)|0);return}function o4b(){f[124889]=0;f[124888]=149204;return}function p4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857292)|0);return}function q4b(){t5b(499560,1);return}function r4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857300)|0);return}function s4b(){f[124895]=0;f[124894]=149252;return}function t4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857308)|0);return}function u4b(){f[124897]=0;f[124896]=149300;return}function v4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857316)|0);return}function w4b(){s5b(499592,1);return}function x4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(855516)|0);return}function y4b(){r5b(499616,1);return}function z4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(855540)|0);return}function A4b(){f[124913]=0;f[124912]=146648;return}function B4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(855524)|0);return}function C4b(){f[124915]=0;f[124914]=146712;return}function D4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(855548)|0);return}function E4b(){f[124917]=0;f[124916]=146776;return}function F4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(855556)|0);return}function G4b(){f[124919]=0;f[124918]=146828;return}function H4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(855564)|0);return}function I4b(){f[124921]=0;f[124920]=148376;return}function J4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857212)|0);return}function K4b(){f[124923]=0;f[124922]=148432;return}function L4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857220)|0);return}function M4b(){f[124925]=0;f[124924]=148488;return}function N4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857228)|0);return}function O4b(){f[124927]=0;f[124926]=148544;return}function P4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857236)|0);return}function Q4b(){f[124929]=0;f[124928]=148600;return}function R4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857244)|0);return}function S4b(){f[124931]=0;f[124930]=148628;return}function T4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857252)|0);return}function U4b(){f[124933]=0;f[124932]=148656;return}function V4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857260)|0);return}function W4b(){f[124935]=0;f[124934]=148684;return}function X4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857268)|0);return}function Y4b(){f[124937]=0;f[124936]=149116;$3b(499752);f[124936]=146880;f[124938]=146928;return}function Z4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(856376)|0);return}function _4b(){f[124941]=0;f[124940]=149116;a4b(499768);f[124940]=146964;f[124942]=147012;return}function $4b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857188)|0);return}function a5b(){var a=0;f[124945]=0;f[124944]=149116;a=AZb()|0;f[124946]=a;f[124944]=148328;return}function b5b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857196)|0);return}function c5b(){var a=0;f[124949]=0;f[124948]=149116;a=AZb()|0;f[124950]=a;f[124948]=148352;return}function d5b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857204)|0);return}function e5b(){f[124953]=0;f[124952]=148712;return}function f5b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857276)|0);return}function g5b(){f[124955]=0;f[124954]=148744;return}function h5b(a,b){a=a|0;b=b|0;i5b(a,b,CZb(857284)|0);return}function i5b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;G5b(b);d=a+8|0;e=f[d>>2]|0;if((f[a+12>>2]|0)-e>>2>>>0>c>>>0){g=d;h=e}else{j5b(d,c+1|0);g=d;h=f[d>>2]|0}d=f[h+(c<<2)>>2]|0;if(d|0)I5b(d)|0;f[(f[g>>2]|0)+(c<<2)>>2]=b;return}function j5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>2;h=e;e=d;a:do if(g>>>0>=b>>>0){if(g>>>0>b>>>0){d=h+(b<<2)|0;i=e;while(1){if((i|0)==(d|0))break a;j=i+-4|0;f[c>>2]=j;i=j}}}else k5b(a,b-g|0);while(0);return}function k5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=a+8|0;g=a+4|0;h=f[g>>2]|0;do if((f[e>>2]|0)-h>>2>>>0<b>>>0){i=(h-(f[a>>2]|0)>>2)+b|0;j=m5b(a)|0;if(j>>>0<i>>>0)c4b(a);else{k=f[a>>2]|0;l=(f[e>>2]|0)-k|0;m=l>>1;n5b(d,l>>2>>>0<j>>>1>>>0?(m>>>0<i>>>0?i:m):j,(f[g>>2]|0)-k>>2,a+16|0);o5b(d,b);p5b(a,d);q5b(d);break}}else l5b(a,b);while(0);u=c;return}function l5b(a,b){a=a|0;b=b|0;var c=0;c=a+4|0;a=b;b=f[c>>2]|0;do{f[b>>2]=0;b=(f[c>>2]|0)+4|0;f[c>>2]=b;a=a+-1|0}while((a|0)!=0);return}function m5b(a){a=a|0;return 1073741823}function n5b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;f[a+12>>2]=0;f[a+16>>2]=e;do if(c){g=e+112|0;if(c>>>0<29&(b[g>>0]|0)==0){b[g>>0]=1;h=e;break}else{h=L5b(c<<2)|0;break}}else h=0;while(0);f[a>>2]=h;e=h+(d<<2)|0;f[a+8>>2]=e;f[a+4>>2]=e;f[a+12>>2]=h+(c<<2);return}function o5b(a,b){a=a|0;b=b|0;var c=0;c=a+8|0;a=b;b=f[c>>2]|0;do{f[b>>2]=0;b=(f[c>>2]|0)+4|0;f[c>>2]=b;a=a+-1|0}while((a|0)!=0);return}function p5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=(f[d>>2]|0)-c|0;h=(f[e>>2]|0)+(0-(g>>2)<<2)|0;f[e>>2]=h;if((g|0)>0){Vac(h|0,c|0,g|0)|0;i=e;j=f[e>>2]|0}else{i=e;j=h}h=f[a>>2]|0;f[a>>2]=j;f[i>>2]=h;h=b+8|0;j=f[d>>2]|0;f[d>>2]=f[h>>2];f[h>>2]=j;j=a+8|0;a=b+12|0;h=f[j>>2]|0;f[j>>2]=f[a>>2];f[a>>2]=h;f[b>>2]=f[i>>2];return}function q5b(a){a=a|0;var c=0,d=0,e=0,g=0;c=f[a+4>>2]|0;d=a+8|0;e=f[d>>2]|0;while(1){if((e|0)==(c|0))break;g=e+-4|0;f[d>>2]=g;e=g}e=f[a>>2]|0;do if(e|0){d=f[a+16>>2]|0;if((d|0)==(e|0)){b[d+112>>0]=0;break}else{O5b(e);break}}while(0);return}function r5b(a,b){a=a|0;b=b|0;f[a+4>>2]=b+-1;f[a>>2]=149032;f[a+8>>2]=46;f[a+12>>2]=44;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[b+(a<<2)>>2]=0;a=a+1|0}return}function s5b(a,c){a=a|0;c=c|0;f[a+4>>2]=c+-1;f[a>>2]=148992;b[a+8>>0]=46;b[a+9>>0]=44;c=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[c+(a<<2)>>2]=0;a=a+1|0}return}function t5b(a,b){a=a|0;b=b|0;f[a+4>>2]=b+-1;f[a>>2]=148872;b=AZb()|0;f[a+8>>2]=b;return}function u5b(a,c){a=a|0;c=c|0;var d=0,e=0;if((m5b(a)|0)>>>0<c>>>0)c4b(a);d=a+128|0;if(c>>>0<29&(b[d>>0]|0)==0){b[d>>0]=1;e=a+16|0}else e=L5b(c<<2)|0;f[a+4>>2]=e;f[a>>2]=e;f[a+8>>2]=e+(c<<2);return}function v5b(){if((b[499824]|0)==0?Cac(499824)|0:0){w5b()|0;f[214332]=857324}return f[214332]|0}function w5b(){x5b();f[214331]=499832;return 857324}function x5b(){e4b(499832,1);return}function y5b(){z5b(857332,v5b()|0);return 857332}function z5b(a,b){a=a|0;b=b|0;var c=0;c=f[b>>2]|0;f[a>>2]=c;G5b(c);return}function A5b(){if((b[499992]|0)==0?Cac(499992)|0:0){y5b()|0;f[214334]=857332}return f[214334]|0}function B5b(a){a=a|0;var b=0,c=0;b=A5b()|0;c=f[b>>2]|0;f[a>>2]=c;G5b(c);return}function C5b(a,b){a=a|0;b=b|0;var c=0;c=f[a>>2]|0;return D5b(c,CZb(b)|0)|0}function D5b(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[a+8>>2]|0;if((f[a+12>>2]|0)-c>>2>>>0>b>>>0)d=(f[c+(b<<2)>>2]|0)!=0;else d=0;return d|0}function E5b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!c)d=0;else d=ZVb(a,b,c)|0;return d|0}function F5b(a){a=a|0;return}function G5b(a){a=a|0;H5b(a+4|0);return}function H5b(a){a=a|0;f[a>>2]=(f[a>>2]|0)+1;return}function I5b(a){a=a|0;var b=0;if((J5b(a+4|0)|0)==-1){bi[f[(f[a>>2]|0)+8>>2]&2047](a);b=1}else b=0;return b|0}function J5b(a){a=a|0;var b=0;b=f[a>>2]|0;f[a>>2]=b+-1;return b+-1|0}function K5b(a,b,c){a=a|0;b=b|0;c=c|0;Mac(857340)|0;while(1){if((f[a>>2]|0)!=1)break;_e(857368,857340)|0}if(!(f[a>>2]|0)){f[a>>2]=1;Lac(857340)|0;bi[c&2047](b);Mac(857340)|0;f[a>>2]=-1;Lac(857340)|0;Tac(857368)|0}else Lac(857340)|0;return}function L5b(a){a=a|0;var b=0,c=0;b=(a|0)==0?1:a;while(1){a=OSb(b)|0;if(a|0){c=a;break}a=Fac()|0;if(!a){c=0;break}$h[a&127]()}return c|0}function M5b(a,b){a=a|0;b=b|0;return L5b(a)|0}function N5b(a){a=a|0;return L5b(a)|0}function O5b(a){a=a|0;PSb(a);return}function P5b(a){a=a|0;O5b(a);return}function Q5b(){Re()}function R5b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=kUb(b)|0;d=L5b(c+13|0)|0;f[d>>2]=c;f[d+4>>2]=c;f[d+8>>2]=0;e=S5b(d)|0;Vac(e|0,b|0,c+1|0)|0;f[a>>2]=e;return}function S5b(a){a=a|0;return a+12|0}function T5b(a,b){a=a|0;b=b|0;f[a>>2]=149508;R5b(a+4|0,b);return}function U5b(a){a=a|0;return 1}function V5b(a){a=a|0;Re()}function W5b(a){a=a|0;Re()}function X5b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if((b[c+11>>0]|0)<0){g=f[c>>2]|0;h=f[c+4>>2]|0;if(h>>>0>4294967279)V5b(a);if(h>>>0<11){b[a+11>>0]=h;i=a}else{j=h+16&-16;k=L5b(j)|0;f[a>>2]=k;f[a+8>>2]=j|-2147483648;f[a+4>>2]=h;i=k}VWb(i,g,h)|0;b[e>>0]=0;PXb(i+h|0,e)}else{f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2]}u=d;return}function Y5b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;g=u;u=u+16|0;h=g;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;i=b[c+11>>0]|0;j=i<<24>>24<0;k=j?f[c+4>>2]|0:i&255;if(k>>>0<d>>>0)W5b(a);i=(j?f[c>>2]|0:c)+d|0;c=k-d|0;d=c>>>0<e>>>0?c:e;if(d>>>0>4294967279)V5b(a);if(d>>>0<11){b[a+11>>0]=d;l=a}else{e=d+16&-16;c=L5b(e)|0;f[a>>2]=c;f[a+8>>2]=e|-2147483648;f[a+4>>2]=d;l=c}VWb(l,i,d)|0;b[h>>0]=0;PXb(l+d|0,h);u=g;return}function Z5b(a){a=a|0;if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);return}function _5b(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)!=(c|0)){d=b[c+11>>0]|0;e=d<<24>>24<0;$5b(a,e?f[c>>2]|0:c,e?f[c+4>>2]|0:d&255)|0}return a|0}function $5b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=(f[a+8>>2]&2147483647)+-1|0;else k=10;do if(k>>>0>=d>>>0){if(j)l=f[a>>2]|0;else l=a;a6b(l,c,d)|0;b[g>>0]=0;PXb(l+d|0,g);if((b[h>>0]|0)<0){f[a+4>>2]=d;break}else{b[h>>0]=d;break}}else{if(j)m=f[a+4>>2]|0;else m=i&255;b6b(a,k,d-k|0,m,0,m,d,c)}while(0);u=e;return a|0}function a6b(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)Xac(a|0,b|0,c|0)|0;return a|0}function b6b(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+16|0;l=k;if((-18-c|0)>>>0<d>>>0)V5b(a);if((b[a+11>>0]|0)<0)m=f[a>>2]|0;else m=a;if(c>>>0<2147483623){n=d+c|0;d=c<<1;o=n>>>0<d>>>0?d:n;p=o>>>0<11?11:o+16&-16}else p=-17;o=L5b(p)|0;if(g|0)VWb(o,m,g)|0;if(i|0)VWb(o+g|0,j,i)|0;j=e-h|0;e=j-g|0;if(e|0)VWb(o+g+i|0,m+g+h|0,e)|0;if((c|0)!=10)O5b(m);f[a>>2]=o;f[a+8>>2]=p|-2147483648;p=j+i|0;f[a+4>>2]=p;b[l>>0]=0;PXb(o+p|0,l);u=k;return}function c6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(c>>>0>4294967279)V5b(a);d=a+11|0;e=b[d>>0]|0;g=e<<24>>24<0;if(g){h=f[a+4>>2]|0;i=(f[a+8>>2]&2147483647)+-1|0}else{h=e&255;i=10}j=h>>>0>c>>>0?h:c;c=j>>>0<11;k=c?10:(j+16&-16)+-1|0;do if((k|0)!=(i|0)){do if(c){j=f[a>>2]|0;if(g){l=0;m=j;n=a;o=13}else{VWb(a,j,(e&255)+1|0)|0;O5b(j);o=15}}else{j=L5b(k+1|0)|0;if(g){l=1;m=f[a>>2]|0;n=j;o=13;break}else{VWb(j,a,(e&255)+1|0)|0;p=j;o=14;break}}while(0);if((o|0)==13){VWb(n,m,(f[a+4>>2]|0)+1|0)|0;O5b(m);if(l){p=n;o=14}else o=15}if((o|0)==14){f[a+8>>2]=k+1|-2147483648;f[a+4>>2]=h;f[a>>2]=p;break}else if((o|0)==15){b[d>>0]=h;break}}while(0);return}function d6b(a,b){a=a|0;b=b|0;return $5b(a,b,OXb(b)|0)|0}function e6b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=f[a+4>>2]|0;else k=i&255;do if(k>>>0>=c>>>0)if(j){i=(f[a>>2]|0)+c|0;b[g>>0]=0;PXb(i,g);f[a+4>>2]=c;break}else{b[g>>0]=0;PXb(a+c|0,g);b[h>>0]=c;break}else f6b(a,c-k|0,d)|0;while(0);u=e;return}function f6b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if(c|0){h=a+11|0;i=b[h>>0]|0;if(i<<24>>24<0){j=f[a+4>>2]|0;k=(f[a+8>>2]&2147483647)+-1|0}else{j=i&255;k=10}l=j+c|0;if((k-j|0)>>>0<c>>>0){g6b(a,k,l-k|0,j,j,0,0);m=b[h>>0]|0}else m=i;if(m<<24>>24<0)n=f[a>>2]|0;else n=a;c1b(n+j|0,c,d)|0;if((b[h>>0]|0)<0)f[a+4>>2]=l;else b[h>>0]=l;b[g>>0]=0;PXb(n+l|0,g)}u=e;return a|0}function g6b(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;if((-17-c|0)>>>0<d>>>0)V5b(a);if((b[a+11>>0]|0)<0)j=f[a>>2]|0;else j=a;if(c>>>0<2147483623){k=d+c|0;d=c<<1;l=k>>>0<d>>>0?d:k;m=l>>>0<11?11:l+16&-16}else m=-17;l=L5b(m)|0;if(g|0)VWb(l,j,g)|0;k=e-h-g|0;if(k|0)VWb(l+g+i|0,j+g+h|0,k)|0;if((c|0)!=10)O5b(j);f[a>>2]=l;f[a+8>>2]=m|-2147483648;return}function h6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=b[a+11>>0]|0;e=d<<24>>24<0;if(e)g=f[a+4>>2]|0;else g=d&255;if(g>>>0<=c>>>0)W5b(a);if(e)h=f[a>>2]|0;else h=a;return h+c|0}function i6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=b[a+11>>0]|0;e=d<<24>>24<0;if(e)g=f[a+4>>2]|0;else g=d&255;if(g>>>0<=c>>>0)W5b(a);if(e)h=f[a>>2]|0;else h=a;return h+c|0}function j6b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j){k=f[a+4>>2]|0;l=(f[a+8>>2]&2147483647)+-1|0}else{k=i&255;l=10}i=k+d|0;if((l-k|0)>>>0>=d>>>0){if(d|0){if(j)m=f[a>>2]|0;else m=a;VWb(m+k|0,c,d)|0;if((b[h>>0]|0)<0)f[a+4>>2]=i;else b[h>>0]=i;b[g>>0]=0;PXb(m+i|0,g)}}else b6b(a,l,i-l|0,k,k,0,d,c);u=e;return a|0}function k6b(a,b){a=a|0;b=b|0;return j6b(a,b,OXb(b)|0)|0}function l6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=d+1|0;b[e>>0]=c;c=a+11|0;h=b[c>>0]|0;i=h<<24>>24<0;if(i){j=f[a+4>>2]|0;k=(f[a+8>>2]&2147483647)+-1|0}else{j=h&255;k=10}if((j|0)==(k|0)){g6b(a,k,1,k,k,0,0);h=k+1|0;if((b[c>>0]|0)<0){l=h;m=8}else{n=h;m=7}}else{h=j+1|0;if(i){l=h;m=8}else{n=h;m=7}}if((m|0)==7){b[c>>0]=n;o=a}else if((m|0)==8){m=f[a>>2]|0;f[a+4>>2]=l;o=m}m=o+j|0;PXb(m,e);b[g>>0]=0;PXb(m+1|0,g);u=d;return}function m6b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=b[c+11>>0]|0;h=g<<24>>24<0;i=h?f[c+4>>2]|0:g&255;if(i>>>0<d>>>0)W5b(a);else{g=i-d|0;return j6b(a,(h?f[c>>2]|0:c)+d|0,g>>>0<e>>>0?g:e)|0}return 0}function n6b(a,b,c){a=a|0;b=b|0;c=c|0;return b>>>0<=a>>>0&a>>>0<c>>>0|0}function o6b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=f[a+4>>2]|0;else k=i&255;if(k>>>0<c>>>0)W5b(a);if(d|0){if(j)l=f[a>>2]|0;else l=a;j=k-c|0;m=j>>>0<d>>>0?j:d;d=j-m|0;if(!d)n=i;else{i=l+c|0;a6b(i,i+m|0,d)|0;n=b[h>>0]|0}d=k-m|0;if(n<<24>>24<0)f[a+4>>2]=d;else b[h>>0]=d;b[g>>0]=0;PXb(l+d|0,g)}u=e;return a|0}function p6b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+16|0;i=h;j=a+11|0;k=b[j>>0]|0;l=k<<24>>24<0;if(l)m=f[a+4>>2]|0;else m=k&255;if(m>>>0<c>>>0)W5b(a);k=m-c|0;n=k>>>0<d>>>0?k:d;if(l)o=(f[a+8>>2]&2147483647)+-1|0;else o=10;if((n-m+o|0)>>>0<g>>>0)b6b(a,o,m+g-n-o|0,m,c,n,g,e);else{if(l)p=f[a>>2]|0;else p=a;do if((n|0)!=(g|0)){l=k-n|0;if(!l){q=n;r=c;s=e;t=g;v=21}else{o=p+c|0;if(n>>>0>g>>>0){a6b(o,e,g)|0;a6b(o+g|0,o+n|0,l)|0;w=n;x=g;break}do if(o>>>0<e>>>0&(p+m|0)>>>0>e>>>0)if((o+n|0)>>>0>e>>>0){a6b(o,e,n)|0;y=n+c|0;z=e+g|0;A=g-n|0;B=0;break}else{y=c;z=e+(g-n)|0;A=g;B=n;break}else{y=c;z=e;A=g;B=n}while(0);o=p+y|0;a6b(o+A|0,o+B|0,l)|0;q=B;r=y;s=z;t=A;v=21}}else{q=g;r=c;s=e;t=g;v=21}while(0);if((v|0)==21){a6b(p+r|0,s,t)|0;w=q;x=t}t=x-w+m|0;if((b[j>>0]|0)<0)f[a+4>>2]=t;else b[j>>0]=t;b[i>>0]=0;PXb(p+t|0,i)}u=h;return a|0}function q6b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return p6b(a,b,c,d,OXb(d)|0)|0}function r6b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;if(!c)e=0;else e=xTb(a,UWb(b[d>>0]|0)|0,c)|0;return e|0}function s6b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=b[a+11>>0]|0;if(h<<24>>24<0){i=f[a+4>>2]|0;j=f[a>>2]|0}else{i=h&255;j=a}b[g>>0]=c;if(i>>>0>d>>>0){c=r6b(j+d|0,i-d|0,g)|0;k=(c|0)==0?-1:c-j|0}else k=-1;u=e;return k|0}function t6b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=b[a+11>>0]|0;if(e<<24>>24<0){g=f[a+4>>2]|0;h=f[a>>2]|0}else{g=e&255;h=a}a:do if(!g)i=-1;else{a=h+(g>>>0>d>>>0?d+1|0:g)|0;do{if((a|0)==(h|0)){i=-1;break a}a=a+-1|0}while(!(VXb(b[a>>0]|0,c)|0));i=a-h|0}while(0);return i|0}function u6b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=b[a+11>>0]|0;i=h<<24>>24<0;if(i)j=f[a+4>>2]|0;else j=h&255;if((g|0)==-1|j>>>0<c>>>0)W5b(a);h=j-c|0;j=h>>>0<d>>>0?h:d;if(i)k=f[a>>2]|0;else k=a;a=j>>>0>g>>>0;i=E5b(k+c|0,e,a?g:j)|0;if(!i)return (j>>>0<g>>>0?-1:a&1)|0;else return i|0;return 0}function v6b(a){a=a|0;if((b[a+8+3>>0]|0)<0)O5b(f[a>>2]|0);return}function w6b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+8|0;i=h+3|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k)l=(f[h>>2]&2147483647)+-1|0;else l=1;do if(l>>>0>=d>>>0){if(k)m=f[a>>2]|0;else m=a;x6b(m,c,d)|0;f[g>>2]=0;jZb(m+(d<<2)|0,g);if((b[i>>0]|0)<0){f[a+4>>2]=d;break}else{b[i>>0]=d;break}}else{if(k)n=f[a+4>>2]|0;else n=j&255;y6b(a,l,d-l|0,n,0,n,d,c)}while(0);u=e;return a|0}function x6b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(!c)d=a;else{gWb(a,b,c)|0;d=a}return d|0}function y6b(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=u;u=u+16|0;l=k;if((1073741806-c|0)>>>0<d>>>0)V5b(a);m=a+8|0;if((b[m+3>>0]|0)<0)n=f[a>>2]|0;else n=a;if(c>>>0<536870887){o=d+c|0;d=c<<1;p=o>>>0<d>>>0?d:o;o=p>>>0<2?2:p+4&-4;if(o>>>0>1073741823)Re();else q=o}else q=1073741807;o=L5b(q<<2)|0;if(g|0)lXb(o,n,g)|0;if(i|0)lXb(o+(g<<2)|0,j,i)|0;j=e-h|0;e=j-g|0;if(e|0)lXb(o+(g<<2)+(i<<2)|0,n+(g<<2)+(h<<2)|0,e)|0;if((c|0)!=1)O5b(n);f[a>>2]=o;f[m>>2]=q|-2147483648;q=j+i|0;f[a+4>>2]=q;f[l>>2]=0;jZb(o+(q<<2)|0,l);u=k;return}function z6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(c>>>0>1073741807)V5b(a);d=a+8|0;e=d+3|0;g=b[e>>0]|0;h=g<<24>>24<0;if(h){i=f[a+4>>2]|0;j=(f[d>>2]&2147483647)+-1|0}else{i=g&255;j=1}k=i>>>0>c>>>0?i:c;c=k>>>0<2;l=c?1:(k+4&-4)+-1|0;do if((l|0)!=(j|0)){do if(c){k=f[a>>2]|0;if(h){m=0;n=k;o=a;p=15}else{lXb(a,k,(g&255)+1|0)|0;O5b(k);p=17}}else{k=l+1|0;if(k>>>0>1073741823)Re();q=L5b(k<<2)|0;if(h){m=1;n=f[a>>2]|0;o=q;p=15;break}else{lXb(q,a,(g&255)+1|0)|0;r=q;p=16;break}}while(0);if((p|0)==15){lXb(o,n,(f[a+4>>2]|0)+1|0)|0;O5b(n);if(m){r=o;p=16}else p=17}if((p|0)==16){f[d>>2]=l+1|-2147483648;f[a+4>>2]=i;f[a>>2]=r;break}else if((p|0)==17){b[e>>0]=i;break}}while(0);return}function A6b(a,b){a=a|0;b=b|0;return w6b(a,b,j0b(b)|0)|0}function B6b(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;if((1073741807-c|0)>>>0<d>>>0)V5b(a);j=a+8|0;if((b[j+3>>0]|0)<0)k=f[a>>2]|0;else k=a;if(c>>>0<536870887){l=d+c|0;d=c<<1;m=l>>>0<d>>>0?d:l;l=m>>>0<2?2:m+4&-4;if(l>>>0>1073741823)Re();else n=l}else n=1073741807;l=L5b(n<<2)|0;if(g|0)lXb(l,k,g)|0;m=e-h-g|0;if(m|0)lXb(l+(g<<2)+(i<<2)|0,k+(g<<2)+(h<<2)|0,m)|0;if((c|0)!=1)O5b(k);f[a>>2]=l;f[j>>2]=n|-2147483648;return}function C6b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+8|0;i=h+3|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k){l=f[a+4>>2]|0;m=(f[h>>2]&2147483647)+-1|0}else{l=j&255;m=1}j=l+d|0;if((m-l|0)>>>0>=d>>>0){if(d|0){if(k)n=f[a>>2]|0;else n=a;lXb(n+(l<<2)|0,c,d)|0;if((b[i>>0]|0)<0)f[a+4>>2]=j;else b[i>>0]=j;f[g>>2]=0;jZb(n+(j<<2)|0,g)}}else y6b(a,m,j-m|0,l,l,0,d,c);u=e;return a|0}function D6b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d;g=d+4|0;f[e>>2]=c;c=a+8|0;h=c+3|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j){k=f[a+4>>2]|0;l=(f[c>>2]&2147483647)+-1|0}else{k=i&255;l=1}if((k|0)==(l|0)){B6b(a,l,1,l,l,0,0);i=l+1|0;if((b[h>>0]|0)<0){m=i;n=8}else{o=i;n=7}}else{i=k+1|0;if(j){m=i;n=8}else{o=i;n=7}}if((n|0)==7){b[h>>0]=o;p=a}else if((n|0)==8){n=f[a>>2]|0;f[a+4>>2]=m;p=n}n=p+(k<<2)|0;jZb(n,e);f[g>>2]=0;jZb(n+4|0,g);u=d;return}function E6b(){var a=0,b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+48|0;b=a+32|0;c=a+24|0;d=a+16|0;e=a;g=a+36|0;a=F6b()|0;if(a|0?(h=f[a>>2]|0,h|0):0){a=h+48|0;i=f[a>>2]|0;j=f[a+4>>2]|0;if(!((i&-256|0)==1126902528&(j|0)==1129074247)){f[c>>2]=f[37354];G6b(488424,c)}if((i|0)==1126902529&(j|0)==1129074247)k=f[h+44>>2]|0;else k=h+80|0;f[g>>2]=k;k=f[h>>2]|0;h=f[k+4>>2]|0;j=li[f[(f[6332]|0)+16>>2]&511](25328,k,g)|0;k=f[37354]|0;if(j){j=f[g>>2]|0;g=di[f[(f[j>>2]|0)+8>>2]&1023](j)|0;f[e>>2]=k;f[e+4>>2]=h;f[e+8>>2]=g;G6b(488338,e)}else{f[d>>2]=k;f[d+4>>2]=h;G6b(488383,d)}}G6b(488462,b)}function F6b(){var a=0,b=0;a=u;u=u+16|0;if(!(Zd(857416,76)|0)){b=Ze(f[214355]|0)|0;u=a;return b|0}else G6b(488613,a);return 0}function G6b(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[d>>2]=b;b=f[35349]|0;oTb(b,a,d)|0;SUb(10,b)|0;Re()}function H6b(a){a=a|0;return}function I6b(a){a=a|0;H6b(a);O5b(a);return}function J6b(a){a=a|0;return}function K6b(a){a=a|0;return}function L6b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d;if(!(P6b(a,b,0)|0))if((b|0)!=0?(g=T6b(b,25352,25336,0)|0,(g|0)!=0):0){b=e+4|0;h=b+52|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(h|0));f[e>>2]=g;f[e+8>>2]=a;f[e+12>>2]=-1;f[e+48>>2]=1;th[f[(f[g>>2]|0)+28>>2]&511](g,e,f[c>>2]|0,1);if((f[e+24>>2]|0)==1){f[c>>2]=f[e+16>>2];i=1}else i=0;j=i}else j=0;else j=1;u=d;return j|0}function M6b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;if(P6b(a,f[b+8>>2]|0,g)|0)S6b(0,b,c,d,e);return}function N6b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;do if(!(P6b(a,f[c+8>>2]|0,g)|0)){if(P6b(a,f[c>>2]|0,g)|0){h=c+32|0;if((f[c+16>>2]|0)!=(d|0)?(i=c+20|0,(f[i>>2]|0)!=(d|0)):0){f[h>>2]=e;f[i>>2]=d;i=c+40|0;f[i>>2]=(f[i>>2]|0)+1;if((f[c+36>>2]|0)==1?(f[c+24>>2]|0)==2:0)b[c+54>>0]=1;f[c+44>>2]=4;break}if((e|0)==1)f[h>>2]=1}}else R6b(0,c,d,e);while(0);return}function O6b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if(P6b(a,f[b+8>>2]|0,0)|0)Q6b(0,b,c,d);return}function P6b(a,b,c){a=a|0;b=b|0;c=c|0;return (a|0)==(b|0)|0}function Q6b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a=c+16|0;g=f[a>>2]|0;h=c+36|0;i=c+24|0;do if(g){if((g|0)!=(d|0)){f[h>>2]=(f[h>>2]|0)+1;f[i>>2]=2;b[c+54>>0]=1;break}if((f[i>>2]|0)==2)f[i>>2]=e}else{f[a>>2]=d;f[i>>2]=e;f[h>>2]=1}while(0);return}function R6b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if((f[b+4>>2]|0)==(c|0)?(c=b+28|0,(f[c>>2]|0)!=1):0)f[c>>2]=d;return}function S6b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;b[c+53>>0]=1;do if((f[c+4>>2]|0)==(e|0)){b[c+52>>0]=1;a=c+16|0;h=f[a>>2]|0;i=c+54|0;j=c+48|0;k=c+24|0;l=c+36|0;if(!h){f[a>>2]=d;f[k>>2]=g;f[l>>2]=1;if(!((f[j>>2]|0)==1&(g|0)==1))break;b[i>>0]=1;break}if((h|0)!=(d|0)){f[l>>2]=(f[l>>2]|0)+1;b[i>>0]=1;break}l=f[k>>2]|0;if((l|0)==2){f[k>>2]=g;m=g}else m=l;if((f[j>>2]|0)==1&(m|0)==1)b[i>>0]=1}while(0);return}function T6b(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+64|0;i=h;j=f[a>>2]|0;k=a+(f[j+-8>>2]|0)|0;l=f[j+-4>>2]|0;f[i>>2]=e;f[i+4>>2]=a;f[i+8>>2]=c;f[i+12>>2]=g;g=i+16|0;c=i+20|0;a=i+24|0;j=i+28|0;m=i+32|0;n=i+40|0;o=g;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));d[g+36>>1]=0;b[g+38>>0]=0;a:do if(P6b(l,e,0)|0){f[i+48>>2]=1;Wg[f[(f[l>>2]|0)+20>>2]&127](l,i,k,k,1,0);q=(f[a>>2]|0)==1?k:0}else{uh[f[(f[l>>2]|0)+24>>2]&255](l,i,k,1,0);switch(f[i+36>>2]|0){case 0:{q=(f[n>>2]|0)==1&(f[j>>2]|0)==1&(f[m>>2]|0)==1?f[c>>2]|0:0;break a;break}case 1:break;default:{q=0;break a}}if((f[a>>2]|0)!=1?!((f[n>>2]|0)==0&(f[j>>2]|0)==1&(f[m>>2]|0)==1):0){q=0;break}q=f[g>>2]|0}while(0);u=h;return q|0}function U6b(a){a=a|0;H6b(a);O5b(a);return}function V6b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0;if(P6b(a,f[b+8>>2]|0,g)|0)S6b(0,b,c,d,e);else{h=f[a+8>>2]|0;Wg[f[(f[h>>2]|0)+20>>2]&127](h,b,c,d,e,g)}return}function W6b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;do if(!(P6b(a,f[c+8>>2]|0,g)|0)){h=a+8|0;if(!(P6b(a,f[c>>2]|0,g)|0)){i=f[h>>2]|0;uh[f[(f[i>>2]|0)+24>>2]&255](i,c,d,e,g);break}i=c+32|0;if((f[c+16>>2]|0)!=(d|0)?(j=c+20|0,(f[j>>2]|0)!=(d|0)):0){f[i>>2]=e;k=c+44|0;if((f[k>>2]|0)==4)break;l=c+52|0;b[l>>0]=0;m=c+53|0;b[m>>0]=0;n=f[h>>2]|0;Wg[f[(f[n>>2]|0)+20>>2]&127](n,c,d,d,1,g);if(b[m>>0]|0)if(!(b[l>>0]|0)){o=3;p=11}else q=3;else{o=4;p=11}if((p|0)==11){f[j>>2]=d;j=c+40|0;f[j>>2]=(f[j>>2]|0)+1;if((f[c+36>>2]|0)==1?(f[c+24>>2]|0)==2:0){b[c+54>>0]=1;q=o}else q=o}f[k>>2]=q;break}if((e|0)==1)f[i>>2]=1}else R6b(0,c,d,e);while(0);return}function X6b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(P6b(a,f[b+8>>2]|0,0)|0)Q6b(0,b,c,d);else{e=f[a+8>>2]|0;th[f[(f[e>>2]|0)+28>>2]&511](e,b,c,d)}return}function Y6b(a){a=a|0;return}function Z6b(){var a=0;a=u;u=u+16|0;if(!(Le(857420,1551)|0)){u=a;return}else G6b(488662,a)}function _6b(a){a=a|0;var b=0;b=u;u=u+16|0;PSb(a);if(!(Ff(f[214355]|0,0)|0)){u=b;return}else G6b(488712,b)}function $6b(){var a=0,b=0;a=F6b()|0;if((a|0?(b=f[a>>2]|0,b|0):0)?(a=b+48|0,(f[a>>2]&-256|0)==1126902528?(f[a+4>>2]|0)==1129074247:0):0)a7b(f[b+12>>2]|0);a7b(b7b()|0)}function a7b(a){a=a|0;var b=0;b=u;u=u+16|0;$h[a&127]();G6b(488765,b)}function b7b(){var a=0;a=f[37353]|0;f[37353]=a+0;return a|0}function c7b(a){a=a|0;return}function d7b(a){a=a|0;f[a>>2]=149508;h7b(a+4|0);return}function e7b(a){a=a|0;d7b(a);O5b(a);return}function f7b(a){a=a|0;return g7b(a+4|0)|0}function g7b(a){a=a|0;return f[a>>2]|0}function h7b(a){a=a|0;var b=0,c=0;if(U5b(a)|0?(b=i7b(f[a>>2]|0)|0,a=b+8|0,c=f[a>>2]|0,f[a>>2]=c+-1,(c+-1|0)<0):0)O5b(b);return}function i7b(a){a=a|0;return a+-12|0}function j7b(a){a=a|0;d7b(a);O5b(a);return}function k7b(a){a=a|0;d7b(a);O5b(a);return}function l7b(a){a=a|0;return}function m7b(a){a=a|0;l7b(a);O5b(a);return}function n7b(a){a=a|0;return 488855}function o7b(a){a=a|0;H6b(a);O5b(a);return}function p7b(a,b,c){a=a|0;b=b|0;c=c|0;return P6b(a,b,0)|0}function q7b(a){a=a|0;H6b(a);O5b(a);return}function r7b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d;f[c>>2]=f[f[c>>2]>>2];if(!(s7b(a,b,0)|0))if(((b|0)!=0?(g=T6b(b,25352,25472,0)|0,(g|0)!=0):0)?(f[g+8>>2]&~f[a+8>>2]|0)==0:0){b=a+12|0;a=g+12|0;if(!(P6b(f[b>>2]|0,f[a>>2]|0,0)|0)?!(P6b(f[b>>2]|0,25504,0)|0):0){g=f[b>>2]|0;if((((g|0)!=0?(b=T6b(g,25352,25336,0)|0,(b|0)!=0):0)?(g=f[a>>2]|0,(g|0)!=0):0)?(a=T6b(g,25352,25336,0)|0,(a|0)!=0):0){g=e+4|0;h=g+52|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));f[e>>2]=a;f[e+8>>2]=b;f[e+12>>2]=-1;f[e+48>>2]=1;th[f[(f[a>>2]|0)+28>>2]&511](a,e,f[c>>2]|0,1);if((f[e+24>>2]|0)==1){f[c>>2]=f[e+16>>2];i=1}else i=0;j=i}else j=0}else j=1}else j=0;else j=1;u=d;return j|0}function s7b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(P6b(a,b,0)|0)d=1;else d=P6b(b,25512,0)|0;return d|0}function t7b(a){a=a|0;H6b(a);O5b(a);return}function u7b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(P6b(a,f[c+8>>2]|0,h)|0)S6b(0,c,d,e,g);else{i=c+52|0;j=b[i>>0]|0;k=c+53|0;l=b[k>>0]|0;m=f[a+12>>2]|0;n=a+16+(m<<3)|0;b[i>>0]=0;b[k>>0]=0;y7b(a+16|0,c,d,e,g,h);a:do if((m|0)>1){o=c+24|0;p=c+54|0;q=a+8|0;r=a+24|0;do{if(b[p>>0]|0)break a;if(!(b[i>>0]|0)){if(b[k>>0]|0?(f[q>>2]&1|0)==0:0)break a}else{if((f[o>>2]|0)==1)break a;if(!(f[q>>2]&2))break a}b[i>>0]=0;b[k>>0]=0;y7b(r,c,d,e,g,h);r=r+8|0}while(r>>>0<n>>>0)}while(0);b[i>>0]=j;b[k>>0]=l}return}function v7b(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;a:do if(!(P6b(a,f[c+8>>2]|0,g)|0)){h=a+12|0;i=c+24|0;j=c+36|0;k=c+54|0;l=a+8|0;m=a+16|0;if(!(P6b(a,f[c>>2]|0,g)|0)){n=f[h>>2]|0;o=a+16+(n<<3)|0;z7b(m,c,d,e,g);p=a+24|0;if((n|0)<=1)break;n=f[l>>2]|0;if((n&2|0)==0?(f[j>>2]|0)!=1:0){if(!(n&1)){n=p;while(1){if(b[k>>0]|0)break a;if((f[j>>2]|0)==1)break a;z7b(n,c,d,e,g);n=n+8|0;if(n>>>0>=o>>>0)break a}}else q=p;while(1){if(b[k>>0]|0)break a;if((f[j>>2]|0)==1?(f[i>>2]|0)==1:0)break a;z7b(q,c,d,e,g);q=q+8|0;if(q>>>0>=o>>>0)break a}}else r=p;while(1){if(b[k>>0]|0)break a;z7b(r,c,d,e,g);r=r+8|0;if(r>>>0>=o>>>0)break a}}o=c+32|0;if((f[c+16>>2]|0)!=(d|0)?(p=c+20|0,(f[p>>2]|0)!=(d|0)):0){f[o>>2]=e;n=c+44|0;if((f[n>>2]|0)==4)break;s=a+16+(f[h>>2]<<3)|0;t=c+52|0;u=c+53|0;v=0;w=m;x=0;b:while(1){if(w>>>0>=s>>>0){y=v;z=18;break}b[t>>0]=0;b[u>>0]=0;y7b(w,c,d,d,1,g);if(b[k>>0]|0){y=v;z=18;break}do if(b[u>>0]|0){if(!(b[t>>0]|0))if(!(f[l>>2]&1)){y=1;z=18;break b}else{A=1;B=x;break}if((f[i>>2]|0)==1){z=23;break b}if(!(f[l>>2]&2)){z=23;break b}else{A=1;B=1}}else{A=v;B=x}while(0);v=A;w=w+8|0;x=B}do if((z|0)==18){if((!x?(f[p>>2]=d,w=c+40|0,f[w>>2]=(f[w>>2]|0)+1,(f[j>>2]|0)==1):0)?(f[i>>2]|0)==2:0){b[k>>0]=1;if(y){z=23;break}else{C=4;break}}if(y)z=23;else C=4}while(0);if((z|0)==23)C=3;f[n>>2]=C;break}if((e|0)==1)f[o>>2]=1}else R6b(0,c,d,e);while(0);return}function w7b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a:do if(!(P6b(a,f[c+8>>2]|0,0)|0)){g=f[a+12>>2]|0;h=a+16+(g<<3)|0;x7b(a+16|0,c,d,e);if((g|0)>1){g=c+54|0;i=a+24|0;do{x7b(i,c,d,e);if(b[g>>0]|0)break a;i=i+8|0}while(i>>>0<h>>>0)}}else Q6b(0,c,d,e);while(0);return}function x7b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=f[a+4>>2]|0;g=e>>8;if(!(e&1))h=g;else h=f[(f[c>>2]|0)+g>>2]|0;g=f[a>>2]|0;th[f[(f[g>>2]|0)+28>>2]&511](g,b,c+h|0,e&2|0?d:2);return}function y7b(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=f[a+4>>2]|0;i=h>>8;if(!(h&1))j=i;else j=f[(f[d>>2]|0)+i>>2]|0;i=f[a>>2]|0;Wg[f[(f[i>>2]|0)+20>>2]&127](i,b,c,d+j|0,h&2|0?e:2,g);return}function z7b(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=f[a+4>>2]|0;h=g>>8;if(!(g&1))i=h;else i=f[(f[c>>2]|0)+h>>2]|0;h=f[a>>2]|0;uh[f[(f[h>>2]|0)+24>>2]&255](h,b,c+i|0,g&2|0?d:2,e);return}function A7b(a){a=a|0;f[a>>2]=149568;return}function B7b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+4192|0;h=g+4176|0;i=g;j=g+4112|0;k=(e|0)!=0;if((a|0)!=0?(l=(c|0)!=0,m=(d|0)==0,!(l&m)):0){if(l)n=f[d>>2]|0;else n=0;C7b(i);D7b(j,i);l=j+48|0;o=j+61|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;b[l+12>>0]=0;b[o>>0]=1;l=j+32|0;p=j+36|0;q=f[p>>2]|0;if(q>>>0<(f[j+40>>2]|0)>>>0){E7b(h,i);f[q>>2]=0;f[q+4>>2]=0;r=f[h>>2]|0;f[q+8>>2]=0;f[q+12>>2]=r;f[p>>2]=(f[p>>2]|0)+16}else F7b(l,i);r=j+62|0;b[r>>0]=0;b[j+63>>0]=1;f[h>>2]=0;q=a+(kUb(a)|0)|0;G7b(a,q,j,h);s=f[h>>2]|0;do if(!((s|0)!=0|(b[r>>0]|0)==0)){t=f[l>>2]|0;if((t|0)!=(f[p>>2]|0)?(f[t>>2]|0)!=(f[t+4>>2]|0):0){b[r>>0]=0;b[o>>0]=0;t=f[j>>2]|0;v=j+4|0;while(1){w=f[v>>2]|0;if((w|0)==(t|0))break;x=w+-24|0;f[v>>2]=x;H7b(x)}v=f[j+16>>2]|0;t=j+20|0;while(1){x=f[t>>2]|0;if((x|0)==(v|0))break;w=x+-16|0;f[t>>2]=w;I7b(w)}G7b(a,q,j,h);if(!(b[r>>0]|0)){y=f[h>>2]|0;z=22;break}else{f[h>>2]=-2;A=0;B=-2;break}}else z=23}else{y=s;z=22}while(0);if((z|0)==22)if(!y)z=23;else{A=0;B=y}do if((z|0)==23){y=j+4|0;s=J7b((f[y>>2]|0)+-24|0)|0;r=s+1|0;if(r>>>0>n>>>0){q=QSb(c,r)|0;if(!q){f[h>>2]=-1;A=0;B=-1;break}if(m)C=q;else{f[d>>2]=r;C=q}}else if(!c){A=0;B=0;break}else C=c;q=f[y>>2]|0;r=q+-12|0;a=b[r+11>>0]|0;o=a<<24>>24<0;K7b(q+-24|0,o?f[r>>2]|0:r,o?f[q+-8>>2]|0:a&255)|0;a=(f[y>>2]|0)+-24|0;if((b[a+11>>0]|0)<0)D=f[a>>2]|0;else D=a;Vac(C|0,D|0,s|0)|0;b[C+s>>0]=0;A=C;B=0}while(0);if(k)f[e>>2]=B;L7b(j);M7b(i);E=A}else if(k){f[e>>2]=-3;E=0}else E=0;u=g;return E|0}function C7b(a){a=a|0;f[a+4096>>2]=a;return}function D7b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;yac(d,b);f[a>>2]=0;f[a+4>>2]=0;e=f[d>>2]|0;f[a+8>>2]=0;f[a+12>>2]=e;E7b(d,b);zac(a+16|0,d);Aac(d,b);Bac(a+32|0,d);u=c;return}function E7b(a,b){a=a|0;b=b|0;f[a>>2]=b;return}function F7b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c+20|0;e=c;g=a+4|0;h=((f[g>>2]|0)-(f[a>>2]|0)>>4)+1|0;i=_9b(a)|0;if(i>>>0<h>>>0)c4b(a);else{j=f[a>>2]|0;k=(f[a+8>>2]|0)-j|0;l=k>>3;$9b(e,k>>4>>>0<i>>>1>>>0?(l>>>0<h>>>0?h:l):i,(f[g>>2]|0)-j>>4,a+12|0);j=e+8|0;g=f[j>>2]|0;E7b(d,b);f[g>>2]=0;f[g+4>>2]=0;b=f[d>>2]|0;f[g+8>>2]=0;f[g+12>>2]=b;f[j>>2]=g+16;aac(a,e);bac(e);u=c;return}}function G7b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;a:do if(a>>>0<c>>>0){b:do if((b[a>>0]|0)!=95){if((a8b(a,c,d)|0)!=(c|0)){f[e>>2]=-2;break a}}else{if((c-a|0)<=3){f[e>>2]=-2;break a}g=a+2|0;switch(b[a+1>>0]|0){case 90:{h=Z7b(g,c,d)|0;if(!((h|0)==(g|0)|(h|0)==(c|0))?(b[h>>0]|0)==46:0)i=_7b(h,c,d)|0;else i=h;if((i|0)==(c|0))break b;f[e>>2]=-2;break a;break}case 95:{if((b[g>>0]|0)==95?(b[a+3>>0]|0)==90:0){g=a+4|0;h=Z7b(g,c,d)|0;if(!((h|0)==(g|0)|(h|0)==(c|0))?($7b(h,c,d)|0)==(c|0):0)break b;f[e>>2]=-2;break a}break}default:{}}f[e>>2]=-2;break a}while(0);if((f[e>>2]|0)==0?(f[d>>2]|0)==(f[d+4>>2]|0):0)f[e>>2]=-2}else f[e>>2]=-2;while(0);return}function H7b(a){a=a|0;Y7b(a+12|0);Y7b(a);return}function I7b(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(b|0){c=a+4|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-24|0;f[c>>2]=e;H7b(e)}c=f[a>>2]|0;X7b(a+12|0,c,((f[a+8>>2]|0)-c|0)/24|0)}return}function J7b(a){a=a|0;var c=0,d=0,e=0;c=b[a+11>>0]|0;if(c<<24>>24<0)d=f[a+4>>2]|0;else d=c&255;c=b[a+12+11>>0]|0;if(c<<24>>24<0)e=f[a+16>>2]|0;else e=c&255;return e+d|0}function K7b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j){k=f[a+4>>2]|0;l=(f[a+8>>2]&2147483647)+-1|0}else{k=i&255;l=10}i=k+d|0;if((l-k|0)>>>0>=d>>>0){if(d|0){if(j)m=f[a>>2]|0;else m=a;VWb(m+k|0,c,d)|0;if((b[h>>0]|0)<0)f[a+4>>2]=i;else b[h>>0]=i;b[g>>0]=0;PXb(m+i|0,g)}}else U7b(a,l,i-l|0,k,k,0,d,c);u=e;return a|0}function L7b(a){a=a|0;N7b(a+32|0);O7b(a+16|0);I7b(a);return}function M7b(a){a=a|0;f[a+4096>>2]=0;return}function N7b(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(b|0){c=a+4|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;O7b(e)}c=f[a>>2]|0;T7b(a+12|0,c,(f[a+8>>2]|0)-c>>4)}return}function O7b(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a>>2]|0;if(b|0){c=a+4|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;I7b(e)}c=f[a>>2]|0;P7b(a+12|0,c,(f[a+8>>2]|0)-c>>4)}return}function P7b(a,b,c){a=a|0;b=b|0;c=c|0;Q7b(f[a>>2]|0,b,c<<4);return}function Q7b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if(R7b(a,b)|0){d=b+(S7b(c)|0)|0;c=a+4096|0;if((d|0)==(f[c>>2]|0))f[c>>2]=b}else PSb(b);return}function R7b(a,b){a=a|0;b=b|0;return a>>>0<=b>>>0&(a+4096|0)>>>0>=b>>>0|0}function S7b(a){a=a|0;return a+15&-16|0}function T7b(a,b,c){a=a|0;b=b|0;c=c|0;Q7b(f[a>>2]|0,b,c<<4);return}function U7b(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=u;u=u+16|0;l=k;if((-18-c|0)>>>0<d>>>0)V5b(a);if((b[a+11>>0]|0)<0)m=f[a>>2]|0;else m=a;if(c>>>0<2147483623){n=d+c|0;d=c<<1;o=n>>>0<d>>>0?d:n;p=o>>>0<11?11:o+16&-16}else p=-17;o=V7b(p)|0;if(g|0)VWb(o,m,g)|0;if(i|0)VWb(o+g|0,j,i)|0;j=e-h|0;e=j-g|0;if(e|0)VWb(o+g+i|0,m+g+h|0,e)|0;if((c|0)!=10)W7b(m);f[a>>2]=o;f[a+8>>2]=p|-2147483648;p=j+i|0;f[a+4>>2]=p;b[l>>0]=0;PXb(o+p|0,l);u=k;return}function V7b(a){a=a|0;return OSb(a)|0}function W7b(a){a=a|0;PSb(a);return}function X7b(a,b,c){a=a|0;b=b|0;c=c|0;Q7b(f[a>>2]|0,b,c*24|0);return}function Y7b(a){a=a|0;if((b[a+11>>0]|0)<0)W7b(f[a>>2]|0);return}function Z7b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+12|0;l=e;if((a|0)!=(c|0)){m=d+56|0;sac(h,m);f[m>>2]=(f[m>>2]|0)+1;n=d+61|0;tac(i,n);if((f[m>>2]|0)>>>0>1)b[n>>0]=1;a:do switch(b[a>>0]|0){case 84:case 71:{o=uac(a,c,d)|0;p=1;break}default:{m=z8b(a,c,d)|0;q=f[d+48>>2]|0;r=f[d+52>>2]|0;b:do if((m|0)!=(a|0))if((m|0)!=(c|0)){switch(b[m>>0]|0){case 46:case 69:{s=m;break b;break}default:{}}tac(j,n);b[n>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;t=0;while(1){if((t|0)==3)break;f[k+(t<<2)>>2]=0;t=t+1|0}t=d+4|0;v=f[t>>2]|0;c:do if((f[d>>2]|0)!=(v|0)){w=v+-24|0;x=b[w+11>>0]|0;y=x<<24>>24<0;if(y)z=f[v+-20>>2]|0;else z=x&255;if(z){if(!(b[d+60>>0]|0)){if(y){A=f[w>>2]|0;B=f[v+-20>>2]|0}else{A=w;B=x&255}if((b[A+B+-1>>0]|0)==62){if(y){C=f[v+-20>>2]|0;D=f[w>>2]|0}else{C=x&255;D=w}if((b[D+(C+-2)>>0]|0)!=45){if(y){E=f[v+-20>>2]|0;F=f[w>>2]|0}else{E=x&255;F=w}if((b[F+(E+-2)>>0]|0)!=62){w=a8b(m,c,d)|0;if((w|0)==(m|0)){G=a;H=0;break}x=f[t>>2]|0;y=x;if(((x-(f[d>>2]|0)|0)/24|0)>>>0<2){G=a;H=0;break}x=y+-24|0;f[l>>2]=f[x>>2];f[l+4>>2]=f[x+4>>2];f[l+8>>2]=f[x+8>>2];I=0;while(1){if((I|0)==3)break;f[x+(I<<2)>>2]=0;I=I+1|0}I=y+-12|0;x=k+11|0;if((b[x>>0]|0)<0){J=f[k>>2]|0;b[g>>0]=0;PXb(J,g);f[k+4>>2]=0}else{b[g>>0]=0;PXb(k,g);b[x>>0]=0}F8b(k);f[k>>2]=f[I>>2];f[k+4>>2]=f[I+4>>2];f[k+8>>2]=f[I+8>>2];J=0;while(1){if((J|0)==3)break;f[I+(J<<2)>>2]=0;J=J+1|0}J=b[x>>0]|0;if(!((J<<24>>24<0?f[k+4>>2]|0:J&255)|0))x9b(l,32);J=f[t>>2]|0;I=J+-24|0;y=J;while(1){if((y|0)==(I|0))break;K=y+-24|0;f[t>>2]=K;H7b(K);y=f[t>>2]|0}y=b[l+11>>0]|0;I=y<<24>>24<0;fac(J+-48|0,0,I?f[l>>2]|0:l,I?f[l+4>>2]|0:y&255)|0;Y7b(l);L=w;M=f[t>>2]|0}else{L=m;M=v}}else{L=m;M=v}}else{L=m;M=v}}else{L=m;M=v}x9b(M+-24|0,40);if((L|0)!=(c|0)?(b[L>>0]|0)==118:0){N=L+1|0;O=f[d>>2]|0;P=f[t>>2]|0}else Q=49;do if((Q|0)==49){y=g+11|0;I=g+4|0;x=l+11|0;K=l+4|0;R=1;S=L;d:while(1){T=S;U=f[d>>2]|0;V=f[t>>2]|0;while(1){W=(V-U|0)/24|0;X=a8b(T,c,d)|0;V=f[t>>2]|0;U=f[d>>2]|0;Y=(V-U|0)/24|0;if((X|0)==(T|0)){Q=72;break d}if(Y>>>0>W>>>0)break;else T=X}f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;Z=0;while(1){if((Z|0)==3){_=W;break}f[g+(Z<<2)>>2]=0;Z=Z+1|0}while(1){if(_>>>0>=Y>>>0){$=W;break}Z=b[y>>0]|0;if((Z<<24>>24<0?f[I>>2]|0:Z&255)|0)e8b(g,489325)|0;s8b(l,(f[d>>2]|0)+(_*24|0)|0);Z=b[x>>0]|0;aa=Z<<24>>24<0;K7b(g,aa?f[l>>2]|0:l,aa?f[K>>2]|0:Z&255)|0;Y7b(l);_=_+1|0}while(1){if($>>>0>=Y>>>0)break;Z=f[t>>2]|0;aa=Z+-24|0;ba=Z;while(1){if((ba|0)==(aa|0))break;Z=ba+-24|0;f[t>>2]=Z;H7b(Z);ba=f[t>>2]|0}$=$+1|0}ba=b[y>>0]|0;aa=f[I>>2]|0;if(!((ba<<24>>24<0?aa:ba&255)|0))ca=R;else{Z=f[t>>2]|0;if((f[d>>2]|0)==(Z|0)){Q=84;break}if(R){da=Z;ea=ba;fa=aa}else{e8b(Z+-24|0,489325)|0;da=f[t>>2]|0;ea=b[y>>0]|0;fa=f[I>>2]|0}Z=ea<<24>>24<0;K7b(da+-24|0,Z?f[g>>2]|0:g,Z?fa:ea&255)|0;ca=0}Y7b(g);R=ca;S=X}if((Q|0)==72){N=T;O=U;P=V;break}else if((Q|0)==84){Y7b(g);G=a;H=0;break c}}while(0);if((O|0)!=(P|0)){x9b(P+-24|0,41);if(q&1|0)e8b((f[t>>2]|0)+-24|0,489048)|0;if(q&2|0)e8b((f[t>>2]|0)+-24|0,489055)|0;if(q&4|0)e8b((f[t>>2]|0)+-24|0,489065)|0;switch(r|0){case 1:{e8b((f[t>>2]|0)+-24|0,490529)|0;break}case 2:{e8b((f[t>>2]|0)+-24|0,490532)|0;break}default:{}}w=b[k+11>>0]|0;J=w<<24>>24<0;K7b((f[t>>2]|0)+-24|0,J?f[k>>2]|0:k,J?f[k+4>>2]|0:w&255)|0;G=N;H=1}else{G=a;H=0}}else{G=a;H=0}}else{G=a;H=0}while(0);Y7b(k);vac(j);if(H)s=G;else{o=G;p=0;break a}}else s=c;else s=a;while(0);o=s;p=1}}while(0);vac(i);wac(h);if(p){ga=o;Q=88}else ha=a}else{ga=a;Q=88}if((Q|0)==88)ha=ga;u=e;return ha|0}function _7b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(((a|0)!=(c|0)?(b[a>>0]|0)==46:0)?(k=d+4|0,(f[d>>2]|0)!=(f[k>>2]|0)):0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=c-a|0;if(d>>>0>4294967279)V5b(j);if(d>>>0<11){b[j+11>>0]=d;l=j}else{m=d+16&-16;n=V7b(m)|0;f[j>>2]=n;f[j+8>>2]=m|-2147483648;f[j+4>>2]=d;l=n}n=a;m=l;while(1){if((n|0)==(c|0))break;PXb(m,n);n=n+1|0;m=m+1|0}b[g>>0]=0;PXb(l+d|0,g);d8b(j,0,489098)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];g=0;while(1){if((g|0)==3)break;f[j+(g<<2)>>2]=0;g=g+1|0}e8b(i,489101)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];g=0;while(1){if((g|0)==3)break;f[i+(g<<2)>>2]=0;g=g+1|0}g=b[h+11>>0]|0;d=g<<24>>24<0;K7b((f[k>>2]|0)+-24|0,d?f[h>>2]|0:h,d?f[h+4>>2]|0:g&255)|0;Y7b(h);Y7b(i);Y7b(j);o=c}else o=a;u=e;return o|0}function $7b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;a:do if((c-a|0)>12){e=0;g=a;while(1){h=g+1|0;if((e|0)>=13)break;if((b[g>>0]|0)==(b[490734+e>>0]|0)){e=e+1|0;g=h}else{i=a;break a}}b:do if((g|0)==(c|0))j=c;else{if((b[g>>0]|0)==95){if((h|0)==(c|0)){i=a;break a}if(((b[h>>0]|0)+-48|0)>>>0>=10){i=a;break a}k=g+2|0}else k=g;while(1){if((k|0)==(c|0)){j=c;break b}if(((b[k>>0]|0)+-48|0)>>>0>=10){j=k;break b}k=k+1|0}}while(0);g=f[d+4>>2]|0;if((f[d>>2]|0)!=(g|0)){d8b(g+-24|0,0,490748)|0;i=j}else i=a}else i=a;while(0);return i|0}function a8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=u;u=u+144|0;g=e+128|0;h=e+104|0;i=e+40|0;j=e+88|0;k=e+24|0;l=e+76|0;m=e+12|0;n=e;o=e+64|0;a:do if((a|0)!=(c|0)){p=d+16|0;switch(b[a>>0]|0){case 75:case 86:case 114:{f[g>>2]=0;q=b8b(a,c,g)|0;b:do if((q|0)!=(a|0)?(r=(b[q>>0]|0)==70,s=d+4|0,t=((f[s>>2]|0)-(f[d>>2]|0)|0)/24|0,v=a8b(q,c,d)|0,w=((f[s>>2]|0)-(f[d>>2]|0)|0)/24|0,(v|0)!=(q|0)):0){s=d+20|0;x=f[s>>2]|0;c:do if(r){y=x+-16|0;z=x;while(1){if((z|0)==(y|0)){A=y;break c}B=z+-16|0;f[s>>2]=B;I7b(B);z=f[s>>2]|0}}else A=x;while(0);f[h>>2]=f[d+12>>2];if(A>>>0<(f[d+24>>2]|0)>>>0){f[A>>2]=0;f[A+4>>2]=0;x=f[h>>2]|0;f[A+8>>2]=0;f[A+12>>2]=x;f[s>>2]=(f[s>>2]|0)+16}else c8b(p,h);x=f[g>>2]|0;z=(x&1|0)==0;y=(x&2|0)==0;B=(x&4|0)==0;x=t;while(1){if(x>>>0>=w>>>0){C=v;break b}if(r){D=f[d>>2]|0;E=D+(x*24|0)+12|0;F=b[E+11>>0]|0;G=F<<24>>24<0;if(G){H=f[D+(x*24|0)+16>>2]|0;I=f[E>>2]|0}else{H=F&255;I=E}J=H+-2|0;if((b[I+J>>0]|0)==38)K=H+-3|0;else{if(G){L=f[E>>2]|0;M=f[D+(x*24|0)+16>>2]|0}else{L=E;M=F&255}K=(b[L+M+-1>>0]|0)==38?J:H}if(z)N=K;else{d8b(E,K,489048)|0;N=K+6|0}if(y)O=N;else{d8b((f[d>>2]|0)+(x*24|0)+12|0,N,489055)|0;O=N+9|0}if(!B)d8b((f[d>>2]|0)+(x*24|0)+12|0,O,489065)|0}else{if(!z)e8b((f[d>>2]|0)+(x*24|0)|0,489048)|0;if(!y)e8b((f[d>>2]|0)+(x*24|0)|0,489055)|0;if(!B)e8b((f[d>>2]|0)+(x*24|0)|0,489065)|0}E=f[s>>2]|0;J=(f[d>>2]|0)+(x*24|0)|0;F=E+-12|0;D=f[F>>2]|0;if((D|0)==(f[E+-8>>2]|0))g8b(E+-16|0,J);else{f8b(D,J);f[F>>2]=(f[F>>2]|0)+24}x=x+1|0}}else C=a;while(0);P=C;break a;break}default:{}}q=h8b(a,c,d)|0;if((q|0)==(a|0)){x=a+1|0;s=(x|0)!=(c|0);d:do switch(b[a>>0]|0){case 65:{B=i8b(a,c,d)|0;if((B|0)==(a|0)){P=a;break a}y=f[d+4>>2]|0;if((f[d>>2]|0)==(y|0)){P=a;break a}f[h>>2]=f[d+12>>2];j8b(g,y+-24|0,h);y=d+20|0;z=f[y>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;r=z+4|0;f[r>>2]=0;v=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=v;f[z>>2]=f[g>>2];v=g+4|0;f[r>>2]=f[v>>2];r=g+8|0;f[z+8>>2]=f[r>>2];f[r>>2]=0;f[v>>2]=0;f[g>>2]=0;f[y>>2]=(f[y>>2]|0)+16}else k8b(p,g);I7b(g);P=B;break a;break}case 67:{B=a8b(x,c,d)|0;if((B|0)==(x|0)){P=a;break a}y=d+4|0;v=f[y>>2]|0;if((f[d>>2]|0)==(v|0)){P=a;break a}e8b(v+-24|0,489075)|0;v=(f[y>>2]|0)+-24|0;f[h>>2]=f[d+12>>2];j8b(g,v,h);v=d+20|0;y=f[v>>2]|0;if(y>>>0<(f[d+24>>2]|0)>>>0){f[y>>2]=0;r=y+4|0;f[r>>2]=0;z=f[g+12>>2]|0;f[y+8>>2]=0;f[y+12>>2]=z;f[y>>2]=f[g>>2];z=g+4|0;f[r>>2]=f[z>>2];r=g+8|0;f[y+8>>2]=f[r>>2];f[r>>2]=0;f[z>>2]=0;f[g>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else k8b(p,g);I7b(g);P=B;break a;break}case 70:{B=l8b(a,c,d)|0;if((B|0)==(a|0)){P=a;break a}v=f[d+4>>2]|0;if((f[d>>2]|0)==(v|0)){P=a;break a}f[h>>2]=f[d+12>>2];j8b(g,v+-24|0,h);v=d+20|0;z=f[v>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;r=z+4|0;f[r>>2]=0;y=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=y;f[z>>2]=f[g>>2];y=g+4|0;f[r>>2]=f[y>>2];r=g+8|0;f[z+8>>2]=f[r>>2];f[r>>2]=0;f[y>>2]=0;f[g>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else k8b(p,g);I7b(g);P=B;break a;break}case 71:{B=a8b(x,c,d)|0;if((B|0)==(x|0)){P=a;break a}v=d+4|0;y=f[v>>2]|0;if((f[d>>2]|0)==(y|0)){P=a;break a}e8b(y+-24|0,489084)|0;y=(f[v>>2]|0)+-24|0;f[h>>2]=f[d+12>>2];j8b(g,y,h);y=d+20|0;v=f[y>>2]|0;if(v>>>0<(f[d+24>>2]|0)>>>0){f[v>>2]=0;r=v+4|0;f[r>>2]=0;z=f[g+12>>2]|0;f[v+8>>2]=0;f[v+12>>2]=z;f[v>>2]=f[g>>2];z=g+4|0;f[r>>2]=f[z>>2];r=g+8|0;f[v+8>>2]=f[r>>2];f[r>>2]=0;f[z>>2]=0;f[g>>2]=0;f[y>>2]=(f[y>>2]|0)+16}else k8b(p,g);I7b(g);P=B;break a;break}case 77:{B=m8b(a,c,d)|0;if((B|0)==(a|0)){P=a;break a}y=f[d+4>>2]|0;if((f[d>>2]|0)==(y|0)){P=a;break a}f[h>>2]=f[d+12>>2];j8b(g,y+-24|0,h);y=d+20|0;z=f[y>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;r=z+4|0;f[r>>2]=0;v=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=v;f[z>>2]=f[g>>2];v=g+4|0;f[r>>2]=f[v>>2];r=g+8|0;f[z+8>>2]=f[r>>2];f[r>>2]=0;f[v>>2]=0;f[g>>2]=0;f[y>>2]=(f[y>>2]|0)+16}else k8b(p,g);I7b(g);P=B;break a;break}case 79:{B=d+4|0;y=((f[B>>2]|0)-(f[d>>2]|0)|0)/24|0;v=a8b(x,c,d)|0;r=((f[B>>2]|0)-(f[d>>2]|0)|0)/24|0;if((v|0)==(x|0)){P=a;break a}B=f[d+12>>2]|0;f[g>>2]=B;z=d+20|0;w=f[z>>2]|0;if(w>>>0<(f[d+24>>2]|0)>>>0){f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=B;f[z>>2]=(f[z>>2]|0)+16}else c8b(p,g);B=g+11|0;w=g+4|0;t=y;while(1){if(t>>>0>=r>>>0){P=v;break a}n8b(g,(f[d>>2]|0)+(t*24|0)+12|0,2);y=OXb(489095)|0;F=b[B>>0]|0;if((y|0)==((F<<24>>24<0?f[w>>2]|0:F&255)|0))Q=(o8b(g,489095,y)|0)==0;else Q=0;Y7b(g);y=f[d>>2]|0;if(!Q){F=y+(t*24|0)+12|0;if((b[F+11>>0]|0)<0)R=f[F>>2]|0;else R=F;if((b[R>>0]|0)==40){e8b(y+(t*24|0)|0,489103)|0;d8b((f[d>>2]|0)+(t*24|0)+12|0,0,489101)|0}}else{e8b(y+(t*24|0)|0,489098)|0;d8b((f[d>>2]|0)+(t*24|0)+12|0,0,489101)|0}e8b((f[d>>2]|0)+(t*24|0)|0,489105)|0;y=f[z>>2]|0;F=(f[d>>2]|0)+(t*24|0)|0;J=y+-12|0;D=f[J>>2]|0;if((D|0)==(f[y+-8>>2]|0))g8b(y+-16|0,F);else{f8b(D,F);f[J>>2]=(f[J>>2]|0)+24}t=t+1|0}break}case 80:{t=d+4|0;z=((f[t>>2]|0)-(f[d>>2]|0)|0)/24|0;w=a8b(x,c,d)|0;B=((f[t>>2]|0)-(f[d>>2]|0)|0)/24|0;if((w|0)==(x|0)){P=a;break a}t=f[d+12>>2]|0;f[g>>2]=t;v=d+20|0;r=f[v>>2]|0;if(r>>>0<(f[d+24>>2]|0)>>>0){f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=t;f[v>>2]=(f[v>>2]|0)+16}else c8b(p,g);t=g+11|0;r=g+4|0;J=g+11|0;F=g+4|0;D=z;while(1){if(D>>>0>=B>>>0){P=w;break a}n8b(g,(f[d>>2]|0)+(D*24|0)+12|0,2);z=OXb(489095)|0;y=b[t>>0]|0;if((z|0)==((y<<24>>24<0?f[r>>2]|0:y&255)|0))S=(o8b(g,489095,z)|0)==0;else S=0;Y7b(g);z=f[d>>2]|0;if(!S){y=z+(D*24|0)+12|0;if((b[y+11>>0]|0)<0)T=f[y>>2]|0;else T=y;if((b[T>>0]|0)==40){e8b(z+(D*24|0)|0,489103)|0;d8b((f[d>>2]|0)+(D*24|0)+12|0,0,489101)|0}}else{e8b(z+(D*24|0)|0,489098)|0;d8b((f[d>>2]|0)+(D*24|0)+12|0,0,489101)|0}if((b[x>>0]|0)==85){n8b(g,(f[d>>2]|0)+(D*24|0)|0,12);z=OXb(489108)|0;y=b[J>>0]|0;if((z|0)==((y<<24>>24<0?f[F>>2]|0:y&255)|0))U=(o8b(g,489108,z)|0)!=0;else U=1;Y7b(g);z=(f[d>>2]|0)+(D*24|0)|0;if(U){V=z;W=112}else p8b(z)}else{V=(f[d>>2]|0)+(D*24|0)|0;W=112}if((W|0)==112){W=0;e8b(V,489121)|0}z=f[v>>2]|0;y=(f[d>>2]|0)+(D*24|0)|0;E=z+-12|0;G=f[E>>2]|0;if((G|0)==(f[z+-8>>2]|0))g8b(z+-16|0,y);else{f8b(G,y);f[E>>2]=(f[E>>2]|0)+24}D=D+1|0}break}case 82:{D=d+4|0;v=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;F=a8b(x,c,d)|0;J=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;if((F|0)==(x|0)){P=a;break a}D=f[d+12>>2]|0;f[g>>2]=D;r=d+20|0;t=f[r>>2]|0;if(t>>>0<(f[d+24>>2]|0)>>>0){f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=D;f[r>>2]=(f[r>>2]|0)+16}else c8b(p,g);D=g+11|0;t=g+4|0;w=v;while(1){if(w>>>0>=J>>>0){P=F;break a}n8b(g,(f[d>>2]|0)+(w*24|0)+12|0,2);v=OXb(489095)|0;B=b[D>>0]|0;if((v|0)==((B<<24>>24<0?f[t>>2]|0:B&255)|0))X=(o8b(g,489095,v)|0)==0;else X=0;Y7b(g);v=f[d>>2]|0;if(!X){B=v+(w*24|0)+12|0;if((b[B+11>>0]|0)<0)Y=f[B>>2]|0;else Y=B;if((b[Y>>0]|0)==40){e8b(v+(w*24|0)|0,489103)|0;d8b((f[d>>2]|0)+(w*24|0)+12|0,0,489101)|0}}else{e8b(v+(w*24|0)|0,489098)|0;d8b((f[d>>2]|0)+(w*24|0)+12|0,0,489101)|0}e8b((f[d>>2]|0)+(w*24|0)|0,489123)|0;v=f[r>>2]|0;B=(f[d>>2]|0)+(w*24|0)|0;E=v+-12|0;y=f[E>>2]|0;if((y|0)==(f[v+-8>>2]|0))g8b(v+-16|0,B);else{f8b(y,B);f[E>>2]=(f[E>>2]|0)+24}w=w+1|0}break}case 84:{w=d+4|0;r=((f[w>>2]|0)-(f[d>>2]|0)|0)/24|0;t=q8b(a,c,d)|0;D=((f[w>>2]|0)-(f[d>>2]|0)|0)/24|0;if((t|0)==(a|0)){P=a;break a}F=d+12|0;J=f[F>>2]|0;f[g>>2]=J;E=d+20|0;B=f[E>>2]|0;y=d+24|0;if(B>>>0<(f[y>>2]|0)>>>0){f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=J;f[E>>2]=(f[E>>2]|0)+16}else c8b(p,g);J=r;while(1){if(J>>>0>=D>>>0)break;B=f[E>>2]|0;v=(f[d>>2]|0)+(J*24|0)|0;G=B+-12|0;z=f[G>>2]|0;if((z|0)==(f[B+-8>>2]|0))g8b(B+-16|0,v);else{f8b(z,v);f[G>>2]=(f[G>>2]|0)+24}J=J+1|0}if(!((D|0)==(r+1|0)&(b[d+63>>0]|0)!=0)){P=t;break a}J=r8b(t,c,d)|0;if((J|0)==(t|0)){P=t;break a}s8b(g,(f[w>>2]|0)+-24|0);G=f[w>>2]|0;v=G+-24|0;z=G;while(1){if((z|0)==(v|0))break;B=z+-24|0;f[w>>2]=B;H7b(B);z=f[w>>2]|0}z=b[g+11>>0]|0;v=z<<24>>24<0;K7b(G+-48|0,v?f[g>>2]|0:g,v?f[g+4>>2]|0:z&255)|0;z=(f[w>>2]|0)+-24|0;f[i>>2]=f[F>>2];j8b(h,z,i);z=f[E>>2]|0;if(z>>>0<(f[y>>2]|0)>>>0){f[z>>2]=0;v=z+4|0;f[v>>2]=0;t=f[h+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=t;f[z>>2]=f[h>>2];t=h+4|0;f[v>>2]=f[t>>2];v=h+8|0;f[z+8>>2]=f[v>>2];f[v>>2]=0;f[t>>2]=0;f[h>>2]=0;f[E>>2]=(f[E>>2]|0)+16}else k8b(p,h);I7b(h);Y7b(g);P=J;break a;break}case 85:{if(!s){P=a;break a}t=t8b(x,c,d)|0;if((t|0)==(x|0)){P=a;break a}v=a8b(t,c,d)|0;if((v|0)==(t|0)){P=a;break a}t=d+4|0;z=f[t>>2]|0;if(((z-(f[d>>2]|0)|0)/24|0)>>>0<2){P=a;break a}s8b(g,z+-24|0);z=f[t>>2]|0;r=z+-24|0;D=z;while(1){if((D|0)==(r|0))break;B=D+-24|0;f[t>>2]=B;H7b(B);D=f[t>>2]|0}n8b(h,z+-48|0,9);D=OXb(489125)|0;r=b[h+11>>0]|0;if((D|0)==((r<<24>>24<0?f[h+4>>2]|0:r&255)|0)){r=(o8b(h,489125,D)|0)==0;Y7b(h);if(r){s8b(h,(f[t>>2]|0)+-24|0);r=f[t>>2]|0;D=r+-24|0;J=r;while(1){if((J|0)==(D|0))break;r=J+-24|0;f[t>>2]=r;H7b(r);J=f[t>>2]|0}J=h+11|0;D=b[J>>0]|0;z=D<<24>>24<0;r=f[h>>2]|0;E=t8b(z?r+9|0:h+9|0,(z?r:h)+(z?f[h+4>>2]|0:D&255)|0,d)|0;if((E|0)==(((b[J>>0]|0)<0?f[h>>2]|0:h)+9|0)){u8b(k,g,489135);E=b[J>>0]|0;J=E<<24>>24<0;K7b(k,J?f[h>>2]|0:h,J?f[h+4>>2]|0:E&255)|0;f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[o+8>>2]=f[k+8>>2];E=0;while(1){if((E|0)==3)break;f[k+(E<<2)>>2]=0;E=E+1|0}v8b(i,o);E=f[t>>2]|0;if(E>>>0<(f[d+8>>2]|0)>>>0){x8b(E,i);f[t>>2]=(f[t>>2]|0)+24}else y8b(d,i);H7b(i);Y7b(o);Y7b(k)}else{u8b(m,g,489137);s8b(n,(f[t>>2]|0)+-24|0);E=b[n+11>>0]|0;J=E<<24>>24<0;K7b(m,J?f[n>>2]|0:n,J?f[n+4>>2]|0:E&255)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];E=0;while(1){if((E|0)==3)break;f[m+(E<<2)>>2]=0;E=E+1|0}e8b(k,489139)|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];f[l+8>>2]=f[k+8>>2];E=0;while(1){if((E|0)==3)break;f[k+(E<<2)>>2]=0;E=E+1|0}v8b(i,l);w8b((f[t>>2]|0)+-24|0,i);H7b(i);Y7b(l);Y7b(k);Y7b(n);Y7b(m)}Y7b(h)}else W=166}else{Y7b(h);W=166}if((W|0)==166){u8b(i,g,489135);s8b(k,(f[t>>2]|0)+-24|0);E=b[k+11>>0]|0;J=E<<24>>24<0;K7b(i,J?f[k>>2]|0:k,J?f[k+4>>2]|0:E&255)|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];f[j+8>>2]=f[i+8>>2];E=0;while(1){if((E|0)==3)break;f[i+(E<<2)>>2]=0;E=E+1|0}v8b(h,j);w8b((f[t>>2]|0)+-24|0,h);H7b(h);Y7b(j);Y7b(k);Y7b(i)}E=(f[t>>2]|0)+-24|0;f[i>>2]=f[d+12>>2];j8b(h,E,i);E=d+20|0;J=f[E>>2]|0;if(J>>>0<(f[d+24>>2]|0)>>>0){f[J>>2]=0;D=J+4|0;f[D>>2]=0;z=f[h+12>>2]|0;f[J+8>>2]=0;f[J+12>>2]=z;f[J>>2]=f[h>>2];z=h+4|0;f[D>>2]=f[z>>2];D=h+8|0;f[J+8>>2]=f[D>>2];f[D>>2]=0;f[z>>2]=0;f[h>>2]=0;f[E>>2]=(f[E>>2]|0)+16}else k8b(p,h);I7b(h);Y7b(g);P=v;break a;break}case 83:{if(s?(b[x>>0]|0)==116:0){E=z8b(a,c,d)|0;if((E|0)==(a|0)){P=a;break a}z=f[d+4>>2]|0;if((f[d>>2]|0)==(z|0)){P=a;break a}f[h>>2]=f[d+12>>2];j8b(g,z+-24|0,h);z=d+20|0;D=f[z>>2]|0;if(D>>>0<(f[d+24>>2]|0)>>>0){f[D>>2]=0;J=D+4|0;f[J>>2]=0;r=f[g+12>>2]|0;f[D+8>>2]=0;f[D+12>>2]=r;f[D>>2]=f[g>>2];r=g+4|0;f[J>>2]=f[r>>2];J=g+8|0;f[D+8>>2]=f[J>>2];f[J>>2]=0;f[r>>2]=0;f[g>>2]=0;f[z>>2]=(f[z>>2]|0)+16}else k8b(p,g);I7b(g);P=E;break a}E=A8b(a,c,d)|0;if((E|0)==(a|0)){P=a;break a}z=r8b(E,c,d)|0;if((z|0)==(E|0)){P=E;break a}r=d+4|0;J=f[r>>2]|0;if(((J-(f[d>>2]|0)|0)/24|0)>>>0<2){P=E;break a}s8b(g,J+-24|0);J=f[r>>2]|0;E=J+-24|0;D=J;while(1){if((D|0)==(E|0))break;y=D+-24|0;f[r>>2]=y;H7b(y);D=f[r>>2]|0}D=b[g+11>>0]|0;E=D<<24>>24<0;K7b(J+-48|0,E?f[g>>2]|0:g,E?f[g+4>>2]|0:D&255)|0;D=(f[r>>2]|0)+-24|0;f[i>>2]=f[d+12>>2];j8b(h,D,i);D=d+20|0;E=f[D>>2]|0;if(E>>>0<(f[d+24>>2]|0)>>>0){f[E>>2]=0;v=E+4|0;f[v>>2]=0;t=f[h+12>>2]|0;f[E+8>>2]=0;f[E+12>>2]=t;f[E>>2]=f[h>>2];t=h+4|0;f[v>>2]=f[t>>2];v=h+8|0;f[E+8>>2]=f[v>>2];f[v>>2]=0;f[t>>2]=0;f[h>>2]=0;f[D>>2]=(f[D>>2]|0)+16}else k8b(p,h);I7b(h);Y7b(g);P=z;break a;break}case 68:{if(s)switch(b[x>>0]|0){case 112:{D=d+4|0;t=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;v=a+2|0;E=a8b(v,c,d)|0;y=((f[D>>2]|0)-(f[d>>2]|0)|0)/24|0;if((E|0)==(v|0))break d;v=f[d+12>>2]|0;f[g>>2]=v;D=d+20|0;F=f[D>>2]|0;if(F>>>0<(f[d+24>>2]|0)>>>0){f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=v;f[D>>2]=(f[D>>2]|0)+16}else c8b(p,g);v=t;while(1){if(v>>>0>=y>>>0){P=E;break a}t=f[D>>2]|0;F=(f[d>>2]|0)+(v*24|0)|0;w=t+-12|0;G=f[w>>2]|0;if((G|0)==(f[t+-8>>2]|0))g8b(t+-16|0,F);else{f8b(G,F);f[w>>2]=(f[w>>2]|0)+24}v=v+1|0}break}case 84:case 116:{v=B8b(a,c,d)|0;if((v|0)==(a|0))break d;D=f[d+4>>2]|0;if((f[d>>2]|0)==(D|0)){P=a;break a}f[h>>2]=f[d+12>>2];j8b(g,D+-24|0,h);D=d+20|0;E=f[D>>2]|0;if(E>>>0<(f[d+24>>2]|0)>>>0){f[E>>2]=0;y=E+4|0;f[y>>2]=0;z=f[g+12>>2]|0;f[E+8>>2]=0;f[E+12>>2]=z;f[E>>2]=f[g>>2];z=g+4|0;f[y>>2]=f[z>>2];y=g+8|0;f[E+8>>2]=f[y>>2];f[y>>2]=0;f[z>>2]=0;f[g>>2]=0;f[D>>2]=(f[D>>2]|0)+16}else k8b(p,g);I7b(g);P=v;break a;break}case 118:{v=C8b(a,c,d)|0;if((v|0)==(a|0))break d;D=f[d+4>>2]|0;if((f[d>>2]|0)==(D|0)){P=a;break a}f[h>>2]=f[d+12>>2];j8b(g,D+-24|0,h);D=d+20|0;z=f[D>>2]|0;if(z>>>0<(f[d+24>>2]|0)>>>0){f[z>>2]=0;y=z+4|0;f[y>>2]=0;E=f[g+12>>2]|0;f[z+8>>2]=0;f[z+12>>2]=E;f[z>>2]=f[g>>2];E=g+4|0;f[y>>2]=f[E>>2];y=g+8|0;f[z+8>>2]=f[y>>2];f[y>>2]=0;f[E>>2]=0;f[g>>2]=0;f[D>>2]=(f[D>>2]|0)+16}else k8b(p,g);I7b(g);P=v;break a;break}default:break d}break}default:{}}while(0);x=h8b(a,c,d)|0;if((x|0)==(a|0)){s=z8b(a,c,d)|0;if((s|0)!=(a|0)?(v=f[d+4>>2]|0,(f[d>>2]|0)!=(v|0)):0){f[h>>2]=f[d+12>>2];j8b(g,v+-24|0,h);v=d+20|0;D=f[v>>2]|0;if(D>>>0<(f[d+24>>2]|0)>>>0){f[D>>2]=0;E=D+4|0;f[E>>2]=0;y=f[g+12>>2]|0;f[D+8>>2]=0;f[D+12>>2]=y;f[D>>2]=f[g>>2];y=g+4|0;f[E>>2]=f[y>>2];E=g+8|0;f[D+8>>2]=f[E>>2];f[E>>2]=0;f[y>>2]=0;f[g>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else k8b(p,g);I7b(g);P=s}else P=a}else P=x}else P=q}else P=a;while(0);u=e;return P|0}function b8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f[d>>2]=0;if((a|0)!=(c|0)){c=b[a>>0]|0;if(c<<24>>24==114){f[d>>2]=4;e=a+1|0;g=e;h=4;i=b[e>>0]|0}else{g=a;h=0;i=c}if(i<<24>>24==86){c=h|2;f[d>>2]=c;e=g+1|0;j=e;k=b[e>>0]|0;l=c}else{j=g;k=i;l=h}if(k<<24>>24==75){f[d>>2]=l|1;m=j+1|0}else m=j}else m=a;return m|0}function c8b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=((f[e>>2]|0)-(f[a>>2]|0)>>4)+1|0;h=gac(a)|0;if(h>>>0<g>>>0)c4b(a);else{i=f[a>>2]|0;j=(f[a+8>>2]|0)-i|0;k=j>>3;hac(d,j>>4>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,(f[e>>2]|0)-i>>4,a+12|0);i=d+8|0;e=f[i>>2]|0;f[e>>2]=0;f[e+4>>2]=0;h=f[b>>2]|0;f[e+8>>2]=0;f[e+12>>2]=h;f[i>>2]=e+16;iac(a,d);jac(d);u=c;return}}function d8b(a,b,c){a=a|0;b=b|0;c=c|0;return fac(a,b,c,OXb(c)|0)|0}function e8b(a,b){a=a|0;b=b|0;return K7b(a,b,OXb(b)|0)|0}function f8b(a,b){a=a|0;b=b|0;B9b(a,b);B9b(a+12|0,b+12|0);return}function g8b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=(((f[e>>2]|0)-(f[a>>2]|0)|0)/24|0)+1|0;h=F9b(a)|0;if(h>>>0<g>>>0)c4b(a);else{i=f[a>>2]|0;j=((f[a+8>>2]|0)-i|0)/24|0;k=j<<1;G9b(d,j>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,((f[e>>2]|0)-i|0)/24|0,a+12|0);i=d+8|0;e=f[i>>2]|0;f8b(e,b);f[i>>2]=e+24;H9b(a,d);I9b(d);u=c;return}}function h8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e;a:do if((a|0)==(c|0))h=a;else{i=a+1|0;do switch(b[a>>0]|0){case 118:{M9b(g,490540);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 119:{nac(g);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 98:{M9b(g,490545);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 99:{M9b(g,490314);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 97:{t9b(g,490319);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 104:{Q9b(g,490331);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 115:{d9b(g,490345);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 116:{u9b(g,490351);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 105:{oac(g,490550);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 106:{v9b(g,490554);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 108:{M9b(g,490567);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 109:{Q9b(g,490572);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 120:{q9b(g,490586);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 121:{pac(g);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 110:{qac(g,490380);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 111:{r9b(g,490389);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 102:{d9b(g,490596);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 100:{rac(g);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 101:{t9b(g,490602);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 103:{p9b(g,490614);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 122:{oac(g,490625);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);h=i;break a;break}case 117:{j=t8b(i,c,d)|0;h=(j|0)==(i|0)?a:j;break a;break}case 68:{if((i|0)==(c|0)){h=a;break a}j=a+2|0;switch(b[i>>0]|0){case 100:{q9b(g,490629);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);h=j;break a;break}case 101:{p9b(g,490639);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);h=j;break a;break}case 102:{q9b(g,490650);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);h=j;break a;break}case 104:{q9b(g,490660);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);h=j;break a;break}case 105:{qac(g,490670);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);h=j;break a;break}case 115:{qac(g,490679);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);h=j;break a;break}case 97:{M9b(g,490688);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);h=j;break a;break}case 110:{u9b(g,490693);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);h=j;break a;break}default:{h=a;break a}}break}default:{h=a;break a}}while(0)}while(0);u=e;return h|0}function i8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+112|0;g=e+96|0;h=e+72|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;do if(((a|0)!=(c|0)?(b[a>>0]|0)==65:0)?(n=a+1|0,(n|0)!=(c|0)):0){o=b[n>>0]|0;if(o<<24>>24==95){p=a+2|0;q=a8b(p,c,d)|0;if((q|0)==(p|0)){r=a;break}p=d+4|0;s=f[p>>2]|0;if((f[d>>2]|0)==(s|0)){r=a;break}n8b(g,s+-12|0,2);s=OXb(489095)|0;t=b[g+11>>0]|0;if((s|0)==((t<<24>>24<0?f[g+4>>2]|0:t&255)|0)){t=(o8b(g,489095,s)|0)==0;Y7b(g);if(t)mac((f[p>>2]|0)+-12|0)}else Y7b(g);d8b((f[p>>2]|0)+-12|0,0,490536)|0;r=q;break}if((o+-49&255)<9){o=D8b(n,c)|0;if((o|0)==(c|0)){r=a;break}if((b[o>>0]|0)!=95){r=a;break}q=o+1|0;p=a8b(q,c,d)|0;if((p|0)==(q|0)){r=a;break}q=d+4|0;t=f[q>>2]|0;if((f[d>>2]|0)==(t|0)){r=a;break}n8b(g,t+-12|0,2);t=OXb(489095)|0;s=b[g+11>>0]|0;if((t|0)==((s<<24>>24<0?f[g+4>>2]|0:s&255)|0)){s=(o8b(g,489095,t)|0)==0;Y7b(g);if(s)mac((f[q>>2]|0)+-12|0)}else Y7b(g);s=(f[q>>2]|0)+-12|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;q=o-n|0;if(q>>>0>4294967279)V5b(j);if(q>>>0<11){b[j+11>>0]=q;v=j}else{t=q+16&-16;w=V7b(t)|0;f[j>>2]=w;f[j+8>>2]=t|-2147483648;f[j+4>>2]=q;v=w}w=n;t=v;while(1){if((w|0)==(o|0))break;PXb(t,w);w=w+1|0;t=t+1|0}b[g>>0]=0;PXb(v+q|0,g);d8b(j,0,489095)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];t=0;while(1){if((t|0)==3)break;f[j+(t<<2)>>2]=0;t=t+1|0}e8b(i,489150)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];t=0;while(1){if((t|0)==3)break;f[i+(t<<2)>>2]=0;t=t+1|0}t=b[h+11>>0]|0;q=t<<24>>24<0;fac(s,0,q?f[h>>2]|0:h,q?f[h+4>>2]|0:t&255)|0;Y7b(h);Y7b(i);Y7b(j);r=p;break}t=E8b(n,c,d)|0;if(((!((t|0)==(n|0)|(t|0)==(c|0))?(b[t>>0]|0)==95:0)?(q=t+1|0,t=a8b(q,c,d)|0,(t|0)!=(q|0)):0)?(q=d+4|0,w=f[q>>2]|0,((w-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){x8b(h,w+-24|0);w=f[q>>2]|0;o=w+-24|0;x=w;while(1){if((x|0)==(o|0))break;y=x+-24|0;f[q>>2]=y;H7b(y);x=f[q>>2]|0}x8b(i,w+-48|0);x=f[q>>2]|0;o=x+-24|0;n=o+11|0;if((b[n>>0]|0)<0){p=f[o>>2]|0;b[g>>0]=0;PXb(p,g);f[x+-20>>2]=0}else{b[g>>0]=0;PXb(o,g);b[n>>0]=0}F8b(o);f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];f[o+8>>2]=f[h+8>>2];o=0;while(1){if((o|0)==3)break;f[h+(o<<2)>>2]=0;o=o+1|0}o=h+12|0;n8b(g,o,2);w=OXb(489095)|0;n=b[g+11>>0]|0;if((w|0)==((n<<24>>24<0?f[g+4>>2]|0:n&255)|0)){n=(o8b(g,489095,w)|0)==0;Y7b(g);if(n)mac(o)}else Y7b(g);s8b(m,i);d8b(m,0,489095)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];n=0;while(1){if((n|0)==3)break;f[m+(n<<2)>>2]=0;n=n+1|0}e8b(l,489150)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];n=0;while(1){if((n|0)==3)break;f[l+(n<<2)>>2]=0;n=n+1|0}n=b[o+11>>0]|0;w=n<<24>>24<0;K7b(k,w?f[o>>2]|0:o,w?f[h+16>>2]|0:n&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];n=0;while(1){if((n|0)==3)break;f[k+(n<<2)>>2]=0;n=n+1|0}n=f[q>>2]|0;o=n+-12|0;w=o+11|0;if((b[w>>0]|0)<0){x=f[o>>2]|0;b[g>>0]=0;PXb(x,g);f[n+-8>>2]=0}else{b[g>>0]=0;PXb(o,g);b[w>>0]=0}F8b(o);f[o>>2]=f[j>>2];f[o+4>>2]=f[j+4>>2];f[o+8>>2]=f[j+8>>2];o=0;while(1){if((o|0)==3)break;f[j+(o<<2)>>2]=0;o=o+1|0}Y7b(j);Y7b(k);Y7b(l);Y7b(m);H7b(i);H7b(h);r=t}else r=a}else r=a;while(0);u=e;return r|0}function j8b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;f[a>>2]=0;d=a+4|0;f[d>>2]=0;e=f[c>>2]|0;f[a+8>>2]=0;f[a+12>>2]=e;lac(a);f8b(f[d>>2]|0,b);f[d>>2]=(f[d>>2]|0)+24;return}function k8b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=((f[e>>2]|0)-(f[a>>2]|0)>>4)+1|0;h=gac(a)|0;if(h>>>0<g>>>0)c4b(a);else{i=f[a>>2]|0;j=(f[a+8>>2]|0)-i|0;k=j>>3;hac(d,j>>4>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,(f[e>>2]|0)-i>>4,a+12|0);i=d+8|0;e=f[i>>2]|0;f[e>>2]=0;h=e+4|0;f[h>>2]=0;k=f[b+12>>2]|0;f[e+8>>2]=0;f[e+12>>2]=k;f[e>>2]=f[b>>2];k=b+4|0;f[h>>2]=f[k>>2];h=b+8|0;f[e+8>>2]=f[h>>2];f[h>>2]=0;f[k>>2]=0;f[b>>2]=0;f[i>>2]=e+16;iac(a,d);jac(d);u=c;return}}function l8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+32|0;g=e+12|0;h=e;a:do if(((a|0)!=(c|0)?(b[a>>0]|0)==70:0)?(i=a+1|0,(i|0)!=(c|0)):0){if((b[i>>0]|0)==89){j=a+2|0;if((j|0)==(c|0)){k=a;break}else l=j}else l=i;i=a8b(l,c,d)|0;if((i|0)!=(l|0)){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;j=OXb(489103)|0;if(j>>>0>4294967279)V5b(h);if(j>>>0<11){m=h+11|0;b[m>>0]=j;n=h;o=m;p=h+4|0}else{m=j+16&-16;q=V7b(m)|0;f[h>>2]=q;f[h+8>>2]=m|-2147483648;m=h+4|0;f[m>>2]=j;n=q;o=h+11|0;p=m}VWb(n,489103,j)|0;b[g>>0]=0;PXb(n+j|0,g);j=d+4|0;m=g+11|0;q=g+4|0;r=0;s=i;b:while(1){i=s;c:while(1){if((i|0)==(c|0)){t=15;break b}v=b[i>>0]|0;w=i+1|0;switch(v<<24>>24){case 69:{t=19;break b;break}case 118:{i=w;continue c;break}default:{}}x=(w|0)==(c|0);if(!(x|v<<24>>24!=82)?(b[w>>0]|0)==69:0){r=1;s=w;continue b}if(!(x|v<<24>>24!=79)?(b[w>>0]|0)==69:0){r=2;s=w;continue b}v=((f[j>>2]|0)-(f[d>>2]|0)|0)/24|0;x=a8b(i,c,d)|0;y=((f[j>>2]|0)-(f[d>>2]|0)|0)/24|0;if((x|0)==(i|0)|(x|0)==(c|0))break b;else z=v;while(1){if(z>>>0>=y>>>0){A=v;break}B=b[o>>0]|0;if((B<<24>>24<0?f[p>>2]|0:B&255)>>>0>1)e8b(h,489325)|0;s8b(g,(f[d>>2]|0)+(z*24|0)|0);B=b[m>>0]|0;C=B<<24>>24<0;K7b(h,C?f[g>>2]|0:g,C?f[q>>2]|0:B&255)|0;Y7b(g);z=z+1|0}while(1){if(A>>>0>=y>>>0){i=x;continue c}v=f[j>>2]|0;B=v+-24|0;C=v;while(1){if((C|0)==(B|0))break;v=C+-24|0;f[j>>2]=v;H7b(v);C=f[j>>2]|0}A=A+1|0}}}d:do if((t|0)==15){q=f[j>>2]|0;m=q+-24|0;s=q;while(1){if((s|0)==(m|0))break d;q=s+-24|0;f[j>>2]=q;H7b(q);s=f[j>>2]|0}}else if((t|0)==19){e8b(h,489101)|0;switch(r&3){case 1:{e8b(h,490529)|0;break}case 2:{e8b(h,490532)|0;break}default:{}}s=f[j>>2]|0;if((f[d>>2]|0)!=(s|0)){e8b(s+-24|0,489135)|0;s=b[o>>0]|0;m=s<<24>>24<0;fac((f[j>>2]|0)+-12|0,0,m?f[h>>2]|0:h,m?f[p>>2]|0:s&255)|0;Y7b(h);k=w;break a}}while(0);Y7b(h);k=a}else k=a}else k=a;while(0);u=e;return k|0}function m8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+112|0;g=e+96|0;h=e+72|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;if(((((a|0)!=(c|0)?(b[a>>0]|0)==77:0)?(n=a+1|0,o=a8b(n,c,d)|0,(o|0)!=(n|0)):0)?(n=a8b(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){x8b(h,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;H7b(q);p=f[o>>2]|0}x8b(i,c+-48|0);c=h+12|0;a:do if((b[((b[c+11>>0]|0)<0?f[c>>2]|0:c)>>0]|0)==40){e8b(h,489103)|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];p=0;while(1){if((p|0)==3)break;f[h+(p<<2)>>2]=0;p=p+1|0}s8b(m,i);p=b[m+11>>0]|0;d=p<<24>>24<0;K7b(l,d?f[m>>2]|0:m,d?f[m+4>>2]|0:p&255)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];p=0;while(1){if((p|0)==3)break;f[l+(p<<2)>>2]=0;p=p+1|0}e8b(k,490525)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];p=0;while(1){if((p|0)==3)break;f[k+(p<<2)>>2]=0;p=p+1|0}p=f[o>>2]|0;d=p+-24|0;q=d+11|0;if((b[q>>0]|0)<0){r=f[d>>2]|0;b[g>>0]=0;PXb(r,g);f[p+-20>>2]=0}else{b[g>>0]=0;PXb(d,g);b[q>>0]=0}F8b(d);f[d>>2]=f[j>>2];f[d+4>>2]=f[j+4>>2];f[d+8>>2]=f[j+8>>2];d=0;while(1){if((d|0)==3)break;f[j+(d<<2)>>2]=0;d=d+1|0}Y7b(j);Y7b(k);Y7b(m);Y7b(l);d8b(c,0,489101)|0;f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[j+8>>2]=f[c+8>>2];d=0;while(1){if((d|0)==3)break;f[c+(d<<2)>>2]=0;d=d+1|0}d=f[o>>2]|0;q=d+-12|0;p=q+11|0;if((b[p>>0]|0)<0){r=f[q>>2]|0;b[g>>0]=0;PXb(r,g);f[d+-8>>2]=0}else{b[g>>0]=0;PXb(q,g);b[p>>0]=0}F8b(q);f[q>>2]=f[j>>2];f[q+4>>2]=f[j+4>>2];f[q+8>>2]=f[j+8>>2];q=0;while(1){if((q|0)==3)break;f[j+(q<<2)>>2]=0;q=q+1|0}Y7b(j)}else{e8b(h,489135)|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];q=0;while(1){if((q|0)==3)break;f[h+(q<<2)>>2]=0;q=q+1|0}s8b(m,i);q=b[m+11>>0]|0;p=q<<24>>24<0;K7b(l,p?f[m>>2]|0:m,p?f[m+4>>2]|0:q&255)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];q=0;while(1){if((q|0)==3)break;f[l+(q<<2)>>2]=0;q=q+1|0}e8b(k,490525)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];q=0;while(1){if((q|0)==3)break;f[k+(q<<2)>>2]=0;q=q+1|0}q=f[o>>2]|0;p=q+-24|0;d=p+11|0;if((b[d>>0]|0)<0){r=f[p>>2]|0;b[g>>0]=0;PXb(r,g);f[q+-20>>2]=0}else{b[g>>0]=0;PXb(p,g);b[d>>0]=0}F8b(p);f[p>>2]=f[j>>2];f[p+4>>2]=f[j+4>>2];f[p+8>>2]=f[j+8>>2];p=0;while(1){if((p|0)==3)break;f[j+(p<<2)>>2]=0;p=p+1|0}Y7b(j);Y7b(k);Y7b(m);Y7b(l);p=f[o>>2]|0;d=p+-12|0;q=d+11|0;if((b[q>>0]|0)<0){r=f[d>>2]|0;b[g>>0]=0;PXb(r,g);f[p+-8>>2]=0}else{b[g>>0]=0;PXb(d,g);b[q>>0]=0}F8b(d);f[d>>2]=f[c>>2];f[d+4>>2]=f[c+4>>2];f[d+8>>2]=f[c+8>>2];d=0;while(1){if((d|0)==3)break a;f[c+(d<<2)>>2]=0;d=d+1|0}}while(0);H7b(i);H7b(h);s=n}else s=a;u=e;return s|0}function n8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=b[c+11>>0]|0;i=h<<24>>24<0;j=i?f[c+4>>2]|0:h&255;h=i?f[c>>2]|0:c;c=j>>>0<d>>>0?j:d;if(c>>>0>4294967279)V5b(a);if(c>>>0<11){b[a+11>>0]=c;k=a}else{d=c+16&-16;j=V7b(d)|0;f[a>>2]=j;f[a+8>>2]=d|-2147483648;f[a+4>>2]=c;k=j}VWb(k,h,c)|0;b[g>>0]=0;PXb(k+c|0,g);u=e;return}function o8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=b[a+11>>0]|0;g=e<<24>>24<0;if(g)h=f[a+4>>2]|0;else h=e&255;if((d|0)==-1)W5b(a);if(g)i=f[a>>2]|0;else i=a;a=h>>>0>d>>>0;g=E5b(i,c,a?d:h)|0;if(!g)return (h>>>0<d>>>0?-1:a&1)|0;else return g|0;return 0}function p8b(a){a=a|0;eac(a,OXb(490522)|0);return}function q8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+64|0;g=e+40|0;h=e;i=e+24|0;j=a;a:do if((c-j|0)>1?(b[a>>0]|0)==84:0){k=b[a+1>>0]|0;l=d+62|0;m=d+32|0;if(k<<24>>24==95){n=f[d+36>>2]|0;if((f[m>>2]|0)==(n|0)){o=a;break}p=f[n+-16>>2]|0;q=a+2|0;if((p|0)==(f[n+-12>>2]|0)){dac(g);n=d+4|0;r=f[n>>2]|0;if(r>>>0<(f[d+8>>2]|0)>>>0){x8b(r,g);f[n>>2]=(f[n>>2]|0)+24}else y8b(d,g);H7b(g);b[l>>0]=1;o=q;break}n=f[p+4>>2]|0;r=d+4|0;s=d+8|0;t=f[p>>2]|0;while(1){if((t|0)==(n|0)){o=q;break a}p=f[r>>2]|0;if((p|0)==(f[s>>2]|0))g8b(d,t);else{f8b(p,t);f[r>>2]=(f[r>>2]|0)+24}t=t+24|0}}t=(k<<24>>24)+-48|0;if(t>>>0<10){r=t;t=a+2|0;while(1){v=t+1|0;if((t|0)==(c|0)){o=a;break a}w=b[t>>0]|0;s=(w<<24>>24)+-48|0;if(s>>>0>=10)break;r=s+(r*10|0)|0;t=v}if(w<<24>>24==95?(t=f[d+36>>2]|0,(f[m>>2]|0)!=(t|0)):0){k=r+1|0;s=f[t+-16>>2]|0;q=s;if(k>>>0<(f[t+-12>>2]|0)-s>>4>>>0){s=f[q+(k<<4)+4>>2]|0;t=d+4|0;n=d+8|0;p=f[q+(k<<4)>>2]|0;while(1){if((p|0)==(s|0)){o=v;break a}k=f[t>>2]|0;if((k|0)==(f[n>>2]|0))g8b(d,p);else{f8b(k,p);f[t>>2]=(f[t>>2]|0)+24}p=p+24|0}};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;p=v-j|0;if(p>>>0>4294967279)V5b(i);if(p>>>0<11){b[i+11>>0]=p;x=i}else{t=p+16&-16;n=V7b(t)|0;f[i>>2]=n;f[i+8>>2]=t|-2147483648;f[i+4>>2]=p;x=n}n=a;t=x;while(1){if((n|0)==(v|0))break;PXb(t,n);n=n+1|0;t=t+1|0}b[g>>0]=0;PXb(x+p|0,g);v8b(h,i);t=d+4|0;n=f[t>>2]|0;if(n>>>0<(f[d+8>>2]|0)>>>0){x8b(n,h);f[t>>2]=(f[t>>2]|0)+24}else y8b(d,h);H7b(h);Y7b(i);b[l>>0]=1;o=v}else o=a}else o=a}else o=a;while(0);u=e;return o|0}function r8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+64|0;g=e+32|0;h=e+16|0;i=e;j=e+4|0;do if((c-a|0)>1?(b[a>>0]|0)==73:0){k=d+61|0;l=d+32|0;a:do if(b[k>>0]|0){m=f[d+36>>2]|0;n=f[m+-16>>2]|0;o=m+-12|0;while(1){m=f[o>>2]|0;if((m|0)==(n|0))break a;p=m+-16|0;f[o>>2]=p;I7b(p)}}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;o=OXb(489137)|0;if(o>>>0>4294967279)V5b(h);if(o>>>0<11){n=h+11|0;b[n>>0]=o;q=h;r=n;s=h+4|0}else{n=o+16&-16;p=V7b(n)|0;f[h>>2]=p;f[h+8>>2]=n|-2147483648;n=h+4|0;f[n>>2]=o;q=p;r=h+11|0;s=n}VWb(q,489137,o)|0;b[g>>0]=0;PXb(q+o|0,g);o=d+4|0;n=d+36|0;p=d+12|0;m=g+11|0;t=g+4|0;v=d+40|0;w=a+1|0;b:while(1){if((b[w>>0]|0)==69)break;if(b[k>>0]|0){f[i>>2]=f[p>>2];x=f[n>>2]|0;if(x>>>0<(f[v>>2]|0)>>>0){X9b(g,i);f[x>>2]=0;f[x+4>>2]=0;y=f[g>>2]|0;f[x+8>>2]=0;f[x+12>>2]=y;f[n>>2]=(f[n>>2]|0)+16}else Y9b(l,i)}y=((f[o>>2]|0)-(f[d>>2]|0)|0)/24|0;x=Z9b(w,c,d)|0;z=((f[o>>2]|0)-(f[d>>2]|0)|0)/24|0;c:do if(b[k>>0]|0){A=f[n>>2]|0;B=A+-16|0;C=A;while(1){if((C|0)==(B|0))break c;A=C+-16|0;f[n>>2]=A;O7b(A);C=f[n>>2]|0}}while(0);if((x|0)==(w|0)|(x|0)==(c|0)){D=53;break}d:do if(!(b[k>>0]|0))E=y;else{C=f[n>>2]|0;B=f[p>>2]|0;f[g>>2]=B;A=C+-12|0;F=f[A>>2]|0;if(F>>>0<(f[C+-8>>2]|0)>>>0){f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=B;f[A>>2]=(f[A>>2]|0)+16}else c8b(C+-16|0,g);C=y;while(1){if(C>>>0>=z>>>0){E=y;break d}A=f[(f[n>>2]|0)+-12>>2]|0;B=(f[d>>2]|0)+(C*24|0)|0;F=A+-12|0;G=f[F>>2]|0;if((G|0)==(f[A+-8>>2]|0))g8b(A+-16|0,B);else{f8b(G,B);f[F>>2]=(f[F>>2]|0)+24}C=C+1|0}}while(0);while(1){if(E>>>0>=z>>>0){H=z;break}C=b[r>>0]|0;if((C<<24>>24<0?f[s>>2]|0:C&255)>>>0>1)e8b(h,489325)|0;s8b(g,(f[d>>2]|0)+(E*24|0)|0);C=b[m>>0]|0;F=C<<24>>24<0;K7b(h,F?f[g>>2]|0:g,F?f[t>>2]|0:C&255)|0;Y7b(g);E=E+1|0}while(1){if((H|0)==(y|0)){w=x;continue b}z=f[o>>2]|0;C=z+-24|0;F=z;while(1){if((F|0)==(C|0))break;z=F+-24|0;f[o>>2]=z;H7b(z);F=f[o>>2]|0}H=H+-1|0}}if((D|0)==53){Y7b(h);I=a;break}t=w+1|0;m=b[r>>0]|0;n=m<<24>>24<0;if((b[(n?f[h>>2]|0:h)+(n?f[s>>2]|0:m&255)+-1>>0]|0)==62)e8b(h,490516)|0;else e8b(h,489139)|0;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];m=0;while(1){if((m|0)==3)break;f[h+(m<<2)>>2]=0;m=m+1|0}v8b(g,j);m=f[o>>2]|0;if(m>>>0<(f[d+8>>2]|0)>>>0){x8b(m,g);f[o>>2]=(f[o>>2]|0)+24}else y8b(d,g);H7b(g);Y7b(j);Y7b(h);I=t}else I=a;while(0);u=e;return I|0}function s8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=c+12|0;e=b[d+11>>0]|0;g=e<<24>>24<0;K7b(c,g?f[d>>2]|0:d,g?f[c+16>>2]|0:e&255)|0;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];a=0;while(1){if((a|0)==3)break;f[c+(a<<2)>>2]=0;a=a+1|0}return}function t8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;a:do if(((a|0)!=(c|0)?(j=(b[a>>0]|0)+-48|0,j>>>0<10):0)?(k=a+1|0,(k|0)!=(c|0)):0){l=j;j=k;while(1){k=(b[j>>0]|0)+-48|0;if(k>>>0>=10)break;m=j+1|0;if((m|0)==(c|0)){n=a;break a}l=k+(l*10|0)|0;j=m}if((c-j|0)>>>0>=l>>>0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(l>>>0>4294967279)V5b(h);if(l>>>0<11){b[h+11>>0]=l;o=h}else{m=l+16&-16;k=V7b(m)|0;f[h>>2]=k;f[h+8>>2]=m|-2147483648;f[h+4>>2]=l;o=k}VWb(o,j,l)|0;b[g>>0]=0;PXb(o+l|0,g);n8b(g,h,10);k=OXb(490483)|0;m=b[g+11>>0]|0;if((k|0)==((m<<24>>24<0?f[g+4>>2]|0:m&255)|0))p=(o8b(g,490483,k)|0)==0;else p=0;Y7b(g);if(p){W9b(g);k=d+4|0;m=f[k>>2]|0;if(m>>>0<(f[d+8>>2]|0)>>>0){x8b(m,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g)}else{f[i>>2]=f[h>>2];f[i+4>>2]=f[h+4>>2];f[i+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}v8b(g,i);k=d+4|0;m=f[k>>2]|0;if(m>>>0<(f[d+8>>2]|0)>>>0){x8b(m,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);Y7b(i)}Y7b(h);n=j+l|0}else n=a}else n=a;while(0);u=e;return n|0}function u8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=0;while(1){if((h|0)==3)break;f[a+(h<<2)>>2]=0;h=h+1|0}h=c+11|0;i=b[h>>0]|0;j=i<<24>>24<0?f[c+4>>2]|0:i&255;i=OXb(d)|0;k=(b[h>>0]|0)<0?f[c>>2]|0:c;c=j+i|0;if(c>>>0>4294967279)V5b(a);if(c>>>0<11){b[a+11>>0]=j;l=a}else{h=c+16&-16;c=V7b(h)|0;f[a>>2]=c;f[a+8>>2]=h|-2147483648;f[a+4>>2]=j;l=c}VWb(l,k,j)|0;b[g>>0]=0;PXb(l+j|0,g);K7b(a,d,i)|0;u=e;return}function v8b(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];c=0;while(1){if((c|0)==3)break;f[b+(c<<2)>>2]=0;c=c+1|0}c=a+12|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[c+(a<<2)>>2]=0;a=a+1|0}return}function w8b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=a+11|0;if((b[g>>0]|0)<0){h=f[a>>2]|0;b[e>>0]=0;PXb(h,e);f[a+4>>2]=0}else{b[e>>0]=0;PXb(a,e);b[g>>0]=0}F8b(a);f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];g=0;while(1){if((g|0)==3)break;f[c+(g<<2)>>2]=0;g=g+1|0}g=a+12|0;h=c+12|0;c=g+11|0;if((b[c>>0]|0)<0){i=f[g>>2]|0;b[e>>0]=0;PXb(i,e);f[a+16>>2]=0}else{b[e>>0]=0;PXb(g,e);b[c>>0]=0}F8b(g);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];g=0;while(1){if((g|0)==3)break;f[h+(g<<2)>>2]=0;g=g+1|0}u=d;return}function x8b(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];c=0;while(1){if((c|0)==3)break;f[b+(c<<2)>>2]=0;c=c+1|0}c=a+12|0;a=b+12|0;f[c>>2]=f[a>>2];f[c+4>>2]=f[a+4>>2];f[c+8>>2]=f[a+8>>2];c=0;while(1){if((c|0)==3)break;f[a+(c<<2)>>2]=0;c=c+1|0}return}function y8b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+32|0;d=c;e=a+4|0;g=(((f[e>>2]|0)-(f[a>>2]|0)|0)/24|0)+1|0;h=F9b(a)|0;if(h>>>0<g>>>0)c4b(a);else{i=f[a>>2]|0;j=((f[a+8>>2]|0)-i|0)/24|0;k=j<<1;G9b(d,j>>>0<h>>>1>>>0?(k>>>0<g>>>0?g:k):h,((f[e>>2]|0)-i|0)/24|0,a+12|0);i=d+8|0;e=f[i>>2]|0;x8b(e,b);f[i>>2]=e+24;H9b(a,d);I9b(d);u=c;return}}function z8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e+8|0;h=e;a:do if((c-a|0)>1){i=(b[a>>0]|0)==76?a+1|0:a;switch(b[i>>0]|0){case 78:{j=R9b(i,c,d)|0;k=(j|0)==(i|0)?a:j;break a;break}case 90:{j=S9b(i,c,d)|0;k=(j|0)==(i|0)?a:j;break a;break}default:{j=T9b(i,c,d)|0;if((j|0)==(i|0)){l=A8b(i,c,d)|0;if((l|0)==(i|0)|(l|0)==(c|0)){k=a;break a}if((b[l>>0]|0)!=73){k=a;break a}i=r8b(l,c,d)|0;if((i|0)==(l|0)){k=a;break a}l=d+4|0;m=f[l>>2]|0;if(((m-(f[d>>2]|0)|0)/24|0)>>>0<2){k=a;break a}s8b(g,m+-24|0);m=f[l>>2]|0;n=m+-24|0;o=m;while(1){if((o|0)==(n|0))break;p=o+-24|0;f[l>>2]=p;H7b(p);o=f[l>>2]|0}l=b[g+11>>0]|0;o=l<<24>>24<0;K7b(m+-48|0,o?f[g>>2]|0:g,o?f[g+4>>2]|0:l&255)|0;Y7b(g);k=i;break a}if((j|0)==(c|0)){k=c;break a}if((b[j>>0]|0)!=73){k=j;break a}l=d+4|0;o=f[l>>2]|0;if((f[d>>2]|0)==(o|0)){k=a;break a}f[h>>2]=f[d+12>>2];j8b(g,o+-24|0,h);o=d+20|0;n=f[o>>2]|0;if(n>>>0<(f[d+24>>2]|0)>>>0){f[n>>2]=0;p=n+4|0;f[p>>2]=0;q=f[g+12>>2]|0;f[n+8>>2]=0;f[n+12>>2]=q;f[n>>2]=f[g>>2];q=g+4|0;f[p>>2]=f[q>>2];p=g+8|0;f[n+8>>2]=f[p>>2];f[p>>2]=0;f[q>>2]=0;f[g>>2]=0;f[o>>2]=(f[o>>2]|0)+16}else k8b(d+16|0,g);I7b(g);o=r8b(j,c,d)|0;if((o|0)==(j|0)){k=a;break a}q=f[l>>2]|0;if(((q-(f[d>>2]|0)|0)/24|0)>>>0<2){k=a;break a}s8b(g,q+-24|0);q=f[l>>2]|0;p=q+-24|0;n=q;while(1){if((n|0)==(p|0))break;r=n+-24|0;f[l>>2]=r;H7b(r);n=f[l>>2]|0}l=b[g+11>>0]|0;n=l<<24>>24<0;K7b(q+-48|0,n?f[g>>2]|0:g,n?f[g+4>>2]|0:l&255)|0;Y7b(g);k=o;break a}}}else k=a;while(0);u=e;return k|0}function A8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e;a:do if((c-a|0)>1?(b[a>>0]|0)==83:0){h=b[a+1>>0]|0;i=a+2|0;j=d+16|0;switch(h|0){case 97:{u9b(g,490429);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);m=i;break a;break}case 98:{r9b(g,490444);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);m=i;break a;break}case 115:{t9b(g,489923);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);m=i;break a;break}case 105:{v9b(g,490019);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);m=i;break a;break}case 111:{v9b(g,490096);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);m=i;break a;break}case 100:{Q9b(g,490173);k=d+4|0;l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);m=i;break a;break}case 95:{k=f[j>>2]|0;if((k|0)==(f[d+20>>2]|0)){m=a;break a}l=f[k+4>>2]|0;n=d+4|0;o=d+8|0;p=f[k>>2]|0;while(1){if((p|0)==(l|0)){m=i;break a}k=f[n>>2]|0;if((k|0)==(f[o>>2]|0))g8b(d,p);else{f8b(k,p);f[n>>2]=(f[n>>2]|0)+24}p=p+24|0}break}default:{p=(h+-48|0)>>>0<10;if(!p?(hVb(h)|0)==0:0){m=a;break a}n=i;o=(p?-48:-55)+h|0;while(1){q=n+1|0;if((n|0)==(c|0)){m=a;break a}r=b[n>>0]|0;p=r<<24>>24;l=(p+-48|0)>>>0<10;if(!l?(hVb(p)|0)==0:0)break;n=q;o=p+(o*36|0)+(l?-48:-55)|0}if(r<<24>>24!=95){m=a;break a}n=o+1|0;h=f[j>>2]|0;i=h;if(n>>>0>=(f[d+20>>2]|0)-h>>4>>>0){m=a;break a}h=f[i+(n<<4)+4>>2]|0;l=d+4|0;p=d+8|0;k=f[i+(n<<4)>>2]|0;while(1){if((k|0)==(h|0)){m=q;break a}n=f[l>>2]|0;if((n|0)==(f[p>>2]|0))g8b(d,k);else{f8b(n,k);f[l>>2]=(f[l>>2]|0)+24}k=k+24|0}}}}else m=a;while(0);u=e;return m|0}function B8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;a:do if((c-a|0)>3?(b[a>>0]|0)==68:0){switch(b[a+1>>0]|0){case 84:case 116:break;default:{k=a;break a}}l=a+2|0;m=E8b(l,c,d)|0;if((!((m|0)==(l|0)|(m|0)==(c|0))?(b[m>>0]|0)==69:0)?(l=d+4|0,n=f[l>>2]|0,(f[d>>2]|0)!=(n|0)):0){s8b(j,n+-24|0);d8b(j,0,490419)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];n=0;while(1){if((n|0)==3)break;f[j+(n<<2)>>2]=0;n=n+1|0}e8b(i,489101)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];n=0;while(1){if((n|0)==3)break;f[i+(n<<2)>>2]=0;n=n+1|0}v8b(g,h);w8b((f[l>>2]|0)+-24|0,g);H7b(g);Y7b(h);Y7b(i);Y7b(j);k=m+1|0}else k=a}else k=a;while(0);u=e;return k|0}function C8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+80|0;g=e+60|0;h=e+24|0;i=e+12|0;j=e;k=e+48|0;a:do if(((c-a|0)>3?(b[a>>0]|0)==68:0)?(b[a+1>>0]|0)==118:0){l=a+2|0;m=b[l>>0]|0;if((m+-49&255)>=9){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;n=0;while(1){if((n|0)==3)break;f[h+(n<<2)>>2]=0;n=n+1|0}b:do if(m<<24>>24!=95?(n=E8b(l,c,d)|0,(n|0)!=(l|0)):0){o=d+4|0;p=f[o>>2]|0;if((f[d>>2]|0)!=(p|0)){s8b(i,p+-24|0);p=h+11|0;if((b[p>>0]|0)<0){q=f[h>>2]|0;b[g>>0]=0;PXb(q,g);f[h+4>>2]=0}else{b[g>>0]=0;PXb(h,g);b[p>>0]=0}F8b(h);f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];p=0;while(1){if((p|0)==3)break;f[i+(p<<2)>>2]=0;p=p+1|0}Y7b(i);p=f[o>>2]|0;q=p+-24|0;r=p;while(1){if((r|0)==(q|0)){s=n;t=53;break b}p=r+-24|0;f[o>>2]=p;H7b(p);r=f[o>>2]|0}}}else{s=l;t=53}while(0);do if((t|0)==53){if((((s|0)!=(c|0)?(b[s>>0]|0)==95:0)?(m=s+1|0,(m|0)!=(c|0)):0)?(o=a8b(m,c,d)|0,(o|0)!=(m|0)):0){m=d+4|0;if((f[d>>2]|0)==(f[m>>2]|0))break;G8b(i,489141,h);e8b(i,489150)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];r=0;while(1){if((r|0)==3)break;f[i+(r<<2)>>2]=0;r=r+1|0}r=b[g+11>>0]|0;n=r<<24>>24<0;K7b((f[m>>2]|0)+-24|0,n?f[g>>2]|0:g,n?f[g+4>>2]|0:r&255)|0;Y7b(g);Y7b(i);v=o}else v=a;Y7b(h);w=v;break a}while(0);Y7b(h);w=a;break}r=D8b(l,c)|0;if(((r|0)!=(c|0)?(b[r>>0]|0)==95:0)?(n=r-l|0,q=r+1|0,(q|0)!=(c|0)):0){if((b[q>>0]|0)!=112){p=a8b(q,c,d)|0;if((p|0)==(q|0)){w=a;break}q=d+4|0;if((f[d>>2]|0)==(f[q>>2]|0)){w=a;break};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(n>>>0>4294967279)V5b(j);if(n>>>0<11){b[j+11>>0]=n;x=j}else{y=n+16&-16;z=V7b(y)|0;f[j>>2]=z;f[j+8>>2]=y|-2147483648;f[j+4>>2]=n;x=z}VWb(x,l,n)|0;b[g>>0]=0;PXb(x+n|0,g);d8b(j,0,489141)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];z=0;while(1){if((z|0)==3)break;f[j+(z<<2)>>2]=0;z=z+1|0}e8b(i,489150)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];z=0;while(1){if((z|0)==3)break;f[i+(z<<2)>>2]=0;z=z+1|0}z=b[h+11>>0]|0;y=z<<24>>24<0;K7b((f[q>>2]|0)+-24|0,y?f[h>>2]|0:h,y?f[h+4>>2]|0:z&255)|0;Y7b(h);Y7b(i);Y7b(j);w=p;break}z=r+2|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(n>>>0>4294967279)V5b(j);if(n>>>0<11){b[j+11>>0]=n;A=j}else{y=n+16&-16;B=V7b(y)|0;f[j>>2]=B;f[j+8>>2]=y|-2147483648;f[j+4>>2]=n;A=B}VWb(A,l,n)|0;b[g>>0]=0;PXb(A+n|0,g);d8b(j,0,489152)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];B=0;while(1){if((B|0)==3)break;f[j+(B<<2)>>2]=0;B=B+1|0}e8b(i,489150)|0;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];f[k+8>>2]=f[i+8>>2];B=0;while(1){if((B|0)==3)break;f[i+(B<<2)>>2]=0;B=B+1|0}v8b(h,k);B=d+4|0;n=f[B>>2]|0;if(n>>>0<(f[d+8>>2]|0)>>>0){x8b(n,h);f[B>>2]=(f[B>>2]|0)+24}else y8b(d,h);H7b(h);Y7b(k);Y7b(i);Y7b(j);w=z}else w=a}else w=a;while(0);u=e;return w|0}function D8b(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;a:do if((a|0)!=(c|0)?(d=(b[a>>0]|0)==110?a+1|0:a,(d|0)!=(c|0)):0){e=b[d>>0]|0;f=d+1|0;if(e<<24>>24!=48)if((e+-49&255)<9){e=f;while(1){if((e|0)==(c|0)){g=c;break a}if(((b[e>>0]|0)+-48|0)>>>0>=10){g=e;break a}e=e+1|0}}else g=a;else g=f}else g=a;while(0);return g|0}
function hrb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=(g|0)==0;if(!h)npb(g);i=a+16|0;j=f[i>>2]|0;k=j+44|0;if(!(f[k>>2]|0))l=j;else{m=j+40|0;n=f[m>>2]|0;if(n|0){o=n;do{n=o;o=f[o>>2]|0;p=n+8|0;if((b[p+11>>0]|0)<0)O5b(f[p>>2]|0);O5b(n)}while((o|0)!=0)}f[m>>2]=0;m=f[j+36>>2]|0;if(m|0){o=j+32|0;j=0;do{f[(f[o>>2]|0)+(j<<2)>>2]=0;j=j+1|0}while((j|0)!=(m|0))}f[k>>2]=0;l=f[i>>2]|0}k=l+24|0;if(!(f[k>>2]|0))q=l;else{m=l+20|0;j=f[m>>2]|0;if(j|0){o=j;do{j=o;o=f[o>>2]|0;n=j+8|0;if((b[n+11>>0]|0)<0)O5b(f[n>>2]|0);O5b(j)}while((o|0)!=0)}f[m>>2]=0;m=f[l+16>>2]|0;if(m|0){o=l+12|0;l=0;do{f[(f[o>>2]|0)+(l<<2)>>2]=0;l=l+1|0}while((l|0)!=(m|0))}f[k>>2]=0;q=f[i>>2]|0}k=c+11|0;f[e>>2]=(b[k>>0]|0)<0?f[c>>2]|0:c;m=crb(q+140|0,e)|0;if((m|0)!=0?(q=f[m+12>>2]|0,(q|0)!=0):0)r=q;else s=24;a:do if((s|0)==24){q=f[a+12>>2]|0;if(q|0?(m=hrb(q,c)|0,m|0):0){r=m;break}do if(irb(a,c)|0){m=f[i>>2]|0;f[e>>2]=(b[k>>0]|0)<0?f[c>>2]|0:c;q=crb(m+140|0,e)|0;if((q|0)!=0?(m=f[q+12>>2]|0,(m|0)!=0):0){r=m;break a}else break}while(0);r=0}while(0);if(h){u=d;return r|0}opb(g);u=d;return r|0}function irb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0;d=u;u=u+144|0;e=d;g=a+4|0;if(!(f[g>>2]|0)){h=0;u=d;return h|0}i=a+16|0;if(jrb((f[i>>2]|0)+12|0,c)|0){h=0;u=d;return h|0}WDb(e);j=f[g>>2]|0;if(li[f[(f[j>>2]|0)+8>>2]&511](j,c,e)|0?(krb(a,e)|0)!=0:0)k=1;else l=5;a:do if((l|0)==5){a=f[i>>2]|0;j=a+12|0;g=b[c+11>>0]|0;m=g<<24>>24<0;o=m?f[c>>2]|0:c;p=b[o>>0]|0;if(!(p<<24>>24))q=0;else{r=o;s=0;t=p;while(1){v=(s*5|0)+(t<<24>>24)|0;r=r+1|0;t=b[r>>0]|0;if(!(t<<24>>24)){q=v;break}else s=v}}s=a+16|0;t=f[s>>2]|0;r=(t|0)==0;b:do if(!r){v=t+-1|0;w=(v&t|0)==0;if(!w)if(q>>>0<t>>>0)x=q;else x=(q>>>0)%(t>>>0)|0;else x=v&q;y=f[(f[j>>2]|0)+(x<<2)>>2]|0;if((y|0)!=0?(z=f[y>>2]|0,(z|0)!=0):0){y=m?f[c+4>>2]|0:g&255;A=(y|0)==0;if(w){if(A){w=z;while(1){B=f[w+4>>2]|0;if(!((B|0)==(q|0)|(B&v|0)==(x|0))){C=x;break b}B=b[w+8+11>>0]|0;if(!((B<<24>>24<0?f[w+12>>2]|0:B&255)|0)){k=0;break a}w=f[w>>2]|0;if(!w){C=x;break b}}}else D=z;while(1){w=f[D+4>>2]|0;if(!((w|0)==(q|0)|(w&v|0)==(x|0))){C=x;break b}w=D+8|0;B=b[w+11>>0]|0;E=B<<24>>24<0;F=B&255;do if(((E?f[D+12>>2]|0:F)|0)==(y|0)){B=f[w>>2]|0;if(E)if(!(ZVb(B,o,y)|0)){k=0;break a}else break;if((B&255)<<24>>24==p<<24>>24){B=w;G=F;H=o;do{G=G+-1|0;B=B+1|0;if(!G){k=0;break a}H=H+1|0}while((b[B>>0]|0)==(b[H>>0]|0))}}while(0);D=f[D>>2]|0;if(!D){C=x;break b}}}if(A){v=z;while(1){F=f[v+4>>2]|0;if((F|0)!=(q|0)){if(F>>>0<t>>>0)I=F;else I=(F>>>0)%(t>>>0)|0;if((I|0)!=(x|0)){C=x;break b}}F=b[v+8+11>>0]|0;if(!((F<<24>>24<0?f[v+12>>2]|0:F&255)|0)){k=0;break a}v=f[v>>2]|0;if(!v){C=x;break b}}}else J=z;while(1){v=f[J+4>>2]|0;if((v|0)!=(q|0)){if(v>>>0<t>>>0)K=v;else K=(v>>>0)%(t>>>0)|0;if((K|0)!=(x|0)){C=x;break b}}v=J+8|0;A=b[v+11>>0]|0;F=A<<24>>24<0;w=A&255;do if(((F?f[J+12>>2]|0:w)|0)==(y|0)){A=f[v>>2]|0;if(F)if(!(ZVb(A,o,y)|0)){k=0;break a}else break;if((A&255)<<24>>24==p<<24>>24){A=v;E=w;H=o;do{E=E+-1|0;A=A+1|0;if(!E){k=0;break a}H=H+1|0}while((b[A>>0]|0)==(b[H>>0]|0))}}while(0);J=f[J>>2]|0;if(!J){C=x;break}}}else C=x}else C=0;while(0);o=L5b(20)|0;X5b(o+8|0,c);f[o+4>>2]=q;f[o>>2]=0;p=a+24|0;L=+(((f[p>>2]|0)+1|0)>>>0);M=+n[a+28>>2];do if(r|L>+(t>>>0)*M){g=(t>>>0<3|(t+-1&t|0)!=0)&1|t<<1;m=~~+X(+(L/M))>>>0;lrb(j,g>>>0<m>>>0?m:g);g=f[s>>2]|0;m=g+-1|0;if(!(m&g)){N=g;O=m&q;break}if(q>>>0<g>>>0){N=g;O=q}else{N=g;O=(q>>>0)%(g>>>0)|0}}else{N=t;O=C}while(0);t=(f[j>>2]|0)+(O<<2)|0;s=f[t>>2]|0;if(!s){r=a+20|0;f[o>>2]=f[r>>2];f[r>>2]=o;f[t>>2]=r;r=f[o>>2]|0;if(r|0){t=f[r+4>>2]|0;r=N+-1|0;if(r&N)if(t>>>0<N>>>0)P=t;else P=(t>>>0)%(N>>>0)|0;else P=t&r;Q=(f[j>>2]|0)+(P<<2)|0;l=60}}else{f[o>>2]=f[s>>2];Q=s;l=60}if((l|0)==60)f[Q>>2]=o;f[p>>2]=(f[p>>2]|0)+1;k=0}while(0);DDb(e);h=k;u=d;return h|0}function jrb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=e?f[c>>2]|0:c;h=b[g>>0]|0;if(!(h<<24>>24))i=0;else{j=g;k=0;l=h;while(1){m=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=m;break}else k=m}}k=f[a+4>>2]|0;if(!k){n=0;return n|0}l=k+-1|0;j=(l&k|0)==0;if(!j)if(i>>>0<k>>>0)o=i;else o=(i>>>0)%(k>>>0)|0;else o=l&i;m=f[(f[a>>2]|0)+(o<<2)>>2]|0;if(!m){n=0;return n|0}a=f[m>>2]|0;if(!a){n=0;return n|0}m=e?f[c+4>>2]|0:d&255;d=(m|0)==0;if(j){j=a;a:while(1){c=f[j+4>>2]|0;e=(i|0)==(c|0);if(!(e|(c&l|0)==(o|0))){n=0;p=36;break}do if(e?(c=j+8|0,q=b[c+11>>0]|0,r=q<<24>>24<0,s=q&255,((r?f[j+12>>2]|0:s)|0)==(m|0)):0){q=f[c>>2]|0;t=r?q:c;if(r){if(d){n=j;p=36;break a}if(!(ZVb(t,g,m)|0)){n=j;p=36;break a}else break}if(d){n=j;p=36;break a}if((q&255)<<24>>24==h<<24>>24){q=c;c=s;s=g;do{c=c+-1|0;q=q+1|0;if(!c){n=j;p=36;break a}s=s+1|0}while((b[q>>0]|0)==(b[s>>0]|0))}}while(0);j=f[j>>2]|0;if(!j){n=0;p=36;break}}if((p|0)==36)return n|0}else u=a;b:while(1){a=f[u+4>>2]|0;j=(i|0)==(a|0);if(!j){if(a>>>0<k>>>0)v=a;else v=(a>>>0)%(k>>>0)|0;if((v|0)!=(o|0)){n=0;p=36;break}if(j)p=28}else p=28;do if((p|0)==28?(p=0,j=u+8|0,a=b[j+11>>0]|0,l=a<<24>>24<0,e=a&255,((l?f[u+12>>2]|0:e)|0)==(m|0)):0){a=f[j>>2]|0;s=l?a:j;if(l){if(d){n=u;p=36;break b}if(!(ZVb(s,g,m)|0)){n=u;p=36;break b}else break}if(d){n=u;p=36;break b}if((a&255)<<24>>24==h<<24>>24){a=j;j=e;e=g;do{j=j+-1|0;a=a+1|0;if(!j){n=u;p=36;break b}e=e+1|0}while((b[a>>0]|0)==(b[e>>0]|0))}}while(0);u=f[u>>2]|0;if(!u){n=0;p=36;break}}if((p|0)==36)return n|0;return 0}function krb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0;d=u;u=u+112|0;e=d;g=a+16|0;h=c+120|0;if(jrb((f[g>>2]|0)+12|0,f[h>>2]|0)|0){i=0;u=d;return i|0}j=f[g>>2]|0;k=f[a+8>>2]|0;f[e>>2]=a;f[e+4>>2]=j;f[e+8>>2]=k;k=e+12|0;j=e+28|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[e+52>>2]=0;f[e+56>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[k+12>>0]=0;f[e+48>>2]=e+52;f[e+64>>2]=0;f[e+68>>2]=0;f[e+60>>2]=e+64;k=e+72|0;j=e+88|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;b[j+11>>0]=0;b[j>>0]=0;j=nrb(e,c)|0;orb(e);if(j|0){i=j;u=d;return i|0}j=f[g>>2]|0;g=j+12|0;e=f[h>>2]|0;h=b[e+11>>0]|0;c=h<<24>>24<0;k=c?f[e>>2]|0:e;a=b[k>>0]|0;if(!(a<<24>>24))l=0;else{m=k;o=0;p=a;while(1){q=(o*5|0)+(p<<24>>24)|0;m=m+1|0;p=b[m>>0]|0;if(!(p<<24>>24)){l=q;break}else o=q}}o=j+16|0;p=f[o>>2]|0;m=(p|0)==0;a:do if(!m){q=p+-1|0;r=(q&p|0)==0;if(!r)if(l>>>0<p>>>0)s=l;else s=(l>>>0)%(p>>>0)|0;else s=q&l;t=f[(f[g>>2]|0)+(s<<2)>>2]|0;if((t|0)!=0?(v=f[t>>2]|0,(v|0)!=0):0){t=c?f[e+4>>2]|0:h&255;w=(t|0)==0;if(r){if(w){r=v;while(1){x=f[r+4>>2]|0;if(!((x|0)==(l|0)|(x&q|0)==(s|0))){y=s;break a}x=b[r+8+11>>0]|0;if(!((x<<24>>24<0?f[r+12>>2]|0:x&255)|0)){i=0;break}r=f[r>>2]|0;if(!r){y=s;break a}}u=d;return i|0}else z=v;b:while(1){r=f[z+4>>2]|0;if(!((r|0)==(l|0)|(r&q|0)==(s|0))){y=s;break a}r=z+8|0;x=b[r+11>>0]|0;A=x<<24>>24<0;B=x&255;do if(((A?f[z+12>>2]|0:B)|0)==(t|0)){x=f[r>>2]|0;if(A)if(!(ZVb(x,k,t)|0)){i=0;C=60;break b}else break;if((x&255)<<24>>24==a<<24>>24){x=r;D=B;E=k;do{D=D+-1|0;x=x+1|0;if(!D){i=0;C=60;break b}E=E+1|0}while((b[x>>0]|0)==(b[E>>0]|0))}}while(0);z=f[z>>2]|0;if(!z){y=s;break a}}if((C|0)==60){u=d;return i|0}}if(w){q=v;while(1){B=f[q+4>>2]|0;if((B|0)!=(l|0)){if(B>>>0<p>>>0)F=B;else F=(B>>>0)%(p>>>0)|0;if((F|0)!=(s|0)){y=s;break a}}B=b[q+8+11>>0]|0;if(!((B<<24>>24<0?f[q+12>>2]|0:B&255)|0)){i=0;break}q=f[q>>2]|0;if(!q){y=s;break a}}u=d;return i|0}else G=v;c:while(1){q=f[G+4>>2]|0;if((q|0)!=(l|0)){if(q>>>0<p>>>0)H=q;else H=(q>>>0)%(p>>>0)|0;if((H|0)!=(s|0)){y=s;break a}}q=G+8|0;w=b[q+11>>0]|0;B=w<<24>>24<0;r=w&255;do if(((B?f[G+12>>2]|0:r)|0)==(t|0)){w=f[q>>2]|0;if(B)if(!(ZVb(w,k,t)|0)){i=0;C=60;break c}else break;if((w&255)<<24>>24==a<<24>>24){w=q;A=r;E=k;do{A=A+-1|0;w=w+1|0;if(!A){i=0;C=60;break c}E=E+1|0}while((b[w>>0]|0)==(b[E>>0]|0))}}while(0);G=f[G>>2]|0;if(!G){y=s;break a}}if((C|0)==60){u=d;return i|0}}else y=s}else y=0;while(0);s=L5b(20)|0;X5b(s+8|0,e);f[s+4>>2]=l;f[s>>2]=0;e=j+24|0;I=+(((f[e>>2]|0)+1|0)>>>0);J=+n[j+28>>2];do if(m|I>+(p>>>0)*J){G=(p>>>0<3|(p+-1&p|0)!=0)&1|p<<1;k=~~+X(+(I/J))>>>0;lrb(g,G>>>0<k>>>0?k:G);G=f[o>>2]|0;k=G+-1|0;if(!(k&G)){K=G;L=k&l;break}if(l>>>0<G>>>0){K=G;L=l}else{K=G;L=(l>>>0)%(G>>>0)|0}}else{K=p;L=y}while(0);y=(f[g>>2]|0)+(L<<2)|0;L=f[y>>2]|0;if(!L){p=j+20|0;f[s>>2]=f[p>>2];f[p>>2]=s;f[y>>2]=p;p=f[s>>2]|0;if(p|0){y=f[p+4>>2]|0;p=K+-1|0;if(p&K)if(y>>>0<K>>>0)M=y;else M=(y>>>0)%(K>>>0)|0;else M=y&p;N=(f[g>>2]|0)+(M<<2)|0;C=58}}else{f[s>>2]=f[L>>2];N=L;C=58}if((C|0)==58)f[N>>2]=s;f[e>>2]=(f[e>>2]|0)+1;i=0;u=d;return i|0}function lrb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=yWb(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){mrb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=yWb(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;mrb(a,d);return}function mrb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=(c|0)!=0;do if(d)if(c>>>0>1073741823){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{g=L5b(c<<2)|0;break}else g=0;while(0);e=f[a>>2]|0;f[a>>2]=g;if(e|0)O5b(e);f[a+4>>2]=c;if(d)h=0;else return;do{f[(f[a>>2]|0)+(h<<2)>>2]=0;h=h+1|0}while((h|0)!=(c|0));h=a+8|0;d=f[h>>2]|0;if(!d)return;e=f[d+4>>2]|0;g=c+-1|0;i=(g&c|0)==0;if(!i)if(e>>>0<c>>>0)j=e;else j=(e>>>0)%(c>>>0)|0;else j=e&g;f[(f[a>>2]|0)+(j<<2)>>2]=h;h=f[d>>2]|0;if(!h)return;else{k=j;l=d;m=h;n=d}a:while(1){d=l;h=m;j=n;b:while(1){o=h;while(1){e=f[o+4>>2]|0;if(!i)if(e>>>0<c>>>0)p=e;else p=(e>>>0)%(c>>>0)|0;else p=e&g;if((p|0)==(k|0))break;q=(f[a>>2]|0)+(p<<2)|0;if(!(f[q>>2]|0))break b;e=f[o>>2]|0;c:do if(!e)r=o;else{s=o+8|0;t=b[s+11>>0]|0;u=t<<24>>24<0;v=t&255;t=u?f[o+12>>2]|0:v;w=(t|0)==0;if(u){u=o;x=e;while(1){y=x+8|0;z=b[y+11>>0]|0;A=z<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:z&255)|0)){r=u;break c}if(!w?ZVb(f[s>>2]|0,A?f[y>>2]|0:y,t)|0:0){r=u;break c}y=f[x>>2]|0;if(!y){r=x;break c}else{A=x;x=y;u=A}}}if(w){u=o;x=e;while(1){A=b[x+8+11>>0]|0;if((A<<24>>24<0?f[x+12>>2]|0:A&255)|0){r=u;break c}A=f[x>>2]|0;if(!A){r=x;break c}else{y=x;x=A;u=y}}}u=o;x=e;while(1){w=x+8|0;y=b[w+11>>0]|0;A=y<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:y&255)|0)){r=u;break c}y=A?f[w>>2]|0:w;if((f[s>>2]&255)<<24>>24==(b[y>>0]|0)){B=s;C=v;D=y}else{r=u;break c}while(1){C=C+-1|0;B=B+1|0;if(!C)break;D=D+1|0;if((b[B>>0]|0)!=(b[D>>0]|0)){r=u;break c}}y=f[x>>2]|0;if(!y){r=x;break}else{w=x;x=y;u=w}}}while(0);f[j>>2]=f[r>>2];f[r>>2]=f[f[(f[a>>2]|0)+(p<<2)>>2]>>2];f[f[(f[a>>2]|0)+(p<<2)>>2]>>2]=o;e=f[d>>2]|0;if(!e){E=41;break a}else o=e}h=f[o>>2]|0;if(!h){E=41;break a}else{d=o;j=o}}f[q>>2]=j;m=f[o>>2]|0;if(!m){E=41;break}else{k=p;l=o;n=o}}if((E|0)==41)return}function nrb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+176|0;e=d+24|0;g=d+12|0;h=d;i=c+120|0;j=a+28|0;_5b(j,f[i>>2]|0)|0;k=a+4|0;l=f[k>>2]|0;f[e>>2]=(b[j+11>>0]|0)<0?f[j>>2]|0:j;j=crb(l+140|0,e)|0;if(j){l=f[j+12>>2]|0;if(l|0){WDb(e);qrb(l,e);if((f[l+64>>2]|0)==2?f[c+8>>2]&2048|0:0)rrb(e,450851);$ob(g,e);$ob(h,c);j=g+11|0;m=b[j>>0]|0;n=m<<24>>24<0;o=m&255;p=n?f[g+4>>2]|0:o;q=b[h+11>>0]|0;r=q<<24>>24<0;a:do if((p|0)==((r?f[h+4>>2]|0:q&255)|0)){s=f[g>>2]|0;t=n?s:g;v=r?f[h>>2]|0:h;w=(p|0)==0;if(n){if(w){x=1;break}x=(ZVb(t,v,p)|0)==0;break}if(!w)if((s&255)<<24>>24==(b[v>>0]|0)){s=g;w=o;t=v;while(1){w=w+-1|0;s=s+1|0;if(!w){x=1;break a}t=t+1|0;if((b[s>>0]|0)!=(b[t>>0]|0)){x=0;break}}}else x=0;else x=1}else x=0;while(0);if(r){O5b(f[h>>2]|0);y=b[j>>0]|0}else y=m;if(y<<24>>24<0)O5b(f[g>>2]|0);DDb(e);if(x){z=l;u=d;return z|0}}}l=f[k>>2]|0;x=l+4|0;g=f[x>>2]|0;y=f[l>>2]|0;m=g;j=y;b:do if((g|0)!=(y|0)){h=f[i>>2]|0;r=b[h+11>>0]|0;o=r<<24>>24<0;p=o?f[h+4>>2]|0:r&255;r=(p|0)==0;n=(g-y|0)/12|0;c:do if(o){q=0;while(1){t=j+(q*12|0)|0;s=b[t+11>>0]|0;w=s<<24>>24<0;v=s&255;do if(((w?f[j+(q*12|0)+4>>2]|0:v)|0)==(p|0)){s=f[t>>2]|0;A=w?s:t;B=f[h>>2]|0;if(w){if(r){C=q;break c}if(!(ZVb(A,B,p)|0)){C=q;break c}else break}if(r){C=q;break c}if((s&255)<<24>>24==(b[B>>0]|0)){s=t;A=v;D=B;do{A=A+-1|0;s=s+1|0;if(!A){C=q;break c}D=D+1|0}while((b[s>>0]|0)==(b[D>>0]|0))}}while(0);q=q+1|0;if(q>>>0>=n>>>0)break b}}else{q=0;while(1){v=j+(q*12|0)|0;t=b[v+11>>0]|0;w=t<<24>>24<0;D=t&255;do if(((w?f[j+(q*12|0)+4>>2]|0:D)|0)==(p|0)){t=f[v>>2]|0;s=w?t:v;if(w){if(r){C=q;break c}if(!(ZVb(s,h,p)|0)){C=q;break c}else break}if(r){C=q;break c}if((t&255)<<24>>24==(b[h>>0]|0)){t=v;s=D;A=h;do{s=s+-1|0;t=t+1|0;if(!s){C=q;break c}A=A+1|0}while((b[t>>0]|0)==(b[A>>0]|0))}}while(0);q=q+1|0;if(q>>>0>=n>>>0)break b}}while(0);srb(a,c,C);z=0;u=d;return z|0}while(0);if(f[(f[a>>2]|0)+4>>2]|0){C=f[i>>2]|0;if((m|0)==(f[l+8>>2]|0))JT(l,C);else{X5b(m,C);f[x>>2]=(f[x>>2]|0)+12}x=c+20|0;C=f[k>>2]|0;if((f[x>>2]|0)>0){m=c+28|0;l=0;i=C;while(1){j=f[(f[m>>2]|0)+4+(l<<2)>>2]|0;f[e>>2]=(b[j+11>>0]|0)<0?f[j>>2]|0:j;j=crb(i+140|0,e)|0;if(!((j|0)!=0?(f[j+12>>2]|0)!=0:0))E=54;do if((E|0)==54){E=0;j=f[a>>2]|0;y=f[j+12>>2]|0;if(!y)F=j;else{if(hrb(y,f[(f[m>>2]|0)+4+(l<<2)>>2]|0)|0)break;F=f[a>>2]|0}irb(F,f[(f[m>>2]|0)+4+(l<<2)>>2]|0)|0}while(0);l=l+1|0;y=f[k>>2]|0;if((l|0)>=(f[x>>2]|0)){G=y;break}else i=y}}else G=C;C=G+4|0;G=f[C>>2]|0;i=G+-12|0;x=G;while(1){G=x+-12|0;f[C>>2]=G;if((b[G+11>>0]|0)<0){O5b(f[G>>2]|0);H=f[C>>2]|0}else H=G;if((H|0)==(i|0))break;else x=H}}z=trb(a,c)|0;u=d;return z|0}function orb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+88|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);c=a+76|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);prb(a+60|0,f[a+64>>2]|0);prb(a+48|0,f[a+52>>2]|0);c=a+28|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);c=a+12|0;d=f[c>>2]|0;if(!d)return;e=a+16|0;a=f[e>>2]|0;if((a|0)==(d|0))g=d;else{h=a;do{a=h+-32|0;f[e>>2]=a;i=h+-20|0;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);h=f[e>>2]|0}while((h|0)!=(d|0));g=f[c>>2]|0}O5b(g);return}function prb(a,b){a=a|0;b=b|0;if(!b)return;else{prb(a,f[b>>2]|0);prb(a,f[b+4>>2]|0);O5b(b);return}}function qrb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=f[a>>2]|0;e=c+8|0;f[e>>2]=f[e>>2]|1;g=c+120|0;h=f[g>>2]|0;if((h|0)==497760)jza(g,d);else _5b(h,d)|0;d=f[a+4>>2]|0;h=b[d+11>>0]|0;if(h<<24>>24<0)i=f[d+4>>2]|0;else i=h&255;do if(i|0){f[e>>2]=f[e>>2]|2;h=c+124|0;g=f[h>>2]|0;if((g|0)==497760){jza(h,d);break}else{_5b(g,d)|0;break}}while(0);if((f[a+64>>2]|0)==3)rrb(c,hqb(3)|0);d=a+12|0;if((f[d>>2]|0)>0){i=a+16|0;g=c+16|0;h=0;do{j=f[f[(f[i>>2]|0)+(h<<2)>>2]>>2]|0;_5b(mza(g)|0,j)|0;h=h+1|0}while((h|0)<(f[d>>2]|0))}d=a+20|0;if((f[d>>2]|0)>0){h=a+24|0;g=c+32|0;i=c+36|0;j=c+40|0;k=0;do{l=f[(f[h>>2]|0)+(k<<2)>>2]|0;m=f[g>>2]|0;if((m|0)==(f[i>>2]|0)){nza(g,m+1|0);n=f[g>>2]|0}else n=m;m=f[j>>2]|0;f[g>>2]=n+1;f[m+4+(n<<2)>>2]=l;k=k+1|0}while((k|0)<(f[d>>2]|0))}d=a+28|0;if((f[d>>2]|0)>0){k=a+32|0;n=c+44|0;g=c+48|0;j=c+52|0;i=0;do{h=f[(f[k>>2]|0)+(i<<2)>>2]|0;l=f[n>>2]|0;if((l|0)==(f[g>>2]|0)){nza(n,l+1|0);o=f[n>>2]|0}else o=l;l=f[j>>2]|0;f[n>>2]=o+1;f[l+4+(o<<2)>>2]=h;i=i+1|0}while((i|0)<(f[d>>2]|0))}d=a+36|0;if((f[d>>2]|0)>0){i=a+40|0;o=c+56|0;n=c+68|0;j=c+64|0;g=c+60|0;k=0;do{h=(f[i>>2]|0)+(k*88|0)|0;l=f[n>>2]|0;do if(l){m=f[g>>2]|0;p=f[l>>2]|0;if((m|0)>=(p|0))if((p|0)==(f[j>>2]|0)){q=p;r=35;break}else{s=p;t=l;r=36;break}else{f[g>>2]=m+1;u=f[l+4+(m<<2)>>2]|0;break}}else{q=f[j>>2]|0;r=35}while(0);if((r|0)==35){r=0;cpb(o,q+1|0);l=f[n>>2]|0;s=f[l>>2]|0;t=l;r=36}if((r|0)==36){r=0;f[t>>2]=s+1;l=ztb(0,f[o>>2]|0)|0;m=f[n>>2]|0;p=f[g>>2]|0;f[g>>2]=p+1;f[m+4+(p<<2)>>2]=l;u=l}Atb(h,u);k=k+1|0}while((k|0)<(f[d>>2]|0))}d=a+44|0;if((f[d>>2]|0)>0){k=a+48|0;u=c+72|0;g=c+84|0;n=c+80|0;o=c+76|0;s=0;do{t=(f[k>>2]|0)+(s<<5)|0;q=f[g>>2]|0;do if(q){j=f[o>>2]|0;i=f[q>>2]|0;if((j|0)>=(i|0))if((i|0)==(f[n>>2]|0)){v=i;r=45;break}else{w=i;x=q;r=46;break}else{f[o>>2]=j+1;y=f[q+4+(j<<2)>>2]|0;break}}else{v=f[n>>2]|0;r=45}while(0);if((r|0)==45){r=0;cpb(u,v+1|0);q=f[g>>2]|0;w=f[q>>2]|0;x=q;r=46}if((r|0)==46){r=0;f[x>>2]=w+1;q=Btb(0,f[u>>2]|0)|0;h=f[g>>2]|0;j=f[o>>2]|0;f[o>>2]=j+1;f[h+4+(j<<2)>>2]=q;y=q}Ctb(t,y);s=s+1|0}while((s|0)<(f[d>>2]|0))}d=a+52|0;if((f[d>>2]|0)>0){s=a+56|0;y=c+88|0;o=c+100|0;g=c+96|0;u=c+92|0;w=0;do{x=(f[s>>2]|0)+(w*24|0)|0;v=f[o>>2]|0;do if(v){n=f[u>>2]|0;k=f[v>>2]|0;if((n|0)>=(k|0))if((k|0)==(f[g>>2]|0)){z=k;r=55;break}else{A=k;B=v;r=56;break}else{f[u>>2]=n+1;C=f[v+4+(n<<2)>>2]|0;break}}else{z=f[g>>2]|0;r=55}while(0);if((r|0)==55){r=0;cpb(y,z+1|0);v=f[o>>2]|0;A=f[v>>2]|0;B=v;r=56}if((r|0)==56){r=0;f[B>>2]=A+1;v=Dtb(0,f[y>>2]|0)|0;t=f[o>>2]|0;n=f[u>>2]|0;f[u>>2]=n+1;f[t+4+(n<<2)>>2]=v;C=v}Etb(x,C);w=w+1|0}while((w|0)<(f[d>>2]|0))}d=a+60|0;if((f[d>>2]|0)>0){w=a+72|0;C=c+104|0;u=c+116|0;o=c+112|0;y=c+108|0;A=0;do{B=(f[w>>2]|0)+(A*88|0)|0;z=f[u>>2]|0;do if(z){g=f[y>>2]|0;s=f[z>>2]|0;if((g|0)>=(s|0))if((s|0)==(f[o>>2]|0)){D=s;r=64;break}else{E=s;F=z;r=65;break}else{f[y>>2]=g+1;G=f[z+4+(g<<2)>>2]|0;break}}else{D=f[o>>2]|0;r=64}while(0);if((r|0)==64){r=0;cpb(C,D+1|0);z=f[u>>2]|0;E=f[z>>2]|0;F=z;r=65}if((r|0)==65){r=0;f[F>>2]=E+1;z=Ftb(0,f[C>>2]|0)|0;x=f[u>>2]|0;g=f[y>>2]|0;f[y>>2]=g+1;f[x+4+(g<<2)>>2]=z;G=z}Gtb(B,G);A=A+1|0}while((A|0)<(f[d>>2]|0))}d=a+76|0;a=f[d>>2]|0;if((a|0)==(fEb()|0))return;f[e>>2]=f[e>>2]|512;e=c+132|0;c=f[e>>2]|0;if(!c){a=L5b(80)|0;aAb(a);f[e>>2]=a;H=a}else H=c;gEb(H,f[d>>2]|0);return}function rrb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|2048;g=a+128|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=kUb(c)|0;if(a>>>0>4294967279)V5b(e);if(a>>>0<11){b[e+11>>0]=a;if(!a)h=e;else{i=e;j=6}}else{k=a+16&-16;l=L5b(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=a;i=l;j=6}if((j|0)==6){Vac(i|0,c|0,a|0)|0;h=i}b[h+a>>0]=0;a=f[g>>2]|0;if((a|0)==497760)jza(g,e);else _5b(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}O5b(f[e>>2]|0);u=d;return}function srb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=L5b(48)|0;f[g>>2]=h;f[g+8>>2]=-2147483600;f[g+4>>2]=33;i=h;j=459340;k=i+33|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+33>>0]=0;h=a+4|0;j=f[h>>2]|0;if((((f[j+4>>2]|0)-(f[j>>2]|0)|0)/12|0)>>>0>d>>>0){i=d;d=j;do{j=f[d>>2]|0;k=j+(i*12|0)|0;l=b[k+11>>0]|0;m=l<<24>>24<0;j6b(g,m?f[k>>2]|0:k,m?f[j+(i*12|0)+4>>2]|0:l&255)|0;k6b(g,459374)|0;i=i+1|0;d=f[h>>2]|0}while(i>>>0<(((f[d+4>>2]|0)-(f[d>>2]|0)|0)/12|0)>>>0)}d=c+120|0;i=f[d>>2]|0;h=b[i+11>>0]|0;l=h<<24>>24<0;j6b(g,l?f[i>>2]|0:i,l?f[i+4>>2]|0:h&255)|0;wrb(a,f[d>>2]|0,c,9,g);if((b[g+11>>0]|0)>=0){u=e;return}O5b(f[g>>2]|0);u=e;return}function trb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0;d=u;u=u+224|0;e=d+180|0;g=d+168|0;h=d+144|0;i=d+211|0;j=d+120|0;k=d+210|0;l=d+96|0;m=d+209|0;n=d+72|0;o=d+208|0;p=d+56|0;q=d+44|0;r=d+32|0;s=d;t=a+4|0;v=f[t>>2]|0;f[e>>2]=(f[v+76>>2]|0)-(f[v+72>>2]|0)>>2;f[e+4>>2]=(f[v+88>>2]|0)-(f[v+84>>2]|0)>>2;f[e+8>>2]=(f[v+100>>2]|0)-(f[v+96>>2]|0)>>2;f[e+12>>2]=(f[v+112>>2]|0)-(f[v+108>>2]|0)>>2;f[e+16>>2]=(f[v+188>>2]|0)-(f[v+184>>2]|0)>>2;f[e+20>>2]=(f[v+200>>2]|0)-(f[v+196>>2]|0)>>2;f[e+24>>2]=(f[v+212>>2]|0)-(f[v+208>>2]|0)>>3;w=v+176|0;x=f[w>>2]|0;if((x|0)==(f[v+180>>2]|0))zqb(v+172|0,e);else{f[x>>2]=f[e>>2];f[x+4>>2]=f[e+4>>2];f[x+8>>2]=f[e+8>>2];f[x+12>>2]=f[e+12>>2];f[x+16>>2]=f[e+16>>2];f[x+20>>2]=f[e+20>>2];f[x+24>>2]=f[e+24>>2];f[w>>2]=(f[w>>2]|0)+28}w=f[t>>2]|0;x=L5b(88)|0;f[e>>2]=x;v=w+112|0;y=f[v>>2]|0;if((y|0)==(f[w+116>>2]|0))HO(w+108|0,e);else{f[y>>2]=x;f[v>>2]=(f[v>>2]|0)+4}v=f[e>>2]|0;x=a+40|0;f[x>>2]=v;b[v+68>>0]=0;y=c+8|0;if(!(f[y>>2]&1024))z=vEb()|0;else{w=f[t>>2]|0;A=L5b(32)|0;vwb(A);f[e>>2]=A;B=w+88|0;C=f[B>>2]|0;if((C|0)==(f[w+92>>2]|0))urb(w+84|0,e);else{f[C>>2]=A;f[B>>2]=(f[B>>2]|0)+4}B=f[c+136>>2]|0;wEb(A,(B|0)==0?499128:B);z=A}f[v+84>>2]=z;z=f[t>>2]|0;A=L5b(148)|0;qqb(A);f[e>>2]=A;B=z+100|0;C=f[B>>2]|0;if((C|0)==(f[z+104>>2]|0))Sqb(z+96|0,e);else{f[C>>2]=A;f[B>>2]=(f[B>>2]|0)+4}B=f[e>>2]|0;f[a+44>>2]=B;f[(f[x>>2]|0)+80>>2]=B;if((f[y>>2]&1|0)==0?(f[e>>2]=0,f[e+4>>2]=0,f[e+8>>2]=0,vrb(a,e,c,9,451046),(b[e+11>>0]|0)<0):0)O5b(f[e>>2]|0);B=c+128|0;A=f[B>>2]|0;C=b[A+11>>0]|0;z=C<<24>>24<0;if(z)D=f[A+4>>2]|0;else D=C&255;a:do if(D){w=f[A+4>>2]|0;if(((z?w:C&255)|0)==6){if(!(u6b(A,0,-1,450851,6)|0)){E=27;break}F=f[B>>2]|0;G=b[F+11>>0]|0;H=f[F+4>>2]|0;I=F}else{G=C;H=w;I=A}do if(((G<<24>>24<0?H:G&255)|0)==6){w=(u6b(I,0,-1,450844,6)|0)==0;F=(f[x>>2]|0)+64|0;if(w){f[F>>2]=3;break a}else{J=F;K=f[B>>2]|0;break}}else{J=(f[x>>2]|0)+64|0;K=I}while(0);f[J>>2]=0;F=f[c+120>>2]|0;dua(e,451087,K);wrb(a,F,c,9,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0)}else E=27;while(0);if((E|0)==27)f[(f[x>>2]|0)+64>>2]=2;x=f[t>>2]|0;K=c+120|0;J=f[K>>2]|0;I=L5b(12)|0;X5b(I,J);f[e>>2]=I;J=x+76|0;B=f[J>>2]|0;if((B|0)==(f[x+80>>2]|0))Rqb(x+72|0,e);else{f[B>>2]=I;f[J>>2]=(f[J>>2]|0)+4}f[v>>2]=f[e>>2];J=f[t>>2]|0;if(!(f[y>>2]&2)){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;I=L5b(12)|0;X5b(I,g);f[e>>2]=I;B=J+76|0;x=f[B>>2]|0;if((x|0)==(f[J+80>>2]|0))Rqb(J+72|0,e);else{f[x>>2]=I;f[B>>2]=(f[B>>2]|0)+4}f[v+4>>2]=f[e>>2];if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0)}else{B=f[c+124>>2]|0;I=L5b(12)|0;X5b(I,B);f[e>>2]=I;B=J+76|0;x=f[B>>2]|0;if((x|0)==(f[J+80>>2]|0))Rqb(J+72|0,e);else{f[x>>2]=I;f[B>>2]=(f[B>>2]|0)+4}f[v+4>>2]=f[e>>2]}f[v+8>>2]=f[a>>2];B=f[t>>2]|0;I=f[v>>2]|0;if((b[I+11>>0]|0)<0)L=f[I>>2]|0;else L=I;f[e>>2]=L;f[e+4>>2]=v;if(!(Kqb(B+140|0,e)|0)){vrb(a,f[K>>2]|0,c,9,451109);Aqb(f[t>>2]|0);M=0;u=d;return M|0}L=f[v>>2]|0;if((b[L+11>>0]|0)<0)N=f[L>>2]|0;else N=L;f[e>>2]=N;L=B+200|0;I=f[L>>2]|0;if((I|0)==(f[B+204>>2]|0))Lqb(B+196|0,e);else{f[I>>2]=N;f[L>>2]=(f[L>>2]|0)+4}L=v+4|0;N=f[L>>2]|0;I=b[N+11>>0]|0;if(I<<24>>24<0)O=f[N+4>>2]|0;else O=I&255;if(O|0)xrb(a,N,c,v);N=q+4|0;f[N>>2]=0;O=q+8|0;f[O>>2]=0;I=q+4|0;f[q>>2]=I;B=c+20|0;x=f[B>>2]|0;J=v+12|0;f[J>>2]=x;G=f[t>>2]|0;H=x<<2;if(!H)P=0;else{x=L5b(H)|0;f[e>>2]=x;H=G+112|0;A=f[H>>2]|0;if((A|0)==(f[G+116>>2]|0))HO(G+108|0,e);else{f[A>>2]=x;f[H>>2]=(f[H>>2]|0)+4}P=f[e>>2]|0}H=v+16|0;f[H>>2]=P;P=a+60|0;x=a+64|0;prb(P,f[x>>2]|0);A=a+68|0;f[A>>2]=0;f[P>>2]=x;f[x>>2]=0;G=r+4|0;f[G>>2]=0;C=r+8|0;f[C>>2]=0;z=r+4|0;f[r>>2]=z;D=c+44|0;F=f[D>>2]|0;b:do if((F|0)>0){w=c+52|0;Q=0;R=0;S=F;while(1){T=f[(f[w>>2]|0)+4+(Q<<2)>>2]|0;do if(R){U=G;V=R;while(1){W=f[V+16>>2]|0;if((T|0)<(W|0)){X=f[V>>2]|0;if(!X){E=79;break}else{Y=V;Z=X}}else{if((W|0)>=(T|0)){E=83;break}_=V+4|0;W=f[_>>2]|0;if(!W){E=82;break}else{Y=_;Z=W}}U=Y;V=Z}if((E|0)==79){E=0;$=V;aa=V;break}else if((E|0)==82){E=0;$=_;aa=V;break}else if((E|0)==83){E=0;$=U;aa=V;break}}else{$=z;aa=z}while(0);if(!(f[$>>2]|0)){W=L5b(20)|0;f[W+16>>2]=T;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=aa;f[$>>2]=W;X=f[f[r>>2]>>2]|0;if(!X)ba=W;else{f[r>>2]=X;ba=f[$>>2]|0}mP(f[G>>2]|0,ba);f[C>>2]=(f[C>>2]|0)+1;ca=f[D>>2]|0}else ca=S;X=Q+1|0;if((X|0)>=(ca|0))break b;Q=X;R=f[z>>2]|0;S=ca}}while(0);if((f[B>>2]|0)>0){ca=c+28|0;C=a+64|0;ba=0;do{G=f[(f[ca>>2]|0)+4+(ba<<2)>>2]|0;$=lP(q,e,G)|0;if(!(f[$>>2]|0)){aa=L5b(28)|0;X5b(aa+16|0,G);G=f[e>>2]|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=G;f[$>>2]=aa;G=f[f[q>>2]>>2]|0;if(!G)da=aa;else{f[q>>2]=G;da=f[$>>2]|0}mP(f[N>>2]|0,da);f[O>>2]=(f[O>>2]|0)+1}else yrb(a,c,ba);$=f[t>>2]|0;G=f[(f[ca>>2]|0)+4+(ba<<2)>>2]|0;f[e>>2]=(b[G+11>>0]|0)<0?f[G>>2]|0:G;G=crb($+140|0,e)|0;if(G){$=f[G+12>>2]|0;G=$;if(!$){ea=G;E=98}else fa=G}else{ea=0;E=98}do if((E|0)==98){E=0;G=f[(f[a>>2]|0)+12>>2]|0;if(!G){fa=ea;break}fa=hrb(G,f[(f[ca>>2]|0)+4+(ba<<2)>>2]|0)|0}while(0);G=fa;$=f[a>>2]|0;c:do if(!fa){d:do if(!(b[$+21>>0]|0)){do if(!(b[$+22>>0]|0)){aa=f[z>>2]|0;if(!aa)break;else{ga=z;ha=aa}e:while(1){aa=ha;while(1){if((f[aa+16>>2]|0)>=(ba|0))break;_=f[aa+4>>2]|0;if(!_){ia=ga;break e}else aa=_}ha=f[aa>>2]|0;if(!ha){ia=aa;break}else ga=aa}if((ia|0)==(z|0))break;if((ba|0)>=(f[ia+16>>2]|0))break d}while(0);Arb(a,c,ba);ja=0;break c}while(0);ja=zrb(a,f[(f[ca>>2]|0)+4+(ba<<2)>>2]|0)|0}else{if(!(b[$+20>>0]|0)){ja=fa;break}T=Brb($+24|0,f[K>>2]|0)|0;if((T|0)==((f[a>>2]|0)+28|0)){ja=fa;break}if(f[G+20>>2]|0){ja=fa;break}T=f[x>>2]|0;do if(T){V=C;U=T;while(1){_=f[U+16>>2]|0;if(G>>>0<_>>>0){Z=f[U>>2]|0;if(!Z){E=119;break}else{ka=U;la=Z}}else{if(_>>>0>=G>>>0){E=123;break}ma=U+4|0;_=f[ma>>2]|0;if(!_){E=122;break}else{ka=ma;la=_}}V=ka;U=la}if((E|0)==119){E=0;na=U;oa=U;break}else if((E|0)==122){E=0;na=ma;oa=U;break}else if((E|0)==123){E=0;na=V;oa=U;break}}else{na=x;oa=x}while(0);if(f[na>>2]|0){ja=fa;break}T=L5b(20)|0;f[T+16>>2]=fa;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=oa;f[na>>2]=T;_=f[f[P>>2]>>2]|0;if(!_)pa=T;else{f[P>>2]=_;pa=f[na>>2]|0}mP(f[C>>2]|0,pa);f[A>>2]=(f[A>>2]|0)+1;ja=fa}while(0);f[(f[H>>2]|0)+(ba<<2)>>2]=ja;ba=ba+1|0}while((ba|0)<(f[B>>2]|0))}ba=f[t>>2]|0;ja=c+32|0;fa=f[ja>>2]|0;pa=fa<<2;if(!pa){qa=0;ra=fa}else{fa=L5b(pa)|0;f[e>>2]=fa;pa=ba+112|0;C=f[pa>>2]|0;if((C|0)==(f[ba+116>>2]|0))HO(ba+108|0,e);else{f[C>>2]=fa;f[pa>>2]=(f[pa>>2]|0)+4}qa=f[e>>2]|0;ra=f[ja>>2]|0}pa=v+24|0;f[pa>>2]=qa;if((ra|0)>0){ra=c+40|0;qa=0;fa=0;while(1){C=f[(f[ra>>2]|0)+4+(qa<<2)>>2]|0;if((C|0)>-1?(C|0)<(f[B>>2]|0):0){f[(f[pa>>2]|0)+(fa<<2)>>2]=C;ba=f[(f[H>>2]|0)+(C<<2)>>2]|0;C=f[x>>2]|0;do if(C|0){na=x;oa=C;f:while(1){ma=oa;while(1){if((f[ma+16>>2]|0)>>>0>=ba>>>0)break;la=f[ma+4>>2]|0;if(!la){sa=na;break f}else ma=la}oa=f[ma>>2]|0;if(!oa){sa=ma;break}else na=ma}if((sa|0)==(x|0))break;if(ba>>>0<(f[sa+16>>2]|0)>>>0)break;na=f[sa+4>>2]|0;do if(!na){oa=sa+8|0;U=f[oa>>2]|0;if((f[U>>2]|0)==(sa|0)){ta=U;break}else ua=oa;do{oa=f[ua>>2]|0;ua=oa+8|0;U=f[ua>>2]|0}while((f[U>>2]|0)!=(oa|0));ta=U}else{ma=na;while(1){U=f[ma>>2]|0;if(!U)break;else ma=U}ta=ma}while(0);if((f[P>>2]|0)==(sa|0))f[P>>2]=ta;f[A>>2]=(f[A>>2]|0)+-1;wwa(C,sa);O5b(sa)}while(0);va=fa+1|0}else{vrb(a,f[K>>2]|0,c,9,451155);va=fa}qa=qa+1|0;if((qa|0)>=(f[ja>>2]|0)){wa=va;break}else fa=va}}else wa=0;f[v+20>>2]=wa;wa=a+48|0;va=a+52|0;prb(wa,f[va>>2]|0);f[a+56>>2]=0;f[wa>>2]=va;f[va>>2]=0;if((f[J>>2]|0)>0){va=0;do{Crb(a,f[(f[H>>2]|0)+(va<<2)>>2]|0);va=va+1|0}while((va|0)<(f[J>>2]|0))}J=f[t>>2]|0;va=f[D>>2]|0;H=va<<2;if(!H){xa=0;ya=va}else{va=L5b(H)|0;f[e>>2]=va;H=J+112|0;wa=f[H>>2]|0;if((wa|0)==(f[J+116>>2]|0))HO(J+108|0,e);else{f[wa>>2]=va;f[H>>2]=(f[H>>2]|0)+4}xa=f[e>>2]|0;ya=f[D>>2]|0}H=v+32|0;f[H>>2]=xa;if((ya|0)>0){ya=c+52|0;xa=0;va=0;while(1){wa=f[(f[ya>>2]|0)+4+(xa<<2)>>2]|0;if((wa|0)>-1?(wa|0)<(f[B>>2]|0):0){f[(f[H>>2]|0)+(va<<2)>>2]=wa;za=va+1|0}else{vrb(a,f[K>>2]|0,c,9,451188);za=va}xa=xa+1|0;if((xa|0)>=(f[D>>2]|0)){Aa=za;break}else va=za}}else Aa=0;f[v+28>>2]=Aa;Aa=c+60|0;za=f[Aa>>2]|0;f[v+36>>2]=za;va=v+40|0;D=f[t>>2]|0;xa=za*88|0;if(!xa){Ba=0;Ca=za}else{za=L5b(xa)|0;f[e>>2]=za;xa=D+112|0;K=f[xa>>2]|0;if((K|0)==(f[D+116>>2]|0))HO(D+108|0,e);else{f[K>>2]=za;f[xa>>2]=(f[xa>>2]|0)+4}Ba=f[e>>2]|0;Ca=f[Aa>>2]|0}f[va>>2]=Ba;g:do if((Ca|0)>0){xa=c+68|0;za=0;K=Ba;while(1){Drb(a,f[(f[xa>>2]|0)+4+(za<<2)>>2]|0,0,K+(za*88|0)|0);D=za+1|0;if((D|0)>=(f[Aa>>2]|0))break g;za=D;K=f[va>>2]|0}}while(0);Ba=c+76|0;Ca=f[Ba>>2]|0;f[v+44>>2]=Ca;K=v+48|0;za=f[t>>2]|0;xa=Ca<<5;if(!xa){Da=0;Ea=Ca}else{Ca=L5b(xa)|0;f[e>>2]=Ca;xa=za+112|0;D=f[xa>>2]|0;if((D|0)==(f[za+116>>2]|0))HO(za+108|0,e);else{f[D>>2]=Ca;f[xa>>2]=(f[xa>>2]|0)+4}Da=f[e>>2]|0;Ea=f[Ba>>2]|0}f[K>>2]=Da;h:do if((Ea|0)>0){xa=c+84|0;Ca=0;D=Da;while(1){Erb(a,f[(f[xa>>2]|0)+4+(Ca<<2)>>2]|0,0,D+(Ca<<5)|0);za=Ca+1|0;if((za|0)>=(f[Ba>>2]|0))break h;Ca=za;D=f[K>>2]|0}}while(0);K=c+92|0;Ba=f[K>>2]|0;f[v+52>>2]=Ba;Da=v+56|0;Ea=f[t>>2]|0;D=Ba*24|0;if(!D){Fa=0;Ga=Ba}else{Ba=L5b(D)|0;f[e>>2]=Ba;D=Ea+112|0;Ca=f[D>>2]|0;if((Ca|0)==(f[Ea+116>>2]|0))HO(Ea+108|0,e);else{f[Ca>>2]=Ba;f[D>>2]=(f[D>>2]|0)+4}Fa=f[e>>2]|0;Ga=f[K>>2]|0}f[Da>>2]=Fa;i:do if((Ga|0)>0){D=c+100|0;Ba=0;Ca=Fa;while(1){Frb(a,f[(f[D>>2]|0)+4+(Ba<<2)>>2]|0,0,Ca+(Ba*24|0)|0);Ea=Ba+1|0;if((Ea|0)>=(f[K>>2]|0))break i;Ba=Ea;Ca=f[Da>>2]|0}}while(0);Da=c+108|0;K=f[Da>>2]|0;f[v+60>>2]=K;Fa=v+72|0;Ga=f[t>>2]|0;Ca=K*88|0;if(!Ca){Ha=0;Ia=K}else{K=L5b(Ca)|0;f[e>>2]=K;Ca=Ga+112|0;Ba=f[Ca>>2]|0;if((Ba|0)==(f[Ga+116>>2]|0))HO(Ga+108|0,e);else{f[Ba>>2]=K;f[Ca>>2]=(f[Ca>>2]|0)+4}Ha=f[e>>2]|0;Ia=f[Da>>2]|0}f[Fa>>2]=Ha;j:do if((Ia|0)>0){Ca=c+116|0;K=0;Ba=Ha;while(1){Grb(a,f[(f[Ca>>2]|0)+4+(K<<2)>>2]|0,0,Ba+(K*88|0)|0,1);Ga=K+1|0;if((Ga|0)>=(f[Da>>2]|0))break j;K=Ga;Ba=f[Fa>>2]|0}}while(0);if(f[y>>2]&512){y=f[c+132>>2]|0;eua(e,f[L>>2]|0,451219);Hrb(a,e,f[v>>2]|0,(y|0)==0?498480:y,v);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0)}else f[v+76>>2]=0;Irb(a,v,c);y=a+24|0;do if(!(b[y>>0]|0)){Jrb(s,a);L=a+12|0;Fa=f[L>>2]|0;Da=a+16|0;do if((Fa|0)!=(f[Da>>2]|0)){Ha=s+4|0;Ia=g+8|0;Ba=g+4|0;K=g+8|0;Ca=g+4|0;Ga=s+8|0;D=e+11|0;Ea=g+11|0;xa=p+11|0;za=e+4|0;H=e+4|0;B=Fa;do{ya=f[B+28>>2]|0;wa=f[B+24>>2]|0;f[Ha>>2]=B;zh[f[(f[ya>>2]|0)+96>>2]&2047](e,ya);J=f[e>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;fa=L5b(32)|0;f[g>>2]=fa;f[Ia>>2]=-2147483616;f[Ba>>2]=20;ja=fa;qa=451226;sa=ja+20|0;do{b[ja>>0]=b[qa>>0]|0;ja=ja+1|0;qa=qa+1|0}while((ja|0)<(sa|0));b[fa+20>>0]=0;Krb(e,f[(f[J+8>>2]|0)+80>>2]|0,J,g,2);if(!(f[e>>2]|0))Ja=0;else{ma=f[H>>2]|0;Ja=b[ma+40>>0]|0?0:ma}O5b(fa);if(!Ja){zpb(h,3,450744,5732);xpb(i,vpb(vpb(h,451247)|0,451299)|0);Apb(h)}ma=di[f[(f[ya>>2]|0)+92>>2]&1023](ya)|0;_h[f[(f[ma>>2]|0)+28>>2]&255](ma,ya,Ja);zh[f[(f[wa>>2]|0)+96>>2]&2047](e,wa);ma=f[e>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;ta=L5b(32)|0;f[g>>2]=ta;f[K>>2]=-2147483616;f[Ca>>2]=20;ja=ta;qa=451226;sa=ja+20|0;do{b[ja>>0]=b[qa>>0]|0;ja=ja+1|0;qa=qa+1|0}while((ja|0)<(sa|0));b[ta+20>>0]=0;Krb(e,f[(f[ma+8>>2]|0)+80>>2]|0,ma,g,2);if(!(f[e>>2]|0))Ka=0;else{qa=f[za>>2]|0;Ka=b[qa+40>>0]|0?0:qa}O5b(ta);if(!Ka){zpb(j,3,450744,5740);xpb(k,vpb(vpb(j,451359)|0,451299)|0);Apb(j)}qa=di[f[(f[wa>>2]|0)+92>>2]&1023](wa)|0;ja=li[f[(f[qa>>2]|0)+24>>2]&511](qa,wa,Ka)|0;k:do if((ja|0)>0){qa=0;while(1){sa=di[f[(f[wa>>2]|0)+92>>2]&1023](wa)|0;fa=Dg[f[(f[sa>>2]|0)+208>>2]&127](sa,wa,Ka,qa)|0;f[Ga>>2]=fa;qa=qa+1|0;if(!(Lrb(s,ya)|0))break;if((qa|0)>=(ja|0)){E=231;break k}}f[Ga>>2]=0;f[Ha>>2]=0}else E=231;while(0);if((E|0)==231){E=0;f[Ga>>2]=0;f[Ha>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(!(Zob(ya,e)|0)){zpb(l,3,450744,5769);xpb(m,vpb(vpb(l,451420)|0,451473)|0);Apb(l)}if(!(Vob(ya,e)|0)){zpb(n,3,450744,5771);xpb(o,vpb(vpb(n,451515)|0,451568)|0);Apb(n)}if(!(di[f[(f[ya>>2]|0)+32>>2]&1023](ya)|0)){ja=f[s>>2]|0;zh[f[(f[ya>>2]|0)+36>>2]&2047](p,ya);dua(g,451623,p);Mrb(ja,B+12|0,wa,9,g);if((b[Ea>>0]|0)<0)O5b(f[g>>2]|0);if((b[xa>>0]|0)<0)O5b(f[p>>2]|0)}if((b[D>>0]|0)<0)O5b(f[e>>2]|0)}B=B+32|0}while((B|0)!=(f[Da>>2]|0));D=f[L>>2]|0;if((B|0)==(D|0))break;else La=B;do{xa=La+-32|0;f[Da>>2]=xa;Ea=La+-20|0;if((b[Ea+11>>0]|0)<0)O5b(f[Ea>>2]|0);if((b[xa+11>>0]|0)<0)O5b(f[xa>>2]|0);La=f[Da>>2]|0}while((La|0)!=(D|0))}while(0);nFb(s+12|0);if(b[y>>0]|0){E=246;break}Nrb(a,v,c);if((b[y>>0]|0)!=0&(f[Aa>>2]|0)>0)E=247}else E=246;while(0);if((E|0)==246?(f[Aa>>2]|0)>0:0)E=247;if((E|0)==247){E=c+68|0;s=0;do{Orb(a,(f[va>>2]|0)+(s*88|0)|0,f[(f[E>>2]|0)+4+(s<<2)>>2]|0);s=s+1|0}while((s|0)<(f[Aa>>2]|0))}if(f[A>>2]|0)Prb(a,c,0);c=f[t>>2]|0;do if(!(b[y>>0]|0)){t=c+176|0;a=(f[t>>2]|0)+-28|0;f[t>>2]=a;if((f[c+172>>2]|0)!=(a|0)){Ma=v;break}a=f[c+184>>2]|0;t=c+188|0;A=f[t>>2]|0;if((A|0)!=(a|0))f[t>>2]=A+(~((A+-4-a|0)>>>2)<<2);a=f[c+196>>2]|0;A=c+200|0;t=f[A>>2]|0;if((t|0)!=(a|0))f[A>>2]=t+(~((t+-4-a|0)>>>2)<<2);a=f[c+208>>2]|0;t=c+212|0;A=f[t>>2]|0;if((A|0)==(a|0)){Ma=v;break}f[t>>2]=A+(~((A+-8-a|0)>>>3)<<3);Ma=v}else{Aqb(c);Ma=0}while(0);Tua(r,f[z>>2]|0);kP(q,f[I>>2]|0);M=Ma;u=d;return M|0}function urb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function vrb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;j=kUb(g)|0;if(j>>>0>4294967279)V5b(i);if(j>>>0<11){b[i+11>>0]=j;if(!j)k=i;else{l=i;m=6}}else{n=j+16&-16;o=L5b(n)|0;f[i>>2]=o;f[i+8>>2]=n|-2147483648;f[i+4>>2]=j;l=o;m=6}if((m|0)==6){Vac(l|0,g|0,j|0)|0;k=l}b[k+j>>0]=0;wrb(a,c,d,e,i);if((b[i+11>>0]|0)>=0){u=h;return}O5b(f[i>>2]|0);u=h;return}function wrb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+64|0;i=h+24|0;j=h;k=f[a+8>>2]|0;if(k|0){Wg[f[(f[k>>2]|0)+8>>2]&127](k,a+28|0,c,d,e,g);l=a+24|0;b[l>>0]=1;u=h;return}e=a+24|0;if(!(b[e>>0]|0)){zpb(i,2,450744,3369);xpb(h+49|0,vpb(wpb(vpb(i,459301)|0,a+28|0)|0,459337)|0);Apb(i)}zpb(j,2,450744,3372);xpb(h+48|0,wpb(vpb(wpb(vpb(j,475796)|0,c)|0,475786)|0,g)|0);Apb(j);l=e;b[l>>0]=1;u=h;return}function xrb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+80|0;h=g+56|0;i=g+48|0;j=g+36|0;k=g+24|0;l=g+12|0;m=g;n=a+4|0;o=f[n>>2]|0;f[i>>2]=8;f[i+4>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];if(htb(o,c,h)|0){o=t6b(c,46,-1)|0;if((o|0)==-1){etb(a,c,c,d);u=g;return}i=f[n>>2]|0;Y5b(j,c,0,o,c);p=L5b(12)|0;X5b(p,j);f[h>>2]=p;q=i+76|0;r=f[q>>2]|0;if((r|0)==(f[i+80>>2]|0))Rqb(i+72|0,h);else{f[r>>2]=p;f[q>>2]=(f[q>>2]|0)+4}q=f[h>>2]|0;if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);xrb(a,q,d,e);Y5b(h,c,o+1|0,-1,c);etb(a,h,c,d);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);u=g;return}Zsb(h,f[n>>2]|0,c);n=f[h>>2]|0;if((n|0)!=8){dua(m,476054,c);eua(l,m,459234);switch(n|0){case 7:{s=f[(f[(f[h+4>>2]|0)+8>>2]|0)+8>>2]|0;break}case 1:{s=f[(f[h+4>>2]|0)+8>>2]|0;break}case 2:{s=f[(f[h+4>>2]|0)+24>>2]|0;break}case 3:{s=f[(f[(f[h+4>>2]|0)+8>>2]|0)+8>>2]|0;break}case 4:{s=f[(f[h+4>>2]|0)+8>>2]|0;break}case 5:{s=f[(f[(f[h+4>>2]|0)+12>>2]|0)+8>>2]|0;break}case 6:{s=f[(f[h+4>>2]|0)+8>>2]|0;break}default:s=0}Ccb(k,l,f[s>>2]|0);eua(j,k,476219);wrb(a,c,d,0,j);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0)}u=g;return}function yrb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e+12|0;h=e;i=f[c+120>>2]|0;dua(h,459151,f[(f[c+28>>2]|0)+4+(d<<2)>>2]|0);eua(g,h,459214);wrb(a,i,c,9,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)>=0){u=e;return}O5b(f[h>>2]|0);u=e;return}function zrb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;g=a+4|0;h=f[g>>2]|0;i=L5b(88)|0;f[e>>2]=i;j=h+112|0;k=f[j>>2]|0;if((k|0)==(f[h+116>>2]|0))HO(h+108|0,e);else{f[k>>2]=i;f[j>>2]=(f[j>>2]|0)+4}j=f[e>>2]|0;i=j;k=i+88|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(k|0));i=f[g>>2]|0;g=L5b(12)|0;X5b(g,c);f[e>>2]=g;c=i+76|0;k=f[c>>2]|0;if((k|0)==(f[i+80>>2]|0))Rqb(i+72|0,e);else{f[k>>2]=g;f[c>>2]=(f[c>>2]|0)+4}f[j>>2]=f[e>>2];if((f[213345]|0)!=2){f[e>>2]=135812;f[e+4>>2]=7;b[e+8>>0]=0;Gpb(853380,e);hpb(e)}f[j+4>>2]=497760;f[j+8>>2]=f[a>>2];a=fEb()|0;f[j+76>>2]=a;if((f[213369]|0)==2){l=f[213370]|0;m=j+80|0;f[m>>2]=l;n=vEb()|0;o=j+84|0;f[o>>2]=n;p=j+68|0;b[p>>0]=1;q=j+64|0;f[q>>2]=2;u=d;return j|0}f[e>>2]=135812;f[e+4>>2]=49;b[e+8>>0]=0;Gpb(853476,e);hpb(e);l=f[213370]|0;m=j+80|0;f[m>>2]=l;n=vEb()|0;o=j+84|0;f[o>>2]=n;p=j+68|0;b[p>>0]=1;q=j+64|0;f[q>>2]=2;u=d;return j|0}function Arb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+48|0;g=e+24|0;h=e+12|0;i=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(!(f[(f[a>>2]|0)+4>>2]|0)){dua(i,459151,f[(f[c+28>>2]|0)+4+(d<<2)>>2]|0);eua(h,i,459160);_5b(g,h)|0;if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0)}else{dua(i,459151,f[(f[c+28>>2]|0)+4+(d<<2)>>2]|0);eua(h,i,459183);_5b(g,h)|0;if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0)}wrb(a,f[c+120>>2]|0,c,9,g);if((b[g+11>>0]|0)>=0){u=e;return}O5b(f[g>>2]|0);u=e;return}function Brb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=ZVb(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=ZVb(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function Crb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=b;if(!b)return;d=a+48|0;e=a+52|0;g=f[e>>2]|0;do if(g){h=a+52|0;i=g;while(1){j=f[i+16>>2]|0;if(j>>>0>b>>>0){k=f[i>>2]|0;if(!k){l=7;break}else{m=i;n=k}}else{if(j>>>0>=b>>>0){l=11;break}o=i+4|0;j=f[o>>2]|0;if(!j){l=10;break}else{m=o;n=j}}h=m;i=n}if((l|0)==7){p=i;q=i;break}else if((l|0)==10){p=o;q=i;break}else if((l|0)==11){p=h;q=i;break}}else{p=e;q=e}while(0);if(f[p>>2]|0)return;e=L5b(20)|0;f[e+16>>2]=c;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=q;f[p>>2]=e;q=f[f[d>>2]>>2]|0;if(!q)r=e;else{f[d>>2]=q;r=f[p>>2]|0}mP(f[a+52>>2]|0,r);r=a+56|0;f[r>>2]=(f[r>>2]|0)+1;r=b+20|0;if((f[r>>2]|0)<=0)return;p=b+16|0;q=b+24|0;b=0;do{Crb(a,f[(f[p>>2]|0)+(f[(f[q>>2]|0)+(b<<2)>>2]<<2)>>2]|0);b=b+1|0}while((b|0)<(f[r>>2]|0));return}function Drb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;g=u;u=u+480|0;h=g+448|0;i=g+440|0;j=g+400|0;k=g+360|0;l=g+320|0;m=g+280|0;o=g+240|0;p=g+200|0;q=g+160|0;r=g+120|0;s=g+80|0;t=g+40|0;v=g;if(!d)w=(f[a+40>>2]|0)+4|0;else w=d+4|0;x=f[w>>2]|0;w=a+4|0;y=f[w>>2]|0;z=L5b(12)|0;X5b(z,x);f[h>>2]=z;x=y+76|0;A=f[x>>2]|0;if((A|0)==(f[y+80>>2]|0))Rqb(y+72|0,h);else{f[A>>2]=z;f[x>>2]=(f[x>>2]|0)+4}x=f[h>>2]|0;z=b[x+11>>0]|0;if(z<<24>>24<0)B=f[x+4>>2]|0;else B=z&255;if(B|0)f6b(x,1,46)|0;B=c+144|0;z=f[B>>2]|0;A=b[z+11>>0]|0;y=A<<24>>24<0;j6b(x,y?f[z>>2]|0:z,y?f[z+4>>2]|0:A&255)|0;etb(a,f[B>>2]|0,x,c);A=f[w>>2]|0;z=f[B>>2]|0;B=L5b(12)|0;X5b(B,z);f[h>>2]=B;z=A+76|0;y=f[z>>2]|0;if((y|0)==(f[A+80>>2]|0))Rqb(A+72|0,h);else{f[y>>2]=B;f[z>>2]=(f[z>>2]|0)+4}f[e>>2]=f[h>>2];z=e+4|0;f[z>>2]=x;f[e+8>>2]=f[a+40>>2];f[e+12>>2]=d;b[e+20>>0]=0;b[e+21>>0]=0;x=c+100|0;B=f[x>>2]|0;f[e+32>>2]=B;y=e+36|0;A=f[w>>2]|0;C=B*28|0;if(!C){D=0;E=B}else{B=L5b(C)|0;f[h>>2]=B;C=A+112|0;F=f[C>>2]|0;if((F|0)==(f[A+116>>2]|0))HO(A+108|0,h);else{f[F>>2]=B;f[C>>2]=(f[C>>2]|0)+4}D=f[h>>2]|0;E=f[x>>2]|0}f[y>>2]=D;if((E|0)>0?(E=c+108|0,ttb(a,f[(f[E>>2]|0)+4>>2]|0,e,D),(f[x>>2]|0)>1):0){D=1;do{ttb(a,f[(f[E>>2]|0)+4+(D<<2)>>2]|0,e,(f[y>>2]|0)+(D*28|0)|0);D=D+1|0}while((D|0)<(f[x>>2]|0))}x=c+20|0;D=f[x>>2]|0;y=e+24|0;f[y>>2]=D;E=e+28|0;C=f[w>>2]|0;B=D*88|0;if(!B){G=0;H=D}else{D=L5b(B)|0;f[h>>2]=D;B=C+112|0;F=f[B>>2]|0;if((F|0)==(f[C+116>>2]|0))HO(C+108|0,h);else{f[F>>2]=D;f[B>>2]=(f[B>>2]|0)+4}G=f[h>>2]|0;H=f[x>>2]|0}f[E>>2]=G;if((H|0)>0?(H=c+28|0,Grb(a,f[(f[H>>2]|0)+4>>2]|0,e,G,0),(f[x>>2]|0)>1):0){G=1;do{Grb(a,f[(f[H>>2]|0)+4+(G<<2)>>2]|0,e,(f[E>>2]|0)+(G*88|0)|0,0);G=G+1|0}while((G|0)<(f[x>>2]|0))}x=c+52|0;G=f[x>>2]|0;f[e+40>>2]=G;H=e+44|0;B=f[w>>2]|0;D=G*88|0;if(!D){I=0;J=G}else{G=L5b(D)|0;f[h>>2]=G;D=B+112|0;F=f[D>>2]|0;if((F|0)==(f[B+116>>2]|0))HO(B+108|0,h);else{f[F>>2]=G;f[D>>2]=(f[D>>2]|0)+4}I=f[h>>2]|0;J=f[x>>2]|0}f[H>>2]=I;if((J|0)>0?(J=c+60|0,Drb(a,f[(f[J>>2]|0)+4>>2]|0,e,I),(f[x>>2]|0)>1):0){I=1;do{Drb(a,f[(f[J>>2]|0)+4+(I<<2)>>2]|0,e,(f[H>>2]|0)+(I*88|0)|0);I=I+1|0}while((I|0)<(f[x>>2]|0))}x=c+68|0;I=f[x>>2]|0;f[e+48>>2]=I;H=e+52|0;J=f[w>>2]|0;D=I<<5;if(!D){K=0;L=I}else{I=L5b(D)|0;f[h>>2]=I;D=J+112|0;G=f[D>>2]|0;if((G|0)==(f[J+116>>2]|0))HO(J+108|0,h);else{f[G>>2]=I;f[D>>2]=(f[D>>2]|0)+4}K=f[h>>2]|0;L=f[x>>2]|0}f[H>>2]=K;if((L|0)>0?(L=c+76|0,Erb(a,f[(f[L>>2]|0)+4>>2]|0,e,K),(f[x>>2]|0)>1):0){K=1;do{Erb(a,f[(f[L>>2]|0)+4+(K<<2)>>2]|0,e,(f[H>>2]|0)+(K<<5)|0);K=K+1|0}while((K|0)<(f[x>>2]|0))}x=c+84|0;K=f[x>>2]|0;H=e+56|0;f[H>>2]=K;L=e+60|0;D=f[w>>2]|0;I=K<<3;if(!I){M=0;N=K}else{K=L5b(I)|0;f[h>>2]=K;I=D+112|0;G=f[I>>2]|0;if((G|0)==(f[D+116>>2]|0))HO(D+108|0,h);else{f[G>>2]=K;f[I>>2]=(f[I>>2]|0)+4}M=f[h>>2]|0;N=f[x>>2]|0}f[L>>2]=M;a:do if((N|0)>0){I=c+92|0;K=0;G=M;while(1){D=f[(f[I>>2]|0)+4+(K<<2)>>2]|0;J=f[D+16>>2]|0;F=G+(K<<3)|0;f[F>>2]=J;B=f[D+20>>2]|0;C=G+(K<<3)+4|0;f[C>>2]=B;if((J|0)<1){vrb(a,f[z>>2]|0,D,1,458635);O=f[F>>2]|0;P=f[C>>2]|0}else{O=J;P=B}if((O|0)>=(P|0))vrb(a,f[z>>2]|0,D,1,458680);D=K+1|0;if((D|0)>=(f[x>>2]|0))break a;K=D;G=f[L>>2]|0}}while(0);x=c+36|0;P=f[x>>2]|0;f[e+64>>2]=P;O=e+68|0;M=f[w>>2]|0;N=P*88|0;if(!N){Q=0;R=P}else{P=L5b(N)|0;f[h>>2]=P;N=M+112|0;G=f[N>>2]|0;if((G|0)==(f[M+116>>2]|0))HO(M+108|0,h);else{f[G>>2]=P;f[N>>2]=(f[N>>2]|0)+4}Q=f[h>>2]|0;R=f[x>>2]|0}f[O>>2]=Q;if((R|0)>0?(R=c+44|0,Grb(a,f[(f[R>>2]|0)+4>>2]|0,e,Q,1),(f[x>>2]|0)>1):0){Q=1;do{Grb(a,f[(f[R>>2]|0)+4+(Q<<2)>>2]|0,e,(f[O>>2]|0)+(Q*88|0)|0,1);Q=Q+1|0}while((Q|0)<(f[x>>2]|0))}x=c+116|0;Q=f[x>>2]|0;O=e+72|0;f[O>>2]=Q;R=e+76|0;N=f[w>>2]|0;P=Q<<3;if(!P){S=0;T=Q}else{Q=L5b(P)|0;f[h>>2]=Q;P=N+112|0;G=f[P>>2]|0;if((G|0)==(f[N+116>>2]|0))HO(N+108|0,h);else{f[G>>2]=Q;f[P>>2]=(f[P>>2]|0)+4}S=f[h>>2]|0;T=f[x>>2]|0}f[R>>2]=S;b:do if((T|0)>0){P=c+124|0;Q=0;G=S;N=T;while(1){M=f[(f[P>>2]|0)+4+(Q<<2)>>2]|0;K=f[M+16>>2]|0;f[G+(Q<<3)>>2]=K;f[G+(Q<<3)+4>>2]=f[M+20>>2];if((K|0)<1){vrb(a,f[z>>2]|0,M,1,458742);U=f[x>>2]|0}else U=N;M=Q+1|0;if((M|0)>=(U|0))break b;Q=M;G=f[R>>2]|0;N=U}}while(0);U=c+132|0;T=f[U>>2]|0;f[e+80>>2]=T;S=f[w>>2]|0;N=T<<2;if(!N)V=0;else{G=L5b(N)|0;f[h>>2]=G;N=S+112|0;Q=f[N>>2]|0;if((Q|0)==(f[S+116>>2]|0))HO(S+108|0,h);else{f[Q>>2]=G;f[N>>2]=(f[N>>2]|0)+4}V=f[h>>2]|0}N=e+84|0;f[N>>2]=V;if((T|0)>0){V=c+140|0;G=0;do{Q=f[w>>2]|0;S=f[(f[V>>2]|0)+4+(G<<2)>>2]|0;P=L5b(12)|0;X5b(P,S);f[h>>2]=P;S=Q+76|0;M=f[S>>2]|0;if((M|0)==(f[Q+80>>2]|0))Rqb(Q+72|0,h);else{f[M>>2]=P;f[S>>2]=(f[S>>2]|0)+4}f[(f[N>>2]|0)+(G<<2)>>2]=f[h>>2];G=G+1|0}while((G|0)<(T|0))}if(!(f[c+8>>2]&128))f[e+16>>2]=0;else{T=f[c+148>>2]|0;G=f[z>>2]|0;utb(a,G,G,(T|0)==0?498568:T,e)}T=f[z>>2]|0;G=f[e>>2]|0;f[i>>2]=1;f[i+4>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];gtb(a,T,d,G,c,h)|0;G=f[x>>2]|0;if((G|0)>0){d=c+124|0;T=j+8|0;i=j+4|0;e=k+8|0;N=k+4|0;V=l+8|0;w=l+4|0;S=m+8|0;P=m+4|0;M=o+4|0;Q=p+4|0;K=q+4|0;I=r+4|0;D=s+4|0;B=t+4|0;J=h+11|0;C=0;F=G;while(1){G=f[d>>2]|0;A=f[G+4+(C<<2)>>2]|0;W=C;C=C+1|0;c:do if((C|0)<(F|0)){Y=A+20|0;Z=A+16|0;_=C;$=G;aa=F;while(1){ba=f[$+4+(_<<2)>>2]|0;ca=f[ba+16>>2]|0;do if((f[Y>>2]|0)>(ca|0)){da=ba+20|0;if((f[da>>2]|0)<=(f[Z>>2]|0)){ea=aa;break}fa=f[z>>2]|0;ga=f[$+4+(W<<2)>>2]|0;ha=rSb(ca,T)|0;f[j>>2]=ha;ia=kUb(ha)|0;f[i>>2]=ia;ia=rSb((f[da>>2]|0)+-1|0,e)|0;f[k>>2]=ia;da=kUb(ia)|0;f[N>>2]=da;da=rSb(f[Z>>2]|0,V)|0;f[l>>2]=da;ia=kUb(da)|0;f[w>>2]=ia;ia=rSb((f[Y>>2]|0)+-1|0,S)|0;f[m>>2]=ia;da=kUb(ia)|0;f[P>>2]=da;f[o>>2]=0;f[M>>2]=-1;f[p>>2]=0;f[Q>>2]=-1;f[q>>2]=0;f[K>>2]=-1;f[r>>2]=0;f[I>>2]=-1;f[s>>2]=0;f[D>>2]=-1;f[t>>2]=0;f[B>>2]=-1;hOb(h,458786,j,k,l,m,o,p,q,r,s,t);wrb(a,fa,ga,1,h);if((b[J>>0]|0)<0)O5b(f[h>>2]|0);ea=f[x>>2]|0}else ea=aa;while(0);ca=_+1|0;if((ca|0)>=(ea|0)){ja=ea;break c}_=ca;$=f[d>>2]|0;aa=ea}}else ja=F;while(0);if((C|0)>=(ja|0))break;else F=ja}}ja=h+16|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;n[ja>>2]=1.0;if((f[U>>2]|0)>0){F=c+140|0;C=h+4|0;ea=h+12|0;d=h+8|0;x=k+4|0;J=l+4|0;B=m+4|0;D=o+4|0;I=p+4|0;K=q+4|0;Q=r+4|0;M=s+4|0;P=t+4|0;S=v+4|0;w=j+11|0;V=0;do{N=f[(f[F>>2]|0)+4+(V<<2)>>2]|0;d:do if(vtb(h,N)|0){e=b[N+11>>0]|0;i=e<<24>>24<0;f[k>>2]=i?f[N>>2]|0:N;f[x>>2]=i?f[N+4>>2]|0:e&255;f[l>>2]=0;f[J>>2]=-1;f[m>>2]=0;f[B>>2]=-1;f[o>>2]=0;f[D>>2]=-1;f[p>>2]=0;f[I>>2]=-1;f[q>>2]=0;f[K>>2]=-1;f[r>>2]=0;f[Q>>2]=-1;f[s>>2]=0;f[M>>2]=-1;f[t>>2]=0;f[P>>2]=-1;f[v>>2]=0;f[S>>2]=-1;hOb(j,458856,k,l,m,o,p,q,r,s,t,v);wrb(a,N,c,0,j);if((b[w>>0]|0)<0)O5b(f[j>>2]|0)}else{e=b[N+11>>0]|0;i=e<<24>>24<0;T=i?f[N>>2]|0:N;W=b[T>>0]|0;if(!(W<<24>>24))ka=0;else{G=T;A=0;aa=W;while(1){$=(A*5|0)+(aa<<24>>24)|0;G=G+1|0;aa=b[G>>0]|0;if(!(aa<<24>>24)){ka=$;break}else A=$}}A=f[C>>2]|0;aa=(A|0)==0;e:do if(aa)la=0;else{G=A+-1|0;$=(G&A|0)==0;do if($)ma=G&ka;else{if(ka>>>0<A>>>0){ma=ka;break}ma=(ka>>>0)%(A>>>0)|0}while(0);_=f[(f[h>>2]|0)+(ma<<2)>>2]|0;if(!_){la=ma;break}Y=f[_>>2]|0;if(!Y){la=ma;break}_=i?f[N+4>>2]|0:e&255;Z=(_|0)==0;if($){if(Z){ca=Y;while(1){ba=f[ca+4>>2]|0;if(!((ba|0)==(ka|0)|(ba&G|0)==(ma|0))){la=ma;break e}ba=b[ca+8+11>>0]|0;if(!((ba<<24>>24<0?f[ca+12>>2]|0:ba&255)|0))break d;ca=f[ca>>2]|0;if(!ca){la=ma;break e}}}else na=Y;while(1){ca=f[na+4>>2]|0;if(!((ca|0)==(ka|0)|(ca&G|0)==(ma|0))){la=ma;break e}ca=na+8|0;$=b[ca+11>>0]|0;ba=$<<24>>24<0;ga=$&255;do if(((ba?f[na+12>>2]|0:ga)|0)==(_|0)){$=f[ca>>2]|0;if(ba)if(!(ZVb($,T,_)|0))break d;else break;if(($&255)<<24>>24!=W<<24>>24)break;$=ca;fa=ga;da=T;do{fa=fa+-1|0;$=$+1|0;if(!fa)break d;da=da+1|0}while((b[$>>0]|0)==(b[da>>0]|0))}while(0);na=f[na>>2]|0;if(!na){la=ma;break e}}}if(Z){G=Y;while(1){ga=f[G+4>>2]|0;if((ga|0)!=(ka|0)){if(ga>>>0<A>>>0)oa=ga;else oa=(ga>>>0)%(A>>>0)|0;if((oa|0)!=(ma|0)){la=ma;break e}}ga=b[G+8+11>>0]|0;if(!((ga<<24>>24<0?f[G+12>>2]|0:ga&255)|0))break d;G=f[G>>2]|0;if(!G){la=ma;break e}}}else pa=Y;while(1){G=f[pa+4>>2]|0;if((G|0)!=(ka|0)){if(G>>>0<A>>>0)qa=G;else qa=(G>>>0)%(A>>>0)|0;if((qa|0)!=(ma|0)){la=ma;break e}}G=pa+8|0;Z=b[G+11>>0]|0;ga=Z<<24>>24<0;ca=Z&255;do if(((ga?f[pa+12>>2]|0:ca)|0)==(_|0)){Z=f[G>>2]|0;if(ga)if(!(ZVb(Z,T,_)|0))break d;else break;if((Z&255)<<24>>24!=W<<24>>24)break;Z=G;ba=ca;da=T;do{ba=ba+-1|0;Z=Z+1|0;if(!ba)break d;da=da+1|0}while((b[Z>>0]|0)==(b[da>>0]|0))}while(0);pa=f[pa>>2]|0;if(!pa){la=ma;break}}}while(0);T=L5b(20)|0;X5b(T+8|0,N);f[T+4>>2]=ka;f[T>>2]=0;ra=+(((f[ea>>2]|0)+1|0)>>>0);sa=+n[ja>>2];do if(aa|ra>+(A>>>0)*sa){W=(A>>>0<3|(A+-1&A|0)!=0)&1|A<<1;e=~~+X(+(ra/sa))>>>0;lrb(h,W>>>0<e>>>0?e:W);W=f[C>>2]|0;e=W+-1|0;if(!(e&W)){ta=W;ua=e&ka;break}if(ka>>>0<W>>>0){ta=W;ua=ka;break}ta=W;ua=(ka>>>0)%(W>>>0)|0}else{ta=A;ua=la}while(0);A=(f[h>>2]|0)+(ua<<2)|0;aa=f[A>>2]|0;do if(!aa){f[T>>2]=f[d>>2];f[d>>2]=T;f[A>>2]=d;W=f[T>>2]|0;if(!W)break;e=f[W+4>>2]|0;W=ta+-1|0;do if(!(W&ta))va=e&W;else{if(e>>>0<ta>>>0){va=e;break}va=(e>>>0)%(ta>>>0)|0}while(0);wa=(f[h>>2]|0)+(va<<2)|0;xa=165}else{f[T>>2]=f[aa>>2];wa=aa;xa=165}while(0);if((xa|0)==165){xa=0;f[wa>>2]=T}f[ea>>2]=(f[ea>>2]|0)+1}while(0);V=V+1|0}while((V|0)<(f[U>>2]|0))}if((f[y>>2]|0)>0){U=c+28|0;V=k+4|0;ea=l+4|0;wa=m+4|0;xa=o+4|0;va=p+4|0;ta=q+4|0;d=r+4|0;ua=s+4|0;la=t+4|0;ka=v+4|0;C=j+11|0;ja=c+124|0;ma=k+4|0;pa=l+8|0;qa=l+4|0;oa=m+4|0;na=o+4|0;w=p+4|0;S=q+4|0;P=r+4|0;M=s+4|0;Q=t+4|0;K=v+4|0;I=j+11|0;D=c+92|0;B=k+8|0;J=k+4|0;x=l+8|0;F=l+4|0;N=m+4|0;aa=o+8|0;A=o+4|0;e=p+4|0;W=q+4|0;i=r+4|0;_=s+4|0;Y=t+4|0;ca=v+4|0;G=j+11|0;ga=0;do{da=f[E>>2]|0;Z=da+(ga*88|0)|0;ba=f[H>>2]|0;if((ba|0)>0){$=da+(ga*88|0)+28|0;fa=da+(ga*88|0)+4|0;ia=0;ha=ba;while(1){ba=f[L>>2]|0;ya=f[ba+(ia<<3)>>2]|0;za=f[$>>2]|0;do if((ya|0)>(za|0))Aa=ha;else{Ba=ba+(ia<<3)+4|0;if((za|0)>=(f[Ba>>2]|0)){Aa=ha;break}Ca=f[fa>>2]|0;Da=f[(f[D>>2]|0)+4+(ia<<2)>>2]|0;Ea=rSb(ya,B)|0;f[k>>2]=Ea;Fa=kUb(Ea)|0;f[J>>2]=Fa;Fa=rSb((f[Ba>>2]|0)+-1|0,x)|0;f[l>>2]=Fa;Ba=kUb(Fa)|0;f[F>>2]=Ba;Ba=f[Z>>2]|0;Fa=b[Ba+11>>0]|0;Ea=Fa<<24>>24<0;f[m>>2]=Ea?f[Ba>>2]|0:Ba;f[N>>2]=Ea?f[Ba+4>>2]|0:Fa&255;Fa=rSb(f[$>>2]|0,aa)|0;f[o>>2]=Fa;Ba=kUb(Fa)|0;f[A>>2]=Ba;f[p>>2]=0;f[e>>2]=-1;f[q>>2]=0;f[W>>2]=-1;f[r>>2]=0;f[i>>2]=-1;f[s>>2]=0;f[_>>2]=-1;f[t>>2]=0;f[Y>>2]=-1;f[v>>2]=0;f[ca>>2]=-1;hOb(j,458900,k,l,m,o,p,q,r,s,t,v);wrb(a,Ca,Da,1,j);if((b[G>>0]|0)<0)O5b(f[j>>2]|0);Aa=f[H>>2]|0}while(0);ia=ia+1|0;if((ia|0)>=(Aa|0))break;else ha=Aa}}ha=f[O>>2]|0;if((ha|0)>0){ia=da+(ga*88|0)+28|0;$=da+(ga*88|0)+4|0;fa=0;ya=ha;while(1){ha=f[R>>2]|0;za=f[ia>>2]|0;do if((f[ha+(fa<<3)>>2]|0)>(za|0))Ga=ya;else{if((za|0)>=(f[ha+(fa<<3)+4>>2]|0)){Ga=ya;break}ba=f[$>>2]|0;T=f[(f[ja>>2]|0)+4+(fa<<2)>>2]|0;Da=f[Z>>2]|0;Ca=b[Da+11>>0]|0;Ba=Ca<<24>>24<0;f[k>>2]=Ba?f[Da>>2]|0:Da;f[ma>>2]=Ba?f[Da+4>>2]|0:Ca&255;Ca=rSb(za,pa)|0;f[l>>2]=Ca;Da=kUb(Ca)|0;f[qa>>2]=Da;f[m>>2]=0;f[oa>>2]=-1;f[o>>2]=0;f[na>>2]=-1;f[p>>2]=0;f[w>>2]=-1;f[q>>2]=0;f[S>>2]=-1;f[r>>2]=0;f[P>>2]=-1;f[s>>2]=0;f[M>>2]=-1;f[t>>2]=0;f[Q>>2]=-1;f[v>>2]=0;f[K>>2]=-1;hOb(j,458951,k,l,m,o,p,q,r,s,t,v);wrb(a,ba,T,1,j);if((b[I>>0]|0)<0)O5b(f[j>>2]|0);Ga=f[O>>2]|0}while(0);fa=fa+1|0;if((fa|0)>=(Ga|0)){Ha=Z;break}else ya=Ga}}else Ha=Z;if(vtb(h,f[Ha>>2]|0)|0?(ya=f[da+(ga*88|0)+4>>2]|0,fa=f[(f[U>>2]|0)+4+(ga<<2)>>2]|0,$=f[Ha>>2]|0,ia=b[$+11>>0]|0,za=ia<<24>>24<0,f[k>>2]=za?f[$>>2]|0:$,f[V>>2]=za?f[$+4>>2]|0:ia&255,f[l>>2]=0,f[ea>>2]=-1,f[m>>2]=0,f[wa>>2]=-1,f[o>>2]=0,f[xa>>2]=-1,f[p>>2]=0,f[va>>2]=-1,f[q>>2]=0,f[ta>>2]=-1,f[r>>2]=0,f[d>>2]=-1,f[s>>2]=0,f[ua>>2]=-1,f[t>>2]=0,f[la>>2]=-1,f[v>>2]=0,f[ka>>2]=-1,hOb(j,458987,k,l,m,o,p,q,r,s,t,v),wrb(a,ya,fa,0,j),(b[C>>0]|0)<0):0)O5b(f[j>>2]|0);ga=ga+1|0}while((ga|0)<(f[y>>2]|0))}y=f[H>>2]|0;if((y|0)>0){ga=c+92|0;c=k+8|0;C=k+4|0;ka=l+8|0;la=l+4|0;ua=m+8|0;d=m+4|0;ta=o+8|0;va=o+4|0;xa=p+4|0;wa=q+4|0;ea=r+4|0;V=s+4|0;Ha=t+4|0;U=v+4|0;Ga=j+11|0;I=k+8|0;K=k+4|0;Q=l+8|0;M=l+4|0;P=m+8|0;S=m+4|0;w=o+8|0;na=o+4|0;oa=p+4|0;qa=q+4|0;pa=r+4|0;ma=s+4|0;ja=t+4|0;Aa=v+4|0;G=j+11|0;ca=0;Y=y;while(1){y=f[L>>2]|0;_=y+(ca<<3)|0;i=f[O>>2]|0;if((i|0)>0){W=y+(ca<<3)+4|0;e=0;A=i;while(1){i=f[R>>2]|0;aa=i+(e<<3)|0;do if((f[W>>2]|0)>(f[aa>>2]|0)){N=i+(e<<3)+4|0;F=f[_>>2]|0;if((f[N>>2]|0)<=(F|0)){Ia=A;break}x=f[z>>2]|0;J=f[(f[ga>>2]|0)+4+(e<<2)>>2]|0;B=rSb(F,I)|0;f[k>>2]=B;F=kUb(B)|0;f[K>>2]=F;F=rSb((f[W>>2]|0)+-1|0,Q)|0;f[l>>2]=F;B=kUb(F)|0;f[M>>2]=B;B=rSb(f[aa>>2]|0,P)|0;f[m>>2]=B;F=kUb(B)|0;f[S>>2]=F;F=rSb((f[N>>2]|0)+-1|0,w)|0;f[o>>2]=F;N=kUb(F)|0;f[na>>2]=N;f[p>>2]=0;f[oa>>2]=-1;f[q>>2]=0;f[qa>>2]=-1;f[r>>2]=0;f[pa>>2]=-1;f[s>>2]=0;f[ma>>2]=-1;f[t>>2]=0;f[ja>>2]=-1;f[v>>2]=0;f[Aa>>2]=-1;hOb(j,459016,k,l,m,o,p,q,r,s,t,v);wrb(a,x,J,1,j);if((b[G>>0]|0)<0)O5b(f[j>>2]|0);Ia=f[O>>2]|0}else Ia=A;while(0);e=e+1|0;if((e|0)>=(Ia|0))break;else A=Ia}Ja=f[H>>2]|0}else Ja=Y;A=ca;ca=ca+1|0;if((ca|0)<(Ja|0)){e=y+(A<<3)+4|0;A=ca;W=Ja;while(1){da=f[L>>2]|0;Z=f[da+(A<<3)>>2]|0;do if((f[e>>2]|0)>(Z|0)){aa=da+(A<<3)+4|0;if((f[aa>>2]|0)<=(f[_>>2]|0)){Ka=W;break}i=f[z>>2]|0;J=f[(f[ga>>2]|0)+4+(A<<2)>>2]|0;x=rSb(Z,c)|0;f[k>>2]=x;N=kUb(x)|0;f[C>>2]=N;N=rSb((f[aa>>2]|0)+-1|0,ka)|0;f[l>>2]=N;aa=kUb(N)|0;f[la>>2]=aa;aa=rSb(f[_>>2]|0,ua)|0;f[m>>2]=aa;N=kUb(aa)|0;f[d>>2]=N;N=rSb((f[e>>2]|0)+-1|0,ta)|0;f[o>>2]=N;aa=kUb(N)|0;f[va>>2]=aa;f[p>>2]=0;f[xa>>2]=-1;f[q>>2]=0;f[wa>>2]=-1;f[r>>2]=0;f[ea>>2]=-1;f[s>>2]=0;f[V>>2]=-1;f[t>>2]=0;f[Ha>>2]=-1;f[v>>2]=0;f[U>>2]=-1;hOb(j,459080,k,l,m,o,p,q,r,s,t,v);wrb(a,i,J,1,j);if((b[Ga>>0]|0)<0)O5b(f[j>>2]|0);Ka=f[H>>2]|0}else Ka=W;while(0);A=A+1|0;if((A|0)>=(Ka|0)){La=Ka;break}else W=Ka}}else La=Ja;if((ca|0)>=(La|0))break;else Y=La}}La=f[h+8>>2]|0;if(La|0){Y=La;do{La=Y;Y=f[Y>>2]|0;ca=La+8|0;if((b[ca+11>>0]|0)<0)O5b(f[ca>>2]|0);O5b(La)}while((Y|0)!=0)}Y=f[h>>2]|0;f[h>>2]=0;if(!Y){u=g;return}O5b(Y);u=g;return}function Erb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+16|0;h=g+8|0;i=g;if(!d)j=(f[a+40>>2]|0)+4|0;else j=d+4|0;k=f[j>>2]|0;j=a+4|0;l=f[j>>2]|0;m=L5b(12)|0;X5b(m,k);f[h>>2]=m;k=l+76|0;n=f[k>>2]|0;if((n|0)==(f[l+80>>2]|0))Rqb(l+72|0,h);else{f[n>>2]=m;f[k>>2]=(f[k>>2]|0)+4}k=f[h>>2]|0;m=b[k+11>>0]|0;if(m<<24>>24<0)o=f[k+4>>2]|0;else o=m&255;if(o|0)f6b(k,1,46)|0;o=c+32|0;m=f[o>>2]|0;n=b[m+11>>0]|0;l=n<<24>>24<0;j6b(k,l?f[m>>2]|0:m,l?f[m+4>>2]|0:n&255)|0;etb(a,f[o>>2]|0,k,c);n=f[j>>2]|0;m=f[o>>2]|0;o=L5b(12)|0;X5b(o,m);f[h>>2]=o;m=n+76|0;l=f[m>>2]|0;if((l|0)==(f[n+80>>2]|0))Rqb(n+72|0,h);else{f[l>>2]=o;f[m>>2]=(f[m>>2]|0)+4}f[e>>2]=f[h>>2];m=e+4|0;f[m>>2]=k;f[e+8>>2]=f[a+40>>2];f[e+12>>2]=d;b[e+20>>0]=0;b[e+21>>0]=0;o=c+20|0;l=f[o>>2]|0;if(!l){vrb(a,k,c,0,458312);p=f[o>>2]|0}else p=l;f[e+24>>2]=p;l=e+28|0;k=f[j>>2]|0;j=p*20|0;if(!j){q=0;r=p}else{p=L5b(j)|0;f[h>>2]=p;j=k+112|0;n=f[j>>2]|0;if((n|0)==(f[k+116>>2]|0))HO(k+108|0,h);else{f[n>>2]=p;f[j>>2]=(f[j>>2]|0)+4}q=f[h>>2]|0;r=f[o>>2]|0}f[l>>2]=q;if((r|0)>0?(r=c+28|0,mtb(a,f[(f[r>>2]|0)+4>>2]|0,e,q),(f[o>>2]|0)>1):0){q=1;do{mtb(a,f[(f[r>>2]|0)+4+(q<<2)>>2]|0,e,(f[l>>2]|0)+(q*20|0)|0);q=q+1|0}while((q|0)<(f[o>>2]|0))}ntb(a,c,e);if(!(f[c+8>>2]&4)){f[e+16>>2]=0;s=f[m>>2]|0;t=f[e>>2]|0;f[i>>2]=4;v=i+4|0;f[v>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];gtb(a,s,d,t,c,h)|0;u=g;return}else{o=f[c+36>>2]|0;q=f[m>>2]|0;otb(a,q,q,(o|0)==0?498760:o,e);s=f[m>>2]|0;t=f[e>>2]|0;f[i>>2]=4;v=i+4|0;f[v>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];gtb(a,s,d,t,c,h)|0;u=g;return}}function Frb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;g=d+8|0;h=d;i=a+4|0;j=f[i>>2]|0;k=a+40|0;l=f[(f[k>>2]|0)+4>>2]|0;m=L5b(12)|0;X5b(m,l);f[g>>2]=m;l=j+76|0;n=f[l>>2]|0;if((n|0)==(f[j+80>>2]|0))Rqb(j+72|0,g);else{f[n>>2]=m;f[l>>2]=(f[l>>2]|0)+4}l=f[g>>2]|0;m=b[l+11>>0]|0;if(m<<24>>24<0)o=f[l+4>>2]|0;else o=m&255;if(o|0)f6b(l,1,46)|0;o=c+32|0;m=f[o>>2]|0;n=b[m+11>>0]|0;j=n<<24>>24<0;j6b(l,j?f[m>>2]|0:m,j?f[m+4>>2]|0:n&255)|0;etb(a,f[o>>2]|0,l,c);n=f[i>>2]|0;m=f[o>>2]|0;o=L5b(12)|0;X5b(o,m);f[g>>2]=o;m=n+76|0;j=f[m>>2]|0;if((j|0)==(f[n+80>>2]|0))Rqb(n+72|0,g);else{f[j>>2]=o;f[m>>2]=(f[m>>2]|0)+4}f[e>>2]=f[g>>2];m=e+4|0;f[m>>2]=l;f[e+8>>2]=f[k>>2];k=c+20|0;l=f[k>>2]|0;f[e+16>>2]=l;o=e+20|0;j=f[i>>2]|0;i=l*28|0;if(!i){p=0;q=l}else{l=L5b(i)|0;f[g>>2]=l;i=j+112|0;n=f[i>>2]|0;if((n|0)==(f[j+116>>2]|0))HO(j+108|0,g);else{f[n>>2]=l;f[i>>2]=(f[i>>2]|0)+4}p=f[g>>2]|0;q=f[k>>2]|0}f[o>>2]=p;if((q|0)>0?(q=c+28|0,jtb(a,f[(f[q>>2]|0)+4>>2]|0,e,p),(f[k>>2]|0)>1):0){p=1;do{jtb(a,f[(f[q>>2]|0)+4+(p<<2)>>2]|0,e,(f[o>>2]|0)+(p*28|0)|0);p=p+1|0}while((p|0)<(f[k>>2]|0))}if(!(f[c+8>>2]&4)){f[e+12>>2]=0;r=f[m>>2]|0;s=f[e>>2]|0;f[h>>2]=6;t=h+4|0;f[t>>2]=e;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];gtb(a,r,0,s,c,g)|0;u=d;return}else{k=f[c+36>>2]|0;p=f[m>>2]|0;ktb(a,p,p,(k|0)==0?498888:k,e);r=f[m>>2]|0;s=f[e>>2]|0;f[h>>2]=6;t=h+4|0;f[t>>2]=e;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];gtb(a,r,0,s,c,g)|0;u=d;return}}function Grb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;h=u;u=u+432|0;i=h+420|0;j=h+408|0;k=h+368|0;l=h+320|0;m=h+280|0;o=h+240|0;q=h+200|0;r=h+160|0;s=h+120|0;t=h+80|0;v=h+40|0;w=h;x=h+360|0;if(!d)y=(f[a+40>>2]|0)+4|0;else y=d+4|0;z=f[y>>2]|0;y=a+4|0;A=f[y>>2]|0;B=L5b(12)|0;X5b(B,z);f[i>>2]=B;z=A+76|0;E=f[z>>2]|0;if((E|0)==(f[A+80>>2]|0))Rqb(A+72|0,i);else{f[E>>2]=B;f[z>>2]=(f[z>>2]|0)+4}z=f[i>>2]|0;B=b[z+11>>0]|0;if(B<<24>>24<0)F=f[z+4>>2]|0;else F=B&255;if(F|0)f6b(z,1,46)|0;F=c+16|0;B=f[F>>2]|0;E=b[B+11>>0]|0;A=E<<24>>24<0;j6b(z,A?f[B>>2]|0:B,A?f[B+4>>2]|0:E&255)|0;etb(a,f[F>>2]|0,z,c);E=f[y>>2]|0;B=f[F>>2]|0;A=L5b(12)|0;X5b(A,B);f[i>>2]=A;B=E+76|0;G=f[B>>2]|0;if((G|0)==(f[E+80>>2]|0))Rqb(E+72|0,i);else{f[G>>2]=A;f[B>>2]=(f[B>>2]|0)+4}f[e>>2]=f[i>>2];B=e+4|0;f[B>>2]=z;f[e+24>>2]=f[a+40>>2];z=e+28|0;f[z>>2]=f[c+40>>2];A=e+40|0;b[A>>0]=g&1;X5b(j,f[F>>2]|0);G=j+11|0;E=b[G>>0]|0;H=E<<24>>24<0;I=f[j>>2]|0;K=j+4|0;L=f[K>>2]|0;M=H?I+L|0:j+(E&255)|0;N=H?I:j;if((N|0)==(M|0)){O=L;P=E}else{E=N;do{N=b[E>>0]|0;if((N+-65&255)<26)b[E>>0]=(N&255)+32;E=E+1|0}while((E|0)!=(M|0));O=f[K>>2]|0;P=b[G>>0]|0}K=f[F>>2]|0;M=P<<24>>24<0;E=P&255;P=M?O:E;O=b[K+11>>0]|0;N=O<<24>>24<0;a:do if((P|0)==((N?f[K+4>>2]|0:O&255)|0)){L=f[j>>2]|0;I=M?L:j;H=N?f[K>>2]|0:K;Q=(P|0)==0;b:do if(M){if(!Q?ZVb(I,H,P)|0:0){R=29;break a}}else if(!Q){if((L&255)<<24>>24==(b[H>>0]|0)){S=j;T=E;U=H}else{R=29;break a}while(1){T=T+-1|0;S=S+1|0;if(!T)break b;U=U+1|0;if((b[S>>0]|0)!=(b[U>>0]|0)){R=29;break a}}}while(0);V=f[e>>2]|0;W=K}else R=29;while(0);if((R|0)==29){K=f[y>>2]|0;U=L5b(12)|0;X5b(U,j);f[i>>2]=U;S=K+76|0;T=f[S>>2]|0;if((T|0)==(f[K+80>>2]|0))Rqb(K+72|0,i);else{f[T>>2]=U;f[S>>2]=(f[S>>2]|0)+4}V=f[i>>2]|0;W=f[F>>2]|0}f[e+8>>2]=V;V=f[y>>2]|0;fsb(k,W,1);W=L5b(12)|0;X5b(W,k);f[i>>2]=W;S=V+76|0;U=f[S>>2]|0;if((U|0)==(f[V+80>>2]|0))Rqb(V+72|0,i);else{f[U>>2]=W;f[S>>2]=(f[S>>2]|0)+4}f[e+12>>2]=f[i>>2];if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);S=c+8|0;W=e+16|0;U=f[y>>2]|0;if(!(f[S>>2]&256)){b[W>>0]=0;V=f[F>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;F=V+11|0;T=b[F>>0]|0;K=V+4|0;c6b(k,T<<24>>24<0?f[K>>2]|0:T&255);T=b[F>>0]|0;if((T<<24>>24<0?f[K>>2]|0:T&255)|0){E=0;P=0;M=T;while(1){T=b[(M<<24>>24<0?f[V>>2]|0:V)+P>>0]|0;do if(T<<24>>24!=95)if(E){N=T<<24>>24;l6b(k,((T+-97&255)<26?N+224|0:N)&255);X=0;break}else{l6b(k,T);X=0;break}else X=1;while(0);P=P+1|0;M=b[F>>0]|0;if(P>>>0>=(M<<24>>24<0?f[K>>2]|0:M&255)>>>0)break;else E=X}}X=L5b(12)|0;X5b(X,k);f[i>>2]=X;E=U+76|0;M=f[E>>2]|0;if((M|0)==(f[U+80>>2]|0))Rqb(U+72|0,i);else{f[M>>2]=X;f[E>>2]=(f[E>>2]|0)+4}f[e+20>>2]=f[i>>2];if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0)}else{b[W>>0]=1;W=f[c+32>>2]|0;E=L5b(12)|0;X5b(E,W);f[i>>2]=E;W=U+76|0;X=f[W>>2]|0;if((X|0)==(f[U+80>>2]|0))Rqb(U+72|0,i);else{f[X>>2]=E;f[W>>2]=(f[W>>2]|0)+4}f[e+20>>2]=f[i>>2]}W=e+32|0;f[W>>2]=f[c+52>>2];E=f[c+48>>2]|0;X=e+36|0;f[X>>2]=E;if((E|0)==2&(b[A>>0]|0)!=0)vrb(a,f[B>>2]|0,c,2,457493);A=e+48|0;f[A>>2]=0;E=e+56|0;f[E>>2]=0;f[e+60>>2]=0;f[e+64>>2]=0;U=f[S>>2]|0;M=e+72|0;b[M>>0]=U>>>6&1;if((U&64|0)!=0?(f[X>>2]|0)==3:0){vrb(a,f[B>>2]|0,c,4,457541);Y=f[S>>2]|0}else Y=U;c:do if(Y&8|0){if(!(Y&64))switch(f[136e3+(f[W>>2]<<2)>>2]|0){case 1:{f[e+80>>2]=0;break c;break}case 2:{U=e+80|0;f[U>>2]=0;f[U+4>>2]=0;break c;break}case 3:{f[e+80>>2]=0;break c;break}case 4:{U=e+80|0;f[U>>2]=0;f[U+4>>2]=0;break c;break}case 6:{n[e+80>>2]=0.0;break c;break}case 5:{p[e+80>>3]=0.0;break c;break}case 7:{b[e+80>>0]=0;break c;break}case 8:{f[e+80>>2]=0;break c;break}case 9:{if((f[213345]|0)!=2){f[i>>2]=135812;f[i+4>>2]=7;b[i+8>>0]=0;Gpb(853380,i);hpb(i)}f[e+80>>2]=497760;break c;break}default:break c}f[k>>2]=0;U=f[W>>2]|0;d:do switch(f[136e3+(U<<2)>>2]|0){case 1:{X=f[c+28>>2]|0;if((b[X+11>>0]|0)<0)Z=f[X>>2]|0;else Z=X;X=WVb(Z,k,0)|0;f[e+80>>2]=X;R=129;break}case 2:{X=f[c+28>>2]|0;if((b[X+11>>0]|0)<0)_=f[X>>2]|0;else _=X;X=VVb(_,k,0)|0;K=e+80|0;f[K>>2]=X;f[K+4>>2]=J;R=129;break}case 3:{K=f[c+28>>2]|0;if((b[K+11>>0]|0)<0)$=f[K>>2]|0;else $=K;K=eVb($,k,0)|0;f[e+80>>2]=K;R=129;break}case 4:{K=f[c+28>>2]|0;if((b[K+11>>0]|0)<0)aa=f[K>>2]|0;else aa=K;K=UVb(aa,k,0)|0;X=e+80|0;f[X>>2]=K;f[X+4>>2]=J;R=129;break}case 6:{X=c+28|0;K=f[X>>2]|0;P=b[K+11>>0]|0;F=f[K+4>>2]|0;if(((P<<24>>24<0?F:P&255)|0)==3)if(!(u6b(K,0,-1,483237,3)|0))ba=D;else{V=f[X>>2]|0;ca=b[V+11>>0]|0;da=f[V+4>>2]|0;ea=V;R=83}else{ca=P;da=F;ea=K;R=83}do if((R|0)==83){if(((ca<<24>>24<0?da:ca&255)|0)==4){if(!(u6b(ea,0,-1,481710,4)|0)){ba=-D;break}K=f[X>>2]|0;fa=b[K+11>>0]|0;ga=f[K+4>>2]|0;ha=K}else{fa=ca;ga=da;ha=ea}if(((fa<<24>>24<0?ga:fa&255)|0)==3){if(!(u6b(ha,0,-1,485166,3)|0)){ba=C;break}K=f[X>>2]|0;ia=b[K+11>>0]|0;ja=K}else{ia=fa;ja=ha}if(ia<<24>>24<0)ka=f[ja>>2]|0;else ka=ja;ba=+sIb(+qIb(ka,k))}while(0);n[e+80>>2]=ba;R=129;break}case 5:{X=c+28|0;K=f[X>>2]|0;F=b[K+11>>0]|0;P=f[K+4>>2]|0;if(((F<<24>>24<0?P:F&255)|0)==3)if(!(u6b(K,0,-1,483237,3)|0))la=D;else{V=f[X>>2]|0;ma=b[V+11>>0]|0;na=f[V+4>>2]|0;oa=V;R=97}else{ma=F;na=P;oa=K;R=97}do if((R|0)==97){if(((ma<<24>>24<0?na:ma&255)|0)==4){if(!(u6b(oa,0,-1,481710,4)|0)){la=-D;break}K=f[X>>2]|0;pa=b[K+11>>0]|0;qa=f[K+4>>2]|0;ra=K}else{pa=ma;qa=na;ra=oa}if(((pa<<24>>24<0?qa:pa&255)|0)==3){if(!(u6b(ra,0,-1,485166,3)|0)){la=C;break}K=f[X>>2]|0;sa=b[K+11>>0]|0;ta=K}else{sa=pa;ta=ra}if(sa<<24>>24<0)ua=f[ta>>2]|0;else ua=ta;la=+qIb(ua,k)}while(0);p[e+80>>3]=la;R=129;break}case 7:{X=c+28|0;K=f[X>>2]|0;P=b[K+11>>0]|0;F=f[K+4>>2]|0;do if(((P<<24>>24<0?F:P&255)|0)==4)if(!(u6b(K,0,-1,490309,4)|0)){b[e+80>>0]=1;R=129;break d}else{V=f[X>>2]|0;va=b[V+11>>0]|0;wa=f[V+4>>2]|0;xa=V;break}else{va=P;wa=F;xa=K}while(0);if(((va<<24>>24<0?wa:va&255)|0)==5?(u6b(xa,0,-1,490303,5)|0)==0:0){b[e+80>>0]=0;R=129;break d}vrb(a,f[B>>2]|0,c,4,457584);R=129;break}case 8:{f[e+80>>2]=0;R=129;break}case 9:{K=f[y>>2]|0;if((U|0)!=12){F=f[c+28>>2]|0;P=L5b(12)|0;X5b(P,F);f[i>>2]=P;F=K+76|0;X=f[F>>2]|0;if((X|0)==(f[K+80>>2]|0))Rqb(K+72|0,i);else{f[X>>2]=P;f[F>>2]=(f[F>>2]|0)+4}f[e+80>>2]=f[i>>2];R=129;break d}nSb(l,f[c+28>>2]|0);F=L5b(12)|0;X5b(F,l);f[i>>2]=F;P=K+76|0;X=f[P>>2]|0;if((X|0)==(f[K+80>>2]|0))Rqb(K+72|0,i);else{f[X>>2]=F;f[P>>2]=(f[P>>2]|0)+4}f[e+80>>2]=f[i>>2];if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);R=129;break}case 10:{vrb(a,f[B>>2]|0,c,4,456907);b[M>>0]=0;R=129;break}default:{}}while(0);do if((R|0)==129?(U=f[k>>2]|0,U|0):0){P=f[c+28>>2]|0;F=b[P+11>>0]|0;if(F<<24>>24<0)ya=f[P+4>>2]|0;else ya=F&255;if(ya|0?(b[U>>0]|0)==0:0)break;U=f[B>>2]|0;dua(l,457623,P);eua(i,l,476219);wrb(a,U,c,4,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0)}while(0)}while(0);ya=f[z>>2]|0;do if((ya|0)>=1){if((ya|0)>536870911&(g^1)){z=f[B>>2]|0;R=rSb(536870911,k+8|0)|0;f[k>>2]=R;M=kUb(R)|0;f[k+4>>2]=M;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;hOb(i,457695,k,l,m,o,q,r,s,t,v,w);wrb(a,z,c,1,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);break}if((ya+-19e3|0)>>>0<1e3?(z=f[B>>2]|0,M=rSb(19e3,k+8|0)|0,f[k>>2]=M,R=kUb(M)|0,f[k+4>>2]=R,R=rSb(19999,l+8|0)|0,f[l>>2]=R,M=kUb(R)|0,f[l+4>>2]=M,f[m>>2]=0,f[m+4>>2]=-1,f[o>>2]=0,f[o+4>>2]=-1,f[q>>2]=0,f[q+4>>2]=-1,f[r>>2]=0,f[r+4>>2]=-1,f[s>>2]=0,f[s+4>>2]=-1,f[t>>2]=0,f[t+4>>2]=-1,f[v>>2]=0,f[v+4>>2]=-1,f[w>>2]=0,f[w+4>>2]=-1,hOb(i,457736,k,l,m,o,q,r,s,t,v,w),wrb(a,z,c,1,i),(b[i+11>>0]|0)<0):0)O5b(f[i>>2]|0)}else vrb(a,f[B>>2]|0,c,1,457654);while(0);ya=f[S>>2]|0;z=(ya&32|0)!=0;e:do if(g){if(z)za=ya;else{vrb(a,f[B>>2]|0,c,3,457825);za=f[S>>2]|0}f[E>>2]=d;if(!(za&128))Aa=0;else{vrb(a,f[B>>2]|0,c,9,457884);Aa=0}}else{if(z){vrb(a,f[B>>2]|0,c,3,457951);Ba=f[S>>2]|0}else Ba=ya;f[A>>2]=d;if(!(Ba&128))Aa=0;else{M=f[c+44>>2]|0;do if((M|0)>=0){if((M|0)>=(f[d+32>>2]|0))break;Aa=(f[d+36>>2]|0)+(M*28|0)|0;break e}while(0);R=f[B>>2]|0;y=rSb(M,k+8|0)|0;f[k>>2]=y;xa=kUb(y)|0;f[k+4>>2]=xa;xa=f[d>>2]|0;y=b[xa+11>>0]|0;va=y<<24>>24<0;f[l>>2]=va?f[xa>>2]|0:xa;f[l+4>>2]=va?f[xa+4>>2]|0:y&255;f[m>>2]=0;f[m+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;hOb(i,458010,k,l,m,o,q,r,s,t,v,w);wrb(a,R,c,9,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);Aa=0}}while(0);f[e+52>>2]=Aa;if(!(f[S>>2]&512))f[e+68>>2]=0;else{S=f[c+36>>2]|0;Aa=f[B>>2]|0;ftb(a,Aa,Aa,(S|0)==0?498632:S,e)}S=f[B>>2]|0;B=f[e>>2]|0;f[x>>2]=2;f[x+4>>2]=e;f[i>>2]=f[x>>2];f[i+4>>2]=f[x+4>>2];gtb(a,S,d,B,c,i)|0;if((b[G>>0]|0)>=0){u=h;return}O5b(f[j>>2]|0);u=h;return}function Hrb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=L5b(80)|0;aAb(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))urb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}$ob(i,e);Uob(k,i)|0;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);f[g+76>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;X5b(i,c);c=i+12|0;X5b(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)c4b(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=ze(8)|0;T5b(a,477177);f[a>>2]=149528;If(a|0,25408,1411)}else{p=L5b(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;X5b(a,i);X5b(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;X5b(n+-32|0,j);X5b(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)O5b(f[v>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)O5b(t)}else{X5b(e,i);X5b(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=h;return}function Irb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=b+76|0;if(!(f[d>>2]|0)){e=fEb()|0;f[d>>2]=e}e=b+36|0;if((f[e>>2]|0)>0){d=b+40|0;g=c+68|0;h=0;do{atb(a,(f[d>>2]|0)+(h*88|0)|0,f[(f[g>>2]|0)+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)<(f[e>>2]|0))}e=b+60|0;if((f[e>>2]|0)>0){h=b+72|0;g=c+116|0;d=0;do{btb(a,(f[h>>2]|0)+(d*88|0)|0,f[(f[g>>2]|0)+4+(d<<2)>>2]|0);d=d+1|0}while((d|0)<(f[e>>2]|0))}e=b+44|0;if((f[e>>2]|0)>0){d=b+48|0;g=0;do{h=f[d>>2]|0;i=h+(g<<5)+16|0;if(!(f[i>>2]|0)){j=nEb()|0;f[i>>2]=j}j=h+(g<<5)+24|0;i=f[j>>2]|0;if((i|0)>0){k=h+(g<<5)+28|0;h=0;l=i;while(1){i=(f[k>>2]|0)+(h*20|0)+16|0;if(!(f[i>>2]|0)){m=pEb()|0;f[i>>2]=m;n=f[j>>2]|0}else n=l;h=h+1|0;if((h|0)>=(n|0))break;else l=n}}g=g+1|0}while((g|0)<(f[e>>2]|0))}e=b+52|0;if((f[e>>2]|0)<=0)return;g=b+56|0;b=c+100|0;c=0;do{n=f[g>>2]|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;l=n+(c*24|0)+12|0;if(!(f[l>>2]|0)){h=rEb()|0;f[l>>2]=h}h=n+(c*24|0)+16|0;if((f[h>>2]|0)>0){l=n+(c*24|0)+20|0;n=d+28|0;d=0;do{ctb(a,(f[l>>2]|0)+(d*28|0)|0,f[(f[n>>2]|0)+4+(d<<2)>>2]|0);d=d+1|0}while((d|0)<(f[h>>2]|0))}c=c+1|0}while((c|0)<(f[e>>2]|0));return}function Jrb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;f[a>>2]=b;rFb(a+12|0);if(f[a>>2]|0){u=c;return}zpb(d,3,450744,5712);xpb(c+24|0,vpb(d,456441)|0);Apb(d);u=c;return}function Krb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=(b[e+11>>0]|0)<0?f[e>>2]|0:e;e=d*65535|0;i=b[h>>0]|0;if(!(i<<24>>24))j=0;else{k=h;l=0;m=i;while(1){i=(l*5|0)+(m<<24>>24)|0;k=k+1|0;m=b[k>>0]|0;if(!(m<<24>>24)){j=i;break}else l=i}}l=j+e|0;e=f[c+4>>2]|0;a:do if(e){j=e+-1|0;m=(j&e|0)==0;if(!m)if(l>>>0<e>>>0)n=l;else n=(l>>>0)%(e>>>0)|0;else n=j&l;k=f[(f[c>>2]|0)+(n<<2)>>2]|0;if((k|0)!=0?(i=f[k>>2]|0,(i|0)!=0):0){b:do if(m){k=i;while(1){o=f[k+4>>2]|0;p=(l|0)==(o|0);if(!(p|(o&j|0)==(n|0))){q=0;r=0;s=0;break a}if((p?(f[k+8>>2]|0)==(d|0):0)?(gTb(f[k+12>>2]|0,h)|0)==0:0){t=k;break b}k=f[k>>2]|0;if(!k){q=0;r=0;s=0;break a}}}else{k=i;while(1){p=f[k+4>>2]|0;if((l|0)==(p|0)){if((f[k+8>>2]|0)==(d|0)?(gTb(f[k+12>>2]|0,h)|0)==0:0){t=k;break b}}else{if(p>>>0<e>>>0)u=p;else u=(p>>>0)%(e>>>0)|0;if((u|0)!=(n|0)){q=0;r=0;s=0;break a}}k=f[k>>2]|0;if(!k){q=0;r=0;s=0;break a}}}while(0);i=t+16|0;q=f[i>>2]|0;r=0;s=f[i+4>>2]|0}else{q=0;r=0;s=0}}else{q=0;r=0;s=0}while(0);t=(q|0)==(g|0);g=a;f[g>>2]=t?q|r:0;f[g+4>>2]=t?s:0;return}function Lrb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;d=u;u=u+224|0;e=d+8|0;g=d+200|0;h=d;i=d+176|0;j=d+222|0;k=d+168|0;l=d+156|0;m=d+144|0;n=d+96|0;o=d+56|0;p=d+44|0;q=d+32|0;r=d+20|0;s=d+140|0;t=d+136|0;v=d+112|0;w=d+221|0;x=d+72|0;y=d+220|0;z=a+8|0;A=f[z>>2]|0;if(!(f[A+20>>2]|0)){B=L5b(32)|0;f[e>>2]=B;f[e+8>>2]=-2147483616;f[e+4>>2]=24;C=B;D=453857;E=C+24|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[B+24>>0]=0;wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,A,7,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);F=0;u=d;return F|0}B=f[(f[(f[A+28>>2]|0)+4>>2]|0)+16>>2]|0;A=b[B+11>>0]|0;if(((A<<24>>24<0?f[B+4>>2]|0:A&255)|0)==20?(u6b(B,0,-1,451226,20)|0)==0:0){B=L5b(64)|0;f[e>>2]=B;f[e+8>>2]=-2147483584;f[e+4>>2]=57;C=B;D=453882;E=C+57|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[B+57>>0]=0;wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);F=0;u=d;return F|0}B=f[a>>2]|0;zh[f[(f[c>>2]|0)+96>>2]&2047](e,c);hsb(h,B,f[B>>2]|0,f[(f[e>>2]|0)+4>>2]|0);if((f[h>>2]|0)==1)G=f[h+4>>2]|0;else{zh[f[(f[c>>2]|0)+96>>2]&2047](e,c);G=f[e>>2]|0}if(!G){zpb(i,3,450744,5819);xpb(j,vpb(i,453940)|0);Apb(i)}f[k>>2]=0;f[l>>2]=0;i=l+4|0;f[i>>2]=0;f[l+8>>2]=0;j=m+11|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;B=m+4|0;D=e+4|0;C=l+8|0;E=e+11|0;A=e+4|0;H=g+11|0;I=a+4|0;J=h;K=0;L=G;M=0;N=0;O=G;G=f[J>>2]|0;P=f[J+4>>2]|0;J=f[z>>2]|0;while(1){Q=f[(f[J+28>>2]|0)+4+(K<<2)>>2]|0;R=f[Q+16>>2]|0;if(!((M<<24>>24<0?N:M&255)|0))S=Q;else{k6b(m,489392)|0;S=f[(f[(f[z>>2]|0)+28>>2]|0)+4+(K<<2)>>2]|0}do if(b[S+20>>0]|0){dua(g,489103,R);eua(e,g,489101);Q=b[E>>0]|0;T=Q<<24>>24<0;j6b(m,T?f[e>>2]|0:e,T?f[A>>2]|0:Q&255)|0;if((b[E>>0]|0)<0)O5b(f[e>>2]|0);if((b[H>>0]|0)<0)O5b(f[g>>2]|0);isb(e,f[a>>2]|0,R,f[I>>2]|0,0,0);Q=e;T=f[Q>>2]|0;U=f[Q+4>>2]|0;if((T|0)==2){f[k>>2]=U;V=U;W=T;X=U;Y=U;break}else{Q=f[k>>2]|0;V=Q;W=T;X=U;Y=Q;break}}else{Q=b[R+11>>0]|0;U=Q<<24>>24<0;j6b(m,U?f[R>>2]|0:R,U?f[R+4>>2]|0:Q&255)|0;Krb(e,f[(f[L+8>>2]|0)+80>>2]|0,O,R,2);if(!(f[e>>2]|0))Z=0;else{Q=f[D>>2]|0;Z=b[Q+40>>0]|0?0:Q}f[k>>2]=Z;V=Z;W=G;X=P;Y=Z}while(0);if(!V){_=30;break}$=f[V+48>>2]|0;if(($|0)!=(L|0)){_=57;break}R=f[z>>2]|0;Q=f[R+20>>2]|0;if((K|0)<(Q+-1|0)){if((f[V+32>>2]|1|0)!=11){_=70;break}if((f[V+36>>2]|0)==3){_=76;break}U=f[i>>2]|0;if((U|0)==(f[C>>2]|0))ksb(l,k);else{f[U>>2]=Y;f[i>>2]=(f[i>>2]|0)+4}U=f[k>>2]|0;T=f[U+60>>2]|0;aa=f[z>>2]|0;ba=T;ca=f[aa+20>>2]|0;da=U;ea=aa;fa=T}else{ba=L;ca=Q;da=V;ea=R;fa=O}R=K+1|0;if((R|0)>=(ca|0)){_=87;break}K=R;L=ba;M=b[j>>0]|0;N=f[B>>2]|0;O=fa;G=W;P=X;J=ea}do if((_|0)==30){ea=h;f[ea>>2]=W;f[ea+4>>2]=X;ea=f[a>>2]|0;if(b[(f[ea>>2]|0)+21>>0]|0){jsb(0,f[z>>2]|0,c);ga=1;break}J=b[ea+88+11>>0]|0;if(J<<24>>24<0)ha=f[ea+92>>2]|0;else ha=J&255;if(!ha){dua(g,453975,m);eua(e,g,454165);wrb(f[a>>2]|0,(f[I>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);ga=0;break}dua(q,453975,m);eua(p,q,453984);Ccb(o,p,(f[a>>2]|0)+88|0);eua(n,o,454004);Y5b(r,m,1,-1,m);Ccb(g,n,r);eua(e,g,454127);wrb(f[a>>2]|0,(f[I>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[r+11>>0]|0)<0)O5b(f[r>>2]|0);if((b[n+11>>0]|0)<0)O5b(f[n>>2]|0);if((b[o+11>>0]|0)<0)O5b(f[o>>2]|0);if((b[p+11>>0]|0)<0)O5b(f[p>>2]|0);if((b[q+11>>0]|0)<0)O5b(f[q>>2]|0);ga=0}else if((_|0)==57){J=h;f[J>>2]=W;f[J+4>>2]=X;if(b[$+20>>0]|0){jsb(0,f[z>>2]|0,c);ga=1;break}dua(o,454176,m);eua(n,o,454191);Ccb(g,n,f[L>>2]|0);eua(e,g,476219);wrb(f[a>>2]|0,(f[I>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[n+11>>0]|0)<0)O5b(f[n>>2]|0);if((b[o+11>>0]|0)<0)O5b(f[o>>2]|0);ga=0}else if((_|0)==70){J=h;f[J>>2]=W;f[J+4>>2]=X;dua(g,453975,m);eua(e,g,454234);wrb(f[a>>2]|0,(f[I>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);ga=0}else if((_|0)==76){J=h;f[J>>2]=W;f[J+4>>2]=X;dua(g,454176,m);eua(e,g,454270);wrb(f[a>>2]|0,(f[I>>2]|0)+12|0,f[z>>2]|0,7,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);ga=0}else if((_|0)==87){J=h;f[J>>2]=W;f[J+4>>2]=X;if((f[da+36>>2]|0)!=3?(f[s>>2]=f[l>>2],f[t>>2]=f[i>>2],J=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0,ea=Uh[f[(f[J>>2]|0)+8>>2]&1023](J,c)|0,f[g>>2]=f[s>>2],f[e>>2]=f[t>>2],!(lsb(a,g,e,da,m,ea)|0)):0){ga=0;break}ea=L5b(4)|0;f[ea>>2]=0;if(msb(a,f[k>>2]|0,ea)|0){J=f[i>>2]|0;a:do if((J|0)==(f[l>>2]|0)){ia=ea;ja=ea;_=106}else{P=g+16|0;G=ea;fa=J;O=ea;B=ea;N=ea;M=ea;ba=ea;K=ea;b:while(1){ka=L5b(4)|0;f[ka>>2]=0;fa=fa+-4|0;ca=f[fa>>2]|0;switch(f[ca+32>>2]|0){case 11:{Nob(e,QPb(ka,f[ca+28>>2]|0)|0);$nb(g,e);aQb(G,g);if(b[P>>0]|0){zpb(v,3,450744,5948);xpb(w,vpb(wpb(vpb(vpb(v,454366)|0,454398)|0,m)|0,476219)|0);Apb(v)}aob(g);xob(e);break}case 10:{JPb(RPb(ka,f[ca+28>>2]|0)|0,G);break}default:break b}if((G|0)!=(ka|0))if(!G){la=ka;ma=ka;na=ka;oa=ka;pa=ka;qa=ka;ra=ka}else{if(f[G>>2]|0)GPb(G);O5b(O);la=ka;ma=ka;na=ka;oa=ka;pa=ka;qa=ka;ra=ka}else{la=G;ma=K;na=ba;oa=M;pa=N;qa=B;ra=O}if((fa|0)==(f[l>>2]|0)){ia=pa;ja=la;_=106;break a}else{G=la;O=ra;B=qa;N=pa;M=oa;ba=na;K=ma}}zpb(x,3,450744,5961);K=vpb(x,454454)|0;xpb(y,ypb(K,f[(f[fa>>2]|0)+32>>2]|0)|0);Apb(x);if(f[ka>>2]|0)GPb(ka);O5b(ka);sa=0;ta=G;ua=N}while(0);if((_|0)==106){J=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;JPb(Uh[f[(f[J>>2]|0)+12>>2]&1023](J,c)|0,ja);sa=1;ta=ja;ua=ia}if(!ta){ga=sa;break}else{va=sa;wa=ta;xa=ua}}else{va=0;wa=ea;xa=ea}if(f[wa>>2]|0)GPb(wa);O5b(xa);ga=va}while(0);if((b[j>>0]|0)<0)O5b(f[m>>2]|0);m=f[l>>2]|0;if(m|0){l=f[i>>2]|0;if((l|0)!=(m|0))f[i>>2]=l+(~((l+-4-m|0)>>>2)<<2);O5b(m)}F=ga;u=d;return F|0}function Mrb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+32|0;h=g;i=f[a+8>>2]|0;if(!i){zpb(h,1,450744,3423);xpb(g+24|0,wpb(vpb(wpb(vpb(wpb(h,a+28|0)|0,489135)|0,b)|0,475786)|0,e)|0);Apb(h);u=g;return}else{Wg[f[(f[i>>2]|0)+12>>2]&127](i,a+28|0,b,c,d,e);u=g;return}}function Nrb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e+12|0;h=e;i=c+36|0;if((f[i>>2]|0)>0){j=c+40|0;k=d+68|0;l=0;do{Urb(a,(f[j>>2]|0)+(l*88|0)|0,f[(f[k>>2]|0)+4+(l<<2)>>2]|0);l=l+1|0}while((l|0)<(f[i>>2]|0))}i=c+44|0;if((f[i>>2]|0)>0){l=c+48|0;k=d+84|0;j=0;do{Vrb(a,(f[l>>2]|0)+(j<<5)|0,f[(f[k>>2]|0)+4+(j<<2)>>2]|0);j=j+1|0}while((j|0)<(f[i>>2]|0))}i=c+52|0;if((f[i>>2]|0)>0){j=c+56|0;k=d+100|0;l=0;do{m=f[j>>2]|0;n=f[(f[k>>2]|0)+4+(l<<2)>>2]|0;o=m+(l*24|0)+8|0;p=f[o>>2]|0;do if((p|0?(q=p+76|0,r=f[q>>2]|0,(r|0)!=(fEb()|0)):0)?(f[(f[q>>2]|0)+76>>2]|0)==3:0){q=f[(f[o>>2]|0)+76>>2]|0;if((b[q+71>>0]|0)==0?(b[q+72>>0]|0)==0:0)break;vrb(a,f[m+(l*24|0)+4>>2]|0,n,0,452189)}while(0);l=l+1|0}while((l|0)<(f[i>>2]|0))}i=c+60|0;if((f[i>>2]|0)>0){l=c+72|0;k=d+116|0;j=0;do{Wrb(a,(f[l>>2]|0)+(j*88|0)|0,f[(f[k>>2]|0)+4+(j<<2)>>2]|0);j=j+1|0}while((j|0)<(f[i>>2]|0))}i=c+76|0;j=f[i>>2]|0;if(!((j|0)!=(fEb()|0)?(f[(f[i>>2]|0)+76>>2]|0)==3:0))s=19;a:do if((s|0)==19?(i=c+12|0,(f[i>>2]|0)>0):0){j=c+16|0;k=0;while(1){l=f[(f[j>>2]|0)+(k<<2)>>2]|0;if((l|0?(n=l+76|0,l=f[n>>2]|0,(l|0)!=(fEb()|0)):0)?(f[(f[n>>2]|0)+76>>2]|0)==3:0)break;n=k+1|0;if((n|0)<(f[i>>2]|0))k=n;else break a}i=f[c>>2]|0;dua(h,452334,f[f[(f[j>>2]|0)+(k<<2)>>2]>>2]|0);eua(g,h,452471);wrb(a,i,d,9,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0)}while(0);if((f[c+64>>2]|0)!=3){u=e;return}Xrb(a,c,d);u=e;return}function Orb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=u;u=u+80|0;g=e+60|0;h=e+48|0;i=e+32|0;j=e+16|0;k=e;l=h+4|0;f[l>>2]=0;m=h+8|0;f[m>>2]=0;n=h+4|0;f[h>>2]=n;o=c+40|0;if((f[o>>2]|0)>0){p=c+44|0;q=j+12|0;r=i+12|0;s=i+11|0;t=j+11|0;v=k+11|0;w=c+4|0;x=g+11|0;y=i+11|0;z=d+60|0;A=0;do{B=f[p>>2]|0;C=B+(A*88|0)|0;X5b(k,f[C>>2]|0);X5b(j,k);f[q>>2]=C;X5b(i,j);f[r>>2]=f[q>>2];D=Rrb(h,g,i)|0;E=f[D>>2]|0;if(!E){F=L5b(32)|0;X5b(F+16|0,i);f[F+28>>2]=f[r>>2];G=f[g>>2]|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=G;f[D>>2]=F;G=f[f[h>>2]>>2]|0;if(!G)H=F;else{f[h>>2]=G;H=f[D>>2]|0}mP(f[l>>2]|0,H);f[m>>2]=(f[m>>2]|0)+1;I=F;J=1}else{I=E;J=0}if((b[s>>0]|0)<0)O5b(f[i>>2]|0);if((b[t>>0]|0)<0)O5b(f[j>>2]|0);if((b[v>>0]|0)<0)O5b(f[k>>2]|0);do if(!(J<<24>>24)){if((b[(f[(f[I+28>>2]|0)+16>>2]|0)+51>>0]|0)==0?(b[(f[B+(A*88|0)+16>>2]|0)+51>>0]|0)==0:0)break;E=f[w>>2]|0;dua(i,452001,f[C>>2]|0);eua(g,i,452026);wrb(a,E,d,0,g);if((b[x>>0]|0)<0)O5b(f[g>>2]|0);if((b[y>>0]|0)<0)O5b(f[i>>2]|0)}while(0);Orb(a,(f[p>>2]|0)+(A*88|0)|0,f[(f[z>>2]|0)+4+(A<<2)>>2]|0);A=A+1|0}while((A|0)<(f[o>>2]|0))}o=c+24|0;if((f[o>>2]|0)>0){A=c+28|0;z=c+4|0;p=g+11|0;y=i+11|0;x=0;do{w=Srb(h,f[(f[A>>2]|0)+(x*88|0)>>2]|0)|0;if((w|0)!=(n|0)?(I=f[w+28>>2]|0,b[(f[I+16>>2]|0)+51>>0]|0):0){w=f[z>>2]|0;dua(i,452001,f[I>>2]|0);eua(g,i,452075);wrb(a,w,d,0,g);if((b[p>>0]|0)<0)O5b(f[g>>2]|0);if((b[y>>0]|0)<0)O5b(f[i>>2]|0)}x=x+1|0}while((x|0)<(f[o>>2]|0))}o=c+48|0;if((f[o>>2]|0)>0){x=c+52|0;y=c+4|0;p=g+11|0;z=i+11|0;A=0;do{w=Srb(h,f[(f[x>>2]|0)+(A<<5)>>2]|0)|0;if((w|0)!=(n|0)?(I=f[w+28>>2]|0,b[(f[I+16>>2]|0)+51>>0]|0):0){w=f[y>>2]|0;dua(i,452001,f[I>>2]|0);eua(g,i,452110);wrb(a,w,d,0,g);if((b[p>>0]|0)<0)O5b(f[g>>2]|0);if((b[z>>0]|0)<0)O5b(f[i>>2]|0)}A=A+1|0}while((A|0)<(f[o>>2]|0))}o=c+32|0;if((f[o>>2]|0)<=0){K=h;L=f[n>>2]|0;Trb(K,L);u=e;return}A=c+36|0;z=c+4|0;c=g+11|0;p=i+11|0;y=0;do{x=Srb(h,f[(f[A>>2]|0)+(y*28|0)>>2]|0)|0;if((x|0)!=(n|0)?(w=f[x+28>>2]|0,b[(f[w+16>>2]|0)+51>>0]|0):0){x=f[z>>2]|0;dua(i,452001,f[w>>2]|0);eua(g,i,452149);wrb(a,x,d,0,g);if((b[c>>0]|0)<0)O5b(f[g>>2]|0);if((b[p>>0]|0)<0)O5b(f[i>>2]|0)}y=y+1|0}while((y|0)<(f[o>>2]|0));K=h;L=f[n>>2]|0;Trb(K,L);u=e;return}function Prb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+48|0;e=d+24|0;g=d+12|0;h=d;if(!(f[a+68>>2]|0)){u=d;return}i=g+4|0;f[i>>2]=0;j=g+8|0;f[j>>2]=0;k=g+4|0;f[g>>2]=k;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;l=L5b(32)|0;f[h>>2]=l;f[h+8>>2]=-2147483616;f[h+4>>2]=30;m=l;n=451738;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[l+30>>0]=0;l=lP(g,e,h)|0;if(!(f[l>>2]|0)){p=L5b(28)|0;X5b(p+16|0,h);q=f[e>>2]|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=q;f[l>>2]=p;q=f[f[g>>2]>>2]|0;if(!q)r=p;else{f[g>>2]=q;r=f[l>>2]|0}mP(f[i>>2]|0,r);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=L5b(32)|0;f[h>>2]=r;f[h+8>>2]=-2147483616;f[h+4>>2]=27;m=r;n=451769;o=m+27|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[r+27>>0]=0;r=lP(g,e,h)|0;if(!(f[r>>2]|0)){l=L5b(28)|0;X5b(l+16|0,h);q=f[e>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=q;f[r>>2]=l;q=f[f[g>>2]>>2]|0;if(!q)s=l;else{f[g>>2]=q;s=f[r>>2]|0}mP(f[i>>2]|0,s);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=L5b(32)|0;f[h>>2]=s;f[h+8>>2]=-2147483616;f[h+4>>2]=28;m=s;n=451797;o=m+28|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[s+28>>0]=0;s=lP(g,e,h)|0;if(!(f[s>>2]|0)){r=L5b(28)|0;X5b(r+16|0,h);q=f[e>>2]|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=q;f[s>>2]=r;q=f[f[g>>2]>>2]|0;if(!q)t=r;else{f[g>>2]=q;t=f[s>>2]|0}mP(f[i>>2]|0,t);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;t=L5b(32)|0;f[h>>2]=t;f[h+8>>2]=-2147483616;f[h+4>>2]=27;m=t;n=451826;o=m+27|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[t+27>>0]=0;t=lP(g,e,h)|0;if(!(f[t>>2]|0)){s=L5b(28)|0;X5b(s+16|0,h);q=f[e>>2]|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=q;f[t>>2]=s;q=f[f[g>>2]>>2]|0;if(!q)v=s;else{f[g>>2]=q;v=f[t>>2]|0}mP(f[i>>2]|0,v);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;v=L5b(48)|0;f[h>>2]=v;f[h+8>>2]=-2147483600;f[h+4>>2]=32;m=v;n=451854;o=m+32|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[v+32>>0]=0;v=lP(g,e,h)|0;if(!(f[v>>2]|0)){t=L5b(28)|0;X5b(t+16|0,h);q=f[e>>2]|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=q;f[v>>2]=t;q=f[f[g>>2]>>2]|0;if(!q)w=t;else{f[g>>2]=q;w=f[v>>2]|0}mP(f[i>>2]|0,w);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;w=L5b(32)|0;f[h>>2]=w;f[h+8>>2]=-2147483616;f[h+4>>2]=30;m=w;n=451887;o=m+30|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[w+30>>0]=0;w=lP(g,e,h)|0;if(!(f[w>>2]|0)){v=L5b(28)|0;X5b(v+16|0,h);q=f[e>>2]|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=q;f[w>>2]=v;q=f[f[g>>2]>>2]|0;if(!q)x=v;else{f[g>>2]=q;x=f[w>>2]|0}mP(f[i>>2]|0,x);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;x=L5b(32)|0;f[h>>2]=x;f[h+8>>2]=-2147483616;f[h+4>>2]=29;m=x;n=451918;o=m+29|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[x+29>>0]=0;x=lP(g,e,h)|0;if(!(f[x>>2]|0)){w=L5b(28)|0;X5b(w+16|0,h);q=f[e>>2]|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=q;f[x>>2]=w;q=f[f[g>>2]>>2]|0;if(!q)y=w;else{f[g>>2]=q;y=f[x>>2]|0}mP(f[i>>2]|0,y);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;y=L5b(32)|0;f[h>>2]=y;f[h+8>>2]=-2147483616;f[h+4>>2]=29;m=y;n=451948;o=m+29|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));b[y+29>>0]=0;y=lP(g,e,h)|0;if(!(f[y>>2]|0)){n=L5b(28)|0;X5b(n+16|0,h);m=f[e>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=m;f[y>>2]=n;m=f[f[g>>2]>>2]|0;if(!m)z=n;else{f[g>>2]=m;z=f[y>>2]|0}mP(f[i>>2]|0,z);f[j>>2]=(f[j>>2]|0)+1}if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);j=f[a+60>>2]|0;z=a+64|0;if((j|0)!=(z|0)){i=h+11|0;y=e+11|0;m=j;while(1){j=m+16|0;n=f[j>>2]|0;o=f[n+60>>2]|0;a:do if((o|0)>0){x=0;q=n;while(1){if((Qrb(g,f[(f[(f[q+72>>2]|0)+(x*88|0)+48>>2]|0)+4>>2]|0)|0)!=(k|0))break;w=x+1|0;v=f[j>>2]|0;t=f[v+60>>2]|0;if((w|0)<(t|0)){x=w;q=v}else{A=w;B=t;C=v;break a}}q=f[j>>2]|0;A=x;B=f[q+60>>2]|0;C=q}else{A=0;B=o;C=n}while(0);if((A|0)==(B|0)){dua(h,451978,f[C>>2]|0);eua(e,h,451986);if((b[i>>0]|0)<0)O5b(f[h>>2]|0);Mrb(a,f[f[j>>2]>>2]|0,c,9,e);if((b[y>>0]|0)<0)O5b(f[e>>2]|0)}n=f[m+4>>2]|0;do if(!n){o=m+8|0;q=f[o>>2]|0;if((f[q>>2]|0)==(m|0)){D=q;break}else E=o;do{o=f[E>>2]|0;E=o+8|0;q=f[E>>2]|0}while((f[q>>2]|0)!=(o|0));D=q}else{x=n;while(1){q=f[x>>2]|0;if(!q)break;else x=q}D=x}while(0);if((D|0)==(z|0))break;else m=D}}kP(g,f[k>>2]|0);u=d;return}function Qrb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=ZVb(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=ZVb(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function Rrb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=ZVb(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=ZVb(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function Srb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=ZVb(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=ZVb(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function Trb(a,c){a=a|0;c=c|0;if(!c)return;Trb(a,f[c>>2]|0);Trb(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(c);return}function Urb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=u;u=u+416|0;g=e+400|0;h=e+360|0;i=e+320|0;j=e+280|0;k=e+240|0;l=e+200|0;m=e+160|0;n=e+120|0;o=e+80|0;p=e+40|0;q=e;r=c+24|0;if((f[r>>2]|0)>0){s=c+28|0;t=d+28|0;v=0;do{Wrb(a,(f[s>>2]|0)+(v*88|0)|0,f[(f[t>>2]|0)+4+(v<<2)>>2]|0);v=v+1|0}while((v|0)<(f[r>>2]|0))}r=c+40|0;if((f[r>>2]|0)>0){v=c+44|0;t=d+60|0;s=0;do{Urb(a,(f[v>>2]|0)+(s*88|0)|0,f[(f[t>>2]|0)+4+(s<<2)>>2]|0);s=s+1|0}while((s|0)<(f[r>>2]|0))}r=c+48|0;if((f[r>>2]|0)>0){s=c+52|0;t=d+76|0;v=0;do{Vrb(a,(f[s>>2]|0)+(v<<5)|0,f[(f[t>>2]|0)+4+(v<<2)>>2]|0);v=v+1|0}while((v|0)<(f[r>>2]|0))}r=c+64|0;if((f[r>>2]|0)>0){v=c+68|0;t=d+44|0;s=0;do{Wrb(a,(f[v>>2]|0)+(s*88|0)|0,f[(f[t>>2]|0)+4+(s<<2)>>2]|0);s=s+1|0}while((s|0)<(f[r>>2]|0))}r=(b[(f[c+16>>2]|0)+48>>0]|0)!=0;s=r?2147483647:536870911;t=r?0:0;r=c+56|0;v=f[r>>2]|0;if((v|0)<=0){u=e;return}w=c+60|0;x=Kac(s|0,t|0,1,0)|0;y=J;z=c+4|0;c=d+92|0;d=h+8|0;A=h+4|0;B=i+4|0;C=j+4|0;D=k+4|0;E=l+4|0;F=m+4|0;G=n+4|0;H=o+4|0;I=p+4|0;K=q+4|0;L=g+11|0;M=0;N=v;while(1){v=f[(f[w>>2]|0)+(M<<3)+4>>2]|0;O=((v|0)<0)<<31>>31;if((O|0)>(y|0)|(O|0)==(y|0)&v>>>0>x>>>0){v=f[z>>2]|0;O=f[(f[c>>2]|0)+4+(M<<2)>>2]|0;P=qSb(s,t,d)|0;f[h>>2]=P;Q=kUb(P)|0;f[A>>2]=Q;f[i>>2]=0;f[B>>2]=-1;f[j>>2]=0;f[C>>2]=-1;f[k>>2]=0;f[D>>2]=-1;f[l>>2]=0;f[E>>2]=-1;f[m>>2]=0;f[F>>2]=-1;f[n>>2]=0;f[G>>2]=-1;f[o>>2]=0;f[H>>2]=-1;f[p>>2]=0;f[I>>2]=-1;f[q>>2]=0;f[K>>2]=-1;hOb(g,453812,h,i,j,k,l,m,n,o,p,q);wrb(a,v,O,1,g);if((b[L>>0]|0)<0)O5b(f[g>>2]|0);R=f[r>>2]|0}else R=N;M=M+1|0;if((M|0)>=(R|0))break;else N=R}u=e;return}function Vrb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;e=u;u=u+96|0;g=e+72|0;h=e+60|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e;m=e+84|0;n=c+24|0;o=c+16|0;p=f[o>>2]|0;if(f[p+24>>2]&1|0?b[p+48>>0]|0:0){u=e;return}p=g+4|0;f[p>>2]=0;q=g+8|0;f[q>>2]=0;r=g+4|0;f[g>>2]=r;a:do if((f[n>>2]|0)>0){s=c+28|0;t=i+11|0;v=j+11|0;w=k+11|0;x=c+4|0;y=h+11|0;z=0;A=0;B=0;while(1){C=f[s>>2]|0;D=C+(z*20|0)+8|0;E=f[D>>2]|0;do if(A){F=r;G=A;b:while(1){H=G;while(1){if((f[H+16>>2]|0)>=(E|0))break;I=f[H+4>>2]|0;if(!I){J=F;break b}else H=I}G=f[H>>2]|0;if(!G){J=H;break}else F=H}if((J|0)!=(r|0)?(E|0)>=(f[J+16>>2]|0):0){dua(k,476054,f[C+(z*20|0)+4>>2]|0);eua(j,k,453699);F=f[D>>2]|0;G=f[r>>2]|0;do if(G){I=p;K=G;L=G;while(1){M=f[K+16>>2]|0;if((F|0)<(M|0)){N=f[K>>2]|0;if(!N){O=18;break}else{P=K;Q=N}}else{if((M|0)>=(F|0)){O=22;break}R=K+4|0;M=f[R>>2]|0;if(!M){O=21;break}else{P=R;Q=M}}I=P;K=Q;L=Q}if((O|0)==18){O=0;S=K;T=K;O=24;break}else if((O|0)==21){O=0;S=R;T=K;O=24;break}else if((O|0)==22){O=0;U=I;V=K;W=L;O=23;break}}else{U=r;V=r;W=G;O=23}while(0);if((O|0)==23){O=0;if(!W){S=U;T=V;O=24}else X=W}if((O|0)==24){O=0;G=L5b(32)|0;f[G+16>>2]=F;H=G+20|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=T;f[S>>2]=G;H=f[f[g>>2]>>2]|0;if(!H)Y=G;else{f[g>>2]=H;Y=f[S>>2]|0}mP(f[p>>2]|0,Y);f[q>>2]=(f[q>>2]|0)+1;X=G}Ccb(i,j,X+20|0);eua(h,i,453731);if((b[t>>0]|0)<0)O5b(f[i>>2]|0);if((b[v>>0]|0)<0)O5b(f[j>>2]|0);if((b[w>>0]|0)<0)O5b(f[k>>2]|0);if(!(b[(f[o>>2]|0)+48>>0]|0))wrb(a,f[x>>2]|0,d,1,h);else{zpb(l,2,450744,5540);xpb(m,wpb(l,h)|0);Apb(l)}if((b[y>>0]|0)<0)O5b(f[h>>2]|0);break}G=f[C+(z*20|0)+4>>2]|0;H=p;M=A;N=B;while(1){Z=f[M+16>>2]|0;if((E|0)<(Z|0)){_=f[M>>2]|0;if(!_){O=43;break}else{$=M;aa=_}}else{if((Z|0)>=(E|0)){O=47;break}ba=M+4|0;Z=f[ba>>2]|0;if(!Z){O=46;break}else{$=ba;aa=Z}}H=$;M=aa;N=aa}if((O|0)==43){O=0;ca=M;da=M;ea=G;O=48;break}else if((O|0)==46){O=0;ca=ba;da=M;ea=G;O=48;break}else if((O|0)==47){O=0;if(!N){ca=H;da=M;ea=G;O=48;break}else{fa=N;ga=G;O=51;break}}}else{ca=r;da=r;ea=f[C+(z*20|0)+4>>2]|0;O=48}while(0);if((O|0)==48){O=0;C=L5b(32)|0;f[C+16>>2]=E;D=C+20|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=da;f[ca>>2]=C;D=f[f[g>>2]>>2]|0;if(!D)ha=C;else{f[g>>2]=D;ha=f[ca>>2]|0}mP(f[p>>2]|0,ha);f[q>>2]=(f[q>>2]|0)+1;fa=C;ga=ea;O=51}if((O|0)==51){O=0;_5b(fa+20|0,ga)|0}C=z+1|0;D=f[r>>2]|0;if((C|0)>=(f[n>>2]|0)){ia=D;break a}z=C;A=D;B=D}}else ia=0;while(0);gsb(g,ia);u=e;return}function Wrb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=c+68|0;g=f[e>>2]|0;if((b[g+57>>0]|0)!=0?(f[c+32>>2]|0)!=11:0){vrb(a,f[c+4>>2]|0,d,2,453115);h=f[e>>2]|0}else h=g;do if(b[h+56>>0]|0){if((f[c+36>>2]|0)==3?((f[c+32>>2]|0)+-9|0)>>>0>3:0)break;vrb(a,f[c+4>>2]|0,d,2,453174)}while(0);h=c+48|0;g=f[h>>2]|0;do if((g|0?(e=f[g+16>>2]|0,(e|0)!=(hEb()|0)):0)?b[(f[(f[h>>2]|0)+16>>2]|0)+48>>0]|0:0){if(!(b[c+40>>0]|0)){vrb(a,f[c+4>>2]|0,d,0,453243);break}if((f[c+36>>2]|0)==1?(f[c+32>>2]|0)==11:0)break;vrb(a,f[c+4>>2]|0,d,2,477395)}while(0);g=f[c+24>>2]|0;do if(((g|0?(e=g+76|0,i=f[e>>2]|0,(i|0)!=(fEb()|0)):0)?(f[(f[e>>2]|0)+76>>2]|0)==3:0)?(e=f[h>>2]|0,e|0):0){i=f[e+8>>2]|0;if((i|0?(e=i+76|0,i=f[e>>2]|0,(i|0)!=(fEb()|0)):0)?(f[(f[e>>2]|0)+76>>2]|0)==3:0)break;vrb(a,f[c+4>>2]|0,d,3,453292)}while(0);if((f[c+32>>2]|0)!=11)return;if(!(b[(f[(f[c+60>>2]|0)+16>>2]|0)+51>>0]|0))return;if(esb(a,c,d)|0)return;vrb(a,f[c+4>>2]|0,d,9,453458);return}function Xrb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=b+60|0;if((f[d>>2]|0)>0){e=b+72|0;g=c+116|0;h=0;do{Yrb(a,(f[e>>2]|0)+(h*88|0)|0,f[(f[g>>2]|0)+4+(h<<2)>>2]|0);h=h+1|0}while((h|0)<(f[d>>2]|0))}d=b+36|0;if((f[d>>2]|0)>0){h=b+40|0;g=c+68|0;e=0;do{Zrb(a,(f[h>>2]|0)+(e*88|0)|0,f[(f[g>>2]|0)+4+(e<<2)>>2]|0);e=e+1|0}while((e|0)<(f[d>>2]|0))}d=b+44|0;e=f[d>>2]|0;if((e|0)<=0)return;g=b+48|0;b=c+84|0;c=0;h=e;while(1){e=f[g>>2]|0;i=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if((f[e+(c<<5)+24>>2]|0)>0?(f[(f[e+(c<<5)+28>>2]|0)+8>>2]|0)!=0:0){vrb(a,f[e+(c<<5)+4>>2]|0,i,9,452483);j=f[d>>2]|0}else j=h;c=c+1|0;if((c|0)>=(j|0))break;else h=j}return}function Yrb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(b[c+40>>0]|0){k=f[(f[c+48>>2]|0)+4>>2]|0;if((f[213367]|0)!=2){f[g>>2]=135812;f[g+4>>2]=50;b[g+8>>0]=0;Gpb(853468,g);hpb(g)}l=Qrb(f[213368]|0,k)|0;if((l|0)==((f[213368]|0)+4|0))vrb(a,f[c+4>>2]|0,d,9,452707)}if((f[c+36>>2]|0)==2)vrb(a,f[c+4>>2]|0,d,9,452767);if(b[c+72>>0]|0)vrb(a,f[c+4>>2]|0,d,9,452810);l=c+32|0;k=f[l>>2]|0;if((k|0)==14){m=f[c+64>>2]|0;if(!m){u=e;return}if((f[(f[m+8>>2]|0)+64>>2]|0)==3){u=e;return}n=f[c+4>>2]|0;dua(j,452861,f[m+4>>2]|0);eua(i,j,452873);Ccb(h,i,f[(f[c+48>>2]|0)+4>>2]|0);eua(g,h,452914);wrb(a,n,d,2,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);o=f[l>>2]|0}else o=k;if((o|0)!=10){u=e;return}vrb(a,f[c+4>>2]|0,d,2,452948);u=e;return}function Zrb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+96|0;g=e+72|0;h=e+60|0;i=e+48|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;n=c+40|0;if((f[n>>2]|0)>0){o=c+44|0;p=d+60|0;q=0;do{Zrb(a,(f[o>>2]|0)+(q*88|0)|0,f[(f[p>>2]|0)+4+(q<<2)>>2]|0);q=q+1|0}while((q|0)<(f[n>>2]|0))}n=c+48|0;q=f[n>>2]|0;if((q|0)>0){p=c+52|0;o=d+76|0;r=0;s=q;while(1){q=f[p>>2]|0;t=f[(f[o>>2]|0)+4+(r<<2)>>2]|0;if((f[q+(r<<5)+24>>2]|0)>0?(f[(f[q+(r<<5)+28>>2]|0)+8>>2]|0)!=0:0){vrb(a,f[q+(r<<5)+4>>2]|0,t,9,452483);v=f[n>>2]|0}else v=s;r=r+1|0;if((r|0)>=(v|0))break;else s=v}}v=c+24|0;if((f[v>>2]|0)>0){s=c+28|0;r=d+28|0;n=0;do{Yrb(a,(f[s>>2]|0)+(n*88|0)|0,f[(f[r>>2]|0)+4+(n<<2)>>2]|0);n=n+1|0}while((n|0)<(f[v>>2]|0))}n=c+64|0;if((f[n>>2]|0)>0){r=c+68|0;s=d+44|0;o=0;do{Yrb(a,(f[r>>2]|0)+(o*88|0)|0,f[(f[s>>2]|0)+4+(o<<2)>>2]|0);o=o+1|0}while((o|0)<(f[n>>2]|0))}if((f[c+56>>2]|0)>0)vrb(a,f[c+4>>2]|0,d,9,452528);if(b[(f[c+16>>2]|0)+48>>0]|0)vrb(a,f[c+4>>2]|0,d,9,452572);f[g+4>>2]=0;f[g+8>>2]=0;n=g+4|0;f[g>>2]=n;if((f[v>>2]|0)<=0){w=g;x=0;_rb(w,x);u=e;return}o=c+28|0;s=h+11|0;r=c+4|0;c=i+11|0;p=j+11|0;t=k+11|0;q=l+11|0;y=m+11|0;z=0;do{A=f[(f[o>>2]|0)+(z*88|0)>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;B=A+11|0;C=b[B>>0]|0;D=A+4|0;if((C<<24>>24<0?f[D>>2]|0:C&255)|0){E=0;F=C;do{C=b[(F<<24>>24<0?f[A>>2]|0:A)+E>>0]|0;do if(C<<24>>24!=95)if((C+-65&255)<26){l6b(h,(C&255)+32&255);break}else{l6b(h,C);break}while(0);E=E+1|0;F=b[B>>0]|0}while(E>>>0<(F<<24>>24<0?f[D>>2]|0:F&255)>>>0)}if(($rb(g,h)|0)!=(n|0)){F=f[r>>2]|0;dua(m,452611,f[(f[o>>2]|0)+(z*88|0)>>2]|0);eua(l,m,452647);D=asb(g,h)|0;Ccb(k,l,f[f[D>>2]>>2]|0);eua(j,k,452672);eua(i,j,452688);wrb(a,F,d,9,i);if((b[c>>0]|0)<0)O5b(f[i>>2]|0);if((b[p>>0]|0)<0)O5b(f[j>>2]|0);if((b[t>>0]|0)<0)O5b(f[k>>2]|0);if((b[q>>0]|0)<0)O5b(f[l>>2]|0);if((b[y>>0]|0)<0)O5b(f[m>>2]|0)}else{F=f[o>>2]|0;D=asb(g,h)|0;f[D>>2]=F+(z*88|0)}if((b[s>>0]|0)<0)O5b(f[h>>2]|0);z=z+1|0}while((z|0)<(f[v>>2]|0));w=g;x=f[n>>2]|0;_rb(w,x);u=e;return}function _rb(a,c){a=a|0;c=c|0;if(!c)return;_rb(a,f[c>>2]|0);_rb(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(c);return}function $rb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=ZVb(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=ZVb(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function asb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=bsb(a,d,b)|0;g=f[e>>2]|0;if(g|0){h=g;i=h+28|0;u=c;return i|0}g=L5b(32)|0;X5b(g+16|0,b);f[g+28>>2]=0;b=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=b;f[e>>2]=g;b=f[f[a>>2]>>2]|0;if(!b)j=g;else{f[a>>2]=b;j=f[e>>2]|0}mP(f[a+4>>2]|0,j);j=a+8|0;f[j>>2]=(f[j>>2]|0)+1;h=g;i=h+28|0;u=c;return i|0}function bsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=ZVb(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=ZVb(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function csb(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;a=u;u=u+48|0;c=a+36|0;d=a+24|0;e=a+12|0;g=a;h=L5b(12)|0;i=h+4|0;f[i>>2]=0;f[h+8>>2]=0;f[h>>2]=i;f[213368]=h;i=e+8|0;j=e+4|0;k=d+11|0;l=e+11|0;m=g+11|0;n=g+5|0;o=d+11|0;p=e+11|0;q=0;r=h;while(1){h=L5b(32)|0;f[e>>2]=h;f[i>>2]=-2147483616;f[j>>2]=16;s=h;t=452991;v=s+16|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));b[h+16>>0]=0;t=f[136232+(q<<2)>>2]|0;eua(d,e,t);s=lP(r,c,d)|0;if(!(f[s>>2]|0)){v=L5b(28)|0;X5b(v+16|0,d);w=f[c>>2]|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=w;f[s>>2]=v;w=f[f[r>>2]>>2]|0;if(!w)x=v;else{f[r>>2]=w;x=f[s>>2]|0}mP(f[r+4>>2]|0,x);s=r+8|0;f[s>>2]=(f[s>>2]|0)+1}if((b[k>>0]|0)<0)O5b(f[d>>2]|0);if((b[l>>0]|0)<0)O5b(f[e>>2]|0);s=f[213368]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[m>>0]=5;b[g>>0]=b[453008]|0;b[g+1>>0]=b[453009]|0;b[g+2>>0]=b[453010]|0;b[g+3>>0]=b[453011]|0;b[g+4>>0]=b[453012]|0;b[n>>0]=0;eua(e,g,453014);eua(d,e,t);t=lP(s,c,d)|0;if(!(f[t>>2]|0)){w=L5b(28)|0;X5b(w+16|0,d);v=f[c>>2]|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=v;f[t>>2]=w;v=f[f[s>>2]>>2]|0;if(!v)y=w;else{f[s>>2]=v;y=f[t>>2]|0}mP(f[s+4>>2]|0,y);t=s+8|0;f[t>>2]=(f[t>>2]|0)+1}if((b[o>>0]|0)<0)O5b(f[d>>2]|0);if((b[p>>0]|0)<0)O5b(f[e>>2]|0);if((b[m>>0]|0)<0)O5b(f[g>>2]|0);t=q+1|0;if(t>>>0>=7)break;q=t;r=f[213368]|0}spb(51);u=a;return}function dsb(){var a=0;a=f[213368]|0;if(!a)return;kP(a,f[a+4>>2]|0);O5b(a);return}function esb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+32|0;g=e+12|0;h=e;i=f[c+60>>2]|0;if(f[i+64>>2]|0){j=0;u=e;return j|0}if((f[c+36>>2]|0)!=3){j=0;u=e;return j|0}if(f[i+56>>2]|0){j=0;u=e;return j|0}if(f[i+40>>2]|0){j=0;u=e;return j|0}if(f[i+48>>2]|0){j=0;u=e;return j|0}if((f[i+24>>2]|0)!=2){j=0;u=e;return j|0}k=f[i>>2]|0;fsb(h,f[c>>2]|0,0);eua(g,h,453535);l=b[k+11>>0]|0;m=l<<24>>24<0;n=l&255;l=m?f[k+4>>2]|0:n;o=b[g+11>>0]|0;p=o<<24>>24<0;a:do if((l|0)==((p?f[g+4>>2]|0:o&255)|0)){q=f[k>>2]|0;r=m?q:k;s=p?f[g>>2]|0:g;t=(l|0)==0;b:do if(m){if(!t?ZVb(r,s,l)|0:0){v=1;break a}}else if(!t){if((q&255)<<24>>24==(b[s>>0]|0)){w=k;x=n;y=s}else{v=1;break a}while(1){x=x+-1|0;w=w+1|0;if(!x)break b;y=y+1|0;if((b[w>>0]|0)!=(b[y>>0]|0)){v=1;break a}}}while(0);v=(f[c+48>>2]|0)!=(f[i+12>>2]|0)}else v=1;while(0);if(p)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if(v){j=0;u=e;return j|0}v=f[i+28>>2]|0;if((f[v+36>>2]|0)!=1){j=0;u=e;return j|0}if((f[v+28>>2]|0)!=1){j=0;u=e;return j|0}i=f[v>>2]|0;h=b[i+11>>0]|0;if(((h<<24>>24<0?f[i+4>>2]|0:h&255)|0)!=3){j=0;u=e;return j|0}if(u6b(i,0,-1,471913,3)|0){j=0;u=e;return j|0}if((f[v+124>>2]|0)!=1){j=0;u=e;return j|0}if((f[v+116>>2]|0)!=2){j=0;u=e;return j|0}i=f[v+88>>2]|0;h=b[i+11>>0]|0;if(((h<<24>>24<0?f[i+4>>2]|0:h&255)|0)!=5){j=0;u=e;return j|0}if(u6b(i,0,-1,471917,5)|0){j=0;u=e;return j|0}switch(f[v+32>>2]|0){case 14:{vrb(a,f[c+4>>2]|0,d,2,453541);break}case 12:case 10:case 11:case 1:case 2:{vrb(a,f[c+4>>2]|0,d,2,453581);break}default:{}}if((f[v+120>>2]|0)!=14){j=1;u=e;return j|0}if(!(f[(f[(f[v+152>>2]|0)+28>>2]|0)+8>>2]|0)){j=1;u=e;return j|0}vrb(a,f[c+4>>2]|0,d,2,453647);j=1;u=e;return j|0}function fsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=c+11|0;g=b[e>>0]|0;h=c+4|0;c6b(a,g<<24>>24<0?f[h>>2]|0:g&255);g=b[e>>0]|0;if((g<<24>>24<0?f[h>>2]|0:g&255)|0){i=d^1;j=0;k=g;while(1){g=b[(k<<24>>24<0?f[c>>2]|0:c)+j>>0]|0;do if(g<<24>>24!=95)if(i){l=g<<24>>24;l6b(a,((g+-97&255)<26?l+224|0:l)&255);m=0;break}else{l6b(a,g);m=0;break}else m=1;while(0);j=j+1|0;k=b[e>>0]|0;if(j>>>0>=(k<<24>>24<0?f[h>>2]|0:k&255)>>>0)break;else i=m}}if(!d)return;d=b[a+11>>0]|0;m=d<<24>>24<0;if(m)n=f[a+4>>2]|0;else n=d&255;if(!n)return;if(m)o=f[a>>2]|0;else o=a;n=b[o>>0]|0;o=n<<24>>24;if(m)p=f[a>>2]|0;else p=a;b[p>>0]=(n+-65&255)<26?o+32|0:o;return}function gsb(a,c){a=a|0;c=c|0;if(!c)return;gsb(a,f[c>>2]|0);gsb(a,f[c+4>>2]|0);a=c+20|0;if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(c);return}function hsb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;if((f[b>>2]|0)!=(c|0)?(h=f[c>>2]|0,(h|0)!=0):0){npb(h);i=h;j=0}else{i=0;j=1}h=c+16|0;Zsb(a,f[h>>2]|0,d);do if(!(f[a>>2]|0)){k=f[c+12>>2]|0;if(k|0?(hsb(g,b,k,d),k=g,l=f[k>>2]|0,m=f[k+4>>2]|0,k=a,f[k>>2]=l,f[k+4>>2]=m,l|0):0)break;if(_sb(c,d)|0){Zsb(g,f[h>>2]|0,d);l=g;m=f[l+4>>2]|0;k=a;f[k>>2]=f[l>>2];f[k+4>>2]=m}}while(0);if(j){u=e;return}opb(i);u=e;return}function isb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i+12|0;k=i;vsb(a,c,d,e,h);if(f[a>>2]|0){u=i;return}if(!(b[(f[c>>2]|0)+21>>0]|0)){u=i;return}h=d+11|0;e=b[h>>0]|0;l=e<<24>>24<0;m=l?f[d+4>>2]|0:e&255;a:do if(m){e=l?f[d>>2]|0:d;n=0;o=0;while(1){p=b[e+n>>0]|0;do if(p<<24>>24>96)if(p<<24>>24<123)q=0;else{r=0;s=0;break a}else{if(p<<24>>24>64)if(p<<24>>24<91|p<<24>>24==95){q=0;break}else{r=0;s=0;break a}if(p<<24>>24>47)if(p<<24>>24<58){q=0;break}else{r=0;s=0;break a}else if(o|p<<24>>24!=46){r=0;s=0;break a}else{q=1;break}}while(0);n=n+1|0;if(n>>>0>=m>>>0)break;else o=q}if(!q){o=c+4|0;n=f[o>>2]|0;if((b[e>>0]|0)==46){Y5b(k,d,1,-1,d);p=L5b(12)|0;X5b(p,k);f[j>>2]=p;t=n+76|0;v=f[t>>2]|0;if((v|0)==(f[n+80>>2]|0))Rqb(n+72|0,j);else{f[v>>2]=p;f[t>>2]=(f[t>>2]|0)+4}t=f[j>>2]|0;if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);w=t}else{t=L5b(12)|0;X5b(t,d);f[j>>2]=t;p=n+76|0;v=f[p>>2]|0;if((v|0)==(f[n+80>>2]|0))Rqb(n+72|0,j);else{f[v>>2]=t;f[p>>2]=(f[p>>2]|0)+4}w=f[j>>2]|0}p=t6b(w,46,-1)|0;if((p|0)==-1)if((f[213345]|0)==2){x=w;y=497760;z=497760}else{f[j>>2]=135812;f[j+4>>2]=7;b[j+8>>0]=0;Gpb(853380,j);hpb(j);x=w;y=497760;z=497760}else{t=f[o>>2]|0;Y5b(k,w,0,p,w);v=L5b(12)|0;X5b(v,k);f[j>>2]=v;n=t+76|0;A=f[n>>2]|0;if((A|0)==(f[t+80>>2]|0))Rqb(t+72|0,j);else{f[A>>2]=v;f[n>>2]=(f[n>>2]|0)+4}n=f[j>>2]|0;if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);v=f[o>>2]|0;Y5b(k,w,p+1|0,-1,w);p=L5b(12)|0;X5b(p,k);f[j>>2]=p;A=v+76|0;t=f[A>>2]|0;if((t|0)==(f[v+80>>2]|0))Rqb(v+72|0,j);else{f[t>>2]=p;f[A>>2]=(f[A>>2]|0)+4}A=f[j>>2]|0;if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);x=A;y=n;z=n}eua(j,w,456385);n=zrb(c,j)|0;if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);f[n+4>>2]=z;if((g|0)!=1){f[n+36>>2]=1;A=f[o>>2]|0;p=L5b(88)|0;f[j>>2]=p;t=A+112|0;v=f[t>>2]|0;if((v|0)==(f[A+116>>2]|0))HO(A+108|0,j);else{f[v>>2]=p;f[t>>2]=(f[t>>2]|0)+4}t=f[j>>2]|0;f[n+40>>2]=t;B=t+12|0;C=B+76|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(C|0));f[t+4>>2]=w;f[t>>2]=x;f[t+8>>2]=n;e=hEb()|0;f[t+16>>2]=e;b[t+20>>0]=1;b[t+21>>0]=(b[((b[h>>0]|0)<0?f[d>>2]|0:d)>>0]|0)!=46&1;if((g|0)==2){f[t+56>>2]=1;e=f[o>>2]|0;p=L5b(8)|0;f[j>>2]=p;v=e+112|0;A=f[v>>2]|0;if((A|0)==(f[e+116>>2]|0))HO(e+108|0,j);else{f[A>>2]=p;f[v>>2]=(f[v>>2]|0)+4}v=f[j>>2]|0;f[t+60>>2]=v;f[v>>2]=1;f[v+4>>2]=536870912}r=1;s=t;break}f[n+44>>2]=1;v=f[o>>2]|0;p=L5b(32)|0;f[j>>2]=p;A=v+112|0;e=f[A>>2]|0;if((e|0)==(f[v+116>>2]|0))HO(v+108|0,j);else{f[e>>2]=p;f[A>>2]=(f[A>>2]|0)+4}A=f[j>>2]|0;f[n+48>>2]=A;p=A+12|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[A+4>>2]=w;f[A>>2]=x;f[A+8>>2]=n;p=nEb()|0;f[A+16>>2]=p;b[A+20>>0]=1;b[A+21>>0]=(b[((b[h>>0]|0)<0?f[d>>2]|0:d)>>0]|0)!=46&1;f[A+24>>2]=1;p=f[o>>2]|0;e=L5b(20)|0;f[j>>2]=e;v=p+112|0;D=f[v>>2]|0;if((D|0)==(f[p+116>>2]|0))HO(p+108|0,j);else{f[D>>2]=e;f[v>>2]=(f[v>>2]|0)+4}v=f[j>>2]|0;f[A+28>>2]=v;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;e=f[o>>2]|0;D=L5b(32)|0;f[k>>2]=D;f[k+8>>2]=-2147483616;f[k+4>>2]=17;B=D;p=456404;C=B+17|0;do{b[B>>0]=b[p>>0]|0;B=B+1|0;p=p+1|0}while((B|0)<(C|0));b[D+17>>0]=0;p=L5b(12)|0;X5b(p,k);f[j>>2]=p;n=e+76|0;t=f[n>>2]|0;if((t|0)==(f[e+80>>2]|0))Rqb(e+72|0,j);else{f[t>>2]=p;f[n>>2]=(f[n>>2]|0)+4}f[v>>2]=f[j>>2];if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);n=b[z+11>>0]|0;if(n<<24>>24<0)E=f[y+4>>2]|0;else E=n&255;if(E){n=f[o>>2]|0;eua(k,y,456422);p=L5b(12)|0;X5b(p,k);f[j>>2]=p;t=n+76|0;F=f[t>>2]|0;if((F|0)==(f[n+80>>2]|0))Rqb(n+72|0,j);else{f[F>>2]=p;f[t>>2]=(f[t>>2]|0)+4}f[v+4>>2]=f[j>>2];if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0)}else f[v+4>>2]=f[v>>2];f[v+8>>2]=0;f[v+12>>2]=A;t=pEb()|0;f[v+16>>2]=t;r=4;s=A}else{r=0;s=0}}else{r=0;s=0}while(0);f[a>>2]=r;f[a+4>>2]=s;u=i;return}function jsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;a=u;u=u+64|0;e=a+40|0;g=a;h=a+16|0;i=a+48|0;zh[f[(f[d>>2]|0)+96>>2]&2047](e,d);j=f[e>>2]|0;k=L5b(32)|0;f[g>>2]=k;f[g+8>>2]=-2147483616;f[g+4>>2]=20;l=k;m=451226;n=l+20|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));b[k+20>>0]=0;Krb(e,f[(f[j+8>>2]|0)+80>>2]|0,j,g,2);if(!(f[e>>2]|0))o=0;else{g=f[e+4>>2]|0;o=b[g+40>>0]|0?0:g}O5b(k);if(!o){zpb(h,3,450744,5980);xpb(i,vpb(h,456355)|0);Apb(h)}h=di[f[(f[d>>2]|0)+92>>2]&1023](d)|0;i=Dg[f[(f[h>>2]|0)+300>>2]&127](h,d,o,0)|0;zh[f[(f[i>>2]|0)+72>>2]&2047](i,c);u=a;return}function ksb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function lsb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+80|0;j=i+56|0;k=i+44|0;l=i+24|0;m=i+40|0;n=i+36|0;o=i+32|0;p=i+28|0;q=i;r=i+68|0;s=f[c>>2]|0;c=f[d>>2]|0;d=c;if((s|0)==(c|0)){c=f[h>>2]|0;t=e+28|0;if(!c){v=1;u=i;return v|0}w=f[c>>2]|0;x=w;y=(f[c+4>>2]|0)-w>>4;w=0;while(1){if((w|0)>=(y|0)){v=1;z=12;break}if((f[x+(w<<4)>>2]|0)==(f[t>>2]|0))break;else w=w+1|0}if((z|0)==12){u=i;return v|0}dua(k,453975,g);eua(j,k,456336);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[a+8>>2]|0,7,j);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);v=0;u=i;return v|0}w=s+4|0;t=0;a:while(1){x=f[h>>2]|0;if(!x)A=0;else A=(f[x+4>>2]|0)-(f[x>>2]|0)>>4;if((t|0)>=(A|0)){v=1;z=12;break}y=f[x>>2]|0;x=f[s>>2]|0;b:do if((f[y+(t<<4)>>2]|0)==(f[x+28>>2]|0)){B=f[x+32>>2]|0;switch(B|0){case 11:break;case 10:{if((f[y+(t<<4)+4>>2]|0)!=4)break b;f[o>>2]=w;f[p>>2]=d;c=f[y+(t<<4)+8>>2]|0;f[k>>2]=f[o>>2];f[j>>2]=f[p>>2];if(lsb(a,k,j,e,g,c)|0)break b;else{v=0;z=12;break a}break}default:{z=27;break a}}if((f[y+(t<<4)+4>>2]|0)==3){f[l>>2]=0;c=f[y+(t<<4)+8>>2]|0;C=b[c+11>>0]|0;D=C<<24>>24<0;if(TPb(l,D?f[c>>2]|0:c,D?f[c+4>>2]|0:C&255)|0?(f[m>>2]=w,f[n>>2]=d,f[k>>2]=f[m>>2],f[j>>2]=f[n>>2],!(lsb(a,k,j,e,g,l)|0)):0)E=1;else E=0;if(f[l>>2]|0)GPb(l);if(E|0){v=0;z=12;break a}}}while(0);t=t+1|0}if((z|0)==12){u=i;return v|0}else if((z|0)==27){zpb(q,3,450744,6039);xpb(r,ypb(vpb(q,454454)|0,B)|0);Apb(q);v=0;u=i;return v|0}return 0}function msb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+96|0;g=e+84|0;h=e+72|0;i=e+60|0;j=e+48|0;k=e+36|0;l=e+24|0;m=e+12|0;o=e;q=f[c+32>>2]|0;a:do switch(f[136e3+(q<<2)>>2]|0){case 1:{r=a+8|0;t=f[r>>2]|0;v=f[t+8>>2]|0;if(v&4|0){w=t+48|0;x=f[w>>2]|0;y=f[w+4>>2]|0;if(!(y>>>0>0|(y|0)==0&x>>>0>2147483647)){nsb(0,f[c+28>>2]|0,x,q,d);break a}dua(h,454494,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}if(!(v&8)){dua(h,454532,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}v=t+56|0;t=f[v>>2]|0;x=f[v+4>>2]|0;if(!((x|0)<-1|(x|0)==-1&t>>>0<2147483648)){nsb(0,f[c+28>>2]|0,t,q,d);break a}dua(h,454494,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}case 2:{r=a+8|0;t=f[r>>2]|0;x=f[t+8>>2]|0;if(!(x&4)){if(x&8|0){x=t+56|0;osb(0,f[c+28>>2]|0,f[x>>2]|0,f[x+4>>2]|0,q,d);break a}dua(h,454611,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}else{x=t+48|0;t=f[x+4>>2]|0;if((t|0)>=0){osb(0,f[c+28>>2]|0,f[x>>2]|0,t,q,d);break a}dua(h,454573,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}break}case 3:{r=a+8|0;t=f[r>>2]|0;if(!(f[t+8>>2]&4)){dua(h,454691,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}x=t+48|0;t=f[x>>2]|0;v=f[x+4>>2]|0;if(!(v>>>0>0|(v|0)==0&t>>>0>4294967295)){psb(0,f[c+28>>2]|0,t,q,d);break a}dua(h,454652,f[c>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}case 4:{r=a+8|0;t=f[r>>2]|0;if(f[t+8>>2]&4|0){v=t+48|0;qsb(0,f[c+28>>2]|0,f[v>>2]|0,f[v+4>>2]|0,q,d);break a}dua(h,454746,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}case 6:{r=a+8|0;v=f[r>>2]|0;t=f[v+8>>2]|0;do if(!(t&16)){if(t&4|0){x=v+48|0;A=+((f[x>>2]|0)>>>0)+4294967296.0*+((f[x+4>>2]|0)>>>0);break}if(t&8|0){x=v+56|0;A=+((f[x>>2]|0)>>>0)+4294967296.0*+(f[x+4>>2]|0);break}dua(h,454801,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}else A=+p[v+64>>3];while(0);OPb(d,f[c+28>>2]|0,(n[s>>2]=A,f[s>>2]|0));break}case 5:{v=a+8|0;r=f[v>>2]|0;t=f[r+8>>2]|0;do if(!(t&16)){if(t&4|0){x=r+48|0;B=+((f[x>>2]|0)>>>0)+4294967296.0*+((f[x+4>>2]|0)>>>0);break}if(t&8|0){x=r+56|0;B=+((f[x>>2]|0)>>>0)+4294967296.0*+(f[x+4>>2]|0);break}dua(h,454841,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[v>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}else B=+p[r+64>>3];while(0);p[s>>3]=B;PPb(d,f[c+28>>2]|0,f[s>>2]|0,f[s+4>>2]|0);break}case 7:{r=a+8|0;v=f[r>>2]|0;if(!(f[v+8>>2]&2)){dua(h,454882,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}t=f[v+32>>2]|0;v=b[t+11>>0]|0;x=f[t+4>>2]|0;if(((v<<24>>24<0?x:v&255)|0)==4)if(!(u6b(t,0,-1,490309,4)|0)){C=1;D=0}else{y=f[(f[r>>2]|0)+32>>2]|0;E=b[y+11>>0]|0;F=f[y+4>>2]|0;G=y;H=91}else{E=v;F=x;G=t;H=91}do if((H|0)==91){if(((E<<24>>24<0?F:E&255)|0)==5?(u6b(G,0,-1,490303,5)|0)==0:0){C=0;D=0;break}dua(h,454928,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}while(0);NPb(d,f[c+28>>2]|0,C,D);break}case 8:{r=a+8|0;t=f[r>>2]|0;if(!(f[t+8>>2]&2)){dua(h,454981,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}x=c+64|0;v=f[x>>2]|0;y=f[t+32>>2]|0;t=v+8|0;w=f[(f[t>>2]|0)+8>>2]|0;if((f[213364]|0)!=2){f[g>>2]=135812;f[g+4>>2]=47;b[g+8>>0]=0;Gpb(853456,g);hpb(g)}if((w|0)==(f[213365]|0)){Krb(g,f[(f[t>>2]|0)+80>>2]|0,v,y,5);if(f[g>>2]|0){I=f[g+4>>2]|0;H=130}}else{t=v+4|0;X5b(g,f[t>>2]|0);w=g+11|0;J=b[w>>0]|0;K=f[v>>2]|0;L=b[K+11>>0]|0;if(L<<24>>24<0)M=f[K+4>>2]|0;else M=L&255;e6b(g,(J<<24>>24<0?f[g+4>>2]|0:J&255)-M|0,0);J=b[y+11>>0]|0;L=J<<24>>24<0;j6b(g,L?f[y>>2]|0:y,L?f[y+4>>2]|0:J&255)|0;J=f[a>>2]|0;hsb(h,J,f[J>>2]|0,g);if((f[h>>2]|0)==5){J=f[h+4>>2]|0;if((f[J+12>>2]|0)==(v|0)){N=J;O=0}else{dua(o,452861,f[t>>2]|0);eua(m,o,455031);Ccb(l,m,y);eua(k,l,455054);Ccb(j,k,f[c+4>>2]|0);eua(i,j,455069);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);if((b[o+11>>0]|0)<0)O5b(f[o>>2]|0);N=0;O=1}}else{N=0;O=0}if((b[w>>0]|0)<0)O5b(f[g>>2]|0);if(!O){I=N;H=130}else{z=0;u=e;return z|0}}if((H|0)==130?I|0:0){w=f[I+8>>2]|0;NPb(d,f[c+28>>2]|0,w,((w|0)<0)<<31>>31);break a}dua(l,452861,f[(f[x>>2]|0)+4>>2]|0);eua(k,l,455031);Ccb(j,k,y);eua(i,j,455054);Ccb(h,i,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);z=0;u=e;return z|0}case 9:{r=a+8|0;y=f[r>>2]|0;if(f[y+8>>2]&32|0){x=f[y+36>>2]|0;_5b(QPb(d,f[c+28>>2]|0)|0,x)|0;break a}dua(h,455120,f[c+4>>2]|0);eua(g,h,476219);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[r>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=e;return z|0}case 10:{if(!(rsb(a,c,d)|0)){z=0;u=e;return z|0}break}default:{}}while(0);z=1;u=e;return z|0}function nsb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=u;u=u+32|0;f=a;switch(d|0){case 5:{NPb(e,b,c,((c|0)<0)<<31>>31);u=a;return}case 15:{OPb(e,b,c);u=a;return}case 17:{NPb(e,b,c<<1^c>>31,0);u=a;return}default:{zpb(f,3,450744,6374);xpb(a+24|0,ypb(vpb(f,456298)|0,d)|0);Apb(f);u=a;return}}}function osb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a=u;u=u+32|0;g=a;switch(e|0){case 3:{NPb(f,b,c,d);u=a;return}case 16:{PPb(f,b,c,d);u=a;return}case 18:{h=$ac(c|0,d|0,1)|0;i=J;NPb(f,b,h^(Rac(c|0,d|0,63)|0),i^J);u=a;return}default:{zpb(g,3,450744,6396);xpb(a+24|0,ypb(vpb(g,456260)|0,e)|0);Apb(g);u=a;return}}}function psb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0;a=u;u=u+32|0;f=a;switch(d|0){case 13:{NPb(e,b,c,0);u=a;return}case 7:{OPb(e,b,c);u=a;return}default:{zpb(f,3,450744,6413);xpb(a+24|0,ypb(vpb(f,456221)|0,d)|0);Apb(f);u=a;return}}}function qsb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0;a=u;u=u+32|0;g=a;switch(e|0){case 4:{NPb(f,b,c,d);u=a;return}case 6:{PPb(f,b,c,d);u=a;return}default:{zpb(g,3,450744,6430);xpb(a+24|0,ypb(vpb(g,456182)|0,e)|0);Apb(g);u=a;return}}}function rsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+144|0;g=e+120|0;h=e+108|0;i=e+88|0;j=e+76|0;k=e+64|0;l=e+24|0;m=e+40|0;n=e+137|0;o=e;p=e+136|0;q=a+8|0;if(!(f[(f[q>>2]|0)+8>>2]&64)){dua(l,453975,f[c+4>>2]|0);eua(k,l,455168);Ccb(j,k,f[c>>2]|0);eua(i,j,455229);Ccb(h,i,f[c>>2]|0);eua(g,h,455301);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[q>>2]|0,8,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);r=0;u=e;return r|0}s=pFb(a+12|0,f[c+60>>2]|0)|0;t=di[f[(f[s>>2]|0)+12>>2]&1023](s)|0;s=(t|0)==0;if(s){zpb(m,3,450744,6328);v=vpb(vpb(m,455316)|0,455354)|0;b[g>>0]=0;b[g+1>>0]=0;b[g+2>>0]=0;ssb(h,c,g);xpb(n,wpb(v,h)|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);Apb(m)}f[g>>2]=136268;m=g+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[h>>2]=136292;f[h+4>>2]=f[a>>2];ZOb(i);f[i>>2]=g;f[i+4>>2]=h;if(yPb(i,f[(f[q>>2]|0)+40>>2]|0,t)|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;_ob(t,j)|0;switch(f[c+32>>2]|0){case 11:{_5b(QPb(d,f[c+28>>2]|0)|0,j)|0;w=j+11|0;break}case 10:{x=30;break}default:{zpb(o,3,450744,6348);xpb(p,vpb(o,455430)|0);Apb(o);x=30}}if((x|0)==30){x=RPb(d,f[c+28>>2]|0)|0;d=j+11|0;o=b[d>>0]|0;p=o<<24>>24<0;TPb(x,p?f[j>>2]|0:j,p?f[j+4>>2]|0:o&255)|0;w=d}if((b[w>>0]|0)<0)O5b(f[j>>2]|0);y=1}else{dua(l,455387,f[c>>2]|0);eua(k,l,455426);Ccb(j,k,m);wrb(f[a>>2]|0,(f[a+4>>2]|0)+12|0,f[q>>2]|0,8,j);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);y=0}_Ob(i);f[g>>2]=136268;if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);if(s){r=y;u=e;return r|0}bi[f[(f[t>>2]|0)+4>>2]&2047](t);r=y;u=e;return r|0}function ssb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+400|0;g=e+360|0;h=e+320|0;i=e+280|0;j=e+240|0;k=e+200|0;l=e+160|0;m=e+120|0;n=e+80|0;o=e+40|0;p=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;q=c+40|0;if(!(b[q>>0]|0))r=0;else{s=f[(f[c+48>>2]|0)+4>>2]|0;t=b[s+11>>0]|0;v=t<<24>>24<0;f[g>>2]=v?f[s>>2]|0:s;f[g+4>>2]=v?f[s+4>>2]|0:t&255;f[h>>2]=0;f[h+4>>2]=-1;f[i>>2]=0;f[i+4>>2]=-1;f[j>>2]=0;f[j+4>>2]=-1;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;iOb(a,455643,g,h,i,j,k,l,m,n,o,p);r=1}Bsb(c,r,0,a,d);if(!(b[q>>0]|0)){u=e;return}k6b(a,475812)|0;u=e;return}function tsb(a){a=a|0;O5b(a);return}function usb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=u;u=u+16|0;g=e;h=a+4|0;zh[f[(f[c>>2]|0)+96>>2]&2047](g,c);c=f[g>>2]|0;vsb(g,f[h>>2]|0,d,f[c+4>>2]|0,0);switch(f[g>>2]|0){case 2:{d=f[g+4>>2]|0;i=(b[d+40>>0]|0)==0?0:d;u=e;return i|0}case 1:{if(!(b[(f[c+16>>2]|0)+48>>0]|0)){i=0;u=e;return i|0}d=f[g+4>>2]|0;g=f[d+64>>2]|0;if((g|0)<=0){i=0;u=e;return i|0}h=f[d+68>>2]|0;a=0;while(1){if((((f[h+(a*88|0)+48>>2]|0)==(c|0)?(f[h+(a*88|0)+32>>2]|0)==11:0)?(f[h+(a*88|0)+36>>2]|0)==1:0)?(f[h+(a*88|0)+60>>2]|0)==(d|0):0)break;j=a+1|0;if((j|0)<(g|0))a=j;else{i=0;k=14;break}}if((k|0)==14){u=e;return i|0}i=h+(a*88|0)|0;u=e;return i|0}default:{i=0;u=e;return i|0}}return 0}function vsb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=u;u=u+48|0;i=h+28|0;j=h+16|0;k=h+8|0;l=h;f[c+72>>2]=0;m=c+88|0;n=m+11|0;if((b[n>>0]|0)<0){b[f[m>>2]>>0]=0;f[c+92>>2]=0}else{b[m>>0]=0;b[n>>0]=0}n=d+11|0;o=b[n>>0]|0;p=o<<24>>24<0;q=d+4|0;if((p?f[q>>2]|0:o&255)|0?(b[(p?f[d>>2]|0:d)>>0]|0)==46:0){Y5b(i,d,1,-1,d);wsb(a,c,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=h;return}p=s6b(d,46,0)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if((p|0)!=-1){Y5b(j,d,0,p,d);_5b(i,j)|0;if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0)}else _5b(i,d)|0;X5b(j,e);e=t6b(j,46,-1)|0;a:do if((e|0)==-1)r=22;else{p=j+11|0;o=j+4|0;s=i+11|0;t=i+4|0;b:do if((g|0)==1){v=e;while(1){o6b(j,v,-1)|0;w=b[p>>0]|0;x=w<<24>>24<0?f[o>>2]|0:w&255;f6b(j,1,46)|0;w=b[s>>0]|0;y=w<<24>>24<0;j6b(j,y?f[i>>2]|0:i,y?f[t>>2]|0:w&255)|0;wsb(k,c,j);w=f[k>>2]|0;c:do if(w|0){y=b[s>>0]|0;z=f[t>>2]|0;A=b[n>>0]|0;B=f[q>>2]|0;if((y<<24>>24<0?z:y&255)>>>0>=(A<<24>>24<0?B:A&255)>>>0)switch(w|0){case 1:case 4:{r=30;break b;break}default:break c}C=w+-1|0;if(C>>>0<8?(-87&255)>>>(C&255)&1:0){D=y;E=z;F=A;G=B;r=27;break b}}while(0);o6b(j,x,-1)|0;v=t6b(j,46,-1)|0;if((v|0)==-1){r=22;break a}}}else{v=e;while(1){o6b(j,v,-1)|0;w=b[p>>0]|0;B=w<<24>>24<0?f[o>>2]|0:w&255;f6b(j,1,46)|0;w=b[s>>0]|0;A=w<<24>>24<0;j6b(j,A?f[i>>2]|0:i,A?f[t>>2]|0:w&255)|0;wsb(k,c,j);w=f[k>>2]|0;if(w|0){A=b[s>>0]|0;z=f[t>>2]|0;y=b[n>>0]|0;C=f[q>>2]|0;if((A<<24>>24<0?z:A&255)>>>0>=(y<<24>>24<0?C:y&255)>>>0){r=30;break b}H=w+-1|0;if(H>>>0<8?(-87&255)>>>(H&255)&1:0){D=A;E=z;F=y;G=C;r=27;break b}}o6b(j,B,-1)|0;v=t6b(j,46,-1)|0;if((v|0)==-1){r=22;break a}}}while(0);if((r|0)==27){t=D<<24>>24<0?E:D&255;m6b(j,d,t,(F<<24>>24<0?G:F&255)-t|0)|0;wsb(l,c,j);t=l;s=f[t>>2]|0;o=f[t+4>>2]|0;t=k;f[t>>2]=s;f[t+4>>2]=o;if(!s)_5b(m,j)|0;t=a;f[t>>2]=s;f[t+4>>2]=o}else if((r|0)==30){o=k;t=f[o+4>>2]|0;s=a;f[s>>2]=f[o>>2];f[s+4>>2]=t}I=p}while(0);if((r|0)==22){wsb(a,c,d);I=j+11|0}if((b[I>>0]|0)<0)O5b(f[j>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=h;return}function wsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+16|0;g=e;hsb(g,c,f[c>>2]|0,d);h=f[g>>2]|0;if(!h){i=g;j=f[i+4>>2]|0;k=a;f[k>>2]=f[i>>2];f[k+4>>2]=j;u=e;return}if(!(b[(f[c>>2]|0)+20>>0]|0)){j=g;k=f[j+4>>2]|0;i=a;f[i>>2]=f[j>>2];f[i+4>>2]=k;u=e;return}switch(h|0){case 8:{l=f[g+4>>2]|0;break}case 1:{l=f[(f[g+4>>2]|0)+8>>2]|0;break}case 2:{l=f[(f[g+4>>2]|0)+24>>2]|0;break}case 3:{l=f[(f[(f[g+4>>2]|0)+8>>2]|0)+8>>2]|0;break}case 4:{l=f[(f[g+4>>2]|0)+8>>2]|0;break}case 5:{l=f[(f[(f[g+4>>2]|0)+12>>2]|0)+8>>2]|0;break}case 6:{l=f[(f[g+4>>2]|0)+8>>2]|0;break}case 7:{l=f[(f[(f[g+4>>2]|0)+8>>2]|0)+8>>2]|0;break}default:l=0}k=l;i=f[c+40>>2]|0;a:do if((l|0)!=(i|0)){j=c+52|0;m=f[j>>2]|0;if(m|0){n=m;do{m=f[n+16>>2]|0;if(l>>>0<m>>>0)o=n;else{if(m>>>0>=l>>>0)break a;o=n+4|0}n=f[o>>2]|0}while((n|0)!=0)}b:do if((h|0)==8){n=i+4|0;m=f[n>>2]|0;p=b[m+11>>0]|0;q=d+11|0;r=b[q>>0]|0;s=r<<24>>24<0;t=d+4|0;v=s?f[t>>2]|0:r&255;do if((p<<24>>24<0?f[m+4>>2]|0:p&255)>>>0>=v>>>0?(u6b(m,0,v,s?f[d>>2]|0:d,v)|0)==0:0){r=f[n>>2]|0;w=b[r+11>>0]|0;x=w<<24>>24<0;if(x)y=f[r+4>>2]|0;else y=w&255;w=b[q>>0]|0;z=w<<24>>24<0?f[t>>2]|0:w&255;if((y|0)!=(z|0)){if(x)A=f[r>>2]|0;else A=r;if((b[A+z>>0]|0)!=46)break}z=g;r=f[z+4>>2]|0;x=a;f[x>>2]=f[z>>2];f[x+4>>2]=r;u=e;return}while(0);n=f[c+48>>2]|0;if((n|0)!=(j|0)){v=n;while(1){n=f[v+16>>2]|0;if((n|0?(s=n+4|0,n=f[s>>2]|0,m=b[n+11>>0]|0,p=b[q>>0]|0,r=p<<24>>24<0,x=r?f[t>>2]|0:p&255,(m<<24>>24<0?f[n+4>>2]|0:m&255)>>>0>=x>>>0):0)?(u6b(n,0,x,r?f[d>>2]|0:d,x)|0)==0:0){x=f[s>>2]|0;s=b[x+11>>0]|0;r=s<<24>>24<0;if(r)B=f[x+4>>2]|0;else B=s&255;s=b[q>>0]|0;n=s<<24>>24<0?f[t>>2]|0:s&255;if((B|0)==(n|0))break;if(r)C=f[x>>2]|0;else C=x;if((b[C+n>>0]|0)==46)break}n=f[v+4>>2]|0;if(!n){x=v+8|0;r=f[x>>2]|0;if((f[r>>2]|0)==(v|0))D=r;else{r=x;do{x=f[r>>2]|0;r=x+8|0;s=f[r>>2]|0}while((f[s>>2]|0)!=(x|0));D=s}}else{r=n;while(1){s=f[r>>2]|0;if(!s)break;else r=s}D=r}if((D|0)==(j|0))break b;else v=D}v=g;t=f[v+4>>2]|0;q=a;f[q>>2]=f[v>>2];f[q+4>>2]=t;u=e;return}}while(0);f[c+72>>2]=k;_5b(c+76|0,d)|0;j=a;f[j>>2]=0;f[j+4>>2]=0;u=e;return}while(0);d=c+60|0;k=c+64|0;D=f[k>>2]|0;if(D|0){C=k;B=D;c:while(1){A=B;while(1){if((f[A+16>>2]|0)>>>0>=l>>>0)break;y=f[A+4>>2]|0;if(!y){E=C;break c}else A=y}B=f[A>>2]|0;if(!B){E=A;break}else C=A}if((E|0)!=(k|0)?l>>>0>=(f[E+16>>2]|0)>>>0:0){l=f[E+4>>2]|0;if(!l){k=E+8|0;C=f[k>>2]|0;if((f[C>>2]|0)==(E|0))F=C;else{C=k;do{k=f[C>>2]|0;C=k+8|0;B=f[C>>2]|0}while((f[B>>2]|0)!=(k|0));F=B}}else{C=l;while(1){l=f[C>>2]|0;if(!l)break;else C=l}F=C}if((f[d>>2]|0)==(E|0))f[d>>2]=F;F=c+68|0;f[F>>2]=(f[F>>2]|0)+-1;wwa(D,E);O5b(E)}}E=g;g=f[E+4>>2]|0;D=a;f[D>>2]=f[E>>2];f[D+4>>2]=g;u=e;return}function xsb(a){a=a|0;var c=0;f[a>>2]=136268;c=a+4|0;if((b[c+11>>0]|0)>=0)return;O5b(f[c>>2]|0);return}function ysb(a){a=a|0;var c=0;f[a>>2]=136268;c=a+4|0;if((b[c+11>>0]|0)>=0){O5b(a);return}O5b(f[c>>2]|0);O5b(a);return}function zsb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;d=a+4|0;c=b[d+11>>0]|0;if(c<<24>>24<0)g=f[a+8>>2]|0;else g=c&255;if(g|0)k6b(d,455582)|0;g=b[e+11>>0]|0;c=g<<24>>24<0;j6b(d,c?f[e>>2]|0:e,c?f[e+4>>2]|0:g&255)|0;return}function Asb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return}function Bsb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;h=u;u=u+576|0;i=h+564|0;j=h+552|0;k=h+512|0;l=h+440|0;m=h+400|0;n=h+360|0;o=h+320|0;p=h+280|0;q=h+240|0;r=h+200|0;s=h+160|0;t=h+120|0;v=h+80|0;w=h+40|0;x=h;y=c<<1;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(y>>>0>4294967279)V5b(i);if(y>>>0<11){b[i+11>>0]=y;if(!c)z=i;else{A=i;B=6}}else{C=y+16&-16;D=L5b(C)|0;f[i>>2]=D;f[i+8>>2]=C|-2147483648;f[i+4>>2]=y;A=D;B=6}if((B|0)==6){Nac(A|0,32,y|0)|0;z=A}b[z+y>>0]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;y=a+32|0;if((f[y>>2]|0)==11?(z=a+60|0,A=f[z>>2]|0,(b[(f[A+16>>2]|0)+51>>0]|0)!=0):0){Csb(l,f[A+28>>2]|0);A=l+11|0;D=b[A>>0]|0;C=D<<24>>24<0;f[k>>2]=C?f[l>>2]|0:l;f[k+4>>2]=C?f[l+4>>2]|0:D&255;Csb(n,(f[(f[z>>2]|0)+28>>2]|0)+88|0);z=n+11|0;D=b[z>>0]|0;C=D<<24>>24<0;f[m>>2]=C?f[n>>2]|0:n;f[m+4>>2]=C?f[n+4>>2]|0:D&255;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;iOb(j,455657,k,m,o,p,q,r,s,t,v,w);if((b[z>>0]|0)<0)O5b(f[n>>2]|0);if((b[A>>0]|0)<0)O5b(f[l>>2]|0)}else B=14;if((B|0)==14?(Csb(k,a),_5b(j,k)|0,(b[k+11>>0]|0)<0):0)O5b(f[k>>2]|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;do if(!d){if((f[y>>2]|0)==11?b[(f[(f[a+60>>2]|0)+16>>2]|0)+51>>0]|0:0)break;d6b(k,f[136196+(f[a+36>>2]<<2)>>2]|0)|0;l6b(k,32)}while(0);d=l+4|0;A=l+20|0;z=A;D=z+36|0;do{f[z>>2]=0;z=z+4|0}while((z|0)<(D|0));z=l+56|0;b[z>>0]=b[g>>0]|0;b[z+1>>0]=b[g+1>>0]|0;b[z+2>>0]=b[g+2>>0]|0;z=l+60|0;X5b(z,i);if(!(b[g>>0]|0))E=0;else E=Dsb(a,d)|0;b[l>>0]=E&1;Esb(l,e);E=i+11|0;d=b[E>>0]|0;D=d<<24>>24<0;f[m>>2]=D?f[i>>2]|0:i;f[m+4>>2]=D?f[i+4>>2]|0:d&255;d=k+11|0;D=b[d>>0]|0;C=D<<24>>24<0;f[n>>2]=C?f[k>>2]|0:k;f[n+4>>2]=C?f[k+4>>2]|0:D&255;D=j+11|0;C=b[D>>0]|0;F=C<<24>>24<0;f[o>>2]=F?f[j>>2]|0:j;f[o+4>>2]=F?f[j+4>>2]|0:C&255;if((f[y>>2]|0)==10)G=f[a+60>>2]|0;else G=a;C=f[G>>2]|0;G=b[C+11>>0]|0;F=G<<24>>24<0;f[p>>2]=F?f[C>>2]|0:C;f[p+4>>2]=F?f[C+4>>2]|0:G&255;G=rSb(f[a+28>>2]|0,q+8|0)|0;f[q>>2]=G;C=kUb(G)|0;f[q+4>>2]=C;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;iOb(e,455669,m,n,o,p,q,r,s,t,v,w);if(!(b[a+72>>0]|0))H=0;else{Fsb(n,a,1);C=n+11|0;G=b[C>>0]|0;F=G<<24>>24<0;f[m>>2]=F?f[n>>2]|0:n;f[m+4>>2]=F?f[n+4>>2]|0:G&255;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;f[w>>2]=0;f[w+4>>2]=-1;f[x>>2]=0;f[x+4>>2]=-1;iOb(e,455684,m,o,p,q,r,s,t,v,w,x);if((b[C>>0]|0)<0)O5b(f[n>>2]|0);H=1}if(!(b[a+16>>0]|0))I=H;else{if(H)k6b(e,489325)|0;else k6b(e,475696)|0;k6b(e,455699)|0;pSb(m,f[a+20>>2]|0);H=m+11|0;n=b[H>>0]|0;C=n<<24>>24<0;j6b(e,C?f[m>>2]|0:m,C?f[m+4>>2]|0:n&255)|0;if((b[H>>0]|0)<0)O5b(f[m>>2]|0);k6b(e,476054)|0;I=1};f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;if(!(Gsb(c,f[a+68>>2]|0,m)|0)){if(I)B=40}else{k6b(e,I?489325:489095)|0;I=b[m+11>>0]|0;H=I<<24>>24<0;j6b(e,H?f[m>>2]|0:m,H?f[m+4>>2]|0:I&255)|0;B=40}if((B|0)==40)k6b(e,489150)|0;do if((f[y>>2]|0)==10)if(!(b[g+1>>0]|0)){Hsb(f[a+60>>2]|0,c,e,g,0);break}else{k6b(e,455713)|0;break}else k6b(e,455724)|0;while(0);Isb(l,e);if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);if((b[z+11>>0]|0)<0)O5b(f[z>>2]|0);z=l+44|0;m=f[z>>2]|0;if(m|0){e=l+48|0;g=f[e>>2]|0;if((g|0)==(m|0))J=m;else{c=g;while(1){g=c+-12|0;f[e>>2]=g;if((b[g+11>>0]|0)<0){O5b(f[g>>2]|0);K=f[e>>2]|0}else K=g;if((K|0)==(m|0))break;else c=K}J=f[z>>2]|0}O5b(J)}J=l+32|0;if((b[J+11>>0]|0)<0)O5b(f[J>>2]|0);if((b[A+11>>0]|0)<0)O5b(f[A>>2]|0);if((b[d>>0]|0)<0)O5b(f[k>>2]|0);if((b[D>>0]|0)<0)O5b(f[j>>2]|0);if((b[E>>0]|0)>=0){u=h;return}O5b(f[i>>2]|0);u=h;return}function Csb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=f[c+32>>2]|0;switch(d|0){case 11:{dua(a,489392,f[(f[c+60>>2]|0)+4>>2]|0);return}case 14:{dua(a,489392,f[(f[c+64>>2]|0)+4>>2]|0);return}default:{c=f[136076+(d<<2)>>2]|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;d=kUb(c)|0;if(d>>>0>4294967279)V5b(a);if(d>>>0<11){b[a+11>>0]=d;if(!d)e=a;else{g=a;h=9}}else{i=d+16&-16;j=L5b(i)|0;f[a>>2]=j;f[a+8>>2]=i|-2147483648;f[a+4>>2]=d;g=j;h=9}if((h|0)==9){Vac(g|0,c|0,d|0)|0;e=g}b[e+d>>0]=0;return}}}function Dsb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;Ysb(a,d);g=Rsb(f[a+24>>2]|0,d,b)|0;b=f[d>>2]|0;if(!b){u=c;return g|0}d=f[e>>2]|0;if((d|0)!=(b|0))f[e>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);u=c;return g|0}function Esb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;if(!(b[a>>0]|0)){u=d;return}g=a+44|0;h=a+48|0;i=f[g>>2]|0;if((f[h>>2]|0)!=(i|0)){j=e+11|0;k=e+4|0;l=0;m=i;do{Jsb(e,a,m+(l*12|0)|0);i=b[j>>0]|0;n=i<<24>>24<0;j6b(c,n?f[e>>2]|0:e,n?f[k>>2]|0:i&255)|0;if((b[j>>0]|0)<0)O5b(f[e>>2]|0);k6b(c,475789)|0;l=l+1|0;m=f[g>>2]|0}while(l>>>0<(((f[h>>2]|0)-m|0)/12|0)>>>0)}m=a+20|0;h=b[m+11>>0]|0;if(h<<24>>24<0)o=f[a+24>>2]|0;else o=h&255;if(!o){u=d;return}Jsb(e,a,m);m=e+11|0;a=b[m>>0]|0;o=a<<24>>24<0;j6b(c,o?f[e>>2]|0:e,o?f[e+4>>2]|0:a&255)|0;if((b[m>>0]|0)<0)O5b(f[e>>2]|0);u=d;return}function Fsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0;e=u;u=u+112|0;g=e+64|0;h=e+88|0;i=e+48|0;j=e+24|0;k=e+101|0;l=e;m=e+100|0;if(!(b[c+72>>0]|0)){zpb(g,3,450744,1790);xpb(e+102|0,vpb(vpb(g,456039)|0,456075)|0);Apb(g)}g=f[c+32>>2]|0;do switch(f[136e3+(g<<2)>>2]|0){case 1:{vSb(a,f[c+80>>2]|0);u=e;return}case 2:{o=c+80|0;xSb(a,f[o>>2]|0,f[o+4>>2]|0);u=e;return}case 3:{wSb(a,f[c+80>>2]|0);u=e;return}case 4:{o=c+80|0;ySb(a,f[o>>2]|0,f[o+4>>2]|0);u=e;return}case 6:{BSb(a,+n[c+80>>2]);u=e;return}case 5:{zSb(a,+p[c+80>>3]);u=e;return}case 7:{o=(b[c+80>>0]|0)!=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;q=o?4:5;b[a+11>>0]=q;Vac(a|0,(o?490309:490303)|0,q|0)|0;b[a+q>>0]=0;u=e;return}case 9:{if(!d){q=f[c+80>>2]|0;if((g|0)==12){pSb(a,q);u=e;return}else{X5b(a,q);u=e;return}}pSb(i,f[c+80>>2]|0);dua(h,476054,i);eua(a,h,476054);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=e;return}case 8:{X5b(a,f[f[c+80>>2]>>2]|0);u=e;return}case 10:{zpb(j,2,450744,1828);xpb(k,vpb(j,456092)|0);Apb(j);break}default:{}}while(0);zpb(l,3,450744,1831);xpb(m,vpb(l,456128)|0);Apb(l);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;u=e;return}function Gsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+64|0;g=e+24|0;h=e+12|0;i=e;f[h>>2]=0;j=h+4|0;f[j>>2]=0;f[h+8>>2]=0;if(Xsb(a,c,h)|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;c=f[h>>2]|0;a=f[j>>2]|0;if((c|0)==(a|0)){k=i+11|0;l=i;m=0;n=0;o=0}else{p=g+4|0;q=c;do{if((q|0)!=(c|0))k6b(i,489325)|0;r=b[q+11>>0]|0;s=r<<24>>24<0;f[g>>2]=s?f[q>>2]|0:q;f[p>>2]=s?f[q+4>>2]|0:r&255;ISb(i,g);q=q+12|0}while((q|0)!=(a|0));a=i+11|0;k=a;l=i;m=b[a>>0]|0;n=f[i>>2]|0;o=f[i+4>>2]|0}a=m<<24>>24<0;j6b(d,a?n:i,a?o:m&255)|0;if((b[k>>0]|0)<0)O5b(f[l>>2]|0)}l=f[h>>2]|0;k=f[j>>2]|0;m=(l|0)!=(k|0);if(!l){u=e;return m|0}if((k|0)==(l|0))t=l;else{o=k;while(1){k=o+-12|0;f[j>>2]=k;if((b[k+11>>0]|0)<0){O5b(f[k>>2]|0);v=f[j>>2]|0}else v=k;if((v|0)==(l|0))break;else o=v}t=f[h>>2]|0}O5b(t);u=e;return m|0}function Hsb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;h=u;u=u+576|0;i=h+552|0;j=h+480|0;k=h+440|0;l=h+400|0;m=h+360|0;n=h+320|0;o=h+280|0;p=h+240|0;q=h+200|0;r=h+160|0;s=h+120|0;t=h+80|0;v=h+40|0;w=h;x=a+16|0;if(b[(f[x>>2]|0)+51>>0]|0){u=h;return}y=c<<1;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(y>>>0>4294967279)V5b(i);if(y>>>0<11){b[i+11>>0]=y;if(!c)z=i;else{A=i;B=7}}else{C=y+16&-16;D=L5b(C)|0;f[i>>2]=D;f[i+8>>2]=C|-2147483648;f[i+4>>2]=y;A=D;B=7}if((B|0)==7){Nac(A|0,32,y|0)|0;z=A}b[z+y>>0]=0;y=c+1|0;z=j+4|0;A=j+20|0;D=A;C=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(C|0));D=j+56|0;b[D>>0]=b[e>>0]|0;b[D+1>>0]=b[e+1>>0]|0;b[D+2>>0]=b[e+2>>0]|0;D=j+60|0;X5b(D,i);if(!(b[e>>0]|0))E=0;else E=Ksb(a,z)|0;b[j>>0]=E&1;Esb(j,d);if(g){g=b[i+11>>0]|0;E=g<<24>>24<0;f[k>>2]=E?f[i>>2]|0:i;f[k+4>>2]=E?f[i+4>>2]|0:g&255;g=f[a>>2]|0;E=b[g+11>>0]|0;z=E<<24>>24<0;f[l>>2]=z?f[g>>2]|0:g;f[l+4>>2]=z?f[g+4>>2]|0:E&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;iOb(d,455736,k,l,m,n,o,p,q,r,s,t)}k6b(d,475692)|0;Lsb(y,f[x>>2]|0,d)|0;x=k+4|0;f[x>>2]=0;E=k+8|0;f[E>>2]=0;g=k+4|0;f[k>>2]=g;z=a+24|0;C=f[z>>2]|0;if((C|0)>0){F=a+28|0;G=0;H=C;while(1){C=f[F>>2]|0;if((f[C+(G*88|0)+32>>2]|0)==10){I=f[C+(G*88|0)+60>>2]|0;C=I;J=f[g>>2]|0;do if(J){K=x;L=J;while(1){M=f[L+16>>2]|0;if(I>>>0<M>>>0){N=f[L>>2]|0;if(!N){B=21;break}else{O=L;P=N}}else{if(M>>>0>=I>>>0){B=25;break}Q=L+4|0;M=f[Q>>2]|0;if(!M){B=24;break}else{O=Q;P=M}}K=O;L=P}if((B|0)==21){B=0;R=L;S=L;break}else if((B|0)==24){B=0;R=Q;S=L;break}else if((B|0)==25){B=0;R=K;S=L;break}}else{R=g;S=g}while(0);if(!(f[R>>2]|0)){I=L5b(20)|0;f[I+16>>2]=C;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=S;f[R>>2]=I;J=f[f[k>>2]>>2]|0;if(!J)T=I;else{f[k>>2]=J;T=f[R>>2]|0}mP(f[x>>2]|0,T);f[E>>2]=(f[E>>2]|0)+1;U=f[z>>2]|0}else U=H}else U=H;G=G+1|0;if((G|0)>=(U|0))break;else H=U}}U=a+64|0;H=f[U>>2]|0;if((H|0)>0){G=a+68|0;T=0;R=H;while(1){H=f[G>>2]|0;if((f[H+(T*88|0)+32>>2]|0)==10){S=f[H+(T*88|0)+60>>2]|0;H=S;Q=f[g>>2]|0;do if(Q){P=x;O=Q;while(1){F=f[O+16>>2]|0;if(S>>>0<F>>>0){J=f[O>>2]|0;if(!J){B=38;break}else{V=O;W=J}}else{if(F>>>0>=S>>>0){B=42;break}X=O+4|0;F=f[X>>2]|0;if(!F){B=41;break}else{V=X;W=F}}P=V;O=W}if((B|0)==38){B=0;Y=O;Z=O;break}else if((B|0)==41){B=0;Y=X;Z=O;break}else if((B|0)==42){B=0;Y=P;Z=O;break}}else{Y=g;Z=g}while(0);if(!(f[Y>>2]|0)){S=L5b(20)|0;f[S+16>>2]=H;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=Z;f[Y>>2]=S;Q=f[f[k>>2]>>2]|0;if(!Q)_=S;else{f[k>>2]=Q;_=f[Y>>2]|0}mP(f[x>>2]|0,_);f[E>>2]=(f[E>>2]|0)+1;$=f[U>>2]|0}else $=R}else $=R;T=T+1|0;if((T|0)>=($|0))break;else R=$}}$=a+40|0;R=f[$>>2]|0;if((R|0)>0){T=a+44|0;E=0;_=R;while(1){R=(f[T>>2]|0)+(E*88|0)|0;x=f[g>>2]|0;a:do if(!x)B=56;else{Y=x;while(1){Z=f[Y+16>>2]|0;if(R>>>0<Z>>>0)aa=Y;else{if(Z>>>0>=R>>>0){ba=_;break a}aa=Y+4|0}Y=f[aa>>2]|0;if(!Y){B=56;break}}}while(0);if((B|0)==56){B=0;Hsb(R,y,d,e,1);ba=f[$>>2]|0}E=E+1|0;if((E|0)>=(ba|0))break;else _=ba}}ba=a+48|0;if((f[ba>>2]|0)>0){_=a+52|0;E=0;do{Msb((f[_>>2]|0)+(E<<5)|0,y,d,e);E=E+1|0}while((E|0)<(f[ba>>2]|0))}if((f[z>>2]|0)>0){ba=a+28|0;E=0;do{_=f[ba>>2]|0;$=_+(E*88|0)|0;B=f[_+(E*88|0)+52>>2]|0;if(B){if((f[f[B+20>>2]>>2]|0)==($|0))Nsb(B,y,d,e)}else Bsb($,y,0,d,e);E=E+1|0}while((E|0)<(f[z>>2]|0))}z=a+56|0;if((f[z>>2]|0)>0){E=i+11|0;y=l+4|0;ba=i+4|0;$=a+60|0;B=m+8|0;_=m+4|0;aa=n+8|0;T=n+4|0;x=o+4|0;H=p+4|0;Y=q+4|0;O=r+4|0;P=s+4|0;Z=t+4|0;X=v+4|0;W=0;do{V=b[E>>0]|0;G=V<<24>>24<0;f[l>>2]=G?f[i>>2]|0:i;f[y>>2]=G?f[ba>>2]|0:V&255;V=rSb(f[(f[$>>2]|0)+(W<<3)>>2]|0,B)|0;f[m>>2]=V;G=kUb(V)|0;f[_>>2]=G;G=rSb((f[(f[$>>2]|0)+(W<<3)+4>>2]|0)+-1|0,aa)|0;f[n>>2]=G;V=kUb(G)|0;f[T>>2]=V;f[o>>2]=0;f[x>>2]=-1;f[p>>2]=0;f[H>>2]=-1;f[q>>2]=0;f[Y>>2]=-1;f[r>>2]=0;f[O>>2]=-1;f[s>>2]=0;f[P>>2]=-1;f[t>>2]=0;f[Z>>2]=-1;f[v>>2]=0;f[X>>2]=-1;iOb(d,455749,l,m,n,o,p,q,r,s,t,v);W=W+1|0}while((W|0)<(f[z>>2]|0))}if((f[U>>2]|0)>0){z=a+68|0;W=c+2|0;c=i+11|0;X=l+4|0;Z=i+4|0;P=m+4|0;O=n+4|0;Y=o+4|0;H=p+4|0;x=q+4|0;T=r+4|0;aa=s+4|0;$=t+4|0;_=v+4|0;B=l+4|0;ba=m+4|0;y=n+4|0;E=o+4|0;V=p+4|0;G=q+4|0;Q=r+4|0;S=s+4|0;C=t+4|0;L=v+4|0;K=0;F=0;while(1){J=f[z>>2]|0;I=f[J+(K*88|0)+48>>2]|0;if((I|0)==(F|0)){ca=F;da=J}else{if((K|0)>0){J=b[c>>0]|0;M=J<<24>>24<0;f[l>>2]=M?f[i>>2]|0:i;f[X>>2]=M?f[Z>>2]|0:J&255;f[m>>2]=0;f[P>>2]=-1;f[n>>2]=0;f[O>>2]=-1;f[o>>2]=0;f[Y>>2]=-1;f[p>>2]=0;f[H>>2]=-1;f[q>>2]=0;f[x>>2]=-1;f[r>>2]=0;f[T>>2]=-1;f[s>>2]=0;f[aa>>2]=-1;f[t>>2]=0;f[$>>2]=-1;f[v>>2]=0;f[_>>2]=-1;iOb(d,455775,l,m,n,o,p,q,r,s,t,v);ea=f[(f[z>>2]|0)+(K*88|0)+48>>2]|0}else ea=I;I=b[c>>0]|0;J=I<<24>>24<0;f[l>>2]=J?f[i>>2]|0:i;f[B>>2]=J?f[Z>>2]|0:I&255;I=f[ea+4>>2]|0;J=b[I+11>>0]|0;M=J<<24>>24<0;f[m>>2]=M?f[I>>2]|0:I;f[ba>>2]=M?f[I+4>>2]|0:J&255;f[n>>2]=0;f[y>>2]=-1;f[o>>2]=0;f[E>>2]=-1;f[p>>2]=0;f[V>>2]=-1;f[q>>2]=0;f[G>>2]=-1;f[r>>2]=0;f[Q>>2]=-1;f[s>>2]=0;f[S>>2]=-1;f[t>>2]=0;f[C>>2]=-1;f[v>>2]=0;f[L>>2]=-1;iOb(d,455782,l,m,n,o,p,q,r,s,t,v);ca=ea;da=f[z>>2]|0}Bsb(da+(K*88|0)|0,W,0,d,e);K=K+1|0;fa=f[U>>2]|0;if((K|0)>=(fa|0))break;else F=ca}if((fa|0)>0){fa=b[i+11>>0]|0;ca=fa<<24>>24<0;f[l>>2]=ca?f[i>>2]|0:i;f[l+4>>2]=ca?f[i+4>>2]|0:fa&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;iOb(d,455775,l,m,n,o,p,q,r,s,t,v)}}fa=a+72|0;if((f[fa>>2]|0)>0){ca=b[i+11>>0]|0;F=ca<<24>>24<0;f[l>>2]=F?f[i>>2]|0:i;f[l+4>>2]=F?f[i+4>>2]|0:ca&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;iOb(d,455800,l,m,n,o,p,q,r,s,t,v);if((f[fa>>2]|0)>0){ca=a+76|0;F=l+8|0;K=l+4|0;U=m+4|0;e=n+4|0;W=o+4|0;da=p+4|0;z=q+4|0;ea=r+4|0;L=s+4|0;C=t+4|0;S=v+4|0;Q=l+8|0;G=l+4|0;V=m+8|0;E=m+4|0;y=n+4|0;ba=o+4|0;Z=p+4|0;B=q+4|0;c=r+4|0;_=s+4|0;$=t+4|0;aa=v+4|0;T=0;do{x=f[ca>>2]|0;H=x+(T<<3)+4|0;Y=f[x+(T<<3)>>2]|0;if((f[H>>2]|0)==(Y+1|0)){x=rSb(Y,F)|0;f[l>>2]=x;O=kUb(x)|0;f[K>>2]=O;f[m>>2]=0;f[U>>2]=-1;f[n>>2]=0;f[e>>2]=-1;f[o>>2]=0;f[W>>2]=-1;f[p>>2]=0;f[da>>2]=-1;f[q>>2]=0;f[z>>2]=-1;f[r>>2]=0;f[ea>>2]=-1;f[s>>2]=0;f[L>>2]=-1;f[t>>2]=0;f[C>>2]=-1;f[v>>2]=0;f[S>>2]=-1;iOb(d,455814,l,m,n,o,p,q,r,s,t,v)}else{O=rSb(Y,Q)|0;f[l>>2]=O;Y=kUb(O)|0;f[G>>2]=Y;Y=rSb((f[H>>2]|0)+-1|0,V)|0;f[m>>2]=Y;H=kUb(Y)|0;f[E>>2]=H;f[n>>2]=0;f[y>>2]=-1;f[o>>2]=0;f[ba>>2]=-1;f[p>>2]=0;f[Z>>2]=-1;f[q>>2]=0;f[B>>2]=-1;f[r>>2]=0;f[c>>2]=-1;f[s>>2]=0;f[_>>2]=-1;f[t>>2]=0;f[$>>2]=-1;f[v>>2]=0;f[aa>>2]=-1;iOb(d,455819,l,m,n,o,p,q,r,s,t,v)}T=T+1|0}while((T|0)<(f[fa>>2]|0))}fa=b[d+11>>0]|0;if(fa<<24>>24<0)ga=f[d+4>>2]|0;else ga=fa&255;q6b(d,ga+-2|0,2,455724)|0}ga=a+80|0;if((f[ga>>2]|0)>0){fa=i+11|0;T=b[fa>>0]|0;aa=T<<24>>24<0;f[l>>2]=aa?f[i>>2]|0:i;$=i+4|0;f[l+4>>2]=aa?f[$>>2]|0:T&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;iOb(d,455800,l,m,n,o,p,q,r,s,t,v);if((f[ga>>2]|0)>0){T=a+84|0;a=m+11|0;aa=l+4|0;_=m+4|0;c=n+4|0;B=o+4|0;Z=p+4|0;ba=q+4|0;y=r+4|0;E=s+4|0;V=t+4|0;G=v+4|0;Q=w+4|0;S=0;do{pSb(m,f[(f[T>>2]|0)+(S<<2)>>2]|0);C=b[a>>0]|0;L=C<<24>>24<0;f[l>>2]=L?f[m>>2]|0:m;f[aa>>2]=L?f[_>>2]|0:C&255;f[n>>2]=0;f[c>>2]=-1;f[o>>2]=0;f[B>>2]=-1;f[p>>2]=0;f[Z>>2]=-1;f[q>>2]=0;f[ba>>2]=-1;f[r>>2]=0;f[y>>2]=-1;f[s>>2]=0;f[E>>2]=-1;f[t>>2]=0;f[V>>2]=-1;f[v>>2]=0;f[G>>2]=-1;f[w>>2]=0;f[Q>>2]=-1;iOb(d,455830,l,n,o,p,q,r,s,t,v,w);if((b[a>>0]|0)<0)O5b(f[m>>2]|0);S=S+1|0}while((S|0)<(f[ga>>2]|0))}ga=b[d+11>>0]|0;if(ga<<24>>24<0)ha=f[d+4>>2]|0;else ha=ga&255;q6b(d,ha+-2|0,2,455724)|0;ia=fa;ja=i;ka=$}else{ia=i+11|0;ja=i;ka=i+4|0}$=b[ia>>0]|0;fa=$<<24>>24<0;f[l>>2]=fa?f[ja>>2]|0:i;f[l+4>>2]=fa?f[ka>>2]|0:$&255;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;f[v>>2]=0;f[v+4>>2]=-1;iOb(d,455837,l,m,n,o,p,q,r,s,t,v);Isb(j,d);Osb(k,f[g>>2]|0);if((b[D+11>>0]|0)<0)O5b(f[D>>2]|0);D=j+44|0;g=f[D>>2]|0;if(g|0){k=j+48|0;d=f[k>>2]|0;if((d|0)==(g|0))la=g;else{v=d;while(1){d=v+-12|0;f[k>>2]=d;if((b[d+11>>0]|0)<0){O5b(f[d>>2]|0);ma=f[k>>2]|0}else ma=d;if((ma|0)==(g|0))break;else v=ma}la=f[D>>2]|0}O5b(la)}la=j+32|0;if((b[la+11>>0]|0)<0)O5b(f[la>>2]|0);if((b[A+11>>0]|0)<0)O5b(f[A>>2]|0);if((b[ia>>0]|0)<0)O5b(f[ja>>2]|0);u=h;return}function Isb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;if(!(b[a>>0]|0)){u=d;return}g=a+32|0;h=b[g+11>>0]|0;if(h<<24>>24<0)i=f[a+36>>2]|0;else i=h&255;if(!i){u=d;return}Jsb(e,a,g);g=e+11|0;a=b[g>>0]|0;i=a<<24>>24<0;j6b(c,i?f[e>>2]|0:e,i?f[e+4>>2]|0:a&255)|0;if((b[g>>0]|0)<0)O5b(f[e>>2]|0);u=d;return}function Jsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=u;u=u+432|0;g=e+412|0;h=e+400|0;i=e+360|0;j=e+320|0;k=e+280|0;l=e+240|0;m=e+200|0;n=e+160|0;o=e+120|0;p=e+80|0;q=e+40|0;r=e;X5b(g,d);kSb(g);f[h>>2]=0;d=h+4|0;f[d>>2]=0;f[h+8>>2]=0;lSb(g,475789,h);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;s=f[d>>2]|0;t=f[h>>2]|0;v=t;if((s|0)==(t|0)){w=s;x=v}else{s=c+60|0;t=s+11|0;y=i+4|0;z=c+64|0;c=j+4|0;A=k+4|0;B=l+4|0;C=m+4|0;D=n+4|0;E=o+4|0;F=p+4|0;G=q+4|0;H=r+4|0;I=0;J=v;while(1){v=J+(I*12|0)|0;K=b[t>>0]|0;L=K<<24>>24<0;f[i>>2]=L?f[s>>2]|0:s;f[y>>2]=L?f[z>>2]|0:K&255;K=b[v+11>>0]|0;L=K<<24>>24<0;f[j>>2]=L?f[v>>2]|0:v;f[c>>2]=L?f[J+(I*12|0)+4>>2]|0:K&255;f[k>>2]=0;f[A>>2]=-1;f[l>>2]=0;f[B>>2]=-1;f[m>>2]=0;f[C>>2]=-1;f[n>>2]=0;f[D>>2]=-1;f[o>>2]=0;f[E>>2]=-1;f[p>>2]=0;f[F>>2]=-1;f[q>>2]=0;f[G>>2]=-1;f[r>>2]=0;f[H>>2]=-1;iOb(a,455727,i,j,k,l,m,n,o,p,q,r);I=I+1|0;K=f[d>>2]|0;L=f[h>>2]|0;v=L;if(I>>>0>=((K-L|0)/12|0)>>>0){w=K;x=v;break}else J=v}}J=w;if(x|0){if((J|0)==(x|0))M=x;else{w=J;while(1){J=w+-12|0;f[d>>2]=J;if((b[J+11>>0]|0)<0){O5b(f[J>>2]|0);N=f[d>>2]|0}else N=J;if((N|0)==(x|0))break;else w=N}M=f[h>>2]|0}O5b(M)}if((b[g+11>>0]|0)>=0){u=e;return}O5b(f[g>>2]|0);u=e;return}function Ksb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;Qsb(a,d);g=Rsb(f[a+8>>2]|0,d,b)|0;b=f[d>>2]|0;if(!b){u=c;return g|0}d=f[e>>2]|0;if((d|0)!=(b|0))f[e>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);u=c;return g|0}function Lsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;e=u;u=u+432|0;g=e+412|0;h=e+400|0;i=e+360|0;j=e+320|0;k=e+280|0;l=e+240|0;m=e+200|0;n=e+160|0;o=e+120|0;p=e+80|0;q=e+40|0;r=e;s=a<<1;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(s>>>0>4294967279)V5b(g);if(s>>>0<11){b[g+11>>0]=s;if(!a)t=g;else{v=g;w=6}}else{x=s+16&-16;y=L5b(x)|0;f[g>>2]=y;f[g+8>>2]=x|-2147483648;f[g+4>>2]=s;v=y;w=6}if((w|0)==6){Nac(v|0,32,s|0)|0;t=v}b[t+s>>0]=0;f[h>>2]=0;s=h+4|0;f[s>>2]=0;f[h+8>>2]=0;if(Xsb(a,c,h)|0){c=f[s>>2]|0;a=f[h>>2]|0;t=a;if((c|0)==(a|0)){z=t;A=c}else{c=g+11|0;a=i+4|0;v=g+4|0;w=j+4|0;y=k+4|0;x=l+4|0;B=m+4|0;C=n+4|0;D=o+4|0;E=p+4|0;F=q+4|0;G=r+4|0;H=0;I=t;do{t=b[c>>0]|0;J=t<<24>>24<0;f[i>>2]=J?f[g>>2]|0:g;f[a>>2]=J?f[v>>2]|0:t&255;t=I+(H*12|0)|0;J=b[t+11>>0]|0;K=J<<24>>24<0;f[j>>2]=K?f[t>>2]|0:t;f[w>>2]=K?f[I+(H*12|0)+4>>2]|0:J&255;f[k>>2]=0;f[y>>2]=-1;f[l>>2]=0;f[x>>2]=-1;f[m>>2]=0;f[B>>2]=-1;f[n>>2]=0;f[C>>2]=-1;f[o>>2]=0;f[D>>2]=-1;f[p>>2]=0;f[E>>2]=-1;f[q>>2]=0;f[F>>2]=-1;f[r>>2]=0;f[G>>2]=-1;iOb(d,456019,i,j,k,l,m,n,o,p,q,r);H=H+1|0;L=f[s>>2]|0;J=f[h>>2]|0;I=J}while(H>>>0<((L-J|0)/12|0)>>>0);z=I;A=L}}else{z=f[h>>2]|0;A=f[s>>2]|0}if(z|0){if((A|0)==(z|0))M=z;else{L=A;while(1){I=L+-12|0;f[s>>2]=I;if((b[I+11>>0]|0)<0){O5b(f[I>>2]|0);N=f[s>>2]|0}else N=I;if((N|0)==(z|0))break;else L=N}M=f[h>>2]|0}O5b(M)}M=(z|0)!=(A|0);if((b[g+11>>0]|0)>=0){u=e;return M|0}O5b(f[g>>2]|0);u=e;return M|0}function Msb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=u;u=u+496|0;h=g+472|0;i=g+400|0;j=g+360|0;k=g+320|0;l=g+280|0;m=g+240|0;n=g+200|0;o=g+160|0;p=g+120|0;q=g+80|0;r=g+40|0;s=g;t=c<<1;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(t>>>0>4294967279)V5b(h);if(t>>>0<11){b[h+11>>0]=t;if(!c)v=h;else{w=h;x=6}}else{y=t+16&-16;z=L5b(y)|0;f[h>>2]=z;f[h+8>>2]=y|-2147483648;f[h+4>>2]=t;w=z;x=6}if((x|0)==6){Nac(w|0,32,t|0)|0;v=w}b[v+t>>0]=0;t=c+1|0;c=i+4|0;v=i+20|0;w=v;x=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(x|0));w=i+56|0;b[w>>0]=b[e>>0]|0;b[w+1>>0]=b[e+1>>0]|0;b[w+2>>0]=b[e+2>>0]|0;w=i+60|0;X5b(w,h);if(!(b[e>>0]|0))A=0;else A=Tsb(a,c)|0;b[i>>0]=A&1;Esb(i,d);A=h+11|0;c=b[A>>0]|0;x=c<<24>>24<0;f[j>>2]=x?f[h>>2]|0:h;z=h+4|0;f[j+4>>2]=x?f[z>>2]|0:c&255;c=f[a>>2]|0;x=b[c+11>>0]|0;y=x<<24>>24<0;f[k>>2]=y?f[c>>2]|0:c;f[k+4>>2]=y?f[c+4>>2]|0:x&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;iOb(d,455990,j,k,l,m,n,o,p,q,r,s);Lsb(t,f[a+16>>2]|0,d)|0;x=a+24|0;if((f[x>>2]|0)>0){c=a+28|0;a=0;do{Usb((f[c>>2]|0)+(a*20|0)|0,t,d,e);a=a+1|0}while((a|0)<(f[x>>2]|0))}x=b[A>>0]|0;a=x<<24>>24<0;f[j>>2]=a?f[h>>2]|0:h;f[j+4>>2]=a?f[z>>2]|0:x&255;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;iOb(d,455837,j,k,l,m,n,o,p,q,r,s);Isb(i,d);if((b[w+11>>0]|0)<0)O5b(f[w>>2]|0);w=i+44|0;d=f[w>>2]|0;if(d|0){s=i+48|0;r=f[s>>2]|0;if((r|0)==(d|0))B=d;else{q=r;while(1){r=q+-12|0;f[s>>2]=r;if((b[r+11>>0]|0)<0){O5b(f[r>>2]|0);C=f[s>>2]|0}else C=r;if((C|0)==(d|0))break;else q=C}B=f[w>>2]|0}O5b(B)}B=i+32|0;if((b[B+11>>0]|0)<0)O5b(f[B>>2]|0);if((b[v+11>>0]|0)<0)O5b(f[v>>2]|0);if((b[A>>0]|0)>=0){u=g;return}O5b(f[h>>2]|0);u=g;return}function Nsb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=u;u=u+496|0;h=g+472|0;i=g+400|0;j=g+360|0;k=g+320|0;l=g+280|0;m=g+240|0;n=g+200|0;o=g+160|0;p=g+120|0;q=g+80|0;r=g+40|0;s=g;t=c<<1;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(t>>>0>4294967279)V5b(h);if(t>>>0<11){b[h+11>>0]=t;if(!c)v=h;else{w=h;x=6}}else{y=t+16&-16;z=L5b(y)|0;f[h>>2]=z;f[h+8>>2]=y|-2147483648;f[h+4>>2]=t;w=z;x=6}if((x|0)==6){Nac(w|0,32,t|0)|0;v=w}b[v+t>>0]=0;t=c+1|0;c=i+4|0;v=i+20|0;w=v;x=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(x|0));w=i+56|0;b[w>>0]=b[e>>0]|0;b[w+1>>0]=b[e+1>>0]|0;b[w+2>>0]=b[e+2>>0]|0;w=i+60|0;X5b(w,h);if(!(b[e>>0]|0))A=0;else A=Psb(a,c)|0;b[i>>0]=A&1;Esb(i,d);A=h+11|0;c=b[A>>0]|0;x=c<<24>>24<0;f[j>>2]=x?f[h>>2]|0:h;z=h+4|0;f[j+4>>2]=x?f[z>>2]|0:c&255;c=f[a>>2]|0;x=b[c+11>>0]|0;y=x<<24>>24<0;f[k>>2]=y?f[c>>2]|0:c;f[k+4>>2]=y?f[c+4>>2]|0:x&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;iOb(d,455842,j,k,l,m,n,o,p,q,r,s);Lsb(t,f[a+24>>2]|0,d)|0;if(!(b[e+2>>0]|0)){x=a+16|0;if((f[x>>2]|0)>0){c=a+20|0;a=0;do{Bsb(f[(f[c>>2]|0)+(a<<2)>>2]|0,t,1,d,e);a=a+1|0}while((a|0)<(f[x>>2]|0))}x=b[A>>0]|0;a=x<<24>>24<0;f[j>>2]=a?f[h>>2]|0:h;f[j+4>>2]=a?f[z>>2]|0:x&255;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;iOb(d,455837,j,k,l,m,n,o,p,q,r,s)}else k6b(d,455856)|0;Isb(i,d);if((b[w+11>>0]|0)<0)O5b(f[w>>2]|0);w=i+44|0;d=f[w>>2]|0;if(d|0){s=i+48|0;r=f[s>>2]|0;if((r|0)==(d|0))B=d;else{q=r;while(1){r=q+-12|0;f[s>>2]=r;if((b[r+11>>0]|0)<0){O5b(f[r>>2]|0);C=f[s>>2]|0}else C=r;if((C|0)==(d|0))break;else q=C}B=f[w>>2]|0}O5b(B)}B=i+32|0;if((b[B+11>>0]|0)<0)O5b(f[B>>2]|0);if((b[v+11>>0]|0)<0)O5b(f[v>>2]|0);if((b[A>>0]|0)>=0){u=g;return}O5b(f[h>>2]|0);u=g;return}function Osb(a,b){a=a|0;b=b|0;if(!b)return;else{Osb(a,f[b>>2]|0);Osb(a,f[b+4>>2]|0);O5b(b);return}}function Psb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c+12|0;e=c;f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;h=a+8|0;Qsb(f[h>>2]|0,e);i=f[g>>2]|0;j=e+8|0;k=f[j>>2]|0;if((i|0)==(k|0)){IO(e,139476);l=f[g>>2]|0;m=f[j>>2]|0}else{f[i>>2]=f[34869];j=i+4|0;f[g>>2]=j;l=j;m=k}k=f[h>>2]|0;j=(a-(f[k+36>>2]|0)|0)/28|0;f[d>>2]=j;if((l|0)==(m|0)){IO(e,d);n=f[h>>2]|0}else{f[l>>2]=j;f[g>>2]=l+4;n=k}k=Rsb(f[n+8>>2]|0,e,b)|0;b=f[e>>2]|0;if(!b){u=c;return k|0}e=f[g>>2]|0;if((e|0)!=(b|0))f[g>>2]=e+(~((e+-4-b|0)>>>2)<<2);O5b(b);u=c;return k|0}function Qsb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+16|0;d=c;e=a+12|0;g=f[e>>2]|0;if(!g){h=b+4|0;i=f[h>>2]|0;j=b+8|0;if((i|0)==(f[j>>2]|0)){IO(b,139448);k=f[e>>2]|0;l=a;if(!k){m=l;n=d;o=15}else{p=k+44|0;q=l;r=d}}else{f[i>>2]=f[34862];f[h>>2]=i+4;m=a;n=d;o=15}if((o|0)==15){p=(f[a+8>>2]|0)+40|0;q=m;r=n}n=(q-(f[p>>2]|0)|0)/88|0;f[d>>2]=n;p=f[h>>2]|0;if((p|0)==(f[j>>2]|0))IO(b,d);else{f[p>>2]=n;f[h>>2]=p+4}u=c;return}Qsb(g,b);g=b+4|0;p=f[g>>2]|0;h=b+8|0;if((p|0)==(f[h>>2]|0))IO(b,139468);else{f[p>>2]=f[34867];f[g>>2]=p+4}p=f[e>>2]|0;if(!p)s=(f[a+8>>2]|0)+40|0;else s=p+44|0;p=(a-(f[s>>2]|0)|0)/88|0;f[d>>2]=p;s=f[g>>2]|0;if((s|0)==(f[h>>2]|0))IO(b,d);else{f[s>>2]=p;f[g>>2]=s+4}u=c;return}function Rsb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+48|0;e=d+16|0;g=d+8|0;h=d+4|0;i=d;if(!c){zpb(e,3,455864,166);xpb(g,vpb(e,455958)|0);Apb(e)}j=f[a+84>>2]|0;if(!j){k=0;u=d;return k|0}l=Zqb(f[a+80>>2]|0,b,j)|0;if(!l){k=0;u=d;return k|0}j=f[l+32>>2]|0;if((j+-3|0)>>>0>=2){k=0;u=d;return k|0}b=f[l+40>>2]|0;f[c>>2]=f[b+4>>2];f[c+8>>2]=f[b+8>>2];f[c+4>>2]=f[b+4+(((j|0)==3?0:2)<<2)>>2];f[c+12>>2]=f[b+4+(j+-1<<2)>>2];_5b(c+16|0,f[l+64>>2]|0)|0;_5b(c+28|0,f[l+68>>2]|0)|0;j=f[l+60>>2]|0;b=(j|0)==0?0:j+4|0;f[h>>2]=b;f[i>>2]=b+(f[l+52>>2]<<2);f[g>>2]=f[h>>2];f[e>>2]=f[i>>2];Ssb(c+40|0,g,e);k=1;u=d;return k|0}function Ssb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=f[c>>2]|0;c=f[d>>2]|0;d=c-e>>2;g=a+8|0;h=f[g>>2]|0;i=f[a>>2]|0;j=e;k=i;l=c;if(d>>>0<=((h-i|0)/12|0)>>>0){m=a+4|0;n=((f[m>>2]|0)-i|0)/12|0;o=d>>>0>n>>>0;p=o?j+(n<<2)|0:c;c=p;if((j|0)==(c|0))q=k;else{n=k;r=e;while(1){_5b(n,f[r>>2]|0)|0;r=r+4|0;s=n+12|0;if((r|0)==(c|0)){q=s;break}else n=s}}if(o){if((c|0)==(l|0))return;c=p;p=f[m>>2]|0;do{X5b(p,f[c>>2]|0);c=c+4|0;p=(f[m>>2]|0)+12|0;f[m>>2]=p}while((c|0)!=(l|0));return}c=f[m>>2]|0;if((c|0)==(q|0))return;else t=c;while(1){c=t+-12|0;f[m>>2]=c;if((b[c+11>>0]|0)<0){O5b(f[c>>2]|0);u=f[m>>2]|0}else u=c;if((u|0)==(q|0))break;else t=u}return}if(!i)v=h;else{h=a+4|0;u=f[h>>2]|0;if((u|0)==(k|0))w=i;else{i=u;while(1){u=i+-12|0;f[h>>2]=u;if((b[u+11>>0]|0)<0){O5b(f[u>>2]|0);x=f[h>>2]|0}else x=u;if((x|0)==(k|0))break;else i=x}w=f[a>>2]|0}O5b(w);f[g>>2]=0;f[h>>2]=0;f[a>>2]=0;v=0}if(d>>>0>357913941)c4b(a);h=(v|0)/12|0;v=h<<1;w=h>>>0<178956970?(v>>>0<d>>>0?d:v):357913941;if(w>>>0>357913941)c4b(a);v=L5b(w*12|0)|0;d=a+4|0;f[d>>2]=v;f[a>>2]=v;f[g>>2]=v+(w*12|0);if((j|0)==(l|0))return;j=e;e=v;do{X5b(e,f[j>>2]|0);j=j+4|0;e=(f[d>>2]|0)+12|0;f[d>>2]=e}while((j|0)!=(l|0));return}function Tsb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[d>>2]=0;e=d+4|0;f[e>>2]=0;f[d+8>>2]=0;Wsb(a,d);g=Rsb(f[a+8>>2]|0,d,b)|0;b=f[d>>2]|0;if(!b){u=c;return g|0}d=f[e>>2]|0;if((d|0)!=(b|0))f[e>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);u=c;return g|0}function Usb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+528|0;h=g+512|0;i=g+440|0;j=g+400|0;k=g+360|0;l=g+320|0;m=g+280|0;n=g+240|0;o=g+200|0;p=g+160|0;q=g+120|0;r=g+80|0;s=g+40|0;t=g;v=c<<1;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(v>>>0>4294967279)V5b(h);if(v>>>0<11){b[h+11>>0]=v;if(!c)w=h;else{x=h;y=6}}else{z=v+16&-16;A=L5b(z)|0;f[h>>2]=A;f[h+8>>2]=z|-2147483648;f[h+4>>2]=v;x=A;y=6}if((y|0)==6){Nac(x|0,32,v|0)|0;w=x}b[w+v>>0]=0;v=i+4|0;w=i+20|0;x=w;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));x=i+56|0;b[x>>0]=b[e>>0]|0;b[x+1>>0]=b[e+1>>0]|0;b[x+2>>0]=b[e+2>>0]|0;x=i+60|0;X5b(x,h);if(!(b[e>>0]|0))B=0;else B=Vsb(a,v)|0;b[i>>0]=B&1;Esb(i,d);B=h+11|0;v=b[B>>0]|0;e=v<<24>>24<0;f[j>>2]=e?f[h>>2]|0:h;f[j+4>>2]=e?f[h+4>>2]|0:v&255;v=f[a>>2]|0;e=b[v+11>>0]|0;y=e<<24>>24<0;f[k>>2]=y?f[v>>2]|0:v;f[k+4>>2]=y?f[v+4>>2]|0:e&255;e=rSb(f[a+8>>2]|0,l+8|0)|0;f[l>>2]=e;v=kUb(e)|0;f[l+4>>2]=v;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;iOb(d,456003,j,k,l,m,n,o,p,q,r,s);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(Gsb(c,f[a+16>>2]|0,j)|0){a=b[j+11>>0]|0;c=a<<24>>24<0;f[k>>2]=c?f[j>>2]|0:j;f[k+4>>2]=c?f[j+4>>2]|0:a&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;f[r>>2]=0;f[r+4>>2]=-1;f[s>>2]=0;f[s+4>>2]=-1;f[t>>2]=0;f[t+4>>2]=-1;iOb(d,456013,k,l,m,n,o,p,q,r,s,t)}k6b(d,455724)|0;Isb(i,d);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[x+11>>0]|0)<0)O5b(f[x>>2]|0);x=i+44|0;j=f[x>>2]|0;if(j|0){d=i+48|0;t=f[d>>2]|0;if((t|0)==(j|0))C=j;else{s=t;while(1){t=s+-12|0;f[d>>2]=t;if((b[t+11>>0]|0)<0){O5b(f[t>>2]|0);D=f[d>>2]|0}else D=t;if((D|0)==(j|0))break;else s=D}C=f[x>>2]|0}O5b(C)}C=i+32|0;if((b[C+11>>0]|0)<0)O5b(f[C>>2]|0);if((b[w+11>>0]|0)<0)O5b(f[w>>2]|0);if((b[B>>0]|0)>=0){u=g;return}O5b(f[h>>2]|0);u=g;return}function Vsb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c+12|0;e=c;f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;h=a+12|0;Wsb(f[h>>2]|0,e);i=f[g>>2]|0;j=e+8|0;k=f[j>>2]|0;if((i|0)==(k|0)){IO(e,139480);l=f[g>>2]|0;m=f[j>>2]|0}else{f[i>>2]=f[34870];j=i+4|0;f[g>>2]=j;l=j;m=k}k=f[h>>2]|0;j=(a-(f[k+28>>2]|0)|0)/20|0;f[d>>2]=j;if((l|0)==(m|0)){IO(e,d);n=f[h>>2]|0}else{f[l>>2]=j;f[g>>2]=l+4;n=k}k=Rsb(f[n+8>>2]|0,e,b)|0;b=f[e>>2]|0;if(!b){u=c;return k|0}e=f[g>>2]|0;if((e|0)!=(b|0))f[g>>2]=e+(~((e+-4-b|0)>>>2)<<2);O5b(b);u=c;return k|0}function Wsb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=u;u=u+16|0;d=c;e=a+12|0;g=f[e>>2]|0;if(!g){h=b+4|0;i=f[h>>2]|0;j=b+8|0;if((i|0)==(f[j>>2]|0)){IO(b,139452);k=f[e>>2]|0;l=a;if(!k){m=l;n=d;o=15}else{p=k+52|0;q=l;r=d}}else{f[i>>2]=f[34863];f[h>>2]=i+4;m=a;n=d;o=15}if((o|0)==15){p=(f[a+8>>2]|0)+48|0;q=m;r=n}n=q-(f[p>>2]|0)>>5;f[d>>2]=n;p=f[h>>2]|0;if((p|0)==(f[j>>2]|0))IO(b,d);else{f[p>>2]=n;f[h>>2]=p+4}u=c;return}Qsb(g,b);g=b+4|0;p=f[g>>2]|0;h=b+8|0;if((p|0)==(f[h>>2]|0))IO(b,139472);else{f[p>>2]=f[34868];f[g>>2]=p+4}p=f[e>>2]|0;if(!p)s=(f[a+8>>2]|0)+48|0;else s=p+52|0;p=a-(f[s>>2]|0)>>5;f[d>>2]=p;s=f[g>>2]|0;if((s|0)==(f[h>>2]|0))IO(b,d);else{f[s>>2]=p;f[g>>2]=s+4}u=c;return}function Xsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=u;u=u+96|0;g=e+76|0;h=e+64|0;i=e+52|0;j=e;k=e+40|0;l=f[d>>2]|0;m=d+4|0;n=f[m>>2]|0;if((n|0)!=(l|0)){o=n;while(1){n=o+-12|0;f[m>>2]=n;if((b[n+11>>0]|0)<0){O5b(f[n>>2]|0);p=f[m>>2]|0}else p=n;if((p|0)==(l|0))break;else o=p}}p=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;f[g>>2]=0;o=g+4|0;f[o>>2]=0;f[g+8>>2]=0;_h[f[(f[p>>2]|0)+64>>2]&255](p,c,g);l=f[o>>2]|0;n=f[g>>2]|0;q=n;if((l|0)==(n|0)){r=l;s=q}else{l=a+1|0;n=i+11|0;t=i+4|0;v=a<<1;a=d+8|0;w=j+11|0;x=k+11|0;y=i+11|0;z=h+11|0;A=j+11|0;B=k+11|0;C=0;D=q;while(1){q=f[D+(C<<2)>>2]|0;if((f[q+36>>2]|0)==3){E=li[f[(f[p>>2]|0)+24>>2]&511](p,c,q)|0;if((E|0)>0){F=1;G=E;H=14}}else{F=0;G=1;H=14}if((H|0)==14){H=0;E=0;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=f[(f[g>>2]|0)+(C<<2)>>2]|0;if((f[q+32>>2]|1|0)==11){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;APb(j);f[j>>2]=l;BPb(j,c,f[(f[g>>2]|0)+(C<<2)>>2]|0,F?E:-1,i);k6b(h,456033)|0;I=b[n>>0]|0;J=I<<24>>24<0;j6b(h,J?f[i>>2]|0:i,J?f[t>>2]|0:I&255)|0;f6b(h,v,32)|0;k6b(h,476773)|0;zOb(j);if((b[n>>0]|0)<0)O5b(f[i>>2]|0)}else CPb(c,q,F?E:-1,h);f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;q=f[(f[g>>2]|0)+(C<<2)>>2]|0;if(b[q+40>>0]|0){dua(k,456036,f[q+4>>2]|0);eua(j,k,489101);_5b(i,j)|0;if((b[A>>0]|0)<0)O5b(f[j>>2]|0);if((b[B>>0]|0)<0)O5b(f[k>>2]|0)}else _5b(i,f[q>>2]|0)|0;eua(k,i,466137);Ccb(j,k,h);q=f[m>>2]|0;if((q|0)==(f[a>>2]|0))JT(d,j);else{X5b(q,j);f[m>>2]=(f[m>>2]|0)+12}if((b[w>>0]|0)<0)O5b(f[j>>2]|0);if((b[x>>0]|0)<0)O5b(f[k>>2]|0);if((b[y>>0]|0)<0)O5b(f[i>>2]|0);if((b[z>>0]|0)<0)O5b(f[h>>2]|0);E=E+1|0}while((E|0)<(G|0))}C=C+1|0;E=f[o>>2]|0;q=f[g>>2]|0;I=q;if(C>>>0>=E-q>>2>>>0){r=E;s=I;break}else D=I}}D=r;r=(f[d>>2]|0)!=(f[m>>2]|0);if(!s){u=e;return r|0}if((D|0)!=(s|0))f[o>>2]=D+(~((D+-4-s|0)>>>2)<<2);O5b(s);u=e;return r|0}function Ysb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=a+40|0;if(!(b[g>>0]|0)){h=a+48|0;Qsb(f[h>>2]|0,c);i=c+4|0;j=f[i>>2]|0;k=c+8|0;if((j|0)==(f[k>>2]|0))IO(c,139460);else{f[j>>2]=f[34865];f[i>>2]=j+4}j=a;do if(b[g>>0]|0){l=f[a+56>>2]|0;if(!l){m=(f[a+24>>2]|0)+72|0;break}else{m=l+68|0;break}}else m=(f[h>>2]|0)+28|0;while(0);h=(j-(f[m>>2]|0)|0)/88|0;f[e>>2]=h;m=f[i>>2]|0;if((m|0)==(f[k>>2]|0))IO(c,e);else{f[m>>2]=h;f[i>>2]=m+4}u=d;return}m=a+56|0;i=f[m>>2]|0;if(!i){h=c+4|0;k=f[h>>2]|0;j=c+8|0;if((k|0)==(f[j>>2]|0)){IO(c,139456);l=a;if(!(b[g>>0]|0)){n=(f[a+48>>2]|0)+28|0;o=l;p=e}else{q=l;r=e;s=7}}else{f[k>>2]=f[34864];f[h>>2]=k+4;q=a;r=e;s=7}do if((s|0)==7){k=f[m>>2]|0;if(!k){n=(f[a+24>>2]|0)+72|0;o=q;p=r;break}else{n=k+68|0;o=q;p=r;break}}while(0);r=(o-(f[n>>2]|0)|0)/88|0;f[e>>2]=r;n=f[h>>2]|0;if((n|0)==(f[j>>2]|0))IO(c,e);else{f[n>>2]=r;f[h>>2]=n+4}u=d;return}Qsb(i,c);i=c+4|0;n=f[i>>2]|0;h=c+8|0;if((n|0)==(f[h>>2]|0))IO(c,139464);else{f[n>>2]=f[34866];f[i>>2]=n+4}n=a;do if(b[g>>0]|0){r=f[m>>2]|0;if(!r){t=(f[a+24>>2]|0)+72|0;break}else{t=r+68|0;break}}else t=(f[a+48>>2]|0)+28|0;while(0);a=(n-(f[t>>2]|0)|0)/88|0;f[e>>2]=a;t=f[i>>2]|0;if((t|0)==(f[h>>2]|0))IO(c,e);else{f[t>>2]=a;f[i>>2]=t+4}u=d;return}function Zsb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=(b[d+11>>0]|0)<0?f[d>>2]|0:d;d=b[e>>0]|0;if(!(d<<24>>24))g=0;else{h=e;i=0;j=d;while(1){d=(i*5|0)+(j<<24>>24)|0;h=h+1|0;j=b[h>>0]|0;if(!(j<<24>>24)){g=d;break}else i=d}}i=f[c+124>>2]|0;a:do if(i|0){j=i+-1|0;h=(j&i|0)==0;if(!h)if(g>>>0<i>>>0)k=g;else k=(g>>>0)%(i>>>0)|0;else k=j&g;d=f[(f[c+120>>2]|0)+(k<<2)>>2]|0;if(d|0?(l=f[d>>2]|0,l|0):0){b:do if(h){d=l;while(1){m=f[d+4>>2]|0;n=(g|0)==(m|0);if(!(n|(m&j|0)==(k|0)))break a;if(n?(gTb(f[d+8>>2]|0,e)|0)==0:0){o=d;break b}d=f[d>>2]|0;if(!d)break a}}else{d=l;while(1){n=f[d+4>>2]|0;if((g|0)==(n|0)){if(!(gTb(f[d+8>>2]|0,e)|0)){o=d;break b}}else{if(n>>>0<i>>>0)p=n;else p=(n>>>0)%(i>>>0)|0;if((p|0)!=(k|0))break a}d=f[d>>2]|0;if(!d)break a}}while(0);l=o+12|0;j=f[l+4>>2]|0;h=a;f[h>>2]=f[l>>2];f[h+4>>2]=j;return}}while(0);o=a;f[o>>2]=0;f[o+4>>2]=0;return}function _sb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0;d=u;u=u+144|0;e=d+140|0;g=d;h=a+4|0;if(!(f[h>>2]|0)){i=0;u=d;return i|0}j=a+16|0;if(jrb((f[j>>2]|0)+32|0,c)|0){i=0;u=d;return i|0}WDb(g);do if(!($sb(a,c)|0)?(k=f[h>>2]|0,li[f[(f[k>>2]|0)+12>>2]&511](k,c,g)|0):0){k=f[j>>2]|0;l=f[g+120>>2]|0;f[e>>2]=(b[l+11>>0]|0)<0?f[l>>2]|0:l;l=crb(k+140|0,e)|0;if(l)if(f[l+12>>2]|0){m=9;break}if(krb(a,g)|0)o=1;else m=9}else m=9;while(0);a:do if((m|0)==9){a=f[j>>2]|0;e=a+32|0;h=b[c+11>>0]|0;l=h<<24>>24<0;k=l?f[c>>2]|0:c;p=b[k>>0]|0;if(!(p<<24>>24))q=0;else{r=k;s=0;t=p;while(1){v=(s*5|0)+(t<<24>>24)|0;r=r+1|0;t=b[r>>0]|0;if(!(t<<24>>24)){q=v;break}else s=v}}s=a+36|0;t=f[s>>2]|0;r=(t|0)==0;b:do if(!r){v=t+-1|0;w=(v&t|0)==0;if(!w)if(q>>>0<t>>>0)x=q;else x=(q>>>0)%(t>>>0)|0;else x=v&q;y=f[(f[e>>2]|0)+(x<<2)>>2]|0;if((y|0)!=0?(z=f[y>>2]|0,(z|0)!=0):0){y=l?f[c+4>>2]|0:h&255;A=(y|0)==0;if(w){if(A){w=z;while(1){B=f[w+4>>2]|0;if(!((B|0)==(q|0)|(B&v|0)==(x|0))){C=x;break b}B=b[w+8+11>>0]|0;if(!((B<<24>>24<0?f[w+12>>2]|0:B&255)|0)){o=0;break a}w=f[w>>2]|0;if(!w){C=x;break b}}}else D=z;while(1){w=f[D+4>>2]|0;if(!((w|0)==(q|0)|(w&v|0)==(x|0))){C=x;break b}w=D+8|0;B=b[w+11>>0]|0;E=B<<24>>24<0;F=B&255;do if(((E?f[D+12>>2]|0:F)|0)==(y|0)){B=f[w>>2]|0;if(E)if(!(ZVb(B,k,y)|0)){o=0;break a}else break;if((B&255)<<24>>24==p<<24>>24){B=w;G=F;H=k;do{G=G+-1|0;B=B+1|0;if(!G){o=0;break a}H=H+1|0}while((b[B>>0]|0)==(b[H>>0]|0))}}while(0);D=f[D>>2]|0;if(!D){C=x;break b}}}if(A){v=z;while(1){F=f[v+4>>2]|0;if((F|0)!=(q|0)){if(F>>>0<t>>>0)I=F;else I=(F>>>0)%(t>>>0)|0;if((I|0)!=(x|0)){C=x;break b}}F=b[v+8+11>>0]|0;if(!((F<<24>>24<0?f[v+12>>2]|0:F&255)|0)){o=0;break a}v=f[v>>2]|0;if(!v){C=x;break b}}}else J=z;while(1){v=f[J+4>>2]|0;if((v|0)!=(q|0)){if(v>>>0<t>>>0)K=v;else K=(v>>>0)%(t>>>0)|0;if((K|0)!=(x|0)){C=x;break b}}v=J+8|0;A=b[v+11>>0]|0;F=A<<24>>24<0;w=A&255;do if(((F?f[J+12>>2]|0:w)|0)==(y|0)){A=f[v>>2]|0;if(F)if(!(ZVb(A,k,y)|0)){o=0;break a}else break;if((A&255)<<24>>24==p<<24>>24){A=v;E=w;H=k;do{E=E+-1|0;A=A+1|0;if(!E){o=0;break a}H=H+1|0}while((b[A>>0]|0)==(b[H>>0]|0))}}while(0);J=f[J>>2]|0;if(!J){C=x;break}}}else C=x}else C=0;while(0);k=L5b(20)|0;X5b(k+8|0,c);f[k+4>>2]=q;f[k>>2]=0;p=a+44|0;L=+(((f[p>>2]|0)+1|0)>>>0);M=+n[a+48>>2];do if(r|L>+(t>>>0)*M){h=(t>>>0<3|(t+-1&t|0)!=0)&1|t<<1;l=~~+X(+(L/M))>>>0;lrb(e,h>>>0<l>>>0?l:h);h=f[s>>2]|0;l=h+-1|0;if(!(l&h)){N=h;O=l&q;break}if(q>>>0<h>>>0){N=h;O=q}else{N=h;O=(q>>>0)%(h>>>0)|0}}else{N=t;O=C}while(0);t=(f[e>>2]|0)+(O<<2)|0;s=f[t>>2]|0;if(!s){r=a+40|0;f[k>>2]=f[r>>2];f[r>>2]=k;f[t>>2]=r;r=f[k>>2]|0;if(r|0){t=f[r+4>>2]|0;r=N+-1|0;if(r&N)if(t>>>0<N>>>0)P=t;else P=(t>>>0)%(N>>>0)|0;else P=t&r;Q=(f[e>>2]|0)+(P<<2)|0;m=64}}else{f[k>>2]=f[s>>2];Q=s;m=64}if((m|0)==64)f[Q>>2]=k;f[p>>2]=(f[p>>2]|0)+1;o=0}while(0);DDb(g);i=o;u=d;return i|0}function $sb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+32|0;e=d+12|0;g=d;X5b(e,c);h=t6b(e,46,-1)|0;a:do if((h|0)==-1)i=7;else{j=g+11|0;k=a+16|0;l=h;while(1){Y5b(g,e,0,l,e);_5b(e,g)|0;if((b[j>>0]|0)<0)O5b(f[g>>2]|0);Zsb(g,f[k>>2]|0,e);if((f[g>>2]|8|0)!=8){m=1;break a}l=t6b(e,46,-1)|0;if((l|0)==-1){i=7;break}}}while(0);if((i|0)==7){i=f[a+12>>2]|0;if(!i)m=0;else m=$sb(i,c)|0}if((b[e+11>>0]|0)>=0){u=d;return m|0}O5b(f[e>>2]|0);u=d;return m|0}function atb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;e=u;u=u+448|0;g=e+424|0;h=e+412|0;i=e+400|0;j=e+360|0;k=e+320|0;l=e+280|0;m=e+240|0;n=e+200|0;o=e+160|0;p=e+120|0;q=e+80|0;r=e+40|0;s=e;t=c+16|0;if(!(f[t>>2]|0)){v=hEb()|0;f[t>>2]=v}v=c+40|0;if((f[v>>2]|0)>0){t=c+44|0;w=d+60|0;x=0;do{atb(a,(f[t>>2]|0)+(x*88|0)|0,f[(f[w>>2]|0)+4+(x<<2)>>2]|0);x=x+1|0}while((x|0)<(f[v>>2]|0))}v=c+48|0;if((f[v>>2]|0)>0){x=c+52|0;w=0;do{t=f[x>>2]|0;y=t+(w<<5)+16|0;if(!(f[y>>2]|0)){z=nEb()|0;f[y>>2]=z}z=t+(w<<5)+24|0;y=f[z>>2]|0;if((y|0)>0){A=t+(w<<5)+28|0;t=0;B=y;while(1){y=(f[A>>2]|0)+(t*20|0)+16|0;if(!(f[y>>2]|0)){C=pEb()|0;f[y>>2]=C;D=f[z>>2]|0}else D=B;t=t+1|0;if((t|0)>=(D|0))break;else B=D}}w=w+1|0}while((w|0)<(f[v>>2]|0))}v=c+24|0;w=f[v>>2]|0;if((w|0)>0){D=c+28|0;x=d+28|0;B=0;do{btb(a,(f[D>>2]|0)+(B*88|0)|0,f[(f[x>>2]|0)+4+(B<<2)>>2]|0);B=B+1|0;t=f[v>>2]|0}while((B|0)<(t|0));E=t}else E=w;w=c+64|0;if((f[w>>2]|0)>0){B=c+68|0;x=d+44|0;D=0;do{btb(a,(f[B>>2]|0)+(D*88|0)|0,f[(f[x>>2]|0)+4+(D<<2)>>2]|0);D=D+1|0}while((D|0)<(f[w>>2]|0));F=f[v>>2]|0}else F=E;if((F|0)>0){E=c+28|0;w=c+4|0;D=d+28|0;x=j+4|0;B=k+4|0;t=l+4|0;z=m+4|0;A=n+4|0;C=o+4|0;y=p+4|0;G=q+4|0;H=r+4|0;I=s+4|0;J=i+11|0;K=g+11|0;L=h+11|0;M=c+36|0;N=0;O=F;while(1){P=f[E>>2]|0;Q=f[P+(N*88|0)+52>>2]|0;if(!Q)R=O;else{if((f[Q+16>>2]|0)>0?(S=N+-1|0,(f[P+(S*88|0)+52>>2]|0)!=(Q|0)):0){eua(h,f[w>>2]|0,489392);Ccb(g,h,f[(f[E>>2]|0)+(S*88|0)>>2]|0);P=f[(f[D>>2]|0)+4+(S<<2)>>2]|0;T=f[(f[E>>2]|0)+(S*88|0)>>2]|0;S=b[T+11>>0]|0;U=S<<24>>24<0;f[j>>2]=U?f[T>>2]|0:T;f[x>>2]=U?f[T+4>>2]|0:S&255;S=f[Q>>2]|0;T=b[S+11>>0]|0;U=T<<24>>24<0;f[k>>2]=U?f[S>>2]|0:S;f[B>>2]=U?f[S+4>>2]|0:T&255;f[l>>2]=0;f[t>>2]=-1;f[m>>2]=0;f[z>>2]=-1;f[n>>2]=0;f[A>>2]=-1;f[o>>2]=0;f[C>>2]=-1;f[p>>2]=0;f[y>>2]=-1;f[q>>2]=0;f[G>>2]=-1;f[r>>2]=0;f[H>>2]=-1;f[s>>2]=0;f[I>>2]=-1;hOb(i,457326,j,k,l,m,n,o,p,q,r,s);wrb(a,g,P,9,i);if((b[J>>0]|0)<0)O5b(f[i>>2]|0);if((b[K>>0]|0)<0)O5b(f[g>>2]|0);if((b[L>>0]|0)<0)O5b(f[h>>2]|0);V=f[v>>2]|0}else V=O;P=(f[M>>2]|0)+(((Q-(f[(f[Q+8>>2]|0)+36>>2]|0)|0)/28|0)*28|0)+16|0;f[P>>2]=(f[P>>2]|0)+1;R=V}N=N+1|0;if((N|0)>=(R|0)){W=R;break}else O=R}}else W=F;F=c+32|0;if((f[F>>2]|0)>0){R=c+36|0;O=c+4|0;N=d+108|0;d=g+11|0;V=h+11|0;M=a+4|0;L=0;do{K=f[R>>2]|0;i=K+(L*28|0)+16|0;J=f[i>>2]|0;if(!J){eua(h,f[O>>2]|0,489392);Ccb(g,h,f[K+(L*28|0)>>2]|0);vrb(a,g,f[(f[N>>2]|0)+4+(L<<2)>>2]|0,0,457457);if((b[d>>0]|0)<0)O5b(f[g>>2]|0);if((b[V>>0]|0)<0)O5b(f[h>>2]|0);X=f[i>>2]|0}else X=J;J=f[M>>2]|0;s=X<<2;if(!s)Y=0;else{r=L5b(s)|0;f[g>>2]=r;s=J+112|0;q=f[s>>2]|0;if((q|0)==(f[J+116>>2]|0))HO(J+108|0,g);else{f[q>>2]=r;f[s>>2]=(f[s>>2]|0)+4}Y=f[g>>2]|0}f[K+(L*28|0)+20>>2]=Y;f[i>>2]=0;i=K+(L*28|0)+24|0;if(!(f[i>>2]|0)){K=lEb()|0;f[i>>2]=K}L=L+1|0}while((L|0)<(f[F>>2]|0));Z=f[v>>2]|0}else Z=W;if((Z|0)<=0){u=e;return}W=c+28|0;v=c+36|0;c=0;do{F=f[W>>2]|0;L=f[F+(c*88|0)+52>>2]|0;if(L|0){Y=f[v>>2]|0;g=(L-(f[(f[L+8>>2]|0)+36>>2]|0)|0)/28|0;L=Y+(g*28|0)+16|0;X=f[L>>2]|0;f[F+(c*88|0)+44>>2]=X;M=f[Y+(g*28|0)+20>>2]|0;f[L>>2]=X+1;f[M+(X<<2)>>2]=F+(c*88|0)}c=c+1|0}while((c|0)<(Z|0));u=e;return}function btb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=u;u=u+464|0;g=e+40|0;h=e;i=e+416|0;j=e+376|0;k=e+336|0;l=e+296|0;m=e+256|0;n=e+216|0;o=e+176|0;p=e+136|0;q=e+96|0;r=e+56|0;s=c+68|0;if(!(f[s>>2]|0)){t=jEb()|0;f[s>>2]=t}t=d+8|0;a:do if(f[t>>2]&32|0){s=d+24|0;v=c+4|0;isb(g,a,f[s>>2]|0,f[v>>2]|0,2,0);switch(f[g>>2]|0){case 0:{dtb(a,f[v>>2]|0,d,3,f[s>>2]|0);u=e;return}case 1:{w=f[g+4>>2]|0;f[c+48>>2]=w;x=w;w=f[c+28>>2]|0;y=f[x+56>>2]|0;b:do if((y|0)>0){z=f[x+60>>2]|0;A=0;while(1){if((f[z+(A<<3)>>2]|0)<=(w|0)?(f[z+(A<<3)+4>>2]|0)>(w|0):0)break b;A=A+1|0;if((A|0)>=(y|0)){B=16;break}}}else B=16;while(0);if((B|0)==16?(y=f[v>>2]|0,A=f[x+4>>2]|0,z=b[A+11>>0]|0,C=z<<24>>24<0,f[i>>2]=C?f[A>>2]|0:A,f[i+4>>2]=C?f[A+4>>2]|0:z&255,z=rSb(w,j+8|0)|0,f[j>>2]=z,A=kUb(z)|0,f[j+4>>2]=A,f[k>>2]=0,f[k+4>>2]=-1,f[l>>2]=0,f[l+4>>2]=-1,f[m>>2]=0,f[m+4>>2]=-1,f[n>>2]=0,f[n+4>>2]=-1,f[o>>2]=0,f[o+4>>2]=-1,f[p>>2]=0,f[p+4>>2]=-1,f[q>>2]=0,f[q+4>>2]=-1,f[r>>2]=0,f[r+4>>2]=-1,hOb(h,456759,i,j,k,l,m,n,o,p,q,r),wrb(a,y,d,1,h),(b[h+11>>0]|0)<0):0)O5b(f[h>>2]|0);break a;break}default:{y=f[v>>2]|0;dua(i,476054,f[s>>2]|0);eua(h,i,456466);wrb(a,y,d,3,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=e;return}}}while(0);if(f[c+52>>2]|0?(f[c+36>>2]|0)!=1:0)vrb(a,f[c+4>>2]|0,d,0,456808);r=f[t>>2]|0;c:do if(!(r&16)){switch(f[136e3+(f[c+32>>2]<<2)>>2]|0){case 8:case 10:break;default:break c}vrb(a,f[c+4>>2]|0,d,2,457062)}else{y=d+20|0;A=c+4|0;isb(g,a,f[y>>2]|0,f[A>>2]|0,(f[d+52>>2]|0)==14|r>>>6&1,1);z=f[g>>2]|0;do if(!z){if((b[(f[a>>2]|0)+22>>0]|0)==0?(C=f[d+36>>2]|0,b[((C|0)==0?498632:C)+59>>0]|0):0){C=L5b(32)|0;f[i>>2]=C;f[i+8>>2]=-2147483616;f[i+4>>2]=21;D=C;E=456868;F=D+21|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));b[C+21>>0]=0;wsb(h,a,i);E=h;D=f[E>>2]|0;F=f[E+4>>2]|0;E=g;f[E>>2]=D;f[E+4>>2]=F;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if(D|0){G=D;break}}dtb(a,f[A>>2]|0,d,2,f[y>>2]|0);u=e;return}else G=z;while(0);if(!(f[t>>2]&8)){switch(G|0){case 1:{H=11;break}case 4:{H=14;break}default:{z=f[A>>2]|0;dua(i,476054,f[y>>2]|0);eua(h,i,456890);wrb(a,z,d,2,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=e;return}}f[c+32>>2]=H;I=H}else I=f[c+32>>2]|0;d:do switch(f[136e3+(I<<2)>>2]|0){case 10:{if((G|0)==1){f[c+60>>2]=f[g+4>>2];if(!(b[c+72>>0]|0))break d;vrb(a,f[A>>2]|0,d,4,456907);break d}z=f[A>>2]|0;dua(i,476054,f[y>>2]|0);eua(h,i,456466);wrb(a,z,d,2,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=e;return}case 8:{if((G|0)!=4){z=f[A>>2]|0;dua(i,476054,f[y>>2]|0);eua(h,i,456943);wrb(a,z,d,2,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=e;return}z=f[g+4>>2]|0;s=c+64|0;f[s>>2]=z;v=z;z=c+72|0;if(!(b[v+20>>0]|0)){if(b[z>>0]|0){w=d+28|0;if(!(FIb(f[w>>2]|0)|0)){vrb(a,f[A>>2]|0,d,4,456966);break d}vsb(h,a,f[w>>2]|0,f[(f[s>>2]|0)+4>>2]|0,0);if((f[h>>2]|0)==5){x=f[h+4>>2]|0;D=f[s>>2]|0;if((f[x+12>>2]|0)==(D|0))f[c+80>>2]=x;else{J=D;B=65}}else{J=f[s>>2]|0;B=65}if((B|0)==65){s=f[A>>2]|0;dua(l,452861,f[J+4>>2]|0);eua(k,l,455031);Ccb(j,k,f[w>>2]|0);eua(i,j,476219);wrb(a,s,d,4,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0)}break d}}else b[z>>0]=0;if((f[v+24>>2]|0)>0)f[c+80>>2]=f[v+28>>2];break}default:vrb(a,f[A>>2]|0,d,2,457021)}while(0)}while(0);J=a+44|0;do if(Nqb(f[J>>2]|0,c)|0){B=c+40|0;if((b[B>>0]|0)!=0?(G=a+4|0,!(Pqb(f[G>>2]|0,c)|0)):0){I=c+48|0;H=f[I>>2]|0;t=f[c+28>>2]|0;r=(f[G>>2]|0)+164|0;G=f[r>>2]|0;do if(G){A=r;y=G;e:while(1){v=y;while(1){z=f[v+16>>2]|0;if(z>>>0>=H>>>0){if(z>>>0>H>>>0)break;if((f[v+20>>2]|0)>=(t|0))break}z=f[v+4>>2]|0;if(!z){K=A;break e}else v=z}y=f[v>>2]|0;if(!y){K=v;break}else A=v}if((K|0)!=(r|0)?(A=f[K+16>>2]|0,A>>>0<=H>>>0):0){if(A>>>0>=H>>>0?(f[K+20>>2]|0)>(t|0):0){L=0;break}L=f[K+24>>2]|0}else L=0}else L=0;while(0);H=rSb(t,h+8|0)|0;f[h>>2]=H;r=kUb(H)|0;f[h+4>>2]=r;r=f[(f[I>>2]|0)+4>>2]|0;H=b[r+11>>0]|0;G=H<<24>>24<0;f[i>>2]=G?f[r>>2]|0:r;f[i+4>>2]=G?f[r+4>>2]|0:H&255;H=f[L+4>>2]|0;r=b[H+11>>0]|0;G=r<<24>>24<0;f[j>>2]=G?f[H>>2]|0:H;f[j+4>>2]=G?f[H+4>>2]|0:r&255;r=f[f[L+24>>2]>>2]|0;H=b[r+11>>0]|0;G=H<<24>>24<0;f[k>>2]=G?f[r>>2]|0:r;f[k+4>>2]=G?f[r+4>>2]|0:H&255;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;hOb(g,457243,h,i,j,k,l,m,n,o,p,q);Mrb(a,f[c+4>>2]|0,d,1,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);M=B}else M=B}else{H=f[J>>2]|0;r=c+48|0;G=f[r>>2]|0;A=f[c+28>>2]|0;y=(G*65535|0)+A|0;C=f[H+64>>2]|0;f:do if(C){z=C+-1|0;s=(z&C|0)==0;if(!s)if(y>>>0<C>>>0)N=y;else N=(y>>>0)%(C>>>0)|0;else N=z&y;w=f[(f[H+60>>2]|0)+(N<<2)>>2]|0;if((w|0)!=0?(D=f[w>>2]|0,(D|0)!=0):0){g:do if(s){w=D;while(1){x=f[w+4>>2]|0;F=(y|0)==(x|0);if(!(F|(x&z|0)==(N|0))){O=0;break f}if((F?(f[w+8>>2]|0)==(G|0):0)?(f[w+12>>2]|0)==(A|0):0){P=w;break g}w=f[w>>2]|0;if(!w){O=0;break f}}}else{w=D;while(1){v=f[w+4>>2]|0;if((y|0)==(v|0)){if((f[w+8>>2]|0)==(G|0)?(f[w+12>>2]|0)==(A|0):0){P=w;break g}}else{if(v>>>0<C>>>0)Q=v;else Q=(v>>>0)%(C>>>0)|0;if((Q|0)!=(N|0)){O=0;break f}}w=f[w>>2]|0;if(!w){O=0;break f}}}while(0);O=f[P+16>>2]|0}else O=0}else O=0;while(0);C=c+40|0;G=f[c+4>>2]|0;if(!(b[C>>0]|0)){y=rSb(A,h+8|0)|0;f[h>>2]=y;H=kUb(y)|0;f[h+4>>2]=H;H=f[(f[r>>2]|0)+4>>2]|0;y=b[H+11>>0]|0;B=y<<24>>24<0;f[i>>2]=B?f[H>>2]|0:H;f[i+4>>2]=B?f[H+4>>2]|0:y&255;y=f[O>>2]|0;H=b[y+11>>0]|0;B=H<<24>>24<0;f[j>>2]=B?f[y>>2]|0:y;f[j+4>>2]=B?f[y+4>>2]|0:H&255;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;hOb(g,457182,h,i,j,k,l,m,n,o,p,q);wrb(a,G,d,1,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);M=C;break}else{H=rSb(A,h+8|0)|0;f[h>>2]=H;y=kUb(H)|0;f[h+4>>2]=y;y=f[(f[r>>2]|0)+4>>2]|0;H=b[y+11>>0]|0;B=H<<24>>24<0;f[i>>2]=B?f[y>>2]|0:y;f[i+4>>2]=B?f[y+4>>2]|0:H&255;H=f[O+4>>2]|0;y=b[H+11>>0]|0;B=y<<24>>24<0;f[j>>2]=B?f[H>>2]|0:H;f[j+4>>2]=B?f[H+4>>2]|0:y&255;f[k>>2]=0;f[k+4>>2]=-1;f[l>>2]=0;f[l+4>>2]=-1;f[m>>2]=0;f[m+4>>2]=-1;f[n>>2]=0;f[n+4>>2]=-1;f[o>>2]=0;f[o+4>>2]=-1;f[p>>2]=0;f[p+4>>2]=-1;f[q>>2]=0;f[q+4>>2]=-1;hOb(g,457113,h,i,j,k,l,m,n,o,p,q);wrb(a,G,d,1,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);M=C;break}}while(0);d=f[J>>2]|0;f[g>>2]=c;do if(b[M>>0]|0){J=f[c+56>>2]|0;if(!J){R=f[c+24>>2]|0;break}else{R=J;break}}else R=f[c+48>>2]|0;while(0);M=f[c+8>>2]|0;if((b[M+11>>0]|0)<0)S=f[M>>2]|0;else S=M;f[h>>2]=R;f[h+4>>2]=S;Mqb(d+20|0,h,g);h=f[c+12>>2]|0;if((b[h+11>>0]|0)<0)T=f[h>>2]|0;else T=h;f[i>>2]=R;f[i+4>>2]=T;Mqb(d+40|0,i,g);u=e;return}function ctb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+48|0;g=e+40|0;h=e+24|0;i=e+12|0;j=e;k=c+20|0;if(!(f[k>>2]|0)){l=tEb()|0;f[k>>2]=l}l=d+20|0;k=c+4|0;isb(g,a,f[l>>2]|0,f[k>>2]|0,0,0);switch(f[g>>2]|0){case 0:{dtb(a,f[k>>2]|0,d,5,f[l>>2]|0);break}case 1:{f[c+12>>2]=f[g+4>>2];break}default:{g=f[k>>2]|0;dua(i,476054,f[l>>2]|0);eua(h,i,456466);wrb(a,g,d,5,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0)}}g=d+24|0;isb(h,a,f[g>>2]|0,f[k>>2]|0,0,0);switch(f[h>>2]|0){case 0:{dtb(a,f[k>>2]|0,d,6,f[g>>2]|0);u=e;return}case 1:{f[c+16>>2]=f[h+4>>2];u=e;return}default:{h=f[k>>2]|0;dua(j,476054,f[g>>2]|0);eua(i,j,456466);wrb(a,h,d,6,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);u=e;return}}}function dtb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;h=u;u=u+80|0;i=h+60|0;j=h+48|0;k=h+36|0;l=h+24|0;m=h+12|0;n=h;o=a+72|0;if(!(f[o>>2]|0)){p=a+88|0;q=b[p+11>>0]|0;if(q<<24>>24<0)r=f[a+92>>2]|0;else r=q&255;if(!r){dua(j,476054,g);eua(i,j,456491);wrb(a,c,d,e,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);u=h;return}else{s=p;t=q}}else{dua(n,476054,a+76|0);eua(m,n,456509);Ccb(l,m,f[f[o>>2]>>2]|0);eua(k,l,456536);Ccb(j,k,a+28|0);eua(i,j,456566);wrb(a,c,d,e,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);if((b[n+11>>0]|0)<0)O5b(f[n>>2]|0);o=a+88|0;s=o;t=b[o+11>>0]|0}if(t<<24>>24<0)v=f[a+92>>2]|0;else v=t&255;if(!v){u=h;return}dua(n,476054,g);eua(m,n,456619);Ccb(l,m,s);eua(k,l,456638);Ccb(j,k,g);eua(i,j,454127);wrb(a,c,d,e,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);if((b[n+11>>0]|0)<0)O5b(f[n>>2]|0);u=h;return}function etb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+32|0;h=g+12|0;i=g;j=c+11|0;k=b[j>>0]|0;l=c+4|0;m=f[l>>2]|0;if(!((k<<24>>24<0?m:k&255)|0)){vrb(a,d,e,0,458269);u=g;return}n=h+11|0;o=i+11|0;p=0;q=k;k=m;while(1){m=b[(q<<24>>24<0?f[c>>2]|0:c)+p>>0]|0;do if(m<<24>>24<97)if(m<<24>>24<65)if((m+-48&255)>9){r=9;break}else{s=q;t=k;break}else if(m<<24>>24<91|m<<24>>24==95){s=q;t=k;break}else{r=9;break}else if(m<<24>>24>122)r=9;else{s=q;t=k}while(0);if((r|0)==9){r=0;dua(i,476054,c);eua(h,i,458283);wrb(a,d,e,0,h);if((b[n>>0]|0)<0)O5b(f[h>>2]|0);if((b[o>>0]|0)<0)O5b(f[i>>2]|0);s=b[j>>0]|0;t=f[l>>2]|0}p=p+1|0;if(p>>>0>=(s<<24>>24<0?t:s&255)>>>0)break;else{q=s;k=t}}u=g;return}function ftb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=L5b(60)|0;qzb(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))urb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}$ob(i,e);Uob(k,i)|0;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);f[g+68>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;X5b(i,c);c=i+12|0;X5b(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)c4b(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=ze(8)|0;T5b(a,477177);f[a>>2]=149528;If(a|0,25408,1411)}else{p=L5b(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;X5b(a,i);X5b(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;X5b(n+-32|0,j);X5b(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)O5b(f[v>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)O5b(t)}else{X5b(e,i);X5b(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=h;return}function gtb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+128|0;j=i+108|0;k=i+8|0;l=i;m=i+72|0;n=i+120|0;o=i+64|0;p=i+96|0;q=i+52|0;r=i+40|0;s=i+28|0;t=i+16|0;if(!d)v=f[a+40>>2]|0;else v=d;d=a+4|0;w=f[d>>2]|0;x=h;h=f[x>>2]|0;y=f[x+4>>2]|0;x=k;f[x>>2]=h;f[x+4>>2]=y;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];if(htb(w,c,j)|0){w=f[a+44>>2]|0;k=l;f[k>>2]=h;f[k+4>>2]=y;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];if(itb(w,v,e,j)|0){z=1;u=i;return z|0}zpb(m,2,450744,3720);xpb(n,vpb(wpb(vpb(m,476054)|0,c)|0,458077)|0);Apb(m);z=0;u=i;return z|0}Zsb(o,f[d>>2]|0,c);switch(f[o>>2]|0){case 8:{A=f[o+4>>2]|0;break}case 1:{A=f[(f[o+4>>2]|0)+8>>2]|0;break}case 2:{A=f[(f[o+4>>2]|0)+24>>2]|0;break}case 3:{A=f[(f[(f[o+4>>2]|0)+8>>2]|0)+8>>2]|0;break}case 4:{A=f[(f[o+4>>2]|0)+8>>2]|0;break}case 5:{A=f[(f[(f[o+4>>2]|0)+12>>2]|0)+8>>2]|0;break}case 6:{A=f[(f[o+4>>2]|0)+8>>2]|0;break}case 7:{A=f[(f[(f[o+4>>2]|0)+8>>2]|0)+8>>2]|0;break}default:A=0}if((A|0)!=(f[a+40>>2]|0)){dua(r,476054,c);eua(q,r,458238);Ccb(p,q,f[A>>2]|0);eua(j,p,476219);wrb(a,c,g,0,j);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[p+11>>0]|0)<0)O5b(f[p>>2]|0);if((b[q+11>>0]|0)<0)O5b(f[q>>2]|0);if((b[r+11>>0]|0)<0)O5b(f[r>>2]|0);z=0;u=i;return z|0}A=t6b(c,46,-1)|0;if((A|0)==-1){dua(p,476054,c);eua(j,p,458190);wrb(a,c,g,0,j);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[p+11>>0]|0)<0)O5b(f[p>>2]|0);z=0;u=i;return z|0}Y5b(s,c,A+1|0,-1,c);dua(r,476054,s);eua(q,r,458212);Y5b(t,c,0,A,c);Ccb(p,q,t);eua(j,p,476219);wrb(a,c,g,0,j);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[p+11>>0]|0)<0)O5b(f[p>>2]|0);if((b[t+11>>0]|0)<0)O5b(f[t>>2]|0);if((b[q+11>>0]|0)<0)O5b(f[q>>2]|0);if((b[r+11>>0]|0)<0)O5b(f[r>>2]|0);if((b[s+11>>0]|0)<0)O5b(f[s>>2]|0);z=0;u=i;return z|0}function htb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+16|0;g=e;h=a+120|0;i=c+11|0;j=(b[i>>0]|0)<0?f[c>>2]|0:c;k=j;l=d;d=f[l>>2]|0;m=f[l+4>>2]|0;l=b[j>>0]|0;if(!(l<<24>>24))o=0;else{p=j;q=0;r=l;while(1){l=(q*5|0)+(r<<24>>24)|0;p=p+1|0;r=b[p>>0]|0;if(!(r<<24>>24)){o=l;break}else q=l}}q=a+124|0;r=f[q>>2]|0;p=(r|0)==0;a:do if(!p){l=r+-1|0;s=(l&r|0)==0;if(!s)if(o>>>0<r>>>0)t=o;else t=(o>>>0)%(r>>>0)|0;else t=l&o;v=f[(f[h>>2]|0)+(t<<2)>>2]|0;if(!v)w=t;else{if(s){s=v;while(1){s=f[s>>2]|0;if(!s){w=t;break a}x=f[s+4>>2]|0;if(!((x|0)==(o|0)|(x&l|0)==(t|0))){w=t;break a}if(!(gTb(f[s+8>>2]|0,j)|0)){y=0;break}}u=e;return y|0}else z=v;while(1){z=f[z>>2]|0;if(!z){w=t;break a}s=f[z+4>>2]|0;if((s|0)!=(o|0)){if(s>>>0<r>>>0)A=s;else A=(s>>>0)%(r>>>0)|0;if((A|0)!=(t|0)){w=t;break a}}if(!(gTb(f[z+8>>2]|0,j)|0)){y=0;break}}u=e;return y|0}}else w=0;while(0);j=L5b(20)|0;f[j+8>>2]=k;k=j+12|0;f[k>>2]=d;f[k+4>>2]=m;f[j+4>>2]=o;f[j>>2]=0;m=a+132|0;B=+(((f[m>>2]|0)+1|0)>>>0);C=+n[a+136>>2];do if(p|B>+(r>>>0)*C){k=(r>>>0<3|(r+-1&r|0)!=0)&1|r<<1;d=~~+X(+(B/C))>>>0;jqb(h,k>>>0<d>>>0?d:k);k=f[q>>2]|0;d=k+-1|0;if(!(d&k)){D=k;E=d&o;break}if(o>>>0<k>>>0){D=k;E=o}else{D=k;E=(o>>>0)%(k>>>0)|0}}else{D=r;E=w}while(0);w=(f[h>>2]|0)+(E<<2)|0;E=f[w>>2]|0;if(!E){r=a+128|0;f[j>>2]=f[r>>2];f[r>>2]=j;f[w>>2]=r;r=f[j>>2]|0;if(r|0){w=f[r+4>>2]|0;r=D+-1|0;if(r&D)if(w>>>0<D>>>0)F=w;else F=(w>>>0)%(D>>>0)|0;else F=w&r;G=(f[h>>2]|0)+(F<<2)|0;H=32}}else{f[j>>2]=f[E>>2];G=E;H=32}if((H|0)==32)f[G>>2]=j;f[m>>2]=(f[m>>2]|0)+1;m=(b[i>>0]|0)<0?f[c>>2]|0:c;f[g>>2]=m;c=a+188|0;i=f[c>>2]|0;if((i|0)==(f[a+192>>2]|0))Lqb(a+184|0,g);else{f[i>>2]=m;f[c>>2]=(f[c>>2]|0)+4}y=1;u=e;return y|0}function itb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0;g=c;h=(b[d+11>>0]|0)<0?f[d>>2]|0:d;d=h;i=e;e=f[i>>2]|0;j=f[i+4>>2]|0;i=g*65535|0;k=b[h>>0]|0;if(!(k<<24>>24))l=0;else{m=h;o=0;p=k;while(1){k=(o*5|0)+(p<<24>>24)|0;m=m+1|0;p=b[m>>0]|0;if(!(p<<24>>24)){l=k;break}else o=k}}o=l+i|0;i=a+4|0;l=f[i>>2]|0;p=(l|0)==0;a:do if(!p){m=l+-1|0;k=(m&l|0)==0;if(!k)if(o>>>0<l>>>0)q=o;else q=(o>>>0)%(l>>>0)|0;else q=m&o;r=f[(f[a>>2]|0)+(q<<2)>>2]|0;if((r|0)!=0?(s=f[r>>2]|0,(s|0)!=0):0){if(k){k=s;while(1){r=f[k+4>>2]|0;if(!((r|0)==(o|0)|(r&m|0)==(q|0))){t=q;break a}if((f[k+8>>2]|0)==(c|0)?(gTb(f[k+12>>2]|0,h)|0)==0:0){u=0;break}k=f[k>>2]|0;if(!k){t=q;break a}}return u|0}else v=s;while(1){k=f[v+4>>2]|0;if((k|0)!=(o|0)){if(k>>>0<l>>>0)w=k;else w=(k>>>0)%(l>>>0)|0;if((w|0)!=(q|0)){t=q;break a}}if((f[v+8>>2]|0)==(c|0)?(gTb(f[v+12>>2]|0,h)|0)==0:0){u=0;break}v=f[v>>2]|0;if(!v){t=q;break a}}return u|0}else t=q}else t=0;while(0);q=L5b(24)|0;f[q+8>>2]=g;f[q+12>>2]=d;d=q+16|0;f[d>>2]=e;f[d+4>>2]=j;f[q+4>>2]=o;f[q>>2]=0;j=a+12|0;x=+(((f[j>>2]|0)+1|0)>>>0);y=+n[a+16>>2];do if(p|x>+(l>>>0)*y){d=(l>>>0<3|(l+-1&l|0)!=0)&1|l<<1;e=~~+X(+(x/y))>>>0;rqb(a,d>>>0<e>>>0?e:d);d=f[i>>2]|0;e=d+-1|0;if(!(e&d)){z=d;A=e&o;break}if(o>>>0<d>>>0){z=d;A=o}else{z=d;A=(o>>>0)%(d>>>0)|0}}else{z=l;A=t}while(0);t=(f[a>>2]|0)+(A<<2)|0;A=f[t>>2]|0;if(!A){l=a+8|0;f[q>>2]=f[l>>2];f[l>>2]=q;f[t>>2]=l;l=f[q>>2]|0;if(l|0){t=f[l+4>>2]|0;l=z+-1|0;if(l&z)if(t>>>0<z>>>0)B=t;else B=(t>>>0)%(z>>>0)|0;else B=t&l;C=(f[a>>2]|0)+(B<<2)|0;D=35}}else{f[q>>2]=f[A>>2];C=A;D=35}if((D|0)==35)f[C>>2]=q;f[j>>2]=(f[j>>2]|0)+1;u=1;return u|0}function jtb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;g=u;u=u+16|0;h=g+8|0;i=g;j=a+4|0;k=f[j>>2]|0;l=c+16|0;m=f[l>>2]|0;n=L5b(12)|0;X5b(n,m);f[h>>2]=n;m=k+76|0;o=f[m>>2]|0;if((o|0)==(f[k+80>>2]|0))Rqb(k+72|0,h);else{f[o>>2]=n;f[m>>2]=(f[m>>2]|0)+4}f[e>>2]=f[h>>2];f[e+8>>2]=d;m=f[j>>2]|0;j=f[d+4>>2]|0;n=L5b(12)|0;X5b(n,j);f[h>>2]=n;j=m+76|0;o=f[j>>2]|0;if((o|0)==(f[m+80>>2]|0))Rqb(m+72|0,h);else{f[o>>2]=n;f[j>>2]=(f[j>>2]|0)+4}j=f[h>>2]|0;f6b(j,1,46)|0;n=f[e>>2]|0;o=b[n+11>>0]|0;m=o<<24>>24<0;j6b(j,m?f[n>>2]|0:n,m?f[n+4>>2]|0:o&255)|0;o=e+4|0;f[o>>2]=j;etb(a,f[l>>2]|0,j,c);f[e+12>>2]=0;f[e+16>>2]=0;if(!(f[c+8>>2]&8)){f[e+20>>2]=0;p=c+32|0;q=b[p>>0]|0;r=e+24|0;b[r>>0]=q;s=c+33|0;t=b[s>>0]|0;v=e+25|0;b[v>>0]=t;w=f[o>>2]|0;x=f[e>>2]|0;f[i>>2]=7;y=i+4|0;f[y>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];gtb(a,w,d,x,c,h)|0;u=g;return}else{j=f[c+28>>2]|0;l=f[o>>2]|0;ltb(a,l,l,(j|0)==0?498952:j,e);p=c+32|0;q=b[p>>0]|0;r=e+24|0;b[r>>0]=q;s=c+33|0;t=b[s>>0]|0;v=e+25|0;b[v>>0]=t;w=f[o>>2]|0;x=f[e>>2]|0;f[i>>2]=7;y=i+4|0;f[y>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];gtb(a,w,d,x,c,h)|0;u=g;return}}function ktb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=L5b(52)|0;Zxb(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))urb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}$ob(i,e);Uob(k,i)|0;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);f[g+12>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;X5b(i,c);c=i+12|0;X5b(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)c4b(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=ze(8)|0;T5b(a,477177);f[a>>2]=149528;If(a|0,25408,1411)}else{p=L5b(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;X5b(a,i);X5b(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;X5b(n+-32|0,j);X5b(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)O5b(f[v>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)O5b(t)}else{X5b(e,i);X5b(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=h;return}function ltb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=L5b(52)|0;Hxb(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))urb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}$ob(i,e);Uob(k,i)|0;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);f[g+20>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;X5b(i,c);c=i+12|0;X5b(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)c4b(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=ze(8)|0;T5b(a,477177);f[a>>2]=149528;If(a|0,25408,1411)}else{p=L5b(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;X5b(a,i);X5b(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;X5b(n+-32|0,j);X5b(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)O5b(f[v>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)O5b(t)}else{X5b(e,i);X5b(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=h;return}function mtb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;g=u;u=u+112|0;h=g+88|0;i=g+60|0;j=g+80|0;k=g+72|0;l=g+48|0;m=g+36|0;n=g+24|0;o=g+12|0;p=g;q=a+4|0;r=f[q>>2]|0;s=c+16|0;t=f[s>>2]|0;v=L5b(12)|0;X5b(v,t);f[h>>2]=v;t=r+76|0;w=f[t>>2]|0;if((w|0)==(f[r+80>>2]|0))Rqb(r+72|0,h);else{f[w>>2]=v;f[t>>2]=(f[t>>2]|0)+4}f[e>>2]=f[h>>2];t=e+8|0;f[t>>2]=f[c+24>>2];v=e+12|0;f[v>>2]=d;w=f[q>>2]|0;q=f[d+4>>2]|0;r=L5b(12)|0;X5b(r,q);f[h>>2]=r;q=w+76|0;x=f[q>>2]|0;if((x|0)==(f[w+80>>2]|0))Rqb(w+72|0,h);else{f[x>>2]=r;f[q>>2]=(f[q>>2]|0)+4}q=f[h>>2]|0;r=b[q+11>>0]|0;if(r<<24>>24<0)y=f[q+4>>2]|0;else y=r&255;r=f[d>>2]|0;x=b[r+11>>0]|0;if(x<<24>>24<0)z=f[r+4>>2]|0;else z=x&255;e6b(q,y-z|0,0);z=f[e>>2]|0;y=b[z+11>>0]|0;x=y<<24>>24<0;j6b(q,x?f[z>>2]|0:z,x?f[z+4>>2]|0:y&255)|0;y=e+4|0;f[y>>2]=q;etb(a,f[s>>2]|0,q,c);if(!(f[c+8>>2]&4))f[e+16>>2]=0;else{q=f[c+20>>2]|0;s=f[y>>2]|0;stb(a,s,s,(q|0)==0?498824:q,e)}q=f[y>>2]|0;s=d+12|0;z=f[s>>2]|0;x=f[e>>2]|0;f[j>>2]=5;f[j+4>>2]=e;f[h>>2]=f[j>>2];f[h+4>>2]=f[j+4>>2];j=gtb(a,q,z,x,c,h)|0;x=a+44|0;z=f[x>>2]|0;q=f[e>>2]|0;f[k>>2]=5;f[k+4>>2]=e;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];if(j|(itb(z,d,q,h)|0)^1){A=f[x>>2]|0;f[h>>2]=e;B=f[v>>2]|0;C=f[t>>2]|0;f[i>>2]=B;D=i+4|0;f[D>>2]=C;E=A+80|0;Oqb(E,i,h)|0;u=g;return};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;q=f[s>>2]|0;if(!q)_5b(h,f[(f[a+40>>2]|0)+4>>2]|0)|0;else _5b(h,f[q+4>>2]|0)|0;q=h+11|0;s=b[q>>0]|0;if((s<<24>>24<0?f[h+4>>2]|0:s&255)|0){dua(l,476054,h);eua(i,l,476054);_5b(h,i)|0;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0)}else d6b(h,458441)|0;s=f[y>>2]|0;dua(p,458458,f[e>>2]|0);eua(o,p,458590);Ccb(n,o,h);eua(m,n,458615);Ccb(l,m,f[d>>2]|0);eua(i,l,476219);wrb(a,s,c,0,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);if((b[n+11>>0]|0)<0)O5b(f[n>>2]|0);if((b[o+11>>0]|0)<0)O5b(f[o>>2]|0);if((b[p+11>>0]|0)<0)O5b(f[p>>2]|0);if((b[q>>0]|0)<0)O5b(f[h>>2]|0);A=f[x>>2]|0;f[h>>2]=e;B=f[v>>2]|0;C=f[t>>2]|0;f[i>>2]=B;D=i+4|0;f[D>>2]=C;E=A+80|0;Oqb(E,i,h)|0;u=g;return}function ntb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=u;u=u+96|0;g=e+84|0;h=e+72|0;i=e+60|0;j=e+48|0;k=e+32|0;l=e;m=e+16|0;n=f[d>>2]|0;o=b[n+11>>0]|0;p=o<<24>>24<0;q=p?f[n>>2]|0:n;r=p?f[n+4>>2]|0:o&255;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if((r|0)>0){o=0;do{n=b[q+o>>0]|0;if(n<<24>>24!=95){p=n<<24>>24;l6b(h,((n+-65&255)<26?p+32|0:p)&255)}o=o+1|0}while((o|0)<(r|0))}r=i+4|0;f[r>>2]=0;o=i+8|0;f[o>>2]=0;q=i+4|0;f[i>>2]=q;p=d+24|0;do if((f[p>>2]|0)>0){n=d+28|0;s=h+11|0;t=h+4|0;v=g+11|0;w=g+8|0;x=g+4|0;y=l+12|0;z=k+12|0;A=k+11|0;B=l+11|0;C=m+11|0;D=c+28|0;E=g+11|0;F=k+11|0;G=l+11|0;H=j+11|0;I=0;a:while(1){J=f[n>>2]|0;K=J+(I*20|0)|0;L=f[K>>2]|0;M=b[L+11>>0]|0;N=M<<24>>24<0;O=N?f[L>>2]|0:L;P=N?f[L+4>>2]|0:M&255;M=(P|0)==0;L=b[s>>0]|0;b:do if(M){Q=0;R=0;S=L&255;T=26}else{N=L&255;c:do if(L<<24>>24<0){U=f[t>>2]|0;V=f[h>>2]|0;W=0;X=0;while(1){if(X>>>0>=U>>>0){Q=X;R=W;S=N;T=26;break b}Y=b[O+W>>0]|0;if(Y<<24>>24!=95){Z=Y<<24>>24;if((((Y+-65&255)<26?Z+32|0:Z)&255)<<24>>24==(b[V+X>>0]|0))_=X+1|0;else break c}else _=X;Z=W+1|0;if(Z>>>0<P>>>0){W=Z;X=_}else{Q=_;R=Z;S=N;T=26;break b}}}else{X=0;W=0;while(1){if(W>>>0>=N>>>0){Q=W;R=X;S=N;T=26;break b}V=b[O+X>>0]|0;if(V<<24>>24!=95){U=V<<24>>24;if((((V+-65&255)<26?U+32|0:U)&255)<<24>>24==(b[h+W>>0]|0))$=W+1|0;else break c}else $=W;U=X+1|0;if(U>>>0<P>>>0){X=U;W=$}else{Q=$;R=U;S=N;T=26;break b}}}while(0);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(P>>>0>4294967279){T=20;break a}if(P>>>0<11){b[v>>0]=P;aa=g}else{N=P+16&-16;W=L5b(N)|0;f[g>>2]=W;f[w>>2]=N|-2147483648;f[x>>2]=P;aa=W}Vac(aa|0,O|0,P|0)|0;b[aa+P>>0]=0}while(0);do if((T|0)==26){T=0;if(Q>>>0<(L<<24>>24<0?f[t>>2]|0:S)>>>0){if(!O){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;break};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(P>>>0>4294967279){T=31;break a}if(P>>>0<11){b[v>>0]=P;if(M)ba=g;else{ca=g;T=35}}else{W=P+16&-16;N=L5b(W)|0;f[g>>2]=N;f[w>>2]=W|-2147483648;f[x>>2]=P;ca=N;T=35}if((T|0)==35){T=0;Vac(ca|0,O|0,P|0)|0;ba=ca}b[ba+P>>0]=0;break}d:do if(R>>>0<P>>>0){N=R;while(1){if((b[O+N>>0]|0)!=95){da=N;break d}W=N+1|0;if(W>>>0<P>>>0)N=W;else{da=W;break}}}else da=R;while(0);if((P|0)==(da|0)){if(!O){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;break};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(P>>>0>4294967279){T=43;break a}if(P>>>0<11){b[v>>0]=P;if(M)ea=g;else{fa=g;T=47}}else{N=P+16&-16;W=L5b(N)|0;f[g>>2]=W;f[w>>2]=N|-2147483648;f[x>>2]=P;fa=W;T=47}if((T|0)==47){T=0;Vac(fa|0,O|0,P|0)|0;ea=fa}b[ea+P>>0]=0;break}else{W=O+da|0;N=P-da|0;if(!W){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;break};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(N>>>0>4294967279){T=52;break a}if(N>>>0<11){b[v>>0]=N;if(!N)ga=g;else{ha=g;T=56}}else{X=N+16&-16;U=L5b(X)|0;f[g>>2]=U;f[w>>2]=X|-2147483648;f[x>>2]=N;ha=U;T=56}if((T|0)==56){T=0;Vac(ha|0,W|0,N|0)|0;ga=ha}b[ga+N>>0]=0;break}}while(0);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;P=b[v>>0]|0;c6b(j,P<<24>>24<0?f[x>>2]|0:P&255);P=b[v>>0]|0;if(!((P<<24>>24<0?f[x>>2]|0:P&255)|0))ia=P;else{O=1;M=0;L=P;while(1){P=b[(L<<24>>24<0?f[g>>2]|0:g)+M>>0]|0;do if(P<<24>>24!=95){N=P<<24>>24;if(O){l6b(j,((P+-97&255)<26?N+224|0:N)&255);ja=0;break}else{l6b(j,((P+-65&255)<26?N+32|0:N)&255);ja=0;break}}else ja=1;while(0);M=M+1|0;P=b[v>>0]|0;if(M>>>0>=(P<<24>>24<0?f[x>>2]|0:P&255)>>>0){ia=P;break}else{O=ja;L=P}}}if(ia<<24>>24<0)O5b(f[g>>2]|0);X5b(m,j);X5b(l,m);f[y>>2]=K;X5b(k,l);f[z>>2]=f[y>>2];L=ptb(i,g,k)|0;O=f[L>>2]|0;if(!O){M=L5b(32)|0;X5b(M+16|0,k);f[M+28>>2]=f[z>>2];P=f[g>>2]|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=P;f[L>>2]=M;P=f[f[i>>2]>>2]|0;if(!P)ka=M;else{f[i>>2]=P;ka=f[L>>2]|0}mP(f[r>>2]|0,ka);f[o>>2]=(f[o>>2]|0)+1;la=M;ma=1}else{la=O;ma=0}if((b[A>>0]|0)<0)O5b(f[k>>2]|0);if((b[B>>0]|0)<0)O5b(f[l>>2]|0);if((b[C>>0]|0)<0)O5b(f[m>>2]|0);e:do if(!(ma<<24>>24)){O=f[la+28>>2]|0;M=f[O>>2]|0;L=f[K>>2]|0;P=b[M+11>>0]|0;N=P<<24>>24<0;W=P&255;P=N?f[M+4>>2]|0:W;U=b[L+11>>0]|0;X=U<<24>>24<0;do if((P|0)==((X?f[L+4>>2]|0:U&255)|0)){V=f[M>>2]|0;Z=N?V:M;Y=X?f[L>>2]|0:L;na=(P|0)==0;if(N){if(na)break e;if(!(ZVb(Z,Y,P)|0))break e;else break}if(na)break e;if((V&255)<<24>>24==(b[Y>>0]|0)){V=M;na=W;Z=Y;do{na=na+-1|0;V=V+1|0;if(!na)break e;Z=Z+1|0}while((b[V>>0]|0)==(b[Z>>0]|0))}}while(0);if((f[O+8>>2]|0)!=(f[J+(I*20|0)+8>>2]|0)){W=f[J+(I*20|0)+4>>2]|0;M=f[(f[D>>2]|0)+4+(I<<2)>>2]|0;dua(l,458351,j);eua(k,l,458405);P=qtb(i,j)|0;Ccb(g,k,f[f[P>>2]>>2]|0);wrb(a,W,M,0,g);if((b[E>>0]|0)<0)O5b(f[g>>2]|0);if((b[F>>0]|0)<0)O5b(f[k>>2]|0);if((b[G>>0]|0)<0)O5b(f[l>>2]|0)}}while(0);if((b[H>>0]|0)<0)O5b(f[j>>2]|0);I=I+1|0;if((I|0)>=(f[p>>2]|0)){T=96;break}}if((T|0)==20)V5b(g);else if((T|0)==31)V5b(g);else if((T|0)==43)V5b(g);else if((T|0)==52)V5b(g);else if((T|0)==96){oa=i;pa=s;qa=f[q>>2]|0;break}}else{oa=i;pa=h+11|0;qa=0}while(0);rtb(oa,qa);if((b[pa>>0]|0)>=0){u=e;return}O5b(f[h>>2]|0);u=e;return}function otb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=L5b(52)|0;Hyb(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))urb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}$ob(i,e);Uob(k,i)|0;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);f[g+16>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;X5b(i,c);c=i+12|0;X5b(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)c4b(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=ze(8)|0;T5b(a,477177);f[a>>2]=149528;If(a|0,25408,1411)}else{p=L5b(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;X5b(a,i);X5b(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;X5b(n+-32|0,j);X5b(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)O5b(f[v>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)O5b(t)}else{X5b(e,i);X5b(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=h;return}function ptb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=ZVb(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=ZVb(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function qtb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=ptb(a,d,b)|0;g=f[e>>2]|0;if(g|0){h=g;i=h+28|0;u=c;return i|0}g=L5b(32)|0;X5b(g+16|0,b);f[g+28>>2]=0;b=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=b;f[e>>2]=g;b=f[f[a>>2]>>2]|0;if(!b)j=g;else{f[a>>2]=b;j=f[e>>2]|0}mP(f[a+4>>2]|0,j);j=a+8|0;f[j>>2]=(f[j>>2]|0)+1;h=g;i=h+28|0;u=c;return i|0}function rtb(a,c){a=a|0;c=c|0;if(!c)return;rtb(a,f[c>>2]|0);rtb(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(c);return}function stb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=L5b(52)|0;pyb(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))urb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}$ob(i,e);Uob(k,i)|0;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);f[g+16>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;X5b(i,c);c=i+12|0;X5b(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)c4b(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=ze(8)|0;T5b(a,477177);f[a>>2]=149528;If(a|0,25408,1411)}else{p=L5b(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;X5b(a,i);X5b(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;X5b(n+-32|0,j);X5b(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)O5b(f[v>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)O5b(t)}else{X5b(e,i);X5b(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=h;return}function ttb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=u;u=u+16|0;h=g+8|0;i=g;j=a+4|0;k=f[j>>2]|0;l=f[d+4>>2]|0;m=L5b(12)|0;X5b(m,l);f[h>>2]=m;l=k+76|0;n=f[l>>2]|0;if((n|0)==(f[k+80>>2]|0))Rqb(k+72|0,h);else{f[n>>2]=m;f[l>>2]=(f[l>>2]|0)+4}l=f[h>>2]|0;f6b(l,1,46)|0;m=c+16|0;n=f[m>>2]|0;k=b[n+11>>0]|0;o=k<<24>>24<0;j6b(l,o?f[n>>2]|0:n,o?f[n+4>>2]|0:k&255)|0;etb(a,f[m>>2]|0,l,c);k=f[j>>2]|0;j=f[m>>2]|0;m=L5b(12)|0;X5b(m,j);f[h>>2]=m;j=k+76|0;n=f[j>>2]|0;if((n|0)==(f[k+80>>2]|0))Rqb(k+72|0,h);else{f[n>>2]=m;f[j>>2]=(f[j>>2]|0)+4}j=f[h>>2]|0;f[e>>2]=j;m=e+4|0;f[m>>2]=l;f[e+8>>2]=d;f[e+16>>2]=0;f[e+20>>2]=0;if(!(f[c+8>>2]&2)){f[e+24>>2]=0;p=l;q=j;f[i>>2]=3;r=i+4|0;f[r>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];gtb(a,p,d,q,c,h)|0;u=g;return}else{j=f[c+20>>2]|0;wtb(a,l,l,(j|0)==0?498704:j,e);p=f[m>>2]|0;q=f[e>>2]|0;f[i>>2]=3;r=i+4|0;f[r>>2]=e;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];gtb(a,p,d,q,c,h)|0;u=g;return}}function utb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=L5b(52)|0;Jzb(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))urb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}$ob(i,e);Uob(k,i)|0;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);f[g+16>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;X5b(i,c);c=i+12|0;X5b(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)c4b(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=ze(8)|0;T5b(a,477177);f[a>>2]=149528;If(a|0,25408,1411)}else{p=L5b(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;X5b(a,i);X5b(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;X5b(n+-32|0,j);X5b(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)O5b(f[v>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)O5b(t)}else{X5b(e,i);X5b(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=h;return}function vtb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=e?f[c>>2]|0:c;h=b[g>>0]|0;if(!(h<<24>>24))i=0;else{j=g;k=0;l=h;while(1){m=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=m;break}else k=m}}k=f[a+4>>2]|0;if(!k){n=0;return n|0}l=k+-1|0;j=(l&k|0)==0;if(!j)if(i>>>0<k>>>0)o=i;else o=(i>>>0)%(k>>>0)|0;else o=l&i;m=f[(f[a>>2]|0)+(o<<2)>>2]|0;if(!m){n=0;return n|0}a=f[m>>2]|0;if(!a){n=0;return n|0}m=e?f[c+4>>2]|0:d&255;d=(m|0)==0;if(j){j=a;a:while(1){c=f[j+4>>2]|0;e=(c|0)==(i|0);if(!(e|(c&l|0)==(o|0))){n=0;p=36;break}do if(e?(c=j+8|0,q=b[c+11>>0]|0,r=q<<24>>24<0,s=q&255,((r?f[j+12>>2]|0:s)|0)==(m|0)):0){q=f[c>>2]|0;t=r?q:c;if(r){if(d){n=j;p=36;break a}if(!(ZVb(t,g,m)|0)){n=j;p=36;break a}else break}if(d){n=j;p=36;break a}if((q&255)<<24>>24==h<<24>>24){q=c;c=s;s=g;do{c=c+-1|0;q=q+1|0;if(!c){n=j;p=36;break a}s=s+1|0}while((b[q>>0]|0)==(b[s>>0]|0))}}while(0);j=f[j>>2]|0;if(!j){n=0;p=36;break}}if((p|0)==36)return n|0}else u=a;b:while(1){a=f[u+4>>2]|0;j=(a|0)==(i|0);if(!j){if(a>>>0<k>>>0)v=a;else v=(a>>>0)%(k>>>0)|0;if((v|0)!=(o|0)){n=0;p=36;break}if(j)p=28}else p=28;do if((p|0)==28?(p=0,j=u+8|0,a=b[j+11>>0]|0,l=a<<24>>24<0,e=a&255,((l?f[u+12>>2]|0:e)|0)==(m|0)):0){a=f[j>>2]|0;s=l?a:j;if(l){if(d){n=u;p=36;break b}if(!(ZVb(s,g,m)|0)){n=u;p=36;break b}else break}if(d){n=u;p=36;break b}if((a&255)<<24>>24==h<<24>>24){a=j;j=e;e=g;do{j=j+-1|0;a=a+1|0;if(!j){n=u;p=36;break b}e=e+1|0}while((b[a>>0]|0)==(b[e>>0]|0))}}while(0);u=f[u>>2]|0;if(!u){n=0;p=36;break}}if((p|0)==36)return n|0;return 0}function wtb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+32|0;i=h;j=f[a+4>>2]|0;k=L5b(48)|0;Zyb(k);f[i>>2]=k;l=j+88|0;m=f[l>>2]|0;if((m|0)==(f[j+92>>2]|0))urb(j+84|0,i);else{f[m>>2]=k;f[l>>2]=(f[l>>2]|0)+4}$ob(i,e);Uob(k,i)|0;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);f[g+24>>2]=k;if((f[k+36>>2]|0)<=0){u=h;return}g=a+12|0;X5b(i,c);c=i+12|0;X5b(c,d);d=i+24|0;f[d>>2]=e;f[i+28>>2]=k;k=a+16|0;e=f[k>>2]|0;l=a+20|0;a=f[l>>2]|0;m=a;if((e|0)==(a|0)){a=f[g>>2]|0;j=e-a>>5;n=j+1|0;if(n>>>0>134217727)c4b(g);o=m-a|0;a=o>>4;m=o>>5>>>0<67108863?(a>>>0<n>>>0?n:a):134217727;do if(m)if(m>>>0>134217727){a=ze(8)|0;T5b(a,477177);f[a>>2]=149528;If(a|0,25408,1411)}else{p=L5b(m<<5)|0;break}else p=0;while(0);a=p+(j<<5)|0;n=a;o=p+(m<<5)|0;X5b(a,i);X5b(p+(j<<5)+12|0,c);m=d;q=f[m+4>>2]|0;r=p+(j<<5)+24|0;f[r>>2]=f[m>>2];f[r+4>>2]=q;q=a+32|0;r=f[g>>2]|0;m=f[k>>2]|0;if((m|0)==(r|0)){s=n;t=r;v=r}else{j=m;m=n;n=a;do{a=j;j=j+-32|0;X5b(n+-32|0,j);X5b(n+-20|0,a+-20|0);p=a+-8|0;a=f[p+4>>2]|0;w=n+-8|0;f[w>>2]=f[p>>2];f[w+4>>2]=a;n=m+-32|0;m=n}while((j|0)!=(r|0));s=m;t=f[g>>2]|0;v=f[k>>2]|0}f[g>>2]=s;f[k>>2]=q;f[l>>2]=o;o=t;if((v|0)!=(o|0)){l=v;do{v=l+-20|0;l=l+-32|0;if((b[v+11>>0]|0)<0)O5b(f[v>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0)}while((l|0)!=(o|0))}if(t|0)O5b(t)}else{X5b(e,i);X5b(e+12|0,c);t=d;d=f[t+4>>2]|0;o=e+24|0;f[o>>2]=f[t>>2];f[o+4>>2]=d;f[k>>2]=(f[k>>2]|0)+32}if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);u=h;return}function xtb(){var a=0;a=L5b(148)|0;qqb(a);f[213370]=a;spb(52);return}function ytb(){var a=0;a=f[213370]|0;if(a|0){oqb(a);O5b(a)}f[213370]=0;return}function ztb(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=hub(b,c)|0;u=a;return d|0}function Atb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+144|0;g=f[e>>2]|0;if((g|0)==497760)jza(e,c);else _5b(g,c)|0;c=a+24|0;if((f[c>>2]|0)>0){g=a+28|0;e=b+16|0;h=b+28|0;i=b+24|0;j=b+20|0;k=0;do{l=(f[g>>2]|0)+(k*88|0)|0;m=f[h>>2]|0;do if(m){n=f[j>>2]|0;o=f[m>>2]|0;if((n|0)>=(o|0))if((o|0)==(f[i>>2]|0)){p=o;q=13;break}else{r=o;s=m;q=14;break}else{f[j>>2]=n+1;t=f[m+4+(n<<2)>>2]|0;break}}else{p=f[i>>2]|0;q=13}while(0);if((q|0)==13){q=0;cpb(e,p+1|0);m=f[h>>2]|0;r=f[m>>2]|0;s=m;q=14}if((q|0)==14){q=0;f[s>>2]=r+1;m=Ftb(0,f[e>>2]|0)|0;n=f[h>>2]|0;o=f[j>>2]|0;f[j>>2]=o+1;f[n+4+(o<<2)>>2]=m;t=m}Gtb(l,t);k=k+1|0}while((k|0)<(f[c>>2]|0))}c=a+32|0;if((f[c>>2]|0)>0){k=a+36|0;t=b+96|0;j=b+108|0;h=b+104|0;e=b+100|0;r=0;do{s=(f[k>>2]|0)+(r*28|0)|0;p=f[j>>2]|0;do if(p){i=f[e>>2]|0;g=f[p>>2]|0;if((i|0)>=(g|0))if((g|0)==(f[h>>2]|0)){u=g;q=23;break}else{v=g;w=p;q=24;break}else{f[e>>2]=i+1;x=f[p+4+(i<<2)>>2]|0;break}}else{u=f[h>>2]|0;q=23}while(0);if((q|0)==23){q=0;cpb(t,u+1|0);p=f[j>>2]|0;v=f[p>>2]|0;w=p;q=24}if((q|0)==24){q=0;f[w>>2]=v+1;p=Ztb(0,f[t>>2]|0)|0;l=f[j>>2]|0;i=f[e>>2]|0;f[e>>2]=i+1;f[l+4+(i<<2)>>2]=p;x=p}_tb(s,x);r=r+1|0}while((r|0)<(f[c>>2]|0))}c=a+40|0;if((f[c>>2]|0)>0){r=a+44|0;x=b+48|0;e=b+60|0;j=b+56|0;t=b+52|0;v=0;do{w=(f[r>>2]|0)+(v*88|0)|0;u=f[e>>2]|0;do if(u){h=f[t>>2]|0;k=f[u>>2]|0;if((h|0)>=(k|0))if((k|0)==(f[j>>2]|0)){y=k;q=33;break}else{z=k;A=u;q=34;break}else{f[t>>2]=h+1;B=f[u+4+(h<<2)>>2]|0;break}}else{y=f[j>>2]|0;q=33}while(0);if((q|0)==33){q=0;cpb(x,y+1|0);u=f[e>>2]|0;z=f[u>>2]|0;A=u;q=34}if((q|0)==34){q=0;f[A>>2]=z+1;u=ztb(0,f[x>>2]|0)|0;s=f[e>>2]|0;h=f[t>>2]|0;f[t>>2]=h+1;f[s+4+(h<<2)>>2]=u;B=u}Atb(w,B);v=v+1|0}while((v|0)<(f[c>>2]|0))}c=a+48|0;if((f[c>>2]|0)>0){v=a+52|0;B=b+64|0;t=b+76|0;e=b+72|0;x=b+68|0;z=0;do{A=(f[v>>2]|0)+(z<<5)|0;y=f[t>>2]|0;do if(y){j=f[x>>2]|0;r=f[y>>2]|0;if((j|0)>=(r|0))if((r|0)==(f[e>>2]|0)){C=r;q=43;break}else{D=r;E=y;q=44;break}else{f[x>>2]=j+1;F=f[y+4+(j<<2)>>2]|0;break}}else{C=f[e>>2]|0;q=43}while(0);if((q|0)==43){q=0;cpb(B,C+1|0);y=f[t>>2]|0;D=f[y>>2]|0;E=y;q=44}if((q|0)==44){q=0;f[E>>2]=D+1;y=Btb(0,f[B>>2]|0)|0;w=f[t>>2]|0;j=f[x>>2]|0;f[x>>2]=j+1;f[w+4+(j<<2)>>2]=y;F=y}Ctb(A,F);z=z+1|0}while((z|0)<(f[c>>2]|0))}c=a+56|0;if((f[c>>2]|0)>0){z=b+80|0;F=b+92|0;x=b+88|0;t=b+84|0;B=a+60|0;D=0;do{E=f[F>>2]|0;do if(E){C=f[t>>2]|0;e=f[E>>2]|0;if((C|0)>=(e|0))if((e|0)==(f[x>>2]|0)){G=e;q=53;break}else{H=e;I=E;q=54;break}else{f[t>>2]=C+1;J=f[E+4+(C<<2)>>2]|0;break}}else{G=f[x>>2]|0;q=53}while(0);if((q|0)==53){q=0;cpb(z,G+1|0);E=f[F>>2]|0;H=f[E>>2]|0;I=E;q=54}if((q|0)==54){q=0;f[I>>2]=H+1;E=$tb(0,f[z>>2]|0)|0;A=f[F>>2]|0;C=f[t>>2]|0;f[t>>2]=C+1;f[A+4+(C<<2)>>2]=E;J=E}E=f[B>>2]|0;C=f[E+(D<<3)>>2]|0;A=J+8|0;e=f[A>>2]|0;f[A>>2]=e|1;f[J+16>>2]=C;C=f[E+(D<<3)+4>>2]|0;f[A>>2]=e|3;f[J+20>>2]=C;D=D+1|0}while((D|0)<(f[c>>2]|0))}c=a+64|0;if((f[c>>2]|0)>0){D=a+68|0;J=b+32|0;B=b+44|0;t=b+40|0;F=b+36|0;z=0;do{H=(f[D>>2]|0)+(z*88|0)|0;I=f[B>>2]|0;do if(I){G=f[F>>2]|0;x=f[I>>2]|0;if((G|0)>=(x|0))if((x|0)==(f[t>>2]|0)){K=x;q=63;break}else{L=x;M=I;q=64;break}else{f[F>>2]=G+1;N=f[I+4+(G<<2)>>2]|0;break}}else{K=f[t>>2]|0;q=63}while(0);if((q|0)==63){q=0;cpb(J,K+1|0);I=f[B>>2]|0;L=f[I>>2]|0;M=I;q=64}if((q|0)==64){q=0;f[M>>2]=L+1;I=Ftb(0,f[J>>2]|0)|0;G=f[B>>2]|0;x=f[F>>2]|0;f[F>>2]=x+1;f[G+4+(x<<2)>>2]=I;N=I}Gtb(H,N);z=z+1|0}while((z|0)<(f[c>>2]|0))}c=a+72|0;if((f[c>>2]|0)>0){z=b+112|0;N=b+124|0;F=b+120|0;B=b+116|0;J=a+76|0;L=0;do{M=f[N>>2]|0;do if(M){K=f[B>>2]|0;t=f[M>>2]|0;if((K|0)>=(t|0))if((t|0)==(f[F>>2]|0)){O=t;q=73;break}else{P=t;Q=M;q=74;break}else{f[B>>2]=K+1;R=f[M+4+(K<<2)>>2]|0;break}}else{O=f[F>>2]|0;q=73}while(0);if((q|0)==73){q=0;cpb(z,O+1|0);M=f[N>>2]|0;P=f[M>>2]|0;Q=M;q=74}if((q|0)==74){q=0;f[Q>>2]=P+1;M=aub(0,f[z>>2]|0)|0;H=f[N>>2]|0;K=f[B>>2]|0;f[B>>2]=K+1;f[H+4+(K<<2)>>2]=M;R=M}M=f[J>>2]|0;K=f[M+(L<<3)>>2]|0;H=R+8|0;t=f[H>>2]|0;f[H>>2]=t|1;f[R+16>>2]=K;K=f[M+(L<<3)+4>>2]|0;f[H>>2]=t|3;f[R+20>>2]=K;L=L+1|0}while((L|0)<(f[c>>2]|0))}c=a+80|0;if((f[c>>2]|0)>0){L=a+84|0;R=b+128|0;J=0;do{B=f[(f[L>>2]|0)+(J<<2)>>2]|0;_5b(mza(R)|0,B)|0;J=J+1|0}while((J|0)<(f[c>>2]|0))}c=a+16|0;a=f[c>>2]|0;if((a|0)==(hEb()|0))return;f[d>>2]=f[d>>2]|128;d=b+148|0;b=f[d>>2]|0;if(!b){a=L5b(52)|0;Jzb(a);f[d>>2]=a;S=a}else S=b;iEb(S,f[c>>2]|0);return}function Btb(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=Xtb(b,c)|0;u=a;return d|0}function Ctb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+32|0;g=f[e>>2]|0;if((g|0)==497760)jza(e,c);else _5b(g,c)|0;c=a+24|0;if((f[c>>2]|0)>0){g=a+28|0;e=b+16|0;h=b+28|0;i=b+24|0;j=b+20|0;k=0;do{l=(f[g>>2]|0)+(k*20|0)|0;m=f[h>>2]|0;do if(m){n=f[j>>2]|0;o=f[m>>2]|0;if((n|0)>=(o|0))if((o|0)==(f[i>>2]|0)){p=o;q=12;break}else{r=o;s=m;q=13;break}else{f[j>>2]=n+1;t=f[m+4+(n<<2)>>2]|0;break}}else{p=f[i>>2]|0;q=12}while(0);if((q|0)==12){q=0;cpb(e,p+1|0);m=f[h>>2]|0;r=f[m>>2]|0;s=m;q=13}if((q|0)==13){q=0;f[s>>2]=r+1;m=Ttb(0,f[e>>2]|0)|0;n=f[h>>2]|0;o=f[j>>2]|0;f[j>>2]=o+1;f[n+4+(o<<2)>>2]=m;t=m}Utb(l,t);k=k+1|0}while((k|0)<(f[c>>2]|0))}c=a+16|0;a=f[c>>2]|0;if((a|0)==(nEb()|0))return;f[d>>2]=f[d>>2]|4;d=b+36|0;b=f[d>>2]|0;if(!b){a=L5b(52)|0;Hyb(a);f[d>>2]=a;u=a}else u=b;oEb(u,f[c>>2]|0);return}function Dtb(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=Rtb(b,c)|0;u=a;return d|0}function Etb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+32|0;g=f[e>>2]|0;if((g|0)==497760)jza(e,c);else _5b(g,c)|0;c=a+16|0;if((f[c>>2]|0)>0){g=a+20|0;e=b+16|0;h=b+28|0;i=b+24|0;j=b+20|0;k=0;do{l=(f[g>>2]|0)+(k*28|0)|0;m=f[h>>2]|0;do if(m){n=f[j>>2]|0;o=f[m>>2]|0;if((n|0)>=(o|0))if((o|0)==(f[i>>2]|0)){p=o;q=12;break}else{r=o;s=m;q=13;break}else{f[j>>2]=n+1;t=f[m+4+(n<<2)>>2]|0;break}}else{p=f[i>>2]|0;q=12}while(0);if((q|0)==12){q=0;cpb(e,p+1|0);m=f[h>>2]|0;r=f[m>>2]|0;s=m;q=13}if((q|0)==13){q=0;f[s>>2]=r+1;m=Ltb(0,f[e>>2]|0)|0;n=f[h>>2]|0;o=f[j>>2]|0;f[j>>2]=o+1;f[n+4+(o<<2)>>2]=m;t=m}Mtb(l,t);k=k+1|0}while((k|0)<(f[c>>2]|0))}c=a+12|0;a=f[c>>2]|0;if((a|0)==(rEb()|0))return;f[d>>2]=f[d>>2]|4;d=b+36|0;b=f[d>>2]|0;if(!b){a=L5b(52)|0;Zxb(a);f[d>>2]=a;u=a}else u=b;sEb(u,f[c>>2]|0);return}function Ftb(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=Jtb(b,c)|0;u=a;return d|0}function Gtb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=c+8|0;f[h>>2]=f[h>>2]|1;i=c+16|0;j=f[i>>2]|0;if((j|0)==497760)jza(i,g);else _5b(j,g)|0;g=f[a+28>>2]|0;j=f[h>>2]|0;f[h>>2]=j|2;f[c+40>>2]=g;do if(b[a+16>>0]|0){g=f[a+20>>2]|0;f[h>>2]=j|258;i=c+32|0;k=f[i>>2]|0;if((k|0)==497760){jza(i,g);break}else{_5b(k,g)|0;break}}while(0);j=f[h>>2]|0;f[c+48>>2]=f[a+36>>2];g=a+32|0;k=f[g>>2]|0;i=j|12;f[h>>2]=i;j=c+52|0;f[j>>2]=k;l=a+40|0;if(!(b[l>>0]|0))m=k;else{k=a+48|0;if(!(b[(f[k>>2]|0)+21>>0]|0)){Htb(c,489392);n=f[h>>2]|0}else n=i;f[h>>2]=n|32;n=c+24|0;i=f[n>>2]|0;if((i|0)==497760){jza(n,497760);o=f[n>>2]|0}else o=i;i=f[(f[k>>2]|0)+4>>2]|0;k=b[i+11>>0]|0;n=k<<24>>24<0;j6b(o,n?f[i>>2]|0:i,n?f[i+4>>2]|0:k&255)|0;m=f[g>>2]|0}switch(f[136e3+(m<<2)>>2]|0){case 10:{m=a+60|0;g=f[m>>2]|0;if(b[g+20>>0]|0){f[j>>2]=1;f[h>>2]=f[h>>2]&-9}if(!(b[g+21>>0]|0))Itb(c,489392);f[h>>2]=f[h>>2]|16;g=c+20|0;j=f[g>>2]|0;if((j|0)==497760){jza(g,497760);p=f[g>>2]|0}else p=j;j=f[(f[m>>2]|0)+4>>2]|0;m=b[j+11>>0]|0;g=m<<24>>24<0;j6b(p,g?f[j>>2]|0:j,g?f[j+4>>2]|0:m&255)|0;break}case 8:{m=a+64|0;if(!(b[(f[m>>2]|0)+21>>0]|0))Itb(c,489392);f[h>>2]=f[h>>2]|16;j=c+20|0;g=f[j>>2]|0;if((g|0)==497760){jza(j,497760);q=f[j>>2]|0}else q=g;g=f[(f[m>>2]|0)+4>>2]|0;m=b[g+11>>0]|0;j=m<<24>>24<0;j6b(q,j?f[g>>2]|0:g,j?f[g+4>>2]|0:m&255)|0;break}default:{}}if(b[a+72>>0]|0){Fsb(e,a,0);f[h>>2]=f[h>>2]|64;m=c+28|0;g=f[m>>2]|0;if((g|0)==497760)jza(m,e);else _5b(g,e)|0;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0)}e=f[a+52>>2]|0;if(e|0?(b[l>>0]|0)==0:0){l=(e-(f[(f[e+8>>2]|0)+36>>2]|0)|0)/28|0;f[h>>2]=f[h>>2]|128;f[c+44>>2]=l}l=a+68|0;a=f[l>>2]|0;if((a|0)==(jEb()|0)){u=d;return}f[h>>2]=f[h>>2]|512;h=c+36|0;c=f[h>>2]|0;if(!c){a=L5b(60)|0;qzb(a);f[h>>2]=a;r=a}else r=c;kEb(r,f[l>>2]|0);u=d;return}function Htb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|32;g=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=kUb(c)|0;if(a>>>0>4294967279)V5b(e);if(a>>>0<11){b[e+11>>0]=a;if(!a)h=e;else{i=e;j=6}}else{k=a+16&-16;l=L5b(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=a;i=l;j=6}if((j|0)==6){Vac(i|0,c|0,a|0)|0;h=i}b[h+a>>0]=0;a=f[g>>2]|0;if((a|0)==497760)jza(g,e);else _5b(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}O5b(f[e>>2]|0);u=d;return}function Itb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|16;g=a+20|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=kUb(c)|0;if(a>>>0>4294967279)V5b(e);if(a>>>0<11){b[e+11>>0]=a;if(!a)h=e;else{i=e;j=6}}else{k=a+16&-16;l=L5b(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=a;i=l;j=6}if((j|0)==6){Vac(i|0,c|0,a|0)|0;h=i}b[h+a>>0]=0;a=f[g>>2]|0;if((a|0)==497760)jza(g,e);else _5b(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}O5b(f[e>>2]|0);u=d;return}function Jtb(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(56)|0;nCb(b);c=b;return c|0}else{b=znb(a,22968,56)|0;nCb(b);xnb(a,b,1511);c=b;return c|0}return 0}function Ktb(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function Ltb(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=Ptb(b,c)|0;u=a;return d|0}function Mtb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=f[a>>2]|0;e=c+8|0;f[e>>2]=f[e>>2]|1;g=c+16|0;h=f[g>>2]|0;if((h|0)==497760)jza(g,d);else _5b(h,d)|0;d=a+12|0;if(!(b[(f[d>>2]|0)+21>>0]|0))Ntb(c,489392);f[e>>2]=f[e>>2]|2;h=c+20|0;g=f[h>>2]|0;if((g|0)==497760){jza(h,497760);i=f[h>>2]|0}else i=g;g=f[(f[d>>2]|0)+4>>2]|0;d=b[g+11>>0]|0;h=d<<24>>24<0;j6b(i,h?f[g>>2]|0:g,h?f[g+4>>2]|0:d&255)|0;d=a+16|0;if(!(b[(f[d>>2]|0)+21>>0]|0))Otb(c,489392);f[e>>2]=f[e>>2]|4;g=c+24|0;h=f[g>>2]|0;if((h|0)==497760){jza(g,497760);j=f[g>>2]|0}else j=h;h=f[(f[d>>2]|0)+4>>2]|0;d=b[h+11>>0]|0;g=d<<24>>24<0;j6b(j,g?f[h>>2]|0:h,g?f[h+4>>2]|0:d&255)|0;d=a+20|0;h=f[d>>2]|0;if((h|0)!=(tEb()|0)){f[e>>2]=f[e>>2]|8;h=c+28|0;g=f[h>>2]|0;if(!g){j=L5b(52)|0;Hxb(j);f[h>>2]=j;k=j}else k=g;uEb(k,f[d>>2]|0)}if(b[a+24>>0]|0){f[e>>2]=f[e>>2]|16;b[c+32>>0]=1}if(!(b[a+25>>0]|0))return;f[e>>2]=f[e>>2]|32;b[c+33>>0]=1;return}function Ntb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+20|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=kUb(c)|0;if(a>>>0>4294967279)V5b(e);if(a>>>0<11){b[e+11>>0]=a;if(!a)h=e;else{i=e;j=6}}else{k=a+16&-16;l=L5b(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=a;i=l;j=6}if((j|0)==6){Vac(i|0,c|0,a|0)|0;h=i}b[h+a>>0]=0;a=f[g>>2]|0;if((a|0)==497760)jza(g,e);else _5b(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}O5b(f[e>>2]|0);u=d;return}function Otb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|4;g=a+24|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=kUb(c)|0;if(a>>>0>4294967279)V5b(e);if(a>>>0<11){b[e+11>>0]=a;if(!a)h=e;else{i=e;j=6}}else{k=a+16&-16;l=L5b(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=a;i=l;j=6}if((j|0)==6){Vac(i|0,c|0,a|0)|0;h=i}b[h+a>>0]=0;a=f[g>>2]|0;if((a|0)==497760)jza(g,e);else _5b(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}O5b(f[e>>2]|0);u=d;return}function Ptb(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(36)|0;uAb(b);c=b;return c|0}else{b=znb(a,22888,36)|0;uAb(b);xnb(a,b,1512);c=b;return c|0}return 0}function Qtb(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function Rtb(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(40)|0;QAb(b);c=b;return c|0}else{b=znb(a,22904,40)|0;QAb(b);xnb(a,b,1513);c=b;return c|0}return 0}function Stb(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function Ttb(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=Vtb(b,c)|0;u=a;return d|0}function Utb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+16|0;g=f[e>>2]|0;if((g|0)==497760)jza(e,c);else _5b(g,c)|0;c=f[a+8>>2]|0;f[d>>2]=f[d>>2]|2;f[b+24>>2]=c;c=a+16|0;a=f[c>>2]|0;if((a|0)==(pEb()|0))return;f[d>>2]=f[d>>2]|4;d=b+20|0;b=f[d>>2]|0;if(!b){a=L5b(52)|0;pyb(a);f[d>>2]=a;h=a}else h=b;qEb(h,f[c>>2]|0);return}function Vtb(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(28)|0;hBb(b);c=b;return c|0}else{b=znb(a,22920,28)|0;hBb(b);xnb(a,b,1514);c=b;return c|0}return 0}function Wtb(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function Xtb(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(40)|0;DBb(b);c=b;return c|0}else{b=znb(a,22936,40)|0;DBb(b);xnb(a,b,1515);c=b;return c|0}return 0}function Ytb(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function Ztb(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=fub(b,c)|0;u=a;return d|0}function _tb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a>>2]|0;d=b+8|0;f[d>>2]=f[d>>2]|1;e=b+16|0;g=f[e>>2]|0;if((g|0)==497760)jza(e,c);else _5b(g,c)|0;c=a+24|0;a=f[c>>2]|0;if((a|0)==(lEb()|0))return;f[d>>2]=f[d>>2]|2;d=b+20|0;b=f[d>>2]|0;if(!b){a=L5b(48)|0;Zyb(a);f[d>>2]=a;h=a}else h=b;mEb(h,f[c>>2]|0);return}function $tb(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=dub(b,c)|0;u=a;return d|0}function aub(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=bub(b,c)|0;u=a;return d|0}function bub(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(24)|0;GCb(b);c=b;return c|0}else{b=znb(a,22984,24)|0;GCb(b);xnb(a,b,1516);c=b;return c|0}return 0}function cub(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function dub(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(24)|0;YCb(b);c=b;return c|0}else{b=znb(a,23e3,24)|0;YCb(b);xnb(a,b,1517);c=b;return c|0}return 0}function eub(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function fub(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(24)|0;WBb(b);c=b;return c|0}else{b=znb(a,22952,24)|0;WBb(b);xnb(a,b,1518);c=b;return c|0}return 0}function gub(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function hub(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(152)|0;BDb(b);c=b;return c|0}else{b=znb(a,23016,152)|0;BDb(b);xnb(a,b,1519);c=b;return c|0}return 0}function iub(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function jub(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;kub(d,f[a+16>>2]|0,a,b);u=c;return ((f[d>>2]|0)==1?f[d+4>>2]|0:0)|0}function kub(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;h=g;i=f[d>>2]|0;j=(i|0)==0;if(!j)npb(i);k=c+44|0;if(f[k>>2]|0){l=c+40|0;m=f[l>>2]|0;if(m|0){n=m;do{m=n;n=f[n>>2]|0;o=m+8|0;if((b[o+11>>0]|0)<0)O5b(f[o>>2]|0);O5b(m)}while((n|0)!=0)}f[l>>2]=0;l=f[c+36>>2]|0;if(l|0){n=c+32|0;m=0;do{f[(f[n>>2]|0)+(m<<2)>>2]=0;m=m+1|0}while((m|0)!=(l|0))}f[k>>2]=0}k=c+24|0;if(f[k>>2]|0){l=c+20|0;m=f[l>>2]|0;if(m|0){n=m;do{m=n;n=f[n>>2]|0;o=m+8|0;if((b[o+11>>0]|0)<0)O5b(f[o>>2]|0);O5b(m)}while((n|0)!=0)}f[l>>2]=0;l=f[c+16>>2]|0;if(l|0){n=c+12|0;m=0;do{f[(f[n>>2]|0)+(m<<2)>>2]=0;m=m+1|0}while((m|0)!=(l|0))}f[k>>2]=0}Zsb(a,c,e);do if(!(f[a>>2]|0)){k=f[d+12>>2]|0;if(k|0?(kub(h,f[k+16>>2]|0,k,e),k=h,l=f[k>>2]|0,m=f[k+4>>2]|0,k=a,f[k>>2]=l,f[k+4>>2]=m,l|0):0)break;if(_sb(d,e)|0){Zsb(h,c,e);l=h;m=f[l+4>>2]|0;k=a;f[k>>2]=f[l>>2];f[k+4>>2]=m}}while(0);if(j){u=g;return}opb(i);u=g;return}function lub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;kub(e,f[a+16>>2]|0,a,c);if((f[e>>2]|0)!=2){g=0;u=d;return g|0}c=f[e+4>>2]|0;g=b[c+40>>0]|0?c:0;u=d;return g|0}function mub(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=f[a>>2]|0;g=(e|0)==0;if(!g)npb(e);h=a+16|0;i=f[h>>2]|0;j=i+44|0;if(!(f[j>>2]|0))k=i;else{l=i+40|0;m=f[l>>2]|0;if(m|0){n=m;do{m=n;n=f[n>>2]|0;o=m+8|0;if((b[o+11>>0]|0)<0)O5b(f[o>>2]|0);O5b(m)}while((n|0)!=0)}f[l>>2]=0;l=f[i+36>>2]|0;if(l|0){n=i+32|0;i=0;do{f[(f[n>>2]|0)+(i<<2)>>2]=0;i=i+1|0}while((i|0)!=(l|0))}f[j>>2]=0;k=f[h>>2]|0}j=k+24|0;if(!(f[j>>2]|0))p=k;else{l=k+20|0;i=f[l>>2]|0;if(i|0){n=i;do{i=n;n=f[n>>2]|0;m=i+8|0;if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);O5b(i)}while((n|0)!=0)}f[l>>2]=0;l=f[k+16>>2]|0;if(l|0){n=k+12|0;k=0;do{f[(f[n>>2]|0)+(k<<2)>>2]=0;k=k+1|0}while((k|0)!=(l|0))}f[j>>2]=0;p=f[h>>2]|0}j=p+164|0;p=f[j>>2]|0;do if(p){l=j;k=p;a:while(1){n=k;while(1){i=f[n+16>>2]|0;if(i>>>0>=c>>>0){if(i>>>0>c>>>0)break;if((f[n+20>>2]|0)>=(d|0))break}i=f[n+4>>2]|0;if(!i){q=l;break a}else n=i}k=f[n>>2]|0;if(!k){q=n;break}else l=n}if((q|0)!=(j|0)?(l=f[q+16>>2]|0,l>>>0<=c>>>0):0){if(l>>>0>=c>>>0?(f[q+20>>2]|0)>(d|0):0){r=33;break}l=f[q+24>>2]|0;if(l)s=l;else r=33}else r=33}else r=33;while(0);b:do if((r|0)==33){q=f[a+12>>2]|0;if(q|0?(j=mub(q,c,d)|0,j|0):0){s=j;break}do if(nub(a,c,d)|0?(j=(f[h>>2]|0)+164|0,q=f[j>>2]|0,q|0):0){p=j;l=q;c:while(1){q=l;while(1){k=f[q+16>>2]|0;if(k>>>0>=c>>>0){if(k>>>0>c>>>0)break;if((f[q+20>>2]|0)>=(d|0))break}k=f[q+4>>2]|0;if(!k){t=p;break c}else q=k}l=f[q>>2]|0;if(!l){t=q;break}else p=q}if((t|0)!=(j|0)?(p=f[t+16>>2]|0,p>>>0<=c>>>0):0){if(p>>>0>=c>>>0?(f[t+20>>2]|0)>(d|0):0)break;p=f[t+24>>2]|0;if(p|0){s=p;break b}}}while(0);s=0}while(0);if(g)return s|0;opb(e);return s|0}function nub(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+144|0;g=e+140|0;h=e;i=a+4|0;if(!(f[i>>2]|0)){j=0;u=e;return j|0}WDb(h);k=f[i>>2]|0;do if(Dg[f[(f[k>>2]|0)+16>>2]&127](k,f[c+4>>2]|0,d,h)|0){i=f[a+16>>2]|0;l=f[h+120>>2]|0;f[g>>2]=(b[l+11>>0]|0)<0?f[l>>2]|0:l;l=crb(i+140|0,g)|0;if(l)if(f[l+12>>2]|0){m=0;break}m=(krb(a,h)|0)!=0}else m=0;while(0);DDb(h);j=m;u=e;return j|0}function oub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[(f[a+8>>2]|0)+80>>2]|0;e=(a*65535|0)+c|0;g=f[d+64>>2]|0;if(!g)return 0;h=g+-1|0;i=(h&g|0)==0;if(!i)if(e>>>0<g>>>0)j=e;else j=(e>>>0)%(g>>>0)|0;else j=h&e;k=f[(f[d+60>>2]|0)+(j<<2)>>2]|0;if(!k)return 0;d=f[k>>2]|0;if(!d)return 0;a:do if(i){k=d;while(1){l=f[k+4>>2]|0;m=(e|0)==(l|0);if(!(m|(l&h|0)==(j|0))){n=23;break}if((m?(f[k+8>>2]|0)==(a|0):0)?(f[k+12>>2]|0)==(c|0):0){o=k;break a}k=f[k>>2]|0;if(!k){n=23;break}}if((n|0)==23)return 0}else{k=d;while(1){m=f[k+4>>2]|0;if((e|0)==(m|0)){if((f[k+8>>2]|0)==(a|0)?(f[k+12>>2]|0)==(c|0):0){o=k;break a}}else{if(m>>>0<g>>>0)p=m;else p=(m>>>0)%(g>>>0)|0;if((p|0)!=(j|0)){n=23;break}}k=f[k>>2]|0;if(!k){n=23;break}}if((n|0)==23)return 0}while(0);n=f[o+16>>2]|0;if(!n)return 0;else return (b[n+40>>0]|0?0:n)|0;return 0}function pub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;g=(f[(f[a+8>>2]|0)+80>>2]|0)+20|0;h=(b[c+11>>0]|0)<0?f[c>>2]|0:c;f[e>>2]=a;f[e+4>>2]=h;h=qub(g,e)|0;if(!h){u=d;return 0}else{u=d;return (b[h+40>>0]|0?0:h)|0}return 0}function qub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[c>>2]|0;e=d*65535|0;g=f[c+4>>2]|0;c=b[g>>0]|0;h=d;if(!(c<<24>>24))i=0;else{d=g;j=0;k=c;while(1){c=(j*5|0)+(k<<24>>24)|0;d=d+1|0;k=b[d>>0]|0;if(!(k<<24>>24)){i=c;break}else j=c}}j=i+e|0;e=f[a+4>>2]|0;if(!e){l=0;return l|0}i=e+-1|0;k=(i&e|0)==0;if(!k)if(j>>>0<e>>>0)m=j;else m=(j>>>0)%(e>>>0)|0;else m=i&j;d=f[(f[a>>2]|0)+(m<<2)>>2]|0;if(!d){l=0;return l|0}a=f[d>>2]|0;if(!a){l=0;return l|0}a:do if(k){d=a;while(1){c=f[d+4>>2]|0;n=(j|0)==(c|0);if(!(n|(c&i|0)==(m|0))){l=0;o=24;break}if((n?(f[d+8>>2]|0)==(h|0):0)?(gTb(f[d+12>>2]|0,g)|0)==0:0){p=d;break a}d=f[d>>2]|0;if(!d){l=0;o=24;break}}if((o|0)==24)return l|0}else{d=a;while(1){n=f[d+4>>2]|0;if((j|0)==(n|0)){if((f[d+8>>2]|0)==(h|0)?(gTb(f[d+12>>2]|0,g)|0)==0:0){p=d;break a}}else{if(n>>>0<e>>>0)q=n;else q=(n>>>0)%(e>>>0)|0;if((q|0)!=(m|0)){l=0;o=24;break}}d=f[d>>2]|0;if(!d){l=0;o=24;break}}if((o|0)==24)return l|0}while(0);l=f[p+16>>2]|0;return l|0}function rub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;Krb(e,f[(f[a+8>>2]|0)+80>>2]|0,a,c,2);if(!(f[e>>2]|0)){g=0;u=d;return g|0}c=f[e+4>>2]|0;g=b[c+40>>0]|0?0:c;u=d;return g|0}function sub(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;Krb(d,f[(f[a+8>>2]|0)+80>>2]|0,a,b,5);u=c;return ((f[d>>2]|0)==0?0:f[d+4>>2]|0)|0}function tub(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[(f[a+8>>2]|0)+80>>2]|0;d=(a*65535|0)+b|0;e=f[c+84>>2]|0;if(!e){g=0;return g|0}h=e+-1|0;i=(h&e|0)==0;if(!i)if(d>>>0<e>>>0)j=d;else j=(d>>>0)%(e>>>0)|0;else j=h&d;k=f[(f[c+80>>2]|0)+(j<<2)>>2]|0;if(!k){g=0;return g|0}c=f[k>>2]|0;if(!c){g=0;return g|0}a:do if(i){k=c;while(1){l=f[k+4>>2]|0;m=(d|0)==(l|0);if(!(m|(l&h|0)==(j|0))){g=0;n=22;break}if((m?(f[k+8>>2]|0)==(a|0):0)?(f[k+12>>2]|0)==(b|0):0){o=k;break a}k=f[k>>2]|0;if(!k){g=0;n=22;break}}if((n|0)==22)return g|0}else{k=c;while(1){m=f[k+4>>2]|0;if((d|0)==(m|0)){if((f[k+8>>2]|0)==(a|0)?(f[k+12>>2]|0)==(b|0):0){o=k;break a}}else{if(m>>>0<e>>>0)p=m;else p=(m>>>0)%(e>>>0)|0;if((p|0)!=(j|0)){g=0;n=22;break}}k=f[k>>2]|0;if(!k){g=0;n=22;break}}if((n|0)==22)return g|0}while(0);g=f[o+16>>2]|0;return g|0}function uub(a,b){a=a|0;b=b|0;return vub(f[(f[a+8>>2]|0)+80>>2]|0,a,b)|0}function vub(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+48|0;g=e;h=e+36|0;i=e+24|0;j=e+12|0;k=c;l=(k*65535|0)+d|0;m=f[a+84>>2]|0;a:do if(m|0){n=m+-1|0;o=(n&m|0)==0;if(!o)if(l>>>0<m>>>0)p=l;else p=(l>>>0)%(m>>>0)|0;else p=n&l;q=f[(f[a+80>>2]|0)+(p<<2)>>2]|0;if(q|0?(r=f[q>>2]|0,r|0):0){b:do if(o){q=r;while(1){s=f[q+4>>2]|0;t=(l|0)==(s|0);if(!(t|(s&n|0)==(p|0)))break a;if((t?(f[q+8>>2]|0)==(c|0):0)?(f[q+12>>2]|0)==(d|0):0){v=q;break b}q=f[q>>2]|0;if(!q)break a}}else{q=r;while(1){t=f[q+4>>2]|0;if((l|0)==(t|0)){if((f[q+8>>2]|0)==(c|0)?(f[q+12>>2]|0)==(d|0):0){v=q;break b}}else{if(t>>>0<m>>>0)w=t;else w=(t>>>0)%(m>>>0)|0;if((w|0)!=(p|0))break a}q=f[q>>2]|0;if(!q)break a}}while(0);r=f[v+16>>2]|0;if(r|0){x=r;u=e;return x|0}}}while(0);v=a+144|0;npb(v);p=a+100|0;w=a+104|0;a=f[w>>2]|0;c:do if(a){m=a+-1|0;r=(m&a|0)==0;if(!r)if(l>>>0<a>>>0)y=l;else y=(l>>>0)%(a>>>0)|0;else y=m&l;n=f[(f[p>>2]|0)+(y<<2)>>2]|0;if((n|0)!=0?(o=f[n>>2]|0,(o|0)!=0):0){d:do if(r){n=o;while(1){q=f[n+4>>2]|0;t=(q|0)==(l|0);if(!(t|(q&m|0)==(y|0))){z=42;break c}if((t?(f[n+8>>2]|0)==(c|0):0)?(f[n+12>>2]|0)==(d|0):0){A=n;break d}n=f[n>>2]|0;if(!n){z=42;break c}}}else{n=o;while(1){t=f[n+4>>2]|0;if((t|0)==(l|0)){if((f[n+8>>2]|0)==(c|0)?(f[n+12>>2]|0)==(d|0):0){A=n;break d}}else{if(t>>>0<a>>>0)B=t;else B=(t>>>0)%(a>>>0)|0;if((B|0)!=(y|0)){z=42;break c}}n=f[n>>2]|0;if(!n){z=42;break c}}}while(0);o=f[A+16>>2]|0;opb(v);if(o|0){x=o;u=e;return x|0}}else z=42}else z=42;while(0);if((z|0)==42)opb(v);npb(v);A=f[w>>2]|0;e:do if(A){w=A+-1|0;y=(w&A|0)==0;if(!y)if(l>>>0<A>>>0)C=l;else C=(l>>>0)%(A>>>0)|0;else C=w&l;B=f[(f[p>>2]|0)+(C<<2)>>2]|0;if((B|0)!=0?(a=f[B>>2]|0,(a|0)!=0):0){f:do if(y){B=a;while(1){o=f[B+4>>2]|0;m=(o|0)==(l|0);if(!(m|(o&w|0)==(C|0))){z=65;break e}if((m?(f[B+8>>2]|0)==(c|0):0)?(f[B+12>>2]|0)==(d|0):0){D=B;break f}B=f[B>>2]|0;if(!B){z=65;break e}}}else{B=a;while(1){m=f[B+4>>2]|0;if((m|0)==(l|0)){if((f[B+8>>2]|0)==(c|0)?(f[B+12>>2]|0)==(d|0):0){D=B;break f}}else{if(m>>>0<A>>>0)E=m;else E=(m>>>0)%(A>>>0)|0;if((E|0)!=(C|0)){z=65;break e}}B=f[B>>2]|0;if(!B){z=65;break e}}}while(0);a=f[D+16>>2]|0;if(a)F=a;else z=65}else z=65}else z=65;while(0);if((z|0)==65){z=f[c>>2]|0;if((b[z+11>>0]|0)<0)G=f[z>>2]|0;else G=z;f[g>>2]=G;f[g+4>>2]=d;gSb(h,459379,g);if((f[213364]|0)!=2){f[g>>2]=135812;f[g+4>>2]=47;b[g+8>>0]=0;Gpb(853456,g);hpb(g)}G=f[(f[213365]|0)+16>>2]|0;z=L5b(20)|0;f[g>>2]=z;D=G+112|0;C=f[D>>2]|0;if((C|0)==(f[G+116>>2]|0))HO(G+108|0,g);else{f[C>>2]=z;f[D>>2]=(f[D>>2]|0)+4}D=f[g>>2]|0;z=L5b(12)|0;X5b(z,h);f[g>>2]=z;C=G+76|0;E=f[C>>2]|0;A=G+80|0;if((E|0)==(f[A>>2]|0))Rqb(G+72|0,g);else{f[E>>2]=z;f[C>>2]=(f[C>>2]|0)+4}f[D>>2]=f[g>>2];eua(j,f[c+4>>2]|0,489392);Ccb(i,j,h);z=L5b(12)|0;X5b(z,i);f[g>>2]=z;E=f[C>>2]|0;if((E|0)==(f[A>>2]|0))Rqb(G+72|0,g);else{f[E>>2]=z;f[C>>2]=(f[C>>2]|0)+4}f[D+4>>2]=f[g>>2];if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);f[D+8>>2]=d;f[D+12>>2]=c;c=pEb()|0;f[D+16>>2]=c;f[g>>2]=k;f[g+4>>2]=d;f[i>>2]=D;Oqb(p,g,i)|0;if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);F=D}opb(v);x=F;u=e;return x|0}function wub(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a+56>>2]|0;if((c|0)<=0){d=0;return d|0}e=f[a+60>>2]|0;a=0;while(1){g=e+(a<<3)|0;if((f[g>>2]|0)<=(b|0)?(f[e+(a<<3)+4>>2]|0)>(b|0):0){d=g;h=6;break}a=a+1|0;if((a|0)>=(c|0)){d=0;h=6;break}}if((h|0)==6)return d|0;return 0}function xub(a){a=a|0;var c=0;if((f[a+32>>2]|0)!=11){c=0;return c|0}c=(b[(f[(f[a+60>>2]|0)+16>>2]|0)+51>>0]|0)!=0;return c|0}function yub(a){a=a|0;var c=0,d=0,e=0;if((f[a+36>>2]|0)!=3){c=0;return c|0}if(((f[a+32>>2]|0)+-9|0)>>>0<=3){c=0;return c|0}d=f[a+68>>2]|0;e=(d|0)==0;if((f[(f[a+24>>2]|0)+64>>2]|0)==2){if(e){c=0;return c|0}c=(b[d+56>>0]|0)!=0;return c|0}if(e){c=1;return c|0}if(!(f[d+24>>2]&2)){c=1;return c|0}c=(b[d+56>>0]|0)!=0;return c|0}function zub(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=136312;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(h);f[b>>2]=0;return}function Aub(a){a=a|0;zub(a);O5b(a);return}function Bub(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Cub(a,b){a=a|0;b=b|0;a=L5b(32)|0;cEb(a);if(!b)return a|0;dEb(b,a);return a|0}function Dub(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function Eub(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+28|0;c=f[a+20>>2]|0;while(1){if((c|0)<=0){d=1;e=4;break}c=c+-1|0;a=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){d=0;e=4;break}}if((e|0)==4)return d|0;return 0}function Fub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=c+4|0;e=c+20|0;g=c+44|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=c+32|0;m=c+12|0;n=c+28|0;o=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[e>>2]=q;f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=_nb(c,t)|0;f[e>>2]=q;if((q+-1|0)>>>0<127){r=q;s=6}else u=q}if((s|0)==6){s=0;if((r|0)==10){q=f[g>>2]|0;f[g>>2]=q+-1;if((q|0)<=0){v=0;s=29;break}while(1){q=f[i>>2]|0;do if(q){a=f[k>>2]|0;p=f[q>>2]|0;if((a|0)>=(p|0))if((p|0)==(f[j>>2]|0)){w=p;s=13;break}else{x=p;y=q;s=14;break}else{f[k>>2]=a+1;z=f[q+4+(a<<2)>>2]|0;break}}else{w=f[j>>2]|0;s=13}while(0);if((s|0)==13){s=0;cpb(h,w+1|0);q=f[i>>2]|0;x=f[q>>2]|0;y=q;s=14}if((s|0)==14){s=0;f[y>>2]=x+1;q=$Db(0,f[h>>2]|0)|0;a=f[i>>2]|0;p=f[k>>2]|0;f[k>>2]=p+1;f[a+4+(p<<2)>>2]=q;z=q}q=Jnb(c)|0;if(!(JDb(z,c)|0)){v=0;s=29;break a}if(!(Pnb(c,q)|0)){v=0;s=29;break a}A=f[c>>2]|0;B=f[d>>2]|0;if(A>>>0>=B>>>0)break;if((b[A>>0]|0)!=10)break;f[c>>2]=A+1}f[g>>2]=(f[g>>2]|0)+1;if((A|0)!=(B|0))continue;if(f[l>>2]|0){s=23;break}if((f[m>>2]|0)==(f[n>>2]|0)){s=23;break}else continue}else u=r}if((u|0)==0|(u&7|0)==4){v=1;s=29;break}q=f[o>>2]|0;if(!(q&1))C=hBa(o)|0;else C=q&-2;if(!(ZPb(c,u,C)|0)){v=0;s=29;break}}if((s|0)==23){f[e>>2]=0;b[c+24>>0]=1;v=1;return v|0}else if((s|0)==29)return v|0;return 0}function Gub(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+20>>2]|0;if(!b)c=0;else{d=a+28|0;e=0;g=b;while(1){h=KDb(f[(f[d>>2]|0)+4+(e<<2)>>2]|0)|0;if(h>>>0<128)i=1;else i=iob(h)|0;j=h+g+i|0;e=e+1|0;if((e|0)==(b|0)){c=j;break}else g=j}}g=f[a+4>>2]|0;if(!(g&1)){k=c;l=a+12|0;f[l>>2]=k;return k|0}k=(dQb(g&-2)|0)+c|0;l=a+12|0;f[l>>2]=k;return k|0}function Hub(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eqb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function Iub(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function Jub(a){a=a|0;return f[a+12>>2]|0}function Kub(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+20>>2]|0;if(!c)e=d;else{g=a+28|0;h=0;i=d;while(1){d=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=10;j=i+1|0;k=f[d+12>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=j;q=k}b[p>>0]=q;m=li[f[(f[d>>2]|0)+68>>2]&511](d,0,p+1|0)|0;h=h+1|0;if((h|0)==(c|0)){e=m;break}else i=m}}i=f[a+4>>2]|0;if(!(i&1)){r=e;return r|0}r=bQb(i&-2,e)|0;return r|0}function Lub(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Mub(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(1097);c=T6b(b,23288,22648,0)|0;if(!c){cOb(b,a);return}ZDb(a+16|0,c+16|0);b=f[c+4>>2]|0;if(!(b&1))return;LPb(b&-2,a+4|0);return}function Nub(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Oub(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213374];f[a+4>>2]=f[213375];u=c;return}function Pub(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+48|0;c=a+24|0;d=a;e=a+36|0;if((f[213372]|0)!=2){f[c>>2]=135812;f[c+4>>2]=54;b[c+8>>0]=0;Gpb(853488,c);hpb(c)}g=drb()|0;h=L5b(48)|0;f[c>>2]=h;f[c+8>>2]=-2147483600;f[c+4>>2]=32;i=h;j=459404;k=i+32|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+32>>0]=0;h=hrb(g,c)|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if(!h){zpb(d,3,459437,115);xpb(e,vpb(d,459532)|0);Apb(d)}d=h+40|0;h=f[d>>2]|0;f[213374]=h;e=pIb(h,497784,136412,8,-1,-1,32,4,-1)|0;f[213375]=e;e=(f[d>>2]|0)+88|0;f[213376]=e;h=pIb(e,497824,136416,8,-1,-1,140,4,-1)|0;f[213377]=h;h=(f[d>>2]|0)+176|0;f[213378]=h;e=pIb(h,497976,136464,8,-1,-1,152,4,-1)|0;f[213379]=e;e=f[(f[213378]|0)+44>>2]|0;f[213380]=e;h=pIb(e,498136,136504,8,-1,-1,24,4,-1)|0;f[213381]=h;h=(f[(f[213378]|0)+44>>2]|0)+88|0;f[213382]=h;e=pIb(h,498168,136512,8,-1,-1,24,4,-1)|0;f[213383]=e;e=(f[d>>2]|0)+264|0;f[213384]=e;h=pIb(e,498200,136520,8,-1,-1,56,4,-1)|0;f[213385]=h;h=f[(f[213384]|0)+52>>2]|0;f[213386]=h;f[213387]=h+32;h=(f[d>>2]|0)+352|0;f[213388]=h;e=pIb(h,498264,136560,8,-1,-1,24,4,-1)|0;f[213389]=e;e=(f[d>>2]|0)+440|0;f[213390]=e;h=pIb(e,498296,136568,8,-1,-1,40,4,-1)|0;f[213391]=h;h=(f[d>>2]|0)+528|0;f[213392]=h;e=pIb(h,498344,136580,8,-1,-1,28,4,-1)|0;f[213393]=e;e=(f[d>>2]|0)+616|0;f[213394]=e;h=pIb(e,498384,136592,8,-1,-1,40,4,-1)|0;f[213395]=h;h=(f[d>>2]|0)+704|0;f[213396]=h;e=pIb(h,498432,136604,8,-1,-1,36,4,-1)|0;f[213397]=e;e=(f[d>>2]|0)+792|0;f[213398]=e;h=pIb(e,498480,136628,24,-1,4,80,20,-1)|0;f[213399]=h;f[213400]=f[(f[213398]|0)+52>>2];h=(f[d>>2]|0)+880|0;f[213401]=h;e=pIb(h,498568,136688,24,-1,4,52,20,-1)|0;f[213402]=e;e=(f[d>>2]|0)+968|0;f[213403]=e;h=pIb(e,498632,136708,24,-1,4,60,20,-1)|0;f[213404]=h;h=f[(f[213403]|0)+52>>2]|0;f[213405]=h;f[213406]=h+32;h=(f[d>>2]|0)+1056|0;f[213407]=h;e=pIb(h,498704,136736,24,-1,4,48,20,-1)|0;f[213408]=e;e=(f[d>>2]|0)+1144|0;f[213409]=e;h=pIb(e,498760,136740,24,-1,4,52,20,-1)|0;f[213410]=h;h=(f[d>>2]|0)+1232|0;f[213411]=h;e=pIb(h,498824,136752,24,-1,4,52,20,-1)|0;f[213412]=e;e=(f[d>>2]|0)+1320|0;f[213413]=e;h=pIb(e,498888,136760,24,-1,4,52,20,-1)|0;f[213414]=h;h=(f[d>>2]|0)+1408|0;f[213415]=h;e=pIb(h,498952,136768,24,-1,4,52,20,-1)|0;f[213416]=e;e=(f[d>>2]|0)+1496|0;f[213417]=e;h=pIb(e,499016,136776,8,-1,-1,72,4,-1)|0;f[213418]=h;h=f[(f[213417]|0)+44>>2]|0;f[213419]=h;e=pIb(h,499096,136804,8,-1,-1,24,4,-1)|0;f[213420]=e;e=(f[d>>2]|0)+1584|0;f[213421]=e;h=pIb(e,499128,136812,8,-1,-1,32,4,-1)|0;f[213422]=h;h=f[(f[213421]|0)+44>>2]|0;f[213423]=h;e=pIb(h,499168,136816,8,-1,-1,72,4,-1)|0;f[213424]=e;e=(f[d>>2]|0)+1672|0;f[213425]=e;d=pIb(e,499248,136836,8,-1,-1,32,4,-1)|0;f[213426]=d;d=f[(f[213425]|0)+44>>2]|0;f[213427]=d;e=pIb(d,499288,136840,8,-1,-1,44,4,-1)|0;f[213428]=e;u=a;return}function Qub(){var a=0,c=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,459437);if((f[213371]|0)!=2){f[c>>2]=135812;f[c+4>>2]=55;b[c+8>>0]=0;Gpb(853484,c);hpb(c)}grb(459561,5298);SNb(459404,1520);spb(56);u=a;return}function Rub(){var a=0,c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,459437);f[124446]=136312;f[124447]=0;f[124448]=0;f[124449]=0;f[124450]=0;f[124451]=0;f[124452]=0;f[124453]=0;b[497816]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124456]=136864;f[124457]=0;e=497832;g=e+112|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[124486]=497760;f[124487]=497760;f[124488]=497760;f[124489]=0;f[124490]=0;b[497968]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124494]=136972;f[124495]=0;Nac(497984,0,136)|0;f[124530]=497760;f[124531]=0;b[498128]=1;f[124534]=137080;f[124535]=0;f[124536]=0;f[124537]=0;f[124538]=0;f[124539]=0;b[498160]=1;f[124542]=137188;f[124543]=0;f[124544]=0;f[124545]=0;f[124546]=0;f[124547]=0;b[498192]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124550]=137296;f[124551]=0;f[124552]=0;f[124553]=0;f[124554]=497760;f[124555]=497760;f[124556]=497760;f[124557]=497760;f[124558]=497760;f[124559]=0;h=498240;f[h>>2]=0;f[h+4>>2]=0;f[124562]=1;f[124563]=1;b[498256]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124566]=137404;f[124567]=0;f[124568]=0;f[124569]=0;f[124570]=497760;f[124571]=0;b[498288]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124574]=137512;f[124575]=0;f[124576]=0;f[124577]=0;f[124578]=0;f[124579]=0;f[124580]=0;f[124581]=0;f[124582]=497760;f[124583]=0;b[498336]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124586]=137620;f[124587]=0;f[124588]=0;f[124589]=0;f[124590]=497760;f[124591]=0;f[124592]=0;b[498376]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124596]=137728;f[124597]=0;f[124598]=0;f[124599]=0;f[124600]=0;f[124601]=0;f[124602]=0;f[124603]=0;f[124604]=497760;f[124605]=0;b[498424]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124608]=137836;f[124609]=0;f[124610]=0;f[124611]=0;f[124612]=497760;f[124613]=497760;f[124614]=497760;f[124615]=0;d[249232]=0;b[498472]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124620]=137944;sQb(498484);f[124625]=0;f[124626]=0;f[124627]=0;f[124628]=0;f[124629]=0;f[124630]=0;f[124631]=0;f[124632]=497760;f[124633]=497760;f[124634]=497760;f[124635]=497760;f[124636]=497760;h=498548;f[h>>2]=0;f[h+4>>2]=0;f[124639]=1;b[498560]=1;f[124642]=138052;sQb(498572);f[124647]=0;f[124648]=0;f[124649]=0;f[124650]=0;f[124651]=0;f[124652]=0;f[124653]=0;f[124654]=0;b[498624]=1;f[124658]=138160;sQb(498636);e=498652;g=e+40|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));b[498696]=1;f[124676]=138268;sQb(498708);f[124681]=0;f[124682]=0;f[124683]=0;f[124684]=0;f[124685]=0;f[124686]=0;f[124687]=0;b[498752]=1;f[124690]=138376;sQb(498764);f[124695]=0;f[124696]=0;f[124697]=0;f[124698]=0;f[124699]=0;f[124700]=0;f[124701]=0;d[249404]=0;b[498816]=1;f[124706]=138484;sQb(498828);f[124711]=0;f[124712]=0;f[124713]=0;f[124714]=0;f[124715]=0;f[124716]=0;f[124717]=0;b[498872]=0;b[498880]=1;f[124722]=138592;sQb(498892);f[124727]=0;f[124728]=0;f[124729]=0;f[124730]=0;f[124731]=0;f[124732]=0;f[124733]=0;b[498936]=0;b[498944]=1;f[124738]=138700;sQb(498956);f[124743]=0;f[124744]=0;f[124745]=0;f[124746]=0;f[124747]=0;f[124748]=0;f[124749]=0;b[499e3]=0;b[499008]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124754]=138808;f[124755]=0;f[124756]=0;f[124757]=0;f[124758]=0;f[124759]=0;f[124760]=0;f[124761]=0;f[124762]=497760;f[124763]=497760;f[124764]=497760;f[124766]=0;f[124767]=0;f[124768]=0;f[124769]=0;f[124770]=0;f[124771]=0;b[499088]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124774]=138916;f[124775]=0;f[124776]=0;f[124777]=0;f[124778]=497760;b[499116]=0;b[499120]=1;f[124782]=139024;f[124783]=0;f[124784]=0;f[124785]=0;f[124786]=0;f[124787]=0;f[124788]=0;f[124789]=0;b[499160]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[124792]=139132;f[124793]=0;f[124800]=0;f[124801]=0;f[124802]=0;f[124804]=0;f[124805]=0;f[124806]=0;f[124807]=0;f[124794]=0;f[124795]=0;f[124796]=0;f[124797]=0;f[124798]=0;f[124808]=497760;f[124809]=497760;b[499240]=1;f[124812]=139240;f[124813]=0;f[124814]=0;f[124815]=0;f[124816]=0;f[124817]=0;f[124818]=0;f[124819]=0;b[499280]=1;if((f[213345]|0)==2){f[124822]=139348;f[124823]=0;f[124824]=0;f[124825]=0;f[124826]=0;f[124827]=0;f[124828]=0;f[124830]=497760;i=499324;j=i;f[j>>2]=0;k=i+4|0;l=k;f[l>>2]=0;b[499336]=1;f[124489]=498480;f[124490]=499128;f[124531]=498568;f[124559]=498632;f[124571]=498704;f[124583]=498760;f[124591]=498824;f[124605]=498888;f[124615]=498952;u=a;return}f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c);f[124822]=139348;f[124823]=0;f[124824]=0;f[124825]=0;f[124826]=0;f[124827]=0;f[124828]=0;f[124830]=497760;i=499324;j=i;f[j>>2]=0;k=i+4|0;l=k;f[l>>2]=0;b[499336]=1;f[124489]=498480;f[124490]=499128;f[124531]=498568;f[124559]=498632;f[124571]=498704;f[124583]=498760;f[124591]=498824;f[124605]=498888;f[124615]=498952;u=a;return}function Sub(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[213373]|0)!=2){f[c>>2]=135812;f[c+4>>2]=53;b[c+8>>0]=0;Gpb(853492,c);hpb(c)}WNb(f[213374]|0,497784);WNb(f[213376]|0,497824);WNb(f[213378]|0,497976);WNb(f[213380]|0,498136);WNb(f[213382]|0,498168);WNb(f[213384]|0,498200);WNb(f[213388]|0,498264);WNb(f[213390]|0,498296);WNb(f[213392]|0,498344);WNb(f[213394]|0,498384);WNb(f[213396]|0,498432);WNb(f[213398]|0,498480);WNb(f[213401]|0,498568);WNb(f[213403]|0,498632);WNb(f[213407]|0,498704);WNb(f[213409]|0,498760);WNb(f[213411]|0,498824);WNb(f[213413]|0,498888);WNb(f[213415]|0,498952);WNb(f[213417]|0,499016);WNb(f[213419]|0,499096);WNb(f[213421]|0,499128);WNb(f[213423]|0,499168);WNb(f[213425]|0,499248);WNb(f[213427]|0,499288);u=a;return}function Tub(){var a=0;if(b[497816]|0){b[497816]=0;bi[f[f[124446]>>2]&2047](497784)}a=f[213375]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[497968]|0){b[497968]=0;bi[f[f[124456]>>2]&2047](497824)}a=f[213377]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498128]|0){b[498128]=0;bi[f[f[124494]>>2]&2047](497976)}a=f[213379]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498160]|0){b[498160]=0;bi[f[f[124534]>>2]&2047](498136)}a=f[213381]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498192]|0){b[498192]=0;bi[f[f[124542]>>2]&2047](498168)}a=f[213383]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498256]|0){b[498256]=0;bi[f[f[124550]>>2]&2047](498200)}a=f[213385]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498288]|0){b[498288]=0;bi[f[f[124566]>>2]&2047](498264)}a=f[213389]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498336]|0){b[498336]=0;bi[f[f[124574]>>2]&2047](498296)}a=f[213391]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498376]|0){b[498376]=0;bi[f[f[124586]>>2]&2047](498344)}a=f[213393]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498424]|0){b[498424]=0;bi[f[f[124596]>>2]&2047](498384)}a=f[213395]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498472]|0){b[498472]=0;bi[f[f[124608]>>2]&2047](498432)}a=f[213397]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498560]|0){b[498560]=0;bi[f[f[124620]>>2]&2047](498480)}a=f[213399]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498624]|0){b[498624]=0;bi[f[f[124642]>>2]&2047](498568)}a=f[213402]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498696]|0){b[498696]=0;bi[f[f[124658]>>2]&2047](498632)}a=f[213404]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498752]|0){b[498752]=0;bi[f[f[124676]>>2]&2047](498704)}a=f[213408]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498816]|0){b[498816]=0;bi[f[f[124690]>>2]&2047](498760)}a=f[213410]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498880]|0){b[498880]=0;bi[f[f[124706]>>2]&2047](498824)}a=f[213412]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[498944]|0){b[498944]=0;bi[f[f[124722]>>2]&2047](498888)}a=f[213414]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[499008]|0){b[499008]=0;bi[f[f[124738]>>2]&2047](498952)}a=f[213416]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[499088]|0){b[499088]=0;bi[f[f[124754]>>2]&2047](499016)}a=f[213418]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[499120]|0){b[499120]=0;bi[f[f[124774]>>2]&2047](499096)}a=f[213420]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[499160]|0){b[499160]=0;bi[f[f[124782]>>2]&2047](499128)}a=f[213422]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[499240]|0){b[499240]=0;bi[f[f[124792]>>2]&2047](499168)}a=f[213424]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[499280]|0){b[499280]=0;bi[f[f[124812]>>2]&2047](499248)}a=f[213426]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[499336]|0){b[499336]=0;bi[f[f[124822]>>2]&2047](499288)}a=f[213428]|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Uub(a){a=a|0;var c=0,d=0;f[a>>2]=139348;c=a+32|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(d);f[c>>2]=0;return}function Vub(a){a=a|0;Uub(a);O5b(a);return}function Wub(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Xub(a,b){a=a|0;b=b|0;a=L5b(44)|0;kvb(a);if(!b)return a|0;lvb(b,a);return a|0}function Yub(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;do if((d&14|0?(e=a+36|0,f[e>>2]=0,f[e+4>>2]=0,d&2|0):0)?(e=f[a+32>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);f[a+16>>2]=0;f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function Zub(a){a=a|0;return 1}function _ub(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=c+4|0;e=c+20|0;g=a+16|0;h=a+20|0;i=a+24|0;j=a+8|0;k=a+32|0;l=a+36|0;m=a+40|0;n=c+32|0;o=c+12|0;p=c+28|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[e>>2]=s;f[c>>2]=a+1;t=s;u=6}else{v=s;u=5}}else{v=0;u=5}if((u|0)==5){u=0;s=_nb(c,v)|0;f[e>>2]=s;if((s+-1|0)>>>0<127){t=s;u=6}else{w=s;u=53}}b:do if((u|0)==6){u=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{x=1;u=59;break a;break}case 10:{s=f[c>>2]|0;if(s>>>0<(f[d>>2]|0)>>>0?(a=b[s>>0]|0,a<<24>>24>-1):0){f[c>>2]=s+1;y=a&255}else{a=Znb(c)|0;if((a|0)>-1)y=a;else{x=0;u=59;break a}}a=Gnb(c,y)|0;if((Qnb(c)|0)>0)do{s=f[c>>2]|0;if(s>>>0<(f[d>>2]|0)>>>0){r=b[s>>0]|0;z=r&255;if(r<<24>>24>-1){f[c>>2]=s+1;A=z}else{B=z;u=16}}else{B=0;u=16}if((u|0)==16){u=0;z=Knb(c,B)|0;s=J;if((s|0)>-1|(s|0)==-1&z>>>0>4294967295)A=z;else{x=0;u=59;break a}}z=f[g>>2]|0;if((z|0)==(f[h>>2]|0)){nza(g,z+1|0);C=f[g>>2]|0}else C=z;z=f[i>>2]|0;f[g>>2]=C+1;f[z+4+(C<<2)>>2]=A}while((Qnb(c)|0)>0);Hnb(c,a);break}case 8:{if(!(PEa(1,10,c,g)|0)){x=0;u=59;break a}break}default:{D=t;break b}}z=f[c>>2]|0;if(z>>>0>=(f[d>>2]|0)>>>0)continue a;if((b[z>>0]|0)!=18)continue a;f[c>>2]=z+1;u=26;break}case 2:{switch(t|0){case 0:{x=1;u=59;break a;break}case 18:{u=26;break}default:{D=t;break b}}break}case 3:{switch(t|0){case 0:{x=1;u=59;break a;break}case 24:break;default:{D=t;break b}}E=f[c>>2]|0;F=f[d>>2]|0;u=34;break}case 4:{switch(t|0){case 0:{x=1;u=59;break a;break}case 32:break;default:{D=t;break b}}G=f[c>>2]|0;H=f[d>>2]|0;break}default:{w=t;u=53;break b}}if((u|0)==26){u=0;f[j>>2]=f[j>>2]|2;z=f[k>>2]|0;if((z|0)==497760){jza(k,497760);I=f[k>>2]|0}else I=z;if(!(fqb(c,I)|0)){x=0;u=59;break a}z=f[c>>2]|0;s=f[d>>2]|0;if(z>>>0>=s>>>0)continue a;if((b[z>>0]|0)!=24)continue a;r=z+1|0;f[c>>2]=r;E=r;F=s;u=34}if((u|0)==34){u=0;f[j>>2]=f[j>>2]|4;if(E>>>0<F>>>0){s=b[E>>0]|0;r=s&255;if(s<<24>>24>-1){s=E+1|0;f[c>>2]=s;K=r;L=s;M=F}else{N=r;u=37}}else{N=0;u=37}if((u|0)==37){u=0;r=Knb(c,N)|0;s=J;if(!((s|0)>-1|(s|0)==-1&r>>>0>4294967295)){x=0;u=59;break a}K=r;L=f[c>>2]|0;M=f[d>>2]|0}f[l>>2]=K;if(L>>>0>=M>>>0)continue a;if((b[L>>0]|0)!=32)continue a;r=L+1|0;f[c>>2]=r;G=r;H=M}f[j>>2]=f[j>>2]|8;if(G>>>0<H>>>0){r=b[G>>0]|0;s=r&255;if(r<<24>>24>-1){r=G+1|0;f[c>>2]=r;O=s;P=r;Q=H}else{R=s;u=47}}else{R=0;u=47}if((u|0)==47){u=0;s=Knb(c,R)|0;r=J;if(!((r|0)>-1|(r|0)==-1&s>>>0>4294967295)){x=0;u=59;break a}O=s;P=f[c>>2]|0;Q=f[d>>2]|0}f[m>>2]=O;if((P|0)!=(Q|0))continue a;if(f[n>>2]|0){u=52;break a}if((f[o>>2]|0)==(f[p>>2]|0)){u=52;break a}else continue a}while(0);if((u|0)==53){u=0;if(!w){x=1;u=59;break}else D=w}if((D&7|0)==4){x=1;u=59;break}s=f[q>>2]|0;if(!(s&1))S=hBa(q)|0;else S=s&-2;if(!(ZPb(c,D,S)|0)){x=0;u=59;break}}if((u|0)==52){f[e>>2]=0;b[c+24>>0]=1;x=1;return x|0}else if((u|0)==59)return x|0;return 0}function $ub(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=a+8|0;d=f[c>>2]|0;if(d&14){if(!(d&2)){e=0;g=d}else{h=f[a+32>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&4)){n=e;o=g}else{l=f[a+36>>2]|0;if((l|0)>=0)if(l>>>0<128){p=2;q=g}else{k=(iob(l)|0)+1|0;p=k;q=f[c>>2]|0}else{p=11;q=g}n=p+e|0;o=q}if(!(o&8))r=n;else{o=f[a+40>>2]|0;if((o|0)>=0)if(o>>>0<128)s=2;else s=(iob(o)|0)+1|0;else s=11;r=s+n|0}}else r=0;n=f[a+16>>2]|0;if(n){s=a+24|0;o=0;q=0;do{e=f[(f[s>>2]|0)+4+(q<<2)>>2]|0;if((e|0)>=0)if(e>>>0<128)t=1;else t=iob(e)|0;else t=10;o=t+o|0;q=q+1|0}while((q|0)!=(n|0));if(o){if((o|0)>=0)if(o>>>0<128)u=2;else u=(iob(o)|0)+1|0;else u=11;v=o;w=u+r|0}else{v=0;w=r}}else{v=0;w=r}f[a+28>>2]=v;r=w+v|0;v=f[a+4>>2]|0;if(!(v&1)){x=r;y=a+12|0;f[y>>2]=x;return x|0}x=(dQb(v&-2)|0)+r|0;y=a+12|0;f[y>>2]=x;return x|0}function avb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=a+16|0;if((f[d>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=10;f[g>>2]=(f[g>>2]|0)+1;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;h=g}else{fob(c,10);h=f[e>>2]|0}g=f[a+28>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else fob(c,g);if((f[d>>2]|0)>0){g=a+24|0;o=c+8|0;e=c+4|0;h=0;do{i=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;do if((i|0)<0)gob(c,i,((i|0)<0)<<31>>31);else{if((f[o>>2]|0)<=4){fob(c,i);break}n=f[e>>2]|0;if(i>>>0>127){k=i;j=n;while(1){b[j>>0]=k|128;l=k>>>7;m=j+1|0;if(k>>>0>16383){k=l;j=m}else{p=m;q=l;break}}}else{p=n;q=i}b[p>>0]=q;j=p+1-n|0;f[e>>2]=(f[e>>2]|0)+j;f[o>>2]=(f[o>>2]|0)-j}while(0);h=h+1|0}while((h|0)<(f[d>>2]|0))}}d=a+8|0;h=f[d>>2]|0;if(!(h&2))r=h;else{$pb(2,f[a+32>>2]|0,c);r=f[d>>2]|0}if(!(r&4))s=r;else{Mpb(3,f[a+36>>2]|0,c);s=f[d>>2]|0}if(s&8|0)Mpb(4,f[a+40>>2]|0,c);s=f[a+4>>2]|0;if(!(s&1))return;aQb(s&-2,c);return}function bvb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function cvb(a){a=a|0;return f[a+12>>2]|0}function dvb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=a+16|0;if((f[c>>2]|0)>0){b[d>>0]=10;e=d+1|0;g=f[a+28>>2]|0;if(g>>>0>127){h=g;i=e;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=e;m=g}b[l>>0]=m;m=l+1|0;if((f[c>>2]|0)>0){l=a+24|0;g=0;e=m;while(1){i=f[(f[l>>2]|0)+4+(g<<2)>>2]|0;if((i|0)<0)n=hob(i,((i|0)<0)<<31>>31,e)|0;else{if(i>>>0>127){h=i;j=e;while(1){b[j>>0]=h|128;k=h>>>7;o=j+1|0;if(h>>>0>16383){h=k;j=o}else{p=o;q=k;break}}}else{p=e;q=i}b[p>>0]=q;n=p+1|0}g=g+1|0;if((g|0)>=(f[c>>2]|0)){r=n;break}else e=n}}else r=m}else r=d;d=a+8|0;m=f[d>>2]|0;if(!(m&2)){s=r;t=m}else{m=f[a+32>>2]|0;b[r>>0]=18;n=kob(m,r+1|0)|0;s=n;t=f[d>>2]|0}do if(!(t&4))u=s;else{n=f[a+36>>2]|0;b[s>>0]=24;r=s+1|0;if((n|0)<0){u=hob(n,((n|0)<0)<<31>>31,r)|0;break}if(n>>>0>127){m=n;e=r;while(1){b[e>>0]=m|128;c=m>>>7;g=e+1|0;if(m>>>0>16383){m=c;e=g}else{v=g;w=c;break}}}else{v=r;w=n}b[v>>0]=w;u=v+1|0}while(0);do if(!(f[d>>2]&8))x=u;else{v=f[a+40>>2]|0;b[u>>0]=32;w=u+1|0;if((v|0)<0){x=hob(v,((v|0)<0)<<31>>31,w)|0;break}if(v>>>0>127){s=v;t=w;while(1){b[t>>0]=s|128;e=s>>>7;m=t+1|0;if(s>>>0>16383){s=e;t=m}else{y=m;z=e;break}}}else{y=w;z=v}b[y>>0]=z;x=y+1|0}while(0);y=f[a+4>>2]|0;if(!(y&1)){A=x;return A|0}A=bQb(y&-2,x)|0;return A|0}function evb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function fvb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(15510);c=T6b(b,23288,22664,0)|0;if(!c){cOb(b,a);return}else{jvb(a,c);return}}function gvb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function hvb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213427];f[a+4>>2]=f[213428];u=c;return}function ivb(a){a=a|0;Enb(459437,a)}function jvb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c+4|0;e=c;g=a+16|0;h=b+16|0;i=f[h>>2]|0;if(i|0){nza(g,(f[g>>2]|0)+i|0);Vac((f[a+24>>2]|0)+4+(f[g>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[g>>2]=(f[g>>2]|0)+(f[h>>2]|0)}h=b+8|0;g=f[h>>2]|0;if(g&510|0){if(!(g&2))j=g;else{g=a+8|0;f[g>>2]=f[g>>2]|2;f[e>>2]=f[b+32>>2];f[d>>2]=f[e>>2];Anb(a+32|0,497760,d);j=f[h>>2]|0}if(!(j&4))k=j;else{j=f[b+36>>2]|0;d=a+8|0;f[d>>2]=f[d>>2]|4;f[a+36>>2]=j;k=f[h>>2]|0}if(k&8|0){k=f[b+40>>2]|0;h=a+8|0;f[h>>2]=f[h>>2]|8;f[a+40>>2]=k}}k=f[b+4>>2]|0;if(!(k&1)){u=c;return}LPb(k&-2,a+4|0);u=c;return}function kvb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=139348;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;if((a|0)!=499288?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;f[a+32>>2]=497760;d=a+36|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function lvb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function mvb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=139240;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(h);f[b>>2]=0;return}function nvb(a){a=a|0;mvb(a);O5b(a);return}function ovb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function pvb(a,b){a=a|0;b=b|0;a=L5b(32)|0;Hvb(a);if(!b)return a|0;Ivb(b,a);return a|0}function qvb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function rvb(a){a=a|0;return 1}function svb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=c+4|0;e=c+20|0;g=c+44|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=c+32|0;m=c+12|0;n=c+28|0;o=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[e>>2]=q;f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=_nb(c,t)|0;f[e>>2]=q;if((q+-1|0)>>>0<127){r=q;s=6}else u=q}if((s|0)==6){s=0;if((r|0)==10){q=f[g>>2]|0;f[g>>2]=q+-1;if((q|0)<=0){v=0;s=29;break}while(1){q=f[i>>2]|0;do if(q){a=f[k>>2]|0;p=f[q>>2]|0;if((a|0)>=(p|0))if((p|0)==(f[j>>2]|0)){w=p;s=13;break}else{x=p;y=q;s=14;break}else{f[k>>2]=a+1;z=f[q+4+(a<<2)>>2]|0;break}}else{w=f[j>>2]|0;s=13}while(0);if((s|0)==13){s=0;cpb(h,w+1|0);q=f[i>>2]|0;x=f[q>>2]|0;y=q;s=14}if((s|0)==14){s=0;f[y>>2]=x+1;q=Evb(0,f[h>>2]|0)|0;a=f[i>>2]|0;p=f[k>>2]|0;f[k>>2]=p+1;f[a+4+(p<<2)>>2]=q;z=q}q=Jnb(c)|0;if(!(_ub(z,c)|0)){v=0;s=29;break a}if(!(Pnb(c,q)|0)){v=0;s=29;break a}A=f[c>>2]|0;B=f[d>>2]|0;if(A>>>0>=B>>>0)break;if((b[A>>0]|0)!=10)break;f[c>>2]=A+1}f[g>>2]=(f[g>>2]|0)+1;if((A|0)!=(B|0))continue;if(f[l>>2]|0){s=23;break}if((f[m>>2]|0)==(f[n>>2]|0)){s=23;break}else continue}else u=r}if((u|0)==0|(u&7|0)==4){v=1;s=29;break}q=f[o>>2]|0;if(!(q&1))C=hBa(o)|0;else C=q&-2;if(!(ZPb(c,u,C)|0)){v=0;s=29;break}}if((s|0)==23){f[e>>2]=0;b[c+24>>0]=1;v=1;return v|0}else if((s|0)==29)return v|0;return 0}function tvb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+20>>2]|0;if(!b)c=0;else{d=a+28|0;e=0;g=b;while(1){h=$ub(f[(f[d>>2]|0)+4+(e<<2)>>2]|0)|0;if(h>>>0<128)i=1;else i=iob(h)|0;j=h+g+i|0;e=e+1|0;if((e|0)==(b|0)){c=j;break}else g=j}}g=f[a+4>>2]|0;if(!(g&1)){k=c;l=a+12|0;f[l>>2]=k;return k|0}k=(dQb(g&-2)|0)+c|0;l=a+12|0;f[l>>2]=k;return k|0}function uvb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eqb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function vvb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function wvb(a){a=a|0;return f[a+12>>2]|0}function xvb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+20>>2]|0;if(!c)e=d;else{g=a+28|0;h=0;i=d;while(1){d=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=10;j=i+1|0;k=f[d+12>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=j;q=k}b[p>>0]=q;m=li[f[(f[d>>2]|0)+68>>2]&511](d,0,p+1|0)|0;h=h+1|0;if((h|0)==(c|0)){e=m;break}else i=m}}i=f[a+4>>2]|0;if(!(i&1)){r=e;return r|0}r=bQb(i&-2,e)|0;return r|0}function yvb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function zvb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(15777);c=T6b(b,23288,22680,0)|0;if(!c){cOb(b,a);return}Cvb(a+16|0,c+16|0);b=f[c+4>>2]|0;if(!(b&1))return;LPb(b&-2,a+4|0);return}function Avb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Bvb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213425];f[a+4>>2]=f[213426];u=c;return}function Cvb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{Dvb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Evb(h,i)|0;Dvb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function Dvb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))ivb(15528);else{jvb(b,a);return}}function Evb(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=Fvb(b,c)|0;u=a;return d|0}function Fvb(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(44)|0;kvb(b);c=b;return c|0}else{b=znb(a,22664,44)|0;kvb(b);xnb(a,b,1521);c=b;return c|0}return 0}function Gvb(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function Hvb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=139240;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=499248?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;u=c;return}function Ivb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function Jvb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=139132;c=a+64|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+68|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+60|0;d=f[c>>2]|0;if(d|0?(f[a+48>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);O5b(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=f[a+40>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=f[a+24>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(i);f[c>>2]=0;return}function Kvb(a){a=a|0;Jvb(a);O5b(a);return}function Lvb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Mvb(a,b){a=a|0;b=b|0;a=L5b(72)|0;_vb(a);if(!b)return a|0;$vb(b,a);return a|0}function Nvb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[c>>2]|0;do if(d&12|0){do if(d&4|0?(e=f[a+64>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(f[c>>2]&8|0?(g=f[a+68>>2]|0,(g|0)!=497760):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}}while(0);f[a+16>>2]=0;f[a+32>>2]=0;d=a+52|0;e=f[d>>2]|0;if((e|0)>0){g=f[a+60>>2]|0;h=0;do{i=f[g+4+(h<<2)>>2]|0;h=h+1|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[j>>0]=0}}while((h|0)!=(e|0));f[d>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function Ovb(a){a=a|0;return 1}function Pvb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=c+4|0;e=c+20|0;g=a+16|0;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;l=a+40|0;m=a+8|0;n=a+64|0;o=a+68|0;p=a+48|0;q=c+32|0;r=c+12|0;s=c+28|0;t=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){u=b[a>>0]|0;v=u&255;if(u<<24>>24>0){f[e>>2]=v;f[c>>2]=a+1;w=v;x=6}else{y=v;x=5}}else{y=0;x=5}if((x|0)==5){x=0;v=_nb(c,y)|0;f[e>>2]=v;if((v+-1|0)>>>0<127){w=v;x=6}else{z=v;x=66}}b:do if((x|0)==6){x=0;c:do switch(w>>>3&536870911|0){case 1:{switch(w|0){case 0:{A=1;x=72;break a;break}case 10:{v=f[c>>2]|0;if(v>>>0<(f[d>>2]|0)>>>0?(a=b[v>>0]|0,a<<24>>24>-1):0){f[c>>2]=v+1;B=a&255}else{a=Znb(c)|0;if((a|0)>-1)B=a;else{A=0;x=72;break a}}a=Gnb(c,B)|0;if((Qnb(c)|0)>0)do{v=f[c>>2]|0;if(v>>>0<(f[d>>2]|0)>>>0){u=b[v>>0]|0;C=u&255;if(u<<24>>24>-1){f[c>>2]=v+1;D=C}else{E=C;x=16}}else{E=0;x=16}if((x|0)==16){x=0;C=Knb(c,E)|0;v=J;if((v|0)>-1|(v|0)==-1&C>>>0>4294967295)D=C;else{A=0;x=72;break a}}C=f[g>>2]|0;if((C|0)==(f[h>>2]|0)){nza(g,C+1|0);F=f[g>>2]|0}else F=C;C=f[i>>2]|0;f[g>>2]=F+1;f[C+4+(F<<2)>>2]=D}while((Qnb(c)|0)>0);Hnb(c,a);break}case 8:{if(!(PEa(1,10,c,g)|0)){A=0;x=72;break a}break}default:{G=w;break b}}C=f[c>>2]|0;v=f[d>>2]|0;if(C>>>0>=v>>>0)continue a;if((b[C>>0]|0)!=18)continue a;u=C+1|0;f[c>>2]=u;H=u;I=v;x=27;break}case 2:{switch(w|0){case 0:{A=1;x=72;break a;break}case 18:{H=f[c>>2]|0;I=f[d>>2]|0;x=27;break c;break}case 16:{if(PEa(1,18,c,j)|0){x=41;break c}else{A=0;x=72;break a}break}default:{G=w;break b}}break}case 3:{switch(w|0){case 0:{A=1;x=72;break a;break}case 26:{x=45;break}default:{G=w;break b}}break}case 4:{switch(w|0){case 0:{A=1;x=72;break a;break}case 34:{x=52;break}default:{G=w;break b}}break}case 6:{switch(w|0){case 0:{A=1;x=72;break a;break}case 50:break;default:{G=w;break b}}break}default:{z=w;x=66;break b}}while(0);if((x|0)==27){x=0;if(H>>>0<I>>>0?(v=b[H>>0]|0,v<<24>>24>-1):0){f[c>>2]=H+1;K=v&255}else{v=Znb(c)|0;if((v|0)>-1)K=v;else{A=0;x=72;break a}}v=Gnb(c,K)|0;if((Qnb(c)|0)>0)do{u=f[c>>2]|0;if(u>>>0<(f[d>>2]|0)>>>0){C=b[u>>0]|0;L=C&255;if(C<<24>>24>-1){f[c>>2]=u+1;M=L}else{N=L;x=35}}else{N=0;x=35}if((x|0)==35){x=0;L=Knb(c,N)|0;u=J;if((u|0)>-1|(u|0)==-1&L>>>0>4294967295)M=L;else{A=0;x=72;break a}}L=f[j>>2]|0;if((L|0)==(f[k>>2]|0)){nza(j,L+1|0);O=f[j>>2]|0}else O=L;L=f[l>>2]|0;f[j>>2]=O+1;f[L+4+(O<<2)>>2]=M}while((Qnb(c)|0)>0);Hnb(c,v);x=41}if((x|0)==41){x=0;L=f[c>>2]|0;if(L>>>0>=(f[d>>2]|0)>>>0)continue a;if((b[L>>0]|0)!=26)continue a;f[c>>2]=L+1;x=45}if((x|0)==45){x=0;f[m>>2]=f[m>>2]|4;L=f[n>>2]|0;if((L|0)==497760){jza(n,497760);P=f[n>>2]|0}else P=L;if(!(fqb(c,P)|0)){A=0;x=72;break a}L=f[c>>2]|0;if(L>>>0>=(f[d>>2]|0)>>>0)continue a;if((b[L>>0]|0)!=34)continue a;f[c>>2]=L+1;x=52}if((x|0)==52){x=0;f[m>>2]=f[m>>2]|8;L=f[o>>2]|0;if((L|0)==497760){jza(o,497760);Q=f[o>>2]|0}else Q=L;if(!(fqb(c,Q)|0)){A=0;x=72;break a}L=f[c>>2]|0;if(L>>>0>=(f[d>>2]|0)>>>0)continue a;if((b[L>>0]|0)==50){R=L;x=58}else continue a}while(1){if((x|0)==58){x=0;f[c>>2]=R+1}if(!(fqb(c,mza(p)|0)|0)){A=0;x=72;break a}R=f[c>>2]|0;S=f[d>>2]|0;if(R>>>0>=S>>>0)break;if((b[R>>0]|0)!=50)break;else x=58}if((R|0)!=(S|0))continue a;if(f[q>>2]|0){x=65;break a}if((f[r>>2]|0)==(f[s>>2]|0)){x=65;break a}else continue a}while(0);if((x|0)==66){x=0;if(!z){A=1;x=72;break}else G=z}if((G&7|0)==4){A=1;x=72;break}v=f[t>>2]|0;if(!(v&1))T=hBa(t)|0;else T=v&-2;if(!(ZPb(c,G,T)|0)){A=0;x=72;break}}if((x|0)==65){f[e>>2]=0;b[c+24>>0]=1;A=1;return A|0}else if((x|0)==72)return A|0;return 0}function Qvb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=a+8|0;d=f[c>>2]|0;if(d&12){if(!(d&4)){e=0;g=d}else{h=f[a+64>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&8))n=e;else{g=f[a+68>>2]|0;l=b[g+11>>0]|0;if(l<<24>>24<0){k=f[g+4>>2]|0;if(k>>>0<128){o=1;p=k}else{o=iob(k)|0;p=k}}else{o=1;p=l&255}n=e+1+p+o|0}}else n=0;o=f[a+16>>2]|0;if(o){p=a+24|0;e=0;l=0;do{k=f[(f[p>>2]|0)+4+(l<<2)>>2]|0;if((k|0)>=0)if(k>>>0<128)q=1;else q=iob(k)|0;else q=10;e=q+e|0;l=l+1|0}while((l|0)!=(o|0));if(e){if((e|0)>=0)if(e>>>0<128)r=2;else r=(iob(e)|0)+1|0;else r=11;s=e;t=r+n|0}else{s=0;t=n}}else{s=0;t=n}f[a+28>>2]=s;n=t+s|0;s=f[a+32>>2]|0;if(s){t=a+40|0;r=0;e=0;do{o=f[(f[t>>2]|0)+4+(r<<2)>>2]|0;if((o|0)>=0)if(o>>>0<128)u=1;else u=iob(o)|0;else u=10;e=u+e|0;r=r+1|0}while((r|0)!=(s|0));if(e){if((e|0)>=0)if(e>>>0<128)v=2;else v=(iob(e)|0)+1|0;else v=11;w=e;x=v+n|0}else{w=0;x=n}}else{w=0;x=n}f[a+44>>2]=w;n=a+52|0;v=f[n>>2]|0;e=x+w+v|0;if((v|0)>0){w=a+60|0;x=0;s=e;r=v;while(1){v=f[(f[w>>2]|0)+4+(x<<2)>>2]|0;u=b[v+11>>0]|0;if(u<<24>>24<0){t=f[v+4>>2]|0;if(t>>>0<128){y=1;z=r;A=t}else{v=iob(t)|0;y=v;z=f[n>>2]|0;A=t}}else{y=1;z=r;A=u&255}u=A+s+y|0;x=x+1|0;if((x|0)>=(z|0)){B=u;break}else{s=u;r=z}}}else B=e;e=f[a+4>>2]|0;if(!(e&1)){C=B;D=a+12|0;f[D>>2]=C;return C|0}C=(dQb(e&-2)|0)+B|0;D=a+12|0;f[D>>2]=C;return C|0}function Rvb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=a+16|0;if((f[d>>2]|0)>0){e=c+8|0;if((f[e>>2]|0)>4){g=c+4|0;b[f[g>>2]>>0]=10;f[g>>2]=(f[g>>2]|0)+1;g=(f[e>>2]|0)+-1|0;f[e>>2]=g;h=g}else{fob(c,10);h=f[e>>2]|0}g=f[a+28>>2]|0;if((h|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else fob(c,g);if((f[d>>2]|0)>0){g=a+24|0;o=c+8|0;e=c+4|0;h=0;do{i=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;do if((i|0)<0)gob(c,i,((i|0)<0)<<31>>31);else{if((f[o>>2]|0)<=4){fob(c,i);break}n=f[e>>2]|0;if(i>>>0>127){k=i;j=n;while(1){b[j>>0]=k|128;l=k>>>7;m=j+1|0;if(k>>>0>16383){k=l;j=m}else{p=m;q=l;break}}}else{p=n;q=i}b[p>>0]=q;j=p+1-n|0;f[e>>2]=(f[e>>2]|0)+j;f[o>>2]=(f[o>>2]|0)-j}while(0);h=h+1|0}while((h|0)<(f[d>>2]|0))}}d=a+32|0;if((f[d>>2]|0)>0){h=c+8|0;if((f[h>>2]|0)>4){o=c+4|0;b[f[o>>2]>>0]=18;f[o>>2]=(f[o>>2]|0)+1;o=(f[h>>2]|0)+-1|0;f[h>>2]=o;r=o}else{fob(c,18);r=f[h>>2]|0}o=f[a+44>>2]|0;if((r|0)>4){r=c+4|0;e=f[r>>2]|0;if(o>>>0>127){p=o;q=e;while(1){b[q>>0]=p|128;g=p>>>7;i=q+1|0;if(p>>>0>16383){p=g;q=i}else{s=i;t=g;break}}}else{s=e;t=o}b[s>>0]=t;t=s+1-e|0;f[r>>2]=(f[r>>2]|0)+t;f[h>>2]=(f[h>>2]|0)-t}else fob(c,o);if((f[d>>2]|0)>0){o=a+40|0;t=c+8|0;h=c+4|0;r=0;do{e=f[(f[o>>2]|0)+4+(r<<2)>>2]|0;do if((e|0)<0)gob(c,e,((e|0)<0)<<31>>31);else{if((f[t>>2]|0)<=4){fob(c,e);break}s=f[h>>2]|0;if(e>>>0>127){q=e;p=s;while(1){b[p>>0]=q|128;g=q>>>7;i=p+1|0;if(q>>>0>16383){q=g;p=i}else{u=i;v=g;break}}}else{u=s;v=e}b[u>>0]=v;p=u+1-s|0;f[h>>2]=(f[h>>2]|0)+p;f[t>>2]=(f[t>>2]|0)-p}while(0);r=r+1|0}while((r|0)<(f[d>>2]|0))}}d=a+8|0;r=f[d>>2]|0;if(!(r&4))w=r;else{$pb(3,f[a+64>>2]|0,c);w=f[d>>2]|0}if(w&8|0)$pb(4,f[a+68>>2]|0,c);w=a+52|0;if((f[w>>2]|0)>0){d=a+60|0;r=0;do{_pb(6,f[(f[d>>2]|0)+4+(r<<2)>>2]|0,c);r=r+1|0}while((r|0)<(f[w>>2]|0))}w=f[a+4>>2]|0;if(!(w&1))return;aQb(w&-2,c);return}function Svb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function Tvb(a){a=a|0;return f[a+12>>2]|0}function Uvb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+16|0;if((f[c>>2]|0)>0){b[d>>0]=10;e=d+1|0;g=f[a+28>>2]|0;if(g>>>0>127){h=g;i=e;while(1){b[i>>0]=h|128;j=h>>>7;k=i+1|0;if(h>>>0>16383){h=j;i=k}else{l=k;m=j;break}}}else{l=e;m=g}b[l>>0]=m;m=l+1|0;if((f[c>>2]|0)>0){l=a+24|0;g=0;e=m;while(1){i=f[(f[l>>2]|0)+4+(g<<2)>>2]|0;if((i|0)<0)n=hob(i,((i|0)<0)<<31>>31,e)|0;else{if(i>>>0>127){h=i;j=e;while(1){b[j>>0]=h|128;k=h>>>7;o=j+1|0;if(h>>>0>16383){h=k;j=o}else{p=o;q=k;break}}}else{p=e;q=i}b[p>>0]=q;n=p+1|0}g=g+1|0;if((g|0)>=(f[c>>2]|0)){r=n;break}else e=n}}else r=m}else r=d;d=a+32|0;if((f[d>>2]|0)>0){b[r>>0]=18;m=r+1|0;n=f[a+44>>2]|0;if(n>>>0>127){e=n;c=m;while(1){b[c>>0]=e|128;g=e>>>7;p=c+1|0;if(e>>>0>16383){e=g;c=p}else{s=p;t=g;break}}}else{s=m;t=n}b[s>>0]=t;t=s+1|0;if((f[d>>2]|0)>0){s=a+40|0;n=0;m=t;while(1){c=f[(f[s>>2]|0)+4+(n<<2)>>2]|0;if((c|0)<0)u=hob(c,((c|0)<0)<<31>>31,m)|0;else{if(c>>>0>127){e=c;g=m;while(1){b[g>>0]=e|128;p=e>>>7;q=g+1|0;if(e>>>0>16383){e=p;g=q}else{v=q;w=p;break}}}else{v=m;w=c}b[v>>0]=w;u=v+1|0}n=n+1|0;if((n|0)>=(f[d>>2]|0)){x=u;break}else m=u}}else x=t}else x=r;r=a+8|0;t=f[r>>2]|0;if(!(t&4)){y=x;z=t}else{t=f[a+64>>2]|0;b[x>>0]=26;u=kob(t,x+1|0)|0;y=u;z=f[r>>2]|0}if(!(z&8))A=y;else{z=f[a+68>>2]|0;b[y>>0]=34;A=kob(z,y+1|0)|0}y=a+52|0;if((f[y>>2]|0)>0){z=a+60|0;r=0;u=A;while(1){x=f[(f[z>>2]|0)+4+(r<<2)>>2]|0;b[u>>0]=50;t=kob(x,u+1|0)|0;r=r+1|0;if((r|0)>=(f[y>>2]|0)){B=t;break}else u=t}}else B=A;A=f[a+4>>2]|0;if(!(A&1)){C=B;return C|0}C=bQb(A&-2,B)|0;return C|0}function Vvb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Wvb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(14559);c=T6b(b,23288,22696,0)|0;if(!c){cOb(b,a);return}else{Zvb(a,c);return}}function Xvb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Yvb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213423];f[a+4>>2]=f[213424];u=c;return}function Zvb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c+8|0;e=c+4|0;g=c;h=a+16|0;i=b+16|0;j=f[i>>2]|0;if(j|0){nza(h,(f[h>>2]|0)+j|0);Vac((f[a+24>>2]|0)+4+(f[h>>2]<<2)|0,(f[b+24>>2]|0)+4|0,f[i>>2]<<2|0)|0;f[h>>2]=(f[h>>2]|0)+(f[i>>2]|0)}i=a+32|0;h=b+32|0;j=f[h>>2]|0;if(j|0){nza(i,(f[i>>2]|0)+j|0);Vac((f[a+40>>2]|0)+4+(f[i>>2]<<2)|0,(f[b+40>>2]|0)+4|0,f[h>>2]<<2|0)|0;f[i>>2]=(f[i>>2]|0)+(f[h>>2]|0)}UDa(a+48|0,b+48|0);h=b+8|0;i=f[h>>2]|0;if(i&1020|0){if(!(i&4))k=i;else{i=a+8|0;f[i>>2]=f[i>>2]|4;f[e>>2]=f[b+64>>2];f[d>>2]=f[e>>2];Anb(a+64|0,497760,d);k=f[h>>2]|0}if(k&8|0){k=a+8|0;f[k>>2]=f[k>>2]|8;f[g>>2]=f[b+68>>2];f[d>>2]=f[g>>2];Anb(a+68|0,497760,d)}}d=f[b+4>>2]|0;if(!(d&1)){u=c;return}LPb(d&-2,a+4|0);u=c;return}function _vb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=139132;f[a+4>>2]=0;f[a+8>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=0;e=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=499168?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;f[a+64>>2]=497760;f[a+68>>2]=497760;u=c;return}function $vb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function awb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=139024;b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(h);f[b>>2]=0;return}function bwb(a){a=a|0;awb(a);O5b(a);return}function cwb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function dwb(a,b){a=a|0;b=b|0;a=L5b(32)|0;vwb(a);if(!b)return a|0;wwb(b,a);return a|0}function ewb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+20|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+28>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function fwb(a){a=a|0;return 1}function gwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=c+4|0;e=c+20|0;g=c+44|0;h=a+16|0;i=a+28|0;j=a+24|0;k=a+20|0;l=c+32|0;m=c+12|0;n=c+28|0;o=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){p=b[a>>0]|0;q=p&255;if(p<<24>>24>0){f[e>>2]=q;f[c>>2]=a+1;r=q;s=6}else{t=q;s=5}}else{t=0;s=5}if((s|0)==5){s=0;q=_nb(c,t)|0;f[e>>2]=q;if((q+-1|0)>>>0<127){r=q;s=6}else u=q}if((s|0)==6){s=0;if((r|0)==10){q=f[g>>2]|0;f[g>>2]=q+-1;if((q|0)<=0){v=0;s=29;break}while(1){q=f[i>>2]|0;do if(q){a=f[k>>2]|0;p=f[q>>2]|0;if((a|0)>=(p|0))if((p|0)==(f[j>>2]|0)){w=p;s=13;break}else{x=p;y=q;s=14;break}else{f[k>>2]=a+1;z=f[q+4+(a<<2)>>2]|0;break}}else{w=f[j>>2]|0;s=13}while(0);if((s|0)==13){s=0;cpb(h,w+1|0);q=f[i>>2]|0;x=f[q>>2]|0;y=q;s=14}if((s|0)==14){s=0;f[y>>2]=x+1;q=swb(0,f[h>>2]|0)|0;a=f[i>>2]|0;p=f[k>>2]|0;f[k>>2]=p+1;f[a+4+(p<<2)>>2]=q;z=q}q=Jnb(c)|0;if(!(Pvb(z,c)|0)){v=0;s=29;break a}if(!(Pnb(c,q)|0)){v=0;s=29;break a}A=f[c>>2]|0;B=f[d>>2]|0;if(A>>>0>=B>>>0)break;if((b[A>>0]|0)!=10)break;f[c>>2]=A+1}f[g>>2]=(f[g>>2]|0)+1;if((A|0)!=(B|0))continue;if(f[l>>2]|0){s=23;break}if((f[m>>2]|0)==(f[n>>2]|0)){s=23;break}else continue}else u=r}if((u|0)==0|(u&7|0)==4){v=1;s=29;break}q=f[o>>2]|0;if(!(q&1))C=hBa(o)|0;else C=q&-2;if(!(ZPb(c,u,C)|0)){v=0;s=29;break}}if((s|0)==23){f[e>>2]=0;b[c+24>>0]=1;v=1;return v|0}else if((s|0)==29)return v|0;return 0}function hwb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+20>>2]|0;if(!b)c=0;else{d=a+28|0;e=0;g=b;while(1){h=Qvb(f[(f[d>>2]|0)+4+(e<<2)>>2]|0)|0;if(h>>>0<128)i=1;else i=iob(h)|0;j=h+g+i|0;e=e+1|0;if((e|0)==(b|0)){c=j;break}else g=j}}g=f[a+4>>2]|0;if(!(g&1)){k=c;l=a+12|0;f[l>>2]=k;return k|0}k=(dQb(g&-2)|0)+c|0;l=a+12|0;f[l>>2]=k;return k|0}function iwb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eqb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function jwb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function kwb(a){a=a|0;return f[a+12>>2]|0}function lwb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+20>>2]|0;if(!c)e=d;else{g=a+28|0;h=0;i=d;while(1){d=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=10;j=i+1|0;k=f[d+12>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=j;q=k}b[p>>0]=q;m=li[f[(f[d>>2]|0)+68>>2]&511](d,0,p+1|0)|0;h=h+1|0;if((h|0)==(c|0)){e=m;break}else i=m}}i=f[a+4>>2]|0;if(!(i&1)){r=e;return r|0}r=bQb(i&-2,e)|0;return r|0}function mwb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function nwb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(14827);c=T6b(b,23288,22712,0)|0;if(!c){cOb(b,a);return}qwb(a+16|0,c+16|0);b=f[c+4>>2]|0;if(!(b&1))return;LPb(b&-2,a+4|0);return}function owb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function pwb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213421];f[a+4>>2]=f[213422];u=c;return}function qwb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{rwb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=swb(h,i)|0;rwb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function rwb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))ivb(14577);else{Zvb(b,a);return}}function swb(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=twb(b,c)|0;u=a;return d|0}function twb(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(72)|0;_vb(b);c=b;return c|0}else{b=znb(a,22696,72)|0;_vb(b);xnb(a,b,1522);c=b;return c|0}return 0}function uwb(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function vwb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=139024;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=499128?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;u=c;return}function wwb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function xwb(a){a=a|0;var c=0,d=0;f[a>>2]=138916;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(d);f[c>>2]=0;return}function ywb(a){a=a|0;xwb(a);O5b(a);return}function zwb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Awb(a,b){a=a|0;b=b|0;a=L5b(24)|0;Nwb(a);if(!b)return a|0;Owb(b,a);return a|0}function Bwb(a){a=a|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);b[a+20>>0]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function Cwb(a){a=a|0;return (f[a+8>>2]&3|0)==3|0}function Dwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+16|0;k=a+20|0;l=c+32|0;m=c+12|0;n=c+28|0;o=e+8|0;p=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){q=b[a>>0]|0;r=q&255;if(q<<24>>24>0){f[h>>2]=r;f[c>>2]=a+1;s=r;t=6}else{v=r;t=5}}else{v=0;t=5}if((t|0)==5){t=0;r=_nb(c,v)|0;f[h>>2]=r;if((r+-1|0)>>>0<127){s=r;t=6}else{w=r;t=25}}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{switch(s|0){case 0:{x=1;t=31;break a;break}case 10:break;default:{y=s;break b}}f[i>>2]=f[i>>2]|1;r=f[j>>2]|0;if((r|0)==497760){jza(j,497760);z=f[j>>2]|0}else z=r;if(!(fqb(c,z)|0)){x=0;t=31;break a}r=f[c>>2]|0;a=f[g>>2]|0;if(r>>>0>=a>>>0)continue a;if((b[r>>0]|0)!=16)continue a;q=r+1|0;f[c>>2]=q;A=q;B=a;break}case 2:{switch(s|0){case 0:{x=1;t=31;break a;break}case 16:break;default:{y=s;break b}}A=f[c>>2]|0;B=f[g>>2]|0;break}default:{w=s;t=25;break b}}f[i>>2]=f[i>>2]|2;if(A>>>0<B>>>0?(a=b[A>>0]|0,a<<24>>24>-1):0){q=A+1|0;f[c>>2]=q;C=a<<24>>24!=0;D=q;E=B}else{Lnb(e,c);q=e;if(!(b[o>>0]|0)){x=0;t=31;break a}C=(f[q>>2]|0)!=0|(f[q+4>>2]|0)!=0;D=f[c>>2]|0;E=f[g>>2]|0}b[k>>0]=C&1;if((D|0)!=(E|0))continue a;if(f[l>>2]|0){t=24;break a}if((f[m>>2]|0)==(f[n>>2]|0)){t=24;break a}else continue a}while(0);if((t|0)==25){t=0;if(!w){x=1;t=31;break}else y=w}if((y&7|0)==4){x=1;t=31;break}q=f[p>>2]|0;if(!(q&1))F=hBa(p)|0;else F=q&-2;if(!(ZPb(c,y,F)|0)){x=0;t=31;break}}if((t|0)==24){f[h>>2]=0;b[c+24>>0]=1;x=1;u=d;return x|0}else if((t|0)==31){u=d;return x|0}return 0}function Ewb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+8|0;d=f[c>>2]|0;if((d&3|0)==3){e=f[a+16>>2]|0;g=b[e+11>>0]|0;if(g<<24>>24<0){h=f[e+4>>2]|0;if(h>>>0<128){i=1;j=h}else{i=iob(h)|0;j=h}}else{i=1;j=g&255}k=j+3+i|0}else{if(!(d&1)){l=0;m=d}else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;if(j<<24>>24<0){g=f[i+4>>2]|0;if(g>>>0<128){n=1;o=d;p=g}else{i=iob(g)|0;n=i;o=f[c>>2]|0;p=g}}else{n=1;o=d;p=j&255}l=p+1+n|0;m=o}k=m&2|0?l+2|0:l}l=f[a+4>>2]|0;if(!(l&1)){q=k;r=a+12|0;f[r>>2]=q;return q|0}q=(dQb(l&-2)|0)+k|0;r=a+12|0;f[r>>2]=q;return q|0}function Fwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{$pb(1,f[a+16>>2]|0,c);g=f[d>>2]|0}if(g&2|0)Ypb(2,(b[a+20>>0]|0)!=0,c);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,c);return}function Gwb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function Hwb(a){a=a|0;return f[a+12>>2]|0}function Iwb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&2))j=g;else{h=b[a+20>>0]|0;b[g>>0]=16;b[g+1>>0]=h;j=g+2|0}g=f[a+4>>2]|0;if(!(g&1)){k=j;return k|0}k=bQb(g&-2,j)|0;return k|0}function Jwb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Kwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+4|0;g=d;if((a|0)==(c|0))ivb(13156);h=T6b(c,23288,22728,0)|0;if(!h){cOb(c,a);u=d;return}c=h+8|0;i=f[c>>2]|0;if(i&255|0){if(!(i&1))j=i;else{i=a+8|0;f[i>>2]=f[i>>2]|1;f[g>>2]=f[h+16>>2];f[e>>2]=f[g>>2];Anb(a+16|0,497760,e);j=f[c>>2]|0}if(j&2|0){j=b[h+20>>0]|0;c=a+8|0;f[c>>2]=f[c>>2]|2;b[a+20>>0]=j}}j=f[h+4>>2]|0;if(j&1|0)LPb(j&-2,a+4|0);u=d;return}function Lwb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function Mwb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213419];f[a+4>>2]=f[213420];u=c;return}function Nwb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=138916;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=499096?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=497760;b[a+20>>0]=0;u=c;return}function Owb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function Pwb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=138808;lxb(a);b=a+28|0;c=f[b>>2]|0;if(c|0?(f[a+16>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(h);f[b>>2]=0;return}function Qwb(a){a=a|0;Pwb(a);O5b(a);return}function Rwb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Swb(a,b){a=a|0;b=b|0;a=L5b(72)|0;jxb(a);if(!b)return a|0;kxb(b,a);return a|0}function Twb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+8|0;d=f[c>>2]|0;do if(d&126|0){e=a+48|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;do if(d&2|0?(e=f[a+32>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(f[c>>2]&32|0?(g=f[a+36>>2]|0,(g|0)!=497760):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(f[c>>2]&64|0?(e=f[a+40>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);d=a+20|0;g=f[d>>2]|0;if((g|0)>0){e=f[a+28>>2]|0;h=0;do{i=f[e+4+(h<<2)>>2]|0;h=h+1|0;bi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((h|0)!=(g|0));f[d>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function Uwb(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+28|0;c=f[a+20>>2]|0;while(1){if((c|0)<=0){d=1;e=4;break}c=c+-1|0;a=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[a>>2]|0)+32>>2]&1023](a)|0)){d=0;e=4;break}}if((e|0)==4)return d|0;return 0}function Vwb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=c+44|0;k=a+16|0;l=a+28|0;m=a+24|0;n=a+20|0;o=a+8|0;q=a+32|0;r=a+48|0;t=e+8|0;v=a+56|0;w=e+8|0;x=a+64|0;y=a+36|0;z=a+40|0;A=c+32|0;B=c+12|0;C=c+28|0;D=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){E=b[a>>0]|0;F=E&255;if(E<<24>>24>0){f[i>>2]=F;f[c>>2]=a+1;G=F;H=6}else{I=F;H=5}}else{I=0;H=5}if((H|0)==5){H=0;F=_nb(c,I)|0;f[i>>2]=F;if((F+-1|0)>>>0<127){G=F;H=6}else{J=F;H=76}}b:do if((H|0)==6){H=0;switch(G>>>3&536870911|0){case 2:{switch(G|0){case 0:{K=1;H=82;break a;break}case 18:break;default:{L=G;break b}}F=f[j>>2]|0;f[j>>2]=F+-1;if((F|0)<=0){K=0;H=82;break a}while(1){F=f[l>>2]|0;do if(F){a=f[n>>2]|0;E=f[F>>2]|0;if((a|0)>=(E|0))if((E|0)==(f[m>>2]|0)){M=E;H=14;break}else{N=E;O=F;H=15;break}else{f[n>>2]=a+1;P=f[F+4+(a<<2)>>2]|0;break}}else{M=f[m>>2]|0;H=14}while(0);if((H|0)==14){H=0;cpb(k,M+1|0);F=f[l>>2]|0;N=f[F>>2]|0;O=F;H=15}if((H|0)==15){H=0;f[O>>2]=N+1;F=gxb(0,f[k>>2]|0)|0;a=f[l>>2]|0;E=f[n>>2]|0;f[n>>2]=E+1;f[a+4+(E<<2)>>2]=F;P=F}F=Jnb(c)|0;if(!(Dwb(P,c)|0)){K=0;H=82;break a}if(!(Pnb(c,F)|0)){K=0;H=82;break a}Q=f[c>>2]|0;if(Q>>>0>=(f[g>>2]|0)>>>0){H=19;break}if((b[Q>>0]|0)!=18)break;f[c>>2]=Q+1}if((H|0)==19){H=0;f[j>>2]=(f[j>>2]|0)+1;continue a}f[j>>2]=(f[j>>2]|0)+1;if((b[Q>>0]|0)!=26)continue a;f[c>>2]=Q+1;H=25;break}case 3:{switch(G|0){case 0:{K=1;H=82;break a;break}case 26:{H=25;break}default:{L=G;break b}}break}case 4:{switch(G|0){case 0:{K=1;H=82;break a;break}case 32:break;default:{L=G;break b}}R=f[g>>2]|0;S=f[c>>2]|0;H=33;break}case 5:{switch(G|0){case 0:{K=1;H=82;break a;break}case 40:break;default:{L=G;break b}}T=f[g>>2]|0;U=f[c>>2]|0;H=43;break}case 6:{switch(G|0){case 0:{K=1;H=82;break a;break}case 49:break;default:{L=G;break b}}F=f[g>>2]|0;V=f[c>>2]|0;W=F;X=F;H=53;break}case 7:{switch(G|0){case 0:{K=1;H=82;break a;break}case 58:{H=62;break}default:{L=G;break b}}break}case 8:{switch(G|0){case 0:{K=1;H=82;break a;break}case 66:break;default:{L=G;break b}}break}default:{J=G;H=76;break b}}if((H|0)==25){H=0;f[o>>2]=f[o>>2]|2;F=f[q>>2]|0;if((F|0)==497760){jza(q,497760);Y=f[q>>2]|0}else Y=F;if(!(fqb(c,Y)|0)){K=0;H=82;break a}F=f[c>>2]|0;E=f[g>>2]|0;if(F>>>0>=E>>>0)continue a;if((b[F>>0]|0)!=32)continue a;a=F+1|0;f[c>>2]=a;R=E;S=a;H=33}if((H|0)==33){H=0;f[o>>2]=f[o>>2]|4;if(S>>>0<R>>>0?(a=b[S>>0]|0,a<<24>>24>-1):0){E=r;f[E>>2]=a&255;f[E+4>>2]=0;E=S+1|0;f[c>>2]=E;Z=R;_=E}else{Lnb(e,c);E=e;a=f[E+4>>2]|0;F=r;f[F>>2]=f[E>>2];f[F+4>>2]=a;if(!(b[t>>0]|0)){K=0;H=82;break a}Z=f[g>>2]|0;_=f[c>>2]|0}if(_>>>0>=Z>>>0)continue a;if((b[_>>0]|0)!=40)continue a;a=_+1|0;f[c>>2]=a;T=Z;U=a;H=43}if((H|0)==43){H=0;f[o>>2]=f[o>>2]|8;if(U>>>0<T>>>0?(a=b[U>>0]|0,a<<24>>24>-1):0){F=U+1|0;f[c>>2]=F;$=T;aa=a&255;ba=0;ca=F}else{Lnb(e,c);F=e;if(!(b[w>>0]|0)){K=0;H=82;break a}$=f[g>>2]|0;aa=f[F>>2]|0;ba=f[F+4>>2]|0;ca=f[c>>2]|0}F=v;f[F>>2]=aa;f[F+4>>2]=ba;if(ca>>>0>=$>>>0)continue a;if((b[ca>>0]|0)!=49)continue a;F=ca+1|0;f[c>>2]=F;V=F;W=$;X=$;H=53}if((H|0)==53){H=0;f[o>>2]=f[o>>2]|16;if((W-V|0)>7){F=V;a=F;E=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=F+4|0;F=h[a>>0]|h[a+1>>0]<<8|h[a+2>>0]<<16|h[a+3>>0]<<24;a=e;f[a>>2]=E;f[a+4>>2]=F;a=V+8|0;f[c>>2]=a;f[s>>2]=E;f[s+4>>2]=F;da=+p[s>>3];ea=a;fa=X}else{if(!(Ynb(c,e)|0)){H=57;break a}da=+p[e>>3];ea=f[c>>2]|0;fa=f[g>>2]|0}p[x>>3]=da;if(ea>>>0>=fa>>>0)continue a;if((b[ea>>0]|0)!=58)continue a;f[c>>2]=ea+1;H=62}if((H|0)==62){H=0;f[o>>2]=f[o>>2]|32;a=f[y>>2]|0;if((a|0)==497760){jza(y,497760);ga=f[y>>2]|0}else ga=a;if(!(fqb(c,ga)|0)){K=0;H=82;break a}a=f[c>>2]|0;if(a>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[a>>0]|0)!=66)continue a;f[c>>2]=a+1}f[o>>2]=f[o>>2]|64;a=f[z>>2]|0;if((a|0)==497760){jza(z,497760);ha=f[z>>2]|0}else ha=a;if(!(fqb(c,ha)|0)){K=0;H=82;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[A>>2]|0){H=75;break a}if((f[B>>2]|0)==(f[C>>2]|0)){H=75;break a}else continue a}while(0);if((H|0)==76){H=0;if(!J){K=1;H=82;break}else L=J}if((L&7|0)==4){K=1;H=82;break}a=f[D>>2]|0;if(!(a&1))ia=hBa(D)|0;else ia=a&-2;if(!(ZPb(c,L,ia)|0)){K=0;H=82;break}}if((H|0)==57){K=0;u=d;return K|0}else if((H|0)==75){f[i>>2]=0;b[c+24>>0]=1;K=1;u=d;return K|0}else if((H|0)==82){u=d;return K|0}return 0}function Wwb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+8|0;d=f[c>>2]|0;if(d&126){if(!(d&2)){e=0;g=d}else{h=f[a+32>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&4)){n=e;o=g}else{g=a+48|0;l=e+1+(job(f[g>>2]|0,f[g+4>>2]|0)|0)|0;n=l;o=f[c>>2]|0}if(!(o&8)){p=n;q=o}else{o=a+56|0;l=n+1+(job(f[o>>2]|0,f[o+4>>2]|0)|0)|0;p=l;q=f[c>>2]|0}l=q&16|0?p+9|0:p;if(!(q&32)){r=l;s=q}else{p=f[a+36>>2]|0;o=b[p+11>>0]|0;if(o<<24>>24<0){n=f[p+4>>2]|0;if(n>>>0<128){t=1;u=q;v=n}else{p=iob(n)|0;t=p;u=f[c>>2]|0;v=n}}else{t=1;u=q;v=o&255}r=l+1+v+t|0;s=u}if(!(s&64))w=r;else{s=f[a+40>>2]|0;u=b[s+11>>0]|0;if(u<<24>>24<0){t=f[s+4>>2]|0;if(t>>>0<128){x=1;y=t}else{x=iob(t)|0;y=t}}else{x=1;y=u&255}w=r+1+y+x|0}}else w=0;x=f[a+20>>2]|0;y=x+w|0;if(!x)z=y;else{w=a+28|0;r=0;u=y;while(1){y=Ewb(f[(f[w>>2]|0)+4+(r<<2)>>2]|0)|0;if(y>>>0<128)A=1;else A=iob(y)|0;t=y+u+A|0;r=r+1|0;if((r|0)==(x|0)){z=t;break}else u=t}}u=f[a+4>>2]|0;if(!(u&1)){B=z;C=a+12|0;f[C>>2]=B;return B|0}B=(dQb(u&-2)|0)+z|0;C=a+12|0;f[C>>2]=B;return B|0}function Xwb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a+20>>2]|0;if(c|0){d=a+28|0;e=0;do{eqb(2,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=a+8|0;e=f[c>>2]|0;if(!(e&2))g=e;else{$pb(3,f[a+32>>2]|0,b);g=f[c>>2]|0}if(!(g&4))h=g;else{g=a+48|0;Ppb(4,f[g>>2]|0,f[g+4>>2]|0,b);h=f[c>>2]|0}if(!(h&8))i=h;else{h=a+56|0;Npb(5,f[h>>2]|0,f[h+4>>2]|0,b);i=f[c>>2]|0}if(!(i&16))j=i;else{Xpb(6,+p[a+64>>3],b);j=f[c>>2]|0}if(!(j&32))k=j;else{bqb(7,f[a+36>>2]|0,b);k=f[c>>2]|0}if(k&64|0)$pb(8,f[a+40>>2]|0,b);k=f[a+4>>2]|0;if(!(k&1))return;aQb(k&-2,b);return}function Ywb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function Zwb(a){a=a|0;return f[a+12>>2]|0}function _wb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0;c=f[a+20>>2]|0;if(!c)e=d;else{g=a+28|0;h=0;i=d;while(1){d=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=18;j=i+1|0;k=f[d+12>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{q=o;r=n;break}}}else{q=j;r=k}b[q>>0]=r;m=li[f[(f[d>>2]|0)+68>>2]&511](d,0,q+1|0)|0;h=h+1|0;if((h|0)==(c|0)){e=m;break}else i=m}}i=a+8|0;c=f[i>>2]|0;if(!(c&2)){t=e;u=c}else{c=f[a+32>>2]|0;b[e>>0]=26;h=kob(c,e+1|0)|0;t=h;u=f[i>>2]|0}if(!(u&4)){v=t;w=u}else{u=a+48|0;h=f[u>>2]|0;e=f[u+4>>2]|0;b[t>>0]=32;u=hob(h,e,t+1|0)|0;v=u;w=f[i>>2]|0}if(!(w&8)){x=v;y=w}else{w=a+56|0;u=f[w>>2]|0;t=f[w+4>>2]|0;b[v>>0]=40;w=hob(u,t,v+1|0)|0;x=w;y=f[i>>2]|0}if(!(y&16)){z=x;A=y}else{B=+p[a+64>>3];b[x>>0]=49;y=x+1|0;p[s>>3]=B;b[y>>0]=b[s>>0];b[y+1>>0]=b[s+1>>0];b[y+2>>0]=b[s+2>>0];b[y+3>>0]=b[s+3>>0];b[y+4>>0]=b[s+4>>0];b[y+5>>0]=b[s+5>>0];b[y+6>>0]=b[s+6>>0];b[y+7>>0]=b[s+7>>0];z=x+9|0;A=f[i>>2]|0}if(!(A&32)){C=z;D=A}else{A=f[a+36>>2]|0;b[z>>0]=58;x=kob(A,z+1|0)|0;C=x;D=f[i>>2]|0}if(!(D&64))E=C;else{D=f[a+40>>2]|0;b[C>>0]=66;E=kob(D,C+1|0)|0}C=f[a+4>>2]|0;if(!(C&1)){F=E;return F|0}F=bQb(C&-2,E)|0;return F|0}function $wb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function axb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(13683);c=T6b(b,23288,22744,0)|0;if(!c){cOb(b,a);return}else{dxb(a,c);return}}function bxb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function cxb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213417];f[a+4>>2]=f[213418];u=c;return}function dxb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;exb(a+16|0,b+16|0);i=b+8|0;j=f[i>>2]|0;if(j&510|0){if(!(j&2))k=j;else{j=a+8|0;f[j>>2]=f[j>>2]|2;f[e>>2]=f[b+32>>2];f[d>>2]=f[e>>2];Anb(a+32|0,497760,d);k=f[i>>2]|0}if(!(k&4))l=k;else{k=b+48|0;e=f[k>>2]|0;j=f[k+4>>2]|0;k=a+8|0;f[k>>2]=f[k>>2]|4;k=a+48|0;f[k>>2]=e;f[k+4>>2]=j;l=f[i>>2]|0}if(!(l&8))m=l;else{l=b+56|0;j=f[l>>2]|0;k=f[l+4>>2]|0;l=a+8|0;f[l>>2]=f[l>>2]|8;l=a+56|0;f[l>>2]=j;f[l+4>>2]=k;m=f[i>>2]|0}if(!(m&16))n=m;else{o=+p[b+64>>3];m=a+8|0;f[m>>2]=f[m>>2]|16;p[a+64>>3]=o;n=f[i>>2]|0}if(!(n&32))q=n;else{n=a+8|0;f[n>>2]=f[n>>2]|32;f[g>>2]=f[b+36>>2];f[d>>2]=f[g>>2];Anb(a+36|0,497760,d);q=f[i>>2]|0}if(q&64|0){q=a+8|0;f[q>>2]=f[q>>2]|64;f[h>>2]=f[b+40>>2];f[d>>2]=f[h>>2];Anb(a+40|0,497760,d)}}d=f[b+4>>2]|0;if(!(d&1)){u=c;return}LPb(d&-2,a+4|0);u=c;return}function exb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{fxb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=gxb(h,i)|0;fxb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function fxb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d+4|0;g=d;if((a|0)==(c|0))ivb(13174);h=a+8|0;i=f[h>>2]|0;if(i&255|0){if(!(i&1))j=i;else{i=c+8|0;f[i>>2]=f[i>>2]|1;f[g>>2]=f[a+16>>2];f[e>>2]=f[g>>2];Anb(c+16|0,497760,e);j=f[h>>2]|0}if(j&2|0){j=b[a+20>>0]|0;h=c+8|0;f[h>>2]=f[h>>2]|2;b[c+20>>0]=j}}j=f[a+4>>2]|0;if(!(j&1)){u=d;return}LPb(j&-2,c+4|0);u=d;return}function gxb(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=hxb(b,c)|0;u=a;return d|0}function hxb(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(24)|0;Nwb(b);c=b;return c|0}else{b=znb(a,22728,24)|0;Nwb(b);xnb(a,b,1523);c=b;return c|0}return 0}function ixb(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function jxb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=138808;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=499016?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;f[a+32>>2]=497760;f[a+36>>2]=497760;f[a+40>>2]=497760;d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;u=c;return}function kxb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function lxb(a){a=a|0;var c=0,d=0;c=a+32|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+36|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+40|0;a=f[c>>2]|0;if((a|0)==497760|(a|0)==0){f[c>>2]=0;return}if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a);f[c>>2]=0;return}function mxb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=138700;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)GPb(h);O5b(c)}f[b>>2]=0;tQb(a+4|0);return}function nxb(a){a=a|0;mxb(a);O5b(a);return}function oxb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function pxb(a,b){a=a|0;b=b|0;a=L5b(52)|0;Hxb(a);if(!b)return a|0;Ixb(b,a);return a|0}function qxb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;RRb(a+4|0);b[a+48>>0]=0;c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}f[a+24>>2]=0;c=f[a+20>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function rxb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+44|0;c=f[a+36>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=5;break}}if((g|0)==5)return e|0;e=WRb(a+4|0)|0;return e|0}function sxb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+24|0;k=a+48|0;l=e+8|0;m=c+44|0;n=a+32|0;o=a+44|0;p=a+40|0;q=a+36|0;r=c+32|0;s=c+12|0;t=c+28|0;v=a+4|0;w=a+20|0;a:while(1){a=f[c>>2]|0;x=f[g>>2]|0;do if(a>>>0<x>>>0){y=b[a>>0]|0;z=y&255;if(y<<24>>24>0){A=z;B=1}else{y=a+1|0;if(y>>>0>=x>>>0){C=z;D=7;break}E=h[y>>0]|0;if(((E^128)&z)>>>0<=127){C=z;D=7;break}A=z+-128+(E<<7)|0;B=2}f[i>>2]=A;f[c>>2]=a+B;F=A;D=9}else{C=0;D=7}while(0);if((D|0)==7){D=0;a=_nb(c,C)|0;f[i>>2]=a;if((a+-1|0)>>>0<16383){F=a;D=9}else{G=a;D=39}}b:do if((D|0)==9){D=0;c:do switch(F>>>3&536870911|0){case 33:{switch(F|0){case 0:{H=1;D=50;break a;break}case 264:break;default:{I=F;break b}}f[j>>2]=f[j>>2]|1;a=f[c>>2]|0;x=f[g>>2]|0;E=x;if(a>>>0<x>>>0?(x=b[a>>0]|0,x<<24>>24>-1):0){z=a+1|0;f[c>>2]=z;J=x<<24>>24!=0;K=z;L=E}else{Lnb(e,c);E=e;if(!(b[l>>0]|0)){H=0;D=50;break a}J=(f[E>>2]|0)!=0|(f[E+4>>2]|0)!=0;K=f[c>>2]|0;L=f[g>>2]|0}b[k>>0]=J&1;E=K;if((L-K|0)<=1)continue a;if((b[E>>0]|0)!=-70)continue a;if((b[E+1>>0]|0)!=62)continue a;f[c>>2]=E+2;break}case 999:{if((F|0)<7994)switch(F|0){case 0:{H=1;D=50;break a;break}default:{I=F;break b}}else switch(F|0){case 7994:{break c;break}default:{I=F;break b}}break}default:{G=F;D=39;break b}}while(0);E=f[m>>2]|0;f[m>>2]=E+-1;if((E|0)<=0){H=0;D=50;break a}while(1){E=f[o>>2]|0;do if(E){z=f[q>>2]|0;x=f[E>>2]|0;if((z|0)>=(x|0))if((x|0)==(f[p>>2]|0)){M=x;D=27;break}else{N=x;O=E;D=28;break}else{f[q>>2]=z+1;P=f[E+4+(z<<2)>>2]|0;break}}else{M=f[p>>2]|0;D=27}while(0);if((D|0)==27){D=0;cpb(n,M+1|0);E=f[o>>2]|0;N=f[E>>2]|0;O=E;D=28}if((D|0)==28){D=0;f[O>>2]=N+1;E=Exb(0,f[n>>2]|0)|0;z=f[o>>2]|0;x=f[q>>2]|0;f[q>>2]=x+1;f[z+4+(x<<2)>>2]=E;P=E}E=Jnb(c)|0;if(!(Vwb(P,c)|0)){H=0;D=50;break a}if(!(Pnb(c,E)|0)){H=0;D=50;break a}Q=f[g>>2]|0;E=f[c>>2]|0;R=E;if((Q-E|0)<=1)break;if((b[R>>0]|0)!=-70)break;if((b[R+1>>0]|0)!=62)break;f[c>>2]=R+2}f[m>>2]=(f[m>>2]|0)+1;if((R|0)!=(Q|0))continue a;if(f[r>>2]|0){D=38;break a}if((f[s>>2]|0)==(f[t>>2]|0)){D=38;break a}else continue a}while(0);if((D|0)==39){D=0;if(!G){H=1;D=50;break}else I=G}if((I&7|0)==4){H=1;D=50;break}E=f[w>>2]|0;x=(E&1|0)==0;if(I>>>0>7999){if(x)S=hBa(w)|0;else S=E&-2;if(FFb(v,I,c,498952,S)|0)continue;else{H=0;D=50;break}}else{if(x)T=hBa(w)|0;else T=E&-2;if(ZPb(c,I,T)|0)continue;else{H=0;D=50;break}}}if((D|0)==38){f[i>>2]=0;b[c+24>>0]=1;H=1;u=d;return H|0}else if((D|0)==50){u=d;return H|0}return 0}function txb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+36>>2]|0;c=(f[a+24>>2]&1|0?3:0)+(b<<1)|0;if(!b)d=c;else{e=a+44|0;g=0;h=c;while(1){c=Wwb(f[(f[e>>2]|0)+4+(g<<2)>>2]|0)|0;if(c>>>0<128)i=1;else i=iob(c)|0;j=c+h+i|0;g=g+1|0;if((g|0)==(b|0)){d=j;break}else h=j}}h=(aSb(a+4|0)|0)+d|0;d=f[a+20>>2]|0;if(!(d&1)){k=h;l=a+28|0;f[l>>2]=k;return k|0}k=(dQb(d&-2)|0)+h|0;l=a+28|0;f[l>>2]=k;return k|0}function uxb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if(f[a+24>>2]&1|0)Ypb(33,(b[a+48>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{eqb(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}_Rb(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;aQb(d&-2,c);return}function vxb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function wxb(a){a=a|0;return f[a+28>>2]|0}function xxb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(!(f[a+24>>2]&1))e=d;else{c=b[a+48>>0]|0;b[d>>0]=-120;b[d+1>>0]=2;b[d+2>>0]=c;e=d+3|0}d=f[a+36>>2]|0;if(!d)g=e;else{c=a+44|0;h=0;i=e;while(1){e=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=-70;b[i+1>>0]=62;j=i+2|0;k=f[e+12>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=j;q=k}b[p>>0]=q;m=li[f[(f[e>>2]|0)+68>>2]&511](e,0,p+1|0)|0;h=h+1|0;if((h|0)==(d|0)){g=m;break}else i=m}}i=JFb(a+4|0,1e3,536870912,0,g)|0;g=f[a+20>>2]|0;if(!(g&1)){r=i;return r|0}r=bQb(g&-2,i)|0;return r|0}function yxb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function zxb(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)==(c|0))ivb(12769);d=T6b(c,23288,22760,0)|0;if(!d){cOb(c,a);return}Cxb(a+32|0,d+32|0);if(f[d+24>>2]&1|0){c=b[d+48>>0]|0;e=a+24|0;f[e>>2]=f[e>>2]|1;b[a+48>>0]=c}SRb(a+4|0,d+4|0);c=f[d+20>>2]|0;if(!(c&1))return;LPb(c&-2,a+20|0);return}function Axb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function Bxb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213415];f[a+4>>2]=f[213416];u=c;return}function Cxb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{Dxb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Exb(h,i)|0;Dxb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function Dxb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))ivb(13701);else{dxb(b,a);return}}function Exb(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=Fxb(b,c)|0;u=a;return d|0}function Fxb(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(72)|0;jxb(b);c=b;return c|0}else{b=znb(a,22744,72)|0;jxb(b);xnb(a,b,1524);c=b;return c|0}return 0}function Gxb(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function Hxb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=138700;sQb(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=498952?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+28>>2]=0;b[a+48>>0]=0;u=c;return}function Ixb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function Jxb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=138592;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)GPb(h);O5b(c)}f[b>>2]=0;tQb(a+4|0);return}function Kxb(a){a=a|0;Jxb(a);O5b(a);return}function Lxb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Mxb(a,b){a=a|0;b=b|0;a=L5b(52)|0;Zxb(a);if(!b)return a|0;_xb(b,a);return a|0}function Nxb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;RRb(a+4|0);b[a+48>>0]=0;c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}f[a+24>>2]=0;c=f[a+20>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function Oxb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+44|0;c=f[a+36>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=5;break}}if((g|0)==5)return e|0;e=WRb(a+4|0)|0;return e|0}function Pxb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+24|0;k=a+48|0;l=e+8|0;m=c+44|0;n=a+32|0;o=a+44|0;p=a+40|0;q=a+36|0;r=c+32|0;s=c+12|0;t=c+28|0;v=a+4|0;w=a+20|0;a:while(1){a=f[c>>2]|0;x=f[g>>2]|0;do if(a>>>0<x>>>0){y=b[a>>0]|0;z=y&255;if(y<<24>>24>0){A=z;B=1}else{y=a+1|0;if(y>>>0>=x>>>0){C=z;D=7;break}E=h[y>>0]|0;if(((E^128)&z)>>>0<=127){C=z;D=7;break}A=z+-128+(E<<7)|0;B=2}f[i>>2]=A;f[c>>2]=a+B;F=A;D=9}else{C=0;D=7}while(0);if((D|0)==7){D=0;a=_nb(c,C)|0;f[i>>2]=a;if((a+-1|0)>>>0<16383){F=a;D=9}else{G=a;D=39}}b:do if((D|0)==9){D=0;c:do switch(F>>>3&536870911|0){case 33:{switch(F|0){case 0:{H=1;D=50;break a;break}case 264:break;default:{I=F;break b}}f[j>>2]=f[j>>2]|1;a=f[c>>2]|0;x=f[g>>2]|0;E=x;if(a>>>0<x>>>0?(x=b[a>>0]|0,x<<24>>24>-1):0){z=a+1|0;f[c>>2]=z;J=x<<24>>24!=0;K=z;L=E}else{Lnb(e,c);E=e;if(!(b[l>>0]|0)){H=0;D=50;break a}J=(f[E>>2]|0)!=0|(f[E+4>>2]|0)!=0;K=f[c>>2]|0;L=f[g>>2]|0}b[k>>0]=J&1;E=K;if((L-K|0)<=1)continue a;if((b[E>>0]|0)!=-70)continue a;if((b[E+1>>0]|0)!=62)continue a;f[c>>2]=E+2;break}case 999:{if((F|0)<7994)switch(F|0){case 0:{H=1;D=50;break a;break}default:{I=F;break b}}else switch(F|0){case 7994:{break c;break}default:{I=F;break b}}break}default:{G=F;D=39;break b}}while(0);E=f[m>>2]|0;f[m>>2]=E+-1;if((E|0)<=0){H=0;D=50;break a}while(1){E=f[o>>2]|0;do if(E){z=f[q>>2]|0;x=f[E>>2]|0;if((z|0)>=(x|0))if((x|0)==(f[p>>2]|0)){M=x;D=27;break}else{N=x;O=E;D=28;break}else{f[q>>2]=z+1;P=f[E+4+(z<<2)>>2]|0;break}}else{M=f[p>>2]|0;D=27}while(0);if((D|0)==27){D=0;cpb(n,M+1|0);E=f[o>>2]|0;N=f[E>>2]|0;O=E;D=28}if((D|0)==28){D=0;f[O>>2]=N+1;E=Exb(0,f[n>>2]|0)|0;z=f[o>>2]|0;x=f[q>>2]|0;f[q>>2]=x+1;f[z+4+(x<<2)>>2]=E;P=E}E=Jnb(c)|0;if(!(Vwb(P,c)|0)){H=0;D=50;break a}if(!(Pnb(c,E)|0)){H=0;D=50;break a}Q=f[g>>2]|0;E=f[c>>2]|0;R=E;if((Q-E|0)<=1)break;if((b[R>>0]|0)!=-70)break;if((b[R+1>>0]|0)!=62)break;f[c>>2]=R+2}f[m>>2]=(f[m>>2]|0)+1;if((R|0)!=(Q|0))continue a;if(f[r>>2]|0){D=38;break a}if((f[s>>2]|0)==(f[t>>2]|0)){D=38;break a}else continue a}while(0);if((D|0)==39){D=0;if(!G){H=1;D=50;break}else I=G}if((I&7|0)==4){H=1;D=50;break}E=f[w>>2]|0;x=(E&1|0)==0;if(I>>>0>7999){if(x)S=hBa(w)|0;else S=E&-2;if(FFb(v,I,c,498888,S)|0)continue;else{H=0;D=50;break}}else{if(x)T=hBa(w)|0;else T=E&-2;if(ZPb(c,I,T)|0)continue;else{H=0;D=50;break}}}if((D|0)==38){f[i>>2]=0;b[c+24>>0]=1;H=1;u=d;return H|0}else if((D|0)==50){u=d;return H|0}return 0}function Qxb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+36>>2]|0;c=(f[a+24>>2]&1|0?3:0)+(b<<1)|0;if(!b)d=c;else{e=a+44|0;g=0;h=c;while(1){c=Wwb(f[(f[e>>2]|0)+4+(g<<2)>>2]|0)|0;if(c>>>0<128)i=1;else i=iob(c)|0;j=c+h+i|0;g=g+1|0;if((g|0)==(b|0)){d=j;break}else h=j}}h=(aSb(a+4|0)|0)+d|0;d=f[a+20>>2]|0;if(!(d&1)){k=h;l=a+28|0;f[l>>2]=k;return k|0}k=(dQb(d&-2)|0)+h|0;l=a+28|0;f[l>>2]=k;return k|0}function Rxb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if(f[a+24>>2]&1|0)Ypb(33,(b[a+48>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{eqb(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}_Rb(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;aQb(d&-2,c);return}function Sxb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function Txb(a){a=a|0;return f[a+28>>2]|0}function Uxb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(!(f[a+24>>2]&1))e=d;else{c=b[a+48>>0]|0;b[d>>0]=-120;b[d+1>>0]=2;b[d+2>>0]=c;e=d+3|0}d=f[a+36>>2]|0;if(!d)g=e;else{c=a+44|0;h=0;i=e;while(1){e=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=-70;b[i+1>>0]=62;j=i+2|0;k=f[e+12>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=j;q=k}b[p>>0]=q;m=li[f[(f[e>>2]|0)+68>>2]&511](e,0,p+1|0)|0;h=h+1|0;if((h|0)==(d|0)){g=m;break}else i=m}}i=JFb(a+4|0,1e3,536870912,0,g)|0;g=f[a+20>>2]|0;if(!(g&1)){r=i;return r|0}r=bQb(g&-2,i)|0;return r|0}function Vxb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Wxb(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)==(c|0))ivb(12394);d=T6b(c,23288,22776,0)|0;if(!d){cOb(c,a);return}Cxb(a+32|0,d+32|0);if(f[d+24>>2]&1|0){c=b[d+48>>0]|0;e=a+24|0;f[e>>2]=f[e>>2]|1;b[a+48>>0]=c}SRb(a+4|0,d+4|0);c=f[d+20>>2]|0;if(!(c&1))return;LPb(c&-2,a+20|0);return}function Xxb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function Yxb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213413];f[a+4>>2]=f[213414];u=c;return}function Zxb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=138592;sQb(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=498888?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+28>>2]=0;b[a+48>>0]=0;u=c;return}function _xb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function $xb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=138484;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)GPb(h);O5b(c)}f[b>>2]=0;tQb(a+4|0);return}function ayb(a){a=a|0;$xb(a);O5b(a);return}function byb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function cyb(a,b){a=a|0;b=b|0;a=L5b(52)|0;pyb(a);if(!b)return a|0;qyb(b,a);return a|0}function dyb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;RRb(a+4|0);b[a+48>>0]=0;c=a+36|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+44>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(d|0));f[c>>2]=0}f[a+24>>2]=0;c=f[a+20>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function eyb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+44|0;c=f[a+36>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=5;break}}if((g|0)==5)return e|0;e=WRb(a+4|0)|0;return e|0}function fyb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+24|0;k=a+48|0;l=e+8|0;m=c+44|0;n=a+32|0;o=a+44|0;p=a+40|0;q=a+36|0;r=c+32|0;s=c+12|0;t=c+28|0;v=a+4|0;w=a+20|0;a:while(1){a=f[c>>2]|0;x=f[g>>2]|0;do if(a>>>0<x>>>0){y=b[a>>0]|0;z=y&255;if(y<<24>>24>0){A=z;B=1}else{y=a+1|0;if(y>>>0>=x>>>0){C=z;D=7;break}E=h[y>>0]|0;if(((E^128)&z)>>>0<=127){C=z;D=7;break}A=z+-128+(E<<7)|0;B=2}f[i>>2]=A;f[c>>2]=a+B;F=A;D=9}else{C=0;D=7}while(0);if((D|0)==7){D=0;a=_nb(c,C)|0;f[i>>2]=a;if((a+-1|0)>>>0<16383){F=a;D=9}else{G=a;D=39}}b:do if((D|0)==9){D=0;c:do switch(F>>>3&536870911|0){case 1:{switch(F|0){case 0:{H=1;D=50;break a;break}case 8:break;default:{I=F;break b}}f[j>>2]=f[j>>2]|1;a=f[c>>2]|0;x=f[g>>2]|0;E=x;if(a>>>0<x>>>0?(x=b[a>>0]|0,x<<24>>24>-1):0){z=a+1|0;f[c>>2]=z;J=x<<24>>24!=0;K=z;L=E}else{Lnb(e,c);E=e;if(!(b[l>>0]|0)){H=0;D=50;break a}J=(f[E>>2]|0)!=0|(f[E+4>>2]|0)!=0;K=f[c>>2]|0;L=f[g>>2]|0}b[k>>0]=J&1;E=K;if((L-K|0)<=1)continue a;if((b[E>>0]|0)!=-70)continue a;if((b[E+1>>0]|0)!=62)continue a;f[c>>2]=E+2;break}case 999:{if((F|0)<7994)switch(F|0){case 0:{H=1;D=50;break a;break}default:{I=F;break b}}else switch(F|0){case 7994:{break c;break}default:{I=F;break b}}break}default:{G=F;D=39;break b}}while(0);E=f[m>>2]|0;f[m>>2]=E+-1;if((E|0)<=0){H=0;D=50;break a}while(1){E=f[o>>2]|0;do if(E){z=f[q>>2]|0;x=f[E>>2]|0;if((z|0)>=(x|0))if((x|0)==(f[p>>2]|0)){M=x;D=27;break}else{N=x;O=E;D=28;break}else{f[q>>2]=z+1;P=f[E+4+(z<<2)>>2]|0;break}}else{M=f[p>>2]|0;D=27}while(0);if((D|0)==27){D=0;cpb(n,M+1|0);E=f[o>>2]|0;N=f[E>>2]|0;O=E;D=28}if((D|0)==28){D=0;f[O>>2]=N+1;E=Exb(0,f[n>>2]|0)|0;z=f[o>>2]|0;x=f[q>>2]|0;f[q>>2]=x+1;f[z+4+(x<<2)>>2]=E;P=E}E=Jnb(c)|0;if(!(Vwb(P,c)|0)){H=0;D=50;break a}if(!(Pnb(c,E)|0)){H=0;D=50;break a}Q=f[g>>2]|0;E=f[c>>2]|0;R=E;if((Q-E|0)<=1)break;if((b[R>>0]|0)!=-70)break;if((b[R+1>>0]|0)!=62)break;f[c>>2]=R+2}f[m>>2]=(f[m>>2]|0)+1;if((R|0)!=(Q|0))continue a;if(f[r>>2]|0){D=38;break a}if((f[s>>2]|0)==(f[t>>2]|0)){D=38;break a}else continue a}while(0);if((D|0)==39){D=0;if(!G){H=1;D=50;break}else I=G}if((I&7|0)==4){H=1;D=50;break}E=f[w>>2]|0;x=(E&1|0)==0;if(I>>>0>7999){if(x)S=hBa(w)|0;else S=E&-2;if(FFb(v,I,c,498824,S)|0)continue;else{H=0;D=50;break}}else{if(x)T=hBa(w)|0;else T=E&-2;if(ZPb(c,I,T)|0)continue;else{H=0;D=50;break}}}if((D|0)==38){f[i>>2]=0;b[c+24>>0]=1;H=1;u=d;return H|0}else if((D|0)==50){u=d;return H|0}return 0}function gyb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+36>>2]|0;c=(f[a+24>>2]<<1&2)+(b<<1)|0;if(!b)d=c;else{e=a+44|0;g=0;h=c;while(1){c=Wwb(f[(f[e>>2]|0)+4+(g<<2)>>2]|0)|0;if(c>>>0<128)i=1;else i=iob(c)|0;j=c+h+i|0;g=g+1|0;if((g|0)==(b|0)){d=j;break}else h=j}}h=(aSb(a+4|0)|0)+d|0;d=f[a+20>>2]|0;if(!(d&1)){k=h;l=a+28|0;f[l>>2]=k;return k|0}k=(dQb(d&-2)|0)+h|0;l=a+28|0;f[l>>2]=k;return k|0}function hyb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;if(f[a+24>>2]&1|0)Ypb(1,(b[a+48>>0]|0)!=0,c);d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{eqb(999,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}_Rb(a+4|0,1e3,536870912,c);d=f[a+20>>2]|0;if(!(d&1))return;aQb(d&-2,c);return}function iyb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function jyb(a){a=a|0;return f[a+28>>2]|0}function kyb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(!(f[a+24>>2]&1))e=d;else{c=b[a+48>>0]|0;b[d>>0]=8;b[d+1>>0]=c;e=d+2|0}d=f[a+36>>2]|0;if(!d)g=e;else{c=a+44|0;h=0;i=e;while(1){e=f[(f[c>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=-70;b[i+1>>0]=62;j=i+2|0;k=f[e+12>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=j;q=k}b[p>>0]=q;m=li[f[(f[e>>2]|0)+68>>2]&511](e,0,p+1|0)|0;h=h+1|0;if((h|0)==(d|0)){g=m;break}else i=m}}i=JFb(a+4|0,1e3,536870912,0,g)|0;g=f[a+20>>2]|0;if(!(g&1)){r=i;return r|0}r=bQb(g&-2,i)|0;return r|0}function lyb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function myb(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)==(c|0))ivb(12019);d=T6b(c,23288,22792,0)|0;if(!d){cOb(c,a);return}Cxb(a+32|0,d+32|0);if(f[d+24>>2]&1|0){c=b[d+48>>0]|0;e=a+24|0;f[e>>2]=f[e>>2]|1;b[a+48>>0]=c}SRb(a+4|0,d+4|0);c=f[d+20>>2]|0;if(!(c&1))return;LPb(c&-2,a+20|0);return}function nyb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function oyb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213411];f[a+4>>2]=f[213412];u=c;return}function pyb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=138484;sQb(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=498824?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+28>>2]=0;b[a+48>>0]=0;u=c;return}function qyb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function ryb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=138376;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)GPb(h);O5b(c)}f[b>>2]=0;tQb(a+4|0);return}function syb(a){a=a|0;ryb(a);O5b(a);return}function tyb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function uyb(a,b){a=a|0;b=b|0;a=L5b(52)|0;Hyb(a);if(!b)return a|0;Iyb(b,a);return a|0}function vyb(a){a=a|0;var b=0,c=0,e=0,g=0,h=0;RRb(a+4|0);d[a+48>>1]=0;b=a+36|0;c=f[b>>2]|0;if((c|0)>0){e=f[a+44>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((g|0)!=(c|0));f[b>>2]=0}f[a+24>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function wyb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+44|0;c=f[a+36>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=5;break}}if((g|0)==5)return e|0;e=WRb(a+4|0)|0;return e|0}function xyb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+24|0;k=a+48|0;l=e+8|0;m=a+49|0;n=e+8|0;o=c+44|0;p=a+32|0;q=a+44|0;r=a+40|0;s=a+36|0;t=c+32|0;v=c+12|0;w=c+28|0;x=a+4|0;y=a+20|0;a:while(1){a=f[c>>2]|0;z=f[g>>2]|0;do if(a>>>0<z>>>0){A=b[a>>0]|0;B=A&255;if(A<<24>>24>0){C=B;D=1}else{A=a+1|0;if(A>>>0>=z>>>0){E=B;F=7;break}G=h[A>>0]|0;if(((G^128)&B)>>>0<=127){E=B;F=7;break}C=B+-128+(G<<7)|0;D=2}f[i>>2]=C;f[c>>2]=a+D;H=C;F=9}else{E=0;F=7}while(0);if((F|0)==7){F=0;a=_nb(c,E)|0;f[i>>2]=a;if((a+-1|0)>>>0<16383){H=a;F=9}else{I=a;F=49}}b:do if((F|0)==9){F=0;c:do switch(H>>>3&536870911|0){case 2:{switch(H|0){case 0:{J=1;F=60;break a;break}case 16:break;default:{K=H;break b}}f[j>>2]=f[j>>2]|1;a=f[c>>2]|0;z=f[g>>2]|0;if(a>>>0<z>>>0?(G=b[a>>0]|0,G<<24>>24>-1):0){B=a+1|0;f[c>>2]=B;L=z;M=G<<24>>24!=0;N=B}else{Lnb(e,c);B=e;if(!(b[l>>0]|0)){J=0;F=60;break a}L=f[g>>2]|0;M=(f[B>>2]|0)!=0|(f[B+4>>2]|0)!=0;N=f[c>>2]|0}b[k>>0]=M&1;if(N>>>0>=L>>>0)continue a;if((b[N>>0]|0)!=24)continue a;B=N+1|0;f[c>>2]=B;O=L;P=B;F=21;break}case 3:{switch(H|0){case 0:{J=1;F=60;break a;break}case 24:break;default:{K=H;break b}}O=f[g>>2]|0;P=f[c>>2]|0;F=21;break}case 999:{if((H|0)<7994)switch(H|0){case 0:{J=1;F=60;break a;break}default:{K=H;break b}}else switch(H|0){case 7994:{break c;break}default:{K=H;break b}}break}default:{I=H;F=49;break b}}while(0);if((F|0)==21){F=0;B=O;f[j>>2]=f[j>>2]|2;if(P>>>0<O>>>0?(G=b[P>>0]|0,G<<24>>24>-1):0){z=P+1|0;f[c>>2]=z;Q=G<<24>>24!=0;R=z;S=B}else{Lnb(e,c);B=e;if(!(b[n>>0]|0)){J=0;F=60;break a}Q=(f[B>>2]|0)!=0|(f[B+4>>2]|0)!=0;R=f[c>>2]|0;S=f[g>>2]|0}b[m>>0]=Q&1;B=R;if((S-R|0)<=1)continue a;if((b[B>>0]|0)!=-70)continue a;if((b[B+1>>0]|0)!=62)continue a;f[c>>2]=B+2}B=f[o>>2]|0;f[o>>2]=B+-1;if((B|0)<=0){J=0;F=60;break a}while(1){B=f[q>>2]|0;do if(B){z=f[s>>2]|0;G=f[B>>2]|0;if((z|0)>=(G|0))if((G|0)==(f[r>>2]|0)){T=G;F=37;break}else{U=G;V=B;F=38;break}else{f[s>>2]=z+1;W=f[B+4+(z<<2)>>2]|0;break}}else{T=f[r>>2]|0;F=37}while(0);if((F|0)==37){F=0;cpb(p,T+1|0);B=f[q>>2]|0;U=f[B>>2]|0;V=B;F=38}if((F|0)==38){F=0;f[V>>2]=U+1;B=Exb(0,f[p>>2]|0)|0;z=f[q>>2]|0;G=f[s>>2]|0;f[s>>2]=G+1;f[z+4+(G<<2)>>2]=B;W=B}B=Jnb(c)|0;if(!(Vwb(W,c)|0)){J=0;F=60;break a}if(!(Pnb(c,B)|0)){J=0;F=60;break a}X=f[g>>2]|0;B=f[c>>2]|0;Y=B;if((X-B|0)<=1)break;if((b[Y>>0]|0)!=-70)break;if((b[Y+1>>0]|0)!=62)break;f[c>>2]=Y+2}f[o>>2]=(f[o>>2]|0)+1;if((Y|0)!=(X|0))continue a;if(f[t>>2]|0){F=48;break a}if((f[v>>2]|0)==(f[w>>2]|0)){F=48;break a}else continue a}while(0);if((F|0)==49){F=0;if(!I){J=1;F=60;break}else K=I}if((K&7|0)==4){J=1;F=60;break}B=f[y>>2]|0;G=(B&1|0)==0;if(K>>>0>7999){if(G)Z=hBa(y)|0;else Z=B&-2;if(FFb(x,K,c,498760,Z)|0)continue;else{J=0;F=60;break}}else{if(G)_=hBa(y)|0;else _=B&-2;if(ZPb(c,K,_)|0)continue;else{J=0;F=60;break}}}if((F|0)==48){f[i>>2]=0;b[c+24>>0]=1;J=1;u=d;return J|0}else if((F|0)==60){u=d;return J|0}return 0}function yyb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+24>>2]|0;if(!(b&3))c=0;else{d=b<<1&2;c=b&2|0?d+2|0:d}d=f[a+36>>2]|0;b=(d<<1)+c|0;if(!d)e=b;else{c=a+44|0;g=0;h=b;while(1){b=Wwb(f[(f[c>>2]|0)+4+(g<<2)>>2]|0)|0;if(b>>>0<128)i=1;else i=iob(b)|0;j=b+h+i|0;g=g+1|0;if((g|0)==(d|0)){e=j;break}else h=j}}h=(aSb(a+4|0)|0)+e|0;e=f[a+20>>2]|0;if(!(e&1)){k=h;l=a+28|0;f[l>>2]=k;return k|0}k=(dQb(e&-2)|0)+h|0;l=a+28|0;f[l>>2]=k;return k|0}function zyb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=a+24|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Ypb(2,(b[a+48>>0]|0)!=0,c);g=f[d>>2]|0}if(g&2|0)Ypb(3,(b[a+49>>0]|0)!=0,c);g=f[a+36>>2]|0;if(g|0){d=a+44|0;e=0;do{eqb(999,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,c);e=e+1|0}while((e|0)!=(g|0))}_Rb(a+4|0,1e3,536870912,c);g=f[a+20>>2]|0;if(!(g&1))return;aQb(g&-2,c);return}function Ayb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function Byb(a){a=a|0;return f[a+28>>2]|0}function Cyb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+24|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=b[a+48>>0]|0;b[d>>0]=16;b[d+1>>0]=e;g=d+2|0;h=f[c>>2]|0}if(!(h&2))i=g;else{h=b[a+49>>0]|0;b[g>>0]=24;b[g+1>>0]=h;i=g+2|0}g=f[a+36>>2]|0;if(!g)j=i;else{h=a+44|0;c=0;d=i;while(1){i=f[(f[h>>2]|0)+4+(c<<2)>>2]|0;b[d>>0]=-70;b[d+1>>0]=62;e=d+2|0;k=f[i+12>>2]|0;if(k>>>0>127){l=k;m=e;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=e;q=k}b[p>>0]=q;m=li[f[(f[i>>2]|0)+68>>2]&511](i,0,p+1|0)|0;c=c+1|0;if((c|0)==(g|0)){j=m;break}else d=m}}d=JFb(a+4|0,1e3,536870912,0,j)|0;j=f[a+20>>2]|0;if(!(j&1)){r=d;return r|0}r=bQb(j&-2,d)|0;return r|0}function Dyb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Eyb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((a|0)==(c|0))ivb(11616);d=T6b(c,23288,22808,0)|0;if(!d){cOb(c,a);return}Cxb(a+32|0,d+32|0);c=d+24|0;e=f[c>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=b[d+48>>0]|0;h=a+24|0;f[h>>2]=f[h>>2]|1;b[a+48>>0]=e;g=f[c>>2]|0}if(g&2|0){g=b[d+49>>0]|0;c=a+24|0;f[c>>2]=f[c>>2]|2;b[a+49>>0]=g}}SRb(a+4|0,d+4|0);g=f[d+20>>2]|0;if(!(g&1))return;LPb(g&-2,a+20|0);return}function Fyb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function Gyb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213409];f[a+4>>2]=f[213410];u=c;return}function Hyb(a){a=a|0;var c=0,e=0,g=0;c=u;u=u+16|0;e=c;f[a>>2]=138376;sQb(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;g=a+32|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((a|0)!=498760?(f[213371]|0)!=2:0){f[e>>2]=135812;f[e+4>>2]=55;b[e+8>>0]=0;Gpb(853484,e);hpb(e)}f[a+28>>2]=0;d[a+48>>1]=0;u=c;return}function Iyb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function Jyb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=138268;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)GPb(h);O5b(c)}f[b>>2]=0;tQb(a+4|0);return}function Kyb(a){a=a|0;Jyb(a);O5b(a);return}function Lyb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Myb(a,b){a=a|0;b=b|0;a=L5b(48)|0;Zyb(a);if(!b)return a|0;_yb(b,a);return a|0}function Nyb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;RRb(a+4|0);b=a+36|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+44>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+24>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function Oyb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+44|0;c=f[a+36>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=5;break}}if((g|0)==5)return e|0;e=WRb(a+4|0)|0;return e|0}function Pyb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=c+4|0;e=c+20|0;g=a+4|0;i=a+20|0;j=c+44|0;k=a+32|0;l=a+44|0;m=a+40|0;n=a+36|0;a=c+32|0;o=c+12|0;p=c+28|0;a:while(1){q=f[c>>2]|0;r=f[d>>2]|0;do if(q>>>0<r>>>0){s=b[q>>0]|0;t=s&255;if(s<<24>>24>0){f[e>>2]=t;f[c>>2]=q+1;u=t;break}s=q+1|0;if(s>>>0<r>>>0?(v=h[s>>0]|0,((v^128)&t)>>>0>127):0){s=t+-128+(v<<7)|0;f[e>>2]=s;f[c>>2]=q+2;w=s;x=9}else{y=t;x=8}}else{y=0;x=8}while(0);if((x|0)==8){x=0;q=_nb(c,y)|0;f[e>>2]=q;if((q+-1|0)>>>0<16383){w=q;x=9}else u=q}if((x|0)==9){x=0;if((w|0)==7994){q=f[j>>2]|0;f[j>>2]=q+-1;if((q|0)<=0){z=0;x=38;break}while(1){q=f[l>>2]|0;do if(q){r=f[n>>2]|0;t=f[q>>2]|0;if((r|0)>=(t|0))if((t|0)==(f[m>>2]|0)){A=t;x=16;break}else{B=t;C=q;x=17;break}else{f[n>>2]=r+1;D=f[q+4+(r<<2)>>2]|0;break}}else{A=f[m>>2]|0;x=16}while(0);if((x|0)==16){x=0;cpb(k,A+1|0);q=f[l>>2]|0;B=f[q>>2]|0;C=q;x=17}if((x|0)==17){x=0;f[C>>2]=B+1;q=Exb(0,f[k>>2]|0)|0;r=f[l>>2]|0;t=f[n>>2]|0;f[n>>2]=t+1;f[r+4+(t<<2)>>2]=q;D=q}q=Jnb(c)|0;if(!(Vwb(D,c)|0)){z=0;x=38;break a}if(!(Pnb(c,q)|0)){z=0;x=38;break a}E=f[d>>2]|0;q=f[c>>2]|0;F=q;if((E-q|0)<=1)break;if((b[F>>0]|0)!=-70)break;if((b[F+1>>0]|0)!=62)break;f[c>>2]=F+2}f[j>>2]=(f[j>>2]|0)+1;if((F|0)!=(E|0))continue;if(f[a>>2]|0){x=27;break}if((f[o>>2]|0)==(f[p>>2]|0)){x=27;break}else continue}else u=w}if((u|0)==0|(u&7|0)==4){z=1;x=38;break}q=f[i>>2]|0;t=(q&1|0)==0;if(u>>>0>7999){if(t)G=hBa(i)|0;else G=q&-2;if(FFb(g,u,c,498704,G)|0)continue;else{z=0;x=38;break}}else{if(t)H=hBa(i)|0;else H=q&-2;if(ZPb(c,u,H)|0)continue;else{z=0;x=38;break}}}if((x|0)==27){f[e>>2]=0;b[c+24>>0]=1;z=1;return z|0}else if((x|0)==38)return z|0;return 0}function Qyb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+36>>2]|0;c=b<<1;if(!b)d=c;else{e=a+44|0;g=0;h=c;while(1){c=Wwb(f[(f[e>>2]|0)+4+(g<<2)>>2]|0)|0;if(c>>>0<128)i=1;else i=iob(c)|0;j=c+h+i|0;g=g+1|0;if((g|0)==(b|0)){d=j;break}else h=j}}h=(aSb(a+4|0)|0)+d|0;d=f[a+20>>2]|0;if(!(d&1)){k=h;l=a+28|0;f[l>>2]=k;return k|0}k=(dQb(d&-2)|0)+h|0;l=a+28|0;f[l>>2]=k;return k|0}function Ryb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+36>>2]|0;if(c|0){d=a+44|0;e=0;do{eqb(999,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}_Rb(a+4|0,1e3,536870912,b);c=f[a+20>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function Syb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function Tyb(a){a=a|0;return f[a+28>>2]|0}function Uyb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+36>>2]|0;if(!c)e=d;else{g=a+44|0;h=0;i=d;while(1){d=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=-70;b[i+1>>0]=62;j=i+2|0;k=f[d+12>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=j;q=k}b[p>>0]=q;m=li[f[(f[d>>2]|0)+68>>2]&511](d,0,p+1|0)|0;h=h+1|0;if((h|0)==(c|0)){e=m;break}else i=m}}i=JFb(a+4|0,1e3,536870912,0,e)|0;e=f[a+20>>2]|0;if(!(e&1)){r=i;return r|0}r=bQb(e&-2,i)|0;return r|0}function Vyb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Wyb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(11217);c=T6b(b,23288,22824,0)|0;if(!c){cOb(b,a);return}Cxb(a+32|0,c+32|0);SRb(a+4|0,c+4|0);b=f[c+20>>2]|0;if(!(b&1))return;LPb(b&-2,a+20|0);return}function Xyb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function Yyb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213407];f[a+4>>2]=f[213408];u=c;return}function Zyb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=138268;sQb(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=498704?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+28>>2]=0;u=c;return}function _yb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function $yb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=138160;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)GPb(h);O5b(c)}f[b>>2]=0;tQb(a+4|0);return}function azb(a){a=a|0;$yb(a);O5b(a);return}function bzb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function czb(a,b){a=a|0;b=b|0;a=L5b(60)|0;qzb(a);if(!b)return a|0;rzb(b,a);return a|0}function dzb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;RRb(a+4|0);b=a+48|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=a+36|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+44>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+24>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function ezb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+44|0;c=f[a+36>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=5;break}}if((g|0)==5)return e|0;e=WRb(a+4|0)|0;return e|0}function fzb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+24|0;k=a+48|0;l=a+20|0;m=a+56|0;n=e+8|0;o=a+58|0;p=e+8|0;q=a+57|0;r=e+8|0;s=a+52|0;t=a+59|0;v=e+8|0;w=c+44|0;x=a+32|0;y=a+44|0;z=a+40|0;A=a+36|0;B=c+32|0;C=c+12|0;D=c+28|0;E=a+4|0;a:while(1){a=f[c>>2]|0;F=f[g>>2]|0;do if(a>>>0<F>>>0){G=b[a>>0]|0;H=G&255;if(G<<24>>24>0){I=H;K=1}else{G=a+1|0;if(G>>>0>=F>>>0){L=H;M=7;break}N=h[G>>0]|0;if(((N^128)&H)>>>0<=127){L=H;M=7;break}I=H+-128+(N<<7)|0;K=2}f[i>>2]=I;f[c>>2]=a+K;O=I;M=9}else{L=0;M=7}while(0);if((M|0)==7){M=0;a=_nb(c,L)|0;f[i>>2]=a;if((a+-1|0)>>>0<16383){O=a;M=9}else{P=a;M=99}}b:do if((M|0)==9){M=0;c:do switch(O>>>3&536870911|0){case 1:{switch(O|0){case 0:{Q=1;M=110;break a;break}case 8:break;default:{R=O;break b}}a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){F=b[a>>0]|0;N=F&255;if(F<<24>>24>-1){f[c>>2]=a+1;S=N}else{T=N;M=14}}else{T=0;M=14}if((M|0)==14){M=0;N=Knb(c,T)|0;a=J;if((a|0)>-1|(a|0)==-1&N>>>0>4294967295)S=N;else{Q=0;M=110;break a}}if(S>>>0<3){f[j>>2]=f[j>>2]|1;f[k>>2]=S}else{N=f[l>>2]|0;if(!(N&1))U=hBa(l)|0;else U=N&-2;NPb(U,1,S,((S|0)<0)<<31>>31)}N=f[c>>2]|0;a=f[g>>2]|0;if(N>>>0>=a>>>0)continue a;if((b[N>>0]|0)!=16)continue a;F=N+1|0;f[c>>2]=F;V=F;W=a;M=26;break}case 2:{switch(O|0){case 0:{Q=1;M=110;break a;break}case 16:break;default:{R=O;break b}}V=f[c>>2]|0;W=f[g>>2]|0;M=26;break}case 3:{switch(O|0){case 0:{Q=1;M=110;break a;break}case 24:break;default:{R=O;break b}}X=f[c>>2]|0;Y=f[g>>2]|0;M=36;break}case 5:{switch(O|0){case 0:{Q=1;M=110;break a;break}case 40:break;default:{R=O;break b}}Z=f[c>>2]|0;_=f[g>>2]|0;M=46;break}case 6:{switch(O|0){case 0:{Q=1;M=110;break a;break}case 48:break;default:{R=O;break b}}$=f[c>>2]|0;aa=f[g>>2]|0;M=56;break}case 10:{switch(O|0){case 0:{Q=1;M=110;break a;break}case 80:break;default:{R=O;break b}}ba=f[g>>2]|0;ca=f[c>>2]|0;M=71;break}case 999:{if((O|0)<7994)switch(O|0){case 0:{Q=1;M=110;break a;break}default:{R=O;break b}}else switch(O|0){case 7994:{break c;break}default:{R=O;break b}}break}default:{P=O;M=99;break b}}while(0);if((M|0)==26){M=0;f[j>>2]=f[j>>2]|2;if(V>>>0<W>>>0?(a=b[V>>0]|0,a<<24>>24>-1):0){F=V+1|0;f[c>>2]=F;da=a<<24>>24!=0;ea=F;fa=W}else{Lnb(e,c);F=e;if(!(b[n>>0]|0)){Q=0;M=110;break a}da=(f[F>>2]|0)!=0|(f[F+4>>2]|0)!=0;ea=f[c>>2]|0;fa=f[g>>2]|0}b[m>>0]=da&1;if(ea>>>0>=fa>>>0)continue a;if((b[ea>>0]|0)!=24)continue a;F=ea+1|0;f[c>>2]=F;X=F;Y=fa;M=36}if((M|0)==36){M=0;f[j>>2]=f[j>>2]|16;if(X>>>0<Y>>>0?(F=b[X>>0]|0,F<<24>>24>-1):0){a=X+1|0;f[c>>2]=a;ga=F<<24>>24!=0;ha=a;ia=Y}else{Lnb(e,c);a=e;if(!(b[p>>0]|0)){Q=0;M=110;break a}ga=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0;ha=f[c>>2]|0;ia=f[g>>2]|0}b[o>>0]=ga&1;if(ha>>>0>=ia>>>0)continue a;if((b[ha>>0]|0)!=40)continue a;a=ha+1|0;f[c>>2]=a;Z=a;_=ia;M=46}if((M|0)==46){M=0;f[j>>2]=f[j>>2]|8;if(Z>>>0<_>>>0?(a=b[Z>>0]|0,a<<24>>24>-1):0){F=Z+1|0;f[c>>2]=F;ja=a<<24>>24!=0;ka=F;la=_}else{Lnb(e,c);F=e;if(!(b[r>>0]|0)){Q=0;M=110;break a}ja=(f[F>>2]|0)!=0|(f[F+4>>2]|0)!=0;ka=f[c>>2]|0;la=f[g>>2]|0}b[q>>0]=ja&1;if(ka>>>0>=la>>>0)continue a;if((b[ka>>0]|0)!=48)continue a;F=ka+1|0;f[c>>2]=F;$=F;aa=la;M=56}if((M|0)==56){M=0;if($>>>0<aa>>>0){F=b[$>>0]|0;a=F&255;if(F<<24>>24>-1){f[c>>2]=$+1;ma=a}else{na=a;M=59}}else{na=0;M=59}if((M|0)==59){M=0;a=Knb(c,na)|0;F=J;if((F|0)>-1|(F|0)==-1&a>>>0>4294967295)ma=a;else{Q=0;M=110;break a}}if(ma>>>0<3){f[j>>2]=f[j>>2]|4;f[s>>2]=ma}else{a=f[l>>2]|0;if(!(a&1))oa=hBa(l)|0;else oa=a&-2;NPb(oa,6,ma,((ma|0)<0)<<31>>31)}a=f[c>>2]|0;F=f[g>>2]|0;if(a>>>0>=F>>>0)continue a;if((b[a>>0]|0)!=80)continue a;N=a+1|0;f[c>>2]=N;ba=F;ca=N;M=71}if((M|0)==71){M=0;N=ba;f[j>>2]=f[j>>2]|32;if(ca>>>0<ba>>>0?(F=b[ca>>0]|0,F<<24>>24>-1):0){a=ca+1|0;f[c>>2]=a;pa=F<<24>>24!=0;qa=a;ra=N}else{Lnb(e,c);N=e;if(!(b[v>>0]|0)){Q=0;M=110;break a}pa=(f[N>>2]|0)!=0|(f[N+4>>2]|0)!=0;qa=f[c>>2]|0;ra=f[g>>2]|0}b[t>>0]=pa&1;N=qa;if((ra-qa|0)<=1)continue a;if((b[N>>0]|0)!=-70)continue a;if((b[N+1>>0]|0)!=62)continue a;f[c>>2]=N+2}N=f[w>>2]|0;f[w>>2]=N+-1;if((N|0)<=0){Q=0;M=110;break a}while(1){N=f[y>>2]|0;do if(N){a=f[A>>2]|0;F=f[N>>2]|0;if((a|0)>=(F|0))if((F|0)==(f[z>>2]|0)){sa=F;M=87;break}else{ta=F;ua=N;M=88;break}else{f[A>>2]=a+1;va=f[N+4+(a<<2)>>2]|0;break}}else{sa=f[z>>2]|0;M=87}while(0);if((M|0)==87){M=0;cpb(x,sa+1|0);N=f[y>>2]|0;ta=f[N>>2]|0;ua=N;M=88}if((M|0)==88){M=0;f[ua>>2]=ta+1;N=Exb(0,f[x>>2]|0)|0;a=f[y>>2]|0;F=f[A>>2]|0;f[A>>2]=F+1;f[a+4+(F<<2)>>2]=N;va=N}N=Jnb(c)|0;if(!(Vwb(va,c)|0)){Q=0;M=110;break a}if(!(Pnb(c,N)|0)){Q=0;M=110;break a}wa=f[g>>2]|0;N=f[c>>2]|0;xa=N;if((wa-N|0)<=1)break;if((b[xa>>0]|0)!=-70)break;if((b[xa+1>>0]|0)!=62)break;f[c>>2]=xa+2}f[w>>2]=(f[w>>2]|0)+1;if((xa|0)!=(wa|0))continue a;if(f[B>>2]|0){M=98;break a}if((f[C>>2]|0)==(f[D>>2]|0)){M=98;break a}else continue a}while(0);if((M|0)==99){M=0;if(!P){Q=1;M=110;break}else R=P}if((R&7|0)==4){Q=1;M=110;break}N=f[l>>2]|0;F=(N&1|0)==0;if(R>>>0>7999){if(F)ya=hBa(l)|0;else ya=N&-2;if(FFb(E,R,c,498632,ya)|0)continue;else{Q=0;M=110;break}}else{if(F)za=hBa(l)|0;else za=N&-2;if(ZPb(c,R,za)|0)continue;else{Q=0;M=110;break}}}if((M|0)==98){f[i>>2]=0;b[c+24>>0]=1;Q=1;u=d;return Q|0}else if((M|0)==110){u=d;return Q|0}return 0}function gzb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=a+24|0;c=f[b>>2]|0;if(!(c&63))d=0;else{if(c&1){e=f[a+48>>2]|0;if((e|0)>=0)if(e>>>0<128){g=2;h=c}else{i=(iob(e)|0)+1|0;g=i;h=f[b>>2]|0}else{g=11;h=c}}else{g=0;h=c}c=h&2|0?g+2|0:g;if(!(h&4)){j=c;k=h}else{g=f[a+52>>2]|0;if((g|0)>=0)if(g>>>0<128){l=2;m=h}else{i=(iob(g)|0)+1|0;l=i;m=f[b>>2]|0}else{l=11;m=h}j=l+c|0;k=m}m=k&8|0?j+2|0:j;j=k&16|0?m+2|0:m;d=k&32|0?j+2|0:j}j=f[a+36>>2]|0;k=(j<<1)+d|0;if(!j)n=k;else{d=a+44|0;m=0;c=k;while(1){k=Wwb(f[(f[d>>2]|0)+4+(m<<2)>>2]|0)|0;if(k>>>0<128)o=1;else o=iob(k)|0;l=k+c+o|0;m=m+1|0;if((m|0)==(j|0)){n=l;break}else c=l}}c=(aSb(a+4|0)|0)+n|0;n=f[a+20>>2]|0;if(!(n&1)){p=c;q=a+28|0;f[q>>2]=p;return p|0}p=(dQb(n&-2)|0)+c|0;q=a+28|0;f[q>>2]=p;return p|0}function hzb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+24|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Zpb(1,f[a+48>>2]|0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{Ypb(2,(b[a+56>>0]|0)!=0,c);h=f[d>>2]|0}if(!(h&16))i=h;else{Ypb(3,(b[a+58>>0]|0)!=0,c);i=f[d>>2]|0}if(!(i&8))j=i;else{Ypb(5,(b[a+57>>0]|0)!=0,c);j=f[d>>2]|0}if(!(j&4))k=j;else{Zpb(6,f[a+52>>2]|0,c);k=f[d>>2]|0}if(k&32|0)Ypb(10,(b[a+59>>0]|0)!=0,c);k=f[a+36>>2]|0;if(k|0){d=a+44|0;j=0;do{eqb(999,f[(f[d>>2]|0)+4+(j<<2)>>2]|0,c);j=j+1|0}while((j|0)!=(k|0))}_Rb(a+4|0,1e3,536870912,c);k=f[a+20>>2]|0;if(!(k&1))return;aQb(k&-2,c);return}function izb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function jzb(a){a=a|0;return f[a+28>>2]|0}function kzb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=a+24|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+48>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);m=f[c>>2]|0;if(!(m&2)){o=e;p=m}else{m=b[a+56>>0]|0;b[e>>0]=16;b[e+1>>0]=m;o=e+2|0;p=f[c>>2]|0}if(!(p&16)){q=o;r=p}else{p=b[a+58>>0]|0;b[o>>0]=24;b[o+1>>0]=p;q=o+2|0;r=f[c>>2]|0}if(!(r&8)){s=q;t=r}else{r=b[a+57>>0]|0;b[q>>0]=40;b[q+1>>0]=r;s=q+2|0;t=f[c>>2]|0}do if(!(t&4))u=s;else{q=f[a+52>>2]|0;b[s>>0]=48;r=s+1|0;if((q|0)<0){u=hob(q,((q|0)<0)<<31>>31,r)|0;break}if(q>>>0>127){o=q;p=r;while(1){b[p>>0]=o|128;e=o>>>7;m=p+1|0;if(o>>>0>16383){o=e;p=m}else{v=m;w=e;break}}}else{v=r;w=q}b[v>>0]=w;u=v+1|0}while(0);if(!(f[c>>2]&32))x=u;else{c=b[a+59>>0]|0;b[u>>0]=80;b[u+1>>0]=c;x=u+2|0}u=f[a+36>>2]|0;if(!u)y=x;else{c=a+44|0;v=0;w=x;while(1){x=f[(f[c>>2]|0)+4+(v<<2)>>2]|0;b[w>>0]=-70;b[w+1>>0]=62;s=w+2|0;t=f[x+12>>2]|0;if(t>>>0>127){p=t;o=s;while(1){b[o>>0]=p|128;g=p>>>7;h=o+1|0;if(p>>>0>16383){p=g;o=h}else{z=h;A=g;break}}}else{z=s;A=t}b[z>>0]=A;o=li[f[(f[x>>2]|0)+68>>2]&511](x,0,z+1|0)|0;v=v+1|0;if((v|0)==(u|0)){y=o;break}else w=o}}w=JFb(a+4|0,1e3,536870912,0,y)|0;y=f[a+20>>2]|0;if(!(y&1)){B=w;return B|0}B=bQb(y&-2,w)|0;return B|0}function lzb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function mzb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(10733);c=T6b(b,23288,22840,0)|0;if(!c){cOb(b,a);return}else{pzb(a,c);return}}function nzb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function ozb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213403];f[a+4>>2]=f[213404];u=c;return}function pzb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;Cxb(a+32|0,c+32|0);d=c+24|0;e=f[d>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=f[c+48>>2]|0;h=a+24|0;f[h>>2]=f[h>>2]|1;f[a+48>>2]=e;g=f[d>>2]|0}if(!(g&2))i=g;else{g=b[c+56>>0]|0;e=a+24|0;f[e>>2]=f[e>>2]|2;b[a+56>>0]=g;i=f[d>>2]|0}if(!(i&4))j=i;else{i=f[c+52>>2]|0;g=a+24|0;f[g>>2]=f[g>>2]|4;f[a+52>>2]=i;j=f[d>>2]|0}if(!(j&8))k=j;else{j=b[c+57>>0]|0;i=a+24|0;f[i>>2]=f[i>>2]|8;b[a+57>>0]=j;k=f[d>>2]|0}if(!(k&16))l=k;else{k=b[c+58>>0]|0;j=a+24|0;f[j>>2]=f[j>>2]|16;b[a+58>>0]=k;l=f[d>>2]|0}if(l&32|0){l=b[c+59>>0]|0;d=a+24|0;f[d>>2]=f[d>>2]|32;b[a+59>>0]=l}}SRb(a+4|0,c+4|0);l=f[c+20>>2]|0;if(!(l&1))return;LPb(l&-2,a+20|0);return}function qzb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=138160;sQb(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=498632?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+28>>2]=0;d=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;u=c;return}function rzb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function szb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=138052;b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)GPb(h);O5b(c)}f[b>>2]=0;tQb(a+4|0);return}function tzb(a){a=a|0;szb(a);O5b(a);return}function uzb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function vzb(a,b){a=a|0;b=b|0;a=L5b(52)|0;Jzb(a);if(!b)return a|0;Kzb(b,a);return a|0}function wzb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;RRb(a+4|0);f[a+48>>2]=0;b=a+36|0;c=f[b>>2]|0;if((c|0)>0){d=f[a+44>>2]|0;e=0;do{g=f[d+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((e|0)!=(c|0));f[b>>2]=0}f[a+24>>2]=0;b=f[a+20>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function xzb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+44|0;c=f[a+36>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=5;break}}if((g|0)==5)return e|0;e=WRb(a+4|0)|0;return e|0}function yzb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+24|0;k=a+48|0;l=e+8|0;m=a+49|0;n=e+8|0;o=a+50|0;p=e+8|0;q=a+51|0;r=e+8|0;s=c+44|0;t=a+32|0;v=a+44|0;w=a+40|0;x=a+36|0;y=c+32|0;z=c+12|0;A=c+28|0;B=a+4|0;C=a+20|0;a:while(1){a=f[c>>2]|0;D=f[g>>2]|0;do if(a>>>0<D>>>0){E=b[a>>0]|0;F=E&255;if(E<<24>>24>0){G=F;H=1}else{E=a+1|0;if(E>>>0>=D>>>0){I=F;J=7;break}K=h[E>>0]|0;if(((K^128)&F)>>>0<=127){I=F;J=7;break}G=F+-128+(K<<7)|0;H=2}f[i>>2]=G;f[c>>2]=a+H;L=G;J=9}else{I=0;J=7}while(0);if((J|0)==7){J=0;a=_nb(c,I)|0;f[i>>2]=a;if((a+-1|0)>>>0<16383){L=a;J=9}else{M=a;J=69}}b:do if((J|0)==9){J=0;c:do switch(L>>>3&536870911|0){case 1:{switch(L|0){case 0:{N=1;J=80;break a;break}case 8:break;default:{O=L;break b}}f[j>>2]=f[j>>2]|1;a=f[c>>2]|0;D=f[g>>2]|0;if(a>>>0<D>>>0?(K=b[a>>0]|0,K<<24>>24>-1):0){F=a+1|0;f[c>>2]=F;P=D;Q=K<<24>>24!=0;R=F}else{Lnb(e,c);F=e;if(!(b[l>>0]|0)){N=0;J=80;break a}P=f[g>>2]|0;Q=(f[F>>2]|0)!=0|(f[F+4>>2]|0)!=0;R=f[c>>2]|0}b[k>>0]=Q&1;if(R>>>0>=P>>>0)continue a;if((b[R>>0]|0)!=16)continue a;F=R+1|0;f[c>>2]=F;S=P;T=F;J=21;break}case 2:{switch(L|0){case 0:{N=1;J=80;break a;break}case 16:break;default:{O=L;break b}}S=f[g>>2]|0;T=f[c>>2]|0;J=21;break}case 3:{switch(L|0){case 0:{N=1;J=80;break a;break}case 24:break;default:{O=L;break b}}U=f[g>>2]|0;V=f[c>>2]|0;J=31;break}case 7:{switch(L|0){case 0:{N=1;J=80;break a;break}case 56:break;default:{O=L;break b}}W=f[g>>2]|0;X=f[c>>2]|0;J=41;break}case 999:{if((L|0)<7994)switch(L|0){case 0:{N=1;J=80;break a;break}default:{O=L;break b}}else switch(L|0){case 7994:{break c;break}default:{O=L;break b}}break}default:{M=L;J=69;break b}}while(0);if((J|0)==21){J=0;f[j>>2]=f[j>>2]|2;if(T>>>0<S>>>0?(F=b[T>>0]|0,F<<24>>24>-1):0){K=T+1|0;f[c>>2]=K;Y=F<<24>>24!=0;Z=S;_=K}else{Lnb(e,c);K=e;if(!(b[n>>0]|0)){N=0;J=80;break a}Y=(f[K>>2]|0)!=0|(f[K+4>>2]|0)!=0;Z=f[g>>2]|0;_=f[c>>2]|0}b[m>>0]=Y&1;if(_>>>0>=Z>>>0)continue a;if((b[_>>0]|0)!=24)continue a;K=_+1|0;f[c>>2]=K;U=Z;V=K;J=31}if((J|0)==31){J=0;f[j>>2]=f[j>>2]|4;if(V>>>0<U>>>0?(K=b[V>>0]|0,K<<24>>24>-1):0){F=V+1|0;f[c>>2]=F;$=K<<24>>24!=0;aa=U;ba=F}else{Lnb(e,c);F=e;if(!(b[p>>0]|0)){N=0;J=80;break a}$=(f[F>>2]|0)!=0|(f[F+4>>2]|0)!=0;aa=f[g>>2]|0;ba=f[c>>2]|0}b[o>>0]=$&1;if(ba>>>0>=aa>>>0)continue a;if((b[ba>>0]|0)!=56)continue a;F=ba+1|0;f[c>>2]=F;W=aa;X=F;J=41}if((J|0)==41){J=0;F=W;f[j>>2]=f[j>>2]|8;if(X>>>0<W>>>0?(K=b[X>>0]|0,K<<24>>24>-1):0){D=X+1|0;f[c>>2]=D;ca=K<<24>>24!=0;da=D;ea=F}else{Lnb(e,c);F=e;if(!(b[r>>0]|0)){N=0;J=80;break a}ca=(f[F>>2]|0)!=0|(f[F+4>>2]|0)!=0;da=f[c>>2]|0;ea=f[g>>2]|0}b[q>>0]=ca&1;F=da;if((ea-da|0)<=1)continue a;if((b[F>>0]|0)!=-70)continue a;if((b[F+1>>0]|0)!=62)continue a;f[c>>2]=F+2}F=f[s>>2]|0;f[s>>2]=F+-1;if((F|0)<=0){N=0;J=80;break a}while(1){F=f[v>>2]|0;do if(F){D=f[x>>2]|0;K=f[F>>2]|0;if((D|0)>=(K|0))if((K|0)==(f[w>>2]|0)){fa=K;J=57;break}else{ga=K;ha=F;J=58;break}else{f[x>>2]=D+1;ia=f[F+4+(D<<2)>>2]|0;break}}else{fa=f[w>>2]|0;J=57}while(0);if((J|0)==57){J=0;cpb(t,fa+1|0);F=f[v>>2]|0;ga=f[F>>2]|0;ha=F;J=58}if((J|0)==58){J=0;f[ha>>2]=ga+1;F=Exb(0,f[t>>2]|0)|0;D=f[v>>2]|0;K=f[x>>2]|0;f[x>>2]=K+1;f[D+4+(K<<2)>>2]=F;ia=F}F=Jnb(c)|0;if(!(Vwb(ia,c)|0)){N=0;J=80;break a}if(!(Pnb(c,F)|0)){N=0;J=80;break a}ja=f[g>>2]|0;F=f[c>>2]|0;ka=F;if((ja-F|0)<=1)break;if((b[ka>>0]|0)!=-70)break;if((b[ka+1>>0]|0)!=62)break;f[c>>2]=ka+2}f[s>>2]=(f[s>>2]|0)+1;if((ka|0)!=(ja|0))continue a;if(f[y>>2]|0){J=68;break a}if((f[z>>2]|0)==(f[A>>2]|0)){J=68;break a}else continue a}while(0);if((J|0)==69){J=0;if(!M){N=1;J=80;break}else O=M}if((O&7|0)==4){N=1;J=80;break}F=f[C>>2]|0;K=(F&1|0)==0;if(O>>>0>7999){if(K)la=hBa(C)|0;else la=F&-2;if(FFb(B,O,c,498568,la)|0)continue;else{N=0;J=80;break}}else{if(K)ma=hBa(C)|0;else ma=F&-2;if(ZPb(c,O,ma)|0)continue;else{N=0;J=80;break}}}if((J|0)==68){f[i>>2]=0;b[c+24>>0]=1;N=1;u=d;return N|0}else if((J|0)==80){u=d;return N|0}return 0}function zzb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=f[a+24>>2]|0;if(!(b&15))c=0;else{d=b<<1&2;e=b&2|0?d+2|0:d;d=b&4|0?e+2|0:e;c=b&8|0?d+2|0:d}d=f[a+36>>2]|0;b=(d<<1)+c|0;if(!d)g=b;else{c=a+44|0;e=0;h=b;while(1){b=Wwb(f[(f[c>>2]|0)+4+(e<<2)>>2]|0)|0;if(b>>>0<128)i=1;else i=iob(b)|0;j=b+h+i|0;e=e+1|0;if((e|0)==(d|0)){g=j;break}else h=j}}h=(aSb(a+4|0)|0)+g|0;g=f[a+20>>2]|0;if(!(g&1)){k=h;l=a+28|0;f[l>>2]=k;return k|0}k=(dQb(g&-2)|0)+h|0;l=a+28|0;f[l>>2]=k;return k|0}function Azb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=a+24|0;e=f[d>>2]|0;if(!(e&1))g=e;else{Ypb(1,(b[a+48>>0]|0)!=0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{Ypb(2,(b[a+49>>0]|0)!=0,c);h=f[d>>2]|0}if(!(h&4))i=h;else{Ypb(3,(b[a+50>>0]|0)!=0,c);i=f[d>>2]|0}if(i&8|0)Ypb(7,(b[a+51>>0]|0)!=0,c);i=f[a+36>>2]|0;if(i|0){d=a+44|0;h=0;do{eqb(999,f[(f[d>>2]|0)+4+(h<<2)>>2]|0,c);h=h+1|0}while((h|0)!=(i|0))}_Rb(a+4|0,1e3,536870912,c);i=f[a+20>>2]|0;if(!(i&1))return;aQb(i&-2,c);return}function Bzb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function Czb(a){a=a|0;return f[a+28>>2]|0}function Dzb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+24|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=b[a+48>>0]|0;b[d>>0]=8;b[d+1>>0]=e;g=d+2|0;h=f[c>>2]|0}if(!(h&2)){i=g;j=h}else{h=b[a+49>>0]|0;b[g>>0]=16;b[g+1>>0]=h;i=g+2|0;j=f[c>>2]|0}if(!(j&4)){k=i;l=j}else{j=b[a+50>>0]|0;b[i>>0]=24;b[i+1>>0]=j;k=i+2|0;l=f[c>>2]|0}if(!(l&8))m=k;else{l=b[a+51>>0]|0;b[k>>0]=56;b[k+1>>0]=l;m=k+2|0}k=f[a+36>>2]|0;if(!k)n=m;else{l=a+44|0;c=0;i=m;while(1){m=f[(f[l>>2]|0)+4+(c<<2)>>2]|0;b[i>>0]=-70;b[i+1>>0]=62;j=i+2|0;g=f[m+12>>2]|0;if(g>>>0>127){h=g;d=j;while(1){b[d>>0]=h|128;e=h>>>7;o=d+1|0;if(h>>>0>16383){h=e;d=o}else{p=o;q=e;break}}}else{p=j;q=g}b[p>>0]=q;d=li[f[(f[m>>2]|0)+68>>2]&511](m,0,p+1|0)|0;c=c+1|0;if((c|0)==(k|0)){n=d;break}else i=d}}i=JFb(a+4|0,1e3,536870912,0,n)|0;n=f[a+20>>2]|0;if(!(n&1)){r=i;return r|0}r=bQb(n&-2,i)|0;return r|0}function Ezb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Fzb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(10034);c=T6b(b,23288,22856,0)|0;if(!c){cOb(b,a);return}else{Izb(a,c);return}}function Gzb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function Hzb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213401];f[a+4>>2]=f[213402];u=c;return}function Izb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;Cxb(a+32|0,c+32|0);d=c+24|0;e=f[d>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=b[c+48>>0]|0;h=a+24|0;f[h>>2]=f[h>>2]|1;b[a+48>>0]=e;g=f[d>>2]|0}if(!(g&2))i=g;else{g=b[c+49>>0]|0;e=a+24|0;f[e>>2]=f[e>>2]|2;b[a+49>>0]=g;i=f[d>>2]|0}if(!(i&4))j=i;else{i=b[c+50>>0]|0;g=a+24|0;f[g>>2]=f[g>>2]|4;b[a+50>>0]=i;j=f[d>>2]|0}if(j&8|0){j=b[c+51>>0]|0;d=a+24|0;f[d>>2]=f[d>>2]|8;b[a+51>>0]=j}}SRb(a+4|0,c+4|0);j=f[c+20>>2]|0;if(!(j&1))return;LPb(j&-2,a+20|0);return}function Jzb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=138052;sQb(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=498568?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+28>>2]=0;f[a+48>>2]=0;u=c;return}function Kzb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function Lzb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=137944;cAb(a);b=a+44|0;c=f[b>>2]|0;if(c|0?(f[a+32>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+20|0;h=f[b>>2]|0;if(h&1|0?(c=h&-2,h=c,!((c|0)==0|(f[h+4>>2]|0)!=0)):0){if(f[h>>2]|0)GPb(h);O5b(c)}f[b>>2]=0;tQb(a+4|0);return}function Mzb(a){a=a|0;Lzb(a);O5b(a);return}function Nzb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function Ozb(a,b){a=a|0;b=b|0;a=L5b(80)|0;aAb(a);if(!b)return a|0;bAb(b,a);return a|0}function Pzb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;RRb(a+4|0);c=a+24|0;d=f[c>>2]|0;do if(d&255|0){f[a+68>>2]=0;do if(d&1|0?(e=f[a+48>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);do if(f[c>>2]&2|0?(g=f[a+52>>2]|0,(g|0)!=497760):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);f[a+76>>2]=1;if(f[c>>2]&64|0?(e=f[a+56>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);d=f[c>>2]|0;do if(d&16128|0){f[a+72>>2]=0;do if(d&4096|0?(g=f[a+60>>2]|0,(g|0)!=497760):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);if(f[c>>2]&8192|0?(e=f[a+64>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}}while(0);d=a+36|0;g=f[d>>2]|0;if((g|0)>0){e=f[a+44>>2]|0;h=0;do{i=f[e+4+(h<<2)>>2]|0;h=h+1|0;bi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((h|0)!=(g|0));f[d>>2]=0}f[c>>2]=0;c=f[a+20>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function Qzb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+44|0;c=f[a+36>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=5;break}}if((g|0)==5)return e|0;e=WRb(a+4|0)|0;return e|0}function Rzb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0;d=u;u=u+16|0;e=d;g=c+4|0;i=c+20|0;j=a+24|0;k=a+48|0;l=a+52|0;m=a+76|0;n=a+20|0;o=a+68|0;p=e+8|0;q=a+56|0;r=a+71|0;s=e+8|0;t=a+72|0;v=e+8|0;w=a+73|0;x=e+8|0;y=a+69|0;z=e+8|0;A=a+74|0;B=e+8|0;C=a+70|0;D=e+8|0;E=a+75|0;F=e+8|0;G=a+60|0;H=a+64|0;I=c+44|0;K=a+32|0;L=a+44|0;M=a+40|0;N=a+36|0;O=c+32|0;P=c+12|0;Q=c+28|0;R=a+4|0;a:while(1){a=f[c>>2]|0;S=f[g>>2]|0;do if(a>>>0<S>>>0){T=b[a>>0]|0;U=T&255;if(T<<24>>24>0){V=U;W=1}else{T=a+1|0;if(T>>>0>=S>>>0){X=U;Y=7;break}Z=h[T>>0]|0;if(((Z^128)&U)>>>0<=127){X=U;Y=7;break}V=U+-128+(Z<<7)|0;W=2}f[i>>2]=V;f[c>>2]=a+W;_=V;Y=9}else{X=0;Y=7}while(0);if((Y|0)==7){Y=0;a=_nb(c,X)|0;f[i>>2]=a;if((a+-1|0)>>>0<16383){_=a;Y=9}else{$=a;Y=169}}b:do if((Y|0)==9){Y=0;c:do switch(_>>>3&536870911|0){case 1:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 10:break;default:{ba=_;break b}}f[j>>2]=f[j>>2]|1;a=f[k>>2]|0;if((a|0)==497760){jza(k,497760);ca=f[k>>2]|0}else ca=a;if(!(fqb(c,ca)|0)){aa=0;Y=180;break a}a=f[c>>2]|0;if(a>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[a>>0]|0)!=66)continue a;f[c>>2]=a+1;Y=18;break}case 8:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 66:{Y=18;break}default:{ba=_;break b}}break}case 9:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 72:break;default:{ba=_;break b}}da=f[c>>2]|0;ea=f[g>>2]|0;Y=26;break}case 10:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 80:break;default:{ba=_;break b}}fa=f[c>>2]|0;ga=f[g>>2]|0;Y=41;break}case 11:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 90:{Y=50;break}default:{ba=_;break b}}break}case 16:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 128:break;default:{ba=_;break b}}a=f[g>>2]|0;ha=f[c>>2]|0;ia=a;ja=a;Y=59;break}case 17:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 136:break;default:{ba=_;break b}}a=f[g>>2]|0;ka=f[c>>2]|0;la=a;ma=a;Y=70;break}case 18:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 144:break;default:{ba=_;break b}}a=f[g>>2]|0;na=f[c>>2]|0;oa=a;pa=a;Y=81;break}case 20:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 160:break;default:{ba=_;break b}}a=f[g>>2]|0;qa=f[c>>2]|0;ra=a;sa=a;Y=92;break}case 23:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 184:break;default:{ba=_;break b}}a=f[g>>2]|0;ta=f[c>>2]|0;ua=a;va=a;Y=103;break}case 27:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 216:break;default:{ba=_;break b}}a=f[g>>2]|0;wa=f[c>>2]|0;xa=a;ya=a;Y=114;break}case 31:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 248:break;default:{ba=_;break b}}a=f[g>>2]|0;za=f[c>>2]|0;Aa=a;Ba=a;Y=125;break}case 36:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 290:{Y=135;break}default:{ba=_;break b}}break}case 37:{switch(_|0){case 0:{aa=1;Y=180;break a;break}case 298:{Y=143;break}default:{ba=_;break b}}break}case 999:{if((_|0)<7994)switch(_|0){case 0:{aa=1;Y=180;break a;break}default:{ba=_;break b}}else switch(_|0){case 7994:{break c;break}default:{ba=_;break b}}break}default:{$=_;Y=169;break b}}while(0);if((Y|0)==18){Y=0;f[j>>2]=f[j>>2]|2;a=f[l>>2]|0;if((a|0)==497760){jza(l,497760);Ca=f[l>>2]|0}else Ca=a;if(!(fqb(c,Ca)|0)){aa=0;Y=180;break a}a=f[c>>2]|0;S=f[g>>2]|0;if(a>>>0>=S>>>0)continue a;if((b[a>>0]|0)!=72)continue a;Z=a+1|0;f[c>>2]=Z;da=Z;ea=S;Y=26}if((Y|0)==26){Y=0;if(da>>>0<ea>>>0){S=b[da>>0]|0;Z=S&255;if(S<<24>>24>-1){f[c>>2]=da+1;Da=Z}else{Ea=Z;Y=29}}else{Ea=0;Y=29}if((Y|0)==29){Y=0;Z=Knb(c,Ea)|0;S=J;if((S|0)>-1|(S|0)==-1&Z>>>0>4294967295)Da=Z;else{aa=0;Y=180;break a}}if((Da+-1|0)>>>0<3){f[j>>2]=f[j>>2]|32;f[m>>2]=Da}else{Z=f[n>>2]|0;if(!(Z&1))Fa=hBa(n)|0;else Fa=Z&-2;NPb(Fa,9,Da,((Da|0)<0)<<31>>31)}Z=f[c>>2]|0;S=f[g>>2]|0;if(Z>>>0>=S>>>0)continue a;if((b[Z>>0]|0)!=80)continue a;a=Z+1|0;f[c>>2]=a;fa=a;ga=S;Y=41}if((Y|0)==41){Y=0;f[j>>2]=f[j>>2]|4;if(fa>>>0<ga>>>0?(S=b[fa>>0]|0,S<<24>>24>-1):0){a=fa+1|0;f[c>>2]=a;Ga=S<<24>>24!=0;Ha=a;Ia=ga}else{Lnb(e,c);a=e;if(!(b[p>>0]|0)){aa=0;Y=180;break a}Ga=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0;Ha=f[c>>2]|0;Ia=f[g>>2]|0}b[o>>0]=Ga&1;if(Ha>>>0>=Ia>>>0)continue a;if((b[Ha>>0]|0)!=90)continue a;f[c>>2]=Ha+1;Y=50}if((Y|0)==50){Y=0;f[j>>2]=f[j>>2]|64;a=f[q>>2]|0;if((a|0)==497760){jza(q,497760);Ja=f[q>>2]|0}else Ja=a;if(!(fqb(c,Ja)|0)){aa=0;Y=180;break a}a=f[g>>2]|0;S=f[c>>2]|0;Z=S;if((a-S|0)<=1)continue a;if((b[Z>>0]|0)!=-128)continue a;if((b[Z+1>>0]|0)!=1)continue a;S=Z+2|0;f[c>>2]=S;ha=S;ia=a;ja=a;Y=59}if((Y|0)==59){Y=0;f[j>>2]=f[j>>2]|128;if(ha>>>0<ia>>>0?(a=b[ha>>0]|0,a<<24>>24>-1):0){S=ha+1|0;f[c>>2]=S;Ka=a<<24>>24!=0;La=S;Ma=ja;Na=ia}else{Lnb(e,c);S=e;if(!(b[s>>0]|0)){aa=0;Y=180;break a}a=f[g>>2]|0;Ka=(f[S>>2]|0)!=0|(f[S+4>>2]|0)!=0;La=f[c>>2]|0;Ma=a;Na=a}b[r>>0]=Ka&1;a=La;if((Ma-La|0)<=1)continue a;if((b[a>>0]|0)!=-120)continue a;if((b[a+1>>0]|0)!=1)continue a;S=a+2|0;f[c>>2]=S;ka=S;la=Na;ma=Ma;Y=70}if((Y|0)==70){Y=0;f[j>>2]=f[j>>2]|256;if(ka>>>0<la>>>0?(S=b[ka>>0]|0,S<<24>>24>-1):0){a=ka+1|0;f[c>>2]=a;Oa=S<<24>>24!=0;Pa=a;Qa=ma;Ra=la}else{Lnb(e,c);a=e;if(!(b[v>>0]|0)){aa=0;Y=180;break a}S=f[g>>2]|0;Oa=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0;Pa=f[c>>2]|0;Qa=S;Ra=S}b[t>>0]=Oa&1;S=Pa;if((Qa-Pa|0)<=1)continue a;if((b[S>>0]|0)!=-112)continue a;if((b[S+1>>0]|0)!=1)continue a;a=S+2|0;f[c>>2]=a;na=a;oa=Ra;pa=Qa;Y=81}if((Y|0)==81){Y=0;f[j>>2]=f[j>>2]|512;if(na>>>0<oa>>>0?(a=b[na>>0]|0,a<<24>>24>-1):0){S=na+1|0;f[c>>2]=S;Sa=a<<24>>24!=0;Ta=S;Ua=pa;Va=oa}else{Lnb(e,c);S=e;if(!(b[x>>0]|0)){aa=0;Y=180;break a}a=f[g>>2]|0;Sa=(f[S>>2]|0)!=0|(f[S+4>>2]|0)!=0;Ta=f[c>>2]|0;Ua=a;Va=a}b[w>>0]=Sa&1;a=Ta;if((Ua-Ta|0)<=1)continue a;if((b[a>>0]|0)!=-96)continue a;if((b[a+1>>0]|0)!=1)continue a;S=a+2|0;f[c>>2]=S;qa=S;ra=Va;sa=Ua;Y=92}if((Y|0)==92){Y=0;f[j>>2]=f[j>>2]|8;if(qa>>>0<ra>>>0?(S=b[qa>>0]|0,S<<24>>24>-1):0){a=qa+1|0;f[c>>2]=a;Wa=S<<24>>24!=0;Xa=a;Ya=sa;Za=ra}else{Lnb(e,c);a=e;if(!(b[z>>0]|0)){aa=0;Y=180;break a}S=f[g>>2]|0;Wa=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0;Xa=f[c>>2]|0;Ya=S;Za=S}b[y>>0]=Wa&1;S=Xa;if((Ya-Xa|0)<=1)continue a;if((b[S>>0]|0)!=-72)continue a;if((b[S+1>>0]|0)!=1)continue a;a=S+2|0;f[c>>2]=a;ta=a;ua=Za;va=Ya;Y=103}if((Y|0)==103){Y=0;f[j>>2]=f[j>>2]|1024;if(ta>>>0<ua>>>0?(a=b[ta>>0]|0,a<<24>>24>-1):0){S=ta+1|0;f[c>>2]=S;_a=a<<24>>24!=0;$a=S;ab=va;bb=ua}else{Lnb(e,c);S=e;if(!(b[B>>0]|0)){aa=0;Y=180;break a}a=f[g>>2]|0;_a=(f[S>>2]|0)!=0|(f[S+4>>2]|0)!=0;$a=f[c>>2]|0;ab=a;bb=a}b[A>>0]=_a&1;a=$a;if((ab-$a|0)<=1)continue a;if((b[a>>0]|0)!=-40)continue a;if((b[a+1>>0]|0)!=1)continue a;S=a+2|0;f[c>>2]=S;wa=S;xa=bb;ya=ab;Y=114}if((Y|0)==114){Y=0;f[j>>2]=f[j>>2]|16;if(wa>>>0<xa>>>0?(S=b[wa>>0]|0,S<<24>>24>-1):0){a=wa+1|0;f[c>>2]=a;cb=S<<24>>24!=0;db=a;eb=ya;fb=xa}else{Lnb(e,c);a=e;if(!(b[D>>0]|0)){aa=0;Y=180;break a}S=f[g>>2]|0;cb=(f[a>>2]|0)!=0|(f[a+4>>2]|0)!=0;db=f[c>>2]|0;eb=S;fb=S}b[C>>0]=cb&1;S=db;if((eb-db|0)<=1)continue a;if((b[S>>0]|0)!=-8)continue a;if((b[S+1>>0]|0)!=1)continue a;a=S+2|0;f[c>>2]=a;za=a;Aa=fb;Ba=eb;Y=125}if((Y|0)==125){Y=0;f[j>>2]=f[j>>2]|2048;if(za>>>0<Aa>>>0?(a=b[za>>0]|0,a<<24>>24>-1):0){S=za+1|0;f[c>>2]=S;gb=a<<24>>24!=0;hb=S;ib=Ba}else{Lnb(e,c);S=e;if(!(b[F>>0]|0)){aa=0;Y=180;break a}gb=(f[S>>2]|0)!=0|(f[S+4>>2]|0)!=0;hb=f[c>>2]|0;ib=f[g>>2]|0}b[E>>0]=gb&1;S=hb;if((ib-hb|0)<=1)continue a;if((b[S>>0]|0)!=-94)continue a;if((b[S+1>>0]|0)!=2)continue a;f[c>>2]=S+2;Y=135}if((Y|0)==135){Y=0;f[j>>2]=f[j>>2]|4096;S=f[G>>2]|0;if((S|0)==497760){jza(G,497760);jb=f[G>>2]|0}else jb=S;if(!(fqb(c,jb)|0)){aa=0;Y=180;break a}S=f[c>>2]|0;a=S;if(((f[g>>2]|0)-S|0)<=1)continue a;if((b[a>>0]|0)!=-86)continue a;if((b[a+1>>0]|0)!=2)continue a;f[c>>2]=a+2;Y=143}if((Y|0)==143){Y=0;f[j>>2]=f[j>>2]|8192;a=f[H>>2]|0;if((a|0)==497760){jza(H,497760);kb=f[H>>2]|0}else kb=a;if(!(fqb(c,kb)|0)){aa=0;Y=180;break a}a=f[c>>2]|0;S=a;if(((f[g>>2]|0)-a|0)<=1)continue a;if((b[S>>0]|0)!=-70)continue a;if((b[S+1>>0]|0)!=62)continue a;f[c>>2]=S+2}S=f[I>>2]|0;f[I>>2]=S+-1;if((S|0)<=0){aa=0;Y=180;break a}while(1){S=f[L>>2]|0;do if(S){a=f[N>>2]|0;Z=f[S>>2]|0;if((a|0)>=(Z|0))if((Z|0)==(f[M>>2]|0)){lb=Z;Y=157;break}else{mb=Z;nb=S;Y=158;break}else{f[N>>2]=a+1;ob=f[S+4+(a<<2)>>2]|0;break}}else{lb=f[M>>2]|0;Y=157}while(0);if((Y|0)==157){Y=0;cpb(K,lb+1|0);S=f[L>>2]|0;mb=f[S>>2]|0;nb=S;Y=158}if((Y|0)==158){Y=0;f[nb>>2]=mb+1;S=Exb(0,f[K>>2]|0)|0;a=f[L>>2]|0;Z=f[N>>2]|0;f[N>>2]=Z+1;f[a+4+(Z<<2)>>2]=S;ob=S}S=Jnb(c)|0;if(!(Vwb(ob,c)|0)){aa=0;Y=180;break a}if(!(Pnb(c,S)|0)){aa=0;Y=180;break a}pb=f[g>>2]|0;S=f[c>>2]|0;qb=S;if((pb-S|0)<=1)break;if((b[qb>>0]|0)!=-70)break;if((b[qb+1>>0]|0)!=62)break;f[c>>2]=qb+2}f[I>>2]=(f[I>>2]|0)+1;if((qb|0)!=(pb|0))continue a;if(f[O>>2]|0){Y=168;break a}if((f[P>>2]|0)==(f[Q>>2]|0)){Y=168;break a}else continue a}while(0);if((Y|0)==169){Y=0;if(!$){aa=1;Y=180;break}else ba=$}if((ba&7|0)==4){aa=1;Y=180;break}S=f[n>>2]|0;Z=(S&1|0)==0;if(ba>>>0>7999){if(Z)rb=hBa(n)|0;else rb=S&-2;if(FFb(R,ba,c,498480,rb)|0)continue;else{aa=0;Y=180;break}}else{if(Z)sb=hBa(n)|0;else sb=S&-2;if(ZPb(c,ba,sb)|0)continue;else{aa=0;Y=180;break}}}if((Y|0)==168){f[i>>2]=0;b[c+24>>0]=1;aa=1;u=d;return aa|0}else if((Y|0)==180){u=d;return aa|0}return 0}function Szb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;c=a+24|0;d=f[c>>2]|0;if(!(d&255)){e=0;g=d}else{if(!(d&1)){h=0;i=d}else{j=f[a+48>>2]|0;k=b[j+11>>0]|0;if(k<<24>>24<0){l=f[j+4>>2]|0;if(l>>>0<128){m=1;n=d;o=l}else{j=iob(l)|0;m=j;n=f[c>>2]|0;o=l}}else{m=1;n=d;o=k&255}h=o+1+m|0;i=n}if(!(i&2)){p=h;q=i}else{n=f[a+52>>2]|0;m=b[n+11>>0]|0;if(m<<24>>24<0){o=f[n+4>>2]|0;if(o>>>0<128){r=1;s=i;t=o}else{n=iob(o)|0;r=n;s=f[c>>2]|0;t=o}}else{r=1;s=i;t=m&255}p=h+1+t+r|0;q=s}s=q&4|0?p+2|0:p;p=q&8|0?s+3|0:s;s=q&16|0?p+3|0:p;if(!(q&32)){u=s;v=q}else{p=f[a+76>>2]|0;if((p|0)>=0)if(p>>>0<128){w=2;x=q}else{r=(iob(p)|0)+1|0;w=r;x=f[c>>2]|0}else{w=11;x=q}u=w+s|0;v=x}if(!(v&64)){y=u;z=v}else{x=f[a+56>>2]|0;s=b[x+11>>0]|0;if(s<<24>>24<0){w=f[x+4>>2]|0;if(w>>>0<128){A=1;B=v;C=w}else{x=iob(w)|0;A=x;B=f[c>>2]|0;C=w}}else{A=1;B=v;C=s&255}y=u+1+C+A|0;z=B}e=z&128|0?y+3|0:y;g=z}if(g&16128){z=g&256|0?e+3|0:e;y=g&512|0?z+3|0:z;z=g&1024|0?y+3|0:y;y=g&2048|0?z+3|0:z;if(!(g&4096)){D=y;E=g}else{z=f[a+60>>2]|0;B=b[z+11>>0]|0;if(B<<24>>24<0){A=f[z+4>>2]|0;if(A>>>0<128){F=1;G=g;H=A}else{z=iob(A)|0;F=z;G=f[c>>2]|0;H=A}}else{F=1;G=g;H=B&255}D=y+2+H+F|0;E=G}if(!(E&8192))I=D;else{E=f[a+64>>2]|0;G=b[E+11>>0]|0;if(G<<24>>24<0){F=f[E+4>>2]|0;if(F>>>0<128){J=1;K=F}else{J=iob(F)|0;K=F}}else{J=1;K=G&255}I=D+2+K+J|0}}else I=e;e=f[a+36>>2]|0;J=(e<<1)+I|0;if(!e)L=J;else{I=a+44|0;K=0;D=J;while(1){J=Wwb(f[(f[I>>2]|0)+4+(K<<2)>>2]|0)|0;if(J>>>0<128)M=1;else M=iob(J)|0;G=J+D+M|0;K=K+1|0;if((K|0)==(e|0)){L=G;break}else D=G}}D=(aSb(a+4|0)|0)+L|0;L=f[a+20>>2]|0;if(!(L&1)){N=D;O=a+28|0;f[O>>2]=N;return N|0}N=(dQb(L&-2)|0)+D|0;O=a+28|0;f[O>>2]=N;return N|0}function Tzb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=a+24|0;e=f[d>>2]|0;if(!(e&1))g=e;else{$pb(1,f[a+48>>2]|0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{$pb(8,f[a+52>>2]|0,c);h=f[d>>2]|0}if(!(h&32))i=h;else{Zpb(9,f[a+76>>2]|0,c);i=f[d>>2]|0}if(!(i&4))j=i;else{Ypb(10,(b[a+68>>0]|0)!=0,c);j=f[d>>2]|0}if(!(j&64))k=j;else{$pb(11,f[a+56>>2]|0,c);k=f[d>>2]|0}if(!(k&128))l=k;else{Ypb(16,(b[a+71>>0]|0)!=0,c);l=f[d>>2]|0}if(!(l&256))m=l;else{Ypb(17,(b[a+72>>0]|0)!=0,c);m=f[d>>2]|0}if(!(m&512))n=m;else{Ypb(18,(b[a+73>>0]|0)!=0,c);n=f[d>>2]|0}if(!(n&8))o=n;else{Ypb(20,(b[a+69>>0]|0)!=0,c);o=f[d>>2]|0}if(!(o&1024))p=o;else{Ypb(23,(b[a+74>>0]|0)!=0,c);p=f[d>>2]|0}if(!(p&16))q=p;else{Ypb(27,(b[a+70>>0]|0)!=0,c);q=f[d>>2]|0}if(!(q&2048))r=q;else{Ypb(31,(b[a+75>>0]|0)!=0,c);r=f[d>>2]|0}if(!(r&4096))s=r;else{$pb(36,f[a+60>>2]|0,c);s=f[d>>2]|0}if(s&8192|0)$pb(37,f[a+64>>2]|0,c);s=f[a+36>>2]|0;if(s|0){d=a+44|0;r=0;do{eqb(999,f[(f[d>>2]|0)+4+(r<<2)>>2]|0,c);r=r+1|0}while((r|0)!=(s|0))}_Rb(a+4|0,1e3,536870912,c);s=f[a+20>>2]|0;if(!(s&1))return;aQb(s&-2,c);return}function Uzb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function Vzb(a){a=a|0;return f[a+28>>2]|0}function Wzb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;c=a+24|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+48>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&2)){j=g;k=h}else{h=f[a+52>>2]|0;b[g>>0]=66;i=kob(h,g+1|0)|0;j=i;k=f[c>>2]|0}do if(!(k&32))l=j;else{i=f[a+76>>2]|0;b[j>>0]=72;g=j+1|0;if((i|0)<0){l=hob(i,((i|0)<0)<<31>>31,g)|0;break}if(i>>>0>127){h=i;d=g;while(1){b[d>>0]=h|128;e=h>>>7;m=d+1|0;if(h>>>0>16383){h=e;d=m}else{n=m;o=e;break}}}else{n=g;o=i}b[n>>0]=o;l=n+1|0}while(0);n=f[c>>2]|0;if(!(n&4)){p=l;q=n}else{n=b[a+68>>0]|0;b[l>>0]=80;b[l+1>>0]=n;p=l+2|0;q=f[c>>2]|0}if(!(q&64)){r=p;s=q}else{q=f[a+56>>2]|0;b[p>>0]=90;l=kob(q,p+1|0)|0;r=l;s=f[c>>2]|0}if(!(s&128)){t=r;u=s}else{s=b[a+71>>0]|0;b[r>>0]=-128;b[r+1>>0]=1;b[r+2>>0]=s;t=r+3|0;u=f[c>>2]|0}if(!(u&256)){v=t;w=u}else{u=b[a+72>>0]|0;b[t>>0]=-120;b[t+1>>0]=1;b[t+2>>0]=u;v=t+3|0;w=f[c>>2]|0}if(!(w&512)){x=v;y=w}else{w=b[a+73>>0]|0;b[v>>0]=-112;b[v+1>>0]=1;b[v+2>>0]=w;x=v+3|0;y=f[c>>2]|0}if(!(y&8)){z=x;A=y}else{y=b[a+69>>0]|0;b[x>>0]=-96;b[x+1>>0]=1;b[x+2>>0]=y;z=x+3|0;A=f[c>>2]|0}if(!(A&1024)){B=z;C=A}else{A=b[a+74>>0]|0;b[z>>0]=-72;b[z+1>>0]=1;b[z+2>>0]=A;B=z+3|0;C=f[c>>2]|0}if(!(C&16)){D=B;E=C}else{C=b[a+70>>0]|0;b[B>>0]=-40;b[B+1>>0]=1;b[B+2>>0]=C;D=B+3|0;E=f[c>>2]|0}if(!(E&2048)){F=D;G=E}else{E=b[a+75>>0]|0;b[D>>0]=-8;b[D+1>>0]=1;b[D+2>>0]=E;F=D+3|0;G=f[c>>2]|0}if(!(G&4096)){H=F;I=G}else{G=f[a+60>>2]|0;b[F>>0]=-94;b[F+1>>0]=2;D=kob(G,F+2|0)|0;H=D;I=f[c>>2]|0}if(!(I&8192))J=H;else{I=f[a+64>>2]|0;b[H>>0]=-86;b[H+1>>0]=2;J=kob(I,H+2|0)|0}H=f[a+36>>2]|0;if(!H)K=J;else{I=a+44|0;c=0;D=J;while(1){J=f[(f[I>>2]|0)+4+(c<<2)>>2]|0;b[D>>0]=-70;b[D+1>>0]=62;F=D+2|0;G=f[J+12>>2]|0;if(G>>>0>127){E=G;B=F;while(1){b[B>>0]=E|128;C=E>>>7;z=B+1|0;if(E>>>0>16383){E=C;B=z}else{L=z;M=C;break}}}else{L=F;M=G}b[L>>0]=M;B=li[f[(f[J>>2]|0)+68>>2]&511](J,0,L+1|0)|0;c=c+1|0;if((c|0)==(H|0)){K=B;break}else D=B}}D=JFb(a+4|0,1e3,536870912,0,K)|0;K=f[a+20>>2]|0;if(!(K&1)){N=D;return N|0}N=bQb(K&-2,D)|0;return N|0}function Xzb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function Yzb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(9021);c=T6b(b,23288,22872,0)|0;if(!c){cOb(b,a);return}else{$zb(a,c);return}}function Zzb(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function _zb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213398];f[a+4>>2]=f[213399];u=c;return}function $zb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+32|0;e=d+20|0;g=d+16|0;h=d+12|0;i=d+8|0;j=d+4|0;k=d;Cxb(a+32|0,c+32|0);l=c+24|0;m=f[l>>2]|0;if(m&255){if(!(m&1))n=m;else{o=a+24|0;f[o>>2]=f[o>>2]|1;f[g>>2]=f[c+48>>2];f[e>>2]=f[g>>2];Anb(a+48|0,497760,e);n=f[l>>2]|0}if(!(n&2))p=n;else{n=a+24|0;f[n>>2]=f[n>>2]|2;f[h>>2]=f[c+52>>2];f[e>>2]=f[h>>2];Anb(a+52|0,497760,e);p=f[l>>2]|0}if(!(p&4))q=p;else{p=b[c+68>>0]|0;h=a+24|0;f[h>>2]=f[h>>2]|4;b[a+68>>0]=p;q=f[l>>2]|0}if(!(q&8))r=q;else{q=b[c+69>>0]|0;p=a+24|0;f[p>>2]=f[p>>2]|8;b[a+69>>0]=q;r=f[l>>2]|0}if(!(r&16))s=r;else{r=b[c+70>>0]|0;q=a+24|0;f[q>>2]=f[q>>2]|16;b[a+70>>0]=r;s=f[l>>2]|0}if(!(s&32))t=s;else{s=f[c+76>>2]|0;r=a+24|0;f[r>>2]=f[r>>2]|32;f[a+76>>2]=s;t=f[l>>2]|0}if(!(t&64))v=t;else{t=a+24|0;f[t>>2]=f[t>>2]|64;f[i>>2]=f[c+56>>2];f[e>>2]=f[i>>2];Anb(a+56|0,497760,e);v=f[l>>2]|0}if(!(v&128))w=v;else{v=b[c+71>>0]|0;i=a+24|0;f[i>>2]=f[i>>2]|128;b[a+71>>0]=v;w=f[l>>2]|0}}else w=m;if(w&65280|0){if(!(w&256))x=w;else{w=b[c+72>>0]|0;m=a+24|0;f[m>>2]=f[m>>2]|256;b[a+72>>0]=w;x=f[l>>2]|0}if(!(x&512))y=x;else{x=b[c+73>>0]|0;w=a+24|0;f[w>>2]=f[w>>2]|512;b[a+73>>0]=x;y=f[l>>2]|0}if(!(y&1024))z=y;else{y=b[c+74>>0]|0;x=a+24|0;f[x>>2]=f[x>>2]|1024;b[a+74>>0]=y;z=f[l>>2]|0}if(!(z&2048))A=z;else{z=b[c+75>>0]|0;y=a+24|0;f[y>>2]=f[y>>2]|2048;b[a+75>>0]=z;A=f[l>>2]|0}if(!(A&4096))B=A;else{A=a+24|0;f[A>>2]=f[A>>2]|4096;f[j>>2]=f[c+60>>2];f[e>>2]=f[j>>2];Anb(a+60|0,497760,e);B=f[l>>2]|0}if(B&8192|0){B=a+24|0;f[B>>2]=f[B>>2]|8192;f[k>>2]=f[c+64>>2];f[e>>2]=f[k>>2];Anb(a+64|0,497760,e)}}SRb(a+4|0,c+4|0);e=f[c+20>>2]|0;if(!(e&1)){u=d;return}LPb(e&-2,a+20|0);u=d;return}function aAb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=137944;sQb(a+4|0);f[a+20>>2]=0;f[a+24>>2]=0;e=a+32|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=498480?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+28>>2]=0;f[a+48>>2]=497760;f[a+52>>2]=497760;f[a+56>>2]=497760;f[a+60>>2]=497760;f[a+64>>2]=497760;d=a+68|0;f[d>>2]=0;f[d+4>>2]=0;f[a+76>>2]=1;u=c;return}function bAb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function cAb(a){a=a|0;var c=0,d=0;c=a+48|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+52|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+56|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+60|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+64|0;a=f[c>>2]|0;if((a|0)==497760|(a|0)==0){f[c>>2]=0;return}if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a);f[c>>2]=0;return}function dAb(a){a=a|0;var b=0,c=0;f[a>>2]=137836;wAb(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function eAb(a){a=a|0;dAb(a);O5b(a);return}function fAb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function gAb(a,b){a=a|0;b=b|0;a=L5b(36)|0;uAb(a);if(!b)return a|0;vAb(b,a);return a|0}function hAb(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;e=f[c>>2]|0;if(e&63|0){d[a+32>>1]=0;do if(e&1|0?(g=f[a+16>>2]|0,(g|0)!=497760):0){h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);do if(f[c>>2]&2|0?(e=f[a+20>>2]|0,(e|0)!=497760):0){h=e+11|0;if((b[h>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[h>>0]=0;break}}while(0);do if(f[c>>2]&4|0?(h=f[a+24>>2]|0,(h|0)!=497760):0){e=h+11|0;if((b[e>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[e>>0]=0;break}}while(0);if(f[c>>2]&8|0?(e=f[a+28>>2]|0,e|0):0){RRb(e+4|0);b[e+48>>0]=0;h=e+36|0;g=f[h>>2]|0;if((g|0)>0){i=f[e+44>>2]|0;j=0;do{k=f[i+4+(j<<2)>>2]|0;j=j+1|0;bi[f[(f[k>>2]|0)+28>>2]&2047](k)}while((j|0)!=(g|0));f[h>>2]=0}f[e+24>>2]=0;h=f[e+20>>2]|0;if(h&1|0?(e=h&-2,f[e>>2]|0):0)GPb(e)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function iAb(a){a=a|0;var b=0,c=0;if(f[a+8>>2]&8|0?(b=f[a+28>>2]|0,!(di[f[(f[b>>2]|0)+32>>2]&1023](b)|0)):0){c=0;return c|0}c=1;return c|0}function jAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+16|0;k=a+20|0;l=a+24|0;m=a+28|0;n=e+4|0;o=a+32|0;p=e+8|0;q=a+33|0;r=c+32|0;s=c+12|0;t=c+28|0;v=e+8|0;w=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){x=b[a>>0]|0;y=x&255;if(x<<24>>24>0){f[h>>2]=y;f[c>>2]=a+1;z=y;A=6}else{B=y;A=5}}else{B=0;A=5}if((A|0)==5){A=0;y=_nb(c,B)|0;f[h>>2]=y;if((y+-1|0)>>>0<127){z=y;A=6}else{C=y;A=63}}b:do if((A|0)==6){A=0;switch(z>>>3&536870911|0){case 1:{switch(z|0){case 0:{D=1;A=69;break a;break}case 10:break;default:{E=z;break b}}f[i>>2]=f[i>>2]|1;y=f[j>>2]|0;if((y|0)==497760){jza(j,497760);F=f[j>>2]|0}else F=y;if(!(fqb(c,F)|0)){D=0;A=69;break a}y=f[c>>2]|0;if(y>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[y>>0]|0)!=18)continue a;f[c>>2]=y+1;A=15;break}case 2:{switch(z|0){case 0:{D=1;A=69;break a;break}case 18:{A=15;break}default:{E=z;break b}}break}case 3:{switch(z|0){case 0:{D=1;A=69;break a;break}case 26:{A=22;break}default:{E=z;break b}}break}case 4:{switch(z|0){case 0:{D=1;A=69;break a;break}case 34:{A=29;break}default:{E=z;break b}}break}case 5:{switch(z|0){case 0:{D=1;A=69;break a;break}case 40:break;default:{E=z;break b}}G=f[c>>2]|0;H=f[g>>2]|0;A=44;break}case 6:{switch(z|0){case 0:{D=1;A=69;break a;break}case 48:break;default:{E=z;break b}}I=f[c>>2]|0;J=f[g>>2]|0;break}default:{C=z;A=63;break b}}if((A|0)==15){A=0;f[i>>2]=f[i>>2]|2;y=f[k>>2]|0;if((y|0)==497760){jza(k,497760);K=f[k>>2]|0}else K=y;if(!(fqb(c,K)|0)){D=0;A=69;break a}y=f[c>>2]|0;if(y>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[y>>0]|0)!=26)continue a;f[c>>2]=y+1;A=22}if((A|0)==22){A=0;f[i>>2]=f[i>>2]|4;y=f[l>>2]|0;if((y|0)==497760){jza(l,497760);L=f[l>>2]|0}else L=y;if(!(fqb(c,L)|0)){D=0;A=69;break a}y=f[c>>2]|0;if(y>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[y>>0]|0)!=34)continue a;f[c>>2]=y+1;A=29}if((A|0)==29){A=0;f[i>>2]=f[i>>2]|8;y=f[m>>2]|0;if(!y){a=L5b(52)|0;Hxb(a);f[m>>2]=a;M=a}else M=y;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(a=b[y>>0]|0,a<<24>>24>-1):0){f[c>>2]=y+1;N=a&255}else{a=Znb(c)|0;if((a|0)>-1)N=a;else{D=0;A=69;break a}}Inb(e,c,N);if((f[n>>2]|0)<0){A=37;break a}if(!(sxb(M,c)|0)){A=37;break a}if(!(Onb(c,f[e>>2]|0)|0)){D=0;A=69;break a}a=f[c>>2]|0;y=f[g>>2]|0;if(a>>>0>=y>>>0)continue a;if((b[a>>0]|0)!=40)continue a;x=a+1|0;f[c>>2]=x;G=x;H=y;A=44}if((A|0)==44){A=0;f[i>>2]=f[i>>2]|16;if(G>>>0<H>>>0?(y=b[G>>0]|0,y<<24>>24>-1):0){x=G+1|0;f[c>>2]=x;O=y<<24>>24!=0;P=x;Q=H}else{Lnb(e,c);x=e;if(!(b[p>>0]|0)){D=0;A=69;break a}O=(f[x>>2]|0)!=0|(f[x+4>>2]|0)!=0;P=f[c>>2]|0;Q=f[g>>2]|0}b[o>>0]=O&1;if(P>>>0>=Q>>>0)continue a;if((b[P>>0]|0)!=48)continue a;x=P+1|0;f[c>>2]=x;I=x;J=Q}f[i>>2]=f[i>>2]|32;if(I>>>0<J>>>0?(x=b[I>>0]|0,x<<24>>24>-1):0){y=I+1|0;f[c>>2]=y;R=x<<24>>24!=0;S=y;T=J}else{Lnb(e,c);y=e;if(!(b[v>>0]|0)){D=0;A=69;break a}R=(f[y>>2]|0)!=0|(f[y+4>>2]|0)!=0;S=f[c>>2]|0;T=f[g>>2]|0}b[q>>0]=R&1;if((S|0)!=(T|0))continue a;if(f[r>>2]|0){A=62;break a}if((f[s>>2]|0)==(f[t>>2]|0)){A=62;break a}else continue a}while(0);if((A|0)==63){A=0;if(!C){D=1;A=69;break}else E=C}if((E&7|0)==4){D=1;A=69;break}y=f[w>>2]|0;if(!(y&1))U=hBa(w)|0;else U=y&-2;if(!(ZPb(c,E,U)|0)){D=0;A=69;break}}if((A|0)==37){D=0;u=d;return D|0}else if((A|0)==62){f[h>>2]=0;b[c+24>>0]=1;D=1;u=d;return D|0}else if((A|0)==69){u=d;return D|0}return 0}function kAb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;c=a+8|0;d=f[c>>2]|0;if(!(d&63))e=0;else{if(!(d&1)){g=0;h=d}else{i=f[a+16>>2]|0;j=b[i+11>>0]|0;if(j<<24>>24<0){k=f[i+4>>2]|0;if(k>>>0<128){l=1;m=d;n=k}else{i=iob(k)|0;l=i;m=f[c>>2]|0;n=k}}else{l=1;m=d;n=j&255}g=n+1+l|0;h=m}if(!(h&2)){o=g;p=h}else{m=f[a+20>>2]|0;l=b[m+11>>0]|0;if(l<<24>>24<0){n=f[m+4>>2]|0;if(n>>>0<128){q=1;r=h;s=n}else{m=iob(n)|0;q=m;r=f[c>>2]|0;s=n}}else{q=1;r=h;s=l&255}o=g+1+s+q|0;p=r}if(!(p&4)){t=o;u=p}else{r=f[a+24>>2]|0;q=b[r+11>>0]|0;if(q<<24>>24<0){s=f[r+4>>2]|0;if(s>>>0<128){v=1;w=p;x=s}else{r=iob(s)|0;v=r;w=f[c>>2]|0;x=s}}else{v=1;w=p;x=q&255}t=o+1+x+v|0;u=w}if(!(u&8)){y=t;z=u}else{u=f[a+28>>2]|0;w=f[u+36>>2]|0;v=(f[u+24>>2]&1|0?3:0)+(w<<1)|0;if(!w)A=v;else{x=u+44|0;o=0;q=v;while(1){v=Wwb(f[(f[x>>2]|0)+4+(o<<2)>>2]|0)|0;if(v>>>0<128)B=1;else B=iob(v)|0;p=v+q+B|0;o=o+1|0;if((o|0)==(w|0)){A=p;break}else q=p}}q=(aSb(u+4|0)|0)+A|0;A=f[u+20>>2]|0;if(!(A&1))C=q;else C=(dQb(A&-2)|0)+q|0;f[u+28>>2]=C;if(C>>>0<128)D=1;else D=iob(C)|0;y=t+1+C+D|0;z=f[c>>2]|0}c=z&16|0?y+2|0:y;e=z&32|0?c+2|0:c}c=f[a+4>>2]|0;if(!(c&1)){E=e;F=a+12|0;f[F>>2]=E;return E|0}E=(dQb(c&-2)|0)+e|0;F=a+12|0;f[F>>2]=E;return E|0}function lAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+8|0;e=f[d>>2]|0;if(!(e&1))g=e;else{$pb(1,f[a+16>>2]|0,c);g=f[d>>2]|0}if(!(g&2))h=g;else{$pb(2,f[a+20>>2]|0,c);h=f[d>>2]|0}if(!(h&4))i=h;else{$pb(3,f[a+24>>2]|0,c);i=f[d>>2]|0}if(!(i&8))j=i;else{eqb(4,f[a+28>>2]|0,c);j=f[d>>2]|0}if(!(j&16))k=j;else{Ypb(5,(b[a+32>>0]|0)!=0,c);k=f[d>>2]|0}if(k&32|0)Ypb(6,(b[a+33>>0]|0)!=0,c);k=f[a+4>>2]|0;if(!(k&1))return;aQb(k&-2,c);return}function mAb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function nAb(a){a=a|0;return f[a+12>>2]|0}function oAb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&2)){j=g;k=h}else{h=f[a+20>>2]|0;b[g>>0]=18;i=kob(h,g+1|0)|0;j=i;k=f[c>>2]|0}if(!(k&4)){l=j;m=k}else{k=f[a+24>>2]|0;b[j>>0]=26;i=kob(k,j+1|0)|0;l=i;m=f[c>>2]|0}if(!(m&8)){n=l;o=m}else{m=f[a+28>>2]|0;b[l>>0]=34;i=l+1|0;l=f[m+28>>2]|0;if(l>>>0>127){j=l;k=i;while(1){b[k>>0]=j|128;g=j>>>7;h=k+1|0;if(j>>>0>16383){j=g;k=h}else{p=h;q=g;break}}}else{p=i;q=l}b[p>>0]=q;q=li[f[(f[m>>2]|0)+68>>2]&511](m,0,p+1|0)|0;n=q;o=f[c>>2]|0}if(!(o&16)){r=n;s=o}else{o=b[a+32>>0]|0;b[n>>0]=40;b[n+1>>0]=o;r=n+2|0;s=f[c>>2]|0}if(!(s&32))t=r;else{s=b[a+33>>0]|0;b[r>>0]=48;b[r+1>>0]=s;t=r+2|0}r=f[a+4>>2]|0;if(!(r&1)){u=t;return u|0}u=bQb(r&-2,t)|0;return u|0}function pAb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function qAb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(7862);c=T6b(b,23288,22888,0)|0;if(!c){cOb(b,a);return}else{tAb(a,c);return}}function rAb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function sAb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213396];f[a+4>>2]=f[213397];u=c;return}function tAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+16|0;e=d+12|0;g=d+8|0;h=d+4|0;i=d;j=c+8|0;k=f[j>>2]|0;if(k&255|0){if(!(k&1))l=k;else{k=a+8|0;f[k>>2]=f[k>>2]|1;f[g>>2]=f[c+16>>2];f[e>>2]=f[g>>2];Anb(a+16|0,497760,e);l=f[j>>2]|0}if(!(l&2))m=l;else{l=a+8|0;f[l>>2]=f[l>>2]|2;f[h>>2]=f[c+20>>2];f[e>>2]=f[h>>2];Anb(a+20|0,497760,e);m=f[j>>2]|0}if(!(m&4))n=m;else{m=a+8|0;f[m>>2]=f[m>>2]|4;f[i>>2]=f[c+24>>2];f[e>>2]=f[i>>2];Anb(a+24|0,497760,e);n=f[j>>2]|0}if(n&8|0){n=a+8|0;f[n>>2]=f[n>>2]|8;n=a+28|0;e=f[n>>2]|0;if(!e){i=L5b(52)|0;Hxb(i);f[n>>2]=i;o=i}else o=e;e=f[c+28>>2]|0;i=(e|0)==0?498952:e;if((i|0)==(o|0))ivb(12787);Cxb(o+32|0,i+32|0);if(f[i+24>>2]&1|0){e=b[i+48>>0]|0;n=o+24|0;f[n>>2]=f[n>>2]|1;b[o+48>>0]=e}SRb(o+4|0,i+4|0);e=f[i+20>>2]|0;if(e&1|0)LPb(e&-2,o+20|0)}o=f[j>>2]|0;if(!(o&16))p=o;else{o=b[c+32>>0]|0;e=a+8|0;f[e>>2]=f[e>>2]|16;b[a+32>>0]=o;p=f[j>>2]|0}if(p&32|0){p=b[c+33>>0]|0;j=a+8|0;f[j>>2]=f[j>>2]|32;b[a+33>>0]=p}}p=f[c+4>>2]|0;if(!(p&1)){u=d;return}LPb(p&-2,a+4|0);u=d;return}function uAb(a){a=a|0;var c=0,e=0;c=u;u=u+16|0;e=c;f[a>>2]=137836;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=498432?(f[213371]|0)!=2:0){f[e>>2]=135812;f[e+4>>2]=55;b[e+8>>0]=0;Gpb(853484,e);hpb(e)}f[a+12>>2]=0;f[a+16>>2]=497760;f[a+20>>2]=497760;f[a+24>>2]=497760;f[a+28>>2]=0;d[a+32>>1]=0;u=c;return}function vAb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function wAb(a){a=a|0;var c=0,d=0;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+20|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+24|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)==498432)return;c=f[a+28>>2]|0;if(!c)return;bi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function xAb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=137728;c=a+32|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)!=498384?(c=f[a+36>>2]|0,c|0):0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+28|0;d=f[c>>2]|0;if(d|0?(f[a+16>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)bi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(i);f[c>>2]=0;return}function yAb(a){a=a|0;xAb(a);O5b(a);return}function zAb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function AAb(a,b){a=a|0;b=b|0;a=L5b(40)|0;QAb(a);if(!b)return a|0;RAb(b,a);return a|0}function BAb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[c>>2]|0;if(d&5|0){do if(d&1|0?(e=f[a+32>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(f[c>>2]&4|0?(d=f[a+36>>2]|0,d|0):0){RRb(d+4|0);b[d+48>>0]=0;g=d+36|0;e=f[g>>2]|0;if((e|0)>0){h=f[d+44>>2]|0;i=0;do{j=f[h+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((i|0)!=(e|0));f[g>>2]=0}f[d+24>>2]=0;g=f[d+20>>2]|0;if(g&1|0?(d=g&-2,f[d>>2]|0):0)GPb(d)}}d=a+20|0;g=f[d>>2]|0;if((g|0)>0){e=f[a+28>>2]|0;i=0;do{h=f[e+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((i|0)!=(g|0));f[d>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function CAb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+28|0;c=f[a+20>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=7;break}}if((g|0)==7)return e|0;if(f[a+8>>2]&4|0?(g=f[a+36>>2]|0,!(di[f[(f[g>>2]|0)+32>>2]&1023](g)|0)):0){e=0;return e|0}e=1;return e|0}function DAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+32|0;k=c+44|0;l=a+16|0;m=a+28|0;n=a+24|0;o=a+20|0;p=a+36|0;q=e+4|0;r=c+32|0;s=c+12|0;t=c+28|0;v=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){w=b[a>>0]|0;x=w&255;if(w<<24>>24>0){f[h>>2]=x;f[c>>2]=a+1;y=x;z=6}else{A=x;z=5}}else{A=0;z=5}if((z|0)==5){z=0;x=_nb(c,A)|0;f[h>>2]=x;if((x+-1|0)>>>0<127){y=x;z=6}else{B=x;z=46}}b:do if((z|0)==6){z=0;switch(y>>>3&536870911|0){case 1:{switch(y|0){case 0:{C=1;z=52;break a;break}case 10:break;default:{D=y;break b}}f[i>>2]=f[i>>2]|1;x=f[j>>2]|0;if((x|0)==497760){jza(j,497760);E=f[j>>2]|0}else E=x;if(!(fqb(c,E)|0)){C=0;z=52;break a}x=f[c>>2]|0;if(x>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[x>>0]|0)!=18)continue a;f[c>>2]=x+1;z=15;break}case 2:{switch(y|0){case 0:{C=1;z=52;break a;break}case 18:{z=15;break}default:{D=y;break b}}break}case 3:{switch(y|0){case 0:{C=1;z=52;break a;break}case 26:break;default:{D=y;break b}}break}default:{B=y;z=46;break b}}if((z|0)==15){z=0;x=f[k>>2]|0;f[k>>2]=x+-1;if((x|0)<=0){C=0;z=52;break a}while(1){x=f[m>>2]|0;do if(x){a=f[o>>2]|0;w=f[x>>2]|0;if((a|0)>=(w|0))if((w|0)==(f[n>>2]|0)){F=w;z=21;break}else{G=w;H=x;z=22;break}else{f[o>>2]=a+1;I=f[x+4+(a<<2)>>2]|0;break}}else{F=f[n>>2]|0;z=21}while(0);if((z|0)==21){z=0;cpb(l,F+1|0);x=f[m>>2]|0;G=f[x>>2]|0;H=x;z=22}if((z|0)==22){z=0;f[H>>2]=G+1;x=Ltb(0,f[l>>2]|0)|0;a=f[m>>2]|0;w=f[o>>2]|0;f[o>>2]=w+1;f[a+4+(w<<2)>>2]=x;I=x}x=Jnb(c)|0;if(!(jAb(I,c)|0)){C=0;z=52;break a}if(!(Pnb(c,x)|0)){C=0;z=52;break a}J=f[c>>2]|0;if(J>>>0>=(f[g>>2]|0)>>>0){z=26;break}if((b[J>>0]|0)!=18)break;f[c>>2]=J+1}if((z|0)==26){z=0;f[k>>2]=(f[k>>2]|0)+1;continue a}f[k>>2]=(f[k>>2]|0)+1;if((b[J>>0]|0)!=26)continue a;f[c>>2]=J+1}f[i>>2]=f[i>>2]|4;x=f[p>>2]|0;if(!x){w=L5b(52)|0;Zxb(w);f[p>>2]=w;K=w}else K=x;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(w=b[x>>0]|0,w<<24>>24>-1):0){f[c>>2]=x+1;L=w&255}else{w=Znb(c)|0;if((w|0)>-1)L=w;else{C=0;z=52;break a}}Inb(e,c,L);if((f[q>>2]|0)<0){z=40;break a}if(!(Pxb(K,c)|0)){z=40;break a}if(!(Onb(c,f[e>>2]|0)|0)){C=0;z=52;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[r>>2]|0){z=45;break a}if((f[s>>2]|0)==(f[t>>2]|0)){z=45;break a}else continue a}while(0);if((z|0)==46){z=0;if(!B){C=1;z=52;break}else D=B}if((D&7|0)==4){C=1;z=52;break}w=f[v>>2]|0;if(!(w&1))M=hBa(v)|0;else M=w&-2;if(!(ZPb(c,D,M)|0)){C=0;z=52;break}}if((z|0)==40){C=0;u=d;return C|0}else if((z|0)==45){f[h>>2]=0;b[c+24>>0]=1;C=1;u=d;return C|0}else if((z|0)==52){u=d;return C|0}return 0}function EAb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+8|0;d=f[c>>2]|0;if(d&5){if(!(d&1)){e=0;g=d}else{h=f[a+32>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&4))n=e;else{g=f[a+36>>2]|0;l=f[g+36>>2]|0;k=(f[g+24>>2]&1|0?3:0)+(l<<1)|0;if(!l)o=k;else{m=g+44|0;i=0;d=k;while(1){k=Wwb(f[(f[m>>2]|0)+4+(i<<2)>>2]|0)|0;if(k>>>0<128)p=1;else p=iob(k)|0;j=k+d+p|0;i=i+1|0;if((i|0)==(l|0)){o=j;break}else d=j}}d=(aSb(g+4|0)|0)+o|0;o=f[g+20>>2]|0;if(!(o&1))q=d;else q=(dQb(o&-2)|0)+d|0;f[g+28>>2]=q;if(q>>>0<128)r=1;else r=iob(q)|0;n=e+1+q+r|0}}else n=0;r=f[a+20>>2]|0;q=r+n|0;if(!r)s=q;else{n=a+28|0;e=0;g=q;while(1){q=kAb(f[(f[n>>2]|0)+4+(e<<2)>>2]|0)|0;if(q>>>0<128)t=1;else t=iob(q)|0;d=q+g+t|0;e=e+1|0;if((e|0)==(r|0)){s=d;break}else g=d}}g=f[a+4>>2]|0;if(!(g&1)){u=s;v=a+12|0;f[v>>2]=u;return u|0}u=(dQb(g&-2)|0)+s|0;v=a+12|0;f[v>>2]=u;return u|0}function FAb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;if(f[c>>2]&1|0)$pb(1,f[a+32>>2]|0,b);d=f[a+20>>2]|0;if(d|0){e=a+28|0;g=0;do{eqb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(f[c>>2]&4|0)eqb(3,f[a+36>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function GAb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function HAb(a){a=a|0;return f[a+12>>2]|0}function IAb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+8|0;if(!(f[c>>2]&1))e=d;else{g=f[a+32>>2]|0;b[d>>0]=10;e=kob(g,d+1|0)|0}d=f[a+20>>2]|0;if(!d)h=e;else{g=a+28|0;i=0;j=e;while(1){e=f[(f[g>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=18;k=j+1|0;l=f[e+12>>2]|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=li[f[(f[e>>2]|0)+68>>2]&511](e,0,q+1|0)|0;i=i+1|0;if((i|0)==(d|0)){h=n;break}else j=n}}if(!(f[c>>2]&4))s=h;else{c=f[a+36>>2]|0;b[h>>0]=26;j=h+1|0;h=f[c+28>>2]|0;if(h>>>0>127){d=h;i=j;while(1){b[i>>0]=d|128;q=d>>>7;r=i+1|0;if(d>>>0>16383){d=q;i=r}else{t=r;u=q;break}}}else{t=j;u=h}b[t>>0]=u;s=li[f[(f[c>>2]|0)+68>>2]&511](c,0,t+1|0)|0}t=f[a+4>>2]|0;if(!(t&1)){v=s;return v|0}v=bQb(t&-2,s)|0;return v|0}function JAb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function KAb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(7217);c=T6b(b,23288,22904,0)|0;if(!c){cOb(b,a);return}else{NAb(a,c);return}}function LAb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function MAb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213394];f[a+4>>2]=f[213395];u=c;return}function NAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d+4|0;g=d;OAb(a+16|0,c+16|0);h=c+8|0;i=f[h>>2]|0;if(i&255|0){if(!(i&1))j=i;else{i=a+8|0;f[i>>2]=f[i>>2]|1;f[g>>2]=f[c+32>>2];f[e>>2]=f[g>>2];Anb(a+32|0,497760,e);j=f[h>>2]|0}if(j&4|0){j=a+8|0;f[j>>2]=f[j>>2]|4;j=a+36|0;h=f[j>>2]|0;if(!h){e=L5b(52)|0;Zxb(e);f[j>>2]=e;k=e}else k=h;h=f[c+36>>2]|0;e=(h|0)==0?498888:h;if((e|0)==(k|0))ivb(12412);Cxb(k+32|0,e+32|0);if(f[e+24>>2]&1|0){h=b[e+48>>0]|0;j=k+24|0;f[j>>2]=f[j>>2]|1;b[k+48>>0]=h}SRb(k+4|0,e+4|0);h=f[e+20>>2]|0;if(h&1|0)LPb(h&-2,k+20|0)}}k=f[c+4>>2]|0;if(!(k&1)){u=d;return}LPb(k&-2,a+4|0);u=d;return}function OAb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{PAb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Ltb(h,i)|0;PAb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function PAb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))ivb(7880);else{tAb(b,a);return}}function QAb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=137728;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=498384?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;f[a+32>>2]=497760;f[a+36>>2]=0;u=c;return}function RAb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function SAb(a){a=a|0;var c=0,d=0;f[a>>2]=137620;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)!=498344?(c=f[a+20>>2]|0,c|0):0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(d);f[c>>2]=0;return}function TAb(a){a=a|0;SAb(a);O5b(a);return}function UAb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function VAb(a,b){a=a|0;b=b|0;a=L5b(28)|0;hBb(a);if(!b)return a|0;iBb(b,a);return a|0}function WAb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[c>>2]|0;if(d&7|0){do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);f[a+24>>2]=0;if(f[c>>2]&4|0?(d=f[a+20>>2]|0,d|0):0){RRb(d+4|0);b[d+48>>0]=0;g=d+36|0;e=f[g>>2]|0;if((e|0)>0){h=f[d+44>>2]|0;i=0;do{j=f[h+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((i|0)!=(e|0));f[g>>2]=0}f[d+24>>2]=0;g=f[d+20>>2]|0;if(g&1|0?(d=g&-2,f[d>>2]|0):0)GPb(d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function XAb(a){a=a|0;var b=0,c=0;if(f[a+8>>2]&4|0?(b=f[a+20>>2]|0,!(di[f[(f[b>>2]|0)+32>>2]&1023](b)|0)):0){c=0;return c|0}c=1;return c|0}function YAb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+16|0;k=a+24|0;l=a+20|0;m=e+4|0;n=c+32|0;o=c+12|0;p=c+28|0;q=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){r=b[a>>0]|0;s=r&255;if(r<<24>>24>0){f[h>>2]=s;f[c>>2]=a+1;t=s;v=6}else{w=s;v=5}}else{w=0;v=5}if((v|0)==5){v=0;s=_nb(c,w)|0;f[h>>2]=s;if((s+-1|0)>>>0<127){t=s;v=6}else{x=s;v=39}}b:do if((v|0)==6){v=0;switch(t>>>3&536870911|0){case 1:{switch(t|0){case 0:{y=1;v=45;break a;break}case 10:break;default:{z=t;break b}}f[i>>2]=f[i>>2]|1;s=f[j>>2]|0;if((s|0)==497760){jza(j,497760);A=f[j>>2]|0}else A=s;if(!(fqb(c,A)|0)){y=0;v=45;break a}s=f[c>>2]|0;a=f[g>>2]|0;if(s>>>0>=a>>>0)continue a;if((b[s>>0]|0)!=16)continue a;r=s+1|0;f[c>>2]=r;B=r;C=a;v=16;break}case 2:{switch(t|0){case 0:{y=1;v=45;break a;break}case 16:break;default:{z=t;break b}}B=f[c>>2]|0;C=f[g>>2]|0;v=16;break}case 3:{switch(t|0){case 0:{y=1;v=45;break a;break}case 26:break;default:{z=t;break b}}break}default:{x=t;v=39;break b}}if((v|0)==16){v=0;f[i>>2]=f[i>>2]|2;if(B>>>0<C>>>0){a=b[B>>0]|0;r=a&255;if(a<<24>>24>-1){a=B+1|0;f[c>>2]=a;D=r;E=a;F=C}else{G=r;v=19}}else{G=0;v=19}if((v|0)==19){v=0;r=Knb(c,G)|0;a=J;if(!((a|0)>-1|(a|0)==-1&r>>>0>4294967295)){y=0;v=45;break a}D=r;E=f[c>>2]|0;F=f[g>>2]|0}f[k>>2]=D;if(E>>>0>=F>>>0)continue a;if((b[E>>0]|0)!=26)continue a;f[c>>2]=E+1}f[i>>2]=f[i>>2]|4;r=f[l>>2]|0;if(!r){a=L5b(52)|0;pyb(a);f[l>>2]=a;H=a}else H=r;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(a=b[r>>0]|0,a<<24>>24>-1):0){f[c>>2]=r+1;I=a&255}else{a=Znb(c)|0;if((a|0)>-1)I=a;else{y=0;v=45;break a}}Inb(e,c,I);if((f[m>>2]|0)<0){v=33;break a}if(!(fyb(H,c)|0)){v=33;break a}if(!(Onb(c,f[e>>2]|0)|0)){y=0;v=45;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[n>>2]|0){v=38;break a}if((f[o>>2]|0)==(f[p>>2]|0)){v=38;break a}else continue a}while(0);if((v|0)==39){v=0;if(!x){y=1;v=45;break}else z=x}if((z&7|0)==4){y=1;v=45;break}a=f[q>>2]|0;if(!(a&1))K=hBa(q)|0;else K=a&-2;if(!(ZPb(c,z,K)|0)){y=0;v=45;break}}if((v|0)==33){y=0;u=d;return y|0}else if((v|0)==38){f[h>>2]=0;b[c+24>>0]=1;y=1;u=d;return y|0}else if((v|0)==45){u=d;return y|0}return 0}function ZAb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+8|0;d=f[c>>2]|0;if(d&7){if(!(d&1)){e=0;g=d}else{h=f[a+16>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&2)){n=e;o=g}else{l=f[a+24>>2]|0;if((l|0)>=0)if(l>>>0<128){p=2;q=g}else{k=(iob(l)|0)+1|0;p=k;q=f[c>>2]|0}else{p=11;q=g}n=p+e|0;o=q}if(!(o&4))r=n;else{o=f[a+20>>2]|0;q=f[o+36>>2]|0;e=(f[o+24>>2]<<1&2)+(q<<1)|0;if(!q)s=e;else{p=o+44|0;g=0;c=e;while(1){e=Wwb(f[(f[p>>2]|0)+4+(g<<2)>>2]|0)|0;if(e>>>0<128)t=1;else t=iob(e)|0;k=e+c+t|0;g=g+1|0;if((g|0)==(q|0)){s=k;break}else c=k}}c=(aSb(o+4|0)|0)+s|0;s=f[o+20>>2]|0;if(!(s&1))u=c;else u=(dQb(s&-2)|0)+c|0;f[o+28>>2]=u;if(u>>>0<128)v=1;else v=iob(u)|0;r=n+1+u+v|0}}else r=0;v=f[a+4>>2]|0;if(!(v&1)){w=r;x=a+12|0;f[x>>2]=w;return w|0}w=(dQb(v&-2)|0)+r|0;x=a+12|0;f[x>>2]=w;return w|0}function _Ab(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{$pb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(!(e&2))g=e;else{Mpb(2,f[a+24>>2]|0,b);g=f[c>>2]|0}if(g&4|0)eqb(3,f[a+20>>2]|0,b);g=f[a+4>>2]|0;if(!(g&1))return;aQb(g&-2,b);return}function $Ab(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function aBb(a){a=a|0;return f[a+12>>2]|0}function bBb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}do if(!(h&2))j=g;else{i=f[a+24>>2]|0;b[g>>0]=16;d=g+1|0;if((i|0)<0){j=hob(i,((i|0)<0)<<31>>31,d)|0;break}if(i>>>0>127){e=i;k=d;while(1){b[k>>0]=e|128;l=e>>>7;m=k+1|0;if(e>>>0>16383){e=l;k=m}else{n=m;o=l;break}}}else{n=d;o=i}b[n>>0]=o;j=n+1|0}while(0);if(!(f[c>>2]&4))p=j;else{c=f[a+20>>2]|0;b[j>>0]=26;n=j+1|0;j=f[c+28>>2]|0;if(j>>>0>127){o=j;g=n;while(1){b[g>>0]=o|128;h=o>>>7;k=g+1|0;if(o>>>0>16383){o=h;g=k}else{q=k;r=h;break}}}else{q=n;r=j}b[q>>0]=r;p=li[f[(f[c>>2]|0)+68>>2]&511](c,0,q+1|0)|0}q=f[a+4>>2]|0;if(!(q&1)){s=p;return s|0}s=bQb(q&-2,p)|0;return s|0}function cBb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function dBb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(6721);c=T6b(b,23288,22920,0)|0;if(!c){cOb(b,a);return}else{gBb(a,c);return}}function eBb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function fBb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213392];f[a+4>>2]=f[213393];u=c;return}function gBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d+4|0;g=d;h=c+8|0;i=f[h>>2]|0;if(i&255|0){if(!(i&1))j=i;else{i=a+8|0;f[i>>2]=f[i>>2]|1;f[g>>2]=f[c+16>>2];f[e>>2]=f[g>>2];Anb(a+16|0,497760,e);j=f[h>>2]|0}if(!(j&2))k=j;else{j=f[c+24>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;f[a+24>>2]=j;k=f[h>>2]|0}if(k&4|0){k=a+8|0;f[k>>2]=f[k>>2]|4;k=a+20|0;h=f[k>>2]|0;if(!h){j=L5b(52)|0;pyb(j);f[k>>2]=j;l=j}else l=h;h=f[c+20>>2]|0;j=(h|0)==0?498824:h;if((j|0)==(l|0))ivb(12037);Cxb(l+32|0,j+32|0);if(f[j+24>>2]&1|0){h=b[j+48>>0]|0;k=l+24|0;f[k>>2]=f[k>>2]|1;b[l+48>>0]=h}SRb(l+4|0,j+4|0);h=f[j+20>>2]|0;if(h&1|0)LPb(h&-2,l+20|0)}}l=f[c+4>>2]|0;if(!(l&1)){u=d;return}LPb(l&-2,a+4|0);u=d;return}function hBb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=137620;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=498344?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=497760;f[a+20>>2]=0;f[a+24>>2]=0;u=c;return}function iBb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function jBb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=137512;c=a+32|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)!=498296?(c=f[a+36>>2]|0,c|0):0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+28|0;d=f[c>>2]|0;if(d|0?(f[a+16>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)bi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(i);f[c>>2]=0;return}function kBb(a){a=a|0;jBb(a);O5b(a);return}function lBb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function mBb(a,b){a=a|0;b=b|0;a=L5b(40)|0;DBb(a);if(!b)return a|0;EBb(b,a);return a|0}function nBb(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;e=f[c>>2]|0;if(e&5|0){do if(e&1|0?(g=f[a+32>>2]|0,(g|0)!=497760):0){h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[h>>0]=0;break}}while(0);if(f[c>>2]&4|0?(e=f[a+36>>2]|0,e|0):0){RRb(e+4|0);d[e+48>>1]=0;h=e+36|0;g=f[h>>2]|0;if((g|0)>0){i=f[e+44>>2]|0;j=0;do{k=f[i+4+(j<<2)>>2]|0;j=j+1|0;bi[f[(f[k>>2]|0)+28>>2]&2047](k)}while((j|0)!=(g|0));f[h>>2]=0}f[e+24>>2]=0;h=f[e+20>>2]|0;if(h&1|0?(e=h&-2,f[e>>2]|0):0)GPb(e)}}e=a+20|0;h=f[e>>2]|0;if((h|0)>0){g=f[a+28>>2]|0;j=0;do{i=f[g+4+(j<<2)>>2]|0;j=j+1|0;bi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((j|0)!=(h|0));f[e>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function oBb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+28|0;c=f[a+20>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=7;break}}if((g|0)==7)return e|0;if(f[a+8>>2]&4|0?(g=f[a+36>>2]|0,!(di[f[(f[g>>2]|0)+32>>2]&1023](g)|0)):0){e=0;return e|0}e=1;return e|0}function pBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+32|0;k=c+44|0;l=a+16|0;m=a+28|0;n=a+24|0;o=a+20|0;p=a+36|0;q=e+4|0;r=c+32|0;s=c+12|0;t=c+28|0;v=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){w=b[a>>0]|0;x=w&255;if(w<<24>>24>0){f[h>>2]=x;f[c>>2]=a+1;y=x;z=6}else{A=x;z=5}}else{A=0;z=5}if((z|0)==5){z=0;x=_nb(c,A)|0;f[h>>2]=x;if((x+-1|0)>>>0<127){y=x;z=6}else{B=x;z=46}}b:do if((z|0)==6){z=0;switch(y>>>3&536870911|0){case 1:{switch(y|0){case 0:{C=1;z=52;break a;break}case 10:break;default:{D=y;break b}}f[i>>2]=f[i>>2]|1;x=f[j>>2]|0;if((x|0)==497760){jza(j,497760);E=f[j>>2]|0}else E=x;if(!(fqb(c,E)|0)){C=0;z=52;break a}x=f[c>>2]|0;if(x>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[x>>0]|0)!=18)continue a;f[c>>2]=x+1;z=15;break}case 2:{switch(y|0){case 0:{C=1;z=52;break a;break}case 18:{z=15;break}default:{D=y;break b}}break}case 3:{switch(y|0){case 0:{C=1;z=52;break a;break}case 26:break;default:{D=y;break b}}break}default:{B=y;z=46;break b}}if((z|0)==15){z=0;x=f[k>>2]|0;f[k>>2]=x+-1;if((x|0)<=0){C=0;z=52;break a}while(1){x=f[m>>2]|0;do if(x){a=f[o>>2]|0;w=f[x>>2]|0;if((a|0)>=(w|0))if((w|0)==(f[n>>2]|0)){F=w;z=21;break}else{G=w;H=x;z=22;break}else{f[o>>2]=a+1;I=f[x+4+(a<<2)>>2]|0;break}}else{F=f[n>>2]|0;z=21}while(0);if((z|0)==21){z=0;cpb(l,F+1|0);x=f[m>>2]|0;G=f[x>>2]|0;H=x;z=22}if((z|0)==22){z=0;f[H>>2]=G+1;x=Ttb(0,f[l>>2]|0)|0;a=f[m>>2]|0;w=f[o>>2]|0;f[o>>2]=w+1;f[a+4+(w<<2)>>2]=x;I=x}x=Jnb(c)|0;if(!(YAb(I,c)|0)){C=0;z=52;break a}if(!(Pnb(c,x)|0)){C=0;z=52;break a}J=f[c>>2]|0;if(J>>>0>=(f[g>>2]|0)>>>0){z=26;break}if((b[J>>0]|0)!=18)break;f[c>>2]=J+1}if((z|0)==26){z=0;f[k>>2]=(f[k>>2]|0)+1;continue a}f[k>>2]=(f[k>>2]|0)+1;if((b[J>>0]|0)!=26)continue a;f[c>>2]=J+1}f[i>>2]=f[i>>2]|4;x=f[p>>2]|0;if(!x){w=L5b(52)|0;Hyb(w);f[p>>2]=w;K=w}else K=x;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(w=b[x>>0]|0,w<<24>>24>-1):0){f[c>>2]=x+1;L=w&255}else{w=Znb(c)|0;if((w|0)>-1)L=w;else{C=0;z=52;break a}}Inb(e,c,L);if((f[q>>2]|0)<0){z=40;break a}if(!(xyb(K,c)|0)){z=40;break a}if(!(Onb(c,f[e>>2]|0)|0)){C=0;z=52;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[r>>2]|0){z=45;break a}if((f[s>>2]|0)==(f[t>>2]|0)){z=45;break a}else continue a}while(0);if((z|0)==46){z=0;if(!B){C=1;z=52;break}else D=B}if((D&7|0)==4){C=1;z=52;break}w=f[v>>2]|0;if(!(w&1))M=hBa(v)|0;else M=w&-2;if(!(ZPb(c,D,M)|0)){C=0;z=52;break}}if((z|0)==40){C=0;u=d;return C|0}else if((z|0)==45){f[h>>2]=0;b[c+24>>0]=1;C=1;u=d;return C|0}else if((z|0)==52){u=d;return C|0}return 0}function qBb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=a+8|0;d=f[c>>2]|0;if(d&5){if(!(d&1)){e=0;g=d}else{h=f[a+32>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&4))n=e;else{g=yyb(f[a+36>>2]|0)|0;if(g>>>0<128)o=1;else o=iob(g)|0;n=e+1+g+o|0}}else n=0;o=f[a+20>>2]|0;g=o+n|0;if(!o)p=g;else{n=a+28|0;e=0;l=g;while(1){g=ZAb(f[(f[n>>2]|0)+4+(e<<2)>>2]|0)|0;if(g>>>0<128)q=1;else q=iob(g)|0;k=g+l+q|0;e=e+1|0;if((e|0)==(o|0)){p=k;break}else l=k}}l=f[a+4>>2]|0;if(!(l&1)){r=p;s=a+12|0;f[s>>2]=r;return r|0}r=(dQb(l&-2)|0)+p|0;s=a+12|0;f[s>>2]=r;return r|0}function rBb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;if(f[c>>2]&1|0)$pb(1,f[a+32>>2]|0,b);d=f[a+20>>2]|0;if(d|0){e=a+28|0;g=0;do{eqb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(f[c>>2]&4|0)eqb(3,f[a+36>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function sBb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function tBb(a){a=a|0;return f[a+12>>2]|0}function uBb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+8|0;if(!(f[c>>2]&1))e=d;else{g=f[a+32>>2]|0;b[d>>0]=10;e=kob(g,d+1|0)|0}d=f[a+20>>2]|0;if(!d)h=e;else{g=a+28|0;i=0;j=e;while(1){e=f[(f[g>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=18;k=j+1|0;l=f[e+12>>2]|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=li[f[(f[e>>2]|0)+68>>2]&511](e,0,q+1|0)|0;i=i+1|0;if((i|0)==(d|0)){h=n;break}else j=n}}if(!(f[c>>2]&4))s=h;else{c=f[a+36>>2]|0;b[h>>0]=26;j=h+1|0;h=f[c+28>>2]|0;if(h>>>0>127){d=h;i=j;while(1){b[i>>0]=d|128;q=d>>>7;r=i+1|0;if(d>>>0>16383){d=q;i=r}else{t=r;u=q;break}}}else{t=j;u=h}b[t>>0]=u;s=li[f[(f[c>>2]|0)+68>>2]&511](c,0,t+1|0)|0}t=f[a+4>>2]|0;if(!(t&1)){v=s;return v|0}v=bQb(t&-2,s)|0;return v|0}function vBb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function wBb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(6228);c=T6b(b,23288,22936,0)|0;if(!c){cOb(b,a);return}else{zBb(a,c);return}}function xBb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function yBb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213390];f[a+4>>2]=f[213391];u=c;return}function zBb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c+4|0;e=c;ABb(a+16|0,b+16|0);g=b+8|0;h=f[g>>2]|0;if(h&255|0){if(!(h&1))i=h;else{h=a+8|0;f[h>>2]=f[h>>2]|1;f[e>>2]=f[b+32>>2];f[d>>2]=f[e>>2];Anb(a+32|0,497760,d);i=f[g>>2]|0}if(i&4|0){i=a+8|0;f[i>>2]=f[i>>2]|4;i=a+36|0;g=f[i>>2]|0;if(!g){d=L5b(52)|0;Hyb(d);f[i>>2]=d;j=d}else j=g;g=f[b+36>>2]|0;BBb(j,(g|0)==0?498760:g)}}g=f[b+4>>2]|0;if(!(g&1)){u=c;return}LPb(g&-2,a+4|0);u=c;return}function ABb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{CBb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Ttb(h,i)|0;CBb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function BBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((c|0)==(a|0))ivb(11634);Cxb(a+32|0,c+32|0);d=c+24|0;e=f[d>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=b[c+48>>0]|0;h=a+24|0;f[h>>2]=f[h>>2]|1;b[a+48>>0]=e;g=f[d>>2]|0}if(g&2|0){g=b[c+49>>0]|0;d=a+24|0;f[d>>2]=f[d>>2]|2;b[a+49>>0]=g}}SRb(a+4|0,c+4|0);g=f[c+20>>2]|0;if(!(g&1))return;LPb(g&-2,a+20|0);return}function CBb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))ivb(6739);else{gBb(b,a);return}}function DBb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=137512;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=498296?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;f[a+32>>2]=497760;f[a+36>>2]=0;u=c;return}function EBb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function FBb(a){a=a|0;var c=0,d=0;f[a>>2]=137404;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)!=498264?(c=f[a+20>>2]|0,c|0):0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}d=a&-2;a=d;if((d|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(d);f[c>>2]=0;return}function GBb(a){a=a|0;FBb(a);O5b(a);return}function HBb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function IBb(a,b){a=a|0;b=b|0;a=L5b(24)|0;WBb(a);if(!b)return a|0;XBb(b,a);return a|0}function JBb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[c>>2]|0;if(d&3|0){do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(f[c>>2]&2|0?(d=f[a+20>>2]|0,d|0):0){RRb(d+4|0);g=d+36|0;e=f[g>>2]|0;if((e|0)>0){h=f[d+44>>2]|0;i=0;do{j=f[h+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((i|0)!=(e|0));f[g>>2]=0}f[d+24>>2]=0;g=f[d+20>>2]|0;if(g&1|0?(d=g&-2,f[d>>2]|0):0)GPb(d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function KBb(a){a=a|0;var b=0,c=0;if(f[a+8>>2]&2|0?(b=f[a+20>>2]|0,!(di[f[(f[b>>2]|0)+32>>2]&1023](b)|0)):0){c=0;return c|0}c=1;return c|0}
function KJb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;f[d+24>>2]=0;e=f[(f[b+16>>2]|0)+(c<<2)>>2]|0;g=d;h=e+4|0;i=f[h>>2]|0;do if(i){j=e+4|0;k=i;while(1){l=k+16|0;if(qJb(d,f[l>>2]|0)|0){m=f[k>>2]|0;if(!m){n=6;break}else{o=k;p=m}}else{if(!(qJb(f[l>>2]|0,d)|0)){n=10;break}q=k+4|0;l=f[q>>2]|0;if(!l){n=9;break}else{o=q;p=l}}j=o;k=p}if((n|0)==6){r=k;s=k;break}else if((n|0)==9){r=q;s=k;break}else if((n|0)==10){r=j;s=k;break}}else{r=h;s=h}while(0);h=f[r>>2]|0;if(h|0){t=h;u=t;v=c&-2;w=t+16|0;x=f[w>>2]|0;f[a>>2]=x;y=a+4|0;f[y>>2]=b;z=a+8|0;f[z>>2]=v;A=a+12|0;f[A>>2]=u;return}h=f[e+8>>2]|0;if(!h)B=L5b(20)|0;else B=znb(h,25536,20)|0;f[B+16>>2]=g;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=s;f[r>>2]=B;s=f[f[e>>2]>>2]|0;if(!s)C=B;else{f[e>>2]=s;C=f[r>>2]|0}mP(f[e+4>>2]|0,C);C=e+12|0;f[C>>2]=(f[C>>2]|0)+1;t=B;u=t;v=c&-2;w=t+16|0;x=f[w>>2]|0;f[a>>2]=x;y=a+4|0;f[y>>2]=b;z=a+8|0;f[z>>2]=v;A=a+12|0;f[A>>2]=u;return}function LJb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=u;u=u+16|0;d=a+12|0;e=a+8|0;g=a+4|0;h=a;f[b>>2]=0;i=f[c+8>>2]|0;j=b+4|0;f[j>>2]=0;f[b+8>>2]=i;i=b+12|0;f[i>>2]=0;k=b+4|0;f[b>>2]=k;l=f[c>>2]|0;m=c+4|0;if((l|0)==(m|0)){u=a;return}c=k;k=b+8|0;n=l;while(1){l=n+16|0;f[h>>2]=c;f[d>>2]=f[h>>2];o=OJb(b,d,e,g,l)|0;if(!(f[o>>2]|0)){p=f[k>>2]|0;if(!p)q=L5b(20)|0;else q=znb(p,25536,20)|0;f[q+16>>2]=f[l>>2];l=f[e>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=l;f[o>>2]=q;l=f[f[b>>2]>>2]|0;if(!l)r=q;else{f[b>>2]=l;r=f[o>>2]|0}mP(f[j>>2]|0,r);f[i>>2]=(f[i>>2]|0)+1}o=f[n+4>>2]|0;if(!o){l=n+8|0;p=f[l>>2]|0;if((f[p>>2]|0)==(n|0))s=p;else{p=l;do{l=f[p>>2]|0;p=l+8|0;t=f[p>>2]|0}while((f[t>>2]|0)!=(l|0));s=t}}else{p=o;while(1){t=f[p>>2]|0;if(!t)break;else p=t}s=p}if((s|0)==(m|0))break;else n=s}u=a;return}function MJb(a,b){a=a|0;b=b|0;if(!b)return;MJb(a,f[b>>2]|0);MJb(a,f[b+4>>2]|0);if(f[a+8>>2]|0)return;O5b(b);return}function NJb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=f[(f[a+16>>2]|0)+(b<<2)>>2]|0;if(!d){e=0;return e|0}b=c+4|0;a=c+8|0;g=c+4|0;h=c+12|0;i=d;d=0;while(1){j=i;k=f[b>>2]|0;do if(k){l=g;m=k;while(1){n=m+16|0;if(qJb(i,f[n>>2]|0)|0){o=f[m>>2]|0;if(!o){p=7;break}else{q=m;r=o}}else{if(!(qJb(f[n>>2]|0,i)|0)){p=11;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=10;break}else{q=s;r=n}}l=q;m=r}if((p|0)==7){p=0;t=m;u=m;break}else if((p|0)==10){p=0;t=s;u=m;break}else if((p|0)==11){p=0;t=l;u=m;break}}else{t=b;u=b}while(0);if(!(f[t>>2]|0)){k=f[a>>2]|0;if(!k)v=L5b(20)|0;else v=znb(k,25536,20)|0;f[v+16>>2]=j;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=u;f[t>>2]=v;k=f[f[c>>2]>>2]|0;if(!k)w=v;else{f[c>>2]=k;w=f[t>>2]|0}mP(f[g>>2]|0,w);f[h>>2]=(f[h>>2]|0)+1}k=d+1|0;n=i+24|0;i=f[n>>2]|0;f[n>>2]=0;if(!i){e=k;break}else d=k}return e|0}function OJb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=a+4|0;h=f[b>>2]|0;b=h;if((h|0)!=(g|0)?(i=h+16|0,!(qJb(f[e>>2]|0,f[i>>2]|0)|0)):0){if(!(qJb(f[i>>2]|0,f[e>>2]|0)|0)){f[c>>2]=b;f[d>>2]=b;j=d;return j|0}d=f[h+4>>2]|0;if(!d){i=h+8|0;k=f[i>>2]|0;if((f[k>>2]|0)==(h|0))l=k;else{k=i;do{i=f[k>>2]|0;k=i+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(i|0));l=m}}else{k=d;while(1){d=f[k>>2]|0;if(!d)break;else k=d}l=k}if((l|0)!=(g|0)?!(qJb(f[e>>2]|0,f[l+16>>2]|0)|0):0){k=f[g>>2]|0;if(!k){f[c>>2]=g;j=g;return j|0}d=a+4|0;m=k;while(1){k=m+16|0;if(qJb(f[e>>2]|0,f[k>>2]|0)|0){i=f[m>>2]|0;if(!i){n=39;break}else{o=m;p=i}}else{if(!(qJb(f[k>>2]|0,f[e>>2]|0)|0)){n=43;break}q=m+4|0;k=f[q>>2]|0;if(!k){n=42;break}else{o=q;p=k}}d=o;m=p}if((n|0)==39){f[c>>2]=m;j=m;return j|0}else if((n|0)==42){f[c>>2]=m;j=q;return j|0}else if((n|0)==43){f[c>>2]=m;j=d;return j|0}}if(!(f[h+4>>2]|0)){f[c>>2]=b;j=h+4|0;return j|0}else{f[c>>2]=l;j=l;return j|0}}if((h|0)!=(f[a>>2]|0)){l=f[h>>2]|0;if(!l){d=h;while(1){m=f[d+8>>2]|0;if((f[m>>2]|0)==(d|0))d=m;else{r=m;break}}}else{d=l;while(1){l=f[d+4>>2]|0;if(!l){r=d;break}else d=l}}if(!(qJb(f[r+16>>2]|0,f[e>>2]|0)|0)){d=f[g>>2]|0;if(!d){f[c>>2]=g;j=g;return j|0}g=a+4|0;a=d;while(1){d=a+16|0;if(qJb(f[e>>2]|0,f[d>>2]|0)|0){l=f[a>>2]|0;if(!l){n=17;break}else{s=a;t=l}}else{if(!(qJb(f[d>>2]|0,f[e>>2]|0)|0)){n=21;break}u=a+4|0;d=f[u>>2]|0;if(!d){n=20;break}else{s=u;t=d}}g=s;a=t}if((n|0)==17){f[c>>2]=a;j=a;return j|0}else if((n|0)==20){f[c>>2]=a;j=u;return j|0}else if((n|0)==21){f[c>>2]=a;j=g;return j|0}}else v=r}else v=b;if(!(f[h>>2]|0)){f[c>>2]=h;j=h;return j|0}else{h=v;f[c>>2]=h;j=h+4|0;return j|0}return 0}function PJb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+16|0;e=d;g=f[b+(c<<2)>>2]|0;c=a+8|0;b=a+4|0;h=g+4|0;i=f[g>>2]|0;while(1){j=f[i+16>>2]|0;k=oJb(a,j)|0;IJb(e,a,(f[b>>2]|0)+-1&(f[c>>2]|0)+k,j);j=f[i+4>>2]|0;if(!j){k=i+8|0;l=f[k>>2]|0;if((f[l>>2]|0)==(i|0))m=l;else{l=k;do{k=f[l>>2]|0;l=k+8|0;n=f[l>>2]|0}while((f[n>>2]|0)!=(k|0));m=n}}else{l=j;while(1){n=f[l>>2]|0;if(!n)break;else l=n}m=l}if((m|0)==(h|0))break;else i=m}m=f[a+20>>2]|0;MJb(g,f[h>>2]|0);if(m|0){u=d;return}O5b(g);u=d;return}function QJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=oJb(a+20|0,b)|0;d=f[a+4>>2]|0;if(!d){e=0;return e|0}g=d+-1|0;h=(g&d|0)==0;if(!h)if(c>>>0<d>>>0)i=c;else i=(c>>>0)%(d>>>0)|0;else i=g&c;j=f[(f[a>>2]|0)+(i<<2)>>2]|0;if(!j){e=0;return e|0}a=f[j>>2]|0;if(!a){e=0;return e|0}if(h){h=a;while(1){j=f[h+4>>2]|0;k=(j|0)==(c|0);if(!(k|(j&g|0)==(i|0))){e=0;l=20;break}if(k?pJb(h+8|0,b)|0:0){e=h;l=20;break}h=f[h>>2]|0;if(!h){e=0;l=20;break}}if((l|0)==20)return e|0}else m=a;while(1){a=f[m+4>>2]|0;h=(a|0)==(c|0);if(!h){if(a>>>0<d>>>0)n=a;else n=(a>>>0)%(d>>>0)|0;if((n|0)!=(i|0)){e=0;l=20;break}if(h)l=19}else l=19;if((l|0)==19?(l=0,pJb(m+8|0,b)|0):0){e=m;l=20;break}m=f[m>>2]|0;if(!m){e=0;l=20;break}}if((l|0)==20)return e|0;return 0}function RJb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0,D=0;e=d+8|0;g=oJb(c+20|0,e)|0;h=d+4|0;f[h>>2]=g;i=c+4|0;j=f[i>>2]|0;k=(j|0)==0;a:do if(!k){l=j+-1|0;m=(l&j|0)==0;if(!m)if(g>>>0<j>>>0)o=g;else o=(g>>>0)%(j>>>0)|0;else o=l&g;p=f[(f[c>>2]|0)+(o<<2)>>2]|0;if(!p)q=o;else{if(m){m=p;while(1){r=f[m>>2]|0;if(!r){q=o;break a}if((f[r+4>>2]&l|0)!=(o|0)){q=o;break a}if(pJb(r+8|0,e)|0){s=0;t=r;break}else m=r}u=t;f[a>>2]=u;v=a+4|0;b[v>>0]=s;return}else w=p;while(1){m=f[w>>2]|0;if(!m){q=o;break a}l=f[m+4>>2]|0;if(l>>>0<j>>>0)x=l;else x=(l>>>0)%(j>>>0)|0;if((x|0)!=(o|0)){q=o;break a}if(pJb(m+8|0,e)|0){s=0;t=m;break}else w=m}u=t;f[a>>2]=u;v=a+4|0;b[v>>0]=s;return}}else q=0;while(0);w=c+20|0;y=+(((f[w>>2]|0)+1|0)>>>0);z=+n[c+24>>2];do if(k|y>+(j>>>0)*z){e=(j>>>0<3|(j+-1&j|0)!=0)&1|j<<1;o=~~+X(+(y/z))>>>0;SJb(c,e>>>0<o>>>0?o:e);e=f[i>>2]|0;o=f[h>>2]|0;x=e+-1|0;if(!(x&e)){A=e;B=x&o;break}if(o>>>0<e>>>0){A=e;B=o}else{A=e;B=(o>>>0)%(e>>>0)|0}}else{A=j;B=q}while(0);q=f[(f[c>>2]|0)+(B<<2)>>2]|0;if(!q){j=c+12|0;f[d>>2]=f[j>>2];f[j>>2]=d;f[(f[c>>2]|0)+(B<<2)>>2]=j;j=f[d>>2]|0;if(!j)C=d;else{B=f[j+4>>2]|0;j=A+-1|0;if(j&A)if(B>>>0<A>>>0)D=B;else D=(B>>>0)%(A>>>0)|0;else D=B&j;f[(f[c>>2]|0)+(D<<2)>>2]=d;C=d}}else{f[d>>2]=f[q>>2];f[q>>2]=d;C=d}f[w>>2]=(f[w>>2]|0)+1;s=1;t=C;u=t;f[a>>2]=u;v=a+4|0;b[v>>0]=s;return}function SJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=yWb(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){TJb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+20>>2]|0)>>>0)/+n[a+24>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=yWb(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;TJb(a,d);return}function TJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=(b|0)!=0;if(c){d=f[a+8>>2]|0;e=b<<2;if(!d)g=L5b(e)|0;else g=znb(d,25536,e)|0;h=g}else h=0;g=f[a>>2]|0;f[a>>2]=h;if(g|0?(f[a+8>>2]|0)==0:0)O5b(g);f[a+4>>2]=b;if(c)i=0;else return;do{f[(f[a>>2]|0)+(i<<2)>>2]=0;i=i+1|0}while((i|0)!=(b|0));i=a+12|0;c=f[i>>2]|0;if(!c)return;g=f[c+4>>2]|0;h=b+-1|0;e=(h&b|0)==0;if(!e)if(g>>>0<b>>>0)j=g;else j=(g>>>0)%(b>>>0)|0;else j=g&h;f[(f[a>>2]|0)+(j<<2)>>2]=i;i=f[c>>2]|0;if(!i)return;else{k=j;l=c;m=i;n=c}a:while(1){c=l;i=m;j=n;b:while(1){c:do if(e){g=i;while(1){d=f[g+4>>2]&h;if((d|0)==(k|0)){o=g;break c}p=(f[a>>2]|0)+(d<<2)|0;if(!(f[p>>2]|0)){q=g;r=p;s=d;break b}p=f[g>>2]|0;d:do if(!p)t=g;else{u=g+8|0;v=g;w=p;x=g;while(1){if(!(pJb(u,w+8|0)|0)){t=v;break d}x=f[x>>2]|0;w=f[x>>2]|0;if(!w){t=x;break}else v=x}}while(0);f[j>>2]=f[t>>2];f[t>>2]=f[f[(f[a>>2]|0)+(d<<2)>>2]>>2];f[f[(f[a>>2]|0)+(d<<2)>>2]>>2]=g;g=f[c>>2]|0;if(!g){y=37;break a}}}else{g=i;while(1){p=f[g+4>>2]|0;if(p>>>0<b>>>0)z=p;else z=(p>>>0)%(b>>>0)|0;if((z|0)==(k|0)){o=g;break c}p=(f[a>>2]|0)+(z<<2)|0;if(!(f[p>>2]|0)){q=g;r=p;s=z;break b}p=f[g>>2]|0;e:do if(!p)A=g;else{x=g+8|0;v=g;w=p;u=g;while(1){if(!(pJb(x,w+8|0)|0)){A=v;break e}u=f[u>>2]|0;w=f[u>>2]|0;if(!w){A=u;break}else v=u}}while(0);f[j>>2]=f[A>>2];f[A>>2]=f[f[(f[a>>2]|0)+(z<<2)>>2]>>2];f[f[(f[a>>2]|0)+(z<<2)>>2]>>2]=g;g=f[c>>2]|0;if(!g){y=37;break a}}}while(0);i=f[o>>2]|0;if(!i){y=37;break a}else{c=o;j=o}}f[r>>2]=j;m=f[q>>2]|0;if(!m){y=37;break}else{k=s;l=q;n=q}}if((y|0)==37)return}function UJb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+40|0;h=e+32|0;i=e;j=e+16|0;if(!(f[c>>2]|0)){if((f[d>>2]|0)==1)k=(f[d+20>>2]|0)+24|0;else k=(f[d+4>>2]|0)+16|0;l=f[k>>2]|0;if(l|0){if((f[l+8>>2]|0)==9?(k=f[l>>2]|0,k|0):0){if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);O5b(k)}O5b(l)}}if((f[d>>2]|0)==1){l=d+20|0;k=f[l>>2]|0;f[l>>2]=f[k>>2];m=0;n=k}else{k=f[d+4>>2]|0;l=d+8|0;f[i>>2]=f[l>>2];f[i+4>>2]=f[l+4>>2];f[i+8>>2]=f[l+8>>2];yJb(d+4|0)|0;m=k;n=0}k=c+12|0;if(!(b[c+8>>0]|0)){c=f[k>>2]|0;f[j>>2]=m;m=j+4|0;f[m>>2]=f[i>>2];f[m+4>>2]=f[i+4>>2];f[m+8>>2]=f[i+8>>2];f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2];f[g+8>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];WJb(c,g);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];f[a+8>>2]=f[d+8>>2];f[a+12>>2]=f[d+12>>2];f[a+16>>2]=f[d+16>>2];f[a+20>>2]=f[d+20>>2];u=e;return}else{c=f[k>>2]|0;f[h>>2]=n;f[g>>2]=f[h>>2];VJb(c,g)|0;f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];f[a+8>>2]=f[d+8>>2];f[a+12>>2]=f[d+12>>2];f[a+16>>2]=f[d+16>>2];f[a+20>>2]=f[d+20>>2];u=e;return}}function VJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=f[c>>2]|0;c=f[d>>2]|0;e=f[a+4>>2]|0;g=f[d+4>>2]|0;h=e+-1|0;i=(h&e|0)==0;if(!i)if(g>>>0<e>>>0)j=g;else j=(g>>>0)%(e>>>0)|0;else j=h&g;g=(f[a>>2]|0)+(j<<2)|0;k=f[g>>2]|0;while(1){l=f[k>>2]|0;if((l|0)==(d|0))break;else k=l}if((k|0)!=(a+12|0)){l=f[k+4>>2]|0;if(!i)if(l>>>0<e>>>0)m=l;else m=(l>>>0)%(e>>>0)|0;else m=l&h;if((m|0)==(j|0)){n=c;o=21}else o=13}else o=13;do if((o|0)==13){if(c|0){m=f[c+4>>2]|0;if(!i)if(m>>>0<e>>>0)p=m;else p=(m>>>0)%(e>>>0)|0;else p=m&h;if((p|0)==(j|0)){q=c;r=c;o=22;break}}f[g>>2]=0;n=f[d>>2]|0;o=21}while(0);if((o|0)==21){g=n;if(!n)s=g;else{q=n;r=g;o=22}}if((o|0)==22){o=f[q+4>>2]|0;if(!i)if(o>>>0<e>>>0)t=o;else t=(o>>>0)%(e>>>0)|0;else t=o&h;if((t|0)==(j|0))s=r;else{f[(f[a>>2]|0)+(t<<2)>>2]=k;s=f[d>>2]|0}}f[k>>2]=s;f[d>>2]=0;s=a+20|0;f[s>>2]=(f[s>>2]|0)+-1;if(!d)return c|0;if((f[d+16>>2]|0)==9?(s=f[d+8>>2]|0,s|0):0){if((b[s+11>>0]|0)<0)O5b(f[s>>2]|0);O5b(s)}if(f[a+16>>2]|0)return c|0;O5b(d);return c|0}function WJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+32|0;e=d;g=f[c+4>>2]|0;h=c+8|0;i=f[h>>2]&(f[g+4>>2]|0)+-1;f[h>>2]=i;j=g+16|0;k=f[j>>2]|0;l=f[k+(i<<2)>>2]|0;m=f[c>>2]|0;a:do if((l|0)!=(m|0)){b:do if(l|0?(l|0)!=(f[k+((i^1)<<2)>>2]|0):0){n=l;while(1){n=f[n+24>>2]|0;if(!n)break b;if((n|0)==(m|0)){o=i;p=7;break a}}}while(0);nJb(e,g,m);n=f[e+8>>2]|0;q=f[e+12>>2]|0;f[h>>2]=n;f[c+12>>2]=q;r=f[j>>2]|0;s=f[r+(n<<2)>>2]|0;t=q;if(s){v=a+16|0;w=(f[v>>2]|0)+(n<<2)|0;if((s|0)==(f[r+((n^1)<<2)>>2]|0)){r=f[w>>2]|0;s=f[t+4>>2]|0;if(!s){x=t+8|0;y=f[x>>2]|0;if((f[y>>2]|0)==(q|0))z=y;else{y=x;do{x=f[y>>2]|0;y=x+8|0;A=f[y>>2]|0}while((f[A>>2]|0)!=(x|0));z=A}}else{y=s;while(1){A=f[y>>2]|0;if(!A)break;else y=A}z=y}if((f[r>>2]|0)==(t|0))f[r>>2]=z;s=r+12|0;f[s>>2]=(f[s>>2]|0)+-1;wwa(f[r+4>>2]|0,q);if(!(f[r+8>>2]|0))O5b(q);if(!(f[s>>2]|0)){s=n&-2;A=f[a+20>>2]|0;MJb(r,f[r+4>>2]|0);if(!A)O5b(r);f[(f[v>>2]|0)+((n|1)<<2)>>2]=0;f[(f[v>>2]|0)+(s<<2)>>2]=0;B=s;C=v}else{B=n;C=v}}else{D=w;E=v;F=n;p=9}}else{o=n;p=7}}else{o=i;p=7}while(0);if((p|0)==7){i=a+16|0;D=(f[i>>2]|0)+(o<<2)|0;E=i;F=o;p=9}if((p|0)==9){o=XJb(a,m,f[D>>2]|0)|0;f[(f[E>>2]|0)+(F<<2)>>2]=o;B=F;C=E}if((f[m+8>>2]|0)==9?(E=f[m>>2]|0,E|0):0){if((b[E+11>>0]|0)<0)O5b(f[E>>2]|0);O5b(E)}if(!(f[a+20>>2]|0))O5b(m);f[a>>2]=(f[a>>2]|0)+-1;m=a+12|0;if((B|0)!=(f[m>>2]|0)){u=d;return}E=f[a+4>>2]|0;if(B>>>0>=E>>>0){u=d;return}a=f[C>>2]|0;C=B;while(1){if(f[a+(C<<2)>>2]|0){p=35;break}C=C+1|0;f[m>>2]=C;if(C>>>0>=E>>>0){p=35;break}}if((p|0)==35){u=d;return}}function XJb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=c+24|0;e=f[d>>2]|0;if((c|0)==(b|0))return e|0;else{g=XJb(a,b,e)|0;f[d>>2]=g;return c|0}return 0}function YJb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!((c|0)==0&(d|0)!=0))if((d|0)!=(c|0)){e=tLb(b,d)|0;xHb(b,e);if((b|0)==0|(c|0)!=0)g=e;else{bi[f[(f[b>>2]|0)+4>>2]&2047](b);g=e}}else g=b;else{eFb(d,b);g=b}b=a+12|0;d=f[b>>2]|0;e=f[a+8>>2]|0;c=a+4|0;do if((d|0)!=0?(h=f[c>>2]|0,(h|0)!=(e|0)):0){i=f[d>>2]|0;if((i|0)==(e|0)){j=f[d+4+(h<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0){k=d;break}bi[f[(f[j>>2]|0)+4>>2]&2047](j);k=f[b>>2]|0;break}if((h|0)<(i|0)){f[d+4+(i<<2)>>2]=f[d+4+(h<<2)>>2];h=f[b>>2]|0;l=h;m=f[h>>2]|0}else{l=d;m=i}f[l>>2]=m+1;k=l}else n=8;while(0);if((n|0)==8){cpb(a,e+1|0);e=f[b>>2]|0;f[e>>2]=(f[e>>2]|0)+1;k=e}e=f[c>>2]|0;f[c>>2]=e+1;f[k+4+(e<<2)>>2]=g;return}function ZJb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((hKb(a)|0)==9){d=f[a>>2]|0;u=b;return d|0}zpb(c,3,471595,383);e=vpb(vpb(vpb(vpb(c,471718)|0,472310)|0,471773)|0,471795)|0;g=vpb(vpb(vpb(e,f[34047]|0)|0,475789)|0,471809)|0;e=136152+((hKb(a)|0)<<2)|0;xpb(b+24|0,vpb(g,f[e>>2]|0)|0);Apb(c);d=f[a>>2]|0;u=b;return d|0}function _Jb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+32|0;c=b;if((hKb(a)|0)==2){d=f[a>>2]|0;e=d;g=e;h=f[g>>2]|0;i=e+4|0;j=i;k=f[j>>2]|0;J=k;u=b;return h|0}zpb(c,3,471595,353);l=vpb(vpb(vpb(vpb(c,471718)|0,472283)|0,471773)|0,471795)|0;m=vpb(vpb(vpb(l,f[34040]|0)|0,475789)|0,471809)|0;l=136152+((hKb(a)|0)<<2)|0;xpb(b+24|0,vpb(m,f[l>>2]|0)|0);Apb(c);d=f[a>>2]|0;e=d;g=e;h=f[g>>2]|0;i=e+4|0;j=i;k=f[j>>2]|0;J=k;u=b;return h|0}function $Jb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;if((hKb(a)|0)==1){d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}zpb(c,3,471595,363);g=vpb(vpb(vpb(vpb(c,471718)|0,472256)|0,471773)|0,471795)|0;h=vpb(vpb(vpb(g,f[34039]|0)|0,475789)|0,471809)|0;g=136152+((hKb(a)|0)<<2)|0;xpb(b+24|0,vpb(h,f[g>>2]|0)|0);Apb(c);d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}function aKb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;b=u;u=u+32|0;c=b;if((hKb(a)|0)==4){d=f[a>>2]|0;e=d;g=e;h=f[g>>2]|0;i=e+4|0;j=i;k=f[j>>2]|0;J=k;u=b;return h|0}zpb(c,3,471595,358);l=vpb(vpb(vpb(vpb(c,471718)|0,472228)|0,471773)|0,471795)|0;m=vpb(vpb(vpb(l,f[34042]|0)|0,475789)|0,471809)|0;l=136152+((hKb(a)|0)<<2)|0;xpb(b+24|0,vpb(m,f[l>>2]|0)|0);Apb(c);d=f[a>>2]|0;e=d;g=e;h=f[g>>2]|0;i=e+4|0;j=i;k=f[j>>2]|0;J=k;u=b;return h|0}function bKb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;if((hKb(a)|0)==3){d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}zpb(c,3,471595,368);g=vpb(vpb(vpb(vpb(c,471718)|0,472200)|0,471773)|0,471795)|0;h=vpb(vpb(vpb(g,f[34041]|0)|0,475789)|0,471809)|0;g=136152+((hKb(a)|0)<<2)|0;xpb(b+24|0,vpb(h,f[g>>2]|0)|0);Apb(c);d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}function cKb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+32|0;d=c;if((hKb(a)|0)==7){e=f[a>>2]|0;g=b[e>>0]|0;h=g<<24>>24!=0;u=c;return h|0}zpb(d,3,471595,373);i=vpb(vpb(vpb(vpb(d,471718)|0,472174)|0,471773)|0,471795)|0;j=vpb(vpb(vpb(i,f[34045]|0)|0,475789)|0,471809)|0;i=136152+((hKb(a)|0)<<2)|0;xpb(c+24|0,vpb(j,f[i>>2]|0)|0);Apb(d);e=f[a>>2]|0;g=b[e>>0]|0;h=g<<24>>24!=0;u=c;return h|0}function dKb(a){a=a|0;var b=0,c=0,d=0,e=0.0,g=0,h=0;b=u;u=u+32|0;c=b;if((hKb(a)|0)==5){d=f[a>>2]|0;e=+p[d>>3];u=b;return +e}zpb(c,3,471595,393);g=vpb(vpb(vpb(vpb(c,471718)|0,472146)|0,471773)|0,471795)|0;h=vpb(vpb(vpb(g,f[34043]|0)|0,475789)|0,471809)|0;g=136152+((hKb(a)|0)<<2)|0;xpb(b+24|0,vpb(h,f[g>>2]|0)|0);Apb(c);d=f[a>>2]|0;e=+p[d>>3];u=b;return +e}function eKb(a){a=a|0;var b=0,c=0,d=0,e=0.0,g=0,h=0;b=u;u=u+32|0;c=b;if((hKb(a)|0)==6){d=f[a>>2]|0;e=+n[d>>2];u=b;return +e}zpb(c,3,471595,388);g=vpb(vpb(vpb(vpb(c,471718)|0,472119)|0,471773)|0,471795)|0;h=vpb(vpb(vpb(g,f[34044]|0)|0,475789)|0,471809)|0;g=136152+((hKb(a)|0)<<2)|0;xpb(b+24|0,vpb(h,f[g>>2]|0)|0);Apb(c);d=f[a>>2]|0;e=+n[d>>2];u=b;return +e}function fKb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;if((hKb(a)|0)==8){d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}zpb(c,3,471595,378);g=vpb(vpb(vpb(vpb(c,471718)|0,472093)|0,471773)|0,471795)|0;h=vpb(vpb(vpb(g,f[34046]|0)|0,475789)|0,471809)|0;g=136152+((hKb(a)|0)<<2)|0;xpb(b+24|0,vpb(h,f[g>>2]|0)|0);Apb(c);d=f[a>>2]|0;e=f[d>>2]|0;u=b;return e|0}function gKb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((hKb(a)|0)==10){d=f[a>>2]|0;u=b;return d|0}zpb(c,3,471595,399);e=vpb(vpb(vpb(vpb(c,471718)|0,472014)|0,471773)|0,471795)|0;g=vpb(vpb(vpb(e,f[34048]|0)|0,475789)|0,471809)|0;e=136152+((hKb(a)|0)<<2)|0;xpb(b+24|0,vpb(g,f[e>>2]|0)|0);Apb(c);d=f[a>>2]|0;u=b;return d|0}function hKb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;d=b+24|0;e=a+4|0;g=f[e>>2]|0;if(g|0?f[a>>2]|0:0){h=g;u=b;return h|0}zpb(c,3,471595,427);xpb(d,vpb(vpb(c,471718)|0,472043)|0);Apb(c);h=f[e>>2]|0;u=b;return h|0}function iKb(a){a=a|0;var c=0,d=0,e=0,g=0;wJb(a);if(f[a>>2]|0)return;c=a+12|0;if(!(b[a+8>>0]|0)){a=f[c>>2]|0;if(!a)return;d=a+16|0;if(f[d>>2]|0?(jKb(a),(f[a+20>>2]|0)==0):0)O5b(f[d>>2]|0);O5b(a);return}a=f[c>>2]|0;if(!a)return;c=f[a+12>>2]|0;if(c|0){d=a+16|0;e=c;do{c=e;e=f[e>>2]|0;if((f[c+16>>2]|0)==9?(g=f[c+8>>2]|0,g|0):0){if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);O5b(g)}if(!(f[d>>2]|0))O5b(c)}while((e|0)!=0)}e=f[a>>2]|0;f[a>>2]=0;if(e|0?(f[a+8>>2]|0)==0:0)O5b(e);O5b(a);return}function jKb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+4|0;if(!(f[c>>2]|0)){d=0;f[a>>2]=0;e=a+12|0;f[e>>2]=d;return}g=a+16|0;h=a+20|0;i=0;while(1){j=f[g>>2]|0;k=j+(i<<2)|0;l=f[k>>2]|0;a:do if(l){if((l|0)!=(f[j+((i^1)<<2)>>2]|0)){f[k>>2]=0;m=l;while(1){n=m;m=f[m+24>>2]|0;if((f[n+8>>2]|0)==9?(o=f[n>>2]|0,o|0):0){if((b[o+11>>0]|0)<0)O5b(f[o>>2]|0);O5b(o)}if(!(f[h>>2]|0))O5b(n);if(!m){p=i;break a}}}if((l|0)==(f[j+((i^1)<<2)>>2]|0)){m=i+1|0;f[j+(m<<2)>>2]=0;f[(f[g>>2]|0)+(i<<2)>>2]=0;n=l+12|0;o=l+4|0;q=l+8|0;r=l+4|0;s=f[l>>2]|0;do{t=s;u=f[t+16>>2]|0;v=s;w=f[v+4>>2]|0;if(!w){x=v+8|0;y=f[x>>2]|0;if((f[y>>2]|0)==(v|0))z=y;else{y=x;do{x=f[y>>2]|0;y=x+8|0;A=f[y>>2]|0}while((f[A>>2]|0)!=(x|0));z=A}}else{y=w;while(1){A=f[y>>2]|0;if(!A)break;else y=A}z=y}w=f[t+4>>2]|0;if(!w){A=t+8|0;x=f[A>>2]|0;if((f[x>>2]|0)==(v|0))B=x;else{x=A;do{A=f[x>>2]|0;x=A+8|0;C=f[x>>2]|0}while((f[C>>2]|0)!=(A|0));B=C}}else{x=w;while(1){y=f[x>>2]|0;if(!y)break;else x=y}B=x}if((f[l>>2]|0)==(t|0))f[l>>2]=B;f[n>>2]=(f[n>>2]|0)+-1;wwa(f[o>>2]|0,v);if(!(f[q>>2]|0))O5b(s);s=z;if((f[u+8>>2]|0)==9?(w=f[u>>2]|0,w|0):0){if((b[w+11>>0]|0)<0)O5b(f[w>>2]|0);O5b(w)}if(!(f[h>>2]|0))O5b(u)}while((z|0)!=(r|0));s=f[h>>2]|0;MJb(l,f[r>>2]|0);if(!s){O5b(l);p=m}else p=m}else p=i}else p=i;while(0);i=p+1|0;l=f[c>>2]|0;if(i>>>0>=l>>>0){d=l;break}}f[a>>2]=0;e=a+12|0;f[e>>2]=d;return}function kKb(){var a=0,b=0,c=0,d=0,e=0,g=0,h=0;a=f[213433]|0;b=f[a>>2]|0;if((f[a+4>>2]|0)==(b|0))c=a;else{d=0;e=a;a=b;while(1){b=f[a+(d<<2)>>2]|0;if(!b)g=e;else{bi[f[(f[b>>2]|0)+4>>2]&2047](b);g=f[213433]|0}d=d+1|0;a=f[g>>2]|0;if(d>>>0>=(f[g+4>>2]|0)-a>>2>>>0){c=g;break}else e=g}}g=f[213432]|0;if(!g)h=c;else{Cpb(g);O5b(g);h=f[213433]|0}if(!h)return;g=f[h>>2]|0;if(g|0){c=h+4|0;e=f[c>>2]|0;if((e|0)!=(g|0))f[c>>2]=e+(~((e+-4-g|0)>>>2)<<2);O5b(g)}O5b(h);return}function lKb(){var a=0;a=L5b(4)|0;Bpb(a);f[213432]=a;a=L5b(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[213433]=a;spb(59);return}function mKb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c+4|0;e=c;f[e>>2]=a;if((f[213431]|0)!=2){f[d>>2]=135812;f[d+4>>2]=60;b[d+8>>0]=0;Gpb(853724,d);hpb(d)}d=f[213432]|0;npb(d);a=f[213433]|0;g=a+4|0;h=f[g>>2]|0;if((h|0)==(f[a+8>>2]|0)){nKb(a,e);opb(d);u=c;return}else{f[h>>2]=f[e>>2];f[g>>2]=(f[g>>2]|0)+4;opb(d);u=c;return}}function nKb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function oKb(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+24|0;if(f[b>>2]|0){c=a+8|0;d=f[c>>2]|0;return d|0}e=a+20|0;npb(e);if(!(f[b>>2]|0)){bi[f[(f[a>>2]|0)+40>>2]&2047](a);f[b>>2]=2}opb(e);c=a+8|0;d=f[c>>2]|0;return d|0}function pKb(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+24|0;if(f[b>>2]|0){f[b>>2]=1;c=a+8|0;d=f[c>>2]|0;return d|0}e=a+20|0;npb(e);if(!(f[b>>2]|0)){bi[f[(f[a>>2]|0)+40>>2]&2047](a);f[b>>2]=2}opb(e);f[b>>2]=1;c=a+8|0;d=f[c>>2]|0;return d|0}function qKb(a){a=a|0;var b=0,c=0;b=a+20|0;npb(b);c=di[f[(f[a>>2]|0)+36>>2]&1023](a)|0;opb(b);return c|0}function rKb(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+64|0;c=b+24|0;d=b;if(!(f[a+12>>2]|0)){zpb(c,3,471923,96);xpb(b+49|0,vpb(c,472468)|0);Apb(c)}c=a+16|0;a=f[c>>2]|0;if(a|0){e=a;$h[e&127]();u=b;return}zpb(d,3,471923,97);xpb(b+48|0,vpb(d,472510)|0);Apb(d);e=f[c>>2]|0;$h[e&127]();u=b;return}function sKb(a){a=a|0;f[a+24>>2]=0;return}function tKb(a){a=a|0;var b=0,c=0;b=a+24|0;if((f[b>>2]|0)!=1)return;c=a+20|0;npb(c);if((f[b>>2]|0)==1){bi[f[(f[a>>2]|0)+44>>2]&2047](a);f[b>>2]=2}opb(c);return}function uKb(a,c){a=a|0;c=c|0;var d=0;f[a>>2]=140148;d=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;Bpb(a+20|0);f[a+24>>2]=0;f[a>>2]=140220;d=a+28|0;f[d>>2]=0;f[a+32>>2]=0;b[a+36>>0]=1;vKb(d);f[a+44>>2]=c;return}function vKb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c+5|0;e=c+4|0;g=c;h=f[a>>2]|0;i=h;if(!(b[a+8>>0]|0)){if(!h){j=L5b(24)|0;f[j>>2]=0;f[j+8>>2]=j;k=j+16|0;f[k>>2]=0;f[j+20>>2]=i;l=L5b(32)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;f[k>>2]=l;f[j+12>>2]=8;f[j+4>>2]=8;m=j}else{j=znb(h,23248,24)|0;f[j>>2]=0;f[j+8>>2]=j;l=j+16|0;f[l>>2]=0;f[j+20>>2]=i;k=znb(h,25536,32)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;f[l>>2]=k;f[j+12>>2]=8;f[j+4>>2]=8;xnb(h,j,1530);m=j}f[a+12>>2]=m;u=c;return}else{f[g>>2]=i;if(!h){i=L5b(28)|0;wKb(i,0,d,e,g);n=i}else{i=znb(h,23232,28)|0;wKb(i,0,d,e,g);xnb(h,i,1529);n=i}f[a+12>>2]=n;u=c;return}}function wKb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;d=f[e>>2]|0;f[a>>2]=0;e=a+4|0;f[e>>2]=0;f[e+4>>2]=d;f[a+12>>2]=0;f[a+16>>2]=d;f[a+20>>2]=0;n[a+24>>2]=1.0;SJb(a,b);return}function xKb(a){a=a|0;var c=0,d=0,e=0,g=0;c=f[a+12>>2]|0;if(c|0){d=a+16|0;e=c;do{c=e;e=f[e>>2]|0;if((f[c+16>>2]|0)==9?(g=f[c+8>>2]|0,g|0):0){if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);O5b(g)}if(!(f[d>>2]|0))O5b(c)}while((e|0)!=0)}e=f[a>>2]|0;f[a>>2]=0;if(!e)return;if(f[a+8>>2]|0)return;O5b(e);return}function yKb(a){a=a|0;var b=0;b=a+16|0;if(!(f[b>>2]|0))return;jKb(a);if(f[a+20>>2]|0)return;O5b(f[b>>2]|0);return}function zKb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+16|0;d=c;zh[f[(f[b>>2]|0)+96>>2]&2047](d,b);X5b(a,f[(f[d>>2]|0)+4>>2]|0);u=c;return}function AKb(a){a=a|0;bOb(a);return}function BKb(a){a=a|0;return dOb(a)|0}function CKb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=u;u=u+64|0;e=d+16|0;g=d;f[g>>2]=0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;fOb(c,e,g);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=f[g>>2]|0;i=f[h>>2]|0;if((c|0)==(i|0))j=c;else{k=e+4|0;l=c;do{if((l|0)!=(c|0))k6b(a,489325)|0;m=b[l+11>>0]|0;n=m<<24>>24<0;f[e>>2]=n?f[l>>2]|0:l;f[k>>2]=n?f[l+4>>2]|0:m&255;ISb(a,e);l=l+12|0}while((l|0)!=(i|0));j=f[g>>2]|0}if(!j){u=d;return}i=f[h>>2]|0;if((i|0)==(j|0))o=j;else{l=i;while(1){i=l+-12|0;f[h>>2]=i;if((b[i+11>>0]|0)<0){O5b(f[i>>2]|0);p=f[h>>2]|0}else p=i;if((p|0)==(j|0))break;else l=p}o=f[g>>2]|0}O5b(o);u=d;return}function DKb(a,b){a=a|0;b=b|0;zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function EKb(a,b){a=a|0;b=b|0;return eQb(b,a)|0}function FKb(a){a=a|0;var b=0;b=mQb(a)|0;zh[f[(f[a>>2]|0)+88>>2]&2047](a,b);return b|0}function GKb(a,b){a=a|0;b=b|0;iQb(a,di[f[(f[a>>2]|0)+64>>2]&1023](a)|0,b);return}function HKb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+48|0;d=c+24|0;e=c;zh[f[(f[a>>2]|0)+96>>2]&2047](d,a);g=f[d>>2]|0;zh[f[(f[b>>2]|0)+96>>2]&2047](d,b);if((f[d>>2]|0)==(g|0)){aOb(b,a);u=c;return}zpb(e,3,473004,80);h=vpb(vpb(e,473196)|0,473321)|0;i=vpb(wpb(h,f[g+4>>2]|0)|0,473312)|0;zh[f[(f[b>>2]|0)+96>>2]&2047](d,b);xpb(c+32|0,wpb(i,f[(f[d>>2]|0)+4>>2]|0)|0);Apb(e);aOb(b,a);u=c;return}function IKb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+48|0;d=c+24|0;e=c;zh[f[(f[a>>2]|0)+96>>2]&2047](d,a);g=f[d>>2]|0;zh[f[(f[b>>2]|0)+96>>2]&2047](d,b);if((f[d>>2]|0)==(g|0)){cOb(b,a);u=c;return}zpb(e,3,473004,67);h=vpb(vpb(e,473196)|0,473251)|0;i=vpb(wpb(h,f[g+4>>2]|0)|0,473312)|0;zh[f[(f[b>>2]|0)+96>>2]&2047](d,b);xpb(c+32|0,wpb(i,f[(f[d>>2]|0)+4>>2]|0)|0);Apb(e);cOb(b,a);u=c;return}function JKb(a){a=a|0;eOb(a);return}function KKb(a){a=a|0;var b=0;b=di[f[(f[a>>2]|0)+92>>2]&1023](a)|0;return Uh[f[(f[b>>2]|0)+16>>2]&1023](b,a)|0}function LKb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;b=u;u=u+48|0;c=b+24|0;d=b;zpb(d,3,473004,156);e=vpb(d,473093)|0;zh[f[(f[a>>2]|0)+96>>2]&2047](c,a);xpb(b+32|0,vpb(wpb(e,f[(f[c>>2]|0)+4>>2]|0)|0,473109)|0);Apb(d);u=b;return}function MKb(a){a=a|0;return}function NKb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;a=u;u=u+64|0;d=a+48|0;e=a+24|0;g=a;h=a+60|0;if((f[c+36>>2]|0)!=3){zpb(e,3,473004,428);xpb(a+61|0,vpb(e,473407)|0);Apb(e)}do switch(f[136e3+(f[c+32>>2]<<2)>>2]|0){case 1:{if((f[213434]|0)!=2){f[d>>2]=135812;f[d+4>>2]=61;b[d+8>>0]=0;Gpb(853736,d);hpb(d)}i=f[213435]|0;u=a;return i|0}case 3:{if((f[213436]|0)!=2){f[d>>2]=135812;f[d+4>>2]=62;b[d+8>>0]=0;Gpb(853744,d);hpb(d)}i=f[213437]|0;u=a;return i|0}case 2:{if((f[213438]|0)!=2){f[d>>2]=135812;f[d+4>>2]=63;b[d+8>>0]=0;Gpb(853752,d);hpb(d)}i=f[213439]|0;u=a;return i|0}case 4:{if((f[213440]|0)!=2){f[d>>2]=135812;f[d+4>>2]=64;b[d+8>>0]=0;Gpb(853760,d);hpb(d)}i=f[213441]|0;u=a;return i|0}case 6:{if((f[213442]|0)!=2){f[d>>2]=135812;f[d+4>>2]=65;b[d+8>>0]=0;Gpb(853768,d);hpb(d)}i=f[213443]|0;u=a;return i|0}case 5:{if((f[213444]|0)!=2){f[d>>2]=135812;f[d+4>>2]=66;b[d+8>>0]=0;Gpb(853776,d);hpb(d)}i=f[213445]|0;u=a;return i|0}case 7:{if((f[213446]|0)!=2){f[d>>2]=135812;f[d+4>>2]=67;b[d+8>>0]=0;Gpb(853784,d);hpb(d)}i=f[213447]|0;u=a;return i|0}case 8:{if((f[213434]|0)!=2){f[d>>2]=135812;f[d+4>>2]=61;b[d+8>>0]=0;Gpb(853736,d);hpb(d)}i=f[213435]|0;u=a;return i|0}case 9:{if((f[213448]|0)!=2){f[d>>2]=135812;f[d+4>>2]=68;b[d+8>>0]=0;Gpb(853792,d);hpb(d)}i=f[213449]|0;u=a;return i|0}case 10:{if(xub(c)|0){if((f[213450]|0)!=2){f[d>>2]=135812;f[d+4>>2]=69;b[d+8>>0]=0;Gpb(853800,d);hpb(d)}i=f[213451]|0;u=a;return i|0}else{if((f[213452]|0)!=2){f[d>>2]=135812;f[d+4>>2]=70;b[d+8>>0]=0;Gpb(853808,d);hpb(d)}i=f[213453]|0;u=a;return i|0}break}default:{zpb(g,3,473004,456);xpb(h,vpb(g,473444)|0);Apb(g);i=0;u=a;return i|0}}while(0);return 0}function OKb(){var a=0;a=L5b(4)|0;f[a>>2]=141108;f[213435]=a;return}function PKb(){var a=0;a=L5b(4)|0;f[a>>2]=141020;f[213437]=a;return}function QKb(){var a=0;a=L5b(4)|0;f[a>>2]=140932;f[213439]=a;return}function RKb(){var a=0;a=L5b(4)|0;f[a>>2]=140844;f[213441]=a;return}function SKb(){var a=0;a=L5b(4)|0;f[a>>2]=140756;f[213443]=a;return}function TKb(){var a=0;a=L5b(4)|0;f[a>>2]=140668;f[213445]=a;return}function UKb(){var a=0;a=L5b(4)|0;f[a>>2]=140580;f[213447]=a;return}function VKb(){var a=0;a=L5b(4)|0;f[a>>2]=140488;f[213449]=a;return}function WKb(){var a=0;a=L5b(4)|0;f[a>>2]=140396;f[213451]=a;return}function XKb(){var a=0;a=L5b(4)|0;f[a>>2]=140304;f[213453]=a;return}function YKb(a){a=a|0;return}function ZKb(a){a=a|0;O5b(a);return}function _Kb(a,b){a=a|0;b=b|0;return (f[b+4>>2]|0)==0|0}function $Kb(a,b){a=a|0;b=b|0;return f[b+4>>2]|0}function aLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[f[(f[a>>2]|0)+80>>2]&511](a,f[(f[b+12>>2]|0)+4+(c<<2)>>2]|0,d)|0}function bLb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=b+4|0;c=f[a>>2]|0;if((c|0)<=0)return;d=f[b+12>>2]|0;b=0;do{e=f[d+4+(b<<2)>>2]|0;b=b+1|0;bi[f[(f[e>>2]|0)+28>>2]&2047](e)}while((b|0)!=(c|0));f[a>>2]=0;return}function cLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[f[(f[a>>2]|0)+76>>2]&255](a,d,f[(f[b+12>>2]|0)+4+(c<<2)>>2]|0);return}function dLb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=Uh[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;_h[f[(f[a>>2]|0)+76>>2]&255](a,c,d);c=di[f[(f[d>>2]|0)+24>>2]&1023](d)|0;a=f[b>>2]|0;if(((a|0)==(c|0)?(c=b+12|0,e=f[c>>2]|0,e|0):0)?(g=f[e>>2]|0,(g|0)<(f[b+8>>2]|0)):0){h=b+4|0;i=f[h>>2]|0;if((i|0)<(g|0)){j=e+4+(i<<2)|0;f[e+4+(g<<2)>>2]=f[j>>2];k=j}else k=e+4+(i<<2)|0;f[k>>2]=d;f[h>>2]=i+1;i=f[c>>2]|0;f[i>>2]=(f[i>>2]|0)+1;return}YJb(b,d,di[f[(f[d>>2]|0)+20>>2]&1023](d)|0,a);return}function eLb(a,b){a=a|0;b=b|0;var c=0;a=f[b+12>>2]|0;c=b+4|0;b=(f[c>>2]|0)+-1|0;f[c>>2]=b;c=f[a+4+(b<<2)>>2]|0;bi[f[(f[c>>2]|0)+28>>2]&2047](c);return}function fLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+12>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function gLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+32|0;g=e;if((a|0)!=(c|0)){zpb(g,3,473467,358);xpb(e+24|0,vpb(g,473567)|0);Apb(g)}if((b|0)==(d|0)){u=e;return}if((f[d>>2]|0)==(f[b>>2]|0)){g=b+12|0;c=d+12|0;a=f[g>>2]|0;f[g>>2]=f[c>>2];f[c>>2]=a;a=b+4|0;c=d+4|0;g=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=g;g=b+8|0;c=d+8|0;a=f[g>>2]|0;f[g>>2]=f[c>>2];f[c>>2]=a;u=e;return}else{rLb(b,d);u=e;return}}function hLb(a,b){a=a|0;b=b|0;return 0}function iLb(a,b){a=a|0;b=b|0;return Uh[f[(f[a>>2]|0)+12>>2]&1023](a,b)|0}function jLb(a,b,c){a=a|0;b=b|0;c=c|0;return c|0}function kLb(a,b,c){a=a|0;b=b|0;c=c|0;return c+1|0}function lLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return (c|0)==(d|0)|0}function mLb(a,b,c){a=a|0;b=b|0;c=c|0;return}function nLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Dg[f[(f[a>>2]|0)+16>>2]&127](a,b,c,d)|0}function oLb(a,b){a=a|0;b=b|0;return di[f[(f[b>>2]|0)+12>>2]&1023](b)|0}function pLb(a,b,c){a=a|0;b=b|0;c=c|0;zh[f[(f[c>>2]|0)+72>>2]&2047](c,b);return}function qLb(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function rLb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;f[d>>2]=f[b>>2];e=d+4|0;f[e>>2]=0;g=d+8|0;f[g>>2]=0;h=d+12|0;f[h>>2]=0;sLb(d,a);i=a+4|0;j=f[i>>2]|0;if((j|0)>0){k=f[a+12>>2]|0;l=0;do{m=f[k+4+(l<<2)>>2]|0;l=l+1|0;bi[f[(f[m>>2]|0)+28>>2]&2047](m)}while((l|0)!=(j|0));f[i>>2]=0}sLb(a,b);a=b+4|0;i=f[a>>2]|0;j=b+12|0;if((i|0)>0){l=f[j>>2]|0;k=0;do{m=f[l+4+(k<<2)>>2]|0;k=k+1|0;bi[f[(f[m>>2]|0)+28>>2]&2047](m)}while((k|0)!=(i|0));f[a>>2]=0;n=0}else n=i;i=f[j>>2]|0;f[j>>2]=f[h>>2];f[h>>2]=i;f[a>>2]=f[e>>2];f[e>>2]=n;n=b+8|0;b=f[n>>2]|0;f[n>>2]=f[g>>2];f[g>>2]=b;b=i;if(!((i|0)!=0&(f[d>>2]|0)==0)){u=c;return}d=i;i=f[b>>2]|0;if((i|0)>0){g=0;do{n=f[b+4+(g<<2)>>2]|0;if(n|0)bi[f[(f[n>>2]|0)+4>>2]&2047](n);g=g+1|0}while((g|0)!=(i|0));o=f[h>>2]|0}else o=d;O5b(o);u=c;return}function sLb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{xHb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=tLb(h,i)|0;xHb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function tLb(a,b){a=a|0;b=b|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,b)|0}function uLb(a){a=a|0;O5b(a);return}function vLb(a,b){a=a|0;b=b|0;a=(oKb(b)|0)+4|0;return (f[a>>2]|0)==0|0}function wLb(a,b){a=a|0;b=b|0;a=(oKb(b)|0)+4|0;return f[a>>2]|0}function xLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[(f[a>>2]|0)+80>>2]|0;g=(oKb(b)|0)+12|0;return li[e&511](a,f[(f[g>>2]|0)+4+(c<<2)>>2]|0,d)|0}function yLb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;a=pKb(b)|0;b=a+4|0;c=f[b>>2]|0;if((c|0)<=0)return;d=f[a+12>>2]|0;a=0;do{e=f[d+4+(a<<2)>>2]|0;a=a+1|0;bi[f[(f[e>>2]|0)+28>>2]&2047](e)}while((a|0)!=(c|0));f[b>>2]=0;return}function zLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=f[(f[a>>2]|0)+76>>2]|0;g=(pKb(b)|0)+12|0;_h[e&255](a,d,f[(f[g>>2]|0)+4+(c<<2)>>2]|0);return}function ALb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=Uh[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;_h[f[(f[a>>2]|0)+76>>2]&255](a,c,d);c=pKb(b)|0;b=di[f[(f[d>>2]|0)+24>>2]&1023](d)|0;a=f[c>>2]|0;if(((a|0)==(b|0)?(b=c+12|0,e=f[b>>2]|0,e|0):0)?(g=f[e>>2]|0,(g|0)<(f[c+8>>2]|0)):0){h=c+4|0;i=f[h>>2]|0;if((i|0)<(g|0)){j=e+4+(i<<2)|0;f[e+4+(g<<2)>>2]=f[j>>2];k=j}else k=e+4+(i<<2)|0;f[k>>2]=d;f[h>>2]=i+1;i=f[b>>2]|0;f[i>>2]=(f[i>>2]|0)+1;return}YJb(c,d,di[f[(f[d>>2]|0)+20>>2]&1023](d)|0,a);return}function BLb(a,b){a=a|0;b=b|0;var c=0;a=pKb(b)|0;b=f[a+12>>2]|0;c=a+4|0;a=(f[c>>2]|0)+-1|0;f[c>>2]=a;c=f[b+4+(a<<2)>>2]|0;bi[f[(f[c>>2]|0)+28>>2]&2047](c);return}function CLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=(pKb(b)|0)+12|0;b=f[a>>2]|0;a=b+4+(c<<2)|0;c=b+4+(d<<2)|0;d=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=d;return}function DLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+32|0;g=e;if((a|0)!=(c|0)){zpb(g,3,473467,240);xpb(e+24|0,vpb(g,473567)|0);Apb(g)}g=pKb(b)|0;b=pKb(d)|0;if((g|0)==(b|0)){u=e;return}if((f[b>>2]|0)==(f[g>>2]|0)){d=g+12|0;c=b+12|0;a=f[d>>2]|0;f[d>>2]=f[c>>2];f[c>>2]=a;a=g+4|0;c=b+4|0;d=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=d;d=g+8|0;c=b+8|0;a=f[d>>2]|0;f[d>>2]=f[c>>2];f[c>>2]=a;u=e;return}else{rLb(g,b);u=e;return}}function ELb(a,b){a=a|0;b=b|0;return di[f[(f[b>>2]|0)+12>>2]&1023](b)|0}function FLb(a,b,c){a=a|0;b=b|0;c=c|0;zh[f[(f[c>>2]|0)+72>>2]&2047](c,b);return}function GLb(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function HLb(a){a=a|0;O5b(a);return}function ILb(a,b){a=a|0;b=b|0;return (f[b+4>>2]|0)==0|0}function JLb(a,b){a=a|0;b=b|0;return f[b+4>>2]|0}function KLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[f[(f[a>>2]|0)+80>>2]&511](a,f[(f[b+12>>2]|0)+4+(c<<2)>>2]|0,d)|0}function LLb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;a=c+4|0;d=f[a>>2]|0;if((d|0)<=0)return;e=f[c+12>>2]|0;c=0;do{g=f[e+4+(c<<2)>>2]|0;c=c+1|0;h=g+11|0;if((b[h>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0}else{b[g>>0]=0;b[h>>0]=0}}while((c|0)!=(d|0));f[a>>2]=0;return}function MLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[f[(f[a>>2]|0)+76>>2]&255](a,d,f[(f[b+12>>2]|0)+4+(c<<2)>>2]|0);return}function NLb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=Uh[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;_h[f[(f[a>>2]|0)+76>>2]&255](a,c,d);c=f[b>>2]|0;if(((c|0)==0?(a=b+12|0,e=f[a>>2]|0,e|0):0)?(g=f[e>>2]|0,(g|0)<(f[b+8>>2]|0)):0){h=b+4|0;i=f[h>>2]|0;if((i|0)<(g|0)){j=e+4+(i<<2)|0;f[e+4+(g<<2)>>2]=f[j>>2];k=j}else k=e+4+(i<<2)|0;f[k>>2]=d;f[h>>2]=i+1;i=f[a>>2]|0;f[i>>2]=(f[i>>2]|0)+1;return}VLb(b,d,0,c);return}function OLb(a,c){a=a|0;c=c|0;var d=0;a=f[c+12>>2]|0;d=c+4|0;c=(f[d>>2]|0)+-1|0;f[d>>2]=c;d=f[a+4+(c<<2)>>2]|0;c=d+11|0;if((b[c>>0]|0)<0){b[f[d>>2]>>0]=0;f[d+4>>2]=0;return}else{b[d>>0]=0;b[c>>0]=0;return}}function PLb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+12>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function QLb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+48|0;h=g+32|0;i=g+16|0;j=g;if((a|0)==(d|0)){if((c|0)==(e|0)){u=g;return}if((f[e>>2]|0)==(f[c>>2]|0)){k=c+12|0;l=e+12|0;m=f[k>>2]|0;f[k>>2]=f[l>>2];f[l>>2]=m;m=c+4|0;l=e+4|0;k=f[m>>2]|0;f[m>>2]=f[l>>2];f[l>>2]=k;k=c+8|0;l=e+8|0;m=f[k>>2]|0;f[k>>2]=f[l>>2];f[l>>2]=m;u=g;return}else{ULb(c,e);u=g;return}};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;do if((i|0)!=(c|0))if(!(f[c>>2]|0)){m=c+12|0;f[i+12>>2]=f[m>>2];f[m>>2]=0;m=c+4|0;f[i+4>>2]=f[m>>2];f[m>>2]=0;m=c+8|0;f[i+8>>2]=f[m>>2];f[m>>2]=0;break}else{ULb(i,c);break}while(0);m=Uh[f[(f[d>>2]|0)+12>>2]&1023](d,e)|0;if((m|0)>0){l=h+11|0;k=h+11|0;n=j+11|0;o=0;do{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;X5b(j,Dg[f[(f[d>>2]|0)+16>>2]&127](d,e,o,h)|0);if((b[l>>0]|0)<0)O5b(f[h>>2]|0);X5b(h,j);_h[f[(f[a>>2]|0)+28>>2]&255](a,c,h);if((b[k>>0]|0)<0)O5b(f[h>>2]|0);if((b[n>>0]|0)<0)O5b(f[j>>2]|0);o=o+1|0}while((o|0)<(m|0))}m=Uh[f[(f[a>>2]|0)+12>>2]&1023](a,c)|0;zh[f[(f[d>>2]|0)+20>>2]&2047](d,e);c=i+12|0;a=f[c>>2]|0;if((m|0)>0){o=h+11|0;j=0;n=a;while(1){X5b(h,f[n+4+(j<<2)>>2]|0);_h[f[(f[d>>2]|0)+28>>2]&255](d,e,h);if((b[o>>0]|0)<0)O5b(f[h>>2]|0);j=j+1|0;k=f[c>>2]|0;if((j|0)>=(m|0)){p=k;break}else n=k}}else p=a;if(p|0?(f[i>>2]|0)==0:0){i=f[p>>2]|0;if((i|0)>0){a=0;do{n=f[p+4+(a<<2)>>2]|0;if(n|0){if((b[n+11>>0]|0)<0)O5b(f[n>>2]|0);O5b(n)}a=a+1|0}while((a|0)!=(i|0));q=f[c>>2]|0}else q=p;O5b(q)}u=g;return}function RLb(a,b){a=a|0;b=b|0;b=L5b(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;return b|0}function SLb(a,b,c){a=a|0;b=b|0;c=c|0;_5b(c,b)|0;return}function TLb(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function ULb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=e+4|0;f[g>>2]=0;h=e+8|0;f[h>>2]=0;i=e+12|0;f[i>>2]=0;UDa(e,a);j=a+4|0;k=f[j>>2]|0;if((k|0)>0){l=f[a+12>>2]|0;m=0;do{n=f[l+4+(m<<2)>>2]|0;m=m+1|0;o=n+11|0;if((b[o>>0]|0)<0){b[f[n>>2]>>0]=0;f[n+4>>2]=0}else{b[n>>0]=0;b[o>>0]=0}}while((m|0)!=(k|0));f[j>>2]=0}UDa(a,c);a=c+4|0;j=f[a>>2]|0;k=c+12|0;if((j|0)>0){m=f[k>>2]|0;l=0;do{o=f[m+4+(l<<2)>>2]|0;l=l+1|0;n=o+11|0;if((b[n>>0]|0)<0){b[f[o>>2]>>0]=0;f[o+4>>2]=0}else{b[o>>0]=0;b[n>>0]=0}}while((l|0)!=(j|0));f[a>>2]=0;p=0}else p=j;j=f[k>>2]|0;f[k>>2]=f[i>>2];f[i>>2]=j;f[a>>2]=f[g>>2];f[g>>2]=p;p=c+8|0;c=f[p>>2]|0;f[p>>2]=f[h>>2];f[h>>2]=c;c=j;if(!((j|0)!=0&(f[e>>2]|0)==0)){u=d;return}e=j;j=f[c>>2]|0;if((j|0)>0){h=0;do{p=f[c+4+(h<<2)>>2]|0;if(p|0){if((b[p+11>>0]|0)<0)O5b(f[p>>2]|0);O5b(p)}h=h+1|0}while((h|0)!=(j|0));q=f[i>>2]|0}else q=e;O5b(q);u=d;return}function VLb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;if(!((d|0)==0&(e|0)!=0))if((e|0)!=(d|0)){if(!e){g=L5b(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;h=g}else{g=znb(e,8992,12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;xnb(e,g,1480);h=g}_5b(h,c)|0;if((c|0)==0|(d|0)!=0)i=h;else{if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);O5b(c);i=h}}else i=c;else{eya(e,c);i=c}WLb(a,i);return}function WLb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+12|0;e=f[d>>2]|0;g=f[a+8>>2]|0;h=a+4|0;do if((e|0)!=0?(i=f[h>>2]|0,(i|0)!=(g|0)):0){j=f[e>>2]|0;if((j|0)!=(g|0)){if((i|0)<(j|0)){f[e+4+(j<<2)>>2]=f[e+4+(i<<2)>>2];k=f[d>>2]|0;l=k;m=f[k>>2]|0}else{l=e;m=j}f[l>>2]=m+1;n=l;break}j=f[e+4+(i<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0)n=e;else{if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);O5b(j);n=f[d>>2]|0}}else o=3;while(0);if((o|0)==3){cpb(a,g+1|0);g=f[d>>2]|0;f[g>>2]=(f[g>>2]|0)+1;n=g}g=f[h>>2]|0;f[h>>2]=g+1;f[n+4+(g<<2)>>2]=c;return}function XLb(a){a=a|0;O5b(a);return}function YLb(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function ZLb(a,b){a=a|0;b=b|0;return f[b>>2]|0}function _Lb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+4+c|0,d)|0}function $Lb(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function aMb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0;g=(Uh[f[(f[a>>2]|0)+72>>2]&1023](a,e)|0)&1;b[(f[c+8>>2]|0)+4+d>>0]=g;return}function bMb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=(Uh[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0)&1;d=f[c>>2]|0;if((d|0)==(f[c+4>>2]|0)){vFa(c,d+1|0);g=f[c>>2]|0}else g=d;d=f[c+8>>2]|0;f[c>>2]=g+1;b[d+4+g>>0]=e;return}function cMb(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function dMb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;a=f[c+8>>2]|0;c=a+4+d|0;d=a+4+e|0;e=b[c>>0]|0;b[c>>0]=b[d>>0]|0;b[d>>0]=e;return}function eMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){YHb(b,d);u=e;return}zpb(f,3,473467,287);xpb(e+24|0,vpb(f,473567)|0);Apb(f);YHb(b,d);u=e;return}function fMb(a,c){a=a|0;c=c|0;return (b[c>>0]|0)!=0|0}function gMb(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function hMb(a){a=a|0;O5b(a);return}function iMb(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function jMb(a,b){a=a|0;b=b|0;return f[b>>2]|0}function kMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+8+(c<<3)|0,d)|0}function lMb(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function mMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0;e=+yg[f[(f[a>>2]|0)+72>>2]&31](a,d);p[(f[b+8>>2]|0)+8+(c<<3)>>3]=e;return}function nMb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0;d=+yg[f[(f[a>>2]|0)+72>>2]&31](a,c);c=f[b>>2]|0;if((c|0)==(f[b+4>>2]|0)){tFa(b,c+1|0);e=f[b>>2]|0}else e=c;c=f[b+8>>2]|0;f[b>>2]=e+1;p[c+8+(e<<3)>>3]=d;return}function oMb(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function pMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0;a=f[b+8>>2]|0;b=a+8+(c<<3)|0;c=a+8+(d<<3)|0;e=+p[b>>3];p[b>>3]=+p[c>>3];p[c>>3]=e;return}function qMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){XHb(b,d);u=e;return}zpb(f,3,473467,287);xpb(e+24|0,vpb(f,473567)|0);Apb(f);XHb(b,d);u=e;return}function rMb(a,b){a=a|0;b=b|0;return +(+p[b>>3])}function sMb(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function tMb(a){a=a|0;O5b(a);return}function uMb(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function vMb(a,b){a=a|0;b=b|0;return f[b>>2]|0}function wMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+4+(c<<2)|0,d)|0}function xMb(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function yMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0.0;e=+yg[f[(f[a>>2]|0)+72>>2]&31](a,d);n[(f[b+8>>2]|0)+4+(c<<2)>>2]=e;return}function zMb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0;d=+yg[f[(f[a>>2]|0)+72>>2]&31](a,c);c=f[b>>2]|0;if((c|0)==(f[b+4>>2]|0)){qza(b,c+1|0);e=f[b>>2]|0}else e=c;c=f[b+8>>2]|0;f[b>>2]=e+1;n[c+4+(e<<2)>>2]=d;return}function AMb(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function BMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+8>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function CMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){WHb(b,d);u=e;return}zpb(f,3,473467,287);xpb(e+24|0,vpb(f,473567)|0);Apb(f);WHb(b,d);u=e;return}function DMb(a,b){a=a|0;b=b|0;return +(+n[b>>2])}function EMb(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function FMb(a){a=a|0;O5b(a);return}function GMb(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function HMb(a,b){a=a|0;b=b|0;return f[b>>2]|0}function IMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+8+(c<<3)|0,d)|0}function JMb(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function KMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Uh[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0;d=(f[b+8>>2]|0)+8+(c<<3)|0;f[d>>2]=e;f[d+4>>2]=J;return}function LMb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Uh[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;c=J;a=f[b>>2]|0;if((a|0)==(f[b+4>>2]|0)){AHb(b,a+1|0);e=f[b>>2]|0}else e=a;a=f[b+8>>2]|0;f[b>>2]=e+1;b=a+8+(e<<3)|0;f[b>>2]=d;f[b+4>>2]=c;return}function MMb(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function NMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;a=f[b+8>>2]|0;b=a+8+(c<<3)|0;c=a+8+(d<<3)|0;d=b;a=f[d>>2]|0;e=f[d+4>>2]|0;d=c;g=f[d+4>>2]|0;h=b;f[h>>2]=f[d>>2];f[h+4>>2]=g;g=c;f[g>>2]=a;f[g+4>>2]=e;return}function OMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){VHb(b,d);u=e;return}zpb(f,3,473467,287);xpb(e+24|0,vpb(f,473567)|0);Apb(f);VHb(b,d);u=e;return}function PMb(a,b){a=a|0;b=b|0;a=b;J=f[a+4>>2]|0;return f[a>>2]|0}function QMb(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function RMb(a){a=a|0;O5b(a);return}function SMb(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function TMb(a,b){a=a|0;b=b|0;return f[b>>2]|0}function UMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+8+(c<<3)|0,d)|0}function VMb(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function WMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Uh[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0;d=(f[b+8>>2]|0)+8+(c<<3)|0;f[d>>2]=e;f[d+4>>2]=J;return}function XMb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Uh[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;c=J;a=f[b>>2]|0;if((a|0)==(f[b+4>>2]|0)){uFa(b,a+1|0);e=f[b>>2]|0}else e=a;a=f[b+8>>2]|0;f[b>>2]=e+1;b=a+8+(e<<3)|0;f[b>>2]=d;f[b+4>>2]=c;return}function YMb(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function ZMb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;a=f[b+8>>2]|0;b=a+8+(c<<3)|0;c=a+8+(d<<3)|0;d=b;a=f[d>>2]|0;e=f[d+4>>2]|0;d=c;g=f[d+4>>2]|0;h=b;f[h>>2]=f[d>>2];f[h+4>>2]=g;g=c;f[g>>2]=a;f[g+4>>2]=e;return}function _Mb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){THb(b,d);u=e;return}zpb(f,3,473467,287);xpb(e+24|0,vpb(f,473567)|0);Apb(f);THb(b,d);u=e;return}function $Mb(a,b){a=a|0;b=b|0;a=b;J=f[a+4>>2]|0;return f[a>>2]|0}function aNb(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function bNb(a){a=a|0;O5b(a);return}function cNb(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function dNb(a,b){a=a|0;b=b|0;return f[b>>2]|0}function eNb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+4+(c<<2)|0,d)|0}function fNb(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function gNb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Uh[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0;f[(f[b+8>>2]|0)+4+(c<<2)>>2]=e;return}function hNb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Uh[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;c=f[b>>2]|0;if((c|0)==(f[b+4>>2]|0)){rza(b,c+1|0);e=f[b>>2]|0}else e=c;c=f[b+8>>2]|0;f[b>>2]=e+1;f[c+4+(e<<2)>>2]=d;return}function iNb(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function jNb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+8>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function kNb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){UHb(b,d);u=e;return}zpb(f,3,473467,287);xpb(e+24|0,vpb(f,473567)|0);Apb(f);UHb(b,d);u=e;return}function lNb(a,b){a=a|0;b=b|0;return f[b>>2]|0}function mNb(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function nNb(a){a=a|0;O5b(a);return}function oNb(a,b){a=a|0;b=b|0;return (f[b>>2]|0)==0|0}function pNb(a,b){a=a|0;b=b|0;return f[b>>2]|0}function qNb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[f[(f[a>>2]|0)+76>>2]&511](a,(f[b+8>>2]|0)+4+(c<<2)|0,d)|0}function rNb(a,b){a=a|0;b=b|0;f[b>>2]=0;return}function sNb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Uh[f[(f[a>>2]|0)+72>>2]&1023](a,d)|0;f[(f[b+8>>2]|0)+4+(c<<2)>>2]=e;return}function tNb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=Uh[f[(f[a>>2]|0)+72>>2]&1023](a,c)|0;c=f[b>>2]|0;if((c|0)==(f[b+4>>2]|0)){nza(b,c+1|0);e=f[b>>2]|0}else e=c;c=f[b+8>>2]|0;f[b>>2]=e+1;f[c+4+(e<<2)>>2]=d;return}function uNb(a,b){a=a|0;b=b|0;f[b>>2]=(f[b>>2]|0)+-1;return}function vNb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=f[b+8>>2]|0;b=a+4+(c<<2)|0;c=a+4+(d<<2)|0;d=f[b>>2]|0;f[b>>2]=f[c>>2];f[c>>2]=d;return}function wNb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=u;u=u+32|0;f=e;if((a|0)==(c|0)){SHb(b,d);u=e;return}zpb(f,3,473467,287);xpb(e+24|0,vpb(f,473567)|0);Apb(f);SHb(b,d);u=e;return}function xNb(a,b){a=a|0;b=b|0;return f[b>>2]|0}function yNb(a,b,c){a=a|0;b=b|0;c=c|0;return b|0}function zNb(a){a=a|0;return}function ANb(){spb(71);return}function BNb(){var a=0;a=f[213435]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);f[213435]=0;a=f[213437]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);f[213437]=0;a=f[213439]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);f[213439]=0;a=f[213441]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);f[213441]=0;a=f[213443]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);f[213443]=0;a=f[213445]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);f[213445]=0;a=f[213447]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);f[213447]=0;a=f[213449]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);f[213449]=0;a=f[213453]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);f[213453]=0;a=f[213451]|0;if(!a){f[213451]=0;return}bi[f[(f[a>>2]|0)+4>>2]&2047](a);f[213451]=0;return}function CNb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;fOb(a,e,c);if((b[e+11>>0]|0)>=0){u=d;return}O5b(f[e>>2]|0);u=d;return}function DNb(a,b,c){a=a|0;b=b|0;c=c|0;return Xf[f[(f[a>>2]|0)+324>>2]&127](a,b,c,1,-1,0)|0}function ENb(a,b,c){a=a|0;b=b|0;c=c|0;return Xf[f[(f[a>>2]|0)+324>>2]&127](a,b,c,2,-1,0)|0}function FNb(a,b,c){a=a|0;b=b|0;c=c|0;return Xf[f[(f[a>>2]|0)+324>>2]&127](a,b,c,3,-1,0)|0}function GNb(a,b,c){a=a|0;b=b|0;c=c|0;return Xf[f[(f[a>>2]|0)+324>>2]&127](a,b,c,4,-1,0)|0}function HNb(a,b,c){a=a|0;b=b|0;c=c|0;return Xf[f[(f[a>>2]|0)+324>>2]&127](a,b,c,6,-1,0)|0}function INb(a,b,c){a=a|0;b=b|0;c=c|0;return Xf[f[(f[a>>2]|0)+324>>2]&127](a,b,c,5,-1,0)|0}function JNb(a,b,c){a=a|0;b=b|0;c=c|0;return Xf[f[(f[a>>2]|0)+324>>2]&127](a,b,c,7,-1,0)|0}function KNb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Xf[f[(f[a>>2]|0)+324>>2]&127](a,b,c,9,0,0)|0}function LNb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;if((f[213454]|0)==2){d=f[213455]|0;u=a;return d|0}f[c>>2]=135812;f[c+4>>2]=72;b[c+8>>0]=0;Gpb(853816,c);hpb(c);d=f[213455]|0;u=a;return d|0}function MNb(){var a=0,b=0;a=L5b(48)|0;f[a>>2]=141196;b=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+20>>2]=1.0;Bpb(a+24|0);b=a+28|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;n[a+44>>2]=1.0;f[213455]=a;spb(73);return}function NNb(){var a=0;a=f[213455]|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ONb(a){a=a|0;var b=0,c=0;f[a>>2]=141196;b=f[a+36>>2]|0;if(b|0){c=b;do{b=c;c=f[c>>2]|0;O5b(b)}while((c|0)!=0)}c=a+28|0;b=f[c>>2]|0;f[c>>2]=0;if(b|0)O5b(b);Cpb(a+24|0);b=f[a+12>>2]|0;if(b|0){c=b;do{b=c;c=f[c>>2]|0;O5b(b)}while((c|0)!=0)}c=a+4|0;a=f[c>>2]|0;f[c>>2]=0;if(!a)return;O5b(a);return}function PNb(a){a=a|0;ONb(a);O5b(a);return}function QNb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=u;u=u+64|0;e=d+48|0;g=d+24|0;h=d+53|0;i=d;j=d+52|0;k=c;l=a+24|0;npb(l);m=a+28|0;n=a+32|0;o=f[n>>2]|0;a:do if(o){p=o+-1|0;q=(p&o|0)==0;if(!q)if(k>>>0<o>>>0)r=k;else r=(k>>>0)%(o>>>0)|0;else r=p&k;s=f[(f[m>>2]|0)+(r<<2)>>2]|0;if((s|0)!=0?(t=f[s>>2]|0,(t|0)!=0):0){b:do if(q){s=t;while(1){v=f[s+4>>2]|0;w=(v|0)==(k|0);if(!(w|(v&p|0)==(r|0))){x=19;break a}if(w?(f[s+8>>2]|0)==(c|0):0){y=s;break b}s=f[s>>2]|0;if(!s){x=19;break a}}}else{s=t;while(1){w=f[s+4>>2]|0;if((w|0)==(k|0)){if((f[s+8>>2]|0)==(c|0)){y=s;break b}}else{if(w>>>0<o>>>0)z=w;else z=(w>>>0)%(o>>>0)|0;if((z|0)!=(r|0)){x=19;break a}}s=f[s>>2]|0;if(!s){x=19;break a}}}while(0);t=f[y+12>>2]|0;opb(l);if(t|0){A=t;u=d;return A|0}}else x=19}else x=19;while(0);if((x|0)==19)opb(l);y=c+8|0;r=f[(f[y>>2]|0)+8>>2]|0;if((r|0)!=(drb()|0)){A=0;u=d;return A|0}r=f[f[y>>2]>>2]|0;if((b[r+11>>0]|0)<0)B=f[r>>2]|0;else B=r;f[e>>2]=B;B=RNb(a+4|0,e)|0;if(B){e=f[B+12>>2]|0;if(e|0){npb(l);B=f[n>>2]|0;c:do if(B){a=B+-1|0;r=(a&B|0)==0;if(!r)if(k>>>0<B>>>0)C=k;else C=(k>>>0)%(B>>>0)|0;else C=a&k;z=f[(f[m>>2]|0)+(C<<2)>>2]|0;if((z|0)!=0?(o=f[z>>2]|0,(o|0)!=0):0){d:do if(r){z=o;while(1){t=f[z+4>>2]|0;p=(t|0)==(k|0);if(!(p|(t&a|0)==(C|0))){x=48;break c}if(p?(f[z+8>>2]|0)==(c|0):0){D=z;break d}z=f[z>>2]|0;if(!z){x=48;break c}}}else{z=o;while(1){p=f[z+4>>2]|0;if((p|0)==(k|0)){if((f[z+8>>2]|0)==(c|0)){D=z;break d}}else{if(p>>>0<B>>>0)E=p;else E=(p>>>0)%(B>>>0)|0;if((E|0)!=(C|0)){x=48;break c}}z=f[z>>2]|0;if(!z){x=48;break c}}}while(0);o=f[D+12>>2]|0;if(o)F=o;else x=48}else x=48}else x=48;while(0);e:do if((x|0)==48){bi[e&2047](f[f[y>>2]>>2]|0);D=f[n>>2]|0;f:do if(D|0){C=D+-1|0;E=(C&D|0)==0;if(!E)if(k>>>0<D>>>0)G=k;else G=(k>>>0)%(D>>>0)|0;else G=C&k;B=f[(f[m>>2]|0)+(G<<2)>>2]|0;if(B|0?(o=f[B>>2]|0,o|0):0){g:do if(E){B=o;while(1){a=f[B+4>>2]|0;r=(a|0)==(k|0);if(!(r|(a&C|0)==(G|0)))break f;if(r?(f[B+8>>2]|0)==(c|0):0){H=B;break g}B=f[B>>2]|0;if(!B)break f}}else{B=o;while(1){r=f[B+4>>2]|0;if((r|0)==(k|0)){if((f[B+8>>2]|0)==(c|0)){H=B;break g}}else{if(r>>>0<D>>>0)I=r;else I=(r>>>0)%(D>>>0)|0;if((I|0)!=(G|0))break f}B=f[B>>2]|0;if(!B)break f}}while(0);o=f[H+12>>2]|0;if(o|0){F=o;break e}}}while(0);zpb(i,2,473004,383);D=vpb(vpb(i,475012)|0,475061)|0;xpb(j,wpb(D,f[c+4>>2]|0)|0);Apb(i);F=0}while(0);opb(l);A=F;u=d;return A|0}}zpb(g,2,473004,366);F=vpb(g,474951)|0;xpb(h,wpb(F,f[f[y>>2]>>2]|0)|0);Apb(g);A=0;u=d;return A|0}function RNb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;c=b[d>>0]|0;if(!(c<<24>>24))e=0;else{g=d;h=0;i=c;while(1){c=(h*5|0)+(i<<24>>24)|0;g=g+1|0;i=b[g>>0]|0;if(!(i<<24>>24)){e=c;break}else h=c}}h=f[a+4>>2]|0;if(!h){j=0;return j|0}i=h+-1|0;g=(i&h|0)==0;if(!g)if(e>>>0<h>>>0)k=e;else k=(e>>>0)%(h>>>0)|0;else k=i&e;c=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!c){j=0;return j|0}a=f[c>>2]|0;if(!a){j=0;return j|0}if(g){g=a;while(1){c=f[g+4>>2]|0;l=(c|0)==(e|0);if(!(l|(c&i|0)==(k|0))){j=0;m=22;break}if(l?(gTb(f[g+8>>2]|0,d)|0)==0:0){j=g;m=22;break}g=f[g>>2]|0;if(!g){j=0;m=22;break}}if((m|0)==22)return j|0}else n=a;while(1){a=f[n+4>>2]|0;g=(a|0)==(e|0);if(!g){if(a>>>0<h>>>0)o=a;else o=(a>>>0)%(h>>>0)|0;if((o|0)!=(k|0)){j=0;m=22;break}if(g)m=21}else m=21;if((m|0)==21?(m=0,(gTb(f[n+8>>2]|0,d)|0)==0):0){j=n;m=22;break}n=f[n>>2]|0;if(!n){j=0;m=22;break}}if((m|0)==22)return j|0;return 0}function SNb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+24|0;g=d;if((f[213454]|0)!=2){f[e>>2]=135812;f[e+4>>2]=72;b[e+8>>0]=0;Gpb(853816,e);hpb(e)}h=(f[213455]|0)+4|0;f[e>>2]=a;f[e+4>>2]=c;if(TNb(h,e)|0){u=d;return}zpb(g,3,473004,331);xpb(d+36|0,vpb(vpb(g,475132)|0,a)|0);Apb(g);u=d;return}function TNb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0;d=f[c>>2]|0;e=b[d>>0]|0;if(!(e<<24>>24))g=0;else{h=d;i=0;j=e;while(1){e=(i*5|0)+(j<<24>>24)|0;h=h+1|0;j=b[h>>0]|0;if(!(j<<24>>24)){g=e;break}else i=e}}i=a+4|0;j=f[i>>2]|0;h=(j|0)==0;a:do if(!h){e=j+-1|0;k=(e&j|0)==0;if(!k)if(g>>>0<j>>>0)l=g;else l=(g>>>0)%(j>>>0)|0;else l=e&g;m=f[(f[a>>2]|0)+(l<<2)>>2]|0;if(!m)o=l;else{if(k){k=m;while(1){k=f[k>>2]|0;if(!k){o=l;break a}p=f[k+4>>2]|0;if(!((p|0)==(g|0)|(p&e|0)==(l|0))){o=l;break a}if(!(gTb(f[k+8>>2]|0,d)|0)){q=0;break}}return q|0}else r=m;while(1){r=f[r>>2]|0;if(!r){o=l;break a}k=f[r+4>>2]|0;if((k|0)!=(g|0)){if(k>>>0<j>>>0)s=k;else s=(k>>>0)%(j>>>0)|0;if((s|0)!=(l|0)){o=l;break a}}if(!(gTb(f[r+8>>2]|0,d)|0)){q=0;break}}return q|0}}else o=0;while(0);d=L5b(16)|0;r=c;c=f[r+4>>2]|0;l=d+8|0;f[l>>2]=f[r>>2];f[l+4>>2]=c;f[d+4>>2]=g;f[d>>2]=0;c=a+12|0;t=+(((f[c>>2]|0)+1|0)>>>0);u=+n[a+16>>2];do if(h|t>+(j>>>0)*u){l=(j>>>0<3|(j+-1&j|0)!=0)&1|j<<1;r=~~+X(+(t/u))>>>0;UNb(a,l>>>0<r>>>0?r:l);l=f[i>>2]|0;r=l+-1|0;if(!(r&l)){v=l;w=r&g;break}if(g>>>0<l>>>0){v=l;w=g}else{v=l;w=(g>>>0)%(l>>>0)|0}}else{v=j;w=o}while(0);o=(f[a>>2]|0)+(w<<2)|0;w=f[o>>2]|0;if(!w){j=a+8|0;f[d>>2]=f[j>>2];f[j>>2]=d;f[o>>2]=j;j=f[d>>2]|0;if(j|0){o=f[j+4>>2]|0;j=v+-1|0;if(j&v)if(o>>>0<v>>>0)x=o;else x=(o>>>0)%(v>>>0)|0;else x=o&j;y=(f[a>>2]|0)+(x<<2)|0;z=32}}else{f[d>>2]=f[w>>2];y=w;z=32}if((z|0)==32)f[y>>2]=d;f[c>>2]=(f[c>>2]|0)+1;q=1;return q|0}function UNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=yWb(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){VNb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=yWb(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;VNb(a,d);return}function VNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{e=L5b(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)O5b(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){b:do if(h){c=k;g=l;i=m;while(1){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if(!(gTb(f[o>>2]|0,f[u+8>>2]|0)|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[c>>2]|0;if(!o){v=35;break a}else d=o}g=f[d>>2]|0;if(!g){v=35;break a}else{c=d;i=d}}}else{i=k;c=l;g=m;while(1){o=c;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=g;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if(!(gTb(f[w>>2]|0,f[z+8>>2]|0)|0))y=z;else break}f[g>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=35;break a}else o=w}c=f[o>>2]|0;if(!c){v=35;break a}else{i=o;g=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=35;break}else{j=s;k=p;m=p}}if((v|0)==35)return}function WNb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d+24|0;g=d;if((f[213454]|0)!=2){f[e>>2]=135812;f[e+4>>2]=72;b[e+8>>0]=0;Gpb(853816,e);hpb(e)}h=(f[213455]|0)+28|0;f[e>>2]=a;f[e+4>>2]=c;if(XNb(h,e)|0){u=d;return}zpb(g,2,473004,346);e=vpb(g,475161)|0;xpb(d+36|0,wpb(e,f[a+4>>2]|0)|0);Apb(g);u=d;return}function XNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0;c=f[b>>2]|0;d=a+4|0;e=f[d>>2]|0;g=(e|0)==0;h=c;a:do if(!g){i=e+-1|0;j=(i&e|0)==0;if(!j)if(c>>>0<e>>>0)k=c;else k=(c>>>0)%(e>>>0)|0;else k=i&c;l=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!l)m=k;else{if(j){j=l;while(1){j=f[j>>2]|0;if(!j){m=k;break a}o=f[j+4>>2]|0;if(!((o|0)==(c|0)|(o&i|0)==(k|0))){m=k;break a}if((f[j+8>>2]|0)==(h|0)){p=0;break}}return p|0}else q=l;while(1){q=f[q>>2]|0;if(!q){m=k;break a}j=f[q+4>>2]|0;if((j|0)!=(c|0)){if(j>>>0<e>>>0)r=j;else r=(j>>>0)%(e>>>0)|0;if((r|0)!=(k|0)){m=k;break a}}if((f[q+8>>2]|0)==(h|0)){p=0;break}}return p|0}}else m=0;while(0);h=L5b(16)|0;q=b;b=f[q+4>>2]|0;k=h+8|0;f[k>>2]=f[q>>2];f[k+4>>2]=b;f[h+4>>2]=c;f[h>>2]=0;b=a+12|0;s=+(((f[b>>2]|0)+1|0)>>>0);t=+n[a+16>>2];do if(g|s>+(e>>>0)*t){k=(e>>>0<3|(e+-1&e|0)!=0)&1|e<<1;q=~~+X(+(s/t))>>>0;YNb(a,k>>>0<q>>>0?q:k);k=f[d>>2]|0;q=k+-1|0;if(!(q&k)){u=k;v=q&c;break}if(c>>>0<k>>>0){u=k;v=c}else{u=k;v=(c>>>0)%(k>>>0)|0}}else{u=e;v=m}while(0);m=(f[a>>2]|0)+(v<<2)|0;v=f[m>>2]|0;if(!v){e=a+8|0;f[h>>2]=f[e>>2];f[e>>2]=h;f[m>>2]=e;e=f[h>>2]|0;if(e|0){m=f[e+4>>2]|0;e=u+-1|0;if(e&u)if(m>>>0<u>>>0)w=m;else w=(m>>>0)%(u>>>0)|0;else w=m&e;x=(f[a>>2]|0)+(w<<2)|0;y=30}}else{f[h>>2]=f[v>>2];x=v;y=30}if((y|0)==30)f[x>>2]=h;f[b>>2]=(f[b>>2]|0)+1;p=1;return p|0}function YNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=yWb(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){ZNb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=yWb(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;ZNb(a,d);return}function ZNb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{e=L5b(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)O5b(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){b:do if(h){c=k;g=l;i=m;while(1){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if((f[o>>2]|0)==(f[u+8>>2]|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[c>>2]|0;if(!o){v=35;break a}else d=o}g=f[d>>2]|0;if(!g){v=35;break a}else{c=d;i=d}}}else{i=k;c=l;g=m;while(1){o=c;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=g;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if((f[w>>2]|0)==(f[z+8>>2]|0))y=z;else break}f[g>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=35;break a}else o=w}c=f[o>>2]|0;if(!c){v=35;break a}else{i=o;g=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=35;break}else{j=s;k=p;m=p}}if((v|0)==35)return}function _Nb(a){a=a|0;return di[f[(f[a>>2]|0)+20>>2]&1023](a)|0}function $Nb(a){a=a|0;return di[f[(f[a>>2]|0)+24>>2]&1023](a)|0}function aOb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bOb(b);cOb(a,b);return}function bOb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;b=u;u=u+16|0;c=b;d=di[f[(f[a>>2]|0)+92>>2]&1023](a)|0;f[c>>2]=0;e=c+4|0;f[e>>2]=0;f[c+8>>2]=0;_h[f[(f[d>>2]|0)+64>>2]&255](d,a,c);g=f[c>>2]|0;if((f[e>>2]|0)!=(g|0)){h=0;i=g;do{_h[f[(f[d>>2]|0)+28>>2]&255](d,a,f[i+(h<<2)>>2]|0);h=h+1|0;i=f[c>>2]|0}while(h>>>0<(f[e>>2]|0)-i>>2>>>0)}i=Uh[f[(f[d>>2]|0)+12>>2]&1023](d,a)|0;if(f[i>>2]|0)GPb(i);i=f[c>>2]|0;if(!i){u=b;return}c=f[e>>2]|0;if((c|0)!=(i|0))f[e>>2]=c+(~((c+-4-i|0)>>>2)<<2);O5b(i);u=b;return}function cOb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0.0,w=0;d=u;u=u+80|0;e=d+64|0;g=d+40|0;h=d+16|0;i=d;if((a|0)==(c|0)){zpb(g,3,475190,55);xpb(d+77|0,vpb(g,475286)|0);Apb(g)}zh[f[(f[a>>2]|0)+96>>2]&2047](e,a);g=f[e>>2]|0;zh[f[(f[c>>2]|0)+96>>2]&2047](e,c);if((f[e>>2]|0)!=(g|0)){zpb(h,3,475190,58);j=vpb(vpb(vpb(h,475318)|0,475372)|0,475416)|0;k=vpb(wpb(j,f[g+4>>2]|0)|0,475424)|0;zh[f[(f[c>>2]|0)+96>>2]&2047](e,c);xpb(d+76|0,vpb(wpb(k,f[(f[e>>2]|0)+4>>2]|0)|0,489101)|0);Apb(h)}h=di[f[(f[a>>2]|0)+92>>2]&1023](a)|0;k=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;_h[f[(f[h>>2]|0)+64>>2]&255](h,a,e);j=f[e>>2]|0;if((f[g>>2]|0)!=(j|0)){l=i+11|0;m=i+11|0;n=0;o=j;do{j=f[o+(n<<2)>>2]|0;a:do if((f[j+36>>2]|0)==3){p=li[f[(f[h>>2]|0)+24>>2]&511](h,a,j)|0;if((p|0)>0){q=j+32|0;r=0;while(1){do switch(f[136e3+(f[q>>2]<<2)>>2]|0){case 1:{s=f[(f[k>>2]|0)+260>>2]|0;t=Dg[f[(f[h>>2]|0)+168>>2]&127](h,a,j,r)|0;th[s&511](k,c,j,t);break}case 2:{t=f[(f[k>>2]|0)+264>>2]|0;s=Dg[f[(f[h>>2]|0)+172>>2]&127](h,a,j,r)|0;uh[t&255](k,c,j,s,J);break}case 3:{s=f[(f[k>>2]|0)+268>>2]|0;t=Dg[f[(f[h>>2]|0)+176>>2]&127](h,a,j,r)|0;th[s&511](k,c,j,t);break}case 4:{t=f[(f[k>>2]|0)+272>>2]|0;s=Dg[f[(f[h>>2]|0)+180>>2]&127](h,a,j,r)|0;uh[t&255](k,c,j,s,J);break}case 6:{s=f[(f[k>>2]|0)+276>>2]|0;v=+Kh[f[(f[h>>2]|0)+184>>2]&15](h,a,j,r);oh[s&63](k,c,j,v);break}case 5:{s=f[(f[k>>2]|0)+280>>2]|0;v=+Kh[f[(f[h>>2]|0)+188>>2]&15](h,a,j,r);oh[s&63](k,c,j,v);break}case 7:{s=f[(f[k>>2]|0)+284>>2]|0;t=Dg[f[(f[h>>2]|0)+192>>2]&127](h,a,j,r)|0;th[s&511](k,c,j,t);break}case 9:{t=f[(f[k>>2]|0)+288>>2]|0;uh[f[(f[h>>2]|0)+196>>2]&255](i,h,a,j,r);th[t&511](k,c,j,i);if((b[l>>0]|0)<0)O5b(f[i>>2]|0);break}case 8:{t=f[(f[k>>2]|0)+292>>2]|0;s=Dg[f[(f[h>>2]|0)+200>>2]&127](h,a,j,r)|0;th[t&511](k,c,j,s);break}case 10:{s=Dg[f[(f[k>>2]|0)+300>>2]&127](k,c,j,0)|0;t=f[(f[s>>2]|0)+76>>2]|0;w=Dg[f[(f[h>>2]|0)+208>>2]&127](h,a,j,r)|0;zh[t&2047](s,w);break}default:{}}while(0);r=r+1|0;if((r|0)>=(p|0))break a}}}else do switch(f[136e3+(f[j+32>>2]<<2)>>2]|0){case 1:{p=f[(f[k>>2]|0)+116>>2]|0;r=li[f[(f[h>>2]|0)+68>>2]&511](h,a,j)|0;th[p&511](k,c,j,r);break a;break}case 2:{r=f[(f[k>>2]|0)+120>>2]|0;p=li[f[(f[h>>2]|0)+72>>2]&511](h,a,j)|0;uh[r&255](k,c,j,p,J);break a;break}case 3:{p=f[(f[k>>2]|0)+124>>2]|0;r=li[f[(f[h>>2]|0)+76>>2]&511](h,a,j)|0;th[p&511](k,c,j,r);break a;break}case 4:{r=f[(f[k>>2]|0)+128>>2]|0;p=li[f[(f[h>>2]|0)+80>>2]&511](h,a,j)|0;uh[r&255](k,c,j,p,J);break a;break}case 6:{p=f[(f[k>>2]|0)+132>>2]|0;v=+fh[f[(f[h>>2]|0)+84>>2]&31](h,a,j);oh[p&63](k,c,j,v);break a;break}case 5:{p=f[(f[k>>2]|0)+136>>2]|0;v=+fh[f[(f[h>>2]|0)+88>>2]&31](h,a,j);oh[p&63](k,c,j,v);break a;break}case 7:{p=f[(f[k>>2]|0)+140>>2]|0;r=li[f[(f[h>>2]|0)+92>>2]&511](h,a,j)|0;th[p&511](k,c,j,r);break a;break}case 9:{r=f[(f[k>>2]|0)+144>>2]|0;th[f[(f[h>>2]|0)+96>>2]&511](i,h,a,j);th[r&511](k,c,j,i);if((b[m>>0]|0)<0)O5b(f[i>>2]|0);break a;break}case 8:{r=f[(f[k>>2]|0)+148>>2]|0;p=li[f[(f[h>>2]|0)+100>>2]&511](h,a,j)|0;th[r&511](k,c,j,p);break a;break}case 10:{p=Dg[f[(f[k>>2]|0)+156>>2]&127](k,c,j,0)|0;r=f[(f[p>>2]|0)+76>>2]|0;q=Dg[f[(f[h>>2]|0)+108>>2]&127](h,a,j,0)|0;zh[r&2047](p,q);break a;break}default:break a}while(0);while(0);n=n+1|0;o=f[e>>2]|0}while(n>>>0<(f[g>>2]|0)-o>>2>>>0)}o=Uh[f[(f[k>>2]|0)+12>>2]&1023](k,c)|0;JPb(o,Uh[f[(f[h>>2]|0)+8>>2]&1023](h,a)|0);a=f[e>>2]|0;if(!a){u=d;return}e=f[g>>2]|0;if((e|0)!=(a|0))f[g>>2]=e+(~((e+-4-a|0)>>>2)<<2);O5b(a);u=d;return}function dOb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=u;u=u+16|0;c=b;zh[f[(f[a>>2]|0)+96>>2]&2047](c,a);d=f[c>>2]|0;e=di[f[(f[a>>2]|0)+92>>2]&1023](a)|0;g=d+24|0;h=f[g>>2]|0;a:do if((h|0)>0){i=d+28|0;j=0;k=h;while(1){l=f[i>>2]|0;if((f[l+(j*88|0)+36>>2]|0)==2){if(!(li[f[(f[e>>2]|0)+20>>2]&511](e,a,l+(j*88|0)|0)|0)){m=0;break}n=f[g>>2]|0}else n=k;j=j+1|0;if((j|0)>=(n|0))break a;else k=n}u=b;return m|0}while(0);f[c>>2]=0;n=c+4|0;f[n>>2]=0;f[c+8>>2]=0;_h[f[(f[e>>2]|0)+64>>2]&255](e,a,c);g=f[c>>2]|0;do if((f[n>>2]|0)!=(g|0)){h=0;d=g;b:while(1){k=f[d+(h<<2)>>2]|0;do if((f[136e3+(f[k+32>>2]<<2)>>2]|0)==10){if((f[k+36>>2]|0)!=3){j=Dg[f[(f[e>>2]|0)+108>>2]&127](e,a,k,0)|0;if(di[f[(f[j>>2]|0)+32>>2]&1023](j)|0)break;else{o=16;break b}}j=li[f[(f[e>>2]|0)+24>>2]&511](e,a,k)|0;if((j|0)>0){i=0;do{l=Dg[f[(f[e>>2]|0)+208>>2]&127](e,a,k,i)|0;i=i+1|0;if(!(di[f[(f[l>>2]|0)+32>>2]&1023](l)|0)){o=16;break b}}while((i|0)<(j|0))}}while(0);h=h+1|0;d=f[c>>2]|0;if(h>>>0>=(f[n>>2]|0)-d>>2>>>0){o=17;break}}if((o|0)==16){p=0;q=f[c>>2]|0;break}else if((o|0)==17){p=1;q=d;break}}else{p=1;q=g}while(0);if(q|0){g=f[n>>2]|0;if((g|0)!=(q|0))f[n>>2]=g+(~((g+-4-q|0)>>>2)<<2);O5b(q)}m=p;u=b;return m|0}function eOb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=u;u=u+16|0;c=b;d=di[f[(f[a>>2]|0)+92>>2]&1023](a)|0;e=Uh[f[(f[d>>2]|0)+12>>2]&1023](d,a)|0;if(f[e>>2]|0)GPb(e);f[c>>2]=0;e=c+4|0;f[e>>2]=0;f[c+8>>2]=0;_h[f[(f[d>>2]|0)+64>>2]&255](d,a,c);g=f[e>>2]|0;h=f[c>>2]|0;i=h;if((g|0)==(h|0)){j=g;k=i}else{g=0;h=i;while(1){i=f[h+(g<<2)>>2]|0;do if((f[136e3+(f[i+32>>2]<<2)>>2]|0)==10){if((f[i+36>>2]|0)!=3){l=Dg[f[(f[d>>2]|0)+156>>2]&127](d,a,i,0)|0;bi[f[(f[l>>2]|0)+80>>2]&2047](l);break}l=li[f[(f[d>>2]|0)+24>>2]&511](d,a,i)|0;if((l|0)>0){m=0;do{n=Dg[f[(f[d>>2]|0)+256>>2]&127](d,a,i,m)|0;bi[f[(f[n>>2]|0)+80>>2]&2047](n);m=m+1|0}while((m|0)<(l|0))}}while(0);g=g+1|0;i=f[e>>2]|0;l=f[c>>2]|0;m=l;if(g>>>0>=i-l>>2>>>0){j=i;k=m;break}else h=m}}h=j;if(!k){u=b;return}if((h|0)!=(k|0))f[e>>2]=h+(~((h+-4-k|0)>>>2)<<2);O5b(k);u=b;return}function fOb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+32|0;g=e+12|0;h=e;zh[f[(f[a>>2]|0)+96>>2]&2047](g,a);i=f[g>>2]|0;j=di[f[(f[a>>2]|0)+92>>2]&1023](a)|0;k=i+24|0;if((f[k>>2]|0)>0){l=i+28|0;i=d+4|0;m=d+8|0;n=g+11|0;o=0;do{p=f[l>>2]|0;if((f[p+(o*88|0)+36>>2]|0)==2?!(li[f[(f[j>>2]|0)+20>>2]&511](j,a,p+(o*88|0)|0)|0):0){Ccb(g,c,f[(f[l>>2]|0)+(o*88|0)>>2]|0);p=f[i>>2]|0;if((p|0)==(f[m>>2]|0))JT(d,g);else{X5b(p,g);f[i>>2]=(f[i>>2]|0)+12}if((b[n>>0]|0)<0)O5b(f[g>>2]|0)}o=o+1|0}while((o|0)<(f[k>>2]|0))}f[g>>2]=0;k=g+4|0;f[k>>2]=0;f[g+8>>2]=0;_h[f[(f[j>>2]|0)+64>>2]&255](j,a,g);o=f[k>>2]|0;n=f[g>>2]|0;i=n;if((o|0)==(n|0)){q=o;r=i}else{o=h+11|0;n=h+11|0;m=0;l=i;while(1){i=f[l+(m<<2)>>2]|0;do if((f[136e3+(f[i+32>>2]<<2)>>2]|0)==10){if((f[i+36>>2]|0)!=3){p=Dg[f[(f[j>>2]|0)+108>>2]&127](j,a,i,0)|0;gOb(h,c,i,-1);fOb(p,h,d);if((b[n>>0]|0)<0)O5b(f[h>>2]|0);break}p=li[f[(f[j>>2]|0)+24>>2]&511](j,a,i)|0;if((p|0)>0){s=0;do{t=Dg[f[(f[j>>2]|0)+208>>2]&127](j,a,i,s)|0;gOb(h,c,i,s);fOb(t,h,d);if((b[o>>0]|0)<0)O5b(f[h>>2]|0);s=s+1|0}while((s|0)<(p|0))}}while(0);m=m+1|0;i=f[k>>2]|0;p=f[g>>2]|0;s=p;if(m>>>0>=i-p>>2>>>0){q=i;r=s;break}else l=s}}l=q;if(!r){u=e;return}if((l|0)!=(r|0))f[k>>2]=l+(~((l+-4-r|0)>>>2)<<2);O5b(r);u=e;return}function gOb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;X5b(a,c);if(!(b[d+40>>0]|0)){c=f[d>>2]|0;i=b[c+11>>0]|0;j=i<<24>>24<0;j6b(a,j?f[c>>2]|0:c,j?f[c+4>>2]|0:i&255)|0}else{k6b(a,489103)|0;i=f[d+4>>2]|0;d=b[i+11>>0]|0;c=d<<24>>24<0;j6b(a,c?f[i>>2]|0:i,c?f[i+4>>2]|0:d&255)|0;k6b(a,489101)|0}if((e|0)==-1){k6b(a,489392)|0;u=g;return}k6b(a,475696)|0;vSb(h,e);e=h+11|0;d=b[e>>0]|0;i=d<<24>>24<0;j6b(a,i?f[h>>2]|0:h,i?f[h+4>>2]|0:d&255)|0;if((b[e>>0]|0)<0)O5b(f[h>>2]|0);k6b(a,489150)|0;k6b(a,489392)|0;u=g;return}function hOb(a,b,c,d,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;iOb(a,b,c,d,e,g,h,i,j,k,l,m);return}function iOb(a,c,d,e,g,h,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;o=u;u=u+128|0;p=o+76|0;q=o+40|0;r=o+64|0;s=o+24|0;t=o+121|0;v=o;w=o+120|0;f[p>>2]=d;f[p+4>>2]=e;f[p+8>>2]=g;f[p+12>>2]=h;f[p+16>>2]=i;f[p+20>>2]=j;f[p+24>>2]=k;f[p+28>>2]=l;f[p+32>>2]=m;f[p+36>>2]=n;f[p+40>>2]=0;n=0;m=0;a:while(1){b:do switch(b[c+m>>0]|0){case 0:{x=32;break a;break}case 36:{l=m+1|0;k=b[c+l>>0]|0;if((k+-48&255)<10){y=(k<<24>>24)+-48|0;j=f[(f[p+(y<<2)>>2]|0)+4>>2]|0;if((j|0)==-1){x=5;break a}else{z=l;A=j;break b}}else if(k<<24>>24==36){z=l;A=1;break b}else{x=20;break a}break}default:{z=m;A=1}}while(0);n=A+n|0;m=z+1|0}if((x|0)==5){zpb(q,2,475429,84);z=vpb(ypb(vpb(q,475527)|0,y)|0,475583)|0;y=0;m=d;while(1){if((f[m+4>>2]|0)==-1){B=y;break}d=y+1|0;m=f[p+(d<<2)>>2]|0;if(!m){B=d;break}else y=d}y=vpb(ypb(z,B)|0,475596)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;B=kUb(c)|0;if(B>>>0>4294967279)V5b(s);if(B>>>0<11){b[s+11>>0]=B;if(!B)C=s;else{D=s;x=13}}else{z=B+16&-16;m=L5b(z)|0;f[s>>2]=m;f[s+8>>2]=z|-2147483648;f[s+4>>2]=B;D=m;x=13}if((x|0)==13){Vac(D|0,c|0,B|0)|0;C=D}b[C+B>>0]=0;pSb(r,s);xpb(t,vpb(wpb(y,r)|0,476219)|0);if((b[r+11>>0]|0)<0)O5b(f[r>>2]|0);if((b[s+11>>0]|0)<0)O5b(f[s>>2]|0);Apb(q);u=o;return}else if((x|0)==20){zpb(v,2,475429,97);q=vpb(v,475641)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;y=kUb(c)|0;if(y>>>0>4294967279)V5b(s);if(y>>>0<11){b[s+11>>0]=y;if(!y)E=s;else{F=s;x=25}}else{t=y+16&-16;B=L5b(t)|0;f[s>>2]=B;f[s+8>>2]=t|-2147483648;f[s+4>>2]=y;F=B;x=25}if((x|0)==25){Vac(F|0,c|0,y|0)|0;E=F}b[E+y>>0]=0;pSb(r,s);xpb(w,vpb(wpb(q,r)|0,476219)|0);if((b[r+11>>0]|0)<0)O5b(f[r>>2]|0);if((b[s+11>>0]|0)<0)O5b(f[s>>2]|0);Apb(v);u=o;return}else if((x|0)==32){if(!n){u=o;return}x=a+11|0;v=b[x>>0]|0;if(v<<24>>24<0)G=f[a+4>>2]|0;else G=v&255;e6b(a,G+n|0,0);n=b[x>>0]|0;x=n<<24>>24<0;if(x)H=f[a+4>>2]|0;else H=n&255;do if(H)if(x){I=f[a>>2]|0;break}else{I=a;break}else I=0;while(0);a=0;x=I+G|0;c:while(1){G=b[c+a>>0]|0;d:do switch(G<<24>>24){case 0:{break c;break}case 36:{I=a+1|0;H=b[c+I>>0]|0;if((H+-48&255)<10){n=f[p+((H<<24>>24)+-48<<2)>>2]|0;v=n+4|0;Vac(x|0,f[n>>2]|0,f[v>>2]|0)|0;J=I;K=x+(f[v>>2]|0)|0;break d}if(H<<24>>24==36){b[x>>0]=36;J=I;K=x+1|0}else{J=a;K=x}break}default:{b[x>>0]=G;J=a;K=x+1|0}}while(0);a=J+1|0;x=K}u=o;return}}function jOb(a){a=a|0;return}function kOb(a){a=a|0;O5b(a);return}function lOb(a,c,d){a=a|0;c=c|0;d=d|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=d?4:5;b[a+11>>0]=c;Vac(a|0,(d?490309:490303)|0,c|0)|0;b[a+c>>0]=0;return}function mOb(a,b,c){a=a|0;b=b|0;c=c|0;vSb(a,c);return}function nOb(a,b,c){a=a|0;b=b|0;c=c|0;wSb(a,c);return}function oOb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;xSb(a,c,d);return}function pOb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ySb(a,c,d);return}function qOb(a,b,c){a=a|0;b=b|0;c=+c;BSb(a,c);return}function rOb(a,b,c){a=a|0;b=b|0;c=+c;zSb(a,c);return}function sOb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;c=u;u=u+16|0;e=c+8|0;g=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=1;b[a>>0]=34;b[a+1>>0]=0;h=b[d+11>>0]|0;i=h<<24>>24<0;f[g>>2]=i?f[d>>2]|0:d;f[g+4>>2]=i?f[d+4>>2]|0:h&255;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];oSb(e,a);l6b(a,34);u=c;return}function tOb(a,b,c){a=a|0;b=b|0;c=c|0;_h[f[(f[b>>2]|0)+36>>2]&255](a,b,c);return}function uOb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;X5b(a,d);return}function vOb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;e=u;u=u+128|0;d=e+80|0;c=e+40|0;h=e;if(!(b[g+40>>0]|0))if((f[g+32>>2]|0)==10){X5b(a,f[f[g+60>>2]>>2]|0);u=e;return}else{X5b(a,f[g>>2]|0);u=e;return}if(((b[(f[(f[g+48>>2]|0)+16>>2]|0)+48>>0]|0?(f[g+32>>2]|0)==11:0)?(f[g+36>>2]|0)==1:0)?(i=f[g+56>>2]|0,(i|0)==(f[g+60>>2]|0)):0){f[d>>2]=475696;f[d+4>>2]=1;j=f[i+4>>2]|0;i=b[j+11>>0]|0;k=i<<24>>24<0;f[c>>2]=k?f[j>>2]|0:j;f[c+4>>2]=k?f[j+4>>2]|0:i&255;f[h>>2]=489150;f[h+4>>2]=1;HSb(a,d,c,h);u=e;return}f[d>>2]=475696;f[d+4>>2]=1;i=f[g+4>>2]|0;g=b[i+11>>0]|0;j=g<<24>>24<0;f[c>>2]=j?f[i>>2]|0:i;f[c+4>>2]=j?f[i+4>>2]|0:g&255;f[h>>2]=489150;f[h+4>>2]=1;HSb(a,d,c,h);u=e;return}function wOb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;g=h?475688:475692;h=a+4|0;f[h>>2]=0;f[h+4>>2]=0;b[a+11>>0]=3;b[a>>0]=b[g>>0]|0;b[a+1>>0]=b[g+1>>0]|0;b[a+2>>0]=b[g+2>>0]|0;b[a+3>>0]=0;return}function xOb(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=2;d[a>>1]=i?8317:2685;b[a+2>>0]=0;return}function yOb(a){a=a|0;return}function zOb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=a+28|0;c=f[b>>2]|0;d=a+32|0;if((c|0)!=(d|0)){e=c;while(1){c=f[e+20>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[e+4>>2]|0;if(!c){g=e+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(e|0))i=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;j=f[h>>2]|0}while((f[j>>2]|0)!=(g|0));i=j}}else{h=c;while(1){j=f[h>>2]|0;if(!j)break;else h=j}i=h}if((i|0)==(d|0))break;else e=i}}AOb(b,f[d>>2]|0);f[a+36>>2]=0;f[b>>2]=d;f[d>>2]=0;AOb(b,0);b=f[a+24>>2]|0;if(!b)return;bi[f[(f[b>>2]|0)+4>>2]&2047](b);return}function AOb(a,b){a=a|0;b=b|0;if(!b)return;else{AOb(a,f[b>>2]|0);AOb(a,f[b+4>>2]|0);O5b(b);return}}function BOb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+16|0;g=e;zh[f[(f[c>>2]|0)+96>>2]&2047](g,c);h=f[g>>2]|0;i=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;j=f[h+4>>2]|0;h=kUb(481720)|0;k=b[j+11>>0]|0;if((((h|0)==((k<<24>>24<0?f[j+4>>2]|0:k&255)|0)?(u6b(j,0,-1,481720,h)|0)==0:0)?b[a+9>>0]|0:0)?COb(a,c,d)|0:0){u=e;return}f[g>>2]=0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;_h[f[(f[i>>2]|0)+64>>2]&255](i,c,g);if(b[a+8>>0]|0)DOb(f[g>>2]|0,f[h>>2]|0);j=f[g>>2]|0;k=j;if((f[h>>2]|0)==(j|0))l=k;else{j=0;m=k;while(1){EOb(a,c,i,f[m+(j<<2)>>2]|0,d);j=j+1|0;k=f[g>>2]|0;n=k;if(j>>>0>=(f[h>>2]|0)-k>>2>>>0){l=n;break}else m=n}}if(!(b[a+7>>0]|0)){FOb(a,Uh[f[(f[i>>2]|0)+8>>2]&1023](i,c)|0,d);o=f[g>>2]|0}else o=l;if(o|0){l=f[h>>2]|0;if((l|0)!=(o|0))f[h>>2]=l+(~((l+-4-o|0)>>>2)<<2);O5b(o)}u=e;return}function COb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=u;u=u+256|0;g=e+224|0;h=e+220|0;i=e+216|0;j=e+204|0;k=e+192|0;l=e+168|0;m=e+245|0;n=e+156|0;o=e+80|0;p=e+244|0;q=e+144|0;r=e+104|0;s=e+40|0;t=e;if(!(KSb(c,h,i)|0)){v=0;u=e;return v|0}w=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;th[f[(f[w>>2]|0)+96>>2]&511](j,w,c,f[h>>2]|0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;do if(JSb(j,k)|0){zh[f[(f[c>>2]|0)+96>>2]&2047](g,c);h=jub(f[(f[(f[g>>2]|0)+8>>2]|0)+8>>2]|0,k)|0;if(!h){zpb(l,1,475815,1582);xpb(m,vpb(wpb(vpb(l,476004)|0,j)|0,476016)|0);Apb(l);x=0;break}rFb(g);y=pFb(g,h)|0;h=di[f[(f[y>>2]|0)+12>>2]&1023](y)|0;th[f[(f[w>>2]|0)+96>>2]&511](n,w,c,f[i>>2]|0);if(Uob(h,n)|0){f[r>>2]=475696;f[r+4>>2]=1;y=b[j+11>>0]|0;z=y<<24>>24<0;f[s>>2]=z?f[j>>2]|0:j;f[s+4>>2]=z?f[j+4>>2]|0:y&255;f[t>>2]=489150;f[t+4>>2]=1;HSb(q,r,s,t);y=q+11|0;z=b[y>>0]|0;A=z<<24>>24<0;B=A?f[q>>2]|0:q;C=A?f[q+4>>2]|0:z&255;if(!C)D=0;else{z=d+12|0;A=0;E=0;while(1){F=E;E=E+1|0;if((b[B+F>>0]|0)==10){GOb(d,B+A|0,E-A|0);b[z>>0]=1;G=E}else G=A;if((E|0)==(C|0)){D=G;break}else A=G}}GOb(d,B+D|0,C-D|0);if((b[y>>0]|0)<0)O5b(f[q>>2]|0);A=f[a+24>>2]|0;E=a+32|0;z=f[E>>2]|0;if(z){F=f[i>>2]|0;H=E;I=z;a:while(1){z=I;while(1){if((f[z+16>>2]|0)>>>0>=F>>>0)break;J=f[z+4>>2]|0;if(!J){K=H;break a}else z=J}I=f[z>>2]|0;if(!I){K=z;break}else H=z}if((K|0)!=(E|0)?F>>>0>=(f[K+16>>2]|0)>>>0:0)L=f[K+20>>2]|0;else L=A}else L=A;H=a+4|0;Wg[f[(f[L>>2]|0)+52>>2]&127](q,L,c,-1,0,(b[H>>0]|0)!=0);I=q+11|0;y=b[I>>0]|0;C=y<<24>>24<0;B=C?f[q>>2]|0:q;J=C?f[q+4>>2]|0:y&255;if(!J)M=0;else{y=d+12|0;C=0;N=0;while(1){O=N;N=N+1|0;if((b[B+O>>0]|0)==10){GOb(d,B+C|0,N-C|0);b[y>>0]=1;P=N}else P=C;if((N|0)==(J|0)){M=P;break}else C=P}}GOb(d,B+M|0,J-M|0);if((b[I>>0]|0)<0)O5b(f[q>>2]|0);k6b(d+16|0,475796)|0;BOb(a,h,d);HOb(d);Wg[f[(f[L>>2]|0)+56>>2]&127](q,L,c,-1,0,(b[H>>0]|0)!=0);C=q+11|0;N=b[C>>0]|0;y=N<<24>>24<0;A=y?f[q>>2]|0:q;F=y?f[q+4>>2]|0:N&255;if(!F)Q=0;else{N=d+12|0;y=0;E=0;while(1){O=E;E=E+1|0;if((b[A+O>>0]|0)==10){GOb(d,A+y|0,E-y|0);b[N>>0]=1;R=E}else R=y;if((E|0)==(F|0)){Q=R;break}else y=R}}GOb(d,A+Q|0,F-Q|0);if((b[C>>0]|0)<0)O5b(f[q>>2]|0);S=1}else{zpb(o,1,475815,1590);xpb(p,vpb(wpb(o,j)|0,476027)|0);Apb(o);S=0}if((b[n+11>>0]|0)<0)O5b(f[n>>2]|0);if(h|0)bi[f[(f[h>>2]|0)+4>>2]&2047](h);nFb(g);x=S}else x=0;while(0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);v=x;u=e;return v|0}function DOb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;d=a;a=c;a:while(1){c=a;e=a+-4|0;g=d;while(1){h=g;b:while(1){i=h;j=c-i|0;k=j>>2;switch(k|0){case 2:{l=5;break a;break}case 3:{l=17;break a;break}case 4:{l=18;break a;break}case 5:{l=19;break a;break}case 1:case 0:{l=207;break a;break}default:{}}if((j|0)<124){l=21;break a}m=h+(((k|0)/2|0)<<2)|0;if((j|0)>3996){j=(k|0)/4|0;n=TOb(h,h+(j<<2)|0,m,m+(j<<2)|0,e)|0}else n=ROb(h,m,e)|0;j=f[h>>2]|0;k=f[m>>2]|0;o=(b[j+40>>0]|0)==0;p=j;do if(!o){q=f[j+56>>2]|0;if(!q){r=(f[j+24>>2]|0)+72|0;break}else{r=q+68|0;break}}else r=(f[j+48>>2]|0)+28|0;while(0);q=p-(f[r>>2]|0)|0;s=(b[k+40>>0]|0)==0;t=k;do if(!s){u=f[k+56>>2]|0;if(!u){v=(f[k+24>>2]|0)+72|0;break}else{v=u+68|0;break}}else v=(f[k+48>>2]|0)+28|0;while(0);if((q|0)<(t-(f[v>>2]|0)|0)){w=e;x=n;break}u=k+48|0;y=k+56|0;z=k+24|0;A=e;while(1){A=A+-4|0;if((h|0)==(A|0))break;B=f[A>>2]|0;C=B;do if(b[B+40>>0]|0){D=f[B+56>>2]|0;if(!D){E=(f[B+24>>2]|0)+72|0;break}else{E=D+68|0;break}}else E=(f[B+48>>2]|0)+28|0;while(0);B=C-(f[E>>2]|0)|0;do if(!s){D=f[y>>2]|0;if(!D){F=(f[z>>2]|0)+72|0;break}else{F=D+68|0;break}}else F=(f[u>>2]|0)+28|0;while(0);if((B|0)<(t-(f[F>>2]|0)|0)){l=149;break b}}t=h+4|0;u=f[e>>2]|0;z=u;do if(!o){y=f[j+56>>2]|0;if(!y){G=(f[j+24>>2]|0)+72|0;break}else{G=y+68|0;break}}else G=(f[j+48>>2]|0)+28|0;while(0);y=p-(f[G>>2]|0)|0;do if(b[u+40>>0]|0){s=f[u+56>>2]|0;if(!s){H=(f[u+24>>2]|0)+72|0;break}else{H=s+68|0;break}}else H=(f[u+48>>2]|0)+28|0;while(0);if((y|0)<(z-(f[H>>2]|0)|0))I=t;else{if((t|0)==(e|0)){l=207;break a}u=j+24|0;c:do if(o){s=p-(f[(f[j+48>>2]|0)+28>>2]|0)|0;k=t;while(1){q=f[k>>2]|0;D=q;do if(b[q+40>>0]|0){J=f[q+56>>2]|0;if(!J){K=(f[q+24>>2]|0)+72|0;break}else{K=J+68|0;break}}else K=(f[q+48>>2]|0)+28|0;while(0);if((s|0)<(D-(f[K>>2]|0)|0)){L=k;break c}k=k+4|0;if((k|0)==(e|0)){l=207;break a}}}else{k=f[j+56>>2]|0;s=(k|0)==0;B=k+68|0;k=t;while(1){q=f[k>>2]|0;if(s)M=(f[u>>2]|0)+72|0;else M=B;J=p-(f[M>>2]|0)|0;N=q;do if(b[q+40>>0]|0){O=f[q+56>>2]|0;if(!O){P=(f[q+24>>2]|0)+72|0;break}else{P=O+68|0;break}}else P=(f[q+48>>2]|0)+28|0;while(0);if((J|0)<(N-(f[P>>2]|0)|0)){L=k;break c}k=k+4|0;if((k|0)==(e|0)){l=207;break a}}}while(0);u=f[L>>2]|0;f[L>>2]=z;f[e>>2]=u;I=L+4|0}if((I|0)==(e|0)){l=207;break a}else{Q=e;R=I}while(1){u=f[h>>2]|0;t=(b[u+40>>0]|0)==0;j=u;o=u+48|0;y=u+56|0;k=u+24|0;if(t){u=j-(f[(f[o>>2]|0)+28>>2]|0)|0;B=R;while(1){s=f[B>>2]|0;q=s;do if(b[s+40>>0]|0){D=f[s+56>>2]|0;if(!D){S=(f[s+24>>2]|0)+72|0;break}else{S=D+68|0;break}}else S=(f[s+48>>2]|0)+28|0;while(0);if((u|0)<(q-(f[S>>2]|0)|0)){T=B;break}else B=B+4|0}}else{B=f[y>>2]|0;u=(B|0)==0;s=B+68|0;B=R;while(1){N=f[B>>2]|0;if(u)U=(f[k>>2]|0)+72|0;else U=s;J=j-(f[U>>2]|0)|0;D=N;do if(b[N+40>>0]|0){O=f[N+56>>2]|0;if(!O){V=(f[N+24>>2]|0)+72|0;break}else{V=O+68|0;break}}else V=(f[N+48>>2]|0)+28|0;while(0);if((J|0)<(D-(f[V>>2]|0)|0)){T=B;break}else B=B+4|0}}if(t){B=j-(f[(f[o>>2]|0)+28>>2]|0)|0;s=Q;while(1){u=s+-4|0;N=f[u>>2]|0;q=N;do if(b[N+40>>0]|0){O=f[N+56>>2]|0;if(!O){W=(f[N+24>>2]|0)+72|0;break}else{W=O+68|0;break}}else W=(f[N+48>>2]|0)+28|0;while(0);if((B|0)<(q-(f[W>>2]|0)|0))s=u;else{X=u;break}}}else{s=f[y>>2]|0;B=(s|0)==0;o=s+68|0;s=Q;while(1){t=s+-4|0;N=f[t>>2]|0;if(B)Y=(f[k>>2]|0)+72|0;else Y=o;D=j-(f[Y>>2]|0)|0;J=N;do if(b[N+40>>0]|0){O=f[N+56>>2]|0;if(!O){Z=(f[N+24>>2]|0)+72|0;break}else{Z=O+68|0;break}}else Z=(f[N+48>>2]|0)+28|0;while(0);if((D|0)<(J-(f[Z>>2]|0)|0))s=t;else{X=t;break}}}if(T>>>0>=X>>>0){h=T;continue b}s=f[T>>2]|0;f[T>>2]=f[X>>2];f[X>>2]=s;Q=X;R=T+4|0}}if((l|0)==149){l=0;f[h>>2]=C;f[A>>2]=p;w=A;x=n+1|0}z=h+4|0;d:do if(z>>>0<w>>>0){s=m;j=w;o=z;k=x;while(1){B=f[s>>2]|0;y=(b[B+40>>0]|0)==0;N=B;u=B+48|0;q=B+56|0;O=B+24|0;if(y){B=N-(f[(f[u>>2]|0)+28>>2]|0)|0;_=o;while(1){$=f[_>>2]|0;aa=$;do if(b[$+40>>0]|0){ba=f[$+56>>2]|0;if(!ba){ca=(f[$+24>>2]|0)+72|0;break}else{ca=ba+68|0;break}}else ca=(f[$+48>>2]|0)+28|0;while(0);if((aa-(f[ca>>2]|0)|0)<(B|0))_=_+4|0;else{da=_;break}}}else{_=f[q>>2]|0;B=(_|0)==0;$=_+68|0;_=o;while(1){t=f[_>>2]|0;J=t;do if(b[t+40>>0]|0){D=f[t+56>>2]|0;if(!D){ea=(f[t+24>>2]|0)+72|0;break}else{ea=D+68|0;break}}else ea=(f[t+48>>2]|0)+28|0;while(0);if(B)fa=(f[O>>2]|0)+72|0;else fa=$;if((J-(f[ea>>2]|0)|0)<(N-(f[fa>>2]|0)|0))_=_+4|0;else{da=_;break}}}if(y){_=N-(f[(f[u>>2]|0)+28>>2]|0)|0;$=j;while(1){B=$+-4|0;t=f[B>>2]|0;aa=t;do if(b[t+40>>0]|0){D=f[t+56>>2]|0;if(!D){ga=(f[t+24>>2]|0)+72|0;break}else{ga=D+68|0;break}}else ga=(f[t+48>>2]|0)+28|0;while(0);if((aa-(f[ga>>2]|0)|0)<(_|0)){ha=B;break}else $=B}}else{$=f[q>>2]|0;_=($|0)==0;u=$+68|0;$=j;while(1){y=$+-4|0;t=f[y>>2]|0;J=t;do if(b[t+40>>0]|0){D=f[t+56>>2]|0;if(!D){ia=(f[t+24>>2]|0)+72|0;break}else{ia=D+68|0;break}}else ia=(f[t+48>>2]|0)+28|0;while(0);if(_)ja=(f[O>>2]|0)+72|0;else ja=u;if((J-(f[ia>>2]|0)|0)<(N-(f[ja>>2]|0)|0)){ha=y;break}else $=y}}if(da>>>0>ha>>>0){ka=s;la=k;ma=da;break d}$=f[da>>2]|0;f[da>>2]=f[ha>>2];f[ha>>2]=$;s=(s|0)==(da|0)?ha:s;j=ha;o=da+4|0;k=k+1|0}}else{ka=m;la=x;ma=z}while(0);if((ma|0)!=(ka|0)){z=f[ka>>2]|0;k=f[ma>>2]|0;o=z;j=k;do if(b[z+40>>0]|0){s=f[z+56>>2]|0;if(!s){na=(f[z+24>>2]|0)+72|0;break}else{na=s+68|0;break}}else na=(f[z+48>>2]|0)+28|0;while(0);z=o-(f[na>>2]|0)|0;do if(b[k+40>>0]|0){s=f[k+56>>2]|0;if(!s){oa=(f[k+24>>2]|0)+72|0;break}else{oa=s+68|0;break}}else oa=(f[k+48>>2]|0)+28|0;while(0);if((z|0)<(j-(f[oa>>2]|0)|0)){f[ma>>2]=o;f[ka>>2]=j;pa=la+1|0}else pa=la}else pa=la;if(!pa){qa=UOb(h,ma)|0;k=ma+4|0;if(UOb(k,a)|0){l=206;break}if(qa){g=k;continue}}k=ma;if((k-i|0)>=(c-k|0)){l=205;break}DOb(h,ma);g=ma+4|0}if((l|0)==205){l=0;DOb(ma+4|0,a);d=h;a=ma;continue}else if((l|0)==206){l=0;if(qa){l=207;break}else{d=h;a=ma;continue}}}if((l|0)==5){ma=f[e>>2]|0;d=f[h>>2]|0;qa=ma;i=d;do if(b[ma+40>>0]|0){pa=f[ma+56>>2]|0;if(!pa){ra=(f[ma+24>>2]|0)+72|0;break}else{ra=pa+68|0;break}}else ra=(f[ma+48>>2]|0)+28|0;while(0);ma=qa-(f[ra>>2]|0)|0;do if(b[d+40>>0]|0){ra=f[d+56>>2]|0;if(!ra){sa=(f[d+24>>2]|0)+72|0;break}else{sa=ra+68|0;break}}else sa=(f[d+48>>2]|0)+28|0;while(0);if((ma|0)>=(i-(f[sa>>2]|0)|0))return;f[h>>2]=qa;f[e>>2]=i;return}else if((l|0)==17){ROb(h,h+4|0,e)|0;return}else if((l|0)==18){SOb(h,h+4|0,h+8|0,e)|0;return}else if((l|0)==19){TOb(h,h+4|0,h+8|0,h+12|0,e)|0;return}else if((l|0)==21){e=h+8|0;ROb(h,h+4|0,e)|0;i=h+12|0;if((i|0)==(a|0))return;else{ta=i;ua=e}while(1){e=f[ta>>2]|0;i=f[ua>>2]|0;qa=(b[e+40>>0]|0)==0;sa=e;do if(!qa){ma=f[e+56>>2]|0;if(!ma){va=(f[e+24>>2]|0)+72|0;break}else{va=ma+68|0;break}}else va=(f[e+48>>2]|0)+28|0;while(0);ma=sa-(f[va>>2]|0)|0;d=i;do if(b[i+40>>0]|0){ra=f[i+56>>2]|0;if(!ra){wa=(f[i+24>>2]|0)+72|0;break}else{wa=ra+68|0;break}}else wa=(f[i+48>>2]|0)+28|0;while(0);if((ma|0)<(d-(f[wa>>2]|0)|0)){i=e+48|0;ra=e+56|0;pa=e+24|0;e:do if(qa){la=ua;ka=ta;while(1){f[ka>>2]=f[la>>2];if((la|0)==(h|0)){xa=la;break e}oa=la+-4|0;na=f[oa>>2]|0;x=sa-(f[(f[i>>2]|0)+28>>2]|0)|0;m=na;do if(b[na+40>>0]|0){da=f[na+56>>2]|0;if(!da){ya=(f[na+24>>2]|0)+72|0;break}else{ya=da+68|0;break}}else ya=(f[na+48>>2]|0)+28|0;while(0);if((x|0)<(m-(f[ya>>2]|0)|0)){na=la;la=oa;ka=na}else{xa=la;break}}}else{la=ua;ka=ta;while(1){f[ka>>2]=f[la>>2];if((la|0)==(h|0)){xa=la;break e}j=la+-4|0;o=f[j>>2]|0;z=f[ra>>2]|0;if(!z)za=(f[pa>>2]|0)+72|0;else za=z+68|0;z=sa-(f[za>>2]|0)|0;na=o;do if(b[o+40>>0]|0){da=f[o+56>>2]|0;if(!da){Aa=(f[o+24>>2]|0)+72|0;break}else{Aa=da+68|0;break}}else Aa=(f[o+48>>2]|0)+28|0;while(0);if((z|0)<(na-(f[Aa>>2]|0)|0)){o=la;la=j;ka=o}else{xa=la;break}}}while(0);f[xa>>2]=sa}pa=ta+4|0;if((pa|0)==(a|0))break;else{ra=ta;ta=pa;ua=ra}}return}else if((l|0)==207)return}function EOb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;h=u;u=u+48|0;i=h+28|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h;n=h+4|0;o=e+36|0;p=(f[o>>2]|0)==3;if(!(b[a+6>>0]|0))if(p)q=6;else q=7;else if(p)if(((f[136e3+(f[e+32>>2]<<2)>>2]|0)+-9|0)>>>0<2)q=6;else{IOb(a,c,d,e,g);u=h;return}else q=7;if((q|0)==6)r=li[f[(f[d>>2]|0)+24>>2]&511](d,c,e)|0;else if((q|0)==7)r=(li[f[(f[d>>2]|0)+20>>2]&511](d,c,e)|0)&1;f[n>>2]=0;q=n+4|0;f[q>>2]=0;f[n+8>>2]=0;if(xub(e)|0){p=Xf[f[(f[d>>2]|0)+328>>2]&127](d,c,e,10,-1,0)|0;s=p+12|0;t=f[s>>2]|0;v=p+4|0;p=f[v>>2]|0;if(p|0){w=n+8|0;x=(t|0)==0?0:t+4|0;t=p;while(1){p=f[q>>2]|0;if((p|0)==(f[w>>2]|0)){JOb(n,x);y=f[v>>2]|0}else{f[p>>2]=f[x>>2];f[q>>2]=(f[q>>2]|0)+4;y=t}x=x+4|0;p=f[s>>2]|0;if((x|0)==(((p|0)==0?0:p+4|0)+(y<<2)|0))break;else t=y}}y=f[n>>2]|0;t=f[q>>2]|0;f[m>>2]=f[(f[e+60>>2]|0)+28>>2];x=t-y|0;s=x>>2;if((x|0)>512){x=(s|0)<536870911?s:536870911;while(1){v=M5b(x<<2,1124529)|0;if(v|0){z=v;A=x;break}x=x>>>1;if(!x){z=0;A=0;break}}B=z;C=A;D=z}else{B=0;C=0;D=0}f[k>>2]=y;f[l>>2]=t;f[j>>2]=f[k>>2];f[i>>2]=f[l>>2];KOb(j,i,m,s,B,C);if(B|0)O5b(D)}if((r|0)>0){D=e+32|0;B=a+24|0;C=a+32|0;s=a+4|0;m=i+11|0;j=i+4|0;l=g+16|0;k=i+11|0;t=i+4|0;y=g+12|0;z=0;do{A=(f[o>>2]|0)==3?z:-1;LOb(a,c,d,e,g);do if((f[136e3+(f[D>>2]<<2)>>2]|0)==10){x=f[B>>2]|0;v=f[C>>2]|0;if(v){w=C;p=v;a:while(1){v=p;while(1){if((f[v+16>>2]|0)>>>0>=e>>>0)break;E=f[v+4>>2]|0;if(!E){F=w;break a}else v=E}p=f[v>>2]|0;if(!p){F=v;break}else w=v}if((F|0)!=(C|0)?(f[F+16>>2]|0)>>>0<=e>>>0:0)G=f[F+20>>2]|0;else G=x}else G=x;do if((f[o>>2]|0)==3)if(xub(e)|0){H=f[(f[n>>2]|0)+(z<<2)>>2]|0;break}else{H=Dg[f[(f[d>>2]|0)+208>>2]&127](d,c,e,z)|0;break}else H=Dg[f[(f[d>>2]|0)+108>>2]&127](d,c,e,0)|0;while(0);Wg[f[(f[G>>2]|0)+52>>2]&127](i,G,H,A,r,(b[s>>0]|0)!=0);x=b[m>>0]|0;w=x<<24>>24<0;p=w?f[i>>2]|0:i;E=w?f[j>>2]|0:x&255;if(!E)I=0;else{x=0;w=0;while(1){J=w;w=w+1|0;if((b[p+J>>0]|0)==10){GOb(g,p+x|0,w-x|0);b[y>>0]=1;K=w}else K=x;if((w|0)==(E|0)){I=K;break}else x=K}}GOb(g,p+I|0,E-I|0);if((b[m>>0]|0)<0)O5b(f[i>>2]|0);k6b(l,475796)|0;BOb(a,H,g);HOb(g);Wg[f[(f[G>>2]|0)+56>>2]&127](i,G,H,A,r,(b[s>>0]|0)!=0);x=b[k>>0]|0;w=x<<24>>24<0;J=w?f[i>>2]|0:i;L=w?f[t>>2]|0:x&255;if(!L)M=0;else{x=0;w=0;while(1){N=w;w=w+1|0;if((b[J+N>>0]|0)==10){GOb(g,J+x|0,w-x|0);b[y>>0]=1;O=w}else O=x;if((w|0)==(L|0)){M=O;break}else x=O}}GOb(g,J+M|0,L-M|0);if((b[k>>0]|0)<0)O5b(f[i>>2]|0)}else{GOb(g,475786,2);MOb(a,c,d,e,A,g);if(!(b[s>>0]|0)){GOb(g,475789,1);b[y>>0]=1;GOb(g,475790,0);break}else{GOb(g,489135,1);break}}while(0);z=z+1|0}while((z|0)<(r|0))}r=f[n>>2]|0;if(r|0){n=f[q>>2]|0;if((n|0)!=(r|0))f[q>>2]=n+(~((n+-4-r|0)>>>2)<<2);O5b(r)}u=h;return}function FOb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;e=u;u=u+128|0;g=e+32|0;h=e+108|0;i=e+96|0;j=e+48|0;k=e+16|0;l=e;m=e+88|0;n=h+11|0;o=h+4|0;p=g+11|0;q=g+4|0;r=a+4|0;s=d+12|0;t=k+8|0;v=j+4|0;w=i+11|0;x=i+4|0;y=i+8|0;z=l+8|0;A=j+4|0;B=i+11|0;C=i+4|0;D=i+8|0;E=j+11|0;F=j+3|0;G=m+4|0;H=j+4|0;I=d+16|0;J=j+4|0;K=0;a:while(1){L=f[c>>2]|0;if(!L)M=0;else M=(f[L+4>>2]|0)-(f[L>>2]|0)>>4;if((K|0)>=(M|0)){N=5;break}O=f[L>>2]|0;vSb(h,f[O+(K<<4)>>2]|0);b:do switch(f[O+(K<<4)+4>>2]|0){case 0:{L=b[n>>0]|0;P=L<<24>>24<0;Q=P?f[h>>2]|0:h;R=P?f[o>>2]|0:L&255;if(!R)S=0;else{L=0;P=0;while(1){T=P;P=P+1|0;if((b[Q+T>>0]|0)==10){GOb(d,Q+L|0,P-L|0);b[s>>0]=1;U=P}else U=L;if((P|0)==(R|0)){S=U;break}else L=U}}GOb(d,Q+S|0,R-S|0);GOb(d,475786,2);L=O+(K<<4)+8|0;ySb(g,f[L>>2]|0,f[L+4>>2]|0);L=b[p>>0]|0;P=L<<24>>24<0;T=P?f[g>>2]|0:g;V=P?f[q>>2]|0:L&255;if(!V)W=0;else{L=0;P=0;while(1){X=P;P=P+1|0;if((b[T+X>>0]|0)==10){GOb(d,T+L|0,P-L|0);b[s>>0]=1;Y=P}else Y=L;if((P|0)==(V|0)){W=Y;break}else L=Y}}GOb(d,T+W|0,V-W|0);if((b[p>>0]|0)<0)O5b(f[g>>2]|0);if(!(b[r>>0]|0)){GOb(d,475789,1);b[s>>0]=1;GOb(d,475790,0);break b}else{GOb(d,489135,1);break b}break}case 1:{L=b[n>>0]|0;P=L<<24>>24<0;R=P?f[h>>2]|0:h;Q=P?f[o>>2]|0:L&255;if(!Q)Z=0;else{L=0;P=0;while(1){X=P;P=P+1|0;if((b[R+X>>0]|0)==10){GOb(d,R+L|0,P-L|0);b[s>>0]=1;_=P}else _=L;if((P|0)==(Q|0)){Z=_;break}else L=_}}GOb(d,R+Z|0,Q-Z|0);GOb(d,475791,4);L=f[O+(K<<4)+8>>2]|0;f[t>>2]=8;P=k;f[P>>2]=L;f[P+4>>2]=0;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];f[g+8>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];GSb(j,g);P=f[j>>2]|0;L=f[v>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(L>>>0>4294967279){N=25;break a}if(L>>>0<11){b[w>>0]=L;if(!L)$=i;else{aa=i;N=29}}else{V=L+16&-16;T=L5b(V)|0;f[i>>2]=T;f[y>>2]=V|-2147483648;f[x>>2]=L;aa=T;N=29}if((N|0)==29){N=0;Vac(aa|0,P|0,L|0)|0;$=aa}b[$+L>>0]=0;L=b[w>>0]|0;P=L<<24>>24<0;T=P?f[i>>2]|0:i;V=P?f[x>>2]|0:L&255;if(!V)ba=0;else{L=0;P=0;while(1){X=P;P=P+1|0;if((b[T+X>>0]|0)==10){GOb(d,T+L|0,P-L|0);b[s>>0]=1;ca=P}else ca=L;if((P|0)==(V|0)){ba=ca;break}else L=ca}}GOb(d,T+ba|0,V-ba|0);if((b[w>>0]|0)<0)O5b(f[i>>2]|0);if(!(b[r>>0]|0)){GOb(d,475789,1);b[s>>0]=1;GOb(d,475790,0);break b}else{GOb(d,489135,1);break b}break}case 2:{L=b[n>>0]|0;P=L<<24>>24<0;Q=P?f[h>>2]|0:h;R=P?f[o>>2]|0:L&255;if(!R)da=0;else{L=0;P=0;while(1){X=P;P=P+1|0;if((b[Q+X>>0]|0)==10){GOb(d,Q+L|0,P-L|0);b[s>>0]=1;ea=P}else ea=L;if((P|0)==(R|0)){da=ea;break}else L=ea}}GOb(d,Q+da|0,R-da|0);GOb(d,475791,4);L=O+(K<<4)+8|0;P=f[L>>2]|0;V=f[L+4>>2]|0;f[z>>2]=16;L=l;f[L>>2]=P;f[L+4>>2]=V;f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];f[g+8>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];GSb(j,g);V=f[j>>2]|0;L=f[A>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(L>>>0>4294967279){N=44;break a}if(L>>>0<11){b[B>>0]=L;if(!L)fa=i;else{ga=i;N=48}}else{P=L+16&-16;T=L5b(P)|0;f[i>>2]=T;f[D>>2]=P|-2147483648;f[C>>2]=L;ga=T;N=48}if((N|0)==48){N=0;Vac(ga|0,V|0,L|0)|0;fa=ga}b[fa+L>>0]=0;L=b[B>>0]|0;V=L<<24>>24<0;T=V?f[i>>2]|0:i;P=V?f[C>>2]|0:L&255;if(!P)ha=0;else{L=0;V=0;while(1){X=V;V=V+1|0;if((b[T+X>>0]|0)==10){GOb(d,T+L|0,V-L|0);b[s>>0]=1;ia=V}else ia=L;if((V|0)==(P|0)){ha=ia;break}else L=ia}}GOb(d,T+ha|0,P-ha|0);if((b[B>>0]|0)<0)O5b(f[i>>2]|0);if(!(b[r>>0]|0)){GOb(d,475789,1);b[s>>0]=1;GOb(d,475790,0);break b}else{GOb(d,489135,1);break b}break}case 3:{L=b[n>>0]|0;V=L<<24>>24<0;R=V?f[h>>2]|0:h;Q=V?f[o>>2]|0:L&255;if(!Q)ja=0;else{L=0;V=0;while(1){X=V;V=V+1|0;if((b[R+X>>0]|0)==10){GOb(d,R+L|0,V-L|0);b[s>>0]=1;ka=V}else ka=L;if((V|0)==(Q|0)){ja=ka;break}else L=ka}}GOb(d,R+ja|0,Q-ja|0);L=f[O+(K<<4)+8>>2]|0;f[i>>2]=0;V=L+11|0;P=b[V>>0]|0;T=P<<24>>24<0;if(T)la=f[L+4>>2]|0;else la=P&255;do if(la){X=L+4|0;if(TPb(i,T?f[L>>2]|0:L,T?f[X>>2]|0:P&255)|0){if(!(b[r>>0]|0)){GOb(d,475692,3);b[s>>0]=1;GOb(d,475695,0);k6b(I,475796)|0}else GOb(d,475688,3);FOb(a,i,d);if(!(b[r>>0]|0)){HOb(d);GOb(d,475812,2);b[s>>0]=1;GOb(d,475814,0);break}else{GOb(d,475799,2);break}}else{ma=L;na=X;N=73}}else{ma=L;na=L+4|0;N=73}while(0);if((N|0)==73){N=0;P=J;f[P>>2]=0;f[P+4>>2]=0;b[E>>0]=3;b[j>>0]=b[475802]|0;b[j+1>>0]=b[475803]|0;b[j+2>>0]=b[475804]|0;b[F>>0]=0;P=b[V>>0]|0;T=P<<24>>24<0;f[m>>2]=T?f[L>>2]|0:ma;f[G>>2]=0;f[G>>2]=T?f[na>>2]|0:P&255;f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];oSb(g,j);k6b(j,b[r>>0]|0?475806:475809)|0;P=b[E>>0]|0;T=P<<24>>24<0;Q=T?f[j>>2]|0:j;R=T?f[H>>2]|0:P&255;if(!R)oa=0;else{P=0;T=0;while(1){X=T;T=T+1|0;if((b[Q+X>>0]|0)==10){GOb(d,Q+P|0,T-P|0);b[s>>0]=1;pa=T}else pa=P;if((T|0)==(R|0)){oa=pa;break}else P=pa}}GOb(d,Q+oa|0,R-oa|0);if((b[E>>0]|0)<0)O5b(f[j>>2]|0)}if(f[i>>2]|0)GPb(i);break}case 4:{P=b[n>>0]|0;T=P<<24>>24<0;L=T?f[h>>2]|0:h;V=T?f[o>>2]|0:P&255;if(!V)qa=0;else{P=0;T=0;while(1){X=T;T=T+1|0;if((b[L+X>>0]|0)==10){GOb(d,L+P|0,T-P|0);b[s>>0]=1;ra=T}else ra=P;if((T|0)==(V|0)){qa=ra;break}else P=ra}}GOb(d,L+qa|0,V-qa|0);if(!(b[r>>0]|0)){GOb(d,475692,3);b[s>>0]=1;GOb(d,475695,0);k6b(I,475796)|0}else GOb(d,475688,3);FOb(a,f[O+(K<<4)+8>>2]|0,d);if(!(b[r>>0]|0)){HOb(d);GOb(d,475812,2);b[s>>0]=1;GOb(d,475814,0);break b}else{GOb(d,475799,2);break b}break}default:{}}while(0);if((b[n>>0]|0)<0)O5b(f[h>>2]|0);K=K+1|0}if((N|0)==5){u=e;return}else if((N|0)==25)V5b(i);else if((N|0)==44)V5b(i)}function GOb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+13|0;if((d|0)==0|(b[h>>0]|0)!=0){u=e;return}i=a+12|0;if(b[i>>0]|0){b[i>>0]=0;i=a+16|0;j=b[i+11>>0]|0;if(j<<24>>24<0){k=f[i>>2]|0;l=f[a+20>>2]|0}else{k=i;l=j&255}GOb(a,k,l);if(b[h>>0]|0){u=e;return}}l=a+8|0;k=f[l>>2]|0;j=a+4|0;i=f[j>>2]|0;a:do if(k>>>0<d>>>0){m=d;n=c;o=i;p=k;while(1){Vac(o|0,n|0,p|0)|0;q=f[l>>2]|0;r=f[a>>2]|0;s=li[f[(f[r>>2]|0)+8>>2]&511](r,g,l)|0;b[h>>0]=(s^1)&1;if(!s)break;s=m-q|0;r=n+q|0;q=f[g>>2]|0;f[j>>2]=q;p=f[l>>2]|0;t=q;if(s>>>0<=p>>>0){v=s;w=r;x=t;break a}else{m=s;n=r;o=t}}u=e;return}else{v=d;w=c;x=i}while(0);Vac(x|0,w|0,v|0)|0;f[j>>2]=(f[j>>2]|0)+v;f[l>>2]=(f[l>>2]|0)-v;u=e;return}function HOb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c;e=c+24|0;g=a+16|0;h=b[g+11>>0]|0;i=h<<24>>24<0;if(i)j=f[a+20>>2]|0;else j=h&255;if(j|0){if(i)k=f[a+20>>2]|0;else k=h&255;if(k>>>0>=f[a+28>>2]<<1>>>0){if(i)l=f[a+20>>2]|0;else l=h&255;e6b(g,l+-2|0,0);u=c;return}}zpb(d,2,475815,1188);xpb(e,vpb(d,475908)|0);Apb(d);u=c;return}function IOb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;LOb(a,c,d,e,g);h=li[f[(f[d>>2]|0)+24>>2]&511](d,c,e)|0;GOb(g,475994,3);if((h|0)>0){i=0;do{if((i|0)>0)GOb(g,489325,2);MOb(a,c,d,e,i,g);i=i+1|0}while((i|0)!=(h|0))}if(!(b[a+4>>0]|0)){GOb(g,476001,2);b[g+12>>0]=1;GOb(g,476003,0);return}else{GOb(g,475998,2);return}}function JOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function KOb(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;h=u;u=u+64|0;i=h+52|0;j=h+48|0;k=h+44|0;l=h+40|0;m=h+36|0;n=h+32|0;o=h+28|0;p=h+24|0;q=h+20|0;r=h+16|0;s=h+12|0;t=h+8|0;v=h+4|0;w=h;switch(d|0){case 2:{x=(f[b>>2]|0)+-4|0;f[b>>2]=x;y=f[a>>2]|0;if(!(NOb(c,f[x>>2]|0,f[y>>2]|0)|0)){u=h;return}z=f[y>>2]|0;f[y>>2]=f[x>>2];f[x>>2]=z;u=h;return}case 1:case 0:{u=h;return}default:{if((d|0)<129){z=f[a>>2]|0;x=f[b>>2]|0;if((z|0)==(x|0)){u=h;return}y=z+4|0;if((y|0)==(x|0)){u=h;return}else A=y;do{y=A;B=f[A>>2]|0;a:do if((A|0)==(z|0))C=y;else{D=B;E=y;F=A;while(1){F=F+-4|0;if(!(NOb(c,D,f[F>>2]|0)|0)){C=E;break a}f[E>>2]=f[F>>2];G=E+-4|0;if((F|0)==(z|0)){C=G;break}else E=G}}while(0);f[C>>2]=B;A=A+4|0}while((A|0)!=(x|0));u=h;return}x=d>>>1;A=f[a>>2]|0;a=A+(x<<2)|0;C=A;if((d|0)>(g|0)){f[p>>2]=C;f[q>>2]=a;f[j>>2]=f[p>>2];f[i>>2]=f[q>>2];KOb(j,i,c,x,e,g);f[r>>2]=a;q=f[b>>2]|0;f[s>>2]=q;p=d-x|0;f[j>>2]=f[r>>2];f[i>>2]=f[s>>2];KOb(j,i,c,p,e,g);f[t>>2]=C;f[v>>2]=a;f[w>>2]=q;f[k>>2]=f[t>>2];f[j>>2]=f[v>>2];f[i>>2]=f[w>>2];POb(k,j,i,c,x,p,e,g);u=h;return}f[l>>2]=C;f[m>>2]=a;f[j>>2]=f[l>>2];f[i>>2]=f[m>>2];OOb(j,i,c,x,e);f[n>>2]=a;f[o>>2]=f[b>>2];b=e+(x<<2)|0;f[j>>2]=f[n>>2];f[i>>2]=f[o>>2];OOb(j,i,c,d-x|0,b);x=e+(d<<2)|0;d=b;i=e;e=C;while(1){if((d|0)==(x|0))break;if(NOb(c,f[d>>2]|0,f[i>>2]|0)|0){C=e;f[C>>2]=f[d>>2];H=d+4|0;I=i;J=C}else{C=e;f[C>>2]=f[i>>2];H=d;I=i+4|0;J=C}K=J+4|0;if((I|0)==(b|0)){L=14;break}else{d=H;i=I;e=K}}if((L|0)==14){if((H|0)==(x|0)){u=h;return}else{M=H;N=K}while(1){f[N>>2]=f[M>>2];M=M+4|0;if((M|0)==(x|0))break;else N=N+4|0}u=h;return}if((i|0)==(b|0)){u=h;return}N=i;i=e;while(1){f[i>>2]=f[N>>2];N=N+4|0;if((N|0)==(b|0))break;else i=i+4|0}u=h;return}}}function LOb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+16|0;i=h;if(b[a+5>>0]|0){vSb(i,f[e+28>>2]|0);j=i+11|0;k=b[j>>0]|0;l=k<<24>>24<0;m=l?f[i>>2]|0:i;n=l?f[i+4>>2]|0:k&255;if(!n)o=0;else{k=g+12|0;l=0;p=0;while(1){q=p;p=p+1|0;if((b[m+q>>0]|0)==10){GOb(g,m+l|0,p-l|0);b[k>>0]=1;r=p}else r=l;if((p|0)==(n|0)){o=r;break}else l=r}}GOb(g,m+o|0,n-o|0);if((b[j>>0]|0)<0)O5b(f[i>>2]|0);u=h;return}j=f[a+24>>2]|0;o=a+32|0;a=f[o>>2]|0;if(a){n=o;m=a;a:while(1){a=m;while(1){if((f[a+16>>2]|0)>>>0>=e>>>0)break;r=f[a+4>>2]|0;if(!r){s=n;break a}else a=r}m=f[a>>2]|0;if(!m){s=a;break}else n=a}if((s|0)!=(o|0)?(f[s+16>>2]|0)>>>0<=e>>>0:0)t=f[s+20>>2]|0;else t=j}else t=j;uh[f[(f[t>>2]|0)+48>>2]&255](i,t,c,d,e);e=i+11|0;d=b[e>>0]|0;c=d<<24>>24<0;t=c?f[i>>2]|0:i;j=c?f[i+4>>2]|0:d&255;if(!j)v=0;else{d=g+12|0;c=0;s=0;while(1){o=s;s=s+1|0;if((b[t+o>>0]|0)==10){GOb(g,t+c|0,s-c|0);b[d>>0]=1;w=s}else w=c;if((s|0)==(j|0)){v=w;break}else c=w}}GOb(g,t+v|0,j-v|0);if((b[e>>0]|0)<0)O5b(f[i>>2]|0);u=h;return}function MOb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0.0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;i=u;u=u+64|0;j=i;k=i+40|0;l=i+28|0;m=i+16|0;n=i+4|0;o=f[a+24>>2]|0;p=a+32|0;q=f[p>>2]|0;if(q){r=p;s=q;a:while(1){q=s;while(1){if((f[q+16>>2]|0)>>>0>=e>>>0)break;t=f[q+4>>2]|0;if(!t){v=r;break a}else q=t}s=f[q>>2]|0;if(!s){v=q;break}else r=q}if((v|0)!=(p|0)?(f[v+16>>2]|0)>>>0<=e>>>0:0)w=f[v+20>>2]|0;else w=o}else w=o;o=e+32|0;do switch(f[136e3+(f[o>>2]<<2)>>2]|0){case 1:{v=f[(f[w>>2]|0)+12>>2]|0;if((f[e+36>>2]|0)==3)x=Dg[f[(f[d>>2]|0)+168>>2]&127](d,c,e,g)|0;else x=li[f[(f[d>>2]|0)+68>>2]&511](d,c,e)|0;_h[v&255](k,w,x);v=k+11|0;p=b[v>>0]|0;r=p<<24>>24<0;s=r?f[k>>2]|0:k;t=r?f[k+4>>2]|0:p&255;if(!t)y=0;else{p=h+12|0;r=0;z=0;while(1){A=z;z=z+1|0;if((b[s+A>>0]|0)==10){GOb(h,s+r|0,z-r|0);b[p>>0]=1;B=z}else B=r;if((z|0)==(t|0)){y=B;break}else r=B}}GOb(h,s+y|0,t-y|0);if((b[v>>0]|0)<0)O5b(f[k>>2]|0);u=i;return}case 2:{r=f[(f[w>>2]|0)+20>>2]|0;if((f[e+36>>2]|0)==3){z=Dg[f[(f[d>>2]|0)+172>>2]&127](d,c,e,g)|0;C=z;D=J}else{z=li[f[(f[d>>2]|0)+72>>2]&511](d,c,e)|0;C=z;D=J}th[r&511](k,w,C,D);r=k+11|0;z=b[r>>0]|0;p=z<<24>>24<0;q=p?f[k>>2]|0:k;A=p?f[k+4>>2]|0:z&255;if(!A)E=0;else{z=h+12|0;p=0;F=0;while(1){G=F;F=F+1|0;if((b[q+G>>0]|0)==10){GOb(h,q+p|0,F-p|0);b[z>>0]=1;H=F}else H=p;if((F|0)==(A|0)){E=H;break}else p=H}}GOb(h,q+E|0,A-E|0);if((b[r>>0]|0)<0)O5b(f[k>>2]|0);u=i;return}case 3:{p=f[(f[w>>2]|0)+16>>2]|0;if((f[e+36>>2]|0)==3)I=Dg[f[(f[d>>2]|0)+176>>2]&127](d,c,e,g)|0;else I=li[f[(f[d>>2]|0)+76>>2]&511](d,c,e)|0;_h[p&255](k,w,I);p=k+11|0;F=b[p>>0]|0;z=F<<24>>24<0;v=z?f[k>>2]|0:k;t=z?f[k+4>>2]|0:F&255;if(!t)K=0;else{F=h+12|0;z=0;s=0;while(1){G=s;s=s+1|0;if((b[v+G>>0]|0)==10){GOb(h,v+z|0,s-z|0);b[F>>0]=1;L=s}else L=z;if((s|0)==(t|0)){K=L;break}else z=L}}GOb(h,v+K|0,t-K|0);if((b[p>>0]|0)<0)O5b(f[k>>2]|0);u=i;return}case 4:{z=f[(f[w>>2]|0)+24>>2]|0;if((f[e+36>>2]|0)==3){s=Dg[f[(f[d>>2]|0)+180>>2]&127](d,c,e,g)|0;M=s;N=J}else{s=li[f[(f[d>>2]|0)+80>>2]&511](d,c,e)|0;M=s;N=J}th[z&511](k,w,M,N);z=k+11|0;s=b[z>>0]|0;F=s<<24>>24<0;r=F?f[k>>2]|0:k;A=F?f[k+4>>2]|0:s&255;if(!A)O=0;else{s=h+12|0;F=0;q=0;while(1){G=q;q=q+1|0;if((b[r+G>>0]|0)==10){GOb(h,r+F|0,q-F|0);b[s>>0]=1;P=q}else P=F;if((q|0)==(A|0)){O=P;break}else F=P}}GOb(h,r+O|0,A-O|0);if((b[z>>0]|0)<0)O5b(f[k>>2]|0);u=i;return}case 6:{F=f[(f[w>>2]|0)+28>>2]|0;if((f[e+36>>2]|0)==3)Q=+Kh[f[(f[d>>2]|0)+184>>2]&15](d,c,e,g);else Q=+fh[f[(f[d>>2]|0)+84>>2]&31](d,c,e);ai[F&31](k,w,Q);F=k+11|0;q=b[F>>0]|0;s=q<<24>>24<0;p=s?f[k>>2]|0:k;t=s?f[k+4>>2]|0:q&255;if(!t)R=0;else{q=h+12|0;s=0;v=0;while(1){G=v;v=v+1|0;if((b[p+G>>0]|0)==10){GOb(h,p+s|0,v-s|0);b[q>>0]=1;S=v}else S=s;if((v|0)==(t|0)){R=S;break}else s=S}}GOb(h,p+R|0,t-R|0);if((b[F>>0]|0)<0)O5b(f[k>>2]|0);u=i;return}case 5:{s=f[(f[w>>2]|0)+32>>2]|0;if((f[e+36>>2]|0)==3)T=+Kh[f[(f[d>>2]|0)+188>>2]&15](d,c,e,g);else T=+fh[f[(f[d>>2]|0)+88>>2]&31](d,c,e);ai[s&31](k,w,T);s=k+11|0;v=b[s>>0]|0;q=v<<24>>24<0;z=q?f[k>>2]|0:k;A=q?f[k+4>>2]|0:v&255;if(!A)U=0;else{v=h+12|0;q=0;r=0;while(1){G=r;r=r+1|0;if((b[z+G>>0]|0)==10){GOb(h,z+q|0,r-q|0);b[v>>0]=1;V=r}else V=q;if((r|0)==(A|0)){U=V;break}else q=V}}GOb(h,z+U|0,A-U|0);if((b[s>>0]|0)<0)O5b(f[k>>2]|0);u=i;return}case 7:{q=f[(f[w>>2]|0)+8>>2]|0;if((f[e+36>>2]|0)==3)W=Dg[f[(f[d>>2]|0)+192>>2]&127](d,c,e,g)|0;else W=li[f[(f[d>>2]|0)+92>>2]&511](d,c,e)|0;_h[q&255](k,w,W);q=k+11|0;r=b[q>>0]|0;v=r<<24>>24<0;F=v?f[k>>2]|0:k;t=v?f[k+4>>2]|0:r&255;if(!t)X=0;else{r=h+12|0;v=0;p=0;while(1){G=p;p=p+1|0;if((b[F+G>>0]|0)==10){GOb(h,F+v|0,p-v|0);b[r>>0]=1;Y=p}else Y=v;if((p|0)==(t|0)){X=Y;break}else v=Y}}GOb(h,F+X|0,t-X|0);if((b[q>>0]|0)<0)O5b(f[k>>2]|0);u=i;return}case 9:{f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if((f[e+36>>2]|0)==3)Z=nh[f[(f[d>>2]|0)+212>>2]&127](d,c,e,g,k)|0;else Z=Dg[f[(f[d>>2]|0)+112>>2]&127](d,c,e,k)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;v=a+16|0;p=f[v>>2]|0;r=f[v+4>>2]|0;if((r|0)>0|(r|0)==0&p>>>0>0){v=b[Z+11>>0]|0;if(v<<24>>24<0)_=f[Z+4>>2]|0;else _=v&255;if((r|0)<0|(r|0)==0&p>>>0<_>>>0){Y5b(n,Z,0,p,Z);eua(m,n,475946);_5b(l,m)|0;if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);if((b[n+11>>0]|0)<0)O5b(f[n>>2]|0);$=l}else $=Z}else $=Z;if((f[o>>2]|0)==9){_h[f[(f[w>>2]|0)+36>>2]&255](m,w,$);p=m+11|0;r=b[p>>0]|0;v=r<<24>>24<0;s=v?f[m>>2]|0:m;A=v?f[m+4>>2]|0:r&255;if(!A)aa=0;else{r=h+12|0;v=0;z=0;while(1){G=z;z=z+1|0;if((b[s+G>>0]|0)==10){GOb(h,s+v|0,z-v|0);b[r>>0]=1;ba=z}else ba=v;if((z|0)==(A|0)){aa=ba;break}else v=ba}}GOb(h,s+aa|0,A-aa|0);if((b[p>>0]|0)<0)O5b(f[m>>2]|0)}else{_h[f[(f[w>>2]|0)+40>>2]&255](m,w,$);v=m+11|0;z=b[v>>0]|0;r=z<<24>>24<0;q=r?f[m>>2]|0:m;t=r?f[m+4>>2]|0:z&255;if(!t)ca=0;else{z=h+12|0;r=0;F=0;while(1){G=F;F=F+1|0;if((b[q+G>>0]|0)==10){GOb(h,q+r|0,F-r|0);b[z>>0]=1;da=F}else da=r;if((F|0)==(t|0)){ca=da;break}else r=da}}GOb(h,q+ca|0,t-ca|0);if((b[v>>0]|0)<0)O5b(f[m>>2]|0)}if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);u=i;return}case 8:{if((f[e+36>>2]|0)==3)ea=Dg[f[(f[d>>2]|0)+204>>2]&127](d,c,e,g)|0;else ea=li[f[(f[d>>2]|0)+104>>2]&511](d,c,e)|0;r=tub(f[e+64>>2]|0,ea)|0;if(r|0){th[f[(f[w>>2]|0)+44>>2]&511](k,w,ea,f[r>>2]|0);r=k+11|0;F=b[r>>0]|0;z=F<<24>>24<0;p=z?f[k>>2]|0:k;A=z?f[k+4>>2]|0:F&255;if(!A)fa=0;else{F=h+12|0;z=0;s=0;while(1){G=s;s=s+1|0;if((b[p+G>>0]|0)==10){GOb(h,p+z|0,s-z|0);b[F>>0]=1;ga=s}else ga=z;if((s|0)==(A|0)){fa=ga;break}else z=ga}}GOb(h,p+fa|0,A-fa|0);if((b[r>>0]|0)<0)O5b(f[k>>2]|0);u=i;return}z=f[(f[w>>2]|0)+44>>2]|0;f[j>>2]=ea;gSb(l,475964,j);th[z&511](k,w,ea,l);z=k+11|0;s=b[z>>0]|0;F=s<<24>>24<0;v=F?f[k>>2]|0:k;t=F?f[k+4>>2]|0:s&255;if(!t)ha=0;else{s=h+12|0;F=0;q=0;while(1){G=q;q=q+1|0;if((b[v+G>>0]|0)==10){GOb(h,v+F|0,q-F|0);b[s>>0]=1;ia=q}else ia=F;if((q|0)==(t|0)){ha=ia;break}else F=ia}}GOb(h,v+ha|0,t-ha|0);if((b[z>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);u=i;return}case 10:{if((f[e+36>>2]|0)==3)ja=Dg[f[(f[d>>2]|0)+208>>2]&127](d,c,e,g)|0;else ja=Dg[f[(f[d>>2]|0)+108>>2]&127](d,c,e,0)|0;BOb(a,ja,h);u=i;return}default:{u=i;return}}while(0)}function NOb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+64|0;g=e+36|0;h=e+24|0;i=e;j=e+48|0;k=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;l=f[a>>2]|0;switch(f[136e3+(f[l+32>>2]<<2)>>2]|0){case 7:{m=li[f[(f[k>>2]|0)+92>>2]&511](k,c,l)|0;n=(li[f[(f[k>>2]|0)+92>>2]&511](k,d,f[a>>2]|0)|0)&(m^1);u=e;return n|0}case 1:{n=(li[f[(f[k>>2]|0)+68>>2]&511](k,c,l)|0)<(li[f[(f[k>>2]|0)+68>>2]&511](k,d,f[a>>2]|0)|0);u=e;return n|0}case 2:{m=li[f[(f[k>>2]|0)+72>>2]&511](k,c,l)|0;o=J;p=li[f[(f[k>>2]|0)+72>>2]&511](k,d,f[a>>2]|0)|0;q=J;n=(o|0)<(q|0)|(o|0)==(q|0)&m>>>0<p>>>0;u=e;return n|0}case 3:{n=(li[f[(f[k>>2]|0)+76>>2]&511](k,c,l)|0)>>>0<(li[f[(f[k>>2]|0)+76>>2]&511](k,d,f[a>>2]|0)|0)>>>0;u=e;return n|0}case 4:{p=li[f[(f[k>>2]|0)+80>>2]&511](k,c,l)|0;m=J;q=li[f[(f[k>>2]|0)+80>>2]&511](k,d,f[a>>2]|0)|0;o=J;n=m>>>0<o>>>0|(m|0)==(o|0)&p>>>0<q>>>0;u=e;return n|0}case 9:{th[f[(f[k>>2]|0)+96>>2]&511](g,k,c,l);th[f[(f[k>>2]|0)+96>>2]&511](h,k,d,f[a>>2]|0);a=b[h+11>>0]|0;d=a<<24>>24<0;k=d?f[h+4>>2]|0:a&255;a=g+11|0;l=b[a>>0]|0;c=l<<24>>24<0;q=c?f[g+4>>2]|0:l&255;p=k>>>0<q>>>0;o=p?k:q;if((o|0)!=0?(m=ZVb(c?f[g>>2]|0:g,d?f[h>>2]|0:h,o)|0,(m|0)!=0):0)r=m;else r=q>>>0<k>>>0?-1:p&1;if(d){O5b(f[h>>2]|0);s=b[a>>0]|0}else s=l;if(s<<24>>24<0)O5b(f[g>>2]|0);n=(r|0)<0;u=e;return n|0}default:{zpb(i,2,475815,1680);xpb(j,vpb(i,475967)|0);Apb(i);n=1;u=e;return n|0}}return 0}function OOb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;g=u;u=u+32|0;h=g+8|0;i=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;switch(d|0){case 1:{f[e>>2]=f[f[a>>2]>>2];u=g;return}case 2:{n=(f[b>>2]|0)+-4|0;f[b>>2]=n;o=NOb(c,f[n>>2]|0,f[f[a>>2]>>2]|0)|0;f[e>>2]=f[f[(o?b:a)>>2]>>2];f[e+4>>2]=f[f[(o?a:b)>>2]>>2];u=g;return}case 0:{u=g;return}default:{if((d|0)>=9){o=d>>>1;n=f[a>>2]|0;p=n+(o<<2)|0;q=n;f[j>>2]=q;f[k>>2]=p;f[i>>2]=f[j>>2];f[h>>2]=f[k>>2];KOb(i,h,c,o,e,o);f[l>>2]=p;k=f[b>>2]|0;f[m>>2]=k;j=d-o|0;f[i>>2]=f[l>>2];f[h>>2]=f[m>>2];KOb(i,h,c,j,e+(o<<2)|0,j);f[h>>2]=p;f[i>>2]=q;q=k;a:do if(o){if((p|0)==(q|0)){r=e;s=n}else{k=e;j=p;m=n;while(1){l=NOb(c,f[j>>2]|0,f[m>>2]|0)|0;d=l?h:i;l=f[d>>2]|0;f[k>>2]=f[l>>2];f[d>>2]=l+4;l=k+4|0;d=f[i>>2]|0;j=f[h>>2]|0;if((d|0)==(p|0)){t=l;v=j;w=16;break a}if((j|0)==(q|0)){r=l;s=d;break}else{k=l;m=d}}}if((s|0)!=(p|0)){m=r;k=s;while(1){f[m>>2]=f[k>>2];k=(f[i>>2]|0)+4|0;f[i>>2]=k;if((k|0)==(p|0))break;else m=m+4|0}}}else{t=e;v=n;w=16}while(0);if((w|0)==16?(v|0)!=(q|0):0){w=t;t=v;while(1){f[w>>2]=f[t>>2];t=(f[h>>2]|0)+4|0;f[h>>2]=t;if((t|0)==(q|0))break;else w=w+4|0}}u=g;return}w=f[a>>2]|0;a=f[b>>2]|0;if((w|0)==(a|0)){u=g;return}b=f[w>>2]|0;f[e>>2]=b;q=w+4|0;if((q|0)==(a|0)){u=g;return}w=e;t=q;q=b;while(1){b=w+4|0;b:do if(NOb(c,f[t>>2]|0,q)|0){f[b>>2]=f[w>>2];if((w|0)==(e|0))x=e;else{h=w;while(1){v=h;h=h+-4|0;if(!(NOb(c,f[t>>2]|0,f[h>>2]|0)|0)){x=v;break b}f[v>>2]=f[h>>2];if((h|0)==(e|0)){x=e;break}}}}else x=b;while(0);f[x>>2]=f[t>>2];h=t+4|0;if((h|0)==(a|0))break;w=b;t=h;q=f[b>>2]|0}u=g;return}}}function POb(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;j=u;u=u+64|0;k=j+52|0;l=j+48|0;m=j+44|0;n=j+40|0;o=j+36|0;p=j+32|0;q=j+20|0;r=j+12|0;s=j+28|0;t=j+24|0;v=j+16|0;w=j+8|0;x=j+4|0;y=j;if(!g){u=j;return}z=e;e=g;a:while(1){if(!((e|0)>(i|0)&(z|0)>(i|0))){A=6;break}if(!z){A=42;break}B=f[b>>2]|0;g=B;C=z;D=f[a>>2]|0;while(1){if(NOb(d,f[B>>2]|0,f[D>>2]|0)|0)break;E=D+4|0;f[a>>2]=E;F=C+-1|0;if(!F){A=42;break a}else{C=F;D=E}}E=D;if((C|0)<(e|0)){F=(e|0)/2|0;G=B+(F<<2)|0;H=G;f[r>>2]=H;I=g-E>>2;if(!I)J=D;else{K=I;I=D;L=D;while(1){M=(K|0)/2|0;N=L+(M<<2)|0;O=NOb(d,f[G>>2]|0,f[N>>2]|0)|0;P=N+4|0;N=O?I:P;K=O?M:K+-1-M|0;if(!K){J=N;break}else{I=N;L=O?L:P}}}L=J;f[q>>2]=L;Q=L-E>>2;R=F;S=H;T=L}else{if((C|0)==1){A=14;break}L=(C|0)/2|0;I=D+(L<<2)|0;K=I;f[q>>2]=K;G=(f[c>>2]|0)-g>>2;if(!G)U=B;else{P=G;G=B;O=B;while(1){N=(P|0)/2|0;M=O+(N<<2)|0;V=NOb(d,f[M>>2]|0,f[I>>2]|0)|0;W=M+4|0;M=V?W:G;P=V?P+-1-N|0:N;if(!P){U=M;break}else{G=M;O=V?W:O}}}O=U;f[r>>2]=O;Q=L;R=O-g>>2;S=O;T=K}O=C-Q|0;G=e-R|0;P=T;I=S;b:do if((P|0)!=(B|0))if((B|0)==(I|0))X=P;else{if((P+4|0)==(B|0)){H=f[T>>2]|0;F=S-g|0;E=F>>2;if(E|0)Xac(T|0,B|0,F|0)|0;F=P+(E<<2)|0;f[F>>2]=H;X=F;break}if((B+4|0)==(I|0)){F=f[B>>2]|0;H=g-T|0;E=H>>2;W=I+(0-E<<2)|0;if(!E)Y=I;else{Xac(W|0,T|0,H|0)|0;Y=W}f[T>>2]=F;X=Y;break}F=g-T>>2;W=S-g>>2;if((F|0)==(W|0)){H=P;E=B;while(1){V=f[H>>2]|0;f[H>>2]=f[E>>2];f[E>>2]=V;H=H+4|0;if((H|0)==(B|0)){X=B;break b}else E=E+4|0}}else{Z=F;_=W}while(1){E=(Z|0)%(_|0)|0;if(!E)break;else{H=_;_=E;Z=H}}if(!_)$=P;else{H=(_<<2)+-4|0;E=P+(_<<2)|0;do{E=E+-4|0;V=f[E>>2]|0;M=E+(F<<2)|0;N=E;while(1){f[N>>2]=f[M>>2];N=M;aa=S-N>>2;ba=(F|0)<(aa|0)?M+(F<<2)|0:P+(F-aa<<2)|0;if((ba|0)==(E|0))break;else M=ba}f[M>>2]=V}while((E|0)!=(P|0));$=P+(_+-1-(H>>>2)<<2)|0}X=$+(W<<2)|0}else X=I;while(0);f[b>>2]=X;I=X;if((Q+R|0)<(O+G|0)){f[s>>2]=f[a>>2];f[t>>2]=f[q>>2];f[v>>2]=I;f[m>>2]=f[s>>2];f[l>>2]=f[t>>2];f[k>>2]=f[v>>2];POb(m,l,k,d,Q,R,h,i);ca=G;da=O;ea=r;fa=a}else{f[w>>2]=I;f[x>>2]=f[r>>2];f[y>>2]=f[c>>2];f[m>>2]=f[w>>2];f[l>>2]=f[x>>2];f[k>>2]=f[y>>2];POb(m,l,k,d,O,G,h,i);ca=R;da=Q;ea=q;fa=c}f[fa>>2]=I;f[b>>2]=f[ea>>2];if(!ca){A=42;break}else{z=da;e=ca}}if((A|0)==6){f[n>>2]=f[a>>2];f[o>>2]=f[b>>2];f[p>>2]=f[c>>2];f[m>>2]=f[n>>2];f[l>>2]=f[o>>2];f[k>>2]=f[p>>2];QOb(m,l,k,d,z,e,h);u=j;return}else if((A|0)==14){h=f[D>>2]|0;f[D>>2]=f[B>>2];f[B>>2]=h;u=j;return}else if((A|0)==42){u=j;return}}function QOb(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+16|0;j=i;k=i+4|0;if((e|0)>(g|0)){g=f[b>>2]|0;e=g;l=f[c>>2]|0;if((e|0)==(l|0)){m=h;n=l;o=g}else{l=h;p=g;g=e;while(1){f[l>>2]=f[p>>2];e=g+4|0;q=l+4|0;r=f[c>>2]|0;if((e|0)==(r|0))break;else{l=q;p=e;g=e}}m=q;n=r;o=f[b>>2]|0}r=f[a>>2]|0;f[j>>2]=o;f[k>>2]=m;a:do if((m|0)!=(h|0)){q=o;if((q|0)==(r|0)){s=m;t=n}else{g=q;q=m;p=n;while(1){l=NOb(d,f[g+-4>>2]|0,f[q+-4>>2]|0)|0;e=l?k:j;l=(f[e>>2]|0)+-4|0;v=p+-4|0;f[v>>2]=f[l>>2];f[e>>2]=l;l=f[k>>2]|0;if((l|0)==(h|0))break a;g=f[j>>2]|0;if((g|0)==(r|0)){s=l;t=v;break}else{q=l;p=v}}}if((s|0)!=(h|0)){p=s;q=t;do{p=p+-4|0;q=q+-4|0;f[q>>2]=f[p>>2]}while((p|0)!=(h|0))}}while(0);u=i;return}t=f[a>>2]|0;s=t;if((s|0)==(f[b>>2]|0)){w=h;x=t;y=s}else{r=h;k=t;t=s;while(1){f[r>>2]=f[k>>2];z=t+4|0;A=r+4|0;if((z|0)==(f[b>>2]|0))break;else{r=A;k=z;t=z}}w=A;x=f[a>>2]|0;y=z}z=f[c>>2]|0;f[j>>2]=f[d>>2];b:do if((w|0)!=(h|0)){d=h;c=x;a=y;A=y;while(1){if((a|0)==(z|0))break;if(NOb(j,f[a>>2]|0,f[d>>2]|0)|0){t=c;f[t>>2]=f[A>>2];k=A+4|0;B=d;C=t;D=k;E=k}else{k=c;f[k>>2]=f[d>>2];B=d+4|0;C=k;D=A;E=a}if((B|0)==(w|0))break b;else{d=B;c=C+4|0;a=E;A=D}}A=w-d|0;if(A|0)Xac(c|0,d|0,A|0)|0}while(0);u=i;return}function ROb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=f[c>>2]|0;g=f[a>>2]|0;h=(b[e+40>>0]|0)==0;i=e;j=g;do if(!h){k=f[e+56>>2]|0;if(!k){l=(f[e+24>>2]|0)+72|0;break}else{l=k+68|0;break}}else l=(f[e+48>>2]|0)+28|0;while(0);k=i-(f[l>>2]|0)|0;l=(b[g+40>>0]|0)==0;do if(!l){m=f[g+56>>2]|0;if(!m){n=(f[g+24>>2]|0)+72|0;break}else{n=m+68|0;break}}else n=(f[g+48>>2]|0)+28|0;while(0);m=(k|0)<(j-(f[n>>2]|0)|0);n=f[d>>2]|0;k=n;do if(b[n+40>>0]|0){o=f[n+56>>2]|0;if(!o){p=(f[n+24>>2]|0)+72|0;break}else{p=o+68|0;break}}else p=(f[n+48>>2]|0)+28|0;while(0);n=k-(f[p>>2]|0)|0;do if(!h){p=f[e+56>>2]|0;if(!p){q=(f[e+24>>2]|0)+72|0;break}else{q=p+68|0;break}}else q=(f[e+48>>2]|0)+28|0;while(0);e=(n|0)<(i-(f[q>>2]|0)|0);if(!m){if(!e){r=0;return r|0}f[c>>2]=k;f[d>>2]=i;m=f[c>>2]|0;q=f[a>>2]|0;n=m;h=q;do if(b[m+40>>0]|0){p=f[m+56>>2]|0;if(!p){s=(f[m+24>>2]|0)+72|0;break}else{s=p+68|0;break}}else s=(f[m+48>>2]|0)+28|0;while(0);m=n-(f[s>>2]|0)|0;do if(b[q+40>>0]|0){s=f[q+56>>2]|0;if(!s){t=(f[q+24>>2]|0)+72|0;break}else{t=s+68|0;break}}else t=(f[q+48>>2]|0)+28|0;while(0);if((m|0)>=(h-(f[t>>2]|0)|0)){r=1;return r|0}f[a>>2]=n;f[c>>2]=h;r=2;return r|0}if(e){f[a>>2]=k;f[d>>2]=j;r=1;return r|0}f[a>>2]=i;f[c>>2]=j;i=f[d>>2]|0;a=i;do if(b[i+40>>0]|0){k=f[i+56>>2]|0;if(!k){u=(f[i+24>>2]|0)+72|0;break}else{u=k+68|0;break}}else u=(f[i+48>>2]|0)+28|0;while(0);i=a-(f[u>>2]|0)|0;do if(!l){u=f[g+56>>2]|0;if(!u){v=(f[g+24>>2]|0)+72|0;break}else{v=u+68|0;break}}else v=(f[g+48>>2]|0)+28|0;while(0);if((i|0)>=(j-(f[v>>2]|0)|0)){r=1;return r|0}f[c>>2]=a;f[d>>2]=j;r=2;return r|0}function SOb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=ROb(a,c,d)|0;h=f[e>>2]|0;i=f[d>>2]|0;j=h;k=i;do if(b[h+40>>0]|0){l=f[h+56>>2]|0;if(!l){m=(f[h+24>>2]|0)+72|0;break}else{m=l+68|0;break}}else m=(f[h+48>>2]|0)+28|0;while(0);h=j-(f[m>>2]|0)|0;do if(b[i+40>>0]|0){m=f[i+56>>2]|0;if(!m){n=(f[i+24>>2]|0)+72|0;break}else{n=m+68|0;break}}else n=(f[i+48>>2]|0)+28|0;while(0);if((h|0)>=(k-(f[n>>2]|0)|0)){o=g;return o|0}f[d>>2]=j;f[e>>2]=k;k=g+1|0;e=f[d>>2]|0;j=f[c>>2]|0;n=e;h=j;do if(b[e+40>>0]|0){i=f[e+56>>2]|0;if(!i){p=(f[e+24>>2]|0)+72|0;break}else{p=i+68|0;break}}else p=(f[e+48>>2]|0)+28|0;while(0);e=n-(f[p>>2]|0)|0;do if(b[j+40>>0]|0){p=f[j+56>>2]|0;if(!p){q=(f[j+24>>2]|0)+72|0;break}else{q=p+68|0;break}}else q=(f[j+48>>2]|0)+28|0;while(0);if((e|0)>=(h-(f[q>>2]|0)|0)){o=k;return o|0}f[c>>2]=n;f[d>>2]=h;h=g+2|0;d=f[c>>2]|0;n=f[a>>2]|0;k=d;q=n;do if(b[d+40>>0]|0){e=f[d+56>>2]|0;if(!e){r=(f[d+24>>2]|0)+72|0;break}else{r=e+68|0;break}}else r=(f[d+48>>2]|0)+28|0;while(0);d=k-(f[r>>2]|0)|0;do if(b[n+40>>0]|0){r=f[n+56>>2]|0;if(!r){s=(f[n+24>>2]|0)+72|0;break}else{s=r+68|0;break}}else s=(f[n+48>>2]|0)+28|0;while(0);if((d|0)>=(q-(f[s>>2]|0)|0)){o=h;return o|0}f[a>>2]=k;f[c>>2]=q;o=g+3|0;return o|0}function TOb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=SOb(a,c,d,e)|0;i=f[g>>2]|0;j=f[e>>2]|0;k=i;l=j;do if(b[i+40>>0]|0){m=f[i+56>>2]|0;if(!m){n=(f[i+24>>2]|0)+72|0;break}else{n=m+68|0;break}}else n=(f[i+48>>2]|0)+28|0;while(0);i=k-(f[n>>2]|0)|0;do if(b[j+40>>0]|0){n=f[j+56>>2]|0;if(!n){o=(f[j+24>>2]|0)+72|0;break}else{o=n+68|0;break}}else o=(f[j+48>>2]|0)+28|0;while(0);if((i|0)>=(l-(f[o>>2]|0)|0)){p=h;return p|0}f[e>>2]=k;f[g>>2]=l;l=h+1|0;g=f[e>>2]|0;k=f[d>>2]|0;o=g;i=k;do if(b[g+40>>0]|0){j=f[g+56>>2]|0;if(!j){q=(f[g+24>>2]|0)+72|0;break}else{q=j+68|0;break}}else q=(f[g+48>>2]|0)+28|0;while(0);g=o-(f[q>>2]|0)|0;do if(b[k+40>>0]|0){q=f[k+56>>2]|0;if(!q){r=(f[k+24>>2]|0)+72|0;break}else{r=q+68|0;break}}else r=(f[k+48>>2]|0)+28|0;while(0);if((g|0)>=(i-(f[r>>2]|0)|0)){p=l;return p|0}f[d>>2]=o;f[e>>2]=i;i=h+2|0;e=f[d>>2]|0;o=f[c>>2]|0;l=e;r=o;do if(b[e+40>>0]|0){g=f[e+56>>2]|0;if(!g){s=(f[e+24>>2]|0)+72|0;break}else{s=g+68|0;break}}else s=(f[e+48>>2]|0)+28|0;while(0);e=l-(f[s>>2]|0)|0;do if(b[o+40>>0]|0){s=f[o+56>>2]|0;if(!s){t=(f[o+24>>2]|0)+72|0;break}else{t=s+68|0;break}}else t=(f[o+48>>2]|0)+28|0;while(0);if((e|0)>=(r-(f[t>>2]|0)|0)){p=i;return p|0}f[c>>2]=l;f[d>>2]=r;r=h+3|0;d=f[c>>2]|0;l=f[a>>2]|0;i=d;t=l;do if(b[d+40>>0]|0){e=f[d+56>>2]|0;if(!e){u=(f[d+24>>2]|0)+72|0;break}else{u=e+68|0;break}}else u=(f[d+48>>2]|0)+28|0;while(0);d=i-(f[u>>2]|0)|0;do if(b[l+40>>0]|0){u=f[l+56>>2]|0;if(!u){v=(f[l+24>>2]|0)+72|0;break}else{v=u+68|0;break}}else v=(f[l+48>>2]|0)+28|0;while(0);if((d|0)>=(t-(f[v>>2]|0)|0)){p=r;return p|0}f[a>>2]=i;f[c>>2]=t;p=h+4|0;return p|0}function UOb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;switch(c-a>>2|0){case 2:{d=c+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=e;i=g;do if(b[e+40>>0]|0){j=f[e+56>>2]|0;if(!j){k=(f[e+24>>2]|0)+72|0;break}else{k=j+68|0;break}}else k=(f[e+48>>2]|0)+28|0;while(0);e=h-(f[k>>2]|0)|0;do if(b[g+40>>0]|0){k=f[g+56>>2]|0;if(!k){l=(f[g+24>>2]|0)+72|0;break}else{l=k+68|0;break}}else l=(f[g+48>>2]|0)+28|0;while(0);if((e|0)>=(i-(f[l>>2]|0)|0)){m=1;return m|0}f[a>>2]=h;f[d>>2]=i;m=1;return m|0}case 3:{ROb(a,a+4|0,c+-4|0)|0;m=1;return m|0}case 4:{SOb(a,a+4|0,a+8|0,c+-4|0)|0;m=1;return m|0}case 5:{TOb(a,a+4|0,a+8|0,a+12|0,c+-4|0)|0;m=1;return m|0}case 1:case 0:{m=1;return m|0}default:{i=a+8|0;ROb(a,a+4|0,i)|0;d=a+12|0;a:do if((d|0)==(c|0)){n=1;o=0}else{h=d;l=0;e=i;while(1){g=f[h>>2]|0;k=f[e>>2]|0;j=(b[g+40>>0]|0)==0;p=g;do if(!j){q=f[g+56>>2]|0;if(!q){r=(f[g+24>>2]|0)+72|0;break}else{r=q+68|0;break}}else r=(f[g+48>>2]|0)+28|0;while(0);q=p-(f[r>>2]|0)|0;s=k;do if(b[k+40>>0]|0){t=f[k+56>>2]|0;if(!t){u=(f[k+24>>2]|0)+72|0;break}else{u=t+68|0;break}}else u=(f[k+48>>2]|0)+28|0;while(0);if((q|0)<(s-(f[u>>2]|0)|0)){k=g+48|0;t=g+56|0;v=g+24|0;w=e;x=h;while(1){f[x>>2]=f[w>>2];if((w|0)==(a|0))break;y=w+-4|0;z=f[y>>2]|0;do if(!j){A=f[t>>2]|0;if(!A){B=(f[v>>2]|0)+72|0;break}else{B=A+68|0;break}}else B=(f[k>>2]|0)+28|0;while(0);A=p-(f[B>>2]|0)|0;C=z;do if(b[z+40>>0]|0){D=f[z+56>>2]|0;if(!D){E=(f[z+24>>2]|0)+72|0;break}else{E=D+68|0;break}}else E=(f[z+48>>2]|0)+28|0;while(0);if((A|0)<(C-(f[E>>2]|0)|0)){z=w;w=y;x=z}else break}f[w>>2]=p;x=l+1|0;if((x|0)==8){n=0;o=(h+4|0)==(c|0);break a}else F=x}else F=l;x=h+4|0;if((x|0)==(c|0)){n=1;o=0;break}else{k=h;h=x;l=F;e=k}}}while(0);m=o|n;return m|0}}return 0}function VOb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=b;e=a+4|0;g=f[e>>2]|0;do if(g){h=a+4|0;i=g;j=g;while(1){k=f[i+16>>2]|0;if(k>>>0>b>>>0){l=f[i>>2]|0;if(!l){m=6;break}else{n=i;o=l}}else{if(k>>>0>=b>>>0){m=10;break}p=i+4|0;k=f[p>>2]|0;if(!k){m=9;break}else{n=p;o=k}}h=n;i=o;j=o}if((m|0)==6){q=i;r=i;m=13;break}else if((m|0)==9){q=p;r=i;m=13;break}else if((m|0)==10){s=h;t=i;u=j;m=12;break}}else{s=e;t=e;u=g;m=12}while(0);if((m|0)==12)if(!u){q=s;r=t;m=13}else v=u;if((m|0)==13){m=L5b(32)|0;f[m+16>>2]=d;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=r;f[q>>2]=m;r=f[f[a>>2]>>2]|0;if(!r)w=m;else{f[a>>2]=r;w=f[q>>2]|0}mP(f[a+4>>2]|0,w);w=a+8|0;f[w>>2]=(f[w>>2]|0)+1;v=m}m=v+24|0;w=f[m>>2]|0;if((w|0)==(f[v+28>>2]|0)){WOb(v+20|0,c);return}else{v=c;c=f[v+4>>2]|0;a=w;f[a>>2]=f[v>>2];f[a+4>>2]=c;f[m>>2]=(f[m>>2]|0)+8;return}}function WOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;O5b(d);return}function XOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;c=u;u=u+16|0;d=c;e=b;g=L5b(24)|0;h=g+4|0;f[h>>2]=0;f[g+8>>2]=0;f[g>>2]=h;h=g+16|0;f[h>>2]=0;f[g+20>>2]=0;f[g+12>>2]=h;f[d>>2]=g;g=a+12|0;h=a+16|0;i=f[h>>2]|0;do if(i){j=a+16|0;k=i;l=i;while(1){m=f[k+16>>2]|0;if(m>>>0>b>>>0){n=f[k>>2]|0;if(!n){o=6;break}else{p=k;q=n}}else{if(m>>>0>=b>>>0){o=10;break}r=k+4|0;m=f[r>>2]|0;if(!m){o=9;break}else{p=r;q=m}}j=p;k=q;l=q}if((o|0)==6){s=k;t=k;o=13;break}else if((o|0)==9){s=r;t=k;o=13;break}else if((o|0)==10){v=j;w=k;x=l;o=12;break}}else{v=h;w=h;x=i;o=12}while(0);if((o|0)==12)if(!x){s=v;t=w;o=13}else y=x;if((o|0)==13){o=L5b(32)|0;f[o+16>>2]=e;f[o+20>>2]=0;f[o+24>>2]=0;f[o+28>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=t;f[s>>2]=o;t=f[f[g>>2]>>2]|0;if(!t)z=o;else{f[g>>2]=t;z=f[s>>2]|0}mP(f[a+16>>2]|0,z);z=a+20|0;f[z>>2]=(f[z>>2]|0)+1;y=o}o=y+24|0;z=f[o>>2]|0;if((z|0)==(f[y+28>>2]|0)){YOb(y+20|0,d);A=f[d>>2]|0;u=c;return A|0}else{f[z>>2]=f[d>>2];f[o>>2]=(f[o>>2]|0)+4;A=f[d>>2]|0;u=c;return A|0}return 0}function YOb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function ZOb(a){a=a|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;d[a+16>>1]=0;b[a+18>>0]=0;return}function _Ob(a){a=a|0;return}function $Ob(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+160|0;g=e+152|0;h=e;bi[f[(f[d>>2]|0)+28>>2]&2047](d);i=(b[a+18>>0]^1)&255;zh[f[(f[d>>2]|0)+96>>2]&2047](g,d);aPb(h,f[g>>2]|0,c,f[a>>2]|0,f[a+4>>2]|0,f[a+8>>2]|0,i,(b[a+13>>0]|0)!=0,(b[a+14>>0]|0)!=0,(b[a+15>>0]|0)!=0,(b[a+16>>0]|0)!=0,(b[a+17>>0]|0)!=0,(b[a+12>>0]|0)!=0);i=bPb(a,0,d,h)|0;vIb(h+20|0);u=e;return i|0}function aPb(a,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;f[a>>2]=e;f[a+4>>2]=g;f[a+8>>2]=h;h=a+12|0;f[h>>2]=141284;f[a+16>>2]=a;g=a+20|0;uIb(g,d,h);f[a+132>>2]=c;f[a+136>>2]=i;b[a+140>>0]=j&1;b[a+141>>0]=k&1;b[a+142>>0]=l&1;b[a+143>>0]=m&1;b[a+144>>0]=o&1;b[a+145>>0]=0;b[a+120>>0]=1;f[a+124>>2]=1;if(!n){BIb(g)|0;return}b[a+128>>0]=0;b[a+129>>0]=1;BIb(g)|0;return}function bPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+80|0;g=c+40|0;h=c+24|0;i=c+12|0;j=c;k=e+20|0;while(1){if((f[k>>2]|0)==1)break;if(!(cPb(e,d)|0)){l=0;m=24;break}}if((m|0)==24){u=c;return l|0}if(b[e+145>>0]|0){l=0;u=c;return l|0}if(b[a+12>>0]|0){l=1;u=c;return l|0}if(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0){l=1;u=c;return l|0}f[h>>2]=0;a=h+4|0;f[a>>2]=0;f[h+8>>2]=0;CNb(d,h);f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;d=f[h>>2]|0;m=f[a>>2]|0;if((d|0)!=(m|0)){k=g+4|0;n=d;do{if((n|0)!=(d|0))k6b(j,489325)|0;o=b[n+11>>0]|0;p=o<<24>>24<0;f[g>>2]=p?f[n>>2]|0:n;f[k>>2]=p?f[n+4>>2]|0:o&255;ISb(j,g);n=n+12|0}while((n|0)!=(m|0))}dua(i,476056,j);dPb(e,-1,0,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);j=f[h>>2]|0;if(j|0){i=f[a>>2]|0;if((i|0)==(j|0))q=j;else{e=i;while(1){i=e+-12|0;f[a>>2]=i;if((b[i+11>>0]|0)<0){O5b(f[i>>2]|0);r=f[a>>2]|0}else r=i;if((r|0)==(j|0))break;else e=r}q=f[h>>2]|0}O5b(q)}l=0;u=c;return l|0}function cPb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;d=u;u=u+128|0;e=d+108|0;g=d;h=d+96|0;i=d+92|0;j=d+88|0;k=d+48|0;l=d+36|0;m=d+24|0;n=d+64|0;o=d+120|0;p=d+12|0;q=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;zh[f[(f[c>>2]|0)+96>>2]&2047](e,c);r=f[e>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;s=a+20|0;t=a+36|0;v=f[t>>2]|0;w=a+40|0;x=f[w>>2]|0;a:do if(KSb(c,i,j)|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=91;b[e+1>>0]=0;y=a+24|0;z=y+11|0;A=b[z>>0]|0;B=A<<24>>24<0;C=a+28|0;D=A&255;b:do if(((B?f[C>>2]|0:D)|0)==1){A=f[y>>2]|0;c:do if(B){if((b[A>>0]|0)!=(b[e>>0]|0))break b}else{if((A&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break b;E=y;F=D;G=e;while(1){F=F+-1|0;E=E+1|0;if(!F)break c;G=G+1|0;if((b[E>>0]|0)!=(b[G>>0]|0))break b}}while(0);BIb(s)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(ePb(a,g,k)|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;A=e+11|0;b[A>>0]=1;b[e>>0]=93;b[e+1>>0]=0;G=fPb(a,e)|0;if((b[A>>0]|0)<0)O5b(f[e>>2]|0);if(G){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=58;b[e+1>>0]=0;G=b[z>>0]|0;A=G<<24>>24<0;E=G&255;d:do if(((A?f[C>>2]|0:E)|0)==1){G=f[y>>2]|0;e:do if(A){if((b[G>>0]|0)!=(b[e>>0]|0))break d}else{if((G&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break d;F=y;H=E;I=e;while(1){H=H+-1|0;F=F+1|0;if(!H)break e;I=I+1|0;if((b[F>>0]|0)!=(b[I>>0]|0))break d}}while(0);BIb(s)|0}while(0);E=f[(f[c>>2]|0)+96>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;zh[E&2047](e,c);f:do if(gPb(a,g,f[(f[(f[e>>2]|0)+8>>2]|0)+8>>2]|0,l)|0){do if((f[a+136>>2]|0)==1){E=f[i>>2]|0;if(!((f[E+36>>2]|0)!=3?li[f[(f[q>>2]|0)+20>>2]&511](q,c,E)|0:0))J=27;if((J|0)==27){E=f[j>>2]|0;if((f[E+36>>2]|0)==3)break;if(!(li[f[(f[q>>2]|0)+20>>2]&511](q,c,E)|0))break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;E=L5b(48)|0;f[e>>2]=E;f[e+8>>2]=-2147483600;f[e+4>>2]=42;A=E;G=476119;I=A+42|0;do{b[A>>0]=b[G>>0]|0;A=A+1|0;G=G+1|0}while((A|0)<(I|0));b[E+42>>0]=0;dPb(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);K=0;break f}while(0);G=f[(f[q>>2]|0)+144>>2]|0;A=f[i>>2]|0;Ccb(e,k,g);th[G&511](q,c,A,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);th[f[(f[q>>2]|0)+144>>2]&511](q,c,f[j>>2]|0,l);K=1}else K=0;while(0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);L=K}else L=0}else L=0;if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);M=L;break a}while(0);N=y;O=z;P=C;J=43}else{D=a+24|0;N=D;O=D+11|0;P=a+28|0;J=43}while(0);g:do if((J|0)==43){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=91;b[e+1>>0]=0;L=b[O>>0]|0;K=L<<24>>24<0;j=L&255;h:do if(((K?f[P>>2]|0:j)|0)==1){L=f[a+24>>2]|0;i:do if(K){if((b[L>>0]|0)!=(b[e>>0]|0)){J=77;break h}}else{if((L&255)<<24>>24!=(f[e>>2]&255)<<24>>24){J=77;break h}i=N;D=j;B=e;while(1){D=D+-1|0;i=i+1|0;if(!D)break i;B=B+1|0;if((b[i>>0]|0)!=(b[B>>0]|0)){J=77;break h}}}while(0);BIb(s)|0;if(!(hPb(a,h)|0)){M=0;break g};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;L=e+11|0;b[L>>0]=1;b[e>>0]=93;b[e+1>>0]=0;B=fPb(a,e)|0;if((b[L>>0]|0)<0)O5b(f[e>>2]|0);if(!B){M=0;break g}B=f[a+4>>2]|0;if(!B)Q=Uh[f[(f[q>>2]|0)+308>>2]&1023](q,h)|0;else Q=li[f[(f[B>>2]|0)+8>>2]&511](B,c,h)|0;if(!Q)if(!(b[a+141>>0]|0)){dua(l,476162,h);eua(k,l,476174);Ccb(g,k,f[r+4>>2]|0);eua(e,g,476219);dPb(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);M=0;break g}else{dua(l,476162,h);eua(k,l,476174);Ccb(g,k,f[r+4>>2]|0);eua(e,g,476219);iPb(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);J=132;break}else R=Q}else J=77;while(0);do if((J|0)==77){if(!(jPb(a,h)|0)){M=0;break g}do if((b[a+143>>0]|0)!=0?DSb(h,e)|0:0){j=(wub(r,f[e>>2]|0)|0)==0;K=f[e>>2]|0;if(j){S=oub(r,K)|0;J=111;break}else{S=Uh[f[(f[q>>2]|0)+312>>2]&1023](q,K)|0;J=111;break}}else J=83;while(0);j:do if((J|0)==83){K=rub(r,h)|0;if(!K){X5b(g,h);j=g+11|0;C=b[j>>0]|0;z=C<<24>>24<0;y=f[g>>2]|0;B=z?y+(f[g+4>>2]|0)|0:g+(C&255)|0;C=z?y:g;if((C|0)!=(B|0)){y=C;do{C=b[y>>0]|0;if((C+-65&255)<26)b[y>>0]=(C&255)+32;y=y+1|0}while((y|0)!=(B|0))}B=rub(r,g)|0;if(!B)T=0;else T=(f[B+32>>2]|0)==10?B:0;if((b[j>>0]|0)<0)O5b(f[g>>2]|0);if(T|0){U=T;J=93}}else{U=K;J=93}k:do if((J|0)==93){if((f[U+32>>2]|0)!=10){V=U;J=130;break j}B=f[f[U+60>>2]>>2]|0;y=b[B+11>>0]|0;C=y<<24>>24<0;z=y&255;y=C?f[B+4>>2]|0:z;L=b[h+11>>0]|0;i=L<<24>>24<0;if((y|0)==((i?f[h+4>>2]|0:L&255)|0)){L=f[B>>2]|0;D=C?L:B;A=i?f[h>>2]|0:h;i=(y|0)==0;if(C){if(i){V=U;J=130;break j}if(!(ZVb(D,A,y)|0)){V=U;J=130;break j}else break}if(i){V=U;J=130;break j}if((L&255)<<24>>24==(b[A>>0]|0)){L=B;B=z;z=A;while(1){B=B+-1|0;L=L+1|0;if(!B)break;z=z+1|0;if((b[L>>0]|0)!=(b[z>>0]|0))break k}if(U|0){V=U;J=130;break j}}}}while(0);if(b[a+140>>0]|0){X5b(g,h);K=g+11|0;j=b[K>>0]|0;z=j<<24>>24<0;L=f[g>>2]|0;B=z?L+(f[g+4>>2]|0)|0:g+(j&255)|0;j=z?L:g;if((j|0)!=(B|0)){L=j;do{j=b[L>>0]|0;if((j+-65&255)<26)b[L>>0]=(j&255)+32;L=L+1|0}while((L|0)!=(B|0))}B=pub(r,g)|0;if((b[K>>0]|0)<0)O5b(f[g>>2]|0);S=B;J=111}}while(0);if((J|0)==111?S|0:0){V=S;J=130}if((J|0)==130){R=V;break}if(!(b[a+141>>0]|0)){dua(m,476222,f[r+4>>2]|0);eua(l,m,476237);Ccb(k,l,h);eua(g,k,476219);dPb(a,f[t>>2]|0,f[w>>2]|0,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);M=0;break g}else{dua(m,476222,f[r+4>>2]|0);eua(l,m,476237);Ccb(k,l,h);eua(g,k,476219);iPb(a,f[t>>2]|0,f[w>>2]|0,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);J=132;break}}while(0);if((J|0)==132){if(!(b[a+141>>0]|0)){zpb(n,3,475815,484);xpb(o,vpb(n,476260)|0);Apb(n)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=58;b[e+1>>0]=0;B=b[O>>0]|0;L=B<<24>>24<0;j=B&255;l:do if(((L?f[P>>2]|0:j)|0)==1){B=a+24|0;z=f[B>>2]|0;m:do if(L){if((b[z>>0]|0)!=(b[e>>0]|0)){J=152;break l}}else{if((z&255)<<24>>24==(f[e>>2]&255)<<24>>24){W=N;X=j;Y=e}else{J=152;break l}while(1){X=X+-1|0;W=W+1|0;if(!X)break m;Y=Y+1|0;if((b[W>>0]|0)!=(b[Y>>0]|0)){J=152;break l}}}while(0);BIb(s)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=123;b[g+1>>0]=0;z=b[O>>0]|0;K=z<<24>>24<0;E=z&255;z=((K?f[P>>2]|0:E)|0)==1;n:do if(z){A=f[B>>2]|0;o:do if(K){if((b[A>>0]|0)!=(b[g>>0]|0))break n}else{if((A&255)<<24>>24==(f[g>>2]&255)<<24>>24){Z=N;_=E;$=g}else break n;while(1){_=_+-1|0;Z=Z+1|0;if(!_)break o;$=$+1|0;if((b[Z>>0]|0)!=(b[$>>0]|0))break n}}while(0);break l}while(0);f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[k+11>>0]=1;b[k>>0]=60;b[k+1>>0]=0;p:do if(z){A=f[B>>2]|0;if(K)if((b[A>>0]|0)==(b[k>>0]|0))break l;else break;if((A&255)<<24>>24==(f[k>>2]&255)<<24>>24){A=N;i=E;y=k;while(1){i=i+-1|0;A=A+1|0;if(!i)break;y=y+1|0;if((b[A>>0]|0)!=(b[y>>0]|0)){J=154;break p}}break l}else J=154}else J=154;while(0);M=kPb(a)|0;break g}else J=152;while(0);M=lPb(a)|0;break}if((f[a+136>>2]|0)==1){if((f[R+36>>2]|0)!=3?li[f[(f[q>>2]|0)+20>>2]&511](q,c,R)|0:0){dua(g,476297,h);eua(e,g,476318);dPb(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);M=0;break}j=f[R+52>>2]|0;if(j|0?li[f[(f[q>>2]|0)+32>>2]&511](q,c,j)|0:0){L=li[f[(f[q>>2]|0)+40>>2]&511](q,c,j)|0;dua(p,476349,h);eua(m,p,476357);Ccb(l,m,f[L>>2]|0);eua(k,l,476391);Ccb(g,k,f[j>>2]|0);eua(e,g,476219);dPb(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);if((b[p+11>>0]|0)<0)O5b(f[p>>2]|0);M=0;break}}j=R+32|0;if((f[136e3+(f[j>>2]<<2)>>2]|0)!=10){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;L=e+11|0;b[L>>0]=1;b[e>>0]=58;b[e+1>>0]=0;E=fPb(a,e)|0;if((b[L>>0]|0)<0)O5b(f[e>>2]|0);if(!E){M=0;break}}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=58;b[e+1>>0]=0;E=b[O>>0]|0;L=E<<24>>24<0;K=E&255;q:do if(((L?f[P>>2]|0:K)|0)==1){E=f[a+24>>2]|0;r:do if(L){if((b[E>>0]|0)!=(b[e>>0]|0))break q}else{if((E&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break q;B=N;z=K;y=e;while(1){z=z+-1|0;B=B+1|0;if(!z)break r;y=y+1|0;if((b[B>>0]|0)!=(b[y>>0]|0))break q}}while(0);BIb(s)|0}while(0)}s:do if((f[R+36>>2]|0)==3){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=91;b[e+1>>0]=0;K=b[O>>0]|0;L=K<<24>>24<0;E=K&255;t:do if(((L?f[P>>2]|0:E)|0)==1){K=f[a+24>>2]|0;u:do if(L){if((b[K>>0]|0)!=(b[e>>0]|0))break t}else{if((K&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break t;y=N;B=E;z=e;while(1){B=B+-1|0;y=y+1|0;if(!B)break u;z=z+1|0;if((b[y>>0]|0)!=(b[z>>0]|0))break t}}while(0);BIb(s)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=93;b[e+1>>0]=0;K=b[O>>0]|0;z=K<<24>>24<0;y=K&255;v:do if(((z?f[P>>2]|0:y)|0)==1){K=f[a+24>>2]|0;w:do if(z){if((b[K>>0]|0)!=(b[e>>0]|0))break v}else{if((K&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break v;B=N;A=y;i=e;while(1){A=A+-1|0;B=B+1|0;if(!A)break w;i=i+1|0;if((b[B>>0]|0)!=(b[i>>0]|0))break v}}while(0);BIb(s)|0;break s}while(0);y=e+11|0;z=e+1|0;K=a+24|0;i=e+11|0;B=e+1|0;x:while(1){if((f[136e3+(f[j>>2]<<2)>>2]|0)==10){if(!(mPb(a,c,q,R)|0)){M=0;break g}}else if(!(nPb(a,c,q,R)|0)){M=0;break g};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[y>>0]=1;b[e>>0]=93;b[z>>0]=0;A=b[O>>0]|0;D=A<<24>>24<0;C=A&255;do if(((D?f[P>>2]|0:C)|0)==1){A=f[K>>2]|0;if(D)if((b[A>>0]|0)==(b[e>>0]|0))break x;else break;if((A&255)<<24>>24==(f[e>>2]&255)<<24>>24){A=N;G=C;I=e;do{G=G+-1|0;A=A+1|0;if(!G)break x;I=I+1|0}while((b[A>>0]|0)==(b[I>>0]|0))}}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[i>>0]=1;b[e>>0]=44;b[B>>0]=0;C=fPb(a,e)|0;if((b[i>>0]|0)<0)O5b(f[e>>2]|0);if(!C){M=0;break g}}BIb(s)|0;break s}while(0);J=225}else J=225;while(0);do if((J|0)==225)if((f[136e3+(f[j>>2]<<2)>>2]|0)==10)if(mPb(a,c,q,R)|0)break;else{M=0;break g}else if(nPb(a,c,q,R)|0)break;else{M=0;break g}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=59;b[e+1>>0]=0;j=b[O>>0]|0;E=j<<24>>24<0;L=j&255;j=((E?f[P>>2]|0:L)|0)==1;y:do if(j){i=f[a+24>>2]|0;z:do if(E){if((b[i>>0]|0)!=(b[e>>0]|0)){J=236;break y}}else{if((i&255)<<24>>24!=(f[e>>2]&255)<<24>>24){J=236;break y}B=N;K=L;z=e;while(1){K=K+-1|0;B=B+1|0;if(!K)break z;z=z+1|0;if((b[B>>0]|0)!=(b[z>>0]|0)){J=236;break y}}}while(0);BIb(s)|0}else J=236;while(0);if((J|0)==236){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=44;b[g+1>>0]=0;A:do if(j){i=f[a+24>>2]|0;B:do if(E){if((b[i>>0]|0)!=(b[g>>0]|0))break A}else{if((i&255)<<24>>24!=(f[g>>2]&255)<<24>>24)break A;z=N;B=L;K=g;while(1){B=B+-1|0;z=z+1|0;if(!B)break B;K=K+1|0;if((b[z>>0]|0)!=(b[K>>0]|0))break A}}while(0);BIb(s)|0}while(0)}if(b[(f[R+68>>2]|0)+58>>0]|0){dua(g,476420,h);eua(e,g,476054);iPb(a,f[t>>2]|0,f[w>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0)}L=f[a+8>>2]|0;if(!L)M=1;else{E=g;f[E>>2]=v;f[E+4>>2]=x;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];VOb(L,R,e);M=1}}while(0);if((b[h+11>>0]|0)>=0){u=d;return M|0}O5b(f[h>>2]|0);u=d;return M|0}function dPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+64|0;h=g+24|0;i=g;b[a+145>>0]=1;j=f[a>>2]|0;if(j|0){th[f[(f[j>>2]|0)+8>>2]&511](j,c,d,e);u=g;return}if((c|0)>-1){zpb(h,2,475815,298);j=vpb(h,476090)|0;xpb(g+49|0,wpb(vpb(ypb(vpb(ypb(vpb(wpb(j,f[(f[a+132>>2]|0)+4>>2]|0)|0,475786)|0,c+1|0)|0,476117)|0,d+1|0)|0,475786)|0,e)|0);Apb(h);u=g;return}else{zpb(i,2,475815,303);h=vpb(i,476090)|0;xpb(g+48|0,wpb(vpb(wpb(h,f[(f[a+132>>2]|0)+4>>2]|0)|0,475786)|0,e)|0);Apb(i);u=g;return}}function ePb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+96|0;g=e+84|0;h=e+72|0;i=e+60|0;j=e+48|0;k=e+36|0;l=e+24|0;m=e+12|0;n=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;do if(jPb(a,g)|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;o=j+11|0;b[o>>0]=1;b[j>>0]=46;b[j+1>>0]=0;p=fPb(a,j)|0;if((b[o>>0]|0)<0)O5b(f[j>>2]|0);if(p?jPb(a,h)|0:0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;p=j+11|0;b[p>>0]=1;b[j>>0]=46;b[j+1>>0]=0;o=fPb(a,j)|0;if((b[p>>0]|0)<0)O5b(f[j>>2]|0);if(o?jPb(a,i)|0:0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;o=j+11|0;b[o>>0]=1;b[j>>0]=47;b[j+1>>0]=0;p=fPb(a,j)|0;if((b[o>>0]|0)<0)O5b(f[j>>2]|0);if(p?hPb(a,c)|0:0){eua(n,g,489392);Ccb(m,n,h);eua(l,m,489392);Ccb(k,l,i);eua(j,k,489196);_5b(d,j)|0;if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);if((b[n+11>>0]|0)<0)O5b(f[n>>2]|0);p=kUb(481740)|0;o=d+11|0;q=b[o>>0]|0;r=d+4|0;s=f[r>>2]|0;if((p|0)==((q<<24>>24<0?s:q&255)|0)){if(!(u6b(d,0,-1,481740,p)|0)){t=1;break}v=b[o>>0]|0;w=f[r>>2]|0}else{v=q;w=s}s=kUb(481761)|0;if((s|0)==((v<<24>>24<0?w:v&255)|0)?(u6b(d,0,-1,481761,s)|0)==0:0){t=1;break}dua(k,477007,d);eua(j,k,476054);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,j);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);t=0}else t=0}else t=0}else t=0}else t=0;while(0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[g+11>>0]|0)>=0){u=e;return t|0}O5b(f[g>>2]|0);u=e;return t|0}function fPb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+48|0;e=d+36|0;g=d+24|0;h=d+12|0;i=d;j=a+20|0;k=a+24|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=l&255;l=m?f[a+28>>2]|0:n;o=b[c+11>>0]|0;p=o<<24>>24<0;a:do if((l|0)==((p?f[c+4>>2]|0:o&255)|0)){q=f[k>>2]|0;r=m?q:k;s=p?f[c>>2]|0:c;t=(l|0)==0;b:do if(m){if(!t?ZVb(r,s,l)|0:0)break a}else if(!t){if((q&255)<<24>>24==(b[s>>0]|0)){v=k;w=n;x=s}else break a;while(1){w=w+-1|0;v=v+1|0;if(!w)break b;x=x+1|0;if((b[v>>0]|0)!=(b[x>>0]|0))break a}}while(0);BIb(j)|0;y=1;u=d;return y|0}while(0);dua(i,476985,c);eua(h,i,476996);Ccb(g,h,k);eua(e,g,476219);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);y=0;u=d;return y|0}function gPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+80|0;h=g+48|0;i=g+36|0;j=g+24|0;k=g+12|0;l=g;m=jub(d,c)|0;if(!m){dua(i,476854,c);eua(h,i,476876);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);n=0;u=g;return n|0}rFb(h);d=pFb(h,m)|0;if(d){m=di[f[(f[d>>2]|0)+12>>2]&1023](d)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;do if(sPb(a,i)|0){X5b(j,i);d=tPb(a,m,j)|0;if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if(d){if(b[a+144>>0]|0){Zob(m,e)|0;o=1;break}if(di[f[(f[m>>2]|0)+32>>2]&1023](m)|0){Yob(m,e)|0;o=1;break}dua(l,476909,c);eua(k,l,476925);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,k);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);o=0}else o=0}else o=0;while(0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if(!m)p=o;else{bi[f[(f[m>>2]|0)+4>>2]&2047](m);p=o}}else p=0;nFb(h);n=p;u=g;return n|0}function hPb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;if(!(jPb(a,c)|0)){g=0;u=d;return g|0}h=e+11|0;i=e+1|0;j=a+20|0;k=a+24|0;l=k+11|0;m=a+28|0;n=e+11|0;o=e+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[h>>0]=1;b[e>>0]=46;b[i>>0]=0;p=b[l>>0]|0;q=p<<24>>24<0;r=p&255;a:do if(((q?f[m>>2]|0:r)|0)==1){p=r;s=q;while(1){t=f[k>>2]|0;b:do if(s){if((b[t>>0]|0)!=(b[e>>0]|0))break a}else{if((t&255)<<24>>24==(f[e>>2]&255)<<24>>24){v=k;w=p;x=e}else break a;while(1){w=w+-1|0;v=v+1|0;if(!w)break b;x=x+1|0;if((b[v>>0]|0)!=(b[x>>0]|0))break a}}while(0);BIb(j)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(!(jPb(a,e)|0))break;k6b(c,489392)|0;t=b[n>>0]|0;y=t<<24>>24<0;j6b(c,y?f[e>>2]|0:e,y?f[o>>2]|0:t&255)|0;if((b[n>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[h>>0]=1;b[e>>0]=46;b[i>>0]=0;t=b[l>>0]|0;s=t<<24>>24<0;p=t&255;if(((s?f[m>>2]|0:p)|0)!=1)break a}if((b[n>>0]|0)<0)O5b(f[e>>2]|0);g=0;u=d;return g|0}while(0);g=1;u=d;return g|0}function iPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+64|0;g=e+24|0;h=e;i=f[a>>2]|0;if(i|0){th[f[(f[i>>2]|0)+12>>2]&511](i,b,c,d);u=e;return}if((b|0)>-1){zpb(g,1,475815,315);i=vpb(g,476825)|0;xpb(e+49|0,wpb(vpb(ypb(vpb(ypb(vpb(wpb(i,f[(f[a+132>>2]|0)+4>>2]|0)|0,475786)|0,b+1|0)|0,476117)|0,c+1|0)|0,475786)|0,d)|0);Apb(g);u=e;return}else{zpb(h,1,475815,320);g=vpb(h,476825)|0;xpb(e+48|0,wpb(vpb(wpb(g,f[(f[a+132>>2]|0)+4>>2]|0)|0,475786)|0,d)|0);Apb(h);u=e;return}}function jPb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=f[a+20>>2]|0;if((g|0)==2){_5b(c,a+24|0)|0;BIb(a+20|0)|0;h=1;u=d;return h|0}if(!(b[a+143>>0]|0)){if((b[a+141>>0]|0)!=0&(g|0)==3)i=6}else if((g|0)==3)i=6;if((i|0)==6){_5b(c,a+24|0)|0;BIb(a+20|0)|0;h=1;u=d;return h|0}dua(e,476798,a+24|0);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);h=0;u=d;return h|0}function kPb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;c=u;u=u+32|0;d=c+12|0;e=c;g=a+20|0;if((f[g>>2]|0)==5){h=a+20|0;do BIb(h)|0;while((f[g>>2]|0)==5);i=1;u=c;return i|0};f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;b[d+11>>0]=1;b[d>>0]=91;b[d+1>>0]=0;h=a+20|0;j=a+24|0;k=j+11|0;l=b[k>>0]|0;m=l<<24>>24<0;n=a+28|0;o=l&255;a:do if(((m?f[n>>2]|0:o)|0)==1){l=f[j>>2]|0;b:do if(m){if((b[l>>0]|0)!=(b[d>>0]|0))break a}else{if((l&255)<<24>>24!=(f[d>>2]&255)<<24>>24)break a;p=j;q=o;r=d;while(1){q=q+-1|0;p=p+1|0;if(!q)break b;r=r+1|0;if((b[p>>0]|0)!=(b[r>>0]|0))break a}}while(0);BIb(h)|0;l=d+11|0;r=d+1|0;p=d+11|0;q=d+1|0;s=d+11|0;t=d+1|0;v=e+11|0;w=e+1|0;c:while(1){f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;b[l>>0]=1;b[d>>0]=123;b[r>>0]=0;x=b[k>>0]|0;y=x<<24>>24<0;z=x&255;x=((y?f[n>>2]|0:z)|0)==1;d:do if(x){A=f[j>>2]|0;e:do if(y)if((b[A>>0]|0)==(b[d>>0]|0))B=24;else B=18;else if((A&255)<<24>>24==(f[d>>2]&255)<<24>>24){C=j;D=z;E=d;while(1){D=D+-1|0;C=C+1|0;if(!D){B=24;break e}E=E+1|0;if((b[C>>0]|0)!=(b[E>>0]|0)){B=18;break}}}else B=18;while(0);do if((B|0)==18){B=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[v>>0]=1;b[e>>0]=60;b[w>>0]=0;if(!x){B=26;break d}A=f[j>>2]|0;if(y)if((b[A>>0]|0)==(b[e>>0]|0))break;else{B=28;break d}if((A&255)<<24>>24==(f[e>>2]&255)<<24>>24){F=j;G=z;H=e}else{B=26;break d}while(1){G=G+-1|0;F=F+1|0;if(!G)break;H=H+1|0;if((b[F>>0]|0)!=(b[H>>0]|0)){B=26;break d}}}else if((B|0)==24)B=0;while(0);if(!(lPb(a)|0)){i=0;B=72;break c}}else{f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[v>>0]=1;b[e>>0]=60;b[w>>0]=0;B=26}while(0);if((B|0)==26){B=0;B=28}if((B|0)==28?(B=0,!(kPb(a)|0)):0){i=0;B=72;break};f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;b[p>>0]=1;b[d>>0]=93;b[q>>0]=0;z=b[k>>0]|0;y=z<<24>>24<0;x=z&255;do if(((y?f[n>>2]|0:x)|0)==1){z=f[j>>2]|0;if(y)if((b[z>>0]|0)==(b[d>>0]|0)){B=36;break c}else break;if((z&255)<<24>>24==(f[d>>2]&255)<<24>>24){z=j;A=x;E=d;do{A=A+-1|0;z=z+1|0;if(!A){B=36;break c}E=E+1|0}while((b[z>>0]|0)==(b[E>>0]|0))}}while(0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;b[s>>0]=1;b[d>>0]=44;b[t>>0]=0;x=fPb(a,d)|0;if((b[s>>0]|0)<0)O5b(f[d>>2]|0);if(!x){i=0;B=72;break}}if((B|0)==36){BIb(h)|0;i=1;u=c;return i|0}else if((B|0)==72){u=c;return i|0}}while(0);f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;b[d+11>>0]=1;b[d>>0]=45;b[d+1>>0]=0;H=b[k>>0]|0;k=H<<24>>24<0;F=H&255;f:do if(((k?f[n>>2]|0:F)|0)==1){H=f[j>>2]|0;g:do if(k){if((b[H>>0]|0)!=(b[d>>0]|0)){I=0;break f}}else{if((H&255)<<24>>24!=(f[d>>2]&255)<<24>>24){I=0;break f}G=j;o=F;m=d;while(1){o=o+-1|0;G=G+1|0;if(!o)break g;m=m+1|0;if((b[G>>0]|0)!=(b[m>>0]|0)){I=0;break f}}}while(0);BIb(h)|0;I=1}else I=0;while(0);F=f[g>>2]|0;if((F+-2|0)>>>0>=3){i=0;u=c;return i|0}if(I&(F|0)==2){X5b(d,j);j=d+11|0;F=b[j>>0]|0;I=F<<24>>24<0;g=f[d>>2]|0;k=d+4|0;n=f[k>>2]|0;H=I?g+n|0:d+(F&255)|0;m=I?g:d;if((m|0)==(H|0)){J=F;K=n}else{n=m;do{m=b[n>>0]|0;if((m+-65&255)<26)b[n>>0]=(m&255)+32;n=n+1|0}while((n|0)!=(H|0));J=b[j>>0]|0;K=f[k>>2]|0}if(((J<<24>>24<0?K:J&255)|0)==3){if(u6b(d,0,-1,483237,3)|0){L=b[j>>0]|0;M=f[k>>2]|0;B=58}}else{L=J;M=K;B=58}do if((B|0)==58){if(((L<<24>>24<0?M:L&255)|0)==8){if(!(u6b(d,0,-1,485157,8)|0))break;N=b[j>>0]|0;O=f[k>>2]|0}else{N=L;O=M}if(((N<<24>>24<0?O:N&255)|0)==3?(u6b(d,0,-1,485166,3)|0)==0:0)break;dua(e,476775,d);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if((b[j>>0]|0)<0)O5b(f[d>>2]|0);i=0;u=c;return i|0}while(0);if((b[j>>0]|0)<0)O5b(f[d>>2]|0)}BIb(h)|0;i=1;u=c;return i|0}function lPb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;c=u;u=u+48|0;d=c+24|0;e=c+12|0;g=c;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a:do if(sPb(a,d)|0){h=e+11|0;i=e+1|0;j=a+24|0;k=j+11|0;l=a+28|0;m=g+11|0;n=g+1|0;b:while(1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[h>>0]=1;b[e>>0]=62;b[i>>0]=0;o=b[k>>0]|0;p=o<<24>>24<0;q=o&255;o=((p?f[l>>2]|0:q)|0)==1;do if(o){r=f[j>>2]|0;if(p){if((b[r>>0]|0)==(b[e>>0]|0)){s=15;break b}}else if((r&255)<<24>>24==(f[e>>2]&255)<<24>>24){r=j;t=q;v=e;do{t=t+-1|0;r=r+1|0;if(!t){s=15;break b}v=v+1|0}while((b[r>>0]|0)==(b[v>>0]|0))};f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[m>>0]=1;b[g>>0]=125;b[n>>0]=0;if(o){v=f[j>>2]|0;if(p)if((b[v>>0]|0)==(b[g>>0]|0))break b;else break;if((v&255)<<24>>24==(f[g>>2]&255)<<24>>24){v=j;r=q;t=g;while(1){r=r+-1|0;v=v+1|0;if(!r){s=13;break b}t=t+1|0;if((b[v>>0]|0)!=(b[t>>0]|0)){s=17;break}}}else s=17}else s=17}else{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[m>>0]=1;b[g>>0]=125;b[n>>0]=0;s=17}while(0);if((s|0)==17)s=0;if(!(uPb(a)|0)){w=0;break a}}w=fPb(a,d)|0}else w=0;while(0);if((b[d+11>>0]|0)>=0){u=c;return w|0}O5b(f[d>>2]|0);u=c;return w|0}function mPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+48|0;h=g+24|0;i=g+12|0;j=g;k=a+8|0;l=f[k>>2]|0;if(l|0){m=XOb(l,e)|0;f[k>>2]=m};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;do if(sPb(a,h)|0){m=f[d>>2]|0;if((f[e+36>>2]|0)==3){n=Dg[f[m+300>>2]&127](d,c,e,0)|0;X5b(i,h);o=tPb(a,n,i)|0;if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if(!o){p=0;break}}else{o=Dg[f[m+156>>2]&127](d,c,e,0)|0;X5b(j,h);m=tPb(a,o,j)|0;if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if(!m){p=0;break}}f[k>>2]=l;p=1}else p=0;while(0);if((b[h+11>>0]|0)>=0){u=g;return p|0}O5b(f[h>>2]|0);u=g;return p|0}function nPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;g=u;u=u+96|0;h=g;i=g+48|0;j=g+36|0;k=g+24|0;l=g+12|0;m=g+64|0;n=g+88|0;a:do switch(f[136e3+(f[e+32>>2]<<2)>>2]|0){case 1:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=45;b[h+1>>0]=0;o=a+20|0;q=a+24|0;r=b[q+11>>0]|0;s=r<<24>>24<0;t=r&255;b:do if(((s?f[a+28>>2]|0:t)|0)==1){r=f[q>>2]|0;c:do if(s){if((b[r>>0]|0)!=45){v=0;break b}}else{if((r&255)<<24>>24!=(f[h>>2]&255)<<24>>24){v=0;break b}w=q;x=t;y=h;while(1){x=x+-1|0;w=w+1|0;if(!x)break c;y=y+1|0;if((b[w>>0]|0)!=(b[y>>0]|0)){v=0;break b}}}while(0);BIb(o)|0;v=1}else v=0;while(0);if(!(oPb(a,h,v?-2147483648:2147483647,v?0:0)|0)){z=0;u=g;return z|0}o=h;t=f[o>>2]|0;q=f[o+4>>2]|0;o=(t|0)==0&(q|0)==-2147483648;s=Jac(0,0,t|0,q|0)|0;q=v?(o?0:s):t;t=f[d>>2]|0;if((f[e+36>>2]|0)==3){th[f[t+260>>2]&511](d,c,e,q);break a}else{th[f[t+116>>2]&511](d,c,e,q);break a}break}case 3:{if(!(oPb(a,h,-1,0)|0)){z=0;u=g;return z|0}q=f[d>>2]|0;t=f[h>>2]|0;if((f[e+36>>2]|0)==3)th[f[q+268>>2]&511](d,c,e,t);else th[f[q+124>>2]&511](d,c,e,t);break}case 2:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=45;b[h+1>>0]=0;t=a+20|0;q=a+24|0;s=b[q+11>>0]|0;o=s<<24>>24<0;r=s&255;d:do if(((o?f[a+28>>2]|0:r)|0)==1){s=f[q>>2]|0;e:do if(o){if((b[s>>0]|0)!=45){A=0;break d}}else{if((s&255)<<24>>24!=(f[h>>2]&255)<<24>>24){A=0;break d}y=q;w=r;x=h;while(1){w=w+-1|0;y=y+1|0;if(!w)break e;x=x+1|0;if((b[y>>0]|0)!=(b[x>>0]|0)){A=0;break d}}}while(0);BIb(t)|0;A=1}else A=0;while(0);if(!(oPb(a,h,A?0:-1,A?-2147483648:2147483647)|0)){z=0;u=g;return z|0}t=h;r=f[t>>2]|0;q=f[t+4>>2]|0;t=(r|0)==0&(q|0)==-2147483648;o=Jac(0,0,r|0,q|0)|0;s=A?(t?0:o):r;r=A?(t?-2147483648:J):q;q=f[d>>2]|0;if((f[e+36>>2]|0)==3){uh[f[q+264>>2]&255](d,c,e,s,r);break a}else{uh[f[q+120>>2]&255](d,c,e,s,r);break a}break}case 4:{if(!(oPb(a,h,-1,-1)|0)){z=0;u=g;return z|0}r=f[d>>2]|0;s=h;q=f[s>>2]|0;t=f[s+4>>2]|0;if((f[e+36>>2]|0)==3)uh[f[r+272>>2]&255](d,c,e,q,t);else uh[f[r+128>>2]&255](d,c,e,q,t);break}case 6:{if(!(pPb(a,h)|0)){z=0;u=g;return z|0}t=f[d>>2]|0;B=+p[h>>3];if((f[e+36>>2]|0)==3){q=f[t+276>>2]|0;C=+sIb(B);oh[q&63](d,c,e,C)}else{q=f[t+132>>2]|0;C=+sIb(B);oh[q&63](d,c,e,C)}break}case 5:{if(!(pPb(a,h)|0)){z=0;u=g;return z|0}q=f[d>>2]|0;C=+p[h>>3];if((f[e+36>>2]|0)==3)oh[f[q+280>>2]&63](d,c,e,C);else oh[f[q+136>>2]&63](d,c,e,C);break}case 9:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(!(qPb(a,h)|0)){if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=g;return z|0}q=f[d>>2]|0;if((f[e+36>>2]|0)==3)th[f[q+288>>2]&511](d,c,e,h);else th[f[q+144>>2]&511](d,c,e,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);break}case 7:{if((f[a+20>>2]|0)==3){if(!(oPb(a,h,1,0)|0)){z=0;u=g;return z|0}q=f[d>>2]|0;t=h;r=(f[t>>2]|0)!=0|(f[t+4>>2]|0)!=0;if((f[e+36>>2]|0)==3)th[f[q+284>>2]&511](d,c,e,r);else th[f[q+140>>2]&511](d,c,e,r);break a};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=jPb(a,h)|0;q=h+11|0;t=b[q>>0]|0;s=t<<24>>24<0;if(!r){if(s)O5b(f[h>>2]|0);z=0;u=g;return z|0}r=h+4|0;o=f[r>>2]|0;if(((s?o:t&255)|0)==4)if(!(u6b(h,0,-1,490309,4)|0))D=69;else{E=b[q>>0]|0;F=f[r>>2]|0;D=63}else{E=t;F=o;D=63}do if((D|0)==63){if(((E<<24>>24<0?F:E&255)|0)==4){if(!(u6b(h,0,-1,476460,4)|0)){D=69;break}G=b[q>>0]|0;H=f[r>>2]|0}else{G=E;H=F}if(((G<<24>>24<0?H:G&255)|0)==1){if(!(u6b(h,0,-1,476465,1)|0)){D=69;break}I=b[q>>0]|0;K=f[r>>2]|0}else{I=G;K=H}if(((I<<24>>24<0?K:I&255)|0)==5){if(u6b(h,0,-1,490303,5)|0){L=b[q>>0]|0;M=f[r>>2]|0;D=75}}else{L=I;M=K;D=75}do if((D|0)==75){if(((L<<24>>24<0?M:L&255)|0)==5){if(!(u6b(h,0,-1,476467,5)|0))break;N=b[q>>0]|0;O=f[r>>2]|0}else{N=L;O=M}if(((N<<24>>24<0?O:N&255)|0)==1?(u6b(h,0,-1,476473,1)|0)==0:0)break;dua(l,476475,f[e>>2]|0);eua(k,l,476509);Ccb(j,k,h);eua(i,j,476219);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);if((b[q>>0]|0)<0)O5b(f[h>>2]|0);z=0;u=g;return z|0}while(0);o=f[d>>2]|0;if((f[e+36>>2]|0)==3){th[f[o+284>>2]&511](d,c,e,0);break}else{th[f[o+140>>2]&511](d,c,e,0);break}}while(0);do if((D|0)==69){r=f[d>>2]|0;if((f[e+36>>2]|0)==3){th[f[r+284>>2]&511](d,c,e,1);break}else{th[f[r+140>>2]&511](d,c,e,1);break}}while(0);if((b[q>>0]|0)<0)O5b(f[h>>2]|0);break}case 8:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;r=f[e+64>>2]|0;o=f[a+20>>2]|0;do if((o|0)==2)if(jPb(a,i)|0){P=sub(r,i)|0;D=125}else{Q=1;R=0}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=45;b[h+1>>0]=0;t=a+24|0;s=b[t+11>>0]|0;x=s<<24>>24<0;y=s&255;s=((x?f[a+28>>2]|0:y)|0)==1;f:do if(s){w=f[t>>2]|0;g:do if(x){if((b[w>>0]|0)!=(b[h>>0]|0)){D=107;break f}}else{if((w&255)<<24>>24!=(f[h>>2]&255)<<24>>24){D=107;break f}S=t;T=y;U=h;while(1){T=T+-1|0;S=S+1|0;if(!T)break g;U=U+1|0;if((b[S>>0]|0)!=(b[U>>0]|0)){D=107;break f}}}while(0)}else D=107;while(0);if((D|0)==107?(o|0)!=3:0){dua(h,476521,t);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);Q=1;R=0;break};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=45;b[h+1>>0]=0;w=a+20|0;h:do if(s){U=f[t>>2]|0;i:do if(x){if((b[U>>0]|0)!=45){V=0;break h}}else{if((U&255)<<24>>24!=(f[h>>2]&255)<<24>>24){V=0;break h}S=t;T=y;W=h;while(1){T=T+-1|0;S=S+1|0;if(!T)break i;W=W+1|0;if((b[S>>0]|0)!=(b[W>>0]|0)){V=0;break h}}}while(0);BIb(w)|0;V=1}else V=0;while(0);if(!(oPb(a,h,V?-2147483648:2147483647,V?0:0)|0)){Q=1;R=0;break}w=h;y=f[w>>2]|0;t=f[w+4>>2]|0;w=(y|0)==0&(t|0)==-2147483648;x=Jac(0,0,y|0,t|0)|0;s=V?(w?0:x):y;xSb(h,s,V?(w?-2147483648:J):t);_5b(i,h)|0;if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);P=tub(r,s)|0;D=125}while(0);do if((D|0)==125){if(P|0){r=f[d>>2]|0;if((f[e+36>>2]|0)==3){th[f[r+292>>2]&511](d,c,e,P);Q=2;R=0;break}else{th[f[r+148>>2]&511](d,c,e,P);Q=2;R=0;break}}if(!(b[a+142>>0]|0)){dua(l,476559,i);eua(k,l,476590);Ccb(j,k,f[e>>2]|0);eua(h,j,476219);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);Q=1;R=0;break}else{dua(l,476559,i);eua(k,l,476590);Ccb(j,k,f[e>>2]|0);eua(h,j,476219);iPb(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);Q=1;R=1;break}}while(0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if((Q|0)==1){z=R;u=g;return z|0}break}case 10:{zpb(m,3,475815,760);xpb(n,vpb(m,476604)|0);Apb(m);break}default:{}}while(0);z=1;u=g;return z|0}function oPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+32|0;h=g+12|0;i=g;if((f[a+20>>2]|0)!=3){dua(h,476695,a+24|0);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);j=0;u=g;return j|0}k=a+24|0;if(CIb(k,d,e,c)|0){BIb(a+20|0)|0;j=1;u=g;return j|0}dua(i,476750,k);eua(h,i,489101);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);j=0;u=g;return j|0}function pPb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,E=0;d=u;u=u+32|0;e=d;g=d+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=45;b[e+1>>0]=0;h=a+20|0;i=a+24|0;j=b[i+11>>0]|0;k=j<<24>>24<0;l=j&255;a:do if(((k?f[a+28>>2]|0:l)|0)==1){j=f[i>>2]|0;b:do if(k){if((b[j>>0]|0)!=(b[e>>0]|0)){m=0;break a}}else{if((j&255)<<24>>24!=(f[e>>2]&255)<<24>>24){m=0;break a}n=i;o=l;q=e;while(1){o=o+-1|0;n=n+1|0;if(!o)break b;q=q+1|0;if((b[n>>0]|0)!=(b[q>>0]|0)){m=0;break a}}}while(0);BIb(h)|0;m=1}else m=0;while(0);c:do switch(f[a+20>>2]|0){case 3:{if(rPb(a,e,-1,-1)|0){l=e;p[c>>3]=+((f[l>>2]|0)>>>0)+4294967296.0*+((f[l+4>>2]|0)>>>0);break c}r=0;u=d;return r|0}case 4:{s=+DIb(i);p[c>>3]=s;BIb(h)|0;break}case 2:{X5b(e,i);l=e+11|0;k=b[l>>0]|0;j=k<<24>>24<0;q=f[e>>2]|0;n=e+4|0;o=f[n>>2]|0;t=j?q+o|0:e+(k&255)|0;v=j?q:e;if((v|0)==(t|0)){w=k;x=o}else{o=v;do{v=b[o>>0]|0;if((v+-65&255)<26)b[o>>0]=(v&255)+32;o=o+1|0}while((o|0)!=(t|0));w=b[l>>0]|0;x=f[n>>2]|0}if(((w<<24>>24<0?x:w&255)|0)==3)if(!(u6b(e,0,-1,483237,3)|0))y=25;else{z=b[l>>0]|0;A=f[n>>2]|0;y=22}else{z=w;A=x;y=22}do if((y|0)==22){if(((z<<24>>24<0?A:z&255)|0)==8){if(!(u6b(e,0,-1,485157,8)|0)){y=25;break}B=b[l>>0]|0;E=f[n>>2]|0}else{B=z;E=A}if(((B<<24>>24<0?E:B&255)|0)==3?(u6b(e,0,-1,485166,3)|0)==0:0){p[c>>3]=C;BIb(h)|0;break}dua(g,476672,e);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[l>>0]|0)<0)O5b(f[e>>2]|0);r=0;u=d;return r|0}while(0);if((y|0)==25){p[c>>3]=D;BIb(h)|0}if((b[l>>0]|0)<0)O5b(f[e>>2]|0);break}default:{dua(e,476672,i);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);r=0;u=d;return r|0}}while(0);if(!m){r=1;u=d;return r|0}p[c>>3]=-+p[c>>3];r=1;u=d;return r|0}function qPb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d;g=a+20|0;if((f[g>>2]|0)!=5){dua(e,476649,a+24|0);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);h=0;u=d;return h|0}e=c+11|0;if((b[e>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0}else{b[c>>0]=0;b[e>>0]=0}if((f[g>>2]|0)!=5){h=1;u=d;return h|0}e=a+20|0;i=a+24|0;do{EIb(i,c);BIb(e)|0}while((f[g>>2]|0)==5);h=1;u=d;return h|0}function rPb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+32|0;h=g+12|0;i=g;if((f[a+20>>2]|0)!=3){dua(h,476695,a+24|0);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);j=0;u=g;return j|0}k=a+20|0;l=a+24|0;m=b[l+11>>0]|0;n=m<<24>>24<0;do if((n?f[a+28>>2]|0:m&255)>>>0>1){o=n?f[l>>2]|0:l;if(!((b[o>>0]|0)==48?(b[o+1>>0]|32)<<24>>24==120:0)){o=n?f[l>>2]|0:l;if((b[o>>0]|0)!=48)break;if((b[o+1>>0]&-8)<<24>>24!=48)break}dua(h,476719,l);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);j=0;u=g;return j|0}while(0);if(CIb(l,d,e,c)|0){BIb(k)|0;j=1;u=g;return j|0}dua(i,476750,l);eua(h,i,489101);dPb(a,f[a+36>>2]|0,f[a+40>>2]|0,h);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);j=0;u=g;return j|0}function sPb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=60;b[e+1>>0]=0;g=a+20|0;h=a+24|0;i=b[h+11>>0]|0;j=i<<24>>24<0;k=i&255;a:do if(((j?f[a+28>>2]|0:k)|0)==1){i=f[h>>2]|0;b:do if(j){if((b[i>>0]|0)!=(b[e>>0]|0))break a}else{if((i&255)<<24>>24!=(f[e>>2]&255)<<24>>24)break a;l=h;m=k;n=e;while(1){m=m+-1|0;l=l+1|0;if(!m)break b;n=n+1|0;if((b[l>>0]|0)!=(b[n>>0]|0))break a}}while(0);BIb(g)|0;d6b(c,489139)|0;o=1;u=d;return o|0}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;g=e+11|0;b[g>>0]=1;b[e>>0]=123;b[e+1>>0]=0;k=fPb(a,e)|0;if((b[g>>0]|0)<0)O5b(f[e>>2]|0);if(!k){o=0;u=d;return o|0}d6b(c,476773)|0;o=1;u=d;return o|0}function tPb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+32|0;g=e+12|0;h=e;i=g+11|0;j=g+1|0;k=a+24|0;l=k+11|0;m=a+28|0;n=h+11|0;o=h+1|0;a:while(1){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[i>>0]=1;b[g>>0]=62;b[j>>0]=0;p=b[l>>0]|0;q=p<<24>>24<0;r=p&255;p=((q?f[m>>2]|0:r)|0)==1;do if(p){s=f[k>>2]|0;if(q){if((b[s>>0]|0)==(b[g>>0]|0)){t=14;break a}}else if((s&255)<<24>>24==(f[g>>2]&255)<<24>>24){s=k;v=r;w=g;do{v=v+-1|0;s=s+1|0;if(!v){t=14;break a}w=w+1|0}while((b[s>>0]|0)==(b[w>>0]|0))};f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[n>>0]=1;b[h>>0]=125;b[o>>0]=0;if(p){w=f[k>>2]|0;if(q)if((b[w>>0]|0)==(b[h>>0]|0))break a;else break;if((w&255)<<24>>24==(f[h>>2]&255)<<24>>24){w=k;s=r;v=h;while(1){s=s+-1|0;w=w+1|0;if(!s){t=12;break a}v=v+1|0;if((b[w>>0]|0)!=(b[v>>0]|0)){t=16;break}}}else t=16}else t=16}else{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[n>>0]=1;b[h>>0]=125;b[o>>0]=0;t=16}while(0);if((t|0)==16)t=0;if(!(cPb(a,c)|0)){x=0;t=20;break}}if((t|0)!=12)if((t|0)!=14)if((t|0)==20){u=e;return x|0}x=fPb(a,d)|0;u=e;return x|0}function uPb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=u;u=u+48|0;d=c+36|0;e=c+24|0;g=c+12|0;h=c;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=91;b[e+1>>0]=0;i=a+20|0;j=a+24|0;k=j+11|0;l=b[k>>0]|0;m=l<<24>>24<0;n=a+28|0;o=l&255;a:do if(((m?f[n>>2]|0:o)|0)==1){l=f[j>>2]|0;b:do if(m){if((b[l>>0]|0)!=(b[e>>0]|0)){p=12;break a}}else{if((l&255)<<24>>24!=(f[e>>2]&255)<<24>>24){p=12;break a}q=j;r=o;s=e;while(1){r=r+-1|0;q=q+1|0;if(!r)break b;s=s+1|0;if((b[q>>0]|0)!=(b[s>>0]|0)){p=12;break a}}}while(0);BIb(i)|0;if(hPb(a,d)|0){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;l=e+11|0;b[l>>0]=1;b[e>>0]=93;b[e+1>>0]=0;s=fPb(a,e)|0;if((b[l>>0]|0)<0)O5b(f[e>>2]|0);if(s)p=13;else t=0}else t=0}else p=12;while(0);if((p|0)==12)if(jPb(a,d)|0)p=13;else t=0;c:do if((p|0)==13){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=58;b[e+1>>0]=0;o=b[k>>0]|0;m=o<<24>>24<0;s=o&255;d:do if(((m?f[n>>2]|0:s)|0)==1){o=f[j>>2]|0;e:do if(m){if((b[o>>0]|0)!=(b[e>>0]|0)){p=31;break d}}else{if((o&255)<<24>>24==(f[e>>2]&255)<<24>>24){v=j;w=s;x=e}else{p=31;break d}while(1){w=w+-1|0;v=v+1|0;if(!w)break e;x=x+1|0;if((b[v>>0]|0)!=(b[x>>0]|0)){p=31;break d}}}while(0);BIb(i)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=123;b[g+1>>0]=0;o=b[k>>0]|0;l=o<<24>>24<0;q=o&255;o=((l?f[n>>2]|0:q)|0)==1;f:do if(o){r=f[j>>2]|0;g:do if(l){if((b[r>>0]|0)!=(b[g>>0]|0))break f}else{if((r&255)<<24>>24==(f[g>>2]&255)<<24>>24){y=j;z=q;A=g}else break f;while(1){z=z+-1|0;y=y+1|0;if(!z)break g;A=A+1|0;if((b[y>>0]|0)!=(b[A>>0]|0))break f}}while(0);p=38;break d}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[h+11>>0]=1;b[h>>0]=60;b[h+1>>0]=0;do if(o){r=f[j>>2]|0;if(l)if((b[r>>0]|0)==(b[h>>0]|0)){p=38;break d}else break;if((r&255)<<24>>24==(f[h>>2]&255)<<24>>24){B=j;C=q;D=h}else break;while(1){C=C+-1|0;B=B+1|0;if(!C){p=37;break}D=D+1|0;if((b[B>>0]|0)!=(b[D>>0]|0)){p=35;break}}if((p|0)==35)break;else if((p|0)==37){p=38;break d}}while(0);if(!(kPb(a)|0)){t=0;break c}}else p=31;while(0);if((p|0)==31)p=38;if((p|0)==38?!(lPb(a)|0):0){t=0;break};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[e+11>>0]=1;b[e>>0]=59;b[e+1>>0]=0;s=b[k>>0]|0;m=s<<24>>24<0;q=s&255;s=((m?f[n>>2]|0:q)|0)==1;h:do if(s){l=f[j>>2]|0;i:do if(m){if((b[l>>0]|0)!=(b[e>>0]|0)){p=47;break h}}else{if((l&255)<<24>>24!=(f[e>>2]&255)<<24>>24){p=47;break h}o=j;r=q;E=e;while(1){r=r+-1|0;o=o+1|0;if(!r)break i;E=E+1|0;if((b[o>>0]|0)!=(b[E>>0]|0)){p=47;break h}}}while(0);BIb(i)|0}else p=47;while(0);if((p|0)==47){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[g+11>>0]=1;b[g>>0]=44;b[g+1>>0]=0;j:do if(s){l=f[j>>2]|0;k:do if(m){if((b[l>>0]|0)!=(b[g>>0]|0))break j}else{if((l&255)<<24>>24!=(f[g>>2]&255)<<24>>24)break j;E=j;o=q;r=g;while(1){o=o+-1|0;E=E+1|0;if(!o)break k;r=r+1|0;if((b[E>>0]|0)!=(b[r>>0]|0))break j}}while(0);BIb(i)|0}while(0)}t=1}while(0);if((b[d+11>>0]|0)>=0){u=c;return t|0}O5b(f[d>>2]|0);u=c;return t|0}function vPb(a){a=a|0;O5b(a);return}function wPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;dPb(f[a+4>>2]|0,b,c,d);return}function xPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;iPb(f[a+4>>2]|0,b,c,d);return}function yPb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e;h=b[c+11>>0]|0;i=h<<24>>24<0;Lob(g,i?f[c>>2]|0:c,i?f[c+4>>2]|0:h&255,-1);h=$Ob(a,g,d)|0;lob(g);u=e;return h|0}function zPb(a,c){a=a|0;c=c|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;d[g+16>>1]=0;b[g+18>>0]=0;h=$Ob(g,a,c)|0;u=e;return h|0}function APb(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;b=a+24|0;f[b>>2]=0;f[a+32>>2]=0;f[a+36>>2]=0;f[a>>2]=0;f[a+4>>2]=0;d[a+8>>1]=0;f[a+28>>2]=a+32;a=L5b(4)|0;f[a>>2]=141216;f[b>>2]=a;return}function BPb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=u;u=u+48|0;i=h+32|0;j=h;k=g+11|0;if((b[k>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0}else{b[g>>0]=0;b[k>>0]=0}Nob(i,g);g=f[a>>2]|0;f[j>>2]=i;f[j+4>>2]=0;k=j+8|0;f[k>>2]=0;b[j+12>>0]=1;l=j+13|0;b[l>>0]=0;m=j+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;n=m+11|0;b[n>>0]=0;b[m>>0]=0;f[j+28>>2]=g;e6b(m,g<<1,32);MOb(a,c,di[f[(f[c>>2]|0)+92>>2]&1023](c)|0,d,e,j);if((b[l>>0]|0)==0?(l=f[k>>2]|0,(l|0)>0):0){k=f[j>>2]|0;zh[f[(f[k>>2]|0)+12>>2]&2047](k,l)}if((b[n>>0]|0)>=0){xob(i);u=h;return}O5b(f[m>>2]|0);xob(i);u=h;return}function CPb(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g;i=h+16|0;f[i>>2]=0;f[i+4>>2]=0;i=h+24|0;f[i>>2]=0;f[h+32>>2]=0;f[h+36>>2]=0;f[h>>2]=0;f[h+4>>2]=0;d[h+8>>1]=0;f[h+28>>2]=h+32;j=L5b(4)|0;f[j>>2]=141216;f[i>>2]=j;BPb(h,a,b,c,e);zOb(h);u=g;return}function DPb(){var a=0,c=0,d=0;a=u;u=u+16|0;c=a;if((f[213456]|0)==2){d=f[213457]|0;u=a;return d|0}f[c>>2]=135812;f[c+4>>2]=74;b[c+8>>0]=0;Gpb(853824,c);hpb(c);d=f[213457]|0;u=a;return d|0}function EPb(){var a=0;a=L5b(4)|0;f[a>>2]=0;f[213457]=a;spb(75);return}function FPb(){var a=0;a=f[213457]|0;if(!a)return;if(f[a>>2]|0)GPb(a);O5b(a);return}function GPb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=f[a>>2]|0;d=(f[c+4>>2]|0)-(f[c>>2]|0)>>4;e=c;do{c=d;d=d+-1|0;g=f[e>>2]|0;switch(f[g+(d<<4)+4>>2]|0){case 3:{h=f[g+(d<<4)+8>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);O5b(h)}break}case 4:{h=f[g+(d<<4)+8>>2]|0;if(h|0){if(f[h>>2]|0)GPb(h);O5b(h)}break}default:{}}e=f[a>>2]|0}while((c|0)>1);if(!e){f[a>>2]=0;return}d=f[e>>2]|0;if(d|0){c=e+4|0;h=f[c>>2]|0;if((h|0)!=(d|0))f[c>>2]=h+(~((h+-16-d|0)>>>4)<<4);O5b(d)}O5b(e);f[a>>2]=0;return}function HPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[b>>2]|0;if(!c)return;d=(f[c+4>>2]|0)-(f[c>>2]|0)|0;c=d>>4;if((d|0)<=0)return;d=L5b(12)|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[a>>2]=d;e=0;g=d;while(1){d=(f[f[b>>2]>>2]|0)+(e<<4)|0;h=g+4|0;i=f[h>>2]|0;if((i|0)==(f[g+8>>2]|0))IPb(g,d);else{f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[h>>2]=(f[h>>2]|0)+16}h=f[(f[a>>2]|0)+4>>2]|0;switch(f[h+-12>>2]|0){case 3:{d=L5b(12)|0;i=h+-8|0;X5b(d,f[i>>2]|0);j=d;k=i;l=10;break}case 4:{i=L5b(4)|0;f[i>>2]=0;d=h+-8|0;HPb(i,f[d>>2]|0);j=i;k=d;l=10;break}default:{}}if((l|0)==10){l=0;f[k>>2]=j}d=e+1|0;if((d|0)>=(c|0))break;e=d;g=f[a>>2]|0}return}function IPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>4;h=g+1|0;if(h>>>0>268435455)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>3;l=j>>4>>>0<134217727?(k>>>0<h>>>0?h:k):268435455;do if(l)if(l>>>0>268435455){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<4)|0;break}else m=0;while(0);k=m+(g<<4)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];b=k+(0-g<<4)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+16;f[i>>2]=m+(l<<4);if(!d)return;O5b(d);return}function JPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[b>>2]|0;if(!c)return;d=(f[c+4>>2]|0)-(f[c>>2]|0)|0;c=d>>4;if((d|0)<=0)return;d=f[a>>2]|0;if(!d){e=L5b(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[a>>2]=e;g=0;h=e}else{g=0;h=d}while(1){d=(f[f[b>>2]>>2]|0)+(g<<4)|0;e=h+4|0;i=f[e>>2]|0;if((i|0)==(f[h+8>>2]|0))IPb(h,d);else{f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[e>>2]=(f[e>>2]|0)+16}e=f[(f[a>>2]|0)+4>>2]|0;switch(f[e+-12>>2]|0){case 3:{d=L5b(12)|0;i=e+-8|0;X5b(d,f[i>>2]|0);j=d;k=i;l=11;break}case 4:{i=L5b(4)|0;f[i>>2]=0;d=e+-8|0;HPb(i,f[d>>2]|0);j=i;k=d;l=11;break}default:{}}if((l|0)==11){l=0;f[k>>2]=j}d=g+1|0;if((d|0)>=(c|0))break;g=d;h=f[a>>2]|0}return}function KPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}d=(f[c+4>>2]|0)-(f[c>>2]|0)|0;c=d>>4;a:do if((d|0)>0){e=f[a>>2]|0;if(!e){g=L5b(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[a>>2]=g;h=0;i=g}else{h=0;i=e}while(1){e=(f[f[b>>2]>>2]|0)+(h<<4)|0;g=i+4|0;j=f[g>>2]|0;if((j|0)==(f[i+8>>2]|0))IPb(i,e);else{f[j>>2]=f[e>>2];f[j+4>>2]=f[e+4>>2];f[j+8>>2]=f[e+8>>2];f[j+12>>2]=f[e+12>>2];f[g>>2]=(f[g>>2]|0)+16}g=f[f[b>>2]>>2]|0;switch(f[g+(h<<4)+4>>2]|0){case 3:{f[g+(h<<4)+8>>2]=0;break}case 4:{f[g+(h<<4)+8>>2]=0;break}default:{}}g=h+1|0;if((g|0)>=(c|0))break a;h=g;i=f[a>>2]|0}}while(0);a=f[b>>2]|0;if(!a){f[b>>2]=0;return}i=f[a>>2]|0;if(i|0){h=a+4|0;c=f[h>>2]|0;if((c|0)!=(i|0))f[h>>2]=c+(~((c+-16-i|0)>>>4)<<4);O5b(i)}O5b(a);f[b>>2]=0;return}function LPb(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[b>>2]|0;if(!(c&1))d=hBa(b)|0;else d=c&-2;JPb(d,a);return}function MPb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a>>2]|0;if(!b){c=0;return c|0}d=f[b+4>>2]|0;e=f[b>>2]|0;g=d-e|12;if((d|0)==(e|0)){c=g;return c|0}else{h=0;i=g;j=b}while(1){b=f[j>>2]|0;switch(f[b+(h<<4)+4>>2]|0){case 3:{k=i+12+(Dnb(f[b+(h<<4)+8>>2]|0)|0)|0;break}case 4:{k=i+4+(MPb(f[b+(h<<4)+8>>2]|0)|0)|0;break}default:k=i}h=h+1|0;j=f[a>>2]|0;if(h>>>0>=(f[j+4>>2]|0)-(f[j>>2]|0)>>4>>>0){c=k;break}else i=k}return c|0}function NPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;f[g>>2]=b;f[g+4>>2]=0;b=g+8|0;f[b>>2]=c;f[b+4>>2]=d;d=f[a>>2]|0;if(!d){b=L5b(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[a>>2]=b;h=b}else h=d;d=h+4|0;b=f[d>>2]|0;if((b|0)==(f[h+8>>2]|0)){IPb(h,g);u=e;return}else{f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];f[d>>2]=(f[d>>2]|0)+16;u=e;return}}function OPb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[e>>2]=b;f[e+4>>2]=1;f[e+8>>2]=c;c=f[a>>2]|0;if(!c){b=L5b(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[a>>2]=b;g=b}else g=c;c=g+4|0;b=f[c>>2]|0;if((b|0)==(f[g+8>>2]|0)){IPb(g,e);u=d;return}else{f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[c>>2]=(f[c>>2]|0)+16;u=d;return}}function PPb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;f[g>>2]=b;f[g+4>>2]=2;b=g+8|0;f[b>>2]=c;f[b+4>>2]=d;d=f[a>>2]|0;if(!d){b=L5b(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[a>>2]=b;h=b}else h=d;d=h+4|0;b=f[d>>2]|0;if((b|0)==(f[h+8>>2]|0)){IPb(h,g);u=e;return}else{f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];f[d>>2]=(f[d>>2]|0)+16;u=e;return}}function QPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[d>>2]=b;f[d+4>>2]=3;b=L5b(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;e=d+8|0;f[e>>2]=b;b=f[a>>2]|0;if(!b){g=L5b(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[a>>2]=g;h=g}else h=b;b=h+4|0;g=f[b>>2]|0;if((g|0)==(f[h+8>>2]|0)){IPb(h,d);i=f[e>>2]|0;u=c;return i|0}else{f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];f[b>>2]=(f[b>>2]|0)+16;i=f[e>>2]|0;u=c;return i|0}return 0}function RPb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[d>>2]=b;f[d+4>>2]=4;b=L5b(4)|0;f[b>>2]=0;e=d+8|0;f[e>>2]=b;b=f[a>>2]|0;if(!b){g=L5b(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[a>>2]=g;h=g}else h=b;b=h+4|0;g=f[b>>2]|0;if((g|0)==(f[h+8>>2]|0)){IPb(h,d);i=f[e>>2]|0;u=c;return i|0}else{f[g>>2]=f[d>>2];f[g+4>>2]=f[d+4>>2];f[g+8>>2]=f[d+8>>2];f[g+12>>2]=f[d+12>>2];f[b>>2]=(f[b>>2]|0)+16;i=f[e>>2]|0;u=c;return i|0}return 0}function SPb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;if(f[a>>2]|0)GPb(a);f[e>>2]=0;if(_Pb(c,e)|0?(b[c+24>>0]|0)!=0:0){KPb(a,e);g=1}else g=0;if(!(f[e>>2]|0)){u=d;return g|0}GPb(e);u=d;return g|0}function TPb(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+96|0;h=g+24|0;i=g;Lob(i,c,e,-1);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=i;e=h+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;d[e+12>>1]=0;f[h+28>>2]=2147483647;f[h+32>>2]=0;f[h+36>>2]=67108864;f[h+40>>2]=33554432;e=f[33911]|0;f[h+44>>2]=e;f[h+48>>2]=e;f[h+52>>2]=0;f[h+56>>2]=0;Mnb(h)|0;e=SPb(a,h)|0;a=b[h+24>>0]|0;Fnb(h);lob(i);u=g;return e&a<<24>>24!=0|0}function UPb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a+8>>2]|0;a=d+11|0;e=b[a>>0]|0;if(e<<24>>24<0)g=f[d+4>>2]|0;else g=e&255;e=c+8|0;if((f[e>>2]|0)>4){h=c+4|0;i=f[h>>2]|0;if(g>>>0>127){j=g;k=i;while(1){b[k>>0]=j|128;l=j>>>7;m=k+1|0;if(j>>>0>16383){j=l;k=m}else{n=m;o=l;break}}}else{n=i;o=g}b[n>>0]=o;o=n+1-i|0;f[h>>2]=(f[h>>2]|0)+o;f[e>>2]=(f[e>>2]|0)-o}else fob(c,g);g=b[a>>0]|0;if(g<<24>>24<0){p=f[d>>2]|0;q=f[d+4>>2]|0}else{p=d;q=g&255}if(!(b[c+17>>0]|0)){bob(c,p,q);return}else{cob(c,p,q);return}}function VPb(a){a=a|0;O5b(a);return}function WPb(a,b,c){a=a|0;b=b|0;c=c|0;return ZPb(b,c,f[a+4>>2]|0)|0}function XPb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=f[a+4>>2]|0;a=c+4|0;e=c+20|0;while(1){g=f[c>>2]|0;if(g>>>0<(f[a>>2]|0)>>>0){h=b[g>>0]|0;i=h&255;if(h<<24>>24>-1){f[e>>2]=i;f[c>>2]=g+1;j=i}else{k=i;l=5}}else{k=0;l=5}if((l|0)==5){l=0;i=_nb(c,k)|0;f[e>>2]=i;j=i}if((j|0)==0|(j&7|0)==4){m=1;l=8;break}if(!(ZPb(c,j,d)|0)){m=0;l=8;break}}if((l|0)==8)return m|0;return 0}function YPb(a,b,c){a=a|0;b=b|0;c=c|0;NPb(f[a+4>>2]|0,b,c,((c|0)<0)<<31>>31);return}function ZPb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+16|0;g=e;i=c>>>3;switch(c&7){case 0:{c=f[a>>2]|0;if(c>>>0<(f[a+4>>2]|0)>>>0?(j=b[c>>0]|0,j<<24>>24>-1):0){f[a>>2]=c+1;k=j&255;l=0}else{Lnb(g,a);j=g;if(!(b[g+8>>0]|0)){m=0;u=e;return m|0}else{k=f[j>>2]|0;l=f[j+4>>2]|0}}if(!d){m=1;u=e;return m|0}NPb(d,i,k,l);m=1;u=e;return m|0}case 1:{l=f[a>>2]|0;if(((f[a+4>>2]|0)-l|0)<=7)if(Ynb(a,g)|0)n=11;else o=0;else{k=l;j=k;c=k+4|0;k=h[c>>0]|h[c+1>>0]<<8|h[c+2>>0]<<16|h[c+3>>0]<<24;c=g;f[c>>2]=h[j>>0]|h[j+1>>0]<<8|h[j+2>>0]<<16|h[j+3>>0]<<24;f[c+4>>2]=k;f[a>>2]=l+8;n=11}if((n|0)==11)if(!d)o=1;else{l=g;PPb(d,i,f[l>>2]|0,f[l+4>>2]|0);o=1}m=o;u=e;return m|0}case 2:{o=f[a>>2]|0;if(o>>>0<(f[a+4>>2]|0)>>>0){l=b[o>>0]|0;k=l&255;if(l<<24>>24>-1){f[a>>2]=o+1;p=k}else{q=k;n=17}}else{q=0;n=17}if((n|0)==17){k=Knb(a,q)|0;q=J;if((q|0)>-1|(q|0)==-1&k>>>0>4294967295)p=k;else{m=0;u=e;return m|0}}if(!d){if(!(Tnb(a,p)|0)){m=0;u=e;return m|0}}else if(!(Vnb(a,QPb(d,i)|0,p)|0)){m=0;u=e;return m|0}m=1;u=e;return m|0}case 3:{p=a+44|0;k=f[p>>2]|0;f[p>>2]=k+-1;if((k|0)<=0){m=0;u=e;return m|0}if(!d)r=0;else r=RPb(d,i)|0;k=a+4|0;q=a+20|0;while(1){o=f[a>>2]|0;if(o>>>0<(f[k>>2]|0)>>>0){l=b[o>>0]|0;c=l&255;if(l<<24>>24>-1){f[q>>2]=c;f[a>>2]=o+1;s=c}else{t=c;n=29}}else{t=0;n=29}if((n|0)==29){n=0;c=_nb(a,t)|0;f[q>>2]=c;s=c}if((s|0)==0|(s&7|0)==4)break;if(!(ZPb(a,s,r)|0)){m=0;n=41;break}}if((n|0)==41){u=e;return m|0}r=f[p>>2]|0;if((r|0)<(f[a+48>>2]|0))f[p>>2]=r+1;m=(s|0)==(i<<3|4|0);u=e;return m|0}case 5:{s=f[a>>2]|0;if(((f[a+4>>2]|0)-s|0)<=3)if(Xnb(a,g)|0)n=38;else v=0;else{r=s;f[g>>2]=h[r>>0]|h[r+1>>0]<<8|h[r+2>>0]<<16|h[r+3>>0]<<24;f[a>>2]=s+4;n=38}if((n|0)==38)if(!d)v=1;else{OPb(d,i,f[g>>2]|0);v=1}m=v;u=e;return m|0}default:{m=0;u=e;return m|0}}return 0}function _Pb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+4|0;e=a+20|0;while(1){g=f[a>>2]|0;if(g>>>0<(f[d>>2]|0)>>>0){h=b[g>>0]|0;i=h&255;if(h<<24>>24>-1){f[e>>2]=i;f[a>>2]=g+1;j=i}else{k=i;l=5}}else{k=0;l=5}if((l|0)==5){l=0;i=_nb(a,k)|0;f[e>>2]=i;j=i}if((j|0)==0|(j&7|0)==4){m=1;l=8;break}if(!(ZPb(a,j,c)|0)){m=0;l=8;break}}if((l|0)==8)return m|0;return 0}function $Pb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=f[a>>2]|0;i=a+4|0;if(h>>>0<(f[i>>2]|0)>>>0){j=b[h>>0]|0;k=j&255;if(j<<24>>24>-1){f[a>>2]=h+1;l=k}else{m=k;n=4}}else{m=0;n=4}if((n|0)==4){k=Knb(a,m)|0;m=J;if((m|0)>-1|(m|0)==-1&k>>>0>4294967295)l=k;else{o=0;return o|0}}k=Gnb(a,l)|0;a:do if((Qnb(a)|0)>0){l=g+4|0;m=g+8|0;if(!d){while(1){h=f[a>>2]|0;if(h>>>0<(f[i>>2]|0)>>>0){j=b[h>>0]|0;p=j&255;if(j<<24>>24>-1){f[a>>2]=h+1;q=p}else{r=p;n=9}}else{r=0;n=9}if((n|0)==9){n=0;p=Knb(a,r)|0;h=J;if((h|0)>-1|(h|0)==-1&p>>>0>4294967295)q=p;else{o=0;break}}p=f[g>>2]|0;if((p|0)==(f[l>>2]|0)){nza(g,p+1|0);s=f[g>>2]|0}else s=p;p=f[m>>2]|0;f[g>>2]=s+1;f[p+4+(s<<2)>>2]=q;if((Qnb(a)|0)<=0)break a}return o|0}while(1){p=f[a>>2]|0;if(p>>>0<(f[i>>2]|0)>>>0){h=b[p>>0]|0;j=h&255;if(h<<24>>24>-1){f[a>>2]=p+1;t=j}else{u=j;n=17}}else{u=0;n=17}if((n|0)==17){n=0;j=Knb(a,u)|0;p=J;if((p|0)>-1|(p|0)==-1&j>>>0>4294967295)t=j;else{o=0;break}}if(di[d&1023](t)|0){j=f[g>>2]|0;if((j|0)==(f[l>>2]|0)){nza(g,j+1|0);v=f[g>>2]|0}else v=j;j=f[m>>2]|0;f[g>>2]=v+1;f[j+4+(v<<2)>>2]=t}else NPb(e,c,t,((t|0)<0)<<31>>31);if((Qnb(a)|0)<=0)break a}return o|0}while(0);Hnb(a,k);o=1;return o|0}function aQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=c+8|0;e=c+4|0;g=c+17|0;h=0;while(1){i=f[a>>2]|0;if(!i)j=0;else j=(f[i+4>>2]|0)-(f[i>>2]|0)>>4;if((h|0)>=(j|0))break;k=f[i>>2]|0;i=k+(h<<4)|0;a:do switch(f[k+(h<<4)+4>>2]|0){case 0:{l=f[i>>2]<<3;if((f[d>>2]|0)>4){m=f[e>>2]|0;if(l>>>0>127){n=l;o=m;while(1){b[o>>0]=n|128;p=n>>>7;q=o+1|0;if(n>>>0>16383){n=p;o=q}else{r=q;s=p;break}}}else{r=m;s=l}b[r>>0]=s;o=r+1-m|0;f[e>>2]=(f[e>>2]|0)+o;f[d>>2]=(f[d>>2]|0)-o}else fob(c,l);o=k+(h<<4)+8|0;gob(c,f[o>>2]|0,f[o+4>>2]|0);break}case 1:{o=f[i>>2]<<3|5;if((f[d>>2]|0)>4){n=f[e>>2]|0;if(o>>>0>127){p=o;q=n;while(1){b[q>>0]=p|128;t=p>>>7;u=q+1|0;if(p>>>0>16383){p=t;q=u}else{v=u;w=t;break}}}else{v=n;w=o}b[v>>0]=w;q=v+1-n|0;f[e>>2]=(f[e>>2]|0)+q;f[d>>2]=(f[d>>2]|0)-q}else fob(c,o);dob(c,f[k+(h<<4)+8>>2]|0);break}case 2:{q=f[i>>2]<<3|1;if((f[d>>2]|0)>4){p=f[e>>2]|0;if(q>>>0>127){l=q;m=p;while(1){b[m>>0]=l|128;t=l>>>7;u=m+1|0;if(l>>>0>16383){l=t;m=u}else{x=u;y=t;break}}}else{x=p;y=q}b[x>>0]=y;m=x+1-p|0;f[e>>2]=(f[e>>2]|0)+m;f[d>>2]=(f[d>>2]|0)-m}else fob(c,q);m=k+(h<<4)+8|0;eob(c,f[m>>2]|0,f[m+4>>2]|0);break}case 3:{m=f[i>>2]<<3|2;if((f[d>>2]|0)>4){l=f[e>>2]|0;if(m>>>0>127){o=m;n=l;while(1){b[n>>0]=o|128;t=o>>>7;u=n+1|0;if(o>>>0>16383){o=t;n=u}else{z=u;A=t;break}}}else{z=l;A=m}b[z>>0]=A;n=z+1-l|0;f[e>>2]=(f[e>>2]|0)+n;f[d>>2]=(f[d>>2]|0)-n}else fob(c,m);n=k+(h<<4)+8|0;o=f[n>>2]|0;q=b[o+11>>0]|0;if(q<<24>>24<0)B=f[o+4>>2]|0;else B=q&255;if((f[d>>2]|0)>4){q=f[e>>2]|0;if(B>>>0>127){o=B;p=q;while(1){b[p>>0]=o|128;t=o>>>7;u=p+1|0;if(o>>>0>16383){o=t;p=u}else{C=u;D=t;break}}}else{C=q;D=B}b[C>>0]=D;p=C+1-q|0;f[e>>2]=(f[e>>2]|0)+p;f[d>>2]=(f[d>>2]|0)-p}else fob(c,B);p=f[n>>2]|0;o=b[p+11>>0]|0;if(o<<24>>24<0){E=f[p>>2]|0;F=f[p+4>>2]|0}else{E=p;F=o&255}if(!(b[g>>0]|0)){bob(c,E,F);break a}else{cob(c,E,F);break a}break}case 4:{o=f[i>>2]<<3|3;if((f[d>>2]|0)>4){p=f[e>>2]|0;if(o>>>0>127){m=o;l=p;while(1){b[l>>0]=m|128;t=m>>>7;u=l+1|0;if(m>>>0>16383){m=t;l=u}else{G=u;H=t;break}}}else{G=p;H=o}b[G>>0]=H;l=G+1-p|0;f[e>>2]=(f[e>>2]|0)+l;f[d>>2]=(f[d>>2]|0)-l}else fob(c,o);aQb(f[k+(h<<4)+8>>2]|0,c);l=f[i>>2]<<3|4;if((f[d>>2]|0)<=4){fob(c,l);break a}m=f[e>>2]|0;if(l>>>0>127){n=l;q=m;while(1){b[q>>0]=n|128;t=n>>>7;u=q+1|0;if(n>>>0>16383){n=t;q=u}else{I=u;J=t;break}}}else{I=m;J=l}b[I>>0]=J;q=I+1-m|0;f[e>>2]=(f[e>>2]|0)+q;f[d>>2]=(f[d>>2]|0)-q;break}default:{}}while(0);h=h+1|0}return}function bQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=c;c=0;while(1){e=f[a>>2]|0;if(!e)g=0;else g=(f[e+4>>2]|0)-(f[e>>2]|0)>>4;if((c|0)>=(g|0))break;h=f[e>>2]|0;e=h+(c<<4)|0;switch(f[h+(c<<4)+4>>2]|0){case 0:{i=h+(c<<4)+8|0;j=f[i>>2]|0;k=f[i+4>>2]|0;i=f[e>>2]<<3;if(i>>>0>127){l=i;m=d;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=d;q=i}b[p>>0]=q;r=hob(j,k,p+1|0)|0;break}case 1:{m=f[h+(c<<4)+8>>2]|0;l=f[e>>2]<<3|5;if(l>>>0>127){n=l;o=d;while(1){b[o>>0]=n|128;s=n>>>7;t=o+1|0;if(n>>>0>16383){n=s;o=t}else{u=t;v=s;break}}}else{u=d;v=l}b[u>>0]=v;o=u+1|0;b[o>>0]=m;b[o+1>>0]=m>>8;b[o+2>>0]=m>>16;b[o+3>>0]=m>>24;r=u+5|0;break}case 2:{o=h+(c<<4)+8|0;n=f[o>>2]|0;k=f[o+4>>2]|0;o=f[e>>2]<<3|1;if(o>>>0>127){j=o;i=d;while(1){b[i>>0]=j|128;s=j>>>7;t=i+1|0;if(j>>>0>16383){j=s;i=t}else{w=t;x=s;break}}}else{w=d;x=o}b[w>>0]=x;i=w+1|0;j=i;b[j>>0]=n;b[j+1>>0]=n>>8;b[j+2>>0]=n>>16;b[j+3>>0]=n>>24;j=i+4|0;b[j>>0]=k;b[j+1>>0]=k>>8;b[j+2>>0]=k>>16;b[j+3>>0]=k>>24;r=w+9|0;break}case 3:{j=f[h+(c<<4)+8>>2]|0;i=f[e>>2]<<3|2;if(i>>>0>127){m=i;l=d;while(1){b[l>>0]=m|128;s=m>>>7;t=l+1|0;if(m>>>0>16383){m=s;l=t}else{y=t;z=s;break}}}else{y=d;z=i}b[y>>0]=z;r=kob(j,y+1|0)|0;break}case 4:{l=f[e>>2]<<3|3;if(l>>>0>127){m=l;k=d;while(1){b[k>>0]=m|128;n=m>>>7;o=k+1|0;if(m>>>0>16383){m=n;k=o}else{A=o;B=n;break}}}else{A=d;B=l}b[A>>0]=B;k=bQb(f[h+(c<<4)+8>>2]|0,A+1|0)|0;m=f[e>>2]<<3|4;if(m>>>0>127){j=m;i=k;while(1){b[i>>0]=j|128;n=j>>>7;o=i+1|0;if(j>>>0>16383){j=n;i=o}else{C=o;D=n;break}}}else{C=k;D=m}b[C>>0]=D;r=C+1|0;break}default:r=d}d=r;c=c+1|0}return d|0}function cQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=c+8|0;e=c+4|0;g=0;while(1){h=f[a>>2]|0;if(!h)i=0;else i=(f[h+4>>2]|0)-(f[h>>2]|0)>>4;if((g|0)>=(i|0))break;j=f[h>>2]|0;h=j+(g<<4)|0;do if((f[j+(g<<4)+4>>2]|0)==3){if((f[d>>2]|0)>4){b[f[e>>2]>>0]=11;f[e>>2]=(f[e>>2]|0)+1;k=(f[d>>2]|0)+-1|0;f[d>>2]=k;l=k}else{fob(c,11);l=f[d>>2]|0}if((l|0)>4){b[f[e>>2]>>0]=16;f[e>>2]=(f[e>>2]|0)+1;k=(f[d>>2]|0)+-1|0;f[d>>2]=k;m=k}else{fob(c,16);m=f[d>>2]|0}k=f[h>>2]|0;if((m|0)>4){n=f[e>>2]|0;if(k>>>0>127){o=k;p=n;while(1){b[p>>0]=o|128;q=o>>>7;r=p+1|0;if(o>>>0>16383){o=q;p=r}else{s=r;t=q;break}}}else{s=n;t=k}b[s>>0]=t;p=s+1-n|0;f[e>>2]=(f[e>>2]|0)+p;o=(f[d>>2]|0)-p|0;f[d>>2]=o;u=o}else{fob(c,k);u=f[d>>2]|0}if((u|0)>4){b[f[e>>2]>>0]=26;f[e>>2]=(f[e>>2]|0)+1;f[d>>2]=(f[d>>2]|0)+-1}else fob(c,26);UPb(h,c);if((f[d>>2]|0)>4){b[f[e>>2]>>0]=12;f[e>>2]=(f[e>>2]|0)+1;f[d>>2]=(f[d>>2]|0)+-1;break}else{fob(c,12);break}}while(0);g=g+1|0}return}function dQb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=0;d=0;while(1){e=f[a>>2]|0;if(!e)g=0;else g=(f[e+4>>2]|0)-(f[e>>2]|0)>>4;if((d|0)>=(g|0))break;h=f[e>>2]|0;e=h+(d<<4)|0;switch(f[h+(d<<4)+4>>2]|0){case 0:{i=f[e>>2]<<3;if(i>>>0<128)j=1;else j=iob(i)|0;i=h+(d<<4)+8|0;k=j+c+(job(f[i>>2]|0,f[i+4>>2]|0)|0)|0;break}case 1:{i=f[e>>2]<<3|5;if(i>>>0<128)l=1;else l=iob(i)|0;k=c+4+l|0;break}case 2:{i=f[e>>2]<<3|1;if(i>>>0<128)m=1;else m=iob(i)|0;k=c+8+m|0;break}case 3:{i=f[e>>2]<<3|2;if(i>>>0<128)n=1;else n=iob(i)|0;i=n+c|0;o=h+(d<<4)+8|0;p=f[o>>2]|0;q=b[p+11>>0]|0;do if(q<<24>>24<0){r=f[p+4>>2]|0;if(r>>>0>=128){s=iob(r)|0;r=f[o>>2]|0;t=b[r+11>>0]|0;u=i+s|0;if(t<<24>>24<0){v=r;w=u}else{x=t;y=u;z=24;break}}else{v=p;w=i+1|0}A=f[v+4>>2]|0;B=w}else{x=q;y=i+1|0;z=24}while(0);if((z|0)==24){z=0;A=x&255;B=y}k=B+A|0;break}case 4:{i=f[e>>2]<<3|3;if(i>>>0<128)C=1;else C=iob(i)|0;i=C+c+(dQb(f[h+(d<<4)+8>>2]|0)|0)|0;q=f[e>>2]<<3|4;if(q>>>0<128)D=1;else D=iob(q)|0;k=i+D|0;break}default:k=c}c=k;d=d+1|0}return c|0}function eQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;zh[f[(f[c>>2]|0)+96>>2]&2047](e,c);g=f[e>>2]|0;e=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;h=a+4|0;i=a+20|0;j=g+16|0;k=a+52|0;if(!g){l=0;while(1){m=f[a>>2]|0;if(m>>>0<(f[h>>2]|0)>>>0){n=b[m>>0]|0;o=n&255;if(n<<24>>24>-1){f[i>>2]=o;f[a>>2]=m+1;p=o}else{q=o;r=4}}else{q=0;r=4}if((r|0)==4){r=0;o=_nb(a,q)|0;f[i>>2]=o;p=o}if((p|0)==0|(p&7|0)==4){s=1;r=23;break}o=fQb(p,0,c,a)|0;m=l&o;if(o)l=m;else{s=m;r=23;break}}if((r|0)==23){u=d;return s|0}}else t=0;a:while(1){l=f[a>>2]|0;if(l>>>0<(f[h>>2]|0)>>>0){p=b[l>>0]|0;q=p&255;if(p<<24>>24>-1){f[i>>2]=q;f[a>>2]=l+1;v=q}else{w=q;r=11}}else{w=0;r=11}if((r|0)==11){r=0;q=_nb(a,w)|0;f[i>>2]=q;v=q}if((v|0)==0|(v&7|0)==4){s=1;r=23;break}q=v>>>3;l=oub(g,q)|0;do if(!l){if(wub(g,q)|0){p=f[k>>2]|0;if(!p)x=Uh[f[(f[e>>2]|0)+312>>2]&1023](e,q)|0;else x=mub(p,g,q)|0;if(x|0){y=x;r=21;break}}if((v|0)==11?(b[(f[j>>2]|0)+48>>0]|0)!=0:0){p=gQb(a,c)|0;z=p?2:1;A=p}else{y=0;r=21}}else{y=l;r=21}while(0);if((r|0)==21){r=0;l=fQb(v,y,c,a)|0;z=(l^1)&1;A=l}l=t&A;switch(z&3){case 2:case 0:{t=l;break}default:{s=l;r=23;break a}}}if((r|0)==23){u=d;return s|0}return 0}function fQb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;g=u;u=u+16|0;i=g;j=di[f[(f[d>>2]|0)+92>>2]&1023](d)|0;do if(c|0){k=a&7;l=c+32|0;m=f[l>>2]|0;if((k|0)!=(f[135924+(m<<2)>>2]|0)){if(!((k|0)==2&((m+-9|0)>>>0>3?(f[c+36>>2]|0)==3:0)))break;k=f[e>>2]|0;o=e+4|0;if(k>>>0<(f[o>>2]|0)>>>0){q=b[k>>0]|0;r=q&255;if(q<<24>>24>-1){f[e>>2]=k+1;t=r}else{v=r;w=8}}else{v=0;w=8}if((w|0)==8){r=Knb(e,v)|0;k=J;if((k|0)>-1|(k|0)==-1&r>>>0>4294967295)t=r;else{x=0;u=g;return x|0}}r=Gnb(e,t)|0;a:do switch(f[l>>2]|0){case 5:{if((Qnb(e)|0)>0){while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0){q=b[k>>0]|0;y=q&255;if(q<<24>>24>-1){f[e>>2]=k+1;z=y}else{A=y;w=41}}else{A=0;w=41}if((w|0)==41){w=0;y=Knb(e,A)|0;k=J;if((k|0)>-1|(k|0)==-1&y>>>0>4294967295)z=y;else{x=0;break}}th[f[(f[j>>2]|0)+260>>2]&511](j,d,c,z);if((Qnb(e)|0)<=0)break a}u=g;return x|0}break}case 3:{if((Qnb(e)|0)>0){y=i+8|0;while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0?(q=b[k>>0]|0,q<<24>>24>-1):0){f[e>>2]=k+1;B=q&255;C=0}else{Lnb(i,e);q=i;if(!(b[y>>0]|0)){x=0;break}else{B=f[q>>2]|0;C=f[q+4>>2]|0}}uh[f[(f[j>>2]|0)+264>>2]&255](j,d,c,B,C);if((Qnb(e)|0)<=0)break a}u=g;return x|0}break}case 17:{if((Qnb(e)|0)>0){while(1){y=f[e>>2]|0;if(y>>>0<(f[o>>2]|0)>>>0){q=b[y>>0]|0;k=q&255;if(q<<24>>24>-1){f[e>>2]=y+1;D=k>>>1^0-(k&1)}else{E=k;w=51}}else{E=0;w=51}if((w|0)==51){w=0;k=Knb(e,E)|0;y=J;if((y|0)>-1|(y|0)==-1&k>>>0>4294967295)D=k>>>1^0-(k&1);else{x=0;break}}th[f[(f[j>>2]|0)+260>>2]&511](j,d,c,D);if((Qnb(e)|0)<=0)break a}u=g;return x|0}break}case 18:{if((Qnb(e)|0)>0){k=i+8|0;while(1){y=f[e>>2]|0;if(y>>>0<(f[o>>2]|0)>>>0?(q=b[y>>0]|0,q<<24>>24>-1):0){F=q&255;f[e>>2]=y+1;y=Sac(F|0,0,1)|0;q=J;G=Jac(0,0,F&1|0,0)|0;H=y^G;I=q^J}else{Lnb(i,e);q=i;G=f[q>>2]|0;y=(b[k>>0]|0)==0;F=Sac(G|0,f[q+4>>2]|0,1)|0;q=J;K=Jac(0,0,G&1|0,0)|0;if(y){x=0;break}else{H=F^K;I=q^J}}uh[f[(f[j>>2]|0)+264>>2]&255](j,d,c,H,I);if((Qnb(e)|0)<=0)break a}u=g;return x|0}break}case 13:{if((Qnb(e)|0)>0){while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0){q=b[k>>0]|0;K=q&255;if(q<<24>>24>-1){f[e>>2]=k+1;L=K}else{M=K;w=61}}else{M=0;w=61}if((w|0)==61){w=0;K=Knb(e,M)|0;k=J;if((k|0)>-1|(k|0)==-1&K>>>0>4294967295)L=K;else{x=0;break}}th[f[(f[j>>2]|0)+268>>2]&511](j,d,c,L);if((Qnb(e)|0)<=0)break a}u=g;return x|0}break}case 4:{if((Qnb(e)|0)>0){K=i+8|0;while(1){k=f[e>>2]|0;if(k>>>0<(f[o>>2]|0)>>>0?(q=b[k>>0]|0,q<<24>>24>-1):0){f[e>>2]=k+1;N=q&255;O=0}else{Lnb(i,e);q=i;if(!(b[K>>0]|0)){x=0;break}else{N=f[q>>2]|0;O=f[q+4>>2]|0}}uh[f[(f[j>>2]|0)+272>>2]&255](j,d,c,N,O);if((Qnb(e)|0)<=0)break a}u=g;return x|0}break}case 7:{if((Qnb(e)|0)>0){while(1){K=f[e>>2]|0;if(((f[o>>2]|0)-K|0)>3){q=K;k=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;f[i>>2]=k;f[e>>2]=K+4;P=k}else{if(!(Xnb(e,i)|0))break;P=f[i>>2]|0}th[f[(f[j>>2]|0)+268>>2]&511](j,d,c,P);if((Qnb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 6:{if((Qnb(e)|0)>0){while(1){k=f[e>>2]|0;if(((f[o>>2]|0)-k|0)>7){K=k;q=K;F=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=K+4|0;K=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=i;f[q>>2]=F;f[q+4>>2]=K;f[e>>2]=k+8;Q=F;R=K}else{if(!(Ynb(e,i)|0))break;K=i;Q=f[K>>2]|0;R=f[K+4>>2]|0}uh[f[(f[j>>2]|0)+272>>2]&255](j,d,c,Q,R);if((Qnb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 15:{if((Qnb(e)|0)>0){while(1){K=f[e>>2]|0;if(((f[o>>2]|0)-K|0)>3){F=K;k=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;f[i>>2]=k;f[e>>2]=K+4;S=k}else{if(!(Xnb(e,i)|0))break;S=f[i>>2]|0}th[f[(f[j>>2]|0)+260>>2]&511](j,d,c,S);if((Qnb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 16:{if((Qnb(e)|0)>0){while(1){k=f[e>>2]|0;if(((f[o>>2]|0)-k|0)>7){K=k;F=K;q=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;F=K+4|0;K=h[F>>0]|h[F+1>>0]<<8|h[F+2>>0]<<16|h[F+3>>0]<<24;F=i;f[F>>2]=q;f[F+4>>2]=K;f[e>>2]=k+8;T=q;U=K}else{if(!(Ynb(e,i)|0))break;K=i;T=f[K>>2]|0;U=f[K+4>>2]|0}uh[f[(f[j>>2]|0)+264>>2]&255](j,d,c,T,U);if((Qnb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 2:{if((Qnb(e)|0)>0){while(1){K=f[e>>2]|0;if(((f[o>>2]|0)-K|0)>3){q=K;k=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;f[i>>2]=k;f[e>>2]=K+4;V=k}else{if(!(Xnb(e,i)|0))break;V=f[i>>2]|0}oh[f[(f[j>>2]|0)+276>>2]&63](j,d,c,(f[s>>2]=V,+n[s>>2]));if((Qnb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 1:{if((Qnb(e)|0)>0){while(1){k=f[e>>2]|0;if(((f[o>>2]|0)-k|0)>7){K=k;q=K;F=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=K+4|0;K=h[q>>0]|h[q+1>>0]<<8|h[q+2>>0]<<16|h[q+3>>0]<<24;q=i;f[q>>2]=F;f[q+4>>2]=K;f[e>>2]=k+8;f[s>>2]=F;f[s+4>>2]=K;W=+p[s>>3]}else{if(!(Ynb(e,i)|0))break;W=+p[i>>3]}oh[f[(f[j>>2]|0)+280>>2]&63](j,d,c,W);if((Qnb(e)|0)<=0)break a}x=0;u=g;return x|0}break}case 8:{if((Qnb(e)|0)>0){K=i+8|0;while(1){F=f[e>>2]|0;if(F>>>0<(f[o>>2]|0)>>>0?(k=b[F>>0]|0,k<<24>>24>-1):0){f[e>>2]=F+1;X=k<<24>>24!=0}else{Lnb(i,e);k=i;if(!(b[K>>0]|0)){x=0;break}else X=(f[k>>2]|0)!=0|(f[k+4>>2]|0)!=0}th[f[(f[j>>2]|0)+284>>2]&511](j,d,c,X);if((Qnb(e)|0)<=0)break a}u=g;return x|0}break}case 14:{if((Qnb(e)|0)>0){K=c+64|0;k=a>>>3;while(1){F=f[e>>2]|0;if(F>>>0<(f[o>>2]|0)>>>0){q=b[F>>0]|0;y=q&255;if(q<<24>>24>-1){f[e>>2]=F+1;Y=y}else{Z=y;w=112}}else{Z=0;w=112}if((w|0)==112){w=0;y=Knb(e,Z)|0;F=J;if((F|0)>-1|(F|0)==-1&y>>>0>4294967295)Y=y;else{x=0;break}}zh[f[(f[d>>2]|0)+96>>2]&2047](i,d);do if((f[(f[(f[i>>2]|0)+8>>2]|0)+64>>2]|0)!=3){y=tub(f[K>>2]|0,Y)|0;if(!y){NPb(Uh[f[(f[j>>2]|0)+12>>2]&1023](j,d)|0,k,Y,((Y|0)<0)<<31>>31);break}else{th[f[(f[j>>2]|0)+292>>2]&511](j,d,c,y);break}}else th[f[(f[j>>2]|0)+296>>2]&511](j,d,c,Y);while(0);if((Qnb(e)|0)<=0)break a}u=g;return x|0}break}case 12:case 11:case 10:case 9:{x=0;u=g;return x|0}default:{}}while(0);Hnb(e,r);x=1;u=g;return x|0}do switch(m|0){case 5:{o=f[e>>2]|0;if(o>>>0<(f[e+4>>2]|0)>>>0){l=b[o>>0]|0;k=l&255;if(l<<24>>24>-1){f[e>>2]=o+1;_=k}else{$=k;w=124}}else{$=0;w=124}if((w|0)==124){k=Knb(e,$)|0;o=J;if((o|0)>-1|(o|0)==-1&k>>>0>4294967295)_=k;else{x=0;u=g;return x|0}}k=f[j>>2]|0;if((f[c+36>>2]|0)==3){th[f[k+260>>2]&511](j,d,c,_);x=1;u=g;return x|0}else{th[f[k+116>>2]&511](j,d,c,_);x=1;u=g;return x|0}break}case 3:{k=f[e>>2]|0;if(k>>>0<(f[e+4>>2]|0)>>>0?(o=b[k>>0]|0,o<<24>>24>-1):0){f[e>>2]=k+1;aa=o&255;ba=0}else{Lnb(i,e);o=i;if(!(b[i+8>>0]|0)){x=0;u=g;return x|0}else{aa=f[o>>2]|0;ba=f[o+4>>2]|0}}o=f[j>>2]|0;if((f[c+36>>2]|0)==3){uh[f[o+264>>2]&255](j,d,c,aa,ba);x=1;u=g;return x|0}else{uh[f[o+120>>2]&255](j,d,c,aa,ba);x=1;u=g;return x|0}break}case 17:{o=f[e>>2]|0;if(o>>>0<(f[e+4>>2]|0)>>>0){k=b[o>>0]|0;l=k&255;if(k<<24>>24>-1){f[e>>2]=o+1;ca=l>>>1^0-(l&1)}else{da=l;w=138}}else{da=0;w=138}if((w|0)==138){l=Knb(e,da)|0;o=J;if((o|0)>-1|(o|0)==-1&l>>>0>4294967295)ca=l>>>1^0-(l&1);else{x=0;u=g;return x|0}}l=f[j>>2]|0;if((f[c+36>>2]|0)==3){th[f[l+260>>2]&511](j,d,c,ca);x=1;u=g;return x|0}else{th[f[l+116>>2]&511](j,d,c,ca);x=1;u=g;return x|0}break}case 18:{l=f[e>>2]|0;if(l>>>0<(f[e+4>>2]|0)>>>0?(o=b[l>>0]|0,o<<24>>24>-1):0){k=o&255;f[e>>2]=l+1;l=Sac(k|0,0,1)|0;o=J;K=Jac(0,0,k&1|0,0)|0;ea=l^K;fa=o^J}else{Lnb(i,e);o=i;K=f[o>>2]|0;l=(b[i+8>>0]|0)==0;k=Sac(K|0,f[o+4>>2]|0,1)|0;o=J;y=Jac(0,0,K&1|0,0)|0;K=o^J;if(l){x=0;u=g;return x|0}else{ea=k^y;fa=K}}K=f[j>>2]|0;if((f[c+36>>2]|0)==3){uh[f[K+264>>2]&255](j,d,c,ea,fa);x=1;u=g;return x|0}else{uh[f[K+120>>2]&255](j,d,c,ea,fa);x=1;u=g;return x|0}break}case 13:{K=f[e>>2]|0;if(K>>>0<(f[e+4>>2]|0)>>>0){y=b[K>>0]|0;k=y&255;if(y<<24>>24>-1){f[e>>2]=K+1;ga=k}else{ha=k;w=152}}else{ha=0;w=152}if((w|0)==152){k=Knb(e,ha)|0;K=J;if((K|0)>-1|(K|0)==-1&k>>>0>4294967295)ga=k;else{x=0;u=g;return x|0}}k=f[j>>2]|0;if((f[c+36>>2]|0)==3){th[f[k+268>>2]&511](j,d,c,ga);x=1;u=g;return x|0}else{th[f[k+124>>2]&511](j,d,c,ga);x=1;u=g;return x|0}break}case 4:{k=f[e>>2]|0;if(k>>>0<(f[e+4>>2]|0)>>>0?(K=b[k>>0]|0,K<<24>>24>-1):0){f[e>>2]=k+1;ia=K&255;ja=0}else{Lnb(i,e);K=i;if(!(b[i+8>>0]|0)){x=0;u=g;return x|0}else{ia=f[K>>2]|0;ja=f[K+4>>2]|0}}K=f[j>>2]|0;if((f[c+36>>2]|0)==3){uh[f[K+272>>2]&255](j,d,c,ia,ja);x=1;u=g;return x|0}else{uh[f[K+128>>2]&255](j,d,c,ia,ja);x=1;u=g;return x|0}break}case 7:{K=f[e>>2]|0;do if(((f[e+4>>2]|0)-K|0)>3){k=K;y=h[k>>0]|h[k+1>>0]<<8|h[k+2>>0]<<16|h[k+3>>0]<<24;f[i>>2]=y;f[e>>2]=K+4;ka=y}else{if(Xnb(e,i)|0){ka=f[i>>2]|0;break}x=0;u=g;return x|0}while(0);K=f[j>>2]|0;if((f[c+36>>2]|0)==3)th[f[K+268>>2]&511](j,d,c,ka);else th[f[K+124>>2]&511](j,d,c,ka);x=1;u=g;return x|0}case 6:{K=f[e>>2]|0;do if(((f[e+4>>2]|0)-K|0)>7){y=K;k=y;l=h[k>>0]|h[k+1>>0]<<8|h[k+2>>0]<<16|h[k+3>>0]<<24;k=y+4|0;y=h[k>>0]|h[k+1>>0]<<8|h[k+2>>0]<<16|h[k+3>>0]<<24;k=i;f[k>>2]=l;f[k+4>>2]=y;f[e>>2]=K+8;la=l;ma=y}else{if(Ynb(e,i)|0){y=i;la=f[y>>2]|0;ma=f[y+4>>2]|0;break}x=0;u=g;return x|0}while(0);K=f[j>>2]|0;if((f[c+36>>2]|0)==3)uh[f[K+272>>2]&255](j,d,c,la,ma);else uh[f[K+128>>2]&255](j,d,c,la,ma);x=1;u=g;return x|0}case 15:{K=f[e>>2]|0;do if(((f[e+4>>2]|0)-K|0)>3){y=K;l=h[y>>0]|h[y+1>>0]<<8|h[y+2>>0]<<16|h[y+3>>0]<<24;f[i>>2]=l;f[e>>2]=K+4;na=l}else{if(Xnb(e,i)|0){na=f[i>>2]|0;break}x=0;u=g;return x|0}while(0);K=f[j>>2]|0;if((f[c+36>>2]|0)==3){th[f[K+260>>2]&511](j,d,c,na);x=1;u=g;return x|0}else{th[f[K+116>>2]&511](j,d,c,na);x=1;u=g;return x|0}break}case 16:{K=f[e>>2]|0;do if(((f[e+4>>2]|0)-K|0)>7){l=K;y=l;k=h[y>>0]|h[y+1>>0]<<8|h[y+2>>0]<<16|h[y+3>>0]<<24;y=l+4|0;l=h[y>>0]|h[y+1>>0]<<8|h[y+2>>0]<<16|h[y+3>>0]<<24;y=i;f[y>>2]=k;f[y+4>>2]=l;f[e>>2]=K+8;oa=k;pa=l}else{if(Ynb(e,i)|0){l=i;oa=f[l>>2]|0;pa=f[l+4>>2]|0;break}x=0;u=g;return x|0}while(0);K=f[j>>2]|0;if((f[c+36>>2]|0)==3){uh[f[K+264>>2]&255](j,d,c,oa,pa);x=1;u=g;return x|0}else{uh[f[K+120>>2]&255](j,d,c,oa,pa);x=1;u=g;return x|0}break}case 2:{K=f[e>>2]|0;do if(((f[e+4>>2]|0)-K|0)>3){l=K;k=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;f[i>>2]=k;f[e>>2]=K+4;qa=k}else{if(Xnb(e,i)|0){qa=f[i>>2]|0;break}x=0;u=g;return x|0}while(0);K=f[j>>2]|0;ra=(f[s>>2]=qa,+n[s>>2]);if((f[c+36>>2]|0)==3){oh[f[K+276>>2]&63](j,d,c,ra);x=1;u=g;return x|0}else{oh[f[K+132>>2]&63](j,d,c,ra);x=1;u=g;return x|0}break}case 1:{K=f[e>>2]|0;do if(((f[e+4>>2]|0)-K|0)>7){k=K;l=k;y=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;l=k+4|0;k=h[l>>0]|h[l+1>>0]<<8|h[l+2>>0]<<16|h[l+3>>0]<<24;l=i;f[l>>2]=y;f[l+4>>2]=k;f[e>>2]=K+8;f[s>>2]=y;f[s+4>>2]=k;sa=+p[s>>3]}else{if(Ynb(e,i)|0){sa=+p[i>>3];break}x=0;u=g;return x|0}while(0);K=f[j>>2]|0;if((f[c+36>>2]|0)==3){oh[f[K+280>>2]&63](j,d,c,sa);x=1;u=g;return x|0}else{oh[f[K+136>>2]&63](j,d,c,sa);x=1;u=g;return x|0}break}case 8:{K=f[e>>2]|0;if(K>>>0<(f[e+4>>2]|0)>>>0?(k=b[K>>0]|0,k<<24>>24>-1):0){f[e>>2]=K+1;ta=k<<24>>24!=0}else{Lnb(i,e);k=i;if(!(b[i+8>>0]|0)){x=0;u=g;return x|0}else ta=(f[k>>2]|0)!=0|(f[k+4>>2]|0)!=0}k=f[j>>2]|0;if((f[c+36>>2]|0)==3){th[f[k+284>>2]&511](j,d,c,ta);x=1;u=g;return x|0}else{th[f[k+140>>2]&511](j,d,c,ta);x=1;u=g;return x|0}break}case 14:{k=f[e>>2]|0;if(k>>>0<(f[e+4>>2]|0)>>>0){K=b[k>>0]|0;y=K&255;if(K<<24>>24>-1){f[e>>2]=k+1;ua=y}else{va=y;w=217}}else{va=0;w=217}if((w|0)==217){y=Knb(e,va)|0;k=J;if((k|0)>-1|(k|0)==-1&y>>>0>4294967295)ua=y;else{x=0;u=g;return x|0}}zh[f[(f[d>>2]|0)+96>>2]&2047](i,d);if((f[(f[(f[i>>2]|0)+8>>2]|0)+64>>2]|0)==3){y=f[j>>2]|0;if((f[c+36>>2]|0)==3){th[f[y+296>>2]&511](j,d,c,ua);x=1;u=g;return x|0}else{th[f[y+152>>2]&511](j,d,c,ua);x=1;u=g;return x|0}}y=tub(f[c+64>>2]|0,ua)|0;if(!y){NPb(Uh[f[(f[j>>2]|0)+12>>2]&1023](j,d)|0,a>>>3,ua,((ua|0)<0)<<31>>31);x=1;u=g;return x|0}k=f[j>>2]|0;if((f[c+36>>2]|0)==3){th[f[k+292>>2]&511](j,d,c,y);x=1;u=g;return x|0}else{th[f[k+148>>2]&511](j,d,c,y);x=1;u=g;return x|0}break}case 9:{y=(f[(f[c+24>>2]|0)+64>>2]|0)==3;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=fqb(e,i)|0;K=i+11|0;l=b[K>>0]|0;o=l<<24>>24<0;if(!k){if(o)O5b(f[i>>2]|0);x=0;u=g;return x|0}k=f[c+4>>2]|0;if((b[k+11>>0]|0)<0)wa=f[k>>2]|0;else wa=k;if(y?!(gqb(o?f[i>>2]|0:i,o?f[i+4>>2]|0:l&255,0,wa)|0):0){if((b[K>>0]|0)<0)O5b(f[i>>2]|0);x=0;u=g;return x|0}l=f[j>>2]|0;if((f[c+36>>2]|0)==3)th[f[l+288>>2]&511](j,d,c,i);else th[f[l+144>>2]&511](j,d,c,i);if((b[K>>0]|0)<0)O5b(f[i>>2]|0);x=1;u=g;return x|0}case 12:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(!(fqb(e,i)|0)){if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);x=0;u=g;return x|0}K=f[j>>2]|0;if((f[c+36>>2]|0)==3)th[f[K+288>>2]&511](j,d,c,i);else th[f[K+144>>2]&511](j,d,c,i);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);x=1;u=g;return x|0}case 10:{K=f[j>>2]|0;l=f[e+56>>2]|0;if((f[c+36>>2]|0)==3)xa=Dg[f[K+300>>2]&127](j,d,c,l)|0;else xa=Dg[f[K+156>>2]&127](j,d,c,l)|0;l=a&-8;K=e+44|0;o=f[K>>2]|0;f[K>>2]=o+-1;if((o|0)>0?Uh[f[(f[xa>>2]|0)+44>>2]&1023](xa,e)|0:0){o=f[K>>2]|0;if((o|0)<(f[e+48>>2]|0))f[K>>2]=o+1;if((f[e+20>>2]|0)==(l|4|0)){x=1;u=g;return x|0}}x=0;u=g;return x|0}case 11:{l=f[j>>2]|0;o=f[e+56>>2]|0;if((f[c+36>>2]|0)==3)ya=Dg[f[l+300>>2]&127](j,d,c,o)|0;else ya=Dg[f[l+156>>2]&127](j,d,c,o)|0;o=f[e>>2]|0;if(o>>>0<(f[e+4>>2]|0)>>>0?(l=b[o>>0]|0,l<<24>>24>-1):0){f[e>>2]=o+1;za=l&255;w=262}else w=261;if((w|0)==261?(l=Znb(e)|0,(l|0)>-1):0){za=l;w=262}do if(((w|0)==262?(Inb(i,e,za),(f[i+4>>2]|0)>=0):0)?Uh[f[(f[ya>>2]|0)+44>>2]&1023](ya,e)|0:0){if(Onb(e,f[i>>2]|0)|0)x=1;else break;u=g;return x|0}while(0);x=0;u=g;return x|0}default:{x=1;u=g;return x|0}}while(0)}while(0);x=ZPb(e,a,Uh[f[(f[j>>2]|0)+12>>2]&1023](j,d)|0)|0;u=g;return x|0}function gQb(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;e=u;u=u+128|0;g=e+104|0;h=e+80|0;i=e+20|0;j=e;k=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=a+4|0;m=a+20|0;n=j+8|0;o=j+4|0;p=h+11|0;q=h+4|0;r=g+11|0;s=g+4|0;t=i+4|0;v=i+8|0;w=i+12|0;x=i+28|0;y=i+32|0;z=i+36|0;A=i+40|0;B=i+44|0;C=i+48|0;D=i+52|0;E=i+56|0;F=0;G=0;a:while(1){H=(G|0)==0;b:while(1){if(!H){I=10;break}c:while(1){K=f[a>>2]|0;if(K>>>0<(f[l>>2]|0)>>>0){L=b[K>>0]|0;M=L&255;if(L<<24>>24>-1){f[m>>2]=M;f[a>>2]=K+1;N=M}else{O=M;I=6}}else{O=0;I=6}if((I|0)==6){I=0;M=_nb(a,O)|0;f[m>>2]=M;N=M}switch(N|0){case 12:{P=1;break a;break}case 0:{I=41;break a;break}case 16:{break b;break}case 26:{break c;break}default:{}}if(!(ZPb(a,N,0)|0)){I=41;break a}}f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;M=f[a>>2]|0;if(M>>>0<(f[l>>2]|0)>>>0){K=b[M>>0]|0;L=K&255;if(K<<24>>24>-1){f[a>>2]=M+1;Q=L;I=29}else{R=L;I=28}}else{R=0;I=28}if((I|0)==28){I=0;L=Knb(a,R)|0;M=J;if((M|0)>-1|(M|0)==-1&L>>>0>4294967295){Q=L;I=29}else S=1}if((I|0)==29){I=0;if(Vnb(a,h,Q)|0){Nob(i,g);$nb(j,i);if((f[n>>2]|0)>4){L=f[o>>2]|0;if(Q>>>0>127){M=Q;K=L;while(1){b[K>>0]=M|128;T=M>>>7;U=K+1|0;if(M>>>0>16383){M=T;K=U}else{V=U;W=T;break}}}else{V=L;W=Q}b[V>>0]=W;K=V+1-L|0;f[o>>2]=(f[o>>2]|0)+K;f[n>>2]=(f[n>>2]|0)-K}else fob(j,Q);K=b[p>>0]|0;M=K<<24>>24<0;bob(j,M?f[h>>2]|0:h,M?f[q>>2]|0:K&255);aob(j);xob(i);S=0}else S=1}if((b[p>>0]|0)<0)O5b(f[h>>2]|0);if(S|0){P=0;break a}}d:do if((I|0)==10)e:while(1){I=0;H=f[a>>2]|0;if(H>>>0<(f[l>>2]|0)>>>0){K=b[H>>0]|0;M=K&255;if(K<<24>>24>-1){f[m>>2]=M;f[a>>2]=H+1;X=M}else{Y=M;I=13}}else{Y=0;I=13}if((I|0)==13){I=0;M=_nb(a,Y)|0;f[m>>2]=M;X=M}switch(X|0){case 12:{P=1;break a;break}case 0:{I=42;break a;break}case 16:{break d;break}case 26:{if(hQb(G,F,c,a)|0){I=10;continue e}else{I=42;break a}break}default:if(ZPb(a,X,0)|0){I=10;continue e}else{I=42;break a}}}while(0);L=f[a>>2]|0;if(L>>>0<(f[l>>2]|0)>>>0){M=b[L>>0]|0;H=M&255;if(M<<24>>24>-1){f[a>>2]=L+1;Z=H}else{_=H;I=18}}else{_=0;I=18}if((I|0)==18){I=0;H=Knb(a,_)|0;L=J;if((L|0)>-1|(L|0)==-1&H>>>0>4294967295)Z=H;else{P=0;break}}H=F;F=Uh[f[(f[k>>2]|0)+312>>2]&1023](k,Z)|0;H=b[r>>0]|0;L=H<<24>>24<0;M=f[s>>2]|0;K=H&255;if(!((L?M:K)|0)){F=F;G=Z;continue}Lob(h,L?f[g>>2]|0:g,L?M:K,-1);f[i>>2]=0;f[t>>2]=0;f[v>>2]=h;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;d[w+12>>1]=0;f[x>>2]=2147483647;f[y>>2]=0;f[z>>2]=67108864;f[A>>2]=33554432;K=f[33911]|0;f[B>>2]=K;f[C>>2]=K;f[D>>2]=0;f[E>>2]=0;Mnb(i)|0;do if(hQb(Z,F,c,i)|0)if((b[r>>0]|0)<0){b[f[g>>2]>>0]=0;f[s>>2]=0;$=0;break}else{b[g>>0]=0;b[r>>0]=0;$=0;break}else $=1;while(0);Fnb(i);lob(h);if($|0){P=0;break}else G=Z}if((I|0)==41)P=0;else if((I|0)==42)P=0;if((b[r>>0]|0)>=0){u=e;return P|0}O5b(f[g>>2]|0);u=e;return P|0}function hQb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+32|0;k=di[f[(f[d>>2]|0)+92>>2]&1023](d)|0;if(!c){l=Uh[f[(f[k>>2]|0)+12>>2]&1023](k,d)|0;m=f[e>>2]|0;if(m>>>0<(f[e+4>>2]|0)>>>0){n=b[m>>0]|0;o=n&255;if(n<<24>>24>-1){f[e>>2]=m+1;p=o}else{q=o;r=5}}else{q=0;r=5}if((r|0)==5){r=Knb(e,q)|0;q=J;if((q|0)>-1|(q|0)==-1&r>>>0>4294967295)p=r;else{s=0;u=g;return s|0}}s=Vnb(e,QPb(l,a)|0,p)|0;u=g;return s|0}if((f[c+36>>2]|0)!=3?(f[c+32>>2]|0)==11:0){p=Dg[f[(f[k>>2]|0)+156>>2]&127](k,d,c,f[e+56>>2]|0)|0;c=f[e>>2]|0;if(c>>>0<(f[e+4>>2]|0)>>>0?(d=b[c>>0]|0,d<<24>>24>-1):0){f[e>>2]=c+1;t=d&255}else{d=Znb(e)|0;if((d|0)>-1)t=d;else{s=0;u=g;return s|0}}Inb(h,e,t);if((f[h+4>>2]|0)>=0?Uh[f[(f[p>>2]|0)+44>>2]&1023](p,e)|0:0)v=Onb(e,f[h>>2]|0)|0;else v=0;s=v;u=g;return s|0}zpb(i,2,477302,455);xpb(j,vpb(i,477395)|0);Apb(i);s=0;u=g;return s|0}function iQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+36|0;zh[f[(f[a>>2]|0)+96>>2]&2047](g,a);j=f[g>>2]|0;k=di[f[(f[a>>2]|0)+92>>2]&1023](a)|0;l=d+12|0;m=d+8|0;n=(f[l>>2]|0)+c-(f[m>>2]|0)|0;f[g>>2]=0;c=g+4|0;f[c>>2]=0;f[g+8>>2]=0;_h[f[(f[k>>2]|0)+64>>2]&255](k,a,g);o=f[g>>2]|0;if((f[c>>2]|0)!=(o|0)){p=0;q=o;do{jQb(f[q+(p<<2)>>2]|0,a,d);p=p+1|0;q=f[g>>2]|0}while(p>>>0<(f[c>>2]|0)-q>>2>>>0)}q=(b[(f[j+16>>2]|0)+48>>0]|0)==0;j=Uh[f[(f[k>>2]|0)+8>>2]&1023](k,a)|0;if(q)aQb(j,d);else cQb(j,d);if(((f[l>>2]|0)-(f[m>>2]|0)|0)!=(n|0)){zpb(h,3,477302,809);xpb(i,vpb(vpb(h,477448)|0,477509)|0);Apb(h)}h=f[g>>2]|0;if(!h){u=e;return}g=f[c>>2]|0;if((g|0)!=(h|0))f[c>>2]=g+(~((g+-4-h|0)>>>2)<<2);O5b(h);u=e;return}function jQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;e=u;u=u+16|0;g=e;h=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;if(((b[a+40>>0]|0?b[(f[(f[a+48>>2]|0)+16>>2]|0)+48>>0]|0:0)?(f[136e3+(f[a+32>>2]<<2)>>2]|0)==10:0)?(f[a+36>>2]|0)!=3:0){kQb(a,c,d);u=e;return}i=a+36|0;if((f[i>>2]|0)==3)j=li[f[(f[h>>2]|0)+24>>2]&511](h,c,a)|0;else j=(li[f[(f[h>>2]|0)+20>>2]&511](h,c,a)|0)&1;k=yub(a)|0;l=(j|0)>0;do if(k&l){m=f[a+28>>2]<<3|2;o=d+8|0;if((f[o>>2]|0)>4){q=d+4|0;r=f[q>>2]|0;if(m>>>0>127){t=m;v=r;while(1){b[v>>0]=t|128;w=t>>>7;x=v+1|0;if(t>>>0>16383){t=w;v=x}else{y=x;z=w;break}}}else{y=r;z=m}b[y>>0]=z;v=y+1-r|0;f[q>>2]=(f[q>>2]|0)+v;f[o>>2]=(f[o>>2]|0)-v}else fob(d,m);v=lQb(a,c)|0;if((f[o>>2]|0)<=4){fob(d,v);break}t=d+4|0;w=f[t>>2]|0;if(v>>>0>127){x=v;A=w;while(1){b[A>>0]=x|128;B=x>>>7;C=A+1|0;if(x>>>0>16383){x=B;A=C}else{D=C;E=B;break}}}else{D=w;E=v}b[D>>0]=E;A=D+1-w|0;f[t>>2]=(f[t>>2]|0)+A;f[o>>2]=(f[o>>2]|0)-A}while(0);if(!l){u=e;return}l=a+32|0;D=d+8|0;E=d+4|0;y=a+28|0;z=a+24|0;A=a+4|0;x=g+11|0;m=g+11|0;q=0;do{a:do switch(f[l>>2]|0){case 5:{if((f[i>>2]|0)==3)F=Dg[f[(f[h>>2]|0)+168>>2]&127](h,c,a,q)|0;else F=li[f[(f[h>>2]|0)+68>>2]&511](h,c,a)|0;if(!k){Mpb(f[y>>2]|0,F,d);break a}if((F|0)<0){gob(d,F,((F|0)<0)<<31>>31);break a}if((f[D>>2]|0)<=4){fob(d,F);break a}r=f[E>>2]|0;if(F>>>0>127){B=F;C=r;while(1){b[C>>0]=B|128;G=B>>>7;H=C+1|0;if(B>>>0>16383){B=G;C=H}else{I=H;K=G;break}}}else{I=r;K=F}b[I>>0]=K;C=I+1-r|0;f[E>>2]=(f[E>>2]|0)+C;f[D>>2]=(f[D>>2]|0)-C;break}case 3:{if((f[i>>2]|0)==3){C=Dg[f[(f[h>>2]|0)+172>>2]&127](h,c,a,q)|0;L=C;M=J}else{C=li[f[(f[h>>2]|0)+72>>2]&511](h,c,a)|0;L=C;M=J}if(k){gob(d,L,M);break a}else{Npb(f[y>>2]|0,L,M,d);break a}break}case 17:{if((f[i>>2]|0)==3)N=Dg[f[(f[h>>2]|0)+168>>2]&127](h,c,a,q)|0;else N=li[f[(f[h>>2]|0)+68>>2]&511](h,c,a)|0;if(!k){Qpb(f[y>>2]|0,N,d);break a}C=N<<1^N>>31;if((f[D>>2]|0)<=4){fob(d,C);break a}B=f[E>>2]|0;if(C>>>0>127){G=C;H=B;while(1){b[H>>0]=G|128;O=G>>>7;P=H+1|0;if(G>>>0>16383){G=O;H=P}else{Q=P;R=O;break}}}else{Q=B;R=C}b[Q>>0]=R;H=Q+1-B|0;f[E>>2]=(f[E>>2]|0)+H;f[D>>2]=(f[D>>2]|0)-H;break}case 18:{if((f[i>>2]|0)==3){H=Dg[f[(f[h>>2]|0)+172>>2]&127](h,c,a,q)|0;S=H;T=J}else{H=li[f[(f[h>>2]|0)+72>>2]&511](h,c,a)|0;S=H;T=J}if(k){H=$ac(S|0,T|0,1)|0;G=J;r=Rac(S|0,T|0,63)|0;gob(d,H^r,G^J);break a}else{Rpb(f[y>>2]|0,S,T,d);break a}break}case 13:{if((f[i>>2]|0)==3)U=Dg[f[(f[h>>2]|0)+176>>2]&127](h,c,a,q)|0;else U=li[f[(f[h>>2]|0)+76>>2]&511](h,c,a)|0;if(!k){Opb(f[y>>2]|0,U,d);break a}if((f[D>>2]|0)<=4){fob(d,U);break a}G=f[E>>2]|0;if(U>>>0>127){r=U;H=G;while(1){b[H>>0]=r|128;O=r>>>7;P=H+1|0;if(r>>>0>16383){r=O;H=P}else{V=P;W=O;break}}}else{V=G;W=U}b[V>>0]=W;H=V+1-G|0;f[E>>2]=(f[E>>2]|0)+H;f[D>>2]=(f[D>>2]|0)-H;break}case 4:{if((f[i>>2]|0)==3){H=Dg[f[(f[h>>2]|0)+180>>2]&127](h,c,a,q)|0;X=H;Y=J}else{H=li[f[(f[h>>2]|0)+80>>2]&511](h,c,a)|0;X=H;Y=J}if(k){gob(d,X,Y);break a}else{Ppb(f[y>>2]|0,X,Y,d);break a}break}case 7:{if((f[i>>2]|0)==3)Z=Dg[f[(f[h>>2]|0)+176>>2]&127](h,c,a,q)|0;else Z=li[f[(f[h>>2]|0)+76>>2]&511](h,c,a)|0;if(k){dob(d,Z);break a}else{Spb(f[y>>2]|0,Z,d);break a}break}case 6:{if((f[i>>2]|0)==3){H=Dg[f[(f[h>>2]|0)+180>>2]&127](h,c,a,q)|0;_=H;$=J}else{H=li[f[(f[h>>2]|0)+80>>2]&511](h,c,a)|0;_=H;$=J}if(k){eob(d,_,$);break a}else{Tpb(f[y>>2]|0,_,$,d);break a}break}case 15:{if((f[i>>2]|0)==3)aa=Dg[f[(f[h>>2]|0)+168>>2]&127](h,c,a,q)|0;else aa=li[f[(f[h>>2]|0)+68>>2]&511](h,c,a)|0;if(k){dob(d,aa);break a}else{Upb(f[y>>2]|0,aa,d);break a}break}case 16:{if((f[i>>2]|0)==3){H=Dg[f[(f[h>>2]|0)+172>>2]&127](h,c,a,q)|0;ba=H;ca=J}else{H=li[f[(f[h>>2]|0)+72>>2]&511](h,c,a)|0;ba=H;ca=J}if(k){eob(d,ba,ca);break a}else{Vpb(f[y>>2]|0,ba,ca,d);break a}break}case 2:{if((f[i>>2]|0)==3)da=+Kh[f[(f[h>>2]|0)+184>>2]&15](h,c,a,q);else da=+fh[f[(f[h>>2]|0)+84>>2]&31](h,c,a);if(k){dob(d,(n[s>>2]=da,f[s>>2]|0));break a}else{Wpb(f[y>>2]|0,da,d);break a}break}case 1:{if((f[i>>2]|0)==3)ea=+Kh[f[(f[h>>2]|0)+188>>2]&15](h,c,a,q);else ea=+fh[f[(f[h>>2]|0)+88>>2]&31](h,c,a);if(k){p[s>>3]=ea;eob(d,f[s>>2]|0,f[s+4>>2]|0);break a}else{Xpb(f[y>>2]|0,ea,d);break a}break}case 8:{if((f[i>>2]|0)==3)fa=Dg[f[(f[h>>2]|0)+192>>2]&127](h,c,a,q)|0;else fa=li[f[(f[h>>2]|0)+92>>2]&511](h,c,a)|0;if(!k){Ypb(f[y>>2]|0,fa,d);break a}if((f[D>>2]|0)>4){b[f[E>>2]>>0]=fa&1;f[E>>2]=(f[E>>2]|0)+1;f[D>>2]=(f[D>>2]|0)+-1;break a}else{fob(d,fa&1);break a}break}case 10:{H=f[y>>2]|0;if((f[i>>2]|0)==3)ga=Dg[f[(f[h>>2]|0)+208>>2]&127](h,c,a,q)|0;else ga=Dg[f[(f[h>>2]|0)+108>>2]&127](h,c,a,0)|0;cqb(H,ga,d);break}case 11:{H=f[y>>2]|0;if((f[i>>2]|0)==3)ha=Dg[f[(f[h>>2]|0)+208>>2]&127](h,c,a,q)|0;else ha=Dg[f[(f[h>>2]|0)+108>>2]&127](h,c,a,0)|0;dqb(H,ha,d);break}case 14:{if((f[i>>2]|0)==3)ia=Dg[f[(f[h>>2]|0)+200>>2]&127](h,c,a,q)|0;else ia=li[f[(f[h>>2]|0)+100>>2]&511](h,c,a)|0;if(!k){Zpb(f[y>>2]|0,f[ia+8>>2]|0,d);break a}H=f[ia+8>>2]|0;if((H|0)<0){gob(d,H,((H|0)<0)<<31>>31);break a}if((f[D>>2]|0)<=4){fob(d,H);break a}r=f[E>>2]|0;if(H>>>0>127){B=H;C=r;while(1){b[C>>0]=B|128;O=B>>>7;P=C+1|0;if(B>>>0>16383){B=O;C=P}else{ja=P;ka=O;break}}}else{ja=r;ka=H}b[ja>>0]=ka;C=ja+1-r|0;f[E>>2]=(f[E>>2]|0)+C;f[D>>2]=(f[D>>2]|0)-C;break}case 9:{C=(f[(f[z>>2]|0)+64>>2]|0)==3;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if((f[i>>2]|0)==3)la=nh[f[(f[h>>2]|0)+212>>2]&127](h,c,a,q,g)|0;else la=Dg[f[(f[h>>2]|0)+112>>2]&127](h,c,a,g)|0;B=b[la+11>>0]|0;if(B<<24>>24<0){ma=f[la>>2]|0;na=f[la+4>>2]|0}else{ma=la;na=B&255}B=f[A>>2]|0;if((b[B+11>>0]|0)<0)oa=f[B>>2]|0;else oa=B;if(C)gqb(ma,na,1,oa)|0;_pb(f[y>>2]|0,la,d);if((b[x>>0]|0)<0)O5b(f[g>>2]|0);break}case 12:{f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if((f[i>>2]|0)==3)pa=nh[f[(f[h>>2]|0)+212>>2]&127](h,c,a,q,g)|0;else pa=Dg[f[(f[h>>2]|0)+112>>2]&127](h,c,a,g)|0;aqb(f[y>>2]|0,pa,d);if((b[m>>0]|0)<0)O5b(f[g>>2]|0);break}default:{}}while(0);q=q+1|0}while((q|0)<(j|0));u=e;return}function kQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;g=d+8|0;if((f[g>>2]|0)>4){h=d+4|0;b[f[h>>2]>>0]=11;f[h>>2]=(f[h>>2]|0)+1;h=(f[g>>2]|0)+-1|0;f[g>>2]=h;i=h}else{fob(d,11);i=f[g>>2]|0}if((i|0)>4){i=d+4|0;b[f[i>>2]>>0]=16;f[i>>2]=(f[i>>2]|0)+1;i=(f[g>>2]|0)+-1|0;f[g>>2]=i;j=i}else{fob(d,16);j=f[g>>2]|0}i=f[a+28>>2]|0;if((j|0)>4){j=d+4|0;h=f[j>>2]|0;if(i>>>0>127){k=i;l=h;while(1){b[l>>0]=k|128;m=k>>>7;n=l+1|0;if(k>>>0>16383){k=m;l=n}else{o=n;p=m;break}}}else{o=h;p=i}b[o>>0]=p;p=o+1-h|0;f[j>>2]=(f[j>>2]|0)+p;j=(f[g>>2]|0)-p|0;f[g>>2]=j;q=j}else{fob(d,i);q=f[g>>2]|0}if((q|0)>4){q=d+4|0;b[f[q>>2]>>0]=26;f[q>>2]=(f[q>>2]|0)+1;f[g>>2]=(f[g>>2]|0)+-1}else fob(d,26);q=Dg[f[(f[e>>2]|0)+108>>2]&127](e,c,a,0)|0;a=di[f[(f[q>>2]|0)+64>>2]&1023](q)|0;if((f[g>>2]|0)>4){c=d+4|0;e=f[c>>2]|0;if(a>>>0>127){i=a;j=e;while(1){b[j>>0]=i|128;p=i>>>7;h=j+1|0;if(i>>>0>16383){i=p;j=h}else{r=h;s=p;break}}}else{r=e;s=a}b[r>>0]=s;s=r+1-e|0;f[c>>2]=(f[c>>2]|0)+s;f[g>>2]=(f[g>>2]|0)-s}else fob(d,a);zh[f[(f[q>>2]|0)+56>>2]&2047](q,d);if((f[g>>2]|0)>4){q=d+4|0;b[f[q>>2]>>0]=12;f[q>>2]=(f[q>>2]|0)+1;f[g>>2]=(f[g>>2]|0)+-1;return}else{fob(d,12);return}}function lQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+16|0;e=d;g=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;h=a+36|0;if((f[h>>2]|0)==3)i=li[f[(f[g>>2]|0)+24>>2]&511](g,c,a)|0;else i=(li[f[(f[g>>2]|0)+20>>2]&511](g,c,a)|0)&1;do switch(f[a+32>>2]|0){case 5:{if((f[h>>2]|0)!=3){j=li[f[(f[g>>2]|0)+68>>2]&511](g,c,a)|0;if((j|0)<0){k=10;u=d;return k|0}if(j>>>0<128){k=1;u=d;return k|0}k=iob(j)|0;u=d;return k|0}if(!i){k=0;u=d;return k|0}j=0;l=0;while(1){m=Dg[f[(f[g>>2]|0)+168>>2]&127](g,c,a,j)|0;if((m|0)>=0)if(m>>>0<128)n=1;else n=iob(m)|0;else n=10;m=n+l|0;j=j+1|0;if((j|0)==(i|0)){k=m;break}else l=m}u=d;return k|0}case 3:{if((f[h>>2]|0)!=3){l=li[f[(f[g>>2]|0)+72>>2]&511](g,c,a)|0;k=job(l,J)|0;u=d;return k|0}if(!i){k=0;u=d;return k|0}l=0;j=0;while(1){m=Dg[f[(f[g>>2]|0)+172>>2]&127](g,c,a,l)|0;o=(job(m,J)|0)+j|0;l=l+1|0;if((l|0)==(i|0)){k=o;break}else j=o}u=d;return k|0}case 17:{if((f[h>>2]|0)!=3){j=li[f[(f[g>>2]|0)+68>>2]&511](g,c,a)|0;l=j<<1^j>>31;if(l>>>0<128){k=1;u=d;return k|0}k=iob(l)|0;u=d;return k|0}if(!i){k=0;u=d;return k|0}l=0;j=0;while(1){o=Dg[f[(f[g>>2]|0)+168>>2]&127](g,c,a,l)|0;m=o<<1^o>>31;if(m>>>0<128)p=1;else p=iob(m)|0;m=p+j|0;l=l+1|0;if((l|0)==(i|0)){k=m;break}else j=m}u=d;return k|0}case 18:{if((f[h>>2]|0)!=3){j=li[f[(f[g>>2]|0)+72>>2]&511](g,c,a)|0;l=J;m=$ac(j|0,l|0,1)|0;o=J;q=Rac(j|0,l|0,63)|0;k=job(m^q,o^J)|0;u=d;return k|0}if(!i){k=0;u=d;return k|0}o=0;q=0;while(1){m=Dg[f[(f[g>>2]|0)+172>>2]&127](g,c,a,o)|0;l=J;j=$ac(m|0,l|0,1)|0;r=J;s=Rac(m|0,l|0,63)|0;l=(job(j^s,r^J)|0)+q|0;o=o+1|0;if((o|0)==(i|0)){k=l;break}else q=l}u=d;return k|0}case 13:{if((f[h>>2]|0)!=3){q=li[f[(f[g>>2]|0)+76>>2]&511](g,c,a)|0;if(q>>>0<128){k=1;u=d;return k|0}k=iob(q)|0;u=d;return k|0}if(!i){k=0;u=d;return k|0}q=0;o=0;while(1){l=Dg[f[(f[g>>2]|0)+176>>2]&127](g,c,a,q)|0;if(l>>>0<128)t=1;else t=iob(l)|0;l=t+o|0;q=q+1|0;if((q|0)==(i|0)){k=l;break}else o=l}u=d;return k|0}case 4:{if((f[h>>2]|0)!=3){o=li[f[(f[g>>2]|0)+80>>2]&511](g,c,a)|0;k=job(o,J)|0;u=d;return k|0}if(!i){k=0;u=d;return k|0}o=0;q=0;while(1){l=Dg[f[(f[g>>2]|0)+180>>2]&127](g,c,a,o)|0;r=(job(l,J)|0)+q|0;o=o+1|0;if((o|0)==(i|0)){k=r;break}else q=r}u=d;return k|0}case 7:{k=i<<2;u=d;return k|0}case 6:{k=i<<3;u=d;return k|0}case 15:{k=i<<2;u=d;return k|0}case 16:{k=i<<3;u=d;return k|0}case 2:{k=i<<2;u=d;return k|0}case 1:{k=i<<3;u=d;return k|0}case 8:{k=i;u=d;return k|0}case 10:{if((f[h>>2]|0)!=3){q=Dg[f[(f[g>>2]|0)+108>>2]&127](g,c,a,0)|0;k=di[f[(f[q>>2]|0)+52>>2]&1023](q)|0;u=d;return k|0}if(!i){k=0;u=d;return k|0}q=0;o=0;while(1){r=Dg[f[(f[g>>2]|0)+208>>2]&127](g,c,a,q)|0;l=(di[f[(f[r>>2]|0)+52>>2]&1023](r)|0)+o|0;q=q+1|0;if((q|0)==(i|0)){k=l;break}else o=l}u=d;return k|0}case 11:{if((f[h>>2]|0)!=3){o=Dg[f[(f[g>>2]|0)+108>>2]&127](g,c,a,0)|0;q=di[f[(f[o>>2]|0)+52>>2]&1023](o)|0;if(q>>>0<128)v=1;else v=iob(q)|0;k=v+q|0;u=d;return k|0}if(!i){k=0;u=d;return k|0}q=0;o=0;while(1){l=Dg[f[(f[g>>2]|0)+208>>2]&127](g,c,a,q)|0;r=di[f[(f[l>>2]|0)+52>>2]&1023](l)|0;if(r>>>0<128)w=1;else w=iob(r)|0;l=r+o+w|0;q=q+1|0;if((q|0)==(i|0)){k=l;break}else o=l}u=d;return k|0}case 14:{if((f[h>>2]|0)!=3){o=(li[f[(f[g>>2]|0)+100>>2]&511](g,c,a)|0)+8|0;q=f[o>>2]|0;if((q|0)<0){k=10;u=d;return k|0}if(q>>>0<128){k=1;u=d;return k|0}k=iob(q)|0;u=d;return k|0}if(!i){k=0;u=d;return k|0}q=0;o=0;while(1){l=(Dg[f[(f[g>>2]|0)+200>>2]&127](g,c,a,q)|0)+8|0;r=f[l>>2]|0;if((r|0)>=0)if(r>>>0<128)x=1;else x=iob(r)|0;else x=10;r=x+o|0;q=q+1|0;if((q|0)==(i|0)){k=r;break}else o=r}u=d;return k|0}case 12:case 9:{if(!i){k=0;u=d;return k|0}o=e+11|0;q=0;r=0;while(1){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if((f[h>>2]|0)==3)y=nh[f[(f[g>>2]|0)+212>>2]&127](g,c,a,q,e)|0;else y=Dg[f[(f[g>>2]|0)+112>>2]&127](g,c,a,e)|0;l=b[y+11>>0]|0;if(l<<24>>24<0){s=f[y+4>>2]|0;if(s>>>0<128){z=1;A=s}else{z=iob(s)|0;A=s}}else{z=1;A=l&255}l=A+r+z|0;if((b[o>>0]|0)<0)O5b(f[e>>2]|0);q=q+1|0;if(q>>>0>=i>>>0){k=l;break}else r=l}u=d;return k|0}default:{k=0;u=d;return k|0}}while(0);return 0}function mQb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;zh[f[(f[a>>2]|0)+96>>2]&2047](d,a);e=f[d>>2]|0;g=di[f[(f[a>>2]|0)+92>>2]&1023](a)|0;f[d>>2]=0;h=d+4|0;f[h>>2]=0;f[d+8>>2]=0;_h[f[(f[g>>2]|0)+64>>2]&255](g,a,d);i=f[d>>2]|0;if((f[h>>2]|0)==(i|0))j=0;else{k=0;l=0;m=i;while(1){i=(nQb(f[m+(l<<2)>>2]|0,a)|0)+k|0;l=l+1|0;m=f[d>>2]|0;if(l>>>0>=(f[h>>2]|0)-m>>2>>>0){j=i;break}else k=i}}k=(b[(f[e+16>>2]|0)+48>>0]|0)==0;e=Uh[f[(f[g>>2]|0)+8>>2]&1023](g,a)|0;a:do if(k)n=dQb(e)|0;else{a=f[33961]|0;g=0;m=0;while(1){l=f[e>>2]|0;if(!l)o=0;else o=(f[l+4>>2]|0)-(f[l>>2]|0)>>4;if((m|0)>=(o|0)){n=g;break a}i=f[l>>2]|0;if((f[i+(m<<4)+4>>2]|0)==3){l=f[i+(m<<4)>>2]|0;if(l>>>0<128)p=1;else p=iob(l)|0;l=g+a+p|0;q=f[i+(m<<4)+8>>2]|0;i=b[q+11>>0]|0;if(i<<24>>24<0){r=f[q+4>>2]|0;if(r>>>0<128){s=1;t=r}else{s=iob(r)|0;t=r}}else{s=1;t=i&255}v=l+t+s|0}else v=g;g=v;m=m+1|0}}while(0);v=n+j|0;j=f[d>>2]|0;if(!j){u=c;return v|0}d=f[h>>2]|0;if((d|0)!=(j|0))f[h>>2]=d+(~((d+-4-j|0)>>>2)<<2);O5b(j);u=c;return v|0}function nQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;if(((b[a+40>>0]|0?b[(f[(f[a+48>>2]|0)+16>>2]|0)+48>>0]|0:0)?(f[136e3+(f[a+32>>2]<<2)>>2]|0)==10:0)?(f[a+36>>2]|0)!=3:0){e=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;g=f[33961]|0;h=f[a+28>>2]|0;if(h>>>0<128)i=1;else i=iob(h)|0;h=Dg[f[(f[e>>2]|0)+108>>2]&127](e,c,a,0)|0;e=di[f[(f[h>>2]|0)+52>>2]&1023](h)|0;if(e>>>0<128)j=1;else j=iob(e)|0;k=i+g+e+j|0;return k|0}if((f[a+36>>2]|0)==3)l=li[f[(f[d>>2]|0)+24>>2]&511](d,c,a)|0;else l=(li[f[(f[d>>2]|0)+20>>2]&511](d,c,a)|0)&1;d=lQb(a,c)|0;if(!(yub(a)|0)){c=f[a+32>>2]|0;j=f[a+28>>2]<<3;if(j>>>0<128)m=1;else m=iob(j)|0;k=(Y(m<<((c|0)==10&1),l)|0)+d|0;return k|0}if(!d){k=0;return k|0}l=f[a+28>>2]<<3;if(l>>>0<128)n=1;else n=iob(l)|0;if(d>>>0<128)o=1;else o=iob(d)|0;k=n+d+o|0;return k|0}function oQb(a){a=a|0;return}function pQb(a){a=a|0;O5b(a);return}function qQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a+4>>2]|0;a=f[213458]|0;if(!a){e=0;return e|0}g=(d*65535|0)+b|0;h=f[a+4>>2]|0;if(!h){e=0;return e|0}i=h+-1|0;j=(i&h|0)==0;if(!j)if(g>>>0<h>>>0)k=g;else k=(g>>>0)%(h>>>0)|0;else k=i&g;l=f[(f[a>>2]|0)+(k<<2)>>2]|0;if(!l){e=0;return e|0}a=f[l>>2]|0;if(!a){e=0;return e|0}a:do if(j){l=a;while(1){m=f[l+4>>2]|0;n=(m|0)==(g|0);if(!(n|(m&i|0)==(k|0))){e=0;o=23;break}if((n?(f[l+8>>2]|0)==(d|0):0)?(f[l+12>>2]|0)==(b|0):0){p=l;break a}l=f[l>>2]|0;if(!l){e=0;o=23;break}}if((o|0)==23)return e|0}else{l=a;while(1){n=f[l+4>>2]|0;if((n|0)==(g|0)){if((f[l+8>>2]|0)==(d|0)?(f[l+12>>2]|0)==(b|0):0){p=l;break a}}else{if(n>>>0<h>>>0)q=n;else q=(n>>>0)%(h>>>0)|0;if((q|0)!=(k|0)){e=0;o=23;break}}l=f[l>>2]|0;if(!l){e=0;o=23;break}}if((o|0)==23)return e|0}while(0);o=p+16|0;f[c>>2]=f[o>>2];f[c+4>>2]=f[o+4>>2];f[c+8>>2]=f[o+8>>2];f[c+12>>2]=f[o+12>>2];e=1;return e|0}function rQb(a,b){a=a|0;b=b|0;if(!b)return;else{rQb(a,f[b>>2]|0);rQb(a,f[b+4>>2]|0);O5b(b);return}}function sQb(a){a=a|0;f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=a+4;f[a+12>>2]=0;return}function tQb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;if(!(f[a+12>>2]|0)){b=f[a>>2]|0;c=a+4|0;if((b|0)==(c|0))d=c;else{e=b;while(1){uQb(e+24|0);b=f[e+4>>2]|0;if(!b){g=e+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(e|0))i=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;j=f[h>>2]|0}while((f[j>>2]|0)!=(g|0));i=j}}else{h=b;while(1){j=f[h>>2]|0;if(!j)break;else h=j}i=h}if((i|0)==(c|0)){d=c;break}else e=i}}}else d=a+4|0;rQb(a,f[d>>2]|0);return}function uQb(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=f[135848+(h[a+8>>0]<<2)>>2]|0;if(!(b[a+9>>0]|0))switch(c|0){case 9:{d=f[a>>2]|0;if(!d)return;if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d);return}case 10:{d=f[a>>2]|0;e=(d|0)==0;if(!(b[a+10>>0]&16)){if(e)return;bi[f[(f[d>>2]|0)+4>>2]&2047](d);return}else{if(e)return;bi[f[(f[d>>2]|0)+4>>2]&2047](d);return}break}default:return}do switch(c|0){case 1:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)O5b(e);O5b(d);return}case 2:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)O5b(e);O5b(d);return}case 3:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)O5b(e);O5b(d);return}case 4:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)O5b(e);O5b(d);return}case 6:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)O5b(e);O5b(d);return}case 5:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)O5b(e);O5b(d);return}case 7:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)O5b(e);O5b(d);return}case 8:{d=f[a>>2]|0;if(!d)return;e=f[d+8>>2]|0;if(e|0?(f[e>>2]|0)==0:0)O5b(e);O5b(d);return}case 9:{d=f[a>>2]|0;if(!d)return;e=d+12|0;g=f[e>>2]|0;if(g|0?(f[d>>2]|0)==0:0){i=f[g>>2]|0;if((i|0)>0){j=0;do{k=f[g+4+(j<<2)>>2]|0;if(k|0){if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);O5b(k)}j=j+1|0}while((j|0)!=(i|0));l=f[e>>2]|0}else l=g;O5b(l)}O5b(d);return}case 10:{i=f[a>>2]|0;if(!i)return;j=i+12|0;k=f[j>>2]|0;if(k|0?(f[i>>2]|0)==0:0){m=f[k>>2]|0;if((m|0)>0){n=0;do{o=f[k+4+(n<<2)>>2]|0;if(o|0)bi[f[(f[o>>2]|0)+4>>2]&2047](o);n=n+1|0}while((n|0)!=(m|0));p=f[j>>2]|0}else p=k;O5b(p)}O5b(i);return}default:return}while(0)}function vQb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+4|0;a=f[d>>2]|0;if(!a){e=0;return e|0}else{g=d;h=a}a:while(1){a=h;while(1){if((f[a+16>>2]|0)>=(c|0))break;i=f[a+4>>2]|0;if(!i){j=g;break a}else a=i}h=f[a>>2]|0;if(!h){j=a;break}else g=a}if((j|0)==(d|0)){e=0;return e|0}d=j+16|0;if((f[d>>2]|0)>(c|0)){e=0;return e|0}e=(b[d+18>>0]&1)==0;return e|0}function wQb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;a=f[c>>2]|0;if(!a){d=0;return d|0}else{e=c;g=a}a:while(1){a=g;while(1){if((f[a+16>>2]|0)>=(b|0))break;h=f[a+4>>2]|0;if(!h){i=e;break a}else a=h}g=f[a>>2]|0;if(!g){i=a;break}else e=a}if((i|0)==(c|0)){d=0;return d|0}if((f[i+16>>2]|0)>(b|0)){d=0;return d|0}d=xQb(i+24|0)|0;return d|0}function xQb(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+32|0;c=b;do switch(f[135848+((h[a+8>>0]|0)<<2)>>2]|0){case 1:{d=f[f[a>>2]>>2]|0;break}case 2:{d=f[f[a>>2]>>2]|0;break}case 3:{d=f[f[a>>2]>>2]|0;break}case 4:{d=f[f[a>>2]>>2]|0;break}case 6:{d=f[f[a>>2]>>2]|0;break}case 5:{d=f[f[a>>2]>>2]|0;break}case 7:{d=f[f[a>>2]>>2]|0;break}case 8:{d=f[f[a>>2]>>2]|0;break}case 9:{d=f[(f[a>>2]|0)+4>>2]|0;break}case 10:{d=f[(f[a>>2]|0)+4>>2]|0;break}default:{zpb(c,3,477758,1703);xpb(b+24|0,vpb(c,477853)|0);Apb(c);d=0}}while(0);u=b;return d|0}function yQb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;a=f[c>>2]|0;if(!a)return;else{d=c;e=a}a:while(1){a=e;while(1){if((f[a+16>>2]|0)>=(b|0))break;g=f[a+4>>2]|0;if(!g){h=d;break a}else a=g}e=f[a>>2]|0;if(!e){h=a;break}else d=a}if((h|0)==(c|0))return;if((f[h+16>>2]|0)>(b|0))return;zQb(h+24|0);return}function zQb(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0;if(!(b[a+9>>0]|0)){c=a+10|0;d=b[c>>0]|0;if(d&1)return;a:do switch(f[135848+(h[a+8>>0]<<2)>>2]|0){case 9:{e=f[a>>2]|0;g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break a}else{b[e>>0]=0;b[g>>0]=0;break a}break}case 10:{g=f[a>>2]|0;e=f[g>>2]|0;if(!(d&16)){bi[f[e+28>>2]&2047](g);break a}else{bi[f[e+52>>2]&2047](g);break a}break}default:{}}while(0);b[c>>0]=b[c>>0]&-16|1;return}do switch(f[135848+(h[a+8>>0]<<2)>>2]|0){case 1:{f[f[a>>2]>>2]=0;return}case 2:{f[f[a>>2]>>2]=0;return}case 3:{f[f[a>>2]>>2]=0;return}case 4:{f[f[a>>2]>>2]=0;return}case 6:{f[f[a>>2]>>2]=0;return}case 5:{f[f[a>>2]>>2]=0;return}case 7:{f[f[a>>2]>>2]=0;return}case 8:{f[f[a>>2]>>2]=0;return}case 9:{c=f[a>>2]|0;d=c+4|0;g=f[d>>2]|0;if((g|0)<=0)return;e=f[c+12>>2]|0;c=0;do{i=f[e+4+(c<<2)>>2]|0;c=c+1|0;j=i+11|0;if((b[j>>0]|0)<0){b[f[i>>2]>>0]=0;f[i+4>>2]=0}else{b[i>>0]=0;b[j>>0]=0}}while((c|0)!=(g|0));f[d>>2]=0;return}case 10:{g=f[a>>2]|0;c=g+4|0;e=f[c>>2]|0;if((e|0)<=0)return;j=f[g+12>>2]|0;g=0;do{i=f[j+4+(g<<2)>>2]|0;g=g+1|0;bi[f[(f[i>>2]|0)+28>>2]&2047](i)}while((g|0)!=(e|0));f[c>>2]=0;return}default:return}while(0)}function AQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=f[k+24>>2]|0;return g|0}function BQb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=s;v=m;break}else if((p|0)==10){t=l;v=m;break}}else{t=j;v=j}while(0);j=f[t>>2]|0;if(j|0){f[j+40>>2]=g;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}j=L5b(48)|0;f[j+16>>2]=c;c=j+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=v;f[t>>2]=j;v=f[f[a>>2]>>2]|0;if(!v)A=j;else{f[a>>2]=v;A=f[t>>2]|0}mP(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}function CQb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+32|0;g=e;h=g+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;h=a+4|0;i=f[h>>2]|0;do if(i){j=a+4|0;k=i;while(1){l=f[k+16>>2]|0;if((l|0)>(b|0)){m=f[k>>2]|0;if(!m){n=5;break}else{o=k;p=m}}else{if((l|0)>=(b|0)){n=10;break}q=k+4|0;l=f[q>>2]|0;if(!l){n=9;break}else{o=q;p=l}}j=o;k=p}if((n|0)==5){r=k;s=k;break}else if((n|0)==9){r=q;s=k;break}else if((n|0)==10){r=j;s=k;break}}else{r=h;s=h}while(0);h=f[r>>2]|0;if(h|0){t=h;v=0;w=t+24|0;f[d>>2]=w;x=t+40|0;f[x>>2]=c;u=e;return v|0}h=L5b(48)|0;f[h+16>>2]=b;b=h+20|0;f[b>>2]=f[g>>2];f[b+4>>2]=f[g+4>>2];f[b+8>>2]=f[g+8>>2];f[b+12>>2]=f[g+12>>2];f[b+16>>2]=f[g+16>>2];f[b+20>>2]=f[g+20>>2];f[b+24>>2]=f[g+24>>2];f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=s;f[r>>2]=h;s=f[f[a>>2]>>2]|0;if(!s)y=h;else{f[a>>2]=s;y=f[r>>2]|0}mP(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;t=h;v=1;w=t+24|0;f[d>>2]=w;x=t+40|0;f[x>>2]=c;u=e;return v|0}function DQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){zpb(e,3,477758,326);xpb(g,vpb(vpb(e,477869)|0,477911)|0);Apb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+8>>2]|0)+4+(c<<2)>>2]|0}function EQb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){n=m;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}}zpb(g,3,477758,326);xpb(h,vpb(vpb(g,477869)|0,477911)|0);Apb(g);n=i;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}function FQb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i;k=i+4|0;l=k+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;l=a+4|0;m=f[l>>2]|0;do if(m){n=a+4|0;o=m;while(1){p=f[o+16>>2]|0;if((p|0)>(c|0)){q=f[o>>2]|0;if(!q){r=5;break}else{s=o;t=q}}else{if((p|0)>=(c|0)){r=10;break}v=o+4|0;p=f[v>>2]|0;if(!p){r=9;break}else{s=v;t=p}}n=s;o=t}if((r|0)==5){w=o;x=o;break}else if((r|0)==9){w=v;x=o;break}else if((r|0)==10){w=n;x=o;break}}else{w=l;x=l}while(0);l=f[w>>2]|0;if(!l){r=L5b(48)|0;f[r+16>>2]=c;c=r+20|0;f[c>>2]=f[k>>2];f[c+4>>2]=f[k+4>>2];f[c+8>>2]=f[k+8>>2];f[c+12>>2]=f[k+12>>2];f[c+16>>2]=f[k+16>>2];f[c+20>>2]=f[k+20>>2];f[c+24>>2]=f[k+24>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=x;f[w>>2]=r;x=f[f[a>>2]>>2]|0;if(!x)y=r;else{f[a>>2]=x;y=f[w>>2]|0}mP(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;y=r+24|0;f[r+40>>2]=h;b[r+32>>0]=d;b[r+33>>0]=1;b[r+35>>0]=e&1;e=f[a+12>>2]|0;if(e){f[j>>2]=0;a=GQb(j)|0;j=znb(e,23736,12)|0;f[j>>2]=0;f[j+4>>2]=0;r=j+8|0;f[r>>2]=0;d=znb(e,25528,4)|0;f[r>>2]=d;f[d>>2]=e;if(a)z=j;else{xnb(e,j,1531);z=j}}else{j=L5b(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;z=j}f[y>>2]=z;A=y}else{f[l+40>>2]=h;A=l+24|0}l=f[A>>2]|0;A=f[l>>2]|0;if((A|0)!=(f[l+4>>2]|0)){B=A;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+4+(B<<2)|0;f[F>>2]=g;u=i;return}nza(l,A+1|0);B=f[l>>2]|0;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+4+(B<<2)|0;f[F>>2]=g;u=i;return}function GQb(a){a=a|0;return 0}function HQb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;O5b(b);return}function IQb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=a+4|0;a=f[g>>2]|0;if(a){h=g;i=a;a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if(((k|0)!=(g|0)?(g=k+16|0,(f[g>>2]|0)<=(c|0)):0)?(b[g+18>>0]&1)==0:0){g=k+24|0;l=f[g+4>>2]|0;m=f[g>>2]|0}else{l=e;m=d}}else{l=e;m=d}J=l;return m|0}function JQb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i;k=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=t;w=n;break}else if((q|0)==10){v=m;w=n;break}}else{v=k;w=k}while(0);k=f[v>>2]|0;if(k|0){f[k+40>>2]=h;x=k+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;B=x;C=B;f[C>>2]=e;D=B+4|0;E=D;f[E>>2]=g;u=i;return}k=L5b(48)|0;f[k+16>>2]=c;c=k+20|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=w;f[v>>2]=k;w=f[f[a>>2]>>2]|0;if(!w)F=k;else{f[a>>2]=w;F=f[v>>2]|0}mP(f[a+4>>2]|0,F);F=a+8|0;f[F>>2]=(f[F>>2]|0)+1;f[k+40>>2]=h;b[k+32>>0]=d;b[k+33>>0]=0;x=k+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;B=x;C=B;f[C>>2]=e;D=B+4|0;E=D;f[E>>2]=g;u=i;return}function KQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){zpb(e,3,477758,327);xpb(g,vpb(vpb(e,477869)|0,477911)|0);Apb(e);m=h}h=(f[(f[m+24>>2]|0)+8>>2]|0)+8+(c<<3)|0;J=f[h+4>>2]|0;u=d;return f[h>>2]|0}function LQb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+32|0;h=g;i=g+24|0;j=a+4|0;a=f[j>>2]|0;if(a){k=j;l=a;a:while(1){a=l;while(1){if((f[a+16>>2]|0)>=(b|0))break;m=f[a+4>>2]|0;if(!m){n=k;break a}else a=m}l=f[a>>2]|0;if(!l){n=a;break}else k=a}if((n|0)!=(j|0)?(f[n+16>>2]|0)<=(b|0):0)o=n;else p=8}else p=8;if((p|0)==8){zpb(h,3,477758,327);xpb(i,vpb(vpb(h,477869)|0,477911)|0);Apb(h);o=j}j=(f[(f[o+24>>2]|0)+8>>2]|0)+8+(c<<3)|0;f[j>>2]=d;f[j+4>>2]=e;u=g;return}function MQb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;j=u;u=u+32|0;k=j;l=j+4|0;m=l+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;m=a+4|0;n=f[m>>2]|0;do if(n){o=a+4|0;p=n;while(1){q=f[p+16>>2]|0;if((q|0)>(c|0)){r=f[p>>2]|0;if(!r){s=5;break}else{t=p;v=r}}else{if((q|0)>=(c|0)){s=10;break}w=p+4|0;q=f[w>>2]|0;if(!q){s=9;break}else{t=w;v=q}}o=t;p=v}if((s|0)==5){x=p;y=p;break}else if((s|0)==9){x=w;y=p;break}else if((s|0)==10){x=o;y=p;break}}else{x=m;y=m}while(0);m=f[x>>2]|0;if(!m){s=L5b(48)|0;f[s+16>>2]=c;c=s+20|0;f[c>>2]=f[l>>2];f[c+4>>2]=f[l+4>>2];f[c+8>>2]=f[l+8>>2];f[c+12>>2]=f[l+12>>2];f[c+16>>2]=f[l+16>>2];f[c+20>>2]=f[l+20>>2];f[c+24>>2]=f[l+24>>2];f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=y;f[x>>2]=s;y=f[f[a>>2]>>2]|0;if(!y)z=s;else{f[a>>2]=y;z=f[x>>2]|0}mP(f[a+4>>2]|0,z);z=a+8|0;f[z>>2]=(f[z>>2]|0)+1;z=s+24|0;f[s+40>>2]=i;b[s+32>>0]=d;b[s+33>>0]=1;b[s+35>>0]=e&1;e=f[a+12>>2]|0;if(e){f[k>>2]=0;a=NQb(k)|0;k=znb(e,23744,12)|0;f[k>>2]=0;f[k+4>>2]=0;s=k+8|0;f[s>>2]=0;d=znb(e,25528,8)|0;f[s>>2]=d;f[d>>2]=e;if(a)A=k;else{xnb(e,k,1532);A=k}}else{k=L5b(12)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;A=k}f[z>>2]=A;B=z}else{f[m+40>>2]=i;B=m+24|0}m=f[B>>2]|0;B=f[m>>2]|0;if((B|0)!=(f[m+4>>2]|0)){C=B;D=m+8|0;E=f[D>>2]|0;F=C+1|0;f[m>>2]=F;G=E+8+(C<<3)|0;H=G;I=H;f[I>>2]=g;J=H+4|0;K=J;f[K>>2]=h;u=j;return}uFa(m,B+1|0);C=f[m>>2]|0;D=m+8|0;E=f[D>>2]|0;F=C+1|0;f[m>>2]=F;G=E+8+(C<<3)|0;H=G;I=H;f[I>>2]=g;J=H+4|0;K=J;f[K>>2]=h;u=j;return}function NQb(a){a=a|0;return 0}function OQb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;O5b(b);return}function PQb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=f[k+24>>2]|0;return g|0}function QQb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=s;v=m;break}else if((p|0)==10){t=l;v=m;break}}else{t=j;v=j}while(0);j=f[t>>2]|0;if(j|0){f[j+40>>2]=g;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}j=L5b(48)|0;f[j+16>>2]=c;c=j+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=v;f[t>>2]=j;v=f[f[a>>2]>>2]|0;if(!v)A=j;else{f[a>>2]=v;A=f[t>>2]|0}mP(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}function RQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){zpb(e,3,477758,328);xpb(g,vpb(vpb(e,477869)|0,477911)|0);Apb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+8>>2]|0)+4+(c<<2)>>2]|0}function SQb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){n=m;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}}zpb(g,3,477758,328);xpb(h,vpb(vpb(g,477869)|0,477911)|0);Apb(g);n=i;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}function TQb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i;k=i+4|0;l=k+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;l=a+4|0;m=f[l>>2]|0;do if(m){n=a+4|0;o=m;while(1){p=f[o+16>>2]|0;if((p|0)>(c|0)){q=f[o>>2]|0;if(!q){r=5;break}else{s=o;t=q}}else{if((p|0)>=(c|0)){r=10;break}v=o+4|0;p=f[v>>2]|0;if(!p){r=9;break}else{s=v;t=p}}n=s;o=t}if((r|0)==5){w=o;x=o;break}else if((r|0)==9){w=v;x=o;break}else if((r|0)==10){w=n;x=o;break}}else{w=l;x=l}while(0);l=f[w>>2]|0;if(!l){r=L5b(48)|0;f[r+16>>2]=c;c=r+20|0;f[c>>2]=f[k>>2];f[c+4>>2]=f[k+4>>2];f[c+8>>2]=f[k+8>>2];f[c+12>>2]=f[k+12>>2];f[c+16>>2]=f[k+16>>2];f[c+20>>2]=f[k+20>>2];f[c+24>>2]=f[k+24>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=x;f[w>>2]=r;x=f[f[a>>2]>>2]|0;if(!x)y=r;else{f[a>>2]=x;y=f[w>>2]|0}mP(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;y=r+24|0;f[r+40>>2]=h;b[r+32>>0]=d;b[r+33>>0]=1;b[r+35>>0]=e&1;e=f[a+12>>2]|0;if(e){f[j>>2]=0;a=UQb(j)|0;j=znb(e,23752,12)|0;f[j>>2]=0;f[j+4>>2]=0;r=j+8|0;f[r>>2]=0;d=znb(e,25528,4)|0;f[r>>2]=d;f[d>>2]=e;if(a)z=j;else{xnb(e,j,1533);z=j}}else{j=L5b(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;z=j}f[y>>2]=z;A=y}else{f[l+40>>2]=h;A=l+24|0}l=f[A>>2]|0;A=f[l>>2]|0;if((A|0)!=(f[l+4>>2]|0)){B=A;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+4+(B<<2)|0;f[F>>2]=g;u=i;return}rza(l,A+1|0);B=f[l>>2]|0;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+4+(B<<2)|0;f[F>>2]=g;u=i;return}function UQb(a){a=a|0;return 0}function VQb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;O5b(b);return}function WQb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=a+4|0;a=f[g>>2]|0;if(a){h=g;i=a;a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if(((k|0)!=(g|0)?(g=k+16|0,(f[g>>2]|0)<=(c|0)):0)?(b[g+18>>0]&1)==0:0){g=k+24|0;l=f[g+4>>2]|0;m=f[g>>2]|0}else{l=e;m=d}}else{l=e;m=d}J=l;return m|0}function XQb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i;k=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=t;w=n;break}else if((q|0)==10){v=m;w=n;break}}else{v=k;w=k}while(0);k=f[v>>2]|0;if(k|0){f[k+40>>2]=h;x=k+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;B=x;C=B;f[C>>2]=e;D=B+4|0;E=D;f[E>>2]=g;u=i;return}k=L5b(48)|0;f[k+16>>2]=c;c=k+20|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=w;f[v>>2]=k;w=f[f[a>>2]>>2]|0;if(!w)F=k;else{f[a>>2]=w;F=f[v>>2]|0}mP(f[a+4>>2]|0,F);F=a+8|0;f[F>>2]=(f[F>>2]|0)+1;f[k+40>>2]=h;b[k+32>>0]=d;b[k+33>>0]=0;x=k+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;B=x;C=B;f[C>>2]=e;D=B+4|0;E=D;f[E>>2]=g;u=i;return}function YQb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){zpb(e,3,477758,329);xpb(g,vpb(vpb(e,477869)|0,477911)|0);Apb(e);m=h}h=(f[(f[m+24>>2]|0)+8>>2]|0)+8+(c<<3)|0;J=f[h+4>>2]|0;u=d;return f[h>>2]|0}function ZQb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+32|0;h=g;i=g+24|0;j=a+4|0;a=f[j>>2]|0;if(a){k=j;l=a;a:while(1){a=l;while(1){if((f[a+16>>2]|0)>=(b|0))break;m=f[a+4>>2]|0;if(!m){n=k;break a}else a=m}l=f[a>>2]|0;if(!l){n=a;break}else k=a}if((n|0)!=(j|0)?(f[n+16>>2]|0)<=(b|0):0)o=n;else p=8}else p=8;if((p|0)==8){zpb(h,3,477758,329);xpb(i,vpb(vpb(h,477869)|0,477911)|0);Apb(h);o=j}j=(f[(f[o+24>>2]|0)+8>>2]|0)+8+(c<<3)|0;f[j>>2]=d;f[j+4>>2]=e;u=g;return}function _Qb(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;j=u;u=u+32|0;k=j;l=j+4|0;m=l+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;m=a+4|0;n=f[m>>2]|0;do if(n){o=a+4|0;p=n;while(1){q=f[p+16>>2]|0;if((q|0)>(c|0)){r=f[p>>2]|0;if(!r){s=5;break}else{t=p;v=r}}else{if((q|0)>=(c|0)){s=10;break}w=p+4|0;q=f[w>>2]|0;if(!q){s=9;break}else{t=w;v=q}}o=t;p=v}if((s|0)==5){x=p;y=p;break}else if((s|0)==9){x=w;y=p;break}else if((s|0)==10){x=o;y=p;break}}else{x=m;y=m}while(0);m=f[x>>2]|0;if(!m){s=L5b(48)|0;f[s+16>>2]=c;c=s+20|0;f[c>>2]=f[l>>2];f[c+4>>2]=f[l+4>>2];f[c+8>>2]=f[l+8>>2];f[c+12>>2]=f[l+12>>2];f[c+16>>2]=f[l+16>>2];f[c+20>>2]=f[l+20>>2];f[c+24>>2]=f[l+24>>2];f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=y;f[x>>2]=s;y=f[f[a>>2]>>2]|0;if(!y)z=s;else{f[a>>2]=y;z=f[x>>2]|0}mP(f[a+4>>2]|0,z);z=a+8|0;f[z>>2]=(f[z>>2]|0)+1;z=s+24|0;f[s+40>>2]=i;b[s+32>>0]=d;b[s+33>>0]=1;b[s+35>>0]=e&1;e=f[a+12>>2]|0;if(e){f[k>>2]=0;a=$Qb(k)|0;k=znb(e,23760,12)|0;f[k>>2]=0;f[k+4>>2]=0;s=k+8|0;f[s>>2]=0;d=znb(e,25528,8)|0;f[s>>2]=d;f[d>>2]=e;if(a)A=k;else{xnb(e,k,1534);A=k}}else{k=L5b(12)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;A=k}f[z>>2]=A;B=z}else{f[m+40>>2]=i;B=m+24|0}m=f[B>>2]|0;B=f[m>>2]|0;if((B|0)!=(f[m+4>>2]|0)){C=B;D=m+8|0;E=f[D>>2]|0;F=C+1|0;f[m>>2]=F;G=E+8+(C<<3)|0;H=G;I=H;f[I>>2]=g;J=H+4|0;K=J;f[K>>2]=h;u=j;return}AHb(m,B+1|0);C=f[m>>2]|0;D=m+8|0;E=f[D>>2]|0;F=C+1|0;f[m>>2]=F;G=E+8+(C<<3)|0;H=G;I=H;f[I>>2]=g;J=H+4|0;K=J;f[K>>2]=h;u=j;return}function $Qb(a){a=a|0;return 0}function aRb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;O5b(b);return}function bRb(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0.0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return +g}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return +g}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return +g}if(b[e+18>>0]&1){g=d;return +g}g=+n[k+24>>2];return +g}function cRb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){o=f[m+16>>2]|0;if((o|0)>(c|0)){p=f[m>>2]|0;if(!p){q=5;break}else{r=m;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=m+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}l=r;m=s}if((q|0)==5){v=m;w=m;break}else if((q|0)==9){v=t;w=m;break}else if((q|0)==10){v=l;w=m;break}}else{v=j;w=j}while(0);j=f[v>>2]|0;if(j|0){f[j+40>>2]=g;x=j+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;n[x>>2]=e;u=h;return}j=L5b(48)|0;f[j+16>>2]=c;c=j+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=w;f[v>>2]=j;w=f[f[a>>2]>>2]|0;if(!w)B=j;else{f[a>>2]=w;B=f[v>>2]|0}mP(f[a+4>>2]|0,B);B=a+8|0;f[B>>2]=(f[B>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;x=j+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;n[x>>2]=e;u=h;return}function dRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else o=8}else o=8;if((o|0)==8){zpb(e,3,477758,330);xpb(g,vpb(vpb(e,477869)|0,477911)|0);Apb(e);m=h}u=d;return +(+n[(f[(f[m+24>>2]|0)+8>>2]|0)+4+(c<<2)>>2])}function eRb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){o=m;p=o+24|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+4+(c<<2)|0;n[t>>2]=d;u=e;return}}zpb(g,3,477758,330);xpb(h,vpb(vpb(g,477869)|0,477911)|0);Apb(g);o=i;p=o+24|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+4+(c<<2)|0;n[t>>2]=d;u=e;return}function fRb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;i=u;u=u+32|0;j=i;k=i+4|0;l=k+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;l=a+4|0;m=f[l>>2]|0;do if(m){o=a+4|0;p=m;while(1){q=f[p+16>>2]|0;if((q|0)>(c|0)){r=f[p>>2]|0;if(!r){s=5;break}else{t=p;v=r}}else{if((q|0)>=(c|0)){s=10;break}w=p+4|0;q=f[w>>2]|0;if(!q){s=9;break}else{t=w;v=q}}o=t;p=v}if((s|0)==5){x=p;y=p;break}else if((s|0)==9){x=w;y=p;break}else if((s|0)==10){x=o;y=p;break}}else{x=l;y=l}while(0);l=f[x>>2]|0;if(!l){s=L5b(48)|0;f[s+16>>2]=c;c=s+20|0;f[c>>2]=f[k>>2];f[c+4>>2]=f[k+4>>2];f[c+8>>2]=f[k+8>>2];f[c+12>>2]=f[k+12>>2];f[c+16>>2]=f[k+16>>2];f[c+20>>2]=f[k+20>>2];f[c+24>>2]=f[k+24>>2];f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=y;f[x>>2]=s;y=f[f[a>>2]>>2]|0;if(!y)z=s;else{f[a>>2]=y;z=f[x>>2]|0}mP(f[a+4>>2]|0,z);z=a+8|0;f[z>>2]=(f[z>>2]|0)+1;z=s+24|0;f[s+40>>2]=h;b[s+32>>0]=d;b[s+33>>0]=1;b[s+35>>0]=e&1;e=f[a+12>>2]|0;if(e){f[j>>2]=0;a=gRb(j)|0;j=znb(e,23768,12)|0;f[j>>2]=0;f[j+4>>2]=0;s=j+8|0;f[s>>2]=0;d=znb(e,25528,4)|0;f[s>>2]=d;f[d>>2]=e;if(a)A=j;else{xnb(e,j,1535);A=j}}else{j=L5b(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;A=j}f[z>>2]=A;B=z}else{f[l+40>>2]=h;B=l+24|0}l=f[B>>2]|0;B=f[l>>2]|0;if((B|0)!=(f[l+4>>2]|0)){C=B;D=l+8|0;E=f[D>>2]|0;F=C+1|0;f[l>>2]=F;G=E+4+(C<<2)|0;n[G>>2]=g;u=i;return}qza(l,B+1|0);C=f[l>>2]|0;D=l+8|0;E=f[D>>2]|0;F=C+1|0;f[l>>2]=F;G=E+4+(C<<2)|0;n[G>>2]=g;u=i;return}function gRb(a){a=a|0;return 0}function hRb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;O5b(b);return}function iRb(a,c,d){a=a|0;c=c|0;d=+d;var e=0,g=0.0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return +g}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return +g}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return +g}if(b[e+18>>0]&1){g=d;return +g}g=+p[k+24>>3];return +g}function jRb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){q=5;break}else{r=m;s=o}}else{if((n|0)>=(c|0)){q=10;break}t=m+4|0;n=f[t>>2]|0;if(!n){q=9;break}else{r=t;s=n}}l=r;m=s}if((q|0)==5){v=m;w=m;break}else if((q|0)==9){v=t;w=m;break}else if((q|0)==10){v=l;w=m;break}}else{v=j;w=j}while(0);j=f[v>>2]|0;if(j|0){f[j+40>>2]=g;x=j+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;p[x>>3]=e;u=h;return}j=L5b(48)|0;f[j+16>>2]=c;c=j+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=w;f[v>>2]=j;w=f[f[a>>2]>>2]|0;if(!w)B=j;else{f[a>>2]=w;B=f[v>>2]|0}mP(f[a+4>>2]|0,B);B=a+8|0;f[B>>2]=(f[B>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;x=j+24|0;y=x+10|0;z=b[y>>0]|0;A=z&-16;b[y>>0]=A;p[x>>3]=e;u=h;return}function kRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){zpb(e,3,477758,331);xpb(g,vpb(vpb(e,477869)|0,477911)|0);Apb(e);m=h}u=d;return +(+p[(f[(f[m+24>>2]|0)+8>>2]|0)+8+(c<<3)>>3])}function lRb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){n=m;o=n+24|0;q=f[o>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+8+(c<<3)|0;p[t>>3]=d;u=e;return}}zpb(g,3,477758,331);xpb(h,vpb(vpb(g,477869)|0,477911)|0);Apb(g);n=i;o=n+24|0;q=f[o>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+8+(c<<3)|0;p[t>>3]=d;u=e;return}function mRb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;i=u;u=u+32|0;j=i;k=i+4|0;l=k+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;l=a+4|0;m=f[l>>2]|0;do if(m){n=a+4|0;o=m;while(1){q=f[o+16>>2]|0;if((q|0)>(c|0)){r=f[o>>2]|0;if(!r){s=5;break}else{t=o;v=r}}else{if((q|0)>=(c|0)){s=10;break}w=o+4|0;q=f[w>>2]|0;if(!q){s=9;break}else{t=w;v=q}}n=t;o=v}if((s|0)==5){x=o;y=o;break}else if((s|0)==9){x=w;y=o;break}else if((s|0)==10){x=n;y=o;break}}else{x=l;y=l}while(0);l=f[x>>2]|0;if(!l){s=L5b(48)|0;f[s+16>>2]=c;c=s+20|0;f[c>>2]=f[k>>2];f[c+4>>2]=f[k+4>>2];f[c+8>>2]=f[k+8>>2];f[c+12>>2]=f[k+12>>2];f[c+16>>2]=f[k+16>>2];f[c+20>>2]=f[k+20>>2];f[c+24>>2]=f[k+24>>2];f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=y;f[x>>2]=s;y=f[f[a>>2]>>2]|0;if(!y)z=s;else{f[a>>2]=y;z=f[x>>2]|0}mP(f[a+4>>2]|0,z);z=a+8|0;f[z>>2]=(f[z>>2]|0)+1;z=s+24|0;f[s+40>>2]=h;b[s+32>>0]=d;b[s+33>>0]=1;b[s+35>>0]=e&1;e=f[a+12>>2]|0;if(e){f[j>>2]=0;a=nRb(j)|0;j=znb(e,23776,12)|0;f[j>>2]=0;f[j+4>>2]=0;s=j+8|0;f[s>>2]=0;d=znb(e,25528,8)|0;f[s>>2]=d;f[d>>2]=e;if(a)A=j;else{xnb(e,j,1536);A=j}}else{j=L5b(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;A=j}f[z>>2]=A;B=z}else{f[l+40>>2]=h;B=l+24|0}l=f[B>>2]|0;B=f[l>>2]|0;if((B|0)!=(f[l+4>>2]|0)){C=B;D=l+8|0;E=f[D>>2]|0;F=C+1|0;f[l>>2]=F;G=E+8+(C<<3)|0;p[G>>3]=g;u=i;return}tFa(l,B+1|0);C=f[l>>2]|0;D=l+8|0;E=f[D>>2]|0;F=C+1|0;f[l>>2]=F;G=E+8+(C<<3)|0;p[G>>3]=g;u=i;return}function nRb(a){a=a|0;return 0}function oRb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;O5b(b);return}function pRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=(b[k+24>>0]|0)!=0;return g|0}function qRb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h;j=e&1;e=i+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;e=a+4|0;k=f[e>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=s;v=m;break}else if((p|0)==10){t=l;v=m;break}}else{t=e;v=e}while(0);e=f[t>>2]|0;if(e|0){f[e+40>>2]=g;w=e+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;b[w>>0]=j;u=h;return}e=L5b(48)|0;f[e+16>>2]=c;c=e+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=v;f[t>>2]=e;v=f[f[a>>2]>>2]|0;if(!v)A=e;else{f[a>>2]=v;A=f[t>>2]|0}mP(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[e+40>>2]=g;b[e+32>>0]=d;b[e+33>>0]=0;w=e+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;b[w>>0]=j;u=h;return}function rRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(c|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(c|0):0)n=m;else o=8}else o=8;if((o|0)==8){zpb(g,3,477758,332);xpb(h,vpb(vpb(g,477869)|0,477911)|0);Apb(g);n=i}u=e;return (b[(f[(f[n+24>>2]|0)+8>>2]|0)+4+d>>0]|0)!=0|0}function sRb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=u;u=u+32|0;h=g;i=g+24|0;j=e&1;e=a+4|0;a=f[e>>2]|0;if(a|0){k=e;l=a;a:while(1){a=l;while(1){if((f[a+16>>2]|0)>=(c|0))break;m=f[a+4>>2]|0;if(!m){n=k;break a}else a=m}l=f[a>>2]|0;if(!l){n=a;break}else k=a}if((n|0)!=(e|0)?(f[n+16>>2]|0)<=(c|0):0){o=n;p=o+24|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+4+d|0;b[t>>0]=j;u=g;return}}zpb(h,3,477758,332);xpb(i,vpb(vpb(h,477869)|0,477911)|0);Apb(h);o=e;p=o+24|0;q=f[p>>2]|0;r=q+8|0;s=f[r>>2]|0;t=s+4+d|0;b[t>>0]=j;u=g;return}function tRb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i;k=i+4|0;l=g&1;g=k+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;g=a+4|0;m=f[g>>2]|0;do if(m){n=a+4|0;o=m;while(1){p=f[o+16>>2]|0;if((p|0)>(c|0)){q=f[o>>2]|0;if(!q){r=5;break}else{s=o;t=q}}else{if((p|0)>=(c|0)){r=10;break}v=o+4|0;p=f[v>>2]|0;if(!p){r=9;break}else{s=v;t=p}}n=s;o=t}if((r|0)==5){w=o;x=o;break}else if((r|0)==9){w=v;x=o;break}else if((r|0)==10){w=n;x=o;break}}else{w=g;x=g}while(0);g=f[w>>2]|0;if(!g){r=L5b(48)|0;f[r+16>>2]=c;c=r+20|0;f[c>>2]=f[k>>2];f[c+4>>2]=f[k+4>>2];f[c+8>>2]=f[k+8>>2];f[c+12>>2]=f[k+12>>2];f[c+16>>2]=f[k+16>>2];f[c+20>>2]=f[k+20>>2];f[c+24>>2]=f[k+24>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=x;f[w>>2]=r;x=f[f[a>>2]>>2]|0;if(!x)y=r;else{f[a>>2]=x;y=f[w>>2]|0}mP(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;y=r+24|0;f[r+40>>2]=h;b[r+32>>0]=d;b[r+33>>0]=1;b[r+35>>0]=e&1;e=f[a+12>>2]|0;if(e){f[j>>2]=0;a=uRb(j)|0;j=znb(e,23784,12)|0;f[j>>2]=0;f[j+4>>2]=0;r=j+8|0;f[r>>2]=0;d=znb(e,25528,4)|0;f[r>>2]=d;f[d>>2]=e;if(a)z=j;else{xnb(e,j,1537);z=j}}else{j=L5b(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;z=j}f[y>>2]=z;A=y}else{f[g+40>>2]=h;A=g+24|0}g=f[A>>2]|0;A=f[g>>2]|0;if((A|0)!=(f[g+4>>2]|0)){B=A;C=g+8|0;D=f[C>>2]|0;E=B+1|0;f[g>>2]=E;F=D+4+B|0;b[F>>0]=l;u=i;return}vFa(g,A+1|0);B=f[g>>2]|0;C=g+8|0;D=f[C>>2]|0;E=B+1|0;f[g>>2]=E;F=D+4+B|0;b[F>>0]=l;u=i;return}function uRb(a){a=a|0;return 0}function vRb(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(!b)return;if(f[b>>2]|0)return;O5b(b);return}function wRb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;h=u;u=u+112|0;i=h+72|0;j=h+64|0;k=h+56|0;l=h+48|0;m=h+40|0;n=h+32|0;o=h+24|0;p=h+16|0;q=h+8|0;r=h;s=h+76|0;t=s+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;t=a+4|0;v=f[t>>2]|0;do if(v){w=a+4|0;x=v;while(1){y=f[x+16>>2]|0;if((y|0)>(c|0)){z=f[x>>2]|0;if(!z){A=5;break}else{B=x;C=z}}else{if((y|0)>=(c|0)){A=10;break}D=x+4|0;y=f[D>>2]|0;if(!y){A=9;break}else{B=D;C=y}}w=B;x=C}if((A|0)==5){E=x;F=x;break}else if((A|0)==9){E=D;F=x;break}else if((A|0)==10){E=w;F=x;break}}else{E=t;F=t}while(0);t=f[E>>2]|0;if(t|0){f[t+40>>2]=g;G=t+24|0;H=f[G>>2]|0;u=h;return H|0}t=L5b(48)|0;f[t+16>>2]=c;c=t+20|0;f[c>>2]=f[s>>2];f[c+4>>2]=f[s+4>>2];f[c+8>>2]=f[s+8>>2];f[c+12>>2]=f[s+12>>2];f[c+16>>2]=f[s+16>>2];f[c+20>>2]=f[s+20>>2];f[c+24>>2]=f[s+24>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=F;f[E>>2]=t;F=f[f[a>>2]>>2]|0;if(!F)I=t;else{f[a>>2]=F;I=f[E>>2]|0}mP(f[a+4>>2]|0,I);I=a+8|0;f[I>>2]=(f[I>>2]|0)+1;I=t+24|0;f[t+40>>2]=g;b[t+33>>0]=1;b[t+32>>0]=d;b[t+35>>0]=e&1;do switch(f[135848+((d&255)<<2)>>2]|0){case 1:{e=f[a+12>>2]|0;if(e){f[r>>2]=0;t=GQb(r)|0;g=znb(e,23736,12)|0;f[g>>2]=0;f[g+4>>2]=0;E=g+8|0;f[E>>2]=0;F=znb(e,25528,4)|0;f[E>>2]=F;f[F>>2]=e;if(t)J=g;else{xnb(e,g,1531);J=g}}else{g=L5b(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;J=g}f[I>>2]=J;G=I;H=f[G>>2]|0;u=h;return H|0}case 2:{g=f[a+12>>2]|0;if(g){f[q>>2]=0;e=NQb(q)|0;t=znb(g,23744,12)|0;f[t>>2]=0;f[t+4>>2]=0;F=t+8|0;f[F>>2]=0;E=znb(g,25528,8)|0;f[F>>2]=E;f[E>>2]=g;if(e)K=t;else{xnb(g,t,1532);K=t}}else{t=L5b(12)|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;K=t}f[I>>2]=K;G=I;H=f[G>>2]|0;u=h;return H|0}case 3:{t=f[a+12>>2]|0;if(t){f[p>>2]=0;g=UQb(p)|0;e=znb(t,23752,12)|0;f[e>>2]=0;f[e+4>>2]=0;E=e+8|0;f[E>>2]=0;F=znb(t,25528,4)|0;f[E>>2]=F;f[F>>2]=t;if(g)L=e;else{xnb(t,e,1533);L=e}}else{e=L5b(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;L=e}f[I>>2]=L;G=I;H=f[G>>2]|0;u=h;return H|0}case 4:{e=f[a+12>>2]|0;if(e){f[o>>2]=0;t=$Qb(o)|0;g=znb(e,23760,12)|0;f[g>>2]=0;f[g+4>>2]=0;F=g+8|0;f[F>>2]=0;E=znb(e,25528,8)|0;f[F>>2]=E;f[E>>2]=e;if(t)M=g;else{xnb(e,g,1534);M=g}}else{g=L5b(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;M=g}f[I>>2]=M;G=I;H=f[G>>2]|0;u=h;return H|0}case 5:{g=f[a+12>>2]|0;if(g){f[n>>2]=0;e=nRb(n)|0;t=znb(g,23776,12)|0;f[t>>2]=0;f[t+4>>2]=0;E=t+8|0;f[E>>2]=0;F=znb(g,25528,8)|0;f[E>>2]=F;f[F>>2]=g;if(e)N=t;else{xnb(g,t,1536);N=t}}else{t=L5b(12)|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;N=t}f[I>>2]=N;G=I;H=f[G>>2]|0;u=h;return H|0}case 6:{t=f[a+12>>2]|0;if(t){f[m>>2]=0;g=gRb(m)|0;e=znb(t,23768,12)|0;f[e>>2]=0;f[e+4>>2]=0;F=e+8|0;f[F>>2]=0;E=znb(t,25528,4)|0;f[F>>2]=E;f[E>>2]=t;if(g)O=e;else{xnb(t,e,1535);O=e}}else{e=L5b(12)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;O=e}f[I>>2]=O;G=I;H=f[G>>2]|0;u=h;return H|0}case 7:{e=f[a+12>>2]|0;if(e){f[l>>2]=0;t=uRb(l)|0;g=znb(e,23784,12)|0;f[g>>2]=0;f[g+4>>2]=0;E=g+8|0;f[E>>2]=0;F=znb(e,25528,4)|0;f[E>>2]=F;f[F>>2]=e;if(t)P=g;else{xnb(e,g,1537);P=g}}else{g=L5b(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;P=g}f[I>>2]=P;G=I;H=f[G>>2]|0;u=h;return H|0}case 8:{g=f[a+12>>2]|0;if(g){f[k>>2]=0;e=GQb(k)|0;t=znb(g,23736,12)|0;f[t>>2]=0;f[t+4>>2]=0;F=t+8|0;f[F>>2]=0;E=znb(g,25528,4)|0;f[F>>2]=E;f[E>>2]=g;if(e)Q=t;else{xnb(g,t,1531);Q=t}}else{t=L5b(12)|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;Q=t}f[I>>2]=Q;G=I;H=f[G>>2]|0;u=h;return H|0}case 9:{t=f[a+12>>2]|0;if(t){f[j>>2]=0;g=xRb(j)|0;e=znb(t,23792,16)|0;f[e>>2]=t;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if(g)R=e;else{xnb(t,e,1538);R=e}}else{e=L5b(16)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;R=e}f[I>>2]=R;G=I;H=f[G>>2]|0;u=h;return H|0}case 10:{e=f[a+12>>2]|0;if(e){f[i>>2]=0;t=AFb(i)|0;g=znb(e,23120,16)|0;f[g>>2]=e;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if(t)S=g;else{xnb(e,g,1526);S=g}}else{g=L5b(16)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;S=g}f[I>>2]=S;G=I;H=f[G>>2]|0;u=h;return H|0}default:{G=I;H=f[G>>2]|0;u=h;return H|0}}while(0);return 0}function xRb(a){a=a|0;return 0}function yRb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+12|0;d=f[c>>2]|0;if(!d){f[c>>2]=0;return}if(f[a>>2]|0){f[c>>2]=0;return}a=f[d>>2]|0;if((a|0)>0){e=0;do{g=f[d+4+(e<<2)>>2]|0;if(g|0){if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);O5b(g)}e=e+1|0}while((e|0)!=(a|0));h=f[c>>2]|0}else h=d;O5b(h);f[c>>2]=0;return}function zRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=f[k+24>>2]|0;return g|0}function ARb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=s;v=m;break}else if((p|0)==10){t=l;v=m;break}}else{t=j;v=j}while(0);j=f[t>>2]|0;if(j|0){f[j+40>>2]=g;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}j=L5b(48)|0;f[j+16>>2]=c;c=j+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=v;f[t>>2]=j;v=f[f[a>>2]>>2]|0;if(!v)A=j;else{f[a>>2]=v;A=f[t>>2]|0}mP(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[j+40>>2]=g;b[j+32>>0]=d;b[j+33>>0]=0;w=j+24|0;x=w+10|0;y=b[x>>0]|0;z=y&-16;b[x>>0]=z;f[w>>2]=e;u=h;return}function BRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){zpb(e,3,477758,450);xpb(g,vpb(vpb(e,477869)|0,477911)|0);Apb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+8>>2]|0)+4+(c<<2)>>2]|0}function CRb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e;h=e+24|0;i=a+4|0;a=f[i>>2]|0;if(a|0){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(b|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(b|0):0){n=m;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}}zpb(g,3,477758,457);xpb(h,vpb(vpb(g,477869)|0,477911)|0);Apb(g);n=i;o=n+24|0;p=f[o>>2]|0;q=p+8|0;r=f[q>>2]|0;s=r+4+(c<<2)|0;f[s>>2]=d;u=e;return}function DRb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+32|0;j=i;k=i+4|0;l=k+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;l=a+4|0;m=f[l>>2]|0;do if(m){n=a+4|0;o=m;while(1){p=f[o+16>>2]|0;if((p|0)>(c|0)){q=f[o>>2]|0;if(!q){r=5;break}else{s=o;t=q}}else{if((p|0)>=(c|0)){r=10;break}v=o+4|0;p=f[v>>2]|0;if(!p){r=9;break}else{s=v;t=p}}n=s;o=t}if((r|0)==5){w=o;x=o;break}else if((r|0)==9){w=v;x=o;break}else if((r|0)==10){w=n;x=o;break}}else{w=l;x=l}while(0);l=f[w>>2]|0;if(!l){r=L5b(48)|0;f[r+16>>2]=c;c=r+20|0;f[c>>2]=f[k>>2];f[c+4>>2]=f[k+4>>2];f[c+8>>2]=f[k+8>>2];f[c+12>>2]=f[k+12>>2];f[c+16>>2]=f[k+16>>2];f[c+20>>2]=f[k+20>>2];f[c+24>>2]=f[k+24>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=x;f[w>>2]=r;x=f[f[a>>2]>>2]|0;if(!x)y=r;else{f[a>>2]=x;y=f[w>>2]|0}mP(f[a+4>>2]|0,y);y=a+8|0;f[y>>2]=(f[y>>2]|0)+1;y=r+24|0;f[r+40>>2]=h;b[r+32>>0]=d;b[r+33>>0]=1;b[r+35>>0]=e&1;e=f[a+12>>2]|0;if(e){f[j>>2]=0;a=GQb(j)|0;j=znb(e,23736,12)|0;f[j>>2]=0;f[j+4>>2]=0;r=j+8|0;f[r>>2]=0;d=znb(e,25528,4)|0;f[r>>2]=d;f[d>>2]=e;if(a)z=j;else{xnb(e,j,1531);z=j}}else{j=L5b(12)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;z=j}f[y>>2]=z;A=y}else{f[l+40>>2]=h;A=l+24|0}l=f[A>>2]|0;A=f[l>>2]|0;if((A|0)!=(f[l+4>>2]|0)){B=A;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+4+(B<<2)|0;f[F>>2]=g;u=i;return}nza(l,A+1|0);B=f[l>>2]|0;C=l+8|0;D=f[C>>2]|0;E=B+1|0;f[l>>2]=E;F=D+4+(B<<2)|0;f[F>>2]=g;u=i;return}function ERb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0;e=a+4|0;a=f[e>>2]|0;if(!a){g=d;return g|0}else{h=e;i=a}a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)==(e|0)){g=d;return g|0}e=k+16|0;if((f[e>>2]|0)>(c|0)){g=d;return g|0}if(b[e+18>>0]&1){g=d;return g|0}g=f[k+24>>2]|0;return g|0}function FRb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=u;u=u+32|0;h=g;i=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=a+4|0;j=f[i>>2]|0;do if(j){k=a+4|0;l=j;while(1){m=f[l+16>>2]|0;if((m|0)>(c|0)){n=f[l>>2]|0;if(!n){o=5;break}else{p=l;q=n}}else{if((m|0)>=(c|0)){o=10;break}r=l+4|0;m=f[r>>2]|0;if(!m){o=9;break}else{p=r;q=m}}k=p;l=q}if((o|0)==5){s=l;t=l;break}else if((o|0)==9){s=r;t=l;break}else if((o|0)==10){s=k;t=l;break}}else{s=i;t=i}while(0);i=f[s>>2]|0;if(i|0){f[i+40>>2]=e;v=i+24|0;w=v+10|0;x=b[w>>0]|0;y=x&-16;b[w>>0]=y;z=f[v>>2]|0;u=g;return z|0}i=L5b(48)|0;f[i+16>>2]=c;c=i+20|0;f[c>>2]=f[h>>2];f[c+4>>2]=f[h+4>>2];f[c+8>>2]=f[h+8>>2];f[c+12>>2]=f[h+12>>2];f[c+16>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];f[c+24>>2]=f[h+24>>2];f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=t;f[s>>2]=i;t=f[f[a>>2]>>2]|0;if(!t)A=i;else{f[a>>2]=t;A=f[s>>2]|0}mP(f[a+4>>2]|0,A);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;A=i+24|0;f[i+40>>2]=e;b[i+32>>0]=d;b[i+33>>0]=0;i=f[a+12>>2]|0;if(!i){a=L5b(12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;B=a}else{a=znb(i,8992,12)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;xnb(i,a,1480);B=a}f[A>>2]=B;v=A;w=v+10|0;x=b[w>>0]|0;y=x&-16;b[w>>0]=y;z=f[v>>2]|0;u=g;return z|0}function GRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){zpb(e,3,477758,512);xpb(g,vpb(vpb(e,477869)|0,477911)|0);Apb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+12>>2]|0)+4+(c<<2)>>2]|0}function HRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){zpb(e,3,477758,519);xpb(g,vpb(vpb(e,477869)|0,477911)|0);Apb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+12>>2]|0)+4+(c<<2)>>2]|0}function IRb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;g=u;u=u+32|0;h=g;i=g+4|0;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=s;v=m;break}else if((p|0)==10){t=l;v=m;break}}else{t=j;v=j}while(0);j=f[t>>2]|0;if(j|0){f[j+40>>2]=e;w=j+24|0;x=f[w>>2]|0;y=mza(x)|0;u=g;return y|0}j=L5b(48)|0;f[j+16>>2]=c;c=j+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=v;f[t>>2]=j;v=f[f[a>>2]>>2]|0;if(!v)z=j;else{f[a>>2]=v;z=f[t>>2]|0}mP(f[a+4>>2]|0,z);z=a+8|0;f[z>>2]=(f[z>>2]|0)+1;z=j+24|0;f[j+40>>2]=e;b[j+32>>0]=d;b[j+33>>0]=1;b[j+35>>0]=0;j=f[a+12>>2]|0;if(j){f[h>>2]=0;a=xRb(h)|0;h=znb(j,23792,16)|0;f[h>>2]=j;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if(a)A=h;else{xnb(j,h,1538);A=h}}else{h=L5b(16)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;A=h}f[z>>2]=A;w=z;x=f[w>>2]|0;y=mza(x)|0;u=g;return y|0}function JRb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;k=f[j>>2]|0;do if(k){l=a+4|0;m=k;while(1){n=f[m+16>>2]|0;if((n|0)>(c|0)){o=f[m>>2]|0;if(!o){p=5;break}else{q=m;r=o}}else{if((n|0)>=(c|0)){p=10;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=9;break}else{q=s;r=n}}l=q;m=r}if((p|0)==5){t=m;v=m;break}else if((p|0)==9){t=s;v=m;break}else if((p|0)==10){t=l;v=m;break}}else{t=j;v=j}while(0);j=f[t>>2]|0;if(!j){p=L5b(48)|0;f[p+16>>2]=c;c=p+20|0;f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=v;f[t>>2]=p;v=f[f[a>>2]>>2]|0;if(!v)w=p;else{f[a>>2]=v;w=f[t>>2]|0}mP(f[a+4>>2]|0,w);w=a+8|0;f[w>>2]=(f[w>>2]|0)+1;f[p+40>>2]=g;b[p+32>>0]=d;b[p+33>>0]=0;d=p+34|0;b[d>>0]=b[d>>0]&15;w=Uh[f[(f[e>>2]|0)+16>>2]&1023](e,f[a+12>>2]|0)|0;f[p+24>>2]=w;b[d>>0]=b[d>>0]&-16;x=w;u=h;return x|0}else{f[j+40>>2]=g;g=j+34|0;w=b[g>>0]|0;b[g>>0]=w&-16;g=f[j+24>>2]|0;if(!(w&16)){x=g;u=h;return x|0}x=Uh[f[(f[g>>2]|0)+16>>2]&1023](g,e)|0;u=h;return x|0}return 0}function KRb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h;if(!g){j=a+4|0;k=f[j>>2]|0;if(!k){u=h;return}else{l=j;m=k}a:while(1){k=m;while(1){if((f[k+16>>2]|0)>=(c|0))break;n=f[k+4>>2]|0;if(!n){o=l;break a}else k=n}m=f[k>>2]|0;if(!m){o=k;break}else l=k}if((o|0)==(j|0)){u=h;return}if((f[o+16>>2]|0)>(c|0)){u=h;return}zQb(o+24|0);u=h;return}o=di[f[(f[g>>2]|0)+20>>2]&1023](g)|0;j=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;j=a+4|0;l=f[j>>2]|0;do if(l){m=a+4|0;n=l;while(1){p=f[n+16>>2]|0;if((p|0)>(c|0)){q=f[n>>2]|0;if(!q){r=14;break}else{s=n;t=q}}else{if((p|0)>=(c|0)){r=19;break}v=n+4|0;p=f[v>>2]|0;if(!p){r=18;break}else{s=v;t=p}}m=s;n=t}if((r|0)==14){w=n;x=n;break}else if((r|0)==18){w=v;x=n;break}else if((r|0)==19){w=m;x=n;break}}else{w=j;x=j}while(0);j=f[w>>2]|0;do if(!j){r=L5b(48)|0;f[r+16>>2]=c;v=r+20|0;f[v>>2]=f[i>>2];f[v+4>>2]=f[i+4>>2];f[v+8>>2]=f[i+8>>2];f[v+12>>2]=f[i+12>>2];f[v+16>>2]=f[i+16>>2];f[v+20>>2]=f[i+20>>2];f[v+24>>2]=f[i+24>>2];f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=x;f[w>>2]=r;v=f[f[a>>2]>>2]|0;if(!v)y=r;else{f[a>>2]=v;y=f[w>>2]|0}mP(f[a+4>>2]|0,y);v=a+8|0;f[v>>2]=(f[v>>2]|0)+1;v=r+24|0;f[r+40>>2]=e;b[r+32>>0]=d;b[r+33>>0]=0;t=r+34|0;b[t>>0]=b[t>>0]&15;t=f[a+12>>2]|0;if((o|0)==(t|0)){f[v>>2]=g;z=v;break}if(!o){f[v>>2]=g;Rob(t,g);z=v;break}else{r=Uh[f[(f[g>>2]|0)+16>>2]&1023](g,t)|0;f[v>>2]=r;zh[f[(f[r>>2]|0)+40>>2]&2047](r,g);z=v;break}}else{v=j+24|0;f[j+40>>2]=e;if(b[j+34>>0]&16){r=f[v>>2]|0;zh[f[(f[r>>2]|0)+20>>2]&2047](r,g);z=v;break}r=a+12|0;t=f[r>>2]|0;if(!t){s=f[v>>2]|0;if(!s)A=0;else{bi[f[(f[s>>2]|0)+4>>2]&2047](s);A=f[r>>2]|0}}else A=t;if((o|0)==(A|0)){f[v>>2]=g;z=v;break}if(!o){f[v>>2]=g;Rob(f[r>>2]|0,g);z=v;break}else{r=Uh[f[(f[g>>2]|0)+16>>2]&1023](g,A)|0;f[v>>2]=r;zh[f[(f[r>>2]|0)+40>>2]&2047](r,g);z=v;break}}while(0);g=z+10|0;b[g>>0]=b[g>>0]&-16;u=h;return}function LRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){zpb(e,3,477758,725);xpb(g,vpb(vpb(e,477869)|0,477911)|0);Apb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+12>>2]|0)+4+(c<<2)>>2]|0}function MRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=a+4|0;a=f[h>>2]|0;if(a){i=h;j=a;a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)!=(h|0)?(f[l+16>>2]|0)<=(b|0):0)m=l;else n=8}else n=8;if((n|0)==8){zpb(e,3,477758,732);xpb(g,vpb(vpb(e,477869)|0,477911)|0);Apb(e);m=h}u=d;return f[(f[(f[m+24>>2]|0)+12>>2]|0)+4+(c<<2)>>2]|0}function NRb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+32|0;i=h;j=h+4|0;k=j+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;k=a+4|0;l=f[k>>2]|0;do if(l){m=a+4|0;n=l;while(1){o=f[n+16>>2]|0;if((o|0)>(c|0)){p=f[n>>2]|0;if(!p){q=5;break}else{r=n;s=p}}else{if((o|0)>=(c|0)){q=10;break}t=n+4|0;o=f[t>>2]|0;if(!o){q=9;break}else{r=t;s=o}}m=r;n=s}if((q|0)==5){v=n;w=n;break}else if((q|0)==9){v=t;w=n;break}else if((q|0)==10){v=m;w=n;break}}else{v=k;w=k}while(0);k=f[v>>2]|0;if(!k){q=L5b(48)|0;f[q+16>>2]=c;c=q+20|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2];f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];f[c+16>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=w;f[v>>2]=q;w=f[f[a>>2]>>2]|0;if(!w)x=q;else{f[a>>2]=w;x=f[v>>2]|0}mP(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;x=q+24|0;f[q+40>>2]=g;b[q+32>>0]=d;b[q+33>>0]=1;q=f[a+12>>2]|0;if(q){f[i>>2]=0;d=AFb(i)|0;i=znb(q,23120,16)|0;f[i>>2]=q;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if(d)y=i;else{xnb(q,i,1526);y=i}}else{i=L5b(16)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;y=i}f[x>>2]=y;z=x}else{f[k+40>>2]=g;z=k+24|0}k=f[z>>2]|0;g=f[k+12>>2]|0;if((g|0?(x=k+4|0,k=f[x>>2]|0,(k|0)<(f[g>>2]|0)):0)?(f[x>>2]=k+1,x=f[g+4+(k<<2)>>2]|0,x|0):0){A=x;u=h;return A|0}x=Uh[f[(f[e>>2]|0)+16>>2]&1023](e,f[a+12>>2]|0)|0;DFb(f[z>>2]|0,x);A=x;u=h;return A|0}function ORb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+32|0;e=d;g=d+24|0;i=a+4|0;a=f[i>>2]|0;if(a){j=i;k=a;a:while(1){a=k;while(1){if((f[a+16>>2]|0)>=(c|0))break;l=f[a+4>>2]|0;if(!l){m=j;break a}else a=l}k=f[a>>2]|0;if(!k){m=a;break}else j=a}if((m|0)!=(i|0)?(f[m+16>>2]|0)<=(c|0):0)n=m;else o=8}else o=8;if((o|0)==8){zpb(e,3,477758,771);xpb(g,vpb(vpb(e,477869)|0,477911)|0);Apb(e);n=i}i=n+24|0;do switch(f[135848+(h[n+32>>0]<<2)>>2]|0){case 1:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 2:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 3:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 4:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 6:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 5:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 7:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 8:{e=f[i>>2]|0;f[e>>2]=(f[e>>2]|0)+-1;u=d;return}case 9:{e=f[i>>2]|0;g=f[e+12>>2]|0;o=e+4|0;e=(f[o>>2]|0)+-1|0;f[o>>2]=e;o=f[g+4+(e<<2)>>2]|0;e=o+11|0;if((b[e>>0]|0)<0){b[f[o>>2]>>0]=0;f[o+4>>2]=0;u=d;return}else{b[o>>0]=0;b[e>>0]=0;u=d;return}break}case 10:{e=f[i>>2]|0;o=f[e+12>>2]|0;g=e+4|0;e=(f[g>>2]|0)+-1|0;f[g>>2]=e;g=f[o+4+(e<<2)>>2]|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g);u=d;return}default:{u=d;return}}while(0)}function PRb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=c+24|0;g=a+4|0;a=f[g>>2]|0;if(a){h=g;i=a;a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(b|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if((k|0)!=(g|0)?(f[k+16>>2]|0)<=(b|0):0)l=k;else m=8}else m=8;if((m|0)==8){zpb(d,3,477758,812);xpb(e,vpb(vpb(d,477869)|0,477911)|0);Apb(d);l=g}g=f[l+24>>2]|0;l=f[g+12>>2]|0;d=g+4|0;g=f[d>>2]|0;e=g+-1|0;f[d>>2]=e;d=l+4+(e<<2)|0;e=f[d>>2]|0;m=f[l>>2]|0;k=m+-1|0;f[l>>2]=k;if((g|0)>=(m|0)){u=c;return e|0}f[d>>2]=f[l+4+(k<<2)>>2];u=c;return e|0}function QRb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0;g=u;u=u+32|0;i=g;j=g+24|0;k=a+4|0;a=f[k>>2]|0;if(a){l=k;m=a;a:while(1){a=m;while(1){if((f[a+16>>2]|0)>=(c|0))break;n=f[a+4>>2]|0;if(!n){o=l;break a}else a=n}m=f[a>>2]|0;if(!m){o=a;break}else l=a}if((o|0)!=(k|0)?(f[o+16>>2]|0)<=(c|0):0)q=o;else r=8}else r=8;if((r|0)==8){zpb(i,3,477758,822);xpb(j,vpb(vpb(i,477869)|0,477911)|0);Apb(i);q=k}k=q+24|0;do switch(f[135848+((h[q+32>>0]|0)<<2)>>2]|0){case 1:{i=f[(f[k>>2]|0)+8>>2]|0;j=i+4+(d<<2)|0;r=i+4+(e<<2)|0;i=f[j>>2]|0;f[j>>2]=f[r>>2];f[r>>2]=i;u=g;return}case 2:{i=f[(f[k>>2]|0)+8>>2]|0;r=i+8+(d<<3)|0;j=i+8+(e<<3)|0;i=r;o=f[i>>2]|0;c=f[i+4>>2]|0;i=j;l=f[i+4>>2]|0;m=r;f[m>>2]=f[i>>2];f[m+4>>2]=l;l=j;f[l>>2]=o;f[l+4>>2]=c;u=g;return}case 3:{c=f[(f[k>>2]|0)+8>>2]|0;l=c+4+(d<<2)|0;o=c+4+(e<<2)|0;c=f[l>>2]|0;f[l>>2]=f[o>>2];f[o>>2]=c;u=g;return}case 4:{c=f[(f[k>>2]|0)+8>>2]|0;o=c+8+(d<<3)|0;l=c+8+(e<<3)|0;c=o;j=f[c>>2]|0;m=f[c+4>>2]|0;c=l;i=f[c+4>>2]|0;r=o;f[r>>2]=f[c>>2];f[r+4>>2]=i;i=l;f[i>>2]=j;f[i+4>>2]=m;u=g;return}case 6:{m=f[(f[k>>2]|0)+8>>2]|0;i=m+4+(d<<2)|0;j=m+4+(e<<2)|0;m=f[i>>2]|0;f[i>>2]=f[j>>2];f[j>>2]=m;u=g;return}case 5:{m=f[(f[k>>2]|0)+8>>2]|0;j=m+8+(d<<3)|0;i=m+8+(e<<3)|0;s=+p[j>>3];p[j>>3]=+p[i>>3];p[i>>3]=s;u=g;return}case 7:{i=f[(f[k>>2]|0)+8>>2]|0;j=i+4+d|0;m=i+4+e|0;i=b[j>>0]|0;b[j>>0]=b[m>>0]|0;b[m>>0]=i;u=g;return}case 8:{i=f[(f[k>>2]|0)+8>>2]|0;m=i+4+(d<<2)|0;j=i+4+(e<<2)|0;i=f[m>>2]|0;f[m>>2]=f[j>>2];f[j>>2]=i;u=g;return}case 9:{i=f[(f[k>>2]|0)+12>>2]|0;j=i+4+(d<<2)|0;m=i+4+(e<<2)|0;i=f[j>>2]|0;f[j>>2]=f[m>>2];f[m>>2]=i;u=g;return}case 10:{i=f[(f[k>>2]|0)+12>>2]|0;m=i+4+(d<<2)|0;j=i+4+(e<<2)|0;i=f[m>>2]|0;f[m>>2]=f[j>>2];f[j>>2]=i;u=g;return}default:{u=g;return}}while(0)}function RRb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=f[a>>2]|0;c=a+4|0;if((b|0)==(c|0))return;else d=b;while(1){zQb(d+24|0);b=f[d+4>>2]|0;if(!b){a=d+8|0;e=f[a>>2]|0;if((f[e>>2]|0)==(d|0))g=e;else{e=a;do{a=f[e>>2]|0;e=a+8|0;h=f[e>>2]|0}while((f[h>>2]|0)!=(a|0));g=h}}else{e=b;while(1){h=f[e>>2]|0;if(!h)break;else e=h}g=e}if((g|0)==(c|0))break;else d=g}return}function SRb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=f[b>>2]|0;d=b+4|0;if((c|0)==(d|0))return;else e=c;while(1){TRb(a,f[e+16>>2]|0,e+24|0);c=f[e+4>>2]|0;if(!c){b=e+8|0;g=f[b>>2]|0;if((f[g>>2]|0)==(e|0))h=g;else{g=b;do{b=f[g>>2]|0;g=b+8|0;i=f[g>>2]|0}while((f[i>>2]|0)!=(b|0));h=i}}else{g=c;while(1){i=f[g>>2]|0;if(!i)break;else g=i}h=g}if((h|0)==(d|0))break;else e=h}return}function TRb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0.0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0;e=u;u=u+112|0;g=e+72|0;h=e+64|0;i=e+56|0;j=e+48|0;k=e+40|0;l=e+32|0;m=e+24|0;n=e+16|0;o=e+8|0;q=e;r=e+76|0;if(b[d+9>>0]|0){s=f[d+16>>2]|0;t=r+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;f[t+16>>2]=0;f[t+20>>2]=0;t=a+4|0;v=f[t>>2]|0;do if(v){w=a+4|0;x=v;while(1){y=f[x+16>>2]|0;if((y|0)>(c|0)){z=f[x>>2]|0;if(!z){A=6;break}else{B=x;C=z}}else{if((y|0)>=(c|0)){A=11;break}D=x+4|0;y=f[D>>2]|0;if(!y){A=10;break}else{B=D;C=y}}w=B;x=C}if((A|0)==6){E=x;F=x;break}else if((A|0)==10){E=D;F=x;break}else if((A|0)==11){E=w;F=x;break}}else{E=t;F=t}while(0);t=f[E>>2]|0;if(!t){D=L5b(48)|0;f[D+16>>2]=c;C=D+20|0;f[C>>2]=f[r>>2];f[C+4>>2]=f[r+4>>2];f[C+8>>2]=f[r+8>>2];f[C+12>>2]=f[r+12>>2];f[C+16>>2]=f[r+16>>2];f[C+20>>2]=f[r+20>>2];f[C+24>>2]=f[r+24>>2];f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=F;f[E>>2]=D;F=f[f[a>>2]>>2]|0;if(!F)G=D;else{f[a>>2]=F;G=f[E>>2]|0}mP(f[a+4>>2]|0,G);G=a+8|0;f[G>>2]=(f[G>>2]|0)+1;f[D+40>>2]=s;G=b[d+8>>0]|0;b[D+32>>0]=G;b[D+35>>0]=b[d+11>>0]|0;b[D+33>>0]=1;H=1;I=G;J=D+24|0}else{f[t+40>>2]=s;H=0;I=b[d+8>>0]|0;J=t+24|0}do switch(f[135848+((I&255)<<2)>>2]|0){case 1:{if(H){t=f[a+12>>2]|0;if(t){f[q>>2]=0;s=GQb(q)|0;D=znb(t,23736,12)|0;f[D>>2]=0;f[D+4>>2]=0;G=D+8|0;f[G>>2]=0;E=znb(t,25528,4)|0;f[G>>2]=E;f[E>>2]=t;if(s)K=D;else{xnb(t,D,1531);K=D}}else{D=L5b(12)|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;K=D}f[J>>2]=K;L=K}else L=f[J>>2]|0;jIb(L,f[d>>2]|0);u=e;return}case 2:{if(H){D=f[a+12>>2]|0;if(D){f[o>>2]=0;t=NQb(o)|0;s=znb(D,23744,12)|0;f[s>>2]=0;f[s+4>>2]=0;E=s+8|0;f[E>>2]=0;G=znb(D,25528,8)|0;f[E>>2]=G;f[G>>2]=D;if(t)M=s;else{xnb(D,s,1532);M=s}}else{s=L5b(12)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;M=s}f[J>>2]=M;N=M}else N=f[J>>2]|0;iIb(N,f[d>>2]|0);u=e;return}case 3:{if(H){s=f[a+12>>2]|0;if(s){f[n>>2]=0;D=UQb(n)|0;t=znb(s,23752,12)|0;f[t>>2]=0;f[t+4>>2]=0;G=t+8|0;f[G>>2]=0;E=znb(s,25528,4)|0;f[G>>2]=E;f[E>>2]=s;if(D)O=t;else{xnb(s,t,1533);O=t}}else{t=L5b(12)|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;O=t}f[J>>2]=O;P=O}else P=f[J>>2]|0;hIb(P,f[d>>2]|0);u=e;return}case 4:{if(H){t=f[a+12>>2]|0;if(t){f[m>>2]=0;s=$Qb(m)|0;D=znb(t,23760,12)|0;f[D>>2]=0;f[D+4>>2]=0;E=D+8|0;f[E>>2]=0;G=znb(t,25528,8)|0;f[E>>2]=G;f[G>>2]=t;if(s)Q=D;else{xnb(t,D,1534);Q=D}}else{D=L5b(12)|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;Q=D}f[J>>2]=Q;R=Q}else R=f[J>>2]|0;gIb(R,f[d>>2]|0);u=e;return}case 6:{if(H){D=f[a+12>>2]|0;if(D){f[l>>2]=0;t=gRb(l)|0;s=znb(D,23768,12)|0;f[s>>2]=0;f[s+4>>2]=0;G=s+8|0;f[G>>2]=0;E=znb(D,25528,4)|0;f[G>>2]=E;f[E>>2]=D;if(t)S=s;else{xnb(D,s,1535);S=s}}else{s=L5b(12)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;S=s}f[J>>2]=S;T=S}else T=f[J>>2]|0;fIb(T,f[d>>2]|0);u=e;return}case 5:{if(H){s=f[a+12>>2]|0;if(s){f[k>>2]=0;D=nRb(k)|0;t=znb(s,23776,12)|0;f[t>>2]=0;f[t+4>>2]=0;E=t+8|0;f[E>>2]=0;G=znb(s,25528,8)|0;f[E>>2]=G;f[G>>2]=s;if(D)U=t;else{xnb(s,t,1536);U=t}}else{t=L5b(12)|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;U=t}f[J>>2]=U;V=U}else V=f[J>>2]|0;eIb(V,f[d>>2]|0);u=e;return}case 7:{if(H){t=f[a+12>>2]|0;if(t){f[j>>2]=0;s=uRb(j)|0;D=znb(t,23784,12)|0;f[D>>2]=0;f[D+4>>2]=0;G=D+8|0;f[G>>2]=0;E=znb(t,25528,4)|0;f[G>>2]=E;f[E>>2]=t;if(s)W=D;else{xnb(t,D,1537);W=D}}else{D=L5b(12)|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;W=D}f[J>>2]=W;X=W}else X=f[J>>2]|0;dIb(X,f[d>>2]|0);u=e;return}case 8:{if(H){D=f[a+12>>2]|0;if(D){f[i>>2]=0;t=GQb(i)|0;s=znb(D,23736,12)|0;f[s>>2]=0;f[s+4>>2]=0;E=s+8|0;f[E>>2]=0;G=znb(D,25528,4)|0;f[E>>2]=G;f[G>>2]=D;if(t)Y=s;else{xnb(D,s,1531);Y=s}}else{s=L5b(12)|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;Y=s}f[J>>2]=Y;Z=Y}else Z=f[J>>2]|0;jIb(Z,f[d>>2]|0);u=e;return}case 9:{if(H){s=f[a+12>>2]|0;if(s){f[h>>2]=0;D=xRb(h)|0;t=znb(s,23792,16)|0;f[t>>2]=s;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if(D)_=t;else{xnb(s,t,1538);_=t}}else{t=L5b(16)|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;_=t}f[J>>2]=_;$=_}else $=f[J>>2]|0;UDa($,f[d>>2]|0);u=e;return}case 10:{if(H){t=f[a+12>>2]|0;if(t){f[g>>2]=0;s=AFb(g)|0;D=znb(t,23120,16)|0;f[D>>2]=t;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if(s)aa=D;else{xnb(t,D,1526);aa=D}}else{D=L5b(16)|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;aa=D}f[J>>2]=aa}D=f[d>>2]|0;t=D+4|0;if((f[t>>2]|0)<=0){u=e;return}s=D+12|0;D=a+12|0;G=0;do{E=f[(f[s>>2]|0)+4+(G<<2)>>2]|0;F=f[J>>2]|0;C=f[F+12>>2]|0;if(((C|0)!=0?(B=F+4|0,F=f[B>>2]|0,(F|0)<(f[C>>2]|0)):0)?(f[B>>2]=F+1,B=f[C+4+(F<<2)>>2]|0,(B|0)!=0):0)ba=B;else{B=Uh[f[(f[E>>2]|0)+16>>2]&1023](E,f[D>>2]|0)|0;DFb(f[J>>2]|0,B);ba=B}zh[f[(f[ba>>2]|0)+40>>2]&2047](ba,E);G=G+1|0}while((G|0)<(f[t>>2]|0));u=e;return}default:{u=e;return}}while(0)}ba=d+10|0;if(b[ba>>0]&1){u=e;return}J=d+8|0;aa=b[J>>0]|0;do switch(f[135848+((aa&255)<<2)>>2]|0){case 1:{g=f[d>>2]|0;H=f[d+16>>2]|0;$=r+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;f[$+16>>2]=0;f[$+20>>2]=0;$=a+4|0;_=f[$>>2]|0;do if(_){h=a+4|0;Z=_;while(1){Y=f[Z+16>>2]|0;if((Y|0)>(c|0)){i=f[Z>>2]|0;if(!i){A=110;break}else{ca=Z;da=i}}else{if((Y|0)>=(c|0)){A=115;break}ea=Z+4|0;Y=f[ea>>2]|0;if(!Y){A=114;break}else{ca=ea;da=Y}}h=ca;Z=da}if((A|0)==110){fa=Z;ga=Z;break}else if((A|0)==114){fa=ea;ga=Z;break}else if((A|0)==115){fa=h;ga=Z;break}}else{fa=$;ga=$}while(0);$=f[fa>>2]|0;if(!$){_=L5b(48)|0;f[_+16>>2]=c;Y=_+20|0;f[Y>>2]=f[r>>2];f[Y+4>>2]=f[r+4>>2];f[Y+8>>2]=f[r+8>>2];f[Y+12>>2]=f[r+12>>2];f[Y+16>>2]=f[r+16>>2];f[Y+20>>2]=f[r+20>>2];f[Y+24>>2]=f[r+24>>2];f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=ga;f[fa>>2]=_;Y=f[f[a>>2]>>2]|0;if(!Y)ha=_;else{f[a>>2]=Y;ha=f[fa>>2]|0}mP(f[a+4>>2]|0,ha);Y=a+8|0;f[Y>>2]=(f[Y>>2]|0)+1;f[_+40>>2]=H;b[_+32>>0]=aa;b[_+33>>0]=0;ia=_+24|0}else{f[$+40>>2]=H;ia=$+24|0}$=ia+10|0;b[$>>0]=b[$>>0]&-16;f[ia>>2]=g;u=e;return}case 2:{$=d;_=f[$>>2]|0;Y=f[$+4>>2]|0;$=f[d+16>>2]|0;i=r+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=a+4|0;X=f[i>>2]|0;do if(X){W=a+4|0;j=X;while(1){V=f[j+16>>2]|0;if((V|0)>(c|0)){U=f[j>>2]|0;if(!U){A=127;break}else{ja=j;ka=U}}else{if((V|0)>=(c|0)){A=132;break}la=j+4|0;V=f[la>>2]|0;if(!V){A=131;break}else{ja=la;ka=V}}W=ja;j=ka}if((A|0)==127){ma=j;na=j;break}else if((A|0)==131){ma=la;na=j;break}else if((A|0)==132){ma=W;na=j;break}}else{ma=i;na=i}while(0);i=f[ma>>2]|0;if(!i){X=L5b(48)|0;f[X+16>>2]=c;g=X+20|0;f[g>>2]=f[r>>2];f[g+4>>2]=f[r+4>>2];f[g+8>>2]=f[r+8>>2];f[g+12>>2]=f[r+12>>2];f[g+16>>2]=f[r+16>>2];f[g+20>>2]=f[r+20>>2];f[g+24>>2]=f[r+24>>2];f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=na;f[ma>>2]=X;g=f[f[a>>2]>>2]|0;if(!g)oa=X;else{f[a>>2]=g;oa=f[ma>>2]|0}mP(f[a+4>>2]|0,oa);g=a+8|0;f[g>>2]=(f[g>>2]|0)+1;f[X+40>>2]=$;b[X+32>>0]=aa;b[X+33>>0]=0;pa=X+24|0}else{f[i+40>>2]=$;pa=i+24|0}i=pa+10|0;b[i>>0]=b[i>>0]&-16;i=pa;f[i>>2]=_;f[i+4>>2]=Y;u=e;return}case 3:{i=f[d>>2]|0;X=f[d+16>>2]|0;g=r+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;g=a+4|0;H=f[g>>2]|0;do if(H){Z=a+4|0;h=H;while(1){V=f[h+16>>2]|0;if((V|0)>(c|0)){U=f[h>>2]|0;if(!U){A=144;break}else{qa=h;ra=U}}else{if((V|0)>=(c|0)){A=149;break}sa=h+4|0;V=f[sa>>2]|0;if(!V){A=148;break}else{qa=sa;ra=V}}Z=qa;h=ra}if((A|0)==144){ta=h;ua=h;break}else if((A|0)==148){ta=sa;ua=h;break}else if((A|0)==149){ta=Z;ua=h;break}}else{ta=g;ua=g}while(0);g=f[ta>>2]|0;if(!g){H=L5b(48)|0;f[H+16>>2]=c;Y=H+20|0;f[Y>>2]=f[r>>2];f[Y+4>>2]=f[r+4>>2];f[Y+8>>2]=f[r+8>>2];f[Y+12>>2]=f[r+12>>2];f[Y+16>>2]=f[r+16>>2];f[Y+20>>2]=f[r+20>>2];f[Y+24>>2]=f[r+24>>2];f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=ua;f[ta>>2]=H;Y=f[f[a>>2]>>2]|0;if(!Y)va=H;else{f[a>>2]=Y;va=f[ta>>2]|0}mP(f[a+4>>2]|0,va);Y=a+8|0;f[Y>>2]=(f[Y>>2]|0)+1;f[H+40>>2]=X;b[H+32>>0]=aa;b[H+33>>0]=0;wa=H+24|0}else{f[g+40>>2]=X;wa=g+24|0}g=wa+10|0;b[g>>0]=b[g>>0]&-16;f[wa>>2]=i;u=e;return}case 4:{g=d;H=f[g>>2]|0;Y=f[g+4>>2]|0;g=f[d+16>>2]|0;_=r+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;f[_+16>>2]=0;f[_+20>>2]=0;_=a+4|0;$=f[_>>2]|0;do if($){j=a+4|0;W=$;while(1){V=f[W+16>>2]|0;if((V|0)>(c|0)){U=f[W>>2]|0;if(!U){A=161;break}else{xa=W;ya=U}}else{if((V|0)>=(c|0)){A=166;break}za=W+4|0;V=f[za>>2]|0;if(!V){A=165;break}else{xa=za;ya=V}}j=xa;W=ya}if((A|0)==161){Aa=W;Ba=W;break}else if((A|0)==165){Aa=za;Ba=W;break}else if((A|0)==166){Aa=j;Ba=W;break}}else{Aa=_;Ba=_}while(0);_=f[Aa>>2]|0;if(!_){$=L5b(48)|0;f[$+16>>2]=c;i=$+20|0;f[i>>2]=f[r>>2];f[i+4>>2]=f[r+4>>2];f[i+8>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];f[i+16>>2]=f[r+16>>2];f[i+20>>2]=f[r+20>>2];f[i+24>>2]=f[r+24>>2];f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=Ba;f[Aa>>2]=$;i=f[f[a>>2]>>2]|0;if(!i)Ca=$;else{f[a>>2]=i;Ca=f[Aa>>2]|0}mP(f[a+4>>2]|0,Ca);i=a+8|0;f[i>>2]=(f[i>>2]|0)+1;f[$+40>>2]=g;b[$+32>>0]=aa;b[$+33>>0]=0;Da=$+24|0}else{f[_+40>>2]=g;Da=_+24|0}_=Da+10|0;b[_>>0]=b[_>>0]&-16;_=Da;f[_>>2]=H;f[_+4>>2]=Y;u=e;return}case 6:{_=f[d>>2]|0;$=f[d+16>>2]|0;i=r+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=a+4|0;X=f[i>>2]|0;do if(X){h=a+4|0;Z=X;while(1){V=f[Z+16>>2]|0;if((V|0)>(c|0)){U=f[Z>>2]|0;if(!U){A=178;break}else{Ea=Z;Fa=U}}else{if((V|0)>=(c|0)){A=183;break}Ga=Z+4|0;V=f[Ga>>2]|0;if(!V){A=182;break}else{Ea=Ga;Fa=V}}h=Ea;Z=Fa}if((A|0)==178){Ha=Z;Ia=Z;break}else if((A|0)==182){Ha=Ga;Ia=Z;break}else if((A|0)==183){Ha=h;Ia=Z;break}}else{Ha=i;Ia=i}while(0);i=f[Ha>>2]|0;if(!i){X=L5b(48)|0;f[X+16>>2]=c;Y=X+20|0;f[Y>>2]=f[r>>2];f[Y+4>>2]=f[r+4>>2];f[Y+8>>2]=f[r+8>>2];f[Y+12>>2]=f[r+12>>2];f[Y+16>>2]=f[r+16>>2];f[Y+20>>2]=f[r+20>>2];f[Y+24>>2]=f[r+24>>2];f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=Ia;f[Ha>>2]=X;Y=f[f[a>>2]>>2]|0;if(!Y)Ja=X;else{f[a>>2]=Y;Ja=f[Ha>>2]|0}mP(f[a+4>>2]|0,Ja);Y=a+8|0;f[Y>>2]=(f[Y>>2]|0)+1;f[X+40>>2]=$;b[X+32>>0]=aa;b[X+33>>0]=0;Ka=X+24|0}else{f[i+40>>2]=$;Ka=i+24|0}i=Ka+10|0;b[i>>0]=b[i>>0]&-16;f[Ka>>2]=_;u=e;return}case 5:{La=+p[d>>3];i=f[d+16>>2]|0;X=r+4|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;f[X+16>>2]=0;f[X+20>>2]=0;X=a+4|0;Y=f[X>>2]|0;do if(Y){H=a+4|0;g=Y;while(1){W=f[g+16>>2]|0;if((W|0)>(c|0)){j=f[g>>2]|0;if(!j){A=195;break}else{Ma=g;Na=j}}else{if((W|0)>=(c|0)){A=200;break}Oa=g+4|0;W=f[Oa>>2]|0;if(!W){A=199;break}else{Ma=Oa;Na=W}}H=Ma;g=Na}if((A|0)==195){Pa=g;Qa=g;break}else if((A|0)==199){Pa=Oa;Qa=g;break}else if((A|0)==200){Pa=H;Qa=g;break}}else{Pa=X;Qa=X}while(0);X=f[Pa>>2]|0;if(!X){Y=L5b(48)|0;f[Y+16>>2]=c;_=Y+20|0;f[_>>2]=f[r>>2];f[_+4>>2]=f[r+4>>2];f[_+8>>2]=f[r+8>>2];f[_+12>>2]=f[r+12>>2];f[_+16>>2]=f[r+16>>2];f[_+20>>2]=f[r+20>>2];f[_+24>>2]=f[r+24>>2];f[Y>>2]=0;f[Y+4>>2]=0;f[Y+8>>2]=Qa;f[Pa>>2]=Y;_=f[f[a>>2]>>2]|0;if(!_)Ra=Y;else{f[a>>2]=_;Ra=f[Pa>>2]|0}mP(f[a+4>>2]|0,Ra);_=a+8|0;f[_>>2]=(f[_>>2]|0)+1;f[Y+40>>2]=i;b[Y+32>>0]=aa;b[Y+33>>0]=0;Sa=Y+24|0}else{f[X+40>>2]=i;Sa=X+24|0}X=Sa+10|0;b[X>>0]=b[X>>0]&-16;p[Sa>>3]=La;u=e;return}case 7:{X=b[d>>0]|0;Y=f[d+16>>2]|0;_=r+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;f[_+16>>2]=0;f[_+20>>2]=0;_=a+4|0;$=f[_>>2]|0;do if($){Z=a+4|0;h=$;while(1){W=f[h+16>>2]|0;if((W|0)>(c|0)){j=f[h>>2]|0;if(!j){A=212;break}else{Ta=h;Ua=j}}else{if((W|0)>=(c|0)){A=217;break}Va=h+4|0;W=f[Va>>2]|0;if(!W){A=216;break}else{Ta=Va;Ua=W}}Z=Ta;h=Ua}if((A|0)==212){Wa=h;Xa=h;break}else if((A|0)==216){Wa=Va;Xa=h;break}else if((A|0)==217){Wa=Z;Xa=h;break}}else{Wa=_;Xa=_}while(0);_=f[Wa>>2]|0;if(!_){$=L5b(48)|0;f[$+16>>2]=c;i=$+20|0;f[i>>2]=f[r>>2];f[i+4>>2]=f[r+4>>2];f[i+8>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];f[i+16>>2]=f[r+16>>2];f[i+20>>2]=f[r+20>>2];f[i+24>>2]=f[r+24>>2];f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=Xa;f[Wa>>2]=$;i=f[f[a>>2]>>2]|0;if(!i)Ya=$;else{f[a>>2]=i;Ya=f[Wa>>2]|0}mP(f[a+4>>2]|0,Ya);i=a+8|0;f[i>>2]=(f[i>>2]|0)+1;f[$+40>>2]=Y;b[$+32>>0]=aa;b[$+33>>0]=0;Za=$+24|0}else{f[_+40>>2]=Y;Za=_+24|0}_=Za+10|0;b[_>>0]=b[_>>0]&-16;b[Za>>0]=X;u=e;return}case 8:{_=f[d>>2]|0;$=f[d+16>>2]|0;i=r+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;i=a+4|0;g=f[i>>2]|0;do if(g){H=a+4|0;W=g;while(1){j=f[W+16>>2]|0;if((j|0)>(c|0)){V=f[W>>2]|0;if(!V){A=229;break}else{_a=W;$a=V}}else{if((j|0)>=(c|0)){A=234;break}ab=W+4|0;j=f[ab>>2]|0;if(!j){A=233;break}else{_a=ab;$a=j}}H=_a;W=$a}if((A|0)==229){bb=W;cb=W;break}else if((A|0)==233){bb=ab;cb=W;break}else if((A|0)==234){bb=H;cb=W;break}}else{bb=i;cb=i}while(0);i=f[bb>>2]|0;if(!i){g=L5b(48)|0;f[g+16>>2]=c;X=g+20|0;f[X>>2]=f[r>>2];f[X+4>>2]=f[r+4>>2];f[X+8>>2]=f[r+8>>2];f[X+12>>2]=f[r+12>>2];f[X+16>>2]=f[r+16>>2];f[X+20>>2]=f[r+20>>2];f[X+24>>2]=f[r+24>>2];f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=cb;f[bb>>2]=g;X=f[f[a>>2]>>2]|0;if(!X)db=g;else{f[a>>2]=X;db=f[bb>>2]|0}mP(f[a+4>>2]|0,db);X=a+8|0;f[X>>2]=(f[X>>2]|0)+1;f[g+40>>2]=$;b[g+32>>0]=aa;b[g+33>>0]=0;eb=g+24|0}else{f[i+40>>2]=$;eb=i+24|0}i=eb+10|0;b[i>>0]=b[i>>0]&-16;f[eb>>2]=_;u=e;return}case 9:{i=f[d>>2]|0;_5b(FRb(a,c,aa,f[d+16>>2]|0)|0,i)|0;u=e;return}case 10:{i=f[d+16>>2]|0;g=r+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;f[g+16>>2]=0;f[g+20>>2]=0;g=a+4|0;X=f[g>>2]|0;do if(X){Y=a+4|0;h=X;while(1){Z=f[h+16>>2]|0;if((Z|0)>(c|0)){j=f[h>>2]|0;if(!j){A=247;break}else{fb=h;gb=j}}else{if((Z|0)>=(c|0)){A=252;break}hb=h+4|0;Z=f[hb>>2]|0;if(!Z){A=251;break}else{fb=hb;gb=Z}}Y=fb;h=gb}if((A|0)==247){ib=h;jb=h;break}else if((A|0)==251){ib=hb;jb=h;break}else if((A|0)==252){ib=Y;jb=h;break}}else{ib=g;jb=g}while(0);g=f[ib>>2]|0;do if(!g){X=L5b(48)|0;f[X+16>>2]=c;_=X+20|0;f[_>>2]=f[r>>2];f[_+4>>2]=f[r+4>>2];f[_+8>>2]=f[r+8>>2];f[_+12>>2]=f[r+12>>2];f[_+16>>2]=f[r+16>>2];f[_+20>>2]=f[r+20>>2];f[_+24>>2]=f[r+24>>2];f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=jb;f[ib>>2]=X;_=f[f[a>>2]>>2]|0;if(!_)kb=X;else{f[a>>2]=_;kb=f[ib>>2]|0}mP(f[a+4>>2]|0,kb);_=a+8|0;f[_>>2]=(f[_>>2]|0)+1;_=X+24|0;f[X+40>>2]=i;b[X+32>>0]=b[J>>0]|0;b[X+35>>0]=b[d+11>>0]|0;b[X+33>>0]=0;$=X+34|0;X=b[$>>0]&15;W=f[a+12>>2]|0;if(!(b[ba>>0]&16)){b[$>>0]=X;H=f[d>>2]|0;Z=Uh[f[(f[H>>2]|0)+16>>2]&1023](H,W)|0;f[_>>2]=Z;zh[f[(f[Z>>2]|0)+40>>2]&2047](Z,f[d>>2]|0);lb=_;break}else{b[$>>0]=X|16;X=f[d>>2]|0;$=Uh[f[(f[X>>2]|0)+8>>2]&1023](X,W)|0;f[_>>2]=$;zh[f[(f[$>>2]|0)+48>>2]&2047]($,f[d>>2]|0);lb=_;break}}else{_=g+24|0;f[g+40>>2]=i;$=(b[g+34>>0]&16)!=0;W=f[_>>2]|0;if(!(b[ba>>0]&16))if($){X=Uh[f[(f[W>>2]|0)+16>>2]&1023](W,f[d>>2]|0)|0;zh[f[(f[X>>2]|0)+40>>2]&2047](X,f[d>>2]|0);lb=_;break}else{zh[f[(f[W>>2]|0)+40>>2]&2047](W,f[d>>2]|0);lb=_;break}else{X=f[W>>2]|0;if($){zh[f[X+48>>2]&2047](W,f[d>>2]|0);lb=_;break}else{$=f[X+40>>2]|0;X=f[d>>2]|0;Z=Uh[f[(f[X>>2]|0)+12>>2]&1023](X,W)|0;zh[$&2047](W,Z);lb=_;break}}}while(0);g=lb+10|0;b[g>>0]=b[g>>0]&-16;u=e;return}default:{u=e;return}}while(0)}function URb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;if((f[a+12>>2]|0)==(f[b+12>>2]|0)){e=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=e;e=a+4|0;g=b+4|0;h=f[e>>2]|0;f[e>>2]=f[g>>2];f[g>>2]=h;h=a+8|0;i=b+8|0;j=f[h>>2]|0;f[h>>2]=f[i>>2];f[i>>2]=j;if(!(f[h>>2]|0))k=a;else k=(f[e>>2]|0)+8|0;f[k>>2]=e;f[((j|0)==0?b:(f[g>>2]|0)+8|0)>>2]=g;u=c;return}f[d+4>>2]=0;f[d+8>>2]=0;g=d+4|0;f[d>>2]=g;j=d+12|0;f[j>>2]=0;e=f[b>>2]|0;k=b+4|0;if((e|0)==(k|0))l=e;else{h=e;while(1){TRb(d,f[h+16>>2]|0,h+24|0);e=f[h+4>>2]|0;if(!e){i=h+8|0;m=f[i>>2]|0;if((f[m>>2]|0)==(h|0))n=m;else{m=i;do{i=f[m>>2]|0;m=i+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(i|0));n=o}}else{m=e;while(1){o=f[m>>2]|0;if(!o)break;else m=o}n=m}if((n|0)==(k|0))break;else h=n}l=f[b>>2]|0}if((l|0)!=(k|0)){n=l;while(1){zQb(n+24|0);l=f[n+4>>2]|0;if(!l){h=n+8|0;e=f[h>>2]|0;if((f[e>>2]|0)==(n|0))p=e;else{e=h;do{h=f[e>>2]|0;e=h+8|0;o=f[e>>2]|0}while((f[o>>2]|0)!=(h|0));p=o}}else{e=l;while(1){m=f[e>>2]|0;if(!m)break;else e=m}p=e}if((p|0)==(k|0))break;else n=p}}p=f[a>>2]|0;n=a+4|0;if((p|0)==(n|0))q=p;else{k=p;while(1){TRb(b,f[k+16>>2]|0,k+24|0);p=f[k+4>>2]|0;if(!p){l=k+8|0;m=f[l>>2]|0;if((f[m>>2]|0)==(k|0))r=m;else{m=l;do{l=f[m>>2]|0;m=l+8|0;o=f[m>>2]|0}while((f[o>>2]|0)!=(l|0));r=o}}else{m=p;while(1){e=f[m>>2]|0;if(!e)break;else m=e}r=m}if((r|0)==(n|0))break;else k=r}q=f[a>>2]|0}if((q|0)!=(n|0)){r=q;while(1){zQb(r+24|0);q=f[r+4>>2]|0;if(!q){k=r+8|0;b=f[k>>2]|0;if((f[b>>2]|0)==(r|0))s=b;else{b=k;do{k=f[b>>2]|0;b=k+8|0;p=f[b>>2]|0}while((f[p>>2]|0)!=(k|0));s=p}}else{b=q;while(1){m=f[b>>2]|0;if(!m)break;else b=m}s=b}if((s|0)==(n|0))break;else r=s}}s=f[d>>2]|0;if((s|0)!=(g|0)){r=s;while(1){TRb(a,f[r+16>>2]|0,r+24|0);s=f[r+4>>2]|0;if(!s){n=r+8|0;q=f[n>>2]|0;if((f[q>>2]|0)==(r|0))t=q;else{q=n;do{n=f[q>>2]|0;q=n+8|0;m=f[q>>2]|0}while((f[m>>2]|0)!=(n|0));t=m}}else{q=s;while(1){b=f[q>>2]|0;if(!b)break;else q=b}t=q}if((t|0)==(g|0))break;else r=t}}if((f[j>>2]|0)==0?(j=f[d>>2]|0,(j|0)!=(g|0)):0){t=j;while(1){uQb(t+24|0);j=f[t+4>>2]|0;if(!j){r=t+8|0;a=f[r>>2]|0;if((f[a>>2]|0)==(t|0))v=a;else{a=r;do{r=f[a>>2]|0;a=r+8|0;s=f[a>>2]|0}while((f[s>>2]|0)!=(r|0));v=s}}else{a=j;while(1){q=f[a>>2]|0;if(!q)break;else a=q}v=a}if((v|0)==(g|0))break;else t=v}}rQb(d,f[g>>2]|0);u=c;return}function VRb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+64|0;e=d;g=d+28|0;if((a|0)==(b|0)){u=d;return}h=a+4|0;i=f[h>>2]|0;j=(i|0)==0;if(!j){k=h;l=i;a:while(1){m=l;while(1){if((f[m+16>>2]|0)>=(c|0))break;n=f[m+4>>2]|0;if(!n){o=k;break a}else m=n}l=f[m>>2]|0;if(!l){o=m;break}else k=m}if((o|0)!=(h|0)?(f[o+16>>2]|0)<=(c|0):0)p=o;else q=9}else q=9;if((q|0)==9)p=h;o=b+4|0;k=f[o>>2]|0;l=(k|0)==0;if(!l){n=o;r=k;b:while(1){s=r;while(1){if((f[s+16>>2]|0)>=(c|0))break;t=f[s+4>>2]|0;if(!t){v=n;break b}else s=t}r=f[s>>2]|0;if(!r){v=s;break}else n=s}if((v|0)!=(o|0)?(f[v+16>>2]|0)<=(c|0):0)w=v;else q=17}else q=17;if((q|0)==17)w=o;v=(p|0)==(h|0);if(!((w|0)!=(o|0)|v^1)){u=d;return}n=(w|0)==(o|0);if(!(v|n)){if((f[a+12>>2]|0)==(f[b+12>>2]|0)){r=p+24|0;m=w+24|0;f[e>>2]=f[r>>2];f[e+4>>2]=f[r+4>>2];f[e+8>>2]=f[r+8>>2];f[e+12>>2]=f[r+12>>2];f[e+16>>2]=f[r+16>>2];f[e+20>>2]=f[r+20>>2];f[r>>2]=f[m>>2];f[r+4>>2]=f[m+4>>2];f[r+8>>2]=f[m+8>>2];f[r+12>>2]=f[m+12>>2];f[r+16>>2]=f[m+16>>2];f[r+20>>2]=f[m+20>>2];f[m>>2]=f[e>>2];f[m+4>>2]=f[e+4>>2];f[m+8>>2]=f[e+8>>2];f[m+12>>2]=f[e+12>>2];f[m+16>>2]=f[e+16>>2];f[m+20>>2]=f[e+20>>2];u=d;return}f[e+4>>2]=0;f[e+8>>2]=0;m=e+4|0;f[e>>2]=m;r=e+12|0;f[r>>2]=0;t=w+24|0;TRb(e,c,t);x=f[m>>2]|0;if(x){y=m;z=x;c:while(1){x=z;while(1){if((f[x+16>>2]|0)>=(c|0))break;A=f[x+4>>2]|0;if(!A){B=y;break c}else x=A}z=f[x>>2]|0;if(!z){B=x;break}else y=x}if((B|0)!=(m|0)?(f[B+16>>2]|0)<=(c|0):0)C=B;else q=29}else q=29;if((q|0)==29)C=m;zQb(t);t=p+24|0;TRb(b,c,t);zQb(t);TRb(a,c,C+24|0);if((f[r>>2]|0)==0?(r=f[e>>2]|0,(r|0)!=(m|0)):0){C=r;while(1){uQb(C+24|0);r=f[C+4>>2]|0;if(!r){t=C+8|0;B=f[t>>2]|0;if((f[B>>2]|0)==(C|0))D=B;else{B=t;do{t=f[B>>2]|0;B=t+8|0;y=f[B>>2]|0}while((f[y>>2]|0)!=(t|0));D=y}}else{B=r;while(1){x=f[B>>2]|0;if(!x)break;else B=x}D=B}if((D|0)==(m|0))break;else C=D}}rQb(e,f[m>>2]|0);u=d;return}if(v){if((f[a+12>>2]|0)==(f[b+12>>2]|0)){v=g+4|0;Xac(v|0,w+24|0,24)|0;m=e+4|0;f[m>>2]=f[v>>2];f[m+4>>2]=f[v+4>>2];f[m+8>>2]=f[v+8>>2];f[m+12>>2]=f[v+12>>2];f[m+16>>2]=f[v+16>>2];f[m+20>>2]=f[v+20>>2];do if(!j){v=a+4|0;m=i;while(1){D=f[m+16>>2]|0;if((D|0)>(c|0)){C=f[m>>2]|0;if(!C){q=45;break}else{E=m;F=C}}else{if((D|0)>=(c|0)){q=50;break}G=m+4|0;D=f[G>>2]|0;if(!D){q=49;break}else{E=G;F=D}}v=E;m=F}if((q|0)==45){H=m;I=m;break}else if((q|0)==49){H=G;I=m;break}else if((q|0)==50){H=v;I=m;break}}else{H=h;I=h}while(0);if(!(f[H>>2]|0)){G=L5b(48)|0;f[G+16>>2]=c;F=G+20|0;f[F>>2]=f[e>>2];f[F+4>>2]=f[e+4>>2];f[F+8>>2]=f[e+8>>2];f[F+12>>2]=f[e+12>>2];f[F+16>>2]=f[e+16>>2];f[F+20>>2]=f[e+20>>2];f[F+24>>2]=f[e+24>>2];f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=I;f[H>>2]=G;I=f[f[a>>2]>>2]|0;if(!I)J=G;else{f[a>>2]=I;J=f[H>>2]|0}mP(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}}else TRb(a,c,w+24|0);w=f[o>>2]|0;if(!w){u=d;return}else{K=o;L=w}d:while(1){J=L;while(1){if((f[J+16>>2]|0)>=(c|0))break;H=f[J+4>>2]|0;if(!H){M=K;break d}else J=H}L=f[J>>2]|0;if(!L){M=J;break}else K=J}if((M|0)==(o|0)){u=d;return}if((f[M+16>>2]|0)>(c|0)){u=d;return}K=f[M+4>>2]|0;if(!K){L=M+8|0;m=f[L>>2]|0;if((f[m>>2]|0)==(M|0))N=m;else{m=L;do{L=f[m>>2]|0;m=L+8|0;v=f[m>>2]|0}while((f[v>>2]|0)!=(L|0));N=v}}else{m=K;while(1){K=f[m>>2]|0;if(!K)break;else m=K}N=m}if((f[b>>2]|0)==(M|0))f[b>>2]=N;N=b+8|0;f[N>>2]=(f[N>>2]|0)+-1;wwa(w,M);O5b(M);u=d;return}if(!n){u=d;return}if((f[a+12>>2]|0)==(f[b+12>>2]|0)){n=g+4|0;Xac(n|0,p+24|0,24)|0;g=e+4|0;f[g>>2]=f[n>>2];f[g+4>>2]=f[n+4>>2];f[g+8>>2]=f[n+8>>2];f[g+12>>2]=f[n+12>>2];f[g+16>>2]=f[n+16>>2];f[g+20>>2]=f[n+20>>2];do if(!l){n=b+4|0;g=k;while(1){M=f[g+16>>2]|0;if((M|0)>(c|0)){w=f[g>>2]|0;if(!w){q=79;break}else{O=g;P=w}}else{if((M|0)>=(c|0)){q=84;break}Q=g+4|0;M=f[Q>>2]|0;if(!M){q=83;break}else{O=Q;P=M}}n=O;g=P}if((q|0)==79){R=g;S=g;break}else if((q|0)==83){R=Q;S=g;break}else if((q|0)==84){R=n;S=g;break}}else{R=o;S=o}while(0);if(!(f[R>>2]|0)){o=L5b(48)|0;f[o+16>>2]=c;q=o+20|0;f[q>>2]=f[e>>2];f[q+4>>2]=f[e+4>>2];f[q+8>>2]=f[e+8>>2];f[q+12>>2]=f[e+12>>2];f[q+16>>2]=f[e+16>>2];f[q+20>>2]=f[e+20>>2];f[q+24>>2]=f[e+24>>2];f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=S;f[R>>2]=o;S=f[f[b>>2]>>2]|0;if(!S)T=o;else{f[b>>2]=S;T=f[R>>2]|0}mP(f[b+4>>2]|0,T);T=b+8|0;f[T>>2]=(f[T>>2]|0)+1}}else TRb(b,c,p+24|0);p=f[h>>2]|0;if(!p){u=d;return}else{U=h;V=p}e:while(1){b=V;while(1){if((f[b+16>>2]|0)>=(c|0))break;T=f[b+4>>2]|0;if(!T){W=U;break e}else b=T}V=f[b>>2]|0;if(!V){W=b;break}else U=b}if((W|0)==(h|0)){u=d;return}if((f[W+16>>2]|0)>(c|0)){u=d;return}c=f[W+4>>2]|0;if(!c){h=W+8|0;U=f[h>>2]|0;if((f[U>>2]|0)==(W|0))X=U;else{U=h;do{h=f[U>>2]|0;U=h+8|0;V=f[U>>2]|0}while((f[V>>2]|0)!=(h|0));X=V}}else{U=c;while(1){c=f[U>>2]|0;if(!c)break;else U=c}X=U}if((f[a>>2]|0)==(W|0))f[a>>2]=X;X=a+8|0;f[X>>2]=(f[X>>2]|0)+-1;wwa(p,W);O5b(W);u=d;return}function WRb(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=f[a>>2]|0;d=a+4|0;if((c|0)==(d|0)){e=1;return e|0}else g=c;a:while(1){c=g+16|0;a=g+24|0;b:do if((f[135848+(h[g+32>>0]<<2)>>2]|0)==10){if(b[c+17>>0]|0){i=f[a>>2]|0;if((f[i+4>>2]|0)>0){j=0;k=i}else break;while(1){i=f[(f[k+12>>2]|0)+4+(j<<2)>>2]|0;j=j+1|0;if(!(di[f[(f[i>>2]|0)+32>>2]&1023](i)|0)){e=0;l=17;break a}k=f[a>>2]|0;if((j|0)>=(f[k+4>>2]|0))break b}}i=b[c+18>>0]|0;if(!(i&1)){m=f[a>>2]|0;n=f[m>>2]|0;if(!(i&16))if(di[f[n+32>>2]&1023](m)|0)break;else{e=0;l=17;break a}else if(di[f[n+36>>2]&1023](m)|0)break;else{e=0;l=17;break a}}}while(0);a=f[g+4>>2]|0;if(!a){c=g+8|0;m=f[c>>2]|0;if((f[m>>2]|0)==(g|0))o=m;else{m=c;do{c=f[m>>2]|0;m=c+8|0;n=f[m>>2]|0}while((f[n>>2]|0)!=(c|0));o=n}}else{m=a;while(1){n=f[m>>2]|0;if(!n)break;else m=n}o=m}if((o|0)==(d|0)){e=1;l=17;break}else g=o}if((l|0)==17)return e|0;return 0}function XRb(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0;a=u;u=u+32|0;j=a;k=a+24|0;if(!(li[f[(f[e>>2]|0)+8>>2]&511](e,d,g)|0)){l=0;u=a;return l|0}d=f[135924+(h[g>>0]<<2)>>2]|0;b[i>>0]=0;do if((c|0)==2&(b[g+1>>0]|0)!=0){if(d>>>0>=6){zpb(j,3,477758,74);xpb(k,vpb(j,478311)|0);Apb(j);break}if(35>>>(d&63)&1){b[i>>0]=1;l=1;u=a;return l|0}}while(0);l=(d|0)==(c|0);u=a;return l|0}function YRb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=u;u=u+32|0;i=h+16|0;j=h;k=c>>>3;if(XRb(0,c&7,k,e,j,i)|0){l=ZRb(a,k,(b[i>>0]|0)!=0,j,d,g)|0;u=h;return l|0}else{l=li[f[(f[g>>2]|0)+8>>2]&511](g,d,c)|0;u=h;return l|0}return 0}function ZRb(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0.0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0;j=u;u=u+80|0;k=j+8|0;l=j+40|0;m=j+64|0;o=j;a:do if(d){q=f[g>>2]|0;r=g+4|0;if(q>>>0<(f[r>>2]|0)>>>0){t=b[q>>0]|0;v=t&255;if(t<<24>>24>-1){f[g>>2]=q+1;w=v}else{x=v;y=5}}else{x=0;y=5}if((y|0)==5){v=Knb(g,x)|0;q=J;if((q|0)>-1|(q|0)==-1&v>>>0>4294967295)w=v;else{z=0;u=j;return z|0}}v=Gnb(g,w)|0;b:do switch(b[e>>0]|0){case 5:{if((Qnb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){A=f[g>>2]|0;if(A>>>0<(f[r>>2]|0)>>>0){B=b[A>>0]|0;C=B&255;if(B<<24>>24>-1){f[g>>2]=A+1;D=C}else{E=C;y=38}}else{E=0;y=38}if((y|0)==38){y=0;C=Knb(g,E)|0;A=J;if((A|0)>-1|(A|0)==-1&C>>>0>4294967295)D=C;else{z=0;break}}FQb(a,c,5,(b[q>>0]|0)!=0,D,f[t>>2]|0);if((Qnb(g)|0)<=0)break b}u=j;return z|0}break}case 3:{if((Qnb(g)|0)>0){t=e+2|0;q=e+12|0;C=k+8|0;while(1){A=f[g>>2]|0;if(A>>>0<(f[r>>2]|0)>>>0?(B=b[A>>0]|0,B<<24>>24>-1):0){f[g>>2]=A+1;F=B&255;G=0}else{Lnb(k,g);B=k;if(!(b[C>>0]|0)){z=0;break}else{F=f[B>>2]|0;G=f[B+4>>2]|0}}MQb(a,c,3,(b[t>>0]|0)!=0,F,G,f[q>>2]|0);if((Qnb(g)|0)<=0)break b}u=j;return z|0}break}case 13:{if((Qnb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){C=f[g>>2]|0;if(C>>>0<(f[r>>2]|0)>>>0){B=b[C>>0]|0;A=B&255;if(B<<24>>24>-1){f[g>>2]=C+1;H=A}else{I=A;y=48}}else{I=0;y=48}if((y|0)==48){y=0;A=Knb(g,I)|0;C=J;if((C|0)>-1|(C|0)==-1&A>>>0>4294967295)H=A;else{z=0;break}}TQb(a,c,13,(b[q>>0]|0)!=0,H,f[t>>2]|0);if((Qnb(g)|0)<=0)break b}u=j;return z|0}break}case 4:{if((Qnb(g)|0)>0){t=e+2|0;q=e+12|0;A=k+8|0;while(1){C=f[g>>2]|0;if(C>>>0<(f[r>>2]|0)>>>0?(B=b[C>>0]|0,B<<24>>24>-1):0){f[g>>2]=C+1;K=B&255;L=0}else{Lnb(k,g);B=k;if(!(b[A>>0]|0)){z=0;break}else{K=f[B>>2]|0;L=f[B+4>>2]|0}}_Qb(a,c,4,(b[t>>0]|0)!=0,K,L,f[q>>2]|0);if((Qnb(g)|0)<=0)break b}u=j;return z|0}break}case 17:{if((Qnb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){A=f[g>>2]|0;if(A>>>0<(f[r>>2]|0)>>>0){B=b[A>>0]|0;C=B&255;if(B<<24>>24>-1){f[g>>2]=A+1;M=C>>>1^0-(C&1)}else{N=C;y=58}}else{N=0;y=58}if((y|0)==58){y=0;C=Knb(g,N)|0;A=J;if((A|0)>-1|(A|0)==-1&C>>>0>4294967295)M=C>>>1^0-(C&1);else{z=0;break}}FQb(a,c,17,(b[q>>0]|0)!=0,M,f[t>>2]|0);if((Qnb(g)|0)<=0)break b}u=j;return z|0}break}case 18:{if((Qnb(g)|0)>0){t=e+2|0;q=e+12|0;C=k+8|0;while(1){A=f[g>>2]|0;if(A>>>0<(f[r>>2]|0)>>>0?(B=b[A>>0]|0,B<<24>>24>-1):0){O=B&255;f[g>>2]=A+1;A=Sac(O|0,0,1)|0;B=J;P=Jac(0,0,O&1|0,0)|0;Q=A^P;R=B^J}else{Lnb(k,g);B=k;P=f[B>>2]|0;A=(b[C>>0]|0)==0;O=Sac(P|0,f[B+4>>2]|0,1)|0;B=J;S=Jac(0,0,P&1|0,0)|0;if(A){z=0;break}else{Q=O^S;R=B^J}}MQb(a,c,18,(b[t>>0]|0)!=0,Q,R,f[q>>2]|0);if((Qnb(g)|0)<=0)break b}u=j;return z|0}break}case 7:{if((Qnb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){C=f[g>>2]|0;if(((f[r>>2]|0)-C|0)>3){B=C;S=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[k>>2]=S;f[g>>2]=C+4;T=S}else{if(!(Xnb(g,k)|0))break;T=f[k>>2]|0}TQb(a,c,7,(b[q>>0]|0)!=0,T,f[t>>2]|0);if((Qnb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 6:{if((Qnb(g)|0)>0){t=e+2|0;q=e+12|0;while(1){S=f[g>>2]|0;if(((f[r>>2]|0)-S|0)>7){C=S;B=C;O=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=C+4|0;C=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=k;f[B>>2]=O;f[B+4>>2]=C;f[g>>2]=S+8;U=O;V=C}else{if(!(Ynb(g,k)|0))break;C=k;U=f[C>>2]|0;V=f[C+4>>2]|0}_Qb(a,c,6,(b[t>>0]|0)!=0,U,V,f[q>>2]|0);if((Qnb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 15:{if((Qnb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){C=f[g>>2]|0;if(((f[r>>2]|0)-C|0)>3){O=C;S=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;f[k>>2]=S;f[g>>2]=C+4;W=S}else{if(!(Xnb(g,k)|0))break;W=f[k>>2]|0}FQb(a,c,15,(b[q>>0]|0)!=0,W,f[t>>2]|0);if((Qnb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 16:{if((Qnb(g)|0)>0){t=e+2|0;q=e+12|0;while(1){S=f[g>>2]|0;if(((f[r>>2]|0)-S|0)>7){C=S;O=C;B=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;O=C+4|0;C=h[O>>0]|h[O+1>>0]<<8|h[O+2>>0]<<16|h[O+3>>0]<<24;O=k;f[O>>2]=B;f[O+4>>2]=C;f[g>>2]=S+8;X=B;Y=C}else{if(!(Ynb(g,k)|0))break;C=k;X=f[C>>2]|0;Y=f[C+4>>2]|0}MQb(a,c,16,(b[t>>0]|0)!=0,X,Y,f[q>>2]|0);if((Qnb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 2:{if((Qnb(g)|0)>0){q=e+2|0;t=e+12|0;while(1){C=f[g>>2]|0;if(((f[r>>2]|0)-C|0)>3){B=C;S=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;f[k>>2]=S;f[g>>2]=C+4;Z=S}else{if(!(Xnb(g,k)|0))break;Z=f[k>>2]|0}fRb(a,c,2,(b[q>>0]|0)!=0,(f[s>>2]=Z,+n[s>>2]),f[t>>2]|0);if((Qnb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 1:{if((Qnb(g)|0)>0){t=e+2|0;q=e+12|0;while(1){S=f[g>>2]|0;if(((f[r>>2]|0)-S|0)>7){C=S;B=C;O=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=C+4|0;C=h[B>>0]|h[B+1>>0]<<8|h[B+2>>0]<<16|h[B+3>>0]<<24;B=k;f[B>>2]=O;f[B+4>>2]=C;f[g>>2]=S+8;f[s>>2]=O;f[s+4>>2]=C;_=+p[s>>3]}else{if(!(Ynb(g,k)|0))break;_=+p[k>>3]}mRb(a,c,1,(b[t>>0]|0)!=0,_,f[q>>2]|0);if((Qnb(g)|0)<=0)break b}z=0;u=j;return z|0}break}case 8:{if((Qnb(g)|0)>0){q=e+2|0;t=e+12|0;C=k+8|0;while(1){O=f[g>>2]|0;if(O>>>0<(f[r>>2]|0)>>>0?(S=b[O>>0]|0,S<<24>>24>-1):0){f[g>>2]=O+1;$=S<<24>>24!=0}else{Lnb(k,g);S=k;if(!(b[C>>0]|0)){z=0;break}else $=(f[S>>2]|0)!=0|(f[S+4>>2]|0)!=0}tRb(a,c,8,(b[q>>0]|0)!=0,$,f[t>>2]|0);if((Qnb(g)|0)<=0)break b}u=j;return z|0}break}case 14:{if((Qnb(g)|0)>0){t=e+4|0;q=e+8|0;C=e+2|0;S=e+12|0;while(1){O=f[g>>2]|0;if(O>>>0<(f[r>>2]|0)>>>0){B=b[O>>0]|0;A=B&255;if(B<<24>>24>-1){f[g>>2]=O+1;aa=A}else{ba=A;y=109}}else{ba=0;y=109}if((y|0)==109){y=0;A=Knb(g,ba)|0;O=J;if((O|0)>-1|(O|0)==-1&A>>>0>4294967295)aa=A;else{z=0;break}}if(Uh[f[t>>2]&1023](f[q>>2]|0,aa)|0)DRb(a,c,14,(b[C>>0]|0)!=0,aa,f[S>>2]|0);else _h[f[(f[i>>2]|0)+16>>2]&255](i,c,aa);if((Qnb(g)|0)<=0)break b}u=j;return z|0}break}case 11:case 10:case 12:case 9:{zpb(l,3,477758,1221);xpb(m,vpb(l,478329)|0);Apb(l);break}default:{}}while(0);Hnb(g,v)}else do switch(b[e>>0]|0){case 5:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0){S=b[r>>0]|0;C=S&255;if(S<<24>>24>-1){f[g>>2]=r+1;ca=C}else{da=C;y=120}}else{da=0;y=120}if((y|0)==120){C=Knb(g,da)|0;r=J;if((r|0)>-1|(r|0)==-1&C>>>0>4294967295)ca=C;else{z=0;u=j;return z|0}}C=f[e+12>>2]|0;if(b[e+1>>0]|0){FQb(a,c,5,(b[e+2>>0]|0)!=0,ca,C);break a}r=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;r=a+4|0;S=f[r>>2]|0;do if(S){q=a+4|0;t=S;while(1){A=f[t+16>>2]|0;if((A|0)>(c|0)){O=f[t>>2]|0;if(!O){y=127;break}else{ea=t;fa=O}}else{if((A|0)>=(c|0)){y=132;break}ga=t+4|0;A=f[ga>>2]|0;if(!A){y=131;break}else{ea=ga;fa=A}}q=ea;t=fa}if((y|0)==127){ha=t;ia=t;break}else if((y|0)==131){ha=ga;ia=t;break}else if((y|0)==132){ha=q;ia=t;break}}else{ha=r;ia=r}while(0);r=f[ha>>2]|0;if(!r){S=L5b(48)|0;f[S+16>>2]=c;A=S+20|0;f[A>>2]=f[k>>2];f[A+4>>2]=f[k+4>>2];f[A+8>>2]=f[k+8>>2];f[A+12>>2]=f[k+12>>2];f[A+16>>2]=f[k+16>>2];f[A+20>>2]=f[k+20>>2];f[A+24>>2]=f[k+24>>2];f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=ia;f[ha>>2]=S;A=f[f[a>>2]>>2]|0;if(!A)ja=S;else{f[a>>2]=A;ja=f[ha>>2]|0}mP(f[a+4>>2]|0,ja);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[S+40>>2]=C;b[S+32>>0]=5;b[S+33>>0]=0;ka=S+24|0}else{f[r+40>>2]=C;ka=r+24|0}r=ka+10|0;b[r>>0]=b[r>>0]&-16;f[ka>>2]=ca;break a;break}case 3:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0?(S=b[r>>0]|0,S<<24>>24>-1):0){f[g>>2]=r+1;la=S&255;ma=0}else{Lnb(k,g);S=k;if(!(b[k+8>>0]|0)){z=0;u=j;return z|0}else{la=f[S>>2]|0;ma=f[S+4>>2]|0}}S=f[e+12>>2]|0;if(b[e+1>>0]|0){MQb(a,c,3,(b[e+2>>0]|0)!=0,la,ma,S);break a}r=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;r=a+4|0;A=f[r>>2]|0;do if(A){O=a+4|0;B=A;while(1){P=f[B+16>>2]|0;if((P|0)>(c|0)){na=f[B>>2]|0;if(!na){y=150;break}else{oa=B;pa=na}}else{if((P|0)>=(c|0)){y=155;break}qa=B+4|0;P=f[qa>>2]|0;if(!P){y=154;break}else{oa=qa;pa=P}}O=oa;B=pa}if((y|0)==150){ra=B;sa=B;break}else if((y|0)==154){ra=qa;sa=B;break}else if((y|0)==155){ra=O;sa=B;break}}else{ra=r;sa=r}while(0);r=f[ra>>2]|0;if(!r){A=L5b(48)|0;f[A+16>>2]=c;C=A+20|0;f[C>>2]=f[k>>2];f[C+4>>2]=f[k+4>>2];f[C+8>>2]=f[k+8>>2];f[C+12>>2]=f[k+12>>2];f[C+16>>2]=f[k+16>>2];f[C+20>>2]=f[k+20>>2];f[C+24>>2]=f[k+24>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=sa;f[ra>>2]=A;C=f[f[a>>2]>>2]|0;if(!C)ta=A;else{f[a>>2]=C;ta=f[ra>>2]|0}mP(f[a+4>>2]|0,ta);C=a+8|0;f[C>>2]=(f[C>>2]|0)+1;f[A+40>>2]=S;b[A+32>>0]=3;b[A+33>>0]=0;ua=A+24|0}else{f[r+40>>2]=S;ua=r+24|0}r=ua+10|0;b[r>>0]=b[r>>0]&-16;r=ua;f[r>>2]=la;f[r+4>>2]=ma;break a;break}case 13:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0){A=b[r>>0]|0;C=A&255;if(A<<24>>24>-1){f[g>>2]=r+1;va=C}else{wa=C;y=166}}else{wa=0;y=166}if((y|0)==166){C=Knb(g,wa)|0;r=J;if((r|0)>-1|(r|0)==-1&C>>>0>4294967295)va=C;else{z=0;u=j;return z|0}}C=f[e+12>>2]|0;if(b[e+1>>0]|0){TQb(a,c,13,(b[e+2>>0]|0)!=0,va,C);break a}r=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;r=a+4|0;A=f[r>>2]|0;do if(A){t=a+4|0;q=A;while(1){P=f[q+16>>2]|0;if((P|0)>(c|0)){na=f[q>>2]|0;if(!na){y=173;break}else{xa=q;ya=na}}else{if((P|0)>=(c|0)){y=178;break}za=q+4|0;P=f[za>>2]|0;if(!P){y=177;break}else{xa=za;ya=P}}t=xa;q=ya}if((y|0)==173){Aa=q;Ba=q;break}else if((y|0)==177){Aa=za;Ba=q;break}else if((y|0)==178){Aa=t;Ba=q;break}}else{Aa=r;Ba=r}while(0);r=f[Aa>>2]|0;if(!r){A=L5b(48)|0;f[A+16>>2]=c;S=A+20|0;f[S>>2]=f[k>>2];f[S+4>>2]=f[k+4>>2];f[S+8>>2]=f[k+8>>2];f[S+12>>2]=f[k+12>>2];f[S+16>>2]=f[k+16>>2];f[S+20>>2]=f[k+20>>2];f[S+24>>2]=f[k+24>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=Ba;f[Aa>>2]=A;S=f[f[a>>2]>>2]|0;if(!S)Ca=A;else{f[a>>2]=S;Ca=f[Aa>>2]|0}mP(f[a+4>>2]|0,Ca);S=a+8|0;f[S>>2]=(f[S>>2]|0)+1;f[A+40>>2]=C;b[A+32>>0]=13;b[A+33>>0]=0;Da=A+24|0}else{f[r+40>>2]=C;Da=r+24|0}r=Da+10|0;b[r>>0]=b[r>>0]&-16;f[Da>>2]=va;break a;break}case 4:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0?(A=b[r>>0]|0,A<<24>>24>-1):0){f[g>>2]=r+1;Ea=A&255;Fa=0}else{Lnb(k,g);A=k;if(!(b[k+8>>0]|0)){z=0;u=j;return z|0}else{Ea=f[A>>2]|0;Fa=f[A+4>>2]|0}}A=f[e+12>>2]|0;if(b[e+1>>0]|0){_Qb(a,c,4,(b[e+2>>0]|0)!=0,Ea,Fa,A);break a}r=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;r=a+4|0;S=f[r>>2]|0;do if(S){B=a+4|0;O=S;while(1){P=f[O+16>>2]|0;if((P|0)>(c|0)){na=f[O>>2]|0;if(!na){y=196;break}else{Ga=O;Ha=na}}else{if((P|0)>=(c|0)){y=201;break}Ia=O+4|0;P=f[Ia>>2]|0;if(!P){y=200;break}else{Ga=Ia;Ha=P}}B=Ga;O=Ha}if((y|0)==196){Ja=O;Ka=O;break}else if((y|0)==200){Ja=Ia;Ka=O;break}else if((y|0)==201){Ja=B;Ka=O;break}}else{Ja=r;Ka=r}while(0);r=f[Ja>>2]|0;if(!r){S=L5b(48)|0;f[S+16>>2]=c;C=S+20|0;f[C>>2]=f[k>>2];f[C+4>>2]=f[k+4>>2];f[C+8>>2]=f[k+8>>2];f[C+12>>2]=f[k+12>>2];f[C+16>>2]=f[k+16>>2];f[C+20>>2]=f[k+20>>2];f[C+24>>2]=f[k+24>>2];f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=Ka;f[Ja>>2]=S;C=f[f[a>>2]>>2]|0;if(!C)La=S;else{f[a>>2]=C;La=f[Ja>>2]|0}mP(f[a+4>>2]|0,La);C=a+8|0;f[C>>2]=(f[C>>2]|0)+1;f[S+40>>2]=A;b[S+32>>0]=4;b[S+33>>0]=0;Ma=S+24|0}else{f[r+40>>2]=A;Ma=r+24|0}r=Ma+10|0;b[r>>0]=b[r>>0]&-16;r=Ma;f[r>>2]=Ea;f[r+4>>2]=Fa;break a;break}case 17:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0){S=b[r>>0]|0;C=S&255;if(S<<24>>24>-1){f[g>>2]=r+1;Na=C>>>1^0-(C&1)}else{Oa=C;y=212}}else{Oa=0;y=212}if((y|0)==212){C=Knb(g,Oa)|0;r=J;if((r|0)>-1|(r|0)==-1&C>>>0>4294967295)Na=C>>>1^0-(C&1);else{z=0;u=j;return z|0}}C=f[e+12>>2]|0;if(b[e+1>>0]|0){FQb(a,c,17,(b[e+2>>0]|0)!=0,Na,C);break a}r=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;r=a+4|0;S=f[r>>2]|0;do if(S){q=a+4|0;t=S;while(1){P=f[t+16>>2]|0;if((P|0)>(c|0)){na=f[t>>2]|0;if(!na){y=219;break}else{Pa=t;Qa=na}}else{if((P|0)>=(c|0)){y=224;break}Ra=t+4|0;P=f[Ra>>2]|0;if(!P){y=223;break}else{Pa=Ra;Qa=P}}q=Pa;t=Qa}if((y|0)==219){Sa=t;Ta=t;break}else if((y|0)==223){Sa=Ra;Ta=t;break}else if((y|0)==224){Sa=q;Ta=t;break}}else{Sa=r;Ta=r}while(0);r=f[Sa>>2]|0;if(!r){S=L5b(48)|0;f[S+16>>2]=c;A=S+20|0;f[A>>2]=f[k>>2];f[A+4>>2]=f[k+4>>2];f[A+8>>2]=f[k+8>>2];f[A+12>>2]=f[k+12>>2];f[A+16>>2]=f[k+16>>2];f[A+20>>2]=f[k+20>>2];f[A+24>>2]=f[k+24>>2];f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=Ta;f[Sa>>2]=S;A=f[f[a>>2]>>2]|0;if(!A)Ua=S;else{f[a>>2]=A;Ua=f[Sa>>2]|0}mP(f[a+4>>2]|0,Ua);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[S+40>>2]=C;b[S+32>>0]=17;b[S+33>>0]=0;Va=S+24|0}else{f[r+40>>2]=C;Va=r+24|0}r=Va+10|0;b[r>>0]=b[r>>0]&-16;f[Va>>2]=Na;break a;break}case 18:{r=f[g>>2]|0;if(r>>>0<(f[g+4>>2]|0)>>>0?(S=b[r>>0]|0,S<<24>>24>-1):0){A=S&255;f[g>>2]=r+1;r=Sac(A|0,0,1)|0;S=J;O=Jac(0,0,A&1|0,0)|0;Wa=r^O;Xa=S^J}else{Lnb(k,g);S=k;O=f[S>>2]|0;r=(b[k+8>>0]|0)==0;A=Sac(O|0,f[S+4>>2]|0,1)|0;S=J;B=Jac(0,0,O&1|0,0)|0;O=S^J;if(r){z=0;u=j;return z|0}else{Wa=A^B;Xa=O}}O=f[e+12>>2]|0;if(b[e+1>>0]|0){MQb(a,c,18,(b[e+2>>0]|0)!=0,Wa,Xa,O);break a}B=k+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;B=a+4|0;A=f[B>>2]|0;do if(A){r=a+4|0;S=A;while(1){P=f[S+16>>2]|0;if((P|0)>(c|0)){na=f[S>>2]|0;if(!na){y=242;break}else{Ya=S;Za=na}}else{if((P|0)>=(c|0)){y=247;break}_a=S+4|0;P=f[_a>>2]|0;if(!P){y=246;break}else{Ya=_a;Za=P}}r=Ya;S=Za}if((y|0)==242){$a=S;ab=S;break}else if((y|0)==246){$a=_a;ab=S;break}else if((y|0)==247){$a=r;ab=S;break}}else{$a=B;ab=B}while(0);B=f[$a>>2]|0;if(!B){A=L5b(48)|0;f[A+16>>2]=c;C=A+20|0;f[C>>2]=f[k>>2];f[C+4>>2]=f[k+4>>2];f[C+8>>2]=f[k+8>>2];f[C+12>>2]=f[k+12>>2];f[C+16>>2]=f[k+16>>2];f[C+20>>2]=f[k+20>>2];f[C+24>>2]=f[k+24>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=ab;f[$a>>2]=A;C=f[f[a>>2]>>2]|0;if(!C)bb=A;else{f[a>>2]=C;bb=f[$a>>2]|0}mP(f[a+4>>2]|0,bb);C=a+8|0;f[C>>2]=(f[C>>2]|0)+1;f[A+40>>2]=O;b[A+32>>0]=18;b[A+33>>0]=0;cb=A+24|0}else{f[B+40>>2]=O;cb=B+24|0}B=cb+10|0;b[B>>0]=b[B>>0]&-16;B=cb;f[B>>2]=Wa;f[B+4>>2]=Xa;break a;break}case 7:{B=f[g>>2]|0;do if(((f[g+4>>2]|0)-B|0)>3){A=B;C=h[A>>0]|h[A+1>>0]<<8|h[A+2>>0]<<16|h[A+3>>0]<<24;f[o>>2]=C;f[g>>2]=B+4;db=C}else{if(Xnb(g,o)|0){db=f[o>>2]|0;break}z=0;u=j;return z|0}while(0);B=f[e+12>>2]|0;if(!(b[e+1>>0]|0)){O=k+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;f[O+16>>2]=0;f[O+20>>2]=0;O=a+4|0;C=f[O>>2]|0;do if(C){A=a+4|0;t=C;while(1){q=f[t+16>>2]|0;if((q|0)>(c|0)){P=f[t>>2]|0;if(!P){y=265;break}else{eb=t;fb=P}}else{if((q|0)>=(c|0)){y=270;break}gb=t+4|0;q=f[gb>>2]|0;if(!q){y=269;break}else{eb=gb;fb=q}}A=eb;t=fb}if((y|0)==265){hb=t;ib=t;break}else if((y|0)==269){hb=gb;ib=t;break}else if((y|0)==270){hb=A;ib=t;break}}else{hb=O;ib=O}while(0);O=f[hb>>2]|0;if(!O){C=L5b(48)|0;f[C+16>>2]=c;S=C+20|0;f[S>>2]=f[k>>2];f[S+4>>2]=f[k+4>>2];f[S+8>>2]=f[k+8>>2];f[S+12>>2]=f[k+12>>2];f[S+16>>2]=f[k+16>>2];f[S+20>>2]=f[k+20>>2];f[S+24>>2]=f[k+24>>2];f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=ib;f[hb>>2]=C;S=f[f[a>>2]>>2]|0;if(!S)jb=C;else{f[a>>2]=S;jb=f[hb>>2]|0}mP(f[a+4>>2]|0,jb);S=a+8|0;f[S>>2]=(f[S>>2]|0)+1;f[C+40>>2]=B;b[C+32>>0]=7;b[C+33>>0]=0;kb=C+24|0}else{f[O+40>>2]=B;kb=O+24|0}O=kb+10|0;b[O>>0]=b[O>>0]&-16;f[kb>>2]=db}else TQb(a,c,7,(b[e+2>>0]|0)!=0,db,B);break a;break}case 6:{O=f[g>>2]|0;do if(((f[g+4>>2]|0)-O|0)>7){C=O;S=C;r=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;S=C+4|0;C=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;S=o;f[S>>2]=r;f[S+4>>2]=C;f[g>>2]=O+8;lb=r;mb=C}else{if(Ynb(g,o)|0){C=o;lb=f[C>>2]|0;mb=f[C+4>>2]|0;break}z=0;u=j;return z|0}while(0);O=f[e+12>>2]|0;if(!(b[e+1>>0]|0)){B=k+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;B=a+4|0;C=f[B>>2]|0;do if(C){r=a+4|0;S=C;while(1){q=f[S+16>>2]|0;if((q|0)>(c|0)){P=f[S>>2]|0;if(!P){y=289;break}else{nb=S;ob=P}}else{if((q|0)>=(c|0)){y=294;break}pb=S+4|0;q=f[pb>>2]|0;if(!q){y=293;break}else{nb=pb;ob=q}}r=nb;S=ob}if((y|0)==289){qb=S;rb=S;break}else if((y|0)==293){qb=pb;rb=S;break}else if((y|0)==294){qb=r;rb=S;break}}else{qb=B;rb=B}while(0);B=f[qb>>2]|0;if(!B){C=L5b(48)|0;f[C+16>>2]=c;t=C+20|0;f[t>>2]=f[k>>2];f[t+4>>2]=f[k+4>>2];f[t+8>>2]=f[k+8>>2];f[t+12>>2]=f[k+12>>2];f[t+16>>2]=f[k+16>>2];f[t+20>>2]=f[k+20>>2];f[t+24>>2]=f[k+24>>2];f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=rb;f[qb>>2]=C;t=f[f[a>>2]>>2]|0;if(!t)sb=C;else{f[a>>2]=t;sb=f[qb>>2]|0}mP(f[a+4>>2]|0,sb);t=a+8|0;f[t>>2]=(f[t>>2]|0)+1;f[C+40>>2]=O;b[C+32>>0]=6;b[C+33>>0]=0;tb=C+24|0}else{f[B+40>>2]=O;tb=B+24|0}B=tb+10|0;b[B>>0]=b[B>>0]&-16;B=tb;f[B>>2]=lb;f[B+4>>2]=mb}else _Qb(a,c,6,(b[e+2>>0]|0)!=0,lb,mb,O);break a;break}case 15:{B=f[g>>2]|0;do if(((f[g+4>>2]|0)-B|0)>3){C=B;t=h[C>>0]|h[C+1>>0]<<8|h[C+2>>0]<<16|h[C+3>>0]<<24;f[k>>2]=t;f[g>>2]=B+4;ub=t}else{if(Xnb(g,k)|0){ub=f[k>>2]|0;break}z=0;u=j;return z|0}while(0);B=f[e+12>>2]|0;if(b[e+1>>0]|0){FQb(a,c,15,(b[e+2>>0]|0)!=0,ub,B);break a}O=k+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;f[O+16>>2]=0;f[O+20>>2]=0;O=a+4|0;t=f[O>>2]|0;do if(t){C=a+4|0;A=t;while(1){q=f[A+16>>2]|0;if((q|0)>(c|0)){P=f[A>>2]|0;if(!P){y=313;break}else{vb=A;wb=P}}else{if((q|0)>=(c|0)){y=318;break}xb=A+4|0;q=f[xb>>2]|0;if(!q){y=317;break}else{vb=xb;wb=q}}C=vb;A=wb}if((y|0)==313){yb=A;zb=A;break}else if((y|0)==317){yb=xb;zb=A;break}else if((y|0)==318){yb=C;zb=A;break}}else{yb=O;zb=O}while(0);O=f[yb>>2]|0;if(!O){t=L5b(48)|0;f[t+16>>2]=c;S=t+20|0;f[S>>2]=f[k>>2];f[S+4>>2]=f[k+4>>2];f[S+8>>2]=f[k+8>>2];f[S+12>>2]=f[k+12>>2];f[S+16>>2]=f[k+16>>2];f[S+20>>2]=f[k+20>>2];f[S+24>>2]=f[k+24>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=zb;f[yb>>2]=t;S=f[f[a>>2]>>2]|0;if(!S)Ab=t;else{f[a>>2]=S;Ab=f[yb>>2]|0}mP(f[a+4>>2]|0,Ab);S=a+8|0;f[S>>2]=(f[S>>2]|0)+1;f[t+40>>2]=B;b[t+32>>0]=15;b[t+33>>0]=0;Bb=t+24|0}else{f[O+40>>2]=B;Bb=O+24|0}O=Bb+10|0;b[O>>0]=b[O>>0]&-16;f[Bb>>2]=ub;break a;break}case 16:{O=f[g>>2]|0;do if(((f[g+4>>2]|0)-O|0)>7){t=O;S=t;r=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;S=t+4|0;t=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;S=k;f[S>>2]=r;f[S+4>>2]=t;f[g>>2]=O+8;Cb=r;Db=t}else{if(Ynb(g,k)|0){t=k;Cb=f[t>>2]|0;Db=f[t+4>>2]|0;break}z=0;u=j;return z|0}while(0);O=f[e+12>>2]|0;if(b[e+1>>0]|0){MQb(a,c,16,(b[e+2>>0]|0)!=0,Cb,Db,O);break a}B=k+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;B=a+4|0;t=f[B>>2]|0;do if(t){r=a+4|0;S=t;while(1){q=f[S+16>>2]|0;if((q|0)>(c|0)){P=f[S>>2]|0;if(!P){y=336;break}else{Eb=S;Fb=P}}else{if((q|0)>=(c|0)){y=341;break}Gb=S+4|0;q=f[Gb>>2]|0;if(!q){y=340;break}else{Eb=Gb;Fb=q}}r=Eb;S=Fb}if((y|0)==336){Hb=S;Ib=S;break}else if((y|0)==340){Hb=Gb;Ib=S;break}else if((y|0)==341){Hb=r;Ib=S;break}}else{Hb=B;Ib=B}while(0);B=f[Hb>>2]|0;if(!B){t=L5b(48)|0;f[t+16>>2]=c;A=t+20|0;f[A>>2]=f[k>>2];f[A+4>>2]=f[k+4>>2];f[A+8>>2]=f[k+8>>2];f[A+12>>2]=f[k+12>>2];f[A+16>>2]=f[k+16>>2];f[A+20>>2]=f[k+20>>2];f[A+24>>2]=f[k+24>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=Ib;f[Hb>>2]=t;A=f[f[a>>2]>>2]|0;if(!A)Jb=t;else{f[a>>2]=A;Jb=f[Hb>>2]|0}mP(f[a+4>>2]|0,Jb);A=a+8|0;f[A>>2]=(f[A>>2]|0)+1;f[t+40>>2]=O;b[t+32>>0]=16;b[t+33>>0]=0;Kb=t+24|0}else{f[B+40>>2]=O;Kb=B+24|0}B=Kb+10|0;b[B>>0]=b[B>>0]&-16;B=Kb;f[B>>2]=Cb;f[B+4>>2]=Db;break a;break}case 2:{B=f[g>>2]|0;do if(((f[g+4>>2]|0)-B|0)>3){t=B;A=h[t>>0]|h[t+1>>0]<<8|h[t+2>>0]<<16|h[t+3>>0]<<24;f[k>>2]=A;f[g>>2]=B+4;Lb=A}else{if(Xnb(g,k)|0){Lb=f[k>>2]|0;break}z=0;u=j;return z|0}while(0);B=f[e+12>>2]|0;if(b[e+1>>0]|0){fRb(a,c,2,(b[e+2>>0]|0)!=0,(f[s>>2]=Lb,+n[s>>2]),B);break a}O=k+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;f[O+16>>2]=0;f[O+20>>2]=0;O=a+4|0;A=f[O>>2]|0;do if(A){t=a+4|0;C=A;while(1){q=f[C+16>>2]|0;if((q|0)>(c|0)){P=f[C>>2]|0;if(!P){y=359;break}else{Mb=C;Nb=P}}else{if((q|0)>=(c|0)){y=364;break}Ob=C+4|0;q=f[Ob>>2]|0;if(!q){y=363;break}else{Mb=Ob;Nb=q}}t=Mb;C=Nb}if((y|0)==359){Pb=C;Qb=C;break}else if((y|0)==363){Pb=Ob;Qb=C;break}else if((y|0)==364){Pb=t;Qb=C;break}}else{Pb=O;Qb=O}while(0);O=f[Pb>>2]|0;if(!O){A=L5b(48)|0;f[A+16>>2]=c;S=A+20|0;f[S>>2]=f[k>>2];f[S+4>>2]=f[k+4>>2];f[S+8>>2]=f[k+8>>2];f[S+12>>2]=f[k+12>>2];f[S+16>>2]=f[k+16>>2];f[S+20>>2]=f[k+20>>2];f[S+24>>2]=f[k+24>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=Qb;f[Pb>>2]=A;S=f[f[a>>2]>>2]|0;if(!S)Rb=A;else{f[a>>2]=S;Rb=f[Pb>>2]|0}mP(f[a+4>>2]|0,Rb);S=a+8|0;f[S>>2]=(f[S>>2]|0)+1;f[A+40>>2]=B;b[A+32>>0]=2;b[A+33>>0]=0;Sb=A+24|0}else{f[O+40>>2]=B;Sb=O+24|0}O=Sb+10|0;b[O>>0]=b[O>>0]&-16;f[Sb>>2]=Lb;break a;break}case 1:{O=f[g>>2]|0;do if(((f[g+4>>2]|0)-O|0)>7){A=O;S=A;r=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;S=A+4|0;A=h[S>>0]|h[S+1>>0]<<8|h[S+2>>0]<<16|h[S+3>>0]<<24;S=k;f[S>>2]=r;f[S+4>>2]=A;f[g>>2]=O+8;f[s>>2]=r;f[s+4>>2]=A;Tb=+p[s>>3]}else{if(Ynb(g,k)|0){Tb=+p[k>>3];break}z=0;u=j;return z|0}while(0);O=f[e+12>>2]|0;if(b[e+1>>0]|0){mRb(a,c,1,(b[e+2>>0]|0)!=0,Tb,O);break a}B=k+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;f[B+16>>2]=0;f[B+20>>2]=0;B=a+4|0;A=f[B>>2]|0;do if(A){r=a+4|0;S=A;while(1){q=f[S+16>>2]|0;if((q|0)>(c|0)){P=f[S>>2]|0;if(!P){y=382;break}else{Ub=S;Vb=P}}else{if((q|0)>=(c|0)){y=387;break}Wb=S+4|0;q=f[Wb>>2]|0;if(!q){y=386;break}else{Ub=Wb;Vb=q}}r=Ub;S=Vb}if((y|0)==382){Xb=S;Yb=S;break}else if((y|0)==386){Xb=Wb;Yb=S;break}else if((y|0)==387){Xb=r;Yb=S;break}}else{Xb=B;Yb=B}while(0);B=f[Xb>>2]|0;if(!B){A=L5b(48)|0;f[A+16>>2]=c;C=A+20|0;f[C>>2]=f[k>>2];f[C+4>>2]=f[k+4>>2];f[C+8>>2]=f[k+8>>2];f[C+12>>2]=f[k+12>>2];f[C+16>>2]=f[k+16>>2];f[C+20>>2]=f[k+20>>2];f[C+24>>2]=f[k+24>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=Yb;f[Xb>>2]=A;C=f[f[a>>2]>>2]|0;if(!C)Zb=A;else{f[a>>2]=C;Zb=f[Xb>>2]|0}mP(f[a+4>>2]|0,Zb);C=a+8|0;f[C>>2]=(f[C>>2]|0)+1;f[A+40>>2]=O;b[A+32>>0]=1;b[A+33>>0]=0;_b=A+24|0}else{f[B+40>>2]=O;_b=B+24|0}B=_b+10|0;b[B>>0]=b[B>>0]&-16;p[_b>>3]=Tb;break a;break}case 8:{B=f[g>>2]|0;if(B>>>0<(f[g+4>>2]|0)>>>0?(A=b[B>>0]|0,A<<24>>24>-1):0){f[g>>2]=B+1;$b=A<<24>>24!=0}else{Lnb(k,g);A=k;if(!(b[k+8>>0]|0)){z=0;u=j;return z|0}else $b=(f[A>>2]|0)!=0|(f[A+4>>2]|0)!=0}A=f[e+12>>2]|0;if(b[e+1>>0]|0){tRb(a,c,8,(b[e+2>>0]|0)!=0,$b,A);break a}B=$b&1;C=k+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;f[C+16>>2]=0;f[C+20>>2]=0;C=a+4|0;t=f[C>>2]|0;do if(t){q=a+4|0;P=t;while(1){na=f[P+16>>2]|0;if((na|0)>(c|0)){ac=f[P>>2]|0;if(!ac){y=405;break}else{bc=P;cc=ac}}else{if((na|0)>=(c|0)){y=410;break}dc=P+4|0;na=f[dc>>2]|0;if(!na){y=409;break}else{bc=dc;cc=na}}q=bc;P=cc}if((y|0)==405){ec=P;fc=P;break}else if((y|0)==409){ec=dc;fc=P;break}else if((y|0)==410){ec=q;fc=P;break}}else{ec=C;fc=C}while(0);C=f[ec>>2]|0;if(!C){t=L5b(48)|0;f[t+16>>2]=c;O=t+20|0;f[O>>2]=f[k>>2];f[O+4>>2]=f[k+4>>2];f[O+8>>2]=f[k+8>>2];f[O+12>>2]=f[k+12>>2];f[O+16>>2]=f[k+16>>2];f[O+20>>2]=f[k+20>>2];f[O+24>>2]=f[k+24>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=fc;f[ec>>2]=t;O=f[f[a>>2]>>2]|0;if(!O)gc=t;else{f[a>>2]=O;gc=f[ec>>2]|0}mP(f[a+4>>2]|0,gc);O=a+8|0;f[O>>2]=(f[O>>2]|0)+1;f[t+40>>2]=A;b[t+32>>0]=8;b[t+33>>0]=0;hc=t+24|0}else{f[C+40>>2]=A;hc=C+24|0}C=hc+10|0;b[C>>0]=b[C>>0]&-16;b[hc>>0]=B;break a;break}case 14:{C=f[g>>2]|0;if(C>>>0<(f[g+4>>2]|0)>>>0){t=b[C>>0]|0;O=t&255;if(t<<24>>24>-1){f[g>>2]=C+1;ic=O}else{jc=O;y=421}}else{jc=0;y=421}if((y|0)==421){O=Knb(g,jc)|0;C=J;if((C|0)>-1|(C|0)==-1&O>>>0>4294967295)ic=O;else{z=0;u=j;return z|0}}if(!(Uh[f[e+4>>2]&1023](f[e+8>>2]|0,ic)|0)){_h[f[(f[i>>2]|0)+16>>2]&255](i,c,ic);break a}O=f[e+12>>2]|0;if(b[e+1>>0]|0){DRb(a,c,14,(b[e+2>>0]|0)!=0,ic,O);break a}C=k+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;f[C+16>>2]=0;f[C+20>>2]=0;C=a+4|0;t=f[C>>2]|0;do if(t){S=a+4|0;r=t;while(1){na=f[r+16>>2]|0;if((na|0)>(c|0)){ac=f[r>>2]|0;if(!ac){y=430;break}else{kc=r;lc=ac}}else{if((na|0)>=(c|0)){y=435;break}mc=r+4|0;na=f[mc>>2]|0;if(!na){y=434;break}else{kc=mc;lc=na}}S=kc;r=lc}if((y|0)==430){nc=r;oc=r;break}else if((y|0)==434){nc=mc;oc=r;break}else if((y|0)==435){nc=S;oc=r;break}}else{nc=C;oc=C}while(0);C=f[nc>>2]|0;if(!C){t=L5b(48)|0;f[t+16>>2]=c;B=t+20|0;f[B>>2]=f[k>>2];f[B+4>>2]=f[k+4>>2];f[B+8>>2]=f[k+8>>2];f[B+12>>2]=f[k+12>>2];f[B+16>>2]=f[k+16>>2];f[B+20>>2]=f[k+20>>2];f[B+24>>2]=f[k+24>>2];f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=oc;f[nc>>2]=t;B=f[f[a>>2]>>2]|0;if(!B)pc=t;else{f[a>>2]=B;pc=f[nc>>2]|0}mP(f[a+4>>2]|0,pc);B=a+8|0;f[B>>2]=(f[B>>2]|0)+1;f[t+40>>2]=O;b[t+32>>0]=14;b[t+33>>0]=0;qc=t+24|0}else{f[C+40>>2]=O;qc=C+24|0}C=qc+10|0;b[C>>0]=b[C>>0]&-16;f[qc>>2]=ic;break a;break}case 9:{C=f[e+12>>2]|0;if(!(b[e+1>>0]|0))rc=FRb(a,c,9,C)|0;else rc=IRb(a,c,9,C)|0;if(fqb(g,rc)|0)break a;else z=0;u=j;return z|0}case 12:{C=f[e+12>>2]|0;if(!(b[e+1>>0]|0))sc=FRb(a,c,12,C)|0;else sc=IRb(a,c,12,C)|0;if(fqb(g,sc)|0)break a;else z=0;u=j;return z|0}case 10:{C=f[e+4>>2]|0;t=f[e+12>>2]|0;if(!(b[e+1>>0]|0))tc=JRb(a,c,10,C,t)|0;else tc=NRb(a,c,10,C,t)|0;t=g+44|0;C=f[t>>2]|0;f[t>>2]=C+-1;if((C|0)<=0){z=0;u=j;return z|0}if(!(Uh[f[(f[tc>>2]|0)+44>>2]&1023](tc,g)|0)){z=0;u=j;return z|0}C=f[t>>2]|0;if((C|0)<(f[g+48>>2]|0))f[t>>2]=C+1;if((f[g+20>>2]|0)==(c<<3|4|0))break a;else z=0;u=j;return z|0}case 11:{C=f[e+4>>2]|0;t=f[e+12>>2]|0;if(!(b[e+1>>0]|0))uc=JRb(a,c,11,C,t)|0;else uc=NRb(a,c,11,C,t)|0;t=f[g>>2]|0;if(t>>>0<(f[g+4>>2]|0)>>>0?(C=b[t>>0]|0,C<<24>>24>-1):0){f[g>>2]=t+1;vc=C&255}else{C=Znb(g)|0;if((C|0)>-1)vc=C;else{z=0;u=j;return z|0}}Inb(k,g,vc);if((f[k+4>>2]|0)>=0?Uh[f[(f[uc>>2]|0)+44>>2]&1023](uc,g)|0:0){if(Onb(g,f[k>>2]|0)|0)break a;else z=0;u=j;return z|0}z=0;u=j;return z|0}default:break a}while(0);while(0);z=1;u=j;return z|0}function _Rb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=a+4|0;a=f[e>>2]|0;if(!a)return;else{g=e;h=a}a:while(1){a=h;while(1){if((f[a+16>>2]|0)>=(b|0))break;i=f[a+4>>2]|0;if(!i){j=g;break a}else a=i}h=f[a>>2]|0;if(!h){j=a;break}else g=a}if((j|0)==(e|0))return;else k=j;while(1){j=f[k+16>>2]|0;if((j|0)>=(c|0)){l=14;break}$Rb(k+24|0,j,d);j=f[k+4>>2]|0;if(!j){g=k+8|0;h=f[g>>2]|0;if((f[h>>2]|0)==(k|0))m=h;else{h=g;do{g=f[h>>2]|0;h=g+8|0;b=f[h>>2]|0}while((f[b>>2]|0)!=(g|0));m=b}}else{h=j;while(1){a=f[h>>2]|0;if(!a)break;else h=a}m=h}if((m|0)==(e|0)){l=14;break}else k=m}if((l|0)==14)return}function $Rb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;e=u;u=u+32|0;g=e;h=e+24|0;if(!(b[a+9>>0]|0)){i=b[a+10>>0]|0;if(i&1){u=e;return}do switch(b[a+8>>0]|0){case 5:{Mpb(c,f[a>>2]|0,d);u=e;return}case 3:{j=a;Npb(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 13:{Opb(c,f[a>>2]|0,d);u=e;return}case 4:{j=a;Ppb(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 17:{Qpb(c,f[a>>2]|0,d);u=e;return}case 18:{j=a;Rpb(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 7:{Spb(c,f[a>>2]|0,d);u=e;return}case 6:{j=a;Tpb(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 15:{Upb(c,f[a>>2]|0,d);u=e;return}case 16:{j=a;Vpb(c,f[j>>2]|0,f[j+4>>2]|0,d);u=e;return}case 2:{Wpb(c,+n[a>>2],d);u=e;return}case 1:{Xpb(c,+p[a>>3],d);u=e;return}case 8:{Ypb(c,(b[a>>0]|0)!=0,d);u=e;return}case 9:{_pb(c,f[a>>2]|0,d);u=e;return}case 12:{aqb(c,f[a>>2]|0,d);u=e;return}case 14:{Zpb(c,f[a>>2]|0,d);u=e;return}case 10:{cqb(c,f[a>>2]|0,d);u=e;return}case 11:{j=f[a>>2]|0;if(!(i&16)){dqb(c,j,d);u=e;return}else{_h[f[(f[j>>2]|0)+60>>2]&255](j,c,d);u=e;return}break}default:{u=e;return}}while(0)}if(!(b[a+11>>0]|0))do switch(b[a+8>>0]|0){case 5:{i=f[a>>2]|0;if((f[i>>2]|0)>0){k=0;l=i}else{u=e;return}do{Mpb(c,f[(f[l+8>>2]|0)+4+(k<<2)>>2]|0,d);k=k+1|0;l=f[a>>2]|0}while((k|0)<(f[l>>2]|0));u=e;return}case 3:{i=f[a>>2]|0;if((f[i>>2]|0)>0){m=0;o=i}else{u=e;return}do{i=(f[o+8>>2]|0)+8+(m<<3)|0;Npb(c,f[i>>2]|0,f[i+4>>2]|0,d);m=m+1|0;o=f[a>>2]|0}while((m|0)<(f[o>>2]|0));u=e;return}case 13:{i=f[a>>2]|0;if((f[i>>2]|0)>0){q=0;r=i}else{u=e;return}do{Opb(c,f[(f[r+8>>2]|0)+4+(q<<2)>>2]|0,d);q=q+1|0;r=f[a>>2]|0}while((q|0)<(f[r>>2]|0));u=e;return}case 4:{i=f[a>>2]|0;if((f[i>>2]|0)>0){s=0;t=i}else{u=e;return}do{i=(f[t+8>>2]|0)+8+(s<<3)|0;Ppb(c,f[i>>2]|0,f[i+4>>2]|0,d);s=s+1|0;t=f[a>>2]|0}while((s|0)<(f[t>>2]|0));u=e;return}case 17:{i=f[a>>2]|0;if((f[i>>2]|0)>0){v=0;w=i}else{u=e;return}do{Qpb(c,f[(f[w+8>>2]|0)+4+(v<<2)>>2]|0,d);v=v+1|0;w=f[a>>2]|0}while((v|0)<(f[w>>2]|0));u=e;return}case 18:{i=f[a>>2]|0;if((f[i>>2]|0)>0){x=0;y=i}else{u=e;return}do{i=(f[y+8>>2]|0)+8+(x<<3)|0;Rpb(c,f[i>>2]|0,f[i+4>>2]|0,d);x=x+1|0;y=f[a>>2]|0}while((x|0)<(f[y>>2]|0));u=e;return}case 7:{i=f[a>>2]|0;if((f[i>>2]|0)>0){z=0;A=i}else{u=e;return}do{Spb(c,f[(f[A+8>>2]|0)+4+(z<<2)>>2]|0,d);z=z+1|0;A=f[a>>2]|0}while((z|0)<(f[A>>2]|0));u=e;return}case 6:{i=f[a>>2]|0;if((f[i>>2]|0)>0){B=0;C=i}else{u=e;return}do{i=(f[C+8>>2]|0)+8+(B<<3)|0;Tpb(c,f[i>>2]|0,f[i+4>>2]|0,d);B=B+1|0;C=f[a>>2]|0}while((B|0)<(f[C>>2]|0));u=e;return}case 15:{i=f[a>>2]|0;if((f[i>>2]|0)>0){D=0;E=i}else{u=e;return}do{Upb(c,f[(f[E+8>>2]|0)+4+(D<<2)>>2]|0,d);D=D+1|0;E=f[a>>2]|0}while((D|0)<(f[E>>2]|0));u=e;return}case 16:{i=f[a>>2]|0;if((f[i>>2]|0)>0){F=0;G=i}else{u=e;return}do{i=(f[G+8>>2]|0)+8+(F<<3)|0;Vpb(c,f[i>>2]|0,f[i+4>>2]|0,d);F=F+1|0;G=f[a>>2]|0}while((F|0)<(f[G>>2]|0));u=e;return}case 2:{i=f[a>>2]|0;if((f[i>>2]|0)>0){H=0;I=i}else{u=e;return}do{Wpb(c,+n[(f[I+8>>2]|0)+4+(H<<2)>>2],d);H=H+1|0;I=f[a>>2]|0}while((H|0)<(f[I>>2]|0));u=e;return}case 1:{i=f[a>>2]|0;if((f[i>>2]|0)>0){K=0;L=i}else{u=e;return}do{Xpb(c,+p[(f[L+8>>2]|0)+8+(K<<3)>>3],d);K=K+1|0;L=f[a>>2]|0}while((K|0)<(f[L>>2]|0));u=e;return}case 8:{i=f[a>>2]|0;if((f[i>>2]|0)>0){M=0;N=i}else{u=e;return}do{Ypb(c,(b[(f[N+8>>2]|0)+4+M>>0]|0)!=0,d);M=M+1|0;N=f[a>>2]|0}while((M|0)<(f[N>>2]|0));u=e;return}case 9:{i=f[a>>2]|0;if((f[i+4>>2]|0)>0){O=0;P=i}else{u=e;return}do{_pb(c,f[(f[P+12>>2]|0)+4+(O<<2)>>2]|0,d);O=O+1|0;P=f[a>>2]|0}while((O|0)<(f[P+4>>2]|0));u=e;return}case 12:{i=f[a>>2]|0;if((f[i+4>>2]|0)>0){Q=0;R=i}else{u=e;return}do{aqb(c,f[(f[R+12>>2]|0)+4+(Q<<2)>>2]|0,d);Q=Q+1|0;R=f[a>>2]|0}while((Q|0)<(f[R+4>>2]|0));u=e;return}case 14:{i=f[a>>2]|0;if((f[i>>2]|0)>0){S=0;T=i}else{u=e;return}do{Zpb(c,f[(f[T+8>>2]|0)+4+(S<<2)>>2]|0,d);S=S+1|0;T=f[a>>2]|0}while((S|0)<(f[T>>2]|0));u=e;return}case 10:{i=f[a>>2]|0;if((f[i+4>>2]|0)>0){U=0;V=i}else{u=e;return}do{cqb(c,f[(f[V+12>>2]|0)+4+(U<<2)>>2]|0,d);U=U+1|0;V=f[a>>2]|0}while((U|0)<(f[V+4>>2]|0));u=e;return}case 11:{i=f[a>>2]|0;if((f[i+4>>2]|0)>0){W=0;X=i}else{u=e;return}do{dqb(c,f[(f[X+12>>2]|0)+4+(W<<2)>>2]|0,d);W=W+1|0;X=f[a>>2]|0}while((W|0)<(f[X+4>>2]|0));u=e;return}default:{u=e;return}}while(0);X=a+12|0;if(!(f[X>>2]|0)){u=e;return}W=c<<3|2;c=d+8|0;if((f[c>>2]|0)>4){V=d+4|0;U=f[V>>2]|0;if(W>>>0>127){T=W;S=U;while(1){b[S>>0]=T|128;R=T>>>7;Q=S+1|0;if(T>>>0>16383){T=R;S=Q}else{Y=Q;Z=R;break}}}else{Y=U;Z=W}b[Y>>0]=Z;Z=Y+1-U|0;f[V>>2]=(f[V>>2]|0)+Z;V=(f[c>>2]|0)-Z|0;f[c>>2]=V;_=V}else{fob(d,W);_=f[c>>2]|0}W=f[X>>2]|0;if((_|0)>4){_=d+4|0;X=f[_>>2]|0;if(W>>>0>127){V=W;Z=X;while(1){b[Z>>0]=V|128;U=V>>>7;Y=Z+1|0;if(V>>>0>16383){V=U;Z=Y}else{$=Y;aa=U;break}}}else{$=X;aa=W}b[$>>0]=aa;aa=$+1-X|0;f[_>>2]=(f[_>>2]|0)+aa;f[c>>2]=(f[c>>2]|0)-aa}else fob(d,W);do switch(b[a+8>>0]|0){case 5:{W=f[a>>2]|0;if((f[W>>2]|0)<=0){u=e;return}aa=d+4|0;_=0;X=W;do{W=f[(f[X+8>>2]|0)+4+(_<<2)>>2]|0;do if((W|0)<0)gob(d,W,((W|0)<0)<<31>>31);else{if((f[c>>2]|0)<=4){fob(d,W);break}$=f[aa>>2]|0;if(W>>>0>127){Z=W;V=$;while(1){b[V>>0]=Z|128;U=Z>>>7;Y=V+1|0;if(Z>>>0>16383){Z=U;V=Y}else{ba=Y;ca=U;break}}}else{ba=$;ca=W}b[ba>>0]=ca;V=ba+1-$|0;f[aa>>2]=(f[aa>>2]|0)+V;f[c>>2]=(f[c>>2]|0)-V}while(0);_=_+1|0;X=f[a>>2]|0}while((_|0)<(f[X>>2]|0));u=e;return}case 3:{X=f[a>>2]|0;if((f[X>>2]|0)>0){da=0;ea=X}else{u=e;return}do{X=(f[ea+8>>2]|0)+8+(da<<3)|0;gob(d,f[X>>2]|0,f[X+4>>2]|0);da=da+1|0;ea=f[a>>2]|0}while((da|0)<(f[ea>>2]|0));u=e;return}case 13:{X=f[a>>2]|0;if((f[X>>2]|0)<=0){u=e;return}_=d+4|0;aa=0;W=X;do{X=f[(f[W+8>>2]|0)+4+(aa<<2)>>2]|0;if((f[c>>2]|0)>4){V=f[_>>2]|0;if(X>>>0>127){Z=X;U=V;while(1){b[U>>0]=Z|128;Y=Z>>>7;S=U+1|0;if(Z>>>0>16383){Z=Y;U=S}else{fa=S;ga=Y;break}}}else{fa=V;ga=X}b[fa>>0]=ga;U=fa+1-V|0;f[_>>2]=(f[_>>2]|0)+U;f[c>>2]=(f[c>>2]|0)-U}else fob(d,X);aa=aa+1|0;W=f[a>>2]|0}while((aa|0)<(f[W>>2]|0));u=e;return}case 4:{W=f[a>>2]|0;if((f[W>>2]|0)>0){ha=0;ia=W}else{u=e;return}do{W=(f[ia+8>>2]|0)+8+(ha<<3)|0;gob(d,f[W>>2]|0,f[W+4>>2]|0);ha=ha+1|0;ia=f[a>>2]|0}while((ha|0)<(f[ia>>2]|0));u=e;return}case 17:{W=f[a>>2]|0;if((f[W>>2]|0)<=0){u=e;return}aa=d+4|0;_=0;U=W;do{W=f[(f[U+8>>2]|0)+4+(_<<2)>>2]|0;Z=W<<1^W>>31;if((f[c>>2]|0)>4){W=f[aa>>2]|0;if(Z>>>0>127){Y=Z;S=W;while(1){b[S>>0]=Y|128;T=Y>>>7;R=S+1|0;if(Y>>>0>16383){Y=T;S=R}else{ja=R;ka=T;break}}}else{ja=W;ka=Z}b[ja>>0]=ka;S=ja+1-W|0;f[aa>>2]=(f[aa>>2]|0)+S;f[c>>2]=(f[c>>2]|0)-S}else fob(d,Z);_=_+1|0;U=f[a>>2]|0}while((_|0)<(f[U>>2]|0));u=e;return}case 18:{U=f[a>>2]|0;if((f[U>>2]|0)>0){la=0;ma=U}else{u=e;return}do{U=(f[ma+8>>2]|0)+8+(la<<3)|0;_=f[U>>2]|0;aa=f[U+4>>2]|0;U=$ac(_|0,aa|0,1)|0;S=J;Y=Rac(_|0,aa|0,63)|0;gob(d,U^Y,S^J);la=la+1|0;ma=f[a>>2]|0}while((la|0)<(f[ma>>2]|0));u=e;return}case 7:{S=f[a>>2]|0;if((f[S>>2]|0)>0){na=0;oa=S}else{u=e;return}do{dob(d,f[(f[oa+8>>2]|0)+4+(na<<2)>>2]|0);na=na+1|0;oa=f[a>>2]|0}while((na|0)<(f[oa>>2]|0));u=e;return}case 6:{S=f[a>>2]|0;if((f[S>>2]|0)>0){pa=0;qa=S}else{u=e;return}do{S=(f[qa+8>>2]|0)+8+(pa<<3)|0;eob(d,f[S>>2]|0,f[S+4>>2]|0);pa=pa+1|0;qa=f[a>>2]|0}while((pa|0)<(f[qa>>2]|0));u=e;return}case 15:{S=f[a>>2]|0;if((f[S>>2]|0)>0){ra=0;sa=S}else{u=e;return}do{dob(d,f[(f[sa+8>>2]|0)+4+(ra<<2)>>2]|0);ra=ra+1|0;sa=f[a>>2]|0}while((ra|0)<(f[sa>>2]|0));u=e;return}case 16:{S=f[a>>2]|0;if((f[S>>2]|0)>0){ta=0;ua=S}else{u=e;return}do{S=(f[ua+8>>2]|0)+8+(ta<<3)|0;eob(d,f[S>>2]|0,f[S+4>>2]|0);ta=ta+1|0;ua=f[a>>2]|0}while((ta|0)<(f[ua>>2]|0));u=e;return}case 2:{S=f[a>>2]|0;if((f[S>>2]|0)>0){va=0;wa=S}else{u=e;return}do{dob(d,f[(f[wa+8>>2]|0)+4+(va<<2)>>2]|0);va=va+1|0;wa=f[a>>2]|0}while((va|0)<(f[wa>>2]|0));u=e;return}case 1:{S=f[a>>2]|0;if((f[S>>2]|0)>0){xa=0;ya=S}else{u=e;return}do{S=(f[ya+8>>2]|0)+8+(xa<<3)|0;eob(d,f[S>>2]|0,f[S+4>>2]|0);xa=xa+1|0;ya=f[a>>2]|0}while((xa|0)<(f[ya>>2]|0));u=e;return}case 8:{S=f[a>>2]|0;if((f[S>>2]|0)<=0){u=e;return}Y=d+4|0;U=0;aa=S;do{S=b[(f[aa+8>>2]|0)+4+U>>0]|0;if((f[c>>2]|0)>4){b[f[Y>>2]>>0]=S;f[Y>>2]=(f[Y>>2]|0)+1;f[c>>2]=(f[c>>2]|0)+-1}else fob(d,S&255);U=U+1|0;aa=f[a>>2]|0}while((U|0)<(f[aa>>2]|0));u=e;return}case 14:{aa=f[a>>2]|0;if((f[aa>>2]|0)<=0){u=e;return}U=d+4|0;Y=0;S=aa;do{aa=f[(f[S+8>>2]|0)+4+(Y<<2)>>2]|0;do if((aa|0)<0)gob(d,aa,((aa|0)<0)<<31>>31);else{if((f[c>>2]|0)<=4){fob(d,aa);break}_=f[U>>2]|0;if(aa>>>0>127){X=aa;V=_;while(1){b[V>>0]=X|128;T=X>>>7;R=V+1|0;if(X>>>0>16383){X=T;V=R}else{za=R;Aa=T;break}}}else{za=_;Aa=aa}b[za>>0]=Aa;V=za+1-_|0;f[U>>2]=(f[U>>2]|0)+V;f[c>>2]=(f[c>>2]|0)-V}while(0);Y=Y+1|0;S=f[a>>2]|0}while((Y|0)<(f[S>>2]|0));u=e;return}case 11:case 10:case 12:case 9:{zpb(g,3,477758,1469);xpb(h,vpb(g,478329)|0);Apb(g);u=e;return}default:{u=e;return}}while(0)}function aSb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a>>2]|0;c=a+4|0;if((b|0)==(c|0)){d=0;return d|0}else{e=0;g=b}while(1){b=(bSb(g+24|0,f[g+16>>2]|0)|0)+e|0;a=f[g+4>>2]|0;if(!a){h=g+8|0;i=f[h>>2]|0;if((f[i>>2]|0)==(g|0))j=i;else{i=h;do{h=f[i>>2]|0;i=h+8|0;k=f[i>>2]|0}while((f[k>>2]|0)!=(h|0));j=k}}else{i=a;while(1){k=f[i>>2]|0;if(!k)break;else i=k}j=i}if((j|0)==(c|0)){d=b;break}else{e=b;g=j}}return d|0}function bSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;d=u;u=u+32|0;e=d;g=d+24|0;if(!(b[a+9>>0]|0)){h=a+10|0;if(b[h>>0]&1){i=0;u=d;return i|0}j=a+8|0;k=b[j>>0]|0;l=c<<3;if(l>>>0<128){m=1;n=k}else{o=iob(l)|0;m=o;n=b[j>>0]|0}j=m<<(k<<24>>24==10&1);do switch(n<<24>>24){case 5:{k=f[a>>2]|0;if((k|0)>=0)if(k>>>0<128)p=1;else p=iob(k)|0;else p=10;i=p+j|0;u=d;return i|0}case 3:{k=a;i=(job(f[k>>2]|0,f[k+4>>2]|0)|0)+j|0;u=d;return i|0}case 13:{k=f[a>>2]|0;if(k>>>0<128)q=1;else q=iob(k)|0;i=q+j|0;u=d;return i|0}case 4:{k=a;i=(job(f[k>>2]|0,f[k+4>>2]|0)|0)+j|0;u=d;return i|0}case 17:{k=f[a>>2]|0;m=k<<1^k>>31;if(m>>>0<128)r=1;else r=iob(m)|0;i=r+j|0;u=d;return i|0}case 18:{m=a;k=f[m>>2]|0;o=f[m+4>>2]|0;m=$ac(k|0,o|0,1)|0;l=J;i=(job(m^(Rac(k|0,o|0,63)|0),l^J)|0)+j|0;u=d;return i|0}case 9:{l=f[a>>2]|0;o=b[l+11>>0]|0;if(o<<24>>24<0){k=f[l+4>>2]|0;if(k>>>0<128){s=1;t=k}else{s=iob(k)|0;t=k}}else{s=1;t=o&255}i=t+j+s|0;u=d;return i|0}case 12:{o=f[a>>2]|0;k=b[o+11>>0]|0;if(k<<24>>24<0){l=f[o+4>>2]|0;if(l>>>0<128){v=1;w=l}else{v=iob(l)|0;w=l}}else{v=1;w=k&255}i=w+j+v|0;u=d;return i|0}case 14:{k=f[a>>2]|0;if((k|0)>=0)if(k>>>0<128)x=1;else x=iob(k)|0;else x=10;i=x+j|0;u=d;return i|0}case 10:{k=f[a>>2]|0;i=(di[f[(f[k>>2]|0)+52>>2]&1023](k)|0)+j|0;u=d;return i|0}case 11:{k=f[a>>2]|0;l=f[k>>2]|0;if(!(b[h>>0]&16)){o=di[f[l+52>>2]&1023](k)|0;if(o>>>0<128)y=1;else y=iob(o)|0;i=o+j+y|0;u=d;return i|0}else{o=di[f[l+40>>2]&1023](k)|0;if(o>>>0<128)z=1;else z=iob(o)|0;i=o+j+z|0;u=d;return i|0}break}case 7:{i=j+4|0;u=d;return i|0}case 6:{i=j+8|0;u=d;return i|0}case 15:{i=j+4|0;u=d;return i|0}case 16:{i=j+8|0;u=d;return i|0}case 2:{i=j+4|0;u=d;return i|0}case 1:{i=j+8|0;u=d;return i|0}case 8:{i=j+1|0;u=d;return i|0}default:{i=j;u=d;return i|0}}while(0)}j=a+8|0;z=b[j>>0]|0;if(b[a+11>>0]|0){do switch(z<<24>>24){case 5:{y=f[a>>2]|0;if((f[y>>2]|0)>0){h=0;x=0;v=y;while(1){y=f[(f[v+8>>2]|0)+4+(h<<2)>>2]|0;if((y|0)>=0)if(y>>>0<128){A=1;B=v}else{w=iob(y)|0;A=w;B=f[a>>2]|0}else{A=10;B=v}w=A+x|0;h=h+1|0;if((h|0)>=(f[B>>2]|0)){C=w;D=38;break}else{x=w;v=B}}}else D=37;break}case 3:{v=f[a>>2]|0;if((f[v>>2]|0)>0){x=0;h=0;w=v;while(1){v=(f[w+8>>2]|0)+8+(x<<3)|0;y=(job(f[v>>2]|0,f[v+4>>2]|0)|0)+h|0;x=x+1|0;w=f[a>>2]|0;if((x|0)>=(f[w>>2]|0)){C=y;D=38;break}else h=y}}else D=37;break}case 13:{h=f[a>>2]|0;if((f[h>>2]|0)>0){w=0;x=0;y=h;while(1){h=f[(f[y+8>>2]|0)+4+(w<<2)>>2]|0;if(h>>>0<128){E=1;F=y}else{v=iob(h)|0;E=v;F=f[a>>2]|0}v=E+x|0;w=w+1|0;if((w|0)>=(f[F>>2]|0)){C=v;D=38;break}else{x=v;y=F}}}else D=37;break}case 4:{y=f[a>>2]|0;if((f[y>>2]|0)>0){x=0;w=0;v=y;while(1){y=(f[v+8>>2]|0)+8+(x<<3)|0;h=(job(f[y>>2]|0,f[y+4>>2]|0)|0)+w|0;x=x+1|0;v=f[a>>2]|0;if((x|0)>=(f[v>>2]|0)){C=h;D=38;break}else w=h}}else D=37;break}case 17:{w=f[a>>2]|0;if((f[w>>2]|0)>0){v=0;x=0;h=w;while(1){w=f[(f[h+8>>2]|0)+4+(v<<2)>>2]|0;y=w<<1^w>>31;if(y>>>0<128){G=1;H=h}else{w=iob(y)|0;G=w;H=f[a>>2]|0}w=G+x|0;v=v+1|0;if((v|0)>=(f[H>>2]|0)){C=w;D=38;break}else{x=w;h=H}}}else D=37;break}case 18:{h=f[a>>2]|0;if((f[h>>2]|0)>0){x=0;v=0;w=h;while(1){h=(f[w+8>>2]|0)+8+(x<<3)|0;y=f[h>>2]|0;s=f[h+4>>2]|0;h=$ac(y|0,s|0,1)|0;t=J;r=Rac(y|0,s|0,63)|0;s=(job(h^r,t^J)|0)+v|0;x=x+1|0;w=f[a>>2]|0;if((x|0)>=(f[w>>2]|0)){C=s;D=38;break}else v=s}}else D=37;break}case 14:{v=f[a>>2]|0;if((f[v>>2]|0)>0){w=0;x=0;s=v;while(1){v=f[(f[s+8>>2]|0)+4+(w<<2)>>2]|0;if((v|0)>=0)if(v>>>0<128){I=1;K=s}else{t=iob(v)|0;I=t;K=f[a>>2]|0}else{I=10;K=s}t=I+x|0;w=w+1|0;if((w|0)>=(f[K>>2]|0)){C=t;D=38;break}else{x=t;s=K}}}else D=37;break}case 7:{C=f[f[a>>2]>>2]<<2;D=38;break}case 6:{C=f[f[a>>2]>>2]<<3;D=38;break}case 15:{C=f[f[a>>2]>>2]<<2;D=38;break}case 16:{C=f[f[a>>2]>>2]<<3;D=38;break}case 2:{C=f[f[a>>2]>>2]<<2;D=38;break}case 1:{C=f[f[a>>2]>>2]<<3;D=38;break}case 8:{C=f[f[a>>2]>>2]|0;D=38;break}case 11:case 10:case 12:case 9:{zpb(e,3,477758,1581);xpb(g,vpb(e,478329)|0);Apb(e);D=36;break}default:D=36}while(0);if((D|0)==36){f[a+12>>2]=0;i=0;u=d;return i|0}else if((D|0)==37){f[a+12>>2]=0;i=0;u=d;return i|0}else if((D|0)==38){f[a+12>>2]=C;if(!C){i=0;u=d;return i|0}if(C>>>0<128)L=1;else L=iob(C)|0;D=c<<3|2;if(D>>>0<128)M=1;else M=iob(D)|0;i=L+C+M|0;u=d;return i|0}}M=c<<3;if(M>>>0<128){N=1;O=z}else{c=iob(M)|0;N=c;O=b[j>>0]|0}j=N<<(z<<24>>24==10&1);do switch(O<<24>>24){case 5:{z=f[a>>2]|0;N=f[z>>2]|0;c=Y(N,j)|0;if((N|0)>0){P=0;Q=c;R=z}else{i=c;u=d;return i|0}while(1){c=f[(f[R+8>>2]|0)+4+(P<<2)>>2]|0;if((c|0)>=0)if(c>>>0<128){S=1;T=R}else{z=iob(c)|0;S=z;T=f[a>>2]|0}else{S=10;T=R}z=S+Q|0;P=P+1|0;if((P|0)>=(f[T>>2]|0)){i=z;break}else{Q=z;R=T}}u=d;return i|0}case 3:{z=f[a>>2]|0;c=f[z>>2]|0;N=Y(c,j)|0;if((c|0)>0){U=0;V=N;W=z}else{i=N;u=d;return i|0}while(1){N=(f[W+8>>2]|0)+8+(U<<3)|0;z=(job(f[N>>2]|0,f[N+4>>2]|0)|0)+V|0;U=U+1|0;W=f[a>>2]|0;if((U|0)>=(f[W>>2]|0)){i=z;break}else V=z}u=d;return i|0}case 13:{z=f[a>>2]|0;N=f[z>>2]|0;c=Y(N,j)|0;if((N|0)>0){X=0;Z=c;_=z}else{i=c;u=d;return i|0}while(1){c=f[(f[_+8>>2]|0)+4+(X<<2)>>2]|0;if(c>>>0<128){$=1;aa=_}else{z=iob(c)|0;$=z;aa=f[a>>2]|0}z=$+Z|0;X=X+1|0;if((X|0)>=(f[aa>>2]|0)){i=z;break}else{Z=z;_=aa}}u=d;return i|0}case 4:{z=f[a>>2]|0;c=f[z>>2]|0;N=Y(c,j)|0;if((c|0)>0){ba=0;ca=N;da=z}else{i=N;u=d;return i|0}while(1){N=(f[da+8>>2]|0)+8+(ba<<3)|0;z=(job(f[N>>2]|0,f[N+4>>2]|0)|0)+ca|0;ba=ba+1|0;da=f[a>>2]|0;if((ba|0)>=(f[da>>2]|0)){i=z;break}else ca=z}u=d;return i|0}case 17:{z=f[a>>2]|0;N=f[z>>2]|0;c=Y(N,j)|0;if((N|0)>0){ea=0;fa=c;ga=z}else{i=c;u=d;return i|0}while(1){c=f[(f[ga+8>>2]|0)+4+(ea<<2)>>2]|0;z=c<<1^c>>31;if(z>>>0<128){ha=1;ia=ga}else{c=iob(z)|0;ha=c;ia=f[a>>2]|0}c=ha+fa|0;ea=ea+1|0;if((ea|0)>=(f[ia>>2]|0)){i=c;break}else{fa=c;ga=ia}}u=d;return i|0}case 18:{c=f[a>>2]|0;z=f[c>>2]|0;N=Y(z,j)|0;if((z|0)>0){ja=0;ka=N;la=c}else{i=N;u=d;return i|0}while(1){N=(f[la+8>>2]|0)+8+(ja<<3)|0;c=f[N>>2]|0;z=f[N+4>>2]|0;N=$ac(c|0,z|0,1)|0;M=J;C=Rac(c|0,z|0,63)|0;z=(job(N^C,M^J)|0)+ka|0;ja=ja+1|0;la=f[a>>2]|0;if((ja|0)>=(f[la>>2]|0)){i=z;break}else ka=z}u=d;return i|0}case 9:{z=f[a>>2]|0;M=f[z+4>>2]|0;C=Y(M,j)|0;if((M|0)>0){ma=0;na=C;oa=z}else{i=C;u=d;return i|0}while(1){C=f[(f[oa+12>>2]|0)+4+(ma<<2)>>2]|0;z=b[C+11>>0]|0;if(z<<24>>24<0){M=f[C+4>>2]|0;if(M>>>0<128){pa=1;qa=M;ra=oa}else{C=iob(M)|0;pa=C;qa=M;ra=f[a>>2]|0}}else{pa=1;qa=z&255;ra=oa}z=qa+na+pa|0;ma=ma+1|0;if((ma|0)>=(f[ra+4>>2]|0)){i=z;break}else{na=z;oa=ra}}u=d;return i|0}case 12:{z=f[a>>2]|0;M=f[z+4>>2]|0;C=Y(M,j)|0;if((M|0)>0){sa=0;ta=C;ua=z}else{i=C;u=d;return i|0}while(1){C=f[(f[ua+12>>2]|0)+4+(sa<<2)>>2]|0;z=b[C+11>>0]|0;if(z<<24>>24<0){M=f[C+4>>2]|0;if(M>>>0<128){va=1;wa=M;xa=ua}else{C=iob(M)|0;va=C;wa=M;xa=f[a>>2]|0}}else{va=1;wa=z&255;xa=ua}z=wa+ta+va|0;sa=sa+1|0;if((sa|0)>=(f[xa+4>>2]|0)){i=z;break}else{ta=z;ua=xa}}u=d;return i|0}case 14:{z=f[a>>2]|0;M=f[z>>2]|0;C=Y(M,j)|0;if((M|0)>0){ya=0;za=C;Aa=z}else{i=C;u=d;return i|0}while(1){C=f[(f[Aa+8>>2]|0)+4+(ya<<2)>>2]|0;if((C|0)>=0)if(C>>>0<128){Ba=1;Ca=Aa}else{z=iob(C)|0;Ba=z;Ca=f[a>>2]|0}else{Ba=10;Ca=Aa}z=Ba+za|0;ya=ya+1|0;if((ya|0)>=(f[Ca>>2]|0)){i=z;break}else{za=z;Aa=Ca}}u=d;return i|0}case 10:{z=f[a>>2]|0;C=f[z+4>>2]|0;M=Y(C,j)|0;if((C|0)>0){Da=0;Ea=M;Fa=z}else{i=M;u=d;return i|0}while(1){M=f[(f[Fa+12>>2]|0)+4+(Da<<2)>>2]|0;z=(di[f[(f[M>>2]|0)+52>>2]&1023](M)|0)+Ea|0;Da=Da+1|0;Fa=f[a>>2]|0;if((Da|0)>=(f[Fa+4>>2]|0)){i=z;break}else Ea=z}u=d;return i|0}case 11:{z=f[a>>2]|0;M=f[z+4>>2]|0;C=Y(M,j)|0;if((M|0)>0){Ga=0;Ha=C;Ia=z}else{i=C;u=d;return i|0}while(1){C=f[(f[Ia+12>>2]|0)+4+(Ga<<2)>>2]|0;z=di[f[(f[C>>2]|0)+52>>2]&1023](C)|0;if(z>>>0<128)Ja=1;else Ja=iob(z)|0;C=z+Ha+Ja|0;Ga=Ga+1|0;Ia=f[a>>2]|0;if((Ga|0)>=(f[Ia+4>>2]|0)){i=C;break}else Ha=C}u=d;return i|0}case 7:{i=Y(f[f[a>>2]>>2]|0,j+4|0)|0;u=d;return i|0}case 6:{i=Y(f[f[a>>2]>>2]|0,j+8|0)|0;u=d;return i|0}case 15:{i=Y(f[f[a>>2]>>2]|0,j+4|0)|0;u=d;return i|0}case 16:{i=Y(f[f[a>>2]>>2]|0,j+8|0)|0;u=d;return i|0}case 2:{i=Y(f[f[a>>2]>>2]|0,j+4|0)|0;u=d;return i|0}case 1:{i=Y(f[f[a>>2]>>2]|0,j+8|0)|0;u=d;return i|0}case 8:{i=Y(f[f[a>>2]>>2]|0,j+1|0)|0;u=d;return i|0}default:{i=0;u=d;return i|0}}while(0);return 0}function cSb(a){a=a|0;return}function dSb(a){a=a|0;return}function eSb(a,b,c){a=a|0;b=b|0;c=c|0;c=u;u=u+32|0;b=c;zpb(b,3,478409,50);xpb(c+24|0,vpb(b,478510)|0);Apb(b);u=c;return 0}function fSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+1040|0;e=d+16|0;g=d;f[g>>2]=f[c>>2];h=mUb(e,1024,b,g)|0;if((h|0)<1024){if((h|0)<=-1){u=d;return}j6b(a,e,h)|0;u=d;return}else{e=h+1|0;i=N5b(e)|0;f[g>>2]=f[c>>2];c=mUb(i,e,b,g)|0;if(!((c|0)<0|(c|0)>(h|0)))j6b(a,i,c)|0;P5b(i);u=d;return}}function gSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;fSb(a,b,e);u=d;return}function hSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[e>>2]=c;fSb(a,b,e);u=d;return}function iSb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f[e>>2]=0;if(!d){g=241;return g|0}i=f[a+16>>2]|0;j=c+d|0;d=j+-7|0;k=(f[a+32>>2]|0)+(f[a>>2]|0)|0;l=f[a+44>>2]|0;m=f[a+24>>2]|0;n=f[a+28>>2]|0;o=a+4|0;a=k;p=c;while(1){q=p&7;a:do if(p>>>0<j>>>0&(q|0)!=0){r=p;while(1){if(b[l+(h[r>>0]|0)>>0]|0){s=r;break a}t=r+1|0;u=t&7;if(t>>>0<j>>>0&(u|0)!=0)r=t;else{v=t;w=u;x=6;break}}}else{v=p;w=q;x=6}while(0);b:do if((x|0)==6){x=0;if((w|0)==0&v>>>0<d>>>0){q=v;while(1){r=f[q>>2]|0;u=q+4|0;t=f[u>>2]|0;y=q+8|0;if((r-m|r+n|t-m|t+n)&-2139062144|0){if((b[l+(h[q+1>>0]|0)>>0]|b[l+(r&255)>>0]|b[l+(h[q+2>>0]|0)>>0]|b[l+(h[q+3>>0]|0)>>0])<<24>>24){s=q;break b}if((b[l+(h[q+5>>0]|0)>>0]|b[l+(t&255)>>0]|b[l+(h[q+6>>0]|0)>>0]|b[l+(h[q+7>>0]|0)>>0])<<24>>24){s=u;break b}}if(y>>>0<d>>>0)q=y;else{s=y;break}}}else s=v}while(0);if(s>>>0<j>>>0){z=k;A=s}else{B=k;C=s;x=18;break}while(1){D=b[z+(h[A>>0]|0)>>0]|0;E=D&255;F=A+1|0;if((D&255)>239){G=z;break}q=k+(E<<i)|0;if(F>>>0<j>>>0){z=q;A=F}else{G=q;break}}if((D&255)<=239){B=G;C=F;x=18;break}c:do if((G-a|0)>>>0<(f[o>>2]|0)>>>0)H=A;else{q=A;while(1){y=q+-1|0;if(y>>>0<=c>>>0){H=y;break c}if((b[y>>0]&-64)<<24>>24==-128)q=y;else{H=y;break}}}while(0);if(D<<24>>24==-3)p=H;else{I=H;J=E;break}}d:do if((x|0)==18)if((B-k|0)>>>0<(f[o>>2]|0)>>>0){I=C;J=241}else{E=C;while(1){H=E+-1|0;if(H>>>0<=c>>>0){I=H;J=240;break d}if((b[H>>0]&-64)<<24>>24==-128)E=H;else{I=H;J=240;break}}}while(0);f[e>>2]=I-c;g=J;return g|0}function jSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+16|0;e=d;if(!c){g=0;h=(g|0)==(c|0);u=d;return h|0}i=a+c|0;j=i+-7|0;k=a;l=k+c|0;m=a;do{a=m&7;a:do if(m>>>0<i>>>0&(a|0)!=0){n=m;while(1){if((b[n>>0]|0)<=-1){o=n;break a}p=n+1|0;q=p&7;if(p>>>0<i>>>0&(q|0)!=0)n=p;else{r=p;s=q;t=7;break}}}else{r=m;s=a;t=7}while(0);b:do if((t|0)==7){t=0;if(r>>>0<j>>>0&(s|0)==0){a=r;while(1){if((f[a+4>>2]|f[a>>2])&-2139062144|0){o=a;break b}n=a+8|0;if(n>>>0<j>>>0)a=n;else{o=n;break}}}else o=r}while(0);c:do if(o>>>0<i>>>0){a=o;while(1){if((b[a>>0]|0)<=-1){v=a;break c}n=a+1|0;if(n>>>0<i>>>0)a=n;else{v=n;break}}}else v=o;while(0);a=iSb(141348,v,l-v|0,e)|0;m=v+(f[e>>2]|0)|0}while((a|0)==253);g=m-k|0;h=(g|0)==(c|0);u=d;return h|0}function kSb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+11|0;d=b[c>>0]|0;if(d<<24>>24<0)e=f[a+4>>2]|0;else e=d&255;a:do if((e|0)>0){d=0;while(1){g=i6b(a,d)|0;h=(b[g>>0]|0)+-9<<24>>24;if((h&255)>23|(8388639>>>(h&255)&1|0)==0){i=d;break a}h=d+1|0;if((e|0)>(h|0))d=h;else{i=h;break}}}else i=0;while(0);if((e|0)==(i|0))if((b[c>>0]|0)<0){b[f[a>>2]>>0]=0;f[a+4>>2]=0;return}else{b[a>>0]=0;b[c>>0]=0;return}if((i|0)>0){o6b(a,0,i)|0;j=e-i|0}else j=e;e=j+-1|0;if((j|0)>0)k=e;else return;while(1){j=i6b(a,k)|0;i=(b[j>>0]|0)+-9<<24>>24;if((i&255)>23|(8388639>>>(i&255)&1|0)==0)break;if((k|0)>0)k=k+-1|0;else{l=18;break}}if((l|0)==18)return;if((k|0)==(e|0))return;o6b(a,k+1|0,-1)|0;return}function lSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+16|0;g=e;i=b[c>>0]|0;if(i<<24>>24?(b[c+1>>0]|0)==0:0){j=b[a+11>>0]|0;k=j<<24>>24<0;l=k?f[a>>2]|0:a;m=k?f[a+4>>2]|0:j&255;j=l+m|0;if(!m){u=e;return}m=g+11|0;k=g+8|0;n=g+4|0;o=d+4|0;p=d+8|0;q=l;while(1){if((b[q>>0]|0)==i<<24>>24)r=q+1|0;else{l=q;while(1){s=l+1|0;if((s|0)==(j|0)){t=j;break}if((b[s>>0]|0)==i<<24>>24){t=s;break}else l=s}l=t-q|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(l>>>0>4294967279){v=12;break}if(l>>>0<11){b[m>>0]=l;if(!l)w=g;else{x=g;v=16}}else{s=l+16&-16;y=L5b(s)|0;f[g>>2]=y;f[k>>2]=s|-2147483648;f[n>>2]=l;x=y;v=16}if((v|0)==16){v=0;Vac(x|0,q|0,l|0)|0;w=x}b[w+l>>0]=0;l=f[o>>2]|0;if((l|0)==(f[p>>2]|0))JT(d,g);else{X5b(l,g);f[o>>2]=(f[o>>2]|0)+12}if((b[m>>0]|0)<0)O5b(f[g>>2]|0);r=t}if((r|0)==(j|0)){v=47;break}else q=r}if((v|0)==12)V5b(g);else if((v|0)==47){u=e;return}}r=a+11|0;q=b[r>>0]|0;j=q<<24>>24<0;t=a+4|0;m=f[t>>2]|0;o=j?m:q&255;if(!o){u=e;return}p=kUb(c)|0;w=f[a>>2]|0;x=g+11|0;n=d+4|0;k=d+8|0;i=0;l=j?w:a;j=o;o=p;p=q;q=w;w=m;a:while(1){m=l+j|0;y=l+i|0;b:do if(!o)z=y;else{s=y;while(1){if(!(xTb(c,h[s>>0]|0,o)|0)){z=s;break b}s=s+1|0;if((s|0)==(m|0)){v=47;break a}}}while(0);A=z-l|0;if((A|0)==-1){v=47;break}m=p<<24>>24<0;y=m?q:a;s=m?w:p&255;m=kUb(c)|0;if(s>>>0<=A>>>0|(m|0)==0){v=35;break}B=y+A|0;C=y+s|0;D=c+m|0;c:do if((s|0)==(A|0))E=B;else{m=B;while(1){F=b[m>>0]|0;G=c;do{if(F<<24>>24==(b[G>>0]|0)){E=m;break c}G=G+1|0}while((G|0)!=(D|0));m=m+1|0;if((m|0)==(C|0)){v=35;break a}}}while(0);i=E-y|0;if((E|0)==(C|0)|(i|0)==-1){v=35;break}Y5b(g,a,A,i-A|0,a);D=f[n>>2]|0;if((D|0)==(f[k>>2]|0))JT(d,g);else{X5b(D,g);f[n>>2]=(f[n>>2]|0)+12}if((b[x>>0]|0)<0)O5b(f[g>>2]|0);p=b[r>>0]|0;D=p<<24>>24<0;B=f[a>>2]|0;w=f[t>>2]|0;j=D?w:p&255;o=kUb(c)|0;if(j>>>0<=i>>>0){v=47;break}else{l=D?B:a;q=B}}if((v|0)==35){Y5b(g,a,A,-1,a);a=f[n>>2]|0;if((a|0)==(f[k>>2]|0))JT(d,g);else{X5b(a,g);f[n>>2]=(f[n>>2]|0)+12}if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);u=e;return}else if((v|0)==47){u=e;return}}function mSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;a:do if((a|0)==(c|0)){d=a;e=a;while(1){switch(b[d>>0]|0){case 92:case 0:{f=d;g=e;break a;break}default:{}}h=d+1|0;i=e+1|0;if((d|0)==(e|0)){d=h;e=i}else{f=h;g=i;break a}}}else{f=a;g=c}while(0);a=b[f>>0]|0;if(!(a<<24>>24)){j=g;b[j>>0]=0;k=j;l=c;m=k-l|0;return m|0}else{n=f;o=g;p=a}b:while(1){a=n+1|0;if(p<<24>>24==92){g=b[a>>0]|0;c:do switch(g|0){case 0:{j=o;q=28;break b;break}case 97:{b[o>>0]=7;r=o+1|0;s=a;break}case 98:{b[o>>0]=8;r=o+1|0;s=a;break}case 102:{b[o>>0]=12;r=o+1|0;s=a;break}case 110:{b[o>>0]=10;r=o+1|0;s=a;break}case 114:{b[o>>0]=13;r=o+1|0;s=a;break}case 116:{b[o>>0]=9;r=o+1|0;s=a;break}case 118:{b[o>>0]=11;r=o+1|0;s=a;break}case 92:{b[o>>0]=92;r=o+1|0;s=a;break}case 63:{b[o>>0]=63;r=o+1|0;s=a;break}case 39:{b[o>>0]=39;r=o+1|0;s=a;break}case 34:{b[o>>0]=34;r=o+1|0;s=a;break}case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{f=g+208|0;e=n+2|0;d=b[e>>0]|0;i=(d&-8)<<24>>24==48;h=i?e:a;e=i?(f<<3)+208+(d&255)|0:f;f=h+1|0;d=b[f>>0]|0;i=(d&-8)<<24>>24==48;b[o>>0]=i?(d&255)+208+(e<<3)|0:e;r=o+1|0;s=i?f:h;break}case 88:case 120:{h=b[n+2>>0]|0;if((h+-48&255)<10){t=0;u=a}else switch(h<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:{t=0;u=a;break}default:{r=o;s=a;break c}}d:while(1){h=u+1|0;f=b[h>>0]|0;if((f+-48&255)>=10)switch(f<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}i=f&255;t=((f&255)>57?i+9|0:i)&15|t<<4;u=h}b[o>>0]=t;r=o+1|0;s=u;break}default:{r=o;s=a}}while(0);v=s+1|0;w=r}else{b[o>>0]=p;v=a;w=o+1|0}p=b[v>>0]|0;if(!(p<<24>>24)){j=w;q=28;break}else{n=v;o=w}}if((q|0)==28){b[j>>0]=0;k=j;l=c;m=k-l|0;return m|0}return 0}function nSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=N5b((e?f[c+4>>2]|0:d&255)+1|0)|0;d=mSb(e?f[c>>2]|0:c,g,0)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if(d>>>0>4294967279)V5b(a);if(d>>>0<11){b[a+11>>0]=d;if(!d){h=a;i=h+d|0;b[i>>0]=0;P5b(g);return}else j=a}else{c=d+16&-16;e=L5b(c)|0;f[a>>2]=e;f[a+8>>2]=c|-2147483648;f[a+4>>2]=d;j=e}Vac(j|0,g|0,d|0)|0;h=j;i=h+d|0;b[i>>0]=0;P5b(g);return}function oSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=f[a>>2]|0;e=a+4|0;g=f[e>>2]|0;i=(g|0)>0;if(i){j=0;k=0;while(1){l=(b[481237+(h[d+k>>0]|0)>>0]|0)+j|0;k=k+1|0;if((k|0)==(g|0)){m=l;break}else j=l}}else m=0;if((m|0)==(g|0)){j6b(c,d,g)|0;return}g=c+11|0;j=b[g>>0]|0;if(j<<24>>24<0)n=f[c+4>>2]|0;else n=j&255;e6b(c,n+m|0,0);if((b[g>>0]|0)<0)o=f[c>>2]|0;else o=c;if(!i)return;i=o+n|0;n=0;o=d;while(1){d=b[o+n>>0]|0;a:do switch(d<<24>>24){case 10:{b[i>>0]=92;b[i+1>>0]=110;p=i+2|0;break}case 13:{b[i>>0]=92;b[i+1>>0]=114;p=i+2|0;break}case 9:{b[i>>0]=92;b[i+1>>0]=116;p=i+2|0;break}case 34:{b[i>>0]=92;b[i+1>>0]=34;p=i+2|0;break}case 39:{b[i>>0]=92;b[i+1>>0]=39;p=i+2|0;break}case 92:{b[i>>0]=92;b[i+1>>0]=92;p=i+2|0;break}default:{c=i+1|0;if(d<<24>>24>31&d<<24>>24!=127){b[i>>0]=d;p=c;break a}else{b[i>>0]=92;b[c>>0]=(d&255)>>>6|48;b[i+2>>0]=(d&255)>>>3&7|48;b[i+3>>0]=d&7|48;p=i+4|0;break a}}}while(0);d=n+1|0;if((d|0)>=(f[e>>2]|0))break;i=p;n=d;o=f[a>>2]|0}return}function pSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+16|0;e=d+8|0;g=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=b[c+11>>0]|0;i=h<<24>>24<0;f[g>>2]=i?f[c>>2]|0:c;f[g+4>>2]=i?f[c+4>>2]|0:h&255;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];oSb(e,a);u=d;return}function qSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=d+20|0;b[d+21>>0]=0;if((c|0)>-1|(c|0)==-1&a>>>0>4294967295){f=e;g=a;h=c;while(1){i=Qac(g|0,h|0,10,0)|0;j=Kac(i|0,J|0,48,0)|0;b[f>>0]=j;j=g;g=abc(g|0,h|0,10,0)|0;if(!((h|0)>0|(h|0)==0&j>>>0>9)){k=f;break}else{f=f+-1|0;h=J}}return k|0}if((c|0)>-1|(c|0)==-1&a>>>0>4294967286){h=Jac(48,0,a|0,c|0)|0;b[e>>0]=h;l=d+19|0}else{h=Jac(-10,-1,a|0,c|0)|0;c=J;a=Qac(h|0,c|0,10,0)|0;f=Kac(a|0,J|0,48,0)|0;b[e>>0]=f;f=abc(h|0,c|0,10,0)|0;c=Kac(f|0,J|0,1,0)|0;f=d+19|0;d=c;c=J;while(1){h=Qac(d|0,c|0,10,0)|0;e=Kac(h|0,J|0,48,0)|0;h=f+-1|0;b[f>>0]=e;e=d;d=abc(d|0,c|0,10,0)|0;if(!((c|0)>0|(c|0)==0&e>>>0>9)){l=h;break}else{f=h;c=J}}}b[l>>0]=45;k=l;return k|0}function rSb(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=c+10|0;b[c+11>>0]=0;if((a|0)>-1){e=d;f=a;while(1){b[e>>0]=((f|0)%10|0)+48;if((f|0)>9){e=e+-1|0;f=(f|0)/10|0}else{g=e;break}}return g|0}if((a|0)>-10){b[d>>0]=48-a;h=c+9|0}else{e=-10-a|0;b[d>>0]=((e|0)%10|0)+48;d=c+9|0;c=((e|0)/10|0)+1|0;while(1){e=d+-1|0;b[d>>0]=((c|0)%10|0)+48;if((c|0)>9){d=e;c=(c|0)/10|0}else{h=e;break}}}b[h>>0]=45;g=h;return g|0}function sSb(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;do if(a>>>0<=999999999){if(a>>>0<100){if(a>>>0>9){d=a;e=c;break}b[c>>0]=a+48;f=c+1|0;b[f>>0]=0;return f|0}if(a>>>0<1e4){if(a>>>0>999){g=a;h=c;i=8;break}j=(a>>>0)/100|0;b[c>>0]=j+48;k=j;l=a;m=c+1|0;i=9;break}if(a>>>0<1e6){if(a>>>0>99999){n=a;o=c;i=6;break}j=(a>>>0)/1e4|0;b[c>>0]=j+48;p=j;q=a;r=c+1|0;i=7;break}if(a>>>0>=1e8){j=(a>>>0)/1e8|0;b[c>>0]=j+48;s=j;t=c+1|0;i=3;break}if(a>>>0>9999999){u=a;v=c;i=4}else{j=(a>>>0)/1e6|0;b[c>>0]=j+48;w=j;x=a;y=c+1|0;i=5}}else{j=(a>>>0)/1e8|0;b[c>>0]=b[481510+(j<<1)>>0]|0;b[c+1>>0]=b[481510+(j<<1)+1>>0]|0;s=j;t=c+2|0;i=3}while(0);if((i|0)==3){u=(Y(s,-1e8)|0)+a|0;v=t;i=4}if((i|0)==4){t=(u>>>0)/1e6|0;b[v>>0]=b[481510+(t<<1)>>0]|0;b[v+1>>0]=b[481510+(t<<1)+1>>0]|0;w=t;x=u;y=v+2|0;i=5}if((i|0)==5){n=(Y(w,-1e6)|0)+x|0;o=y;i=6}if((i|0)==6){y=(n>>>0)/1e4|0;b[o>>0]=b[481510+(y<<1)>>0]|0;b[o+1>>0]=b[481510+(y<<1)+1>>0]|0;p=y;q=n;r=o+2|0;i=7}if((i|0)==7){g=(Y(p,-1e4)|0)+q|0;h=r;i=8}if((i|0)==8){r=(g>>>0)/100|0;b[h>>0]=b[481510+(r<<1)>>0]|0;b[h+1>>0]=b[481510+(r<<1)+1>>0]|0;k=r;l=g;m=h+2|0;i=9}if((i|0)==9){d=(Y(k,-100)|0)+l|0;e=m}b[e>>0]=b[481510+(d<<1)>>0]|0;b[e+1>>0]=b[481510+(d<<1)+1>>0]|0;f=e+2|0;b[f>>0]=0;return f|0}function tSb(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)<0){b[c>>0]=45;d=0-a|0;e=c+1|0}else{d=a;e=c}return sSb(d,e)|0}function uSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0;if((a|0)==(a|0)&0==(c|0))return sSb(a,d)|0;else{e=Uac(a|0,c|0,1e9,0)|0;f=J;g=uSb(e,f,d)|0;d=cbc(e|0,f|0,-1e9,-1)|0;f=Kac(d|0,J|0,a|0,c|0)|0;c=(f>>>0)/1e7|0;b[g>>0]=b[481510+(c<<1)>>0]|0;b[g+1>>0]=b[481510+(c<<1)+1>>0]|0;a=(Y(c,-1e7)|0)+f|0;f=(a>>>0)/1e5|0;b[g+2>>0]=b[481510+(f<<1)>>0]|0;b[g+3>>0]=b[481510+(f<<1)+1>>0]|0;c=(Y(f,-1e5)|0)+a|0;a=(c>>>0)/1e3|0;b[g+4>>0]=b[481510+(a<<1)>>0]|0;b[g+5>>0]=b[481510+(a<<1)+1>>0]|0;f=(Y(a,-1e3)|0)+c|0;c=(f>>>0)/10|0;b[g+6>>0]=b[481510+(c<<1)>>0]|0;b[g+7>>0]=b[481510+(c<<1)+1>>0]|0;a=f+48+(Y(c,-10)|0)&255;c=g+9|0;b[g+8>>0]=a;b[c>>0]=0;return c|0}return 0}function vSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=e+10|0;b[e+11>>0]=0;if((c|0)>-1){h=g;i=c;while(1){b[h>>0]=((i|0)%10|0)+48;if((i|0)>9){h=h+-1|0;i=(i|0)/10|0}else{j=h;break}}}else{if((c|0)>-10){b[g>>0]=48-c;k=e+9|0}else{h=-10-c|0;b[g>>0]=((h|0)%10|0)+48;g=e+9|0;e=((h|0)/10|0)+1|0;while(1){h=g+-1|0;b[g>>0]=((e|0)%10|0)+48;if((e|0)>9){g=h;e=(e|0)/10|0}else{k=h;break}}}b[k>>0]=45;j=k};f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;k=kUb(j)|0;if(k>>>0>4294967279)V5b(a);if(k>>>0<11){b[a+11>>0]=k;if(!k){l=a;m=l+k|0;b[m>>0]=0;u=d;return}else n=a}else{e=k+16&-16;g=L5b(e)|0;f[a>>2]=g;f[a+8>>2]=e|-2147483648;f[a+4>>2]=k;n=g}Vac(n|0,j|0,k|0)|0;l=n;m=l+k|0;b[m>>0]=0;u=d;return}function wSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+32|0;e=d;g=sSb(c,e)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;c=g-e|0;if(c>>>0>4294967279)V5b(a);if(c>>>0<11){b[a+11>>0]=c;h=a}else{i=c+16&-16;j=L5b(i)|0;f[a>>2]=j;f[a+8>>2]=i|-2147483648;f[a+4>>2]=c;h=j}if((e|0)==(g|0)){k=h;b[k>>0]=0;u=d;return}else{l=h;m=e}while(1){b[l>>0]=b[m>>0]|0;m=m+1|0;if((m|0)==(g|0))break;else l=l+1|0}k=h+c|0;b[k>>0]=0;u=d;return}function xSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+32|0;g=e;h=g+20|0;b[g+21>>0]=0;if((d|0)>-1|(d|0)==-1&c>>>0>4294967295){i=h;j=c;k=d;while(1){l=Qac(j|0,k|0,10,0)|0;m=Kac(l|0,J|0,48,0)|0;b[i>>0]=m;m=j;j=abc(j|0,k|0,10,0)|0;if(!((k|0)>0|(k|0)==0&m>>>0>9)){n=i;break}else{i=i+-1|0;k=J}}}else{if((d|0)>-1|(d|0)==-1&c>>>0>4294967286){k=Jac(48,0,c|0,d|0)|0;b[h>>0]=k;o=g+19|0}else{k=Jac(-10,-1,c|0,d|0)|0;d=J;c=Qac(k|0,d|0,10,0)|0;i=Kac(c|0,J|0,48,0)|0;b[h>>0]=i;i=abc(k|0,d|0,10,0)|0;d=Kac(i|0,J|0,1,0)|0;i=g+19|0;g=d;d=J;while(1){k=Qac(g|0,d|0,10,0)|0;h=Kac(k|0,J|0,48,0)|0;k=i+-1|0;b[i>>0]=h;h=g;g=abc(g|0,d|0,10,0)|0;if(!((d|0)>0|(d|0)==0&h>>>0>9)){o=k;break}else{i=k;d=J}}}b[o>>0]=45;n=o};f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;o=kUb(n)|0;if(o>>>0>4294967279)V5b(a);if(o>>>0<11){b[a+11>>0]=o;if(!o){p=a;q=p+o|0;b[q>>0]=0;u=e;return}else r=a}else{d=o+16&-16;i=L5b(d)|0;f[a>>2]=i;f[a+8>>2]=d|-2147483648;f[a+4>>2]=o;r=i}Vac(r|0,n|0,o|0)|0;p=r;q=p+o|0;b[q>>0]=0;u=e;return}function ySb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+32|0;g=e;h=uSb(c,d,g)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;d=h-g|0;if(d>>>0>4294967279)V5b(a);if(d>>>0<11){b[a+11>>0]=d;i=a}else{c=d+16&-16;j=L5b(c)|0;f[a>>2]=j;f[a+8>>2]=c|-2147483648;f[a+4>>2]=d;i=j}if((g|0)==(h|0)){k=i;b[k>>0]=0;u=e;return}else{l=i;m=g}while(1){b[l>>0]=b[m>>0]|0;m=m+1|0;if((m|0)==(h|0))break;else l=l+1|0}k=i+d|0;b[k>>0]=0;u=e;return}function zSb(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=ASb(c,d)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=kUb(e)|0;if(g>>>0>4294967279)V5b(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;u=d;return}else j=a}else{k=g+16&-16;l=L5b(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}Vac(j|0,e|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;u=d;return}function ASb(a,c){a=+a;c=c|0;var d=0,e=0,g=0,h=0,i=0.0,j=0,k=0;d=u;u=u+32|0;e=d+16|0;g=d;if(a==D){b[c>>0]=105;b[c+1>>0]=110;b[c+2>>0]=102;b[c+3>>0]=0;u=d;return c|0}if(a==-D){b[c>>0]=b[481710]|0;b[c+1>>0]=b[481711]|0;b[c+2>>0]=b[481712]|0;b[c+3>>0]=b[481713]|0;b[c+4>>0]=b[481714]|0;u=d;return c|0}p[s>>3]=a;h=f[s+4>>2]&2147483647;if(h>>>0>2146435072|(h|0)==2146435072&(f[s>>2]|0)>>>0>0){b[c>>0]=110;b[c+1>>0]=97;b[c+2>>0]=110;b[c+3>>0]=0;u=d;return c|0}f[g>>2]=15;p[g+8>>3]=a;GUb(c,32,481715,g)|0;i=+PVb(c,0);p[g>>3]=i;if(+p[g>>3]!=a){f[e>>2]=17;p[e+8>>3]=a;GUb(c,32,481715,e)|0}a:do if(!(uUb(c,46)|0)){e=c;b:while(1){g=b[e>>0]|0;if((g+-48&255)>=10)switch(g<<24>>24){case 0:{break a;break}case 45:case 43:case 69:case 101:break;default:break b}e=e+1|0}b[e>>0]=46;g=e+1|0;h=b[g>>0]|0;if((h+-48&255)>=10){switch(h<<24>>24){case 0:case 45:case 43:case 69:case 101:{break a;break}default:j=g}c:while(1){k=j+1|0;h=b[k>>0]|0;if((h+-48&255)<10)break;switch(h<<24>>24){case 0:case 45:case 43:case 69:case 101:{break c;break}default:j=k}}Xac(g|0,k|0,(kUb(k)|0)+1|0)|0}}while(0);u=d;return c|0}function BSb(a,c){a=a|0;c=+c;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=CSb(c,d)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=kUb(e)|0;if(g>>>0>4294967279)V5b(a);if(g>>>0<11){b[a+11>>0]=g;if(!g){h=a;i=h+g|0;b[i>>0]=0;u=d;return}else j=a}else{k=g+16&-16;l=L5b(k)|0;f[a>>2]=l;f[a+8>>2]=k|-2147483648;f[a+4>>2]=g;j=l}Vac(j|0,e|0,g|0)|0;h=j;i=h+g|0;b[i>>0]=0;u=d;return}function CSb(a,c){a=+a;c=c|0;var d=0,e=0,g=0,h=0.0,i=0,j=0.0,k=0,l=0,m=0,o=0;d=u;u=u+32|0;e=d+16|0;g=d;h=a;if(a==D){b[c>>0]=105;b[c+1>>0]=110;b[c+2>>0]=102;b[c+3>>0]=0;u=d;return c|0}if(a==-D){b[c>>0]=b[481710]|0;b[c+1>>0]=b[481711]|0;b[c+2>>0]=b[481712]|0;b[c+3>>0]=b[481713]|0;b[c+4>>0]=b[481714]|0;u=d;return c|0}if(((n[s>>2]=a,f[s>>2]|0)&2147483647)>>>0>2139095040){b[c>>0]=110;b[c+1>>0]=97;b[c+2>>0]=110;b[c+3>>0]=0;u=d;return c|0}f[g>>2]=6;p[g+8>>3]=h;GUb(c,24,481715,g)|0;i=ZSb()|0;f[i>>2]=0;j=+NVb(c,g);if((b[c>>0]|0)!=0?(b[f[g>>2]>>0]|0)==0:0){g=ZSb()|0;if(j!=a|(f[g>>2]|0)!=0)k=11}else k=11;if((k|0)==11){f[e>>2]=8;p[e+8>>3]=h;GUb(c,24,481715,e)|0}if(!(uUb(c,46)|0))l=c;else{u=d;return c|0}a:while(1){e=b[l>>0]|0;if((e+-48&255)>=10)switch(e<<24>>24){case 0:{k=21;break a;break}case 45:case 43:case 69:case 101:break;default:break a}l=l+1|0}if((k|0)==21){u=d;return c|0}b[l>>0]=46;k=l+1|0;l=b[k>>0]|0;if((l+-48&255)<10){u=d;return c|0}switch(l<<24>>24){case 0:case 45:case 43:case 69:case 101:{u=d;return c|0}default:m=k}b:while(1){o=m+1|0;l=b[o>>0]|0;if((l+-48&255)<10)break;switch(l<<24>>24){case 0:case 45:case 43:case 69:case 101:{break b;break}default:m=o}}Xac(k|0,o|0,(kUb(o)|0)+1|0)|0;u=d;return c|0}function DSb(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;X5b(e,a);a=ESb(e,c)|0;if((b[e+11>>0]|0)>=0){u=d;return a|0}O5b(f[e>>2]|0);u=d;return a|0}function ESb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+16|0;e=d+12|0;g=d;f[c>>2]=0;if(!(FSb(a,e)|0)){h=0;u=d;return h|0}if(b[e>>0]|0){e=b[a+11>>0]|0;i=e<<24>>24<0;j=i?f[a>>2]|0:a;k=i?f[a+4>>2]|0:e&255;e=j+k|0;a:do if((k|0)>0){i=0;l=j;while(1){m=b[l>>0]|0;n=m&255;o=n+-48|0;if((m&255)<48|(o|0)>9){p=0;q=i;break a}if((i|0)<-214748364){p=0;q=-2147483648;break a}m=i*10|0;if((m|0)<(n+2147483600|0)){p=0;q=-2147483648;break a}n=m-o|0;l=l+1|0;if(l>>>0>=e>>>0){p=1;q=n;break}else i=n}}else{p=1;q=0}while(0);f[c>>2]=q;h=p;u=d;return h|0}X5b(g,a);a=b[g+11>>0]|0;p=a<<24>>24<0;q=f[g>>2]|0;e=p?q:g;j=p?f[g+4>>2]|0:a&255;a=e+j|0;b:do if((j|0)>0){g=0;k=e;while(1){i=b[k>>0]|0;l=i&255;n=l+-48|0;if((i&255)<48|(n|0)>9){r=0;s=g;break b}if((g|0)>214748364){r=0;s=2147483647;break b}i=g*10|0;if((i|0)>(-2147483601-l|0)){r=0;s=2147483647;break b}l=n+i|0;k=k+1|0;if(k>>>0>=a>>>0){r=1;s=l;break}else g=l}}else{r=1;s=0}while(0);f[c>>2]=s;if(!p){h=r;u=d;return h|0}O5b(q);h=r;u=d;return h|0}function FSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;g=b[a+11>>0]|0;h=g<<24>>24<0;if(h){i=f[a>>2]|0;j=f[a+4>>2]|0}else{i=a;j=g&255}g=i+j|0;a:do if((j|0)>0){k=i;while(1){if((b[k>>0]|0)!=32){l=k;break a}m=k+1|0;if(m>>>0<g>>>0)k=m;else{l=m;break}}}else l=i;while(0);i=g;while(1){if(l>>>0>=i>>>0){n=0;o=19;break}g=i+-1|0;if((b[g>>0]|0)==32)i=g;else break}if((o|0)==19){u=d;return n|0}o=(b[l>>0]|0)==45;b[c>>0]=o&1;if(!o?(b[l>>0]|0)!=43:0)p=l;else{o=l+1|0;if(o>>>0<i>>>0)p=o;else{n=0;u=d;return n|0}}if(h)q=f[a>>2]|0;else q=a;h=p;Y5b(e,a,h-q|0,i-h|0,a);_5b(a,e)|0;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);n=1;u=d;return n|0}function GSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=a+40|0;e=c;g=f[e>>2]|0;h=f[e+4>>2]|0;e=$ac(f[c+8>>2]|0,0,2)|0;c=Kac(e|0,J|0,-4,-1)|0;e=$ac(1,0,c|0)|0;c=d;i=g;j=h;k=e|g;g=J|h;do{c=c+-1|0;b[c>>0]=b[481493+(i&15)>>0]|0;i=Sac(i|0,j|0,4)|0;j=J;k=Sac(k|0,g|0,4)|0;g=J}while(!((k|0)==0&(g|0)==0));f[a>>2]=c;f[a+4>>2]=d-c;return}function HSb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=c+4|0;h=d+4|0;i=e+4|0;e6b(a,(f[h>>2]|0)+(f[g>>2]|0)+(f[i>>2]|0)|0,0);if((b[a+11>>0]|0)<0)j=f[a>>2]|0;else j=a;Vac(j|0,f[c>>2]|0,f[g>>2]|0)|0;c=j+(f[g>>2]|0)|0;Vac(c|0,f[d>>2]|0,f[h>>2]|0)|0;Vac(c+(f[h>>2]|0)|0,f[e>>2]|0,f[i>>2]|0)|0;return}function ISb(a,b){a=a|0;b=b|0;j6b(a,f[b>>2]|0,f[b+4>>2]|0)|0;return}function JSb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=b[a+11>>0]|0;i=g<<24>>24<0;j=i?f[a>>2]|0:a;k=i?f[a+4>>2]|0:g&255;g=j;i=j+k|0;do{if((i|0)==(j|0)){l=0;m=9;break}i=i+-1|0}while(!(xTb(489196,h[i>>0]|0,1)|0));if((m|0)==9){u=d;return l|0}m=i-g|0;if((m|0)==-1){l=0;u=d;return l|0}g=m+1|0;if((g|0)==(k|0)){l=0;u=d;return l|0}Y5b(e,a,g,-1,a);_5b(c,e)|0;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);l=1;u=d;return l|0}function KSb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;zh[f[(f[a>>2]|0)+96>>2]&2047](g,a);a=f[g>>2]|0;g=f[a+4>>2]|0;h=b[g+11>>0]|0;if(((h<<24>>24<0?f[g+4>>2]|0:h&255)|0)!=19){i=0;u=e;return i|0}if(u6b(g,0,-1,481720,19)|0){i=0;u=e;return i|0}g=oub(a,1)|0;f[c>>2]=g;g=oub(a,2)|0;f[d>>2]=g;d=f[c>>2]|0;if(!d){i=0;u=e;return i|0}if((g|0)==0?1:(f[d+32>>2]|0)!=9){i=0;u=e;return i|0}i=(f[g+32>>2]|0)==12;u=e;return i|0}function LSb(){MSb(0);return}function MSb(a){a=a|0;kf(25504,490540);Rd(25520,490545,1,1,0);ye(25528,490314,1,-128,127);ye(25544,490319,1,-128,127);ye(25536,490331,1,0,255);ye(25552,490345,2,-32768,32767);ye(25560,490351,2,0,65535);ye(25568,490550,4,-2147483648,2147483647);ye(25576,490554,4,0,-1);ye(25584,490567,4,-2147483648,2147483647);ye(25592,490572,4,0,-1);Af(25600,490596,4);Af(25608,490708,8);rd(8992,489923);rd(23824,481782);rf(23848,4,481815);Vd(8368,481828);bf(8880,0,481844);bf(23872,0,481874);bf(8872,1,481911);bf(8896,2,481950);bf(8888,3,481981);bf(8904,4,482021);bf(23880,5,482050);bf(23888,4,482088);bf(23896,5,482118);bf(23872,0,482157);bf(8872,1,482189);bf(8896,2,482222);bf(8888,3,482255);bf(8904,4,482289);bf(23880,5,482322);bf(8912,6,482356);bf(8920,7,482387);bf(23904,7,482419);return}function NSb(a){a=a|0;return WUb(f[a+4>>2]|0)|0}function OSb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;b=u;u=u+16|0;c=b;do if(a>>>0<245){d=a>>>0<11?16:a+11&-8;e=d>>>3;g=f[213459]|0;h=g>>>e;if(h&3|0){i=(h&1^1)+e|0;j=853876+(i<<1<<2)|0;k=j+8|0;l=f[k>>2]|0;m=l+8|0;n=f[m>>2]|0;if((j|0)==(n|0))f[213459]=g&~(1<<i);else{f[n+12>>2]=j;f[k>>2]=n}n=i<<3;f[l+4>>2]=n|3;i=l+n+4|0;f[i>>2]=f[i>>2]|1;o=m;u=b;return o|0}m=f[213461]|0;if(d>>>0>m>>>0){if(h|0){i=2<<e;n=h<<e&(i|0-i);i=(n&0-n)+-1|0;n=i>>>12&16;e=i>>>n;i=e>>>5&8;h=e>>>i;e=h>>>2&4;l=h>>>e;h=l>>>1&2;k=l>>>h;l=k>>>1&1;j=(i|n|e|h|l)+(k>>>l)|0;l=853876+(j<<1<<2)|0;k=l+8|0;h=f[k>>2]|0;e=h+8|0;n=f[e>>2]|0;if((l|0)==(n|0)){i=g&~(1<<j);f[213459]=i;p=i}else{f[n+12>>2]=l;f[k>>2]=n;p=g}n=(j<<3)-d|0;f[h+4>>2]=d|3;j=h+d|0;f[j+4>>2]=n|1;f[j+n>>2]=n;if(m|0){h=f[213464]|0;k=m>>>3;l=853876+(k<<1<<2)|0;i=1<<k;if(!(p&i)){f[213459]=p|i;q=l;r=l+8|0}else{i=l+8|0;q=f[i>>2]|0;r=i}f[r>>2]=h;f[q+12>>2]=h;f[h+8>>2]=q;f[h+12>>2]=l}f[213461]=n;f[213464]=j;o=e;u=b;return o|0}e=f[213460]|0;if(e){j=(e&0-e)+-1|0;n=j>>>12&16;l=j>>>n;j=l>>>5&8;h=l>>>j;l=h>>>2&4;i=h>>>l;h=i>>>1&2;k=i>>>h;i=k>>>1&1;s=f[854140+((j|n|l|h|i)+(k>>>i)<<2)>>2]|0;i=(f[s+4>>2]&-8)-d|0;k=f[s+16+(((f[s+16>>2]|0)==0&1)<<2)>>2]|0;if(!k){t=s;v=i}else{h=s;s=i;i=k;while(1){k=(f[i+4>>2]&-8)-d|0;l=k>>>0<s>>>0;n=l?k:s;k=l?i:h;i=f[i+16+(((f[i+16>>2]|0)==0&1)<<2)>>2]|0;if(!i){t=k;v=n;break}else{h=k;s=n}}}s=t+d|0;if(t>>>0<s>>>0){h=f[t+24>>2]|0;i=f[t+12>>2]|0;do if((i|0)==(t|0)){n=t+20|0;k=f[n>>2]|0;if(!k){l=t+16|0;j=f[l>>2]|0;if(!j){w=0;break}else{x=j;y=l}}else{x=k;y=n}while(1){n=x+20|0;k=f[n>>2]|0;if(k|0){x=k;y=n;continue}n=x+16|0;k=f[n>>2]|0;if(!k)break;else{x=k;y=n}}f[y>>2]=0;w=x}else{n=f[t+8>>2]|0;f[n+12>>2]=i;f[i+8>>2]=n;w=i}while(0);do if(h|0){i=f[t+28>>2]|0;n=854140+(i<<2)|0;if((t|0)==(f[n>>2]|0)){f[n>>2]=w;if(!w){f[213460]=e&~(1<<i);break}}else{f[h+16+(((f[h+16>>2]|0)!=(t|0)&1)<<2)>>2]=w;if(!w)break}f[w+24>>2]=h;i=f[t+16>>2]|0;if(i|0){f[w+16>>2]=i;f[i+24>>2]=w}i=f[t+20>>2]|0;if(i|0){f[w+20>>2]=i;f[i+24>>2]=w}}while(0);if(v>>>0<16){h=v+d|0;f[t+4>>2]=h|3;e=t+h+4|0;f[e>>2]=f[e>>2]|1}else{f[t+4>>2]=d|3;f[s+4>>2]=v|1;f[s+v>>2]=v;if(m|0){e=f[213464]|0;h=m>>>3;i=853876+(h<<1<<2)|0;n=1<<h;if(!(g&n)){f[213459]=g|n;z=i;A=i+8|0}else{n=i+8|0;z=f[n>>2]|0;A=n}f[A>>2]=e;f[z+12>>2]=e;f[e+8>>2]=z;f[e+12>>2]=i}f[213461]=v;f[213464]=s}o=t+8|0;u=b;return o|0}else B=d}else B=d}else B=d}else if(a>>>0<=4294967231){i=a+11|0;e=i&-8;n=f[213460]|0;if(n){h=0-e|0;k=i>>>8;if(k)if(e>>>0>16777215)C=31;else{i=(k+1048320|0)>>>16&8;l=k<<i;k=(l+520192|0)>>>16&4;j=l<<k;l=(j+245760|0)>>>16&2;D=14-(k|i|l)+(j<<l>>>15)|0;C=e>>>(D+7|0)&1|D<<1}else C=0;D=f[854140+(C<<2)>>2]|0;a:do if(!D){E=0;F=0;G=h;H=57}else{l=0;j=h;i=D;k=e<<((C|0)==31?0:25-(C>>>1)|0);I=0;while(1){J=(f[i+4>>2]&-8)-e|0;if(J>>>0<j>>>0)if(!J){K=i;L=0;M=i;H=61;break a}else{N=i;O=J}else{N=l;O=j}J=f[i+20>>2]|0;i=f[i+16+(k>>>31<<2)>>2]|0;P=(J|0)==0|(J|0)==(i|0)?I:J;J=(i|0)==0;if(J){E=P;F=N;G=O;H=57;break}else{l=N;j=O;k=k<<((J^1)&1);I=P}}}while(0);if((H|0)==57){if((E|0)==0&(F|0)==0){D=2<<C;h=n&(D|0-D);if(!h){B=e;break}D=(h&0-h)+-1|0;h=D>>>12&16;d=D>>>h;D=d>>>5&8;s=d>>>D;d=s>>>2&4;g=s>>>d;s=g>>>1&2;m=g>>>s;g=m>>>1&1;Q=0;R=f[854140+((D|h|d|s|g)+(m>>>g)<<2)>>2]|0}else{Q=F;R=E}if(!R){S=Q;T=G}else{K=Q;L=G;M=R;H=61}}if((H|0)==61)while(1){H=0;g=(f[M+4>>2]&-8)-e|0;m=g>>>0<L>>>0;s=m?g:L;g=m?M:K;M=f[M+16+(((f[M+16>>2]|0)==0&1)<<2)>>2]|0;if(!M){S=g;T=s;break}else{K=g;L=s;H=61}}if((S|0)!=0?T>>>0<((f[213461]|0)-e|0)>>>0:0){s=S+e|0;if(S>>>0>=s>>>0){o=0;u=b;return o|0}g=f[S+24>>2]|0;m=f[S+12>>2]|0;do if((m|0)==(S|0)){d=S+20|0;h=f[d>>2]|0;if(!h){D=S+16|0;I=f[D>>2]|0;if(!I){U=0;break}else{V=I;W=D}}else{V=h;W=d}while(1){d=V+20|0;h=f[d>>2]|0;if(h|0){V=h;W=d;continue}d=V+16|0;h=f[d>>2]|0;if(!h)break;else{V=h;W=d}}f[W>>2]=0;U=V}else{d=f[S+8>>2]|0;f[d+12>>2]=m;f[m+8>>2]=d;U=m}while(0);do if(g){m=f[S+28>>2]|0;d=854140+(m<<2)|0;if((S|0)==(f[d>>2]|0)){f[d>>2]=U;if(!U){d=n&~(1<<m);f[213460]=d;X=d;break}}else{f[g+16+(((f[g+16>>2]|0)!=(S|0)&1)<<2)>>2]=U;if(!U){X=n;break}}f[U+24>>2]=g;d=f[S+16>>2]|0;if(d|0){f[U+16>>2]=d;f[d+24>>2]=U}d=f[S+20>>2]|0;if(d){f[U+20>>2]=d;f[d+24>>2]=U;X=n}else X=n}else X=n;while(0);do if(T>>>0>=16){f[S+4>>2]=e|3;f[s+4>>2]=T|1;f[s+T>>2]=T;n=T>>>3;if(T>>>0<256){g=853876+(n<<1<<2)|0;d=f[213459]|0;m=1<<n;if(!(d&m)){f[213459]=d|m;Y=g;Z=g+8|0}else{m=g+8|0;Y=f[m>>2]|0;Z=m}f[Z>>2]=s;f[Y+12>>2]=s;f[s+8>>2]=Y;f[s+12>>2]=g;break}g=T>>>8;if(g)if(T>>>0>16777215)_=31;else{m=(g+1048320|0)>>>16&8;d=g<<m;g=(d+520192|0)>>>16&4;n=d<<g;d=(n+245760|0)>>>16&2;h=14-(g|m|d)+(n<<d>>>15)|0;_=T>>>(h+7|0)&1|h<<1}else _=0;h=854140+(_<<2)|0;f[s+28>>2]=_;d=s+16|0;f[d+4>>2]=0;f[d>>2]=0;d=1<<_;if(!(X&d)){f[213460]=X|d;f[h>>2]=s;f[s+24>>2]=h;f[s+12>>2]=s;f[s+8>>2]=s;break}d=T<<((_|0)==31?0:25-(_>>>1)|0);n=f[h>>2]|0;while(1){if((f[n+4>>2]&-8|0)==(T|0)){H=97;break}$=n+16+(d>>>31<<2)|0;h=f[$>>2]|0;if(!h){H=96;break}else{d=d<<1;n=h}}if((H|0)==96){f[$>>2]=s;f[s+24>>2]=n;f[s+12>>2]=s;f[s+8>>2]=s;break}else if((H|0)==97){d=n+8|0;h=f[d>>2]|0;f[h+12>>2]=s;f[d>>2]=s;f[s+8>>2]=h;f[s+12>>2]=n;f[s+24>>2]=0;break}}else{h=T+e|0;f[S+4>>2]=h|3;d=S+h+4|0;f[d>>2]=f[d>>2]|1}while(0);o=S+8|0;u=b;return o|0}else B=e}else B=e}else B=-1;while(0);S=f[213461]|0;if(S>>>0>=B>>>0){T=S-B|0;$=f[213464]|0;if(T>>>0>15){_=$+B|0;f[213464]=_;f[213461]=T;f[_+4>>2]=T|1;f[_+T>>2]=T;f[$+4>>2]=B|3}else{f[213461]=0;f[213464]=0;f[$+4>>2]=S|3;T=$+S+4|0;f[T>>2]=f[T>>2]|1}o=$+8|0;u=b;return o|0}$=f[213462]|0;if($>>>0>B>>>0){T=$-B|0;f[213462]=T;S=f[213465]|0;_=S+B|0;f[213465]=_;f[_+4>>2]=T|1;f[S+4>>2]=B|3;o=S+8|0;u=b;return o|0}if(!(f[213577]|0)){f[213579]=4096;f[213578]=4096;f[213580]=-1;f[213581]=-1;f[213582]=0;f[213570]=0;S=c&-16^1431655768;f[c>>2]=S;f[213577]=S;aa=4096}else aa=f[213579]|0;S=B+48|0;c=B+47|0;T=aa+c|0;_=0-aa|0;aa=T&_;if(aa>>>0<=B>>>0){o=0;u=b;return o|0}X=f[213569]|0;if(X|0?(Y=f[213567]|0,Z=Y+aa|0,Z>>>0<=Y>>>0|Z>>>0>X>>>0):0){o=0;u=b;return o|0}b:do if(!(f[213570]&4)){X=f[213465]|0;c:do if(X){Z=854284;while(1){Y=f[Z>>2]|0;if(Y>>>0<=X>>>0?(ba=Z+4|0,(Y+(f[ba>>2]|0)|0)>>>0>X>>>0):0)break;Y=f[Z+8>>2]|0;if(!Y){H=118;break c}else Z=Y}n=T-$&_;if(n>>>0<2147483647){Y=Wac(n|0)|0;if((Y|0)==((f[Z>>2]|0)+(f[ba>>2]|0)|0))if((Y|0)==(-1|0))ca=n;else{da=n;ea=Y;H=135;break b}else{fa=Y;ga=n;H=126}}else ca=0}else H=118;while(0);do if((H|0)==118){X=Wac(0)|0;if((X|0)!=(-1|0)?(e=X,n=f[213578]|0,Y=n+-1|0,U=((Y&e|0)==0?0:(Y+e&0-n)-e|0)+aa|0,e=f[213567]|0,n=U+e|0,U>>>0>B>>>0&U>>>0<2147483647):0){Y=f[213569]|0;if(Y|0?n>>>0<=e>>>0|n>>>0>Y>>>0:0){ca=0;break}Y=Wac(U|0)|0;if((Y|0)==(X|0)){da=U;ea=X;H=135;break b}else{fa=Y;ga=U;H=126}}else ca=0}while(0);do if((H|0)==126){U=0-ga|0;if(!(S>>>0>ga>>>0&(ga>>>0<2147483647&(fa|0)!=(-1|0))))if((fa|0)==(-1|0)){ca=0;break}else{da=ga;ea=fa;H=135;break b}Y=f[213579]|0;X=c-ga+Y&0-Y;if(X>>>0>=2147483647){da=ga;ea=fa;H=135;break b}if((Wac(X|0)|0)==(-1|0)){Wac(U|0)|0;ca=0;break}else{da=X+ga|0;ea=fa;H=135;break b}}while(0);f[213570]=f[213570]|4;ha=ca;H=133}else{ha=0;H=133}while(0);if(((H|0)==133?aa>>>0<2147483647:0)?(ca=Wac(aa|0)|0,aa=Wac(0)|0,fa=aa-ca|0,ga=fa>>>0>(B+40|0)>>>0,!((ca|0)==(-1|0)|ga^1|ca>>>0<aa>>>0&((ca|0)!=(-1|0)&(aa|0)!=(-1|0))^1)):0){da=ga?fa:ha;ea=ca;H=135}if((H|0)==135){ca=(f[213567]|0)+da|0;f[213567]=ca;if(ca>>>0>(f[213568]|0)>>>0)f[213568]=ca;ca=f[213465]|0;do if(ca){ha=854284;while(1){ia=f[ha>>2]|0;ja=ha+4|0;ka=f[ja>>2]|0;if((ea|0)==(ia+ka|0)){H=145;break}fa=f[ha+8>>2]|0;if(!fa)break;else ha=fa}if(((H|0)==145?(f[ha+12>>2]&8|0)==0:0)?ca>>>0<ea>>>0&ca>>>0>=ia>>>0:0){f[ja>>2]=ka+da;fa=ca+8|0;ga=(fa&7|0)==0?0:0-fa&7;fa=ca+ga|0;aa=(f[213462]|0)+(da-ga)|0;f[213465]=fa;f[213462]=aa;f[fa+4>>2]=aa|1;f[fa+aa+4>>2]=40;f[213466]=f[213581];break}if(ea>>>0<(f[213463]|0)>>>0)f[213463]=ea;aa=ea+da|0;fa=854284;while(1){if((f[fa>>2]|0)==(aa|0)){H=153;break}ga=f[fa+8>>2]|0;if(!ga)break;else fa=ga}if((H|0)==153?(f[fa+12>>2]&8|0)==0:0){f[fa>>2]=ea;ha=fa+4|0;f[ha>>2]=(f[ha>>2]|0)+da;ha=ea+8|0;ga=ea+((ha&7|0)==0?0:0-ha&7)|0;ha=aa+8|0;c=aa+((ha&7|0)==0?0:0-ha&7)|0;ha=ga+B|0;S=c-ga-B|0;f[ga+4>>2]=B|3;do if((c|0)!=(ca|0)){if((c|0)==(f[213464]|0)){ba=(f[213461]|0)+S|0;f[213461]=ba;f[213464]=ha;f[ha+4>>2]=ba|1;f[ha+ba>>2]=ba;break}ba=f[c+4>>2]|0;if((ba&3|0)==1){_=ba&-8;$=ba>>>3;d:do if(ba>>>0<256){T=f[c+8>>2]|0;X=f[c+12>>2]|0;if((X|0)==(T|0)){f[213459]=f[213459]&~(1<<$);break}else{f[T+12>>2]=X;f[X+8>>2]=T;break}}else{T=f[c+24>>2]|0;X=f[c+12>>2]|0;do if((X|0)==(c|0)){U=c+16|0;Y=U+4|0;n=f[Y>>2]|0;if(!n){e=f[U>>2]|0;if(!e){la=0;break}else{ma=e;na=U}}else{ma=n;na=Y}while(1){Y=ma+20|0;n=f[Y>>2]|0;if(n|0){ma=n;na=Y;continue}Y=ma+16|0;n=f[Y>>2]|0;if(!n)break;else{ma=n;na=Y}}f[na>>2]=0;la=ma}else{Y=f[c+8>>2]|0;f[Y+12>>2]=X;f[X+8>>2]=Y;la=X}while(0);if(!T)break;X=f[c+28>>2]|0;Y=854140+(X<<2)|0;do if((c|0)!=(f[Y>>2]|0)){f[T+16+(((f[T+16>>2]|0)!=(c|0)&1)<<2)>>2]=la;if(!la)break d}else{f[Y>>2]=la;if(la|0)break;f[213460]=f[213460]&~(1<<X);break d}while(0);f[la+24>>2]=T;X=c+16|0;Y=f[X>>2]|0;if(Y|0){f[la+16>>2]=Y;f[Y+24>>2]=la}Y=f[X+4>>2]|0;if(!Y)break;f[la+20>>2]=Y;f[Y+24>>2]=la}while(0);oa=c+_|0;pa=_+S|0}else{oa=c;pa=S}$=oa+4|0;f[$>>2]=f[$>>2]&-2;f[ha+4>>2]=pa|1;f[ha+pa>>2]=pa;$=pa>>>3;if(pa>>>0<256){ba=853876+($<<1<<2)|0;Z=f[213459]|0;Y=1<<$;if(!(Z&Y)){f[213459]=Z|Y;qa=ba;ra=ba+8|0}else{Y=ba+8|0;qa=f[Y>>2]|0;ra=Y}f[ra>>2]=ha;f[qa+12>>2]=ha;f[ha+8>>2]=qa;f[ha+12>>2]=ba;break}ba=pa>>>8;do if(!ba)sa=0;else{if(pa>>>0>16777215){sa=31;break}Y=(ba+1048320|0)>>>16&8;Z=ba<<Y;$=(Z+520192|0)>>>16&4;X=Z<<$;Z=(X+245760|0)>>>16&2;n=14-($|Y|Z)+(X<<Z>>>15)|0;sa=pa>>>(n+7|0)&1|n<<1}while(0);ba=854140+(sa<<2)|0;f[ha+28>>2]=sa;_=ha+16|0;f[_+4>>2]=0;f[_>>2]=0;_=f[213460]|0;n=1<<sa;if(!(_&n)){f[213460]=_|n;f[ba>>2]=ha;f[ha+24>>2]=ba;f[ha+12>>2]=ha;f[ha+8>>2]=ha;break}n=pa<<((sa|0)==31?0:25-(sa>>>1)|0);_=f[ba>>2]|0;while(1){if((f[_+4>>2]&-8|0)==(pa|0)){H=194;break}ta=_+16+(n>>>31<<2)|0;ba=f[ta>>2]|0;if(!ba){H=193;break}else{n=n<<1;_=ba}}if((H|0)==193){f[ta>>2]=ha;f[ha+24>>2]=_;f[ha+12>>2]=ha;f[ha+8>>2]=ha;break}else if((H|0)==194){n=_+8|0;ba=f[n>>2]|0;f[ba+12>>2]=ha;f[n>>2]=ha;f[ha+8>>2]=ba;f[ha+12>>2]=_;f[ha+24>>2]=0;break}}else{ba=(f[213462]|0)+S|0;f[213462]=ba;f[213465]=ha;f[ha+4>>2]=ba|1}while(0);o=ga+8|0;u=b;return o|0}ha=854284;while(1){S=f[ha>>2]|0;if(S>>>0<=ca>>>0?(ua=S+(f[ha+4>>2]|0)|0,ua>>>0>ca>>>0):0)break;ha=f[ha+8>>2]|0}ha=ua+-47|0;ga=ha+8|0;S=ha+((ga&7|0)==0?0:0-ga&7)|0;ga=ca+16|0;ha=S>>>0<ga>>>0?ca:S;S=ha+8|0;c=ea+8|0;aa=(c&7|0)==0?0:0-c&7;c=ea+aa|0;fa=da+-40-aa|0;f[213465]=c;f[213462]=fa;f[c+4>>2]=fa|1;f[c+fa+4>>2]=40;f[213466]=f[213581];fa=ha+4|0;f[fa>>2]=27;f[S>>2]=f[213571];f[S+4>>2]=f[213572];f[S+8>>2]=f[213573];f[S+12>>2]=f[213574];f[213571]=ea;f[213572]=da;f[213574]=0;f[213573]=S;S=ha+24|0;do{c=S;S=S+4|0;f[S>>2]=7}while((c+8|0)>>>0<ua>>>0);if((ha|0)!=(ca|0)){S=ha-ca|0;f[fa>>2]=f[fa>>2]&-2;f[ca+4>>2]=S|1;f[ha>>2]=S;c=S>>>3;if(S>>>0<256){aa=853876+(c<<1<<2)|0;ba=f[213459]|0;n=1<<c;if(!(ba&n)){f[213459]=ba|n;va=aa;wa=aa+8|0}else{n=aa+8|0;va=f[n>>2]|0;wa=n}f[wa>>2]=ca;f[va+12>>2]=ca;f[ca+8>>2]=va;f[ca+12>>2]=aa;break}aa=S>>>8;if(aa)if(S>>>0>16777215)xa=31;else{n=(aa+1048320|0)>>>16&8;ba=aa<<n;aa=(ba+520192|0)>>>16&4;c=ba<<aa;ba=(c+245760|0)>>>16&2;Z=14-(aa|n|ba)+(c<<ba>>>15)|0;xa=S>>>(Z+7|0)&1|Z<<1}else xa=0;Z=854140+(xa<<2)|0;f[ca+28>>2]=xa;f[ca+20>>2]=0;f[ga>>2]=0;ba=f[213460]|0;c=1<<xa;if(!(ba&c)){f[213460]=ba|c;f[Z>>2]=ca;f[ca+24>>2]=Z;f[ca+12>>2]=ca;f[ca+8>>2]=ca;break}c=S<<((xa|0)==31?0:25-(xa>>>1)|0);ba=f[Z>>2]|0;while(1){if((f[ba+4>>2]&-8|0)==(S|0)){H=216;break}ya=ba+16+(c>>>31<<2)|0;Z=f[ya>>2]|0;if(!Z){H=215;break}else{c=c<<1;ba=Z}}if((H|0)==215){f[ya>>2]=ca;f[ca+24>>2]=ba;f[ca+12>>2]=ca;f[ca+8>>2]=ca;break}else if((H|0)==216){c=ba+8|0;S=f[c>>2]|0;f[S+12>>2]=ca;f[c>>2]=ca;f[ca+8>>2]=S;f[ca+12>>2]=ba;f[ca+24>>2]=0;break}}}else{S=f[213463]|0;if((S|0)==0|ea>>>0<S>>>0)f[213463]=ea;f[213571]=ea;f[213572]=da;f[213574]=0;f[213468]=f[213577];f[213467]=-1;S=0;do{c=853876+(S<<1<<2)|0;f[c+12>>2]=c;f[c+8>>2]=c;S=S+1|0}while((S|0)!=32);S=ea+8|0;ba=(S&7|0)==0?0:0-S&7;S=ea+ba|0;c=da+-40-ba|0;f[213465]=S;f[213462]=c;f[S+4>>2]=c|1;f[S+c+4>>2]=40;f[213466]=f[213581]}while(0);da=f[213462]|0;if(da>>>0>B>>>0){ea=da-B|0;f[213462]=ea;da=f[213465]|0;ca=da+B|0;f[213465]=ca;f[ca+4>>2]=ea|1;f[da+4>>2]=B|3;o=da+8|0;u=b;return o|0}}da=ZSb()|0;f[da>>2]=12;o=0;u=b;return o|0}function PSb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;if(!a)return;b=a+-8|0;c=f[213463]|0;d=f[a+-4>>2]|0;a=d&-8;e=b+a|0;do if(!(d&1)){g=f[b>>2]|0;if(!(d&3))return;h=b+(0-g)|0;i=g+a|0;if(h>>>0<c>>>0)return;if((h|0)==(f[213464]|0)){j=e+4|0;k=f[j>>2]|0;if((k&3|0)!=3){l=h;m=i;n=h;break}f[213461]=i;f[j>>2]=k&-2;f[h+4>>2]=i|1;f[h+i>>2]=i;return}k=g>>>3;if(g>>>0<256){g=f[h+8>>2]|0;j=f[h+12>>2]|0;if((j|0)==(g|0)){f[213459]=f[213459]&~(1<<k);l=h;m=i;n=h;break}else{f[g+12>>2]=j;f[j+8>>2]=g;l=h;m=i;n=h;break}}g=f[h+24>>2]|0;j=f[h+12>>2]|0;do if((j|0)==(h|0)){k=h+16|0;o=k+4|0;p=f[o>>2]|0;if(!p){q=f[k>>2]|0;if(!q){r=0;break}else{s=q;t=k}}else{s=p;t=o}while(1){o=s+20|0;p=f[o>>2]|0;if(p|0){s=p;t=o;continue}o=s+16|0;p=f[o>>2]|0;if(!p)break;else{s=p;t=o}}f[t>>2]=0;r=s}else{o=f[h+8>>2]|0;f[o+12>>2]=j;f[j+8>>2]=o;r=j}while(0);if(g){j=f[h+28>>2]|0;o=854140+(j<<2)|0;if((h|0)==(f[o>>2]|0)){f[o>>2]=r;if(!r){f[213460]=f[213460]&~(1<<j);l=h;m=i;n=h;break}}else{f[g+16+(((f[g+16>>2]|0)!=(h|0)&1)<<2)>>2]=r;if(!r){l=h;m=i;n=h;break}}f[r+24>>2]=g;j=h+16|0;o=f[j>>2]|0;if(o|0){f[r+16>>2]=o;f[o+24>>2]=r}o=f[j+4>>2]|0;if(o){f[r+20>>2]=o;f[o+24>>2]=r;l=h;m=i;n=h}else{l=h;m=i;n=h}}else{l=h;m=i;n=h}}else{l=b;m=a;n=b}while(0);if(n>>>0>=e>>>0)return;b=e+4|0;a=f[b>>2]|0;if(!(a&1))return;if(!(a&2)){r=f[213464]|0;if((e|0)==(f[213465]|0)){s=(f[213462]|0)+m|0;f[213462]=s;f[213465]=l;f[l+4>>2]=s|1;if((l|0)!=(r|0))return;f[213464]=0;f[213461]=0;return}if((e|0)==(r|0)){r=(f[213461]|0)+m|0;f[213461]=r;f[213464]=n;f[l+4>>2]=r|1;f[n+r>>2]=r;return}r=(a&-8)+m|0;s=a>>>3;do if(a>>>0<256){t=f[e+8>>2]|0;c=f[e+12>>2]|0;if((c|0)==(t|0)){f[213459]=f[213459]&~(1<<s);break}else{f[t+12>>2]=c;f[c+8>>2]=t;break}}else{t=f[e+24>>2]|0;c=f[e+12>>2]|0;do if((c|0)==(e|0)){d=e+16|0;o=d+4|0;j=f[o>>2]|0;if(!j){p=f[d>>2]|0;if(!p){u=0;break}else{v=p;w=d}}else{v=j;w=o}while(1){o=v+20|0;j=f[o>>2]|0;if(j|0){v=j;w=o;continue}o=v+16|0;j=f[o>>2]|0;if(!j)break;else{v=j;w=o}}f[w>>2]=0;u=v}else{o=f[e+8>>2]|0;f[o+12>>2]=c;f[c+8>>2]=o;u=c}while(0);if(t|0){c=f[e+28>>2]|0;h=854140+(c<<2)|0;if((e|0)==(f[h>>2]|0)){f[h>>2]=u;if(!u){f[213460]=f[213460]&~(1<<c);break}}else{f[t+16+(((f[t+16>>2]|0)!=(e|0)&1)<<2)>>2]=u;if(!u)break}f[u+24>>2]=t;c=e+16|0;h=f[c>>2]|0;if(h|0){f[u+16>>2]=h;f[h+24>>2]=u}h=f[c+4>>2]|0;if(h|0){f[u+20>>2]=h;f[h+24>>2]=u}}}while(0);f[l+4>>2]=r|1;f[n+r>>2]=r;if((l|0)==(f[213464]|0)){f[213461]=r;return}else x=r}else{f[b>>2]=a&-2;f[l+4>>2]=m|1;f[n+m>>2]=m;x=m}m=x>>>3;if(x>>>0<256){n=853876+(m<<1<<2)|0;a=f[213459]|0;b=1<<m;if(!(a&b)){f[213459]=a|b;y=n;z=n+8|0}else{b=n+8|0;y=f[b>>2]|0;z=b}f[z>>2]=l;f[y+12>>2]=l;f[l+8>>2]=y;f[l+12>>2]=n;return}n=x>>>8;if(n)if(x>>>0>16777215)A=31;else{y=(n+1048320|0)>>>16&8;z=n<<y;n=(z+520192|0)>>>16&4;b=z<<n;z=(b+245760|0)>>>16&2;a=14-(n|y|z)+(b<<z>>>15)|0;A=x>>>(a+7|0)&1|a<<1}else A=0;a=854140+(A<<2)|0;f[l+28>>2]=A;f[l+20>>2]=0;f[l+16>>2]=0;z=f[213460]|0;b=1<<A;do if(z&b){y=x<<((A|0)==31?0:25-(A>>>1)|0);n=f[a>>2]|0;while(1){if((f[n+4>>2]&-8|0)==(x|0)){B=73;break}C=n+16+(y>>>31<<2)|0;m=f[C>>2]|0;if(!m){B=72;break}else{y=y<<1;n=m}}if((B|0)==72){f[C>>2]=l;f[l+24>>2]=n;f[l+12>>2]=l;f[l+8>>2]=l;break}else if((B|0)==73){y=n+8|0;t=f[y>>2]|0;f[t+12>>2]=l;f[y>>2]=l;f[l+8>>2]=t;f[l+12>>2]=n;f[l+24>>2]=0;break}}else{f[213460]=z|b;f[a>>2]=l;f[l+24>>2]=a;f[l+12>>2]=l;f[l+8>>2]=l}while(0);l=(f[213467]|0)+-1|0;f[213467]=l;if(!l)D=854292;else return;while(1){l=f[D>>2]|0;if(!l)break;else D=l+8|0}f[213467]=-1;return}function QSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if(!a){c=OSb(b)|0;return c|0}if(b>>>0>4294967231){d=ZSb()|0;f[d>>2]=12;c=0;return c|0}d=RSb(a+-8|0,b>>>0<11?16:b+11&-8)|0;if(d|0){c=d+8|0;return c|0}d=OSb(b)|0;if(!d){c=0;return c|0}e=f[a+-4>>2]|0;g=(e&-8)-((e&3|0)==0?8:4)|0;Vac(d|0,a|0,(g>>>0<b>>>0?g:b)|0)|0;PSb(a);c=d;return c|0}function RSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[c>>2]|0;e=d&-8;g=a+e|0;if(!(d&3)){if(b>>>0<256){h=0;return h|0}if(e>>>0>=(b+4|0)>>>0?(e-b|0)>>>0<=f[213579]<<1>>>0:0){h=a;return h|0}h=0;return h|0}if(e>>>0>=b>>>0){i=e-b|0;if(i>>>0<=15){h=a;return h|0}j=a+b|0;f[c>>2]=d&1|b|2;f[j+4>>2]=i|3;k=j+i+4|0;f[k>>2]=f[k>>2]|1;SSb(j,i);h=a;return h|0}if((g|0)==(f[213465]|0)){i=(f[213462]|0)+e|0;j=i-b|0;k=a+b|0;if(i>>>0<=b>>>0){h=0;return h|0}f[c>>2]=d&1|b|2;f[k+4>>2]=j|1;f[213465]=k;f[213462]=j;h=a;return h|0}if((g|0)==(f[213464]|0)){j=(f[213461]|0)+e|0;if(j>>>0<b>>>0){h=0;return h|0}k=j-b|0;i=d&1;if(k>>>0>15){l=a+b|0;m=l+k|0;f[c>>2]=i|b|2;f[l+4>>2]=k|1;f[m>>2]=k;n=m+4|0;f[n>>2]=f[n>>2]&-2;o=l;p=k}else{f[c>>2]=i|j|2;i=a+j+4|0;f[i>>2]=f[i>>2]|1;o=0;p=0}f[213461]=p;f[213464]=o;h=a;return h|0}o=f[g+4>>2]|0;if(o&2|0){h=0;return h|0}p=(o&-8)+e|0;if(p>>>0<b>>>0){h=0;return h|0}e=p-b|0;i=o>>>3;do if(o>>>0<256){j=f[g+8>>2]|0;k=f[g+12>>2]|0;if((k|0)==(j|0)){f[213459]=f[213459]&~(1<<i);break}else{f[j+12>>2]=k;f[k+8>>2]=j;break}}else{j=f[g+24>>2]|0;k=f[g+12>>2]|0;do if((k|0)==(g|0)){l=g+16|0;n=l+4|0;m=f[n>>2]|0;if(!m){q=f[l>>2]|0;if(!q){r=0;break}else{s=q;t=l}}else{s=m;t=n}while(1){n=s+20|0;m=f[n>>2]|0;if(m|0){s=m;t=n;continue}n=s+16|0;m=f[n>>2]|0;if(!m)break;else{s=m;t=n}}f[t>>2]=0;r=s}else{n=f[g+8>>2]|0;f[n+12>>2]=k;f[k+8>>2]=n;r=k}while(0);if(j|0){k=f[g+28>>2]|0;n=854140+(k<<2)|0;if((g|0)==(f[n>>2]|0)){f[n>>2]=r;if(!r){f[213460]=f[213460]&~(1<<k);break}}else{f[j+16+(((f[j+16>>2]|0)!=(g|0)&1)<<2)>>2]=r;if(!r)break}f[r+24>>2]=j;k=g+16|0;n=f[k>>2]|0;if(n|0){f[r+16>>2]=n;f[n+24>>2]=r}n=f[k+4>>2]|0;if(n|0){f[r+20>>2]=n;f[n+24>>2]=r}}}while(0);r=d&1;if(e>>>0<16){f[c>>2]=p|r|2;d=a+p+4|0;f[d>>2]=f[d>>2]|1;h=a;return h|0}else{d=a+b|0;f[c>>2]=r|b|2;f[d+4>>2]=e|3;b=d+e+4|0;f[b>>2]=f[b>>2]|1;SSb(d,e);h=a;return h|0}return 0}function SSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;c=a+b|0;d=f[a+4>>2]|0;do if(!(d&1)){e=f[a>>2]|0;if(!(d&3))return;g=a+(0-e)|0;h=e+b|0;if((g|0)==(f[213464]|0)){i=c+4|0;j=f[i>>2]|0;if((j&3|0)!=3){k=g;l=h;break}f[213461]=h;f[i>>2]=j&-2;f[g+4>>2]=h|1;f[g+h>>2]=h;return}j=e>>>3;if(e>>>0<256){e=f[g+8>>2]|0;i=f[g+12>>2]|0;if((i|0)==(e|0)){f[213459]=f[213459]&~(1<<j);k=g;l=h;break}else{f[e+12>>2]=i;f[i+8>>2]=e;k=g;l=h;break}}e=f[g+24>>2]|0;i=f[g+12>>2]|0;do if((i|0)==(g|0)){j=g+16|0;m=j+4|0;n=f[m>>2]|0;if(!n){o=f[j>>2]|0;if(!o){p=0;break}else{q=o;r=j}}else{q=n;r=m}while(1){m=q+20|0;n=f[m>>2]|0;if(n|0){q=n;r=m;continue}m=q+16|0;n=f[m>>2]|0;if(!n)break;else{q=n;r=m}}f[r>>2]=0;p=q}else{m=f[g+8>>2]|0;f[m+12>>2]=i;f[i+8>>2]=m;p=i}while(0);if(e){i=f[g+28>>2]|0;m=854140+(i<<2)|0;if((g|0)==(f[m>>2]|0)){f[m>>2]=p;if(!p){f[213460]=f[213460]&~(1<<i);k=g;l=h;break}}else{f[e+16+(((f[e+16>>2]|0)!=(g|0)&1)<<2)>>2]=p;if(!p){k=g;l=h;break}}f[p+24>>2]=e;i=g+16|0;m=f[i>>2]|0;if(m|0){f[p+16>>2]=m;f[m+24>>2]=p}m=f[i+4>>2]|0;if(m){f[p+20>>2]=m;f[m+24>>2]=p;k=g;l=h}else{k=g;l=h}}else{k=g;l=h}}else{k=a;l=b}while(0);b=c+4|0;a=f[b>>2]|0;if(!(a&2)){p=f[213464]|0;if((c|0)==(f[213465]|0)){q=(f[213462]|0)+l|0;f[213462]=q;f[213465]=k;f[k+4>>2]=q|1;if((k|0)!=(p|0))return;f[213464]=0;f[213461]=0;return}if((c|0)==(p|0)){p=(f[213461]|0)+l|0;f[213461]=p;f[213464]=k;f[k+4>>2]=p|1;f[k+p>>2]=p;return}p=(a&-8)+l|0;q=a>>>3;do if(a>>>0<256){r=f[c+8>>2]|0;d=f[c+12>>2]|0;if((d|0)==(r|0)){f[213459]=f[213459]&~(1<<q);break}else{f[r+12>>2]=d;f[d+8>>2]=r;break}}else{r=f[c+24>>2]|0;d=f[c+12>>2]|0;do if((d|0)==(c|0)){m=c+16|0;i=m+4|0;n=f[i>>2]|0;if(!n){j=f[m>>2]|0;if(!j){s=0;break}else{t=j;u=m}}else{t=n;u=i}while(1){i=t+20|0;n=f[i>>2]|0;if(n|0){t=n;u=i;continue}i=t+16|0;n=f[i>>2]|0;if(!n)break;else{t=n;u=i}}f[u>>2]=0;s=t}else{i=f[c+8>>2]|0;f[i+12>>2]=d;f[d+8>>2]=i;s=d}while(0);if(r|0){d=f[c+28>>2]|0;h=854140+(d<<2)|0;if((c|0)==(f[h>>2]|0)){f[h>>2]=s;if(!s){f[213460]=f[213460]&~(1<<d);break}}else{f[r+16+(((f[r+16>>2]|0)!=(c|0)&1)<<2)>>2]=s;if(!s)break}f[s+24>>2]=r;d=c+16|0;h=f[d>>2]|0;if(h|0){f[s+16>>2]=h;f[h+24>>2]=s}h=f[d+4>>2]|0;if(h|0){f[s+20>>2]=h;f[h+24>>2]=s}}}while(0);f[k+4>>2]=p|1;f[k+p>>2]=p;if((k|0)==(f[213464]|0)){f[213461]=p;return}else v=p}else{f[b>>2]=a&-2;f[k+4>>2]=l|1;f[k+l>>2]=l;v=l}l=v>>>3;if(v>>>0<256){a=853876+(l<<1<<2)|0;b=f[213459]|0;p=1<<l;if(!(b&p)){f[213459]=b|p;w=a;x=a+8|0}else{p=a+8|0;w=f[p>>2]|0;x=p}f[x>>2]=k;f[w+12>>2]=k;f[k+8>>2]=w;f[k+12>>2]=a;return}a=v>>>8;if(a)if(v>>>0>16777215)y=31;else{w=(a+1048320|0)>>>16&8;x=a<<w;a=(x+520192|0)>>>16&4;p=x<<a;x=(p+245760|0)>>>16&2;b=14-(a|w|x)+(p<<x>>>15)|0;y=v>>>(b+7|0)&1|b<<1}else y=0;b=854140+(y<<2)|0;f[k+28>>2]=y;f[k+20>>2]=0;f[k+16>>2]=0;x=f[213460]|0;p=1<<y;if(!(x&p)){f[213460]=x|p;f[b>>2]=k;f[k+24>>2]=b;f[k+12>>2]=k;f[k+8>>2]=k;return}p=v<<((y|0)==31?0:25-(y>>>1)|0);y=f[b>>2]|0;while(1){if((f[y+4>>2]&-8|0)==(v|0)){z=69;break}A=y+16+(p>>>31<<2)|0;b=f[A>>2]|0;if(!b){z=68;break}else{p=p<<1;y=b}}if((z|0)==68){f[A>>2]=k;f[k+24>>2]=y;f[k+12>>2]=k;f[k+8>>2]=k;return}else if((z|0)==69){z=y+8|0;A=f[z>>2]|0;f[A+12>>2]=k;f[z>>2]=k;f[k+8>>2]=A;f[k+12>>2]=y;f[k+24>>2]=0;return}}function TSb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a>>>0>16?a:16;if(!(c+-1&c))d=c;else{a=16;while(1)if(a>>>0<c>>>0)a=a<<1;else{d=a;break}}if((-64-d|0)>>>0<=b>>>0){a=ZSb()|0;f[a>>2]=12;e=0;return e|0}a=b>>>0<11?16:b+11&-8;b=OSb(a+12+d|0)|0;if(!b){e=0;return e|0}c=b+-8|0;do if(b&d+-1){g=(b+d+-1&0-d)+-8|0;h=c;i=(g-h|0)>>>0>15?g:g+d|0;g=i-h|0;h=b+-4|0;j=f[h>>2]|0;k=(j&-8)-g|0;if(!(j&3)){f[i>>2]=(f[c>>2]|0)+g;f[i+4>>2]=k;l=i;m=i;break}else{j=i+4|0;f[j>>2]=k|f[j>>2]&1|2;n=i+k+4|0;f[n>>2]=f[n>>2]|1;f[h>>2]=g|f[h>>2]&1|2;f[j>>2]=f[j>>2]|1;SSb(c,g);l=i;m=i;break}}else{l=c;m=c}while(0);c=l+4|0;l=f[c>>2]|0;if(l&3|0?(b=l&-8,b>>>0>(a+16|0)>>>0):0){d=b-a|0;b=m+a|0;f[c>>2]=a|l&1|2;f[b+4>>2]=d|3;l=b+d+4|0;f[l>>2]=f[l>>2]|1;SSb(b,d)}e=m+8|0;return e|0}function USb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;do if((b|0)!=8){d=b>>>2;if((b&3|0)!=0|(d|0)==0){e=22;return e|0}if(d+1073741823&d|0){e=22;return e|0}if((-64-b|0)>>>0<c>>>0){e=12;return e|0}else{g=TSb(b>>>0>16?b:16,c)|0;break}}else g=OSb(c)|0;while(0);if(!g){e=12;return e|0}f[a>>2]=g;e=0;return e|0}function VSb(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=aTb(f[a+60>>2]|0)|0;f[c>>2]=d;d=YSb(je(6,c|0)|0)|0;u=b;return d|0}function WSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+48|0;e=d+16|0;g=d;h=d+32|0;i=a+28|0;j=f[i>>2]|0;f[h>>2]=j;k=a+20|0;l=(f[k>>2]|0)-j|0;f[h+4>>2]=l;f[h+8>>2]=b;f[h+12>>2]=c;b=l+c|0;l=a+60|0;f[g>>2]=f[l>>2];f[g+4>>2]=h;f[g+8>>2]=2;j=YSb(Hd(146,g|0)|0)|0;a:do if((b|0)!=(j|0)){g=2;m=b;n=h;o=j;while(1){if((o|0)<0)break;m=m-o|0;p=f[n+4>>2]|0;q=o>>>0>p>>>0;r=q?n+8|0:n;s=(q<<31>>31)+g|0;t=o-(q?p:0)|0;f[r>>2]=(f[r>>2]|0)+t;p=r+4|0;f[p>>2]=(f[p>>2]|0)-t;f[e>>2]=f[l>>2];f[e+4>>2]=r;f[e+8>>2]=s;o=YSb(Hd(146,e|0)|0)|0;if((m|0)==(o|0)){v=3;break a}else{g=s;n=r}}f[a+16>>2]=0;f[i>>2]=0;f[k>>2]=0;f[a>>2]=f[a>>2]|32;if((g|0)==2)w=0;else w=c-(f[n+4>>2]|0)|0}else v=3;while(0);if((v|0)==3){v=f[a+44>>2]|0;f[a+16>>2]=v+(f[a+48>>2]|0);f[i>>2]=v;f[k>>2]=v;w=c}u=d;return w|0}function XSb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+32|0;e=d;g=d+20|0;f[e>>2]=f[a+60>>2];f[e+4>>2]=0;f[e+8>>2]=b;f[e+12>>2]=g;f[e+16>>2]=c;if((YSb(Ed(140,e|0)|0)|0)<0){f[g>>2]=-1;h=-1}else h=f[g>>2]|0;u=d;return h|0}function YSb(a){a=a|0;var b=0,c=0;if(a>>>0>4294963200){b=ZSb()|0;f[b>>2]=0-a;c=-1}else c=a;return c|0}function ZSb(){return (_Sb()|0)+64|0}function _Sb(){return $Sb()|0}function $Sb(){return 141524}function aTb(a){a=a|0;return a|0}function bTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+32|0;g=e;h=e+16|0;f[h>>2]=c;i=h+4|0;j=a+48|0;k=f[j>>2]|0;f[i>>2]=d-((k|0)!=0&1);l=a+44|0;f[h+8>>2]=f[l>>2];f[h+12>>2]=k;f[g>>2]=f[a+60>>2];f[g+4>>2]=h;f[g+8>>2]=2;h=YSb(Gd(145,g|0)|0)|0;if((h|0)>=1){g=f[i>>2]|0;if(h>>>0>g>>>0){i=f[l>>2]|0;l=a+4|0;f[l>>2]=i;f[a+8>>2]=i+(h-g);if(!(f[j>>2]|0))m=d;else{f[l>>2]=i+1;b[c+(d+-1)>>0]=b[i>>0]|0;m=d}}else m=h}else{f[a>>2]=f[a>>2]|h&48^16;m=h}u=e;return m|0}function cTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+32|0;g=e;f[a+36>>2]=206;if((f[a>>2]&64|0)==0?(f[g>>2]=f[a+60>>2],f[g+4>>2]=21523,f[g+8>>2]=e+16,ue(54,g|0)|0):0)b[a+75>>0]=-1;g=WSb(a,c,d)|0;u=e;return g|0}function dTb(){return 854332}function eTb(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;d=aTb(a)|0;f[c>>2]=d;d=je(6,c|0)|0;c=YSb((d|0)==-4?0:d)|0;u=b;return c|0}function fTb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+48|0;e=d+16|0;g=d;h=d+32|0;if(!(b&4194368))i=0;else{f[h>>2]=c;c=(f[h>>2]|0)+(4-1)&~(4-1);j=f[c>>2]|0;f[h>>2]=c+4;i=j}f[g>>2]=a;f[g+4>>2]=b|32768;f[g+8>>2]=i;i=ke(5,g|0)|0;if(!((b&524288|0)==0|(i|0)<0)){f[e>>2]=i;f[e+4>>2]=2;f[e+8>>2]=1;Yc(221,e|0)|0}e=YSb(i)|0;u=d;return e|0}function gTb(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;d=b[a>>0]|0;e=b[c>>0]|0;if(d<<24>>24==0?1:d<<24>>24!=e<<24>>24){f=e;g=d}else{d=c;c=a;do{c=c+1|0;d=d+1|0;a=b[c>>0]|0;e=b[d>>0]|0}while(!(a<<24>>24==0?1:a<<24>>24!=e<<24>>24));f=e;g=a}return (g&255)-(f&255)|0}function hTb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+32|0;e=d;g=d+20|0;f[e>>2]=a;f[e+4>>2]=0;f[e+8>>2]=b;f[e+12>>2]=g;f[e+16>>2]=c;c=(YSb(Ed(140,e|0)|0)|0)!=0;u=d;return (c?-1:f[g>>2]|0)|0}function iTb(a){a=a|0;var b=0,c=0,d=0;if((f[a+76>>2]|0)>-1){b=(jTb(a)|0)==0;c=(f[a>>2]|0)>>>4&1;if(b)d=c;else d=c}else d=(f[a>>2]|0)>>>4&1;return d|0}function jTb(a){a=a|0;return 0}function kTb(a){a=a|0;return}function lTb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;if((f[a+76>>2]|0)>=0?(jTb(a)|0)!=0:0){b=a+4|0;c=f[b>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[b>>2]=c+1;d=h[c>>0]|0}else d=mTb(a)|0;e=d}else g=3;do if((g|0)==3){d=a+4|0;c=f[d>>2]|0;if(c>>>0<(f[a+8>>2]|0)>>>0){f[d>>2]=c+1;e=h[c>>0]|0;break}else{e=mTb(a)|0;break}}while(0);return e|0}function mTb(a){a=a|0;var b=0,c=0,d=0;b=u;u=u+16|0;c=b;if((nTb(a)|0)==0?(li[f[a+32>>2]&511](a,c,1)|0)==1:0)d=h[c>>0]|0;else d=-1;u=b;return d|0}function nTb(a){a=a|0;var c=0,d=0,e=0;c=a+74|0;d=b[c>>0]|0;b[c>>0]=d+255|d;d=a+20|0;c=a+28|0;if((f[d>>2]|0)>>>0>(f[c>>2]|0)>>>0)li[f[a+36>>2]&511](a,0,0)|0;f[a+16>>2]=0;f[c>>2]=0;f[d>>2]=0;d=f[a>>2]|0;if(!(d&4)){c=(f[a+44>>2]|0)+(f[a+48>>2]|0)|0;f[a+8>>2]=c;f[a+4>>2]=c;e=d<<27>>31}else{f[a>>2]=d|32;e=-1}return e|0}function oTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+224|0;g=e+120|0;h=e+80|0;i=e;j=e+136|0;k=h;l=k+40|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(l|0));f[g>>2]=f[d>>2];if((pTb(0,c,g,i,h)|0)<0)m=-1;else{if((f[a+76>>2]|0)>-1)n=jTb(a)|0;else n=0;d=f[a>>2]|0;k=d&32;if((b[a+74>>0]|0)<1)f[a>>2]=d&-33;d=a+48|0;if(!(f[d>>2]|0)){l=a+44|0;o=f[l>>2]|0;f[l>>2]=j;p=a+28|0;f[p>>2]=j;q=a+20|0;f[q>>2]=j;f[d>>2]=80;r=a+16|0;f[r>>2]=j+80;j=pTb(a,c,g,i,h)|0;if(!o)s=j;else{li[f[a+36>>2]&511](a,0,0)|0;t=(f[q>>2]|0)==0?-1:j;f[l>>2]=o;f[d>>2]=0;f[r>>2]=0;f[p>>2]=0;f[q>>2]=0;s=t}}else s=pTb(a,c,g,i,h)|0;h=f[a>>2]|0;f[a>>2]=h|k;if(n|0)kTb(a);m=(h&32|0)==0?s:-1}u=e;return m|0}function pTb(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;i=u;u=u+64|0;j=i+16|0;k=i;l=i+24|0;m=i+8|0;n=i+20|0;f[j>>2]=c;o=(a|0)!=0;q=l+40|0;r=q;s=l+39|0;l=m+4|0;t=0;v=0;w=0;x=c;a:while(1){do if((v|0)>-1)if((t|0)>(2147483647-v|0)){c=ZSb()|0;f[c>>2]=75;y=-1;break}else{y=t+v|0;break}else y=v;while(0);c=b[x>>0]|0;if(!(c<<24>>24)){z=87;break}else{A=c;B=x}b:while(1){switch(A<<24>>24){case 37:{C=B;D=B;z=9;break b;break}case 0:{E=B;F=B;break b;break}default:{}}c=B+1|0;f[j>>2]=c;A=b[c>>0]|0;B=c}c:do if((z|0)==9)while(1){z=0;if((b[D+1>>0]|0)!=37){E=C;F=D;break c}c=C+1|0;G=D+2|0;f[j>>2]=G;if((b[G>>0]|0)==37){C=c;D=G;z=9}else{E=c;F=G;break}}while(0);G=E-x|0;if(o)qTb(a,x,G);if(G|0){t=G;v=y;x=F;continue}G=F+1|0;c=(b[G>>0]|0)+-48|0;if(c>>>0<10){H=(b[F+2>>0]|0)==36;I=H?c:-1;K=H?1:w;L=H?F+3|0:G}else{I=-1;K=w;L=G}f[j>>2]=L;G=b[L>>0]|0;H=(G<<24>>24)+-32|0;d:do if(H>>>0<32){c=0;M=G;N=H;O=L;while(1){P=1<<N;if(!(P&75913)){Q=c;R=M;S=O;break d}T=P|c;P=O+1|0;f[j>>2]=P;U=b[P>>0]|0;N=(U<<24>>24)+-32|0;if(N>>>0>=32){Q=T;R=U;S=P;break}else{c=T;M=U;O=P}}}else{Q=0;R=G;S=L}while(0);if(R<<24>>24==42){G=S+1|0;H=(b[G>>0]|0)+-48|0;if(H>>>0<10?(b[S+2>>0]|0)==36:0){f[h+(H<<2)>>2]=10;V=f[g+((b[G>>0]|0)+-48<<3)>>2]|0;W=1;X=S+3|0}else{if(K|0){Y=-1;break}if(o){H=(f[e>>2]|0)+(4-1)&~(4-1);O=f[H>>2]|0;f[e>>2]=H+4;V=O;W=0;X=G}else{V=0;W=0;X=G}}f[j>>2]=X;G=(V|0)<0;Z=G?0-V|0:V;_=G?Q|8192:Q;$=W;aa=X}else{G=rTb(j)|0;if((G|0)<0){Y=-1;break}Z=G;_=Q;$=K;aa=f[j>>2]|0}do if((b[aa>>0]|0)==46){if((b[aa+1>>0]|0)!=42){f[j>>2]=aa+1;G=rTb(j)|0;ba=G;ca=f[j>>2]|0;break}G=aa+2|0;O=(b[G>>0]|0)+-48|0;if(O>>>0<10?(b[aa+3>>0]|0)==36:0){f[h+(O<<2)>>2]=10;O=f[g+((b[G>>0]|0)+-48<<3)>>2]|0;H=aa+4|0;f[j>>2]=H;ba=O;ca=H;break}if($|0){Y=-1;break a}if(o){H=(f[e>>2]|0)+(4-1)&~(4-1);O=f[H>>2]|0;f[e>>2]=H+4;da=O}else da=0;f[j>>2]=G;ba=da;ca=G}else{ba=-1;ca=aa}while(0);G=0;O=ca;while(1){if(((b[O>>0]|0)+-65|0)>>>0>57){Y=-1;break a}ea=O+1|0;f[j>>2]=ea;fa=b[(b[O>>0]|0)+-65+(482737+(G*58|0))>>0]|0;ga=fa&255;if((ga+-1|0)>>>0<8){G=ga;O=ea}else break}if(!(fa<<24>>24)){Y=-1;break}H=(I|0)>-1;do if(fa<<24>>24==19)if(H){Y=-1;break a}else z=49;else{if(H){f[h+(I<<2)>>2]=ga;M=g+(I<<3)|0;c=f[M+4>>2]|0;N=k;f[N>>2]=f[M>>2];f[N+4>>2]=c;z=49;break}if(!o){Y=0;break a}sTb(k,ga,e)}while(0);if((z|0)==49?(z=0,!o):0){t=0;v=y;w=$;x=ea;continue}H=b[O>>0]|0;c=(G|0)!=0&(H&15|0)==3?H&-33:H;H=_&-65537;N=(_&8192|0)==0?_:H;e:do switch(c|0){case 110:{switch((G&255)<<24>>24){case 0:{f[f[k>>2]>>2]=y;t=0;v=y;w=$;x=ea;continue a;break}case 1:{f[f[k>>2]>>2]=y;t=0;v=y;w=$;x=ea;continue a;break}case 2:{M=f[k>>2]|0;f[M>>2]=y;f[M+4>>2]=((y|0)<0)<<31>>31;t=0;v=y;w=$;x=ea;continue a;break}case 3:{d[f[k>>2]>>1]=y;t=0;v=y;w=$;x=ea;continue a;break}case 4:{b[f[k>>2]>>0]=y;t=0;v=y;w=$;x=ea;continue a;break}case 6:{f[f[k>>2]>>2]=y;t=0;v=y;w=$;x=ea;continue a;break}case 7:{M=f[k>>2]|0;f[M>>2]=y;f[M+4>>2]=((y|0)<0)<<31>>31;t=0;v=y;w=$;x=ea;continue a;break}default:{t=0;v=y;w=$;x=ea;continue a}}break}case 112:{ha=120;ia=ba>>>0>8?ba:8;ja=N|8;z=61;break}case 88:case 120:{ha=c;ia=ba;ja=N;z=61;break}case 111:{M=k;P=f[M>>2]|0;U=f[M+4>>2]|0;M=uTb(P,U,q)|0;T=r-M|0;ka=M;la=0;ma=483201;na=(N&8|0)==0|(ba|0)>(T|0)?ba:T+1|0;oa=N;pa=P;qa=U;z=67;break}case 105:case 100:{U=k;P=f[U>>2]|0;T=f[U+4>>2]|0;if((T|0)<0){U=Jac(0,0,P|0,T|0)|0;M=J;ra=k;f[ra>>2]=U;f[ra+4>>2]=M;sa=1;ta=483201;ua=U;va=M;z=66;break e}else{sa=(N&2049|0)!=0&1;ta=(N&2048|0)==0?((N&1|0)==0?483201:483203):483202;ua=P;va=T;z=66;break e}break}case 117:{T=k;sa=0;ta=483201;ua=f[T>>2]|0;va=f[T+4>>2]|0;z=66;break}case 99:{b[s>>0]=f[k>>2];wa=s;xa=0;ya=483201;za=q;Aa=1;Ba=H;break}case 109:{T=ZSb()|0;Ca=wTb(f[T>>2]|0)|0;z=71;break}case 115:{T=f[k>>2]|0;Ca=T|0?T:483211;z=71;break}case 67:{f[m>>2]=f[k>>2];f[l>>2]=0;f[k>>2]=m;Da=-1;Ea=m;z=75;break}case 83:{T=f[k>>2]|0;if(!ba){yTb(a,32,Z,0,N);Fa=0;z=84}else{Da=ba;Ea=T;z=75}break}case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{t=ATb(a,+p[k>>3],Z,ba,N,c)|0;v=y;w=$;x=ea;continue a;break}default:{wa=x;xa=0;ya=483201;za=q;Aa=ba;Ba=N}}while(0);f:do if((z|0)==61){z=0;c=k;G=f[c>>2]|0;O=f[c+4>>2]|0;c=tTb(G,O,q,ha&32)|0;T=(ja&8|0)==0|(G|0)==0&(O|0)==0;ka=c;la=T?0:2;ma=T?483201:483201+(ha>>4)|0;na=ia;oa=ja;pa=G;qa=O;z=67}else if((z|0)==66){z=0;ka=vTb(ua,va,q)|0;la=sa;ma=ta;na=ba;oa=N;pa=ua;qa=va;z=67}else if((z|0)==71){z=0;O=xTb(Ca,0,ba)|0;G=(O|0)==0;wa=Ca;xa=0;ya=483201;za=G?Ca+ba|0:O;Aa=G?ba:O-Ca|0;Ba=H}else if((z|0)==75){z=0;O=Ea;G=0;T=0;while(1){c=f[O>>2]|0;if(!c){Ga=G;Ha=T;break}P=zTb(n,c)|0;if((P|0)<0|P>>>0>(Da-G|0)>>>0){Ga=G;Ha=P;break}c=P+G|0;if(Da>>>0>c>>>0){O=O+4|0;G=c;T=P}else{Ga=c;Ha=P;break}}if((Ha|0)<0){Y=-1;break a}yTb(a,32,Z,Ga,N);if(!Ga){Fa=0;z=84}else{T=Ea;G=0;while(1){O=f[T>>2]|0;if(!O){Fa=Ga;z=84;break f}P=zTb(n,O)|0;G=P+G|0;if((G|0)>(Ga|0)){Fa=Ga;z=84;break f}qTb(a,n,P);if(G>>>0>=Ga>>>0){Fa=Ga;z=84;break}else T=T+4|0}}}while(0);if((z|0)==67){z=0;H=(pa|0)!=0|(qa|0)!=0;T=(na|0)!=0|H;G=((H^1)&1)+(r-ka)|0;wa=T?ka:q;xa=la;ya=ma;za=q;Aa=T?((na|0)>(G|0)?na:G):na;Ba=(na|0)>-1?oa&-65537:oa}else if((z|0)==84){z=0;yTb(a,32,Z,Fa,N^8192);t=(Z|0)>(Fa|0)?Z:Fa;v=y;w=$;x=ea;continue}G=za-wa|0;T=(Aa|0)<(G|0)?G:Aa;H=T+xa|0;P=(Z|0)<(H|0)?H:Z;yTb(a,32,P,H,Ba);qTb(a,ya,xa);yTb(a,48,P,H,Ba^65536);yTb(a,48,T,G,0);qTb(a,wa,G);yTb(a,32,P,H,Ba^8192);t=P;v=y;w=$;x=ea}g:do if((z|0)==87)if(!a)if(!w)Y=0;else{ea=1;while(1){x=f[h+(ea<<2)>>2]|0;if(!x){Ia=ea;break}sTb(g+(ea<<3)|0,x,e);ea=ea+1|0;if((ea|0)>=10){Y=1;break g}}while(1){if(f[h+(Ia<<2)>>2]|0){Y=-1;break g}Ia=Ia+1|0;if((Ia|0)>=10){Y=1;break}}}else Y=y;while(0);u=i;return Y|0}function qTb(a,b,c){a=a|0;b=b|0;c=c|0;if(!(f[a>>2]&32))MTb(b,c,a)|0;return}function rTb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=f[a>>2]|0;d=(b[c>>0]|0)+-48|0;if(d>>>0<10){e=0;g=c;c=d;while(1){d=c+(e*10|0)|0;g=g+1|0;f[a>>2]=g;c=(b[g>>0]|0)+-48|0;if(c>>>0>=10){h=d;break}else e=d}}else h=0;return h|0}function sTb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0.0;a:do if(b>>>0<=20)do switch(b|0){case 9:{d=(f[c>>2]|0)+(4-1)&~(4-1);e=f[d>>2]|0;f[c>>2]=d+4;f[a>>2]=e;break a;break}case 10:{e=(f[c>>2]|0)+(4-1)&~(4-1);d=f[e>>2]|0;f[c>>2]=e+4;e=a;f[e>>2]=d;f[e+4>>2]=((d|0)<0)<<31>>31;break a;break}case 11:{d=(f[c>>2]|0)+(4-1)&~(4-1);e=f[d>>2]|0;f[c>>2]=d+4;d=a;f[d>>2]=e;f[d+4>>2]=0;break a;break}case 12:{d=(f[c>>2]|0)+(8-1)&~(8-1);e=d;g=f[e>>2]|0;h=f[e+4>>2]|0;f[c>>2]=d+8;d=a;f[d>>2]=g;f[d+4>>2]=h;break a;break}case 13:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=(d&65535)<<16>>16;d=a;f[d>>2]=h;f[d+4>>2]=((h|0)<0)<<31>>31;break a;break}case 14:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=a;f[h>>2]=d&65535;f[h+4>>2]=0;break a;break}case 15:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=(d&255)<<24>>24;d=a;f[d>>2]=h;f[d+4>>2]=((h|0)<0)<<31>>31;break a;break}case 16:{h=(f[c>>2]|0)+(4-1)&~(4-1);d=f[h>>2]|0;f[c>>2]=h+4;h=a;f[h>>2]=d&255;f[h+4>>2]=0;break a;break}case 17:{h=(f[c>>2]|0)+(8-1)&~(8-1);i=+p[h>>3];f[c>>2]=h+8;p[a>>3]=i;break a;break}case 18:{h=(f[c>>2]|0)+(8-1)&~(8-1);i=+p[h>>3];f[c>>2]=h+8;p[a>>3]=i;break a;break}default:break a}while(0);while(0);return}function tTb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;if((a|0)==0&(c|0)==0)f=d;else{g=d;d=c;c=a;while(1){a=g+-1|0;b[a>>0]=h[483249+(c&15)>>0]|0|e;c=Sac(c|0,d|0,4)|0;d=J;if((c|0)==0&(d|0)==0){f=a;break}else g=a}}return f|0}function uTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0;if((a|0)==0&(c|0)==0)e=d;else{f=d;d=c;c=a;while(1){a=f+-1|0;b[a>>0]=c&7|48;c=Sac(c|0,d|0,3)|0;d=J;if((c|0)==0&(d|0)==0){e=a;break}else f=a}}return e|0}function vTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;if(c>>>0>0|(c|0)==0&a>>>0>4294967295){e=d;f=a;g=c;while(1){c=Yac(f|0,g|0,10,0)|0;e=e+-1|0;b[e>>0]=c&255|48;c=f;f=Uac(f|0,g|0,10,0)|0;if(!(g>>>0>9|(g|0)==9&c>>>0>4294967295))break;else g=J}h=f;i=e}else{h=a;i=d}if(!h)j=i;else{d=h;h=i;while(1){i=h+-1|0;b[i>>0]=(d>>>0)%10|0|48;if(d>>>0<10){j=i;break}else{d=(d>>>0)/10|0;h=i}}}return j|0}function wTb(a){a=a|0;var b=0;b=(GTb()|0)+188|0;return HTb(a,f[b>>2]|0)|0}function xTb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=c&255;g=(d|0)!=0;a:do if(g&(a&3|0)!=0){h=c&255;i=a;j=d;while(1){if((b[i>>0]|0)==h<<24>>24){k=i;l=j;m=6;break a}n=i+1|0;o=j+-1|0;p=(o|0)!=0;if(p&(n&3|0)!=0){i=n;j=o}else{q=n;r=o;s=p;m=5;break}}}else{q=a;r=d;s=g;m=5}while(0);if((m|0)==5)if(s){k=q;l=r;m=6}else{t=q;u=0}b:do if((m|0)==6){q=c&255;if((b[k>>0]|0)==q<<24>>24){t=k;u=l}else{r=Y(e,16843009)|0;c:do if(l>>>0>3){s=k;g=l;while(1){d=f[s>>2]^r;if((d&-2139062144^-2139062144)&d+-16843009|0)break;d=s+4|0;a=g+-4|0;if(a>>>0>3){s=d;g=a}else{v=d;w=a;m=11;break c}}x=s;y=g}else{v=k;w=l;m=11}while(0);if((m|0)==11)if(!w){t=v;u=0;break}else{x=v;y=w}while(1){if((b[x>>0]|0)==q<<24>>24){t=x;u=y;break b}r=x+1|0;y=y+-1|0;if(!y){t=r;u=0;break}else x=r}}}while(0);return (u|0?t:0)|0}function yTb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=u;u=u+256|0;g=f;if((c|0)>(d|0)&(e&73728|0)==0){e=c-d|0;Nac(g|0,b|0,(e>>>0<256?e:256)|0)|0;if(e>>>0>255){b=c-d|0;d=e;do{qTb(a,g,256);d=d+-256|0}while(d>>>0>255);h=b&255}else h=e;qTb(a,g,h)}u=f;return}function zTb(a,b){a=a|0;b=b|0;var c=0;if(!a)c=0;else c=ETb(a,b,0)|0;return c|0}
function ME(a,c,d,e,f,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){k=(h|0)>0;l=d;m=f;n=a;o=j;while(1){if(k){p=0;do{q=b[n+p>>0]|0;r=b[l+p>>0]|0;s=(q&255)>(r&255);b[m+p>>0]=((s?q:r)&255)-((s?r:q)&255);p=p+1|0}while((p|0)!=(h|0))}if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0;o=o+-1|0}}return}o=h&-4;n=(o|0)<(h|0);m=d;d=f;f=a;a=j;while(1){j=0;do{l=b[f+j>>0]|0;k=b[m+j>>0]|0;p=(l&255)>(k&255);q=j|1;r=b[f+q>>0]|0;s=b[m+q>>0]|0;t=(r&255)>(s&255);b[d+j>>0]=((p?l:k)&255)-((p?k:l)&255);b[d+q>>0]=((t?r:s)&255)-((t?s:r)&255);r=j|2;s=b[f+r>>0]|0;t=b[m+r>>0]|0;q=(s&255)>(t&255);l=j|3;k=b[f+l>>0]|0;p=b[m+l>>0]|0;u=(k&255)>(p&255);b[d+r>>0]=((q?s:t)&255)-((q?t:s)&255);b[d+l>>0]=((u?k:p)&255)-((u?p:k)&255);j=j+4|0}while((j|0)<=(i|0));if(n){j=o;do{k=b[f+j>>0]|0;p=b[m+j>>0]|0;u=(k&255)>(p&255);b[d+j>>0]=((u?k:p)&255)-((u?p:k)&255);j=j+1|0}while((j|0)!=(h|0))}if(!a)break;else{m=m+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}function NE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=u;u=u+16|0;h=g;i=g+8|0;p[h>>3]=d;dQ(i,40388);j=UM()|0;k=+L(+(d+-1.0))<2.220446049250313e-16;WD(a,b,c,j,e,40408,1,h,k?4:5);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function OE(a,c,d,e,f,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;l=+p[k>>3];k=j+-1|0;m=(j|0)==0;if(l==1.0){if(m)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){n=d;o=f;q=a;r=k}else return;while(1){s=0;do{t=Y(h[n+s>>0]|0,h[q+s>>0]|0)|0;b[o+s>>0]=t>>>0<256?t:t|0?255:0;s=s+1|0}while((s|0)!=(i|0));if(!r)break;else{n=n+e|0;o=o+g|0;q=q+c|0;r=r+-1|0}}return}r=i&-4;q=(r|0)<(i|0);o=d;n=f;s=a;t=k;while(1){u=0;do{v=Y(h[o+u>>0]|0,h[s+u>>0]|0)|0;w=u|1;x=Y(h[o+w>>0]|0,h[s+w>>0]|0)|0;b[n+u>>0]=v>>>0<256?v:v|0?255:0;b[n+w>>0]=x>>>0<256?x:x|0?255:0;x=u|2;w=Y(h[o+x>>0]|0,h[s+x>>0]|0)|0;v=u|3;y=Y(h[o+v>>0]|0,h[s+v>>0]|0)|0;b[n+x>>0]=w>>>0<256?w:w|0?255:0;b[n+v>>0]=y>>>0<256?y:y|0?255:0;u=u+4|0}while((u|0)<=(j|0));if(q){u=r;do{y=Y(h[o+u>>0]|0,h[s+u>>0]|0)|0;b[n+u>>0]=y>>>0<256?y:y|0?255:0;u=u+1|0}while((u|0)!=(i|0))}if(!t)break;else{o=o+e|0;n=n+g|0;s=s+c|0;t=t+-1|0}}return}else{if(m)return;m=i+-4|0;if((i|0)<4){if((i|0)>0){z=d;A=f;B=a;C=k}else return;while(1){t=0;do{s=LVb(l*+(h[B+t>>0]|0)*+(h[z+t>>0]|0))|0;b[A+t>>0]=s>>>0<256?s:(s|0)>0?255:0;t=t+1|0}while((t|0)!=(i|0));if(!C)break;else{z=z+e|0;A=A+g|0;B=B+c|0;C=C+-1|0}}return}C=i&-4;B=(C|0)<(i|0);A=d;d=f;f=a;a=k;while(1){k=0;do{z=LVb(l*+(h[f+k>>0]|0)*+(h[A+k>>0]|0))|0;t=k|1;s=LVb(l*+(h[f+t>>0]|0)*+(h[A+t>>0]|0))|0;b[d+k>>0]=z>>>0<256?z:(z|0)>0?255:0;b[d+t>>0]=s>>>0<256?s:(s|0)>0?255:0;s=k|2;t=LVb(l*+(h[f+s>>0]|0)*+(h[A+s>>0]|0))|0;z=k|3;n=LVb(l*+(h[f+z>>0]|0)*+(h[A+z>>0]|0))|0;b[d+s>>0]=t>>>0<256?t:(t|0)>0?255:0;b[d+z>>0]=n>>>0<256?n:(n|0)>0?255:0;k=k+4|0}while((k|0)<=(m|0));if(B){k=C;do{n=LVb(l*+(h[f+k>>0]|0)*+(h[A+k>>0]|0))|0;b[d+k>>0]=n>>>0<256?n:(n|0)>0?255:0;k=k+1|0}while((k|0)!=(i|0))}if(!a)break;else{A=A+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}}function PE(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=+p[j>>3];j=i+-1|0;l=(i|0)==0;if(!(k==1.0)){if(l)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){m=d;n=f;o=a;q=j}else return;while(1){r=0;do{s=LVb(k*+(b[o+r>>0]|0)*+(b[m+r>>0]|0))|0;b[n+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+1|0}while((r|0)!=(h|0));if(!q)break;else{m=m+e|0;n=n+g|0;o=o+c|0;q=q+-1|0}}return}q=h&-4;o=(q|0)<(h|0);n=d;m=f;r=a;s=j;while(1){t=0;do{u=LVb(k*+(b[r+t>>0]|0)*+(b[n+t>>0]|0))|0;v=t|1;w=LVb(k*+(b[r+v>>0]|0)*+(b[n+v>>0]|0))|0;b[m+t>>0]=(u+128|0)>>>0<256?u:(u|0)>0?127:128;b[m+v>>0]=(w+128|0)>>>0<256?w:(w|0)>0?127:128;w=t|2;v=LVb(k*+(b[r+w>>0]|0)*+(b[n+w>>0]|0))|0;u=t|3;x=LVb(k*+(b[r+u>>0]|0)*+(b[n+u>>0]|0))|0;b[m+w>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;b[m+u>>0]=(x+128|0)>>>0<256?x:(x|0)>0?127:128;t=t+4|0}while((t|0)<=(i|0));if(o){t=q;do{x=LVb(k*+(b[r+t>>0]|0)*+(b[n+t>>0]|0))|0;b[m+t>>0]=(x+128|0)>>>0<256?x:(x|0)>0?127:128;t=t+1|0}while((t|0)!=(h|0))}if(!s)break;else{n=n+e|0;m=m+g|0;r=r+c|0;s=s+-1|0}}return}if(l)return;l=h+-4|0;if((h|0)<4){if((h|0)>0){y=d;z=f;A=a;B=j}else return;while(1){s=0;do{r=Y(b[y+s>>0]|0,b[A+s>>0]|0)|0;b[z+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;s=s+1|0}while((s|0)!=(h|0));if(!B)break;else{y=y+e|0;z=z+g|0;A=A+c|0;B=B+-1|0}}return}B=h&-4;if((B|0)<(h|0)){C=d;D=f;E=a;F=j}else{A=d;d=f;f=a;a=j;while(1){j=0;do{z=Y(b[A+j>>0]|0,b[f+j>>0]|0)|0;y=j|1;s=Y(b[A+y>>0]|0,b[f+y>>0]|0)|0;b[d+j>>0]=(z+128|0)>>>0<256?z:(z|0)>0?127:128;b[d+y>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=j|2;y=Y(b[A+s>>0]|0,b[f+s>>0]|0)|0;z=j|3;r=Y(b[A+z>>0]|0,b[f+z>>0]|0)|0;b[d+s>>0]=(y+128|0)>>>0<256?y:(y|0)>0?127:128;b[d+z>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;j=j+4|0}while((j|0)<=(l|0));if(!a)break;else{A=A+e|0;d=d+g|0;f=f+c|0;a=a+-1|0}}return}while(1){a=0;do{f=Y(b[C+a>>0]|0,b[E+a>>0]|0)|0;d=a|1;A=Y(b[C+d>>0]|0,b[E+d>>0]|0)|0;b[D+a>>0]=(f+128|0)>>>0<256?f:(f|0)>0?127:128;b[D+d>>0]=(A+128|0)>>>0<256?A:(A|0)>0?127:128;A=a|2;d=Y(b[C+A>>0]|0,b[E+A>>0]|0)|0;f=a|3;j=Y(b[C+f>>0]|0,b[E+f>>0]|0)|0;b[D+A>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[D+f>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;a=a+4|0}while((a|0)<=(l|0));G=B;do{a=Y(b[C+G>>0]|0,b[E+G>>0]|0)|0;b[D+G>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;G=G+1|0}while((G|0)!=(h|0));if(!F)break;else{C=C+e|0;D=D+g|0;E=E+c|0;F=F+-1|0}}return}function QE(a,b,c,e,f,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;l=+p[k>>3];k=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;m=(i|0)==0;if(!(l==1.0)){if(m)return;i=h+-4|0;n=(h|0)<4;o=h&-4;q=c;r=f;s=a;t=g;while(1){if(n)u=0;else{v=0;do{w=LVb(l*+(j[s+(v<<1)>>1]|0)*+(j[q+(v<<1)>>1]|0))|0;x=v|1;y=LVb(l*+(j[s+(x<<1)>>1]|0)*+(j[q+(x<<1)>>1]|0))|0;d[r+(v<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[r+(x<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=v|2;x=LVb(l*+(j[s+(y<<1)>>1]|0)*+(j[q+(y<<1)>>1]|0))|0;w=v|3;z=LVb(l*+(j[s+(w<<1)>>1]|0)*+(j[q+(w<<1)>>1]|0))|0;d[r+(y<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;d[r+(w<<1)>>1]=z>>>0<65536?z:(z|0)>0?65535:0;v=v+4|0}while((v|0)<=(i|0));u=o}if((u|0)<(h|0)){v=u;do{z=LVb(l*+(j[s+(v<<1)>>1]|0)*+(j[q+(v<<1)>>1]|0))|0;d[r+(v<<1)>>1]=z>>>0<65536?z:(z|0)>0?65535:0;v=v+1|0}while((v|0)!=(h|0))}if(!t)break;else{q=q+(b<<1)|0;r=r+(e<<1)|0;s=s+(k<<1)|0;t=t+-1|0}}return}if(m)return;m=h+-4|0;if((h|0)<4){if((h|0)>0){A=c;B=f;C=a;D=g}else return;while(1){t=0;do{s=Y(j[A+(t<<1)>>1]|0,j[C+(t<<1)>>1]|0)|0;d[B+(t<<1)>>1]=s>>>0<65536?s:s|0?65535:0;t=t+1|0}while((t|0)!=(h|0));if(!D)break;else{A=A+(b<<1)|0;B=B+(e<<1)|0;C=C+(k<<1)|0;D=D+-1|0}}return}D=h&-4;C=(D|0)<(h|0);B=c;c=f;f=a;a=g;while(1){g=0;do{A=Y(j[B+(g<<1)>>1]|0,j[f+(g<<1)>>1]|0)|0;t=g|1;s=Y(j[B+(t<<1)>>1]|0,j[f+(t<<1)>>1]|0)|0;d[c+(g<<1)>>1]=A>>>0<65536?A:A|0?65535:0;d[c+(t<<1)>>1]=s>>>0<65536?s:s|0?65535:0;s=g|2;t=Y(j[B+(s<<1)>>1]|0,j[f+(s<<1)>>1]|0)|0;A=g|3;r=Y(j[B+(A<<1)>>1]|0,j[f+(A<<1)>>1]|0)|0;d[c+(s<<1)>>1]=t>>>0<65536?t:t|0?65535:0;d[c+(A<<1)>>1]=r>>>0<65536?r:r|0?65535:0;g=g+4|0}while((g|0)<=(m|0));if(C){g=D;do{r=Y(j[B+(g<<1)>>1]|0,j[f+(g<<1)>>1]|0)|0;d[c+(g<<1)>>1]=r>>>0<65536?r:r|0?65535:0;g=g+1|0}while((g|0)!=(h|0))}if(!a)break;else{B=B+(b<<1)|0;c=c+(e<<1)|0;f=f+(k<<1)|0;a=a+-1|0}}return}function RE(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;k=+p[j>>3];j=b>>>1;b=e>>>1;e=g>>>1;g=i+-1|0;l=(i|0)==0;if(!(k==1.0)){if(l)return;i=h+-4|0;m=(h|0)<4;n=h&-4;o=c;q=f;r=a;s=g;while(1){if(m)t=0;else{u=0;do{v=LVb(k*+(d[r+(u<<1)>>1]|0)*+(d[o+(u<<1)>>1]|0))|0;w=u|1;x=LVb(k*+(d[r+(w<<1)>>1]|0)*+(d[o+(w<<1)>>1]|0))|0;d[q+(u<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[q+(w<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=u|2;w=LVb(k*+(d[r+(x<<1)>>1]|0)*+(d[o+(x<<1)>>1]|0))|0;v=u|3;y=LVb(k*+(d[r+(v<<1)>>1]|0)*+(d[o+(v<<1)>>1]|0))|0;d[q+(x<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[q+(v<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;u=u+4|0}while((u|0)<=(i|0));t=n}if((t|0)<(h|0)){u=t;do{y=LVb(k*+(d[r+(u<<1)>>1]|0)*+(d[o+(u<<1)>>1]|0))|0;d[q+(u<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;u=u+1|0}while((u|0)!=(h|0))}if(!s)break;else{o=o+(b<<1)|0;q=q+(e<<1)|0;r=r+(j<<1)|0;s=s+-1|0}}return}if(l)return;l=h+-4|0;if((h|0)<4){if((h|0)>0){z=c;A=f;B=a;C=g}else return;while(1){s=0;do{r=Y(d[z+(s<<1)>>1]|0,d[B+(s<<1)>>1]|0)|0;d[A+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;s=s+1|0}while((s|0)!=(h|0));if(!C)break;else{z=z+(b<<1)|0;A=A+(e<<1)|0;B=B+(j<<1)|0;C=C+-1|0}}return}C=h&-4;B=(C|0)<(h|0);A=c;c=f;f=a;a=g;while(1){g=0;do{z=Y(d[A+(g<<1)>>1]|0,d[f+(g<<1)>>1]|0)|0;s=g|1;r=Y(d[A+(s<<1)>>1]|0,d[f+(s<<1)>>1]|0)|0;d[c+(g<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;d[c+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=g|2;s=Y(d[A+(r<<1)>>1]|0,d[f+(r<<1)>>1]|0)|0;z=g|3;q=Y(d[A+(z<<1)>>1]|0,d[f+(z<<1)>>1]|0)|0;d[c+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[c+(z<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;g=g+4|0}while((g|0)<=(l|0));if(B){g=C;do{q=Y(d[A+(g<<1)>>1]|0,d[f+(g<<1)>>1]|0)|0;d[c+(g<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;g=g+1|0}while((g|0)!=(h|0))}if(!a)break;else{A=A+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0;a=a+-1|0}}return}function SE(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=+p[j>>3];j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;l=(i|0)==0;if(!(k==1.0)){if(l)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){m=c;n=e;o=a;q=g}else return;while(1){r=0;do{s=MVb(k*+(f[o+(r<<2)>>2]|0)*+(f[m+(r<<2)>>2]|0))|0;f[n+(r<<2)>>2]=s;r=r+1|0}while((r|0)!=(h|0));if(!q)break;else{m=m+(b<<2)|0;n=n+(d<<2)|0;o=o+(j<<2)|0;q=q+-1|0}}return}q=h&-4;o=(q|0)<(h|0);n=c;m=e;r=a;s=g;while(1){t=0;do{u=MVb(k*+(f[r+(t<<2)>>2]|0)*+(f[n+(t<<2)>>2]|0))|0;v=t|1;w=MVb(k*+(f[r+(v<<2)>>2]|0)*+(f[n+(v<<2)>>2]|0))|0;f[m+(t<<2)>>2]=u;f[m+(v<<2)>>2]=w;w=t|2;v=MVb(k*+(f[r+(w<<2)>>2]|0)*+(f[n+(w<<2)>>2]|0))|0;u=t|3;x=MVb(k*+(f[r+(u<<2)>>2]|0)*+(f[n+(u<<2)>>2]|0))|0;f[m+(w<<2)>>2]=v;f[m+(u<<2)>>2]=x;t=t+4|0}while((t|0)<=(i|0));if(o){t=q;do{x=MVb(k*+(f[r+(t<<2)>>2]|0)*+(f[n+(t<<2)>>2]|0))|0;f[m+(t<<2)>>2]=x;t=t+1|0}while((t|0)!=(h|0))}if(!s)break;else{n=n+(b<<2)|0;m=m+(d<<2)|0;r=r+(j<<2)|0;s=s+-1|0}}return}if(l)return;l=h+-4|0;if((h|0)<4){if((h|0)>0){y=c;z=e;A=a;B=g}else return;while(1){s=0;do{r=Y(f[y+(s<<2)>>2]|0,f[A+(s<<2)>>2]|0)|0;f[z+(s<<2)>>2]=r;s=s+1|0}while((s|0)!=(h|0));if(!B)break;else{y=y+(b<<2)|0;z=z+(d<<2)|0;A=A+(j<<2)|0;B=B+-1|0}}return}B=h&-4;if((B|0)<(h|0)){C=c;D=e;E=a;F=g}else{A=c;c=e;e=a;a=g;while(1){g=0;do{z=Y(f[A+(g<<2)>>2]|0,f[e+(g<<2)>>2]|0)|0;y=g|1;s=Y(f[A+(y<<2)>>2]|0,f[e+(y<<2)>>2]|0)|0;f[c+(g<<2)>>2]=z;f[c+(y<<2)>>2]=s;s=g|2;y=Y(f[A+(s<<2)>>2]|0,f[e+(s<<2)>>2]|0)|0;z=g|3;r=Y(f[A+(z<<2)>>2]|0,f[e+(z<<2)>>2]|0)|0;f[c+(s<<2)>>2]=y;f[c+(z<<2)>>2]=r;g=g+4|0}while((g|0)<=(l|0));if(!a)break;else{A=A+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=Y(f[C+(a<<2)>>2]|0,f[E+(a<<2)>>2]|0)|0;c=a|1;A=Y(f[C+(c<<2)>>2]|0,f[E+(c<<2)>>2]|0)|0;f[D+(a<<2)>>2]=e;f[D+(c<<2)>>2]=A;A=a|2;c=Y(f[C+(A<<2)>>2]|0,f[E+(A<<2)>>2]|0)|0;e=a|3;g=Y(f[C+(e<<2)>>2]|0,f[E+(e<<2)>>2]|0)|0;f[D+(A<<2)>>2]=c;f[D+(e<<2)>>2]=g;a=a+4|0}while((a|0)<=(l|0));G=B;do{a=Y(f[C+(G<<2)>>2]|0,f[E+(G<<2)>>2]|0)|0;f[D+(G<<2)>>2]=a;G=G+1|0}while((G|0)!=(h|0));if(!F)break;else{C=C+(b<<2)|0;D=D+(d<<2)|0;E=E+(j<<2)|0;F=F+-1|0}}return}function TE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=+p[i>>3];i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;k=(h|0)==0;if(!(j==1.0)){if(k)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=c;m=e;o=a;q=f}else return;while(1){r=0;do{n[m+(r<<2)>>2]=j*+n[o+(r<<2)>>2]*+n[l+(r<<2)>>2];r=r+1|0}while((r|0)!=(g|0));if(!q)break;else{l=l+(b<<2)|0;m=m+(d<<2)|0;o=o+(i<<2)|0;q=q+-1|0}}return}q=g&-4;o=(q|0)<(g|0);m=c;l=e;r=a;s=f;while(1){t=0;do{u=t|1;v=j*+n[r+(u<<2)>>2]*+n[m+(u<<2)>>2];n[l+(t<<2)>>2]=j*+n[r+(t<<2)>>2]*+n[m+(t<<2)>>2];n[l+(u<<2)>>2]=v;u=t|2;w=t|3;v=j*+n[r+(w<<2)>>2]*+n[m+(w<<2)>>2];n[l+(u<<2)>>2]=j*+n[r+(u<<2)>>2]*+n[m+(u<<2)>>2];n[l+(w<<2)>>2]=v;t=t+4|0}while((t|0)<=(h|0));if(o){t=q;do{n[l+(t<<2)>>2]=j*+n[r+(t<<2)>>2]*+n[m+(t<<2)>>2];t=t+1|0}while((t|0)!=(g|0))}if(!s)break;else{m=m+(b<<2)|0;l=l+(d<<2)|0;r=r+(i<<2)|0;s=s+-1|0}}return}if(k)return;k=g+-4|0;if((g|0)<4){if((g|0)>0){x=c;y=e;z=a;A=f}else return;while(1){s=0;do{n[y+(s<<2)>>2]=+n[z+(s<<2)>>2]*+n[x+(s<<2)>>2];s=s+1|0}while((s|0)!=(g|0));if(!A)break;else{x=x+(b<<2)|0;y=y+(d<<2)|0;z=z+(i<<2)|0;A=A+-1|0}}return}A=g&-4;if((A|0)<(g|0)){B=c;C=e;D=a;E=f}else{z=c;c=e;e=a;a=f;while(1){f=0;do{y=f|1;j=+n[e+(y<<2)>>2]*+n[z+(y<<2)>>2];n[c+(f<<2)>>2]=+n[e+(f<<2)>>2]*+n[z+(f<<2)>>2];n[c+(y<<2)>>2]=j;y=f|2;x=f|3;j=+n[e+(x<<2)>>2]*+n[z+(x<<2)>>2];n[c+(y<<2)>>2]=+n[e+(y<<2)>>2]*+n[z+(y<<2)>>2];n[c+(x<<2)>>2]=j;f=f+4|0}while((f|0)<=(k|0));if(!a)break;else{z=z+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;j=+n[D+(e<<2)>>2]*+n[B+(e<<2)>>2];n[C+(a<<2)>>2]=+n[D+(a<<2)>>2]*+n[B+(a<<2)>>2];n[C+(e<<2)>>2]=j;e=a|2;c=a|3;j=+n[D+(c<<2)>>2]*+n[B+(c<<2)>>2];n[C+(e<<2)>>2]=+n[D+(e<<2)>>2]*+n[B+(e<<2)>>2];n[C+(c<<2)>>2]=j;a=a+4|0}while((a|0)<=(k|0));F=A;do{n[C+(F<<2)>>2]=+n[D+(F<<2)>>2]*+n[B+(F<<2)>>2];F=F+1|0}while((F|0)!=(g|0));if(!E)break;else{B=B+(b<<2)|0;C=C+(d<<2)|0;D=D+(i<<2)|0;E=E+-1|0}}return}function UE(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;j=+p[i>>3];i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;k=(h|0)==0;if(!(j==1.0)){if(k)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){l=c;m=e;n=a;o=f}else return;while(1){q=0;do{p[m+(q<<3)>>3]=j*+p[n+(q<<3)>>3]*+p[l+(q<<3)>>3];q=q+1|0}while((q|0)!=(g|0));if(!o)break;else{l=l+(b<<3)|0;m=m+(d<<3)|0;n=n+(i<<3)|0;o=o+-1|0}}return}o=g&-4;n=(o|0)<(g|0);m=c;l=e;q=a;r=f;while(1){s=0;do{t=s|1;u=j*+p[q+(t<<3)>>3]*+p[m+(t<<3)>>3];p[l+(s<<3)>>3]=j*+p[q+(s<<3)>>3]*+p[m+(s<<3)>>3];p[l+(t<<3)>>3]=u;t=s|2;v=s|3;u=j*+p[q+(v<<3)>>3]*+p[m+(v<<3)>>3];p[l+(t<<3)>>3]=j*+p[q+(t<<3)>>3]*+p[m+(t<<3)>>3];p[l+(v<<3)>>3]=u;s=s+4|0}while((s|0)<=(h|0));if(n){s=o;do{p[l+(s<<3)>>3]=j*+p[q+(s<<3)>>3]*+p[m+(s<<3)>>3];s=s+1|0}while((s|0)!=(g|0))}if(!r)break;else{m=m+(b<<3)|0;l=l+(d<<3)|0;q=q+(i<<3)|0;r=r+-1|0}}return}if(k)return;k=g+-4|0;if((g|0)<4){if((g|0)>0){w=c;x=e;y=a;z=f}else return;while(1){r=0;do{p[x+(r<<3)>>3]=+p[y+(r<<3)>>3]*+p[w+(r<<3)>>3];r=r+1|0}while((r|0)!=(g|0));if(!z)break;else{w=w+(b<<3)|0;x=x+(d<<3)|0;y=y+(i<<3)|0;z=z+-1|0}}return}z=g&-4;if((z|0)<(g|0)){A=c;B=e;C=a;D=f}else{y=c;c=e;e=a;a=f;while(1){f=0;do{x=f|1;j=+p[e+(x<<3)>>3]*+p[y+(x<<3)>>3];p[c+(f<<3)>>3]=+p[e+(f<<3)>>3]*+p[y+(f<<3)>>3];p[c+(x<<3)>>3]=j;x=f|2;w=f|3;j=+p[e+(w<<3)>>3]*+p[y+(w<<3)>>3];p[c+(x<<3)>>3]=+p[e+(x<<3)>>3]*+p[y+(x<<3)>>3];p[c+(w<<3)>>3]=j;f=f+4|0}while((f|0)<=(k|0));if(!a)break;else{y=y+(b<<3)|0;c=c+(d<<3)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;j=+p[C+(e<<3)>>3]*+p[A+(e<<3)>>3];p[B+(a<<3)>>3]=+p[C+(a<<3)>>3]*+p[A+(a<<3)>>3];p[B+(e<<3)>>3]=j;e=a|2;c=a|3;j=+p[C+(c<<3)>>3]*+p[A+(c<<3)>>3];p[B+(e<<3)>>3]=+p[C+(e<<3)>>3]*+p[A+(e<<3)>>3];p[B+(c<<3)>>3]=j;a=a+4|0}while((a|0)<=(k|0));E=z;do{p[B+(E<<3)>>3]=+p[C+(E<<3)>>3]*+p[A+(E<<3)>>3];E=E+1|0}while((E|0)!=(g|0));if(!D)break;else{A=A+(b<<3)|0;B=B+(d<<3)|0;C=C+(i<<3)|0;D=D+-1|0}}return}function VE(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;i=g+8|0;p[h>>3]=d;dQ(i,40440);WD(a,b,c,UM()|0,e,40460,1,h,6);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function WE(a,c,d,e,f,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;l=+p[k>>3];k=(i|0)>0&(j|0)!=0;if(!a){if(k){m=f;n=d;o=j}else return;while(1){q=0;do{r=b[n+q>>0]|0;if(!(r<<24>>24))s=0;else{t=LVb(l/+(r&255))|0;s=(t>>>0<256?t:(t|0)>0?255:0)&255}b[m+q>>0]=s;q=q+1|0}while((q|0)!=(i|0));o=o+-1|0;if(!o)break;else{m=m+g|0;n=n+e|0}}return}else{if(k){u=d;v=f;w=a;x=j}else return;while(1){j=0;do{a=b[u+j>>0]|0;if(!(a<<24>>24))y=0;else{f=LVb(l*+(h[w+j>>0]|0)/+(a&255))|0;y=(f>>>0<256?f:(f|0)>0?255:0)&255}b[v+j>>0]=y;j=j+1|0}while((j|0)!=(i|0));x=x+-1|0;if(!x)break;else{u=u+e|0;v=v+g|0;w=w+c|0}}return}}function XE(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0,q=0;k=+p[j>>3];if((h|0)>0&(i|0)!=0){l=d;m=f;n=a;o=i}else return;while(1){i=0;do{a=b[l+i>>0]|0;if(!(a<<24>>24))q=0;else{f=LVb(k*+(b[n+i>>0]|0)/+(a<<24>>24))|0;q=((f+128|0)>>>0<256?f:(f|0)>0?127:128)&255}b[m+i>>0]=q;i=i+1|0}while((i|0)!=(h|0));o=o+-1|0;if(!o)break;else{l=l+e|0;m=m+g|0;n=n+c|0}}return}function YE(a,b,c,e,f,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0.0,n=0,o=0,q=0,r=0,s=0;l=b>>>1;b=e>>>1;e=g>>>1;m=+p[k>>3];if((h|0)>0&(i|0)!=0){n=c;o=f;q=a;r=i}else return;while(1){i=0;do{a=d[n+(i<<1)>>1]|0;if(!(a<<16>>16))s=0;else{f=LVb(m*+(j[q+(i<<1)>>1]|0)/+(a&65535))|0;s=(f>>>0<65536?f:(f|0)>0?65535:0)&65535}d[o+(i<<1)>>1]=s;i=i+1|0}while((i|0)!=(h|0));r=r+-1|0;if(!r)break;else{n=n+(b<<1)|0;o=o+(e<<1)|0;q=q+(l<<1)|0}}return}function ZE(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0.0,m=0,n=0,o=0,q=0,r=0;k=b>>>1;b=e>>>1;e=g>>>1;l=+p[j>>3];if((h|0)>0&(i|0)!=0){m=c;n=f;o=a;q=i}else return;while(1){i=0;do{a=d[m+(i<<1)>>1]|0;if(!(a<<16>>16))r=0;else{f=LVb(l*+(d[o+(i<<1)>>1]|0)/+(a<<16>>16))|0;r=((f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768)&65535}d[n+(i<<1)>>1]=r;i=i+1|0}while((i|0)!=(h|0));q=q+-1|0;if(!q)break;else{m=m+(b<<1)|0;n=n+(e<<1)|0;o=o+(k<<1)|0}}return}function _E(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0.0,m=0,n=0,o=0,q=0,r=0;k=b>>>2;b=d>>>2;d=g>>>2;l=+p[j>>3];if((h|0)>0&(i|0)!=0){m=c;n=e;o=a;q=i}else return;while(1){i=0;do{a=f[m+(i<<2)>>2]|0;if(!a)r=0;else r=LVb(l*+(f[o+(i<<2)>>2]|0)/+(a|0))|0;f[n+(i<<2)>>2]=r;i=i+1|0}while((i|0)!=(h|0));q=q+-1|0;if(!q)break;else{m=m+(b<<2)|0;n=n+(d<<2)|0;o=o+(k<<2)|0}}return}function $E(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0,q=0.0,r=0.0;j=+p[i>>3];i=b>>>2;b=d>>>2;d=f>>>2;if((g|0)>0&(h|0)!=0){k=c;l=e;m=a;o=h}else return;while(1){h=0;do{q=+n[k+(h<<2)>>2];if(q!=0.0)r=j*+n[m+(h<<2)>>2]/q;else r=0.0;n[l+(h<<2)>>2]=r;h=h+1|0}while((h|0)!=(g|0));o=o+-1|0;if(!o)break;else{k=k+(b<<2)|0;l=l+(d<<2)|0;m=m+(i<<2)|0}}return}function aF(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0,o=0.0,q=0.0;j=+p[i>>3];i=b>>>3;b=d>>>3;d=f>>>3;if((g|0)>0&(h|0)!=0){k=c;l=e;m=a;n=h}else return;while(1){h=0;do{o=+p[k+(h<<3)>>3];if(o!=0.0)q=j*+p[m+(h<<3)>>3]/o;else q=0.0;p[l+(h<<3)>>3]=q;h=h+1|0}while((h|0)!=(g|0));n=n+-1|0;if(!n)break;else{k=k+(b<<3)|0;l=l+(d<<3)|0;m=m+(i<<3)|0}}return}function bF(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;h=e+8|0;p[g>>3]=a;dQ(h,40492);WD(b,b,c,UM()|0,d,40512,1,g,7);if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function cF(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0;k=+p[j>>3];if((h|0)>0&(i|0)!=0){l=f;m=d;n=i}else return;while(1){i=0;do{d=b[m+i>>0]|0;if(!(d<<24>>24))o=0;else{f=LVb(k/+(d&255))|0;o=(f>>>0<256?f:(f|0)>0?255:0)&255}b[l+i>>0]=o;i=i+1|0}while((i|0)!=(h|0));n=n+-1|0;if(!n)break;else{l=l+g|0;m=m+e|0}}return}function dF(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0;k=+p[j>>3];if((h|0)>0&(i|0)!=0){l=f;m=d;n=i}else return;while(1){i=0;do{d=b[m+i>>0]|0;if(!(d<<24>>24))o=0;else{f=LVb(k/+(d<<24>>24))|0;o=((f+128|0)>>>0<256?f:(f|0)>0?127:128)&255}b[l+i>>0]=o;i=i+1|0}while((i|0)!=(h|0));n=n+-1|0;if(!n)break;else{l=l+g|0;m=m+e|0}}return}function eF(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0;b=e>>>1;e=g>>>1;k=+p[j>>3];if((h|0)>0&(i|0)!=0){l=f;m=c;n=i}else return;while(1){i=0;do{c=d[m+(i<<1)>>1]|0;if(!(c<<16>>16))o=0;else{f=LVb(k/+(c&65535))|0;o=(f>>>0<65536?f:(f|0)>0?65535:0)&65535}d[l+(i<<1)>>1]=o;i=i+1|0}while((i|0)!=(h|0));n=n+-1|0;if(!n)break;else{l=l+(e<<1)|0;m=m+(b<<1)|0}}return}function fF(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0;b=e>>>1;e=g>>>1;k=+p[j>>3];if((h|0)>0&(i|0)!=0){l=f;m=c;n=i}else return;while(1){i=0;do{c=d[m+(i<<1)>>1]|0;if(!(c<<16>>16))o=0;else{f=LVb(k/+(c<<16>>16))|0;o=((f+32768|0)>>>0<65536?f:(f|0)>0?32767:32768)&65535}d[l+(i<<1)>>1]=o;i=i+1|0}while((i|0)!=(h|0));n=n+-1|0;if(!n)break;else{l=l+(e<<1)|0;m=m+(b<<1)|0}}return}function gF(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0,m=0,n=0,o=0;b=d>>>2;d=g>>>2;k=+p[j>>3];if((h|0)>0&(i|0)!=0){l=e;m=c;n=i}else return;while(1){i=0;do{c=f[m+(i<<2)>>2]|0;if(!c)o=0;else o=LVb(k/+(c|0))|0;f[l+(i<<2)>>2]=o;i=i+1|0}while((i|0)!=(h|0));n=n+-1|0;if(!n)break;else{l=l+(d<<2)|0;m=m+(b<<2)|0}}return}function hF(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,o=0.0;j=+p[i>>3];i=d>>>2;d=f>>>2;if((g|0)>0&(h|0)!=0){k=e;l=c;m=h}else return;while(1){h=0;do{o=+n[l+(h<<2)>>2];n[k+(h<<2)>>2]=o!=0.0?j/o:0.0;h=h+1|0}while((h|0)!=(g|0));m=m+-1|0;if(!m)break;else{k=k+(d<<2)|0;l=l+(i<<2)|0}}return}function iF(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,l=0,m=0,n=0.0;j=+p[i>>3];i=d>>>3;d=f>>>3;if((g|0)>0&(h|0)!=0){k=e;l=c;m=h}else return;while(1){h=0;do{n=+p[l+(h<<3)>>3];p[k+(h<<3)>>3]=n!=0.0?j/n:0.0;h=h+1|0}while((h|0)!=(g|0));m=m+-1|0;if(!m)break;else{k=k+(d<<3)|0;l=l+(i<<3)|0}}return}function jF(a,b,c,d,e,g,h){a=a|0;b=+b;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+32|0;j=i+24|0;k=i;dQ(j,40544);p[k>>3]=b;p[k+8>>3]=d;p[k+16>>3]=e;WD(a,c,g,UM()|0,h,40564,1,k,8);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function kF(a,c,d,e,f,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,o=0.0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0;l=+p[k>>3];m=+p[k+8>>3];o=+p[k+16>>3];if(!j)return;k=i+-4|0;q=(i|0)<4;r=i&-4;s=d;d=f;f=a;a=j;while(1){a=a+-1|0;if(q)t=0;else{j=0;do{u=j|1;v=o+(l*+n[43660+((h[f+u>>0]|0)+128<<2)>>2]+m*+n[43660+((h[s+u>>0]|0)+128<<2)>>2]);w=LVb(o+(l*+n[43660+((h[f+j>>0]|0)+128<<2)>>2]+m*+n[43660+((h[s+j>>0]|0)+128<<2)>>2]))|0;b[d+j>>0]=w>>>0<256?w:(w|0)>0?255:0;w=LVb(v)|0;b[d+u>>0]=w>>>0<256?w:(w|0)>0?255:0;w=j|2;u=j|3;v=o+(l*+n[43660+((h[f+u>>0]|0)+128<<2)>>2]+m*+n[43660+((h[s+u>>0]|0)+128<<2)>>2]);x=LVb(o+(l*+n[43660+((h[f+w>>0]|0)+128<<2)>>2]+m*+n[43660+((h[s+w>>0]|0)+128<<2)>>2]))|0;b[d+w>>0]=x>>>0<256?x:(x|0)>0?255:0;x=LVb(v)|0;b[d+u>>0]=x>>>0<256?x:(x|0)>0?255:0;j=j+4|0}while((j|0)<=(k|0));t=r}if((t|0)<(i|0)){j=t;do{x=LVb(o+(l*+n[43660+((h[f+j>>0]|0)+128<<2)>>2]+m*+n[43660+((h[s+j>>0]|0)+128<<2)>>2]))|0;b[d+j>>0]=x>>>0<256?x:(x|0)>0?255:0;j=j+1|0}while((j|0)!=(i|0))}if(!a)break;else{s=s+e|0;d=d+g|0;f=f+c|0}}return}function lF(a,c,d,e,f,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0;k=+p[j>>3];l=+p[j+8>>3];m=+p[j+16>>3];if(!i)return;j=h+-4|0;n=(h|0)<4;o=h&-4;q=d;d=f;f=a;a=i;while(1){a=a+-1|0;if(n)r=0;else{i=0;do{s=LVb(m+(k*+(b[f+i>>0]|0)+l*+(b[q+i>>0]|0)))|0;t=i|1;u=LVb(m+(k*+(b[f+t>>0]|0)+l*+(b[q+t>>0]|0)))|0;b[d+i>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;b[d+t>>0]=(u+128|0)>>>0<256?u:(u|0)>0?127:128;u=i|2;t=LVb(m+(k*+(b[f+u>>0]|0)+l*+(b[q+u>>0]|0)))|0;s=i|3;v=LVb(m+(k*+(b[f+s>>0]|0)+l*+(b[q+s>>0]|0)))|0;b[d+u>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;b[d+s>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;i=i+4|0}while((i|0)<=(j|0));r=o}if((r|0)<(h|0)){i=r;do{v=LVb(m+(k*+(b[f+i>>0]|0)+l*+(b[q+i>>0]|0)))|0;b[d+i>>0]=(v+128|0)>>>0<256?v:(v|0)>0?127:128;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{q=q+e|0;d=d+g|0;f=f+c|0}}return}function mF(a,b,c,e,f,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0.0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=+p[k>>3];m=+p[k+8>>3];n=+p[k+16>>3];k=b>>>1;b=e>>>1;e=g>>>1;if(!i)return;g=h+-4|0;o=(h|0)<4;q=h&-4;r=c;c=f;f=a;a=i;while(1){a=a+-1|0;if(o)s=0;else{i=0;do{t=LVb(n+(l*+(j[f+(i<<1)>>1]|0)+m*+(j[r+(i<<1)>>1]|0)))|0;u=i|1;v=LVb(n+(l*+(j[f+(u<<1)>>1]|0)+m*+(j[r+(u<<1)>>1]|0)))|0;d[c+(i<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[c+(u<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;v=i|2;u=LVb(n+(l*+(j[f+(v<<1)>>1]|0)+m*+(j[r+(v<<1)>>1]|0)))|0;t=i|3;w=LVb(n+(l*+(j[f+(t<<1)>>1]|0)+m*+(j[r+(t<<1)>>1]|0)))|0;d[c+(v<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[c+(t<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;i=i+4|0}while((i|0)<=(g|0));s=q}if((s|0)<(h|0)){i=s;do{w=LVb(n+(l*+(j[f+(i<<1)>>1]|0)+m*+(j[r+(i<<1)>>1]|0)))|0;d[c+(i<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{r=r+(b<<1)|0;c=c+(e<<1)|0;f=f+(k<<1)|0}}return}function nF(a,b,c,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0;k=+p[j>>3];l=+p[j+8>>3];m=+p[j+16>>3];j=b>>>1;b=e>>>1;e=g>>>1;if(!i)return;g=h+-4|0;n=(h|0)<4;o=h&-4;q=c;c=f;f=a;a=i;while(1){a=a+-1|0;if(n)r=0;else{i=0;do{s=LVb(m+(k*+(d[f+(i<<1)>>1]|0)+l*+(d[q+(i<<1)>>1]|0)))|0;t=i|1;u=LVb(m+(k*+(d[f+(t<<1)>>1]|0)+l*+(d[q+(t<<1)>>1]|0)))|0;d[c+(i<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[c+(t<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;u=i|2;t=LVb(m+(k*+(d[f+(u<<1)>>1]|0)+l*+(d[q+(u<<1)>>1]|0)))|0;s=i|3;v=LVb(m+(k*+(d[f+(s<<1)>>1]|0)+l*+(d[q+(s<<1)>>1]|0)))|0;d[c+(u<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[c+(s<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;i=i+4|0}while((i|0)<=(g|0));r=o}if((r|0)<(h|0)){i=r;do{v=LVb(m+(k*+(d[f+(i<<1)>>1]|0)+l*+(d[q+(i<<1)>>1]|0)))|0;d[c+(i<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;i=i+1|0}while((i|0)!=(h|0))}if(!a)break;else{q=q+(b<<1)|0;c=c+(e<<1)|0;f=f+(j<<1)|0}}return}function oF(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0,u=0;k=+p[j>>3];l=+p[j+8>>3];m=+p[j+16>>3];j=b>>>2;b=d>>>2;d=g>>>2;g=i+-1|0;if(!i)return;i=h+-4|0;if((h|0)<4){if((h|0)>0){n=c;o=e;q=a;r=g}else return;while(1){s=0;do{t=MVb(m+(k*+(f[q+(s<<2)>>2]|0)+l*+(f[n+(s<<2)>>2]|0)))|0;f[o+(s<<2)>>2]=t;s=s+1|0}while((s|0)!=(h|0));if(!r)break;else{n=n+(b<<2)|0;o=o+(d<<2)|0;q=q+(j<<2)|0;r=r+-1|0}}return}r=h&-4;q=(r|0)<(h|0);o=c;c=e;e=a;a=g;while(1){g=0;do{n=MVb(m+(k*+(f[e+(g<<2)>>2]|0)+l*+(f[o+(g<<2)>>2]|0)))|0;s=g|1;t=MVb(m+(k*+(f[e+(s<<2)>>2]|0)+l*+(f[o+(s<<2)>>2]|0)))|0;f[c+(g<<2)>>2]=n;f[c+(s<<2)>>2]=t;t=g|2;s=MVb(m+(k*+(f[e+(t<<2)>>2]|0)+l*+(f[o+(t<<2)>>2]|0)))|0;n=g|3;u=MVb(m+(k*+(f[e+(n<<2)>>2]|0)+l*+(f[o+(n<<2)>>2]|0)))|0;f[c+(t<<2)>>2]=s;f[c+(n<<2)>>2]=u;g=g+4|0}while((g|0)<=(i|0));if(q){g=r;do{u=MVb(m+(k*+(f[e+(g<<2)>>2]|0)+l*+(f[o+(g<<2)>>2]|0)))|0;f[c+(g<<2)>>2]=u;g=g+1|0}while((g|0)!=(h|0))}if(!a)break;else{o=o+(b<<2)|0;c=c+(d<<2)|0;e=e+(j<<2)|0;a=a+-1|0}}return}function pF(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0.0;j=+p[i>>3];k=+p[i+8>>3];l=+p[i+16>>3];i=b>>>2;b=d>>>2;d=f>>>2;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){m=c;o=e;q=a;r=f}else return;while(1){s=0;do{n[o+(s<<2)>>2]=l+(j*+n[q+(s<<2)>>2]+k*+n[m+(s<<2)>>2]);s=s+1|0}while((s|0)!=(g|0));if(!r)break;else{m=m+(b<<2)|0;o=o+(d<<2)|0;q=q+(i<<2)|0;r=r+-1|0}}return}r=g&-4;q=(r|0)<(g|0);o=c;c=e;e=a;a=f;while(1){f=0;do{m=f|1;t=l+(j*+n[e+(m<<2)>>2]+k*+n[o+(m<<2)>>2]);n[c+(f<<2)>>2]=l+(j*+n[e+(f<<2)>>2]+k*+n[o+(f<<2)>>2]);n[c+(m<<2)>>2]=t;m=f|2;s=f|3;t=l+(j*+n[e+(s<<2)>>2]+k*+n[o+(s<<2)>>2]);n[c+(m<<2)>>2]=l+(j*+n[e+(m<<2)>>2]+k*+n[o+(m<<2)>>2]);n[c+(s<<2)>>2]=t;f=f+4|0}while((f|0)<=(h|0));if(q){f=r;do{n[c+(f<<2)>>2]=l+(j*+n[e+(f<<2)>>2]+k*+n[o+(f<<2)>>2]);f=f+1|0}while((f|0)!=(g|0))}if(!a)break;else{o=o+(b<<2)|0;c=c+(d<<2)|0;e=e+(i<<2)|0;a=a+-1|0}}return}function qF(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;j=+p[i>>3];k=+p[i+8>>3];l=+p[i+16>>3];i=b>>>3;b=d>>>3;d=f>>>3;f=h+-1|0;if(!h)return;h=g+-4|0;if((g|0)<4){if((g|0)>0){m=c;n=e;o=a;q=f}else return;while(1){r=0;do{p[n+(r<<3)>>3]=l+(j*+p[o+(r<<3)>>3]+k*+p[m+(r<<3)>>3]);r=r+1|0}while((r|0)!=(g|0));if(!q)break;else{m=m+(b<<3)|0;n=n+(d<<3)|0;o=o+(i<<3)|0;q=q+-1|0}}return}q=g&-4;if((q|0)<(g|0)){s=c;t=e;u=a;v=f}else{o=c;c=e;e=a;a=f;while(1){f=0;do{n=f|1;w=l+(j*+p[e+(n<<3)>>3]+k*+p[o+(n<<3)>>3]);p[c+(f<<3)>>3]=l+(j*+p[e+(f<<3)>>3]+k*+p[o+(f<<3)>>3]);p[c+(n<<3)>>3]=w;n=f|2;m=f|3;w=l+(j*+p[e+(m<<3)>>3]+k*+p[o+(m<<3)>>3]);p[c+(n<<3)>>3]=l+(j*+p[e+(n<<3)>>3]+k*+p[o+(n<<3)>>3]);p[c+(m<<3)>>3]=w;f=f+4|0}while((f|0)<=(h|0));if(!a)break;else{o=o+(b<<3)|0;c=c+(d<<3)|0;e=e+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;w=l+(j*+p[u+(e<<3)>>3]+k*+p[s+(e<<3)>>3]);p[t+(a<<3)>>3]=l+(j*+p[u+(a<<3)>>3]+k*+p[s+(a<<3)>>3]);p[t+(e<<3)>>3]=w;e=a|2;c=a|3;w=l+(j*+p[u+(c<<3)>>3]+k*+p[s+(c<<3)>>3]);p[t+(e<<3)>>3]=l+(j*+p[u+(e<<3)>>3]+k*+p[s+(e<<3)>>3]);p[t+(c<<3)>>3]=w;a=a+4|0}while((a|0)<=(h|0));x=q;do{p[t+(x<<3)>>3]=l+(j*+p[u+(x<<3)>>3]+k*+p[s+(x<<3)>>3]);x=x+1|0}while((x|0)!=(g|0));if(!v)break;else{s=s+(b<<3)|0;t=t+(d<<3)|0;u=u+(i<<3)|0;v=v+-1|0}}return}function rF(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0.0,aa=0.0,ba=0;g=u;u=u+1456|0;h=g+1400|0;i=g+1392|0;j=g+1384|0;k=g+1264|0;l=g+1376|0;m=g+1208|0;n=g+1320|0;o=g+1192|0;q=g+1168|0;r=g+1136|0;s=g+96|0;t=g+88|0;v=g+1184|0;w=g+56|0;x=g;f[i>>2]=e;dQ(j,40596);if(e>>>0>=6){f[h>>2]=0;f[h+4>>2]=0;e=aD(h,92)|0;y=173867;z=e+92|0;do{b[e>>0]=b[y>>0]|0;e=e+1|0;y=y+1|0}while((e|0)<(z|0));bO(-215,h,173960,172127,1234);bD(h)}y=yM(a)|0;if(((((yM(c)|0)==131072&1)+((y|0)==131072&1)|0)!=1?DM(a,c)|0:0)?(y=BL(a,-1)|0,(y|0)==(BL(c,-1)|0)):0){A=0;B=32}else B=6;do if((B|0)==6){y=BL(c,-1)|0;e=yM(a)|0;z=yM(c)|0;if((_L(a,-1)|0)<=2?IM(a,-1)|0:0){AL(h,a,-1);C=f[h>>2]|0;D=(C|0)==1;if(!D?(f[h+4>>2]|0)!=1:0)E=0;else{F=(y>>>3&511)+1|0;if(!((e|0)!=131072&(z|0)==131072)){z=f[h+4>>2]|0;e=(z|0)==1;if(!((C|0)==(F|0)&e|D&(e|(z|0)==(F|0))))if(D&(z|0)==4)E=F>>>0<5&(BL(a,-1)|0)==6;else E=0;else E=1}else E=0}G=E}else G=0;F=BL(a,-1)|0;z=yM(c)|0;D=yM(a)|0;if((_L(c,-1)|0)<=2?IM(c,-1)|0:0){AL(h,c,-1);e=f[h>>2]|0;C=(e|0)==1;if(!C?(f[h+4>>2]|0)!=1:0)H=0;else{y=(F>>>3&511)+1|0;if(!((z|0)!=131072&(D|0)==131072)){D=f[h+4>>2]|0;z=(D|0)==1;if(!((e|0)==(y|0)&z|C&(z|(D|0)==(y|0))))if(C&(D|0)==4)H=y>>>0<5&(BL(c,-1)|0)==6;else H=0;else H=1}else H=0}I=H}else I=0;y=G^1;if(I|y){if((y|I^1)&(G|I)){A=1;B=32;break}f[h>>2]=0;f[h+4>>2]=0;Vac(aD(h,139)|0,173968,139)|0;bO(-209,h,173960,172127,1256);bD(h);A=1;B=32;break}y=f[i>>2]|0;switch(y|0){case 3:{K=1;break}case 4:{K=2;break}case 2:{K=4;break}default:K=(y|0)==1?3:y}f[i>>2]=K;rF(c,a,d,K)}while(0);if((B|0)==32){K=yM(a)|0;I=yM(c)|0;do if((yM(a)|0)==65536){G=f[a+4>>2]|0;f[h>>2]=f[G>>2];H=h+4|0;E=G+4|0;f[H>>2]=f[E>>2];y=h+8|0;f[y>>2]=f[G+8>>2];f[h+12>>2]=f[G+12>>2];f[h+16>>2]=f[G+16>>2];f[h+20>>2]=f[G+20>>2];f[h+24>>2]=f[G+24>>2];f[h+28>>2]=f[G+28>>2];f[h+32>>2]=f[G+32>>2];D=f[G+36>>2]|0;f[h+36>>2]=D;f[h+40>>2]=y;y=h+48|0;C=h+44|0;f[C>>2]=y;f[y>>2]=0;f[h+52>>2]=0;if(D|0){y=D+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[E>>2]|0)<3){E=f[G+44>>2]|0;y=f[C>>2]|0;f[y>>2]=f[E>>2];f[y+4>>2]=f[E+4>>2];break}else{f[H>>2]=0;jL(h,G);break}}else yL(h,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];G=k+4|0;H=a+4|0;f[G>>2]=f[H>>2];E=k+8|0;f[E>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[k+36>>2]=y;f[k+40>>2]=E;E=k+48|0;C=k+44|0;f[C>>2]=E;f[E>>2]=0;f[k+52>>2]=0;if(y|0){E=y+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[H>>2]|0)<3){H=f[a+44>>2]|0;E=f[C>>2]|0;f[E>>2]=f[H>>2];f[E+4>>2]=f[H+4>>2];break}else{f[G>>2]=0;jL(k,a);break}}else yL(k,c,-1);while(0);c=h+4|0;a=f[c>>2]|0;if(((K|0)==(I|0)&(a|0)<3?(f[k+4>>2]|0)<3:0)?(I=h+40|0,K=f[I>>2]|0,G=f[K+4>>2]|0,H=f[K>>2]|0,E=f[k+40>>2]|0,(H|0)==(f[E>>2]|0)?(G|0)==(f[E+4>>2]|0):0):0){E=f[h>>2]|0;C=f[k>>2]|0;y=(E>>>3&511)+1|0;if(!((C^E)&4095)){f[l>>2]=G;f[l+4>>2]=H;vM(d,l,(y<<3)+-8|0,-1,0,0);do if((yM(d)|0)==65536){l=f[d+4>>2]|0;f[m>>2]=f[l>>2];H=m+4|0;G=l+4|0;f[H>>2]=f[G>>2];D=m+8|0;f[D>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];z=f[l+36>>2]|0;f[m+36>>2]=z;f[m+40>>2]=D;D=m+48|0;e=m+44|0;f[e>>2]=D;f[D>>2]=0;f[m+52>>2]=0;if(z|0){D=z+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[G>>2]|0)<3){G=f[l+44>>2]|0;D=f[e>>2]|0;f[D>>2]=f[G>>2];f[D+4>>2]=f[G+4>>2];L=m;break}else{f[H>>2]=0;jL(m,l);L=m;break}}else{yL(m,d,-1);L=m}while(0);l=f[h>>2]|0;H=(l>>>3&511)+1|0;G=f[k>>2]|0;D=f[L>>2]|0;L=f[h+12>>2]|0;e=f[h+8>>2]|0;z=cbc(L|0,((L|0)<0)<<31>>31|0,H|0,0)|0;F=cbc(z|0,J|0,e|0,((e|0)<0)<<31>>31|0)|0;if((l&16384&G&D|0)!=0?(F|0)==(F|0)&(((F|0)<0)<<31>>31|0)==(J|0):0){M=1;N=F}else{M=e;N=Y(L,H)|0}H=m+16|0;L=m+44|0;e=m+48|0;Th[f[40616+((l&7)<<2)>>2]&127](f[h+16>>2]|0,f[h+48>>2]|0,f[k+16>>2]|0,f[k+48>>2]|0,f[H>>2]|0,f[e>>2]|0,N,M,i);M=m+36|0;N=f[M>>2]|0;if(N|0?(l=N+12|0,N=f[l>>2]|0,f[l>>2]=N+-1,(N|0)==1):0)kL(m);f[M>>2]=0;M=m+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[M>>2]|0)>0){H=f[m+40>>2]|0;N=0;do{f[H+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[M>>2]|0))}M=f[L>>2]|0;if((M|0)!=(e|0))UC(M);O=k+36|0}else{P=k;Q=I;R=E;S=C;T=y;U=K;V=h;B=70}}else{K=f[h>>2]|0;y=h+40|0;P=k;Q=y;R=K;S=f[k>>2]|0;T=(K>>>3&511)+1|0;U=f[y>>2]|0;V=h;B=70}if((B|0)==70){y=R&7;R=S&7;wL(d,a,U,(T<<3)+-8|0,-1,0,0);WL(m,h,1,0);T=m+36|0;U=f[T>>2]|0;if(U|0){a=U+12|0;f[a>>2]=(f[a>>2]|0)+1}a=h+36|0;U=f[a>>2]|0;if(U|0?(S=U+12|0,U=f[S>>2]|0,f[S>>2]=U+-1,(U|0)==1):0)kL(h);f[a>>2]=0;U=h+16|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[c>>2]|0)>0){S=f[Q>>2]|0;Q=0;do{f[S+(Q<<2)>>2]=0;Q=Q+1|0;W=f[c>>2]|0}while((Q|0)<(W|0));f[V>>2]=f[m>>2];if((W|0)<3)B=80;else B=82}else{f[V>>2]=f[m>>2];B=80}if((B|0)==80){V=f[m+4>>2]|0;if((V|0)<3){f[c>>2]=V;f[h+8>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];V=f[m+44>>2]|0;W=f[h+44>>2]|0;f[W>>2]=f[V>>2];f[W+4>>2]=f[V+4>>2]}else B=82}if((B|0)==82)jL(h,m);V=m+16|0;f[U>>2]=f[V>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];U=f[T>>2]|0;f[a>>2]=U;if(U|0?(a=U+12|0,U=f[a>>2]|0,f[a>>2]=U+-1,(U|0)==1):0)kL(m);f[T>>2]=0;T=m+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[T>>2]|0)>0){V=f[m+40>>2]|0;U=0;do{f[V+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[T>>2]|0))}T=f[m+44>>2]|0;if((T|0)!=(m+48|0))UC(T);WL(m,k,1,0);T=m+36|0;U=f[T>>2]|0;if(U|0){V=U+12|0;f[V>>2]=(f[V>>2]|0)+1}V=k+36|0;U=f[V>>2]|0;if(U|0?(a=U+12|0,U=f[a>>2]|0,f[a>>2]=U+-1,(U|0)==1):0)kL(k);f[V>>2]=0;U=k+16|0;a=k+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[a>>2]|0)>0){W=f[k+40>>2]|0;Q=0;do{f[W+(Q<<2)>>2]=0;Q=Q+1|0;X=f[a>>2]|0}while((Q|0)<(X|0));f[P>>2]=f[m>>2];if((X|0)<3)B=101;else B=103}else{f[P>>2]=f[m>>2];B=101}if((B|0)==101){P=f[m+4>>2]|0;if((P|0)<3){f[a>>2]=P;f[k+8>>2]=f[m+8>>2];f[k+12>>2]=f[m+12>>2];P=f[m+44>>2]|0;a=f[k+44>>2]|0;f[a>>2]=f[P>>2];f[a+4>>2]=f[P+4>>2]}else B=103}if((B|0)==103)jL(k,m);P=m+16|0;f[U>>2]=f[P>>2];f[k+20>>2]=f[m+20>>2];f[k+24>>2]=f[m+24>>2];f[k+28>>2]=f[m+28>>2];f[k+32>>2]=f[m+32>>2];a=f[T>>2]|0;f[V>>2]=a;if(a|0?(X=a+12|0,a=f[X>>2]|0,f[X>>2]=a+-1,(a|0)==1):0)kL(m);f[T>>2]=0;T=m+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[T>>2]|0)>0){P=f[m+40>>2]|0;a=0;do{f[P+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[T>>2]|0))}T=f[m+44>>2]|0;if((T|0)!=(m+48|0))UC(T);do if((yM(d)|0)==65536){T=f[d+4>>2]|0;f[n>>2]=f[T>>2];a=n+4|0;P=T+4|0;f[a>>2]=f[P>>2];X=n+8|0;f[X>>2]=f[T+8>>2];f[n+12>>2]=f[T+12>>2];f[n+16>>2]=f[T+16>>2];f[n+20>>2]=f[T+20>>2];f[n+24>>2]=f[T+24>>2];f[n+28>>2]=f[T+28>>2];f[n+32>>2]=f[T+32>>2];Q=f[T+36>>2]|0;f[n+36>>2]=Q;f[n+40>>2]=X;X=n+48|0;W=n+44|0;f[W>>2]=X;f[X>>2]=0;f[n+52>>2]=0;if(Q|0){X=Q+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[P>>2]|0)<3){P=f[T+44>>2]|0;X=f[W>>2]|0;f[X>>2]=f[P>>2];f[X+4>>2]=f[P+4>>2];break}else{f[a>>2]=0;jL(n,T);break}}else yL(n,d,-1);while(0);WL(m,n,1,0);d=n+36|0;T=f[d>>2]|0;do if(T|0){a=T+12|0;P=f[a>>2]|0;f[a>>2]=P+-1;if((P|0)!=1)break;kL(n)}while(0);f[d>>2]=0;d=n+16|0;T=n+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[T>>2]|0)>0){d=f[n+40>>2]|0;P=0;do{f[d+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[T>>2]|0))}T=f[n+44>>2]|0;if((T|0)!=(n+48|0))UC(T);T=f[c>>2]|0;if((T|0)>0)Z=f[(f[h+44>>2]|0)+(T+-1<<2)>>2]|0;else Z=0;T=(Z|0)==0?1:Z;Z=((T+1023|0)>>>0)/(T>>>0)|0;c=f[40616+(y<<2)>>2]|0;if(A){f[o>>2]=h;f[o+4>>2]=m;f[o+8>>2]=0;RN(r,o,q,-1);A=f[r+20>>2]|0;n=Z>>>0<A>>>0?Z:A;Z=Y(n,T)|0;P=s+8|0;f[s>>2]=P;d=s+4|0;f[d>>2]=Z;if(Z>>>0>1032){a=N5b(Z)|0;f[s>>2]=a;_=a}else _=P;a:do if(y>>>0>4){cD(k,y,_,n);B=157}else{p[t>>3]=0.0;a=KI(R,6)|0;Z=f[U>>2]|0;f[v>>2]=1;f[v+4>>2]=1;Hh[a&255](Z,1,0,1,t,1,v,0);$=+p[t>>3];do if($<+p[9992+(y<<3)>>3]){Z=f[i>>2]|0;aa=(Z|0)==5|(Z+-1|0)>>>0<2?255.0:0.0;p[w>>3]=aa;p[w+8>>3]=aa;p[w+16>>3]=aa;p[w+24>>3]=aa;UP(m,w)|0}else{if($>+p[10056+(y<<3)>>3]){aa=((f[i>>2]|0)+-3|0)>>>0<3?255.0:0.0;p[w>>3]=aa;p[w+8>>3]=aa;p[w+16>>3]=aa;p[w+24>>3]=aa;UP(m,w)|0;break}Z=MVb($)|0;f[w>>2]=Z;b:do if($!=+(Z|0)){a=f[i>>2]|0;if((a|1|0)==3){X=~~$;f[w>>2]=(+(X|0)<$&1)+X;break}switch(a|0){case 1:case 4:{X=~~$;f[w>>2]=X-(+(X|0)>$&1);break b;break}default:{aa=(a|0)==5?255.0:0.0;p[x>>3]=aa;p[x+8>>3]=aa;p[x+16>>3]=aa;p[x+24>>3]=aa;UP(m,x)|0;break a}}}while(0);Z=x+4|0;f[Z>>2]=2;a=x+8|0;f[a>>2]=1;f[x+12>>2]=1;X=x+16|0;f[X>>2]=w;f[x+20>>2]=w;W=x+24|0;Q=x+40|0;S=W+8|0;f[S>>2]=0;f[S+4>>2]=0;f[Q>>2]=a;a=x+48|0;S=x+44|0;f[S>>2]=a;f[x>>2]=1124024324;f[a>>2]=4;f[x+52>>2]=4;f[x+28>>2]=w+4;f[W>>2]=w+4;cD(x,y,_,n);W=x+36|0;K=f[W>>2]|0;do if(K|0){C=K+12|0;E=f[C>>2]|0;f[C>>2]=E+-1;if((E|0)!=1)break;kL(x)}while(0);f[W>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[Z>>2]|0)>0){K=f[Q>>2]|0;E=0;do{f[K+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[Z>>2]|0))}Z=f[S>>2]|0;if((Z|0)!=(a|0))UC(Z);B=157;break a}while(0)}while(0);c:do if((B|0)==157){x=r+16|0;y=q+4|0;if(!A){w=0;while(1){if(w>>>0>=(f[x>>2]|0)>>>0)break c;aL(r)|0;w=w+1|0}}else ba=0;while(1){if(ba>>>0>=(f[x>>2]|0)>>>0)break c;w=0;t=f[q>>2]|0;v=f[y>>2]|0;do{U=A-w|0;R=U>>>0>n>>>0?n:U;Th[c&127](t,0,_,0,v,0,R,1,i);U=Y(R,T)|0;t=(f[q>>2]|0)+U|0;f[q>>2]=t;v=(f[y>>2]|0)+R|0;f[y>>2]=v;w=w+n|0}while(A>>>0>w>>>0);aL(r)|0;ba=ba+1|0}}while(0);ba=f[s>>2]|0;if((ba|0)!=(P|0)){if(ba|0)P5b(ba);f[s>>2]=P;f[d>>2]=1032}}else{f[o>>2]=h;f[o+4>>2]=k;f[o+8>>2]=m;f[o+12>>2]=0;RN(r,o,q,-1);o=f[r+20>>2]|0;d=r+16|0;P=q+4|0;s=q+8|0;ba=0;while(1){if(ba>>>0>=(f[d>>2]|0)>>>0)break;Th[c&127](f[q>>2]|0,0,f[P>>2]|0,0,f[s>>2]|0,0,o,1,i);aL(r)|0;ba=ba+1|0}}ba=m+36|0;r=f[ba>>2]|0;do if(r|0){i=r+12|0;o=f[i>>2]|0;f[i>>2]=o+-1;if((o|0)!=1)break;kL(m)}while(0);f[ba>>2]=0;ba=m+16|0;r=m+4|0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[r>>2]|0)>0){ba=f[m+40>>2]|0;o=0;do{f[ba+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[r>>2]|0))}r=f[m+44>>2]|0;if((r|0)!=(m+48|0))UC(r);O=V}V=f[O>>2]|0;if(V|0?(r=V+12|0,V=f[r>>2]|0,f[r>>2]=V+-1,(V|0)==1):0)kL(k);f[O>>2]=0;O=k+16|0;V=k+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[V>>2]|0)>0){O=f[k+40>>2]|0;r=0;do{f[O+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[V>>2]|0))}V=f[k+44>>2]|0;if((V|0)!=(k+48|0))UC(V);V=h+36|0;k=f[V>>2]|0;if(k|0?(r=k+12|0,k=f[r>>2]|0,f[r>>2]=k+-1,(k|0)==1):0)kL(h);f[V>>2]=0;V=h+16|0;k=h+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[k>>2]|0)>0){V=f[h+40>>2]|0;r=0;do{f[V+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[k>>2]|0))}k=f[h+44>>2]|0;if((k|0)!=(h+48|0))UC(k)}if(!(f[j+4>>2]|0)){u=g;return}u=g;return}function sF(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;m=a;a=d;d=f[l>>2]|0;l=(d|1|0)==3;n=l?a:m;o=l?e:c;p=l?m:a;a=l?c:e;e=l?((d|0)==2?4:1):d;switch(e|0){case 1:case 4:{d=(e|0)==1?0:255;if((k|0)!=0&(j|0)>0){q=g;r=k;s=p;t=n}else return;while(1){r=r+-1|0;l=t;c=s;m=0;do{b[q+m>>0]=((h[l+m>>0]|0)>(h[c+m>>0]|0))<<31>>31^d;m=m+1|0}while((m|0)!=(j|0));if(!r)break;else{q=q+i|0;s=c+a|0;t=l+o|0}}return}case 0:case 5:{t=(e|0)==0?0:255;if((k|0)!=0&(j|0)>0){u=g;v=k;w=p;x=n}else return;while(1){v=v+-1|0;n=x;p=w;k=0;do{b[u+k>>0]=((b[n+k>>0]|0)==(b[p+k>>0]|0))<<31>>31^t;k=k+1|0}while((k|0)!=(j|0));if(!v)break;else{u=u+i|0;w=p+a|0;x=n+o|0}}return}default:return}}function tF(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;l=f[k>>2]|0;k=a;a=d;d=(l|1|0)==3;m=d?e:c;n=d?k:a;o=d?c:e;e=d?a:k;k=d?((l|0)==2?4:1):l;switch(k|0){case 1:case 4:{l=(k|0)==1?0:255;d=j+-1|0;if(!j)return;a=i+-4|0;if((i|0)<4){if((i|0)>0){p=g;q=n;r=e;s=d}else return;while(1){c=r;t=q;u=0;do{b[p+u>>0]=((b[c+u>>0]|0)>(b[t+u>>0]|0))<<31>>31^l;u=u+1|0}while((u|0)!=(i|0));if(!s)break;else{p=p+h|0;q=t+o|0;r=c+m|0;s=s+-1|0}}return}s=i&-4;if((s|0)<(i|0)){v=g;w=n;x=e;y=d}else{r=g;q=n;p=e;u=d;while(1){d=p;z=q;A=0;do{B=A|1;C=((b[d+B>>0]|0)>(b[z+B>>0]|0))<<31>>31^l;b[r+A>>0]=((b[d+A>>0]|0)>(b[z+A>>0]|0))<<31>>31^l;b[r+B>>0]=C;C=A|2;B=A|3;D=((b[d+B>>0]|0)>(b[z+B>>0]|0))<<31>>31^l;b[r+C>>0]=((b[d+C>>0]|0)>(b[z+C>>0]|0))<<31>>31^l;b[r+B>>0]=D;A=A+4|0}while((A|0)<=(a|0));if(!u)break;else{r=r+h|0;q=z+o|0;p=d+m|0;u=u+-1|0}}return}while(1){u=x;p=w;q=0;do{r=q|1;A=((b[u+r>>0]|0)>(b[p+r>>0]|0))<<31>>31^l;b[v+q>>0]=((b[u+q>>0]|0)>(b[p+q>>0]|0))<<31>>31^l;b[v+r>>0]=A;A=q|2;r=q|3;c=((b[u+r>>0]|0)>(b[p+r>>0]|0))<<31>>31^l;b[v+A>>0]=((b[u+A>>0]|0)>(b[p+A>>0]|0))<<31>>31^l;b[v+r>>0]=c;q=q+4|0}while((q|0)<=(a|0));E=s;do{b[v+E>>0]=((b[u+E>>0]|0)>(b[p+E>>0]|0))<<31>>31^l;E=E+1|0}while((E|0)!=(i|0));if(!y)break;else{v=v+h|0;w=p+o|0;x=u+m|0;y=y+-1|0}}return}case 0:case 5:{y=(k|0)==0?0:255;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){F=g;G=n;H=e;I=k}else return;while(1){x=H;w=G;v=0;do{b[F+v>>0]=((b[x+v>>0]|0)==(b[w+v>>0]|0))<<31>>31^y;v=v+1|0}while((v|0)!=(i|0));if(!I)break;else{F=F+h|0;G=w+o|0;H=x+m|0;I=I+-1|0}}return}I=i&-4;if((I|0)<(i|0)){J=g;K=n;L=e;M=k}else{H=g;g=n;n=e;e=k;while(1){k=n;G=g;F=0;do{v=F|1;u=((b[k+v>>0]|0)==(b[G+v>>0]|0))<<31>>31^y;b[H+F>>0]=((b[k+F>>0]|0)==(b[G+F>>0]|0))<<31>>31^y;b[H+v>>0]=u;u=F|2;v=F|3;p=((b[k+v>>0]|0)==(b[G+v>>0]|0))<<31>>31^y;b[H+u>>0]=((b[k+u>>0]|0)==(b[G+u>>0]|0))<<31>>31^y;b[H+v>>0]=p;F=F+4|0}while((F|0)<=(j|0));if(!e)break;else{H=H+h|0;g=G+o|0;n=k+m|0;e=e+-1|0}}return}while(1){e=L;n=K;g=0;do{H=g|1;F=((b[e+H>>0]|0)==(b[n+H>>0]|0))<<31>>31^y;b[J+g>>0]=((b[e+g>>0]|0)==(b[n+g>>0]|0))<<31>>31^y;b[J+H>>0]=F;F=g|2;H=g|3;x=((b[e+H>>0]|0)==(b[n+H>>0]|0))<<31>>31^y;b[J+F>>0]=((b[e+F>>0]|0)==(b[n+F>>0]|0))<<31>>31^y;b[J+H>>0]=x;g=g+4|0}while((g|0)<=(j|0));N=I;do{b[J+N>>0]=((b[e+N>>0]|0)==(b[n+N>>0]|0))<<31>>31^y;N=N+1|0}while((N|0)!=(i|0));if(!M)break;else{J=J+h|0;K=n+o|0;L=e+m|0;M=M+-1|0}}return}default:return}}function uF(a,c,e,g,h,i,k,l,m){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;n=f[m>>2]|0;m=a;a=e;e=c>>>1;c=g>>>1;g=(n|1|0)==3;o=g?c:e;p=g?m:a;q=g?e:c;c=g?a:m;m=g?((n|0)==2?4:1):n;switch(m|0){case 1:case 4:{n=(m|0)==1?0:255;g=l+-1|0;if(!l)return;a=k+-4|0;if((k|0)<4){if((k|0)>0){r=h;s=p;t=c;u=g}else return;while(1){e=t;v=s;w=0;do{b[r+w>>0]=((j[e+(w<<1)>>1]|0)>(j[v+(w<<1)>>1]|0))<<31>>31^n;w=w+1|0}while((w|0)!=(k|0));if(!u)break;else{r=r+i|0;s=v+(q<<1)|0;t=e+(o<<1)|0;u=u+-1|0}}return}u=k&-4;if((u|0)<(k|0)){x=h;y=p;z=c;A=g}else{t=h;s=p;r=c;w=g;while(1){g=r;B=s;C=0;do{D=C|1;E=((j[g+(D<<1)>>1]|0)>(j[B+(D<<1)>>1]|0))<<31>>31^n;b[t+C>>0]=((j[g+(C<<1)>>1]|0)>(j[B+(C<<1)>>1]|0))<<31>>31^n;b[t+D>>0]=E;E=C|2;D=C|3;F=((j[g+(D<<1)>>1]|0)>(j[B+(D<<1)>>1]|0))<<31>>31^n;b[t+E>>0]=((j[g+(E<<1)>>1]|0)>(j[B+(E<<1)>>1]|0))<<31>>31^n;b[t+D>>0]=F;C=C+4|0}while((C|0)<=(a|0));if(!w)break;else{t=t+i|0;s=B+(q<<1)|0;r=g+(o<<1)|0;w=w+-1|0}}return}while(1){w=z;r=y;s=0;do{t=s|1;C=((j[w+(t<<1)>>1]|0)>(j[r+(t<<1)>>1]|0))<<31>>31^n;b[x+s>>0]=((j[w+(s<<1)>>1]|0)>(j[r+(s<<1)>>1]|0))<<31>>31^n;b[x+t>>0]=C;C=s|2;t=s|3;e=((j[w+(t<<1)>>1]|0)>(j[r+(t<<1)>>1]|0))<<31>>31^n;b[x+C>>0]=((j[w+(C<<1)>>1]|0)>(j[r+(C<<1)>>1]|0))<<31>>31^n;b[x+t>>0]=e;s=s+4|0}while((s|0)<=(a|0));G=u;do{b[x+G>>0]=((j[w+(G<<1)>>1]|0)>(j[r+(G<<1)>>1]|0))<<31>>31^n;G=G+1|0}while((G|0)!=(k|0));if(!A)break;else{x=x+i|0;y=r+(q<<1)|0;z=w+(o<<1)|0;A=A+-1|0}}return}case 0:case 5:{A=(m|0)==0?0:255;m=l+-1|0;if(!l)return;l=k+-4|0;if((k|0)<4){if((k|0)>0){H=h;I=p;J=c;K=m}else return;while(1){z=J;y=I;x=0;do{b[H+x>>0]=((d[z+(x<<1)>>1]|0)==(d[y+(x<<1)>>1]|0))<<31>>31^A;x=x+1|0}while((x|0)!=(k|0));if(!K)break;else{H=H+i|0;I=y+(q<<1)|0;J=z+(o<<1)|0;K=K+-1|0}}return}K=k&-4;J=(K|0)<(k|0);I=h;h=p;p=c;c=m;while(1){m=p;H=h;x=0;do{w=x|1;r=((d[m+(w<<1)>>1]|0)==(d[H+(w<<1)>>1]|0))<<31>>31^A;b[I+x>>0]=((d[m+(x<<1)>>1]|0)==(d[H+(x<<1)>>1]|0))<<31>>31^A;b[I+w>>0]=r;r=x|2;w=x|3;G=((d[m+(w<<1)>>1]|0)==(d[H+(w<<1)>>1]|0))<<31>>31^A;b[I+r>>0]=((d[m+(r<<1)>>1]|0)==(d[H+(r<<1)>>1]|0))<<31>>31^A;b[I+w>>0]=G;x=x+4|0}while((x|0)<=(l|0));if(J){x=K;do{b[I+x>>0]=((d[m+(x<<1)>>1]|0)==(d[H+(x<<1)>>1]|0))<<31>>31^A;x=x+1|0}while((x|0)!=(k|0))}if(!c)break;else{I=I+i|0;h=H+(q<<1)|0;p=m+(o<<1)|0;c=c+-1|0}}return}default:return}}function vF(a,c,e,g,h,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;m=a;a=e;e=f[l>>2]|0;l=c>>>1;c=g>>>1;g=(e|1|0)==3;n=g?a:m;o=g?c:l;p=g?m:a;a=g?l:c;c=g?((e|0)==2?4:1):e;switch(c|0){case 1:case 4:{e=(c|0)==1?0:255;if((k|0)!=0&(j|0)>0){q=h;r=k;s=p;t=n}else return;while(1){r=r+-1|0;g=t;l=s;m=0;do{b[q+m>>0]=((d[g+(m<<1)>>1]|0)>(d[l+(m<<1)>>1]|0))<<31>>31^e;m=m+1|0}while((m|0)!=(j|0));if(!r)break;else{q=q+i|0;s=l+(a<<1)|0;t=g+(o<<1)|0}}return}case 0:case 5:{t=(c|0)==0?0:255;if((k|0)!=0&(j|0)>0){u=h;v=k;w=p;x=n}else return;while(1){v=v+-1|0;n=x;p=w;k=0;do{b[u+k>>0]=((d[n+(k<<1)>>1]|0)==(d[p+(k<<1)>>1]|0))<<31>>31^t;k=k+1|0}while((k|0)!=(j|0));if(!v)break;else{u=u+i|0;w=p+(a<<1)|0;x=n+(o<<1)|0}}return}default:return}}function wF(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=f[k>>2]|0;k=a;a=d;d=c>>>2;c=e>>>2;e=(l|1|0)==3;m=e?c:d;n=e?k:a;o=e?d:c;c=e?a:k;k=e?((l|0)==2?4:1):l;switch(k|0){case 1:case 4:{l=(k|0)==1?0:255;e=j+-1|0;if(!j)return;a=i+-4|0;if((i|0)<4){if((i|0)>0){p=g;q=n;r=c;s=e}else return;while(1){d=r;t=q;u=0;do{b[p+u>>0]=((f[d+(u<<2)>>2]|0)>(f[t+(u<<2)>>2]|0))<<31>>31^l;u=u+1|0}while((u|0)!=(i|0));if(!s)break;else{p=p+h|0;q=t+(o<<2)|0;r=d+(m<<2)|0;s=s+-1|0}}return}s=i&-4;if((s|0)<(i|0)){v=g;w=n;x=c;y=e}else{r=g;q=n;p=c;u=e;while(1){e=p;z=q;A=0;do{B=A|1;C=((f[e+(B<<2)>>2]|0)>(f[z+(B<<2)>>2]|0))<<31>>31^l;b[r+A>>0]=((f[e+(A<<2)>>2]|0)>(f[z+(A<<2)>>2]|0))<<31>>31^l;b[r+B>>0]=C;C=A|2;B=A|3;D=((f[e+(B<<2)>>2]|0)>(f[z+(B<<2)>>2]|0))<<31>>31^l;b[r+C>>0]=((f[e+(C<<2)>>2]|0)>(f[z+(C<<2)>>2]|0))<<31>>31^l;b[r+B>>0]=D;A=A+4|0}while((A|0)<=(a|0));if(!u)break;else{r=r+h|0;q=z+(o<<2)|0;p=e+(m<<2)|0;u=u+-1|0}}return}while(1){u=x;p=w;q=0;do{r=q|1;A=((f[u+(r<<2)>>2]|0)>(f[p+(r<<2)>>2]|0))<<31>>31^l;b[v+q>>0]=((f[u+(q<<2)>>2]|0)>(f[p+(q<<2)>>2]|0))<<31>>31^l;b[v+r>>0]=A;A=q|2;r=q|3;d=((f[u+(r<<2)>>2]|0)>(f[p+(r<<2)>>2]|0))<<31>>31^l;b[v+A>>0]=((f[u+(A<<2)>>2]|0)>(f[p+(A<<2)>>2]|0))<<31>>31^l;b[v+r>>0]=d;q=q+4|0}while((q|0)<=(a|0));E=s;do{b[v+E>>0]=((f[u+(E<<2)>>2]|0)>(f[p+(E<<2)>>2]|0))<<31>>31^l;E=E+1|0}while((E|0)!=(i|0));if(!y)break;else{v=v+h|0;w=p+(o<<2)|0;x=u+(m<<2)|0;y=y+-1|0}}return}case 0:case 5:{y=(k|0)==0?0:255;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){F=g;G=n;H=c;I=k}else return;while(1){x=H;w=G;v=0;do{b[F+v>>0]=((f[x+(v<<2)>>2]|0)==(f[w+(v<<2)>>2]|0))<<31>>31^y;v=v+1|0}while((v|0)!=(i|0));if(!I)break;else{F=F+h|0;G=w+(o<<2)|0;H=x+(m<<2)|0;I=I+-1|0}}return}I=i&-4;H=(I|0)<(i|0);G=g;g=n;n=c;c=k;while(1){k=n;F=g;v=0;do{u=v|1;p=((f[k+(u<<2)>>2]|0)==(f[F+(u<<2)>>2]|0))<<31>>31^y;b[G+v>>0]=((f[k+(v<<2)>>2]|0)==(f[F+(v<<2)>>2]|0))<<31>>31^y;b[G+u>>0]=p;p=v|2;u=v|3;E=((f[k+(u<<2)>>2]|0)==(f[F+(u<<2)>>2]|0))<<31>>31^y;b[G+p>>0]=((f[k+(p<<2)>>2]|0)==(f[F+(p<<2)>>2]|0))<<31>>31^y;b[G+u>>0]=E;v=v+4|0}while((v|0)<=(j|0));if(H){v=I;do{b[G+v>>0]=((f[k+(v<<2)>>2]|0)==(f[F+(v<<2)>>2]|0))<<31>>31^y;v=v+1|0}while((v|0)!=(i|0))}if(!c)break;else{G=G+h|0;g=F+(o<<2)|0;n=k+(m<<2)|0;c=c+-1|0}}return}default:return}}function xF(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;l=f[k>>2]|0;k=a;a=d;d=c>>>2;c=e>>>2;e=(l|1|0)==3;m=e?c:d;o=e?k:a;p=e?d:c;c=e?a:k;k=e?((l|0)==2?4:1):l;switch(k|0){case 1:case 4:{l=(k|0)==1?0:255;e=j+-1|0;if(!j)return;a=i+-4|0;if((i|0)<4){if((i|0)>0){q=g;r=o;s=c;t=e}else return;while(1){d=s;u=r;v=0;do{b[q+v>>0]=(+n[d+(v<<2)>>2]>+n[u+(v<<2)>>2])<<31>>31^l;v=v+1|0}while((v|0)!=(i|0));if(!t)break;else{q=q+h|0;r=u+(p<<2)|0;s=d+(m<<2)|0;t=t+-1|0}}return}t=i&-4;if((t|0)<(i|0)){w=g;x=o;y=c;z=e}else{s=g;r=o;q=c;v=e;while(1){e=q;A=r;B=0;do{C=B|1;D=(+n[e+(C<<2)>>2]>+n[A+(C<<2)>>2])<<31>>31^l;b[s+B>>0]=(+n[e+(B<<2)>>2]>+n[A+(B<<2)>>2])<<31>>31^l;b[s+C>>0]=D;D=B|2;C=B|3;E=(+n[e+(C<<2)>>2]>+n[A+(C<<2)>>2])<<31>>31^l;b[s+D>>0]=(+n[e+(D<<2)>>2]>+n[A+(D<<2)>>2])<<31>>31^l;b[s+C>>0]=E;B=B+4|0}while((B|0)<=(a|0));if(!v)break;else{s=s+h|0;r=A+(p<<2)|0;q=e+(m<<2)|0;v=v+-1|0}}return}while(1){v=y;q=x;r=0;do{s=r|1;B=(+n[v+(s<<2)>>2]>+n[q+(s<<2)>>2])<<31>>31^l;b[w+r>>0]=(+n[v+(r<<2)>>2]>+n[q+(r<<2)>>2])<<31>>31^l;b[w+s>>0]=B;B=r|2;s=r|3;d=(+n[v+(s<<2)>>2]>+n[q+(s<<2)>>2])<<31>>31^l;b[w+B>>0]=(+n[v+(B<<2)>>2]>+n[q+(B<<2)>>2])<<31>>31^l;b[w+s>>0]=d;r=r+4|0}while((r|0)<=(a|0));F=t;do{b[w+F>>0]=(+n[v+(F<<2)>>2]>+n[q+(F<<2)>>2])<<31>>31^l;F=F+1|0}while((F|0)!=(i|0));if(!z)break;else{w=w+h|0;x=q+(p<<2)|0;y=v+(m<<2)|0;z=z+-1|0}}return}case 0:case 5:{z=(k|0)==0?0:255;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){G=g;H=o;I=c;J=k}else return;while(1){y=I;x=H;w=0;do{b[G+w>>0]=(+n[y+(w<<2)>>2]==+n[x+(w<<2)>>2])<<31>>31^z;w=w+1|0}while((w|0)!=(i|0));if(!J)break;else{G=G+h|0;H=x+(p<<2)|0;I=y+(m<<2)|0;J=J+-1|0}}return}J=i&-4;I=(J|0)<(i|0);H=g;g=o;o=c;c=k;while(1){k=o;G=g;w=0;do{v=w|1;q=(+n[k+(v<<2)>>2]==+n[G+(v<<2)>>2])<<31>>31^z;b[H+w>>0]=(+n[k+(w<<2)>>2]==+n[G+(w<<2)>>2])<<31>>31^z;b[H+v>>0]=q;q=w|2;v=w|3;F=(+n[k+(v<<2)>>2]==+n[G+(v<<2)>>2])<<31>>31^z;b[H+q>>0]=(+n[k+(q<<2)>>2]==+n[G+(q<<2)>>2])<<31>>31^z;b[H+v>>0]=F;w=w+4|0}while((w|0)<=(j|0));if(I){w=J;do{b[H+w>>0]=(+n[k+(w<<2)>>2]==+n[G+(w<<2)>>2])<<31>>31^z;w=w+1|0}while((w|0)!=(i|0))}if(!c)break;else{H=H+h|0;g=G+(p<<2)|0;o=k+(m<<2)|0;c=c+-1|0}}return}default:return}}function yF(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;l=f[k>>2]|0;k=a;a=d;d=c>>>3;c=e>>>3;e=(l|1|0)==3;m=e?c:d;n=e?k:a;o=e?d:c;c=e?a:k;k=e?((l|0)==2?4:1):l;switch(k|0){case 1:case 4:{l=(k|0)==1?0:255;e=j+-1|0;if(!j)return;a=i+-4|0;if((i|0)<4){if((i|0)>0){q=g;r=n;s=c;t=e}else return;while(1){d=s;u=r;v=0;do{b[q+v>>0]=(+p[d+(v<<3)>>3]>+p[u+(v<<3)>>3])<<31>>31^l;v=v+1|0}while((v|0)!=(i|0));if(!t)break;else{q=q+h|0;r=u+(o<<3)|0;s=d+(m<<3)|0;t=t+-1|0}}return}t=i&-4;if((t|0)<(i|0)){w=g;x=n;y=c;z=e}else{s=g;r=n;q=c;v=e;while(1){e=q;A=r;B=0;do{C=B|1;D=(+p[e+(C<<3)>>3]>+p[A+(C<<3)>>3])<<31>>31^l;b[s+B>>0]=(+p[e+(B<<3)>>3]>+p[A+(B<<3)>>3])<<31>>31^l;b[s+C>>0]=D;D=B|2;C=B|3;E=(+p[e+(C<<3)>>3]>+p[A+(C<<3)>>3])<<31>>31^l;b[s+D>>0]=(+p[e+(D<<3)>>3]>+p[A+(D<<3)>>3])<<31>>31^l;b[s+C>>0]=E;B=B+4|0}while((B|0)<=(a|0));if(!v)break;else{s=s+h|0;r=A+(o<<3)|0;q=e+(m<<3)|0;v=v+-1|0}}return}while(1){v=y;q=x;r=0;do{s=r|1;B=(+p[v+(s<<3)>>3]>+p[q+(s<<3)>>3])<<31>>31^l;b[w+r>>0]=(+p[v+(r<<3)>>3]>+p[q+(r<<3)>>3])<<31>>31^l;b[w+s>>0]=B;B=r|2;s=r|3;d=(+p[v+(s<<3)>>3]>+p[q+(s<<3)>>3])<<31>>31^l;b[w+B>>0]=(+p[v+(B<<3)>>3]>+p[q+(B<<3)>>3])<<31>>31^l;b[w+s>>0]=d;r=r+4|0}while((r|0)<=(a|0));F=t;do{b[w+F>>0]=(+p[v+(F<<3)>>3]>+p[q+(F<<3)>>3])<<31>>31^l;F=F+1|0}while((F|0)!=(i|0));if(!z)break;else{w=w+h|0;x=q+(o<<3)|0;y=v+(m<<3)|0;z=z+-1|0}}return}case 0:case 5:{z=(k|0)==0?0:255;k=j+-1|0;if(!j)return;j=i+-4|0;if((i|0)<4){if((i|0)>0){G=g;H=n;I=c;J=k}else return;while(1){y=I;x=H;w=0;do{b[G+w>>0]=(+p[y+(w<<3)>>3]==+p[x+(w<<3)>>3])<<31>>31^z;w=w+1|0}while((w|0)!=(i|0));if(!J)break;else{G=G+h|0;H=x+(o<<3)|0;I=y+(m<<3)|0;J=J+-1|0}}return}J=i&-4;I=(J|0)<(i|0);H=g;g=n;n=c;c=k;while(1){k=n;G=g;w=0;do{v=w|1;q=(+p[k+(v<<3)>>3]==+p[G+(v<<3)>>3])<<31>>31^z;b[H+w>>0]=(+p[k+(w<<3)>>3]==+p[G+(w<<3)>>3])<<31>>31^z;b[H+v>>0]=q;q=w|2;v=w|3;F=(+p[k+(v<<3)>>3]==+p[G+(v<<3)>>3])<<31>>31^z;b[H+q>>0]=(+p[k+(q<<3)>>3]==+p[G+(q<<3)>>3])<<31>>31^z;b[H+v>>0]=F;w=w+4|0}while((w|0)<=(j|0));if(I){w=J;do{b[H+w>>0]=(+p[k+(w<<3)>>3]==+p[G+(w<<3)>>3])<<31>>31^z;w=w+1|0}while((w|0)!=(i|0))}if(!c)break;else{H=H+h|0;g=G+(o<<3)|0;n=k+(m<<3)|0;c=c+-1|0}}return}default:return}}function zF(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0;g=u;u=u+1488|0;h=g+1432|0;i=g+1424|0;j=g+1368|0;k=g+1312|0;l=g+1256|0;m=g+1200|0;n=g+1188|0;o=g+1168|0;q=g+1144|0;r=g+1104|0;s=g+64|0;t=g+1160|0;v=g+1136|0;w=g;x=g+56|0;dQ(i,40648);y=yM(a)|0;z=yM(c)|0;A=yM(d)|0;do if((yM(a)|0)==65536){B=f[a+4>>2]|0;f[j>>2]=f[B>>2];C=j+4|0;D=B+4|0;f[C>>2]=f[D>>2];E=j+8|0;f[E>>2]=f[B+8>>2];f[j+12>>2]=f[B+12>>2];f[j+16>>2]=f[B+16>>2];f[j+20>>2]=f[B+20>>2];f[j+24>>2]=f[B+24>>2];f[j+28>>2]=f[B+28>>2];f[j+32>>2]=f[B+32>>2];F=f[B+36>>2]|0;f[j+36>>2]=F;f[j+40>>2]=E;E=j+48|0;G=j+44|0;f[G>>2]=E;f[E>>2]=0;f[j+52>>2]=0;if(F|0){E=F+12|0;f[E>>2]=(f[E>>2]|0)+1}if((f[D>>2]|0)<3){D=f[B+44>>2]|0;E=f[G>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2];break}else{f[C>>2]=0;jL(j,B);break}}else yL(j,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];B=k+4|0;C=a+4|0;f[B>>2]=f[C>>2];D=k+8|0;f[D>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];E=f[a+36>>2]|0;f[k+36>>2]=E;f[k+40>>2]=D;D=k+48|0;G=k+44|0;f[G>>2]=D;f[D>>2]=0;f[k+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[C>>2]|0)<3){C=f[a+44>>2]|0;D=f[G>>2]|0;f[D>>2]=f[C>>2];f[D+4>>2]=f[C+4>>2];break}else{f[B>>2]=0;jL(k,a);break}}else yL(k,c,-1);while(0);do if((yM(d)|0)==65536){c=f[d+4>>2]|0;f[l>>2]=f[c>>2];a=l+4|0;B=c+4|0;f[a>>2]=f[B>>2];C=l+8|0;f[C>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];f[l+16>>2]=f[c+16>>2];f[l+20>>2]=f[c+20>>2];f[l+24>>2]=f[c+24>>2];f[l+28>>2]=f[c+28>>2];f[l+32>>2]=f[c+32>>2];D=f[c+36>>2]|0;f[l+36>>2]=D;f[l+40>>2]=C;C=l+48|0;G=l+44|0;f[G>>2]=C;f[C>>2]=0;f[l+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[c+44>>2]|0;C=f[G>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];break}else{f[a>>2]=0;jL(l,c);break}}else yL(l,d,-1);while(0);d=(y|0)!=131072;a:do if(!(d&(z|0)==131072)?(c=f[j+40>>2]|0,a=f[c+-4>>2]|0,B=f[k+40>>2]|0,(a|0)==(f[B+-4>>2]|0)):0){if((a|0)==2){if((f[c>>2]|0)!=(f[B>>2]|0)){H=31;break}if((f[c+4>>2]|0)!=(f[B+4>>2]|0)){H=31;break}}else if((a|0)>0){C=0;do{if((f[c+(C<<2)>>2]|0)!=(f[B+(C<<2)>>2]|0)){H=31;break a}C=C+1|0}while((C|0)<(a|0))}if(!((f[k>>2]^f[j>>2])&4095))I=0;else H=31}else H=31;while(0);do if((H|0)==31){a=f[j>>2]|0;if((((f[k+4>>2]|0)<=2?(C=f[k>>2]|0,C&16384|0):0)?(B=f[k+40>>2]|0,c=f[B+4>>2]|0,G=f[B>>2]|0,B=(c|0)==1,D=(G|0)==1,B|D):0)?(E=(a>>>3&511)+1|0,!((y|0)==131072&(z|0)!=131072)):0){if((c|0)==(E|0)&D|B&(D|(G|0)==(E|0))){I=1;break}if(!(E>>>0>4|(C&4095|0)!=6|B&(G|0)==4^1)){I=1;break}}f[h>>2]=0;f[h+4>>2]=0;J=aD(h,90)|0;K=174167;L=J+90|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-209,h,174258,172127,1769);bD(h);I=1}while(0);b:do if(!(d&(A|0)==131072)?(z=f[j+40>>2]|0,G=f[z+-4>>2]|0,B=f[l+40>>2]|0,(G|0)==(f[B+-4>>2]|0)):0){if((G|0)==2){if((f[z>>2]|0)!=(f[B>>2]|0)){H=47;break}if((f[z+4>>2]|0)!=(f[B+4>>2]|0)){H=47;break}}else if((G|0)>0){C=0;do{if((f[z+(C<<2)>>2]|0)!=(f[B+(C<<2)>>2]|0)){H=47;break b}C=C+1|0}while((C|0)<(G|0))}if(!((f[l>>2]^f[j>>2])&4095)){G=I&1;if(I){M=0;N=0;O=G;H=56}else{P=0;Q=j;R=0;S=G}}else H=47}else H=47;while(0);if((H|0)==47){d=f[j>>2]|0;if((((f[l+4>>2]|0)<=2?(G=f[l>>2]|0,(G&16384|0)!=0):0)?(C=f[l+40>>2]|0,B=f[C+4>>2]|0,z=f[C>>2]|0,C=(B|0)==1,E=(z|0)==1,C|E):0)?(D=(d>>>3&511)+1|0,!((y|0)==131072&(A|0)!=131072)):0){if(!((B|0)==(D|0)&E|C&(E|(z|0)==(D|0)))?D>>>0>4|(G&4095|0)!=6|C&(z|0)==4^1:0)H=53}else H=53;if((H|0)==53){f[h>>2]=0;f[h+4>>2]=0;J=aD(h,90)|0;K=174266;L=J+90|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-209,h,174258,172127,1778);bD(h)}z=I&1;if(I){P=1;Q=j;R=1;S=z}else{M=1;N=1;O=z;H=56}}if((H|0)==56){f[h>>2]=0;f[h+4>>2]=0;J=aD(h,20)|0;K=174357;L=J+20|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-215,h,174258,172127,1782);bD(h);P=M;Q=j;R=N;S=O}O=f[Q>>2]|0;N=O>>>3;M=N&511;z=M+1|0;C=O&7;O=j+4|0;G=f[O>>2]|0;if((G|0)>0)T=f[(f[j+44>>2]|0)+(G+-1<<2)>>2]|0;else T=0;D=((T+1023|0)>>>0)/(T>>>0)|0;E=j+40|0;wL(e,G,f[E>>2]|0,0,-1,0,0);do if((yM(e)|0)==65536){G=f[e+4>>2]|0;f[m>>2]=f[G>>2];B=m+4|0;A=G+4|0;f[B>>2]=f[A>>2];y=m+8|0;f[y>>2]=f[G+8>>2];f[m+12>>2]=f[G+12>>2];f[m+16>>2]=f[G+16>>2];f[m+20>>2]=f[G+20>>2];f[m+24>>2]=f[G+24>>2];f[m+28>>2]=f[G+28>>2];f[m+32>>2]=f[G+32>>2];d=f[G+36>>2]|0;f[m+36>>2]=d;f[m+40>>2]=y;y=m+48|0;c=m+44|0;f[c>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(d|0){y=d+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[A>>2]|0)<3){A=f[G+44>>2]|0;y=f[c>>2]|0;f[y>>2]=f[A>>2];f[y+4>>2]=f[A+4>>2];break}else{f[B>>2]=0;jL(m,G);break}}else yL(m,e,-1);while(0);e=f[40668+(C<<2)>>2]|0;f[n>>2]=j;f[n+4>>2]=m;f[n+8>>2]=0;f[o>>2]=j;f[o+4>>2]=m;f[o+8>>2]=k;f[o+12>>2]=l;f[o+16>>2]=0;G=I&P;RN(r,G?n:o,q,-1);o=f[r+20>>2]|0;n=D>>>0<o>>>0?D:o;D=(z<<3)+128+(Y(n,(Y(T,S+R|0)|0)+z|0)|0)|0;R=s+8|0;f[s>>2]=R;S=s+4|0;f[S>>2]=D;if(D>>>0>1032){B=N5b(D)|0;f[s>>2]=B;U=B}else U=R;B=U+(Y(n,z)|0)+15&-16;if(G){G=Y(n,T)|0;D=B+G+15&-16;A=f[k>>2]|0;if(!((f[l>>2]^A)&4095))V=A;else{f[h>>2]=0;f[h+4>>2]=0;J=aD(h,22)|0;K=174378;L=J+22|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-215,h,174258,172127,1809);bD(h);V=f[k>>2]|0}A=V&7;if(C>>>0<4&(A|0)!=(C|0)){V=D+G+15&-16;G=V;y=V;c=y+(z<<2)|0;d=KI(A,4)|0;A=k+16|0;a=f[A>>2]|0;F=k+44|0;f[t>>2]=z;f[t+4>>2]=1;Hh[d&255](a,1,0,1,G,1,t,0);t=l+16|0;a=f[t>>2]|0;W=l+44|0;f[v>>2]=z;f[v+4>>2]=1;Hh[d&255](a,1,0,1,c,1,v,0);v=MVb(+p[9992+(C<<3)>>3])|0;a=MVb(+p[10056+(C<<3)>>3])|0;C=v+1|0;d=0;do{X=y+(d<<2)|0;Z=f[X>>2]|0;_=c+(d<<2)|0;$=f[_>>2]|0;if(($|0)<(v|0)|((Z|0)>(a|0)|(Z|0)>($|0))){f[X>>2]=C;f[_>>2]=v}d=d+1|0}while((d|0)!=(z|0));f[w>>2]=1124007940;d=w+4|0;f[d>>2]=2;v=w+8|0;f[v>>2]=z;C=w+12|0;f[C>>2]=1;a=w+16|0;f[a>>2]=G;y=w+20|0;f[y>>2]=G;_=w+24|0;X=w+28|0;$=w+40|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;f[$>>2]=v;Z=w+48|0;aa=w+44|0;f[aa>>2]=Z;f[w+52>>2]=0;f[Z>>2]=0;if(!V){f[h>>2]=0;f[h+4>>2]=0;J=aD(h,26)|0;K=426262;L=J+26|0;do{b[J>>0]=b[K>>0]|0;J=J+1|0;K=K+1|0}while((J|0)<(L|0));bO(-215,h,426289,431198,500);bD(h);K=w+36|0;ba=K;ca=f[C>>2]|0;da=f[w>>2]|0;ea=f[aa>>2]|0;fa=f[y>>2]|0;ga=f[K>>2]|0}else{ba=w+36|0;ca=1;da=1124007940;ea=Z;fa=G;ga=0}G=ca<<2;f[w>>2]=da|16384;f[ea>>2]=G;f[ea+4>>2]=4;ea=fa+(Y(f[v>>2]|0,G)|0)|0;f[X>>2]=ea;f[_>>2]=ea+(0-G)+G;if(ga|0){G=ga+12|0;f[G>>2]=(f[G>>2]|0)+1}G=k+36|0;ga=f[G>>2]|0;if(ga|0?(ea=ga+12|0,ga=f[ea>>2]|0,f[ea>>2]=ga+-1,(ga|0)==1):0)kL(k);f[G>>2]=0;ga=k+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[ga>>2]|0)>0){ea=f[k+40>>2]|0;fa=0;do{f[ea+(fa<<2)>>2]=0;fa=fa+1|0;ha=f[ga>>2]|0}while((fa|0)<(ha|0));f[k>>2]=f[w>>2];if((ha|0)<3)H=89;else H=91}else{f[k>>2]=f[w>>2];H=89}if((H|0)==89){ha=f[d>>2]|0;if((ha|0)<3){f[ga>>2]=ha;f[k+8>>2]=f[v>>2];f[k+12>>2]=f[C>>2];C=f[aa>>2]|0;v=f[F>>2]|0;f[v>>2]=f[C>>2];f[v+4>>2]=f[C+4>>2]}else H=91}if((H|0)==91)jL(k,w);f[A>>2]=f[a>>2];f[k+20>>2]=f[y>>2];f[k+24>>2]=f[_>>2];f[k+28>>2]=f[X>>2];f[k+32>>2]=f[w+32>>2];X=f[ba>>2]|0;f[G>>2]=X;if(X|0?(G=X+12|0,X=f[G>>2]|0,f[G>>2]=X+-1,(X|0)==1):0)kL(w);f[ba>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[d>>2]|0)>0){a=f[$>>2]|0;$=0;do{f[a+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[d>>2]|0))}d=f[aa>>2]|0;if((d|0)!=(Z|0))UC(d);d=h+4|0;f[d>>2]=2;Z=h+8|0;f[Z>>2]=z;aa=h+12|0;f[aa>>2]=1;$=h+16|0;f[$>>2]=c;a=h+20|0;f[a>>2]=c;ba=h+24|0;w=h+28|0;X=h+40|0;G=ba+8|0;f[G>>2]=0;f[G+4>>2]=0;f[X>>2]=Z;G=h+48|0;_=h+44|0;f[_>>2]=G;f[h>>2]=1124024324;f[G>>2]=4;f[h+52>>2]=4;y=c+(z<<2)|0;f[w>>2]=y;f[ba>>2]=y+-4+4;y=h+36|0;c=l+36|0;A=f[c>>2]|0;do if(A|0){C=A+12|0;v=f[C>>2]|0;f[C>>2]=v+-1;if((v|0)!=1)break;kL(l)}while(0);f[c>>2]=0;A=l+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[A>>2]|0)>0){v=f[l+40>>2]|0;C=0;do{f[v+(C<<2)>>2]=0;C=C+1|0;ia=f[A>>2]|0}while((C|0)<(ia|0));f[l>>2]=f[h>>2];if((ia|0)<3)H=108;else H=110}else{f[l>>2]=f[h>>2];H=108}do if((H|0)==108){ia=f[d>>2]|0;if((ia|0)>=3){H=110;break}f[A>>2]=ia;f[l+8>>2]=f[Z>>2];f[l+12>>2]=f[aa>>2];ia=f[_>>2]|0;C=f[W>>2]|0;f[C>>2]=f[ia>>2];f[C+4>>2]=f[ia+4>>2]}while(0);if((H|0)==110)jL(l,h);f[t>>2]=f[$>>2];f[l+20>>2]=f[a>>2];f[l+24>>2]=f[ba>>2];f[l+28>>2]=f[w>>2];f[l+32>>2]=f[h+32>>2];w=f[y>>2]|0;f[c>>2]=w;do if(w|0){c=w+12|0;ba=f[c>>2]|0;f[c>>2]=ba+-1;if((ba|0)!=1)break;kL(h)}while(0);f[y>>2]=0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[d>>2]|0)>0){$=f[X>>2]|0;X=0;do{f[$+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[d>>2]|0))}d=f[_>>2]|0;if((d|0)!=(G|0))UC(d)}cD(k,f[Q>>2]&4095,B,n);cD(l,f[Q>>2]&4095,D,n);ja=B;ka=D}else{ja=0;ka=0}D=r+16|0;B=(o|0)==0;Q=q+((I?2:3)<<2)|0;d=(M|0)==0;G=q+4|0;_=x+4|0;X=N+1&3;N=(X|0)==0?4:X;X=N&255;$=N>>>0>=z>>>0;y=q+8|0;h=0;while(1){if(h>>>0>=(f[D>>2]|0)>>>0)break;if(!B){w=0;do{ba=o-w|0;c=ba>>>0>n>>>0?n:ba;ba=Y(c,T)|0;if(I)la=ja;else{a=f[y>>2]|0;f[y>>2]=a+ba;la=a}if(P)ma=ka;else{a=f[Q>>2]|0;f[Q>>2]=a+ba;ma=a}a=f[q>>2]|0;t=d?f[G>>2]|0:U;H=Y(c,z)|0;f[x>>2]=H;f[_>>2]=1;Th[e&127](a,0,la,0,ma,0,t,0,x);c:do if(!d){t=f[G>>2]|0;switch(X&7){case 1:{if(!c)break c;else{na=0;oa=0}while(1){b[t+na>>0]=b[U+oa>>0]|0;na=na+1|0;if((na|0)==(c|0))break;else oa=oa+z|0}break}case 2:{if(!c)break c;else{pa=0;qa=0}while(1){b[t+qa>>0]=b[U+(pa+1)>>0]&b[U+pa>>0];qa=qa+1|0;if((qa|0)==(c|0))break;else pa=pa+z|0}break}case 3:{if(!c)break c;else{ra=0;sa=0}while(1){b[t+sa>>0]=b[U+(ra+1)>>0]&b[U+ra>>0]&b[U+(ra+2)>>0];sa=sa+1|0;if((sa|0)==(c|0))break;else ra=ra+z|0}break}default:{if(!c)break c;else{ta=0;ua=0}while(1){b[t+ta>>0]=b[U+(ua+1)>>0]&b[U+ua>>0]&b[U+(ua+2)>>0]&b[U+(ua+3)>>0];ta=ta+1|0;if((ta|0)==(c|0))break;else ua=ua+z|0}}}if(!($|(c|0)==0)){a=N;do{H=0;W=a;while(1){aa=t+H|0;b[aa>>0]=b[U+(W+1)>>0]&b[U+W>>0]&b[U+(W+2)>>0]&b[U+(W+3)>>0]&b[aa>>0];H=H+1|0;if((H|0)==(c|0))break;else W=W+z|0}a=a+4|0}while((a|0)<=(M|0))}}while(0);f[q>>2]=(f[q>>2]|0)+ba;f[G>>2]=(f[G>>2]|0)+c;w=w+n|0}while(o>>>0>w>>>0)}aL(r)|0;h=h+1|0}h=f[s>>2]|0;if((h|0)!=(R|0)){if(h|0)P5b(h);f[s>>2]=R;f[S>>2]=1032}S=m+36|0;R=f[S>>2]|0;if(R|0?(s=R+12|0,R=f[s>>2]|0,f[s>>2]=R+-1,(R|0)==1):0)kL(m);f[S>>2]=0;S=m+16|0;R=m+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[R>>2]|0)>0){S=f[m+40>>2]|0;s=0;do{f[S+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[R>>2]|0))}R=f[m+44>>2]|0;if((R|0)!=(m+48|0))UC(R);R=l+36|0;m=f[R>>2]|0;if(m|0?(s=m+12|0,m=f[s>>2]|0,f[s>>2]=m+-1,(m|0)==1):0)kL(l);f[R>>2]=0;R=l+16|0;m=l+4|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[m>>2]|0)>0){R=f[l+40>>2]|0;s=0;do{f[R+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[m>>2]|0))}m=f[l+44>>2]|0;if((m|0)!=(l+48|0))UC(m);m=k+36|0;l=f[m>>2]|0;if(l|0?(s=l+12|0,l=f[s>>2]|0,f[s>>2]=l+-1,(l|0)==1):0)kL(k);f[m>>2]=0;m=k+16|0;l=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[l>>2]|0)>0){m=f[k+40>>2]|0;s=0;do{f[m+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))UC(l);l=j+36|0;k=f[l>>2]|0;do if(k|0){s=k+12|0;m=f[s>>2]|0;f[s>>2]=m+-1;if((m|0)!=1)break;kL(j)}while(0);f[l>>2]=0;l=j+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[O>>2]|0)>0){l=f[E>>2]|0;E=0;do{f[l+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[O>>2]|0))}O=f[j+44>>2]|0;if((O|0)!=(j+48|0))UC(O);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function AF(a,c,d,e,g,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;m=f[l>>2]|0;n=f[l+4>>2]|0;if(!n)return;l=m+-4|0;if((m|0)<4){o=(m|0)>0;p=a;q=j;r=g;s=d;t=n;while(1){t=t+-1|0;if(o){u=0;do{v=b[p+u>>0]|0;if((h[s+u>>0]|0)>(v&255))w=0;else w=(v&255)<=(h[r+u>>0]|0);b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(m|0))}if(!t)break;else{p=p+c|0;q=q+k|0;r=r+i|0;s=s+e|0}}return}s=m&-4;r=(s|0)<(m|0);q=a;a=j;j=g;g=d;d=n;while(1){n=0;do{p=b[q+n>>0]|0;if((h[g+n>>0]|0)>(p&255))x=0;else x=(p&255)<=(h[j+n>>0]|0);p=n|1;t=b[q+p>>0]|0;if((h[g+p>>0]|0)>(t&255))y=0;else y=(t&255)<=(h[j+p>>0]|0);b[a+n>>0]=x<<31>>31;b[a+p>>0]=y<<31>>31;p=n|2;t=b[q+p>>0]|0;if((h[g+p>>0]|0)>(t&255))z=0;else z=(t&255)<=(h[j+p>>0]|0);t=n|3;w=b[q+t>>0]|0;if((h[g+t>>0]|0)>(w&255))A=0;else A=(w&255)<=(h[j+t>>0]|0);b[a+p>>0]=z<<31>>31;b[a+t>>0]=A<<31>>31;n=n+4|0}while((n|0)<=(l|0));d=d+-1|0;if(r){n=s;do{t=b[q+n>>0]|0;if((h[g+n>>0]|0)>(t&255))B=0;else B=(t&255)<=(h[j+n>>0]|0);b[a+n>>0]=B<<31>>31;n=n+1|0}while((n|0)!=(m|0))}if(!d)break;else{q=q+c|0;a=a+k|0;j=j+i|0;g=g+e|0}}return}function BF(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=f[k>>2]|0;m=f[k+4>>2]|0;if(!m)return;k=l+-4|0;if((l|0)<4){n=(l|0)>0;o=a;p=i;q=g;r=d;s=m;while(1){s=s+-1|0;if(n){t=0;do{u=b[o+t>>0]|0;if((b[r+t>>0]|0)>u<<24>>24)v=0;else v=u<<24>>24<=(b[q+t>>0]|0);b[p+t>>0]=v<<31>>31;t=t+1|0}while((t|0)!=(l|0))}if(!s)break;else{o=o+c|0;p=p+j|0;q=q+h|0;r=r+e|0}}return}r=l&-4;q=(r|0)<(l|0);p=a;a=i;i=g;g=d;d=m;while(1){m=0;do{o=b[p+m>>0]|0;if((b[g+m>>0]|0)>o<<24>>24)w=0;else w=o<<24>>24<=(b[i+m>>0]|0);o=m|1;s=b[p+o>>0]|0;if((b[g+o>>0]|0)>s<<24>>24)x=0;else x=s<<24>>24<=(b[i+o>>0]|0);b[a+m>>0]=w<<31>>31;b[a+o>>0]=x<<31>>31;o=m|2;s=b[p+o>>0]|0;if((b[g+o>>0]|0)>s<<24>>24)y=0;else y=s<<24>>24<=(b[i+o>>0]|0);s=m|3;v=b[p+s>>0]|0;if((b[g+s>>0]|0)>v<<24>>24)z=0;else z=v<<24>>24<=(b[i+s>>0]|0);b[a+o>>0]=y<<31>>31;b[a+s>>0]=z<<31>>31;m=m+4|0}while((m|0)<=(k|0));d=d+-1|0;if(q){m=r;do{s=b[p+m>>0]|0;if((b[g+m>>0]|0)>s<<24>>24)A=0;else A=s<<24>>24<=(b[i+m>>0]|0);b[a+m>>0]=A<<31>>31;m=m+1|0}while((m|0)!=(l|0))}if(!d)break;else{p=p+c|0;a=a+j|0;i=i+h|0;g=g+e|0}}return}function CF(a,c,e,g,h,i,k,l,m){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;n=f[m>>2]|0;o=f[m+4>>2]|0;m=c>>>1;c=g>>>1;g=i>>>1;if(!o)return;i=n+-4|0;if((n|0)<4){p=(n|0)>0;q=a;r=k;s=h;t=e;u=o;while(1){u=u+-1|0;if(p){v=0;do{w=d[q+(v<<1)>>1]|0;if((j[t+(v<<1)>>1]|0)>(w&65535))x=0;else x=(w&65535)<=(j[s+(v<<1)>>1]|0);b[r+v>>0]=x<<31>>31;v=v+1|0}while((v|0)!=(n|0))}if(!u)break;else{q=q+(m<<1)|0;r=r+l|0;s=s+(g<<1)|0;t=t+(c<<1)|0}}return}t=n&-4;s=(t|0)<(n|0);r=a;a=k;k=h;h=e;e=o;while(1){o=0;do{q=d[r+(o<<1)>>1]|0;if((j[h+(o<<1)>>1]|0)>(q&65535))y=0;else y=(q&65535)<=(j[k+(o<<1)>>1]|0);q=o|1;u=d[r+(q<<1)>>1]|0;if((j[h+(q<<1)>>1]|0)>(u&65535))z=0;else z=(u&65535)<=(j[k+(q<<1)>>1]|0);b[a+o>>0]=y<<31>>31;b[a+q>>0]=z<<31>>31;q=o|2;u=d[r+(q<<1)>>1]|0;if((j[h+(q<<1)>>1]|0)>(u&65535))A=0;else A=(u&65535)<=(j[k+(q<<1)>>1]|0);u=o|3;x=d[r+(u<<1)>>1]|0;if((j[h+(u<<1)>>1]|0)>(x&65535))B=0;else B=(x&65535)<=(j[k+(u<<1)>>1]|0);b[a+q>>0]=A<<31>>31;b[a+u>>0]=B<<31>>31;o=o+4|0}while((o|0)<=(i|0));e=e+-1|0;if(s){o=t;do{u=d[r+(o<<1)>>1]|0;if((j[h+(o<<1)>>1]|0)>(u&65535))C=0;else C=(u&65535)<=(j[k+(o<<1)>>1]|0);b[a+o>>0]=C<<31>>31;o=o+1|0}while((o|0)!=(n|0))}if(!e)break;else{r=r+(m<<1)|0;a=a+l|0;k=k+(g<<1)|0;h=h+(c<<1)|0}}return}function DF(a,c,e,g,h,i,j,k,l){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;m=f[l>>2]|0;n=f[l+4>>2]|0;l=c>>>1;c=g>>>1;g=i>>>1;if(!n)return;i=m+-4|0;if((m|0)<4){o=(m|0)>0;p=a;q=j;r=h;s=e;t=n;while(1){t=t+-1|0;if(o){u=0;do{v=d[p+(u<<1)>>1]|0;if((d[s+(u<<1)>>1]|0)>v<<16>>16)w=0;else w=v<<16>>16<=(d[r+(u<<1)>>1]|0);b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(m|0))}if(!t)break;else{p=p+(l<<1)|0;q=q+k|0;r=r+(g<<1)|0;s=s+(c<<1)|0}}return}s=m&-4;r=(s|0)<(m|0);q=a;a=j;j=h;h=e;e=n;while(1){n=0;do{p=d[q+(n<<1)>>1]|0;if((d[h+(n<<1)>>1]|0)>p<<16>>16)x=0;else x=p<<16>>16<=(d[j+(n<<1)>>1]|0);p=n|1;t=d[q+(p<<1)>>1]|0;if((d[h+(p<<1)>>1]|0)>t<<16>>16)y=0;else y=t<<16>>16<=(d[j+(p<<1)>>1]|0);b[a+n>>0]=x<<31>>31;b[a+p>>0]=y<<31>>31;p=n|2;t=d[q+(p<<1)>>1]|0;if((d[h+(p<<1)>>1]|0)>t<<16>>16)z=0;else z=t<<16>>16<=(d[j+(p<<1)>>1]|0);t=n|3;w=d[q+(t<<1)>>1]|0;if((d[h+(t<<1)>>1]|0)>w<<16>>16)A=0;else A=w<<16>>16<=(d[j+(t<<1)>>1]|0);b[a+p>>0]=z<<31>>31;b[a+t>>0]=A<<31>>31;n=n+4|0}while((n|0)<=(i|0));e=e+-1|0;if(r){n=s;do{t=d[q+(n<<1)>>1]|0;if((d[h+(n<<1)>>1]|0)>t<<16>>16)B=0;else B=t<<16>>16<=(d[j+(n<<1)>>1]|0);b[a+n>>0]=B<<31>>31;n=n+1|0}while((n|0)!=(m|0))}if(!e)break;else{q=q+(l<<1)|0;a=a+k|0;j=j+(g<<1)|0;h=h+(c<<1)|0}}return}function EF(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c>>>2;c=e>>>2;e=h>>>2;if(!m)return;h=l+-4|0;if((l|0)<4){n=(l|0)>0;o=a;p=i;q=g;r=d;s=m;while(1){s=s+-1|0;if(n){t=0;do{u=f[o+(t<<2)>>2]|0;if((f[r+(t<<2)>>2]|0)>(u|0))v=0;else v=(u|0)<=(f[q+(t<<2)>>2]|0);b[p+t>>0]=v<<31>>31;t=t+1|0}while((t|0)!=(l|0))}if(!s)break;else{o=o+(k<<2)|0;p=p+j|0;q=q+(e<<2)|0;r=r+(c<<2)|0}}return}r=l&-4;q=(r|0)<(l|0);p=a;a=i;i=g;g=d;d=m;while(1){m=0;do{o=f[p+(m<<2)>>2]|0;if((f[g+(m<<2)>>2]|0)>(o|0))w=0;else w=(o|0)<=(f[i+(m<<2)>>2]|0);o=m|1;s=f[p+(o<<2)>>2]|0;if((f[g+(o<<2)>>2]|0)>(s|0))x=0;else x=(s|0)<=(f[i+(o<<2)>>2]|0);b[a+m>>0]=w<<31>>31;b[a+o>>0]=x<<31>>31;o=m|2;s=f[p+(o<<2)>>2]|0;if((f[g+(o<<2)>>2]|0)>(s|0))y=0;else y=(s|0)<=(f[i+(o<<2)>>2]|0);s=m|3;v=f[p+(s<<2)>>2]|0;if((f[g+(s<<2)>>2]|0)>(v|0))z=0;else z=(v|0)<=(f[i+(s<<2)>>2]|0);b[a+o>>0]=y<<31>>31;b[a+s>>0]=z<<31>>31;m=m+4|0}while((m|0)<=(h|0));d=d+-1|0;if(q){m=r;do{s=f[p+(m<<2)>>2]|0;if((f[g+(m<<2)>>2]|0)>(s|0))A=0;else A=(s|0)<=(f[i+(m<<2)>>2]|0);b[a+m>>0]=A<<31>>31;m=m+1|0}while((m|0)!=(l|0))}if(!d)break;else{p=p+(k<<2)|0;a=a+j|0;i=i+(e<<2)|0;g=g+(c<<2)|0}}return}function FF(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c>>>2;c=e>>>2;e=h>>>2;if(!m)return;h=l+-4|0;if((l|0)<4){o=(l|0)>0;p=a;q=i;r=g;s=d;t=m;while(1){t=t+-1|0;if(o){u=0;do{v=+n[p+(u<<2)>>2];if(!(+n[s+(u<<2)>>2]<=v))w=0;else w=v<=+n[r+(u<<2)>>2];b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(l|0))}if(!t)break;else{p=p+(k<<2)|0;q=q+j|0;r=r+(e<<2)|0;s=s+(c<<2)|0}}return}s=l&-4;r=(s|0)<(l|0);q=a;a=i;i=g;g=d;d=m;while(1){m=0;do{v=+n[q+(m<<2)>>2];if(!(+n[g+(m<<2)>>2]<=v))x=0;else x=v<=+n[i+(m<<2)>>2];p=m|1;v=+n[q+(p<<2)>>2];if(!(+n[g+(p<<2)>>2]<=v))y=0;else y=v<=+n[i+(p<<2)>>2];b[a+m>>0]=x<<31>>31;b[a+p>>0]=y<<31>>31;p=m|2;v=+n[q+(p<<2)>>2];if(!(+n[g+(p<<2)>>2]<=v))z=0;else z=v<=+n[i+(p<<2)>>2];t=m|3;v=+n[q+(t<<2)>>2];if(!(+n[g+(t<<2)>>2]<=v))A=0;else A=v<=+n[i+(t<<2)>>2];b[a+p>>0]=z<<31>>31;b[a+t>>0]=A<<31>>31;m=m+4|0}while((m|0)<=(h|0));d=d+-1|0;if(r){m=s;do{v=+n[q+(m<<2)>>2];if(!(+n[g+(m<<2)>>2]<=v))B=0;else B=v<=+n[i+(m<<2)>>2];b[a+m>>0]=B<<31>>31;m=m+1|0}while((m|0)!=(l|0))}if(!d)break;else{q=q+(k<<2)|0;a=a+j|0;i=i+(e<<2)|0;g=g+(c<<2)|0}}return}function GF(a,c,d,e,g,h,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c>>>3;c=e>>>3;e=h>>>3;if(!m)return;h=l+-4|0;if((l|0)<4){n=(l|0)>0;o=a;q=i;r=g;s=d;t=m;while(1){t=t+-1|0;if(n){u=0;do{v=+p[o+(u<<3)>>3];if(!(+p[s+(u<<3)>>3]<=v))w=0;else w=v<=+p[r+(u<<3)>>3];b[q+u>>0]=w<<31>>31;u=u+1|0}while((u|0)!=(l|0))}if(!t)break;else{o=o+(k<<3)|0;q=q+j|0;r=r+(e<<3)|0;s=s+(c<<3)|0}}return}s=l&-4;r=(s|0)<(l|0);q=a;a=i;i=g;g=d;d=m;while(1){m=0;do{v=+p[q+(m<<3)>>3];if(!(+p[g+(m<<3)>>3]<=v))x=0;else x=v<=+p[i+(m<<3)>>3];o=m|1;v=+p[q+(o<<3)>>3];if(!(+p[g+(o<<3)>>3]<=v))y=0;else y=v<=+p[i+(o<<3)>>3];b[a+m>>0]=x<<31>>31;b[a+o>>0]=y<<31>>31;o=m|2;v=+p[q+(o<<3)>>3];if(!(+p[g+(o<<3)>>3]<=v))z=0;else z=v<=+p[i+(o<<3)>>3];t=m|3;v=+p[q+(t<<3)>>3];if(!(+p[g+(t<<3)>>3]<=v))A=0;else A=v<=+p[i+(t<<3)>>3];b[a+o>>0]=z<<31>>31;b[a+t>>0]=A<<31>>31;m=m+4|0}while((m|0)<=(h|0));d=d+-1|0;if(r){m=s;do{v=+p[q+(m<<3)>>3];if(!(+p[g+(m<<3)>>3]<=v))B=0;else B=v<=+p[i+(m<<3)>>3];b[a+m>>0]=B<<31>>31;m=m+1|0}while((m|0)!=(l|0))}if(!d)break;else{q=q+(k<<3)|0;a=a+j|0;i=i+(e<<3)|0;g=g+(c<<3)|0}}return}function HF(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0.0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0;e=d;g=f[e>>2]|0;h=f[e+4>>2]|0;if(!(b[1119608]|0)){f[125028]=1991057938;f[125029]=0;n[125156]=1.7290404663583558e-09;n[125283]=1.6030947680434338e-09;n[125284]=1.0;n[125411]=2.6696291752159595e-03;e=126;i=3.442619855899;while(1){j=i;i=+M(+(+W(+(.00991256303526217/i+ +V(+(i*(i*-.5)))))*-2.0));f[500112+(e+1<<2)>>2]=~~(i/j*2147483648.0)>>>0;j=+V(+(i*(i*-.5)));n[501136+(e<<2)>>2]=j;n[500624+(e<<2)>>2]=i*4.656612873077393e-10;if((e|0)<=1)break;else e=e+-1|0}b[1119608]=1}if((c|0)>0){k=0;l=g;m=h}else{o=g;p=h;q=d;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}while(1){h=l;g=m;while(1){e=cbc(h|0,0,-130063606,0)|0;u=Kac(e|0,J|0,g|0,0)|0;e=J;v=h&127;i=+n[500624+(v<<2)>>2]*+(h|0);if(((h|0)>-1?h:0-h|0)>>>0<(f[500112+(v<<2)>>2]|0)>>>0){w=i;x=u;y=e;break}if(!v){z=u;A=e;B=9;break}C=cbc(u|0,0,-130063606,0)|0;D=Kac(C|0,J|0,e|0,0)|0;e=J;j=+n[501136+(v<<2)>>2];E=i;if(!(j+ +(u>>>0)*2.3283064365386963e-10*(+n[501136+(v+-1<<2)>>2]-j)<+V(+(E*(E*-.5))))){h=D;g=e}else{w=i;x=D;y=e;break}}if((B|0)==9){while(1){B=0;g=cbc(z|0,0,-130063606,0)|0;e=Kac(g|0,J|0,A|0,0)|0;g=J;D=cbc(e|0,0,-130063606,0)|0;v=z;z=Kac(D|0,J|0,g|0,0)|0;A=J;F=-+W(+(+(v>>>0)*2.3283064365386963e-10+1.1754943508222875e-38))*.2904764;i=+W(+(+(e>>>0)*2.3283064365386963e-10+1.1754943508222875e-38));if(!(-i-i<F*F))break;else B=9}w=(h|0)>0?F+3.442620038986206:-3.442620038986206-F;x=z;y=A}n[a+(k<<2)>>2]=w;k=k+1|0;if((k|0)==(c|0)){o=x;p=y;break}else{l=x;m=y}}q=d;r=q;f[r>>2]=o;s=q+4|0;t=s;f[t>>2]=p;return}function IF(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;i=u;u=u+2528|0;j=i+2464|0;k=i+2408|0;l=i+2352|0;m=i+2296|0;o=i+1096|0;q=i+2224|0;r=i+2288|0;t=i+2280|0;v=i+2192|0;w=i;do if((yM(c)|0)==65536){x=f[c+4>>2]|0;f[k>>2]=f[x>>2];y=k+4|0;z=x+4|0;f[y>>2]=f[z>>2];A=k+8|0;f[A>>2]=f[x+8>>2];f[k+12>>2]=f[x+12>>2];f[k+16>>2]=f[x+16>>2];f[k+20>>2]=f[x+20>>2];f[k+24>>2]=f[x+24>>2];f[k+28>>2]=f[x+28>>2];f[k+32>>2]=f[x+32>>2];B=f[x+36>>2]|0;f[k+36>>2]=B;f[k+40>>2]=A;A=k+48|0;C=k+44|0;f[C>>2]=A;f[A>>2]=0;f[k+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[x+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(k,x);break}}else yL(k,c,-1);while(0);do if((yM(e)|0)==65536){c=f[e+4>>2]|0;f[l>>2]=f[c>>2];x=l+4|0;y=c+4|0;f[x>>2]=f[y>>2];z=l+8|0;f[z>>2]=f[c+8>>2];f[l+12>>2]=f[c+12>>2];f[l+16>>2]=f[c+16>>2];f[l+20>>2]=f[c+20>>2];f[l+24>>2]=f[c+24>>2];f[l+28>>2]=f[c+28>>2];f[l+32>>2]=f[c+32>>2];A=f[c+36>>2]|0;f[l+36>>2]=A;f[l+40>>2]=z;z=l+48|0;C=l+44|0;f[C>>2]=z;f[z>>2]=0;f[l+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[c+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[x>>2]=0;jL(l,c);break}}else yL(l,e,-1);while(0);do if((yM(g)|0)==65536){e=f[g+4>>2]|0;f[m>>2]=f[e>>2];c=m+4|0;x=e+4|0;f[c>>2]=f[x>>2];y=m+8|0;f[y>>2]=f[e+8>>2];f[m+12>>2]=f[e+12>>2];f[m+16>>2]=f[e+16>>2];f[m+20>>2]=f[e+20>>2];f[m+24>>2]=f[e+24>>2];f[m+28>>2]=f[e+28>>2];f[m+32>>2]=f[e+32>>2];z=f[e+36>>2]|0;f[m+36>>2]=z;f[m+40>>2]=y;y=m+48|0;C=m+44|0;f[C>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[e+44>>2]|0;y=f[C>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[c>>2]=0;jL(m,e);break}}else yL(m,g,-1);while(0);g=f[k>>2]|0;e=g&7;c=g>>>3&511;x=c+1|0;y=o+8|0;f[o>>2]=y;C=o+4|0;f[C>>2]=136;z=f[l>>2]|0;if((z&4088|0)==0?(A=f[l+8>>2]|0,B=f[l+12>>2]|0,(A|0)==1|(B|0)==1):0){D=A+-1+B|0;if(!((D|0)==(x|0)|(D|0)==1)?(D=f[l+40>>2]|0,x>>>0>4|(z&4095|0)!=6|((f[D>>2]|0)!=4?1:(f[D+4>>2]|0)!=1)):0)E=26}else E=26;if((E|0)==26){f[j>>2]=0;f[j+4>>2]=0;Vac(aD(j,218)|0,174467,218)|0;bO(-215,j,376245,174686,525);bD(j)}do if(!(f[m>>2]&4088)){D=f[m+8>>2]|0;z=f[m+12>>2]|0;if((D|0)!=1)if((z|0)==1){F=1;E=30}else G=z;else{F=z;E=30}if((E|0)==30){z=D+-1+F|0;if((z|0)==(x|0)|(z|0)==1)break;z=f[l+40>>2]|0;if(((f[z>>2]|0)==4?(f[z+4>>2]|0)==1:0)?(x>>>0<5?(f[l>>2]&4095|0)==6:0):0)break;else G=F}if(!((D|0)==(x|0)?(d|0)==1&(G|0)==(x|0):0))E=35}else E=35;while(0);if((E|0)==35){f[j>>2]=0;f[j+4>>2]=0;Vac(aD(j,290)|0,174752,290)|0;bO(-215,j,376245,174686,530);bD(j)}G=l+4|0;F=f[G>>2]|0;if((F|0)<3)H=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;else{D=f[l+40>>2]|0;z=0;B=1;while(1){A=Y(f[D+(z<<2)>>2]|0,B)|0;z=z+1|0;if((z|0)==(F|0)){H=A;break}else B=A}}B=m+4|0;F=f[B>>2]|0;if((F|0)<3)I=Y(f[m+12>>2]|0,f[m+8>>2]|0)|0;else{z=f[m+40>>2]|0;D=0;A=1;while(1){K=Y(f[z+(D<<2)>>2]|0,A)|0;D=D+1|0;if((D|0)==(F|0)){I=K;break}else A=K}}A=(d|0)==0;do if(!A){if((d|0)!=1){f[j>>2]=0;f[j+4>>2]=0;L=aD(j,25)|0;M=175058;N=L+25|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));bO(-5,j,376245,174686,690);bD(j);O=0;P=0;Q=0;R=0;S=0;T=0;U=0;V=0;W=0;X=0;Z=1;break}F=(H|0)<=(c|0);D=F?x:H;z=(I|0)<=(c|0);K=(z?x:I)+D|0;if((f[C>>2]|0)>>>0<K>>>0){_=f[o>>2]|0;if((_|0)!=(y|0)){if(_|0)P5b(_);f[o>>2]=y;f[C>>2]=136}f[C>>2]=K;if(K>>>0>136){_=N5b(K>>>0>536870911?-1:K<<3)|0;f[o>>2]=_;$=_}else $=y}else{f[C>>2]=K;$=f[o>>2]|0}K=(e|0)==6?6:5;_=47696>>>(K<<1)&3;aa=f[l>>2]|0;if((aa&16384|0)!=0?!(F|(aa&4095|0)!=(K|0)):0)ba=f[l+16>>2]|0;else{aa=f[l+40>>2]|0;ca=f[aa>>2]|0;f[r>>2]=f[aa+4>>2];f[r+4>>2]=ca;JF(j,r,K,$,0);ca=q+8|0;f[ca>>2]=0;f[ca+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=j;OJ(l,q,K,1.0,0.0);ca=j+36|0;aa=f[ca>>2]|0;if(aa|0?(da=aa+12|0,aa=f[da>>2]|0,f[da>>2]=aa+-1,(aa|0)==1):0)kL(j);f[ca>>2]=0;ca=j+16|0;aa=j+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[aa>>2]|0)>0){ca=f[j+40>>2]|0;da=0;do{f[ca+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[aa>>2]|0))}aa=f[j+44>>2]|0;if((aa|0)!=(j+48|0))UC(aa);ba=$}if(F?(aa=H<<_,da=x<<_,(aa|0)<(da|0)):0){ca=aa;do{b[ba+ca>>0]=b[ba+(ca-aa)>>0]|0;ca=ca+1|0}while((ca|0)!=(da|0))}da=f[m>>2]|0;if((da&16384|0)!=0?!(z|(da&4095|0)!=(K|0)):0)ea=f[m+16>>2]|0;else{da=f[m+40>>2]|0;ca=f[da>>2]|0;f[t>>2]=f[da+4>>2];f[t+4>>2]=ca;ca=$+(D<<3)|0;JF(j,t,K,ca,0);da=q+8|0;f[da>>2]=0;f[da+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=j;OJ(m,q,K,1.0,0.0);da=j+36|0;aa=f[da>>2]|0;if(aa|0?(F=aa+12|0,aa=f[F>>2]|0,f[F>>2]=aa+-1,(aa|0)==1):0)kL(j);f[da>>2]=0;da=j+16|0;aa=j+4|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[aa>>2]|0)>0){da=f[j+40>>2]|0;F=0;do{f[da+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[aa>>2]|0))}aa=f[j+44>>2]|0;if((aa|0)!=(j+48|0))UC(aa);ea=ca}if(z?(aa=I<<_,F=x<<_,(aa|0)<(F|0)):0){da=aa;do{b[ea+da>>0]=b[ea+(da-aa)>>0]|0;da=da+1|0}while((da|0)!=(F|0))}F=(f[m+8>>2]|0)==(x|0)?(f[m+12>>2]|0)==(x|0):0;da=f[40764+(e<<2)>>2]|0;if((e|0)==7){f[j>>2]=0;f[j+4>>2]=0;L=aD(j,14)|0;M=175043;N=L+14|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));bO(-215,j,376245,174686,687);bD(j);O=da;P=F;Q=0;R=0;S=ea;T=ba;U=0;V=0;W=0;X=0;Z=1}else{O=da;P=F;Q=0;R=0;S=ea;T=ba;U=0;V=0;W=0;X=0;Z=1}}else{aa=H+(x<<3)+I|0;if((f[C>>2]|0)>>>0<aa>>>0){_=f[o>>2]|0;if((_|0)!=(y|0)){if(_|0)P5b(_);f[o>>2]=y;f[C>>2]=136}f[C>>2]=aa;if(aa>>>0>136){_=N5b(aa>>>0>536870911?-1:aa<<3)|0;f[o>>2]=_;fa=_}else fa=y}else{f[C>>2]=aa;fa=f[o>>2]|0}aa=f[m+16>>2]|0;_=f[l>>2]|0;if((_&16384|0)!=0?(H|0)==(x|0)&(_&4095|0)==6:0)ga=f[l+16>>2]|0;else{_=f[l+40>>2]|0;z=f[_+4>>2]|0;ca=f[_>>2]|0;f[q>>2]=1124007942;_=q+4|0;f[_>>2]=2;K=q+8|0;f[K>>2]=ca;D=q+12|0;f[D>>2]=z;ha=q+16|0;f[ha>>2]=fa;ia=q+20|0;f[ia>>2]=fa;ja=q+24|0;ka=q+28|0;la=q+40|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;f[la>>2]=K;ma=q+48|0;na=q+44|0;f[na>>2]=ma;f[q+52>>2]=0;f[ma>>2]=0;if((fa|0)==0&(Y(ca,z)|0)!=0){f[j>>2]=0;f[j+4>>2]=0;L=aD(j,26)|0;M=426262;N=L+26|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));bO(-215,j,426289,431198,533);bD(j);oa=f[D>>2]|0;pa=f[q>>2]|0;qa=f[na>>2]|0;ra=f[ia>>2]|0}else{oa=z;pa=1124007942;qa=ma;ra=fa}F=oa<<3;f[q>>2]=pa|16384;f[qa>>2]=F;f[qa+4>>2]=8;da=ra+(Y(f[K>>2]|0,F)|0)|0;f[ka>>2]=da;f[ja>>2]=da+(0-F)+F;F=j+8|0;f[F>>2]=0;f[F+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=q;OJ(l,j,6,1.0,0.0);if((H|0)<=(c|0)){F=H;while(1){p[fa+(F<<3)>>3]=+p[fa+(F-H<<3)>>3];if((F|0)<(c|0))F=F+1|0;else break}}F=q+36|0;ja=f[F>>2]|0;if(ja|0?(ka=ja+12|0,ja=f[ka>>2]|0,f[ka>>2]=ja+-1,(ja|0)==1):0)kL(q);f[F>>2]=0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[_>>2]|0)>0){F=f[la>>2]|0;ja=0;do{f[F+(ja<<2)>>2]=0;ja=ja+1|0}while((ja|0)<(f[_>>2]|0))}_=f[na>>2]|0;if((_|0)!=(ma|0))UC(_);ga=fa}_=f[m>>2]|0;if((_&16384|0)!=0?(I|0)==(x|0)&(_&4095|0)==6:0)sa=aa;else{_=f[m+40>>2]|0;ja=f[_+4>>2]|0;F=f[_>>2]|0;_=fa+(x<<3)|0;la=j+4|0;f[la>>2]=2;ha=j+8|0;f[ha>>2]=F;f[j+12>>2]=ja;ka=j+16|0;f[ka>>2]=_;f[j+20>>2]=_;K=j+24|0;z=j+40|0;ia=K+8|0;f[ia>>2]=0;f[ia+4>>2]=0;f[z>>2]=ha;ha=j+48|0;ia=j+44|0;f[ia>>2]=ha;D=ja<<3;f[j>>2]=1124024326;f[ha>>2]=D;f[j+52>>2]=8;ja=_+(Y(F,D)|0)|0;f[j+28>>2]=ja;f[K>>2]=ja+(0-D)+D;D=q+8|0;f[D>>2]=0;f[D+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=j;OJ(m,q,6,1.0,0.0);if((I|0)<=(c|0)){D=I;while(1){p[_+(D<<3)>>3]=+p[_+(D-I<<3)>>3];if((D|0)<(c|0))D=D+1|0;else break}}D=j+36|0;aa=f[D>>2]|0;if(aa|0?(ma=aa+12|0,aa=f[ma>>2]|0,f[ma>>2]=aa+-1,(aa|0)==1):0)kL(j);f[D>>2]=0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[la>>2]|0)>0){D=f[z>>2]|0;aa=0;do{f[D+(aa<<2)>>2]=0;aa=aa+1|0}while((aa|0)<(f[la>>2]|0))}la=f[ia>>2]|0;if((la|0)!=(ha|0))UC(la);sa=_}do if(e>>>0>=5){ta=(e|0)==6?5.421010862427522e-20:2.3283064365386963e-10;ua=h?3402823466385288598117041.0e14:1797693134862315708145274.0e284;la=fa+(x<<1<<3)|0;if((e|0)==5){aa=0;do{va=+p[sa+(aa<<3)>>3];wa=+p[ga+(aa<<3)>>3];xa=va-wa;D=la+(aa<<3)|0;n[D>>2]=ta*(xa<ua?xa:ua);n[D+4>>2]=(va+wa)*.5;aa=aa+1|0}while((aa|0)!=(x|0));ya=0;za=0;Aa=0;Ba=la;Ca=0;Da=1;Ea=0;break}else{aa=0;do{D=sa+(aa<<3)|0;z=ga+(aa<<3)|0;ua=+p[D>>3]-+p[z>>3];p[la+(aa<<4)>>3]=ta*(ua<1797693134862315708145274.0e284?ua:1797693134862315708145274.0e284);p[la+(aa<<4)+8>>3]=(+p[D>>3]+ +p[z>>3])*.5;aa=aa+1|0}while((aa|0)!=(x|0));ya=0;za=0;Aa=la;Ba=0;Ca=0;Da=1;Ea=0}}else{la=fa+(x<<1<<3)|0;aa=(e|2|0)==2;z=g&255;D=(e|0)==3;ta=D?32768.0:2147483647.0;if(h){ka=aa|(e|0)!=1;ua=aa?0.0:D?-32768.0:-2147483648.0;D=1;aa=1;ma=0;while(1){wa=+p[sa+(ma<<3)>>3];va=+p[ga+(ma<<3)>>3];xa=wa<va?wa:va;Fa=va<wa?wa:va;a:do if(ka){va=xa<ua?ua:xa;switch(z&7){case 0:{Ga=va;Ha=256.0;break a;break}case 1:{Ia=va;E=87;break a;break}case 2:{Ga=va;Ha=65536.0;break a;break}default:{Ga=va;Ha=ta;break a}}}else{Ia=xa<-128.0?-128.0:xa;E=87}while(0);if((E|0)==87){E=0;Ga=Ia;Ha=128.0}xa=Ha<Fa?Ha:Fa;na=~~Ga;ja=(+(na|0)<Ga&1)+na|0;na=la+(ma<<3)|0;K=na+4|0;f[K>>2]=ja;F=~~xa;da=F-(+(F|0)>xa&1)-ja|0;ja=da+-1|0;f[na>>2]=ja;va=xa-Ga;F=(ja&da|0)==0;do if(D<<24>>24!=0&va<=4294967296.0){ja=F&1;if(!F){Ja=ja;E=92;break}Ka=(aa&1)!=0&(da|0)<257&1;La=ja}else{Ja=0;E=92}while(0);do if((E|0)==92){E=0;if(va>2147483647.0)f[na>>2]=2147483647;if(!(Ga<-1073741824.0)){Ka=aa;La=Ja;break}f[K>>2]=-1073741824;Ka=aa;La=Ja}while(0);ma=ma+1|0;if((ma|0)==(x|0)){Ma=La;Na=Ka;break}else{D=La;aa=Ka}}}else{aa=1;D=1;ma=0;while(1){ta=+p[sa+(ma<<3)>>3];ua=+p[ga+(ma<<3)>>3];va=ta<ua?ta:ua;Fa=ua<ta?ta:ua;z=~~va;ka=(+(z|0)<va&1)+z|0;z=la+(ma<<3)|0;K=z+4|0;f[K>>2]=ka;na=~~Fa;da=na-(+(na|0)>Fa&1)-ka|0;ka=da+-1|0;f[z>>2]=ka;ua=Fa-va;na=(ka&da|0)==0;if(aa<<24>>24!=0&ua<=4294967296.0){ka=na&1;if(na){Oa=(D&1)!=0&(da|0)<257&1;Pa=ka}else{Qa=ka;E=101}}else{Qa=0;E=101}do if((E|0)==101){E=0;if(ua>2147483647.0)f[z>>2]=2147483647;if(!(va<-1073741824.0)){Oa=D;Pa=Qa;break}f[K>>2]=-1073741824;Oa=D;Pa=Qa}while(0);ma=ma+1|0;if((ma|0)==(x|0)){Ma=Pa;Na=Oa;break}else{aa=Pa;D=Oa}}}if(!(Ma<<24>>24)){D=la+(x<<3)|0;aa=0;do{ma=la+(aa<<3)|0;f[D+(aa*20|0)+16>>2]=f[ma+4>>2];K=(f[ma>>2]|0)+1|0;f[D+(aa*20|0)>>2]=K;ma=0;while(1){Ra=$ac(1,0,ma|0)|0;Sa=J;if(Sa>>>0<0|(Sa|0)==0&Ra>>>0<K>>>0)ma=ma+1|0;else break}z=Jac(Ra|0,Sa|0,K|0,0)|0;ka=Uac(0,z|0,K|0,0)|0;f[D+(aa*20|0)+4>>2]=ka+1;f[D+(aa*20|0)+8>>2]=(ma|0)<1?ma:1;ka=ma+-1|0;f[D+(aa*20|0)+12>>2]=(ka|0)>0?ka:0;aa=aa+1|0}while((aa|0)!=(x|0));Ta=D}else Ta=0;ya=la;za=Ma;Aa=0;Ba=0;Ca=Ta;Da=Na;Ea=Ma&255}while(0);_=f[40700+(Ea<<5)+(e<<2)>>2]|0;if(!_){f[j>>2]=0;f[j+4>>2]=0;L=aD(j,9)|0;M=255890;N=L+9|0;do{b[L>>0]=b[M>>0]|0;L=L+1|0;M=M+1|0}while((L|0)<(N|0));bO(-215,j,376245,174686,649);bD(j)}O=0;P=0;Q=_;R=ya;S=0;T=0;U=(za&1)!=0;V=Aa;W=Ba;X=Ca;Z=(Da&1)!=0}while(0);f[j>>2]=k;f[j+4>>2]=0;RN(v,j,q,1);j=f[v+20>>2]|0;Da=((c|1024)>>>0)/(x>>>0)|0;c=(j|0)<(Da|0)?j:Da;Da=k+4|0;Ca=f[Da>>2]|0;if((Ca|0)>0)Ua=f[(f[k+44>>2]|0)+(Ca+-1<<2)>>2]|0;else Ua=0;Ca=w+8|0;f[w>>2]=Ca;Ba=w+4|0;f[Ba>>2]=136;Aa=Y(c,x)|0;do if(A){za=Aa<<2;f[Ba>>2]=za;if(za>>>0>136){ya=N5b(za>>>0>536870911?-1:za<<3)|0;f[w>>2]=ya;Va=ya}else Va=Ca;if(e>>>0<5)if(U){if((Aa|0)>0)Wa=0;else{Xa=0;Ya=Va;break}do{ya=0;do{za=R+(ya<<3)|0;M=Va+(ya+Wa<<3)|0;f[s>>2]=f[za>>2];f[s+4>>2]=f[za+4>>2];p[s>>3]=+p[s>>3];f[M>>2]=f[s>>2];f[M+4>>2]=f[s+4>>2];ya=ya+1|0}while((ya|0)!=(x|0));Wa=Wa+x|0}while((Wa|0)<(Aa|0));Xa=0;Ya=Va}else{if((Aa|0)>0)Za=0;else{Xa=0;Ya=Va;break}do{_=0;do{ya=X+(_*20|0)|0;la=Va+((_+Za|0)*20|0)|0;f[la>>2]=f[ya>>2];f[la+4>>2]=f[ya+4>>2];f[la+8>>2]=f[ya+8>>2];f[la+12>>2]=f[ya+12>>2];f[la+16>>2]=f[ya+16>>2];_=_+1|0}while((_|0)!=(x|0));Za=Za+x|0}while((Za|0)<(Aa|0));Xa=0;Ya=Va}else if((e|0)==5){if((Aa|0)>0)_a=0;else{Xa=0;Ya=Va;break}do{_=0;do{ya=W+(_<<3)|0;la=Va+(_+_a<<3)|0;f[s>>2]=f[ya>>2];f[s+4>>2]=f[ya+4>>2];p[s>>3]=+p[s>>3];f[la>>2]=f[s>>2];f[la+4>>2]=f[s+4>>2];_=_+1|0}while((_|0)!=(x|0));_a=_a+x|0}while((_a|0)<(Aa|0));Xa=0;Ya=Va}else{if((Aa|0)>0)$a=0;else{Xa=0;Ya=Va;break}do{_=0;do{la=V+(_<<4)|0;ya=Va+(_+$a<<4)|0;f[ya>>2]=f[la>>2];f[ya+4>>2]=f[la+4>>2];f[ya+8>>2]=f[la+8>>2];f[ya+12>>2]=f[la+12>>2];_=_+1|0}while((_|0)!=(x|0));$a=$a+x|0}while(($a|0)<(Aa|0));Xa=0;Ya=Va}}else{_=(Aa+1|0)/2|0;f[Ba>>2]=_;if(_>>>0>136){la=N5b(_>>>0>536870911?-1:_<<3)|0;f[w>>2]=la;Xa=la;Ya=0}else{Xa=Ca;Ya=0}}while(0);Aa=v+16|0;b:do if((j|0)>0){Va=0;while(1){if(Va>>>0>=(f[Aa>>2]|0)>>>0)break b;if(A){$a=0;V=f[q>>2]|0;do{_a=j-$a|0;W=(c|0)<(_a|0)?c:_a;_a=Y(W,x)|0;uh[Q&255](V,_a,a,Ya,Z);_a=Y(W,Ua)|0;V=(f[q>>2]|0)+_a|0;f[q>>2]=V;$a=$a+c|0}while((j|0)>($a|0))}else{$a=0;do{V=j-$a|0;_a=(c|0)<(V|0)?c:V;HF(Xa,Y(_a,x)|0,a);Qh[O&127](Xa,f[q>>2]|0,_a,x,T,S,P);V=Y(_a,Ua)|0;f[q>>2]=(f[q>>2]|0)+V;$a=$a+c|0}while((j|0)>($a|0))}aL(v)|0;Va=Va+1|0}}else{Va=0;while(1){if(Va>>>0>=(f[Aa>>2]|0)>>>0)break b;aL(v)|0;Va=Va+1|0}}while(0);v=f[w>>2]|0;if((v|0)!=(Ca|0)){if(v|0)P5b(v);f[w>>2]=Ca;f[Ba>>2]=136}Ba=f[o>>2]|0;if((Ba|0)!=(y|0)){if(Ba|0)P5b(Ba);f[o>>2]=y;f[C>>2]=136}C=m+36|0;y=f[C>>2]|0;if(y|0?(o=y+12|0,y=f[o>>2]|0,f[o>>2]=y+-1,(y|0)==1):0)kL(m);f[C>>2]=0;C=m+16|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[B>>2]|0)>0){C=f[m+40>>2]|0;y=0;do{f[C+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[B>>2]|0))}B=f[m+44>>2]|0;if((B|0)!=(m+48|0))UC(B);B=l+36|0;m=f[B>>2]|0;if(m|0?(y=m+12|0,m=f[y>>2]|0,f[y>>2]=m+-1,(m|0)==1):0)kL(l);f[B>>2]=0;B=l+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[G>>2]|0)>0){B=f[l+40>>2]|0;m=0;do{f[B+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[G>>2]|0))}G=f[l+44>>2]|0;if((G|0)!=(l+48|0))UC(G);G=k+36|0;l=f[G>>2]|0;do if(l|0){m=l+12|0;B=f[m>>2]|0;f[m>>2]=B+-1;if((B|0)!=1)break;kL(k)}while(0);f[G>>2]=0;G=k+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[Da>>2]|0)>0){G=f[k+40>>2]|0;l=0;do{f[G+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[Da>>2]|0))}Da=f[k+44>>2]|0;if((Da|0)==(k+48|0)){u=i;return}UC(Da);u=i;return}function JF(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;h=u;u=u+16|0;i=h;f[a>>2]=d&4095|1124007936;f[a+4>>2]=2;j=a+8|0;k=f[c+4>>2]|0;f[j>>2]=k;l=a+12|0;m=f[c>>2]|0;f[l>>2]=m;f[a+16>>2]=e;c=a+20|0;f[c>>2]=e;n=a+24|0;o=a+28|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[a+40>>2]=j;p=a+48|0;q=a+44|0;f[q>>2]=p;f[a+52>>2]=0;f[p>>2]=0;if((Y(m,k)|0)!=0&(e|0)==0){f[i>>2]=0;f[i+4>>2]=0;r=aD(i,26)|0;s=426262;t=r+26|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,i,426289,431198,533);bD(i);v=f[l>>2]|0}else v=m;m=d&7;l=(d>>>3&511)+1<<(47696>>>(m<<1)&3);d=Y(v,l)|0;if(g){if((g>>>0)%((1212424721>>>(m<<2)&15)>>>0)|0|0){f[i>>2]=0;f[i+4>>2]=0;r=aD(i,31)|0;s=179428;t=r+31|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-13,i,426289,431198,548);bD(i)}if((d|0)!=(g|0)?(f[j>>2]|0)!=1:0){w=g;x=f[q>>2]|0;f[x>>2]=w;y=x+4|0;f[y>>2]=l;z=f[c>>2]|0;A=f[j>>2]|0;B=Y(A,w)|0;C=z+B|0;f[o>>2]=C;D=0-w|0;E=C+D|0;F=E+d|0;f[n>>2]=F;u=h;return}else G=g}else G=d;f[a>>2]=f[a>>2]|16384;w=G;x=f[q>>2]|0;f[x>>2]=w;y=x+4|0;f[y>>2]=l;z=f[c>>2]|0;A=f[j>>2]|0;B=Y(A,w)|0;C=z+B|0;f[o>>2]=C;D=0-w|0;E=C+D|0;F=E+d|0;f[n>>2]=F;u=h;return}function KF(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((d|0)>0&(e|0)>0){i=c;j=a;k=0}else return;while(1){h=0;do{l=Y(h,e)|0;m=+n[f+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(e|0));o=LVb(m)|0;b[i+h>>0]=o>>>0<256?o:(o|0)>0?255:0;h=h+1|0}while((h|0)!=(e|0));k=k+1|0;if((k|0)==(d|0))break;else{i=i+e|0;j=j+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((d|0)>0)r=0;else return;do{j=LVb(p+q*+n[a+(r<<2)>>2])|0;b[c+r>>0]=j>>>0<256?j:(j|0)>0?255:0;r=r+1|0}while((r|0)!=(d|0));return}if((d|0)>0&(e|0)>0){s=a;t=c;u=0}else return;while(1){c=0;do{a=LVb(+n[s+(c<<2)>>2]*+n[g+(c<<2)>>2]+ +n[f+(c<<2)>>2])|0;b[t+c>>0]=a>>>0<256?a:(a|0)>0?255:0;c=c+1|0}while((c|0)!=(e|0));u=u+1|0;if((u|0)==(d|0))break;else{s=s+(e<<2)|0;t=t+e|0}}return}function LF(a,c,d,e,f,g,h){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((d|0)>0&(e|0)>0){i=c;j=a;k=0}else return;while(1){h=0;do{l=Y(h,e)|0;m=+n[f+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(e|0));o=LVb(m)|0;b[i+h>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;h=h+1|0}while((h|0)!=(e|0));k=k+1|0;if((k|0)==(d|0))break;else{i=i+e|0;j=j+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((d|0)>0)r=0;else return;do{j=LVb(p+q*+n[a+(r<<2)>>2])|0;b[c+r>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;r=r+1|0}while((r|0)!=(d|0));return}if((d|0)>0&(e|0)>0){s=a;t=c;u=0}else return;while(1){c=0;do{a=LVb(+n[s+(c<<2)>>2]*+n[g+(c<<2)>>2]+ +n[f+(c<<2)>>2])|0;b[t+c>>0]=(a+128|0)>>>0<256?a:(a|0)>0?127:128;c=c+1|0}while((c|0)!=(e|0));u=u+1|0;if((u|0)==(d|0))break;else{s=s+(e<<2)|0;t=t+e|0}}return}function MF(a,b,c,e,f,g,h){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((c|0)>0&(e|0)>0){i=b;j=a;k=0}else return;while(1){h=0;do{l=Y(h,e)|0;m=+n[f+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(e|0));o=LVb(m)|0;d[i+(h<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;h=h+1|0}while((h|0)!=(e|0));k=k+1|0;if((k|0)==(c|0))break;else{i=i+(e<<1)|0;j=j+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((c|0)>0)r=0;else return;do{j=LVb(p+q*+n[a+(r<<2)>>2])|0;d[b+(r<<1)>>1]=j>>>0<65536?j:(j|0)>0?65535:0;r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(e|0)>0){s=a;t=b;u=0}else return;while(1){b=0;do{a=LVb(+n[s+(b<<2)>>2]*+n[g+(b<<2)>>2]+ +n[f+(b<<2)>>2])|0;d[t+(b<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;b=b+1|0}while((b|0)!=(e|0));u=u+1|0;if((u|0)==(c|0))break;else{s=s+(e<<2)|0;t=t+(e<<1)|0}}return}function NF(a,b,c,e,f,g,h){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((c|0)>0&(e|0)>0){i=b;j=a;k=0}else return;while(1){h=0;do{l=Y(h,e)|0;m=+n[f+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(e|0));o=LVb(m)|0;d[i+(h<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;h=h+1|0}while((h|0)!=(e|0));k=k+1|0;if((k|0)==(c|0))break;else{i=i+(e<<1)|0;j=j+(e<<2)|0}}return}if((e|0)==1){p=+n[f>>2];q=+n[g>>2];if((c|0)>0)r=0;else return;do{j=LVb(p+q*+n[a+(r<<2)>>2])|0;d[b+(r<<1)>>1]=(j+32768|0)>>>0<65536?j:(j|0)>0?32767:32768;r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(e|0)>0){s=a;t=b;u=0}else return;while(1){b=0;do{a=LVb(+n[s+(b<<2)>>2]*+n[g+(b<<2)>>2]+ +n[f+(b<<2)>>2])|0;d[t+(b<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;b=b+1|0}while((b|0)!=(e|0));u=u+1|0;if((u|0)==(c|0))break;else{s=s+(e<<2)|0;t=t+(e<<1)|0}}return}function OF(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0;if(h){if((c|0)>0&(d|0)>0){i=b;j=a;k=0}else return;while(1){h=0;do{l=Y(h,d)|0;m=+n[e+(h<<2)>>2];o=0;do{m=m+ +n[j+(o<<2)>>2]*+n[g+(o+l<<2)>>2];o=o+1|0}while((o|0)!=(d|0));o=LVb(m)|0;f[i+(h<<2)>>2]=o;h=h+1|0}while((h|0)!=(d|0));k=k+1|0;if((k|0)==(c|0))break;else{i=i+(d<<2)|0;j=j+(d<<2)|0}}return}if((d|0)==1){p=+n[e>>2];q=+n[g>>2];if((c|0)>0)r=0;else return;do{j=LVb(p+q*+n[a+(r<<2)>>2])|0;f[b+(r<<2)>>2]=j;r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(d|0)>0){s=a;t=b;u=0}else return;while(1){b=0;do{a=LVb(+n[s+(b<<2)>>2]*+n[g+(b<<2)>>2]+ +n[e+(b<<2)>>2])|0;f[t+(b<<2)>>2]=a;b=b+1|0}while((b|0)!=(d|0));u=u+1|0;if((u|0)==(c|0))break;else{s=s+(d<<2)|0;t=t+(d<<2)|0}}return}function PF(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,o=0.0,p=0.0,q=0,r=0,s=0,t=0;if(g){if((c|0)>0&(d|0)>0){h=b;i=a;j=0}else return;while(1){g=0;do{k=Y(g,d)|0;l=+n[e+(g<<2)>>2];m=0;do{l=l+ +n[i+(m<<2)>>2]*+n[f+(m+k<<2)>>2];m=m+1|0}while((m|0)!=(d|0));n[h+(g<<2)>>2]=l;g=g+1|0}while((g|0)!=(d|0));j=j+1|0;if((j|0)==(c|0))break;else{h=h+(d<<2)|0;i=i+(d<<2)|0}}return}if((d|0)==1){o=+n[e>>2];p=+n[f>>2];if((c|0)>0)q=0;else return;do{n[b+(q<<2)>>2]=o+p*+n[a+(q<<2)>>2];q=q+1|0}while((q|0)!=(c|0));return}if((c|0)>0&(d|0)>0){r=a;s=b;t=0}else return;while(1){b=0;do{n[s+(b<<2)>>2]=+n[r+(b<<2)>>2]*+n[f+(b<<2)>>2]+ +n[e+(b<<2)>>2];b=b+1|0}while((b|0)!=(d|0));t=t+1|0;if((t|0)==(c|0))break;else{r=r+(d<<2)|0;s=s+(d<<2)|0}}return}function QF(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,o=0.0,q=0.0,r=0,s=0,t=0,u=0;if(g){if((c|0)>0&(d|0)>0){h=b;i=a;j=0}else return;while(1){g=0;do{k=Y(g,d)|0;l=+p[e+(g<<3)>>3];m=0;do{l=l+ +n[i+(m<<2)>>2]*+p[f+(m+k<<3)>>3];m=m+1|0}while((m|0)!=(d|0));p[h+(g<<3)>>3]=l;g=g+1|0}while((g|0)!=(d|0));j=j+1|0;if((j|0)==(c|0))break;else{h=h+(d<<3)|0;i=i+(d<<2)|0}}return}if((d|0)==1){o=+p[e>>3];q=+p[f>>3];if((c|0)>0)r=0;else return;do{p[b+(r<<3)>>3]=o+q*+n[a+(r<<2)>>2];r=r+1|0}while((r|0)!=(c|0));return}if((c|0)>0&(d|0)>0){s=a;t=b;u=0}else return;while(1){b=0;do{p[t+(b<<3)>>3]=+n[s+(b<<2)>>2]*+p[f+(b<<3)>>3]+ +p[e+(b<<3)>>3];b=b+1|0}while((b|0)!=(d|0));u=u+1|0;if((u|0)==(c|0))break;else{s=s+(d<<2)|0;t=t+(d<<3)|0}}return}function RF(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=d;h=f[g>>2]|0;i=f[g+4>>2]|0;g=c+-4|0;if((c|0)<4){j=0;k=h;l=i}else{m=0;n=h;h=i;do{i=cbc(n|0,0,-130063606,0)|0;o=Kac(i|0,J|0,h|0,0)|0;i=J;p=cbc(o|0,0,-130063606,0)|0;q=Kac(p|0,J|0,i|0,0)|0;i=J;cbc(o|0,0,f[e+(m*20|0)+4>>2]|0,0)|0;p=J;r=m|1;cbc(q|0,0,f[e+(r*20|0)+4>>2]|0,0)|0;s=J;t=o-(Y((((o-p|0)>>>(f[e+(m*20|0)+8>>2]|0))+p|0)>>>(f[e+(m*20|0)+12>>2]|0),f[e+(m*20|0)>>2]|0)|0)|0;p=t+(f[e+(m*20|0)+16>>2]|0)|0;t=q-(Y((((q-s|0)>>>(f[e+(r*20|0)+8>>2]|0))+s|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;s=t+(f[e+(r*20|0)+16>>2]|0)|0;b[a+m>>0]=p>>>0<256?p:(p|0)>0?255:0;b[a+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=cbc(q|0,0,-130063606,0)|0;q=Kac(s|0,J|0,i|0,0)|0;i=J;s=cbc(q|0,0,-130063606,0)|0;n=Kac(s|0,J|0,i|0,0)|0;h=J;i=m|2;cbc(f[e+(i*20|0)+4>>2]|0,0,q|0,0)|0;s=J;r=m|3;cbc(f[e+(r*20|0)+4>>2]|0,0,n|0,0)|0;p=J;t=q-(Y((((q-s|0)>>>(f[e+(i*20|0)+8>>2]|0))+s|0)>>>(f[e+(i*20|0)+12>>2]|0),f[e+(i*20|0)>>2]|0)|0)|0;s=t+(f[e+(i*20|0)+16>>2]|0)|0;t=n-(Y((((n-p|0)>>>(f[e+(r*20|0)+8>>2]|0))+p|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;p=t+(f[e+(r*20|0)+16>>2]|0)|0;b[a+i>>0]=s>>>0<256?s:(s|0)>0?255:0;b[a+r>>0]=p>>>0<256?p:(p|0)>0?255:0;m=m+4|0}while((m|0)<=(g|0));j=c&-4;k=n;l=h}if((j|0)<(c|0)){u=j;v=k;w=l}else{x=k;y=l;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){l=cbc(v|0,0,-130063606,0)|0;k=Kac(l|0,J|0,w|0,0)|0;l=J;cbc(k|0,0,f[e+(u*20|0)+4>>2]|0,0)|0;j=J;h=k-(Y((((k-j|0)>>>(f[e+(u*20|0)+8>>2]|0))+j|0)>>>(f[e+(u*20|0)+12>>2]|0),f[e+(u*20|0)>>2]|0)|0)|0;j=h+(f[e+(u*20|0)+16>>2]|0)|0;b[a+u>>0]=j>>>0<256?j:(j|0)>0?255:0;u=u+1|0;if((u|0)==(c|0)){x=k;y=l;break}else{v=k;w=l}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function SF(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=d;h=f[g>>2]|0;i=f[g+4>>2]|0;g=c+-4|0;if((c|0)<4){j=0;k=h;l=i}else{m=0;n=h;h=i;do{i=cbc(n|0,0,-130063606,0)|0;o=Kac(i|0,J|0,h|0,0)|0;i=J;p=cbc(o|0,0,-130063606,0)|0;q=Kac(p|0,J|0,i|0,0)|0;i=J;cbc(o|0,0,f[e+(m*20|0)+4>>2]|0,0)|0;p=J;r=m|1;cbc(q|0,0,f[e+(r*20|0)+4>>2]|0,0)|0;s=J;t=o-(Y((((o-p|0)>>>(f[e+(m*20|0)+8>>2]|0))+p|0)>>>(f[e+(m*20|0)+12>>2]|0),f[e+(m*20|0)>>2]|0)|0)|0;p=t+(f[e+(m*20|0)+16>>2]|0)|0;t=q-(Y((((q-s|0)>>>(f[e+(r*20|0)+8>>2]|0))+s|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;s=t+(f[e+(r*20|0)+16>>2]|0)|0;b[a+m>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;b[a+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=cbc(q|0,0,-130063606,0)|0;q=Kac(s|0,J|0,i|0,0)|0;i=J;s=cbc(q|0,0,-130063606,0)|0;n=Kac(s|0,J|0,i|0,0)|0;h=J;i=m|2;cbc(f[e+(i*20|0)+4>>2]|0,0,q|0,0)|0;s=J;r=m|3;cbc(f[e+(r*20|0)+4>>2]|0,0,n|0,0)|0;p=J;t=q-(Y((((q-s|0)>>>(f[e+(i*20|0)+8>>2]|0))+s|0)>>>(f[e+(i*20|0)+12>>2]|0),f[e+(i*20|0)>>2]|0)|0)|0;s=t+(f[e+(i*20|0)+16>>2]|0)|0;t=n-(Y((((n-p|0)>>>(f[e+(r*20|0)+8>>2]|0))+p|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;p=t+(f[e+(r*20|0)+16>>2]|0)|0;b[a+i>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;b[a+r>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;m=m+4|0}while((m|0)<=(g|0));j=c&-4;k=n;l=h}if((j|0)<(c|0)){u=j;v=k;w=l}else{x=k;y=l;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){l=cbc(v|0,0,-130063606,0)|0;k=Kac(l|0,J|0,w|0,0)|0;l=J;cbc(k|0,0,f[e+(u*20|0)+4>>2]|0,0)|0;j=J;h=k-(Y((((k-j|0)>>>(f[e+(u*20|0)+8>>2]|0))+j|0)>>>(f[e+(u*20|0)+12>>2]|0),f[e+(u*20|0)>>2]|0)|0)|0;j=h+(f[e+(u*20|0)+16>>2]|0)|0;b[a+u>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;u=u+1|0;if((u|0)==(c|0)){x=k;y=l;break}else{v=k;w=l}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function TF(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=c;h=f[g>>2]|0;i=f[g+4>>2]|0;g=b+-4|0;if((b|0)<4){j=0;k=h;l=i}else{m=0;n=h;h=i;do{i=cbc(n|0,0,-130063606,0)|0;o=Kac(i|0,J|0,h|0,0)|0;i=J;p=cbc(o|0,0,-130063606,0)|0;q=Kac(p|0,J|0,i|0,0)|0;i=J;cbc(o|0,0,f[e+(m*20|0)+4>>2]|0,0)|0;p=J;r=m|1;cbc(q|0,0,f[e+(r*20|0)+4>>2]|0,0)|0;s=J;t=o-(Y((((o-p|0)>>>(f[e+(m*20|0)+8>>2]|0))+p|0)>>>(f[e+(m*20|0)+12>>2]|0),f[e+(m*20|0)>>2]|0)|0)|0;p=t+(f[e+(m*20|0)+16>>2]|0)|0;t=q-(Y((((q-s|0)>>>(f[e+(r*20|0)+8>>2]|0))+s|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;s=t+(f[e+(r*20|0)+16>>2]|0)|0;d[a+(m<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;d[a+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=cbc(q|0,0,-130063606,0)|0;q=Kac(s|0,J|0,i|0,0)|0;i=J;s=cbc(q|0,0,-130063606,0)|0;n=Kac(s|0,J|0,i|0,0)|0;h=J;i=m|2;cbc(f[e+(i*20|0)+4>>2]|0,0,q|0,0)|0;s=J;r=m|3;cbc(f[e+(r*20|0)+4>>2]|0,0,n|0,0)|0;p=J;t=q-(Y((((q-s|0)>>>(f[e+(i*20|0)+8>>2]|0))+s|0)>>>(f[e+(i*20|0)+12>>2]|0),f[e+(i*20|0)>>2]|0)|0)|0;s=t+(f[e+(i*20|0)+16>>2]|0)|0;t=n-(Y((((n-p|0)>>>(f[e+(r*20|0)+8>>2]|0))+p|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;p=t+(f[e+(r*20|0)+16>>2]|0)|0;d[a+(i<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;d[a+(r<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;m=m+4|0}while((m|0)<=(g|0));j=b&-4;k=n;l=h}if((j|0)<(b|0)){u=j;v=k;w=l}else{x=k;y=l;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){l=cbc(v|0,0,-130063606,0)|0;k=Kac(l|0,J|0,w|0,0)|0;l=J;cbc(k|0,0,f[e+(u*20|0)+4>>2]|0,0)|0;j=J;h=k-(Y((((k-j|0)>>>(f[e+(u*20|0)+8>>2]|0))+j|0)>>>(f[e+(u*20|0)+12>>2]|0),f[e+(u*20|0)>>2]|0)|0)|0;j=h+(f[e+(u*20|0)+16>>2]|0)|0;d[a+(u<<1)>>1]=j>>>0<65536?j:(j|0)>0?65535:0;u=u+1|0;if((u|0)==(b|0)){x=k;y=l;break}else{v=k;w=l}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function UF(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=c;h=f[g>>2]|0;i=f[g+4>>2]|0;g=b+-4|0;if((b|0)<4){j=0;k=h;l=i}else{m=0;n=h;h=i;do{i=cbc(n|0,0,-130063606,0)|0;o=Kac(i|0,J|0,h|0,0)|0;i=J;p=cbc(o|0,0,-130063606,0)|0;q=Kac(p|0,J|0,i|0,0)|0;i=J;cbc(o|0,0,f[e+(m*20|0)+4>>2]|0,0)|0;p=J;r=m|1;cbc(q|0,0,f[e+(r*20|0)+4>>2]|0,0)|0;s=J;t=o-(Y((((o-p|0)>>>(f[e+(m*20|0)+8>>2]|0))+p|0)>>>(f[e+(m*20|0)+12>>2]|0),f[e+(m*20|0)>>2]|0)|0)|0;p=t+(f[e+(m*20|0)+16>>2]|0)|0;t=q-(Y((((q-s|0)>>>(f[e+(r*20|0)+8>>2]|0))+s|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;s=t+(f[e+(r*20|0)+16>>2]|0)|0;d[a+(m<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[a+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=cbc(q|0,0,-130063606,0)|0;q=Kac(s|0,J|0,i|0,0)|0;i=J;s=cbc(q|0,0,-130063606,0)|0;n=Kac(s|0,J|0,i|0,0)|0;h=J;i=m|2;cbc(f[e+(i*20|0)+4>>2]|0,0,q|0,0)|0;s=J;r=m|3;cbc(f[e+(r*20|0)+4>>2]|0,0,n|0,0)|0;p=J;t=q-(Y((((q-s|0)>>>(f[e+(i*20|0)+8>>2]|0))+s|0)>>>(f[e+(i*20|0)+12>>2]|0),f[e+(i*20|0)>>2]|0)|0)|0;s=t+(f[e+(i*20|0)+16>>2]|0)|0;t=n-(Y((((n-p|0)>>>(f[e+(r*20|0)+8>>2]|0))+p|0)>>>(f[e+(r*20|0)+12>>2]|0),f[e+(r*20|0)>>2]|0)|0)|0;p=t+(f[e+(r*20|0)+16>>2]|0)|0;d[a+(i<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[a+(r<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;m=m+4|0}while((m|0)<=(g|0));j=b&-4;k=n;l=h}if((j|0)<(b|0)){u=j;v=k;w=l}else{x=k;y=l;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){l=cbc(v|0,0,-130063606,0)|0;k=Kac(l|0,J|0,w|0,0)|0;l=J;cbc(k|0,0,f[e+(u*20|0)+4>>2]|0,0)|0;j=J;h=k-(Y((((k-j|0)>>>(f[e+(u*20|0)+8>>2]|0))+j|0)>>>(f[e+(u*20|0)+12>>2]|0),f[e+(u*20|0)>>2]|0)|0)|0;j=h+(f[e+(u*20|0)+16>>2]|0)|0;d[a+(u<<1)>>1]=(j+32768|0)>>>0<65536?j:(j|0)>0?32767:32768;u=u+1|0;if((u|0)==(b|0)){x=k;y=l;break}else{v=k;w=l}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function VF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=c;g=f[e>>2]|0;h=f[e+4>>2]|0;e=b+-4|0;if((b|0)<4){i=0;j=g;k=h}else{l=0;m=g;g=h;do{h=cbc(m|0,0,-130063606,0)|0;n=Kac(h|0,J|0,g|0,0)|0;h=J;o=cbc(n|0,0,-130063606,0)|0;p=Kac(o|0,J|0,h|0,0)|0;h=J;cbc(n|0,0,f[d+(l*20|0)+4>>2]|0,0)|0;o=J;q=l|1;cbc(p|0,0,f[d+(q*20|0)+4>>2]|0,0)|0;r=J;s=Y((((n-o|0)>>>(f[d+(l*20|0)+8>>2]|0))+o|0)>>>(f[d+(l*20|0)+12>>2]|0),f[d+(l*20|0)>>2]|0)|0;o=Y((((p-r|0)>>>(f[d+(q*20|0)+8>>2]|0))+r|0)>>>(f[d+(q*20|0)+12>>2]|0),f[d+(q*20|0)>>2]|0)|0;r=(f[d+(q*20|0)+16>>2]|0)+p-o|0;f[a+(l<<2)>>2]=(f[d+(l*20|0)+16>>2]|0)+n-s;f[a+(q<<2)>>2]=r;r=cbc(p|0,0,-130063606,0)|0;p=Kac(r|0,J|0,h|0,0)|0;h=J;r=cbc(p|0,0,-130063606,0)|0;m=Kac(r|0,J|0,h|0,0)|0;g=J;h=l|2;cbc(f[d+(h*20|0)+4>>2]|0,0,p|0,0)|0;r=J;q=l|3;cbc(f[d+(q*20|0)+4>>2]|0,0,m|0,0)|0;s=J;n=Y((((p-r|0)>>>(f[d+(h*20|0)+8>>2]|0))+r|0)>>>(f[d+(h*20|0)+12>>2]|0),f[d+(h*20|0)>>2]|0)|0;r=Y((((m-s|0)>>>(f[d+(q*20|0)+8>>2]|0))+s|0)>>>(f[d+(q*20|0)+12>>2]|0),f[d+(q*20|0)>>2]|0)|0;s=(f[d+(q*20|0)+16>>2]|0)+m-r|0;f[a+(h<<2)>>2]=(f[d+(h*20|0)+16>>2]|0)+p-n;f[a+(q<<2)>>2]=s;l=l+4|0}while((l|0)<=(e|0));i=b&-4;j=m;k=g}if((i|0)<(b|0)){t=i;u=j;v=k}else{w=j;x=k;y=c;z=y;f[z>>2]=w;A=y+4|0;B=A;f[B>>2]=x;return}while(1){k=cbc(u|0,0,-130063606,0)|0;j=Kac(k|0,J|0,v|0,0)|0;k=J;cbc(j|0,0,f[d+(t*20|0)+4>>2]|0,0)|0;i=J;g=Y((((j-i|0)>>>(f[d+(t*20|0)+8>>2]|0))+i|0)>>>(f[d+(t*20|0)+12>>2]|0),f[d+(t*20|0)>>2]|0)|0;f[a+(t<<2)>>2]=(f[d+(t*20|0)+16>>2]|0)+j-g;t=t+1|0;if((t|0)==(b|0)){w=j;x=k;break}else{u=j;v=k}}y=c;z=y;f[z>>2]=w;A=y+4|0;B=A;f[B>>2]=x;return}function WF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=c;g=f[e>>2]|0;h=f[e+4>>2]|0;e=b+-4|0;if((b|0)<4){i=0;j=g;k=h}else{l=0;m=g;g=h;do{h=cbc(m|0,0,-130063606,0)|0;o=Kac(h|0,J|0,g|0,0)|0;h=J;p=cbc(o|0,0,-130063606,0)|0;q=Kac(p|0,J|0,h|0,0)|0;h=J;p=cbc(q|0,0,-130063606,0)|0;r=Kac(p|0,J|0,h|0,0)|0;h=J;p=cbc(r|0,0,-130063606,0)|0;m=Kac(p|0,J|0,h|0,0)|0;g=J;n[a+(l<<2)>>2]=+(o|0)*+n[d+(l<<3)>>2]+ +n[d+(l<<3)+4>>2];o=l|1;n[a+(o<<2)>>2]=+(q|0)*+n[d+(o<<3)>>2]+ +n[d+(o<<3)+4>>2];o=l|2;n[a+(o<<2)>>2]=+(r|0)*+n[d+(o<<3)>>2]+ +n[d+(o<<3)+4>>2];o=l|3;n[a+(o<<2)>>2]=+(m|0)*+n[d+(o<<3)>>2]+ +n[d+(o<<3)+4>>2];l=l+4|0}while((l|0)<=(e|0));i=b&-4;j=m;k=g}if((i|0)<(b|0)){s=i;t=j;u=k}else{v=j;w=k;x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}while(1){k=cbc(t|0,0,-130063606,0)|0;j=Kac(k|0,J|0,u|0,0)|0;k=J;n[a+(s<<2)>>2]=+(j|0)*+n[d+(s<<3)>>2]+ +n[d+(s<<3)+4>>2];s=s+1|0;if((s|0)==(b|0)){v=j;w=k;break}else{t=j;u=k}}x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}function XF(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=c;g=f[e>>2]|0;h=f[e+4>>2]|0;e=b+-4|0;if((b|0)<4){i=0;j=g;k=h}else{l=0;m=g;g=h;do{h=cbc(m|0,0,-130063606,0)|0;n=Kac(h|0,J|0,g|0,0)|0;h=J;o=(+(h>>>0)+4294967296.0*+(n|0))*+p[d+(l<<4)>>3]+ +p[d+(l<<4)+8>>3];q=cbc(n|0,0,-130063606,0)|0;n=Kac(q|0,J|0,h|0,0)|0;h=J;q=l|1;r=(+(h>>>0)+4294967296.0*+(n|0))*+p[d+(q<<4)>>3]+ +p[d+(q<<4)+8>>3];p[a+(l<<3)>>3]=o;p[a+(q<<3)>>3]=r;q=cbc(n|0,0,-130063606,0)|0;n=Kac(q|0,J|0,h|0,0)|0;h=J;q=l|2;r=(+(h>>>0)+4294967296.0*+(n|0))*+p[d+(q<<4)>>3]+ +p[d+(q<<4)+8>>3];s=cbc(n|0,0,-130063606,0)|0;m=Kac(s|0,J|0,h|0,0)|0;g=J;h=l|3;o=(+(g>>>0)+4294967296.0*+(m|0))*+p[d+(h<<4)>>3]+ +p[d+(h<<4)+8>>3];p[a+(q<<3)>>3]=r;p[a+(h<<3)>>3]=o;l=l+4|0}while((l|0)<=(e|0));i=b&-4;j=m;k=g}if((i|0)<(b|0)){t=i;u=j;v=k}else{w=j;x=k;y=c;z=y;f[z>>2]=w;A=y+4|0;B=A;f[B>>2]=x;return}while(1){k=cbc(u|0,0,-130063606,0)|0;j=Kac(k|0,J|0,v|0,0)|0;k=J;p[a+(t<<3)>>3]=(+(k>>>0)+4294967296.0*+(j|0))*+p[d+(t<<4)>>3]+ +p[d+(t<<4)+8>>3];t=t+1|0;if((t|0)==(b|0)){w=j;x=k;break}else{u=j;v=k}}y=c;z=y;f[z>>2]=w;A=y+4|0;B=A;f[B>>2]=x;return}function YF(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=d;i=f[h>>2]|0;j=f[h+4>>2]|0;h=c+-4|0;k=(c|0)<4;if(g)if(k){l=0;m=i;n=j}else{g=0;o=i;p=j;do{q=cbc(o|0,0,-130063606,0)|0;o=Kac(q|0,J|0,p|0,0)|0;p=J;q=(o&f[e+(g<<3)>>2])+(f[e+(g<<3)+4>>2]|0)|0;r=g|1;s=(o>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;b[a+g>>0]=q>>>0<256?q:(q|0)>0?255:0;b[a+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=g|2;r=(f[e+(s<<3)>>2]&o>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=g|3;t=(f[e+(q<<3)>>2]&o>>24)+(f[e+(q<<3)+4>>2]|0)|0;b[a+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[a+q>>0]=t>>>0<256?t:(t|0)>0?255:0;g=g+4|0}while((g|0)<=(h|0));l=c&-4;m=o;n=p}else if(k){l=0;m=i;n=j}else{k=0;p=i;i=j;do{j=cbc(p|0,0,-130063606,0)|0;o=Kac(j|0,J|0,i|0,0)|0;j=J;g=(o&f[e+(k<<3)>>2])+(f[e+(k<<3)+4>>2]|0)|0;t=cbc(o|0,0,-130063606,0)|0;o=Kac(t|0,J|0,j|0,0)|0;j=J;t=k|1;q=(o&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;b[a+k>>0]=g>>>0<256?g:(g|0)>0?255:0;b[a+t>>0]=q>>>0<256?q:(q|0)>0?255:0;q=cbc(o|0,0,-130063606,0)|0;o=Kac(q|0,J|0,j|0,0)|0;j=J;q=k|2;t=(o&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;g=cbc(o|0,0,-130063606,0)|0;p=Kac(g|0,J|0,j|0,0)|0;i=J;j=k|3;g=(p&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;b[a+q>>0]=t>>>0<256?t:(t|0)>0?255:0;b[a+j>>0]=g>>>0<256?g:(g|0)>0?255:0;k=k+4|0}while((k|0)<=(h|0));l=c&-4;m=p;n=i}if((l|0)<(c|0)){u=l;v=m;w=n}else{x=m;y=n;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){n=cbc(v|0,0,-130063606,0)|0;m=Kac(n|0,J|0,w|0,0)|0;n=J;l=(m&f[e+(u<<3)>>2])+(f[e+(u<<3)+4>>2]|0)|0;b[a+u>>0]=l>>>0<256?l:(l|0)>0?255:0;u=u+1|0;if((u|0)==(c|0)){x=m;y=n;break}else{v=m;w=n}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function ZF(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=d;i=f[h>>2]|0;j=f[h+4>>2]|0;h=c+-4|0;k=(c|0)<4;if(g)if(k){l=0;m=i;n=j}else{g=0;o=i;p=j;do{q=cbc(o|0,0,-130063606,0)|0;o=Kac(q|0,J|0,p|0,0)|0;p=J;q=(o&f[e+(g<<3)>>2])+(f[e+(g<<3)+4>>2]|0)|0;r=g|1;s=(o>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;b[a+g>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[a+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=g|2;r=(f[e+(s<<3)>>2]&o>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=g|3;t=(f[e+(q<<3)>>2]&o>>24)+(f[e+(q<<3)+4>>2]|0)|0;b[a+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;b[a+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;g=g+4|0}while((g|0)<=(h|0));l=c&-4;m=o;n=p}else if(k){l=0;m=i;n=j}else{k=0;p=i;i=j;do{j=cbc(p|0,0,-130063606,0)|0;o=Kac(j|0,J|0,i|0,0)|0;j=J;g=(o&f[e+(k<<3)>>2])+(f[e+(k<<3)+4>>2]|0)|0;t=cbc(o|0,0,-130063606,0)|0;o=Kac(t|0,J|0,j|0,0)|0;j=J;t=k|1;q=(o&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;b[a+k>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;b[a+t>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;q=cbc(o|0,0,-130063606,0)|0;o=Kac(q|0,J|0,j|0,0)|0;j=J;q=k|2;t=(o&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;g=cbc(o|0,0,-130063606,0)|0;p=Kac(g|0,J|0,j|0,0)|0;i=J;j=k|3;g=(p&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;b[a+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;b[a+j>>0]=(g+128|0)>>>0<256?g:(g|0)>0?127:128;k=k+4|0}while((k|0)<=(h|0));l=c&-4;m=p;n=i}if((l|0)<(c|0)){u=l;v=m;w=n}else{x=m;y=n;z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){n=cbc(v|0,0,-130063606,0)|0;m=Kac(n|0,J|0,w|0,0)|0;n=J;l=(m&f[e+(u<<3)>>2])+(f[e+(u<<3)+4>>2]|0)|0;b[a+u>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;u=u+1|0;if((u|0)==(c|0)){x=m;y=n;break}else{v=m;w=n}}z=d;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function _F(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=c;i=f[h>>2]|0;j=f[h+4>>2]|0;h=b+-4|0;k=(b|0)<4;if(g)if(k){l=0;m=i;n=j}else{g=0;o=i;p=j;do{q=cbc(o|0,0,-130063606,0)|0;o=Kac(q|0,J|0,p|0,0)|0;p=J;q=(o&f[e+(g<<3)>>2])+(f[e+(g<<3)+4>>2]|0)|0;r=g|1;s=(o>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;d[a+(g<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d[a+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=g|2;r=(f[e+(s<<3)>>2]&o>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=g|3;t=(f[e+(q<<3)>>2]&o>>24)+(f[e+(q<<3)+4>>2]|0)|0;d[a+(s<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d[a+(q<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;g=g+4|0}while((g|0)<=(h|0));l=b&-4;m=o;n=p}else if(k){l=0;m=i;n=j}else{k=0;p=i;i=j;do{j=cbc(p|0,0,-130063606,0)|0;o=Kac(j|0,J|0,i|0,0)|0;j=J;g=(o&f[e+(k<<3)>>2])+(f[e+(k<<3)+4>>2]|0)|0;t=cbc(o|0,0,-130063606,0)|0;o=Kac(t|0,J|0,j|0,0)|0;j=J;t=k|1;q=(o&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;d[a+(k<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;d[a+(t<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;q=cbc(o|0,0,-130063606,0)|0;o=Kac(q|0,J|0,j|0,0)|0;j=J;q=k|2;t=(o&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;g=cbc(o|0,0,-130063606,0)|0;p=Kac(g|0,J|0,j|0,0)|0;i=J;j=k|3;g=(p&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;d[a+(q<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[a+(j<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;k=k+4|0}while((k|0)<=(h|0));l=b&-4;m=p;n=i}if((l|0)<(b|0)){u=l;v=m;w=n}else{x=m;y=n;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){n=cbc(v|0,0,-130063606,0)|0;m=Kac(n|0,J|0,w|0,0)|0;n=J;l=(m&f[e+(u<<3)>>2])+(f[e+(u<<3)+4>>2]|0)|0;d[a+(u<<1)>>1]=l>>>0<65536?l:(l|0)>0?65535:0;u=u+1|0;if((u|0)==(b|0)){x=m;y=n;break}else{v=m;w=n}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function $F(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=c;i=f[h>>2]|0;j=f[h+4>>2]|0;h=b+-4|0;k=(b|0)<4;if(g)if(k){l=0;m=i;n=j}else{g=0;o=i;p=j;do{q=cbc(o|0,0,-130063606,0)|0;o=Kac(q|0,J|0,p|0,0)|0;p=J;q=(o&f[e+(g<<3)>>2])+(f[e+(g<<3)+4>>2]|0)|0;r=g|1;s=(o>>8&f[e+(r<<3)>>2])+(f[e+(r<<3)+4>>2]|0)|0;d[a+(g<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;d[a+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=g|2;r=(f[e+(s<<3)>>2]&o>>16)+(f[e+(s<<3)+4>>2]|0)|0;q=g|3;t=(f[e+(q<<3)>>2]&o>>24)+(f[e+(q<<3)+4>>2]|0)|0;d[a+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[a+(q<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;g=g+4|0}while((g|0)<=(h|0));l=b&-4;m=o;n=p}else if(k){l=0;m=i;n=j}else{k=0;p=i;i=j;do{j=cbc(p|0,0,-130063606,0)|0;o=Kac(j|0,J|0,i|0,0)|0;j=J;g=(o&f[e+(k<<3)>>2])+(f[e+(k<<3)+4>>2]|0)|0;t=cbc(o|0,0,-130063606,0)|0;o=Kac(t|0,J|0,j|0,0)|0;j=J;t=k|1;q=(o&f[e+(t<<3)>>2])+(f[e+(t<<3)+4>>2]|0)|0;d[a+(k<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;d[a+(t<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;q=cbc(o|0,0,-130063606,0)|0;o=Kac(q|0,J|0,j|0,0)|0;j=J;q=k|2;t=(o&f[e+(q<<3)>>2])+(f[e+(q<<3)+4>>2]|0)|0;g=cbc(o|0,0,-130063606,0)|0;p=Kac(g|0,J|0,j|0,0)|0;i=J;j=k|3;g=(p&f[e+(j<<3)>>2])+(f[e+(j<<3)+4>>2]|0)|0;d[a+(q<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[a+(j<<1)>>1]=(g+32768|0)>>>0<65536?g:(g|0)>0?32767:32768;k=k+4|0}while((k|0)<=(h|0));l=b&-4;m=p;n=i}if((l|0)<(b|0)){u=l;v=m;w=n}else{x=m;y=n;z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}while(1){n=cbc(v|0,0,-130063606,0)|0;m=Kac(n|0,J|0,w|0,0)|0;n=J;l=(m&f[e+(u<<3)>>2])+(f[e+(u<<3)+4>>2]|0)|0;d[a+(u<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;u=u+1|0;if((u|0)==(b|0)){x=m;y=n;break}else{v=m;w=n}}z=c;A=z;f[A>>2]=x;B=z+4|0;C=B;f[C>>2]=y;return}function aG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=c;h=f[g>>2]|0;i=f[g+4>>2]|0;g=b+-4|0;j=(b|0)<4;if(e)if(j){k=0;l=h;m=i}else{e=0;n=h;o=i;do{p=cbc(n|0,0,-130063606,0)|0;n=Kac(p|0,J|0,o|0,0)|0;o=J;p=e|1;q=(n>>8&f[d+(p<<3)>>2])+(f[d+(p<<3)+4>>2]|0)|0;f[a+(e<<2)>>2]=(n&f[d+(e<<3)>>2])+(f[d+(e<<3)+4>>2]|0);f[a+(p<<2)>>2]=q;q=e|2;p=e|3;r=(f[d+(p<<3)>>2]&n>>24)+(f[d+(p<<3)+4>>2]|0)|0;f[a+(q<<2)>>2]=(f[d+(q<<3)>>2]&n>>16)+(f[d+(q<<3)+4>>2]|0);f[a+(p<<2)>>2]=r;e=e+4|0}while((e|0)<=(g|0));k=b&-4;l=n;m=o}else if(j){k=0;l=h;m=i}else{j=0;o=h;h=i;do{i=cbc(o|0,0,-130063606,0)|0;n=Kac(i|0,J|0,h|0,0)|0;i=J;e=(n&f[d+(j<<3)>>2])+(f[d+(j<<3)+4>>2]|0)|0;r=cbc(n|0,0,-130063606,0)|0;n=Kac(r|0,J|0,i|0,0)|0;i=J;r=j|1;p=(n&f[d+(r<<3)>>2])+(f[d+(r<<3)+4>>2]|0)|0;f[a+(j<<2)>>2]=e;f[a+(r<<2)>>2]=p;p=cbc(n|0,0,-130063606,0)|0;n=Kac(p|0,J|0,i|0,0)|0;i=J;p=j|2;r=(n&f[d+(p<<3)>>2])+(f[d+(p<<3)+4>>2]|0)|0;e=cbc(n|0,0,-130063606,0)|0;o=Kac(e|0,J|0,i|0,0)|0;h=J;i=j|3;e=(o&f[d+(i<<3)>>2])+(f[d+(i<<3)+4>>2]|0)|0;f[a+(p<<2)>>2]=r;f[a+(i<<2)>>2]=e;j=j+4|0}while((j|0)<=(g|0));k=b&-4;l=o;m=h}if((k|0)<(b|0)){s=k;t=l;u=m}else{v=l;w=m;x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}while(1){m=cbc(t|0,0,-130063606,0)|0;l=Kac(m|0,J|0,u|0,0)|0;m=J;f[a+(s<<2)>>2]=(l&f[d+(s<<3)>>2])+(f[d+(s<<3)+4>>2]|0);s=s+1|0;if((s|0)==(b|0)){v=l;w=m;break}else{t=l;u=m}}x=c;y=x;f[y>>2]=v;z=x+4|0;A=z;f[A>>2]=w;return}function bG(){return qO(pO()|0)|0}function cG(a){a=a|0;var b=0,c=0;b=(a|0)!=0;c=qO(pO()|0)|0;f[c>>2]=b?a:-1;f[c+4>>2]=b?((a|0)<0)<<31>>31:0;return}function dG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;dQ(e,40796);IF(qO(pO()|0)|0,a,0,b,c,0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function eG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;dQ(e,40816);IF(qO(pO()|0)|0,a,1,b,c,0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function fG(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+1184|0;e=d+1168|0;g=d+1112|0;h=d+1104|0;i=d+1096|0;j=d+1064|0;k=d;dQ(e,40836);do if((yM(c)|0)==65536){l=f[c+4>>2]|0;f[g>>2]=f[l>>2];m=g+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=g+8|0;f[o>>2]=f[l+8>>2];f[g+12>>2]=f[l+12>>2];f[g+16>>2]=f[l+16>>2];f[g+20>>2]=f[l+20>>2];f[g+24>>2]=f[l+24>>2];f[g+28>>2]=f[l+28>>2];f[g+32>>2]=f[l+32>>2];q=f[l+36>>2]|0;f[g+36>>2]=q;f[g+40>>2]=o;o=g+48|0;r=g+44|0;f[r>>2]=o;f[o>>2]=0;f[g+52>>2]=0;if(q|0){o=q+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];s=g;break}else{f[m>>2]=0;jL(g,l);s=g;break}}else{yL(g,c,-1);s=g}while(0);c=f[s>>2]|0;s=c>>>3&511;l=s+1|0;m=c&7;c=f[40856+(m<<2)>>2]|0;if(!((m|0)!=7&l>>>0<5)){f[h>>2]=0;f[h+4>>2]=0;n=aD(h,20)|0;o=175454;r=n+20|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(r|0));bO(-215,h,427522,175475,1199);bD(h)}f[h>>2]=g;f[h+4>>2]=0;RN(j,h,i,-1);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+28>>2]=0;h=f[j+20>>2]|0;o=k+8|0;f[k>>2]=o;n=k+4|0;f[n>>2]=264;r=m>>>0<4;if(r){q=m>>>0<2?8388608:32768;m=(q|0)<(h|0)?q:h;f[n>>2]=l;if(l>>>0>264){t=N5b(l<<2)|0;f[k>>2]=t;v=t}else v=o;Nac(v|0,0,(s<<2)+4|0)|0;s=f[g+4>>2]|0;if((s|0)>0){w=m;x=q;y=f[(f[g+44>>2]|0)+(s+-1<<2)>>2]|0;z=v}else{w=m;x=q;y=0;z=v}}else{w=h;x=0;y=0;z=a}v=j+16|0;a:do if((h|0)>0){q=0;m=0;while(1){if(q>>>0>=(f[v>>2]|0)>>>0)break a;s=q+1|0;t=f[i>>2]|0;if(r){A=0;B=m;C=t;while(1){D=h-A|0;E=(w|0)<(D|0)?w:D;nh[c&127](C,0,z,E,l)|0;D=E+B|0;if((D+w|0)<(x|0)?((E+A|0)<(h|0)?1:s>>>0<(f[v>>2]|0)>>>0):0)F=D;else{G=0;H=23}if((H|0)==23)while(1){H=0;D=z+(G<<2)|0;I=a+(G<<3)|0;p[I>>3]=+p[I>>3]+ +(f[D>>2]|0);f[D>>2]=0;G=G+1|0;if((G|0)==(l|0)){F=0;break}else H=23}D=Y(E,y)|0;C=(f[i>>2]|0)+D|0;f[i>>2]=C;A=A+w|0;if((h|0)<=(A|0)){J=F;break}else B=F}}else{B=0;A=m;C=t;while(1){D=h-B|0;I=(w|0)<(D|0)?w:D;nh[c&127](C,0,z,I,l)|0;D=I+A|0;K=Y(I,y)|0;C=(f[i>>2]|0)+K|0;f[i>>2]=C;B=B+w|0;if((h|0)<=(B|0)){J=D;break}else A=D}}aL(j)|0;q=s;m=J}}else{m=0;while(1){if(m>>>0>=(f[v>>2]|0)>>>0)break a;aL(j)|0;m=m+1|0}}while(0);j=f[k>>2]|0;if((j|0)!=(o|0)){if(j|0)P5b(j);f[k>>2]=o;f[n>>2]=264}n=g+36|0;o=f[n>>2]|0;if(o|0?(k=o+12|0,o=f[k>>2]|0,f[k>>2]=o+-1,(o|0)==1):0)kL(g);f[n>>2]=0;n=g+16|0;o=g+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[o>>2]|0)>0){n=f[g+40>>2]|0;k=0;do{f[n+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[o>>2]|0))}o=f[g+44>>2]|0;if((o|0)!=(g+48|0))UC(o);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function gG(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;if(!c){i=(g|0)%4|0;switch(i|0){case 1:{j=f[d>>2]|0;k=e+-4|0;if((e|0)<4){l=a;m=j;n=0}else{o=g<<1;p=g*3|0;q=g<<2;r=e&-4;s=a;t=j;j=0;while(1){t=(h[s>>0]|0)+t+(h[s+g>>0]|0)+(h[s+o>>0]|0)+(h[s+p>>0]|0)|0;j=j+4|0;if((j|0)>(k|0))break;else s=s+q|0}l=a+(Y(r,g)|0)|0;m=t;n=r}if((n|0)<(e|0)){r=m;t=n;q=l;while(1){l=(h[q>>0]|0)+r|0;t=t+1|0;if((t|0)==(e|0)){u=l;v=e;break}else{r=l;q=q+g|0}}}else{u=m;v=n}f[d>>2]=u;w=v;break}case 2:{v=f[d>>2]|0;u=d+4|0;n=f[u>>2]|0;if((e|0)>0){m=n;q=v;r=0;t=a;while(1){l=(h[t>>0]|0)+q|0;s=(h[t+1>>0]|0)+m|0;r=r+1|0;if((r|0)==(e|0)){x=s;y=l;z=e;break}else{m=s;q=l;t=t+g|0}}}else{x=n;y=v;z=0}f[d>>2]=y;f[u>>2]=x;w=z;break}case 3:{z=f[d>>2]|0;x=d+4|0;u=f[x>>2]|0;y=d+8|0;v=f[y>>2]|0;if((e|0)>0){n=v;t=u;q=z;m=0;r=a;while(1){l=(h[r>>0]|0)+q|0;s=(h[r+1>>0]|0)+t|0;k=(h[r+2>>0]|0)+n|0;m=m+1|0;if((m|0)==(e|0)){A=k;B=s;C=l;D=e;break}else{n=k;t=s;q=l;r=r+g|0}}}else{A=v;B=u;C=z;D=0}f[d>>2]=C;f[x>>2]=B;f[y>>2]=A;w=D;break}default:w=0}if((i|0)<(g|0)){E=i;F=w}else{G=e;return G|0}while(1){w=d+(E<<2)|0;i=f[w>>2]|0;D=d+(E+1<<2)|0;A=f[D>>2]|0;y=d+(E+2<<2)|0;B=f[y>>2]|0;x=d+(E+3<<2)|0;C=f[x>>2]|0;if((F|0)<(e|0)){z=C;u=B;v=A;r=i;q=a+(Y(F,g)|0)+E|0;t=F;while(1){n=(h[q>>0]|0)+r|0;m=(h[q+1>>0]|0)+v|0;l=(h[q+2>>0]|0)+u|0;s=(h[q+3>>0]|0)+z|0;t=t+1|0;if((t|0)==(e|0)){H=s;I=l;J=m;K=n;L=e;break}else{z=s;u=l;v=m;r=n;q=q+g|0}}}else{H=C;I=B;J=A;K=i;L=F}f[w>>2]=K;f[D>>2]=J;f[y>>2]=I;f[x>>2]=H;E=E+4|0;if((E|0)>=(g|0)){G=e;break}else F=L}return G|0}switch(g|0){case 1:{L=f[d>>2]|0;if((e|0)>0){F=L;E=0;H=0;while(1){if(!(b[c+H>>0]|0)){M=F;N=E}else{M=(h[a+H>>0]|0)+F|0;N=E+1|0}H=H+1|0;if((H|0)==(e|0)){O=M;P=N;break}else{F=M;E=N}}}else{O=L;P=0}f[d>>2]=O;G=P;return G|0}case 3:{P=f[d>>2]|0;O=d+4|0;L=f[O>>2]|0;N=d+8|0;E=f[N>>2]|0;if((e|0)>0){M=E;F=L;H=P;I=0;J=0;K=a;while(1){if(!(b[c+I>>0]|0)){Q=M;R=F;S=H;T=J}else{Q=(h[K+2>>0]|0)+M|0;R=(h[K+1>>0]|0)+F|0;S=(h[K>>0]|0)+H|0;T=J+1|0}I=I+1|0;if((I|0)==(e|0)){U=Q;V=R;W=S;X=T;break}else{M=Q;F=R;H=S;J=T;K=K+3|0}}}else{U=E;V=L;W=P;X=0}f[d>>2]=W;f[O>>2]=V;f[N>>2]=U;G=X;return G|0}default:{if((e|0)<=0){G=0;return G|0}X=g+-4|0;if((g|0)<4){if((g|0)>0){Z=0;_=0;$=a}else{U=0;N=0;while(1){V=N+((b[c+U>>0]|0)!=0&1)|0;U=U+1|0;if((U|0)==(e|0)){G=V;break}else N=V}return G|0}while(1){if(!(b[c+Z>>0]|0))aa=_;else{N=0;do{U=d+(N<<2)|0;f[U>>2]=(f[U>>2]|0)+(h[$+N>>0]|0);N=N+1|0}while((N|0)!=(g|0));aa=_+1|0}Z=Z+1|0;if((Z|0)==(e|0)){G=aa;break}else{_=aa;$=$+g|0}}return G|0}$=g&-4;if(($|0)<(g|0)){ba=0;ca=0;da=a}else{aa=0;_=0;Z=a;while(1){if(!(b[c+aa>>0]|0))ea=_;else{a=0;do{N=d+(a<<2)|0;x=a|1;y=d+(x<<2)|0;D=(h[Z+x>>0]|0)+(f[y>>2]|0)|0;f[N>>2]=(h[Z+a>>0]|0)+(f[N>>2]|0);f[y>>2]=D;D=a|2;y=d+(D<<2)|0;N=a|3;x=d+(N<<2)|0;w=(h[Z+N>>0]|0)+(f[x>>2]|0)|0;f[y>>2]=(h[Z+D>>0]|0)+(f[y>>2]|0);f[x>>2]=w;a=a+4|0}while((a|0)<=(X|0));ea=_+1|0}aa=aa+1|0;if((aa|0)==(e|0)){G=ea;break}else{_=ea;Z=Z+g|0}}return G|0}while(1){if(!(b[c+ba>>0]|0))fa=ca;else{Z=0;do{ea=d+(Z<<2)|0;_=Z|1;aa=d+(_<<2)|0;a=(h[da+_>>0]|0)+(f[aa>>2]|0)|0;f[ea>>2]=(h[da+Z>>0]|0)+(f[ea>>2]|0);f[aa>>2]=a;a=Z|2;aa=d+(a<<2)|0;ea=Z|3;_=d+(ea<<2)|0;w=(h[da+ea>>0]|0)+(f[_>>2]|0)|0;f[aa>>2]=(h[da+a>>0]|0)+(f[aa>>2]|0);f[_>>2]=w;Z=Z+4|0}while((Z|0)<=(X|0));ga=$;do{Z=d+(ga<<2)|0;f[Z>>2]=(f[Z>>2]|0)+(h[da+ga>>0]|0);ga=ga+1|0}while((ga|0)!=(g|0));fa=ca+1|0}ba=ba+1|0;if((ba|0)==(e|0)){G=fa;break}else{ca=fa;da=da+g|0}}return G|0}}return 0}function hG(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=f[d>>2]|0;j=e+-4|0;if((e|0)<4){k=a;l=i;m=0}else{n=g<<1;o=g*3|0;p=g<<2;q=e&-4;r=a;s=i;i=0;while(1){s=(b[r>>0]|0)+s+(b[r+g>>0]|0)+(b[r+n>>0]|0)+(b[r+o>>0]|0)|0;i=i+4|0;if((i|0)>(j|0))break;else r=r+p|0}k=a+(Y(q,g)|0)|0;l=s;m=q}if((m|0)<(e|0)){q=l;s=m;p=k;while(1){k=(b[p>>0]|0)+q|0;s=s+1|0;if((s|0)==(e|0)){t=k;u=e;break}else{q=k;p=p+g|0}}}else{t=l;u=m}f[d>>2]=t;v=u;break}case 2:{u=f[d>>2]|0;t=d+4|0;m=f[t>>2]|0;if((e|0)>0){l=m;p=u;q=0;s=a;while(1){k=(b[s>>0]|0)+p|0;r=(b[s+1>>0]|0)+l|0;q=q+1|0;if((q|0)==(e|0)){w=r;x=k;y=e;break}else{l=r;p=k;s=s+g|0}}}else{w=m;x=u;y=0}f[d>>2]=x;f[t>>2]=w;v=y;break}case 3:{y=f[d>>2]|0;w=d+4|0;t=f[w>>2]|0;x=d+8|0;u=f[x>>2]|0;if((e|0)>0){m=u;s=t;p=y;l=0;q=a;while(1){k=(b[q>>0]|0)+p|0;r=(b[q+1>>0]|0)+s|0;j=(b[q+2>>0]|0)+m|0;l=l+1|0;if((l|0)==(e|0)){z=j;A=r;B=k;C=e;break}else{m=j;s=r;p=k;q=q+g|0}}}else{z=u;A=t;B=y;C=0}f[d>>2]=B;f[w>>2]=A;f[x>>2]=z;v=C;break}default:v=0}if((h|0)<(g|0)){D=h;E=v}else{F=e;return F|0}while(1){v=d+(D<<2)|0;h=f[v>>2]|0;C=d+(D+1<<2)|0;z=f[C>>2]|0;x=d+(D+2<<2)|0;A=f[x>>2]|0;w=d+(D+3<<2)|0;B=f[w>>2]|0;if((E|0)<(e|0)){y=B;t=A;u=z;q=h;p=a+(Y(E,g)|0)+D|0;s=E;while(1){m=(b[p>>0]|0)+q|0;l=(b[p+1>>0]|0)+u|0;k=(b[p+2>>0]|0)+t|0;r=(b[p+3>>0]|0)+y|0;s=s+1|0;if((s|0)==(e|0)){G=r;H=k;I=l;J=m;K=e;break}else{y=r;t=k;u=l;q=m;p=p+g|0}}}else{G=B;H=A;I=z;J=h;K=E}f[v>>2]=J;f[C>>2]=I;f[x>>2]=H;f[w>>2]=G;D=D+4|0;if((D|0)>=(g|0)){F=e;break}else E=K}return F|0}switch(g|0){case 1:{K=f[d>>2]|0;if((e|0)>0){E=K;D=0;G=0;while(1){if(!(b[c+G>>0]|0)){L=E;M=D}else{L=(b[a+G>>0]|0)+E|0;M=D+1|0}G=G+1|0;if((G|0)==(e|0)){N=L;O=M;break}else{E=L;D=M}}}else{N=K;O=0}f[d>>2]=N;F=O;return F|0}case 3:{O=f[d>>2]|0;N=d+4|0;K=f[N>>2]|0;M=d+8|0;D=f[M>>2]|0;if((e|0)>0){L=D;E=K;G=O;H=0;I=0;J=a;while(1){if(!(b[c+H>>0]|0)){P=L;Q=E;R=G;S=I}else{P=(b[J+2>>0]|0)+L|0;Q=(b[J+1>>0]|0)+E|0;R=(b[J>>0]|0)+G|0;S=I+1|0}H=H+1|0;if((H|0)==(e|0)){T=P;U=Q;V=R;W=S;break}else{L=P;E=Q;G=R;I=S;J=J+3|0}}}else{T=D;U=K;V=O;W=0}f[d>>2]=V;f[N>>2]=U;f[M>>2]=T;F=W;return F|0}default:{if((e|0)<=0){F=0;return F|0}W=g+-4|0;if((g|0)<4){if((g|0)>0){X=0;Z=0;_=a}else{T=0;M=0;while(1){U=M+((b[c+T>>0]|0)!=0&1)|0;T=T+1|0;if((T|0)==(e|0)){F=U;break}else M=U}return F|0}while(1){if(!(b[c+X>>0]|0))$=Z;else{M=0;do{T=d+(M<<2)|0;f[T>>2]=(f[T>>2]|0)+(b[_+M>>0]|0);M=M+1|0}while((M|0)!=(g|0));$=Z+1|0}X=X+1|0;if((X|0)==(e|0)){F=$;break}else{Z=$;_=_+g|0}}return F|0}_=g&-4;if((_|0)<(g|0)){aa=0;ba=0;ca=a}else{$=0;Z=0;X=a;while(1){if(!(b[c+$>>0]|0))da=Z;else{a=0;do{M=d+(a<<2)|0;w=a|1;x=d+(w<<2)|0;C=(b[X+w>>0]|0)+(f[x>>2]|0)|0;f[M>>2]=(b[X+a>>0]|0)+(f[M>>2]|0);f[x>>2]=C;C=a|2;x=d+(C<<2)|0;M=a|3;w=d+(M<<2)|0;v=(b[X+M>>0]|0)+(f[w>>2]|0)|0;f[x>>2]=(b[X+C>>0]|0)+(f[x>>2]|0);f[w>>2]=v;a=a+4|0}while((a|0)<=(W|0));da=Z+1|0}$=$+1|0;if(($|0)==(e|0)){F=da;break}else{Z=da;X=X+g|0}}return F|0}while(1){if(!(b[c+aa>>0]|0))ea=ba;else{X=0;do{da=d+(X<<2)|0;Z=X|1;$=d+(Z<<2)|0;a=(b[ca+Z>>0]|0)+(f[$>>2]|0)|0;f[da>>2]=(b[ca+X>>0]|0)+(f[da>>2]|0);f[$>>2]=a;a=X|2;$=d+(a<<2)|0;da=X|3;Z=d+(da<<2)|0;v=(b[ca+da>>0]|0)+(f[Z>>2]|0)|0;f[$>>2]=(b[ca+a>>0]|0)+(f[$>>2]|0);f[Z>>2]=v;X=X+4|0}while((X|0)<=(W|0));fa=_;do{X=d+(fa<<2)|0;f[X>>2]=(f[X>>2]|0)+(b[ca+fa>>0]|0);fa=fa+1|0}while((fa|0)!=(g|0));ea=ba+1|0}aa=aa+1|0;if((aa|0)==(e|0)){F=ea;break}else{ba=ea;ca=ca+g|0}}return F|0}}return 0}function iG(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=f[d>>2]|0;k=e+-4|0;if((e|0)<4){l=a;m=i;n=0}else{o=g<<1;p=g*3|0;q=g<<2;r=k>>>2;s=Y((r<<3)+8|0,g)|0;t=a;u=i;i=0;while(1){u=(j[t>>1]|0)+u+(j[t+(g<<1)>>1]|0)+(j[t+(o<<1)>>1]|0)+(j[t+(p<<1)>>1]|0)|0;i=i+4|0;if((i|0)>(k|0))break;else t=t+(q<<1)|0}l=a+s|0;m=u;n=(r<<2)+4|0}if((n|0)<(e|0)){r=m;u=n;s=l;while(1){l=(j[s>>1]|0)+r|0;u=u+1|0;if((u|0)==(e|0)){v=l;w=e;break}else{r=l;s=s+(g<<1)|0}}}else{v=m;w=n}f[d>>2]=v;x=w;break}case 2:{w=f[d>>2]|0;v=d+4|0;n=f[v>>2]|0;if((e|0)>0){m=n;s=w;r=0;u=a;while(1){l=(j[u>>1]|0)+s|0;q=(j[u+2>>1]|0)+m|0;r=r+1|0;if((r|0)==(e|0)){y=q;z=l;A=e;break}else{m=q;s=l;u=u+(g<<1)|0}}}else{y=n;z=w;A=0}f[d>>2]=z;f[v>>2]=y;x=A;break}case 3:{A=f[d>>2]|0;y=d+4|0;v=f[y>>2]|0;z=d+8|0;w=f[z>>2]|0;if((e|0)>0){n=w;u=v;s=A;m=0;r=a;while(1){l=(j[r>>1]|0)+s|0;q=(j[r+2>>1]|0)+u|0;t=(j[r+4>>1]|0)+n|0;m=m+1|0;if((m|0)==(e|0)){B=t;C=q;D=l;E=e;break}else{n=t;u=q;s=l;r=r+(g<<1)|0}}}else{B=w;C=v;D=A;E=0}f[d>>2]=D;f[y>>2]=C;f[z>>2]=B;x=E;break}default:x=0}if((h|0)<(g|0)){F=h;G=x}else{H=e;return H|0}while(1){x=d+(F<<2)|0;h=f[x>>2]|0;E=d+(F+1<<2)|0;B=f[E>>2]|0;z=d+(F+2<<2)|0;C=f[z>>2]|0;y=d+(F+3<<2)|0;D=f[y>>2]|0;if((G|0)<(e|0)){A=D;v=C;w=B;r=h;s=a+((Y(G,g)|0)<<1)+(F<<1)|0;u=G;while(1){n=(j[s>>1]|0)+r|0;m=(j[s+2>>1]|0)+w|0;l=(j[s+4>>1]|0)+v|0;q=(j[s+6>>1]|0)+A|0;u=u+1|0;if((u|0)==(e|0)){I=q;J=l;K=m;L=n;M=e;break}else{A=q;v=l;w=m;r=n;s=s+(g<<1)|0}}}else{I=D;J=C;K=B;L=h;M=G}f[x>>2]=L;f[E>>2]=K;f[z>>2]=J;f[y>>2]=I;F=F+4|0;if((F|0)>=(g|0)){H=e;break}else G=M}return H|0}switch(g|0){case 1:{M=f[d>>2]|0;if((e|0)>0){G=M;F=0;I=0;while(1){if(!(b[c+I>>0]|0)){N=G;O=F}else{N=(j[a+(I<<1)>>1]|0)+G|0;O=F+1|0}I=I+1|0;if((I|0)==(e|0)){P=N;Q=O;break}else{G=N;F=O}}}else{P=M;Q=0}f[d>>2]=P;H=Q;return H|0}case 3:{Q=f[d>>2]|0;P=d+4|0;M=f[P>>2]|0;O=d+8|0;F=f[O>>2]|0;if((e|0)>0){N=F;G=M;I=Q;J=0;K=0;L=a;while(1){if(!(b[c+J>>0]|0)){R=N;S=G;T=I;U=K}else{R=(j[L+4>>1]|0)+N|0;S=(j[L+2>>1]|0)+G|0;T=(j[L>>1]|0)+I|0;U=K+1|0}J=J+1|0;if((J|0)==(e|0)){V=R;W=S;X=T;Z=U;break}else{N=R;G=S;I=T;K=U;L=L+6|0}}}else{V=F;W=M;X=Q;Z=0}f[d>>2]=X;f[P>>2]=W;f[O>>2]=V;H=Z;return H|0}default:{if((e|0)<=0){H=0;return H|0}Z=g+-4|0;if((g|0)<4){if((g|0)>0){_=0;$=0;aa=a}else{V=0;O=0;while(1){W=O+((b[c+V>>0]|0)!=0&1)|0;V=V+1|0;if((V|0)==(e|0)){H=W;break}else O=W}return H|0}while(1){if(!(b[c+_>>0]|0))ba=$;else{O=0;do{V=d+(O<<2)|0;f[V>>2]=(f[V>>2]|0)+(j[aa+(O<<1)>>1]|0);O=O+1|0}while((O|0)!=(g|0));ba=$+1|0}_=_+1|0;if((_|0)==(e|0)){H=ba;break}else{$=ba;aa=aa+(g<<1)|0}}return H|0}aa=g&-4;if((aa|0)<(g|0)){ca=0;da=0;ea=a}else{ba=0;$=0;_=a;while(1){if(!(b[c+ba>>0]|0))fa=$;else{a=0;do{O=d+(a<<2)|0;y=a|1;z=d+(y<<2)|0;E=(j[_+(y<<1)>>1]|0)+(f[z>>2]|0)|0;f[O>>2]=(j[_+(a<<1)>>1]|0)+(f[O>>2]|0);f[z>>2]=E;E=a|2;z=d+(E<<2)|0;O=a|3;y=d+(O<<2)|0;x=(j[_+(O<<1)>>1]|0)+(f[y>>2]|0)|0;f[z>>2]=(j[_+(E<<1)>>1]|0)+(f[z>>2]|0);f[y>>2]=x;a=a+4|0}while((a|0)<=(Z|0));fa=$+1|0}ba=ba+1|0;if((ba|0)==(e|0)){H=fa;break}else{$=fa;_=_+(g<<1)|0}}return H|0}while(1){if(!(b[c+ca>>0]|0))ga=da;else{_=0;do{fa=d+(_<<2)|0;$=_|1;ba=d+($<<2)|0;a=(j[ea+($<<1)>>1]|0)+(f[ba>>2]|0)|0;f[fa>>2]=(j[ea+(_<<1)>>1]|0)+(f[fa>>2]|0);f[ba>>2]=a;a=_|2;ba=d+(a<<2)|0;fa=_|3;$=d+(fa<<2)|0;x=(j[ea+(fa<<1)>>1]|0)+(f[$>>2]|0)|0;f[ba>>2]=(j[ea+(a<<1)>>1]|0)+(f[ba>>2]|0);f[$>>2]=x;_=_+4|0}while((_|0)<=(Z|0));ha=aa;do{_=d+(ha<<2)|0;f[_>>2]=(f[_>>2]|0)+(j[ea+(ha<<1)>>1]|0);ha=ha+1|0}while((ha|0)!=(g|0));ga=da+1|0}ca=ca+1|0;if((ca|0)==(e|0)){H=ga;break}else{da=ga;ea=ea+(g<<1)|0}}return H|0}}return 0}function jG(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;if(!c){i=(h|0)%4|0;switch(i|0){case 1:{j=f[e>>2]|0;k=g+-4|0;if((g|0)<4){l=a;m=j;n=0}else{o=h<<1;p=h*3|0;q=h<<2;r=k>>>2;s=Y((r<<3)+8|0,h)|0;t=a;u=j;j=0;while(1){u=(d[t>>1]|0)+u+(d[t+(h<<1)>>1]|0)+(d[t+(o<<1)>>1]|0)+(d[t+(p<<1)>>1]|0)|0;j=j+4|0;if((j|0)>(k|0))break;else t=t+(q<<1)|0}l=a+s|0;m=u;n=(r<<2)+4|0}if((n|0)<(g|0)){r=m;u=n;s=l;while(1){l=(d[s>>1]|0)+r|0;u=u+1|0;if((u|0)==(g|0)){v=l;w=g;break}else{r=l;s=s+(h<<1)|0}}}else{v=m;w=n}f[e>>2]=v;x=w;break}case 2:{w=f[e>>2]|0;v=e+4|0;n=f[v>>2]|0;if((g|0)>0){m=n;s=w;r=0;u=a;while(1){l=(d[u>>1]|0)+s|0;q=(d[u+2>>1]|0)+m|0;r=r+1|0;if((r|0)==(g|0)){y=q;z=l;A=g;break}else{m=q;s=l;u=u+(h<<1)|0}}}else{y=n;z=w;A=0}f[e>>2]=z;f[v>>2]=y;x=A;break}case 3:{A=f[e>>2]|0;y=e+4|0;v=f[y>>2]|0;z=e+8|0;w=f[z>>2]|0;if((g|0)>0){n=w;u=v;s=A;m=0;r=a;while(1){l=(d[r>>1]|0)+s|0;q=(d[r+2>>1]|0)+u|0;t=(d[r+4>>1]|0)+n|0;m=m+1|0;if((m|0)==(g|0)){B=t;C=q;D=l;E=g;break}else{n=t;u=q;s=l;r=r+(h<<1)|0}}}else{B=w;C=v;D=A;E=0}f[e>>2]=D;f[y>>2]=C;f[z>>2]=B;x=E;break}default:x=0}if((i|0)<(h|0)){F=i;G=x}else{H=g;return H|0}while(1){x=e+(F<<2)|0;i=f[x>>2]|0;E=e+(F+1<<2)|0;B=f[E>>2]|0;z=e+(F+2<<2)|0;C=f[z>>2]|0;y=e+(F+3<<2)|0;D=f[y>>2]|0;if((G|0)<(g|0)){A=D;v=C;w=B;r=i;s=a+((Y(G,h)|0)<<1)+(F<<1)|0;u=G;while(1){n=(d[s>>1]|0)+r|0;m=(d[s+2>>1]|0)+w|0;l=(d[s+4>>1]|0)+v|0;q=(d[s+6>>1]|0)+A|0;u=u+1|0;if((u|0)==(g|0)){I=q;J=l;K=m;L=n;M=g;break}else{A=q;v=l;w=m;r=n;s=s+(h<<1)|0}}}else{I=D;J=C;K=B;L=i;M=G}f[x>>2]=L;f[E>>2]=K;f[z>>2]=J;f[y>>2]=I;F=F+4|0;if((F|0)>=(h|0)){H=g;break}else G=M}return H|0}switch(h|0){case 1:{M=f[e>>2]|0;if((g|0)>0){G=M;F=0;I=0;while(1){if(!(b[c+I>>0]|0)){N=G;O=F}else{N=(d[a+(I<<1)>>1]|0)+G|0;O=F+1|0}I=I+1|0;if((I|0)==(g|0)){P=N;Q=O;break}else{G=N;F=O}}}else{P=M;Q=0}f[e>>2]=P;H=Q;return H|0}case 3:{Q=f[e>>2]|0;P=e+4|0;M=f[P>>2]|0;O=e+8|0;F=f[O>>2]|0;if((g|0)>0){N=F;G=M;I=Q;J=0;K=0;L=a;while(1){if(!(b[c+J>>0]|0)){R=N;S=G;T=I;U=K}else{R=(d[L+4>>1]|0)+N|0;S=(d[L+2>>1]|0)+G|0;T=(d[L>>1]|0)+I|0;U=K+1|0}J=J+1|0;if((J|0)==(g|0)){V=R;W=S;X=T;Z=U;break}else{N=R;G=S;I=T;K=U;L=L+6|0}}}else{V=F;W=M;X=Q;Z=0}f[e>>2]=X;f[P>>2]=W;f[O>>2]=V;H=Z;return H|0}default:{if((g|0)<=0){H=0;return H|0}Z=h+-4|0;if((h|0)<4){if((h|0)>0){_=0;$=0;aa=a}else{V=0;O=0;while(1){W=O+((b[c+V>>0]|0)!=0&1)|0;V=V+1|0;if((V|0)==(g|0)){H=W;break}else O=W}return H|0}while(1){if(!(b[c+_>>0]|0))ba=$;else{O=0;do{V=e+(O<<2)|0;f[V>>2]=(f[V>>2]|0)+(d[aa+(O<<1)>>1]|0);O=O+1|0}while((O|0)!=(h|0));ba=$+1|0}_=_+1|0;if((_|0)==(g|0)){H=ba;break}else{$=ba;aa=aa+(h<<1)|0}}return H|0}aa=h&-4;if((aa|0)<(h|0)){ca=0;da=0;ea=a}else{ba=0;$=0;_=a;while(1){if(!(b[c+ba>>0]|0))fa=$;else{a=0;do{O=e+(a<<2)|0;y=a|1;z=e+(y<<2)|0;E=(d[_+(y<<1)>>1]|0)+(f[z>>2]|0)|0;f[O>>2]=(d[_+(a<<1)>>1]|0)+(f[O>>2]|0);f[z>>2]=E;E=a|2;z=e+(E<<2)|0;O=a|3;y=e+(O<<2)|0;x=(d[_+(O<<1)>>1]|0)+(f[y>>2]|0)|0;f[z>>2]=(d[_+(E<<1)>>1]|0)+(f[z>>2]|0);f[y>>2]=x;a=a+4|0}while((a|0)<=(Z|0));fa=$+1|0}ba=ba+1|0;if((ba|0)==(g|0)){H=fa;break}else{$=fa;_=_+(h<<1)|0}}return H|0}while(1){if(!(b[c+ca>>0]|0))ga=da;else{_=0;do{fa=e+(_<<2)|0;$=_|1;ba=e+($<<2)|0;a=(d[ea+($<<1)>>1]|0)+(f[ba>>2]|0)|0;f[fa>>2]=(d[ea+(_<<1)>>1]|0)+(f[fa>>2]|0);f[ba>>2]=a;a=_|2;ba=e+(a<<2)|0;fa=_|3;$=e+(fa<<2)|0;x=(d[ea+(fa<<1)>>1]|0)+(f[$>>2]|0)|0;f[ba>>2]=(d[ea+(a<<1)>>1]|0)+(f[ba>>2]|0);f[$>>2]=x;_=_+4|0}while((_|0)<=(Z|0));ha=aa;do{_=e+(ha<<2)|0;f[_>>2]=(f[_>>2]|0)+(d[ea+(ha<<1)>>1]|0);ha=ha+1|0}while((ha|0)!=(h|0));ga=da+1|0}ca=ca+1|0;if((ca|0)==(g|0)){H=ga;break}else{da=ga;ea=ea+(h<<1)|0}}return H|0}}return 0}function kG(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0.0,S=0,T=0.0,U=0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=+p[d>>3];j=e+-4|0;if((e|0)<4){k=a;l=i;m=0}else{n=g<<1;o=g*3|0;q=g<<2;r=j>>>2;s=Y((r<<4)+16|0,g)|0;t=a;u=i;v=0;while(1){u=u+ +((f[t+(g<<2)>>2]|0)+(f[t>>2]|0)+(f[t+(n<<2)>>2]|0)+(f[t+(o<<2)>>2]|0)|0);v=v+4|0;if((v|0)>(j|0))break;else t=t+(q<<2)|0}k=a+s|0;l=u;m=(r<<2)+4|0}if((m|0)<(e|0)){u=l;r=m;s=k;while(1){i=u+ +(f[s>>2]|0);r=r+1|0;if((r|0)==(e|0)){w=i;x=e;break}else{u=i;s=s+(g<<2)|0}}}else{w=l;x=m}p[d>>3]=w;y=x;break}case 2:{w=+p[d>>3];x=d+8|0;l=+p[x>>3];if((e|0)>0){u=l;i=w;m=0;s=a;while(1){z=i+ +(f[s>>2]|0);A=u+ +(f[s+4>>2]|0);m=m+1|0;if((m|0)==(e|0)){B=A;C=z;D=e;break}else{u=A;i=z;s=s+(g<<2)|0}}}else{B=l;C=w;D=0}p[d>>3]=C;p[x>>3]=B;y=D;break}case 3:{B=+p[d>>3];D=d+8|0;C=+p[D>>3];x=d+16|0;w=+p[x>>3];if((e|0)>0){l=w;i=C;u=B;s=0;m=a;while(1){z=u+ +(f[m>>2]|0);A=i+ +(f[m+4>>2]|0);E=l+ +(f[m+8>>2]|0);s=s+1|0;if((s|0)==(e|0)){F=E;G=A;H=z;I=e;break}else{l=E;i=A;u=z;m=m+(g<<2)|0}}}else{F=w;G=C;H=B;I=0}p[d>>3]=H;p[D>>3]=G;p[x>>3]=F;y=I;break}default:y=0}if((h|0)<(g|0)){J=h;K=y}else{L=e;return L|0}while(1){y=d+(J<<3)|0;F=+p[y>>3];h=d+(J+1<<3)|0;G=+p[h>>3];I=d+(J+2<<3)|0;H=+p[I>>3];x=d+(J+3<<3)|0;B=+p[x>>3];if((K|0)<(e|0)){C=B;w=H;u=G;i=F;D=a+((Y(K,g)|0)<<2)+(J<<2)|0;m=K;while(1){l=i+ +(f[D>>2]|0);z=u+ +(f[D+4>>2]|0);A=w+ +(f[D+8>>2]|0);E=C+ +(f[D+12>>2]|0);m=m+1|0;if((m|0)==(e|0)){M=E;N=A;O=z;P=l;Q=e;break}else{C=E;w=A;u=z;i=l;D=D+(g<<2)|0}}}else{M=B;N=H;O=G;P=F;Q=K}p[y>>3]=P;p[h>>3]=O;p[I>>3]=N;p[x>>3]=M;J=J+4|0;if((J|0)>=(g|0)){L=e;break}else K=Q}return L|0}switch(g|0){case 1:{M=+p[d>>3];if((e|0)>0){N=M;Q=0;K=0;while(1){if(!(b[c+K>>0]|0)){R=N;S=Q}else{R=N+ +(f[a+(K<<2)>>2]|0);S=Q+1|0}K=K+1|0;if((K|0)==(e|0)){T=R;U=S;break}else{N=R;Q=S}}}else{T=M;U=0}p[d>>3]=T;L=U;return L|0}case 3:{T=+p[d>>3];U=d+8|0;M=+p[U>>3];S=d+16|0;R=+p[S>>3];if((e|0)>0){N=R;O=M;P=T;Q=0;K=0;J=a;while(1){if(!(b[c+Q>>0]|0)){V=N;W=O;X=P;Z=K}else{V=N+ +(f[J+8>>2]|0);W=O+ +(f[J+4>>2]|0);X=P+ +(f[J>>2]|0);Z=K+1|0}Q=Q+1|0;if((Q|0)==(e|0)){_=V;$=W;aa=X;ba=Z;break}else{N=V;O=W;P=X;K=Z;J=J+12|0}}}else{_=R;$=M;aa=T;ba=0}p[d>>3]=aa;p[U>>3]=$;p[S>>3]=_;L=ba;return L|0}default:{if((e|0)<=0){L=0;return L|0}ba=g+-4|0;if((g|0)<4){if((g|0)>0){ca=0;da=0;ea=a}else{S=0;U=0;while(1){J=U+((b[c+S>>0]|0)!=0&1)|0;S=S+1|0;if((S|0)==(e|0)){L=J;break}else U=J}return L|0}while(1){if(!(b[c+ca>>0]|0))fa=da;else{U=0;do{S=d+(U<<3)|0;p[S>>3]=+p[S>>3]+ +(f[ea+(U<<2)>>2]|0);U=U+1|0}while((U|0)!=(g|0));fa=da+1|0}ca=ca+1|0;if((ca|0)==(e|0)){L=fa;break}else{da=fa;ea=ea+(g<<2)|0}}return L|0}ea=g&-4;if((ea|0)<(g|0)){ga=0;ha=0;ia=a}else{fa=0;da=0;ca=a;while(1){if(!(b[c+fa>>0]|0))ja=da;else{a=0;do{U=d+(a<<3)|0;x=a|1;I=d+(x<<3)|0;F=+p[I>>3]+ +(f[ca+(x<<2)>>2]|0);p[U>>3]=+p[U>>3]+ +(f[ca+(a<<2)>>2]|0);p[I>>3]=F;I=a|2;U=d+(I<<3)|0;x=a|3;h=d+(x<<3)|0;F=+p[h>>3]+ +(f[ca+(x<<2)>>2]|0);p[U>>3]=+p[U>>3]+ +(f[ca+(I<<2)>>2]|0);p[h>>3]=F;a=a+4|0}while((a|0)<=(ba|0));ja=da+1|0}fa=fa+1|0;if((fa|0)==(e|0)){L=ja;break}else{da=ja;ca=ca+(g<<2)|0}}return L|0}while(1){if(!(b[c+ga>>0]|0))ka=ha;else{ca=0;do{ja=d+(ca<<3)|0;da=ca|1;fa=d+(da<<3)|0;F=+p[fa>>3]+ +(f[ia+(da<<2)>>2]|0);p[ja>>3]=+p[ja>>3]+ +(f[ia+(ca<<2)>>2]|0);p[fa>>3]=F;fa=ca|2;ja=d+(fa<<3)|0;da=ca|3;a=d+(da<<3)|0;F=+p[a>>3]+ +(f[ia+(da<<2)>>2]|0);p[ja>>3]=+p[ja>>3]+ +(f[ia+(fa<<2)>>2]|0);p[a>>3]=F;ca=ca+4|0}while((ca|0)<=(ba|0));la=ea;do{ca=d+(la<<3)|0;p[ca>>3]=+p[ca>>3]+ +(f[ia+(la<<2)>>2]|0);la=la+1|0}while((la|0)!=(g|0));ka=ha+1|0}ga=ga+1|0;if((ga|0)==(e|0)){L=ka;break}else{ha=ka;ia=ia+(g<<2)|0}}return L|0}}return 0}function lG(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0.0,S=0,T=0.0,U=0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0;if(!c){g=(f|0)%4|0;switch(g|0){case 1:{h=+p[d>>3];i=e+-4|0;if((e|0)<4){j=a;k=h;l=0}else{m=f<<1;o=f*3|0;q=f<<2;r=i>>>2;s=Y((r<<4)+16|0,f)|0;t=a;u=h;v=0;while(1){u=u+(+n[t>>2]+ +n[t+(f<<2)>>2]+ +n[t+(m<<2)>>2]+ +n[t+(o<<2)>>2]);v=v+4|0;if((v|0)>(i|0))break;else t=t+(q<<2)|0}j=a+s|0;k=u;l=(r<<2)+4|0}if((l|0)<(e|0)){u=k;r=l;s=j;while(1){h=u+ +n[s>>2];r=r+1|0;if((r|0)==(e|0)){w=h;x=e;break}else{u=h;s=s+(f<<2)|0}}}else{w=k;x=l}p[d>>3]=w;y=x;break}case 2:{w=+p[d>>3];x=d+8|0;k=+p[x>>3];if((e|0)>0){u=k;h=w;l=0;s=a;while(1){z=h+ +n[s>>2];A=u+ +n[s+4>>2];l=l+1|0;if((l|0)==(e|0)){B=A;C=z;D=e;break}else{u=A;h=z;s=s+(f<<2)|0}}}else{B=k;C=w;D=0}p[d>>3]=C;p[x>>3]=B;y=D;break}case 3:{B=+p[d>>3];D=d+8|0;C=+p[D>>3];x=d+16|0;w=+p[x>>3];if((e|0)>0){k=w;h=C;u=B;s=0;l=a;while(1){z=u+ +n[l>>2];A=h+ +n[l+4>>2];E=k+ +n[l+8>>2];s=s+1|0;if((s|0)==(e|0)){F=E;G=A;H=z;I=e;break}else{k=E;h=A;u=z;l=l+(f<<2)|0}}}else{F=w;G=C;H=B;I=0}p[d>>3]=H;p[D>>3]=G;p[x>>3]=F;y=I;break}default:y=0}if((g|0)<(f|0)){J=g;K=y}else{L=e;return L|0}while(1){y=d+(J<<3)|0;F=+p[y>>3];g=d+(J+1<<3)|0;G=+p[g>>3];I=d+(J+2<<3)|0;H=+p[I>>3];x=d+(J+3<<3)|0;B=+p[x>>3];if((K|0)<(e|0)){C=B;w=H;u=G;h=F;D=a+((Y(K,f)|0)<<2)+(J<<2)|0;l=K;while(1){k=h+ +n[D>>2];z=u+ +n[D+4>>2];A=w+ +n[D+8>>2];E=C+ +n[D+12>>2];l=l+1|0;if((l|0)==(e|0)){M=E;N=A;O=z;P=k;Q=e;break}else{C=E;w=A;u=z;h=k;D=D+(f<<2)|0}}}else{M=B;N=H;O=G;P=F;Q=K}p[y>>3]=P;p[g>>3]=O;p[I>>3]=N;p[x>>3]=M;J=J+4|0;if((J|0)>=(f|0)){L=e;break}else K=Q}return L|0}switch(f|0){case 1:{M=+p[d>>3];if((e|0)>0){N=M;Q=0;K=0;while(1){if(!(b[c+K>>0]|0)){R=N;S=Q}else{R=N+ +n[a+(K<<2)>>2];S=Q+1|0}K=K+1|0;if((K|0)==(e|0)){T=R;U=S;break}else{N=R;Q=S}}}else{T=M;U=0}p[d>>3]=T;L=U;return L|0}case 3:{T=+p[d>>3];U=d+8|0;M=+p[U>>3];S=d+16|0;R=+p[S>>3];if((e|0)>0){N=R;O=M;P=T;Q=0;K=0;J=a;while(1){if(!(b[c+Q>>0]|0)){V=N;W=O;X=P;Z=K}else{V=N+ +n[J+8>>2];W=O+ +n[J+4>>2];X=P+ +n[J>>2];Z=K+1|0}Q=Q+1|0;if((Q|0)==(e|0)){_=V;$=W;aa=X;ba=Z;break}else{N=V;O=W;P=X;K=Z;J=J+12|0}}}else{_=R;$=M;aa=T;ba=0}p[d>>3]=aa;p[U>>3]=$;p[S>>3]=_;L=ba;return L|0}default:{if((e|0)<=0){L=0;return L|0}ba=f+-4|0;if((f|0)<4){if((f|0)>0){ca=0;da=0;ea=a}else{S=0;U=0;while(1){J=U+((b[c+S>>0]|0)!=0&1)|0;S=S+1|0;if((S|0)==(e|0)){L=J;break}else U=J}return L|0}while(1){if(!(b[c+ca>>0]|0))fa=da;else{U=0;do{S=d+(U<<3)|0;p[S>>3]=+p[S>>3]+ +n[ea+(U<<2)>>2];U=U+1|0}while((U|0)!=(f|0));fa=da+1|0}ca=ca+1|0;if((ca|0)==(e|0)){L=fa;break}else{da=fa;ea=ea+(f<<2)|0}}return L|0}ea=f&-4;if((ea|0)<(f|0)){ga=0;ha=0;ia=a}else{fa=0;da=0;ca=a;while(1){if(!(b[c+fa>>0]|0))ja=da;else{a=0;do{U=d+(a<<3)|0;x=a|1;I=d+(x<<3)|0;F=+p[I>>3]+ +n[ca+(x<<2)>>2];p[U>>3]=+p[U>>3]+ +n[ca+(a<<2)>>2];p[I>>3]=F;I=a|2;U=d+(I<<3)|0;x=a|3;g=d+(x<<3)|0;F=+p[g>>3]+ +n[ca+(x<<2)>>2];p[U>>3]=+p[U>>3]+ +n[ca+(I<<2)>>2];p[g>>3]=F;a=a+4|0}while((a|0)<=(ba|0));ja=da+1|0}fa=fa+1|0;if((fa|0)==(e|0)){L=ja;break}else{da=ja;ca=ca+(f<<2)|0}}return L|0}while(1){if(!(b[c+ga>>0]|0))ka=ha;else{ca=0;do{ja=d+(ca<<3)|0;da=ca|1;fa=d+(da<<3)|0;F=+p[fa>>3]+ +n[ia+(da<<2)>>2];p[ja>>3]=+p[ja>>3]+ +n[ia+(ca<<2)>>2];p[fa>>3]=F;fa=ca|2;ja=d+(fa<<3)|0;da=ca|3;a=d+(da<<3)|0;F=+p[a>>3]+ +n[ia+(da<<2)>>2];p[ja>>3]=+p[ja>>3]+ +n[ia+(fa<<2)>>2];p[a>>3]=F;ca=ca+4|0}while((ca|0)<=(ba|0));la=ea;do{ca=d+(la<<3)|0;p[ca>>3]=+p[ca>>3]+ +n[ia+(la<<2)>>2];la=la+1|0}while((la|0)!=(f|0));ka=ha+1|0}ga=ga+1|0;if((ga|0)==(e|0)){L=ka;break}else{ha=ka;ia=ia+(f<<2)|0}}return L|0}}return 0}function mG(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0,S=0.0,T=0,U=0.0,V=0.0,W=0.0,X=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;if(!c){g=(f|0)%4|0;switch(g|0){case 1:{h=+p[d>>3];i=e+-4|0;if((e|0)<4){j=a;k=h;l=0}else{m=f<<1;n=f*3|0;o=f<<2;q=i>>>2;r=Y((q<<5)+32|0,f)|0;s=a;t=h;u=0;while(1){t=t+(+p[s>>3]+ +p[s+(f<<3)>>3]+ +p[s+(m<<3)>>3]+ +p[s+(n<<3)>>3]);u=u+4|0;if((u|0)>(i|0))break;else s=s+(o<<3)|0}j=a+r|0;k=t;l=(q<<2)+4|0}if((l|0)<(e|0)){t=k;q=l;r=j;while(1){h=t+ +p[r>>3];q=q+1|0;if((q|0)==(e|0)){v=h;w=e;break}else{t=h;r=r+(f<<3)|0}}}else{v=k;w=l}p[d>>3]=v;x=w;break}case 2:{v=+p[d>>3];w=d+8|0;k=+p[w>>3];if((e|0)>0){t=k;h=v;l=0;r=a;while(1){y=h+ +p[r>>3];z=t+ +p[r+8>>3];l=l+1|0;if((l|0)==(e|0)){A=z;B=y;C=e;break}else{t=z;h=y;r=r+(f<<3)|0}}}else{A=k;B=v;C=0}p[d>>3]=B;p[w>>3]=A;x=C;break}case 3:{A=+p[d>>3];C=d+8|0;B=+p[C>>3];w=d+16|0;v=+p[w>>3];if((e|0)>0){k=v;h=B;t=A;r=0;l=a;while(1){y=t+ +p[l>>3];z=h+ +p[l+8>>3];D=k+ +p[l+16>>3];r=r+1|0;if((r|0)==(e|0)){E=D;F=z;G=y;H=e;break}else{k=D;h=z;t=y;l=l+(f<<3)|0}}}else{E=v;F=B;G=A;H=0}p[d>>3]=G;p[C>>3]=F;p[w>>3]=E;x=H;break}default:x=0}if((g|0)<(f|0)){I=g;J=x}else{K=e;return K|0}while(1){x=d+(I<<3)|0;E=+p[x>>3];g=d+(I+1<<3)|0;F=+p[g>>3];H=d+(I+2<<3)|0;G=+p[H>>3];w=d+(I+3<<3)|0;A=+p[w>>3];if((J|0)<(e|0)){B=A;v=G;t=F;h=E;C=a+((Y(J,f)|0)<<3)+(I<<3)|0;l=J;while(1){k=h+ +p[C>>3];y=t+ +p[C+8>>3];z=v+ +p[C+16>>3];D=B+ +p[C+24>>3];l=l+1|0;if((l|0)==(e|0)){L=D;M=z;N=y;O=k;P=e;break}else{B=D;v=z;t=y;h=k;C=C+(f<<3)|0}}}else{L=A;M=G;N=F;O=E;P=J}p[x>>3]=O;p[g>>3]=N;p[H>>3]=M;p[w>>3]=L;I=I+4|0;if((I|0)>=(f|0)){K=e;break}else J=P}return K|0}switch(f|0){case 1:{L=+p[d>>3];if((e|0)>0){M=L;P=0;J=0;while(1){if(!(b[c+J>>0]|0)){Q=M;R=P}else{Q=M+ +p[a+(J<<3)>>3];R=P+1|0}J=J+1|0;if((J|0)==(e|0)){S=Q;T=R;break}else{M=Q;P=R}}}else{S=L;T=0}p[d>>3]=S;K=T;return K|0}case 3:{S=+p[d>>3];T=d+8|0;L=+p[T>>3];R=d+16|0;Q=+p[R>>3];if((e|0)>0){M=Q;N=L;O=S;P=0;J=0;I=a;while(1){if(!(b[c+P>>0]|0)){U=M;V=N;W=O;X=J}else{U=M+ +p[I+16>>3];V=N+ +p[I+8>>3];W=O+ +p[I>>3];X=J+1|0}P=P+1|0;if((P|0)==(e|0)){Z=U;_=V;$=W;aa=X;break}else{M=U;N=V;O=W;J=X;I=I+24|0}}}else{Z=Q;_=L;$=S;aa=0}p[d>>3]=$;p[T>>3]=_;p[R>>3]=Z;K=aa;return K|0}default:{if((e|0)<=0){K=0;return K|0}aa=f+-4|0;if((f|0)<4){if((f|0)>0){ba=0;ca=0;da=a}else{R=0;T=0;while(1){I=T+((b[c+R>>0]|0)!=0&1)|0;R=R+1|0;if((R|0)==(e|0)){K=I;break}else T=I}return K|0}while(1){if(!(b[c+ba>>0]|0))ea=ca;else{T=0;do{R=d+(T<<3)|0;p[R>>3]=+p[da+(T<<3)>>3]+ +p[R>>3];T=T+1|0}while((T|0)!=(f|0));ea=ca+1|0}ba=ba+1|0;if((ba|0)==(e|0)){K=ea;break}else{ca=ea;da=da+(f<<3)|0}}return K|0}da=f&-4;if((da|0)<(f|0)){fa=0;ga=0;ha=a}else{ea=0;ca=0;ba=a;while(1){if(!(b[c+ea>>0]|0))ia=ca;else{a=0;do{T=d+(a<<3)|0;w=a|1;H=d+(w<<3)|0;E=+p[H>>3]+ +p[ba+(w<<3)>>3];p[T>>3]=+p[T>>3]+ +p[ba+(a<<3)>>3];p[H>>3]=E;H=a|2;T=d+(H<<3)|0;w=a|3;g=d+(w<<3)|0;E=+p[g>>3]+ +p[ba+(w<<3)>>3];p[T>>3]=+p[T>>3]+ +p[ba+(H<<3)>>3];p[g>>3]=E;a=a+4|0}while((a|0)<=(aa|0));ia=ca+1|0}ea=ea+1|0;if((ea|0)==(e|0)){K=ia;break}else{ca=ia;ba=ba+(f<<3)|0}}return K|0}while(1){if(!(b[c+fa>>0]|0))ja=ga;else{ba=0;do{ia=d+(ba<<3)|0;ca=ba|1;ea=d+(ca<<3)|0;E=+p[ea>>3]+ +p[ha+(ca<<3)>>3];p[ia>>3]=+p[ia>>3]+ +p[ha+(ba<<3)>>3];p[ea>>3]=E;ea=ba|2;ia=d+(ea<<3)|0;ca=ba|3;a=d+(ca<<3)|0;E=+p[a>>3]+ +p[ha+(ca<<3)>>3];p[ia>>3]=+p[ia>>3]+ +p[ha+(ea<<3)>>3];p[a>>3]=E;ba=ba+4|0}while((ba|0)<=(aa|0));ka=da;do{ba=d+(ka<<3)|0;p[ba>>3]=+p[ha+(ka<<3)>>3]+ +p[ba>>3];ka=ka+1|0}while((ka|0)!=(f|0));ja=ga+1|0}fa=fa+1|0;if((fa|0)==(e|0)){K=ja;break}else{ga=ja;ha=ha+(f<<3)|0}}return K|0}}return 0}function nG(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+112|0;d=c+104|0;e=c+48|0;g=c+40|0;h=c+32|0;i=c;dQ(d,40888);if((BL(a,-1)|0)&4088|0){f[e>>2]=0;f[e+4>>2]=0;j=aD(e,7)|0;b[j>>0]=b[359044]|0;b[j+1>>0]=b[359045]|0;b[j+2>>0]=b[359046]|0;b[j+3>>0]=b[359047]|0;b[j+4>>0]=b[359048]|0;b[j+5>>0]=b[359049]|0;b[j+6>>0]=b[359050]|0;bO(-215,e,175572,175475,1358);bD(e)}do if((yM(a)|0)==65536){j=f[a+4>>2]|0;f[e>>2]=f[j>>2];k=e+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=e+8|0;f[m>>2]=f[j+8>>2];f[e+12>>2]=f[j+12>>2];f[e+16>>2]=f[j+16>>2];f[e+20>>2]=f[j+20>>2];f[e+24>>2]=f[j+24>>2];f[e+28>>2]=f[j+28>>2];f[e+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[e+36>>2]=n;f[e+40>>2]=m;m=e+48|0;o=e+44|0;f[o>>2]=m;f[m>>2]=0;f[e+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];p=e;break}else{f[k>>2]=0;jL(e,j);p=e;break}}else{yL(e,a,-1);p=e}while(0);a=f[p>>2]&7;p=f[40908+(a<<2)>>2]|0;if((a|0)==7){f[g>>2]=0;f[g+4>>2]=0;a=aD(g,9)|0;j=255890;k=a+9|0;do{b[a>>0]=b[j>>0]|0;a=a+1|0;j=j+1|0}while((a|0)<(k|0));bO(-215,g,175572,175475,1374);bD(g)}f[g>>2]=e;f[g+4>>2]=0;RN(i,g,h,-1);g=f[i+20>>2]|0;j=i+16|0;a=0;k=0;while(1){if(a>>>0>=(f[j>>2]|0)>>>0)break;l=(Uh[p&1023](f[h>>2]|0,g)|0)+k|0;aL(i)|0;a=a+1|0;k=l}a=e+36|0;i=f[a>>2]|0;if(i|0?(g=i+12|0,i=f[g>>2]|0,f[g>>2]=i+-1,(i|0)==1):0)kL(e);f[a>>2]=0;a=e+16|0;i=e+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[i>>2]|0)>0){a=f[e+40>>2]|0;g=0;do{f[a+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[i>>2]|0))}i=f[e+44>>2]|0;if((i|0)!=(e+48|0))UC(i);if(!(f[d+4>>2]|0)){u=c;return k|0}u=c;return k|0}function oG(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;if((c|0)>0){d=0;e=0}else{f=0;return f|0}while(1){g=((b[a+e>>0]|0)!=0&1)+d|0;e=e+1|0;if((e|0)==(c|0)){f=g;break}else d=g}return f|0}function pG(a,b){a=a|0;b=b|0;var c=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=b+-4|0;if((b|0)<4){e=0;f=0}else{g=0;h=0;do{h=((d[a+(g<<1)>>1]|0)!=0&1)+h+((d[a+((g|1)<<1)>>1]|0)!=0&1)+((d[a+((g|2)<<1)>>1]|0)!=0&1)+((d[a+((g|3)<<1)>>1]|0)!=0&1)|0;g=g+4|0}while((g|0)<=(c|0));e=h;f=b&-4}if((f|0)<(b|0)){i=f;j=e}else{k=e;return k|0}while(1){e=((d[a+(i<<1)>>1]|0)!=0&1)+j|0;i=i+1|0;if((i|0)==(b|0)){k=e;break}else j=e}return k|0}function qG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{g=0;h=0;do{h=((f[a+(g<<2)>>2]|0)!=0&1)+h+((f[a+((g|1)<<2)>>2]|0)!=0&1)+((f[a+((g|2)<<2)>>2]|0)!=0&1)+((f[a+((g|3)<<2)>>2]|0)!=0&1)|0;g=g+4|0}while((g|0)<=(c|0));d=h;e=b&-4}if((e|0)<(b|0)){i=e;j=d}else{k=d;return k|0}while(1){d=((f[a+(i<<2)>>2]|0)!=0&1)+j|0;i=i+1|0;if((i|0)==(b|0)){k=d;break}else j=d}return k|0}function rG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{f=0;g=0;do{g=(+n[a+(f<<2)>>2]!=0.0&1)+g+(+n[a+((f|1)<<2)>>2]!=0.0&1)+(+n[a+((f|2)<<2)>>2]!=0.0&1)+(+n[a+((f|3)<<2)>>2]!=0.0&1)|0;f=f+4|0}while((f|0)<=(c|0));d=g;e=b&-4}if((e|0)<(b|0)){h=e;i=d}else{j=d;return j|0}while(1){d=(+n[a+(h<<2)>>2]!=0.0&1)+i|0;h=h+1|0;if((h|0)==(b|0)){j=d;break}else i=d}return j|0}function sG(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;c=b+-4|0;if((b|0)<4){d=0;e=0}else{f=0;g=0;do{g=(+p[a+(f<<3)>>3]!=0.0&1)+g+(+p[a+((f|1)<<3)>>3]!=0.0&1)+(+p[a+((f|2)<<3)>>3]!=0.0&1)+(+p[a+((f|3)<<3)>>3]!=0.0&1)|0;f=f+4|0}while((f|0)<=(c|0));d=g;e=b&-4}if((e|0)<(b|0)){h=e;i=d}else{j=d;return j|0}while(1){d=(+p[a+(h<<3)>>3]!=0.0&1)+i|0;h=h+1|0;if((h|0)==(b|0)){j=d;break}else i=d}return j|0}function tG(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0;e=u;u=u+1280|0;g=e+1264|0;h=e+1208|0;i=e+1152|0;j=e;k=e+1136|0;l=e+1128|0;m=e+1096|0;n=e+32|0;dQ(g,40940);do if((yM(c)|0)==65536){o=f[c+4>>2]|0;f[h>>2]=f[o>>2];q=h+4|0;r=o+4|0;f[q>>2]=f[r>>2];s=h+8|0;f[s>>2]=f[o+8>>2];f[h+12>>2]=f[o+12>>2];f[h+16>>2]=f[o+16>>2];f[h+20>>2]=f[o+20>>2];f[h+24>>2]=f[o+24>>2];f[h+28>>2]=f[o+28>>2];f[h+32>>2]=f[o+32>>2];t=f[o+36>>2]|0;f[h+36>>2]=t;f[h+40>>2]=s;s=h+48|0;v=h+44|0;f[v>>2]=s;f[s>>2]=0;f[h+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[o+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;jL(h,o);break}}else yL(h,c,-1);while(0);do if((yM(d)|0)==65536){c=f[d+4>>2]|0;f[i>>2]=f[c>>2];o=i+4|0;q=c+4|0;f[o>>2]=f[q>>2];r=i+8|0;f[r>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];s=i+16|0;f[s>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[i+32>>2]=f[c+32>>2];v=f[c+36>>2]|0;f[i+36>>2]=v;f[i+40>>2]=r;r=i+48|0;t=i+44|0;f[t>>2]=r;f[r>>2]=0;f[i+52>>2]=0;if(v|0){r=v+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[c+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];w=s;break}else{f[o>>2]=0;jL(i,c);w=s;break}}else{yL(i,d,-1);w=i+16|0}while(0);if(f[w>>2]|0){d=f[i+4>>2]|0;if((d|0)<3)x=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{s=f[i+40>>2]|0;c=0;o=1;while(1){q=Y(f[s+(c<<2)>>2]|0,o)|0;c=c+1|0;if((c|0)==(d|0)){x=q;break}else o=q}}if(!((d|0)==0|(x|0)==0)?f[i>>2]&4095|0:0){f[j>>2]=0;f[j+4>>2]=0;y=aD(j,32)|0;z=175618;A=y+32|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,j,175651,175475,1488);bD(j)}}x=f[h>>2]|0;d=x>>>3&511;o=d+1|0;c=x&7;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;x=f[40856+(c<<2)>>2]|0;if(!((c|0)!=7&o>>>0<5)){f[k>>2]=0;f[k+4>>2]=0;y=aD(k,20)|0;z=175454;A=y+20|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,k,175651,175475,1497);bD(k)}f[k>>2]=h;f[k+4>>2]=i;f[k+8>>2]=0;RN(m,k,l,-1);k=f[m+20>>2]|0;z=n+8|0;f[n>>2]=z;y=n+4|0;f[y>>2]=264;A=c>>>0<4;if(A){s=c>>>0<2?8388608:32768;c=(s|0)<(k|0)?s:k;f[y>>2]=o;if(o>>>0>264){q=N5b(o<<2)|0;f[n>>2]=q;B=q}else B=z;Nac(B|0,0,(d<<2)+4|0)|0;d=f[h+4>>2]|0;if((d|0)>0){C=f[(f[h+44>>2]|0)+(d+-1<<2)>>2]|0;D=B;E=c;F=s}else{C=0;D=B;E=c;F=s}}else{C=0;D=j;E=k;F=0}s=m+16|0;c=(k|0)>0;B=l+4|0;d=0;q=0;r=0;while(1){if(d>>>0>=(f[s>>2]|0)>>>0)break;t=d+1|0;a:do if(c){v=f[l>>2]|0;G=f[B>>2]|0;if(A){H=0;I=q;J=r;K=v;L=G}else{M=0;N=q;O=r;P=v;v=G;while(1){G=k-M|0;Q=(E|0)<(G|0)?E:G;G=nh[x&127](P,v,D,Q,o)|0;R=G+O|0;S=G+N|0;G=Y(Q,C)|0;P=(f[l>>2]|0)+G|0;f[l>>2]=P;G=f[B>>2]|0;if(!G)T=0;else{U=G+Q|0;f[B>>2]=U;T=U}M=M+E|0;if((k|0)<=(M|0)){V=S;W=R;break a}else{N=S;O=R;v=T}}}while(1){v=k-H|0;O=(E|0)<(v|0)?E:v;v=nh[x&127](K,L,D,O,o)|0;N=v+J|0;M=v+I|0;if((N+E|0)<(F|0)?((O+H|0)<(k|0)?1:t>>>0<(f[s>>2]|0)>>>0):0)X=N;else{Z=0;_=36}if((_|0)==36)while(1){_=0;N=D+(Z<<2)|0;v=j+(Z<<3)|0;p[v>>3]=+p[v>>3]+ +(f[N>>2]|0);f[N>>2]=0;Z=Z+1|0;if((Z|0)==(o|0)){X=0;break}else _=36}N=Y(O,C)|0;K=(f[l>>2]|0)+N|0;f[l>>2]=K;N=f[B>>2]|0;if(!N)$=0;else{v=N+O|0;f[B>>2]=v;$=v}H=H+E|0;if((k|0)<=(H|0)){V=M;W=X;break}else{I=M;J=X;L=$}}}else{V=q;W=r}while(0);aL(m)|0;d=t;q=V;r=W}aa=(q|0)==0?0.0:1.0/+(q>>>0);ba=aa*+p[j+8>>3];ca=aa*+p[j+16>>3];da=aa*+p[j+24>>3];p[a>>3]=aa*+p[j>>3];p[a+8>>3]=ba;p[a+16>>3]=ca;p[a+24>>3]=da;a=f[n>>2]|0;if((a|0)!=(z|0)){if(a|0)P5b(a);f[n>>2]=z;f[y>>2]=264}y=i+36|0;z=f[y>>2]|0;if(z|0?(n=z+12|0,z=f[n>>2]|0,f[n>>2]=z+-1,(z|0)==1):0)kL(i);f[y>>2]=0;y=i+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[y>>2]|0)>0){w=f[i+40>>2]|0;z=0;do{f[w+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[y>>2]|0))}y=f[i+44>>2]|0;if((y|0)!=(i+48|0))UC(y);y=h+36|0;i=f[y>>2]|0;if(i|0?(z=i+12|0,i=f[z>>2]|0,f[z>>2]=i+-1,(i|0)==1):0)kL(h);f[y>>2]=0;y=h+16|0;i=h+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[i>>2]|0)>0){y=f[h+40>>2]|0;z=0;do{f[y+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))UC(i);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function uG(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0;g=u;u=u+1360|0;h=g+1344|0;i=g+1288|0;j=g+1232|0;k=g+1216|0;l=g+1208|0;m=g+1176|0;n=g+16|0;o=g;q=g+1120|0;r=g+1112|0;dQ(h,40960);do if((yM(a)|0)==65536){s=f[a+4>>2]|0;f[i>>2]=f[s>>2];t=i+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=i+8|0;f[w>>2]=f[s+8>>2];f[i+12>>2]=f[s+12>>2];f[i+16>>2]=f[s+16>>2];f[i+20>>2]=f[s+20>>2];f[i+24>>2]=f[s+24>>2];f[i+28>>2]=f[s+28>>2];f[i+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[i+36>>2]=x;f[i+40>>2]=w;w=i+48|0;y=i+44|0;f[y>>2]=w;f[w>>2]=0;f[i+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;jL(i,s);break}}else yL(i,a,-1);while(0);do if((yM(e)|0)==65536){a=f[e+4>>2]|0;f[j>>2]=f[a>>2];s=j+4|0;t=a+4|0;f[s>>2]=f[t>>2];v=j+8|0;f[v>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];w=j+16|0;f[w>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[j+36>>2]=y;f[j+40>>2]=v;v=j+48|0;x=j+44|0;f[x>>2]=v;f[v>>2]=0;f[j+52>>2]=0;if(y|0){v=y+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[a+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];z=w;break}else{f[s>>2]=0;jL(j,a);z=w;break}}else{yL(j,e,-1);z=j+16|0}while(0);if(f[z>>2]|0){e=f[j+4>>2]|0;if((e|0)<3)A=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{w=f[j+40>>2]|0;a=0;s=1;while(1){t=Y(f[w+(a<<2)>>2]|0,s)|0;a=a+1|0;if((a|0)==(e|0)){A=t;break}else s=t}}if(!((e|0)==0|(A|0)==0)?f[j>>2]&4095|0:0){f[k>>2]=0;f[k+4>>2]=0;B=aD(k,72)|0;C=232418;D=B+72|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,k,175700,175475,1869);bD(k)}}A=f[i>>2]|0;e=A>>>3;s=e&511;a=s+1|0;w=A&7;A=f[40980+(w<<2)>>2]|0;if((w|0)==7){f[k>>2]=0;f[k+4>>2]=0;B=aD(k,9)|0;C=255890;D=B+9|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,k,175700,175475,1880);bD(k)}f[k>>2]=i;f[k+4>>2]=j;f[k+8>>2]=0;RN(m,k,l,-1);k=f[m+20>>2]|0;t=n+8|0;f[n>>2]=t;v=n+4|0;f[v>>2]=a<<2;if(a>>>0>34){x=N5b(a<<5)|0;f[n>>2]=x;E=x}else E=t;x=E+(a<<3)|0;y=w>>>0<4;F=0;do{p[x+(F<<3)>>3]=0.0;p[E+(F<<3)>>3]=0.0;F=F+1|0}while((F|0)!=(a|0));F=w>>>0<2;if(y){w=(k|0)<32768;G=x+(a<<3)|0;H=F?G+(a<<2)|0:x;I=0;do{f[H+(I<<2)>>2]=0;f[G+(I<<2)>>2]=0;I=I+1|0}while((I|0)!=(a|0));I=w?k:32768;w=f[i+4>>2]|0;if((w|0)>0){J=f[(f[i+44>>2]|0)+(w+-1<<2)>>2]|0;K=G;L=I;N=32768;O=H}else{J=0;K=G;L=I;N=32768;O=H}}else{J=0;K=E;L=k;N=0;O=x}H=m+16|0;I=(k|0)>0;G=l+4|0;w=0;P=0;Q=0;while(1){if(Q>>>0>=(f[H>>2]|0)>>>0)break;R=Q+1|0;a:do if(I){S=f[l>>2]|0;T=f[G>>2]|0;if(y){U=0;V=w;W=P;X=S;Z=T}else{_=0;$=w;aa=P;ba=S;S=T;while(1){T=k-_|0;ca=(L|0)<(T|0)?L:T;T=Xf[A&127](ba,S,K,O,ca,a)|0;da=T+$|0;ea=T+aa|0;T=Y(ca,J)|0;ba=(f[l>>2]|0)+T|0;f[l>>2]=ba;T=f[G>>2]|0;if(!T)fa=0;else{ga=T+ca|0;f[G>>2]=ga;fa=ga}_=_+L|0;if((k|0)<=(_|0)){ha=da;ia=ea;break a}else{$=da;aa=ea;S=fa}}}while(1){S=k-U|0;aa=(L|0)<(S|0)?L:S;S=Xf[A&127](X,Z,K,O,aa,a)|0;$=S+V|0;_=S+W|0;if(($+L|0)<(N|0)?((aa+U|0)<(k|0)?1:R>>>0<(f[H>>2]|0)>>>0):0)ja=$;else{ka=0;la=40}if((la|0)==40){while(1){la=0;$=K+(ka<<2)|0;S=E+(ka<<3)|0;p[S>>3]=+p[S>>3]+ +(f[$>>2]|0);f[$>>2]=0;ka=ka+1|0;if((ka|0)==(a|0))break;else la=40}if(F){$=0;do{S=O+($<<2)|0;ba=x+($<<3)|0;p[ba>>3]=+p[ba>>3]+ +(f[S>>2]|0);f[S>>2]=0;$=$+1|0}while(($|0)!=(a|0));ja=0}else ja=0}$=Y(aa,J)|0;X=(f[l>>2]|0)+$|0;f[l>>2]=X;$=f[G>>2]|0;if(!$)ma=0;else{S=$+aa|0;f[G>>2]=S;ma=S}U=U+L|0;if((k|0)<=(U|0)){ha=ja;ia=_;break}else{V=ja;W=_;Z=ma}}}else{ha=w;ia=P}while(0);aL(m)|0;w=ha;P=ia;Q=R}na=(P|0)==0?0.0:1.0/+(P|0);P=0;do{Q=E+(P<<3)|0;oa=na*+p[Q>>3];p[Q>>3]=oa;Q=x+(P<<3)|0;pa=na*+p[Q>>3]-oa*oa;oa=+M(+(pa<0.0?0.0:pa));p[Q>>3]=oa;P=P+1|0}while((P|0)!=(a|0));P=o+8|0;Q=o+12|0;ia=o+4|0;ha=q+4|0;w=q+8|0;m=q+12|0;ma=q+16|0;Z=q+20|0;W=q+24|0;ja=q+28|0;V=q+32|0;U=q+36|0;k=q+40|0;L=q+48|0;G=q+44|0;X=q+52|0;l=r+4|0;J=(e|536870400)^511;e=0;do{O=(e|0)==0;F=O?E:x;ka=O?c:d;O=ka;K=f[O+4>>2]|0;H=o;f[H>>2]=f[O>>2];f[H+4>>2]=K;f[P>>2]=f[ka+8>>2];f[Q>>2]=f[ka+12>>2];if(PM(o)|0){if(!(LM(o)|0))aM(o,a,1,6,-1,1,0);do if((yM(o)|0)==65536){ka=f[ia>>2]|0;f[q>>2]=f[ka>>2];K=ka+4|0;f[ha>>2]=f[K>>2];f[w>>2]=f[ka+8>>2];f[m>>2]=f[ka+12>>2];f[ma>>2]=f[ka+16>>2];f[Z>>2]=f[ka+20>>2];f[W>>2]=f[ka+24>>2];f[ja>>2]=f[ka+28>>2];f[V>>2]=f[ka+32>>2];H=f[ka+36>>2]|0;f[U>>2]=H;f[k>>2]=w;f[G>>2]=L;f[L>>2]=0;f[X>>2]=0;if(H|0){O=H+12|0;f[O>>2]=(f[O>>2]|0)+1}if((f[K>>2]|0)<3){K=f[ka+44>>2]|0;O=f[G>>2]|0;f[O>>2]=f[K>>2];f[O+4>>2]=f[K+4>>2];break}else{f[ha>>2]=0;jL(q,ka);break}}else yL(q,o,-1);while(0);R=f[ha>>2]|0;if((R|0)<3)qa=Y(f[m>>2]|0,f[w>>2]|0)|0;else{ka=f[k>>2]|0;K=0;O=1;while(1){H=Y(f[ka+(K<<2)>>2]|0,O)|0;K=K+1|0;if((K|0)==(R|0)){qa=H;break}else O=H}}do if((f[q>>2]&20479|0)==16390)if((f[m>>2]|0)==1)if((qa|0)>(s|0))break;else{la=71;break}else if((qa|0)<=(s|0)|(f[w>>2]|0)!=1){la=71;break}else break;else la=71;while(0);if((la|0)==71){la=0;f[r>>2]=0;f[l>>2]=0;B=aD(r,86)|0;C=175711;D=B+86|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,r,175700,175475,1958);bD(r)}O=f[ma>>2]|0;R=0;do{p[O+(R<<3)>>3]=+p[F+(R<<3)>>3];R=R+1|0}while((R|0)!=(a|0));if((a|0)<(qa|0))Nac(O+(a<<3)|0,0,J+qa<<3|0)|0;R=f[U>>2]|0;if(R|0?(F=R+12|0,R=f[F>>2]|0,f[F>>2]=R+-1,(R|0)==1):0)kL(q);f[U>>2]=0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ha>>2]|0)>0){R=f[k>>2]|0;F=0;do{f[R+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[ha>>2]|0))}F=f[G>>2]|0;if((F|0)!=(L|0))UC(F)}e=e+1|0}while((e|0)<2);e=f[n>>2]|0;if((e|0)!=(t|0)){if(e|0)P5b(e);f[n>>2]=t;f[v>>2]=136}v=j+36|0;t=f[v>>2]|0;if(t|0?(n=t+12|0,t=f[n>>2]|0,f[n>>2]=t+-1,(t|0)==1):0)kL(j);f[v>>2]=0;v=j+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[v>>2]|0)>0){z=f[j+40>>2]|0;t=0;do{f[z+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[v>>2]|0))}v=f[j+44>>2]|0;if((v|0)!=(j+48|0))UC(v);v=i+36|0;j=f[v>>2]|0;if(j|0?(t=j+12|0,j=f[t>>2]|0,f[t>>2]=j+-1,(j|0)==1):0)kL(i);f[v>>2]=0;v=i+16|0;j=i+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[j>>2]|0)>0){v=f[i+40>>2]|0;t=0;do{f[v+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))UC(j);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function vG(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0;if(!c){j=(i|0)%4|0;switch(j|0){case 1:{k=f[d>>2]|0;l=f[e>>2]|0;if((g|0)>0){m=a;n=0;o=k;p=l;while(1){q=h[m>>0]|0;r=q+o|0;s=(Y(q,q)|0)+p|0;n=n+1|0;if((n|0)==(g|0)){t=g;u=r;v=s;break}else{m=m+i|0;o=r;p=s}}}else{t=0;u=k;v=l}f[d>>2]=u;f[e>>2]=v;w=t;break}case 2:{t=f[d>>2]|0;v=d+4|0;u=f[v>>2]|0;l=f[e>>2]|0;k=e+4|0;p=f[k>>2]|0;if((g|0)>0){o=t;m=u;n=l;s=p;r=0;q=a;while(1){x=h[q>>0]|0;y=x+o|0;z=(Y(x,x)|0)+n|0;x=h[q+1>>0]|0;A=x+m|0;B=(Y(x,x)|0)+s|0;r=r+1|0;if((r|0)==(g|0)){C=y;D=A;E=z;F=B;G=g;break}else{o=y;m=A;n=z;s=B;q=q+i|0}}}else{C=t;D=u;E=l;F=p;G=0}f[d>>2]=C;f[v>>2]=D;f[e>>2]=E;f[k>>2]=F;w=G;break}case 3:{G=f[d>>2]|0;F=d+4|0;k=f[F>>2]|0;E=d+8|0;D=f[E>>2]|0;v=f[e>>2]|0;C=e+4|0;p=f[C>>2]|0;l=e+8|0;u=f[l>>2]|0;if((g|0)>0){t=G;q=k;s=u;n=p;m=v;o=D;r=0;B=a;while(1){z=h[B>>0]|0;A=z+t|0;y=(Y(z,z)|0)+m|0;z=h[B+1>>0]|0;x=z+q|0;H=(Y(z,z)|0)+n|0;z=h[B+2>>0]|0;I=z+o|0;J=(Y(z,z)|0)+s|0;r=r+1|0;if((r|0)==(g|0)){K=A;L=x;M=J;N=H;O=y;P=I;Q=g;break}else{t=A;q=x;s=J;n=H;m=y;o=I;B=B+i|0}}}else{K=G;L=k;M=u;N=p;O=v;P=D;Q=0}f[d>>2]=K;f[F>>2]=L;f[E>>2]=P;f[e>>2]=O;f[C>>2]=N;f[l>>2]=M;w=Q;break}default:w=0}if((j|0)<(i|0)){R=j;S=w}else{T=g;return T|0}while(1){w=d+(R<<2)|0;j=f[w>>2]|0;Q=R+1|0;M=d+(Q<<2)|0;l=f[M>>2]|0;N=R+2|0;C=d+(N<<2)|0;O=f[C>>2]|0;P=R+3|0;E=d+(P<<2)|0;L=f[E>>2]|0;F=e+(R<<2)|0;K=f[F>>2]|0;D=e+(Q<<2)|0;Q=f[D>>2]|0;v=e+(N<<2)|0;N=f[v>>2]|0;p=e+(P<<2)|0;P=f[p>>2]|0;if((S|0)<(g|0)){u=P;k=N;G=Q;B=K;o=L;m=O;n=l;s=j;q=a+R|0;t=S;while(1){r=h[q>>0]|0;I=r+s|0;y=(Y(r,r)|0)+B|0;r=h[q+1>>0]|0;H=r+n|0;J=(Y(r,r)|0)+G|0;r=h[q+2>>0]|0;x=r+m|0;A=(Y(r,r)|0)+k|0;r=h[q+3>>0]|0;z=r+o|0;U=(Y(r,r)|0)+u|0;t=t+1|0;if((t|0)==(g|0)){V=U;W=A;X=J;Z=y;_=z;$=x;aa=H;ba=I;ca=g;break}else{u=U;k=A;G=J;B=y;o=z;m=x;n=H;s=I;q=q+i|0}}}else{V=P;W=N;X=Q;Z=K;_=L;$=O;aa=l;ba=j;ca=S}f[w>>2]=ba;f[M>>2]=aa;f[C>>2]=$;f[E>>2]=_;f[F>>2]=Z;f[D>>2]=X;f[v>>2]=W;f[p>>2]=V;R=R+4|0;if((R|0)>=(i|0)){T=g;break}else S=ca}return T|0}switch(i|0){case 1:{ca=f[d>>2]|0;S=f[e>>2]|0;if((g|0)>0){R=S;V=ca;W=0;X=0;while(1){if(!(b[c+X>>0]|0)){da=R;ea=V;fa=W}else{Z=h[a+X>>0]|0;da=(Y(Z,Z)|0)+R|0;ea=Z+V|0;fa=W+1|0}X=X+1|0;if((X|0)==(g|0)){ga=da;ha=ea;ia=fa;break}else{R=da;V=ea;W=fa}}}else{ga=S;ha=ca;ia=0}f[d>>2]=ha;f[e>>2]=ga;T=ia;return T|0}case 3:{ia=f[d>>2]|0;ga=d+4|0;ha=f[ga>>2]|0;ca=d+8|0;S=f[ca>>2]|0;fa=f[e>>2]|0;W=e+4|0;ea=f[W>>2]|0;V=e+8|0;da=f[V>>2]|0;if((g|0)>0){R=da;X=ea;Z=fa;_=S;$=ha;aa=ia;ba=0;q=0;s=a;while(1){if(!(b[c+ba>>0]|0)){ja=R;ka=X;la=Z;ma=_;na=$;oa=aa;pa=q}else{n=h[s>>0]|0;m=h[s+1>>0]|0;o=h[s+2>>0]|0;ja=(Y(o,o)|0)+R|0;ka=(Y(m,m)|0)+X|0;la=(Y(n,n)|0)+Z|0;ma=o+_|0;na=m+$|0;oa=n+aa|0;pa=q+1|0}ba=ba+1|0;if((ba|0)==(g|0)){qa=ja;ra=ka;sa=la;ta=ma;ua=na;va=oa;wa=pa;break}else{R=ja;X=ka;Z=la;_=ma;$=na;aa=oa;q=pa;s=s+3|0}}}else{qa=da;ra=ea;sa=fa;ta=S;ua=ha;va=ia;wa=0}f[d>>2]=va;f[ga>>2]=ua;f[ca>>2]=ta;f[e>>2]=sa;f[W>>2]=ra;f[V>>2]=qa;T=wa;return T|0}default:{if((g|0)<=0){T=0;return T|0}if((i|0)>0){xa=0;ya=0;za=a}else{a=0;wa=0;while(1){qa=((b[c+a>>0]|0)!=0&1)+wa|0;a=a+1|0;if((a|0)==(g|0)){T=qa;break}else wa=qa}return T|0}while(1){if(!(b[c+xa>>0]|0))Aa=ya;else{wa=0;do{a=d+(wa<<2)|0;qa=h[za+wa>>0]|0;V=e+(wa<<2)|0;ra=(f[V>>2]|0)+(Y(qa,qa)|0)|0;f[a>>2]=(f[a>>2]|0)+qa;f[V>>2]=ra;wa=wa+1|0}while((wa|0)!=(i|0));Aa=ya+1|0}xa=xa+1|0;if((xa|0)==(g|0)){T=Aa;break}else{ya=Aa;za=za+i|0}}return T|0}}return 0}function wG(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;if(!c){i=(h|0)%4|0;switch(i|0){case 1:{j=f[d>>2]|0;k=f[e>>2]|0;if((g|0)>0){l=a;m=0;n=j;o=k;while(1){p=b[l>>0]|0;q=p+n|0;r=(Y(p,p)|0)+o|0;m=m+1|0;if((m|0)==(g|0)){s=g;t=q;u=r;break}else{l=l+h|0;n=q;o=r}}}else{s=0;t=j;u=k}f[d>>2]=t;f[e>>2]=u;v=s;break}case 2:{s=f[d>>2]|0;u=d+4|0;t=f[u>>2]|0;k=f[e>>2]|0;j=e+4|0;o=f[j>>2]|0;if((g|0)>0){n=s;l=t;m=k;r=o;q=0;p=a;while(1){w=b[p>>0]|0;x=w+n|0;y=(Y(w,w)|0)+m|0;w=b[p+1>>0]|0;z=w+l|0;A=(Y(w,w)|0)+r|0;q=q+1|0;if((q|0)==(g|0)){B=x;C=z;D=y;E=A;F=g;break}else{n=x;l=z;m=y;r=A;p=p+h|0}}}else{B=s;C=t;D=k;E=o;F=0}f[d>>2]=B;f[u>>2]=C;f[e>>2]=D;f[j>>2]=E;v=F;break}case 3:{F=f[d>>2]|0;E=d+4|0;j=f[E>>2]|0;D=d+8|0;C=f[D>>2]|0;u=f[e>>2]|0;B=e+4|0;o=f[B>>2]|0;k=e+8|0;t=f[k>>2]|0;if((g|0)>0){s=F;p=j;r=t;m=o;l=u;n=C;q=0;A=a;while(1){y=b[A>>0]|0;z=y+s|0;x=(Y(y,y)|0)+l|0;y=b[A+1>>0]|0;w=y+p|0;G=(Y(y,y)|0)+m|0;y=b[A+2>>0]|0;H=y+n|0;I=(Y(y,y)|0)+r|0;q=q+1|0;if((q|0)==(g|0)){J=z;K=w;L=I;M=G;N=x;O=H;P=g;break}else{s=z;p=w;r=I;m=G;l=x;n=H;A=A+h|0}}}else{J=F;K=j;L=t;M=o;N=u;O=C;P=0}f[d>>2]=J;f[E>>2]=K;f[D>>2]=O;f[e>>2]=N;f[B>>2]=M;f[k>>2]=L;v=P;break}default:v=0}if((i|0)<(h|0)){Q=i;R=v}else{S=g;return S|0}while(1){v=d+(Q<<2)|0;i=f[v>>2]|0;P=Q+1|0;L=d+(P<<2)|0;k=f[L>>2]|0;M=Q+2|0;B=d+(M<<2)|0;N=f[B>>2]|0;O=Q+3|0;D=d+(O<<2)|0;K=f[D>>2]|0;E=e+(Q<<2)|0;J=f[E>>2]|0;C=e+(P<<2)|0;P=f[C>>2]|0;u=e+(M<<2)|0;M=f[u>>2]|0;o=e+(O<<2)|0;O=f[o>>2]|0;if((R|0)<(g|0)){t=O;j=M;F=P;A=J;n=K;l=N;m=k;r=i;p=a+Q|0;s=R;while(1){q=b[p>>0]|0;H=q+r|0;x=(Y(q,q)|0)+A|0;q=b[p+1>>0]|0;G=q+m|0;I=(Y(q,q)|0)+F|0;q=b[p+2>>0]|0;w=q+l|0;z=(Y(q,q)|0)+j|0;q=b[p+3>>0]|0;y=q+n|0;T=(Y(q,q)|0)+t|0;s=s+1|0;if((s|0)==(g|0)){U=T;V=z;W=I;X=x;Z=y;_=w;$=G;aa=H;ba=g;break}else{t=T;j=z;F=I;A=x;n=y;l=w;m=G;r=H;p=p+h|0}}}else{U=O;V=M;W=P;X=J;Z=K;_=N;$=k;aa=i;ba=R}f[v>>2]=aa;f[L>>2]=$;f[B>>2]=_;f[D>>2]=Z;f[E>>2]=X;f[C>>2]=W;f[u>>2]=V;f[o>>2]=U;Q=Q+4|0;if((Q|0)>=(h|0)){S=g;break}else R=ba}return S|0}switch(h|0){case 1:{ba=f[d>>2]|0;R=f[e>>2]|0;if((g|0)>0){Q=R;U=ba;V=0;W=0;while(1){if(!(b[c+W>>0]|0)){ca=Q;da=U;ea=V}else{X=b[a+W>>0]|0;ca=(Y(X,X)|0)+Q|0;da=X+U|0;ea=V+1|0}W=W+1|0;if((W|0)==(g|0)){fa=ca;ga=da;ha=ea;break}else{Q=ca;U=da;V=ea}}}else{fa=R;ga=ba;ha=0}f[d>>2]=ga;f[e>>2]=fa;S=ha;return S|0}case 3:{ha=f[d>>2]|0;fa=d+4|0;ga=f[fa>>2]|0;ba=d+8|0;R=f[ba>>2]|0;ea=f[e>>2]|0;V=e+4|0;da=f[V>>2]|0;U=e+8|0;ca=f[U>>2]|0;if((g|0)>0){Q=ca;W=da;X=ea;Z=R;_=ga;$=ha;aa=0;p=0;r=a;while(1){if(!(b[c+aa>>0]|0)){ia=Q;ja=W;ka=X;la=Z;ma=_;na=$;oa=p}else{m=b[r>>0]|0;l=b[r+1>>0]|0;n=b[r+2>>0]|0;ia=(Y(n,n)|0)+Q|0;ja=(Y(l,l)|0)+W|0;ka=(Y(m,m)|0)+X|0;la=n+Z|0;ma=l+_|0;na=m+$|0;oa=p+1|0}aa=aa+1|0;if((aa|0)==(g|0)){pa=ia;qa=ja;ra=ka;sa=la;ta=ma;ua=na;va=oa;break}else{Q=ia;W=ja;X=ka;Z=la;_=ma;$=na;p=oa;r=r+3|0}}}else{pa=ca;qa=da;ra=ea;sa=R;ta=ga;ua=ha;va=0}f[d>>2]=ua;f[fa>>2]=ta;f[ba>>2]=sa;f[e>>2]=ra;f[V>>2]=qa;f[U>>2]=pa;S=va;return S|0}default:{if((g|0)<=0){S=0;return S|0}if((h|0)>0){wa=0;xa=0;ya=a}else{a=0;va=0;while(1){pa=((b[c+a>>0]|0)!=0&1)+va|0;a=a+1|0;if((a|0)==(g|0)){S=pa;break}else va=pa}return S|0}while(1){if(!(b[c+wa>>0]|0))za=xa;else{va=0;do{a=d+(va<<2)|0;pa=b[ya+va>>0]|0;U=e+(va<<2)|0;qa=(f[U>>2]|0)+(Y(pa,pa)|0)|0;f[a>>2]=(f[a>>2]|0)+pa;f[U>>2]=qa;va=va+1|0}while((va|0)!=(h|0));za=xa+1|0}wa=wa+1|0;if((wa|0)==(g|0)){S=za;break}else{xa=za;ya=ya+h|0}}return S|0}}return 0}function xG(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;if(!c){j=(i|0)%4|0;switch(j|0){case 1:{k=f[e>>2]|0;l=+p[g>>3];if((h|0)>0){m=a;n=0;o=k;q=l;while(1){r=d[m>>1]|0;s=(r&65535)+o|0;t=+(r&65535);u=q+t*t;n=n+1|0;if((n|0)==(h|0)){v=h;w=s;x=u;break}else{m=m+(i<<1)|0;o=s;q=u}}}else{v=0;w=k;x=l}f[e>>2]=w;p[g>>3]=x;y=v;break}case 2:{v=f[e>>2]|0;w=e+4|0;k=f[w>>2]|0;x=+p[g>>3];o=g+8|0;l=+p[o>>3];if((h|0)>0){m=v;n=k;q=x;u=l;s=0;r=a;while(1){z=d[r>>1]|0;A=d[r+2>>1]|0;B=(z&65535)+m|0;t=+(z&65535);C=q+t*t;z=(A&65535)+n|0;t=+(A&65535);D=u+t*t;s=s+1|0;if((s|0)==(h|0)){E=B;F=z;G=C;H=D;I=h;break}else{m=B;n=z;q=C;u=D;r=r+(i<<1)|0}}}else{E=v;F=k;G=x;H=l;I=0}f[e>>2]=E;f[w>>2]=F;p[g>>3]=G;p[o>>3]=H;y=I;break}case 3:{I=f[e>>2]|0;o=e+4|0;F=f[o>>2]|0;w=e+8|0;E=f[w>>2]|0;H=+p[g>>3];k=g+8|0;G=+p[k>>3];v=g+16|0;l=+p[v>>3];if((h|0)>0){r=I;n=F;x=l;u=G;q=H;m=E;s=0;z=a;while(1){B=d[z>>1]|0;A=d[z+2>>1]|0;J=d[z+4>>1]|0;K=(B&65535)+r|0;D=+(B&65535);C=q+D*D;B=(A&65535)+n|0;D=+(A&65535);t=u+D*D;A=(J&65535)+m|0;D=+(J&65535);L=x+D*D;s=s+1|0;if((s|0)==(h|0)){M=K;N=B;O=L;P=t;Q=C;R=A;S=h;break}else{r=K;n=B;x=L;u=t;q=C;m=A;z=z+(i<<1)|0}}}else{M=I;N=F;O=l;P=G;Q=H;R=E;S=0}f[e>>2]=M;f[o>>2]=N;f[w>>2]=R;p[g>>3]=Q;p[k>>3]=P;p[v>>3]=O;y=S;break}default:y=0}if((j|0)<(i|0)){T=j;U=y}else{V=h;return V|0}while(1){y=e+(T<<2)|0;j=f[y>>2]|0;S=T+1|0;v=e+(S<<2)|0;k=f[v>>2]|0;R=T+2|0;w=e+(R<<2)|0;N=f[w>>2]|0;o=T+3|0;M=e+(o<<2)|0;E=f[M>>2]|0;F=g+(T<<3)|0;O=+p[F>>3];I=g+(S<<3)|0;P=+p[I>>3];S=g+(R<<3)|0;Q=+p[S>>3];R=g+(o<<3)|0;H=+p[R>>3];if((U|0)<(h|0)){G=H;l=Q;q=P;u=O;o=E;z=N;m=k;n=j;r=a+(T<<1)|0;s=U;while(1){A=d[r>>1]|0;B=d[r+2>>1]|0;K=(A&65535)+n|0;x=+(A&65535);C=u+x*x;A=(B&65535)+m|0;x=+(B&65535);t=q+x*x;B=d[r+4>>1]|0;J=d[r+6>>1]|0;W=(B&65535)+z|0;x=+(B&65535);L=l+x*x;B=(J&65535)+o|0;x=+(J&65535);D=G+x*x;s=s+1|0;if((s|0)==(h|0)){X=D;Y=L;Z=t;_=C;$=B;aa=W;ba=A;ca=K;da=h;break}else{G=D;l=L;q=t;u=C;o=B;z=W;m=A;n=K;r=r+(i<<1)|0}}}else{X=H;Y=Q;Z=P;_=O;$=E;aa=N;ba=k;ca=j;da=U}f[y>>2]=ca;f[v>>2]=ba;f[w>>2]=aa;f[M>>2]=$;p[F>>3]=_;p[I>>3]=Z;p[S>>3]=Y;p[R>>3]=X;T=T+4|0;if((T|0)>=(i|0)){V=h;break}else U=da}return V|0}switch(i|0){case 1:{da=f[e>>2]|0;X=+p[g>>3];if((h|0)>0){Y=X;U=da;T=0;$=0;while(1){if(!(b[c+$>>0]|0)){ea=Y;fa=U;ga=T}else{aa=d[a+($<<1)>>1]|0;Z=+(aa&65535);ea=Y+Z*Z;fa=(aa&65535)+U|0;ga=T+1|0}$=$+1|0;if(($|0)==(h|0)){ha=ea;ia=fa;ja=ga;break}else{Y=ea;U=fa;T=ga}}}else{ha=X;ia=da;ja=0}f[e>>2]=ia;p[g>>3]=ha;V=ja;return V|0}case 3:{ja=f[e>>2]|0;ia=e+4|0;da=f[ia>>2]|0;ga=e+8|0;T=f[ga>>2]|0;ha=+p[g>>3];fa=g+8|0;X=+p[fa>>3];U=g+16|0;ea=+p[U>>3];if((h|0)>0){Y=ea;Z=X;_=ha;$=T;aa=da;ba=ja;ca=0;r=0;n=a;while(1){if(!(b[c+ca>>0]|0)){ka=Y;la=Z;ma=_;na=$;oa=aa;pa=ba;qa=r}else{m=d[n>>1]|0;z=d[n+2>>1]|0;o=d[n+4>>1]|0;u=+(m&65535);q=+(z&65535);l=+(o&65535);ka=Y+l*l;la=Z+q*q;ma=_+u*u;na=(o&65535)+$|0;oa=(z&65535)+aa|0;pa=(m&65535)+ba|0;qa=r+1|0}ca=ca+1|0;if((ca|0)==(h|0)){ra=ka;sa=la;ta=ma;ua=na;va=oa;wa=pa;xa=qa;break}else{Y=ka;Z=la;_=ma;$=na;aa=oa;ba=pa;r=qa;n=n+6|0}}}else{ra=ea;sa=X;ta=ha;ua=T;va=da;wa=ja;xa=0}f[e>>2]=wa;f[ia>>2]=va;f[ga>>2]=ua;p[g>>3]=ta;p[fa>>3]=sa;p[U>>3]=ra;V=xa;return V|0}default:{if((h|0)<=0){V=0;return V|0}if((i|0)>0){ya=0;za=0;Aa=a}else{a=0;xa=0;while(1){U=((b[c+a>>0]|0)!=0&1)+xa|0;a=a+1|0;if((a|0)==(h|0)){V=U;break}else xa=U}return V|0}while(1){if(!(b[c+ya>>0]|0))Ba=za;else{xa=0;do{a=d[Aa+(xa<<1)>>1]|0;U=e+(xa<<2)|0;fa=g+(xa<<3)|0;ra=+(a&65535);sa=+p[fa>>3]+ra*ra;f[U>>2]=(f[U>>2]|0)+(a&65535);p[fa>>3]=sa;xa=xa+1|0}while((xa|0)!=(i|0));Ba=za+1|0}ya=ya+1|0;if((ya|0)==(h|0)){V=Ba;break}else{za=Ba;Aa=Aa+(i<<1)|0}}return V|0}}return 0}function yG(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;if(!c){j=(i|0)%4|0;switch(j|0){case 1:{k=f[e>>2]|0;l=+p[g>>3];if((h|0)>0){m=a;n=0;o=k;q=l;while(1){r=d[m>>1]|0;s=(r<<16>>16)+o|0;t=+(r<<16>>16);u=q+t*t;n=n+1|0;if((n|0)==(h|0)){v=h;w=s;x=u;break}else{m=m+(i<<1)|0;o=s;q=u}}}else{v=0;w=k;x=l}f[e>>2]=w;p[g>>3]=x;y=v;break}case 2:{v=f[e>>2]|0;w=e+4|0;k=f[w>>2]|0;x=+p[g>>3];o=g+8|0;l=+p[o>>3];if((h|0)>0){m=v;n=k;q=x;u=l;s=0;r=a;while(1){z=d[r>>1]|0;A=d[r+2>>1]|0;B=(z<<16>>16)+m|0;t=+(z<<16>>16);C=q+t*t;z=(A<<16>>16)+n|0;t=+(A<<16>>16);D=u+t*t;s=s+1|0;if((s|0)==(h|0)){E=B;F=z;G=C;H=D;I=h;break}else{m=B;n=z;q=C;u=D;r=r+(i<<1)|0}}}else{E=v;F=k;G=x;H=l;I=0}f[e>>2]=E;f[w>>2]=F;p[g>>3]=G;p[o>>3]=H;y=I;break}case 3:{I=f[e>>2]|0;o=e+4|0;F=f[o>>2]|0;w=e+8|0;E=f[w>>2]|0;H=+p[g>>3];k=g+8|0;G=+p[k>>3];v=g+16|0;l=+p[v>>3];if((h|0)>0){r=I;n=F;x=l;u=G;q=H;m=E;s=0;z=a;while(1){B=d[z>>1]|0;A=d[z+2>>1]|0;J=d[z+4>>1]|0;K=(B<<16>>16)+r|0;D=+(B<<16>>16);C=q+D*D;B=(A<<16>>16)+n|0;D=+(A<<16>>16);t=u+D*D;A=(J<<16>>16)+m|0;D=+(J<<16>>16);L=x+D*D;s=s+1|0;if((s|0)==(h|0)){M=K;N=B;O=L;P=t;Q=C;R=A;S=h;break}else{r=K;n=B;x=L;u=t;q=C;m=A;z=z+(i<<1)|0}}}else{M=I;N=F;O=l;P=G;Q=H;R=E;S=0}f[e>>2]=M;f[o>>2]=N;f[w>>2]=R;p[g>>3]=Q;p[k>>3]=P;p[v>>3]=O;y=S;break}default:y=0}if((j|0)<(i|0)){T=j;U=y}else{V=h;return V|0}while(1){y=e+(T<<2)|0;j=f[y>>2]|0;S=T+1|0;v=e+(S<<2)|0;k=f[v>>2]|0;R=T+2|0;w=e+(R<<2)|0;N=f[w>>2]|0;o=T+3|0;M=e+(o<<2)|0;E=f[M>>2]|0;F=g+(T<<3)|0;O=+p[F>>3];I=g+(S<<3)|0;P=+p[I>>3];S=g+(R<<3)|0;Q=+p[S>>3];R=g+(o<<3)|0;H=+p[R>>3];if((U|0)<(h|0)){G=H;l=Q;q=P;u=O;o=E;z=N;m=k;n=j;r=a+(T<<1)|0;s=U;while(1){A=d[r>>1]|0;B=d[r+2>>1]|0;K=(A<<16>>16)+n|0;x=+(A<<16>>16);C=u+x*x;A=(B<<16>>16)+m|0;x=+(B<<16>>16);t=q+x*x;B=d[r+4>>1]|0;J=d[r+6>>1]|0;W=(B<<16>>16)+z|0;x=+(B<<16>>16);L=l+x*x;B=(J<<16>>16)+o|0;x=+(J<<16>>16);D=G+x*x;s=s+1|0;if((s|0)==(h|0)){X=D;Y=L;Z=t;_=C;$=B;aa=W;ba=A;ca=K;da=h;break}else{G=D;l=L;q=t;u=C;o=B;z=W;m=A;n=K;r=r+(i<<1)|0}}}else{X=H;Y=Q;Z=P;_=O;$=E;aa=N;ba=k;ca=j;da=U}f[y>>2]=ca;f[v>>2]=ba;f[w>>2]=aa;f[M>>2]=$;p[F>>3]=_;p[I>>3]=Z;p[S>>3]=Y;p[R>>3]=X;T=T+4|0;if((T|0)>=(i|0)){V=h;break}else U=da}return V|0}switch(i|0){case 1:{da=f[e>>2]|0;X=+p[g>>3];if((h|0)>0){Y=X;U=da;T=0;$=0;while(1){if(!(b[c+$>>0]|0)){ea=Y;fa=U;ga=T}else{aa=d[a+($<<1)>>1]|0;Z=+(aa<<16>>16);ea=Y+Z*Z;fa=(aa<<16>>16)+U|0;ga=T+1|0}$=$+1|0;if(($|0)==(h|0)){ha=ea;ia=fa;ja=ga;break}else{Y=ea;U=fa;T=ga}}}else{ha=X;ia=da;ja=0}f[e>>2]=ia;p[g>>3]=ha;V=ja;return V|0}case 3:{ja=f[e>>2]|0;ia=e+4|0;da=f[ia>>2]|0;ga=e+8|0;T=f[ga>>2]|0;ha=+p[g>>3];fa=g+8|0;X=+p[fa>>3];U=g+16|0;ea=+p[U>>3];if((h|0)>0){Y=ea;Z=X;_=ha;$=T;aa=da;ba=ja;ca=0;r=0;n=a;while(1){if(!(b[c+ca>>0]|0)){ka=Y;la=Z;ma=_;na=$;oa=aa;pa=ba;qa=r}else{m=d[n>>1]|0;z=d[n+2>>1]|0;o=d[n+4>>1]|0;u=+(m<<16>>16);q=+(z<<16>>16);l=+(o<<16>>16);ka=Y+l*l;la=Z+q*q;ma=_+u*u;na=(o<<16>>16)+$|0;oa=(z<<16>>16)+aa|0;pa=(m<<16>>16)+ba|0;qa=r+1|0}ca=ca+1|0;if((ca|0)==(h|0)){ra=ka;sa=la;ta=ma;ua=na;va=oa;wa=pa;xa=qa;break}else{Y=ka;Z=la;_=ma;$=na;aa=oa;ba=pa;r=qa;n=n+6|0}}}else{ra=ea;sa=X;ta=ha;ua=T;va=da;wa=ja;xa=0}f[e>>2]=wa;f[ia>>2]=va;f[ga>>2]=ua;p[g>>3]=ta;p[fa>>3]=sa;p[U>>3]=ra;V=xa;return V|0}default:{if((h|0)<=0){V=0;return V|0}if((i|0)>0){ya=0;za=0;Aa=a}else{a=0;xa=0;while(1){U=((b[c+a>>0]|0)!=0&1)+xa|0;a=a+1|0;if((a|0)==(h|0)){V=U;break}else xa=U}return V|0}while(1){if(!(b[c+ya>>0]|0))Ba=za;else{xa=0;do{a=d[Aa+(xa<<1)>>1]|0;U=e+(xa<<2)|0;fa=g+(xa<<3)|0;ra=+(a<<16>>16);sa=+p[fa>>3]+ra*ra;f[U>>2]=(f[U>>2]|0)+(a<<16>>16);p[fa>>3]=sa;xa=xa+1|0}while((xa|0)!=(i|0));Ba=za+1|0}ya=ya+1|0;if((ya|0)==(h|0)){V=Ba;break}else{za=Ba;Aa=Aa+(i<<1)|0}}return V|0}}return 0}function zG(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0;if(!c){i=(h|0)%4|0;switch(i|0){case 1:{j=+p[d>>3];k=+p[e>>3];if((g|0)>0){l=a;m=0;n=j;o=k;while(1){q=+(f[l>>2]|0);r=n+q;s=o+q*q;m=m+1|0;if((m|0)==(g|0)){t=g;u=r;v=s;break}else{l=l+(h<<2)|0;n=r;o=s}}}else{t=0;u=j;v=k}p[d>>3]=u;p[e>>3]=v;w=t;break}case 2:{v=+p[d>>3];t=d+8|0;u=+p[t>>3];k=+p[e>>3];l=e+8|0;j=+p[l>>3];if((g|0)>0){o=v;n=u;s=k;r=j;m=0;x=a;while(1){q=+(f[x>>2]|0);y=o+q;z=s+q*q;q=+(f[x+4>>2]|0);A=n+q;B=r+q*q;m=m+1|0;if((m|0)==(g|0)){C=y;D=A;E=z;F=B;G=g;break}else{o=y;n=A;s=z;r=B;x=x+(h<<2)|0}}}else{C=v;D=u;E=k;F=j;G=0}p[d>>3]=C;p[t>>3]=D;p[e>>3]=E;p[l>>3]=F;w=G;break}case 3:{F=+p[d>>3];G=d+8|0;E=+p[G>>3];l=d+16|0;D=+p[l>>3];C=+p[e>>3];t=e+8|0;j=+p[t>>3];x=e+16|0;k=+p[x>>3];if((g|0)>0){u=F;v=E;r=k;s=j;n=C;o=D;m=0;H=a;while(1){B=+(f[H>>2]|0);z=u+B;A=n+B*B;B=+(f[H+4>>2]|0);y=v+B;q=s+B*B;B=+(f[H+8>>2]|0);I=o+B;J=r+B*B;m=m+1|0;if((m|0)==(g|0)){K=z;L=y;M=J;N=q;O=A;P=I;Q=g;break}else{u=z;v=y;r=J;s=q;n=A;o=I;H=H+(h<<2)|0}}}else{K=F;L=E;M=k;N=j;O=C;P=D;Q=0}p[d>>3]=K;p[G>>3]=L;p[l>>3]=P;p[e>>3]=O;p[t>>3]=N;p[x>>3]=M;w=Q;break}default:w=0}if((i|0)<(h|0)){R=i;S=w}else{T=g;return T|0}while(1){w=d+(R<<3)|0;M=+p[w>>3];i=R+1|0;Q=d+(i<<3)|0;N=+p[Q>>3];x=R+2|0;t=d+(x<<3)|0;O=+p[t>>3];l=R+3|0;G=d+(l<<3)|0;P=+p[G>>3];H=e+(R<<3)|0;L=+p[H>>3];m=e+(i<<3)|0;K=+p[m>>3];i=e+(x<<3)|0;D=+p[i>>3];x=e+(l<<3)|0;C=+p[x>>3];if((S|0)<(g|0)){j=C;k=D;E=K;F=L;o=P;n=O;s=N;r=M;l=a+(R<<2)|0;U=S;while(1){v=+(f[l>>2]|0);u=r+v;I=F+v*v;v=+(f[l+4>>2]|0);A=s+v;q=E+v*v;v=+(f[l+8>>2]|0);J=n+v;y=k+v*v;v=+(f[l+12>>2]|0);z=o+v;B=j+v*v;U=U+1|0;if((U|0)==(g|0)){V=B;W=y;X=q;Y=I;Z=z;_=J;$=A;aa=u;ba=g;break}else{j=B;k=y;E=q;F=I;o=z;n=J;s=A;r=u;l=l+(h<<2)|0}}}else{V=C;W=D;X=K;Y=L;Z=P;_=O;$=N;aa=M;ba=S}p[w>>3]=aa;p[Q>>3]=$;p[t>>3]=_;p[G>>3]=Z;p[H>>3]=Y;p[m>>3]=X;p[i>>3]=W;p[x>>3]=V;R=R+4|0;if((R|0)>=(h|0)){T=g;break}else S=ba}return T|0}switch(h|0){case 1:{V=+p[d>>3];W=+p[e>>3];if((g|0)>0){X=W;Y=V;ba=0;S=0;while(1){if(!(b[c+S>>0]|0)){ca=X;da=Y;ea=ba}else{Z=+(f[a+(S<<2)>>2]|0);ca=X+Z*Z;da=Y+Z;ea=ba+1|0}S=S+1|0;if((S|0)==(g|0)){fa=ca;ga=da;ha=ea;break}else{X=ca;Y=da;ba=ea}}}else{fa=W;ga=V;ha=0}p[d>>3]=ga;p[e>>3]=fa;T=ha;return T|0}case 3:{fa=+p[d>>3];ha=d+8|0;ga=+p[ha>>3];ea=d+16|0;V=+p[ea>>3];W=+p[e>>3];ba=e+8|0;da=+p[ba>>3];S=e+16|0;Y=+p[S>>3];if((g|0)>0){ca=Y;X=da;Z=W;_=V;$=ga;aa=fa;R=0;l=0;U=a;while(1){if(!(b[c+R>>0]|0)){ia=ca;ja=X;ka=Z;la=_;ma=$;na=aa;oa=l}else{r=+(f[U>>2]|0);s=+(f[U+4>>2]|0);n=+(f[U+8>>2]|0);ia=ca+n*n;ja=X+s*s;ka=Z+r*r;la=_+n;ma=$+s;na=aa+r;oa=l+1|0}R=R+1|0;if((R|0)==(g|0)){pa=ia;qa=ja;ra=ka;sa=la;ta=ma;ua=na;va=oa;break}else{ca=ia;X=ja;Z=ka;_=la;$=ma;aa=na;l=oa;U=U+12|0}}}else{pa=Y;qa=da;ra=W;sa=V;ta=ga;ua=fa;va=0}p[d>>3]=ua;p[ha>>3]=ta;p[ea>>3]=sa;p[e>>3]=ra;p[ba>>3]=qa;p[S>>3]=pa;T=va;return T|0}default:{if((g|0)<=0){T=0;return T|0}if((h|0)>0){wa=0;xa=0;ya=a}else{a=0;va=0;while(1){S=((b[c+a>>0]|0)!=0&1)+va|0;a=a+1|0;if((a|0)==(g|0)){T=S;break}else va=S}return T|0}while(1){if(!(b[c+wa>>0]|0))za=xa;else{va=0;do{a=d+(va<<3)|0;pa=+(f[ya+(va<<2)>>2]|0);S=e+(va<<3)|0;qa=+p[S>>3]+pa*pa;p[a>>3]=+p[a>>3]+pa;p[S>>3]=qa;va=va+1|0}while((va|0)!=(h|0));za=xa+1|0}wa=wa+1|0;if((wa|0)==(g|0)){T=za;break}else{xa=za;ya=ya+(h<<2)|0}}return T|0}}return 0}function AG(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,j=0.0,k=0,l=0,m=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0,za=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=+p[d>>3];j=+p[e>>3];if((f|0)>0){k=a;l=0;m=i;o=j;while(1){q=+n[k>>2];r=m+q;s=o+q*q;l=l+1|0;if((l|0)==(f|0)){t=f;u=r;v=s;break}else{k=k+(g<<2)|0;m=r;o=s}}}else{t=0;u=i;v=j}p[d>>3]=u;p[e>>3]=v;w=t;break}case 2:{v=+p[d>>3];t=d+8|0;u=+p[t>>3];j=+p[e>>3];k=e+8|0;i=+p[k>>3];if((f|0)>0){o=v;m=u;s=j;r=i;l=0;x=a;while(1){q=+n[x>>2];y=o+q;z=s+q*q;q=+n[x+4>>2];A=m+q;B=r+q*q;l=l+1|0;if((l|0)==(f|0)){C=y;D=A;E=z;F=B;G=f;break}else{o=y;m=A;s=z;r=B;x=x+(g<<2)|0}}}else{C=v;D=u;E=j;F=i;G=0}p[d>>3]=C;p[t>>3]=D;p[e>>3]=E;p[k>>3]=F;w=G;break}case 3:{F=+p[d>>3];G=d+8|0;E=+p[G>>3];k=d+16|0;D=+p[k>>3];C=+p[e>>3];t=e+8|0;i=+p[t>>3];x=e+16|0;j=+p[x>>3];if((f|0)>0){u=F;v=E;r=j;s=i;m=C;o=D;l=0;H=a;while(1){B=+n[H>>2];z=u+B;A=m+B*B;B=+n[H+4>>2];y=v+B;q=s+B*B;B=+n[H+8>>2];I=o+B;J=r+B*B;l=l+1|0;if((l|0)==(f|0)){K=z;L=y;M=J;N=q;O=A;P=I;Q=f;break}else{u=z;v=y;r=J;s=q;m=A;o=I;H=H+(g<<2)|0}}}else{K=F;L=E;M=j;N=i;O=C;P=D;Q=0}p[d>>3]=K;p[G>>3]=L;p[k>>3]=P;p[e>>3]=O;p[t>>3]=N;p[x>>3]=M;w=Q;break}default:w=0}if((h|0)<(g|0)){R=h;S=w}else{T=f;return T|0}while(1){w=d+(R<<3)|0;M=+p[w>>3];h=R+1|0;Q=d+(h<<3)|0;N=+p[Q>>3];x=R+2|0;t=d+(x<<3)|0;O=+p[t>>3];k=R+3|0;G=d+(k<<3)|0;P=+p[G>>3];H=e+(R<<3)|0;L=+p[H>>3];l=e+(h<<3)|0;K=+p[l>>3];h=e+(x<<3)|0;D=+p[h>>3];x=e+(k<<3)|0;C=+p[x>>3];if((S|0)<(f|0)){i=C;j=D;E=K;F=L;o=P;m=O;s=N;r=M;k=a+(R<<2)|0;U=S;while(1){v=+n[k>>2];u=r+v;I=F+v*v;v=+n[k+4>>2];A=s+v;q=E+v*v;v=+n[k+8>>2];J=m+v;y=j+v*v;v=+n[k+12>>2];z=o+v;B=i+v*v;U=U+1|0;if((U|0)==(f|0)){V=B;W=y;X=q;Y=I;Z=z;_=J;$=A;aa=u;ba=f;break}else{i=B;j=y;E=q;F=I;o=z;m=J;s=A;r=u;k=k+(g<<2)|0}}}else{V=C;W=D;X=K;Y=L;Z=P;_=O;$=N;aa=M;ba=S}p[w>>3]=aa;p[Q>>3]=$;p[t>>3]=_;p[G>>3]=Z;p[H>>3]=Y;p[l>>3]=X;p[h>>3]=W;p[x>>3]=V;R=R+4|0;if((R|0)>=(g|0)){T=f;break}else S=ba}return T|0}switch(g|0){case 1:{V=+p[d>>3];W=+p[e>>3];if((f|0)>0){X=W;Y=V;ba=0;S=0;while(1){if(!(b[c+S>>0]|0)){ca=X;da=Y;ea=ba}else{Z=+n[a+(S<<2)>>2];ca=X+Z*Z;da=Y+Z;ea=ba+1|0}S=S+1|0;if((S|0)==(f|0)){fa=ca;ga=da;ha=ea;break}else{X=ca;Y=da;ba=ea}}}else{fa=W;ga=V;ha=0}p[d>>3]=ga;p[e>>3]=fa;T=ha;return T|0}case 3:{fa=+p[d>>3];ha=d+8|0;ga=+p[ha>>3];ea=d+16|0;V=+p[ea>>3];W=+p[e>>3];ba=e+8|0;da=+p[ba>>3];S=e+16|0;Y=+p[S>>3];if((f|0)>0){ca=Y;X=da;Z=W;_=V;$=ga;aa=fa;R=0;k=0;U=a;while(1){if(!(b[c+R>>0]|0)){ia=ca;ja=X;ka=Z;la=_;ma=$;na=aa;oa=k}else{r=+n[U>>2];s=+n[U+4>>2];m=+n[U+8>>2];ia=ca+m*m;ja=X+s*s;ka=Z+r*r;la=_+m;ma=$+s;na=aa+r;oa=k+1|0}R=R+1|0;if((R|0)==(f|0)){pa=ia;qa=ja;ra=ka;sa=la;ta=ma;ua=na;va=oa;break}else{ca=ia;X=ja;Z=ka;_=la;$=ma;aa=na;k=oa;U=U+12|0}}}else{pa=Y;qa=da;ra=W;sa=V;ta=ga;ua=fa;va=0}p[d>>3]=ua;p[ha>>3]=ta;p[ea>>3]=sa;p[e>>3]=ra;p[ba>>3]=qa;p[S>>3]=pa;T=va;return T|0}default:{if((f|0)<=0){T=0;return T|0}if((g|0)>0){wa=0;xa=0;ya=a}else{a=0;va=0;while(1){S=((b[c+a>>0]|0)!=0&1)+va|0;a=a+1|0;if((a|0)==(f|0)){T=S;break}else va=S}return T|0}while(1){if(!(b[c+wa>>0]|0))za=xa;else{va=0;do{a=d+(va<<3)|0;pa=+n[ya+(va<<2)>>2];S=e+(va<<3)|0;qa=+p[S>>3]+pa*pa;p[a>>3]=+p[a>>3]+pa;p[S>>3]=qa;va=va+1|0}while((va|0)!=(g|0));za=xa+1|0}wa=wa+1|0;if((wa|0)==(f|0)){T=za;break}else{xa=za;ya=ya+(g<<2)|0}}return T|0}}return 0}function BG(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0.0,ca=0.0,da=0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0,ya=0;if(!c){h=(g|0)%4|0;switch(h|0){case 1:{i=+p[d>>3];j=+p[e>>3];if((f|0)>0){k=a;l=0;m=i;n=j;while(1){o=+p[k>>3];q=m+o;r=n+o*o;l=l+1|0;if((l|0)==(f|0)){s=f;t=q;u=r;break}else{k=k+(g<<3)|0;m=q;n=r}}}else{s=0;t=i;u=j}p[d>>3]=t;p[e>>3]=u;v=s;break}case 2:{u=+p[d>>3];s=d+8|0;t=+p[s>>3];j=+p[e>>3];k=e+8|0;i=+p[k>>3];if((f|0)>0){n=u;m=t;r=j;q=i;l=0;w=a;while(1){o=+p[w>>3];x=+p[w+8>>3];y=n+o;z=r+o*o;o=m+x;A=q+x*x;l=l+1|0;if((l|0)==(f|0)){B=y;C=o;D=z;E=A;F=f;break}else{n=y;m=o;r=z;q=A;w=w+(g<<3)|0}}}else{B=u;C=t;D=j;E=i;F=0}p[d>>3]=B;p[s>>3]=C;p[e>>3]=D;p[k>>3]=E;v=F;break}case 3:{E=+p[d>>3];F=d+8|0;D=+p[F>>3];k=d+16|0;C=+p[k>>3];B=+p[e>>3];s=e+8|0;i=+p[s>>3];w=e+16|0;j=+p[w>>3];if((f|0)>0){t=E;u=D;q=j;r=i;m=B;n=C;l=0;G=a;while(1){A=+p[G>>3];z=+p[G+8>>3];o=+p[G+16>>3];y=t+A;x=m+A*A;A=u+z;H=r+z*z;z=n+o;I=q+o*o;l=l+1|0;if((l|0)==(f|0)){J=y;K=A;L=I;M=H;N=x;O=z;P=f;break}else{t=y;u=A;q=I;r=H;m=x;n=z;G=G+(g<<3)|0}}}else{J=E;K=D;L=j;M=i;N=B;O=C;P=0}p[d>>3]=J;p[F>>3]=K;p[k>>3]=O;p[e>>3]=N;p[s>>3]=M;p[w>>3]=L;v=P;break}default:v=0}if((h|0)<(g|0)){Q=h;R=v}else{S=f;return S|0}while(1){v=d+(Q<<3)|0;L=+p[v>>3];h=Q+1|0;P=d+(h<<3)|0;M=+p[P>>3];w=Q+2|0;s=d+(w<<3)|0;N=+p[s>>3];k=Q+3|0;F=d+(k<<3)|0;O=+p[F>>3];G=e+(Q<<3)|0;K=+p[G>>3];l=e+(h<<3)|0;J=+p[l>>3];h=e+(w<<3)|0;C=+p[h>>3];w=e+(k<<3)|0;B=+p[w>>3];if((R|0)<(f|0)){i=B;j=C;D=J;E=K;n=O;m=N;r=M;q=L;k=a+(Q<<3)|0;T=R;while(1){u=+p[k>>3];t=+p[k+8>>3];z=q+u;x=E+u*u;u=r+t;H=D+t*t;t=+p[k+16>>3];I=+p[k+24>>3];A=m+t;y=j+t*t;t=n+I;o=i+I*I;T=T+1|0;if((T|0)==(f|0)){U=o;V=y;W=H;X=x;Y=t;Z=A;_=u;$=z;aa=f;break}else{i=o;j=y;D=H;E=x;n=t;m=A;r=u;q=z;k=k+(g<<3)|0}}}else{U=B;V=C;W=J;X=K;Y=O;Z=N;_=M;$=L;aa=R}p[v>>3]=$;p[P>>3]=_;p[s>>3]=Z;p[F>>3]=Y;p[G>>3]=X;p[l>>3]=W;p[h>>3]=V;p[w>>3]=U;Q=Q+4|0;if((Q|0)>=(g|0)){S=f;break}else R=aa}return S|0}switch(g|0){case 1:{U=+p[d>>3];V=+p[e>>3];if((f|0)>0){W=V;X=U;aa=0;R=0;while(1){if(!(b[c+R>>0]|0)){ba=W;ca=X;da=aa}else{Y=+p[a+(R<<3)>>3];ba=W+Y*Y;ca=X+Y;da=aa+1|0}R=R+1|0;if((R|0)==(f|0)){ea=ba;fa=ca;ga=da;break}else{W=ba;X=ca;aa=da}}}else{ea=V;fa=U;ga=0}p[d>>3]=fa;p[e>>3]=ea;S=ga;return S|0}case 3:{ea=+p[d>>3];ga=d+8|0;fa=+p[ga>>3];da=d+16|0;U=+p[da>>3];V=+p[e>>3];aa=e+8|0;ca=+p[aa>>3];R=e+16|0;X=+p[R>>3];if((f|0)>0){ba=X;W=ca;Y=V;Z=U;_=fa;$=ea;Q=0;k=0;T=a;while(1){if(!(b[c+Q>>0]|0)){ha=ba;ia=W;ja=Y;ka=Z;la=_;ma=$;na=k}else{q=+p[T>>3];r=+p[T+8>>3];m=+p[T+16>>3];ha=ba+m*m;ia=W+r*r;ja=Y+q*q;ka=Z+m;la=_+r;ma=$+q;na=k+1|0}Q=Q+1|0;if((Q|0)==(f|0)){oa=ha;pa=ia;qa=ja;ra=ka;sa=la;ta=ma;ua=na;break}else{ba=ha;W=ia;Y=ja;Z=ka;_=la;$=ma;k=na;T=T+24|0}}}else{oa=X;pa=ca;qa=V;ra=U;sa=fa;ta=ea;ua=0}p[d>>3]=ta;p[ga>>3]=sa;p[da>>3]=ra;p[e>>3]=qa;p[aa>>3]=pa;p[R>>3]=oa;S=ua;return S|0}default:{if((f|0)<=0){S=0;return S|0}if((g|0)>0){va=0;wa=0;xa=a}else{a=0;ua=0;while(1){R=((b[c+a>>0]|0)!=0&1)+ua|0;a=a+1|0;if((a|0)==(f|0)){S=R;break}else ua=R}return S|0}while(1){if(!(b[c+va>>0]|0))ya=wa;else{ua=0;do{oa=+p[xa+(ua<<3)>>3];a=d+(ua<<3)|0;R=e+(ua<<3)|0;pa=oa*oa+ +p[R>>3];p[a>>3]=oa+ +p[a>>3];p[R>>3]=pa;ua=ua+1|0}while((ua|0)!=(g|0));ya=wa+1|0}va=va+1|0;if((va|0)==(f|0)){S=ya;break}else{wa=ya;xa=xa+(g<<3)|0}}return S|0}}return 0}function CG(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;i=u;u=u+224|0;j=i+208|0;k=i+152|0;l=i+96|0;m=i+80|0;o=i+72|0;q=i+40|0;r=i+36|0;s=i+32|0;t=i+28|0;v=i+24|0;w=i+20|0;x=i+16|0;y=i+8|0;z=i;dQ(j,41012);A=BL(a,-1)|0;B=A&7;C=A>>>3&511;A=C+1|0;E=HM(h)|0;if(!C){if(!E?BL(h,-1)|0:0)F=5}else if((g|0)!=0|((e|0)!=0|E^1))F=5;if((F|0)==5){f[k>>2]=0;f[k+4>>2]=0;G=aD(k,100)|0;H=175868;I=G+100|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));bO(-215,k,175969,175475,2709);bD(k)}do if((yM(a)|0)==65536){F=f[a+4>>2]|0;f[k>>2]=f[F>>2];E=k+4|0;C=F+4|0;f[E>>2]=f[C>>2];J=k+8|0;f[J>>2]=f[F+8>>2];f[k+12>>2]=f[F+12>>2];f[k+16>>2]=f[F+16>>2];f[k+20>>2]=f[F+20>>2];f[k+24>>2]=f[F+24>>2];f[k+28>>2]=f[F+28>>2];f[k+32>>2]=f[F+32>>2];K=f[F+36>>2]|0;f[k+36>>2]=K;f[k+40>>2]=J;J=k+48|0;L=k+44|0;f[L>>2]=J;f[J>>2]=0;f[k+52>>2]=0;if(K|0){J=K+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[C>>2]|0)<3){C=f[F+44>>2]|0;J=f[L>>2]|0;f[J>>2]=f[C>>2];f[J+4>>2]=f[C+4>>2];break}else{f[E>>2]=0;jL(k,F);break}}else yL(k,a,-1);while(0);do if((yM(h)|0)==65536){a=f[h+4>>2]|0;f[l>>2]=f[a>>2];F=l+4|0;E=a+4|0;f[F>>2]=f[E>>2];C=l+8|0;f[C>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];J=f[a+36>>2]|0;f[l+36>>2]=J;f[l+40>>2]=C;C=l+48|0;L=l+44|0;f[L>>2]=C;f[C>>2]=0;f[l+52>>2]=0;if(J|0){C=J+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[E>>2]|0)<3){E=f[a+44>>2]|0;C=f[L>>2]|0;f[C>>2]=f[E>>2];f[C+4>>2]=f[E+4>>2];break}else{f[F>>2]=0;jL(l,a);break}}else yL(l,h,-1);while(0);h=f[41032+(B<<2)>>2]|0;if((B|0)==7){f[m>>2]=0;f[m+4>>2]=0;G=aD(m,9)|0;H=255890;I=G+9|0;do{b[G>>0]=b[H>>0]|0;G=G+1|0;H=H+1|0}while((G|0)<(I|0));bO(-215,m,175969,175475,2722);bD(m)}f[m>>2]=k;f[m+4>>2]=l;f[m+8>>2]=0;RN(q,m,o,-1);f[r>>2]=0;f[s>>2]=0;f[t>>2]=2147483647;f[v>>2]=-2147483648;n[w>>2]=D;n[x>>2]=-D;p[y>>3]=D;p[z>>3]=-D;m=Y(f[q+20>>2]|0,A)|0;A=(B|0)==5;if(!A)if((B|0)==6){M=z;N=y}else{M=v;N=t}else{M=x;N=w}H=q+16|0;if(f[H>>2]|0){G=o+4|0;I=0;a=1;while(1){Hh[h&255](f[o>>2]|0,f[G>>2]|0,N,M,r,s,m,a);aL(q)|0;I=I+1|0;if(I>>>0>=(f[H>>2]|0)>>>0)break;else a=a+m|0}}m=k+16|0;do if(f[m>>2]|0){a=f[k+4>>2]|0;if((a|0)<3)O=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{H=f[k+40>>2]|0;I=0;q=1;while(1){M=Y(f[H+(I<<2)>>2]|0,q)|0;I=I+1|0;if((I|0)==(a|0)){O=M;break}else q=M}}if(!((a|0)==0|(O|0)==0)){if(f[l+16>>2]|0){q=f[l+4>>2]|0;if((q|0)<3)P=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;else{I=f[l+40>>2]|0;H=0;M=1;while(1){N=Y(f[I+(H<<2)>>2]|0,M)|0;H=H+1|0;if((H|0)==(q|0)){P=N;break}else M=N}}if(!((q|0)==0|(P|0)==0))break}if(!(f[r>>2]|0))f[r>>2]=1;if(!(f[s>>2]|0))f[s>>2]=1}}while(0);P=f[r>>2]|0;r=(P|0)==0;do if(!r){if(A){p[y>>3]=+n[w>>2];p[z>>3]=+n[x>>2];break}if(B>>>0<5){p[y>>3]=+(f[t>>2]|0);p[z>>3]=+(f[v>>2]|0)}}else{p[z>>3]=0.0;p[y>>3]=0.0}while(0);if(c|0)p[c>>3]=+p[y>>3];if(d|0)p[d>>3]=+p[z>>3];do if(e|0){z=f[k+4>>2]|0;d=(z|0)>0;if(r){if(!d)break;Nac(e|0,-1,z<<2|0)|0;break}if(d){d=f[k+40>>2]|0;y=z;z=P+-1|0;while(1){c=y;y=y+-1|0;v=f[d+(y<<2)>>2]|0;f[e+(y<<2)>>2]=(z>>>0)%(v>>>0)|0;if((c|0)<=1)break;else z=(z>>>0)/(v>>>0)|0}}}while(0);do if(g|0){e=f[s>>2]|0;P=f[k+4>>2]|0;r=(P|0)>0;if(!e){if(!r)break;Nac(g|0,-1,P<<2|0)|0;break}if(r){r=f[k+40>>2]|0;z=P;P=e+-1|0;while(1){e=z;z=z+-1|0;y=f[r+(z<<2)>>2]|0;f[g+(z<<2)>>2]=(P>>>0)%(y>>>0)|0;if((e|0)<=1)break;else P=(P>>>0)/(y>>>0)|0}}}while(0);g=l+36|0;s=f[g>>2]|0;if(s|0?(P=s+12|0,s=f[P>>2]|0,f[P>>2]=s+-1,(s|0)==1):0)kL(l);f[g>>2]=0;g=l+16|0;s=l+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[s>>2]|0)>0){g=f[l+40>>2]|0;P=0;do{f[g+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[s>>2]|0))}s=f[l+44>>2]|0;if((s|0)!=(l+48|0))UC(s);s=k+36|0;l=f[s>>2]|0;if(l|0?(P=l+12|0,l=f[P>>2]|0,f[P>>2]=l+-1,(l|0)==1):0)kL(k);f[s>>2]=0;s=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[s>>2]|0)>0){m=f[k+40>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[s>>2]|0))}s=f[k+44>>2]|0;if((s|0)!=(k+48|0))UC(s);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function DG(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=f[d>>2]|0;m=f[e>>2]|0;n=f[g>>2]|0;o=f[i>>2]|0;p=(j|0)>0;if(!c)if(p){q=m;r=0;s=o;t=n;u=l;while(1){v=h[a+r>>0]|0;w=(v|0)<(u|0);x=r+k|0;y=w?x:t;z=w?v:u;w=(v|0)>(q|0);A=w?x:s;x=w?v:q;r=r+1|0;if((r|0)==(j|0)){B=z;C=x;D=A;E=y;break}else{q=x;s=A;t=y;u=z}}}else{B=l;C=m;D=o;E=n}else if(p){p=0;u=m;t=o;s=n;q=l;while(1){r=(b[c+p>>0]|0)!=0;z=h[a+p>>0]|0;y=p+k|0;A=r&(z|0)<(q|0);x=A?z:q;v=A?y:s;A=r&(z|0)>(u|0);r=A?y:t;y=A?z:u;p=p+1|0;if((p|0)==(j|0)){B=x;C=y;D=r;E=v;break}else{u=y;t=r;s=v;q=x}}}else{B=l;C=m;D=o;E=n}f[g>>2]=E;f[i>>2]=D;f[d>>2]=B;f[e>>2]=C;return}function EG(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=f[d>>2]|0;l=f[e>>2]|0;m=f[g>>2]|0;n=f[h>>2]|0;o=(i|0)>0;if(!c)if(o){p=l;q=0;r=n;s=m;t=k;while(1){u=b[a+q>>0]|0;v=(u|0)<(t|0);w=q+j|0;x=v?w:s;y=v?u:t;v=(u|0)>(p|0);z=v?w:r;w=v?u:p;q=q+1|0;if((q|0)==(i|0)){A=y;B=w;C=z;D=x;break}else{p=w;r=z;s=x;t=y}}}else{A=k;B=l;C=n;D=m}else if(o){o=0;t=l;s=n;r=m;p=k;while(1){q=(b[c+o>>0]|0)!=0;y=b[a+o>>0]|0;x=o+j|0;z=q&(y|0)<(p|0);w=z?y:p;u=z?x:r;z=q&(y|0)>(t|0);q=z?x:s;x=z?y:t;o=o+1|0;if((o|0)==(i|0)){A=w;B=x;C=q;D=u;break}else{t=x;s=q;r=u;p=w}}}else{A=k;B=l;C=n;D=m}f[g>>2]=D;f[h>>2]=C;f[d>>2]=A;f[e>>2]=B;return}function FG(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=f[d>>2]|0;m=f[e>>2]|0;n=f[g>>2]|0;o=f[h>>2]|0;p=(i|0)>0;if(!c)if(p){q=m;r=0;s=o;t=n;u=l;while(1){v=j[a+(r<<1)>>1]|0;w=(v|0)<(u|0);x=r+k|0;y=w?x:t;z=w?v:u;w=(v|0)>(q|0);A=w?x:s;x=w?v:q;r=r+1|0;if((r|0)==(i|0)){B=z;C=x;D=A;E=y;break}else{q=x;s=A;t=y;u=z}}}else{B=l;C=m;D=o;E=n}else if(p){p=0;u=l;t=m;s=o;q=n;while(1){r=(b[c+p>>0]|0)!=0;z=j[a+(p<<1)>>1]|0;y=p+k|0;A=r&(z|0)<(u|0);x=A?z:u;v=A?y:q;A=r&(z|0)>(t|0);r=A?y:s;y=A?z:t;p=p+1|0;if((p|0)==(i|0)){B=x;C=y;D=r;E=v;break}else{u=x;t=y;s=r;q=v}}}else{B=l;C=m;D=o;E=n}f[g>>2]=E;f[h>>2]=D;f[d>>2]=B;f[e>>2]=C;return}function GG(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;l=f[e>>2]|0;m=f[g>>2]|0;n=f[h>>2]|0;o=f[i>>2]|0;p=(j|0)>0;if(!c)if(p){q=m;r=0;s=o;t=n;u=l;while(1){v=d[a+(r<<1)>>1]|0;w=(v|0)<(u|0);x=r+k|0;y=w?x:t;z=w?v:u;w=(v|0)>(q|0);A=w?x:s;x=w?v:q;r=r+1|0;if((r|0)==(j|0)){B=z;C=x;D=A;E=y;break}else{q=x;s=A;t=y;u=z}}}else{B=l;C=m;D=o;E=n}else if(p){p=0;u=l;t=m;s=o;q=n;while(1){r=(b[c+p>>0]|0)!=0;z=d[a+(p<<1)>>1]|0;y=p+k|0;A=r&(z|0)<(u|0);x=A?z:u;v=A?y:q;A=r&(z|0)>(t|0);r=A?y:s;y=A?z:t;p=p+1|0;if((p|0)==(j|0)){B=x;C=y;D=r;E=v;break}else{u=x;t=y;s=r;q=v}}}else{B=l;C=m;D=o;E=n}f[h>>2]=E;f[i>>2]=D;f[e>>2]=B;f[g>>2]=C;return}function HG(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=f[d>>2]|0;l=f[e>>2]|0;m=f[g>>2]|0;n=f[h>>2]|0;o=(i|0)>0;if(!c)if(o){p=l;q=0;r=n;s=m;t=k;while(1){u=f[a+(q<<2)>>2]|0;v=(u|0)<(t|0);w=q+j|0;x=v?w:s;y=v?u:t;v=(u|0)>(p|0);z=v?w:r;w=v?u:p;q=q+1|0;if((q|0)==(i|0)){A=y;B=w;C=z;D=x;break}else{p=w;r=z;s=x;t=y}}}else{A=k;B=l;C=n;D=m}else if(o){o=0;t=l;s=n;r=m;p=k;while(1){q=f[a+(o<<2)>>2]|0;y=(b[c+o>>0]|0)!=0;x=(q|0)<(p|0)&y;z=o+j|0;w=x?z:r;u=x?q:p;x=(q|0)>(t|0)&y;y=x?z:s;z=x?q:t;o=o+1|0;if((o|0)==(i|0)){A=u;B=z;C=y;D=w;break}else{t=z;s=y;r=w;p=u}}}else{A=k;B=l;C=n;D=m}f[g>>2]=D;f[h>>2]=C;f[d>>2]=A;f[e>>2]=B;return}function IG(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0;k=+n[d>>2];l=+n[e>>2];m=f[g>>2]|0;o=f[h>>2]|0;p=(i|0)>0;if(!c)if(p){q=l;r=0;s=o;t=m;u=k;while(1){v=+n[a+(r<<2)>>2];w=v<u;x=r+j|0;y=w?x:t;z=w?v:u;w=v>q;A=w?x:s;B=w?v:q;r=r+1|0;if((r|0)==(i|0)){C=z;D=B;E=A;F=y;break}else{q=B;s=A;t=y;u=z}}}else{C=k;D=l;E=o;F=m}else if(p){p=0;u=l;t=o;s=m;q=k;while(1){z=+n[a+(p<<2)>>2];r=(b[c+p>>0]|0)!=0;y=z<q&r;A=p+j|0;w=y?A:s;B=y?z:q;y=z>u&r;r=y?A:t;v=y?z:u;p=p+1|0;if((p|0)==(i|0)){C=B;D=v;E=r;F=w;break}else{u=v;t=r;s=w;q=B}}}else{C=k;D=l;E=o;F=m}f[g>>2]=F;f[h>>2]=E;n[d>>2]=C;n[e>>2]=D;return}function JG(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0;k=+p[d>>3];l=+p[e>>3];m=f[g>>2]|0;n=f[h>>2]|0;o=(i|0)>0;if(!c)if(o){q=l;r=0;s=n;t=m;u=k;while(1){v=+p[a+(r<<3)>>3];w=v<u;x=r+j|0;y=w?x:t;z=w?v:u;w=v>q;A=w?x:s;B=w?v:q;r=r+1|0;if((r|0)==(i|0)){C=z;D=B;E=A;F=y;break}else{q=B;s=A;t=y;u=z}}}else{C=k;D=l;E=n;F=m}else if(o){o=0;u=l;t=n;s=m;q=k;while(1){z=+p[a+(o<<3)>>3];r=(b[c+o>>0]|0)!=0;y=z<q&r;A=o+j|0;w=y?A:s;B=y?z:q;y=z>u&r;r=y?A:t;v=y?z:u;o=o+1|0;if((o|0)==(i|0)){C=B;D=v;E=r;F=w;break}else{u=v;t=r;s=w;q=B}}}else{C=k;D=l;E=n;F=m}f[g>>2]=F;f[h>>2]=E;p[d>>3]=C;p[e>>3]=D;return}function KG(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=u;u=u+16|0;j=i+8|0;k=i;dQ(j,41064);if((_L(a,-1)|0)>=3){f[k>>2]=0;f[k+4>>2]=0;l=aD(k,16)|0;m=176056;n=l+16|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,k,176073,175475,2775);bD(k)}CG(a,c,d,e,g,h);if(e|0){h=e+4|0;d=f[e>>2]|0;f[e>>2]=f[h>>2];f[h>>2]=d}if(g|0){d=g+4|0;h=f[g>>2]|0;f[g>>2]=f[d>>2];f[d>>2]=h}if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function LG(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,N=0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;e=u;u=u+272|0;g=e+256|0;i=e+200|0;j=e+144|0;k=e+88|0;l=e+72|0;m=e;o=e+40|0;q=e+32|0;dQ(g,41084);r=c&7;t=(r|0)==1;v=(r|0)==2;w=(r|0)==4;x=(r|0)==5;y=c&255;a:do switch(y&7){case 1:case 2:case 4:case 5:break;default:{if((r|1|0)==7?(BL(a,-1)|0)==0:0)break a;f[i>>2]=0;f[i+4>>2]=0;Vac(aD(i,173)|0,176164,173)|0;bO(-215,i,176338,175475,3186);bD(i)}}while(0);do if((yM(a)|0)==65536){c=f[a+4>>2]|0;f[i>>2]=f[c>>2];z=i+4|0;A=c+4|0;f[z>>2]=f[A>>2];B=i+8|0;f[B>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];f[i+16>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[i+32>>2]=f[c+32>>2];C=f[c+36>>2]|0;f[i+36>>2]=C;f[i+40>>2]=B;B=i+48|0;D=i+44|0;f[D>>2]=B;f[B>>2]=0;f[i+52>>2]=0;if(C|0){B=C+12|0;f[B>>2]=(f[B>>2]|0)+1}if((f[A>>2]|0)<3){A=f[c+44>>2]|0;B=f[D>>2]|0;f[B>>2]=f[A>>2];f[B+4>>2]=f[A+4>>2];break}else{f[z>>2]=0;jL(i,c);break}}else yL(i,a,-1);while(0);do if((yM(d)|0)==65536){a=f[d+4>>2]|0;f[j>>2]=f[a>>2];c=j+4|0;z=a+4|0;f[c>>2]=f[z>>2];A=j+8|0;f[A>>2]=f[a+8>>2];f[j+12>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];B=f[a+36>>2]|0;f[j+36>>2]=B;f[j+40>>2]=A;A=j+48|0;D=j+44|0;f[D>>2]=A;f[A>>2]=0;f[j+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[a+44>>2]|0;A=f[D>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[c>>2]=0;jL(j,a);break}}else yL(j,d,-1);while(0);d=f[i>>2]|0;a=d&7;c=(d>>>3&511)+1|0;z=j+16|0;A=f[z>>2]|0;b:do if(!(d&16384))E=64;else{if(A|0){D=f[j+4>>2]|0;if((D|0)<3)F=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{B=f[j+40>>2]|0;C=0;G=1;while(1){H=Y(f[B+(C<<2)>>2]|0,G)|0;C=C+1|0;if((C|0)==(D|0)){F=H;break}else G=H}}if(!((D|0)==0|(F|0)==0)){E=64;break}}G=f[i+4>>2]|0;if((G|0)<3)I=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{C=f[i+40>>2]|0;B=0;H=1;while(1){J=Y(f[C+(B<<2)>>2]|0,H)|0;B=B+1|0;if((B|0)==(G|0)){I=J;break}else H=J}}H=Y(I,c)|0;switch(d&7){case 5:break;case 0:{G=f[i+16>>2]|0;switch(y&7){case 6:{K=+(uI(G,H)|0);break b;break}case 7:break;default:{E=64;break b}}B=H+-4|0;if((H|0)<4){N=0;O=0}else{C=0;D=0;do{D=(h[176343+(h[G+C>>0]|0)>>0]|0)+D+(h[176343+(h[G+(C|1)>>0]|0)>>0]|0)+(h[176343+(h[G+(C|2)>>0]|0)>>0]|0)+(h[176343+(h[G+(C|3)>>0]|0)>>0]|0)|0;C=C+4|0}while((C|0)<=(B|0));N=D;O=H&-4}if((O|0)<(H|0)){B=O;C=N;while(1){J=(h[176343+(h[G+B>>0]|0)>>0]|0)+C|0;B=B+1|0;if((B|0)==(H|0)){P=J;break}else C=J}}else P=N;K=+(P|0);break b;break}default:{E=64;break b}}C=f[i+16>>2]|0;if(w){B=H+-4|0;if((H|0)<4){Q=0.0;R=0}else{G=0;S=0.0;do{T=+n[C+(G<<2)>>2];U=+n[C+((G|1)<<2)>>2];V=+n[C+((G|2)<<2)>>2];W=+n[C+((G|3)<<2)>>2];S=S+(T*T+U*U+V*V+W*W);G=G+4|0}while((G|0)<=(B|0));Q=S;R=H&-4}if((R|0)<(H|0)){B=R;W=Q;while(1){V=+n[C+(B<<2)>>2];U=W+V*V;B=B+1|0;if((B|0)==(H|0)){X=U;break}else W=U}}else X=Q;K=+M(+(X+0.0));break}if(x){B=H+-4|0;if((H|0)<4){Z=0.0;_=0}else{G=0;W=0.0;do{S=+n[C+(G<<2)>>2];U=+n[C+((G|1)<<2)>>2];V=+n[C+((G|2)<<2)>>2];T=+n[C+((G|3)<<2)>>2];W=W+(S*S+U*U+V*V+T*T);G=G+4|0}while((G|0)<=(B|0));Z=W;_=H&-4}if((_|0)<(H|0)){B=_;T=Z;while(1){V=+n[C+(B<<2)>>2];U=T+V*V;B=B+1|0;if((B|0)==(H|0)){$=U;break}else T=U}}else $=Z;K=$+0.0;break}if(!v){if(!t){E=64;break}if((H|0)>0){B=0;T=0.0;while(1){W=+L(+(+n[C+(B<<2)>>2]));U=T<W?W:T;B=B+1|0;if((B|0)==(H|0)){aa=U;break}else T=U}}else aa=0.0;K=aa>0.0?aa:0.0;break}B=H+-4|0;if((H|0)<4){ba=0;ca=0.0}else{T=0.0;G=0;do{U=+L(+(+n[C+(G<<2)>>2]));W=U+ +L(+(+n[C+((G|1)<<2)>>2]));U=W+ +L(+(+n[C+((G|2)<<2)>>2]));T=T+(U+ +L(+(+n[C+((G|3)<<2)>>2])));G=G+4|0}while((G|0)<=(B|0));ba=H&-4;ca=T}if((ba|0)<(H|0)){U=ca;B=ba;while(1){W=U+ +L(+(+n[C+(B<<2)>>2]));B=B+1|0;if((B|0)==(H|0)){da=W;break}else U=W}}else da=ca;K=da+0.0}while(0);do if((E|0)==64){if(A|0){ba=f[j+4>>2]|0;if((ba|0)<3)ea=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{_=f[j+40>>2]|0;x=0;R=1;while(1){P=Y(f[_+(x<<2)>>2]|0,R)|0;x=x+1|0;if((x|0)==(ba|0)){ea=P;break}else R=P}}if(!((ba|0)==0|(ea|0)==0)?f[j>>2]&4095|0:0){f[k>>2]=0;f[k+4>>2]=0;fa=aD(k,32)|0;ga=175618;ha=fa+32|0;do{b[fa>>0]=b[ga>>0]|0;fa=fa+1|0;ga=ga+1|0}while((fa|0)<(ha|0));bO(-215,k,176338,175475,3253);bD(k)}}ba=(r|0)==6;R=r|1;if((R|0)==7){if(f[z>>2]|0){x=f[j+4>>2]|0;if((x|0)<3)ia=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{_=f[j+40>>2]|0;P=0;N=1;while(1){O=Y(f[_+(P<<2)>>2]|0,N)|0;P=P+1|0;if((P|0)==(x|0)){ia=O;break}else N=O}}if(!((x|0)==0|(ia|0)==0)){f[k>>2]=1124007936;N=k+4|0;P=k+8|0;_=k+40|0;fa=N;ha=fa+36|0;do{f[fa>>2]=0;fa=fa+4|0}while((fa|0)<(ha|0));f[_>>2]=P;x=k+48|0;O=k+44|0;f[O>>2]=x;f[x>>2]=0;f[k+52>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=i;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=j;y=o+8|0;f[y>>2]=0;f[y+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=k;dD(l,m,o,UM()|0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=k;da=+LG(l,r,UM()|0);y=k+36|0;d=f[y>>2]|0;if(d|0?(I=d+12|0,d=f[I>>2]|0,f[I>>2]=d+-1,(d|0)==1):0)kL(k);f[y>>2]=0;y=k+16|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[N>>2]|0)>0){y=f[_>>2]|0;d=0;do{f[y+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[N>>2]|0))}N=f[O>>2]|0;if((N|0)!=(x|0))UC(N);K=da;break}}N=ba?1:2;f[k>>2]=i;f[k+4>>2]=0;RN(m,k,l,-1);d=f[m+20>>2]|0;y=m+16|0;_=0;P=0;while(1){if(_>>>0>=(f[y>>2]|0)>>>0)break;I=(MG(f[l>>2]|0,d,N)|0)+P|0;aL(m)|0;_=_+1|0;P=I}K=+(P|0);break}_=f[41104+(r>>>1<<5)+(a<<2)>>2]|0;if(!_){f[k>>2]=0;f[k+4>>2]=0;fa=aD(k,9)|0;ga=255890;ha=fa+9|0;do{b[fa>>0]=b[ga>>0]|0;fa=fa+1|0;ga=ga+1|0}while((fa|0)<(ha|0));bO(-215,k,176338,175475,3280);bD(k)}f[k>>2]=i;f[k+4>>2]=j;f[k+8>>2]=0;p[m>>3]=0.0;RN(o,k,l,-1);P=f[o+20>>2]|0;N=a>>>0<2;f[q>>2]=0;if(v&a>>>0<4|(R|0)==5&N){d=((v&N?8388608:32768)>>>0)/(c>>>0)|0;N=(d|0)<(P|0)?d:P;y=f[i+4>>2]|0;if((y|0)>0){ja=f[(f[i+44>>2]|0)+(y+-1<<2)>>2]|0;ka=q;la=d;ma=N;na=1}else{ja=0;ka=q;la=d;ma=N;na=1}}else{ja=0;ka=m;la=0;ma=P;na=0}N=o+16|0;d=l+4|0;c:do if((P|0)>0){y=0;ba=0;while(1){if(y>>>0>=(f[N>>2]|0)>>>0)break c;x=y+1|0;O=f[l>>2]|0;I=f[d>>2]|0;if(na){F=0;H=ba;B=O;C=I;while(1){G=P-F|0;D=(ma|0)<(G|0)?ma:G;nh[_&127](B,C,ka,D,c)|0;G=D+H|0;if((G+ma|0)<(la|0)?((D+F|0)<(P|0)?1:x>>>0<(f[N>>2]|0)>>>0):0)oa=G;else{p[m>>3]=+p[m>>3]+ +(f[q>>2]|0);f[q>>2]=0;oa=0}G=Y(D,ja)|0;B=(f[l>>2]|0)+G|0;f[l>>2]=B;G=f[d>>2]|0;if(!G)pa=0;else{J=G+D|0;f[d>>2]=J;pa=J}F=F+ma|0;if((P|0)<=(F|0)){qa=oa;break}else{H=oa;C=pa}}}else{C=0;H=ba;F=O;B=I;while(1){J=P-C|0;D=(ma|0)<(J|0)?ma:J;nh[_&127](F,B,ka,D,c)|0;J=D+H|0;G=Y(D,ja)|0;F=(f[l>>2]|0)+G|0;f[l>>2]=F;G=f[d>>2]|0;if(!G)ra=0;else{sa=G+D|0;f[d>>2]=sa;ra=sa}C=C+ma|0;if((P|0)<=(C|0)){qa=J;break}else{H=J;B=ra}}}aL(o)|0;y=x;ba=qa}}else{ba=0;while(1){if(ba>>>0>=(f[N>>2]|0)>>>0)break c;aL(o)|0;ba=ba+1|0}}while(0);if(t){if((a|0)!=6){N=f[m>>2]|0;p[m>>3]=(a|0)==5?(f[s>>2]=N,+n[s>>2]):+(N|0)}}else if(w){da=+M(+(+p[m>>3]));p[m>>3]=da}K=+p[m>>3]}while(0);m=j+36|0;w=f[m>>2]|0;if(w|0?(a=w+12|0,w=f[a>>2]|0,f[a>>2]=w+-1,(w|0)==1):0)kL(j);f[m>>2]=0;m=j+16|0;w=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[w>>2]|0)>0){m=f[j+40>>2]|0;a=0;do{f[m+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[w>>2]|0))}w=f[j+44>>2]|0;if((w|0)!=(j+48|0))UC(w);w=i+36|0;j=f[w>>2]|0;if(j|0?(a=j+12|0,j=f[a>>2]|0,f[a>>2]=j+-1,(j|0)==1):0)kL(i);f[w>>2]=0;w=i+16|0;j=i+4|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[j>>2]|0)>0){w=f[i+40>>2]|0;a=0;do{f[w+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))UC(j);if(!(f[g+4>>2]|0)){u=e;return +K}u=e;return +K}function MG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,i=0,j=0,k=0,l=0;switch(c|0){case 1:{d=uI(a,b)|0;return d|0}case 2:{e=176343;break}case 4:{e=176599;break}default:{d=-1;return d|0}}c=b+-4|0;if((b|0)<4){f=0;g=0}else{i=0;j=0;do{j=(h[e+(h[a+i>>0]|0)>>0]|0)+j+(h[e+(h[a+(i|1)>>0]|0)>>0]|0)+(h[e+(h[a+(i|2)>>0]|0)>>0]|0)+(h[e+(h[a+(i|3)>>0]|0)>>0]|0)|0;i=i+4|0}while((i|0)<=(c|0));f=j;g=b&-4}if((g|0)<(b|0)){k=g;l=f}else{d=f;return d|0}while(1){f=(h[e+(h[a+k>>0]|0)>>0]|0)+l|0;k=k+1|0;if((k|0)==(b|0)){d=f;break}else l=f}return d|0}function NG(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=f[d>>2]|0;if(!c){j=Y(g,e)|0;if((j|0)>0){k=0;l=0;while(1){m=h[a+l>>0]|0;n=(k|0)<(m|0)?m:k;l=l+1|0;if((l|0)==(j|0)){o=n;break}else k=n}}else o=0;p=(i|0)<(o|0)?o:i;f[d>>2]=p;return 0}if((e|0)>0&(g|0)>0){q=0;r=a;s=i}else{p=i;f[d>>2]=p;return 0}while(1){if(!(b[c+q>>0]|0))t=s;else{i=0;a=s;while(1){o=h[r+i>>0]|0;k=(a|0)<(o|0)?o:a;i=i+1|0;if((i|0)==(g|0)){t=k;break}else a=k}}q=q+1|0;if((q|0)==(e|0)){p=t;break}else{r=r+g|0;s=t}}f[d>>2]=p;return 0}function OG(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(!c){i=Y(g,e)|0;if((i|0)>0){j=0;k=0;while(1){l=b[a+k>>0]|0;m=l<<24>>24;n=l<<24>>24>-1?m:0-m|0;m=(j|0)<(n|0)?n:j;k=k+1|0;if((k|0)==(i|0)){o=m;break}else j=m}}else o=0;p=(h|0)<(o|0)?o:h;f[d>>2]=p;return 0}if((e|0)>0&(g|0)>0){q=0;r=a;s=h}else{p=h;f[d>>2]=p;return 0}while(1){if(!(b[c+q>>0]|0))t=s;else{h=0;a=s;while(1){o=b[r+h>>0]|0;j=o<<24>>24;i=o<<24>>24>-1?j:0-j|0;j=(a|0)<(i|0)?i:a;h=h+1|0;if((h|0)==(g|0)){t=j;break}else a=j}}q=q+1|0;if((q|0)==(e|0)){p=t;break}else{r=r+g|0;s=t}}f[d>>2]=p;return 0}function PG(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(!c){i=Y(g,e)|0;if((i|0)>0){k=0;l=0;while(1){m=j[a+(l<<1)>>1]|0;n=(k|0)<(m|0)?m:k;l=l+1|0;if((l|0)==(i|0)){o=n;break}else k=n}}else o=0;p=(h|0)<(o|0)?o:h;f[d>>2]=p;return 0}if((e|0)>0&(g|0)>0){q=0;r=a;s=h}else{p=h;f[d>>2]=p;return 0}while(1){if(!(b[c+q>>0]|0))t=s;else{h=0;a=s;while(1){o=j[r+(h<<1)>>1]|0;k=(a|0)<(o|0)?o:a;h=h+1|0;if((h|0)==(g|0)){t=k;break}else a=k}}q=q+1|0;if((q|0)==(e|0)){p=t;break}else{r=r+(g<<1)|0;s=t}}f[d>>2]=p;return 0}function QG(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[e>>2]|0;if(!c){j=Y(h,g)|0;if((j|0)>0){k=0;l=0;while(1){m=d[a+(l<<1)>>1]|0;n=m<<16>>16;o=m<<16>>16>-1?n:0-n|0;n=(k|0)<(o|0)?o:k;l=l+1|0;if((l|0)==(j|0)){p=n;break}else k=n}}else p=0;q=(i|0)<(p|0)?p:i;f[e>>2]=q;return 0}if((g|0)>0&(h|0)>0){r=0;s=a;t=i}else{q=i;f[e>>2]=q;return 0}while(1){if(!(b[c+r>>0]|0))u=t;else{i=0;a=t;while(1){p=d[s+(i<<1)>>1]|0;k=p<<16>>16;j=p<<16>>16>-1?k:0-k|0;k=(a|0)<(j|0)?j:a;i=i+1|0;if((i|0)==(h|0)){u=k;break}else a=k}}r=r+1|0;if((r|0)==(g|0)){q=u;break}else{s=s+(h<<1)|0;t=u}}f[e>>2]=q;return 0}function RG(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=f[d>>2]|0;if(!c){i=Y(g,e)|0;if((i|0)>0){j=0;k=0;while(1){l=f[a+(k<<2)>>2]|0;m=(l|0)>-1?l:0-l|0;l=(j|0)<(m|0)?m:j;k=k+1|0;if((k|0)==(i|0)){n=l;break}else j=l}}else n=0;o=(h|0)<(n|0)?n:h;f[d>>2]=o;return 0}if((e|0)>0&(g|0)>0){p=0;q=a;r=h}else{o=h;f[d>>2]=o;return 0}while(1){if(!(b[c+p>>0]|0))s=r;else{h=0;a=r;while(1){n=f[q+(h<<2)>>2]|0;j=(n|0)>-1?n:0-n|0;n=(a|0)<(j|0)?j:a;h=h+1|0;if((h|0)==(g|0)){s=n;break}else a=n}}p=p+1|0;if((p|0)==(e|0)){o=s;break}else{q=q+(g<<2)|0;r=s}}f[d>>2]=o;return 0}function SG(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0,t=0,u=0.0,v=0,w=0.0,x=0;h=f[d>>2]|0;i=(f[s>>2]=h,+n[s>>2]);if(!c){j=Y(g,e)|0;if((j|0)>0){k=0;l=0.0;while(1){m=+L(+(+n[a+(k<<2)>>2]));o=l<m?m:l;k=k+1|0;if((k|0)==(j|0)){p=o;break}else l=o}}else p=0.0;q=(n[s>>2]=i<p?p:i,f[s>>2]|0);f[d>>2]=q;return 0}if((e|0)>0&(g|0)>0){r=0;t=a;u=i;v=h}else{q=h;f[d>>2]=q;return 0}while(1){if(!(b[c+r>>0]|0)){w=u;x=v}else{h=0;i=u;do{p=+L(+(+n[t+(h<<2)>>2]));i=i<p?p:i;h=h+1|0}while((h|0)!=(g|0));w=i;x=(n[s>>2]=i,f[s>>2]|0)}r=r+1|0;if((r|0)==(e|0)){q=x;break}else{t=t+(g<<2)|0;u=w;v=x}}f[d>>2]=q;return 0}function TG(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,q=0,r=0.0,s=0.0;g=+p[d>>3];if(!c){h=Y(f,e)|0;if((h|0)>0){i=0.0;j=0;while(1){k=+L(+(+p[a+(j<<3)>>3]));l=i<k?k:i;j=j+1|0;if((j|0)==(h|0)){m=l;break}else i=l}}else m=0.0;n=g<m?m:g;p[d>>3]=n;return 0}if((e|0)>0&(f|0)>0){o=0;q=a;r=g}else{n=g;p[d>>3]=n;return 0}while(1){if(!(b[c+o>>0]|0))s=r;else{a=0;g=r;while(1){m=+L(+(+p[q+(a<<3)>>3]));i=g<m?m:g;a=a+1|0;if((a|0)==(f|0)){s=i;break}else g=i}}o=o+1|0;if((o|0)==(e|0)){n=s;break}else{q=q+(f<<3)|0;r=s}}p[d>>3]=n;return 0}function UG(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){j=0;k=i;l=a}else{m=i;f[d>>2]=m;return 0}while(1){if(!(b[c+j>>0]|0))n=k;else{o=0;p=k;while(1){q=(h[l+o>>0]|0)+p|0;o=o+1|0;if((o|0)==(g|0)){n=q;break}else p=q}}j=j+1|0;if((j|0)==(e|0)){m=n;break}else{k=n;l=l+g|0}}f[d>>2]=m;return 0}l=Y(g,e)|0;e=l+-4|0;if((l|0)<4){r=0;s=0}else{g=0;n=0;do{g=(h[a+n>>0]|0)+g+(h[a+(n|1)>>0]|0)+(h[a+(n|2)>>0]|0)+(h[a+(n|3)>>0]|0)|0;n=n+4|0}while((n|0)<=(e|0));r=l&-4;s=g}if((r|0)<(l|0)){g=s;e=r;while(1){r=(h[a+e>>0]|0)+g|0;e=e+1|0;if((e|0)==(l|0)){t=r;break}else g=r}}else t=s;m=t+i|0;f[d>>2]=m;return 0}function VG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return pH(a,b,c,d,e)|0}function WG(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){i=0;k=h;l=a}else{m=h;f[d>>2]=m;return 0}while(1){if(!(b[c+i>>0]|0))n=k;else{o=0;p=k;while(1){q=(j[l+(o<<1)>>1]|0)+p|0;o=o+1|0;if((o|0)==(g|0)){n=q;break}else p=q}}i=i+1|0;if((i|0)==(e|0)){m=n;break}else{k=n;l=l+(g<<1)|0}}f[d>>2]=m;return 0}l=Y(g,e)|0;e=l+-4|0;if((l|0)<4){r=0;s=0}else{g=0;n=0;do{g=(j[a+(n<<1)>>1]|0)+g+(j[a+((n|1)<<1)>>1]|0)+(j[a+((n|2)<<1)>>1]|0)+(j[a+((n|3)<<1)>>1]|0)|0;n=n+4|0}while((n|0)<=(e|0));r=l&-4;s=g}if((r|0)<(l|0)){g=s;e=r;while(1){r=(j[a+(e<<1)>>1]|0)+g|0;e=e+1|0;if((e|0)==(l|0)){t=r;break}else g=r}}else t=s;m=t+h|0;f[d>>2]=m;return 0}function XG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return oH(a,b,c,d,e)|0}function YG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return nH(a,b,c,d,e)|0}function ZG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return mH(a,b,c,d,e)|0}function _G(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;n=i;while(1){o=n+ +L(+(+p[j+(m<<3)>>3]));m=m+1|0;if((m|0)==(f|0)){l=o;break}else n=o}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<3)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){q=0;r=0.0}else{l=0.0;f=0;do{i=+L(+(+p[a+(f<<3)>>3]));n=i+ +L(+(+p[a+((f|1)<<3)>>3]));i=n+ +L(+(+p[a+((f|2)<<3)>>3]));l=l+(i+ +L(+(+p[a+((f|3)<<3)>>3])));f=f+4|0}while((f|0)<=(e|0));q=j&-4;r=l}if((q|0)<(j|0)){l=r;e=q;while(1){i=l+ +L(+(+p[a+(e<<3)>>3]));e=e+1|0;if((e|0)==(j|0)){s=i;break}else l=i}}else s=r;k=g+s;p[d>>3]=k;return 0}function $G(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return lH(a,b,c,d,e)|0}function aH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return kH(a,b,c,d,e)|0}function bH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return jH(a,b,c,d,e)|0}function cH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return iH(a,b,c,d,e)|0}function dH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return hH(a,b,c,d,e)|0}function eH(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return gH(a,b,c,d,e)|0}function fH(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0,t=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;n=i;while(1){o=+p[j+(m<<3)>>3];q=n+o*o;m=m+1|0;if((m|0)==(f|0)){l=q;break}else n=q}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<3)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){r=0.0;s=0}else{f=0;l=0.0;do{i=+p[a+(f<<3)>>3];n=+p[a+((f|1)<<3)>>3];q=+p[a+((f|2)<<3)>>3];o=+p[a+((f|3)<<3)>>3];l=l+(i*i+n*n+q*q+o*o);f=f+4|0}while((f|0)<=(e|0));r=l;s=j&-4}if((s|0)<(j|0)){e=s;l=r;while(1){o=+p[a+(e<<3)>>3];q=l+o*o;e=e+1|0;if((e|0)==(j|0)){t=q;break}else l=q}}else t=r;k=g+t;p[d>>3]=k;return 0}function gH(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;o=i;while(1){q=+n[j+(m<<2)>>2];r=o+q*q;m=m+1|0;if((m|0)==(f|0)){l=r;break}else o=r}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<2)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){s=0.0;t=0}else{f=0;l=0.0;do{i=+n[a+(f<<2)>>2];o=+n[a+((f|1)<<2)>>2];r=+n[a+((f|2)<<2)>>2];q=+n[a+((f|3)<<2)>>2];l=l+(i*i+o*o+r*r+q*q);f=f+4|0}while((f|0)<=(e|0));s=l;t=j&-4}if((t|0)<(j|0)){e=t;l=s;while(1){q=+n[a+(e<<2)>>2];r=l+q*q;e=e+1|0;if((e|0)==(j|0)){u=r;break}else l=r}}else u=s;k=g+u;p[d>>3]=k;return 0}function hH(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;h=+p[d>>3];if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;p[d>>3]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){q=+(f[k+(n<<2)>>2]|0);r=o+q*q;n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+(g<<2)|0}}p[d>>3]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){s=0.0;t=0}else{g=0;m=0.0;do{j=+(f[a+(g<<2)>>2]|0);o=+(f[a+((g|1)<<2)>>2]|0);r=+(f[a+((g|2)<<2)>>2]|0);q=+(f[a+((g|3)<<2)>>2]|0);m=m+(j*j+o*o+r*r+q*q);g=g+4|0}while((g|0)<=(e|0));s=m;t=k&-4}if((t|0)<(k|0)){e=t;m=s;while(1){q=+(f[a+(e<<2)>>2]|0);r=m+q*q;e=e+1|0;if((e|0)==(k|0)){u=r;break}else m=r}}else u=s;l=h+u;p[d>>3]=l;return 0}function iH(a,c,e,f,g){a=a|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;h=+p[e>>3];if(c|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;p[e>>3]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){q=+(d[k+(n<<1)>>1]|0);r=o+q*q;n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(f|0)){l=m;break}else{j=m;k=k+(g<<1)|0}}p[e>>3]=l;return 0}k=Y(g,f)|0;f=k+-4|0;if((k|0)<4){s=0.0;t=0}else{g=0;m=0.0;do{j=+(d[a+(g<<1)>>1]|0);o=+(d[a+((g|1)<<1)>>1]|0);r=+(d[a+((g|2)<<1)>>1]|0);q=+(d[a+((g|3)<<1)>>1]|0);m=m+(j*j+o*o+r*r+q*q);g=g+4|0}while((g|0)<=(f|0));s=m;t=k&-4}if((t|0)<(k|0)){f=t;m=s;while(1){q=+(d[a+(f<<1)>>1]|0);r=m+q*q;f=f+1|0;if((f|0)==(k|0)){u=r;break}else m=r}}else u=s;l=h+u;p[e>>3]=l;return 0}function jH(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;k=a}else{l=g;p[d>>3]=l;return 0}while(1){if(!(b[c+h>>0]|0))m=i;else{n=0;o=i;while(1){q=+(j[k+(n<<1)>>1]|0);r=o+q*q;n=n+1|0;if((n|0)==(f|0)){m=r;break}else o=r}}h=h+1|0;if((h|0)==(e|0)){l=m;break}else{i=m;k=k+(f<<1)|0}}p[d>>3]=l;return 0}k=Y(f,e)|0;e=k+-4|0;if((k|0)<4){s=0.0;t=0}else{f=0;m=0.0;do{i=+(j[a+(f<<1)>>1]|0);o=+(j[a+((f|1)<<1)>>1]|0);r=+(j[a+((f|2)<<1)>>1]|0);q=+(j[a+((f|3)<<1)>>1]|0);m=m+(i*i+o*o+r*r+q*q);f=f+4|0}while((f|0)<=(e|0));s=m;t=k&-4}if((t|0)<(k|0)){e=t;m=s;while(1){q=+(j[a+(e<<1)>>1]|0);r=m+q*q;e=e+1|0;if((e|0)==(k|0)){u=r;break}else m=r}}else u=s;l=g+u;p[d>>3]=l;return 0}function kH(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;f[d>>2]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){p=b[k+n>>0]|0;q=(Y(p,p)|0)+o|0;n=n+1|0;if((n|0)==(g|0)){m=q;break}else o=q}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+g|0}}f[d>>2]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){r=0;s=0}else{g=0;m=0;do{j=b[a+g>>0]|0;i=b[a+(g|1)>>0]|0;c=b[a+(g|2)>>0]|0;o=b[a+(g|3)>>0]|0;m=(Y(j,j)|0)+m+(Y(i,i)|0)+(Y(c,c)|0)+(Y(o,o)|0)|0;g=g+4|0}while((g|0)<=(e|0));r=m;s=k&-4}if((s|0)<(k|0)){m=s;s=r;while(1){e=b[a+m>>0]|0;g=(Y(e,e)|0)+s|0;m=m+1|0;if((m|0)==(k|0)){t=g;break}else s=g}}else t=r;l=t+h|0;f[d>>2]=l;return 0}function lH(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){j=0;k=i;l=a}else{m=i;f[d>>2]=m;return 0}while(1){if(!(b[c+j>>0]|0))n=k;else{o=0;p=k;while(1){q=h[l+o>>0]|0;r=(Y(q,q)|0)+p|0;o=o+1|0;if((o|0)==(g|0)){n=r;break}else p=r}}j=j+1|0;if((j|0)==(e|0)){m=n;break}else{k=n;l=l+g|0}}f[d>>2]=m;return 0}l=Y(g,e)|0;e=l+-4|0;if((l|0)<4){s=0;t=0}else{g=0;n=0;do{k=h[a+g>>0]|0;j=h[a+(g|1)>>0]|0;c=h[a+(g|2)>>0]|0;p=h[a+(g|3)>>0]|0;n=(Y(k,k)|0)+n+(Y(j,j)|0)+(Y(c,c)|0)+(Y(p,p)|0)|0;g=g+4|0}while((g|0)<=(e|0));s=n;t=l&-4}if((t|0)<(l|0)){n=t;t=s;while(1){e=h[a+n>>0]|0;g=(Y(e,e)|0)+t|0;n=n+1|0;if((n|0)==(l|0)){u=g;break}else t=g}}else u=s;m=u+i|0;f[d>>2]=m;return 0}function mH(a,c,d,e,f){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0.0,l=0.0,m=0,o=0.0,q=0.0,r=0,s=0.0,t=0.0;g=+p[d>>3];if(c|0){if((e|0)>0&(f|0)>0){h=0;i=g;j=a}else{k=g;p[d>>3]=k;return 0}while(1){if(!(b[c+h>>0]|0))l=i;else{m=0;o=i;while(1){q=o+ +L(+(+n[j+(m<<2)>>2]));m=m+1|0;if((m|0)==(f|0)){l=q;break}else o=q}}h=h+1|0;if((h|0)==(e|0)){k=l;break}else{i=l;j=j+(f<<2)|0}}p[d>>3]=k;return 0}j=Y(f,e)|0;e=j+-4|0;if((j|0)<4){r=0;s=0.0}else{l=0.0;f=0;do{i=+L(+(+n[a+(f<<2)>>2]));o=i+ +L(+(+n[a+((f|1)<<2)>>2]));i=o+ +L(+(+n[a+((f|2)<<2)>>2]));l=l+(i+ +L(+(+n[a+((f|3)<<2)>>2])));f=f+4|0}while((f|0)<=(e|0));r=j&-4;s=l}if((r|0)<(j|0)){l=s;e=r;while(1){i=l+ +L(+(+n[a+(e<<2)>>2]));e=e+1|0;if((e|0)==(j|0)){t=i;break}else l=i}}else t=s;k=g+t;p[d>>3]=k;return 0}function nH(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0,o=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0;h=+p[d>>3];if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;p[d>>3]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){q=f[k+(n<<2)>>2]|0;r=o+ +(((q|0)>-1?q:0-q|0)|0);n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+(g<<2)|0}}p[d>>3]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){s=0;t=0.0}else{m=0.0;g=0;do{i=f[a+(g<<2)>>2]|0;c=f[a+((g|1)<<2)>>2]|0;n=f[a+((g|2)<<2)>>2]|0;q=f[a+((g|3)<<2)>>2]|0;m=m+(+(((i|0)>-1?i:0-i|0)|0)+ +(((c|0)>-1?c:0-c|0)|0)+ +(((n|0)>-1?n:0-n|0)|0)+ +(((q|0)>-1?q:0-q|0)|0));g=g+4|0}while((g|0)<=(e|0));s=k&-4;t=m}if((s|0)<(k|0)){m=t;e=s;while(1){s=f[a+(e<<2)>>2]|0;j=m+ +(((s|0)>-1?s:0-s|0)|0);e=e+1|0;if((e|0)==(k|0)){u=j;break}else m=j}}else u=t;l=h+u;p[d>>3]=l;return 0}function oH(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(c|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a}else{m=i;f[e>>2]=m;return 0}while(1){if(!(b[c+j>>0]|0))n=k;else{o=0;p=k;while(1){q=d[l+(o<<1)>>1]|0;r=q<<16>>16;s=(q<<16>>16>-1?r:0-r|0)+p|0;o=o+1|0;if((o|0)==(h|0)){n=s;break}else p=s}}j=j+1|0;if((j|0)==(g|0)){m=n;break}else{k=n;l=l+(h<<1)|0}}f[e>>2]=m;return 0}l=Y(h,g)|0;g=l+-4|0;if((l|0)<4){t=0;u=0}else{h=0;n=0;do{k=d[a+(n<<1)>>1]|0;j=k<<16>>16;c=d[a+((n|1)<<1)>>1]|0;p=c<<16>>16;o=d[a+((n|2)<<1)>>1]|0;s=o<<16>>16;r=d[a+((n|3)<<1)>>1]|0;q=r<<16>>16;h=(k<<16>>16>-1?j:0-j|0)+h+(c<<16>>16>-1?p:0-p|0)+(o<<16>>16>-1?s:0-s|0)+(r<<16>>16>-1?q:0-q|0)|0;n=n+4|0}while((n|0)<=(g|0));t=l&-4;u=h}if((t|0)<(l|0)){h=u;g=t;while(1){t=d[a+(g<<1)>>1]|0;n=t<<16>>16;q=(t<<16>>16>-1?n:0-n|0)+h|0;g=g+1|0;if((g|0)==(l|0)){v=q;break}else h=q}}else v=u;m=v+i|0;f[e>>2]=m;return 0}function pH(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=f[d>>2]|0;if(c|0){if((e|0)>0&(g|0)>0){i=0;j=h;k=a}else{l=h;f[d>>2]=l;return 0}while(1){if(!(b[c+i>>0]|0))m=j;else{n=0;o=j;while(1){p=b[k+n>>0]|0;q=p<<24>>24;r=(p<<24>>24>-1?q:0-q|0)+o|0;n=n+1|0;if((n|0)==(g|0)){m=r;break}else o=r}}i=i+1|0;if((i|0)==(e|0)){l=m;break}else{j=m;k=k+g|0}}f[d>>2]=l;return 0}k=Y(g,e)|0;e=k+-4|0;if((k|0)<4){s=0;t=0}else{g=0;m=0;do{j=b[a+m>>0]|0;i=j<<24>>24;c=b[a+(m|1)>>0]|0;o=c<<24>>24;n=b[a+(m|2)>>0]|0;r=n<<24>>24;q=b[a+(m|3)>>0]|0;p=q<<24>>24;g=(j<<24>>24>-1?i:0-i|0)+g+(c<<24>>24>-1?o:0-o|0)+(n<<24>>24>-1?r:0-r|0)+(q<<24>>24>-1?p:0-p|0)|0;m=m+4|0}while((m|0)<=(e|0));s=k&-4;t=g}if((s|0)<(k|0)){g=t;e=s;while(1){s=b[a+e>>0]|0;m=s<<24>>24;p=(s<<24>>24>-1?m:0-m|0)+g|0;e=e+1|0;if((e|0)==(k|0)){u=p;break}else g=p}}else u=t;l=u+h|0;f[d>>2]=l;return 0}function qH(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0,ea=0,fa=0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0;g=u;u=u+320|0;h=g+312|0;i=g+256|0;j=g+200|0;k=g+144|0;l=g+88|0;m=g+72|0;o=g;q=g+40|0;r=g+32|0;dQ(h,41200);if(!(DM(a,c)|0?(t=BL(a,-1)|0,(t|0)==(BL(c,-1)|0)):0)){f[i>>2]=0;f[i+4>>2]=0;v=aD(i,53)|0;w=176900;x=v+53|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,i,176338,175475,3633);bD(i)}if(!(d&8)){do if((yM(a)|0)==65536){t=f[a+4>>2]|0;f[i>>2]=f[t>>2];y=i+4|0;z=t+4|0;f[y>>2]=f[z>>2];A=i+8|0;f[A>>2]=f[t+8>>2];f[i+12>>2]=f[t+12>>2];f[i+16>>2]=f[t+16>>2];f[i+20>>2]=f[t+20>>2];f[i+24>>2]=f[t+24>>2];f[i+28>>2]=f[t+28>>2];f[i+32>>2]=f[t+32>>2];B=f[t+36>>2]|0;f[i+36>>2]=B;f[i+40>>2]=A;A=i+48|0;C=i+44|0;f[C>>2]=A;f[A>>2]=0;f[i+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[t+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(i,t);break}}else yL(i,a,-1);while(0);do if((yM(c)|0)==65536){t=f[c+4>>2]|0;f[j>>2]=f[t>>2];y=j+4|0;z=t+4|0;f[y>>2]=f[z>>2];A=j+8|0;f[A>>2]=f[t+8>>2];f[j+12>>2]=f[t+12>>2];f[j+16>>2]=f[t+16>>2];f[j+20>>2]=f[t+20>>2];f[j+24>>2]=f[t+24>>2];f[j+28>>2]=f[t+28>>2];f[j+32>>2]=f[t+32>>2];C=f[t+36>>2]|0;f[j+36>>2]=C;f[j+40>>2]=A;A=j+48|0;B=j+44|0;f[B>>2]=A;f[A>>2]=0;f[j+52>>2]=0;if(C|0){A=C+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[t+44>>2]|0;A=f[B>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(j,t);break}}else yL(j,c,-1);while(0);do if((yM(e)|0)==65536){t=f[e+4>>2]|0;f[k>>2]=f[t>>2];y=k+4|0;z=t+4|0;f[y>>2]=f[z>>2];A=k+8|0;f[A>>2]=f[t+8>>2];f[k+12>>2]=f[t+12>>2];f[k+16>>2]=f[t+16>>2];f[k+20>>2]=f[t+20>>2];f[k+24>>2]=f[t+24>>2];f[k+28>>2]=f[t+28>>2];f[k+32>>2]=f[t+32>>2];B=f[t+36>>2]|0;f[k+36>>2]=B;f[k+40>>2]=A;A=k+48|0;C=k+44|0;f[C>>2]=A;f[A>>2]=0;f[k+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[t+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(k,t);break}}else yL(k,e,-1);while(0);t=f[i>>2]|0;y=t&7;z=(t>>>3&511)+1|0;A=d&7;C=(A|0)==1;B=(A|0)==2;D=(A|0)==4;E=(A|0)==5;switch(d&7){case 1:case 2:case 4:case 5:{F=t;break}default:if((A|1|0)==7&(t&4095|0)==0)F=t;else{f[l>>2]=0;f[l+4>>2]=0;Vac(aD(l,173)|0,176954,173)|0;bO(-215,l,176338,175475,3658);bD(l);F=f[i>>2]|0}}do if((F&16384|0)!=0?(f[j>>2]&16384|0)!=0:0){if(f[k+16>>2]|0){t=f[k+4>>2]|0;if((t|0)<3)G=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{H=f[k+40>>2]|0;I=0;J=1;while(1){K=Y(f[H+(I<<2)>>2]|0,J)|0;I=I+1|0;if((I|0)==(t|0)){G=K;break}else J=K}}if(!((t|0)==0|(G|0)==0)){N=68;break}}J=f[i+4>>2]|0;if((J|0)<3)O=Y(f[i+12>>2]|0,f[i+8>>2]|0)|0;else{I=f[i+40>>2]|0;H=0;K=1;while(1){P=Y(f[I+(H<<2)>>2]|0,K)|0;H=H+1|0;if((H|0)==(J|0)){O=P;break}else K=P}}K=Y((F>>>3&511)+1|0,O)|0;if((F&7|0)==5){J=f[i+16>>2]|0;H=f[j+16>>2]|0;if(D){I=K+-4|0;if((K|0)<4){Q=0.0;R=0}else{t=0;S=0.0;do{T=+n[J+(t<<2)>>2]-+n[H+(t<<2)>>2];P=t|1;U=+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2];P=t|2;V=+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2];P=t|3;W=+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2];S=S+(T*T+U*U+V*V+W*W);t=t+4|0}while((t|0)<=(I|0));Q=S;R=K&-4}if((R|0)<(K|0)){I=R;W=Q;while(1){V=+n[J+(I<<2)>>2]-+n[H+(I<<2)>>2];U=W+V*V;I=I+1|0;if((I|0)==(K|0)){X=U;break}else W=U}}else X=Q;Z=+M(+(X+0.0));break}if(E){I=K+-4|0;if((K|0)<4){_=0.0;$=0}else{t=0;W=0.0;do{S=+n[J+(t<<2)>>2]-+n[H+(t<<2)>>2];P=t|1;U=+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2];P=t|2;V=+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2];P=t|3;T=+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2];W=W+(S*S+U*U+V*V+T*T);t=t+4|0}while((t|0)<=(I|0));_=W;$=K&-4}if(($|0)<(K|0)){I=$;T=_;while(1){V=+n[J+(I<<2)>>2]-+n[H+(I<<2)>>2];U=T+V*V;I=I+1|0;if((I|0)==(K|0)){aa=U;break}else T=U}}else aa=_;Z=aa+0.0;break}if(!B){if(!C){N=68;break}if((K|0)>0){I=0;T=0.0;while(1){W=+L(+(+n[J+(I<<2)>>2]-+n[H+(I<<2)>>2]));U=T<W?W:T;I=I+1|0;if((I|0)==(K|0)){ba=U;break}else T=U}}else ba=0.0;Z=ba>0.0?ba:0.0;break}I=K+-4|0;if((K|0)<4){ca=0.0;da=0}else{t=0;T=0.0;do{P=t|1;ea=t|2;fa=t|3;T=T+(+L(+(+n[J+(t<<2)>>2]-+n[H+(t<<2)>>2]))+ +L(+(+n[J+(P<<2)>>2]-+n[H+(P<<2)>>2]))+ +L(+(+n[J+(ea<<2)>>2]-+n[H+(ea<<2)>>2]))+ +L(+(+n[J+(fa<<2)>>2]-+n[H+(fa<<2)>>2])));t=t+4|0}while((t|0)<=(I|0));ca=T;da=K&-4}if((da|0)<(K|0)){I=da;U=ca;while(1){W=U+ +L(+(+n[J+(I<<2)>>2]-+n[H+(I<<2)>>2]));I=I+1|0;if((I|0)==(K|0)){ga=W;break}else U=W}}else ga=ca;Z=ga+0.0}else N=68}else N=68;while(0);do if((N|0)==68){da=k+16|0;if(f[da>>2]|0){$=f[k+4>>2]|0;if(($|0)<3)ha=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{E=f[k+40>>2]|0;R=0;F=1;while(1){O=Y(f[E+(R<<2)>>2]|0,F)|0;R=R+1|0;if((R|0)==($|0)){ha=O;break}else F=O}}if(!(($|0)==0|(ha|0)==0)?f[k>>2]&4095|0:0){f[l>>2]=0;f[l+4>>2]=0;v=aD(l,32)|0;w=175618;x=v+32|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,l,176338,175475,3698);bD(l)}}$=(A|0)==6;F=A|1;if((F|0)==7){if(f[da>>2]|0){R=f[k+4>>2]|0;if((R|0)<3)ia=Y(f[k+12>>2]|0,f[k+8>>2]|0)|0;else{E=f[k+40>>2]|0;O=0;G=1;while(1){K=Y(f[E+(O<<2)>>2]|0,G)|0;O=O+1|0;if((O|0)==(R|0)){ia=K;break}else G=K}}if(!((R|0)==0|(ia|0)==0)){f[l>>2]=1124007936;G=l+4|0;O=l+8|0;E=l+40|0;v=G;x=v+36|0;do{f[v>>2]=0;v=v+4|0}while((v|0)<(x|0));f[E>>2]=O;R=l+48|0;da=l+44|0;f[da>>2]=R;f[R>>2]=0;f[l+52>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=i;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=j;K=q+8|0;f[K>>2]=0;f[K+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=l;kD(m,o,q,UM()|0);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=l;f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;K=q+8|0;f[K>>2]=0;f[K+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=l;dD(m,o,q,UM()|0);f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=l;ga=+LG(m,A,UM()|0);K=l+36|0;I=f[K>>2]|0;if(I|0?(H=I+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)kL(l);f[K>>2]=0;K=l+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[G>>2]|0)>0){K=f[E>>2]|0;I=0;do{f[K+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[G>>2]|0))}G=f[da>>2]|0;if((G|0)!=(R|0))UC(G);Z=ga;break}}G=$?1:2;f[l>>2]=i;f[l+4>>2]=j;f[l+8>>2]=0;RN(o,l,m,-1);I=f[o+20>>2]|0;K=o+16|0;E=m+4|0;O=0;H=0;while(1){if(O>>>0>=(f[K>>2]|0)>>>0)break;J=(rH(f[m>>2]|0,f[E>>2]|0,I,G)|0)+H|0;aL(o)|0;O=O+1|0;H=J}Z=+(H|0);break}O=f[41220+(A>>>1<<5)+(y<<2)>>2]|0;if(!O){f[l>>2]=0;f[l+4>>2]=0;v=aD(l,9)|0;w=255890;x=v+9|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,l,176338,175475,3726);bD(l)}f[l>>2]=i;f[l+4>>2]=j;f[l+8>>2]=k;f[l+12>>2]=0;p[o>>3]=0.0;RN(q,l,m,-1);H=f[q+20>>2]|0;G=y>>>0<2;f[r>>2]=0;if(B&y>>>0<4|(F|0)==5&G){I=B&G?8388608:32768;G=(I|0)<(H|0)?I:H;E=f[i+4>>2]|0;if((E|0)>0){ja=f[(f[i+44>>2]|0)+(E+-1<<2)>>2]|0;ka=r;la=I;ma=G;na=1}else{ja=0;ka=r;la=I;ma=G;na=1}}else{ja=0;ka=o;la=0;ma=H;na=0}G=q+16|0;I=(H|0)>0;E=m+4|0;K=m+8|0;$=0;R=0;while(1){if($>>>0>=(f[G>>2]|0)>>>0)break;da=$+1|0;a:do if(I){J=f[m>>2]|0;t=f[E>>2]|0;fa=f[K>>2]|0;if(na){oa=0;pa=R;qa=J;ra=t;sa=fa}else{ea=0;P=R;ta=J;J=t;t=fa;while(1){fa=H-ea|0;ua=(ma|0)<(fa|0)?ma:fa;Xf[O&127](ta,J,t,ka,ua,z)|0;fa=ua+P|0;va=Y(ua,ja)|0;ta=(f[m>>2]|0)+va|0;f[m>>2]=ta;J=(f[E>>2]|0)+va|0;f[E>>2]=J;va=f[K>>2]|0;if(!va)wa=0;else{xa=va+ua|0;f[K>>2]=xa;wa=xa}ea=ea+ma|0;if((H|0)<=(ea|0)){ya=fa;break a}else{P=fa;t=wa}}}while(1){t=H-oa|0;P=(ma|0)<(t|0)?ma:t;Xf[O&127](qa,ra,sa,ka,P,z)|0;t=P+pa|0;if((t+ma|0)<(la|0)?((P+oa|0)<(H|0)?1:da>>>0<(f[G>>2]|0)>>>0):0)za=t;else{p[o>>3]=+p[o>>3]+ +((f[r>>2]|0)>>>0);f[r>>2]=0;za=0}t=Y(P,ja)|0;qa=(f[m>>2]|0)+t|0;f[m>>2]=qa;ra=(f[E>>2]|0)+t|0;f[E>>2]=ra;t=f[K>>2]|0;if(!t)Aa=0;else{ea=t+P|0;f[K>>2]=ea;Aa=ea}oa=oa+ma|0;if((H|0)<=(oa|0)){ya=za;break}else{pa=za;sa=Aa}}}else ya=R;while(0);aL(q)|0;$=da;R=ya}if(C){if((y|0)!=6){R=f[o>>2]|0;p[o>>3]=(y|0)==5?(f[s>>2]=R,+n[s>>2]):+(R>>>0)}}else if(D){ga=+M(+(+p[o>>3]));p[o>>3]=ga}Z=+p[o>>3]}while(0);o=k+36|0;D=f[o>>2]|0;if(D|0?(y=D+12|0,D=f[y>>2]|0,f[y>>2]=D+-1,(D|0)==1):0)kL(k);f[o>>2]=0;o=k+16|0;D=k+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[D>>2]|0)>0){o=f[k+40>>2]|0;y=0;do{f[o+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[D>>2]|0))}D=f[k+44>>2]|0;if((D|0)!=(k+48|0))UC(D);D=j+36|0;k=f[D>>2]|0;if(k|0?(y=k+12|0,k=f[y>>2]|0,f[y>>2]=k+-1,(k|0)==1):0)kL(j);f[D>>2]=0;D=j+16|0;k=j+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[k>>2]|0)>0){D=f[j+40>>2]|0;y=0;do{f[D+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))UC(k);k=i+36|0;j=f[k>>2]|0;if(j|0?(y=j+12|0,j=f[y>>2]|0,f[y>>2]=j+-1,(j|0)==1):0)kL(i);f[k>>2]=0;k=i+16|0;j=i+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[j>>2]|0)>0){k=f[i+40>>2]|0;y=0;do{f[k+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))UC(j);Ba=Z}else{Z=+qH(a,c,d&-9,e);Ba=Z/(+LG(c,d,e)+2.220446049250313e-16)}if(!(f[h+4>>2]|0)){u=g;return +Ba}u=g;return +Ba}function rH(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;switch(e|0){case 1:{f=vI(a,c,d)|0;return f|0}case 2:{g=176343;break}case 4:{g=176599;break}default:{f=-1;return f|0}}e=d+-4|0;if((d|0)<4){i=0;j=0}else{k=0;l=0;do{m=k|1;n=k|2;o=k|3;l=(h[g+((b[c+k>>0]^b[a+k>>0])&255)>>0]|0)+l+(h[g+((b[c+m>>0]^b[a+m>>0])&255)>>0]|0)+(h[g+((b[c+n>>0]^b[a+n>>0])&255)>>0]|0)+(h[g+((b[c+o>>0]^b[a+o>>0])&255)>>0]|0)|0;k=k+4|0}while((k|0)<=(e|0));i=l;j=d&-4}if((j|0)<(d|0)){p=j;q=i}else{f=i;return f|0}while(1){i=(h[g+((b[c+p>>0]^b[a+p>>0])&255)>>0]|0)+q|0;p=p+1|0;if((p|0)==(d|0)){f=i;break}else q=i}return f|0}function sH(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=f[e>>2]|0;if(!d){k=Y(i,g)|0;if((k|0)>0){l=0;m=0;while(1){n=(h[a+m>>0]|0)-(h[c+m>>0]|0)|0;o=(n|0)>-1?n:0-n|0;n=(l|0)<(o|0)?o:l;m=m+1|0;if((m|0)==(k|0)){p=n;break}else l=n}}else p=0;q=(j|0)<(p|0)?p:j;f[e>>2]=q;return 0}if((g|0)>0&(i|0)>0){r=0;s=a;t=c;u=j}else{q=j;f[e>>2]=q;return 0}while(1){if(!(b[d+r>>0]|0))v=u;else{j=0;c=u;while(1){a=(h[s+j>>0]|0)-(h[t+j>>0]|0)|0;p=(a|0)>-1?a:0-a|0;a=(c|0)<(p|0)?p:c;j=j+1|0;if((j|0)==(i|0)){v=a;break}else c=a}}r=r+1|0;if((r|0)==(g|0)){q=v;break}else{s=s+i|0;t=t+i|0;u=v}}f[e>>2]=q;return 0}function tH(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[e>>2]|0;if(!d){j=Y(h,g)|0;if((j|0)>0){k=0;l=0;while(1){m=(b[a+l>>0]|0)-(b[c+l>>0]|0)|0;n=(m|0)>-1?m:0-m|0;m=(k|0)<(n|0)?n:k;l=l+1|0;if((l|0)==(j|0)){o=m;break}else k=m}}else o=0;p=(i|0)<(o|0)?o:i;f[e>>2]=p;return 0}if((g|0)>0&(h|0)>0){q=0;r=a;s=c;t=i}else{p=i;f[e>>2]=p;return 0}while(1){if(!(b[d+q>>0]|0))u=t;else{i=0;c=t;while(1){a=(b[r+i>>0]|0)-(b[s+i>>0]|0)|0;o=(a|0)>-1?a:0-a|0;a=(c|0)<(o|0)?o:c;i=i+1|0;if((i|0)==(h|0)){u=a;break}else c=a}}q=q+1|0;if((q|0)==(g|0)){p=u;break}else{r=r+h|0;s=s+h|0;t=u}}f[e>>2]=p;return 0}function uH(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(!d){k=Y(h,g)|0;if((k|0)>0){l=0;m=0;while(1){n=(j[a+(m<<1)>>1]|0)-(j[c+(m<<1)>>1]|0)|0;o=(n|0)>-1?n:0-n|0;n=(l|0)<(o|0)?o:l;m=m+1|0;if((m|0)==(k|0)){p=n;break}else l=n}}else p=0;q=(i|0)<(p|0)?p:i;f[e>>2]=q;return 0}if((g|0)>0&(h|0)>0){r=0;s=a;t=c;u=i}else{q=i;f[e>>2]=q;return 0}while(1){if(!(b[d+r>>0]|0))v=u;else{i=0;c=u;while(1){a=(j[s+(i<<1)>>1]|0)-(j[t+(i<<1)>>1]|0)|0;p=(a|0)>-1?a:0-a|0;a=(c|0)<(p|0)?p:c;i=i+1|0;if((i|0)==(h|0)){v=a;break}else c=a}}r=r+1|0;if((r|0)==(g|0)){q=v;break}else{s=s+(h<<1)|0;t=t+(h<<1)|0;u=v}}f[e>>2]=q;return 0}function vH(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=f[g>>2]|0;if(!e){k=Y(i,h)|0;if((k|0)>0){l=0;m=0;while(1){n=(d[a+(m<<1)>>1]|0)-(d[c+(m<<1)>>1]|0)|0;o=(n|0)>-1?n:0-n|0;n=(l|0)<(o|0)?o:l;m=m+1|0;if((m|0)==(k|0)){p=n;break}else l=n}}else p=0;q=(j|0)<(p|0)?p:j;f[g>>2]=q;return 0}if((h|0)>0&(i|0)>0){r=0;s=a;t=c;u=j}else{q=j;f[g>>2]=q;return 0}while(1){if(!(b[e+r>>0]|0))v=u;else{j=0;c=u;while(1){a=(d[s+(j<<1)>>1]|0)-(d[t+(j<<1)>>1]|0)|0;p=(a|0)>-1?a:0-a|0;a=(c|0)<(p|0)?p:c;j=j+1|0;if((j|0)==(i|0)){v=a;break}else c=a}}r=r+1|0;if((r|0)==(h|0)){q=v;break}else{s=s+(i<<1)|0;t=t+(i<<1)|0;u=v}}f[g>>2]=q;return 0}function wH(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=f[e>>2]|0;if(!d){j=Y(h,g)|0;if((j|0)>0){k=0;l=0;while(1){m=(f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0;n=(m|0)>-1?m:0-m|0;m=(k|0)<(n|0)?n:k;l=l+1|0;if((l|0)==(j|0)){o=m;break}else k=m}}else o=0;p=(i|0)<(o|0)?o:i;f[e>>2]=p;return 0}if((g|0)>0&(h|0)>0){q=0;r=a;s=c;t=i}else{p=i;f[e>>2]=p;return 0}while(1){if(!(b[d+q>>0]|0))u=t;else{i=0;c=t;while(1){a=(f[r+(i<<2)>>2]|0)-(f[s+(i<<2)>>2]|0)|0;o=(a|0)>-1?a:0-a|0;a=(c|0)<(o|0)?o:c;i=i+1|0;if((i|0)==(h|0)){u=a;break}else c=a}}q=q+1|0;if((q|0)==(g|0)){p=u;break}else{r=r+(h<<2)|0;s=s+(h<<2)|0;t=u}}f[e>>2]=p;return 0}function xH(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0.0,r=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0;i=f[e>>2]|0;j=(f[s>>2]=i,+n[s>>2]);if(!d){k=Y(h,g)|0;if((k|0)>0){l=0;m=0.0;while(1){o=+L(+(+n[a+(l<<2)>>2]-+n[c+(l<<2)>>2]));p=m<o?o:m;l=l+1|0;if((l|0)==(k|0)){q=p;break}else m=p}}else q=0.0;r=(n[s>>2]=j<q?q:j,f[s>>2]|0);f[e>>2]=r;return 0}if((g|0)>0&(h|0)>0){t=0;u=a;v=c;w=j;x=i}else{r=i;f[e>>2]=r;return 0}while(1){if(!(b[d+t>>0]|0)){y=w;z=x}else{i=0;j=w;do{q=+L(+(+n[u+(i<<2)>>2]-+n[v+(i<<2)>>2]));j=j<q?q:j;i=i+1|0}while((i|0)!=(h|0));y=j;z=(n[s>>2]=j,f[s>>2]|0)}t=t+1|0;if((t|0)==(g|0)){r=z;break}else{u=u+(h<<2)|0;v=v+(h<<2)|0;w=y;x=z}}f[e>>2]=r;return 0}function yH(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,q=0,r=0,s=0,t=0.0,u=0.0;h=+p[e>>3];if(!d){i=Y(g,f)|0;if((i|0)>0){j=0.0;k=0;while(1){l=+L(+(+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3]));m=j<l?l:j;k=k+1|0;if((k|0)==(i|0)){n=m;break}else j=m}}else n=0.0;o=h<n?n:h;p[e>>3]=o;return 0}if((f|0)>0&(g|0)>0){q=0;r=a;s=c;t=h}else{o=h;p[e>>3]=o;return 0}while(1){if(!(b[d+q>>0]|0))u=t;else{c=0;h=t;while(1){n=+L(+(+p[r+(c<<3)>>3]-+p[s+(c<<3)>>3]));j=h<n?n:h;c=c+1|0;if((c|0)==(g|0)){u=j;break}else h=j}}q=q+1|0;if((q|0)==(f|0)){o=u;break}else{r=r+(g<<3)|0;s=s+(g<<3)|0;t=u}}p[e>>3]=o;return 0}function zH(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=f[e>>2]|0;if(d|0){if((g|0)>0&(i|0)>0){k=0;l=j;m=a;n=c}else{o=j;f[e>>2]=o;return 0}while(1){if(!(b[d+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(h[m+q>>0]|0)-(h[n+q>>0]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(i|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(g|0)){o=p;break}else{l=p;m=m+i|0;n=n+i|0}}f[e>>2]=o;return 0}n=Y(i,g)|0;g=n+-4|0;if((n|0)<4){u=0;v=0}else{i=0;m=0;do{p=(h[a+i>>0]|0)-(h[c+i>>0]|0)|0;l=i|1;k=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|2;d=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|3;r=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;m=((p|0)>-1?p:0-p|0)+m+((k|0)>-1?k:0-k|0)+((d|0)>-1?d:0-d|0)+((r|0)>-1?r:0-r|0)|0;i=i+4|0}while((i|0)<=(g|0));u=m;v=n&-4}if((v|0)<(n|0)){m=v;v=u;while(1){g=(h[a+m>>0]|0)-(h[c+m>>0]|0)|0;i=((g|0)>-1?g:0-g|0)+v|0;m=m+1|0;if((m|0)==(n|0)){w=i;break}else v=i}}else w=u;o=w+j|0;f[e>>2]=o;return 0}function AH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return YH(a,b,c,d,e,f)|0}function BH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return XH(a,b,c,d,e,f)|0}function CH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return WH(a,b,c,d,e,f)|0}function DH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return VH(a,b,c,d,e,f)|0}function EH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return UH(a,b,c,d,e,f)|0}function FH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return TH(a,b,c,d,e,f)|0}function GH(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=f[e>>2]|0;if(d|0){if((g|0)>0&(i|0)>0){k=0;l=j;m=c;n=a}else{o=j;f[e>>2]=o;return 0}while(1){if(!(b[d+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(h[n+q>>0]|0)-(h[m+q>>0]|0)|0;t=(Y(s,s)|0)+r|0;q=q+1|0;if((q|0)==(i|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(g|0)){o=p;break}else{l=p;m=m+i|0;n=n+i|0}}f[e>>2]=o;return 0}n=Y(i,g)|0;g=n+-4|0;if((n|0)<4){u=0;v=0}else{i=0;m=0;do{p=(h[a+i>>0]|0)-(h[c+i>>0]|0)|0;l=i|1;k=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|2;d=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;l=i|3;r=(h[a+l>>0]|0)-(h[c+l>>0]|0)|0;m=(Y(p,p)|0)+m+(Y(k,k)|0)+(Y(d,d)|0)+(Y(r,r)|0)|0;i=i+4|0}while((i|0)<=(g|0));u=m;v=n&-4}if((v|0)<(n|0)){m=v;v=u;while(1){g=(h[a+m>>0]|0)-(h[c+m>>0]|0)|0;i=(Y(g,g)|0)+v|0;m=m+1|0;if((m|0)==(n|0)){w=i;break}else v=i}}else w=u;o=w+j|0;f[e>>2]=o;return 0}function HH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return SH(a,b,c,d,e,f)|0}function IH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return RH(a,b,c,d,e,f)|0}function JH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return QH(a,b,c,d,e,f)|0}function KH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return PH(a,b,c,d,e,f)|0}function LH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return OH(a,b,c,d,e,f)|0}function MH(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return NH(a,b,c,d,e,f)|0}function NH(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=c;l=a}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))n=j;else{o=0;q=j;while(1){r=+p[l+(o<<3)>>3]-+p[k+(o<<3)>>3];s=q+r*r;o=o+1|0;if((o|0)==(g|0)){n=s;break}else q=s}}i=i+1|0;if((i|0)==(f|0)){m=n;break}else{j=n;k=k+(g<<3)|0;l=l+(g<<3)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){t=0.0;u=0}else{g=0;n=0.0;do{j=+p[a+(g<<3)>>3]-+p[c+(g<<3)>>3];k=g|1;q=+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3];k=g|2;s=+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3];k=g|3;r=+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3];n=n+(j*j+q*q+s*s+r*r);g=g+4|0}while((g|0)<=(f|0));t=n;u=l&-4}if((u|0)<(l|0)){f=u;n=t;while(1){r=+p[a+(f<<3)>>3]-+p[c+(f<<3)>>3];s=n+r*r;f=f+1|0;if((f|0)==(l|0)){v=s;break}else n=s}}else v=t;m=h+v;p[e>>3]=m;return 0}function OH(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=c;l=a}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))o=j;else{q=0;r=j;while(1){s=+n[l+(q<<2)>>2]-+n[k+(q<<2)>>2];t=r+s*s;q=q+1|0;if((q|0)==(g|0)){o=t;break}else r=t}}i=i+1|0;if((i|0)==(f|0)){m=o;break}else{j=o;k=k+(g<<2)|0;l=l+(g<<2)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){u=0.0;v=0}else{g=0;o=0.0;do{j=+n[a+(g<<2)>>2]-+n[c+(g<<2)>>2];k=g|1;r=+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2];k=g|2;t=+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2];k=g|3;s=+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2];o=o+(j*j+r*r+t*t+s*s);g=g+4|0}while((g|0)<=(f|0));u=o;v=l&-4}if((v|0)<(l|0)){f=v;o=u;while(1){s=+n[a+(f<<2)>>2]-+n[c+(f<<2)>>2];t=o+s*s;f=f+1|0;if((f|0)==(l|0)){w=t;break}else o=t}}else w=u;m=h+w;p[e>>3]=m;return 0}function PH(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0;i=+p[e>>3];if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=c;m=a}else{n=i;p[e>>3]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{q=0;r=k;while(1){s=+((f[m+(q<<2)>>2]|0)-(f[l+(q<<2)>>2]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(h|0)){o=t;break}else r=t}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+(h<<2)|0;m=m+(h<<2)|0}}p[e>>3]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){u=0.0;v=0}else{h=0;o=0.0;do{k=+((f[a+(h<<2)>>2]|0)-(f[c+(h<<2)>>2]|0)|0);l=h|1;r=+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0);l=h|2;t=+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0);l=h|3;s=+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0);o=o+(k*k+r*r+t*t+s*s);h=h+4|0}while((h|0)<=(g|0));u=o;v=m&-4}if((v|0)<(m|0)){g=v;o=u;while(1){s=+((f[a+(g<<2)>>2]|0)-(f[c+(g<<2)>>2]|0)|0);t=o+s*s;g=g+1|0;if((g|0)==(m|0)){w=t;break}else o=t}}else w=u;n=i+w;p[e>>3]=n;return 0}function QH(a,c,e,f,g,h){a=a|0;c=c|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0;i=+p[f>>3];if(e|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=c;m=a}else{n=i;p[f>>3]=n;return 0}while(1){if(!(b[e+j>>0]|0))o=k;else{q=0;r=k;while(1){s=+((d[m+(q<<1)>>1]|0)-(d[l+(q<<1)>>1]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(h|0)){o=t;break}else r=t}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+(h<<1)|0;m=m+(h<<1)|0}}p[f>>3]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){u=0.0;v=0}else{h=0;o=0.0;do{k=+((d[a+(h<<1)>>1]|0)-(d[c+(h<<1)>>1]|0)|0);l=h|1;r=+((d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0);l=h|2;t=+((d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0);l=h|3;s=+((d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0);o=o+(k*k+r*r+t*t+s*s);h=h+4|0}while((h|0)<=(g|0));u=o;v=m&-4}if((v|0)<(m|0)){g=v;o=u;while(1){s=+((d[a+(g<<1)>>1]|0)-(d[c+(g<<1)>>1]|0)|0);t=o+s*s;g=g+1|0;if((g|0)==(m|0)){w=t;break}else o=t}}else w=u;n=i+w;p[f>>3]=n;return 0}function RH(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;k=h;l=c;m=a}else{n=h;p[e>>3]=n;return 0}while(1){if(!(b[d+i>>0]|0))o=k;else{q=0;r=k;while(1){s=+((j[m+(q<<1)>>1]|0)-(j[l+(q<<1)>>1]|0)|0);t=r+s*s;q=q+1|0;if((q|0)==(g|0)){o=t;break}else r=t}}i=i+1|0;if((i|0)==(f|0)){n=o;break}else{k=o;l=l+(g<<1)|0;m=m+(g<<1)|0}}p[e>>3]=n;return 0}m=Y(g,f)|0;f=m+-4|0;if((m|0)<4){u=0.0;v=0}else{g=0;o=0.0;do{k=+((j[a+(g<<1)>>1]|0)-(j[c+(g<<1)>>1]|0)|0);l=g|1;r=+((j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0);l=g|2;t=+((j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0);l=g|3;s=+((j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0);o=o+(k*k+r*r+t*t+s*s);g=g+4|0}while((g|0)<=(f|0));u=o;v=m&-4}if((v|0)<(m|0)){f=v;o=u;while(1){s=+((j[a+(f<<1)>>1]|0)-(j[c+(f<<1)>>1]|0)|0);t=o+s*s;f=f+1|0;if((f|0)==(m|0)){w=t;break}else o=t}}else w=u;n=h+w;p[e>>3]=n;return 0}function SH(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=c;m=a}else{n=i;f[e>>2]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{p=0;q=k;while(1){r=(b[m+p>>0]|0)-(b[l+p>>0]|0)|0;s=(Y(r,r)|0)+q|0;p=p+1|0;if((p|0)==(h|0)){o=s;break}else q=s}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+h|0;m=m+h|0}}f[e>>2]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){t=0;u=0}else{h=0;l=0;do{o=(b[a+h>>0]|0)-(b[c+h>>0]|0)|0;k=h|1;j=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|2;d=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|3;q=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;l=(Y(o,o)|0)+l+(Y(j,j)|0)+(Y(d,d)|0)+(Y(q,q)|0)|0;h=h+4|0}while((h|0)<=(g|0));t=l;u=m&-4}if((u|0)<(m|0)){l=u;u=t;while(1){g=(b[a+l>>0]|0)-(b[c+l>>0]|0)|0;h=(Y(g,g)|0)+u|0;l=l+1|0;if((l|0)==(m|0)){v=h;break}else u=h}}else v=t;n=v+i|0;f[e>>2]=n;return 0}function TH(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a;l=c}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))n=j;else{o=0;q=j;while(1){r=q+ +L(+(+p[k+(o<<3)>>3]-+p[l+(o<<3)>>3]));o=o+1|0;if((o|0)==(g|0)){n=r;break}else q=r}}i=i+1|0;if((i|0)==(f|0)){m=n;break}else{j=n;k=k+(g<<3)|0;l=l+(g<<3)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){s=0.0;t=0}else{g=0;n=0.0;do{k=g|1;i=g|2;d=g|3;n=n+(+L(+(+p[a+(g<<3)>>3]-+p[c+(g<<3)>>3]))+ +L(+(+p[a+(k<<3)>>3]-+p[c+(k<<3)>>3]))+ +L(+(+p[a+(i<<3)>>3]-+p[c+(i<<3)>>3]))+ +L(+(+p[a+(d<<3)>>3]-+p[c+(d<<3)>>3])));g=g+4|0}while((g|0)<=(f|0));s=n;t=l&-4}if((t|0)<(l|0)){f=t;n=s;while(1){j=n+ +L(+(+p[a+(f<<3)>>3]-+p[c+(f<<3)>>3]));f=f+1|0;if((f|0)==(l|0)){u=j;break}else n=j}}else u=s;m=h+u;p[e>>3]=m;return 0}function UH(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0.0,k=0,l=0,m=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0;h=+p[e>>3];if(d|0){if((f|0)>0&(g|0)>0){i=0;j=h;k=a;l=c}else{m=h;p[e>>3]=m;return 0}while(1){if(!(b[d+i>>0]|0))o=j;else{q=0;r=j;while(1){s=r+ +L(+(+n[k+(q<<2)>>2]-+n[l+(q<<2)>>2]));q=q+1|0;if((q|0)==(g|0)){o=s;break}else r=s}}i=i+1|0;if((i|0)==(f|0)){m=o;break}else{j=o;k=k+(g<<2)|0;l=l+(g<<2)|0}}p[e>>3]=m;return 0}l=Y(g,f)|0;f=l+-4|0;if((l|0)<4){t=0.0;u=0}else{g=0;o=0.0;do{k=g|1;i=g|2;d=g|3;o=o+(+L(+(+n[a+(g<<2)>>2]-+n[c+(g<<2)>>2]))+ +L(+(+n[a+(k<<2)>>2]-+n[c+(k<<2)>>2]))+ +L(+(+n[a+(i<<2)>>2]-+n[c+(i<<2)>>2]))+ +L(+(+n[a+(d<<2)>>2]-+n[c+(d<<2)>>2])));g=g+4|0}while((g|0)<=(f|0));t=o;u=l&-4}if((u|0)<(l|0)){f=u;o=t;while(1){j=o+ +L(+(+n[a+(f<<2)>>2]-+n[c+(f<<2)>>2]));f=f+1|0;if((f|0)==(l|0)){v=j;break}else o=j}}else v=t;m=h+v;p[e>>3]=m;return 0}function VH(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0,w=0.0;i=+p[e>>3];if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a;m=c}else{n=i;p[e>>3]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{q=0;r=k;while(1){s=(f[l+(q<<2)>>2]|0)-(f[m+(q<<2)>>2]|0)|0;t=r+ +(((s|0)>-1?s:0-s|0)|0);q=q+1|0;if((q|0)==(h|0)){o=t;break}else r=t}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+(h<<2)|0;m=m+(h<<2)|0}}p[e>>3]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){u=0.0;v=0}else{h=0;o=0.0;do{l=h|1;j=h|2;d=h|3;o=o+(+L(+(+((f[a+(h<<2)>>2]|0)-(f[c+(h<<2)>>2]|0)|0)))+ +L(+(+((f[a+(l<<2)>>2]|0)-(f[c+(l<<2)>>2]|0)|0)))+ +L(+(+((f[a+(j<<2)>>2]|0)-(f[c+(j<<2)>>2]|0)|0)))+ +L(+(+((f[a+(d<<2)>>2]|0)-(f[c+(d<<2)>>2]|0)|0))));h=h+4|0}while((h|0)<=(g|0));u=o;v=m&-4}if((v|0)<(m|0)){g=v;o=u;while(1){k=o+ +L(+(+((f[a+(g<<2)>>2]|0)-(f[c+(g<<2)>>2]|0)|0)));g=g+1|0;if((g|0)==(m|0)){w=k;break}else o=k}}else w=u;n=i+w;p[e>>3]=n;return 0}function WH(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=f[g>>2]|0;if(e|0){if((h|0)>0&(i|0)>0){k=0;l=j;m=a;n=c}else{o=j;f[g>>2]=o;return 0}while(1){if(!(b[e+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(d[m+(q<<1)>>1]|0)-(d[n+(q<<1)>>1]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(i|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(h|0)){o=p;break}else{l=p;m=m+(i<<1)|0;n=n+(i<<1)|0}}f[g>>2]=o;return 0}n=Y(i,h)|0;h=n+-4|0;if((n|0)<4){u=0;v=0}else{i=0;m=0;do{p=(d[a+(i<<1)>>1]|0)-(d[c+(i<<1)>>1]|0)|0;l=i|1;k=(d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0;l=i|2;e=(d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0;l=i|3;r=(d[a+(l<<1)>>1]|0)-(d[c+(l<<1)>>1]|0)|0;m=((p|0)>-1?p:0-p|0)+m+((k|0)>-1?k:0-k|0)+((e|0)>-1?e:0-e|0)+((r|0)>-1?r:0-r|0)|0;i=i+4|0}while((i|0)<=(h|0));u=m;v=n&-4}if((v|0)<(n|0)){m=v;v=u;while(1){h=(d[a+(m<<1)>>1]|0)-(d[c+(m<<1)>>1]|0)|0;i=((h|0)>-1?h:0-h|0)+v|0;m=m+1|0;if((m|0)==(n|0)){w=i;break}else v=i}}else w=u;o=w+j|0;f[g>>2]=o;return 0}function XH(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;i=f[e>>2]|0;if(d|0){if((g|0)>0&(h|0)>0){k=0;l=i;m=a;n=c}else{o=i;f[e>>2]=o;return 0}while(1){if(!(b[d+k>>0]|0))p=l;else{q=0;r=l;while(1){s=(j[m+(q<<1)>>1]|0)-(j[n+(q<<1)>>1]|0)|0;t=((s|0)>-1?s:0-s|0)+r|0;q=q+1|0;if((q|0)==(h|0)){p=t;break}else r=t}}k=k+1|0;if((k|0)==(g|0)){o=p;break}else{l=p;m=m+(h<<1)|0;n=n+(h<<1)|0}}f[e>>2]=o;return 0}n=Y(h,g)|0;g=n+-4|0;if((n|0)<4){u=0;v=0}else{h=0;m=0;do{p=(j[a+(h<<1)>>1]|0)-(j[c+(h<<1)>>1]|0)|0;l=h|1;k=(j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0;l=h|2;d=(j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0;l=h|3;r=(j[a+(l<<1)>>1]|0)-(j[c+(l<<1)>>1]|0)|0;m=((p|0)>-1?p:0-p|0)+m+((k|0)>-1?k:0-k|0)+((d|0)>-1?d:0-d|0)+((r|0)>-1?r:0-r|0)|0;h=h+4|0}while((h|0)<=(g|0));u=m;v=n&-4}if((v|0)<(n|0)){m=v;v=u;while(1){g=(j[a+(m<<1)>>1]|0)-(j[c+(m<<1)>>1]|0)|0;h=((g|0)>-1?g:0-g|0)+v|0;m=m+1|0;if((m|0)==(n|0)){w=h;break}else v=h}}else w=u;o=w+i|0;f[e>>2]=o;return 0}function YH(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;i=f[e>>2]|0;if(d|0){if((g|0)>0&(h|0)>0){j=0;k=i;l=a;m=c}else{n=i;f[e>>2]=n;return 0}while(1){if(!(b[d+j>>0]|0))o=k;else{p=0;q=k;while(1){r=(b[l+p>>0]|0)-(b[m+p>>0]|0)|0;s=((r|0)>-1?r:0-r|0)+q|0;p=p+1|0;if((p|0)==(h|0)){o=s;break}else q=s}}j=j+1|0;if((j|0)==(g|0)){n=o;break}else{k=o;l=l+h|0;m=m+h|0}}f[e>>2]=n;return 0}m=Y(h,g)|0;g=m+-4|0;if((m|0)<4){t=0;u=0}else{h=0;l=0;do{o=(b[a+h>>0]|0)-(b[c+h>>0]|0)|0;k=h|1;j=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|2;d=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;k=h|3;q=(b[a+k>>0]|0)-(b[c+k>>0]|0)|0;l=((o|0)>-1?o:0-o|0)+l+((j|0)>-1?j:0-j|0)+((d|0)>-1?d:0-d|0)+((q|0)>-1?q:0-q|0)|0;h=h+4|0}while((h|0)<=(g|0));t=l;u=m&-4}if((u|0)<(m|0)){l=u;u=t;while(1){g=(b[a+l>>0]|0)-(b[c+l>>0]|0)|0;h=((g|0)>-1?g:0-g|0)+u|0;l=l+1|0;if((l|0)==(m|0)){v=h;break}else u=h}}else v=t;n=v+i|0;f[e>>2]=n;return 0}function ZH(){NO(501688);NO(501692);NO(501696);NO(501700);NO(501704);NO(501708);NO(501712);NO(501716);NO(501720);NO(501724);NO(501728);NO(501732);NO(501736);NO(501740);NO(501744);NO(501748);NO(501752);NO(501756);NO(501760);NO(501764);NO(501768);NO(501772);NO(501776);NO(501780);NO(501784);NO(501788);NO(501792);NO(501796);NO(501800);NO(501804);NO(501808);zd(1458,0,x|0)|0;return}function _H(a){a=a|0;OO(501808);OO(501804);OO(501800);OO(501796);OO(501792);OO(501788);OO(501784);OO(501780);OO(501776);OO(501772);OO(501768);OO(501764);OO(501760);OO(501756);OO(501752);OO(501748);OO(501744);OO(501740);OO(501736);OO(501732);OO(501728);OO(501724);OO(501720);OO(501716);OO(501712);OO(501708);OO(501704);OO(501700);OO(501696);OO(501692);OO(501688);return}function $H(a,b){a=a|0;b=b|0;f[a+4>>2]=b;f[a>>2]=b;b=a+8|0;a=b+44|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(a|0));return}function aI(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if(f[a+44>>2]|0){f[d>>2]=0;f[d+4>>2]=0;e=aD(d,13)|0;g=177185;h=e+13|0;do{b[e>>0]=b[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));bO(-215,d,177199,177209,77);bD(d)}d=a+16|0;g=a+48|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;f[d+24>>2]=0;d=f[g>>2]|0;if(!d){u=c;return}a=d+8|0;f[a>>2]=(f[a>>2]|0)+-1;e=d+12|0;f[e>>2]=(f[e>>2]|0)+-1;do if(!(f[e>>2]|0)){if(f[d+44>>2]|0){h=f[d+4>>2]|0;if(!h)i=$K()|0;else i=h;zh[f[(f[i>>2]|0)+24>>2]&2047](i,d);if(f[e>>2]|0)break}if(!(f[a>>2]|0)){h=f[d+4>>2]|0;zh[f[(f[h>>2]|0)+16>>2]&2047](h,d)}}while(0);f[g>>2]=0;u=c;return}function bI(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;i=h;if(c>>>0>=33){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,25)|0;k=179335;l=j+25|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,i,179361,177209,182);bD(i)}m=a+4|0;if((f[m>>2]|0)!=(c|0)){n=a+36|0;o=f[n>>2]|0;p=a+40|0;if((o|0)!=(p|0)){UC(o);f[n>>2]=p;f[a+32>>2]=a+8}if((c|0)>2){p=TC(c<<3|4)|0;f[n>>2]=p;n=p+(c<<2)+4|0;f[a+32>>2]=n;f[n+-4>>2]=c;f[a+12>>2]=-1;f[a+8>>2]=-1}}f[m>>2]=c;if(!d){u=h;return}n=f[a>>2]|0;p=(n>>>3&511)+1<<(47696>>>(n<<1&14)&3);n=c+-1|0;if((c|0)<=0){u=h;return}o=a+32|0;q=a+36|0;r=i+4|0;s=i+4|0;if(!e){t=n;v=p;while(1){w=f[d+(t<<2)>>2]|0;if((w|0)<=-1){f[i>>2]=0;f[s>>2]=0;x=aD(i,6)|0;b[x>>0]=b[179369]|0;b[x+1>>0]=b[179370]|0;b[x+2>>0]=b[179371]|0;b[x+3>>0]=b[179372]|0;b[x+4>>0]=b[179373]|0;b[x+5>>0]=b[179374]|0;bO(-215,i,179361,177209,209);bD(i)}f[(f[o>>2]|0)+(t<<2)>>2]=w;if(g){f[(f[q>>2]|0)+(t<<2)>>2]=v;x=cbc(w|0,((w|0)<0)<<31>>31|0,v|0,0)|0;if((x|0)==(x|0)&(J|0)==0)y=x;else{f[i>>2]=0;f[r>>2]=0;j=aD(i,51)|0;k=179376;l=j+51|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-211,i,179361,177209,219);bD(i);y=x}}else y=v;if((t|0)>0){t=t+-1|0;v=y}else break}}else{y=n;while(1){v=f[d+(y<<2)>>2]|0;if((v|0)<=-1){f[i>>2]=0;f[s>>2]=0;t=aD(i,6)|0;b[t>>0]=b[179369]|0;b[t+1>>0]=b[179370]|0;b[t+2>>0]=b[179371]|0;b[t+3>>0]=b[179372]|0;b[t+4>>0]=b[179373]|0;b[t+5>>0]=b[179374]|0;bO(-215,i,179361,177209,209);bD(i)}f[(f[o>>2]|0)+(y<<2)>>2]=v;if((y|0)<(n|0))z=f[e+(y<<2)>>2]|0;else z=p;f[(f[q>>2]|0)+(y<<2)>>2]=z;if((y|0)>0)y=y+-1|0;else break}}if((c|0)!=1){u=h;return}f[m>>2]=2;f[a+12>>2]=1;f[(f[a+36>>2]|0)+4>>2]=p;u=h;return}function cI(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0;g=u;u=u+192|0;h=g+136|0;i=g+128|0;j=g+120|0;k=g+64|0;l=g;m=g+48|0;f[h>>2]=1124007936;n=h+4|0;o=h+8|0;p=h+20|0;q=h+24|0;r=h+28|0;s=h+32|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;f[n+24>>2]=0;f[s>>2]=o;t=h+40|0;v=h+36|0;f[v>>2]=t;f[h+44>>2]=0;f[t>>2]=0;w=c+16|0;x=f[w>>2]|0;a:do if(x){y=c+20|0;do if((x|0)!=(f[y>>2]|0)){f[i>>2]=0;z=i+4|0;f[z>>2]=0;f[j>>2]=0;A=j+4|0;f[A>>2]=0;uL(c,i,j);B=f[c+12>>2]|0;C=f[c+8>>2]|0;if(!(f[A>>2]|f[j>>2])){if((f[w>>2]|0)==(f[y>>2]|0))break;f[i>>2]=0;f[i+4>>2]=0;D=aD(i,17)|0;E=177278;F=D+17|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));bO(-215,i,183294,177209,287);bD(i);break}f[k>>2]=f[c>>2];G=k+4|0;H=c+4|0;I=f[H>>2]|0;f[G>>2]=I;K=k+8|0;f[K>>2]=C;L=k+12|0;f[L>>2]=B;M=k+16|0;f[M>>2]=f[w>>2];f[k+20>>2]=f[y>>2];f[k+24>>2]=f[c+24>>2];f[k+28>>2]=f[c+28>>2];f[k+32>>2]=f[c+32>>2];N=k+36|0;O=f[c+36>>2]|0;f[N>>2]=O;P=k+40|0;f[P>>2]=K;Q=k+48|0;R=k+44|0;f[R>>2]=Q;f[Q>>2]=0;f[k+52>>2]=0;if(!O)S=I;else{I=O+12|0;f[I>>2]=(f[I>>2]|0)+1;S=f[H>>2]|0}if((S|0)<3){H=f[c+44>>2]|0;I=f[R>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2]}else{f[G>>2]=0;jL(k,c)}H=f[A>>2]|0;I=f[j>>2]|0;vL(k,H,(f[z>>2]|0)-H-(f[K>>2]|0)|0,I,(f[i>>2]|0)-I-(f[L>>2]|0)|0)|0;cI(l,k,d,e);L=f[A>>2]|0;f[m>>2]=f[j>>2];f[m+4>>2]=L;f[m+8>>2]=B;f[m+12>>2]=C;dI(a,l,m);L=l+24|0;I=f[L>>2]|0;if(I|0?(K=I+8|0,I=f[K>>2]|0,f[K>>2]=I+-1,(I|0)==1):0){I=f[L>>2]|0;f[L>>2]=0;K=f[I+4>>2]|0;zh[f[(f[K>>2]|0)+16>>2]&2047](K,I)}I=l+4|0;if((f[I>>2]|0)>0){K=f[l+32>>2]|0;H=0;do{f[K+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[I>>2]|0))}f[L>>2]=0;I=f[l+36>>2]|0;if((I|0)!=(l+40|0))UC(I);I=f[N>>2]|0;if(I|0?(H=I+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)kL(k);f[N>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[G>>2]|0)>0){I=f[P>>2]|0;H=0;do{f[I+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[G>>2]|0))}G=f[R>>2]|0;if((G|0)!=(Q|0))UC(G);break a}while(0);y=d|50331648;G=f[c+32>>2]|0;H=$K()|0;I=(G|0)==0?H:G;G=c+4|0;H=c+40|0;P=c+44|0;M=Di[f[(f[I>>2]|0)+8>>2]&15](I,f[G>>2]|0,f[H>>2]|0,f[c>>2]&4095,f[w>>2]|0,f[P>>2]|0,y,e)|0;I=$K()|0;if(!(Dg[f[(f[I>>2]|0)+12>>2]&127](I,M,y,e)|0)?(I=$K()|0,!(Dg[f[(f[I>>2]|0)+12>>2]&127](I,M,y,e)|0)):0){f[i>>2]=0;f[i+4>>2]=0;D=aD(i,9)|0;E=177296;F=D+9|0;do{b[D>>0]=b[E>>0]|0;D=D+1|0;E=E+1|0}while((D|0)<(F|0));bO(-215,i,183294,177209,309);bD(i)}y=c+36|0;I=f[y>>2]|0;if(I|0){f[M+48>>2]=I;N=I+12|0;f[N>>2]=(f[N>>2]|0)+1;N=(f[y>>2]|0)+8|0;f[N>>2]=(f[N>>2]|0)+1}f[h>>2]=f[c>>2];bI(h,f[G>>2]|0,f[H>>2]|0,f[P>>2]|0,0);N=f[n>>2]|0;y=f[s>>2]|0;b:do if((N|0)>0){I=0;while(1){if((f[y+(I<<2)>>2]|0)>1){T=I;break b}L=I+1|0;if((L|0)<(N|0))I=L;else{T=L;break}}}else T=0;while(0);P=f[v>>2]|0;H=N;do{G=H;H=H+-1|0;if((H|0)<=(T|0))break;I=Y(f[y+(H<<2)>>2]|0,f[P+(H<<2)>>2]|0)|0}while(I>>>0>=(f[P+(G+-2<<2)>>2]|0)>>>0);G=f[y>>2]|0;I=cbc(G|0,((G|0)<0)<<31>>31|0,f[P>>2]|0,0)|0;G=f[h>>2]|0;Q=(H|0)<=(T|0)&((I|0)==(I|0)&(J|0)==0)?G|16384:G&-16385;f[h>>2]=Q;if((N|0)>2){f[h+12>>2]=-1;f[o>>2]=-1}f[q>>2]=M;f[r>>2]=0;if(!M){U=Q;V=N;W=M;X=0}else{Q=M+8|0;f[Q>>2]=(f[Q>>2]|0)+1;U=f[h>>2]|0;V=f[n>>2]|0;W=f[q>>2]|0;X=f[r>>2]|0}f[a>>2]=U;Q=a+4|0;f[Q>>2]=V;G=a+8|0;f[G>>2]=f[o>>2];f[a+12>>2]=f[h+12>>2];f[a+16>>2]=f[h+16>>2];f[a+20>>2]=f[p>>2];f[a+24>>2]=W;f[a+28>>2]=X;I=a+32|0;f[I>>2]=G;G=a+40|0;R=a+36|0;f[R>>2]=G;f[a+44>>2]=0;f[G>>2]=0;if(!W)Z=V;else{G=W+8|0;f[G>>2]=(f[G>>2]|0)+1;Z=f[n>>2]|0}if((Z|0)<3){G=f[v>>2]|0;L=f[R>>2]|0;f[L>>2]=f[G>>2];f[L+4>>2]=f[G+4>>2];break}f[Q>>2]=0;bI(a,Z,0,0,0);if((f[Q>>2]|0)>0){G=f[s>>2]|0;L=f[I>>2]|0;I=f[v>>2]|0;K=f[R>>2]|0;R=0;do{f[L+(R<<2)>>2]=f[G+(R<<2)>>2];f[K+(R<<2)>>2]=f[I+(R<<2)>>2];R=R+1|0}while((R|0)<(f[Q>>2]|0))}}else{f[a>>2]=1124007936;Q=a+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;f[Q+16>>2]=0;f[Q+20>>2]=0;f[Q+24>>2]=0;f[a+32>>2]=a+8;Q=a+40|0;f[a+36>>2]=Q;f[Q>>2]=0;f[a+44>>2]=0}while(0);a=f[q>>2]|0;if(a|0?(Z=a+8|0,a=f[Z>>2]|0,f[Z>>2]=a+-1,(a|0)==1):0){a=f[q>>2]|0;f[q>>2]=0;Z=f[a+4>>2]|0;zh[f[(f[Z>>2]|0)+16>>2]&2047](Z,a)}if((f[n>>2]|0)>0){a=f[s>>2]|0;s=0;do{f[a+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[n>>2]|0))}f[q>>2]=0;q=f[v>>2]|0;if((q|0)==(t|0)){u=g;return}UC(q);u=g;return}function dI(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=u;u=u+16|0;g=e;h=f[c>>2]|0;f[a>>2]=h;i=a+4|0;f[i>>2]=2;j=a+8|0;k=d+12|0;f[j>>2]=f[k>>2];l=a+12|0;m=d+8|0;f[l>>2]=f[m>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];n=a+24|0;f[n>>2]=f[c+24>>2];o=a+28|0;p=d+4|0;q=c+36|0;r=(Y(f[f[q>>2]>>2]|0,f[p>>2]|0)|0)+(f[c+28>>2]|0)|0;f[o>>2]=r;s=a+32|0;f[s>>2]=j;t=a+40|0;v=a+36|0;f[v>>2]=t;f[a+44>>2]=0;f[t>>2]=0;if((f[c+4>>2]|0)<3){w=h;x=r}else{f[g>>2]=0;f[g+4>>2]=0;y=aD(g,11)|0;z=180095;A=y+11|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,g,177306,177209,471);bD(g);w=f[a>>2]|0;x=f[o>>2]|0}r=f[m>>2]|0;h=c+12|0;t=f[h>>2]|0;B=f[k>>2]|0;f[a>>2]=((B|0)==1?16384:0)|((r|0)<(t|0)?-16385:-1)&w;C=(w>>>3&511)+1<<(47696>>>(w<<1&14)&3);w=f[d>>2]|0;d=(Y(C,w)|0)+x|0;f[o>>2]=d;if(!((!((w|r|0)<0|(w+r|0)>(t|0))?(t=f[p>>2]|0,(t|B|0)>-1):0)?(t+B|0)<=(f[c+8>>2]|0):0)){f[g>>2]=0;f[g+4>>2]=0;y=aD(g,124)|0;z=180107;A=y+124|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,g,177306,177209,478);bD(g)}g=f[n>>2]|0;if(g|0){z=g+8|0;f[z>>2]=(f[z>>2]|0)+1}if(!((f[m>>2]|0)>=(f[h>>2]|0)?(f[k>>2]|0)>=(f[c+8>>2]|0):0))f[a>>2]=f[a>>2]|32768;a=f[v>>2]|0;f[a>>2]=f[f[q>>2]>>2];f[a+4>>2]=C;if((f[j>>2]|0)>=1?(f[l>>2]|0)>=1:0){u=e;return}C=f[n>>2]|0;if(C|0?(a=C+8|0,C=f[a>>2]|0,f[a>>2]=C+-1,(C|0)==1):0){C=f[n>>2]|0;f[n>>2]=0;a=f[C+4>>2]|0;zh[f[(f[a>>2]|0)+16>>2]&2047](a,C)}if((f[i>>2]|0)>0){C=f[s>>2]|0;s=0;do{f[C+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[i>>2]|0))}f[n>>2]=0;f[l>>2]=0;f[j>>2]=0;u=e;return}function eI(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+144|0;i=h+8|0;j=h;k=a+20|0;f[k>>2]=g;if(!(c>>>0<33&(d|0)!=0)){f[i>>2]=0;f[i+4>>2]=0;g=aD(i,27)|0;l=179661;m=g+27|0;do{b[g>>0]=b[l>>0]|0;g=g+1|0;l=l+1|0}while((g|0)<(m|0));bO(-215,i,440241,177209,337);bD(i)}l=e&4095;e=a+24|0;g=f[e>>2]|0;m=(g|0)==0;do if(!m){n=f[a+4>>2]|0;if((n|0)!=(c|0)?!((c|0)==1&(n|0)<3):0)break;if((l|0)==(f[a>>2]&4095|0)){if((c|0)==2)if((f[a+8>>2]|0)==(f[d>>2]|0)?(f[a+12>>2]|0)==(f[d+4>>2]|0):0){u=h;return}else o=11;else if((c|0)>0)o=11;else p=0;a:do if((o|0)==11){n=f[a+32>>2]|0;q=0;while(1){if((f[n+(q<<2)>>2]|0)!=(f[d+(q<<2)>>2]|0)){p=q;break a}r=q+1|0;if((r|0)<(c|0))q=r;else{p=r;break}}}while(0);if((p|0)==(c|0)){if((c|0)>1){u=h;return}if((f[(f[a+32>>2]|0)+4>>2]|0)==1){u=h;return}}}}while(0);p=a+32|0;if((f[p>>2]|0)==(d|0)){if((c|0)>0)Vac(i|0,d|0,c<<2|0)|0;s=i}else s=d;if(!m?(m=g+8|0,g=f[m>>2]|0,f[m>>2]=g+-1,(g|0)==1):0){g=f[e>>2]|0;f[e>>2]=0;m=f[g+4>>2]|0;zh[f[(f[m>>2]|0)+16>>2]&2047](m,g)}g=a+4|0;if((f[g>>2]|0)>0){m=f[p>>2]|0;d=0;do{f[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[g>>2]|0))}f[e>>2]=0;if(c|0){f[a>>2]=l|1124007936;bI(a,c,s,0,1);f[a+28>>2]=0;s=f[g>>2]|0;if((s|0)<3)t=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{c=f[p>>2]|0;d=0;m=1;while(1){i=Y(f[c+(d<<2)>>2]|0,m)|0;d=d+1|0;if((d|0)==(s|0)){t=i;break}else m=i}}if(t){t=f[a+16>>2]|0;m=$K()|0;if(!t){$K()|0;v=m}else v=t;t=a+36|0;m=Di[f[(f[v>>2]|0)+8>>2]&15](v,f[g>>2]|0,f[p>>2]|0,l,0,f[t>>2]|0,0,f[k>>2]|0)|0;f[e>>2]=m;if(!m){f[j>>2]=0;f[j+4>>2]=0;m=aD(j,6)|0;b[m>>0]=b[179689]|0;b[m+1>>0]=b[179690]|0;b[m+2>>0]=b[179691]|0;b[m+3>>0]=b[179692]|0;b[m+4>>0]=b[179693]|0;b[m+5>>0]=b[179694]|0;bO(-215,j,440241,177209,377);bD(j)}m=f[g>>2]|0;k=f[a>>2]|0;if((f[(f[t>>2]|0)+(m+-1<<2)>>2]|0)==((k>>>3&511)+1<<(47696>>>(k<<1&14)&3)|0))w=m;else{f[j>>2]=0;f[j+4>>2]=0;Vac(aD(j,146)|0,179696,146)|0;bO(-215,j,440241,177209,385);bD(j);w=f[g>>2]|0}}else w=s;s=f[p>>2]|0;b:do if((w|0)>0){p=0;while(1){if((f[s+(p<<2)>>2]|0)>1){x=p;break b}g=p+1|0;if((g|0)<(w|0))p=g;else{x=g;break}}}else x=0;while(0);p=f[a+36>>2]|0;g=w;do{j=g;g=g+-1|0;if((g|0)<=(x|0))break;m=Y(f[s+(g<<2)>>2]|0,f[p+(g<<2)>>2]|0)|0}while(m>>>0>=(f[p+(j+-2<<2)>>2]|0)>>>0);j=f[s>>2]|0;s=cbc(j|0,((j|0)<0)<<31>>31|0,f[p>>2]|0,0)|0;p=f[a>>2]|0;f[a>>2]=(g|0)<=(x|0)&((s|0)==(s|0)&(J|0)==0)?p|16384:p&-16385;if((w|0)>2){f[a+12>>2]=-1;f[a+8>>2]=-1}a=f[e>>2]|0;if(a|0){e=a+8|0;f[e>>2]=(f[e>>2]|0)+1}}u=h;return}function fI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f[b>>2]|0;eI(a,(f[b+4>>2]|0)-e>>2,e,c,d);return}function gI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;bI(a,f[b+4>>2]|0,0,0,0);c=a+4|0;if((f[c>>2]|0)<=0)return;d=f[b+32>>2]|0;e=f[a+32>>2]|0;g=f[b+36>>2]|0;b=f[a+36>>2]|0;a=0;do{f[e+(a<<2)>>2]=f[d+(a<<2)>>2];f[b+(a<<2)>>2]=f[g+(a<<2)>>2];a=a+1|0}while((a|0)<(f[c>>2]|0));return}function hI(a){a=a|0;var b=0,c=0,d=0,e=0;b=a+24|0;c=f[b>>2]|0;if(c|0?(d=c+8|0,c=f[d>>2]|0,f[d>>2]=c+-1,(c|0)==1):0){c=f[b>>2]|0;f[b>>2]=0;d=f[c+4>>2]|0;zh[f[(f[d>>2]|0)+16>>2]&2047](d,c)}c=a+4|0;if((f[c>>2]|0)>0){d=f[a+32>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}f[b>>2]=0;b=f[a+36>>2]|0;if((b|0)==(a+40|0))return;UC(b);return}function iI(a){a=a|0;var b=0;b=a+24|0;a=f[b>>2]|0;f[b>>2]=0;b=f[a+4>>2]|0;zh[f[(f[b>>2]|0)+16>>2]&2047](b,a);return}function jI(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=u;u=u+1152|0;h=g+48|0;i=g;f[a>>2]=1124007936;j=a+4|0;k=a+8|0;l=a+12|0;m=a+24|0;n=a+28|0;o=a+32|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[o>>2]=k;p=a+40|0;q=a+36|0;f[q>>2]=p;f[a+44>>2]=0;f[p>>2]=0;r=c+4|0;s=f[r>>2]|0;if((s|0)>1)t=s;else{f[h>>2]=0;f[h+4>>2]=0;v=aD(h,11)|0;w=434484;x=v+11|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,h,177306,177209,426);bD(h);t=f[r>>2]|0}if((t|0)>2){s=h+8|0;Nac(s|0,0,1088)|0;f[h>>2]=s;y=h+4|0;f[y>>2]=t;if(t>>>0>136){z=N5b(t>>>0>536870911?-1:t<<3)|0;Nac(z|0,0,t<<3|0)|0;f[h>>2]=z;A=z}else A=s;z=d;t=f[z+4>>2]|0;B=A;f[B>>2]=f[z>>2];f[B+4>>2]=t;t=f[h>>2]|0;B=e;z=f[B+4>>2]|0;A=t+8|0;f[A>>2]=f[B>>2];f[A+4>>2]=z;if((f[r>>2]|0)>2){z=2;A=t;while(1){B=A+(z<<3)|0;f[B>>2]=-2147483648;f[B+4>>2]=2147483647;z=z+1|0;B=f[h>>2]|0;if((z|0)>=(f[r>>2]|0)){C=B;break}else A=B}}else C=t;kI(i,c,C);lI(a,i)|0;C=i+24|0;t=f[C>>2]|0;if(t|0?(A=t+8|0,t=f[A>>2]|0,f[A>>2]=t+-1,(t|0)==1):0){t=f[C>>2]|0;f[C>>2]=0;A=f[t+4>>2]|0;zh[f[(f[A>>2]|0)+16>>2]&2047](A,t)}t=i+4|0;if((f[t>>2]|0)>0){A=f[i+32>>2]|0;r=0;do{f[A+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[t>>2]|0))}f[C>>2]=0;C=f[i+36>>2]|0;if((C|0)!=(i+40|0))UC(C);C=f[h>>2]|0;if((C|0)!=(s|0)){if(C|0)P5b(C);f[h>>2]=s;f[y>>2]=136}u=g;return}lI(a,c)|0;y=f[d>>2]|0;s=d+4|0;C=f[s>>2]|0;if((y|0)!=-2147483648|(C|0)!=2147483647?(y|0?1:(C|0)!=(f[k>>2]|0)):0){if(!((y|0)<0|(y|0)>(C|0))?(C|0)<=(f[c+8>>2]|0):0){D=y;E=C}else{f[h>>2]=0;f[h+4>>2]=0;v=aD(h,83)|0;w=179843;x=v+83|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,h,177306,177209,441);bD(h);D=f[d>>2]|0;E=f[s>>2]|0}f[k>>2]=E-D;E=Y(D,f[p>>2]|0)|0;f[n>>2]=(f[n>>2]|0)+E;f[a>>2]=f[a>>2]|32768}E=f[e>>2]|0;p=e+4|0;D=f[p>>2]|0;if((E|0)!=-2147483648|(D|0)!=2147483647?(E|0?1:(D|0)!=(f[l>>2]|0)):0){if(!((E|0)<0|(E|0)>(D|0))?(D|0)<=(f[c+12>>2]|0):0){F=E;G=D}else{f[h>>2]=0;f[h+4>>2]=0;v=aD(h,83)|0;w=179927;x=v+83|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,h,177306,177209,449);bD(h);F=f[e>>2]|0;G=f[p>>2]|0}p=G-F|0;f[l>>2]=p;G=f[j>>2]|0;if((G|0)>0)H=f[(f[q>>2]|0)+(G+-1<<2)>>2]|0;else H=0;G=Y(H,F)|0;f[n>>2]=(f[n>>2]|0)+G;f[a>>2]=((p|0)<(f[c+12>>2]|0)?-49153:-32769)&f[a>>2]|32768}c=f[k>>2]|0;if((c|0)!=1){if((c|0)>=1)I=38}else{f[a>>2]=f[a>>2]|16384;I=38}if((I|0)==38?(f[l>>2]|0)>=1:0){u=g;return}I=f[m>>2]|0;if(I|0?(a=I+8|0,I=f[a>>2]|0,f[a>>2]=I+-1,(I|0)==1):0){I=f[m>>2]|0;f[m>>2]=0;a=f[I+4>>2]|0;zh[f[(f[a>>2]|0)+16>>2]&2047](a,I)}if((f[j>>2]|0)>0){I=f[o>>2]|0;o=0;do{f[I+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[j>>2]|0))}f[m>>2]=0;f[l>>2]=0;f[k>>2]=0;u=g;return}function kI(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;f[a>>2]=1124007936;h=a+4|0;i=a+28|0;j=a+32|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[j>>2]=a+8;k=a+40|0;l=a+36|0;f[l>>2]=k;f[a+44>>2]=0;f[k>>2]=0;k=f[c+4>>2]|0;if(!d){f[g>>2]=0;f[g+4>>2]=0;m=aD(g,6)|0;b[m>>0]=b[180011]|0;b[m+1>>0]=b[180012]|0;b[m+2>>0]=b[180013]|0;b[m+3>>0]=b[180014]|0;b[m+4>>0]=b[180015]|0;b[m+5>>0]=b[180016]|0;bO(-215,g,177306,177209,499);bD(g)}m=(k|0)>0;if(m){n=c+32|0;o=g+4|0;p=0;do{q=d+(p<<3)|0;r=f[q>>2]|0;s=f[q+4>>2]|0;do if(!((r|0)==-2147483648&(s|0)==2147483647)){if((r|0)>-1&(r|0)<(s|0)?(s|0)<=(f[(f[n>>2]|0)+(p<<2)>>2]|0):0)break;f[g>>2]=0;f[o>>2]=0;q=aD(g,76)|0;t=180018;v=q+76|0;do{b[q>>0]=b[t>>0]|0;q=q+1|0;t=t+1|0}while((q|0)<(v|0));bO(-215,g,177306,177209,503);bD(g)}while(0);p=p+1|0}while((p|0)<(k|0));lI(a,c)|0;if(m){m=0;do{p=d+(m<<3)|0;g=f[p>>2]|0;o=f[p+4>>2]|0;if((g|0)!=-2147483648|(o|0)!=2147483647?(p=(f[j>>2]|0)+(m<<2)|0,g|0?1:(o|0)!=(f[p>>2]|0)):0){f[p>>2]=o-g;o=Y(f[(f[l>>2]|0)+(m<<2)>>2]|0,g)|0;f[i>>2]=(f[i>>2]|0)+o;f[a>>2]=f[a>>2]|32768}m=m+1|0}while((m|0)!=(k|0))}}else lI(a,c)|0;c=f[h>>2]|0;h=f[j>>2]|0;a:do if((c|0)>0){j=0;while(1){if((f[h+(j<<2)>>2]|0)>1){w=j;break a}k=j+1|0;if((k|0)<(c|0))j=k;else{w=k;break}}}else w=0;while(0);j=f[l>>2]|0;l=c;while(1){c=l;l=l+-1|0;if((l|0)<=(w|0)){x=22;break}k=Y(f[h+(l<<2)>>2]|0,f[j+(l<<2)>>2]|0)|0;if(k>>>0<(f[j+(c+-2<<2)>>2]|0)>>>0){x=22;break}}if((x|0)==22){x=f[h>>2]|0;h=cbc(x|0,((x|0)<0)<<31>>31|0,f[j>>2]|0,0)|0;j=f[a>>2]|0;f[a>>2]=(l|0)<=(w|0)&((h|0)==(h|0)&(J|0)==0)?j|16384:j&-16385;u=e;return}}function lI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((a|0)==(b|0))return a|0;c=b+24|0;d=f[c>>2]|0;if(d|0){e=d+8|0;f[e>>2]=(f[e>>2]|0)+1}e=a+24|0;d=f[e>>2]|0;if(d|0?(g=d+8|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0){d=f[e>>2]|0;f[e>>2]=0;g=f[d+4>>2]|0;zh[f[(f[g>>2]|0)+16>>2]&2047](g,d)}d=a+4|0;if((f[d>>2]|0)>0){g=f[a+32>>2]|0;h=0;do{f[g+(h<<2)>>2]=0;h=h+1|0;i=f[d>>2]|0}while((h|0)<(i|0));f[e>>2]=0;f[a>>2]=f[b>>2];if((i|0)<3)j=13;else{k=f[b+4>>2]|0;j=15}}else{f[e>>2]=0;f[a>>2]=f[b>>2];j=13}if((j|0)==13){i=f[b+4>>2]|0;if((i|0)<3){f[d>>2]=i;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];h=f[b+36>>2]|0;g=f[a+36>>2]|0;f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2]}else{k=i;j=15}}if((j|0)==15?(bI(a,k,0,0,0),(f[d>>2]|0)>0):0){k=f[b+32>>2]|0;j=f[a+32>>2]|0;i=f[b+36>>2]|0;h=f[a+36>>2]|0;g=0;do{f[j+(g<<2)>>2]=f[k+(g<<2)>>2];f[h+(g<<2)>>2]=f[i+(g<<2)>>2];g=g+1|0}while((g|0)<(f[d>>2]|0))}f[a+16>>2]=f[b+16>>2];d=a+20|0;if(!(f[d>>2]|0))f[d>>2]=f[b+20>>2];f[e>>2]=f[c>>2];f[a+28>>2]=f[b+28>>2];return a|0}function mI(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+16|0;h=g;i=f[c>>2]|0;j=(i>>>3&511)+1|0;f[a>>2]=i;i=a+4|0;k=c+4|0;l=f[k>>2]|0;f[i>>2]=l;m=a+8|0;n=c+8|0;f[m>>2]=f[n>>2];o=a+12|0;p=c+12|0;f[o>>2]=f[p>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];q=f[c+24>>2]|0;f[a+24>>2]=q;f[a+28>>2]=f[c+28>>2];r=a+32|0;f[r>>2]=m;s=a+40|0;t=a+36|0;f[t>>2]=s;f[a+44>>2]=0;f[s>>2]=0;if(!q)v=l;else{l=q+8|0;f[l>>2]=(f[l>>2]|0)+1;v=f[k>>2]|0}if((v|0)>=3){f[i>>2]=0;bI(a,v,0,0,0);if((f[i>>2]|0)>0){v=f[c+32>>2]|0;l=f[r>>2]|0;q=f[c+36>>2]|0;s=f[t>>2]|0;w=0;do{f[l+(w<<2)>>2]=f[v+(w<<2)>>2];f[s+(w<<2)>>2]=f[q+(w<<2)>>2];w=w+1|0}while((w|0)<(f[i>>2]|0))}}else{i=f[c+36>>2]|0;w=f[t>>2]|0;f[w>>2]=f[i>>2];f[w+4>>2]=f[i+4>>2]}i=f[k>>2]|0;w=(e|0)==0;if((d|0)!=0&(w&(i|0)>2)){q=i+-1|0;if(!((Y(f[(f[c+32>>2]|0)+(q<<2)>>2]|0,j)|0)%(d|0)|0)){s=f[a>>2]|0;v=(d<<3)+-8|0;f[a>>2]=s&-4089|v;f[(f[t>>2]|0)+(q<<2)>>2]=(v>>>3&511)+1<<(47696>>>(s<<1&14)&3);s=(f[r>>2]|0)+((f[k>>2]|0)+-1<<2)|0;k=(Y(f[s>>2]|0,j)|0)/(d|0)|0;f[s>>2]=k;u=g;return}else x=12}else if((i|0)>=3)x=12;if((x|0)==12){f[h>>2]=0;f[h+4>>2]=0;y=aD(h,9)|0;z=180256;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,h,181862,177209,637);bD(h)}i=(d|0)==0?j:d;d=Y(f[p>>2]|0,j)|0;if((i|0)>(d|0))if(w)x=16;else{B=e;x=18}else if(w&((d|0)%(i|0)|0|0)!=0)x=16;else{C=e;x=17}if((x|0)==16){C=(Y(f[n>>2]|0,d)|0)/(i|0)|0;x=17}if((x|0)==17)if(!C)D=d;else{B=C;x=18}if((x|0)==18){x=f[n>>2]|0;if((B|0)==(x|0))D=d;else{n=Y(x,d)|0;if(!(f[c>>2]&16384)){f[h>>2]=0;f[h+4>>2]=0;y=aD(h,72)|0;z=195401;A=y+72|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-13,h,181862,177209,652);bD(h)}if(B>>>0>n>>>0){f[h>>2]=0;f[h+4>>2]=0;y=aD(h,22)|0;z=195474;A=y+22|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-211,h,181862,177209,655);bD(h)}d=(n|0)/(B|0)|0;if((Y(d,B)|0)!=(n|0)){f[h>>2]=0;f[h+4>>2]=0;y=aD(h,78)|0;z=195312;A=y+78|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-5,h,181862,177209,661);bD(h)}f[m>>2]=B;B=Y(1212424721>>>(f[c>>2]<<2&28)&15,d)|0;f[f[t>>2]>>2]=B;D=d}}d=(D|0)/(i|0)|0;if((Y(d,i)|0)!=(D|0)){f[h>>2]=0;f[h+4>>2]=0;y=aD(h,62)|0;z=195497;A=y+62|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-15,h,181862,177209,671);bD(h)}f[o>>2]=d;d=f[a>>2]|0;o=(i<<3)+-8|0;f[a>>2]=d&-4089|o;f[(f[t>>2]|0)+4>>2]=(o>>>3&511)+1<<(47696>>>(d<<1&14)&3);u=g;return}function nI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+64|0;e=d+56|0;g=d;dQ(e,41356);h=HM(c)|0;qI(g,a,h?33554432:50331648);VP(g,b,c)|0;c=g+36|0;b=f[c>>2]|0;if(b|0?(h=b+12|0,b=f[h>>2]|0,f[h>>2]=b+-1,(b|0)==1):0)kL(g);f[c>>2]=0;c=g+16|0;b=g+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[g+40>>2]|0;h=0;do{f[c+(h<<2)>>2]=0;h=h+1|0}while((h|0)<(f[b>>2]|0))}b=f[g+44>>2]|0;if((b|0)!=(g+48|0))UC(b);if(!(f[e+4>>2]|0)){u=d;return a|0}u=d;return a|0}function oI(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=u;u=u+464|0;e=d+448|0;g=d+320|0;h=d+192|0;i=d+64|0;j=d+8|0;k=d;dQ(e,41316);l=BL(c,-1)|0;if(MM(c)|0?(m=f[a>>2]|0,(l|0)!=(m&4095|0)):0){if((m^l)&4088|0){f[g>>2]=0;f[g+4>>2]=0;n=aD(g,55)|0;m=192255;o=n+55|0;do{b[n>>0]=b[m>>0]|0;n=n+1|0;m=m+1|0}while((n|0)<(o|0));bO(-215,g,192311,177209,820);bD(g)}pI(a,c,l,1.0,0.0)}else p=6;do if((p|0)==6){l=a+24|0;if(f[l>>2]|0){m=a+4|0;q=f[m>>2]|0;if((q|0)<3)r=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{s=f[a+32>>2]|0;t=0;v=1;while(1){w=Y(f[s+(t<<2)>>2]|0,v)|0;t=t+1|0;if((t|0)==(q|0)){r=w;break}else v=w}}if(!((q|0)==0|(r|0)==0)){n=g;o=n+128|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));v=(q|0)>0;if(v)x=f[(f[a+36>>2]|0)+(q+-1<<2)>>2]|0;else x=0;t=f[a+32>>2]|0;s=0;do{f[g+(s<<2)>>2]=f[t+(s<<2)>>2];s=s+1|0}while(s>>>0<q>>>0);s=q+-1|0;t=g+(s<<2)|0;w=Y(f[t>>2]|0,x)|0;f[t>>2]=w;if(v){w=f[a+36>>2]|0;t=0;y=f[a+28>>2]|0;do{z=f[w+(t<<2)>>2]|0;A=(y>>>0)/(z>>>0)|0;f[h+(t<<2)>>2]=A;y=y-(Y(A,z)|0)|0;t=t+1|0}while((t|0)<(q|0))}t=h+(s<<2)|0;y=Y(f[t>>2]|0,x)|0;f[t>>2]=y;wL(c,q,f[a+32>>2]|0,f[a>>2]&4095,-1,0,0);if((yM(c)|0)==655360){zM(j,c,-1);y=j+24|0;t=f[y>>2]|0;if(!t){f[k>>2]=0;f[k+4>>2]=0;w=aD(k,5)|0;b[w>>0]=b[177311]|0;b[w+1>>0]=b[177312]|0;b[w+2>>0]=b[177313]|0;b[w+3>>0]=b[177314]|0;b[w+4>>0]=b[177315]|0;bO(-215,k,192311,177209,842);bD(k);B=f[y>>2]|0}else B=t;t=f[l>>2]|0;if((t|0)==(B|0)?(f[j+28>>2]|0)==(f[a+28>>2]|0):0){C=B;p=31}else{w=f[t+4>>2]|0;if((w|0)==(f[B+4>>2]|0)){v=f[j+4>>2]|0;if((v|0)>0){z=f[j+36>>2]|0;A=0;D=f[j+28>>2]|0;do{E=f[z+(A<<2)>>2]|0;F=(D>>>0)/(E>>>0)|0;f[i+(A<<2)>>2]=F;D=D-(Y(F,E)|0)|0;A=A+1|0}while((A|0)<(v|0));G=z}else G=f[j+36>>2]|0;z=f[m>>2]|0;v=i+(z+-1<<2)|0;A=Y(f[v>>2]|0,x)|0;f[v>>2]=A;dh[f[(f[w>>2]|0)+36>>2]&7](w,t,B,z,g,h,f[a+36>>2]|0,i,G,0);C=f[y>>2]|0;p=31}else{H=0;I=B;p=32}}if((p|0)==31)if(!C)J=1;else{H=1;I=C;p=32}if((p|0)==32){z=I+8|0;A=f[z>>2]|0;f[z>>2]=A+-1;if((A|0)==1){A=f[y>>2]|0;f[y>>2]=0;z=f[A+4>>2]|0;zh[f[(f[z>>2]|0)+16>>2]&2047](z,A);J=H}else J=H}A=j+4|0;if((f[A>>2]|0)>0){z=f[j+32>>2]|0;v=0;do{f[z+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[A>>2]|0))}f[y>>2]=0;A=f[j+36>>2]|0;if((A|0)!=(j+40|0))UC(A);if(!J)p=40}else p=40;if((p|0)==40){do if((yM(c)|0)==65536){A=f[c+4>>2]|0;f[j>>2]=f[A>>2];v=j+4|0;z=A+4|0;f[v>>2]=f[z>>2];t=j+8|0;f[t>>2]=f[A+8>>2];f[j+12>>2]=f[A+12>>2];w=j+16|0;f[w>>2]=f[A+16>>2];f[j+20>>2]=f[A+20>>2];f[j+24>>2]=f[A+24>>2];f[j+28>>2]=f[A+28>>2];f[j+32>>2]=f[A+32>>2];D=f[A+36>>2]|0;f[j+36>>2]=D;f[j+40>>2]=t;t=j+48|0;q=j+44|0;f[q>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(D|0){t=D+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[z>>2]|0)<3){z=f[A+44>>2]|0;t=f[q>>2]|0;f[t>>2]=f[z>>2];f[t+4>>2]=f[z+4>>2];K=w;L=q;break}else{f[v>>2]=0;jL(j,A);K=w;L=q;break}}else{yL(j,c,-1);K=j+16|0;L=j+44|0}while(0);y=f[l>>2]|0;q=f[y+4>>2]|0;Hh[f[(f[q>>2]|0)+28>>2]&255](q,y,f[K>>2]|0,f[m>>2]|0,g,h,f[a+36>>2]|0,f[L>>2]|0);y=j+36|0;q=f[y>>2]|0;if(q|0?(w=q+12|0,q=f[w>>2]|0,f[w>>2]=q+-1,(q|0)==1):0)kL(j);f[y>>2]=0;y=j+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[y>>2]|0)>0){q=f[j+40>>2]|0;w=0;do{f[q+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[y>>2]|0))}y=f[L>>2]|0;if((y|0)!=(j+48|0))UC(y)}break}}$L(c)}while(0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function pI(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=u;u=u+112|0;h=g+104|0;i=g+56|0;j=g;dQ(h,41336);if(+L(+(d+-1.0))<2.220446049250313e-16)k=+L(+e)<2.220446049250313e-16;else k=0;l=f[a>>2]|0;m=l&4095;if((c|0)<0)if(MM(b)|0)n=BL(b,-1)|0;else n=m;else n=l&4088|c&7;if(((n^l)&7|0)!=0|k^1){f[i>>2]=f[a>>2];k=i+4|0;l=a+4|0;c=f[l>>2]|0;f[k>>2]=c;m=i+8|0;f[m>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];o=i+24|0;p=f[a+24>>2]|0;f[o>>2]=p;f[i+28>>2]=f[a+28>>2];q=i+32|0;f[q>>2]=m;m=i+40|0;r=i+36|0;f[r>>2]=m;f[i+44>>2]=0;f[m>>2]=0;if(!p)s=c;else{c=p+8|0;f[c>>2]=(f[c>>2]|0)+1;s=f[l>>2]|0}if((s|0)>=3){f[k>>2]=0;bI(i,s,0,0,0);if((f[k>>2]|0)>0){s=f[a+32>>2]|0;i=f[q>>2]|0;l=f[a+36>>2]|0;c=f[r>>2]|0;p=0;do{f[i+(p<<2)>>2]=f[s+(p<<2)>>2];f[c+(p<<2)>>2]=f[l+(p<<2)>>2];p=p+1|0}while((p|0)<(f[k>>2]|0))}}else{p=f[a+36>>2]|0;l=f[r>>2]|0;f[l>>2]=f[p>>2];f[l+4>>2]=f[p+4>>2]}qI(j,a,16777216);OJ(j,b,n,d,e);n=j+36|0;p=f[n>>2]|0;if(p|0?(l=p+12|0,p=f[l>>2]|0,f[l>>2]=p+-1,(p|0)==1):0)kL(j);f[n>>2]=0;n=j+16|0;p=j+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[p>>2]|0)>0){n=f[j+40>>2]|0;l=0;do{f[n+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[p>>2]|0))}p=f[j+44>>2]|0;if((p|0)!=(j+48|0))UC(p);p=f[o>>2]|0;if(p|0?(j=p+8|0,p=f[j>>2]|0,f[j>>2]=p+-1,(p|0)==1):0){p=f[o>>2]|0;f[o>>2]=0;j=f[p+4>>2]|0;zh[f[(f[j>>2]|0)+16>>2]&2047](j,p)}if((f[k>>2]|0)>0){p=f[q>>2]|0;q=0;do{f[p+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[k>>2]|0))}f[o>>2]=0;o=f[r>>2]|0;if((o|0)!=(m|0))UC(o)}else oI(a,b);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function qI(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=c+24|0;i=f[h>>2]|0;if(!i){f[a>>2]=1124007936;j=a+8|0;k=a+40|0;l=a+4|0;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[k>>2]=j;j=a+48|0;f[a+44>>2]=j;f[j>>2]=0;f[a+52>>2]=0;u=e;return}j=501688+(((i>>>0)%31|0)<<2)|0;PO(j);i=(f[h>>2]|0)+12|0;k=f[i>>2]|0;f[i>>2]=k+1;if(!k){k=f[h>>2]|0;i=f[k+4>>2]|0;_h[f[(f[i>>2]|0)+20>>2]&255](i,k,d|50331648)}d=f[h>>2]|0;k=f[d+16>>2]|0;if(!k){i=d+12|0;f[i>>2]=(f[i>>2]|0)+-1;if(!(f[(f[h>>2]|0)+16>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,55)|0;i=177317;m=l+55|0;do{b[l>>0]=b[i>>0]|0;l=l+1|0;i=i+1|0}while((l|0)<(m|0));bO(-215,g,177373,177209,778);bD(g)}f[a>>2]=1124007936;g=a+8|0;i=a+40|0;l=a+4|0;m=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));f[i>>2]=g;g=a+48|0;f[a+44>>2]=g;f[g>>2]=0;f[a+52>>2]=0}else{g=c+28|0;oL(a,f[c+4>>2]|0,f[c+32>>2]|0,f[c>>2]&4095,k+(f[g>>2]|0)|0,f[c+36>>2]|0);f[a>>2]=f[c>>2];c=f[h>>2]|0;f[a+36>>2]=c;h=f[c+16>>2]|0;f[a+20>>2]=h;f[a+16>>2]=h+(f[g>>2]|0);g=h+(f[c+24>>2]|0)|0;f[a+24>>2]=g;f[a+28>>2]=g}QO(j);u=e;return}function rI(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=u;u=u+32|0;i=h+8|0;j=h;k=c+4|0;if((f[k>>2]|0)==(e|0)){if(!g){mI(a,c,d,0);u=h;return}if((e|0)==2){mI(a,c,d,f[g>>2]|0);u=h;return}}if(!(f[c>>2]&16384)){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,71)|0;m=182083;n=l+71|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-213,i,181862,177209,751);bD(i);f[a>>2]=1124007936;o=a+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[o+24>>2]=0;f[a+32>>2]=a+8;o=a+40|0;f[a+36>>2]=o;f[a+44>>2]=0;f[o>>2]=0;u=h;return}if(!((g|0)!=0&((d|0)>-1&(e+-1|0)>>>0<32))){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,54)|0;m=181870;n=l+54|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,i,181862,177209,715);bD(i)}if(d)if((d|0)<513)p=d;else{f[i>>2]=0;f[i+4>>2]=0;l=aD(i,10)|0;m=181925;n=l+10|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,i,181862,177209,720);bD(i);p=d}else p=((f[c>>2]|0)>>>3&511)+1|0;d=f[k>>2]|0;if((d|0)<3)q=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{o=f[c+32>>2]|0;r=0;s=1;while(1){t=Y(f[o+(r<<2)>>2]|0,s)|0;r=r+1|0;if((r|0)==(d|0)){q=t;break}else s=t}}s=Y(((f[c>>2]|0)>>>3&511)+1|0,q)|0;q=i+8|0;f[i>>2]=q;d=i+4|0;f[d>>2]=e;if(e>>>0>4){r=N5b(e>>>0>1073741823?-1:e<<2)|0;f[i>>2]=r}if((e|0)>0){r=c+32|0;o=j+4|0;t=j+4|0;v=p;w=0;while(1){x=g+(w<<2)|0;y=f[x>>2]|0;if((y|0)>-1)z=y;else{f[j>>2]=0;f[t>>2]=0;l=aD(j,14)|0;m=181936;n=l+14|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,j,181862,177209,729);bD(j);z=f[x>>2]|0}do if((z|0)<=0)if((w|0)<(f[k>>2]|0)){y=f[(f[r>>2]|0)+(w<<2)>>2]|0;f[(f[i>>2]|0)+(w<<2)>>2]=y;A=y;break}else{f[j>>2]=0;f[o>>2]=0;l=aD(j,68)|0;m=181951;n=l+68|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-211,j,181862,177209,736);bD(j);A=f[(f[i>>2]|0)+(w<<2)>>2]|0;break}else{f[(f[i>>2]|0)+(w<<2)>>2]=z;A=z}while(0);x=Y(A,v)|0;w=w+1|0;if((w|0)>=(e|0)){B=x;break}else v=x}}else B=p;if((B|0)!=(s|0)){f[j>>2]=0;f[j+4>>2]=0;l=aD(j,62)|0;m=182020;n=l+62|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-209,j,181862,177209,742);bD(j)}f[a>>2]=f[c>>2];j=a+4|0;m=f[k>>2]|0;f[j>>2]=m;l=a+8|0;f[l>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];n=f[c+24>>2]|0;f[a+24>>2]=n;f[a+28>>2]=f[c+28>>2];s=a+32|0;f[s>>2]=l;l=a+40|0;B=a+36|0;f[B>>2]=l;f[a+44>>2]=0;f[l>>2]=0;if(!n)C=m;else{m=n+8|0;f[m>>2]=(f[m>>2]|0)+1;C=f[k>>2]|0}if((C|0)>=3){f[j>>2]=0;bI(a,C,0,0,0);if((f[j>>2]|0)>0){C=f[c+32>>2]|0;k=f[s>>2]|0;s=f[c+36>>2]|0;m=f[B>>2]|0;n=0;do{f[k+(n<<2)>>2]=f[C+(n<<2)>>2];f[m+(n<<2)>>2]=f[s+(n<<2)>>2];n=n+1|0}while((n|0)<(f[j>>2]|0))}}else{j=f[c+36>>2]|0;c=f[B>>2]|0;f[c>>2]=f[j>>2];f[c+4>>2]=f[j+4>>2]}f[a>>2]=f[a>>2]&-4089|(p<<3)+-8;bI(a,e,f[i>>2]|0,0,1);e=f[i>>2]|0;if((e|0)!=(q|0)){if(e|0)P5b(e);f[i>>2]=q;f[d>>2]=4}u=h;return}function sI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+4|0;if((f[c>>2]|0)<=0)return;d=f[a+36>>2]|0;e=0;g=f[a+28>>2]|0;do{a=f[d+(e<<2)>>2]|0;h=(g>>>0)/(a>>>0)|0;f[b+(e<<2)>>2]=h;g=g-(Y(h,a)|0)|0;e=e+1|0}while((e|0)<(f[c>>2]|0));return}function tI(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=d+-4|0;if((d|0)<4){f=0;g=0}else{i=0;j=0;do{k=i|1;l=i|2;m=i|3;j=(h[175198+((b[c+i>>0]^b[a+i>>0])&255)>>0]|0)+j+(h[175198+((b[c+k>>0]^b[a+k>>0])&255)>>0]|0)+(h[175198+((b[c+l>>0]^b[a+l>>0])&255)>>0]|0)+(h[175198+((b[c+m>>0]^b[a+m>>0])&255)>>0]|0)|0;i=i+4|0}while((i|0)<=(e|0));f=j;g=d&-4}if((g|0)<(d|0)){n=g;o=f}else{p=f;return p|0}while(1){f=(h[175198+((b[c+n>>0]^b[a+n>>0])&255)>>0]|0)+o|0;n=n+1|0;if((n|0)==(d|0)){p=f;break}else o=f}return p|0}function uI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;dQ(d,41376);e=b+-4|0;if((b|0)<4){g=0;i=0}else{j=0;k=0;do{k=(h[175198+(h[a+j>>0]|0)>>0]|0)+k+(h[175198+(h[a+(j|1)>>0]|0)>>0]|0)+(h[175198+(h[a+(j|2)>>0]|0)>>0]|0)+(h[175198+(h[a+(j|3)>>0]|0)>>0]|0)|0;j=j+4|0}while((j|0)<=(e|0));g=k;i=b&-4}if((i|0)<(b|0)){k=i;i=g;while(1){e=(h[175198+(h[a+k>>0]|0)>>0]|0)+i|0;k=k+1|0;if((k|0)==(b|0)){l=e;break}else i=e}}else l=g;if(!(f[d+4>>2]|0)){u=c;return l|0}u=c;return l|0}function vI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;dQ(e,41396);g=tI(a,b,c)|0;if(!(f[e+4>>2]|0)){u=d;return g|0}u=d;return g|0}function wI(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+1104|0;e=d+1096|0;g=d+1080|0;h=d+40|0;i=d+8|0;j=d;dQ(e,41416);k=f[a>>2]|0;l=k&7;m=k>>>3&511;k=m+1|0;if(m){n=a+4|0;o=a+40|0;p=0;while(1){hL(c+(p*56|0)|0,f[n>>2]|0,f[o>>2]|0,l);if((p|0)<(m|0))p=p+1|0;else break}p=f[41436+(l<<2)>>2]|0;if((l|0)==7){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,9)|0;o=255890;q=l+9|0;do{b[l>>0]=b[o>>0]|0;l=l+1|0;o=o+1|0}while((l|0)<(q|0));bO(-215,g,378637,177716,162);bD(g)}o=f[n>>2]|0;if((o|0)>0)r=f[(f[a+44>>2]|0)+(o+-1<<2)>>2]|0;else r=0;o=1212424721>>>(f[a>>2]<<2&28)&15;f[g>>2]=((r+1023|0)>>>0)/(r>>>0)|0;n=m+2|0;m=(n<<3)+16|0;l=h+8|0;f[h>>2]=l;q=h+4|0;f[q>>2]=m;if(m>>>0>1032){s=N5b(m)|0;f[h>>2]=s;t=s}else t=l;s=t+(k<<2)+4+15&-16;m=s;f[t>>2]=a;v=0;do{w=v;v=v+1|0;f[t+(v<<2)>>2]=c+(w*56|0)}while((v|0)!=(k|0));v=s;RN(i,t,v,n);n=f[i+20>>2]|0;f[j>>2]=n;t=536870911/(k>>>0)|0;if(k>>>0<5)x=n;else{s=f[g>>2]|0;x=s>>>0<n>>>0?s:f[j>>2]|0}s=x>>>0<t>>>0?x:t;t=i+16|0;x=m+4|0;w=n;y=n;n=0;while(1){if(n>>>0>=(f[t>>2]|0)>>>0)break;if(!w){z=0;A=y}else{B=w;C=y;D=0;while(1){E=B-D|0;F=s>>>0<E>>>0?s:E;th[p&511](f[v>>2]|0,x,F,k);D=D+s|0;if(D>>>0<C>>>0){E=Y(r,F)|0;f[v>>2]=(f[v>>2]|0)+E;E=Y(o,F)|0;F=0;do{F=F+1|0;G=m+(F<<2)|0;f[G>>2]=(f[G>>2]|0)+E}while((F|0)!=(k|0));H=f[j>>2]|0}else H=C;if(H>>>0<=D>>>0){z=H;A=H;break}else{B=H;C=H}}}aL(i)|0;w=z;y=A;n=n+1|0}n=f[h>>2]|0;if((n|0)!=(l|0)){if(n|0)P5b(n);f[h>>2]=l;f[q>>2]=1032}}else{q=g+8|0;f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=c;SP(a,g)}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function xI(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+80|0;e=d+72|0;g=d+16|0;h=d;dQ(e,41468);do if((yM(a)|0)==65536){i=f[a+4>>2]|0;f[g>>2]=f[i>>2];j=g+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=g+8|0;f[l>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];m=g+16|0;f[m>>2]=f[i+16>>2];f[g+20>>2]=f[i+20>>2];f[g+24>>2]=f[i+24>>2];f[g+28>>2]=f[i+28>>2];f[g+32>>2]=f[i+32>>2];n=f[i+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=l;l=g+48|0;o=g+44|0;f[o>>2]=l;f[l>>2]=0;f[g+52>>2]=0;if(n|0){l=n+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[o>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];p=m;break}else{f[j>>2]=0;jL(g,i);p=m;break}}else{yL(g,a,-1);p=g+16|0}while(0);if(f[p>>2]|0){a=g+4|0;m=f[a>>2]|0;if((m|0)<3)q=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{i=f[g+40>>2]|0;j=0;k=1;while(1){l=Y(f[i+(j<<2)>>2]|0,k)|0;j=j+1|0;if((j|0)==(m|0)){q=l;break}else k=l}}if(!((m|0)==0|(q|0)==0)){if((MM(c)|0?!(HM(c)|0):0)?(q=BL(c,-1)|0,(q|0)!=(f[g>>2]&7|0)):0){f[h>>2]=0;f[h+4>>2]=0;q=aD(h,58)|0;m=177828;k=q+58|0;do{b[q>>0]=b[m>>0]|0;q=q+1|0;m=m+1|0}while((q|0)<(k|0));bO(-215,h,378637,177716,257);bD(h)}m=f[g>>2]|0;q=m&7;k=m>>>3&511;aM(c,k+1|0,1,q,-1,0,0);m=g+40|0;j=0;while(1){wL(c,f[a>>2]|0,f[m>>2]|0,q,j,0,0);if((j|0)<(k|0))j=j+1|0;else break}f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;AM(c,h);wI(g,f[h>>2]|0);et(h)}else r=14}else r=14;if((r|0)==14)$L(c);c=g+36|0;r=f[c>>2]|0;if(r|0?(h=r+12|0,r=f[h>>2]|0,f[h>>2]=r+-1,(r|0)==1):0)kL(g);f[c>>2]=0;c=g+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[c>>2]|0)>0){p=f[g+40>>2]|0;r=0;do{f[p+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[c>>2]|0))}c=f[g+44>>2]|0;if((c|0)!=(g+48|0))UC(c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function yI(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0;e=u;u=u+2208|0;g=e+2200|0;h=e+2144|0;i=e+1080|0;j=e+40|0;k=e+8|0;l=e;dQ(g,41488);if(!((a|0)!=0&(c|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;m=aD(h,11)|0;n=177935;o=m+11|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,177947,177716,328);bD(h);p=f[a>>2]&7;if(!c){q=1;r=0;s=p;t=1;v=16}else{w=p;v=4}}else{w=f[a>>2]&7;v=4}if((v|0)==4){p=a+40|0;x=h+4|0;y=1;z=0;A=0;while(1){B=a+(A*56|0)|0;C=f[a+(A*56|0)+40>>2]|0;D=f[C+-4>>2]|0;E=f[p>>2]|0;a:do if((D|0)==(f[E+-4>>2]|0)){if((D|0)==2){if((f[C>>2]|0)!=(f[E>>2]|0)){v=13;break}if((f[C+4>>2]|0)!=(f[E+4>>2]|0)){v=13;break}}else if((D|0)>0){F=0;do{if((f[C+(F<<2)>>2]|0)!=(f[E+(F<<2)>>2]|0)){v=13;break a}F=F+1|0}while((F|0)<(D|0))}if((f[B>>2]&7|0)!=(w|0))v=13}else v=13;while(0);if((v|0)==13){v=0;f[h>>2]=0;f[x>>2]=0;m=aD(h,50)|0;n=177953;o=m+50|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,177947,177716,337);bD(h)}D=f[B>>2]|0;y=y&(D&4088|0)==0;G=D>>>3&511;H=z+1+G|0;A=A+1|0;if(A>>>0>=c>>>0)break;else z=H}if((z+G|0)>>>0<512){I=y;J=H;K=0;L=w}else{q=y;r=H;s=w;t=0;v=16}}if((v|0)==16){f[h>>2]=0;f[h+4>>2]=0;m=aD(h,19)|0;n=178004;o=m+19|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,177947,177716,342);bD(h);I=q;J=r;K=t;L=s}wL(d,f[a+4>>2]|0,f[a+40>>2]|0,(J<<3)+-8|L,-1,0,0);do if((yM(d)|0)==65536){s=f[d+4>>2]|0;f[h>>2]=f[s>>2];t=h+4|0;r=s+4|0;f[t>>2]=f[r>>2];q=h+8|0;f[q>>2]=f[s+8>>2];f[h+12>>2]=f[s+12>>2];f[h+16>>2]=f[s+16>>2];f[h+20>>2]=f[s+20>>2];f[h+24>>2]=f[s+24>>2];f[h+28>>2]=f[s+28>>2];f[h+32>>2]=f[s+32>>2];v=f[s+36>>2]|0;f[h+36>>2]=v;f[h+40>>2]=q;q=h+48|0;w=h+44|0;f[w>>2]=q;f[q>>2]=0;f[h+52>>2]=0;if(v|0){q=v+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[r>>2]|0)<3){r=f[s+44>>2]|0;q=f[w>>2]|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];break}else{f[t>>2]=0;jL(h,s);break}}else yL(h,d,-1);while(0);do if((c|0)!=1){if(!I){d=J<<1;s=i+8|0;f[i>>2]=s;t=i+4|0;f[t>>2]=d;if(d>>>0>264){r=N5b(d>>>0>1073741823?-1:d<<2)|0;f[i>>2]=r;M=r}else M=s;if(!K){r=0;d=0;while(1){q=(f[a+(d*56|0)>>2]|0)>>>3&511;w=0;while(1){v=w+r|0;H=v<<1;f[M+(H<<2)>>2]=v;f[M+((H|1)<<2)>>2]=v;if((w|0)==(q|0))break;else w=w+1|0}d=d+1|0;if((d|0)==(c|0))break;else r=r+1+q|0}}zI(a,c,h,1,M,J);r=f[i>>2]|0;if((r|0)!=(s|0)){if(r|0)P5b(r);f[i>>2]=s;f[t>>2]=264}break}r=f[41508+(L<<2)>>2]|0;if((L|0)==7){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,9)|0;n=255890;o=m+9|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,177947,177716,373);bD(i)}t=f[h+4>>2]|0;if((t|0)>0)N=f[(f[h+44>>2]|0)+(t+-1<<2)>>2]|0;else N=0;t=1212424721>>>(f[h>>2]<<2&28)&15;f[i>>2]=((N+1023|0)>>>0)/(N>>>0)|0;s=J+1|0;d=(s<<3)+16|0;B=j+8|0;f[j>>2]=B;w=j+4|0;f[w>>2]=d;if(d>>>0>1032){v=N5b(d)|0;f[j>>2]=v;O=v}else O=B;v=O+(J<<2)+4+15&-16;d=v;H=v;f[O>>2]=h;v=(J|0)>0;if(v){y=0;do{G=y;y=y+1|0;f[O+(y<<2)>>2]=a+(G*56|0)}while((y|0)!=(J|0))}RN(k,O,H,s);y=f[k+20>>2]|0;f[l>>2]=y;G=536870911/(J|0)|0;if((J|0)<5)P=y;else{z=f[i>>2]|0;P=z>>>0<y>>>0?z:f[l>>2]|0}z=P>>>0<G>>>0?P:G;G=k+16|0;A=d+4|0;b:do if(v){x=y;p=y;D=0;while(1){if(D>>>0>=(f[G>>2]|0)>>>0)break b;if(!x){Q=0;R=p}else{E=x;C=p;F=0;while(1){S=E-F|0;T=z>>>0<S>>>0?z:S;th[r&511](A,f[H>>2]|0,T,J);F=F+z|0;if(F>>>0<C>>>0){S=Y(N,T)|0;f[H>>2]=(f[H>>2]|0)+S;S=Y(t,T)|0;T=0;do{T=T+1|0;U=d+(T<<2)|0;f[U>>2]=(f[U>>2]|0)+S}while((T|0)!=(J|0));V=f[l>>2]|0}else V=C;if(V>>>0<=F>>>0){Q=V;R=V;break}else{E=V;C=V}}}aL(k)|0;x=Q;p=R;D=D+1|0}}else{D=y;p=y;x=0;while(1){if(x>>>0>=(f[G>>2]|0)>>>0)break b;if(!D){W=0;X=p}else{q=D;C=p;E=0;while(1){F=q-E|0;T=z>>>0<F>>>0?z:F;th[r&511](A,f[H>>2]|0,T,J);E=E+z|0;if(E>>>0<C>>>0){F=Y(N,T)|0;f[H>>2]=(f[H>>2]|0)+F;Z=f[l>>2]|0}else Z=C;if(Z>>>0<=E>>>0){W=Z;X=Z;break}else{q=Z;C=Z}}}aL(k)|0;D=W;p=X;x=x+1|0}}while(0);H=f[j>>2]|0;if((H|0)!=(B|0)){if(H|0)P5b(H);f[j>>2]=B;f[w>>2]=1032}}else{H=i+8|0;f[H>>2]=0;f[H+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;SP(a,i)}while(0);i=h+36|0;a=f[i>>2]|0;if(a|0?(j=a+12|0,a=f[j>>2]|0,f[j>>2]=a+-1,(a|0)==1):0)kL(h);f[i>>2]=0;i=h+16|0;a=h+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[a>>2]|0)>0){i=f[h+40>>2]|0;j=0;do{f[i+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[a>>2]|0))}a=f[h+44>>2]|0;if((a|0)!=(h+48|0))UC(a);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function zI(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0;i=u;u=u+1088|0;j=i+1072|0;k=i+32|0;l=i;dQ(j,41540);if(h|0){m=(e|0)!=0;if(!((a|0)!=0&(c|0)!=0&(d|0)!=0&m&(g|0)!=0)){f[k>>2]=0;f[k+4>>2]=0;n=aD(k,60)|0;o=178024;p=n+60|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,k,178085,177716,574);bD(k)}q=f[d>>2]|0;r=1212424721>>>(q<<2&28)&15;s=q&7;q=e+c|0;t=(q<<3)+8+(h<<5)|0;v=k+8|0;f[k>>2]=v;w=k+4|0;f[w>>2]=t;if(t>>>0>1032){x=N5b(t)|0;f[k>>2]=x;y=x}else y=v;x=y+(c<<2)+(e<<2)|0;t=x+(c<<2)+(e<<2)+4|0;z=t+(h<<2)|0;A=z+(h<<2)|0;B=A+(h<<2<<2)|0;C=B+(h<<2)|0;D=(c|0)==0;if(!D){E=0;do{f[y+(E<<2)>>2]=a+(E*56|0);E=E+1|0}while((E|0)!=(c|0))}if(e|0){E=0;do{f[y+(E+c<<2)>>2]=d+(E*56|0);E=E+1|0}while((E|0)!=(e|0))}f[x+(q<<2)>>2]=0;E=l+4|0;F=l+4|0;G=0;do{H=G<<1;I=f[g+(H<<2)>>2]|0;J=f[g+((H|1)<<2)>>2]|0;if((I|0)>-1){a:do if(!D){H=I;K=0;while(1){L=f[a+(K*56|0)>>2]|0;M=L>>>3&511;if((H|0)<=(M|0))break;N=H+-1-M|0;M=K+1|0;if(M>>>0<c>>>0){H=N;K=M}else{O=N;P=M;Q=16;break a}}if((L&7|0)==(s|0)){R=H;S=K}else{O=H;P=K;Q=16}}else{O=I;P=0;Q=16}while(0);if((Q|0)==16){Q=0;f[l>>2]=0;f[E>>2]=0;n=aD(l,36)|0;o=178097;p=n+36|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,l,178085,177716,601);bD(l);R=O;S=P}I=G<<2;f[A+(I<<2)>>2]=S;M=Y(R,r)|0;f[A+((I|1)<<2)>>2]=M;T=((f[a+(S*56|0)>>2]|0)>>>3&511)+1|0}else{M=G<<2;f[A+(M<<2)>>2]=q;f[A+((M|1)<<2)>>2]=0;T=0}f[B+(G<<2)>>2]=T;b:do if(m){M=J;I=0;while(1){U=f[d+(I*56|0)>>2]|0;N=U>>>3&511;if((M|0)<=(N|0))break;V=M+-1-N|0;N=I+1|0;if(N>>>0<e>>>0){M=V;I=N}else{W=V;X=N;Q=23;break b}}if((M|0)>-1&(U&7|0)==(s|0)){Z=M;_=I}else{W=M;X=I;Q=23}}else{W=J;X=0;Q=23}while(0);if((Q|0)==23){Q=0;f[l>>2]=0;f[F>>2]=0;n=aD(l,47)|0;o=178134;p=n+47|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,l,178085,177716,614);bD(l);Z=W;_=X}J=G<<2;f[A+((J|2)<<2)>>2]=_+c;K=Y(Z,r)|0;f[A+((J|3)<<2)>>2]=K;f[C+(G<<2)>>2]=((f[d+(_*56|0)>>2]|0)>>>3&511)+1;G=G+1|0}while(G>>>0<h>>>0);RN(l,y,x,q);q=f[l+20>>2]|0;y=((r+1023|0)>>>0)/(r>>>0)|0;G=(y|0)<(q|0)?y:q;y=f[41560+(s<<2)>>2]|0;s=l+16|0;_=(q|0)>0;d=Y(G,r)|0;r=0;while(1){if(r>>>0<(f[s>>2]|0)>>>0)$=0;else break;do{Z=$<<2;f[t+($<<2)>>2]=(f[x+(f[A+(Z<<2)>>2]<<2)>>2]|0)+(f[A+((Z|1)<<2)>>2]|0);f[z+($<<2)>>2]=(f[x+(f[A+((Z|2)<<2)>>2]<<2)>>2]|0)+(f[A+((Z|3)<<2)>>2]|0);$=$+1|0}while(($|0)!=(h|0));c:do if(_){Z=0;do{c=q-Z|0;Wg[y&127](t,B,z,C,(G|0)<(c|0)?G:c,h);Z=Z+G|0;c=(Z|0)<(q|0);if(c)aa=0;else break c;do{X=Y(d,f[B+(aa<<2)>>2]|0)|0;W=t+(aa<<2)|0;f[W>>2]=(f[W>>2]|0)+X;X=Y(d,f[C+(aa<<2)>>2]|0)|0;W=z+(aa<<2)|0;f[W>>2]=(f[W>>2]|0)+X;aa=aa+1|0}while((aa|0)!=(h|0))}while(c)}while(0);aL(l)|0;r=r+1|0}r=f[k>>2]|0;if((r|0)!=(v|0)){if(r|0)P5b(r);f[k>>2]=v;f[w>>2]=1032}}if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function AI(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;if((h|0)<=0)return;i=g+-2|0;if((g|0)<2){if((g|0)==1)j=0;else return;do{k=f[a+(j<<2)>>2]|0;if(!k)l=0;else l=b[k>>0]|0;b[f[d+(j<<2)>>2]>>0]=l;j=j+1|0}while((j|0)!=(h|0));return}j=g&-2;if((j|0)<(g|0))m=0;else{g=0;do{l=f[a+(g<<2)>>2]|0;k=f[d+(g<<2)>>2]|0;n=f[c+(g<<2)>>2]|0;o=f[e+(g<<2)>>2]|0;if(!l){p=o<<1;q=k;r=0;while(1){b[q+o>>0]=0;b[q>>0]=0;r=r+2|0;if((r|0)>(i|0))break;else q=q+p|0}}else{p=n<<1;q=o<<1;r=l;s=k;t=0;while(1){u=b[r+n>>0]|0;b[s>>0]=b[r>>0]|0;b[s+o>>0]=u;t=t+2|0;if((t|0)>(i|0))break;else{r=r+p|0;s=s+q|0}}}g=g+1|0}while((g|0)!=(h|0));return}do{g=f[a+(m<<2)>>2]|0;q=f[d+(m<<2)>>2]|0;s=f[c+(m<<2)>>2]|0;p=f[e+(m<<2)>>2]|0;if(!g){r=p<<1;t=q;o=0;while(1){b[t+p>>0]=0;b[t>>0]=0;o=o+2|0;if((o|0)>(i|0))break;else t=t+r|0}r=q+(Y(p,j)|0)|0;b[r>>0]=0}else{r=s<<1;t=p<<1;o=Y(s,j)|0;n=g;k=q;l=0;while(1){u=b[n+s>>0]|0;b[k>>0]=b[n>>0]|0;b[k+p>>0]=u;l=l+2|0;if((l|0)>(i|0))break;else{n=n+r|0;k=k+t|0}}t=q+(Y(p,j)|0)|0;b[t>>0]=b[g+o>>0]|0}m=m+1|0}while((m|0)!=(h|0));return}function BI(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((h|0)<=0)return;i=g+-2|0;if((g|0)<2){if((g|0)==1)j=0;else return;do{k=f[a+(j<<2)>>2]|0;if(!k)l=0;else l=d[k>>1]|0;d[f[c+(j<<2)>>2]>>1]=l;j=j+1|0}while((j|0)!=(h|0));return}j=i>>>1;l=(j<<2)+4|0;if(((j<<1)+2|0)<(g|0))m=0;else{g=0;do{j=f[a+(g<<2)>>2]|0;k=f[c+(g<<2)>>2]|0;n=f[b+(g<<2)>>2]|0;o=f[e+(g<<2)>>2]|0;if(!j){p=o<<1;q=k;r=0;while(1){d[q+(o<<1)>>1]=0;d[q>>1]=0;r=r+2|0;if((r|0)>(i|0))break;else q=q+(p<<1)|0}}else{p=n<<1;q=o<<1;r=j;s=k;t=0;while(1){u=d[r+(n<<1)>>1]|0;d[s>>1]=d[r>>1]|0;d[s+(o<<1)>>1]=u;t=t+2|0;if((t|0)>(i|0))break;else{r=r+(p<<1)|0;s=s+(q<<1)|0}}}g=g+1|0}while((g|0)!=(h|0));return}do{g=f[a+(m<<2)>>2]|0;q=f[c+(m<<2)>>2]|0;s=f[b+(m<<2)>>2]|0;p=f[e+(m<<2)>>2]|0;if(!g){r=p<<1;t=Y(p,l)|0;o=q;n=0;while(1){d[o+(p<<1)>>1]=0;d[o>>1]=0;n=n+2|0;if((n|0)>(i|0))break;else o=o+(r<<1)|0}d[q+t>>1]=0}else{r=s<<1;o=p<<1;n=Y(s,l)|0;k=Y(p,l)|0;j=g;u=q;v=0;while(1){w=d[j+(s<<1)>>1]|0;d[u>>1]=d[j>>1]|0;d[u+(p<<1)>>1]=w;v=v+2|0;if((v|0)>(i|0))break;else{j=j+(r<<1)|0;u=u+(o<<1)|0}}d[q+k>>1]=d[g+n>>1]|0}m=m+1|0}while((m|0)!=(h|0));return}function CI(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;if((g|0)<=0)return;h=e+-2|0;if((e|0)<2){if((e|0)==1)i=0;else return;do{j=f[a+(i<<2)>>2]|0;if(!j)k=0;else k=f[j>>2]|0;f[f[c+(i<<2)>>2]>>2]=k;i=i+1|0}while((i|0)!=(g|0));return}i=h>>>1;k=(i<<3)+8|0;if(((i<<1)+2|0)<(e|0))l=0;else{e=0;do{i=f[a+(e<<2)>>2]|0;j=f[c+(e<<2)>>2]|0;m=f[b+(e<<2)>>2]|0;n=f[d+(e<<2)>>2]|0;if(!i){o=n<<1;p=j;q=0;while(1){f[p+(n<<2)>>2]=0;f[p>>2]=0;q=q+2|0;if((q|0)>(h|0))break;else p=p+(o<<2)|0}}else{o=m<<1;p=n<<1;q=i;r=j;s=0;while(1){t=f[q+(m<<2)>>2]|0;f[r>>2]=f[q>>2];f[r+(n<<2)>>2]=t;s=s+2|0;if((s|0)>(h|0))break;else{q=q+(o<<2)|0;r=r+(p<<2)|0}}}e=e+1|0}while((e|0)!=(g|0));return}do{e=f[a+(l<<2)>>2]|0;p=f[c+(l<<2)>>2]|0;r=f[b+(l<<2)>>2]|0;o=f[d+(l<<2)>>2]|0;if(!e){q=o<<1;s=Y(o,k)|0;n=p;m=0;while(1){f[n+(o<<2)>>2]=0;f[n>>2]=0;m=m+2|0;if((m|0)>(h|0))break;else n=n+(q<<2)|0}f[p+s>>2]=0}else{q=r<<1;n=o<<1;m=Y(r,k)|0;j=Y(o,k)|0;i=e;t=p;u=0;while(1){v=f[i+(r<<2)>>2]|0;f[t>>2]=f[i>>2];f[t+(o<<2)>>2]=v;u=u+2|0;if((u|0)>(h|0))break;else{i=i+(q<<2)|0;t=t+(n<<2)|0}}f[p+j>>2]=f[e+m>>2]}l=l+1|0}while((l|0)!=(g|0));return}function DI(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;if((g|0)<=0)return;h=e+-2|0;if((e|0)<2){if((e|0)==1)i=0;else return;do{j=f[a+(i<<2)>>2]|0;if(!j){k=0;l=0}else{m=j;k=f[m>>2]|0;l=f[m+4>>2]|0}m=f[c+(i<<2)>>2]|0;f[m>>2]=k;f[m+4>>2]=l;i=i+1|0}while((i|0)!=(g|0));return}i=h>>>1;l=(i<<4)+16|0;if(((i<<1)+2|0)<(e|0))n=0;else{e=0;do{i=f[a+(e<<2)>>2]|0;k=f[c+(e<<2)>>2]|0;m=f[b+(e<<2)>>2]|0;j=f[d+(e<<2)>>2]|0;if(!i){o=j<<1;p=k;q=0;while(1){r=p+(j<<3)|0;f[r>>2]=0;f[r+4>>2]=0;r=p;f[r>>2]=0;f[r+4>>2]=0;q=q+2|0;if((q|0)>(h|0))break;else p=p+(o<<3)|0}}else{o=m<<1;p=j<<1;q=i;r=k;s=0;while(1){t=q;u=f[t+4>>2]|0;v=q+(m<<3)|0;w=f[v>>2]|0;x=f[v+4>>2]|0;v=r;f[v>>2]=f[t>>2];f[v+4>>2]=u;u=r+(j<<3)|0;f[u>>2]=w;f[u+4>>2]=x;s=s+2|0;if((s|0)>(h|0))break;else{q=q+(o<<3)|0;r=r+(p<<3)|0}}}e=e+1|0}while((e|0)!=(g|0));return}do{e=f[a+(n<<2)>>2]|0;p=f[c+(n<<2)>>2]|0;r=f[b+(n<<2)>>2]|0;o=f[d+(n<<2)>>2]|0;if(!e){q=o<<1;s=Y(o,l)|0;j=p;m=0;while(1){k=j+(o<<3)|0;f[k>>2]=0;f[k+4>>2]=0;k=j;f[k>>2]=0;f[k+4>>2]=0;m=m+2|0;if((m|0)>(h|0))break;else j=j+(q<<3)|0}q=p+s|0;f[q>>2]=0;f[q+4>>2]=0}else{q=r<<1;j=o<<1;m=Y(r,l)|0;k=Y(o,l)|0;i=e;x=p;u=0;while(1){w=i;v=f[w+4>>2]|0;t=i+(r<<3)|0;y=f[t>>2]|0;z=f[t+4>>2]|0;t=x;f[t>>2]=f[w>>2];f[t+4>>2]=v;v=x+(o<<3)|0;f[v>>2]=y;f[v+4>>2]=z;u=u+2|0;if((u|0)>(h|0))break;else{i=i+(q<<3)|0;x=x+(j<<3)|0}}j=e+m|0;x=f[j+4>>2]|0;q=p+k|0;f[q>>2]=f[j>>2];f[q+4>>2]=x}n=n+1|0}while((n|0)!=(g|0));return}function EI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+32|0;d=c+16|0;e=c;dQ(d,41592);f[e>>2]=0;g=e+4|0;f[g>>2]=0;f[e+8>>2]=0;AM(a,e);a=f[e>>2]|0;h=f[g>>2]|0;yI((a|0)==(h|0)?0:a,(h-a|0)/56|0,b);et(e);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function FI(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=0;do{f[a+8+(d*56|0)>>2]=1124007936;e=a+8+(d*56|0)+8|0;g=a+8+(d*56|0)+40|0;h=a+8+(d*56|0)+4|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[g>>2]=e;j=a+8+(d*56|0)+48|0;f[a+8+(d*56|0)+44>>2]=j;f[j>>2]=0;f[a+8+(d*56|0)+52>>2]=0;d=d+1|0}while((d|0)!=26);f[a>>2]=c;c=a+4|0;f[c>>2]=26;if(b>>>0<=26){f[c>>2]=b;return}HI(a);f[c>>2]=b;c=b*56|0;d=N5b(b>>>0>76695844|c>>>0>4294967291?-1:c+4|0)|0;f[d>>2]=b;c=d+4|0;d=c+(b*56|0)|0;b=c;do{f[b>>2]=1124007936;j=b+8|0;k=b+40|0;h=b+4|0;i=h+36|0;do{f[h>>2]=0;h=h+4|0}while((h|0)<(i|0));f[k>>2]=j;e=b+48|0;f[b+44>>2]=e;f[e>>2]=0;f[b+52>>2]=0;b=b+56|0}while((b|0)!=(d|0));f[a>>2]=c;return}function GI(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;HI(a);b=a+8|0;c=a+1464|0;do{a=c;c=c+-56|0;d=a+-20|0;e=f[d>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)kL(c);f[d>>2]=0;d=a+-40|0;e=a+-52|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[e>>2]|0)>0){d=f[a+-16>>2]|0;g=0;do{f[d+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[e>>2]|0))}e=f[a+-12>>2]|0;if((e|0)!=(a+-8|0))UC(e)}while((c|0)!=(b|0));return}function HI(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;c=a+8|0;if((b|0)==(c|0))return;if(b|0){d=b+-4|0;e=f[d>>2]|0;if(e|0){g=b+(e*56|0)|0;do{e=g;g=g+-56|0;h=e+-20|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)kL(g);f[h>>2]=0;h=e+-40|0;i=e+-52|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[i>>2]|0)>0){h=f[e+-16>>2]|0;j=0;do{f[h+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[i>>2]|0))}i=f[e+-12>>2]|0;if((i|0)!=(e+-8|0))UC(i)}while((g|0)!=(b|0))}P5b(d)}f[a>>2]=c;f[a+4>>2]=26;return}function II(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+1536|0;g=e+1520|0;h=e+56|0;i=e;dQ(g,41612);j=d+4|0;if((f[d>>2]|0)!=(f[j>>2]|0)){if(((yM(a)|0)!=327680?(yM(a)|0)!=983040:0)?(yM(a)|0)!=262144:0)k=(yM(a)|0)!=720896;else k=0;if(((yM(c)|0)!=327680?(yM(c)|0)!=983040:0)?(yM(c)|0)!=262144:0)l=(yM(c)|0)!=720896;else l=0;if(k)m=1;else m=EM(a,-1)|0;if(l)n=1;else n=EM(c,-1)|0;o=(m|0)>0;p=(n|0)>0;if(!(p&(o&((f[j>>2]|0)-(f[d>>2]|0)&4|0)==0))){f[h>>2]=0;f[h+4>>2]=0;q=aD(h,44)|0;r=178369;s=q+44|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-215,h,178085,177716,801);bD(h)}FI(h,n+m|0);r=f[h>>2]|0;if(o){o=a+4|0;q=i+4|0;s=i+8|0;t=i+12|0;v=i+16|0;w=i+20|0;x=i+24|0;y=i+28|0;z=i+32|0;A=i+36|0;B=i+40|0;C=i+48|0;D=i+44|0;E=i+52|0;F=0;do{G=k?-1:F;do if((G|0)<0&(yM(a)|0)==65536){H=f[o>>2]|0;f[i>>2]=f[H>>2];I=H+4|0;f[q>>2]=f[I>>2];f[s>>2]=f[H+8>>2];f[t>>2]=f[H+12>>2];f[v>>2]=f[H+16>>2];f[w>>2]=f[H+20>>2];f[x>>2]=f[H+24>>2];f[y>>2]=f[H+28>>2];f[z>>2]=f[H+32>>2];J=f[H+36>>2]|0;f[A>>2]=J;f[B>>2]=s;f[D>>2]=C;f[C>>2]=0;f[E>>2]=0;if(J|0){K=J+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[I>>2]|0)<3){I=f[H+44>>2]|0;K=f[D>>2]|0;f[K>>2]=f[I>>2];f[K+4>>2]=f[I+4>>2];break}else{f[q>>2]=0;jL(i,H);break}}else yL(i,a,G);while(0);G=r+(F*56|0)|0;if((G|0)!=(i|0)){H=f[A>>2]|0;if(H|0){I=H+12|0;f[I>>2]=(f[I>>2]|0)+1}I=r+(F*56|0)+36|0;H=f[I>>2]|0;if(H|0?(K=H+12|0,H=f[K>>2]|0,f[K>>2]=H+-1,(H|0)==1):0)kL(G);f[I>>2]=0;H=r+(F*56|0)+16|0;K=r+(F*56|0)+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[K>>2]|0)>0){J=f[r+(F*56|0)+40>>2]|0;L=0;do{f[J+(L<<2)>>2]=0;L=L+1|0;M=f[K>>2]|0}while((L|0)<(M|0));f[G>>2]=f[i>>2];if((M|0)<3)N=38;else N=40}else{f[G>>2]=f[i>>2];N=38}if((N|0)==38){N=0;L=f[q>>2]|0;if((L|0)<3){f[K>>2]=L;f[r+(F*56|0)+8>>2]=f[s>>2];f[r+(F*56|0)+12>>2]=f[t>>2];L=f[D>>2]|0;J=f[r+(F*56|0)+44>>2]|0;f[J>>2]=f[L>>2];f[J+4>>2]=f[L+4>>2]}else N=40}if((N|0)==40){N=0;jL(G,i)}f[H>>2]=f[v>>2];f[r+(F*56|0)+20>>2]=f[w>>2];f[r+(F*56|0)+24>>2]=f[x>>2];f[r+(F*56|0)+28>>2]=f[y>>2];f[r+(F*56|0)+32>>2]=f[z>>2];f[I>>2]=f[A>>2]}L=f[A>>2]|0;if(L|0?(J=L+12|0,L=f[J>>2]|0,f[J>>2]=L+-1,(L|0)==1):0)kL(i);f[A>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[q>>2]|0)>0){L=f[B>>2]|0;J=0;do{f[L+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[q>>2]|0))}J=f[D>>2]|0;if((J|0)!=(C|0))UC(J);F=F+1|0}while((F|0)<(m|0))}if(p){p=c+4|0;F=i+4|0;C=i+8|0;D=i+12|0;q=i+16|0;B=i+20|0;v=i+24|0;A=i+28|0;z=i+32|0;y=i+36|0;x=i+40|0;w=i+48|0;t=i+44|0;s=i+52|0;M=0;do{a=l?-1:M;do if((a|0)<0&(yM(c)|0)==65536){E=f[p>>2]|0;f[i>>2]=f[E>>2];o=E+4|0;f[F>>2]=f[o>>2];f[C>>2]=f[E+8>>2];f[D>>2]=f[E+12>>2];f[q>>2]=f[E+16>>2];f[B>>2]=f[E+20>>2];f[v>>2]=f[E+24>>2];f[A>>2]=f[E+28>>2];f[z>>2]=f[E+32>>2];k=f[E+36>>2]|0;f[y>>2]=k;f[x>>2]=C;f[t>>2]=w;f[w>>2]=0;f[s>>2]=0;if(k|0){J=k+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[o>>2]|0)<3){o=f[E+44>>2]|0;J=f[t>>2]|0;f[J>>2]=f[o>>2];f[J+4>>2]=f[o+4>>2];break}else{f[F>>2]=0;jL(i,E);break}}else yL(i,c,a);while(0);a=M+m|0;E=r+(a*56|0)|0;if((E|0)!=(i|0)){o=f[y>>2]|0;if(o|0){J=o+12|0;f[J>>2]=(f[J>>2]|0)+1}J=r+(a*56|0)+36|0;o=f[J>>2]|0;if(o|0?(k=o+12|0,o=f[k>>2]|0,f[k>>2]=o+-1,(o|0)==1):0)kL(E);f[J>>2]=0;o=r+(a*56|0)+16|0;k=r+(a*56|0)+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[k>>2]|0)>0){L=f[r+(a*56|0)+40>>2]|0;I=0;do{f[L+(I<<2)>>2]=0;I=I+1|0;O=f[k>>2]|0}while((I|0)<(O|0));f[E>>2]=f[i>>2];if((O|0)<3)N=69;else N=71}else{f[E>>2]=f[i>>2];N=69}if((N|0)==69){N=0;I=f[F>>2]|0;if((I|0)<3){f[k>>2]=I;f[r+(a*56|0)+8>>2]=f[C>>2];f[r+(a*56|0)+12>>2]=f[D>>2];I=f[t>>2]|0;L=f[r+(a*56|0)+44>>2]|0;f[L>>2]=f[I>>2];f[L+4>>2]=f[I+4>>2]}else N=71}if((N|0)==71){N=0;jL(E,i)}f[o>>2]=f[q>>2];f[r+(a*56|0)+20>>2]=f[B>>2];f[r+(a*56|0)+24>>2]=f[v>>2];f[r+(a*56|0)+28>>2]=f[A>>2];f[r+(a*56|0)+32>>2]=f[z>>2];f[J>>2]=f[y>>2]}I=f[y>>2]|0;if(I|0?(L=I+12|0,I=f[L>>2]|0,f[L>>2]=I+-1,(I|0)==1):0)kL(i);f[y>>2]=0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[F>>2]|0)>0){I=f[x>>2]|0;L=0;do{f[I+(L<<2)>>2]=0;L=L+1|0}while((L|0)<(f[F>>2]|0))}L=f[t>>2]|0;if((L|0)!=(w|0))UC(L);M=M+1|0}while((M|0)<(n|0))}M=f[d>>2]|0;zI(r,m,r+(m*56|0)|0,n,M,(f[j>>2]|0)-M>>2>>>1);GI(h)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function JI(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+128|0;g=e+120|0;h=e+112|0;i=e+56|0;j=e;dQ(g,41632);k=BL(a,-1)|0;l=k&7;if(!((d|0)>-1?(k>>>3&511|0)>=(d|0):0)){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,20)|0;m=178507;n=k+20|0;do{b[k>>0]=b[m>>0]|0;k=k+1|0;m=m+1|0}while((k|0)<(n|0));bO(-215,h,178528,177716,898);bD(h)}f[h>>2]=d;f[h+4>>2]=0;do if((yM(a)|0)==65536){d=f[a+4>>2]|0;f[i>>2]=f[d>>2];m=i+4|0;k=d+4|0;f[m>>2]=f[k>>2];n=i+8|0;f[n>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[i+16>>2]=f[d+16>>2];f[i+20>>2]=f[d+20>>2];f[i+24>>2]=f[d+24>>2];f[i+28>>2]=f[d+28>>2];f[i+32>>2]=f[d+32>>2];o=f[d+36>>2]|0;f[i+36>>2]=o;p=i+40|0;f[p>>2]=n;n=i+48|0;q=i+44|0;f[q>>2]=n;f[n>>2]=0;f[i+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[k>>2]|0)<3){k=f[d+44>>2]|0;n=f[q>>2]|0;f[n>>2]=f[k>>2];f[n+4>>2]=f[k+4>>2];r=p;s=m;break}else{f[m>>2]=0;jL(i,d);r=p;s=m;break}}else{yL(i,a,-1);r=i+40|0;s=i+4|0}while(0);wL(c,f[s>>2]|0,f[r>>2]|0,l,-1,0,0);do if((yM(c)|0)==65536){l=f[c+4>>2]|0;f[j>>2]=f[l>>2];a=j+4|0;m=l+4|0;f[a>>2]=f[m>>2];p=j+8|0;f[p>>2]=f[l+8>>2];f[j+12>>2]=f[l+12>>2];f[j+16>>2]=f[l+16>>2];f[j+20>>2]=f[l+20>>2];f[j+24>>2]=f[l+24>>2];f[j+28>>2]=f[l+28>>2];f[j+32>>2]=f[l+32>>2];d=f[l+36>>2]|0;f[j+36>>2]=d;f[j+40>>2]=p;p=j+48|0;k=j+44|0;f[k>>2]=p;f[p>>2]=0;f[j+52>>2]=0;if(d|0){p=d+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[m>>2]|0)<3){m=f[l+44>>2]|0;p=f[k>>2]|0;f[p>>2]=f[m>>2];f[p+4>>2]=f[m+4>>2];break}else{f[a>>2]=0;jL(j,l);break}}else yL(j,c,-1);while(0);zI(i,1,j,1,h,1);h=j+36|0;c=f[h>>2]|0;if(c|0?(l=c+12|0,c=f[l>>2]|0,f[l>>2]=c+-1,(c|0)==1):0)kL(j);f[h>>2]=0;h=j+16|0;c=j+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[c>>2]|0)>0){h=f[j+40>>2]|0;l=0;do{f[h+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[c>>2]|0))}c=f[j+44>>2]|0;if((c|0)!=(j+48|0))UC(c);c=i+36|0;j=f[c>>2]|0;if(j|0?(l=j+12|0,j=f[l>>2]|0,f[l>>2]=j+-1,(j|0)==1):0)kL(i);f[c>>2]=0;c=i+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[s>>2]|0)>0){c=f[r>>2]|0;r=0;do{f[c+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[s>>2]|0))}s=f[i+44>>2]|0;if((s|0)!=(i+48|0))UC(s);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function KI(a,b){a=a|0;b=b|0;return f[41652+((b&7)<<5)+((a&7)<<2)>>2]|0}function LI(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;i=f[h>>2]|0;d=f[h+4>>2]|0;if(!d)return;else{j=a;k=e;l=d}while(1){l=l+-1|0;Vac(k|0,j|0,i|0)|0;if(!l)break;else{j=j+b|0;k=k+g|0}}return}function MI(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=f[i>>2]|0;e=f[i+4>>2]|0;if(!e)return;i=j+-4|0;if((j|0)<4){d=(j|0)>0;k=g;l=a;m=e;while(1){m=m+-1|0;if(d){n=0;do{o=b[l+n>>0]|0;b[k+n>>0]=(o|0)>0?o:0;n=n+1|0}while((n|0)!=(j|0))}if(!m)break;else{k=k+h|0;l=l+c|0}}return}l=j&-4;k=(l|0)<(j|0);m=g;g=a;a=e;while(1){e=0;do{d=b[g+e>>0]|0;n=e|1;o=b[g+n>>0]|0;b[m+e>>0]=(d|0)>0?d:0;b[m+n>>0]=(o|0)>0?o:0;o=e|2;n=b[g+o>>0]|0;d=e|3;p=b[g+d>>0]|0;b[m+o>>0]=(n|0)>0?n:0;b[m+d>>0]=(p|0)>0?p:0;e=e+4|0}while((e|0)<=(i|0));a=a+-1|0;if(k){e=l;do{p=b[g+e>>0]|0;b[m+e>>0]=(p|0)>0?p:0;e=e+1|0}while((e|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+c|0}}return}function NI(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>1;if(!e)return;c=k+-4|0;if((k|0)<4){d=(k|0)>0;l=g;m=a;n=e;while(1){n=n+-1|0;if(d){o=0;do{p=j[m+(o<<1)>>1]|0;b[l+o>>0]=p>>>0<255?p:255;o=o+1|0}while((o|0)!=(k|0))}if(!n)break;else{l=l+h|0;m=m+(i<<1)|0}}return}m=k&-4;l=(m|0)<(k|0);n=g;g=a;a=e;while(1){e=0;do{d=j[g+(e<<1)>>1]|0;o=e|1;p=j[g+(o<<1)>>1]|0;b[n+e>>0]=d>>>0<255?d:255;b[n+o>>0]=p>>>0<255?p:255;p=e|2;o=j[g+(p<<1)>>1]|0;d=e|3;q=j[g+(d<<1)>>1]|0;b[n+p>>0]=o>>>0<255?o:255;b[n+d>>0]=q>>>0<255?q:255;e=e+4|0}while((e|0)<=(c|0));a=a+-1|0;if(l){e=m;do{q=j[g+(e<<1)>>1]|0;b[n+e>>0]=q>>>0<255?q:255;e=e+1|0}while((e|0)!=(k|0))}if(!a)break;else{n=n+h|0;g=g+(i<<1)|0}}return}function OI(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=c>>>1;if(!g)return;c=k+-4|0;if((k|0)<4){e=(k|0)>0;l=h;m=a;n=g;while(1){n=n+-1|0;if(e){o=0;do{p=d[m+(o<<1)>>1]|0;b[l+o>>0]=(p&65535)<256?p&65535:p<<16>>16>0?255:0;o=o+1|0}while((o|0)!=(k|0))}if(!n)break;else{l=l+i|0;m=m+(j<<1)|0}}return}m=k&-4;l=(m|0)<(k|0);n=h;h=a;a=g;while(1){g=0;do{e=d[h+(g<<1)>>1]|0;o=g|1;p=d[h+(o<<1)>>1]|0;b[n+g>>0]=(e&65535)<256?e&65535:e<<16>>16>0?255:0;b[n+o>>0]=(p&65535)<256?p&65535:p<<16>>16>0?255:0;p=g|2;o=d[h+(p<<1)>>1]|0;e=g|3;q=d[h+(e<<1)>>1]|0;b[n+p>>0]=(o&65535)<256?o&65535:o<<16>>16>0?255:0;b[n+e>>0]=(q&65535)<256?q&65535:q<<16>>16>0?255:0;g=g+4|0}while((g|0)<=(c|0));a=a+-1|0;if(l){g=m;do{q=d[h+(g<<1)>>1]|0;b[n+g>>0]=(q&65535)<256?q&65535:q<<16>>16>0?255:0;g=g+1|0}while((g|0)!=(k|0))}if(!a)break;else{n=n+i|0;h=h+(j<<1)|0}}return}function PI(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if(!e)return;c=j+-4|0;if((j|0)<4){d=(j|0)>0;k=g;l=a;m=e;while(1){m=m+-1|0;if(d){n=0;do{o=f[l+(n<<2)>>2]|0;b[k+n>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+1|0}while((n|0)!=(j|0))}if(!m)break;else{k=k+h|0;l=l+(i<<2)|0}}return}l=j&-4;k=(l|0)<(j|0);m=g;g=a;a=e;while(1){e=0;do{d=f[g+(e<<2)>>2]|0;n=e|1;o=f[g+(n<<2)>>2]|0;b[m+e>>0]=d>>>0<256?d:(d|0)>0?255:0;b[m+n>>0]=o>>>0<256?o:(o|0)>0?255:0;o=e|2;n=f[g+(o<<2)>>2]|0;d=e|3;p=f[g+(d<<2)>>2]|0;b[m+o>>0]=n>>>0<256?n:(n|0)>0?255:0;b[m+d>>0]=p>>>0<256?p:(p|0)>0?255:0;e=e+4|0}while((e|0)<=(c|0));a=a+-1|0;if(k){e=l;do{p=f[g+(e<<2)>>2]|0;b[m+e>>0]=p>>>0<256?p:(p|0)>0?255:0;e=e+1|0}while((e|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+(i<<2)|0}}return}function QI(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if(!e)return;c=j+-4|0;if((j|0)<4){d=(j|0)>0;k=g;l=a;m=e;while(1){m=m+-1|0;if(d){o=0;do{p=LVb(+n[l+(o<<2)>>2])|0;b[k+o>>0]=p>>>0<256?p:(p|0)>0?255:0;o=o+1|0}while((o|0)!=(j|0))}if(!m)break;else{k=k+h|0;l=l+(i<<2)|0}}return}l=j&-4;k=(l|0)<(j|0);m=g;g=a;a=e;while(1){e=0;do{d=LVb(+n[g+(e<<2)>>2])|0;o=e|1;p=LVb(+n[g+(o<<2)>>2])|0;b[m+e>>0]=d>>>0<256?d:(d|0)>0?255:0;b[m+o>>0]=p>>>0<256?p:(p|0)>0?255:0;p=e|2;o=LVb(+n[g+(p<<2)>>2])|0;d=e|3;q=LVb(+n[g+(d<<2)>>2])|0;b[m+p>>0]=o>>>0<256?o:(o|0)>0?255:0;b[m+d>>0]=q>>>0<256?q:(q|0)>0?255:0;e=e+4|0}while((e|0)<=(c|0));a=a+-1|0;if(k){e=l;do{q=LVb(+n[g+(e<<2)>>2])|0;b[m+e>>0]=q>>>0<256?q:(q|0)>0?255:0;e=e+1|0}while((e|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+(i<<2)|0}}return}function RI(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>3;if(!e)return;c=j+-4|0;if((j|0)<4){d=(j|0)>0;k=g;l=a;m=e;while(1){m=m+-1|0;if(d){n=0;do{o=MVb(+p[l+(n<<3)>>3])|0;b[k+n>>0]=o>>>0<256?o:(o|0)>0?255:0;n=n+1|0}while((n|0)!=(j|0))}if(!m)break;else{k=k+h|0;l=l+(i<<3)|0}}return}l=j&-4;k=(l|0)<(j|0);m=g;g=a;a=e;while(1){e=0;do{d=MVb(+p[g+(e<<3)>>3])|0;n=e|1;o=MVb(+p[g+(n<<3)>>3])|0;b[m+e>>0]=d>>>0<256?d:(d|0)>0?255:0;b[m+n>>0]=o>>>0<256?o:(o|0)>0?255:0;o=e|2;n=MVb(+p[g+(o<<3)>>3])|0;d=e|3;q=MVb(+p[g+(d<<3)>>3])|0;b[m+o>>0]=n>>>0<256?n:(n|0)>0?255:0;b[m+d>>0]=q>>>0<256?q:(q|0)>0?255:0;e=e+4|0}while((e|0)<=(c|0));a=a+-1|0;if(k){e=l;do{q=MVb(+p[g+(e<<3)>>3])|0;b[m+e>>0]=q>>>0<256?q:(q|0)>0?255:0;e=e+1|0}while((e|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+(i<<3)|0}}return}function SI(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;k=f[j>>2]|0;e=f[j+4>>2]|0;if(!e)return;j=k+-4|0;if((k|0)<4){d=(k|0)>0;l=g;m=a;n=e;while(1){n=n+-1|0;if(d){o=0;do{p=h[m+o>>0]|0;b[l+o>>0]=p>>>0<127?p:127;o=o+1|0}while((o|0)!=(k|0))}if(!n)break;else{l=l+i|0;m=m+c|0}}return}m=k&-4;l=(m|0)<(k|0);n=g;g=a;a=e;while(1){e=0;do{d=h[g+e>>0]|0;o=e|1;p=h[g+o>>0]|0;b[n+e>>0]=d>>>0<127?d:127;b[n+o>>0]=p>>>0<127?p:127;p=e|2;o=h[g+p>>0]|0;d=e|3;q=h[g+d>>0]|0;b[n+p>>0]=o>>>0<127?o:127;b[n+d>>0]=q>>>0<127?q:127;e=e+4|0}while((e|0)<=(j|0));a=a+-1|0;if(l){e=m;do{q=h[g+e>>0]|0;b[n+e>>0]=q>>>0<127?q:127;e=e+1|0}while((e|0)!=(k|0))}if(!a)break;else{n=n+i|0;g=g+c|0}}return}function TI(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>1;if(!e)return;c=k+-4|0;if((k|0)<4){d=(k|0)>0;l=g;m=a;n=e;while(1){n=n+-1|0;if(d){o=0;do{p=j[m+(o<<1)>>1]|0;b[l+o>>0]=p>>>0<127?p:127;o=o+1|0}while((o|0)!=(k|0))}if(!n)break;else{l=l+h|0;m=m+(i<<1)|0}}return}m=k&-4;l=(m|0)<(k|0);n=g;g=a;a=e;while(1){e=0;do{d=j[g+(e<<1)>>1]|0;o=e|1;p=j[g+(o<<1)>>1]|0;b[n+e>>0]=d>>>0<127?d:127;b[n+o>>0]=p>>>0<127?p:127;p=e|2;o=j[g+(p<<1)>>1]|0;d=e|3;q=j[g+(d<<1)>>1]|0;b[n+p>>0]=o>>>0<127?o:127;b[n+d>>0]=q>>>0<127?q:127;e=e+4|0}while((e|0)<=(c|0));a=a+-1|0;if(l){e=m;do{q=j[g+(e<<1)>>1]|0;b[n+e>>0]=q>>>0<127?q:127;e=e+1|0}while((e|0)!=(k|0))}if(!a)break;else{n=n+h|0;g=g+(i<<1)|0}}return}function UI(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=c>>>1;if(!g)return;c=k+-4|0;if((k|0)<4){e=(k|0)>0;l=h;m=a;n=g;while(1){n=n+-1|0;if(e){o=0;do{p=d[m+(o<<1)>>1]|0;q=p<<16>>16;b[l+o>>0]=(q+128|0)>>>0<256?q:p<<16>>16>0?127:128;o=o+1|0}while((o|0)!=(k|0))}if(!n)break;else{l=l+i|0;m=m+(j<<1)|0}}return}m=k&-4;l=(m|0)<(k|0);n=h;h=a;a=g;while(1){g=0;do{e=d[h+(g<<1)>>1]|0;o=e<<16>>16;p=g|1;q=d[h+(p<<1)>>1]|0;r=q<<16>>16;b[n+g>>0]=(o+128|0)>>>0<256?o:e<<16>>16>0?127:128;b[n+p>>0]=(r+128|0)>>>0<256?r:q<<16>>16>0?127:128;q=g|2;r=d[h+(q<<1)>>1]|0;p=r<<16>>16;e=g|3;o=d[h+(e<<1)>>1]|0;s=o<<16>>16;b[n+q>>0]=(p+128|0)>>>0<256?p:r<<16>>16>0?127:128;b[n+e>>0]=(s+128|0)>>>0<256?s:o<<16>>16>0?127:128;g=g+4|0}while((g|0)<=(c|0));a=a+-1|0;if(l){g=m;do{o=d[h+(g<<1)>>1]|0;s=o<<16>>16;b[n+g>>0]=(s+128|0)>>>0<256?s:o<<16>>16>0?127:128;g=g+1|0}while((g|0)!=(k|0))}if(!a)break;else{n=n+i|0;h=h+(j<<1)|0}}return}function VI(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if(!e)return;c=j+-4|0;if((j|0)<4){d=(j|0)>0;k=g;l=a;m=e;while(1){m=m+-1|0;if(d){n=0;do{o=f[l+(n<<2)>>2]|0;b[k+n>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;n=n+1|0}while((n|0)!=(j|0))}if(!m)break;else{k=k+h|0;l=l+(i<<2)|0}}return}l=j&-4;k=(l|0)<(j|0);m=g;g=a;a=e;while(1){e=0;do{d=f[g+(e<<2)>>2]|0;n=e|1;o=f[g+(n<<2)>>2]|0;b[m+e>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[m+n>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;o=e|2;n=f[g+(o<<2)>>2]|0;d=e|3;p=f[g+(d<<2)>>2]|0;b[m+o>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;b[m+d>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;e=e+4|0}while((e|0)<=(c|0));a=a+-1|0;if(k){e=l;do{p=f[g+(e<<2)>>2]|0;b[m+e>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;e=e+1|0}while((e|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+(i<<2)|0}}return}function WI(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>2;if(!e)return;c=j+-4|0;if((j|0)<4){d=(j|0)>0;k=g;l=a;m=e;while(1){m=m+-1|0;if(d){o=0;do{p=LVb(+n[l+(o<<2)>>2])|0;b[k+o>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;o=o+1|0}while((o|0)!=(j|0))}if(!m)break;else{k=k+h|0;l=l+(i<<2)|0}}return}l=j&-4;k=(l|0)<(j|0);m=g;g=a;a=e;while(1){e=0;do{d=LVb(+n[g+(e<<2)>>2])|0;o=e|1;p=LVb(+n[g+(o<<2)>>2])|0;b[m+e>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[m+o>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;p=e|2;o=LVb(+n[g+(p<<2)>>2])|0;d=e|3;q=LVb(+n[g+(d<<2)>>2])|0;b[m+p>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;b[m+d>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;e=e+4|0}while((e|0)<=(c|0));a=a+-1|0;if(k){e=l;do{q=LVb(+n[g+(e<<2)>>2])|0;b[m+e>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;e=e+1|0}while((e|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+(i<<2)|0}}return}function XI(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=c>>>3;if(!e)return;c=j+-4|0;if((j|0)<4){d=(j|0)>0;k=g;l=a;m=e;while(1){m=m+-1|0;if(d){n=0;do{o=MVb(+p[l+(n<<3)>>3])|0;b[k+n>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;n=n+1|0}while((n|0)!=(j|0))}if(!m)break;else{k=k+h|0;l=l+(i<<3)|0}}return}l=j&-4;k=(l|0)<(j|0);m=g;g=a;a=e;while(1){e=0;do{d=MVb(+p[g+(e<<3)>>3])|0;n=e|1;o=MVb(+p[g+(n<<3)>>3])|0;b[m+e>>0]=(d+128|0)>>>0<256?d:(d|0)>0?127:128;b[m+n>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;o=e|2;n=MVb(+p[g+(o<<3)>>3])|0;d=e|3;q=MVb(+p[g+(d<<3)>>3])|0;b[m+o>>0]=(n+128|0)>>>0<256?n:(n|0)>0?127:128;b[m+d>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;e=e+4|0}while((e|0)<=(c|0));a=a+-1|0;if(k){e=l;do{q=MVb(+p[g+(e<<3)>>3])|0;b[m+e>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;e=e+1|0}while((e|0)!=(j|0))}if(!a)break;else{m=m+h|0;g=g+(i<<3)|0}}return}function YI(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;k=f[j>>2]|0;e=f[j+4>>2]|0;j=i>>>1;if(!e)return;i=k+-4|0;if((k|0)<4){c=(k|0)>0;l=g;m=a;n=e;while(1){n=n+-1|0;if(c){o=0;do{d[l+(o<<1)>>1]=h[m+o>>0]|0;o=o+1|0}while((o|0)!=(k|0))}if(!n)break;else{l=l+(j<<1)|0;m=m+b|0}}return}m=k&-4;l=(m|0)<(k|0);n=g;g=a;a=e;while(1){e=0;do{c=e|1;o=h[g+c>>0]|0;d[n+(e<<1)>>1]=h[g+e>>0]|0;d[n+(c<<1)>>1]=o;o=e|2;c=e|3;p=h[g+c>>0]|0;d[n+(o<<1)>>1]=h[g+o>>0]|0;d[n+(c<<1)>>1]=p;e=e+4|0}while((e|0)<=(i|0));a=a+-1|0;if(l){e=m;do{d[n+(e<<1)>>1]=h[g+e>>0]|0;e=e+1|0}while((e|0)!=(k|0))}if(!a)break;else{n=n+(j<<1)|0;g=g+b|0}}return}function ZI(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=i>>>1;if(!g)return;i=k+-4|0;if((k|0)<4){e=(k|0)>0;l=h;m=a;n=g;while(1){n=n+-1|0;if(e){o=0;do{p=b[m+o>>0]|0;d[l+(o<<1)>>1]=(p|0)>0?p:0;o=o+1|0}while((o|0)!=(k|0))}if(!n)break;else{l=l+(j<<1)|0;m=m+c|0}}return}m=k&-4;l=(m|0)<(k|0);n=h;h=a;a=g;while(1){g=0;do{e=b[h+g>>0]|0;o=g|1;p=b[h+o>>0]|0;d[n+(g<<1)>>1]=(e|0)>0?e:0;d[n+(o<<1)>>1]=(p|0)>0?p:0;p=g|2;o=b[h+p>>0]|0;e=g|3;q=b[h+e>>0]|0;d[n+(p<<1)>>1]=(o|0)>0?o:0;d[n+(e<<1)>>1]=(q|0)>0?q:0;g=g+4|0}while((g|0)<=(i|0));a=a+-1|0;if(l){g=m;do{q=b[h+g>>0]|0;d[n+(g<<1)>>1]=(q|0)>0?q:0;g=g+1|0}while((g|0)!=(k|0))}if(!a)break;else{n=n+(j<<1)|0;h=h+c|0}}return}function _I(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;i=f[h+4>>2]|0;d=b>>>1;b=g>>>1;if(!i)return;g=f[h>>2]<<1;h=a;a=e;e=i;while(1){e=e+-1|0;Vac(a|0,h|0,g|0)|0;if(!e)break;else{h=h+(d<<1)|0;a=a+(b<<1)|0}}return}function $I(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>1;h=e+-1|0;if(!e)return;if((j|0)<4){if((j|0)>0){k=g;l=a;m=h}else return;while(1){e=0;do{c=d[l+(e<<1)>>1]|0;d[k+(e<<1)>>1]=(c|0)>0?c:0;e=e+1|0}while((e|0)!=(j|0));if(!m)break;else{k=k+(b<<1)|0;l=l+(i<<1)|0;m=m+-1|0}}return}m=j+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(j|0)){n=g;o=a;p=h}else{k=g;g=a;a=h;while(1){h=0;do{e=d[g+(h<<1)>>1]|0;c=h|1;q=d[g+(c<<1)>>1]|0;d[k+(h<<1)>>1]=(e|0)>0?e:0;d[k+(c<<1)>>1]=(q|0)>0?q:0;q=h|2;c=d[g+(q<<1)>>1]|0;e=h|3;r=d[g+(e<<1)>>1]|0;d[k+(q<<1)>>1]=(c|0)>0?c:0;d[k+(e<<1)>>1]=(r|0)>0?r:0;h=h+4|0}while((h|0)<=(m|0));if(!a)break;else{k=k+(b<<1)|0;g=g+(i<<1)|0;a=a+-1|0}}return}while(1){a=0;do{g=d[o+(a<<1)>>1]|0;k=a|1;h=d[o+(k<<1)>>1]|0;d[n+(a<<1)>>1]=(g|0)>0?g:0;d[n+(k<<1)>>1]=(h|0)>0?h:0;h=a|2;k=d[o+(h<<1)>>1]|0;g=a|3;r=d[o+(g<<1)>>1]|0;d[n+(h<<1)>>1]=(k|0)>0?k:0;d[n+(g<<1)>>1]=(r|0)>0?r:0;a=a+4|0}while((a|0)<=(m|0));s=l;do{a=d[o+(s<<1)>>1]|0;d[n+(s<<1)>>1]=(a|0)>0?a:0;s=s+1|0}while((s|0)!=(j|0));if(!p)break;else{n=n+(b<<1)|0;o=o+(i<<1)|0;p=p+-1|0}}return}function aJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if(!e)return;h=j+-4|0;c=(((h|0)>3?h:3)&2147483644)+4|0;if((j|0)<4){k=(j|0)>0;l=g;m=a;n=e;while(1){n=n+-1|0;if(k){o=0;do{p=f[m+(o<<2)>>2]|0;d[l+(o<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;o=o+1|0}while((o|0)!=(j|0))}if(!n)break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}m=(c|0)<(j|0);l=g;g=a;a=e;while(1){e=0;do{n=f[g+(e<<2)>>2]|0;k=e|1;o=f[g+(k<<2)>>2]|0;d[l+(e<<1)>>1]=n>>>0<65536?n:(n|0)>0?65535:0;d[l+(k<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=e|2;k=f[g+(o<<2)>>2]|0;n=e|3;p=f[g+(n<<2)>>2]|0;d[l+(o<<1)>>1]=k>>>0<65536?k:(k|0)>0?65535:0;d[l+(n<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;e=e+4|0}while((e|0)<=(h|0));a=a+-1|0;if(m){e=c;do{p=f[g+(e<<2)>>2]|0;d[l+(e<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;e=e+1|0}while((e|0)!=(j|0))}if(!a)break;else{l=l+(b<<1)|0;g=g+(i<<2)|0}}return}function bJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;h=e+-1|0;if(!e)return;if((j|0)<4){if((j|0)>0){k=g;l=a;m=h}else return;while(1){e=0;do{c=LVb(+n[l+(e<<2)>>2])|0;d[k+(e<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;e=e+1|0}while((e|0)!=(j|0));if(!m)break;else{k=k+(b<<1)|0;l=l+(i<<2)|0;m=m+-1|0}}return}m=j+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(j|0)){o=g;p=a;q=h}else{k=g;g=a;a=h;while(1){h=0;do{e=LVb(+n[g+(h<<2)>>2])|0;c=h|1;r=LVb(+n[g+(c<<2)>>2])|0;d[k+(h<<1)>>1]=e>>>0<65536?e:(e|0)>0?65535:0;d[k+(c<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;r=h|2;c=LVb(+n[g+(r<<2)>>2])|0;e=h|3;s=LVb(+n[g+(e<<2)>>2])|0;d[k+(r<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;d[k+(e<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;h=h+4|0}while((h|0)<=(m|0));if(!a)break;else{k=k+(b<<1)|0;g=g+(i<<2)|0;a=a+-1|0}}return}while(1){a=0;do{g=LVb(+n[p+(a<<2)>>2])|0;k=a|1;h=LVb(+n[p+(k<<2)>>2])|0;d[o+(a<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;d[o+(k<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;h=a|2;k=LVb(+n[p+(h<<2)>>2])|0;g=a|3;s=LVb(+n[p+(g<<2)>>2])|0;d[o+(h<<1)>>1]=k>>>0<65536?k:(k|0)>0?65535:0;d[o+(g<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+4|0}while((a|0)<=(m|0));t=l;do{a=LVb(+n[p+(t<<2)>>2])|0;d[o+(t<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;t=t+1|0}while((t|0)!=(j|0));if(!q)break;else{o=o+(b<<1)|0;p=p+(i<<2)|0;q=q+-1|0}}return}function cJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>3;b=h>>>1;h=e+-1|0;if(!e)return;if((j|0)<4){if((j|0)>0){k=g;l=a;m=h}else return;while(1){e=0;do{c=MVb(+p[l+(e<<3)>>3])|0;d[k+(e<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;e=e+1|0}while((e|0)!=(j|0));if(!m)break;else{k=k+(b<<1)|0;l=l+(i<<3)|0;m=m+-1|0}}return}m=j+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(j|0)){n=g;o=a;q=h}else{k=g;g=a;a=h;while(1){h=0;do{e=MVb(+p[g+(h<<3)>>3])|0;c=h|1;r=MVb(+p[g+(c<<3)>>3])|0;d[k+(h<<1)>>1]=e>>>0<65536?e:(e|0)>0?65535:0;d[k+(c<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;r=h|2;c=MVb(+p[g+(r<<3)>>3])|0;e=h|3;s=MVb(+p[g+(e<<3)>>3])|0;d[k+(r<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;d[k+(e<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;h=h+4|0}while((h|0)<=(m|0));if(!a)break;else{k=k+(b<<1)|0;g=g+(i<<3)|0;a=a+-1|0}}return}while(1){a=0;do{g=MVb(+p[o+(a<<3)>>3])|0;k=a|1;h=MVb(+p[o+(k<<3)>>3])|0;d[n+(a<<1)>>1]=g>>>0<65536?g:(g|0)>0?65535:0;d[n+(k<<1)>>1]=h>>>0<65536?h:(h|0)>0?65535:0;h=a|2;k=MVb(+p[o+(h<<3)>>3])|0;g=a|3;s=MVb(+p[o+(g<<3)>>3])|0;d[n+(h<<1)>>1]=k>>>0<65536?k:(k|0)>0?65535:0;d[n+(g<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;a=a+4|0}while((a|0)<=(m|0));t=l;do{a=MVb(+p[o+(t<<3)>>3])|0;d[n+(t<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;t=t+1|0}while((t|0)!=(j|0));if(!q)break;else{n=n+(b<<1)|0;o=o+(i<<3)|0;q=q+-1|0}}return}function dJ(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;k=f[j>>2]|0;e=f[j+4>>2]|0;j=i>>>1;if(!e)return;i=k+-4|0;if((k|0)<4){c=(k|0)>0;l=g;m=a;n=e;while(1){n=n+-1|0;if(c){o=0;do{d[l+(o<<1)>>1]=h[m+o>>0]|0;o=o+1|0}while((o|0)!=(k|0))}if(!n)break;else{l=l+(j<<1)|0;m=m+b|0}}return}m=k&-4;l=(m|0)<(k|0);n=g;g=a;a=e;while(1){e=0;do{c=e|1;o=h[g+c>>0]|0;d[n+(e<<1)>>1]=h[g+e>>0]|0;d[n+(c<<1)>>1]=o;o=e|2;c=e|3;p=h[g+c>>0]|0;d[n+(o<<1)>>1]=h[g+o>>0]|0;d[n+(c<<1)>>1]=p;e=e+4|0}while((e|0)<=(i|0));a=a+-1|0;if(l){e=m;do{d[n+(e<<1)>>1]=h[g+e>>0]|0;e=e+1|0}while((e|0)!=(k|0))}if(!a)break;else{n=n+(j<<1)|0;g=g+b|0}}return}function eJ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;k=f[j>>2]|0;g=f[j+4>>2]|0;j=i>>>1;if(!g)return;i=k+-4|0;if((k|0)<4){e=(k|0)>0;l=h;m=a;n=g;while(1){n=n+-1|0;if(e){o=0;do{d[l+(o<<1)>>1]=b[m+o>>0]|0;o=o+1|0}while((o|0)!=(k|0))}if(!n)break;else{l=l+(j<<1)|0;m=m+c|0}}return}m=k&-4;l=(m|0)<(k|0);n=h;h=a;a=g;while(1){g=0;do{e=g|1;o=b[h+e>>0]|0;d[n+(g<<1)>>1]=b[h+g>>0]|0;d[n+(e<<1)>>1]=o;o=g|2;e=g|3;p=b[h+e>>0]|0;d[n+(o<<1)>>1]=b[h+o>>0]|0;d[n+(e<<1)>>1]=p;g=g+4|0}while((g|0)<=(i|0));a=a+-1|0;if(l){g=m;do{d[n+(g<<1)>>1]=b[h+g>>0]|0;g=g+1|0}while((g|0)!=(k|0))}if(!a)break;else{n=n+(j<<1)|0;h=h+c|0}}return}function fJ(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>1;h=e+-1|0;if(!e)return;if((k|0)<4){if((k|0)>0){l=g;m=a;n=h}else return;while(1){e=0;do{c=j[m+(e<<1)>>1]|0;d[l+(e<<1)>>1]=c>>>0<32767?c:32767;e=e+1|0}while((e|0)!=(k|0));if(!n)break;else{l=l+(b<<1)|0;m=m+(i<<1)|0;n=n+-1|0}}return}n=k+-4|0;m=(((n|0)>3?n:3)&2147483644)+4|0;if((m|0)<(k|0)){o=g;p=a;q=h}else{l=g;g=a;a=h;while(1){h=0;do{e=j[g+(h<<1)>>1]|0;c=h|1;r=j[g+(c<<1)>>1]|0;d[l+(h<<1)>>1]=e>>>0<32767?e:32767;d[l+(c<<1)>>1]=r>>>0<32767?r:32767;r=h|2;c=j[g+(r<<1)>>1]|0;e=h|3;s=j[g+(e<<1)>>1]|0;d[l+(r<<1)>>1]=c>>>0<32767?c:32767;d[l+(e<<1)>>1]=s>>>0<32767?s:32767;h=h+4|0}while((h|0)<=(n|0));if(!a)break;else{l=l+(b<<1)|0;g=g+(i<<1)|0;a=a+-1|0}}return}while(1){a=0;do{g=j[p+(a<<1)>>1]|0;l=a|1;h=j[p+(l<<1)>>1]|0;d[o+(a<<1)>>1]=g>>>0<32767?g:32767;d[o+(l<<1)>>1]=h>>>0<32767?h:32767;h=a|2;l=j[p+(h<<1)>>1]|0;g=a|3;s=j[p+(g<<1)>>1]|0;d[o+(h<<1)>>1]=l>>>0<32767?l:32767;d[o+(g<<1)>>1]=s>>>0<32767?s:32767;a=a+4|0}while((a|0)<=(n|0));t=m;do{a=j[p+(t<<1)>>1]|0;d[o+(t<<1)>>1]=a>>>0<32767?a:32767;t=t+1|0}while((t|0)!=(k|0));if(!q)break;else{o=o+(b<<1)|0;p=p+(i<<1)|0;q=q+-1|0}}return}function gJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;if(!e)return;h=j+-4|0;c=(((h|0)>3?h:3)&2147483644)+4|0;if((j|0)<4){k=(j|0)>0;l=g;m=a;n=e;while(1){n=n+-1|0;if(k){o=0;do{p=f[m+(o<<2)>>2]|0;d[l+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;o=o+1|0}while((o|0)!=(j|0))}if(!n)break;else{l=l+(b<<1)|0;m=m+(i<<2)|0}}return}m=(c|0)<(j|0);l=g;g=a;a=e;while(1){e=0;do{n=f[g+(e<<2)>>2]|0;k=e|1;o=f[g+(k<<2)>>2]|0;d[l+(e<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;d[l+(k<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=e|2;k=f[g+(o<<2)>>2]|0;n=e|3;p=f[g+(n<<2)>>2]|0;d[l+(o<<1)>>1]=(k+32768|0)>>>0<65536?k:(k|0)>0?32767:32768;d[l+(n<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;e=e+4|0}while((e|0)<=(h|0));a=a+-1|0;if(m){e=c;do{p=f[g+(e<<2)>>2]|0;d[l+(e<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;e=e+1|0}while((e|0)!=(j|0))}if(!a)break;else{l=l+(b<<1)|0;g=g+(i<<2)|0}}return}function hJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>2;b=h>>>1;h=e+-1|0;if(!e)return;if((j|0)<4){if((j|0)>0){k=g;l=a;m=h}else return;while(1){e=0;do{c=LVb(+n[l+(e<<2)>>2])|0;d[k+(e<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;e=e+1|0}while((e|0)!=(j|0));if(!m)break;else{k=k+(b<<1)|0;l=l+(i<<2)|0;m=m+-1|0}}return}m=j+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;k=(l|0)<(j|0);e=g;g=a;a=h;while(1){h=0;do{c=LVb(+n[g+(h<<2)>>2])|0;o=h|1;p=LVb(+n[g+(o<<2)>>2])|0;d[e+(h<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;d[e+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;p=h|2;o=LVb(+n[g+(p<<2)>>2])|0;c=h|3;q=LVb(+n[g+(c<<2)>>2])|0;d[e+(p<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;d[e+(c<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;h=h+4|0}while((h|0)<=(m|0));if(k){h=l;do{q=LVb(+n[g+(h<<2)>>2])|0;d[e+(h<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;h=h+1|0}while((h|0)!=(j|0))}if(!a)break;else{e=e+(b<<1)|0;g=g+(i<<2)|0;a=a+-1|0}}return}function iJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>3;b=h>>>1;h=e+-1|0;if(!e)return;if((j|0)<4){if((j|0)>0){k=g;l=a;m=h}else return;while(1){e=0;do{c=MVb(+p[l+(e<<3)>>3])|0;d[k+(e<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;e=e+1|0}while((e|0)!=(j|0));if(!m)break;else{k=k+(b<<1)|0;l=l+(i<<3)|0;m=m+-1|0}}return}m=j+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;k=(l|0)<(j|0);e=g;g=a;a=h;while(1){h=0;do{c=MVb(+p[g+(h<<3)>>3])|0;n=h|1;o=MVb(+p[g+(n<<3)>>3])|0;d[e+(h<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;d[e+(n<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;o=h|2;n=MVb(+p[g+(o<<3)>>3])|0;c=h|3;q=MVb(+p[g+(c<<3)>>3])|0;d[e+(o<<1)>>1]=(n+32768|0)>>>0<65536?n:(n|0)>0?32767:32768;d[e+(c<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;h=h+4|0}while((h|0)<=(m|0));if(k){h=l;do{q=MVb(+p[g+(h<<3)>>3])|0;d[e+(h<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;h=h+1|0}while((h|0)!=(j|0))}if(!a)break;else{e=e+(b<<1)|0;g=g+(i<<3)|0;a=a+-1|0}}return}function jJ(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;j=f[i>>2]|0;d=f[i+4>>2]|0;i=g>>>2;if(!d)return;g=j+-4|0;if((j|0)<4){c=(j|0)>0;k=e;l=a;m=d;while(1){m=m+-1|0;if(c){n=0;do{f[k+(n<<2)>>2]=h[l+n>>0];n=n+1|0}while((n|0)!=(j|0))}if(!m)break;else{k=k+(i<<2)|0;l=l+b|0}}return}l=j&-4;k=(l|0)<(j|0);m=e;e=a;a=d;while(1){d=0;do{c=d|1;n=h[e+c>>0]|0;f[m+(d<<2)>>2]=h[e+d>>0];f[m+(c<<2)>>2]=n;n=d|2;c=d|3;o=h[e+c>>0]|0;f[m+(n<<2)>>2]=h[e+n>>0];f[m+(c<<2)>>2]=o;d=d+4|0}while((d|0)<=(g|0));a=a+-1|0;if(k){d=l;do{f[m+(d<<2)>>2]=h[e+d>>0];d=d+1|0}while((d|0)!=(j|0))}if(!a)break;else{m=m+(i<<2)|0;e=e+b|0}}return}function kJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=h>>>2;if(!e)return;h=j+-4|0;if((j|0)<4){d=(j|0)>0;k=g;l=a;m=e;while(1){m=m+-1|0;if(d){n=0;do{f[k+(n<<2)>>2]=b[l+n>>0];n=n+1|0}while((n|0)!=(j|0))}if(!m)break;else{k=k+(i<<2)|0;l=l+c|0}}return}l=j&-4;k=(l|0)<(j|0);m=g;g=a;a=e;while(1){e=0;do{d=e|1;n=b[g+d>>0]|0;f[m+(e<<2)>>2]=b[g+e>>0];f[m+(d<<2)>>2]=n;n=e|2;d=e|3;o=b[g+d>>0]|0;f[m+(n<<2)>>2]=b[g+n>>0];f[m+(d<<2)>>2]=o;e=e+4|0}while((e|0)<=(h|0));a=a+-1|0;if(k){e=l;do{f[m+(e<<2)>>2]=b[g+e>>0];e=e+1|0}while((e|0)!=(j|0))}if(!a)break;else{m=m+(i<<2)|0;g=g+c|0}}return}function lJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>2;if(!d)return;g=i+-4|0;if((i|0)<4){c=(i|0)>0;k=e;l=a;m=d;while(1){m=m+-1|0;if(c){n=0;do{f[k+(n<<2)>>2]=j[l+(n<<1)>>1];n=n+1|0}while((n|0)!=(i|0))}if(!m)break;else{k=k+(b<<2)|0;l=l+(h<<1)|0}}return}l=i&-4;k=(l|0)<(i|0);m=e;e=a;a=d;while(1){d=0;do{c=d|1;n=j[e+(c<<1)>>1]|0;f[m+(d<<2)>>2]=j[e+(d<<1)>>1];f[m+(c<<2)>>2]=n;n=d|2;c=d|3;o=j[e+(c<<1)>>1]|0;f[m+(n<<2)>>2]=j[e+(n<<1)>>1];f[m+(c<<2)>>2]=o;d=d+4|0}while((d|0)<=(g|0));a=a+-1|0;if(k){d=l;do{f[m+(d<<2)>>2]=j[e+(d<<1)>>1];d=d+1|0}while((d|0)!=(i|0))}if(!a)break;else{m=m+(b<<2)|0;e=e+(h<<1)|0}}return}function mJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>2;if(!e)return;h=j+-4|0;if((j|0)<4){c=(j|0)>0;k=g;l=a;m=e;while(1){m=m+-1|0;if(c){n=0;do{f[k+(n<<2)>>2]=d[l+(n<<1)>>1];n=n+1|0}while((n|0)!=(j|0))}if(!m)break;else{k=k+(b<<2)|0;l=l+(i<<1)|0}}return}l=j&-4;k=(l|0)<(j|0);m=g;g=a;a=e;while(1){e=0;do{c=e|1;n=d[g+(c<<1)>>1]|0;f[m+(e<<2)>>2]=d[g+(e<<1)>>1];f[m+(c<<2)>>2]=n;n=e|2;c=e|3;o=d[g+(c<<1)>>1]|0;f[m+(n<<2)>>2]=d[g+(n<<1)>>1];f[m+(c<<2)>>2]=o;e=e+4|0}while((e|0)<=(h|0));a=a+-1|0;if(k){e=l;do{f[m+(e<<2)>>2]=d[g+(e<<1)>>1];e=e+1|0}while((e|0)!=(j|0))}if(!a)break;else{m=m+(b<<2)|0;g=g+(i<<1)|0}}return}function nJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;i=f[h+4>>2]|0;d=b>>>2;b=g>>>2;if(!i)return;g=f[h>>2]<<2;h=a;a=e;e=i;while(1){e=e+-1|0;Vac(a|0,h|0,g|0)|0;if(!e)break;else{h=h+(d<<2)|0;a=a+(b<<2)|0}}return}function oJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>2;if(!d)return;g=i+-4|0;if((i|0)<4){c=(i|0)>0;j=e;k=a;l=d;while(1){l=l+-1|0;if(c){m=0;do{o=LVb(+n[k+(m<<2)>>2])|0;f[j+(m<<2)>>2]=o;m=m+1|0}while((m|0)!=(i|0))}if(!l)break;else{j=j+(b<<2)|0;k=k+(h<<2)|0}}return}k=i&-4;j=(k|0)<(i|0);l=e;e=a;a=d;while(1){d=0;do{c=LVb(+n[e+(d<<2)>>2])|0;m=d|1;o=LVb(+n[e+(m<<2)>>2])|0;f[l+(d<<2)>>2]=c;f[l+(m<<2)>>2]=o;o=d|2;m=LVb(+n[e+(o<<2)>>2])|0;c=d|3;p=LVb(+n[e+(c<<2)>>2])|0;f[l+(o<<2)>>2]=m;f[l+(c<<2)>>2]=p;d=d+4|0}while((d|0)<=(g|0));a=a+-1|0;if(j){d=k;do{p=LVb(+n[e+(d<<2)>>2])|0;f[l+(d<<2)>>2]=p;d=d+1|0}while((d|0)!=(i|0))}if(!a)break;else{l=l+(b<<2)|0;e=e+(h<<2)|0}}return}function pJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>3;b=g>>>2;if(!d)return;g=i+-4|0;if((i|0)<4){c=(i|0)>0;j=e;k=a;l=d;while(1){l=l+-1|0;if(c){m=0;do{n=MVb(+p[k+(m<<3)>>3])|0;f[j+(m<<2)>>2]=n;m=m+1|0}while((m|0)!=(i|0))}if(!l)break;else{j=j+(b<<2)|0;k=k+(h<<3)|0}}return}k=i&-4;j=(k|0)<(i|0);l=e;e=a;a=d;while(1){d=0;do{c=MVb(+p[e+(d<<3)>>3])|0;m=d|1;n=MVb(+p[e+(m<<3)>>3])|0;f[l+(d<<2)>>2]=c;f[l+(m<<2)>>2]=n;n=d|2;m=MVb(+p[e+(n<<3)>>3])|0;c=d|3;o=MVb(+p[e+(c<<3)>>3])|0;f[l+(n<<2)>>2]=m;f[l+(c<<2)>>2]=o;d=d+4|0}while((d|0)<=(g|0));a=a+-1|0;if(j){d=k;do{o=MVb(+p[e+(d<<3)>>3])|0;f[l+(d<<2)>>2]=o;d=d+1|0}while((d|0)!=(i|0))}if(!a)break;else{l=l+(b<<2)|0;e=e+(h<<3)|0}}return}function qJ(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0.0;j=f[i>>2]|0;d=f[i+4>>2]|0;i=g>>>2;if(!d)return;g=j+-4|0;if((j|0)<4){c=(j|0)>0;k=e;l=a;m=d;while(1){m=m+-1|0;if(c){o=0;do{n[k+(o<<2)>>2]=+(h[l+o>>0]|0);o=o+1|0}while((o|0)!=(j|0))}if(!m)break;else{k=k+(i<<2)|0;l=l+b|0}}return}l=j&-4;k=(l|0)<(j|0);m=e;e=a;a=d;while(1){d=0;do{c=d|1;p=+(h[e+c>>0]|0);n[m+(d<<2)>>2]=+(h[e+d>>0]|0);n[m+(c<<2)>>2]=p;c=d|2;o=d|3;p=+(h[e+o>>0]|0);n[m+(c<<2)>>2]=+(h[e+c>>0]|0);n[m+(o<<2)>>2]=p;d=d+4|0}while((d|0)<=(g|0));a=a+-1|0;if(k){d=l;do{n[m+(d<<2)>>2]=+(h[e+d>>0]|0);d=d+1|0}while((d|0)!=(j|0))}if(!a)break;else{m=m+(i<<2)|0;e=e+b|0}}return}function rJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0.0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=h>>>2;if(!e)return;h=j+-4|0;if((j|0)<4){d=(j|0)>0;k=g;l=a;m=e;while(1){m=m+-1|0;if(d){o=0;do{n[k+(o<<2)>>2]=+(b[l+o>>0]|0);o=o+1|0}while((o|0)!=(j|0))}if(!m)break;else{k=k+(i<<2)|0;l=l+c|0}}return}l=j&-4;k=(l|0)<(j|0);m=g;g=a;a=e;while(1){e=0;do{d=e|1;p=+(b[g+d>>0]|0);n[m+(e<<2)>>2]=+(b[g+e>>0]|0);n[m+(d<<2)>>2]=p;d=e|2;o=e|3;p=+(b[g+o>>0]|0);n[m+(d<<2)>>2]=+(b[g+d>>0]|0);n[m+(o<<2)>>2]=p;e=e+4|0}while((e|0)<=(h|0));a=a+-1|0;if(k){e=l;do{n[m+(e<<2)>>2]=+(b[g+e>>0]|0);e=e+1|0}while((e|0)!=(j|0))}if(!a)break;else{m=m+(i<<2)|0;g=g+c|0}}return}function sJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>2;g=d+-1|0;if(!d)return;if((i|0)<4){if((i|0)>0){k=e;l=a;m=g}else return;while(1){d=0;do{n[k+(d<<2)>>2]=+(j[l+(d<<1)>>1]|0);d=d+1|0}while((d|0)!=(i|0));if(!m)break;else{k=k+(b<<2)|0;l=l+(h<<1)|0;m=m+-1|0}}return}m=i+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(i|0)){o=e;p=a;q=g}else{k=e;e=a;a=g;while(1){g=0;do{d=g|1;r=+(j[e+(d<<1)>>1]|0);n[k+(g<<2)>>2]=+(j[e+(g<<1)>>1]|0);n[k+(d<<2)>>2]=r;d=g|2;c=g|3;r=+(j[e+(c<<1)>>1]|0);n[k+(d<<2)>>2]=+(j[e+(d<<1)>>1]|0);n[k+(c<<2)>>2]=r;g=g+4|0}while((g|0)<=(m|0));if(!a)break;else{k=k+(b<<2)|0;e=e+(h<<1)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;r=+(j[p+(e<<1)>>1]|0);n[o+(a<<2)>>2]=+(j[p+(a<<1)>>1]|0);n[o+(e<<2)>>2]=r;e=a|2;k=a|3;r=+(j[p+(k<<1)>>1]|0);n[o+(e<<2)>>2]=+(j[p+(e<<1)>>1]|0);n[o+(k<<2)>>2]=r;a=a+4|0}while((a|0)<=(m|0));s=l;do{n[o+(s<<2)>>2]=+(j[p+(s<<1)>>1]|0);s=s+1|0}while((s|0)!=(i|0));if(!q)break;else{o=o+(b<<2)|0;p=p+(h<<1)|0;q=q+-1|0}}return}function tJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>2;h=e+-1|0;if(!e)return;if((j|0)<4){if((j|0)>0){k=g;l=a;m=h}else return;while(1){e=0;do{n[k+(e<<2)>>2]=+(d[l+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(j|0));if(!m)break;else{k=k+(b<<2)|0;l=l+(i<<1)|0;m=m+-1|0}}return}m=j+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(j|0)){o=g;p=a;q=h}else{k=g;g=a;a=h;while(1){h=0;do{e=h|1;r=+(d[g+(e<<1)>>1]|0);n[k+(h<<2)>>2]=+(d[g+(h<<1)>>1]|0);n[k+(e<<2)>>2]=r;e=h|2;c=h|3;r=+(d[g+(c<<1)>>1]|0);n[k+(e<<2)>>2]=+(d[g+(e<<1)>>1]|0);n[k+(c<<2)>>2]=r;h=h+4|0}while((h|0)<=(m|0));if(!a)break;else{k=k+(b<<2)|0;g=g+(i<<1)|0;a=a+-1|0}}return}while(1){a=0;do{g=a|1;r=+(d[p+(g<<1)>>1]|0);n[o+(a<<2)>>2]=+(d[p+(a<<1)>>1]|0);n[o+(g<<2)>>2]=r;g=a|2;k=a|3;r=+(d[p+(k<<1)>>1]|0);n[o+(g<<2)>>2]=+(d[p+(g<<1)>>1]|0);n[o+(k<<2)>>2]=r;a=a+4|0}while((a|0)<=(m|0));s=l;do{n[o+(s<<2)>>2]=+(d[p+(s<<1)>>1]|0);s=s+1|0}while((s|0)!=(j|0));if(!q)break;else{o=o+(b<<2)|0;p=p+(i<<1)|0;q=q+-1|0}}return}function uJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0.0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>2;if(!d)return;g=i+-4|0;c=(((g|0)>3?g:3)&2147483644)+4|0;if((i|0)<4){j=(i|0)>0;k=e;l=a;m=d;while(1){m=m+-1|0;if(j){o=0;do{n[k+(o<<2)>>2]=+(f[l+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(i|0))}if(!m)break;else{k=k+(b<<2)|0;l=l+(h<<2)|0}}return}l=(c|0)<(i|0);k=e;e=a;a=d;while(1){d=0;do{m=d|1;p=+(f[e+(m<<2)>>2]|0);n[k+(d<<2)>>2]=+(f[e+(d<<2)>>2]|0);n[k+(m<<2)>>2]=p;m=d|2;j=d|3;p=+(f[e+(j<<2)>>2]|0);n[k+(m<<2)>>2]=+(f[e+(m<<2)>>2]|0);n[k+(j<<2)>>2]=p;d=d+4|0}while((d|0)<=(g|0));a=a+-1|0;if(l){d=c;do{n[k+(d<<2)>>2]=+(f[e+(d<<2)>>2]|0);d=d+1|0}while((d|0)!=(i|0))}if(!a)break;else{k=k+(b<<2)|0;e=e+(h<<2)|0}}return}function vJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>3;b=g>>>2;g=d+-1|0;if(!d)return;if((i|0)<4){if((i|0)>0){j=e;k=a;l=g}else return;while(1){d=0;do{n[j+(d<<2)>>2]=+p[k+(d<<3)>>3];d=d+1|0}while((d|0)!=(i|0));if(!l)break;else{j=j+(b<<2)|0;k=k+(h<<3)|0;l=l+-1|0}}return}l=i+-4|0;k=(((l|0)>3?l:3)&2147483644)+4|0;if((k|0)<(i|0)){m=e;o=a;q=g}else{j=e;e=a;a=g;while(1){g=0;do{d=g|1;r=+p[e+(d<<3)>>3];n[j+(g<<2)>>2]=+p[e+(g<<3)>>3];n[j+(d<<2)>>2]=r;d=g|2;c=g|3;r=+p[e+(c<<3)>>3];n[j+(d<<2)>>2]=+p[e+(d<<3)>>3];n[j+(c<<2)>>2]=r;g=g+4|0}while((g|0)<=(l|0));if(!a)break;else{j=j+(b<<2)|0;e=e+(h<<3)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;r=+p[o+(e<<3)>>3];n[m+(a<<2)>>2]=+p[o+(a<<3)>>3];n[m+(e<<2)>>2]=r;e=a|2;j=a|3;r=+p[o+(j<<3)>>3];n[m+(e<<2)>>2]=+p[o+(e<<3)>>3];n[m+(j<<2)>>2]=r;a=a+4|0}while((a|0)<=(l|0));s=k;do{n[m+(s<<2)>>2]=+p[o+(s<<3)>>3];s=s+1|0}while((s|0)!=(i|0));if(!q)break;else{m=m+(b<<2)|0;o=o+(h<<3)|0;q=q+-1|0}}return}function wJ(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0.0;j=f[i>>2]|0;d=f[i+4>>2]|0;i=g>>>3;if(!d)return;g=j+-4|0;if((j|0)<4){c=(j|0)>0;k=e;l=a;m=d;while(1){m=m+-1|0;if(c){n=0;do{p[k+(n<<3)>>3]=+(h[l+n>>0]|0);n=n+1|0}while((n|0)!=(j|0))}if(!m)break;else{k=k+(i<<3)|0;l=l+b|0}}return}l=j&-4;k=(l|0)<(j|0);m=e;e=a;a=d;while(1){d=0;do{c=d|1;o=+(h[e+c>>0]|0);p[m+(d<<3)>>3]=+(h[e+d>>0]|0);p[m+(c<<3)>>3]=o;c=d|2;n=d|3;o=+(h[e+n>>0]|0);p[m+(c<<3)>>3]=+(h[e+c>>0]|0);p[m+(n<<3)>>3]=o;d=d+4|0}while((d|0)<=(g|0));a=a+-1|0;if(k){d=l;do{p[m+(d<<3)>>3]=+(h[e+d>>0]|0);d=d+1|0}while((d|0)!=(j|0))}if(!a)break;else{m=m+(i<<3)|0;e=e+b|0}}return}function xJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0.0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=h>>>3;if(!e)return;h=j+-4|0;if((j|0)<4){d=(j|0)>0;k=g;l=a;m=e;while(1){m=m+-1|0;if(d){n=0;do{p[k+(n<<3)>>3]=+(b[l+n>>0]|0);n=n+1|0}while((n|0)!=(j|0))}if(!m)break;else{k=k+(i<<3)|0;l=l+c|0}}return}l=j&-4;k=(l|0)<(j|0);m=g;g=a;a=e;while(1){e=0;do{d=e|1;o=+(b[g+d>>0]|0);p[m+(e<<3)>>3]=+(b[g+e>>0]|0);p[m+(d<<3)>>3]=o;d=e|2;n=e|3;o=+(b[g+n>>0]|0);p[m+(d<<3)>>3]=+(b[g+d>>0]|0);p[m+(n<<3)>>3]=o;e=e+4|0}while((e|0)<=(h|0));a=a+-1|0;if(k){e=l;do{p[m+(e<<3)>>3]=+(b[g+e>>0]|0);e=e+1|0}while((e|0)!=(j|0))}if(!a)break;else{m=m+(i<<3)|0;g=g+c|0}}return}function yJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>1;b=g>>>3;g=d+-1|0;if(!d)return;if((i|0)<4){if((i|0)>0){k=e;l=a;m=g}else return;while(1){d=0;do{p[k+(d<<3)>>3]=+(j[l+(d<<1)>>1]|0);d=d+1|0}while((d|0)!=(i|0));if(!m)break;else{k=k+(b<<3)|0;l=l+(h<<1)|0;m=m+-1|0}}return}m=i+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(i|0)){n=e;o=a;q=g}else{k=e;e=a;a=g;while(1){g=0;do{d=g|1;r=+(j[e+(d<<1)>>1]|0);p[k+(g<<3)>>3]=+(j[e+(g<<1)>>1]|0);p[k+(d<<3)>>3]=r;d=g|2;c=g|3;r=+(j[e+(c<<1)>>1]|0);p[k+(d<<3)>>3]=+(j[e+(d<<1)>>1]|0);p[k+(c<<3)>>3]=r;g=g+4|0}while((g|0)<=(m|0));if(!a)break;else{k=k+(b<<3)|0;e=e+(h<<1)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;r=+(j[o+(e<<1)>>1]|0);p[n+(a<<3)>>3]=+(j[o+(a<<1)>>1]|0);p[n+(e<<3)>>3]=r;e=a|2;k=a|3;r=+(j[o+(k<<1)>>1]|0);p[n+(e<<3)>>3]=+(j[o+(e<<1)>>1]|0);p[n+(k<<3)>>3]=r;a=a+4|0}while((a|0)<=(m|0));s=l;do{p[n+(s<<3)>>3]=+(j[o+(s<<1)>>1]|0);s=s+1|0}while((s|0)!=(i|0));if(!q)break;else{n=n+(b<<3)|0;o=o+(h<<1)|0;q=q+-1|0}}return}function zJ(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0;j=f[i>>2]|0;e=f[i+4>>2]|0;i=b>>>1;b=h>>>3;h=e+-1|0;if(!e)return;if((j|0)<4){if((j|0)>0){k=g;l=a;m=h}else return;while(1){e=0;do{p[k+(e<<3)>>3]=+(d[l+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(j|0));if(!m)break;else{k=k+(b<<3)|0;l=l+(i<<1)|0;m=m+-1|0}}return}m=j+-4|0;l=(((m|0)>3?m:3)&2147483644)+4|0;if((l|0)<(j|0)){n=g;o=a;q=h}else{k=g;g=a;a=h;while(1){h=0;do{e=h|1;r=+(d[g+(e<<1)>>1]|0);p[k+(h<<3)>>3]=+(d[g+(h<<1)>>1]|0);p[k+(e<<3)>>3]=r;e=h|2;c=h|3;r=+(d[g+(c<<1)>>1]|0);p[k+(e<<3)>>3]=+(d[g+(e<<1)>>1]|0);p[k+(c<<3)>>3]=r;h=h+4|0}while((h|0)<=(m|0));if(!a)break;else{k=k+(b<<3)|0;g=g+(i<<1)|0;a=a+-1|0}}return}while(1){a=0;do{g=a|1;r=+(d[o+(g<<1)>>1]|0);p[n+(a<<3)>>3]=+(d[o+(a<<1)>>1]|0);p[n+(g<<3)>>3]=r;g=a|2;k=a|3;r=+(d[o+(k<<1)>>1]|0);p[n+(g<<3)>>3]=+(d[o+(g<<1)>>1]|0);p[n+(k<<3)>>3]=r;a=a+4|0}while((a|0)<=(m|0));s=l;do{p[n+(s<<3)>>3]=+(d[o+(s<<1)>>1]|0);s=s+1|0}while((s|0)!=(j|0));if(!q)break;else{n=n+(b<<3)|0;o=o+(i<<1)|0;q=q+-1|0}}return}function AJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0.0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>3;if(!d)return;g=i+-4|0;c=(((g|0)>3?g:3)&2147483644)+4|0;if((i|0)<4){j=(i|0)>0;k=e;l=a;m=d;while(1){m=m+-1|0;if(j){n=0;do{p[k+(n<<3)>>3]=+(f[l+(n<<2)>>2]|0);n=n+1|0}while((n|0)!=(i|0))}if(!m)break;else{k=k+(b<<3)|0;l=l+(h<<2)|0}}return}l=(c|0)<(i|0);k=e;e=a;a=d;while(1){d=0;do{m=d|1;o=+(f[e+(m<<2)>>2]|0);p[k+(d<<3)>>3]=+(f[e+(d<<2)>>2]|0);p[k+(m<<3)>>3]=o;m=d|2;j=d|3;o=+(f[e+(j<<2)>>2]|0);p[k+(m<<3)>>3]=+(f[e+(m<<2)>>2]|0);p[k+(j<<3)>>3]=o;d=d+4|0}while((d|0)<=(g|0));a=a+-1|0;if(l){d=c;do{p[k+(d<<3)>>3]=+(f[e+(d<<2)>>2]|0);d=d+1|0}while((d|0)!=(i|0))}if(!a)break;else{k=k+(b<<3)|0;e=e+(h<<2)|0}}return}function BJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0.0,s=0;i=f[h>>2]|0;d=f[h+4>>2]|0;h=b>>>2;b=g>>>3;g=d+-1|0;if(!d)return;if((i|0)<4){if((i|0)>0){j=e;k=a;l=g}else return;while(1){d=0;do{p[j+(d<<3)>>3]=+n[k+(d<<2)>>2];d=d+1|0}while((d|0)!=(i|0));if(!l)break;else{j=j+(b<<3)|0;k=k+(h<<2)|0;l=l+-1|0}}return}l=i+-4|0;k=(((l|0)>3?l:3)&2147483644)+4|0;if((k|0)<(i|0)){m=e;o=a;q=g}else{j=e;e=a;a=g;while(1){g=0;do{d=g|1;r=+n[e+(d<<2)>>2];p[j+(g<<3)>>3]=+n[e+(g<<2)>>2];p[j+(d<<3)>>3]=r;d=g|2;c=g|3;r=+n[e+(c<<2)>>2];p[j+(d<<3)>>3]=+n[e+(d<<2)>>2];p[j+(c<<3)>>3]=r;g=g+4|0}while((g|0)<=(l|0));if(!a)break;else{j=j+(b<<3)|0;e=e+(h<<2)|0;a=a+-1|0}}return}while(1){a=0;do{e=a|1;r=+n[o+(e<<2)>>2];p[m+(a<<3)>>3]=+n[o+(a<<2)>>2];p[m+(e<<3)>>3]=r;e=a|2;j=a|3;r=+n[o+(j<<2)>>2];p[m+(e<<3)>>3]=+n[o+(e<<2)>>2];p[m+(j<<3)>>3]=r;a=a+4|0}while((a|0)<=(l|0));s=k;do{p[m+(s<<3)>>3]=+n[o+(s<<2)>>2];s=s+1|0}while((s|0)!=(i|0));if(!q)break;else{m=m+(b<<3)|0;o=o+(h<<2)|0;q=q+-1|0}}return}function CJ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;i=f[h+4>>2]|0;d=b>>>3;b=g>>>3;if(!i)return;g=f[h>>2]<<3;h=a;a=e;e=i;while(1){e=e+-1|0;Vac(a|0,h|0,g|0)|0;if(!e)break;else{h=h+(d<<3)|0;a=a+(b<<3)|0}}return}function DJ(a,c,d,e){a=a|0;c=c|0;d=+d;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+208|0;h=g+200|0;i=g+144|0;j=g;k=g+88|0;l=g+72|0;m=g+64|0;n=g+56|0;o=g+24|0;q=g+16|0;dQ(h,41908);do if((yM(a)|0)==65536){r=f[a+4>>2]|0;f[i>>2]=f[r>>2];s=i+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=i+8|0;f[v>>2]=f[r+8>>2];f[i+12>>2]=f[r+12>>2];f[i+16>>2]=f[r+16>>2];f[i+20>>2]=f[r+20>>2];f[i+24>>2]=f[r+24>>2];f[i+28>>2]=f[r+28>>2];f[i+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[i+36>>2]=w;x=i+40|0;f[x>>2]=v;v=i+48|0;y=i+44|0;f[y>>2]=v;f[v>>2]=0;f[i+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[y>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];z=s;A=x;B=i;break}else{f[s>>2]=0;jL(i,r);z=s;A=x;B=i;break}}else{yL(i,a,-1);z=i+4|0;A=i+40|0;B=i}while(0);a=((f[B>>2]|0)>>>3&511)+1|0;p[j>>3]=d;p[j+8>>3]=e;wL(c,f[z>>2]|0,f[A>>2]|0,(a<<3)+-8|0,-1,0,0);do if((yM(c)|0)==65536){x=f[c+4>>2]|0;f[k>>2]=f[x>>2];s=k+4|0;r=x+4|0;f[s>>2]=f[r>>2];t=k+8|0;f[t>>2]=f[x+8>>2];f[k+12>>2]=f[x+12>>2];f[k+16>>2]=f[x+16>>2];f[k+20>>2]=f[x+20>>2];f[k+24>>2]=f[x+24>>2];f[k+28>>2]=f[x+28>>2];f[k+32>>2]=f[x+32>>2];v=f[x+36>>2]|0;f[k+36>>2]=v;f[k+40>>2]=t;t=k+48|0;y=k+44|0;f[y>>2]=t;f[t>>2]=0;f[k+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[r>>2]|0)<3){r=f[x+44>>2]|0;t=f[y>>2]|0;f[t>>2]=f[r>>2];f[t+4>>2]=f[r+4>>2];break}else{f[s>>2]=0;jL(k,x);break}}else yL(k,c,-1);while(0);c=f[B>>2]&7;x=f[41928+(c<<2)>>2]|0;if((c|0)==7){f[l>>2]=0;f[l+4>>2]=0;c=aD(l,9)|0;s=255890;r=c+9|0;do{b[c>>0]=b[s>>0]|0;c=c+1|0;s=s+1|0}while((c|0)<(r|0));bO(-215,l,178597,177716,4013);bD(l)}if((f[z>>2]|0)<3){s=f[B>>2]|0;B=f[k>>2]|0;c=f[i+12>>2]|0;r=f[i+8>>2]|0;t=cbc(c|0,((c|0)<0)<<31>>31|0,a|0,0)|0;y=cbc(t|0,J|0,r|0,((r|0)<0)<<31>>31|0)|0;if((s&16384&B|0)!=0?(y|0)==(y|0)&(((y|0)<0)<<31>>31|0)==(J|0):0){C=1;D=y}else{C=r;D=Y(c,a)|0}c=f[i+16>>2]|0;r=f[i+48>>2]|0;y=f[k+16>>2]|0;B=f[k+48>>2]|0;f[m>>2]=D;f[m+4>>2]=C;Hh[x&255](c,r,0,0,y,B,m,j)}else{f[l>>2]=i;f[l+4>>2]=k;f[l+8>>2]=0;RN(o,l,n,-1);l=Y(f[o+20>>2]|0,a)|0;a=o+16|0;m=n+4|0;B=q+4|0;y=0;while(1){if(y>>>0>=(f[a>>2]|0)>>>0)break;r=f[n>>2]|0;c=f[m>>2]|0;f[q>>2]=l;f[B>>2]=1;Hh[x&255](r,0,0,0,c,0,q,j);aL(o)|0;y=y+1|0}}y=k+36|0;o=f[y>>2]|0;if(o|0?(j=o+12|0,o=f[j>>2]|0,f[j>>2]=o+-1,(o|0)==1):0)kL(k);f[y>>2]=0;y=k+16|0;o=k+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[o>>2]|0)>0){y=f[k+40>>2]|0;j=0;do{f[y+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[o>>2]|0))}o=f[k+44>>2]|0;if((o|0)!=(k+48|0))UC(o);o=i+36|0;k=f[o>>2]|0;if(k|0?(j=k+12|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)kL(i);f[o>>2]=0;o=i+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[z>>2]|0)>0){o=f[A>>2]|0;A=0;do{f[o+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[z>>2]|0))}z=f[i+44>>2]|0;if((z|0)!=(i+48|0))UC(z);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function EJ(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[j>>2]|0;d=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];if(!d)return;k=e+-4|0;if((e|0)<4){j=(e|0)>0;n=g;o=a;q=d;while(1){q=q+-1|0;if(j){r=0;do{s=LVb(+L(+(m+l*+(h[o+r>>0]|0))))|0;b[n+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{n=n+i|0;o=o+c|0}}return}o=e&-4;n=(o|0)<(e|0);q=g;g=a;a=d;while(1){d=0;do{j=LVb(+L(+(m+l*+(h[g+d>>0]|0))))|0;r=d|1;s=LVb(+L(+(m+l*+(h[g+r>>0]|0))))|0;b[q+d>>0]=j>>>0<256?j:(j|0)>0?255:0;b[q+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=d|2;r=LVb(+L(+(m+l*+(h[g+s>>0]|0))))|0;j=d|3;t=LVb(+L(+(m+l*+(h[g+j>>0]|0))))|0;b[q+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[q+j>>0]=t>>>0<256?t:(t|0)>0?255:0;d=d+4|0}while((d|0)<=(k|0));a=a+-1|0;if(n){d=o;do{t=LVb(+L(+(m+l*+(h[g+d>>0]|0))))|0;b[q+d>>0]=t>>>0<256?t:(t|0)>0?255:0;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{q=q+i|0;g=g+c|0}}return}function FJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];if(!d)return;j=e+-4|0;if((e|0)<4){i=(e|0)>0;m=g;n=a;o=d;while(1){o=o+-1|0;if(i){q=0;do{r=LVb(+L(+(l+k*+(b[n+q>>0]|0))))|0;b[m+q>>0]=r>>>0<256?r:(r|0)>0?255:0;q=q+1|0}while((q|0)!=(e|0))}if(!o)break;else{m=m+h|0;n=n+c|0}}return}n=e&-4;m=(n|0)<(e|0);o=g;g=a;a=d;while(1){d=0;do{i=LVb(+L(+(l+k*+(b[g+d>>0]|0))))|0;q=d|1;r=LVb(+L(+(l+k*+(b[g+q>>0]|0))))|0;b[o+d>>0]=i>>>0<256?i:(i|0)>0?255:0;b[o+q>>0]=r>>>0<256?r:(r|0)>0?255:0;r=d|2;q=LVb(+L(+(l+k*+(b[g+r>>0]|0))))|0;i=d|3;s=LVb(+L(+(l+k*+(b[g+i>>0]|0))))|0;b[o+r>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+i>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+4|0}while((d|0)<=(j|0));a=a+-1|0;if(m){d=n;do{s=LVb(+L(+(l+k*+(b[g+d>>0]|0))))|0;b[o+d>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{o=o+h|0;g=g+c|0}}return}function GJ(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;n=g;o=a;q=d;while(1){q=q+-1|0;if(i){r=0;do{s=LVb(+L(+(m+l*+(j[o+(r<<1)>>1]|0))))|0;b[n+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{n=n+h|0;o=o+(k<<1)|0}}return}o=e&-4;n=(o|0)<(e|0);q=g;g=a;a=d;while(1){d=0;do{i=LVb(+L(+(m+l*+(j[g+(d<<1)>>1]|0))))|0;r=d|1;s=LVb(+L(+(m+l*+(j[g+(r<<1)>>1]|0))))|0;b[q+d>>0]=i>>>0<256?i:(i|0)>0?255:0;b[q+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=d|2;r=LVb(+L(+(m+l*+(j[g+(s<<1)>>1]|0))))|0;i=d|3;t=LVb(+L(+(m+l*+(j[g+(i<<1)>>1]|0))))|0;b[q+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[q+i>>0]=t>>>0<256?t:(t|0)>0?255:0;d=d+4|0}while((d|0)<=(c|0));a=a+-1|0;if(n){d=o;do{t=LVb(+L(+(m+l*+(j[g+(d<<1)>>1]|0))))|0;b[q+d>>0]=t>>>0<256?t:(t|0)>0?255:0;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{q=q+h|0;g=g+(k<<1)|0}}return}function HJ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if(!e)return;c=g+-4|0;if((g|0)<4){j=(g|0)>0;n=h;o=a;q=e;while(1){q=q+-1|0;if(j){r=0;do{s=LVb(+L(+(m+l*+(d[o+(r<<1)>>1]|0))))|0;b[n+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(g|0))}if(!q)break;else{n=n+i|0;o=o+(k<<1)|0}}return}o=g&-4;n=(o|0)<(g|0);q=h;h=a;a=e;while(1){e=0;do{j=LVb(+L(+(m+l*+(d[h+(e<<1)>>1]|0))))|0;r=e|1;s=LVb(+L(+(m+l*+(d[h+(r<<1)>>1]|0))))|0;b[q+e>>0]=j>>>0<256?j:(j|0)>0?255:0;b[q+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=e|2;r=LVb(+L(+(m+l*+(d[h+(s<<1)>>1]|0))))|0;j=e|3;t=LVb(+L(+(m+l*+(d[h+(j<<1)>>1]|0))))|0;b[q+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[q+j>>0]=t>>>0<256?t:(t|0)>0?255:0;e=e+4|0}while((e|0)<=(c|0));a=a+-1|0;if(n){e=o;do{t=LVb(+L(+(m+l*+(d[h+(e<<1)>>1]|0))))|0;b[q+e>>0]=t>>>0<256?t:(t|0)>0?255:0;e=e+1|0}while((e|0)!=(g|0))}if(!a)break;else{q=q+i|0;h=h+(k<<1)|0}}return}function IJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;m=g;n=a;o=d;while(1){o=o+-1|0;if(i){q=0;do{r=LVb(+L(+(l+k*+(f[n+(q<<2)>>2]|0))))|0;b[m+q>>0]=r>>>0<256?r:(r|0)>0?255:0;q=q+1|0}while((q|0)!=(e|0))}if(!o)break;else{m=m+h|0;n=n+(j<<2)|0}}return}n=e&-4;m=(n|0)<(e|0);o=g;g=a;a=d;while(1){d=0;do{i=LVb(+L(+(l+k*+(f[g+(d<<2)>>2]|0))))|0;q=d|1;r=LVb(+L(+(l+k*+(f[g+(q<<2)>>2]|0))))|0;b[o+d>>0]=i>>>0<256?i:(i|0)>0?255:0;b[o+q>>0]=r>>>0<256?r:(r|0)>0?255:0;r=d|2;q=LVb(+L(+(l+k*+(f[g+(r<<2)>>2]|0))))|0;i=d|3;s=LVb(+L(+(l+k*+(f[g+(i<<2)>>2]|0))))|0;b[o+r>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+i>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+4|0}while((d|0)<=(c|0));a=a+-1|0;if(m){d=n;do{s=LVb(+L(+(l+k*+(f[g+(d<<2)>>2]|0))))|0;b[o+d>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{o=o+h|0;g=g+(j<<2)|0}}return}function JJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;m=g;o=a;q=d;while(1){q=q+-1|0;if(i){r=0;do{s=LVb(+L(+(l+k*+n[o+(r<<2)>>2])))|0;b[m+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{m=m+h|0;o=o+(j<<2)|0}}return}o=e&-4;m=(o|0)<(e|0);q=g;g=a;a=d;while(1){d=0;do{i=LVb(+L(+(l+k*+n[g+(d<<2)>>2])))|0;r=d|1;s=LVb(+L(+(l+k*+n[g+(r<<2)>>2])))|0;b[q+d>>0]=i>>>0<256?i:(i|0)>0?255:0;b[q+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=d|2;r=LVb(+L(+(l+k*+n[g+(s<<2)>>2])))|0;i=d|3;t=LVb(+L(+(l+k*+n[g+(i<<2)>>2])))|0;b[q+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[q+i>>0]=t>>>0<256?t:(t|0)>0?255:0;d=d+4|0}while((d|0)<=(c|0));a=a+-1|0;if(m){d=o;do{t=LVb(+L(+(l+k*+n[g+(d<<2)>>2])))|0;b[q+d>>0]=t>>>0<256?t:(t|0)>0?255:0;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{q=q+h|0;g=g+(j<<2)|0}}return}function KJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;i=c>>>3;if(!d)return;k=+p[j>>3];l=+p[j+8>>3];j=e+-4|0;if((e|0)<4){c=(e|0)>0;m=g;n=a;o=d;while(1){o=o+-1|0;if(c){q=0;do{r=MVb(+L(+(l+k*+p[n+(q<<3)>>3])))|0;b[m+q>>0]=r>>>0<256?r:(r|0)>0?255:0;q=q+1|0}while((q|0)!=(e|0))}if(!o)break;else{m=m+h|0;n=n+(i<<3)|0}}return}n=e&-4;m=(n|0)<(e|0);o=g;g=a;a=d;while(1){d=0;do{c=MVb(+L(+(l+k*+p[g+(d<<3)>>3])))|0;q=d|1;r=MVb(+L(+(l+k*+p[g+(q<<3)>>3])))|0;b[o+d>>0]=c>>>0<256?c:(c|0)>0?255:0;b[o+q>>0]=r>>>0<256?r:(r|0)>0?255:0;r=d|2;q=MVb(+L(+(l+k*+p[g+(r<<3)>>3])))|0;c=d|3;s=MVb(+L(+(l+k*+p[g+(c<<3)>>3])))|0;b[o+r>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+c>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+4|0}while((d|0)<=(j|0));a=a+-1|0;if(m){d=n;do{s=MVb(+L(+(l+k*+p[g+(d<<3)>>3])))|0;b[o+d>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{o=o+h|0;g=g+(i<<3)|0}}return}function LJ(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;d=u;u=u+192|0;e=d+184|0;g=d+128|0;h=d+72|0;i=d+48|0;j=d+64|0;k=d+40|0;l=d;m=d+32|0;dQ(e,41960);switch(FM(a,-1)|0){case 5:{n=3;o=4;break}case 3:{n=5;o=4;break}default:{f[g>>2]=0;f[g+4>>2]=0;p=aD(g,23)|0;q=178679;r=p+23|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-210,g,178703,177716,4046);bD(g)}}if((o|0)==4){do if((yM(a)|0)==65536){o=f[a+4>>2]|0;f[g>>2]=f[o>>2];s=g+4|0;t=o+4|0;f[s>>2]=f[t>>2];v=g+8|0;f[v>>2]=f[o+8>>2];f[g+12>>2]=f[o+12>>2];f[g+16>>2]=f[o+16>>2];f[g+20>>2]=f[o+20>>2];f[g+24>>2]=f[o+24>>2];f[g+28>>2]=f[o+28>>2];f[g+32>>2]=f[o+32>>2];w=f[o+36>>2]|0;f[g+36>>2]=w;x=g+40|0;f[x>>2]=v;v=g+48|0;y=g+44|0;f[y>>2]=v;f[v>>2]=0;f[g+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[o+44>>2]|0;v=f[y>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];z=s;A=x;B=g;break}else{f[s>>2]=0;jL(g,o);z=s;A=x;B=g;break}}else{yL(g,a,-1);z=g+4|0;A=g+40|0;B=g}while(0);wL(c,f[z>>2]|0,f[A>>2]|0,f[B>>2]&4088|n,-1,0,0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[h>>2]=f[a>>2];x=h+4|0;s=a+4|0;f[x>>2]=f[s>>2];o=h+8|0;f[o>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[h+32>>2]=f[a+32>>2];t=f[a+36>>2]|0;f[h+36>>2]=t;f[h+40>>2]=o;o=h+48|0;v=h+44|0;f[v>>2]=o;f[o>>2]=0;f[h+52>>2]=0;if(t|0){o=t+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[s>>2]|0)<3){s=f[a+44>>2]|0;o=f[v>>2]|0;f[o>>2]=f[s>>2];f[o+4>>2]=f[s+4>>2];break}else{f[x>>2]=0;jL(h,a);break}}else yL(h,c,-1);while(0);c=f[41980+(n<<2)>>2]|0;a=((f[B>>2]|0)>>>3&511)+1|0;switch(n&7){case 3:case 5:break;default:{f[i>>2]=0;f[i+4>>2]=0;p=aD(i,9)|0;q=255890;r=p+9|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,i,178703,177716,4060);bD(i)}}if((f[z>>2]|0)<3){q=f[B>>2]|0;B=f[h>>2]|0;p=f[g+12>>2]|0;r=f[g+8>>2]|0;n=cbc(p|0,((p|0)<0)<<31>>31|0,a|0,0)|0;x=cbc(n|0,J|0,r|0,((r|0)<0)<<31>>31|0)|0;if((q&16384&B|0)!=0?(x|0)==(x|0)&(((x|0)<0)<<31>>31|0)==(J|0):0){C=1;D=x}else{C=r;D=Y(p,a)|0}p=f[g+16>>2]|0;r=f[g+48>>2]|0;x=f[h+16>>2]|0;B=f[h+48>>2]|0;f[j>>2]=D;f[j+4>>2]=C;Wg[c&127](p,r,x,B,j,0)}else{f[i>>2]=g;f[i+4>>2]=h;f[i+8>>2]=0;RN(l,i,k,-1);i=Y(f[l+20>>2]|0,a)|0;a=l+16|0;j=k+4|0;B=m+4|0;x=0;while(1){if(x>>>0>=(f[a>>2]|0)>>>0)break;r=f[k>>2]|0;p=f[j>>2]|0;f[m>>2]=i;f[B>>2]=1;Wg[c&127](r,1,p,1,m,0);aL(l)|0;x=x+1|0}}x=h+36|0;l=f[x>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)kL(h);f[x>>2]=0;x=h+16|0;l=h+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[l>>2]|0)>0){x=f[h+40>>2]|0;m=0;do{f[x+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}l=f[h+44>>2]|0;if((l|0)!=(h+48|0))UC(l);l=g+36|0;h=f[l>>2]|0;if(h|0?(m=h+12|0,h=f[m>>2]|0,f[m>>2]=h+-1,(h|0)==1):0)kL(g);f[l>>2]=0;l=g+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[z>>2]|0)>0){l=f[A>>2]|0;A=0;do{f[l+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[z>>2]|0))}z=f[g+44>>2]|0;if((z|0)!=(g+48|0))UC(z)}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function MJ(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=b>>>2;b=e>>>1;if((h|0)>0&(i|0)!=0){j=c;k=a;l=i}else return;while(1){i=0;do{a=f[k+(i<<2)>>2]|0;c=a>>>23;e=c&255;m=e+-127|0;n=a&8388607;o=a&2147483647;do if(o>>>0>1199566847)if((n|0)!=0&(m|0)==128)p=(n>>>13|32256)&65535;else p=31744;else if(o>>>0<855638017)p=0;else{if(o>>>0<947904512){q=e+-103|0;if((o|0)==868220928){p=2;break}r=126-e|0;p=(((8388608>>>q&n)>>>r^1|4194304>>>q|0)<=(16777215>>>(e+-102|0)&n|0)&1)+((n|8388608)>>>r)&65535;break}r=n>>>13;q=(c+16&65535)<<10&31744|r&65535;if((4097-(r&1)|0)>>>0>(a&8191)>>>0?!((r|0)==1023&(m|0)==-15):0){p=q;break}p=q+1<<16>>16}while(0);d[j+(i<<1)>>1]=p&32767|a>>>16&32768;i=i+1|0}while((i|0)!=(h|0));l=l+-1|0;if(!l)break;else{j=j+(b<<1)|0;k=k+(g<<2)|0}}return}function NJ(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=f[g>>2]|0;i=f[g+4>>2]|0;g=b>>>1;b=e>>>2;if((h|0)>0&(i|0)!=0){j=c;k=a;l=i}else return;while(1){i=0;do{a=d[k+(i<<1)>>1]|0;c=(a&65535)>>>10&31;e=(c&65535)+-15|0;m=a&1023;n=m&65535;o=((a&65535)>>>15&65535)<<31;do if((e|0)==16)p=o|(m<<16>>16==0?0:n<<13)|2139095040;else{if(!(c<<16>>16)){if(!(m<<16>>16)){p=o;break}else{q=n;r=-1}do{q=q<<1;r=r+1|0}while(!(q&1024|0));s=e-r|0;t=q&1022}else{s=e;t=n}p=(s<<23)+1065353216&2139095040|o|t<<13&8380416}while(0);f[j+(i<<2)>>2]=p;i=i+1|0}while((i|0)!=(h|0));l=l+-1|0;if(!l)break;else{j=j+(b<<2)|0;k=k+(g<<1)|0}}return}function OJ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=+e;g=+g;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,M=0,N=0,O=0;h=u;u=u+224|0;i=h+208|0;j=h+152|0;k=h+88|0;l=h+96|0;m=h;n=h+72|0;o=h+56|0;q=h+64|0;r=h+24|0;s=h+16|0;dQ(i,42012);if(+L(+(e+-1.0))<2.220446049250313e-16)t=+L(+g)<2.220446049250313e-16;else t=0;do if((d|0)<0)if(MM(c)|0){v=BL(c,-1)|0;w=v;x=a;y=f[a>>2]|0;break}else{v=f[a>>2]|0;w=v&4095;x=a;y=v;break}else{v=f[a>>2]|0;w=v&4088|d&7;x=a;y=v}while(0);d=y&7;v=w&7;if((d|0)!=(v|0)|t^1){f[j>>2]=y;y=j+4|0;z=a+4|0;A=f[z>>2]|0;f[y>>2]=A;B=j+8|0;f[B>>2]=f[a+8>>2];C=j+12|0;f[C>>2]=f[a+12>>2];D=j+16|0;f[D>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];E=j+36|0;F=f[a+36>>2]|0;f[E>>2]=F;G=j+40|0;f[G>>2]=B;H=j+48|0;I=j+44|0;f[I>>2]=H;f[H>>2]=0;f[j+52>>2]=0;if(!F)K=A;else{A=F+12|0;f[A>>2]=(f[A>>2]|0)+1;K=f[z>>2]|0}if((K|0)<3){K=f[a+44>>2]|0;A=f[I>>2]|0;f[A>>2]=f[K>>2];f[A+4>>2]=f[K+4>>2]}else{f[y>>2]=0;jL(j,a)}K=f[z>>2]|0;A=f[a+40>>2]|0;if((K|0)<3){F=f[A>>2]|0;f[k>>2]=f[A+4>>2];f[k+4>>2]=F;vM(c,k,w,-1,0,0)}else wL(c,K,A,w,-1,0,0);do if((yM(c)|0)==65536){w=f[c+4>>2]|0;f[l>>2]=f[w>>2];A=l+4|0;K=w+4|0;f[A>>2]=f[K>>2];k=l+8|0;f[k>>2]=f[w+8>>2];f[l+12>>2]=f[w+12>>2];f[l+16>>2]=f[w+16>>2];f[l+20>>2]=f[w+20>>2];f[l+24>>2]=f[w+24>>2];f[l+28>>2]=f[w+28>>2];f[l+32>>2]=f[w+32>>2];F=f[w+36>>2]|0;f[l+36>>2]=F;f[l+40>>2]=k;k=l+48|0;M=l+44|0;f[M>>2]=k;f[k>>2]=0;f[l+52>>2]=0;if(F|0){k=F+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[K>>2]|0)<3){K=f[w+44>>2]|0;k=f[M>>2]|0;f[k>>2]=f[K>>2];f[k+4>>2]=f[K+4>>2];break}else{f[A>>2]=0;jL(l,w);break}}else yL(l,c,-1);while(0);w=f[(t?41652:42032)+(v<<5)+(d<<2)>>2]|0;p[m>>3]=e;p[m+8>>3]=g;d=((f[x>>2]|0)>>>3&511)+1|0;if(!w){f[n>>2]=0;f[n+4>>2]=0;x=aD(n,9)|0;v=255890;t=x+9|0;do{b[x>>0]=b[v>>0]|0;x=x+1|0;v=v+1|0}while((x|0)<(t|0));bO(-215,n,178761,177716,4175);bD(n)}if((f[z>>2]|0)<3){z=f[j>>2]|0;v=f[l>>2]|0;x=f[C>>2]|0;C=f[B>>2]|0;B=cbc(x|0,((x|0)<0)<<31>>31|0,d|0,0)|0;t=cbc(B|0,J|0,C|0,((C|0)<0)<<31>>31|0)|0;if((z&16384&v|0)!=0?(t|0)==(t|0)&(((t|0)<0)<<31>>31|0)==(J|0):0){N=1;O=t}else{N=C;O=Y(x,d)|0}x=f[D>>2]|0;C=f[H>>2]|0;t=f[l+16>>2]|0;v=f[l+48>>2]|0;f[o>>2]=O;f[o+4>>2]=N;Hh[w&255](x,C,0,0,t,v,o,m)}else{f[n>>2]=j;f[n+4>>2]=l;f[n+8>>2]=0;RN(r,n,q,-1);n=Y(f[r+20>>2]|0,d)|0;d=r+16|0;o=q+4|0;v=s+4|0;t=0;while(1){if(t>>>0>=(f[d>>2]|0)>>>0)break;C=f[q>>2]|0;x=f[o>>2]|0;f[s>>2]=n;f[v>>2]=1;Hh[w&255](C,1,0,0,x,1,s,m);aL(r)|0;t=t+1|0}}t=l+36|0;r=f[t>>2]|0;if(r|0?(m=r+12|0,r=f[m>>2]|0,f[m>>2]=r+-1,(r|0)==1):0)kL(l);f[t>>2]=0;t=l+16|0;r=l+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[r>>2]|0)>0){t=f[l+40>>2]|0;m=0;do{f[t+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[r>>2]|0))}r=f[l+44>>2]|0;if((r|0)!=(l+48|0))UC(r);r=f[E>>2]|0;if(r|0?(l=r+12|0,r=f[l>>2]|0,f[l>>2]=r+-1,(r|0)==1):0)kL(j);f[E>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[y>>2]|0)>0){D=f[G>>2]|0;G=0;do{f[D+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[y>>2]|0))}y=f[I>>2]|0;if((y|0)!=(H|0))UC(y)}else SP(a,c);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function PJ(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[j>>2]|0;d=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];if(!d)return;k=e+-4|0;if((e|0)<4){j=(e|0)>0;n=g;o=a;q=d;while(1){q=q+-1|0;if(j){r=0;do{s=LVb(m+l*+(h[o+r>>0]|0))|0;b[n+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{n=n+i|0;o=o+c|0}}return}o=e&-4;n=(o|0)<(e|0);q=g;g=a;a=d;while(1){d=0;do{j=LVb(m+l*+(h[g+d>>0]|0))|0;r=d|1;s=LVb(m+l*+(h[g+r>>0]|0))|0;b[q+d>>0]=j>>>0<256?j:(j|0)>0?255:0;b[q+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=d|2;r=LVb(m+l*+(h[g+s>>0]|0))|0;j=d|3;t=LVb(m+l*+(h[g+j>>0]|0))|0;b[q+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[q+j>>0]=t>>>0<256?t:(t|0)>0?255:0;d=d+4|0}while((d|0)<=(k|0));a=a+-1|0;if(n){d=o;do{t=LVb(m+l*+(h[g+d>>0]|0))|0;b[q+d>>0]=t>>>0<256?t:(t|0)>0?255:0;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{q=q+i|0;g=g+c|0}}return}function QJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];if(!d)return;j=e+-4|0;if((e|0)<4){i=(e|0)>0;m=g;n=a;o=d;while(1){o=o+-1|0;if(i){q=0;do{r=LVb(l+k*+(b[n+q>>0]|0))|0;b[m+q>>0]=r>>>0<256?r:(r|0)>0?255:0;q=q+1|0}while((q|0)!=(e|0))}if(!o)break;else{m=m+h|0;n=n+c|0}}return}n=e&-4;m=(n|0)<(e|0);o=g;g=a;a=d;while(1){d=0;do{i=LVb(l+k*+(b[g+d>>0]|0))|0;q=d|1;r=LVb(l+k*+(b[g+q>>0]|0))|0;b[o+d>>0]=i>>>0<256?i:(i|0)>0?255:0;b[o+q>>0]=r>>>0<256?r:(r|0)>0?255:0;r=d|2;q=LVb(l+k*+(b[g+r>>0]|0))|0;i=d|3;s=LVb(l+k*+(b[g+i>>0]|0))|0;b[o+r>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+i>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+4|0}while((d|0)<=(j|0));a=a+-1|0;if(m){d=n;do{s=LVb(l+k*+(b[g+d>>0]|0))|0;b[o+d>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{o=o+h|0;g=g+c|0}}return}function RJ(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;n=g;o=a;q=d;while(1){q=q+-1|0;if(i){r=0;do{s=LVb(m+l*+(j[o+(r<<1)>>1]|0))|0;b[n+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{n=n+h|0;o=o+(k<<1)|0}}return}o=e&-4;n=(o|0)<(e|0);q=g;g=a;a=d;while(1){d=0;do{i=LVb(m+l*+(j[g+(d<<1)>>1]|0))|0;r=d|1;s=LVb(m+l*+(j[g+(r<<1)>>1]|0))|0;b[q+d>>0]=i>>>0<256?i:(i|0)>0?255:0;b[q+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=d|2;r=LVb(m+l*+(j[g+(s<<1)>>1]|0))|0;i=d|3;t=LVb(m+l*+(j[g+(i<<1)>>1]|0))|0;b[q+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[q+i>>0]=t>>>0<256?t:(t|0)>0?255:0;d=d+4|0}while((d|0)<=(c|0));a=a+-1|0;if(n){d=o;do{t=LVb(m+l*+(j[g+(d<<1)>>1]|0))|0;b[q+d>>0]=t>>>0<256?t:(t|0)>0?255:0;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{q=q+h|0;g=g+(k<<1)|0}}return}function SJ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if(!e)return;c=g+-4|0;if((g|0)<4){j=(g|0)>0;n=h;o=a;q=e;while(1){q=q+-1|0;if(j){r=0;do{s=LVb(m+l*+(d[o+(r<<1)>>1]|0))|0;b[n+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(g|0))}if(!q)break;else{n=n+i|0;o=o+(k<<1)|0}}return}o=g&-4;n=(o|0)<(g|0);q=h;h=a;a=e;while(1){e=0;do{j=LVb(m+l*+(d[h+(e<<1)>>1]|0))|0;r=e|1;s=LVb(m+l*+(d[h+(r<<1)>>1]|0))|0;b[q+e>>0]=j>>>0<256?j:(j|0)>0?255:0;b[q+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=e|2;r=LVb(m+l*+(d[h+(s<<1)>>1]|0))|0;j=e|3;t=LVb(m+l*+(d[h+(j<<1)>>1]|0))|0;b[q+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[q+j>>0]=t>>>0<256?t:(t|0)>0?255:0;e=e+4|0}while((e|0)<=(c|0));a=a+-1|0;if(n){e=o;do{t=LVb(m+l*+(d[h+(e<<1)>>1]|0))|0;b[q+e>>0]=t>>>0<256?t:(t|0)>0?255:0;e=e+1|0}while((e|0)!=(g|0))}if(!a)break;else{q=q+i|0;h=h+(k<<1)|0}}return}function TJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;m=g;n=a;o=d;while(1){o=o+-1|0;if(i){q=0;do{r=LVb(l+k*+(f[n+(q<<2)>>2]|0))|0;b[m+q>>0]=r>>>0<256?r:(r|0)>0?255:0;q=q+1|0}while((q|0)!=(e|0))}if(!o)break;else{m=m+h|0;n=n+(j<<2)|0}}return}n=e&-4;m=(n|0)<(e|0);o=g;g=a;a=d;while(1){d=0;do{i=LVb(l+k*+(f[g+(d<<2)>>2]|0))|0;q=d|1;r=LVb(l+k*+(f[g+(q<<2)>>2]|0))|0;b[o+d>>0]=i>>>0<256?i:(i|0)>0?255:0;b[o+q>>0]=r>>>0<256?r:(r|0)>0?255:0;r=d|2;q=LVb(l+k*+(f[g+(r<<2)>>2]|0))|0;i=d|3;s=LVb(l+k*+(f[g+(i<<2)>>2]|0))|0;b[o+r>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+i>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+4|0}while((d|0)<=(c|0));a=a+-1|0;if(m){d=n;do{s=LVb(l+k*+(f[g+(d<<2)>>2]|0))|0;b[o+d>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{o=o+h|0;g=g+(j<<2)|0}}return}function UJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;m=g;o=a;q=d;while(1){q=q+-1|0;if(i){r=0;do{s=LVb(l+k*+n[o+(r<<2)>>2])|0;b[m+r>>0]=s>>>0<256?s:(s|0)>0?255:0;r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{m=m+h|0;o=o+(j<<2)|0}}return}o=e&-4;m=(o|0)<(e|0);q=g;g=a;a=d;while(1){d=0;do{i=LVb(l+k*+n[g+(d<<2)>>2])|0;r=d|1;s=LVb(l+k*+n[g+(r<<2)>>2])|0;b[q+d>>0]=i>>>0<256?i:(i|0)>0?255:0;b[q+r>>0]=s>>>0<256?s:(s|0)>0?255:0;s=d|2;r=LVb(l+k*+n[g+(s<<2)>>2])|0;i=d|3;t=LVb(l+k*+n[g+(i<<2)>>2])|0;b[q+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[q+i>>0]=t>>>0<256?t:(t|0)>0?255:0;d=d+4|0}while((d|0)<=(c|0));a=a+-1|0;if(m){d=o;do{t=LVb(l+k*+n[g+(d<<2)>>2])|0;b[q+d>>0]=t>>>0<256?t:(t|0)>0?255:0;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{q=q+h|0;g=g+(j<<2)|0}}return}function VJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;i=c>>>3;if(!d)return;k=+p[j>>3];l=+p[j+8>>3];j=e+-4|0;if((e|0)<4){c=(e|0)>0;m=g;n=a;o=d;while(1){o=o+-1|0;if(c){q=0;do{r=MVb(l+k*+p[n+(q<<3)>>3])|0;b[m+q>>0]=r>>>0<256?r:(r|0)>0?255:0;q=q+1|0}while((q|0)!=(e|0))}if(!o)break;else{m=m+h|0;n=n+(i<<3)|0}}return}n=e&-4;m=(n|0)<(e|0);o=g;g=a;a=d;while(1){d=0;do{c=MVb(l+k*+p[g+(d<<3)>>3])|0;q=d|1;r=MVb(l+k*+p[g+(q<<3)>>3])|0;b[o+d>>0]=c>>>0<256?c:(c|0)>0?255:0;b[o+q>>0]=r>>>0<256?r:(r|0)>0?255:0;r=d|2;q=MVb(l+k*+p[g+(r<<3)>>3])|0;c=d|3;s=MVb(l+k*+p[g+(c<<3)>>3])|0;b[o+r>>0]=q>>>0<256?q:(q|0)>0?255:0;b[o+c>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+4|0}while((d|0)<=(j|0));a=a+-1|0;if(m){d=n;do{s=MVb(l+k*+p[g+(d<<3)>>3])|0;b[o+d>>0]=s>>>0<256?s:(s|0)>0?255:0;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{o=o+h|0;g=g+(i<<3)|0}}return}function WJ(a,c,d,e,g,i,j,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[j>>2]|0;d=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];if(!d)return;k=e+-4|0;if((e|0)<4){j=(e|0)>0;n=g;o=a;q=d;while(1){q=q+-1|0;if(j){r=0;do{s=LVb(m+l*+(h[o+r>>0]|0))|0;b[n+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{n=n+i|0;o=o+c|0}}return}o=e&-4;n=(o|0)<(e|0);q=g;g=a;a=d;while(1){d=0;do{j=LVb(m+l*+(h[g+d>>0]|0))|0;r=d|1;s=LVb(m+l*+(h[g+r>>0]|0))|0;b[q+d>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;b[q+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=d|2;r=LVb(m+l*+(h[g+s>>0]|0))|0;j=d|3;t=LVb(m+l*+(h[g+j>>0]|0))|0;b[q+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;b[q+j>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;d=d+4|0}while((d|0)<=(k|0));a=a+-1|0;if(n){d=o;do{t=LVb(m+l*+(h[g+d>>0]|0))|0;b[q+d>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{q=q+i|0;g=g+c|0}}return}function XJ(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];if(!d)return;j=e+-4|0;if((e|0)<4){i=(e|0)>0;m=g;n=a;o=d;while(1){o=o+-1|0;if(i){q=0;do{r=LVb(l+k*+(b[n+q>>0]|0))|0;b[m+q>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;q=q+1|0}while((q|0)!=(e|0))}if(!o)break;else{m=m+h|0;n=n+c|0}}return}n=e&-4;m=(n|0)<(e|0);o=g;g=a;a=d;while(1){d=0;do{i=LVb(l+k*+(b[g+d>>0]|0))|0;q=d|1;r=LVb(l+k*+(b[g+q>>0]|0))|0;b[o+d>>0]=(i+128|0)>>>0<256?i:(i|0)>0?127:128;b[o+q>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;r=d|2;q=LVb(l+k*+(b[g+r>>0]|0))|0;i=d|3;s=LVb(l+k*+(b[g+i>>0]|0))|0;b[o+r>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[o+i>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;d=d+4|0}while((d|0)<=(j|0));a=a+-1|0;if(m){d=n;do{s=LVb(l+k*+(b[g+d>>0]|0))|0;b[o+d>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{o=o+h|0;g=g+c|0}}return}function YJ(a,c,d,e,g,h,i,k){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;d=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;n=g;o=a;q=d;while(1){q=q+-1|0;if(i){r=0;do{s=LVb(m+l*+(j[o+(r<<1)>>1]|0))|0;b[n+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{n=n+h|0;o=o+(k<<1)|0}}return}o=e&-4;n=(o|0)<(e|0);q=g;g=a;a=d;while(1){d=0;do{i=LVb(m+l*+(j[g+(d<<1)>>1]|0))|0;r=d|1;s=LVb(m+l*+(j[g+(r<<1)>>1]|0))|0;b[q+d>>0]=(i+128|0)>>>0<256?i:(i|0)>0?127:128;b[q+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=d|2;r=LVb(m+l*+(j[g+(s<<1)>>1]|0))|0;i=d|3;t=LVb(m+l*+(j[g+(i<<1)>>1]|0))|0;b[q+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;b[q+i>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;d=d+4|0}while((d|0)<=(c|0));a=a+-1|0;if(n){d=o;do{t=LVb(m+l*+(j[g+(d<<1)>>1]|0))|0;b[q+d>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{q=q+h|0;g=g+(k<<1)|0}}return}function ZJ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=c>>>1;if(!e)return;c=g+-4|0;if((g|0)<4){j=(g|0)>0;n=h;o=a;q=e;while(1){q=q+-1|0;if(j){r=0;do{s=LVb(m+l*+(d[o+(r<<1)>>1]|0))|0;b[n+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+1|0}while((r|0)!=(g|0))}if(!q)break;else{n=n+i|0;o=o+(k<<1)|0}}return}o=g&-4;n=(o|0)<(g|0);q=h;h=a;a=e;while(1){e=0;do{j=LVb(m+l*+(d[h+(e<<1)>>1]|0))|0;r=e|1;s=LVb(m+l*+(d[h+(r<<1)>>1]|0))|0;b[q+e>>0]=(j+128|0)>>>0<256?j:(j|0)>0?127:128;b[q+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=e|2;r=LVb(m+l*+(d[h+(s<<1)>>1]|0))|0;j=e|3;t=LVb(m+l*+(d[h+(j<<1)>>1]|0))|0;b[q+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;b[q+j>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;e=e+4|0}while((e|0)<=(c|0));a=a+-1|0;if(n){e=o;do{t=LVb(m+l*+(d[h+(e<<1)>>1]|0))|0;b[q+e>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;e=e+1|0}while((e|0)!=(g|0))}if(!a)break;else{q=q+i|0;h=h+(k<<1)|0}}return}function _J(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;m=g;n=a;o=d;while(1){o=o+-1|0;if(i){q=0;do{r=LVb(l+k*+(f[n+(q<<2)>>2]|0))|0;b[m+q>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;q=q+1|0}while((q|0)!=(e|0))}if(!o)break;else{m=m+h|0;n=n+(j<<2)|0}}return}n=e&-4;m=(n|0)<(e|0);o=g;g=a;a=d;while(1){d=0;do{i=LVb(l+k*+(f[g+(d<<2)>>2]|0))|0;q=d|1;r=LVb(l+k*+(f[g+(q<<2)>>2]|0))|0;b[o+d>>0]=(i+128|0)>>>0<256?i:(i|0)>0?127:128;b[o+q>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;r=d|2;q=LVb(l+k*+(f[g+(r<<2)>>2]|0))|0;i=d|3;s=LVb(l+k*+(f[g+(i<<2)>>2]|0))|0;b[o+r>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[o+i>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;d=d+4|0}while((d|0)<=(c|0));a=a+-1|0;if(m){d=n;do{s=LVb(l+k*+(f[g+(d<<2)>>2]|0))|0;b[o+d>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{o=o+h|0;g=g+(j<<2)|0}}return}function $J(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=c>>>2;if(!d)return;c=e+-4|0;if((e|0)<4){i=(e|0)>0;m=g;o=a;q=d;while(1){q=q+-1|0;if(i){r=0;do{s=LVb(l+k*+n[o+(r<<2)>>2])|0;b[m+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{m=m+h|0;o=o+(j<<2)|0}}return}o=e&-4;m=(o|0)<(e|0);q=g;g=a;a=d;while(1){d=0;do{i=LVb(l+k*+n[g+(d<<2)>>2])|0;r=d|1;s=LVb(l+k*+n[g+(r<<2)>>2])|0;b[q+d>>0]=(i+128|0)>>>0<256?i:(i|0)>0?127:128;b[q+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;s=d|2;r=LVb(l+k*+n[g+(s<<2)>>2])|0;i=d|3;t=LVb(l+k*+n[g+(i<<2)>>2])|0;b[q+s>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;b[q+i>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;d=d+4|0}while((d|0)<=(c|0));a=a+-1|0;if(m){d=o;do{t=LVb(l+k*+n[g+(d<<2)>>2])|0;b[q+d>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{q=q+h|0;g=g+(j<<2)|0}}return}function aK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;i=c>>>3;if(!d)return;k=+p[j>>3];l=+p[j+8>>3];j=e+-4|0;if((e|0)<4){c=(e|0)>0;m=g;n=a;o=d;while(1){o=o+-1|0;if(c){q=0;do{r=MVb(l+k*+p[n+(q<<3)>>3])|0;b[m+q>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;q=q+1|0}while((q|0)!=(e|0))}if(!o)break;else{m=m+h|0;n=n+(i<<3)|0}}return}n=e&-4;m=(n|0)<(e|0);o=g;g=a;a=d;while(1){d=0;do{c=MVb(l+k*+p[g+(d<<3)>>3])|0;q=d|1;r=MVb(l+k*+p[g+(q<<3)>>3])|0;b[o+d>>0]=(c+128|0)>>>0<256?c:(c|0)>0?127:128;b[o+q>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;r=d|2;q=MVb(l+k*+p[g+(r<<3)>>3])|0;c=d|3;s=MVb(l+k*+p[g+(c<<3)>>3])|0;b[o+r>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[o+c>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;d=d+4|0}while((d|0)<=(j|0));a=a+-1|0;if(m){d=n;do{s=MVb(l+k*+p[g+(d<<3)>>3])|0;b[o+d>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{o=o+h|0;g=g+(i<<3)|0}}return}function bK(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[j>>2]|0;c=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if(!c)return;i=e+-4|0;if((e|0)<4){j=(e|0)>0;n=g;o=a;q=c;while(1){q=q+-1|0;if(j){r=0;do{s=LVb(m+l*+(h[o+r>>0]|0))|0;d[n+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{n=n+(k<<1)|0;o=o+b|0}}return}o=e&-4;n=(o|0)<(e|0);q=g;g=a;a=c;while(1){c=0;do{j=LVb(m+l*+(h[g+c>>0]|0))|0;r=c|1;s=LVb(m+l*+(h[g+r>>0]|0))|0;d[q+(c<<1)>>1]=j>>>0<65536?j:(j|0)>0?65535:0;d[q+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=c|2;r=LVb(m+l*+(h[g+s>>0]|0))|0;j=c|3;t=LVb(m+l*+(h[g+j>>0]|0))|0;d[q+(s<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d[q+(j<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;c=c+4|0}while((c|0)<=(i|0));a=a+-1|0;if(n){c=o;do{t=LVb(m+l*+(h[g+c>>0]|0))|0;d[q+(c<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;c=c+1|0}while((c|0)!=(e|0))}if(!a)break;else{q=q+(k<<1)|0;g=g+b|0}}return}function cK(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if(!e)return;i=g+-4|0;if((g|0)<4){j=(g|0)>0;n=h;o=a;q=e;while(1){q=q+-1|0;if(j){r=0;do{s=LVb(m+l*+(b[o+r>>0]|0))|0;d[n+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;r=r+1|0}while((r|0)!=(g|0))}if(!q)break;else{n=n+(k<<1)|0;o=o+c|0}}return}o=g&-4;n=(o|0)<(g|0);q=h;h=a;a=e;while(1){e=0;do{j=LVb(m+l*+(b[h+e>>0]|0))|0;r=e|1;s=LVb(m+l*+(b[h+r>>0]|0))|0;d[q+(e<<1)>>1]=j>>>0<65536?j:(j|0)>0?65535:0;d[q+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=e|2;r=LVb(m+l*+(b[h+s>>0]|0))|0;j=e|3;t=LVb(m+l*+(b[h+j>>0]|0))|0;d[q+(s<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d[q+(j<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;e=e+4|0}while((e|0)<=(i|0));a=a+-1|0;if(n){e=o;do{t=LVb(m+l*+(b[h+e>>0]|0))|0;d[q+(e<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;e=e+1|0}while((e|0)!=(g|0))}if(!a)break;else{q=q+(k<<1)|0;h=h+c|0}}return}function dK(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;c=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=b>>>1;b=h>>>1;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){n=g;o=a;q=h}else return;while(1){c=0;do{i=LVb(m+l*+(j[o+(c<<1)>>1]|0))|0;d[n+(c<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;c=c+1|0}while((c|0)!=(e|0));if(!q)break;else{n=n+(b<<1)|0;o=o+(k<<1)|0;q=q+-1|0}}return}q=e+-4|0;o=(((q|0)>3?q:3)&2147483644)+4|0;n=(o|0)<(e|0);c=g;g=a;a=h;while(1){h=0;do{i=LVb(m+l*+(j[g+(h<<1)>>1]|0))|0;r=h|1;s=LVb(m+l*+(j[g+(r<<1)>>1]|0))|0;d[c+(h<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;d[c+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=h|2;r=LVb(m+l*+(j[g+(s<<1)>>1]|0))|0;i=h|3;t=LVb(m+l*+(j[g+(i<<1)>>1]|0))|0;d[c+(s<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d[c+(i<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;h=h+4|0}while((h|0)<=(q|0));if(n){h=o;do{t=LVb(m+l*+(j[g+(h<<1)>>1]|0))|0;d[c+(h<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;h=h+1|0}while((h|0)!=(e|0))}if(!a)break;else{c=c+(b<<1)|0;g=g+(k<<1)|0;a=a+-1|0}}return}function eK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>1;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){m=g;n=a;o=h}else return;while(1){c=0;do{i=LVb(l+k*+(d[n+(c<<1)>>1]|0))|0;d[m+(c<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;c=c+1|0}while((c|0)!=(e|0));if(!o)break;else{m=m+(b<<1)|0;n=n+(j<<1)|0;o=o+-1|0}}return}o=e+-4|0;n=(((o|0)>3?o:3)&2147483644)+4|0;m=(n|0)<(e|0);c=g;g=a;a=h;while(1){h=0;do{i=LVb(l+k*+(d[g+(h<<1)>>1]|0))|0;q=h|1;r=LVb(l+k*+(d[g+(q<<1)>>1]|0))|0;d[c+(h<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;d[c+(q<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;r=h|2;q=LVb(l+k*+(d[g+(r<<1)>>1]|0))|0;i=h|3;s=LVb(l+k*+(d[g+(i<<1)>>1]|0))|0;d[c+(r<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d[c+(i<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;h=h+4|0}while((h|0)<=(o|0));if(m){h=n;do{s=LVb(l+k*+(d[g+(h<<1)>>1]|0))|0;d[c+(h<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;h=h+1|0}while((h|0)!=(e|0))}if(!a)break;else{c=c+(b<<1)|0;g=g+(j<<1)|0;a=a+-1|0}}return}function fK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if(!c)return;h=e+-4|0;i=(((h|0)>3?h:3)&2147483644)+4|0;if((e|0)<4){m=(e|0)>0;n=g;o=a;q=c;while(1){q=q+-1|0;if(m){r=0;do{s=LVb(l+k*+(f[o+(r<<2)>>2]|0))|0;d[n+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{n=n+(b<<1)|0;o=o+(j<<2)|0}}return}o=(i|0)<(e|0);n=g;g=a;a=c;while(1){c=0;do{q=LVb(l+k*+(f[g+(c<<2)>>2]|0))|0;m=c|1;r=LVb(l+k*+(f[g+(m<<2)>>2]|0))|0;d[n+(c<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d[n+(m<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;r=c|2;m=LVb(l+k*+(f[g+(r<<2)>>2]|0))|0;q=c|3;s=LVb(l+k*+(f[g+(q<<2)>>2]|0))|0;d[n+(r<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;d[n+(q<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;c=c+4|0}while((c|0)<=(h|0));a=a+-1|0;if(o){c=i;do{s=LVb(l+k*+(f[g+(c<<2)>>2]|0))|0;d[n+(c<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;c=c+1|0}while((c|0)!=(e|0))}if(!a)break;else{n=n+(b<<1)|0;g=g+(j<<2)|0}}return}function gK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){m=g;o=a;q=h}else return;while(1){c=0;do{i=LVb(l+k*+n[o+(c<<2)>>2])|0;d[m+(c<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;c=c+1|0}while((c|0)!=(e|0));if(!q)break;else{m=m+(b<<1)|0;o=o+(j<<2)|0;q=q+-1|0}}return}q=e+-4|0;o=(((q|0)>3?q:3)&2147483644)+4|0;m=(o|0)<(e|0);c=g;g=a;a=h;while(1){h=0;do{i=LVb(l+k*+n[g+(h<<2)>>2])|0;r=h|1;s=LVb(l+k*+n[g+(r<<2)>>2])|0;d[c+(h<<1)>>1]=i>>>0<65536?i:(i|0)>0?65535:0;d[c+(r<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=h|2;r=LVb(l+k*+n[g+(s<<2)>>2])|0;i=h|3;t=LVb(l+k*+n[g+(i<<2)>>2])|0;d[c+(s<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;d[c+(i<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;h=h+4|0}while((h|0)<=(q|0));if(m){h=o;do{t=LVb(l+k*+n[g+(h<<2)>>2])|0;d[c+(h<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;h=h+1|0}while((h|0)!=(e|0))}if(!a)break;else{c=c+(b<<1)|0;g=g+(j<<2)|0;a=a+-1|0}}return}function hK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;c=f[i+4>>2]|0;i=b>>>3;b=h>>>1;h=c+-1|0;if(!c)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)<4){if((e|0)>0){m=g;n=a;o=h}else return;while(1){j=0;do{c=MVb(l+k*+p[n+(j<<3)>>3])|0;d[m+(j<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;j=j+1|0}while((j|0)!=(e|0));if(!o)break;else{m=m+(b<<1)|0;n=n+(i<<3)|0;o=o+-1|0}}return}o=e+-4|0;n=(((o|0)>3?o:3)&2147483644)+4|0;m=(n|0)<(e|0);j=g;g=a;a=h;while(1){h=0;do{c=MVb(l+k*+p[g+(h<<3)>>3])|0;q=h|1;r=MVb(l+k*+p[g+(q<<3)>>3])|0;d[j+(h<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;d[j+(q<<1)>>1]=r>>>0<65536?r:(r|0)>0?65535:0;r=h|2;q=MVb(l+k*+p[g+(r<<3)>>3])|0;c=h|3;s=MVb(l+k*+p[g+(c<<3)>>3])|0;d[j+(r<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d[j+(c<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;h=h+4|0}while((h|0)<=(o|0));if(m){h=n;do{s=MVb(l+k*+p[g+(h<<3)>>3])|0;d[j+(h<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;h=h+1|0}while((h|0)!=(e|0))}if(!a)break;else{j=j+(b<<1)|0;g=g+(i<<3)|0;a=a+-1|0}}return}function iK(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[j>>2]|0;c=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if(!c)return;i=e+-4|0;if((e|0)<4){j=(e|0)>0;n=g;o=a;q=c;while(1){q=q+-1|0;if(j){r=0;do{s=LVb(m+l*+(h[o+r>>0]|0))|0;d[n+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{n=n+(k<<1)|0;o=o+b|0}}return}o=e&-4;n=(o|0)<(e|0);q=g;g=a;a=c;while(1){c=0;do{j=LVb(m+l*+(h[g+c>>0]|0))|0;r=c|1;s=LVb(m+l*+(h[g+r>>0]|0))|0;d[q+(c<<1)>>1]=(j+32768|0)>>>0<65536?j:(j|0)>0?32767:32768;d[q+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=c|2;r=LVb(m+l*+(h[g+s>>0]|0))|0;j=c|3;t=LVb(m+l*+(h[g+j>>0]|0))|0;d[q+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[q+(j<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;c=c+4|0}while((c|0)<=(i|0));a=a+-1|0;if(n){c=o;do{t=LVb(m+l*+(h[g+c>>0]|0))|0;d[q+(c<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;c=c+1|0}while((c|0)!=(e|0))}if(!a)break;else{q=q+(k<<1)|0;g=g+b|0}}return}function jK(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;g=f[j>>2]|0;e=f[j+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=i>>>1;if(!e)return;i=g+-4|0;if((g|0)<4){j=(g|0)>0;n=h;o=a;q=e;while(1){q=q+-1|0;if(j){r=0;do{s=LVb(m+l*+(b[o+r>>0]|0))|0;d[n+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;r=r+1|0}while((r|0)!=(g|0))}if(!q)break;else{n=n+(k<<1)|0;o=o+c|0}}return}o=g&-4;n=(o|0)<(g|0);q=h;h=a;a=e;while(1){e=0;do{j=LVb(m+l*+(b[h+e>>0]|0))|0;r=e|1;s=LVb(m+l*+(b[h+r>>0]|0))|0;d[q+(e<<1)>>1]=(j+32768|0)>>>0<65536?j:(j|0)>0?32767:32768;d[q+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=e|2;r=LVb(m+l*+(b[h+s>>0]|0))|0;j=e|3;t=LVb(m+l*+(b[h+j>>0]|0))|0;d[q+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[q+(j<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;e=e+4|0}while((e|0)<=(i|0));a=a+-1|0;if(n){e=o;do{t=LVb(m+l*+(b[h+e>>0]|0))|0;d[q+(e<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;e=e+1|0}while((e|0)!=(g|0))}if(!a)break;else{q=q+(k<<1)|0;h=h+c|0}}return}function kK(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0.0,m=0.0,n=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;c=f[i+4>>2]|0;l=+p[k>>3];m=+p[k+8>>3];k=b>>>1;b=h>>>1;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){n=g;o=a;q=h}else return;while(1){c=0;do{i=LVb(m+l*+(j[o+(c<<1)>>1]|0))|0;d[n+(c<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;c=c+1|0}while((c|0)!=(e|0));if(!q)break;else{n=n+(b<<1)|0;o=o+(k<<1)|0;q=q+-1|0}}return}q=e+-4|0;o=(((q|0)>3?q:3)&2147483644)+4|0;n=(o|0)<(e|0);c=g;g=a;a=h;while(1){h=0;do{i=LVb(m+l*+(j[g+(h<<1)>>1]|0))|0;r=h|1;s=LVb(m+l*+(j[g+(r<<1)>>1]|0))|0;d[c+(h<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;d[c+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=h|2;r=LVb(m+l*+(j[g+(s<<1)>>1]|0))|0;i=h|3;t=LVb(m+l*+(j[g+(i<<1)>>1]|0))|0;d[c+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[c+(i<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;h=h+4|0}while((h|0)<=(q|0));if(n){h=o;do{t=LVb(m+l*+(j[g+(h<<1)>>1]|0))|0;d[c+(h<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;h=h+1|0}while((h|0)!=(e|0))}if(!a)break;else{c=c+(b<<1)|0;g=g+(k<<1)|0;a=a+-1|0}}return}function lK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>1;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){m=g;n=a;o=h}else return;while(1){c=0;do{i=LVb(l+k*+(d[n+(c<<1)>>1]|0))|0;d[m+(c<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;c=c+1|0}while((c|0)!=(e|0));if(!o)break;else{m=m+(b<<1)|0;n=n+(j<<1)|0;o=o+-1|0}}return}o=e+-4|0;n=(((o|0)>3?o:3)&2147483644)+4|0;m=(n|0)<(e|0);c=g;g=a;a=h;while(1){h=0;do{i=LVb(l+k*+(d[g+(h<<1)>>1]|0))|0;q=h|1;r=LVb(l+k*+(d[g+(q<<1)>>1]|0))|0;d[c+(h<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;d[c+(q<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=h|2;q=LVb(l+k*+(d[g+(r<<1)>>1]|0))|0;i=h|3;s=LVb(l+k*+(d[g+(i<<1)>>1]|0))|0;d[c+(r<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;d[c+(i<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;h=h+4|0}while((h|0)<=(o|0));if(m){h=n;do{s=LVb(l+k*+(d[g+(h<<1)>>1]|0))|0;d[c+(h<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;h=h+1|0}while((h|0)!=(e|0))}if(!a)break;else{c=c+(b<<1)|0;g=g+(j<<1)|0;a=a+-1|0}}return}function mK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;if(!c)return;h=e+-4|0;i=(((h|0)>3?h:3)&2147483644)+4|0;if((e|0)<4){m=(e|0)>0;n=g;o=a;q=c;while(1){q=q+-1|0;if(m){r=0;do{s=LVb(l+k*+(f[o+(r<<2)>>2]|0))|0;d[n+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;r=r+1|0}while((r|0)!=(e|0))}if(!q)break;else{n=n+(b<<1)|0;o=o+(j<<2)|0}}return}o=(i|0)<(e|0);n=g;g=a;a=c;while(1){c=0;do{q=LVb(l+k*+(f[g+(c<<2)>>2]|0))|0;m=c|1;r=LVb(l+k*+(f[g+(m<<2)>>2]|0))|0;d[n+(c<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;d[n+(m<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=c|2;m=LVb(l+k*+(f[g+(r<<2)>>2]|0))|0;q=c|3;s=LVb(l+k*+(f[g+(q<<2)>>2]|0))|0;d[n+(r<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;d[n+(q<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;c=c+4|0}while((c|0)<=(h|0));a=a+-1|0;if(o){c=i;do{s=LVb(l+k*+(f[g+(c<<2)>>2]|0))|0;d[n+(c<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;c=c+1|0}while((c|0)!=(e|0))}if(!a)break;else{n=n+(b<<1)|0;g=g+(j<<2)|0}}return}function nK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,o=0,q=0,r=0,s=0,t=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>2;b=h>>>1;h=c+-1|0;if(!c)return;if((e|0)<4){if((e|0)>0){m=g;o=a;q=h}else return;while(1){c=0;do{i=LVb(l+k*+n[o+(c<<2)>>2])|0;d[m+(c<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;c=c+1|0}while((c|0)!=(e|0));if(!q)break;else{m=m+(b<<1)|0;o=o+(j<<2)|0;q=q+-1|0}}return}q=e+-4|0;o=(((q|0)>3?q:3)&2147483644)+4|0;m=(o|0)<(e|0);c=g;g=a;a=h;while(1){h=0;do{i=LVb(l+k*+n[g+(h<<2)>>2])|0;r=h|1;s=LVb(l+k*+n[g+(r<<2)>>2])|0;d[c+(h<<1)>>1]=(i+32768|0)>>>0<65536?i:(i|0)>0?32767:32768;d[c+(r<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;s=h|2;r=LVb(l+k*+n[g+(s<<2)>>2])|0;i=h|3;t=LVb(l+k*+n[g+(i<<2)>>2])|0;d[c+(s<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[c+(i<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;h=h+4|0}while((h|0)<=(q|0));if(m){h=o;do{t=LVb(l+k*+n[g+(h<<2)>>2])|0;d[c+(h<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;h=h+1|0}while((h|0)!=(e|0))}if(!a)break;else{c=c+(b<<1)|0;g=g+(j<<2)|0;a=a+-1|0}}return}function oK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;c=f[i+4>>2]|0;i=b>>>3;b=h>>>1;h=c+-1|0;if(!c)return;k=+p[j>>3];l=+p[j+8>>3];if((e|0)<4){if((e|0)>0){m=g;n=a;o=h}else return;while(1){j=0;do{c=MVb(l+k*+p[n+(j<<3)>>3])|0;d[m+(j<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;j=j+1|0}while((j|0)!=(e|0));if(!o)break;else{m=m+(b<<1)|0;n=n+(i<<3)|0;o=o+-1|0}}return}o=e+-4|0;n=(((o|0)>3?o:3)&2147483644)+4|0;m=(n|0)<(e|0);j=g;g=a;a=h;while(1){h=0;do{c=MVb(l+k*+p[g+(h<<3)>>3])|0;q=h|1;r=MVb(l+k*+p[g+(q<<3)>>3])|0;d[j+(h<<1)>>1]=(c+32768|0)>>>0<65536?c:(c|0)>0?32767:32768;d[j+(q<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=h|2;q=MVb(l+k*+p[g+(r<<3)>>3])|0;c=h|3;s=MVb(l+k*+p[g+(c<<3)>>3])|0;d[j+(r<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;d[j+(c<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;h=h+4|0}while((h|0)<=(o|0));if(m){h=n;do{s=MVb(l+k*+p[g+(h<<3)>>3])|0;d[j+(h<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;h=h+1|0}while((h|0)!=(e|0))}if(!a)break;else{j=j+(b<<1)|0;g=g+(i<<3)|0;a=a+-1|0}}return}function pK(a,b,c,d,e,g,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;d=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=g>>>2;if(!c)return;g=d+-4|0;if((d|0)<4){i=(d|0)>0;m=e;n=a;o=c;while(1){o=o+-1|0;if(i){q=0;do{r=LVb(l+k*+(h[n+q>>0]|0))|0;f[m+(q<<2)>>2]=r;q=q+1|0}while((q|0)!=(d|0))}if(!o)break;else{m=m+(j<<2)|0;n=n+b|0}}return}n=d&-4;m=(n|0)<(d|0);o=e;e=a;a=c;while(1){c=0;do{i=LVb(l+k*+(h[e+c>>0]|0))|0;q=c|1;r=LVb(l+k*+(h[e+q>>0]|0))|0;f[o+(c<<2)>>2]=i;f[o+(q<<2)>>2]=r;r=c|2;q=LVb(l+k*+(h[e+r>>0]|0))|0;i=c|3;s=LVb(l+k*+(h[e+i>>0]|0))|0;f[o+(r<<2)>>2]=q;f[o+(i<<2)>>2]=s;c=c+4|0}while((c|0)<=(g|0));a=a+-1|0;if(m){c=n;do{s=LVb(l+k*+(h[e+c>>0]|0))|0;f[o+(c<<2)>>2]=s;c=c+1|0}while((c|0)!=(d|0))}if(!a)break;else{o=o+(j<<2)|0;e=e+b|0}}return}function qK(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;e=f[i>>2]|0;d=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=h>>>2;if(!d)return;h=e+-4|0;if((e|0)<4){i=(e|0)>0;m=g;n=a;o=d;while(1){o=o+-1|0;if(i){q=0;do{r=LVb(l+k*+(b[n+q>>0]|0))|0;f[m+(q<<2)>>2]=r;q=q+1|0}while((q|0)!=(e|0))}if(!o)break;else{m=m+(j<<2)|0;n=n+c|0}}return}n=e&-4;m=(n|0)<(e|0);o=g;g=a;a=d;while(1){d=0;do{i=LVb(l+k*+(b[g+d>>0]|0))|0;q=d|1;r=LVb(l+k*+(b[g+q>>0]|0))|0;f[o+(d<<2)>>2]=i;f[o+(q<<2)>>2]=r;r=d|2;q=LVb(l+k*+(b[g+r>>0]|0))|0;i=d|3;s=LVb(l+k*+(b[g+i>>0]|0))|0;f[o+(r<<2)>>2]=q;f[o+(i<<2)>>2]=s;d=d+4|0}while((d|0)<=(h|0));a=a+-1|0;if(m){d=n;do{s=LVb(l+k*+(b[g+d>>0]|0))|0;f[o+(d<<2)>>2]=s;d=d+1|0}while((d|0)!=(e|0))}if(!a)break;else{o=o+(j<<2)|0;g=g+c|0}}return}function rK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0.0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0;d=f[h>>2]|0;c=f[h+4>>2]|0;k=+p[i>>3];l=+p[i+8>>3];i=b>>>1;b=g>>>2;if(!c)return;g=d+-4|0;if((d|0)<4){h=(d|0)>0;m=e;n=a;o=c;while(1){o=o+-1|0;if(h){q=0;do{r=LVb(l+k*+(j[n+(q<<1)>>1]|0))|0;f[m+(q<<2)>>2]=r;q=q+1|0}while((q|0)!=(d|0))}if(!o)break;else{m=m+(b<<2)|0;n=n+(i<<1)|0}}return}n=d&-4;m=(n|0)<(d|0);o=e;e=a;a=c;while(1){c=0;do{h=LVb(l+k*+(j[e+(c<<1)>>1]|0))|0;q=c|1;r=LVb(l+k*+(j[e+(q<<1)>>1]|0))|0;f[o+(c<<2)>>2]=h;f[o+(q<<2)>>2]=r;r=c|2;q=LVb(l+k*+(j[e+(r<<1)>>1]|0))|0;h=c|3;s=LVb(l+k*+(j[e+(h<<1)>>1]|0))|0;f[o+(r<<2)>>2]=q;f[o+(h<<2)>>2]=s;c=c+4|0}while((c|0)<=(g|0));a=a+-1|0;if(m){c=n;do{s=LVb(l+k*+(j[e+(c<<1)>>1]|0))|0;f[o+(c<<2)>>2]=s;c=c+1|0}while((c|0)!=(d|0))}if(!a)break;else{o=o+(b<<2)|0;e=e+(i<<1)|0}}return}function sK(a,b,c,e,g,h,i,j){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,l=0.0,m=0,n=0,o=0;e=f[i>>2]|0;c=f[i+4>>2]|0;k=+p[j>>3];l=+p[j+8>>3];j=b>>>1;b=h>>>2;if((c|0)!=0&(e|0)>0){m=a;n=g;o=c}else return;while(1){c=0;do{g=LVb(l+k*+(d[m+(c<<1)>>1]|0))|0;f[n+(c<<2)>>2]=g;c=c+1|0}while((c|0)!=(e|0));o=o+-1|0;if(!o)break;else{m=m+(j<<1)|0;n=n+(b<<2)|0}}return}function tK(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0;d=f[h>>2]|0;c=f[h+4>>2]|0;j=+p[i>>3];k=+p[i+8>>3];i=b>>>2;b=g>>>2;if(!c)return;g=d+-4|0;if((d|0)<4){h=(d|0)>0;l=e;m=a;n=c;while(1){n=n+-1|0;if(h){o=0;do{q=MVb(k+j*+(f[m+(o<<2)>>2]|0))|0;f[l+(o<<2)>>2]=q;o=o+1|0}while((o|0)!=(d|0))}if(!n)break;else{l=l+(b<<2)|0;m=m+(i<<2)|0}}return}m=d&-4;l=(m|0)<(d|0);n=e;e=a;a=c;while(1){c=0;do{h=MVb(k+j*+(f[e+(c<<2)>>2]|0))|0;o=c|1;q=MVb(k+j*+(f[e+(o<<2)>>2]|0))|0;f[n+(c<<2)>>2]=h;f[n+(o<<2)>>2]=q;q=c|2;o=MVb(k+j*+(f[e+(q<<2)>>2]|0))|0;h=c|3;r=MVb(k+j*+(f[e+(h<<2)>>2]|0))|0;f[n+(q<<2)>>2]=o;f[n+(h<<2)>>2]=r;c=c+4|0}while((c|0)<=(g|0));a=a+-1|0;if(l){c=m;do{r=MVb(k+j*+(f[e+(c<<2)>>2]|0))|0;f[n+(c<<2)>>2]=r;c=c+1|0}while((c|0)!=(d|0))}if(!a)break;else{n=n+(b<<2)|0;e=e+(i<<2)|0}}return}
function LBb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+16|0;k=a+20|0;l=e+4|0;m=c+32|0;n=c+12|0;o=c+28|0;p=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){q=b[a>>0]|0;r=q&255;if(q<<24>>24>0){f[h>>2]=r;f[c>>2]=a+1;s=r;t=6}else{v=r;t=5}}else{v=0;t=5}if((t|0)==5){t=0;r=_nb(c,v)|0;f[h>>2]=r;if((r+-1|0)>>>0<127){s=r;t=6}else{w=r;t=29}}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{switch(s|0){case 0:{x=1;t=35;break a;break}case 10:break;default:{y=s;break b}}f[i>>2]=f[i>>2]|1;r=f[j>>2]|0;if((r|0)==497760){jza(j,497760);z=f[j>>2]|0}else z=r;if(!(fqb(c,z)|0)){x=0;t=35;break a}r=f[c>>2]|0;if(r>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[r>>0]|0)!=18)continue a;f[c>>2]=r+1;break}case 2:{switch(s|0){case 0:{x=1;t=35;break a;break}case 18:break;default:{y=s;break b}}break}default:{w=s;t=29;break b}}f[i>>2]=f[i>>2]|2;r=f[k>>2]|0;if(!r){a=L5b(48)|0;Zyb(a);f[k>>2]=a;A=a}else A=r;r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0?(a=b[r>>0]|0,a<<24>>24>-1):0){f[c>>2]=r+1;B=a&255}else{a=Znb(c)|0;if((a|0)>-1)B=a;else{x=0;t=35;break a}}Inb(e,c,B);if((f[l>>2]|0)<0){t=23;break a}if(!(Pyb(A,c)|0)){t=23;break a}if(!(Onb(c,f[e>>2]|0)|0)){x=0;t=35;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[m>>2]|0){t=28;break a}if((f[n>>2]|0)==(f[o>>2]|0)){t=28;break a}else continue a}while(0);if((t|0)==29){t=0;if(!w){x=1;t=35;break}else y=w}if((y&7|0)==4){x=1;t=35;break}a=f[p>>2]|0;if(!(a&1))C=hBa(p)|0;else C=a&-2;if(!(ZPb(c,y,C)|0)){x=0;t=35;break}}if((t|0)==23){x=0;u=d;return x|0}else if((t|0)==28){f[h>>2]=0;b[c+24>>0]=1;x=1;u=d;return x|0}else if((t|0)==35){u=d;return x|0}return 0}function MBb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+8|0;d=f[c>>2]|0;if(d&3){if(!(d&1)){e=0;g=d}else{h=f[a+16>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&2))n=e;else{g=f[a+20>>2]|0;l=f[g+36>>2]|0;k=l<<1;if(!l)o=k;else{m=g+44|0;i=0;d=k;while(1){k=Wwb(f[(f[m>>2]|0)+4+(i<<2)>>2]|0)|0;if(k>>>0<128)p=1;else p=iob(k)|0;j=k+d+p|0;i=i+1|0;if((i|0)==(l|0)){o=j;break}else d=j}}d=(aSb(g+4|0)|0)+o|0;o=f[g+20>>2]|0;if(!(o&1))q=d;else q=(dQb(o&-2)|0)+d|0;f[g+28>>2]=q;if(q>>>0<128)r=1;else r=iob(q)|0;n=e+1+q+r|0}}else n=0;r=f[a+4>>2]|0;if(!(r&1)){s=n;t=a+12|0;f[t>>2]=s;return s|0}s=(dQb(r&-2)|0)+n|0;t=a+12|0;f[t>>2]=s;return s|0}function NBb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{$pb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(e&2|0)eqb(2,f[a+20>>2]|0,b);e=f[a+4>>2]|0;if(!(e&1))return;aQb(e&-2,b);return}function OBb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function PBb(a){a=a|0;return f[a+12>>2]|0}function QBb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&2))j=g;else{h=f[a+20>>2]|0;b[g>>0]=18;c=g+1|0;g=f[h+28>>2]|0;if(g>>>0>127){i=g;d=c;while(1){b[d>>0]=i|128;e=i>>>7;k=d+1|0;if(i>>>0>16383){i=e;d=k}else{l=k;m=e;break}}}else{l=c;m=g}b[l>>0]=m;j=li[f[(f[h>>2]|0)+68>>2]&511](h,0,l+1|0)|0}l=f[a+4>>2]|0;if(!(l&1)){n=j;return n|0}n=bQb(l&-2,j)|0;return n|0}function RBb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function SBb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(5760);c=T6b(b,23288,22952,0)|0;if(!c){cOb(b,a);return}else{VBb(a,c);return}}function TBb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function UBb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213388];f[a+4>>2]=f[213389];u=c;return}function VBb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c+4|0;e=c;g=b+8|0;h=f[g>>2]|0;if(h&255|0){if(!(h&1))i=h;else{h=a+8|0;f[h>>2]=f[h>>2]|1;f[e>>2]=f[b+16>>2];f[d>>2]=f[e>>2];Anb(a+16|0,497760,d);i=f[g>>2]|0}if(i&2|0){i=a+8|0;f[i>>2]=f[i>>2]|2;i=a+20|0;g=f[i>>2]|0;if(!g){d=L5b(48)|0;Zyb(d);f[i>>2]=d;j=d}else j=g;g=f[b+20>>2]|0;d=(g|0)==0?498704:g;if((d|0)==(j|0))ivb(11235);Cxb(j+32|0,d+32|0);SRb(j+4|0,d+4|0);g=f[d+20>>2]|0;if(g&1|0)LPb(g&-2,j+20|0)}}j=f[b+4>>2]|0;if(!(j&1)){u=c;return}LPb(j&-2,a+4|0);u=c;return}function WBb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=137404;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=498264?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=497760;f[a+20>>2]=0;u=c;return}function XBb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function YBb(a){a=a|0;var b=0,c=0;f[a>>2]=137296;pCb(a);b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function ZBb(a){a=a|0;YBb(a);O5b(a);return}function _Bb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function $Bb(a,b){a=a|0;b=b|0;a=L5b(56)|0;nCb(a);if(!b)return a|0;oCb(b,a);return a|0}function aCb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[c>>2]|0;do if(d&255|0){e=a+40|0;f[e>>2]=0;f[e+4>>2]=0;do if(d&1|0?(e=f[a+16>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);f[a+48>>2]=1;f[a+52>>2]=1;do if(f[c>>2]&16|0?(g=f[a+20>>2]|0,(g|0)!=497760):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}while(0);do if(f[c>>2]&32|0?(e=f[a+24>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(f[c>>2]&64|0?(g=f[a+28>>2]|0,(g|0)!=497760):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}}while(0);d=f[c>>2]|0;if(d&768|0){do if(d&256|0?(e=f[a+32>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(f[c>>2]&512|0?(d=f[a+36>>2]|0,d|0):0){RRb(d+4|0);g=d+48|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;g=d+36|0;e=f[g>>2]|0;if((e|0)>0){h=f[d+44>>2]|0;i=0;do{j=f[h+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((i|0)!=(e|0));f[g>>2]=0}f[d+24>>2]=0;g=f[d+20>>2]|0;if(g&1|0?(d=g&-2,f[d>>2]|0):0)GPb(d)}}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function bCb(a){a=a|0;var b=0,c=0;if(f[a+8>>2]&512|0?(b=f[a+36>>2]|0,!(di[f[(f[b>>2]|0)+32>>2]&1023](b)|0)):0){c=0;return c|0}c=1;return c|0}function cCb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+16|0;k=a+24|0;l=a+40|0;m=a+48|0;n=a+4|0;o=a+52|0;p=a+20|0;q=a+28|0;r=a+36|0;s=e+4|0;t=a+44|0;v=a+32|0;a=c+32|0;w=c+12|0;x=c+28|0;a:while(1){y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0){z=b[y>>0]|0;A=z&255;if(z<<24>>24>0){f[h>>2]=A;f[c>>2]=y+1;B=A;C=6}else{D=A;C=5}}else{D=0;C=5}if((C|0)==5){C=0;A=_nb(c,D)|0;f[h>>2]=A;if((A+-1|0)>>>0<127){B=A;C=6}else{E=A;C=107}}b:do if((C|0)==6){C=0;do switch(B>>>3&536870911|0){case 1:{switch(B|0){case 0:{F=1;C=113;break a;break}case 10:break;default:{G=B;break b}}f[i>>2]=f[i>>2]|1;A=f[j>>2]|0;if((A|0)==497760){jza(j,497760);H=f[j>>2]|0}else H=A;if(!(fqb(c,H)|0)){F=0;C=113;break a}A=f[c>>2]|0;if(A>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[A>>0]|0)!=18)continue a;f[c>>2]=A+1;C=15;break}case 2:{switch(B|0){case 0:{F=1;C=113;break a;break}case 18:{C=15;break}default:{G=B;break b}}break}case 3:{switch(B|0){case 0:{F=1;C=113;break a;break}case 24:break;default:{G=B;break b}}I=f[c>>2]|0;K=f[g>>2]|0;C=23;break}case 4:{switch(B|0){case 0:{F=1;C=113;break a;break}case 32:break;default:{G=B;break b}}L=f[c>>2]|0;M=f[g>>2]|0;C=33;break}case 5:{switch(B|0){case 0:{F=1;C=113;break a;break}case 40:break;default:{G=B;break b}}N=f[c>>2]|0;O=f[g>>2]|0;C=48;break}case 6:{switch(B|0){case 0:{F=1;C=113;break a;break}case 50:{C=62;break}default:{G=B;break b}}break}case 7:{switch(B|0){case 0:{F=1;C=113;break a;break}case 58:{C=69;break}default:{G=B;break b}}break}case 8:{switch(B|0){case 0:{F=1;C=113;break a;break}case 66:{C=76;break}default:{G=B;break b}}break}case 9:{switch(B|0){case 0:{F=1;C=113;break a;break}case 72:break;default:{G=B;break b}}P=f[c>>2]|0;Q=f[g>>2]|0;C=91;break}case 10:{switch(B|0){case 0:{F=1;C=113;break a;break}case 82:break;default:{G=B;break b}}break}default:{E=B;C=107;break b}}while(0);if((C|0)==15){C=0;f[i>>2]=f[i>>2]|32;A=f[k>>2]|0;if((A|0)==497760){jza(k,497760);R=f[k>>2]|0}else R=A;if(!(fqb(c,R)|0)){F=0;C=113;break a}A=f[c>>2]|0;y=f[g>>2]|0;if(A>>>0>=y>>>0)continue a;if((b[A>>0]|0)!=24)continue a;z=A+1|0;f[c>>2]=z;I=z;K=y;C=23}if((C|0)==23){C=0;f[i>>2]=f[i>>2]|2;if(I>>>0<K>>>0){y=b[I>>0]|0;z=y&255;if(y<<24>>24>-1){y=I+1|0;f[c>>2]=y;S=z;T=y;U=K}else{V=z;C=26}}else{V=0;C=26}if((C|0)==26){C=0;z=Knb(c,V)|0;y=J;if(!((y|0)>-1|(y|0)==-1&z>>>0>4294967295)){F=0;C=113;break a}S=z;T=f[c>>2]|0;U=f[g>>2]|0}f[l>>2]=S;if(T>>>0>=U>>>0)continue a;if((b[T>>0]|0)!=32)continue a;z=T+1|0;f[c>>2]=z;L=z;M=U;C=33}if((C|0)==33){C=0;if(L>>>0<M>>>0){z=b[L>>0]|0;y=z&255;if(z<<24>>24>-1){f[c>>2]=L+1;W=y}else{X=y;C=36}}else{X=0;C=36}if((C|0)==36){C=0;y=Knb(c,X)|0;z=J;if((z|0)>-1|(z|0)==-1&y>>>0>4294967295)W=y;else{F=0;C=113;break a}}if((W+-1|0)>>>0<3){f[i>>2]=f[i>>2]|4;f[m>>2]=W}else{y=f[n>>2]|0;if(!(y&1))Y=hBa(n)|0;else Y=y&-2;NPb(Y,4,W,((W|0)<0)<<31>>31)}y=f[c>>2]|0;z=f[g>>2]|0;if(y>>>0>=z>>>0)continue a;if((b[y>>0]|0)!=40)continue a;A=y+1|0;f[c>>2]=A;N=A;O=z;C=48}if((C|0)==48){C=0;if(N>>>0<O>>>0){z=b[N>>0]|0;A=z&255;if(z<<24>>24>-1){f[c>>2]=N+1;Z=A}else{_=A;C=51}}else{_=0;C=51}if((C|0)==51){C=0;A=Knb(c,_)|0;z=J;if((z|0)>-1|(z|0)==-1&A>>>0>4294967295)Z=A;else{F=0;C=113;break a}}if((Z+-1|0)>>>0<18){f[i>>2]=f[i>>2]|8;f[o>>2]=Z}else{A=f[n>>2]|0;if(!(A&1))$=hBa(n)|0;else $=A&-2;NPb($,5,Z,((Z|0)<0)<<31>>31)}A=f[c>>2]|0;if(A>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[A>>0]|0)!=50)continue a;f[c>>2]=A+1;C=62}if((C|0)==62){C=0;f[i>>2]=f[i>>2]|16;A=f[p>>2]|0;if((A|0)==497760){jza(p,497760);aa=f[p>>2]|0}else aa=A;if(!(fqb(c,aa)|0)){F=0;C=113;break a}A=f[c>>2]|0;if(A>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[A>>0]|0)!=58)continue a;f[c>>2]=A+1;C=69}if((C|0)==69){C=0;f[i>>2]=f[i>>2]|64;A=f[q>>2]|0;if((A|0)==497760){jza(q,497760);ba=f[q>>2]|0}else ba=A;if(!(fqb(c,ba)|0)){F=0;C=113;break a}A=f[c>>2]|0;if(A>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[A>>0]|0)!=66)continue a;f[c>>2]=A+1;C=76}if((C|0)==76){C=0;f[i>>2]=f[i>>2]|512;A=f[r>>2]|0;if(!A){z=L5b(60)|0;qzb(z);f[r>>2]=z;ca=z}else ca=A;A=f[c>>2]|0;if(A>>>0<(f[g>>2]|0)>>>0?(z=b[A>>0]|0,z<<24>>24>-1):0){f[c>>2]=A+1;da=z&255}else{z=Znb(c)|0;if((z|0)>-1)da=z;else{F=0;C=113;break a}}Inb(e,c,da);if((f[s>>2]|0)<0){C=84;break a}if(!(fzb(ca,c)|0)){C=84;break a}if(!(Onb(c,f[e>>2]|0)|0)){F=0;C=113;break a}z=f[c>>2]|0;A=f[g>>2]|0;if(z>>>0>=A>>>0)continue a;if((b[z>>0]|0)!=72)continue a;y=z+1|0;f[c>>2]=y;P=y;Q=A;C=91}if((C|0)==91){C=0;f[i>>2]=f[i>>2]|128;if(P>>>0<Q>>>0){A=b[P>>0]|0;y=A&255;if(A<<24>>24>-1){A=P+1|0;f[c>>2]=A;ea=y;fa=A;ga=Q}else{ha=y;C=94}}else{ha=0;C=94}if((C|0)==94){C=0;y=Knb(c,ha)|0;A=J;if(!((A|0)>-1|(A|0)==-1&y>>>0>4294967295)){F=0;C=113;break a}ea=y;fa=f[c>>2]|0;ga=f[g>>2]|0}f[t>>2]=ea;if(fa>>>0>=ga>>>0)continue a;if((b[fa>>0]|0)!=82)continue a;f[c>>2]=fa+1}f[i>>2]=f[i>>2]|256;y=f[v>>2]|0;if((y|0)==497760){jza(v,497760);ia=f[v>>2]|0}else ia=y;if(!(fqb(c,ia)|0)){F=0;C=113;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[a>>2]|0){C=106;break a}if((f[w>>2]|0)==(f[x>>2]|0)){C=106;break a}else continue a}while(0);if((C|0)==107){C=0;if(!E){F=1;C=113;break}else G=E}if((G&7|0)==4){F=1;C=113;break}y=f[n>>2]|0;if(!(y&1))ja=hBa(n)|0;else ja=y&-2;if(!(ZPb(c,G,ja)|0)){F=0;C=113;break}}if((C|0)==84){F=0;u=d;return F|0}else if((C|0)==106){f[h>>2]=0;b[c+24>>0]=1;F=1;u=d;return F|0}else if((C|0)==113){u=d;return F|0}return 0}function dCb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;c=a+8|0;d=f[c>>2]|0;if(d&255){if(!(d&1)){e=0;g=d}else{h=f[a+16>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&2)){n=e;o=g}else{l=f[a+40>>2]|0;if((l|0)>=0)if(l>>>0<128){p=1;q=g}else{k=iob(l)|0;p=k;q=f[c>>2]|0}else{p=10;q=g}n=e+1+p|0;o=q}if(!(o&4)){r=n;s=o}else{q=f[a+48>>2]|0;if((q|0)>=0)if(q>>>0<128){t=1;u=o}else{p=iob(q)|0;t=p;u=f[c>>2]|0}else{t=10;u=o}r=n+1+t|0;s=u}if(!(s&8)){v=r;w=s}else{u=f[a+52>>2]|0;if((u|0)>=0)if(u>>>0<128){x=1;y=s}else{t=iob(u)|0;x=t;y=f[c>>2]|0}else{x=10;y=s}v=r+1+x|0;w=y}if(!(w&16)){z=v;A=w}else{y=f[a+20>>2]|0;x=b[y+11>>0]|0;if(x<<24>>24<0){r=f[y+4>>2]|0;if(r>>>0<128){B=1;C=w;D=r}else{y=iob(r)|0;B=y;C=f[c>>2]|0;D=r}}else{B=1;C=w;D=x&255}z=v+1+D+B|0;A=C}if(!(A&32)){E=z;F=A}else{C=f[a+24>>2]|0;B=b[C+11>>0]|0;if(B<<24>>24<0){D=f[C+4>>2]|0;if(D>>>0<128){G=1;H=A;I=D}else{C=iob(D)|0;G=C;H=f[c>>2]|0;I=D}}else{G=1;H=A;I=B&255}E=z+1+I+G|0;F=H}if(!(F&64)){J=E;K=F}else{H=f[a+28>>2]|0;G=b[H+11>>0]|0;if(G<<24>>24<0){I=f[H+4>>2]|0;if(I>>>0<128){L=1;M=F;N=I}else{H=iob(I)|0;L=H;M=f[c>>2]|0;N=I}}else{L=1;M=F;N=G&255}J=E+1+N+L|0;K=M}if(!(K&128)){O=J;P=K}else{M=f[a+44>>2]|0;if((M|0)>=0)if(M>>>0<128){Q=2;R=K}else{L=(iob(M)|0)+1|0;Q=L;R=f[c>>2]|0}else{Q=11;R=K}O=Q+J|0;P=R}}else{O=0;P=d}if(P&768){if(!(P&256)){S=O;T=P}else{d=f[a+32>>2]|0;R=b[d+11>>0]|0;if(R<<24>>24<0){J=f[d+4>>2]|0;if(J>>>0<128){U=1;V=P;W=J}else{d=iob(J)|0;U=d;V=f[c>>2]|0;W=J}}else{U=1;V=P;W=R&255}S=O+1+W+U|0;T=V}if(!(T&512))X=S;else{T=gzb(f[a+36>>2]|0)|0;if(T>>>0<128)Y=1;else Y=iob(T)|0;X=S+1+T+Y|0}}else X=O;O=f[a+4>>2]|0;if(!(O&1)){Z=X;_=a+12|0;f[_>>2]=Z;return Z|0}Z=(dQb(O&-2)|0)+X|0;_=a+12|0;f[_>>2]=Z;return Z|0}function eCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{$pb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(!(e&32))g=e;else{$pb(2,f[a+24>>2]|0,b);g=f[c>>2]|0}if(!(g&2))h=g;else{Mpb(3,f[a+40>>2]|0,b);h=f[c>>2]|0}if(!(h&4))i=h;else{Zpb(4,f[a+48>>2]|0,b);i=f[c>>2]|0}if(!(i&8))j=i;else{Zpb(5,f[a+52>>2]|0,b);j=f[c>>2]|0}if(!(j&16))k=j;else{$pb(6,f[a+20>>2]|0,b);k=f[c>>2]|0}if(!(k&64))l=k;else{$pb(7,f[a+28>>2]|0,b);l=f[c>>2]|0}if(!(l&512))m=l;else{eqb(8,f[a+36>>2]|0,b);m=f[c>>2]|0}if(!(m&128))n=m;else{Mpb(9,f[a+44>>2]|0,b);n=f[c>>2]|0}if(n&256|0)$pb(10,f[a+32>>2]|0,b);n=f[a+4>>2]|0;if(!(n&1))return;aQb(n&-2,b);return}function fCb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function gCb(a){a=a|0;return f[a+12>>2]|0}function hCb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+16>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&32)){j=g;k=h}else{h=f[a+24>>2]|0;b[g>>0]=18;i=kob(h,g+1|0)|0;j=i;k=f[c>>2]|0}do if(!(k&2))l=j;else{i=f[a+40>>2]|0;b[j>>0]=24;g=j+1|0;if((i|0)<0){l=hob(i,((i|0)<0)<<31>>31,g)|0;break}if(i>>>0>127){h=i;d=g;while(1){b[d>>0]=h|128;e=h>>>7;m=d+1|0;if(h>>>0>16383){h=e;d=m}else{n=m;o=e;break}}}else{n=g;o=i}b[n>>0]=o;l=n+1|0}while(0);do if(!(f[c>>2]&4))p=l;else{n=f[a+48>>2]|0;b[l>>0]=32;o=l+1|0;if((n|0)<0){p=hob(n,((n|0)<0)<<31>>31,o)|0;break}if(n>>>0>127){j=n;k=o;while(1){b[k>>0]=j|128;d=j>>>7;h=k+1|0;if(j>>>0>16383){j=d;k=h}else{q=h;r=d;break}}}else{q=o;r=n}b[q>>0]=r;p=q+1|0}while(0);do if(!(f[c>>2]&8))s=p;else{q=f[a+52>>2]|0;b[p>>0]=40;r=p+1|0;if((q|0)<0){s=hob(q,((q|0)<0)<<31>>31,r)|0;break}if(q>>>0>127){l=q;k=r;while(1){b[k>>0]=l|128;j=l>>>7;i=k+1|0;if(l>>>0>16383){l=j;k=i}else{t=i;u=j;break}}}else{t=r;u=q}b[t>>0]=u;s=t+1|0}while(0);t=f[c>>2]|0;if(!(t&16)){v=s;w=t}else{t=f[a+20>>2]|0;b[s>>0]=50;u=kob(t,s+1|0)|0;v=u;w=f[c>>2]|0}if(!(w&64)){x=v;y=w}else{w=f[a+28>>2]|0;b[v>>0]=58;u=kob(w,v+1|0)|0;x=u;y=f[c>>2]|0}if(!(y&512)){z=x;A=y}else{y=f[a+36>>2]|0;b[x>>0]=66;u=x+1|0;x=f[y+28>>2]|0;if(x>>>0>127){v=x;w=u;while(1){b[w>>0]=v|128;s=v>>>7;t=w+1|0;if(v>>>0>16383){v=s;w=t}else{B=t;C=s;break}}}else{B=u;C=x}b[B>>0]=C;C=li[f[(f[y>>2]|0)+68>>2]&511](y,0,B+1|0)|0;z=C;A=f[c>>2]|0}do if(!(A&128))D=z;else{C=f[a+44>>2]|0;b[z>>0]=72;B=z+1|0;if((C|0)<0){D=hob(C,((C|0)<0)<<31>>31,B)|0;break}if(C>>>0>127){y=C;x=B;while(1){b[x>>0]=y|128;u=y>>>7;w=x+1|0;if(y>>>0>16383){y=u;x=w}else{E=w;F=u;break}}}else{E=B;F=C}b[E>>0]=F;D=E+1|0}while(0);if(!(f[c>>2]&256))G=D;else{c=f[a+32>>2]|0;b[D>>0]=82;G=kob(c,D+1|0)|0}D=f[a+4>>2]|0;if(!(D&1)){H=G;return H|0}H=bQb(D&-2,G)|0;return H|0}function iCb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function jCb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(4983);c=T6b(b,23288,22968,0)|0;if(!c){cOb(b,a);return}else{mCb(a,c);return}}function kCb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function lCb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213384];f[a+4>>2]=f[213385];u=c;return}function mCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+32|0;d=c+20|0;e=c+16|0;g=c+12|0;h=c+8|0;i=c+4|0;j=c;k=b+8|0;l=f[k>>2]|0;if(l&255){if(!(l&1))m=l;else{n=a+8|0;f[n>>2]=f[n>>2]|1;f[e>>2]=f[b+16>>2];f[d>>2]=f[e>>2];Anb(a+16|0,497760,d);m=f[k>>2]|0}if(!(m&2))o=m;else{m=f[b+40>>2]|0;e=a+8|0;f[e>>2]=f[e>>2]|2;f[a+40>>2]=m;o=f[k>>2]|0}if(!(o&4))p=o;else{o=f[b+48>>2]|0;m=a+8|0;f[m>>2]=f[m>>2]|4;f[a+48>>2]=o;p=f[k>>2]|0}if(!(p&8))q=p;else{p=f[b+52>>2]|0;o=a+8|0;f[o>>2]=f[o>>2]|8;f[a+52>>2]=p;q=f[k>>2]|0}if(!(q&16))r=q;else{q=a+8|0;f[q>>2]=f[q>>2]|16;f[g>>2]=f[b+20>>2];f[d>>2]=f[g>>2];Anb(a+20|0,497760,d);r=f[k>>2]|0}if(!(r&32))s=r;else{r=a+8|0;f[r>>2]=f[r>>2]|32;f[h>>2]=f[b+24>>2];f[d>>2]=f[h>>2];Anb(a+24|0,497760,d);s=f[k>>2]|0}if(!(s&64))t=s;else{s=a+8|0;f[s>>2]=f[s>>2]|64;f[i>>2]=f[b+28>>2];f[d>>2]=f[i>>2];Anb(a+28|0,497760,d);t=f[k>>2]|0}if(!(t&128))v=t;else{t=f[b+44>>2]|0;i=a+8|0;f[i>>2]=f[i>>2]|128;f[a+44>>2]=t;v=f[k>>2]|0}}else v=l;do if(v&65280|0){if(!(v&256))w=v;else{l=a+8|0;f[l>>2]=f[l>>2]|256;f[j>>2]=f[b+32>>2];f[d>>2]=f[j>>2];Anb(a+32|0,497760,d);w=f[k>>2]|0}if(w&512|0){l=a+8|0;f[l>>2]=f[l>>2]|512;l=a+36|0;t=f[l>>2]|0;if(!t){i=L5b(60)|0;qzb(i);f[l>>2]=i;x=i}else x=t;t=f[b+36>>2]|0;i=(t|0)==0?498632:t;if((i|0)==(x|0))ivb(10751);else{pzb(x,i);break}}}while(0);x=f[b+4>>2]|0;if(!(x&1)){u=c;return}LPb(x&-2,a+4|0);u=c;return}function nCb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=137296;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=498200?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;f[a+16>>2]=497760;f[a+20>>2]=497760;f[a+24>>2]=497760;f[a+28>>2]=497760;f[a+32>>2]=497760;f[a+36>>2]=0;d=a+40|0;f[d>>2]=0;f[d+4>>2]=0;f[a+48>>2]=1;f[a+52>>2]=1;u=c;return}function oCb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function pCb(a){a=a|0;var c=0,d=0;c=a+16|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+20|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+24|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+28|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+32|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)==498200)return;c=f[a+36>>2]|0;if(!c)return;bi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function qCb(a){a=a|0;var b=0,c=0;f[a>>2]=137188;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function rCb(a){a=a|0;var b=0,c=0;f[a>>2]=137188;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function sCb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function tCb(a,b){a=a|0;b=b|0;a=L5b(24)|0;GCb(a);if(!b)return a|0;HCb(b,a);return a|0}function uCb(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function vCb(a){a=a|0;return 1}function wCb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+16|0;i=a+20|0;j=c+32|0;k=c+12|0;l=c+28|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[e>>2]=o;f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=_nb(c,r)|0;f[e>>2]=o;if((o+-1|0)>>>0<127){p=o;q=6}else{s=o;q=27}}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{switch(p|0){case 0:{t=1;q=33;break a;break}case 8:break;default:{u=p;break b}}f[g>>2]=f[g>>2]|1;o=f[c>>2]|0;a=f[d>>2]|0;if(o>>>0<a>>>0){n=b[o>>0]|0;v=n&255;if(n<<24>>24>-1){n=o+1|0;f[c>>2]=n;w=v;x=n;y=a}else{z=v;q=11}}else{z=0;q=11}if((q|0)==11){q=0;v=Knb(c,z)|0;a=J;if(!((a|0)>-1|(a|0)==-1&v>>>0>4294967295)){t=0;q=33;break a}w=v;x=f[c>>2]|0;y=f[d>>2]|0}f[h>>2]=w;if(x>>>0>=y>>>0)continue a;if((b[x>>0]|0)!=16)continue a;v=x+1|0;f[c>>2]=v;A=v;B=y;break}case 2:{switch(p|0){case 0:{t=1;q=33;break a;break}case 16:break;default:{u=p;break b}}A=f[c>>2]|0;B=f[d>>2]|0;break}default:{s=p;q=27;break b}}f[g>>2]=f[g>>2]|2;if(A>>>0<B>>>0){v=b[A>>0]|0;a=v&255;if(v<<24>>24>-1){v=A+1|0;f[c>>2]=v;C=a;D=v;E=B}else{F=a;q=21}}else{F=0;q=21}if((q|0)==21){q=0;a=Knb(c,F)|0;v=J;if(!((v|0)>-1|(v|0)==-1&a>>>0>4294967295)){t=0;q=33;break a}C=a;D=f[c>>2]|0;E=f[d>>2]|0}f[i>>2]=C;if((D|0)!=(E|0))continue a;if(f[j>>2]|0){q=26;break a}if((f[k>>2]|0)==(f[l>>2]|0)){q=26;break a}else continue a}while(0);if((q|0)==27){q=0;if(!s){t=1;q=33;break}else u=s}if((u&7|0)==4){t=1;q=33;break}a=f[m>>2]|0;if(!(a&1))G=hBa(m)|0;else G=a&-2;if(!(ZPb(c,u,G)|0)){t=0;q=33;break}}if((q|0)==26){f[e>>2]=0;b[c+24>>0]=1;t=1;return t|0}else if((q|0)==33)return t|0;return 0}function xCb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+8|0;c=f[b>>2]|0;if(c&3){if(c&1){d=f[a+16>>2]|0;if((d|0)>=0)if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}else{e=11;g=c}}else{e=0;g=c}if(!(g&2))i=e;else{g=f[a+20>>2]|0;if((g|0)>=0)if(g>>>0<128)j=2;else j=(iob(g)|0)+1|0;else j=11;i=j+e|0}}else i=0;e=f[a+4>>2]|0;if(!(e&1)){k=i;l=a+12|0;f[l>>2]=k;return k|0}k=(dQb(e&-2)|0)+i|0;l=a+12|0;f[l>>2]=k;return k|0}function yCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Mpb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(e&2|0)Mpb(2,f[a+20>>2]|0,b);e=f[a+4>>2]|0;if(!(e&1))return;aQb(e&-2,b);return}function zCb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function ACb(a){a=a|0;return f[a+12>>2]|0}function BCb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);do if(!(f[c>>2]&2))o=e;else{m=f[a+20>>2]|0;b[e>>0]=16;n=e+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){d=m;j=n;while(1){b[j>>0]=d|128;i=d>>>7;k=j+1|0;if(d>>>0>16383){d=i;j=k}else{p=k;q=i;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}while(0);p=f[a+4>>2]|0;if(!(p&1)){r=o;return r|0}r=bQb(p&-2,o)|0;return r|0}function CCb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function DCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))ivb(3047);c=T6b(b,23288,22984,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[b>>2]|0}if(e&2|0){e=f[c+20>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|2;f[a+20>>2]=e}}e=f[c+4>>2]|0;if(!(e&1))return;LPb(e&-2,a+4|0);return}function ECb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function FCb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213382];f[a+4>>2]=f[213383];u=c;return}function GCb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=137188;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=498168?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function HCb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function ICb(a){a=a|0;var b=0,c=0;f[a>>2]=137080;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}c=a&-2;a=c;if((c|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(c);f[b>>2]=0;return}function JCb(a){a=a|0;var b=0,c=0;f[a>>2]=137080;b=f[a+4>>2]|0;if(!(b&1)){O5b(a);return}c=b&-2;b=c;if((c|0)==0|(f[b+4>>2]|0)!=0){O5b(a);return}if(f[b>>2]|0)GPb(b);O5b(c);O5b(a);return}function KCb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function LCb(a,b){a=a|0;b=b|0;a=L5b(24)|0;YCb(a);if(!b)return a|0;ZCb(b,a);return a|0}function MCb(a){a=a|0;var b=0;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;f[a+8>>2]=0;b=f[a+4>>2]|0;if(!(b&1))return;a=b&-2;if(!(f[a>>2]|0))return;GPb(a);return}function NCb(a){a=a|0;return 1}function OCb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=c+4|0;e=c+20|0;g=a+8|0;h=a+16|0;i=a+20|0;j=c+32|0;k=c+12|0;l=c+28|0;m=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[d>>2]|0)>>>0){n=b[a>>0]|0;o=n&255;if(n<<24>>24>0){f[e>>2]=o;f[c>>2]=a+1;p=o;q=6}else{r=o;q=5}}else{r=0;q=5}if((q|0)==5){q=0;o=_nb(c,r)|0;f[e>>2]=o;if((o+-1|0)>>>0<127){p=o;q=6}else{s=o;q=27}}b:do if((q|0)==6){q=0;switch(p>>>3&536870911|0){case 1:{switch(p|0){case 0:{t=1;q=33;break a;break}case 8:break;default:{u=p;break b}}f[g>>2]=f[g>>2]|1;o=f[c>>2]|0;a=f[d>>2]|0;if(o>>>0<a>>>0){n=b[o>>0]|0;v=n&255;if(n<<24>>24>-1){n=o+1|0;f[c>>2]=n;w=v;x=n;y=a}else{z=v;q=11}}else{z=0;q=11}if((q|0)==11){q=0;v=Knb(c,z)|0;a=J;if(!((a|0)>-1|(a|0)==-1&v>>>0>4294967295)){t=0;q=33;break a}w=v;x=f[c>>2]|0;y=f[d>>2]|0}f[h>>2]=w;if(x>>>0>=y>>>0)continue a;if((b[x>>0]|0)!=16)continue a;v=x+1|0;f[c>>2]=v;A=v;B=y;break}case 2:{switch(p|0){case 0:{t=1;q=33;break a;break}case 16:break;default:{u=p;break b}}A=f[c>>2]|0;B=f[d>>2]|0;break}default:{s=p;q=27;break b}}f[g>>2]=f[g>>2]|2;if(A>>>0<B>>>0){v=b[A>>0]|0;a=v&255;if(v<<24>>24>-1){v=A+1|0;f[c>>2]=v;C=a;D=v;E=B}else{F=a;q=21}}else{F=0;q=21}if((q|0)==21){q=0;a=Knb(c,F)|0;v=J;if(!((v|0)>-1|(v|0)==-1&a>>>0>4294967295)){t=0;q=33;break a}C=a;D=f[c>>2]|0;E=f[d>>2]|0}f[i>>2]=C;if((D|0)!=(E|0))continue a;if(f[j>>2]|0){q=26;break a}if((f[k>>2]|0)==(f[l>>2]|0)){q=26;break a}else continue a}while(0);if((q|0)==27){q=0;if(!s){t=1;q=33;break}else u=s}if((u&7|0)==4){t=1;q=33;break}a=f[m>>2]|0;if(!(a&1))G=hBa(m)|0;else G=a&-2;if(!(ZPb(c,u,G)|0)){t=0;q=33;break}}if((q|0)==26){f[e>>2]=0;b[c+24>>0]=1;t=1;return t|0}else if((q|0)==33)return t|0;return 0}function PCb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=a+8|0;c=f[b>>2]|0;if(c&3){if(c&1){d=f[a+16>>2]|0;if((d|0)>=0)if(d>>>0<128){e=2;g=c}else{h=(iob(d)|0)+1|0;e=h;g=f[b>>2]|0}else{e=11;g=c}}else{e=0;g=c}if(!(g&2))i=e;else{g=f[a+20>>2]|0;if((g|0)>=0)if(g>>>0<128)j=2;else j=(iob(g)|0)+1|0;else j=11;i=j+e|0}}else i=0;e=f[a+4>>2]|0;if(!(e&1)){k=i;l=a+12|0;f[l>>2]=k;return k|0}k=(dQb(e&-2)|0)+i|0;l=a+12|0;f[l>>2]=k;return k|0}function QCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{Mpb(1,f[a+16>>2]|0,b);e=f[c>>2]|0}if(e&2|0)Mpb(2,f[a+20>>2]|0,b);e=f[a+4>>2]|0;if(!(e&1))return;aQb(e&-2,b);return}function RCb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function SCb(a){a=a|0;return f[a+12>>2]|0}function TCb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+8|0;do if(!(f[c>>2]&1))e=d;else{g=f[a+16>>2]|0;b[d>>0]=8;h=d+1|0;if((g|0)<0){e=hob(g,((g|0)<0)<<31>>31,h)|0;break}if(g>>>0>127){i=g;j=h;while(1){b[j>>0]=i|128;k=i>>>7;l=j+1|0;if(i>>>0>16383){i=k;j=l}else{m=l;n=k;break}}}else{m=h;n=g}b[m>>0]=n;e=m+1|0}while(0);do if(!(f[c>>2]&2))o=e;else{m=f[a+20>>2]|0;b[e>>0]=16;n=e+1|0;if((m|0)<0){o=hob(m,((m|0)<0)<<31>>31,n)|0;break}if(m>>>0>127){d=m;j=n;while(1){b[j>>0]=d|128;i=d>>>7;k=j+1|0;if(d>>>0>16383){d=i;j=k}else{p=k;q=i;break}}}else{p=n;q=m}b[p>>0]=q;o=p+1|0}while(0);p=f[a+4>>2]|0;if(!(p&1)){r=o;return r|0}r=bQb(p&-2,o)|0;return r|0}function UCb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function VCb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))ivb(2739);c=T6b(b,23288,23e3,0)|0;if(!c){cOb(b,a);return}b=c+8|0;d=f[b>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[c+16>>2]|0;g=a+8|0;f[g>>2]=f[g>>2]|1;f[a+16>>2]=d;e=f[b>>2]|0}if(e&2|0){e=f[c+20>>2]|0;b=a+8|0;f[b>>2]=f[b>>2]|2;f[a+20>>2]=e}}e=f[c+4>>2]|0;if(!(e&1))return;LPb(e&-2,a+4|0);return}function WCb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function XCb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213380];f[a+4>>2]=f[213381];u=c;return}function YCb(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=137080;f[a+4>>2]=0;f[a+8>>2]=0;if((a|0)!=498136?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;u=c;return}function ZCb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function _Cb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f[a>>2]=136972;c=a+144|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)!=497976?(c=f[a+148>>2]|0,c|0):0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+140|0;d=f[c>>2]|0;if(d|0?(f[a+128>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);O5b(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=a+124|0;i=f[c>>2]|0;if(i|0?(f[a+112>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;O5b(j)}f[c>>2]=0;c=a+108|0;j=f[c>>2]|0;if(j|0?(f[a+96>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;O5b(k)}f[c>>2]=0;c=a+92|0;k=f[c>>2]|0;if(k|0?(f[a+80>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)bi[f[(f[d>>2]|0)+4>>2]&2047](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;O5b(l)}f[c>>2]=0;c=a+76|0;l=f[c>>2]|0;if(l|0?(f[a+64>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0)bi[f[(f[i>>2]|0)+4>>2]&2047](i);j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;O5b(m)}f[c>>2]=0;c=a+60|0;m=f[c>>2]|0;if(m|0?(f[a+48>>2]|0)==0:0){l=f[m>>2]|0;if((l|0)>0){k=0;do{j=f[m+4+(k<<2)>>2]|0;if(j|0)bi[f[(f[j>>2]|0)+4>>2]&2047](j);k=k+1|0}while((k|0)!=(l|0));n=f[c>>2]|0}else n=m;O5b(n)}f[c>>2]=0;c=a+44|0;n=f[c>>2]|0;if(n|0?(f[a+32>>2]|0)==0:0){m=f[n>>2]|0;if((m|0)>0){l=0;do{k=f[n+4+(l<<2)>>2]|0;if(k|0)bi[f[(f[k>>2]|0)+4>>2]&2047](k);l=l+1|0}while((l|0)!=(m|0));o=f[c>>2]|0}else o=n;O5b(o)}f[c>>2]=0;c=a+28|0;o=f[c>>2]|0;if(o|0?(f[a+16>>2]|0)==0:0){n=f[o>>2]|0;if((n|0)>0){m=0;do{l=f[o+4+(m<<2)>>2]|0;if(l|0)bi[f[(f[l>>2]|0)+4>>2]&2047](l);m=m+1|0}while((m|0)!=(n|0));p=f[c>>2]|0}else p=o;O5b(p)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}p=a&-2;a=p;if((p|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(p);f[c>>2]=0;return}function $Cb(a){a=a|0;_Cb(a);O5b(a);return}function aDb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function bDb(a,b){a=a|0;b=b|0;a=L5b(152)|0;BDb(a);if(!b)return a|0;CDb(b,a);return a|0}function cDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=a+8|0;d=f[c>>2]|0;if(d&129|0){do if(d&1|0?(e=f[a+144>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(f[c>>2]&128|0?(d=f[a+148>>2]|0,d|0):0){RRb(d+4|0);f[d+48>>2]=0;g=d+36|0;e=f[g>>2]|0;if((e|0)>0){h=f[d+44>>2]|0;i=0;do{j=f[h+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[j>>2]|0)+28>>2]&2047](j)}while((i|0)!=(e|0));f[g>>2]=0}f[d+24>>2]=0;g=f[d+20>>2]|0;if(g&1|0?(d=g&-2,f[d>>2]|0):0)GPb(d)}}d=a+20|0;g=f[d>>2]|0;if((g|0)>0){e=f[a+28>>2]|0;i=0;do{h=f[e+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((i|0)!=(g|0));f[d>>2]=0}d=a+36|0;g=f[d>>2]|0;if((g|0)>0){i=f[a+44>>2]|0;e=0;do{h=f[i+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(g|0));f[d>>2]=0}d=a+52|0;g=f[d>>2]|0;if((g|0)>0){e=f[a+60>>2]|0;i=0;do{h=f[e+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((i|0)!=(g|0));f[d>>2]=0}d=a+68|0;g=f[d>>2]|0;if((g|0)>0){i=f[a+76>>2]|0;e=0;do{h=f[i+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(g|0));f[d>>2]=0}d=a+84|0;g=f[d>>2]|0;if((g|0)>0){e=f[a+92>>2]|0;i=0;do{h=f[e+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((i|0)!=(g|0));f[d>>2]=0}d=a+100|0;g=f[d>>2]|0;if((g|0)>0){i=f[a+108>>2]|0;e=0;do{h=f[i+4+(e<<2)>>2]|0;e=e+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((e|0)!=(g|0));f[d>>2]=0}d=a+116|0;g=f[d>>2]|0;if((g|0)>0){e=f[a+124>>2]|0;i=0;do{h=f[e+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[h>>2]|0)+28>>2]&2047](h)}while((i|0)!=(g|0));f[d>>2]=0}d=a+132|0;g=f[d>>2]|0;if((g|0)>0){i=f[a+140>>2]|0;e=0;do{h=f[i+4+(e<<2)>>2]|0;e=e+1|0;j=h+11|0;if((b[j>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[j>>0]=0}}while((e|0)!=(g|0));f[d>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function dDb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+28|0;c=f[a+20>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=19;break}}if((g|0)==19)return e|0;c=a+44|0;b=f[a+36>>2]|0;while(1){if((b|0)<=0)break;b=b+-1|0;d=f[(f[c>>2]|0)+4+(b<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=19;break}}if((g|0)==19)return e|0;b=a+60|0;c=f[a+52>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=19;break}}if((g|0)==19)return e|0;c=a+76|0;b=f[a+68>>2]|0;while(1){if((b|0)<=0)break;b=b+-1|0;d=f[(f[c>>2]|0)+4+(b<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=19;break}}if((g|0)==19)return e|0;b=a+108|0;c=f[a+100>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=19;break}}if((g|0)==19)return e|0;if(f[a+8>>2]&128|0?(g=f[a+148>>2]|0,!(di[f[(f[g>>2]|0)+32>>2]&1023](g)|0)):0){e=0;return e|0}e=1;return e|0}function eDb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+144|0;k=c+44|0;l=a+16|0;m=a+28|0;n=a+24|0;o=a+20|0;p=a+48|0;q=a+60|0;r=a+56|0;s=a+52|0;t=a+64|0;v=a+76|0;w=a+72|0;x=a+68|0;y=a+80|0;z=a+92|0;A=a+88|0;B=a+84|0;C=a+32|0;D=a+44|0;E=a+40|0;F=a+36|0;G=a+148|0;H=e+4|0;I=a+96|0;J=a+108|0;K=a+104|0;L=a+100|0;M=a+112|0;N=a+124|0;O=a+120|0;P=a+116|0;Q=a+128|0;R=c+32|0;S=c+12|0;T=c+28|0;U=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){V=b[a>>0]|0;W=V&255;if(V<<24>>24>0){f[h>>2]=W;f[c>>2]=a+1;X=W;Y=6}else{Z=W;Y=5}}else{Z=0;Y=5}if((Y|0)==5){Y=0;W=_nb(c,Z)|0;f[h>>2]=W;if((W+-1|0)>>>0<127){X=W;Y=6}else{_=W;Y=150}}b:do if((Y|0)==6){Y=0;do switch(X>>>3&536870911|0){case 1:{switch(X|0){case 0:{$=1;Y=156;break a;break}case 10:break;default:{aa=X;break b}}f[i>>2]=f[i>>2]|1;W=f[j>>2]|0;if((W|0)==497760){jza(j,497760);ba=f[j>>2]|0}else ba=W;if(!(fqb(c,ba)|0)){$=0;Y=156;break a}W=f[c>>2]|0;if(W>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[W>>0]|0)!=18)continue a;f[c>>2]=W+1;Y=15;break}case 2:{switch(X|0){case 0:{$=1;Y=156;break a;break}case 18:{Y=15;break}default:{aa=X;break b}}break}case 3:{switch(X|0){case 0:{$=1;Y=156;break a;break}case 26:break;default:{aa=X;break b}}W=f[k>>2]|0;f[k>>2]=W+-1;if((W|0)>0)Y=33;else{$=0;Y=156;break a}break}case 4:{switch(X|0){case 0:{$=1;Y=156;break a;break}case 34:break;default:{aa=X;break b}}W=f[k>>2]|0;f[k>>2]=W+-1;if((W|0)>0)Y=49;else{$=0;Y=156;break a}break}case 5:{switch(X|0){case 0:{$=1;Y=156;break a;break}case 42:break;default:{aa=X;break b}}W=f[k>>2]|0;f[k>>2]=W+-1;if((W|0)>0)Y=65;else{$=0;Y=156;break a}break}case 6:{switch(X|0){case 0:{$=1;Y=156;break a;break}case 50:break;default:{aa=X;break b}}W=f[k>>2]|0;f[k>>2]=W+-1;if((W|0)>0)Y=81;else{$=0;Y=156;break a}break}case 7:{switch(X|0){case 0:{$=1;Y=156;break a;break}case 58:{Y=96;break}default:{aa=X;break b}}break}case 8:{switch(X|0){case 0:{$=1;Y=156;break a;break}case 66:{Y=110;break}default:{aa=X;break b}}break}case 9:{switch(X|0){case 0:{$=1;Y=156;break a;break}case 74:break;default:{aa=X;break b}}W=f[k>>2]|0;f[k>>2]=W+-1;if((W|0)>0)Y=128;else{$=0;Y=156;break a}break}case 10:{switch(X|0){case 0:{$=1;Y=156;break a;break}case 82:{Y=143;break}default:{aa=X;break b}}break}default:{_=X;Y=150;break b}}while(0);do if((Y|0)==15){Y=0;W=f[k>>2]|0;f[k>>2]=W+-1;if((W|0)<=0){$=0;Y=156;break a}while(1){W=f[m>>2]|0;do if(W){a=f[o>>2]|0;V=f[W>>2]|0;if((a|0)>=(V|0))if((V|0)==(f[n>>2]|0)){ca=V;Y=21;break}else{da=V;ea=W;Y=22;break}else{f[o>>2]=a+1;fa=f[W+4+(a<<2)>>2]|0;break}}else{ca=f[n>>2]|0;Y=21}while(0);if((Y|0)==21){Y=0;cpb(l,ca+1|0);W=f[m>>2]|0;da=f[W>>2]|0;ea=W;Y=22}if((Y|0)==22){Y=0;f[ea>>2]=da+1;W=Ftb(0,f[l>>2]|0)|0;a=f[m>>2]|0;V=f[o>>2]|0;f[o>>2]=V+1;f[a+4+(V<<2)>>2]=W;fa=W}W=Jnb(c)|0;if(!(cCb(fa,c)|0)){$=0;Y=156;break a}if(!(Pnb(c,W)|0)){$=0;Y=156;break a}ga=f[c>>2]|0;if(ga>>>0>=(f[g>>2]|0)>>>0)break;if((b[ga>>0]|0)!=18){Y=28;break}f[c>>2]=ga+1}if((Y|0)==28?(Y=0,(b[ga>>0]|0)==26):0){ha=ga;Y=32;break}f[k>>2]=(f[k>>2]|0)+1;continue a}while(0);c:while(1){if((Y|0)==32){Y=0;f[c>>2]=ha+1;Y=33;continue}else if((Y|0)==33){Y=0;W=f[q>>2]|0;do if(W){V=f[s>>2]|0;a=f[W>>2]|0;if((V|0)>=(a|0))if((a|0)==(f[r>>2]|0)){ia=a;Y=38;break}else{ja=a;ka=W;Y=39;break}else{f[s>>2]=V+1;la=f[W+4+(V<<2)>>2]|0;break}}else{ia=f[r>>2]|0;Y=38}while(0);if((Y|0)==38){Y=0;cpb(p,ia+1|0);W=f[q>>2]|0;ja=f[W>>2]|0;ka=W;Y=39}if((Y|0)==39){Y=0;f[ka>>2]=ja+1;W=ztb(0,f[p>>2]|0)|0;V=f[q>>2]|0;a=f[s>>2]|0;f[s>>2]=a+1;f[V+4+(a<<2)>>2]=W;la=W}W=Jnb(c)|0;if(!(eDb(la,c)|0)){$=0;Y=156;break a}if(!(Pnb(c,W)|0)){$=0;Y=156;break a}W=f[c>>2]|0;if(W>>>0>=(f[g>>2]|0)>>>0){Y=45;break}if((b[W>>0]|0)==26){ha=W;Y=32;continue}if((b[W>>0]|0)==34){ma=W;Y=48}else{Y=45;break}}else if((Y|0)==49){Y=0;W=f[v>>2]|0;do if(W){a=f[x>>2]|0;V=f[W>>2]|0;if((a|0)>=(V|0))if((V|0)==(f[w>>2]|0)){na=V;Y=54;break}else{oa=V;pa=W;Y=55;break}else{f[x>>2]=a+1;qa=f[W+4+(a<<2)>>2]|0;break}}else{na=f[w>>2]|0;Y=54}while(0);if((Y|0)==54){Y=0;cpb(t,na+1|0);W=f[v>>2]|0;oa=f[W>>2]|0;pa=W;Y=55}if((Y|0)==55){Y=0;f[pa>>2]=oa+1;W=Btb(0,f[t>>2]|0)|0;a=f[v>>2]|0;V=f[x>>2]|0;f[x>>2]=V+1;f[a+4+(V<<2)>>2]=W;qa=W}W=Jnb(c)|0;if(!(pBb(qa,c)|0)){$=0;Y=156;break a}if(!(Pnb(c,W)|0)){$=0;Y=156;break a}W=f[c>>2]|0;if(W>>>0>=(f[g>>2]|0)>>>0){Y=61;break}if((b[W>>0]|0)!=34)if((b[W>>0]|0)==42){ra=W;Y=64}else{Y=61;break}else{ma=W;Y=48}}else if((Y|0)==65){Y=0;W=f[z>>2]|0;do if(W){V=f[B>>2]|0;a=f[W>>2]|0;if((V|0)>=(a|0))if((a|0)==(f[A>>2]|0)){sa=a;Y=70;break}else{ta=a;ua=W;Y=71;break}else{f[B>>2]=V+1;va=f[W+4+(V<<2)>>2]|0;break}}else{sa=f[A>>2]|0;Y=70}while(0);if((Y|0)==70){Y=0;cpb(y,sa+1|0);W=f[z>>2]|0;ta=f[W>>2]|0;ua=W;Y=71}if((Y|0)==71){Y=0;f[ua>>2]=ta+1;W=$tb(0,f[y>>2]|0)|0;V=f[z>>2]|0;a=f[B>>2]|0;f[B>>2]=a+1;f[V+4+(a<<2)>>2]=W;va=W}W=Jnb(c)|0;if(!(OCb(va,c)|0)){$=0;Y=156;break a}if(!(Pnb(c,W)|0)){$=0;Y=156;break a}W=f[c>>2]|0;if(W>>>0>=(f[g>>2]|0)>>>0){Y=77;break}if((b[W>>0]|0)!=42)if((b[W>>0]|0)==50){wa=W;Y=80}else{Y=77;break}else{ra=W;Y=64}}else if((Y|0)==81){Y=0;W=f[D>>2]|0;do if(W){a=f[F>>2]|0;V=f[W>>2]|0;if((a|0)>=(V|0))if((V|0)==(f[E>>2]|0)){xa=V;Y=86;break}else{ya=V;za=W;Y=87;break}else{f[F>>2]=a+1;Aa=f[W+4+(a<<2)>>2]|0;break}}else{xa=f[E>>2]|0;Y=86}while(0);if((Y|0)==86){Y=0;cpb(C,xa+1|0);W=f[D>>2]|0;ya=f[W>>2]|0;za=W;Y=87}if((Y|0)==87){Y=0;f[za>>2]=ya+1;W=Ftb(0,f[C>>2]|0)|0;a=f[D>>2]|0;V=f[F>>2]|0;f[F>>2]=V+1;f[a+4+(V<<2)>>2]=W;Aa=W}W=Jnb(c)|0;if(!(cCb(Aa,c)|0)){$=0;Y=156;break a}if(!(Pnb(c,W)|0)){$=0;Y=156;break a}W=f[c>>2]|0;if(W>>>0>=(f[g>>2]|0)>>>0){Y=91;break}if((b[W>>0]|0)==50){wa=W;Y=80}else{f[k>>2]=(f[k>>2]|0)+1;if((b[W>>0]|0)!=58)continue a;f[c>>2]=W+1;Y=96;continue}}else if((Y|0)==96){Y=0;f[i>>2]=f[i>>2]|128;W=f[G>>2]|0;if(!W){V=L5b(52)|0;Jzb(V);f[G>>2]=V;Ba=V}else Ba=W;W=f[c>>2]|0;if(W>>>0<(f[g>>2]|0)>>>0?(V=b[W>>0]|0,V<<24>>24>-1):0){f[c>>2]=W+1;Ca=V&255}else{V=Znb(c)|0;if((V|0)>-1)Ca=V;else{$=0;Y=156;break a}}Inb(e,c,Ca);if((f[H>>2]|0)<0){Y=104;break a}if(!(yzb(Ba,c)|0)){Y=104;break a}if(!(Onb(c,f[e>>2]|0)|0)){$=0;Y=156;break a}V=f[c>>2]|0;if(V>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[V>>0]|0)!=66)continue a;f[c>>2]=V+1;Y=110;continue}else if((Y|0)==110){Y=0;V=f[k>>2]|0;f[k>>2]=V+-1;if((V|0)<=0){$=0;Y=156;break a}while(1){V=f[J>>2]|0;do if(V){W=f[L>>2]|0;a=f[V>>2]|0;if((W|0)>=(a|0))if((a|0)==(f[K>>2]|0)){Da=a;Y=116;break}else{Ea=a;Fa=V;Y=117;break}else{f[L>>2]=W+1;Ga=f[V+4+(W<<2)>>2]|0;break}}else{Da=f[K>>2]|0;Y=116}while(0);if((Y|0)==116){Y=0;cpb(I,Da+1|0);V=f[J>>2]|0;Ea=f[V>>2]|0;Fa=V;Y=117}if((Y|0)==117){Y=0;f[Fa>>2]=Ea+1;V=Ztb(0,f[I>>2]|0)|0;W=f[J>>2]|0;a=f[L>>2]|0;f[L>>2]=a+1;f[W+4+(a<<2)>>2]=V;Ga=V}V=Jnb(c)|0;if(!(LBb(Ga,c)|0)){$=0;Y=156;break a}if(!(Pnb(c,V)|0)){$=0;Y=156;break a}Ha=f[c>>2]|0;if(Ha>>>0>=(f[g>>2]|0)>>>0){Y=124;break c}if((b[Ha>>0]|0)!=66)break;f[c>>2]=Ha+1}if((b[Ha>>0]|0)==74){Ia=Ha;Y=127}else{Y=124;break}}else if((Y|0)==128){Y=0;V=f[N>>2]|0;do if(V){a=f[P>>2]|0;W=f[V>>2]|0;if((a|0)>=(W|0))if((W|0)==(f[O>>2]|0)){Ja=W;Y=133;break}else{Ka=W;La=V;Y=134;break}else{f[P>>2]=a+1;Ma=f[V+4+(a<<2)>>2]|0;break}}else{Ja=f[O>>2]|0;Y=133}while(0);if((Y|0)==133){Y=0;cpb(M,Ja+1|0);V=f[N>>2]|0;Ka=f[V>>2]|0;La=V;Y=134}if((Y|0)==134){Y=0;f[La>>2]=Ka+1;V=aub(0,f[M>>2]|0)|0;a=f[N>>2]|0;W=f[P>>2]|0;f[P>>2]=W+1;f[a+4+(W<<2)>>2]=V;Ma=V}V=Jnb(c)|0;if(!(wCb(Ma,c)|0)){$=0;Y=156;break a}if(!(Pnb(c,V)|0)){$=0;Y=156;break a}V=f[c>>2]|0;if(V>>>0>=(f[g>>2]|0)>>>0){Y=138;break}if((b[V>>0]|0)!=74){f[k>>2]=(f[k>>2]|0)+1;if((b[V>>0]|0)==82){Na=V;Y=142}else continue a}else{Ia=V;Y=127}}else if((Y|0)==143){Y=0;if(!(fqb(c,mza(Q)|0)|0)){$=0;Y=156;break a}Oa=f[c>>2]|0;Pa=f[g>>2]|0;if(Oa>>>0>=Pa>>>0){Y=146;break}if((b[Oa>>0]|0)==82){Na=Oa;Y=142}else{Y=146;break}}if((Y|0)==48){Y=0;f[c>>2]=ma+1;Y=49;continue}else if((Y|0)==64){Y=0;f[c>>2]=ra+1;Y=65;continue}else if((Y|0)==80){Y=0;f[c>>2]=wa+1;Y=81;continue}else if((Y|0)==127){Y=0;f[c>>2]=Ia+1;Y=128;continue}else if((Y|0)==142){Y=0;f[c>>2]=Na+1;Y=143;continue}}if((Y|0)==45){Y=0;f[k>>2]=(f[k>>2]|0)+1;continue a}else if((Y|0)==61){Y=0;f[k>>2]=(f[k>>2]|0)+1;continue a}else if((Y|0)==77){Y=0;f[k>>2]=(f[k>>2]|0)+1;continue a}else if((Y|0)==91){Y=0;f[k>>2]=(f[k>>2]|0)+1;continue a}else if((Y|0)==124){Y=0;f[k>>2]=(f[k>>2]|0)+1;continue a}else if((Y|0)==138){Y=0;f[k>>2]=(f[k>>2]|0)+1;continue a}else if((Y|0)==146){Y=0;if((Oa|0)!=(Pa|0))continue a;if(f[R>>2]|0){Y=149;break a}if((f[S>>2]|0)==(f[T>>2]|0)){Y=149;break a}else continue a}}while(0);if((Y|0)==150){Y=0;if(!_){$=1;Y=156;break}else aa=_}if((aa&7|0)==4){$=1;Y=156;break}V=f[U>>2]|0;if(!(V&1))Qa=hBa(U)|0;else Qa=V&-2;if(!(ZPb(c,aa,Qa)|0)){$=0;Y=156;break}}if((Y|0)==104){$=0;u=d;return $|0}else if((Y|0)==149){f[h>>2]=0;b[c+24>>0]=1;$=1;u=d;return $|0}else if((Y|0)==156){u=d;return $|0}return 0}function fDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;c=a+8|0;d=f[c>>2]|0;if(d&129){if(!(d&1)){e=0;g=d}else{h=f[a+144>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&128))n=e;else{g=zzb(f[a+148>>2]|0)|0;if(g>>>0<128)o=1;else o=iob(g)|0;n=e+1+g+o|0}}else n=0;o=f[a+20>>2]|0;g=o+n|0;if(!o)p=g;else{n=a+28|0;e=0;l=g;while(1){g=dCb(f[(f[n>>2]|0)+4+(e<<2)>>2]|0)|0;if(g>>>0<128)q=1;else q=iob(g)|0;k=g+l+q|0;e=e+1|0;if((e|0)==(o|0)){p=k;break}else l=k}}l=f[a+36>>2]|0;o=l+p|0;if(!l)r=o;else{p=a+44|0;e=0;q=o;while(1){o=dCb(f[(f[p>>2]|0)+4+(e<<2)>>2]|0)|0;if(o>>>0<128)s=1;else s=iob(o)|0;n=o+q+s|0;e=e+1|0;if((e|0)==(l|0)){r=n;break}else q=n}}q=f[a+52>>2]|0;l=q+r|0;if(!q)t=l;else{r=a+60|0;e=0;s=l;while(1){l=fDb(f[(f[r>>2]|0)+4+(e<<2)>>2]|0)|0;if(l>>>0<128)u=1;else u=iob(l)|0;p=l+s+u|0;e=e+1|0;if((e|0)==(q|0)){t=p;break}else s=p}}s=f[a+68>>2]|0;q=s+t|0;if(!s)v=q;else{t=a+76|0;e=0;u=q;while(1){q=qBb(f[(f[t>>2]|0)+4+(e<<2)>>2]|0)|0;if(q>>>0<128)w=1;else w=iob(q)|0;r=q+u+w|0;e=e+1|0;if((e|0)==(s|0)){v=r;break}else u=r}}u=f[a+84>>2]|0;s=u+v|0;if(!u)x=s;else{v=a+92|0;e=0;w=s;while(1){s=f[(f[v>>2]|0)+4+(e<<2)>>2]|0;t=s+8|0;r=f[t>>2]|0;if(r&3){if(r&1){q=f[s+16>>2]|0;if((q|0)>=0)if(q>>>0<128){y=2;z=r}else{p=(iob(q)|0)+1|0;y=p;z=f[t>>2]|0}else{y=11;z=r}}else{y=0;z=r}if(!(z&2))A=y;else{r=f[s+20>>2]|0;if((r|0)>=0)if(r>>>0<128)B=2;else B=(iob(r)|0)+1|0;else B=11;A=B+y|0}}else A=0;r=f[s+4>>2]|0;if(!(r&1))C=A;else C=(dQb(r&-2)|0)+A|0;f[s+12>>2]=C;if(C>>>0<128)D=1;else D=iob(C)|0;s=C+w+D|0;e=e+1|0;if((e|0)==(u|0)){x=s;break}else w=s}}w=f[a+100>>2]|0;u=w+x|0;if(!w)E=u;else{x=a+108|0;e=0;D=u;while(1){u=MBb(f[(f[x>>2]|0)+4+(e<<2)>>2]|0)|0;if(u>>>0<128)F=1;else F=iob(u)|0;C=u+D+F|0;e=e+1|0;if((e|0)==(w|0)){E=C;break}else D=C}}D=f[a+116>>2]|0;w=D+E|0;if(!D)G=w;else{E=a+124|0;e=0;F=w;while(1){w=f[(f[E>>2]|0)+4+(e<<2)>>2]|0;x=w+8|0;C=f[x>>2]|0;if(C&3){if(C&1){u=f[w+16>>2]|0;if((u|0)>=0)if(u>>>0<128){H=2;I=C}else{A=(iob(u)|0)+1|0;H=A;I=f[x>>2]|0}else{H=11;I=C}}else{H=0;I=C}if(!(I&2))J=H;else{C=f[w+20>>2]|0;if((C|0)>=0)if(C>>>0<128)K=2;else K=(iob(C)|0)+1|0;else K=11;J=K+H|0}}else J=0;C=f[w+4>>2]|0;if(!(C&1))L=J;else L=(dQb(C&-2)|0)+J|0;f[w+12>>2]=L;if(L>>>0<128)M=1;else M=iob(L)|0;w=L+F+M|0;e=e+1|0;if((e|0)==(D|0)){G=w;break}else F=w}}F=a+132|0;D=f[F>>2]|0;e=D+G|0;if((D|0)>0){G=a+140|0;M=0;L=e;J=D;while(1){D=f[(f[G>>2]|0)+4+(M<<2)>>2]|0;H=b[D+11>>0]|0;if(H<<24>>24<0){K=f[D+4>>2]|0;if(K>>>0<128){N=1;O=K;P=J}else{D=iob(K)|0;N=D;O=K;P=f[F>>2]|0}}else{N=1;O=H&255;P=J}H=O+L+N|0;M=M+1|0;if((M|0)>=(P|0)){Q=H;break}else{L=H;J=P}}}else Q=e;e=f[a+4>>2]|0;if(!(e&1)){R=Q;S=a+12|0;f[S>>2]=R;return R|0}R=(dQb(e&-2)|0)+Q|0;S=a+12|0;f[S>>2]=R;return R|0}function gDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;if(f[c>>2]&1|0)$pb(1,f[a+144>>2]|0,b);d=f[a+20>>2]|0;if(d|0){e=a+28|0;g=0;do{eqb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+52>>2]|0;if(d|0){g=a+60|0;e=0;do{eqb(3,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+68>>2]|0;if(d|0){e=a+76|0;g=0;do{eqb(4,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}d=f[a+84>>2]|0;if(d|0){g=a+92|0;e=0;do{eqb(5,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(d|0))}d=f[a+36>>2]|0;if(d|0){e=a+44|0;g=0;do{eqb(6,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(d|0))}if(f[c>>2]&128|0)eqb(7,f[a+148>>2]|0,b);c=f[a+100>>2]|0;if(c|0){d=a+108|0;g=0;do{eqb(8,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(c|0))}c=f[a+116>>2]|0;if(c|0){g=a+124|0;d=0;do{eqb(9,f[(f[g>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(c|0))}c=a+132|0;if((f[c>>2]|0)>0){d=a+140|0;g=0;do{_pb(10,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)<(f[c>>2]|0))}c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function hDb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function iDb(a){a=a|0;return f[a+12>>2]|0}function jDb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;c=a+8|0;if(!(f[c>>2]&1))e=d;else{g=f[a+144>>2]|0;b[d>>0]=10;e=kob(g,d+1|0)|0}d=f[a+20>>2]|0;if(!d)h=e;else{g=a+28|0;i=0;j=e;while(1){e=f[(f[g>>2]|0)+4+(i<<2)>>2]|0;b[j>>0]=18;k=j+1|0;l=f[e+12>>2]|0;if(l>>>0>127){m=l;n=k;while(1){b[n>>0]=m|128;o=m>>>7;p=n+1|0;if(m>>>0>16383){m=o;n=p}else{q=p;r=o;break}}}else{q=k;r=l}b[q>>0]=r;n=li[f[(f[e>>2]|0)+68>>2]&511](e,0,q+1|0)|0;i=i+1|0;if((i|0)==(d|0)){h=n;break}else j=n}}j=f[a+52>>2]|0;if(!j)s=h;else{d=a+60|0;i=0;q=h;while(1){h=f[(f[d>>2]|0)+4+(i<<2)>>2]|0;b[q>>0]=26;r=q+1|0;g=f[h+12>>2]|0;if(g>>>0>127){n=g;m=r;while(1){b[m>>0]=n|128;o=n>>>7;p=m+1|0;if(n>>>0>16383){n=o;m=p}else{t=p;u=o;break}}}else{t=r;u=g}b[t>>0]=u;m=li[f[(f[h>>2]|0)+68>>2]&511](h,0,t+1|0)|0;i=i+1|0;if((i|0)==(j|0)){s=m;break}else q=m}}q=f[a+68>>2]|0;if(!q)v=s;else{j=a+76|0;i=0;t=s;while(1){s=f[(f[j>>2]|0)+4+(i<<2)>>2]|0;b[t>>0]=34;u=t+1|0;d=f[s+12>>2]|0;if(d>>>0>127){m=d;n=u;while(1){b[n>>0]=m|128;e=m>>>7;l=n+1|0;if(m>>>0>16383){m=e;n=l}else{w=l;x=e;break}}}else{w=u;x=d}b[w>>0]=x;n=li[f[(f[s>>2]|0)+68>>2]&511](s,0,w+1|0)|0;i=i+1|0;if((i|0)==(q|0)){v=n;break}else t=n}}t=f[a+84>>2]|0;if(!t)y=v;else{q=a+92|0;i=0;w=v;while(1){v=f[(f[q>>2]|0)+4+(i<<2)>>2]|0;b[w>>0]=42;x=w+1|0;j=f[v+12>>2]|0;if(j>>>0>127){n=j;m=x;while(1){b[m>>0]=n|128;h=n>>>7;g=m+1|0;if(n>>>0>16383){n=h;m=g}else{z=g;A=h;break}}}else{z=x;A=j}b[z>>0]=A;m=li[f[(f[v>>2]|0)+68>>2]&511](v,0,z+1|0)|0;i=i+1|0;if((i|0)==(t|0)){y=m;break}else w=m}}w=f[a+36>>2]|0;if(!w)B=y;else{t=a+44|0;i=0;z=y;while(1){y=f[(f[t>>2]|0)+4+(i<<2)>>2]|0;b[z>>0]=50;A=z+1|0;q=f[y+12>>2]|0;if(q>>>0>127){m=q;n=A;while(1){b[n>>0]=m|128;s=m>>>7;d=n+1|0;if(m>>>0>16383){m=s;n=d}else{C=d;D=s;break}}}else{C=A;D=q}b[C>>0]=D;n=li[f[(f[y>>2]|0)+68>>2]&511](y,0,C+1|0)|0;i=i+1|0;if((i|0)==(w|0)){B=n;break}else z=n}}if(!(f[c>>2]&128))E=B;else{c=f[a+148>>2]|0;b[B>>0]=58;z=B+1|0;B=f[c+28>>2]|0;if(B>>>0>127){w=B;i=z;while(1){b[i>>0]=w|128;C=w>>>7;D=i+1|0;if(w>>>0>16383){w=C;i=D}else{F=D;G=C;break}}}else{F=z;G=B}b[F>>0]=G;E=li[f[(f[c>>2]|0)+68>>2]&511](c,0,F+1|0)|0}F=f[a+100>>2]|0;if(!F)H=E;else{c=a+108|0;G=0;B=E;while(1){E=f[(f[c>>2]|0)+4+(G<<2)>>2]|0;b[B>>0]=66;z=B+1|0;i=f[E+12>>2]|0;if(i>>>0>127){w=i;C=z;while(1){b[C>>0]=w|128;D=w>>>7;t=C+1|0;if(w>>>0>16383){w=D;C=t}else{I=t;J=D;break}}}else{I=z;J=i}b[I>>0]=J;C=li[f[(f[E>>2]|0)+68>>2]&511](E,0,I+1|0)|0;G=G+1|0;if((G|0)==(F|0)){H=C;break}else B=C}}B=f[a+116>>2]|0;if(!B)K=H;else{F=a+124|0;G=0;I=H;while(1){H=f[(f[F>>2]|0)+4+(G<<2)>>2]|0;b[I>>0]=74;J=I+1|0;c=f[H+12>>2]|0;if(c>>>0>127){C=c;w=J;while(1){b[w>>0]=C|128;y=C>>>7;q=w+1|0;if(C>>>0>16383){C=y;w=q}else{L=q;M=y;break}}}else{L=J;M=c}b[L>>0]=M;w=li[f[(f[H>>2]|0)+68>>2]&511](H,0,L+1|0)|0;G=G+1|0;if((G|0)==(B|0)){K=w;break}else I=w}}I=a+132|0;if((f[I>>2]|0)>0){B=a+140|0;G=0;L=K;while(1){M=f[(f[B>>2]|0)+4+(G<<2)>>2]|0;b[L>>0]=82;F=kob(M,L+1|0)|0;G=G+1|0;if((G|0)>=(f[I>>2]|0)){N=F;break}else L=F}}else N=K;K=f[a+4>>2]|0;if(!(K&1)){O=N;return O|0}O=bQb(K&-2,N)|0;return O|0}function kDb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function lDb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(3707);c=T6b(b,23288,23016,0)|0;if(!c){cOb(b,a);return}else{oDb(a,c);return}}function mDb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function nDb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213378];f[a+4>>2]=f[213379];u=c;return}function oDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c+4|0;e=c;pDb(a+16|0,b+16|0);pDb(a+32|0,b+32|0);qDb(a+48|0,b+48|0);rDb(a+64|0,b+64|0);sDb(a+80|0,b+80|0);tDb(a+96|0,b+96|0);uDb(a+112|0,b+112|0);UDa(a+128|0,b+128|0);g=b+8|0;h=f[g>>2]|0;do if(h&255|0){if(!(h&1))i=h;else{j=a+8|0;f[j>>2]=f[j>>2]|1;f[e>>2]=f[b+144>>2];f[d>>2]=f[e>>2];Anb(a+144|0,497760,d);i=f[g>>2]|0}if(i&128|0){j=a+8|0;f[j>>2]=f[j>>2]|128;j=a+148|0;k=f[j>>2]|0;if(!k){l=L5b(52)|0;Jzb(l);f[j>>2]=l;m=l}else m=k;k=f[b+148>>2]|0;l=(k|0)==0?498568:k;if((l|0)==(m|0))ivb(10052);else{Izb(m,l);break}}}while(0);m=f[b+4>>2]|0;if(!(m&1)){u=c;return}LPb(m&-2,a+4|0);u=c;return}function pDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{ADb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Ftb(h,i)|0;ADb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function qDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{zDb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=ztb(h,i)|0;zDb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function rDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{yDb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Btb(h,i)|0;yDb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function sDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{xDb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=$tb(h,i)|0;xDb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function tDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{wDb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Ztb(h,i)|0;wDb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function uDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{vDb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=aub(h,i)|0;vDb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function vDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))ivb(3065);c=a+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[a+16>>2]|0;g=b+8|0;f[g>>2]=f[g>>2]|1;f[b+16>>2]=d;e=f[c>>2]|0}if(e&2|0){e=f[a+20>>2]|0;c=b+8|0;f[c>>2]=f[c>>2]|2;f[b+20>>2]=e}}e=f[a+4>>2]|0;if(!(e&1))return;LPb(e&-2,b+4|0);return}function wDb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))ivb(5778);else{VBb(b,a);return}}function xDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if((a|0)==(b|0))ivb(2757);c=a+8|0;d=f[c>>2]|0;if(d&255|0){if(!(d&1))e=d;else{d=f[a+16>>2]|0;g=b+8|0;f[g>>2]=f[g>>2]|1;f[b+16>>2]=d;e=f[c>>2]|0}if(e&2|0){e=f[a+20>>2]|0;c=b+8|0;f[c>>2]=f[c>>2]|2;f[b+20>>2]=e}}e=f[a+4>>2]|0;if(!(e&1))return;LPb(e&-2,b+4|0);return}function yDb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))ivb(6246);else{zBb(b,a);return}}function zDb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))ivb(3725);else{oDb(b,a);return}}function ADb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))ivb(5001);else{mCb(b,a);return}}function BDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=136972;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==497976;g=a+16|0;h=g+128|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;f[a+144>>2]=497760;f[a+148>>2]=0;u=c;return}function CDb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function DDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f[a>>2]=136864;YDb(a);c=a+116|0;d=f[c>>2]|0;if(d|0?(f[a+104>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)bi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=a+100|0;i=f[c>>2]|0;if(i|0?(f[a+88>>2]|0)==0:0){d=f[i>>2]|0;if((d|0)>0){e=0;do{g=f[i+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));j=f[c>>2]|0}else j=i;O5b(j)}f[c>>2]=0;c=a+84|0;j=f[c>>2]|0;if(j|0?(f[a+72>>2]|0)==0:0){i=f[j>>2]|0;if((i|0)>0){d=0;do{e=f[j+4+(d<<2)>>2]|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(i|0));k=f[c>>2]|0}else k=j;O5b(k)}f[c>>2]=0;c=a+68|0;k=f[c>>2]|0;if(k|0?(f[a+56>>2]|0)==0:0){j=f[k>>2]|0;if((j|0)>0){i=0;do{d=f[k+4+(i<<2)>>2]|0;if(d|0)bi[f[(f[d>>2]|0)+4>>2]&2047](d);i=i+1|0}while((i|0)!=(j|0));l=f[c>>2]|0}else l=k;O5b(l)}f[c>>2]=0;c=f[a+52>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=f[a+40>>2]|0;if(c|0?(f[c>>2]|0)==0:0)O5b(c);c=a+28|0;l=f[c>>2]|0;if(l|0?(f[a+16>>2]|0)==0:0){k=f[l>>2]|0;if((k|0)>0){j=0;do{i=f[l+4+(j<<2)>>2]|0;if(i|0){if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);O5b(i)}j=j+1|0}while((j|0)!=(k|0));m=f[c>>2]|0}else m=l;O5b(m)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}m=a&-2;a=m;if((m|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(m);f[c>>2]=0;return}function EDb(a){a=a|0;DDb(a);O5b(a);return}function FDb(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function GDb(a,b){a=a|0;b=b|0;a=L5b(140)|0;WDb(a);if(!b)return a|0;XDb(b,a);return a|0}function HDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+8|0;d=f[c>>2]|0;do if(d&3|0){do if(d&1|0?(e=f[a+120>>2]|0,(e|0)!=497760):0){g=e+11|0;if((b[g>>0]|0)<0){b[f[e>>2]>>0]=0;f[e+4>>2]=0;break}else{b[e>>0]=0;b[g>>0]=0;break}}while(0);if(f[c>>2]&2|0?(g=f[a+124>>2]|0,(g|0)!=497760):0){e=g+11|0;if((b[e>>0]|0)<0){b[f[g>>2]>>0]=0;f[g+4>>2]=0;break}else{b[g>>0]=0;b[e>>0]=0;break}}}while(0);d=f[c>>2]|0;do if(d&3584|0){if((d&512|0)!=0?(e=f[a+132>>2]|0,(e|0)!=0):0){Pzb(e);h=f[c>>2]|0}else h=d;if(h&1024|0?(e=f[a+136>>2]|0,e|0):0){g=e+20|0;i=f[g>>2]|0;if((i|0)>0){j=f[e+28>>2]|0;k=0;do{l=f[j+4+(k<<2)>>2]|0;k=k+1|0;bi[f[(f[l>>2]|0)+28>>2]&2047](l)}while((k|0)!=(i|0));f[g>>2]=0}f[e+8>>2]=0;i=f[e+4>>2]|0;if(i&1|0?(k=i&-2,f[k>>2]|0):0)GPb(k)}if(f[c>>2]&2048|0?(k=f[a+128>>2]|0,(k|0)!=497760):0){i=k+11|0;if((b[i>>0]|0)<0){b[f[k>>2]>>0]=0;f[k+4>>2]=0;break}else{b[k>>0]=0;b[i>>0]=0;break}}}while(0);h=a+20|0;d=f[h>>2]|0;if((d|0)>0){i=f[a+28>>2]|0;k=0;do{j=f[i+4+(k<<2)>>2]|0;k=k+1|0;l=j+11|0;if((b[l>>0]|0)<0){b[f[j>>2]>>0]=0;f[j+4>>2]=0}else{b[j>>0]=0;b[l>>0]=0}}while((k|0)!=(d|0));f[h>>2]=0}f[a+32>>2]=0;f[a+44>>2]=0;h=a+60|0;d=f[h>>2]|0;if((d|0)>0){k=f[a+68>>2]|0;i=0;do{l=f[k+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[l>>2]|0)+28>>2]&2047](l)}while((i|0)!=(d|0));f[h>>2]=0}h=a+76|0;d=f[h>>2]|0;if((d|0)>0){i=f[a+84>>2]|0;k=0;do{l=f[i+4+(k<<2)>>2]|0;k=k+1|0;bi[f[(f[l>>2]|0)+28>>2]&2047](l)}while((k|0)!=(d|0));f[h>>2]=0}h=a+92|0;d=f[h>>2]|0;if((d|0)>0){k=f[a+100>>2]|0;i=0;do{l=f[k+4+(i<<2)>>2]|0;i=i+1|0;bi[f[(f[l>>2]|0)+28>>2]&2047](l)}while((i|0)!=(d|0));f[h>>2]=0}h=a+108|0;d=f[h>>2]|0;if((d|0)>0){i=f[a+116>>2]|0;k=0;do{l=f[i+4+(k<<2)>>2]|0;k=k+1|0;bi[f[(f[l>>2]|0)+28>>2]&2047](l)}while((k|0)!=(d|0));f[h>>2]=0}f[c>>2]=0;c=f[a+4>>2]|0;if(!(c&1))return;a=c&-2;if(!(f[a>>2]|0))return;GPb(a);return}function IDb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+68|0;c=f[a+60>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=16;break}}if((g|0)==16)return e|0;c=a+84|0;b=f[a+76>>2]|0;while(1){if((b|0)<=0)break;b=b+-1|0;d=f[(f[c>>2]|0)+4+(b<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=16;break}}if((g|0)==16)return e|0;b=a+100|0;c=f[a+92>>2]|0;while(1){if((c|0)<=0)break;c=c+-1|0;d=f[(f[b>>2]|0)+4+(c<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=16;break}}if((g|0)==16)return e|0;c=a+116|0;b=f[a+108>>2]|0;while(1){if((b|0)<=0)break;b=b+-1|0;d=f[(f[c>>2]|0)+4+(b<<2)>>2]|0;if(!(di[f[(f[d>>2]|0)+32>>2]&1023](d)|0)){e=0;g=16;break}}if((g|0)==16)return e|0;if(f[a+8>>2]&512|0?(g=f[a+132>>2]|0,!(di[f[(f[g>>2]|0)+32>>2]&1023](g)|0)):0){e=0;return e|0}e=1;return e|0}function JDb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+8|0;j=a+120|0;k=a+124|0;l=a+16|0;m=c+44|0;n=a+56|0;o=a+68|0;p=a+64|0;q=a+60|0;r=a+72|0;s=a+84|0;t=a+80|0;v=a+76|0;w=a+88|0;x=a+100|0;y=a+96|0;z=a+92|0;A=a+104|0;B=a+116|0;C=a+112|0;D=a+108|0;E=a+132|0;F=e+4|0;G=a+136|0;H=e+4|0;I=a+32|0;K=a+36|0;L=a+40|0;M=a+44|0;N=a+48|0;O=a+52|0;P=a+128|0;Q=c+32|0;R=c+12|0;S=c+28|0;T=a+4|0;a:while(1){a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0){U=b[a>>0]|0;V=U&255;if(U<<24>>24>0){f[h>>2]=V;f[c>>2]=a+1;W=V;X=6}else{Y=V;X=5}}else{Y=0;X=5}if((X|0)==5){X=0;V=_nb(c,Y)|0;f[h>>2]=V;if((V+-1|0)>>>0<127){W=V;X=6}else{Z=V;X=172}}b:do if((X|0)==6){X=0;c:do switch(W>>>3&536870911|0){case 1:{switch(W|0){case 0:{_=1;X=178;break a;break}case 10:break;default:{$=W;break b}}f[i>>2]=f[i>>2]|1;V=f[j>>2]|0;if((V|0)==497760){jza(j,497760);aa=f[j>>2]|0}else aa=V;if(!(fqb(c,aa)|0)){_=0;X=178;break a}V=f[c>>2]|0;if(V>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[V>>0]|0)!=18)continue a;f[c>>2]=V+1;X=15;break}case 2:{switch(W|0){case 0:{_=1;X=178;break a;break}case 18:{X=15;break}default:{$=W;break b}}break}case 3:{switch(W|0){case 0:{_=1;X=178;break a;break}case 26:{X=22;break}default:{$=W;break b}}break}case 4:{switch(W|0){case 0:{_=1;X=178;break a;break}case 34:{X=28;break}default:{$=W;break b}}break}case 5:{switch(W|0){case 0:{_=1;X=178;break a;break}case 42:break;default:{$=W;break b}}V=f[m>>2]|0;f[m>>2]=V+-1;if((V|0)>0)X=46;else{_=0;X=178;break a}break}case 6:{switch(W|0){case 0:{_=1;X=178;break a;break}case 50:break;default:{$=W;break b}}V=f[m>>2]|0;f[m>>2]=V+-1;if((V|0)>0)X=62;else{_=0;X=178;break a}break}case 7:{switch(W|0){case 0:{_=1;X=178;break a;break}case 58:break;default:{$=W;break b}}V=f[m>>2]|0;f[m>>2]=V+-1;if((V|0)>0)X=78;else{_=0;X=178;break a}break}case 8:{switch(W|0){case 0:{_=1;X=178;break a;break}case 66:{X=93;break}default:{$=W;break b}}break}case 9:{switch(W|0){case 0:{_=1;X=178;break a;break}case 74:{X=107;break}default:{$=W;break b}}break}case 10:{switch(W|0){case 0:{_=1;X=178;break a;break}case 80:{ba=f[c>>2]|0;ca=f[g>>2]|0;X=122;break c;break}case 82:{if(a6a(c,I)|0){X=138;break c}else{_=0;X=178;break a}break}default:{$=W;break b}}break}case 11:{switch(W|0){case 0:{_=1;X=178;break a;break}case 88:{da=f[c>>2]|0;ea=f[g>>2]|0;X=144;break c;break}case 90:{if(a6a(c,M)|0){X=160;break c}else{_=0;X=178;break a}break}default:{$=W;break b}}break}case 12:{switch(W|0){case 0:{_=1;X=178;break a;break}case 98:{X=165;break}default:{$=W;break b}}break}default:{Z=W;X=172;break b}}while(0);if((X|0)==15){X=0;f[i>>2]=f[i>>2]|2;V=f[k>>2]|0;if((V|0)==497760){jza(k,497760);fa=f[k>>2]|0}else fa=V;if(!(fqb(c,fa)|0)){_=0;X=178;break a}V=f[c>>2]|0;if(V>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[V>>0]|0)==26){ga=V;X=21}else continue a}d:while(1){switch(X|0){case 21:{X=0;f[c>>2]=ga+1;X=22;continue d;break}case 22:{X=0;if(!(fqb(c,mza(l)|0)|0)){_=0;X=178;break a}V=f[c>>2]|0;if(V>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[V>>0]|0)==26){ga=V;X=21;continue d}if((b[V>>0]|0)!=34)continue a;f[c>>2]=V+1;X=28;continue d;break}case 28:{X=0;V=f[m>>2]|0;f[m>>2]=V+-1;if((V|0)<=0){_=0;X=178;break a}while(1){V=f[o>>2]|0;do if(V){a=f[q>>2]|0;U=f[V>>2]|0;if((a|0)>=(U|0))if((U|0)==(f[p>>2]|0)){ha=U;X=34;break}else{ia=U;ja=V;X=35;break}else{f[q>>2]=a+1;ka=f[V+4+(a<<2)>>2]|0;break}}else{ha=f[p>>2]|0;X=34}while(0);if((X|0)==34){X=0;cpb(n,ha+1|0);V=f[o>>2]|0;ia=f[V>>2]|0;ja=V;X=35}if((X|0)==35){X=0;f[ja>>2]=ia+1;V=ztb(0,f[n>>2]|0)|0;a=f[o>>2]|0;U=f[q>>2]|0;f[q>>2]=U+1;f[a+4+(U<<2)>>2]=V;ka=V}V=Jnb(c)|0;if(!(eDb(ka,c)|0)){_=0;X=178;break a}if(!(Pnb(c,V)|0)){_=0;X=178;break a}la=f[c>>2]|0;if(la>>>0>=(f[g>>2]|0)>>>0){X=42;break d}if((b[la>>0]|0)!=34)break;f[c>>2]=la+1}if((b[la>>0]|0)==42){ma=la;X=45}else{X=42;break d}break}case 46:{X=0;V=f[s>>2]|0;do if(V){U=f[v>>2]|0;a=f[V>>2]|0;if((U|0)>=(a|0))if((a|0)==(f[t>>2]|0)){na=a;X=51;break}else{oa=a;pa=V;X=52;break}else{f[v>>2]=U+1;qa=f[V+4+(U<<2)>>2]|0;break}}else{na=f[t>>2]|0;X=51}while(0);if((X|0)==51){X=0;cpb(r,na+1|0);V=f[s>>2]|0;oa=f[V>>2]|0;pa=V;X=52}if((X|0)==52){X=0;f[pa>>2]=oa+1;V=Btb(0,f[r>>2]|0)|0;U=f[s>>2]|0;a=f[v>>2]|0;f[v>>2]=a+1;f[U+4+(a<<2)>>2]=V;qa=V}V=Jnb(c)|0;if(!(pBb(qa,c)|0)){_=0;X=178;break a}if(!(Pnb(c,V)|0)){_=0;X=178;break a}V=f[c>>2]|0;if(V>>>0>=(f[g>>2]|0)>>>0){X=58;break d}if((b[V>>0]|0)!=42)if((b[V>>0]|0)==50){ra=V;X=61}else{X=58;break d}else{ma=V;X=45}break}case 62:{X=0;V=f[x>>2]|0;do if(V){a=f[z>>2]|0;U=f[V>>2]|0;if((a|0)>=(U|0))if((U|0)==(f[y>>2]|0)){sa=U;X=67;break}else{ta=U;ua=V;X=68;break}else{f[z>>2]=a+1;va=f[V+4+(a<<2)>>2]|0;break}}else{sa=f[y>>2]|0;X=67}while(0);if((X|0)==67){X=0;cpb(w,sa+1|0);V=f[x>>2]|0;ta=f[V>>2]|0;ua=V;X=68}if((X|0)==68){X=0;f[ua>>2]=ta+1;V=Dtb(0,f[w>>2]|0)|0;a=f[x>>2]|0;U=f[z>>2]|0;f[z>>2]=U+1;f[a+4+(U<<2)>>2]=V;va=V}V=Jnb(c)|0;if(!(DAb(va,c)|0)){_=0;X=178;break a}if(!(Pnb(c,V)|0)){_=0;X=178;break a}V=f[c>>2]|0;if(V>>>0>=(f[g>>2]|0)>>>0){X=74;break d}if((b[V>>0]|0)!=50)if((b[V>>0]|0)==58){wa=V;X=77}else{X=74;break d}else{ra=V;X=61}break}case 78:{X=0;V=f[B>>2]|0;do if(V){U=f[D>>2]|0;a=f[V>>2]|0;if((U|0)>=(a|0))if((a|0)==(f[C>>2]|0)){xa=a;X=83;break}else{ya=a;za=V;X=84;break}else{f[D>>2]=U+1;Aa=f[V+4+(U<<2)>>2]|0;break}}else{xa=f[C>>2]|0;X=83}while(0);if((X|0)==83){X=0;cpb(A,xa+1|0);V=f[B>>2]|0;ya=f[V>>2]|0;za=V;X=84}if((X|0)==84){X=0;f[za>>2]=ya+1;V=Ftb(0,f[A>>2]|0)|0;U=f[B>>2]|0;a=f[D>>2]|0;f[D>>2]=a+1;f[U+4+(a<<2)>>2]=V;Aa=V}V=Jnb(c)|0;if(!(cCb(Aa,c)|0)){_=0;X=178;break a}if(!(Pnb(c,V)|0)){_=0;X=178;break a}V=f[c>>2]|0;if(V>>>0>=(f[g>>2]|0)>>>0){X=88;break d}if((b[V>>0]|0)==58){wa=V;X=77}else{f[m>>2]=(f[m>>2]|0)+1;if((b[V>>0]|0)!=66)continue a;f[c>>2]=V+1;X=93;continue d}break}case 93:{X=0;f[i>>2]=f[i>>2]|512;V=f[E>>2]|0;if(!V){a=L5b(80)|0;aAb(a);f[E>>2]=a;Ba=a}else Ba=V;V=f[c>>2]|0;if(V>>>0<(f[g>>2]|0)>>>0?(a=b[V>>0]|0,a<<24>>24>-1):0){f[c>>2]=V+1;Ca=a&255}else{a=Znb(c)|0;if((a|0)>-1)Ca=a;else{_=0;X=178;break a}}Inb(e,c,Ca);if((f[F>>2]|0)<0){X=101;break a}if(!(Rzb(Ba,c)|0)){X=101;break a}if(!(Onb(c,f[e>>2]|0)|0)){_=0;X=178;break a}a=f[c>>2]|0;if(a>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[a>>0]|0)!=74)continue a;f[c>>2]=a+1;X=107;continue d;break}case 107:{X=0;f[i>>2]=f[i>>2]|1024;a=f[G>>2]|0;if(!a){V=L5b(32)|0;vwb(V);f[G>>2]=V;Da=V}else Da=a;a=f[c>>2]|0;if(a>>>0<(f[g>>2]|0)>>>0?(V=b[a>>0]|0,V<<24>>24>-1):0){f[c>>2]=a+1;Ea=V&255}else{V=Znb(c)|0;if((V|0)>-1)Ea=V;else{_=0;X=178;break a}}Inb(e,c,Ea);if((f[H>>2]|0)<0){X=115;break a}if(!(gwb(Da,c)|0)){X=115;break a}if(!(Onb(c,f[e>>2]|0)|0)){_=0;X=178;break a}V=f[c>>2]|0;a=f[g>>2]|0;if(V>>>0>=a>>>0)continue a;if((b[V>>0]|0)==80){Fa=V;Ga=a;X=121}else continue a;break}case 122:{X=0;if(ba>>>0<ca>>>0){a=b[ba>>0]|0;V=a&255;if(a<<24>>24>-1){f[c>>2]=ba+1;Ha=V}else{Ia=V;X=125}}else{Ia=0;X=125}if((X|0)==125){X=0;V=Knb(c,Ia)|0;a=J;if((a|0)>-1|(a|0)==-1&V>>>0>4294967295)Ha=V;else{_=0;X=178;break a}}V=f[I>>2]|0;if((V|0)==(f[K>>2]|0)){nza(I,V+1|0);Ja=f[I>>2]|0}else Ja=V;V=f[L>>2]|0;f[I>>2]=Ja+1;f[V+4+(Ja<<2)>>2]=Ha;a=(f[K>>2]|0)-(f[I>>2]|0)|0;if((a|0)>0){Ka=a;La=V}else{X=138;continue d}while(1){V=f[c>>2]|0;a=f[g>>2]|0;if(V>>>0>=a>>>0){X=138;continue d}if((b[V>>0]|0)!=80){X=138;continue d}U=V+1|0;f[c>>2]=U;if(U>>>0<a>>>0){a=b[U>>0]|0;U=a&255;if(a<<24>>24>-1){f[c>>2]=V+2;Ma=U;Na=La}else{Oa=U;X=133}}else{Oa=0;X=133}if((X|0)==133){X=0;U=Knb(c,Oa)|0;V=J;if(!((V|0)>-1|(V|0)==-1&U>>>0>4294967295)){_=0;X=178;break a}Ma=U;Na=f[L>>2]|0}U=f[I>>2]|0;f[I>>2]=U+1;f[Na+4+(U<<2)>>2]=Ma;if((Ka|0)>1){Ka=Ka+-1|0;La=Na}else{X=138;continue d}}break}case 138:{X=0;U=f[c>>2]|0;V=f[g>>2]|0;if(U>>>0>=V>>>0)continue a;if((b[U>>0]|0)!=80)if((b[U>>0]|0)==88){Pa=U;Qa=V;X=143}else continue a;else{Fa=U;Ga=V;X=121}break}case 144:{X=0;if(da>>>0<ea>>>0){V=b[da>>0]|0;U=V&255;if(V<<24>>24>-1){f[c>>2]=da+1;Ra=U}else{Sa=U;X=147}}else{Sa=0;X=147}if((X|0)==147){X=0;U=Knb(c,Sa)|0;V=J;if((V|0)>-1|(V|0)==-1&U>>>0>4294967295)Ra=U;else{_=0;X=178;break a}}U=f[M>>2]|0;if((U|0)==(f[N>>2]|0)){nza(M,U+1|0);Ta=f[M>>2]|0}else Ta=U;U=f[O>>2]|0;f[M>>2]=Ta+1;f[U+4+(Ta<<2)>>2]=Ra;V=(f[N>>2]|0)-(f[M>>2]|0)|0;if((V|0)>0){Ua=V;Va=U}else{X=160;continue d}while(1){U=f[c>>2]|0;V=f[g>>2]|0;if(U>>>0>=V>>>0){X=160;continue d}if((b[U>>0]|0)!=88){X=160;continue d}a=U+1|0;f[c>>2]=a;if(a>>>0<V>>>0){V=b[a>>0]|0;a=V&255;if(V<<24>>24>-1){f[c>>2]=U+2;Wa=a;Xa=Va}else{Ya=a;X=155}}else{Ya=0;X=155}if((X|0)==155){X=0;a=Knb(c,Ya)|0;U=J;if(!((U|0)>-1|(U|0)==-1&a>>>0>4294967295)){_=0;X=178;break a}Wa=a;Xa=f[O>>2]|0}a=f[M>>2]|0;f[M>>2]=a+1;f[Xa+4+(a<<2)>>2]=Wa;if((Ua|0)>1){Ua=Ua+-1|0;Va=Xa}else{X=160;continue d}}break}case 160:{X=0;a=f[c>>2]|0;U=f[g>>2]|0;if(a>>>0>=U>>>0)continue a;if((b[a>>0]|0)==88){Pa=a;Qa=U;X=143}else{if((b[a>>0]|0)!=98)continue a;f[c>>2]=a+1;X=165;continue d}break}case 165:{X=0;f[i>>2]=f[i>>2]|2048;a=f[P>>2]|0;if((a|0)==497760){X=166;break d}else{Za=a;break d}break}}if((X|0)==45){X=0;f[c>>2]=ma+1;X=46;continue}else if((X|0)==61){X=0;f[c>>2]=ra+1;X=62;continue}else if((X|0)==77){X=0;f[c>>2]=wa+1;X=78;continue}else if((X|0)==121){X=0;a=Fa+1|0;f[c>>2]=a;ba=a;ca=Ga;X=122;continue}else if((X|0)==143){X=0;a=Pa+1|0;f[c>>2]=a;da=a;ea=Qa;X=144;continue}}if((X|0)==42){X=0;f[m>>2]=(f[m>>2]|0)+1;continue a}else if((X|0)==58){X=0;f[m>>2]=(f[m>>2]|0)+1;continue a}else if((X|0)==74){X=0;f[m>>2]=(f[m>>2]|0)+1;continue a}else if((X|0)==88){X=0;f[m>>2]=(f[m>>2]|0)+1;continue a}else if((X|0)==166){X=0;jza(P,497760);Za=f[P>>2]|0}if(!(fqb(c,Za)|0)){_=0;X=178;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[Q>>2]|0){X=171;break a}if((f[R>>2]|0)==(f[S>>2]|0)){X=171;break a}else continue a}while(0);if((X|0)==172){X=0;if(!Z){_=1;X=178;break}else $=Z}if(($&7|0)==4){_=1;X=178;break}a=f[T>>2]|0;if(!(a&1))_a=hBa(T)|0;else _a=a&-2;if(!(ZPb(c,$,_a)|0)){_=0;X=178;break}}if((X|0)==101){_=0;u=d;return _|0}else if((X|0)==115){_=0;u=d;return _|0}else if((X|0)==171){f[h>>2]=0;b[c+24>>0]=1;_=1;u=d;return _|0}else if((X|0)==178){u=d;return _|0}return 0}function KDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;c=a+8|0;d=f[c>>2]|0;if(d&3){if(!(d&1)){e=0;g=d}else{h=f[a+120>>2]|0;i=b[h+11>>0]|0;if(i<<24>>24<0){j=f[h+4>>2]|0;if(j>>>0<128){k=1;l=d;m=j}else{h=iob(j)|0;k=h;l=f[c>>2]|0;m=j}}else{k=1;l=d;m=i&255}e=m+1+k|0;g=l}if(!(g&2)){n=e;o=g}else{l=f[a+124>>2]|0;k=b[l+11>>0]|0;if(k<<24>>24<0){m=f[l+4>>2]|0;if(m>>>0<128){p=1;q=g;r=m}else{l=iob(m)|0;p=l;q=f[c>>2]|0;r=m}}else{p=1;q=g;r=k&255}n=e+1+r+p|0;o=q}}else{n=0;o=d}if(o&3584){if(!(o&512)){s=n;t=o}else{o=Szb(f[a+132>>2]|0)|0;if(o>>>0<128)u=1;else u=iob(o)|0;s=n+1+o+u|0;t=f[c>>2]|0}if(!(t&1024)){v=s;w=t}else{t=f[a+136>>2]|0;u=f[t+20>>2]|0;if(!u)x=0;else{o=t+28|0;d=0;q=u;while(1){p=Qvb(f[(f[o>>2]|0)+4+(d<<2)>>2]|0)|0;if(p>>>0<128)y=1;else y=iob(p)|0;r=p+q+y|0;d=d+1|0;if((d|0)==(u|0)){x=r;break}else q=r}}q=f[t+4>>2]|0;if(!(q&1))z=x;else z=(dQb(q&-2)|0)+x|0;f[t+12>>2]=z;if(z>>>0<128)A=1;else A=iob(z)|0;v=s+1+z+A|0;w=f[c>>2]|0}if(!(w&2048))B=v;else{w=f[a+128>>2]|0;c=b[w+11>>0]|0;if(c<<24>>24<0){A=f[w+4>>2]|0;if(A>>>0<128){C=1;D=A}else{C=iob(A)|0;D=A}}else{C=1;D=c&255}B=v+1+D+C|0}}else B=n;n=a+20|0;C=f[n>>2]|0;D=C+B|0;if((C|0)>0){B=a+28|0;v=0;c=D;A=C;while(1){C=f[(f[B>>2]|0)+4+(v<<2)>>2]|0;w=b[C+11>>0]|0;if(w<<24>>24<0){z=f[C+4>>2]|0;if(z>>>0<128){E=1;F=z;G=A}else{C=iob(z)|0;E=C;F=z;G=f[n>>2]|0}}else{E=1;F=w&255;G=A}w=F+c+E|0;v=v+1|0;if((v|0)>=(G|0)){H=w;break}else{c=w;A=G}}}else H=D;D=a+32|0;G=f[D>>2]|0;if(!G){I=0;J=0}else{A=a+40|0;c=0;v=0;do{E=f[(f[A>>2]|0)+4+(v<<2)>>2]|0;if((E|0)>=0)if(E>>>0<128)K=1;else K=iob(E)|0;else K=10;c=K+c|0;v=v+1|0}while((v|0)!=(G|0));I=c;J=f[D>>2]|0}D=a+44|0;c=f[D>>2]|0;if(!c){L=0;M=0}else{G=a+52|0;v=0;K=0;do{A=f[(f[G>>2]|0)+4+(K<<2)>>2]|0;if((A|0)>=0)if(A>>>0<128)N=1;else N=iob(A)|0;else N=10;v=N+v|0;K=K+1|0}while((K|0)!=(c|0));L=v;M=f[D>>2]|0}D=f[a+60>>2]|0;v=I+H+J+L+M+D|0;if(!D)O=v;else{M=a+68|0;L=0;J=v;while(1){v=fDb(f[(f[M>>2]|0)+4+(L<<2)>>2]|0)|0;if(v>>>0<128)P=1;else P=iob(v)|0;H=v+J+P|0;L=L+1|0;if((L|0)==(D|0)){O=H;break}else J=H}}J=f[a+76>>2]|0;D=J+O|0;if(!J)Q=D;else{O=a+84|0;L=0;P=D;while(1){D=qBb(f[(f[O>>2]|0)+4+(L<<2)>>2]|0)|0;if(D>>>0<128)R=1;else R=iob(D)|0;M=D+P+R|0;L=L+1|0;if((L|0)==(J|0)){Q=M;break}else P=M}}P=f[a+92>>2]|0;J=P+Q|0;if(!P)S=J;else{Q=a+100|0;L=0;R=J;while(1){J=EAb(f[(f[Q>>2]|0)+4+(L<<2)>>2]|0)|0;if(J>>>0<128)T=1;else T=iob(J)|0;O=J+R+T|0;L=L+1|0;if((L|0)==(P|0)){S=O;break}else R=O}}R=f[a+108>>2]|0;P=R+S|0;if(!R)U=P;else{S=a+116|0;L=0;T=P;while(1){P=dCb(f[(f[S>>2]|0)+4+(L<<2)>>2]|0)|0;if(P>>>0<128)V=1;else V=iob(P)|0;Q=P+T+V|0;L=L+1|0;if((L|0)==(R|0)){U=Q;break}else T=Q}}T=f[a+4>>2]|0;if(!(T&1)){W=U;X=a+12|0;f[X>>2]=W;return W|0}W=(dQb(T&-2)|0)+U|0;X=a+12|0;f[X>>2]=W;return W|0}function LDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=a+8|0;d=f[c>>2]|0;if(!(d&1))e=d;else{$pb(1,f[a+120>>2]|0,b);e=f[c>>2]|0}if(e&2|0)$pb(2,f[a+124>>2]|0,b);e=a+20|0;if((f[e>>2]|0)>0){d=a+28|0;g=0;do{_pb(3,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)<(f[e>>2]|0))}e=f[a+60>>2]|0;if(e|0){g=a+68|0;d=0;do{eqb(4,f[(f[g>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(e|0))}e=f[a+76>>2]|0;if(e|0){d=a+84|0;g=0;do{eqb(5,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(e|0))}e=f[a+92>>2]|0;if(e|0){g=a+100|0;d=0;do{eqb(6,f[(f[g>>2]|0)+4+(d<<2)>>2]|0,b);d=d+1|0}while((d|0)!=(e|0))}e=f[a+108>>2]|0;if(e|0){d=a+116|0;g=0;do{eqb(7,f[(f[d>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)!=(e|0))}e=f[c>>2]|0;if(!(e&512))h=e;else{eqb(8,f[a+132>>2]|0,b);h=f[c>>2]|0}if(h&1024|0)eqb(9,f[a+136>>2]|0,b);h=a+32|0;if((f[h>>2]|0)>0){e=a+40|0;g=0;do{Mpb(10,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,b);g=g+1|0}while((g|0)<(f[h>>2]|0))}h=a+44|0;if((f[h>>2]|0)>0){g=a+52|0;e=0;do{Mpb(11,f[(f[g>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)<(f[h>>2]|0))}if(f[c>>2]&2048|0)$pb(12,f[a+128>>2]|0,b);c=f[a+4>>2]|0;if(!(c&1))return;aQb(c&-2,b);return}function MDb(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function NDb(a){a=a|0;return f[a+12>>2]|0}function ODb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;c=a+8|0;e=f[c>>2]|0;if(!(e&1)){g=d;h=e}else{e=f[a+120>>2]|0;b[d>>0]=10;i=kob(e,d+1|0)|0;g=i;h=f[c>>2]|0}if(!(h&2))j=g;else{h=f[a+124>>2]|0;b[g>>0]=18;j=kob(h,g+1|0)|0}g=a+20|0;if((f[g>>2]|0)>0){h=a+28|0;i=0;d=j;while(1){e=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;b[d>>0]=26;k=kob(e,d+1|0)|0;i=i+1|0;if((i|0)>=(f[g>>2]|0)){l=k;break}else d=k}}else l=j;j=f[a+60>>2]|0;if(!j)m=l;else{d=a+68|0;g=0;i=l;while(1){l=f[(f[d>>2]|0)+4+(g<<2)>>2]|0;b[i>>0]=34;h=i+1|0;k=f[l+12>>2]|0;if(k>>>0>127){e=k;n=h;while(1){b[n>>0]=e|128;o=e>>>7;p=n+1|0;if(e>>>0>16383){e=o;n=p}else{q=p;r=o;break}}}else{q=h;r=k}b[q>>0]=r;n=li[f[(f[l>>2]|0)+68>>2]&511](l,0,q+1|0)|0;g=g+1|0;if((g|0)==(j|0)){m=n;break}else i=n}}i=f[a+76>>2]|0;if(!i)s=m;else{j=a+84|0;g=0;q=m;while(1){m=f[(f[j>>2]|0)+4+(g<<2)>>2]|0;b[q>>0]=42;r=q+1|0;d=f[m+12>>2]|0;if(d>>>0>127){n=d;e=r;while(1){b[e>>0]=n|128;o=n>>>7;p=e+1|0;if(n>>>0>16383){n=o;e=p}else{t=p;u=o;break}}}else{t=r;u=d}b[t>>0]=u;e=li[f[(f[m>>2]|0)+68>>2]&511](m,0,t+1|0)|0;g=g+1|0;if((g|0)==(i|0)){s=e;break}else q=e}}q=f[a+92>>2]|0;if(!q)v=s;else{i=a+100|0;g=0;t=s;while(1){s=f[(f[i>>2]|0)+4+(g<<2)>>2]|0;b[t>>0]=50;u=t+1|0;j=f[s+12>>2]|0;if(j>>>0>127){e=j;n=u;while(1){b[n>>0]=e|128;l=e>>>7;k=n+1|0;if(e>>>0>16383){e=l;n=k}else{w=k;x=l;break}}}else{w=u;x=j}b[w>>0]=x;n=li[f[(f[s>>2]|0)+68>>2]&511](s,0,w+1|0)|0;g=g+1|0;if((g|0)==(q|0)){v=n;break}else t=n}}t=f[a+108>>2]|0;if(!t)y=v;else{q=a+116|0;g=0;w=v;while(1){v=f[(f[q>>2]|0)+4+(g<<2)>>2]|0;b[w>>0]=58;x=w+1|0;i=f[v+12>>2]|0;if(i>>>0>127){n=i;e=x;while(1){b[e>>0]=n|128;m=n>>>7;d=e+1|0;if(n>>>0>16383){n=m;e=d}else{z=d;A=m;break}}}else{z=x;A=i}b[z>>0]=A;e=li[f[(f[v>>2]|0)+68>>2]&511](v,0,z+1|0)|0;g=g+1|0;if((g|0)==(t|0)){y=e;break}else w=e}}w=f[c>>2]|0;if(!(w&512)){B=y;C=w}else{w=f[a+132>>2]|0;b[y>>0]=66;t=y+1|0;y=f[w+28>>2]|0;if(y>>>0>127){g=y;z=t;while(1){b[z>>0]=g|128;A=g>>>7;q=z+1|0;if(g>>>0>16383){g=A;z=q}else{D=q;E=A;break}}}else{D=t;E=y}b[D>>0]=E;E=li[f[(f[w>>2]|0)+68>>2]&511](w,0,D+1|0)|0;B=E;C=f[c>>2]|0}if(!(C&1024))F=B;else{C=f[a+136>>2]|0;b[B>>0]=74;E=B+1|0;B=f[C+12>>2]|0;if(B>>>0>127){D=B;w=E;while(1){b[w>>0]=D|128;y=D>>>7;t=w+1|0;if(D>>>0>16383){D=y;w=t}else{G=t;H=y;break}}}else{G=E;H=B}b[G>>0]=H;F=li[f[(f[C>>2]|0)+68>>2]&511](C,0,G+1|0)|0}G=a+32|0;if((f[G>>2]|0)>0){C=a+40|0;H=0;B=F;while(1){E=f[(f[C>>2]|0)+4+(H<<2)>>2]|0;b[B>>0]=80;w=B+1|0;if((E|0)<0)I=hob(E,((E|0)<0)<<31>>31,w)|0;else{if(E>>>0>127){D=E;y=w;while(1){b[y>>0]=D|128;t=D>>>7;z=y+1|0;if(D>>>0>16383){D=t;y=z}else{J=z;K=t;break}}}else{J=w;K=E}b[J>>0]=K;I=J+1|0}H=H+1|0;if((H|0)>=(f[G>>2]|0)){L=I;break}else B=I}}else L=F;F=a+44|0;if((f[F>>2]|0)>0){I=a+52|0;B=0;G=L;while(1){H=f[(f[I>>2]|0)+4+(B<<2)>>2]|0;b[G>>0]=88;J=G+1|0;if((H|0)<0)M=hob(H,((H|0)<0)<<31>>31,J)|0;else{if(H>>>0>127){K=H;C=J;while(1){b[C>>0]=K|128;y=K>>>7;D=C+1|0;if(K>>>0>16383){K=y;C=D}else{N=D;O=y;break}}}else{N=J;O=H}b[N>>0]=O;M=N+1|0}B=B+1|0;if((B|0)>=(f[F>>2]|0)){P=M;break}else G=M}}else P=L;if(!(f[c>>2]&2048))Q=P;else{c=f[a+128>>2]|0;b[P>>0]=98;Q=kob(c,P+1|0)|0}P=f[a+4>>2]|0;if(!(P&1)){R=Q;return R|0}R=bQb(P&-2,Q)|0;return R|0}function PDb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function QDb(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))ivb(1899);c=T6b(b,23288,23032,0)|0;if(!c){cOb(b,a);return}else{TDb(a,c);return}}function RDb(a,b){a=a|0;b=b|0;f[a+12>>2]=b;return}function SDb(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[213373]|0)!=2){f[d>>2]=135812;f[d+4>>2]=53;b[d+8>>0]=0;Gpb(853492,d);hpb(d)}f[a>>2]=f[213376];f[a+4>>2]=f[213377];u=c;return}function TDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;d=c+12|0;e=c+8|0;g=c+4|0;h=c;UDa(a+16|0,b+16|0);i=a+32|0;j=b+32|0;k=f[j>>2]|0;if(k|0){nza(i,(f[i>>2]|0)+k|0);Vac((f[a+40>>2]|0)+4+(f[i>>2]<<2)|0,(f[b+40>>2]|0)+4|0,f[j>>2]<<2|0)|0;f[i>>2]=(f[i>>2]|0)+(f[j>>2]|0)}j=a+44|0;i=b+44|0;k=f[i>>2]|0;if(k|0){nza(j,(f[j>>2]|0)+k|0);Vac((f[a+52>>2]|0)+4+(f[j>>2]<<2)|0,(f[b+52>>2]|0)+4|0,f[i>>2]<<2|0)|0;f[j>>2]=(f[j>>2]|0)+(f[i>>2]|0)}qDb(a+56|0,b+56|0);rDb(a+72|0,b+72|0);UDb(a+88|0,b+88|0);pDb(a+104|0,b+104|0);i=b+8|0;j=f[i>>2]|0;if(j&255){if(!(j&1))l=j;else{k=a+8|0;f[k>>2]=f[k>>2]|1;f[e>>2]=f[b+120>>2];f[d>>2]=f[e>>2];Anb(a+120|0,497760,d);l=f[i>>2]|0}if(!(l&2))m=l;else{l=a+8|0;f[l>>2]=f[l>>2]|2;f[g>>2]=f[b+124>>2];f[d>>2]=f[g>>2];Anb(a+124|0,497760,d);m=f[i>>2]|0}}else m=j;if(m&130560|0){do if(m&512){j=a+8|0;f[j>>2]=f[j>>2]|512;j=a+132|0;g=f[j>>2]|0;if(!g){l=L5b(80)|0;aAb(l);f[j>>2]=l;n=l}else n=g;g=f[b+132>>2]|0;l=(g|0)==0?498480:g;if((l|0)==(n|0))ivb(9039);else{$zb(n,l);o=f[i>>2]|0;break}}else o=m;while(0);if(o&1024|0){o=a+8|0;f[o>>2]=f[o>>2]|1024;o=a+136|0;m=f[o>>2]|0;if(!m){n=L5b(32)|0;vwb(n);f[o>>2]=n;p=n}else p=m;m=f[b+136>>2]|0;n=(m|0)==0?499128:m;if((n|0)==(p|0))ivb(14845);qwb(p+16|0,n+16|0);m=f[n+4>>2]|0;if(m&1|0)LPb(m&-2,p+4|0)}if(f[i>>2]&2048|0){i=a+8|0;f[i>>2]=f[i>>2]|2048;f[h>>2]=f[b+128>>2];f[d>>2]=f[h>>2];Anb(a+128|0,497760,d)}}d=f[b+4>>2]|0;if(!(d&1)){u=c;return}LPb(d&-2,a+4|0);u=c;return}function UDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{VDb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=Dtb(h,i)|0;VDb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function VDb(a,b){a=a|0;b=b|0;if((a|0)==(b|0))ivb(7235);else{NAb(b,a);return}}function WDb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=u;u=u+16|0;d=c;f[a>>2]=136864;f[a+4>>2]=0;f[a+8>>2]=0;e=(a|0)==497824;g=a+16|0;h=g+104|0;do{f[g>>2]=0;g=g+4|0}while((g|0)<(h|0));if(!e?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;f[a+120>>2]=497760;f[a+124>>2]=497760;f[a+128>>2]=497760;f[a+132>>2]=0;f[a+136>>2]=0;u=c;return}function XDb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function YDb(a){a=a|0;var c=0,d=0;c=a+120|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+124|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=a+128|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;if((a|0)==497824)return;c=f[a+132>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=f[a+136>>2]|0;if(!c)return;bi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function ZDb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{_Db(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=$Db(h,i)|0;_Db(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function _Db(a,b){a=a|0;b=b|0;if((a|0)==(b|0))ivb(1917);else{TDb(b,a);return}}function $Db(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=aEb(b,c)|0;u=a;return d|0}function aEb(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(140)|0;WDb(b);c=b;return c|0}else{b=znb(a,23032,140)|0;WDb(b);xnb(a,b,1525);c=b;return c|0}return 0}function bEb(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function cEb(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=136312;f[a+4>>2]=0;f[a+8>>2]=0;e=a+16|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((a|0)!=497784?(f[213371]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=55;b[d+8>>0]=0;Gpb(853484,d);hpb(d)}f[a+12>>2]=0;u=c;return}function dEb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function eEb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213372]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=54;b[c+8>>0]=0;Gpb(853488,c);hpb(c);u=a;return}function fEb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213371]|0)==2){u=a;return 498480}f[c>>2]=135812;f[c+4>>2]=55;b[c+8>>0]=0;Gpb(853484,c);hpb(c);u=a;return 498480}function gEb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);$zb(a,b);return}function hEb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213371]|0)==2){u=a;return 498568}f[c>>2]=135812;f[c+4>>2]=55;b[c+8>>0]=0;Gpb(853484,c);hpb(c);u=a;return 498568}function iEb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);Izb(a,b);return}function jEb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213371]|0)==2){u=a;return 498632}f[c>>2]=135812;f[c+4>>2]=55;b[c+8>>0]=0;Gpb(853484,c);hpb(c);u=a;return 498632}function kEb(a,b){a=a|0;b=b|0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);pzb(a,b);return}function lEb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213371]|0)==2){u=a;return 498704}f[c>>2]=135812;f[c+4>>2]=55;b[c+8>>0]=0;Gpb(853484,c);hpb(c);u=a;return 498704}function mEb(a,b){a=a|0;b=b|0;var c=0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);Cxb(a+32|0,b+32|0);SRb(a+4|0,b+4|0);c=f[b+20>>2]|0;if(!(c&1))return;LPb(c&-2,a+20|0);return}function nEb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213371]|0)==2){u=a;return 498760}f[c>>2]=135812;f[c+4>>2]=55;b[c+8>>0]=0;Gpb(853484,c);hpb(c);u=a;return 498760}function oEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;if((c|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);Cxb(a+32|0,c+32|0);d=c+24|0;e=f[d>>2]|0;if(e&255|0){if(!(e&1))g=e;else{e=b[c+48>>0]|0;h=a+24|0;f[h>>2]=f[h>>2]|1;b[a+48>>0]=e;g=f[d>>2]|0}if(g&2|0){g=b[c+49>>0]|0;d=a+24|0;f[d>>2]=f[d>>2]|2;b[a+49>>0]=g}}SRb(a+4|0,c+4|0);g=f[c+20>>2]|0;if(!(g&1))return;LPb(g&-2,a+20|0);return}function pEb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213371]|0)==2){u=a;return 498824}f[c>>2]=135812;f[c+4>>2]=55;b[c+8>>0]=0;Gpb(853484,c);hpb(c);u=a;return 498824}function qEb(a,c){a=a|0;c=c|0;var d=0,e=0;if((c|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);Cxb(a+32|0,c+32|0);if(f[c+24>>2]&1|0){d=b[c+48>>0]|0;e=a+24|0;f[e>>2]=f[e>>2]|1;b[a+48>>0]=d}SRb(a+4|0,c+4|0);d=f[c+20>>2]|0;if(!(d&1))return;LPb(d&-2,a+20|0);return}function rEb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213371]|0)==2){u=a;return 498888}f[c>>2]=135812;f[c+4>>2]=55;b[c+8>>0]=0;Gpb(853484,c);hpb(c);u=a;return 498888}function sEb(a,c){a=a|0;c=c|0;var d=0,e=0;if((c|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);Cxb(a+32|0,c+32|0);if(f[c+24>>2]&1|0){d=b[c+48>>0]|0;e=a+24|0;f[e>>2]=f[e>>2]|1;b[a+48>>0]=d}SRb(a+4|0,c+4|0);d=f[c+20>>2]|0;if(!(d&1))return;LPb(d&-2,a+20|0);return}function tEb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213371]|0)==2){u=a;return 498952}f[c>>2]=135812;f[c+4>>2]=55;b[c+8>>0]=0;Gpb(853484,c);hpb(c);u=a;return 498952}function uEb(a,c){a=a|0;c=c|0;var d=0,e=0;if((c|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);Cxb(a+32|0,c+32|0);if(f[c+24>>2]&1|0){d=b[c+48>>0]|0;e=a+24|0;f[e>>2]=f[e>>2]|1;b[a+48>>0]=d}SRb(a+4|0,c+4|0);d=f[c+20>>2]|0;if(!(d&1))return;LPb(d&-2,a+20|0);return}function vEb(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[213371]|0)==2){u=a;return 499128}f[c>>2]=135812;f[c+4>>2]=55;b[c+8>>0]=0;Gpb(853484,c);hpb(c);u=a;return 499128}function wEb(a,b){a=a|0;b=b|0;var c=0;if((b|0)==(a|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);qwb(a+16|0,b+16|0);c=f[b+4>>2]|0;if(!(c&1))return;LPb(c&-2,a+4|0);return}function xEb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;f[a>>2]=139492;b=a+40|0;c=a+44|0;d=f[c>>2]|0;e=f[b>>2]|0;g=e;if((d|0)==(e|0)){h=d;i=g}else{d=0;e=g;while(1){O5b(f[e+(d<<2)>>2]|0);d=d+1|0;g=f[c>>2]|0;j=f[b>>2]|0;k=j;if(d>>>0>=g-j>>2>>>0){h=g;i=k;break}else e=k}}e=h;if(i|0){if((e|0)!=(i|0))f[c>>2]=e+(~((e+-4-i|0)>>>2)<<2);O5b(i)}LEb(a+28|0,f[a+32>>2]|0);MEb(a+16|0,f[a+20>>2]|0);MEb(a+4|0,f[a+8>>2]|0);return}function yEb(a){a=a|0;xEb(a);O5b(a);return}function zEb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+16|0;e=d;f[e>>2]=0;f[e+4>>2]=0;g=KEb(a+4|0,b)|0;b=(g|0)==(a+8|0)?e:g+28|0;g=f[b>>2]|0;if(!g){h=0;u=d;return h|0}h=Wob(c,g,f[b+4>>2]|0)|0;u=d;return h|0}function AEb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;IEb(e,a+4|0,b);b=f[e>>2]|0;if(!b){g=0;u=d;return g|0}g=Wob(c,b,f[e+4>>2]|0)|0;u=d;return g|0}function BEb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+16|0;g=e;FEb(g,a+4|0,b,c);c=f[g>>2]|0;if(!c){h=0;u=e;return h|0}h=Wob(d,c,f[g+4>>2]|0)|0;u=e;return h|0}function CEb(a,b,c){a=a|0;b=b|0;c=c|0;return DEb(a+4|0,b,c)|0}function DEb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+32|0;g=e+16|0;h=e;X5b(h,c);X5b(g,h);f[g+12>>2]=0;i=a+28|0;j=EEb(a+24|0,g,f[i>>2]|0,i)|0;if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((j|0)==(i|0)){k=0;u=e;return k|0}h=c+11|0;g=c+4|0;a=d+4|0;l=d+8|0;m=0;n=j;a:while(1){j=n+16|0;o=b[j+11>>0]|0;p=o<<24>>24<0;q=o&255;o=p?f[n+20>>2]|0:q;r=b[h>>0]|0;s=r<<24>>24<0;if((o|0)!=((s?f[g>>2]|0:r&255)|0)){k=m;t=24;break}r=f[j>>2]|0;v=p?r:j;w=s?f[c>>2]|0:c;s=(o|0)==0;b:do if(p){if(!s?ZVb(v,w,o)|0:0){k=m;t=24;break a}}else if(!s){if((r&255)<<24>>24==(b[w>>0]|0)){x=j;y=q;z=w}else{k=m;t=24;break a}while(1){y=y+-1|0;x=x+1|0;if(!y)break b;z=z+1|0;if((b[x>>0]|0)!=(b[z>>0]|0)){k=m;t=24;break a}}}while(0);w=n+28|0;q=f[a>>2]|0;if((q|0)==(f[l>>2]|0))IO(d,w);else{f[q>>2]=f[w>>2];f[a>>2]=q+4}q=f[n+4>>2]|0;if(!q){w=n+8|0;j=f[w>>2]|0;if((f[j>>2]|0)==(n|0))A=j;else{j=w;do{w=f[j>>2]|0;j=w+8|0;r=f[j>>2]|0}while((f[r>>2]|0)!=(w|0));A=r}}else{j=q;while(1){r=f[j>>2]|0;if(!r)break;else j=r}A=j}if((A|0)==(i|0)){k=1;t=24;break}else{m=1;n=A}}if((t|0)==24){u=e;return k|0}return 0}function EEb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!d){g=e;return g|0}a=b[c+11>>0]|0;h=a<<24>>24<0;i=h?f[c+4>>2]|0:a&255;a=f[c+12>>2]|0;j=h?f[c>>2]|0:c;c=e;e=d;a:while(1){d=e;while(1){h=d+16|0;k=b[h+11>>0]|0;l=k<<24>>24<0;m=l?f[d+20>>2]|0:k&255;k=i>>>0<m>>>0;n=k?i:m;if((n|0)!=0?(o=ZVb(l?f[h>>2]|0:h,j,n)|0,(o|0)!=0):0){if((o|0)>=0)p=8}else p=6;if((p|0)==6?(p=0,m>>>0>=i>>>0):0)p=8;if((p|0)==8){p=0;o=m>>>0<i>>>0?m:i;if((o|0)!=0?(m=ZVb(j,l?f[h>>2]|0:h,o)|0,(m|0)!=0):0){if((m|0)<0)break}else p=10;if((p|0)==10?(p=0,k):0)break;if((f[d+28>>2]|0)>=(a|0))break}k=f[d+4>>2]|0;if(!k){g=c;p=15;break a}else d=k}e=f[d>>2]|0;if(!e){g=d;p=15;break}else c=d}if((p|0)==15)return g|0;return 0}function FEb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+16|0;X5b(i,d);X5b(h,i);f[h+12>>2]=e;f[j>>2]=0;f[j+4>>2]=0;e=GEb(c+24|0,h)|0;d=(e|0)==(c+28|0)?j:e+32|0;e=f[d+4>>2]|0;j=a;f[j>>2]=f[d>>2];f[j+4>>2]=e;if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)>=0){u=g;return}O5b(f[i>>2]|0);u=g;return}function GEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=a+4|0;e=HEb(a,c,f[d>>2]|0,d)|0;do if((e|0)!=(d|0)){a=e+16|0;g=b[a+11>>0]|0;h=g<<24>>24<0;i=h?f[e+20>>2]|0:g&255;g=b[c+11>>0]|0;j=g<<24>>24<0;k=j?f[c+4>>2]|0:g&255;g=i>>>0<k>>>0;l=g?i:k;if((l|0)!=0?(m=ZVb(j?f[c>>2]|0:c,h?f[a>>2]|0:a,l)|0,(m|0)!=0):0){if((m|0)<0)break}else n=4;if((n|0)==4?k>>>0<i>>>0:0)break;m=k>>>0<i>>>0?k:i;if((m|0)!=0?(i=ZVb(h?f[a>>2]|0:a,j?f[c>>2]|0:c,m)|0,(i|0)!=0):0){if((i|0)<0){o=e;return o|0}}else n=8;if((n|0)==8?g:0){o=e;return o|0}if((f[c+12>>2]|0)>=(f[e+28>>2]|0)){o=e;return o|0}}while(0);o=d;return o|0}function HEb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!d){g=e;return g|0}a=b[c+11>>0]|0;h=a<<24>>24<0;i=h?f[c+4>>2]|0:a&255;a=f[c+12>>2]|0;j=h?f[c>>2]|0:c;c=e;e=d;a:while(1){d=e;while(1){h=d+16|0;k=b[h+11>>0]|0;l=k<<24>>24<0;m=l?f[d+20>>2]|0:k&255;k=i>>>0<m>>>0;n=k?i:m;if((n|0)!=0?(o=ZVb(l?f[h>>2]|0:h,j,n)|0,(o|0)!=0):0){if((o|0)>=0)p=8}else p=6;if((p|0)==6?(p=0,m>>>0>=i>>>0):0)p=8;if((p|0)==8){p=0;o=m>>>0<i>>>0?m:i;if((o|0)!=0?(m=ZVb(j,l?f[h>>2]|0:h,o)|0,(m|0)!=0):0){if((m|0)<0)break}else p=10;if((p|0)==10?(p=0,k):0)break;if((f[d+28>>2]|0)>=(a|0))break}k=f[d+4>>2]|0;if(!k){g=c;p=15;break a}else d=k}e=f[d>>2]|0;if(!e){g=d;p=15;break}else c=d}if((p|0)==15)return g|0;return 0}function IEb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=c+16|0;g=f[e>>2]|0;a:do if(!g)h=e;else{i=b[d+11>>0]|0;j=i<<24>>24<0;k=j?f[d+4>>2]|0:i&255;i=j?f[d>>2]|0:d;j=e;l=g;while(1){m=l;while(1){n=m+16|0;o=b[n+11>>0]|0;p=o<<24>>24<0;q=p?f[m+20>>2]|0:o&255;o=q>>>0<k>>>0?q:k;if((o|0)!=0?(r=ZVb(i,p?f[n>>2]|0:n,o)|0,(r|0)!=0):0){if((r|0)<0)break}else s=6;if((s|0)==6?(s=0,k>>>0<q>>>0):0)break;q=f[m+4>>2]|0;if(!q){h=j;break a}else m=q}l=f[m>>2]|0;if(!l){h=m;break}else j=m}}while(0);if((h|0)==(f[c+12>>2]|0))t=h;else{s=f[h>>2]|0;if(!s){g=h;while(1){h=f[g+8>>2]|0;if((f[h>>2]|0)==(g|0))g=h;else{u=h;break}}}else{g=s;while(1){s=f[g+4>>2]|0;if(!s){u=g;break}else g=s}}t=u}if((t|0)!=(e|0)?JEb(c,t+16|0,d)|0:0){d=t+28|0;t=f[d+4>>2]|0;c=a;f[c>>2]=f[d>>2];f[c+4>>2]=t;return}f[a>>2]=0;f[a+4>>2]=0;return}function JEb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a=c+11|0;e=b[a>>0]|0;g=e<<24>>24<0;h=c+4|0;i=e&255;e=g?f[h>>2]|0:i;j=d+11|0;k=b[j>>0]|0;l=k<<24>>24<0;m=l?f[d+4>>2]|0:k&255;a:do if((e|0)==(m|0)){k=f[c>>2]|0;n=g?k:c;o=l?f[d>>2]|0:d;p=(e|0)==0;if(g){if(p){q=1;return q|0}if(!(ZVb(n,o,e)|0))q=1;else break;return q|0}if(p){q=1;return q|0}if((k&255)<<24>>24==(b[o>>0]|0)){k=c;p=i;n=o;while(1){p=p+-1|0;k=k+1|0;if(!p){q=1;break}n=n+1|0;if((b[k>>0]|0)!=(b[n>>0]|0))break a}return q|0}}while(0);if(m>>>0<e>>>0){q=0;return q|0}if(u6b(d,0,e,g?f[c>>2]|0:c,e)|0){q=0;return q|0}e=b[a>>0]|0;q=(b[((b[j>>0]|0)<0?f[d>>2]|0:d)+(e<<24>>24<0?f[h>>2]|0:e&255)>>0]|0)==46;return q|0}function KEb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=ZVb(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=ZVb(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function LEb(a,c){a=a|0;c=c|0;if(!c)return;LEb(a,f[c>>2]|0);LEb(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(c);return}function MEb(a,c){a=a|0;c=c|0;if(!c)return;MEb(a,f[c>>2]|0);MEb(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(c);return}function NEb(a){a=a|0;f[a>>2]=139492;f[a+8>>2]=0;f[a+12>>2]=0;f[a+4>>2]=a+8;f[a+20>>2]=0;f[a+24>>2]=0;f[a+16>>2]=a+20;f[a+32>>2]=0;f[a+36>>2]=0;f[a+28>>2]=a+32;f[a+40>>2]=0;f[a+44>>2]=0;f[a+48>>2]=0;return}function OEb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+192|0;e=d+176|0;g=d+32|0;h=d+24|0;i=d;WDb(g);if(Wob(g,b,c)|0){f[h>>2]=b;f[h+4>>2]=c;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];j=PEb(a+4|0,g,e)|0;DDb(g);u=d;return j|0}else{zpb(i,2,465938,314);xpb(d+184|0,vpb(i,466219)|0);Apb(i);j=0;DDb(g);u=d;return j|0}return 0}function PEb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;e=u;u=u+128|0;g=e+96|0;h=e+72|0;i=e+60|0;j=e+48|0;k=e+40|0;l=e+32|0;m=e+24|0;n=e+16|0;o=e+8|0;p=e;q=c+120|0;X5b(g,f[q>>2]|0);r=d;d=f[r>>2]|0;s=f[r+4>>2]|0;r=g+12|0;f[r>>2]=d;f[r+4>>2]=s;r=QEb(a,g)|0;if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if(!r){zpb(h,2,465938,57);r=vpb(h,466039)|0;xpb(e+116|0,wpb(r,f[q>>2]|0)|0);Apb(h);t=0;u=e;return t|0}if(!(f[c+8>>2]&2)){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;v=i+11|0;w=0;x=0}else{X5b(i,f[c+124>>2]|0);h=i+11|0;v=h;w=b[h>>0]|0;x=f[i+4>>2]|0}if((w<<24>>24<0?x:w&255)|0)l6b(i,46);w=c+60|0;a:do if((f[w>>2]|0)>0){x=c+68|0;h=j+11|0;q=0;while(1){Ccb(j,i,f[(f[(f[x>>2]|0)+4+(q<<2)>>2]|0)+144>>2]|0);r=k;f[r>>2]=d;f[r+4>>2]=s;f[g>>2]=f[k>>2];f[g+4>>2]=f[k+4>>2];r=REb(a,j,g)|0;if((b[h>>0]|0)<0)O5b(f[j>>2]|0);if(!r){y=0;break a}r=f[(f[x>>2]|0)+4+(q<<2)>>2]|0;z=l;f[z>>2]=d;f[z+4>>2]=s;f[g>>2]=f[l>>2];f[g+4>>2]=f[l+4>>2];q=q+1|0;if(!(SEb(a,r,g)|0)){y=0;break a}if((q|0)>=(f[w>>2]|0)){A=13;break}}}else A=13;while(0);b:do if((A|0)==13){w=c+76|0;if((f[w>>2]|0)>0){l=c+84|0;k=j+11|0;q=0;do{Ccb(j,i,f[(f[(f[l>>2]|0)+4+(q<<2)>>2]|0)+32>>2]|0);x=m;f[x>>2]=d;f[x+4>>2]=s;f[g>>2]=f[m>>2];f[g+4>>2]=f[m+4>>2];x=REb(a,j,g)|0;if((b[k>>0]|0)<0)O5b(f[j>>2]|0);q=q+1|0;if(!x){y=0;break b}}while((q|0)<(f[w>>2]|0))}w=c+108|0;if((f[w>>2]|0)>0){q=c+116|0;k=j+11|0;l=0;do{Ccb(j,i,f[(f[(f[q>>2]|0)+4+(l<<2)>>2]|0)+16>>2]|0);x=n;f[x>>2]=d;f[x+4>>2]=s;f[g>>2]=f[n>>2];f[g+4>>2]=f[n+4>>2];x=REb(a,j,g)|0;if((b[k>>0]|0)<0)O5b(f[j>>2]|0);if(!x){y=0;break b}x=f[(f[q>>2]|0)+4+(l<<2)>>2]|0;h=o;f[h>>2]=d;f[h+4>>2]=s;f[g>>2]=f[o>>2];f[g+4>>2]=f[o+4>>2];l=l+1|0;if(!(TEb(a,x,g)|0)){y=0;break b}}while((l|0)<(f[w>>2]|0))}w=c+92|0;if((f[w>>2]|0)>0){l=c+100|0;q=j+11|0;k=0;while(1){Ccb(j,i,f[(f[(f[l>>2]|0)+4+(k<<2)>>2]|0)+32>>2]|0);x=p;f[x>>2]=d;f[x+4>>2]=s;f[g>>2]=f[p>>2];f[g+4>>2]=f[p+4>>2];x=REb(a,j,g)|0;if((b[q>>0]|0)<0)O5b(f[j>>2]|0);k=k+1|0;if(!x){y=0;break b}if((k|0)>=(f[w>>2]|0)){y=1;break}}}else y=1}while(0);if((b[v>>0]|0)<0)O5b(f[i>>2]|0);t=y;u=e;return t|0}function QEb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=WEb(a,d,b)|0;if(f[e>>2]|0){g=0;u=c;return g|0}h=L5b(36)|0;X5b(h+16|0,b);i=b+12|0;b=f[i+4>>2]|0;j=h+28|0;f[j>>2]=f[i>>2];f[j+4>>2]=b;b=f[d>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=b;f[e>>2]=h;b=f[f[a>>2]>>2]|0;if(!b)k=h;else{f[a>>2]=b;k=f[e>>2]|0}mP(f[a+4>>2]|0,k);k=a+8|0;f[k>>2]=(f[k>>2]|0)+1;g=1;u=c;return g|0}function REb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=u;u=u+144|0;g=e+124|0;h=e+104|0;i=e+100|0;j=e+96|0;k=e+72|0;l=e+130|0;m=e+24|0;n=e+129|0;o=e;p=e+128|0;q=e+48|0;r=b[c+11>>0]|0;s=r<<24>>24<0;t=s?f[c+4>>2]|0:r&255;a:do if(t|0){r=s?f[c>>2]|0:c;v=0;b:while(1){w=b[r+v>>0]|0;switch(w<<24>>24){case 95:case 46:break;default:{if(w<<24>>24<48)break b;if(w<<24>>24>57){if(w<<24>>24<65)break b;if(w<<24>>24>90&(w+-97&255)>25)break b}}}v=v+1|0;if(v>>>0>=t>>>0)break a}zpb(k,2,465938,94);xpb(l,wpb(vpb(k,466144)|0,c)|0);Apb(k);x=0;u=e;return x|0}while(0);k=a+16|0;l=f[k>>2]|0;c:do if(!l)y=k;else{v=s?f[c>>2]|0:c;r=k;w=l;while(1){z=w;while(1){A=z+16|0;B=b[A+11>>0]|0;C=B<<24>>24<0;D=C?f[z+20>>2]|0:B&255;B=D>>>0<t>>>0?D:t;if((B|0)!=0?(E=ZVb(v,C?f[A>>2]|0:A,B)|0,(E|0)!=0):0){if((E|0)<0)break}else F=15;if((F|0)==15?(F=0,t>>>0<D>>>0):0)break;D=f[z+4>>2]|0;if(!D){y=r;break c}else z=D}w=f[z>>2]|0;if(!w){y=z;break}else r=z}}while(0);if((y|0)==(f[a+12>>2]|0))G=y;else{t=f[y>>2]|0;if(!t){F=y;while(1){y=f[F+8>>2]|0;if((f[y>>2]|0)==(F|0))F=y;else{H=y;break}}}else{F=t;while(1){t=f[F+4>>2]|0;if(!t){H=F;break}else F=t}}G=H}H=a+12|0;if((G|0)==(k|0)){X5b(h,c);F=h+12|0;t=d;y=f[t+4>>2]|0;l=F;f[l>>2]=f[t>>2];f[l+4>>2]=y;y=WEb(H,g,h)|0;if(!(f[y>>2]|0)){l=L5b(36)|0;X5b(l+16|0,h);t=F;F=f[t+4>>2]|0;s=l+28|0;f[s>>2]=f[t>>2];f[s+4>>2]=F;F=f[g>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=F;f[y>>2]=l;F=f[f[H>>2]>>2]|0;if(!F)I=l;else{f[H>>2]=F;I=f[y>>2]|0}mP(f[a+16>>2]|0,I);I=a+20|0;f[I>>2]=(f[I>>2]|0)+1}if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);x=1;u=e;return x|0}I=G+16|0;if(JEb(a,I,c)|0){zpb(m,2,465938,109);xpb(n,vpb(wpb(vpb(wpb(vpb(m,466166)|0,c)|0,466180)|0,I)|0,476219)|0);Apb(m);x=0;u=e;return x|0}m=f[G+4>>2]|0;if(!m){I=G+8|0;n=f[I>>2]|0;if((f[n>>2]|0)==(G|0))J=n;else{n=I;do{I=f[n>>2]|0;n=I+8|0;G=f[n>>2]|0}while((f[G>>2]|0)!=(I|0));J=G}}else{n=m;while(1){m=f[n>>2]|0;if(!m)break;else n=m}J=n}n=J;if((J|0)!=(k|0)?(k=J+16|0,JEb(a,c,k)|0):0){zpb(o,2,465938,122);xpb(p,vpb(wpb(vpb(wpb(vpb(o,466166)|0,c)|0,466180)|0,k)|0,476219)|0);Apb(o);x=0;u=e;return x|0}X5b(q,c);c=q+12|0;o=d;d=f[o+4>>2]|0;k=c;f[k>>2]=f[o>>2];f[k+4>>2]=d;f[j>>2]=n;f[g>>2]=f[j>>2];j=XEb(H,g,h,i,q)|0;if(!(f[j>>2]|0)){i=L5b(36)|0;X5b(i+16|0,q);g=c;c=f[g+4>>2]|0;n=i+28|0;f[n>>2]=f[g>>2];f[n+4>>2]=c;c=f[h>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=c;f[j>>2]=i;c=f[f[H>>2]>>2]|0;if(!c)K=i;else{f[H>>2]=c;K=f[j>>2]|0}mP(f[a+16>>2]|0,K);K=a+20|0;f[K>>2]=(f[K>>2]|0)+1}if((b[q+11>>0]|0)<0)O5b(f[q>>2]|0);x=1;u=e;return x|0}function SEb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;i=b+52|0;a:do if((f[i>>2]|0)>0){j=b+60|0;k=c;l=f[k>>2]|0;m=f[k+4>>2]|0;k=0;while(1){n=f[(f[j>>2]|0)+4+(k<<2)>>2]|0;o=g;f[o>>2]=l;f[o+4>>2]=m;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];k=k+1|0;if(!(SEb(a,n,e)|0)){p=0;break}if((k|0)>=(f[i>>2]|0))break a}u=d;return p|0}while(0);i=b+36|0;if((f[i>>2]|0)<=0){p=1;u=d;return p|0}g=b+44|0;b=c;c=f[b>>2]|0;k=f[b+4>>2]|0;b=0;while(1){m=f[(f[g>>2]|0)+4+(b<<2)>>2]|0;l=h;f[l>>2]=c;f[l+4>>2]=k;f[e>>2]=f[h>>2];f[e+4>>2]=f[h+4>>2];b=b+1|0;if(!(TEb(a,m,e)|0)){p=0;q=9;break}if((b|0)>=(f[i>>2]|0)){p=1;q=9;break}}if((q|0)==9){u=d;return p|0}return 0}function TEb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+96|0;g=e+56|0;h=e+40|0;i=e+24|0;j=e;k=c+24|0;l=f[k>>2]|0;m=b[l+11>>0]|0;n=m<<24>>24<0;if(n)o=f[l+4>>2]|0;else o=m&255;if(!o){p=1;u=e;return p|0}if(n)q=f[l>>2]|0;else q=l;if((b[q>>0]|0)!=46){p=1;u=e;return p|0}Y5b(i,l,1,-1,l);l=c+40|0;q=f[l>>2]|0;X5b(h,i);n=h+12|0;f[n>>2]=q;X5b(g,h);f[g+12>>2]=f[n>>2];n=d;d=f[n+4>>2]|0;q=g+16|0;f[q>>2]=f[n>>2];f[q+4>>2]=d;d=UEb(a+24|0,g)|0;if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);if(d){p=1;u=e;return p|0}zpb(j,2,465938,160);d=vpb(j,466073)|0;i=vpb(wpb(d,f[k>>2]|0)|0,475688)|0;k=vpb(wpb(i,f[c+16>>2]|0)|0,466137)|0;xpb(e+80|0,vpb(ypb(k,f[l>>2]|0)|0,466141)|0);Apb(j);p=0;u=e;return p|0}function UEb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=VEb(a,d,b)|0;if(f[e>>2]|0){g=0;u=c;return g|0}h=L5b(40)|0;X5b(h+16|0,b);f[h+28>>2]=f[b+12>>2];i=b+16|0;b=f[i+4>>2]|0;j=h+32|0;f[j>>2]=f[i>>2];f[j+4>>2]=b;b=f[d>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=b;f[e>>2]=h;b=f[f[a>>2]>>2]|0;if(!b)k=h;else{f[a>>2]=b;k=f[e>>2]|0}mP(f[a+4>>2]|0,k);k=a+8|0;f[k>>2]=(f[k>>2]|0)+1;g=1;u=c;return g|0}function VEb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=f[d+12>>2]|0;k=i?f[d>>2]|0:d;d=a+4|0;a=g;a:while(1){g=a+16|0;i=b[g+11>>0]|0;l=i<<24>>24<0;m=l?f[a+20>>2]|0:i&255;i=m>>>0<j>>>0;n=i?m:j;o=(n|0)==0;if(!o?(p=ZVb(k,l?f[g>>2]|0:g,n)|0,(p|0)!=0):0)if((p|0)<0)q=13;else q=8;else if(j>>>0<m>>>0)q=13;else q=8;do if((q|0)==8){q=0;p=j>>>0<m>>>0;r=p?j:m;s=(r|0)==0;if(!s?(t=ZVb(l?f[g>>2]|0:g,k,r)|0,(t|0)!=0):0)if((t|0)<0)q=16;else q=12;else if(i)q=15;else q=12;if((q|0)==12){q=0;if((e|0)<(f[a+28>>2]|0)){q=13;break}else q=15}if((q|0)==15){q=0;if(s)q=17;else q=16}if((q|0)==16){q=0;s=ZVb(l?f[g>>2]|0:g,k,r)|0;if(s){if((s|0)>=0)q=19}else q=17}if((q|0)==17?(q=0,!i):0)q=19;if((q|0)==19){q=0;if(!o?(s=ZVb(k,l?f[g>>2]|0:g,n)|0,(s|0)!=0):0){if((s|0)<0){q=26;break a}}else q=21;if((q|0)==21?(q=0,p):0){q=26;break a}if((f[a+28>>2]|0)>=(e|0)){q=26;break a}}u=a+4|0;p=f[u>>2]|0;if(!p){q=25;break a}else{v=u;w=p}}while(0);if((q|0)==13){q=0;n=f[a>>2]|0;if(!n){q=14;break}else{v=a;w=n}}d=v;a=w}if((q|0)==14){f[c>>2]=a;h=a;return h|0}else if((q|0)==25){f[c>>2]=a;h=u;return h|0}else if((q|0)==26){f[c>>2]=a;h=d;return h|0}return 0}function WEb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=ZVb(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=ZVb(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function XEb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=a+4|0;i=f[c>>2]|0;c=i;do if((i|0)!=(h|0)){j=i+16|0;k=b[j+11>>0]|0;l=k<<24>>24<0;m=l?f[i+20>>2]|0:k&255;k=b[g+11>>0]|0;n=k<<24>>24<0;o=n?f[g+4>>2]|0:k&255;k=m>>>0<o>>>0;p=k?m:o;if((p|0)!=0?(q=ZVb(n?f[g>>2]|0:g,l?f[j>>2]|0:j,p)|0,(q|0)!=0):0){if((q|0)<0)break}else r=4;if((r|0)==4?o>>>0<m>>>0:0)break;q=o>>>0<m>>>0?o:m;if((q|0)!=0?(m=ZVb(l?f[j>>2]|0:j,n?f[g>>2]|0:g,q)|0,(m|0)!=0):0){if((m|0)>=0)r=36}else r=20;if((r|0)==20?!k:0)r=36;if((r|0)==36){f[d>>2]=c;f[e>>2]=c;s=e;return s|0}k=i+4|0;m=f[k>>2]|0;if(!m){q=i+8|0;j=f[q>>2]|0;if((f[j>>2]|0)==(i|0))t=j;else{j=q;do{q=f[j>>2]|0;j=q+8|0;l=f[j>>2]|0}while((f[l>>2]|0)!=(q|0));t=l}}else{j=m;while(1){l=f[j>>2]|0;if(!l)break;else j=l}t=j}do if((t|0)!=(h|0)){m=t+16|0;l=b[m+11>>0]|0;q=l<<24>>24<0;p=q?f[t+20>>2]|0:l&255;l=p>>>0<o>>>0?p:o;if((l|0)!=0?(u=ZVb(n?f[g>>2]|0:g,q?f[m>>2]|0:m,l)|0,(u|0)!=0):0){if((u|0)<0)break}else r=30;if((r|0)==30?o>>>0<p>>>0:0)break;s=WEb(a,d,g)|0;return s|0}while(0);if(!(f[i+4>>2]|0)){f[d>>2]=c;s=k;return s|0}else{f[d>>2]=t;s=t;return s|0}}while(0);t=f[i>>2]|0;do if((i|0)==(f[a>>2]|0))v=c;else{if(!t){h=i;while(1){e=f[h+8>>2]|0;if((f[e>>2]|0)==(h|0))h=e;else{w=e;break}}}else{h=t;while(1){k=f[h+4>>2]|0;if(!k){w=h;break}else h=k}}h=w;k=w+16|0;e=b[g+11>>0]|0;o=e<<24>>24<0;n=o?f[g+4>>2]|0:e&255;e=b[k+11>>0]|0;j=e<<24>>24<0;p=j?f[w+20>>2]|0:e&255;e=n>>>0<p>>>0?n:p;if((e|0)!=0?(u=ZVb(j?f[k>>2]|0:k,o?f[g>>2]|0:g,e)|0,(u|0)!=0):0){if((u|0)<0){v=h;break}}else r=12;if((r|0)==12?p>>>0<n>>>0:0){v=h;break}s=WEb(a,d,g)|0;return s|0}while(0);if(!t){f[d>>2]=i;s=i;return s|0}else{i=v;f[d>>2]=i;s=i+4|0;return s|0}return 0}function YEb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f[a>>2]=139524;c=a+4|0;d=f[c>>2]|0;e=f[d+28>>2]|0;g=a+(f[d+12>>2]|0)|0;if(!(f[g>>2]|0))h=d;else{GPb(g);h=f[c>>2]|0}g=f[h+16>>2]|0;if((g|0)!=-1)tQb(a+g|0);g=e+24|0;h=f[g>>2]|0;if((h|0)<=0)return;d=e+28|0;e=0;i=h;do{h=f[d>>2]|0;j=h+(e*88|0)|0;k=f[h+(e*88|0)+52>>2]|0;l=f[c>>2]|0;a:do if(k){m=(k-(f[(f[k+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[a+((m<<2)+(f[l+8>>2]|0))>>2]|0)==(f[h+(e*88|0)+28>>2]|0)){n=f[l+32>>2]|0;o=a+(f[n+(m+i<<2)>>2]|0)|0;switch(f[136e3+(f[h+(e*88|0)+32>>2]<<2)>>2]|0){case 9:break;case 10:{m=f[o>>2]|0;if(!m)break a;bi[f[(f[m>>2]|0)+4>>2]&2047](m);break a;break}default:break a}m=f[(f[l+44>>2]|0)+(f[n+(e<<2)>>2]|0)>>2]|0;n=f[o>>2]|0;if(!((n|0)==(m|0)|(n|0)==0)){if((b[n+11>>0]|0)<0)O5b(f[n>>2]|0);O5b(n)}f[o>>2]=m}}else{m=f[(f[l+32>>2]|0)+(e<<2)>>2]|0;o=a+m|0;n=f[136e3+(f[h+(e*88|0)+32>>2]<<2)>>2]|0;if((f[h+(e*88|0)+36>>2]|0)!=3){switch(n|0){case 9:break;case 10:{p=f[l+40>>2]|0;if((p|0)==(a|0)|(p|0)==0)break a;p=f[o>>2]|0;if(!p)break a;bi[f[(f[p>>2]|0)+4>>2]&2047](p);break a;break}default:break a}p=f[(f[l+40>>2]|0)+m>>2]|0;m=f[o>>2]|0;if(!((m|0)==(p|0)|(m|0)==0)){if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);O5b(m)}f[o>>2]=p;break}do switch(n|0){case 1:{p=f[o+8>>2]|0;if(!p)break a;if(f[p>>2]|0)break a;O5b(p);break a;break}case 2:{p=f[o+8>>2]|0;if(!p)break a;if(f[p>>2]|0)break a;O5b(p);break a;break}case 3:{p=f[o+8>>2]|0;if(!p)break a;if(f[p>>2]|0)break a;O5b(p);break a;break}case 4:{p=f[o+8>>2]|0;if(!p)break a;if(f[p>>2]|0)break a;O5b(p);break a;break}case 5:{p=f[o+8>>2]|0;if(!p)break a;if(f[p>>2]|0)break a;O5b(p);break a;break}case 6:{p=f[o+8>>2]|0;if(!p)break a;if(f[p>>2]|0)break a;O5b(p);break a;break}case 7:{p=f[o+8>>2]|0;if(!p)break a;if(f[p>>2]|0)break a;O5b(p);break a;break}case 8:{p=f[o+8>>2]|0;if(!p)break a;if(f[p>>2]|0)break a;O5b(p);break a;break}case 9:{p=o+12|0;m=f[p>>2]|0;if(m|0?(f[o>>2]|0)==0:0){q=f[m>>2]|0;if((q|0)>0){r=0;do{s=f[m+4+(r<<2)>>2]|0;if(s|0){if((b[s+11>>0]|0)<0)O5b(f[s>>2]|0);O5b(s)}r=r+1|0}while((r|0)!=(q|0));t=f[p>>2]|0}else t=m;O5b(t)}f[p>>2]=0;break a;break}case 10:{if(xub(j)|0){bi[f[f[o>>2]>>2]&2047](o);break a}q=o+12|0;r=f[q>>2]|0;if(r|0?(f[o>>2]|0)==0:0){s=f[r>>2]|0;if((s|0)>0){u=0;do{v=f[r+4+(u<<2)>>2]|0;if(v|0)bi[f[(f[v>>2]|0)+4>>2]&2047](v);u=u+1|0}while((u|0)!=(s|0));w=f[q>>2]|0}else w=r;O5b(w)}f[q>>2]=0;break a;break}default:break a}while(0)}while(0);e=e+1|0;i=f[g>>2]|0}while((e|0)<(i|0));return}function ZEb(a){a=a|0;YEb(a);O5b(a);return}function _Eb(a){a=a|0;var b=0,c=0;b=a+4|0;a=L5b(f[f[b>>2]>>2]|0)|0;c=f[b>>2]|0;Nac(a|0,0,f[c>>2]|0)|0;f[a>>2]=139524;f[a+4>>2]=c;f[a+8>>2]=0;fFb(a);return a|0}function $Eb(a,b){a=a|0;b=b|0;var c=0;c=di[f[(f[a>>2]|0)+12>>2]&1023](a)|0;if(!b)return c|0;eFb(b,c);return c|0}function aFb(a){a=a|0;return 0}function bFb(a){a=a|0;return f[a+8>>2]|0}function cFb(a,b){a=a|0;b=b|0;f[a+8>>2]=b;return}function dFb(a,b){a=a|0;b=b|0;var c=0;c=f[b+4>>2]|0;f[a>>2]=f[c+28>>2];f[a+4>>2]=f[c+36>>2];return}function eFb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function fFb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[d+28>>2]|0;g=e+32|0;if((f[g>>2]|0)>0){h=0;i=d;while(1){f[a+((f[i+8>>2]|0)+(h<<2))>>2]=0;h=h+1|0;j=f[c>>2]|0;if((h|0)>=(f[g>>2]|0)){k=j;break}else i=j}}else k=d;f[a+(f[k+12>>2]|0)>>2]=0;k=f[(f[c>>2]|0)+16>>2]|0;if((k|0)!=-1)sQb(a+k|0);k=e+24|0;if((f[k>>2]|0)<=0)return;d=e+28|0;e=0;do{i=f[d>>2]|0;g=i+(e*88|0)|0;h=f[c>>2]|0;j=f[(f[h+32>>2]|0)+(e<<2)>>2]|0;l=a+j|0;a:do if(!(f[i+(e*88|0)+52>>2]|0))do switch(f[136e3+(f[i+(e*88|0)+32>>2]<<2)>>2]|0){case 1:{if((f[i+(e*88|0)+36>>2]|0)==3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;break a}else{f[l>>2]=f[i+(e*88|0)+80>>2];break a}break}case 2:{if((f[i+(e*88|0)+36>>2]|0)==3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;break a}else{m=i+(e*88|0)+80|0;n=f[m+4>>2]|0;o=l;f[o>>2]=f[m>>2];f[o+4>>2]=n;break a}break}case 3:{if((f[i+(e*88|0)+36>>2]|0)==3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;break a}else{f[l>>2]=f[i+(e*88|0)+80>>2];break a}break}case 4:{if((f[i+(e*88|0)+36>>2]|0)==3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;break a}else{n=i+(e*88|0)+80|0;o=f[n+4>>2]|0;m=l;f[m>>2]=f[n>>2];f[m+4>>2]=o;break a}break}case 5:{if((f[i+(e*88|0)+36>>2]|0)==3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;break a}else{p[l>>3]=+p[i+(e*88|0)+80>>3];break a}break}case 6:{if((f[i+(e*88|0)+36>>2]|0)==3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;break a}else{f[l>>2]=f[i+(e*88|0)+80>>2];break a}break}case 7:{if((f[i+(e*88|0)+36>>2]|0)==3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;break a}else{b[l>>0]=b[i+(e*88|0)+80>>0]|0;break a}break}case 8:{if((f[i+(e*88|0)+36>>2]|0)==3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;break a}else{f[l>>2]=f[(f[i+(e*88|0)+80>>2]|0)+8>>2];break a}break}case 9:{if((f[i+(e*88|0)+36>>2]|0)==3){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;break a}else{o=f[h+40>>2]|0;f[l>>2]=f[((o|0)==(a|0)|(o|0)==0?i+(e*88|0)+80|0:o+j|0)>>2];break a}break}case 10:{if((f[i+(e*88|0)+36>>2]|0)!=3){f[l>>2]=0;break a}if(xub(g)|0){uKb(l,gFb(f[(f[c>>2]|0)+20>>2]|0,f[i+(e*88|0)+60>>2]|0)|0);break a}else{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;break a}break}default:break a}while(0);while(0);e=e+1|0}while((e|0)<(f[k>>2]|0));return}function gFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=u;u=u+48|0;e=d+8|0;g=d+32|0;h=d;f[h>>2]=c;if(b[a+8>>0]|0?(i=f[(f[c+8>>2]|0)+8>>2]|0,(i|0)==(drb()|0)):0){i=LNb()|0;j=Uh[f[(f[i>>2]|0)+8>>2]&1023](i,c)|0;u=d;return j|0}c=hFb(f[a+12>>2]|0,h)|0;i=f[c>>2]|0;if(i|0){j=f[i+40>>2]|0;u=d;return j|0}i=L5b(48)|0;k=i+32|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[c>>2]=i;c=f[h>>2]|0;l=i+28|0;f[l>>2]=c;m=f[a+4>>2]|0;if(!m)n=f[(f[c+8>>2]|0)+8>>2]|0;else n=m;m=i+24|0;f[m>>2]=n;f[i+20>>2]=a;n=(f[c+32>>2]|0)+(f[c+24>>2]|0)|0;o=N5b(n>>>0>1073741823?-1:n<<2)|0;n=f[k>>2]|0;if((n|0)==(o|0))p=c;else{if(!n)q=c;else{P5b(n);q=f[h>>2]|0}f[k>>2]=o;p=q}q=i+4|0;if((f[(f[p+8>>2]|0)+64>>2]|0)==3){f[q>>2]=-1;r=16}else{f[q>>2]=16;n=((((f[p+24>>2]|0)+31|0)/32|0)<<2)+23|0;r=n-((n|0)%8|0)|0}n=f[p+32>>2]|0;if((n|0)>0){f[i+8>>2]=r;c=r+7+(n<<2)|0;s=c-((c|0)%8|0)|0}else s=r;r=i+16|0;if((f[p+56>>2]|0)>0){f[r>>2]=s;c=s+23|0;t=c-((c|0)%8|0)|0}else{f[r>>2]=-1;t=s}s=f[p+24>>2]|0;if((s|0)>0){c=0;v=t;w=p;while(1){x=f[w+28>>2]|0;y=x+(c*88|0)|0;if(!(f[x+(c*88|0)+52>>2]|0)){z=f[136e3+(f[x+(c*88|0)+32>>2]<<2)>>2]|0;a:do if((f[x+(c*88|0)+36>>2]|0)==3)switch(z|0){case 8:case 7:case 6:case 5:case 4:case 3:case 2:case 1:{A=12;break a;break}case 10:{B=xub(y)|0;A=B?48:16;break a;break}case 9:{A=16;break a;break}default:{C=35;break a}}else switch(z|0){case 9:case 10:case 8:case 6:case 3:case 1:{A=4;break a;break}case 2:{A=8;break a;break}case 4:{A=8;break a;break}case 5:{A=8;break a;break}case 7:{A=1;break a;break}default:{C=35;break a}}while(0);if((C|0)==35){C=0;zpb(e,2,466292,161);xpb(g,vpb(e,477853)|0);Apb(e);A=0}z=A>>>0<8?A:8;y=v+-1+z|0;x=y-((y|0)%(z|0)|0)|0;f[o+(c<<2)>>2]=x;D=x+A|0;E=f[h>>2]|0}else{D=v;E=w}c=c+1|0;F=f[E+24>>2]|0;if((c|0)>=(F|0))break;else{v=D;w=E}}G=D;H=E;I=f[E+32>>2]|0;J=F}else{G=t;H=p;I=n;J=s}s=H+32|0;n=G+7|0;G=n-((n|0)%8|0)|0;if((I|0)>0){I=H+24|0;f[o+(J<<2)>>2]=G;J=G+15|0;H=J-((J|0)%8|0)|0;if((f[s>>2]|0)>1){J=1;n=H;while(1){f[o+((f[I>>2]|0)+J<<2)>>2]=n;J=J+1|0;p=n+15|0;t=p-((p|0)%8|0)|0;if((J|0)>=(f[s>>2]|0)){K=t;break}else n=t}}else K=H}else K=G;G=i+12|0;f[G>>2]=K;H=K+11|0;K=H-((H|0)%8|0)|0;f[i>>2]=K;H=L5b(K)|0;Nac(H|0,0,K|0)|0;K=i+40|0;f[K>>2]=H;f[H>>2]=139524;f[H+4>>2]=i;f[H+8>>2]=0;fFb(H);n=f[h>>2]|0;if((f[n+32>>2]|0)>0){s=0;J=0;I=n;while(1){n=f[I+36>>2]|0;b:do if((f[n+(s*28|0)+16>>2]|0)>0){t=0;p=J;F=n;while(1){E=f[(f[F+(s*28|0)+20>>2]|0)+(t<<2)>>2]|0;switch(f[136e3+(f[E+32>>2]<<2)>>2]|0){case 9:case 10:case 8:case 6:case 3:case 1:{L=4;break}case 2:{L=8;break}case 4:{L=8;break}case 5:{L=8;break}case 7:{L=1;break}default:{zpb(e,2,466292,191);xpb(g,vpb(e,477853)|0);Apb(e);L=0}}D=L>>>0<8?L:8;w=p+-1+D|0;v=w-((w|0)%(D|0)|0)|0;D=E;do if(b[E+40>>0]|0){w=f[E+56>>2]|0;if(!w){M=(f[E+24>>2]|0)+72|0;break}else{M=w+68|0;break}}else M=(f[E+48>>2]|0)+28|0;while(0);f[o+(((D-(f[M>>2]|0)|0)/88|0)<<2)>>2]=v;E=v+L|0;t=t+1|0;w=f[h>>2]|0;F=f[w+36>>2]|0;if((t|0)>=(f[F+(s*28|0)+16>>2]|0)){N=E;O=w;break b}else p=E}}else{N=J;O=I}while(0);s=s+1|0;if((s|0)>=(f[O+32>>2]|0))break;else{J=N;I=O}}O=L5b(N)|0;N=i+44|0;f[N>>2]=O;iFb(f[l>>2]|0,f[k>>2]|0,O);O=L5b(52)|0;nIb(O,f[l>>2]|0,f[K>>2]|0,f[k>>2]|0,f[q>>2]|0,f[G>>2]|0,f[r>>2]|0,f[N>>2]|0,f[i+8>>2]|0,f[m>>2]|0,a,f[i>>2]|0,-1);N=i+36|0;I=f[N>>2]|0;if((I|0)!=(O|0)){if(I|0)bi[f[(f[I>>2]|0)+4>>2]&2047](I);f[N>>2]=O}}else{O=L5b(52)|0;mIb(O,f[l>>2]|0,f[K>>2]|0,f[k>>2]|0,f[q>>2]|0,f[G>>2]|0,f[r>>2]|0,f[m>>2]|0,a,f[i>>2]|0,-1);a=i+36|0;i=f[a>>2]|0;if((i|0)!=(O|0)){if(i|0)bi[f[(f[i>>2]|0)+4>>2]&2047](i);f[a>>2]=O}}jFb(H);j=H;u=d;return j|0}function hFb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+16|0;d=c;e=f[b>>2]|0;b=f[a+4>>2]|0;g=e;a:do if(b|0){h=b+-1|0;i=(h&b|0)==0;if(!i)if(e>>>0<b>>>0)j=e;else j=(e>>>0)%(b>>>0)|0;else j=h&e;k=f[(f[a>>2]|0)+(j<<2)>>2]|0;if(k|0?(l=f[k>>2]|0,l|0):0){b:do if(i){k=l;while(1){m=f[k+4>>2]|0;n=(m|0)==(e|0);if(!(n|(m&h|0)==(j|0)))break a;if(n?(f[k+8>>2]|0)==(g|0):0){o=k;break b}k=f[k>>2]|0;if(!k)break a}}else{k=l;while(1){n=f[k+4>>2]|0;if((n|0)==(e|0)){if((f[k+8>>2]|0)==(g|0)){o=k;break b}}else{if(n>>>0<b>>>0)p=n;else p=(n>>>0)%(b>>>0)|0;if((p|0)!=(j|0))break a}k=f[k>>2]|0;if(!k)break a}}while(0);q=o;r=q+12|0;u=c;return r|0}}while(0);o=L5b(16)|0;f[o+8>>2]=e;f[o+12>>2]=0;kFb(d,a,o);q=f[d>>2]|0;r=q+12|0;u=c;return r|0}function iFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0;e=a+32|0;if((f[e>>2]|0)<=0)return;g=a+36|0;a=0;h=f[g>>2]|0;while(1){a:do if((f[h+(a*28|0)+16>>2]|0)>0){i=0;j=h;while(1){k=f[(f[j+(a*28|0)+20>>2]|0)+(i<<2)>>2]|0;l=k;do if(b[k+40>>0]|0){m=f[k+56>>2]|0;if(!m){n=(f[k+24>>2]|0)+72|0;break}else{n=m+68|0;break}}else n=(f[k+48>>2]|0)+28|0;while(0);m=d+(f[c+(((l-(f[n>>2]|0)|0)/88|0)<<2)>>2]|0)|0;do switch(f[136e3+(f[k+32>>2]<<2)>>2]|0){case 1:{f[m>>2]=f[k+80>>2];break}case 2:{o=k+80|0;q=f[o+4>>2]|0;r=m;f[r>>2]=f[o>>2];f[r+4>>2]=q;break}case 3:{f[m>>2]=f[k+80>>2];break}case 4:{q=k+80|0;r=f[q+4>>2]|0;o=m;f[o>>2]=f[q>>2];f[o+4>>2]=r;break}case 5:{p[m>>3]=+p[k+80>>3];break}case 6:{f[m>>2]=f[k+80>>2];break}case 7:{b[m>>0]=b[k+80>>0]|0;break}case 8:{f[m>>2]=f[(f[k+80>>2]|0)+8>>2];break}case 9:{f[m>>2]=0;f[m>>2]=f[k+80>>2];break}case 10:{f[m>>2]=0;break}default:{}}while(0);i=i+1|0;m=f[g>>2]|0;if((i|0)>=(f[m+(a*28|0)+16>>2]|0)){s=m;break a}else j=m}}else s=h;while(0);a=a+1|0;if((a|0)>=(f[e>>2]|0))break;else h=s}return}function jFb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;b=u;u=u+32|0;c=b;d=a+4|0;e=f[d>>2]|0;g=f[e+40>>2]|0;if((g|0)==(a|0)|(g|0)==0)h=e;else{zpb(c,3,466292,529);xpb(b+24|0,vpb(c,466389)|0);Apb(c);h=f[d>>2]|0}c=f[h+20>>2]|0;e=f[h+28>>2]|0;g=e+24|0;i=f[g>>2]|0;if((i|0)<=0){u=b;return}j=e+28|0;e=0;k=h;h=i;while(1){i=f[j>>2]|0;if(!(f[i+(e*88|0)+52>>2]|0))l=a;else l=f[k+44>>2]|0;m=l+(f[(f[k+32>>2]|0)+(e<<2)>>2]|0)|0;if((f[136e3+(f[i+(e*88|0)+32>>2]<<2)>>2]|0)==10?(f[i+(e*88|0)+36>>2]|0)!=3:0){n=gFb(c,f[i+(e*88|0)+60>>2]|0)|0;f[m>>2]=n;o=f[g>>2]|0}else o=h;n=e+1|0;if((n|0)>=(o|0))break;e=n;k=f[d>>2]|0;h=o}u=b;return}function kFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0,D=0;e=f[d+8>>2]|0;g=d+4|0;f[g>>2]=e;h=c+4|0;i=f[h>>2]|0;j=(i|0)==0;k=e;a:do if(!j){l=i+-1|0;m=(l&i|0)==0;if(!m)if(e>>>0<i>>>0)o=e;else o=(e>>>0)%(i>>>0)|0;else o=l&e;p=f[(f[c>>2]|0)+(o<<2)>>2]|0;if(!p)q=o;else{if(m){m=p;while(1){r=f[m>>2]|0;if(!r){q=o;break a}if((f[r+4>>2]&l|0)!=(o|0)){q=o;break a}if((f[r+8>>2]|0)==(k|0)){s=0;t=r;break}else m=r}u=t;f[a>>2]=u;v=a+4|0;b[v>>0]=s;return}else w=p;while(1){m=f[w>>2]|0;if(!m){q=o;break a}l=f[m+4>>2]|0;if(l>>>0<i>>>0)x=l;else x=(l>>>0)%(i>>>0)|0;if((x|0)!=(o|0)){q=o;break a}if((f[m+8>>2]|0)==(k|0)){s=0;t=m;break}else w=m}u=t;f[a>>2]=u;v=a+4|0;b[v>>0]=s;return}}else q=0;while(0);w=c+12|0;y=+(((f[w>>2]|0)+1|0)>>>0);z=+n[c+16>>2];do if(j|y>+(i>>>0)*z){k=(i>>>0<3|(i+-1&i|0)!=0)&1|i<<1;o=~~+X(+(y/z))>>>0;lFb(c,k>>>0<o>>>0?o:k);k=f[h>>2]|0;o=f[g>>2]|0;x=k+-1|0;if(!(x&k)){A=k;B=x&o;break}if(o>>>0<k>>>0){A=k;B=o}else{A=k;B=(o>>>0)%(k>>>0)|0}}else{A=i;B=q}while(0);q=f[(f[c>>2]|0)+(B<<2)>>2]|0;if(!q){i=c+8|0;f[d>>2]=f[i>>2];f[i>>2]=d;f[(f[c>>2]|0)+(B<<2)>>2]=i;i=f[d>>2]|0;if(!i)C=d;else{B=f[i+4>>2]|0;i=A+-1|0;if(i&A)if(B>>>0<A>>>0)D=B;else D=(B>>>0)%(A>>>0)|0;else D=B&i;f[(f[c>>2]|0)+(D<<2)>>2]=d;C=d}}else{f[d>>2]=f[q>>2];f[q>>2]=d;C=d}f[w>>2]=(f[w>>2]|0)+1;s=1;t=C;u=t;f[a>>2]=u;v=a+4|0;b[v>>0]=s;return}function lFb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=yWb(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){mFb(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+12>>2]|0)>>>0)/+n[a+16>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=yWb(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;mFb(a,d);return}function mFb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=(b|0)!=0;do if(c)if(b>>>0>1073741823){d=ze(8)|0;T5b(d,477177);f[d>>2]=149528;If(d|0,25408,1411)}else{e=L5b(b<<2)|0;break}else e=0;while(0);d=f[a>>2]|0;f[a>>2]=e;if(d|0)O5b(d);f[a+4>>2]=b;if(c)g=0;else return;do{f[(f[a>>2]|0)+(g<<2)>>2]=0;g=g+1|0}while((g|0)!=(b|0));g=a+8|0;c=f[g>>2]|0;if(!c)return;d=f[c+4>>2]|0;e=b+-1|0;h=(e&b|0)==0;if(!h)if(d>>>0<b>>>0)i=d;else i=(d>>>0)%(b>>>0)|0;else i=d&e;f[(f[a>>2]|0)+(i<<2)>>2]=g;g=f[c>>2]|0;if(!g)return;else{j=i;k=c;l=g;m=c}a:while(1){b:do if(h){c=k;g=l;i=m;while(1){d=g;while(1){n=f[d+4>>2]&e;if((n|0)==(j|0))break;o=(f[a>>2]|0)+(n<<2)|0;if(!(f[o>>2]|0)){p=d;q=i;r=o;s=n;break b}o=d+8|0;t=d;while(1){u=f[t>>2]|0;if(!u)break;if((f[o>>2]|0)==(f[u+8>>2]|0))t=u;else break}f[i>>2]=u;f[t>>2]=f[f[(f[a>>2]|0)+(n<<2)>>2]>>2];f[f[(f[a>>2]|0)+(n<<2)>>2]>>2]=d;o=f[c>>2]|0;if(!o){v=35;break a}else d=o}g=f[d>>2]|0;if(!g){v=35;break a}else{c=d;i=d}}}else{i=k;c=l;g=m;while(1){o=c;while(1){w=f[o+4>>2]|0;if(w>>>0<b>>>0)x=w;else x=(w>>>0)%(b>>>0)|0;if((x|0)==(j|0))break;w=(f[a>>2]|0)+(x<<2)|0;if(!(f[w>>2]|0)){p=o;q=g;r=w;s=x;break b}w=o+8|0;y=o;while(1){z=f[y>>2]|0;if(!z)break;if((f[w>>2]|0)==(f[z+8>>2]|0))y=z;else break}f[g>>2]=z;f[y>>2]=f[f[(f[a>>2]|0)+(x<<2)>>2]>>2];f[f[(f[a>>2]|0)+(x<<2)>>2]>>2]=o;w=f[i>>2]|0;if(!w){v=35;break a}else o=w}c=f[o>>2]|0;if(!c){v=35;break a}else{i=o;g=o}}}while(0);f[r>>2]=q;l=f[p>>2]|0;if(!l){v=35;break}else{j=s;k=p;m=p}}if((v|0)==35)return}function nFb(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=139632;b=a+12|0;c=f[(f[b>>2]|0)+8>>2]|0;if(c|0){d=c;do{c=f[d+12>>2]|0;if(c|0){qFb(c);O5b(c)}d=f[d>>2]|0}while((d|0)!=0)}Cpb(a+16|0);a=f[b>>2]|0;if(!a)return;b=f[a+8>>2]|0;if(b|0){d=b;do{b=d;d=f[d>>2]|0;O5b(b)}while((d|0)!=0)}d=f[a>>2]|0;f[a>>2]=0;if(d|0)O5b(d);O5b(a);return}function oFb(a){a=a|0;nFb(a);O5b(a);return}function pFb(a,b){a=a|0;b=b|0;var c=0,d=0;c=a+16|0;npb(c);d=gFb(a,b)|0;opb(c);return d|0}function qFb(a){a=a|0;var b=0;b=f[a+40>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);O5b(f[a+44>>2]|0);b=f[a+36>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);b=f[a+32>>2]|0;if(!b)return;P5b(b);return}function rFb(a){a=a|0;var c=0;f[a>>2]=139632;f[a+4>>2]=0;b[a+8>>0]=0;c=L5b(20)|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;n[c+16>>2]=1.0;f[a+12>>2]=c;Bpb(a+16|0);return}function sFb(a){a=a|0;O5b(a);return}function tFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+32|0;g=e;h=mub(f[a+4>>2]|0,f[a+12>>2]|0,c)|0;if(!h){i=0;u=e;return i|0}c=f[h+32>>2]|0;b[d>>0]=c;b[d+1>>0]=(f[h+36>>2]|0)==3&1;b[d+2>>0]=b[(f[h+68>>2]|0)+56>>0]|0;f[d+12>>2]=h;switch(f[136e3+(c<<2)>>2]|0){case 10:{c=f[a+8>>2]|0;a=Uh[f[(f[c>>2]|0)+8>>2]&1023](c,f[h+60>>2]|0)|0;f[d+4>>2]=a;if(a|0){i=1;u=e;return i|0}zpb(g,3,466497,300);xpb(e+24|0,wpb(vpb(vpb(g,466598)|0,466648)|0,f[h+4>>2]|0)|0);Apb(g);i=1;u=e;return i|0}case 8:{f[d+4>>2]=562;f[d+8>>2]=f[h+64>>2];i=1;u=e;return i|0}default:{i=1;u=e;return i|0}}return 0}function uFb(a,b){a=a|0;b=b|0;return (tub(a,b)|0)!=0|0}function vFb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+16|0;h=g;i=f[a>>2]|0;j=a+4|0;if((i|0)==(j|0)){u=g;return}a=e+4|0;k=e+8|0;l=i;while(1){i=l+16|0;if(!(b[i+17>>0]|0)){if(!(b[i+18>>0]&1))m=7}else if((xQb(l+24|0)|0)>0)m=7;do if((m|0)==7){m=0;n=l+40|0;o=f[n>>2]|0;p=o;if(o|0){o=f[a>>2]|0;if((o|0)==(f[k>>2]|0)){ksb(e,n);break}else{f[o>>2]=p;f[a>>2]=(f[a>>2]|0)+4;break}}p=mub(d,c,f[i>>2]|0)|0;f[h>>2]=p;o=f[a>>2]|0;if((o|0)==(f[k>>2]|0))ksb(e,h);else{f[o>>2]=p;f[a>>2]=(f[a>>2]|0)+4}}while(0);i=f[l+4>>2]|0;if(!i){p=l+8|0;o=f[p>>2]|0;if((f[o>>2]|0)==(l|0))q=o;else{o=p;do{p=f[o>>2]|0;o=p+8|0;n=f[o>>2]|0}while((f[n>>2]|0)!=(p|0));q=n}}else{o=i;while(1){n=f[o>>2]|0;if(!n)break;else o=n}q=o}if((q|0)==(j|0))break;else l=q}u=g;return}function wFb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=a+4|0;a=f[g>>2]|0;if(a|0){h=g;i=a;a:while(1){a=i;while(1){if((f[a+16>>2]|0)>=(c|0))break;j=f[a+4>>2]|0;if(!j){k=h;break a}else a=j}i=f[a>>2]|0;if(!i){k=a;break}else h=a}if(((k|0)!=(g|0)?(g=k+16|0,(f[g>>2]|0)<=(c|0)):0)?(c=b[g+18>>0]|0,(c&1)==0):0){g=f[k+24>>2]|0;if(!(c&16)){l=g;return l|0}c=f[(f[g>>2]|0)+12>>2]|0;k=Uh[f[(f[e>>2]|0)+8>>2]&1023](e,d)|0;l=Uh[c&1023](g,k)|0;return l|0}}l=Uh[f[(f[e>>2]|0)+8>>2]&1023](e,d)|0;return l|0}function xFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+16|0;g=e;if(CQb(a,f[c+28>>2]|0,c,g)|0){h=f[g>>2]|0;b[h+8>>0]=f[c+32>>2];b[h+9>>0]=0;b[h+11>>0]=0;h=Uh[f[(f[d>>2]|0)+8>>2]&1023](d,f[c+60>>2]|0)|0;i=(f[g>>2]|0)+10|0;b[i>>0]=b[i>>0]&15;i=Uh[f[(f[h>>2]|0)+16>>2]&1023](h,f[a+12>>2]|0)|0;f[f[g>>2]>>2]=i;i=f[g>>2]|0;a=i+10|0;b[a>>0]=b[a>>0]&-16;j=f[i>>2]|0;u=e;return j|0}i=f[g>>2]|0;g=i+10|0;a=b[g>>0]|0;b[g>>0]=a&-16;g=f[i>>2]|0;if(!(a&16)){j=g;u=e;return j|0}a=f[(f[g>>2]|0)+16>>2]|0;i=Uh[f[(f[d>>2]|0)+8>>2]&1023](d,f[c+60>>2]|0)|0;j=Uh[a&1023](g,i)|0;u=e;return j|0}function yFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=c+28|0;g=f[e>>2]|0;h=a+4|0;i=f[h>>2]|0;if(!i){j=0;return j|0}else{k=h;l=i}a:while(1){i=l;while(1){if((f[i+16>>2]|0)>=(g|0))break;m=f[i+4>>2]|0;if(!m){n=k;break a}else i=m}l=f[i>>2]|0;if(!l){n=i;break}else k=i}if((n|0)==(h|0)){j=0;return j|0}k=n+16|0;if((g|0)<(f[k>>2]|0)){j=0;return j|0}g=n+24|0;n=f[g>>2]|0;if(b[k+18>>0]&16){k=f[(f[n>>2]|0)+32>>2]|0;l=Uh[f[(f[d>>2]|0)+8>>2]&1023](d,f[c+60>>2]|0)|0;c=Uh[k&1023](n,l)|0;if((f[a+12>>2]|0)==0?(l=f[g>>2]|0,(l|0)!=0):0){bi[f[(f[l>>2]|0)+4>>2]&2047](l);o=c}else o=c}else o=n;n=f[e>>2]|0;e=f[h>>2]|0;if(!e){j=o;return j|0}else{p=h;q=e}b:while(1){c=q;while(1){if((f[c+16>>2]|0)>=(n|0))break;l=f[c+4>>2]|0;if(!l){r=p;break b}else c=l}q=f[c>>2]|0;if(!q){r=c;break}else p=c}if((r|0)==(h|0)){j=o;return j|0}if((n|0)<(f[r+16>>2]|0)){j=o;return j|0}n=f[r+4>>2]|0;if(!n){h=r+8|0;p=f[h>>2]|0;if((f[p>>2]|0)==(r|0))s=p;else{p=h;do{h=f[p>>2]|0;p=h+8|0;q=f[p>>2]|0}while((f[q>>2]|0)!=(h|0));s=q}}else{p=n;while(1){n=f[p>>2]|0;if(!n)break;else p=n}s=p}if((f[a>>2]|0)==(r|0))f[a>>2]=s;s=a+8|0;f[s>>2]=(f[s>>2]|0)+-1;wwa(e,r);O5b(r);j=o;return j|0}function zFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+16|0;e=d;g=d+4|0;if(!(CQb(a,f[c+28>>2]|0,c,g)|0)){h=f[g>>2]|0;u=d;return h|0}i=f[g>>2]|0;b[i+8>>0]=f[c+32>>2];b[i+9>>0]=1;i=f[a+12>>2]|0;if(i){f[e>>2]=0;a=AFb(e)|0;e=znb(i,23120,16)|0;f[e>>2]=i;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if(a)j=e;else{xnb(i,e,1526);j=e}}else{e=L5b(16)|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;j=e}f[f[g>>2]>>2]=j;h=f[g>>2]|0;u=d;return h|0}function AFb(a){a=a|0;return 0}function BFb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;O5b(g);f[b>>2]=0;return}function CFb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=u;u=u+32|0;e=d;g=d+24|0;h=zFb(a,b)|0;i=f[h>>2]|0;j=f[i+12>>2]|0;if((j|0?(k=i+4|0,l=f[k>>2]|0,(l|0)<(f[j>>2]|0)):0)?(f[k>>2]=l+1,k=f[j+4+(l<<2)>>2]|0,k|0):0){m=k;u=d;return m|0}if(!(f[i+4>>2]|0)){k=Uh[f[(f[c>>2]|0)+8>>2]&1023](c,f[b+60>>2]|0)|0;if(!k){zpb(e,3,466497,265);xpb(g,vpb(e,466829)|0);Apb(e);n=k}else n=k}else n=f[(f[i+12>>2]|0)+4>>2]|0;i=Uh[f[(f[n>>2]|0)+16>>2]&1023](n,f[a+12>>2]|0)|0;DFb(f[h>>2]|0,i);m=i;u=d;return m|0}function DFb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+12|0;d=f[c>>2]|0;do if(d){e=f[d>>2]|0;g=f[a+8>>2]|0;h=a+4|0;i=f[h>>2]|0;if((e|0)<(g|0)){if((i|0)<(e|0)){j=d+4+(i<<2)|0;f[d+4+(e<<2)>>2]=f[j>>2];k=j}else k=d+4+(i<<2)|0;f[k>>2]=b;f[h>>2]=i+1;j=f[c>>2]|0;f[j>>2]=(f[j>>2]|0)+1;return}if((i|0)==(g|0)){l=h;m=g;n=9}else{if((e|0)==(g|0)){g=f[d+4+(i<<2)>>2]|0;if((g|0)==0|(f[a>>2]|0)!=0){o=h;p=d;break}bi[f[(f[g>>2]|0)+4>>2]&2047](g);o=h;p=f[c>>2]|0;break}if((i|0)<(e|0)){f[d+4+(e<<2)>>2]=f[d+4+(i<<2)>>2];i=f[c>>2]|0;q=i;r=f[i>>2]|0}else{q=d;r=e}f[q>>2]=r+1;o=h;p=q}}else{l=a+4|0;m=f[a+8>>2]|0;n=9}while(0);if((n|0)==9){cpb(a,m+1|0);m=f[c>>2]|0;f[m>>2]=(f[m>>2]|0)+1;o=l;p=m}m=f[o>>2]|0;f[o>>2]=m+1;f[p+4+(m<<2)>>2]=b;return}function EFb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=zFb(a,b)|0;DFb(f[d>>2]|0,c);return}function FFb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=u;u=u+32|0;h=g+24|0;i=g+16|0;j=g;f[i>>2]=141308;f[i+4>>2]=e;e=f[c+52>>2]|0;if(!e){f[h>>2]=141336;f[h+4>>2]=d;k=YRb(a,b,c,h,i)|0;u=g;return k|0}else{l=f[c+56>>2]|0;zh[f[(f[d>>2]|0)+96>>2]&2047](h,d);d=f[h>>2]|0;f[j>>2]=139652;f[j+4>>2]=e;f[j+8>>2]=l;f[j+12>>2]=d;k=YRb(a,b,c,j,i)|0;u=g;return k|0}return 0}function GFb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=f[a+8>>2]<<5;c=f[a>>2]|0;d=a+4|0;if((c|0)==(d|0)){e=b;return e|0}else{g=b;h=c}while(1){c=(HFb(h+24|0)|0)+g|0;b=f[h+4>>2]|0;if(!b){a=h+8|0;i=f[a>>2]|0;if((f[i>>2]|0)==(h|0))j=i;else{i=a;do{a=f[i>>2]|0;i=a+8|0;k=f[i>>2]|0}while((f[k>>2]|0)!=(a|0));j=k}}else{i=b;while(1){k=f[i>>2]|0;if(!k)break;else i=k}j=i}if((j|0)==(d|0)){e=c;break}else{g=c;h=j}}return e|0}function HFb(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[136e3+(h[a+8>>0]<<2)>>2]|0;if(!(b[a+9>>0]|0))switch(c|0){case 9:{d=(Dnb(f[a>>2]|0)|0)+12|0;return d|0}case 10:{if(!(b[a+10>>0]&16)){e=f[a>>2]|0;d=di[f[(f[e>>2]|0)+84>>2]&1023](e)|0;return d|0}else{e=f[a>>2]|0;d=di[f[(f[e>>2]|0)+44>>2]&1023](e)|0;return d|0}break}default:{d=0;return d|0}}do switch(c|0){case 1:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<2)+16|0;return d|0}case 2:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<3)+20|0;return d|0}case 3:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<2)+16|0;return d|0}case 4:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<3)+20|0;return d|0}case 6:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<2)+16|0;return d|0}case 5:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<3)+20|0;return d|0}case 7:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]|0)+16|0;return d|0}case 8:{e=f[a>>2]|0;if(!(f[e+8>>2]|0)){d=12;return d|0}d=(f[e+4>>2]<<2)+16|0;return d|0}case 9:{e=f[a>>2]|0;g=f[e+8>>2]<<2;i=e+12|0;e=f[i>>2]|0;if(!e)j=g;else{if((f[e>>2]|0)>0){k=0;l=g;m=e;while(1){e=l+12+(Dnb(f[m+4+(k<<2)>>2]|0)|0)|0;k=k+1|0;m=f[i>>2]|0;if((k|0)>=(f[m>>2]|0)){n=e;break}else l=e}}else n=g;j=n+4|0}d=j+16|0;return d|0}case 10:{l=f[a>>2]|0;m=f[l+8>>2]<<2;k=l+12|0;l=f[k>>2]|0;if(!l)o=m;else{if((f[l>>2]|0)>0){i=0;e=m;p=l;while(1){l=f[p+4+(i<<2)>>2]|0;q=(di[f[(f[l>>2]|0)+84>>2]&1023](l)|0)+e|0;i=i+1|0;p=f[k>>2]|0;if((i|0)>=(f[p>>2]|0)){r=q;break}else e=q}}else r=m;o=r+4|0}d=o+16|0;return d|0}default:{d=0;return d|0}}while(0);return 0}function IFb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0;g=u;u=u+32|0;h=g;i=g+24|0;if(!(b[a+9>>0]|0)){j=b[a+10>>0]|0;if(j&1){k=e;u=g;return k|0}do switch(b[a+8>>0]|0){case 5:{l=f[a>>2]|0;m=c<<3;if(m>>>0>127){n=m;o=e;while(1){b[o>>0]=n|128;q=n>>>7;r=o+1|0;if(n>>>0>16383){n=q;o=r}else{t=r;v=q;break}}}else{t=e;v=m}b[t>>0]=v;o=t+1|0;if((l|0)<0){k=hob(l,((l|0)<0)<<31>>31,o)|0;u=g;return k|0}if(l>>>0>127){n=l;q=o;while(1){b[q>>0]=n|128;r=n>>>7;w=q+1|0;if(n>>>0>16383){n=r;q=w}else{x=w;y=r;break}}}else{x=o;y=l}b[x>>0]=y;k=x+1|0;u=g;return k|0}case 3:{q=a;n=f[q>>2]|0;m=f[q+4>>2]|0;q=c<<3;if(q>>>0>127){r=q;w=e;while(1){b[w>>0]=r|128;z=r>>>7;A=w+1|0;if(r>>>0>16383){r=z;w=A}else{B=A;C=z;break}}}else{B=e;C=q}b[B>>0]=C;k=hob(n,m,B+1|0)|0;u=g;return k|0}case 13:{w=f[a>>2]|0;r=c<<3;if(r>>>0>127){l=r;o=e;while(1){b[o>>0]=l|128;z=l>>>7;A=o+1|0;if(l>>>0>16383){l=z;o=A}else{D=A;E=z;break}}}else{D=e;E=r}b[D>>0]=E;o=D+1|0;if(w>>>0>127){l=w;m=o;while(1){b[m>>0]=l|128;n=l>>>7;q=m+1|0;if(l>>>0>16383){l=n;m=q}else{F=q;G=n;break}}}else{F=o;G=w}b[F>>0]=G;k=F+1|0;u=g;return k|0}case 4:{m=a;l=f[m>>2]|0;r=f[m+4>>2]|0;m=c<<3;if(m>>>0>127){n=m;q=e;while(1){b[q>>0]=n|128;z=n>>>7;A=q+1|0;if(n>>>0>16383){n=z;q=A}else{H=A;I=z;break}}}else{H=e;I=m}b[H>>0]=I;k=hob(l,r,H+1|0)|0;u=g;return k|0}case 17:{q=f[a>>2]|0;n=c<<3;if(n>>>0>127){w=n;o=e;while(1){b[o>>0]=w|128;z=w>>>7;A=o+1|0;if(w>>>0>16383){w=z;o=A}else{K=A;L=z;break}}}else{K=e;L=n}b[K>>0]=L;o=K+1|0;w=q<<1^q>>31;if(w>>>0>127){r=w;l=o;while(1){b[l>>0]=r|128;m=r>>>7;z=l+1|0;if(r>>>0>16383){r=m;l=z}else{M=z;N=m;break}}}else{M=o;N=w}b[M>>0]=N;k=M+1|0;u=g;return k|0}case 18:{l=a;r=f[l>>2]|0;q=f[l+4>>2]|0;l=c<<3;if(l>>>0>127){n=l;m=e;while(1){b[m>>0]=n|128;z=n>>>7;A=m+1|0;if(n>>>0>16383){n=z;m=A}else{O=A;P=z;break}}}else{O=e;P=l}b[O>>0]=P;m=$ac(r|0,q|0,1)|0;n=J;w=Rac(r|0,q|0,63)|0;k=hob(m^w,n^J,O+1|0)|0;u=g;return k|0}case 7:{n=f[a>>2]|0;w=c<<3|5;if(w>>>0>127){m=w;o=e;while(1){b[o>>0]=m|128;z=m>>>7;A=o+1|0;if(m>>>0>16383){m=z;o=A}else{Q=A;R=z;break}}}else{Q=e;R=w}b[Q>>0]=R;o=Q+1|0;b[o>>0]=n;b[o+1>>0]=n>>8;b[o+2>>0]=n>>16;b[o+3>>0]=n>>24;k=Q+5|0;u=g;return k|0}case 6:{o=a;m=f[o>>2]|0;q=f[o+4>>2]|0;o=c<<3|1;if(o>>>0>127){r=o;l=e;while(1){b[l>>0]=r|128;z=r>>>7;A=l+1|0;if(r>>>0>16383){r=z;l=A}else{S=A;T=z;break}}}else{S=e;T=o}b[S>>0]=T;l=S+1|0;r=l;b[r>>0]=m;b[r+1>>0]=m>>8;b[r+2>>0]=m>>16;b[r+3>>0]=m>>24;r=l+4|0;b[r>>0]=q;b[r+1>>0]=q>>8;b[r+2>>0]=q>>16;b[r+3>>0]=q>>24;k=S+9|0;u=g;return k|0}case 15:{r=f[a>>2]|0;l=c<<3|5;if(l>>>0>127){n=l;w=e;while(1){b[w>>0]=n|128;z=n>>>7;A=w+1|0;if(n>>>0>16383){n=z;w=A}else{U=A;V=z;break}}}else{U=e;V=l}b[U>>0]=V;w=U+1|0;b[w>>0]=r;b[w+1>>0]=r>>8;b[w+2>>0]=r>>16;b[w+3>>0]=r>>24;k=U+5|0;u=g;return k|0}case 16:{w=a;n=f[w>>2]|0;q=f[w+4>>2]|0;w=c<<3|1;if(w>>>0>127){m=w;o=e;while(1){b[o>>0]=m|128;z=m>>>7;A=o+1|0;if(m>>>0>16383){m=z;o=A}else{W=A;X=z;break}}}else{W=e;X=w}b[W>>0]=X;o=W+1|0;m=o;b[m>>0]=n;b[m+1>>0]=n>>8;b[m+2>>0]=n>>16;b[m+3>>0]=n>>24;m=o+4|0;b[m>>0]=q;b[m+1>>0]=q>>8;b[m+2>>0]=q>>16;b[m+3>>0]=q>>24;k=W+9|0;u=g;return k|0}case 2:{m=f[a>>2]|0;o=c<<3|5;if(o>>>0>127){r=o;l=e;while(1){b[l>>0]=r|128;z=r>>>7;A=l+1|0;if(r>>>0>16383){r=z;l=A}else{Y=A;Z=z;break}}}else{Y=e;Z=o}b[Y>>0]=Z;l=Y+1|0;b[l>>0]=m;b[l+1>>0]=m>>8;b[l+2>>0]=m>>16;b[l+3>>0]=m>>24;k=Y+5|0;u=g;return k|0}case 1:{_=+p[a>>3];l=c<<3|1;if(l>>>0>127){r=l;q=e;while(1){b[q>>0]=r|128;n=r>>>7;w=q+1|0;if(r>>>0>16383){r=n;q=w}else{$=w;aa=n;break}}}else{$=e;aa=l}b[$>>0]=aa;q=$+1|0;p[s>>3]=_;b[q>>0]=b[s>>0];b[q+1>>0]=b[s+1>>0];b[q+2>>0]=b[s+2>>0];b[q+3>>0]=b[s+3>>0];b[q+4>>0]=b[s+4>>0];b[q+5>>0]=b[s+5>>0];b[q+6>>0]=b[s+6>>0];b[q+7>>0]=b[s+7>>0];k=$+9|0;u=g;return k|0}case 8:{q=b[a>>0]|0;r=c<<3;if(r>>>0>127){m=r;o=e;while(1){b[o>>0]=m|128;n=m>>>7;w=o+1|0;if(m>>>0>16383){m=n;o=w}else{ba=w;ca=n;break}}}else{ba=e;ca=r}b[ba>>0]=ca;b[ba+1>>0]=q;k=ba+2|0;u=g;return k|0}case 9:{o=f[a>>2]|0;m=c<<3|2;if(m>>>0>127){l=m;n=e;while(1){b[n>>0]=l|128;w=l>>>7;z=n+1|0;if(l>>>0>16383){l=w;n=z}else{da=z;ea=w;break}}}else{da=e;ea=m}b[da>>0]=ea;k=kob(o,da+1|0)|0;u=g;return k|0}case 12:{n=f[a>>2]|0;l=c<<3|2;if(l>>>0>127){q=l;r=e;while(1){b[r>>0]=q|128;w=q>>>7;z=r+1|0;if(q>>>0>16383){q=w;r=z}else{fa=z;ga=w;break}}}else{fa=e;ga=l}b[fa>>0]=ga;k=kob(n,fa+1|0)|0;u=g;return k|0}case 14:{r=f[a>>2]|0;q=c<<3;if(q>>>0>127){o=q;m=e;while(1){b[m>>0]=o|128;w=o>>>7;z=m+1|0;if(o>>>0>16383){o=w;m=z}else{ha=z;ia=w;break}}}else{ha=e;ia=q}b[ha>>0]=ia;m=ha+1|0;if((r|0)<0){k=hob(r,((r|0)<0)<<31>>31,m)|0;u=g;return k|0}if(r>>>0>127){o=r;n=m;while(1){b[n>>0]=o|128;l=o>>>7;w=n+1|0;if(o>>>0>16383){o=l;n=w}else{ja=w;ka=l;break}}}else{ja=m;ka=r}b[ja>>0]=ka;k=ja+1|0;u=g;return k|0}case 10:{n=f[a>>2]|0;o=c<<3;q=o|3;if(q>>>0>127){l=q;w=e;while(1){b[w>>0]=l|128;z=l>>>7;A=w+1|0;if(l>>>0>16383){l=z;w=A}else{la=A;ma=z;break}}}else{la=e;ma=q}b[la>>0]=ma;w=li[f[(f[n>>2]|0)+68>>2]&511](n,0,la+1|0)|0;l=o|4;if(l>>>0>127){r=l;m=w;while(1){b[m>>0]=r|128;z=r>>>7;A=m+1|0;if(r>>>0>16383){r=z;m=A}else{na=A;oa=z;break}}}else{na=w;oa=l}b[na>>0]=oa;k=na+1|0;u=g;return k|0}case 11:{m=f[a>>2]|0;if(j&16){k=Dg[f[(f[m>>2]|0)+68>>2]&127](m,c,d,e)|0;u=g;return k|0}r=c<<3|2;if(r>>>0>127){o=r;n=e;while(1){b[n>>0]=o|128;q=o>>>7;z=n+1|0;if(o>>>0>16383){o=q;n=z}else{pa=z;qa=q;break}}}else{pa=e;qa=r}b[pa>>0]=qa;n=pa+1|0;o=di[f[(f[m>>2]|0)+64>>2]&1023](m)|0;if(o>>>0>127){l=o;w=n;while(1){b[w>>0]=l|128;q=l>>>7;z=w+1|0;if(l>>>0>16383){l=q;w=z}else{ra=z;sa=q;break}}}else{ra=n;sa=o}b[ra>>0]=sa;k=li[f[(f[m>>2]|0)+68>>2]&511](m,d,ra+1|0)|0;u=g;return k|0}default:{k=e;u=g;return k|0}}while(0)}if(b[a+11>>0]|0){ra=a+12|0;if(!(f[ra>>2]|0)){k=e;u=g;return k|0}sa=c<<3|2;if(sa>>>0>127){pa=sa;qa=e;while(1){b[qa>>0]=pa|128;j=pa>>>7;na=qa+1|0;if(pa>>>0>16383){pa=j;qa=na}else{ta=na;ua=j;break}}}else{ta=e;ua=sa}b[ta>>0]=ua;ua=ta+1|0;ta=f[ra>>2]|0;if((ta|0)<0)va=hob(ta,((ta|0)<0)<<31>>31,ua)|0;else{if(ta>>>0>127){ra=ta;sa=ua;while(1){b[sa>>0]=ra|128;qa=ra>>>7;pa=sa+1|0;if(ra>>>0>16383){ra=qa;sa=pa}else{wa=pa;xa=qa;break}}}else{wa=ua;xa=ta}b[wa>>0]=xa;va=wa+1|0}do switch(b[a+8>>0]|0){case 5:{wa=f[a>>2]|0;if((f[wa>>2]|0)>0){ya=va;za=0;Aa=wa}else{k=va;u=g;return k|0}while(1){wa=f[(f[Aa+8>>2]|0)+4+(za<<2)>>2]|0;if((wa|0)<0)Ba=hob(wa,((wa|0)<0)<<31>>31,ya)|0;else{if(wa>>>0>127){xa=wa;ta=ya;while(1){b[ta>>0]=xa|128;ua=xa>>>7;sa=ta+1|0;if(xa>>>0>16383){xa=ua;ta=sa}else{Ca=sa;Da=ua;break}}}else{Ca=ya;Da=wa}b[Ca>>0]=Da;Ba=Ca+1|0}za=za+1|0;Aa=f[a>>2]|0;if((za|0)>=(f[Aa>>2]|0)){k=Ba;break}else ya=Ba}u=g;return k|0}case 3:{m=f[a>>2]|0;if((f[m>>2]|0)>0){Ea=0;Fa=va;Ga=m}else{k=va;u=g;return k|0}while(1){m=(f[Ga+8>>2]|0)+8+(Ea<<3)|0;o=hob(f[m>>2]|0,f[m+4>>2]|0,Fa)|0;Ea=Ea+1|0;Ga=f[a>>2]|0;if((Ea|0)>=(f[Ga>>2]|0)){k=o;break}else Fa=o}u=g;return k|0}case 13:{o=f[a>>2]|0;if((f[o>>2]|0)>0){Ha=0;Ia=va;Ja=o}else{k=va;u=g;return k|0}while(1){o=f[(f[Ja+8>>2]|0)+4+(Ha<<2)>>2]|0;if(o>>>0>127){m=o;n=Ia;while(1){b[n>>0]=m|128;ta=m>>>7;xa=n+1|0;if(m>>>0>16383){m=ta;n=xa}else{Ka=xa;La=ta;break}}}else{Ka=Ia;La=o}b[Ka>>0]=La;n=Ka+1|0;Ha=Ha+1|0;Ja=f[a>>2]|0;if((Ha|0)>=(f[Ja>>2]|0)){k=n;break}else Ia=n}u=g;return k|0}case 4:{n=f[a>>2]|0;if((f[n>>2]|0)>0){Ma=0;Na=va;Oa=n}else{k=va;u=g;return k|0}while(1){n=(f[Oa+8>>2]|0)+8+(Ma<<3)|0;m=hob(f[n>>2]|0,f[n+4>>2]|0,Na)|0;Ma=Ma+1|0;Oa=f[a>>2]|0;if((Ma|0)>=(f[Oa>>2]|0)){k=m;break}else Na=m}u=g;return k|0}case 17:{m=f[a>>2]|0;if((f[m>>2]|0)>0){Pa=0;Qa=va;Ra=m}else{k=va;u=g;return k|0}while(1){m=f[(f[Ra+8>>2]|0)+4+(Pa<<2)>>2]|0;n=m<<1^m>>31;if(n>>>0>127){m=n;wa=Qa;while(1){b[wa>>0]=m|128;ta=m>>>7;xa=wa+1|0;if(m>>>0>16383){m=ta;wa=xa}else{Sa=xa;Ta=ta;break}}}else{Sa=Qa;Ta=n}b[Sa>>0]=Ta;wa=Sa+1|0;Pa=Pa+1|0;Ra=f[a>>2]|0;if((Pa|0)>=(f[Ra>>2]|0)){k=wa;break}else Qa=wa}u=g;return k|0}case 18:{wa=f[a>>2]|0;if((f[wa>>2]|0)>0){Ua=0;Va=va;Wa=wa}else{k=va;u=g;return k|0}while(1){wa=(f[Wa+8>>2]|0)+8+(Ua<<3)|0;m=f[wa>>2]|0;o=f[wa+4>>2]|0;wa=$ac(m|0,o|0,1)|0;ta=J;xa=Rac(m|0,o|0,63)|0;o=hob(wa^xa,ta^J,Va)|0;Ua=Ua+1|0;Wa=f[a>>2]|0;if((Ua|0)>=(f[Wa>>2]|0)){k=o;break}else Va=o}u=g;return k|0}case 7:{o=f[a>>2]|0;if((f[o>>2]|0)>0){Xa=0;Ya=va;Za=o}else{k=va;u=g;return k|0}while(1){o=f[(f[Za+8>>2]|0)+4+(Xa<<2)>>2]|0;b[Ya>>0]=o;b[Ya+1>>0]=o>>8;b[Ya+2>>0]=o>>16;b[Ya+3>>0]=o>>24;o=Ya+4|0;Xa=Xa+1|0;Za=f[a>>2]|0;if((Xa|0)>=(f[Za>>2]|0)){k=o;break}else Ya=o}u=g;return k|0}case 6:{o=f[a>>2]|0;if((f[o>>2]|0)>0){_a=0;$a=va;ab=o}else{k=va;u=g;return k|0}while(1){o=(f[ab+8>>2]|0)+8+(_a<<3)|0;ta=f[o>>2]|0;xa=f[o+4>>2]|0;o=$a;wa=o;b[wa>>0]=ta;b[wa+1>>0]=ta>>8;b[wa+2>>0]=ta>>16;b[wa+3>>0]=ta>>24;ta=o+4|0;b[ta>>0]=xa;b[ta+1>>0]=xa>>8;b[ta+2>>0]=xa>>16;b[ta+3>>0]=xa>>24;xa=$a+8|0;_a=_a+1|0;ab=f[a>>2]|0;if((_a|0)>=(f[ab>>2]|0)){k=xa;break}else $a=xa}u=g;return k|0}case 15:{xa=f[a>>2]|0;if((f[xa>>2]|0)>0){bb=0;cb=va;db=xa}else{k=va;u=g;return k|0}while(1){xa=f[(f[db+8>>2]|0)+4+(bb<<2)>>2]|0;b[cb>>0]=xa;b[cb+1>>0]=xa>>8;b[cb+2>>0]=xa>>16;b[cb+3>>0]=xa>>24;xa=cb+4|0;bb=bb+1|0;db=f[a>>2]|0;if((bb|0)>=(f[db>>2]|0)){k=xa;break}else cb=xa}u=g;return k|0}case 16:{xa=f[a>>2]|0;if((f[xa>>2]|0)>0){eb=0;fb=va;gb=xa}else{k=va;u=g;return k|0}while(1){xa=(f[gb+8>>2]|0)+8+(eb<<3)|0;ta=f[xa>>2]|0;o=f[xa+4>>2]|0;xa=fb;wa=xa;b[wa>>0]=ta;b[wa+1>>0]=ta>>8;b[wa+2>>0]=ta>>16;b[wa+3>>0]=ta>>24;ta=xa+4|0;b[ta>>0]=o;b[ta+1>>0]=o>>8;b[ta+2>>0]=o>>16;b[ta+3>>0]=o>>24;o=fb+8|0;eb=eb+1|0;gb=f[a>>2]|0;if((eb|0)>=(f[gb>>2]|0)){k=o;break}else fb=o}u=g;return k|0}case 2:{o=f[a>>2]|0;if((f[o>>2]|0)>0){hb=0;ib=va;jb=o}else{k=va;u=g;return k|0}while(1){o=f[(f[jb+8>>2]|0)+4+(hb<<2)>>2]|0;b[ib>>0]=o;b[ib+1>>0]=o>>8;b[ib+2>>0]=o>>16;b[ib+3>>0]=o>>24;o=ib+4|0;hb=hb+1|0;jb=f[a>>2]|0;if((hb|0)>=(f[jb>>2]|0)){k=o;break}else ib=o}u=g;return k|0}case 1:{o=f[a>>2]|0;if((f[o>>2]|0)>0){kb=0;lb=va;mb=o}else{k=va;u=g;return k|0}while(1){p[s>>3]=+p[(f[mb+8>>2]|0)+8+(kb<<3)>>3];b[lb>>0]=b[s>>0];b[lb+1>>0]=b[s+1>>0];b[lb+2>>0]=b[s+2>>0];b[lb+3>>0]=b[s+3>>0];b[lb+4>>0]=b[s+4>>0];b[lb+5>>0]=b[s+5>>0];b[lb+6>>0]=b[s+6>>0];b[lb+7>>0]=b[s+7>>0];o=lb+8|0;kb=kb+1|0;mb=f[a>>2]|0;if((kb|0)>=(f[mb>>2]|0)){k=o;break}else lb=o}u=g;return k|0}case 8:{o=f[a>>2]|0;if((f[o>>2]|0)>0){nb=0;ob=va;pb=o}else{k=va;u=g;return k|0}while(1){b[ob>>0]=b[(f[pb+8>>2]|0)+4+nb>>0]|0;o=ob+1|0;nb=nb+1|0;pb=f[a>>2]|0;if((nb|0)>=(f[pb>>2]|0)){k=o;break}else ob=o}u=g;return k|0}case 14:{o=f[a>>2]|0;if((f[o>>2]|0)>0){qb=0;rb=va;sb=o}else{k=va;u=g;return k|0}while(1){o=f[(f[sb+8>>2]|0)+4+(qb<<2)>>2]|0;if((o|0)<0)tb=hob(o,((o|0)<0)<<31>>31,rb)|0;else{if(o>>>0>127){ta=o;xa=rb;while(1){b[xa>>0]=ta|128;wa=ta>>>7;m=xa+1|0;if(ta>>>0>16383){ta=wa;xa=m}else{ub=m;vb=wa;break}}}else{ub=rb;vb=o}b[ub>>0]=vb;tb=ub+1|0}qb=qb+1|0;sb=f[a>>2]|0;if((qb|0)>=(f[sb>>2]|0)){k=tb;break}else rb=tb}u=g;return k|0}case 11:case 10:case 12:case 9:{zpb(h,3,466497,486);xpb(i,vpb(h,478329)|0);Apb(h);k=va;u=g;return k|0}default:{k=va;u=g;return k|0}}while(0)}do switch(b[a+8>>0]|0){case 5:{va=f[a>>2]|0;if((f[va>>2]|0)<=0){k=e;u=g;return k|0}h=c<<3;if(h>>>0>127){wb=0;xb=e;yb=va}else{i=h&255;tb=0;rb=e;sb=va;while(1){va=f[(f[sb+8>>2]|0)+4+(tb<<2)>>2]|0;b[rb>>0]=i;qb=rb+1|0;if((va|0)<0)zb=hob(va,((va|0)<0)<<31>>31,qb)|0;else{if(va>>>0>127){ub=va;vb=qb;while(1){b[vb>>0]=ub|128;ob=ub>>>7;pb=vb+1|0;if(ub>>>0>16383){ub=ob;vb=pb}else{Ab=pb;Bb=ob;break}}}else{Ab=qb;Bb=va}b[Ab>>0]=Bb;zb=Ab+1|0}tb=tb+1|0;sb=f[a>>2]|0;if((tb|0)>=(f[sb>>2]|0)){k=zb;break}else rb=zb}u=g;return k|0}while(1){rb=f[(f[yb+8>>2]|0)+4+(wb<<2)>>2]|0;sb=h;tb=xb;while(1){b[tb>>0]=sb|128;i=sb;sb=sb>>>7;Cb=tb+1|0;if(i>>>0<=16383)break;else tb=Cb}b[Cb>>0]=sb;va=tb+2|0;if((rb|0)<0)Db=hob(rb,((rb|0)<0)<<31>>31,va)|0;else{if(rb>>>0>127){qb=rb;i=va;while(1){b[i>>0]=qb|128;vb=qb>>>7;ub=i+1|0;if(qb>>>0>16383){qb=vb;i=ub}else{Eb=ub;Fb=vb;break}}}else{Eb=va;Fb=rb}b[Eb>>0]=Fb;Db=Eb+1|0}wb=wb+1|0;yb=f[a>>2]|0;if((wb|0)>=(f[yb>>2]|0)){k=Db;break}else xb=Db}u=g;return k|0}case 3:{h=f[a>>2]|0;if((f[h>>2]|0)<=0){k=e;u=g;return k|0}i=c<<3;if(i>>>0>127){Gb=0;Hb=e;Ib=h}else{qb=i&255;tb=0;sb=e;vb=h;while(1){h=(f[vb+8>>2]|0)+8+(tb<<3)|0;ub=f[h>>2]|0;o=f[h+4>>2]|0;b[sb>>0]=qb;h=hob(ub,o,sb+1|0)|0;tb=tb+1|0;vb=f[a>>2]|0;if((tb|0)>=(f[vb>>2]|0)){k=h;break}else sb=h}u=g;return k|0}while(1){sb=(f[Ib+8>>2]|0)+8+(Gb<<3)|0;vb=f[sb>>2]|0;tb=f[sb+4>>2]|0;sb=i;qb=Hb;while(1){b[qb>>0]=sb|128;h=sb;sb=sb>>>7;Jb=qb+1|0;if(h>>>0<=16383)break;else qb=Jb}b[Jb>>0]=sb;rb=hob(vb,tb,qb+2|0)|0;Gb=Gb+1|0;Ib=f[a>>2]|0;if((Gb|0)>=(f[Ib>>2]|0)){k=rb;break}else Hb=rb}u=g;return k|0}case 13:{i=f[a>>2]|0;if((f[i>>2]|0)<=0){k=e;u=g;return k|0}rb=c<<3;if(rb>>>0>127){Kb=0;Lb=e;Mb=i}else{va=rb&255;h=0;o=e;ub=i;while(1){i=f[(f[ub+8>>2]|0)+4+(h<<2)>>2]|0;b[o>>0]=va;ob=o+1|0;if(i>>>0>127){pb=i;nb=ob;while(1){b[nb>>0]=pb|128;lb=pb>>>7;mb=nb+1|0;if(pb>>>0>16383){pb=lb;nb=mb}else{Nb=mb;Ob=lb;break}}}else{Nb=ob;Ob=i}b[Nb>>0]=Ob;nb=Nb+1|0;h=h+1|0;ub=f[a>>2]|0;if((h|0)>=(f[ub>>2]|0)){k=nb;break}else o=nb}u=g;return k|0}while(1){o=f[(f[Mb+8>>2]|0)+4+(Kb<<2)>>2]|0;ub=rb;h=Lb;while(1){b[h>>0]=ub|128;va=ub;ub=ub>>>7;Pb=h+1|0;if(va>>>0<=16383)break;else h=Pb}b[Pb>>0]=ub;i=h+2|0;if(o>>>0>127){ob=o;va=i;while(1){b[va>>0]=ob|128;nb=ob>>>7;pb=va+1|0;if(ob>>>0>16383){ob=nb;va=pb}else{Qb=pb;Rb=nb;break}}}else{Qb=i;Rb=o}b[Qb>>0]=Rb;va=Qb+1|0;Kb=Kb+1|0;Mb=f[a>>2]|0;if((Kb|0)>=(f[Mb>>2]|0)){k=va;break}else Lb=va}u=g;return k|0}case 4:{rb=f[a>>2]|0;if((f[rb>>2]|0)<=0){k=e;u=g;return k|0}va=c<<3;if(va>>>0>127){Sb=0;Tb=e;Ub=rb}else{ob=va&255;h=0;ub=e;nb=rb;while(1){rb=(f[nb+8>>2]|0)+8+(h<<3)|0;pb=f[rb>>2]|0;qb=f[rb+4>>2]|0;b[ub>>0]=ob;rb=hob(pb,qb,ub+1|0)|0;h=h+1|0;nb=f[a>>2]|0;if((h|0)>=(f[nb>>2]|0)){k=rb;break}else ub=rb}u=g;return k|0}while(1){ub=(f[Ub+8>>2]|0)+8+(Sb<<3)|0;nb=f[ub>>2]|0;h=f[ub+4>>2]|0;ub=va;ob=Tb;while(1){b[ob>>0]=ub|128;rb=ub;ub=ub>>>7;Vb=ob+1|0;if(rb>>>0<=16383)break;else ob=Vb}b[Vb>>0]=ub;o=hob(nb,h,ob+2|0)|0;Sb=Sb+1|0;Ub=f[a>>2]|0;if((Sb|0)>=(f[Ub>>2]|0)){k=o;break}else Tb=o}u=g;return k|0}case 17:{va=f[a>>2]|0;if((f[va>>2]|0)<=0){k=e;u=g;return k|0}o=c<<3;if(o>>>0>127){Wb=0;Xb=e;Yb=va}else{i=o&255;rb=0;qb=e;pb=va;while(1){va=f[(f[pb+8>>2]|0)+4+(rb<<2)>>2]|0;b[qb>>0]=i;tb=qb+1|0;vb=va<<1^va>>31;if(vb>>>0>127){va=vb;sb=tb;while(1){b[sb>>0]=va|128;lb=va>>>7;mb=sb+1|0;if(va>>>0>16383){va=lb;sb=mb}else{Zb=mb;_b=lb;break}}}else{Zb=tb;_b=vb}b[Zb>>0]=_b;sb=Zb+1|0;rb=rb+1|0;pb=f[a>>2]|0;if((rb|0)>=(f[pb>>2]|0)){k=sb;break}else qb=sb}u=g;return k|0}while(1){qb=f[(f[Yb+8>>2]|0)+4+(Wb<<2)>>2]|0;pb=o;rb=Xb;while(1){b[rb>>0]=pb|128;i=pb;pb=pb>>>7;$b=rb+1|0;if(i>>>0<=16383)break;else rb=$b}b[$b>>0]=pb;vb=rb+2|0;tb=qb<<1^qb>>31;if(tb>>>0>127){i=tb;sb=vb;while(1){b[sb>>0]=i|128;va=i>>>7;ob=sb+1|0;if(i>>>0>16383){i=va;sb=ob}else{ac=ob;bc=va;break}}}else{ac=vb;bc=tb}b[ac>>0]=bc;sb=ac+1|0;Wb=Wb+1|0;Yb=f[a>>2]|0;if((Wb|0)>=(f[Yb>>2]|0)){k=sb;break}else Xb=sb}u=g;return k|0}case 18:{o=f[a>>2]|0;if((f[o>>2]|0)<=0){k=e;u=g;return k|0}sb=c<<3;if(sb>>>0>127){cc=0;dc=e;ec=o}else{i=sb&255;qb=0;rb=e;pb=o;while(1){o=(f[pb+8>>2]|0)+8+(qb<<3)|0;va=f[o>>2]|0;ob=f[o+4>>2]|0;b[rb>>0]=i;o=$ac(va|0,ob|0,1)|0;h=J;nb=Rac(va|0,ob|0,63)|0;ob=hob(o^nb,h^J,rb+1|0)|0;qb=qb+1|0;pb=f[a>>2]|0;if((qb|0)>=(f[pb>>2]|0)){k=ob;break}else rb=ob}u=g;return k|0}while(1){rb=(f[ec+8>>2]|0)+8+(cc<<3)|0;pb=f[rb>>2]|0;qb=f[rb+4>>2]|0;rb=sb;i=dc;while(1){b[i>>0]=rb|128;ob=rb;rb=rb>>>7;fc=i+1|0;if(ob>>>0<=16383)break;else i=fc}b[fc>>0]=rb;tb=$ac(pb|0,qb|0,1)|0;vb=J;ob=Rac(pb|0,qb|0,63)|0;h=hob(tb^ob,vb^J,i+2|0)|0;cc=cc+1|0;ec=f[a>>2]|0;if((cc|0)>=(f[ec>>2]|0)){k=h;break}else dc=h}u=g;return k|0}case 7:{sb=f[a>>2]|0;if((f[sb>>2]|0)<=0){k=e;u=g;return k|0}h=c<<3|5;if(h>>>0>127){gc=0;hc=e;ic=sb}else{vb=h&255;ob=0;tb=e;nb=sb;while(1){sb=f[(f[nb+8>>2]|0)+4+(ob<<2)>>2]|0;b[tb>>0]=vb;o=tb+1|0;b[o>>0]=sb;b[o+1>>0]=sb>>8;b[o+2>>0]=sb>>16;b[o+3>>0]=sb>>24;sb=tb+5|0;ob=ob+1|0;nb=f[a>>2]|0;if((ob|0)>=(f[nb>>2]|0)){k=sb;break}else tb=sb}u=g;return k|0}while(1){tb=f[(f[ic+8>>2]|0)+4+(gc<<2)>>2]|0;nb=h;ob=hc;while(1){b[ob>>0]=nb|128;vb=nb;nb=nb>>>7;jc=ob+1|0;if(vb>>>0<=16383)break;else ob=jc}b[jc>>0]=nb;i=ob+2|0;b[i>>0]=tb;b[i+1>>0]=tb>>8;b[i+2>>0]=tb>>16;b[i+3>>0]=tb>>24;i=ob+6|0;gc=gc+1|0;ic=f[a>>2]|0;if((gc|0)>=(f[ic>>2]|0)){k=i;break}else hc=i}u=g;return k|0}case 6:{h=f[a>>2]|0;if((f[h>>2]|0)<=0){k=e;u=g;return k|0}i=c<<3|1;if(i>>>0>127){kc=0;lc=e;mc=h}else{qb=i&255;pb=0;rb=e;vb=h;while(1){h=(f[vb+8>>2]|0)+8+(pb<<3)|0;sb=f[h>>2]|0;o=f[h+4>>2]|0;b[rb>>0]=qb;h=rb+1|0;va=h;b[va>>0]=sb;b[va+1>>0]=sb>>8;b[va+2>>0]=sb>>16;b[va+3>>0]=sb>>24;sb=h+4|0;b[sb>>0]=o;b[sb+1>>0]=o>>8;b[sb+2>>0]=o>>16;b[sb+3>>0]=o>>24;o=rb+9|0;pb=pb+1|0;vb=f[a>>2]|0;if((pb|0)>=(f[vb>>2]|0)){k=o;break}else rb=o}u=g;return k|0}while(1){rb=(f[mc+8>>2]|0)+8+(kc<<3)|0;vb=f[rb>>2]|0;pb=f[rb+4>>2]|0;rb=i;qb=lc;while(1){b[qb>>0]=rb|128;o=rb;rb=rb>>>7;nc=qb+1|0;if(o>>>0<=16383)break;else qb=nc}b[nc>>0]=rb;ob=qb+2|0;tb=ob;b[tb>>0]=vb;b[tb+1>>0]=vb>>8;b[tb+2>>0]=vb>>16;b[tb+3>>0]=vb>>24;tb=ob+4|0;b[tb>>0]=pb;b[tb+1>>0]=pb>>8;b[tb+2>>0]=pb>>16;b[tb+3>>0]=pb>>24;tb=qb+10|0;kc=kc+1|0;mc=f[a>>2]|0;if((kc|0)>=(f[mc>>2]|0)){k=tb;break}else lc=tb}u=g;return k|0}case 15:{i=f[a>>2]|0;if((f[i>>2]|0)<=0){k=e;u=g;return k|0}tb=c<<3|5;if(tb>>>0>127){oc=0;pc=e;qc=i}else{ob=tb&255;nb=0;o=e;sb=i;while(1){i=f[(f[sb+8>>2]|0)+4+(nb<<2)>>2]|0;b[o>>0]=ob;h=o+1|0;b[h>>0]=i;b[h+1>>0]=i>>8;b[h+2>>0]=i>>16;b[h+3>>0]=i>>24;i=o+5|0;nb=nb+1|0;sb=f[a>>2]|0;if((nb|0)>=(f[sb>>2]|0)){k=i;break}else o=i}u=g;return k|0}while(1){o=f[(f[qc+8>>2]|0)+4+(oc<<2)>>2]|0;sb=tb;nb=pc;while(1){b[nb>>0]=sb|128;ob=sb;sb=sb>>>7;rc=nb+1|0;if(ob>>>0<=16383)break;else nb=rc}b[rc>>0]=sb;qb=nb+2|0;b[qb>>0]=o;b[qb+1>>0]=o>>8;b[qb+2>>0]=o>>16;b[qb+3>>0]=o>>24;qb=nb+6|0;oc=oc+1|0;qc=f[a>>2]|0;if((oc|0)>=(f[qc>>2]|0)){k=qb;break}else pc=qb}u=g;return k|0}case 16:{tb=f[a>>2]|0;if((f[tb>>2]|0)<=0){k=e;u=g;return k|0}qb=c<<3|1;if(qb>>>0>127){sc=0;tc=e;uc=tb}else{pb=qb&255;vb=0;rb=e;ob=tb;while(1){tb=(f[ob+8>>2]|0)+8+(vb<<3)|0;i=f[tb>>2]|0;h=f[tb+4>>2]|0;b[rb>>0]=pb;tb=rb+1|0;va=tb;b[va>>0]=i;b[va+1>>0]=i>>8;b[va+2>>0]=i>>16;b[va+3>>0]=i>>24;i=tb+4|0;b[i>>0]=h;b[i+1>>0]=h>>8;b[i+2>>0]=h>>16;b[i+3>>0]=h>>24;h=rb+9|0;vb=vb+1|0;ob=f[a>>2]|0;if((vb|0)>=(f[ob>>2]|0)){k=h;break}else rb=h}u=g;return k|0}while(1){rb=(f[uc+8>>2]|0)+8+(sc<<3)|0;ob=f[rb>>2]|0;vb=f[rb+4>>2]|0;rb=qb;pb=tc;while(1){b[pb>>0]=rb|128;h=rb;rb=rb>>>7;vc=pb+1|0;if(h>>>0<=16383)break;else pb=vc}b[vc>>0]=rb;nb=pb+2|0;o=nb;b[o>>0]=ob;b[o+1>>0]=ob>>8;b[o+2>>0]=ob>>16;b[o+3>>0]=ob>>24;o=nb+4|0;b[o>>0]=vb;b[o+1>>0]=vb>>8;b[o+2>>0]=vb>>16;b[o+3>>0]=vb>>24;o=pb+10|0;sc=sc+1|0;uc=f[a>>2]|0;if((sc|0)>=(f[uc>>2]|0)){k=o;break}else tc=o}u=g;return k|0}case 2:{qb=f[a>>2]|0;if((f[qb>>2]|0)<=0){k=e;u=g;return k|0}o=c<<3|5;if(o>>>0>127){wc=0;xc=e;yc=qb}else{nb=o&255;sb=0;h=e;i=qb;while(1){qb=f[(f[i+8>>2]|0)+4+(sb<<2)>>2]|0;b[h>>0]=nb;tb=h+1|0;b[tb>>0]=qb;b[tb+1>>0]=qb>>8;b[tb+2>>0]=qb>>16;b[tb+3>>0]=qb>>24;qb=h+5|0;sb=sb+1|0;i=f[a>>2]|0;if((sb|0)>=(f[i>>2]|0)){k=qb;break}else h=qb}u=g;return k|0}while(1){h=f[(f[yc+8>>2]|0)+4+(wc<<2)>>2]|0;i=o;sb=xc;while(1){b[sb>>0]=i|128;nb=i;i=i>>>7;zc=sb+1|0;if(nb>>>0<=16383)break;else sb=zc}b[zc>>0]=i;pb=sb+2|0;b[pb>>0]=h;b[pb+1>>0]=h>>8;b[pb+2>>0]=h>>16;b[pb+3>>0]=h>>24;pb=sb+6|0;wc=wc+1|0;yc=f[a>>2]|0;if((wc|0)>=(f[yc>>2]|0)){k=pb;break}else xc=pb}u=g;return k|0}case 1:{o=f[a>>2]|0;if((f[o>>2]|0)<=0){k=e;u=g;return k|0}pb=c<<3|1;if(pb>>>0>127){Ac=0;Bc=e;Cc=o}else{vb=pb&255;ob=0;rb=e;nb=o;while(1){_=+p[(f[nb+8>>2]|0)+8+(ob<<3)>>3];b[rb>>0]=vb;o=rb+1|0;p[s>>3]=_;b[o>>0]=b[s>>0];b[o+1>>0]=b[s+1>>0];b[o+2>>0]=b[s+2>>0];b[o+3>>0]=b[s+3>>0];b[o+4>>0]=b[s+4>>0];b[o+5>>0]=b[s+5>>0];b[o+6>>0]=b[s+6>>0];b[o+7>>0]=b[s+7>>0];o=rb+9|0;ob=ob+1|0;nb=f[a>>2]|0;if((ob|0)>=(f[nb>>2]|0)){k=o;break}else rb=o}u=g;return k|0}while(1){_=+p[(f[Cc+8>>2]|0)+8+(Ac<<3)>>3];rb=pb;nb=Bc;while(1){b[nb>>0]=rb|128;ob=rb;rb=rb>>>7;Dc=nb+1|0;if(ob>>>0<=16383)break;else nb=Dc}b[Dc>>0]=rb;sb=nb+2|0;p[s>>3]=_;b[sb>>0]=b[s>>0];b[sb+1>>0]=b[s+1>>0];b[sb+2>>0]=b[s+2>>0];b[sb+3>>0]=b[s+3>>0];b[sb+4>>0]=b[s+4>>0];b[sb+5>>0]=b[s+5>>0];b[sb+6>>0]=b[s+6>>0];b[sb+7>>0]=b[s+7>>0];sb=nb+10|0;Ac=Ac+1|0;Cc=f[a>>2]|0;if((Ac|0)>=(f[Cc>>2]|0)){k=sb;break}else Bc=sb}u=g;return k|0}case 8:{pb=f[a>>2]|0;if((f[pb>>2]|0)<=0){k=e;u=g;return k|0}sb=c<<3;if(sb>>>0>127){Ec=0;Fc=e;Gc=pb}else{h=sb&255;i=0;ob=e;vb=pb;while(1){pb=b[(f[vb+8>>2]|0)+4+i>>0]|0;b[ob>>0]=h;b[ob+1>>0]=pb;pb=ob+2|0;i=i+1|0;vb=f[a>>2]|0;if((i|0)>=(f[vb>>2]|0)){k=pb;break}else ob=pb}u=g;return k|0}while(1){ob=b[(f[Gc+8>>2]|0)+4+Ec>>0]|0;vb=sb;i=Fc;while(1){b[i>>0]=vb|128;h=vb;vb=vb>>>7;Hc=i+1|0;if(h>>>0<=16383)break;else i=Hc}b[Hc>>0]=vb;b[i+2>>0]=ob;nb=i+3|0;Ec=Ec+1|0;Gc=f[a>>2]|0;if((Ec|0)>=(f[Gc>>2]|0)){k=nb;break}else Fc=nb}u=g;return k|0}case 9:{sb=f[a>>2]|0;if((f[sb+4>>2]|0)<=0){k=e;u=g;return k|0}nb=c<<3|2;if(nb>>>0>127){Ic=0;Jc=e;Kc=sb}else{rb=nb&255;h=0;pb=e;o=sb;while(1){sb=f[(f[o+12>>2]|0)+4+(h<<2)>>2]|0;b[pb>>0]=rb;qb=kob(sb,pb+1|0)|0;h=h+1|0;o=f[a>>2]|0;if((h|0)>=(f[o+4>>2]|0)){k=qb;break}else pb=qb}u=g;return k|0}while(1){pb=f[(f[Kc+12>>2]|0)+4+(Ic<<2)>>2]|0;o=nb;h=Jc;while(1){b[h>>0]=o|128;rb=o;o=o>>>7;Lc=h+1|0;if(rb>>>0<=16383)break;else h=Lc}b[Lc>>0]=o;i=kob(pb,h+2|0)|0;Ic=Ic+1|0;Kc=f[a>>2]|0;if((Ic|0)>=(f[Kc+4>>2]|0)){k=i;break}else Jc=i}u=g;return k|0}case 12:{nb=f[a>>2]|0;if((f[nb+4>>2]|0)<=0){k=e;u=g;return k|0}i=c<<3|2;if(i>>>0>127){Mc=0;Nc=e;Oc=nb}else{ob=i&255;vb=0;rb=e;qb=nb;while(1){nb=f[(f[qb+12>>2]|0)+4+(vb<<2)>>2]|0;b[rb>>0]=ob;sb=kob(nb,rb+1|0)|0;vb=vb+1|0;qb=f[a>>2]|0;if((vb|0)>=(f[qb+4>>2]|0)){k=sb;break}else rb=sb}u=g;return k|0}while(1){rb=f[(f[Oc+12>>2]|0)+4+(Mc<<2)>>2]|0;qb=i;vb=Nc;while(1){b[vb>>0]=qb|128;ob=qb;qb=qb>>>7;Pc=vb+1|0;if(ob>>>0<=16383)break;else vb=Pc}b[Pc>>0]=qb;h=kob(rb,vb+2|0)|0;Mc=Mc+1|0;Oc=f[a>>2]|0;if((Mc|0)>=(f[Oc+4>>2]|0)){k=h;break}else Nc=h}u=g;return k|0}case 14:{i=f[a>>2]|0;if((f[i>>2]|0)<=0){k=e;u=g;return k|0}h=c<<3;if(h>>>0>127){Qc=0;Rc=e;Sc=i}else{pb=h&255;o=0;ob=e;sb=i;while(1){i=f[(f[sb+8>>2]|0)+4+(o<<2)>>2]|0;b[ob>>0]=pb;nb=ob+1|0;if((i|0)<0)Tc=hob(i,((i|0)<0)<<31>>31,nb)|0;else{if(i>>>0>127){tb=i;va=nb;while(1){b[va>>0]=tb|128;ub=tb>>>7;lb=va+1|0;if(tb>>>0>16383){tb=ub;va=lb}else{Uc=lb;Vc=ub;break}}}else{Uc=nb;Vc=i}b[Uc>>0]=Vc;Tc=Uc+1|0}o=o+1|0;sb=f[a>>2]|0;if((o|0)>=(f[sb>>2]|0)){k=Tc;break}else ob=Tc}u=g;return k|0}while(1){ob=f[(f[Sc+8>>2]|0)+4+(Qc<<2)>>2]|0;sb=h;o=Rc;while(1){b[o>>0]=sb|128;pb=sb;sb=sb>>>7;Wc=o+1|0;if(pb>>>0<=16383)break;else o=Wc}b[Wc>>0]=sb;i=o+2|0;if((ob|0)<0)Xc=hob(ob,((ob|0)<0)<<31>>31,i)|0;else{if(ob>>>0>127){nb=ob;pb=i;while(1){b[pb>>0]=nb|128;va=nb>>>7;tb=pb+1|0;if(nb>>>0>16383){nb=va;pb=tb}else{Yc=tb;Zc=va;break}}}else{Yc=i;Zc=ob}b[Yc>>0]=Zc;Xc=Yc+1|0}Qc=Qc+1|0;Sc=f[a>>2]|0;if((Qc|0)>=(f[Sc>>2]|0)){k=Xc;break}else Rc=Xc}u=g;return k|0}case 10:{h=f[a>>2]|0;if((f[h+4>>2]|0)<=0){k=e;u=g;return k|0}pb=c<<3;nb=pb|3;o=pb|4;pb=o>>>0>127;if(nb>>>0>127){_c=0;$c=e;ad=h}else{sb=nb&255;va=0;tb=e;vb=h;while(1){h=f[(f[vb+12>>2]|0)+4+(va<<2)>>2]|0;b[tb>>0]=sb;rb=li[f[(f[h>>2]|0)+68>>2]&511](h,d,tb+1|0)|0;if(pb){h=o;qb=rb;while(1){b[qb>>0]=h|128;ub=h>>>7;lb=qb+1|0;if(h>>>0>16383){h=ub;qb=lb}else{bd=lb;cd=ub;break}}}else{bd=rb;cd=o}b[bd>>0]=cd;qb=bd+1|0;va=va+1|0;vb=f[a>>2]|0;if((va|0)>=(f[vb+4>>2]|0)){k=qb;break}else tb=qb}u=g;return k|0}while(1){tb=f[(f[ad+12>>2]|0)+4+(_c<<2)>>2]|0;vb=nb;va=$c;while(1){b[va>>0]=vb|128;sb=vb;vb=vb>>>7;dd=va+1|0;if(sb>>>0<=16383)break;else va=dd}b[dd>>0]=vb;rb=li[f[(f[tb>>2]|0)+68>>2]&511](tb,d,va+2|0)|0;if(pb){sb=o;qb=rb;while(1){b[qb>>0]=sb|128;h=sb>>>7;ob=qb+1|0;if(sb>>>0>16383){sb=h;qb=ob}else{ed=ob;fd=h;break}}}else{ed=rb;fd=o}b[ed>>0]=fd;qb=ed+1|0;_c=_c+1|0;ad=f[a>>2]|0;if((_c|0)>=(f[ad+4>>2]|0)){k=qb;break}else $c=qb}u=g;return k|0}case 11:{o=f[a>>2]|0;if((f[o+4>>2]|0)<=0){k=e;u=g;return k|0}pb=c<<3|2;if(pb>>>0>127){gd=0;hd=e;id=o}else{nb=pb&255;qb=0;sb=e;va=o;while(1){o=f[(f[va+12>>2]|0)+4+(qb<<2)>>2]|0;b[sb>>0]=nb;tb=sb+1|0;vb=di[f[(f[o>>2]|0)+64>>2]&1023](o)|0;if(vb>>>0>127){h=vb;ob=tb;while(1){b[ob>>0]=h|128;i=h>>>7;ub=ob+1|0;if(h>>>0>16383){h=i;ob=ub}else{jd=ub;kd=i;break}}}else{jd=tb;kd=vb}b[jd>>0]=kd;ob=li[f[(f[o>>2]|0)+68>>2]&511](o,d,jd+1|0)|0;qb=qb+1|0;va=f[a>>2]|0;if((qb|0)>=(f[va+4>>2]|0)){k=ob;break}else sb=ob}u=g;return k|0}while(1){sb=f[(f[id+12>>2]|0)+4+(gd<<2)>>2]|0;va=pb;qb=hd;while(1){b[qb>>0]=va|128;nb=va;va=va>>>7;ld=qb+1|0;if(nb>>>0<=16383)break;else qb=ld}b[ld>>0]=va;o=qb+2|0;vb=di[f[(f[sb>>2]|0)+64>>2]&1023](sb)|0;if(vb>>>0>127){tb=vb;nb=o;while(1){b[nb>>0]=tb|128;ob=tb>>>7;h=nb+1|0;if(tb>>>0>16383){tb=ob;nb=h}else{md=h;nd=ob;break}}}else{md=o;nd=vb}b[md>>0]=nd;nb=li[f[(f[sb>>2]|0)+68>>2]&511](sb,d,md+1|0)|0;gd=gd+1|0;id=f[a>>2]|0;if((gd|0)>=(f[id+4>>2]|0)){k=nb;break}else hd=nb}u=g;return k|0}default:{k=e;u=g;return k|0}}while(0);return 0}function JFb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=a+4|0;a=f[g>>2]|0;if(!a){h=e;return h|0}else{i=g;j=a}a:while(1){a=j;while(1){if((f[a+16>>2]|0)>=(b|0))break;k=f[a+4>>2]|0;if(!k){l=i;break a}else a=k}j=f[a>>2]|0;if(!j){l=a;break}else i=a}if((l|0)==(g|0)){h=e;return h|0}else{m=e;n=l}while(1){l=f[n+16>>2]|0;if((l|0)>=(c|0)){h=m;o=14;break}e=IFb(n+24|0,l,d,m)|0;l=f[n+4>>2]|0;if(!l){i=n+8|0;j=f[i>>2]|0;if((f[j>>2]|0)==(n|0))p=j;else{j=i;do{i=f[j>>2]|0;j=i+8|0;b=f[j>>2]|0}while((f[b>>2]|0)!=(i|0));p=b}}else{j=l;while(1){a=f[j>>2]|0;if(!a)break;else j=a}p=j}if((p|0)==(g|0)){h=e;o=14;break}else{m=e;n=p}}if((o|0)==14)return h|0;return 0}function KFb(a){a=a|0;return}function LFb(a){a=a|0;O5b(a);return}function MFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;if((f[(f[(f[a+4>>2]|0)+8>>2]|0)+64>>2]|0)==3){if((f[213429]|0)!=2){f[e>>2]=135812;f[e+4>>2]=57;b[e+8>>0]=0;Gpb(853716,e);hpb(e)}g=f[213430]|0;u=d;return g|0}e=f[a+28>>2]|0;if((e|0)!=-1){g=c+e|0;u=d;return g|0}e=f[c+(f[a+36>>2]|0)>>2]|0;if(!(e&1)){g=DPb()|0;u=d;return g|0}else{g=e&-2;u=d;return g|0}return 0}function NFb(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[a+28>>2]|0;if((c|0)!=-1){d=b+c|0;return d|0}c=b+(f[a+36>>2]|0)|0;a=f[c>>2]|0;if(!(a&1)){d=hBa(c)|0;return d|0}else{d=a&-2;return d|0}return 0}function OFb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;d=f[a+40>>2]|0;e=(MPb(Uh[f[(f[a>>2]|0)+8>>2]&1023](a,c)|0)|0)+d|0;d=f[a+32>>2]|0;if((d|0)==-1)g=e;else g=(GFb(c+d|0)|0)+e|0;e=a+4|0;d=f[e>>2]|0;h=f[d+24>>2]|0;if((h|0)<=0){i=g;return i|0}j=a+16|0;k=a+24|0;l=a+12|0;m=a+8|0;a=0;n=g;g=d;d=h;while(1){h=f[g+28>>2]|0;o=h+(a*88|0)|0;a:do if((f[h+(a*88|0)+36>>2]|0)!=3){p=f[h+(a*88|0)+52>>2]|0;q=(p|0)==0;if(!q?(f[c+(f[k>>2]|0)+(((p-(f[(f[p+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)!=(f[h+(a*88|0)+28>>2]|0):0){r=n;break}switch(f[136e3+(f[h+(a*88|0)+32>>2]<<2)>>2]|0){case 10:{if((f[m>>2]|0)==(c|0)){r=n;break a}do if(q){s=o;do if(b[h+(a*88|0)+40>>0]|0){t=f[h+(a*88|0)+56>>2]|0;if(!t){u=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{u=t+68|0;break}}else u=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);v=(s-(f[u>>2]|0)|0)/88|0;w=261}else{t=(p-(f[(f[p+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[k>>2]|0)+(t<<2)>>2]|0)==(f[h+(a*88|0)+28>>2]|0)){v=d+t|0;w=261;break}t=f[j>>2]|0;x=f[l>>2]|0;y=o;do if(b[h+(a*88|0)+40>>0]|0){z=f[h+(a*88|0)+56>>2]|0;if(!z){A=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{A=z+68|0;break}}else A=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);B=t+(((y-(f[A>>2]|0)|0)/88|0)<<2)|0;C=x}while(0);if((w|0)==261){w=0;B=(f[j>>2]|0)+(v<<2)|0;C=c}s=f[C+(f[B>>2]|0)>>2]|0;if(!s){r=n;break a}r=(di[f[(f[s>>2]|0)+84>>2]&1023](s)|0)+n|0;break a;break}case 9:break;default:{r=n;break a}}s=f[j>>2]|0;z=f[(q?m:l)>>2]|0;D=(b[h+(a*88|0)+40>>0]|0)==0;E=o;do if(!D){F=f[h+(a*88|0)+56>>2]|0;if(!F){G=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{G=F+68|0;break}}else G=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);F=f[z+(f[s+(((E-(f[G>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]|0;do if(q){do if(!D){H=f[h+(a*88|0)+56>>2]|0;if(!H){I=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{I=H+68|0;break}}else I=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);J=(E-(f[I>>2]|0)|0)/88|0;K=c}else{x=(p-(f[(f[p+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[k>>2]|0)+(x<<2)>>2]|0)==(f[h+(a*88|0)+28>>2]|0)){J=d+x|0;K=c;break}x=f[l>>2]|0;do if(!D){y=f[h+(a*88|0)+56>>2]|0;if(!y){L=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{L=y+68|0;break}}else L=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);J=(E-(f[L>>2]|0)|0)/88|0;K=x}while(0);E=f[K+(f[s+(J<<2)>>2]|0)>>2]|0;if((E|0)==(F|0))r=n;else r=n+12+(Dnb(E)|0)|0}else do switch(f[136e3+(f[h+(a*88|0)+32>>2]<<2)>>2]|0){case 1:{E=f[h+(a*88|0)+52>>2]|0;do if(!E){D=o;do if(b[h+(a*88|0)+40>>0]|0){p=f[h+(a*88|0)+56>>2]|0;if(!p){M=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{M=p+68|0;break}}else M=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);N=(D-(f[M>>2]|0)|0)/88|0;w=23}else{p=(E-(f[(f[E+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[k>>2]|0)+(p<<2)>>2]|0)==(f[h+(a*88|0)+28>>2]|0)){N=p+d|0;w=23;break}p=f[j>>2]|0;q=f[l>>2]|0;z=o;do if(b[h+(a*88|0)+40>>0]|0){y=f[h+(a*88|0)+56>>2]|0;if(!y){O=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{O=y+68|0;break}}else O=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);P=p+(((z-(f[O>>2]|0)|0)/88|0)<<2)|0;Q=q}while(0);if((w|0)==23){w=0;P=(f[j>>2]|0)+(N<<2)|0;Q=c}E=Q+(f[P>>2]|0)|0;if(!(f[E+8>>2]|0))R=0;else R=(f[E+4>>2]<<2)+4|0;r=R+n|0;break a;break}case 2:{E=f[h+(a*88|0)+52>>2]|0;do if(!E){x=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){S=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{S=D+68|0;break}}else S=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);T=(x-(f[S>>2]|0)|0)/88|0;w=42}else{q=(E-(f[(f[E+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[k>>2]|0)+(q<<2)>>2]|0)==(f[h+(a*88|0)+28>>2]|0)){T=q+d|0;w=42;break}q=f[j>>2]|0;z=f[l>>2]|0;p=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){U=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{U=D+68|0;break}}else U=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);V=q+(((p-(f[U>>2]|0)|0)/88|0)<<2)|0;W=z}while(0);if((w|0)==42){w=0;V=(f[j>>2]|0)+(T<<2)|0;W=c}E=W+(f[V>>2]|0)|0;if(!(f[E+8>>2]|0))X=0;else X=(f[E+4>>2]<<3)+8|0;r=X+n|0;break a;break}case 3:{E=f[h+(a*88|0)+52>>2]|0;do if(!E){x=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){Y=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{Y=D+68|0;break}}else Y=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);Z=(x-(f[Y>>2]|0)|0)/88|0;w=61}else{z=(E-(f[(f[E+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[k>>2]|0)+(z<<2)>>2]|0)==(f[h+(a*88|0)+28>>2]|0)){Z=z+d|0;w=61;break}z=f[j>>2]|0;p=f[l>>2]|0;q=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){_=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{_=D+68|0;break}}else _=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);$=z+(((q-(f[_>>2]|0)|0)/88|0)<<2)|0;aa=p}while(0);if((w|0)==61){w=0;$=(f[j>>2]|0)+(Z<<2)|0;aa=c}E=aa+(f[$>>2]|0)|0;if(!(f[E+8>>2]|0))ba=0;else ba=(f[E+4>>2]<<2)+4|0;r=ba+n|0;break a;break}case 4:{E=f[h+(a*88|0)+52>>2]|0;do if(!E){x=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){ca=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{ca=D+68|0;break}}else ca=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);da=(x-(f[ca>>2]|0)|0)/88|0;w=80}else{p=(E-(f[(f[E+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[k>>2]|0)+(p<<2)>>2]|0)==(f[h+(a*88|0)+28>>2]|0)){da=p+d|0;w=80;break}p=f[j>>2]|0;q=f[l>>2]|0;z=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){ea=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{ea=D+68|0;break}}else ea=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);fa=p+(((z-(f[ea>>2]|0)|0)/88|0)<<2)|0;ga=q}while(0);if((w|0)==80){w=0;fa=(f[j>>2]|0)+(da<<2)|0;ga=c}E=ga+(f[fa>>2]|0)|0;if(!(f[E+8>>2]|0))ha=0;else ha=(f[E+4>>2]<<3)+8|0;r=ha+n|0;break a;break}case 5:{E=f[h+(a*88|0)+52>>2]|0;do if(!E){x=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){ia=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{ia=D+68|0;break}}else ia=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);ja=(x-(f[ia>>2]|0)|0)/88|0;w=99}else{q=(E-(f[(f[E+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[k>>2]|0)+(q<<2)>>2]|0)==(f[h+(a*88|0)+28>>2]|0)){ja=q+d|0;w=99;break}q=f[j>>2]|0;z=f[l>>2]|0;p=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){ka=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{ka=D+68|0;break}}else ka=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);la=q+(((p-(f[ka>>2]|0)|0)/88|0)<<2)|0;ma=z}while(0);if((w|0)==99){w=0;la=(f[j>>2]|0)+(ja<<2)|0;ma=c}E=ma+(f[la>>2]|0)|0;if(!(f[E+8>>2]|0))na=0;else na=(f[E+4>>2]<<3)+8|0;r=na+n|0;break a;break}case 6:{E=f[h+(a*88|0)+52>>2]|0;do if(!E){x=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){oa=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{oa=D+68|0;break}}else oa=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);pa=(x-(f[oa>>2]|0)|0)/88|0;w=118}else{z=(E-(f[(f[E+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[k>>2]|0)+(z<<2)>>2]|0)==(f[h+(a*88|0)+28>>2]|0)){pa=z+d|0;w=118;break}z=f[j>>2]|0;p=f[l>>2]|0;q=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){qa=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{qa=D+68|0;break}}else qa=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);ra=z+(((q-(f[qa>>2]|0)|0)/88|0)<<2)|0;sa=p}while(0);if((w|0)==118){w=0;ra=(f[j>>2]|0)+(pa<<2)|0;sa=c}E=sa+(f[ra>>2]|0)|0;if(!(f[E+8>>2]|0))ta=0;else ta=(f[E+4>>2]<<2)+4|0;r=ta+n|0;break a;break}case 7:{E=f[h+(a*88|0)+52>>2]|0;do if(!E){x=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){ua=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{ua=D+68|0;break}}else ua=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);va=(x-(f[ua>>2]|0)|0)/88|0;w=137}else{p=(E-(f[(f[E+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[k>>2]|0)+(p<<2)>>2]|0)==(f[h+(a*88|0)+28>>2]|0)){va=p+d|0;w=137;break}p=f[j>>2]|0;q=f[l>>2]|0;z=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){wa=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{wa=D+68|0;break}}else wa=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);xa=p+(((z-(f[wa>>2]|0)|0)/88|0)<<2)|0;ya=q}while(0);if((w|0)==137){w=0;xa=(f[j>>2]|0)+(va<<2)|0;ya=c}E=ya+(f[xa>>2]|0)|0;if(!(f[E+8>>2]|0))za=0;else za=(f[E+4>>2]|0)+4|0;r=za+n|0;break a;break}case 8:{E=f[h+(a*88|0)+52>>2]|0;do if(!E){x=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){Aa=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{Aa=D+68|0;break}}else Aa=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);Ba=(x-(f[Aa>>2]|0)|0)/88|0;w=156}else{q=(E-(f[(f[E+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[k>>2]|0)+(q<<2)>>2]|0)==(f[h+(a*88|0)+28>>2]|0)){Ba=q+d|0;w=156;break}q=f[j>>2]|0;z=f[l>>2]|0;p=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){Ca=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{Ca=D+68|0;break}}else Ca=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);Da=q+(((p-(f[Ca>>2]|0)|0)/88|0)<<2)|0;Ea=z}while(0);if((w|0)==156){w=0;Da=(f[j>>2]|0)+(Ba<<2)|0;Ea=c}E=Ea+(f[Da>>2]|0)|0;if(!(f[E+8>>2]|0))Fa=0;else Fa=(f[E+4>>2]<<2)+4|0;r=Fa+n|0;break a;break}case 9:{E=f[h+(a*88|0)+52>>2]|0;do if(!E){x=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){Ga=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{Ga=D+68|0;break}}else Ga=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);Ha=(x-(f[Ga>>2]|0)|0)/88|0;w=175}else{z=(E-(f[(f[E+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[k>>2]|0)+(z<<2)>>2]|0)==(f[h+(a*88|0)+28>>2]|0)){Ha=z+d|0;w=175;break}z=f[j>>2]|0;p=f[l>>2]|0;q=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){Ia=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{Ia=D+68|0;break}}else Ia=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);Ja=z+(((q-(f[Ia>>2]|0)|0)/88|0)<<2)|0;Ka=p}while(0);if((w|0)==175){w=0;Ja=(f[j>>2]|0)+(Ha<<2)|0;Ka=c}E=Ka+(f[Ja>>2]|0)|0;x=f[E+8>>2]<<2;D=E+12|0;E=f[D>>2]|0;if(!E)La=x;else{if((f[E>>2]|0)>0){y=0;t=x;H=E;while(1){E=t+12+(Dnb(f[H+4+(y<<2)>>2]|0)|0)|0;y=y+1|0;H=f[D>>2]|0;if((y|0)>=(f[H>>2]|0)){Ma=E;break}else t=E}}else Ma=x;La=Ma+4|0}r=La+n|0;break a;break}case 10:{t=xub(o)|0;H=f[h+(a*88|0)+52>>2]|0;y=(H|0)==0;if(t){do if(y){t=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){Na=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{Na=D+68|0;break}}else Na=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);Oa=(t-(f[Na>>2]|0)|0)/88|0;w=197}else{p=(H-(f[(f[H+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[k>>2]|0)+(p<<2)>>2]|0)==(f[h+(a*88|0)+28>>2]|0)){Oa=(f[(f[e>>2]|0)+24>>2]|0)+p|0;w=197;break}p=f[j>>2]|0;q=f[l>>2]|0;z=o;do if(b[h+(a*88|0)+40>>0]|0){D=f[h+(a*88|0)+56>>2]|0;if(!D){Pa=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{Pa=D+68|0;break}}else Pa=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);Qa=p+(((z-(f[Pa>>2]|0)|0)/88|0)<<2)|0;Ra=q}while(0);if((w|0)==197){w=0;Qa=(f[j>>2]|0)+(Oa<<2)|0;Ra=c}r=(qKb(Ra+(f[Qa>>2]|0)|0)|0)+n|0;break a}do if(y){x=o;do if(b[h+(a*88|0)+40>>0]|0){t=f[h+(a*88|0)+56>>2]|0;if(!t){Sa=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{Sa=t+68|0;break}}else Sa=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);Ta=(x-(f[Sa>>2]|0)|0)/88|0;w=214}else{q=(H-(f[(f[H+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[k>>2]|0)+(q<<2)>>2]|0)==(f[h+(a*88|0)+28>>2]|0)){Ta=(f[(f[e>>2]|0)+24>>2]|0)+q|0;w=214;break}q=f[j>>2]|0;z=f[l>>2]|0;p=o;do if(b[h+(a*88|0)+40>>0]|0){t=f[h+(a*88|0)+56>>2]|0;if(!t){Ua=(f[h+(a*88|0)+24>>2]|0)+72|0;break}else{Ua=t+68|0;break}}else Ua=(f[h+(a*88|0)+48>>2]|0)+28|0;while(0);Va=q+(((p-(f[Ua>>2]|0)|0)/88|0)<<2)|0;Wa=z}while(0);if((w|0)==214){w=0;Va=(f[j>>2]|0)+(Ta<<2)|0;Wa=c}H=Wa+(f[Va>>2]|0)|0;y=f[H+8>>2]<<2;x=H+12|0;H=f[x>>2]|0;if(!H)Xa=y;else{if((f[H>>2]|0)>0){t=0;D=y;E=H;while(1){H=f[E+4+(t<<2)>>2]|0;Ya=(di[f[(f[H>>2]|0)+84>>2]&1023](H)|0)+D|0;t=t+1|0;E=f[x>>2]|0;if((t|0)>=(f[E>>2]|0)){Za=Ya;break}else D=Ya}}else Za=y;Xa=Za+4|0}r=Xa+n|0;break a;break}default:{r=n;break a}}while(0);while(0);a=a+1|0;g=f[e>>2]|0;d=f[g+24>>2]|0;if((a|0)>=(d|0)){i=r;break}else n=r}return i|0}function PFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=a+4|0;g=f[e>>2]|0;if((f[d+48>>2]|0)!=(g|0))tHb(g,d,470070,468162);if((f[d+36>>2]|0)==3)tHb(f[e>>2]|0,d,470070,469189);if(b[d+40>>0]|0){h=vQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0)|0;return h|0}e=f[d+52>>2]|0;if(!e){h=LHb(a,c,d)|0;return h|0}else{h=(f[c+(f[a+24>>2]|0)+(((e-(f[(f[e+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)==(f[d+28>>2]|0);return h|0}return 0}function QFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;e=u;u=u+32|0;g=e;h=e+24|0;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tHb(k,d,470060,468162);if((f[d+36>>2]|0)!=3)tHb(f[j>>2]|0,d,470060,467614);k=d+40|0;if(b[k>>0]|0){l=wQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0)|0;u=e;return l|0}do switch(f[136e3+(f[d+32>>2]<<2)>>2]|0){case 1:{m=f[d+52>>2]|0;do if(m){n=(m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(n<<2)>>2]|0)==(f[d+28>>2]|0)){o=c;p=(f[(f[j>>2]|0)+24>>2]|0)+n|0;q=13;break}else{r=(f[a+16>>2]|0)+(((d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;s=f[a+12>>2]|0;break}}else{o=c;p=(d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0;q=13}while(0);if((q|0)==13){r=(f[a+16>>2]|0)+(p<<2)|0;s=o}l=f[s+(f[r>>2]|0)>>2]|0;u=e;return l|0}case 2:{m=f[d+52>>2]|0;do if(m){n=(m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(n<<2)>>2]|0)==(f[d+28>>2]|0)){t=c;v=(f[(f[j>>2]|0)+24>>2]|0)+n|0;q=20;break}else{w=(f[a+16>>2]|0)+(((d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;x=f[a+12>>2]|0;break}}else{t=c;v=(d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0;q=20}while(0);if((q|0)==20){w=(f[a+16>>2]|0)+(v<<2)|0;x=t}l=f[x+(f[w>>2]|0)>>2]|0;u=e;return l|0}case 3:{m=f[d+52>>2]|0;do if(m){n=(m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(n<<2)>>2]|0)==(f[d+28>>2]|0)){y=c;z=(f[(f[j>>2]|0)+24>>2]|0)+n|0;q=27;break}else{A=(f[a+16>>2]|0)+(((d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;B=f[a+12>>2]|0;break}}else{y=c;z=(d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0;q=27}while(0);if((q|0)==27){A=(f[a+16>>2]|0)+(z<<2)|0;B=y}l=f[B+(f[A>>2]|0)>>2]|0;u=e;return l|0}case 4:{m=f[d+52>>2]|0;do if(m){n=(m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(n<<2)>>2]|0)==(f[d+28>>2]|0)){C=c;D=(f[(f[j>>2]|0)+24>>2]|0)+n|0;q=34;break}else{E=(f[a+16>>2]|0)+(((d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;F=f[a+12>>2]|0;break}}else{C=c;D=(d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0;q=34}while(0);if((q|0)==34){E=(f[a+16>>2]|0)+(D<<2)|0;F=C}l=f[F+(f[E>>2]|0)>>2]|0;u=e;return l|0}case 5:{m=f[d+52>>2]|0;do if(m){n=(m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(n<<2)>>2]|0)==(f[d+28>>2]|0)){G=c;H=(f[(f[j>>2]|0)+24>>2]|0)+n|0;q=41;break}else{I=(f[a+16>>2]|0)+(((d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;J=f[a+12>>2]|0;break}}else{G=c;H=(d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0;q=41}while(0);if((q|0)==41){I=(f[a+16>>2]|0)+(H<<2)|0;J=G}l=f[J+(f[I>>2]|0)>>2]|0;u=e;return l|0}case 6:{m=f[d+52>>2]|0;do if(m){n=(m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(n<<2)>>2]|0)==(f[d+28>>2]|0)){K=c;L=(f[(f[j>>2]|0)+24>>2]|0)+n|0;q=48;break}else{M=(f[a+16>>2]|0)+(((d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;N=f[a+12>>2]|0;break}}else{K=c;L=(d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0;q=48}while(0);if((q|0)==48){M=(f[a+16>>2]|0)+(L<<2)|0;N=K}l=f[N+(f[M>>2]|0)>>2]|0;u=e;return l|0}case 7:{m=f[d+52>>2]|0;do if(m){n=(m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(n<<2)>>2]|0)==(f[d+28>>2]|0)){O=c;P=(f[(f[j>>2]|0)+24>>2]|0)+n|0;q=55;break}else{Q=(f[a+16>>2]|0)+(((d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;R=f[a+12>>2]|0;break}}else{O=c;P=(d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0;q=55}while(0);if((q|0)==55){Q=(f[a+16>>2]|0)+(P<<2)|0;R=O}l=f[R+(f[Q>>2]|0)>>2]|0;u=e;return l|0}case 8:{m=f[d+52>>2]|0;do if(m){n=(m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(n<<2)>>2]|0)==(f[d+28>>2]|0)){S=c;T=(f[(f[j>>2]|0)+24>>2]|0)+n|0;q=62;break}else{U=(f[a+16>>2]|0)+(((d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;V=f[a+12>>2]|0;break}}else{S=c;T=(d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0;q=62}while(0);if((q|0)==62){U=(f[a+16>>2]|0)+(T<<2)|0;V=S}l=f[V+(f[U>>2]|0)>>2]|0;u=e;return l|0}case 10:case 9:{m=xub(d)|0;n=f[d+52>>2]|0;W=(n|0)==0;if(m){do if(W){m=d;do if(b[k>>0]|0){X=f[d+56>>2]|0;if(!X){Y=(f[d+24>>2]|0)+72|0;break}else{Y=X+68|0;break}}else Y=(f[i>>2]|0)+28|0;while(0);Z=c;_=(m-(f[Y>>2]|0)|0)/88|0;q=80}else{X=(n-(f[(f[n+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(X<<2)>>2]|0)==(f[d+28>>2]|0)){Z=c;_=(f[(f[j>>2]|0)+24>>2]|0)+X|0;q=80;break}X=f[a+16>>2]|0;$=f[a+12>>2]|0;aa=d;do if(b[k>>0]|0){ba=f[d+56>>2]|0;if(!ba){ca=(f[d+24>>2]|0)+72|0;break}else{ca=ba+68|0;break}}else ca=(f[i>>2]|0)+28|0;while(0);da=X+(((aa-(f[ca>>2]|0)|0)/88|0)<<2)|0;ea=$}while(0);if((q|0)==80){da=(f[a+16>>2]|0)+(_<<2)|0;ea=Z}m=(oKb(ea+(f[da>>2]|0)|0)|0)+4|0;l=f[m>>2]|0;u=e;return l|0}else{do if(W){m=d;do if(b[k>>0]|0){ba=f[d+56>>2]|0;if(!ba){fa=(f[d+24>>2]|0)+72|0;break}else{fa=ba+68|0;break}}else fa=(f[i>>2]|0)+28|0;while(0);ga=c;ha=(m-(f[fa>>2]|0)|0)/88|0;q=97}else{$=(n-(f[(f[n+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+($<<2)>>2]|0)==(f[d+28>>2]|0)){ga=c;ha=(f[(f[j>>2]|0)+24>>2]|0)+$|0;q=97;break}$=f[a+16>>2]|0;aa=f[a+12>>2]|0;X=d;do if(b[k>>0]|0){ba=f[d+56>>2]|0;if(!ba){ia=(f[d+24>>2]|0)+72|0;break}else{ia=ba+68|0;break}}else ia=(f[i>>2]|0)+28|0;while(0);ja=$+(((X-(f[ia>>2]|0)|0)/88|0)<<2)|0;ka=aa}while(0);if((q|0)==97){ja=(f[a+16>>2]|0)+(ha<<2)|0;ka=ga}l=f[ka+(f[ja>>2]|0)+4>>2]|0;u=e;return l|0}break}default:{zpb(g,3,466902,777);xpb(h,vpb(g,477853)|0);Apb(g);l=0;u=e;return l|0}}while(0);return 0}function RFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=d+48|0;g=a+4|0;h=f[g>>2]|0;if((f[e>>2]|0)!=(h|0))tHb(h,d,470049,468162);h=d+40|0;if(b[h>>0]|0){yQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0);return}if((f[d+36>>2]|0)==3)do switch(f[136e3+(f[d+32>>2]<<2)>>2]|0){case 1:{i=f[d+52>>2]|0;if(!i)j=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else j=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(j<<2)>>2]|0)>>2]=0;return}case 2:{i=f[d+52>>2]|0;if(!i)k=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else k=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(k<<2)>>2]|0)>>2]=0;return}case 3:{i=f[d+52>>2]|0;if(!i)l=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else l=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(l<<2)>>2]|0)>>2]=0;return}case 4:{i=f[d+52>>2]|0;if(!i)m=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else m=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(m<<2)>>2]|0)>>2]=0;return}case 5:{i=f[d+52>>2]|0;if(!i)n=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else n=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(n<<2)>>2]|0)>>2]=0;return}case 6:{i=f[d+52>>2]|0;if(!i)o=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else o=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(o<<2)>>2]|0)>>2]=0;return}case 7:{i=f[d+52>>2]|0;if(!i)q=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else q=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(q<<2)>>2]|0)>>2]=0;return}case 8:{i=f[d+52>>2]|0;if(!i)r=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else r=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(r<<2)>>2]|0)>>2]=0;return}case 9:{i=f[d+52>>2]|0;if(!i)s=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else s=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;i=c+(f[(f[a+16>>2]|0)+(s<<2)>>2]|0)|0;t=i+4|0;u=f[t>>2]|0;if((u|0)<=0)return;v=f[i+12>>2]|0;i=0;do{w=f[v+4+(i<<2)>>2]|0;i=i+1|0;x=w+11|0;if((b[x>>0]|0)<0){b[f[w>>2]>>0]=0;f[w+4>>2]=0}else{b[w>>0]=0;b[x>>0]=0}}while((i|0)!=(u|0));f[t>>2]=0;return}case 10:{u=xub(d)|0;i=f[d+52>>2]|0;v=(i|0)==0;if(u){if(v){u=d;do if(b[h>>0]|0){x=f[d+56>>2]|0;if(!x){y=(f[d+24>>2]|0)+72|0;break}else{y=x+68|0;break}}else y=(f[e>>2]|0)+28|0;while(0);z=(u-(f[y>>2]|0)|0)/88|0}else z=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;t=pKb(c+(f[(f[a+16>>2]|0)+(z<<2)>>2]|0)|0)|0;x=t+4|0;w=f[x>>2]|0;if((w|0)<=0)return;A=f[t+12>>2]|0;t=0;do{B=f[A+4+(t<<2)>>2]|0;t=t+1|0;bi[f[(f[B>>2]|0)+28>>2]&2047](B)}while((t|0)!=(w|0));f[x>>2]=0;return}else{if(v){w=d;do if(b[h>>0]|0){t=f[d+56>>2]|0;if(!t){C=(f[d+24>>2]|0)+72|0;break}else{C=t+68|0;break}}else C=(f[e>>2]|0)+28|0;while(0);D=(w-(f[C>>2]|0)|0)/88|0}else D=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;v=c+(f[(f[a+16>>2]|0)+(D<<2)>>2]|0)|0;x=v+4|0;t=f[x>>2]|0;if((t|0)<=0)return;A=f[v+12>>2]|0;v=0;do{u=f[A+4+(v<<2)>>2]|0;v=v+1|0;bi[f[(f[u>>2]|0)+28>>2]&2047](u)}while((v|0)!=(t|0));f[x>>2]=0;return}break}default:return}while(0);D=d+52|0;C=f[D>>2]|0;if(C|0){if((f[c+(f[a+24>>2]|0)+(((C-(f[(f[C+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)!=(f[d+28>>2]|0))return;_h[f[(f[a>>2]|0)+36>>2]&255](a,c,C);return}if(!(LHb(a,c,d)|0))return;C=a+20|0;z=f[C>>2]|0;if((z|0)!=-1){y=d;do if(b[h>>0]|0){s=f[d+56>>2]|0;if(!s){E=(f[d+24>>2]|0)+72|0;break}else{E=s+68|0;break}}else E=(f[e>>2]|0)+28|0;while(0);s=(y-(f[E>>2]|0)|0)/88|0;E=c+z+(s>>>5<<2)|0;f[E>>2]=f[E>>2]&~(1<<(s&31))}do switch(f[136e3+(f[d+32>>2]<<2)>>2]|0){case 1:{s=f[d+80>>2]|0;E=f[D>>2]|0;if(!E){z=d;do if(b[h>>0]|0){y=f[d+56>>2]|0;if(!y){F=(f[d+24>>2]|0)+72|0;break}else{F=y+68|0;break}}else F=(f[e>>2]|0)+28|0;while(0);G=(z-(f[F>>2]|0)|0)/88|0}else G=((E-(f[(f[E+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(G<<2)>>2]|0)>>2]=s;return}case 2:{x=d+80|0;y=f[x>>2]|0;r=f[x+4>>2]|0;x=f[D>>2]|0;if(!x){q=d;do if(b[h>>0]|0){o=f[d+56>>2]|0;if(!o){H=(f[d+24>>2]|0)+72|0;break}else{H=o+68|0;break}}else H=(f[e>>2]|0)+28|0;while(0);I=(q-(f[H>>2]|0)|0)/88|0}else I=((x-(f[(f[x+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;s=c+(f[(f[a+16>>2]|0)+(I<<2)>>2]|0)|0;f[s>>2]=y;f[s+4>>2]=r;return}case 3:{s=f[d+80>>2]|0;E=f[D>>2]|0;if(!E){z=d;do if(b[h>>0]|0){o=f[d+56>>2]|0;if(!o){J=(f[d+24>>2]|0)+72|0;break}else{J=o+68|0;break}}else J=(f[e>>2]|0)+28|0;while(0);K=(z-(f[J>>2]|0)|0)/88|0}else K=((E-(f[(f[E+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(K<<2)>>2]|0)>>2]=s;return}case 4:{r=d+80|0;y=f[r>>2]|0;x=f[r+4>>2]|0;r=f[D>>2]|0;if(!r){q=d;do if(b[h>>0]|0){o=f[d+56>>2]|0;if(!o){L=(f[d+24>>2]|0)+72|0;break}else{L=o+68|0;break}}else L=(f[e>>2]|0)+28|0;while(0);M=(q-(f[L>>2]|0)|0)/88|0}else M=((r-(f[(f[r+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;s=c+(f[(f[a+16>>2]|0)+(M<<2)>>2]|0)|0;f[s>>2]=y;f[s+4>>2]=x;return}case 6:{s=f[d+80>>2]|0;E=f[D>>2]|0;if(!E){z=d;do if(b[h>>0]|0){o=f[d+56>>2]|0;if(!o){N=(f[d+24>>2]|0)+72|0;break}else{N=o+68|0;break}}else N=(f[e>>2]|0)+28|0;while(0);O=(z-(f[N>>2]|0)|0)/88|0}else O=((E-(f[(f[E+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(O<<2)>>2]|0)>>2]=s;return}case 5:{P=+p[d+80>>3];x=f[D>>2]|0;if(!x){y=d;do if(b[h>>0]|0){r=f[d+56>>2]|0;if(!r){Q=(f[d+24>>2]|0)+72|0;break}else{Q=r+68|0;break}}else Q=(f[e>>2]|0)+28|0;while(0);R=(y-(f[Q>>2]|0)|0)/88|0}else R=((x-(f[(f[x+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;p[c+(f[(f[a+16>>2]|0)+(R<<2)>>2]|0)>>3]=P;return}case 7:{s=b[d+80>>0]|0;E=f[D>>2]|0;if(!E){z=d;do if(b[h>>0]|0){r=f[d+56>>2]|0;if(!r){S=(f[d+24>>2]|0)+72|0;break}else{S=r+68|0;break}}else S=(f[e>>2]|0)+28|0;while(0);T=(z-(f[S>>2]|0)|0)/88|0}else T=((E-(f[(f[E+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;b[c+(f[(f[a+16>>2]|0)+(T<<2)>>2]|0)>>0]=s;return}case 8:{x=f[(f[d+80>>2]|0)+8>>2]|0;y=f[D>>2]|0;if(!y){r=d;do if(b[h>>0]|0){q=f[d+56>>2]|0;if(!q){U=(f[d+24>>2]|0)+72|0;break}else{U=q+68|0;break}}else U=(f[e>>2]|0)+28|0;while(0);V=(r-(f[U>>2]|0)|0)/88|0}else V=((y-(f[(f[y+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(V<<2)>>2]|0)>>2]=x;return}case 9:{s=f[D>>2]|0;E=(s|0)==0;z=f[a+16>>2]|0;q=f[(E?a+8|0:a+12|0)>>2]|0;o=(b[h>>0]|0)==0;n=d;do if(!o){m=f[d+56>>2]|0;if(!m){W=(f[d+24>>2]|0)+72|0;break}else{W=m+68|0;break}}else W=(f[e>>2]|0)+28|0;while(0);x=f[q+(f[z+(((n-(f[W>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]|0;if(E){do if(!o){y=f[d+56>>2]|0;if(!y){X=(f[d+24>>2]|0)+72|0;break}else{X=y+68|0;break}}else X=(f[e>>2]|0)+28|0;while(0);Y=(n-(f[X>>2]|0)|0)/88|0}else Y=((s-(f[(f[s+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;o=c+(f[z+(Y<<2)>>2]|0)|0;E=f[a+36>>2]|0;if((E|0)!=-1){q=c+E|0;do if((f[a+28>>2]|0)==-1){E=f[q>>2]|0;y=E&-2;if(!(E&1)){Z=y;break}else{Z=f[y+4>>2]|0;break}}else Z=f[q>>2]|0;while(0);if(Z)_=o;else{$=o;aa=111}}else{$=o;aa=111}if((aa|0)==111){q=f[$>>2]|0;if((q|0)==(x|0)|(q|0)==0)_=$;else{if((b[q+11>>0]|0)<0)O5b(f[q>>2]|0);O5b(q);_=$}}f[_>>2]=x;return}case 10:{if((f[C>>2]|0)!=-1){q=f[D>>2]|0;if(!q){z=d;do if(b[h>>0]|0){s=f[d+56>>2]|0;if(!s){ba=(f[d+24>>2]|0)+72|0;break}else{ba=s+68|0;break}}else ba=(f[e>>2]|0)+28|0;while(0);ca=(z-(f[ba>>2]|0)|0)/88|0}else ca=((q-(f[(f[q+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;x=f[c+(f[(f[a+16>>2]|0)+(ca<<2)>>2]|0)>>2]|0;bi[f[(f[x>>2]|0)+28>>2]&2047](x);return}x=f[a+36>>2]|0;if((x|0)!=-1){o=c+x|0;do if((f[a+28>>2]|0)==-1){x=f[o>>2]|0;s=x&-2;if(!(x&1)){da=s;break}else{da=f[s+4>>2]|0;break}}else da=f[o>>2]|0;while(0);if(!da)aa=124}else aa=124;if((aa|0)==124){o=f[D>>2]|0;if(!o){q=d;do if(b[h>>0]|0){z=f[d+56>>2]|0;if(!z){ea=(f[d+24>>2]|0)+72|0;break}else{ea=z+68|0;break}}else ea=(f[e>>2]|0)+28|0;while(0);fa=(q-(f[ea>>2]|0)|0)/88|0}else fa=((o-(f[(f[o+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;z=f[c+(f[(f[a+16>>2]|0)+(fa<<2)>>2]|0)>>2]|0;if(z|0)bi[f[(f[z>>2]|0)+4>>2]&2047](z)}z=f[D>>2]|0;if(!z){s=d;do if(b[h>>0]|0){x=f[d+56>>2]|0;if(!x){ga=(f[d+24>>2]|0)+72|0;break}else{ga=x+68|0;break}}else ga=(f[e>>2]|0)+28|0;while(0);ha=(s-(f[ga>>2]|0)|0)/88|0}else ha=((z-(f[(f[z+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(ha<<2)>>2]|0)>>2]=0;return}default:return}while(0)}function SFb(a,b,c){a=a|0;b=b|0;c=c|0;return (f[b+(f[a+24>>2]|0)+(((c-(f[(f[c+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)!=0|0}function TFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=a+24|0;g=d+8|0;h=d;d=f[c+(f[e>>2]|0)+(((h-(f[(f[g>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0;if(!d)return;i=a+4|0;j=oub(f[i>>2]|0,d)|0;d=a+36|0;k=f[d>>2]|0;if((k|0)!=-1){l=c+k|0;do if((f[a+28>>2]|0)==-1){k=f[l>>2]|0;m=k&-2;if(!(k&1)){n=m;break}else{n=f[m+4>>2]|0;break}}else n=f[l>>2]|0;while(0);if(!n)o=9}else o=9;a:do if((o|0)==9){switch(f[136e3+(f[j+32>>2]<<2)>>2]|0){case 9:break;case 10:{n=f[j+52>>2]|0;if(!n){l=j;do if(b[j+40>>0]|0){m=f[j+56>>2]|0;if(!m){p=(f[j+24>>2]|0)+72|0;break}else{p=m+68|0;break}}else p=(f[j+48>>2]|0)+28|0;while(0);q=(l-(f[p>>2]|0)|0)/88|0}else q=((n-(f[(f[n+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;m=f[c+(f[(f[a+16>>2]|0)+(q<<2)>>2]|0)>>2]|0;if(!m)break a;bi[f[(f[m>>2]|0)+4>>2]&2047](m);break a;break}default:break a}m=f[j+52>>2]|0;k=(m|0)==0;r=f[a+16>>2]|0;s=f[(k?a+8|0:a+12|0)>>2]|0;t=(b[j+40>>0]|0)==0;u=j;do if(!t){v=f[j+56>>2]|0;if(!v){w=(f[j+24>>2]|0)+72|0;break}else{w=v+68|0;break}}else w=(f[j+48>>2]|0)+28|0;while(0);n=f[s+(f[r+(((u-(f[w>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]|0;if(k){l=f[a+20>>2]|0;if((l|0)!=-1){do if(!t){v=f[j+56>>2]|0;if(!v){x=(f[j+24>>2]|0)+72|0;break}else{x=v+68|0;break}}else x=(f[j+48>>2]|0)+28|0;while(0);k=(u-(f[x>>2]|0)|0)/88|0;s=c+l+(k>>>5<<2)|0;f[s>>2]=1<<(k&31)|f[s>>2]}do if(!t){s=f[j+56>>2]|0;if(!s){y=(f[j+24>>2]|0)+72|0;break}else{y=s+68|0;break}}else y=(f[j+48>>2]|0)+28|0;while(0);z=(u-(f[y>>2]|0)|0)/88|0}else{t=(m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0;f[c+(f[e>>2]|0)+(t<<2)>>2]=f[j+28>>2];z=t+(f[(f[i>>2]|0)+24>>2]|0)|0}t=c+(f[r+(z<<2)>>2]|0)|0;l=f[d>>2]|0;if((l|0)!=-1){s=c+l|0;do if((f[a+28>>2]|0)==-1){l=f[s>>2]|0;k=l&-2;if(!(l&1)){A=k;break}else{A=f[k+4>>2]|0;break}}else A=f[s>>2]|0;while(0);if(A)B=t;else{C=t;o=38}}else{C=t;o=38}if((o|0)==38){s=f[C>>2]|0;if((s|0)==(n|0)|(s|0)==0)B=C;else{if((b[s+11>>0]|0)<0)O5b(f[s>>2]|0);O5b(s);B=C}}f[B>>2]=n}while(0);f[c+(f[e>>2]|0)+(((h-(f[(f[g>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]=0;return}function UFb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=f[b+(f[a+24>>2]|0)+(((c-(f[(f[c+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0;if(!d){e=0;return e|0}e=oub(f[a+4>>2]|0,d)|0;return e|0}function VFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=d+48|0;g=a+4|0;h=f[g>>2]|0;if((f[e>>2]|0)!=(h|0))tHb(h,d,470038,468162);if((f[d+36>>2]|0)!=3)tHb(f[g>>2]|0,d,470038,467614);h=d+40|0;if(b[h>>0]|0){ORb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0);return}do switch(f[136e3+(f[d+32>>2]<<2)>>2]|0){case 1:{i=f[d+52>>2]|0;if(!i)j=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else j=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;i=c+(f[(f[a+16>>2]|0)+(j<<2)>>2]|0)|0;f[i>>2]=(f[i>>2]|0)+-1;return}case 2:{i=f[d+52>>2]|0;if(!i)k=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else k=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;i=c+(f[(f[a+16>>2]|0)+(k<<2)>>2]|0)|0;f[i>>2]=(f[i>>2]|0)+-1;return}case 3:{i=f[d+52>>2]|0;if(!i)l=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else l=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;i=c+(f[(f[a+16>>2]|0)+(l<<2)>>2]|0)|0;f[i>>2]=(f[i>>2]|0)+-1;return}case 4:{i=f[d+52>>2]|0;if(!i)m=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else m=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;i=c+(f[(f[a+16>>2]|0)+(m<<2)>>2]|0)|0;f[i>>2]=(f[i>>2]|0)+-1;return}case 5:{i=f[d+52>>2]|0;if(!i)n=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else n=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;i=c+(f[(f[a+16>>2]|0)+(n<<2)>>2]|0)|0;f[i>>2]=(f[i>>2]|0)+-1;return}case 6:{i=f[d+52>>2]|0;if(!i)o=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else o=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;i=c+(f[(f[a+16>>2]|0)+(o<<2)>>2]|0)|0;f[i>>2]=(f[i>>2]|0)+-1;return}case 7:{i=f[d+52>>2]|0;if(!i)p=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else p=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;i=c+(f[(f[a+16>>2]|0)+(p<<2)>>2]|0)|0;f[i>>2]=(f[i>>2]|0)+-1;return}case 8:{i=f[d+52>>2]|0;if(!i)q=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else q=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;i=c+(f[(f[a+16>>2]|0)+(q<<2)>>2]|0)|0;f[i>>2]=(f[i>>2]|0)+-1;return}case 9:{i=f[d+52>>2]|0;if(!i)r=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;else r=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;i=c+(f[(f[a+16>>2]|0)+(r<<2)>>2]|0)|0;s=f[i+12>>2]|0;t=i+4|0;i=(f[t>>2]|0)+-1|0;f[t>>2]=i;t=f[s+4+(i<<2)>>2]|0;i=t+11|0;if((b[i>>0]|0)<0){b[f[t>>2]>>0]=0;f[t+4>>2]=0;return}else{b[t>>0]=0;b[i>>0]=0;return}break}case 10:{i=xub(d)|0;t=f[d+52>>2]|0;s=(t|0)==0;if(i){if(s){i=d;do if(b[h>>0]|0){u=f[d+56>>2]|0;if(!u){v=(f[d+24>>2]|0)+72|0;break}else{v=u+68|0;break}}else v=(f[e>>2]|0)+28|0;while(0);w=(i-(f[v>>2]|0)|0)/88|0}else w=((t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;u=pKb(c+(f[(f[a+16>>2]|0)+(w<<2)>>2]|0)|0)|0;x=f[u+12>>2]|0;y=u+4|0;u=(f[y>>2]|0)+-1|0;f[y>>2]=u;y=f[x+4+(u<<2)>>2]|0;bi[f[(f[y>>2]|0)+28>>2]&2047](y);return}else{if(s){y=d;do if(b[h>>0]|0){u=f[d+56>>2]|0;if(!u){z=(f[d+24>>2]|0)+72|0;break}else{z=u+68|0;break}}else z=(f[e>>2]|0)+28|0;while(0);A=(y-(f[z>>2]|0)|0)/88|0}else A=((t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;s=c+(f[(f[a+16>>2]|0)+(A<<2)>>2]|0)|0;i=f[s+12>>2]|0;u=s+4|0;s=(f[u>>2]|0)+-1|0;f[u>>2]=s;u=f[i+4+(s<<2)>>2]|0;bi[f[(f[u>>2]|0)+28>>2]&2047](u);return}break}default:return}while(0)}function WFb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=d+48|0;g=a+4|0;h=f[g>>2]|0;if((f[e>>2]|0)!=(h|0))tHb(h,d,470026,468162);if((f[d+36>>2]|0)!=3)tHb(f[g>>2]|0,d,470026,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=10)vHb(f[g>>2]|0,d,470026,10);h=d+40|0;if(b[h>>0]|0){i=PRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0)|0;return i|0}j=xub(d)|0;k=f[d+52>>2]|0;l=(k|0)==0;if(j){if(l){j=d;do if(b[h>>0]|0){m=f[d+56>>2]|0;if(!m){n=(f[d+24>>2]|0)+72|0;break}else{n=m+68|0;break}}else n=(f[e>>2]|0)+28|0;while(0);o=(j-(f[n>>2]|0)|0)/88|0}else o=((k-(f[(f[k+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;n=pKb(c+(f[(f[a+16>>2]|0)+(o<<2)>>2]|0)|0)|0;o=f[n+12>>2]|0;j=n+4|0;m=f[j>>2]|0;p=m+-1|0;f[j>>2]=p;j=o+4+(p<<2)|0;p=f[j>>2]|0;q=f[o>>2]|0;r=q+-1|0;f[o>>2]=r;if((m|0)<(q|0))f[j>>2]=f[o+4+(r<<2)>>2];if(!(f[n>>2]|0)){i=p;return i|0}n=tLb(p,0)|0;xHb(p,n);i=n;return i|0}else{if(l){l=d;do if(b[h>>0]|0){n=f[d+56>>2]|0;if(!n){s=(f[d+24>>2]|0)+72|0;break}else{s=n+68|0;break}}else s=(f[e>>2]|0)+28|0;while(0);t=(l-(f[s>>2]|0)|0)/88|0}else t=((k-(f[(f[k+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[g>>2]|0)+24>>2]|0)|0;g=c+(f[(f[a+16>>2]|0)+(t<<2)>>2]|0)|0;t=f[g+12>>2]|0;a=g+4|0;c=f[a>>2]|0;k=c+-1|0;f[a>>2]=k;a=t+4+(k<<2)|0;k=f[a>>2]|0;s=f[t>>2]|0;l=s+-1|0;f[t>>2]=l;if((c|0)<(s|0))f[a>>2]=f[t+4+(l<<2)>>2];if(!(f[g>>2]|0)){i=k;return i|0}g=tLb(k,0)|0;xHb(k,g);i=g;return i|0}return 0}function XFb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+64|0;e=d+48|0;g=d+24|0;h=d;if((b|0)==(c|0)){u=d;return}if((di[f[(f[b>>2]|0)+92>>2]&1023](b)|0)!=(a|0)){zpb(g,3,466902,620);i=vpb(vpb(g,469555)|0,469953)|0;zh[f[(f[b>>2]|0)+96>>2]&2047](e,b);j=vpb(wpb(i,f[(f[e>>2]|0)+4>>2]|0)|0,469651)|0;xpb(d+57|0,vpb(wpb(j,f[(f[a+4>>2]|0)+4>>2]|0)|0,469721)|0);Apb(g)}if((di[f[(f[c>>2]|0)+92>>2]&1023](c)|0)!=(a|0)){zpb(h,3,466902,627);g=vpb(vpb(h,469800)|0,469989)|0;zh[f[(f[c>>2]|0)+96>>2]&2047](e,c);j=vpb(wpb(g,f[(f[e>>2]|0)+4>>2]|0)|0,469651)|0;xpb(d+56|0,vpb(wpb(j,f[(f[a+4>>2]|0)+4>>2]|0)|0,469721)|0);Apb(h)}h=a+36|0;j=f[h>>2]|0;if((j|0)!=-1){e=a+28|0;g=(f[e>>2]|0)==-1;i=b+j|0;do if(g){k=f[i>>2]|0;l=k&-2;m=k;if(!(k&1))n=l;else n=f[l+4>>2]|0;l=f[c+j>>2]|0;o=l&-2;if(!(l&1)){p=n;q=o;r=m;s=k;break}else{p=n;q=f[o+4>>2]|0;r=m;s=k;break}}else{k=f[i>>2]|0;p=k;q=f[c+j>>2]|0;r=k;s=k}while(0);if((p|0)!=(q|0)){q=f[(f[b>>2]|0)+16>>2]|0;do if(g){p=s&-2;if(!(s&1)){t=p;break}else{t=f[p+4>>2]|0;break}}else t=r;while(0);r=Uh[q&1023](b,t)|0;zh[f[(f[r>>2]|0)+76>>2]&2047](r,b);zh[f[(f[b>>2]|0)+72>>2]&2047](b,c);zh[f[(f[c>>2]|0)+72>>2]&2047](c,r);t=f[h>>2]|0;do if((t|0)!=-1){h=b+t|0;if((f[e>>2]|0)!=-1){v=f[h>>2]|0;break}q=f[h>>2]|0;h=q&-2;if(!(q&1)){v=h;break}else{v=f[h+4>>2]|0;break}}else v=0;while(0);if((r|0)==0|(v|0)!=0){u=d;return}bi[f[(f[r>>2]|0)+4>>2]&2047](r);u=d;return}}r=f[a+20>>2]|0;if((r|0)!=-1){v=b+r|0;e=c+r|0;r=a+4|0;t=f[r>>2]|0;h=f[t+24>>2]|0;q=(h+31|0)/32|0;if((h|0)>0){h=0;do{s=v+(h<<2)|0;g=e+(h<<2)|0;p=f[s>>2]|0;f[s>>2]=f[g>>2];f[g>>2]=p;h=h+1|0}while((h|0)<(q|0));w=r;x=t}else{w=r;x=t}}else{t=a+4|0;w=t;x=f[t>>2]|0}if((f[x+24>>2]|0)>0){t=0;r=x;while(1){q=f[r+28>>2]|0;if(!(f[q+(t*88|0)+52>>2]|0)){RHb(a,b,c,q+(t*88|0)|0);y=f[w>>2]|0}else y=r;t=t+1|0;if((t|0)>=(f[y+24>>2]|0)){z=y;break}else r=y}}else z=x;if((f[z+32>>2]|0)>0){x=0;y=z;do{PHb(a,b,c,(f[y+36>>2]|0)+(x*28|0)|0);x=x+1|0;y=f[w>>2]|0}while((x|0)<(f[y+32>>2]|0))}y=f[a+32>>2]|0;if((y|0)!=-1)URb(b+y|0,c+y|0);y=Uh[f[(f[a>>2]|0)+12>>2]&1023](a,b)|0;b=Uh[f[(f[a>>2]|0)+12>>2]&1023](a,c)|0;c=f[y>>2]|0;f[y>>2]=f[b>>2];f[b>>2]=c;u=d;return}function YFb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=u;u=u+64|0;h=g+48|0;i=g+24|0;j=g;if((c|0)==(d|0)){u=g;return}if((di[f[(f[c>>2]|0)+92>>2]&1023](c)|0)!=(a|0)){zpb(i,3,466902,685);k=vpb(vpb(i,469555)|0,469609)|0;zh[f[(f[c>>2]|0)+96>>2]&2047](h,c);l=vpb(wpb(k,f[(f[h>>2]|0)+4>>2]|0)|0,469651)|0;xpb(g+61|0,vpb(wpb(l,f[(f[a+4>>2]|0)+4>>2]|0)|0,469721)|0);Apb(i)}if((di[f[(f[d>>2]|0)+92>>2]&1023](d)|0)!=(a|0)){zpb(j,3,466902,692);i=vpb(vpb(j,469800)|0,469854)|0;zh[f[(f[d>>2]|0)+96>>2]&2047](h,d);l=vpb(wpb(i,f[(f[h>>2]|0)+4>>2]|0)|0,469651)|0;xpb(g+60|0,vpb(wpb(l,f[(f[a+4>>2]|0)+4>>2]|0)|0,469721)|0);Apb(j)}j=h+4|0;f[j>>2]=0;l=h+8|0;f[l>>2]=0;i=h+4|0;f[h>>2]=i;k=e+4|0;m=f[e>>2]|0;if((f[k>>2]|0)==(m|0))n=0;else{o=a+32|0;p=0;q=m;do{m=f[q+(p<<2)>>2]|0;a:do if(!(b[m+40>>0]|0)){r=m+52|0;s=f[r>>2]|0;if(!s){QHb(a,c,d,m);RHb(a,c,d,m);break}t=(s-(f[(f[s+8>>2]|0)+36>>2]|0)|0)/28|0;v=f[i>>2]|0;do if(v){w=i;x=v;b:while(1){y=x;while(1){if((f[y+16>>2]|0)>=(t|0))break;z=f[y+4>>2]|0;if(!z){A=w;break b}else y=z}x=f[y>>2]|0;if(!x){A=y;break}else w=y}if((A|0)!=(i|0)?(t|0)>=(f[A+16>>2]|0):0)break a;else{B=j;C=v}while(1){w=f[C+16>>2]|0;if((t|0)<(w|0)){x=f[C>>2]|0;if(!x){D=23;break}else{E=C;F=x}}else{if((w|0)>=(t|0)){D=27;break}G=C+4|0;w=f[G>>2]|0;if(!w){D=26;break}else{E=G;F=w}}B=E;C=F}if((D|0)==23){D=0;H=C;I=C;break}else if((D|0)==26){D=0;H=G;I=C;break}else if((D|0)==27){D=0;H=B;I=C;break}}else{H=i;I=i}while(0);if(!(f[H>>2]|0)){v=L5b(20)|0;f[v+16>>2]=t;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=I;f[H>>2]=v;w=f[f[h>>2]>>2]|0;if(!w)J=v;else{f[h>>2]=w;J=f[H>>2]|0}mP(f[j>>2]|0,J);f[l>>2]=(f[l>>2]|0)+1;K=f[r>>2]|0}else K=s;PHb(a,c,d,K)}else{w=f[o>>2]|0;VRb(c+w|0,d+w|0,f[m+28>>2]|0)}while(0);p=p+1|0;q=f[e>>2]|0}while(p>>>0<(f[k>>2]|0)-q>>2>>>0);n=f[i>>2]|0}Tua(h,n);u=g;return}function ZFb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tHb(j,d,469550,468162);if((f[d+36>>2]|0)!=3)tHb(f[i>>2]|0,d,469550,467614);j=d+40|0;if(b[j>>0]|0){QRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e,g);return}do switch(f[136e3+(f[d+32>>2]<<2)>>2]|0){case 1:{k=f[d+52>>2]|0;if(!k)l=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else l=((k-(f[(f[k+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;k=f[c+(f[(f[a+16>>2]|0)+(l<<2)>>2]|0)+8>>2]|0;m=k+4+(e<<2)|0;n=k+4+(g<<2)|0;k=f[m>>2]|0;f[m>>2]=f[n>>2];f[n>>2]=k;return}case 2:{k=f[d+52>>2]|0;if(!k)o=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else o=((k-(f[(f[k+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;k=f[c+(f[(f[a+16>>2]|0)+(o<<2)>>2]|0)+8>>2]|0;n=k+8+(e<<3)|0;m=k+8+(g<<3)|0;k=n;q=f[k>>2]|0;r=f[k+4>>2]|0;k=m;s=f[k+4>>2]|0;t=n;f[t>>2]=f[k>>2];f[t+4>>2]=s;s=m;f[s>>2]=q;f[s+4>>2]=r;return}case 3:{r=f[d+52>>2]|0;if(!r)u=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else u=((r-(f[(f[r+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;r=f[c+(f[(f[a+16>>2]|0)+(u<<2)>>2]|0)+8>>2]|0;s=r+4+(e<<2)|0;q=r+4+(g<<2)|0;r=f[s>>2]|0;f[s>>2]=f[q>>2];f[q>>2]=r;return}case 4:{r=f[d+52>>2]|0;if(!r)v=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else v=((r-(f[(f[r+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;r=f[c+(f[(f[a+16>>2]|0)+(v<<2)>>2]|0)+8>>2]|0;q=r+8+(e<<3)|0;s=r+8+(g<<3)|0;r=q;m=f[r>>2]|0;t=f[r+4>>2]|0;r=s;k=f[r+4>>2]|0;n=q;f[n>>2]=f[r>>2];f[n+4>>2]=k;k=s;f[k>>2]=m;f[k+4>>2]=t;return}case 5:{t=f[d+52>>2]|0;if(!t)w=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else w=((t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;t=f[c+(f[(f[a+16>>2]|0)+(w<<2)>>2]|0)+8>>2]|0;k=t+8+(e<<3)|0;m=t+8+(g<<3)|0;x=+p[k>>3];p[k>>3]=+p[m>>3];p[m>>3]=x;return}case 6:{m=f[d+52>>2]|0;if(!m)y=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else y=((m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;m=f[c+(f[(f[a+16>>2]|0)+(y<<2)>>2]|0)+8>>2]|0;k=m+4+(e<<2)|0;t=m+4+(g<<2)|0;m=f[k>>2]|0;f[k>>2]=f[t>>2];f[t>>2]=m;return}case 7:{m=f[d+52>>2]|0;if(!m)z=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else z=((m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;m=f[c+(f[(f[a+16>>2]|0)+(z<<2)>>2]|0)+8>>2]|0;t=m+4+e|0;k=m+4+g|0;m=b[t>>0]|0;b[t>>0]=b[k>>0]|0;b[k>>0]=m;return}case 8:{m=f[d+52>>2]|0;if(!m)A=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else A=((m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;m=f[c+(f[(f[a+16>>2]|0)+(A<<2)>>2]|0)+8>>2]|0;k=m+4+(e<<2)|0;t=m+4+(g<<2)|0;m=f[k>>2]|0;f[k>>2]=f[t>>2];f[t>>2]=m;return}case 10:case 9:{m=xub(d)|0;t=f[d+52>>2]|0;k=(t|0)==0;if(m){if(k){m=d;do if(b[j>>0]|0){s=f[d+56>>2]|0;if(!s){B=(f[d+24>>2]|0)+72|0;break}else{B=s+68|0;break}}else B=(f[h>>2]|0)+28|0;while(0);C=(m-(f[B>>2]|0)|0)/88|0}else C=((t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;s=(pKb(c+(f[(f[a+16>>2]|0)+(C<<2)>>2]|0)|0)|0)+12|0;n=f[s>>2]|0;s=n+4+(e<<2)|0;r=n+4+(g<<2)|0;n=f[s>>2]|0;f[s>>2]=f[r>>2];f[r>>2]=n;return}else{if(k){n=d;do if(b[j>>0]|0){r=f[d+56>>2]|0;if(!r){D=(f[d+24>>2]|0)+72|0;break}else{D=r+68|0;break}}else D=(f[h>>2]|0)+28|0;while(0);E=(n-(f[D>>2]|0)|0)/88|0}else E=((t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;k=f[c+(f[(f[a+16>>2]|0)+(E<<2)>>2]|0)+12>>2]|0;m=k+4+(e<<2)|0;r=k+4+(g<<2)|0;k=f[m>>2]|0;f[m>>2]=f[r>>2];f[r>>2]=k;return}break}default:return}while(0)}function _Fb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;h=c+4|0;i=f[h>>2]|0;if((i|0)!=(g|0))f[h>>2]=i+(~((i+-4-g|0)>>>2)<<2);if((f[a+8>>2]|0)==(b|0)){u=d;return}g=f[a+20>>2]|0;i=(g|0)==-1?0:b+g|0;g=b+(f[a+24>>2]|0)|0;j=a+4|0;KHb(c,f[(f[j>>2]|0)+24>>2]|0);k=f[j>>2]|0;if((f[k+24>>2]|0)>0){l=c+8|0;m=(i|0)==0;n=0;o=k;while(1){p=f[o+28>>2]|0;q=p+(n*88|0)|0;f[e>>2]=q;r=q;do if((f[p+(n*88|0)+36>>2]|0)==3){if((li[f[(f[a>>2]|0)+24>>2]&511](a,b,q)|0)>0){s=f[h>>2]|0;if((s|0)==(f[l>>2]|0)){ksb(c,e);break}else{f[s>>2]=f[e>>2];f[h>>2]=(f[h>>2]|0)+4;break}}}else{s=f[p+(n*88|0)+52>>2]|0;if(s|0){if((f[g+(((s-(f[(f[s+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)!=(f[p+(n*88|0)+28>>2]|0))break;s=f[h>>2]|0;if((s|0)==(f[l>>2]|0)){ksb(c,e);break}else{f[s>>2]=r;f[h>>2]=(f[h>>2]|0)+4;break}}if(m){if(!(LHb(a,b,q)|0))break;s=f[h>>2]|0;if((s|0)==(f[l>>2]|0)){ksb(c,e);break}else{f[s>>2]=f[e>>2];f[h>>2]=(f[h>>2]|0)+4;break}}else{if(!(f[i+(n>>>5<<2)>>2]&1<<(n&31)))break;s=f[h>>2]|0;if((s|0)==(f[l>>2]|0)){ksb(c,e);break}else{f[s>>2]=r;f[h>>2]=(f[h>>2]|0)+4;break}}}while(0);n=n+1|0;r=f[j>>2]|0;if((n|0)>=(f[r+24>>2]|0)){t=r;break}else o=r}}else t=k;k=f[a+32>>2]|0;if((k|0)!=-1)vFb(b+k|0,t,f[a+44>>2]|0,c);MHb(f[c>>2]|0,f[h>>2]|0);u=d;return}function $Fb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=d+48|0;g=a+4|0;h=f[g>>2]|0;if((f[e>>2]|0)!=(h|0))tHb(h,d,469541,468162);if((f[d+36>>2]|0)==3)tHb(f[g>>2]|0,d,469541,469189);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=1)vHb(f[g>>2]|0,d,469541,1);if(b[d+40>>0]|0){i=AQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[d+80>>2]|0)|0;return i|0}h=f[d+52>>2]|0;do if(h){j=(h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(j<<2)>>2]|0)==(f[d+28>>2]|0)){k=c;l=(f[(f[g>>2]|0)+24>>2]|0)+j|0;m=14;break}else{n=(f[a+16>>2]|0)+(((d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;o=f[a+12>>2]|0;break}}else{k=c;l=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;m=14}while(0);if((m|0)==14){n=(f[a+16>>2]|0)+(l<<2)|0;o=k}i=f[o+(f[n>>2]|0)>>2]|0;return i|0}function aGb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=d+48|0;g=a+4|0;h=f[g>>2]|0;if((f[e>>2]|0)!=(h|0))tHb(h,d,469532,468162);if((f[d+36>>2]|0)==3)tHb(f[g>>2]|0,d,469532,469189);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=2)vHb(f[g>>2]|0,d,469532,2);if(b[d+40>>0]|0){h=d+80|0;i=IQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[h>>2]|0,f[h+4>>2]|0)|0;j=J;k=i;J=j;return k|0}i=f[d+52>>2]|0;do if(i){h=(i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(h<<2)>>2]|0)==(f[d+28>>2]|0)){l=c;m=(f[(f[g>>2]|0)+24>>2]|0)+h|0;n=14;break}else{o=(f[a+16>>2]|0)+(((d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;p=f[a+12>>2]|0;break}}else{l=c;m=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;n=14}while(0);if((n|0)==14){o=(f[a+16>>2]|0)+(m<<2)|0;p=l}l=p+(f[o>>2]|0)|0;j=f[l+4>>2]|0;k=f[l>>2]|0;J=j;return k|0}function bGb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=d+48|0;g=a+4|0;h=f[g>>2]|0;if((f[e>>2]|0)!=(h|0))tHb(h,d,469522,468162);if((f[d+36>>2]|0)==3)tHb(f[g>>2]|0,d,469522,469189);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=3)vHb(f[g>>2]|0,d,469522,3);if(b[d+40>>0]|0){i=PQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[d+80>>2]|0)|0;return i|0}h=f[d+52>>2]|0;do if(h){j=(h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(j<<2)>>2]|0)==(f[d+28>>2]|0)){k=c;l=(f[(f[g>>2]|0)+24>>2]|0)+j|0;m=14;break}else{n=(f[a+16>>2]|0)+(((d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;o=f[a+12>>2]|0;break}}else{k=c;l=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;m=14}while(0);if((m|0)==14){n=(f[a+16>>2]|0)+(l<<2)|0;o=k}i=f[o+(f[n>>2]|0)>>2]|0;return i|0}function cGb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=d+48|0;g=a+4|0;h=f[g>>2]|0;if((f[e>>2]|0)!=(h|0))tHb(h,d,469512,468162);if((f[d+36>>2]|0)==3)tHb(f[g>>2]|0,d,469512,469189);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=4)vHb(f[g>>2]|0,d,469512,4);if(b[d+40>>0]|0){h=d+80|0;i=WQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[h>>2]|0,f[h+4>>2]|0)|0;j=J;k=i;J=j;return k|0}i=f[d+52>>2]|0;do if(i){h=(i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(h<<2)>>2]|0)==(f[d+28>>2]|0)){l=c;m=(f[(f[g>>2]|0)+24>>2]|0)+h|0;n=14;break}else{o=(f[a+16>>2]|0)+(((d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;p=f[a+12>>2]|0;break}}else{l=c;m=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;n=14}while(0);if((n|0)==14){o=(f[a+16>>2]|0)+(m<<2)|0;p=l}l=p+(f[o>>2]|0)|0;j=f[l+4>>2]|0;k=f[l>>2]|0;J=j;return k|0}function dGb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0;e=d+48|0;g=a+4|0;h=f[g>>2]|0;if((f[e>>2]|0)!=(h|0))tHb(h,d,469503,468162);if((f[d+36>>2]|0)==3)tHb(f[g>>2]|0,d,469503,469189);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=6)vHb(f[g>>2]|0,d,469503,6);if(b[d+40>>0]|0){i=+bRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,+n[d+80>>2]);return +i}h=f[d+52>>2]|0;do if(h){j=(h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(j<<2)>>2]|0)==(f[d+28>>2]|0)){k=c;l=(f[(f[g>>2]|0)+24>>2]|0)+j|0;m=14;break}else{o=(f[a+16>>2]|0)+(((d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;p=f[a+12>>2]|0;break}}else{k=c;l=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;m=14}while(0);if((m|0)==14){o=(f[a+16>>2]|0)+(l<<2)|0;p=k}i=+n[p+(f[o>>2]|0)>>2];return +i}function eGb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0,o=0;e=d+48|0;g=a+4|0;h=f[g>>2]|0;if((f[e>>2]|0)!=(h|0))tHb(h,d,469493,468162);if((f[d+36>>2]|0)==3)tHb(f[g>>2]|0,d,469493,469189);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=5)vHb(f[g>>2]|0,d,469493,5);if(b[d+40>>0]|0){i=+iRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,+p[d+80>>3]);return +i}h=f[d+52>>2]|0;do if(h){j=(h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(j<<2)>>2]|0)==(f[d+28>>2]|0)){k=c;l=(f[(f[g>>2]|0)+24>>2]|0)+j|0;m=14;break}else{n=(f[a+16>>2]|0)+(((d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;o=f[a+12>>2]|0;break}}else{k=c;l=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;m=14}while(0);if((m|0)==14){n=(f[a+16>>2]|0)+(l<<2)|0;o=k}i=+p[o+(f[n>>2]|0)>>3];return +i}function fGb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=d+48|0;g=a+4|0;h=f[g>>2]|0;if((f[e>>2]|0)!=(h|0))tHb(h,d,469485,468162);if((f[d+36>>2]|0)==3)tHb(f[g>>2]|0,d,469485,469189);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=7)vHb(f[g>>2]|0,d,469485,7);if(b[d+40>>0]|0){i=pRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,(b[d+80>>0]|0)!=0)|0;return i|0}h=f[d+52>>2]|0;do if(h){j=(h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(j<<2)>>2]|0)==(f[d+28>>2]|0)){k=c;l=(f[(f[g>>2]|0)+24>>2]|0)+j|0;m=14;break}else{n=f[a+12>>2]|0;o=(f[a+16>>2]|0)+(((d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;break}}else{k=c;l=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;m=14}while(0);if((m|0)==14){n=k;o=(f[a+16>>2]|0)+(l<<2)|0}i=(b[n+(f[o>>2]|0)>>0]|0)!=0;return i|0}function gGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=e+48|0;h=c+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,e,469475,468162);if((f[e+36>>2]|0)==3)tHb(f[h>>2]|0,e,469475,469189);if((f[136e3+(f[e+32>>2]<<2)>>2]|0)!=9)vHb(f[h>>2]|0,e,469475,9);if(b[e+40>>0]|0){X5b(a,ERb(d+(f[c+32>>2]|0)|0,f[e+28>>2]|0,f[e+80>>2]|0)|0);return}i=c+16|0;j=c+12|0;k=e;l=f[e+52>>2]|0;do if(l){m=(l-(f[(f[l+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[d+(f[c+24>>2]|0)+(m<<2)>>2]|0)==(f[e+28>>2]|0)){n=d;o=(f[(f[h>>2]|0)+24>>2]|0)+m|0;p=14;break}else{q=(f[i>>2]|0)+(((k-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;r=f[j>>2]|0;break}}else{n=d;o=(k-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;p=14}while(0);if((p|0)==14){q=(f[i>>2]|0)+(o<<2)|0;r=n}X5b(a,f[r+(f[q>>2]|0)>>2]|0);return}function hGb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=li[f[(f[a>>2]|0)+104>>2]&511](a,b,c)|0;return uub(f[c+64>>2]|0,d)|0}function iGb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=d+48|0;g=a+4|0;h=f[g>>2]|0;if((f[e>>2]|0)!=(h|0))tHb(h,d,469462,468162);if((f[d+36>>2]|0)==3)tHb(f[g>>2]|0,d,469462,469189);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=8)vHb(f[g>>2]|0,d,469462,8);if(b[d+40>>0]|0){i=zRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[(f[d+80>>2]|0)+8>>2]|0)|0;return i|0}h=f[d+52>>2]|0;do if(h){j=(h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(j<<2)>>2]|0)==(f[d+28>>2]|0)){k=c;l=(f[(f[g>>2]|0)+24>>2]|0)+j|0;m=14;break}else{n=(f[a+16>>2]|0)+(((d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;o=f[a+12>>2]|0;break}}else{k=c;l=(d-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;m=14}while(0);if((m|0)==14){n=(f[a+16>>2]|0)+(l<<2)|0;o=k}i=f[o+(f[n>>2]|0)>>2]|0;return i|0}function jGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,469451,468162);if((f[d+36>>2]|0)==3)tHb(f[h>>2]|0,d,469451,469189);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=10)vHb(f[h>>2]|0,d,469451,10);if(!e)j=f[a+48>>2]|0;else j=e;if(b[d+40>>0]|0){k=wFb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[d+60>>2]|0,j)|0;return k|0}j=f[d+52>>2]|0;e=(j|0)==0;do if(!e){i=(j-(f[(f[j+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(i<<2)>>2]|0)==(f[d+28>>2]|0)){l=c;m=(f[(f[h>>2]|0)+24>>2]|0)+i|0;n=16;break}else{i=f[a+16>>2]|0;o=i+(((d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;p=f[a+12>>2]|0;q=i;break}}else{l=c;m=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;n=16}while(0);if((n|0)==16){n=f[a+16>>2]|0;o=n+(m<<2)|0;p=l;q=n}n=f[p+(f[o>>2]|0)>>2]|0;if(n|0){k=n;return k|0}k=f[(f[(e?a+8|0:a+12|0)>>2]|0)+(f[q+(((d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]|0;return k|0}function kGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=d+48|0;g=a+4|0;h=f[g>>2]|0;if((f[e>>2]|0)!=(h|0))tHb(h,d,469432,468162);if((f[d+36>>2]|0)==3)tHb(f[g>>2]|0,d,469432,469189);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=9)vHb(f[g>>2]|0,d,469432,9);if(b[d+40>>0]|0){i=ERb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[d+80>>2]|0)|0;return i|0}h=a+16|0;j=a+12|0;k=d;l=f[d+52>>2]|0;do if(l){m=(l-(f[(f[l+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(m<<2)>>2]|0)==(f[d+28>>2]|0)){n=c;o=(f[(f[g>>2]|0)+24>>2]|0)+m|0;p=14;break}else{q=(f[h>>2]|0)+(((k-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;r=f[j>>2]|0;break}}else{n=c;o=(k-(f[(f[e>>2]|0)+28>>2]|0)|0)/88|0;p=14}while(0);if((p|0)==14){q=(f[h>>2]|0)+(o<<2)|0;r=n}i=f[r+(f[q>>2]|0)>>2]|0;return i|0}function lGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;f[h>>2]=e;i=a+4|0;j=f[i>>2]|0;if((f[d+48>>2]|0)!=(j|0))tHb(j,d,469423,468162);if((f[d+36>>2]|0)==3)tHb(f[i>>2]|0,d,469423,469189);j=d+32|0;if((f[136e3+(f[j>>2]<<2)>>2]|0)!=1)vHb(f[i>>2]|0,d,469423,1);if(!(b[d+40>>0]|0)){DHb(a,c,d,h);u=g;return}else{BQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[j>>2]&255,e,d);u=g;return}}function mGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h;j=i;f[j>>2]=e;f[j+4>>2]=g;j=a+4|0;k=f[j>>2]|0;if((f[d+48>>2]|0)!=(k|0))tHb(k,d,469414,468162);if((f[d+36>>2]|0)==3)tHb(f[j>>2]|0,d,469414,469189);k=d+32|0;if((f[136e3+(f[k>>2]<<2)>>2]|0)!=2)vHb(f[j>>2]|0,d,469414,2);if(!(b[d+40>>0]|0)){JHb(a,c,d,i);u=h;return}else{JQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[k>>2]&255,e,g,d);u=h;return}}function nGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;f[h>>2]=e;i=a+4|0;j=f[i>>2]|0;if((f[d+48>>2]|0)!=(j|0))tHb(j,d,469404,468162);if((f[d+36>>2]|0)==3)tHb(f[i>>2]|0,d,469404,469189);j=d+32|0;if((f[136e3+(f[j>>2]<<2)>>2]|0)!=3)vHb(f[i>>2]|0,d,469404,3);if(!(b[d+40>>0]|0)){IHb(a,c,d,h);u=g;return}else{QQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[j>>2]&255,e,d);u=g;return}}function oGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=u;u=u+16|0;i=h;j=i;f[j>>2]=e;f[j+4>>2]=g;j=a+4|0;k=f[j>>2]|0;if((f[d+48>>2]|0)!=(k|0))tHb(k,d,469394,468162);if((f[d+36>>2]|0)==3)tHb(f[j>>2]|0,d,469394,469189);k=d+32|0;if((f[136e3+(f[k>>2]<<2)>>2]|0)!=4)vHb(f[j>>2]|0,d,469394,4);if(!(b[d+40>>0]|0)){HHb(a,c,d,i);u=h;return}else{XQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[k>>2]&255,e,g,d);u=h;return}}function pGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;n[h>>2]=e;i=a+4|0;j=f[i>>2]|0;if((f[d+48>>2]|0)!=(j|0))tHb(j,d,469385,468162);if((f[d+36>>2]|0)==3)tHb(f[i>>2]|0,d,469385,469189);j=d+32|0;if((f[136e3+(f[j>>2]<<2)>>2]|0)!=6)vHb(f[i>>2]|0,d,469385,6);if(!(b[d+40>>0]|0)){GHb(a,c,d,h);u=g;return}else{cRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[j>>2]&255,e,d);u=g;return}}function qGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;p[h>>3]=e;i=a+4|0;j=f[i>>2]|0;if((f[d+48>>2]|0)!=(j|0))tHb(j,d,469375,468162);if((f[d+36>>2]|0)==3)tHb(f[i>>2]|0,d,469375,469189);j=d+32|0;if((f[136e3+(f[j>>2]<<2)>>2]|0)!=5)vHb(f[i>>2]|0,d,469375,5);if(!(b[d+40>>0]|0)){FHb(a,c,d,h);u=g;return}else{jRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[j>>2]&255,e,d);u=g;return}}function rGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+16|0;h=g;b[h>>0]=e&1;i=a+4|0;j=f[i>>2]|0;if((f[d+48>>2]|0)!=(j|0))tHb(j,d,469367,468162);if((f[d+36>>2]|0)==3)tHb(f[i>>2]|0,d,469367,469189);j=d+32|0;if((f[136e3+(f[j>>2]<<2)>>2]|0)!=7)vHb(f[i>>2]|0,d,469367,7);if(!(b[d+40>>0]|0)){EHb(a,c,d,h);u=g;return}else{qRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[j>>2]&255,e,d);u=g;return}}function sGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,469357,468162);if((f[d+36>>2]|0)==3)tHb(f[h>>2]|0,d,469357,469189);i=d+32|0;if((f[136e3+(f[i>>2]<<2)>>2]|0)!=9)vHb(f[h>>2]|0,d,469357,9);j=d+40|0;if(b[j>>0]|0){_5b(FRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[i>>2]&255,d)|0,e)|0;return}i=d+52|0;k=f[i>>2]|0;l=(k|0)==0;m=a+16|0;n=f[m>>2]|0;o=d;p=f[(f[(l?a+8|0:a+12|0)>>2]|0)+(f[n+(((o-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]|0;a:do if(l){q=n;r=26}else{s=a+24|0;t=d+28|0;do if((f[c+(f[s>>2]|0)+(((k-(f[(f[k+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)==(f[t>>2]|0)){u=k;v=n}else{_h[f[(f[a>>2]|0)+36>>2]&255](a,c,k);w=f[i>>2]|0;if(w|0){x=(w-(f[(f[w+8>>2]|0)+36>>2]|0)|0)/28|0;f[c+(f[s>>2]|0)+(x<<2)>>2]=f[t>>2];y=f[m>>2]|0;f[c+(f[y+(x+(f[(f[h>>2]|0)+24>>2]|0)<<2)>>2]|0)>>2]=p;u=w;v=y;break}y=f[a+20>>2]|0;w=b[j>>0]|0;if((y|0)!=-1){do if(w<<24>>24){x=f[d+56>>2]|0;if(!x){z=(f[d+24>>2]|0)+72|0;break}else{z=x+68|0;break}}else z=(f[g>>2]|0)+28|0;while(0);x=(o-(f[z>>2]|0)|0)/88|0;A=c+y+(x>>>5<<2)|0;f[A>>2]=1<<(x&31)|f[A>>2]}do if(w<<24>>24){A=f[d+56>>2]|0;if(!A){B=(f[d+24>>2]|0)+72|0;break}else{B=A+68|0;break}}else B=(f[g>>2]|0)+28|0;while(0);w=f[m>>2]|0;f[c+(f[w+(((o-(f[B>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]=p;q=w;r=26;break a}while(0);w=(u-(f[(f[u+8>>2]|0)+36>>2]|0)|0)/28|0;f[c+(f[s>>2]|0)+(w<<2)>>2]=f[t>>2];C=c;D=v;E=w+(f[(f[h>>2]|0)+24>>2]|0)|0}while(0);if((r|0)==26){r=f[a+20>>2]|0;h=b[j>>0]|0;if((r|0)!=-1){do if(h<<24>>24){j=f[d+56>>2]|0;if(!j){F=(f[d+24>>2]|0)+72|0;break}else{F=j+68|0;break}}else F=(f[g>>2]|0)+28|0;while(0);j=(o-(f[F>>2]|0)|0)/88|0;F=c+r+(j>>>5<<2)|0;f[F>>2]=1<<(j&31)|f[F>>2]}do if(h<<24>>24){F=f[d+56>>2]|0;if(!F){G=(f[d+24>>2]|0)+72|0;break}else{G=F+68|0;break}}else G=(f[g>>2]|0)+28|0;while(0);C=c;D=q;E=(o-(f[G>>2]|0)|0)/88|0}G=C+(f[D+(E<<2)>>2]|0)|0;E=f[a+36>>2]|0;do if((E|0)!=-1){D=C+E|0;if((f[a+28>>2]|0)!=-1){H=f[D>>2]|0;break}o=f[D>>2]|0;D=o&-2;if(!(o&1)){H=D;break}else{H=f[D+4>>2]|0;break}}else H=0;while(0);a=f[G>>2]|0;if((a|0)==(p|0)){dya(G,H,e);return}else{_5b(a,e)|0;return}}function tGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;g=u;u=u+16|0;h=g;if((f[e+12>>2]|0)!=(f[d+64>>2]|0))zHb(f[a+4>>2]|0,d,469349,e);i=f[e+8>>2]|0;f[h>>2]=i;if(!(b[d+40>>0]|0)){DHb(a,c,d,h);u=g;return}else{ARb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[d+32>>2]&255,i,d);u=g;return}}function uGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=u;u=u+32|0;h=g+24|0;i=g;j=g+28|0;k=a+4|0;l=f[k>>2]|0;if((f[d+48>>2]|0)!=(l|0))tHb(l,d,469281,468162);if((f[d+36>>2]|0)==3)tHb(f[k>>2]|0,d,469281,469189);l=d+32|0;if((f[136e3+(f[l>>2]<<2)>>2]|0)!=8)vHb(f[k>>2]|0,d,469281,8);if((f[(f[(f[k>>2]|0)+8>>2]|0)+64>>2]|0)!=3?(tub(f[d+64>>2]|0,e)|0)==0:0){zpb(i,2,466902,1328);k=vpb(ypb(vpb(i,469294)|0,e)|0,468271)|0;xpb(j,wpb(k,f[d+4>>2]|0)|0);Apb(i);m=f[(f[d+80>>2]|0)+8>>2]|0}else m=e;f[h>>2]=m;if(!(b[d+40>>0]|0)){DHb(a,c,d,h);u=g;return}else{ARb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[l>>2]&255,m,d);u=g;return}}function vGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,469266,468162);if((f[d+36>>2]|0)==3)tHb(f[h>>2]|0,d,469266,469189);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=10)vHb(f[h>>2]|0,d,469266,10);if(!e)j=f[a+48>>2]|0;else j=e;e=d+40|0;if(b[e>>0]|0){k=xFb(c+(f[a+32>>2]|0)|0,d,j)|0;return k|0}j=d+52|0;i=f[j>>2]|0;if(!i){l=a+16|0;m=c+(f[(f[l>>2]|0)+(((d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)>>2]|0)|0;n=f[a+20>>2]|0;if((n|0)==-1){o=m;p=l}else{q=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;r=c+n+(q>>>5<<2)|0;f[r>>2]=1<<(q&31)|f[r>>2];o=m;p=l}}else{l=a+16|0;m=a+24|0;r=d+28|0;if((f[c+(f[m>>2]|0)+(((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)==(f[r>>2]|0)){o=c+(f[(f[l>>2]|0)+(((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;p=l}else{_h[f[(f[a>>2]|0)+36>>2]&255](a,c,i);i=f[j>>2]|0;q=(i|0)==0;if(q){n=f[a+20>>2]|0;s=b[e>>0]|0;if((n|0)==-1)t=d;else{u=d;do if(s<<24>>24){v=f[d+56>>2]|0;if(!v){w=(f[d+24>>2]|0)+72|0;break}else{w=v+68|0;break}}else w=(f[g>>2]|0)+28|0;while(0);v=(u-(f[w>>2]|0)|0)/88|0;w=c+n+(v>>>5<<2)|0;f[w>>2]=1<<(v&31)|f[w>>2];t=u}do if(s<<24>>24){u=f[d+56>>2]|0;if(!u){x=(f[d+24>>2]|0)+72|0;break}else{x=u+68|0;break}}else x=(f[g>>2]|0)+28|0;while(0);y=t;z=(t-(f[x>>2]|0)|0)/88|0;A=s}else{s=(i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0;f[c+(f[m>>2]|0)+(s<<2)>>2]=f[r>>2];y=d;z=s+(f[(f[h>>2]|0)+24>>2]|0)|0;A=b[e>>0]|0}h=f[l>>2]|0;s=c+(f[h+(z<<2)>>2]|0)|0;z=f[(q?a+8|0:a+12|0)>>2]|0;do if(A<<24>>24){q=f[d+56>>2]|0;if(!q){B=(f[d+24>>2]|0)+72|0;break}else{B=q+68|0;break}}else B=(f[g>>2]|0)+28|0;while(0);A=f[z+(f[h+(((y-(f[B>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]|0;B=f[(f[A>>2]|0)+16>>2]|0;y=di[f[(f[c>>2]|0)+20>>2]&1023](c)|0;h=Uh[B&1023](A,y)|0;f[s>>2]=h;o=s;p=l}}l=f[o>>2]|0;if(l|0){k=l;return k|0}l=f[p>>2]|0;p=f[((f[j>>2]|0)==0?a+8|0:a+12|0)>>2]|0;a=d;do if(b[e>>0]|0){j=f[d+56>>2]|0;if(!j){C=(f[d+24>>2]|0)+72|0;break}else{C=j+68|0;break}}else C=(f[g>>2]|0)+28|0;while(0);g=f[p+(f[l+(((a-(f[C>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]|0;C=f[(f[g>>2]|0)+16>>2]|0;a=di[f[(f[c>>2]|0)+20>>2]&1023](c)|0;c=Uh[C&1023](g,a)|0;f[o>>2]=c;k=c;return k|0}function wGb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if(c|0?(e=di[f[(f[c>>2]|0)+20>>2]&1023](c)|0,(e|0)!=(di[f[(f[b>>2]|0)+20>>2]&1023](b)|0)):0){if((di[f[(f[c>>2]|0)+20>>2]&1023](c)|0)==0?di[f[(f[b>>2]|0)+20>>2]&1023](b)|0:0){eFb(di[f[(f[b>>2]|0)+20>>2]&1023](b)|0,c);CHb(a,b,c,d);return}e=Dg[f[(f[a>>2]|0)+156>>2]&127](a,b,d,0)|0;zh[f[(f[e>>2]|0)+72>>2]&2047](e,c);return}CHb(a,b,c,d);return}function xGb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=BHb(a,b,c,d)|0;d=f[a+36>>2]|0;if((d|0)==-1){g=e;return g|0}c=b+d|0;do if((f[a+28>>2]|0)==-1){d=f[c>>2]|0;b=d&-2;if(!(d&1)){h=b;break}else{h=f[b+4>>2]|0;break}}else h=f[c>>2]|0;while(0);if(!((e|0)!=0&(h|0)!=0)){g=e;return g|0}h=di[f[(f[e>>2]|0)+12>>2]&1023](e)|0;zh[f[(f[h>>2]|0)+72>>2]&2047](h,e);g=h;return g|0}function yGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,469157,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,469157,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=1)vHb(f[h>>2]|0,d,469157,1);if(b[d+40>>0]|0){j=DQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e)|0;return j|0}i=f[d+52>>2]|0;do if(i){k=(i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(k<<2)>>2]|0)==(f[d+28>>2]|0)){l=c;m=(f[(f[h>>2]|0)+24>>2]|0)+k|0;n=14;break}else{o=(f[a+16>>2]|0)+(((d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;p=f[a+12>>2]|0;break}}else{l=c;m=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;n=14}while(0);if((n|0)==14){o=(f[a+16>>2]|0)+(m<<2)|0;p=l}j=f[(f[p+(f[o>>2]|0)+8>>2]|0)+4+(e<<2)>>2]|0;return j|0}function zGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,469140,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,469140,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=2)vHb(f[h>>2]|0,d,469140,2);if(b[d+40>>0]|0){i=KQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e)|0;j=J;k=i;J=j;return k|0}i=f[d+52>>2]|0;do if(i){l=(i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(l<<2)>>2]|0)==(f[d+28>>2]|0)){m=c;n=(f[(f[h>>2]|0)+24>>2]|0)+l|0;o=14;break}else{p=(f[a+16>>2]|0)+(((d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;q=f[a+12>>2]|0;break}}else{m=c;n=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;o=14}while(0);if((o|0)==14){p=(f[a+16>>2]|0)+(n<<2)|0;q=m}m=(f[q+(f[p>>2]|0)+8>>2]|0)+8+(e<<3)|0;j=f[m+4>>2]|0;k=f[m>>2]|0;J=j;return k|0}function AGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,469122,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,469122,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=3)vHb(f[h>>2]|0,d,469122,3);if(b[d+40>>0]|0){j=RQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e)|0;return j|0}i=f[d+52>>2]|0;do if(i){k=(i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(k<<2)>>2]|0)==(f[d+28>>2]|0)){l=c;m=(f[(f[h>>2]|0)+24>>2]|0)+k|0;n=14;break}else{o=(f[a+16>>2]|0)+(((d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;p=f[a+12>>2]|0;break}}else{l=c;m=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;n=14}while(0);if((n|0)==14){o=(f[a+16>>2]|0)+(m<<2)|0;p=l}j=f[(f[p+(f[o>>2]|0)+8>>2]|0)+4+(e<<2)>>2]|0;return j|0}function BGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,469104,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,469104,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=4)vHb(f[h>>2]|0,d,469104,4);if(b[d+40>>0]|0){i=YQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e)|0;j=J;k=i;J=j;return k|0}i=f[d+52>>2]|0;do if(i){l=(i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(l<<2)>>2]|0)==(f[d+28>>2]|0)){m=c;n=(f[(f[h>>2]|0)+24>>2]|0)+l|0;o=14;break}else{p=(f[a+16>>2]|0)+(((d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;q=f[a+12>>2]|0;break}}else{m=c;n=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;o=14}while(0);if((o|0)==14){p=(f[a+16>>2]|0)+(n<<2)|0;q=m}m=(f[q+(f[p>>2]|0)+8>>2]|0)+8+(e<<3)|0;j=f[m+4>>2]|0;k=f[m>>2]|0;J=j;return k|0}function CGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,469087,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,469087,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=6)vHb(f[h>>2]|0,d,469087,6);if(b[d+40>>0]|0){j=+dRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e);return +j}i=f[d+52>>2]|0;do if(i){k=(i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(k<<2)>>2]|0)==(f[d+28>>2]|0)){l=c;m=(f[(f[h>>2]|0)+24>>2]|0)+k|0;o=14;break}else{p=(f[a+16>>2]|0)+(((d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;q=f[a+12>>2]|0;break}}else{l=c;m=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;o=14}while(0);if((o|0)==14){p=(f[a+16>>2]|0)+(m<<2)|0;q=l}j=+n[(f[q+(f[p>>2]|0)+8>>2]|0)+4+(e<<2)>>2];return +j}function DGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,q=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,469069,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,469069,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=5)vHb(f[h>>2]|0,d,469069,5);if(b[d+40>>0]|0){j=+kRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e);return +j}i=f[d+52>>2]|0;do if(i){k=(i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(k<<2)>>2]|0)==(f[d+28>>2]|0)){l=c;m=(f[(f[h>>2]|0)+24>>2]|0)+k|0;n=14;break}else{o=(f[a+16>>2]|0)+(((d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;q=f[a+12>>2]|0;break}}else{l=c;m=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;n=14}while(0);if((n|0)==14){o=(f[a+16>>2]|0)+(m<<2)|0;q=l}j=+p[(f[q+(f[o>>2]|0)+8>>2]|0)+8+(e<<3)>>3];return +j}function EGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,469053,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,469053,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=7)vHb(f[h>>2]|0,d,469053,7);if(b[d+40>>0]|0){j=rRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e)|0;return j|0}i=f[d+52>>2]|0;do if(i){k=(i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(k<<2)>>2]|0)==(f[d+28>>2]|0)){l=c;m=(f[(f[h>>2]|0)+24>>2]|0)+k|0;n=14;break}else{o=(f[a+16>>2]|0)+(((d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;p=f[a+12>>2]|0;break}}else{l=c;m=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;n=14}while(0);if((n|0)==14){o=(f[a+16>>2]|0)+(m<<2)|0;p=l}j=(b[(f[p+(f[o>>2]|0)+8>>2]|0)+4+e>>0]|0)!=0;return j|0}function FGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=e+48|0;i=c+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tHb(j,e,469035,468162);if((f[e+36>>2]|0)!=3)tHb(f[i>>2]|0,e,469035,467614);if((f[136e3+(f[e+32>>2]<<2)>>2]|0)!=9)vHb(f[i>>2]|0,e,469035,9);if(b[e+40>>0]|0){X5b(a,GRb(d+(f[c+32>>2]|0)|0,f[e+28>>2]|0,g)|0);return}j=f[e+52>>2]|0;do if(j){k=(j-(f[(f[j+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[d+(f[c+24>>2]|0)+(k<<2)>>2]|0)==(f[e+28>>2]|0)){l=d;m=(f[(f[i>>2]|0)+24>>2]|0)+k|0;n=14;break}else{o=(f[c+16>>2]|0)+(((e-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;p=f[c+12>>2]|0;break}}else{l=d;m=(e-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;n=14}while(0);if((n|0)==14){o=(f[c+16>>2]|0)+(m<<2)|0;p=l}X5b(a,f[(f[p+(f[o>>2]|0)+12>>2]|0)+4+(g<<2)>>2]|0);return}function GGb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Dg[f[(f[a>>2]|0)+204>>2]&127](a,b,c,d)|0;return uub(f[c+64>>2]|0,e)|0}function HGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,469014,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,469014,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=8)vHb(f[h>>2]|0,d,469014,8);if(b[d+40>>0]|0){j=BRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e)|0;return j|0}i=f[d+52>>2]|0;do if(i){k=(i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(k<<2)>>2]|0)==(f[d+28>>2]|0)){l=c;m=(f[(f[h>>2]|0)+24>>2]|0)+k|0;n=14;break}else{o=(f[a+16>>2]|0)+(((d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;p=f[a+12>>2]|0;break}}else{l=c;m=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;n=14}while(0);if((n|0)==14){o=(f[a+16>>2]|0)+(m<<2)|0;p=l}j=f[(f[p+(f[o>>2]|0)+8>>2]|0)+4+(e<<2)>>2]|0;return j|0}function IGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,468995,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,468995,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=10)vHb(f[h>>2]|0,d,468995,10);i=d+40|0;if(b[i>>0]|0){j=LRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e)|0;return j|0}k=xub(d)|0;l=f[d+52>>2]|0;m=(l|0)==0;if(k){do if(m){k=d;do if(b[i>>0]|0){n=f[d+56>>2]|0;if(!n){o=(f[d+24>>2]|0)+72|0;break}else{o=n+68|0;break}}else o=(f[g>>2]|0)+28|0;while(0);p=c;q=(k-(f[o>>2]|0)|0)/88|0;r=25}else{n=(l-(f[(f[l+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(n<<2)>>2]|0)==(f[d+28>>2]|0)){p=c;q=(f[(f[h>>2]|0)+24>>2]|0)+n|0;r=25;break}n=f[a+16>>2]|0;s=f[a+12>>2]|0;t=d;do if(b[i>>0]|0){u=f[d+56>>2]|0;if(!u){v=(f[d+24>>2]|0)+72|0;break}else{v=u+68|0;break}}else v=(f[g>>2]|0)+28|0;while(0);w=n+(((t-(f[v>>2]|0)|0)/88|0)<<2)|0;x=s}while(0);if((r|0)==25){w=(f[a+16>>2]|0)+(q<<2)|0;x=p}p=(oKb(x+(f[w>>2]|0)|0)|0)+12|0;j=f[(f[p>>2]|0)+4+(e<<2)>>2]|0;return j|0}else{do if(m){p=d;do if(b[i>>0]|0){w=f[d+56>>2]|0;if(!w){y=(f[d+24>>2]|0)+72|0;break}else{y=w+68|0;break}}else y=(f[g>>2]|0)+28|0;while(0);z=c;A=(p-(f[y>>2]|0)|0)/88|0;r=42}else{s=(l-(f[(f[l+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(s<<2)>>2]|0)==(f[d+28>>2]|0)){z=c;A=(f[(f[h>>2]|0)+24>>2]|0)+s|0;r=42;break}s=f[a+16>>2]|0;t=f[a+12>>2]|0;n=d;do if(b[i>>0]|0){w=f[d+56>>2]|0;if(!w){B=(f[d+24>>2]|0)+72|0;break}else{B=w+68|0;break}}else B=(f[g>>2]|0)+28|0;while(0);C=s+(((n-(f[B>>2]|0)|0)/88|0)<<2)|0;D=t}while(0);if((r|0)==42){C=(f[a+16>>2]|0)+(A<<2)|0;D=z}j=f[(f[D+(f[C>>2]|0)+12>>2]|0)+4+(e<<2)>>2]|0;return j|0}return 0}function JGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,468968,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,468968,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=9)vHb(f[h>>2]|0,d,468968,9);if(b[d+40>>0]|0){j=GRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e)|0;return j|0}i=f[d+52>>2]|0;do if(i){k=(i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(k<<2)>>2]|0)==(f[d+28>>2]|0)){l=c;m=(f[(f[h>>2]|0)+24>>2]|0)+k|0;n=14;break}else{o=(f[a+16>>2]|0)+(((d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)|0;p=f[a+12>>2]|0;break}}else{l=c;m=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;n=14}while(0);if((n|0)==14){o=(f[a+16>>2]|0)+(m<<2)|0;p=l}j=f[(f[p+(f[o>>2]|0)+12>>2]|0)+4+(e<<2)>>2]|0;return j|0}function KGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tHb(j,d,468951,468162);if((f[d+36>>2]|0)!=3)tHb(f[i>>2]|0,d,468951,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=1)vHb(f[i>>2]|0,d,468951,1);if(b[d+40>>0]|0){EQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e,g);return}j=f[d+52>>2]|0;if(!j)k=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else k=((j-(f[(f[j+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;f[(f[c+(f[(f[a+16>>2]|0)+(k<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=g;return}function LGb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tHb(k,d,468934,468162);if((f[d+36>>2]|0)!=3)tHb(f[j>>2]|0,d,468934,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=2)vHb(f[j>>2]|0,d,468934,2);if(b[d+40>>0]|0){LQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e,g,h);return}k=f[d+52>>2]|0;if(!k)l=(d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0;else l=((k-(f[(f[k+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+24>>2]|0)|0;j=(f[c+(f[(f[a+16>>2]|0)+(l<<2)>>2]|0)+8>>2]|0)+8+(e<<3)|0;f[j>>2]=g;f[j+4>>2]=h;return}function MGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tHb(j,d,468916,468162);if((f[d+36>>2]|0)!=3)tHb(f[i>>2]|0,d,468916,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=3)vHb(f[i>>2]|0,d,468916,3);if(b[d+40>>0]|0){SQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e,g);return}j=f[d+52>>2]|0;if(!j)k=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else k=((j-(f[(f[j+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;f[(f[c+(f[(f[a+16>>2]|0)+(k<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=g;return}function NGb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;i=d+48|0;j=a+4|0;k=f[j>>2]|0;if((f[i>>2]|0)!=(k|0))tHb(k,d,468898,468162);if((f[d+36>>2]|0)!=3)tHb(f[j>>2]|0,d,468898,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=4)vHb(f[j>>2]|0,d,468898,4);if(b[d+40>>0]|0){ZQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e,g,h);return}k=f[d+52>>2]|0;if(!k)l=(d-(f[(f[i>>2]|0)+28>>2]|0)|0)/88|0;else l=((k-(f[(f[k+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[j>>2]|0)+24>>2]|0)|0;j=(f[c+(f[(f[a+16>>2]|0)+(l<<2)>>2]|0)+8>>2]|0)+8+(e<<3)|0;f[j>>2]=g;f[j+4>>2]=h;return}function OGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tHb(j,d,468881,468162);if((f[d+36>>2]|0)!=3)tHb(f[i>>2]|0,d,468881,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=6)vHb(f[i>>2]|0,d,468881,6);if(b[d+40>>0]|0){eRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e,g);return}j=f[d+52>>2]|0;if(!j)k=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else k=((j-(f[(f[j+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;n[(f[c+(f[(f[a+16>>2]|0)+(k<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=g;return}function PGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;var h=0,i=0,j=0,k=0;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tHb(j,d,468863,468162);if((f[d+36>>2]|0)!=3)tHb(f[i>>2]|0,d,468863,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=5)vHb(f[i>>2]|0,d,468863,5);if(b[d+40>>0]|0){lRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e,g);return}j=f[d+52>>2]|0;if(!j)k=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else k=((j-(f[(f[j+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;p[(f[c+(f[(f[a+16>>2]|0)+(k<<2)>>2]|0)+8>>2]|0)+8+(e<<3)>>3]=g;return}function QGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tHb(j,d,468847,468162);if((f[d+36>>2]|0)!=3)tHb(f[i>>2]|0,d,468847,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=7)vHb(f[i>>2]|0,d,468847,7);if(b[d+40>>0]|0){sRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e,g);return}j=f[d+52>>2]|0;if(!j)k=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else k=((j-(f[(f[j+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;b[(f[c+(f[(f[a+16>>2]|0)+(k<<2)>>2]|0)+8>>2]|0)+4+e>>0]=g&1;return}function RGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tHb(j,d,468829,468162);if((f[d+36>>2]|0)!=3)tHb(f[i>>2]|0,d,468829,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=9)vHb(f[i>>2]|0,d,468829,9);if(b[d+40>>0]|0){_5b(HRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e)|0,g)|0;return}j=f[d+52>>2]|0;if(!j)k=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else k=((j-(f[(f[j+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;_5b(f[(f[c+(f[(f[a+16>>2]|0)+(k<<2)>>2]|0)+12>>2]|0)+4+(e<<2)>>2]|0,g)|0;return}function SGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;if((f[g+12>>2]|0)!=(f[d+64>>2]|0))zHb(f[a+4>>2]|0,d,468749,g);h=f[g+8>>2]|0;if(b[d+40>>0]|0){CRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e,h);return}g=f[d+52>>2]|0;if(!g)i=(d-(f[(f[d+48>>2]|0)+28>>2]|0)|0)/88|0;else i=((g-(f[(f[g+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;f[(f[c+(f[(f[a+16>>2]|0)+(i<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=h;return}function TGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+32|0;i=h;j=h+24|0;k=d+48|0;l=a+4|0;m=f[l>>2]|0;if((f[k>>2]|0)!=(m|0))tHb(m,d,468749,468162);if((f[d+36>>2]|0)!=3)tHb(f[l>>2]|0,d,468749,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=8)vHb(f[l>>2]|0,d,468749,8);if((f[(f[(f[l>>2]|0)+8>>2]|0)+64>>2]|0)!=3?(tub(f[d+64>>2]|0,g)|0)==0:0){zpb(i,2,466902,1389);m=vpb(ypb(vpb(vpb(i,468765)|0,468822)|0,g)|0,468271)|0;xpb(j,wpb(m,f[d+4>>2]|0)|0);Apb(i);n=f[(f[d+80>>2]|0)+8>>2]|0}else n=g;if(b[d+40>>0]|0){CRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e,n);u=h;return}g=f[d+52>>2]|0;if(!g)o=(d-(f[(f[k>>2]|0)+28>>2]|0)|0)/88|0;else o=((g-(f[(f[g+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[l>>2]|0)+24>>2]|0)|0;f[(f[c+(f[(f[a+16>>2]|0)+(o<<2)>>2]|0)+8>>2]|0)+4+(e<<2)>>2]=n;u=h;return}function UGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,468726,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,468726,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=10)vHb(f[h>>2]|0,d,468726,10);i=d+40|0;if(b[i>>0]|0){j=MRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,e)|0;return j|0}k=xub(d)|0;l=f[d+52>>2]|0;m=(l|0)==0;if(k){if(m){k=d;do if(b[i>>0]|0){n=f[d+56>>2]|0;if(!n){o=(f[d+24>>2]|0)+72|0;break}else{o=n+68|0;break}}else o=(f[g>>2]|0)+28|0;while(0);p=(k-(f[o>>2]|0)|0)/88|0}else p=((l-(f[(f[l+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)|0;o=(pKb(c+(f[(f[a+16>>2]|0)+(p<<2)>>2]|0)|0)|0)+12|0;j=f[(f[o>>2]|0)+4+(e<<2)>>2]|0;return j|0}else{if(m){m=d;do if(b[i>>0]|0){o=f[d+56>>2]|0;if(!o){q=(f[d+24>>2]|0)+72|0;break}else{q=o+68|0;break}}else q=(f[g>>2]|0)+28|0;while(0);r=(m-(f[q>>2]|0)|0)/88|0}else r=((l-(f[(f[l+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)|0;j=f[(f[c+(f[(f[a+16>>2]|0)+(r<<2)>>2]|0)+12>>2]|0)+4+(e<<2)>>2]|0;return j|0}return 0}function VGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,468717,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,468717,467614);i=d+32|0;if((f[136e3+(f[i>>2]<<2)>>2]|0)!=1)vHb(f[h>>2]|0,d,468717,1);if(b[d+40>>0]|0){FQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[i>>2]&255,(b[(f[d+68>>2]|0)+56>>0]|0)!=0,e,d);return}i=f[d+52>>2]|0;if(!i)j=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;else j=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)|0;h=c+(f[(f[a+16>>2]|0)+(j<<2)>>2]|0)|0;j=f[h>>2]|0;if((j|0)==(f[h+4>>2]|0)){nza(h,j+1|0);k=f[h>>2]|0}else k=j;j=f[h+8>>2]|0;f[h>>2]=k+1;f[j+4+(k<<2)>>2]=e;return}function WGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tHb(j,d,468708,468162);if((f[d+36>>2]|0)!=3)tHb(f[i>>2]|0,d,468708,467614);j=d+32|0;if((f[136e3+(f[j>>2]<<2)>>2]|0)!=2)vHb(f[i>>2]|0,d,468708,2);if(b[d+40>>0]|0){MQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[j>>2]&255,(b[(f[d+68>>2]|0)+56>>0]|0)!=0,e,g,d);return}j=f[d+52>>2]|0;if(!j)k=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else k=((j-(f[(f[j+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;i=c+(f[(f[a+16>>2]|0)+(k<<2)>>2]|0)|0;k=f[i>>2]|0;if((k|0)==(f[i+4>>2]|0)){uFa(i,k+1|0);l=f[i>>2]|0}else l=k;k=f[i+8>>2]|0;f[i>>2]=l+1;i=k+8+(l<<3)|0;f[i>>2]=e;f[i+4>>2]=g;return}function XGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,468698,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,468698,467614);i=d+32|0;if((f[136e3+(f[i>>2]<<2)>>2]|0)!=3)vHb(f[h>>2]|0,d,468698,3);if(b[d+40>>0]|0){TQb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[i>>2]&255,(b[(f[d+68>>2]|0)+56>>0]|0)!=0,e,d);return}i=f[d+52>>2]|0;if(!i)j=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;else j=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)|0;h=c+(f[(f[a+16>>2]|0)+(j<<2)>>2]|0)|0;j=f[h>>2]|0;if((j|0)==(f[h+4>>2]|0)){rza(h,j+1|0);k=f[h>>2]|0}else k=j;j=f[h+8>>2]|0;f[h>>2]=k+1;f[j+4+(k<<2)>>2]=e;return}function YGb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=d+48|0;i=a+4|0;j=f[i>>2]|0;if((f[h>>2]|0)!=(j|0))tHb(j,d,468420,468162);if((f[d+36>>2]|0)!=3)tHb(f[i>>2]|0,d,468420,467614);j=d+32|0;if((f[136e3+(f[j>>2]<<2)>>2]|0)!=4)vHb(f[i>>2]|0,d,468420,4);if(b[d+40>>0]|0){_Qb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[j>>2]&255,(b[(f[d+68>>2]|0)+56>>0]|0)!=0,e,g,d);return}j=f[d+52>>2]|0;if(!j)k=(d-(f[(f[h>>2]|0)+28>>2]|0)|0)/88|0;else k=((j-(f[(f[j+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[i>>2]|0)+24>>2]|0)|0;i=c+(f[(f[a+16>>2]|0)+(k<<2)>>2]|0)|0;k=f[i>>2]|0;if((k|0)==(f[i+4>>2]|0)){AHb(i,k+1|0);l=f[i>>2]|0}else l=k;k=f[i+8>>2]|0;f[i>>2]=l+1;i=k+8+(l<<3)|0;f[i>>2]=e;f[i+4>>2]=g;return}function ZGb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,468411,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,468411,467614);i=d+32|0;if((f[136e3+(f[i>>2]<<2)>>2]|0)!=6)vHb(f[h>>2]|0,d,468411,6);if(b[d+40>>0]|0){fRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[i>>2]&255,(b[(f[d+68>>2]|0)+56>>0]|0)!=0,e,d);return}i=f[d+52>>2]|0;if(!i)j=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;else j=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)|0;h=c+(f[(f[a+16>>2]|0)+(j<<2)>>2]|0)|0;j=f[h>>2]|0;if((j|0)==(f[h+4>>2]|0)){qza(h,j+1|0);k=f[h>>2]|0}else k=j;j=f[h+8>>2]|0;f[h>>2]=k+1;n[j+4+(k<<2)>>2]=e;return}function _Gb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,468401,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,468401,467614);i=d+32|0;if((f[136e3+(f[i>>2]<<2)>>2]|0)!=5)vHb(f[h>>2]|0,d,468401,5);if(b[d+40>>0]|0){mRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[i>>2]&255,(b[(f[d+68>>2]|0)+56>>0]|0)!=0,e,d);return}i=f[d+52>>2]|0;if(!i)j=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;else j=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)|0;h=c+(f[(f[a+16>>2]|0)+(j<<2)>>2]|0)|0;j=f[h>>2]|0;if((j|0)==(f[h+4>>2]|0)){tFa(h,j+1|0);k=f[h>>2]|0}else k=j;j=f[h+8>>2]|0;f[h>>2]=k+1;p[j+8+(k<<3)>>3]=e;return}function $Gb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,468393,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,468393,467614);i=d+32|0;if((f[136e3+(f[i>>2]<<2)>>2]|0)!=7)vHb(f[h>>2]|0,d,468393,7);if(b[d+40>>0]|0){tRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[i>>2]&255,(b[(f[d+68>>2]|0)+56>>0]|0)!=0,e,d);return}i=f[d+52>>2]|0;if(!i)j=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;else j=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)|0;h=c+(f[(f[a+16>>2]|0)+(j<<2)>>2]|0)|0;j=f[h>>2]|0;if((j|0)==(f[h+4>>2]|0)){vFa(h,j+1|0);k=f[h>>2]|0}else k=j;j=f[h+8>>2]|0;f[h>>2]=k+1;b[j+4+k>>0]=e&1;return}function aHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,468383,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,468383,467614);i=d+32|0;if((f[136e3+(f[i>>2]<<2)>>2]|0)!=9)vHb(f[h>>2]|0,d,468383,9);if(b[d+40>>0]|0){_5b(IRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[i>>2]&255,d)|0,e)|0;return}i=f[d+52>>2]|0;if(!i)j=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;else j=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)|0;_5b(mza(c+(f[(f[a+16>>2]|0)+(j<<2)>>2]|0)|0)|0,e)|0;return}function bHb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;if((f[d+12>>2]|0)!=(f[c+64>>2]|0))zHb(f[a+4>>2]|0,c,468208,d);yHb(a,b,c,f[d+8>>2]|0);return}function cHb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0;e=u;u=u+32|0;g=e;h=a+4|0;i=f[h>>2]|0;if((f[c+48>>2]|0)!=(i|0))tHb(i,c,468208,468162);if((f[c+36>>2]|0)!=3)tHb(f[h>>2]|0,c,468208,467614);if((f[136e3+(f[c+32>>2]<<2)>>2]|0)!=8)vHb(f[h>>2]|0,c,468208,8);if((f[(f[(f[h>>2]|0)+8>>2]|0)+64>>2]|0)==3){j=d;yHb(a,b,c,j);u=e;return}if(tub(f[c+64>>2]|0,d)|0){j=d;yHb(a,b,c,j);u=e;return}zpb(g,2,466902,1430);h=vpb(ypb(vpb(g,468216)|0,d)|0,468271)|0;xpb(e+24|0,wpb(h,f[c+4>>2]|0)|0);Apb(g);j=f[(f[c+80>>2]|0)+8>>2]|0;yHb(a,b,c,j);u=e;return}function dHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,468197,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,468197,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=10)vHb(f[h>>2]|0,d,468197,10);if(!e)j=f[a+48>>2]|0;else j=e;e=d+40|0;if(b[e>>0]|0){k=CFb(c+(f[a+32>>2]|0)|0,d,j)|0;return k|0}i=xub(d)|0;l=f[d+52>>2]|0;m=(l|0)==0;if(i){if(m){i=d;do if(b[e>>0]|0){n=f[d+56>>2]|0;if(!n){o=(f[d+24>>2]|0)+72|0;break}else{o=n+68|0;break}}else o=(f[g>>2]|0)+28|0;while(0);p=(i-(f[o>>2]|0)|0)/88|0}else p=((l-(f[(f[l+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)|0;q=pKb(c+(f[(f[a+16>>2]|0)+(p<<2)>>2]|0)|0)|0}else{if(m){m=d;do if(b[e>>0]|0){p=f[d+56>>2]|0;if(!p){r=(f[d+24>>2]|0)+72|0;break}else{r=p+68|0;break}}else r=(f[g>>2]|0)+28|0;while(0);s=(m-(f[r>>2]|0)|0)/88|0}else s=((l-(f[(f[l+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)|0;q=c+(f[(f[a+16>>2]|0)+(s<<2)>>2]|0)|0}s=q+12|0;a=f[s>>2]|0;h=q+4|0;l=f[h>>2]|0;if((a|0)!=0?(l|0)<(f[a>>2]|0):0){r=l+1|0;f[h>>2]=r;m=f[a+4+(l<<2)>>2]|0;if(!m)t=r;else{k=m;return k|0}}else t=l;if(!t)u=Uh[f[(f[j>>2]|0)+8>>2]&1023](j,f[d+60>>2]|0)|0;else u=f[a+4>>2]|0;a=f[(f[u>>2]|0)+16>>2]|0;d=di[f[(f[c>>2]|0)+20>>2]&1023](c)|0;c=Uh[a&1023](u,d)|0;d=f[s>>2]|0;u=f[q+8>>2]|0;do if((d|0)!=0?(a=f[h>>2]|0,(a|0)!=(u|0)):0){j=f[d>>2]|0;if((j|0)==(u|0)){t=f[d+4+(a<<2)>>2]|0;if((t|0)==0|(f[q>>2]|0)!=0){v=d;break}bi[f[(f[t>>2]|0)+4>>2]&2047](t);v=f[s>>2]|0;break}if((a|0)<(j|0)){f[d+4+(j<<2)>>2]=f[d+4+(a<<2)>>2];a=f[s>>2]|0;w=a;x=f[a>>2]|0}else{w=d;x=j}f[w>>2]=x+1;v=w}else y=38;while(0);if((y|0)==38){cpb(q,u+1|0);u=f[s>>2]|0;f[u>>2]=(f[u>>2]|0)+1;v=u}u=f[h>>2]|0;f[h>>2]=u+1;f[v+4+(u<<2)>>2]=c;k=c;return k|0}function eHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,468142,468162);if((f[d+36>>2]|0)!=3)tHb(f[h>>2]|0,d,468142,467614);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=10)vHb(f[h>>2]|0,d,468142,10);i=d+40|0;if(b[i>>0]|0){EFb(c+(f[a+32>>2]|0)|0,d,e);return}j=xub(d)|0;k=f[d+52>>2]|0;l=(k|0)==0;if(j){if(l){j=d;do if(b[i>>0]|0){m=f[d+56>>2]|0;if(!m){n=(f[d+24>>2]|0)+72|0;break}else{n=m+68|0;break}}else n=(f[g>>2]|0)+28|0;while(0);o=(j-(f[n>>2]|0)|0)/88|0}else o=((k-(f[(f[k+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)|0;p=pKb(c+(f[(f[a+16>>2]|0)+(o<<2)>>2]|0)|0)|0}else{if(l){l=d;do if(b[i>>0]|0){o=f[d+56>>2]|0;if(!o){q=(f[d+24>>2]|0)+72|0;break}else{q=o+68|0;break}}else q=(f[g>>2]|0)+28|0;while(0);r=(l-(f[q>>2]|0)|0)/88|0}else r=((k-(f[(f[k+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)|0;p=c+(f[(f[a+16>>2]|0)+(r<<2)>>2]|0)|0}r=$Nb(e)|0;a=f[p>>2]|0;if(((a|0)==(r|0)?(r=p+12|0,c=f[r>>2]|0,c|0):0)?(h=f[c>>2]|0,(h|0)<(f[p+8>>2]|0)):0){k=p+4|0;q=f[k>>2]|0;if((q|0)<(h|0)){l=c+4+(q<<2)|0;f[c+4+(h<<2)>>2]=f[l>>2];s=l}else s=c+4+(q<<2)|0;f[s>>2]=e;f[k>>2]=q+1;q=f[r>>2]|0;f[q>>2]=(f[q>>2]|0)+1;return}wHb(p,e,_Nb(e)|0,a);return}function fHb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;if((f[a+32>>2]|0)==-1){d=0;return d|0}e=a+44|0;g=lub(f[e>>2]|0,c)|0;if(g){h=a+4|0;i=f[h>>2]|0;if((f[g+48>>2]|0)==(i|0)){d=g;return d|0}else{j=h;k=i}}else{i=a+4|0;j=i;k=f[i>>2]|0}if(!(b[(f[k+16>>2]|0)+48>>0]|0)){d=0;return d|0}k=jub(f[e>>2]|0,c)|0;if(!k){d=0;return d|0}c=f[k+64>>2]|0;if((c|0)<=0){d=0;return d|0}e=f[k+68>>2]|0;i=f[j>>2]|0;j=0;while(1){if((((f[e+(j*88|0)+48>>2]|0)==(i|0)?(f[e+(j*88|0)+32>>2]|0)==11:0)?(f[e+(j*88|0)+36>>2]|0)==1:0)?(f[e+(j*88|0)+60>>2]|0)==(k|0):0)break;a=j+1|0;if((a|0)<(c|0))j=a;else{d=0;l=15;break}}if((l|0)==15)return d|0;d=e+(j*88|0)|0;return d|0}function gHb(a,b){a=a|0;b=b|0;var c=0;if((f[a+32>>2]|0)==-1){c=0;return c|0}c=mub(f[a+44>>2]|0,f[a+4>>2]|0,b)|0;return c|0}function hHb(a){a=a|0;return (f[(f[(f[a+4>>2]|0)+8>>2]|0)+64>>2]|0)==3|0}function iHb(a){a=a|0;return f[a+48>>2]|0}function jHb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+64|0;j=i+24|0;k=i+49|0;l=i;m=i+48|0;if((f[d+36>>2]|0)!=3)tHb(f[a+4>>2]|0,d,468092,467614);n=d+32|0;if((f[136e3+(f[n>>2]<<2)>>2]|0)!=(e|0))vHb(f[a+4>>2]|0,d,468118,e);if((g|0)>-1?(f[(f[d+68>>2]|0)+48>>2]|0)!=(g|0):0){zpb(j,3,466902,1721);xpb(k,vpb(vpb(j,467691)|0,467745)|0);Apb(j)}if(h|0?(f[d+60>>2]|0)!=(h|0):0){zpb(l,3,466902,1723);xpb(m,vpb(vpb(l,467762)|0,467812)|0);Apb(l)}l=d+40|0;if(b[l>>0]|0){m=c+(f[a+32>>2]|0)|0;h=f[d+28>>2]|0;j=f[n>>2]&255;o=wRb(m,h,j,yub(d)|0,d)|0;u=i;return o|0}j=xub(d)|0;h=f[a+16>>2]|0;a=d;do if(b[l>>0]|0){m=f[d+56>>2]|0;if(!m){p=(f[d+24>>2]|0)+72|0;break}else{p=m+68|0;break}}else p=(f[d+48>>2]|0)+28|0;while(0);d=c+(f[h+(((a-(f[p>>2]|0)|0)/88|0)<<2)>>2]|0)|0;if(!j){o=d;u=i;return o|0}o=pKb(d)|0;u=i;return o|0}function kHb(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=u;u=u+64|0;j=i+24|0;k=i+49|0;l=i;m=i+48|0;if((f[d+36>>2]|0)!=3)tHb(f[a+4>>2]|0,d,467592,467614);n=d+32|0;if((f[136e3+(f[n>>2]<<2)>>2]|0)!=(e|0))vHb(f[a+4>>2]|0,d,467671,e);if((g|0)>-1?(f[(f[d+68>>2]|0)+48>>2]|0)!=(g|0):0){zpb(j,3,466902,1747);xpb(k,vpb(vpb(j,467691)|0,467745)|0);Apb(j)}if(h|0?(f[d+60>>2]|0)!=(h|0):0){zpb(l,3,466902,1749);xpb(m,vpb(vpb(l,467762)|0,467812)|0);Apb(l)}l=d+40|0;if(b[l>>0]|0){m=c+(f[a+32>>2]|0)|0;h=f[d+28>>2]|0;j=f[n>>2]&255;o=wRb(m,h,j,yub(d)|0,d)|0;u=i;return o|0}j=xub(d)|0;h=f[a+16>>2]|0;a=d;do if(b[l>>0]|0){m=f[d+56>>2]|0;if(!m){p=(f[d+24>>2]|0)+72|0;break}else{p=m+68|0;break}}else p=(f[d+48>>2]|0)+28|0;while(0);d=c+(f[h+(((a-(f[p>>2]|0)|0)/88|0)<<2)>>2]|0)|0;if(!j){o=d;u=i;return o|0}o=oKb(d)|0;u=i;return o|0}function lHb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+80|0;i=h+48|0;j=h+24|0;k=h+73|0;l=h;m=h+72|0;if((f[d+36>>2]|0)!=3){zpb(i,3,466902,2236);xpb(h+74|0,vpb(i,473407)|0);Apb(i)}i=d+32|0;n=f[136e3+(f[i>>2]<<2)>>2]|0;if((n|0)!=(e|0)?!((e|0)==1&(n|0)==8):0){zpb(j,3,466902,2239);xpb(k,vpb(vpb(vpb(vpb(j,467242)|0,467390)|0,467453)|0,467518)|0);Apb(j)}if(g|0?(f[d+60>>2]|0)!=(g|0):0){zpb(l,3,466902,2244);xpb(m,vpb(l,467534)|0);Apb(l)}if(!(b[d+40>>0]|0)){o=c+(f[(f[a+16>>2]|0)+(((d-(f[(f[d+48>>2]|0)+28>>2]|0)|0)/88|0)<<2)>>2]|0)|0;u=h;return o|0}else{l=c+(f[a+32>>2]|0)|0;a=f[d+28>>2]|0;c=f[i>>2]&255;o=wRb(l,a,c,yub(d)|0,d)|0;u=h;return o|0}return 0}function mHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;if(!(xub(d)|0))tHb(f[a+4>>2]|0,d,467225,466876);g=f[d+52>>2]|0;do if(!g){h=d;do if(b[d+40>>0]|0){i=f[d+56>>2]|0;if(!i){j=(f[d+24>>2]|0)+72|0;break}else{j=i+68|0;break}}else j=(f[d+48>>2]|0)+28|0;while(0);k=c;l=(h-(f[j>>2]|0)|0)/88|0}else{i=(g-(f[(f[g+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(i<<2)>>2]|0)==(f[d+28>>2]|0)){k=c;l=(f[(f[a+4>>2]|0)+24>>2]|0)+i|0;break}i=f[a+16>>2]|0;m=f[a+12>>2]|0;n=d;do if(b[d+40>>0]|0){o=f[d+56>>2]|0;if(!o){p=(f[d+24>>2]|0)+72|0;break}else{p=o+68|0;break}}else p=(f[d+48>>2]|0)+28|0;while(0);q=i+(((n-(f[p>>2]|0)|0)/88|0)<<2)|0;r=m;s=f[q>>2]|0;t=r+s|0;u=f[t>>2]|0;v=u+8|0;w=f[v>>2]|0;x=Uh[w&1023](t,e)|0;return x|0}while(0);q=(f[a+16>>2]|0)+(l<<2)|0;r=k;s=f[q>>2]|0;t=r+s|0;u=f[t>>2]|0;v=u+8|0;w=f[v>>2]|0;x=Uh[w&1023](t,e)|0;return x|0}function nHb(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+16|0;i=h;if(!(xub(d)|0))tHb(f[a+4>>2]|0,d,467200,466876);j=f[d+60>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;k=i+11|0;b[k>>0]=5;b[i>>0]=b[471917]|0;b[i+1>>0]=b[471918]|0;b[i+2>>0]=b[471919]|0;b[i+3>>0]=b[471920]|0;b[i+4>>0]=b[471921]|0;b[i+5>>0]=0;l=(rub(j,i)|0)+32|0;f[g+4>>2]=f[136e3+(f[l>>2]<<2)>>2];if((b[k>>0]|0)<0)O5b(f[i>>2]|0);i=f[d+52>>2]|0;if(i|0){m=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;n=a+16|0;o=f[n>>2]|0;p=o+(m<<2)|0;q=f[p>>2]|0;r=c+q|0;s=f[r>>2]|0;t=s+12|0;v=f[t>>2]|0;w=li[v&511](r,e,g)|0;u=h;return w|0}i=d;do if(b[d+40>>0]|0){k=f[d+56>>2]|0;if(!k){x=(f[d+24>>2]|0)+72|0;break}else{x=k+68|0;break}}else x=(f[d+48>>2]|0)+28|0;while(0);m=(i-(f[x>>2]|0)|0)/88|0;n=a+16|0;o=f[n>>2]|0;p=o+(m<<2)|0;q=f[p>>2]|0;r=c+q|0;s=f[r>>2]|0;t=s+12|0;v=f[t>>2]|0;w=li[v&511](r,e,g)|0;u=h;return w|0}function oHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0;if(!(xub(d)|0))tHb(f[a+4>>2]|0,d,467183,466876);g=f[d+52>>2]|0;if(!g){h=d;do if(b[d+40>>0]|0){i=f[d+56>>2]|0;if(!i){j=(f[d+24>>2]|0)+72|0;break}else{j=i+68|0;break}}else j=(f[d+48>>2]|0)+28|0;while(0);k=(h-(f[j>>2]|0)|0)/88|0}else k=((g-(f[(f[g+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;g=c+(f[(f[a+16>>2]|0)+(k<<2)>>2]|0)|0;return Uh[f[(f[g>>2]|0)+16>>2]&1023](g,e)|0}function pHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if(!(xub(e)|0))tHb(f[c+4>>2]|0,e,467172,466876);uHb(a,d,e);g=f[e+52>>2]|0;do if(!g){h=e;do if(b[e+40>>0]|0){i=f[e+56>>2]|0;if(!i){j=(f[e+24>>2]|0)+72|0;break}else{j=i+68|0;break}}else j=(f[e+48>>2]|0)+28|0;while(0);k=d;l=(h-(f[j>>2]|0)|0)/88|0}else{i=(g-(f[(f[g+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[d+(f[c+24>>2]|0)+(i<<2)>>2]|0)==(f[e+28>>2]|0)){k=d;l=(f[(f[c+4>>2]|0)+24>>2]|0)+i|0;break}i=f[c+16>>2]|0;m=f[c+12>>2]|0;n=e;do if(b[e+40>>0]|0){o=f[e+56>>2]|0;if(!o){p=(f[e+24>>2]|0)+72|0;break}else{p=o+68|0;break}}else p=(f[e+48>>2]|0)+28|0;while(0);q=i+(((n-(f[p>>2]|0)|0)/88|0)<<2)|0;r=m;s=f[q>>2]|0;t=r+s|0;u=f[t>>2]|0;v=u+24|0;w=f[v>>2]|0;zh[w&2047](t,a);return}while(0);q=(f[c+16>>2]|0)+(l<<2)|0;r=k;s=f[q>>2]|0;t=r+s|0;u=f[t>>2]|0;v=u+24|0;w=f[v>>2]|0;zh[w&2047](t,a);return}function qHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if(!(xub(e)|0))tHb(f[c+4>>2]|0,e,467163,466876);uHb(a,d,e);g=f[e+52>>2]|0;do if(!g){h=e;do if(b[e+40>>0]|0){i=f[e+56>>2]|0;if(!i){j=(f[e+24>>2]|0)+72|0;break}else{j=i+68|0;break}}else j=(f[e+48>>2]|0)+28|0;while(0);k=d;l=(h-(f[j>>2]|0)|0)/88|0}else{i=(g-(f[(f[g+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[d+(f[c+24>>2]|0)+(i<<2)>>2]|0)==(f[e+28>>2]|0)){k=d;l=(f[(f[c+4>>2]|0)+24>>2]|0)+i|0;break}i=f[c+16>>2]|0;m=f[c+12>>2]|0;n=e;do if(b[e+40>>0]|0){o=f[e+56>>2]|0;if(!o){p=(f[e+24>>2]|0)+72|0;break}else{p=o+68|0;break}}else p=(f[e+48>>2]|0)+28|0;while(0);q=i+(((n-(f[p>>2]|0)|0)/88|0)<<2)|0;r=m;s=f[q>>2]|0;t=r+s|0;u=f[t>>2]|0;v=u+28|0;w=f[v>>2]|0;zh[w&2047](t,a);return}while(0);q=(f[c+16>>2]|0)+(l<<2)|0;r=k;s=f[q>>2]|0;t=r+s|0;u=f[t>>2]|0;v=u+28|0;w=f[v>>2]|0;zh[w&2047](t,a);return}function rHb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if(!(xub(d)|0))tHb(f[a+4>>2]|0,d,467153,466876);e=f[d+52>>2]|0;do if(!e){g=d;do if(b[d+40>>0]|0){h=f[d+56>>2]|0;if(!h){i=(f[d+24>>2]|0)+72|0;break}else{i=h+68|0;break}}else i=(f[d+48>>2]|0)+28|0;while(0);j=c;k=(g-(f[i>>2]|0)|0)/88|0}else{h=(e-(f[(f[e+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(h<<2)>>2]|0)==(f[d+28>>2]|0)){j=c;k=(f[(f[a+4>>2]|0)+24>>2]|0)+h|0;break}h=f[a+16>>2]|0;l=f[a+12>>2]|0;m=d;do if(b[d+40>>0]|0){n=f[d+56>>2]|0;if(!n){o=(f[d+24>>2]|0)+72|0;break}else{o=n+68|0;break}}else o=(f[d+48>>2]|0)+28|0;while(0);p=h+(((m-(f[o>>2]|0)|0)/88|0)<<2)|0;q=l;r=f[p>>2]|0;s=q+r|0;t=f[s>>2]|0;u=t+32|0;v=f[u>>2]|0;w=di[v&1023](s)|0;return w|0}while(0);p=(f[a+16>>2]|0)+(k<<2)|0;q=j;r=f[p>>2]|0;s=q+r|0;t=f[s>>2]|0;u=t+32|0;v=f[u>>2]|0;w=di[v&1023](s)|0;return w|0}function sHb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!(xub(d)|0))tHb(f[a+4>>2]|0,d,466863,466876);e=f[d+52>>2]|0;if(e|0){g=((e-(f[(f[e+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;h=a+16|0;i=f[h>>2]|0;j=i+(g<<2)|0;k=f[j>>2]|0;l=c+k|0;return l|0}e=d;do if(b[d+40>>0]|0){m=f[d+56>>2]|0;if(!m){n=(f[d+24>>2]|0)+72|0;break}else{n=m+68|0;break}}else n=(f[d+48>>2]|0)+28|0;while(0);g=(e-(f[n>>2]|0)|0)/88|0;h=a+16|0;i=f[h>>2]|0;j=i+(g<<2)|0;k=f[j>>2]|0;l=c+k|0;return l|0}function tHb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;zpb(g,3,466902,90);h=vpb(vpb(vpb(g,467012)|0,c)|0,467099)|0;c=vpb(wpb(h,f[a+4>>2]|0)|0,467117)|0;xpb(e+24|0,vpb(vpb(wpb(c,f[b+4>>2]|0)|0,467135)|0,d)|0);Apb(g);u=e;return}function uHb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;h=a+8|0;i=a+16|0;f[i>>2]=0;f[a+24>>2]=0;j=a+28|0;f[j>>2]=0;k=di[f[(f[c>>2]|0)+92>>2]&1023](c)|0;l=li[f[(f[k>>2]|0)+364>>2]&511](k,c,d)|0;c=a+4|0;f[c>>2]=l;l=d+60|0;d=f[l>>2]|0;k=g+4|0;f[k>>2]=0;f[k+4>>2]=0;k=g+11|0;b[k>>0]=3;b[g>>0]=b[471913]|0;b[g+1>>0]=b[471914]|0;b[g+2>>0]=b[471915]|0;b[g+3>>0]=0;m=(rub(d,g)|0)+32|0;d=f[136e3+(f[m>>2]<<2)>>2]|0;m=f[i>>2]|0;if((m|0)!=(d|0)){if((m|0)==9?(m=f[h>>2]|0,m|0):0){if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);O5b(m)}f[i>>2]=d;if((d|0)==9){d=L5b(12)|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[h>>2]=d}}if((b[k>>0]|0)<0)O5b(f[g>>2]|0);k=f[l>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;l=g+11|0;b[l>>0]=5;b[g>>0]=b[471917]|0;b[g+1>>0]=b[471918]|0;b[g+2>>0]=b[471919]|0;b[g+3>>0]=b[471920]|0;b[g+4>>0]=b[471921]|0;b[g+5>>0]=0;d=(rub(k,g)|0)+32|0;f[j>>2]=f[136e3+(f[d>>2]<<2)>>2];if((b[l>>0]|0)>=0){n=f[c>>2]|0;o=f[n>>2]|0;p=o+48|0;q=f[p>>2]|0;zh[q&2047](n,a);u=e;return}O5b(f[g>>2]|0);n=f[c>>2]|0;o=f[n>>2]|0;p=o+48|0;q=f[p>>2]|0;zh[q&2047](n,a);u=e;return}function vHb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;zpb(g,3,466902,116);h=vpb(vpb(vpb(g,467012)|0,c)|0,467099)|0;c=vpb(wpb(h,f[a+4>>2]|0)|0,467117)|0;a=vpb(wpb(c,f[b+4>>2]|0)|0,467834)|0;c=vpb(vpb(a,f[140040+(d<<2)>>2]|0)|0,467914)|0;xpb(e+24|0,vpb(c,f[140040+(f[136e3+(f[b+32>>2]<<2)>>2]<<2)>>2]|0)|0);Apb(g);u=e;return}function wHb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!((c|0)==0&(d|0)!=0))if((d|0)!=(c|0)){e=tLb(b,d)|0;xHb(b,e);if((b|0)==0|(c|0)!=0)g=e;else{bi[f[(f[b>>2]|0)+4>>2]&2047](b);g=e}}else g=b;else{eFb(d,b);g=b}b=a+12|0;d=f[b>>2]|0;e=f[a+8>>2]|0;c=a+4|0;do if((d|0)!=0?(h=f[c>>2]|0,(h|0)!=(e|0)):0){i=f[d>>2]|0;if((i|0)==(e|0)){j=f[d+4+(h<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0){k=d;break}bi[f[(f[j>>2]|0)+4>>2]&2047](j);k=f[b>>2]|0;break}if((h|0)<(i|0)){f[d+4+(i<<2)>>2]=f[d+4+(h<<2)>>2];h=f[b>>2]|0;l=h;m=f[h>>2]|0}else{l=d;m=i}f[l>>2]=m+1;k=l}else n=8;while(0);if((n|0)==8){cpb(a,e+1|0);e=f[b>>2]|0;f[e>>2]=(f[e>>2]|0)+1;k=e}e=f[c>>2]|0;f[c>>2]=e+1;f[k+4+(e<<2)>>2]=g;return}function xHb(a,b){a=a|0;b=b|0;zh[f[(f[b>>2]|0)+76>>2]&2047](b,a);return}function yHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0;if(b[d+40>>0]|0){DRb(c+(f[a+32>>2]|0)|0,f[d+28>>2]|0,f[d+32>>2]&255,(b[(f[d+68>>2]|0)+56>>0]|0)!=0,e,d);return}g=f[d+52>>2]|0;if(!g)h=(d-(f[(f[d+48>>2]|0)+28>>2]|0)|0)/88|0;else h=((g-(f[(f[g+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;g=c+(f[(f[a+16>>2]|0)+(h<<2)>>2]|0)|0;h=f[g>>2]|0;if((h|0)==(f[g+4>>2]|0)){nza(g,h+1|0);i=f[g>>2]|0}else i=h;h=f[g+8>>2]|0;f[g>>2]=i+1;f[h+4+(i<<2)>>2]=e;return}function zHb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0;e=u;u=u+32|0;g=e;zpb(g,3,466902,129);h=vpb(vpb(vpb(g,467012)|0,c)|0,467099)|0;c=vpb(wpb(h,f[a+4>>2]|0)|0,467117)|0;a=vpb(wpb(c,f[b+4>>2]|0)|0,468294)|0;c=vpb(wpb(a,f[(f[b+64>>2]|0)+4>>2]|0)|0,468365)|0;xpb(e+24|0,wpb(c,f[d+4>>2]|0)|0);Apb(g);u=e;return}function AHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=a+4|0;g=f[e>>2]|0;if((g|0)>=(b|0)){u=c;return}h=a+8|0;i=f[h>>2]|0;j=(i|0)==0;if(j)k=0;else k=f[i>>2]|0;l=g<<1;g=(l|0)<(b|0)?b:l;l=(g|0)>4?g:4;if(l>>>0>536870910){zpb(d,3,468430,1285);xpb(c+24|0,vpb(vpb(d,468525)|0,468650)|0);Apb(d)}d=(l<<3)+8|0;if(!k)m=L5b(d)|0;else m=znb(k,25528,d)|0;f[h>>2]=m;f[m>>2]=k;f[e>>2]=l;e=m+8|0;if((l|0)>0){l=m+d|0;d=m+16|0;Nac(e|0,0,(l>>>0>d>>>0?l:d)+(-9-m)+8&-8|0)|0}m=f[a>>2]|0;if((m|0)>0)Vac(e|0,i+8|0,m<<3|0)|0;if(j){u=c;return}if(f[i>>2]|0){u=c;return}O5b(i);u=c;return}function BHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=d+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,d,469174,468162);if((f[d+36>>2]|0)==3)tHb(f[h>>2]|0,d,469174,469189);if((f[136e3+(f[d+32>>2]<<2)>>2]|0)!=10)vHb(f[h>>2]|0,d,469174,10);if(!e)j=f[a+48>>2]|0;else j=e;if(b[d+40>>0]|0){k=yFb(c+(f[a+32>>2]|0)|0,d,j)|0;return k|0}j=f[a+20>>2]|0;if((j|0)!=-1){e=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;i=c+j+(e>>>5<<2)|0;f[i>>2]=f[i>>2]&~(1<<(e&31))}e=f[d+52>>2]|0;do if(e){i=(e-(f[(f[e+8>>2]|0)+36>>2]|0)|0)/28|0;j=c+(f[a+24>>2]|0)+(i<<2)|0;if((f[j>>2]|0)==(f[d+28>>2]|0)){f[j>>2]=0;l=c;m=i+(f[(f[h>>2]|0)+24>>2]|0)|0;break}else{k=0;return k|0}}else{l=c;m=(d-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0}while(0);g=l+(f[(f[a+16>>2]|0)+(m<<2)>>2]|0)|0;m=f[g>>2]|0;f[g>>2]=0;k=m;return k|0}function CHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=e+48|0;h=a+4|0;i=f[h>>2]|0;if((f[g>>2]|0)!=(i|0))tHb(i,e,469246,468162);if((f[e+36>>2]|0)==3)tHb(f[h>>2]|0,e,469246,469189);i=e+32|0;if((f[136e3+(f[i>>2]<<2)>>2]|0)!=10)vHb(f[h>>2]|0,e,469246,10);j=e+40|0;if(b[j>>0]|0){KRb(c+(f[a+32>>2]|0)|0,f[e+28>>2]|0,f[i>>2]&255,e,d);return}i=e+52|0;k=f[i>>2]|0;l=(d|0)==0;if(k|0){_h[f[(f[a>>2]|0)+36>>2]&255](a,c,k);if(l)return;k=f[i>>2]|0;if(!k){m=e;do if(b[j>>0]|0){n=f[e+56>>2]|0;if(!n){o=(f[e+24>>2]|0)+72|0;break}else{o=n+68|0;break}}else o=(f[g>>2]|0)+28|0;while(0);p=(m-(f[o>>2]|0)|0)/88|0}else p=((k-(f[(f[k+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[h>>2]|0)+24>>2]|0)|0;f[c+(f[(f[a+16>>2]|0)+(p<<2)>>2]|0)>>2]=d;p=f[i>>2]|0;f[c+(f[a+24>>2]|0)+(((p-(f[(f[p+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]=f[e+28>>2];return}p=f[a+20>>2]|0;i=(p|0)==-1;if(l){if(!i){l=(e-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;h=c+p+(l>>>5<<2)|0;f[h>>2]=f[h>>2]&~(1<<(l&31))}}else if(!i){i=(e-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0;l=c+p+(i>>>5<<2)|0;f[l>>2]=1<<(i&31)|f[l>>2]}l=c+(f[(f[a+16>>2]|0)+(((e-(f[(f[g>>2]|0)+28>>2]|0)|0)/88|0)<<2)>>2]|0)|0;g=f[a+36>>2]|0;if((g|0)!=-1){e=c+g|0;do if((f[a+28>>2]|0)==-1){g=f[e>>2]|0;c=g&-2;if(!(g&1)){q=c;break}else{q=f[c+4>>2]|0;break}}else q=f[e>>2]|0;while(0);if(!q)r=32}else r=32;if((r|0)==32?(r=f[l>>2]|0,r|0):0)bi[f[(f[r>>2]|0)+4>>2]&2047](r);f[l>>2]=d;return}function DHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=d+52|0;h=f[g>>2]|0;do if(!h){i=f[e>>2]|0;j=7}else{if((f[c+(f[a+24>>2]|0)+(((h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)!=(f[d+28>>2]|0)){_h[f[(f[a>>2]|0)+36>>2]&255](a,c,h);k=f[g>>2]|0;l=f[e>>2]|0;if(!k){i=l;j=7;break}else{m=k;n=l}}else{m=h;n=f[e>>2]|0}o=c;p=((m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;q=n;r=m}while(0);if((j|0)==7){j=d;do if(b[d+40>>0]|0){m=f[d+56>>2]|0;if(!m){s=(f[d+24>>2]|0)+72|0;break}else{s=m+68|0;break}}else s=(f[d+48>>2]|0)+28|0;while(0);o=c;p=(j-(f[s>>2]|0)|0)/88|0;q=i;r=0}f[o+(f[(f[a+16>>2]|0)+(p<<2)>>2]|0)>>2]=q;if(r|0){f[o+(f[a+24>>2]|0)+(((r-(f[(f[r+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]=f[d+28>>2];return}r=f[a+20>>2]|0;if((r|0)==-1)return;a=d;do if(b[d+40>>0]|0){q=f[d+56>>2]|0;if(!q){t=(f[d+24>>2]|0)+72|0;break}else{t=q+68|0;break}}else t=(f[d+48>>2]|0)+28|0;while(0);d=(a-(f[t>>2]|0)|0)/88|0;t=o+r+(d>>>5<<2)|0;f[t>>2]=1<<(d&31)|f[t>>2];return}function EHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=d+52|0;h=f[g>>2]|0;do if(!h){i=b[e>>0]|0;j=7}else{if((f[c+(f[a+24>>2]|0)+(((h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)!=(f[d+28>>2]|0)){_h[f[(f[a>>2]|0)+36>>2]&255](a,c,h);k=f[g>>2]|0;l=b[e>>0]|0;if(!k){i=l;j=7;break}else{m=k;n=l}}else{m=h;n=b[e>>0]|0}o=c;p=((m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;q=n;r=m}while(0);if((j|0)==7){j=d;do if(b[d+40>>0]|0){m=f[d+56>>2]|0;if(!m){s=(f[d+24>>2]|0)+72|0;break}else{s=m+68|0;break}}else s=(f[d+48>>2]|0)+28|0;while(0);o=c;p=(j-(f[s>>2]|0)|0)/88|0;q=i;r=0}b[o+(f[(f[a+16>>2]|0)+(p<<2)>>2]|0)>>0]=q;if(r|0){f[o+(f[a+24>>2]|0)+(((r-(f[(f[r+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]=f[d+28>>2];return}r=f[a+20>>2]|0;if((r|0)==-1)return;a=d;do if(b[d+40>>0]|0){q=f[d+56>>2]|0;if(!q){t=(f[d+24>>2]|0)+72|0;break}else{t=q+68|0;break}}else t=(f[d+48>>2]|0)+28|0;while(0);d=(a-(f[t>>2]|0)|0)/88|0;t=o+r+(d>>>5<<2)|0;f[t>>2]=1<<(d&31)|f[t>>2];return}function FHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0,k=0,l=0.0,m=0,n=0.0,o=0,q=0,r=0.0,s=0,t=0,u=0;g=d+52|0;h=f[g>>2]|0;do if(!h){i=+p[e>>3];j=7}else{if((f[c+(f[a+24>>2]|0)+(((h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)!=(f[d+28>>2]|0)){_h[f[(f[a>>2]|0)+36>>2]&255](a,c,h);k=f[g>>2]|0;l=+p[e>>3];if(!k){i=l;j=7;break}else{m=k;n=l}}else{m=h;n=+p[e>>3]}o=c;q=((m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;r=n;s=m}while(0);if((j|0)==7){j=d;do if(b[d+40>>0]|0){m=f[d+56>>2]|0;if(!m){t=(f[d+24>>2]|0)+72|0;break}else{t=m+68|0;break}}else t=(f[d+48>>2]|0)+28|0;while(0);o=c;q=(j-(f[t>>2]|0)|0)/88|0;r=i;s=0}p[o+(f[(f[a+16>>2]|0)+(q<<2)>>2]|0)>>3]=r;if(s|0){f[o+(f[a+24>>2]|0)+(((s-(f[(f[s+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]=f[d+28>>2];return}s=f[a+20>>2]|0;if((s|0)==-1)return;a=d;do if(b[d+40>>0]|0){q=f[d+56>>2]|0;if(!q){u=(f[d+24>>2]|0)+72|0;break}else{u=q+68|0;break}}else u=(f[d+48>>2]|0)+28|0;while(0);d=(a-(f[u>>2]|0)|0)/88|0;u=o+s+(d>>>5<<2)|0;f[u>>2]=1<<(d&31)|f[u>>2];return}function GHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=d+52|0;h=f[g>>2]|0;do if(!h){i=f[e>>2]|0;j=7}else{if((f[c+(f[a+24>>2]|0)+(((h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)!=(f[d+28>>2]|0)){_h[f[(f[a>>2]|0)+36>>2]&255](a,c,h);k=f[g>>2]|0;l=f[e>>2]|0;if(!k){i=l;j=7;break}else{m=k;n=l}}else{m=h;n=f[e>>2]|0}o=c;p=((m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;q=n;r=m}while(0);if((j|0)==7){j=d;do if(b[d+40>>0]|0){m=f[d+56>>2]|0;if(!m){s=(f[d+24>>2]|0)+72|0;break}else{s=m+68|0;break}}else s=(f[d+48>>2]|0)+28|0;while(0);o=c;p=(j-(f[s>>2]|0)|0)/88|0;q=i;r=0}f[o+(f[(f[a+16>>2]|0)+(p<<2)>>2]|0)>>2]=q;if(r|0){f[o+(f[a+24>>2]|0)+(((r-(f[(f[r+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]=f[d+28>>2];return}r=f[a+20>>2]|0;if((r|0)==-1)return;a=d;do if(b[d+40>>0]|0){q=f[d+56>>2]|0;if(!q){t=(f[d+24>>2]|0)+72|0;break}else{t=q+68|0;break}}else t=(f[d+48>>2]|0)+28|0;while(0);d=(a-(f[t>>2]|0)|0)/88|0;t=o+r+(d>>>5<<2)|0;f[t>>2]=1<<(d&31)|f[t>>2];return}function HHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=d+52|0;h=f[g>>2]|0;do if(!h){i=e;j=f[i>>2]|0;k=f[i+4>>2]|0;l=7}else{if((f[c+(f[a+24>>2]|0)+(((h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)!=(f[d+28>>2]|0)){_h[f[(f[a>>2]|0)+36>>2]&255](a,c,h);i=f[g>>2]|0;m=e;n=f[m>>2]|0;o=f[m+4>>2]|0;if(!i){j=n;k=o;l=7;break}else{p=i;q=n;r=o}}else{o=e;p=h;q=f[o>>2]|0;r=f[o+4>>2]|0}s=c;t=((p-(f[(f[p+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;u=q;v=r;w=p}while(0);if((l|0)==7){l=d;do if(b[d+40>>0]|0){p=f[d+56>>2]|0;if(!p){x=(f[d+24>>2]|0)+72|0;break}else{x=p+68|0;break}}else x=(f[d+48>>2]|0)+28|0;while(0);s=c;t=(l-(f[x>>2]|0)|0)/88|0;u=j;v=k;w=0}k=s+(f[(f[a+16>>2]|0)+(t<<2)>>2]|0)|0;f[k>>2]=u;f[k+4>>2]=v;if(w|0){f[s+(f[a+24>>2]|0)+(((w-(f[(f[w+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]=f[d+28>>2];return}w=f[a+20>>2]|0;if((w|0)==-1)return;a=d;do if(b[d+40>>0]|0){v=f[d+56>>2]|0;if(!v){y=(f[d+24>>2]|0)+72|0;break}else{y=v+68|0;break}}else y=(f[d+48>>2]|0)+28|0;while(0);d=(a-(f[y>>2]|0)|0)/88|0;y=s+w+(d>>>5<<2)|0;f[y>>2]=1<<(d&31)|f[y>>2];return}function IHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=d+52|0;h=f[g>>2]|0;do if(!h){i=f[e>>2]|0;j=7}else{if((f[c+(f[a+24>>2]|0)+(((h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)!=(f[d+28>>2]|0)){_h[f[(f[a>>2]|0)+36>>2]&255](a,c,h);k=f[g>>2]|0;l=f[e>>2]|0;if(!k){i=l;j=7;break}else{m=k;n=l}}else{m=h;n=f[e>>2]|0}o=c;p=((m-(f[(f[m+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;q=n;r=m}while(0);if((j|0)==7){j=d;do if(b[d+40>>0]|0){m=f[d+56>>2]|0;if(!m){s=(f[d+24>>2]|0)+72|0;break}else{s=m+68|0;break}}else s=(f[d+48>>2]|0)+28|0;while(0);o=c;p=(j-(f[s>>2]|0)|0)/88|0;q=i;r=0}f[o+(f[(f[a+16>>2]|0)+(p<<2)>>2]|0)>>2]=q;if(r|0){f[o+(f[a+24>>2]|0)+(((r-(f[(f[r+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]=f[d+28>>2];return}r=f[a+20>>2]|0;if((r|0)==-1)return;a=d;do if(b[d+40>>0]|0){q=f[d+56>>2]|0;if(!q){t=(f[d+24>>2]|0)+72|0;break}else{t=q+68|0;break}}else t=(f[d+48>>2]|0)+28|0;while(0);d=(a-(f[t>>2]|0)|0)/88|0;t=o+r+(d>>>5<<2)|0;f[t>>2]=1<<(d&31)|f[t>>2];return}function JHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=d+52|0;h=f[g>>2]|0;do if(!h){i=e;j=f[i>>2]|0;k=f[i+4>>2]|0;l=7}else{if((f[c+(f[a+24>>2]|0)+(((h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]|0)!=(f[d+28>>2]|0)){_h[f[(f[a>>2]|0)+36>>2]&255](a,c,h);i=f[g>>2]|0;m=e;n=f[m>>2]|0;o=f[m+4>>2]|0;if(!i){j=n;k=o;l=7;break}else{p=i;q=n;r=o}}else{o=e;p=h;q=f[o>>2]|0;r=f[o+4>>2]|0}s=c;t=((p-(f[(f[p+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;u=q;v=r;w=p}while(0);if((l|0)==7){l=d;do if(b[d+40>>0]|0){p=f[d+56>>2]|0;if(!p){x=(f[d+24>>2]|0)+72|0;break}else{x=p+68|0;break}}else x=(f[d+48>>2]|0)+28|0;while(0);s=c;t=(l-(f[x>>2]|0)|0)/88|0;u=j;v=k;w=0}k=s+(f[(f[a+16>>2]|0)+(t<<2)>>2]|0)|0;f[k>>2]=u;f[k+4>>2]=v;if(w|0){f[s+(f[a+24>>2]|0)+(((w-(f[(f[w+8>>2]|0)+36>>2]|0)|0)/28|0)<<2)>>2]=f[d+28>>2];return}w=f[a+20>>2]|0;if((w|0)==-1)return;a=d;do if(b[d+40>>0]|0){v=f[d+56>>2]|0;if(!v){y=(f[d+24>>2]|0)+72|0;break}else{y=v+68|0;break}}else y=(f[d+48>>2]|0)+28|0;while(0);d=(a-(f[y>>2]|0)|0)/88|0;y=s+w+(d>>>5<<2)|0;f[y>>2]=1<<(d&31)|f[y>>2];return}function KHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[a>>2]|0;if((f[c>>2]|0)-d>>2>>>0>=b>>>0)return;e=a+4|0;if(b>>>0>1073741823){g=ze(8)|0;T5b(g,477177);f[g>>2]=149528;If(g|0,25408,1411)}g=(f[e>>2]|0)-d|0;h=g>>2;i=L5b(b<<2)|0;j=i+(h<<2)|0;k=j+(0-h<<2)|0;if((g|0)>0)Vac(k|0,d|0,g|0)|0;f[a>>2]=k;f[e>>2]=j;f[c>>2]=i+(b<<2);if(!d)return;O5b(d);return}function LHb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0;e=f[a+20>>2]|0;g=(e|0)==-1;a:do if(g)do switch(f[136e3+(f[d+32>>2]<<2)>>2]|0){case 10:{if((f[a+8>>2]|0)==(c|0)){h=0;return h|0}i=f[d+52>>2]|0;do if(!i){j=d;do if(b[d+40>>0]|0){k=f[d+56>>2]|0;if(!k){l=(f[d+24>>2]|0)+72|0;break}else{l=k+68|0;break}}else l=(f[d+48>>2]|0)+28|0;while(0);m=c;o=(j-(f[l>>2]|0)|0)/88|0;q=19}else{k=(i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(k<<2)>>2]|0)==(f[d+28>>2]|0)){m=c;o=(f[(f[a+4>>2]|0)+24>>2]|0)+k|0;q=19;break}k=f[a+16>>2]|0;r=f[a+12>>2]|0;s=d;do if(b[d+40>>0]|0){t=f[d+56>>2]|0;if(!t){u=(f[d+24>>2]|0)+72|0;break}else{u=t+68|0;break}}else u=(f[d+48>>2]|0)+28|0;while(0);v=k+(((s-(f[u>>2]|0)|0)/88|0)<<2)|0;w=r}while(0);if((q|0)==19){v=(f[a+16>>2]|0)+(o<<2)|0;w=m}h=(f[w+(f[v>>2]|0)>>2]|0)!=0;return h|0}case 9:{i=a+16|0;j=a+12|0;t=d+40|0;x=d;y=f[d+52>>2]|0;do if(!y){do if(b[t>>0]|0){z=f[d+56>>2]|0;if(!z){A=(f[d+24>>2]|0)+72|0;break}else{A=z+68|0;break}}else A=(f[d+48>>2]|0)+28|0;while(0);B=c;C=(x-(f[A>>2]|0)|0)/88|0;q=36}else{r=(y-(f[(f[y+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(r<<2)>>2]|0)==(f[d+28>>2]|0)){B=c;C=(f[(f[a+4>>2]|0)+24>>2]|0)+r|0;q=36;break}r=f[i>>2]|0;s=f[j>>2]|0;do if(b[t>>0]|0){k=f[d+56>>2]|0;if(!k){D=(f[d+24>>2]|0)+72|0;break}else{D=k+68|0;break}}else D=(f[d+48>>2]|0)+28|0;while(0);E=r+(((x-(f[D>>2]|0)|0)/88|0)<<2)|0;F=s}while(0);if((q|0)==36){E=(f[i>>2]|0)+(C<<2)|0;F=B}x=f[F+(f[E>>2]|0)>>2]|0;t=b[x+11>>0]|0;if(t<<24>>24<0)G=f[x+4>>2]|0;else G=t&255;h=(G|0)!=0;return h|0}case 7:{t=f[d+52>>2]|0;do if(!t){x=d;do if(b[d+40>>0]|0){j=f[d+56>>2]|0;if(!j){H=(f[d+24>>2]|0)+72|0;break}else{H=j+68|0;break}}else H=(f[d+48>>2]|0)+28|0;while(0);I=c;J=(x-(f[H>>2]|0)|0)/88|0;q=56}else{s=(t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(s<<2)>>2]|0)==(f[d+28>>2]|0)){I=c;J=(f[(f[a+4>>2]|0)+24>>2]|0)+s|0;q=56;break}s=f[a+16>>2]|0;r=f[a+12>>2]|0;j=d;do if(b[d+40>>0]|0){y=f[d+56>>2]|0;if(!y){K=(f[d+24>>2]|0)+72|0;break}else{K=y+68|0;break}}else K=(f[d+48>>2]|0)+28|0;while(0);L=r;M=s+(((j-(f[K>>2]|0)|0)/88|0)<<2)|0}while(0);if((q|0)==56){L=I;M=(f[a+16>>2]|0)+(J<<2)|0}h=(b[L+(f[M>>2]|0)>>0]|0)!=0;return h|0}case 1:{t=f[d+52>>2]|0;do if(!t){i=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){N=(f[d+24>>2]|0)+72|0;break}else{N=x+68|0;break}}else N=(f[d+48>>2]|0)+28|0;while(0);O=c;P=(i-(f[N>>2]|0)|0)/88|0;q=73}else{j=(t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(j<<2)>>2]|0)==(f[d+28>>2]|0)){O=c;P=(f[(f[a+4>>2]|0)+24>>2]|0)+j|0;q=73;break}j=f[a+16>>2]|0;s=f[a+12>>2]|0;r=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){Q=(f[d+24>>2]|0)+72|0;break}else{Q=x+68|0;break}}else Q=(f[d+48>>2]|0)+28|0;while(0);R=j+(((r-(f[Q>>2]|0)|0)/88|0)<<2)|0;S=s}while(0);if((q|0)==73){R=(f[a+16>>2]|0)+(P<<2)|0;S=O}h=(f[S+(f[R>>2]|0)>>2]|0)!=0;return h|0}case 2:{t=f[d+52>>2]|0;do if(!t){i=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){T=(f[d+24>>2]|0)+72|0;break}else{T=x+68|0;break}}else T=(f[d+48>>2]|0)+28|0;while(0);U=c;V=(i-(f[T>>2]|0)|0)/88|0;q=90}else{s=(t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(s<<2)>>2]|0)==(f[d+28>>2]|0)){U=c;V=(f[(f[a+4>>2]|0)+24>>2]|0)+s|0;q=90;break}s=f[a+16>>2]|0;r=f[a+12>>2]|0;j=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){W=(f[d+24>>2]|0)+72|0;break}else{W=x+68|0;break}}else W=(f[d+48>>2]|0)+28|0;while(0);X=s+(((j-(f[W>>2]|0)|0)/88|0)<<2)|0;Y=r}while(0);if((q|0)==90){X=(f[a+16>>2]|0)+(V<<2)|0;Y=U}t=Y+(f[X>>2]|0)|0;h=(f[t>>2]|0)!=0|(f[t+4>>2]|0)!=0;return h|0}case 3:{t=f[d+52>>2]|0;do if(!t){i=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){Z=(f[d+24>>2]|0)+72|0;break}else{Z=x+68|0;break}}else Z=(f[d+48>>2]|0)+28|0;while(0);_=c;$=(i-(f[Z>>2]|0)|0)/88|0;q=107}else{r=(t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(r<<2)>>2]|0)==(f[d+28>>2]|0)){_=c;$=(f[(f[a+4>>2]|0)+24>>2]|0)+r|0;q=107;break}r=f[a+16>>2]|0;j=f[a+12>>2]|0;s=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){aa=(f[d+24>>2]|0)+72|0;break}else{aa=x+68|0;break}}else aa=(f[d+48>>2]|0)+28|0;while(0);ba=r+(((s-(f[aa>>2]|0)|0)/88|0)<<2)|0;ca=j}while(0);if((q|0)==107){ba=(f[a+16>>2]|0)+($<<2)|0;ca=_}h=(f[ca+(f[ba>>2]|0)>>2]|0)!=0;return h|0}case 4:{t=f[d+52>>2]|0;do if(!t){i=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){da=(f[d+24>>2]|0)+72|0;break}else{da=x+68|0;break}}else da=(f[d+48>>2]|0)+28|0;while(0);ea=c;fa=(i-(f[da>>2]|0)|0)/88|0;q=124}else{j=(t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(j<<2)>>2]|0)==(f[d+28>>2]|0)){ea=c;fa=(f[(f[a+4>>2]|0)+24>>2]|0)+j|0;q=124;break}j=f[a+16>>2]|0;s=f[a+12>>2]|0;r=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){ga=(f[d+24>>2]|0)+72|0;break}else{ga=x+68|0;break}}else ga=(f[d+48>>2]|0)+28|0;while(0);ha=j+(((r-(f[ga>>2]|0)|0)/88|0)<<2)|0;ia=s}while(0);if((q|0)==124){ha=(f[a+16>>2]|0)+(fa<<2)|0;ia=ea}t=ia+(f[ha>>2]|0)|0;h=(f[t>>2]|0)!=0|(f[t+4>>2]|0)!=0;return h|0}case 6:{t=f[d+52>>2]|0;do if(!t){i=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){ja=(f[d+24>>2]|0)+72|0;break}else{ja=x+68|0;break}}else ja=(f[d+48>>2]|0)+28|0;while(0);ka=c;la=(i-(f[ja>>2]|0)|0)/88|0;q=141}else{s=(t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(s<<2)>>2]|0)==(f[d+28>>2]|0)){ka=c;la=(f[(f[a+4>>2]|0)+24>>2]|0)+s|0;q=141;break}s=f[a+16>>2]|0;r=f[a+12>>2]|0;j=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){ma=(f[d+24>>2]|0)+72|0;break}else{ma=x+68|0;break}}else ma=(f[d+48>>2]|0)+28|0;while(0);na=s+(((j-(f[ma>>2]|0)|0)/88|0)<<2)|0;oa=r}while(0);if((q|0)==141){na=(f[a+16>>2]|0)+(la<<2)|0;oa=ka}h=+n[oa+(f[na>>2]|0)>>2]!=0.0;return h|0}case 5:{t=f[d+52>>2]|0;do if(!t){i=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){pa=(f[d+24>>2]|0)+72|0;break}else{pa=x+68|0;break}}else pa=(f[d+48>>2]|0)+28|0;while(0);qa=c;ra=(i-(f[pa>>2]|0)|0)/88|0;q=158}else{r=(t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(r<<2)>>2]|0)==(f[d+28>>2]|0)){qa=c;ra=(f[(f[a+4>>2]|0)+24>>2]|0)+r|0;q=158;break}r=f[a+16>>2]|0;j=f[a+12>>2]|0;s=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){sa=(f[d+24>>2]|0)+72|0;break}else{sa=x+68|0;break}}else sa=(f[d+48>>2]|0)+28|0;while(0);ta=r+(((s-(f[sa>>2]|0)|0)/88|0)<<2)|0;ua=j}while(0);if((q|0)==158){ta=(f[a+16>>2]|0)+(ra<<2)|0;ua=qa}h=+p[ua+(f[ta>>2]|0)>>3]!=0.0;return h|0}case 8:{t=f[d+52>>2]|0;do if(!t){i=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){va=(f[d+24>>2]|0)+72|0;break}else{va=x+68|0;break}}else va=(f[d+48>>2]|0)+28|0;while(0);wa=c;xa=(i-(f[va>>2]|0)|0)/88|0;q=175}else{j=(t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[a+24>>2]|0)+(j<<2)>>2]|0)==(f[d+28>>2]|0)){wa=c;xa=(f[(f[a+4>>2]|0)+24>>2]|0)+j|0;q=175;break}j=f[a+16>>2]|0;s=f[a+12>>2]|0;r=d;do if(b[d+40>>0]|0){x=f[d+56>>2]|0;if(!x){ya=(f[d+24>>2]|0)+72|0;break}else{ya=x+68|0;break}}else ya=(f[d+48>>2]|0)+28|0;while(0);za=j+(((r-(f[ya>>2]|0)|0)/88|0)<<2)|0;Aa=s}while(0);if((q|0)==175){za=(f[a+16>>2]|0)+(xa<<2)|0;Aa=wa}h=(f[Aa+(f[za>>2]|0)>>2]|0)!=0;return h|0}default:break a}while(0);while(0);za=g?0:c+e|0;e=d;do if(b[d+40>>0]|0){c=f[d+56>>2]|0;if(!c){Ba=(f[d+24>>2]|0)+72|0;break}else{Ba=c+68|0;break}}else Ba=(f[d+48>>2]|0)+28|0;while(0);d=(e-(f[Ba>>2]|0)|0)/88|0;h=(1<<(d&31)&f[za+(d>>>5<<2)>>2]|0)!=0;return h|0}function MHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;c=a;a=b;a:while(1){b=a;d=a+-4|0;e=c;while(1){g=e;b:while(1){h=g;i=b-h|0;j=i>>2;switch(j|0){case 2:{k=5;break a;break}case 3:{k=7;break a;break}case 4:{k=15;break a;break}case 5:{k=27;break a;break}case 1:case 0:{k=87;break a;break}default:{}}if((i|0)<124){k=29;break a}l=g+(((j|0)/2|0)<<2)|0;do if((i|0)<=3996){m=f[l>>2]|0;n=f[g>>2]|0;o=f[m+28>>2]|0;p=f[n+28>>2]|0;q=f[d>>2]|0;r=(f[q+28>>2]|0)<(o|0);s=m;m=q;q=n;if((o|0)>=(p|0)){if(!r){t=0;break}f[l>>2]=m;f[d>>2]=s;o=f[l>>2]|0;n=f[g>>2]|0;if((f[o+28>>2]|0)>=(f[n+28>>2]|0)){t=1;break}f[g>>2]=o;f[l>>2]=n;t=2;break}if(r){f[g>>2]=m;f[d>>2]=q;t=1;break}f[g>>2]=s;f[l>>2]=q;s=f[d>>2]|0;if((f[s+28>>2]|0)<(p|0)){f[l>>2]=s;f[d>>2]=q;t=2}else t=1}else{q=(j|0)/4|0;t=NHb(g,g+(q<<2)|0,l,l+(q<<2)|0,d)|0}while(0);u=f[g>>2]|0;j=f[u+28>>2]|0;i=f[(f[l>>2]|0)+28>>2]|0;if((j|0)<(i|0)){v=d;w=t;break}else x=d;while(1){x=x+-4|0;if((g|0)==(x|0))break;y=f[x>>2]|0;if((f[y+28>>2]|0)<(i|0)){k=69;break b}}i=g+4|0;q=f[d>>2]|0;s=q;if((j|0)<(f[q+28>>2]|0))z=i;else{if((i|0)==(d|0)){k=87;break a}else A=i;while(1){B=f[A>>2]|0;if((j|0)<(f[B+28>>2]|0))break;i=A+4|0;if((i|0)==(d|0)){k=87;break a}else A=i}f[A>>2]=s;f[d>>2]=B;z=A+4|0}if((z|0)==(d|0)){k=87;break a}else{C=d;D=z}while(1){j=f[(f[g>>2]|0)+28>>2]|0;i=D;while(1){E=f[i>>2]|0;F=i+4|0;if((j|0)<(f[E+28>>2]|0))break;else i=F}q=E;p=C;do{p=p+-4|0;G=f[p>>2]|0}while((j|0)<(f[G+28>>2]|0));if(i>>>0>=p>>>0){g=i;continue b}f[i>>2]=G;f[p>>2]=q;C=p;D=F}}if((k|0)==69){k=0;f[g>>2]=y;f[x>>2]=u;v=x;w=t+1|0}s=g+4|0;c:do if(s>>>0<v>>>0){j=l;m=v;r=s;n=w;while(1){o=f[(f[j>>2]|0)+28>>2]|0;H=r;while(1){I=f[H>>2]|0;J=H+4|0;if((f[I+28>>2]|0)<(o|0))H=J;else break}p=I;q=m;do{q=q+-4|0;K=f[q>>2]|0}while((f[K+28>>2]|0)>=(o|0));if(H>>>0>q>>>0){L=j;M=n;N=H;break c}f[H>>2]=K;f[q>>2]=p;j=(j|0)==(H|0)?q:j;m=q;r=J;n=n+1|0}}else{L=l;M=w;N=s}while(0);if((N|0)!=(L|0)?(s=f[L>>2]|0,n=f[N>>2]|0,(f[s+28>>2]|0)<(f[n+28>>2]|0)):0){f[N>>2]=s;f[L>>2]=n;O=M+1|0}else O=M;if(!O){P=OHb(g,N)|0;n=N+4|0;if(OHb(n,a)|0){k=86;break}if(P){e=n;continue}}n=N;if((n-h|0)>=(b-n|0)){k=85;break}MHb(g,N);e=N+4|0}if((k|0)==85){k=0;MHb(N+4|0,a);c=g;a=N;continue}else if((k|0)==86){k=0;if(P){k=87;break}else{c=g;a=N;continue}}}if((k|0)==5){N=f[d>>2]|0;c=f[g>>2]|0;if((f[N+28>>2]|0)>=(f[c+28>>2]|0))return;f[g>>2]=N;f[d>>2]=c;return}else if((k|0)==7){c=g+4|0;N=f[c>>2]|0;P=f[g>>2]|0;h=f[N+28>>2]|0;O=f[P+28>>2]|0;M=f[d>>2]|0;L=(f[M+28>>2]|0)<(h|0);w=N;N=M;M=P;if((h|0)>=(O|0)){if(!L)return;f[c>>2]=N;f[d>>2]=w;h=f[c>>2]|0;P=f[g>>2]|0;if((f[h+28>>2]|0)>=(f[P+28>>2]|0))return;f[g>>2]=h;f[c>>2]=P;return}if(L){f[g>>2]=N;f[d>>2]=M;return}f[g>>2]=w;f[c>>2]=M;w=f[d>>2]|0;if((f[w+28>>2]|0)>=(O|0))return;f[c>>2]=w;f[d>>2]=M;return}else if((k|0)==15){M=g+4|0;w=g+8|0;c=f[M>>2]|0;O=f[g>>2]|0;N=f[c+28>>2]|0;L=f[O+28>>2]|0;P=f[w>>2]|0;h=f[P+28>>2]|0;l=(h|0)<(N|0);J=c;K=P;I=O;do if((N|0)<(L|0)){if(l){f[g>>2]=K;f[w>>2]=I;Q=O;R=I;break}f[g>>2]=J;f[M>>2]=I;if((h|0)<(L|0)){f[M>>2]=K;f[w>>2]=I;Q=O;R=I}else{Q=P;R=K}}else if(l){f[M>>2]=K;f[w>>2]=J;if((h|0)<(L|0)){f[g>>2]=K;f[M>>2]=I;Q=c;R=J}else{Q=c;R=J}}else{Q=P;R=K}while(0);K=f[d>>2]|0;if((f[K+28>>2]|0)>=(f[Q+28>>2]|0))return;f[w>>2]=K;f[d>>2]=R;R=f[w>>2]|0;K=f[M>>2]|0;Q=f[R+28>>2]|0;if((Q|0)>=(f[K+28>>2]|0))return;P=R;f[M>>2]=P;f[w>>2]=K;K=f[g>>2]|0;if((Q|0)>=(f[K+28>>2]|0))return;f[g>>2]=P;f[M>>2]=K;return}else if((k|0)==27){NHb(g,g+4|0,g+8|0,g+12|0,d)|0;return}else if((k|0)==29){d=g+8|0;K=g+4|0;M=f[K>>2]|0;P=f[g>>2]|0;Q=f[M+28>>2]|0;w=f[P+28>>2]|0;R=f[d>>2]|0;J=f[R+28>>2]|0;c=(J|0)<(Q|0);I=M;L=R;h=P;do if((Q|0)<(w|0)){if(c){f[g>>2]=L;f[d>>2]=h;S=P;break}f[g>>2]=I;f[K>>2]=h;if((J|0)<(w|0)){f[K>>2]=L;f[d>>2]=h;S=P}else S=R}else if(c){f[K>>2]=L;f[d>>2]=I;if((J|0)<(w|0)){f[g>>2]=L;f[K>>2]=h;S=M}else S=M}else S=R;while(0);R=g+12|0;if((R|0)==(a|0))return;else{T=R;U=d;V=S}while(1){S=f[T>>2]|0;d=f[S+28>>2]|0;R=S;if((d|0)<(f[V+28>>2]|0)){S=U;M=T;while(1){f[M>>2]=f[S>>2];if((S|0)==(g|0))break;h=S+-4|0;if((d|0)<(f[(f[h>>2]|0)+28>>2]|0)){K=S;S=h;M=K}else break}f[S>>2]=R}M=T+4|0;if((M|0)==(a|0))break;d=f[T>>2]|0;K=T;T=M;V=d;U=K}return}else if((k|0)==87)return}function NHb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=f[b>>2]|0;h=f[a>>2]|0;i=f[g+28>>2]|0;j=f[h+28>>2]|0;k=f[c>>2]|0;l=(f[k+28>>2]|0)<(i|0);m=g;n=k;o=h;do if((i|0)<(j|0)){if(l){f[a>>2]=n;f[c>>2]=o;p=1;q=h;r=o;break}f[a>>2]=m;f[b>>2]=o;s=f[c>>2]|0;t=s;if((f[s+28>>2]|0)<(j|0)){f[b>>2]=t;f[c>>2]=o;p=2;q=h;r=o}else{p=1;q=s;r=t}}else if(l){f[b>>2]=n;f[c>>2]=m;t=f[b>>2]|0;s=f[a>>2]|0;if((f[t+28>>2]|0)<(f[s+28>>2]|0)){f[a>>2]=t;f[b>>2]=s;s=f[c>>2]|0;p=2;q=s;r=s}else{p=1;q=g;r=m}}else{p=0;q=k;r=n}while(0);n=f[d>>2]|0;if((f[n+28>>2]|0)<(f[q+28>>2]|0)){f[c>>2]=n;f[d>>2]=r;r=p+1|0;n=f[c>>2]|0;q=f[b>>2]|0;if((f[n+28>>2]|0)<(f[q+28>>2]|0)){f[b>>2]=n;f[c>>2]=q;q=f[b>>2]|0;n=f[a>>2]|0;if((f[q+28>>2]|0)<(f[n+28>>2]|0)){f[a>>2]=q;f[b>>2]=n;u=p+3|0}else u=p+2|0}else u=r}else u=p;p=f[e>>2]|0;r=f[d>>2]|0;if((f[p+28>>2]|0)>=(f[r+28>>2]|0)){v=u;return v|0}f[d>>2]=p;f[e>>2]=r;r=f[d>>2]|0;e=f[c>>2]|0;if((f[r+28>>2]|0)>=(f[e+28>>2]|0)){v=u+1|0;return v|0}f[c>>2]=r;f[d>>2]=e;e=f[c>>2]|0;d=f[b>>2]|0;if((f[e+28>>2]|0)>=(f[d+28>>2]|0)){v=u+2|0;return v|0}f[b>>2]=e;f[c>>2]=d;d=f[b>>2]|0;c=f[a>>2]|0;if((f[d+28>>2]|0)>=(f[c+28>>2]|0)){v=u+3|0;return v|0}f[a>>2]=d;f[b>>2]=c;v=u+4|0;return v|0}function OHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;switch(b-a>>2|0){case 2:{c=b+-4|0;d=f[c>>2]|0;e=f[a>>2]|0;if((f[d+28>>2]|0)>=(f[e+28>>2]|0)){g=1;return g|0}f[a>>2]=d;f[c>>2]=e;g=1;return g|0}case 3:{e=a+4|0;c=b+-4|0;d=f[e>>2]|0;h=f[a>>2]|0;i=f[d+28>>2]|0;j=f[h+28>>2]|0;k=f[c>>2]|0;l=(f[k+28>>2]|0)<(i|0);m=d;d=k;k=h;if((i|0)>=(j|0)){if(!l){g=1;return g|0}f[e>>2]=d;f[c>>2]=m;i=f[e>>2]|0;h=f[a>>2]|0;if((f[i+28>>2]|0)>=(f[h+28>>2]|0)){g=1;return g|0}f[a>>2]=i;f[e>>2]=h;g=1;return g|0}if(l){f[a>>2]=d;f[c>>2]=k;g=1;return g|0}f[a>>2]=m;f[e>>2]=k;m=f[c>>2]|0;if((f[m+28>>2]|0)>=(j|0)){g=1;return g|0}f[e>>2]=m;f[c>>2]=k;g=1;return g|0}case 4:{k=a+4|0;c=a+8|0;m=b+-4|0;e=f[k>>2]|0;j=f[a>>2]|0;d=f[e+28>>2]|0;l=f[j+28>>2]|0;h=f[c>>2]|0;i=f[h+28>>2]|0;n=(i|0)<(d|0);o=e;p=h;q=j;do if((d|0)<(l|0)){if(n){f[a>>2]=p;f[c>>2]=q;r=j;s=q;break}f[a>>2]=o;f[k>>2]=q;if((i|0)<(l|0)){f[k>>2]=p;f[c>>2]=q;r=j;s=q}else{r=h;s=p}}else if(n){f[k>>2]=p;f[c>>2]=o;if((i|0)<(l|0)){f[a>>2]=p;f[k>>2]=q;r=e;s=o}else{r=e;s=o}}else{r=h;s=p}while(0);p=f[m>>2]|0;if((f[p+28>>2]|0)>=(f[r+28>>2]|0)){g=1;return g|0}f[c>>2]=p;f[m>>2]=s;s=f[c>>2]|0;m=f[k>>2]|0;p=f[s+28>>2]|0;if((p|0)>=(f[m+28>>2]|0)){g=1;return g|0}r=s;f[k>>2]=r;f[c>>2]=m;m=f[a>>2]|0;if((p|0)>=(f[m+28>>2]|0)){g=1;return g|0}f[a>>2]=r;f[k>>2]=m;g=1;return g|0}case 5:{NHb(a,a+4|0,a+8|0,a+12|0,b+-4|0)|0;g=1;return g|0}case 1:case 0:{g=1;return g|0}default:{m=a+8|0;k=a+4|0;r=f[k>>2]|0;p=f[a>>2]|0;c=f[r+28>>2]|0;s=f[p+28>>2]|0;h=f[m>>2]|0;o=f[h+28>>2]|0;e=(o|0)<(c|0);q=r;l=h;i=p;do if((c|0)<(s|0)){if(e){f[a>>2]=l;f[m>>2]=i;t=p;break}f[a>>2]=q;f[k>>2]=i;if((o|0)<(s|0)){f[k>>2]=l;f[m>>2]=i;t=p}else t=h}else if(e){f[k>>2]=l;f[m>>2]=q;if((o|0)<(s|0)){f[a>>2]=l;f[k>>2]=i;t=r}else t=r}else t=h;while(0);h=a+12|0;a:do if((h|0)==(b|0)){u=1;v=0}else{r=h;i=0;k=m;l=t;while(1){s=f[r>>2]|0;o=f[s+28>>2]|0;q=s;if((o|0)<(f[l+28>>2]|0)){s=k;e=r;while(1){f[e>>2]=f[s>>2];if((s|0)==(a|0))break;p=s+-4|0;if((o|0)<(f[(f[p>>2]|0)+28>>2]|0)){c=s;s=p;e=c}else break}f[s>>2]=q;e=i+1|0;if((e|0)==8){u=0;v=(r+4|0)==(b|0);break a}else w=e}else w=i;e=r+4|0;if((e|0)==(b|0)){u=1;v=0;break a}o=f[r>>2]|0;c=r;r=e;i=w;l=o;k=c}}while(0);g=v|u;return g|0}}return 0}function PHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0;g=u;u=u+144|0;h=g+132|0;i=g+16|0;j=g+128|0;k=g+8|0;l=g+124|0;m=g;n=g+139|0;o=g+120|0;q=g+108|0;r=g+96|0;s=g+72|0;t=g+138|0;v=g+48|0;w=g+137|0;x=g+24|0;y=g+136|0;z=a+24|0;A=f[z>>2]|0;B=(e-(f[(f[e+8>>2]|0)+36>>2]|0)|0)/28|0;C=f[c+A+(B<<2)>>2]|0;D=f[d+A+(B<<2)>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;B=(C|0)!=0;a:do if(B){A=a+4|0;E=oub(f[A>>2]|0,C)|0;F=E+32|0;do switch(f[136e3+(f[F>>2]<<2)>>2]|0){case 1:{G=f[E+52>>2]|0;do if(!G){H=E;do if(b[E+40>>0]|0){I=f[E+56>>2]|0;if(!I){J=(f[E+24>>2]|0)+72|0;break}else{J=I+68|0;break}}else J=(f[E+48>>2]|0)+28|0;while(0);K=(H-(f[J>>2]|0)|0)/88|0;L=18}else{I=(G-(f[(f[G+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[z>>2]|0)+(I<<2)>>2]|0)==(f[E+28>>2]|0)){K=(f[(f[A>>2]|0)+24>>2]|0)+I|0;L=18;break}I=f[a+16>>2]|0;M=f[a+12>>2]|0;N=E;do if(b[E+40>>0]|0){O=f[E+56>>2]|0;if(!O){P=(f[E+24>>2]|0)+72|0;break}else{P=O+68|0;break}}else P=(f[E+48>>2]|0)+28|0;while(0);Q=I+(((N-(f[P>>2]|0)|0)/88|0)<<2)|0;R=M}while(0);if((L|0)==18){Q=(f[a+16>>2]|0)+(K<<2)|0;R=c}f[h>>2]=f[R+(f[Q>>2]|0)>>2];S=0;T=E;break a;break}case 2:{G=f[E+52>>2]|0;do if(!G){H=E;do if(b[E+40>>0]|0){O=f[E+56>>2]|0;if(!O){U=(f[E+24>>2]|0)+72|0;break}else{U=O+68|0;break}}else U=(f[E+48>>2]|0)+28|0;while(0);V=(H-(f[U>>2]|0)|0)/88|0;L=35}else{M=(G-(f[(f[G+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[z>>2]|0)+(M<<2)>>2]|0)==(f[E+28>>2]|0)){V=(f[(f[A>>2]|0)+24>>2]|0)+M|0;L=35;break}M=f[a+16>>2]|0;N=f[a+12>>2]|0;I=E;do if(b[E+40>>0]|0){O=f[E+56>>2]|0;if(!O){W=(f[E+24>>2]|0)+72|0;break}else{W=O+68|0;break}}else W=(f[E+48>>2]|0)+28|0;while(0);X=M+(((I-(f[W>>2]|0)|0)/88|0)<<2)|0;Y=N}while(0);if((L|0)==35){X=(f[a+16>>2]|0)+(V<<2)|0;Y=c}G=Y+(f[X>>2]|0)|0;H=f[G+4>>2]|0;O=i;f[O>>2]=f[G>>2];f[O+4>>2]=H;S=0;T=E;break a;break}case 3:{H=f[E+52>>2]|0;do if(!H){O=E;do if(b[E+40>>0]|0){G=f[E+56>>2]|0;if(!G){Z=(f[E+24>>2]|0)+72|0;break}else{Z=G+68|0;break}}else Z=(f[E+48>>2]|0)+28|0;while(0);_=(O-(f[Z>>2]|0)|0)/88|0;L=52}else{N=(H-(f[(f[H+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[z>>2]|0)+(N<<2)>>2]|0)==(f[E+28>>2]|0)){_=(f[(f[A>>2]|0)+24>>2]|0)+N|0;L=52;break}N=f[a+16>>2]|0;I=f[a+12>>2]|0;M=E;do if(b[E+40>>0]|0){G=f[E+56>>2]|0;if(!G){$=(f[E+24>>2]|0)+72|0;break}else{$=G+68|0;break}}else $=(f[E+48>>2]|0)+28|0;while(0);aa=N+(((M-(f[$>>2]|0)|0)/88|0)<<2)|0;ba=I}while(0);if((L|0)==52){aa=(f[a+16>>2]|0)+(_<<2)|0;ba=c}f[j>>2]=f[ba+(f[aa>>2]|0)>>2];S=0;T=E;break a;break}case 4:{H=f[E+52>>2]|0;do if(!H){O=E;do if(b[E+40>>0]|0){G=f[E+56>>2]|0;if(!G){ca=(f[E+24>>2]|0)+72|0;break}else{ca=G+68|0;break}}else ca=(f[E+48>>2]|0)+28|0;while(0);da=(O-(f[ca>>2]|0)|0)/88|0;L=69}else{I=(H-(f[(f[H+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[z>>2]|0)+(I<<2)>>2]|0)==(f[E+28>>2]|0)){da=(f[(f[A>>2]|0)+24>>2]|0)+I|0;L=69;break}I=f[a+16>>2]|0;M=f[a+12>>2]|0;N=E;do if(b[E+40>>0]|0){G=f[E+56>>2]|0;if(!G){ea=(f[E+24>>2]|0)+72|0;break}else{ea=G+68|0;break}}else ea=(f[E+48>>2]|0)+28|0;while(0);fa=I+(((N-(f[ea>>2]|0)|0)/88|0)<<2)|0;ga=M}while(0);if((L|0)==69){fa=(f[a+16>>2]|0)+(da<<2)|0;ga=c}H=ga+(f[fa>>2]|0)|0;O=f[H+4>>2]|0;G=k;f[G>>2]=f[H>>2];f[G+4>>2]=O;S=0;T=E;break a;break}case 6:{O=f[E+52>>2]|0;do if(!O){G=E;do if(b[E+40>>0]|0){H=f[E+56>>2]|0;if(!H){ha=(f[E+24>>2]|0)+72|0;break}else{ha=H+68|0;break}}else ha=(f[E+48>>2]|0)+28|0;while(0);ia=(G-(f[ha>>2]|0)|0)/88|0;L=86}else{M=(O-(f[(f[O+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[z>>2]|0)+(M<<2)>>2]|0)==(f[E+28>>2]|0)){ia=(f[(f[A>>2]|0)+24>>2]|0)+M|0;L=86;break}M=f[a+16>>2]|0;N=f[a+12>>2]|0;I=E;do if(b[E+40>>0]|0){H=f[E+56>>2]|0;if(!H){ja=(f[E+24>>2]|0)+72|0;break}else{ja=H+68|0;break}}else ja=(f[E+48>>2]|0)+28|0;while(0);ka=M+(((I-(f[ja>>2]|0)|0)/88|0)<<2)|0;la=N}while(0);if((L|0)==86){ka=(f[a+16>>2]|0)+(ia<<2)|0;la=c}f[l>>2]=f[la+(f[ka>>2]|0)>>2];S=0;T=E;break a;break}case 5:{O=f[E+52>>2]|0;do if(!O){G=E;do if(b[E+40>>0]|0){H=f[E+56>>2]|0;if(!H){ma=(f[E+24>>2]|0)+72|0;break}else{ma=H+68|0;break}}else ma=(f[E+48>>2]|0)+28|0;while(0);na=(G-(f[ma>>2]|0)|0)/88|0;L=103}else{N=(O-(f[(f[O+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[z>>2]|0)+(N<<2)>>2]|0)==(f[E+28>>2]|0)){na=(f[(f[A>>2]|0)+24>>2]|0)+N|0;L=103;break}N=f[a+16>>2]|0;I=f[a+12>>2]|0;M=E;do if(b[E+40>>0]|0){H=f[E+56>>2]|0;if(!H){oa=(f[E+24>>2]|0)+72|0;break}else{oa=H+68|0;break}}else oa=(f[E+48>>2]|0)+28|0;while(0);pa=N+(((M-(f[oa>>2]|0)|0)/88|0)<<2)|0;qa=I}while(0);if((L|0)==103){pa=(f[a+16>>2]|0)+(na<<2)|0;qa=c}p[m>>3]=+p[qa+(f[pa>>2]|0)>>3];S=0;T=E;break a;break}case 7:{O=f[E+52>>2]|0;do if(!O){G=E;do if(b[E+40>>0]|0){H=f[E+56>>2]|0;if(!H){ra=(f[E+24>>2]|0)+72|0;break}else{ra=H+68|0;break}}else ra=(f[E+48>>2]|0)+28|0;while(0);sa=(G-(f[ra>>2]|0)|0)/88|0;L=120}else{I=(O-(f[(f[O+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[z>>2]|0)+(I<<2)>>2]|0)==(f[E+28>>2]|0)){sa=(f[(f[A>>2]|0)+24>>2]|0)+I|0;L=120;break}I=f[a+16>>2]|0;M=f[a+12>>2]|0;N=E;do if(b[E+40>>0]|0){H=f[E+56>>2]|0;if(!H){ta=(f[E+24>>2]|0)+72|0;break}else{ta=H+68|0;break}}else ta=(f[E+48>>2]|0)+28|0;while(0);ua=M;va=I+(((N-(f[ta>>2]|0)|0)/88|0)<<2)|0}while(0);if((L|0)==120){ua=c;va=(f[a+16>>2]|0)+(sa<<2)|0}b[n>>0]=b[ua+(f[va>>2]|0)>>0]|0;S=0;T=E;break a;break}case 8:{O=f[E+52>>2]|0;do if(!O){G=E;do if(b[E+40>>0]|0){H=f[E+56>>2]|0;if(!H){wa=(f[E+24>>2]|0)+72|0;break}else{wa=H+68|0;break}}else wa=(f[E+48>>2]|0)+28|0;while(0);xa=(G-(f[wa>>2]|0)|0)/88|0;L=137}else{N=(O-(f[(f[O+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[c+(f[z>>2]|0)+(N<<2)>>2]|0)==(f[E+28>>2]|0)){xa=(f[(f[A>>2]|0)+24>>2]|0)+N|0;L=137;break}N=f[a+16>>2]|0;I=f[a+12>>2]|0;M=E;do if(b[E+40>>0]|0){H=f[E+56>>2]|0;if(!H){ya=(f[E+24>>2]|0)+72|0;break}else{ya=H+68|0;break}}else ya=(f[E+48>>2]|0)+28|0;while(0);za=N+(((M-(f[ya>>2]|0)|0)/88|0)<<2)|0;Aa=I}while(0);if((L|0)==137){za=(f[a+16>>2]|0)+(xa<<2)|0;Aa=c}f[o>>2]=f[Aa+(f[za>>2]|0)>>2];S=0;T=E;break a;break}case 10:{S=Dg[f[(f[a>>2]|0)+164>>2]&127](a,c,E,0)|0;T=E;break a;break}case 9:{th[f[(f[a>>2]|0)+96>>2]&511](r,a,c,E);_5b(q,r)|0;if((b[r+11>>0]|0)<0)O5b(f[r>>2]|0);S=0;T=E;break a;break}default:{zpb(s,3,466902,541);xpb(t,ypb(vpb(s,469897)|0,f[136e3+(f[F>>2]<<2)>>2]|0)|0);Apb(s);S=0;T=E;break a}}while(0)}else{S=0;T=0}while(0);b:do if(!D)_h[f[(f[a>>2]|0)+36>>2]&255](a,c,e);else{s=a+4|0;t=oub(f[s>>2]|0,D)|0;za=t+32|0;do switch(f[136e3+(f[za>>2]<<2)>>2]|0){case 1:{Aa=f[t+52>>2]|0;do if(!Aa){xa=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){Ba=(f[t+24>>2]|0)+72|0;break}else{Ba=ya+68|0;break}}else Ba=(f[t+48>>2]|0)+28|0;while(0);Ca=(xa-(f[Ba>>2]|0)|0)/88|0;L=161}else{I=(Aa-(f[(f[Aa+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[d+(f[z>>2]|0)+(I<<2)>>2]|0)==(f[t+28>>2]|0)){Ca=(f[(f[s>>2]|0)+24>>2]|0)+I|0;L=161;break}I=f[a+16>>2]|0;M=f[a+12>>2]|0;N=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){Da=(f[t+24>>2]|0)+72|0;break}else{Da=ya+68|0;break}}else Da=(f[t+48>>2]|0)+28|0;while(0);Ea=I+(((N-(f[Da>>2]|0)|0)/88|0)<<2)|0;Fa=M}while(0);if((L|0)==161){Ea=(f[a+16>>2]|0)+(Ca<<2)|0;Fa=d}DHb(a,c,t,Fa+(f[Ea>>2]|0)|0);break b;break}case 2:{Aa=f[t+52>>2]|0;do if(!Aa){xa=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){Ga=(f[t+24>>2]|0)+72|0;break}else{Ga=ya+68|0;break}}else Ga=(f[t+48>>2]|0)+28|0;while(0);Ha=(xa-(f[Ga>>2]|0)|0)/88|0;L=178}else{M=(Aa-(f[(f[Aa+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[d+(f[z>>2]|0)+(M<<2)>>2]|0)==(f[t+28>>2]|0)){Ha=(f[(f[s>>2]|0)+24>>2]|0)+M|0;L=178;break}M=f[a+16>>2]|0;N=f[a+12>>2]|0;I=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){Ia=(f[t+24>>2]|0)+72|0;break}else{Ia=ya+68|0;break}}else Ia=(f[t+48>>2]|0)+28|0;while(0);Ja=M+(((I-(f[Ia>>2]|0)|0)/88|0)<<2)|0;Ka=N}while(0);if((L|0)==178){Ja=(f[a+16>>2]|0)+(Ha<<2)|0;Ka=d}JHb(a,c,t,Ka+(f[Ja>>2]|0)|0);break b;break}case 3:{Aa=f[t+52>>2]|0;do if(!Aa){xa=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){La=(f[t+24>>2]|0)+72|0;break}else{La=ya+68|0;break}}else La=(f[t+48>>2]|0)+28|0;while(0);Ma=(xa-(f[La>>2]|0)|0)/88|0;L=195}else{N=(Aa-(f[(f[Aa+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[d+(f[z>>2]|0)+(N<<2)>>2]|0)==(f[t+28>>2]|0)){Ma=(f[(f[s>>2]|0)+24>>2]|0)+N|0;L=195;break}N=f[a+16>>2]|0;I=f[a+12>>2]|0;M=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){Na=(f[t+24>>2]|0)+72|0;break}else{Na=ya+68|0;break}}else Na=(f[t+48>>2]|0)+28|0;while(0);Oa=N+(((M-(f[Na>>2]|0)|0)/88|0)<<2)|0;Pa=I}while(0);if((L|0)==195){Oa=(f[a+16>>2]|0)+(Ma<<2)|0;Pa=d}IHb(a,c,t,Pa+(f[Oa>>2]|0)|0);break b;break}case 4:{Aa=f[t+52>>2]|0;do if(!Aa){xa=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){Qa=(f[t+24>>2]|0)+72|0;break}else{Qa=ya+68|0;break}}else Qa=(f[t+48>>2]|0)+28|0;while(0);Ra=(xa-(f[Qa>>2]|0)|0)/88|0;L=212}else{I=(Aa-(f[(f[Aa+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[d+(f[z>>2]|0)+(I<<2)>>2]|0)==(f[t+28>>2]|0)){Ra=(f[(f[s>>2]|0)+24>>2]|0)+I|0;L=212;break}I=f[a+16>>2]|0;M=f[a+12>>2]|0;N=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){Sa=(f[t+24>>2]|0)+72|0;break}else{Sa=ya+68|0;break}}else Sa=(f[t+48>>2]|0)+28|0;while(0);Ta=I+(((N-(f[Sa>>2]|0)|0)/88|0)<<2)|0;Ua=M}while(0);if((L|0)==212){Ta=(f[a+16>>2]|0)+(Ra<<2)|0;Ua=d}HHb(a,c,t,Ua+(f[Ta>>2]|0)|0);break b;break}case 6:{Aa=f[t+52>>2]|0;do if(!Aa){xa=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){Va=(f[t+24>>2]|0)+72|0;break}else{Va=ya+68|0;break}}else Va=(f[t+48>>2]|0)+28|0;while(0);Wa=(xa-(f[Va>>2]|0)|0)/88|0;L=229}else{M=(Aa-(f[(f[Aa+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[d+(f[z>>2]|0)+(M<<2)>>2]|0)==(f[t+28>>2]|0)){Wa=(f[(f[s>>2]|0)+24>>2]|0)+M|0;L=229;break}M=f[a+16>>2]|0;N=f[a+12>>2]|0;I=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){Xa=(f[t+24>>2]|0)+72|0;break}else{Xa=ya+68|0;break}}else Xa=(f[t+48>>2]|0)+28|0;while(0);Ya=M+(((I-(f[Xa>>2]|0)|0)/88|0)<<2)|0;Za=N}while(0);if((L|0)==229){Ya=(f[a+16>>2]|0)+(Wa<<2)|0;Za=d}GHb(a,c,t,Za+(f[Ya>>2]|0)|0);break b;break}case 5:{Aa=f[t+52>>2]|0;do if(!Aa){xa=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){_a=(f[t+24>>2]|0)+72|0;break}else{_a=ya+68|0;break}}else _a=(f[t+48>>2]|0)+28|0;while(0);$a=(xa-(f[_a>>2]|0)|0)/88|0;L=246}else{N=(Aa-(f[(f[Aa+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[d+(f[z>>2]|0)+(N<<2)>>2]|0)==(f[t+28>>2]|0)){$a=(f[(f[s>>2]|0)+24>>2]|0)+N|0;L=246;break}N=f[a+16>>2]|0;I=f[a+12>>2]|0;M=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){ab=(f[t+24>>2]|0)+72|0;break}else{ab=ya+68|0;break}}else ab=(f[t+48>>2]|0)+28|0;while(0);bb=N+(((M-(f[ab>>2]|0)|0)/88|0)<<2)|0;cb=I}while(0);if((L|0)==246){bb=(f[a+16>>2]|0)+($a<<2)|0;cb=d}FHb(a,c,t,cb+(f[bb>>2]|0)|0);break b;break}case 7:{Aa=f[t+52>>2]|0;do if(!Aa){xa=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){db=(f[t+24>>2]|0)+72|0;break}else{db=ya+68|0;break}}else db=(f[t+48>>2]|0)+28|0;while(0);eb=(xa-(f[db>>2]|0)|0)/88|0;L=263}else{I=(Aa-(f[(f[Aa+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[d+(f[z>>2]|0)+(I<<2)>>2]|0)==(f[t+28>>2]|0)){eb=(f[(f[s>>2]|0)+24>>2]|0)+I|0;L=263;break}I=f[a+16>>2]|0;M=f[a+12>>2]|0;N=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){fb=(f[t+24>>2]|0)+72|0;break}else{fb=ya+68|0;break}}else fb=(f[t+48>>2]|0)+28|0;while(0);gb=M;hb=I+(((N-(f[fb>>2]|0)|0)/88|0)<<2)|0}while(0);if((L|0)==263){gb=d;hb=(f[a+16>>2]|0)+(eb<<2)|0}EHb(a,c,t,gb+(f[hb>>2]|0)|0);break b;break}case 8:{Aa=f[t+52>>2]|0;do if(!Aa){xa=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){ib=(f[t+24>>2]|0)+72|0;break}else{ib=ya+68|0;break}}else ib=(f[t+48>>2]|0)+28|0;while(0);jb=(xa-(f[ib>>2]|0)|0)/88|0;L=280}else{N=(Aa-(f[(f[Aa+8>>2]|0)+36>>2]|0)|0)/28|0;if((f[d+(f[z>>2]|0)+(N<<2)>>2]|0)==(f[t+28>>2]|0)){jb=(f[(f[s>>2]|0)+24>>2]|0)+N|0;L=280;break}N=f[a+16>>2]|0;I=f[a+12>>2]|0;M=t;do if(b[t+40>>0]|0){ya=f[t+56>>2]|0;if(!ya){kb=(f[t+24>>2]|0)+72|0;break}else{kb=ya+68|0;break}}else kb=(f[t+48>>2]|0)+28|0;while(0);lb=N+(((M-(f[kb>>2]|0)|0)/88|0)<<2)|0;mb=I}while(0);if((L|0)==280){lb=(f[a+16>>2]|0)+(jb<<2)|0;mb=d}DHb(a,c,t,mb+(f[lb>>2]|0)|0);break b;break}case 10:{Aa=f[a>>2]|0;xa=f[Aa+160>>2]|0;ya=Dg[f[Aa+164>>2]&127](a,d,t,0)|0;th[xa&511](a,c,ya,t);break b;break}case 9:{ya=f[a>>2]|0;xa=f[ya+144>>2]|0;th[f[ya+96>>2]&511](r,a,d,t);th[xa&511](a,c,t,r);if((b[r+11>>0]|0)<0)O5b(f[r>>2]|0);break b;break}default:{zpb(v,3,466902,575);xpb(w,ypb(vpb(v,469897)|0,f[136e3+(f[za>>2]<<2)>>2]|0)|0);Apb(v);break b}}while(0)}while(0);c:do if(B){v=T+32|0;do switch(f[136e3+(f[v>>2]<<2)>>2]|0){case 1:{DHb(a,d,T,h);break c;break}case 2:{JHb(a,d,T,i);break c;break}case 3:{IHb(a,d,T,j);break c;break}case 4:{HHb(a,d,T,k);break c;break}case 6:{GHb(a,d,T,l);break c;break}case 5:{FHb(a,d,T,m);break c;break}case 7:{EHb(a,d,T,n);break c;break}case 8:{DHb(a,d,T,o);break c;break}case 10:{th[f[(f[a>>2]|0)+160>>2]&511](a,d,S,T);break c;break}case 9:{th[f[(f[a>>2]|0)+144>>2]&511](a,d,T,q);break c;break}default:{zpb(x,3,466902,607);xpb(y,ypb(vpb(x,469897)|0,f[136e3+(f[v>>2]<<2)>>2]|0)|0);Apb(x);break c}}while(0)}else _h[f[(f[a>>2]|0)+36>>2]&255](a,d,e);while(0);if((b[q+11>>0]|0)>=0){u=g;return}O5b(f[q>>2]|0);u=g;return}function QHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=a+20|0;if((f[g>>2]|0)==-1)return;h=LHb(a,c,e)|0;i=LHb(a,d,e)|0;a=f[g>>2]|0;j=(a|0)==-1;if(i){if(!j){i=e;do if(b[e+40>>0]|0){k=f[e+56>>2]|0;if(!k){l=(f[e+24>>2]|0)+72|0;break}else{l=k+68|0;break}}else l=(f[e+48>>2]|0)+28|0;while(0);k=(i-(f[l>>2]|0)|0)/88|0;l=c+a+(k>>>5<<2)|0;f[l>>2]=1<<(k&31)|f[l>>2]}}else if(!j){j=e;do if(b[e+40>>0]|0){l=f[e+56>>2]|0;if(!l){m=(f[e+24>>2]|0)+72|0;break}else{m=l+68|0;break}}else m=(f[e+48>>2]|0)+28|0;while(0);l=(j-(f[m>>2]|0)|0)/88|0;m=c+a+(l>>>5<<2)|0;f[m>>2]=f[m>>2]&~(1<<(l&31))}l=f[g>>2]|0;g=(l|0)==-1;if(h){if(g)return;h=e;do if(b[e+40>>0]|0){m=f[e+56>>2]|0;if(!m){n=(f[e+24>>2]|0)+72|0;break}else{n=m+68|0;break}}else n=(f[e+48>>2]|0)+28|0;while(0);m=(h-(f[n>>2]|0)|0)/88|0;n=d+l+(m>>>5<<2)|0;f[n>>2]=1<<(m&31)|f[n>>2];return}else{if(g)return;g=e;do if(b[e+40>>0]|0){n=f[e+56>>2]|0;if(!n){o=(f[e+24>>2]|0)+72|0;break}else{o=n+68|0;break}}else o=(f[e+48>>2]|0)+28|0;while(0);e=(g-(f[o>>2]|0)|0)/88|0;o=d+l+(e>>>5<<2)|0;f[o>>2]=f[o>>2]&~(1<<(e&31));return}}function RHb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0.0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0;g=u;u=u+64|0;h=g+24|0;i=g+61|0;j=g+48|0;k=g;l=g+60|0;m=e+32|0;n=f[136e3+(f[m>>2]<<2)>>2]|0;if((f[e+36>>2]|0)==3)do switch(n|0){case 1:{o=f[e+52>>2]|0;if(!o){q=e;do if(b[e+40>>0]|0){r=f[e+56>>2]|0;if(!r){s=(f[e+24>>2]|0)+72|0;break}else{s=r+68|0;break}}else s=(f[e+48>>2]|0)+28|0;while(0);r=f[a+16>>2]|0;t=c+(f[r+(((q-(f[s>>2]|0)|0)/88|0)<<2)>>2]|0)|0;v=e;do if(b[e+40>>0]|0){w=f[e+56>>2]|0;if(!w){x=(f[e+24>>2]|0)+72|0;break}else{x=w+68|0;break}}else x=(f[e+48>>2]|0)+28|0;while(0);y=t;z=r;A=(v-(f[x>>2]|0)|0)/88|0}else{q=f[a+16>>2]|0;y=c+(f[q+(((o-(f[(f[o+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;z=q;A=((o-(f[(f[o+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}SHb(y,d+(f[z+(A<<2)>>2]|0)|0);u=g;return}case 2:{q=f[e+52>>2]|0;if(!q){w=e;do if(b[e+40>>0]|0){B=f[e+56>>2]|0;if(!B){C=(f[e+24>>2]|0)+72|0;break}else{C=B+68|0;break}}else C=(f[e+48>>2]|0)+28|0;while(0);o=f[a+16>>2]|0;v=c+(f[o+(((w-(f[C>>2]|0)|0)/88|0)<<2)>>2]|0)|0;r=e;do if(b[e+40>>0]|0){t=f[e+56>>2]|0;if(!t){D=(f[e+24>>2]|0)+72|0;break}else{D=t+68|0;break}}else D=(f[e+48>>2]|0)+28|0;while(0);E=v;F=o;G=(r-(f[D>>2]|0)|0)/88|0}else{w=f[a+16>>2]|0;E=c+(f[w+(((q-(f[(f[q+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;F=w;G=((q-(f[(f[q+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}THb(E,d+(f[F+(G<<2)>>2]|0)|0);u=g;return}case 3:{w=f[e+52>>2]|0;if(!w){t=e;do if(b[e+40>>0]|0){B=f[e+56>>2]|0;if(!B){H=(f[e+24>>2]|0)+72|0;break}else{H=B+68|0;break}}else H=(f[e+48>>2]|0)+28|0;while(0);q=f[a+16>>2]|0;r=c+(f[q+(((t-(f[H>>2]|0)|0)/88|0)<<2)>>2]|0)|0;o=e;do if(b[e+40>>0]|0){v=f[e+56>>2]|0;if(!v){I=(f[e+24>>2]|0)+72|0;break}else{I=v+68|0;break}}else I=(f[e+48>>2]|0)+28|0;while(0);J=r;K=q;L=(o-(f[I>>2]|0)|0)/88|0}else{t=f[a+16>>2]|0;J=c+(f[t+(((w-(f[(f[w+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;K=t;L=((w-(f[(f[w+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}UHb(J,d+(f[K+(L<<2)>>2]|0)|0);u=g;return}case 4:{t=f[e+52>>2]|0;if(!t){v=e;do if(b[e+40>>0]|0){B=f[e+56>>2]|0;if(!B){M=(f[e+24>>2]|0)+72|0;break}else{M=B+68|0;break}}else M=(f[e+48>>2]|0)+28|0;while(0);w=f[a+16>>2]|0;o=c+(f[w+(((v-(f[M>>2]|0)|0)/88|0)<<2)>>2]|0)|0;q=e;do if(b[e+40>>0]|0){r=f[e+56>>2]|0;if(!r){N=(f[e+24>>2]|0)+72|0;break}else{N=r+68|0;break}}else N=(f[e+48>>2]|0)+28|0;while(0);O=o;P=w;Q=(q-(f[N>>2]|0)|0)/88|0}else{v=f[a+16>>2]|0;O=c+(f[v+(((t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;P=v;Q=((t-(f[(f[t+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}VHb(O,d+(f[P+(Q<<2)>>2]|0)|0);u=g;return}case 6:{v=f[e+52>>2]|0;if(!v){r=e;do if(b[e+40>>0]|0){B=f[e+56>>2]|0;if(!B){R=(f[e+24>>2]|0)+72|0;break}else{R=B+68|0;break}}else R=(f[e+48>>2]|0)+28|0;while(0);t=f[a+16>>2]|0;q=c+(f[t+(((r-(f[R>>2]|0)|0)/88|0)<<2)>>2]|0)|0;w=e;do if(b[e+40>>0]|0){o=f[e+56>>2]|0;if(!o){S=(f[e+24>>2]|0)+72|0;break}else{S=o+68|0;break}}else S=(f[e+48>>2]|0)+28|0;while(0);T=q;U=t;V=(w-(f[S>>2]|0)|0)/88|0}else{r=f[a+16>>2]|0;T=c+(f[r+(((v-(f[(f[v+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;U=r;V=((v-(f[(f[v+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}WHb(T,d+(f[U+(V<<2)>>2]|0)|0);u=g;return}case 5:{r=f[e+52>>2]|0;if(!r){o=e;do if(b[e+40>>0]|0){B=f[e+56>>2]|0;if(!B){W=(f[e+24>>2]|0)+72|0;break}else{W=B+68|0;break}}else W=(f[e+48>>2]|0)+28|0;while(0);v=f[a+16>>2]|0;w=c+(f[v+(((o-(f[W>>2]|0)|0)/88|0)<<2)>>2]|0)|0;t=e;do if(b[e+40>>0]|0){q=f[e+56>>2]|0;if(!q){X=(f[e+24>>2]|0)+72|0;break}else{X=q+68|0;break}}else X=(f[e+48>>2]|0)+28|0;while(0);Y=w;Z=v;_=(t-(f[X>>2]|0)|0)/88|0}else{o=f[a+16>>2]|0;Y=c+(f[o+(((r-(f[(f[r+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;Z=o;_=((r-(f[(f[r+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}XHb(Y,d+(f[Z+(_<<2)>>2]|0)|0);u=g;return}case 7:{o=f[e+52>>2]|0;if(!o){q=e;do if(b[e+40>>0]|0){B=f[e+56>>2]|0;if(!B){$=(f[e+24>>2]|0)+72|0;break}else{$=B+68|0;break}}else $=(f[e+48>>2]|0)+28|0;while(0);r=f[a+16>>2]|0;t=c+(f[r+(((q-(f[$>>2]|0)|0)/88|0)<<2)>>2]|0)|0;v=e;do if(b[e+40>>0]|0){w=f[e+56>>2]|0;if(!w){aa=(f[e+24>>2]|0)+72|0;break}else{aa=w+68|0;break}}else aa=(f[e+48>>2]|0)+28|0;while(0);ba=t;ca=r;da=(v-(f[aa>>2]|0)|0)/88|0}else{q=f[a+16>>2]|0;ba=c+(f[q+(((o-(f[(f[o+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;ca=q;da=((o-(f[(f[o+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}YHb(ba,d+(f[ca+(da<<2)>>2]|0)|0);u=g;return}case 8:{q=f[e+52>>2]|0;if(!q){w=e;do if(b[e+40>>0]|0){B=f[e+56>>2]|0;if(!B){ea=(f[e+24>>2]|0)+72|0;break}else{ea=B+68|0;break}}else ea=(f[e+48>>2]|0)+28|0;while(0);o=f[a+16>>2]|0;v=c+(f[o+(((w-(f[ea>>2]|0)|0)/88|0)<<2)>>2]|0)|0;r=e;do if(b[e+40>>0]|0){t=f[e+56>>2]|0;if(!t){fa=(f[e+24>>2]|0)+72|0;break}else{fa=t+68|0;break}}else fa=(f[e+48>>2]|0)+28|0;while(0);ga=v;ha=o;ia=(r-(f[fa>>2]|0)|0)/88|0}else{w=f[a+16>>2]|0;ga=c+(f[w+(((q-(f[(f[q+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;ha=w;ia=((q-(f[(f[q+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}SHb(ga,d+(f[ha+(ia<<2)>>2]|0)|0);u=g;return}case 9:{w=f[e+52>>2]|0;if(!w){t=e;do if(b[e+40>>0]|0){B=f[e+56>>2]|0;if(!B){ja=(f[e+24>>2]|0)+72|0;break}else{ja=B+68|0;break}}else ja=(f[e+48>>2]|0)+28|0;while(0);q=f[a+16>>2]|0;r=c+(f[q+(((t-(f[ja>>2]|0)|0)/88|0)<<2)>>2]|0)|0;o=e;do if(b[e+40>>0]|0){v=f[e+56>>2]|0;if(!v){ka=(f[e+24>>2]|0)+72|0;break}else{ka=v+68|0;break}}else ka=(f[e+48>>2]|0)+28|0;while(0);la=r;ma=q;na=(o-(f[ka>>2]|0)|0)/88|0}else{t=f[a+16>>2]|0;la=c+(f[t+(((w-(f[(f[w+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;ma=t;na=((w-(f[(f[w+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}t=d+(f[ma+(na<<2)>>2]|0)|0;if((f[t>>2]|0)==(f[la>>2]|0)){v=la+12|0;B=t+12|0;oa=f[v>>2]|0;f[v>>2]=f[B>>2];f[B>>2]=oa;oa=la+4|0;B=t+4|0;v=f[oa>>2]|0;f[oa>>2]=f[B>>2];f[B>>2]=v;v=la+8|0;B=t+8|0;oa=f[v>>2]|0;f[v>>2]=f[B>>2];f[B>>2]=oa;u=g;return}else{ZHb(la,t);u=g;return}break}case 10:{t=xub(e)|0;oa=e+52|0;B=f[oa>>2]|0;v=(B|0)==0;if(!t){if(v){t=e;do if(b[e+40>>0]|0){pa=f[e+56>>2]|0;if(!pa){qa=(f[e+24>>2]|0)+72|0;break}else{qa=pa+68|0;break}}else qa=(f[e+48>>2]|0)+28|0;while(0);w=f[a+16>>2]|0;o=c+(f[w+(((t-(f[qa>>2]|0)|0)/88|0)<<2)>>2]|0)|0;q=e;do if(b[e+40>>0]|0){r=f[e+56>>2]|0;if(!r){ra=(f[e+24>>2]|0)+72|0;break}else{ra=r+68|0;break}}else ra=(f[e+48>>2]|0)+28|0;while(0);sa=o;ta=w;ua=(q-(f[ra>>2]|0)|0)/88|0}else{t=f[a+16>>2]|0;sa=c+(f[t+(((B-(f[(f[B+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;ta=t;ua=((B-(f[(f[B+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}t=d+(f[ta+(ua<<2)>>2]|0)|0;if((f[t>>2]|0)==(f[sa>>2]|0)){r=sa+12|0;pa=t+12|0;va=f[r>>2]|0;f[r>>2]=f[pa>>2];f[pa>>2]=va;va=sa+4|0;pa=t+4|0;r=f[va>>2]|0;f[va>>2]=f[pa>>2];f[pa>>2]=r;r=sa+8|0;pa=t+8|0;va=f[r>>2]|0;f[r>>2]=f[pa>>2];f[pa>>2]=va;u=g;return}else{_Hb(sa,t);u=g;return}}if(v){t=e;do if(b[e+40>>0]|0){va=f[e+56>>2]|0;if(!va){wa=(f[e+24>>2]|0)+72|0;break}else{wa=va+68|0;break}}else wa=(f[e+48>>2]|0)+28|0;while(0);xa=(t-(f[wa>>2]|0)|0)/88|0}else xa=((B-(f[(f[B+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;v=a+16|0;q=pKb(c+(f[(f[v>>2]|0)+(xa<<2)>>2]|0)|0)|0;w=f[oa>>2]|0;if(!w){o=e;do if(b[e+40>>0]|0){va=f[e+56>>2]|0;if(!va){ya=(f[e+24>>2]|0)+72|0;break}else{ya=va+68|0;break}}else ya=(f[e+48>>2]|0)+28|0;while(0);za=(o-(f[ya>>2]|0)|0)/88|0}else za=((w-(f[(f[w+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;oa=pKb(d+(f[(f[v>>2]|0)+(za<<2)>>2]|0)|0)|0;if((f[oa>>2]|0)==(f[q>>2]|0)){B=q+12|0;t=oa+12|0;va=f[B>>2]|0;f[B>>2]=f[t>>2];f[t>>2]=va;va=q+4|0;t=oa+4|0;B=f[va>>2]|0;f[va>>2]=f[t>>2];f[t>>2]=B;B=q+8|0;t=oa+8|0;va=f[B>>2]|0;f[B>>2]=f[t>>2];f[t>>2]=va;u=g;return}else{_Hb(q,oa);u=g;return}break}default:{zpb(h,3,466902,420);xpb(i,ypb(vpb(h,469897)|0,f[136e3+(f[m>>2]<<2)>>2]|0)|0);Apb(h);u=g;return}}while(0);do switch(n|0){case 1:{h=f[e+52>>2]|0;if(!h){i=e;do if(b[e+40>>0]|0){za=f[e+56>>2]|0;if(!za){Aa=(f[e+24>>2]|0)+72|0;break}else{Aa=za+68|0;break}}else Aa=(f[e+48>>2]|0)+28|0;while(0);q=f[a+16>>2]|0;v=c+(f[q+(((i-(f[Aa>>2]|0)|0)/88|0)<<2)>>2]|0)|0;w=e;do if(b[e+40>>0]|0){o=f[e+56>>2]|0;if(!o){Ba=(f[e+24>>2]|0)+72|0;break}else{Ba=o+68|0;break}}else Ba=(f[e+48>>2]|0)+28|0;while(0);Ca=v;Da=q;Ea=(w-(f[Ba>>2]|0)|0)/88|0}else{i=f[a+16>>2]|0;Ca=c+(f[i+(((h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;Da=i;Ea=((h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}i=d+(f[Da+(Ea<<2)>>2]|0)|0;o=f[Ca>>2]|0;f[Ca>>2]=f[i>>2];f[i>>2]=o;u=g;return}case 2:{o=f[e+52>>2]|0;if(!o){i=e;do if(b[e+40>>0]|0){za=f[e+56>>2]|0;if(!za){Fa=(f[e+24>>2]|0)+72|0;break}else{Fa=za+68|0;break}}else Fa=(f[e+48>>2]|0)+28|0;while(0);h=f[a+16>>2]|0;w=c+(f[h+(((i-(f[Fa>>2]|0)|0)/88|0)<<2)>>2]|0)|0;q=e;do if(b[e+40>>0]|0){v=f[e+56>>2]|0;if(!v){Ga=(f[e+24>>2]|0)+72|0;break}else{Ga=v+68|0;break}}else Ga=(f[e+48>>2]|0)+28|0;while(0);Ha=w;Ia=h;Ja=(q-(f[Ga>>2]|0)|0)/88|0}else{i=f[a+16>>2]|0;Ha=c+(f[i+(((o-(f[(f[o+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;Ia=i;Ja=((o-(f[(f[o+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}i=d+(f[Ia+(Ja<<2)>>2]|0)|0;v=Ha;za=f[v>>2]|0;ya=f[v+4>>2]|0;v=i;xa=f[v+4>>2]|0;wa=Ha;f[wa>>2]=f[v>>2];f[wa+4>>2]=xa;xa=i;f[xa>>2]=za;f[xa+4>>2]=ya;u=g;return}case 3:{ya=f[e+52>>2]|0;if(!ya){xa=e;do if(b[e+40>>0]|0){za=f[e+56>>2]|0;if(!za){Ka=(f[e+24>>2]|0)+72|0;break}else{Ka=za+68|0;break}}else Ka=(f[e+48>>2]|0)+28|0;while(0);o=f[a+16>>2]|0;q=c+(f[o+(((xa-(f[Ka>>2]|0)|0)/88|0)<<2)>>2]|0)|0;h=e;do if(b[e+40>>0]|0){w=f[e+56>>2]|0;if(!w){La=(f[e+24>>2]|0)+72|0;break}else{La=w+68|0;break}}else La=(f[e+48>>2]|0)+28|0;while(0);Ma=q;Na=o;Oa=(h-(f[La>>2]|0)|0)/88|0}else{xa=f[a+16>>2]|0;Ma=c+(f[xa+(((ya-(f[(f[ya+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;Na=xa;Oa=((ya-(f[(f[ya+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}xa=d+(f[Na+(Oa<<2)>>2]|0)|0;w=f[Ma>>2]|0;f[Ma>>2]=f[xa>>2];f[xa>>2]=w;u=g;return}case 4:{w=f[e+52>>2]|0;if(!w){xa=e;do if(b[e+40>>0]|0){za=f[e+56>>2]|0;if(!za){Pa=(f[e+24>>2]|0)+72|0;break}else{Pa=za+68|0;break}}else Pa=(f[e+48>>2]|0)+28|0;while(0);ya=f[a+16>>2]|0;h=c+(f[ya+(((xa-(f[Pa>>2]|0)|0)/88|0)<<2)>>2]|0)|0;o=e;do if(b[e+40>>0]|0){q=f[e+56>>2]|0;if(!q){Qa=(f[e+24>>2]|0)+72|0;break}else{Qa=q+68|0;break}}else Qa=(f[e+48>>2]|0)+28|0;while(0);Ra=h;Sa=ya;Ta=(o-(f[Qa>>2]|0)|0)/88|0}else{xa=f[a+16>>2]|0;Ra=c+(f[xa+(((w-(f[(f[w+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;Sa=xa;Ta=((w-(f[(f[w+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}xa=d+(f[Sa+(Ta<<2)>>2]|0)|0;q=Ra;za=f[q>>2]|0;i=f[q+4>>2]|0;q=xa;wa=f[q+4>>2]|0;v=Ra;f[v>>2]=f[q>>2];f[v+4>>2]=wa;wa=xa;f[wa>>2]=za;f[wa+4>>2]=i;u=g;return}case 6:{i=f[e+52>>2]|0;if(!i){wa=e;do if(b[e+40>>0]|0){za=f[e+56>>2]|0;if(!za){Ua=(f[e+24>>2]|0)+72|0;break}else{Ua=za+68|0;break}}else Ua=(f[e+48>>2]|0)+28|0;while(0);w=f[a+16>>2]|0;o=c+(f[w+(((wa-(f[Ua>>2]|0)|0)/88|0)<<2)>>2]|0)|0;ya=e;do if(b[e+40>>0]|0){h=f[e+56>>2]|0;if(!h){Va=(f[e+24>>2]|0)+72|0;break}else{Va=h+68|0;break}}else Va=(f[e+48>>2]|0)+28|0;while(0);Wa=w;Xa=(ya-(f[Va>>2]|0)|0)/88|0;Ya=o}else{wa=f[a+16>>2]|0;Wa=wa;Xa=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;Ya=c+(f[wa+(((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0}wa=d+(f[Wa+(Xa<<2)>>2]|0)|0;h=f[Ya>>2]|0;f[Ya>>2]=f[wa>>2];f[wa>>2]=h;u=g;return}case 5:{h=f[e+52>>2]|0;if(!h){wa=e;do if(b[e+40>>0]|0){za=f[e+56>>2]|0;if(!za){Za=(f[e+24>>2]|0)+72|0;break}else{Za=za+68|0;break}}else Za=(f[e+48>>2]|0)+28|0;while(0);i=f[a+16>>2]|0;o=c+(f[i+(((wa-(f[Za>>2]|0)|0)/88|0)<<2)>>2]|0)|0;ya=e;do if(b[e+40>>0]|0){w=f[e+56>>2]|0;if(!w){_a=(f[e+24>>2]|0)+72|0;break}else{_a=w+68|0;break}}else _a=(f[e+48>>2]|0)+28|0;while(0);$a=o;ab=i;bb=(ya-(f[_a>>2]|0)|0)/88|0}else{wa=f[a+16>>2]|0;$a=c+(f[wa+(((h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;ab=wa;bb=((h-(f[(f[h+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}wa=d+(f[ab+(bb<<2)>>2]|0)|0;cb=+p[$a>>3];p[$a>>3]=+p[wa>>3];p[wa>>3]=cb;u=g;return}case 7:{wa=f[e+52>>2]|0;if(!wa){w=e;do if(b[e+40>>0]|0){za=f[e+56>>2]|0;if(!za){db=(f[e+24>>2]|0)+72|0;break}else{db=za+68|0;break}}else db=(f[e+48>>2]|0)+28|0;while(0);h=f[a+16>>2]|0;ya=c+(f[h+(((w-(f[db>>2]|0)|0)/88|0)<<2)>>2]|0)|0;i=e;do if(b[e+40>>0]|0){o=f[e+56>>2]|0;if(!o){eb=(f[e+24>>2]|0)+72|0;break}else{eb=o+68|0;break}}else eb=(f[e+48>>2]|0)+28|0;while(0);fb=h;gb=(i-(f[eb>>2]|0)|0)/88|0;hb=ya}else{w=f[a+16>>2]|0;fb=w;gb=((wa-(f[(f[wa+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0;hb=c+(f[w+(((wa-(f[(f[wa+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0}w=d+(f[fb+(gb<<2)>>2]|0)|0;o=b[hb>>0]|0;b[hb>>0]=b[w>>0]|0;b[w>>0]=o;u=g;return}case 8:{o=f[e+52>>2]|0;if(!o){w=e;do if(b[e+40>>0]|0){za=f[e+56>>2]|0;if(!za){ib=(f[e+24>>2]|0)+72|0;break}else{ib=za+68|0;break}}else ib=(f[e+48>>2]|0)+28|0;while(0);wa=f[a+16>>2]|0;ya=c+(f[wa+(((w-(f[ib>>2]|0)|0)/88|0)<<2)>>2]|0)|0;i=e;do if(b[e+40>>0]|0){h=f[e+56>>2]|0;if(!h){jb=(f[e+24>>2]|0)+72|0;break}else{jb=h+68|0;break}}else jb=(f[e+48>>2]|0)+28|0;while(0);kb=ya;lb=wa;mb=(i-(f[jb>>2]|0)|0)/88|0}else{w=f[a+16>>2]|0;kb=c+(f[w+(((o-(f[(f[o+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;lb=w;mb=((o-(f[(f[o+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}w=d+(f[lb+(mb<<2)>>2]|0)|0;h=f[kb>>2]|0;f[kb>>2]=f[w>>2];f[w>>2]=h;u=g;return}case 10:{h=f[a+36>>2]|0;do if((h|0)!=-1){w=c+h|0;if((f[a+28>>2]|0)!=-1){nb=f[d+h>>2]|0;ob=f[w>>2]|0;break}za=f[w>>2]|0;w=za&-2;if(!(za&1))pb=w;else pb=f[w+4>>2]|0;w=f[d+h>>2]|0;za=w&-2;if(!(w&1)){nb=za;ob=pb;break}else{nb=f[za+4>>2]|0;ob=pb;break}}else{nb=0;ob=0}while(0);h=(ob|0)==(nb|0);o=f[e+52>>2]|0;if(!o){i=e;do if(b[e+40>>0]|0){wa=f[e+56>>2]|0;if(!wa){qb=(f[e+24>>2]|0)+72|0;break}else{qb=wa+68|0;break}}else qb=(f[e+48>>2]|0)+28|0;while(0);wa=f[a+16>>2]|0;ya=c+(f[wa+(((i-(f[qb>>2]|0)|0)/88|0)<<2)>>2]|0)|0;za=e;do if(b[e+40>>0]|0){w=f[e+56>>2]|0;if(!w){rb=(f[e+24>>2]|0)+72|0;break}else{rb=w+68|0;break}}else rb=(f[e+48>>2]|0)+28|0;while(0);sb=ya;tb=wa;ub=(za-(f[rb>>2]|0)|0)/88|0}else{i=f[a+16>>2]|0;sb=c+(f[i+(((o-(f[(f[o+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;tb=i;ub=((o-(f[(f[o+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}i=d+(f[tb+(ub<<2)>>2]|0)|0;if(h){w=f[sb>>2]|0;f[sb>>2]=f[i>>2];f[i>>2]=w;u=g;return}w=f[sb>>2]|0;xa=(f[i>>2]|0)==0;if(!w){if(xa){u=g;return}v=f[i>>2]|0;q=f[(f[v>>2]|0)+16>>2]|0;sa=di[f[(f[c>>2]|0)+20>>2]&1023](c)|0;ua=Uh[q&1023](v,sa)|0;f[sb>>2]=ua;zh[f[(f[ua>>2]|0)+72>>2]&2047](ua,f[i>>2]|0);_h[f[(f[a>>2]|0)+28>>2]&255](a,d,e);u=g;return}if(xa){xa=f[(f[w>>2]|0)+16>>2]|0;ua=di[f[(f[d>>2]|0)+20>>2]&1023](d)|0;sa=Uh[xa&1023](w,ua)|0;f[i>>2]=sa;zh[f[(f[sa>>2]|0)+72>>2]&2047](sa,f[sb>>2]|0);_h[f[(f[a>>2]|0)+28>>2]&255](a,c,e);u=g;return}else{sa=di[f[(f[w>>2]|0)+92>>2]&1023](w)|0;_h[f[(f[sa>>2]|0)+52>>2]&255](sa,f[sb>>2]|0,f[i>>2]|0);u=g;return}break}case 9:{i=f[a+36>>2]|0;do if((i|0)!=-1){sa=c+i|0;if((f[a+28>>2]|0)!=-1){vb=f[d+i>>2]|0;wb=f[sa>>2]|0;break}w=f[sa>>2]|0;sa=w&-2;if(!(w&1))xb=sa;else xb=f[sa+4>>2]|0;sa=f[d+i>>2]|0;w=sa&-2;if(!(sa&1)){vb=w;wb=xb;break}else{vb=f[w+4>>2]|0;wb=xb;break}}else{vb=0;wb=0}while(0);i=f[e+52>>2]|0;h=(i|0)==0;if(h){o=e;do if(b[e+40>>0]|0){za=f[e+56>>2]|0;if(!za){yb=(f[e+24>>2]|0)+72|0;break}else{yb=za+68|0;break}}else yb=(f[e+48>>2]|0)+28|0;while(0);za=f[a+16>>2]|0;wa=c+(f[za+(((o-(f[yb>>2]|0)|0)/88|0)<<2)>>2]|0)|0;ya=e;do if(b[e+40>>0]|0){w=f[e+56>>2]|0;if(!w){zb=(f[e+24>>2]|0)+72|0;break}else{zb=w+68|0;break}}else zb=(f[e+48>>2]|0)+28|0;while(0);Ab=wa;Bb=za;Cb=(ya-(f[zb>>2]|0)|0)/88|0}else{o=f[a+16>>2]|0;Ab=c+(f[o+(((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)<<2)>>2]|0)|0;Bb=o;Cb=((i-(f[(f[i+8>>2]|0)+36>>2]|0)|0)/28|0)+(f[(f[a+4>>2]|0)+24>>2]|0)|0}o=d+(f[Bb+(Cb<<2)>>2]|0)|0;if((wb|0)==(vb|0)){w=f[Ab>>2]|0;f[Ab>>2]=f[o>>2];f[o>>2]=w;u=g;return}w=f[(h?a+8|0:a+12|0)>>2]|0;sa=e;do if(b[e+40>>0]|0){ua=f[e+56>>2]|0;if(!ua){Db=(f[e+24>>2]|0)+72|0;break}else{Db=ua+68|0;break}}else Db=(f[e+48>>2]|0)+28|0;while(0);h=f[w+(f[Bb+(((sa-(f[Db>>2]|0)|0)/88|0)<<2)>>2]|0)>>2]|0;X5b(j,f[Ab>>2]|0);i=f[o>>2]|0;ya=f[Ab>>2]|0;if((ya|0)==(h|0))dya(Ab,wb,i);else _5b(ya,i)|0;i=f[o>>2]|0;if((i|0)==(h|0))dya(o,vb,j);else _5b(i,j)|0;if((b[j+11>>0]|0)<0)O5b(f[j>>2]|0);u=g;return}default:{zpb(k,3,466902,489);xpb(l,ypb(vpb(k,469897)|0,f[136e3+(f[m>>2]<<2)>>2]|0)|0);Apb(k);u=g;return}}while(0)}function SHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;e=b+4|0;l=f[g>>2]|0;f[g>>2]=f[e>>2];f[e>>2]=l;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){l=znb(m,25528,4)|0;f[k>>2]=l;f[l>>2]=m}jIb(d,a);f[a>>2]=0;jIb(a,b);if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)O5b(n);u=c;return}function THb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;e=b+4|0;l=f[g>>2]|0;f[g>>2]=f[e>>2];f[e>>2]=l;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){l=znb(m,25528,8)|0;f[k>>2]=l;f[l>>2]=m}iIb(d,a);f[a>>2]=0;iIb(a,b);if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)O5b(n);u=c;return}function UHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;e=b+4|0;l=f[g>>2]|0;f[g>>2]=f[e>>2];f[e>>2]=l;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){l=znb(m,25528,4)|0;f[k>>2]=l;f[l>>2]=m}hIb(d,a);f[a>>2]=0;hIb(a,b);if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)O5b(n);u=c;return}function VHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;e=b+4|0;l=f[g>>2]|0;f[g>>2]=f[e>>2];f[e>>2]=l;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){l=znb(m,25528,8)|0;f[k>>2]=l;f[l>>2]=m}gIb(d,a);f[a>>2]=0;gIb(a,b);if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)O5b(n);u=c;return}function WHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;e=b+4|0;l=f[g>>2]|0;f[g>>2]=f[e>>2];f[e>>2]=l;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){l=znb(m,25528,4)|0;f[k>>2]=l;f[l>>2]=m}fIb(d,a);f[a>>2]=0;fIb(a,b);if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)O5b(n);u=c;return}function XHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;e=b+4|0;l=f[g>>2]|0;f[g>>2]=f[e>>2];f[e>>2]=l;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){l=znb(m,25528,8)|0;f[k>>2]=l;f[l>>2]=m}eIb(d,a);f[a>>2]=0;eIb(a,b);if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)O5b(n);u=c;return}function YHb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;d=c;if((a|0)==(b|0)){u=c;return}e=a+8|0;g=f[e>>2]|0;if(!g)h=0;else h=f[g>>2]|0;i=b+8|0;j=f[i>>2]|0;k=(j|0)==0;if(k)l=0;else l=f[j>>2]|0;if((h|0)==(l|0)){f[e>>2]=j;f[i>>2]=g;g=f[a>>2]|0;f[a>>2]=f[b>>2];f[b>>2]=g;g=a+4|0;e=b+4|0;l=f[g>>2]|0;f[g>>2]=f[e>>2];f[e>>2]=l;u=c;return}if(k)m=0;else m=f[j>>2]|0;f[d>>2]=0;j=d+4|0;f[j>>2]=0;k=d+8|0;f[k>>2]=0;if(m|0){l=znb(m,25528,4)|0;f[k>>2]=l;f[l>>2]=m}dIb(d,a);f[a>>2]=0;dIb(a,b);if((d|0)==(b|0))n=f[k>>2]|0;else{a=f[i>>2]|0;f[i>>2]=f[k>>2];f[k>>2]=a;k=f[b>>2]|0;f[b>>2]=f[d>>2];f[d>>2]=k;k=b+4|0;b=f[k>>2]|0;f[k>>2]=f[j>>2];f[j>>2]=b;n=a}if(n|0?(f[n>>2]|0)==0:0)O5b(n);u=c;return}function ZHb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=e+4|0;f[g>>2]=0;h=e+8|0;f[h>>2]=0;i=e+12|0;f[i>>2]=0;aIb(e,a);j=a+4|0;k=f[j>>2]|0;if((k|0)>0){l=f[a+12>>2]|0;m=0;do{n=f[l+4+(m<<2)>>2]|0;m=m+1|0;o=n+11|0;if((b[o>>0]|0)<0){b[f[n>>2]>>0]=0;f[n+4>>2]=0}else{b[n>>0]=0;b[o>>0]=0}}while((m|0)!=(k|0));f[j>>2]=0}aIb(a,c);a=c+4|0;j=f[a>>2]|0;k=c+12|0;if((j|0)>0){m=f[k>>2]|0;l=0;do{o=f[m+4+(l<<2)>>2]|0;l=l+1|0;n=o+11|0;if((b[n>>0]|0)<0){b[f[o>>2]>>0]=0;f[o+4>>2]=0}else{b[o>>0]=0;b[n>>0]=0}}while((l|0)!=(j|0));f[a>>2]=0;p=0}else p=j;j=f[k>>2]|0;f[k>>2]=f[i>>2];f[i>>2]=j;f[a>>2]=f[g>>2];f[g>>2]=p;p=c+8|0;c=f[p>>2]|0;f[p>>2]=f[h>>2];f[h>>2]=c;c=j;if(!((j|0)!=0&(f[e>>2]|0)==0)){u=d;return}e=j;j=f[c>>2]|0;if((j|0)>0){h=0;do{p=f[c+4+(h<<2)>>2]|0;if(p|0){if((b[p+11>>0]|0)<0)O5b(f[p>>2]|0);O5b(p)}h=h+1|0}while((h|0)!=(j|0));q=f[i>>2]|0}else q=e;O5b(q);u=d;return}function _Hb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;f[d>>2]=f[b>>2];e=d+4|0;f[e>>2]=0;g=d+8|0;f[g>>2]=0;h=d+12|0;f[h>>2]=0;$Hb(d,a);i=a+4|0;j=f[i>>2]|0;if((j|0)>0){k=f[a+12>>2]|0;l=0;do{m=f[k+4+(l<<2)>>2]|0;l=l+1|0;bi[f[(f[m>>2]|0)+28>>2]&2047](m)}while((l|0)!=(j|0));f[i>>2]=0}$Hb(a,b);a=b+4|0;i=f[a>>2]|0;j=b+12|0;if((i|0)>0){l=f[j>>2]|0;k=0;do{m=f[l+4+(k<<2)>>2]|0;k=k+1|0;bi[f[(f[m>>2]|0)+28>>2]&2047](m)}while((k|0)!=(i|0));f[a>>2]=0;n=0}else n=i;i=f[j>>2]|0;f[j>>2]=f[h>>2];f[h>>2]=i;f[a>>2]=f[e>>2];f[e>>2]=n;n=b+8|0;b=f[n>>2]|0;f[n>>2]=f[g>>2];f[g>>2]=b;b=i;if(!((i|0)!=0&(f[d>>2]|0)==0)){u=c;return}d=i;i=f[b>>2]|0;if((i|0)>0){g=0;do{n=f[b+4+(g<<2)>>2]|0;if(n|0)bi[f[(f[n>>2]|0)+4>>2]&2047](n);g=g+1|0}while((g|0)!=(i|0));o=f[h>>2]|0}else o=d;O5b(o);u=c;return}function $Hb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{xHb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=tLb(h,i)|0;xHb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function aIb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((h|0)>0&(c|0)>0){i=0;do{apb(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=bIb(h,i)|0;apb(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function bIb(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=cIb(b,c)|0;u=a;return d|0}function cIb(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;c=b;return c|0}else{b=znb(a,8992,12)|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;xnb(a,b,1480);c=b;return c|0}return 0}function dIb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;if((b|0)==(a|0)){zpb(d,3,468430,1166);xpb(c+24|0,vpb(d,469918)|0);Apb(d)}d=f[b>>2]|0;if(!d){u=c;return}vFa(a,(f[a>>2]|0)+d|0);Vac((f[a>>2]|0)+((f[a+8>>2]|0)+4)|0,(f[b+8>>2]|0)+4|0,f[b>>2]|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0);u=c;return}function eIb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;if((b|0)==(a|0)){zpb(d,3,468430,1166);xpb(c+24|0,vpb(d,469918)|0);Apb(d)}d=f[b>>2]|0;if(!d){u=c;return}tFa(a,(f[a>>2]|0)+d|0);Vac((f[a+8>>2]|0)+8+(f[a>>2]<<3)|0,(f[b+8>>2]|0)+8|0,f[b>>2]<<3|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0);u=c;return}function fIb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;if((b|0)==(a|0)){zpb(d,3,468430,1166);xpb(c+24|0,vpb(d,469918)|0);Apb(d)}d=f[b>>2]|0;if(!d){u=c;return}qza(a,(f[a>>2]|0)+d|0);Vac((f[a+8>>2]|0)+4+(f[a>>2]<<2)|0,(f[b+8>>2]|0)+4|0,f[b>>2]<<2|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0);u=c;return}function gIb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;if((b|0)==(a|0)){zpb(d,3,468430,1166);xpb(c+24|0,vpb(d,469918)|0);Apb(d)}d=f[b>>2]|0;if(!d){u=c;return}AHb(a,(f[a>>2]|0)+d|0);Vac((f[a+8>>2]|0)+8+(f[a>>2]<<3)|0,(f[b+8>>2]|0)+8|0,f[b>>2]<<3|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0);u=c;return}function hIb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;if((b|0)==(a|0)){zpb(d,3,468430,1166);xpb(c+24|0,vpb(d,469918)|0);Apb(d)}d=f[b>>2]|0;if(!d){u=c;return}rza(a,(f[a>>2]|0)+d|0);Vac((f[a+8>>2]|0)+4+(f[a>>2]<<2)|0,(f[b+8>>2]|0)+4|0,f[b>>2]<<2|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0);u=c;return}function iIb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;if((b|0)==(a|0)){zpb(d,3,468430,1166);xpb(c+24|0,vpb(d,469918)|0);Apb(d)}d=f[b>>2]|0;if(!d){u=c;return}uFa(a,(f[a>>2]|0)+d|0);Vac((f[a+8>>2]|0)+8+(f[a>>2]<<3)|0,(f[b+8>>2]|0)+8|0,f[b>>2]<<3|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0);u=c;return}function jIb(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;if((b|0)==(a|0)){zpb(d,3,468430,1166);xpb(c+24|0,vpb(d,469918)|0);Apb(d)}d=f[b>>2]|0;if(!d){u=c;return}nza(a,(f[a>>2]|0)+d|0);Vac((f[a+8>>2]|0)+4+(f[a>>2]<<2)|0,(f[b+8>>2]|0)+4|0,f[b>>2]<<2|0)|0;f[a>>2]=(f[a>>2]|0)+(f[b>>2]|0);u=c;return}function kIb(){var a=0;a=L5b(4)|0;f[a>>2]=0;f[213430]=a;spb(58);return}function lIb(){var a=0;a=f[213430]|0;if(!a){f[213430]=0;return}if(f[a>>2]|0)GPb(a);O5b(a);f[213430]=0;return}function mIb(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0;f[a>>2]=139672;f[a+4>>2]=b;f[a+8>>2]=c;f[a+16>>2]=d;f[a+20>>2]=e;f[a+28>>2]=g;f[a+32>>2]=h;f[a+36>>2]=l;f[a+40>>2]=k;k=a+44|0;if(i|0){m=i;f[k>>2]=m;n=a+48|0;f[n>>2]=j;return}m=drb()|0;f[k>>2]=m;n=a+48|0;f[n>>2]=j;return}function nIb(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0;f[a>>2]=139672;f[a+4>>2]=b;f[a+8>>2]=c;f[a+12>>2]=i;f[a+16>>2]=d;f[a+20>>2]=e;f[a+24>>2]=j;f[a+28>>2]=g;f[a+32>>2]=h;f[a+36>>2]=n;f[a+40>>2]=m;m=a+44|0;if(k|0){o=k;f[m>>2]=o;p=a+48|0;f[p>>2]=l;return}o=drb()|0;f[m>>2]=o;p=a+48|0;f[p>>2]=l;return}function oIb(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;l=L5b(52)|0;m=drb()|0;n=LNb()|0;f[l>>2]=139672;f[l+4>>2]=a;f[l+8>>2]=b;f[l+12>>2]=h;f[l+16>>2]=c;f[l+20>>2]=d;f[l+24>>2]=i;f[l+28>>2]=e;f[l+32>>2]=g;f[l+36>>2]=k;f[l+40>>2]=j;j=l+44|0;if(m|0){o=m;f[j>>2]=o;p=l+48|0;f[p>>2]=n;return l|0}o=drb()|0;f[j>>2]=o;p=l+48|0;f[p>>2]=n;return l|0}function pIb(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;j=L5b(52)|0;k=drb()|0;l=LNb()|0;f[j>>2]=139672;f[j+4>>2]=a;f[j+8>>2]=b;f[j+16>>2]=c;f[j+20>>2]=d;f[j+28>>2]=e;f[j+32>>2]=g;f[j+36>>2]=i;f[j+40>>2]=h;h=j+44|0;if(k|0){m=k;f[h>>2]=m;n=j+48|0;f[n>>2]=l;return j|0}m=drb()|0;f[h>>2]=m;n=j+48|0;f[n>>2]=l;return j|0}function qIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0,q=0.0;d=u;u=u+128|0;e=d;g=d+104|0;h=d+72|0;i=d+48|0;j=d+24|0;k=d+20|0;l=d+8|0;m=+PVb(a,k);n=(c|0)!=0;o=f[k>>2]|0;if(n)f[c>>2]=o;if((b[o>>0]|0)!=46){q=m;u=d;return +q}p[e>>3]=1.5;k=_Ub(g,470135,e)|0;if((b[g>>0]|0)!=49){zpb(h,3,470140,63);xpb(d+98|0,vpb(h,470231)|0);Apb(h)}if((b[g+(k+-1)>>0]|0)!=53){zpb(i,3,470140,64);xpb(d+97|0,vpb(i,470266)|0);Apb(i)}if((k|0)>=7){zpb(j,3,470140,65);xpb(d+96|0,vpb(j,470306)|0);Apb(j)};f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;c6b(l,k+-3+(kUb(a)|0)|0);rIb(l,a,o)|0;j6b(l,g+1|0,k+-2|0)|0;k6b(l,o+1|0)|0;k=l+11|0;g=(b[k>>0]|0)<0?f[l>>2]|0:l;m=+PVb(g,e);j=f[e>>2]|0;e=g;g=b[k>>0]|0;if(n&(j-e|0)>(o-a|0)){o=g<<24>>24<0?f[l+4>>2]|0:g&255;n=a+((kUb(a)|0)-(o+e)+j)|0;f[c>>2]=n}if(g<<24>>24<0)O5b(f[l>>2]|0);q=m;u=d;return +q}function rIb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+16|0;g=c;h=e;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k){l=f[a+4>>2]|0;m=(f[a+8>>2]&2147483647)+-1|0}else{l=j&255;m=10}n=d-g|0;if(!n){u=e;return a|0}if(k){k=f[a>>2]|0;o=k;p=f[a+4>>2]|0;q=k}else{o=a;p=j&255;q=a}if(q>>>0<=c>>>0&(o+p|0)>>>0>c>>>0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(n>>>0>4294967279)V5b(h);if(n>>>0<11){b[h+11>>0]=n;r=h}else{p=n+16&-16;o=L5b(p)|0;f[h>>2]=o;f[h+8>>2]=p|-2147483648;f[h+4>>2]=n;r=o}if((c|0)==(d|0))s=r;else{o=r;p=c;while(1){b[o>>0]=b[p>>0]|0;p=p+1|0;if((p|0)==(d|0))break;else o=o+1|0}s=r+n|0}b[s>>0]=0;s=h+11|0;r=b[s>>0]|0;o=r<<24>>24<0;j6b(a,o?f[h>>2]|0:h,o?f[h+4>>2]|0:r&255)|0;if((b[s>>0]|0)<0)O5b(f[h>>2]|0);u=e;return a|0}if((m-l|0)>>>0<n>>>0){g6b(a,m,l+n-m|0,l,l,0,0);t=b[i>>0]|0}else t=j;if(t<<24>>24<0)v=f[a>>2]|0;else v=a;t=v+l|0;if((c|0)==(d|0))w=t;else{j=d+(l-g)|0;g=c;c=t;while(1){b[c>>0]=b[g>>0]|0;g=g+1|0;if((g|0)==(d|0))break;else c=c+1|0}w=v+j|0}b[w>>0]=0;w=l+n|0;if((b[i>>0]|0)<0){f[a+4>>2]=w;u=e;return a|0}else{b[i>>0]=w;u=e;return a|0}return 0}function sIb(a){a=+a;var b=0.0;if(!(a>3402823466385288598117041.0e14))if(a<-3402823466385288598117041.0e14)b=-D;else b=a;else b=D;return +b}function tIb(a){a=a|0;return}function uIb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;h=a+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;h=a+32|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;h=a+56|0;f[h>>2]=c;f[a+60>>2]=d;d=a+68|0;i=a+72|0;j=a+80|0;f[a+84>>2]=0;f[a+88>>2]=0;f[a+92>>2]=0;k=d+4|0;f[k>>2]=0;f[k+4>>2]=0;b[k+8>>0]=0;f[a+96>>2]=-1;b[a+100>>0]=0;f[a+104>>2]=0;b[a+108>>0]=1;b[a+109>>0]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a>>2]=0;f[g>>2]=0;f[d>>2]=0;f[a+76>>2]=0;k=c;while(1){if(!(li[f[(f[k>>2]|0)+8>>2]&511](k,g,i)|0)){l=3;break}if(f[i>>2]|0){l=6;break}k=f[h>>2]|0}if((l|0)==3){f[i>>2]=0;b[j>>0]=1;m=0;n=a+64|0;b[n>>0]=m;u=e;return}else if((l|0)==6){l=f[g>>2]|0;f[d>>2]=l;m=b[l>>0]|0;n=a+64|0;b[n>>0]=m;u=e;return}}function vIb(a){a=a|0;var c=0,d=0,e=0;c=f[a+72>>2]|0;d=f[a+76>>2]|0;if((c|0)>(d|0)){e=f[a+56>>2]|0;zh[f[(f[e>>2]|0)+12>>2]&2047](e,c-d|0)}d=a+32|0;if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);d=a+4|0;if((b[d+11>>0]|0)>=0)return;O5b(f[d>>2]|0);return}function wIb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;e=a+64|0;g=b[e>>0]|0;if(g<<24>>24==10){h=a+84|0;f[h>>2]=(f[h>>2]|0)+1;f[a+88>>2]=0}else{h=a+88|0;i=f[h>>2]|0;if(g<<24>>24==9)j=8-((i|0)%8|0)|0;else j=1;f[h>>2]=j+i}i=a+76|0;j=(f[i>>2]|0)+1|0;f[i>>2]=j;h=a+72|0;g=f[h>>2]|0;if((j|0)<(g|0)){b[e>>0]=b[(f[a+68>>2]|0)+j>>0]|0;u=c;return}j=a+80|0;if(b[j>>0]|0){b[e>>0]=0;u=c;return}k=f[a+92>>2]|0;if(k|0?(l=a+96|0,m=f[l>>2]|0,(g|0)>(m|0)):0){j6b(k,(f[a+68>>2]|0)+m|0,g-m|0)|0;f[l>>2]=0}f[d>>2]=0;l=a+68|0;f[l>>2]=0;f[i>>2]=0;i=a+56|0;while(1){a=f[i>>2]|0;if(!(li[f[(f[a>>2]|0)+8>>2]&511](a,d,h)|0)){n=15;break}if(f[h>>2]|0){n=17;break}}if((n|0)==15){f[h>>2]=0;b[j>>0]=1;o=0}else if((n|0)==17){n=f[d>>2]|0;f[l>>2]=n;o=b[n>>0]|0}b[e>>0]=o;u=c;return}function xIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+16|0;e=d;g=a+64|0;h=a+109|0;i=e+8|0;j=e+4|0;k=a+60|0;l=a+84|0;m=a+88|0;n=e+11|0;o=e+8|0;p=e+4|0;q=e+11|0;r=e+8|0;s=e+4|0;t=e+11|0;v=e+8|0;w=e+4|0;x=e+11|0;a:while(1){y=b[g>>0]|0;switch(y<<24>>24|0){case 0:{z=3;break a;break}case 10:{if(!(b[h>>0]|0)){z=7;break a}wIb(a);continue a;break}case 92:{wIb(a);A=b[g>>0]|0;switch(A<<24>>24){case 34:case 39:case 63:case 92:case 118:case 116:case 114:case 110:case 102:case 98:case 97:{wIb(a);continue a;break}default:{}}if((A&-8)<<24>>24==48){wIb(a);continue a}switch(A<<24>>24){case 120:{wIb(a);A=b[g>>0]|0;b:do if((A+-48&255)>=10){switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:{break b;break}default:{}}B=L5b(48)|0;f[e>>2]=B;f[i>>2]=-2147483600;f[j>>2]=40;C=B;D=470446;E=C+40|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[B+40>>0]=0;F=f[k>>2]|0;th[f[(f[F>>2]|0)+8>>2]&511](F,f[l>>2]|0,f[m>>2]|0,e);if((b[n>>0]|0)<0)O5b(f[e>>2]|0);continue a}while(0);wIb(a);continue a;break}case 117:{wIb(a);A=b[g>>0]|0;if((A+-48&255)<10)z=24;else switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:{z=24;break}default:{}}c:do if((z|0)==24){z=0;wIb(a);A=b[g>>0]|0;if((A+-48&255)>=10)switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break c}wIb(a);A=b[g>>0]|0;if((A+-48&255)>=10)switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break c}wIb(a);A=b[g>>0]|0;if((A+-48&255)>=10)switch(A<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break c}wIb(a);continue a}while(0);A=L5b(64)|0;f[e>>2]=A;f[o>>2]=-2147483584;f[p>>2]=48;C=A;D=470487;E=C+48|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[A+48>>0]=0;F=f[k>>2]|0;th[f[(f[F>>2]|0)+8>>2]&511](F,f[l>>2]|0,f[m>>2]|0,e);if((b[q>>0]|0)<0)O5b(f[e>>2]|0);continue a;break}case 85:{wIb(a);d:do if((b[g>>0]|0)==48?(wIb(a),(b[g>>0]|0)==48):0){wIb(a);switch(b[g>>0]|0){case 48:{wIb(a);break}case 49:{wIb(a);break}default:break d}F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}wIb(a);F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}wIb(a);F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}wIb(a);F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}wIb(a);F=b[g>>0]|0;if((F+-48&255)>=10)switch(F<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:break d}wIb(a);continue a}while(0);A=L5b(64)|0;f[e>>2]=A;f[r>>2]=-2147483584;f[s>>2]=61;C=A;D=470536;E=C+61|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[A+61>>0]=0;F=f[k>>2]|0;th[f[(f[F>>2]|0)+8>>2]&511](F,f[l>>2]|0,f[m>>2]|0,e);if((b[t>>0]|0)<0)O5b(f[e>>2]|0);continue a;break}default:{F=L5b(48)|0;f[e>>2]=F;f[v>>2]=-2147483600;f[w>>2]=42;C=F;D=470598;E=C+42|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[F+42>>0]=0;A=f[k>>2]|0;th[f[(f[A>>2]|0)+8>>2]&511](A,f[l>>2]|0,f[m>>2]|0,e);if((b[x>>0]|0)<0)O5b(f[e>>2]|0);continue a}}break}default:{wIb(a);if(y<<24>>24==c<<24>>24){z=57;break a}else continue a}}}if((z|0)==3){c=L5b(32)|0;f[e>>2]=c;f[e+8>>2]=-2147483616;f[e+4>>2]=25;C=c;D=470374;E=C+25|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[c+25>>0]=0;c=f[k>>2]|0;th[f[(f[c>>2]|0)+8>>2]&511](c,f[l>>2]|0,f[m>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);u=d;return}else if((z|0)==7){c=L5b(48)|0;f[e>>2]=c;f[e+8>>2]=-2147483600;f[e+4>>2]=45;C=c;D=470400;E=C+45|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));b[c+45>>0]=0;c=f[k>>2]|0;th[f[(f[c>>2]|0)+8>>2]&511](c,f[l>>2]|0,f[m>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);u=d;return}else if((z|0)==57){u=d;return}}function yIb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+64|0;i=b[h>>0]|0;a:do if(c){switch(i<<24>>24){case 120:{wIb(a);break}case 88:{wIb(a);break}default:{if((i+-48&255)>=10){j=20;break a}if((i&-8)<<24>>24==48){do{wIb(a);k=b[h>>0]|0}while((k&-8)<<24>>24==48);l=k}else l=i;if((l+-48&255)>=10){m=0;break a}k=L5b(64)|0;f[g>>2]=k;f[g+8>>2]=-2147483584;f[g+4>>2]=52;n=k;o=470678;p=n+52|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[k+52>>0]=0;q=f[a+60>>2]|0;th[f[(f[q>>2]|0)+8>>2]&511](q,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if(((b[h>>0]|0)+-48&255)>=10){m=0;break a}while(1){wIb(a);if(((b[h>>0]|0)+-48&255)>=10){m=0;break a}}}}k=b[h>>0]|0;b:do if((k+-48&255)>=10){switch(k<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:{break b;break}default:{}}q=L5b(48)|0;f[g>>2]=q;f[g+8>>2]=-2147483600;f[g+4>>2]=36;n=q;o=470641;p=n+36|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[q+36>>0]=0;r=f[a+60>>2]|0;th[f[(f[r>>2]|0)+8>>2]&511](r,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);m=0;break a}while(0);while(1){wIb(a);k=b[h>>0]|0;if((k+-48&255)<10)continue;switch(k<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:{m=0;break a}}}}else j=20;while(0);c:do if((j|0)==20){if((i+-48&255)<10){do{wIb(a);l=b[h>>0]|0}while((l+-48&255)<10);s=l}else s=i;if(!d)if(s<<24>>24==46){wIb(a);l=b[h>>0]|0;if((l+-48&255)<10){do{wIb(a);c=b[h>>0]|0}while((c+-48&255)<10);t=1;v=c}else{t=1;v=l}}else{t=0;v=s}else{t=1;v=s}switch(v<<24>>24){case 101:{wIb(a);j=29;break}case 69:{wIb(a);j=29;break}default:w=t}d:do if((j|0)==29){switch(b[h>>0]|0){case 45:{wIb(a);break}case 43:{wIb(a);break}default:{}}if(((b[h>>0]|0)+-48&255)<10)while(1){wIb(a);if(((b[h>>0]|0)+-48&255)>=10){w=1;break d}}q=L5b(48)|0;f[g>>2]=q;f[g+8>>2]=-2147483600;f[g+4>>2]=33;n=q;o=470731;p=n+33|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[q+33>>0]=0;c=f[a+60>>2]|0;th[f[(f[c>>2]|0)+8>>2]&511](c,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);w=1}while(0);if(!(b[a+100>>0]|0))m=w;else switch(b[h>>0]|0){case 102:{wIb(a);m=1;break c;break}case 70:{wIb(a);m=1;break c;break}default:{m=w;break c}}}while(0);w=b[h>>0]|0;if(w<<24>>24==95|((w&-33)+-65&255)<26?b[a+108>>0]|0:0){h=L5b(48)|0;f[g>>2]=h;f[g+8>>2]=-2147483600;f[g+4>>2]=41;n=h;o=470765;p=n+41|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[h+41>>0]=0;h=f[a+60>>2]|0;th[f[(f[h>>2]|0)+8>>2]&511](h,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);x=m?4:3;u=e;return x|0}if(w<<24>>24!=46){x=m?4:3;u=e;return x|0}if(m){w=L5b(64)|0;f[g>>2]=w;f[g+8>>2]=-2147483584;f[g+4>>2]=62;n=w;o=470807;p=n+62|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[w+62>>0]=0;w=f[a+60>>2]|0;th[f[(f[w>>2]|0)+8>>2]&511](w,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);x=m?4:3;u=e;return x|0}else{w=L5b(48)|0;f[g>>2]=w;f[g+8>>2]=-2147483600;f[g+4>>2]=39;n=w;o=470870;p=n+39|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));b[w+39>>0]=0;w=f[a+60>>2]|0;th[f[(f[w>>2]|0)+8>>2]&511](w,f[a+84>>2]|0,f[a+88>>2]|0,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);x=m?4:3;u=e;return x|0}return 0}function zIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=u;u=u+16|0;e=d;g=a+84|0;h=f[g>>2]|0;i=a+88|0;j=(f[i>>2]|0)+-2|0;k=(c|0)!=0;if(k){l=a+92|0;f[l>>2]=c;m=a+76|0;n=a+96|0;f[n>>2]=f[m>>2];o=l;p=n;q=m}else{o=a+92|0;p=a+96|0;q=a+76|0}m=a+64|0;n=a+68|0;l=e+8|0;r=e+4|0;s=a+60|0;t=e+11|0;while(1){a:while(1){v=b[m>>0]|0;switch(v<<24>>24){case 10:{w=8;break a;break}case 42:{w=19;break a;break}case 47:{w=27;break a;break}case 0:{x=v;break a;break}default:{}}wIb(a)}if((w|0)==8){w=0;wIb(a);if(k){v=f[q>>2]|0;y=f[p>>2]|0;if((v|0)!=(y|0))j6b(f[o>>2]|0,(f[n>>2]|0)+y|0,v-y|0)|0;f[o>>2]=0;f[p>>2]=-1}y=b[m>>0]|0;v=y+-9<<24>>24;if((v&255)>23|(8388637>>>(v&255)&1|0)==0)z=y;else{do{wIb(a);y=b[m>>0]|0;v=y+-9<<24>>24}while(!((v&255)>23|(8388637>>>(v&255)&1|0)==0));z=y}if(z<<24>>24==42?(wIb(a),(b[m>>0]|0)==47):0){w=16;break}if(!k)continue;f[o>>2]=c;f[p>>2]=f[q>>2];continue}else if((w|0)==19){w=0;wIb(a);y=b[m>>0]|0;if(y<<24>>24==47){w=20;break}else x=y}else if((w|0)==27){w=0;wIb(a);y=b[m>>0]|0;if(y<<24>>24==42){v=L5b(64)|0;f[e>>2]=v;f[l>>2]=-2147483584;f[r>>2]=60;A=v;B=470910;C=A+60|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[v+60>>0]=0;D=f[s>>2]|0;th[f[(f[D>>2]|0)+8>>2]&511](D,f[g>>2]|0,f[i>>2]|0,e);if((b[t>>0]|0)<0)O5b(f[e>>2]|0);continue}else x=y}if(!(x<<24>>24)){w=32;break}}if((w|0)==16){wIb(a);u=d;return}else if((w|0)==20){wIb(a);if(!k){u=d;return}a=f[q>>2]|0;x=f[p>>2]|0;if((a|0)!=(x|0))j6b(f[o>>2]|0,(f[n>>2]|0)+x|0,a-x|0)|0;f[o>>2]=0;f[p>>2]=-1;x=b[c+11>>0]|0;if(x<<24>>24<0)E=f[c+4>>2]|0;else E=x&255;o6b(c,E+-2|0,-1)|0;u=d;return}else if((w|0)==32){w=L5b(48)|0;f[e>>2]=w;f[e+8>>2]=-2147483600;f[e+4>>2]=33;A=w;B=470971;C=A+33|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[w+33>>0]=0;w=f[s>>2]|0;th[f[(f[w>>2]|0)+8>>2]&511](w,f[g>>2]|0,f[i>>2]|0,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);i=f[s>>2]|0;s=f[(f[i>>2]|0)+8>>2]|0;g=L5b(32)|0;f[e>>2]=g;f[e+8>>2]=-2147483616;f[e+4>>2]=23;A=g;B=471005;C=A+23|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));b[g+23>>0]=0;th[s&511](i,h,j,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);if(!k){u=d;return}k=f[q>>2]|0;q=f[p>>2]|0;if((k|0)!=(q|0))j6b(f[o>>2]|0,(f[n>>2]|0)+q|0,k-q|0)|0;f[o>>2]=0;f[p>>2]=-1;u=d;return}}function AIb(a){a=a|0;var c=0,d=0;switch(f[a+104>>2]|0){case 0:{c=a+64|0;if((b[c>>0]|0)!=47){d=3;return d|0}wIb(a);switch(b[c>>0]|0){case 47:{wIb(a);d=0;return d|0}case 42:{wIb(a);d=1;return d|0}default:{f[a>>2]=6;d6b(a+4|0,489196)|0;f[a+16>>2]=f[a+84>>2];c=f[a+88>>2]|0;f[a+20>>2]=c+-1;f[a+24>>2]=c;d=2;return d|0}}break}case 1:{if((b[a+64>>0]|0)!=35){d=3;return d|0}wIb(a);d=0;return d|0}default:{d=3;return d|0}}return 0}function BIb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=u;u=u+16|0;d=c;e=c+4|0;g=a+28|0;f[g>>2]=f[a>>2];h=a+4|0;_5b(a+32|0,h)|0;i=a+44|0;j=a+16|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];k=a+80|0;a:do if(!(b[k>>0]|0)){l=a+64|0;m=e+8|0;n=e+4|0;o=a+60|0;p=a+84|0;q=a+88|0;r=e+11|0;b:while(1){s=(b[l>>0]|0)+-9<<24>>24;if(!((s&255)>23|(8388639>>>(s&255)&1|0)==0))do{wIb(a);s=(b[l>>0]|0)+-9<<24>>24}while(!((s&255)>23|(8388639>>>(s&255)&1|0)==0));c:do switch(AIb(a)|0){case 2:{t=1;v=59;break b;break}case 0:{d:while(1){switch(b[l>>0]|0){case 0:{break c;break}case 10:{break d;break}default:{}}wIb(a)}wIb(a);break}case 1:{zIb(a,0);break}default:{if(b[k>>0]|0){v=54;break a}w=b[l>>0]|0;if(!((w+-1&255)<31|w<<24>>24==0))break b;s=L5b(48)|0;f[e>>2]=s;f[m>>2]=-2147483600;f[n>>2]=47;x=s;y=471029;z=x+47|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[s+47>>0]=0;A=f[o>>2]|0;th[f[(f[A>>2]|0)+8>>2]&511](A,f[p>>2]|0,f[q>>2]|0,e);if((b[r>>0]|0)<0)O5b(f[e>>2]|0);wIb(a);while(1){A=b[l>>0]|0;if((A+-1&255)<31){wIb(a);continue}if(b[k>>0]|0){v=54;break a}if(A<<24>>24)break c;wIb(a)}}}while(0);if(b[k>>0]|0){v=54;break a}}if((v|0)==59){u=c;return t|0}f[a>>2]=0;r=h+11|0;if((b[r>>0]|0)<0){b[f[h>>2]>>0]=0;f[a+8>>2]=0;B=b[l>>0]|0}else{b[h>>0]=0;b[r>>0]=0;B=w}f[j>>2]=f[p>>2];r=a+20|0;f[r>>2]=f[q>>2];n=a+92|0;f[n>>2]=h;m=a+76|0;s=a+96|0;f[s>>2]=f[m>>2];e:do if(B<<24>>24==95|((B&-33)+-65&255)<26){wIb(a);A=b[l>>0]|0;if(((A&-33)+-65&255)<26|(A<<24>>24==95|(A+-48&255)<10)){do{wIb(a);A=b[l>>0]|0}while(((A&-33)+-65&255)<26|(A<<24>>24==95|(A+-48&255)<10));C=2}else C=2}else{switch(B<<24>>24){case 48:{wIb(a);C=yIb(a,1,0)|0;break e;break}case 46:{wIb(a);D=1;E=b[l>>0]|0;break}default:{D=0;E=B}}if((E+-48&255)<10){wIb(a);F=1}else F=0;if(D){if(!F){C=6;break}if(((f[g>>2]|0)==2?(f[j>>2]|0)==(f[i>>2]|0):0)?(f[r>>2]|0)==(f[a+52>>2]|0):0){A=f[o>>2]|0;G=f[(f[A>>2]|0)+8>>2]|0;H=f[p>>2]|0;I=(f[q>>2]|0)+-2|0;J=L5b(64)|0;f[e>>2]=J;f[e+8>>2]=-2147483584;f[e+4>>2]=48;x=J;y=471077;z=x+48|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));b[J+48>>0]=0;th[G&511](A,H,I,e);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0)}C=yIb(a,0,1)|0;break}if(F){C=yIb(a,0,0)|0;break}K=b[l>>0]|0;switch(K<<24>>24){case 34:{wIb(a);xIb(a,34);C=5;break e;break}case 39:{wIb(a);xIb(a,39);C=5;break e;break}default:{if(K<<24>>24<0?(L=f[o>>2]|0,M=f[(f[L>>2]|0)+8>>2]|0,N=f[p>>2]|0,O=f[q>>2]|0,f[d>>2]=K&255,gSb(e,471126,d),th[M&511](L,N,O,e),(b[e+11>>0]|0)<0):0)O5b(f[e>>2]|0);wIb(a);C=6;break e}}}while(0);f[a>>2]=C;p=f[m>>2]|0;o=f[s>>2]|0;if((p|0)!=(o|0))j6b(f[n>>2]|0,(f[a+68>>2]|0)+o|0,p-o|0)|0;f[n>>2]=0;f[s>>2]=-1;P=1;Q=f[q>>2]|0}else v=54;while(0);if((v|0)==54){f[a>>2]=1;v=h+11|0;if((b[v>>0]|0)<0){b[f[h>>2]>>0]=0;f[a+8>>2]=0}else{b[h>>0]=0;b[v>>0]=0}f[j>>2]=f[a+84>>2];j=f[a+88>>2]|0;f[a+20>>2]=j;P=0;Q=j}f[a+24>>2]=Q;t=P;u=c;return t|0}function CIb(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=(b[a+11>>0]|0)<0?f[a>>2]|0:a;a=b[g>>0]|0;a:do if(a<<24>>24==48){switch(b[g+1>>0]|0){case 88:case 120:break;default:{h=8;i=g;j=48;k=5;break a}}l=g+2|0;m=16;n=l;o=b[l>>0]|0;k=4}else{m=10;n=g;o=a;k=4}while(0);if((k|0)==4)if(!(o<<24>>24)){p=0;q=0}else{h=m;i=n;j=o;k=5}b:do if((k|0)==5){o=i;n=j;m=0;a=0;while(1){g=n<<24>>24;if((n+-48&255)>=10)if((n+-97&255)<26){r=-87;k=9}else s=(n+-65&255)<26?g+-55|0:-1;else{r=-48;k=9}if((k|0)==9){k=0;s=r+g|0}if(s>>>0>=h>>>0){t=0;k=15;break}g=((s|0)<0)<<31>>31;if(g>>>0>d>>>0|(g|0)==(d|0)&s>>>0>c>>>0){t=0;k=15;break}l=Jac(c|0,d|0,s|0,g|0)|0;u=Uac(l|0,J|0,h|0,0)|0;l=J;if(m>>>0>l>>>0|(m|0)==(l|0)&a>>>0>u>>>0){t=0;k=15;break}u=cbc(a|0,m|0,h|0,0)|0;l=Kac(s|0,g|0,u|0,J|0)|0;u=J;o=o+1|0;n=b[o>>0]|0;if(!(n<<24>>24)){p=l;q=u;break b}else{m=u;a=l}}if((k|0)==15)return t|0}while(0);k=e;f[k>>2]=p;f[k+4>>2]=q;t=1;return t|0}function DIb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+48|0;d=c+36|0;e=c;g=c+24|0;h=c+40|0;i=a+11|0;j=(b[i>>0]|0)<0?f[a>>2]|0:a;k=+qIb(j,d);l=f[d>>2]|0;m=b[l>>0]|0;a:do switch(m<<24>>24){case 69:case 101:{n=l+1|0;f[d>>2]=n;o=b[n>>0]|0;switch(o<<24>>24){case 43:case 45:break;default:{p=n;q=o;break a}}o=l+2|0;f[d>>2]=o;p=o;q=b[o>>0]|0;break}default:{p=l;q=m}}while(0);switch(q<<24>>24){case 70:case 102:{q=p+1|0;f[d>>2]=q;r=q;break}default:r=p}p=b[i>>0]|0;if((r-j|0)==((p<<24>>24<0?f[a+4>>2]|0:p&255)|0)?(b[j>>0]|0)!=45:0){u=c;return +k}zpb(e,2,471163,919);j=vpb(e,471257)|0;pSb(g,a);xpb(h,wpb(j,g)|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);Apb(e);u=c;return +k}function EIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;d=u;u=u+48|0;e=d;g=d+32|0;h=d+8|0;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[a+4>>2]|0:j&255;if(!k){zpb(h,2,471163,1044);l=vpb(h,471342)|0;pSb(g,a);xpb(d+44|0,wpb(l,g)|0);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);Apb(h);u=d;return}h=b[c+11>>0]|0;if(h<<24>>24<0){m=f[c+4>>2]|0;n=(f[c+8>>2]&2147483647)+-1|0}else{m=h&255;n=10}h=m+k|0;if(h>>>0>n>>>0){c6b(c,h);o=b[i>>0]|0}else o=j;j=g+4|0;h=o<<24>>24<0?f[a>>2]|0:a;a:while(1){o=h+1|0;n=b[o>>0]|0;switch(n<<24>>24){case 0:{break a;break}case 92:{k=h+2|0;m=b[k>>0]|0;if(m<<24>>24){if((m&-8)<<24>>24==48){l=m<<24>>24;if((m+-48&255)>=10)if((m+-97&255)<26){p=-87;q=17}else r=(m+-65&255)<26?l+-55|0:-1;else{p=-48;q=17}if((q|0)==17){q=0;r=p+l|0}l=h+3|0;s=b[l>>0]|0;if((s&-8)<<24>>24==48){t=r<<3;v=s<<24>>24;if((s+-48&255)>=10)if((s+-97&255)<26){w=-87;q=22}else x=(s+-65&255)<26?v+-55|0:-1;else{w=-48;q=22}if((q|0)==22){q=0;x=w+v|0}y=x+t|0;z=l}else{y=r;z=k}l=z+1|0;t=b[l>>0]|0;if((t&-8)<<24>>24==48){v=y<<3;s=t<<24>>24;if((t+-48&255)>=10)if((t+-97&255)<26){A=-87;q=28}else B=(t+-65&255)<26?s+-55|0:-1;else{A=-48;q=28}if((q|0)==28){q=0;B=A+s|0}C=B+v|0;D=l}else{C=y;D=z}l6b(c,C&255);h=D;continue a}switch(m<<24>>24){case 120:{l=h+3|0;v=b[l>>0]|0;b:do if((v+-48&255)>=10){switch(v<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:{E=0;F=k;break b}}s=v<<24>>24;if((v+-97&255)<26){G=-87;H=s;q=37}else{E=(v+-65&255)<26?s+-55|0:-1;F=l}}else{G=-48;H=v<<24>>24;q=37}while(0);if((q|0)==37){q=0;E=G+H|0;F=l}v=F+1|0;s=b[v>>0]|0;c:do if((s+-48&255)>=10){switch(s<<24>>24){case 65:case 66:case 67:case 68:case 69:case 70:case 97:case 98:case 99:case 100:case 101:case 102:break;default:{I=E;J=F;break c}}t=E<<4;K=s<<24>>24;if((s+-97&255)<26){L=-87;M=t;N=K;q=43}else{O=t;P=(s+-65&255)<26?K+-55|0:-1;q=44}}else{L=-48;M=E<<4;N=s<<24>>24;q=43}while(0);if((q|0)==43){q=0;O=M;P=L+N|0;q=44}if((q|0)==44){q=0;I=P+O|0;J=v}l6b(c,I&255);h=J;continue a;break}case 85:case 117:{s=h+3|0;l=m<<24>>24==117?4:m<<24>>24==85?8:0;d:do if(l|0){K=s+l|0;t=s;Q=0;do{R=b[t>>0]|0;if(!(R<<24>>24))break d;S=Q<<4;T=R<<24>>24;if((R+-48&255)>=10)if((R+-97&255)<26){U=-87;q=52}else V=(R+-65&255)<26?T+-55|0:-1;else{U=-48;q=52}if((q|0)==52){q=0;V=U+T|0}Q=V+S|0;t=t+1|0}while(t>>>0<K>>>0);do if((((Q&-1024|0)==55296?(b[K>>0]|0)==92:0)?(b[K+1>>0]|0)==117:0)?(t=b[K+2>>0]|0,t<<24>>24!=0):0){S=t<<24>>24;if((t+-48&255)>=10)if((t+-97&255)<26){W=-87;q=61}else X=(t+-65&255)<26?S+-55|0:-1;else{W=-48;q=61}if((q|0)==61){q=0;X=W+S|0}S=b[K+3>>0]|0;if(S<<24>>24){t=X<<4;T=S<<24>>24;if((S+-48&255)>=10)if((S+-97&255)<26){Y=-87;q=66}else Z=(S+-65&255)<26?T+-55|0:-1;else{Y=-48;q=66}if((q|0)==66){q=0;Z=Y+T|0}T=b[K+4>>0]|0;if(T<<24>>24){S=Z+t<<4;t=T<<24>>24;do if((T+-48&255)<10){_=-48;q=71}else{if((T+-97&255)<26){_=-87;q=71;break}$=(T+-65&255)<26?t+-55|0:-1}while(0);if((q|0)==71){q=0;$=_+t|0}T=b[K+5>>0]|0;if(!(T<<24>>24)){aa=K;ba=Q;break}R=$+S<<4;ca=T<<24>>24;do if((T+-48&255)<10){da=-48;q=76}else{if((T+-97&255)<26){da=-87;q=76;break}ea=(T+-65&255)<26?ca+-55|0:-1}while(0);if((q|0)==76){q=0;ea=da+ca|0}T=ea+R|0;S=(T&-1024|0)==56320;aa=S?K+6|0:K;ba=S?(T+-56320|(Q<<10)+-56623104)+65536|0:Q}else{aa=K;ba=Q}}else{aa=K;ba=Q}}else{aa=K;ba=Q}while(0);if((aa|0)!=(k|0)){f[g>>2]=0;do if(ba>>>0>=128){if(ba>>>0<2048){Q=ba&63|ba<<2&7936|49280;f[g>>2]=Q;fa=2;ga=Q;q=89;break}if(ba>>>0<65536){Q=ba&63|ba<<2&16128|ba<<4&983040|14712960;f[g>>2]=Q;fa=3;ga=Q;q=89;break}if(ba>>>0<2097152){Q=ba&63|ba<<4&4128768|ba<<6&117440512|ba<<2&16128|-260013952;f[g>>2]=Q;fa=4;ga=Q;q=89;break}else{f[e>>2]=ba;hSb(c,471435,e);break}}else{f[g>>2]=ba;fa=1;ga=ba;q=89}while(0);if((q|0)==89){q=0;Q=Epb(ga)|0;f[g>>2]=Q;j6b(c,j+(0-fa)|0,fa)|0}h=aa+-1|0;continue a}}while(0);l6b(c,m);h=k;continue a;break}default:{do switch(m<<24>>24|0){case 97:{ha=7;break}case 98:{ha=8;break}case 102:{ha=12;break}case 110:{ha=10;break}case 114:{ha=13;break}case 116:{ha=9;break}case 118:{ha=11;break}case 92:{ha=92;break}case 63:{ha=63;break}case 39:{ha=39;break}case 34:{ha=34;break}default:ha=63}while(0);l6b(c,ha);h=k;continue a}}}break}default:{}}if(n<<24>>24==(b[((b[i>>0]|0)<0?f[a>>2]|0:a)>>0]|0)?(b[h+2>>0]|0)==0:0){h=o;continue}l6b(c,n);h=o}u=d;return}function FIb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c;e=b[a+11>>0]|0;if(!((e<<24>>24<0?f[a+4>>2]|0:e&255)|0)){g=0;u=c;return g|0}e=h6b(a,0)|0;h=b[e>>0]|0;if(!(h<<24>>24==95|((h&-33)+-65&255)<26)){g=0;u=c;return g|0}Y5b(d,a,1,-1,a);a=b[d+11>>0]|0;h=a<<24>>24<0;e=h?f[d+4>>2]|0:a&255;a:do if(!e)i=1;else{a=h?f[d>>2]|0:d;j=0;while(1){k=b[a+j>>0]|0;j=j+1|0;if(!(((k&-33)+-65&255)<26|(k<<24>>24==95|(k+-48&255)<10))){i=0;break a}if(j>>>0>=e>>>0){i=1;break}}}while(0);if(h)O5b(f[d>>2]|0);g=i;u=c;return g|0}function GIb(a){a=a|0;f[a>>2]=140092;Cob(a+16|0);return}function HIb(a){a=a|0;f[a>>2]=140092;Cob(a+16|0);O5b(a);return}function IIb(a,b,c){a=a|0;b=b|0;c=c|0;return Eob(a+16|0,b,c)|0}function JIb(a,b){a=a|0;b=b|0;Fob(a+16|0,b);return}function KIb(a,b){a=a|0;b=b|0;return Gob(a+16|0,b)|0}function LIb(a){a=a|0;var b=0;b=Hob(a+16|0)|0;return b|0}function MIb(a){a=a|0;return}function NIb(a){a=a|0;O5b(a);return}function OIb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=a+4|0;dYb(f[d>>2]|0,b,c)|0;c=f[d>>2]|0;d=f[c+4>>2]|0;if((d|0)==0?(b=f[c+(f[(f[c>>2]|0)+-12>>2]|0)+16>>2]|0,!((b&5|0)==0|(b&2|0)!=0)):0){e=-1;return e|0}e=d;return e|0}function PIb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;f[a>>2]=140092;d=a+4|0;f[d>>2]=140124;f[a+8>>2]=b;Oob(a+16|0,d,c);return}function QIb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=140148;b=f[a+8>>2]|0;if(b|0?(f[a+4>>2]|0)==0:0){c=b+12|0;d=f[c>>2]|0;if(d|0?(f[b>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0)bi[f[(f[h>>2]|0)+4>>2]&2047](h);g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}O5b(b)}Cpb(a+20|0);return}function RIb(a){a=a|0;QIb(a);O5b(a);return}function SIb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a+8>>2]|0;if(!b){c=0;return c|0}a=f[b+8>>2]<<2;d=b+12|0;b=f[d>>2]|0;if(!b){c=a;return c|0}if((f[b>>2]|0)>0){e=0;g=a;h=b;while(1){b=f[h+4+(e<<2)>>2]|0;i=(di[f[(f[b>>2]|0)+84>>2]&1023](b)|0)+g|0;e=e+1|0;h=f[d>>2]|0;if((e|0)>=(f[h>>2]|0)){j=i;break}else g=i}}else j=a;c=j+4|0;return c|0}function TIb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+16|0;c=b;d=a+8|0;if(f[d>>2]|0){u=b;return}e=f[a+4>>2]|0;if(e){f[c>>2]=0;a=pDa(c)|0;c=znb(e,18456,16)|0;f[c>>2]=e;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if(a)g=c;else{xnb(e,c,1492);g=c}}else{c=L5b(16)|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;g=c}f[d>>2]=g;u=b;return}function UIb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=u;u=u+32|0;d=c;f[a>>2]=140220;e=a+28|0;g=a+36|0;h=b[g>>0]|0;if(!(h<<24>>24)){i=f[a+40>>2]|0;j=f[i+12>>2]|0;k=f[i+4>>2]|0;a:do if(k>>>0>j>>>0){l=f[i+16>>2]|0;m=j;while(1){n=f[l+(m<<2)>>2]|0;if(n|0)break;o=m+1|0;if(o>>>0<k>>>0)m=o;else{p=0;q=o;r=0;break a}}if((n|0)==(f[l+((m^1)<<2)>>2]|0)){o=f[n>>2]|0;p=f[o+16>>2]|0;q=m;r=o;break}else{p=n;q=m;r=0;break}}else{p=0;q=j;r=0}while(0);f[d>>2]=2;j=d+4|0;f[j>>2]=p;f[d+8>>2]=i;f[d+12>>2]=q;f[d+16>>2]=r;r=d+20|0;f[r>>2]=0;q=d+20|0;s=d+4|0;t=r;v=q;w=q;x=j;y=d;z=2}else{j=f[(f[a+40>>2]|0)+12>>2]|0;f[d>>2]=1;q=d+4|0;f[q>>2]=0;r=d+20|0;f[r>>2]=j;s=q;t=d+20|0;v=r;w=r;x=d+4|0;y=d;z=1}d=z;z=h;b:while(1){c:do if((d|0)==((z<<24>>24==0?2:1)|0))switch(d|0){case 0:{A=16;break b;break}case 1:{if(!(f[t>>2]|0)){A=16;break b}else break c;break}default:if(!(f[s>>2]|0)){A=16;break b}else break c}while(0);xJb((f[((d|0)==1?(f[v>>2]|0)+24|0:(f[s>>2]|0)+16|0)>>2]|0)+16|0);if((f[y>>2]|0)==1){f[w>>2]=f[f[v>>2]>>2];B=1}else{yJb(x)|0;B=f[y>>2]|0}d=B;z=b[g>>0]|0}if((A|0)==16){wJb(e);iKb(e);QIb(a);u=c;return}}function VIb(a){a=a|0;UIb(a);O5b(a);return}function WIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d;g=di[f[(f[a>>2]|0)+64>>2]&1023](a)|0;a=g+8|0;if(!(b[a>>0]|0)){nJb(e,f[g+12>>2]|0,c);h=2;i=0;j=f[e>>2]|0}else{h=1;i=QJb(f[g+12>>2]|0,c)|0;j=0}if((h|0)!=(((b[a>>0]|0)==0?2:1)|0)){k=0;l=k^1;u=d;return l|0}switch(h&3){case 1:{k=(i|0)==0;l=k^1;u=d;return l|0}case 0:{k=1;l=k^1;u=d;return l|0}default:{k=(j|0)==0;l=k^1;u=d;return l|0}}return 0}function XIb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=u;u=u+32|0;g=e;h=di[f[(f[a>>2]|0)+68>>2]&1023](a)|0;i=h+8|0;if(!(b[i>>0]|0)){nJb(g,f[h+12>>2]|0,c);j=2;k=0;l=f[g>>2]|0}else{j=1;k=QJb(f[h+12>>2]|0,c)|0;l=0}m=(b[i>>0]|0)==0;a:do if((j|0)!=((m?2:1)|0))if((j|0)==1)o=28;else o=29;else{switch(j&3){case 0:break;case 1:{if(k|0){o=28;break a}break}default:if(l|0){o=29;break a}}i=h+12|0;if(m)q=AJb(f[i>>2]|0,c)|0;else q=zJb(f[i>>2]|0,c)|0;i=f[q>>2]|0;if(!i){r=BJb(h,c)|0;f[q>>2]=r;s=r}else s=i;i=s+16|0;r=a+44|0;t=f[r>>2]|0;zh[f[(f[t>>2]|0)+96>>2]&2047](g,t);t=f[g>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;v=g+11|0;b[v>>0]=5;b[g>>0]=b[471917]|0;b[g+1>>0]=b[471918]|0;b[g+2>>0]=b[471919]|0;b[g+3>>0]=b[471920]|0;b[g+4>>0]=b[471921]|0;b[g+5>>0]=0;w=rub(t,g)|0;if((b[v>>0]|0)<0)O5b(f[g>>2]|0);v=f[136e3+(f[w+32>>2]<<2)>>2]|0;t=s+20|0;f[t>>2]=v;do switch(v|0){case 1:{x=L5b(4)|0;f[x>>2]=0;y=x;break}case 2:{x=L5b(8)|0;z=x;f[z>>2]=0;f[z+4>>2]=0;y=x;break}case 3:{x=L5b(4)|0;f[x>>2]=0;y=x;break}case 4:{x=L5b(8)|0;z=x;f[z>>2]=0;f[z+4>>2]=0;y=x;break}case 5:{x=L5b(8)|0;p[x>>3]=0.0;y=x;break}case 6:{x=L5b(4)|0;n[x>>2]=0.0;y=x;break}case 7:{x=L5b(1)|0;b[x>>0]=0;y=x;break}case 9:{x=L5b(12)|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;y=x;break}case 8:{x=L5b(4)|0;f[x>>2]=0;y=x;break}case 10:{x=f[r>>2]|0;z=di[f[(f[x>>2]|0)+92>>2]&1023](x)|0;x=Dg[f[(f[z>>2]|0)+108>>2]&127](z,f[r>>2]|0,w,0)|0;y=di[f[(f[x>>2]|0)+12>>2]&1023](x)|0;break}default:{A=1;B=t;C=i;D=f[B>>2]|0;E=d+4|0;f[E>>2]=D;F=f[C>>2]|0;f[d>>2]=F;u=e;return A|0}}while(0);f[i>>2]=y;A=1;B=t;C=i;D=f[B>>2]|0;E=d+4|0;f[E>>2]=D;F=f[C>>2]|0;f[d>>2]=F;u=e;return A|0}while(0);if((o|0)==28)G=k+24|0;else if((o|0)==29)G=l+16|0;l=f[G>>2]|0;A=0;B=l+20|0;C=l+16|0;D=f[B>>2]|0;E=d+4|0;f[E>>2]=D;F=f[C>>2]|0;f[d>>2]=F;u=e;return A|0}function YIb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+80|0;e=d+48|0;g=d+24|0;h=d;i=a+24|0;if((f[i>>2]|0)==1){j=a+20|0;npb(j);if((f[i>>2]|0)==1){bi[f[(f[a>>2]|0)+44>>2]&2047](a);f[i>>2]=2}opb(j)}j=a+28|0;k=a+36|0;if(!(b[k>>0]|0)){nJb(e,f[a+40>>2]|0,c);l=2;m=f[e+4>>2]|0;n=f[e+8>>2]|0;o=f[e+12>>2]|0;p=0;q=f[e>>2]|0}else{l=1;m=0;n=0;o=0;p=QJb(f[a+40>>2]|0,c)|0;q=0}a:do if((l|0)!=(((b[k>>0]|0)==0?2:1)|0)){f[i>>2]=0;if((l|0)==1)r=15;else r=16}else switch(l&3){case 1:{if(!p){s=0;u=d;return s|0}else{f[i>>2]=0;r=15;break a}break}case 0:{s=0;u=d;return s|0}default:if(!q){s=0;u=d;return s|0}else{f[i>>2]=0;r=16;break a}}while(0);if((r|0)==15)t=p+24|0;else if((r|0)==16)t=q+16|0;xJb((f[t>>2]|0)+16|0);f[g>>2]=l;f[g+4>>2]=q;f[g+8>>2]=m;f[g+12>>2]=n;f[g+16>>2]=o;f[g+20>>2]=p;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[e+16>>2]=f[g+16>>2];f[e+20>>2]=f[g+20>>2];UJb(h,j,e);s=1;u=d;return s|0}function ZIb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=f[b>>2]|0;b=f[c>>2]|0;c=f[a>>2]|0;if((c|0)!=(f[b>>2]|0)){d=0;return d|0}switch(c|0){case 1:{d=(f[a+20>>2]|0)==(f[b+20>>2]|0);return d|0}case 0:{d=1;return d|0}default:{d=(f[a+4>>2]|0)==(f[b+4>>2]|0);return d|0}}return 0}function _Ib(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=di[f[(f[a>>2]|0)+64>>2]&1023](a)|0;if(!(b[d+8>>0]|0)){e=f[d+12>>2]|0;g=f[e+12>>2]|0;h=f[e+4>>2]|0;a:do if(h>>>0>g>>>0){i=f[e+16>>2]|0;j=g;while(1){k=f[i+(j<<2)>>2]|0;if(k|0)break;l=j+1|0;if(l>>>0<h>>>0)j=l;else{m=0;n=l;o=0;break a}}if((k|0)==(f[i+((j^1)<<2)>>2]|0)){l=f[k>>2]|0;m=f[l+16>>2]|0;n=j;o=l;break}else{m=k;n=j;o=0;break}}else{m=0;n=g;o=0}while(0);p=2;q=0;r=m;s=e;t=n;u=o}else{p=1;q=f[(f[d+12>>2]|0)+12>>2]|0;r=0;s=0;t=0;u=0}d=f[c>>2]|0;f[d>>2]=p;f[d+4>>2]=r;f[d+8>>2]=s;f[d+12>>2]=t;f[d+16>>2]=u;f[d+20>>2]=q;zh[f[(f[a>>2]|0)+72>>2]&2047](a,c);return}function $Ib(a,c){a=a|0;c=c|0;var d=0;d=(di[f[(f[a>>2]|0)+64>>2]&1023](a)|0)+8|0;a=f[c>>2]|0;f[a>>2]=(b[d>>0]|0)==0?2:1;f[a+4>>2]=0;f[a+20>>2]=0;return}function aJb(a){a=a|0;var c=0;c=di[f[(f[a>>2]|0)+64>>2]&1023](a)|0;a=f[c+12>>2]|0;return f[((b[c+8>>0]|0)==0?a:a+20|0)>>2]|0}function bJb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=u;u=u+32|0;d=c;e=f[a+8>>2]|0;if(!e)g=16;else{h=f[e+8>>2]<<2;i=e+12|0;e=f[i>>2]|0;if(!e)j=h;else{if((f[e>>2]|0)>0){k=0;l=h;m=e;while(1){e=f[m+4+(k<<2)>>2]|0;n=(di[f[(f[e>>2]|0)+84>>2]&1023](e)|0)+l|0;k=k+1|0;m=f[i>>2]|0;if((k|0)>=(f[m>>2]|0)){o=n;break}else l=n}}else o=h;j=o+4|0}g=j+16|0}j=a+36|0;o=(b[j>>0]|0)==0;h=a+40|0;if(o){a=f[h>>2]|0;p=a;q=a;r=a}else{a=f[h>>2]|0;p=a+20|0;q=a;r=a}a=f[p>>2]|0;if(!a){s=g;u=c;return s|0}if(o){o=f[q+12>>2]|0;p=f[q+4>>2]|0;a:do if(p>>>0>o>>>0){h=f[q+16>>2]|0;l=o;while(1){t=f[h+(l<<2)>>2]|0;if(t|0)break;m=l+1|0;if(m>>>0<p>>>0)l=m;else{v=0;w=m;x=0;break a}}if((t|0)==(f[h+((l^1)<<2)>>2]|0)){m=f[t>>2]|0;v=f[m+16>>2]|0;w=l;x=m;break}else{v=t;w=l;x=0;break}}else{v=0;w=o;x=0}while(0);f[d+4>>2]=v;f[d+8>>2]=q;f[d+12>>2]=w;f[d+16>>2]=x;f[d+20>>2]=0;f[d>>2]=2;y=d+4|0;z=d+20|0;A=d;B=2;C=v;D=0}else{v=f[r+12>>2]|0;f[d>>2]=1;r=d+4|0;f[r>>2]=0;x=d+20|0;f[x>>2]=v;y=r;z=x;A=d;B=1;C=0;D=v}v=a<<3;x=(B|0)==1;r=(oDa(f[(x?D+24|0:C+16|0)>>2]|0)|0)==9;w=a*12|0;q=(a<<4)+g+v+(r?w:0)|0;b:do switch(hKb((f[(x?D+24|0:C+16|0)>>2]|0)+16|0)|0){case 1:{E=q+(a<<2)|0;break}case 2:{E=q+v|0;break}case 3:{E=q+(a<<2)|0;break}case 4:{E=q+v|0;break}case 5:{E=q+v|0;break}case 6:{E=q+(a<<2)|0;break}case 7:{E=q+a|0;break}case 9:{E=q+w|0;break}case 8:{E=q+(a<<2)|0;break}case 10:{r=d+20|0;g=d+4|0;o=q;t=B;while(1){c:do if((t|0)==(((b[j>>0]|0)==0?2:1)|0))switch(t|0){case 0:{E=o;break b;break}case 1:{if(!(f[r>>2]|0)){E=o;break b}else break c;break}default:if(!(f[y>>2]|0)){E=o;break b}else break c}while(0);p=gKb((f[((t|0)==1?(f[z>>2]|0)+24|0:(f[y>>2]|0)+16|0)>>2]|0)+16|0)|0;m=di[f[(f[p>>2]|0)+92>>2]&1023](p)|0;k=(Uh[f[(f[m>>2]|0)+16>>2]&1023](m,p)|0)+o|0;if((f[A>>2]|0)==1){f[z>>2]=f[f[z>>2]>>2];o=k;t=1;continue}else{mJb(g)|0;o=k;t=f[A>>2]|0;continue}}break}default:E=q}while(0);s=E;u=c;return s|0}function cJb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0;c=u;u=u+64|0;d=c;e=c+32|0;g=c+8|0;h=c+56|0;i=a+44|0;j=f[i>>2]|0;k=di[f[(f[j>>2]|0)+92>>2]&1023](j)|0;j=f[i>>2]|0;zh[f[(f[j>>2]|0)+96>>2]&2047](e,j);j=f[e>>2]|0;l=e+4|0;f[l>>2]=0;f[l+4>>2]=0;l=e+11|0;b[l>>0]=3;b[e>>0]=b[471913]|0;b[e+1>>0]=b[471914]|0;b[e+2>>0]=b[471915]|0;b[e+3>>0]=0;m=rub(j,e)|0;if((b[l>>0]|0)<0)O5b(f[e>>2]|0);l=f[i>>2]|0;zh[f[(f[l>>2]|0)+96>>2]&2047](e,l);l=f[e>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+11|0;b[j>>0]=5;b[e>>0]=b[471917]|0;b[e+1>>0]=b[471918]|0;b[e+2>>0]=b[471919]|0;b[e+3>>0]=b[471920]|0;b[e+4>>0]=b[471921]|0;b[e+5>>0]=0;n=rub(l,e)|0;if((b[j>>0]|0)<0)O5b(f[e>>2]|0);j=a+8|0;l=f[j>>2]|0;if(!l){o=f[a+4>>2]|0;if(o){f[d>>2]=0;p=pDa(d)|0;d=znb(o,18456,16)|0;f[d>>2]=o;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if(p)q=d;else{xnb(o,d,1492);q=d}}else{d=L5b(16)|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;q=d}f[j>>2]=q;r=q}else r=l;l=r+4|0;q=f[l>>2]|0;if((q|0)>0){d=f[r+12>>2]|0;r=0;do{o=f[d+4+(r<<2)>>2]|0;r=r+1|0;bi[f[(f[o>>2]|0)+28>>2]&2047](o)}while((r|0)!=(q|0));f[l>>2]=0}l=a+36|0;q=b[l>>0]|0;if(!(q<<24>>24)){r=f[a+40>>2]|0;d=f[r+12>>2]|0;o=f[r+4>>2]|0;a:do if(o>>>0>d>>>0){p=f[r+16>>2]|0;s=d;while(1){t=f[p+(s<<2)>>2]|0;if(t|0)break;v=s+1|0;if(v>>>0<o>>>0)s=v;else{w=0;x=v;y=0;break a}}if((t|0)==(f[p+((s^1)<<2)>>2]|0)){v=f[t>>2]|0;w=f[v+16>>2]|0;x=s;y=v;break}else{w=t;x=s;y=0;break}}else{w=0;x=d;y=0}while(0);d=e+4|0;f[d>>2]=w;f[e+8>>2]=r;f[e+12>>2]=x;f[e+16>>2]=y;y=e+20|0;f[y>>2]=0;f[e>>2]=2;x=e+20|0;z=e+4|0;A=y;B=x;C=x;D=d;E=e;F=2}else{d=f[(f[a+40>>2]|0)+12>>2]|0;f[e>>2]=1;a=e+4|0;f[a>>2]=0;x=e+20|0;f[x>>2]=d;z=a;A=e+20|0;B=x;C=x;D=e+4|0;E=e;F=1}e=m+32|0;x=n+32|0;a=q;q=F;b:while(1){c:do if((q|0)==((a<<24>>24==0?2:1)|0))switch(q|0){case 0:{G=30;break b;break}case 1:{if(!(f[A>>2]|0)){G=30;break b}else break c;break}default:if(!(f[z>>2]|0)){G=30;break b}else break c}while(0);s=f[i>>2]|0;p=di[f[(f[s>>2]|0)+12>>2]&1023](s)|0;s=f[j>>2]|0;F=$Nb(p)|0;d=f[s>>2]|0;if(((d|0)==(F|0)?(F=s+12|0,y=f[F>>2]|0,(y|0)!=0):0)?(r=f[y>>2]|0,(r|0)<(f[s+8>>2]|0)):0){w=s+4|0;t=f[w>>2]|0;if((t|0)<(r|0)){o=y+4+(t<<2)|0;f[y+4+(r<<2)>>2]=f[o>>2];H=o}else H=y+4+(t<<2)|0;f[H>>2]=p;f[w>>2]=t+1;t=f[F>>2]|0;f[t>>2]=(f[t>>2]|0)+1}else YJb(s,p,_Nb(p)|0,d);d=f[((f[E>>2]|0)==1?(f[B>>2]|0)+24|0:(f[z>>2]|0)+16|0)>>2]|0;switch(f[136e3+(f[e>>2]<<2)>>2]|0){case 9:{s=f[(f[k>>2]|0)+144>>2]|0;t=xDa(d)|0;th[s&511](k,p,m,t);break}case 2:{t=f[(f[k>>2]|0)+120>>2]|0;s=rJb(d)|0;uh[t&255](k,p,m,s,J);break}case 1:{s=f[(f[k>>2]|0)+116>>2]|0;t=sJb(d)|0;th[s&511](k,p,m,t);break}case 4:{t=f[(f[k>>2]|0)+128>>2]|0;s=tJb(d)|0;uh[t&255](k,p,m,s,J);break}case 3:{s=f[(f[k>>2]|0)+124>>2]|0;t=uJb(d)|0;th[s&511](k,p,m,t);break}case 7:{t=f[(f[k>>2]|0)+140>>2]|0;s=vJb(d)|0;th[t&511](k,p,m,s);break}case 10:case 8:case 6:case 5:{zpb(g,3,471923,308);xpb(h,vpb(g,477853)|0);Apb(g);break}default:{}}s=(f[((f[E>>2]|0)==1?(f[B>>2]|0)+24|0:(f[z>>2]|0)+16|0)>>2]|0)+16|0;do switch(f[136e3+(f[x>>2]<<2)>>2]|0){case 9:{t=f[(f[k>>2]|0)+144>>2]|0;d=ZJb(s)|0;th[t&511](k,p,n,d);break}case 2:{d=f[(f[k>>2]|0)+120>>2]|0;t=_Jb(s)|0;uh[d&255](k,p,n,t,J);break}case 1:{t=f[(f[k>>2]|0)+116>>2]|0;d=$Jb(s)|0;th[t&511](k,p,n,d);break}case 4:{d=f[(f[k>>2]|0)+128>>2]|0;t=aKb(s)|0;uh[d&255](k,p,n,t,J);break}case 3:{t=f[(f[k>>2]|0)+124>>2]|0;d=bKb(s)|0;th[t&511](k,p,n,d);break}case 7:{d=f[(f[k>>2]|0)+140>>2]|0;t=cKb(s)|0;th[d&511](k,p,n,t);break}case 5:{t=f[(f[k>>2]|0)+136>>2]|0;I=+dKb(s);oh[t&63](k,p,n,I);break}case 6:{t=f[(f[k>>2]|0)+132>>2]|0;I=+eKb(s);oh[t&63](k,p,n,I);break}case 8:{t=f[(f[k>>2]|0)+152>>2]|0;d=fKb(s)|0;th[t&511](k,p,n,d);break}case 10:{d=gKb(s)|0;t=Dg[f[(f[k>>2]|0)+156>>2]&127](k,p,n,0)|0;zh[f[(f[t>>2]|0)+72>>2]&2047](t,d);break}default:{}}while(0);if((f[E>>2]|0)==1){f[C>>2]=f[f[B>>2]>>2];K=1}else{mJb(D)|0;K=f[E>>2]|0}a=b[l>>0]|0;q=K}if((G|0)==30){u=c;return}}function dJb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0.0;c=u;u=u+80|0;d=c;e=c+24|0;g=c+40|0;h=c+64|0;i=a+28|0;j=a+44|0;k=f[j>>2]|0;l=di[f[(f[k>>2]|0)+92>>2]&1023](k)|0;k=f[j>>2]|0;zh[f[(f[k>>2]|0)+96>>2]&2047](d,k);k=f[d>>2]|0;m=d+4|0;f[m>>2]=0;f[m+4>>2]=0;m=d+11|0;b[m>>0]=3;b[d>>0]=b[471913]|0;b[d+1>>0]=b[471914]|0;b[d+2>>0]=b[471915]|0;b[d+3>>0]=0;o=rub(k,d)|0;if((b[m>>0]|0)<0)O5b(f[d>>2]|0);m=f[j>>2]|0;zh[f[(f[m>>2]|0)+96>>2]&2047](d,m);m=f[d>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;j=d+11|0;b[j>>0]=5;b[d>>0]=b[471917]|0;b[d+1>>0]=b[471918]|0;b[d+2>>0]=b[471919]|0;b[d+3>>0]=b[471920]|0;b[d+4>>0]=b[471921]|0;b[d+5>>0]=0;k=rub(m,d)|0;if((b[j>>0]|0)<0)O5b(f[d>>2]|0);j=a+36|0;m=b[j>>0]|0;if(!(m<<24>>24)){q=f[a+40>>2]|0;r=f[q+12>>2]|0;s=f[q+4>>2]|0;a:do if(s>>>0>r>>>0){t=f[q+16>>2]|0;v=r;while(1){w=f[t+(v<<2)>>2]|0;if(w|0)break;x=v+1|0;if(x>>>0<s>>>0)v=x;else{y=0;z=x;A=0;break a}}if((w|0)==(f[t+((v^1)<<2)>>2]|0)){x=f[w>>2]|0;y=f[x+16>>2]|0;z=v;A=x;break}else{y=w;z=v;A=0;break}}else{y=0;z=r;A=0}while(0);f[d>>2]=2;r=d+4|0;f[r>>2]=y;f[d+8>>2]=q;f[d+12>>2]=z;f[d+16>>2]=A;A=d+20|0;f[A>>2]=0;z=d+20|0;B=d+4|0;C=A;D=z;E=z;F=r;G=d;H=2}else{r=f[(f[a+40>>2]|0)+12>>2]|0;f[d>>2]=1;z=d+4|0;f[z>>2]=0;A=d+20|0;f[A>>2]=r;B=z;C=d+20|0;D=A;E=A;F=d+4|0;G=d;H=1}A=H;H=m;b:while(1){c:do if((A|0)==((H<<24>>24==0?2:1)|0))switch(A|0){case 0:{break b;break}case 1:{if(!(f[C>>2]|0))break b;else break c;break}default:if(!(f[B>>2]|0))break b;else break c}while(0);xJb((f[((A|0)==1?(f[D>>2]|0)+24|0:(f[B>>2]|0)+16|0)>>2]|0)+16|0);if((f[G>>2]|0)==1){f[E>>2]=f[f[D>>2]>>2];I=1}else{yJb(F)|0;I=f[G>>2]|0}A=I;H=b[j>>0]|0}wJb(i);H=a+8|0;I=f[H>>2]|0;A=f[I+12>>2]|0;if(!(f[I+4>>2]|0)){u=c;return}I=d+8|0;G=o+32|0;F=a+40|0;a=k+32|0;D=e+11|0;E=e+11|0;B=(A|0)==0?0:A+4|0;do{f[I>>2]=0;switch(f[136e3+(f[G>>2]<<2)>>2]|0){case 9:{th[f[(f[l>>2]|0)+96>>2]&511](e,l,f[B>>2]|0,o);if((f[I>>2]|0)==9)K=f[d>>2]|0;else{f[I>>2]=9;A=L5b(12)|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[d>>2]=A;K=A}_5b(K,e)|0;if((b[E>>0]|0)<0)O5b(f[e>>2]|0);break}case 2:{A=li[f[(f[l>>2]|0)+72>>2]&511](l,f[B>>2]|0,o)|0;C=J;switch(f[I>>2]|0){case 2:break;case 9:{v=f[d>>2]|0;if(!v)L=39;else{if((b[v+11>>0]|0)<0)O5b(f[v>>2]|0);O5b(v);L=39}break}default:L=39}if((L|0)==39){L=0;f[I>>2]=2}v=d;f[v>>2]=A;f[v+4>>2]=C;break}case 1:{C=li[f[(f[l>>2]|0)+68>>2]&511](l,f[B>>2]|0,o)|0;switch(f[I>>2]|0){case 1:break;case 9:{v=f[d>>2]|0;if(!v)L=46;else{if((b[v+11>>0]|0)<0)O5b(f[v>>2]|0);O5b(v);L=46}break}default:L=46}if((L|0)==46){L=0;f[I>>2]=1}f[d>>2]=C;break}case 4:{C=li[f[(f[l>>2]|0)+80>>2]&511](l,f[B>>2]|0,o)|0;v=J;switch(f[I>>2]|0){case 4:break;case 9:{A=f[d>>2]|0;if(!A)L=53;else{if((b[A+11>>0]|0)<0)O5b(f[A>>2]|0);O5b(A);L=53}break}default:L=53}if((L|0)==53){L=0;f[I>>2]=4}A=d;f[A>>2]=C;f[A+4>>2]=v;break}case 3:{v=li[f[(f[l>>2]|0)+76>>2]&511](l,f[B>>2]|0,o)|0;switch(f[I>>2]|0){case 3:break;case 9:{A=f[d>>2]|0;if(!A)L=60;else{if((b[A+11>>0]|0)<0)O5b(f[A>>2]|0);O5b(A);L=60}break}default:L=60}if((L|0)==60){L=0;f[I>>2]=3}f[d>>2]=v;break}case 7:{v=(li[f[(f[l>>2]|0)+92>>2]&511](l,f[B>>2]|0,o)|0)&1;switch(f[I>>2]|0){case 7:break;case 9:{A=f[d>>2]|0;if(!A)L=67;else{if((b[A+11>>0]|0)<0)O5b(f[A>>2]|0);O5b(A);L=67}break}default:L=67}if((L|0)==67){L=0;f[I>>2]=7}b[d>>0]=v;break}case 10:case 8:case 6:case 5:{zpb(g,3,471923,390);xpb(h,vpb(g,477853)|0);Apb(g);break}default:{}}if(!(b[j>>0]|0))M=AJb(f[F>>2]|0,d)|0;else M=zJb(f[F>>2]|0,d)|0;v=f[M>>2]|0;if(!v){A=BJb(i,d)|0;f[M>>2]=A;N=A}else N=v;v=f[136e3+(f[a>>2]<<2)>>2]|0;f[N+20>>2]=v;do switch(v|0){case 1:{A=L5b(4)|0;C=li[f[(f[l>>2]|0)+68>>2]&511](l,f[B>>2]|0,k)|0;f[A>>2]=C;O=A;L=88;break}case 2:{A=L5b(8)|0;C=li[f[(f[l>>2]|0)+72>>2]&511](l,f[B>>2]|0,k)|0;t=A;f[t>>2]=C;f[t+4>>2]=J;O=A;L=88;break}case 3:{A=L5b(4)|0;t=li[f[(f[l>>2]|0)+76>>2]&511](l,f[B>>2]|0,k)|0;f[A>>2]=t;O=A;L=88;break}case 4:{A=L5b(8)|0;t=li[f[(f[l>>2]|0)+80>>2]&511](l,f[B>>2]|0,k)|0;C=A;f[C>>2]=t;f[C+4>>2]=J;O=A;L=88;break}case 5:{A=L5b(8)|0;P=+fh[f[(f[l>>2]|0)+88>>2]&31](l,f[B>>2]|0,k);p[A>>3]=P;O=A;L=88;break}case 6:{A=L5b(4)|0;P=+fh[f[(f[l>>2]|0)+84>>2]&31](l,f[B>>2]|0,k);n[A>>2]=P;O=A;L=88;break}case 7:{A=L5b(1)|0;C=(li[f[(f[l>>2]|0)+92>>2]&511](l,f[B>>2]|0,k)|0)&1;b[A>>0]=C;O=A;L=88;break}case 9:{A=L5b(12)|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;th[f[(f[l>>2]|0)+96>>2]&511](e,l,f[B>>2]|0,k);_5b(A,e)|0;if((b[D>>0]|0)<0)O5b(f[e>>2]|0);O=A;L=88;break}case 8:{A=L5b(4)|0;C=li[f[(f[l>>2]|0)+104>>2]&511](l,f[B>>2]|0,k)|0;f[A>>2]=C;O=A;L=88;break}case 10:{A=Dg[f[(f[l>>2]|0)+108>>2]&127](l,f[B>>2]|0,k,0)|0;C=di[f[(f[A>>2]|0)+12>>2]&1023](A)|0;zh[f[(f[C>>2]|0)+72>>2]&2047](C,A);O=C;L=88;break}default:{}}while(0);if((L|0)==88){L=0;f[N+16>>2]=O}if((f[I>>2]|0)==9?(v=f[d>>2]|0,v|0):0){if((b[v+11>>0]|0)<0)O5b(f[v>>2]|0);O5b(v)}B=B+4|0;v=f[H>>2]|0;C=f[v+12>>2]|0}while((B|0)!=(((C|0)==0?0:C+4|0)+(f[v+4>>2]<<2)|0));u=c;return}function eJb(a,b){a=a|0;b=b|0;a=L5b(24)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+20>>2]=0;f[b>>2]=a;return}function fJb(a,b){a=a|0;b=b|0;a=f[b>>2]|0;if(!a)return;O5b(a);return}function gJb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=f[d>>2]|0;g=f[c>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];f[g+16>>2]=f[e+16>>2];f[g+20>>2]=f[e+20>>2];e=c+8|0;g=oDa(d+8|0)|0;h=c+16|0;i=f[h>>2]|0;if((i|0)!=(g|0)){if((i|0)==9?(i=f[e>>2]|0,i|0):0){if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);O5b(i)}f[h>>2]=g;if((g|0)==9){g=L5b(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[e>>2]=g}}f[c+28>>2]=f[d+28>>2];zh[f[(f[a>>2]|0)+72>>2]&2047](a,c);return}function hJb(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[b>>2]|0;if((f[c>>2]|0)==1){d=c+20|0;f[d>>2]=f[f[d>>2]>>2]}else mJb(c+4|0)|0;zh[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function iJb(a){a=a|0;var b=0,c=0,d=0;b=a+24|0;if((f[b>>2]|0)!=1){c=a+28|0;return c|0}d=a+20|0;npb(d);if((f[b>>2]|0)==1){bi[f[(f[a>>2]|0)+44>>2]&2047](a);f[b>>2]=2}opb(d);c=a+28|0;return c|0}function jJb(a){a=a|0;var b=0,c=0,d=0;b=a+24|0;if((f[b>>2]|0)!=1){f[b>>2]=0;c=a+28|0;return c|0}d=a+20|0;npb(d);if((f[b>>2]|0)==1){bi[f[(f[a>>2]|0)+44>>2]&2047](a);f[b>>2]=2}opb(d);f[b>>2]=0;c=a+28|0;return c|0}function kJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=f[c>>2]|0;e=f[d>>2]|0;g=f[d+4>>2]|0;h=f[d+20>>2]|0;a:do if((e|0)!=(((b[a+36>>0]|0)==0?2:1)|0)){d=c+8|0;if((e|0)==1){i=d;j=8}else{k=d;j=9}}else switch(e|0){case 1:{if(!h)return;else{i=c+8|0;j=8;break a}break}case 0:return;default:if(!g)return;else{k=c+8|0;j=9;break a}}while(0);if((j|0)==8){l=h+24|0;m=i}else if((j|0)==9){l=g+16|0;m=k}lJb(m,f[l>>2]|0);m=f[l>>2]|0;f[c+28>>2]=f[m+20>>2];f[c+24>>2]=f[m+16>>2];return}function lJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d;g=d+24|0;h=oDa(c)|0;i=a+8|0;j=f[i>>2]|0;a:do if((j|0)==(h|0)){switch(h|0){case 10:case 8:case 6:case 5:{k=10;break a;break}case 9:{k=11;break a;break}case 2:{k=12;break a;break}case 1:{k=13;break a;break}case 4:{k=14;break a;break}case 3:{k=15;break a;break}case 7:{k=16;break a;break}default:{}}u=d;return}else{if((j|0)==9?(l=f[a>>2]|0,l|0):0){if((b[l+11>>0]|0)<0)O5b(f[l>>2]|0);O5b(l)}f[i>>2]=h;switch(h|0){case 10:case 8:case 6:case 5:{k=10;break a;break}case 2:{k=12;break a;break}case 1:{k=13;break a;break}case 4:{k=14;break a;break}case 3:{k=15;break a;break}case 7:{k=16;break a;break}case 9:{l=L5b(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[a>>2]=l;k=11;break a;break}default:{u=d;return}}}while(0);if((k|0)==10){zpb(e,3,471595,245);xpb(g,vpb(e,471679)|0);Apb(e);u=d;return}else if((k|0)==11){_5b(f[a>>2]|0,f[c>>2]|0)|0;u=d;return}else if((k|0)==12){e=c;g=f[e+4>>2]|0;h=a;f[h>>2]=f[e>>2];f[h+4>>2]=g;u=d;return}else if((k|0)==13){f[a>>2]=f[c>>2];u=d;return}else if((k|0)==14){g=c;h=f[g+4>>2]|0;e=a;f[e>>2]=f[g>>2];f[e+4>>2]=h;u=d;return}else if((k|0)==15){f[a>>2]=f[c>>2];u=d;return}else if((k|0)==16){b[a>>0]=b[c>>0]|0;u=d;return}}function mJb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;b=u;u=u+32|0;c=b;d=f[a>>2]|0;e=f[d+24>>2]|0;if(e|0){f[a>>2]=e;u=b;return a|0}e=a+4|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]&(f[g+4>>2]|0)+-1;f[h>>2]=i;j=f[g+16>>2]|0;k=f[j+(i<<2)>>2]|0;a:do if((k|0)!=(d|0)){b:do if(k|0?(k|0)!=(f[j+((i^1)<<2)>>2]|0):0){l=k;while(1){l=f[l+24>>2]|0;if(!l)break b;if((l|0)==(d|0)){m=i;n=g;break a}}}while(0);nJb(c,g,d);l=f[c+8>>2]|0;o=f[c+12>>2]|0;f[h>>2]=l;p=a+12|0;f[p>>2]=o;q=f[e>>2]|0;r=f[q+16>>2]|0;s=f[r+(l<<2)>>2]|0;t=o;if((s|0)!=0?(s|0)==(f[r+((l^1)<<2)>>2]|0):0){o=f[t+4>>2]|0;if(!o){v=t+8|0;w=f[v>>2]|0;if((f[w>>2]|0)==(t|0))x=w;else{w=v;do{v=f[w>>2]|0;w=v+8|0;t=f[w>>2]|0}while((f[t>>2]|0)!=(v|0));x=t}}else{w=o;while(1){t=f[w>>2]|0;if(!t)break;else w=t}x=w}f[p>>2]=x;if((x|0)!=(s+4|0)){f[a>>2]=f[x+16>>2];u=b;return a|0}o=l+2|0;f[a>>2]=0;f[h>>2]=o;t=f[q+4>>2]|0;if(t>>>0>o>>>0)y=o;else{u=b;return a|0}while(1){z=f[r+(y<<2)>>2]|0;if(z|0)break;o=y+1|0;f[h>>2]=o;if(o>>>0<t>>>0)y=o;else{A=32;break}}if((A|0)==32){u=b;return a|0}if((z|0)==(f[r+((y^1)<<2)>>2]|0)){t=f[z>>2]|0;f[a+12>>2]=t;B=f[t+16>>2]|0}else B=z;f[a>>2]=B;u=b;return a|0}else{m=l;n=q}}else{m=i;n=g}while(0);g=m+1|0;f[a>>2]=0;f[h>>2]=g;m=f[n+4>>2]|0;if(m>>>0<=g>>>0){u=b;return a|0}i=f[n+16>>2]|0;n=g;while(1){C=f[i+(n<<2)>>2]|0;if(C|0)break;g=n+1|0;f[h>>2]=g;if(g>>>0<m>>>0)n=g;else{A=32;break}}if((A|0)==32){u=b;return a|0}if((C|0)==(f[i+((n^1)<<2)>>2]|0)){n=f[C>>2]|0;f[a+12>>2]=n;D=f[n+16>>2]|0}else D=C;f[a>>2]=D;u=b;return a|0}function nJb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=oJb(b,c)|0;h=(f[b+4>>2]|0)+-1&(f[b+8>>2]|0)+g;g=f[b+16>>2]|0;i=f[g+(h<<2)>>2]|0;a:do if(i){if((i|0)!=(f[g+((h^1)<<2)>>2]|0)){j=i;while(1){if(pJb(j,c)|0)break;k=f[j+24>>2]|0;if(!k){l=h;break a}else j=k}f[a>>2]=j;f[a+4>>2]=b;f[a+8>>2]=h;m=h;n=a+16|0;f[n>>2]=m;u=d;return}if((i|0)==(f[g+((h^1)<<2)>>2]|0)){k=h&-2;o=(f[g+(k<<2)>>2]|0)+4|0;p=f[o>>2]|0;if(p){q=o;r=p;b:while(1){p=r;while(1){if(!(qJb(f[p+16>>2]|0,c)|0))break;s=f[p+4>>2]|0;if(!s){t=q;break b}else p=s}r=f[p>>2]|0;if(!r){t=p;break}else q=p}if((t|0)!=(o|0)?(q=t+16|0,!(qJb(c,f[q>>2]|0)|0)):0){f[a>>2]=f[q>>2];f[a+4>>2]=b;f[a+8>>2]=k;f[a+12>>2]=t;m=k;n=a+16|0;f[n>>2]=m;u=d;return}else l=k}else l=k}else l=h}else l=h;while(0);f[a>>2]=0;h=a+4|0;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];m=l;n=a+16|0;f[n>>2]=m;u=d;return}function oJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;a=u;u=u+64|0;d=a+24|0;e=a;g=a+48|0;switch(oDa(c)|0){case 10:case 8:case 6:case 5:{zpb(d,3,471595,1723);xpb(a+49|0,vpb(d,471679)|0);Apb(d);break}case 9:{d=xDa(c)|0;h=(b[d+11>>0]|0)<0?f[d>>2]|0:d;d=b[h>>0]|0;if(!(d<<24>>24)){i=0;u=a;return i|0}else{j=h;k=0;l=d}while(1){d=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=d;break}else k=d}u=a;return i|0}case 2:{k=rJb(c)|0;l=Y(k,1540483477)|0;k=Y(J,1540483477)|0;j=(Y((Y(l>>>24^l,1540483477)|0)^-561034072,1540483477)|0)^(Y(k>>>24^k,1540483477)|0);k=Y(j>>>13^j,1540483477)|0;i=k>>>15^k;u=a;return i|0}case 1:{i=sJb(c)|0;u=a;return i|0}case 4:{k=tJb(c)|0;j=Y(k,1540483477)|0;k=Y(J,1540483477)|0;l=(Y((Y(j>>>24^j,1540483477)|0)^-561034072,1540483477)|0)^(Y(k>>>24^k,1540483477)|0);k=Y(l>>>13^l,1540483477)|0;i=k>>>15^k;u=a;return i|0}case 3:{i=uJb(c)|0;u=a;return i|0}case 7:{i=(vJb(c)|0)&1;u=a;return i|0}default:{}}zpb(e,3,471595,1738);xpb(g,vpb(e,477853)|0);Apb(e);i=0;u=a;return i|0}function pJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+80|0;e=d+48|0;g=d+24|0;h=d;i=d+72|0;if((f[a+8>>2]|0)!=(f[c+8>>2]|0)){zpb(e,3,471595,212);xpb(d+74|0,vpb(e,471691)|0);Apb(e)}switch(oDa(a)|0){case 10:case 8:case 6:case 5:{zpb(g,3,471595,219);xpb(d+73|0,vpb(g,471679)|0);Apb(g);break}case 9:{g=f[a>>2]|0;e=f[c>>2]|0;j=b[g+11>>0]|0;k=j<<24>>24<0;l=j&255;j=k?f[g+4>>2]|0:l;m=b[e+11>>0]|0;n=m<<24>>24<0;if((j|0)!=((n?f[e+4>>2]|0:m&255)|0)){o=0;u=d;return o|0}m=f[g>>2]|0;p=k?m:g;q=n?f[e>>2]|0:e;e=(j|0)==0;if(k){if(e){o=1;u=d;return o|0}o=(ZVb(p,q,j)|0)==0;u=d;return o|0}if(e){o=1;u=d;return o|0}if((m&255)<<24>>24==(b[q>>0]|0)){r=g;s=l;t=q}else{o=0;u=d;return o|0}while(1){s=s+-1|0;r=r+1|0;if(!s){o=1;v=19;break}t=t+1|0;if((b[r>>0]|0)!=(b[t>>0]|0)){o=0;v=19;break}}if((v|0)==19){u=d;return o|0}break}case 2:{v=a;t=c;o=(f[v>>2]|0)==(f[t>>2]|0)?(f[v+4>>2]|0)==(f[t+4>>2]|0):0;u=d;return o|0}case 1:{o=(f[a>>2]|0)==(f[c>>2]|0);u=d;return o|0}case 4:{t=a;v=c;o=(f[t>>2]|0)==(f[v>>2]|0)?(f[t+4>>2]|0)==(f[v+4>>2]|0):0;u=d;return o|0}case 3:{o=(f[a>>2]|0)==(f[c>>2]|0);u=d;return o|0}case 7:{o=(b[a>>0]|0)==(b[c>>0]|0);u=d;return o|0}default:{}}zpb(h,3,471595,234);xpb(i,vpb(h,477853)|0);Apb(h);o=0;u=d;return o|0}function qJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+64|0;e=d+24|0;g=d;if((f[a+8>>2]|0)!=(f[c+8>>2]|0)){zpb(e,3,471595,184);xpb(d+49|0,vpb(e,471691)|0);Apb(e)}switch(oDa(a)|0){case 10:case 8:case 6:case 5:{zpb(g,3,471595,191);xpb(d+48|0,vpb(g,471679)|0);Apb(g);i=0;u=d;return i|0}case 9:{g=f[a>>2]|0;e=f[c>>2]|0;j=b[e+11>>0]|0;k=j<<24>>24<0;l=k?f[e+4>>2]|0:j&255;j=b[g+11>>0]|0;m=j<<24>>24<0;n=m?f[g+4>>2]|0:j&255;j=l>>>0<n>>>0;o=j?l:n;if((o|0)!=0?(p=ZVb(m?f[g>>2]|0:g,k?f[e>>2]|0:e,o)|0,(p|0)!=0):0)q=p;else q=n>>>0<l>>>0?-1:j&1;i=(q|0)<0;u=d;return i|0}case 2:{q=a;j=f[q+4>>2]|0;l=c;n=f[l+4>>2]|0;i=(j|0)<(n|0)|((j|0)==(n|0)?(f[q>>2]|0)>>>0<(f[l>>2]|0)>>>0:0);u=d;return i|0}case 1:{i=(f[a>>2]|0)<(f[c>>2]|0);u=d;return i|0}case 4:{l=a;q=f[l+4>>2]|0;n=c;j=f[n+4>>2]|0;i=q>>>0<j>>>0|((q|0)==(j|0)?(f[l>>2]|0)>>>0<(f[n>>2]|0)>>>0:0);u=d;return i|0}case 3:{i=(f[a>>2]|0)>>>0<(f[c>>2]|0)>>>0;u=d;return i|0}case 7:{i=(h[a>>0]|0)<(h[c>>0]|0);u=d;return i|0}default:{i=0;u=d;return i|0}}return 0}function rJb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+32|0;c=b;if((oDa(a)|0)==2){d=a;e=d;g=f[e>>2]|0;h=d+4|0;i=h;j=f[i>>2]|0;J=j;u=b;return g|0}zpb(c,3,471595,151);k=vpb(vpb(vpb(vpb(c,471718)|0,471891)|0,471773)|0,471795)|0;l=vpb(vpb(vpb(k,f[34040]|0)|0,475789)|0,471809)|0;k=136152+((oDa(a)|0)<<2)|0;xpb(b+24|0,vpb(l,f[k>>2]|0)|0);Apb(c);d=a;e=d;g=f[e>>2]|0;h=d+4|0;i=h;j=f[i>>2]|0;J=j;u=b;return g|0}function sJb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((oDa(a)|0)==1){d=f[a>>2]|0;u=b;return d|0}zpb(c,3,471595,161);e=vpb(vpb(vpb(vpb(c,471718)|0,471869)|0,471773)|0,471795)|0;g=vpb(vpb(vpb(e,f[34039]|0)|0,475789)|0,471809)|0;e=136152+((oDa(a)|0)<<2)|0;xpb(b+24|0,vpb(g,f[e>>2]|0)|0);Apb(c);d=f[a>>2]|0;u=b;return d|0}function tJb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;b=u;u=u+32|0;c=b;if((oDa(a)|0)==4){d=a;e=d;g=f[e>>2]|0;h=d+4|0;i=h;j=f[i>>2]|0;J=j;u=b;return g|0}zpb(c,3,471595,156);k=vpb(vpb(vpb(vpb(c,471718)|0,471846)|0,471773)|0,471795)|0;l=vpb(vpb(vpb(k,f[34042]|0)|0,475789)|0,471809)|0;k=136152+((oDa(a)|0)<<2)|0;xpb(b+24|0,vpb(l,f[k>>2]|0)|0);Apb(c);d=a;e=d;g=f[e>>2]|0;h=d+4|0;i=h;j=f[i>>2]|0;J=j;u=b;return g|0}function uJb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((oDa(a)|0)==3){d=f[a>>2]|0;u=b;return d|0}zpb(c,3,471595,166);e=vpb(vpb(vpb(vpb(c,471718)|0,471823)|0,471773)|0,471795)|0;g=vpb(vpb(vpb(e,f[34041]|0)|0,475789)|0,471809)|0;e=136152+((oDa(a)|0)<<2)|0;xpb(b+24|0,vpb(g,f[e>>2]|0)|0);Apb(c);d=f[a>>2]|0;u=b;return d|0}function vJb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c;if((oDa(a)|0)==7){e=b[a>>0]|0;g=e<<24>>24!=0;u=c;return g|0}zpb(d,3,471595,171);h=vpb(vpb(vpb(vpb(d,471718)|0,471752)|0,471773)|0,471795)|0;i=vpb(vpb(vpb(h,f[34045]|0)|0,475789)|0,471809)|0;h=136152+((oDa(a)|0)<<2)|0;xpb(c+24|0,vpb(i,f[h>>2]|0)|0);Apb(d);e=b[a>>0]|0;g=e<<24>>24!=0;u=c;return g|0}function wJb(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+80|0;d=c+48|0;e=c+24|0;g=c;h=(b[a+8>>0]|0)==0;a:do if(h){i=f[a+12>>2]|0;j=f[i+12>>2]|0;k=f[i+4>>2]|0;if(k>>>0>j>>>0){l=f[i+16>>2]|0;m=j;while(1){n=f[l+(m<<2)>>2]|0;if(n|0)break;o=m+1|0;if(o>>>0<k>>>0)m=o;else{p=2;q=0;r=i;s=o;t=0;v=0;break a}}if((n|0)==(f[l+((m^1)<<2)>>2]|0)){k=f[n>>2]|0;p=2;q=f[k+16>>2]|0;r=i;s=m;t=k;v=0;break}else{p=2;q=n;r=i;s=m;t=0;v=0;break}}else{p=2;q=0;r=i;s=j;t=0;v=0}}else{p=1;q=0;r=0;s=0;t=0;v=f[(f[a+12>>2]|0)+12>>2]|0}while(0);n=h?2:1;f[g>>2]=p;f[g+4>>2]=q;f[g+8>>2]=r;f[g+12>>2]=s;f[g+16>>2]=t;f[g+20>>2]=v;t=g+4|0;s=g+20|0;r=(p|0)==(n|0);if(h){if(r&(q|0)==0){u=c;return}do{f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];f[d+8>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];f[d+16>>2]=f[g+16>>2];f[d+20>>2]=f[g+20>>2];UJb(e,a,d);f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];f[g+16>>2]=f[e+16>>2];f[g+20>>2]=f[e+20>>2]}while(!((f[t>>2]|0)==0?(f[g>>2]|0)==(n|0):0));u=c;return}else{if(r&(v|0)==0){u=c;return}do{f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];f[d+8>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];f[d+16>>2]=f[g+16>>2];f[d+20>>2]=f[g+20>>2];UJb(e,a,d);f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];f[g+16>>2]=f[e+16>>2];f[g+20>>2]=f[e+20>>2]}while(!((f[s>>2]|0)==0?(f[g>>2]|0)==(n|0):0));u=c;return}}function xJb(a){a=a|0;var c=0;do switch(f[a+4>>2]|0){case 1:{c=f[a>>2]|0;if(!c)return;O5b(c);return}case 2:{c=f[a>>2]|0;if(!c)return;O5b(c);return}case 3:{c=f[a>>2]|0;if(!c)return;O5b(c);return}case 4:{c=f[a>>2]|0;if(!c)return;O5b(c);return}case 5:{c=f[a>>2]|0;if(!c)return;O5b(c);return}case 6:{c=f[a>>2]|0;if(!c)return;O5b(c);return}case 7:{c=f[a>>2]|0;if(!c)return;O5b(c);return}case 9:{c=f[a>>2]|0;if(!c)return;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);O5b(c);return}case 8:{c=f[a>>2]|0;if(!c)return;O5b(c);return}case 10:{c=f[a>>2]|0;if(!c)return;bi[f[(f[c>>2]|0)+4>>2]&2047](c);return}default:return}while(0)}function yJb(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;b=u;u=u+32|0;c=b;d=f[a>>2]|0;e=f[d+24>>2]|0;if(e|0){f[a>>2]=e;u=b;return a|0}e=a+4|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]&(f[g+4>>2]|0)+-1;f[h>>2]=i;j=f[g+16>>2]|0;k=f[j+(i<<2)>>2]|0;a:do if((k|0)!=(d|0)){b:do if(k|0?(k|0)!=(f[j+((i^1)<<2)>>2]|0):0){l=k;while(1){l=f[l+24>>2]|0;if(!l)break b;if((l|0)==(d|0)){m=i;n=g;break a}}}while(0);nJb(c,g,d);l=f[c+8>>2]|0;o=f[c+12>>2]|0;f[h>>2]=l;p=a+12|0;f[p>>2]=o;q=f[e>>2]|0;r=f[q+16>>2]|0;s=f[r+(l<<2)>>2]|0;t=o;if((s|0)!=0?(s|0)==(f[r+((l^1)<<2)>>2]|0):0){o=f[t+4>>2]|0;if(!o){v=t+8|0;w=f[v>>2]|0;if((f[w>>2]|0)==(t|0))x=w;else{w=v;do{v=f[w>>2]|0;w=v+8|0;t=f[w>>2]|0}while((f[t>>2]|0)!=(v|0));x=t}}else{w=o;while(1){t=f[w>>2]|0;if(!t)break;else w=t}x=w}f[p>>2]=x;if((x|0)!=(s+4|0)){f[a>>2]=f[x+16>>2];u=b;return a|0}o=l+2|0;f[a>>2]=0;f[h>>2]=o;t=f[q+4>>2]|0;if(t>>>0>o>>>0)y=o;else{u=b;return a|0}while(1){z=f[r+(y<<2)>>2]|0;if(z|0)break;o=y+1|0;f[h>>2]=o;if(o>>>0<t>>>0)y=o;else{A=32;break}}if((A|0)==32){u=b;return a|0}if((z|0)==(f[r+((y^1)<<2)>>2]|0)){t=f[z>>2]|0;f[a+12>>2]=t;B=f[t+16>>2]|0}else B=z;f[a>>2]=B;u=b;return a|0}else{m=l;n=q}}else{m=i;n=g}while(0);g=m+1|0;f[a>>2]=0;f[h>>2]=g;m=f[n+4>>2]|0;if(m>>>0<=g>>>0){u=b;return a|0}i=f[n+16>>2]|0;n=g;while(1){C=f[i+(n<<2)>>2]|0;if(C|0)break;g=n+1|0;f[h>>2]=g;if(g>>>0<m>>>0)n=g;else{A=32;break}}if((A|0)==32){u=b;return a|0}if((C|0)==(f[i+((n^1)<<2)>>2]|0)){n=f[C>>2]|0;f[a+12>>2]=n;D=f[n+16>>2]|0}else D=C;f[a>>2]=D;u=b;return a|0}function zJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;e=QJb(a,b)|0;if(e|0){g=e;h=g+24|0;u=c;return h|0}e=f[a+16>>2]|0;if(!e)i=L5b(32)|0;else i=znb(e,25536,32)|0;f[i+16>>2]=0;lJb(i+8|0,b);f[i+24>>2]=0;RJb(d,a,i);g=f[d>>2]|0;h=g+24|0;u=c;return h|0}function AJb(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0;d=u;u=u+48|0;e=d;g=d+24|0;h=e+8|0;f[h>>2]=0;lJb(e,c);f[e+16>>2]=0;GJb(g,a,e);a=(f[g>>2]|0)+16|0;if((f[h>>2]|0)!=9){u=d;return a|0}h=f[e>>2]|0;if(!h){u=d;return a|0}if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);O5b(h);u=d;return a|0}function BJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=f[a>>2]|0;if(!c){d=L5b(24)|0;f[d+8>>2]=0;lJb(d,b);f[d+16>>2]=0;f[d+20>>2]=0;e=d;return e|0}else{d=znb(c,25536,24)|0;c=f[a>>2]|0;f[d+8>>2]=0;CJb(c,d);c=d+16|0;g=f[a>>2]|0;f[c>>2]=0;f[d+20>>2]=0;DJb(g,c);f[d>>2]=f[b>>2];f[d+4>>2]=f[b+4>>2];f[d+8>>2]=f[b+8>>2];e=d;return e|0}return 0}function CJb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1527);return}function DJb(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1528);return}function EJb(a){a=a|0;return}function FJb(a){a=a|0;var c=0;if((f[a+8>>2]|0)!=9)return;c=f[a>>2]|0;if(!c)return;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);O5b(c);return}function GJb(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+20|0;h=e;nJb(g,c,d);i=f[g>>2]|0;if(i|0){j=f[g+4>>2]|0;k=f[g+8>>2]|0;l=f[g+12>>2]|0;f[a>>2]=i;f[a+4>>2]=j;f[a+8>>2]=k;f[a+12>>2]=l;b[a+16>>0]=0;u=e;return}l=(f[c>>2]|0)+1|0;k=f[c+4>>2]|0;j=k*12|0;i=j>>>4;if(i>>>0>l>>>0){if(k>>>0>8&j>>>6>>>0>=l>>>0){j=((l*5|0)>>>2)+1|0;l=1;while(1)if(j<<l>>>0<i>>>0)l=l+1|0;else break;i=k>>>l;l=i>>>0>8?i:8;if((l|0)!=(k|0)){HJb(c,l);m=11}}}else if(k>>>0<=134217728){HJb(c,k<<1);m=11}if((m|0)==11){nJb(h,c,d);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2];f[g+16>>2]=f[h+16>>2]}m=f[g+16>>2]|0;g=f[c+20>>2]|0;if(!g)n=L5b(32)|0;else n=znb(g,25536,32)|0;f[n+8>>2]=0;lJb(n,d);f[n+16>>2]=f[d+16>>2];IJb(h,c,m,n);f[c>>2]=(f[c>>2]|0)+1;f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];b[a+16>>0]=1;u=e;return}function HJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=u;u=u+16|0;d=c;e=a+16|0;g=f[e>>2]|0;h=a+4|0;i=f[h>>2]|0;f[h>>2]=b;j=a+20|0;k=f[j>>2]|0;l=b<<2;if(!k)m=L5b(l)|0;else m=znb(k,25536,l)|0;Nac(m|0,0,l|0)|0;f[e>>2]=m;m=a+12|0;e=f[m>>2]|0;f[m>>2]=f[h>>2];if(e>>>0<i>>>0){m=a+8|0;l=e;do{e=f[g+(l<<2)>>2]|0;do if(!e)n=l;else{if((e|0)==(f[g+((l^1)<<2)>>2]|0)){PJb(a,g,l);n=l+1|0;break}k=e;do{b=k;k=f[k+24>>2]|0;o=oJb(a,b)|0;IJb(d,a,(f[h>>2]|0)+-1&(f[m>>2]|0)+o,b)}while((k|0)!=0);n=l}while(0);l=n+1|0}while(l>>>0<i>>>0)}if(f[j>>2]|0){u=c;return}O5b(g);u=c;return}function IJb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;h=f[b+16>>2]|0;i=h+(c<<2)|0;j=f[i>>2]|0;k=j;do if(!j){f[d+24>>2]=k;f[i>>2]=d;l=d;m=0;n=b;o=c}else{if((j|0)==(f[h+((c^1)<<2)>>2]|0)){KJb(a,b,c,d);u=e;return}p=j;q=0;do{q=q+1|0;p=f[p+24>>2]|0}while((p|0)!=0);if(q>>>0>7){JJb(b,c);KJb(g,b,c,d);l=f[g>>2]|0;m=f[g+12>>2]|0;n=f[g+4>>2]|0;o=f[g+8>>2]|0;break}f[d+24>>2]=k;f[i>>2]=d;f[a>>2]=d;f[a+4>>2]=b;f[a+8>>2]=c;u=e;return}while(0);c=b+12|0;b=f[c>>2]|0;f[c>>2]=o>>>0<b>>>0?o:b;f[a>>2]=l;f[a+4>>2]=n;f[a+8>>2]=o;f[a+12>>2]=m;u=e;return}function JJb(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c+16|0;e=c;g=a+20|0;h=f[g>>2]|0;f[d>>2]=h;if(!h)i=L5b(16)|0;else i=znb(h,25536,16)|0;h=f[g>>2]|0;f[e+4>>2]=0;f[e+8>>2]=h;f[e+12>>2]=0;h=e+4|0;f[e>>2]=h;LJb(d,i,e);MJb(e,f[h>>2]|0);NJb(a,b,i)|0;h=b^1;NJb(a,h,i)|0;e=a+16|0;f[(f[e>>2]|0)+(h<<2)>>2]=i;f[(f[e>>2]|0)+(b<<2)>>2]=i;u=c;return}
function Tga(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;cha(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}RQ(i,j,+(m>>>0)*.0000152587890625);dha(j);u=h;return}function Uga(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;_ga(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}RQ(i,j,+(m>>>0)*.0000152587890625);$ga(j);u=h;return}function Vga(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+144|0;i=h+136|0;j=h;k=b+8|0;l=f[k>>2]|0;f[i>>2]=0;f[i+4>>2]=l;Wga(j,a,b,e,g,c,d);d=f[b+4>>2]|0;if((d|0)<3)m=Y(f[b+12>>2]|0,f[k>>2]|0)|0;else{k=f[b+40>>2]|0;b=0;c=1;while(1){g=Y(f[k+(b<<2)>>2]|0,c)|0;b=b+1|0;if((b|0)==(d|0)){m=g;break}else c=g}}RQ(i,j,+(m>>>0)*.0000152587890625);Xga(j);u=h;return}function Wga(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=57148;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;jL(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;jL(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function Xga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57148;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Yga(a){a=a|0;Xga(a);O5b(a);return}function Zga(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0,W=0.0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0.0;c=f[a+44>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;c=((f[a+4>>2]|0)>>>3&511)+1|0;g=a+116|0;h=f[g>>2]|0;i=a+120|0;j=f[i>>2]|0;k=Y(j,h)|0;l=Y((d|0)/(h|0)|0,c)|0;h=Y(c,f[(f[a+100>>2]|0)+4>>2]|0)|0;m=Y(c,d)|0;d=f[b>>2]|0;n=f[b+4>>2]|0;if((d|0)>=(n|0))return;b=f[a+76>>2]|0;o=f[a+108>>2]|0;q=a+20|0;r=a+48|0;s=a+128|0;t=k+-4|0;u=(k|0)<4;v=1.0/+(k|0);w=a+124|0;a=(h|0)>0;x=h<<3;y=k&-4;z=(y|0)<(k|0);A=(k|0)>0;B=d;D=0;while(1){E=b+(Y(o,d+D|0)|0)|0;F=b+(Y(o,B)|0)|0;G=Y(j,B)|0;H=(G+j|0)<=(e|0)?l:0;a:do if((G|0)<(e|0)){b:do if((H|0)>0){I=(f[q>>2]|0)+(Y(f[f[r>>2]>>2]|0,G)|0)|0;J=f[s>>2]|0;if(u){K=0;while(1){L=I+(f[J+(K<<2)>>2]<<3)|0;if(A){M=f[w>>2]|0;N=0.0;O=0;while(1){P=N+ +p[L+(f[M+(O<<2)>>2]<<3)>>3];O=O+1|0;if((O|0)==(k|0)){Q=P;break}else N=P}}else Q=0.0;p[F+(K<<3)>>3]=v*Q;K=K+1|0;if((K|0)==(H|0)){R=H;break b}}}K=f[w>>2]|0;O=0;do{M=I+(f[J+(O<<2)>>2]<<3)|0;N=0.0;L=0;do{N=N+(+p[M+(f[K+(L<<2)>>2]<<3)>>3]+ +p[M+(f[K+((L|1)<<2)>>2]<<3)>>3]+ +p[M+(f[K+((L|2)<<2)>>2]<<3)>>3]+ +p[M+(f[K+((L|3)<<2)>>2]<<3)>>3]);L=L+4|0}while((L|0)<=(t|0));if(z){P=N;L=y;while(1){S=P+ +p[M+(f[K+(L<<2)>>2]<<3)>>3];L=L+1|0;if((L|0)==(k|0)){T=S;break}else P=S}}else T=N;p[F+(O<<3)>>3]=v*T;O=O+1|0}while((O|0)!=(H|0));R=H}else R=0;while(0);if((R|0)<(h|0)){O=f[s>>2]|0;K=f[i>>2]|0;if((K|0)>0)U=R;else{J=R;while(1){I=F+(J<<3)|0;if((f[O+(J<<2)>>2]|0)>=(m|0))p[I>>3]=0.0;p[I>>3]=C;J=J+1|0;if((J|0)==(h|0))break a}}do{J=f[O+(U<<2)>>2]|0;c:do if((J|0)<(m|0)){I=0;L=0;P=0.0;while(1){M=I+G|0;if((M|0)>=(e|0)){V=L;W=P;break c}X=(f[q>>2]|0)+(Y(f[f[r>>2]>>2]|0,M)|0)+(J<<3)|0;M=Y(f[g>>2]|0,c)|0;if((M|0)>0){Z=0;_=L;S=P;while(1){$=S+ +p[X+(Z<<3)>>3];aa=_+1|0;Z=Z+c|0;if(!((Z+J|0)<(m|0)&(Z|0)<(M|0))){ba=aa;ca=$;break}else{_=aa;S=$}}}else{ba=L;ca=P}I=I+1|0;if((I|0)>=(K|0)){V=ba;W=ca;break}else{L=ba;P=ca}}}else{p[F+(U<<3)>>3]=0.0;V=0;W=0.0}while(0);p[F+(U<<3)>>3]=W/+(V|0);U=U+1|0}while((U|0)!=(h|0))}}else if(a)Nac(E|0,0,x|0)|0;while(0);B=B+1|0;if((B|0)>=(n|0))break;else D=D+1|0}return}function _ga(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=57168;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;jL(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;jL(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function $ga(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57168;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function aha(a){a=a|0;$ga(a);O5b(a);return}function bha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0,W=0.0,X=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0.0;c=f[a+44>>2]|0;d=f[c+4>>2]|0;e=f[c>>2]|0;c=((f[a+4>>2]|0)>>>3&511)+1|0;g=a+116|0;h=f[g>>2]|0;i=a+120|0;j=f[i>>2]|0;k=Y(j,h)|0;l=1.0/+(k|0);m=Y((d|0)/(h|0)|0,c)|0;h=Y(c,f[(f[a+100>>2]|0)+4>>2]|0)|0;o=Y(c,d)|0;d=f[b>>2]|0;p=f[b+4>>2]|0;if((d|0)>=(p|0))return;b=f[a+76>>2]|0;q=f[a+108>>2]|0;r=a+20|0;s=a+48|0;t=a+128|0;u=k+-4|0;v=(k|0)<4;w=a+124|0;a=(h|0)>0;x=h<<2;y=k&-4;z=(y|0)<(k|0);A=(k|0)>0;B=d;D=0;while(1){E=b+(Y(q,d+D|0)|0)|0;F=b+(Y(q,B)|0)|0;G=Y(j,B)|0;H=(G+j|0)<=(e|0)?m:0;a:do if((G|0)<(e|0)){b:do if((H|0)>0){I=(f[r>>2]|0)+(Y(f[f[s>>2]>>2]|0,G)|0)|0;J=f[t>>2]|0;if(v){K=0;while(1){L=I+(f[J+(K<<2)>>2]<<2)|0;if(A){M=f[w>>2]|0;N=0.0;O=0;while(1){P=N+ +n[L+(f[M+(O<<2)>>2]<<2)>>2];O=O+1|0;if((O|0)==(k|0)){Q=P;break}else N=P}}else Q=0.0;n[F+(K<<2)>>2]=l*Q;K=K+1|0;if((K|0)==(H|0)){R=H;break b}}}K=f[w>>2]|0;O=0;do{M=I+(f[J+(O<<2)>>2]<<2)|0;N=0.0;L=0;do{N=N+(+n[M+(f[K+(L<<2)>>2]<<2)>>2]+ +n[M+(f[K+((L|1)<<2)>>2]<<2)>>2]+ +n[M+(f[K+((L|2)<<2)>>2]<<2)>>2]+ +n[M+(f[K+((L|3)<<2)>>2]<<2)>>2]);L=L+4|0}while((L|0)<=(u|0));if(z){P=N;L=y;while(1){S=P+ +n[M+(f[K+(L<<2)>>2]<<2)>>2];L=L+1|0;if((L|0)==(k|0)){T=S;break}else P=S}}else T=N;n[F+(O<<2)>>2]=l*T;O=O+1|0}while((O|0)!=(H|0));R=H}else R=0;while(0);if((R|0)<(h|0)){O=f[t>>2]|0;K=f[i>>2]|0;if((K|0)>0)U=R;else{J=R;while(1){I=F+(J<<2)|0;if((f[O+(J<<2)>>2]|0)>=(o|0))n[I>>2]=0.0;n[I>>2]=C;J=J+1|0;if((J|0)==(h|0))break a}}do{J=f[O+(U<<2)>>2]|0;c:do if((J|0)<(o|0)){I=0;L=0;P=0.0;while(1){M=I+G|0;if((M|0)>=(e|0)){V=L;W=P;break c}X=(f[r>>2]|0)+(Y(f[f[s>>2]>>2]|0,M)|0)+(J<<2)|0;M=Y(f[g>>2]|0,c)|0;if((M|0)>0){Z=0;_=L;S=P;while(1){$=S+ +n[X+(Z<<2)>>2];aa=_+1|0;Z=Z+c|0;if(!((Z+J|0)<(o|0)&(Z|0)<(M|0))){ba=aa;ca=$;break}else{_=aa;S=$}}}else{ba=L;ca=P}I=I+1|0;if((I|0)>=(K|0)){V=ba;W=ca;break}else{L=ba;P=ca}}}else{n[F+(U<<2)>>2]=0.0;V=0;W=0.0}while(0);n[F+(U<<2)>>2]=W/+(V|0);U=U+1|0}while((U|0)!=(h|0))}}else if(a)Nac(E|0,0,x|0)|0;while(0);B=B+1|0;if((B|0)>=(p|0))break;else D=D+1|0}return}function cha(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=57188;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;jL(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;jL(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function dha(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57188;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function eha(a){a=a|0;dha(a);O5b(a);return}function fha(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0,X=0,Z=0.0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0.0;e=u;u=u+32|0;g=e;h=f[a+44>>2]|0;i=f[h+4>>2]|0;j=f[h>>2]|0;h=(f[a+4>>2]|0)>>>3;k=(h&511)+1|0;l=a+116|0;m=f[l>>2]|0;n=a+120|0;o=f[n>>2]|0;p=Y(o,m)|0;q=1.0/+(p|0);r=Y((i|0)/(m|0)|0,k)|0;s=Y(k,f[(f[a+100>>2]|0)+4>>2]|0)|0;t=Y(k,i)|0;i=f[a+52>>2]|0;f[g>>2]=m;f[g+4>>2]=o;f[g+8>>2]=k;f[g+16>>2]=i;a:do if((m|0)==2&(o|0)==2){switch(h&511){case 2:case 0:{v=1;break a;break}default:{}}v=(k|0)==4&1}else v=0;while(0);b[g+12>>0]=v;v=f[c>>2]|0;h=c+4|0;if((v|0)>=(f[h>>2]|0)){u=e;return}c=a+76|0;m=a+108|0;i=a+20|0;w=a+48|0;x=a+128|0;y=p+-4|0;z=(p|0)<4;A=a+124|0;a=(s|0)>0;B=s<<1;D=p&-4;E=(D|0)<(p|0);F=(p|0)>0;G=v;v=o;while(1){o=(f[c>>2]|0)+(Y(f[m>>2]|0,G)|0)|0;H=Y(v,G)|0;I=(H+v|0)<=(j|0)?r:0;b:do if((H|0)<(j|0)){J=gha(g,(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,H)|0)|0,o,I)|0;c:do if((J|0)<(I|0)){K=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,H)|0)|0;L=f[x>>2]|0;if(z){M=J;while(1){N=K+(f[L+(M<<2)>>2]<<1)|0;if(F){O=f[A>>2]|0;P=0.0;Q=0;while(1){R=P+ +(d[N+(f[O+(Q<<2)>>2]<<1)>>1]|0);Q=Q+1|0;if((Q|0)==(p|0)){S=R;break}else P=R}}else S=0.0;Q=LVb(q*S)|0;d[o+(M<<1)>>1]=(Q+32768|0)>>>0<65536?Q:(Q|0)>0?32767:32768;M=M+1|0;if((M|0)==(I|0)){T=I;break c}}}M=f[A>>2]|0;Q=J;do{O=K+(f[L+(Q<<2)>>2]<<1)|0;P=0.0;N=0;do{P=P+ +((d[O+(f[M+((N|1)<<2)>>2]<<1)>>1]|0)+(d[O+(f[M+(N<<2)>>2]<<1)>>1]|0)+(d[O+(f[M+((N|2)<<2)>>2]<<1)>>1]|0)+(d[O+(f[M+((N|3)<<2)>>2]<<1)>>1]|0)|0);N=N+4|0}while((N|0)<=(y|0));if(E){R=P;N=D;while(1){U=R+ +(d[O+(f[M+(N<<2)>>2]<<1)>>1]|0);N=N+1|0;if((N|0)==(p|0)){V=U;break}else R=U}}else V=P;N=LVb(q*V)|0;d[o+(Q<<1)>>1]=(N+32768|0)>>>0<65536?N:(N|0)>0?32767:32768;Q=Q+1|0}while((Q|0)!=(I|0));T=I}else T=J;while(0);if((T|0)<(s|0)){J=f[x>>2]|0;Q=f[n>>2]|0;if((Q|0)>0)W=T;else{M=LVb(C)|0;L=((M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768)&65535;M=T;while(1){K=o+(M<<1)|0;if((f[J+(M<<2)>>2]|0)>=(t|0))d[K>>1]=0;d[K>>1]=L;M=M+1|0;if((M|0)==(s|0))break b}}do{M=f[J+(W<<2)>>2]|0;d:do if((M|0)<(t|0)){L=0;K=0;R=0.0;while(1){N=L+H|0;if((N|0)>=(j|0)){X=K;Z=R;break d}O=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,N)|0)+(M<<1)|0;N=Y(f[l>>2]|0,k)|0;if((N|0)>0){_=0;$=K;U=R;while(1){aa=U+ +(d[O+(_<<1)>>1]|0);ba=$+1|0;_=_+k|0;if(!((_+M|0)<(t|0)&(_|0)<(N|0))){ca=ba;da=aa;break}else{$=ba;U=aa}}}else{ca=K;da=R}L=L+1|0;if((L|0)>=(Q|0)){X=ca;Z=da;break}else{K=ca;R=da}}}else{d[o+(W<<1)>>1]=0;X=0;Z=0.0}while(0);M=LVb(Z/+(X|0))|0;d[o+(W<<1)>>1]=(M+32768|0)>>>0<65536?M:(M|0)>0?32767:32768;W=W+1|0}while((W|0)!=(s|0))}}else if(a)Nac(o|0,0,B|0)|0;while(0);o=G+1|0;if((o|0)>=(f[h>>2]|0))break;G=o;v=f[n>>2]|0}u=e;return}function gha(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;h=u;u=u+16|0;i=h;if(!(b[a+12>>0]|0)){j=0;u=h;return j|0}k=c+(f[a+16>>2]|0)|0;switch(f[a+8>>2]|0){case 1:{if((g|0)>0)l=0;else{j=0;u=h;return j|0}do{a=l<<1;m=a|1;d[e+(l<<1)>>1]=((d[c+(a<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;l=l+1|0}while((l|0)!=(g|0));j=g;u=h;return j|0}case 3:{if((g|0)>0)n=0;else{j=0;u=h;return j|0}while(1){l=n<<1;m=l+3|0;d[e+(n<<1)>>1]=((d[c+(l<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(l<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=l|1;a=l+4|0;d[e+(n+1<<1)>>1]=((d[c+(m<<1)>>1]|0)+2+(d[c+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)|0)>>>2;a=l+2|0;m=l+5|0;d[e+(n+2<<1)>>1]=((d[c+(a<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(a<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=n+3|0;if((m|0)<(g|0))n=m;else{j=m;break}}u=h;return j|0}case 4:break;default:{f[i>>2]=0;f[i+4>>2]=0;n=aD(i,7)|0;b[n>>0]=b[258050]|0;b[n+1>>0]=b[258051]|0;b[n+2>>0]=b[258052]|0;b[n+3>>0]=b[258053]|0;b[n+4>>0]=b[258054]|0;b[n+5>>0]=b[258055]|0;b[n+6>>0]=b[258056]|0;bO(-215,i,489445,255802,2890);bD(i)}}if((g|0)>0)o=0;else{j=0;u=h;return j|0}do{i=o<<1;n=i|4;d[e+(o<<1)>>1]=((d[c+(i<<1)>>1]|0)+2+(d[c+(n<<1)>>1]|0)+(d[k+(i<<1)>>1]|0)+(d[k+(n<<1)>>1]|0)|0)>>>2;n=i|1;m=i|5;d[e+((o|1)<<1)>>1]=((d[c+(n<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(n<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;m=i|2;n=i|6;d[e+((o|2)<<1)>>1]=((d[c+(m<<1)>>1]|0)+2+(d[c+(n<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)+(d[k+(n<<1)>>1]|0)|0)>>>2;n=i|3;m=i|7;d[e+((o|3)<<1)>>1]=((d[c+(n<<1)>>1]|0)+2+(d[c+(m<<1)>>1]|0)+(d[k+(n<<1)>>1]|0)+(d[k+(m<<1)>>1]|0)|0)>>>2;o=o+4|0}while((o|0)<(g|0));j=g+3&-4;u=h;return j|0}function hha(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=57208;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;jL(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;jL(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function iha(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57208;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function jha(a){a=a|0;iha(a);O5b(a);return}function kha(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0.0,X=0,Z=0,_=0.0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0;e=u;u=u+32|0;g=e;h=f[a+44>>2]|0;i=f[h+4>>2]|0;k=f[h>>2]|0;h=(f[a+4>>2]|0)>>>3;l=(h&511)+1|0;m=a+116|0;n=f[m>>2]|0;o=a+120|0;p=f[o>>2]|0;q=Y(p,n)|0;r=1.0/+(q|0);s=Y((i|0)/(n|0)|0,l)|0;t=Y(l,f[(f[a+100>>2]|0)+4>>2]|0)|0;v=Y(l,i)|0;i=f[a+52>>2]|0;f[g>>2]=n;f[g+4>>2]=p;f[g+8>>2]=l;f[g+16>>2]=i;a:do if((n|0)==2&(p|0)==2){switch(h&511){case 2:case 0:{w=1;break a;break}default:{}}w=(l|0)==4&1}else w=0;while(0);b[g+12>>0]=w;w=f[c>>2]|0;h=c+4|0;if((w|0)>=(f[h>>2]|0)){u=e;return}c=a+76|0;n=a+108|0;i=a+20|0;x=a+48|0;y=a+128|0;z=q+-4|0;A=(q|0)<4;B=a+124|0;a=(t|0)>0;D=t<<1;E=q&-4;F=(E|0)<(q|0);G=(q|0)>0;H=w;w=p;while(1){p=(f[c>>2]|0)+(Y(f[n>>2]|0,H)|0)|0;I=Y(w,H)|0;J=(I+w|0)<=(k|0)?s:0;b:do if((I|0)<(k|0)){K=lha(g,(f[i>>2]|0)+(Y(f[f[x>>2]>>2]|0,I)|0)|0,p,J)|0;c:do if((K|0)<(J|0)){L=(f[i>>2]|0)+(Y(f[f[x>>2]>>2]|0,I)|0)|0;M=f[y>>2]|0;if(A){N=K;while(1){O=L+(f[M+(N<<2)>>2]<<1)|0;if(G){P=f[B>>2]|0;Q=0.0;R=0;while(1){S=Q+ +(j[O+(f[P+(R<<2)>>2]<<1)>>1]|0);R=R+1|0;if((R|0)==(q|0)){T=S;break}else Q=S}}else T=0.0;R=LVb(r*T)|0;d[p+(N<<1)>>1]=R>>>0<65536?R:(R|0)>0?65535:0;N=N+1|0;if((N|0)==(J|0)){U=J;break c}}}N=f[B>>2]|0;R=K;do{P=L+(f[M+(R<<2)>>2]<<1)|0;Q=0.0;O=0;do{Q=Q+ +((j[P+(f[N+((O|1)<<2)>>2]<<1)>>1]|0)+(j[P+(f[N+(O<<2)>>2]<<1)>>1]|0)+(j[P+(f[N+((O|2)<<2)>>2]<<1)>>1]|0)+(j[P+(f[N+((O|3)<<2)>>2]<<1)>>1]|0)|0);O=O+4|0}while((O|0)<=(z|0));if(F){S=Q;O=E;while(1){V=S+ +(j[P+(f[N+(O<<2)>>2]<<1)>>1]|0);O=O+1|0;if((O|0)==(q|0)){W=V;break}else S=V}}else W=Q;O=LVb(r*W)|0;d[p+(R<<1)>>1]=O>>>0<65536?O:(O|0)>0?65535:0;R=R+1|0}while((R|0)!=(J|0));U=J}else U=K;while(0);if((U|0)<(t|0)){K=f[y>>2]|0;R=f[o>>2]|0;if((R|0)>0)X=U;else{N=LVb(C)|0;M=(N>>>0<65536?N:(N|0)>0?65535:0)&65535;N=U;while(1){L=p+(N<<1)|0;if((f[K+(N<<2)>>2]|0)>=(v|0))d[L>>1]=0;d[L>>1]=M;N=N+1|0;if((N|0)==(t|0))break b}}do{N=f[K+(X<<2)>>2]|0;d:do if((N|0)<(v|0)){M=0;L=0;S=0.0;while(1){O=M+I|0;if((O|0)>=(k|0)){Z=L;_=S;break d}P=(f[i>>2]|0)+(Y(f[f[x>>2]>>2]|0,O)|0)+(N<<1)|0;O=Y(f[m>>2]|0,l)|0;if((O|0)>0){$=0;aa=L;V=S;while(1){ba=V+ +(j[P+($<<1)>>1]|0);ca=aa+1|0;$=$+l|0;if(!(($+N|0)<(v|0)&($|0)<(O|0))){da=ca;ea=ba;break}else{aa=ca;V=ba}}}else{da=L;ea=S}M=M+1|0;if((M|0)>=(R|0)){Z=da;_=ea;break}else{L=da;S=ea}}}else{d[p+(X<<1)>>1]=0;Z=0;_=0.0}while(0);N=LVb(_/+(Z|0))|0;d[p+(X<<1)>>1]=N>>>0<65536?N:(N|0)>0?65535:0;X=X+1|0}while((X|0)!=(t|0))}}else if(a)Nac(p|0,0,D|0)|0;while(0);p=H+1|0;if((p|0)>=(f[h>>2]|0))break;H=p;w=f[o>>2]|0}u=e;return}function lha(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0;h=u;u=u+16|0;i=h;if(!(b[a+12>>0]|0)){k=0;u=h;return k|0}l=c+(f[a+16>>2]|0)|0;switch(f[a+8>>2]|0){case 1:{if((g|0)>0)m=0;else{k=0;u=h;return k|0}do{a=m<<1;n=a|1;d[e+(m<<1)>>1]=((j[c+(a<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;m=m+1|0}while((m|0)!=(g|0));k=g;u=h;return k|0}case 3:{if((g|0)>0)o=0;else{k=0;u=h;return k|0}while(1){m=o<<1;n=m+3|0;d[e+(o<<1)>>1]=((j[c+(m<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(m<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=m|1;a=m+4|0;d[e+(o+1<<1)>>1]=((j[c+(n<<1)>>1]|0)+2+(j[c+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)|0)>>>2;a=m+2|0;n=m+5|0;d[e+(o+2<<1)>>1]=((j[c+(a<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(a<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=o+3|0;if((n|0)<(g|0))o=n;else{k=n;break}}u=h;return k|0}case 4:break;default:{f[i>>2]=0;f[i+4>>2]=0;o=aD(i,7)|0;b[o>>0]=b[258050]|0;b[o+1>>0]=b[258051]|0;b[o+2>>0]=b[258052]|0;b[o+3>>0]=b[258053]|0;b[o+4>>0]=b[258054]|0;b[o+5>>0]=b[258055]|0;b[o+6>>0]=b[258056]|0;bO(-215,i,489445,255802,2890);bD(i)}}if((g|0)>0)p=0;else{k=0;u=h;return k|0}do{i=p<<1;o=i|4;d[e+(p<<1)>>1]=((j[c+(i<<1)>>1]|0)+2+(j[c+(o<<1)>>1]|0)+(j[l+(i<<1)>>1]|0)+(j[l+(o<<1)>>1]|0)|0)>>>2;o=i|1;n=i|5;d[e+((p|1)<<1)>>1]=((j[c+(o<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(o<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;n=i|2;o=i|6;d[e+((p|2)<<1)>>1]=((j[c+(n<<1)>>1]|0)+2+(j[c+(o<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)+(j[l+(o<<1)>>1]|0)|0)>>>2;o=i|3;n=i|7;d[e+((p|3)<<1)>>1]=((j[c+(o<<1)>>1]|0)+2+(j[c+(n<<1)>>1]|0)+(j[l+(o<<1)>>1]|0)+(j[l+(n<<1)>>1]|0)|0)>>>2;p=p+4|0}while((p|0)<(g|0));k=g+3&-4;u=h;return k|0}function mha(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f[a>>2]=57228;i=a+4|0;f[i>>2]=f[b>>2];j=a+8|0;k=b+4|0;f[j>>2]=f[k>>2];l=a+12|0;f[l>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];m=f[b+36>>2]|0;f[a+40>>2]=m;f[a+44>>2]=l;l=a+52|0;n=a+48|0;f[n>>2]=l;f[l>>2]=0;f[a+56>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[b+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2]}else{f[j>>2]=0;jL(i,b)}b=a+60|0;f[b>>2]=f[c>>2];i=a+64|0;j=c+4|0;f[i>>2]=f[j>>2];k=a+68|0;f[k>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];l=f[c+36>>2]|0;f[a+96>>2]=l;f[a+100>>2]=k;k=a+108|0;n=a+104|0;f[n>>2]=k;f[k>>2]=0;f[a+112>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[c+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}else{f[i>>2]=0;jL(b,c);o=a+116|0;f[o>>2]=d;p=a+120|0;f[p>>2]=e;q=a+124|0;f[q>>2]=g;r=a+128|0;f[r>>2]=h;return}}function nha(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=57228;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function oha(a){a=a|0;nha(a);O5b(a);return}function pha(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;d=u;u=u+32|0;e=d;g=f[a+44>>2]|0;i=f[g+4>>2]|0;j=f[g>>2]|0;g=(f[a+4>>2]|0)>>>3;k=(g&511)+1|0;l=a+116|0;m=f[l>>2]|0;n=a+120|0;o=f[n>>2]|0;p=Y(o,m)|0;q=1.0/+(p|0);r=Y((i|0)/(m|0)|0,k)|0;s=Y(k,f[(f[a+100>>2]|0)+4>>2]|0)|0;t=Y(k,i)|0;i=f[a+52>>2]|0;f[e>>2]=m;f[e+4>>2]=o;f[e+8>>2]=k;f[e+16>>2]=i;a:do if((m|0)==2&(o|0)==2){switch(g&511){case 2:case 0:{v=1;break a;break}default:{}}v=(k|0)==4&1}else v=0;while(0);b[e+12>>0]=v;v=f[c>>2]|0;g=c+4|0;if((v|0)>=(f[g>>2]|0)){u=d;return}c=a+76|0;m=a+108|0;i=a+20|0;w=a+48|0;x=a+128|0;y=p+-4|0;z=(p|0)<4;A=a+124|0;a=(s|0)>0;B=p&-4;C=(p|0)>0;D=(B|0)<(p|0);E=v;v=o;while(1){o=(f[c>>2]|0)+(Y(f[m>>2]|0,E)|0)|0;F=Y(v,E)|0;G=(F+v|0)<=(j|0)?r:0;if((F|0)<(j|0)){H=qha(e,(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,F)|0)|0,o,G)|0;b:do if((H|0)<(G|0)){if(z){I=H;while(1){J=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,F)|0)|0;K=J+(f[(f[x>>2]|0)+(I<<2)>>2]|0)|0;if(C){J=f[A>>2]|0;L=0;M=0;while(1){N=(h[K+(f[J+(M<<2)>>2]|0)>>0]|0)+L|0;M=M+1|0;if((M|0)==(p|0)){O=N;break}else L=N}}else O=0;L=LVb(q*+(O|0))|0;b[o+I>>0]=L>>>0<256?L:(L|0)>0?255:0;I=I+1|0;if((I|0)==(G|0)){P=G;break b}}}else Q=H;do{I=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,F)|0)|0;L=I+(f[(f[x>>2]|0)+(Q<<2)>>2]|0)|0;I=f[A>>2]|0;M=0;J=0;do{M=(h[L+(f[I+(J<<2)>>2]|0)>>0]|0)+M+(h[L+(f[I+((J|1)<<2)>>2]|0)>>0]|0)+(h[L+(f[I+((J|2)<<2)>>2]|0)>>0]|0)+(h[L+(f[I+((J|3)<<2)>>2]|0)>>0]|0)|0;J=J+4|0}while((J|0)<=(y|0));if(D){J=M;K=B;while(1){N=(h[L+(f[I+(K<<2)>>2]|0)>>0]|0)+J|0;K=K+1|0;if((K|0)==(p|0)){R=N;break}else J=N}}else R=M;J=LVb(q*+(R|0))|0;b[o+Q>>0]=J>>>0<256?J:(J|0)>0?255:0;Q=Q+1|0}while((Q|0)!=(G|0));P=G}else P=H;while(0);if((P|0)<(s|0)){H=P;do{G=f[(f[x>>2]|0)+(H<<2)>>2]|0;J=(G|0)<(t|0);if(!J)b[o+H>>0]=0;K=f[n>>2]|0;c:do if((K|0)<1|J^1){S=0;T=0}else{I=0;L=0;N=0;while(1){U=I+F|0;if((U|0)>=(j|0)){S=L;T=N;break c}V=(f[i>>2]|0)+(Y(f[f[w>>2]>>2]|0,U)|0)+G|0;U=Y(f[l>>2]|0,k)|0;if((U|0)>0){W=0;X=L;Z=N;while(1){_=(h[V+W>>0]|0)+Z|0;$=X+1|0;W=W+k|0;if(!((W+G|0)<(t|0)&(W|0)<(U|0))){aa=$;ba=_;break}else{X=$;Z=_}}}else{aa=L;ba=N}I=I+1|0;if((I|0)>=(K|0)){S=aa;T=ba;break}else{L=aa;N=ba}}}while(0);K=LVb(+(T|0)/+(S|0))|0;b[o+H>>0]=K>>>0<256?K:(K|0)>0?255:0;H=H+1|0}while((H|0)!=(s|0))}}else if(a)Nac(o|0,0,s|0)|0;H=E+1|0;if((H|0)>=(f[g>>2]|0))break;E=H;v=f[n>>2]|0}u=d;return}function qha(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+16|0;i=g;if(!(b[a+12>>0]|0)){j=0;u=g;return j|0}k=c+(f[a+16>>2]|0)|0;switch(f[a+8>>2]|0){case 1:{if((e|0)>0)l=0;else{j=0;u=g;return j|0}do{a=l<<1;m=a|1;b[d+l>>0]=((h[c+a>>0]|0)+2+(h[c+m>>0]|0)+(h[k+a>>0]|0)+(h[k+m>>0]|0)|0)>>>2;l=l+1|0}while((l|0)!=(e|0));j=e;u=g;return j|0}case 3:{if((e|0)>0)n=0;else{j=0;u=g;return j|0}while(1){l=n<<1;m=l+3|0;b[d+n>>0]=((h[c+l>>0]|0)+2+(h[c+m>>0]|0)+(h[k+l>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=l|1;a=l+4|0;b[d+(n+1)>>0]=((h[c+m>>0]|0)+2+(h[c+a>>0]|0)+(h[k+m>>0]|0)+(h[k+a>>0]|0)|0)>>>2;a=l+2|0;m=l+5|0;b[d+(n+2)>>0]=((h[c+a>>0]|0)+2+(h[c+m>>0]|0)+(h[k+a>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=n+3|0;if((m|0)<(e|0))n=m;else{j=m;break}}u=g;return j|0}case 4:break;default:{f[i>>2]=0;f[i+4>>2]=0;n=aD(i,7)|0;b[n>>0]=b[258050]|0;b[n+1>>0]=b[258051]|0;b[n+2>>0]=b[258052]|0;b[n+3>>0]=b[258053]|0;b[n+4>>0]=b[258054]|0;b[n+5>>0]=b[258055]|0;b[n+6>>0]=b[258056]|0;bO(-215,i,489445,255802,2890);bD(i)}}if((e|0)>0)o=0;else{j=0;u=g;return j|0}do{i=o<<1;n=i|4;b[d+o>>0]=((h[c+i>>0]|0)+2+(h[c+n>>0]|0)+(h[k+i>>0]|0)+(h[k+n>>0]|0)|0)>>>2;n=i|1;m=i|5;b[d+(o|1)>>0]=((h[c+n>>0]|0)+2+(h[c+m>>0]|0)+(h[k+n>>0]|0)+(h[k+m>>0]|0)|0)>>>2;m=i|2;n=i|6;b[d+(o|2)>>0]=((h[c+m>>0]|0)+2+(h[c+n>>0]|0)+(h[k+m>>0]|0)+(h[k+n>>0]|0)|0)>>>2;n=i|3;m=i|7;b[d+(o|3)>>0]=((h[c+n>>0]|0)+2+(h[c+m>>0]|0)+(h[k+n>>0]|0)+(h[k+m>>0]|0)|0)>>>2;o=o+4|0}while((o|0)<(e|0));j=e+3&-4;u=g;return j|0}function rha(a){a=a|0;Hea(a);O5b(a);return}function sha(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=f[(f[a+100>>2]|0)+4>>2]|0;g=f[a+8>>2]|0;if((g|0)>0)h=f[(f[a+48>>2]|0)+(g+-1<<2)>>2]|0;else h=0;g=f[c>>2]|0;i=c+4|0;if((g|0)>=(f[i>>2]|0))return;c=a+76|0;j=a+108|0;k=a+128|0;l=(f[f[a+44>>2]>>2]|0)+-1|0;m=a+20|0;n=a+48|0;o=(e|0)>0;q=a+116|0;r=a+120|0;a=e+-2|0;s=(e|0)<2;t=e&-2;u=g;do{g=(f[c>>2]|0)+(Y(f[j>>2]|0,u)|0)|0;v=+(u|0)*+p[k>>3];w=~~v;x=w-(+(w|0)>v&1)|0;w=(f[m>>2]|0)+(Y((l|0)<(x|0)?l:x,f[f[n>>2]>>2]|0)|0)|0;switch(h|0){case 1:{if(s)y=0;else{x=0;do{z=f[q>>2]|0;A=x|1;B=b[w+(f[z+(A<<2)>>2]|0)>>0]|0;b[g+x>>0]=b[w+(f[z+(x<<2)>>2]|0)>>0]|0;b[g+A>>0]=B;x=x+2|0}while((x|0)<=(a|0));y=t}if((y|0)<(e|0)){x=y;do{b[g+x>>0]=b[w+(f[(f[q>>2]|0)+(x<<2)>>2]|0)>>0]|0;x=x+1|0}while((x|0)!=(e|0))}break}case 2:{if(o){x=f[q>>2]|0;B=0;do{d[g+(B<<1)>>1]=d[w+(f[x+(B<<2)>>2]|0)>>1]|0;B=B+1|0}while((B|0)!=(e|0))}break}case 3:{if(o){B=g;x=0;while(1){A=w+(f[(f[q>>2]|0)+(x<<2)>>2]|0)|0;b[B>>0]=b[A>>0]|0;b[B+1>>0]=b[A+1>>0]|0;b[B+2>>0]=b[A+2>>0]|0;x=x+1|0;if((x|0)==(e|0))break;else B=B+3|0}}break}case 4:{if(o){B=f[q>>2]|0;x=0;do{f[g+(x<<2)>>2]=f[w+(f[B+(x<<2)>>2]|0)>>2];x=x+1|0}while((x|0)!=(e|0))}break}case 6:{if(o){x=f[q>>2]|0;B=g;A=0;while(1){z=w+(f[x+(A<<2)>>2]|0)|0;d[B>>1]=d[z>>1]|0;d[B+2>>1]=d[z+2>>1]|0;d[B+4>>1]=d[z+4>>1]|0;A=A+1|0;if((A|0)==(e|0))break;else B=B+6|0}}break}case 8:{if(o){B=f[q>>2]|0;A=g;x=0;while(1){z=w+(f[B+(x<<2)>>2]|0)|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];x=x+1|0;if((x|0)==(e|0))break;else A=A+8|0}}break}case 12:{if(o){A=f[q>>2]|0;x=g;B=0;while(1){z=w+(f[A+(B<<2)>>2]|0)|0;f[x>>2]=f[z>>2];f[x+4>>2]=f[z+4>>2];f[x+8>>2]=f[z+8>>2];B=B+1|0;if((B|0)==(e|0))break;else x=x+12|0}}break}default:if(o){x=f[q>>2]|0;B=g;A=0;z=f[r>>2]|0;while(1){C=w+(f[x+(A<<2)>>2]|0)|0;if((z|0)>0){D=0;do{f[B+(D<<2)>>2]=f[C+(D<<2)>>2];D=D+1|0;E=f[r>>2]|0}while((D|0)<(E|0));F=E}else F=z;A=A+1|0;if((A|0)==(e|0))break;else{B=B+h|0;z=F}}}}u=u+1|0}while((u|0)<(f[i>>2]|0));return}function tha(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?142:141;break}case 2:{t=(c|0)>2?144:143;break}case 3:{t=(c|0)>2?146:145;break}case 4:{t=(c|0)>2?148:147;break}default:t=(c|0)>2?150:149}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;tmb(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;tmb(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=i+h<<3;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=N5b(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<2)|0;if((h|0)>0){F=0;do{Gia(q,F,D+(F<<2)|0,z+(F<<2)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{Gia(r,w,C+(w<<2)|0,E+(w<<2)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=57348;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;RQ(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)P5b(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function uha(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?152:151;break}case 2:{t=(c|0)>2?154:153;break}case 3:{t=(c|0)>2?156:155;break}case 4:{t=(c|0)>2?158:157;break}default:t=(c|0)>2?160:159}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;tmb(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;tmb(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=(i+h|0)*12|0;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=N5b(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<1<<2)|0;if((h|0)>0){F=0;do{tia(q,F,D+(F<<2)|0,z+(F<<1<<2)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{tia(r,w,C+(w<<2)|0,E+(w<<1<<2)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=57328;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;RQ(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)P5b(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function vha(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?162:161;break}case 2:{t=(c|0)>2?164:163;break}case 3:{t=(c|0)>2?166:165;break}case 4:{t=(c|0)>2?168:167;break}default:t=(c|0)>2?170:169}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;tmb(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;tmb(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=(i+h|0)*12|0;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=N5b(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<1<<2)|0;if((h|0)>0){F=0;do{gia(q,F,D+(F<<2)|0,z+(F<<1<<2)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{gia(r,w,C+(w<<2)|0,E+(w<<1<<2)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=57308;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;RQ(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)P5b(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function wha(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?172:171;break}case 2:{t=(c|0)>2?174:173;break}case 3:{t=(c|0)>2?176:175;break}case 4:{t=(c|0)>2?178:177;break}default:t=(c|0)>2?180:179}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;tmb(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;tmb(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=(i+h|0)*12|0;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=N5b(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<1<<2)|0;if((h|0)>0){F=0;do{Vha(q,F,D+(F<<2)|0,z+(F<<1<<2)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{Vha(r,w,C+(w<<2)|0,E+(w<<1<<2)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=57288;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;RQ(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)P5b(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function xha(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+1184|0;n=m+128|0;o=m+48|0;q=m+24|0;r=m;s=m+1168|0;switch(j|0){case 1:{t=(c|0)>2?182:181;break}case 2:{t=(c|0)>2?184:183;break}case 3:{t=(c|0)>2?186:185;break}case 4:{t=(c|0)>2?188:187;break}default:t=(c|0)>2?190:189}v=n;f[v>>2]=0;f[v+4>>2]=1072693248;p[o>>3]=k;tmb(q,n,o);f[q+8>>2]=c;v=q+12|0;f[v>>2]=0;w=q+16|0;f[w>>2]=h;x=n;f[x>>2]=0;f[x+4>>2]=1072693248;p[o>>3]=l;tmb(r,n,o);f[r+8>>2]=d;x=r+12|0;f[x>>2]=0;y=r+16|0;f[y>>2]=i;z=(i+h|0)*20|0;A=n+8|0;f[n>>2]=A;B=n+4|0;f[B>>2]=z;if(z>>>0>1032){C=N5b(z)|0;f[n>>2]=C;D=C}else D=A;C=D+(h<<2)|0;z=C+(i<<2)|0;E=z+(h<<1<<3)|0;if((h|0)>0){F=0;do{Iha(q,F,D+(F<<2)|0,z+(F<<1<<3)|0);F=F+1|0}while((F|0)<(h|0))}F=f[v>>2]|0;v=f[w>>2]|0;if((i|0)>0){w=0;do{Iha(r,w,C+(w<<2)|0,E+(w<<1<<3)|0);w=w+1|0}while((w|0)<(i|0))}w=f[x>>2]|0;x=f[y>>2]|0;f[o>>2]=57268;f[o+4>>2]=a;f[o+8>>2]=b;f[o+12>>2]=c;f[o+16>>2]=d;f[o+20>>2]=e;f[o+24>>2]=g;f[o+28>>2]=h;f[o+32>>2]=i;f[o+36>>2]=j;f[o+40>>2]=D;f[o+44>>2]=C;f[o+48>>2]=z;f[o+52>>2]=E;f[o+56>>2]=F;f[o+60>>2]=v;f[o+64>>2]=w;f[o+68>>2]=x;f[o+72>>2]=t;f[s>>2]=0;f[s+4>>2]=i;RQ(s,o,+(Y(i,h)|0)*.0000152587890625);h=f[n>>2]|0;if((h|0)==(A|0)){u=m;return}if(h|0)P5b(h);f[n>>2]=A;f[B>>2]=1032;u=m;return}function yha(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=f[a>>2]|0;if((g|0)>0){j=0;k=e;while(1){l=k;f[l>>2]=0;f[l+4>>2]=b;j=j+1|0;if((j|0)==(g|0))break;else k=k+8|0}m=d+(g<<1<<3)|0;n=g;o=e+(g<<3)|0}else{m=d;n=0;o=e}if((n|0)<(h|0)){e=m;m=n;d=o;while(1){g=a+(f[c+(m<<2)>>2]<<2)|0;k=e;j=f[g>>2]|0;b=cbc(j|0,((j|0)<0)<<31>>31|0,f[k>>2]|0,f[k+4>>2]|0)|0;k=J;j=e+8|0;l=f[g+4>>2]|0;g=cbc(l|0,((l|0)<0)<<31>>31|0,f[j>>2]|0,f[j+4>>2]|0)|0;j=Kac(g|0,J|0,b|0,k|0)|0;k=d;f[k>>2]=j;f[k+4>>2]=J;m=m+1|0;if((m|0)==(h|0))break;else{e=e+16|0;d=d+8|0}}p=h;q=o+(h-n<<3)|0}else{p=n;q=o}o=f[a+(f[c+(i+-1<<2)>>2]<<2)>>2]|0;if((p|0)<(i|0)){r=p;s=q}else return;while(1){q=s;f[q>>2]=0;f[q+4>>2]=o;r=r+1|0;if((r|0)==(i|0))break;else s=s+8|0}return}function zha(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Hha(a,b,c,d,e,f,g,h);return}function Aha(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=f[a>>2]|0;j=f[a+4>>2]|0;if((g|0)>0){k=g<<1;l=0;m=e;while(1){n=m;f[n>>2]=0;f[n+4>>2]=b;n=m+8|0;f[n>>2]=0;f[n+4>>2]=j;l=l+1|0;if((l|0)==(g|0))break;else m=m+16|0}o=d+(k<<3)|0;p=g;q=e+(k<<3)|0}else{o=d;p=0;q=e}if((p|0)<(h|0)){e=h-p|0;d=p;k=o;o=q;while(1){g=a+(f[c+(d<<2)>>2]<<1<<2)|0;m=k;l=f[g>>2]|0;j=cbc(l|0,((l|0)<0)<<31>>31|0,f[m>>2]|0,f[m+4>>2]|0)|0;m=J;l=k+8|0;b=l;n=f[g+8>>2]|0;r=cbc(n|0,((n|0)<0)<<31>>31|0,f[b>>2]|0,f[b+4>>2]|0)|0;b=Kac(r|0,J|0,j|0,m|0)|0;m=o;f[m>>2]=b;f[m+4>>2]=J;m=k;b=f[g+4>>2]|0;j=cbc(b|0,((b|0)<0)<<31>>31|0,f[m>>2]|0,f[m+4>>2]|0)|0;m=J;b=l;l=f[g+12>>2]|0;g=cbc(l|0,((l|0)<0)<<31>>31|0,f[b>>2]|0,f[b+4>>2]|0)|0;b=Kac(g|0,J|0,j|0,m|0)|0;m=o+8|0;f[m>>2]=b;f[m+4>>2]=J;d=d+1|0;if((d|0)==(h|0))break;else{k=k+16|0;o=o+16|0}}s=h;t=q+(e<<1<<3)|0}else{s=p;t=q}q=a+(f[c+(i+-1<<2)>>2]<<1<<2)|0;c=f[q>>2]|0;a=f[q+4>>2]|0;if((s|0)<(i|0)){u=s;v=t}else return;while(1){t=v;f[t>>2]=0;f[t+4>>2]=c;t=v+8|0;f[t>>2]=0;f[t+4>>2]=a;u=u+1|0;if((u|0)==(i|0))break;else v=v+16|0}return}function Bha(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Hha(a,b,c,d,e,f,g,h);return}function Cha(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=f[a>>2]|0;j=f[a+4>>2]|0;k=f[a+8>>2]|0;if((g|0)>0){l=g*3|0;m=0;n=e;while(1){o=n;f[o>>2]=0;f[o+4>>2]=b;o=n+8|0;f[o>>2]=0;f[o+4>>2]=j;o=n+16|0;f[o>>2]=0;f[o+4>>2]=k;m=m+1|0;if((m|0)==(g|0))break;else n=n+24|0}p=d+(g<<1<<3)|0;q=g;r=e+(l<<3)|0}else{p=d;q=0;r=e}if((q|0)<(h|0)){e=h-q|0;d=q;l=r;g=p;while(1){p=a+((f[c+(d<<2)>>2]|0)*3<<2)|0;n=g;m=f[p>>2]|0;k=cbc(m|0,((m|0)<0)<<31>>31|0,f[n>>2]|0,f[n+4>>2]|0)|0;n=J;m=g+8|0;j=m;b=f[p+12>>2]|0;o=cbc(b|0,((b|0)<0)<<31>>31|0,f[j>>2]|0,f[j+4>>2]|0)|0;j=Kac(o|0,J|0,k|0,n|0)|0;n=l;f[n>>2]=j;f[n+4>>2]=J;n=g;j=f[p+4>>2]|0;k=cbc(j|0,((j|0)<0)<<31>>31|0,f[n>>2]|0,f[n+4>>2]|0)|0;n=J;j=m;o=f[p+16>>2]|0;b=cbc(o|0,((o|0)<0)<<31>>31|0,f[j>>2]|0,f[j+4>>2]|0)|0;j=Kac(b|0,J|0,k|0,n|0)|0;n=l+8|0;f[n>>2]=j;f[n+4>>2]=J;n=g;j=f[p+8>>2]|0;k=cbc(j|0,((j|0)<0)<<31>>31|0,f[n>>2]|0,f[n+4>>2]|0)|0;n=J;j=m;m=f[p+20>>2]|0;p=cbc(m|0,((m|0)<0)<<31>>31|0,f[j>>2]|0,f[j+4>>2]|0)|0;j=Kac(p|0,J|0,k|0,n|0)|0;n=l+16|0;f[n>>2]=j;f[n+4>>2]=J;d=d+1|0;if((d|0)==(h|0))break;else{l=l+24|0;g=g+16|0}}s=h;t=r+(e*3<<3)|0}else{s=q;t=r}r=a+((f[c+(i+-1<<2)>>2]|0)*3<<2)|0;c=f[r>>2]|0;a=f[r+4>>2]|0;q=f[r+8>>2]|0;if((s|0)<(i|0)){u=t;v=s}else return;while(1){s=u;f[s>>2]=0;f[s+4>>2]=c;s=u+8|0;f[s>>2]=0;f[s+4>>2]=a;s=u+16|0;f[s>>2]=0;f[s+4>>2]=q;v=v+1|0;if((v|0)==(i|0))break;else u=u+24|0}return}function Dha(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Hha(a,b,c,d,e,f,g,h);return}function Eha(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=f[a>>2]|0;j=f[a+4>>2]|0;k=f[a+8>>2]|0;l=f[a+12>>2]|0;if((g|0)>0){m=g<<2;n=0;o=e;while(1){p=o;f[p>>2]=0;f[p+4>>2]=b;p=o+8|0;f[p>>2]=0;f[p+4>>2]=j;p=o+16|0;f[p>>2]=0;f[p+4>>2]=k;p=o+24|0;f[p>>2]=0;f[p+4>>2]=l;n=n+1|0;if((n|0)==(g|0))break;else o=o+32|0}q=d+(g<<1<<3)|0;r=g;s=e+(m<<3)|0}else{q=d;r=0;s=e}if((r|0)<(h|0)){e=h-r|0;d=r;m=s;g=q;while(1){q=a+(f[c+(d<<2)>>2]<<2<<2)|0;o=g;n=f[q>>2]|0;l=cbc(n|0,((n|0)<0)<<31>>31|0,f[o>>2]|0,f[o+4>>2]|0)|0;o=J;n=g+8|0;k=n;j=f[q+16>>2]|0;b=cbc(j|0,((j|0)<0)<<31>>31|0,f[k>>2]|0,f[k+4>>2]|0)|0;k=Kac(b|0,J|0,l|0,o|0)|0;o=m;f[o>>2]=k;f[o+4>>2]=J;o=g;k=f[q+4>>2]|0;l=cbc(k|0,((k|0)<0)<<31>>31|0,f[o>>2]|0,f[o+4>>2]|0)|0;o=J;k=n;b=f[q+20>>2]|0;j=cbc(b|0,((b|0)<0)<<31>>31|0,f[k>>2]|0,f[k+4>>2]|0)|0;k=Kac(j|0,J|0,l|0,o|0)|0;o=m+8|0;f[o>>2]=k;f[o+4>>2]=J;o=g;k=f[q+8>>2]|0;l=cbc(k|0,((k|0)<0)<<31>>31|0,f[o>>2]|0,f[o+4>>2]|0)|0;o=J;k=n;j=f[q+24>>2]|0;b=cbc(j|0,((j|0)<0)<<31>>31|0,f[k>>2]|0,f[k+4>>2]|0)|0;k=Kac(b|0,J|0,l|0,o|0)|0;o=m+16|0;f[o>>2]=k;f[o+4>>2]=J;o=g;k=f[q+12>>2]|0;l=cbc(k|0,((k|0)<0)<<31>>31|0,f[o>>2]|0,f[o+4>>2]|0)|0;o=J;k=n;n=f[q+28>>2]|0;q=cbc(n|0,((n|0)<0)<<31>>31|0,f[k>>2]|0,f[k+4>>2]|0)|0;k=Kac(q|0,J|0,l|0,o|0)|0;o=m+24|0;f[o>>2]=k;f[o+4>>2]=J;d=d+1|0;if((d|0)==(h|0))break;else{m=m+32|0;g=g+16|0}}t=h;u=s+(e<<2<<3)|0}else{t=r;u=s}s=a+(f[c+(i+-1<<2)>>2]<<2<<2)|0;c=f[s>>2]|0;a=f[s+4>>2]|0;r=f[s+8>>2]|0;e=f[s+12>>2]|0;if((t|0)<(i|0)){v=u;w=t}else return;while(1){t=v;f[t>>2]=0;f[t+4>>2]=c;t=v+8|0;f[t>>2]=0;f[t+4>>2]=a;t=v+16|0;f[t>>2]=0;f[t+4>>2]=r;t=v+24|0;f[t>>2]=0;f[t+4>>2]=e;w=w+1|0;if((w|0)==(i|0))break;else v=v+32|0}return}function Fha(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Hha(a,b,c,d,e,f,g,h);return}function Gha(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;do if((g|0)>0){j=g<<1;if((b|0)<=0){k=d+(j<<3)|0;l=e;m=g;break}n=Y(g,b)|0;o=e;p=0;while(1){q=0;r=o;while(1){s=f[a+(q<<2)>>2]|0;t=r;f[t>>2]=0;f[t+4>>2]=s;q=q+1|0;if((q|0)==(b|0))break;else r=r+8|0}p=p+1|0;if((p|0)==(g|0))break;else o=o+(b<<3)|0}k=d+(j<<3)|0;l=e+(n<<3)|0;m=g}else{k=d;l=e;m=0}while(0);if((m|0)<(h|0))if((b|0)>0){e=l+((Y(h-m|0,b)|0)<<3)|0;d=m;g=k;k=l;while(1){o=a+((Y(f[c+(d<<2)>>2]|0,b)|0)<<2)|0;p=g+8|0;r=0;q=k;while(1){s=g;t=f[o+(r<<2)>>2]|0;u=cbc(t|0,((t|0)<0)<<31>>31|0,f[s>>2]|0,f[s+4>>2]|0)|0;s=J;t=q;f[t>>2]=u;f[t+4>>2]=s;t=p;v=f[o+(r+b<<2)>>2]|0;w=cbc(v|0,((v|0)<0)<<31>>31|0,f[t>>2]|0,f[t+4>>2]|0)|0;t=Kac(w|0,J|0,u|0,s|0)|0;s=q;f[s>>2]=t;f[s+4>>2]=J;r=r+1|0;if((r|0)==(b|0))break;else q=q+8|0}d=d+1|0;if((d|0)==(h|0)){x=h;y=e;break}else{g=g+16|0;k=k+(b<<3)|0}}}else{x=h;y=l}else{x=m;y=l}l=a+((Y(f[c+(i+-1<<2)>>2]|0,b)|0)<<2)|0;if((x|0)<(i|0)&(b|0)>0){z=x;A=y}else return;while(1){y=0;x=A;while(1){c=f[l+(y<<2)>>2]|0;a=x;f[a>>2]=0;f[a+4>>2]=c;y=y+1|0;if((y|0)==(b|0))break;else x=x+8|0}z=z+1|0;if((z|0)==(i|0))break;else A=A+(b<<3)|0}return}function Hha(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;do if((g|0)>0){j=g<<1;if((b|0)<=0){k=d+(j<<3)|0;l=e;m=g;break}n=Y(g,b)|0;o=e;p=0;while(1){q=0;r=o;while(1){s=f[a+(q<<2)>>2]|0;t=r;f[t>>2]=0;f[t+4>>2]=s;q=q+1|0;if((q|0)==(b|0))break;else r=r+8|0}p=p+1|0;if((p|0)==(g|0))break;else o=o+(b<<3)|0}k=d+(j<<3)|0;l=e+(n<<3)|0;m=g}else{k=d;l=e;m=0}while(0);if((m|0)<(h|0))if((b|0)>0){e=l+((Y(h-m|0,b)|0)<<3)|0;d=k;k=m;g=l;while(1){o=a+((Y(f[c+(k<<2)>>2]|0,b)|0)<<2)|0;p=d+8|0;r=0;q=g;while(1){s=d;t=f[s>>2]|0;u=f[s+4>>2]|0;if((t|0)==0&(u|0)==0){v=0;w=0}else{s=f[o+(r<<2)>>2]|0;x=cbc(s|0,((s|0)<0)<<31>>31|0,t|0,u|0)|0;v=x;w=J}x=q;f[x>>2]=v;f[x+4>>2]=w;x=p;u=f[x>>2]|0;t=f[x+4>>2]|0;if((u|0)==0&(t|0)==0){y=0;z=0}else{x=f[o+(r+b<<2)>>2]|0;s=cbc(x|0,((x|0)<0)<<31>>31|0,u|0,t|0)|0;y=s;z=J}s=Kac(v|0,w|0,y|0,z|0)|0;t=q;f[t>>2]=s;f[t+4>>2]=J;r=r+1|0;if((r|0)==(b|0))break;else q=q+8|0}k=k+1|0;if((k|0)==(h|0)){A=h;B=e;break}else{d=d+16|0;g=g+(b<<3)|0}}}else{A=h;B=l}else{A=m;B=l}l=a+((Y(f[c+(i+-1<<2)>>2]|0,b)|0)<<2)|0;if((A|0)<(i|0)&(b|0)>0){C=A;D=B}else return;while(1){B=0;A=D;while(1){c=f[l+(B<<2)>>2]|0;a=A;f[a>>2]=0;f[a+4>>2]=c;B=B+1|0;if((B|0)==(b|0))break;else A=A+8|0}C=C+1|0;if((C|0)==(i|0))break;else D=D+(b<<3)|0}return}function Iha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+16|0;l=e+8|0;m=e;gmb(j,b);p[h>>3]=.5;omb(g,j,h);smb(k,a,g);p[l>>3]=.5;rmb(i,k,l);k=lmb(i)|0;if((k|0)>-1?(j=f[a+8>>2]|0,(j|0)>1):0){n=j+-1|0;if((k|0)<(n|0)){f[c>>2]=k;gmb(m,k);rmb(l,i,m);hmb(h,0,1);smb(g,l,h);h=mmb(g)|0;g=J;l=d+8|0;f[l>>2]=h;f[l+4>>2]=g;l=Jac(0,1,h|0,g|0)|0;g=d;f[g>>2]=l;f[g+4>>2]=J;u=e;return}else{f[c>>2]=n;n=a+16|0;c=f[n>>2]|0;f[n>>2]=(c|0)>(b|0)?b:c;u=e;return}}c=a+12|0;a=b+1|0;b=f[c>>2]|0;f[c>>2]=(b|0)<(a|0)?a:b;u=e;return}function Jha(a){a=a|0;O5b(a);return}function Kha(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;c=u;u=u+1120|0;d=c+16|0;e=c;g=a+28|0;h=f[g>>2]|0;i=a+36|0;j=f[i>>2]|0;k=Y(h<<1,j)|0;l=d+8|0;Nac(l|0,0,1088)|0;f[d>>2]=l;m=d+4|0;f[m>>2]=k;if(k>>>0>136){n=N5b(k>>>0>536870911?-1:k<<3)|0;Nac(n|0,0,k<<3|0)|0;f[d>>2]=n;o=n}else o=l;n=f[a+64>>2]|0;k=f[b>>2]|0;p=(n|0)<(k|0)?k:n;q=b+4|0;r=f[q>>2]|0;s=f[a+68>>2]|0;t=(r|0)<(s|0)?r:s;if((k|0)<(n|0)){Hh[f[a+72>>2]&255](f[a+4>>2]|0,j,f[a+40>>2]|0,f[a+48>>2]|0,o,f[a+56>>2]|0,f[a+60>>2]|0,h);v=-1;w=1;x=f[b>>2]|0}else{v=-2;w=0;x=k}if((x|0)<(p|0)){k=f[d>>2]|0;b=f[a+20>>2]|0;h=a+24|0;o=x;do{j=b+(Y(f[h>>2]|0,o)|0)|0;n=Y(f[i>>2]|0,f[g>>2]|0)|0;if((n|0)>0){s=0;do{r=k+(s<<3)|0;y=Kac(f[r>>2]|0,f[r+4>>2]|0,-2147483648,0)|0;r=Rac(y|0,J|0,32)|0;y=J;z=Kac(r|0,y|0,-2147483648,0)|0;A=J;f[j+(s<<2)>>2]=A>>>0<1|(A|0)==1&z>>>0<0?r:(y|0)>0|(y|0)==0&r>>>0>0?2147483647:-2147483648;s=s+1|0}while((s|0)!=(n|0))}o=o+1|0}while((o|0)<(p|0));B=p}else B=x;if((B|0)<(t|0)){x=a+44|0;p=a+16|0;o=a+20|0;k=a+24|0;h=e+8|0;b=a+52|0;n=a+72|0;s=a+4|0;j=a+8|0;r=a+40|0;y=a+48|0;z=a+56|0;A=a+60|0;C=v;D=w;E=B;F=0;while(1){G=B+F<<1;H=(f[x>>2]|0)+(E<<2)|0;I=C+2|0;K=f[H>>2]|0;L=(K|0)<(I|0)?I:K;I=K+2|0;M=f[p>>2]|0;if((L|0)<(((M|0)<(I|0)?M:I)|0)){I=L;L=D;while(1){N=(f[s>>2]|0)+(Y(f[j>>2]|0,I)|0)|0;O=f[i>>2]|0;P=f[g>>2]|0;Q=(f[d>>2]|0)+((Y(Y(O,L)|0,P)|0)<<3)|0;Hh[f[n>>2]&255](N,O,f[r>>2]|0,f[y>>2]|0,Q,f[z>>2]|0,f[A>>2]|0,P);I=I+1|0;P=(L+1|0)%2|0;Q=f[H>>2]|0;O=Q+2|0;N=f[p>>2]|0;if((I|0)>=(((N|0)<(O|0)?N:O)|0)){R=P;S=N;T=Q;break}else L=P}}else{R=D;S=M;T=K}L=S+-2|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;I=(((T|0)<(L|0)?L:T)+R-((C|0)<(L|0)?L:C)|0)%2|0;if((I|0)>0){Vac(e|0,(f[b>>2]|0)+((E<<1)+2-I<<3)|0,I<<3|0)|0;U=I}else U=0;Vac(e+(U<<3)|0,(f[b>>2]|0)+(U+G-I<<3)|0,16-(U<<3)|0)|0;L=f[d>>2]|0;H=Y(f[i>>2]|0,f[g>>2]|0)|0;P=(f[o>>2]|0)+(Y(f[k>>2]|0,E)|0)|0;if((H|0)>0){Q=e;N=f[Q>>2]|0;O=f[Q+4>>2]|0;Q=Rac(N|0,O|0,63)|0;V=J;W=Jac(Q^N|0,V^O|0,Q|0,V|0)|0;O=J;N=h;X=f[N>>2]|0;Z=f[N+4>>2]|0;N=Rac(X|0,Z|0,63)|0;_=J;$=Jac(N^X|0,_^Z|0,N|0,_|0)|0;Z=J;X=0;do{aa=L+(X<<3)|0;ba=f[aa>>2]|0;ca=f[aa+4>>2]|0;aa=Rac(ba|0,ca|0,63)|0;da=J;ea=Jac(aa^ba|0,da^ca|0,aa|0,da|0)|0;ca=J;ba=cbc(ea|0,0,W|0,0)|0;Kac(ba|0,J|0,-2147483648,0)|0;ba=J;fa=cbc(ca|0,0,W|0,0)|0;ga=J;ha=cbc(ea|0,0,O|0,0)|0;ea=J;ia=cbc(ca|0,0,O|0,0)|0;ca=Kac(fa|0,0,ha|0,0)|0;ha=Kac(ca|0,J|0,ba|0,0)|0;ba=J;ca=Kac(ia|0,0,ga|0,0)|0;ga=Kac(ca|0,J|0,ea|0,0)|0;ea=Kac(ga|0,J|0,ba|0,0)|0;ga=J;ca=(aa|0)==(Q|0)&(da|0)==(V|0);da=Kac(~ha|0,ba|0,1,0)|0;ba=(da|0)!=0|0!=0;aa=Jac(0,0,ea|0,ga|0)|0;ia=ba?~ea:aa;aa=ba?ga:J;ga=ca?ha:da;da=ca?ea:ia;ia=L+(X+H<<3)|0;ea=f[ia>>2]|0;ca=f[ia+4>>2]|0;ia=Rac(ea|0,ca|0,63)|0;ha=J;ba=Jac(ia^ea|0,ha^ca|0,ia|0,ha|0)|0;ca=J;ea=cbc(ba|0,0,$|0,0)|0;Kac(ea|0,J|0,-2147483648,0)|0;ea=J;aa=cbc(ca|0,0,$|0,0)|0;fa=J;ja=cbc(ba|0,0,Z|0,0)|0;ba=J;ka=cbc(ca|0,0,Z|0,0)|0;ca=Kac(aa|0,0,ja|0,0)|0;ja=Kac(ca|0,J|0,ea|0,0)|0;ea=J;ca=Kac(ka|0,0,fa|0,0)|0;fa=Kac(ca|0,J|0,ba|0,0)|0;ba=Kac(fa|0,J|0,ea|0,0)|0;fa=J;ca=(ia|0)==(N|0)&(ha|0)==(_|0);ha=Kac(~ja|0,ea|0,1,0)|0;ea=(ha|0)!=0|0!=0;ia=Jac(0,0,ba|0,fa|0)|0;ka=ea?~ba:ia;ia=ea?fa:J;fa=ca?ja:ha;ha=ca?ba:ka;ka=Kac(ga|0,da|0,-2147483648,0)|0;da=Kac(ka|0,J|0,fa|0,ha|0)|0;ha=Rac(da|0,J|0,32)|0;da=J;fa=Kac(ha|0,da|0,-2147483648,0)|0;ka=J;f[P+(X<<2)>>2]=ka>>>0<1|(ka|0)==1&fa>>>0<0?ha:(da|0)>0|(da|0)==0&ha>>>0>0?2147483647:-2147483648;X=X+1|0}while((X|0)!=(H|0))}H=E+1|0;if((H|0)<(t|0)){C=T;D=I;E=H;F=F+1|0}else{la=T;ma=I;na=H;oa=L;pa=p;break}}}else{la=v;ma=w;na=B;oa=f[d>>2]|0;pa=a+16|0}B=f[pa>>2]|0;if((la+2|0)>(B|0))qa=oa+((Y(Y(f[g>>2]|0,(ma+~la+B|0)%2|0)|0,f[i>>2]|0)|0)<<3)|0;else{la=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,B+-1|0)|0)|0;Hh[f[a+72>>2]&255](la,f[i>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,oa,f[a+56>>2]|0,f[a+60>>2]|0,f[g>>2]|0);qa=oa}oa=f[q>>2]|0;if((na|0)<(oa|0)){la=f[a+20>>2]|0;B=a+24|0;a=na;na=oa;while(1){oa=la+(Y(f[B>>2]|0,a)|0)|0;ma=Y(f[i>>2]|0,f[g>>2]|0)|0;if((ma|0)>0){pa=0;do{w=qa+(pa<<3)|0;v=Kac(f[w>>2]|0,f[w+4>>2]|0,-2147483648,0)|0;w=Rac(v|0,J|0,32)|0;v=J;p=Kac(w|0,v|0,-2147483648,0)|0;T=J;f[oa+(pa<<2)>>2]=T>>>0<1|(T|0)==1&p>>>0<0?w:(v|0)>0|(v|0)==0&w>>>0>0?2147483647:-2147483648;pa=pa+1|0}while((pa|0)!=(ma|0));ra=f[q>>2]|0}else ra=na;a=a+1|0;if((a|0)>=(ra|0))break;else na=ra}}ra=f[d>>2]|0;if((ra|0)==(l|0)){u=c;return}if(ra|0)P5b(ra);f[d>>2]=l;f[m>>2]=136;u=c;return}function Lha(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=j[a>>1]<<16;if((h|0)>0){l=0;m=g;while(1){f[m>>2]=b;l=l+1|0;if((l|0)==(h|0))break;else m=m+4|0}n=e+(h<<1<<2)|0;o=h;p=g+(h<<2)|0}else{n=e;o=0;p=g}if((o|0)<(i|0)){g=n;n=o;e=p;while(1){h=a+(f[c+(n<<2)>>2]<<1)|0;m=Y(d[h>>1]|0,f[g>>2]|0)|0;l=(Y(d[h+2>>1]|0,f[g+4>>2]|0)|0)+m|0;f[e>>2]=l;n=n+1|0;if((n|0)==(i|0))break;else{g=g+8|0;e=e+4|0}}q=i;r=p+(i-o<<2)|0}else{q=o;r=p}p=j[a+(f[c+(k+-1<<2)>>2]<<1)>>1]<<16;if((q|0)<(k|0)){s=q;t=r}else return;while(1){f[t>>2]=p;s=s+1|0;if((s|0)==(k|0))break;else t=t+4|0}return}function Mha(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Uha(a,b,c,d,e,f,g,h);return}function Nha(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=j[a>>1]<<16;l=j[a+2>>1]<<16;if((h|0)>0){m=h<<1;n=0;o=g;while(1){f[o>>2]=b;f[o+4>>2]=l;n=n+1|0;if((n|0)==(h|0))break;else o=o+8|0}p=e+(m<<2)|0;q=h;r=g+(m<<2)|0}else{p=e;q=0;r=g}if((q|0)<(i|0)){g=i-q|0;e=q;m=p;p=r;while(1){h=a+(f[c+(e<<2)>>2]<<1<<1)|0;o=Y(d[h>>1]|0,f[m>>2]|0)|0;n=m+4|0;l=(Y(d[h+4>>1]|0,f[n>>2]|0)|0)+o|0;f[p>>2]=l;l=Y(d[h+2>>1]|0,f[m>>2]|0)|0;o=(Y(d[h+6>>1]|0,f[n>>2]|0)|0)+l|0;f[p+4>>2]=o;e=e+1|0;if((e|0)==(i|0))break;else{m=m+8|0;p=p+8|0}}s=i;t=r+(g<<1<<2)|0}else{s=q;t=r}r=a+(f[c+(k+-1<<2)>>2]<<1<<1)|0;c=j[r>>1]<<16;a=j[r+2>>1]<<16;if((s|0)<(k|0)){u=s;v=t}else return;while(1){f[v>>2]=c;f[v+4>>2]=a;u=u+1|0;if((u|0)==(k|0))break;else v=v+8|0}return}function Oha(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Uha(a,b,c,d,e,f,g,h);return}function Pha(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=j[a>>1]<<16;l=j[a+2>>1]<<16;m=j[a+4>>1]<<16;if((h|0)>0){n=h*3|0;o=0;p=g;while(1){f[p>>2]=b;f[p+4>>2]=l;f[p+8>>2]=m;o=o+1|0;if((o|0)==(h|0))break;else p=p+12|0}q=e+(h<<1<<2)|0;r=h;s=g+(n<<2)|0}else{q=e;r=0;s=g}if((r|0)<(i|0)){g=i-r|0;e=r;n=s;h=q;while(1){q=a+((f[c+(e<<2)>>2]|0)*3<<1)|0;p=Y(d[q>>1]|0,f[h>>2]|0)|0;o=h+4|0;m=(Y(d[q+6>>1]|0,f[o>>2]|0)|0)+p|0;f[n>>2]=m;m=Y(d[q+2>>1]|0,f[h>>2]|0)|0;p=(Y(d[q+8>>1]|0,f[o>>2]|0)|0)+m|0;f[n+4>>2]=p;p=Y(d[q+4>>1]|0,f[h>>2]|0)|0;m=(Y(d[q+10>>1]|0,f[o>>2]|0)|0)+p|0;f[n+8>>2]=m;e=e+1|0;if((e|0)==(i|0))break;else{n=n+12|0;h=h+8|0}}t=i;u=s+(g*3<<2)|0}else{t=r;u=s}s=a+((f[c+(k+-1<<2)>>2]|0)*3<<1)|0;c=j[s>>1]<<16;a=j[s+2>>1]<<16;r=j[s+4>>1]<<16;if((t|0)<(k|0)){v=u;w=t}else return;while(1){f[v>>2]=c;f[v+4>>2]=a;f[v+8>>2]=r;w=w+1|0;if((w|0)==(k|0))break;else v=v+12|0}return}function Qha(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Uha(a,b,c,d,e,f,g,h);return}function Rha(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=j[a>>1]<<16;l=j[a+2>>1]<<16;m=j[a+4>>1]<<16;n=j[a+6>>1]<<16;if((h|0)>0){o=h<<2;p=0;q=g;while(1){f[q>>2]=b;f[q+4>>2]=l;f[q+8>>2]=m;f[q+12>>2]=n;p=p+1|0;if((p|0)==(h|0))break;else q=q+16|0}r=e+(h<<1<<2)|0;s=h;t=g+(o<<2)|0}else{r=e;s=0;t=g}if((s|0)<(i|0)){g=i-s|0;e=s;o=t;h=r;while(1){r=a+(f[c+(e<<2)>>2]<<2<<1)|0;q=Y(d[r>>1]|0,f[h>>2]|0)|0;p=h+4|0;n=(Y(d[r+8>>1]|0,f[p>>2]|0)|0)+q|0;f[o>>2]=n;n=Y(d[r+2>>1]|0,f[h>>2]|0)|0;q=(Y(d[r+10>>1]|0,f[p>>2]|0)|0)+n|0;f[o+4>>2]=q;q=Y(d[r+4>>1]|0,f[h>>2]|0)|0;n=(Y(d[r+12>>1]|0,f[p>>2]|0)|0)+q|0;f[o+8>>2]=n;n=Y(d[r+6>>1]|0,f[h>>2]|0)|0;q=(Y(d[r+14>>1]|0,f[p>>2]|0)|0)+n|0;f[o+12>>2]=q;e=e+1|0;if((e|0)==(i|0))break;else{o=o+16|0;h=h+8|0}}u=i;v=t+(g<<2<<2)|0}else{u=s;v=t}t=a+(f[c+(k+-1<<2)>>2]<<2<<1)|0;c=j[t>>1]<<16;a=j[t+2>>1]<<16;s=j[t+4>>1]<<16;g=j[t+6>>1]<<16;if((u|0)<(k|0)){w=v;x=u}else return;while(1){f[w>>2]=c;f[w+4>>2]=a;f[w+8>>2]=s;f[w+12>>2]=g;x=x+1|0;if((x|0)==(k|0))break;else w=w+16|0}return}function Sha(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Uha(a,b,c,d,e,f,g,h);return}function Tha(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;do if((h|0)>0){l=h<<1;if((b|0)<=0){m=e+(l<<2)|0;n=g;o=h;break}p=Y(h,b)|0;q=g;r=0;while(1){s=0;t=q;while(1){f[t>>2]=j[a+(s<<1)>>1]<<16;s=s+1|0;if((s|0)==(b|0))break;else t=t+4|0}r=r+1|0;if((r|0)==(h|0))break;else q=q+(b<<2)|0}m=e+(l<<2)|0;n=g+(p<<2)|0;o=h}else{m=e;n=g;o=0}while(0);if((o|0)<(i|0))if((b|0)>0){g=n+((Y(i-o|0,b)|0)<<2)|0;e=o;h=m;m=n;while(1){q=a+((Y(f[c+(e<<2)>>2]|0,b)|0)<<1)|0;r=h+4|0;t=0;s=m;while(1){u=Y(d[q+(t<<1)>>1]|0,f[h>>2]|0)|0;f[s>>2]=u;v=(Y(d[q+(t+b<<1)>>1]|0,f[r>>2]|0)|0)+u|0;f[s>>2]=v;t=t+1|0;if((t|0)==(b|0))break;else s=s+4|0}e=e+1|0;if((e|0)==(i|0)){w=i;x=g;break}else{h=h+8|0;m=m+(b<<2)|0}}}else{w=i;x=n}else{w=o;x=n}n=a+((Y(f[c+(k+-1<<2)>>2]|0,b)|0)<<1)|0;if((w|0)<(k|0)&(b|0)>0){y=w;z=x}else return;while(1){x=0;w=z;while(1){f[w>>2]=j[n+(x<<1)>>1]<<16;x=x+1|0;if((x|0)==(b|0))break;else w=w+4|0}y=y+1|0;if((y|0)==(k|0))break;else z=z+(b<<2)|0}return}function Uha(a,b,c,e,g,h,i,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;do if((h|0)>0){l=h<<1;if((b|0)<=0){m=e+(l<<2)|0;n=g;o=h;break}p=Y(h,b)|0;q=g;r=0;while(1){s=0;t=q;while(1){f[t>>2]=j[a+(s<<1)>>1]<<16;s=s+1|0;if((s|0)==(b|0))break;else t=t+4|0}r=r+1|0;if((r|0)==(h|0))break;else q=q+(b<<2)|0}m=e+(l<<2)|0;n=g+(p<<2)|0;o=h}else{m=e;n=g;o=0}while(0);if((o|0)<(i|0))if((b|0)>0){g=n+((Y(i-o|0,b)|0)<<2)|0;e=m;m=o;h=n;while(1){q=a+((Y(f[c+(m<<2)>>2]|0,b)|0)<<1)|0;r=e+4|0;t=0;s=h;while(1){u=f[e>>2]|0;if(!u)v=0;else v=Y(d[q+(t<<1)>>1]|0,u)|0;f[s>>2]=v;u=f[r>>2]|0;if(!u)w=0;else w=Y(d[q+(t+b<<1)>>1]|0,u)|0;f[s>>2]=v+w;t=t+1|0;if((t|0)==(b|0))break;else s=s+4|0}m=m+1|0;if((m|0)==(i|0)){x=i;y=g;break}else{e=e+8|0;h=h+(b<<2)|0}}}else{x=i;y=n}else{x=o;y=n}n=a+((Y(f[c+(k+-1<<2)>>2]|0,b)|0)<<1)|0;if((x|0)<(k|0)&(b|0)>0){z=x;A=y}else return;while(1){y=0;x=A;while(1){f[x>>2]=j[n+(y<<1)>>1]<<16;y=y+1|0;if((y|0)==(b|0))break;else x=x+4|0}z=z+1|0;if((z|0)==(k|0))break;else A=A+(b<<2)|0}return}function Vha(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+16|0;l=e+8|0;m=e;gmb(j,b);p[h>>3]=.5;omb(g,j,h);smb(k,a,g);p[l>>3]=.5;rmb(i,k,l);k=lmb(i)|0;if((k|0)>-1?(j=f[a+8>>2]|0,(j|0)>1):0){n=j+-1|0;if((k|0)<(n|0)){f[c>>2]=k;gmb(m,k);rmb(l,i,m);gmb(h,65536);smb(g,l,h);h=kmb(g)|0;f[d+4>>2]=h;f[d>>2]=65536-h;u=e;return}else{f[c>>2]=n;n=a+16|0;c=f[n>>2]|0;f[n>>2]=(c|0)>(b|0)?b:c;u=e;return}}c=a+12|0;a=b+1|0;b=f[c>>2]|0;f[c>>2]=(b|0)<(a|0)?a:b;u=e;return}function Wha(a){a=a|0;O5b(a);return}function Xha(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;c=u;u=u+1072|0;e=c+8|0;g=c;h=a+28|0;i=f[h>>2]|0;j=a+36|0;k=f[j>>2]|0;l=Y(i<<1,k)|0;m=e+8|0;Nac(m|0,0,1056)|0;f[e>>2]=m;n=e+4|0;f[n>>2]=l;if(l>>>0>264){o=N5b(l>>>0>1073741823?-1:l<<2)|0;Nac(o|0,0,l<<2|0)|0;f[e>>2]=o;p=o}else p=m;o=f[a+64>>2]|0;l=f[b>>2]|0;q=(o|0)<(l|0)?l:o;r=b+4|0;s=f[r>>2]|0;t=f[a+68>>2]|0;v=(s|0)<(t|0)?s:t;if((l|0)<(o|0)){Hh[f[a+72>>2]&255](f[a+4>>2]|0,k,f[a+40>>2]|0,f[a+48>>2]|0,p,f[a+56>>2]|0,f[a+60>>2]|0,i);w=-1;x=1;y=f[b>>2]|0}else{w=-2;x=0;y=l}if((y|0)<(q|0)){l=f[e>>2]|0;b=f[a+20>>2]|0;i=f[a+24>>2]|0;p=Y(f[j>>2]|0,f[h>>2]|0)|0;if((p|0)>0){k=y;do{o=b+(Y(i,k)|0)|0;t=0;do{s=(f[l+(t<<2)>>2]|0)+32768>>16;d[o+(t<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;t=t+1|0}while((t|0)!=(p|0));k=k+1|0}while((k|0)<(q|0));z=q}else z=q}else z=y;if((z|0)<(v|0)){y=a+44|0;q=a+16|0;k=a+20|0;p=a+24|0;l=g+4|0;i=a+52|0;b=a+72|0;t=a+4|0;o=a+8|0;s=a+40|0;A=a+48|0;B=a+56|0;C=a+60|0;D=w;E=x;F=z;G=0;while(1){H=z+G<<1;I=(f[y>>2]|0)+(F<<2)|0;K=D+2|0;L=f[I>>2]|0;M=(L|0)<(K|0)?K:L;K=L+2|0;N=f[q>>2]|0;if((M|0)<(((N|0)<(K|0)?N:K)|0)){K=M;M=E;while(1){O=(f[t>>2]|0)+(Y(f[o>>2]|0,K)|0)|0;P=f[j>>2]|0;Q=f[h>>2]|0;R=(f[e>>2]|0)+((Y(Y(P,M)|0,Q)|0)<<2)|0;Hh[f[b>>2]&255](O,P,f[s>>2]|0,f[A>>2]|0,R,f[B>>2]|0,f[C>>2]|0,Q);K=K+1|0;Q=(M+1|0)%2|0;R=f[I>>2]|0;P=R+2|0;O=f[q>>2]|0;if((K|0)>=(((O|0)<(P|0)?O:P)|0)){S=Q;T=O;U=R;break}else M=Q}}else{S=E;T=N;U=L}M=T+-2|0;K=g;f[K>>2]=0;f[K+4>>2]=0;K=(((U|0)<(M|0)?M:U)+S-((D|0)<(M|0)?M:D)|0)%2|0;if((K|0)>0){Vac(g|0,(f[i>>2]|0)+((F<<1)+2-K<<2)|0,K<<2|0)|0;V=K}else V=0;Vac(g+(V<<2)|0,(f[i>>2]|0)+(V+H-K<<2)|0,8-(V<<2)|0)|0;M=f[e>>2]|0;I=Y(f[j>>2]|0,f[h>>2]|0)|0;Q=(f[k>>2]|0)+(Y(f[p>>2]|0,F)|0)|0;if((I|0)>0){R=f[g>>2]|0;O=((R|0)<0)<<31>>31;P=f[l>>2]|0;W=((P|0)<0)<<31>>31;X=0;do{Z=f[M+(X<<2)>>2]|0;_=cbc(Z|0,((Z|0)<0)<<31>>31|0,R|0,O|0)|0;Z=J;$=f[M+(X+I<<2)>>2]|0;aa=cbc($|0,(($|0)<0)<<31>>31|0,P|0,W|0)|0;$=J;ba=Kac(_|0,Z|0,-2147483648,0)|0;Z=Kac(ba|0,J|0,aa|0,$|0)|0;$=Rac(Z|0,J|0,32)|0;Z=J;aa=Kac($|0,Z|0,32768,0)|0;ba=J;d[Q+(X<<1)>>1]=ba>>>0<0|(ba|0)==0&aa>>>0<65536?$&65535:(Z|0)>0|(Z|0)==0&$>>>0>0?32767:-32768;X=X+1|0}while((X|0)!=(I|0))}I=F+1|0;if((I|0)<(v|0)){D=U;E=K;F=I;G=G+1|0}else{ca=U;da=K;ea=I;fa=M;ga=T;break}}}else{ca=w;da=x;ea=z;fa=f[e>>2]|0;ga=f[a+16>>2]|0}if((ca+2|0)>(ga|0))ha=fa+((Y(Y(f[h>>2]|0,(da+~ca+ga|0)%2|0)|0,f[j>>2]|0)|0)<<2)|0;else{ca=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,ga+-1|0)|0)|0;Hh[f[a+72>>2]&255](ca,f[j>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,fa,f[a+56>>2]|0,f[a+60>>2]|0,f[h>>2]|0);ha=fa}fa=f[r>>2]|0;if((ea|0)<(fa|0)?(r=f[a+20>>2]|0,ca=f[a+24>>2]|0,a=Y(f[j>>2]|0,f[h>>2]|0)|0,(a|0)>0):0){h=ea;do{ea=r+(Y(ca,h)|0)|0;j=0;do{ga=(f[ha+(j<<2)>>2]|0)+32768>>16;d[ea+(j<<1)>>1]=(ga+32768|0)>>>0<65536?ga:(ga|0)>0?32767:32768;j=j+1|0}while((j|0)!=(a|0));h=h+1|0}while((h|0)<(fa|0))}fa=f[e>>2]|0;if((fa|0)==(m|0)){u=c;return}if(fa|0)P5b(fa);f[e>>2]=m;f[n>>2]=264;u=c;return}function Yha(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;b=(j[a>>1]|0)<<16;k=g+-3|0;if((g|0)>3){l=(g+-4|0)>>>2;m=l<<2;n=d+((l<<3)+8<<2)|0;l=0;o=e;while(1){f[o>>2]=b;f[o+4>>2]=b;f[o+8>>2]=b;f[o+12>>2]=b;l=l+4|0;if((l|0)>=(k|0))break;else o=o+16|0}o=m+4|0;p=n;q=o;r=e+(o<<2)|0}else{p=d;q=0;r=e}if((q|0)<(g|0)){e=g-q|0;d=g-q<<1;o=q;n=r;while(1){f[n>>2]=b;o=o+1|0;if((o|0)==(g|0))break;else n=n+4|0}s=p+(d<<2)|0;t=g;u=r+(e<<2)|0}else{s=p;t=q;u=r}r=h+-3|0;a:do if((t|0)<(r|0)){q=c+(i+-1<<2)|0;p=s;e=t;g=u;while(1){d=f[c+(e+3<<2)>>2]|0;if((d+8|0)>(f[q>>2]|0)){v=p;w=e;x=g;break a}n=a+(f[c+(e<<2)>>2]<<1)|0;o=a+(f[c+(e+1<<2)>>2]<<1)|0;b=a+(f[c+(e+2<<2)>>2]<<1)|0;m=a+(d<<1)|0;d=p+16|0;k=(Y(f[p+4>>2]|0,j[n+2>>1]|0)|0)+(Y(f[p>>2]|0,j[n>>1]|0)|0)|0;n=(Y(f[p+12>>2]|0,j[o+2>>1]|0)|0)+(Y(f[p+8>>2]|0,j[o>>1]|0)|0)|0;o=(Y(f[d+4>>2]|0,j[b+2>>1]|0)|0)+(Y(f[d>>2]|0,j[b>>1]|0)|0)|0;b=(Y(f[d+8>>2]|0,j[m>>1]|0)|0)+(Y(f[d+12>>2]|0,j[m+2>>1]|0)|0)|0;f[g>>2]=k;f[g+4>>2]=n;f[g+8>>2]=o;f[g+12>>2]=b;b=e+4|0;o=p+32|0;n=g+16|0;if((b|0)<(r|0)){p=o;e=b;g=n}else{v=o;w=b;x=n;break}}}else{v=s;w=t;x=u}while(0);if((w|0)<(h|0)){u=h-w|0;t=v;v=w;s=x;while(1){r=a+(f[c+(v<<2)>>2]<<1)|0;g=Y(j[r>>1]|0,f[t>>2]|0)|0;e=(Y(j[r+2>>1]|0,f[t+4>>2]|0)|0)+g|0;f[s>>2]=e;v=v+1|0;if((v|0)==(h|0))break;else{t=t+8|0;s=s+4|0}}y=h;z=x+(u<<2)|0}else{y=w;z=x}x=(j[a+(f[c+(i+-1<<2)>>2]<<1)>>1]|0)<<16;c=i+-3|0;if((y|0)<(c|0)){a=i+-4-y&-4;w=y+a|0;u=a+4|0;a=y;h=z;while(1){f[h>>2]=x;f[h+4>>2]=x;f[h+8>>2]=x;f[h+12>>2]=x;a=a+4|0;if((a|0)>=(c|0))break;else h=h+16|0}A=w+4|0;B=z+(u<<2)|0}else{A=y;B=z}if((A|0)<(i|0)){C=A;D=B}else return;while(1){f[D>>2]=x;C=C+1|0;if((C|0)==(i|0))break;else D=D+4|0}return}function Zha(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;fia(a,b,c,d,e,f,g,h);return}function _ha(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;b=(j[a>>1]|0)<<16;k=(j[a+2>>1]|0)<<16;if((g|0)>0){l=g<<1;m=0;n=e;while(1){f[n>>2]=b;f[n+4>>2]=k;m=m+1|0;if((m|0)==(g|0))break;else n=n+8|0}o=d+(l<<2)|0;p=g;q=e+(l<<2)|0}else{o=d;p=0;q=e}if((p|0)<(h|0)){e=h-p|0;d=p;l=o;o=q;while(1){g=a+(f[c+(d<<2)>>2]<<1<<1)|0;n=Y(j[g>>1]|0,f[l>>2]|0)|0;m=l+4|0;k=(Y(j[g+4>>1]|0,f[m>>2]|0)|0)+n|0;f[o>>2]=k;k=Y(j[g+2>>1]|0,f[l>>2]|0)|0;n=(Y(j[g+6>>1]|0,f[m>>2]|0)|0)+k|0;f[o+4>>2]=n;d=d+1|0;if((d|0)==(h|0))break;else{l=l+8|0;o=o+8|0}}r=h;s=q+(e<<1<<2)|0}else{r=p;s=q}q=a+(f[c+(i+-1<<2)>>2]<<1<<1)|0;c=(j[q>>1]|0)<<16;a=(j[q+2>>1]|0)<<16;if((r|0)<(i|0)){t=r;u=s}else return;while(1){f[u>>2]=c;f[u+4>>2]=a;t=t+1|0;if((t|0)==(i|0))break;else u=u+8|0}return}function $ha(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;fia(a,b,c,d,e,f,g,h);return}function aia(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;b=(j[a>>1]|0)<<16;k=(j[a+2>>1]|0)<<16;l=(j[a+4>>1]|0)<<16;if((g|0)>0){m=g*3|0;n=0;o=e;while(1){f[o>>2]=b;f[o+4>>2]=k;f[o+8>>2]=l;n=n+1|0;if((n|0)==(g|0))break;else o=o+12|0}p=d+(g<<1<<2)|0;q=g;r=e+(m<<2)|0}else{p=d;q=0;r=e}if((q|0)<(h|0)){e=h-q|0;d=q;m=r;g=p;while(1){p=a+((f[c+(d<<2)>>2]|0)*3<<1)|0;o=Y(j[p>>1]|0,f[g>>2]|0)|0;n=g+4|0;l=(Y(j[p+6>>1]|0,f[n>>2]|0)|0)+o|0;f[m>>2]=l;l=Y(j[p+2>>1]|0,f[g>>2]|0)|0;o=(Y(j[p+8>>1]|0,f[n>>2]|0)|0)+l|0;f[m+4>>2]=o;o=Y(j[p+4>>1]|0,f[g>>2]|0)|0;l=(Y(j[p+10>>1]|0,f[n>>2]|0)|0)+o|0;f[m+8>>2]=l;d=d+1|0;if((d|0)==(h|0))break;else{m=m+12|0;g=g+8|0}}s=h;t=r+(e*3<<2)|0}else{s=q;t=r}r=a+((f[c+(i+-1<<2)>>2]|0)*3<<1)|0;c=(j[r>>1]|0)<<16;a=(j[r+2>>1]|0)<<16;q=(j[r+4>>1]|0)<<16;if((s|0)<(i|0)){u=t;v=s}else return;while(1){f[u>>2]=c;f[u+4>>2]=a;f[u+8>>2]=q;v=v+1|0;if((v|0)==(i|0))break;else u=u+12|0}return}function bia(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;fia(a,b,c,d,e,f,g,h);return}function cia(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;b=(j[a>>1]|0)<<16;k=(j[a+2>>1]|0)<<16;l=(j[a+4>>1]|0)<<16;m=(j[a+6>>1]|0)<<16;if((g|0)>0){n=g<<2;o=0;p=e;while(1){f[p>>2]=b;f[p+4>>2]=k;f[p+8>>2]=l;f[p+12>>2]=m;o=o+1|0;if((o|0)==(g|0))break;else p=p+16|0}q=d+(g<<1<<2)|0;r=g;s=e+(n<<2)|0}else{q=d;r=0;s=e}if((r|0)<(h|0)){e=h-r|0;d=r;n=s;g=q;while(1){q=a+(f[c+(d<<2)>>2]<<2<<1)|0;p=Y(j[q>>1]|0,f[g>>2]|0)|0;o=g+4|0;m=(Y(j[q+8>>1]|0,f[o>>2]|0)|0)+p|0;f[n>>2]=m;m=Y(j[q+2>>1]|0,f[g>>2]|0)|0;p=(Y(j[q+10>>1]|0,f[o>>2]|0)|0)+m|0;f[n+4>>2]=p;p=Y(j[q+4>>1]|0,f[g>>2]|0)|0;m=(Y(j[q+12>>1]|0,f[o>>2]|0)|0)+p|0;f[n+8>>2]=m;m=Y(j[q+6>>1]|0,f[g>>2]|0)|0;p=(Y(j[q+14>>1]|0,f[o>>2]|0)|0)+m|0;f[n+12>>2]=p;d=d+1|0;if((d|0)==(h|0))break;else{n=n+16|0;g=g+8|0}}t=h;u=s+(e<<2<<2)|0}else{t=r;u=s}s=a+(f[c+(i+-1<<2)>>2]<<2<<1)|0;c=(j[s>>1]|0)<<16;a=(j[s+2>>1]|0)<<16;r=(j[s+4>>1]|0)<<16;e=(j[s+6>>1]|0)<<16;if((t|0)<(i|0)){v=u;w=t}else return;while(1){f[v>>2]=c;f[v+4>>2]=a;f[v+8>>2]=r;f[v+12>>2]=e;w=w+1|0;if((w|0)==(i|0))break;else v=v+16|0}return}function dia(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;fia(a,b,c,d,e,f,g,h);return}function eia(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;do if((g|0)>0){k=g<<1;if((b|0)<=0){l=d+(k<<2)|0;m=e;n=g;break}o=Y(g,b)|0;p=e;q=0;while(1){r=0;s=p;while(1){f[s>>2]=(j[a+(r<<1)>>1]|0)<<16;r=r+1|0;if((r|0)==(b|0))break;else s=s+4|0}q=q+1|0;if((q|0)==(g|0))break;else p=p+(b<<2)|0}l=d+(k<<2)|0;m=e+(o<<2)|0;n=g}else{l=d;m=e;n=0}while(0);if((n|0)<(h|0))if((b|0)>0){e=m+((Y(h-n|0,b)|0)<<2)|0;d=n;g=l;l=m;while(1){p=a+((Y(f[c+(d<<2)>>2]|0,b)|0)<<1)|0;q=g+4|0;s=0;r=l;while(1){t=Y(j[p+(s<<1)>>1]|0,f[g>>2]|0)|0;f[r>>2]=t;u=(Y(j[p+(s+b<<1)>>1]|0,f[q>>2]|0)|0)+t|0;f[r>>2]=u;s=s+1|0;if((s|0)==(b|0))break;else r=r+4|0}d=d+1|0;if((d|0)==(h|0)){v=h;w=e;break}else{g=g+8|0;l=l+(b<<2)|0}}}else{v=h;w=m}else{v=n;w=m}m=a+((Y(f[c+(i+-1<<2)>>2]|0,b)|0)<<1)|0;if((v|0)<(i|0)&(b|0)>0){x=v;y=w}else return;while(1){w=0;v=y;while(1){f[v>>2]=(j[m+(w<<1)>>1]|0)<<16;w=w+1|0;if((w|0)==(b|0))break;else v=v+4|0}x=x+1|0;if((x|0)==(i|0))break;else y=y+(b<<2)|0}return}function fia(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;do if((g|0)>0){k=g<<1;if((b|0)<=0){l=d+(k<<2)|0;m=e;n=g;break}o=Y(g,b)|0;p=e;q=0;while(1){r=0;s=p;while(1){f[s>>2]=(j[a+(r<<1)>>1]|0)<<16;r=r+1|0;if((r|0)==(b|0))break;else s=s+4|0}q=q+1|0;if((q|0)==(g|0))break;else p=p+(b<<2)|0}l=d+(k<<2)|0;m=e+(o<<2)|0;n=g}else{l=d;m=e;n=0}while(0);if((n|0)<(h|0))if((b|0)>0){e=m+((Y(h-n|0,b)|0)<<2)|0;d=l;l=n;g=m;while(1){p=a+((Y(f[c+(l<<2)>>2]|0,b)|0)<<1)|0;q=d+4|0;s=0;r=g;while(1){t=f[d>>2]|0;if(!t)u=0;else u=Y(j[p+(s<<1)>>1]|0,t)|0;f[r>>2]=u;t=f[q>>2]|0;if(!t)v=0;else v=Y(j[p+(s+b<<1)>>1]|0,t)|0;f[r>>2]=u+v;s=s+1|0;if((s|0)==(b|0))break;else r=r+4|0}l=l+1|0;if((l|0)==(h|0)){w=h;x=e;break}else{d=d+8|0;g=g+(b<<2)|0}}}else{w=h;x=m}else{w=n;x=m}m=a+((Y(f[c+(i+-1<<2)>>2]|0,b)|0)<<1)|0;if((w|0)<(i|0)&(b|0)>0){y=w;z=x}else return;while(1){x=0;w=z;while(1){f[w>>2]=(j[m+(x<<1)>>1]|0)<<16;x=x+1|0;if((x|0)==(b|0))break;else w=w+4|0}y=y+1|0;if((y|0)==(i|0))break;else z=z+(b<<2)|0}return}function gia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+16|0;l=e+8|0;m=e;gmb(j,b);p[h>>3]=.5;omb(g,j,h);smb(k,a,g);p[l>>3]=.5;rmb(i,k,l);k=lmb(i)|0;if((k|0)>-1?(j=f[a+8>>2]|0,(j|0)>1):0){n=j+-1|0;if((k|0)>=(n|0)){f[c>>2]=n;n=a+16|0;j=f[n>>2]|0;f[n>>2]=(j|0)>(b|0)?b:j;u=e;return}f[c>>2]=k;gmb(m,k);rmb(l,i,m);if((f[l+4>>2]|0)<0)o=0;else{gmb(h,65536);smb(g,l,h);o=kmb(g)|0}f[d+4>>2]=o;f[d>>2]=65536-o;u=e;return}o=a+12|0;a=b+1|0;b=f[o>>2]|0;f[o>>2]=(b|0)<(a|0)?a:b;u=e;return}function hia(a){a=a|0;O5b(a);return}function iia(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;c=u;u=u+1072|0;e=c+8|0;g=c;h=a+28|0;i=f[h>>2]|0;j=a+36|0;k=f[j>>2]|0;l=Y(i<<1,k)|0;m=e+8|0;Nac(m|0,0,1056)|0;f[e>>2]=m;n=e+4|0;f[n>>2]=l;if(l>>>0>264){o=N5b(l>>>0>1073741823?-1:l<<2)|0;Nac(o|0,0,l<<2|0)|0;f[e>>2]=o;p=o}else p=m;o=f[a+64>>2]|0;l=f[b>>2]|0;q=(o|0)<(l|0)?l:o;r=b+4|0;s=f[r>>2]|0;t=f[a+68>>2]|0;v=(s|0)<(t|0)?s:t;if((l|0)<(o|0)){Hh[f[a+72>>2]&255](f[a+4>>2]|0,k,f[a+40>>2]|0,f[a+48>>2]|0,p,f[a+56>>2]|0,f[a+60>>2]|0,i);w=-1;x=1;y=f[b>>2]|0}else{w=-2;x=0;y=l}if((y|0)<(q|0)){l=f[e>>2]|0;b=f[a+20>>2]|0;i=f[a+24>>2]|0;p=Y(f[j>>2]|0,f[h>>2]|0)|0;if((p|0)>0){k=y;do{o=b+(Y(i,k)|0)|0;t=0;do{d[o+(t<<1)>>1]=((f[l+(t<<2)>>2]|0)+32768|0)>>>16;t=t+1|0}while((t|0)!=(p|0));k=k+1|0}while((k|0)<(q|0));z=q}else z=q}else z=y;if((z|0)<(v|0)){y=a+44|0;q=a+16|0;k=a+20|0;p=a+24|0;l=g+4|0;i=a+52|0;b=a+72|0;t=a+4|0;o=a+8|0;s=a+40|0;A=a+48|0;B=a+56|0;C=a+60|0;D=w;E=x;F=z;G=0;while(1){H=z+G<<1;I=(f[y>>2]|0)+(F<<2)|0;K=D+2|0;L=f[I>>2]|0;M=(L|0)<(K|0)?K:L;K=L+2|0;N=f[q>>2]|0;if((M|0)<(((N|0)<(K|0)?N:K)|0)){K=M;M=E;while(1){O=(f[t>>2]|0)+(Y(f[o>>2]|0,K)|0)|0;P=f[j>>2]|0;Q=f[h>>2]|0;R=(f[e>>2]|0)+((Y(Y(P,M)|0,Q)|0)<<2)|0;Hh[f[b>>2]&255](O,P,f[s>>2]|0,f[A>>2]|0,R,f[B>>2]|0,f[C>>2]|0,Q);K=K+1|0;Q=(M+1|0)%2|0;R=f[I>>2]|0;P=R+2|0;O=f[q>>2]|0;if((K|0)>=(((O|0)<(P|0)?O:P)|0)){S=Q;T=O;U=R;break}else M=Q}}else{S=E;T=N;U=L}M=T+-2|0;K=g;f[K>>2]=0;f[K+4>>2]=0;K=(((U|0)<(M|0)?M:U)+S-((D|0)<(M|0)?M:D)|0)%2|0;if((K|0)>0){Vac(g|0,(f[i>>2]|0)+((F<<1)+2-K<<2)|0,K<<2|0)|0;V=K}else V=0;Vac(g+(V<<2)|0,(f[i>>2]|0)+(V+H-K<<2)|0,8-(V<<2)|0)|0;M=f[e>>2]|0;I=Y(f[j>>2]|0,f[h>>2]|0)|0;Q=(f[k>>2]|0)+(Y(f[p>>2]|0,F)|0)|0;if((I|0)>0){R=f[g>>2]|0;O=f[l>>2]|0;P=0;do{W=cbc(f[M+(P<<2)>>2]|0,0,R|0,0)|0;X=J;Z=cbc(f[M+(P+I<<2)>>2]|0,0,O|0,0)|0;_=J;$=Kac(W|0,X|0,-2147483648,0)|0;Kac($|0,J|0,Z|0,_|0)|0;_=J;Z=0<0|0==0&_>>>0<65535;$=Z?_:65535;d[Q+(P<<1)>>1]=$;P=P+1|0}while((P|0)!=(I|0))}I=F+1|0;if((I|0)<(v|0)){D=U;E=K;F=I;G=G+1|0}else{aa=U;ba=K;ca=I;da=M;ea=T;break}}}else{aa=w;ba=x;ca=z;da=f[e>>2]|0;ea=f[a+16>>2]|0}if((aa+2|0)>(ea|0))fa=da+((Y(Y(f[h>>2]|0,(ba+~aa+ea|0)%2|0)|0,f[j>>2]|0)|0)<<2)|0;else{aa=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,ea+-1|0)|0)|0;Hh[f[a+72>>2]&255](aa,f[j>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,da,f[a+56>>2]|0,f[a+60>>2]|0,f[h>>2]|0);fa=da}da=f[r>>2]|0;if((ca|0)<(da|0)?(r=f[a+20>>2]|0,aa=f[a+24>>2]|0,a=Y(f[j>>2]|0,f[h>>2]|0)|0,(a|0)>0):0){h=ca;do{ca=r+(Y(aa,h)|0)|0;j=0;do{d[ca+(j<<1)>>1]=((f[fa+(j<<2)>>2]|0)+32768|0)>>>16;j=j+1|0}while((j|0)!=(a|0));h=h+1|0}while((h|0)<(da|0))}da=f[e>>2]|0;if((da|0)==(m|0)){u=c;return}if(da|0)P5b(da);f[e>>2]=m;f[n>>2]=264;u=c;return}function jia(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=b[a>>0]<<16;if((h|0)>0){k=0;l=g;while(1){f[l>>2]=c;k=k+1|0;if((k|0)==(h|0))break;else l=l+4|0}m=e+(h<<1<<2)|0;n=h;o=g+(h<<2)|0}else{m=e;n=0;o=g}if((n|0)<(i|0)){g=m;m=n;e=o;while(1){h=a+(f[d+(m<<2)>>2]|0)|0;l=Y(b[h>>0]|0,f[g>>2]|0)|0;k=(Y(b[h+1>>0]|0,f[g+4>>2]|0)|0)+l|0;f[e>>2]=k;m=m+1|0;if((m|0)==(i|0))break;else{g=g+8|0;e=e+4|0}}p=i;q=o+(i-n<<2)|0}else{p=n;q=o}o=b[a+(f[d+(j+-1<<2)>>2]|0)>>0]<<16;if((p|0)<(j|0)){r=p;s=q}else return;while(1){f[s>>2]=o;r=r+1|0;if((r|0)==(j|0))break;else s=s+4|0}return}function kia(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;sia(a,b,c,d,e,f,g,h);return}function lia(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;c=b[a>>0]<<16;k=b[a+1>>0]<<16;if((h|0)>0){l=h<<1;m=0;n=g;while(1){f[n>>2]=c;f[n+4>>2]=k;m=m+1|0;if((m|0)==(h|0))break;else n=n+8|0}o=e+(l<<2)|0;p=h;q=g+(l<<2)|0}else{o=e;p=0;q=g}if((p|0)<(i|0)){g=i-p|0;e=p;l=o;o=q;while(1){h=a+(f[d+(e<<2)>>2]<<1)|0;n=Y(b[h>>0]|0,f[l>>2]|0)|0;m=l+4|0;k=(Y(b[h+2>>0]|0,f[m>>2]|0)|0)+n|0;f[o>>2]=k;k=Y(b[h+1>>0]|0,f[l>>2]|0)|0;n=(Y(b[h+3>>0]|0,f[m>>2]|0)|0)+k|0;f[o+4>>2]=n;e=e+1|0;if((e|0)==(i|0))break;else{l=l+8|0;o=o+8|0}}r=i;s=q+(g<<1<<2)|0}else{r=p;s=q}q=a+(f[d+(j+-1<<2)>>2]<<1)|0;d=b[q>>0]<<16;a=b[q+1>>0]<<16;if((r|0)<(j|0)){t=r;u=s}else return;while(1){f[u>>2]=d;f[u+4>>2]=a;t=t+1|0;if((t|0)==(j|0))break;else u=u+8|0}return}function mia(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;sia(a,b,c,d,e,f,g,h);return}function nia(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=b[a>>0]<<16;k=b[a+1>>0]<<16;l=b[a+2>>0]<<16;if((h|0)>0){m=h*3|0;n=0;o=g;while(1){f[o>>2]=c;f[o+4>>2]=k;f[o+8>>2]=l;n=n+1|0;if((n|0)==(h|0))break;else o=o+12|0}p=e+(h<<1<<2)|0;q=h;r=g+(m<<2)|0}else{p=e;q=0;r=g}if((q|0)<(i|0)){g=i-q|0;e=q;m=r;h=p;while(1){p=a+((f[d+(e<<2)>>2]|0)*3|0)|0;o=Y(b[p>>0]|0,f[h>>2]|0)|0;n=h+4|0;l=(Y(b[p+3>>0]|0,f[n>>2]|0)|0)+o|0;f[m>>2]=l;l=Y(b[p+1>>0]|0,f[h>>2]|0)|0;o=(Y(b[p+4>>0]|0,f[n>>2]|0)|0)+l|0;f[m+4>>2]=o;o=Y(b[p+2>>0]|0,f[h>>2]|0)|0;l=(Y(b[p+5>>0]|0,f[n>>2]|0)|0)+o|0;f[m+8>>2]=l;e=e+1|0;if((e|0)==(i|0))break;else{m=m+12|0;h=h+8|0}}s=i;t=r+(g*3<<2)|0}else{s=q;t=r}r=a+((f[d+(j+-1<<2)>>2]|0)*3|0)|0;d=b[r>>0]<<16;a=b[r+1>>0]<<16;q=b[r+2>>0]<<16;if((s|0)<(j|0)){u=t;v=s}else return;while(1){f[u>>2]=d;f[u+4>>2]=a;f[u+8>>2]=q;v=v+1|0;if((v|0)==(j|0))break;else u=u+12|0}return}function oia(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;sia(a,b,c,d,e,f,g,h);return}function pia(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;c=b[a>>0]<<16;k=b[a+1>>0]<<16;l=b[a+2>>0]<<16;m=b[a+3>>0]<<16;if((h|0)>0){n=h<<2;o=0;p=g;while(1){f[p>>2]=c;f[p+4>>2]=k;f[p+8>>2]=l;f[p+12>>2]=m;o=o+1|0;if((o|0)==(h|0))break;else p=p+16|0}q=e+(h<<1<<2)|0;r=h;s=g+(n<<2)|0}else{q=e;r=0;s=g}if((r|0)<(i|0)){g=i-r|0;e=r;n=s;h=q;while(1){q=a+(f[d+(e<<2)>>2]<<2)|0;p=Y(b[q>>0]|0,f[h>>2]|0)|0;o=h+4|0;m=(Y(b[q+4>>0]|0,f[o>>2]|0)|0)+p|0;f[n>>2]=m;m=Y(b[q+1>>0]|0,f[h>>2]|0)|0;p=(Y(b[q+5>>0]|0,f[o>>2]|0)|0)+m|0;f[n+4>>2]=p;p=Y(b[q+2>>0]|0,f[h>>2]|0)|0;m=(Y(b[q+6>>0]|0,f[o>>2]|0)|0)+p|0;f[n+8>>2]=m;m=Y(b[q+3>>0]|0,f[h>>2]|0)|0;p=(Y(b[q+7>>0]|0,f[o>>2]|0)|0)+m|0;f[n+12>>2]=p;e=e+1|0;if((e|0)==(i|0))break;else{n=n+16|0;h=h+8|0}}t=i;u=s+(g<<2<<2)|0}else{t=r;u=s}s=a+(f[d+(j+-1<<2)>>2]<<2)|0;d=b[s>>0]<<16;a=b[s+1>>0]<<16;r=b[s+2>>0]<<16;g=b[s+3>>0]<<16;if((t|0)<(j|0)){v=u;w=t}else return;while(1){f[v>>2]=d;f[v+4>>2]=a;f[v+8>>2]=r;f[v+12>>2]=g;w=w+1|0;if((w|0)==(j|0))break;else v=v+16|0}return}function qia(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;sia(a,b,c,d,e,f,g,h);return}function ria(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;do if((h|0)>0){k=h<<1;if((c|0)<=0){l=e+(k<<2)|0;m=g;n=h;break}o=Y(h,c)|0;p=g;q=0;while(1){r=0;s=p;while(1){f[s>>2]=b[a+r>>0]<<16;r=r+1|0;if((r|0)==(c|0))break;else s=s+4|0}q=q+1|0;if((q|0)==(h|0))break;else p=p+(c<<2)|0}l=e+(k<<2)|0;m=g+(o<<2)|0;n=h}else{l=e;m=g;n=0}while(0);if((n|0)<(i|0))if((c|0)>0){g=m+((Y(i-n|0,c)|0)<<2)|0;e=n;h=l;l=m;while(1){p=a+(Y(f[d+(e<<2)>>2]|0,c)|0)|0;q=h+4|0;s=0;r=l;while(1){t=Y(b[p+s>>0]|0,f[h>>2]|0)|0;f[r>>2]=t;u=(Y(b[p+(s+c)>>0]|0,f[q>>2]|0)|0)+t|0;f[r>>2]=u;s=s+1|0;if((s|0)==(c|0))break;else r=r+4|0}e=e+1|0;if((e|0)==(i|0)){v=i;w=g;break}else{h=h+8|0;l=l+(c<<2)|0}}}else{v=i;w=m}else{v=n;w=m}m=a+(Y(f[d+(j+-1<<2)>>2]|0,c)|0)|0;if((v|0)<(j|0)&(c|0)>0){x=v;y=w}else return;while(1){w=0;v=y;while(1){f[v>>2]=b[m+w>>0]<<16;w=w+1|0;if((w|0)==(c|0))break;else v=v+4|0}x=x+1|0;if((x|0)==(j|0))break;else y=y+(c<<2)|0}return}function sia(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;do if((h|0)>0){k=h<<1;if((c|0)<=0){l=e+(k<<2)|0;m=g;n=h;break}o=Y(h,c)|0;p=g;q=0;while(1){r=0;s=p;while(1){f[s>>2]=b[a+r>>0]<<16;r=r+1|0;if((r|0)==(c|0))break;else s=s+4|0}q=q+1|0;if((q|0)==(h|0))break;else p=p+(c<<2)|0}l=e+(k<<2)|0;m=g+(o<<2)|0;n=h}else{l=e;m=g;n=0}while(0);if((n|0)<(i|0))if((c|0)>0){g=m+((Y(i-n|0,c)|0)<<2)|0;e=l;l=n;h=m;while(1){p=a+(Y(f[d+(l<<2)>>2]|0,c)|0)|0;q=e+4|0;s=0;r=h;while(1){t=f[e>>2]|0;if(!t)u=0;else u=Y(b[p+s>>0]|0,t)|0;f[r>>2]=u;t=f[q>>2]|0;if(!t)v=0;else v=Y(b[p+(s+c)>>0]|0,t)|0;f[r>>2]=u+v;s=s+1|0;if((s|0)==(c|0))break;else r=r+4|0}l=l+1|0;if((l|0)==(i|0)){w=i;x=g;break}else{e=e+8|0;h=h+(c<<2)|0}}}else{w=i;x=m}else{w=n;x=m}m=a+(Y(f[d+(j+-1<<2)>>2]|0,c)|0)|0;if((w|0)<(j|0)&(c|0)>0){y=w;z=x}else return;while(1){x=0;w=z;while(1){f[w>>2]=b[m+x>>0]<<16;x=x+1|0;if((x|0)==(c|0))break;else w=w+4|0}y=y+1|0;if((y|0)==(j|0))break;else z=z+(c<<2)|0}return}function tia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+48|0;h=e+40|0;i=e+32|0;j=e+24|0;k=e+16|0;l=e+8|0;m=e;gmb(j,b);p[h>>3]=.5;omb(g,j,h);smb(k,a,g);p[l>>3]=.5;rmb(i,k,l);k=lmb(i)|0;if((k|0)>-1?(j=f[a+8>>2]|0,(j|0)>1):0){n=j+-1|0;if((k|0)<(n|0)){f[c>>2]=k;gmb(m,k);rmb(l,i,m);gmb(h,65536);smb(g,l,h);h=kmb(g)|0;f[d+4>>2]=h;f[d>>2]=65536-h;u=e;return}else{f[c>>2]=n;n=a+16|0;c=f[n>>2]|0;f[n>>2]=(c|0)>(b|0)?b:c;u=e;return}}c=a+12|0;a=b+1|0;b=f[c>>2]|0;f[c>>2]=(b|0)<(a|0)?a:b;u=e;return}function uia(a){a=a|0;O5b(a);return}function via(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;d=u;u=u+1072|0;e=d+8|0;g=d;h=a+28|0;i=f[h>>2]|0;j=a+36|0;k=f[j>>2]|0;l=Y(i<<1,k)|0;m=e+8|0;Nac(m|0,0,1056)|0;f[e>>2]=m;n=e+4|0;f[n>>2]=l;if(l>>>0>264){o=N5b(l>>>0>1073741823?-1:l<<2)|0;Nac(o|0,0,l<<2|0)|0;f[e>>2]=o;p=o}else p=m;o=f[a+64>>2]|0;l=f[c>>2]|0;q=(o|0)<(l|0)?l:o;r=c+4|0;s=f[r>>2]|0;t=f[a+68>>2]|0;v=(s|0)<(t|0)?s:t;if((l|0)<(o|0)){Hh[f[a+72>>2]&255](f[a+4>>2]|0,k,f[a+40>>2]|0,f[a+48>>2]|0,p,f[a+56>>2]|0,f[a+60>>2]|0,i);w=-1;x=1;y=f[c>>2]|0}else{w=-2;x=0;y=l}if((y|0)<(q|0)){l=a+20|0;c=a+24|0;i=y;do{p=f[e>>2]|0;k=(f[l>>2]|0)+(Y(f[c>>2]|0,i)|0)|0;o=Y(f[j>>2]|0,f[h>>2]|0)|0;if((o|0)>0){t=0;do{s=(f[p+(t<<2)>>2]|0)+32768>>16;b[k+t>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;t=t+1|0}while((t|0)!=(o|0))}i=i+1|0}while((i|0)<(q|0));z=q}else z=y;if((z|0)<(v|0)){y=a+44|0;q=a+16|0;i=a+20|0;c=a+24|0;l=g+4|0;o=a+52|0;t=a+72|0;k=a+4|0;p=a+8|0;s=a+40|0;A=a+48|0;B=a+56|0;C=a+60|0;D=w;E=x;F=z;G=0;while(1){H=z+G<<1;I=(f[y>>2]|0)+(F<<2)|0;K=D+2|0;L=f[I>>2]|0;M=(L|0)<(K|0)?K:L;K=L+2|0;N=f[q>>2]|0;if((M|0)<(((N|0)<(K|0)?N:K)|0)){K=M;M=E;while(1){O=(f[k>>2]|0)+(Y(f[p>>2]|0,K)|0)|0;P=f[j>>2]|0;Q=f[h>>2]|0;R=(f[e>>2]|0)+((Y(Y(P,M)|0,Q)|0)<<2)|0;Hh[f[t>>2]&255](O,P,f[s>>2]|0,f[A>>2]|0,R,f[B>>2]|0,f[C>>2]|0,Q);K=K+1|0;Q=(M+1|0)%2|0;R=f[I>>2]|0;P=R+2|0;O=f[q>>2]|0;if((K|0)>=(((O|0)<(P|0)?O:P)|0)){S=Q;T=O;U=R;break}else M=Q}}else{S=E;T=N;U=L}M=T+-2|0;K=g;f[K>>2]=0;f[K+4>>2]=0;K=(((U|0)<(M|0)?M:U)+S-((D|0)<(M|0)?M:D)|0)%2|0;if((K|0)>0){Vac(g|0,(f[o>>2]|0)+((F<<1)+2-K<<2)|0,K<<2|0)|0;V=K}else V=0;Vac(g+(V<<2)|0,(f[o>>2]|0)+(V+H-K<<2)|0,8-(V<<2)|0)|0;M=f[e>>2]|0;I=Y(f[j>>2]|0,f[h>>2]|0)|0;Q=(f[i>>2]|0)+(Y(f[c>>2]|0,F)|0)|0;if((I|0)>0){R=f[g>>2]|0;O=f[l>>2]|0;P=((R|0)<0)<<31>>31;W=((O|0)<0)<<31>>31;X=0;do{Z=f[M+(X<<2)>>2]|0;_=cbc(R|0,P|0,Z|0,((Z|0)<0)<<31>>31|0)|0;Z=J;$=f[M+(X+I<<2)>>2]|0;aa=cbc(O|0,W|0,$|0,(($|0)<0)<<31>>31|0)|0;$=J;ba=Kac(_|0,Z|0,-2147483648,0)|0;Z=Kac(ba|0,J|0,aa|0,$|0)|0;$=Rac(Z|0,J|0,32)|0;Z=J;aa=Kac($|0,Z|0,128,0)|0;ba=J;b[Q+X>>0]=ba>>>0<0|(ba|0)==0&aa>>>0<256?$&255:(Z|0)>0|(Z|0)==0&$>>>0>0?127:-128;X=X+1|0}while((X|0)!=(I|0))}I=F+1|0;if((I|0)<(v|0)){D=U;E=K;F=I;G=G+1|0}else{ca=U;da=K;ea=I;fa=q;break}}}else{ca=w;da=x;ea=z;fa=a+16|0}z=f[e>>2]|0;x=f[fa>>2]|0;if((ca+2|0)>(x|0))ga=z+((Y(Y(f[h>>2]|0,(da+~ca+x|0)%2|0)|0,f[j>>2]|0)|0)<<2)|0;else{ca=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,x+-1|0)|0)|0;Hh[f[a+72>>2]&255](ca,f[j>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,z,f[a+56>>2]|0,f[a+60>>2]|0,f[h>>2]|0);ga=z}z=f[r>>2]|0;if((ea|0)<(z|0)){ca=a+20|0;x=a+24|0;a=ea;ea=z;while(1){z=(f[ca>>2]|0)+(Y(f[x>>2]|0,a)|0)|0;da=Y(f[j>>2]|0,f[h>>2]|0)|0;if((da|0)>0){fa=0;do{w=(f[ga+(fa<<2)>>2]|0)+32768>>16;b[z+fa>>0]=(w+128|0)>>>0<256?w:(w|0)>0?127:128;fa=fa+1|0}while((fa|0)!=(da|0));ha=f[r>>2]|0}else ha=ea;a=a+1|0;if((a|0)>=(ha|0))break;else ea=ha}}ha=f[e>>2]|0;if((ha|0)==(m|0)){u=d;return}if(ha|0)P5b(ha);f[e>>2]=m;f[n>>2]=264;u=d;return}function wia(a,c,e,g,i,k,l,m){a=a|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;c=u;u=u+32|0;n=c+16|0;o=c;p=h[a>>0]<<8&65535;q=k+-7|0;if((k|0)>7){r=(k+-8|0)>>>3;s=r<<3;t=g+((r<<4)+16<<1)|0;r=0;v=i;while(1){d[v>>1]=p;d[v+2>>1]=p;d[v+4>>1]=p;d[v+6>>1]=p;d[v+8>>1]=p;d[v+10>>1]=p;d[v+12>>1]=p;d[v+14>>1]=p;r=r+8|0;if((r|0)>=(q|0))break;else v=v+16|0}v=s+8|0;w=t;x=v;y=i+(v<<1)|0}else{w=g;x=0;y=i}if((x|0)<(k|0)){i=k-x|0;g=k-x<<1;v=x;t=y;while(1){d[t>>1]=p;v=v+1|0;if((v|0)==(k|0))break;else t=t+2|0}z=w+(g<<1)|0;A=k;B=y+(i<<1)|0}else{z=w;A=x;B=y}y=l+-7|0;a:do if((A|0)<(y|0)){x=e+(m+-1<<2)|0;w=n+8|0;i=n+4|0;k=n+12|0;g=o+8|0;t=o+4|0;v=o+12|0;p=z;s=A;q=B;while(1){r=e+(s+7<<2)|0;if(((f[r>>2]|0)+15|0)>(f[x>>2]|0)){C=p;D=s;E=q;break a}F=a+(f[e+(s<<2)>>2]|0)|0;G=b[F+2>>0]|0;H=b[F+3>>0]|0;I=a+(f[e+(s+1<<2)>>2]|0)|0;J=b[I>>0]|0;K=b[I+1>>0]|0;L=b[I+2>>0]|0;M=b[I+3>>0]|0;f[n>>2]=h[F+1>>0]<<16|h[F>>0];f[w>>2]=(K&255)<<16|J&255;f[i>>2]=(H&255)<<16|G&255;f[k>>2]=(M&255)<<16|L&255;L=a+(f[e+(s+2<<2)>>2]|0)|0;M=b[L+2>>0]|0;G=b[L+3>>0]|0;H=a+(f[e+(s+3<<2)>>2]|0)|0;J=b[H>>0]|0;K=b[H+1>>0]|0;F=b[H+2>>0]|0;I=b[H+3>>0]|0;f[o>>2]=h[L+1>>0]<<16|h[L>>0];f[g>>2]=(K&255)<<16|J&255;f[t>>2]=(G&255)<<16|M&255;f[v>>2]=(I&255)<<16|F&255;F=a+(f[e+(s+4<<2)>>2]|0)|0;I=a+(f[e+(s+5<<2)>>2]|0)|0;M=a+(f[e+(s+6<<2)>>2]|0)|0;G=a+(f[r>>2]|0)|0;r=f[n>>2]|0;J=f[o>>2]|0;K=f[w>>2]|0;L=f[g>>2]|0;H=p+16|0;N=(Y(d[p+2>>1]|0,r>>16)|0)+(Y(d[p>>1]|0,r<<16>>16)|0)|0;r=(Y(d[p+6>>1]|0,K>>16)|0)+(Y(d[p+4>>1]|0,K<<16>>16)|0)|0;K=(Y(d[p+10>>1]|0,J>>16)|0)+(Y(d[p+8>>1]|0,J<<16>>16)|0)|0;J=(Y(d[p+14>>1]|0,L>>16)|0)+(Y(d[p+12>>1]|0,L<<16>>16)|0)|0;L=(Y(h[F+1>>0]|0,d[H+2>>1]|0)|0)+(Y(h[F>>0]|0,d[H>>1]|0)|0)|0;F=(Y(h[I+1>>0]|0,d[H+6>>1]|0)|0)+(Y(h[I>>0]|0,d[H+4>>1]|0)|0)|0;I=(Y(h[M+1>>0]|0,d[H+10>>1]|0)|0)+(Y(h[M>>0]|0,d[H+8>>1]|0)|0)|0;M=(Y(h[G+1>>0]|0,d[H+14>>1]|0)|0)+(Y(h[G>>0]|0,d[H+12>>1]|0)|0)|0;d[q>>1]=N>>>0<65535?N:65535;d[q+2>>1]=r>>>0<65535?r:65535;d[q+4>>1]=K>>>0<65535?K:65535;d[q+6>>1]=J>>>0<65535?J:65535;d[q+8>>1]=L>>>0<65535?L:65535;d[q+10>>1]=F>>>0<65535?F:65535;d[q+12>>1]=I>>>0<65535?I:65535;d[q+14>>1]=M>>>0<65535?M:65535;M=s+8|0;I=p+32|0;F=q+16|0;if((M|0)<(y|0)){p=I;s=M;q=F}else{C=I;D=M;E=F;break}}}else{C=z;D=A;E=B}while(0);if((D|0)<(l|0)){B=l-D|0;A=C;C=D;z=E;while(1){y=a+(f[e+(C<<2)>>2]|0)|0;o=Y(h[y>>0]|0,j[A>>1]|0)|0;n=(Y(h[y+1>>0]|0,j[A+2>>1]|0)|0)+o&65535;d[z>>1]=n;C=C+1|0;if((C|0)==(l|0))break;else{A=A+4|0;z=z+2|0}}O=l;P=E+(B<<1)|0}else{O=D;P=E}E=h[a+(f[e+(m+-1<<2)>>2]|0)>>0]<<8&65535;e=m+-7|0;if((O|0)<(e|0)){a=m+-8-O&-8;D=O+a|0;B=a+8|0;a=O;l=P;while(1){d[l>>1]=E;d[l+2>>1]=E;d[l+4>>1]=E;d[l+6>>1]=E;d[l+8>>1]=E;d[l+10>>1]=E;d[l+12>>1]=E;d[l+14>>1]=E;a=a+8|0;if((a|0)>=(e|0))break;else l=l+16|0}Q=D+8|0;R=P+(B<<1)|0}else{Q=O;R=P}if((Q|0)<(m|0)){S=Q;T=R}else{u=c;return}while(1){d[T>>1]=E;S=S+1|0;if((S|0)==(m|0))break;else T=T+2|0}u=c;return}function xia(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Fia(a,b,c,d,e,f,g,h);return}function yia(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;b=u;u=u+64|0;m=b+16|0;n=b;o=b+48|0;p=b+32|0;q=h[a>>0]<<8&65535;r=h[a+1>>0]<<8&65535;s=i+-3|0;if((i|0)>3){t=(i+-4|0)>>>2;v=t<<2;w=(t<<3)+8|0;t=e+(w<<1)|0;x=g;y=0;while(1){d[x>>1]=q;d[x+2>>1]=r;d[x+4>>1]=q;d[x+6>>1]=r;d[x+8>>1]=q;d[x+10>>1]=r;d[x+12>>1]=q;d[x+14>>1]=r;y=y+4|0;if((y|0)>=(s|0))break;else x=x+16|0}z=t;A=g+(w<<1)|0;B=v+4|0}else{z=e;A=g;B=0}if((B|0)<(i|0)){g=i-B<<1;e=A+(g<<1)|0;v=A;w=B;while(1){d[v>>1]=q;d[v+2>>1]=r;w=w+1|0;if((w|0)==(i|0))break;else v=v+4|0}C=z+(g<<1)|0;D=e;E=i}else{C=z;D=A;E=B}B=k+-3|0;a:do if((E|0)<(B|0)){A=c+(l+-1<<2)|0;z=m+8|0;i=m+4|0;e=m+12|0;g=n+8|0;v=n+4|0;w=n+12|0;r=o+2|0;q=p+2|0;t=o+4|0;x=p+4|0;s=o+6|0;y=p+6|0;F=o+8|0;G=p+8|0;H=o+10|0;I=p+10|0;J=o+12|0;K=p+12|0;L=o+14|0;M=p+14|0;N=D;O=C;P=E;while(1){Q=f[c+(P+3<<2)>>2]|0;if((Q+7|0)>(f[A>>2]|0)){R=O;S=N;T=P;break a}U=a+(f[c+(P<<2)>>2]<<1)|0;V=a+(f[c+(P+1<<2)>>2]<<1)|0;W=h[V+1>>0]<<16|h[V>>0];X=h[U+3>>0]<<16|h[U+2>>0];Z=h[V+3>>0]<<16|h[V+2>>0];V=a+(f[c+(P+2<<2)>>2]<<1)|0;_=a+(Q<<1)|0;Q=h[V+1>>0]<<16|h[V>>0];$=h[_+1>>0]<<16|h[_>>0];aa=h[V+3>>0]<<16|h[V+2>>0];V=h[_+3>>0]<<16|h[_+2>>0];f[m>>2]=h[U+1>>0]<<16|h[U>>0];f[i>>2]=W;f[z>>2]=Q;f[e>>2]=$;f[n>>2]=X;f[v>>2]=Z;f[g>>2]=aa;f[w>>2]=V;d[o>>1]=d[m>>1]|0;d[o+2>>1]=d[m+2>>1]|0;d[o+4>>1]=d[m+4>>1]|0;d[o+6>>1]=d[m+6>>1]|0;d[o+8>>1]=d[m+8>>1]|0;d[o+10>>1]=d[m+10>>1]|0;d[o+12>>1]=d[m+12>>1]|0;d[o+14>>1]=d[m+14>>1]|0;d[p>>1]=d[n>>1]|0;d[p+2>>1]=d[n+2>>1]|0;d[p+4>>1]=d[n+4>>1]|0;d[p+6>>1]=d[n+6>>1]|0;d[p+8>>1]=d[n+8>>1]|0;d[p+10>>1]=d[n+10>>1]|0;d[p+12>>1]=d[n+12>>1]|0;d[p+14>>1]=d[n+14>>1]|0;V=f[O>>2]|0;aa=f[O+4>>2]|0;Z=f[O+8>>2]|0;X=f[O+12>>2]|0;$=V<<16>>16;Q=V>>16;V=(Y(Q,d[p>>1]|0)|0)+(Y($,d[o>>1]|0)|0)|0;W=(Y(Q,d[q>>1]|0)|0)+(Y($,d[r>>1]|0)|0)|0;$=aa<<16>>16;Q=aa>>16;aa=(Y(Q,d[x>>1]|0)|0)+(Y($,d[t>>1]|0)|0)|0;U=(Y(Q,d[y>>1]|0)|0)+(Y($,d[s>>1]|0)|0)|0;$=Z<<16>>16;Q=Z>>16;Z=(Y(d[G>>1]|0,Q)|0)+(Y(d[F>>1]|0,$)|0)|0;_=(Y(d[I>>1]|0,Q)|0)+(Y(d[H>>1]|0,$)|0)|0;$=X<<16>>16;Q=X>>16;X=(Y(d[K>>1]|0,Q)|0)+(Y(d[J>>1]|0,$)|0)|0;ba=(Y(d[M>>1]|0,Q)|0)+(Y(d[L>>1]|0,$)|0)|0;d[N>>1]=V>>>0<65535?V:65535;d[N+2>>1]=W>>>0<65535?W:65535;d[N+4>>1]=aa>>>0<65535?aa:65535;d[N+6>>1]=U>>>0<65535?U:65535;d[N+8>>1]=Z>>>0<65535?Z:65535;d[N+10>>1]=_>>>0<65535?_:65535;d[N+12>>1]=X>>>0<65535?X:65535;d[N+14>>1]=ba>>>0<65535?ba:65535;ba=P+4|0;X=O+16|0;_=N+16|0;if((ba|0)<(B|0)){N=_;O=X;P=ba}else{R=X;S=_;T=ba;break}}}else{R=C;S=D;T=E}while(0);if((T|0)<(k|0)){E=k-T<<1;D=S;C=R;R=T;while(1){B=a+(f[c+(R<<2)>>2]<<1)|0;o=Y(h[B>>0]|0,j[C>>1]|0)|0;p=C+2|0;n=(Y(h[B+2>>0]|0,j[p>>1]|0)|0)+o&65535;d[D>>1]=n;n=Y(h[B+1>>0]|0,j[C>>1]|0)|0;o=(Y(h[B+3>>0]|0,j[p>>1]|0)|0)+n&65535;d[D+2>>1]=o;R=R+1|0;if((R|0)==(k|0))break;else{D=D+4|0;C=C+4|0}}ca=S+(E<<1)|0;da=k}else{ca=S;da=T}T=a+(f[c+(l+-1<<2)>>2]<<1)|0;c=h[T>>0]<<8&65535;a=h[T+1>>0]<<8&65535;T=l+-3|0;if((da|0)<(T|0)){S=(l+-4-da|0)>>>2;k=da+(S<<2)|0;E=(S<<3)+8|0;S=ca;C=da;while(1){d[S>>1]=c;d[S+2>>1]=a;d[S+4>>1]=c;d[S+6>>1]=a;d[S+8>>1]=c;d[S+10>>1]=a;d[S+12>>1]=c;d[S+14>>1]=a;C=C+4|0;if((C|0)>=(T|0))break;else S=S+16|0}ea=k+4|0;fa=ca+(E<<1)|0}else{ea=da;fa=ca}if((ea|0)<(l|0)){ga=fa;ha=ea}else{u=b;return}while(1){d[ga>>1]=c;d[ga+2>>1]=a;ha=ha+1|0;if((ha|0)==(l|0))break;else ga=ga+4|0}u=b;return}function zia(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Fia(a,b,c,d,e,f,g,h);return}function Aia(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=(h[a>>0]|0)<<8&65535;m=(h[a+1>>0]|0)<<8&65535;n=(h[a+2>>0]|0)<<8&65535;if((i|0)>0){o=i*3|0;p=0;q=g;while(1){d[q>>1]=b;d[q+2>>1]=m;d[q+4>>1]=n;p=p+1|0;if((p|0)==(i|0))break;else q=q+6|0}r=e+(i<<1<<1)|0;s=i;t=g+(o<<1)|0}else{r=e;s=0;t=g}if((s|0)<(k|0)){g=k-s|0;e=s;o=t;i=r;while(1){r=a+((f[c+(e<<2)>>2]|0)*3|0)|0;q=Y(h[r>>0]|0,j[i>>1]|0)|0;p=i+2|0;n=(Y(h[r+3>>0]|0,j[p>>1]|0)|0)+q&65535;d[o>>1]=n;n=Y(h[r+1>>0]|0,j[i>>1]|0)|0;q=(Y(h[r+4>>0]|0,j[p>>1]|0)|0)+n&65535;d[o+2>>1]=q;q=Y(h[r+2>>0]|0,j[i>>1]|0)|0;n=(Y(h[r+5>>0]|0,j[p>>1]|0)|0)+q&65535;d[o+4>>1]=n;e=e+1|0;if((e|0)==(k|0))break;else{o=o+6|0;i=i+4|0}}u=k;v=t+(g*3<<1)|0}else{u=s;v=t}t=a+((f[c+(l+-1<<2)>>2]|0)*3|0)|0;c=(h[t>>0]|0)<<8&65535;a=(h[t+1>>0]|0)<<8&65535;s=(h[t+2>>0]|0)<<8&65535;if((u|0)<(l|0)){w=v;x=u}else return;while(1){d[w>>1]=c;d[w+2>>1]=a;d[w+4>>1]=s;x=x+1|0;if((x|0)==(l|0))break;else w=w+6|0}return}function Bia(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Fia(a,b,c,d,e,f,g,h);return}function Cia(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;b=(h[a>>0]|0)<<8&65535;m=(h[a+1>>0]|0)<<8&65535;n=(h[a+2>>0]|0)<<8&65535;o=(h[a+3>>0]|0)<<8&65535;p=i+-1|0;if((i|0)>1){q=(i+-2|0)>>>1;r=q<<1;s=(q<<2)+4|0;t=(q<<3)+8|0;q=0;u=g;while(1){d[u>>1]=b;d[u+2>>1]=m;d[u+4>>1]=n;d[u+6>>1]=o;d[u+8>>1]=b;d[u+10>>1]=m;d[u+12>>1]=n;d[u+14>>1]=o;q=q+2|0;if((q|0)>=(p|0))break;else u=u+16|0}v=e+(s<<1)|0;w=r+2|0;x=g+(t<<1)|0}else{v=e;w=0;x=g}if((w|0)<(i|0)){d[x>>1]=b;d[x+2>>1]=m;d[x+4>>1]=n;d[x+6>>1]=o;y=v+4|0;z=w|1;A=x+8|0}else{y=v;z=w;A=x}x=k+-1|0;a:do if((z|0)<(x|0)){w=c+(l+-1<<2)|0;v=z;o=A;n=y;while(1){m=f[c+(v+1<<2)>>2]|0;if((m+3|0)>(f[w>>2]|0)){B=n;C=v;D=o;break a}b=a+(f[c+(v<<2)>>2]<<2)|0;i=a+(m<<2)|0;m=f[n>>2]|0;g=f[n+4>>2]|0;e=m<<16>>16;t=m>>16;m=(Y(e,h[b>>0]|0)|0)+(Y(t,h[b+4>>0]|0)|0)|0;r=(Y(e,h[b+1>>0]|0)|0)+(Y(t,h[b+5>>0]|0)|0)|0;s=(Y(e,h[b+2>>0]|0)|0)+(Y(t,h[b+6>>0]|0)|0)|0;u=(Y(e,h[b+3>>0]|0)|0)+(Y(t,h[b+7>>0]|0)|0)|0;b=g<<16>>16;t=g>>16;g=(Y(h[i+4>>0]|0,t)|0)+(Y(b,h[i>>0]|0)|0)|0;e=(Y(h[i+5>>0]|0,t)|0)+(Y(h[i+1>>0]|0,b)|0)|0;p=(Y(h[i+6>>0]|0,t)|0)+(Y(h[i+2>>0]|0,b)|0)|0;q=(Y(h[i+7>>0]|0,t)|0)+(Y(h[i+3>>0]|0,b)|0)|0;d[o>>1]=m>>>0<65535?m:65535;d[o+2>>1]=r>>>0<65535?r:65535;d[o+4>>1]=s>>>0<65535?s:65535;d[o+6>>1]=u>>>0<65535?u:65535;d[o+8>>1]=g>>>0<65535?g:65535;d[o+10>>1]=e>>>0<65535?e:65535;d[o+12>>1]=p>>>0<65535?p:65535;d[o+14>>1]=q>>>0<65535?q:65535;q=v+2|0;p=n+8|0;e=o+16|0;if((q|0)<(x|0)){v=q;o=e;n=p}else{B=p;C=q;D=e;break}}}else{B=y;C=z;D=A}while(0);if((C|0)<(k|0)){A=k-C<<2;z=C;y=D;x=B;while(1){B=a+(f[c+(z<<2)>>2]<<2)|0;n=Y(h[B>>0]|0,j[x>>1]|0)|0;o=x+2|0;v=(Y(h[B+4>>0]|0,j[o>>1]|0)|0)+n&65535;d[y>>1]=v;v=Y(h[B+1>>0]|0,j[x>>1]|0)|0;n=(Y(h[B+5>>0]|0,j[o>>1]|0)|0)+v&65535;d[y+2>>1]=n;n=Y(h[B+2>>0]|0,j[x>>1]|0)|0;v=(Y(h[B+6>>0]|0,j[o>>1]|0)|0)+n&65535;d[y+4>>1]=v;v=Y(h[B+3>>0]|0,j[x>>1]|0)|0;n=(Y(h[B+7>>0]|0,j[o>>1]|0)|0)+v&65535;d[y+6>>1]=n;z=z+1|0;if((z|0)==(k|0))break;else{y=y+8|0;x=x+4|0}}E=k;F=D+(A<<1)|0}else{E=C;F=D}D=l+-1|0;C=a+(f[c+(D<<2)>>2]<<2)|0;c=(h[C>>0]|0)<<8&65535;a=(h[C+1>>0]|0)<<8&65535;A=(h[C+2>>0]|0)<<8&65535;k=(h[C+3>>0]|0)<<8&65535;if((E|0)<(D|0)){C=(l+-2-E|0)>>>1;x=E+(C<<1)|0;y=(C<<3)+8|0;C=F;z=E;while(1){d[C>>1]=c;d[C+2>>1]=a;d[C+4>>1]=A;d[C+6>>1]=k;d[C+8>>1]=c;d[C+10>>1]=a;d[C+12>>1]=A;d[C+14>>1]=k;z=z+2|0;if((z|0)>=(D|0))break;else C=C+16|0}G=x+2|0;H=F+(y<<1)|0}else{G=E;H=F}if((G|0)>=(l|0))return;d[H>>1]=c;d[H+2>>1]=a;d[H+4>>1]=A;d[H+6>>1]=k;return}function Dia(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Fia(a,b,c,d,e,f,g,h);return}function Eia(a,b,c,e,g,i,k,l){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;do if((i|0)>0){m=i<<1;if((b|0)<=0){n=e+(m<<1)|0;o=g;p=i;break}q=Y(i,b)|0;r=g;s=0;while(1){t=0;u=r;while(1){d[u>>1]=(h[a+t>>0]|0)<<8;t=t+1|0;if((t|0)==(b|0))break;else u=u+2|0}s=s+1|0;if((s|0)==(i|0))break;else r=r+(b<<1)|0}n=e+(m<<1)|0;o=g+(q<<1)|0;p=i}else{n=e;o=g;p=0}while(0);if((p|0)<(k|0))if((b|0)>0){g=o+((Y(k-p|0,b)|0)<<1)|0;e=p;i=n;n=o;while(1){r=a+(Y(f[c+(e<<2)>>2]|0,b)|0)|0;s=i+2|0;u=0;t=n;while(1){v=Y(h[r+u>>0]|0,j[i>>1]|0)|0;d[t>>1]=v;w=(Y(h[r+(u+b)>>0]|0,j[s>>1]|0)|0)+v&65535;d[t>>1]=w;u=u+1|0;if((u|0)==(b|0))break;else t=t+2|0}e=e+1|0;if((e|0)==(k|0)){x=k;y=g;break}else{i=i+4|0;n=n+(b<<1)|0}}}else{x=k;y=o}else{x=p;y=o}o=a+(Y(f[c+(l+-1<<2)>>2]|0,b)|0)|0;if((x|0)<(l|0)&(b|0)>0){z=x;A=y}else return;while(1){y=0;x=A;while(1){d[x>>1]=(h[o+y>>0]|0)<<8;y=y+1|0;if((y|0)==(b|0))break;else x=x+2|0}z=z+1|0;if((z|0)==(l|0))break;else A=A+(b<<1)|0}return}function Fia(a,b,c,e,g,i,j,k){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;do if((i|0)>0){l=i<<1;if((b|0)<=0){m=e+(l<<1)|0;n=g;o=i;break}p=Y(i,b)|0;q=g;r=0;while(1){s=0;t=q;while(1){d[t>>1]=(h[a+s>>0]|0)<<8;s=s+1|0;if((s|0)==(b|0))break;else t=t+2|0}r=r+1|0;if((r|0)==(i|0))break;else q=q+(b<<1)|0}m=e+(l<<1)|0;n=g+(p<<1)|0;o=i}else{m=e;n=g;o=0}while(0);if((o|0)<(j|0))if((b|0)>0){g=n+((Y(j-o|0,b)|0)<<1)|0;e=m;m=o;i=n;while(1){q=a+(Y(f[c+(m<<2)>>2]|0,b)|0)|0;r=e+2|0;t=0;s=i;while(1){u=d[e>>1]|0;if(!(u<<16>>16))v=0;else v=(Y(h[q+t>>0]|0,u&65535)|0)&65535;d[s>>1]=v;u=d[r>>1]|0;if(!(u<<16>>16))w=0;else w=Y(h[q+(t+b)>>0]|0,u&65535)|0;d[s>>1]=(v&65535)+w;t=t+1|0;if((t|0)==(b|0))break;else s=s+2|0}m=m+1|0;if((m|0)==(j|0)){x=j;y=g;break}else{e=e+4|0;i=i+(b<<1)|0}}}else{x=j;y=n}else{x=o;y=n}n=a+(Y(f[c+(k+-1<<2)>>2]|0,b)|0)|0;if((x|0)<(k|0)&(b|0)>0){z=x;A=y}else return;while(1){y=0;x=A;while(1){d[x>>1]=(h[n+y>>0]|0)<<8;y=y+1|0;if((y|0)==(b|0))break;else x=x+2|0}z=z+1|0;if((z|0)==(k|0))break;else A=A+(b<<1)|0}return}function Gia(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0;g=u;u=u+64|0;h=g+48|0;i=g+40|0;j=g+32|0;k=g+24|0;l=g+16|0;m=g+8|0;n=g;gmb(k,b);p[i>>3]=.5;omb(h,k,i);smb(l,a,h);p[m>>3]=.5;rmb(j,l,m);l=lmb(j)|0;if((l|0)>-1?(k=f[a+8>>2]|0,(k|0)>1):0){o=k+-1|0;if((l|0)>=(o|0)){f[c>>2]=o;o=a+16|0;k=f[o>>2]|0;f[o>>2]=(k|0)>(b|0)?b:k;u=g;return}f[c>>2]=l;gmb(n,l);rmb(m,j,n);if((f[m+4>>2]|0)<0)q=0;else{gmb(i,256);smb(h,m,i);q=(kmb(h)|0)&65535}d[e+2>>1]=q;d[e>>1]=256-(q&65535);u=g;return}q=a+12|0;a=b+1|0;b=f[q>>2]|0;f[q>>2]=(b|0)<(a|0)?a:b;u=g;return}function Hia(a){a=a|0;O5b(a);return}function Iia(a,c){a=a|0;c=c|0;var e=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;e=u;u=u+1104|0;g=e+1088|0;i=e+1072|0;k=e+1056|0;l=e+8|0;m=e;n=a+28|0;o=f[n>>2]|0;p=a+36|0;q=f[p>>2]|0;r=Y(o<<1,q)|0;s=l+8|0;Nac(s|0,0,1040)|0;f[l>>2]=s;t=l+4|0;f[t>>2]=r;if(r>>>0>520){v=N5b(r>>>0>2147483647?-1:r<<1)|0;Nac(v|0,0,r<<1|0)|0;f[l>>2]=v;w=v}else w=s;v=f[a+64>>2]|0;r=f[c>>2]|0;x=(v|0)<(r|0)?r:v;y=c+4|0;z=f[y>>2]|0;A=f[a+68>>2]|0;B=(z|0)<(A|0)?z:A;if((r|0)<(v|0)){Hh[f[a+72>>2]&255](f[a+4>>2]|0,q,f[a+40>>2]|0,f[a+48>>2]|0,w,f[a+56>>2]|0,f[a+60>>2]|0,o);C=-1;D=1;E=f[c>>2]|0}else{C=-2;D=0;E=r}if((E|0)<(x|0)){r=a+20|0;c=a+24|0;o=E;while(1){w=(f[r>>2]|0)+(Y(f[c>>2]|0,o)|0)|0;Jia(f[l>>2]|0,w,Y(f[p>>2]|0,f[n>>2]|0)|0);w=o+1|0;if((w|0)<(x|0))o=w;else{F=w;break}}}else F=E;if((F|0)<(B|0)){E=a+44|0;o=a+16|0;x=a+20|0;c=a+24|0;r=i+8|0;w=i+2|0;q=i+10|0;v=i+4|0;A=i+12|0;z=i+6|0;G=i+14|0;H=k+8|0;I=k+2|0;J=k+10|0;K=k+4|0;L=k+12|0;M=k+6|0;N=k+14|0;O=g+1|0;P=g+2|0;Q=g+3|0;R=g+4|0;S=g+5|0;T=g+6|0;U=g+7|0;V=g+8|0;W=g+9|0;X=g+10|0;Z=g+11|0;_=g+12|0;$=g+13|0;aa=g+14|0;ba=g+15|0;ca=m+2|0;da=a+52|0;ea=a+72|0;fa=a+4|0;ga=a+8|0;ha=a+40|0;ia=a+48|0;ja=a+56|0;ka=a+60|0;la=C;ma=D;na=F;oa=0;while(1){pa=F+oa<<1;qa=(f[E>>2]|0)+(na<<2)|0;ra=la+2|0;sa=f[qa>>2]|0;ta=(sa|0)<(ra|0)?ra:sa;ra=sa+2|0;ua=f[o>>2]|0;if((ta|0)<(((ua|0)<(ra|0)?ua:ra)|0)){ra=ta;ta=ma;while(1){va=(f[fa>>2]|0)+(Y(f[ga>>2]|0,ra)|0)|0;wa=f[p>>2]|0;xa=f[n>>2]|0;ya=(f[l>>2]|0)+((Y(Y(wa,ta)|0,xa)|0)<<1)|0;Hh[f[ea>>2]&255](va,wa,f[ha>>2]|0,f[ia>>2]|0,ya,f[ja>>2]|0,f[ka>>2]|0,xa);ra=ra+1|0;xa=(ta+1|0)%2|0;ya=f[qa>>2]|0;wa=ya+2|0;va=f[o>>2]|0;if((ra|0)>=(((va|0)<(wa|0)?va:wa)|0)){za=xa;Aa=va;Ba=ya;break}else ta=xa}}else{za=ma;Aa=ua;Ba=sa}ta=Aa+-2|0;f[m>>2]=0;ra=(((Ba|0)<(ta|0)?ta:Ba)+za-((la|0)<(ta|0)?ta:la)|0)%2|0;if((ra|0)>0){Vac(m|0,(f[da>>2]|0)+((na<<1)+2-ra<<1)|0,ra<<1|0)|0;Ca=ra}else Ca=0;ta=Ca<<1;Vac(m+ta|0,(f[da>>2]|0)+(Ca+pa-ra<<1)|0,4-ta|0)|0;ta=f[l>>2]|0;qa=Y(f[p>>2]|0,f[n>>2]|0)|0;xa=(f[x>>2]|0)+(Y(f[c>>2]|0,na)|0)|0;if((b[491576]|0)==0?Cac(491576)|0:0){f[126805]=32768;f[126806]=32768;f[126807]=32768;f[126808]=32768}if((b[491584]|0)==0?Cac(491584)|0:0){d[473770]=-32768;d[473771]=-32768;d[473772]=-32768;d[473773]=-32768;d[473774]=-32768;d[473775]=-32768;d[473776]=-32768;d[473777]=-32768}if((b[491592]|0)==0?Cac(491592)|0:0){ya=1120381;va=ya+16|0;do{b[ya>>0]=128;ya=ya+1|0}while((ya|0)<(va|0))}ya=ta+(qa<<1)|0;va=f[m>>2]|0;pa=qa+-15|0;if((qa|0)>15){sa=va<<16>>16;ua=va>>16;va=0;wa=ta;Da=xa;Ea=ya;while(1){Fa=j[473770]|0;Ga=j[473771]|0;Ha=j[473772]|0;Ia=j[473773]|0;Ja=j[473774]|0;Ka=j[473775]|0;La=j[473776]|0;Ma=j[473777]|0;Na=Y(Fa+(j[Ea>>1]|0)<<16>>16,ua)|0;Oa=Y(Ga+(j[Ea+2>>1]|0)<<16>>16,ua)|0;Pa=Y(Ha+(j[Ea+4>>1]|0)<<16>>16,ua)|0;Qa=Y(Ia+(j[Ea+6>>1]|0)<<16>>16,ua)|0;Ra=Y(Ja+(j[Ea+8>>1]|0)<<16>>16,ua)|0;Sa=Y(Ka+(j[Ea+10>>1]|0)<<16>>16,ua)|0;Ta=Y(La+(j[Ea+12>>1]|0)<<16>>16,ua)|0;Ua=Y(Ma+(j[Ea+14>>1]|0)<<16>>16,ua)|0;Va=wa+16|0;Wa=Ea+16|0;Xa=Na+(Y(Fa+(j[wa>>1]|0)<<16>>16,sa)|0)|0;Na=Oa+(Y(Ga+(j[wa+2>>1]|0)<<16>>16,sa)|0)|0;Oa=Pa+(Y(Ha+(j[wa+4>>1]|0)<<16>>16,sa)|0)|0;Pa=Qa+(Y(Ia+(j[wa+6>>1]|0)<<16>>16,sa)|0)|0;Qa=Ra+(Y(Ja+(j[wa+8>>1]|0)<<16>>16,sa)|0)|0;Ra=Sa+(Y(Ka+(j[wa+10>>1]|0)<<16>>16,sa)|0)|0;Sa=Ta+(Y(La+(j[wa+12>>1]|0)<<16>>16,sa)|0)|0;Ta=Ua+(Y(Ma+(j[wa+14>>1]|0)<<16>>16,sa)|0)|0;Ua=(Y((j[Wa>>1]|0)+Fa<<16>>16,ua)|0)+(Y((j[Va>>1]|0)+Fa<<16>>16,sa)|0)|0;Fa=(Y((j[Wa+2>>1]|0)+Ga<<16>>16,ua)|0)+(Y((j[Va+2>>1]|0)+Ga<<16>>16,sa)|0)|0;Ga=(Y((j[Wa+4>>1]|0)+Ha<<16>>16,ua)|0)+(Y((j[Va+4>>1]|0)+Ha<<16>>16,sa)|0)|0;Ha=(Y((j[Wa+6>>1]|0)+Ia<<16>>16,ua)|0)+(Y((j[Va+6>>1]|0)+Ia<<16>>16,sa)|0)|0;Ia=(Y((j[Wa+8>>1]|0)+Ja<<16>>16,ua)|0)+(Y((j[Va+8>>1]|0)+Ja<<16>>16,sa)|0)|0;Ja=(Y((j[Wa+10>>1]|0)+Ka<<16>>16,ua)|0)+(Y((j[Va+10>>1]|0)+Ka<<16>>16,sa)|0)|0;Ka=(Y((j[Wa+12>>1]|0)+La<<16>>16,ua)|0)+(Y((j[Va+12>>1]|0)+La<<16>>16,sa)|0)|0;La=(Y((j[Wa+14>>1]|0)+Ma<<16>>16,ua)|0)+(Y((j[Va+14>>1]|0)+Ma<<16>>16,sa)|0)|0;Ma=f[126805]|0;Va=f[126806]|0;Wa=f[126807]|0;Ya=f[126808]|0;Za=Xa+Ma>>16;Xa=Na+Va>>16;Na=Oa+Wa>>16;Oa=Pa+Ya>>16;Pa=Qa+Ma>>16;Qa=Ra+Va>>16;Ra=Sa+Wa>>16;Sa=Ta+Ya>>16;d[i>>1]=(Za+32768|0)>>>0<65536?Za:(Za|0)>0?32767:32768;d[r>>1]=(Pa+32768|0)>>>0<65536?Pa:(Pa|0)>0?32767:32768;d[w>>1]=(Xa+32768|0)>>>0<65536?Xa:(Xa|0)>0?32767:32768;d[q>>1]=(Qa+32768|0)>>>0<65536?Qa:(Qa|0)>0?32767:32768;d[v>>1]=(Na+32768|0)>>>0<65536?Na:(Na|0)>0?32767:32768;d[A>>1]=(Ra+32768|0)>>>0<65536?Ra:(Ra|0)>0?32767:32768;d[z>>1]=(Oa+32768|0)>>>0<65536?Oa:(Oa|0)>0?32767:32768;d[G>>1]=(Sa+32768|0)>>>0<65536?Sa:(Sa|0)>0?32767:32768;Sa=Ua+Ma>>16;Ua=Fa+Va>>16;Fa=Ga+Wa>>16;Ga=Ha+Ya>>16;Ha=Ia+Ma>>16;Ma=Ja+Va>>16;Va=Ka+Wa>>16;Wa=La+Ya>>16;d[k>>1]=(Sa+32768|0)>>>0<65536?Sa:(Sa|0)>0?32767:32768;d[H>>1]=(Ha+32768|0)>>>0<65536?Ha:(Ha|0)>0?32767:32768;d[I>>1]=(Ua+32768|0)>>>0<65536?Ua:(Ua|0)>0?32767:32768;d[J>>1]=(Ma+32768|0)>>>0<65536?Ma:(Ma|0)>0?32767:32768;d[K>>1]=(Fa+32768|0)>>>0<65536?Fa:(Fa|0)>0?32767:32768;d[L>>1]=(Va+32768|0)>>>0<65536?Va:(Va|0)>0?32767:32768;d[M>>1]=(Ga+32768|0)>>>0<65536?Ga:(Ga|0)>0?32767:32768;d[N>>1]=(Wa+32768|0)>>>0<65536?Wa:(Wa|0)>0?32767:32768;Kia(g,i,k);Wa=(h[O>>0]|0)-(h[1120382]|0)&255;Ga=(h[P>>0]|0)-(h[1120383]|0)&255;Va=(h[Q>>0]|0)-(h[1120384]|0)&255;Fa=(h[R>>0]|0)-(h[1120385]|0)&255;Ma=(h[S>>0]|0)-(h[1120386]|0)&255;Ua=(h[T>>0]|0)-(h[1120387]|0)&255;Ha=(h[U>>0]|0)-(h[1120388]|0)&255;Sa=(h[V>>0]|0)-(h[1120389]|0)&255;Ya=(h[W>>0]|0)-(h[1120390]|0)&255;La=(h[X>>0]|0)-(h[1120391]|0)&255;Ka=(h[Z>>0]|0)-(h[1120392]|0)&255;Ja=(h[_>>0]|0)-(h[1120393]|0)&255;Ia=(h[$>>0]|0)-(h[1120394]|0)&255;Oa=(h[aa>>0]|0)-(h[1120395]|0)&255;Ra=(h[ba>>0]|0)-(h[1120396]|0)&255;b[Da>>0]=(h[g>>0]|0)-(h[1120381]|0);b[Da+1>>0]=Wa;b[Da+2>>0]=Ga;b[Da+3>>0]=Va;b[Da+4>>0]=Fa;b[Da+5>>0]=Ma;b[Da+6>>0]=Ua;b[Da+7>>0]=Ha;b[Da+8>>0]=Sa;b[Da+9>>0]=Ya;b[Da+10>>0]=La;b[Da+11>>0]=Ka;b[Da+12>>0]=Ja;b[Da+13>>0]=Ia;b[Da+14>>0]=Oa;b[Da+15>>0]=Ra;Ra=va+16|0;Oa=wa+32|0;Ia=Ea+32|0;Ja=Da+16|0;if((Ra|0)<(pa|0)){va=Ra;wa=Oa;Da=Ja;Ea=Ia}else{_a=Ia;$a=Ra;ab=Oa;bb=Ja;break}}}else{_a=ya;$a=0;ab=ta;bb=xa}if(($a|0)<(qa|0)){Ea=$a;Da=ab;wa=bb;va=_a;while(1){pa=Y(j[m>>1]|0,j[Da>>1]|0)|0;sa=(pa+32768+(Y(j[ca>>1]|0,j[va>>1]|0)|0)|0)>>>16;b[wa>>0]=sa>>>0<255?sa:255;Ea=Ea+1|0;if((Ea|0)==(qa|0))break;else{Da=Da+2|0;wa=wa+1|0;va=va+2|0}}}va=na+1|0;if((va|0)<(B|0)){la=Ba;ma=ra;na=va;oa=oa+1|0}else{cb=Ba;db=ra;eb=va;fb=o;break}}}else{cb=C;db=D;eb=F;fb=a+16|0}F=f[l>>2]|0;D=f[fb>>2]|0;if((cb+2|0)>(D|0))gb=F+((Y(Y(f[n>>2]|0,(db+~cb+D|0)%2|0)|0,f[p>>2]|0)|0)<<1)|0;else{cb=(f[a+4>>2]|0)+(Y(f[a+8>>2]|0,D+-1|0)|0)|0;Hh[f[a+72>>2]&255](cb,f[p>>2]|0,f[a+40>>2]|0,f[a+48>>2]|0,F,f[a+56>>2]|0,f[a+60>>2]|0,f[n>>2]|0);gb=F}if((eb|0)<(f[y>>2]|0)){F=a+20|0;cb=a+24|0;a=eb;do{eb=(f[F>>2]|0)+(Y(f[cb>>2]|0,a)|0)|0;Jia(gb,eb,Y(f[p>>2]|0,f[n>>2]|0)|0);a=a+1|0}while((a|0)<(f[y>>2]|0))}y=f[l>>2]|0;if((y|0)==(s|0)){u=e;return}if(y|0)P5b(y);f[l>>2]=s;f[t>>2]=520;u=e;return}function Jia(a,c,e){a=a|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;if((b[491600]|0)==0?Cac(491600)|0:0){d[473778]=128;d[473779]=128;d[473780]=128;d[473781]=128;d[473782]=128;d[473783]=128;d[473784]=128;d[473785]=128}f=e+-15|0;if((e|0)>15){g=e&-16;h=a+(g<<1)|0;i=0;k=a;l=c;while(1){m=k+16|0;n=j[473778]|0;o=n+(j[k>>1]|0)|0;p=j[473779]|0;q=p+(j[k+2>>1]|0)|0;r=j[473780]|0;s=r+(j[k+4>>1]|0)|0;t=j[473781]|0;u=t+(j[k+6>>1]|0)|0;v=j[473782]|0;w=v+(j[k+8>>1]|0)|0;x=j[473783]|0;y=x+(j[k+10>>1]|0)|0;z=j[473784]|0;A=z+(j[k+12>>1]|0)|0;B=j[473785]|0;C=B+(j[k+14>>1]|0)|0;D=n+(j[m>>1]|0)|0;n=p+(j[m+2>>1]|0)|0;p=r+(j[m+4>>1]|0)|0;r=t+(j[m+6>>1]|0)|0;t=v+(j[m+8>>1]|0)|0;v=x+(j[m+10>>1]|0)|0;x=z+(j[m+12>>1]|0)|0;z=B+(j[m+14>>1]|0)|0;b[l>>0]=(o>>>0<65536?o:o|0?65280:0)>>>8;b[l+1>>0]=(q>>>0<65536?q:q|0?65280:0)>>>8;b[l+2>>0]=(s>>>0<65536?s:s|0?65280:0)>>>8;b[l+3>>0]=(u>>>0<65536?u:u|0?65280:0)>>>8;b[l+4>>0]=(w>>>0<65536?w:w|0?65280:0)>>>8;b[l+5>>0]=(y>>>0<65536?y:y|0?65280:0)>>>8;b[l+6>>0]=(A>>>0<65536?A:A|0?65280:0)>>>8;b[l+7>>0]=(C>>>0<65536?C:C|0?65280:0)>>>8;b[l+8>>0]=(D>>>0<65536?D:D|0?65280:0)>>>8;b[l+9>>0]=(n>>>0<65536?n:n|0?65280:0)>>>8;b[l+10>>0]=(p>>>0<65536?p:p|0?65280:0)>>>8;b[l+11>>0]=(r>>>0<65536?r:r|0?65280:0)>>>8;b[l+12>>0]=(t>>>0<65536?t:t|0?65280:0)>>>8;b[l+13>>0]=(v>>>0<65536?v:v|0?65280:0)>>>8;b[l+14>>0]=(x>>>0<65536?x:x|0?65280:0)>>>8;b[l+15>>0]=(z>>>0<65536?z:z|0?65280:0)>>>8;i=i+16|0;if((i|0)>=(f|0))break;else{k=k+32|0;l=l+16|0}}E=g;F=h;G=c+g|0}else{E=0;F=a;G=c}if((E|0)<(e|0)){H=E;I=F;J=G}else return;while(1){b[J>>0]=((j[I>>1]|0)+128|0)>>>8;H=H+1|0;if((H|0)==(e|0))break;else{I=I+2|0;J=J+1|0}}return}function Kia(a,c,e){a=a|0;c=c|0;e=e|0;var f=0,g=0;f=d[c>>1]|0;g=f<<16>>16;b[a>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[e>>1]|0;g=f<<16>>16;b[a+8>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[c+2>>1]|0;g=f<<16>>16;b[a+1>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[e+2>>1]|0;g=f<<16>>16;b[a+9>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[c+4>>1]|0;g=f<<16>>16;b[a+2>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[e+4>>1]|0;g=f<<16>>16;b[a+10>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[c+6>>1]|0;g=f<<16>>16;b[a+3>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[e+6>>1]|0;g=f<<16>>16;b[a+11>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[c+8>>1]|0;g=f<<16>>16;b[a+4>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[e+8>>1]|0;g=f<<16>>16;b[a+12>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[c+10>>1]|0;g=f<<16>>16;b[a+5>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[e+10>>1]|0;g=f<<16>>16;b[a+13>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[c+12>>1]|0;g=f<<16>>16;b[a+6>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[e+12>>1]|0;g=f<<16>>16;b[a+14>>0]=(g+128|0)>>>0<256?g:f<<16>>16>0?127:128;f=d[c+14>>1]|0;c=f<<16>>16;b[a+7>>0]=(c+128|0)>>>0<256?c:f<<16>>16>0?127:128;f=d[e+14>>1]|0;e=f<<16>>16;b[a+15>>0]=(e+128|0)>>>0<256?e:f<<16>>16>0?127:128;return}function Lia(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0;i=u;u=u+160|0;j=i+144|0;k=i+136|0;l=i+80|0;m=i+72|0;n=i+16|0;o=i;dQ(j,57360);AL(k,a,-1);if(!((f[k>>2]|0)>0?(f[k+4>>2]|0)>0:0)){f[l>>2]=0;f[l+4>>2]=0;p=aD(l,35)|0;q=258787;r=p+35|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,l,255795,255802,4044);bD(l)}s=f[d>>2]|0;t=d+4|0;v=f[t>>2]|0;if((Y(v,s)|0)<=0?!(e>0.0&g>0.0):0){f[l>>2]=0;f[l+4>>2]=0;p=aD(l,56)|0;q=258823;r=p+56|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,l,255795,255802,4045);bD(l);w=f[d>>2]|0;x=f[t>>2]|0}else{w=s;x=v}if(!(Y(x,w)|0)){v=MVb(+(f[k>>2]|0)*e)|0;s=MVb(+(f[k+4>>2]|0)*g)|0;f[d>>2]=v;f[t>>2]=s;if((Y(s,v)|0)>0){y=g;z=e}else{f[l>>2]=0;f[l+4>>2]=0;p=aD(l,16)|0;q=255873;r=p+16|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,l,255795,255802,4050);bD(l);y=g;z=e}}else{y=+(x|0)/+(f[k+4>>2]|0);z=+(w|0)/+(f[k>>2]|0)}do if((h|0)==5){if((FM(a,-1)|0)!=5?(FM(a,-1)|0)!=6:0){A=5;break}A=1}else A=h;while(0);do if((yM(a)|0)==65536){h=f[a+4>>2]|0;f[l>>2]=f[h>>2];w=l+4|0;x=h+4|0;f[w>>2]=f[x>>2];q=l+8|0;f[q>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[l+16>>2]=f[h+16>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];p=f[h+36>>2]|0;f[l+36>>2]=p;f[l+40>>2]=q;q=l+48|0;r=l+44|0;f[r>>2]=q;f[q>>2]=0;f[l+52>>2]=0;if(p|0){q=p+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[x>>2]|0)<3){x=f[h+44>>2]|0;q=f[r>>2]|0;f[q>>2]=f[x>>2];f[q+4>>2]=f[x+4>>2];B=l;break}else{f[w>>2]=0;jL(l,h);B=l;break}}else{yL(l,a,-1);B=l}while(0);f[m>>2]=f[d>>2];f[m+4>>2]=f[t>>2];vM(c,m,f[B>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){m=f[c+4>>2]|0;f[n>>2]=f[m>>2];a=n+4|0;h=m+4|0;f[a>>2]=f[h>>2];w=n+8|0;f[w>>2]=f[m+8>>2];f[n+12>>2]=f[m+12>>2];f[n+16>>2]=f[m+16>>2];f[n+20>>2]=f[m+20>>2];f[n+24>>2]=f[m+24>>2];f[n+28>>2]=f[m+28>>2];f[n+32>>2]=f[m+32>>2];x=f[m+36>>2]|0;f[n+36>>2]=x;f[n+40>>2]=w;w=n+48|0;q=n+44|0;f[q>>2]=w;f[w>>2]=0;f[n+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[h>>2]|0)<3){h=f[m+44>>2]|0;w=f[q>>2]|0;f[w>>2]=f[h>>2];f[w+4>>2]=f[h+4>>2];break}else{f[a>>2]=0;jL(n,m);break}}else yL(n,c,-1);while(0);if((f[d>>2]|0)==(f[k>>2]|0)?(f[t>>2]|0)==(f[k+4>>2]|0):0){k=o+8|0;f[k>>2]=0;f[k+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=n;SP(l,o)}else Fea(f[B>>2]&4095,f[l+16>>2]|0,f[l+48>>2]|0,f[l+12>>2]|0,f[l+8>>2]|0,f[n+16>>2]|0,f[n+48>>2]|0,f[n+12>>2]|0,f[n+8>>2]|0,z,y,A);A=n+36|0;B=f[A>>2]|0;if(B|0?(o=B+12|0,B=f[o>>2]|0,f[o>>2]=B+-1,(B|0)==1):0)kL(n);f[A>>2]=0;A=n+16|0;B=n+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){A=f[n+40>>2]|0;o=0;do{f[A+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[B>>2]|0))}B=f[n+44>>2]|0;if((B|0)!=(n+48|0))UC(B);B=l+36|0;n=f[B>>2]|0;if(n|0?(o=n+12|0,n=f[o>>2]|0,f[o>>2]=n+-1,(n|0)==1):0)kL(l);f[B>>2]=0;B=l+16|0;n=l+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[n>>2]|0)>0){B=f[l+40>>2]|0;o=0;do{f[B+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)!=(l+48|0))UC(n);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function Mia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+160|0;g=e+96|0;h=e+40|0;i=e+24|0;j=e;k=e+16|0;tL(g,a,0,1,0,0);tL(h,c,0,1,0,0);if((f[h>>2]^f[g>>2])&4095|0){f[i>>2]=0;f[i+4>>2]=0;c=aD(i,24)|0;a=443245;l=c+24|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(l|0));bO(-215,i,258948,255802,4083);bD(i)}f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=g;a=j+8|0;f[a>>2]=0;f[a+4>>2]=0;f[j>>2]=33619968;f[j+4>>2]=h;a=h+40|0;c=f[a>>2]|0;l=f[c>>2]|0;f[k>>2]=f[c+4>>2];f[k+4>>2]=l;Lia(i,j,k,+(f[h+12>>2]|0)/+(f[g+12>>2]|0),+(f[h+8>>2]|0)/+(f[g+8>>2]|0),d);d=h+36|0;k=f[d>>2]|0;if(k|0?(j=k+12|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)kL(h);f[d>>2]=0;d=h+16|0;k=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[a>>2]|0;a=0;do{f[d+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[k>>2]|0))}k=f[h+44>>2]|0;if((k|0)!=(h+48|0))UC(k);k=g+36|0;h=f[k>>2]|0;if(h|0?(a=h+12|0,h=f[a>>2]|0,f[a>>2]=h+-1,(h|0)==1):0)kL(g);f[k>>2]=0;k=g+16|0;h=g+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[h>>2]|0)>0){k=f[g+40>>2]|0;a=0;do{f[k+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)==(g+48|0)){u=e;return}UC(h);u=e;return}function Nia(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0.0,L=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0;e=u;u=u+80|0;g=e+64|0;h=e+8|0;i=e;dQ(g,57380);do if((yM(a)|0)==65536){j=f[a+4>>2]|0;f[h>>2]=f[j>>2];k=h+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=h+8|0;f[m>>2]=f[j+8>>2];f[h+12>>2]=f[j+12>>2];f[h+16>>2]=f[j+16>>2];f[h+20>>2]=f[j+20>>2];f[h+24>>2]=f[j+24>>2];f[h+28>>2]=f[j+28>>2];f[h+32>>2]=f[j+32>>2];o=f[j+36>>2]|0;f[h+36>>2]=o;f[h+40>>2]=m;m=h+48|0;p=h+44|0;f[p>>2]=m;f[m>>2]=0;f[h+52>>2]=0;if(o|0){m=o+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;jL(h,j);break}}else yL(h,a,-1);while(0);a=wM(h,2,-1,1)|0;j=f[h>>2]&7;if(!((a|0)>-1&(j|1|0)==5)){f[i>>2]=0;f[i+4>>2]=0;k=aD(i,40)|0;l=259030;m=k+40|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,i,259071,258957,103);bD(i)}i=(j|0)==5;q=+n[c>>2];j=LVb(q)|0;r=+n[c+4>>2];c=LVb(r)|0;a:do if(!a)t=d?-1797693134862315708145274.0e284:-1.0;else{l=f[h+16>>2]|0;k=a+-1|0;m=f[l+(k<<3)>>2]|0;if(+(j|0)==q&((i|d)^1)&+(c|0)==r){if((a|0)>0){p=0;o=0;v=m;w=f[l+(k<<3)+4>>2]|0;while(1){x=v;v=f[l+(p<<3)>>2]|0;y=w;w=f[l+(p<<3)+4>>2]|0;z=(w|0)>(c|0);if((c|0)<(y|0))if(z)A=19;else A=18;else if(z)A=18;else A=19;if((A|0)==18){A=0;if(!((j|0)>(x|0)&(v|0)<(j|0))){z=c-y|0;B=v-x|0;C=cbc(B|0,((B|0)<0)<<31>>31|0,z|0,((z|0)<0)<<31>>31|0)|0;z=J;B=j-x|0;D=w-y|0;E=cbc(D|0,((D|0)<0)<<31>>31|0,B|0,((B|0)<0)<<31>>31|0)|0;B=Jac(C|0,z|0,E|0,J|0)|0;E=J;z=(w|0)<(y|0);C=Jac(0,0,B|0,E|0)|0;D=z?J:E;if((B|0)==0&(E|0)==0){t=0.0;break a}else F=(((D|0)>0|(D|0)==0&(z?C:B)>>>0>0)&1)+o|0}else A=19}if((A|0)==19){A=0;if((c|0)==(w|0)){if((j|0)==(v|0)){t=0.0;break a}if((c|0)==(y|0)){if(!((j|0)<(x|0)|(j|0)>(v|0))){t=0.0;break a}if(!((j|0)>(x|0)|(v|0)>(j|0))){t=0.0;break a}else F=o}else F=o}else F=o}p=p+1|0;if((p|0)>=(a|0)){G=F;break}else o=F}}else G=0;t=+((G<<1&2)+-1|0);break}o=f[l+(k<<3)+4>>2]|0;if(i){H=m;I=o;K=(f[s>>2]=o,+n[s>>2])}else{L=+(o|0);o=(n[s>>2]=+(m|0),f[s>>2]|0);H=o;I=(n[s>>2]=L,f[s>>2]|0);K=L}o=(a|0)>0;if(!d){if(o)if(i){p=0;v=0;w=H;L=K;while(1){x=w;w=f[l+(p<<3)>>2]|0;N=(f[s>>2]=w,+n[s>>2]);O=L;L=+n[l+(p<<3)+4>>2];if((!(O<=r)|!(L<=r)?!(O>r&L>r):0)?(P=(f[s>>2]=x,+n[s>>2]),!(P<q&N<q)):0){Q=(N-P)*(r-O)-(L-O)*(q-P);if(Q==0.0){t=0.0;break a}R=((L<O?-Q:Q)>0.0&1)+v|0}else if(r==L){if(q==N){t=0.0;break a}if(r==O){O=(f[s>>2]=x,+n[s>>2]);if(!(!(O<=q)|!(q<=N))){t=0.0;break a}if(!(!(N<=q)|!(q<=O))){t=0.0;break a}else R=v}else R=v}else R=v;p=p+1|0;if((p|0)>=(a|0)){S=R;break}else v=R}}else{v=0;p=0;w=H;L=K;while(1){O=+(f[l+(v<<3)>>2]|0);N=L;L=+(f[l+(v<<3)+4>>2]|0);m=w;w=(n[s>>2]=O,f[s>>2]|0);if((!(N<=r)|!(L<=r)?!(N>r&L>r):0)?(Q=(f[s>>2]=m,+n[s>>2]),!(Q<q&O<q)):0){P=(O-Q)*(r-N)-(L-N)*(q-Q);if(P==0.0){t=0.0;break a}T=((L<N?-P:P)>0.0&1)+p|0}else if(r==L){if(q==O){t=0.0;break a}if(r==N){N=(f[s>>2]=m,+n[s>>2]);if(!(!(N<=q)|!(q<=O))){t=0.0;break a}if(!(!(O<=q)|!(q<=N))){t=0.0;break a}else T=p}else T=p}else T=p;v=v+1|0;if((v|0)>=(a|0)){S=T;break}else p=T}}else S=0;t=+((S<<1&2)+-1|0);break}b:do if(o)if(i){L=3402823466385288598117041.0e14;N=1.0;p=0;v=0;w=H;m=I;while(1){k=w;w=f[l+(p<<3)>>2]|0;O=(f[s>>2]=w,+n[s>>2]);x=m;m=f[l+(p<<3)+4>>2]|0;P=(f[s>>2]=m,+n[s>>2]);Q=(f[s>>2]=k,+n[s>>2]);U=O-Q;V=(f[s>>2]=x,+n[s>>2]);W=P-V;X=W;Y=q-Q;Z=r-V;_=q-O;$=r-P;do if(!(U*Y+X*Z<=0.0))if(!(U*_+X*$>=0.0)){aa=U*Z-X*Y;ba=U*U+X*X;ca=aa*aa;break}else{ba=1.0;ca=_*_+$*$;break}else{ba=1.0;ca=Y*Y+Z*Z}while(0);if(N*ca<L*ba)if(ca==0.0){da=ca;ea=ba;fa=v;break b}else{ga=ca;ha=ba}else{ga=L;ha=N}if((!(V<=r)|!(P<=r)?!(V>r&P>r):0)?!(Q<q&O<q):0){$=U*Z-X*Y;ia=((W<0.0?-$:$)>0.0&1)+v|0}else ia=v;p=p+1|0;if((p|0)>=(a|0)){da=ga;ea=ha;fa=ia;break}else{L=ga;N=ha;v=ia}}}else{N=3402823466385288598117041.0e14;L=1.0;v=0;p=0;m=H;w=I;while(1){$=+(f[l+(v<<3)>>2]|0);_=+(f[l+(v<<3)+4>>2]|0);x=m;m=(n[s>>2]=$,f[s>>2]|0);k=w;w=(n[s>>2]=_,f[s>>2]|0);aa=(f[s>>2]=x,+n[s>>2]);ja=$-aa;ka=(f[s>>2]=k,+n[s>>2]);la=_-ka;ma=la;na=q-aa;oa=r-ka;pa=q-$;qa=r-_;do if(!(ja*na+ma*oa<=0.0))if(!(ja*pa+ma*qa>=0.0)){ra=ja*oa-ma*na;sa=ja*ja+ma*ma;ta=ra*ra;break}else{sa=1.0;ta=pa*pa+qa*qa;break}else{sa=1.0;ta=na*na+oa*oa}while(0);if(L*ta<N*sa)if(ta==0.0){da=ta;ea=sa;fa=p;break b}else{ua=ta;va=sa}else{ua=N;va=L}if((!(ka<=r)|!(_<=r)?!(ka>r&_>r):0)?!(aa<q&$<q):0){qa=ja*oa-ma*na;wa=((la<0.0?-qa:qa)>0.0&1)+p|0}else wa=p;v=v+1|0;if((v|0)>=(a|0)){da=ua;ea=va;fa=wa;break}else{N=ua;L=va;p=wa}}}else{da=3402823466385288598117041.0e14;ea=1.0;fa=0}while(0);L=+M(+(da/ea));t=(fa&1|0)==0?-L:L}while(0);fa=h+36|0;wa=f[fa>>2]|0;if(wa|0?(a=wa+12|0,wa=f[a>>2]|0,f[a>>2]=wa+-1,(wa|0)==1):0)kL(h);f[fa>>2]=0;fa=h+16|0;wa=h+4|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[wa>>2]|0)>0){fa=f[h+40>>2]|0;a=0;do{f[fa+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[wa>>2]|0))}wa=f[h+44>>2]|0;if((wa|0)!=(h+48|0))UC(wa);if(!(f[g+4>>2]|0)){u=e;return +t}u=e;return +t}function Oia(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0,J=0.0,K=0.0,L=0.0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0.0;d=u;u=u+1152|0;e=d+88|0;g=d+72|0;h=d+64|0;i=d+56|0;j=d;dQ(i,57400);f[j>>2]=1124007936;k=j+4|0;l=j+8|0;m=j+40|0;o=k;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[m>>2]=l;q=j+48|0;r=j+44|0;f[r>>2]=q;f[q>>2]=0;f[j+52>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;t=e+8|0;f[t>>2]=0;f[t+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=j;tZ(c,e,1,1);if((f[j>>2]&7|0)!=5){f[e>>2]=1124007936;c=e+4|0;t=e+8|0;v=e+40|0;o=c;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[v>>2]=t;w=e+48|0;x=e+44|0;f[x>>2]=w;f[w>>2]=0;f[e+52>>2]=0;y=g+8|0;f[y>>2]=0;f[y+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=e;OJ(j,g,5,1.0,0.0);y=e+36|0;z=f[y>>2]|0;if(z|0){A=z+12|0;f[A>>2]=(f[A>>2]|0)+1}A=j+36|0;z=f[A>>2]|0;if(z|0?(B=z+12|0,z=f[B>>2]|0,f[B>>2]=z+-1,(z|0)==1):0)kL(j);f[A>>2]=0;z=j+16|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[k>>2]|0)>0){B=f[m>>2]|0;C=0;do{f[B+(C<<2)>>2]=0;C=C+1|0;D=f[k>>2]|0}while((C|0)<(D|0));f[j>>2]=f[e>>2];if((D|0)<3)E=12;else E=14}else{f[j>>2]=f[e>>2];E=12}if((E|0)==12){D=f[c>>2]|0;if((D|0)<3){f[k>>2]=D;f[l>>2]=f[t>>2];f[j+12>>2]=f[e+12>>2];t=f[x>>2]|0;l=f[r>>2]|0;f[l>>2]=f[t>>2];f[l+4>>2]=f[t+4>>2]}else E=14}if((E|0)==14)jL(j,e);t=e+16|0;f[z>>2]=f[t>>2];f[j+20>>2]=f[e+20>>2];f[j+24>>2]=f[e+24>>2];f[j+28>>2]=f[e+28>>2];f[j+32>>2]=f[e+32>>2];z=f[y>>2]|0;f[A>>2]=z;if(z|0?(A=z+12|0,z=f[A>>2]|0,f[A>>2]=z+-1,(z|0)==1):0)kL(e);f[y>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[c>>2]|0)>0){t=f[v>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[c>>2]|0))}c=f[x>>2]|0;if((c|0)!=(w|0))UC(c)}c=wM(j,2,-1,1)|0;w=j+16|0;x=f[w>>2]|0;a:do if((c|0)>2){v=c*3|0;t=e+8|0;f[e>>2]=t;y=e+4|0;f[y>>2]=v;if(v>>>0>264){z=N5b(v>>>0>1073741823?-1:v<<2)|0;f[e>>2]=z;F=z}else F=t;z=F+(c<<2)|0;f[g>>2]=-1;f[g+4>>2]=-1;f[g+8>>2]=-1;f[g+12>>2]=-1;v=f[x>>2]|0;A=f[x+4>>2]|0;G=(f[s>>2]=v,+n[s>>2]);H=(f[s>>2]=A,+n[s>>2]);l=0;D=0;C=0;B=0;I=0;J=G;K=G;G=H;L=H;N=v;v=A;while(1){H=(f[s>>2]=N,+n[s>>2]);A=H<J;D=A?l:D;O=H>K;B=O?l:B;P=(f[s>>2]=v,+n[s>>2]);Q=P>G;I=Q?l:I;R=P<L;C=R?l:C;S=l;l=l+1|0;T=(l|0)<(c|0)?l:0;N=f[x+(T<<3)>>2]|0;v=f[x+(T<<3)+4>>2]|0;V=(f[s>>2]=N,+n[s>>2])-H;W=V;X=(f[s>>2]=v,+n[s>>2])-P;Y=X;n[z+(S<<3)>>2]=V;n[z+(S<<3)+4>>2]=X;X=1.0/+M(+(W*W+Y*Y));n[F+(S<<2)>>2]=X;if((l|0)==(c|0))break;else{J=A?H:J;K=O?H:K;G=Q?P:G;L=R?P:L}}l=c+-1|0;L=+n[z+(l<<3)>>2];G=+n[z+(l<<3)+4>>2];l=0;while(1){K=L;L=+n[z+(l<<3)>>2];J=G;G=+n[z+(l<<3)+4>>2];Z=K*G-J*L;l=l+1|0;if(Z!=0.0){E=33;break}if((l|0)>=(c|0)){E=32;break}}if((E|0)==32){f[h>>2]=0;f[h+4>>2]=0;o=aD(h,16)|0;l=259143;p=o+16|0;do{b[o>>0]=b[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(p|0));bO(-215,h,259160,259177,166);bD(h);_=0.0}else if((E|0)==33)_=Z>0.0?1.0:-1.0;f[g>>2]=C;l=g+4|0;f[l>>2]=B;v=g+8|0;f[v>>2]=I;N=g+12|0;f[N>>2]=D;R=0;L=_;G=0.0;J=3402823466385288598117041.0e14;Q=0;K=0.0;P=0.0;H=0.0;O=0;X=0.0;A=C;S=B;T=I;$=D;b:while(1){Y=(L*+n[z+(A<<3)>>2]+G*+n[z+(A<<3)+4>>2])*+n[F+(A<<2)>>2];W=(L*+n[z+(S<<3)+4>>2]-G*+n[z+(S<<3)>>2])*+n[F+(S<<2)>>2];aa=W>Y;V=aa?W:Y;Y=(-(L*+n[z+(T<<3)>>2])-G*+n[z+(T<<3)+4>>2])*+n[F+(T<<2)>>2];ba=Y>V;ca=(G*+n[z+($<<3)>>2]-L*+n[z+($<<3)+4>>2])*+n[F+($<<2)>>2]>(ba?Y:V)?3:ba?2:aa&1;aa=g+(ca<<2)|0;ba=f[aa>>2]|0;V=+n[F+(ba<<2)>>2];Y=+n[z+(ba<<3)>>2]*V;W=V*+n[z+(ba<<3)+4>>2];switch(ca&3){case 0:{da=Y;ea=W;break}case 1:{da=W;ea=-Y;break}case 2:{da=-Y;ea=-W;break}case 3:{da=-W;ea=Y;break}default:{E=39;break b}}ca=ba+1|0;f[aa>>2]=(ca|0)==(c|0)?0:ca;S=f[l>>2]|0;$=f[N>>2]|0;Y=da*(+n[x+(S<<3)>>2]-+n[x+($<<3)>>2])+ea*(+n[x+(S<<3)+4>>2]-+n[x+($<<3)+4>>2]);T=f[v>>2]|0;A=f[g>>2]|0;W=da*(+n[x+(T<<3)+4>>2]-+n[x+(A<<3)+4>>2])-ea*(+n[x+(T<<3)>>2]-+n[x+(A<<3)>>2]);V=Y*W;if(!(V<=J)){fa=J;ga=Q;ha=K;ia=P;ja=H;ka=O;la=X}else{fa=V;ga=$;ha=Y;ia=ea;ja=W;ka=A;la=da}R=R+1|0;if((R|0)>=(c|0))break;else{L=da;G=ea;J=fa;Q=ga;K=ha;P=ia;H=ja;O=ka;X=la}}X=-ia;H=la*+n[x+(ga<<3)>>2]+ia*+n[x+(ga<<3)+4>>2];P=+n[x+(ka<<3)>>2]*X+la*+n[x+(ka<<3)+4>>2];K=1.0/(la*la-ia*X);J=K*(la*H-ia*P);G=K*(la*P-H*X);H=ha*la;P=ia*ha;K=ja*X;X=ja*la;O=f[e>>2]|0;if((O|0)!=(t|0)){if(O|0)P5b(O);f[e>>2]=t;f[y>>2]=264}n[a>>2]=J+(H+K)*.5;n[a+4>>2]=G+(P+X)*.5;G=H;H=P;P=+M(+(G*G+H*H));n[a+8>>2]=P;P=K;K=X;X=+M(+(P*P+K*K));n[a+12>>2]=X;X=+U(+H,+G);n[a+16>>2]=X}else switch(c|0){case 2:{X=+n[x>>2];G=+n[x+8>>2];n[a>>2]=(X+G)*.5;H=+n[x+4>>2];K=+n[x+12>>2];n[a+4>>2]=(H+K)*.5;P=G-X;X=K-H;H=+M(+(P*P+X*X));n[a+8>>2]=H;n[a+12>>2]=0.0;H=+U(+X,+P);n[a+16>>2]=H;break a;break}case 1:{f[a>>2]=f[x>>2];f[a+4>>2]=f[x+4>>2];break a;break}default:break a}while(0);x=a+16|0;n[x>>2]=+n[x>>2]*180.0/3.141592653589793;x=j+36|0;a=f[x>>2]|0;if(a|0?(c=a+12|0,a=f[c>>2]|0,f[c>>2]=a+-1,(a|0)==1):0)kL(j);f[x>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[k>>2]|0)>0){w=f[m>>2]|0;m=0;do{f[w+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[r>>2]|0;if((k|0)!=(q|0))UC(k);if(!(f[i+4>>2]|0)){u=d;return}u=d;return}function Pia(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=u;u=u+16|0;i=h;j=h+8|0;k=d&7;l=(g|0)<0?(e|0)/2|0:g;g=(c|0)==0;if((c|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;c=aD(j,39)|0;m=260066;n=c+39|0;do{b[c>>0]=b[m>>0]|0;c=c+1|0;m=m+1|0}while((c|0)<(n|0));bO(-215,j,260106,260129,852);bD(j)}m=(k|0)==0;a:do if(g){if(m){k=L5b(16)|0;a8(k);f[k>>2]=57428;f[k+4>>2]=e;f[k+8>>2]=l;c=L5b(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=57448;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}switch(d&7){case 2:{c=L5b(16)|0;a8(c);f[c>>2]=57468;f[c+4>>2]=e;f[c+8>>2]=l;k=L5b(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=57488;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}bi[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}case 3:{k=L5b(16)|0;a8(k);f[k>>2]=57508;f[k+4>>2]=e;f[k+8>>2]=l;c=L5b(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=57528;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 5:{c=L5b(16)|0;a8(c);f[c>>2]=57548;f[c+4>>2]=e;f[c+8>>2]=l;k=L5b(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=57568;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}bi[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}case 6:{k=L5b(16)|0;a8(k);f[k>>2]=57588;f[k+4>>2]=e;f[k+8>>2]=l;c=L5b(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=57608;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}default:break a}}else{if(m){c=L5b(16)|0;a8(c);f[c>>2]=57628;f[c+4>>2]=e;f[c+8>>2]=l;k=L5b(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=57648;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}bi[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}switch(d&7){case 2:{k=L5b(16)|0;a8(k);f[k>>2]=57668;f[k+4>>2]=e;f[k+8>>2]=l;c=L5b(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=57688;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 3:{c=L5b(16)|0;a8(c);f[c>>2]=57708;f[c+4>>2]=e;f[c+8>>2]=l;k=L5b(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=57728;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}bi[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}case 5:{k=L5b(16)|0;a8(k);f[k>>2]=57748;f[k+4>>2]=e;f[k+8>>2]=l;c=L5b(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=57768;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 6:{c=L5b(16)|0;a8(c);f[c>>2]=57788;f[c+4>>2]=e;f[c+8>>2]=l;k=L5b(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=57808;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}bi[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}default:break a}}while(0);f[i>>2]=d;hO(j,260199,i);bO(-213,j,260106,260129,890);bD(j);f[a>>2]=0;f[a+4>>2]=0;u=h;return}function Qia(a){a=a|0;O5b(a);return}function Ria(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Sia(a){a=a|0;O5b(a);return}function Tia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{p[c+(h<<3)>>3]=+p[b+(h<<3)>>3];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)n=0;else{o=0;while(1){q=c+(o<<3)|0;r=+p[q+(e<<3)>>3];s=+p[q>>3];p[l+(o<<3)>>3]=r<s?s:r;s=+p[q+(h<<3)>>3];p[l+(o+e<<3)>>3]=r<s?s:r;q=o+h|0;if((q|0)>(d|0)){m=q;break a}else o=q}}while(1){o=c+(n<<3)|0;r=+p[o+(e<<3)>>3];q=h;do{s=+p[o+(q<<3)>>3];r=r<s?s:r;q=q+e|0}while((q|0)<(g|0));s=+p[o>>3];p[l+(n<<3)>>3]=r<s?s:r;s=+p[o+(q<<3)>>3];p[l+(n+e<<3)>>3]=r<s?s:r;t=n+h|0;if((t|0)>(d|0)){m=t;break}else n=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){p[l+(t<<3)>>3]=+p[c+(t<<3)>>3];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<3)|0;s=+p[t>>3];v=e;do{w=+p[t+(v<<3)>>3];s=s<w?w:s;v=v+e|0}while((v|0)<(g|0));p[l+(u<<3)>>3]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+8|0;c=c+8|0}}return}function Uia(a){a=a|0;O5b(a);return}function Via(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Wia(a){a=a|0;O5b(a);return}function Xia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{f[c+(h<<2)>>2]=f[b+(h<<2)>>2];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)o=0;else{p=0;while(1){q=c+(p<<2)|0;r=+n[q+(e<<2)>>2];s=+n[q>>2];n[l+(p<<2)>>2]=r<s?s:r;s=+n[q+(h<<2)>>2];n[l+(p+e<<2)>>2]=r<s?s:r;q=p+h|0;if((q|0)>(d|0)){m=q;break a}else p=q}}while(1){p=c+(o<<2)|0;r=+n[p+(e<<2)>>2];q=h;do{s=+n[p+(q<<2)>>2];r=r<s?s:r;q=q+e|0}while((q|0)<(g|0));s=+n[p>>2];n[l+(o<<2)>>2]=r<s?s:r;s=+n[p+(q<<2)>>2];n[l+(o+e<<2)>>2]=r<s?s:r;t=o+h|0;if((t|0)>(d|0)){m=t;break}else o=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){f[l+(t<<2)>>2]=f[c+(t<<2)>>2];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<2)|0;s=+n[t>>2];v=e;do{w=+n[t+(v<<2)>>2];s=s<w?w:s;v=v+e|0}while((v|0)<(g|0));n[l+(u<<2)>>2]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+4|0;c=c+4|0}}return}function Yia(a){a=a|0;O5b(a);return}function Zia(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _ia(a){a=a|0;O5b(a);return}function $ia(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=r<<16>>16<s<<16>>16?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=r<<16>>16<s<<16>>16?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=d[p+(g<<1)>>1]|0;s=i;do{q=d[p+(s<<1)>>1]|0;r=r<<16>>16<q<<16>>16?q:r;s=s+g|0}while((s|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=r<<16>>16<q<<16>>16?q:r;q=d[p+(s<<1)>>1]|0;d[m+(o+g<<1)>>1]=r<<16>>16<q<<16>>16?q:r;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=d[q>>1]|0;v=g;do{w=d[q+(v<<1)>>1]|0;u=u<<16>>16<w<<16>>16?w:u;v=v+g|0}while((v|0)<(h|0));d[m+(t<<1)>>1]=u;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function aja(a){a=a|0;O5b(a);return}function bja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function cja(a){a=a|0;O5b(a);return}function dja(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=(r&65535)<(s&65535)?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=(r&65535)<(s&65535)?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=d[p+(g<<1)>>1]|0;s=i;do{q=d[p+(s<<1)>>1]|0;r=(r&65535)<(q&65535)?q:r;s=s+g|0}while((s|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=(r&65535)<(q&65535)?q:r;q=d[p+(s<<1)>>1]|0;d[m+(o+g<<1)>>1]=(r&65535)<(q&65535)?q:r;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=d[q>>1]|0;v=g;do{w=d[q+(v<<1)>>1]|0;u=(u&65535)<(w&65535)?w:u;v=v+g|0}while((v|0)<(h|0));d[m+(t<<1)>>1]=u;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function eja(a){a=a|0;O5b(a);return}function fja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function gja(a){a=a|0;O5b(a);return}function hja(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((i|0)==(g|0)){if((a|0)>0)j=0;else return;do{b[d+j>>0]=b[c+j>>0]|0;j=j+1|0}while((j|0)!=(a|0));return}if((g|0)<=0)return;j=g<<1;e=a-j|0;k=(e|0)<0;l=(i|0)>(g|0);m=(j|0)<(i|0);n=d;d=c;c=0;while(1){a:do if(k)o=0;else{if(m)p=0;else{q=0;while(1){r=d+q|0;s=h[r+g>>0]|0;t=(h[r>>0]|0)-s+256|0;if(t>>>0<769)u=h[259297+t>>0]|0;else u=0;b[n+q>>0]=u+s;t=(h[r+j>>0]|0)-s+256|0;if(t>>>0<769)v=h[259297+t>>0]|0;else v=0;b[n+(q+g)>>0]=v+s;s=q+j|0;if((s|0)>(e|0)){o=s;break a}else q=s}}while(1){q=d+p|0;s=b[q+g>>0]|0;t=j;while(1){r=s&255;w=(h[q+t>>0]|0)-r+256|0;if(w>>>0<769)x=h[259297+w>>0]|0;else x=0;y=x+r|0;t=t+g|0;if((t|0)>=(i|0))break;else s=y&255}s=y&255;r=(h[q>>0]|0)-s+256|0;if(r>>>0<769)z=h[259297+r>>0]|0;else z=0;b[n+p>>0]=z+y;r=(h[q+t>>0]|0)-s+256|0;if(r>>>0<769)A=h[259297+r>>0]|0;else A=0;b[n+(p+g)>>0]=A+y;r=p+j|0;if((r|0)>(e|0)){o=r;break}else p=r}}while(0);b:do if((o|0)<(a|0)){if(l)B=o;else{r=o;while(1){b[n+r>>0]=b[d+r>>0]|0;r=r+g|0;if((r|0)>=(a|0))break b}}do{r=d+B|0;s=b[r>>0]|0;w=g;do{C=s&255;D=(h[r+w>>0]|0)-C+256|0;if(D>>>0<769)E=h[259297+D>>0]|0;else E=0;s=E+C&255;w=w+g|0}while((w|0)<(i|0));b[n+B>>0]=s;B=B+g|0}while((B|0)<(a|0))}while(0);c=c+1|0;if((c|0)==(g|0))break;else{n=n+1|0;d=d+1|0}}return}function ija(a){a=a|0;O5b(a);return}function jja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function kja(a){a=a|0;O5b(a);return}function lja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{p[c+(h<<3)>>3]=+p[b+(h<<3)>>3];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)n=0;else{o=0;while(1){q=c+(o<<3)|0;r=+p[q+(e<<3)>>3];s=+p[q>>3];p[l+(o<<3)>>3]=s<r?s:r;s=+p[q+(h<<3)>>3];p[l+(o+e<<3)>>3]=s<r?s:r;q=o+h|0;if((q|0)>(d|0)){m=q;break a}else o=q}}while(1){o=c+(n<<3)|0;r=+p[o+(e<<3)>>3];q=h;do{s=+p[o+(q<<3)>>3];r=s<r?s:r;q=q+e|0}while((q|0)<(g|0));s=+p[o>>3];p[l+(n<<3)>>3]=s<r?s:r;s=+p[o+(q<<3)>>3];p[l+(n+e<<3)>>3]=s<r?s:r;t=n+h|0;if((t|0)>(d|0)){m=t;break}else n=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){p[l+(t<<3)>>3]=+p[c+(t<<3)>>3];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<3)|0;s=+p[t>>3];v=e;do{w=+p[t+(v<<3)>>3];s=w<s?w:s;v=v+e|0}while((v|0)<(g|0));p[l+(u<<3)>>3]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+8|0;c=c+8|0}}return}function mja(a){a=a|0;O5b(a);return}function nja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function oja(a){a=a|0;O5b(a);return}function pja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0.0;g=Y(f[a+4>>2]|0,e)|0;a=Y(e,d)|0;if((g|0)==(e|0)){if((a|0)>0)h=0;else return;do{f[c+(h<<2)>>2]=f[b+(h<<2)>>2];h=h+1|0}while((h|0)!=(a|0));return}if((e|0)<=0)return;h=e<<1;d=a-h|0;i=(d|0)<0;j=(g|0)>(e|0);k=(h|0)<(g|0);l=c;c=b;b=0;while(1){a:do if(i)m=0;else{if(k)o=0;else{p=0;while(1){q=c+(p<<2)|0;r=+n[q+(e<<2)>>2];s=+n[q>>2];n[l+(p<<2)>>2]=s<r?s:r;s=+n[q+(h<<2)>>2];n[l+(p+e<<2)>>2]=s<r?s:r;q=p+h|0;if((q|0)>(d|0)){m=q;break a}else p=q}}while(1){p=c+(o<<2)|0;r=+n[p+(e<<2)>>2];q=h;do{s=+n[p+(q<<2)>>2];r=s<r?s:r;q=q+e|0}while((q|0)<(g|0));s=+n[p>>2];n[l+(o<<2)>>2]=s<r?s:r;s=+n[p+(q<<2)>>2];n[l+(o+e<<2)>>2]=s<r?s:r;t=o+h|0;if((t|0)>(d|0)){m=t;break}else o=t}}while(0);b:do if((m|0)<(a|0)){if(j)u=m;else{t=m;while(1){f[l+(t<<2)>>2]=f[c+(t<<2)>>2];t=t+e|0;if((t|0)>=(a|0))break b}}do{t=c+(u<<2)|0;s=+n[t>>2];v=e;do{w=+n[t+(v<<2)>>2];s=w<s?w:s;v=v+e|0}while((v|0)<(g|0));n[l+(u<<2)>>2]=s;u=u+e|0}while((u|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(e|0))break;else{l=l+4|0;c=c+4|0}}return}function qja(a){a=a|0;O5b(a);return}function rja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function sja(a){a=a|0;O5b(a);return}function tja(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=s<<16>>16<r<<16>>16?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=s<<16>>16<r<<16>>16?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=d[p+(g<<1)>>1]|0;s=i;do{q=d[p+(s<<1)>>1]|0;r=q<<16>>16<r<<16>>16?q:r;s=s+g|0}while((s|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=q<<16>>16<r<<16>>16?q:r;q=d[p+(s<<1)>>1]|0;d[m+(o+g<<1)>>1]=q<<16>>16<r<<16>>16?q:r;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=d[q>>1]|0;v=g;do{w=d[q+(v<<1)>>1]|0;u=w<<16>>16<u<<16>>16?w:u;v=v+g|0}while((v|0)<(h|0));d[m+(t<<1)>>1]=u;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function uja(a){a=a|0;O5b(a);return}function vja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function wja(a){a=a|0;O5b(a);return}function xja(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((h|0)==(g|0)){if((a|0)>0)i=0;else return;do{d[c+(i<<1)>>1]=d[b+(i<<1)>>1]|0;i=i+1|0}while((i|0)!=(a|0));return}if((g|0)<=0)return;i=g<<1;e=a-i|0;j=(e|0)<0;k=(h|0)>(g|0);l=(i|0)<(h|0);m=c;c=b;b=0;while(1){a:do if(j)n=0;else{if(l)o=0;else{p=0;while(1){q=c+(p<<1)|0;r=d[q+(g<<1)>>1]|0;s=d[q>>1]|0;d[m+(p<<1)>>1]=(s&65535)<(r&65535)?s:r;s=d[q+(i<<1)>>1]|0;d[m+(p+g<<1)>>1]=(s&65535)<(r&65535)?s:r;r=p+i|0;if((r|0)>(e|0)){n=r;break a}else p=r}}while(1){p=c+(o<<1)|0;r=d[p+(g<<1)>>1]|0;s=i;do{q=d[p+(s<<1)>>1]|0;r=(q&65535)<(r&65535)?q:r;s=s+g|0}while((s|0)<(h|0));q=d[p>>1]|0;d[m+(o<<1)>>1]=(q&65535)<(r&65535)?q:r;q=d[p+(s<<1)>>1]|0;d[m+(o+g<<1)>>1]=(q&65535)<(r&65535)?q:r;q=o+i|0;if((q|0)>(e|0)){n=q;break}else o=q}}while(0);b:do if((n|0)<(a|0)){if(k)t=n;else{q=n;while(1){d[m+(q<<1)>>1]=d[c+(q<<1)>>1]|0;q=q+g|0;if((q|0)>=(a|0))break b}}do{q=c+(t<<1)|0;u=d[q>>1]|0;v=g;do{w=d[q+(v<<1)>>1]|0;u=(w&65535)<(u&65535)?w:u;v=v+g|0}while((v|0)<(h|0));d[m+(t<<1)>>1]=u;t=t+g|0}while((t|0)<(a|0))}while(0);b=b+1|0;if((b|0)==(g|0))break;else{m=m+2|0;c=c+2|0}}return}function yja(a){a=a|0;O5b(a);return}function zja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Aja(a){a=a|0;O5b(a);return}function Bja(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=Y(f[a+4>>2]|0,g)|0;a=Y(g,e)|0;if((i|0)==(g|0)){if((a|0)>0)j=0;else return;do{b[d+j>>0]=b[c+j>>0]|0;j=j+1|0}while((j|0)!=(a|0));return}if((g|0)<=0)return;j=g<<1;e=a-j|0;k=(e|0)<0;l=(i|0)>(g|0);m=(j|0)<(i|0);n=d;d=c;c=0;while(1){a:do if(k)o=0;else{if(m)p=0;else{q=0;while(1){r=d+q|0;s=h[r+g>>0]|0;t=s-(h[r>>0]|0)+256|0;if(t>>>0<769)u=h[259297+t>>0]|0;else u=0;b[n+q>>0]=s-u;t=s-(h[r+j>>0]|0)+256|0;if(t>>>0<769)v=h[259297+t>>0]|0;else v=0;b[n+(q+g)>>0]=s-v;s=q+j|0;if((s|0)>(e|0)){o=s;break a}else q=s}}while(1){q=d+p|0;s=b[q+g>>0]|0;t=j;while(1){r=s&255;w=r-(h[q+t>>0]|0)+256|0;if(w>>>0<769)x=h[259297+w>>0]|0;else x=0;y=r-x|0;t=t+g|0;if((t|0)>=(i|0))break;else s=y&255}s=y&255;r=s-(h[q>>0]|0)+256|0;if(r>>>0<769)z=h[259297+r>>0]|0;else z=0;b[n+p>>0]=y-z;r=s-(h[q+t>>0]|0)+256|0;if(r>>>0<769)A=h[259297+r>>0]|0;else A=0;b[n+(p+g)>>0]=y-A;r=p+j|0;if((r|0)>(e|0)){o=r;break}else p=r}}while(0);b:do if((o|0)<(a|0)){if(l)B=o;else{r=o;while(1){b[n+r>>0]=b[d+r>>0]|0;r=r+g|0;if((r|0)>=(a|0))break b}}do{r=d+B|0;s=b[r>>0]|0;w=g;do{C=s&255;D=C-(h[r+w>>0]|0)+256|0;if(D>>>0<769)E=h[259297+D>>0]|0;else E=0;s=C-E&255;w=w+g|0}while((w|0)<(i|0));b[n+B>>0]=s;B=B+g|0}while((B|0)<(a|0))}while(0);c=c+1|0;if((c|0)==(g|0))break;else{n=n+1|0;d=d+1|0}}return}function Cja(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=u;u=u+16|0;i=h;j=h+8|0;k=d&7;l=(g|0)<0?(e|0)/2|0:g;g=(c|0)==0;if((c|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;c=aD(j,39)|0;m=260066;n=c+39|0;do{b[c>>0]=b[m>>0]|0;c=c+1|0;m=m+1|0}while((c|0)<(n|0));bO(-215,j,261867,260129,899);bD(j)}m=(k|0)==0;a:do if(g){if(m){k=L5b(16)|0;b8(k);f[k>>2]=57828;f[k+4>>2]=e;f[k+8>>2]=l;c=L5b(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=57852;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}switch(d&7){case 2:{c=L5b(16)|0;b8(c);f[c>>2]=57872;f[c+4>>2]=e;f[c+8>>2]=l;k=L5b(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=57896;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}bi[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}case 3:{k=L5b(16)|0;b8(k);f[k>>2]=57916;f[k+4>>2]=e;f[k+8>>2]=l;c=L5b(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=57940;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 5:{c=L5b(16)|0;b8(c);f[c>>2]=57960;f[c+4>>2]=e;f[c+8>>2]=l;k=L5b(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=57984;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}bi[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}case 6:{k=L5b(16)|0;b8(k);f[k>>2]=58004;f[k+4>>2]=e;f[k+8>>2]=l;c=L5b(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=58028;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}default:break a}}else{if(m){c=L5b(16)|0;b8(c);f[c>>2]=58048;f[c+4>>2]=e;f[c+8>>2]=l;k=L5b(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=58072;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}bi[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}switch(d&7){case 2:{k=L5b(16)|0;b8(k);f[k>>2]=58092;f[k+4>>2]=e;f[k+8>>2]=l;c=L5b(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=58116;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 3:{c=L5b(16)|0;b8(c);f[c>>2]=58136;f[c+4>>2]=e;f[c+8>>2]=l;k=L5b(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=58160;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}bi[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}case 5:{k=L5b(16)|0;b8(k);f[k>>2]=58180;f[k+4>>2]=e;f[k+8>>2]=l;c=L5b(16)|0;n=c+4|0;f[n>>2]=1;f[c>>2]=58204;f[c+8>>2]=k;f[a>>2]=c;f[a+4>>2]=k;f[n>>2]=(f[n>>2]|0)+1;k=f[n>>2]|0;f[n>>2]=k+-1;if((k|0)!=1){u=h;return}bi[f[(f[c>>2]|0)+8>>2]&2047](c);u=h;return}case 6:{c=L5b(16)|0;b8(c);f[c>>2]=58224;f[c+4>>2]=e;f[c+8>>2]=l;k=L5b(16)|0;n=k+4|0;f[n>>2]=1;f[k>>2]=58248;f[k+8>>2]=c;f[a>>2]=k;f[a+4>>2]=c;f[n>>2]=(f[n>>2]|0)+1;c=f[n>>2]|0;f[n>>2]=c+-1;if((c|0)!=1){u=h;return}bi[f[(f[k>>2]|0)+8>>2]&2047](k);u=h;return}default:break a}}while(0);f[i>>2]=d;hO(j,260199,i);bO(-213,j,261867,260129,937);bD(j);f[a>>2]=0;f[a+4>>2]=0;u=h;return}function Dja(a){a=a|0;O5b(a);return}function Eja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Fja(a){a=a|0;O5b(a);return}function Gja(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>3;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;n=c;o=b;q=e;while(1){a:do if(j)r=0;else{s=f[o+4>>2]|0;t=f[o>>2]|0;if(!k){u=f[o+8>>2]|0;v=0;while(1){w=s+(v<<3)|0;x=+p[w>>3];y=+p[w+8>>3];z=+p[w+16>>3];A=+p[w+24>>3];w=t+(v<<3)|0;B=+p[w>>3];p[n+(v<<3)>>3]=x<B?B:x;B=+p[w+8>>3];p[n+((v|1)<<3)>>3]=y<B?B:y;B=+p[w+16>>3];p[n+((v|2)<<3)>>3]=z<B?B:z;B=+p[w+24>>3];p[n+((v|3)<<3)>>3]=A<B?B:A;w=u+(v<<3)|0;B=+p[w>>3];C=v+a|0;p[n+(C<<3)>>3]=x<B?B:x;x=+p[w+8>>3];p[n+(C+1<<3)>>3]=y<x?x:y;y=+p[w+16>>3];p[n+(C+2<<3)>>3]=z<y?y:z;z=+p[w+24>>3];p[n+(C+3<<3)>>3]=A<z?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[o+(h<<2)>>2]|0;u=0;do{C=s+(u<<3)|0;A=+p[C+24>>3];z=+p[C+16>>3];y=+p[C+8>>3];x=+p[C>>3];C=2;do{w=(f[o+(C<<2)>>2]|0)+(u<<3)|0;B=+p[w>>3];x=x<B?B:x;B=+p[w+8>>3];y=y<B?B:y;B=+p[w+16>>3];z=z<B?B:z;B=+p[w+24>>3];A=A<B?B:A;C=C+1|0}while((C|0)!=(h|0));C=t+(u<<3)|0;B=+p[C>>3];p[n+(u<<3)>>3]=x<B?B:x;B=+p[C+8>>3];p[n+((u|1)<<3)>>3]=y<B?B:y;B=+p[C+16>>3];p[n+((u|2)<<3)>>3]=z<B?B:z;B=+p[C+24>>3];p[n+((u|3)<<3)>>3]=A<B?B:A;C=v+(u<<3)|0;B=+p[C>>3];w=u+a|0;p[n+(w<<3)>>3]=x<B?B:x;B=+p[C+8>>3];p[n+(w+1<<3)>>3]=y<B?B:y;B=+p[C+16>>3];p[n+(w+2<<3)>>3]=z<B?B:z;B=+p[C+24>>3];p[n+(w+3<<3)>>3]=A<B?B:A;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[o+4>>2]|0;v=f[o>>2]|0;if(!k){t=f[o+8>>2]|0;s=r;while(1){B=+p[u+(s<<3)>>3];D=+p[v+(s<<3)>>3];p[n+(s<<3)>>3]=B<D?D:B;D=+p[t+(s<<3)>>3];p[n+(s+a<<3)>>3]=B<D?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[o+(h<<2)>>2]|0;t=r;do{B=+p[u+(t<<3)>>3];w=2;do{D=+p[(f[o+(w<<2)>>2]|0)+(t<<3)>>3];B=B<D?D:B;w=w+1|0}while((w|0)!=(h|0));A=+p[v+(t<<3)>>3];p[n+(t<<3)>>3]=B<A?A:B;A=+p[s+(t<<3)>>3];p[n+(t+a<<3)>>3]=B<A?A:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=q+-2|0;s=n+(l<<3)|0;v=o+8|0;if((t|0)>1){n=s;o=v;q=t}else{E=s;F=v;G=t;break}}}else{E=c;F=b;G=e}if((G|0)<=0)return;e=g+-4|0;b=(g|0)<4;c=g&-4;q=F;F=G;G=E;while(1){c:do if(b)H=0;else{E=f[q>>2]|0;if(d)I=0;else{o=0;while(1){n=E+(o<<3)|0;A=+p[n+8>>3];z=+p[n+16>>3];y=+p[n+24>>3];p[G+(o<<3)>>3]=+p[n>>3];p[G+((o|1)<<3)>>3]=A;p[G+((o|2)<<3)>>3]=z;p[G+((o|3)<<3)>>3]=y;o=o+4|0;if((o|0)>(e|0)){H=c;break c}}}do{o=E+(I<<3)|0;y=+p[o+24>>3];z=+p[o+16>>3];A=+p[o+8>>3];x=+p[o>>3];o=1;do{n=(f[q+(o<<2)>>2]|0)+(I<<3)|0;D=+p[n>>3];x=x<D?D:x;D=+p[n+8>>3];A=A<D?D:A;D=+p[n+16>>3];z=z<D?D:z;D=+p[n+24>>3];y=y<D?D:y;o=o+1|0}while((o|0)!=(h|0));p[G+(I<<3)>>3]=x;p[G+((I|1)<<3)>>3]=A;p[G+((I|2)<<3)>>3]=z;p[G+((I|3)<<3)>>3]=y;I=I+4|0}while((I|0)<=(e|0));H=c}while(0);d:do if((H|0)<(g|0)){E=f[q>>2]|0;if(d)J=H;else{o=H;while(1){p[G+(o<<3)>>3]=+p[E+(o<<3)>>3];o=o+1|0;if((o|0)==(g|0))break d}}do{B=+p[E+(J<<3)>>3];o=1;do{D=+p[(f[q+(o<<2)>>2]|0)+(J<<3)>>3];B=B<D?D:B;o=o+1|0}while((o|0)!=(h|0));p[G+(J<<3)>>3]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((F|0)>1){q=q+4|0;F=F+-1|0;G=G+(a<<3)|0}else break}return}function Hja(a){a=a|0;O5b(a);return}function Ija(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Jja(a){a=a|0;O5b(a);return}function Kja(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>2;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;o=c;p=b;q=e;while(1){a:do if(j)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!k){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<2)|0;x=+n[w>>2];y=+n[w+4>>2];z=+n[w+8>>2];A=+n[w+12>>2];w=t+(v<<2)|0;B=+n[w>>2];n[o+(v<<2)>>2]=x<B?B:x;B=+n[w+4>>2];n[o+((v|1)<<2)>>2]=y<B?B:y;B=+n[w+8>>2];n[o+((v|2)<<2)>>2]=z<B?B:z;B=+n[w+12>>2];n[o+((v|3)<<2)>>2]=A<B?B:A;w=u+(v<<2)|0;B=+n[w>>2];C=v+a|0;n[o+(C<<2)>>2]=x<B?B:x;x=+n[w+4>>2];n[o+(C+1<<2)>>2]=y<x?x:y;y=+n[w+8>>2];n[o+(C+2<<2)>>2]=z<y?y:z;z=+n[w+12>>2];n[o+(C+3<<2)>>2]=A<z?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[p+(h<<2)>>2]|0;u=0;do{C=s+(u<<2)|0;A=+n[C+12>>2];z=+n[C+8>>2];y=+n[C+4>>2];x=+n[C>>2];C=2;do{w=(f[p+(C<<2)>>2]|0)+(u<<2)|0;B=+n[w>>2];x=x<B?B:x;B=+n[w+4>>2];y=y<B?B:y;B=+n[w+8>>2];z=z<B?B:z;B=+n[w+12>>2];A=A<B?B:A;C=C+1|0}while((C|0)!=(h|0));C=t+(u<<2)|0;B=+n[C>>2];n[o+(u<<2)>>2]=x<B?B:x;B=+n[C+4>>2];n[o+((u|1)<<2)>>2]=y<B?B:y;B=+n[C+8>>2];n[o+((u|2)<<2)>>2]=z<B?B:z;B=+n[C+12>>2];n[o+((u|3)<<2)>>2]=A<B?B:A;C=v+(u<<2)|0;B=+n[C>>2];w=u+a|0;n[o+(w<<2)>>2]=x<B?B:x;B=+n[C+4>>2];n[o+(w+1<<2)>>2]=y<B?B:y;B=+n[C+8>>2];n[o+(w+2<<2)>>2]=z<B?B:z;B=+n[C+12>>2];n[o+(w+3<<2)>>2]=A<B?B:A;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!k){t=f[p+8>>2]|0;s=r;while(1){B=+n[u+(s<<2)>>2];D=+n[v+(s<<2)>>2];n[o+(s<<2)>>2]=B<D?D:B;D=+n[t+(s<<2)>>2];n[o+(s+a<<2)>>2]=B<D?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[p+(h<<2)>>2]|0;t=r;do{B=+n[u+(t<<2)>>2];w=2;do{D=+n[(f[p+(w<<2)>>2]|0)+(t<<2)>>2];B=B<D?D:B;w=w+1|0}while((w|0)!=(h|0));A=+n[v+(t<<2)>>2];n[o+(t<<2)>>2]=B<A?A:B;A=+n[s+(t<<2)>>2];n[o+(t+a<<2)>>2]=B<A?A:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=q+-2|0;s=o+(l<<2)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{E=s;F=v;G=t;break}}}else{E=c;F=b;G=e}if((G|0)<=0)return;e=g+-4|0;b=(g|0)<4;c=g&-4;q=F;F=G;G=E;while(1){c:do if(b)H=0;else{E=f[q>>2]|0;if(d)I=0;else{p=0;while(1){o=E+(p<<2)|0;l=f[o+4>>2]|0;r=f[o+8>>2]|0;k=f[o+12>>2]|0;f[G+(p<<2)>>2]=f[o>>2];f[G+((p|1)<<2)>>2]=l;f[G+((p|2)<<2)>>2]=r;f[G+((p|3)<<2)>>2]=k;p=p+4|0;if((p|0)>(e|0)){H=c;break c}}}do{p=E+(I<<2)|0;A=+n[p+12>>2];z=+n[p+8>>2];y=+n[p+4>>2];x=+n[p>>2];p=1;do{k=(f[q+(p<<2)>>2]|0)+(I<<2)|0;D=+n[k>>2];x=x<D?D:x;D=+n[k+4>>2];y=y<D?D:y;D=+n[k+8>>2];z=z<D?D:z;D=+n[k+12>>2];A=A<D?D:A;p=p+1|0}while((p|0)!=(h|0));n[G+(I<<2)>>2]=x;n[G+((I|1)<<2)>>2]=y;n[G+((I|2)<<2)>>2]=z;n[G+((I|3)<<2)>>2]=A;I=I+4|0}while((I|0)<=(e|0));H=c}while(0);d:do if((H|0)<(g|0)){E=f[q>>2]|0;if(d)J=H;else{p=H;while(1){f[G+(p<<2)>>2]=f[E+(p<<2)>>2];p=p+1|0;if((p|0)==(g|0))break d}}do{B=+n[E+(J<<2)>>2];p=1;do{D=+n[(f[q+(p<<2)>>2]|0)+(J<<2)>>2];B=B<D?D:B;p=p+1|0}while((p|0)!=(h|0));n[G+(J<<2)>>2]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((F|0)>1){q=q+4|0;F=F+-1|0;G=G+(a<<2)|0}else break}return}function Lja(a){a=a|0;O5b(a);return}function Mja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Nja(a){a=a|0;O5b(a);return}function Oja(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=b;q=g;while(1){a:do if(k)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!l){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=x<<16>>16<B<<16>>16?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=y<<16>>16<B<<16>>16?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=z<<16>>16<B<<16>>16?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=A<<16>>16<B<<16>>16?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=x<<16>>16<w<<16>>16?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=y<<16>>16<x<<16>>16?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=z<<16>>16<y<<16>>16?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=A<<16>>16<z<<16>>16?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[p+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=d[A+6>>1]|0;C=d[A+4>>1]|0;B=d[A+2>>1]|0;y=d[A>>1]|0;A=2;do{x=(f[p+(A<<2)>>2]|0)+(u<<1)|0;w=d[x>>1]|0;y=y<<16>>16<w<<16>>16?w:y;w=d[x+2>>1]|0;B=B<<16>>16<w<<16>>16?w:B;w=d[x+4>>1]|0;C=C<<16>>16<w<<16>>16?w:C;w=d[x+6>>1]|0;z=z<<16>>16<w<<16>>16?w:z;A=A+1|0}while((A|0)!=(i|0));A=t+(u<<1)|0;w=d[A>>1]|0;d[o+(u<<1)>>1]=y<<16>>16<w<<16>>16?w:y;w=d[A+2>>1]|0;d[o+((u|1)<<1)>>1]=B<<16>>16<w<<16>>16?w:B;w=d[A+4>>1]|0;d[o+((u|2)<<1)>>1]=C<<16>>16<w<<16>>16?w:C;w=d[A+6>>1]|0;d[o+((u|3)<<1)>>1]=z<<16>>16<w<<16>>16?w:z;w=v+(u<<1)|0;A=d[w>>1]|0;x=u+a|0;d[o+(x<<1)>>1]=y<<16>>16<A<<16>>16?A:y;A=d[w+2>>1]|0;d[o+(x+1<<1)>>1]=B<<16>>16<A<<16>>16?A:B;A=d[w+4>>1]|0;d[o+(x+2<<1)>>1]=C<<16>>16<A<<16>>16?A:C;A=d[w+6>>1]|0;d[o+(x+3<<1)>>1]=z<<16>>16<A<<16>>16?A:z;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!l){t=f[p+8>>2]|0;s=r;while(1){A=d[u+(s<<1)>>1]|0;x=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=A<<16>>16<x<<16>>16?x:A;x=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=A<<16>>16<x<<16>>16?x:A;s=s+1|0;if((s|0)==(h|0))break b}}s=f[p+(i<<2)>>2]|0;t=r;do{A=d[u+(t<<1)>>1]|0;x=2;do{w=d[(f[p+(x<<2)>>2]|0)+(t<<1)>>1]|0;A=A<<16>>16<w<<16>>16?w:A;x=x+1|0}while((x|0)!=(i|0));x=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=A<<16>>16<x<<16>>16?x:A;x=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=A<<16>>16<x<<16>>16?x:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=q+-2|0;s=o+(m<<1)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{D=s;E=v;F=t;break}}}else{D=c;E=b;F=g}if((F|0)<=0)return;g=h+-4|0;b=(h|0)<4;c=h&-4;q=E;E=F;F=D;while(1){c:do if(b)G=0;else{D=f[q>>2]|0;if(e)H=0;else{p=0;while(1){o=D+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[F+(p<<1)>>1]=d[o>>1]|0;d[F+((p|1)<<1)>>1]=m;d[F+((p|2)<<1)>>1]=r;d[F+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(g|0)){G=c;break c}}}do{p=D+(H<<1)|0;l=d[p+6>>1]|0;r=d[p+4>>1]|0;m=d[p+2>>1]|0;o=d[p>>1]|0;p=1;do{n=(f[q+(p<<2)>>2]|0)+(H<<1)|0;j=d[n>>1]|0;o=o<<16>>16<j<<16>>16?j:o;j=d[n+2>>1]|0;m=m<<16>>16<j<<16>>16?j:m;j=d[n+4>>1]|0;r=r<<16>>16<j<<16>>16?j:r;j=d[n+6>>1]|0;l=l<<16>>16<j<<16>>16?j:l;p=p+1|0}while((p|0)!=(i|0));d[F+(H<<1)>>1]=o;d[F+((H|1)<<1)>>1]=m;d[F+((H|2)<<1)>>1]=r;d[F+((H|3)<<1)>>1]=l;H=H+4|0}while((H|0)<=(g|0));G=c}while(0);d:do if((G|0)<(h|0)){D=f[q>>2]|0;if(e)I=G;else{p=G;while(1){d[F+(p<<1)>>1]=d[D+(p<<1)>>1]|0;p=p+1|0;if((p|0)==(h|0))break d}}do{p=d[D+(I<<1)>>1]|0;A=1;do{j=d[(f[q+(A<<2)>>2]|0)+(I<<1)>>1]|0;p=p<<16>>16<j<<16>>16?j:p;A=A+1|0}while((A|0)!=(i|0));d[F+(I<<1)>>1]=p;I=I+1|0}while((I|0)!=(h|0))}while(0);if((E|0)>1){q=q+4|0;E=E+-1|0;F=F+(a<<1)|0}else break}return}function Pja(a){a=a|0;O5b(a);return}function Qja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Rja(a){a=a|0;O5b(a);return}function Sja(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=b;q=g;while(1){a:do if(k)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!l){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=(x&65535)<(B&65535)?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=(y&65535)<(B&65535)?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=(z&65535)<(B&65535)?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=(A&65535)<(B&65535)?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=(x&65535)<(w&65535)?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=(y&65535)<(x&65535)?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=(z&65535)<(y&65535)?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=(A&65535)<(z&65535)?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[p+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=d[A+6>>1]|0;C=d[A+4>>1]|0;B=d[A+2>>1]|0;y=d[A>>1]|0;A=2;do{x=(f[p+(A<<2)>>2]|0)+(u<<1)|0;w=d[x>>1]|0;y=(y&65535)<(w&65535)?w:y;w=d[x+2>>1]|0;B=(B&65535)<(w&65535)?w:B;w=d[x+4>>1]|0;C=(C&65535)<(w&65535)?w:C;w=d[x+6>>1]|0;z=(z&65535)<(w&65535)?w:z;A=A+1|0}while((A|0)!=(i|0));A=t+(u<<1)|0;w=d[A>>1]|0;d[o+(u<<1)>>1]=(y&65535)<(w&65535)?w:y;w=d[A+2>>1]|0;d[o+((u|1)<<1)>>1]=(B&65535)<(w&65535)?w:B;w=d[A+4>>1]|0;d[o+((u|2)<<1)>>1]=(C&65535)<(w&65535)?w:C;w=d[A+6>>1]|0;d[o+((u|3)<<1)>>1]=(z&65535)<(w&65535)?w:z;w=v+(u<<1)|0;A=d[w>>1]|0;x=u+a|0;d[o+(x<<1)>>1]=(y&65535)<(A&65535)?A:y;A=d[w+2>>1]|0;d[o+(x+1<<1)>>1]=(B&65535)<(A&65535)?A:B;A=d[w+4>>1]|0;d[o+(x+2<<1)>>1]=(C&65535)<(A&65535)?A:C;A=d[w+6>>1]|0;d[o+(x+3<<1)>>1]=(z&65535)<(A&65535)?A:z;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!l){t=f[p+8>>2]|0;s=r;while(1){A=d[u+(s<<1)>>1]|0;x=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=(A&65535)<(x&65535)?x:A;x=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=(A&65535)<(x&65535)?x:A;s=s+1|0;if((s|0)==(h|0))break b}}s=f[p+(i<<2)>>2]|0;t=r;do{A=d[u+(t<<1)>>1]|0;x=2;do{w=d[(f[p+(x<<2)>>2]|0)+(t<<1)>>1]|0;A=(A&65535)<(w&65535)?w:A;x=x+1|0}while((x|0)!=(i|0));x=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=(A&65535)<(x&65535)?x:A;x=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=(A&65535)<(x&65535)?x:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=q+-2|0;s=o+(m<<1)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{D=s;E=v;F=t;break}}}else{D=c;E=b;F=g}if((F|0)<=0)return;g=h+-4|0;b=(h|0)<4;c=h&-4;q=E;E=F;F=D;while(1){c:do if(b)G=0;else{D=f[q>>2]|0;if(e)H=0;else{p=0;while(1){o=D+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[F+(p<<1)>>1]=d[o>>1]|0;d[F+((p|1)<<1)>>1]=m;d[F+((p|2)<<1)>>1]=r;d[F+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(g|0)){G=c;break c}}}do{p=D+(H<<1)|0;l=d[p+6>>1]|0;r=d[p+4>>1]|0;m=d[p+2>>1]|0;o=d[p>>1]|0;p=1;do{n=(f[q+(p<<2)>>2]|0)+(H<<1)|0;j=d[n>>1]|0;o=(o&65535)<(j&65535)?j:o;j=d[n+2>>1]|0;m=(m&65535)<(j&65535)?j:m;j=d[n+4>>1]|0;r=(r&65535)<(j&65535)?j:r;j=d[n+6>>1]|0;l=(l&65535)<(j&65535)?j:l;p=p+1|0}while((p|0)!=(i|0));d[F+(H<<1)>>1]=o;d[F+((H|1)<<1)>>1]=m;d[F+((H|2)<<1)>>1]=r;d[F+((H|3)<<1)>>1]=l;H=H+4|0}while((H|0)<=(g|0));G=c}while(0);d:do if((G|0)<(h|0)){D=f[q>>2]|0;if(e)I=G;else{p=G;while(1){d[F+(p<<1)>>1]=d[D+(p<<1)>>1]|0;p=p+1|0;if((p|0)==(h|0))break d}}do{p=d[D+(I<<1)>>1]|0;A=1;do{j=d[(f[q+(A<<2)>>2]|0)+(I<<1)>>1]|0;p=(p&65535)<(j&65535)?j:p;A=A+1|0}while((A|0)!=(i|0));d[F+(I<<1)>>1]=p;I=I+1|0}while((I|0)!=(h|0))}while(0);if((E|0)>1){q=q+4|0;E=E+-1|0;F=F+(a<<1)|0}else break}return}function Tja(a){a=a|0;O5b(a);return}function Uja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Vja(a){a=a|0;O5b(a);return}function Wja(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;j=f[a+4>>2]|0;a=(j|0)>1;if(a&(g|0)>1){k=i+-4|0;l=(i|0)<4;m=(j|0)>2;n=e<<1;o=i&-4;p=d;q=c;r=g;while(1){if(l)s=0;else{t=q+4|0;u=0;do{v=(f[t>>2]|0)+u|0;w=b[v>>0]|0;x=b[v+1>>0]|0;y=b[v+2>>0]|0;z=b[v+3>>0]|0;if(m){v=z;A=y;B=x;C=w;D=2;while(1){E=(f[q+(D<<2)>>2]|0)+u|0;F=C&255;G=(h[E>>0]|0)-F+256|0;if(G>>>0<769)H=h[259297+G>>0]|0;else H=0;G=H+F&255;F=B&255;I=(h[E+1>>0]|0)-F+256|0;if(I>>>0<769)J=h[259297+I>>0]|0;else J=0;I=J+F&255;F=A&255;K=(h[E+2>>0]|0)-F+256|0;if(K>>>0<769)L=h[259297+K>>0]|0;else L=0;K=L+F&255;F=v&255;M=(h[E+3>>0]|0)-F+256|0;if(M>>>0<769)N=h[259297+M>>0]|0;else N=0;M=N+F&255;D=D+1|0;if((D|0)==(j|0)){O=M;P=K;Q=I;R=G;S=j;break}else{v=M;A=K;B=I;C=G}}}else{O=z;P=y;Q=x;R=w;S=2}C=(f[q>>2]|0)+u|0;B=R&255;A=(h[C>>0]|0)-B+256|0;if(A>>>0<769)T=h[259297+A>>0]|0;else T=0;b[p+u>>0]=T+B;A=Q&255;v=(h[C+1>>0]|0)-A+256|0;if(v>>>0<769)U=h[259297+v>>0]|0;else U=0;b[p+(u|1)>>0]=U+A;v=P&255;D=(h[C+2>>0]|0)-v+256|0;if(D>>>0<769)V=h[259297+D>>0]|0;else V=0;b[p+(u|2)>>0]=V+v;D=O&255;G=(h[C+3>>0]|0)-D+256|0;if(G>>>0<769)W=h[259297+G>>0]|0;else W=0;b[p+(u|3)>>0]=W+D;G=(f[q+(S<<2)>>2]|0)+u|0;C=(h[G>>0]|0)-B+256|0;if(C>>>0<769)X=h[259297+C>>0]|0;else X=0;C=u+e|0;b[p+C>>0]=X+B;B=(h[G+1>>0]|0)-A+256|0;if(B>>>0<769)Y=h[259297+B>>0]|0;else Y=0;b[p+(C+1)>>0]=Y+A;A=(h[G+2>>0]|0)-v+256|0;if(A>>>0<769)Z=h[259297+A>>0]|0;else Z=0;b[p+(C+2)>>0]=Z+v;v=(h[G+3>>0]|0)-D+256|0;if(v>>>0<769)_=h[259297+v>>0]|0;else _=0;b[p+(C+3)>>0]=_+D;u=u+4|0}while((u|0)<=(k|0));s=o}a:do if((s|0)<(i|0)){u=q+4|0;if(!m){t=q+8|0;D=s;while(1){C=h[(f[u>>2]|0)+D>>0]|0;v=(h[(f[q>>2]|0)+D>>0]|0)-C+256|0;if(v>>>0<769)$=h[259297+v>>0]|0;else $=0;b[p+D>>0]=$+C;v=(h[(f[t>>2]|0)+D>>0]|0)-C+256|0;if(v>>>0<769)aa=h[259297+v>>0]|0;else aa=0;b[p+(D+e)>>0]=aa+C;D=D+1|0;if((D|0)==(i|0))break a}}D=q+(j<<2)|0;t=s;do{w=b[(f[u>>2]|0)+t>>0]|0;x=2;while(1){y=w&255;z=(h[(f[q+(x<<2)>>2]|0)+t>>0]|0)-y+256|0;if(z>>>0<769)ba=h[259297+z>>0]|0;else ba=0;ca=ba+y|0;x=x+1|0;if((x|0)==(j|0))break;else w=ca&255}w=ca&255;x=(h[(f[q>>2]|0)+t>>0]|0)-w+256|0;if(x>>>0<769)da=h[259297+x>>0]|0;else da=0;b[p+t>>0]=da+ca;x=(h[(f[D>>2]|0)+t>>0]|0)-w+256|0;if(x>>>0<769)ea=h[259297+x>>0]|0;else ea=0;b[p+(t+e)>>0]=ea+ca;t=t+1|0}while((t|0)!=(i|0))}while(0);t=r+-2|0;D=p+n|0;u=q+8|0;if((t|0)>1){p=D;q=u;r=t}else{fa=D;ga=u;ha=t;break}}}else{fa=d;ga=c;ha=g}if((ha|0)<=0)return;g=i+-4|0;c=(i|0)<4;d=i&-4;r=ga;ga=ha;ha=fa;while(1){b:do if(c)ia=0;else{if(a)ja=0;else{fa=0;while(1){q=(f[r>>2]|0)+fa|0;p=b[q+1>>0]|0;n=b[q+2>>0]|0;ca=b[q+3>>0]|0;b[ha+fa>>0]=b[q>>0]|0;b[ha+(fa|1)>>0]=p;b[ha+(fa|2)>>0]=n;b[ha+(fa|3)>>0]=ca;fa=fa+4|0;if((fa|0)>(g|0)){ia=d;break b}}}do{fa=(f[r>>2]|0)+ja|0;ca=b[fa+3>>0]|0;n=b[fa+2>>0]|0;p=b[fa+1>>0]|0;q=b[fa>>0]|0;fa=1;do{ea=(f[r+(fa<<2)>>2]|0)+ja|0;da=q&255;ba=(h[ea>>0]|0)-da+256|0;if(ba>>>0<769)ka=h[259297+ba>>0]|0;else ka=0;q=ka+da&255;da=p&255;ba=(h[ea+1>>0]|0)-da+256|0;if(ba>>>0<769)la=h[259297+ba>>0]|0;else la=0;p=la+da&255;da=n&255;ba=(h[ea+2>>0]|0)-da+256|0;if(ba>>>0<769)ma=h[259297+ba>>0]|0;else ma=0;n=ma+da&255;da=ca&255;ba=(h[ea+3>>0]|0)-da+256|0;if(ba>>>0<769)na=h[259297+ba>>0]|0;else na=0;ca=na+da&255;fa=fa+1|0}while((fa|0)!=(j|0));b[ha+ja>>0]=q;b[ha+(ja|1)>>0]=p;b[ha+(ja|2)>>0]=n;b[ha+(ja|3)>>0]=ca;ja=ja+4|0}while((ja|0)<=(g|0));ia=d}while(0);c:do if((ia|0)<(i|0)){if(a)oa=ia;else{fa=ia;while(1){b[ha+fa>>0]=b[(f[r>>2]|0)+fa>>0]|0;fa=fa+1|0;if((fa|0)==(i|0))break c}}do{fa=b[(f[r>>2]|0)+oa>>0]|0;da=1;do{ba=fa&255;ea=(h[(f[r+(da<<2)>>2]|0)+oa>>0]|0)-ba+256|0;if(ea>>>0<769)pa=h[259297+ea>>0]|0;else pa=0;fa=pa+ba&255;da=da+1|0}while((da|0)!=(j|0));b[ha+oa>>0]=fa;oa=oa+1|0}while((oa|0)!=(i|0))}while(0);if((ga|0)>1){r=r+4|0;ga=ga+-1|0;ha=ha+e|0}else break}return}function Xja(a){a=a|0;O5b(a);return}function Yja(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Zja(a){a=a|0;O5b(a);return}function _ja(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>3;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;n=c;o=b;q=e;while(1){a:do if(j)r=0;else{s=f[o+4>>2]|0;t=f[o>>2]|0;if(!k){u=f[o+8>>2]|0;v=0;while(1){w=s+(v<<3)|0;x=+p[w>>3];y=+p[w+8>>3];z=+p[w+16>>3];A=+p[w+24>>3];w=t+(v<<3)|0;B=+p[w>>3];p[n+(v<<3)>>3]=B<x?B:x;B=+p[w+8>>3];p[n+((v|1)<<3)>>3]=B<y?B:y;B=+p[w+16>>3];p[n+((v|2)<<3)>>3]=B<z?B:z;B=+p[w+24>>3];p[n+((v|3)<<3)>>3]=B<A?B:A;w=u+(v<<3)|0;B=+p[w>>3];C=v+a|0;p[n+(C<<3)>>3]=B<x?B:x;x=+p[w+8>>3];p[n+(C+1<<3)>>3]=x<y?x:y;y=+p[w+16>>3];p[n+(C+2<<3)>>3]=y<z?y:z;z=+p[w+24>>3];p[n+(C+3<<3)>>3]=z<A?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[o+(h<<2)>>2]|0;u=0;do{C=s+(u<<3)|0;A=+p[C+24>>3];z=+p[C+16>>3];y=+p[C+8>>3];x=+p[C>>3];C=2;do{w=(f[o+(C<<2)>>2]|0)+(u<<3)|0;B=+p[w>>3];x=B<x?B:x;B=+p[w+8>>3];y=B<y?B:y;B=+p[w+16>>3];z=B<z?B:z;B=+p[w+24>>3];A=B<A?B:A;C=C+1|0}while((C|0)!=(h|0));C=t+(u<<3)|0;B=+p[C>>3];p[n+(u<<3)>>3]=B<x?B:x;B=+p[C+8>>3];p[n+((u|1)<<3)>>3]=B<y?B:y;B=+p[C+16>>3];p[n+((u|2)<<3)>>3]=B<z?B:z;B=+p[C+24>>3];p[n+((u|3)<<3)>>3]=B<A?B:A;C=v+(u<<3)|0;B=+p[C>>3];w=u+a|0;p[n+(w<<3)>>3]=B<x?B:x;B=+p[C+8>>3];p[n+(w+1<<3)>>3]=B<y?B:y;B=+p[C+16>>3];p[n+(w+2<<3)>>3]=B<z?B:z;B=+p[C+24>>3];p[n+(w+3<<3)>>3]=B<A?B:A;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[o+4>>2]|0;v=f[o>>2]|0;if(!k){t=f[o+8>>2]|0;s=r;while(1){B=+p[u+(s<<3)>>3];D=+p[v+(s<<3)>>3];p[n+(s<<3)>>3]=D<B?D:B;D=+p[t+(s<<3)>>3];p[n+(s+a<<3)>>3]=D<B?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[o+(h<<2)>>2]|0;t=r;do{B=+p[u+(t<<3)>>3];w=2;do{D=+p[(f[o+(w<<2)>>2]|0)+(t<<3)>>3];B=D<B?D:B;w=w+1|0}while((w|0)!=(h|0));A=+p[v+(t<<3)>>3];p[n+(t<<3)>>3]=A<B?A:B;A=+p[s+(t<<3)>>3];p[n+(t+a<<3)>>3]=A<B?A:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=q+-2|0;s=n+(l<<3)|0;v=o+8|0;if((t|0)>1){n=s;o=v;q=t}else{E=s;F=v;G=t;break}}}else{E=c;F=b;G=e}if((G|0)<=0)return;e=g+-4|0;b=(g|0)<4;c=g&-4;q=F;F=G;G=E;while(1){c:do if(b)H=0;else{E=f[q>>2]|0;if(d)I=0;else{o=0;while(1){n=E+(o<<3)|0;A=+p[n+8>>3];z=+p[n+16>>3];y=+p[n+24>>3];p[G+(o<<3)>>3]=+p[n>>3];p[G+((o|1)<<3)>>3]=A;p[G+((o|2)<<3)>>3]=z;p[G+((o|3)<<3)>>3]=y;o=o+4|0;if((o|0)>(e|0)){H=c;break c}}}do{o=E+(I<<3)|0;y=+p[o+24>>3];z=+p[o+16>>3];A=+p[o+8>>3];x=+p[o>>3];o=1;do{n=(f[q+(o<<2)>>2]|0)+(I<<3)|0;D=+p[n>>3];x=D<x?D:x;D=+p[n+8>>3];A=D<A?D:A;D=+p[n+16>>3];z=D<z?D:z;D=+p[n+24>>3];y=D<y?D:y;o=o+1|0}while((o|0)!=(h|0));p[G+(I<<3)>>3]=x;p[G+((I|1)<<3)>>3]=A;p[G+((I|2)<<3)>>3]=z;p[G+((I|3)<<3)>>3]=y;I=I+4|0}while((I|0)<=(e|0));H=c}while(0);d:do if((H|0)<(g|0)){E=f[q>>2]|0;if(d)J=H;else{o=H;while(1){p[G+(o<<3)>>3]=+p[E+(o<<3)>>3];o=o+1|0;if((o|0)==(g|0))break d}}do{B=+p[E+(J<<3)>>3];o=1;do{D=+p[(f[q+(o<<2)>>2]|0)+(J<<3)>>3];B=D<B?D:B;o=o+1|0}while((o|0)!=(h|0));p[G+(J<<3)>>3]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((F|0)>1){q=q+4|0;F=F+-1|0;G=G+(a<<3)|0}else break}return}function $ja(a){a=a|0;O5b(a);return}function aka(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function bka(a){a=a|0;O5b(a);return}function cka(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;h=f[a+4>>2]|0;a=d>>>2;d=(h|0)>1;if(d&(e|0)>1){i=g+-4|0;j=(g|0)<4;k=(h|0)>2;l=a<<1;m=g&-4;o=c;p=b;q=e;while(1){a:do if(j)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!k){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<2)|0;x=+n[w>>2];y=+n[w+4>>2];z=+n[w+8>>2];A=+n[w+12>>2];w=t+(v<<2)|0;B=+n[w>>2];n[o+(v<<2)>>2]=B<x?B:x;B=+n[w+4>>2];n[o+((v|1)<<2)>>2]=B<y?B:y;B=+n[w+8>>2];n[o+((v|2)<<2)>>2]=B<z?B:z;B=+n[w+12>>2];n[o+((v|3)<<2)>>2]=B<A?B:A;w=u+(v<<2)|0;B=+n[w>>2];C=v+a|0;n[o+(C<<2)>>2]=B<x?B:x;x=+n[w+4>>2];n[o+(C+1<<2)>>2]=x<y?x:y;y=+n[w+8>>2];n[o+(C+2<<2)>>2]=y<z?y:z;z=+n[w+12>>2];n[o+(C+3<<2)>>2]=z<A?z:A;v=v+4|0;if((v|0)>(i|0)){r=m;break a}}}v=f[p+(h<<2)>>2]|0;u=0;do{C=s+(u<<2)|0;A=+n[C+12>>2];z=+n[C+8>>2];y=+n[C+4>>2];x=+n[C>>2];C=2;do{w=(f[p+(C<<2)>>2]|0)+(u<<2)|0;B=+n[w>>2];x=B<x?B:x;B=+n[w+4>>2];y=B<y?B:y;B=+n[w+8>>2];z=B<z?B:z;B=+n[w+12>>2];A=B<A?B:A;C=C+1|0}while((C|0)!=(h|0));C=t+(u<<2)|0;B=+n[C>>2];n[o+(u<<2)>>2]=B<x?B:x;B=+n[C+4>>2];n[o+((u|1)<<2)>>2]=B<y?B:y;B=+n[C+8>>2];n[o+((u|2)<<2)>>2]=B<z?B:z;B=+n[C+12>>2];n[o+((u|3)<<2)>>2]=B<A?B:A;C=v+(u<<2)|0;B=+n[C>>2];w=u+a|0;n[o+(w<<2)>>2]=B<x?B:x;B=+n[C+4>>2];n[o+(w+1<<2)>>2]=B<y?B:y;B=+n[C+8>>2];n[o+(w+2<<2)>>2]=B<z?B:z;B=+n[C+12>>2];n[o+(w+3<<2)>>2]=B<A?B:A;u=u+4|0}while((u|0)<=(i|0));r=m}while(0);b:do if((r|0)<(g|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!k){t=f[p+8>>2]|0;s=r;while(1){B=+n[u+(s<<2)>>2];D=+n[v+(s<<2)>>2];n[o+(s<<2)>>2]=D<B?D:B;D=+n[t+(s<<2)>>2];n[o+(s+a<<2)>>2]=D<B?D:B;s=s+1|0;if((s|0)==(g|0))break b}}s=f[p+(h<<2)>>2]|0;t=r;do{B=+n[u+(t<<2)>>2];w=2;do{D=+n[(f[p+(w<<2)>>2]|0)+(t<<2)>>2];B=D<B?D:B;w=w+1|0}while((w|0)!=(h|0));A=+n[v+(t<<2)>>2];n[o+(t<<2)>>2]=A<B?A:B;A=+n[s+(t<<2)>>2];n[o+(t+a<<2)>>2]=A<B?A:B;t=t+1|0}while((t|0)!=(g|0))}while(0);t=q+-2|0;s=o+(l<<2)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{E=s;F=v;G=t;break}}}else{E=c;F=b;G=e}if((G|0)<=0)return;e=g+-4|0;b=(g|0)<4;c=g&-4;q=F;F=G;G=E;while(1){c:do if(b)H=0;else{E=f[q>>2]|0;if(d)I=0;else{p=0;while(1){o=E+(p<<2)|0;l=f[o+4>>2]|0;r=f[o+8>>2]|0;k=f[o+12>>2]|0;f[G+(p<<2)>>2]=f[o>>2];f[G+((p|1)<<2)>>2]=l;f[G+((p|2)<<2)>>2]=r;f[G+((p|3)<<2)>>2]=k;p=p+4|0;if((p|0)>(e|0)){H=c;break c}}}do{p=E+(I<<2)|0;A=+n[p+12>>2];z=+n[p+8>>2];y=+n[p+4>>2];x=+n[p>>2];p=1;do{k=(f[q+(p<<2)>>2]|0)+(I<<2)|0;D=+n[k>>2];x=D<x?D:x;D=+n[k+4>>2];y=D<y?D:y;D=+n[k+8>>2];z=D<z?D:z;D=+n[k+12>>2];A=D<A?D:A;p=p+1|0}while((p|0)!=(h|0));n[G+(I<<2)>>2]=x;n[G+((I|1)<<2)>>2]=y;n[G+((I|2)<<2)>>2]=z;n[G+((I|3)<<2)>>2]=A;I=I+4|0}while((I|0)<=(e|0));H=c}while(0);d:do if((H|0)<(g|0)){E=f[q>>2]|0;if(d)J=H;else{p=H;while(1){f[G+(p<<2)>>2]=f[E+(p<<2)>>2];p=p+1|0;if((p|0)==(g|0))break d}}do{B=+n[E+(J<<2)>>2];p=1;do{D=+n[(f[q+(p<<2)>>2]|0)+(J<<2)>>2];B=D<B?D:B;p=p+1|0}while((p|0)!=(h|0));n[G+(J<<2)>>2]=B;J=J+1|0}while((J|0)!=(g|0))}while(0);if((F|0)>1){q=q+4|0;F=F+-1|0;G=G+(a<<2)|0}else break}return}function dka(a){a=a|0;O5b(a);return}function eka(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fka(a){a=a|0;O5b(a);return}function gka(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=b;q=g;while(1){a:do if(k)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!l){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=B<<16>>16<x<<16>>16?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=B<<16>>16<y<<16>>16?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=B<<16>>16<z<<16>>16?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=B<<16>>16<A<<16>>16?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=w<<16>>16<x<<16>>16?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=x<<16>>16<y<<16>>16?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=y<<16>>16<z<<16>>16?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=z<<16>>16<A<<16>>16?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[p+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=d[A+6>>1]|0;C=d[A+4>>1]|0;B=d[A+2>>1]|0;y=d[A>>1]|0;A=2;do{x=(f[p+(A<<2)>>2]|0)+(u<<1)|0;w=d[x>>1]|0;y=w<<16>>16<y<<16>>16?w:y;w=d[x+2>>1]|0;B=w<<16>>16<B<<16>>16?w:B;w=d[x+4>>1]|0;C=w<<16>>16<C<<16>>16?w:C;w=d[x+6>>1]|0;z=w<<16>>16<z<<16>>16?w:z;A=A+1|0}while((A|0)!=(i|0));A=t+(u<<1)|0;w=d[A>>1]|0;d[o+(u<<1)>>1]=w<<16>>16<y<<16>>16?w:y;w=d[A+2>>1]|0;d[o+((u|1)<<1)>>1]=w<<16>>16<B<<16>>16?w:B;w=d[A+4>>1]|0;d[o+((u|2)<<1)>>1]=w<<16>>16<C<<16>>16?w:C;w=d[A+6>>1]|0;d[o+((u|3)<<1)>>1]=w<<16>>16<z<<16>>16?w:z;w=v+(u<<1)|0;A=d[w>>1]|0;x=u+a|0;d[o+(x<<1)>>1]=A<<16>>16<y<<16>>16?A:y;A=d[w+2>>1]|0;d[o+(x+1<<1)>>1]=A<<16>>16<B<<16>>16?A:B;A=d[w+4>>1]|0;d[o+(x+2<<1)>>1]=A<<16>>16<C<<16>>16?A:C;A=d[w+6>>1]|0;d[o+(x+3<<1)>>1]=A<<16>>16<z<<16>>16?A:z;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!l){t=f[p+8>>2]|0;s=r;while(1){A=d[u+(s<<1)>>1]|0;x=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=x<<16>>16<A<<16>>16?x:A;x=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=x<<16>>16<A<<16>>16?x:A;s=s+1|0;if((s|0)==(h|0))break b}}s=f[p+(i<<2)>>2]|0;t=r;do{A=d[u+(t<<1)>>1]|0;x=2;do{w=d[(f[p+(x<<2)>>2]|0)+(t<<1)>>1]|0;A=w<<16>>16<A<<16>>16?w:A;x=x+1|0}while((x|0)!=(i|0));x=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=x<<16>>16<A<<16>>16?x:A;x=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=x<<16>>16<A<<16>>16?x:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=q+-2|0;s=o+(m<<1)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{D=s;E=v;F=t;break}}}else{D=c;E=b;F=g}if((F|0)<=0)return;g=h+-4|0;b=(h|0)<4;c=h&-4;q=E;E=F;F=D;while(1){c:do if(b)G=0;else{D=f[q>>2]|0;if(e)H=0;else{p=0;while(1){o=D+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[F+(p<<1)>>1]=d[o>>1]|0;d[F+((p|1)<<1)>>1]=m;d[F+((p|2)<<1)>>1]=r;d[F+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(g|0)){G=c;break c}}}do{p=D+(H<<1)|0;l=d[p+6>>1]|0;r=d[p+4>>1]|0;m=d[p+2>>1]|0;o=d[p>>1]|0;p=1;do{n=(f[q+(p<<2)>>2]|0)+(H<<1)|0;j=d[n>>1]|0;o=j<<16>>16<o<<16>>16?j:o;j=d[n+2>>1]|0;m=j<<16>>16<m<<16>>16?j:m;j=d[n+4>>1]|0;r=j<<16>>16<r<<16>>16?j:r;j=d[n+6>>1]|0;l=j<<16>>16<l<<16>>16?j:l;p=p+1|0}while((p|0)!=(i|0));d[F+(H<<1)>>1]=o;d[F+((H|1)<<1)>>1]=m;d[F+((H|2)<<1)>>1]=r;d[F+((H|3)<<1)>>1]=l;H=H+4|0}while((H|0)<=(g|0));G=c}while(0);d:do if((G|0)<(h|0)){D=f[q>>2]|0;if(e)I=G;else{p=G;while(1){d[F+(p<<1)>>1]=d[D+(p<<1)>>1]|0;p=p+1|0;if((p|0)==(h|0))break d}}do{p=d[D+(I<<1)>>1]|0;A=1;do{j=d[(f[q+(A<<2)>>2]|0)+(I<<1)>>1]|0;p=j<<16>>16<p<<16>>16?j:p;A=A+1|0}while((A|0)!=(i|0));d[F+(I<<1)>>1]=p;I=I+1|0}while((I|0)!=(h|0))}while(0);if((E|0)>1){q=q+4|0;E=E+-1|0;F=F+(a<<1)|0}else break}return}function hka(a){a=a|0;O5b(a);return}function ika(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function jka(a){a=a|0;O5b(a);return}function kka(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=e>>>1;e=(i|0)>1;if(e&(g|0)>1){j=h+-4|0;k=(h|0)<4;l=(i|0)>2;m=a<<1;n=h&-4;o=c;p=b;q=g;while(1){a:do if(k)r=0;else{s=f[p+4>>2]|0;t=f[p>>2]|0;if(!l){u=f[p+8>>2]|0;v=0;while(1){w=s+(v<<1)|0;x=d[w>>1]|0;y=d[w+2>>1]|0;z=d[w+4>>1]|0;A=d[w+6>>1]|0;w=t+(v<<1)|0;B=d[w>>1]|0;d[o+(v<<1)>>1]=(B&65535)<(x&65535)?B:x;B=d[w+2>>1]|0;d[o+((v|1)<<1)>>1]=(B&65535)<(y&65535)?B:y;B=d[w+4>>1]|0;d[o+((v|2)<<1)>>1]=(B&65535)<(z&65535)?B:z;B=d[w+6>>1]|0;d[o+((v|3)<<1)>>1]=(B&65535)<(A&65535)?B:A;B=u+(v<<1)|0;w=d[B>>1]|0;C=v+a|0;d[o+(C<<1)>>1]=(w&65535)<(x&65535)?w:x;x=d[B+2>>1]|0;d[o+(C+1<<1)>>1]=(x&65535)<(y&65535)?x:y;y=d[B+4>>1]|0;d[o+(C+2<<1)>>1]=(y&65535)<(z&65535)?y:z;z=d[B+6>>1]|0;d[o+(C+3<<1)>>1]=(z&65535)<(A&65535)?z:A;v=v+4|0;if((v|0)>(j|0)){r=n;break a}}}v=f[p+(i<<2)>>2]|0;u=0;do{A=s+(u<<1)|0;z=d[A+6>>1]|0;C=d[A+4>>1]|0;B=d[A+2>>1]|0;y=d[A>>1]|0;A=2;do{x=(f[p+(A<<2)>>2]|0)+(u<<1)|0;w=d[x>>1]|0;y=(w&65535)<(y&65535)?w:y;w=d[x+2>>1]|0;B=(w&65535)<(B&65535)?w:B;w=d[x+4>>1]|0;C=(w&65535)<(C&65535)?w:C;w=d[x+6>>1]|0;z=(w&65535)<(z&65535)?w:z;A=A+1|0}while((A|0)!=(i|0));A=t+(u<<1)|0;w=d[A>>1]|0;d[o+(u<<1)>>1]=(w&65535)<(y&65535)?w:y;w=d[A+2>>1]|0;d[o+((u|1)<<1)>>1]=(w&65535)<(B&65535)?w:B;w=d[A+4>>1]|0;d[o+((u|2)<<1)>>1]=(w&65535)<(C&65535)?w:C;w=d[A+6>>1]|0;d[o+((u|3)<<1)>>1]=(w&65535)<(z&65535)?w:z;w=v+(u<<1)|0;A=d[w>>1]|0;x=u+a|0;d[o+(x<<1)>>1]=(A&65535)<(y&65535)?A:y;A=d[w+2>>1]|0;d[o+(x+1<<1)>>1]=(A&65535)<(B&65535)?A:B;A=d[w+4>>1]|0;d[o+(x+2<<1)>>1]=(A&65535)<(C&65535)?A:C;A=d[w+6>>1]|0;d[o+(x+3<<1)>>1]=(A&65535)<(z&65535)?A:z;u=u+4|0}while((u|0)<=(j|0));r=n}while(0);b:do if((r|0)<(h|0)){u=f[p+4>>2]|0;v=f[p>>2]|0;if(!l){t=f[p+8>>2]|0;s=r;while(1){A=d[u+(s<<1)>>1]|0;x=d[v+(s<<1)>>1]|0;d[o+(s<<1)>>1]=(x&65535)<(A&65535)?x:A;x=d[t+(s<<1)>>1]|0;d[o+(s+a<<1)>>1]=(x&65535)<(A&65535)?x:A;s=s+1|0;if((s|0)==(h|0))break b}}s=f[p+(i<<2)>>2]|0;t=r;do{A=d[u+(t<<1)>>1]|0;x=2;do{w=d[(f[p+(x<<2)>>2]|0)+(t<<1)>>1]|0;A=(w&65535)<(A&65535)?w:A;x=x+1|0}while((x|0)!=(i|0));x=d[v+(t<<1)>>1]|0;d[o+(t<<1)>>1]=(x&65535)<(A&65535)?x:A;x=d[s+(t<<1)>>1]|0;d[o+(t+a<<1)>>1]=(x&65535)<(A&65535)?x:A;t=t+1|0}while((t|0)!=(h|0))}while(0);t=q+-2|0;s=o+(m<<1)|0;v=p+8|0;if((t|0)>1){o=s;p=v;q=t}else{D=s;E=v;F=t;break}}}else{D=c;E=b;F=g}if((F|0)<=0)return;g=h+-4|0;b=(h|0)<4;c=h&-4;q=E;E=F;F=D;while(1){c:do if(b)G=0;else{D=f[q>>2]|0;if(e)H=0;else{p=0;while(1){o=D+(p<<1)|0;m=d[o+2>>1]|0;r=d[o+4>>1]|0;l=d[o+6>>1]|0;d[F+(p<<1)>>1]=d[o>>1]|0;d[F+((p|1)<<1)>>1]=m;d[F+((p|2)<<1)>>1]=r;d[F+((p|3)<<1)>>1]=l;p=p+4|0;if((p|0)>(g|0)){G=c;break c}}}do{p=D+(H<<1)|0;l=d[p+6>>1]|0;r=d[p+4>>1]|0;m=d[p+2>>1]|0;o=d[p>>1]|0;p=1;do{n=(f[q+(p<<2)>>2]|0)+(H<<1)|0;j=d[n>>1]|0;o=(j&65535)<(o&65535)?j:o;j=d[n+2>>1]|0;m=(j&65535)<(m&65535)?j:m;j=d[n+4>>1]|0;r=(j&65535)<(r&65535)?j:r;j=d[n+6>>1]|0;l=(j&65535)<(l&65535)?j:l;p=p+1|0}while((p|0)!=(i|0));d[F+(H<<1)>>1]=o;d[F+((H|1)<<1)>>1]=m;d[F+((H|2)<<1)>>1]=r;d[F+((H|3)<<1)>>1]=l;H=H+4|0}while((H|0)<=(g|0));G=c}while(0);d:do if((G|0)<(h|0)){D=f[q>>2]|0;if(e)I=G;else{p=G;while(1){d[F+(p<<1)>>1]=d[D+(p<<1)>>1]|0;p=p+1|0;if((p|0)==(h|0))break d}}do{p=d[D+(I<<1)>>1]|0;A=1;do{j=d[(f[q+(A<<2)>>2]|0)+(I<<1)>>1]|0;p=(j&65535)<(p&65535)?j:p;A=A+1|0}while((A|0)!=(i|0));d[F+(I<<1)>>1]=p;I=I+1|0}while((I|0)!=(h|0))}while(0);if((E|0)>1){q=q+4|0;E=E+-1|0;F=F+(a<<1)|0}else break}return}function lka(a){a=a|0;O5b(a);return}function mka(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function nka(a){a=a|0;O5b(a);return}function oka(a,c,d,e,g,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;j=f[a+4>>2]|0;a=(j|0)>1;if(a&(g|0)>1){k=i+-4|0;l=(i|0)<4;m=(j|0)>2;n=e<<1;o=i&-4;p=d;q=c;r=g;while(1){if(l)s=0;else{t=q+4|0;u=0;do{v=(f[t>>2]|0)+u|0;w=b[v>>0]|0;x=b[v+1>>0]|0;y=b[v+2>>0]|0;z=b[v+3>>0]|0;if(m){v=z;A=y;B=x;C=w;D=2;while(1){E=(f[q+(D<<2)>>2]|0)+u|0;F=C&255;G=F-(h[E>>0]|0)+256|0;if(G>>>0<769)H=h[259297+G>>0]|0;else H=0;G=F-H&255;F=B&255;I=F-(h[E+1>>0]|0)+256|0;if(I>>>0<769)J=h[259297+I>>0]|0;else J=0;I=F-J&255;F=A&255;K=F-(h[E+2>>0]|0)+256|0;if(K>>>0<769)L=h[259297+K>>0]|0;else L=0;K=F-L&255;F=v&255;M=F-(h[E+3>>0]|0)+256|0;if(M>>>0<769)N=h[259297+M>>0]|0;else N=0;M=F-N&255;D=D+1|0;if((D|0)==(j|0)){O=M;P=K;Q=I;R=G;S=j;break}else{v=M;A=K;B=I;C=G}}}else{O=z;P=y;Q=x;R=w;S=2}C=(f[q>>2]|0)+u|0;B=R&255;A=B-(h[C>>0]|0)+256|0;if(A>>>0<769)T=h[259297+A>>0]|0;else T=0;b[p+u>>0]=B-T;A=Q&255;v=A-(h[C+1>>0]|0)+256|0;if(v>>>0<769)U=h[259297+v>>0]|0;else U=0;b[p+(u|1)>>0]=A-U;v=P&255;D=v-(h[C+2>>0]|0)+256|0;if(D>>>0<769)V=h[259297+D>>0]|0;else V=0;b[p+(u|2)>>0]=v-V;D=O&255;G=D-(h[C+3>>0]|0)+256|0;if(G>>>0<769)W=h[259297+G>>0]|0;else W=0;b[p+(u|3)>>0]=D-W;G=(f[q+(S<<2)>>2]|0)+u|0;C=B-(h[G>>0]|0)+256|0;if(C>>>0<769)X=h[259297+C>>0]|0;else X=0;C=u+e|0;b[p+C>>0]=B-X;B=A-(h[G+1>>0]|0)+256|0;if(B>>>0<769)Y=h[259297+B>>0]|0;else Y=0;b[p+(C+1)>>0]=A-Y;A=v-(h[G+2>>0]|0)+256|0;if(A>>>0<769)Z=h[259297+A>>0]|0;else Z=0;b[p+(C+2)>>0]=v-Z;v=D-(h[G+3>>0]|0)+256|0;if(v>>>0<769)_=h[259297+v>>0]|0;else _=0;b[p+(C+3)>>0]=D-_;u=u+4|0}while((u|0)<=(k|0));s=o}a:do if((s|0)<(i|0)){u=q+4|0;if(!m){t=q+8|0;D=s;while(1){C=h[(f[u>>2]|0)+D>>0]|0;v=C-(h[(f[q>>2]|0)+D>>0]|0)+256|0;if(v>>>0<769)$=h[259297+v>>0]|0;else $=0;b[p+D>>0]=C-$;v=C-(h[(f[t>>2]|0)+D>>0]|0)+256|0;if(v>>>0<769)aa=h[259297+v>>0]|0;else aa=0;b[p+(D+e)>>0]=C-aa;D=D+1|0;if((D|0)==(i|0))break a}}D=q+(j<<2)|0;t=s;do{w=b[(f[u>>2]|0)+t>>0]|0;x=2;while(1){y=w&255;z=y-(h[(f[q+(x<<2)>>2]|0)+t>>0]|0)+256|0;if(z>>>0<769)ba=h[259297+z>>0]|0;else ba=0;ca=y-ba|0;x=x+1|0;if((x|0)==(j|0))break;else w=ca&255}w=ca&255;x=w-(h[(f[q>>2]|0)+t>>0]|0)+256|0;if(x>>>0<769)da=h[259297+x>>0]|0;else da=0;b[p+t>>0]=ca-da;x=w-(h[(f[D>>2]|0)+t>>0]|0)+256|0;if(x>>>0<769)ea=h[259297+x>>0]|0;else ea=0;b[p+(t+e)>>0]=ca-ea;t=t+1|0}while((t|0)!=(i|0))}while(0);t=r+-2|0;D=p+n|0;u=q+8|0;if((t|0)>1){p=D;q=u;r=t}else{fa=D;ga=u;ha=t;break}}}else{fa=d;ga=c;ha=g}if((ha|0)<=0)return;g=i+-4|0;c=(i|0)<4;d=i&-4;r=ga;ga=ha;ha=fa;while(1){b:do if(c)ia=0;else{if(a)ja=0;else{fa=0;while(1){q=(f[r>>2]|0)+fa|0;p=b[q+1>>0]|0;n=b[q+2>>0]|0;ea=b[q+3>>0]|0;b[ha+fa>>0]=b[q>>0]|0;b[ha+(fa|1)>>0]=p;b[ha+(fa|2)>>0]=n;b[ha+(fa|3)>>0]=ea;fa=fa+4|0;if((fa|0)>(g|0)){ia=d;break b}}}do{fa=(f[r>>2]|0)+ja|0;ea=b[fa+3>>0]|0;n=b[fa+2>>0]|0;p=b[fa+1>>0]|0;q=b[fa>>0]|0;fa=1;do{ca=(f[r+(fa<<2)>>2]|0)+ja|0;da=q&255;ba=da-(h[ca>>0]|0)+256|0;if(ba>>>0<769)ka=h[259297+ba>>0]|0;else ka=0;q=da-ka&255;da=p&255;ba=da-(h[ca+1>>0]|0)+256|0;if(ba>>>0<769)la=h[259297+ba>>0]|0;else la=0;p=da-la&255;da=n&255;ba=da-(h[ca+2>>0]|0)+256|0;if(ba>>>0<769)ma=h[259297+ba>>0]|0;else ma=0;n=da-ma&255;da=ea&255;ba=da-(h[ca+3>>0]|0)+256|0;if(ba>>>0<769)na=h[259297+ba>>0]|0;else na=0;ea=da-na&255;fa=fa+1|0}while((fa|0)!=(j|0));b[ha+ja>>0]=q;b[ha+(ja|1)>>0]=p;b[ha+(ja|2)>>0]=n;b[ha+(ja|3)>>0]=ea;ja=ja+4|0}while((ja|0)<=(g|0));ia=d}while(0);c:do if((ia|0)<(i|0)){if(a)oa=ia;else{fa=ia;while(1){b[ha+fa>>0]=b[(f[r>>2]|0)+fa>>0]|0;fa=fa+1|0;if((fa|0)==(i|0))break c}}do{fa=b[(f[r>>2]|0)+oa>>0]|0;da=1;do{ba=fa&255;ca=ba-(h[(f[r+(da<<2)>>2]|0)+oa>>0]|0)+256|0;if(ca>>>0<769)pa=h[259297+ca>>0]|0;else pa=0;fa=ba-pa&255;da=da+1|0}while((da|0)!=(j|0));b[ha+oa>>0]=fa;oa=oa+1|0}while((oa|0)!=(i|0))}while(0);if((ga|0)>1){r=r+4|0;ga=ga+-1|0;ha=ha+e|0}else break}return}function pka(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+80|0;i=h;j=h+64|0;k=h+8|0;do if((yM(e)|0)==65536){l=f[e+4>>2]|0;f[k>>2]=f[l>>2];m=k+4|0;n=l+4|0;f[m>>2]=f[n>>2];o=k+8|0;f[o>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];f[k+16>>2]=f[l+16>>2];f[k+20>>2]=f[l+20>>2];f[k+24>>2]=f[l+24>>2];f[k+28>>2]=f[l+28>>2];f[k+32>>2]=f[l+32>>2];p=f[l+36>>2]|0;f[k+36>>2]=p;q=k+40|0;f[q>>2]=o;o=k+48|0;r=k+44|0;f[r>>2]=o;f[o>>2]=0;f[k+52>>2]=0;if(p|0){o=p+12|0;f[o>>2]=(f[o>>2]|0)+1}if((f[n>>2]|0)<3){n=f[l+44>>2]|0;o=f[r>>2]|0;f[o>>2]=f[n>>2];f[o+4>>2]=f[n+4>>2];s=q;break}else{f[m>>2]=0;jL(k,l);s=q;break}}else{yL(k,e,-1);s=k+40|0}while(0);e=d&7;q=f[g>>2]|0;l=g+4|0;m=f[l>>2]|0;n=f[s>>2]|0;o=f[n+4>>2]|0;r=f[n>>2]|0;n=(q|0)==-1?(o|0)/2|0:q;q=(m|0)==-1?(r|0)/2|0:m;if(!((n|0)>-1&(n|0)<(o|0)?!((q|0)<0|(q|0)>=(r|0)):0)){f[j>>2]=0;f[j+4>>2]=0;t=aD(j,52)|0;v=263653;w=t+52|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,j,263706,263722,363);bD(j)}f[g>>2]=n;f[l>>2]=q;q=(c|0)==0;if((c|1|0)!=1){f[j>>2]=0;f[j+4>>2]=0;t=aD(j,39)|0;v=260066;w=t+39|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(w|0));bO(-215,j,263799,260129,947);bD(j)}v=(e|0)==0;a:do if(q){if(v){e=L5b(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];qka(e,k,j);t=L5b(16)|0;w=t+4|0;f[w>>2]=1;f[t>>2]=58268;f[t+8>>2]=e;f[a>>2]=t;f[a+4>>2]=e;f[w>>2]=(f[w>>2]|0)+1;e=f[w>>2]|0;f[w>>2]=e+-1;if((e|0)!=1)break;bi[f[(f[t>>2]|0)+8>>2]&2047](t);break}switch(d&7){case 2:{t=L5b(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];rka(t,k,j);e=L5b(16)|0;w=e+4|0;f[w>>2]=1;f[e>>2]=58288;f[e+8>>2]=t;f[a>>2]=e;f[a+4>>2]=t;f[w>>2]=(f[w>>2]|0)+1;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)!=1)break a;bi[f[(f[e>>2]|0)+8>>2]&2047](e);break a;break}case 3:{e=L5b(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];ska(e,k,j);t=L5b(16)|0;w=t+4|0;f[w>>2]=1;f[t>>2]=58308;f[t+8>>2]=e;f[a>>2]=t;f[a+4>>2]=e;f[w>>2]=(f[w>>2]|0)+1;e=f[w>>2]|0;f[w>>2]=e+-1;if((e|0)!=1)break a;bi[f[(f[t>>2]|0)+8>>2]&2047](t);break a;break}case 5:{t=L5b(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];tka(t,k,j);e=L5b(16)|0;w=e+4|0;f[w>>2]=1;f[e>>2]=58328;f[e+8>>2]=t;f[a>>2]=e;f[a+4>>2]=t;f[w>>2]=(f[w>>2]|0)+1;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)!=1)break a;bi[f[(f[e>>2]|0)+8>>2]&2047](e);break a;break}case 6:{e=L5b(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];uka(e,k,j);t=L5b(16)|0;w=t+4|0;f[w>>2]=1;f[t>>2]=58348;f[t+8>>2]=e;f[a>>2]=t;f[a+4>>2]=e;f[w>>2]=(f[w>>2]|0)+1;e=f[w>>2]|0;f[w>>2]=e+-1;if((e|0)!=1)break a;bi[f[(f[t>>2]|0)+8>>2]&2047](t);break a;break}default:{x=38;break a}}}else{if(v){t=L5b(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];vka(t,k,j);e=L5b(16)|0;w=e+4|0;f[w>>2]=1;f[e>>2]=58368;f[e+8>>2]=t;f[a>>2]=e;f[a+4>>2]=t;f[w>>2]=(f[w>>2]|0)+1;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)!=1)break;bi[f[(f[e>>2]|0)+8>>2]&2047](e);break}switch(d&7){case 2:{e=L5b(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];wka(e,k,j);t=L5b(16)|0;w=t+4|0;f[w>>2]=1;f[t>>2]=58388;f[t+8>>2]=e;f[a>>2]=t;f[a+4>>2]=e;f[w>>2]=(f[w>>2]|0)+1;e=f[w>>2]|0;f[w>>2]=e+-1;if((e|0)!=1)break a;bi[f[(f[t>>2]|0)+8>>2]&2047](t);break a;break}case 3:{t=L5b(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];xka(t,k,j);e=L5b(16)|0;w=e+4|0;f[w>>2]=1;f[e>>2]=58408;f[e+8>>2]=t;f[a>>2]=e;f[a+4>>2]=t;f[w>>2]=(f[w>>2]|0)+1;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)!=1)break a;bi[f[(f[e>>2]|0)+8>>2]&2047](e);break a;break}case 5:{e=L5b(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];yka(e,k,j);t=L5b(16)|0;w=t+4|0;f[w>>2]=1;f[t>>2]=58428;f[t+8>>2]=e;f[a>>2]=t;f[a+4>>2]=e;f[w>>2]=(f[w>>2]|0)+1;e=f[w>>2]|0;f[w>>2]=e+-1;if((e|0)!=1)break a;bi[f[(f[t>>2]|0)+8>>2]&2047](t);break a;break}case 6:{t=L5b(48)|0;f[j>>2]=f[g>>2];f[j+4>>2]=f[l>>2];zka(t,k,j);e=L5b(16)|0;w=e+4|0;f[w>>2]=1;f[e>>2]=58448;f[e+8>>2]=t;f[a>>2]=e;f[a+4>>2]=t;f[w>>2]=(f[w>>2]|0)+1;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)!=1)break a;bi[f[(f[e>>2]|0)+8>>2]&2047](e);break a;break}default:{x=38;break a}}}while(0);if((x|0)==38){f[i>>2]=d;hO(j,260199,i);bO(-213,j,263799,260129,975);bD(j);f[a>>2]=0;f[a+4>>2]=0}a=k+36|0;j=f[a>>2]|0;if(j|0?(i=j+12|0,j=f[i>>2]|0,f[i>>2]=j+-1,(j|0)==1):0)kL(k);f[a>>2]=0;a=k+16|0;j=k+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[j>>2]|0)>0){a=f[s>>2]|0;s=0;do{f[a+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[j>>2]|0))}j=f[k+44>>2]|0;if((j|0)==(k+48|0)){u=h;return}UC(j);u=h;return}function qka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;c8(a);f[a>>2]=58684;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,19)|0;a=263921;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));bO(-215,g,263941,260129,787);bD(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;ica(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Y2(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;O5b(l);u=e;return}function rka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;c8(a);f[a>>2]=58660;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,19)|0;a=263921;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));bO(-215,g,263941,260129,787);bD(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;ica(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Y2(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;O5b(l);u=e;return}function ska(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;c8(a);f[a>>2]=58636;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,19)|0;a=263921;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));bO(-215,g,263941,260129,787);bD(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;ica(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Y2(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;O5b(l);u=e;return}function tka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;c8(a);f[a>>2]=58612;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,19)|0;a=263921;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));bO(-215,g,263941,260129,787);bD(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;ica(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Y2(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;O5b(l);u=e;return}function uka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;c8(a);f[a>>2]=58588;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,19)|0;a=263921;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));bO(-215,g,263941,260129,787);bD(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;ica(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Y2(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;O5b(l);u=e;return}function vka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;c8(a);f[a>>2]=58564;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,19)|0;a=263921;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));bO(-215,g,263941,260129,787);bD(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;ica(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Y2(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;O5b(l);u=e;return}function wka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;c8(a);f[a>>2]=58540;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,19)|0;a=263921;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));bO(-215,g,263941,260129,787);bD(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;ica(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Y2(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;O5b(l);u=e;return}function xka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;c8(a);f[a>>2]=58516;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,19)|0;a=263921;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));bO(-215,g,263941,260129,787);bD(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;ica(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Y2(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;O5b(l);u=e;return}function yka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;c8(a);f[a>>2]=58492;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,19)|0;a=263921;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));bO(-215,g,263941,260129,787);bD(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;ica(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Y2(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;O5b(l);u=e;return}function zka(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;c8(a);f[a>>2]=58468;h=a+20|0;i=a+24|0;j=a+32|0;k=a+36|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[a+12>>2]=f[d>>2];f[a+16>>2]=f[d+4>>2];d=f[c+40>>2]|0;l=f[d>>2]|0;f[a+4>>2]=f[d+4>>2];f[a+8>>2]=l;if(f[c>>2]&4095|0){f[g>>2]=0;f[g+4>>2]=0;l=aD(g,19)|0;a=263921;d=l+19|0;do{b[l>>0]=b[a>>0]|0;l=l+1|0;a=a+1|0}while((l|0)<(d|0));bO(-215,g,263941,260129,787);bD(g)}f[g>>2]=0;a=g+4|0;f[a>>2]=0;f[g+8>>2]=0;ica(c,h,g);c=(f[i>>2]|0)-(f[h>>2]|0)>>3;h=f[k>>2]|0;i=f[j>>2]|0;l=h-i>>2;d=i;i=h;if(c>>>0<=l>>>0){if(c>>>0<l>>>0?(h=d+(c<<2)|0,(i|0)!=(h|0)):0)f[k>>2]=i+(~((i+-4-h|0)>>>2)<<2)}else Y2(j,c-l|0);l=f[g>>2]|0;if(!l){u=e;return}if((f[a>>2]|0)!=(l|0))f[a>>2]=l;O5b(l);u=e;return}function Aka(a){a=a|0;O5b(a);return}function Bka(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Cka(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58468;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);return}function Dka(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58468;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);O5b(a);return}function Eka(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;n=(l|0)<4;o=(k|0)>8;k=l&-4;q=e;e=b;b=c;while(1){if(g){c=0;do{r=(f[e+(f[i+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(c<<3)>>2]|0,h)|0)<<3)|0;f[j+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(n)s=0;else{c=f[j>>2]|0;if(o)t=0;else{r=0;while(1){u=c+(r<<3)|0;v=+p[u+8>>3];w=+p[u+16>>3];x=+p[u+24>>3];p[b+(r<<3)>>3]=+p[u>>3];p[b+((r|1)<<3)>>3]=v;p[b+((r|2)<<3)>>3]=w;p[b+((r|3)<<3)>>3]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=c+(t<<3)|0;x=+p[r+24>>3];w=+p[r+16>>3];v=+p[r+8>>3];y=+p[r>>3];r=1;do{u=(f[j+(r<<2)>>2]|0)+(t<<3)|0;z=+p[u>>3];y=y<z?z:y;z=+p[u+8>>3];v=v<z?z:v;z=+p[u+16>>3];w=w<z?z:w;z=+p[u+24>>3];x=x<z?z:x;r=r+1|0}while((r|0)<(a|0));p[b+(t<<3)>>3]=y;p[b+((t|1)<<3)>>3]=v;p[b+((t|2)<<3)>>3]=w;p[b+((t|3)<<3)>>3]=x;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){c=f[j>>2]|0;if(o)A=s;else{r=s;while(1){p[b+(r<<3)>>3]=+p[c+(r<<3)>>3];r=r+1|0;if((r|0)==(l|0))break b}}do{z=+p[c+(A<<3)>>3];r=1;do{B=+p[(f[j+(r<<2)>>2]|0)+(A<<3)>>3];z=z<B?B:z;r=r+1|0}while((r|0)<(a|0));p[b+(A<<3)>>3]=z;A=A+1|0}while((A|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+4|0;b=b+d|0}else break}return}function Fka(a){a=a|0;O5b(a);return}function Gka(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Hka(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58492;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);return}function Ika(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58492;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);O5b(a);return}function Jka(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;o=(l|0)<4;p=(k|0)>8;k=l&-4;q=e;e=b;b=c;while(1){if(g){c=0;do{r=(f[e+(f[i+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(c<<3)>>2]|0,h)|0)<<2)|0;f[j+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[j>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<2)|0;v=f[u+4>>2]|0;w=f[u+8>>2]|0;x=f[u+12>>2]|0;f[b+(r<<2)>>2]=f[u>>2];f[b+((r|1)<<2)>>2]=v;f[b+((r|2)<<2)>>2]=w;f[b+((r|3)<<2)>>2]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=c+(t<<2)|0;y=+n[r+12>>2];z=+n[r+8>>2];A=+n[r+4>>2];B=+n[r>>2];r=1;do{x=(f[j+(r<<2)>>2]|0)+(t<<2)|0;C=+n[x>>2];B=B<C?C:B;C=+n[x+4>>2];A=A<C?C:A;C=+n[x+8>>2];z=z<C?C:z;C=+n[x+12>>2];y=y<C?C:y;r=r+1|0}while((r|0)<(a|0));n[b+(t<<2)>>2]=B;n[b+((t|1)<<2)>>2]=A;n[b+((t|2)<<2)>>2]=z;n[b+((t|3)<<2)>>2]=y;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){c=f[j>>2]|0;if(p)D=s;else{r=s;while(1){f[b+(r<<2)>>2]=f[c+(r<<2)>>2];r=r+1|0;if((r|0)==(l|0))break b}}do{C=+n[c+(D<<2)>>2];r=1;do{E=+n[(f[j+(r<<2)>>2]|0)+(D<<2)>>2];C=C<E?E:C;r=r+1|0}while((r|0)<(a|0));n[b+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+4|0;b=b+d|0}else break}return}function Kka(a){a=a|0;O5b(a);return}function Lka(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Mka(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58516;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);return}function Nka(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58516;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);O5b(a);return}function Oka(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=b;b=c;while(1){if(h){c=0;do{r=(f[g+(f[j+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(c<<3)>>2]|0,i)|0)<<1)|0;f[k+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[b+(r<<1)>>1]=d[u>>1]|0;d[b+((r|1)<<1)>>1]=v;d[b+((r|2)<<1)>>1]=w;d[b+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=c+(t<<1)|0;x=d[r+6>>1]|0;w=d[r+4>>1]|0;v=d[r+2>>1]|0;u=d[r>>1]|0;r=1;do{y=(f[k+(r<<2)>>2]|0)+(t<<1)|0;z=d[y>>1]|0;u=u<<16>>16<z<<16>>16?z:u;z=d[y+2>>1]|0;v=v<<16>>16<z<<16>>16?z:v;z=d[y+4>>1]|0;w=w<<16>>16<z<<16>>16?z:w;z=d[y+6>>1]|0;x=x<<16>>16<z<<16>>16?z:x;r=r+1|0}while((r|0)<(a|0));d[b+(t<<1)>>1]=u;d[b+((t|1)<<1)>>1]=v;d[b+((t|2)<<1)>>1]=w;d[b+((t|3)<<1)>>1]=x;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){c=f[k>>2]|0;if(p)A=s;else{r=s;while(1){d[b+(r<<1)>>1]=d[c+(r<<1)>>1]|0;r=r+1|0;if((r|0)==(m|0))break b}}do{r=d[c+(A<<1)>>1]|0;z=1;do{y=d[(f[k+(z<<2)>>2]|0)+(A<<1)>>1]|0;r=r<<16>>16<y<<16>>16?y:r;z=z+1|0}while((z|0)<(a|0));d[b+(A<<1)>>1]=r;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+4|0;b=b+e|0}else break}return}function Pka(a){a=a|0;O5b(a);return}function Qka(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Rka(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58540;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);return}function Ska(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58540;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);O5b(a);return}function Tka(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=b;b=c;while(1){if(h){c=0;do{r=(f[g+(f[j+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(c<<3)>>2]|0,i)|0)<<1)|0;f[k+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[b+(r<<1)>>1]=d[u>>1]|0;d[b+((r|1)<<1)>>1]=v;d[b+((r|2)<<1)>>1]=w;d[b+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=c+(t<<1)|0;x=d[r+6>>1]|0;w=d[r+4>>1]|0;v=d[r+2>>1]|0;u=d[r>>1]|0;r=1;do{y=(f[k+(r<<2)>>2]|0)+(t<<1)|0;z=d[y>>1]|0;u=(u&65535)<(z&65535)?z:u;z=d[y+2>>1]|0;v=(v&65535)<(z&65535)?z:v;z=d[y+4>>1]|0;w=(w&65535)<(z&65535)?z:w;z=d[y+6>>1]|0;x=(x&65535)<(z&65535)?z:x;r=r+1|0}while((r|0)<(a|0));d[b+(t<<1)>>1]=u;d[b+((t|1)<<1)>>1]=v;d[b+((t|2)<<1)>>1]=w;d[b+((t|3)<<1)>>1]=x;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){c=f[k>>2]|0;if(p)A=s;else{r=s;while(1){d[b+(r<<1)>>1]=d[c+(r<<1)>>1]|0;r=r+1|0;if((r|0)==(m|0))break b}}do{r=d[c+(A<<1)>>1]|0;z=1;do{y=d[(f[k+(z<<2)>>2]|0)+(A<<1)>>1]|0;r=(r&65535)<(y&65535)?y:r;z=z+1|0}while((z|0)<(a|0));d[b+(A<<1)>>1]=r;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+4|0;b=b+e|0}else break}return}function Uka(a){a=a|0;O5b(a);return}function Vka(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Wka(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58564;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);return}function Xka(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58564;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);O5b(a);return}function Yka(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=(f[a+24>>2]|0)-k|0;a=m>>3;n=Y(j,i)|0;if((g|0)<=0)return;i=(m|0)>0;o=n+-4|0;p=(n|0)<4;q=(m|0)>8;m=n&-4;r=c;c=d;d=g;while(1){if(i){g=0;do{s=(f[r+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(g<<3)>>2]|0,j)|0)|0;f[l+(g<<2)>>2]=s;g=g+1|0}while((g|0)<(a|0))}a:do if(p)t=0;else{if(q)u=0;else{g=0;while(1){s=(f[l>>2]|0)+g|0;v=b[s+1>>0]|0;w=b[s+2>>0]|0;x=b[s+3>>0]|0;b[c+g>>0]=b[s>>0]|0;b[c+(g|1)>>0]=v;b[c+(g|2)>>0]=w;b[c+(g|3)>>0]=x;g=g+4|0;if((g|0)>(o|0)){t=m;break a}}}do{g=(f[l>>2]|0)+u|0;x=b[g+3>>0]|0;w=b[g+2>>0]|0;v=b[g+1>>0]|0;s=b[g>>0]|0;g=1;do{y=(f[l+(g<<2)>>2]|0)+u|0;z=s&255;A=(h[y>>0]|0)-z+256|0;if(A>>>0<769)B=h[259297+A>>0]|0;else B=0;s=B+z&255;z=v&255;A=(h[y+1>>0]|0)-z+256|0;if(A>>>0<769)C=h[259297+A>>0]|0;else C=0;v=C+z&255;z=w&255;A=(h[y+2>>0]|0)-z+256|0;if(A>>>0<769)D=h[259297+A>>0]|0;else D=0;w=D+z&255;z=x&255;A=(h[y+3>>0]|0)-z+256|0;if(A>>>0<769)E=h[259297+A>>0]|0;else E=0;x=E+z&255;g=g+1|0}while((g|0)<(a|0));b[c+u>>0]=s;b[c+(u|1)>>0]=v;b[c+(u|2)>>0]=w;b[c+(u|3)>>0]=x;u=u+4|0}while((u|0)<=(o|0));t=m}while(0);b:do if((t|0)<(n|0)){if(q)F=t;else{g=t;while(1){b[c+g>>0]=b[(f[l>>2]|0)+g>>0]|0;g=g+1|0;if((g|0)==(n|0))break b}}do{g=b[(f[l>>2]|0)+F>>0]|0;z=1;do{A=g&255;y=(h[(f[l+(z<<2)>>2]|0)+F>>0]|0)-A+256|0;if(y>>>0<769)G=h[259297+y>>0]|0;else G=0;g=G+A&255;z=z+1|0}while((z|0)<(a|0));b[c+F>>0]=g;F=F+1|0}while((F|0)!=(n|0))}while(0);if((d|0)>1){r=r+4|0;c=c+e|0;d=d+-1|0}else break}return}function Zka(a){a=a|0;O5b(a);return}function _ka(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function $ka(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58588;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);return}function ala(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58588;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);O5b(a);return}function bla(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;n=(l|0)<4;o=(k|0)>8;k=l&-4;q=e;e=b;b=c;while(1){if(g){c=0;do{r=(f[e+(f[i+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(c<<3)>>2]|0,h)|0)<<3)|0;f[j+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(n)s=0;else{c=f[j>>2]|0;if(o)t=0;else{r=0;while(1){u=c+(r<<3)|0;v=+p[u+8>>3];w=+p[u+16>>3];x=+p[u+24>>3];p[b+(r<<3)>>3]=+p[u>>3];p[b+((r|1)<<3)>>3]=v;p[b+((r|2)<<3)>>3]=w;p[b+((r|3)<<3)>>3]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=c+(t<<3)|0;x=+p[r+24>>3];w=+p[r+16>>3];v=+p[r+8>>3];y=+p[r>>3];r=1;do{u=(f[j+(r<<2)>>2]|0)+(t<<3)|0;z=+p[u>>3];y=z<y?z:y;z=+p[u+8>>3];v=z<v?z:v;z=+p[u+16>>3];w=z<w?z:w;z=+p[u+24>>3];x=z<x?z:x;r=r+1|0}while((r|0)<(a|0));p[b+(t<<3)>>3]=y;p[b+((t|1)<<3)>>3]=v;p[b+((t|2)<<3)>>3]=w;p[b+((t|3)<<3)>>3]=x;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){c=f[j>>2]|0;if(o)A=s;else{r=s;while(1){p[b+(r<<3)>>3]=+p[c+(r<<3)>>3];r=r+1|0;if((r|0)==(l|0))break b}}do{z=+p[c+(A<<3)>>3];r=1;do{B=+p[(f[j+(r<<2)>>2]|0)+(A<<3)>>3];z=B<z?B:z;r=r+1|0}while((r|0)<(a|0));p[b+(A<<3)>>3]=z;A=A+1|0}while((A|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+4|0;b=b+d|0}else break}return}function cla(a){a=a|0;O5b(a);return}function dla(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ela(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58612;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);return}function fla(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58612;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);O5b(a);return}function gla(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0.0;i=f[a+20>>2]|0;j=f[a+32>>2]|0;k=(f[a+24>>2]|0)-i|0;a=k>>3;l=Y(h,g)|0;if((e|0)<=0)return;g=(k|0)>0;m=l+-4|0;o=(l|0)<4;p=(k|0)>8;k=l&-4;q=e;e=b;b=c;while(1){if(g){c=0;do{r=(f[e+(f[i+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[i+(c<<3)>>2]|0,h)|0)<<2)|0;f[j+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[j>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<2)|0;v=f[u+4>>2]|0;w=f[u+8>>2]|0;x=f[u+12>>2]|0;f[b+(r<<2)>>2]=f[u>>2];f[b+((r|1)<<2)>>2]=v;f[b+((r|2)<<2)>>2]=w;f[b+((r|3)<<2)>>2]=x;r=r+4|0;if((r|0)>(m|0)){s=k;break a}}}do{r=c+(t<<2)|0;y=+n[r+12>>2];z=+n[r+8>>2];A=+n[r+4>>2];B=+n[r>>2];r=1;do{x=(f[j+(r<<2)>>2]|0)+(t<<2)|0;C=+n[x>>2];B=C<B?C:B;C=+n[x+4>>2];A=C<A?C:A;C=+n[x+8>>2];z=C<z?C:z;C=+n[x+12>>2];y=C<y?C:y;r=r+1|0}while((r|0)<(a|0));n[b+(t<<2)>>2]=B;n[b+((t|1)<<2)>>2]=A;n[b+((t|2)<<2)>>2]=z;n[b+((t|3)<<2)>>2]=y;t=t+4|0}while((t|0)<=(m|0));s=k}while(0);b:do if((s|0)<(l|0)){c=f[j>>2]|0;if(p)D=s;else{r=s;while(1){f[b+(r<<2)>>2]=f[c+(r<<2)>>2];r=r+1|0;if((r|0)==(l|0))break b}}do{C=+n[c+(D<<2)>>2];r=1;do{E=+n[(f[j+(r<<2)>>2]|0)+(D<<2)>>2];C=E<C?E:C;r=r+1|0}while((r|0)<(a|0));n[b+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(l|0))}while(0);if((q|0)>1){q=q+-1|0;e=e+4|0;b=b+d|0}else break}return}function hla(a){a=a|0;O5b(a);return}function ila(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function jla(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58636;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);return}function kla(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58636;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);O5b(a);return}function lla(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=b;b=c;while(1){if(h){c=0;do{r=(f[g+(f[j+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(c<<3)>>2]|0,i)|0)<<1)|0;f[k+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[b+(r<<1)>>1]=d[u>>1]|0;d[b+((r|1)<<1)>>1]=v;d[b+((r|2)<<1)>>1]=w;d[b+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=c+(t<<1)|0;x=d[r+6>>1]|0;w=d[r+4>>1]|0;v=d[r+2>>1]|0;u=d[r>>1]|0;r=1;do{y=(f[k+(r<<2)>>2]|0)+(t<<1)|0;z=d[y>>1]|0;u=z<<16>>16<u<<16>>16?z:u;z=d[y+2>>1]|0;v=z<<16>>16<v<<16>>16?z:v;z=d[y+4>>1]|0;w=z<<16>>16<w<<16>>16?z:w;z=d[y+6>>1]|0;x=z<<16>>16<x<<16>>16?z:x;r=r+1|0}while((r|0)<(a|0));d[b+(t<<1)>>1]=u;d[b+((t|1)<<1)>>1]=v;d[b+((t|2)<<1)>>1]=w;d[b+((t|3)<<1)>>1]=x;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){c=f[k>>2]|0;if(p)A=s;else{r=s;while(1){d[b+(r<<1)>>1]=d[c+(r<<1)>>1]|0;r=r+1|0;if((r|0)==(m|0))break b}}do{r=d[c+(A<<1)>>1]|0;z=1;do{y=d[(f[k+(z<<2)>>2]|0)+(A<<1)>>1]|0;r=y<<16>>16<r<<16>>16?y:r;z=z+1|0}while((z|0)<(a|0));d[b+(A<<1)>>1]=r;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+4|0;b=b+e|0}else break}return}function mla(a){a=a|0;O5b(a);return}function nla(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function ola(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58660;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);return}function pla(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58660;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);O5b(a);return}function qla(a,b,c,e,g,h,i){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=f[a+20>>2]|0;k=f[a+32>>2]|0;l=(f[a+24>>2]|0)-j|0;a=l>>3;m=Y(i,h)|0;if((g|0)<=0)return;h=(l|0)>0;n=m+-4|0;o=(m|0)<4;p=(l|0)>8;l=m&-4;q=g;g=b;b=c;while(1){if(h){c=0;do{r=(f[g+(f[j+(c<<3)+4>>2]<<2)>>2]|0)+((Y(f[j+(c<<3)>>2]|0,i)|0)<<1)|0;f[k+(c<<2)>>2]=r;c=c+1|0}while((c|0)<(a|0))}a:do if(o)s=0;else{c=f[k>>2]|0;if(p)t=0;else{r=0;while(1){u=c+(r<<1)|0;v=d[u+2>>1]|0;w=d[u+4>>1]|0;x=d[u+6>>1]|0;d[b+(r<<1)>>1]=d[u>>1]|0;d[b+((r|1)<<1)>>1]=v;d[b+((r|2)<<1)>>1]=w;d[b+((r|3)<<1)>>1]=x;r=r+4|0;if((r|0)>(n|0)){s=l;break a}}}do{r=c+(t<<1)|0;x=d[r+6>>1]|0;w=d[r+4>>1]|0;v=d[r+2>>1]|0;u=d[r>>1]|0;r=1;do{y=(f[k+(r<<2)>>2]|0)+(t<<1)|0;z=d[y>>1]|0;u=(z&65535)<(u&65535)?z:u;z=d[y+2>>1]|0;v=(z&65535)<(v&65535)?z:v;z=d[y+4>>1]|0;w=(z&65535)<(w&65535)?z:w;z=d[y+6>>1]|0;x=(z&65535)<(x&65535)?z:x;r=r+1|0}while((r|0)<(a|0));d[b+(t<<1)>>1]=u;d[b+((t|1)<<1)>>1]=v;d[b+((t|2)<<1)>>1]=w;d[b+((t|3)<<1)>>1]=x;t=t+4|0}while((t|0)<=(n|0));s=l}while(0);b:do if((s|0)<(m|0)){c=f[k>>2]|0;if(p)A=s;else{r=s;while(1){d[b+(r<<1)>>1]=d[c+(r<<1)>>1]|0;r=r+1|0;if((r|0)==(m|0))break b}}do{r=d[c+(A<<1)>>1]|0;z=1;do{y=d[(f[k+(z<<2)>>2]|0)+(A<<1)>>1]|0;r=(y&65535)<(r&65535)?y:r;z=z+1|0}while((z|0)<(a|0));d[b+(A<<1)>>1]=r;A=A+1|0}while((A|0)!=(m|0))}while(0);if((q|0)>1){q=q+-1|0;g=g+4|0;b=b+e|0}else break}return}function rla(a){a=a|0;O5b(a);return}function sla(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function tla(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58684;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);return}function ula(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=58684;b=f[a+32>>2]|0;if(b|0){c=a+36|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+20>>2]|0;if(!b){T7(a);O5b(a);return}d=a+24|0;c=f[d>>2]|0;if((c|0)!=(b|0))f[d>>2]=c+(~((c+-8-b|0)>>>3)<<3);O5b(b);T7(a);O5b(a);return}function vla(a,c,d,e,g,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=f[a+20>>2]|0;l=f[a+32>>2]|0;m=(f[a+24>>2]|0)-k|0;a=m>>3;n=Y(j,i)|0;if((g|0)<=0)return;i=(m|0)>0;o=n+-4|0;p=(n|0)<4;q=(m|0)>8;m=n&-4;r=c;c=d;d=g;while(1){if(i){g=0;do{s=(f[r+(f[k+(g<<3)+4>>2]<<2)>>2]|0)+(Y(f[k+(g<<3)>>2]|0,j)|0)|0;f[l+(g<<2)>>2]=s;g=g+1|0}while((g|0)<(a|0))}a:do if(p)t=0;else{if(q)u=0;else{g=0;while(1){s=(f[l>>2]|0)+g|0;v=b[s+1>>0]|0;w=b[s+2>>0]|0;x=b[s+3>>0]|0;b[c+g>>0]=b[s>>0]|0;b[c+(g|1)>>0]=v;b[c+(g|2)>>0]=w;b[c+(g|3)>>0]=x;g=g+4|0;if((g|0)>(o|0)){t=m;break a}}}do{g=(f[l>>2]|0)+u|0;x=b[g+3>>0]|0;w=b[g+2>>0]|0;v=b[g+1>>0]|0;s=b[g>>0]|0;g=1;do{y=(f[l+(g<<2)>>2]|0)+u|0;z=s&255;A=z-(h[y>>0]|0)+256|0;if(A>>>0<769)B=h[259297+A>>0]|0;else B=0;s=z-B&255;z=v&255;A=z-(h[y+1>>0]|0)+256|0;if(A>>>0<769)C=h[259297+A>>0]|0;else C=0;v=z-C&255;z=w&255;A=z-(h[y+2>>0]|0)+256|0;if(A>>>0<769)D=h[259297+A>>0]|0;else D=0;w=z-D&255;z=x&255;A=z-(h[y+3>>0]|0)+256|0;if(A>>>0<769)E=h[259297+A>>0]|0;else E=0;x=z-E&255;g=g+1|0}while((g|0)<(a|0));b[c+u>>0]=s;b[c+(u|1)>>0]=v;b[c+(u|2)>>0]=w;b[c+(u|3)>>0]=x;u=u+4|0}while((u|0)<=(o|0));t=m}while(0);b:do if((t|0)<(n|0)){if(q)F=t;else{g=t;while(1){b[c+g>>0]=b[(f[l>>2]|0)+g>>0]|0;g=g+1|0;if((g|0)==(n|0))break b}}do{g=b[(f[l>>2]|0)+F>>0]|0;z=1;do{A=g&255;y=A-(h[(f[l+(z<<2)>>2]|0)+F>>0]|0)+256|0;if(y>>>0<769)G=h[259297+y>>0]|0;else G=0;g=A-G&255;z=z+1|0}while((z|0)<(a|0));b[c+F>>0]=g;F=F+1|0}while((F|0)!=(n|0))}while(0);if((d|0)>1){r=r+4|0;c=c+e|0;d=d+-1|0}else break}return}function wla(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;k=u;u=u+144|0;l=k+128|0;m=k+72|0;n=k+64|0;o=k+56|0;q=k;r=k+32|0;s=k+48|0;do if((yM(e)|0)==65536){t=f[e+4>>2]|0;f[m>>2]=f[t>>2];v=m+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=m+8|0;f[x>>2]=f[t+8>>2];f[m+12>>2]=f[t+12>>2];f[m+16>>2]=f[t+16>>2];f[m+20>>2]=f[t+20>>2];f[m+24>>2]=f[t+24>>2];f[m+28>>2]=f[t+28>>2];f[m+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[m+36>>2]=y;z=m+40|0;f[z>>2]=x;x=m+48|0;A=m+44|0;f[A>>2]=x;f[x>>2]=0;f[m+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];B=z;break}else{f[v>>2]=0;jL(m,t);B=z;break}}else{yL(m,e,-1);B=m+40|0}while(0);e=f[g>>2]|0;z=g+4|0;t=f[z>>2]|0;v=f[B>>2]|0;w=f[v+4>>2]|0;x=f[v>>2]|0;v=(e|0)==-1?(w|0)/2|0:e;e=(t|0)==-1?(x|0)/2|0:t;if(!((v|0)>-1&(v|0)<(w|0)?!((e|0)<0|(e|0)>=(x|0)):0)){f[l>>2]=0;f[l+4>>2]=0;C=aD(l,52)|0;D=263653;E=C+52|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,l,263706,263722,363);bD(l)}f[g>>2]=v;f[z>>2]=e;f[l>>2]=0;e=l+4|0;f[e>>2]=0;f[n>>2]=0;v=n+4|0;f[v>>2]=0;f[o>>2]=0;x=o+4|0;f[x>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=m;w=nG(q)|0;t=m+8|0;A=f[m+12>>2]|0;if((w|0)==(Y(A,f[t>>2]|0)|0)){Pia(q,c,d,A,f[g>>2]|0);A=f[q>>2]|0;w=f[q+4>>2]|0;if(A|0){y=A+4|0;f[y>>2]=(f[y>>2]|0)+1}y=f[l>>2]|0;f[l>>2]=A;f[e>>2]=w;if(y|0?(w=y+4|0,e=f[w>>2]|0,f[w>>2]=e+-1,(e|0)==1):0)bi[f[(f[y>>2]|0)+8>>2]&2047](y);y=f[q>>2]|0;if(y|0?(e=y+4|0,w=f[e>>2]|0,f[e>>2]=w+-1,(w|0)==1):0)bi[f[(f[y>>2]|0)+8>>2]&2047](y);Cja(q,c,d,f[t>>2]|0,f[z>>2]|0);t=f[q>>2]|0;y=f[q+4>>2]|0;if(t|0){w=t+4|0;f[w>>2]=(f[w>>2]|0)+1}w=f[n>>2]|0;f[n>>2]=t;f[v>>2]=y;if(w|0?(y=w+4|0,v=f[y>>2]|0,f[y>>2]=v+-1,(v|0)==1):0)bi[f[(f[w>>2]|0)+8>>2]&2047](w);w=f[q>>2]|0;if(w|0?(v=w+4|0,y=f[v>>2]|0,f[v>>2]=y+-1,(y|0)==1):0)bi[f[(f[w>>2]|0)+8>>2]&2047](w)}else{f[r+8>>2]=0;f[r+12>>2]=0;f[r>>2]=16842752;f[r+4>>2]=m;f[s>>2]=f[g>>2];f[s+4>>2]=f[z>>2];pka(q,c,d,r,s);s=f[q>>2]|0;z=f[q+4>>2]|0;if(s|0){g=s+4|0;f[g>>2]=(f[g>>2]|0)+1}g=f[o>>2]|0;f[o>>2]=s;f[x>>2]=z;if(g|0?(z=g+4|0,x=f[z>>2]|0,f[z>>2]=x+-1,(x|0)==1):0)bi[f[(f[g>>2]|0)+8>>2]&2047](g);g=f[q>>2]|0;if(g|0?(x=g+4|0,z=f[x>>2]|0,f[x>>2]=z+-1,(z|0)==1):0)bi[f[(f[g>>2]|0)+8>>2]&2047](g)}F=+p[j>>3];p[q>>3]=F;G=+p[j+8>>3];g=q+8|0;p[g>>3]=G;H=+p[j+16>>3];z=q+16|0;p[z>>3]=H;I=+p[j+24>>3];j=q+24|0;p[j>>3]=I;do if(((h|0)==0|(i|0)==0)&F==1797693134862315708145274.0e284&G==1797693134862315708145274.0e284?!(I!=1797693134862315708145274.0e284|H!=1797693134862315708145274.0e284):0){x=d&7;s=(x|2|0)==2;w=(x|0)==3;y=(x|0)==5;x=d&255;switch(x&7){case 0:case 2:case 3:case 5:case 6:break;default:{f[r>>2]=0;f[r+4>>2]=0;C=aD(r,66)|0;D=265371;E=C+66|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,r,265438,260129,1006);bD(r)}}if(c|0){J=s?0.0:w?-32768.0:y?-3402823466385288598117041.0e14:-1797693134862315708145274.0e284;p[q>>3]=J;p[g>>3]=J;p[z>>3]=J;p[j>>3]=J;break}switch(x&7){case 0:{K=255.0;break}case 2:{K=65535.0;break}default:K=w?32767.0:y?3402823466385288598117041.0e14:1797693134862315708145274.0e284}p[q>>3]=K;p[g>>3]=K;p[z>>3]=K;p[j>>3]=K}while(0);j=L5b(200)|0;d8(j,o,l,n,d,d,d,h,i,q);q=L5b(16)|0;f[q+4>>2]=1;f[q>>2]=53340;f[q+8>>2]=j;f[a>>2]=q;f[a+4>>2]=j;j=f[o>>2]|0;if(j|0?(o=j+4|0,a=f[o>>2]|0,f[o>>2]=a+-1,(a|0)==1):0)bi[f[(f[j>>2]|0)+8>>2]&2047](j);j=f[n>>2]|0;if(j|0?(n=j+4|0,a=f[n>>2]|0,f[n>>2]=a+-1,(a|0)==1):0)bi[f[(f[j>>2]|0)+8>>2]&2047](j);j=f[l>>2]|0;if(j|0?(l=j+4|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)bi[f[(f[j>>2]|0)+8>>2]&2047](j);j=m+36|0;a=f[j>>2]|0;if(a|0?(l=a+12|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)kL(m);f[j>>2]=0;j=m+16|0;a=m+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[a>>2]|0)>0){j=f[B>>2]|0;B=0;do{f[j+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[a>>2]|0))}a=f[m+44>>2]|0;if((a|0)==(m+48|0)){u=k;return}UC(a);u=k;return}function xla(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=u;u=u+16|0;h=g;if(c>>>0>=3){f[h>>2]=0;f[h+4>>2]=0;i=aD(h,69)|0;j=265461;k=i+69|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,h,265531,260129,1030);bD(h)}l=f[e>>2]|0;m=e+4|0;n=f[m>>2]|0;o=f[d>>2]|0;p=d+4|0;q=f[p>>2]|0;r=(l|0)==-1?(o|0)/2|0:l;l=(n|0)==-1?(q|0)/2|0:n;if((r|0)>-1&(r|0)<(o|0)?!((l|0)<0|(l|0)>=(q|0)):0)s=o;else{f[h>>2]=0;f[h+4>>2]=0;i=aD(h,52)|0;j=263653;k=i+52|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,h,263706,263722,363);bD(h);s=f[d>>2]|0}f[e>>2]=r;f[m>>2]=l;l=f[p>>2]|0;r=(s|0)==1&(l|0)==1?0:c;if((r|0)==2){c=(l|0)/2|0;t=+(c|0);v=(l+1|0)>>>0>2?1.0/(t*t):0.0;w=(s|0)/2|0;x=c}else{v=0.0;w=0;x=0}f[a>>2]=1124007936;c=a+8|0;j=a+40|0;i=a+4|0;k=i+36|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(k|0));f[j>>2]=c;c=a+48|0;j=a+44|0;f[j>>2]=c;f[c>>2]=0;f[a+52>>2]=0;f[h>>2]=l;f[h+4>>2]=s;hL(a,2,h,0);if((f[p>>2]|0)<=0){u=g;return}h=a+16|0;t=+(w|0);a=Y(x,x)|0;if(!r){s=0;l=f[d>>2]|0;while(1){c=(f[h>>2]|0)+(Y(f[f[j>>2]>>2]|0,s)|0)|0;if((l|0)>0){Nac(c|0,1,l|0)|0;y=l;z=f[d>>2]|0}else{y=0;z=l}if((y|0)<(z|0)){i=y;do{b[c+i>>0]=0;i=i+1|0;k=f[d>>2]|0}while((i|0)<(k|0));A=k}else A=z;s=s+1|0;if((s|0)>=(f[p>>2]|0))break;else l=A}u=g;return}A=(r|0)==1;r=0;do{l=f[h>>2]|0;s=Y(f[f[j>>2]>>2]|0,r)|0;z=l+s|0;do if(A)if((r|0)!=(f[m>>2]|0)){y=f[e>>2]|0;i=y+1|0;if((y|0)>0){B=i;C=y;D=23;break}else{E=0;F=i;D=24;break}}else{E=0;F=f[d>>2]|0;D=24;break}else{i=r-x|0;if((((i|0)>-1?i:0-i|0)|0)<=(x|0)){y=MVb(t*+M(+(v*+(a-(Y(i,i)|0)|0))))|0;i=w-y|0;c=y+w|0;y=f[d>>2]|0;k=(y|0)<=(c|0)?y:c+1|0;if((i|0)>0){B=k;C=i;D=23}else{E=0;F=k;D=24}}else G=0}while(0);if((D|0)==23){D=0;Nac(z|0,0,C|0)|0;E=C;F=B;D=24}if((D|0)==24){D=0;if((F|0)>(E|0)){Nac(l+(E+s)|0,1,F-E|0)|0;G=F}else G=E}if((G|0)<(f[d>>2]|0)){k=G;do{b[z+k>>0]=0;k=k+1|0}while((k|0)<(f[d>>2]|0))}r=r+1|0}while((r|0)<(f[p>>2]|0));u=g;return}function yla(a,b,c,d,e,g,h,i,j,k,l,m,n,o,q,r,s,t,v,w,x,y,z,A,B,C,D,E){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;q=q|0;r=r|0;s=s|0;t=t|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;var F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0;E=u;u=u+224|0;F=E+168|0;G=E+160|0;H=E+152|0;I=E+96|0;J=E+88|0;K=E;L=E+80|0;M=E+72|0;N=E+64|0;O=E+56|0;f[G>>2]=x;f[G+4>>2]=y;JF(F,G,t,v,w);P=+p[C>>3];Q=+p[C+8>>3];R=+p[C+16>>3];S=+p[C+24>>3];f[I+8>>2]=0;f[I+12>>2]=0;f[I>>2]=16842752;f[I+4>>2]=F;f[J>>2]=z;f[J+4>>2]=A;p[K>>3]=P;p[K+8>>3]=Q;p[K+16>>3]=R;p[K+24>>3]=S;wla(H,a,b,I,J,B,B,K);f[L>>2]=i;f[L+4>>2]=j;JF(I,L,b,d,e);f[M>>2]=i;f[M+4>>2]=j;JF(K,M,c,g,h);f[N>>2]=m;f[N+4>>2]=n;f[O>>2]=k;f[O+4>>2]=l;l=f[H+4>>2]|0;uh[f[(f[l>>2]|0)+20>>2]&255](l,I,K,O,N);f[N>>2]=r;f[N+4>>2]=s;f[O>>2]=o;f[O+4>>2]=q;if((D|0)>1){q=1;do{uh[f[(f[l>>2]|0)+20>>2]&255](l,K,K,O,N);q=q+1|0}while((q|0)<(D|0))}D=K+36|0;q=f[D>>2]|0;if(q|0?(N=q+12|0,q=f[N>>2]|0,f[N>>2]=q+-1,(q|0)==1):0)kL(K);f[D>>2]=0;D=K+16|0;q=K+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[q>>2]|0)>0){D=f[K+40>>2]|0;N=0;do{f[D+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[q>>2]|0))}q=f[K+44>>2]|0;if((q|0)!=(K+48|0))UC(q);q=I+36|0;K=f[q>>2]|0;if(K|0?(N=K+12|0,K=f[N>>2]|0,f[N>>2]=K+-1,(K|0)==1):0)kL(I);f[q>>2]=0;q=I+16|0;K=I+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[K>>2]|0)>0){q=f[I+40>>2]|0;N=0;do{f[q+(N<<2)>>2]=0;N=N+1|0}while((N|0)<(f[K>>2]|0))}K=f[I+44>>2]|0;if((K|0)!=(I+48|0))UC(K);K=f[H>>2]|0;if(K|0?(H=K+4|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)bi[f[(f[K>>2]|0)+8>>2]&2047](K);K=F+36|0;I=f[K>>2]|0;if(I|0?(H=I+12|0,I=f[H>>2]|0,f[H>>2]=I+-1,(I|0)==1):0)kL(F);f[K>>2]=0;K=F+16|0;I=F+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[I>>2]|0)>0){K=f[F+40>>2]|0;H=0;do{f[K+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[I>>2]|0))}I=f[F+44>>2]|0;if((I|0)==(F+48|0)){u=E;return}UC(I);u=E;return}function zla(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;dQ(j,58700);f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];Ala(0,a,b,c,k,e,g,h);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function Ala(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0;k=u;u=u+256|0;l=k+192|0;m=k+184|0;n=k+128|0;o=k+120|0;p=k+112|0;q=k+104|0;r=k+96|0;s=k+32|0;t=k+40|0;v=k+24|0;w=k+16|0;x=k+8|0;y=k;dQ(m,58720);do if((yM(e)|0)==65536){z=f[e+4>>2]|0;f[n>>2]=f[z>>2];A=n+4|0;B=z+4|0;f[A>>2]=f[B>>2];C=n+8|0;f[C>>2]=f[z+8>>2];f[n+12>>2]=f[z+12>>2];D=n+16|0;f[D>>2]=f[z+16>>2];f[n+20>>2]=f[z+20>>2];f[n+24>>2]=f[z+24>>2];f[n+28>>2]=f[z+28>>2];f[n+32>>2]=f[z+32>>2];E=f[z+36>>2]|0;f[n+36>>2]=E;f[n+40>>2]=C;C=n+48|0;F=n+44|0;f[F>>2]=C;f[C>>2]=0;f[n+52>>2]=0;if(E|0){C=E+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[z+44>>2]|0;C=f[F>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];G=D;break}else{f[A>>2]=0;jL(n,z);G=D;break}}else{yL(n,e,-1);G=n+16|0}while(0);if(f[G>>2]|0){e=f[n+4>>2]|0;if((e|0)<3)H=Y(f[n+12>>2]|0,f[n+8>>2]|0)|0;else{D=f[n+40>>2]|0;z=0;A=1;while(1){B=Y(f[D+(z<<2)>>2]|0,A)|0;z=z+1|0;if((z|0)==(e|0)){H=B;break}else A=B}}if(!((e|0)==0|(H|0)==0)){H=f[n+40>>2]|0;I=f[H+4>>2]|0;J=f[H>>2]|0}else{I=3;J=3}}else{I=3;J=3}H=f[g>>2]|0;e=g+4|0;A=f[e>>2]|0;z=(H|0)==-1?(I|0)/2|0:H;H=(A|0)==-1?(J|0)/2|0:A;if(!((z|0)>-1&(z|0)<(I|0)?!((H|0)<0|(H|0)>=(J|0)):0)){f[l>>2]=0;f[l+4>>2]=0;A=aD(l,52)|0;D=263653;B=A+52|0;do{b[A>>0]=b[D>>0]|0;A=A+1|0;D=D+1|0}while((A|0)<(B|0));bO(-215,l,263706,263722,363);bD(l)}f[g>>2]=z;f[e>>2]=H;if((h|0)!=0?(H=n+8|0,z=n+12|0,D=Y(f[z>>2]|0,f[H>>2]|0)|0,(D|0)!=1):0){if(f[G>>2]|0){A=n+4|0;B=f[A>>2]|0;if((B|0)<3)K=D;else{D=f[n+40>>2]|0;C=0;F=1;while(1){E=Y(f[D+(C<<2)>>2]|0,F)|0;C=C+1|0;if((C|0)==(B|0)){K=E;break}else F=E}}if(!((B|0)==0|(K|0)==0))if((h|0)>1?(f[l+8>>2]=0,f[l+12>>2]=0,f[l>>2]=16842752,f[l+4>>2]=n,K=nG(l)|0,(K|0)==(Y(f[z>>2]|0,f[H>>2]|0)|0)):0){K=Y(f[g>>2]|0,h)|0;B=Y(f[e>>2]|0,h)|0;f[g>>2]=K;f[e>>2]=B;F=h+-1|0;C=(Y(I+-1|0,F)|0)+I|0;I=(Y(J+-1|0,F)|0)+J|0;f[q>>2]=C;f[q+4>>2]=I;f[r>>2]=K;f[r+4>>2]=B;xla(l,0,q,r);r=l+36|0;q=f[r>>2]|0;if(q|0){B=q+12|0;f[B>>2]=(f[B>>2]|0)+1}B=n+36|0;q=f[B>>2]|0;if(q|0?(K=q+12|0,q=f[K>>2]|0,f[K>>2]=q+-1,(q|0)==1):0)kL(n);f[B>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[A>>2]|0)>0){q=f[n+40>>2]|0;K=0;do{f[q+(K<<2)>>2]=0;K=K+1|0;L=f[A>>2]|0}while((K|0)<(L|0));f[n>>2]=f[l>>2];if((L|0)<3)M=60;else M=62}else{f[n>>2]=f[l>>2];M=60}if((M|0)==60){L=f[l+4>>2]|0;if((L|0)<3){f[A>>2]=L;f[H>>2]=f[l+8>>2];f[z>>2]=f[l+12>>2];L=f[l+44>>2]|0;A=f[n+44>>2]|0;f[A>>2]=f[L>>2];f[A+4>>2]=f[L+4>>2]}else M=62}if((M|0)==62)jL(n,l);L=l+16|0;f[G>>2]=f[L>>2];f[n+20>>2]=f[l+20>>2];f[n+24>>2]=f[l+24>>2];f[n+28>>2]=f[l+28>>2];f[n+32>>2]=f[l+32>>2];A=f[r>>2]|0;f[B>>2]=A;if(A|0?(B=A+12|0,A=f[B>>2]|0,f[B>>2]=A+-1,(A|0)==1):0)kL(l);f[r>>2]=0;r=l+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[r>>2]|0)>0){L=f[l+40>>2]|0;A=0;do{f[L+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[r>>2]|0))}r=f[l+44>>2]|0;if((r|0)!=(l+48|0))UC(r);N=1}else N=h;else M=26}else M=26;if((M|0)==26){r=h<<1|1;f[o>>2]=r;f[o+4>>2]=r;f[p>>2]=-1;f[p+4>>2]=-1;xla(l,0,o,p);p=l+36|0;o=f[p>>2]|0;if(o|0){r=o+12|0;f[r>>2]=(f[r>>2]|0)+1}r=n+36|0;o=f[r>>2]|0;if(o|0?(A=o+12|0,o=f[A>>2]|0,f[A>>2]=o+-1,(o|0)==1):0)kL(n);f[r>>2]=0;o=n+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[o>>2]|0)>0){A=f[n+40>>2]|0;L=0;do{f[A+(L<<2)>>2]=0;L=L+1|0;O=f[o>>2]|0}while((L|0)<(O|0));f[n>>2]=f[l>>2];if((O|0)<3)M=36;else M=38}else{f[n>>2]=f[l>>2];M=36}if((M|0)==36){O=f[l+4>>2]|0;if((O|0)<3){f[o>>2]=O;f[H>>2]=f[l+8>>2];f[z>>2]=f[l+12>>2];O=f[l+44>>2]|0;o=f[n+44>>2]|0;f[o>>2]=f[O>>2];f[o+4>>2]=f[O+4>>2]}else M=38}if((M|0)==38)jL(n,l);M=l+16|0;f[G>>2]=f[M>>2];f[n+20>>2]=f[l+20>>2];f[n+24>>2]=f[l+24>>2];f[n+28>>2]=f[l+28>>2];f[n+32>>2]=f[l+32>>2];O=f[p>>2]|0;f[r>>2]=O;if(O|0?(r=O+12|0,O=f[r>>2]|0,f[r>>2]=O+-1,(O|0)==1):0)kL(l);f[p>>2]=0;p=l+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[p>>2]|0)>0){M=f[l+40>>2]|0;O=0;do{f[M+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[p>>2]|0))}p=f[l+44>>2]|0;if((p|0)!=(l+48|0))UC(p);f[g>>2]=h;f[e>>2]=h;N=1}do if((yM(c)|0)==65536){h=f[c+4>>2]|0;f[l>>2]=f[h>>2];p=l+4|0;O=h+4|0;f[p>>2]=f[O>>2];M=l+8|0;f[M>>2]=f[h+8>>2];f[l+12>>2]=f[h+12>>2];f[l+16>>2]=f[h+16>>2];f[l+20>>2]=f[h+20>>2];f[l+24>>2]=f[h+24>>2];f[l+28>>2]=f[h+28>>2];f[l+32>>2]=f[h+32>>2];r=f[h+36>>2]|0;f[l+36>>2]=r;o=l+40|0;f[o>>2]=M;M=l+48|0;L=l+44|0;f[L>>2]=M;f[M>>2]=0;f[l+52>>2]=0;if(r|0){M=r+12|0;f[M>>2]=(f[M>>2]|0)+1}if((f[O>>2]|0)<3){O=f[h+44>>2]|0;M=f[L>>2]|0;f[M>>2]=f[O>>2];f[M+4>>2]=f[O+4>>2];P=o;Q=l;break}else{f[p>>2]=0;jL(l,h);P=o;Q=l;break}}else{yL(l,c,-1);P=l+40|0;Q=l}while(0);o=f[P>>2]|0;h=f[o>>2]|0;f[s>>2]=f[o+4>>2];f[s+4>>2]=h;vM(d,s,f[Q>>2]&4095,-1,0,0);do if((yM(d)|0)==65536){s=f[d+4>>2]|0;f[t>>2]=f[s>>2];h=t+4|0;o=s+4|0;f[h>>2]=f[o>>2];p=t+8|0;f[p>>2]=f[s+8>>2];O=t+12|0;f[O>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];f[t+32>>2]=f[s+32>>2];M=f[s+36>>2]|0;f[t+36>>2]=M;f[t+40>>2]=p;L=t+48|0;r=t+44|0;f[r>>2]=L;f[L>>2]=0;f[t+52>>2]=0;if(M|0){L=M+12|0;f[L>>2]=(f[L>>2]|0)+1}if((f[o>>2]|0)<3){o=f[s+44>>2]|0;L=f[r>>2]|0;f[L>>2]=f[o>>2];f[L+4>>2]=f[o+4>>2];R=O;S=p;break}else{f[h>>2]=0;jL(t,s);R=O;S=p;break}}else{yL(t,d,-1);R=t+12|0;S=t+8|0}while(0);f[v>>2]=0;p=v+4|0;f[p>>2]=0;O=l+12|0;s=f[O>>2]|0;h=l+8|0;o=f[h>>2]|0;f[w>>2]=s;L=w+4|0;f[L>>2]=o;f[x>>2]=0;r=x+4|0;f[r>>2]=0;M=f[R>>2]|0;R=f[S>>2]|0;f[y>>2]=M;S=y+4|0;f[S>>2]=R;A=(i&16|0)!=0;if(A){T=s;U=o;V=s;W=o;X=0;Z=0;_=M;$=R;aa=0;ba=0}else{uL(l,w,v);uL(t,y,x);T=f[O>>2]|0;U=f[h>>2]|0;V=f[w>>2]|0;W=f[L>>2]|0;X=f[v>>2]|0;Z=f[p>>2]|0;_=f[y>>2]|0;$=f[S>>2]|0;aa=f[x>>2]|0;ba=f[r>>2]|0}r=f[Q>>2]|0;Q=l+16|0;x=l+48|0;S=t+16|0;y=t+48|0;yla(a,r&4095,f[t>>2]&4095,f[Q>>2]|0,f[x>>2]|0,f[S>>2]|0,f[y>>2]|0,T,U,V,W,X,Z,_,$,aa,ba,f[n>>2]&4095,f[G>>2]|0,f[n+48>>2]|0,f[z>>2]|0,f[H>>2]|0,f[g>>2]|0,f[e>>2]|0,i&-17,j,N,(r&32768|0)!=0&(A^1));A=t+36|0;r=f[A>>2]|0;if(r|0?(N=r+12|0,r=f[N>>2]|0,f[N>>2]=r+-1,(r|0)==1):0)kL(t);f[A>>2]=0;A=t+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[A>>2]|0)>0){S=f[t+40>>2]|0;r=0;do{f[S+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[A>>2]|0))}A=f[t+44>>2]|0;if((A|0)!=(y|0))UC(A);A=l+36|0;y=f[A>>2]|0;if(y|0?(t=y+12|0,y=f[t>>2]|0,f[t>>2]=y+-1,(y|0)==1):0)kL(l);f[A>>2]=0;A=l+4|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[A>>2]|0)>0){Q=f[P>>2]|0;P=0;do{f[Q+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[A>>2]|0))}A=f[l+44>>2]|0;if((A|0)!=(x|0))UC(A)}else JM(c,d);d=n+36|0;c=f[d>>2]|0;if(c|0?(A=c+12|0,c=f[A>>2]|0,f[A>>2]=c+-1,(c|0)==1):0)kL(n);f[d>>2]=0;d=n+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[d>>2]|0)>0){G=f[n+40>>2]|0;c=0;do{f[G+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[n+44>>2]|0;if((d|0)!=(n+48|0))UC(d);if(!(f[m+4>>2]|0)){u=k;return}u=k;return}function Bla(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0;i=u;u=u+16|0;j=i+8|0;k=i;dQ(j,58740);f[k>>2]=f[d>>2];f[k+4>>2]=f[d+4>>2];Ala(1,a,b,c,k,e,g,h);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function Cla(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;k=u;u=u+832|0;l=k;m=k+808|0;n=k+728|0;o=k+720|0;p=k+664|0;q=k+800|0;r=k+792|0;s=k+608|0;t=k+552|0;v=k+784|0;w=k+496|0;x=k+440|0;y=k+384|0;z=k+328|0;A=k+272|0;B=k+256|0;C=k+240|0;D=k+224|0;dQ(o,58760);do if((yM(e)|0)==65536){E=f[e+4>>2]|0;f[p>>2]=f[E>>2];F=p+4|0;G=E+4|0;f[F>>2]=f[G>>2];H=p+8|0;f[H>>2]=f[E+8>>2];f[p+12>>2]=f[E+12>>2];I=p+16|0;f[I>>2]=f[E+16>>2];f[p+20>>2]=f[E+20>>2];f[p+24>>2]=f[E+24>>2];f[p+28>>2]=f[E+28>>2];f[p+32>>2]=f[E+32>>2];J=f[E+36>>2]|0;f[p+36>>2]=J;f[p+40>>2]=H;H=p+48|0;K=p+44|0;f[K>>2]=H;f[H>>2]=0;f[p+52>>2]=0;if(J|0){H=J+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[G>>2]|0)<3){G=f[E+44>>2]|0;H=f[K>>2]|0;f[H>>2]=f[G>>2];f[H+4>>2]=f[G+4>>2];L=I;break}else{f[F>>2]=0;jL(p,E);L=I;break}}else{yL(p,e,-1);L=p+16|0}while(0);if(f[L>>2]|0){e=f[p+4>>2]|0;if((e|0)<3)M=Y(f[p+12>>2]|0,f[p+8>>2]|0)|0;else{I=f[p+40>>2]|0;E=0;F=1;while(1){G=Y(f[I+(E<<2)>>2]|0,F)|0;E=E+1|0;if((E|0)==(e|0)){M=G;break}else F=G}}if((e|0)==0|(M|0)==0)N=14}else N=14;if((N|0)==14){f[q>>2]=3;f[q+4>>2]=3;f[r>>2]=1;f[r+4>>2]=1;xla(l,0,q,r);r=l+36|0;q=f[r>>2]|0;if(q|0){M=q+12|0;f[M>>2]=(f[M>>2]|0)+1}M=p+36|0;q=f[M>>2]|0;if(q|0?(e=q+12|0,q=f[e>>2]|0,f[e>>2]=q+-1,(q|0)==1):0)kL(p);f[M>>2]=0;q=p+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[q>>2]|0)>0){e=f[p+40>>2]|0;F=0;do{f[e+(F<<2)>>2]=0;F=F+1|0;O=f[q>>2]|0}while((F|0)<(O|0));f[p>>2]=f[l>>2];if((O|0)<3)N=24;else N=26}else{f[p>>2]=f[l>>2];N=24}if((N|0)==24){O=f[l+4>>2]|0;if((O|0)<3){f[q>>2]=O;f[p+8>>2]=f[l+8>>2];f[p+12>>2]=f[l+12>>2];O=f[l+44>>2]|0;q=f[p+44>>2]|0;f[q>>2]=f[O>>2];f[q+4>>2]=f[O+4>>2]}else N=26}if((N|0)==26)jL(p,l);O=l+16|0;f[L>>2]=f[O>>2];f[p+20>>2]=f[l+20>>2];f[p+24>>2]=f[l+24>>2];f[p+28>>2]=f[l+28>>2];f[p+32>>2]=f[l+32>>2];q=f[r>>2]|0;f[M>>2]=q;if(q|0?(M=q+12|0,q=f[M>>2]|0,f[M>>2]=q+-1,(q|0)==1):0)kL(l);f[r>>2]=0;r=l+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[r>>2]|0)>0){O=f[l+40>>2]|0;q=0;do{f[O+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[r>>2]|0))}r=f[l+44>>2]|0;if((r|0)!=(l+48|0))UC(r)}do if((yM(a)|0)==65536){r=f[a+4>>2]|0;f[s>>2]=f[r>>2];q=s+4|0;O=r+4|0;f[q>>2]=f[O>>2];M=s+8|0;f[M>>2]=f[r+8>>2];f[s+12>>2]=f[r+12>>2];f[s+16>>2]=f[r+16>>2];f[s+20>>2]=f[r+20>>2];f[s+24>>2]=f[r+24>>2];f[s+28>>2]=f[r+28>>2];f[s+32>>2]=f[r+32>>2];F=f[r+36>>2]|0;f[s+36>>2]=F;e=s+40|0;f[e>>2]=M;M=s+48|0;E=s+44|0;f[E>>2]=M;f[M>>2]=0;f[s+52>>2]=0;if(F|0){M=F+12|0;f[M>>2]=(f[M>>2]|0)+1}if((f[O>>2]|0)<3){O=f[r+44>>2]|0;M=f[E>>2]|0;f[M>>2]=f[O>>2];f[M+4>>2]=f[O+4>>2];P=e;Q=s;break}else{f[q>>2]=0;jL(s,r);P=e;Q=s;break}}else{yL(s,a,-1);P=s+40|0;Q=s}while(0);f[t>>2]=1124007936;a=t+4|0;e=t+8|0;r=t+40|0;q=a;O=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(O|0));f[r>>2]=e;M=t+48|0;E=t+44|0;f[E>>2]=M;f[M>>2]=0;f[t+52>>2]=0;F=f[P>>2]|0;I=f[F>>2]|0;f[v>>2]=f[F+4>>2];f[v+4>>2]=I;vM(c,v,f[Q>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){v=f[c+4>>2]|0;f[w>>2]=f[v>>2];I=w+4|0;F=v+4|0;f[I>>2]=f[F>>2];G=w+8|0;f[G>>2]=f[v+8>>2];f[w+12>>2]=f[v+12>>2];f[w+16>>2]=f[v+16>>2];f[w+20>>2]=f[v+20>>2];f[w+24>>2]=f[v+24>>2];f[w+28>>2]=f[v+28>>2];f[w+32>>2]=f[v+32>>2];H=f[v+36>>2]|0;f[w+36>>2]=H;f[w+40>>2]=G;G=w+48|0;K=w+44|0;f[K>>2]=G;f[G>>2]=0;f[w+52>>2]=0;if(H|0){G=H+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[v+44>>2]|0;G=f[K>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];break}else{f[I>>2]=0;jL(w,v);break}}else yL(w,c,-1);while(0);a:do switch(d|0){case 0:{f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;c=x+8|0;f[c>>2]=0;f[c+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;c=f[g>>2]|0;v=f[g+4>>2]|0;dQ(l,58700);f[m>>2]=c;f[m+4>>2]=v;Ala(0,n,x,y,m,h,i,j);break}case 1:{f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;v=x+8|0;f[v>>2]=0;f[v+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;v=f[g>>2]|0;c=f[g+4>>2]|0;dQ(l,58740);f[m>>2]=v;f[m+4>>2]=c;Ala(1,n,x,y,m,h,i,j);break}case 2:{f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;c=x+8|0;f[c>>2]=0;f[c+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;c=f[g>>2]|0;v=g+4|0;I=f[v>>2]|0;dQ(l,58700);f[m>>2]=c;f[m+4>>2]=I;Ala(0,n,x,y,m,h,i,j);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=w;I=x+8|0;f[I>>2]=0;f[I+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;I=f[g>>2]|0;c=f[v>>2]|0;dQ(l,58740);f[m>>2]=I;f[m+4>>2]=c;Ala(1,n,x,y,m,h,i,j);break}case 3:{f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;c=x+8|0;f[c>>2]=0;f[c+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;c=f[g>>2]|0;I=g+4|0;v=f[I>>2]|0;dQ(l,58740);f[m>>2]=c;f[m+4>>2]=v;Ala(1,n,x,y,m,h,i,j);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=w;v=x+8|0;f[v>>2]=0;f[v+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;v=f[g>>2]|0;c=f[I>>2]|0;dQ(l,58700);f[m>>2]=v;f[m+4>>2]=c;Ala(0,n,x,y,m,h,i,j);break}case 4:{f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;c=x+8|0;f[c>>2]=0;f[c+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=t;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;c=f[g>>2]|0;v=g+4|0;I=f[v>>2]|0;dQ(l,58700);f[m>>2]=c;f[m+4>>2]=I;Ala(0,n,x,y,m,h,i,j);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;I=x+8|0;f[I>>2]=0;f[I+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=w;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;I=f[g>>2]|0;c=f[v>>2]|0;dQ(l,58740);f[m>>2]=I;f[m+4>>2]=c;Ala(1,n,x,y,m,h,i,j);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=w;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=t;c=n+8|0;f[c>>2]=0;f[c+4>>2]=0;f[n>>2]=33619968;f[n+4>>2]=w;jE(l,m,n,UM()|0,-1);break}case 5:{c=w+16|0;if((f[s+16>>2]|0)!=(f[c>>2]|0)){I=w+36|0;v=f[I>>2]|0;if(v|0){F=v+12|0;f[F>>2]=(f[F>>2]|0)+1}F=t+36|0;v=f[F>>2]|0;if(v|0?(G=v+12|0,v=f[G>>2]|0,f[G>>2]=v+-1,(v|0)==1):0)kL(t);f[F>>2]=0;v=t+16|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[a>>2]|0)>0){G=f[r>>2]|0;K=0;do{f[G+(K<<2)>>2]=0;K=K+1|0;R=f[a>>2]|0}while((K|0)<(R|0));f[t>>2]=f[w>>2];if((R|0)<3)N=83;else N=85}else{f[t>>2]=f[w>>2];N=83}if((N|0)==83){K=f[w+4>>2]|0;if((K|0)<3){f[a>>2]=K;f[e>>2]=f[w+8>>2];f[t+12>>2]=f[w+12>>2];K=f[w+44>>2]|0;G=f[E>>2]|0;f[G>>2]=f[K>>2];f[G+4>>2]=f[K+4>>2]}else N=85}if((N|0)==85)jL(t,w);f[v>>2]=f[c>>2];f[t+20>>2]=f[w+20>>2];f[t+24>>2]=f[w+24>>2];f[t+28>>2]=f[w+28>>2];f[t+32>>2]=f[w+32>>2];f[F>>2]=f[I>>2]}f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;K=x+8|0;f[K>>2]=0;f[K+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=t;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;K=f[g>>2]|0;G=g+4|0;H=f[G>>2]|0;dQ(l,58700);f[m>>2]=K;f[m+4>>2]=H;Ala(0,n,x,y,m,h,i,j);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=t;H=x+8|0;f[H>>2]=0;f[H+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=t;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;H=f[g>>2]|0;K=f[G>>2]|0;dQ(l,58740);f[m>>2]=H;f[m+4>>2]=K;Ala(1,n,x,y,m,h,i,j);wS(l,s,t);K=f[l>>2]|0;th[f[(f[K>>2]|0)+12>>2]&511](K,l,w,-1);Wi(l);break}case 6:{K=w+16|0;if((f[s+16>>2]|0)!=(f[K>>2]|0)){H=w+36|0;G=f[H>>2]|0;if(G|0){J=G+12|0;f[J>>2]=(f[J>>2]|0)+1}J=t+36|0;G=f[J>>2]|0;if(G|0?(S=G+12|0,G=f[S>>2]|0,f[S>>2]=G+-1,(G|0)==1):0)kL(t);f[J>>2]=0;G=t+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[a>>2]|0)>0){S=f[r>>2]|0;T=0;do{f[S+(T<<2)>>2]=0;T=T+1|0;U=f[a>>2]|0}while((T|0)<(U|0));f[t>>2]=f[w>>2];if((U|0)<3)N=103;else N=105}else{f[t>>2]=f[w>>2];N=103}if((N|0)==103){T=f[w+4>>2]|0;if((T|0)<3){f[a>>2]=T;f[e>>2]=f[w+8>>2];f[t+12>>2]=f[w+12>>2];T=f[w+44>>2]|0;S=f[E>>2]|0;f[S>>2]=f[T>>2];f[S+4>>2]=f[T+4>>2]}else N=105}if((N|0)==105)jL(t,w);f[G>>2]=f[K>>2];f[t+20>>2]=f[w+20>>2];f[t+24>>2]=f[w+24>>2];f[t+28>>2]=f[w+28>>2];f[t+32>>2]=f[w+32>>2];f[J>>2]=f[H>>2]}f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=s;T=x+8|0;f[T>>2]=0;f[T+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=t;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;T=f[g>>2]|0;S=g+4|0;I=f[S>>2]|0;dQ(l,58740);f[m>>2]=T;f[m+4>>2]=I;Ala(1,n,x,y,m,h,i,j);f[n+8>>2]=0;f[n+12>>2]=0;f[n>>2]=16842752;f[n+4>>2]=t;I=x+8|0;f[I>>2]=0;f[I+4>>2]=0;f[x>>2]=33619968;f[x+4>>2]=t;f[y+8>>2]=0;f[y+12>>2]=0;f[y>>2]=16842752;f[y+4>>2]=p;I=f[g>>2]|0;T=f[S>>2]|0;dQ(l,58700);f[m>>2]=I;f[m+4>>2]=T;Ala(0,n,x,y,m,h,i,j);wS(l,t,s);T=f[l>>2]|0;th[f[(f[T>>2]|0)+12>>2]&511](T,l,w,-1);Wi(l);break}case 7:{if(f[Q>>2]&4095|0){f[l>>2]=0;f[l+4>>2]=0;q=aD(l,55)|0;V=271684;O=q+55|0;do{b[q>>0]=b[V>>0]|0;q=q+1|0;V=V+1|0}while((q|0)<(O|0));bO(-215,l,265816,260129,2104);bD(l)}f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=p;if((nG(l)|0)<1){H=l+8|0;f[H>>2]=0;f[H+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=w;SP(s,l);break a}f[n>>2]=1124007936;H=n+4|0;J=n+8|0;K=n+40|0;q=H;O=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(O|0));f[K>>2]=J;G=n+48|0;T=n+44|0;f[T>>2]=G;f[G>>2]=0;f[n+52>>2]=0;f[x>>2]=1124007936;I=x+4|0;S=x+8|0;F=x+40|0;q=I;O=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(O|0));f[F>>2]=S;J=x+48|0;c=x+44|0;f[c>>2]=J;f[J>>2]=0;f[x+52>>2]=0;f[y>>2]=1124007936;v=y+4|0;W=y+8|0;X=y+40|0;q=v;O=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(O|0));f[X>>2]=W;S=y+48|0;Z=y+44|0;f[Z>>2]=S;f[S>>2]=0;f[y+52>>2]=0;f[z>>2]=1124007936;_=z+4|0;$=z+8|0;aa=z+40|0;q=_;O=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(O|0));f[aa>>2]=$;ba=z+48|0;ca=z+44|0;f[ca>>2]=ba;f[ba>>2]=0;f[z+52>>2]=0;IS(l,p,1.0);da=f[l>>2]|0;th[f[(f[da>>2]|0)+12>>2]&511](da,l,n,-1);Wi(l);IS(l,p,-1.0);da=f[l>>2]|0;th[f[(f[da>>2]|0)+12>>2]&511](da,l,x,-1);Wi(l);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=n;if((nG(l)|0)>=1){f[A+8>>2]=0;f[A+12>>2]=0;f[A>>2]=16842752;f[A+4>>2]=s;da=B+8|0;f[da>>2]=0;f[da+4>>2]=0;f[B>>2]=33619968;f[B+4>>2]=y;f[C+8>>2]=0;f[C+12>>2]=0;f[C>>2]=16842752;f[C+4>>2]=n;da=f[g>>2]|0;ea=f[g+4>>2]|0;dQ(l,58700);f[m>>2]=da;f[m+4>>2]=ea;Ala(0,A,B,C,m,h,i,j)}else{ea=s+36|0;da=f[ea>>2]|0;if(da|0){fa=da+12|0;f[fa>>2]=(f[fa>>2]|0)+1}fa=y+36|0;da=f[fa>>2]|0;if(da|0?(ga=da+12|0,da=f[ga>>2]|0,f[ga>>2]=da+-1,(da|0)==1):0)kL(y);f[fa>>2]=0;da=y+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[v>>2]|0)>0){ga=f[X>>2]|0;ha=0;do{f[ga+(ha<<2)>>2]=0;ha=ha+1|0;ia=f[v>>2]|0}while((ha|0)<(ia|0));f[y>>2]=f[Q>>2];if((ia|0)<3)N=127;else N=129}else{f[y>>2]=f[Q>>2];N=127}if((N|0)==127){ha=f[s+4>>2]|0;if((ha|0)<3){f[v>>2]=ha;f[W>>2]=f[s+8>>2];f[y+12>>2]=f[s+12>>2];ha=f[s+44>>2]|0;ga=f[Z>>2]|0;f[ga>>2]=f[ha>>2];f[ga+4>>2]=f[ha+4>>2]}else N=129}if((N|0)==129)jL(y,s);f[da>>2]=f[s+16>>2];f[y+20>>2]=f[s+20>>2];f[y+24>>2]=f[s+24>>2];f[y+28>>2]=f[s+28>>2];f[y+32>>2]=f[s+32>>2];f[fa>>2]=f[ea>>2]}f[A>>2]=1124007936;ha=A+4|0;ga=A+8|0;ja=A+40|0;q=ha;O=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(O|0));f[ja>>2]=ga;ea=A+48|0;fa=A+44|0;f[fa>>2]=ea;f[ea>>2]=0;f[A+52>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=s;da=m+8|0;f[da>>2]=0;f[da+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=A;nD(l,m,UM()|0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=x;if((nG(l)|0)>=1){f[B+8>>2]=0;f[B+12>>2]=0;f[B>>2]=16842752;f[B+4>>2]=A;da=C+8|0;f[da>>2]=0;f[da+4>>2]=0;f[C>>2]=33619968;f[C+4>>2]=z;f[D+8>>2]=0;f[D+12>>2]=0;f[D>>2]=16842752;f[D+4>>2]=x;da=f[g>>2]|0;W=f[g+4>>2]|0;dQ(l,58700);f[m>>2]=da;f[m+4>>2]=W;Ala(0,B,C,D,m,h,i,j)}else{W=A+36|0;da=f[W>>2]|0;if(da|0){ka=da+12|0;f[ka>>2]=(f[ka>>2]|0)+1}ka=z+36|0;da=f[ka>>2]|0;if(da|0?(la=da+12|0,da=f[la>>2]|0,f[la>>2]=da+-1,(da|0)==1):0)kL(z);f[ka>>2]=0;da=z+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[_>>2]|0)>0){la=f[aa>>2]|0;ma=0;do{f[la+(ma<<2)>>2]=0;ma=ma+1|0;na=f[_>>2]|0}while((ma|0)<(na|0));f[z>>2]=f[A>>2];if((na|0)<3)N=145;else N=147}else{f[z>>2]=f[A>>2];N=145}if((N|0)==145){ma=f[ha>>2]|0;if((ma|0)<3){f[_>>2]=ma;f[$>>2]=f[ga>>2];f[z+12>>2]=f[A+12>>2];ma=f[fa>>2]|0;la=f[ca>>2]|0;f[la>>2]=f[ma>>2];f[la+4>>2]=f[ma+4>>2]}else N=147}if((N|0)==147)jL(z,A);f[da>>2]=f[A+16>>2];f[z+20>>2]=f[A+20>>2];f[z+24>>2]=f[A+24>>2];f[z+28>>2]=f[A+28>>2];f[z+32>>2]=f[A+32>>2];f[ka>>2]=f[W>>2]}JS(l,y,z);ma=f[l>>2]|0;th[f[(f[ma>>2]|0)+12>>2]&511](ma,l,w,-1);Wi(l);ma=A+36|0;la=f[ma>>2]|0;if(la|0?(oa=la+12|0,la=f[oa>>2]|0,f[oa>>2]=la+-1,(la|0)==1):0)kL(A);f[ma>>2]=0;ma=A+16|0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ha>>2]|0)>0){ma=f[ja>>2]|0;la=0;do{f[ma+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[ha>>2]|0))}ha=f[fa>>2]|0;if((ha|0)!=(ea|0))UC(ha);ha=z+36|0;la=f[ha>>2]|0;if(la|0?(ma=la+12|0,la=f[ma>>2]|0,f[ma>>2]=la+-1,(la|0)==1):0)kL(z);f[ha>>2]=0;ha=z+16|0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[_>>2]|0)>0){ha=f[aa>>2]|0;la=0;do{f[ha+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[_>>2]|0))}_=f[ca>>2]|0;if((_|0)!=(ba|0))UC(_);_=y+36|0;la=f[_>>2]|0;if(la|0?(ha=la+12|0,la=f[ha>>2]|0,f[ha>>2]=la+-1,(la|0)==1):0)kL(y);f[_>>2]=0;_=y+16|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[v>>2]|0)>0){_=f[X>>2]|0;la=0;do{f[_+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[v>>2]|0))}v=f[Z>>2]|0;if((v|0)!=(S|0))UC(v);v=x+36|0;la=f[v>>2]|0;do if(la|0){_=la+12|0;X=f[_>>2]|0;f[_>>2]=X+-1;if((X|0)!=1)break;kL(x)}while(0);f[v>>2]=0;la=x+16|0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=0;f[la+12>>2]=0;if((f[I>>2]|0)>0){la=f[F>>2]|0;S=0;do{f[la+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[I>>2]|0))}I=f[c>>2]|0;if((I|0)!=(J|0))UC(I);I=n+36|0;S=f[I>>2]|0;do if(S|0){la=S+12|0;F=f[la>>2]|0;f[la>>2]=F+-1;if((F|0)!=1)break;kL(n)}while(0);f[I>>2]=0;S=n+16|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[H>>2]|0)>0){S=f[K>>2]|0;J=0;do{f[S+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[H>>2]|0))}H=f[T>>2]|0;if((H|0)!=(G|0))UC(H);break}default:{f[l>>2]=0;f[l+4>>2]=0;q=aD(l,31)|0;V=265829;O=q+31|0;do{b[q>>0]=b[V>>0]|0;q=q+1|0;V=V+1|0}while((q|0)<(O|0));bO(-5,l,265816,260129,2130);bD(l)}}while(0);l=w+36|0;V=f[l>>2]|0;if(V|0?(q=V+12|0,V=f[q>>2]|0,f[q>>2]=V+-1,(V|0)==1):0)kL(w);f[l>>2]=0;l=w+16|0;V=w+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[V>>2]|0)>0){l=f[w+40>>2]|0;q=0;do{f[l+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[V>>2]|0))}V=f[w+44>>2]|0;if((V|0)!=(w+48|0))UC(V);V=t+36|0;w=f[V>>2]|0;if(w|0?(q=w+12|0,w=f[q>>2]|0,f[q>>2]=w+-1,(w|0)==1):0)kL(t);f[V>>2]=0;V=t+16|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[a>>2]|0)>0){V=f[r>>2]|0;r=0;do{f[V+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[a>>2]|0))}a=f[E>>2]|0;if((a|0)!=(M|0))UC(a);a=s+36|0;M=f[a>>2]|0;if(M|0?(E=M+12|0,M=f[E>>2]|0,f[E>>2]=M+-1,(M|0)==1):0)kL(s);f[a>>2]=0;a=s+16|0;M=s+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[M>>2]|0)>0){a=f[P>>2]|0;P=0;do{f[a+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[M>>2]|0))}M=f[s+44>>2]|0;if((M|0)!=(s+48|0))UC(M);M=p+36|0;s=f[M>>2]|0;if(s|0?(P=s+12|0,s=f[P>>2]|0,f[P>>2]=s+-1,(s|0)==1):0)kL(p);f[M>>2]=0;M=p+4|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[M>>2]|0)>0){L=f[p+40>>2]|0;s=0;do{f[L+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[M>>2]|0))}M=f[p+44>>2]|0;if((M|0)!=(p+48|0))UC(M);if(!(f[o+4>>2]|0)){u=k;return}u=k;return}function Dla(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;d=u;u=u+4256|0;e=d+4240|0;g=d+4184|0;i=d+4128|0;j=d+4112|0;k=d+2064|0;l=d+8|0;m=d;dQ(e,58780);do if((yM(a)|0)==65536){n=f[a+4>>2]|0;f[g>>2]=f[n>>2];o=g+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=g+8|0;f[q>>2]=f[n+8>>2];f[g+12>>2]=f[n+12>>2];f[g+16>>2]=f[n+16>>2];f[g+20>>2]=f[n+20>>2];f[g+24>>2]=f[n+24>>2];f[g+28>>2]=f[n+28>>2];f[g+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[g+36>>2]=r;f[g+40>>2]=q;q=g+48|0;s=g+44|0;f[s>>2]=q;f[q>>2]=0;f[g+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;jL(g,n);break}}else yL(g,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[i>>2]=f[a>>2];n=i+4|0;o=a+4|0;f[n>>2]=f[o>>2];p=i+8|0;f[p>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];q=f[a+36>>2]|0;f[i+36>>2]=q;f[i+40>>2]=p;p=i+48|0;s=i+44|0;f[s>>2]=p;f[p>>2]=0;f[i+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[a+44>>2]|0;p=f[s>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;jL(i,a);break}}else yL(i,c,-1);while(0);c=g+40|0;a=f[c>>2]|0;n=f[a+4>>2]|0;o=f[a>>2]|0;f[j>>2]=0;p=j+4|0;f[p>>2]=0;f[j+8>>2]=0;Nac(k|0,0,2048)|0;if((f[g>>2]&4095|0)==16?(f[i>>2]&4095|0)==4:0)t=a;else{f[m>>2]=0;f[m+4>>2]=0;v=aD(m,114)|0;w=265958;x=v+114|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,m,266073,266083,161);bD(m);t=f[c>>2]|0}a=i+40|0;s=f[a>>2]|0;if(!((f[t>>2]|0)==(f[s>>2]|0)?(f[t+4>>2]|0)==(f[s+4>>2]|0):0)){f[m>>2]=0;f[m+4>>2]=0;v=aD(m,24)|0;w=271940;x=v+24|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,m,266073,266083,162);bD(m)}m=g+16|0;w=f[m>>2]|0;v=g+48|0;x=f[v>>2]|0;s=i+16|0;t=f[s>>2]|0;q=i+48|0;r=f[q>>2]|0;Nac(l|0,0,1024)|0;y=g+44|0;z=i+44|0;A=r>>>2;r=256;do{f[l+(r<<2)>>2]=r+-256;r=r+1|0}while((r|0)!=513);r=o+-1|0;if((n|0)>0){o=Y(A,r)|0;B=0;do{f[t+(B+o<<2)>>2]=-1;f[t+(B<<2)>>2]=-1;B=B+1|0}while((B|0)!=(n|0))}if((r|0)>1){B=n+-1|0;n=(B|0)>1;o=0-A|0;C=0-x|0;D=0;E=t;t=w;w=1;while(1){t=t+x|0;E=E+(A<<2)|0;f[E+(B<<2)>>2]=-1;f[E>>2]=-1;if(n){F=Y(w,A)|0;G=Y(w,x)|0;H=D;I=1;while(1){J=E+(I<<2)|0;K=f[J>>2]|0;if((K|0)>=0)if(!K)L=33;else M=H;else{f[J>>2]=0;L=33}do if((L|0)==33){L=0;if((f[J+-4>>2]|0)>0){K=I*3|0;N=t+K|0;O=N+-3|0;P=(h[N>>0]|0)-(h[O>>0]|0)|0;Q=(h[N+1>>0]|0)-(h[O+1>>0]|0)|0;R=(Q|0)>-1?Q:0-Q|0;Q=(h[N+2>>0]|0)-(h[O+2>>0]|0)|0;O=(Q|0)>-1?Q:0-Q|0;S=O+(f[l+((f[l+(((P|0)>-1?P:0-P|0)+256-R<<2)>>2]|0)+256+R-O<<2)>>2]|0)|0;T=f[J+4>>2]|0;U=N;V=K}else{K=f[J+4>>2]|0;if(((K|0)<=0?(f[J+(o<<2)>>2]|0)<=0:0)?(f[J+(A<<2)>>2]|0)<=0:0){M=H;break}N=I*3|0;S=256;T=K;U=t+N|0;V=N}if((T|0)>0){N=(h[U>>0]|0)-(h[U+3>>0]|0)|0;K=(h[U+1>>0]|0)-(h[U+4>>0]|0)|0;O=(K|0)>-1?K:0-K|0;K=(h[U+2>>0]|0)-(h[U+5>>0]|0)|0;R=(K|0)>-1?K:0-K|0;W=S-(f[l+(S+256-(f[l+((f[l+(((N|0)>-1?N:0-N|0)+256-O<<2)>>2]|0)+256+O-R<<2)>>2]|0)-R<<2)>>2]|0)|0}else W=S;if((f[J+(o<<2)>>2]|0)>0){R=U+C|0;O=(h[U>>0]|0)-(h[R>>0]|0)|0;N=(h[U+1>>0]|0)-(h[R+1>>0]|0)|0;K=(N|0)>-1?N:0-N|0;N=(h[U+2>>0]|0)-(h[R+2>>0]|0)|0;R=(N|0)>-1?N:0-N|0;X=W-(f[l+(W+256-(f[l+((f[l+(((O|0)>-1?O:0-O|0)+256-K<<2)>>2]|0)+256+K-R<<2)>>2]|0)-R<<2)>>2]|0)|0}else X=W;if((f[J+(A<<2)>>2]|0)>0){R=U+x|0;K=(h[U>>0]|0)-(h[R>>0]|0)|0;O=(h[U+1>>0]|0)-(h[R+1>>0]|0)|0;N=(O|0)>-1?O:0-O|0;O=(h[U+2>>0]|0)-(h[R+2>>0]|0)|0;R=(O|0)>-1?O:0-O|0;Z=X-(f[l+(X+256-(f[l+((f[l+(((K|0)>-1?K:0-K|0)+256-N<<2)>>2]|0)+256+N-R<<2)>>2]|0)-R<<2)>>2]|0)|0}else Z=X;if(!H){R=f[p>>2]|0;N=f[j>>2]|0;K=R-N|0;O=(K|0)/12|0;P=O*3|0;Q=(P|0)>257?(P|0)/2|0:128;P=N;N=R;do if(Q>>>0>O>>>0){Ela(j,Q-O|0);L=52}else{if(Q>>>0>=O>>>0){L=52;break}R=P+(Q*12|0)|0;if((N|0)==(R|0)){_=O;$=P;break}f[p>>2]=N+(~(((N+-12-R|0)>>>0)/12|0)*12|0);_=O;$=P}while(0);do if((L|0)==52){L=0;P=f[j>>2]|0;if(K|0){_=O;$=P;break}f[P>>2]=0;_=1;$=P}while(0);O=Q+-1|0;if((_|0)<(O|0)){K=_;do{P=K;K=K+1|0;f[$+(P*12|0)>>2]=K}while((K|0)!=(O|0))}f[$+(O*12|0)>>2]=0;aa=_;ba=$}else{aa=H;ba=f[j>>2]|0}K=ba+(aa*12|0)|0;Q=f[K>>2]|0;f[K>>2]=0;f[ba+(aa*12|0)+4>>2]=I+F;f[ba+(aa*12|0)+8>>2]=V+G;K=k+(Z<<3)+4|0;P=f[K>>2]|0;f[((P|0)==0?k+(Z<<3)|0:(f[j>>2]|0)+(P*12|0)|0)>>2]=aa;f[K>>2]=aa;f[J>>2]=-2;M=Q}while(0);I=I+1|0;if((I|0)>=(B|0)){ca=M;break}else H=M}}else ca=D;w=w+1|0;if((w|0)>=(r|0)){da=ca;break}else D=ca}}else da=0;ca=0;while(1){if(f[k+(ca<<3)>>2]|0){ea=ca;L=63;break}ca=ca+1|0;if((ca|0)>=256){L=62;break}}if((L|0)==62?(ca|0)!=256:0){ea=ca;L=63}a:do if((L|0)==63){ca=f[m>>2]|0;D=f[s>>2]|0;r=0-A|0;w=0-x|0;M=ea;B=da;while(1){aa=f[k+(M<<3)>>2]|0;b:do if(!aa){Z=M;while(1){fa=Z+1|0;if((fa|0)>=256)break;V=f[k+(fa<<3)>>2]|0;if(!V)Z=fa;else{ga=fa;ha=V;break b}}if((fa|0)==256)break a;ga=fa;ha=f[k+(fa<<3)>>2]|0}else{ga=M;ha=aa}while(0);aa=f[j>>2]|0;Z=aa+(ha*12|0)|0;O=f[Z>>2]|0;f[k+(ga<<3)>>2]=O;V=aa;if(!O)f[k+(ga<<3)+4>>2]=0;f[Z>>2]=B;Z=f[aa+(ha*12|0)+4>>2]|0;O=f[aa+(ha*12|0)+8>>2]|0;ba=D+(Z<<2)|0;$=ca+O|0;_=ba+-4|0;X=f[_>>2]|0;U=(X|0)>0?X:0;W=ba+4|0;C=f[W>>2]|0;if((C|0)>0)ia=(X|0)<1?C:(C|0)==(U|0)?U:-1;else ia=U;U=ba+(r<<2)|0;o=f[U>>2]|0;if((o|0)>0)ja=(ia|0)==0?o:(o|0)==(ia|0)?ia:-1;else ja=ia;o=ba+(A<<2)|0;S=f[o>>2]|0;if((S|0)>0)if(!ja)f[ba>>2]=S;else{ka=(S|0)==(ja|0)?ja:-1;L=78}else{ka=ja;L=78}if((L|0)==78?(L=0,f[ba>>2]=ka,(ka|0)==-1):0){M=ga;B=ha;continue}if(!X){X=$+-3|0;ba=(h[$>>0]|0)-(h[X>>0]|0)|0;S=(h[$+1>>0]|0)-(h[X+1>>0]|0)|0;T=(S|0)>-1?S:0-S|0;S=(h[$+2>>0]|0)-(h[X+2>>0]|0)|0;X=(S|0)>-1?S:0-S|0;S=X+(f[l+((f[l+(((ba|0)>-1?ba:0-ba|0)+256-T<<2)>>2]|0)+256+T-X<<2)>>2]|0)|0;if(!ha){X=f[p>>2]|0;T=X-V|0;ba=(T|0)/12|0;t=ba*3|0;E=(t|0)>257?(t|0)/2|0:128;t=X;do if(E>>>0<=ba>>>0)if(E>>>0<ba>>>0){X=aa+(E*12|0)|0;if((t|0)==(X|0)){la=ba;ma=aa;break}f[p>>2]=t+(~(((t+-12-X|0)>>>0)/12|0)*12|0);la=ba;ma=aa}else L=86;else{Ela(j,E-ba|0);L=86}while(0);if((L|0)==86){L=0;t=f[j>>2]|0;if(!T){f[t>>2]=0;la=1;ma=t}else{la=ba;ma=t}}t=E+-1|0;if((la|0)<(t|0)){X=la;do{n=X;X=X+1|0;f[ma+(n*12|0)>>2]=X}while((X|0)!=(t|0))}f[ma+(t*12|0)>>2]=0;na=la;oa=ma}else{na=ha;oa=aa}X=oa+(na*12|0)|0;E=f[X>>2]|0;f[X>>2]=0;f[oa+(na*12|0)+4>>2]=Z+-1;f[oa+(na*12|0)+8>>2]=O+-3;X=k+(S<<3)+4|0;ba=f[X>>2]|0;T=f[j>>2]|0;f[((ba|0)==0?k+(S<<3)|0:T+(ba*12|0)|0)>>2]=na;f[X>>2]=na;X=ga-(f[l+(ga+256-S<<2)>>2]|0)|0;f[_>>2]=-2;pa=X;qa=E;ra=f[W>>2]|0;sa=T;ta=T}else{pa=ga;qa=ha;ra=C;sa=V;ta=aa}if(!ra){T=$+3|0;E=(h[$>>0]|0)-(h[T>>0]|0)|0;X=(h[$+1>>0]|0)-(h[T+1>>0]|0)|0;ba=(X|0)>-1?X:0-X|0;X=(h[$+2>>0]|0)-(h[T+2>>0]|0)|0;T=(X|0)>-1?X:0-X|0;X=T+(f[l+((f[l+(((E|0)>-1?E:0-E|0)+256-ba<<2)>>2]|0)+256+ba-T<<2)>>2]|0)|0;if(!qa){T=f[p>>2]|0;ba=T-sa|0;E=(ba|0)/12|0;n=E*3|0;H=(n|0)>257?(n|0)/2|0:128;n=sa;I=T;do if(H>>>0>E>>>0){Ela(j,H-E|0);L=99}else{if(H>>>0>=E>>>0){L=99;break}T=n+(H*12|0)|0;if((I|0)==(T|0)){ua=E;va=ta;break}f[p>>2]=I+(~(((I+-12-T|0)>>>0)/12|0)*12|0);ua=E;va=ta}while(0);do if((L|0)==99){L=0;I=f[j>>2]|0;if(ba|0){ua=E;va=I;break}f[I>>2]=0;ua=1;va=I}while(0);E=H+-1|0;if((ua|0)<(E|0)){ba=ua;do{I=ba;ba=ba+1|0;f[va+(I*12|0)>>2]=ba}while((ba|0)!=(E|0))}f[va+(E*12|0)>>2]=0;wa=ua;xa=va}else{wa=qa;xa=ta}ba=xa+(wa*12|0)|0;H=f[ba>>2]|0;f[ba>>2]=0;f[xa+(wa*12|0)+4>>2]=Z+1;f[xa+(wa*12|0)+8>>2]=O+3;ba=k+(X<<3)+4|0;I=f[ba>>2]|0;n=f[j>>2]|0;f[((I|0)==0?k+(X<<3)|0:n+(I*12|0)|0)>>2]=wa;f[ba>>2]=wa;ba=pa-(f[l+(pa+256-X<<2)>>2]|0)|0;f[W>>2]=-2;ya=ba;za=H;Aa=n;Ba=n}else{ya=pa;za=qa;Aa=sa;Ba=ta}if(!(f[U>>2]|0)){n=$+w|0;H=(h[$>>0]|0)-(h[n>>0]|0)|0;ba=(h[$+1>>0]|0)-(h[n+1>>0]|0)|0;I=(ba|0)>-1?ba:0-ba|0;ba=(h[$+2>>0]|0)-(h[n+2>>0]|0)|0;n=(ba|0)>-1?ba:0-ba|0;ba=n+(f[l+((f[l+(((H|0)>-1?H:0-H|0)+256-I<<2)>>2]|0)+256+I-n<<2)>>2]|0)|0;if(!za){n=f[p>>2]|0;I=n-Aa|0;H=(I|0)/12|0;aa=H*3|0;V=(aa|0)>257?(aa|0)/2|0:128;aa=Aa;C=n;do if(V>>>0>H>>>0){Ela(j,V-H|0);L=112}else{if(V>>>0>=H>>>0){L=112;break}n=aa+(V*12|0)|0;if((C|0)==(n|0)){Ca=H;Da=Ba;break}f[p>>2]=C+(~(((C+-12-n|0)>>>0)/12|0)*12|0);Ca=H;Da=Ba}while(0);do if((L|0)==112){L=0;C=f[j>>2]|0;if(I|0){Ca=H;Da=C;break}f[C>>2]=0;Ca=1;Da=C}while(0);H=V+-1|0;if((Ca|0)<(H|0)){I=Ca;do{C=I;I=I+1|0;f[Da+(C*12|0)>>2]=I}while((I|0)!=(H|0))}f[Da+(H*12|0)>>2]=0;Ea=Ca;Fa=Da}else{Ea=za;Fa=Ba}I=Fa+(Ea*12|0)|0;V=f[I>>2]|0;f[I>>2]=0;f[Fa+(Ea*12|0)+4>>2]=Z-A;f[Fa+(Ea*12|0)+8>>2]=O-x;I=k+(ba<<3)+4|0;C=f[I>>2]|0;aa=f[j>>2]|0;f[((C|0)==0?k+(ba<<3)|0:aa+(C*12|0)|0)>>2]=Ea;f[I>>2]=Ea;I=ya-(f[l+(ya+256-ba<<2)>>2]|0)|0;f[U>>2]=-2;Ga=V;Ha=I;Ia=aa;Ja=aa}else{Ga=za;Ha=ya;Ia=Aa;Ja=Ba}if(f[o>>2]|0){M=Ha;B=Ga;continue}aa=$+x|0;I=(h[$>>0]|0)-(h[aa>>0]|0)|0;V=(h[$+1>>0]|0)-(h[aa+1>>0]|0)|0;C=(V|0)>-1?V:0-V|0;V=(h[$+2>>0]|0)-(h[aa+2>>0]|0)|0;aa=(V|0)>-1?V:0-V|0;V=aa+(f[l+((f[l+(((I|0)>-1?I:0-I|0)+256-C<<2)>>2]|0)+256+C-aa<<2)>>2]|0)|0;if(!Ga){aa=f[p>>2]|0;C=aa-Ia|0;I=(C|0)/12|0;W=I*3|0;X=(W|0)>257?(W|0)/2|0:128;W=Ia;E=aa;do if(X>>>0>I>>>0){Ela(j,X-I|0);L=125}else{if(X>>>0>=I>>>0){L=125;break}aa=W+(X*12|0)|0;if((E|0)==(aa|0)){Ka=I;La=Ja;break}f[p>>2]=E+(~(((E+-12-aa|0)>>>0)/12|0)*12|0);Ka=I;La=Ja}while(0);do if((L|0)==125){L=0;E=f[j>>2]|0;if(C|0){Ka=I;La=E;break}f[E>>2]=0;Ka=1;La=E}while(0);I=X+-1|0;if((Ka|0)<(I|0)){C=Ka;do{E=C;C=C+1|0;f[La+(E*12|0)>>2]=C}while((C|0)!=(I|0))}f[La+(I*12|0)>>2]=0;Ma=Ka;Na=La}else{Ma=Ga;Na=Ja}C=Na+(Ma*12|0)|0;X=f[C>>2]|0;f[C>>2]=0;f[Na+(Ma*12|0)+4>>2]=Z+A;f[Na+(Ma*12|0)+8>>2]=O+x;C=k+(V<<3)+4|0;E=f[C>>2]|0;f[((E|0)==0?k+(V<<3)|0:(f[j>>2]|0)+(E*12|0)|0)>>2]=Ma;f[C>>2]=Ma;C=Ha-(f[l+(Ha+256-V<<2)>>2]|0)|0;f[o>>2]=-2;M=C;B=X}}while(0);Ha=f[j>>2]|0;if(Ha|0){j=f[p>>2]|0;if((j|0)!=(Ha|0))f[p>>2]=j+(~(((j+-12-Ha|0)>>>0)/12|0)*12|0);O5b(Ha)}Ha=i+36|0;j=f[Ha>>2]|0;if(j|0?(p=j+12|0,j=f[p>>2]|0,f[p>>2]=j+-1,(j|0)==1):0)kL(i);f[Ha>>2]=0;Ha=i+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[Ha>>2]|0)>0){s=f[a>>2]|0;a=0;do{f[s+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[Ha>>2]|0))}Ha=f[z>>2]|0;if((Ha|0)!=(q|0))UC(Ha);Ha=g+36|0;q=f[Ha>>2]|0;if(q|0?(z=q+12|0,q=f[z>>2]|0,f[z>>2]=q+-1,(q|0)==1):0)kL(g);f[Ha>>2]=0;Ha=g+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[Ha>>2]|0)>0){m=f[c>>2]|0;c=0;do{f[m+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[Ha>>2]|0))}Ha=f[y>>2]|0;if((Ha|0)!=(v|0))UC(Ha);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function Ela(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(((d-g|0)/12|0)>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;i=(f[e>>2]|0)+12|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=(g-h|0)/12|0;g=i+b|0;if(g>>>0>357913941)c4b(a);j=(d-h|0)/12|0;h=j<<1;d=j>>>0<178956970?(h>>>0<g>>>0?g:h):357913941;do if(d)if(d>>>0>357913941){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d*12|0)|0;break}else k=0;while(0);h=k+(i*12|0)|0;i=k+(d*12|0)|0;d=b;b=h;k=h;do{f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;b=k+12|0;k=b;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;b=(f[e>>2]|0)-d|0;g=h+(((b|0)/-12|0)*12|0)|0;if((b|0)>0)Vac(g|0,d|0,b|0)|0;f[a>>2]=g;f[e>>2]=k;f[c>>2]=i;if(!d)return;O5b(d);return}function Fla(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0.0,$b=0,ac=0,bc=0,cc=0.0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0;i=u;u=u+1536|0;k=i+480|0;l=i;m=i+336|0;o=i+304|0;p=i+248|0;q=i+192|0;r=i+328|0;s=i+320|0;t=i+136|0;v=i+312|0;dQ(o,58800);do if((yM(a)|0)==65536){w=f[a+4>>2]|0;f[p>>2]=f[w>>2];x=p+4|0;y=w+4|0;f[x>>2]=f[y>>2];z=p+8|0;f[z>>2]=f[w+8>>2];f[p+12>>2]=f[w+12>>2];f[p+16>>2]=f[w+16>>2];f[p+20>>2]=f[w+20>>2];f[p+24>>2]=f[w+24>>2];f[p+28>>2]=f[w+28>>2];f[p+32>>2]=f[w+32>>2];A=f[w+36>>2]|0;f[p+36>>2]=A;B=p+40|0;f[B>>2]=z;z=p+48|0;C=p+44|0;f[C>>2]=z;f[z>>2]=0;f[p+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[w+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];D=p;E=B;break}else{f[x>>2]=0;jL(p,w);D=p;E=B;break}}else{yL(p,a,-1);D=p;E=p+40|0}while(0);f[q>>2]=1124007936;a=q+4|0;B=q+8|0;w=q+40|0;x=a;y=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(y|0));f[w>>2]=B;z=q+48|0;C=q+44|0;f[C>>2]=z;f[z>>2]=0;f[q+52>>2]=0;A=f[E>>2]|0;F=f[A+4>>2]|0;G=f[A>>2]|0;A=f[D>>2]|0;D=A>>>3&511;H=A&7;A=(H|0)==0;I=(H|0)==2;if((H|2|0)!=2){f[k>>2]=0;f[k+4>>2]=0;x=aD(k,24)|0;J=266209;y=x+24|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));bO(-215,k,266234,266246,1624);bD(k)}K=p+16|0;if(f[K>>2]|0){L=f[p+4>>2]|0;if((L|0)<3)M=Y(f[p+12>>2]|0,f[p+8>>2]|0)|0;else{N=f[E>>2]|0;O=0;P=1;while(1){Q=Y(f[N+(O<<2)>>2]|0,P)|0;O=O+1|0;if((O|0)==(L|0)){M=Q;break}else P=Q}}if((L|0)==0|(M|0)==0)R=16}else R=16;if((R|0)==16){f[k>>2]=0;f[k+4>>2]=0;x=aD(k,12)|0;J=361040;y=x+12|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));bO(-215,k,266234,266246,1625);bD(k)}a:do switch(e|0){case 89:case 88:case 87:case 86:{M=(g|0)>1?g:1;if(!((g|0)<2&(D|0)==0)){f[k>>2]=0;f[k+4>>2]=0;x=aD(k,20)|0;J=266322;y=x+20|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));bO(-215,k,266234,266246,1632);bD(k)}f[r>>2]=F;f[r+4>>2]=G;vM(c,r,H|(M<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){L=f[c+4>>2]|0;f[k>>2]=f[L>>2];P=k+4|0;O=L+4|0;f[P>>2]=f[O>>2];N=k+8|0;f[N>>2]=f[L+8>>2];f[k+12>>2]=f[L+12>>2];f[k+16>>2]=f[L+16>>2];f[k+20>>2]=f[L+20>>2];f[k+24>>2]=f[L+24>>2];f[k+28>>2]=f[L+28>>2];f[k+32>>2]=f[L+32>>2];Q=k+36|0;S=f[L+36>>2]|0;f[Q>>2]=S;f[k+40>>2]=N;N=k+48|0;T=k+44|0;f[T>>2]=N;f[N>>2]=0;f[k+52>>2]=0;if(S|0){N=S+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[O>>2]|0)<3){O=f[L+44>>2]|0;N=f[T>>2]|0;f[N>>2]=f[O>>2];f[N+4>>2]=f[O+4>>2];U=Q;break}else{f[P>>2]=0;jL(k,L);U=Q;break}}else{yL(k,c,-1);U=k+36|0}while(0);M=f[U>>2]|0;if(M|0){Q=M+12|0;f[Q>>2]=(f[Q>>2]|0)+1}Q=q+36|0;M=f[Q>>2]|0;if(M|0?(L=M+12|0,M=f[L>>2]|0,f[L>>2]=M+-1,(M|0)==1):0)kL(q);f[Q>>2]=0;M=q+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[a>>2]|0)>0){L=f[w>>2]|0;P=0;do{f[L+(P<<2)>>2]=0;P=P+1|0;V=f[a>>2]|0}while((P|0)<(V|0));f[q>>2]=f[k>>2];if((V|0)<3)R=37;else R=39}else{f[q>>2]=f[k>>2];R=37}if((R|0)==37){P=f[k+4>>2]|0;if((P|0)<3){f[a>>2]=P;f[B>>2]=f[k+8>>2];f[q+12>>2]=f[k+12>>2];P=f[k+44>>2]|0;L=f[C>>2]|0;f[L>>2]=f[P>>2];f[L+4>>2]=f[P+4>>2]}else R=39}if((R|0)==39)jL(q,k);P=k+16|0;f[M>>2]=f[P>>2];f[q+20>>2]=f[k+20>>2];f[q+24>>2]=f[k+24>>2];f[q+28>>2]=f[k+28>>2];f[q+32>>2]=f[k+32>>2];L=f[U>>2]|0;f[Q>>2]=L;if(L|0?(O=L+12|0,L=f[O>>2]|0,f[O>>2]=L+-1,(L|0)==1):0)kL(k);f[U>>2]=0;L=k+4|0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[L>>2]|0)>0){P=f[k+40>>2]|0;O=0;do{f[P+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[L>>2]|0))}L=f[k+44>>2]|0;if((L|0)!=(k+48|0))UC(L);if(A){L=f[E>>2]|0;O=f[L+4>>2]|0;P=f[L>>2]|0;L=k+4|0;Q=(e&-2|0)==86;N=P+-2|0;f[L>>2]=N;f[k>>2]=O+-2;if((P|0)>2){f[l>>2]=0;f[l+4>>2]=N;Gla(m,p,q,((e|0)==87|(e|0)==89)&1,Q,k,Q?1868:4899,Q?4899:1868);Q=f[a>>2]|0;if((Q|0)<3)W=Y(f[q+12>>2]|0,f[B>>2]|0)|0;else{N=f[w>>2]|0;P=0;O=1;while(1){T=Y(f[N+(P<<2)>>2]|0,O)|0;P=P+1|0;if((P|0)==(Q|0)){W=T;break}else O=T}}RQ(l,m,+(W>>>0)*.0000152587890625);Hla(m)}O=f[w>>2]|0;Q=f[O+4>>2]|0;P=f[O>>2]|0;f[k>>2]=Q;f[L>>2]=P;O=f[M>>2]|0;N=f[z>>2]|0;T=(Q|0)>0;if((P|0)>2){if(T){Q=0;do{b[O+Q>>0]=b[O+(Q+N)>>0]|0;S=f[L>>2]|0;X=O+((Y(S+-2|0,N)|0)+Q)|0;Z=O+((Y(S+-1|0,N)|0)+Q)|0;b[Z>>0]=b[X>>0]|0;Q=Q+1|0}while((Q|0)<(f[k>>2]|0))}}else if(T?(Q=O+(Y(P+-1|0,N)|0)|0,b[Q>>0]=0,b[O>>0]=0,(f[k>>2]|0)>1):0){Q=1;do{X=O+((Y((f[L>>2]|0)+-1|0,N)|0)+Q)|0;b[X>>0]=0;b[O+Q>>0]=0;Q=Q+1|0}while((Q|0)<(f[k>>2]|0))}break a}if(!I){f[k>>2]=0;f[k+4>>2]=0;x=aD(k,54)|0;J=266343;y=x+54|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));bO(-210,k,266234,266246,1642);bD(k);break a}Q=f[E>>2]|0;O=f[Q+4>>2]|0;N=f[Q>>2]|0;Q=k+4|0;L=(e&-2|0)==86;P=N+-2|0;f[Q>>2]=P;f[k>>2]=O+-2;if((N|0)>2){f[l>>2]=0;f[l+4>>2]=P;Ila(m,p,q,((e|0)==87|(e|0)==89)&1,L,k,L?1868:4899,L?4899:1868);L=f[a>>2]|0;if((L|0)<3)_=Y(f[q+12>>2]|0,f[B>>2]|0)|0;else{P=f[w>>2]|0;N=0;O=1;while(1){T=Y(f[P+(N<<2)>>2]|0,O)|0;N=N+1|0;if((N|0)==(L|0)){_=T;break}else O=T}}RQ(l,m,+(_>>>0)*.0000152587890625);Jla(m)}O=f[w>>2]|0;L=f[O+4>>2]|0;N=f[O>>2]|0;f[k>>2]=L;f[Q>>2]=N;O=f[M>>2]|0;P=(f[z>>2]|0)>>>1;T=(L|0)>0;if((N|0)>2){if(T){X=Y(P,N+-2|0)|0;Z=Y(P,N+-1|0)|0;S=0;do{d[O+(S<<1)>>1]=d[O+(S+P<<1)>>1]|0;d[O+(S+Z<<1)>>1]=d[O+(S+X<<1)>>1]|0;S=S+1|0}while((S|0)!=(L|0))}}else if(T){S=Y(P,N+-1|0)|0;X=0;do{d[O+(X+S<<1)>>1]=0;d[O+(X<<1)>>1]=0;X=X+1|0}while((X|0)!=(L|0))}break}case 65:case 64:case 63:case 62:case 142:case 141:case 140:case 139:case 49:case 48:case 47:case 46:{L=(g|0)<1?3:g;if(!((L+-3|0)>>>0<2&(D|0)==0)){f[k>>2]=0;f[k+4>>2]=0;x=aD(k,34)|0;J=266398;y=x+34|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));bO(-215,k,266234,266246,1651);bD(k)}f[s>>2]=F;f[s+4>>2]=G;vM(c,s,H|(L<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){X=f[c+4>>2]|0;f[t>>2]=f[X>>2];O=t+4|0;S=X+4|0;f[O>>2]=f[S>>2];N=t+8|0;f[N>>2]=f[X+8>>2];f[t+12>>2]=f[X+12>>2];f[t+16>>2]=f[X+16>>2];f[t+20>>2]=f[X+20>>2];f[t+24>>2]=f[X+24>>2];f[t+28>>2]=f[X+28>>2];f[t+32>>2]=f[X+32>>2];P=f[X+36>>2]|0;f[t+36>>2]=P;f[t+40>>2]=N;N=t+48|0;T=t+44|0;f[T>>2]=N;f[N>>2]=0;f[t+52>>2]=0;if(P|0){N=P+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[S>>2]|0)<3){S=f[X+44>>2]|0;N=f[T>>2]|0;f[N>>2]=f[S>>2];f[N+4>>2]=f[S+4>>2];break}else{f[O>>2]=0;jL(t,X);break}}else yL(t,c,-1);while(0);b:do switch(e|0){case 46:case 47:case 48:case 49:case 139:case 140:case 141:case 142:{if(A){Kla(p,t,e);break b}if(!I){f[k>>2]=0;f[k+4>>2]=0;x=aD(k,53)|0;J=266433;y=x+53|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));bO(-210,k,266234,266246,1666);bD(k);break b}L=(f[t+48>>2]|0)>>>1;X=f[E>>2]|0;O=f[X+4>>2]|0;S=f[X>>2]|0;X=k+4|0;N=((f[t>>2]|0)>>>3&511)+1|0;T=S+-2|0;f[X>>2]=T;f[k>>2]=O+-2;if((S|0)>2){f[l>>2]=0;f[l+4>>2]=T;Lla(m,p,t,((e|0)==47|(e|0)==49)&1,(e|1|0)==47?-1:1,k);T=f[t+4>>2]|0;if((T|0)<3)$=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;else{S=f[t+40>>2]|0;O=0;P=1;while(1){Z=Y(f[S+(O<<2)>>2]|0,P)|0;O=O+1|0;if((O|0)==(T|0)){$=Z;break}else P=Z}}RQ(l,m,+($>>>0)*.0000152587890625);Mla(m)}P=f[t+40>>2]|0;T=f[P+4>>2]|0;O=f[P>>2]|0;f[k>>2]=T;f[X>>2]=O;P=f[t+16>>2]|0;S=Y(T,N)|0;T=(S|0)>0;if((O|0)>2){if(T){Z=Y(O+-2|0,L)|0;M=Y(O+-1|0,L)|0;Q=0;do{d[P+(Q<<1)>>1]=d[P+(Q+L<<1)>>1]|0;d[P+(Q+M<<1)>>1]=d[P+(Q+Z<<1)>>1]|0;Q=Q+1|0}while((Q|0)!=(S|0))}}else if(T){Q=Y(O+-1|0,L)|0;Z=0;do{d[P+(Z+Q<<1)>>1]=0;d[P+(Z<<1)>>1]=0;Z=Z+1|0}while((Z|0)!=(S|0))}break}default:{if(!A){f[k>>2]=0;f[k+4>>2]=0;x=aD(k,10)|0;J=359571;y=x+10|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));bO(-215,k,266234,266246,1670);bD(k)}S=f[K>>2]|0;Z=f[p+48>>2]|0;P=f[t+16>>2]|0;Q=f[t+48>>2]|0;L=f[E>>2]|0;O=f[L+4>>2]|0;T=f[L>>2]|0;if((((O|0)>(T|0)?T:O)|0)<8){Kla(p,t,e);break b}L=O<<1;M=O*3|0;N=O<<2;X=O*5|0;aa=O*6|0;ba=O*49|0;ca=O*147|0;da=k+8|0;f[k>>2]=da;ea=k+4|0;f[ea>>2]=ca;if(ca>>>0>520){fa=N5b(ca>>>0>2147483647?-1:ca<<1)|0;f[k>>2]=fa;ga=fa}else ga=da;fa=Z<<1;ca=S+fa|0;S=T+-4|0;if((S|0)>2){ha=O+-2|0;ia=O+-1|0;ja=(ia|0)>1;ka=~Z;la=Z+-1|0;ma=0-Z|0;na=1-Z|0;oa=Z+1|0;pa=(ha|0)>2;qa=M+-9|0;ra=ha*3|0;sa=O+1|0;ta=L|1;ua=L+-1|0;va=M+-1|0;wa=M+1|0;xa=ma<<1;ya=xa+-1|0;za=xa|1;Aa=fa+-1|0;Ba=fa|1;Ca=-2-Z|0;Da=Z+-2|0;Ea=2-Z|0;Fa=Z+2|0;Ga=N|1;Ha=N+-1|0;Ia=X+-1|0;Ja=X+1|0;Ka=Y(Z,-2)|0;La=Ka+2|0;Ma=aa|1;Na=fa+-2|0;Oa=aa+-1|0;Pa=Ka+-2|0;Ka=fa+2|0;Qa=ha+O|0;Ra=ha+L|0;Sa=ha+M|0;Ta=ha+N|0;Ua=ha+X|0;Va=ha+aa|0;Wa=(e|1|0)==63?0:2;Xa=2;Ya=(e|0)!=62&(e|0)!=64;while(1){Za=Y(Xa,Q)|0;_a=(Xa|0)==2?-1:1;do{$a=_a+Xa|0;ab=ga+((Y(($a+-1|0)%3|0,ba)|0)<<1)+2|0;d[ab+(ha<<1)>>1]=0;d[ab+-2>>1]=0;d[ab+(Qa<<1)>>1]=0;d[ab+(ia<<1)>>1]=0;d[ab+(Ra<<1)>>1]=0;d[ab+(ua<<1)>>1]=0;d[ab+(Sa<<1)>>1]=0;d[ab+(va<<1)>>1]=0;d[ab+(Ta<<1)>>1]=0;d[ab+(Ha<<1)>>1]=0;d[ab+(Ua<<1)>>1]=0;d[ab+(Ia<<1)>>1]=0;d[ab+(Va<<1)>>1]=0;d[ab+(Oa<<1)>>1]=0;if(ja){bb=ab;ab=ca+(Y($a,Z)|0)+1|0;$a=1;while(1){cb=ab+ka|0;db=ab+la|0;eb=(h[cb>>0]|0)-(h[db>>0]|0)|0;fb=ab+ma|0;gb=ab+Z|0;hb=(h[fb>>0]|0)-(h[gb>>0]|0)|0;ib=ab+na|0;jb=ab+oa|0;kb=(h[ib>>0]|0)-(h[jb>>0]|0)|0;d[bb>>1]=(((hb|0)>-1?hb:0-hb|0)<<1)+((eb|0)>-1?eb:0-eb|0)+((kb|0)>-1?kb:0-kb|0);kb=(h[cb>>0]|0)-(h[ib>>0]|0)|0;eb=ab+-1|0;ab=ab+1|0;hb=(h[eb>>0]|0)-(h[ab>>0]|0)|0;lb=(h[db>>0]|0)-(h[jb>>0]|0)|0;d[bb+(O<<1)>>1]=(((hb|0)>-1?hb:0-hb|0)<<1)+((kb|0)>-1?kb:0-kb|0)+((lb|0)>-1?lb:0-lb|0);lb=(h[ib>>0]|0)-(h[db>>0]|0)|0;db=bb+(L<<1)|0;d[db>>1]=((lb|0)>-1?lb:0-lb|0)<<1;lb=(h[cb>>0]|0)-(h[jb>>0]|0)|0;jb=bb+(M<<1)|0;d[jb>>1]=((lb|0)>-1?lb:0-lb|0)<<1;lb=(h[fb>>0]|0)-(h[eb>>0]|0)|0;cb=(h[gb>>0]|0)-(h[ab>>0]|0)|0;d[bb+(N<<1)>>1]=((lb|0)>-1?lb:0-lb|0)+(j[db>>1]|0)+((cb|0)>-1?cb:0-cb|0);cb=(h[fb>>0]|0)-(h[ab>>0]|0)|0;db=(h[gb>>0]|0)-(h[eb>>0]|0)|0;d[bb+(X<<1)>>1]=((cb|0)>-1?cb:0-cb|0)+(j[jb>>1]|0)+((db|0)>-1?db:0-db|0);d[bb+(aa<<1)>>1]=((h[eb>>0]|0)+(h[fb>>0]|0)+(h[ab>>0]|0)+(h[gb>>0]|0)|0)>>>1;$a=$a+1|0;if(($a|0)==(ia|0))break;else bb=bb+2|0}}_a=_a+1|0}while((_a|0)!=2);_a=P+Za|0;if(pa){bb=Wa^2;$a=Ya;ab=ga+((Y((Xa|0)%3|0,ba)|0)<<1)+4|0;gb=ga+((Y((Xa+-1|0)%3|0,ba)|0)<<1)+4|0;fb=ga+((Y((Xa+-2|0)%3|0,ba)|0)<<1)+4|0;eb=_a+6|0;db=ca+(Y(Xa,Z)|0)+2|0;jb=2;while(1){cb=j[gb>>1]|0;lb=cb+(j[fb>>1]|0)|0;ib=(j[ab>>1]|0)+cb|0;cb=j[gb+(O<<1)>>1]|0;kb=cb+(j[gb+(ia<<1)>>1]|0)|0;hb=(j[gb+(sa<<1)>>1]|0)+cb|0;cb=ib>>>0<lb>>>0?ib:lb;mb=(kb|0)<(cb|0)?kb:cb;cb=(hb|0)<(mb|0)?hb:mb;mb=lb>>>0<ib>>>0?ib:lb;nb=(mb|0)<(kb|0)?kb:mb;mb=(nb|0)<(hb|0)?hb:nb;if($a){nb=j[gb+(L<<1)>>1]|0;ob=(j[fb+(ta<<1)>>1]|0)+(j[fb+(L<<1)>>1]|0)+nb+(j[gb+(ta<<1)>>1]|0)|0;pb=(j[gb+(ua<<1)>>1]|0)+nb+(j[ab+(L<<1)>>1]|0)+(j[ab+(ua<<1)>>1]|0)|0;nb=j[gb+(M<<1)>>1]|0;qb=(j[fb+(va<<1)>>1]|0)+(j[fb+(M<<1)>>1]|0)+nb+(j[gb+(va<<1)>>1]|0)|0;rb=(j[gb+(wa<<1)>>1]|0)+nb+(j[ab+(M<<1)>>1]|0)+(j[ab+(wa<<1)>>1]|0)|0;nb=(ob|0)<(cb|0)?ob:cb;sb=(pb|0)<(nb|0)?pb:nb;nb=(qb|0)<(sb|0)?qb:sb;sb=(mb|0)<(ob|0)?ob:mb;tb=(sb|0)<(pb|0)?pb:sb;sb=(tb|0)<(qb|0)?qb:tb;tb=(sb|0)<(rb|0)?rb:sb;sb=((tb|0)<2?1:tb>>>1)+((rb|0)<(nb|0)?rb:nb)|0;if((lb|0)<(sb|0)){ub=1;vb=(h[db+ma>>0]|0)<<1;wb=(h[db>>0]|0)+(h[db+xa>>0]|0)|0;xb=(h[db+za>>0]|0)+(h[db+ya>>0]|0)|0}else{ub=0;vb=0;wb=0;xb=0}if((ib|0)<(sb|0)){yb=ub+1|0;zb=((h[db+Z>>0]|0)<<1)+vb|0;Ab=(h[db+fa>>0]|0)+wb+(h[db>>0]|0)|0;Bb=(h[db+Aa>>0]|0)+xb+(h[db+Ba>>0]|0)|0}else{yb=ub;zb=vb;Ab=wb;Bb=xb}if((kb|0)<(sb|0)){Cb=yb+1|0;Db=(h[db+Ca>>0]|0)+zb+(h[db+Da>>0]|0)|0;Eb=(h[db+-2>>0]|0)+Ab+(h[db>>0]|0)|0;Fb=((h[db+-1>>0]|0)<<1)+Bb|0}else{Cb=yb;Db=zb;Eb=Ab;Fb=Bb}if((hb|0)<(sb|0)){Gb=Cb+1|0;Hb=(h[db+Ea>>0]|0)+Db+(h[db+Fa>>0]|0)|0;Ib=(h[db+2>>0]|0)+Eb+(h[db>>0]|0)|0;Jb=((h[db+1>>0]|0)<<1)+Fb|0}else{Gb=Cb;Hb=Db;Ib=Eb;Jb=Fb}if((ob|0)<(sb|0)){Kb=Gb+1|0;Lb=(h[db+ma>>0]|0)+Hb+(h[db+Ea>>0]|0)|0;Mb=((h[db+na>>0]|0)<<1)+Ib|0;Nb=(h[db+za>>0]|0)+Jb+(h[db+1>>0]|0)|0}else{Kb=Gb;Lb=Hb;Mb=Ib;Nb=Jb}if((pb|0)<(sb|0)){Ob=Kb+1|0;Pb=(h[db+Z>>0]|0)+Lb+(h[db+Da>>0]|0)|0;Qb=((h[db+la>>0]|0)<<1)+Mb|0;Rb=(h[db+Aa>>0]|0)+Nb+(h[db+-1>>0]|0)|0}else{Ob=Kb;Pb=Lb;Qb=Mb;Rb=Nb}if((qb|0)<(sb|0)){Sb=Ob+1|0;Tb=(h[db+Ca>>0]|0)+Pb+(h[db+ma>>0]|0)|0;Ub=((h[db+ka>>0]|0)<<1)+Qb|0;Vb=(h[db+ya>>0]|0)+Rb+(h[db+-1>>0]|0)|0}else{Sb=Ob;Tb=Pb;Ub=Qb;Vb=Rb}if((rb|0)<(sb|0)){Wb=Sb+1|0;Xb=(h[db+Fa>>0]|0)+Tb+(h[db+Z>>0]|0)|0;Yb=((h[db+oa>>0]|0)<<1)+Ub|0;Zb=(h[db+Ba>>0]|0)+Vb+(h[db+1>>0]|0)|0}else{Wb=Sb;Xb=Tb;Yb=Ub;Zb=Vb}sb=h[db>>0]|0;_b=+n[58820+(Wb<<2)>>2];$b=sb;ac=(LVb(+(Zb-Yb|0)*_b)|0)+sb|0;bc=sb;cc=_b;dc=Xb-Yb|0}else{sb=j[gb+(N<<1)>>1]|0;rb=sb+(j[fb+(Ga<<1)>>1]|0)|0;qb=(j[ab+(Ha<<1)>>1]|0)+sb|0;sb=j[gb+(X<<1)>>1]|0;pb=sb+(j[fb+(Ia<<1)>>1]|0)|0;ob=(j[ab+(Ja<<1)>>1]|0)+sb|0;sb=(rb|0)<(cb|0)?rb:cb;cb=(qb|0)<(sb|0)?qb:sb;sb=(pb|0)<(cb|0)?pb:cb;cb=(mb|0)<(rb|0)?rb:mb;mb=(cb|0)<(qb|0)?qb:cb;cb=(mb|0)<(pb|0)?pb:mb;mb=(cb|0)<(ob|0)?ob:cb;cb=((mb|0)<2?1:mb>>>1)+((ob|0)<(sb|0)?ob:sb)|0;sb=h[db>>0]|0;if((lb|0)<(cb|0)){ec=1;fc=(h[db+na>>0]|0)+(h[db+ka>>0]|0)|0;gc=(h[db+ma>>0]|0)<<1;hc=(h[db+xa>>0]|0)+sb|0}else{ec=0;fc=0;gc=0;hc=0}if((ib|0)<(cb|0)){ic=ec+1|0;jc=(h[db+la>>0]|0)+fc+(h[db+oa>>0]|0)|0;kc=((h[db+Z>>0]|0)<<1)+gc|0;lc=hc+sb+(h[db+fa>>0]|0)|0}else{ic=ec;jc=fc;kc=gc;lc=hc}if((kb|0)<(cb|0)){mc=ic+1|0;nc=(h[db+ka>>0]|0)+jc+(h[db+la>>0]|0)|0;oc=((h[db+-1>>0]|0)<<1)+kc|0;pc=lc+sb+(h[db+-2>>0]|0)|0}else{mc=ic;nc=jc;oc=kc;pc=lc}if((hb|0)<(cb|0)){qc=mc+1|0;rc=(h[db+na>>0]|0)+nc+(h[db+oa>>0]|0)|0;sc=((h[db+1>>0]|0)<<1)+oc|0;tc=pc+sb+(h[db+2>>0]|0)|0}else{qc=mc;rc=nc;sc=oc;tc=pc}if((rb|0)<(cb|0)){uc=qc+1|0;vc=((h[db+na>>0]|0)<<1)+rc|0;wc=(j[fb+(Ma<<1)>>1]|0)+sc|0;xc=tc+sb+(h[db+La>>0]|0)|0}else{uc=qc;vc=rc;wc=sc;xc=tc}if((qb|0)<(cb|0)){yc=uc+1|0;zc=((h[db+la>>0]|0)<<1)+vc|0;Ac=(j[ab+(Oa<<1)>>1]|0)+wc|0;Bc=xc+sb+(h[db+Na>>0]|0)|0}else{yc=uc;zc=vc;Ac=wc;Bc=xc}if((pb|0)<(cb|0)){Cc=yc+1|0;Dc=((h[db+na>>0]|0)<<1)+zc|0;Ec=(j[fb+(Oa<<1)>>1]|0)+Ac|0;Fc=Bc+sb+(h[db+Pa>>0]|0)|0}else{Cc=yc;Dc=zc;Ec=Ac;Fc=Bc}if((ob|0)<(cb|0)){Gc=Cc+1|0;Hc=((h[db+na>>0]|0)<<1)+Dc|0;Ic=(j[ab+(Ma<<1)>>1]|0)+Ec|0;Jc=Fc+sb+(h[db+Ka>>0]|0)|0}else{Gc=Cc;Hc=Dc;Ic=Ec;Jc=Fc}_b=+n[58820+(Gc<<2)>>2];$b=(LVb(+(Ic-Jc|0)*_b)|0)+sb|0;ac=sb;bc=sb;cc=_b;dc=Hc-Jc|0}sb=(LVb(+(dc|0)*cc)|0)+bc|0;b[eb+Wa>>0]=sb>>>0<256?sb:(sb|0)>0?255:0;b[eb+1>>0]=$b>>>0<256?$b:($b|0)>0?255:0;b[eb+bb>>0]=ac>>>0<256?ac:(ac|0)>0?255:0;jb=jb+1|0;if((jb|0)==(ha|0)){Kc=bb;break}else{$a=$a^1;ab=ab+2|0;gb=gb+2|0;fb=fb+2|0;eb=eb+3|0;db=db+1|0}}}else Kc=Wa^2;db=qa+Za|0;eb=Za+ra|0;fb=P+(Za+5)|0;b[fb>>0]=b[P+(Za+8)>>0]|0;b[P+eb>>0]=b[P+db>>0]|0;gb=P+(Za+4)|0;b[gb>>0]=b[P+(Za+7)>>0]|0;b[P+(eb+1)>>0]=b[P+(db+1)>>0]|0;ab=P+(Za+3)|0;b[ab>>0]=b[P+(Za+6)>>0]|0;b[P+(eb+2)>>0]=b[P+(db+2)>>0]|0;b[P+(Za+2)>>0]=b[fb>>0]|0;b[P+(eb+3)>>0]=b[P+(db+3)>>0]|0;b[P+(Za+1)>>0]=b[gb>>0]|0;b[P+(eb+4)>>0]=b[P+(db+4)>>0]|0;b[_a>>0]=b[ab>>0]|0;b[P+(eb+5)>>0]=b[P+(db+5)>>0]|0;Xa=Xa+1|0;if((Xa|0)==(S|0))break;else{Wa=Kc;Ya=Ya^1}}}if((M|0)>0){Ya=Q<<1;Wa=Y(T+-5|0,Q)|0;Xa=Y(T+-1|0,Q)|0;ra=Y(T+-2|0,Q)|0;qa=Y(T+-3|0,Q)|0;ha=Y(S,Q)|0;Ka=0;do{Ma=b[P+(Ka+Ya)>>0]|0;b[P+(Ka+Q)>>0]=Ma;b[P+Ka>>0]=Ma;Ma=b[P+(Ka+Wa)>>0]|0;b[P+(Ka+Xa)>>0]=Ma;b[P+(Ka+ra)>>0]=Ma;b[P+(Ka+qa)>>0]=Ma;b[P+(Ka+ha)>>0]=Ma;Ka=Ka+1|0}while((Ka|0)!=(M|0))}M=f[k>>2]|0;if((M|0)!=(da|0)){if(M|0)P5b(M);f[k>>2]=da;f[ea>>2]=520}}}while(0);M=t+36|0;Ka=f[M>>2]|0;if(Ka|0?(ha=Ka+12|0,Ka=f[ha>>2]|0,f[ha>>2]=Ka+-1,(Ka|0)==1):0)kL(t);f[M>>2]=0;M=t+16|0;Ka=t+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[Ka>>2]|0)>0){M=f[t+40>>2]|0;ha=0;do{f[M+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[Ka>>2]|0))}Ka=f[t+44>>2]|0;if((Ka|0)!=(t+48|0))UC(Ka);break}case 138:case 137:case 136:case 135:{Ka=(g|0)<1?3:g;if(!((Ka|0)==3&(D|0)==0)){f[k>>2]=0;f[k+4>>2]=0;x=aD(k,20)|0;J=266487;y=x+20|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));bO(-215,k,266234,266246,1680);bD(k)}f[v>>2]=F;f[v+4>>2]=G;vM(c,v,H|(Ka<<3)+-8,-1,0,0);do if((yM(c)|0)==65536){ha=f[c+4>>2]|0;f[k>>2]=f[ha>>2];M=k+4|0;P=ha+4|0;f[M>>2]=f[P>>2];qa=k+8|0;f[qa>>2]=f[ha+8>>2];f[k+12>>2]=f[ha+12>>2];f[k+16>>2]=f[ha+16>>2];f[k+20>>2]=f[ha+20>>2];f[k+24>>2]=f[ha+24>>2];f[k+28>>2]=f[ha+28>>2];f[k+32>>2]=f[ha+32>>2];ra=k+36|0;Xa=f[ha+36>>2]|0;f[ra>>2]=Xa;f[k+40>>2]=qa;qa=k+48|0;Wa=k+44|0;f[Wa>>2]=qa;f[qa>>2]=0;f[k+52>>2]=0;if(Xa|0){qa=Xa+12|0;f[qa>>2]=(f[qa>>2]|0)+1}if((f[P>>2]|0)<3){P=f[ha+44>>2]|0;qa=f[Wa>>2]|0;f[qa>>2]=f[P>>2];f[qa+4>>2]=f[P+4>>2];Lc=ra;break}else{f[M>>2]=0;jL(k,ha);Lc=ra;break}}else{yL(k,c,-1);Lc=k+36|0}while(0);Ka=f[Lc>>2]|0;if(Ka|0){ra=Ka+12|0;f[ra>>2]=(f[ra>>2]|0)+1}ra=q+36|0;Ka=f[ra>>2]|0;if(Ka|0?(ha=Ka+12|0,Ka=f[ha>>2]|0,f[ha>>2]=Ka+-1,(Ka|0)==1):0)kL(q);f[ra>>2]=0;Ka=q+16|0;f[Ka>>2]=0;f[Ka+4>>2]=0;f[Ka+8>>2]=0;f[Ka+12>>2]=0;if((f[a>>2]|0)>0){ha=f[w>>2]|0;M=0;do{f[ha+(M<<2)>>2]=0;M=M+1|0;Mc=f[a>>2]|0}while((M|0)<(Mc|0));f[q>>2]=f[k>>2];if((Mc|0)<3)R=195;else R=197}else{f[q>>2]=f[k>>2];R=195}if((R|0)==195){M=f[k+4>>2]|0;if((M|0)<3){f[a>>2]=M;f[B>>2]=f[k+8>>2];f[q+12>>2]=f[k+12>>2];M=f[k+44>>2]|0;ha=f[C>>2]|0;f[ha>>2]=f[M>>2];f[ha+4>>2]=f[M+4>>2]}else R=197}if((R|0)==197)jL(q,k);M=k+16|0;f[Ka>>2]=f[M>>2];f[q+20>>2]=f[k+20>>2];f[q+24>>2]=f[k+24>>2];f[q+28>>2]=f[k+28>>2];f[q+32>>2]=f[k+32>>2];ha=f[Lc>>2]|0;f[ra>>2]=ha;if(ha|0?(P=ha+12|0,ha=f[P>>2]|0,f[P>>2]=ha+-1,(ha|0)==1):0)kL(k);f[Lc>>2]=0;ha=k+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[ha>>2]|0)>0){M=f[k+40>>2]|0;P=0;do{f[M+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[ha>>2]|0))}ha=f[k+44>>2]|0;if((ha|0)!=(k+48|0))UC(ha);if(A){ha=f[E>>2]|0;P=f[ha+4>>2]|0;M=f[ha>>2]|0;f[k>>2]=P;ha=k+4|0;f[ha>>2]=M;c:do if(!((P|0)<3|(M|0)<3)){f[k>>2]=P+-2;f[ha>>2]=M+-2;Nla(l,p,q,k,(e+-135|0)>>>0<2&1,(e|2|0)==138&1);ra=f[ha>>2]|0;f[m>>2]=0;f[m+4>>2]=ra;ra=f[a>>2]|0;if((ra|0)<3)Nc=Y(f[q+12>>2]|0,f[B>>2]|0)|0;else{qa=f[w>>2]|0;Wa=0;Xa=1;while(1){Q=Y(f[qa+(Wa<<2)>>2]|0,Xa)|0;Wa=Wa+1|0;if((Wa|0)==(ra|0)){Nc=Q;break}else Xa=Q}}RQ(m,l,+(Nc>>>0)*.0000152587890625);Ola(l);Xa=f[w>>2]|0;ra=f[Xa+4>>2]|0;Wa=f[Xa>>2]|0;f[ha>>2]=Wa;Xa=f[q>>2]|0;qa=Y((Xa>>>3&511)+1|0,ra)|0;f[k>>2]=qa;ra=((f[z>>2]|0)>>>0)/((1212424721>>>(Xa<<2&28)&15)>>>0)|0;Xa=f[Ka>>2]|0;ea=Xa+(Y(ra,Wa+-1|0)|0)|0;da=(qa|0)>0;if((Wa|0)<=2){if(da)Oc=0;else break;while(1){b[ea+Oc>>0]=0;b[Xa+Oc>>0]=0;Oc=Oc+1|0;if((Oc|0)>=(f[k>>2]|0))break c}}if(da){Wa=Xa+ra|0;qa=ea+(0-ra)|0;Q=0;do{b[Xa+Q>>0]=b[Wa+Q>>0]|0;b[ea+Q>>0]=b[qa+Q>>0]|0;Q=Q+1|0}while((Q|0)<(f[k>>2]|0))}}else{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;UP(q,l)|0}while(0);break a}if(!I){f[k>>2]=0;f[k+4>>2]=0;x=aD(k,74)|0;J=266508;y=x+74|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));bO(-210,k,266234,266246,1689);bD(k);break a}ha=f[E>>2]|0;M=f[ha+4>>2]|0;P=f[ha>>2]|0;f[k>>2]=M;ha=k+4|0;f[ha>>2]=P;d:do if(!((M|0)<3|(P|0)<3)){f[k>>2]=M+-2;f[ha>>2]=P+-2;Pla(l,p,q,k,(e+-135|0)>>>0<2&1,(e|2|0)==138&1);Q=f[ha>>2]|0;f[m>>2]=0;f[m+4>>2]=Q;Q=f[a>>2]|0;if((Q|0)<3)Pc=Y(f[q+12>>2]|0,f[B>>2]|0)|0;else{qa=f[w>>2]|0;ea=0;Wa=1;while(1){Xa=Y(f[qa+(ea<<2)>>2]|0,Wa)|0;ea=ea+1|0;if((ea|0)==(Q|0)){Pc=Xa;break}else Wa=Xa}}RQ(m,l,+(Pc>>>0)*.0000152587890625);Qla(l);Wa=f[w>>2]|0;Q=f[Wa+4>>2]|0;ea=f[Wa>>2]|0;f[ha>>2]=ea;Wa=f[q>>2]|0;qa=Y((Wa>>>3&511)+1|0,Q)|0;f[k>>2]=qa;Q=((f[z>>2]|0)>>>0)/((1212424721>>>(Wa<<2&28)&15)>>>0)|0;Wa=f[Ka>>2]|0;Xa=Wa+((Y(Q,ea+-1|0)|0)<<1)|0;ra=(qa|0)>0;if((ea|0)<=2){if(ra)Qc=0;else break;while(1){d[Xa+(Qc<<1)>>1]=0;d[Wa+(Qc<<1)>>1]=0;Qc=Qc+1|0;if((Qc|0)==(qa|0))break d}}if(ra){ea=Wa+(Q<<1)|0;da=Xa+(0-Q<<1)|0;Ya=0;do{d[Wa+(Ya<<1)>>1]=d[ea+(Ya<<1)>>1]|0;d[Xa+(Ya<<1)>>1]=d[da+(Ya<<1)>>1]|0;Ya=Ya+1|0}while((Ya|0)!=(qa|0))}}else{f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;UP(q,l)|0}while(0);break}default:{f[k>>2]=0;f[k+4>>2]=0;x=aD(k,43)|0;J=266583;y=x+43|0;do{b[x>>0]=b[J>>0]|0;x=x+1|0;J=J+1|0}while((x|0)<(y|0));bO(-206,k,266234,266246,1694);bD(k)}}while(0);k=q+36|0;J=f[k>>2]|0;if(J|0?(x=J+12|0,J=f[x>>2]|0,f[x>>2]=J+-1,(J|0)==1):0)kL(q);f[k>>2]=0;k=q+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[a>>2]|0)>0){k=f[w>>2]|0;w=0;do{f[k+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[a>>2]|0))}a=f[C>>2]|0;if((a|0)!=(z|0))UC(a);a=p+36|0;z=f[a>>2]|0;if(z|0?(C=z+12|0,z=f[C>>2]|0,f[C>>2]=z+-1,(z|0)==1):0)kL(p);f[a>>2]=0;a=p+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[a>>2]|0)>0){K=f[E>>2]|0;E=0;do{f[K+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[a>>2]|0))}a=f[p+44>>2]|0;if((a|0)!=(p+48|0))UC(a);if(!(f[o+4>>2]|0)){u=i;return}u=i;return}function Gla(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=g&1;f[a>>2]=58964;g=a+4|0;f[g>>2]=f[c>>2];l=a+8|0;m=c+4|0;f[l>>2]=f[m>>2];n=a+12|0;f[n>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];o=f[c+36>>2]|0;f[a+40>>2]=o;f[a+44>>2]=n;n=a+52|0;p=a+48|0;f[p>>2]=n;f[n>>2]=0;f[a+56>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[c+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[l>>2]=0;jL(g,c)}c=a+60|0;f[c>>2]=f[d>>2];g=a+64|0;l=d+4|0;f[g>>2]=f[l>>2];m=a+68|0;f[m>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];n=f[d+36>>2]|0;f[a+96>>2]=n;f[a+100>>2]=m;m=a+108|0;p=a+104|0;f[p>>2]=m;f[m>>2]=0;f[a+112>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[d+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}else{f[g>>2]=0;jL(c,d);q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}}function Hla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58964;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Ila(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=g&1;f[a>>2]=58944;g=a+4|0;f[g>>2]=f[c>>2];l=a+8|0;m=c+4|0;f[l>>2]=f[m>>2];n=a+12|0;f[n>>2]=f[c+8>>2];f[a+16>>2]=f[c+12>>2];f[a+20>>2]=f[c+16>>2];f[a+24>>2]=f[c+20>>2];f[a+28>>2]=f[c+24>>2];f[a+32>>2]=f[c+28>>2];f[a+36>>2]=f[c+32>>2];o=f[c+36>>2]|0;f[a+40>>2]=o;f[a+44>>2]=n;n=a+52|0;p=a+48|0;f[p>>2]=n;f[n>>2]=0;f[a+56>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[c+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2]}else{f[l>>2]=0;jL(g,c)}c=a+60|0;f[c>>2]=f[d>>2];g=a+64|0;l=d+4|0;f[g>>2]=f[l>>2];m=a+68|0;f[m>>2]=f[d+8>>2];f[a+72>>2]=f[d+12>>2];f[a+76>>2]=f[d+16>>2];f[a+80>>2]=f[d+20>>2];f[a+84>>2]=f[d+24>>2];f[a+88>>2]=f[d+28>>2];f[a+92>>2]=f[d+32>>2];n=f[d+36>>2]|0;f[a+96>>2]=n;f[a+100>>2]=m;m=a+108|0;p=a+104|0;f[p>>2]=m;f[m>>2]=0;f[a+112>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[d+44>>2]|0;m=f[p>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}else{f[g>>2]=0;jL(c,d);q=a+116|0;f[q>>2]=e;r=a+120|0;b[r>>0]=k;s=a+124|0;t=f[h>>2]|0;f[s>>2]=t;u=a+128|0;v=h+4|0;w=f[v>>2]|0;f[u>>2]=w;x=a+132|0;f[x>>2]=i;y=a+136|0;f[y>>2]=j;return}}function Jla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58944;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Kla(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+160|0;g=e+144|0;h=e+136|0;i=e;j=f[c+48>>2]|0;k=f[a+40>>2]|0;l=f[k+4>>2]|0;m=f[k>>2]|0;k=g+4|0;n=((f[c>>2]|0)>>>3&511)+1|0;o=m+-2|0;f[k>>2]=o;f[g>>2]=l+-2;if((m|0)>2){f[h>>2]=0;f[h+4>>2]=o;Xla(i,a,c,((d|0)==47|(d|0)==49)&1,(d|1|0)==47?-1:1,g);d=f[c+4>>2]|0;if((d|0)<3)p=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{a=f[c+40>>2]|0;o=0;m=1;while(1){l=Y(f[a+(o<<2)>>2]|0,m)|0;o=o+1|0;if((o|0)==(d|0)){p=l;break}else m=l}}RQ(h,i,+(p>>>0)*.0000152587890625);Yla(i)}i=f[c+40>>2]|0;p=f[i+4>>2]|0;h=f[i>>2]|0;f[g>>2]=p;f[k>>2]=h;i=f[c+16>>2]|0;c=(Y(p,n)|0)>0;if((h|0)>2){if(c)q=0;else{u=e;return}do{b[i+q>>0]=b[i+(q+j)>>0]|0;p=f[k>>2]|0;m=i+((Y(p+-2|0,j)|0)+q)|0;d=i+((Y(p+-1|0,j)|0)+q)|0;b[d>>0]=b[m>>0]|0;q=q+1|0}while((q|0)<(Y(f[g>>2]|0,n)|0));u=e;return}if(!c){u=e;return}c=i+(Y(h+-1|0,j)|0)|0;b[c>>0]=0;b[i>>0]=0;if((Y(f[g>>2]|0,n)|0)>1)r=1;else{u=e;return}do{c=i+((Y((f[k>>2]|0)+-1|0,j)|0)+r)|0;b[c>>0]=0;b[i+r>>0]=0;r=r+1|0}while((r|0)<(Y(f[g>>2]|0,n)|0));u=e;return}function Lla(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=58904;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;jL(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}else{f[h>>2]=0;jL(b,c);n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}}function Mla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58904;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Nla(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=58884;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;jL(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}else{f[h>>2]=0;jL(b,c);n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}}function Ola(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58884;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Pla(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=58864;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;jL(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}else{f[h>>2]=0;jL(b,c);n=a+116|0;o=f[d>>2]|0;f[n>>2]=o;p=a+120|0;q=d+4|0;r=f[q>>2]|0;f[p>>2]=r;s=a+124|0;f[s>>2]=e;t=a+128|0;f[t>>2]=g;return}}function Qla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58864;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Rla(a){a=a|0;Qla(a);O5b(a);return}function Sla(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;c=f[a+60>>2]|0;e=(c>>>3&511)+1|0;g=e<<1;h=((f[a+52>>2]|0)>>>0)/((1212424721>>>(f[a+4>>2]<<2&28)&15)>>>0)|0;i=f[a+108>>2]|0;k=(i>>>0)/((1212424721>>>(c<<2&28)&15)>>>0)|0;c=f[b>>2]|0;l=c+1|0;m=f[b+4>>2]|0;if((c|0)>=(m|0))return;b=c&1;n=(f[a+76>>2]|0)+(Y(l,i)|0)+(e<<1)|0;i=0-h|0;o=a+116|0;p=g-k|0;q=e-k|0;k=~h;r=1-h|0;s=h+-1|0;t=h+1|0;u=c;c=n;n=(f[a+20>>2]|0)+(Y(f[f[a+48>>2]>>2]|0,l)|0)+2|0;l=b^f[a+124>>2];v=b^f[a+128>>2];while(1){if(!v){w=1;x=c;y=n}else{a=l<<1;d[c+(a<<1)>>1]=((j[n+(h<<1)>>1]|0)+(j[n+(i<<1)>>1]|0)|0)>>>1;d[c+2>>1]=d[n>>1]|0;b=n+2|0;d[c+(2-a<<1)>>1]=((j[b>>1]|0)+(j[n+-2>>1]|0)|0)>>>1;w=2;x=c+(e<<1)|0;y=b}b=f[o>>2]|0;a=(w|0)<(b|0);if(!l)if(a){z=w;A=x;B=y;while(1){C=B+(r<<1)|0;D=B+(t<<1)|0;d[A>>1]=((j[B+(k<<1)>>1]|0)+2+(j[C>>1]|0)+(j[B+(s<<1)>>1]|0)+(j[D>>1]|0)|0)>>>2;E=j[B+-2>>1]|0;F=B+2|0;G=d[F>>1]|0;H=E-(G&65535)|0;I=j[B+(h<<1)>>1]|0;J=d[B+(i<<1)>>1]|0;K=I-(J&65535)|0;L=(((H|0)>-1?H:0-H|0)|0)>(((K|0)>-1?K:0-K|0)|0);d[A+2>>1]=((L?I:E)+1+((L?J:G)&65535)|0)>>>1;d[A+4>>1]=d[B>>1]|0;d[A+6>>1]=((j[C>>1]|0)+1+(j[D>>1]|0)|0)>>>1;d[A+8>>1]=d[F>>1]|0;F=B+4|0;d[A+10>>1]=((j[B>>1]|0)+1+(j[F>>1]|0)|0)>>>1;D=z+2|0;C=A+(g<<1)|0;if((D|0)<(b|0)){z=D;A=C;B=F}else{M=D;N=C;O=F;break}}}else{M=w;N=x;O=y}else if(a){B=w;A=x;z=y;while(1){d[A>>1]=d[z>>1]|0;F=j[z+-2>>1]|0;C=z+2|0;D=d[C>>1]|0;G=F-(D&65535)|0;J=j[z+(h<<1)>>1]|0;L=d[z+(i<<1)>>1]|0;E=J-(L&65535)|0;I=(((G|0)>-1?G:0-G|0)|0)>(((E|0)>-1?E:0-E|0)|0);d[A+2>>1]=((I?J:F)+1+((I?L:D)&65535)|0)>>>1;D=z+(r<<1)|0;L=z+(t<<1)|0;d[A+4>>1]=((j[D>>1]|0)+(j[z+(k<<1)>>1]|0)+(j[z+(s<<1)>>1]|0)+(j[L>>1]|0)|0)>>>2;I=z+4|0;d[A+6>>1]=((j[z>>1]|0)+1+(j[I>>1]|0)|0)>>>1;d[A+8>>1]=d[C>>1]|0;d[A+10>>1]=((j[D>>1]|0)+1+(j[L>>1]|0)|0)>>>1;L=B+2|0;D=A+(g<<1)|0;if((L|0)<(b|0)){B=L;A=D;z=I}else{M=L;N=D;O=I;break}}}else{M=w;N=x;O=y}if((M|0)>(b|0)){P=N;Q=O}else{z=l<<1;d[N+(z<<1)>>1]=((j[O+(k<<1)>>1]|0)+2+(j[O+(r<<1)>>1]|0)+(j[O+(s<<1)>>1]|0)+(j[O+(t<<1)>>1]|0)|0)>>>2;A=j[O+-2>>1]|0;B=O+2|0;a=d[B>>1]|0;I=A-(a&65535)|0;D=j[O+(h<<1)>>1]|0;L=d[O+(i<<1)>>1]|0;C=D-(L&65535)|0;F=(((I|0)>-1?I:0-I|0)|0)>(((C|0)>-1?C:0-C|0)|0);d[N+2>>1]=((F?D:A)+1+((F?L:a)&65535)|0)>>>1;d[N+(2-z<<1)>>1]=d[O>>1]|0;P=N+(e<<1)|0;Q=B}B=0;do{d[P+(B<<1)>>1]=d[P+(B-e<<1)>>1]|0;d[P+(q+B<<1)>>1]=d[P+(p+B<<1)>>1]|0;B=B+1|0}while((B|0)!=(e|0));u=u+1|0;if((u|0)>=(m|0))break;else{c=P+(g<<1)|0;n=Q+4|0;l=l^1;v=v^1}}return}function Tla(a){a=a|0;Ola(a);O5b(a);return}function Ula(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;d=f[a+60>>2]|0;e=(d>>>3&511)+1|0;g=e<<1;i=((f[a+52>>2]|0)>>>0)/((1212424721>>>(f[a+4>>2]<<2&28)&15)>>>0)|0;j=f[a+108>>2]|0;k=(j>>>0)/((1212424721>>>(d<<2&28)&15)>>>0)|0;d=f[c>>2]|0;l=d+1|0;m=c+4|0;if((d|0)>=(f[m>>2]|0))return;c=d&1;n=(f[a+76>>2]|0)+(Y(l,j)|0)+e|0;j=0-i|0;o=a+116|0;p=g-k|0;q=e-k|0;k=~i;r=1-i|0;s=i+-1|0;t=i+1|0;u=d;d=n;n=(f[a+20>>2]|0)+(Y(f[f[a+48>>2]>>2]|0,l)|0)+1|0;l=c^f[a+124>>2];v=c^f[a+128>>2];while(1){if(!v){w=1;x=d;y=n}else{a=l<<1;b[d+a>>0]=((h[n+i>>0]|0)+(h[n+j>>0]|0)|0)>>>1;b[d+1>>0]=b[n>>0]|0;c=n+1|0;b[d+(2-a)>>0]=((h[c>>0]|0)+(h[n+-1>>0]|0)|0)>>>1;w=2;x=d+e|0;y=c}c=f[o>>2]|0;a=(w|0)<(c|0);if(!l)if(a){z=w;A=x;B=y;while(1){C=B+r|0;D=B+t|0;b[A>>0]=((h[B+k>>0]|0)+2+(h[C>>0]|0)+(h[B+s>>0]|0)+(h[D>>0]|0)|0)>>>2;E=h[B+-1>>0]|0;F=B+1|0;G=b[F>>0]|0;H=E-(G&255)|0;I=h[B+i>>0]|0;J=b[B+j>>0]|0;K=I-(J&255)|0;L=(((H|0)>-1?H:0-H|0)|0)>(((K|0)>-1?K:0-K|0)|0);b[A+1>>0]=((L?I:E)+1+((L?J:G)&255)|0)>>>1;b[A+2>>0]=b[B>>0]|0;b[A+3>>0]=((h[C>>0]|0)+1+(h[D>>0]|0)|0)>>>1;b[A+4>>0]=b[F>>0]|0;F=B+2|0;b[A+5>>0]=((h[B>>0]|0)+1+(h[F>>0]|0)|0)>>>1;D=z+2|0;C=A+g|0;G=f[o>>2]|0;if((D|0)<(G|0)){z=D;A=C;B=F}else{M=D;N=C;O=F;P=G;break}}}else{M=w;N=x;O=y;P=c}else if(a){B=w;A=x;z=y;while(1){b[A>>0]=b[z>>0]|0;G=h[z+-1>>0]|0;F=z+1|0;C=b[F>>0]|0;D=G-(C&255)|0;J=h[z+i>>0]|0;L=b[z+j>>0]|0;E=J-(L&255)|0;I=(((D|0)>-1?D:0-D|0)|0)>(((E|0)>-1?E:0-E|0)|0);b[A+1>>0]=((I?J:G)+1+((I?L:C)&255)|0)>>>1;C=z+r|0;L=z+t|0;b[A+2>>0]=((h[C>>0]|0)+(h[z+k>>0]|0)+(h[z+s>>0]|0)+(h[L>>0]|0)|0)>>>2;I=z+2|0;b[A+3>>0]=((h[z>>0]|0)+1+(h[I>>0]|0)|0)>>>1;b[A+4>>0]=b[F>>0]|0;b[A+5>>0]=((h[C>>0]|0)+1+(h[L>>0]|0)|0)>>>1;L=B+2|0;C=A+g|0;F=f[o>>2]|0;if((L|0)<(F|0)){B=L;A=C;z=I}else{M=L;N=C;O=I;P=F;break}}}else{M=w;N=x;O=y;P=c}if((M|0)>(P|0)){Q=N;R=O}else{z=l<<1;b[N+z>>0]=((h[O+k>>0]|0)+2+(h[O+r>>0]|0)+(h[O+s>>0]|0)+(h[O+t>>0]|0)|0)>>>2;A=h[O+-1>>0]|0;B=O+1|0;a=b[B>>0]|0;F=A-(a&255)|0;I=h[O+i>>0]|0;C=b[O+j>>0]|0;L=I-(C&255)|0;G=(((F|0)>-1?F:0-F|0)|0)>(((L|0)>-1?L:0-L|0)|0);b[N+1>>0]=((G?I:A)+1+((G?C:a)&255)|0)>>>1;b[N+(2-z)>>0]=b[O>>0]|0;Q=N+e|0;R=B}B=0;do{b[Q+B>>0]=b[Q+(B-e)>>0]|0;b[Q+(q+B)>>0]=b[Q+(p+B)>>0]|0;B=B+1|0}while((B|0)!=(e|0));u=u+1|0;if((u|0)>=(f[m>>2]|0))break;else{d=Q+g|0;n=R+2|0;l=l^1;v=v^1}}return}function Vla(a){a=a|0;Mla(a);O5b(a);return}function Wla(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;c=((f[a+60>>2]|0)>>>3&511)+1|0;e=c<<1;g=f[a+52>>2]|0;h=g>>>1;i=f[b>>2]|0;k=(f[a+108>>2]|0)>>>1;l=f[a+120>>2]|0;m=f[a+116>>2]|0;n=(i&1|0)==0;o=f[b+4>>2]|0;if((i|0)>=(o|0))return;b=(f[a+76>>2]|0)+((Y(k,i+1|0)|0)<<1)+(c<<1)+2|0;p=(f[a+20>>2]|0)+((Y(i,h)|0)<<1)|0;q=a+124|0;a=f[q>>2]|0;r=(a|0)<1;s=(c|0)==3;t=Y(a,c)|0;u=t+1|0;v=t+-1|0;w=t+2|0;x=g|1;g=h+2|0;y=h+1|0;z=(c|0)==4;A=h<<1;B=A+2|0;C=A|1;D=h+3|0;E=b;b=i;i=p;p=n?m:(m|0)==0&1;m=n?l:0-l|0;while(1){l=i+(a<<1)|0;if(r){d[E+(u<<1)>>1]=0;d[E+(t<<1)>>1]=0;d[E+(v<<1)>>1]=0;if(s){F=-4;G=0;H=-3;I=-2}else{d[E+-6>>1]=0;d[E+-8>>1]=0;F=-2;G=-1;H=w;I=-5}d[E+(I<<1)>>1]=0;d[E+(H<<1)>>1]=G;d[E+(F<<1)>>1]=G;J=p;K=m}else{n=(p|0)!=0;if(n){L=i+2|0;M=((j[i+(h<<1)>>1]|0)+1+(j[i+(g<<1)>>1]|0)|0)>>>1;d[E+(0-m<<1)>>1]=((j[L>>1]|0)+1+(j[i+(x<<1)>>1]|0)|0)>>>1;d[E>>1]=d[i+(y<<1)>>1]|0;d[E+(m<<1)>>1]=M;if(z)d[E+4>>1]=-1;N=E+(c<<1)|0;O=L}else{N=E;O=i}L=(m|0)>0;M=l+-4|0;P=O>>>0>M>>>0;do if(s)if(L){if(P){Q=N;R=O;break}else{S=O;T=N}while(1){U=S+4|0;V=S+(B<<1)|0;W=S+(g<<1)|0;X=((j[S+2>>1]|0)+2+(j[S+(h<<1)>>1]|0)+(j[W>>1]|0)+(j[S+(C<<1)>>1]|0)|0)>>>2;d[T+-2>>1]=((j[S>>1]|0)+2+(j[U>>1]|0)+(j[S+(A<<1)>>1]|0)+(j[V>>1]|0)|0)>>>2;d[T>>1]=X;X=S+(y<<1)|0;d[T+2>>1]=d[X>>1]|0;Z=((j[X>>1]|0)+1+(j[S+(D<<1)>>1]|0)|0)>>>1;d[T+4>>1]=((j[U>>1]|0)+1+(j[V>>1]|0)|0)>>>1;d[T+6>>1]=d[W>>1]|0;d[T+8>>1]=Z;Z=T+(e<<1)|0;if(U>>>0>M>>>0){Q=Z;R=U;break}else{S=U;T=Z}}}else{if(P){Q=N;R=O;break}else{_=O;$=N}while(1){Z=_+4|0;U=_+(B<<1)|0;W=_+(g<<1)|0;V=((j[_+2>>1]|0)+2+(j[_+(h<<1)>>1]|0)+(j[W>>1]|0)+(j[_+(C<<1)>>1]|0)|0)>>>2;d[$+2>>1]=((j[_>>1]|0)+2+(j[Z>>1]|0)+(j[_+(A<<1)>>1]|0)+(j[U>>1]|0)|0)>>>2;d[$>>1]=V;V=_+(y<<1)|0;d[$+-2>>1]=d[V>>1]|0;X=((j[V>>1]|0)+1+(j[_+(D<<1)>>1]|0)|0)>>>1;d[$+8>>1]=((j[Z>>1]|0)+1+(j[U>>1]|0)|0)>>>1;d[$+6>>1]=d[W>>1]|0;d[$+4>>1]=X;X=$+(e<<1)|0;if(Z>>>0>M>>>0){Q=X;R=Z;break}else{_=Z;$=X}}}else if(L){if(P){Q=N;R=O;break}else{aa=O;ba=N}while(1){X=aa+4|0;Z=aa+(B<<1)|0;W=aa+(g<<1)|0;U=((j[aa+2>>1]|0)+2+(j[aa+(h<<1)>>1]|0)+(j[W>>1]|0)+(j[aa+(C<<1)>>1]|0)|0)>>>2;d[ba+-2>>1]=((j[aa>>1]|0)+2+(j[X>>1]|0)+(j[aa+(A<<1)>>1]|0)+(j[Z>>1]|0)|0)>>>2;d[ba>>1]=U;U=aa+(y<<1)|0;d[ba+2>>1]=d[U>>1]|0;d[ba+4>>1]=-1;V=((j[U>>1]|0)+1+(j[aa+(D<<1)>>1]|0)|0)>>>1;d[ba+6>>1]=((j[X>>1]|0)+1+(j[Z>>1]|0)|0)>>>1;d[ba+8>>1]=d[W>>1]|0;d[ba+10>>1]=V;d[ba+12>>1]=-1;V=ba+(e<<1)|0;if(X>>>0>M>>>0){Q=V;R=X;break}else{aa=X;ba=V}}}else{if(P){Q=N;R=O;break}else{ca=O;da=N}while(1){V=ca+4|0;X=ca+(B<<1)|0;W=((j[ca>>1]|0)+2+(j[V>>1]|0)+(j[ca+(A<<1)>>1]|0)+(j[X>>1]|0)|0)>>>2;Z=ca+(g<<1)|0;U=((j[ca+2>>1]|0)+2+(j[ca+(h<<1)>>1]|0)+(j[Z>>1]|0)+(j[ca+(C<<1)>>1]|0)|0)>>>2;ea=ca+(y<<1)|0;d[da+-2>>1]=d[ea>>1]|0;d[da>>1]=U;d[da+2>>1]=W;d[da+4>>1]=-1;W=((j[V>>1]|0)+1+(j[X>>1]|0)|0)>>>1;d[da+6>>1]=((j[ea>>1]|0)+1+(j[ca+(D<<1)>>1]|0)|0)>>>1;d[da+8>>1]=d[Z>>1]|0;d[da+10>>1]=W;d[da+12>>1]=-1;W=da+(e<<1)|0;if(V>>>0>M>>>0){Q=W;R=V;break}else{ca=V;da=W}}}while(0);if(R>>>0<l>>>0?(M=((j[R+2>>1]|0)+2+(j[R+(h<<1)>>1]|0)+(j[R+(g<<1)>>1]|0)+(j[R+(C<<1)>>1]|0)|0)>>>2,d[Q+(0-m<<1)>>1]=((j[R>>1]|0)+2+(j[R+4>>1]|0)+(j[R+(A<<1)>>1]|0)+(j[R+(B<<1)>>1]|0)|0)>>>2,d[Q>>1]=M,d[Q+(m<<1)>>1]=d[R+(y<<1)>>1]|0,z):0)d[Q+4>>1]=-1;M=d[E+-2>>1]|0;P=d[E+2>>1]|0;L=d[E>>1]|0;W=Y(f[q>>2]|0,c)|0;V=W+-4|0;if(s){d[E+-8>>1]=M;d[E+-6>>1]=L;d[E+-4>>1]=P;fa=W;ga=d[E+(V<<1)>>1]|0;ha=1}else{d[E+-10>>1]=M;d[E+-8>>1]=L;d[E+-6>>1]=P;d[E+-4>>1]=d[E+4>>1]|0;P=d[E+(W+-5<<1)>>1]|0;d[E+(W<<1)>>1]=d[E+(V<<1)>>1]|0;fa=W+1|0;ga=P;ha=2}d[E+(W+-1<<1)>>1]=ga;d[E+(fa<<1)>>1]=d[E+(W+-3<<1)>>1]|0;d[E+(ha+W<<1)>>1]=d[E+(W+-2<<1)>>1]|0;J=(n^1)&1;K=0-m|0}b=b+1|0;if((b|0)>=(o|0))break;else{E=E+(k<<1)|0;i=i+(h<<1)|0;p=J;m=K}}return}function Xla(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f[a>>2]=58924;h=a+4|0;f[h>>2]=f[b>>2];i=a+8|0;j=b+4|0;f[i>>2]=f[j>>2];k=a+12|0;f[k>>2]=f[b+8>>2];f[a+16>>2]=f[b+12>>2];f[a+20>>2]=f[b+16>>2];f[a+24>>2]=f[b+20>>2];f[a+28>>2]=f[b+24>>2];f[a+32>>2]=f[b+28>>2];f[a+36>>2]=f[b+32>>2];l=f[b+36>>2]|0;f[a+40>>2]=l;f[a+44>>2]=k;k=a+52|0;m=a+48|0;f[m>>2]=k;f[k>>2]=0;f[a+56>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[b+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2]}else{f[i>>2]=0;jL(h,b)}b=a+60|0;f[b>>2]=f[c>>2];h=a+64|0;i=c+4|0;f[h>>2]=f[i>>2];j=a+68|0;f[j>>2]=f[c+8>>2];f[a+72>>2]=f[c+12>>2];f[a+76>>2]=f[c+16>>2];f[a+80>>2]=f[c+20>>2];f[a+84>>2]=f[c+24>>2];f[a+88>>2]=f[c+28>>2];f[a+92>>2]=f[c+32>>2];k=f[c+36>>2]|0;f[a+96>>2]=k;f[a+100>>2]=j;j=a+108|0;m=a+104|0;f[m>>2]=j;f[j>>2]=0;f[a+112>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[c+44>>2]|0;j=f[m>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}else{f[h>>2]=0;jL(b,c);n=a+116|0;f[n>>2]=d;o=a+120|0;f[o>>2]=e;p=a+124|0;q=f[g>>2]|0;f[p>>2]=q;r=a+128|0;s=g+4|0;t=f[s>>2]|0;f[r>>2]=t;return}}function Yla(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=58924;b=a+60|0;c=a+96|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+76|0;b=a+64|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+100>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+104>>2]|0;if((b|0)!=(a+108|0))UC(b);b=a+4|0;d=a+40|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+20|0;b=a+8|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+44>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function Zla(a){a=a|0;Yla(a);O5b(a);return}function _la(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;d=((f[a+60>>2]|0)>>>3&511)+1|0;e=d<<1;g=f[a+52>>2]|0;i=f[c>>2]|0;j=f[a+108>>2]|0;k=f[a+120>>2]|0;l=f[a+116>>2]|0;m=(i&1|0)==0;n=c+4|0;if((i|0)>=(f[n>>2]|0))return;c=(f[a+76>>2]|0)+(Y(i+1|0,j)|0)+d+1|0;o=a+124|0;p=(d|0)==3;q=g<<1;r=q|1;s=g+2|0;t=g+1|0;u=(d|0)==4;v=q+2|0;w=g+3|0;x=c;c=i;y=(f[a+20>>2]|0)+(Y(i,g)|0)|0;i=m?l:(l|0)==0&1;l=m?k:0-k|0;while(1){k=f[o>>2]|0;m=y+k|0;if((k|0)<1){a=x+((Y(k,d)|0)+1)|0;b[a>>0]=0;a=x+(Y(f[o>>2]|0,d)|0)|0;b[a>>0]=0;a=x+((Y(f[o>>2]|0,d)|0)+-1)|0;b[a>>0]=0;if(p){b[x+-2>>0]=0;z=-4;A=0;B=-3}else{b[x+-3>>0]=0;b[x+-4>>0]=0;b[x+-5>>0]=0;z=-2;A=-1;B=(Y(f[o>>2]|0,d)|0)+2|0}b[x+B>>0]=A;b[x+z>>0]=A;C=i;D=l}else{a=(i|0)!=0;if(a){k=y+1|0;E=((h[y+g>>0]|0)+1+(h[y+s>>0]|0)|0)>>>1;b[x+(0-l)>>0]=((h[k>>0]|0)+1+(h[y+r>>0]|0)|0)>>>1;b[x>>0]=b[y+t>>0]|0;b[x+l>>0]=E;if(u)b[x+2>>0]=-1;F=x+d|0;G=k}else{F=x;G=y}k=(l|0)>0;E=m+-2|0;H=G>>>0>E>>>0;do if(p)if(k){if(H){I=F;J=G;break}else{K=G;L=F}while(1){M=K+2|0;N=K+v|0;O=K+s|0;P=((h[K+1>>0]|0)+2+(h[K+g>>0]|0)+(h[O>>0]|0)+(h[K+r>>0]|0)|0)>>>2;b[L+-1>>0]=((h[K>>0]|0)+2+(h[M>>0]|0)+(h[K+q>>0]|0)+(h[N>>0]|0)|0)>>>2;b[L>>0]=P;P=K+t|0;b[L+1>>0]=b[P>>0]|0;Q=((h[P>>0]|0)+1+(h[K+w>>0]|0)|0)>>>1;b[L+2>>0]=((h[M>>0]|0)+1+(h[N>>0]|0)|0)>>>1;b[L+3>>0]=b[O>>0]|0;b[L+4>>0]=Q;Q=L+e|0;if(M>>>0>E>>>0){I=Q;J=M;break}else{K=M;L=Q}}}else{if(H){I=F;J=G;break}else{R=G;S=F}while(1){Q=R+2|0;M=R+v|0;O=R+s|0;N=((h[R+1>>0]|0)+2+(h[R+g>>0]|0)+(h[O>>0]|0)+(h[R+r>>0]|0)|0)>>>2;b[S+1>>0]=((h[R>>0]|0)+2+(h[Q>>0]|0)+(h[R+q>>0]|0)+(h[M>>0]|0)|0)>>>2;b[S>>0]=N;N=R+t|0;b[S+-1>>0]=b[N>>0]|0;P=((h[N>>0]|0)+1+(h[R+w>>0]|0)|0)>>>1;b[S+4>>0]=((h[Q>>0]|0)+1+(h[M>>0]|0)|0)>>>1;b[S+3>>0]=b[O>>0]|0;b[S+2>>0]=P;P=S+e|0;if(Q>>>0>E>>>0){I=P;J=Q;break}else{R=Q;S=P}}}else if(k){if(H){I=F;J=G;break}else{T=G;U=F}while(1){P=T+2|0;Q=T+v|0;O=T+s|0;M=((h[T+1>>0]|0)+2+(h[T+g>>0]|0)+(h[O>>0]|0)+(h[T+r>>0]|0)|0)>>>2;b[U+-1>>0]=((h[T>>0]|0)+2+(h[P>>0]|0)+(h[T+q>>0]|0)+(h[Q>>0]|0)|0)>>>2;b[U>>0]=M;M=T+t|0;b[U+1>>0]=b[M>>0]|0;b[U+2>>0]=-1;N=((h[M>>0]|0)+1+(h[T+w>>0]|0)|0)>>>1;b[U+3>>0]=((h[P>>0]|0)+1+(h[Q>>0]|0)|0)>>>1;b[U+4>>0]=b[O>>0]|0;b[U+5>>0]=N;b[U+6>>0]=-1;N=U+e|0;if(P>>>0>E>>>0){I=N;J=P;break}else{T=P;U=N}}}else{if(H){I=F;J=G;break}else{V=G;W=F}while(1){N=V+2|0;P=V+v|0;O=((h[V>>0]|0)+2+(h[N>>0]|0)+(h[V+q>>0]|0)+(h[P>>0]|0)|0)>>>2;Q=V+s|0;M=((h[V+1>>0]|0)+2+(h[V+g>>0]|0)+(h[Q>>0]|0)+(h[V+r>>0]|0)|0)>>>2;X=V+t|0;b[W+-1>>0]=b[X>>0]|0;b[W>>0]=M;b[W+1>>0]=O;b[W+2>>0]=-1;O=((h[N>>0]|0)+1+(h[P>>0]|0)|0)>>>1;b[W+3>>0]=((h[X>>0]|0)+1+(h[V+w>>0]|0)|0)>>>1;b[W+4>>0]=b[Q>>0]|0;b[W+5>>0]=O;b[W+6>>0]=-1;O=W+e|0;if(N>>>0>E>>>0){I=O;J=N;break}else{V=N;W=O}}}while(0);if(J>>>0<m>>>0?(E=((h[J+1>>0]|0)+2+(h[J+g>>0]|0)+(h[J+s>>0]|0)+(h[J+r>>0]|0)|0)>>>2,b[I+(0-l)>>0]=((h[J>>0]|0)+2+(h[J+2>>0]|0)+(h[J+q>>0]|0)+(h[J+v>>0]|0)|0)>>>2,b[I>>0]=E,b[I+l>>0]=b[J+t>>0]|0,u):0)b[I+2>>0]=-1;E=b[x+-1>>0]|0;H=b[x+1>>0]|0;k=b[x>>0]|0;if(p){b[x+-4>>0]=E;b[x+-3>>0]=k;b[x+-2>>0]=H;O=(f[o>>2]|0)*3|0;b[x+(O+-1)>>0]=b[x+(O+-4)>>0]|0;O=(f[o>>2]|0)*3|0;Z=O;_=O;$=1}else{b[x+-5>>0]=E;b[x+-4>>0]=k;b[x+-3>>0]=H;b[x+-2>>0]=b[x+2>>0]|0;H=Y(f[o>>2]|0,d)|0;b[x+(H+-1)>>0]=b[x+(H+-5)>>0]|0;H=Y(f[o>>2]|0,d)|0;b[x+H>>0]=b[x+(H+-4)>>0]|0;H=Y(f[o>>2]|0,d)|0;Z=H;_=H+1|0;$=2}b[x+_>>0]=b[x+(Z+-3)>>0]|0;H=Y(f[o>>2]|0,d)|0;b[x+(H+$)>>0]=b[x+(H+-2)>>0]|0;C=(a^1)&1;D=0-l|0}c=c+1|0;if((c|0)>=(f[n>>2]|0))break;else{x=x+j|0;y=y+g|0;i=C;l=D}}return}function $la(a){a=a|0;Jla(a);O5b(a);return}function ama(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;c=f[a+52>>2]|0;e=c>>>1;g=(f[a+108>>2]|0)>>>1;h=f[a+132>>2]|0;i=f[a+136>>2]|0;k=f[a+116>>2]|0;l=f[b>>2]|0;m=(l&1|0)==0;n=f[b+4>>2]|0;if((l|0)>=(n|0))return;b=(f[a+76>>2]|0)+(g+1<<1)+((Y(l,g)|0)<<1)|0;o=(f[a+20>>2]|0)+((Y(l,e)|0)<<1)|0;p=f[a+124>>2]|0;a=(p|0)<1;q=c|1;c=e+2|0;r=e+1|0;s=e<<1;t=s+2|0;u=s|1;v=e+3|0;w=p+-1|0;x=b;b=l;l=o;o=m?k:(k|0)==0&1;k=m?i:h;y=m?h:i;while(1){i=l+(p<<1)|0;if(a){d[x+(p<<1)>>1]=0;d[x+-2>>1]=0;z=k;A=o;B=y}else{h=(o|0)!=0;if(h){m=l+2|0;C=Y((j[l+(q<<1)>>1]|0)+(j[m>>1]|0)|0,k)|0;D=Y((j[l+(c<<1)>>1]|0)+(j[l+(e<<1)>>1]|0)|0,y)|0;d[x>>1]=(C+16384+D+((j[l+(r<<1)>>1]|0)*19234|0)|0)>>>15;E=x+2|0;F=m}else{E=x;F=l}m=i+-4|0;if(F>>>0>m>>>0){G=E;H=F}else{D=y<<2;C=F;I=E;while(1){J=C+4|0;K=C+(t<<1)|0;L=Y((j[J>>1]|0)+(j[C>>1]|0)+(j[C+(s<<1)>>1]|0)+(j[K>>1]|0)|0,k)|0;M=C+(c<<1)|0;N=C+(r<<1)|0;O=(L+32768+(((j[C+(e<<1)>>1]|0)+(j[C+2>>1]|0)+(j[M>>1]|0)+(j[C+(u<<1)>>1]|0)|0)*9617|0)+(Y(D,j[N>>1]|0)|0)|0)>>>16&65535;d[I>>1]=O;O=Y((j[K>>1]|0)+(j[J>>1]|0)|0,k)|0;K=Y((j[C+(v<<1)>>1]|0)+(j[N>>1]|0)|0,y)|0;d[I+2>>1]=(O+16384+K+((j[M>>1]|0)*19234|0)|0)>>>15;M=I+4|0;if(J>>>0>m>>>0){G=M;H=J;break}else{C=J;I=M}}}if(H>>>0<i>>>0){I=Y((j[H+4>>1]|0)+(j[H>>1]|0)+(j[H+(s<<1)>>1]|0)+(j[H+(t<<1)>>1]|0)|0,k)|0;C=(I+32768+(((j[H+(e<<1)>>1]|0)+(j[H+2>>1]|0)+(j[H+(c<<1)>>1]|0)+(j[H+(u<<1)>>1]|0)|0)*9617|0)+(Y(y<<2,j[H+(r<<1)>>1]|0)|0)|0)>>>16&65535;d[G>>1]=C}d[x+-2>>1]=d[x>>1]|0;d[x+(p<<1)>>1]=d[x+(w<<1)>>1]|0;z=y;A=(h^1)&1;B=k}b=b+1|0;if((b|0)>=(n|0))break;else{x=x+(g<<1)|0;l=l+(e<<1)|0;o=A;k=z;y=B}}return}function bma(a){a=a|0;Hla(a);O5b(a);return}function cma(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=f[a+52>>2]|0;e=f[a+108>>2]|0;g=f[a+132>>2]|0;i=f[a+136>>2]|0;j=f[a+116>>2]|0;k=f[c>>2]|0;l=(k&1|0)==0;m=c+4|0;if((k|0)>=(f[m>>2]|0))return;c=(f[a+76>>2]|0)+(e+1)+(Y(k,e)|0)|0;n=(f[a+20>>2]|0)+(Y(k,d)|0)|0;o=a+124|0;a=d<<1;p=a|1;q=d+2|0;r=d+1|0;s=a+2|0;t=d+3|0;u=c;c=k;k=n;n=l?j:(j|0)==0&1;j=l?i:g;v=l?g:i;while(1){i=f[o>>2]|0;g=k+i|0;if((i|0)<1){b[u+i>>0]=0;b[u+-1>>0]=0;w=j;x=n;y=v}else{i=(n|0)!=0;if(i){l=k+1|0;z=Y((h[k+p>>0]|0)+(h[l>>0]|0)|0,j)|0;A=Y((h[k+q>>0]|0)+(h[k+d>>0]|0)|0,v)|0;b[u>>0]=(z+16384+A+((h[k+r>>0]|0)*19234|0)|0)>>>15;B=u+1|0;C=l}else{B=u;C=k}l=g+-2|0;if(C>>>0>l>>>0){D=B;E=C}else{A=v<<2;z=C;F=B;while(1){G=z+2|0;H=z+s|0;I=Y((h[G>>0]|0)+(h[z>>0]|0)+(h[z+a>>0]|0)+(h[H>>0]|0)|0,j)|0;J=z+q|0;K=z+r|0;L=(I+32768+(((h[z+d>>0]|0)+(h[z+1>>0]|0)+(h[J>>0]|0)+(h[z+p>>0]|0)|0)*9617|0)+(Y(A,h[K>>0]|0)|0)|0)>>>16&255;b[F>>0]=L;L=Y((h[H>>0]|0)+(h[G>>0]|0)|0,j)|0;H=Y((h[z+t>>0]|0)+(h[K>>0]|0)|0,v)|0;b[F+1>>0]=(L+16384+H+((h[J>>0]|0)*19234|0)|0)>>>15;J=F+2|0;if(G>>>0>l>>>0){D=J;E=G;break}else{z=G;F=J}}}if(E>>>0<g>>>0){F=Y((h[E+2>>0]|0)+(h[E>>0]|0)+(h[E+a>>0]|0)+(h[E+s>>0]|0)|0,j)|0;z=(F+32768+(((h[E+d>>0]|0)+(h[E+1>>0]|0)+(h[E+q>>0]|0)+(h[E+p>>0]|0)|0)*9617|0)+(Y(v<<2,h[E+r>>0]|0)|0)|0)>>>16&255;b[D>>0]=z}b[u+-1>>0]=b[u>>0]|0;z=f[o>>2]|0;b[u+z>>0]=b[u+(z+-1)>>0]|0;w=v;x=(i^1)&1;y=j}c=c+1|0;if((c|0)>=(f[m>>2]|0))break;else{u=u+e|0;k=k+d|0;n=x;j=w;v=y}}return}function dma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,M=0.0,N=0,O=0,P=0;d=u;u=u+16|0;e=d;dQ(e,58976);g=a;h=f[g>>2]|0;i=f[g+4>>2]|0;g=Kac(h|0,i|0,-1,-1)|0;j=J;k=a+8|0;a=f[k>>2]|0;l=f[k+4>>2]|0;k=Kac(a|0,l|0,-1,-1)|0;m=J;if((i|0)<0|(i|0)==0&h>>>0<1|((l|0)<0|(l|0)==0&a>>>0<1))n=0;else{o=b+8|0;p=c+8|0;q=b;r=f[q>>2]|0;s=f[q+4>>2]|0;q=Sac(r|0,s|0,63)|0;t=o;v=f[t>>2]|0;w=f[t+4>>2]|0;t=Sac(v|0,w|0,61)|0;x=(((s|0)>(i|0)|(s|0)==(i|0)&r>>>0>=h>>>0)&1)<<1|q|t&4|(((w|0)>(l|0)|(w|0)==(l|0)&v>>>0>=a>>>0)&1)<<3;t=c;q=f[t>>2]|0;y=f[t+4>>2]|0;t=Sac(q|0,y|0,63)|0;z=p;A=f[z>>2]|0;B=f[z+4>>2]|0;z=Sac(A|0,B|0,61)|0;C=(((y|0)>(i|0)|(y|0)==(i|0)&q>>>0>=h>>>0)&1)<<1|t|z&4|(((B|0)>(l|0)|(B|0)==(l|0)&A>>>0>=a>>>0)&1)<<3;if(!((C&x|0)!=0|(C|x|0)==0)){if(!(x&12)){D=x;E=r;F=s;G=v;H=w}else{a=x>>>0<8;l=a?0:k;z=a?0:m;a=Jac(l|0,z|0,v|0,w|0)|0;I=+(a>>>0)+4294967296.0*+(J|0);a=Jac(q|0,y|0,r|0,s|0)|0;M=(+(a>>>0)+4294967296.0*+(J|0))*I;a=Jac(A|0,B|0,v|0,w|0)|0;I=M/(+(a>>>0)+4294967296.0*+(J|0));a=Kac(~~I>>>0|0,(+L(I)>=1.0?(I>0.0?~~+Z(+K(I/4294967296.0),4294967295.0)>>>0:~~+X((I-+(~~I>>>0))/4294967296.0)>>>0):0)|0,r|0,s|0)|0;s=J;r=b;f[r>>2]=a;f[r+4>>2]=s;r=o;f[r>>2]=l;f[r+4>>2]=z;r=Sac(a|0,s|0,63)|0;D=(((s|0)>(i|0)|(s|0)==(i|0)&a>>>0>=h>>>0)&1)<<1|r;E=a;F=s;G=l;H=z}if(!(C&12))N=C;else{z=C>>>0<8;l=z?0:k;k=z?0:m;m=p;z=f[m>>2]|0;s=f[m+4>>2]|0;m=Jac(l|0,k|0,z|0,s|0)|0;I=+(m>>>0)+4294967296.0*+(J|0);m=c;a=f[m>>2]|0;r=f[m+4>>2]|0;m=Jac(a|0,r|0,E|0,F|0)|0;M=I*(+(m>>>0)+4294967296.0*+(J|0));m=Jac(z|0,s|0,G|0,H|0)|0;I=M/(+(m>>>0)+4294967296.0*+(J|0));m=Kac(~~I>>>0|0,(+L(I)>=1.0?(I>0.0?~~+Z(+K(I/4294967296.0),4294967295.0)>>>0:~~+X((I-+(~~I>>>0))/4294967296.0)>>>0):0)|0,a|0,r|0)|0;r=J;a=c;f[a>>2]=m;f[a+4>>2]=r;a=p;f[a>>2]=l;f[a+4>>2]=k;k=Sac(m|0,r|0,63)|0;N=(((r|0)>(i|0)|(r|0)==(i|0)&m>>>0>=h>>>0)&1)<<1|k}if(!((N&D|0)!=0|(N|D|0)==0)){if(D|0){k=(D|0)==1;h=k?0:g;m=k?0:j;k=b;i=f[k>>2]|0;r=f[k+4>>2]|0;k=Jac(h|0,m|0,i|0,r|0)|0;I=+(k>>>0)+4294967296.0*+(J|0);k=p;a=o;l=f[a>>2]|0;H=f[a+4>>2]|0;a=Jac(f[k>>2]|0,f[k+4>>2]|0,l|0,H|0)|0;M=I*(+(a>>>0)+4294967296.0*+(J|0));a=c;k=Jac(f[a>>2]|0,f[a+4>>2]|0,i|0,r|0)|0;I=M/(+(k>>>0)+4294967296.0*+(J|0));k=Kac(~~I>>>0|0,(+L(I)>=1.0?(I>0.0?~~+Z(+K(I/4294967296.0),4294967295.0)>>>0:~~+X((I-+(~~I>>>0))/4294967296.0)>>>0):0)|0,l|0,H|0)|0;H=o;f[H>>2]=k;f[H+4>>2]=J;H=b;f[H>>2]=h;f[H+4>>2]=m}if(!N){O=0;P=0}else{m=(N|0)==1;H=m?0:g;g=m?0:j;j=c;m=f[j>>2]|0;h=f[j+4>>2]|0;j=Jac(H|0,g|0,m|0,h|0)|0;I=+(j>>>0)+4294967296.0*+(J|0);j=p;k=f[j>>2]|0;l=f[j+4>>2]|0;j=o;o=Jac(k|0,l|0,f[j>>2]|0,f[j+4>>2]|0)|0;M=I*(+(o>>>0)+4294967296.0*+(J|0));o=b;b=Jac(m|0,h|0,f[o>>2]|0,f[o+4>>2]|0)|0;I=M/(+(b>>>0)+4294967296.0*+(J|0));b=Kac(~~I>>>0|0,(+L(I)>=1.0?(I>0.0?~~+Z(+K(I/4294967296.0),4294967295.0)>>>0:~~+X((I-+(~~I>>>0))/4294967296.0)>>>0):0)|0,k|0,l|0)|0;l=p;f[l>>2]=b;f[l+4>>2]=J;l=c;f[l>>2]=H;f[l+4>>2]=g;O=0;P=0}}else{O=N;P=D}}else{O=C;P=x}n=(P|O|0)==0}if(!(f[e+4>>2]|0)){u=d;return n|0}u=d;return n|0}function ema(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=u;u=u+48|0;j=i+32|0;k=i+16|0;l=i;m=a+20|0;f[m>>2]=-1;n=(g|0)==8;switch(g|0){case 4:case 8:break;default:{f[j>>2]=0;f[j+4>>2]=0;g=aD(j,38)|0;o=267207;p=g+38|0;do{b[g>>0]=b[o>>0]|0;g=g+1|0;o=o+1|0}while((g|0)<(p|0));bO(-215,j,267246,267135,170);bD(j)}}o=f[d>>2]|0;g=f[c+12>>2]|0;p=f[e>>2]|0;if((o>>>0<g>>>0&p>>>0<g>>>0?(g=f[c+8>>2]|0,(f[d+4>>2]|0)>>>0<g>>>0):0)?(q=f[e+4>>2]|0,q>>>0<g>>>0):0){r=p;s=q}else{q=f[c+40>>2]|0;g=f[q+4>>2]|0;t=f[q>>2]|0;q=d+4|0;v=f[q>>2]|0;w=j;f[w>>2]=o;f[w+4>>2]=((o|0)<0)<<31>>31;o=j+8|0;w=o;f[w>>2]=v;f[w+4>>2]=((v|0)<0)<<31>>31;v=e+4|0;w=f[v>>2]|0;x=k;f[x>>2]=p;f[x+4>>2]=((p|0)<0)<<31>>31;p=k+8|0;x=p;f[x>>2]=w;f[x+4>>2]=((w|0)<0)<<31>>31;w=l;f[w>>2]=g;f[w+4>>2]=((g|0)<0)<<31>>31;g=l+8|0;f[g>>2]=t;f[g+4>>2]=((t|0)<0)<<31>>31;t=dma(l,j,k)|0;f[d>>2]=f[j>>2];f[q>>2]=f[o>>2];o=f[k>>2]|0;f[e>>2]=o;e=f[p>>2]|0;f[v>>2]=e;if(t){r=o;s=e}else{f[a>>2]=f[c+16>>2];e=a+16|0;f[a+4>>2]=0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;y=0;z=0;A=a+8|0;f[A>>2]=z;B=a+12|0;f[B>>2]=y;u=i;return}}e=f[c+4>>2]|0;if((e|0)>0)C=f[(f[c+44>>2]|0)+(e+-1<<2)>>2]|0;else C=0;e=c+48|0;o=f[e>>2]|0;t=f[d>>2]|0;v=r-t|0;p=d+4|0;k=f[p>>2]|0;q=s-k|0;j=v>>31;l=(j^v)-j|0;if(h){h=j&(t^r)^t;f[d>>2]=h;d=(s^k)&j^k;f[p>>2]=d;D=(q^j)-j|0;E=C;F=d;G=h}else{D=q;E=(j^C)-j|0;F=k;G=t}t=c+16|0;c=(f[t>>2]|0)+(Y(F,o)|0)+(Y(G,C)|0)|0;f[a>>2]=c;c=D>>31;G=(c^D)-c|0;D=(c^o)-c|0;c=(G|0)>(l|0);o=(c?G:0)^l;l=(c?o:0)^G;G=(c?l:0)^o;o=(c?D:0)^E;E=(c?o:0)^D;D=(c?E:0)^o;o=G<<1;c=l<<1;if(n){H=o;I=G-c|0;J=G;K=E}else{H=o+c|0;I=0;J=G+l|0;K=E-D|0}f[a+16>>2]=I;f[a+28>>2]=H;f[a+24>>2]=0-c;f[a+36>>2]=K;f[a+32>>2]=D;f[m>>2]=J+1;f[a+4>>2]=f[t>>2];y=C;z=f[e>>2]|0;A=a+8|0;f[A>>2]=z;B=a+12|0;f[B>>2]=y;u=i;return}function fma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=u;u=u+64|0;j=i+40|0;k=i+16|0;l=i;m=i+32|0;f[j>>2]=0;n=j+4|0;f[n>>2]=0;f[j+8>>2]=0;o=+(f[a+4>>2]|0);p[k>>3]=+(f[a>>2]|0);p[k+8>>3]=o;o=+(f[b+4>>2]|0);p[l>>3]=+(f[b>>2]|0);p[l+8>>3]=o;gma(k,l,c,d,e,g,j);g=h+4|0;e=f[g>>2]|0;d=f[h>>2]|0;c=e;if((e|0)==(d|0)|(c|0)==(d|0))q=e;else{e=c+(~((c+-8-d|0)>>>3)<<3)|0;f[g>>2]=e;q=e}e=f[n>>2]|0;c=f[j>>2]|0;l=c;if((e|0)==(c|0)){r=d;s=q;t=l}else{q=m+4|0;d=h+8|0;k=0;b=-2147483648;v=-2147483648;w=l;x=l;l=c;c=e;while(1){e=MVb(+p[w+(k<<4)>>3])|0;f[m>>2]=e;y=MVb(+p[w+(k<<4)+8>>3])|0;f[q>>2]=y;if((e|0)!=(b|0)|(y|0)!=(v|0)){z=f[g>>2]|0;if((z|0)==(f[d>>2]|0)){b2(h,m);A=f[n>>2]|0;B=f[j>>2]|0}else{f[z>>2]=e;f[z+4>>2]=y;f[g>>2]=z+8;A=c;B=l}C=f[m>>2]|0;D=f[q>>2]|0;E=B;F=A;G=B}else{C=b;D=v;E=l;F=c;G=x}k=k+1|0;if(k>>>0>=F-E>>4>>>0)break;else{b=C;v=D;w=E;x=G;l=E;c=F}}r=f[h>>2]|0;s=f[g>>2]|0;t=G}if((s-r|0)==8){hma(h,2,a);H=f[j>>2]|0}else H=t;if(!H){u=i;return}t=f[n>>2]|0;if((t|0)!=(H|0))f[n>>2]=t+(~((t+-16-H|0)>>>4)<<4);O5b(H);u=i;return}function gma(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0;i=u;u=u+32|0;j=i+16|0;k=i;dQ(j,58996);l=((c|0)>0?c:0)+359-c|0;m=l-((l>>>0)%360|0)+c|0;c=~m;l=m+((c|0)>-361?c:-361)+360|0;c=m+(((l>>>0)%360|0)-l)|0;l=(d|0)>(e|0);m=l?d:e;o=l?e:d;if((o|0)<0){l=~((e|0)<(d|0)?e:d);d=((o|0)>-360?o:-360)+l+360|0;e=d-((d>>>0)%360|0)|0;q=e+359-l|0;r=m+e+360|0}else{q=o;r=m}if((r|0)>360){m=r+-361|0;o=m-((m>>>0)%360|0)|0;s=q+-360-o|0;t=r+-360-o|0}else{s=q;t=r}r=(t-s|0)>360;q=r?360:t;t=r?0:s;s=(c>>31&360)+c|0;v=+n[59016+(s<<2)>>2];w=+n[59016+(450-s<<2)>>2];s=h+4|0;c=f[s>>2]|0;r=f[h>>2]|0;o=c;if((c|0)==(r|0)|(o|0)==(r|0)){x=c;y=o}else{c=o+(~((o+-16-r|0)>>>4)<<4)|0;f[s>>2]=c;x=c;y=c}c=q+g|0;if((t|0)<(c|0)){o=b+8|0;z=w;w=v;m=a+8|0;e=k+8|0;l=h+8|0;d=t;t=y;while(1){y=(d|0)>(q|0)?q:d;A=(y|0)<0?y+360|0:y;v=+p[b>>3]*+n[59016+(450-A<<2)>>2];B=+p[o>>3]*+n[59016+(A<<2)>>2];C=z*v+ +p[a>>3]-w*B;p[k>>3]=C;D=z*B+(w*v+ +p[m>>3]);p[e>>3]=D;if((t|0)==(f[l>>2]|0))ima(h,k);else{p[t>>3]=C;p[t+8>>3]=D;f[s>>2]=t+16}A=d+g|0;if((A|0)>=(c|0))break;d=A;t=f[s>>2]|0}E=f[h>>2]|0;F=f[s>>2]|0}else{E=r;F=x}if((F-E|0)==16)jma(h,2,a);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function hma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>3>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>3;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=c+4|0;o=m;m=h;while(1){f[m>>2]=f[c>>2];f[m+4>>2]=f[j>>2];o=o+-1|0;if(!o)break;else m=m+8|0}}if(!l){m=h+(b<<3)|0;if((n|0)==(m|0))return;else{p=i;q=n+(~((n+-8-m|0)>>>3)<<3)|0;break}}else{m=b-k|0;o=c+4|0;j=m;r=n;while(1){f[r>>2]=f[c>>2];f[r+4>>2]=f[o>>2];j=j+-1|0;if(!j)break;else r=r+8|0}p=i;q=n+(m<<3)|0;break}}else{r=g;if(!g)s=e;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(h|0))f[j>>2]=o+(~((o+-8-g|0)>>>3)<<3);O5b(r);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;s=0}if(b>>>0>536870911)c4b(a);j=s>>2;r=s>>3>>>0<268435455?(j>>>0<b>>>0?b:j):536870911;if(r>>>0>536870911)c4b(a);j=L5b(r<<3)|0;o=a+4|0;f[o>>2]=j;f[a>>2]=j;f[d>>2]=j+(r<<3);r=c+4|0;k=b;l=j;while(1){f[l>>2]=f[c>>2];f[l+4>>2]=f[r>>2];k=k+-1|0;if(!k)break;else l=l+8|0}p=o;q=j+(b<<3)|0}while(0);f[p>>2]=q;return}function ima(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)c4b(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=ze(8)|0;T5b(l,477177);f[l>>2]=149528;If(l|0,25408,1411)}else{n=L5b(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;p[l>>3]=+p[b>>3];p[n+(g<<4)+8>>3]=+p[b+8>>3];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;while(1){m=n;n=n+-16|0;p[j+-16>>3]=+p[n>>3];p[j+-8>>3]=+p[m+-8>>3];if((n|0)==(i|0))break;else j=j+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;O5b(e);return}function jma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>4>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>4;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=c+8|0;o=m;m=h;while(1){p[m>>3]=+p[c>>3];p[m+8>>3]=+p[j>>3];o=o+-1|0;if(!o)break;else m=m+16|0}}if(!l){m=h+(b<<4)|0;if((n|0)==(m|0))return;else{q=i;r=n+(~((n+-16-m|0)>>>4)<<4)|0;break}}else{m=b-k|0;o=c+8|0;j=m;s=n;while(1){p[s>>3]=+p[c>>3];p[s+8>>3]=+p[o>>3];j=j+-1|0;if(!j)break;else s=s+16|0}q=i;r=n+(m<<4)|0;break}}else{s=g;if(!g)t=e;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(h|0))f[j>>2]=o+(~((o+-16-g|0)>>>4)<<4);O5b(s);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;t=0}if(b>>>0>268435455)c4b(a);j=t>>3;s=t>>4>>>0<134217727?(j>>>0<b>>>0?b:j):268435455;if(s>>>0>268435455)c4b(a);j=L5b(s<<4)|0;o=a+4|0;f[o>>2]=j;f[a>>2]=j;f[d>>2]=j+(s<<4);s=c+8|0;k=b;l=j;while(1){p[l>>3]=+p[c>>3];p[l+8>>3]=+p[s>>3];k=k+-1|0;if(!k)break;else l=l+16|0}q=o;r=j+(b<<4)|0}while(0);f[q>>2]=r;return}function kma(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;j=u;u=u+128|0;k=j+120|0;l=j+64|0;m=j+32|0;n=j+16|0;o=j;dQ(k,60820);do if((yM(a)|0)==65536){p=f[a+4>>2]|0;f[l>>2]=f[p>>2];q=l+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=l+8|0;f[s>>2]=f[p+8>>2];f[l+12>>2]=f[p+12>>2];f[l+16>>2]=f[p+16>>2];f[l+20>>2]=f[p+20>>2];f[l+24>>2]=f[p+24>>2];f[l+28>>2]=f[p+28>>2];f[l+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[l+36>>2]=t;f[l+40>>2]=s;s=l+48|0;v=l+44|0;f[v>>2]=s;f[s>>2]=0;f[l+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;jL(l,p);break}}else yL(l,a,-1);while(0);if((h|0)==16)w=(f[l>>2]&7|0)==0?16:8;else w=h;if(g>>>0>=32768){f[m>>2]=0;f[m+4>>2]=0;x=aD(m,44)|0;y=267342;z=x+44|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,m,267387,267135,1817);bD(m)}if(i>>>0>=17){f[m>>2]=0;f[m+4>>2]=0;x=aD(m,31)|0;y=267392;z=x+31|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,m,267387,267135,1818);bD(m)}xM(e,m,f[l>>2]&4095,0);e=f[c>>2]|0;y=f[c+4>>2]|0;c=n;f[c>>2]=e;f[c+4>>2]=((e|0)<0)<<31>>31;e=n+8|0;f[e>>2]=y;f[e+4>>2]=((y|0)<0)<<31>>31;y=f[d>>2]|0;e=f[d+4>>2]|0;d=o;f[d>>2]=y;f[d+4>>2]=((y|0)<0)<<31>>31;y=o+8|0;f[y>>2]=e;f[y+4>>2]=((e|0)<0)<<31>>31;lma(l,n,o,m,g,w,3,i);i=l+36|0;w=f[i>>2]|0;if(w|0?(g=w+12|0,w=f[g>>2]|0,f[g>>2]=w+-1,(w|0)==1):0)kL(l);f[i>>2]=0;i=l+16|0;w=l+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[w>>2]|0)>0){i=f[l+40>>2]|0;g=0;do{f[i+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[w>>2]|0))}w=f[l+44>>2]|0;if((w|0)!=(l+48|0))UC(w);if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function lma(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,N=0.0,O=0.0,P=0.0,Q=0.0;j=u;u=u+176|0;k=j+80|0;l=j+64|0;m=j+48|0;n=j+32|0;o=j+96|0;p=j+160|0;q=j+16|0;r=j;s=16-i|0;t=b;v=$ac(f[t>>2]|0,f[t+4>>2]|0,s|0)|0;t=b;f[t>>2]=v;f[t+4>>2]=J;t=b+8|0;v=t;w=$ac(f[v>>2]|0,f[v+4>>2]|0,s|0)|0;v=t;f[v>>2]=w;f[v+4>>2]=J;v=c;w=$ac(f[v>>2]|0,f[v+4>>2]|0,s|0)|0;v=J;x=c;f[x>>2]=w;f[x+4>>2]=v;x=c+8|0;y=x;z=$ac(f[y>>2]|0,f[y+4>>2]|0,s|0)|0;s=J;y=x;f[y>>2]=z;f[y+4>>2]=s;if((e|0)<2){if((g|0)>=16){y=b;A=f[y+4>>2]|0;B=m;f[B>>2]=f[y>>2];f[B+4>>2]=A;A=t;B=f[A+4>>2]|0;y=m+8|0;f[y>>2]=f[A>>2];f[y+4>>2]=B;B=n;f[B>>2]=w;f[B+4>>2]=v;B=n+8|0;f[B>>2]=z;f[B+4>>2]=s;oma(a,m,n,d);u=j;return}a:do if(i|0){switch(g|0){case 1:case 4:{break a;break}default:{}}n=b;m=f[n+4>>2]|0;B=k;f[B>>2]=f[n>>2];f[B+4>>2]=m;m=t;B=f[m+4>>2]|0;n=k+8|0;f[n>>2]=f[m>>2];f[n+4>>2]=B;B=l;f[B>>2]=w;f[B+4>>2]=v;B=l+8|0;f[B>>2]=z;f[B+4>>2]=s;nma(a,k,l,d);u=j;return}while(0);l=b;k=Kac(f[l>>2]|0,f[l+4>>2]|0,32768,0)|0;l=Rac(k|0,J|0,16)|0;k=b;f[k>>2]=l;f[k+4>>2]=J;k=t;l=Kac(f[k>>2]|0,f[k+4>>2]|0,32768,0)|0;k=Rac(l|0,J|0,16)|0;l=t;f[l>>2]=k;f[l+4>>2]=J;l=c;k=Kac(f[l>>2]|0,f[l+4>>2]|0,32768,0)|0;l=Rac(k|0,J|0,16)|0;k=J;i=c;f[i>>2]=l;f[i+4>>2]=k;i=x;B=Kac(f[i>>2]|0,f[i+4>>2]|0,32768,0)|0;i=Rac(B|0,J|0,16)|0;B=J;n=x;f[n>>2]=i;f[n+4>>2]=B;n=b;m=f[n>>2]|0;y=f[n+4>>2]|0;n=Kac(m|0,y|0,-2147483648,0)|0;A=J;C=t;D=f[C>>2]|0;E=f[C+4>>2]|0;C=Kac(D|0,E|0,-2147483648,0)|0;F=J;G=Kac(l|0,k|0,-2147483648,0)|0;H=J;I=Kac(i|0,B|0,-2147483648,0)|0;K=J;mma(a,A>>>0<1|(A|0)==1&n>>>0<0?m:(y|0)>0|(y|0)==0&m>>>0>0?2147483647:-2147483648,F>>>0<1|(F|0)==1&C>>>0<0?D:(E|0)>0|(E|0)==0&D>>>0>0?2147483647:-2147483648,H>>>0<1|(H|0)==1&G>>>0<0?l:(k|0)>0|(k|0)==0&l>>>0>0?2147483647:-2147483648,K>>>0<1|(K|0)==1&I>>>0<0?i:(B|0)>0|(B|0)==0&i>>>0>0?2147483647:-2147483648,d,g);u=j;return}i=o;B=i+64|0;do{f[i>>2]=0;i=i+4|0}while((i|0)<(B|0));i=b;B=f[i>>2]|0;I=f[i+4>>2]|0;i=Jac(B|0,I|0,w|0,v|0)|0;N=(+(i>>>0)+4294967296.0*+(J|0))*.0000152587890625;i=t;K=f[i>>2]|0;l=f[i+4>>2]|0;i=Jac(z|0,s|0,K|0,l|0)|0;O=(+(i>>>0)+4294967296.0*+(J|0))*.0000152587890625;P=N*N+O*O;i=e<<15;if(+L(+P)>2.220446049250313e-16){Q=(+(i|0)+ +(e<<16&65536|0)*.5)/+M(+P);e=MVb(O*Q)|0;k=((e|0)<0)<<31>>31;G=MVb(N*Q)|0;H=((G|0)<0)<<31>>31;D=Kac(e|0,k|0,B|0,I|0)|0;E=o;f[E>>2]=D;f[E+4>>2]=J;E=Kac(K|0,l|0,G|0,H|0)|0;D=o+8|0;f[D>>2]=E;f[D+4>>2]=J;D=Jac(B|0,I|0,e|0,k|0)|0;I=o+16|0;f[I>>2]=D;f[I+4>>2]=J;I=Jac(K|0,l|0,G|0,H|0)|0;l=o+24|0;f[l>>2]=I;f[l+4>>2]=J;l=Jac(w|0,v|0,e|0,k|0)|0;I=o+32|0;f[I>>2]=l;f[I+4>>2]=J;I=Jac(z|0,s|0,G|0,H|0)|0;l=o+40|0;f[l>>2]=I;f[l+4>>2]=J;l=Kac(w|0,v|0,e|0,k|0)|0;k=o+48|0;f[k>>2]=l;f[k+4>>2]=J;k=Kac(z|0,s|0,G|0,H|0)|0;H=o+56|0;f[H>>2]=k;f[H+4>>2]=J;pma(a,o,4,d,g,16)}o=p+4|0;H=i+32768>>16;k=q+8|0;G=((i|0)<0)<<31>>31;s=r+8|0;z=(h&1|0)==0;if((g|0)<16){if(!z){l=b;e=Kac(f[l>>2]|0,f[l+4>>2]|0,32768,0)|0;l=Sac(e|0,J|0,16)|0;e=t;v=Kac(f[e>>2]|0,f[e+4>>2]|0,32768,0)|0;e=Sac(v|0,J|0,16)|0;f[p>>2]=l;f[o>>2]=e;qma(a,p,H,d,1)}e=c;l=f[e>>2]|0;v=f[e+4>>2]|0;e=b;f[e>>2]=l;f[e+4>>2]=v;e=x;w=f[e>>2]|0;I=f[e+4>>2]|0;e=t;f[e>>2]=w;f[e+4>>2]=I;if(h&2|0){e=Kac(l|0,v|0,32768,0)|0;v=Sac(e|0,J|0,16)|0;e=Kac(w|0,I|0,32768,0)|0;I=Sac(e|0,J|0,16)|0;f[p>>2]=v;f[o>>2]=I;qma(a,p,H,d,1)}}else{if(!z){z=b;H=f[z+4>>2]|0;p=q;f[p>>2]=f[z>>2];f[p+4>>2]=H;H=t;p=f[H+4>>2]|0;z=k;f[z>>2]=f[H>>2];f[z+4>>2]=p;p=r;f[p>>2]=i;f[p+4>>2]=G;p=s;f[p>>2]=i;f[p+4>>2]=G;rma(a,q,r,0,0,360,d,-1,g)}p=c;z=f[p>>2]|0;H=f[p+4>>2]|0;p=b;f[p>>2]=z;f[p+4>>2]=H;p=x;I=f[p>>2]|0;o=f[p+4>>2]|0;p=t;f[p>>2]=I;f[p+4>>2]=o;if(h&2|0){h=q;f[h>>2]=z;f[h+4>>2]=H;H=k;f[H>>2]=I;f[H+4>>2]=o;o=r;f[o>>2]=i;f[o+4>>2]=G;o=s;f[o>>2]=i;f[o+4>>2]=G;rma(a,q,r,0,0,360,d,-1,g)}}g=c;c=f[g+4>>2]|0;d=b;f[d>>2]=f[g>>2];f[d+4>>2]=c;c=x;x=f[c+4>>2]|0;d=t;f[d>>2]=f[c>>2];f[d+4>>2]=x;u=j;return}function mma(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=u;u=u+64|0;k=j+16|0;l=j+8|0;m=j;switch(i|0){case 0:{n=8;break}case 1:{n=4;break}default:n=i}f[l>>2]=c;f[l+4>>2]=d;f[m>>2]=e;f[m+4>>2]=g;ema(k,a,l,m,n,1);n=f[k+20>>2]|0;m=f[a+4>>2]|0;if((m|0)>0)o=f[(f[a+44>>2]|0)+(m+-1<<2)>>2]|0;else o=0;if((n|0)<=0){u=j;return}m=k+16|0;a=k+24|0;l=k+28|0;g=k+32|0;e=k+36|0;d=h+1|0;c=h+2|0;switch(o|0){case 1:{i=0;p=f[k>>2]|0;do{b[p>>0]=b[h>>0]|0;i=i+1|0;q=f[m>>2]|0;r=q>>31;f[m>>2]=(f[a>>2]|0)+q+(f[l>>2]&r);p=(f[k>>2]|0)+((f[e>>2]&r)+(f[g>>2]|0))|0;f[k>>2]=p}while((i|0)!=(n|0));u=j;return}case 3:{i=0;p=f[k>>2]|0;do{b[p>>0]=b[h>>0]|0;b[p+1>>0]=b[d>>0]|0;b[p+2>>0]=b[c>>0]|0;i=i+1|0;r=f[m>>2]|0;q=r>>31;f[m>>2]=(f[a>>2]|0)+r+(f[l>>2]&q);p=(f[k>>2]|0)+((f[e>>2]&q)+(f[g>>2]|0))|0;f[k>>2]=p}while((i|0)!=(n|0));u=j;return}default:{i=0;p=f[k>>2]|0;do{Vac(p|0,h|0,o|0)|0;i=i+1|0;c=f[m>>2]|0;d=c>>31;f[m>>2]=(f[a>>2]|0)+c+(f[l>>2]&d);p=(f[k>>2]|0)+((f[e>>2]&d)+(f[g>>2]|0))|0;f[k>>2]=p}while((i|0)!=(n|0));u=j;return}}}function nma(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;g=u;u=u+16|0;h=g;i=b[e>>0]|0;j=b[e+1>>0]|0;k=b[e+2>>0]|0;l=f[a+4>>2]|0;if((l|0)>0)m=f[(f[a+44>>2]|0)+(l+-1<<2)>>2]|0;else m=0;l=f[a+16>>2]|0;n=f[a+48>>2]|0;o=f[a+40>>2]|0;a=f[o+4>>2]|0;p=f[o>>2]|0;o=$ac(a|0,((a|0)<0)<<31>>31|0,16)|0;q=J;r=$ac(p|0,((p|0)<0)<<31>>31|0,16)|0;s=h;f[s>>2]=o;f[s+4>>2]=q;q=h+8|0;f[q>>2]=r;f[q+4>>2]=J;if(!(dma(h,c,d)|0)){u=g;return}h=d;q=f[h>>2]|0;r=f[h+4>>2]|0;h=c;s=f[h>>2]|0;o=f[h+4>>2]|0;h=Jac(q|0,r|0,s|0,o|0)|0;t=J;v=d+8|0;w=v;x=f[w>>2]|0;y=f[w+4>>2]|0;w=c+8|0;z=w;A=f[z>>2]|0;B=f[z+4>>2]|0;z=Jac(x|0,y|0,A|0,B|0)|0;C=J;D=Rac(h|0,t|0,63)|0;E=J;F=Jac(D^h|0,E^t|0,D|0,E|0)|0;G=J;H=Rac(z|0,C|0,63)|0;I=J;K=Jac(H^z|0,I^C|0,H|0,I|0)|0;L=J;M=(G|0)>(L|0)|(G|0)==(L|0)&F>>>0>K>>>0;if(M){N=Jac(z^D|0,C^E|0,D|0,E|0)|0;C=D&q^s;z=E&r^o;O=c;f[O>>2]=C;f[O+4>>2]=z;O=d;P=f[O>>2]^C&D;C=f[O+4>>2]^z&E;z=d;f[z>>2]=P;f[z+4>>2]=C;z=c;O=f[z>>2]^P&D;P=f[z+4>>2]^C&E;C=c;f[C>>2]=O;f[C+4>>2]=P;C=D&x^A;z=E&y^B;Q=w;f[Q>>2]=C;f[Q+4>>2]=z;Q=v;R=f[Q>>2]^C&D;C=f[Q+4>>2]^z&E;z=v;f[z>>2]=R;f[z+4>>2]=C;z=w;Q=f[z>>2]^R&D;D=f[z+4>>2]^C&E;E=w;f[E>>2]=Q;f[E+4>>2]=D;E=$ac(N|0,J|0,16)|0;N=abc(E|0,J|0,F|1|0,G|0)|0;S=d;T=O;U=P;V=O;W=P;X=Q;Z=D;_=N;$=J;aa=65536;ba=0}else{N=Jac(H^h|0,I^t|0,H|0,I|0)|0;t=H&q^s;s=I&r^o;o=c;f[o>>2]=t;f[o+4>>2]=s;o=d;r=f[o>>2]^t&H;t=f[o+4>>2]^s&I;s=d;f[s>>2]=r;f[s+4>>2]=t;s=c;o=f[s>>2]^r&H;r=f[s+4>>2]^t&I;t=c;f[t>>2]=o;f[t+4>>2]=r;t=A^x&H;x=B^y&I;y=w;f[y>>2]=t;f[y+4>>2]=x;y=v;B=f[y>>2]^t&H;t=f[y+4>>2]^x&I;x=v;f[x>>2]=B;f[x+4>>2]=t;x=w;y=f[x>>2]^B&H;H=f[x+4>>2]^t&I;I=w;f[I>>2]=y;f[I+4>>2]=H;I=$ac(N|0,J|0,16)|0;N=abc(I|0,J|0,K|1|0,L|0)|0;S=v;T=y;U=H;V=o;W=r;X=y;Z=H;_=65536;$=0;aa=N;ba=J}N=S;S=Jac(f[N>>2]|0,f[N+4>>2]|0,T|0,U|0)|0;U=Sac(S|0,J|0,16)|0;S=Kac(V|0,W|0,32768,0)|0;W=c;f[W>>2]=S;f[W+4>>2]=J;W=Kac(X|0,Z|0,32768,0)|0;Z=w;f[Z>>2]=W;f[Z+4>>2]=J;Z=d;d=v;v=f[d>>2]|0;W=f[d+4>>2]|0;d=Kac(f[Z>>2]|0,f[Z+4>>2]|0,32768,0)|0;Z=J;X=Kac(v|0,W|0,32768,0)|0;W=Sac(X|0,J|0,16)|0;X=Sac(d|0,Z|0,16)|0;Z=(X|0)>-1;switch(m|0){case 3:{if(Z?(d=l+(Y(W,n)|0)+(X*3|0)|0,(W|0)<(p|0)&((X|0)<(a|0)&(W|0)>-1)):0){b[d>>0]=i;b[d+1>>0]=j;b[d+2>>0]=k}if(M){d=c;v=Rac(f[d>>2]|0,f[d+4>>2]|0,16)|0;d=J;S=c;f[S>>2]=v;f[S+4>>2]=d;if((U|0)<=-1){u=g;return}S=w;V=U;T=f[S>>2]|0;N=f[S+4>>2]|0;S=v;v=d;while(1){d=Sac(T|0,N|0,16)|0;if((S|0)>-1?(H=l+(Y(d,n)|0)+(S*3|0)|0,(d|0)<(p|0)&((S|0)<(a|0)&(d|0)>-1)):0){b[H>>0]=i;b[H+1>>0]=j;b[H+2>>0]=k;H=c;d=w;ca=f[H>>2]|0;da=f[H+4>>2]|0;ea=f[d>>2]|0;fa=f[d+4>>2]|0}else{ca=S;da=v;ea=T;fa=N}S=Kac(ca|0,da|0,1,0)|0;v=J;d=c;f[d>>2]=S;f[d+4>>2]=v;T=Kac(ea|0,fa|0,_|0,$|0)|0;N=J;d=w;f[d>>2]=T;f[d+4>>2]=N;if((V|0)<=0)break;else V=V+-1|0}u=g;return}else{V=w;N=Rac(f[V>>2]|0,f[V+4>>2]|0,16)|0;V=J;T=w;f[T>>2]=N;f[T+4>>2]=V;if((U|0)<=-1){u=g;return}T=c;fa=U;ea=f[T>>2]|0;v=f[T+4>>2]|0;T=N;N=V;while(1){V=Sac(ea|0,v|0,16)|0;if((V|0)>-1?(S=l+(Y(T,n)|0)+(V*3|0)|0,(T|0)<(p|0)&((V|0)<(a|0)&(T|0)>-1)):0){b[S>>0]=i;b[S+1>>0]=j;b[S+2>>0]=k;S=c;V=w;ga=f[S>>2]|0;ha=f[S+4>>2]|0;ia=f[V>>2]|0;ja=f[V+4>>2]|0}else{ga=ea;ha=v;ia=T;ja=N}ea=Kac(ga|0,ha|0,aa|0,ba|0)|0;v=J;V=c;f[V>>2]=ea;f[V+4>>2]=v;T=Kac(ia|0,ja|0,1,0)|0;N=J;V=w;f[V>>2]=T;f[V+4>>2]=N;if((fa|0)<=0)break;else fa=fa+-1|0}u=g;return}break}case 1:{if(Z?(W|0)<(p|0)&((X|0)<(a|0)&(W|0)>-1):0){fa=l+(Y(W,n)|0)+X|0;b[fa>>0]=i}if(M){fa=c;N=Rac(f[fa>>2]|0,f[fa+4>>2]|0,16)|0;fa=J;T=c;f[T>>2]=N;f[T+4>>2]=fa;if((U|0)<=-1){u=g;return}T=w;ja=U;ia=f[T>>2]|0;v=f[T+4>>2]|0;T=N;N=fa;while(1){fa=Sac(ia|0,v|0,16)|0;if((T|0)>-1?(fa|0)<(p|0)&((T|0)<(a|0)&(fa|0)>-1):0){ea=l+(Y(fa,n)|0)+T|0;b[ea>>0]=i;ea=c;fa=w;ka=f[ea>>2]|0;la=f[ea+4>>2]|0;ma=f[fa>>2]|0;na=f[fa+4>>2]|0}else{ka=T;la=N;ma=ia;na=v}T=Kac(ka|0,la|0,1,0)|0;N=J;fa=c;f[fa>>2]=T;f[fa+4>>2]=N;ia=Kac(ma|0,na|0,_|0,$|0)|0;v=J;fa=w;f[fa>>2]=ia;f[fa+4>>2]=v;if((ja|0)<=0)break;else ja=ja+-1|0}u=g;return}else{ja=w;v=Rac(f[ja>>2]|0,f[ja+4>>2]|0,16)|0;ja=J;ia=w;f[ia>>2]=v;f[ia+4>>2]=ja;if((U|0)<=-1){u=g;return}ia=c;na=U;ma=f[ia>>2]|0;N=f[ia+4>>2]|0;ia=v;v=ja;while(1){ja=Sac(ma|0,N|0,16)|0;if((ja|0)>-1?(ia|0)<(p|0)&((ja|0)<(a|0)&(ia|0)>-1):0){T=l+(Y(ia,n)|0)+ja|0;b[T>>0]=i;T=c;ja=w;oa=f[T>>2]|0;pa=f[T+4>>2]|0;qa=f[ja>>2]|0;ra=f[ja+4>>2]|0}else{oa=ma;pa=N;qa=ia;ra=v}ma=Kac(oa|0,pa|0,aa|0,ba|0)|0;N=J;ja=c;f[ja>>2]=ma;f[ja+4>>2]=N;ia=Kac(qa|0,ra|0,1,0)|0;v=J;ja=w;f[ja>>2]=ia;f[ja+4>>2]=v;if((na|0)<=0)break;else na=na+-1|0}u=g;return}break}default:{if((Z?(W|0)<(p|0)&((X|0)<(a|0)&(W|0)>-1):0)?(Z=l+(Y(W,n)|0)+(Y(X,m)|0)|0,X=((m|0)<0)<<31>>31,(m|0)>0):0){W=0;na=0;do{b[Z+W>>0]=b[e+W>>0]|0;W=Kac(W|0,na|0,1,0)|0;na=J}while((na|0)<(X|0)|(na|0)==(X|0)&W>>>0<m>>>0)}if(M){M=c;W=Rac(f[M>>2]|0,f[M+4>>2]|0,16)|0;M=J;X=c;f[X>>2]=W;f[X+4>>2]=M;if((U|0)<=-1){u=g;return}X=((m|0)<0)<<31>>31;na=w;Z=f[na>>2]|0;v=f[na+4>>2]|0;if((m|0)>0){sa=U;ta=Z;ua=v;va=W;wa=M}else{na=U;ia=W;W=M;M=Z;Z=v;while(1){ia=Kac(ia|0,W|0,1,0)|0;W=J;M=Kac(M|0,Z|0,_|0,$|0)|0;Z=J;if((na|0)<=0)break;else na=na+-1|0}na=c;f[na>>2]=ia;f[na+4>>2]=W;W=w;f[W>>2]=M;f[W+4>>2]=Z;u=g;return}while(1){Z=Sac(ta|0,ua|0,16)|0;if((va|0)>-1?(Z|0)<(p|0)&((va|0)<(a|0)&(Z|0)>-1):0){W=l+(Y(Z,n)|0)+(Y(va,m)|0)|0;Z=0;M=0;do{b[W+Z>>0]=b[e+Z>>0]|0;Z=Kac(Z|0,M|0,1,0)|0;M=J}while((M|0)<(X|0)|(M|0)==(X|0)&Z>>>0<m>>>0);Z=c;M=w;xa=f[Z>>2]|0;ya=f[Z+4>>2]|0;za=f[M>>2]|0;Aa=f[M+4>>2]|0}else{xa=va;ya=wa;za=ta;Aa=ua}va=Kac(xa|0,ya|0,1,0)|0;wa=J;M=c;f[M>>2]=va;f[M+4>>2]=wa;ta=Kac(za|0,Aa|0,_|0,$|0)|0;ua=J;M=w;f[M>>2]=ta;f[M+4>>2]=ua;if((sa|0)<=0)break;else sa=sa+-1|0}u=g;return}else{sa=w;ua=Rac(f[sa>>2]|0,f[sa+4>>2]|0,16)|0;sa=J;ta=w;f[ta>>2]=ua;f[ta+4>>2]=sa;if((U|0)<=-1){u=g;return}ta=((m|0)<0)<<31>>31;$=c;_=f[$>>2]|0;Aa=f[$+4>>2]|0;if((m|0)>0){Ba=U;Ca=_;Da=Aa;Ea=ua;Fa=sa}else{$=U;U=_;_=Aa;Aa=ua;ua=sa;while(1){U=Kac(U|0,_|0,aa|0,ba|0)|0;_=J;Aa=Kac(Aa|0,ua|0,1,0)|0;ua=J;if(($|0)<=0)break;else $=$+-1|0}$=c;f[$>>2]=U;f[$+4>>2]=_;_=w;f[_>>2]=Aa;f[_+4>>2]=ua;u=g;return}while(1){ua=Sac(Ca|0,Da|0,16)|0;if((ua|0)>-1?(Ea|0)<(p|0)&((ua|0)<(a|0)&(Ea|0)>-1):0){_=l+(Y(Ea,n)|0)+(Y(ua,m)|0)|0;ua=0;Aa=0;do{b[_+ua>>0]=b[e+ua>>0]|0;ua=Kac(ua|0,Aa|0,1,0)|0;Aa=J}while((Aa|0)<(ta|0)|(Aa|0)==(ta|0)&ua>>>0<m>>>0);ua=c;Aa=w;Ga=f[ua>>2]|0;Ha=f[ua+4>>2]|0;Ia=f[Aa>>2]|0;Ja=f[Aa+4>>2]|0}else{Ga=Ca;Ha=Da;Ia=Ea;Ja=Fa}Ca=Kac(Ga|0,Ha|0,aa|0,ba|0)|0;Da=J;Aa=c;f[Aa>>2]=Ca;f[Aa+4>>2]=Da;Ea=Kac(Ia|0,Ja|0,1,0)|0;Fa=J;Aa=w;f[Aa>>2]=Ea;f[Aa+4>>2]=Fa;if((Ba|0)<=0)break;else Ba=Ba+-1|0}u=g;return}}}}function oma(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;g=u;u=u+64|0;i=g+16|0;j=g;k=h[e>>0]|0;l=h[e+1>>0]|0;m=h[e+2>>0]|0;n=h[e+3>>0]|0;o=f[a>>2]|0;p=o>>>3;q=f[a+16>>2]|0;r=f[a+48>>2]|0;s=f[a+40>>2]|0;t=f[s+4>>2]|0;v=f[s>>2]|0;s=p&65535;switch(s&511){case 0:case 2:case 3:{if(!(o&7)){o=c;w=Kac(f[o>>2]|0,f[o+4>>2]|0,-131072,-1)|0;o=c;f[o>>2]=w;f[o+4>>2]=J;o=c+8|0;w=o;x=Kac(f[w>>2]|0,f[w+4>>2]|0,-131072,-1)|0;w=o;f[w>>2]=x;f[w+4>>2]=J;w=d;x=Kac(f[w>>2]|0,f[w+4>>2]|0,-131072,-1)|0;w=d;f[w>>2]=x;f[w+4>>2]=J;w=d+8|0;x=w;y=Kac(f[x>>2]|0,f[x+4>>2]|0,-131072,-1)|0;x=w;f[x>>2]=y;f[x+4>>2]=J;x=q+((p&511)+1+r<<1)|0;p=$ac(t|0,((t|0)<0)<<31>>31|0,16)|0;t=Kac(p|0,J|0,-327679,-1)|0;p=J;q=$ac(v|0,((v|0)<0)<<31>>31|0,16)|0;v=Kac(q|0,J|0,-327679,-1)|0;q=j;f[q>>2]=t;f[q+4>>2]=p;p=j+8|0;f[p>>2]=v;f[p+4>>2]=J;if(!(dma(j,c,d)|0)){u=g;return}j=d;p=f[j>>2]|0;v=f[j+4>>2]|0;j=c;q=f[j>>2]|0;t=f[j+4>>2]|0;j=Jac(p|0,v|0,q|0,t|0)|0;y=J;z=w;A=f[z>>2]|0;B=f[z+4>>2]|0;z=o;C=f[z>>2]|0;D=f[z+4>>2]|0;z=Jac(A|0,B|0,C|0,D|0)|0;E=J;F=Rac(j|0,y|0,63)|0;G=J;H=Jac(F^j|0,G^y|0,F|0,G|0)|0;I=J;K=Rac(z|0,E|0,63)|0;L=J;M=Jac(K^z|0,L^E|0,K|0,L|0)|0;N=J;O=(I|0)>(N|0)|(I|0)==(N|0)&H>>>0>M>>>0;if(O){P=Jac(z^F|0,E^G|0,F|0,G|0)|0;E=F&p^q;z=G&v^t;Q=c;f[Q>>2]=E;f[Q+4>>2]=z;Q=d;R=f[Q>>2]^E&F;E=f[Q+4>>2]^z&G;z=d;f[z>>2]=R;f[z+4>>2]=E;z=c;Q=f[z+4>>2]^E&G;E=c;f[E>>2]=f[z>>2]^R&F;f[E+4>>2]=Q;Q=F&A^C;E=G&B^D;R=o;f[R>>2]=Q;f[R+4>>2]=E;R=w;z=f[R>>2]^Q&F;Q=f[R+4>>2]^E&G;E=w;f[E>>2]=z;f[E+4>>2]=Q;E=o;R=f[E>>2]^z&F;F=f[E+4>>2]^Q&G;G=$ac(P|0,J|0,16)|0;P=abc(G|0,J|0,H|1|0,I|0)|0;I=J;H=d;G=Kac(f[H>>2]|0,f[H+4>>2]|0,65536,0)|0;H=J;Q=d;f[Q>>2]=G;f[Q+4>>2]=H;Q=Sac(G|0,H|0,16)|0;E=J;z=c;S=f[z>>2]|0;T=f[z+4>>2]|0;z=Sac(S|0,T|0,16)|0;U=Jac(Q|0,E|0,z|0,J|0)|0;z=Jac(0,0,P|0,I|0)|0;E=cbc(S&65535|0,0,z|0,J|0)|0;z=Rac(E|0,J|0,16)|0;E=J;Q=Kac(R|0,F|0,32768,0)|0;F=Kac(Q|0,J|0,z|0,E|0)|0;E=J;z=o;f[z>>2]=F;f[z+4>>2]=E;z=Sac(P|0,I|0,11)|0;Q=Rac(S|0,T|0,9)|0;R=J;V=Rac(G|0,H|0,9)|0;W=U;X=z&63^((I|0)<0?63:0);Z=J;_=R;$=Q;aa=V;ba=S;ca=T;da=P;ea=I;fa=F;ga=E;ha=65536;ia=0}else{E=Jac(K^j|0,L^y|0,K|0,L|0)|0;y=K&p^q;q=L&v^t;t=c;f[t>>2]=y;f[t+4>>2]=q;t=d;v=f[t>>2]^y&K;y=f[t+4>>2]^q&L;q=d;f[q>>2]=v;f[q+4>>2]=y;q=c;t=f[q>>2]^v&K;v=f[q+4>>2]^y&L;y=C^A&K;A=D^B&L;B=o;f[B>>2]=y;f[B+4>>2]=A;B=w;D=f[B>>2]^y&K;y=f[B+4>>2]^A&L;A=w;f[A>>2]=D;f[A+4>>2]=y;A=o;B=f[A+4>>2]^y&L;L=o;f[L>>2]=f[A>>2]^D&K;f[L+4>>2]=B;B=$ac(E|0,J|0,16)|0;E=abc(B|0,J|0,M|1|0,N|0)|0;N=J;M=w;B=Kac(f[M>>2]|0,f[M+4>>2]|0,65536,0)|0;M=J;L=w;f[L>>2]=B;f[L+4>>2]=M;L=Sac(B|0,M|0,16)|0;w=J;K=o;D=f[K>>2]|0;A=f[K+4>>2]|0;K=Sac(D|0,A|0,16)|0;y=Jac(L|0,w|0,K|0,J|0)|0;K=Jac(0,0,E|0,N|0)|0;w=cbc(D&65535|0,0,K|0,J|0)|0;K=Rac(w|0,J|0,16)|0;w=J;L=Kac(t|0,v|0,32768,0)|0;v=Kac(L|0,J|0,K|0,w|0)|0;w=J;K=c;f[K>>2]=v;f[K+4>>2]=w;K=Sac(E|0,N|0,11)|0;L=Sac(D|0,A|0,9)|0;t=J;C=Sac(B|0,M|0,9)|0;W=y;X=K&63^((N|0)<0?63:0);Z=J;_=t;$=L;aa=C;ba=v;ca=w;da=65536;ea=0;fa=D;ga=A;ha=E;ia=N}N=$&120;$=aa&120;if(!(X&32))ja=h[267483+X>>0]|0;else ja=256;X=ja<<7;aa=Y(ja,120-N|4)|0;E=Y(ja,$|4)|0;f[i>>2]=0;f[i+32>>2]=ja;A=Jac($|0,0,N|0,0)|0;N=J;$=cbc(ja|0,0,A&120|4|0,0)|0;D=Sac($|0,J|0,8)|0;f[i+12>>2]=D;f[i+4>>2]=D;f[i+8>>2]=aa>>>8&511;D=Kac(A|0,N|0,128,0)|0;N=cbc(ja|0,0,D|4|0,J|0)|0;D=Sac(N|0,J|0,8)|0;f[i+16>>2]=D&511;f[i+20>>2]=(aa+X|0)>>>8&511;f[i+24>>2]=E>>>8;f[i+28>>2]=(E+X|0)>>>8&511;switch(s&511){case 2:{s=(W|0)>-1;if(O){if(!s){u=g;return}X=Rac(ba|0,ca|0,16)|0;E=cbc(X|0,J|0,3,0)|0;X=0;aa=x+E|0;E=W;D=fa;N=ga;while(1){ja=Rac(D|0,N|0,16)|0;A=Kac(ja|0,J|0,-1,-1)|0;ja=cbc(A|0,J|0,r|0,0)|0;A=aa+ja|0;ja=f[i+(((((X|0)>1?2:1)&(X|2))*3|0)+(((E|0)>1?2:1)&(E|2))<<2)>>2]|0;$=Sac(D|0,N|0,11)|0;w=$&31;$=(Y(f[60840+((w|32)<<2)>>2]|0,ja)|0)>>>8&255;v=h[A>>0]|0;C=(((Y(k-v|0,$)|0)+127|0)>>>8)+v|0;v=A+1|0;L=h[v>>0]|0;t=(((Y(l-L|0,$)|0)+127|0)>>>8)+L|0;L=A+2|0;_=h[L>>0]|0;Z=(((Y(m-_|0,$)|0)+127|0)>>>8)+_|0;_=(((Y(l-(t&255)|0,$)|0)+127|0)>>>8)+t|0;t=(((Y(m-(Z&255)|0,$)|0)+127|0)>>>8)+Z|0;Z=(((Y(k-(C&255)|0,$)|0)+127|0)>>>8)+C&255;b[A>>0]=Z;b[v>>0]=_;b[L>>0]=t;t=A+r|0;A=(Y(f[60840+(w<<2)>>2]|0,ja)|0)>>>8&255;L=h[t>>0]|0;_=(((Y(k-L|0,A)|0)+127|0)>>>8)+L|0;L=t+1|0;v=h[L>>0]|0;Z=(((Y(l-v|0,A)|0)+127|0)>>>8)+v|0;v=t+2|0;C=h[v>>0]|0;$=(((Y(m-C|0,A)|0)+127|0)>>>8)+C|0;C=(((Y(l-(Z&255)|0,A)|0)+127|0)>>>8)+Z|0;Z=(((Y(m-($&255)|0,A)|0)+127|0)>>>8)+$|0;$=(((Y(k-(_&255)|0,A)|0)+127|0)>>>8)+_&255;b[t>>0]=$;b[L>>0]=C;b[v>>0]=Z;Z=t+r|0;t=(Y(f[60840+((w^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[Z>>0]|0;w=(((Y(k-ja|0,t)|0)+127|0)>>>8)+ja|0;ja=Z+1|0;v=h[ja>>0]|0;C=(((Y(l-v|0,t)|0)+127|0)>>>8)+v|0;v=Z+2|0;L=h[v>>0]|0;$=(((Y(m-L|0,t)|0)+127|0)>>>8)+L|0;L=(((Y(l-(C&255)|0,t)|0)+127|0)>>>8)+C|0;C=(((Y(m-($&255)|0,t)|0)+127|0)>>>8)+$|0;$=(((Y(k-(w&255)|0,t)|0)+127|0)>>>8)+w&255;b[Z>>0]=$;b[ja>>0]=L;b[v>>0]=C;C=o;D=Kac(f[C>>2]|0,f[C+4>>2]|0,da|0,ea|0)|0;N=J;C=o;f[C>>2]=D;f[C+4>>2]=N;if((E|0)<=0)break;else{X=X+1|0;aa=aa+3|0;E=E+-1|0}}u=g;return}else{if(!s){u=g;return}s=Rac(fa|0,ga|0,16)|0;E=cbc(s|0,J|0,r|0,0)|0;s=0;aa=x+E|0;E=W;X=ba;N=ca;while(1){D=Rac(X|0,N|0,16)|0;C=cbc(D|0,J|0,3,0)|0;D=Kac(C|0,J|0,-3,0)|0;C=aa+D|0;D=f[i+(((((s|0)>1?2:1)&(s|2))*3|0)+(((E|0)>1?2:1)&(E|2))<<2)>>2]|0;v=Sac(X|0,N|0,11)|0;L=v&31;v=(Y(f[60840+((L|32)<<2)>>2]|0,D)|0)>>>8&255;ja=h[C>>0]|0;$=(((Y(k-ja|0,v)|0)+127|0)>>>8)+ja|0;ja=C+1|0;Z=h[ja>>0]|0;w=(((Y(l-Z|0,v)|0)+127|0)>>>8)+Z|0;Z=C+2|0;t=h[Z>>0]|0;_=(((Y(m-t|0,v)|0)+127|0)>>>8)+t|0;t=(((Y(l-(w&255)|0,v)|0)+127|0)>>>8)+w|0;w=(((Y(m-(_&255)|0,v)|0)+127|0)>>>8)+_|0;_=(((Y(k-($&255)|0,v)|0)+127|0)>>>8)+$&255;b[C>>0]=_;b[ja>>0]=t;b[Z>>0]=w;w=C+3|0;C=(Y(f[60840+(L<<2)>>2]|0,D)|0)>>>8&255;Z=h[w>>0]|0;t=(((Y(k-Z|0,C)|0)+127|0)>>>8)+Z|0;Z=w+1|0;ja=h[Z>>0]|0;_=(((Y(l-ja|0,C)|0)+127|0)>>>8)+ja|0;ja=w+2|0;$=h[ja>>0]|0;v=(((Y(m-$|0,C)|0)+127|0)>>>8)+$|0;$=(((Y(l-(_&255)|0,C)|0)+127|0)>>>8)+_|0;_=(((Y(m-(v&255)|0,C)|0)+127|0)>>>8)+v|0;v=(((Y(k-(t&255)|0,C)|0)+127|0)>>>8)+t&255;b[w>>0]=v;b[Z>>0]=$;b[ja>>0]=_;_=w+3|0;w=(Y(f[60840+((L^63)<<2)>>2]|0,D)|0)>>>8&255;D=h[_>>0]|0;L=(((Y(k-D|0,w)|0)+127|0)>>>8)+D|0;D=_+1|0;ja=h[D>>0]|0;$=(((Y(l-ja|0,w)|0)+127|0)>>>8)+ja|0;ja=_+2|0;Z=h[ja>>0]|0;v=(((Y(m-Z|0,w)|0)+127|0)>>>8)+Z|0;Z=(((Y(l-($&255)|0,w)|0)+127|0)>>>8)+$|0;$=(((Y(m-(v&255)|0,w)|0)+127|0)>>>8)+v|0;v=(((Y(k-(L&255)|0,w)|0)+127|0)>>>8)+L&255;b[_>>0]=v;b[D>>0]=Z;b[ja>>0]=$;$=c;X=Kac(f[$>>2]|0,f[$+4>>2]|0,ha|0,ia|0)|0;N=J;$=c;f[$>>2]=X;f[$+4>>2]=N;if((E|0)<=0)break;else{s=s+1|0;aa=aa+r|0;E=E+-1|0}}u=g;return}break}case 0:{E=(W|0)>-1;if(O){if(!E){u=g;return}aa=Sac(ba|0,ca|0,16)|0;s=x+aa|0;aa=0;N=W;X=fa;$=ga;while(1){ja=Rac(X|0,$|0,16)|0;Z=Kac(ja|0,J|0,-1,-1)|0;ja=cbc(Z|0,J|0,r|0,0)|0;Z=s+ja|0;ja=f[i+(((((aa|0)>1?2:1)&(aa|2))*3|0)+(((N|0)>1?2:1)&(N|2))<<2)>>2]|0;D=Sac(X|0,$|0,11)|0;v=D&31;D=(Y(f[60840+((v|32)<<2)>>2]|0,ja)|0)>>>8&255;_=h[Z>>0]|0;L=(((Y(k-_|0,D)|0)+127|0)>>>8)+_|0;_=(((Y(k-(L&255)|0,D)|0)+127|0)>>>8)+L&255;b[Z>>0]=_;_=Z+r|0;Z=(Y(f[60840+(v<<2)>>2]|0,ja)|0)>>>8&255;L=h[_>>0]|0;D=(((Y(k-L|0,Z)|0)+127|0)>>>8)+L|0;L=(((Y(k-(D&255)|0,Z)|0)+127|0)>>>8)+D&255;b[_>>0]=L;L=_+r|0;_=(Y(f[60840+((v^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[L>>0]|0;v=(((Y(k-ja|0,_)|0)+127|0)>>>8)+ja|0;ja=(((Y(k-(v&255)|0,_)|0)+127|0)>>>8)+v&255;b[L>>0]=ja;ja=o;X=Kac(f[ja>>2]|0,f[ja+4>>2]|0,da|0,ea|0)|0;$=J;ja=o;f[ja>>2]=X;f[ja+4>>2]=$;if((N|0)<=0)break;else{s=s+1|0;aa=aa+1|0;N=N+-1|0}}u=g;return}else{if(!E){u=g;return}E=Rac(fa|0,ga|0,16)|0;N=cbc(E|0,J|0,r|0,0)|0;E=x+N|0;N=0;aa=W;s=ba;$=ca;while(1){X=Sac(s|0,$|0,16)|0;ja=Kac(X|0,J|0,-1,0)|0;X=E+ja|0;ja=f[i+(((((N|0)>1?2:1)&(N|2))*3|0)+(((aa|0)>1?2:1)&(aa|2))<<2)>>2]|0;L=Sac(s|0,$|0,11)|0;v=L&31;L=(Y(f[60840+((v|32)<<2)>>2]|0,ja)|0)>>>8&255;_=h[X>>0]|0;D=(((Y(k-_|0,L)|0)+127|0)>>>8)+_|0;_=(((Y(k-(D&255)|0,L)|0)+127|0)>>>8)+D&255;b[X>>0]=_;_=X+1|0;X=(Y(f[60840+(v<<2)>>2]|0,ja)|0)>>>8&255;D=h[_>>0]|0;L=(((Y(k-D|0,X)|0)+127|0)>>>8)+D|0;D=(((Y(k-(L&255)|0,X)|0)+127|0)>>>8)+L&255;b[_>>0]=D;D=_+1|0;_=(Y(f[60840+((v^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[D>>0]|0;v=(((Y(k-ja|0,_)|0)+127|0)>>>8)+ja|0;ja=(((Y(k-(v&255)|0,_)|0)+127|0)>>>8)+v&255;b[D>>0]=ja;ja=c;s=Kac(f[ja>>2]|0,f[ja+4>>2]|0,ha|0,ia|0)|0;$=J;ja=c;f[ja>>2]=s;f[ja+4>>2]=$;if((aa|0)<=0)break;else{E=E+r|0;N=N+1|0;aa=aa+-1|0}}u=g;return}break}default:{aa=(W|0)>-1;if(O){if(!aa){u=g;return}O=Rac(ba|0,ca|0,16)|0;N=$ac(O|0,J|0,2)|0;O=x+N|0;N=0;E=W;$=fa;s=ga;while(1){ja=Rac($|0,s|0,16)|0;D=Kac(ja|0,J|0,-1,-1)|0;ja=cbc(D|0,J|0,r|0,0)|0;D=O+ja|0;ja=f[i+(((((N|0)>1?2:1)&(N|2))*3|0)+(((E|0)>1?2:1)&(E|2))<<2)>>2]|0;v=Sac($|0,s|0,11)|0;_=v&31;v=(Y(f[60840+((_|32)<<2)>>2]|0,ja)|0)>>>8&255;L=h[D>>0]|0;X=(((Y(k-L|0,v)|0)+127|0)>>>8)+L|0;L=D+1|0;Z=h[L>>0]|0;w=(((Y(l-Z|0,v)|0)+127|0)>>>8)+Z|0;Z=D+2|0;t=h[Z>>0]|0;C=(((Y(m-t|0,v)|0)+127|0)>>>8)+t|0;t=D+3|0;A=h[t>>0]|0;K=(((Y(n-A|0,v)|0)+127|0)>>>8)+A|0;A=(((Y(l-(w&255)|0,v)|0)+127|0)>>>8)+w|0;w=(((Y(m-(C&255)|0,v)|0)+127|0)>>>8)+C|0;C=(((Y(n-(K&255)|0,v)|0)+127|0)>>>8)+K|0;K=(((Y(k-(X&255)|0,v)|0)+127|0)>>>8)+X&255;b[D>>0]=K;b[L>>0]=A;b[Z>>0]=w;b[t>>0]=C;C=D+r|0;D=(Y(f[60840+(_<<2)>>2]|0,ja)|0)>>>8&255;t=h[C>>0]|0;w=(((Y(k-t|0,D)|0)+127|0)>>>8)+t|0;t=C+1|0;Z=h[t>>0]|0;A=(((Y(l-Z|0,D)|0)+127|0)>>>8)+Z|0;Z=C+2|0;L=h[Z>>0]|0;K=(((Y(m-L|0,D)|0)+127|0)>>>8)+L|0;L=C+3|0;X=h[L>>0]|0;v=(((Y(n-X|0,D)|0)+127|0)>>>8)+X|0;X=(((Y(l-(A&255)|0,D)|0)+127|0)>>>8)+A|0;A=(((Y(m-(K&255)|0,D)|0)+127|0)>>>8)+K|0;K=(((Y(n-(v&255)|0,D)|0)+127|0)>>>8)+v|0;v=(((Y(k-(w&255)|0,D)|0)+127|0)>>>8)+w&255;b[C>>0]=v;b[t>>0]=X;b[Z>>0]=A;b[L>>0]=K;K=C+r|0;C=(Y(f[60840+((_^63)<<2)>>2]|0,ja)|0)>>>8&255;ja=h[K>>0]|0;_=(((Y(k-ja|0,C)|0)+127|0)>>>8)+ja|0;ja=K+1|0;L=h[ja>>0]|0;A=(((Y(l-L|0,C)|0)+127|0)>>>8)+L|0;L=K+2|0;Z=h[L>>0]|0;X=(((Y(m-Z|0,C)|0)+127|0)>>>8)+Z|0;Z=K+3|0;t=h[Z>>0]|0;v=(((Y(n-t|0,C)|0)+127|0)>>>8)+t|0;t=(((Y(l-(A&255)|0,C)|0)+127|0)>>>8)+A|0;A=(((Y(m-(X&255)|0,C)|0)+127|0)>>>8)+X|0;X=(((Y(n-(v&255)|0,C)|0)+127|0)>>>8)+v|0;v=(((Y(k-(_&255)|0,C)|0)+127|0)>>>8)+_&255;b[K>>0]=v;b[ja>>0]=t;b[L>>0]=A;b[Z>>0]=X;X=o;$=Kac(f[X>>2]|0,f[X+4>>2]|0,da|0,ea|0)|0;s=J;X=o;f[X>>2]=$;f[X+4>>2]=s;if((E|0)<=0)break;else{O=O+4|0;N=N+1|0;E=E+-1|0}}u=g;return}else{if(!aa){u=g;return}aa=Rac(fa|0,ga|0,16)|0;ga=cbc(aa|0,J|0,r|0,0)|0;aa=x+ga|0;ga=0;x=W;W=ba;ba=ca;while(1){ca=Rac(W|0,ba|0,16)|0;fa=$ac(ca|0,J|0,2)|0;ca=Kac(fa|0,J|0,-4,0)|0;fa=aa+ca|0;ca=f[i+(((((ga|0)>1?2:1)&(ga|2))*3|0)+(((x|0)>1?2:1)&(x|2))<<2)>>2]|0;E=Sac(W|0,ba|0,11)|0;N=E&31;E=(Y(f[60840+((N|32)<<2)>>2]|0,ca)|0)>>>8&255;O=h[fa>>0]|0;s=(((Y(k-O|0,E)|0)+127|0)>>>8)+O|0;O=fa+1|0;$=h[O>>0]|0;o=(((Y(l-$|0,E)|0)+127|0)>>>8)+$|0;$=fa+2|0;ea=h[$>>0]|0;da=(((Y(m-ea|0,E)|0)+127|0)>>>8)+ea|0;ea=fa+3|0;X=h[ea>>0]|0;Z=(((Y(n-X|0,E)|0)+127|0)>>>8)+X|0;X=(((Y(l-(o&255)|0,E)|0)+127|0)>>>8)+o|0;o=(((Y(m-(da&255)|0,E)|0)+127|0)>>>8)+da|0;da=(((Y(n-(Z&255)|0,E)|0)+127|0)>>>8)+Z|0;Z=(((Y(k-(s&255)|0,E)|0)+127|0)>>>8)+s&255;b[fa>>0]=Z;b[O>>0]=X;b[$>>0]=o;b[ea>>0]=da;da=fa+4|0;fa=(Y(f[60840+(N<<2)>>2]|0,ca)|0)>>>8&255;ea=h[da>>0]|0;o=(((Y(k-ea|0,fa)|0)+127|0)>>>8)+ea|0;ea=da+1|0;$=h[ea>>0]|0;X=(((Y(l-$|0,fa)|0)+127|0)>>>8)+$|0;$=da+2|0;O=h[$>>0]|0;Z=(((Y(m-O|0,fa)|0)+127|0)>>>8)+O|0;O=da+3|0;s=h[O>>0]|0;E=(((Y(n-s|0,fa)|0)+127|0)>>>8)+s|0;s=(((Y(l-(X&255)|0,fa)|0)+127|0)>>>8)+X|0;X=(((Y(m-(Z&255)|0,fa)|0)+127|0)>>>8)+Z|0;Z=(((Y(n-(E&255)|0,fa)|0)+127|0)>>>8)+E|0;E=(((Y(k-(o&255)|0,fa)|0)+127|0)>>>8)+o&255;b[da>>0]=E;b[ea>>0]=s;b[$>>0]=X;b[O>>0]=Z;Z=da+4|0;da=(Y(f[60840+((N^63)<<2)>>2]|0,ca)|0)>>>8&255;ca=h[Z>>0]|0;N=(((Y(k-ca|0,da)|0)+127|0)>>>8)+ca|0;ca=Z+1|0;O=h[ca>>0]|0;X=(((Y(l-O|0,da)|0)+127|0)>>>8)+O|0;O=Z+2|0;$=h[O>>0]|0;s=(((Y(m-$|0,da)|0)+127|0)>>>8)+$|0;$=Z+3|0;ea=h[$>>0]|0;E=(((Y(n-ea|0,da)|0)+127|0)>>>8)+ea|0;ea=(((Y(l-(X&255)|0,da)|0)+127|0)>>>8)+X|0;X=(((Y(m-(s&255)|0,da)|0)+127|0)>>>8)+s|0;s=(((Y(n-(E&255)|0,da)|0)+127|0)>>>8)+E|0;E=(((Y(k-(N&255)|0,da)|0)+127|0)>>>8)+N&255;b[Z>>0]=E;b[ca>>0]=ea;b[O>>0]=X;b[$>>0]=s;s=c;W=Kac(f[s>>2]|0,f[s+4>>2]|0,ha|0,ia|0)|0;ba=J;s=c;f[s>>2]=W;f[s+4>>2]=ba;if((x|0)<=0)break;else{aa=aa+r|0;ga=ga+1|0;x=x+-1|0}}u=g;return}}}}break}default:{}}x=c;ga=Sac(f[x>>2]|0,f[x+4>>2]|0,16)|0;x=c+8|0;c=Sac(f[x>>2]|0,f[x+4>>2]|0,16)|0;x=d;r=Sac(f[x>>2]|0,f[x+4>>2]|0,16)|0;x=d+8|0;d=Sac(f[x>>2]|0,f[x+4>>2]|0,16)|0;mma(a,ga,c,r,d,e,8);u=g;return}function pma(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0;i=u;u=u+128|0;j=i+64|0;k=i+48|0;l=i+32|0;m=i+16|0;n=i;o=1<<h>>1;p=f[a+16>>2]|0;q=f[a+40>>2]|0;r=f[q+4>>2]|0;s=f[q>>2]|0;q=f[a+4>>2]|0;if((q|0)>0)t=f[(f[a+44>>2]|0)+(q+-1<<2)>>2]|0;else t=0;q=(g|0)<16;v=q?32768:65535;w=q?0:0;x=q?32768:0;y=q?0:0;z=d+-1|0;A=c+(z<<4)|0;B=c+(z<<4)+8|0;C=f[B>>2]|0;D=f[B+4>>2]|0;B=16-h|0;E=$ac(f[A>>2]|0,f[A+4>>2]|0,B|0)|0;A=J;F=$ac(C|0,D|0,B|0)|0;D=J;C=c;G=f[C>>2]|0;H=f[C+4>>2]|0;C=c+8|0;I=f[C>>2]|0;K=f[C+4>>2]|0;a:do if((d|0)>0){C=(h|0)==0;L=k+8|0;M=l+8|0;N=m+8|0;O=n+8|0;if((g|0)<9){P=0;Q=0;R=H;S=G;T=E;U=A;V=F;W=D;X=K;Z=K;_=I;$=I;aa=K;ba=I;ca=H;da=H;ea=G;fa=G}else{ga=0;ha=0;ia=K;ja=K;ka=I;la=I;ma=K;na=I;oa=H;pa=H;qa=G;ra=G;sa=H;ta=G;ua=E;va=A;wa=F;xa=D;while(1){ya=(ia|0)<(ja|0)|(ia|0)==(ja|0)&ka>>>0<la>>>0;za=ya?ga:ha;Aa=ya?ka:la;Ba=ya?ia:ja;ya=(ma|0)<(ia|0)|(ma|0)==(ia|0)&na>>>0<ka>>>0;Ca=ya?ka:na;Da=ya?ia:ma;ya=(oa|0)<(pa|0)|(oa|0)==(pa|0)&qa>>>0<ra>>>0;Ea=ya?ra:qa;Fa=ya?pa:oa;ya=(sa|0)>(pa|0)|(sa|0)==(pa|0)&ta>>>0>ra>>>0;Ga=ya?ra:ta;Ha=ya?pa:sa;ya=$ac(ra|0,pa|0,B|0)|0;Ia=J;Ja=$ac(ka|0,ia|0,B|0)|0;Ka=J;La=m;f[La>>2]=ua;f[La+4>>2]=va;La=N;f[La>>2]=wa;f[La+4>>2]=xa;La=n;f[La>>2]=ya;f[La+4>>2]=Ia;La=O;f[La>>2]=Ja;f[La+4>>2]=Ka;oma(a,m,n,e);La=ga+1|0;if((La|0)==(d|0)){Ma=za;Na=Aa;Oa=Ba;Pa=Ca;Qa=Da;Ra=Ea;Sa=Fa;Ta=Ga;Ua=Ha;break a}Va=c+(La<<4)|0;Wa=c+(La<<4)+8|0;ga=La;ha=za;ia=f[Wa+4>>2]|0;ja=Ba;ka=f[Wa>>2]|0;la=Aa;ma=Da;na=Ca;oa=Fa;pa=f[Va+4>>2]|0;qa=Ea;ra=f[Va>>2]|0;sa=Ha;ta=Ga;ua=ya;va=Ia;wa=Ja;xa=Ka}}while(1){xa=(X|0)<(Z|0)|(X|0)==(Z|0)&_>>>0<$>>>0;wa=xa?P:Q;va=xa?_:$;ua=xa?X:Z;xa=(aa|0)<(X|0)|(aa|0)==(X|0)&ba>>>0<_>>>0;ta=xa?_:ba;sa=xa?X:aa;xa=(ca|0)<(da|0)|(ca|0)==(da|0)&ea>>>0<fa>>>0;ra=xa?fa:ea;qa=xa?da:ca;xa=(R|0)>(da|0)|(R|0)==(da|0)&S>>>0>fa>>>0;pa=xa?fa:S;oa=xa?da:R;xa=$ac(fa|0,da|0,B|0)|0;na=J;ma=$ac(_|0,X|0,B|0)|0;la=J;if(C){ka=Sac(T|0,U|0,16)|0;ja=Sac(V|0,W|0,16)|0;ia=Sac(xa|0,na|0,16)|0;ha=Sac(ma|0,la|0,16)|0;mma(a,ka,ja,ia,ha,e,g)}else{ha=k;f[ha>>2]=T;f[ha+4>>2]=U;ha=L;f[ha>>2]=V;f[ha+4>>2]=W;ha=l;f[ha>>2]=xa;f[ha+4>>2]=na;ha=M;f[ha>>2]=ma;f[ha+4>>2]=la;nma(a,k,l,e)}ha=P+1|0;if((ha|0)==(d|0)){Ma=wa;Na=va;Oa=ua;Pa=ta;Qa=sa;Ra=ra;Sa=qa;Ta=pa;Ua=oa;break a}ia=c+(ha<<4)|0;ja=c+(ha<<4)+8|0;P=ha;Q=wa;R=oa;S=pa;T=xa;U=na;V=ma;W=la;X=f[ja+4>>2]|0;Z=ua;_=f[ja>>2]|0;$=va;aa=sa;ba=ta;ca=qa;da=f[ia+4>>2]|0;ea=ra;fa=f[ia>>2]|0}}else{Ma=0;Na=I;Oa=K;Pa=I;Qa=K;Ra=G;Sa=H;Ta=G;Ua=H}while(0);H=((o|0)<0)<<31>>31;G=Kac(Na|0,Oa|0,o|0,H|0)|0;Oa=Rac(G|0,J|0,h|0)|0;G=Kac(Pa|0,Qa|0,o|0,H|0)|0;Qa=Rac(G|0,J|0,h|0)|0;G=J;if((d|0)<3){u=i;return}Pa=Kac(Ra|0,Sa|0,o|0,H|0)|0;Sa=Rac(Pa|0,J|0,h|0)|0;Pa=J;Pa=Kac(Ta|0,Ua|0,o|0,H|0)|0;Ua=Rac(Pa|0,J|0,h|0)|0;if(!((Sa|Qa|0)>-1&(Ua|0)<(r|0))){u=i;return}if((Oa|0)>=(s|0)){u=i;return}Ua=s+-1|0;s=((Ua|0)<0)<<31>>31;Sa=(G|0)>(s|0)|(G|0)==(s|0)&Qa>>>0>Ua>>>0;s=Sa?Ua:Qa;Qa=j+32|0;f[Qa>>2]=Ma;f[j>>2]=Ma;Ma=j+56|0;f[Ma>>2]=Oa;Ua=j+24|0;f[Ua>>2]=Oa;Sa=j+4|0;f[Sa>>2]=1;G=j+36|0;f[G>>2]=z;z=j+40|0;Pa=z;f[Pa>>2]=-65536;f[Pa+4>>2]=-1;Pa=j+8|0;Ta=Pa;f[Ta>>2]=-65536;f[Ta+4>>2]=-1;Ta=j+48|0;Ra=Ta;f[Ra>>2]=0;f[Ra+4>>2]=0;Ra=j+16|0;Na=Ra;f[Na>>2]=0;f[Na+4>>2]=0;Na=a+48|0;a=p+(Y(f[Na>>2]|0,Oa)|0)|0;p=r+-1|0;K=(t|0)==1;I=(h|0)==16?0:B;B=Oa;fa=a;a=d;ea=-65536;da=-1;ca=-65536;ba=-1;while(1){if(!q?!((B|0)<(s|0)|(B|0)==(Oa|0)):0){Xa=a;Ya=ba;Za=da;_a=ca;$a=ea}else ab=18;b:do if((ab|0)==18){ab=0;c:do if((B|0)<(f[Ua>>2]|0)){bb=a;cb=ca;db=ba}else{aa=f[Sa>>2]|0;$=f[j>>2]|0;_=a;while(1){Z=$+aa|0;eb=Z-((Z|0)<(d|0)?0:d)|0;Z=_;_=_+-1|0;if((Z|0)<=0){bb=_;cb=ca;db=ba;break c}Z=c+(eb<<4)+8|0;X=Kac(f[Z>>2]|0,f[Z+4>>2]|0,o|0,H|0)|0;fb=Rac(X|0,J|0,h|0)|0;if((fb|0)>(B|0))break;else $=eb}aa=c+($<<4)|0;X=c+(eb<<4)|0;Z=f[X>>2]|0;W=f[X+4>>2]|0;X=$ac(f[aa>>2]|0,f[aa+4>>2]|0,I|0)|0;aa=J;V=$ac(Z|0,W|0,I|0)|0;f[Ua>>2]=fb;W=Jac(V|0,J|0,X|0,aa|0)|0;V=$ac(W|0,J|0,1)|0;W=fb-B|0;Z=Kac(V|0,J|0,W|0,((W|0)<0)<<31>>31|0)|0;V=W<<1;W=abc(Z|0,J|0,V|0,((V|0)<0)<<31>>31|0)|0;V=Ra;f[V>>2]=W;f[V+4>>2]=J;V=Pa;f[V>>2]=X;f[V+4>>2]=aa;f[j>>2]=eb;bb=_;cb=X;db=aa}while(0);if((B|0)<(f[Ma>>2]|0)){Xa=bb;Ya=db;Za=da;_a=cb;$a=ea}else{aa=f[G>>2]|0;X=f[Qa>>2]|0;V=bb;while(1){W=X+aa|0;gb=W-((W|0)<(d|0)?0:d)|0;W=V;V=V+-1|0;if((W|0)<=0){Xa=V;Ya=db;Za=da;_a=cb;$a=ea;break b}W=c+(gb<<4)+8|0;Z=Kac(f[W>>2]|0,f[W+4>>2]|0,o|0,H|0)|0;hb=Rac(Z|0,J|0,h|0)|0;if((hb|0)>(B|0))break;else X=gb}aa=c+(X<<4)|0;Z=c+(gb<<4)|0;W=f[Z>>2]|0;U=f[Z+4>>2]|0;Z=$ac(f[aa>>2]|0,f[aa+4>>2]|0,I|0)|0;aa=J;T=$ac(W|0,U|0,I|0)|0;f[Ma>>2]=hb;U=Jac(T|0,J|0,Z|0,aa|0)|0;T=$ac(U|0,J|0,1)|0;U=hb-B|0;W=Kac(T|0,J|0,U|0,((U|0)<0)<<31>>31|0)|0;T=U<<1;U=abc(W|0,J|0,T|0,((T|0)<0)<<31>>31|0)|0;T=Ta;f[T>>2]=U;f[T+4>>2]=J;T=z;f[T>>2]=Z;f[T+4>>2]=aa;f[Qa>>2]=gb;Xa=V;Ya=db;Za=aa;_a=cb;$a=Z}}while(0);if((Xa|0)<0){ab=35;break}do if((B|0)>-1?(Z=(Ya|0)>(Za|0)|(Ya|0)==(Za|0)&_a>>>0>$a>>>0,aa=j+((Z&1)<<5)+8|0,T=Kac(f[aa>>2]|0,f[aa+4>>2]|0,v|0,w|0)|0,aa=Sac(T|0,J|0,16)|0,T=j+(((Z^1)&1)<<5)+8|0,Z=Kac(f[T>>2]|0,f[T+4>>2]|0,x|0,y|0)|0,T=Sac(Z|0,J|0,16)|0,(aa|0)<(r|0)&(T|0)>-1):0){Z=Y((aa|0)>0?aa:0,t)|0;aa=fa+Z|0;U=Y(((T|0)<(r|0)?T:p)+1|0,t)|0;T=fa+U|0;if(K){Nac(aa|0,b[e>>0]|0,T-aa|0)|0;break}if((Z|0)<(U|0)){Vac(aa|0,e|0,t|0)|0;ib=aa+t|0}else ib=aa;if(ib>>>0<T>>>0){U=T;Z=t;W=ib;while(1){Vac(W|0,aa|0,Z|0)|0;W=W+Z|0;S=Z<<1;R=U-W|0;if(W>>>0>=T>>>0)break;else Z=R>>>0<S>>>0?R:S}}}while(0);Z=Ra;T=Pa;ca=Kac(f[T>>2]|0,f[T+4>>2]|0,f[Z>>2]|0,f[Z+4>>2]|0)|0;ba=J;Z=Pa;f[Z>>2]=ca;f[Z+4>>2]=ba;Z=Ta;T=z;ea=Kac(f[T>>2]|0,f[T+4>>2]|0,f[Z>>2]|0,f[Z+4>>2]|0)|0;da=J;Z=z;f[Z>>2]=ea;f[Z+4>>2]=da;if((B|0)>=(s|0)){ab=35;break}else{B=B+1|0;fa=fa+(f[Na>>2]|0)|0;a=Xa}}if((ab|0)==35){u=i;return}}function qma(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;h=f[a+40>>2]|0;i=f[h+4>>2]|0;j=f[h>>2]|0;h=f[a+48>>2]|0;k=f[a+4>>2]|0;if((k|0)>0)l=f[(f[a+44>>2]|0)+(k+-1<<2)>>2]|0;else l=0;k=f[a+16>>2]|0;a=f[c>>2]|0;if((a|0)>=(d|0)&(a|0)<(i-d|0)){m=f[c+4>>2]|0;n=(m|0)<(j-d|0)&(m|0)>=(d|0)}else n=0;if((d|0)<0)return;m=c+4|0;o=(g|0)!=0;g=(l|0)==1;p=i+-1|0;q=d;r=0;s=1;t=(d<<1)+-1|0;d=0;u=a;while(1){a=f[m>>2]|0;v=a-r|0;w=a+r|0;x=a-q|0;y=a+q|0;a=u-q|0;z=u+q|0;A=u-r|0;B=u+r|0;do if(n){C=k+(Y(v,h)|0)|0;D=k+(Y(w,h)|0)|0;E=Y(a,l)|0;F=C+E|0;if(!o){Vac(F|0,e|0,l|0)|0;Vac(D+E|0,e|0,l|0)|0;G=Y(z,l)|0;Vac(C+G|0,e|0,l|0)|0;Vac(D+G|0,e|0,l|0)|0;G=k+(Y(x,h)|0)|0;H=k+(Y(y,h)|0)|0;I=Y(A,l)|0;Vac(G+I|0,e|0,l|0)|0;Vac(H+I|0,e|0,l|0)|0;I=Y(B,l)|0;Vac(G+I|0,e|0,l|0)|0;Vac(H+I|0,e|0,l|0)|0;break}I=Y(z+1|0,l)|0;H=C+I|0;if(!g){C=(I|0)>(E|0);if(C){Vac(F|0,e|0,l|0)|0;J=F+l|0}else J=F;if(J>>>0<H>>>0){G=H;K=l;L=J;while(1){Vac(L|0,F|0,K|0)|0;L=L+K|0;M=K<<1;N=G-L|0;if(L>>>0>=H>>>0)break;else K=N>>>0<M>>>0?N:M}}K=D+E|0;L=D+I|0;if(C){Vac(K|0,e|0,l|0)|0;O=D+E+l|0}else O=K;if(O>>>0<L>>>0){G=L;M=l;N=O;while(1){Vac(N|0,K|0,M|0)|0;N=N+M|0;P=M<<1;Q=G-N|0;if(N>>>0>=L>>>0)break;else M=Q>>>0<P>>>0?Q:P}}}else{Nac(F|0,b[e>>0]|0,H-F|0)|0;Nac(D+E|0,b[e>>0]|0,I-E|0)|0}M=k+(Y(x,h)|0)|0;L=k+(Y(y,h)|0)|0;N=Y(A,l)|0;G=M+N|0;K=Y(B+1|0,l)|0;C=M+K|0;if(g){Nac(G|0,b[e>>0]|0,C-G|0)|0;Nac(L+N|0,b[e>>0]|0,K-N|0)|0;break}M=(K|0)>(N|0);if(M){Vac(G|0,e|0,l|0)|0;R=G+l|0}else R=G;if(R>>>0<C>>>0){P=C;Q=l;S=R;while(1){Vac(S|0,G|0,Q|0)|0;S=S+Q|0;T=Q<<1;U=P-S|0;if(S>>>0>=C>>>0)break;else Q=U>>>0<T>>>0?U:T}}Q=L+N|0;C=L+K|0;if(M){Vac(Q|0,e|0,l|0)|0;V=L+N+l|0}else V=Q;if(V>>>0<C>>>0){S=C;P=l;G=V;while(1){Vac(G|0,Q|0,P|0)|0;G=G+P|0;E=P<<1;I=S-G|0;if(G>>>0>=C>>>0)break;else P=I>>>0<E>>>0?I:E}}}else if((a|0)<(i|0)&(z|0)>-1?(x|0)<(j|0)&(y|0)>-1:0){P=o?((a|0)>0?a:0):a;C=o&(z|0)>=(i|0)?p:z;do if(v>>>0<j>>>0){G=k+(Y(v,h)|0)|0;if(!o){if((P|0)>-1)Vac(G+(Y(P,l)|0)|0,e|0,l|0)|0;if((C|0)>=(i|0))break;Vac(G+(Y(C,l)|0)|0,e|0,l|0)|0;break}S=Y(P,l)|0;Q=G+S|0;N=Y(C+1|0,l)|0;L=G+N|0;if(g){Nac(Q|0,b[e>>0]|0,L-Q|0)|0;break}if((S|0)<(N|0)){Vac(Q|0,e|0,l|0)|0;W=Q+l|0}else W=Q;if(W>>>0<L>>>0){N=L;S=l;G=W;while(1){Vac(G|0,Q|0,S|0)|0;G=G+S|0;M=S<<1;K=N-G|0;if(G>>>0>=L>>>0)break;else S=K>>>0<M>>>0?K:M}}}while(0);do if(w>>>0<j>>>0){S=k+(Y(w,h)|0)|0;if(!o){if((P|0)>-1)Vac(S+(Y(P,l)|0)|0,e|0,l|0)|0;if((C|0)>=(i|0))break;Vac(S+(Y(C,l)|0)|0,e|0,l|0)|0;break}L=Y(P,l)|0;G=S+L|0;N=Y(C+1|0,l)|0;Q=S+N|0;if(g){Nac(G|0,b[e>>0]|0,Q-G|0)|0;break}if((L|0)<(N|0)){Vac(G|0,e|0,l|0)|0;X=G+l|0}else X=G;if(X>>>0<Q>>>0){N=Q;L=l;S=X;while(1){Vac(S|0,G|0,L|0)|0;S=S+L|0;M=L<<1;K=N-S|0;if(S>>>0>=Q>>>0)break;else L=K>>>0<M>>>0?K:M}}}while(0);if((A|0)<(i|0)&(B|0)>-1){C=o?((A|0)>0?A:0):A;P=o&(B|0)>=(i|0)?p:B;do if(x>>>0<j>>>0){L=k+(Y(x,h)|0)|0;if(!o){if((C|0)>-1)Vac(L+(Y(C,l)|0)|0,e|0,l|0)|0;if((P|0)>=(i|0))break;Vac(L+(Y(P,l)|0)|0,e|0,l|0)|0;break}Q=Y(C,l)|0;S=L+Q|0;N=Y(P+1|0,l)|0;G=L+N|0;if(g){Nac(S|0,b[e>>0]|0,G-S|0)|0;break}if((Q|0)<(N|0)){Vac(S|0,e|0,l|0)|0;Z=S+l|0}else Z=S;if(Z>>>0<G>>>0){N=G;Q=l;L=Z;while(1){Vac(L|0,S|0,Q|0)|0;L=L+Q|0;M=Q<<1;K=N-L|0;if(L>>>0>=G>>>0)break;else Q=K>>>0<M>>>0?K:M}}}while(0);if(y>>>0<j>>>0){Q=k+(Y(y,h)|0)|0;if(!o){if((C|0)>-1)Vac(Q+(Y(C,l)|0)|0,e|0,l|0)|0;if((P|0)>=(i|0))break;Vac(Q+(Y(P,l)|0)|0,e|0,l|0)|0;break}G=Y(C,l)|0;L=Q+G|0;N=Y(P+1|0,l)|0;S=Q+N|0;if(g){Nac(L|0,b[e>>0]|0,S-L|0)|0;break}if((G|0)<(N|0)){Vac(L|0,e|0,l|0)|0;_=L+l|0}else _=L;if(_>>>0<S>>>0){N=S;G=l;Q=_;while(1){Vac(Q|0,L|0,G|0)|0;Q=Q+G|0;M=G<<1;K=N-Q|0;if(Q>>>0>=S>>>0)break;else G=K>>>0<M>>>0?K:M}}}}}while(0);y=d+s|0;x=(y|0)>0;B=(x<<31>>31)+q|0;if((B|0)<=(r|0))break;A=y-(x?t:0)|0;q=B;r=r+1|0;s=s+2|0;t=t-(x?2:0)|0;d=A;u=f[c>>2]|0}return}function rma(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;k=u;u=u+80|0;l=k+68|0;m=k+32|0;n=k;o=k+56|0;q=k+16|0;r=k+48|0;s=c;t=f[s>>2]|0;v=f[s+4>>2]|0;s=(v|0)>-1|(v|0)==-1&t>>>0>4294967295;w=Jac(0,0,t|0,v|0)|0;x=s?t:w;w=s?v:J;v=c;f[v>>2]=x;f[v+4>>2]=w;v=c+8|0;c=v;s=f[c>>2]|0;t=f[c+4>>2]|0;c=(t|0)>-1|(t|0)==-1&s>>>0>4294967295;y=Jac(0,0,s|0,t|0)|0;z=c?s:y;y=c?t:J;t=v;f[t>>2]=z;f[t+4>>2]=y;t=(w|0)<(y|0)|(w|0)==(y|0)&x>>>0<z>>>0;v=Kac((t?z:x)|0,(t?y:w)|0,32768,0)|0;t=Sac(v|0,J|0,16)|0;if((t|0)<3)A=90;else A=(t|0)<10?30:(t|0)<15?18:5;f[l>>2]=0;t=l+4|0;f[t>>2]=0;f[l+8>>2]=0;v=b;c=b+8|0;s=c;B=+((f[s>>2]|0)>>>0)+4294967296.0*+(f[s+4>>2]|0);p[m>>3]=+((f[v>>2]|0)>>>0)+4294967296.0*+(f[v+4>>2]|0);p[m+8>>3]=B;p[n>>3]=+(x>>>0)+4294967296.0*+(w|0);p[n+8>>3]=+(z>>>0)+4294967296.0*+(y|0);gma(m,n,d,e,g,A,l);f[o>>2]=0;A=o+4|0;f[A>>2]=0;f[o+8>>2]=0;d=f[t>>2]|0;n=f[l>>2]|0;if((d|0)==(n|0)){C=0;D=0}else{m=q+8|0;y=o+8|0;z=0;w=n;n=-1;x=-1;v=-1;s=-1;E=d;while(1){d=w;F=MVb(+p[d+(z<<4)>>3]*.0000152587890625)|0;G=$ac(F|0,((F|0)<0)<<31>>31|0,16)|0;F=J;H=MVb(+p[d+(z<<4)+8>>3]*.0000152587890625)|0;I=$ac(H|0,((H|0)<0)<<31>>31|0,16)|0;H=J;K=MVb(+p[d+(z<<4)>>3]-(+(G>>>0)+4294967296.0*+(F|0)))|0;L=Kac(K|0,((K|0)<0)<<31>>31|0,G|0,F|0)|0;F=J;G=q;f[G>>2]=L;f[G+4>>2]=F;G=MVb(+p[d+(z<<4)+8>>3]-(+(I>>>0)+4294967296.0*+(H|0)))|0;d=Kac(G|0,((G|0)<0)<<31>>31|0,I|0,H|0)|0;H=J;I=m;f[I>>2]=d;f[I+4>>2]=H;if((L|0)!=(v|0)|(F|0)!=(s|0)|((d|0)!=(n|0)|(H|0)!=(x|0))){I=f[A>>2]|0;if((I|0)==(f[y>>2]|0)){sma(o,q);M=f[t>>2]|0;N=f[l>>2]|0}else{G=I;f[G>>2]=L;f[G+4>>2]=F;F=I+8|0;f[F>>2]=d;f[F+4>>2]=H;f[A>>2]=I+16;M=E;N=w}I=q;H=m;O=N;P=M;Q=f[H>>2]|0;R=f[H+4>>2]|0;S=f[I>>2]|0;T=f[I+4>>2]|0}else{O=w;P=E;Q=n;R=x;S=v;T=s}z=z+1|0;if(z>>>0>=P-O>>4>>>0)break;else{w=O;n=Q;x=R;v=S;s=T;E=P}}C=f[A>>2]|0;D=f[o>>2]|0}if((C-D|0)==16)tma(o,2,b);do if((i|0)<=-1){if((g-e|0)>359){D=f[o>>2]|0;pma(a,D,(f[A>>2]|0)-D>>4,h,j,16);break}D=f[A>>2]|0;if((D|0)==(f[o+8>>2]|0)){sma(o,b);U=f[A>>2]|0}else{C=b;P=f[C+4>>2]|0;E=D;f[E>>2]=f[C>>2];f[E+4>>2]=P;P=c;E=f[P+4>>2]|0;C=D+8|0;f[C>>2]=f[P>>2];f[C+4>>2]=E;E=D+16|0;f[A>>2]=E;U=E}f[q>>2]=0;E=q+4|0;f[E>>2]=0;f[q+8>>2]=0;D=f[o>>2]|0;f[r>>2]=0;f[r+4>>2]=0;vma(a,D,U-D>>4,q,h,j,16,r);wma(a,q,h);D=f[q>>2]|0;if(D|0){C=f[E>>2]|0;if((C|0)!=(D|0))f[E>>2]=C+(~((C+-32-D|0)>>>5)<<5);O5b(D)}}else{D=f[o>>2]|0;uma(a,D,(f[A>>2]|0)-D>>4,0,h,i,j,16)}while(0);j=f[o>>2]|0;if(j|0){o=f[A>>2]|0;if((o|0)!=(j|0))f[A>>2]=o+(~((o+-16-j|0)>>>4)<<4);O5b(j)}j=f[l>>2]|0;if(!j){u=k;return}l=f[t>>2]|0;if((l|0)!=(j|0))f[t>>2]=l+(~((l+-16-j|0)>>>4)<<4);O5b(j);u=k;return}function sma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)c4b(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=ze(8)|0;T5b(l,477177);f[l>>2]=149528;If(l|0,25408,1411)}else{n=L5b(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;m=b;k=f[m+4>>2]|0;o=l;f[o>>2]=f[m>>2];f[o+4>>2]=k;k=b+8|0;b=f[k+4>>2]|0;o=n+(g<<4)+8|0;f[o>>2]=f[k>>2];f[o+4>>2]=b;b=l+16|0;if((j|0)==(i|0))p=l;else{o=j+-16-e|0;k=j;j=l;while(1){g=k;k=k+-16|0;n=k;m=f[n+4>>2]|0;q=j+-16|0;f[q>>2]=f[n>>2];f[q+4>>2]=m;m=g+-8|0;g=f[m+4>>2]|0;q=j+-8|0;f[q>>2]=f[m>>2];f[q+4>>2]=g;if((k|0)==(i|0))break;else j=j+-16|0}p=l+(~(o>>>4)<<4)|0}f[a>>2]=p;f[c>>2]=b;f[d>>2]=h;if(!e)return;O5b(e);return}function tma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=a+8|0;e=f[d>>2]|0;g=f[a>>2]|0;h=g;do if(e-g>>4>>>0>=b>>>0){i=a+4|0;j=f[i>>2]|0;k=j-g>>4;l=k>>>0<b>>>0;m=l?k:b;n=j;if(m|0){j=c+8|0;o=m;m=h;while(1){p=c;q=f[p+4>>2]|0;r=m;f[r>>2]=f[p>>2];f[r+4>>2]=q;q=j;r=f[q+4>>2]|0;p=m+8|0;f[p>>2]=f[q>>2];f[p+4>>2]=r;o=o+-1|0;if(!o)break;else m=m+16|0}}if(!l){m=h+(b<<4)|0;if((n|0)==(m|0))return;else{s=i;t=n+(~((n+-16-m|0)>>>4)<<4)|0;break}}else{m=b-k|0;o=c+8|0;j=m;r=n;while(1){p=c;q=f[p+4>>2]|0;u=r;f[u>>2]=f[p>>2];f[u+4>>2]=q;q=o;u=f[q+4>>2]|0;p=r+8|0;f[p>>2]=f[q>>2];f[p+4>>2]=u;j=j+-1|0;if(!j)break;else r=r+16|0}s=i;t=n+(m<<4)|0;break}}else{r=g;if(!g)v=e;else{j=a+4|0;o=f[j>>2]|0;if((o|0)!=(h|0))f[j>>2]=o+(~((o+-16-g|0)>>>4)<<4);O5b(r);f[d>>2]=0;f[j>>2]=0;f[a>>2]=0;v=0}if(b>>>0>268435455)c4b(a);j=v>>3;r=v>>4>>>0<134217727?(j>>>0<b>>>0?b:j):268435455;if(r>>>0>268435455)c4b(a);j=L5b(r<<4)|0;o=a+4|0;f[o>>2]=j;f[a>>2]=j;f[d>>2]=j+(r<<4);r=c+8|0;k=b;l=j;while(1){u=c;p=f[u+4>>2]|0;q=l;f[q>>2]=f[u>>2];f[q+4>>2]=p;p=r;q=f[p+4>>2]|0;u=l+8|0;f[u>>2]=f[p>>2];f[u+4>>2]=q;k=k+-1|0;if(!k)break;else l=l+16|0}s=o;t=j+(b<<4)|0}while(0);f[s>>2]=t;return}function uma(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;k=u;u=u+48|0;l=k+32|0;m=k+16|0;n=k;if((c|0)==0|(d|0)<1){u=k;return}o=e?d+-1|0:0;p=(e^1)&1;q=e?2:3;if(!((h|0)>-1&j>>>0<17)){f[l>>2]=0;f[l+4>>2]=0;e=aD(l,49)|0;r=267424;s=e+49|0;do{b[e>>0]=b[r>>0]|0;e=e+1|0;r=r+1|0}while((e|0)<(s|0));bO(-215,l,267474,267135,1726);bD(l)}if((p|0)>=(d|0)){u=k;return}l=c+(o<<4)+8|0;r=c+(o<<4)|0;o=m+8|0;e=n+8|0;s=q;q=p;p=f[r>>2]|0;t=f[r+4>>2]|0;r=f[l>>2]|0;v=f[l+4>>2]|0;while(1){l=c+(q<<4)|0;w=p;p=f[l>>2]|0;x=t;t=f[l+4>>2]|0;l=c+(q<<4)+8|0;y=r;r=f[l>>2]|0;z=v;v=f[l+4>>2]|0;l=m;f[l>>2]=w;f[l+4>>2]=x;x=o;f[x>>2]=y;f[x+4>>2]=z;z=n;f[z>>2]=p;f[z+4>>2]=t;z=e;f[z>>2]=r;f[z+4>>2]=v;lma(a,m,n,g,h,i,s,j);q=q+1|0;if((q|0)==(d|0))break;else s=2}u=k;return}function vma(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;j=u;u=u+96|0;k=j+80|0;l=j+64|0;m=j+32|0;n=j+16|0;o=j;p=(f[i+4>>2]|0)+(1<<h>>1)|0;q=c+-1|0;r=b+(q<<4)|0;s=f[r>>2]|0;t=f[r+4>>2]|0;r=k+8|0;v=b+(q<<4)+8|0;q=f[v>>2]|0;w=f[v+4>>2]|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;v=f[i>>2]|0;x=Kac(v|0,((v|0)<0)<<31>>31|0,s|0,t|0)|0;t=16-h|0;s=$ac(x|0,J|0,t|0)|0;x=J;v=k;f[v>>2]=s;f[v+4>>2]=x;v=((p|0)<0)<<31>>31;y=Kac(q|0,w|0,p|0,v|0)|0;w=Rac(y|0,J|0,h|0)|0;y=J;q=r;f[q>>2]=w;f[q+4>>2]=y;q=d+4|0;Dma(d,((f[q>>2]|0)-(f[d>>2]|0)>>5)+c|0);if((c|0)<=0){u=j;return}z=l+8|0;A=(g|0)<16;B=m+4|0;C=m+8|0;D=m+16|0;E=d+8|0;F=n+8|0;G=o+8|0;H=0;I=s;s=x;x=w;w=y;do{f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;y=b+(H<<4)|0;K=b+(H<<4)+8|0;L=f[K>>2]|0;M=f[K+4>>2]|0;K=f[i>>2]|0;N=Kac(K|0,((K|0)<0)<<31>>31|0,f[y>>2]|0,f[y+4>>2]|0)|0;y=I;I=$ac(N|0,J|0,t|0)|0;N=s;s=J;K=l;f[K>>2]=I;f[K+4>>2]=s;K=Kac(L|0,M|0,p|0,v|0)|0;M=x;x=Rac(K|0,J|0,h|0)|0;K=w;w=J;L=z;f[L>>2]=x;f[L+4>>2]=w;if(A){L=Kac(y|0,N|0,32768,0)|0;O=Rac(L|0,J|0,16)|0;L=J;P=Kac(I|0,s|0,32768,0)|0;Q=Rac(P|0,J|0,16)|0;P=J;R=Kac(O|0,L|0,-2147483648,0)|0;S=J;T=Kac(M|0,K|0,-2147483648,0)|0;U=J;V=Kac(Q|0,P|0,-2147483648,0)|0;W=J;X=Kac(x|0,w|0,-2147483648,0)|0;Y=J;mma(a,S>>>0<1|(S|0)==1&R>>>0<0?O:(L|0)>0|(L|0)==0&O>>>0>0?2147483647:-2147483648,U>>>0<1|(U|0)==1&T>>>0<0?M:(K|0)>0|(K|0)==0&M>>>0>0?2147483647:-2147483648,W>>>0<1|(W|0)==1&V>>>0<0?Q:(P|0)>0|(P|0)==0&Q>>>0>0?2147483647:-2147483648,Y>>>0<1|(Y|0)==1&X>>>0<0?x:(w|0)>0|(w|0)==0&x>>>0>0?2147483647:-2147483648,e,g)}else{X=$ac(M|0,K|0,16)|0;Y=J;Q=$ac(x|0,w|0,16)|0;P=n;f[P>>2]=y;f[P+4>>2]=N;P=F;f[P>>2]=X;f[P+4>>2]=Y;Y=o;f[Y>>2]=I;f[Y+4>>2]=s;Y=G;f[Y>>2]=Q;f[Y+4>>2]=J;oma(a,n,o,e)}do if(!((x|0)==(M|0)&(w|0)==(K|0))){Y=(w|0)>(K|0)|(w|0)==(K|0)&x>>>0>M>>>0;Q=Y?k:l;f[m>>2]=f[Q+8>>2];f[B>>2]=f[(Y?l:k)+8>>2];Y=Q;Q=f[Y+4>>2]|0;P=C;f[P>>2]=f[Y>>2];f[P+4>>2]=Q;Q=Jac(I|0,s|0,y|0,N|0)|0;P=J;Y=Jac(x|0,w|0,M|0,K|0)|0;X=abc(Q|0,P|0,Y|0,J|0)|0;Y=D;f[Y>>2]=X;f[Y+4>>2]=J;Y=f[q>>2]|0;if((Y|0)==(f[E>>2]|0)){yma(d,m);break}else{f[Y>>2]=f[m>>2];f[Y+4>>2]=f[m+4>>2];f[Y+8>>2]=f[m+8>>2];f[Y+12>>2]=f[m+12>>2];f[Y+16>>2]=f[m+16>>2];f[Y+20>>2]=f[m+20>>2];f[Y+24>>2]=f[m+24>>2];f[Y+28>>2]=f[m+28>>2];f[q>>2]=(f[q>>2]|0)+32;break}}while(0);H=H+1|0;K=k;f[K>>2]=I;f[K+4>>2]=s;K=r;f[K>>2]=x;f[K+4>>2]=w}while((H|0)!=(c|0));u=j;return}function wma(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;e=u;u=u+48|0;g=e+32|0;h=e;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;i=c+4|0;j=f[i>>2]|0;k=f[c>>2]|0;l=j-k|0;m=l>>5;n=f[a+40>>2]|0;o=f[n+4>>2]|0;p=f[n>>2]|0;n=f[a+4>>2]|0;q=k;k=j;if((n|0)>0)r=f[(f[a+44>>2]|0)+(n+-1<<2)>>2]|0;else r=0;if((l|0)<64){u=e;return}else{s=-2147483648;t=2147483647;v=0;w=2147483647;x=-1;y=-1;z=-1}while(1){l=q+(v<<5)+8|0;n=f[l>>2]|0;j=f[l+4>>2]|0;l=f[q+(v<<5)+4>>2]|0;A=f[q+(v<<5)>>2]|0;B=l-A|0;C=q+(v<<5)+16|0;D=cbc(B|0,((B|0)<0)<<31>>31|0,f[C>>2]|0,f[C+4>>2]|0)|0;C=Kac(D|0,J|0,n|0,j|0)|0;D=J;t=(A|0)<(t|0)?A:t;s=(s|0)<(l|0)?l:s;l=(j|0)<(w|0)|(j|0)==(w|0)&n>>>0<x>>>0;A=l?n:x;B=l?j:w;l=(y|0)<(j|0)|(y|0)==(j|0)&z>>>0<n>>>0;E=l?n:z;n=l?j:y;j=(D|0)<(B|0)|(D|0)==(B|0)&C>>>0<A>>>0;x=j?C:A;w=j?D:B;B=(n|0)<(D|0)|(n|0)==(D|0)&E>>>0<C>>>0;y=B?D:n;v=v+1|0;if((v|0)>=(m|0))break;else z=B?C:E}if((s|0)<0){u=e;return}if((y|0)<0|(t|0)>=(p|0)){u=e;return}t=$ac(o|0,((o|0)<0)<<31>>31|0,16)|0;y=J;if(!((w|0)<(y|0)|(w|0)==(y|0)&x>>>0<t>>>0)){u=e;return}xma(q,k,g);f[h>>2]=2147483647;g=f[i>>2]|0;if((g|0)==(f[c+8>>2]|0))yma(c,h);else{f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2];f[g+16>>2]=f[h+16>>2];f[g+20>>2]=f[h+20>>2];f[g+24>>2]=f[h+24>>2];f[g+28>>2]=f[h+28>>2];f[i>>2]=(f[i>>2]|0)+32}i=h+24|0;f[i>>2]=0;g=f[c>>2]|0;k=(s|0)>(p|0)?p:s;s=f[g>>2]|0;if((s|0)>=(k|0)){u=e;return}p=a+16|0;q=a+44|0;a=o+-1|0;t=(r|0)==1;x=s;s=g;g=0;y=0;while(1){a:do if((x|0)<0){w=f[c>>2]|0;z=0;v=h;E=y;C=s;B=g;while(1){b:do if(!E)F=22;else{n=v+24|0;D=E;while(1){if((f[D+4>>2]|0)!=(x|0))break;j=D+24|0;f[n>>2]=f[j>>2];A=f[j>>2]|0;if(!A){F=22;break b}else D=A}if((f[C>>2]|0)<=(x|0)?(A=D+8|0,j=f[A+4>>2]|0,l=C+8|0,G=f[l+4>>2]|0,!((j|0)<(G|0)|((j|0)==(G|0)?(f[A>>2]|0)>>>0<(f[l>>2]|0)>>>0:0))):0)if((B|0)<(m|0)){H=D;I=n;F=24;break}else{K=C;L=B;break a}M=D;N=f[D+24>>2]|0;O=C;P=B}while(0);if((F|0)==22){F=0;if(!((B|0)<(m|0)?(f[C>>2]|0)==(x|0):0)){K=C;L=B;break a}H=0;I=v+24|0;F=24}if((F|0)==24){F=0;f[I>>2]=C;f[C+24>>2]=H;l=B+1|0;M=C;N=H;O=w+(l<<5)|0;P=l}if(z|0){l=v+16|0;A=v+8|0;G=A;j=Kac(f[G>>2]|0,f[G+4>>2]|0,f[l>>2]|0,f[l+4>>2]|0)|0;l=A;f[l>>2]=j;f[l+4>>2]=J;l=M+16|0;j=M+8|0;A=j;G=Kac(f[A>>2]|0,f[A+4>>2]|0,f[l>>2]|0,f[l+4>>2]|0)|0;l=j;f[l>>2]=G;f[l+4>>2]=J}z=z^1;v=M;E=N;C=O;B=P}}else{B=0;C=h;E=y;v=s;z=g;while(1){c:do if(!E)F=31;else{w=C+24|0;l=E;while(1){if((f[l+4>>2]|0)!=(x|0))break;G=l+24|0;f[w>>2]=f[G>>2];j=f[G>>2]|0;if(!j){F=31;break c}else l=j}if((f[v>>2]|0)<=(x|0)?(D=l+8|0,n=f[D+4>>2]|0,j=v+8|0,G=f[j+4>>2]|0,!((n|0)<(G|0)|((n|0)==(G|0)?(f[D>>2]|0)>>>0<(f[j>>2]|0)>>>0:0))):0)if((z|0)<(m|0)){Q=l;R=w;F=40;break}else{K=v;L=z;break a}S=l;T=f[l+24>>2]|0;U=v;V=z}while(0);if((F|0)==31){F=0;if(!((z|0)<(m|0)?(f[v>>2]|0)==(x|0):0)){K=v;L=z;break a}Q=0;R=C+24|0;F=40}if((F|0)==40){F=0;f[R>>2]=v;f[v+24>>2]=Q;j=z+1|0;S=v;T=Q;U=(f[c>>2]|0)+(j<<5)|0;V=j}if(B|0){j=(f[p>>2]|0)+(Y(f[f[q>>2]>>2]|0,x)|0)|0;D=C+8|0;G=D;n=f[G>>2]|0;A=f[G+4>>2]|0;G=S+8|0;W=G;X=f[W>>2]|0;Z=f[W+4>>2]|0;W=(A|0)>(Z|0)|(A|0)==(Z|0)&n>>>0>X>>>0;_=Kac((W?X:n)|0,(W?Z:A)|0,65535,0)|0;$=Sac(_|0,J|0,16)|0;_=Sac((W?n:X)|0,(W?A:Z)|0,16)|0;do if((_|0)>-1&($|0)<(o|0)){Z=Y(($|0)>0?$:0,r)|0;A=j+Z|0;W=Y(((_|0)<(o|0)?_:a)+1|0,r)|0;X=j+W|0;if(t){Nac(A|0,b[d>>0]|0,X-A|0)|0;break}if((Z|0)<(W|0)){Vac(A|0,d|0,r|0)|0;aa=A+r|0}else aa=A;if(aa>>>0<X>>>0){W=X;Z=r;n=aa;while(1){Vac(n|0,A|0,Z|0)|0;n=n+Z|0;ba=Z<<1;ca=W-n|0;if(n>>>0>=X>>>0)break;else Z=ca>>>0<ba>>>0?ca:ba}}}while(0);j=C+16|0;_=D;$=Kac(f[_>>2]|0,f[_+4>>2]|0,f[j>>2]|0,f[j+4>>2]|0)|0;j=D;f[j>>2]=$;f[j+4>>2]=J;j=S+16|0;$=G;_=Kac(f[$>>2]|0,f[$+4>>2]|0,f[j>>2]|0,f[j+4>>2]|0)|0;j=G;f[j>>2]=_;f[j+4>>2]=J}B=B^1;C=S;E=T;v=U;z=V}}while(0);z=0;v=0;E=f[i>>2]|0;while(1){d:do if((E|0)==(v|0)){da=z;ea=h}else{C=z;B=h;j=E;while(1){_=j+24|0;$=f[_>>2]|0;if(!$){da=C;ea=B;break d}Z=j+8|0;X=f[Z>>2]|0;n=f[Z+4>>2]|0;Z=C;W=B;A=$;while(1){$=A+8|0;l=f[$+4>>2]|0;if(!((n|0)>(l|0)|((n|0)==(l|0)?X>>>0>(f[$>>2]|0)>>>0:0)))break;f[W+24>>2]=A;$=A+24|0;f[_>>2]=f[$>>2];f[$>>2]=j;$=f[_>>2]|0;if(!$){da=1;ea=A;break d}else{l=A;Z=1;A=$;W=l}}if((A|0)==(v|0)){da=Z;ea=j;break}else{W=j;C=Z;j=A;B=W}}}while(0);if(!da)break;E=f[i>>2]|0;if(!((ea|0)!=(h|0)&(ea|0)!=(E|0)))break;else{z=da;v=ea}}v=x+1|0;if((v|0)>=(k|0))break;x=v;s=K;g=L;y=f[i>>2]|0}u=e;return}function xma(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;d=u;u=u+32|0;e=d;g=a;a=b;a:while(1){b=a;h=a+-32|0;i=a+-64|0;j=a+-24|0;k=a+-16|0;l=g;while(1){m=l;b:while(1){n=m;o=b-n|0;p=o>>5;switch(p|0){case 2:{q=5;break a;break}case 3:{q=11;break a;break}case 4:{q=12;break a;break}case 5:{q=13;break a;break}case 1:case 0:{q=107;break a;break}default:{}}if((o|0)<992){q=15;break a}r=(p|0)/2|0;s=m+(r<<5)|0;if((o|0)>31968){o=(p|0)/4|0;t=Bma(m,m+(o<<5)|0,s,s+(o<<5)|0,h,c)|0}else t=zma(m,s,h,c)|0;o=f[m>>2]|0;p=f[s>>2]|0;if((o|0)==(p|0)){v=m+8|0;w=f[v>>2]|0;x=f[v+4>>2]|0;v=m+(r<<5)+8|0;y=f[v>>2]|0;z=f[v+4>>2]|0;if((w|0)==(y|0)&(x|0)==(z|0)){v=m+16|0;A=m+(r<<5)+16|0;B=f[v+4>>2]|0;C=f[A+4>>2]|0;D=f[v>>2]|0;E=f[A>>2]|0}else{B=x;C=z;D=w;E=y}if((B|0)<(C|0)|(B|0)==(C|0)&D>>>0<E>>>0){F=h;G=t;break}}else if((o|0)<(p|0)){F=h;G=t;break}if((m|0)!=(i|0)){y=m+(r<<5)+8|0;w=m+(r<<5)+16|0;r=h;H=i;while(1){z=f[H>>2]|0;if((z|0)==(p|0)){x=r+-24|0;A=f[x>>2]|0;v=f[x+4>>2]|0;x=y;I=f[x>>2]|0;J=f[x+4>>2]|0;if((A|0)==(I|0)&(v|0)==(J|0)){x=r+-16|0;K=w;L=f[x+4>>2]|0;M=f[K+4>>2]|0;N=f[x>>2]|0;O=f[K>>2]|0}else{L=v;M=J;N=A;O=I}if((L|0)<(M|0)|(L|0)==(M|0)&N>>>0<O>>>0){q=77;break b}}else if((z|0)<(p|0)){q=77;break b}z=H+-32|0;if((m|0)==(z|0))break;else{I=H;H=z;r=I}}}r=m+32|0;p=f[h>>2]|0;if((o|0)==(p|0)){w=m+8|0;y=f[w>>2]|0;I=f[w+4>>2]|0;w=j;z=f[w>>2]|0;A=f[w+4>>2]|0;if((y|0)==(z|0)&(I|0)==(A|0)){w=m+16|0;J=k;P=f[w+4>>2]|0;Q=f[J+4>>2]|0;R=f[w>>2]|0;S=f[J>>2]|0}else{P=I;Q=A;R=y;S=z}if((P|0)<(Q|0)|(P|0)==(Q|0)&R>>>0<S>>>0)T=r;else q=46}else if((o|0)<(p|0))T=r;else q=46;if((q|0)==46){q=0;if((r|0)==(h|0)){q=107;break a}p=m+8|0;z=m+16|0;y=r;while(1){r=f[y>>2]|0;if((o|0)==(r|0)){A=p;I=f[A>>2]|0;J=f[A+4>>2]|0;A=y+8|0;w=f[A>>2]|0;v=f[A+4>>2]|0;if((I|0)==(w|0)&(J|0)==(v|0)){A=z;K=y+16|0;U=f[A+4>>2]|0;V=f[K+4>>2]|0;W=f[A>>2]|0;X=f[K>>2]|0}else{U=J;V=v;W=I;X=w}if((U|0)<(V|0)|(U|0)==(V|0)&W>>>0<X>>>0)break}else if((o|0)<(r|0))break;r=y+32|0;if((r|0)==(h|0)){q=107;break a}else y=r}f[e>>2]=f[y>>2];f[e+4>>2]=f[y+4>>2];f[e+8>>2]=f[y+8>>2];f[e+12>>2]=f[y+12>>2];f[e+16>>2]=f[y+16>>2];f[e+20>>2]=f[y+20>>2];f[e+24>>2]=f[y+24>>2];f[e+28>>2]=f[y+28>>2];f[y>>2]=f[h>>2];f[y+4>>2]=f[h+4>>2];f[y+8>>2]=f[h+8>>2];f[y+12>>2]=f[h+12>>2];f[y+16>>2]=f[h+16>>2];f[y+20>>2]=f[h+20>>2];f[y+24>>2]=f[h+24>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];T=y+32|0}if((T|0)==(h|0)){q=107;break a}o=m+8|0;z=m+16|0;p=h;r=T;while(1){w=f[m>>2]|0;I=r;while(1){v=f[I>>2]|0;if((w|0)==(v|0)){J=o;K=f[J>>2]|0;A=f[J+4>>2]|0;J=I+8|0;x=f[J>>2]|0;Y=f[J+4>>2]|0;if((K|0)==(x|0)&(A|0)==(Y|0)){J=z;Z=I+16|0;_=f[J+4>>2]|0;$=f[Z+4>>2]|0;aa=f[J>>2]|0;ba=f[Z>>2]|0}else{_=A;$=Y;aa=K;ba=x}if((_|0)<($|0)|(_|0)==($|0)&aa>>>0<ba>>>0){ca=p;break}}else if((w|0)<(v|0)){ca=p;break}I=I+32|0}while(1){v=ca;ca=ca+-32|0;x=f[ca>>2]|0;if((w|0)!=(x|0))if((w|0)<(x|0)){ca=ca;continue}else break;x=o;K=f[x>>2]|0;Y=f[x+4>>2]|0;x=v+-24|0;A=f[x>>2]|0;Z=f[x+4>>2]|0;if((K|0)==(A|0)&(Y|0)==(Z|0)){x=z;J=v+-16|0;da=f[x+4>>2]|0;ea=f[J+4>>2]|0;fa=f[x>>2]|0;ga=f[J>>2]|0}else{da=Y;ea=Z;fa=K;ga=A}if(!((da|0)<(ea|0)|(da|0)==(ea|0)&fa>>>0<ga>>>0))break}if(I>>>0>=ca>>>0){m=I;continue b};f[e>>2]=f[I>>2];f[e+4>>2]=f[I+4>>2];f[e+8>>2]=f[I+8>>2];f[e+12>>2]=f[I+12>>2];f[e+16>>2]=f[I+16>>2];f[e+20>>2]=f[I+20>>2];f[e+24>>2]=f[I+24>>2];f[e+28>>2]=f[I+28>>2];f[I>>2]=f[ca>>2];f[I+4>>2]=f[ca+4>>2];f[I+8>>2]=f[ca+8>>2];f[I+12>>2]=f[ca+12>>2];f[I+16>>2]=f[ca+16>>2];f[I+20>>2]=f[ca+20>>2];f[I+24>>2]=f[ca+24>>2];f[ca>>2]=f[e>>2];f[ca+4>>2]=f[e+4>>2];f[ca+8>>2]=f[e+8>>2];f[ca+12>>2]=f[e+12>>2];f[ca+16>>2]=f[e+16>>2];f[ca+20>>2]=f[e+20>>2];f[ca+24>>2]=f[e+24>>2];p=ca;r=I+32|0}}if((q|0)==77){q=0;f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];f[e+8>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];f[e+16>>2]=f[m+16>>2];f[e+20>>2]=f[m+20>>2];f[e+24>>2]=f[m+24>>2];f[e+28>>2]=f[m+28>>2];f[m>>2]=f[H>>2];f[m+4>>2]=f[H+4>>2];f[m+8>>2]=f[H+8>>2];f[m+12>>2]=f[H+12>>2];f[m+16>>2]=f[H+16>>2];f[m+20>>2]=f[H+20>>2];f[m+24>>2]=f[H+24>>2];f[H>>2]=f[e>>2];f[H+4>>2]=f[e+4>>2];f[H+8>>2]=f[e+8>>2];f[H+12>>2]=f[e+12>>2];f[H+16>>2]=f[e+16>>2];f[H+20>>2]=f[e+20>>2];f[H+24>>2]=f[e+24>>2];F=H;G=t+1|0}r=m+32|0;c:do if(r>>>0<F>>>0){p=s;z=F;o=r;y=G;while(1){w=f[p>>2]|0;A=p+8|0;K=p+16|0;Z=o;while(1){Y=f[Z>>2]|0;if((Y|0)==(w|0)){J=Z+8|0;x=f[J>>2]|0;v=f[J+4>>2]|0;J=A;ha=f[J>>2]|0;ia=f[J+4>>2]|0;if((x|0)==(ha|0)&(v|0)==(ia|0)){J=Z+16|0;ja=K;ka=f[J+4>>2]|0;la=f[ja+4>>2]|0;ma=f[J>>2]|0;na=f[ja>>2]|0}else{ka=v;la=ia;ma=x;na=ha}if(!((ka|0)<(la|0)|(ka|0)==(la|0)&ma>>>0<na>>>0)){oa=z;break}}else if((Y|0)>=(w|0)){oa=z;break}Z=Z+32|0}while(1){I=oa;oa=oa+-32|0;Y=f[oa>>2]|0;if((Y|0)!=(w|0))if((Y|0)<(w|0))break;else{oa=oa;continue}Y=I+-24|0;ha=f[Y>>2]|0;x=f[Y+4>>2]|0;Y=A;ia=f[Y>>2]|0;v=f[Y+4>>2]|0;if((ha|0)==(ia|0)&(x|0)==(v|0)){Y=I+-16|0;I=K;pa=f[Y+4>>2]|0;qa=f[I+4>>2]|0;ra=f[Y>>2]|0;sa=f[I>>2]|0}else{pa=x;qa=v;ra=ha;sa=ia}if((pa|0)<(qa|0)|(pa|0)==(qa|0)&ra>>>0<sa>>>0)break}if(Z>>>0>oa>>>0){ta=p;ua=y;va=Z;break c};f[e>>2]=f[Z>>2];f[e+4>>2]=f[Z+4>>2];f[e+8>>2]=f[Z+8>>2];f[e+12>>2]=f[Z+12>>2];f[e+16>>2]=f[Z+16>>2];f[e+20>>2]=f[Z+20>>2];f[e+24>>2]=f[Z+24>>2];f[e+28>>2]=f[Z+28>>2];f[Z>>2]=f[oa>>2];f[Z+4>>2]=f[oa+4>>2];f[Z+8>>2]=f[oa+8>>2];f[Z+12>>2]=f[oa+12>>2];f[Z+16>>2]=f[oa+16>>2];f[Z+20>>2]=f[oa+20>>2];f[Z+24>>2]=f[oa+24>>2];f[oa>>2]=f[e>>2];f[oa+4>>2]=f[e+4>>2];f[oa+8>>2]=f[e+8>>2];f[oa+12>>2]=f[e+12>>2];f[oa+16>>2]=f[e+16>>2];f[oa+20>>2]=f[e+20>>2];f[oa+24>>2]=f[e+24>>2];p=(p|0)==(Z|0)?oa:p;z=oa;o=Z+32|0;y=y+1|0}}else{ta=s;ua=G;va=r}while(0);do if((va|0)==(ta|0))wa=ua;else{r=f[ta>>2]|0;y=f[va>>2]|0;if((r|0)==(y|0)){o=ta+8|0;z=f[o>>2]|0;p=f[o+4>>2]|0;o=va+8|0;K=f[o>>2]|0;A=f[o+4>>2]|0;if((z|0)==(K|0)&(p|0)==(A|0)){o=ta+16|0;w=va+16|0;xa=f[o+4>>2]|0;ya=f[w+4>>2]|0;za=f[o>>2]|0;Aa=f[w>>2]|0}else{xa=p;ya=A;za=z;Aa=K}if(!((xa|0)<(ya|0)|(xa|0)==(ya|0)&za>>>0<Aa>>>0)){wa=ua;break}}else if((r|0)>=(y|0)){wa=ua;break};f[e>>2]=f[va>>2];f[e+4>>2]=f[va+4>>2];f[e+8>>2]=f[va+8>>2];f[e+12>>2]=f[va+12>>2];f[e+16>>2]=f[va+16>>2];f[e+20>>2]=f[va+20>>2];f[e+24>>2]=f[va+24>>2];f[e+28>>2]=f[va+28>>2];f[va>>2]=f[ta>>2];f[va+4>>2]=f[ta+4>>2];f[va+8>>2]=f[ta+8>>2];f[va+12>>2]=f[ta+12>>2];f[va+16>>2]=f[ta+16>>2];f[va+20>>2]=f[ta+20>>2];f[va+24>>2]=f[ta+24>>2];f[ta>>2]=f[e>>2];f[ta+4>>2]=f[e+4>>2];f[ta+8>>2]=f[e+8>>2];f[ta+12>>2]=f[e+12>>2];f[ta+16>>2]=f[e+16>>2];f[ta+20>>2]=f[e+20>>2];f[ta+24>>2]=f[e+24>>2];wa=ua+1|0}while(0);if(!wa){Ba=Cma(m,va,c)|0;y=va+32|0;if(Cma(y,a,c)|0){q=106;break}if(Ba){l=y;continue}}y=va;if((y-n|0)>=(b-y|0)){q=105;break}xma(m,va,c);l=va+32|0}if((q|0)==105){q=0;xma(va+32|0,a,c);g=m;a=va;continue}else if((q|0)==106){q=0;if(Ba){q=107;break}else{g=m;a=va;continue}}}if((q|0)==5){va=f[h>>2]|0;g=f[m>>2]|0;if((va|0)==(g|0)){Ba=j;j=f[Ba>>2]|0;n=f[Ba+4>>2]|0;Ba=m+8|0;wa=f[Ba>>2]|0;ua=f[Ba+4>>2]|0;if((j|0)==(wa|0)&(n|0)==(ua|0)){Ba=k;k=m+16|0;Ca=f[Ba+4>>2]|0;Da=f[k+4>>2]|0;Ea=f[Ba>>2]|0;Fa=f[k>>2]|0}else{Ca=n;Da=ua;Ea=j;Fa=wa}if(!((Ca|0)<(Da|0)|(Ca|0)==(Da|0)&Ea>>>0<Fa>>>0)){u=d;return}}else if((va|0)>=(g|0)){u=d;return};f[e>>2]=f[m>>2];f[e+4>>2]=f[m+4>>2];f[e+8>>2]=f[m+8>>2];f[e+12>>2]=f[m+12>>2];f[e+16>>2]=f[m+16>>2];f[e+20>>2]=f[m+20>>2];f[e+24>>2]=f[m+24>>2];f[e+28>>2]=f[m+28>>2];f[m>>2]=f[h>>2];f[m+4>>2]=f[h+4>>2];f[m+8>>2]=f[h+8>>2];f[m+12>>2]=f[h+12>>2];f[m+16>>2]=f[h+16>>2];f[m+20>>2]=f[h+20>>2];f[m+24>>2]=f[h+24>>2];f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2];f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];f[h+16>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];u=d;return}else if((q|0)==11){zma(m,m+32|0,h,c)|0;u=d;return}else if((q|0)==12){Ama(m,m+32|0,m+64|0,h,c)|0;u=d;return}else if((q|0)==13){Bma(m,m+32|0,m+64|0,m+96|0,h,c)|0;u=d;return}else if((q|0)==15){h=m+64|0;zma(m,m+32|0,h,c)|0;c=m+96|0;if((c|0)==(a|0)){u=d;return}else{Ga=c;Ha=h}while(1){h=f[Ga>>2]|0;c=f[Ha>>2]|0;if((h|0)==(c|0)){e=Ga+8|0;g=f[e>>2]|0;va=f[e+4>>2]|0;e=Ha+8|0;Fa=f[e>>2]|0;Ea=f[e+4>>2]|0;if((g|0)==(Fa|0)&(va|0)==(Ea|0)){e=Ga+16|0;Da=Ha+16|0;Ia=f[e+4>>2]|0;Ja=f[Da+4>>2]|0;Ka=f[e>>2]|0;La=f[Da>>2]|0}else{Ia=va;Ja=Ea;Ka=g;La=Fa}if((Ia|0)<(Ja|0)|(Ia|0)==(Ja|0)&Ka>>>0<La>>>0){Ma=g;Na=va;q=22}}else if((h|0)<(c|0)){c=Ga+8|0;Ma=f[c>>2]|0;Na=f[c+4>>2]|0;q=22}if((q|0)==22){q=0;c=f[Ga+4>>2]|0;va=Ga+16|0;g=f[va>>2]|0;Fa=f[va+4>>2]|0;va=f[Ga+24>>2]|0;f[Ga>>2]=f[Ha>>2];f[Ga+4>>2]=f[Ha+4>>2];f[Ga+8>>2]=f[Ha+8>>2];f[Ga+12>>2]=f[Ha+12>>2];f[Ga+16>>2]=f[Ha+16>>2];f[Ga+20>>2]=f[Ha+20>>2];f[Ga+24>>2]=f[Ha+24>>2];d:do if((Ha|0)==(m|0))Oa=m;else{Ea=Ha;while(1){Da=Ea;Ea=Ea+-32|0;e=f[Ea>>2]|0;if((h|0)==(e|0)){Ca=Da+-24|0;wa=f[Ca>>2]|0;j=f[Ca+4>>2]|0;if((Ma|0)==(wa|0)&(Na|0)==(j|0)){Ca=Da+-16|0;Pa=Fa;Qa=f[Ca+4>>2]|0;Ra=g;Sa=f[Ca>>2]|0}else{Pa=Na;Qa=j;Ra=Ma;Sa=wa}if(!((Pa|0)<(Qa|0)|(Pa|0)==(Qa|0)&Ra>>>0<Sa>>>0)){Oa=Da;break d}}else if((h|0)>=(e|0)){Oa=Da;break d};f[Da>>2]=f[Ea>>2];f[Da+4>>2]=f[Ea+4>>2];f[Da+8>>2]=f[Ea+8>>2];f[Da+12>>2]=f[Ea+12>>2];f[Da+16>>2]=f[Ea+16>>2];f[Da+20>>2]=f[Ea+20>>2];f[Da+24>>2]=f[Ea+24>>2];if((Ea|0)==(m|0)){Oa=m;break}}}while(0);f[Oa>>2]=h;f[Oa+4>>2]=c;Ea=Oa+8|0;f[Ea>>2]=Ma;f[Ea+4>>2]=Na;Ea=Oa+16|0;f[Ea>>2]=g;f[Ea+4>>2]=Fa;f[Oa+24>>2]=va}Ea=Ga+32|0;if((Ea|0)==(a|0))break;else{Da=Ga;Ga=Ea;Ha=Da}}u=d;return}else if((q|0)==107){u=d;return}}function yma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>5;h=g+1|0;if(h>>>0>134217727)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>4;l=j>>5>>>0<67108863?(k>>>0<h>>>0?h:k):134217727;do if(l)if(l>>>0>134217727){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<5)|0;break}else m=0;while(0);k=m+(g<<5)|0;f[k>>2]=f[b>>2];f[k+4>>2]=f[b+4>>2];f[k+8>>2]=f[b+8>>2];f[k+12>>2]=f[b+12>>2];f[k+16>>2]=f[b+16>>2];f[k+20>>2]=f[b+20>>2];f[k+24>>2]=f[b+24>>2];f[k+28>>2]=f[b+28>>2];b=k+(0-g<<5)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+32;f[i>>2]=m+(l<<5);if(!d)return;O5b(d);return}function zma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+32|0;e=d;g=f[b>>2]|0;h=f[a>>2]|0;if((g|0)==(h|0)){i=b+8|0;j=f[i>>2]|0;k=f[i+4>>2]|0;i=a+8|0;l=f[i>>2]|0;m=f[i+4>>2]|0;if((j|0)==(l|0)&(k|0)==(m|0)){i=b+16|0;n=a+16|0;o=f[i+4>>2]|0;p=f[n+4>>2]|0;q=f[i>>2]|0;r=f[n>>2]|0}else{o=k;p=m;q=j;r=l}s=(o|0)<(p|0)|(o|0)==(p|0)&q>>>0<r>>>0}else s=(g|0)<(h|0);h=f[c>>2]|0;if((h|0)==(g|0)){r=c+8|0;q=f[r>>2]|0;p=f[r+4>>2]|0;r=b+8|0;o=f[r>>2]|0;l=f[r+4>>2]|0;if((q|0)==(o|0)&(p|0)==(l|0)){r=c+16|0;j=b+16|0;t=f[r+4>>2]|0;v=f[j+4>>2]|0;w=f[r>>2]|0;x=f[j>>2]|0}else{t=p;v=l;w=q;x=o}y=(t|0)<(v|0)|(t|0)==(v|0)&w>>>0<x>>>0}else y=(h|0)<(g|0);if(!s){if(!y){z=0;u=d;return z|0};f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];f[e+8>>2]=f[b+8>>2];f[e+12>>2]=f[b+12>>2];f[e+16>>2]=f[b+16>>2];f[e+20>>2]=f[b+20>>2];f[e+24>>2]=f[b+24>>2];f[e+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];s=f[b>>2]|0;g=f[a>>2]|0;if((s|0)==(g|0)){h=b+8|0;x=f[h>>2]|0;w=f[h+4>>2]|0;h=a+8|0;v=f[h>>2]|0;t=f[h+4>>2]|0;if((x|0)==(v|0)&(w|0)==(t|0)){h=b+16|0;o=a+16|0;A=f[h+4>>2]|0;B=f[o+4>>2]|0;C=f[h>>2]|0;D=f[o>>2]|0}else{A=w;B=t;C=x;D=v}if(!((A|0)<(B|0)|(A|0)==(B|0)&C>>>0<D>>>0)){z=1;u=d;return z|0}}else if((s|0)>=(g|0)){z=1;u=d;return z|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[e+16>>2]=f[a+16>>2];f[e+20>>2]=f[a+20>>2];f[e+24>>2]=f[a+24>>2];f[e+28>>2]=f[a+28>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[b+16>>2]=f[e+16>>2];f[b+20>>2]=f[e+20>>2];f[b+24>>2]=f[e+24>>2];z=2;u=d;return z|0};f[e>>2]=f[a>>2];f[e+4>>2]=f[a+4>>2];f[e+8>>2]=f[a+8>>2];f[e+12>>2]=f[a+12>>2];f[e+16>>2]=f[a+16>>2];f[e+20>>2]=f[a+20>>2];f[e+24>>2]=f[a+24>>2];f[e+28>>2]=f[a+28>>2];if(y){f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];z=1;u=d;return z|0};f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[e>>2];f[b+4>>2]=f[e+4>>2];f[b+8>>2]=f[e+8>>2];f[b+12>>2]=f[e+12>>2];f[b+16>>2]=f[e+16>>2];f[b+20>>2]=f[e+20>>2];f[b+24>>2]=f[e+24>>2];a=f[c>>2]|0;y=f[b>>2]|0;if((a|0)==(y|0)){g=c+8|0;s=f[g>>2]|0;D=f[g+4>>2]|0;g=b+8|0;C=f[g>>2]|0;B=f[g+4>>2]|0;if((s|0)==(C|0)&(D|0)==(B|0)){g=c+16|0;A=b+16|0;E=f[g+4>>2]|0;F=f[A+4>>2]|0;G=f[g>>2]|0;H=f[A>>2]|0}else{E=D;F=B;G=s;H=C}if(!((E|0)<(F|0)|(E|0)==(F|0)&G>>>0<H>>>0)){z=1;u=d;return z|0}}else if((a|0)>=(y|0)){z=1;u=d;return z|0};f[e>>2]=f[b>>2];f[e+4>>2]=f[b+4>>2];f[e+8>>2]=f[b+8>>2];f[e+12>>2]=f[b+12>>2];f[e+16>>2]=f[b+16>>2];f[e+20>>2]=f[b+20>>2];f[e+24>>2]=f[b+24>>2];f[e+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[e>>2];f[c+4>>2]=f[e+4>>2];f[c+8>>2]=f[e+8>>2];f[c+12>>2]=f[e+12>>2];f[c+16>>2]=f[e+16>>2];f[c+20>>2]=f[e+20>>2];f[c+24>>2]=f[e+24>>2];z=2;u=d;return z|0}function Ama(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;g=u;u=u+32|0;h=g;i=zma(a,b,c,e)|0;e=f[d>>2]|0;j=f[c>>2]|0;if((e|0)==(j|0)){k=d+8|0;l=f[k>>2]|0;m=f[k+4>>2]|0;k=c+8|0;n=f[k>>2]|0;o=f[k+4>>2]|0;if((l|0)==(n|0)&(m|0)==(o|0)){k=d+16|0;p=c+16|0;q=f[k+4>>2]|0;r=f[p+4>>2]|0;s=f[k>>2]|0;t=f[p>>2]|0}else{q=m;r=o;s=l;t=n}if(!((q|0)<(r|0)|(q|0)==(r|0)&s>>>0<t>>>0)){v=i;u=g;return v|0}}else if((e|0)>=(j|0)){v=i;u=g;return v|0};f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2];f[h+8>>2]=f[c+8>>2];f[h+12>>2]=f[c+12>>2];f[h+16>>2]=f[c+16>>2];f[h+20>>2]=f[c+20>>2];f[h+24>>2]=f[c+24>>2];f[h+28>>2]=f[c+28>>2];f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[c+16>>2]=f[d+16>>2];f[c+20>>2]=f[d+20>>2];f[c+24>>2]=f[d+24>>2];f[d>>2]=f[h>>2];f[d+4>>2]=f[h+4>>2];f[d+8>>2]=f[h+8>>2];f[d+12>>2]=f[h+12>>2];f[d+16>>2]=f[h+16>>2];f[d+20>>2]=f[h+20>>2];f[d+24>>2]=f[h+24>>2];d=i+1|0;j=f[c>>2]|0;e=f[b>>2]|0;if((j|0)==(e|0)){t=c+8|0;s=f[t>>2]|0;r=f[t+4>>2]|0;t=b+8|0;q=f[t>>2]|0;n=f[t+4>>2]|0;if((s|0)==(q|0)&(r|0)==(n|0)){t=c+16|0;l=b+16|0;w=f[t+4>>2]|0;x=f[l+4>>2]|0;y=f[t>>2]|0;z=f[l>>2]|0}else{w=r;x=n;y=s;z=q}if(!((w|0)<(x|0)|(w|0)==(x|0)&y>>>0<z>>>0)){v=d;u=g;return v|0}}else if((j|0)>=(e|0)){v=d;u=g;return v|0};f[h>>2]=f[b>>2];f[h+4>>2]=f[b+4>>2];f[h+8>>2]=f[b+8>>2];f[h+12>>2]=f[b+12>>2];f[h+16>>2]=f[b+16>>2];f[h+20>>2]=f[b+20>>2];f[h+24>>2]=f[b+24>>2];f[h+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[h>>2];f[c+4>>2]=f[h+4>>2];f[c+8>>2]=f[h+8>>2];f[c+12>>2]=f[h+12>>2];f[c+16>>2]=f[h+16>>2];f[c+20>>2]=f[h+20>>2];f[c+24>>2]=f[h+24>>2];c=i+2|0;d=f[b>>2]|0;e=f[a>>2]|0;if((d|0)==(e|0)){j=b+8|0;z=f[j>>2]|0;y=f[j+4>>2]|0;j=a+8|0;x=f[j>>2]|0;w=f[j+4>>2]|0;if((z|0)==(x|0)&(y|0)==(w|0)){j=b+16|0;q=a+16|0;A=f[j+4>>2]|0;B=f[q+4>>2]|0;C=f[j>>2]|0;D=f[q>>2]|0}else{A=y;B=w;C=z;D=x}if(!((A|0)<(B|0)|(A|0)==(B|0)&C>>>0<D>>>0)){v=c;u=g;return v|0}}else if((d|0)>=(e|0)){v=c;u=g;return v|0};f[h>>2]=f[a>>2];f[h+4>>2]=f[a+4>>2];f[h+8>>2]=f[a+8>>2];f[h+12>>2]=f[a+12>>2];f[h+16>>2]=f[a+16>>2];f[h+20>>2]=f[a+20>>2];f[h+24>>2]=f[a+24>>2];f[h+28>>2]=f[a+28>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[h>>2];f[b+4>>2]=f[h+4>>2];f[b+8>>2]=f[h+8>>2];f[b+12>>2]=f[h+12>>2];f[b+16>>2]=f[h+16>>2];f[b+20>>2]=f[h+20>>2];f[b+24>>2]=f[h+24>>2];v=i+3|0;u=g;return v|0}function Bma(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=u;u=u+32|0;i=h;j=Ama(a,b,c,d,g)|0;g=f[e>>2]|0;k=f[d>>2]|0;if((g|0)==(k|0)){l=e+8|0;m=f[l>>2]|0;n=f[l+4>>2]|0;l=d+8|0;o=f[l>>2]|0;p=f[l+4>>2]|0;if((m|0)==(o|0)&(n|0)==(p|0)){l=e+16|0;q=d+16|0;r=f[l+4>>2]|0;s=f[q+4>>2]|0;t=f[l>>2]|0;v=f[q>>2]|0}else{r=n;s=p;t=m;v=o}if(!((r|0)<(s|0)|(r|0)==(s|0)&t>>>0<v>>>0)){w=j;u=h;return w|0}}else if((g|0)>=(k|0)){w=j;u=h;return w|0};f[i>>2]=f[d>>2];f[i+4>>2]=f[d+4>>2];f[i+8>>2]=f[d+8>>2];f[i+12>>2]=f[d+12>>2];f[i+16>>2]=f[d+16>>2];f[i+20>>2]=f[d+20>>2];f[i+24>>2]=f[d+24>>2];f[i+28>>2]=f[d+28>>2];f[d>>2]=f[e>>2];f[d+4>>2]=f[e+4>>2];f[d+8>>2]=f[e+8>>2];f[d+12>>2]=f[e+12>>2];f[d+16>>2]=f[e+16>>2];f[d+20>>2]=f[e+20>>2];f[d+24>>2]=f[e+24>>2];f[e>>2]=f[i>>2];f[e+4>>2]=f[i+4>>2];f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[e+16>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];e=j+1|0;k=f[d>>2]|0;g=f[c>>2]|0;if((k|0)==(g|0)){v=d+8|0;t=f[v>>2]|0;s=f[v+4>>2]|0;v=c+8|0;r=f[v>>2]|0;o=f[v+4>>2]|0;if((t|0)==(r|0)&(s|0)==(o|0)){v=d+16|0;m=c+16|0;x=f[v+4>>2]|0;y=f[m+4>>2]|0;z=f[v>>2]|0;A=f[m>>2]|0}else{x=s;y=o;z=t;A=r}if(!((x|0)<(y|0)|(x|0)==(y|0)&z>>>0<A>>>0)){w=e;u=h;return w|0}}else if((k|0)>=(g|0)){w=e;u=h;return w|0};f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[i+8>>2]=f[c+8>>2];f[i+12>>2]=f[c+12>>2];f[i+16>>2]=f[c+16>>2];f[i+20>>2]=f[c+20>>2];f[i+24>>2]=f[c+24>>2];f[i+28>>2]=f[c+28>>2];f[c>>2]=f[d>>2];f[c+4>>2]=f[d+4>>2];f[c+8>>2]=f[d+8>>2];f[c+12>>2]=f[d+12>>2];f[c+16>>2]=f[d+16>>2];f[c+20>>2]=f[d+20>>2];f[c+24>>2]=f[d+24>>2];f[d>>2]=f[i>>2];f[d+4>>2]=f[i+4>>2];f[d+8>>2]=f[i+8>>2];f[d+12>>2]=f[i+12>>2];f[d+16>>2]=f[i+16>>2];f[d+20>>2]=f[i+20>>2];f[d+24>>2]=f[i+24>>2];d=j+2|0;e=f[c>>2]|0;g=f[b>>2]|0;if((e|0)==(g|0)){k=c+8|0;A=f[k>>2]|0;z=f[k+4>>2]|0;k=b+8|0;y=f[k>>2]|0;x=f[k+4>>2]|0;if((A|0)==(y|0)&(z|0)==(x|0)){k=c+16|0;r=b+16|0;B=f[k+4>>2]|0;C=f[r+4>>2]|0;D=f[k>>2]|0;E=f[r>>2]|0}else{B=z;C=x;D=A;E=y}if(!((B|0)<(C|0)|(B|0)==(C|0)&D>>>0<E>>>0)){w=d;u=h;return w|0}}else if((e|0)>=(g|0)){w=d;u=h;return w|0};f[i>>2]=f[b>>2];f[i+4>>2]=f[b+4>>2];f[i+8>>2]=f[b+8>>2];f[i+12>>2]=f[b+12>>2];f[i+16>>2]=f[b+16>>2];f[i+20>>2]=f[b+20>>2];f[i+24>>2]=f[b+24>>2];f[i+28>>2]=f[b+28>>2];f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];f[b+16>>2]=f[c+16>>2];f[b+20>>2]=f[c+20>>2];f[b+24>>2]=f[c+24>>2];f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];f[c+12>>2]=f[i+12>>2];f[c+16>>2]=f[i+16>>2];f[c+20>>2]=f[i+20>>2];f[c+24>>2]=f[i+24>>2];c=j+3|0;d=f[b>>2]|0;g=f[a>>2]|0;if((d|0)==(g|0)){e=b+8|0;E=f[e>>2]|0;D=f[e+4>>2]|0;e=a+8|0;C=f[e>>2]|0;B=f[e+4>>2]|0;if((E|0)==(C|0)&(D|0)==(B|0)){e=b+16|0;y=a+16|0;F=f[e+4>>2]|0;G=f[y+4>>2]|0;H=f[e>>2]|0;I=f[y>>2]|0}else{F=D;G=B;H=E;I=C}if(!((F|0)<(G|0)|(F|0)==(G|0)&H>>>0<I>>>0)){w=c;u=h;return w|0}}else if((d|0)>=(g|0)){w=c;u=h;return w|0};f[i>>2]=f[a>>2];f[i+4>>2]=f[a+4>>2];f[i+8>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[a>>2]=f[b>>2];f[a+4>>2]=f[b+4>>2];f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];f[a+16>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[b>>2]=f[i>>2];f[b+4>>2]=f[i+4>>2];f[b+8>>2]=f[i+8>>2];f[b+12>>2]=f[i+12>>2];f[b+16>>2]=f[i+16>>2];f[b+20>>2]=f[i+20>>2];f[b+24>>2]=f[i+24>>2];w=j+4|0;u=h;return w|0}
function e5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;j=0;do{p[c+(j<<3)>>3]=+n[b+(j<<2)>>2]+ +n[b+(j+e<<2)>>2]+ +n[b+(j+i<<2)>>2];j=j+1|0}while((j|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;j=e*3|0;i=e<<2;k=0;do{p[c+(k<<3)>>3]=+n[b+(k<<2)>>2]+ +n[b+(k+e<<2)>>2]+ +n[b+(k+d<<2)>>2]+ +n[b+(k+j<<2)>>2]+ +n[b+(k+i<<2)>>2];k=k+1|0}while((k|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){l=0.0;g=0;while(1){m=l+ +n[b+(g<<2)>>2];g=g+1|0;if((g|0)==(a|0)){o=m;break}else l=m}}else o=0.0;p[c>>3]=o;if((h|0)>0){q=o;r=0}else return;do{q=q+(+n[b+(r+a<<2)>>2]-+n[b+(r<<2)>>2]);r=r+1|0;p[c+(r<<3)>>3]=q}while((r|0)!=(h|0));return}case 3:{if((a|0)>0){q=0.0;o=0.0;l=0.0;r=0;while(1){m=l+ +n[b+(r<<2)>>2];s=o+ +n[b+(r+1<<2)>>2];t=q+ +n[b+(r+2<<2)>>2];r=r+3|0;if((r|0)>=(a|0)){u=t;v=s;w=m;break}else{q=t;o=s;l=m}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=w;p[c+8>>3]=v;p[c+16>>3]=u;if((h|0)>0){x=u;y=v;z=w;A=0}else return;do{r=A+a|0;z=z+(+n[b+(r<<2)>>2]-+n[b+(A<<2)>>2]);y=y+(+n[b+(r+1<<2)>>2]-+n[b+(A+1<<2)>>2]);x=x+(+n[b+(r+2<<2)>>2]-+n[b+(A+2<<2)>>2]);r=A;A=A+3|0;p[c+(A<<3)>>3]=z;p[c+(r+4<<3)>>3]=y;p[c+(r+5<<3)>>3]=x}while((A|0)<(h|0));return}case 4:{if((a|0)>0){x=0.0;y=0.0;z=0.0;w=0.0;A=0;while(1){v=w+ +n[b+(A<<2)>>2];u=z+ +n[b+((A|1)<<2)>>2];l=y+ +n[b+((A|2)<<2)>>2];o=x+ +n[b+((A|3)<<2)>>2];A=A+4|0;if((A|0)>=(a|0)){B=o;C=l;D=u;E=v;break}else{x=o;y=l;z=u;w=v}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=E;p[c+8>>3]=D;p[c+16>>3]=C;p[c+24>>3]=B;if((h|0)>0){F=B;G=C;H=D;I=E;J=0}else return;do{A=J+a|0;I=I+(+n[b+(A<<2)>>2]-+n[b+(J<<2)>>2]);H=H+(+n[b+(A+1<<2)>>2]-+n[b+((J|1)<<2)>>2]);G=G+(+n[b+(A+2<<2)>>2]-+n[b+((J|2)<<2)>>2]);F=F+(+n[b+(A+3<<2)>>2]-+n[b+((J|3)<<2)>>2]);A=J;J=J+4|0;p[c+(J<<3)>>3]=I;p[c+(A+5<<3)>>3]=H;p[c+(A+6<<3)>>3]=G;p[c+(A+7<<3)>>3]=F}while((J|0)<(h|0));return}default:{if((e|0)<=0)return;J=(h|0)>0;if((a|0)>0){A=0;r=c;g=b;while(1){F=0.0;k=0;do{F=F+ +n[g+(k<<2)>>2];k=k+e|0}while((k|0)<(a|0));p[r>>3]=F;if(J){G=F;k=0;do{G=G+(+n[g+(k+a<<2)>>2]-+n[g+(k<<2)>>2]);k=k+e|0;p[r+(k<<3)>>3]=G}while((k|0)<(h|0))}A=A+1|0;if((A|0)==(e|0))break;else{r=r+8|0;g=g+4|0}}return}if(J){K=0;L=c;M=b}else{Nac(c|0,0,e<<3|0)|0;return}while(1){p[L>>3]=0.0;G=0.0;c=0;do{G=G+(+n[M+(c+a<<2)>>2]-+n[M+(c<<2)>>2]);c=c+e|0;p[L+(c<<3)>>3]=G}while((c|0)<(h|0));K=K+1|0;if((K|0)==(e|0))break;else{L=L+8|0;M=M+4|0}}return}}}}function f5(a){a=a|0;O5b(a);return}function g5(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function h5(a){a=a|0;O5b(a);return}function i5(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0;h=f[a+4>>2]|0;a=Y(h,g)|0;i=Y(e+-1|0,g)|0;switch(h|0){case 3:{h=Y(g,e)|0;if((h|0)<=0)return;j=g<<1;k=0;do{p[c+(k<<3)>>3]=+(d[b+(k<<1)>>1]|0)+ +(d[b+(k+g<<1)>>1]|0)+ +(d[b+(k+j<<1)>>1]|0);k=k+1|0}while((k|0)!=(h|0));return}case 5:{h=Y(g,e)|0;if((h|0)<=0)return;e=g<<1;k=g*3|0;j=g<<2;l=0;do{p[c+(l<<3)>>3]=+(d[b+(l<<1)>>1]|0)+ +(d[b+(l+g<<1)>>1]|0)+ +(d[b+(l+e<<1)>>1]|0)+ +(d[b+(l+k<<1)>>1]|0)+ +(d[b+(l+j<<1)>>1]|0);l=l+1|0}while((l|0)!=(h|0));return}default:switch(g|0){case 1:{if((a|0)>0){m=0.0;h=0;while(1){n=m+ +(d[b+(h<<1)>>1]|0);h=h+1|0;if((h|0)==(a|0)){o=n;break}else m=n}}else o=0.0;p[c>>3]=o;if((i|0)>0){q=o;r=0}else return;do{q=q+(+(d[b+(r+a<<1)>>1]|0)-+(d[b+(r<<1)>>1]|0));r=r+1|0;p[c+(r<<3)>>3]=q}while((r|0)!=(i|0));return}case 3:{if((a|0)>0){q=0.0;o=0.0;m=0.0;r=0;while(1){n=m+ +(d[b+(r<<1)>>1]|0);s=o+ +(d[b+(r+1<<1)>>1]|0);t=q+ +(d[b+(r+2<<1)>>1]|0);r=r+3|0;if((r|0)>=(a|0)){u=t;v=s;w=n;break}else{q=t;o=s;m=n}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=w;p[c+8>>3]=v;p[c+16>>3]=u;if((i|0)>0){x=u;y=v;z=w;A=0}else return;do{r=A+a|0;z=z+(+(d[b+(r<<1)>>1]|0)-+(d[b+(A<<1)>>1]|0));y=y+(+(d[b+(r+1<<1)>>1]|0)-+(d[b+(A+1<<1)>>1]|0));x=x+(+(d[b+(r+2<<1)>>1]|0)-+(d[b+(A+2<<1)>>1]|0));r=A;A=A+3|0;p[c+(A<<3)>>3]=z;p[c+(r+4<<3)>>3]=y;p[c+(r+5<<3)>>3]=x}while((A|0)<(i|0));return}case 4:{if((a|0)>0){x=0.0;y=0.0;z=0.0;w=0.0;A=0;while(1){v=w+ +(d[b+(A<<1)>>1]|0);u=z+ +(d[b+((A|1)<<1)>>1]|0);m=y+ +(d[b+((A|2)<<1)>>1]|0);o=x+ +(d[b+((A|3)<<1)>>1]|0);A=A+4|0;if((A|0)>=(a|0)){B=o;C=m;D=u;E=v;break}else{x=o;y=m;z=u;w=v}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=E;p[c+8>>3]=D;p[c+16>>3]=C;p[c+24>>3]=B;if((i|0)>0){F=B;G=C;H=D;I=E;J=0}else return;do{A=J+a|0;I=I+(+(d[b+(A<<1)>>1]|0)-+(d[b+(J<<1)>>1]|0));H=H+(+(d[b+(A+1<<1)>>1]|0)-+(d[b+((J|1)<<1)>>1]|0));G=G+(+(d[b+(A+2<<1)>>1]|0)-+(d[b+((J|2)<<1)>>1]|0));F=F+(+(d[b+(A+3<<1)>>1]|0)-+(d[b+((J|3)<<1)>>1]|0));A=J;J=J+4|0;p[c+(J<<3)>>3]=I;p[c+(A+5<<3)>>3]=H;p[c+(A+6<<3)>>3]=G;p[c+(A+7<<3)>>3]=F}while((J|0)<(i|0));return}default:{if((g|0)<=0)return;J=(i|0)>0;if((a|0)>0){A=0;r=c;h=b;while(1){F=0.0;l=0;do{F=F+ +(d[h+(l<<1)>>1]|0);l=l+g|0}while((l|0)<(a|0));p[r>>3]=F;if(J){G=F;l=0;do{G=G+(+(d[h+(l+a<<1)>>1]|0)-+(d[h+(l<<1)>>1]|0));l=l+g|0;p[r+(l<<3)>>3]=G}while((l|0)<(i|0))}A=A+1|0;if((A|0)==(g|0))break;else{r=r+8|0;h=h+2|0}}return}if(J){K=0;L=c;M=b}else{Nac(c|0,0,g<<3|0)|0;return}while(1){p[L>>3]=0.0;G=0.0;c=0;do{G=G+(+(d[M+(c+a<<1)>>1]|0)-+(d[M+(c<<1)>>1]|0));c=c+g|0;p[L+(c<<3)>>3]=G}while((c|0)<(i|0));K=K+1|0;if((K|0)==(g|0))break;else{L=L+8|0;M=M+2|0}}return}}}}function j5(a){a=a|0;O5b(a);return}function k5(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function l5(a){a=a|0;O5b(a);return}function m5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;j=0;do{f[c+(j<<2)>>2]=(f[b+(j+e<<2)>>2]|0)+(f[b+(j<<2)>>2]|0)+(f[b+(j+i<<2)>>2]|0);j=j+1|0}while((j|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;j=e*3|0;i=e<<2;k=0;do{f[c+(k<<2)>>2]=(f[b+(k+e<<2)>>2]|0)+(f[b+(k<<2)>>2]|0)+(f[b+(k+d<<2)>>2]|0)+(f[b+(k+j<<2)>>2]|0)+(f[b+(k+i<<2)>>2]|0);k=k+1|0}while((k|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;k=0;while(1){i=(f[b+(k<<2)>>2]|0)+g|0;k=k+1|0;if((k|0)==(a|0)){l=i;break}else g=i}}else l=0;f[c>>2]=l;if((h|0)>0){m=l;n=0}else return;do{m=(f[b+(n+a<<2)>>2]|0)-(f[b+(n<<2)>>2]|0)+m|0;n=n+1|0;f[c+(n<<2)>>2]=m}while((n|0)!=(h|0));return}case 3:{if((a|0)>0){n=0;m=0;l=0;g=0;while(1){k=(f[b+(g<<2)>>2]|0)+l|0;i=(f[b+(g+1<<2)>>2]|0)+m|0;j=(f[b+(g+2<<2)>>2]|0)+n|0;g=g+3|0;if((g|0)>=(a|0)){o=j;p=i;q=k;break}else{n=j;m=i;l=k}}}else{o=0;p=0;q=0}f[c>>2]=q;f[c+4>>2]=p;f[c+8>>2]=o;if((h|0)>0){r=o;s=p;t=q;u=0}else return;do{q=u+a|0;t=(f[b+(q<<2)>>2]|0)-(f[b+(u<<2)>>2]|0)+t|0;s=(f[b+(q+1<<2)>>2]|0)-(f[b+(u+1<<2)>>2]|0)+s|0;r=(f[b+(q+2<<2)>>2]|0)-(f[b+(u+2<<2)>>2]|0)+r|0;q=u;u=u+3|0;f[c+(u<<2)>>2]=t;f[c+(q+4<<2)>>2]=s;f[c+(q+5<<2)>>2]=r}while((u|0)<(h|0));return}case 4:{if((a|0)>0){u=0;r=0;s=0;t=0;q=0;while(1){p=(f[b+(q<<2)>>2]|0)+t|0;o=(f[b+((q|1)<<2)>>2]|0)+s|0;l=(f[b+((q|2)<<2)>>2]|0)+r|0;m=(f[b+((q|3)<<2)>>2]|0)+u|0;q=q+4|0;if((q|0)>=(a|0)){v=m;w=l;x=o;y=p;break}else{u=m;r=l;s=o;t=p}}}else{v=0;w=0;x=0;y=0}f[c>>2]=y;f[c+4>>2]=x;f[c+8>>2]=w;f[c+12>>2]=v;if((h|0)>0){z=v;A=w;B=x;C=y;D=0}else return;do{y=D+a|0;C=(f[b+(y<<2)>>2]|0)-(f[b+(D<<2)>>2]|0)+C|0;B=(f[b+(y+1<<2)>>2]|0)-(f[b+((D|1)<<2)>>2]|0)+B|0;A=(f[b+(y+2<<2)>>2]|0)-(f[b+((D|2)<<2)>>2]|0)+A|0;z=(f[b+(y+3<<2)>>2]|0)-(f[b+((D|3)<<2)>>2]|0)+z|0;y=D;D=D+4|0;f[c+(D<<2)>>2]=C;f[c+(y+5<<2)>>2]=B;f[c+(y+6<<2)>>2]=A;f[c+(y+7<<2)>>2]=z}while((D|0)<(h|0));return}default:{if((e|0)<=0)return;D=(h|0)>0;if((a|0)>0){z=0;A=c;B=b;while(1){C=0;y=0;do{C=(f[B+(y<<2)>>2]|0)+C|0;y=y+e|0}while((y|0)<(a|0));f[A>>2]=C;if(D){y=C;x=0;do{y=(f[B+(x+a<<2)>>2]|0)-(f[B+(x<<2)>>2]|0)+y|0;x=x+e|0;f[A+(x<<2)>>2]=y}while((x|0)<(h|0))}z=z+1|0;if((z|0)==(e|0))break;else{A=A+4|0;B=B+4|0}}return}if(D){E=0;F=c;G=b}else{Nac(c|0,0,e<<2|0)|0;return}while(1){f[F>>2]=0;c=0;b=0;do{c=(f[G+(b+a<<2)>>2]|0)-(f[G+(b<<2)>>2]|0)+c|0;b=b+e|0;f[F+(b<<2)>>2]=c}while((b|0)<(h|0));E=E+1|0;if((E|0)==(e|0))break;else{F=F+4|0;G=G+4|0}}return}}}}function n5(a){a=a|0;O5b(a);return}function o5(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function p5(a){a=a|0;O5b(a);return}function q5(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=f[a+4>>2]|0;a=Y(h,g)|0;i=Y(e+-1|0,g)|0;switch(h|0){case 3:{h=Y(g,e)|0;if((h|0)<=0)return;j=g<<1;k=0;do{f[c+(k<<2)>>2]=(d[b+(k+g<<1)>>1]|0)+(d[b+(k<<1)>>1]|0)+(d[b+(k+j<<1)>>1]|0);k=k+1|0}while((k|0)!=(h|0));return}case 5:{h=Y(g,e)|0;if((h|0)<=0)return;e=g<<1;k=g*3|0;j=g<<2;l=0;do{f[c+(l<<2)>>2]=(d[b+(l+g<<1)>>1]|0)+(d[b+(l<<1)>>1]|0)+(d[b+(l+e<<1)>>1]|0)+(d[b+(l+k<<1)>>1]|0)+(d[b+(l+j<<1)>>1]|0);l=l+1|0}while((l|0)!=(h|0));return}default:switch(g|0){case 1:{if((a|0)>0){h=0;l=0;while(1){j=(d[b+(l<<1)>>1]|0)+h|0;l=l+1|0;if((l|0)==(a|0)){m=j;break}else h=j}}else m=0;f[c>>2]=m;if((i|0)>0){n=m;o=0}else return;do{n=(d[b+(o+a<<1)>>1]|0)-(d[b+(o<<1)>>1]|0)+n|0;o=o+1|0;f[c+(o<<2)>>2]=n}while((o|0)!=(i|0));return}case 3:{if((a|0)>0){o=0;n=0;m=0;h=0;while(1){l=(d[b+(h<<1)>>1]|0)+m|0;j=(d[b+(h+1<<1)>>1]|0)+n|0;k=(d[b+(h+2<<1)>>1]|0)+o|0;h=h+3|0;if((h|0)>=(a|0)){p=k;q=j;r=l;break}else{o=k;n=j;m=l}}}else{p=0;q=0;r=0}f[c>>2]=r;f[c+4>>2]=q;f[c+8>>2]=p;if((i|0)>0){s=p;t=q;u=r;v=0}else return;do{r=v+a|0;u=(d[b+(r<<1)>>1]|0)-(d[b+(v<<1)>>1]|0)+u|0;t=(d[b+(r+1<<1)>>1]|0)-(d[b+(v+1<<1)>>1]|0)+t|0;s=(d[b+(r+2<<1)>>1]|0)-(d[b+(v+2<<1)>>1]|0)+s|0;r=v;v=v+3|0;f[c+(v<<2)>>2]=u;f[c+(r+4<<2)>>2]=t;f[c+(r+5<<2)>>2]=s}while((v|0)<(i|0));return}case 4:{if((a|0)>0){v=0;s=0;t=0;u=0;r=0;while(1){q=(d[b+(r<<1)>>1]|0)+u|0;p=(d[b+((r|1)<<1)>>1]|0)+t|0;m=(d[b+((r|2)<<1)>>1]|0)+s|0;n=(d[b+((r|3)<<1)>>1]|0)+v|0;r=r+4|0;if((r|0)>=(a|0)){w=n;x=m;y=p;z=q;break}else{v=n;s=m;t=p;u=q}}}else{w=0;x=0;y=0;z=0}f[c>>2]=z;f[c+4>>2]=y;f[c+8>>2]=x;f[c+12>>2]=w;if((i|0)>0){A=w;B=x;C=y;D=z;E=0}else return;do{z=E+a|0;D=(d[b+(z<<1)>>1]|0)-(d[b+(E<<1)>>1]|0)+D|0;C=(d[b+(z+1<<1)>>1]|0)-(d[b+((E|1)<<1)>>1]|0)+C|0;B=(d[b+(z+2<<1)>>1]|0)-(d[b+((E|2)<<1)>>1]|0)+B|0;A=(d[b+(z+3<<1)>>1]|0)-(d[b+((E|3)<<1)>>1]|0)+A|0;z=E;E=E+4|0;f[c+(E<<2)>>2]=D;f[c+(z+5<<2)>>2]=C;f[c+(z+6<<2)>>2]=B;f[c+(z+7<<2)>>2]=A}while((E|0)<(i|0));return}default:{if((g|0)<=0)return;E=(i|0)>0;if((a|0)>0){A=0;B=c;C=b;while(1){D=0;z=0;do{D=(d[C+(z<<1)>>1]|0)+D|0;z=z+g|0}while((z|0)<(a|0));f[B>>2]=D;if(E){z=D;y=0;do{z=(d[C+(y+a<<1)>>1]|0)-(d[C+(y<<1)>>1]|0)+z|0;y=y+g|0;f[B+(y<<2)>>2]=z}while((y|0)<(i|0))}A=A+1|0;if((A|0)==(g|0))break;else{B=B+4|0;C=C+2|0}}return}if(E){F=0;G=c;H=b}else{Nac(c|0,0,g<<2|0)|0;return}while(1){f[G>>2]=0;c=0;b=0;do{c=(d[H+(b+a<<1)>>1]|0)-(d[H+(b<<1)>>1]|0)+c|0;b=b+g|0;f[G+(b<<2)>>2]=c}while((b|0)<(i|0));F=F+1|0;if((F|0)==(g|0))break;else{G=G+4|0;H=H+2|0}}return}}}}function r5(a){a=a|0;O5b(a);return}function s5(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function t5(a){a=a|0;O5b(a);return}function u5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;k=0;do{p[c+(k<<3)>>3]=+(j[b+(k<<1)>>1]|0)+ +(j[b+(k+e<<1)>>1]|0)+ +(j[b+(k+i<<1)>>1]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;i=e<<2;l=0;do{p[c+(l<<3)>>3]=+(j[b+(l<<1)>>1]|0)+ +(j[b+(l+e<<1)>>1]|0)+ +(j[b+(l+d<<1)>>1]|0)+ +(j[b+(l+k<<1)>>1]|0)+ +(j[b+(l+i<<1)>>1]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){m=0.0;g=0;while(1){n=m+ +(j[b+(g<<1)>>1]|0);g=g+1|0;if((g|0)==(a|0)){o=n;break}else m=n}}else o=0.0;p[c>>3]=o;if((h|0)>0){q=o;r=0}else return;do{q=q+(+(j[b+(r+a<<1)>>1]|0)-+(j[b+(r<<1)>>1]|0));r=r+1|0;p[c+(r<<3)>>3]=q}while((r|0)!=(h|0));return}case 3:{if((a|0)>0){q=0.0;o=0.0;m=0.0;r=0;while(1){n=m+ +(j[b+(r<<1)>>1]|0);s=o+ +(j[b+(r+1<<1)>>1]|0);t=q+ +(j[b+(r+2<<1)>>1]|0);r=r+3|0;if((r|0)>=(a|0)){u=t;v=s;w=n;break}else{q=t;o=s;m=n}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=w;p[c+8>>3]=v;p[c+16>>3]=u;if((h|0)>0){x=u;y=v;z=w;A=0}else return;do{r=A+a|0;z=z+(+(j[b+(r<<1)>>1]|0)-+(j[b+(A<<1)>>1]|0));y=y+(+(j[b+(r+1<<1)>>1]|0)-+(j[b+(A+1<<1)>>1]|0));x=x+(+(j[b+(r+2<<1)>>1]|0)-+(j[b+(A+2<<1)>>1]|0));r=A;A=A+3|0;p[c+(A<<3)>>3]=z;p[c+(r+4<<3)>>3]=y;p[c+(r+5<<3)>>3]=x}while((A|0)<(h|0));return}case 4:{if((a|0)>0){x=0.0;y=0.0;z=0.0;w=0.0;A=0;while(1){v=w+ +(j[b+(A<<1)>>1]|0);u=z+ +(j[b+((A|1)<<1)>>1]|0);m=y+ +(j[b+((A|2)<<1)>>1]|0);o=x+ +(j[b+((A|3)<<1)>>1]|0);A=A+4|0;if((A|0)>=(a|0)){B=o;C=m;D=u;E=v;break}else{x=o;y=m;z=u;w=v}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=E;p[c+8>>3]=D;p[c+16>>3]=C;p[c+24>>3]=B;if((h|0)>0){F=B;G=C;H=D;I=E;J=0}else return;do{A=J+a|0;I=I+(+(j[b+(A<<1)>>1]|0)-+(j[b+(J<<1)>>1]|0));H=H+(+(j[b+(A+1<<1)>>1]|0)-+(j[b+((J|1)<<1)>>1]|0));G=G+(+(j[b+(A+2<<1)>>1]|0)-+(j[b+((J|2)<<1)>>1]|0));F=F+(+(j[b+(A+3<<1)>>1]|0)-+(j[b+((J|3)<<1)>>1]|0));A=J;J=J+4|0;p[c+(J<<3)>>3]=I;p[c+(A+5<<3)>>3]=H;p[c+(A+6<<3)>>3]=G;p[c+(A+7<<3)>>3]=F}while((J|0)<(h|0));return}default:{if((e|0)<=0)return;J=(h|0)>0;if((a|0)>0){A=0;r=c;g=b;while(1){F=0.0;l=0;do{F=F+ +(j[g+(l<<1)>>1]|0);l=l+e|0}while((l|0)<(a|0));p[r>>3]=F;if(J){G=F;l=0;do{G=G+(+(j[g+(l+a<<1)>>1]|0)-+(j[g+(l<<1)>>1]|0));l=l+e|0;p[r+(l<<3)>>3]=G}while((l|0)<(h|0))}A=A+1|0;if((A|0)==(e|0))break;else{r=r+8|0;g=g+2|0}}return}if(J){K=0;L=c;M=b}else{Nac(c|0,0,e<<3|0)|0;return}while(1){p[L>>3]=0.0;G=0.0;c=0;do{G=G+(+(j[M+(c+a<<1)>>1]|0)-+(j[M+(c<<1)>>1]|0));c=c+e|0;p[L+(c<<3)>>3]=G}while((c|0)<(h|0));K=K+1|0;if((K|0)==(e|0))break;else{L=L+8|0;M=M+2|0}}return}}}}function v5(a){a=a|0;O5b(a);return}function w5(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function x5(a){a=a|0;O5b(a);return}function y5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;k=0;do{f[c+(k<<2)>>2]=(j[b+(k+e<<1)>>1]|0)+(j[b+(k<<1)>>1]|0)+(j[b+(k+i<<1)>>1]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;i=e<<2;l=0;do{f[c+(l<<2)>>2]=(j[b+(l+e<<1)>>1]|0)+(j[b+(l<<1)>>1]|0)+(j[b+(l+d<<1)>>1]|0)+(j[b+(l+k<<1)>>1]|0)+(j[b+(l+i<<1)>>1]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;l=0;while(1){i=(j[b+(l<<1)>>1]|0)+g|0;l=l+1|0;if((l|0)==(a|0)){m=i;break}else g=i}}else m=0;f[c>>2]=m;if((h|0)>0){n=m;o=0}else return;do{n=(j[b+(o+a<<1)>>1]|0)-(j[b+(o<<1)>>1]|0)+n|0;o=o+1|0;f[c+(o<<2)>>2]=n}while((o|0)!=(h|0));return}case 3:{if((a|0)>0){o=0;n=0;m=0;g=0;while(1){l=(j[b+(g<<1)>>1]|0)+m|0;i=(j[b+(g+1<<1)>>1]|0)+n|0;k=(j[b+(g+2<<1)>>1]|0)+o|0;g=g+3|0;if((g|0)>=(a|0)){p=k;q=i;r=l;break}else{o=k;n=i;m=l}}}else{p=0;q=0;r=0}f[c>>2]=r;f[c+4>>2]=q;f[c+8>>2]=p;if((h|0)>0){s=p;t=q;u=r;v=0}else return;do{r=v+a|0;u=(j[b+(r<<1)>>1]|0)-(j[b+(v<<1)>>1]|0)+u|0;t=(j[b+(r+1<<1)>>1]|0)-(j[b+(v+1<<1)>>1]|0)+t|0;s=(j[b+(r+2<<1)>>1]|0)-(j[b+(v+2<<1)>>1]|0)+s|0;r=v;v=v+3|0;f[c+(v<<2)>>2]=u;f[c+(r+4<<2)>>2]=t;f[c+(r+5<<2)>>2]=s}while((v|0)<(h|0));return}case 4:{if((a|0)>0){v=0;s=0;t=0;u=0;r=0;while(1){q=(j[b+(r<<1)>>1]|0)+u|0;p=(j[b+((r|1)<<1)>>1]|0)+t|0;m=(j[b+((r|2)<<1)>>1]|0)+s|0;n=(j[b+((r|3)<<1)>>1]|0)+v|0;r=r+4|0;if((r|0)>=(a|0)){w=n;x=m;y=p;z=q;break}else{v=n;s=m;t=p;u=q}}}else{w=0;x=0;y=0;z=0}f[c>>2]=z;f[c+4>>2]=y;f[c+8>>2]=x;f[c+12>>2]=w;if((h|0)>0){A=w;B=x;C=y;D=z;E=0}else return;do{z=E+a|0;D=(j[b+(z<<1)>>1]|0)-(j[b+(E<<1)>>1]|0)+D|0;C=(j[b+(z+1<<1)>>1]|0)-(j[b+((E|1)<<1)>>1]|0)+C|0;B=(j[b+(z+2<<1)>>1]|0)-(j[b+((E|2)<<1)>>1]|0)+B|0;A=(j[b+(z+3<<1)>>1]|0)-(j[b+((E|3)<<1)>>1]|0)+A|0;z=E;E=E+4|0;f[c+(E<<2)>>2]=D;f[c+(z+5<<2)>>2]=C;f[c+(z+6<<2)>>2]=B;f[c+(z+7<<2)>>2]=A}while((E|0)<(h|0));return}default:{if((e|0)<=0)return;E=(h|0)>0;if((a|0)>0){A=0;B=c;C=b;while(1){D=0;z=0;do{D=(j[C+(z<<1)>>1]|0)+D|0;z=z+e|0}while((z|0)<(a|0));f[B>>2]=D;if(E){z=D;y=0;do{z=(j[C+(y+a<<1)>>1]|0)-(j[C+(y<<1)>>1]|0)+z|0;y=y+e|0;f[B+(y<<2)>>2]=z}while((y|0)<(h|0))}A=A+1|0;if((A|0)==(e|0))break;else{B=B+4|0;C=C+2|0}}return}if(E){F=0;G=c;H=b}else{Nac(c|0,0,e<<2|0)|0;return}while(1){f[G>>2]=0;c=0;b=0;do{c=(j[H+(b+a<<1)>>1]|0)-(j[H+(b<<1)>>1]|0)+c|0;b=b+e|0;f[G+(b<<2)>>2]=c}while((b|0)<(h|0));F=F+1|0;if((F|0)==(e|0))break;else{G=G+4|0;H=H+2|0}}return}}}}function z5(a){a=a|0;O5b(a);return}function A5(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function B5(a){a=a|0;O5b(a);return}function C5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0;g=f[a+4>>2]|0;a=Y(g,e)|0;i=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;j=e<<1;k=0;do{p[c+(k<<3)>>3]=+(h[b+k>>0]|0)+ +(h[b+(k+e)>>0]|0)+ +(h[b+(k+j)>>0]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;j=e<<2;l=0;do{p[c+(l<<3)>>3]=+(h[b+l>>0]|0)+ +(h[b+(l+e)>>0]|0)+ +(h[b+(l+d)>>0]|0)+ +(h[b+(l+k)>>0]|0)+ +(h[b+(l+j)>>0]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){m=0.0;g=0;while(1){n=m+ +(h[b+g>>0]|0);g=g+1|0;if((g|0)==(a|0)){o=n;break}else m=n}}else o=0.0;p[c>>3]=o;if((i|0)>0){q=o;r=0}else return;do{q=q+(+(h[b+(r+a)>>0]|0)-+(h[b+r>>0]|0));r=r+1|0;p[c+(r<<3)>>3]=q}while((r|0)!=(i|0));return}case 3:{if((a|0)>0){q=0.0;o=0.0;m=0.0;r=0;while(1){n=m+ +(h[b+r>>0]|0);s=o+ +(h[b+(r+1)>>0]|0);t=q+ +(h[b+(r+2)>>0]|0);r=r+3|0;if((r|0)>=(a|0)){u=t;v=s;w=n;break}else{q=t;o=s;m=n}}}else{u=0.0;v=0.0;w=0.0}p[c>>3]=w;p[c+8>>3]=v;p[c+16>>3]=u;if((i|0)>0){x=u;y=v;z=w;A=0}else return;do{r=A+a|0;z=z+(+(h[b+r>>0]|0)-+(h[b+A>>0]|0));y=y+(+(h[b+(r+1)>>0]|0)-+(h[b+(A+1)>>0]|0));x=x+(+(h[b+(r+2)>>0]|0)-+(h[b+(A+2)>>0]|0));r=A;A=A+3|0;p[c+(A<<3)>>3]=z;p[c+(r+4<<3)>>3]=y;p[c+(r+5<<3)>>3]=x}while((A|0)<(i|0));return}case 4:{if((a|0)>0){x=0.0;y=0.0;z=0.0;w=0.0;A=0;while(1){v=w+ +(h[b+A>>0]|0);u=z+ +(h[b+(A|1)>>0]|0);m=y+ +(h[b+(A|2)>>0]|0);o=x+ +(h[b+(A|3)>>0]|0);A=A+4|0;if((A|0)>=(a|0)){B=o;C=m;D=u;E=v;break}else{x=o;y=m;z=u;w=v}}}else{B=0.0;C=0.0;D=0.0;E=0.0}p[c>>3]=E;p[c+8>>3]=D;p[c+16>>3]=C;p[c+24>>3]=B;if((i|0)>0){F=B;G=C;H=D;I=E;J=0}else return;do{A=J+a|0;I=I+(+(h[b+A>>0]|0)-+(h[b+J>>0]|0));H=H+(+(h[b+(A+1)>>0]|0)-+(h[b+(J|1)>>0]|0));G=G+(+(h[b+(A+2)>>0]|0)-+(h[b+(J|2)>>0]|0));F=F+(+(h[b+(A+3)>>0]|0)-+(h[b+(J|3)>>0]|0));A=J;J=J+4|0;p[c+(J<<3)>>3]=I;p[c+(A+5<<3)>>3]=H;p[c+(A+6<<3)>>3]=G;p[c+(A+7<<3)>>3]=F}while((J|0)<(i|0));return}default:{if((e|0)<=0)return;J=(i|0)>0;if((a|0)>0){A=0;r=c;g=b;while(1){F=0.0;l=0;do{F=F+ +(h[g+l>>0]|0);l=l+e|0}while((l|0)<(a|0));p[r>>3]=F;if(J){G=F;l=0;do{G=G+(+(h[g+(l+a)>>0]|0)-+(h[g+l>>0]|0));l=l+e|0;p[r+(l<<3)>>3]=G}while((l|0)<(i|0))}A=A+1|0;if((A|0)==(e|0))break;else{r=r+8|0;g=g+1|0}}return}if(J){K=0;L=c;M=b}else{Nac(c|0,0,e<<3|0)|0;return}while(1){p[L>>3]=0.0;G=0.0;c=0;do{G=G+(+(h[M+(c+a)>>0]|0)-+(h[M+c>>0]|0));c=c+e|0;p[L+(c<<3)>>3]=G}while((c|0)<(i|0));K=K+1|0;if((K|0)==(e|0))break;else{L=L+8|0;M=M+1|0}}return}}}}function D5(a){a=a|0;O5b(a);return}function E5(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function F5(a){a=a|0;O5b(a);return}function G5(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;a=Y(i,g)|0;j=Y(e+-1|0,g)|0;switch(i|0){case 3:{i=Y(g,e)|0;if((i|0)<=0)return;k=g<<1;l=0;do{d[c+(l<<1)>>1]=(h[b+(l+g)>>0]|0)+(h[b+l>>0]|0)+(h[b+(l+k)>>0]|0);l=l+1|0}while((l|0)!=(i|0));return}case 5:{i=Y(g,e)|0;if((i|0)<=0)return;e=g<<1;l=g*3|0;k=g<<2;m=0;do{d[c+(m<<1)>>1]=(h[b+(m+g)>>0]|0)+(h[b+m>>0]|0)+(h[b+(m+e)>>0]|0)+(h[b+(m+l)>>0]|0)+(h[b+(m+k)>>0]|0);m=m+1|0}while((m|0)!=(i|0));return}default:switch(g|0){case 1:{if((a|0)>0){i=0;m=0;do{i=(h[b+m>>0]|0)+(i&65535)|0;m=m+1|0}while((m|0)!=(a|0));n=i&65535}else n=0;d[c>>1]=n;if((j|0)>0){o=n;p=0}else return;do{o=(h[b+(p+a)>>0]|0)+(o&65535)-(h[b+p>>0]|0)&65535;p=p+1|0;d[c+(p<<1)>>1]=o}while((p|0)!=(j|0));return}case 3:{if((a|0)>0){p=0;o=0;n=0;i=0;do{n=(h[b+i>>0]|0)+(n&65535)|0;o=(h[b+(i+1)>>0]|0)+(o&65535)|0;p=(h[b+(i+2)>>0]|0)+(p&65535)|0;i=i+3|0}while((i|0)<(a|0));q=p&65535;r=o&65535;s=n&65535}else{q=0;r=0;s=0}d[c>>1]=s;d[c+2>>1]=r;d[c+4>>1]=q;if((j|0)>0){t=q;u=r;v=s;w=0}else return;do{s=w+a|0;v=(h[b+s>>0]|0)+(v&65535)-(h[b+w>>0]|0)&65535;u=(h[b+(s+1)>>0]|0)+(u&65535)-(h[b+(w+1)>>0]|0)&65535;t=(h[b+(s+2)>>0]|0)+(t&65535)-(h[b+(w+2)>>0]|0)&65535;s=w;w=w+3|0;d[c+(w<<1)>>1]=v;d[c+(s+4<<1)>>1]=u;d[c+(s+5<<1)>>1]=t}while((w|0)<(j|0));return}case 4:{if((a|0)>0){w=0;t=0;u=0;v=0;s=0;do{v=(h[b+s>>0]|0)+(v&65535)|0;u=(h[b+(s|1)>>0]|0)+(u&65535)|0;t=(h[b+(s|2)>>0]|0)+(t&65535)|0;w=(h[b+(s|3)>>0]|0)+(w&65535)|0;s=s+4|0}while((s|0)<(a|0));x=w&65535;y=t&65535;z=u&65535;A=v&65535}else{x=0;y=0;z=0;A=0}d[c>>1]=A;d[c+2>>1]=z;d[c+4>>1]=y;d[c+6>>1]=x;if((j|0)>0){B=x;C=y;D=z;E=A;F=0}else return;do{A=F+a|0;E=(h[b+A>>0]|0)+(E&65535)-(h[b+F>>0]|0)&65535;D=(h[b+(A+1)>>0]|0)+(D&65535)-(h[b+(F|1)>>0]|0)&65535;C=(h[b+(A+2)>>0]|0)+(C&65535)-(h[b+(F|2)>>0]|0)&65535;B=(h[b+(A+3)>>0]|0)+(B&65535)-(h[b+(F|3)>>0]|0)&65535;A=F;F=F+4|0;d[c+(F<<1)>>1]=E;d[c+(A+5<<1)>>1]=D;d[c+(A+6<<1)>>1]=C;d[c+(A+7<<1)>>1]=B}while((F|0)<(j|0));return}default:{if((g|0)<=0)return;F=(j|0)>0;if((a|0)>0){B=0;C=c;D=b;while(1){E=0;A=0;do{E=(h[D+A>>0]|0)+(E&65535)|0;A=A+g|0}while((A|0)<(a|0));d[C>>1]=E;if(F){A=E;z=0;do{A=(h[D+(z+a)>>0]|0)+(A&65535)-(h[D+z>>0]|0)|0;z=z+g|0;d[C+(z<<1)>>1]=A}while((z|0)<(j|0))}B=B+1|0;if((B|0)==(g|0))break;else{C=C+2|0;D=D+1|0}}return}if(F){G=0;H=c;I=b}else{Nac(c|0,0,g<<1|0)|0;return}while(1){d[H>>1]=0;c=0;b=0;do{c=(h[I+(b+a)>>0]|0)+(c&65535)-(h[I+b>>0]|0)|0;b=b+g|0;d[H+(b<<1)>>1]=c}while((b|0)<(j|0));G=G+1|0;if((G|0)==(g|0))break;else{H=H+2|0;I=I+1|0}}return}}}}function H5(a){a=a|0;O5b(a);return}function I5(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function J5(a){a=a|0;O5b(a);return}function K5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=f[a+4>>2]|0;a=Y(g,e)|0;i=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;j=e<<1;k=0;do{f[c+(k<<2)>>2]=(h[b+(k+e)>>0]|0)+(h[b+k>>0]|0)+(h[b+(k+j)>>0]|0);k=k+1|0}while((k|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;k=e*3|0;j=e<<2;l=0;do{f[c+(l<<2)>>2]=(h[b+(l+e)>>0]|0)+(h[b+l>>0]|0)+(h[b+(l+d)>>0]|0)+(h[b+(l+k)>>0]|0)+(h[b+(l+j)>>0]|0);l=l+1|0}while((l|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){g=0;l=0;while(1){j=(h[b+l>>0]|0)+g|0;l=l+1|0;if((l|0)==(a|0)){m=j;break}else g=j}}else m=0;f[c>>2]=m;if((i|0)>0){n=m;o=0}else return;do{n=(h[b+(o+a)>>0]|0)-(h[b+o>>0]|0)+n|0;o=o+1|0;f[c+(o<<2)>>2]=n}while((o|0)!=(i|0));return}case 3:{if((a|0)>0){o=0;n=0;m=0;g=0;while(1){l=(h[b+g>>0]|0)+m|0;j=(h[b+(g+1)>>0]|0)+n|0;k=(h[b+(g+2)>>0]|0)+o|0;g=g+3|0;if((g|0)>=(a|0)){p=k;q=j;r=l;break}else{o=k;n=j;m=l}}}else{p=0;q=0;r=0}f[c>>2]=r;f[c+4>>2]=q;f[c+8>>2]=p;if((i|0)>0){s=p;t=q;u=r;v=0}else return;do{r=v+a|0;u=(h[b+r>>0]|0)-(h[b+v>>0]|0)+u|0;t=(h[b+(r+1)>>0]|0)-(h[b+(v+1)>>0]|0)+t|0;s=(h[b+(r+2)>>0]|0)-(h[b+(v+2)>>0]|0)+s|0;r=v;v=v+3|0;f[c+(v<<2)>>2]=u;f[c+(r+4<<2)>>2]=t;f[c+(r+5<<2)>>2]=s}while((v|0)<(i|0));return}case 4:{if((a|0)>0){v=0;s=0;t=0;u=0;r=0;while(1){q=(h[b+r>>0]|0)+u|0;p=(h[b+(r|1)>>0]|0)+t|0;m=(h[b+(r|2)>>0]|0)+s|0;n=(h[b+(r|3)>>0]|0)+v|0;r=r+4|0;if((r|0)>=(a|0)){w=n;x=m;y=p;z=q;break}else{v=n;s=m;t=p;u=q}}}else{w=0;x=0;y=0;z=0}f[c>>2]=z;f[c+4>>2]=y;f[c+8>>2]=x;f[c+12>>2]=w;if((i|0)>0){A=w;B=x;C=y;D=z;E=0}else return;do{z=E+a|0;D=(h[b+z>>0]|0)-(h[b+E>>0]|0)+D|0;C=(h[b+(z+1)>>0]|0)-(h[b+(E|1)>>0]|0)+C|0;B=(h[b+(z+2)>>0]|0)-(h[b+(E|2)>>0]|0)+B|0;A=(h[b+(z+3)>>0]|0)-(h[b+(E|3)>>0]|0)+A|0;z=E;E=E+4|0;f[c+(E<<2)>>2]=D;f[c+(z+5<<2)>>2]=C;f[c+(z+6<<2)>>2]=B;f[c+(z+7<<2)>>2]=A}while((E|0)<(i|0));return}default:{if((e|0)<=0)return;E=(i|0)>0;if((a|0)>0){A=0;B=c;C=b;while(1){D=0;z=0;do{D=(h[C+z>>0]|0)+D|0;z=z+e|0}while((z|0)<(a|0));f[B>>2]=D;if(E){z=D;y=0;do{z=(h[C+(y+a)>>0]|0)-(h[C+y>>0]|0)+z|0;y=y+e|0;f[B+(y<<2)>>2]=z}while((y|0)<(i|0))}A=A+1|0;if((A|0)==(e|0))break;else{B=B+4|0;C=C+1|0}}return}if(E){F=0;G=c;H=b}else{Nac(c|0,0,e<<2|0)|0;return}while(1){f[G>>2]=0;c=0;b=0;do{c=(h[H+(b+a)>>0]|0)-(h[H+b>>0]|0)+c|0;b=b+e|0;f[G+(b<<2)>>2]=c}while((b|0)<(i|0));F=F+1|0;if((F|0)==(e|0))break;else{G=G+4|0;H=H+1|0}}return}}}}function L5(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=+h;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0.0,w=0,x=0;i=u;u=u+16|0;j=i;k=i+8|0;l=c&7;m=d&7;if((d^c)&4088|0){f[k>>2]=0;f[k+4>>2]=0;n=aD(k,90)|0;o=238489;q=n+90|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(q|0));bO(-215,k,238580,237558,1340);bD(k)}o=(g|0)<0?(e|0)/2|0:g;g=(m|0)==0;n=(l|0)==4;if(n&g){q=L5b(40)|0;b8(q);f[q>>2]=52812;f[q+28>>2]=0;f[q+32>>2]=0;f[q+36>>2]=0;f[q+4>>2]=e;f[q+8>>2]=o;p[q+16>>3]=h;f[q+24>>2]=0;r=L5b(16)|0;s=r+4|0;f[s>>2]=1;f[r>>2]=52836;f[r+8>>2]=q;f[a>>2]=r;f[a+4>>2]=q;f[s>>2]=(f[s>>2]|0)+1;q=f[s>>2]|0;f[s>>2]=q+-1;if((q|0)!=1){u=i;return}bi[f[(f[r>>2]|0)+8>>2]&2047](r);u=i;return}if((l|0)==2&g){r=L5b(48)|0;b8(r);f[r>>2]=52856;f[r+36>>2]=0;f[r+40>>2]=0;f[r+44>>2]=0;f[r+4>>2]=e;f[r+8>>2]=o;p[r+16>>3]=h;f[r+24>>2]=0;q=r+28|0;f[q>>2]=0;s=r+32|0;f[s>>2]=1;do if(h!=1.0){t=MVb(1.0/h)|0;v=8388608.0/+(t|0);w=~~v;x=w-(+(w|0)>v&1)|0;f[s>>2]=x;w=(t|0)/2|0;f[q>>2]=w;if(v-+(x|0)<.5){f[q>>2]=w+1;break}else{f[s>>2]=x+1;break}}while(0);s=L5b(16)|0;q=s+4|0;f[q>>2]=1;f[s>>2]=52880;f[s+8>>2]=r;f[a>>2]=s;f[a+4>>2]=r;f[q>>2]=(f[q>>2]|0)+1;r=f[q>>2]|0;f[q>>2]=r+-1;if((r|0)!=1){u=i;return}bi[f[(f[s>>2]|0)+8>>2]&2047](s);u=i;return}s=(l|0)==6;if(s&g){g=L5b(40)|0;b8(g);f[g>>2]=52900;f[g+28>>2]=0;f[g+32>>2]=0;f[g+36>>2]=0;f[g+4>>2]=e;f[g+8>>2]=o;p[g+16>>3]=h;f[g+24>>2]=0;l=L5b(16)|0;r=l+4|0;f[r>>2]=1;f[l>>2]=52924;f[l+8>>2]=g;f[a>>2]=l;f[a+4>>2]=g;f[r>>2]=(f[r>>2]|0)+1;g=f[r>>2]|0;f[r>>2]=g+-1;if((g|0)!=1){u=i;return}bi[f[(f[l>>2]|0)+8>>2]&2047](l);u=i;return}l=(m|0)==2;if(n&l){g=L5b(40)|0;b8(g);f[g>>2]=52944;f[g+28>>2]=0;f[g+32>>2]=0;f[g+36>>2]=0;f[g+4>>2]=e;f[g+8>>2]=o;p[g+16>>3]=h;f[g+24>>2]=0;r=L5b(16)|0;q=r+4|0;f[q>>2]=1;f[r>>2]=52968;f[r+8>>2]=g;f[a>>2]=r;f[a+4>>2]=g;f[q>>2]=(f[q>>2]|0)+1;g=f[q>>2]|0;f[q>>2]=g+-1;if((g|0)!=1){u=i;return}bi[f[(f[r>>2]|0)+8>>2]&2047](r);u=i;return}if(s&l){l=L5b(40)|0;b8(l);f[l>>2]=52988;f[l+28>>2]=0;f[l+32>>2]=0;f[l+36>>2]=0;f[l+4>>2]=e;f[l+8>>2]=o;p[l+16>>3]=h;f[l+24>>2]=0;r=L5b(16)|0;g=r+4|0;f[g>>2]=1;f[r>>2]=53012;f[r+8>>2]=l;f[a>>2]=r;f[a+4>>2]=l;f[g>>2]=(f[g>>2]|0)+1;l=f[g>>2]|0;f[g>>2]=l+-1;if((l|0)!=1){u=i;return}bi[f[(f[r>>2]|0)+8>>2]&2047](r);u=i;return}r=(m|0)==3;if(n&r){l=L5b(40)|0;b8(l);f[l>>2]=53032;f[l+28>>2]=0;f[l+32>>2]=0;f[l+36>>2]=0;f[l+4>>2]=e;f[l+8>>2]=o;p[l+16>>3]=h;f[l+24>>2]=0;g=L5b(16)|0;q=g+4|0;f[q>>2]=1;f[g>>2]=53056;f[g+8>>2]=l;f[a>>2]=g;f[a+4>>2]=l;f[q>>2]=(f[q>>2]|0)+1;l=f[q>>2]|0;f[q>>2]=l+-1;if((l|0)!=1){u=i;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);u=i;return}if(s&r){r=L5b(40)|0;b8(r);f[r>>2]=53076;f[r+28>>2]=0;f[r+32>>2]=0;f[r+36>>2]=0;f[r+4>>2]=e;f[r+8>>2]=o;p[r+16>>3]=h;f[r+24>>2]=0;g=L5b(16)|0;l=g+4|0;f[l>>2]=1;f[g>>2]=53100;f[g+8>>2]=r;f[a>>2]=g;f[a+4>>2]=r;f[l>>2]=(f[l>>2]|0)+1;r=f[l>>2]|0;f[l>>2]=r+-1;if((r|0)!=1){u=i;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);u=i;return}if(n&(m|0)==4){g=L5b(40)|0;b8(g);f[g>>2]=53120;f[g+28>>2]=0;f[g+32>>2]=0;f[g+36>>2]=0;f[g+4>>2]=e;f[g+8>>2]=o;p[g+16>>3]=h;f[g+24>>2]=0;r=L5b(16)|0;l=r+4|0;f[l>>2]=1;f[r>>2]=53144;f[r+8>>2]=g;f[a>>2]=r;f[a+4>>2]=g;f[l>>2]=(f[l>>2]|0)+1;g=f[l>>2]|0;f[l>>2]=g+-1;if((g|0)!=1){u=i;return}bi[f[(f[r>>2]|0)+8>>2]&2047](r);u=i;return}r=(m|0)==5;if(n&r){g=L5b(40)|0;b8(g);f[g>>2]=53164;f[g+28>>2]=0;f[g+32>>2]=0;f[g+36>>2]=0;f[g+4>>2]=e;f[g+8>>2]=o;p[g+16>>3]=h;f[g+24>>2]=0;l=L5b(16)|0;q=l+4|0;f[q>>2]=1;f[l>>2]=53188;f[l+8>>2]=g;f[a>>2]=l;f[a+4>>2]=g;f[q>>2]=(f[q>>2]|0)+1;g=f[q>>2]|0;f[q>>2]=g+-1;if((g|0)!=1){u=i;return}bi[f[(f[l>>2]|0)+8>>2]&2047](l);u=i;return}if(s&r){r=L5b(40)|0;b8(r);f[r>>2]=53208;f[r+28>>2]=0;f[r+32>>2]=0;f[r+36>>2]=0;f[r+4>>2]=e;f[r+8>>2]=o;p[r+16>>3]=h;f[r+24>>2]=0;l=L5b(16)|0;g=l+4|0;f[g>>2]=1;f[l>>2]=53232;f[l+8>>2]=r;f[a>>2]=l;f[a+4>>2]=r;f[g>>2]=(f[g>>2]|0)+1;r=f[g>>2]|0;f[g>>2]=r+-1;if((r|0)!=1){u=i;return}bi[f[(f[l>>2]|0)+8>>2]&2047](l);u=i;return}l=(m|0)==6;if(n&l){n=L5b(40)|0;b8(n);f[n>>2]=53252;f[n+28>>2]=0;f[n+32>>2]=0;f[n+36>>2]=0;f[n+4>>2]=e;f[n+8>>2]=o;p[n+16>>3]=h;f[n+24>>2]=0;m=L5b(16)|0;r=m+4|0;f[r>>2]=1;f[m>>2]=53276;f[m+8>>2]=n;f[a>>2]=m;f[a+4>>2]=n;f[r>>2]=(f[r>>2]|0)+1;n=f[r>>2]|0;f[r>>2]=n+-1;if((n|0)!=1){u=i;return}bi[f[(f[m>>2]|0)+8>>2]&2047](m);u=i;return}if(!(s&l)){f[j>>2]=c;f[j+4>>2]=d;hO(k,238599,j);bO(-213,k,238580,237558,1372);bD(k);f[a>>2]=0;f[a+4>>2]=0;u=i;return}k=L5b(40)|0;b8(k);f[k>>2]=53296;f[k+28>>2]=0;f[k+32>>2]=0;f[k+36>>2]=0;f[k+4>>2]=e;f[k+8>>2]=o;p[k+16>>3]=h;f[k+24>>2]=0;o=L5b(16)|0;e=o+4|0;f[e>>2]=1;f[o>>2]=53320;f[o+8>>2]=k;f[a>>2]=o;f[a+4>>2]=k;f[e>>2]=(f[e>>2]|0)+1;k=f[e>>2]|0;f[e>>2]=k+-1;if((k|0)!=1){u=i;return}bi[f[(f[o>>2]|0)+8>>2]&2047](o);u=i;return}function M5(a){a=a|0;O5b(a);return}function N5(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function O5(a){a=a|0;var b=0,c=0;f[a>>2]=53296;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function P5(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=53296;b=f[a+28>>2]|0;if(!b){O5b(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function Q5(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>3;s=q;if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(!t){v=q;w=s;x=9}else{q=a+4|0;y=f[q>>2]|0;if((t|0)==(y+-1|0))z=y;else{f[j>>2]=0;f[j+4>>2]=0;y=aD(j,19)|0;t=238745;A=y+19|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(A|0));bO(-215,j,489445,237558,228);bD(j);z=f[q>>2]|0}B=c+(z+-1<<2)|0;C=z;D=s}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(o=s+(h<<3)|0,(z|0)!=(o|0)):0){f[n>>2]=z+(~((z+-8-o|0)>>>3)<<3);E=s}else E=s;else{Z2(m,h-r|0);E=f[m>>2]|0}m=a+24|0;f[m>>2]=0;v=m;w=E;x=9}if((x|0)==9){Nac(w|0,0,h<<3|0)|0;x=f[v>>2]|0;E=f[a+4>>2]|0;a=E+-1|0;if((x|0)<(a|0)){if((h|0)>0){m=c;r=x;while(1){s=f[m>>2]|0;o=0;do{z=w+(o<<3)|0;p[z>>3]=+p[s+(o<<3)>>3]+ +p[z>>3];o=o+1|0}while((o|0)!=(h|0));o=r+1|0;s=m+4|0;if((o|0)<(a|0)){m=s;r=o}else{F=o;G=s;break}}}else{r=x+1|0;m=(a|0)>(r|0)?a:r;F=m;G=c+(m-x<<2)|0}f[v>>2]=F;B=G;C=E;D=w}else{B=c;C=E;D=w}}if(!g){u=i;return}w=1-C|0;C=h+-2|0;E=(h|0)<2;c=h&-2;G=d;d=B;B=g;while(1){B=B+-1|0;g=f[d>>2]|0;F=f[d+(w<<2)>>2]|0;if(l){if(E)H=0;else{v=0;do{x=D+(v<<3)|0;I=+p[x>>3]+ +p[g+(v<<3)>>3];m=v|1;r=D+(m<<3)|0;J=+p[r>>3]+ +p[g+(m<<3)>>3];p[G+(v<<3)>>3]=k*I;p[G+(m<<3)>>3]=k*J;K=J-+p[F+(m<<3)>>3];p[x>>3]=I-+p[F+(v<<3)>>3];p[r>>3]=K;v=v+2|0}while((v|0)<=(C|0));H=c}if((H|0)<(h|0)){v=H;do{r=D+(v<<3)|0;K=+p[r>>3]+ +p[g+(v<<3)>>3];p[G+(v<<3)>>3]=k*K;p[r>>3]=K-+p[F+(v<<3)>>3];v=v+1|0}while((v|0)!=(h|0))}}else{if(E)L=0;else{v=0;do{r=D+(v<<3)|0;K=+p[r>>3]+ +p[g+(v<<3)>>3];x=v|1;m=D+(x<<3)|0;I=+p[m>>3]+ +p[g+(x<<3)>>3];p[G+(v<<3)>>3]=K;p[G+(x<<3)>>3]=I;J=I-+p[F+(x<<3)>>3];p[r>>3]=K-+p[F+(v<<3)>>3];p[m>>3]=J;v=v+2|0}while((v|0)<=(C|0));L=c}if((L|0)<(h|0)){v=L;do{m=D+(v<<3)|0;J=+p[m>>3]+ +p[g+(v<<3)>>3];p[G+(v<<3)>>3]=J;p[m>>3]=J-+p[F+(v<<3)>>3];v=v+1|0}while((v|0)!=(h|0))}}if(!B)break;else{G=G+e|0;d=d+4|0}}u=i;return}function R5(a){a=a|0;f[a+24>>2]=0;return}function S5(a){a=a|0;O5b(a);return}function T5(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function U5(a){a=a|0;var b=0,c=0;f[a>>2]=53252;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);O5b(b);return}function V5(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=53252;b=f[a+28>>2]|0;if(!b){O5b(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);O5b(a);return}function W5(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>2;s=q;if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(!t){v=q;w=s;x=9}else{q=a+4|0;y=f[q>>2]|0;if((t|0)==(y+-1|0))z=y;else{f[j>>2]=0;f[j+4>>2]=0;y=aD(j,19)|0;t=238745;A=y+19|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(A|0));bO(-215,j,489445,237558,228);bD(j);z=f[q>>2]|0}B=c+(z+-1<<2)|0;C=z;D=s}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(o=s+(h<<2)|0,(z|0)!=(o|0)):0){f[n>>2]=z+(~((z+-4-o|0)>>>2)<<2);E=s}else E=s;else{HC(m,h-r|0);E=f[m>>2]|0}m=a+24|0;f[m>>2]=0;v=m;w=E;x=9}do if((x|0)==9){Nac(w|0,0,h<<2|0)|0;E=f[v>>2]|0;m=a+4|0;r=f[m>>2]|0;s=r+-1|0;if((E|0)<(s|0)){if((h|0)>0)F=c;else{o=c;z=E;do{z=z+1|0;o=o+4|0}while((z|0)<(s|0));f[v>>2]=z;B=o;C=r;D=w;break}while(1){s=f[F>>2]|0;E=0;do{n=w+(E<<2)|0;f[n>>2]=(f[n>>2]|0)+(f[s+(E<<2)>>2]|0);E=E+1|0}while((E|0)!=(h|0));E=(f[v>>2]|0)+1|0;f[v>>2]=E;s=F+4|0;n=f[m>>2]|0;if((E|0)<(n+-1|0))F=s;else{B=s;C=n;D=w;break}}}else{B=c;C=r;D=w}}while(0);if(!g){u=i;return}w=a+4|0;a=h+-2|0;c=(h|0)<2;F=h&-2;v=d;d=B;B=g;g=C;while(1){C=B+-1|0;x=f[d>>2]|0;m=f[d+(1-g<<2)>>2]|0;if(l){if(c)G=0;else{o=0;do{z=D+(o<<2)|0;n=(f[x+(o<<2)>>2]|0)+(f[z>>2]|0)|0;s=o|1;E=D+(s<<2)|0;q=(f[x+(s<<2)>>2]|0)+(f[E>>2]|0)|0;p[v+(o<<3)>>3]=k*+(n|0);p[v+(s<<3)>>3]=k*+(q|0);j=q-(f[m+(s<<2)>>2]|0)|0;f[z>>2]=n-(f[m+(o<<2)>>2]|0);f[E>>2]=j;o=o+2|0}while((o|0)<=(a|0));G=F}if((G|0)<(h|0)){o=G;do{r=D+(o<<2)|0;j=(f[x+(o<<2)>>2]|0)+(f[r>>2]|0)|0;p[v+(o<<3)>>3]=k*+(j|0);f[r>>2]=j-(f[m+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(h|0))}}else{if(c)H=0;else{o=0;do{j=D+(o<<2)|0;r=(f[x+(o<<2)>>2]|0)+(f[j>>2]|0)|0;E=o|1;n=D+(E<<2)|0;z=(f[x+(E<<2)>>2]|0)+(f[n>>2]|0)|0;p[v+(o<<3)>>3]=+(r|0);p[v+(E<<3)>>3]=+(z|0);s=z-(f[m+(E<<2)>>2]|0)|0;f[j>>2]=r-(f[m+(o<<2)>>2]|0);f[n>>2]=s;o=o+2|0}while((o|0)<=(a|0));H=F}if((H|0)<(h|0)){o=H;do{s=D+(o<<2)|0;n=(f[x+(o<<2)>>2]|0)+(f[s>>2]|0)|0;p[v+(o<<3)>>3]=+(n|0);f[s>>2]=n-(f[m+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(h|0))}}if(!C)break;v=v+e|0;d=d+4|0;B=C;g=f[w>>2]|0}u=i;return}function X5(a){a=a|0;f[a+24>>2]=0;return}function Y5(a){a=a|0;O5b(a);return}function Z5(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _5(a){a=a|0;var b=0,c=0;f[a>>2]=53208;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function $5(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=53208;b=f[a+28>>2]|0;if(!b){O5b(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function a6(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[m>>2]|0;s=q-r>>3;t=r;if((s|0)==(h|0)){r=a+24|0;v=f[r>>2]|0;if(!v){w=r;x=t;y=9}else{r=a+4|0;z=f[r>>2]|0;if((v|0)==(z+-1|0))A=z;else{f[j>>2]=0;f[j+4>>2]=0;z=aD(j,19)|0;v=238745;B=z+19|0;do{b[z>>0]=b[v>>0]|0;z=z+1|0;v=v+1|0}while((z|0)<(B|0));bO(-215,j,489445,237558,228);bD(j);A=f[r>>2]|0}C=c+(A+-1<<2)|0;D=A;E=t}}else{A=q;if(s>>>0>=h>>>0)if(s>>>0>h>>>0?(q=t+(h<<3)|0,(A|0)!=(q|0)):0){f[o>>2]=A+(~((A+-8-q|0)>>>3)<<3);F=t}else F=t;else{Z2(m,h-s|0);F=f[m>>2]|0}m=a+24|0;f[m>>2]=0;w=m;x=F;y=9}if((y|0)==9){Nac(x|0,0,h<<3|0)|0;y=f[w>>2]|0;F=f[a+4>>2]|0;a=F+-1|0;if((y|0)<(a|0)){if((h|0)>0){m=c;s=y;while(1){t=f[m>>2]|0;q=0;do{A=x+(q<<3)|0;p[A>>3]=+p[t+(q<<3)>>3]+ +p[A>>3];q=q+1|0}while((q|0)!=(h|0));q=s+1|0;t=m+4|0;if((q|0)<(a|0)){m=t;s=q}else{G=q;H=t;break}}}else{s=y+1|0;m=(a|0)>(s|0)?a:s;G=m;H=c+(m-y<<2)|0}f[w>>2]=G;C=H;D=F;E=x}else{C=c;D=F;E=x}}if(!g){u=i;return}x=1-D|0;D=h+-2|0;F=(h|0)<2;c=h&-2;H=d;d=C;C=g;while(1){C=C+-1|0;g=f[d>>2]|0;G=f[d+(x<<2)>>2]|0;if(l){if(F)I=0;else{w=0;do{y=E+(w<<3)|0;J=+p[y>>3]+ +p[g+(w<<3)>>3];m=w|1;s=E+(m<<3)|0;K=+p[s>>3]+ +p[g+(m<<3)>>3];n[H+(w<<2)>>2]=k*J;n[H+(m<<2)>>2]=k*K;L=K-+p[G+(m<<3)>>3];p[y>>3]=J-+p[G+(w<<3)>>3];p[s>>3]=L;w=w+2|0}while((w|0)<=(D|0));I=c}if((I|0)<(h|0)){w=I;do{s=E+(w<<3)|0;L=+p[s>>3]+ +p[g+(w<<3)>>3];n[H+(w<<2)>>2]=k*L;p[s>>3]=L-+p[G+(w<<3)>>3];w=w+1|0}while((w|0)!=(h|0))}}else{if(F)M=0;else{w=0;do{s=E+(w<<3)|0;L=+p[s>>3]+ +p[g+(w<<3)>>3];y=w|1;m=E+(y<<3)|0;J=+p[m>>3]+ +p[g+(y<<3)>>3];n[H+(w<<2)>>2]=L;n[H+(y<<2)>>2]=J;K=J-+p[G+(y<<3)>>3];p[s>>3]=L-+p[G+(w<<3)>>3];p[m>>3]=K;w=w+2|0}while((w|0)<=(D|0));M=c}if((M|0)<(h|0)){w=M;do{m=E+(w<<3)|0;K=+p[m>>3]+ +p[g+(w<<3)>>3];n[H+(w<<2)>>2]=K;p[m>>3]=K-+p[G+(w<<3)>>3];w=w+1|0}while((w|0)!=(h|0))}}if(!C)break;else{H=H+e|0;d=d+4|0}}u=i;return}function b6(a){a=a|0;f[a+24>>2]=0;return}function c6(a){a=a|0;O5b(a);return}function d6(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function e6(a){a=a|0;var b=0,c=0;f[a>>2]=53164;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);O5b(b);return}function f6(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=53164;b=f[a+28>>2]|0;if(!b){O5b(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);O5b(a);return}function g6(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[m>>2]|0;s=q-r>>2;t=r;if((s|0)==(h|0)){r=a+24|0;v=f[r>>2]|0;if(!v){w=r;x=t;y=9}else{r=a+4|0;z=f[r>>2]|0;if((v|0)==(z+-1|0))A=z;else{f[j>>2]=0;f[j+4>>2]=0;z=aD(j,19)|0;v=238745;B=z+19|0;do{b[z>>0]=b[v>>0]|0;z=z+1|0;v=v+1|0}while((z|0)<(B|0));bO(-215,j,489445,237558,986);bD(j);A=f[r>>2]|0}C=c+(A+-1<<2)|0;D=A;E=t}}else{A=q;if(s>>>0>=h>>>0)if(s>>>0>h>>>0?(q=t+(h<<2)|0,(A|0)!=(q|0)):0){f[o>>2]=A+(~((A+-4-q|0)>>>2)<<2);F=t}else F=t;else{HC(m,h-s|0);F=f[m>>2]|0}m=a+24|0;f[m>>2]=0;w=m;x=F;y=9}do if((y|0)==9){Nac(x|0,0,h<<2|0)|0;F=f[w>>2]|0;m=a+4|0;s=f[m>>2]|0;t=s+-1|0;if((F|0)<(t|0)){if((h|0)>0)G=c;else{q=c;A=F;do{A=A+1|0;q=q+4|0}while((A|0)<(t|0));f[w>>2]=A;C=q;D=s;E=x;break}while(1){t=f[G>>2]|0;F=0;do{o=x+(F<<2)|0;f[o>>2]=(f[o>>2]|0)+(f[t+(F<<2)>>2]|0);F=F+1|0}while((F|0)!=(h|0));F=(f[w>>2]|0)+1|0;f[w>>2]=F;t=G+4|0;o=f[m>>2]|0;if((F|0)<(o+-1|0))G=t;else{C=t;D=o;E=x;break}}}else{C=c;D=s;E=x}}while(0);x=g+-1|0;if(!g){u=i;return}g=a+4|0;a=(h|0)>0;if(l){l=d;c=C;G=D;w=x;while(1){y=f[c>>2]|0;m=f[c+(1-G<<2)>>2]|0;if(a){q=0;do{A=E+(q<<2)|0;o=(f[y+(q<<2)>>2]|0)+(f[A>>2]|0)|0;n[l+(q<<2)>>2]=k*+(o|0);f[A>>2]=o-(f[m+(q<<2)>>2]|0);q=q+1|0}while((q|0)!=(h|0))}if(!w)break;l=l+e|0;c=c+4|0;G=f[g>>2]|0;w=w+-1|0}u=i;return}if(a){H=d;I=C;J=x;K=D}else{u=i;return}while(1){D=f[I>>2]|0;x=f[I+(1-K<<2)>>2]|0;C=0;do{d=E+(C<<2)|0;a=(f[D+(C<<2)>>2]|0)+(f[d>>2]|0)|0;n[H+(C<<2)>>2]=+(a|0);f[d>>2]=a-(f[x+(C<<2)>>2]|0);C=C+1|0}while((C|0)!=(h|0));if(!J)break;H=H+e|0;I=I+4|0;J=J+-1|0;K=f[g>>2]|0}u=i;return}function h6(a){a=a|0;f[a+24>>2]=0;return}function i6(a){a=a|0;O5b(a);return}function j6(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function k6(a){a=a|0;var b=0,c=0;f[a>>2]=53120;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);O5b(b);return}function l6(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=53120;b=f[a+28>>2]|0;if(!b){O5b(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);O5b(a);return}function m6(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>2;s=q;if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(!t){v=q;w=s;x=9}else{q=a+4|0;y=f[q>>2]|0;if((t|0)==(y+-1|0))z=y;else{f[j>>2]=0;f[j+4>>2]=0;y=aD(j,19)|0;t=238745;A=y+19|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(A|0));bO(-215,j,489445,237558,866);bD(j);z=f[q>>2]|0}B=c+(z+-1<<2)|0;C=z;D=s}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(o=s+(h<<2)|0,(z|0)!=(o|0)):0){f[n>>2]=z+(~((z+-4-o|0)>>>2)<<2);E=s}else E=s;else{HC(m,h-r|0);E=f[m>>2]|0}m=a+24|0;f[m>>2]=0;v=m;w=E;x=9}do if((x|0)==9){Nac(w|0,0,h<<2|0)|0;E=f[v>>2]|0;m=a+4|0;r=f[m>>2]|0;s=r+-1|0;if((E|0)<(s|0)){if((h|0)>0)F=c;else{o=c;z=E;do{z=z+1|0;o=o+4|0}while((z|0)<(s|0));f[v>>2]=z;B=o;C=r;D=w;break}while(1){s=f[F>>2]|0;E=0;do{n=w+(E<<2)|0;f[n>>2]=(f[n>>2]|0)+(f[s+(E<<2)>>2]|0);E=E+1|0}while((E|0)!=(h|0));E=(f[v>>2]|0)+1|0;f[v>>2]=E;s=F+4|0;n=f[m>>2]|0;if((E|0)<(n+-1|0))F=s;else{B=s;C=n;D=w;break}}}else{B=c;C=r;D=w}}while(0);w=g+-1|0;if(!g){u=i;return}g=a+4|0;a=(h|0)>0;if(l){l=d;c=B;F=C;v=w;while(1){x=f[c>>2]|0;m=f[c+(1-F<<2)>>2]|0;if(a){o=0;do{z=D+(o<<2)|0;n=(f[x+(o<<2)>>2]|0)+(f[z>>2]|0)|0;s=MVb(k*+(n|0))|0;f[l+(o<<2)>>2]=s;f[z>>2]=n-(f[m+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(h|0))}if(!v)break;l=l+e|0;c=c+4|0;F=f[g>>2]|0;v=v+-1|0}u=i;return}if(a){G=d;H=B;I=w;J=C}else{u=i;return}while(1){C=f[H>>2]|0;w=f[H+(1-J<<2)>>2]|0;B=0;do{d=D+(B<<2)|0;a=(f[C+(B<<2)>>2]|0)+(f[d>>2]|0)|0;f[G+(B<<2)>>2]=a;f[d>>2]=a-(f[w+(B<<2)>>2]|0);B=B+1|0}while((B|0)!=(h|0));if(!I)break;G=G+e|0;H=H+4|0;I=I+-1|0;J=f[g>>2]|0}u=i;return}function n6(a){a=a|0;f[a+24>>2]=0;return}function o6(a){a=a|0;O5b(a);return}function p6(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function q6(a){a=a|0;var b=0,c=0;f[a>>2]=53076;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function r6(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=53076;b=f[a+28>>2]|0;if(!b){O5b(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function s6(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>3;t=r;if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(!v){w=r;x=t;y=9}else{r=a+4|0;z=f[r>>2]|0;if((v|0)==(z+-1|0))A=z;else{f[k>>2]=0;f[k+4>>2]=0;z=aD(k,19)|0;v=238745;B=z+19|0;do{b[z>>0]=b[v>>0]|0;z=z+1|0;v=v+1|0}while((z|0)<(B|0));bO(-215,k,489445,237558,228);bD(k);A=f[r>>2]|0}C=c+(A+-1<<2)|0;D=A;E=t}}else{A=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(q=t+(i<<3)|0,(A|0)!=(q|0)):0){f[o>>2]=A+(~((A+-8-q|0)>>>3)<<3);F=t}else F=t;else{Z2(n,i-s|0);F=f[n>>2]|0}n=a+24|0;f[n>>2]=0;w=n;x=F;y=9}if((y|0)==9){Nac(x|0,0,i<<3|0)|0;y=f[w>>2]|0;F=f[a+4>>2]|0;a=F+-1|0;if((y|0)<(a|0)){if((i|0)>0){n=c;s=y;while(1){t=f[n>>2]|0;q=0;do{A=x+(q<<3)|0;p[A>>3]=+p[t+(q<<3)>>3]+ +p[A>>3];q=q+1|0}while((q|0)!=(i|0));q=s+1|0;t=n+4|0;if((q|0)<(a|0)){n=t;s=q}else{G=q;H=t;break}}}else{s=y+1|0;n=(a|0)>(s|0)?a:s;G=n;H=c+(n-y<<2)|0}f[w>>2]=G;C=H;D=F;E=x}else{C=c;D=F;E=x}}if(!h){u=j;return}x=1-D|0;D=i+-2|0;F=(i|0)<2;c=i&-2;H=e;e=C;C=h;while(1){C=C+-1|0;h=f[e>>2]|0;G=f[e+(x<<2)>>2]|0;if(m){if(F)I=0;else{w=0;do{y=E+(w<<3)|0;J=+p[y>>3]+ +p[h+(w<<3)>>3];n=w|1;s=E+(n<<3)|0;K=+p[s>>3]+ +p[h+(n<<3)>>3];a=MVb(l*J)|0;d[H+(w<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=MVb(l*K)|0;d[H+(n<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;L=K-+p[G+(n<<3)>>3];p[y>>3]=J-+p[G+(w<<3)>>3];p[s>>3]=L;w=w+2|0}while((w|0)<=(D|0));I=c}if((I|0)<(i|0)){w=I;do{s=E+(w<<3)|0;L=+p[s>>3]+ +p[h+(w<<3)>>3];y=MVb(l*L)|0;d[H+(w<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;p[s>>3]=L-+p[G+(w<<3)>>3];w=w+1|0}while((w|0)!=(i|0))}}else{if(F)M=0;else{w=0;do{s=E+(w<<3)|0;L=+p[s>>3]+ +p[h+(w<<3)>>3];y=w|1;n=E+(y<<3)|0;J=+p[n>>3]+ +p[h+(y<<3)>>3];a=MVb(L)|0;d[H+(w<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;a=MVb(J)|0;d[H+(y<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;K=J-+p[G+(y<<3)>>3];p[s>>3]=L-+p[G+(w<<3)>>3];p[n>>3]=K;w=w+2|0}while((w|0)<=(D|0));M=c}if((M|0)<(i|0)){w=M;do{n=E+(w<<3)|0;K=+p[n>>3]+ +p[h+(w<<3)>>3];s=MVb(K)|0;d[H+(w<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;p[n>>3]=K-+p[G+(w<<3)>>3];w=w+1|0}while((w|0)!=(i|0))}}if(!C)break;else{H=H+g|0;e=e+4|0}}u=j;return}function t6(a){a=a|0;f[a+24>>2]=0;return}function u6(a){a=a|0;O5b(a);return}function v6(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function w6(a){a=a|0;var b=0,c=0;f[a>>2]=53032;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);O5b(b);return}function x6(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=53032;b=f[a+28>>2]|0;if(!b){O5b(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);O5b(a);return}function y6(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>2;t=r;if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(!v){w=r;x=t;y=9}else{r=a+4|0;z=f[r>>2]|0;if((v|0)==(z+-1|0))A=z;else{f[k>>2]=0;f[k+4>>2]=0;z=aD(k,19)|0;v=238745;B=z+19|0;do{b[z>>0]=b[v>>0]|0;z=z+1|0;v=v+1|0}while((z|0)<(B|0));bO(-215,k,489445,237558,614);bD(k);A=f[r>>2]|0}C=c+(A+-1<<2)|0;D=A;E=t}}else{A=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(q=t+(i<<2)|0,(A|0)!=(q|0)):0){f[o>>2]=A+(~((A+-4-q|0)>>>2)<<2);F=t}else F=t;else{HC(n,i-s|0);F=f[n>>2]|0}n=a+24|0;f[n>>2]=0;w=n;x=F;y=9}do if((y|0)==9){Nac(x|0,0,i<<2|0)|0;F=f[w>>2]|0;n=a+4|0;s=f[n>>2]|0;t=s+-1|0;if((F|0)<(t|0)){if((i|0)>0)G=c;else{q=c;A=F;do{A=A+1|0;q=q+4|0}while((A|0)<(t|0));f[w>>2]=A;C=q;D=s;E=x;break}while(1){t=f[G>>2]|0;F=0;do{o=x+(F<<2)|0;f[o>>2]=(f[o>>2]|0)+(f[t+(F<<2)>>2]|0);F=F+1|0}while((F|0)!=(i|0));F=(f[w>>2]|0)+1|0;f[w>>2]=F;t=G+4|0;o=f[n>>2]|0;if((F|0)<(o+-1|0))G=t;else{C=t;D=o;E=x;break}}}else{C=c;D=s;E=x}}while(0);x=h+-1|0;if(!h){u=j;return}h=a+4|0;a=(i|0)>0;if(m){m=e;c=C;G=D;w=x;while(1){y=f[c>>2]|0;n=f[c+(1-G<<2)>>2]|0;if(a){q=0;do{A=E+(q<<2)|0;o=(f[y+(q<<2)>>2]|0)+(f[A>>2]|0)|0;t=MVb(l*+(o|0))|0;d[m+(q<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;f[A>>2]=o-(f[n+(q<<2)>>2]|0);q=q+1|0}while((q|0)!=(i|0))}if(!w)break;m=m+g|0;c=c+4|0;G=f[h>>2]|0;w=w+-1|0}u=j;return}else{w=e;e=C;C=D;D=x;while(1){x=f[e>>2]|0;G=f[e+(1-C<<2)>>2]|0;if(a){c=0;do{m=E+(c<<2)|0;q=(f[x+(c<<2)>>2]|0)+(f[m>>2]|0)|0;d[w+(c<<1)>>1]=(q+32768|0)>>>0<65536?q:(q|0)>0?32767:32768;f[m>>2]=q-(f[G+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(i|0))}if(!D)break;w=w+g|0;e=e+4|0;C=f[h>>2]|0;D=D+-1|0}u=j;return}}function z6(a){a=a|0;f[a+24>>2]=0;return}function A6(a){a=a|0;O5b(a);return}function B6(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function C6(a){a=a|0;var b=0,c=0;f[a>>2]=52988;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function D6(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=52988;b=f[a+28>>2]|0;if(!b){O5b(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function E6(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>3;t=r;if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(!v){w=r;x=t;y=9}else{r=a+4|0;z=f[r>>2]|0;if((v|0)==(z+-1|0))A=z;else{f[k>>2]=0;f[k+4>>2]=0;z=aD(k,19)|0;v=238745;B=z+19|0;do{b[z>>0]=b[v>>0]|0;z=z+1|0;v=v+1|0}while((z|0)<(B|0));bO(-215,k,489445,237558,228);bD(k);A=f[r>>2]|0}C=c+(A+-1<<2)|0;D=A;E=t}}else{A=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(q=t+(i<<3)|0,(A|0)!=(q|0)):0){f[o>>2]=A+(~((A+-8-q|0)>>>3)<<3);F=t}else F=t;else{Z2(n,i-s|0);F=f[n>>2]|0}n=a+24|0;f[n>>2]=0;w=n;x=F;y=9}if((y|0)==9){Nac(x|0,0,i<<3|0)|0;y=f[w>>2]|0;F=f[a+4>>2]|0;a=F+-1|0;if((y|0)<(a|0)){if((i|0)>0){n=c;s=y;while(1){t=f[n>>2]|0;q=0;do{A=x+(q<<3)|0;p[A>>3]=+p[t+(q<<3)>>3]+ +p[A>>3];q=q+1|0}while((q|0)!=(i|0));q=s+1|0;t=n+4|0;if((q|0)<(a|0)){n=t;s=q}else{G=q;H=t;break}}}else{s=y+1|0;n=(a|0)>(s|0)?a:s;G=n;H=c+(n-y<<2)|0}f[w>>2]=G;C=H;D=F;E=x}else{C=c;D=F;E=x}}if(!h){u=j;return}x=1-D|0;D=i+-2|0;F=(i|0)<2;c=i&-2;H=e;e=C;C=h;while(1){C=C+-1|0;h=f[e>>2]|0;G=f[e+(x<<2)>>2]|0;if(m){if(F)I=0;else{w=0;do{y=E+(w<<3)|0;J=+p[y>>3]+ +p[h+(w<<3)>>3];n=w|1;s=E+(n<<3)|0;K=+p[s>>3]+ +p[h+(n<<3)>>3];a=MVb(l*J)|0;d[H+(w<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=MVb(l*K)|0;d[H+(n<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;L=K-+p[G+(n<<3)>>3];p[y>>3]=J-+p[G+(w<<3)>>3];p[s>>3]=L;w=w+2|0}while((w|0)<=(D|0));I=c}if((I|0)<(i|0)){w=I;do{s=E+(w<<3)|0;L=+p[s>>3]+ +p[h+(w<<3)>>3];y=MVb(l*L)|0;d[H+(w<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;p[s>>3]=L-+p[G+(w<<3)>>3];w=w+1|0}while((w|0)!=(i|0))}}else{if(F)M=0;else{w=0;do{s=E+(w<<3)|0;L=+p[s>>3]+ +p[h+(w<<3)>>3];y=w|1;n=E+(y<<3)|0;J=+p[n>>3]+ +p[h+(y<<3)>>3];a=MVb(L)|0;d[H+(w<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;a=MVb(J)|0;d[H+(y<<1)>>1]=a>>>0<65536?a:(a|0)>0?65535:0;K=J-+p[G+(y<<3)>>3];p[s>>3]=L-+p[G+(w<<3)>>3];p[n>>3]=K;w=w+2|0}while((w|0)<=(D|0));M=c}if((M|0)<(i|0)){w=M;do{n=E+(w<<3)|0;K=+p[n>>3]+ +p[h+(w<<3)>>3];s=MVb(K)|0;d[H+(w<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;p[n>>3]=K-+p[G+(w<<3)>>3];w=w+1|0}while((w|0)!=(i|0))}}if(!C)break;else{H=H+g|0;e=e+4|0}}u=j;return}function F6(a){a=a|0;f[a+24>>2]=0;return}function G6(a){a=a|0;O5b(a);return}function H6(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function I6(a){a=a|0;var b=0,c=0;f[a>>2]=52944;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);O5b(b);return}function J6(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=52944;b=f[a+28>>2]|0;if(!b){O5b(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);O5b(a);return}function K6(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=u;u=u+16|0;k=j;l=+p[a+16>>3];m=l!=1.0;n=a+28|0;o=a+32|0;q=f[o>>2]|0;r=f[n>>2]|0;s=q-r>>2;t=r;if((s|0)==(i|0)){r=a+24|0;v=f[r>>2]|0;if(!v){w=r;x=t;y=9}else{r=a+4|0;z=f[r>>2]|0;if((v|0)==(z+-1|0))A=z;else{f[k>>2]=0;f[k+4>>2]=0;z=aD(k,19)|0;v=238745;B=z+19|0;do{b[z>>0]=b[v>>0]|0;z=z+1|0;v=v+1|0}while((z|0)<(B|0));bO(-215,k,489445,237558,741);bD(k);A=f[r>>2]|0}C=c+(A+-1<<2)|0;D=A;E=t}}else{A=q;if(s>>>0>=i>>>0)if(s>>>0>i>>>0?(q=t+(i<<2)|0,(A|0)!=(q|0)):0){f[o>>2]=A+(~((A+-4-q|0)>>>2)<<2);F=t}else F=t;else{HC(n,i-s|0);F=f[n>>2]|0}n=a+24|0;f[n>>2]=0;w=n;x=F;y=9}do if((y|0)==9){Nac(x|0,0,i<<2|0)|0;F=f[w>>2]|0;n=a+4|0;s=f[n>>2]|0;t=s+-1|0;if((F|0)<(t|0)){if((i|0)>0)G=c;else{q=c;A=F;do{A=A+1|0;q=q+4|0}while((A|0)<(t|0));f[w>>2]=A;C=q;D=s;E=x;break}while(1){t=f[G>>2]|0;F=0;do{o=x+(F<<2)|0;f[o>>2]=(f[o>>2]|0)+(f[t+(F<<2)>>2]|0);F=F+1|0}while((F|0)!=(i|0));F=(f[w>>2]|0)+1|0;f[w>>2]=F;t=G+4|0;o=f[n>>2]|0;if((F|0)<(o+-1|0))G=t;else{C=t;D=o;E=x;break}}}else{C=c;D=s;E=x}}while(0);x=h+-1|0;if(!h){u=j;return}h=a+4|0;a=(i|0)>0;if(m){m=e;c=C;G=D;w=x;while(1){y=f[c>>2]|0;n=f[c+(1-G<<2)>>2]|0;if(a){q=0;do{A=E+(q<<2)|0;o=(f[y+(q<<2)>>2]|0)+(f[A>>2]|0)|0;t=MVb(l*+(o|0))|0;d[m+(q<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;f[A>>2]=o-(f[n+(q<<2)>>2]|0);q=q+1|0}while((q|0)!=(i|0))}if(!w)break;m=m+g|0;c=c+4|0;G=f[h>>2]|0;w=w+-1|0}u=j;return}else{w=e;e=C;C=D;D=x;while(1){x=f[e>>2]|0;G=f[e+(1-C<<2)>>2]|0;if(a){c=0;do{m=E+(c<<2)|0;q=(f[x+(c<<2)>>2]|0)+(f[m>>2]|0)|0;d[w+(c<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;f[m>>2]=q-(f[G+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(i|0))}if(!D)break;w=w+g|0;e=e+4|0;C=f[h>>2]|0;D=D+-1|0}u=j;return}}function L6(a){a=a|0;f[a+24>>2]=0;return}function M6(a){a=a|0;O5b(a);return}function N6(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function O6(a){a=a|0;var b=0,c=0;f[a>>2]=52900;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-8-b|0)>>>3)<<3);O5b(b);return}function P6(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=52900;b=f[a+28>>2]|0;if(!b){O5b(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-8-b|0)>>>3)<<3);O5b(b);O5b(a);return}function Q6(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>3;s=q;if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(!t){v=q;w=s;x=9}else{q=a+4|0;y=f[q>>2]|0;if((t|0)==(y+-1|0))z=y;else{f[j>>2]=0;f[j+4>>2]=0;y=aD(j,19)|0;t=238745;A=y+19|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(A|0));bO(-215,j,489445,237558,228);bD(j);z=f[q>>2]|0}B=c+(z+-1<<2)|0;C=z;D=s}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(o=s+(h<<3)|0,(z|0)!=(o|0)):0){f[n>>2]=z+(~((z+-8-o|0)>>>3)<<3);E=s}else E=s;else{Z2(m,h-r|0);E=f[m>>2]|0}m=a+24|0;f[m>>2]=0;v=m;w=E;x=9}if((x|0)==9){Nac(w|0,0,h<<3|0)|0;x=f[v>>2]|0;E=f[a+4>>2]|0;m=E+-1|0;if((x|0)<(m|0)){if((h|0)>0){r=c;s=x;while(1){o=f[r>>2]|0;z=0;do{n=w+(z<<3)|0;p[n>>3]=+p[o+(z<<3)>>3]+ +p[n>>3];z=z+1|0}while((z|0)!=(h|0));z=s+1|0;o=r+4|0;if((z|0)<(m|0)){r=o;s=z}else{F=z;G=o;break}}}else{s=x+1|0;r=(m|0)>(s|0)?m:s;F=r;G=c+(r-x<<2)|0}f[v>>2]=F;B=G;C=E;D=w}else{B=c;C=E;D=w}}if(!g){u=i;return}w=a+4|0;a=h+-2|0;E=(h|0)<2;c=h&-2;G=d;d=B;B=g;g=C;while(1){C=B+-1|0;F=f[d>>2]|0;v=f[d+(1-g<<2)>>2]|0;if(l){if(E)H=0;else{x=0;do{r=D+(x<<3)|0;I=+p[r>>3]+ +p[F+(x<<3)>>3];s=x|1;m=D+(s<<3)|0;J=+p[m>>3]+ +p[F+(s<<3)>>3];o=MVb(k*I)|0;b[G+x>>0]=o>>>0<256?o:(o|0)>0?255:0;o=MVb(k*J)|0;b[G+s>>0]=o>>>0<256?o:(o|0)>0?255:0;K=J-+p[v+(s<<3)>>3];p[r>>3]=I-+p[v+(x<<3)>>3];p[m>>3]=K;x=x+2|0}while((x|0)<=(a|0));H=c}if((H|0)<(h|0)){x=H;do{m=D+(x<<3)|0;K=+p[m>>3]+ +p[F+(x<<3)>>3];r=MVb(k*K)|0;b[G+x>>0]=r>>>0<256?r:(r|0)>0?255:0;p[m>>3]=K-+p[v+(x<<3)>>3];x=x+1|0}while((x|0)!=(h|0))}}else{if(E)L=0;else{x=0;do{m=D+(x<<3)|0;K=+p[m>>3]+ +p[F+(x<<3)>>3];r=x|1;s=D+(r<<3)|0;I=+p[s>>3]+ +p[F+(r<<3)>>3];o=MVb(K)|0;b[G+x>>0]=o>>>0<256?o:(o|0)>0?255:0;o=MVb(I)|0;b[G+r>>0]=o>>>0<256?o:(o|0)>0?255:0;J=I-+p[v+(r<<3)>>3];p[m>>3]=K-+p[v+(x<<3)>>3];p[s>>3]=J;x=x+2|0}while((x|0)<=(a|0));L=c}if((L|0)<(h|0)){x=L;do{s=D+(x<<3)|0;J=+p[s>>3]+ +p[F+(x<<3)>>3];m=MVb(J)|0;b[G+x>>0]=m>>>0<256?m:(m|0)>0?255:0;p[s>>3]=J-+p[v+(x<<3)>>3];x=x+1|0}while((x|0)!=(h|0))}}if(!C)break;G=G+e|0;d=d+4|0;B=C;g=f[w>>2]|0}u=i;return}function R6(a){a=a|0;f[a+24>>2]=0;return}function S6(a){a=a|0;O5b(a);return}function T6(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function U6(a){a=a|0;var b=0,c=0;f[a>>2]=52856;b=f[a+36>>2]|0;if(!b)return;c=a+40|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-2-b|0)>>>1)<<1);O5b(b);return}function V6(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=52856;b=f[a+36>>2]|0;if(!b){O5b(a);return}c=a+40|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-2-b|0)>>>1)<<1);O5b(b);O5b(a);return}function W6(a,c,e,g,h,i){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=u;u=u+16|0;l=k;m=f[a+32>>2]|0;n=f[a+28>>2]|0;o=+p[a+16>>3]!=1.0;q=a+36|0;r=a+40|0;s=f[r>>2]|0;t=f[q>>2]|0;v=s-t>>1;w=t;if((v|0)==(i|0)){t=a+24|0;x=f[t>>2]|0;if(!x){y=t;z=w;A=9}else{t=a+4|0;B=f[t>>2]|0;if((x|0)==(B+-1|0))C=B;else{f[l>>2]=0;f[l+4>>2]=0;B=aD(l,19)|0;x=238745;D=B+19|0;do{b[B>>0]=b[x>>0]|0;B=B+1|0;x=x+1|0}while((B|0)<(D|0));bO(-215,l,489445,237558,485);bD(l);C=f[t>>2]|0}E=c+(C+-1<<2)|0;F=C;G=w}}else{C=s;if(v>>>0>=i>>>0)if(v>>>0>i>>>0?(s=w+(i<<1)|0,(C|0)!=(s|0)):0){f[r>>2]=C+(~((C+-2-s|0)>>>1)<<1);H=w}else H=w;else{Y6(q,i-v|0);H=f[q>>2]|0}q=a+24|0;f[q>>2]=0;y=q;z=H;A=9}if((A|0)==9){Nac(z|0,0,i<<1|0)|0;A=f[y>>2]|0;H=f[a+4>>2]|0;q=H+-1|0;if((A|0)<(q|0)){if((i|0)>0){v=c;w=A;while(1){s=f[v>>2]|0;C=0;do{r=z+(C<<1)|0;d[r>>1]=(j[r>>1]|0)+(j[s+(C<<1)>>1]|0);C=C+1|0}while((C|0)!=(i|0));C=w+1|0;s=v+4|0;if((C|0)<(q|0)){v=s;w=C}else{I=C;J=s;break}}}else{w=A+1|0;v=(q|0)>(w|0)?q:w;I=v;J=c+(v-A<<2)|0}f[y>>2]=I;E=J;F=H;G=z}else{E=c;F=H;G=z}}z=h+-1|0;if(!h){u=k;return}h=a+4|0;a=(i|0)>0;if(o){o=e;H=E;c=F;J=z;while(1){I=f[H>>2]|0;y=f[H+(1-c<<2)>>2]|0;if(a){A=0;do{v=G+(A<<1)|0;w=(j[I+(A<<1)>>1]|0)+(j[v>>1]|0)|0;q=(Y(w+n|0,m)|0)>>>23&255;b[o+A>>0]=q;d[v>>1]=w-(j[y+(A<<1)>>1]|0);A=A+1|0}while((A|0)!=(i|0))}if(!J)break;o=o+g|0;H=H+4|0;c=f[h>>2]|0;J=J+-1|0}u=k;return}else{J=e;e=E;E=F;F=z;while(1){z=f[e>>2]|0;c=f[e+(1-E<<2)>>2]|0;if(a){H=0;do{o=G+(H<<1)|0;m=(j[z+(H<<1)>>1]|0)+(j[o>>1]|0)|0;b[J+H>>0]=m>>>0<256?m:m|0?255:0;d[o>>1]=m-(j[c+(H<<1)>>1]|0);H=H+1|0}while((H|0)!=(i|0))}if(!F)break;J=J+g|0;e=e+4|0;E=f[h>>2]|0;F=F+-1|0}u=k;return}}function X6(a){a=a|0;f[a+24>>2]=0;return}function Y6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>1>>>0>=b>>>0){Nac(g|0,0,b<<1|0)|0;f[e>>2]=g+(b<<1);return}h=f[a>>2]|0;i=g-h|0;g=i>>1;j=g+b|0;if((j|0)<0)c4b(a);k=d-h|0;d=k>>1>>>0<1073741823?(k>>>0<j>>>0?j:k):2147483647;do if(d)if((d|0)<0){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{l=L5b(d<<1)|0;break}else l=0;while(0);k=l+(g<<1)|0;Nac(k|0,0,b<<1|0)|0;j=k+(0-g<<1)|0;if((i|0)>0)Vac(j|0,h|0,i|0)|0;f[a>>2]=j;f[e>>2]=k+(b<<1);f[c>>2]=l+(d<<1);if(!h)return;O5b(h);return}function Z6(a){a=a|0;O5b(a);return}function _6(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function $6(a){a=a|0;var b=0,c=0;f[a>>2]=52812;b=f[a+28>>2]|0;if(!b)return;c=a+32|0;a=f[c>>2]|0;if((a|0)!=(b|0))f[c>>2]=a+(~((a+-4-b|0)>>>2)<<2);O5b(b);return}function a7(a){a=a|0;var b=0,c=0,d=0;f[a>>2]=52812;b=f[a+28>>2]|0;if(!b){O5b(a);return}c=a+32|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-4-b|0)>>>2)<<2);O5b(b);O5b(a);return}function b7(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;i=u;u=u+16|0;j=i;k=+p[a+16>>3];l=k!=1.0;m=a+28|0;n=a+32|0;o=f[n>>2]|0;q=f[m>>2]|0;r=o-q>>2;s=q;if((r|0)==(h|0)){q=a+24|0;t=f[q>>2]|0;if(!t){v=q;w=s;x=9}else{q=a+4|0;y=f[q>>2]|0;if((t|0)==(y+-1|0))z=y;else{f[j>>2]=0;f[j+4>>2]=0;y=aD(j,19)|0;t=238745;A=y+19|0;do{b[y>>0]=b[t>>0]|0;y=y+1|0;t=t+1|0}while((y|0)<(A|0));bO(-215,j,489445,237558,337);bD(j);z=f[q>>2]|0}B=c+(z+-1<<2)|0;C=z;D=s}}else{z=o;if(r>>>0>=h>>>0)if(r>>>0>h>>>0?(o=s+(h<<2)|0,(z|0)!=(o|0)):0){f[n>>2]=z+(~((z+-4-o|0)>>>2)<<2);E=s}else E=s;else{HC(m,h-r|0);E=f[m>>2]|0}m=a+24|0;f[m>>2]=0;v=m;w=E;x=9}do if((x|0)==9){Nac(w|0,0,h<<2|0)|0;E=f[v>>2]|0;m=a+4|0;r=f[m>>2]|0;s=r+-1|0;if((E|0)<(s|0)){if((h|0)>0)F=c;else{o=c;z=E;do{z=z+1|0;o=o+4|0}while((z|0)<(s|0));f[v>>2]=z;B=o;C=r;D=w;break}while(1){s=f[F>>2]|0;E=0;do{n=w+(E<<2)|0;f[n>>2]=(f[n>>2]|0)+(f[s+(E<<2)>>2]|0);E=E+1|0}while((E|0)!=(h|0));E=(f[v>>2]|0)+1|0;f[v>>2]=E;s=F+4|0;n=f[m>>2]|0;if((E|0)<(n+-1|0))F=s;else{B=s;C=n;D=w;break}}}else{B=c;C=r;D=w}}while(0);w=g+-1|0;if(!g){u=i;return}g=a+4|0;a=(h|0)>0;if(l){l=d;c=B;F=C;v=w;while(1){x=f[c>>2]|0;m=f[c+(1-F<<2)>>2]|0;if(a){o=0;do{z=D+(o<<2)|0;n=(f[x+(o<<2)>>2]|0)+(f[z>>2]|0)|0;s=MVb(k*+(n|0))|0;b[l+o>>0]=s>>>0<256?s:(s|0)>0?255:0;f[z>>2]=n-(f[m+(o<<2)>>2]|0);o=o+1|0}while((o|0)!=(h|0))}if(!v)break;l=l+e|0;c=c+4|0;F=f[g>>2]|0;v=v+-1|0}u=i;return}else{v=d;d=B;B=C;C=w;while(1){w=f[d>>2]|0;F=f[d+(1-B<<2)>>2]|0;if(a){c=0;do{l=D+(c<<2)|0;o=(f[w+(c<<2)>>2]|0)+(f[l>>2]|0)|0;b[v+c>>0]=o>>>0<256?o:(o|0)>0?255:0;f[l>>2]=o-(f[F+(c<<2)>>2]|0);c=c+1|0}while((c|0)!=(h|0))}if(!C)break;v=v+e|0;d=d+4|0;B=f[g>>2]|0;C=C+-1|0}u=i;return}}function c7(a){a=a|0;f[a+24>>2]=0;return}function d7(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0;i=u;u=u+64|0;j=i;k=i+48|0;l=i+40|0;m=i+32|0;n=b&7;o=b&4088;p=(n|0)==0;if(p)if((c&7|0)==0?(Y(f[d+4>>2]|0,f[d>>2]|0)|0)<257:0)q=2;else r=5;else if(n>>>0<5)r=5;else q=6;do if((r|0)==5){if(g?(s=Y(f[d+4>>2]|0,f[d>>2]|0)|0,(s|0)>((p?8388608:(n|0)==2?32768:65536)|0)):0){q=6;break}q=4}while(0);n=q|o;Y4(k,b,n,f[d>>2]|0,f[e>>2]|0);o=f[d+4>>2]|0;if(g)t=1.0/+(Y(f[d>>2]|0,o)|0);else t=1.0;L5(l,n,c,o,f[e+4>>2]|0,t);f[m>>2]=0;f[m+4>>2]=0;e=L5b(200)|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[j+28>>2]=0;d8(e,m,k,l,b,c,n,h,-1,j);j=L5b(16)|0;f[j+4>>2]=1;f[j>>2]=53340;f[j+8>>2]=e;f[a>>2]=j;f[a+4>>2]=e;e=f[m>>2]|0;if(e|0?(m=e+4|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)bi[f[(f[e>>2]|0)+8>>2]&2047](e);e=f[l>>2]|0;if(e|0?(l=e+4|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)bi[f[(f[e>>2]|0)+8>>2]&2047](e);e=f[k>>2]|0;if(!e){u=i;return}k=e+4|0;a=f[k>>2]|0;f[k>>2]=a+-1;if((a|0)!=1){u=i;return}bi[f[(f[e>>2]|0)+8>>2]&2047](e);u=i;return}function e7(a){a=a|0;O5b(a);return}function f7(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function g7(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;i=u;u=u+176|0;j=i+160|0;k=i+104|0;l=i+40|0;m=i+48|0;n=i+32|0;o=i+24|0;p=i+16|0;q=i+8|0;r=i;dQ(j,53352);do if((yM(a)|0)==65536){s=f[a+4>>2]|0;f[k>>2]=f[s>>2];t=k+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=k+8|0;f[w>>2]=f[s+8>>2];f[k+12>>2]=f[s+12>>2];f[k+16>>2]=f[s+16>>2];f[k+20>>2]=f[s+20>>2];f[k+24>>2]=f[s+24>>2];f[k+28>>2]=f[s+28>>2];f[k+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[k+36>>2]=x;y=k+40|0;f[y>>2]=w;w=k+48|0;z=k+44|0;f[z>>2]=w;f[w>>2]=0;f[k+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[z>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];A=k;B=y;break}else{f[t>>2]=0;jL(k,s);A=k;B=y;break}}else{yL(k,a,-1);A=k;B=k+40|0}while(0);a=f[A>>2]|0;y=f[B>>2]|0;s=f[y>>2]|0;f[l>>2]=f[y+4>>2];f[l+4>>2]=s;vM(b,l,((c|0)<0?a:c)&7|a&4088,-1,0,0);do if((yM(b)|0)==65536){a=f[b+4>>2]|0;f[m>>2]=f[a>>2];c=m+4|0;l=a+4|0;f[c>>2]=f[l>>2];s=m+8|0;f[s>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[m+36>>2]=y;f[m+40>>2]=s;s=m+48|0;t=m+44|0;f[t>>2]=s;f[s>>2]=0;f[m+52>>2]=0;if(y|0){s=y+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[l>>2]|0)<3){l=f[a+44>>2]|0;s=f[t>>2]|0;f[s>>2]=f[l>>2];f[s+4>>2]=f[l+4>>2];break}else{f[c>>2]=0;jL(m,a);break}}else yL(m,b,-1);while(0);b=(h&16|0)==0;if(!(b|g^1)){a=f[k+8>>2]|0;if((a|0)==1)f[d+4>>2]=1;c=f[k+12>>2]|0;if((c|0)==1){f[d>>2]=1;C=1;D=a}else{C=c;D=a}}else{C=f[k+12>>2]|0;D=f[k+8>>2]|0}f[n>>2]=0;f[n+4>>2]=0;f[o>>2]=C;f[o+4>>2]=D;if(b)uL(k,o,n);b=k+16|0;D=k+44|0;C=m+16|0;a=m+44|0;c=f[A>>2]&4095;A=f[m>>2]&4095;f[q>>2]=f[d>>2];f[q+4>>2]=f[d+4>>2];f[r>>2]=f[e>>2];f[r+4>>2]=f[e+4>>2];d7(p,c,A,q,r,g,h&-17);h=f[p+4>>2]|0;uh[f[(f[h>>2]|0)+20>>2]&255](h,k,m,o,n);n=f[p>>2]|0;if(n|0?(p=n+4|0,o=f[p>>2]|0,f[p>>2]=o+-1,(o|0)==1):0)bi[f[(f[n>>2]|0)+8>>2]&2047](n);n=m+36|0;o=f[n>>2]|0;if(o|0?(p=o+12|0,o=f[p>>2]|0,f[p>>2]=o+-1,(o|0)==1):0)kL(m);f[n>>2]=0;n=m+4|0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=0;f[C+12>>2]=0;if((f[n>>2]|0)>0){C=f[m+40>>2]|0;o=0;do{f[C+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[n>>2]|0))}n=f[a>>2]|0;if((n|0)!=(m+48|0))UC(n);n=k+36|0;m=f[n>>2]|0;if(m|0?(a=m+12|0,m=f[a>>2]|0,f[a>>2]=m+-1,(m|0)==1):0)kL(k);f[n>>2]=0;n=k+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[n>>2]|0)>0){b=f[B>>2]|0;B=0;do{f[b+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[n>>2]|0))}n=f[D>>2]|0;if((n|0)!=(k+48|0))UC(n);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function h7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0;g=u;u=u+32|0;h=g+16|0;i=g+8|0;j=g;dQ(h,53372);f[i>>2]=f[c>>2];f[i+4>>2]=f[c+4>>2];f[j>>2]=f[d>>2];f[j+4>>2]=f[d+4>>2];g7(a,b,-1,i,j,1,e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function i7(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0;i=u;u=u+208|0;j=i+32|0;k=i;l=i+192|0;m=i+184|0;n=i+120|0;o=i+176|0;p=i+64|0;q=i+56|0;r=i+48|0;s=i+40|0;dQ(l,53392);t=BL(a,-1)|0;v=t&7;w=t&4088;AL(m,a,-1);x=(c|0)<0?(v>>>0<5?5:6):c;if(!((h|0)==0|g^1)){if((f[m+4>>2]|0)==1)f[d+4>>2]=1;if((f[m>>2]|0)==1)f[d>>2]=1}c=(v|0)==0;v=(c?4:6)|w;y=x&7|w;do if((yM(a)|0)==65536){w=f[a+4>>2]|0;f[n>>2]=f[w>>2];x=n+4|0;z=w+4|0;f[x>>2]=f[z>>2];A=n+8|0;f[A>>2]=f[w+8>>2];f[n+12>>2]=f[w+12>>2];f[n+16>>2]=f[w+16>>2];f[n+20>>2]=f[w+20>>2];f[n+24>>2]=f[w+24>>2];f[n+28>>2]=f[w+28>>2];f[n+32>>2]=f[w+32>>2];B=f[w+36>>2]|0;f[n+36>>2]=B;f[n+40>>2]=A;A=n+48|0;C=n+44|0;f[C>>2]=A;f[A>>2]=0;f[n+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[w+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[x>>2]=0;jL(n,w);break}}else yL(n,a,-1);while(0);f[o>>2]=f[m>>2];f[o+4>>2]=f[m+4>>2];vM(b,o,y,-1,0,0);do if((yM(b)|0)==65536){o=f[b+4>>2]|0;f[p>>2]=f[o>>2];m=p+4|0;a=o+4|0;f[m>>2]=f[a>>2];w=p+8|0;f[w>>2]=f[o+8>>2];f[p+12>>2]=f[o+12>>2];f[p+16>>2]=f[o+16>>2];f[p+20>>2]=f[o+20>>2];f[p+24>>2]=f[o+24>>2];f[p+28>>2]=f[o+28>>2];f[p+32>>2]=f[o+32>>2];x=f[o+36>>2]|0;f[p+36>>2]=x;f[p+40>>2]=w;w=p+48|0;z=p+44|0;f[z>>2]=w;f[w>>2]=0;f[p+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[a>>2]|0)<3){a=f[o+44>>2]|0;w=f[z>>2]|0;f[w>>2]=f[a>>2];f[w+4>>2]=f[a+4>>2];break}else{f[m>>2]=0;jL(p,o);break}}else yL(p,b,-1);while(0);b=f[d>>2]|0;o=f[e>>2]|0;m=(o|0)<0?(b|0)/2|0:o;a:do if(c){o=L5b(12)|0;a8(o);f[o>>2]=53420;f[o+4>>2]=b;f[o+8>>2]=m;a=L5b(16)|0;w=a+4|0;f[w>>2]=1;f[a>>2]=53440;f[a+8>>2]=o;f[q>>2]=a;f[q+4>>2]=o;f[w>>2]=(f[w>>2]|0)+1;o=f[w>>2]|0;f[w>>2]=o+-1;if((o|0)==1)bi[f[(f[a>>2]|0)+8>>2]&2047](a)}else switch(t&7){case 2:{a=L5b(12)|0;a8(a);f[a>>2]=53460;f[a+4>>2]=b;f[a+8>>2]=m;o=L5b(16)|0;w=o+4|0;f[w>>2]=1;f[o>>2]=53480;f[o+8>>2]=a;f[q>>2]=o;f[q+4>>2]=a;f[w>>2]=(f[w>>2]|0)+1;a=f[w>>2]|0;f[w>>2]=a+-1;if((a|0)!=1)break a;bi[f[(f[o>>2]|0)+8>>2]&2047](o);break a;break}case 3:{o=L5b(12)|0;a8(o);f[o>>2]=53500;f[o+4>>2]=b;f[o+8>>2]=m;a=L5b(16)|0;w=a+4|0;f[w>>2]=1;f[a>>2]=53520;f[a+8>>2]=o;f[q>>2]=a;f[q+4>>2]=o;f[w>>2]=(f[w>>2]|0)+1;o=f[w>>2]|0;f[w>>2]=o+-1;if((o|0)!=1)break a;bi[f[(f[a>>2]|0)+8>>2]&2047](a);break a;break}case 5:{a=L5b(12)|0;a8(a);f[a>>2]=53540;f[a+4>>2]=b;f[a+8>>2]=m;o=L5b(16)|0;w=o+4|0;f[w>>2]=1;f[o>>2]=53560;f[o+8>>2]=a;f[q>>2]=o;f[q+4>>2]=a;f[w>>2]=(f[w>>2]|0)+1;a=f[w>>2]|0;f[w>>2]=a+-1;if((a|0)!=1)break a;bi[f[(f[o>>2]|0)+8>>2]&2047](o);break a;break}case 6:{o=L5b(12)|0;a8(o);f[o>>2]=53580;f[o+4>>2]=b;f[o+8>>2]=m;a=L5b(16)|0;w=a+4|0;f[w>>2]=1;f[a>>2]=53600;f[a+8>>2]=o;f[q>>2]=a;f[q+4>>2]=o;f[w>>2]=(f[w>>2]|0)+1;o=f[w>>2]|0;f[w>>2]=o+-1;if((o|0)!=1)break a;bi[f[(f[a>>2]|0)+8>>2]&2047](a);break a;break}default:{f[j>>2]=t;f[j+4>>2]=v;hO(k,242629,j);bO(-213,k,239999,237558,1654);bD(k);f[q>>2]=0;f[q+4>>2]=0;break a}}while(0);j=f[d+4>>2]|0;if(g)D=1.0/+(Y(f[d>>2]|0,j)|0);else D=1.0;L5(r,v,y,j,f[e+4>>2]|0,D);f[s>>2]=0;f[s+4>>2]=0;e=L5b(200)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[k+24>>2]=0;f[k+28>>2]=0;d8(e,s,q,r,t,y,v,h,-1,k);h=L5b(16)|0;v=h+4|0;f[v>>2]=1;f[h>>2]=53340;f[h+8>>2]=e;y=f[s>>2]|0;if(y|0?(t=y+4|0,j=f[t>>2]|0,f[t>>2]=j+-1,(j|0)==1):0)bi[f[(f[y>>2]|0)+8>>2]&2047](y);f[k>>2]=0;f[k+4>>2]=0;y=f[n+8>>2]|0;f[s>>2]=f[n+12>>2];f[s+4>>2]=y;uL(n,s,k);uh[f[(f[e>>2]|0)+20>>2]&255](e,n,p,s,k);k=f[v>>2]|0;f[v>>2]=k+-1;if((k|0)==1)bi[f[(f[h>>2]|0)+8>>2]&2047](h);h=f[r>>2]|0;if(h|0?(r=h+4|0,k=f[r>>2]|0,f[r>>2]=k+-1,(k|0)==1):0)bi[f[(f[h>>2]|0)+8>>2]&2047](h);h=f[q>>2]|0;if(h|0?(q=h+4|0,k=f[q>>2]|0,f[q>>2]=k+-1,(k|0)==1):0)bi[f[(f[h>>2]|0)+8>>2]&2047](h);h=p+36|0;k=f[h>>2]|0;if(k|0?(q=k+12|0,k=f[q>>2]|0,f[q>>2]=k+-1,(k|0)==1):0)kL(p);f[h>>2]=0;h=p+16|0;k=p+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[k>>2]|0)>0){h=f[p+40>>2]|0;q=0;do{f[h+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[k>>2]|0))}k=f[p+44>>2]|0;if((k|0)!=(p+48|0))UC(k);k=n+36|0;p=f[k>>2]|0;if(p|0?(q=p+12|0,p=f[q>>2]|0,f[q>>2]=p+-1,(p|0)==1):0)kL(n);f[k>>2]=0;k=n+16|0;p=n+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[p>>2]|0)>0){k=f[n+40>>2]|0;q=0;do{f[k+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[p>>2]|0))}p=f[n+44>>2]|0;if((p|0)!=(n+48|0))UC(p);if(!(f[l+4>>2]|0)){u=i;return}u=i;return}function j7(a){a=a|0;O5b(a);return}function k7(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function l7(a){a=a|0;O5b(a);return}function m7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0.0,q=0,r=0,s=0;g=Y(f[a+4>>2]|0,e)|0;a=Y(d+-1|0,e)|0;if((e|0)<=0)return;d=(a|0)>0;if((g|0)>0){h=c;i=0;j=b;while(1){k=0.0;l=0;do{m=+p[j+(l<<3)>>3];k=k+m*m;l=l+e|0}while((l|0)<(g|0));p[h>>3]=k;if(d){l=0;m=k;do{n=+p[j+(l<<3)>>3];o=+p[j+(l+g<<3)>>3];m=m+(o*o-n*n);l=l+e|0;p[h+(l<<3)>>3]=m}while((l|0)<(a|0))}i=i+1|0;if((i|0)==(e|0))break;else{h=h+8|0;j=j+8|0}}return}if(d){q=c;r=0;s=b}else{Nac(c|0,0,e<<3|0)|0;return}while(1){p[q>>3]=0.0;c=0;m=0.0;do{k=+p[s+(c<<3)>>3];n=+p[s+(c+g<<3)>>3];m=m+(n*n-k*k);c=c+e|0;p[q+(c<<3)>>3]=m}while((c|0)<(a|0));r=r+1|0;if((r|0)==(e|0))break;else{q=q+8|0;s=s+8|0}}return}function n7(a){a=a|0;O5b(a);return}function o7(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function p7(a){a=a|0;O5b(a);return}function q7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0.0,l=0,m=0.0,o=0.0,q=0.0,r=0,s=0,t=0;g=Y(f[a+4>>2]|0,e)|0;a=Y(d+-1|0,e)|0;if((e|0)<=0)return;d=(a|0)>0;if((g|0)>0){h=c;i=0;j=b;while(1){k=0.0;l=0;do{m=+n[j+(l<<2)>>2];k=k+m*m;l=l+e|0}while((l|0)<(g|0));p[h>>3]=k;if(d){l=0;m=k;do{o=+n[j+(l<<2)>>2];q=+n[j+(l+g<<2)>>2];m=m+(q*q-o*o);l=l+e|0;p[h+(l<<3)>>3]=m}while((l|0)<(a|0))}i=i+1|0;if((i|0)==(e|0))break;else{h=h+8|0;j=j+4|0}}return}if(d){r=c;s=0;t=b}else{Nac(c|0,0,e<<3|0)|0;return}while(1){p[r>>3]=0.0;c=0;m=0.0;do{k=+n[t+(c<<2)>>2];o=+n[t+(c+g<<2)>>2];m=m+(o*o-k*k);c=c+e|0;p[r+(c<<3)>>3]=m}while((c|0)<(a|0));s=s+1|0;if((s|0)==(e|0))break;else{r=r+8|0;t=t+4|0}}return}function r7(a){a=a|0;O5b(a);return}function s7(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function t7(a){a=a|0;O5b(a);return}function u7(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,q=0.0,r=0,s=0,t=0;h=Y(f[a+4>>2]|0,g)|0;a=Y(e+-1|0,g)|0;if((g|0)<=0)return;e=(a|0)>0;if((h|0)>0){i=c;j=0;k=b;while(1){l=0.0;m=0;do{n=+(d[k+(m<<1)>>1]|0);l=l+n*n;m=m+g|0}while((m|0)<(h|0));p[i>>3]=l;if(e){m=0;n=l;do{o=+(d[k+(m<<1)>>1]|0);q=+(d[k+(m+h<<1)>>1]|0);n=n+(q*q-o*o);m=m+g|0;p[i+(m<<3)>>3]=n}while((m|0)<(a|0))}j=j+1|0;if((j|0)==(g|0))break;else{i=i+8|0;k=k+2|0}}return}if(e){r=c;s=0;t=b}else{Nac(c|0,0,g<<3|0)|0;return}while(1){p[r>>3]=0.0;c=0;n=0.0;do{l=+(d[t+(c<<1)>>1]|0);o=+(d[t+(c+h<<1)>>1]|0);n=n+(o*o-l*l);c=c+g|0;p[r+(c<<3)>>3]=n}while((c|0)<(a|0));s=s+1|0;if((s|0)==(g|0))break;else{r=r+8|0;t=t+2|0}}return}function v7(a){a=a|0;O5b(a);return}function w7(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function x7(a){a=a|0;O5b(a);return}function y7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0.0,m=0,n=0.0,o=0.0,q=0.0,r=0,s=0,t=0;g=Y(f[a+4>>2]|0,e)|0;a=Y(d+-1|0,e)|0;if((e|0)<=0)return;d=(a|0)>0;if((g|0)>0){h=c;i=0;k=b;while(1){l=0.0;m=0;do{n=+(j[k+(m<<1)>>1]|0);l=l+n*n;m=m+e|0}while((m|0)<(g|0));p[h>>3]=l;if(d){m=0;n=l;do{o=+(j[k+(m<<1)>>1]|0);q=+(j[k+(m+g<<1)>>1]|0);n=n+(q*q-o*o);m=m+e|0;p[h+(m<<3)>>3]=n}while((m|0)<(a|0))}i=i+1|0;if((i|0)==(e|0))break;else{h=h+8|0;k=k+2|0}}return}if(d){r=c;s=0;t=b}else{Nac(c|0,0,e<<3|0)|0;return}while(1){p[r>>3]=0.0;c=0;n=0.0;do{l=+(j[t+(c<<1)>>1]|0);o=+(j[t+(c+g<<1)>>1]|0);n=n+(o*o-l*l);c=c+e|0;p[r+(c<<3)>>3]=n}while((c|0)<(a|0));s=s+1|0;if((s|0)==(e|0))break;else{r=r+8|0;t=t+2|0}}return}function z7(a){a=a|0;O5b(a);return}function A7(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function B7(a){a=a|0;O5b(a);return}function C7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=Y(f[a+4>>2]|0,e)|0;a=Y(d+-1|0,e)|0;if((e|0)<=0)return;d=(a|0)>0;if((g|0)>0){i=c;j=0;k=b;while(1){l=0;m=0;do{n=h[k+m>>0]|0;l=(Y(n,n)|0)+l|0;m=m+e|0}while((m|0)<(g|0));f[i>>2]=l;if(d){m=0;n=l;do{o=h[k+m>>0]|0;p=h[k+(m+g)>>0]|0;n=(Y(p,p)|0)-(Y(o,o)|0)+n|0;m=m+e|0;f[i+(m<<2)>>2]=n}while((m|0)<(a|0))}j=j+1|0;if((j|0)==(e|0))break;else{i=i+4|0;k=k+1|0}}return}if(d){q=c;r=0;s=b}else{Nac(c|0,0,e<<2|0)|0;return}while(1){f[q>>2]=0;c=0;b=0;do{d=h[s+c>>0]|0;k=h[s+(c+g)>>0]|0;b=(Y(k,k)|0)-(Y(d,d)|0)+b|0;c=c+e|0;f[q+(c<<2)>>2]=b}while((c|0)<(a|0));r=r+1|0;if((r|0)==(e|0))break;else{q=q+4|0;s=s+1|0}}return}function D7(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0;g=u;u=u+16|0;h=g;i=d<=0.0&((c|0)<8&((c|0)%2|0|0)==1)?53612+((c>>1)*28|0)|0:0;j=(e|0)==5;if((e+-5|0)>>>0>=2){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,24)|0;l=240554;m=k+24|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,240579,237558,1726);bD(h)}f[a>>2]=1124007936;l=a+8|0;o=a+40|0;k=a+4|0;m=k+36|0;do{f[k>>2]=0;k=k+4|0}while((k|0)<(m|0));f[o>>2]=l;l=a+48|0;f[a+44>>2]=l;f[l>>2]=0;f[a+52>>2]=0;f[h>>2]=c;f[h+4>>2]=1;hL(a,2,h,e&4095);e=f[a+16>>2]|0;q=+(c+-1|0)*.5;r=d>0.0?d:(q+-1.0)*.3+.8;d=-.5/(r*r);a=(c|0)>0;if(!a){u=g;return}if(i)if(j){h=0;r=0.0;while(1){s=+n[i+(h<<2)>>2];n[e+(h<<2)>>2]=s;t=r+s;h=h+1|0;if((h|0)==(c|0)){v=t;break}else r=t}}else{h=0;r=0.0;while(1){t=+n[i+(h<<2)>>2];p[e+(h<<3)>>3]=t;s=r+t;h=h+1|0;if((h|0)==(c|0)){v=s;break}else r=s}}else{h=0;r=0.0;while(1){s=+(h|0)-q;t=+V(+(s*(d*s)));if(j){s=t;n[e+(h<<2)>>2]=s;w=s}else{p[e+(h<<3)>>3]=t;w=t}t=r+w;h=h+1|0;if((h|0)==(c|0)){v=t;break}else r=t}}r=1.0/v;if(!a){u=g;return}if(j){j=0;do{a=e+(j<<2)|0;n[a>>2]=r*+n[a>>2];j=j+1|0}while((j|0)!=(c|0));u=g;return}else{j=0;do{a=e+(j<<3)|0;p[a>>3]=r*+p[a>>3];j=j+1|0}while((j|0)!=(c|0));u=g;return}}function E7(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=+h;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;i=u;u=u+64|0;j=i;k=d&7;l=!(h<=0.0)?h:g;d=f[e>>2]|0;if(g>0.0&(d|0)<1){m=MVb(((k|0)==0?3.0:4.0)*g*2.0+1.0)|0|1;f[e>>2]=m;n=m}else n=d;d=e+4|0;m=f[d>>2]|0;if(l>0.0&(m|0)<1){o=MVb(((k|0)==0?3.0:4.0)*l*2.0+1.0)|0|1;f[d>>2]=o;p=o}else p=m;if((n|0)>0&((n|0)%2|0|0)==1?(p|0)>0&((p|0)%2|0|0)==1:0)q=n;else{f[j>>2]=0;f[j+4>>2]=0;n=aD(j,84)|0;p=240597;m=n+84|0;do{b[n>>0]=b[p>>0]|0;n=n+1|0;p=p+1|0}while((n|0)<(m|0));bO(-215,j,240682,237558,1780);bD(j);q=f[e>>2]|0}h=g<0.0?0.0:g;g=l<0.0?0.0:l;p=k>>>0>5?k:5;D7(j,q,h,p);if((j|0)==(a|0)){r=j+36|0;s=f[a+36>>2]|0}else{q=j+36|0;k=f[q>>2]|0;if(k|0){n=k+12|0;f[n>>2]=(f[n>>2]|0)+1}n=a+36|0;k=f[n>>2]|0;if(k|0?(m=k+12|0,k=f[m>>2]|0,f[m>>2]=k+-1,(k|0)==1):0)kL(a);f[n>>2]=0;k=a+16|0;m=a+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[m>>2]|0)>0){o=f[a+40>>2]|0;t=0;do{f[o+(t<<2)>>2]=0;t=t+1|0;v=f[m>>2]|0}while((t|0)<(v|0));f[a>>2]=f[j>>2];if((v|0)<3)w=20;else w=22}else{f[a>>2]=f[j>>2];w=20}if((w|0)==20){v=f[j+4>>2]|0;if((v|0)<3){f[m>>2]=v;f[a+8>>2]=f[j+8>>2];f[a+12>>2]=f[j+12>>2];v=f[j+44>>2]|0;m=f[a+44>>2]|0;f[m>>2]=f[v>>2];f[m+4>>2]=f[v+4>>2]}else w=22}if((w|0)==22)jL(a,j);f[k>>2]=f[j+16>>2];f[a+20>>2]=f[j+20>>2];f[a+24>>2]=f[j+24>>2];f[a+28>>2]=f[j+28>>2];f[a+32>>2]=f[j+32>>2];k=f[q>>2]|0;f[n>>2]=k;r=q;s=k}if(s|0?(k=s+12|0,s=f[k>>2]|0,f[k>>2]=s+-1,(s|0)==1):0)kL(j);f[r>>2]=0;r=j+16|0;s=j+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[s>>2]|0)>0){r=f[j+40>>2]|0;k=0;do{f[r+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[s>>2]|0))}s=f[j+44>>2]|0;if((s|0)!=(j+48|0))UC(s);s=f[d>>2]|0;if((s|0)==(f[e>>2]|0)?+L(+(h-g))<2.220446049250313e-16:0){if((c|0)==(a|0)){u=i;return}e=a+36|0;d=f[e>>2]|0;if(d|0){k=d+12|0;f[k>>2]=(f[k>>2]|0)+1}k=c+36|0;d=f[k>>2]|0;if(d|0?(r=d+12|0,d=f[r>>2]|0,f[r>>2]=d+-1,(d|0)==1):0)kL(c);f[k>>2]=0;d=c+16|0;r=c+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[r>>2]|0)>0){q=f[c+40>>2]|0;n=0;do{f[q+(n<<2)>>2]=0;n=n+1|0;x=f[r>>2]|0}while((n|0)<(x|0));f[c>>2]=f[a>>2];if((x|0)<3)w=45;else w=47}else{f[c>>2]=f[a>>2];w=45}if((w|0)==45){x=f[a+4>>2]|0;if((x|0)<3){f[r>>2]=x;f[c+8>>2]=f[a+8>>2];f[c+12>>2]=f[a+12>>2];x=f[a+44>>2]|0;r=f[c+44>>2]|0;f[r>>2]=f[x>>2];f[r+4>>2]=f[x+4>>2]}else w=47}if((w|0)==47)jL(c,a);f[d>>2]=f[a+16>>2];f[c+20>>2]=f[a+20>>2];f[c+24>>2]=f[a+24>>2];f[c+28>>2]=f[a+28>>2];f[c+32>>2]=f[a+32>>2];f[k>>2]=f[e>>2];u=i;return}D7(j,s,g,p);if((j|0)==(c|0)){y=j+36|0;z=f[c+36>>2]|0}else{p=j+36|0;s=f[p>>2]|0;if(s|0){e=s+12|0;f[e>>2]=(f[e>>2]|0)+1}e=c+36|0;s=f[e>>2]|0;if(s|0?(k=s+12|0,s=f[k>>2]|0,f[k>>2]=s+-1,(s|0)==1):0)kL(c);f[e>>2]=0;s=c+16|0;k=c+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){a=f[c+40>>2]|0;d=0;do{f[a+(d<<2)>>2]=0;d=d+1|0;A=f[k>>2]|0}while((d|0)<(A|0));f[c>>2]=f[j>>2];if((A|0)<3)w=61;else w=63}else{f[c>>2]=f[j>>2];w=61}if((w|0)==61){A=f[j+4>>2]|0;if((A|0)<3){f[k>>2]=A;f[c+8>>2]=f[j+8>>2];f[c+12>>2]=f[j+12>>2];A=f[j+44>>2]|0;k=f[c+44>>2]|0;f[k>>2]=f[A>>2];f[k+4>>2]=f[A+4>>2]}else w=63}if((w|0)==63)jL(c,j);f[s>>2]=f[j+16>>2];f[c+20>>2]=f[j+20>>2];f[c+24>>2]=f[j+24>>2];f[c+28>>2]=f[j+28>>2];f[c+32>>2]=f[j+32>>2];c=f[p>>2]|0;f[e>>2]=c;y=p;z=c}if(z|0?(c=z+12|0,z=f[c>>2]|0,f[c>>2]=z+-1,(z|0)==1):0)kL(j);f[y>>2]=0;y=j+16|0;z=j+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[z>>2]|0)>0){y=f[j+40>>2]|0;c=0;do{f[y+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[z>>2]|0))}z=f[j+44>>2]|0;if((z|0)!=(j+48|0))UC(z);u=i;return}function F7(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;h=u;u=u+352|0;i=h+336|0;j=h+328|0;k=h+264|0;l=h+272|0;m=h+208|0;n=h+88|0;o=h+152|0;p=h+96|0;q=h+80|0;r=h+72|0;s=h+56|0;t=h+40|0;v=h+24|0;w=h+8|0;x=h;dQ(i,53724);y=BL(a,-1)|0;AL(j,a,-1);f[k>>2]=f[j>>2];z=j+4|0;f[k+4>>2]=f[z>>2];vM(b,k,y,-1,0,0);k=(g&16|0)==0;if(!k){if((f[z>>2]|0)==1)f[c+4>>2]=1;if((f[j>>2]|0)==1)f[c>>2]=1}j=f[c>>2]|0;z=f[c+4>>2]|0;if(!((j|0)==1&(z|0)==1)){c=y&7;f[l>>2]=1124007936;A=l+4|0;B=l+8|0;C=l+40|0;D=A;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[C>>2]=B;B=l+48|0;F=l+44|0;f[F>>2]=B;f[B>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;G=m+4|0;H=m+8|0;I=m+40|0;D=G;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[I>>2]=H;H=m+48|0;D=m+44|0;f[D>>2]=H;f[H>>2]=0;f[m+52>>2]=0;f[n>>2]=j;f[n+4>>2]=z;E7(l,m,y,n,d,e);do if((yM(a)|0)==65536){n=f[a+4>>2]|0;f[o>>2]=f[n>>2];y=o+4|0;z=n+4|0;f[y>>2]=f[z>>2];j=o+8|0;f[j>>2]=f[n+8>>2];f[o+12>>2]=f[n+12>>2];f[o+16>>2]=f[n+16>>2];f[o+20>>2]=f[n+20>>2];f[o+24>>2]=f[n+24>>2];f[o+28>>2]=f[n+28>>2];f[o+32>>2]=f[n+32>>2];E=f[n+36>>2]|0;f[o+36>>2]=E;f[o+40>>2]=j;j=o+48|0;J=o+44|0;f[J>>2]=j;f[j>>2]=0;f[o+52>>2]=0;if(E|0){j=E+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[z>>2]|0)<3){z=f[n+44>>2]|0;j=f[J>>2]|0;f[j>>2]=f[z>>2];f[j+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(o,n);break}}else yL(o,a,-1);while(0);do if((yM(b)|0)==65536){n=f[b+4>>2]|0;f[p>>2]=f[n>>2];y=p+4|0;z=n+4|0;f[y>>2]=f[z>>2];j=p+8|0;f[j>>2]=f[n+8>>2];f[p+12>>2]=f[n+12>>2];f[p+16>>2]=f[n+16>>2];f[p+20>>2]=f[n+20>>2];f[p+24>>2]=f[n+24>>2];f[p+28>>2]=f[n+28>>2];f[p+32>>2]=f[n+32>>2];J=f[n+36>>2]|0;f[p+36>>2]=J;f[p+40>>2]=j;j=p+48|0;E=p+44|0;f[E>>2]=j;f[j>>2]=0;f[p+52>>2]=0;if(J|0){j=J+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[z>>2]|0)<3){z=f[n+44>>2]|0;j=f[E>>2]|0;f[j>>2]=f[z>>2];f[j+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(p,n);break}}else yL(p,b,-1);while(0);f[q>>2]=0;f[q+4>>2]=0;n=f[o+8>>2]|0;f[r>>2]=f[o+12>>2];f[r+4>>2]=n;if(k)uL(o,r,q);q=o+16|0;r=o+44|0;k=p+16|0;n=p+44|0;f[s+8>>2]=0;f[s+12>>2]=0;f[s>>2]=16842752;f[s+4>>2]=o;y=t+8|0;f[y>>2]=0;f[y+4>>2]=0;f[t>>2]=33619968;f[t+4>>2]=p;f[v+8>>2]=0;f[v+12>>2]=0;f[v>>2]=16842752;f[v+4>>2]=l;f[w+8>>2]=0;f[w+12>>2]=0;f[w>>2]=16842752;f[w+4>>2]=m;f[x>>2]=-1;f[x+4>>2]=-1;Nda(s,t,c,v,w,x,0.0,g);g=p+36|0;x=f[g>>2]|0;if(x|0?(w=x+12|0,x=f[w>>2]|0,f[w>>2]=x+-1,(x|0)==1):0)kL(p);f[g>>2]=0;g=p+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[g>>2]|0)>0){k=f[p+40>>2]|0;x=0;do{f[k+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[g>>2]|0))}g=f[n>>2]|0;if((g|0)!=(p+48|0))UC(g);g=o+36|0;p=f[g>>2]|0;if(p|0?(n=p+12|0,p=f[n>>2]|0,f[n>>2]=p+-1,(p|0)==1):0)kL(o);f[g>>2]=0;g=o+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[g>>2]|0)>0){q=f[o+40>>2]|0;p=0;do{f[q+(p<<2)>>2]=0;p=p+1|0}while((p|0)<(f[g>>2]|0))}g=f[r>>2]|0;if((g|0)!=(o+48|0))UC(g);g=m+36|0;o=f[g>>2]|0;if(o|0?(r=o+12|0,o=f[r>>2]|0,f[r>>2]=o+-1,(o|0)==1):0)kL(m);f[g>>2]=0;g=m+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[G>>2]|0)>0){g=f[I>>2]|0;I=0;do{f[g+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[G>>2]|0))}G=f[D>>2]|0;if((G|0)!=(H|0))UC(G);G=l+36|0;H=f[G>>2]|0;if(H|0?(D=H+12|0,H=f[D>>2]|0,f[D>>2]=H+-1,(H|0)==1):0)kL(l);f[G>>2]=0;G=l+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[A>>2]|0)>0){G=f[C>>2]|0;C=0;do{f[G+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[A>>2]|0))}A=f[F>>2]|0;if((A|0)!=(B|0))UC(A)}else JM(a,b);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function G7(a,c,e){a=a|0;c=c|0;e=e|0;var g=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0.0,lc=0.0,mc=0.0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0,sc=0,tc=0.0,uc=0,vc=0;g=u;u=u+6608|0;i=g+4096|0;k=g;l=g+6272|0;m=g+6584|0;o=g+6576|0;p=g+6572|0;q=g+6568|0;r=g+6552|0;t=g+6548|0;v=g+6544|0;w=g+6540|0;x=g+6536|0;y=g+6532|0;z=g+6528|0;A=g+6524|0;B=g+6520|0;C=g+6516|0;D=g+6512|0;E=g+6508|0;F=g+6504|0;G=g+6500|0;H=g+6496|0;I=g+6492|0;J=g+6488|0;K=g+6484|0;L=g+6480|0;M=g+6472|0;N=g+6416|0;O=g+6560|0;P=g+6360|0;Q=g+6304|0;dQ(M,53744);if(!(((e|0)%2|0|0)==1?(_L(a,-1)|0)<3:0)){f[i>>2]=0;f[i+4>>2]=0;R=aD(i,40)|0;S=240778;T=R+40|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));bO(-215,i,240819,237558,3125);bD(i)}if((e|0)>=2?!(HM(a)|0):0){do if((yM(a)|0)==65536){U=f[a+4>>2]|0;f[N>>2]=f[U>>2];V=N+4|0;W=U+4|0;f[V>>2]=f[W>>2];X=N+8|0;f[X>>2]=f[U+8>>2];f[N+12>>2]=f[U+12>>2];f[N+16>>2]=f[U+16>>2];f[N+20>>2]=f[U+20>>2];f[N+24>>2]=f[U+24>>2];f[N+28>>2]=f[U+28>>2];f[N+32>>2]=f[U+32>>2];Z=f[U+36>>2]|0;f[N+36>>2]=Z;_=N+40|0;f[_>>2]=X;X=N+48|0;$=N+44|0;f[$>>2]=X;f[X>>2]=0;f[N+52>>2]=0;if(Z|0){X=Z+12|0;f[X>>2]=(f[X>>2]|0)+1}if((f[W>>2]|0)<3){W=f[U+44>>2]|0;X=f[$>>2]|0;f[X>>2]=f[W>>2];f[X+4>>2]=f[W+4>>2];aa=N;ba=_;break}else{f[V>>2]=0;jL(N,U);aa=N;ba=_;break}}else{yL(N,a,-1);aa=N;ba=N+40|0}while(0);_=f[ba>>2]|0;U=f[_>>2]|0;f[O>>2]=f[_+4>>2];f[O+4>>2]=U;vM(c,O,f[aa>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){O=f[c+4>>2]|0;f[P>>2]=f[O>>2];U=P+4|0;_=O+4|0;f[U>>2]=f[_>>2];V=P+8|0;f[V>>2]=f[O+8>>2];f[P+12>>2]=f[O+12>>2];W=P+16|0;f[W>>2]=f[O+16>>2];f[P+20>>2]=f[O+20>>2];f[P+24>>2]=f[O+24>>2];f[P+28>>2]=f[O+28>>2];f[P+32>>2]=f[O+32>>2];X=f[O+36>>2]|0;f[P+36>>2]=X;f[P+40>>2]=V;V=P+48|0;$=P+44|0;f[$>>2]=V;f[V>>2]=0;f[P+52>>2]=0;if(X|0){V=X+12|0;f[V>>2]=(f[V>>2]|0)+1}if((f[_>>2]|0)<3){_=f[O+44>>2]|0;V=f[$>>2]|0;f[V>>2]=f[_>>2];f[V+4>>2]=f[_+4>>2];ca=W;break}else{f[U>>2]=0;jL(P,O);ca=W;break}}else{yL(P,c,-1);ca=P+16|0}while(0);W=N+16|0;O=N+12|0;U=N+8|0;switch(e|0){case 3:{da=1;break}case 5:{_=f[aa>>2]|0;if(!(_&7)){V=(_>>>3&511)+1|0;da=(V|0)==2|V>>>0>4}else da=1;break}default:da=0}f[Q>>2]=1124007936;V=Q+4|0;_=Q+8|0;$=Q+40|0;R=V;T=R+36|0;do{f[R>>2]=0;R=R+4|0}while((R|0)<(T|0));f[$>>2]=_;X=Q+48|0;Z=Q+44|0;f[Z>>2]=X;f[X>>2]=0;f[Q+52>>2]=0;a:do if(!da){f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=N;ea=k+8|0;f[ea>>2]=0;f[ea+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=Q;ea=(e|0)/2|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[l+28>>2]=0;_P(i,k,0,0,ea,ea,17,l);if(!(f[Q>>2]&7))switch((f[aa>>2]|0)>>>3&511){case 0:case 2:case 3:break;default:fa=143}else fa=143;if((fa|0)==143){f[i>>2]=0;f[i+4>>2]=0;R=aD(i,51)|0;S=240830;T=R+51|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));bO(-215,i,240819,237558,3185);bD(i)}ga=f[N+4>>2]|0;if((ga|0)<3)ha=Y(f[O>>2]|0,f[U>>2]|0)|0;else{ia=f[ba>>2]|0;ja=0;ka=1;while(1){la=Y(f[ia+(ja<<2)>>2]|0,ka)|0;ja=ja+1|0;if((ja|0)==(ga|0)){ha=la;break}else ka=la}}ma=+(ha>>>0)*9.5367431640625e-07;if(((ma<1.0?39:ma<4.0?21:9)|0)>=(e|0)){ka=(Y(e,e)|0)>>>1;ga=f[P+40>>2]|0;ja=f[ga+4>>2]|0;ia=f[ga>>2]|0;ga=f[Q+16>>2]|0;la=f[ca>>2]|0;na=f[X>>2]|0;oa=f[P+48>>2]|0;pa=(f[Q>>2]|0)>>>3;qa=pa&511;ra=qa+1|0;sa=ga+(Y(na,ia)|0)|0;if(qa>>>0>=4){f[l>>2]=0;f[l+4>>2]=0;R=aD(l,17)|0;S=240882;T=R+17|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));bO(-215,l,240900,237558,2420);bD(l)}if((ja|0)>0){qa=ia+-1|0;ta=Y(na,qa)|0;ua=Y(oa,qa)|0;va=0-na|0;wa=0-oa|0;xa=ra<<6;ya=ra<<10;za=(e|0)<-1;Aa=(ia|0)>0;Ba=pa&65535;Ca=e<<2;Da=(e|0)>0;Ea=e*3|0;Fa=Y(ra,e)|0;Ga=(Fa|0)>0;Ha=ea+1|0;Ia=(na|0)!=0;Ja=ga;Ka=la;La=0;while(1){Ma=(La&1|0)==0;Na=Ma?oa:wa;Oa=Ma?na:va;Pa=Ma?Ja:Ja+ta|0;Qa=Ma?Ka:Ka+ua|0;Nac(i|0,0,xa|0)|0;Nac(k|0,0,ya|0)|0;b:do if(za)Ra=Pa;else{Ma=(Oa|0)>0;if(Ga){Sa=0;Ta=Pa}else{Ua=0;Va=Pa;while(1){if(Ma)if((Ua|0)<(qa|0))fa=172;else Wa=Va;else if(Ia&(ia-Ua|0)>1)fa=172;else Wa=Va;if((fa|0)==172){fa=0;Wa=Va+Oa|0}if((Ua|0)<(ea|0)){Ua=Ua+1|0;Va=Wa}else{Ra=Wa;break b}}}while(1){if((Sa|0)>0){Va=0;do{Ua=0;do{Xa=h[Ta+(Ua+Va)>>0]|0;Ya=k+(Va<<10)+(Xa<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=i+(Va<<6)+(Xa>>>4<<2)|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ua=Ua+ra|0}while((Ua|0)<(Fa|0));Va=Va+1|0}while((Va|0)!=(ra|0))}else{Va=0;do{Ua=0;do{Ya=h[Ta+(Ua+Va)>>0]|0;Xa=k+(Va<<10)+(Ya<<2)|0;f[Xa>>2]=(f[Xa>>2]|0)+Ha;Xa=i+(Va<<6)+(Ya>>>4<<2)|0;f[Xa>>2]=(f[Xa>>2]|0)+Ha;Ua=Ua+ra|0}while((Ua|0)<(Fa|0));Va=Va+1|0}while((Va|0)!=(ra|0))}if(Ma)if((Sa|0)<(qa|0))fa=162;else Za=Ta;else if(Ia&(ia-Sa|0)>1)fa=162;else Za=Ta;if((fa|0)==162){fa=0;Za=Ta+Oa|0}if((Sa|0)<(ea|0)){Sa=Sa+1|0;Ta=Za}else{Ra=Za;break}}}while(0);c:do if(Aa){Ma=(Oa|0)>-1;Va=(Oa|0)<1;Ua=Qa;Xa=Pa;Ya=0;_a=Ra;while(1){$a=0;do{ab=0;bb=0;while(1){cb=(f[i+($a<<6)+(bb<<2)>>2]|0)+ab|0;if((cb|0)>(ka|0))break;else{ab=cb;bb=bb+1|0}}cb=ab;db=bb<<4;while(1){cb=(f[k+($a<<10)+(db<<2)>>2]|0)+cb|0;if((cb|0)>(ka|0))break;else db=db+1|0}b[Ua+$a>>0]=db;$a=$a+1|0}while(($a|0)!=(ra|0));$a=Ya+1|0;if(($a|0)==(ia|0))break c;d:do switch(Ba&511){case 0:{if(Da)eb=0;else break d;do{cb=h[Xa+eb>>0]|0;bb=h[_a+eb>>0]|0;ab=k+(cb<<2)|0;f[ab>>2]=(f[ab>>2]|0)+-1;ab=i+(cb>>>4<<2)|0;f[ab>>2]=(f[ab>>2]|0)+-1;ab=k+(bb<<2)|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=i+(bb>>>4<<2)|0;f[ab>>2]=(f[ab>>2]|0)+1;eb=eb+1|0}while((eb|0)!=(e|0));break}case 2:{if(Da)fb=0;else break d;do{db=h[Xa+fb>>0]|0;ab=k+(db<<2)|0;f[ab>>2]=(f[ab>>2]|0)+-1;ab=i+(db>>>4<<2)|0;f[ab>>2]=(f[ab>>2]|0)+-1;ab=fb+1|0;db=h[Xa+ab>>0]|0;bb=k+1024+(db<<2)|0;f[bb>>2]=(f[bb>>2]|0)+-1;bb=i+64+(db>>>4<<2)|0;f[bb>>2]=(f[bb>>2]|0)+-1;bb=fb+2|0;db=h[Xa+bb>>0]|0;cb=k+2048+(db<<2)|0;f[cb>>2]=(f[cb>>2]|0)+-1;cb=i+128+(db>>>4<<2)|0;f[cb>>2]=(f[cb>>2]|0)+-1;cb=h[_a+fb>>0]|0;db=k+(cb<<2)|0;f[db>>2]=(f[db>>2]|0)+1;db=i+(cb>>>4<<2)|0;f[db>>2]=(f[db>>2]|0)+1;db=h[_a+ab>>0]|0;ab=k+1024+(db<<2)|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=i+64+(db>>>4<<2)|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=h[_a+bb>>0]|0;bb=k+2048+(ab<<2)|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=i+128+(ab>>>4<<2)|0;f[bb>>2]=(f[bb>>2]|0)+1;fb=fb+3|0}while((fb|0)<(Ea|0));break}default:{if(Da)gb=0;else break d;do{bb=h[Xa+gb>>0]|0;ab=k+(bb<<2)|0;f[ab>>2]=(f[ab>>2]|0)+-1;ab=i+(bb>>>4<<2)|0;f[ab>>2]=(f[ab>>2]|0)+-1;ab=gb|1;bb=h[Xa+ab>>0]|0;db=k+1024+(bb<<2)|0;f[db>>2]=(f[db>>2]|0)+-1;db=i+64+(bb>>>4<<2)|0;f[db>>2]=(f[db>>2]|0)+-1;db=gb|2;bb=h[Xa+db>>0]|0;cb=k+2048+(bb<<2)|0;f[cb>>2]=(f[cb>>2]|0)+-1;cb=i+128+(bb>>>4<<2)|0;f[cb>>2]=(f[cb>>2]|0)+-1;cb=gb|3;bb=h[Xa+cb>>0]|0;hb=k+3072+(bb<<2)|0;f[hb>>2]=(f[hb>>2]|0)+-1;hb=i+192+(bb>>>4<<2)|0;f[hb>>2]=(f[hb>>2]|0)+-1;hb=h[_a+gb>>0]|0;bb=k+(hb<<2)|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=i+(hb>>>4<<2)|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=h[_a+ab>>0]|0;ab=k+1024+(bb<<2)|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=i+64+(bb>>>4<<2)|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=h[_a+db>>0]|0;db=k+2048+(ab<<2)|0;f[db>>2]=(f[db>>2]|0)+1;db=i+128+(ab>>>4<<2)|0;f[db>>2]=(f[db>>2]|0)+1;db=h[_a+cb>>0]|0;cb=k+3072+(db<<2)|0;f[cb>>2]=(f[cb>>2]|0)+1;cb=i+192+(db>>>4<<2)|0;f[cb>>2]=(f[cb>>2]|0)+1;gb=gb+4|0}while((gb|0)<(Ca|0))}}while(0);cb=_a+Oa|0;if(($a|0)<(ia|0)){Ua=Ua+Na|0;Xa=(Ya|0)<(ea|0)?Xa:Xa+Oa|0;Ya=$a;_a=(Va|cb>>>0>=sa>>>0)&(Ma|cb>>>0<Ja>>>0)?_a:cb}else break c}}while(0);La=La+1|0;if((La|0)==(ja|0))break;else{Ja=Ja+ra|0;Ka=Ka+ra|0}}}break}ra=(f[P>>2]|0)>>>3&511;Ka=ra+1|0;Ja=f[P+8>>2]|0;ja=e+-1|0;La=(ja|0)/2|0;if(ra>>>0>=4){f[i>>2]=0;f[i+4>>2]=0;R=aD(i,17)|0;S=240882;T=R+17|0;do{b[R>>0]=b[S>>0]|0;R=R+1|0;S=S+1|0}while((R|0)<(T|0));bO(-215,i,240917,237558,2214);bD(i)}sa=f[X>>2]|0;ea=f[P+48>>2]|0;ia=P+12|0;Ca=512/(Ka>>>0)|0;Da=f[ia>>2]|0;Ea=(Ca|0)<(Da|0)?Ca:Da;Ca=La<<1;Ba=Ea+Ca|0;ka=Y(Ba<<4,Ka)|0;Aa=ka+16|0;f[l>>2]=0;Ia=l+4|0;f[Ia>>2]=0;f[l+8>>2]=0;do if(Aa)if((ka|0)<-16)c4b(l);else{qa=Aa<<1;Fa=L5b(qa)|0;f[l>>2]=Fa;Ha=Fa+(Aa<<1)|0;f[l+8>>2]=Ha;Nac(Fa|0,0,qa|0)|0;f[Ia>>2]=Ha;ib=Fa;break}else ib=0;while(0);Aa=Y(Ka<<8,Ba)|0|16;f[m>>2]=0;ka=m+4|0;f[ka>>2]=0;f[m+8>>2]=0;if((Aa|0)<0)c4b(m);Fa=Aa<<1;Ha=L5b(Fa)|0;f[m>>2]=Ha;qa=Ha+(Aa<<1)|0;f[m+8>>2]=qa;Nac(Ha|0,0,Fa|0)|0;f[ka>>2]=qa;Fa=ib+15&-16;Aa=Fa;Ga=Ha+15&-16;za=Ga;if((Da|0)>0){ya=Q+16|0;xa=Fa;Fa=Ka<<1;ua=Ga;Ga=Ka<<9;ta=La+2|0;va=(ja|0)>3;na=Ja+-1|0;wa=(Ja|0)>0;oa=Ka*544|0;la=Ka<<5;ga=Ca|1;pa=(ja|0)>1;Oa=(Y(Ca,La)|0)+Ca|0;Na=o+4|0;Pa=o+4|0;Qa=0;_a=Da;do{Ma=_a-Qa|0;Va=((Ea|0)<(Ma|0)?Ea:Ma)+Ca|0;Ma=(f[ya>>2]|0)+(Y(Qa,Ka)|0)|0;Ya=f[ca>>2]|0;Xa=Y(Qa-La|0,Ka)|0;Ua=Va<<4;Nac(xa|0,0,Y(Fa,Ua)|0)|0;Nac(ua|0,0,Y(Ga,Va)|0)|0;cb=(Va|0)>0;if(cb){db=0;do{ab=Y(db,Va)|0;bb=db<<4;hb=0;do{jb=Ma+((Y(hb,Ka)|0)+db)|0;kb=Aa+(((h[jb>>0]|0)>>>4|hb+ab<<4)<<1)|0;d[kb>>1]=(j[kb>>1]|0)+ta;kb=h[jb>>0]|0;jb=za+(((Y(kb>>>4|bb,Va)|0)+hb<<4|kb&15)<<1)|0;d[jb>>1]=(j[jb>>1]|0)+ta;hb=hb+1|0}while((hb|0)<(Va|0));if(va){hb=1;do{jb=Ma+(Y((na|0)<(hb|0)?na:hb,sa)|0)|0;kb=0;do{lb=jb+((Y(kb,Ka)|0)+db)|0;mb=Aa+(((h[lb>>0]|0)>>>4|kb+ab<<4)<<1)|0;d[mb>>1]=(d[mb>>1]|0)+1<<16>>16;mb=h[lb>>0]|0;lb=za+(((Y(mb>>>4|bb,Va)|0)+kb<<4|mb&15)<<1)|0;d[lb>>1]=(d[lb>>1]|0)+1<<16>>16;kb=kb+1|0}while((kb|0)<(Va|0));hb=hb+1|0}while((hb|0)<(La|0))}db=db+1|0}while((db|0)!=(Ka|0))}db=Ya+Xa|0;if(wa){hb=Va-La|0;bb=(La|0)<(hb|0);ab=Va+-1|0;kb=0;do{jb=kb-La+-1|0;$a=Ma+(Y((jb|0)>0?jb:0,sa)|0)|0;jb=kb+La|0;lb=Ma+(Y((jb|0)<(na|0)?jb:na,sa)|0)|0;Nac(i|0,0,oa|0)|0;Nac(k|0,0,la|0)|0;jb=Y(kb,ea)|0;mb=0;while(1){if(cb){nb=Y(mb,Va)|0;ob=mb<<4;pb=0;do{qb=pb+nb<<4;rb=(Y(pb,Ka)|0)+mb|0;sb=$a+rb|0;tb=Aa+(((h[sb>>0]|0)>>>4|qb)<<1)|0;d[tb>>1]=(d[tb>>1]|0)+-1<<16>>16;tb=h[sb>>0]|0;sb=za+(((Y(tb>>>4|ob,Va)|0)+pb<<4|tb&15)<<1)|0;d[sb>>1]=(d[sb>>1]|0)+-1<<16>>16;sb=lb+rb|0;rb=Aa+(((h[sb>>0]|0)>>>4|qb)<<1)|0;d[rb>>1]=(d[rb>>1]|0)+1<<16>>16;rb=h[sb>>0]|0;sb=za+(((Y(rb>>>4|ob,Va)|0)+pb<<4|rb&15)<<1)|0;d[sb>>1]=(d[sb>>1]|0)+1<<16>>16;pb=pb+1|0}while((pb|0)<(Va|0));ub=ob}else ub=mb<<4;ob=0;do{pb=za+((Y(ob+ub|0,Ua)|0)<<1)|0;nb=0;do{sb=i+(mb*544|0)+32+(ob<<5)+(nb<<1)|0;rb=(Y(j[pb+(nb<<1)>>1]|0,ga)|0)+(j[sb>>1]|0)&65535;d[sb>>1]=rb;nb=nb+1|0}while((nb|0)!=16);ob=ob+1|0}while((ob|0)!=16);if(pa){ob=Y(mb,Va)|0;nb=0;do{pb=Aa+(nb+ob<<4<<1)|0;rb=0;do{sb=i+(mb*544|0)+(rb<<1)|0;d[sb>>1]=(j[pb+(rb<<1)>>1]|0)+(j[sb>>1]|0);rb=rb+1|0}while((rb|0)!=16);nb=nb+1|0}while((nb|0)<(Ca|0))}if(bb){nb=Y(mb,Va)|0;ob=mb+jb|0;rb=i+(mb*544|0)|0;pb=i+(mb*544|0)+2|0;sb=i+(mb*544|0)+4|0;qb=i+(mb*544|0)+6|0;tb=i+(mb*544|0)+8|0;vb=i+(mb*544|0)+10|0;wb=i+(mb*544|0)+12|0;xb=i+(mb*544|0)+14|0;yb=i+(mb*544|0)+16|0;zb=i+(mb*544|0)+18|0;Ab=i+(mb*544|0)+20|0;Bb=i+(mb*544|0)+22|0;Cb=i+(mb*544|0)+24|0;Db=i+(mb*544|0)+26|0;Eb=i+(mb*544|0)+28|0;Fb=i+(mb*544|0)+30|0;Gb=La;do{Hb=Gb+La|0;Ib=Aa+(((ab|0)<(Hb|0)?ab:Hb)+nb<<4<<1)|0;Jb=0;do{Kb=i+(mb*544|0)+(Jb<<1)|0;d[Kb>>1]=(j[Ib+(Jb<<1)>>1]|0)+(j[Kb>>1]|0);Jb=Jb+1|0}while((Jb|0)!=16);Jb=j[rb>>1]|0;do if((Jb|0)>(Oa|0)){Lb=0;Mb=0}else{Ib=(j[pb>>1]|0)+Jb|0;if((Ib|0)>(Oa|0)){Lb=Jb;Mb=1;break}Kb=(j[sb>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=2;break}Ib=(j[qb>>1]|0)+Kb|0;if((Ib|0)>(Oa|0)){Lb=Kb;Mb=3;break}Kb=(j[tb>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=4;break}Ib=(j[vb>>1]|0)+Kb|0;if((Ib|0)>(Oa|0)){Lb=Kb;Mb=5;break}Kb=(j[wb>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=6;break}Ib=(j[xb>>1]|0)+Kb|0;if((Ib|0)>(Oa|0)){Lb=Kb;Mb=7;break}Kb=(j[yb>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=8;break}Ib=(j[zb>>1]|0)+Kb|0;if((Ib|0)>(Oa|0)){Lb=Kb;Mb=9;break}Kb=(j[Ab>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=10;break}Ib=(j[Bb>>1]|0)+Kb|0;if((Ib|0)>(Oa|0)){Lb=Kb;Mb=11;break}Kb=(j[Cb>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=12;break}Ib=(j[Db>>1]|0)+Kb|0;if((Ib|0)>(Oa|0)){Lb=Kb;Mb=13;break}Kb=(j[Eb>>1]|0)+Ib|0;if((Kb|0)>(Oa|0)){Lb=Ib;Mb=14;break}Ib=(j[Fb>>1]|0)+Kb|0;if((Ib|0)>(Oa|0)){Lb=Kb;Mb=15;break}f[o>>2]=0;f[Na>>2]=0;Kb=aD(o,6)|0;b[Kb>>0]=b[240934]|0;b[Kb+1>>0]=b[240935]|0;b[Kb+2>>0]=b[240936]|0;b[Kb+3>>0]=b[240937]|0;b[Kb+4>>0]=b[240938]|0;b[Kb+5>>0]=b[240939]|0;bO(-215,o,240917,237558,2358);bD(o);Lb=Ib;Mb=16}while(0);Jb=k+(mb<<5)+(Mb<<1)|0;Ib=d[Jb>>1]|0;Kb=Ib&65535;Nb=Gb-La|0;do if((Kb|0)>(Nb|0)){if((Kb|0)>(Hb|0))break;Ob=Y(Mb+ub|0,Va)|0;Pb=Kb;Qb=Ib;do{Rb=Pb-Ca|0;Sb=za+(((Rb|0)<1?0:Rb+-1|0)+Ob<<4<<1)|0;Rb=0;do{Tb=i+(mb*544|0)+32+(Mb<<5)+(Rb<<1)|0;d[Tb>>1]=(j[Tb>>1]|0)-(j[Sb+(Rb<<1)>>1]|0);Rb=Rb+1|0}while((Rb|0)!=16);Rb=Qb&65535;Sb=za+(((Rb|0)<(Va|0)?Rb:ab)+Ob<<4<<1)|0;Rb=0;do{Tb=i+(mb*544|0)+32+(Mb<<5)+(Rb<<1)|0;d[Tb>>1]=(j[Sb+(Rb<<1)>>1]|0)+(j[Tb>>1]|0);Rb=Rb+1|0}while((Rb|0)!=16);Qb=Qb+1<<16>>16;d[Jb>>1]=Qb;Pb=Qb&65535}while((Pb|0)<=(Hb|0))}else{Pb=i+(mb*544|0)+32+(Mb<<5)|0;f[Pb>>2]=0;f[Pb+4>>2]=0;f[Pb+8>>2]=0;f[Pb+12>>2]=0;f[Pb+16>>2]=0;f[Pb+20>>2]=0;f[Pb+24>>2]=0;f[Pb+28>>2]=0;Pb=Nb&65535;d[Jb>>1]=Pb;Qb=Nb&65535;Ob=Hb+1|0;Rb=(Hb|0)<(Va|0)?Ob:Va;if((Qb|0)<(Rb|0)){Sb=Y(Mb+ub|0,Va)|0;Tb=Qb;Ub=Pb;while(1){Pb=za+(Tb+Sb<<4<<1)|0;Vb=0;do{Wb=i+(mb*544|0)+32+(Mb<<5)+(Vb<<1)|0;d[Wb>>1]=(j[Pb+(Vb<<1)>>1]|0)+(j[Wb>>1]|0);Vb=Vb+1|0}while((Vb|0)!=16);Ub=Ub+1<<16>>16;d[Jb>>1]=Ub;Vb=Ub&65535;if((Vb|0)>=(Rb|0)){Xb=Vb;break}else Tb=Vb}}else Xb=Qb;if((Xb|0)>(Hb|0))break;Tb=Ob-Va|0;Rb=za+((Y(Mb+ub|0,Va)|0)+ab<<4<<1)|0;Ub=0;do{Sb=i+(mb*544|0)+32+(Mb<<5)+(Ub<<1)|0;Vb=(Y(j[Rb+(Ub<<1)>>1]|0,Tb)|0)+(j[Sb>>1]|0)&65535;d[Sb>>1]=Vb;Ub=Ub+1|0}while((Ub|0)!=16);d[Jb>>1]=Ob}while(0);Jb=Aa+(((Nb|0)>0?Nb:0)+nb<<4<<1)|0;Hb=0;do{Ib=i+(mb*544|0)+(Hb<<1)|0;d[Ib>>1]=(j[Ib>>1]|0)-(j[Jb+(Hb<<1)>>1]|0);Hb=Hb+1|0}while((Hb|0)!=16);Hb=(j[i+(mb*544|0)+32+(Mb<<5)>>1]|0)+Lb|0;do if((Hb|0)>(Oa|0)){Yb=0;fa=256}else{Jb=(j[i+(mb*544|0)+32+(Mb<<5)+2>>1]|0)+Hb|0;if((Jb|0)>(Oa|0)){Yb=1;fa=256;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+4>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=2;fa=256;break}Jb=(j[i+(mb*544|0)+32+(Mb<<5)+6>>1]|0)+Nb|0;if((Jb|0)>(Oa|0)){Yb=3;fa=256;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+8>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=4;fa=256;break}Jb=(j[i+(mb*544|0)+32+(Mb<<5)+10>>1]|0)+Nb|0;if((Jb|0)>(Oa|0)){Yb=5;fa=256;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+12>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=6;fa=256;break}Jb=(j[i+(mb*544|0)+32+(Mb<<5)+14>>1]|0)+Nb|0;if((Jb|0)>(Oa|0)){Yb=7;fa=256;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+16>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=8;fa=256;break}Jb=(j[i+(mb*544|0)+32+(Mb<<5)+18>>1]|0)+Nb|0;if((Jb|0)>(Oa|0)){Yb=9;fa=256;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+20>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=10;fa=256;break}Jb=(j[i+(mb*544|0)+32+(Mb<<5)+22>>1]|0)+Nb|0;if((Jb|0)>(Oa|0)){Yb=11;fa=256;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+24>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=12;fa=256;break}Jb=(j[i+(mb*544|0)+32+(Mb<<5)+26>>1]|0)+Nb|0;if((Jb|0)>(Oa|0)){Yb=13;fa=256;break}Nb=(j[i+(mb*544|0)+32+(Mb<<5)+28>>1]|0)+Jb|0;if((Nb|0)>(Oa|0)){Yb=14;fa=256;break}if(((j[i+(mb*544|0)+32+(Mb<<5)+30>>1]|0)+Nb|0)>(Oa|0)){Yb=15;fa=256;break}f[o>>2]=0;f[Pa>>2]=0;Nb=aD(o,6)|0;b[Nb>>0]=b[240941]|0;b[Nb+1>>0]=b[240942]|0;b[Nb+2>>0]=b[240943]|0;b[Nb+3>>0]=b[240944]|0;b[Nb+4>>0]=b[240945]|0;b[Nb+5>>0]=b[240946]|0;bO(-215,o,240917,237558,2395);bD(o)}while(0);if((fa|0)==256){fa=0;Hb=db+(ob+(Y(Gb,Ka)|0))|0;b[Hb>>0]=Yb|Mb<<4}Gb=Gb+1|0}while((Gb|0)<(hb|0))}if((mb|0)<(ra|0))mb=mb+1|0;else break}kb=kb+1|0}while((kb|0)<(Ja|0))}Qa=Qa+Ea|0;_a=f[ia>>2]|0}while((_a|0)>(Qa|0));Qa=f[m>>2]|0;if(Qa|0){Zb=f[ka>>2]|0;_b=Qa;$b=Qa;fa=203}}else{Zb=qa;_b=Ha;$b=Ha;fa=203}if((fa|0)==203){if((Zb|0)!=(_b|0))f[ka>>2]=Zb+(~((Zb+-2-_b|0)>>>1)<<1);O5b($b)}Qa=f[l>>2]|0;if(Qa|0){_a=f[Ia>>2]|0;if((_a|0)!=(Qa|0))f[Ia>>2]=_a+(~((_a+-2-Qa|0)>>>1)<<1);O5b(Qa)}}else{if((f[ca>>2]|0)==(f[W>>2]|0)){Qa=i+8|0;f[Qa>>2]=0;f[Qa+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=Q;SP(N,i)}else{Qa=N+36|0;_a=f[Qa>>2]|0;if(_a){ia=_a+12|0;f[ia>>2]=(f[ia>>2]|0)+1;ia=Q+36|0;_a=f[ia>>2]|0;if((_a|0)!=0?(Ea=_a+12|0,_a=f[Ea>>2]|0,f[Ea>>2]=_a+-1,(_a|0)==1):0){kL(Q);ac=ia}else ac=ia}else ac=Q+36|0;f[ac>>2]=0;ia=Q+16|0;f[ia>>2]=0;f[ia+4>>2]=0;f[ia+8>>2]=0;f[ia+12>>2]=0;if((f[V>>2]|0)>0){_a=f[$>>2]|0;Ea=0;do{f[_a+(Ea<<2)>>2]=0;Ea=Ea+1|0;bc=f[V>>2]|0}while((Ea|0)<(bc|0));f[Q>>2]=f[aa>>2];if((bc|0)<3)fa=37;else fa=39}else{f[Q>>2]=f[aa>>2];fa=37}if((fa|0)==37){Ea=f[N+4>>2]|0;if((Ea|0)<3){f[V>>2]=Ea;f[_>>2]=f[U>>2];f[Q+12>>2]=f[O>>2];Ea=f[N+44>>2]|0;_a=f[Z>>2]|0;f[_a>>2]=f[Ea>>2];f[_a+4>>2]=f[Ea+4>>2]}else fa=39}if((fa|0)==39)jL(Q,N);f[ia>>2]=f[W>>2];f[Q+20>>2]=f[N+20>>2];f[Q+24>>2]=f[N+24>>2];f[Q+28>>2]=f[N+28>>2];f[Q+32>>2]=f[N+32>>2];f[ac>>2]=f[Qa>>2]}Ea=f[Q>>2]|0;switch(Ea&7){case 0:{H7(Q,P,e);break a;break}case 2:{_a=f[Q+16>>2]|0;Ia=f[ca>>2]|0;ka=(f[X>>2]|0)>>>1;Ha=(f[P+48>>2]|0)>>>1;qa=f[P+40>>2]|0;Ja=f[qa+4>>2]|0;ra=f[qa>>2]|0;qa=Ea>>>3;Ka=qa&511;Pa=Ka+1|0;b[i>>0]=0;e:do switch(e|0){case 3:{Oa=(ra|0)==1;if((Ja|0)==1|Oa){Aa=ra+Ja|0;za=Aa+-1|0;Ca=Oa?Pa:ka;La=Oa?0:ka-Pa|0;Na=Oa?Pa:Ha;if((Aa|0)<=1)break e;Oa=0-Ca|0;pa=Aa+-2|0;Aa=Ia;ga=0;ea=_a;while(1){la=(ga|0)>0?Oa:0;oa=(ga|0)<(pa|0)?Ca:0;sa=0;na=ea;while(1){wa=d[na+(la<<1)>>1]|0;va=d[na>>1]|0;ta=j[na+(oa<<1)>>1]|0;Ga=(va&65535)<(wa&65535);ua=(Ga?va:wa)&65535;Fa=(Ga?wa:va)&65535;va=ta>>>0<Fa>>>0?ta:Fa;d[Aa+(sa<<1)>>1]=(va|0)<(ua|0)?ua:va;sa=sa+1|0;if((sa|0)==(Pa|0))break;else na=na+2|0}ga=ga+1|0;if((ga|0)>=(za|0))break e;else{Aa=Aa+(Na<<1)|0;ea=ea+(Pa<<1)+(La<<1)|0}}}La=Y(Ja,Pa)|0;if((ra|0)>0){ea=ra+-1|0;Na=(qa|-512)^511;Aa=Na+-1+La|0;za=La-Pa|0;ga=Ia;Ca=0;while(1){pa=Ca+-1|0;Oa=_a+((Y((pa|0)>0?pa:0,ka)|0)<<1)|0;pa=_a+((Y(Ca,ka)|0)<<1)|0;Ca=Ca+1|0;na=_a+((Y((ea|0)<(Ca|0)?ea:Ca,ka)|0)<<1)|0;sa=b[i>>0]&1?Pa:La;oa=0;f:while(1){if((oa|0)<(sa|0)){la=oa;do{va=la-((la|0)>(Ka|0)?Pa:0)|0;ua=((la|0)<(za|0)?Pa:0)+la|0;Fa=d[Oa+(va<<1)>>1]|0;ta=d[Oa+(la<<1)>>1]|0;wa=d[Oa+(ua<<1)>>1]|0;Ga=d[pa+(va<<1)>>1]|0;xa=d[pa+(la<<1)>>1]|0;ya=d[pa+(ua<<1)>>1]|0;Da=d[na+(va<<1)>>1]|0;va=d[na+(la<<1)>>1]|0;ja=d[na+(ua<<1)>>1]|0;ua=(wa&65535)<(ta&65535);Ba=ua?wa:ta;kb=ua?ta:wa;wa=(ya&65535)<(xa&65535);ta=wa?ya:xa;ua=wa?xa:ya;ya=(ja&65535)<(va&65535);xa=ya?ja:va;wa=ya?va:ja;ja=(Ba&65535)<(Fa&65535);va=(ja?Ba:Fa)&65535;ya=ja?Fa:Ba;Ba=(ta&65535)<(Ga&65535);Fa=(Ba?ta:Ga)&65535;ja=Ba?Ga:ta;ta=(xa&65535)<(Da&65535);Ga=(ta?xa:Da)&65535;Ba=ta?Da:xa;xa=(kb&65535)<(ya&65535);Da=(xa?kb:ya)&65535;ta=(xa?ya:kb)&65535;kb=(ua&65535)<(ja&65535);ya=kb?ua:ja;xa=(kb?ja:ua)&65535;ua=(wa&65535)<(Ba&65535);ja=ua?wa:Ba;kb=(ua?Ba:wa)&65535;wa=Fa>>>0<va>>>0?va:Fa;Fa=kb>>>0<xa>>>0?kb:xa;xa=(ja&65535)<(ya&65535);kb=(xa?ja:ya)&65535;va=(xa?ya:ja)&65535;ja=(Ga|0)<(wa|0)?wa:Ga;Ga=kb>>>0<Da>>>0?Da:kb;kb=(Fa|0)<(ta|0)?Fa:ta;ta=(va|0)<(Ga|0)?va:Ga;Ga=(kb|0)<(ta|0);va=Ga?kb:ta;Fa=Ga?ta:kb;kb=(va|0)<(ja|0)?ja:va;d[ga+(la<<1)>>1]=(Fa|0)<(kb|0)?Fa:kb;la=la+1|0}while((la|0)!=(sa|0));cc=sa}else cc=oa;if((sa|0)==(La|0))break;if((cc|0)>(Aa|0)){sa=La;oa=cc;continue}else dc=cc;while(1){la=Oa+(dc<<1)|0;kb=d[la+(Na<<1)>>1]|0;Fa=d[la>>1]|0;va=d[la+(Pa<<1)>>1]|0;la=pa+(dc<<1)|0;ja=d[la+(Na<<1)>>1]|0;ta=d[la>>1]|0;Ga=d[la+(Pa<<1)>>1]|0;la=na+(dc<<1)|0;Da=d[la+(Na<<1)>>1]|0;wa=d[la>>1]|0;ya=d[la+(Pa<<1)>>1]|0;la=(va&65535)<(Fa&65535);xa=la?va:Fa;Ba=la?Fa:va;va=(Ga&65535)<(ta&65535);Fa=va?Ga:ta;la=va?ta:Ga;Ga=(ya&65535)<(wa&65535);ta=Ga?ya:wa;va=Ga?wa:ya;ya=(xa&65535)<(kb&65535);wa=(ya?xa:kb)&65535;Ga=ya?kb:xa;xa=(Fa&65535)<(ja&65535);kb=(xa?Fa:ja)&65535;ya=xa?ja:Fa;Fa=(ta&65535)<(Da&65535);ja=(Fa?ta:Da)&65535;xa=Fa?Da:ta;ta=(Ba&65535)<(Ga&65535);Da=(ta?Ba:Ga)&65535;Fa=(ta?Ga:Ba)&65535;Ba=(la&65535)<(ya&65535);Ga=Ba?la:ya;ta=(Ba?ya:la)&65535;la=(va&65535)<(xa&65535);ya=la?va:xa;Ba=(la?xa:va)&65535;va=kb>>>0<wa>>>0?wa:kb;kb=Ba>>>0<ta>>>0?Ba:ta;ta=(ya&65535)<(Ga&65535);Ba=(ta?ya:Ga)&65535;wa=(ta?Ga:ya)&65535;ya=(ja|0)<(va|0)?va:ja;ja=Ba>>>0<Da>>>0?Da:Ba;Ba=(kb|0)<(Fa|0)?kb:Fa;Fa=(wa|0)<(ja|0)?wa:ja;ja=(Ba|0)<(Fa|0);wa=ja?Ba:Fa;kb=ja?Fa:Ba;Ba=(wa|0)<(ya|0)?ya:wa;d[ga+(dc<<1)>>1]=(kb|0)<(Ba|0)?kb:Ba;Ba=dc+1|0;if((dc|0)<(Aa|0))dc=Ba;else{sa=La;oa=Ba;continue f}}}if((Ca|0)==(ra|0))break;else ga=ga+(Ha<<1)|0}}break}case 5:{ga=(ra|0)==1;if((Ja|0)==1|ga){Ca=ra+Ja|0;La=Ca+-1|0;Aa=ga?Pa:ka;Na=ga?0:ka-Pa|0;za=ga?Pa:Ha;if((Ca|0)<=1)break e;ga=0-Aa|0;ea=ga<<1;oa=Ca+-2|0;sa=Ca+-3|0;Ca=Aa<<1;na=Ia;pa=0;Oa=_a;while(1){Ba=(pa|0)>0?ga:0;kb=(pa|0)>1?ea:Ba;wa=(pa|0)<(oa|0)?Aa:0;ya=(pa|0)<(sa|0)?Ca:wa;Fa=Oa;ja=0;while(1){Da=d[Fa+(kb<<1)>>1]|0;va=d[Fa+(Ba<<1)>>1]|0;Ga=d[Fa>>1]|0;ta=d[Fa+(wa<<1)>>1]|0;xa=d[Fa+(ya<<1)>>1]|0;la=(va&65535)<(Da&65535);ua=(la?va:Da)&65535;hb=(la?Da:va)&65535;va=(xa&65535)<(ta&65535);Da=va?xa:ta;la=va?ta:xa;xa=(Da&65535)<(Ga&65535);ta=(xa?Da:Ga)&65535;va=xa?Ga:Da;Da=(la&65535)<(va&65535);Ga=(Da?la:va)&65535;xa=(Da?va:la)&65535;la=ta>>>0<ua>>>0?ua:ta;ta=(xa|0)<(la|0)?xa:la;la=Ga>>>0<hb>>>0?Ga:hb;d[na+(ja<<1)>>1]=(ta|0)<(la|0)?la:ta;ja=ja+1|0;if((ja|0)==(Pa|0))break;else Fa=Fa+2|0}pa=pa+1|0;if((pa|0)>=(La|0))break e;else{na=na+(za<<1)|0;Oa=Oa+(Pa<<1)+(Na<<1)|0}}}Na=Y(Ja,Pa)|0;if((ra|0)>0){Oa=ra+-1|0;za=Pa<<1;na=0-za|0;La=Na+~za|0;pa=(qa|-512)^511;Ca=Na-Pa|0;sa=Na-za|0;Aa=Ia;oa=0;while(1){ea=oa+-2|0;ga=_a+((Y((ea|0)>0?ea:0,ka)|0)<<1)|0;ea=oa+-1|0;Fa=_a+((Y((ea|0)>0?ea:0,ka)|0)<<1)|0;ea=_a+((Y(oa,ka)|0)<<1)|0;ja=oa;oa=oa+1|0;ya=_a+((Y((Oa|0)<(oa|0)?Oa:oa,ka)|0)<<1)|0;wa=ja+2|0;ja=_a+((Y((Oa|0)<(wa|0)?Oa:wa,ka)|0)<<1)|0;wa=b[i>>0]&1?za:Na;Ba=0;g:while(1){if((Ba|0)<(wa|0)){kb=Ba;do{ta=kb-((kb|0)>(Ka|0)?Pa:0)|0;la=(kb|0)<(za|0)?ta:kb-za|0;hb=((kb|0)<(Ca|0)?Pa:0)+kb|0;Ga=(kb|0)<(sa|0)?kb+za|0:hb;xa=d[ga+(la<<1)>>1]|0;ua=d[ga+(ta<<1)>>1]|0;va=d[ga+(kb<<1)>>1]|0;Da=d[ga+(hb<<1)>>1]|0;db=d[ga+(Ga<<1)>>1]|0;ab=d[Fa+(la<<1)>>1]|0;Va=d[Fa+(ta<<1)>>1]|0;bb=d[Fa+(kb<<1)>>1]|0;Ua=d[Fa+(hb<<1)>>1]|0;cb=d[Fa+(Ga<<1)>>1]|0;Ma=d[ea+(la<<1)>>1]|0;Xa=d[ea+(ta<<1)>>1]|0;Ya=d[ea+(kb<<1)>>1]|0;mb=d[ea+(hb<<1)>>1]|0;jb=d[ea+(Ga<<1)>>1]|0;lb=d[ya+(la<<1)>>1]|0;$a=d[ya+(ta<<1)>>1]|0;Gb=d[ya+(kb<<1)>>1]|0;ob=d[ya+(hb<<1)>>1]|0;nb=d[ya+(Ga<<1)>>1]|0;Fb=d[ja+(la<<1)>>1]|0;la=d[ja+(ta<<1)>>1]|0;ta=d[ja+(kb<<1)>>1]|0;Eb=d[ja+(hb<<1)>>1]|0;hb=d[ja+(Ga<<1)>>1]|0;Ga=(va&65535)<(ua&65535)?va:ua;Db=(va&65535)>(ua&65535)?va:ua;ua=(Ga&65535)<(xa&65535);va=ua?Ga:xa;Cb=ua?xa:Ga;Ga=(Db&65535)<(Cb&65535);xa=Ga?Db:Cb;ua=Ga?Cb:Db;Db=(ab&65535)<(db&65535);Cb=Db?ab:db;Ga=Db?db:ab;ab=(Cb&65535)<(Da&65535);db=ab?Cb:Da;Db=ab?Da:Cb;Cb=(Ga&65535)<(Db&65535);Da=Cb?Ga:Db;ab=Cb?Db:Ga;Ga=(db&65535)<(va&65535);Db=Ga?db:va;Cb=Ga?va:db;db=(ab&65535)<(ua&65535);va=db?ab:ua;Ga=db?ua:ab;ab=(Cb&65535)<(va&65535);ua=ab?Cb:va;db=ab?va:Cb;Cb=(Da&65535)<(xa&65535);va=Cb?Da:xa;ab=Cb?xa:Da;Da=(ua&65535)<(va&65535);xa=Da?ua:va;Cb=Da?va:ua;ua=(ab&65535)<(db&65535);va=ua?ab:db;Da=ua?db:ab;ab=(Ua&65535)<(bb&65535);db=ab?Ua:bb;ua=ab?bb:Ua;Ua=(db&65535)<(Va&65535);bb=Ua?db:Va;ab=Ua?Va:db;db=(ua&65535)<(ab&65535);Va=db?ua:ab;Ua=db?ab:ua;ua=(Xa&65535)<(Ma&65535);ab=ua?Xa:Ma;db=ua?Ma:Xa;Xa=(ab&65535)<(cb&65535);Ma=Xa?ab:cb;ua=Xa?cb:ab;ab=(db&65535)<(ua&65535);cb=ab?db:ua;Xa=ab?ua:db;db=(Ma&65535)<(bb&65535);ua=db?Ma:bb;ab=db?bb:Ma;Ma=(Xa&65535)<(Ua&65535);bb=Ma?Xa:Ua;db=Ma?Ua:Xa;Xa=(ab&65535)<(bb&65535);Ua=Xa?ab:bb;Ma=Xa?bb:ab;ab=(cb&65535)<(Va&65535);bb=ab?cb:Va;Xa=ab?Va:cb;cb=(Ua&65535)<(bb&65535);Va=cb?Ua:bb;ab=cb?bb:Ua;Ua=(Xa&65535)<(Ma&65535);bb=Ua?Xa:Ma;cb=Ua?Ma:Xa;Xa=(ua&65535)<(Db&65535);Ma=(Xa?ua:Db)&65535;Ua=Xa?Db:ua;ua=(cb&65535)<(Da&65535);Db=ua?cb:Da;Xa=ua?Da:cb;cb=(Ua&65535)<(Db&65535);Da=cb?Ua:Db;ua=cb?Db:Ua;Ua=(ab&65535)<(Cb&65535);Db=Ua?ab:Cb;cb=Ua?Cb:ab;ab=(Da&65535)<(Db&65535);Cb=ab?Da:Db;Ua=ab?Db:Da;Da=(cb&65535)<(ua&65535);Db=Da?cb:ua;ab=Da?ua:cb;cb=(Va&65535)<(xa&65535);ua=cb?Va:xa;Da=cb?xa:Va;Va=(db&65535)<(Ga&65535);xa=Va?db:Ga;cb=(Va?Ga:db)&65535;db=(Da&65535)<(xa&65535);Ga=db?Da:xa;Va=db?xa:Da;Da=(bb&65535)<(va&65535);xa=Da?bb:va;db=Da?va:bb;bb=(Ga&65535)<(xa&65535);va=bb?Ga:xa;Da=bb?xa:Ga;Ga=(db&65535)<(Va&65535);xa=Ga?db:Va;bb=Ga?Va:db;db=(Cb&65535)<(ua&65535);Va=(db?Cb:ua)&65535;Ga=(db?ua:Cb)&65535;Cb=(Ua&65535)<(va&65535);ua=(Cb?Ua:va)&65535;db=(Cb?va:Ua)&65535;Ua=(Db&65535)<(Da&65535);va=(Ua?Db:Da)&65535;Cb=(Ua?Da:Db)&65535;Db=(ab&65535)<(xa&65535);Da=(Db?ab:xa)&65535;Ua=(Db?xa:ab)&65535;ab=(Xa&65535)<(bb&65535);xa=(ab?Xa:bb)&65535;Db=(ab?bb:Xa)&65535;Xa=(jb&65535)<(mb&65535);bb=Xa?jb:mb;ab=Xa?mb:jb;jb=(bb&65535)<(Ya&65535);mb=jb?bb:Ya;Xa=jb?Ya:bb;bb=(ab&65535)<(Xa&65535);Ya=bb?ab:Xa;jb=bb?Xa:ab;ab=(Gb&65535)<($a&65535);Xa=ab?Gb:$a;bb=ab?$a:Gb;Gb=(Xa&65535)<(lb&65535);$a=Gb?Xa:lb;ab=Gb?lb:Xa;Xa=(bb&65535)<(ab&65535);lb=Xa?bb:ab;Gb=Xa?ab:bb;bb=($a&65535)<(mb&65535);ab=bb?$a:mb;Xa=bb?mb:$a;$a=(Gb&65535)<(jb&65535);mb=$a?Gb:jb;bb=$a?jb:Gb;Gb=(Xa&65535)<(mb&65535);jb=Gb?Xa:mb;$a=Gb?mb:Xa;Xa=(lb&65535)<(Ya&65535);mb=Xa?lb:Ya;Gb=Xa?Ya:lb;lb=(jb&65535)<(mb&65535);Ya=lb?jb:mb;Xa=lb?mb:jb;jb=(Gb&65535)<($a&65535);mb=jb?Gb:$a;lb=jb?$a:Gb;Gb=(Fb&65535)<(nb&65535);$a=Gb?Fb:nb;jb=Gb?nb:Fb;Fb=($a&65535)<(ob&65535);nb=Fb?$a:ob;Gb=Fb?ob:$a;$a=(jb&65535)<(Gb&65535);ob=$a?jb:Gb;Fb=$a?Gb:jb;jb=(ta&65535)<(la&65535);Gb=jb?ta:la;$a=jb?la:ta;ta=(hb&65535)<(Eb&65535);la=ta?hb:Eb;jb=ta?Eb:hb;hb=(la&65535)<(Gb&65535);Eb=hb?la:Gb;ta=hb?Gb:la;la=(jb&65535)<($a&65535);Gb=la?jb:$a;hb=la?$a:jb;jb=(ta&65535)<(Gb&65535);$a=jb?ta:Gb;la=jb?Gb:ta;ta=(Eb&65535)<(nb&65535);Gb=ta?Eb:nb;jb=ta?nb:Eb;Eb=(la&65535)<(Fb&65535);nb=Eb?la:Fb;ta=Eb?Fb:la;la=(jb&65535)<(nb&65535);Fb=la?jb:nb;Eb=la?nb:jb;jb=($a&65535)<(ob&65535);nb=jb?$a:ob;la=jb?ob:$a;$a=(hb&65535)<(la&65535);ob=$a?hb:la;jb=$a?la:hb;hb=(Fb&65535)<(nb&65535);la=hb?Fb:nb;$a=hb?nb:Fb;Fb=(ob&65535)<(Eb&65535);nb=Fb?ob:Eb;hb=Fb?Eb:ob;ob=(jb&65535)<(ta&65535);Eb=ob?jb:ta;Fb=ob?ta:jb;jb=(Gb&65535)<(ab&65535);ta=(jb?Gb:ab)&65535;ob=jb?ab:Gb;Gb=(hb&65535)<(lb&65535);ab=Gb?hb:lb;jb=Gb?lb:hb;hb=(ob&65535)<(ab&65535);lb=hb?ob:ab;Gb=hb?ab:ob;ob=($a&65535)<(Xa&65535);ab=ob?$a:Xa;hb=ob?Xa:$a;$a=(Fb&65535)<(hb&65535);Xa=$a?Fb:hb;ob=$a?hb:Fb;Fb=(lb&65535)<(ab&65535);hb=Fb?lb:ab;$a=Fb?ab:lb;lb=(Xa&65535)<(Gb&65535);ab=lb?Xa:Gb;Fb=lb?Gb:Xa;Xa=(ob&65535)<(jb&65535);Gb=Xa?ob:jb;lb=Xa?jb:ob;ob=(la&65535)<(Ya&65535);jb=ob?la:Ya;Xa=ob?Ya:la;la=(Eb&65535)<(bb&65535);Ya=la?Eb:bb;ob=la?bb:Eb;Eb=(Xa&65535)<(Ya&65535);bb=Eb?Xa:Ya;la=Eb?Ya:Xa;Xa=(nb&65535)<(mb&65535);Ya=Xa?nb:mb;Eb=Xa?mb:nb;nb=(bb&65535)<(Ya&65535);mb=nb?bb:Ya;Xa=nb?Ya:bb;bb=(Eb&65535)<(la&65535);Ya=bb?Eb:la;nb=bb?la:Eb;Eb=(hb&65535)<(jb&65535);la=(Eb?hb:jb)&65535;bb=(Eb?jb:hb)&65535;hb=($a&65535)<(mb&65535);jb=(hb?$a:mb)&65535;Eb=(hb?mb:$a)&65535;$a=(ab&65535)<(Xa&65535);mb=($a?ab:Xa)&65535;hb=($a?Xa:ab)&65535;ab=(Fb&65535)<(Ya&65535);Xa=(ab?Fb:Ya)&65535;$a=(ab?Ya:Fb)&65535;Fb=(Gb&65535)<(nb&65535);Ya=(Fb?Gb:nb)&65535;ab=(Fb?nb:Gb)&65535;Gb=(lb&65535)<(ob&65535);nb=(Gb?lb:ob)&65535;Fb=(Gb?ob:lb)&65535;lb=ta>>>0<Ma>>>0?Ma:ta;ta=$a>>>0<Ua>>>0?$a:Ua;Ua=(lb|0)<(ta|0)?ta:lb;lb=Eb>>>0<db>>>0?db:Eb;Eb=(Fb|0)<(lb|0)?Fb:lb;lb=(Eb|0)<(Ua|0)?Eb:Ua;Ua=bb>>>0<Ga>>>0?Ga:bb;bb=ab>>>0<Db>>>0?ab:Db;Db=(Ua|0)<(bb|0)?Ua:bb;bb=hb>>>0<Cb>>>0?hb:Cb;Cb=(Db|0)<(bb|0)?bb:Db;Db=(lb|0)<(Cb|0)?Cb:lb;lb=la>>>0<Va>>>0?Va:la;la=Ya>>>0<xa>>>0?Ya:xa;xa=(lb|0)<(la|0)?la:lb;lb=mb>>>0<va>>>0?va:mb;mb=(lb|0)<(xa|0)?lb:xa;xa=jb>>>0<ua>>>0?ua:jb;jb=nb>>>0<cb>>>0?nb:cb;cb=(xa|0)<(jb|0)?xa:jb;jb=Xa>>>0<Da>>>0?Xa:Da;Da=(cb|0)<(jb|0)?jb:cb;cb=(mb|0)<(Da|0)?mb:Da;d[Aa+(kb<<1)>>1]=(Db|0)<(cb|0)?cb:Db;kb=kb+1|0}while((kb|0)!=(wa|0));ec=wa}else ec=Ba;if((wa|0)==(Na|0))break;if((ec|0)>(La|0)){wa=Na;Ba=ec;continue}else fc=ec;while(1){kb=ga+(fc<<1)|0;Db=d[kb+(na<<1)>>1]|0;cb=d[kb+(pa<<1)>>1]|0;Da=d[kb>>1]|0;mb=d[kb+(Pa<<1)>>1]|0;jb=d[kb+(za<<1)>>1]|0;kb=Fa+(fc<<1)|0;Xa=d[kb+(na<<1)>>1]|0;xa=d[kb+(pa<<1)>>1]|0;nb=d[kb>>1]|0;ua=d[kb+(Pa<<1)>>1]|0;lb=d[kb+(za<<1)>>1]|0;kb=ea+(fc<<1)|0;va=d[kb+(na<<1)>>1]|0;la=d[kb+(pa<<1)>>1]|0;Ya=d[kb>>1]|0;Va=d[kb+(Pa<<1)>>1]|0;Cb=d[kb+(za<<1)>>1]|0;kb=ya+(fc<<1)|0;bb=d[kb+(na<<1)>>1]|0;hb=d[kb+(pa<<1)>>1]|0;Ua=d[kb>>1]|0;ab=d[kb+(Pa<<1)>>1]|0;Ga=d[kb+(za<<1)>>1]|0;kb=ja+(fc<<1)|0;Eb=d[kb+(na<<1)>>1]|0;Fb=d[kb+(pa<<1)>>1]|0;db=d[kb>>1]|0;ta=d[kb+(Pa<<1)>>1]|0;$a=d[kb+(za<<1)>>1]|0;kb=(Da&65535)<(cb&65535)?Da:cb;Ma=(Da&65535)>(cb&65535)?Da:cb;cb=(kb&65535)<(Db&65535);Da=cb?kb:Db;ob=cb?Db:kb;kb=(Ma&65535)<(ob&65535);Db=kb?Ma:ob;cb=kb?ob:Ma;Ma=(Xa&65535)<(jb&65535);ob=Ma?Xa:jb;kb=Ma?jb:Xa;Xa=(ob&65535)<(mb&65535);jb=Xa?ob:mb;Ma=Xa?mb:ob;ob=(kb&65535)<(Ma&65535);mb=ob?kb:Ma;Xa=ob?Ma:kb;kb=(jb&65535)<(Da&65535);Ma=kb?jb:Da;ob=kb?Da:jb;jb=(Xa&65535)<(cb&65535);Da=jb?Xa:cb;kb=jb?cb:Xa;Xa=(ob&65535)<(Da&65535);cb=Xa?ob:Da;jb=Xa?Da:ob;ob=(mb&65535)<(Db&65535);Da=ob?mb:Db;Xa=ob?Db:mb;mb=(cb&65535)<(Da&65535);Db=mb?cb:Da;ob=mb?Da:cb;cb=(Xa&65535)<(jb&65535);Da=cb?Xa:jb;mb=cb?jb:Xa;Xa=(ua&65535)<(nb&65535);jb=Xa?ua:nb;cb=Xa?nb:ua;ua=(jb&65535)<(xa&65535);nb=ua?jb:xa;Xa=ua?xa:jb;jb=(cb&65535)<(Xa&65535);xa=jb?cb:Xa;ua=jb?Xa:cb;cb=(la&65535)<(va&65535);Xa=cb?la:va;jb=cb?va:la;la=(Xa&65535)<(lb&65535);va=la?Xa:lb;cb=la?lb:Xa;Xa=(jb&65535)<(cb&65535);lb=Xa?jb:cb;la=Xa?cb:jb;jb=(va&65535)<(nb&65535);cb=jb?va:nb;Xa=jb?nb:va;va=(la&65535)<(ua&65535);nb=va?la:ua;jb=va?ua:la;la=(Xa&65535)<(nb&65535);ua=la?Xa:nb;va=la?nb:Xa;Xa=(lb&65535)<(xa&65535);nb=Xa?lb:xa;la=Xa?xa:lb;lb=(ua&65535)<(nb&65535);xa=lb?ua:nb;Xa=lb?nb:ua;ua=(la&65535)<(va&65535);nb=ua?la:va;lb=ua?va:la;la=(cb&65535)<(Ma&65535);va=(la?cb:Ma)&65535;ua=la?Ma:cb;cb=(lb&65535)<(mb&65535);Ma=cb?lb:mb;la=cb?mb:lb;lb=(ua&65535)<(Ma&65535);mb=lb?ua:Ma;cb=lb?Ma:ua;ua=(Xa&65535)<(ob&65535);Ma=ua?Xa:ob;lb=ua?ob:Xa;Xa=(mb&65535)<(Ma&65535);ob=Xa?mb:Ma;ua=Xa?Ma:mb;mb=(lb&65535)<(cb&65535);Ma=mb?lb:cb;Xa=mb?cb:lb;lb=(xa&65535)<(Db&65535);cb=lb?xa:Db;mb=lb?Db:xa;xa=(jb&65535)<(kb&65535);Db=xa?jb:kb;lb=(xa?kb:jb)&65535;jb=(mb&65535)<(Db&65535);kb=jb?mb:Db;xa=jb?Db:mb;mb=(nb&65535)<(Da&65535);Db=mb?nb:Da;jb=mb?Da:nb;nb=(kb&65535)<(Db&65535);Da=nb?kb:Db;mb=nb?Db:kb;kb=(jb&65535)<(xa&65535);Db=kb?jb:xa;nb=kb?xa:jb;jb=(ob&65535)<(cb&65535);xa=(jb?ob:cb)&65535;kb=(jb?cb:ob)&65535;ob=(ua&65535)<(Da&65535);cb=(ob?ua:Da)&65535;jb=(ob?Da:ua)&65535;ua=(Ma&65535)<(mb&65535);Da=(ua?Ma:mb)&65535;ob=(ua?mb:Ma)&65535;Ma=(Xa&65535)<(Db&65535);mb=(Ma?Xa:Db)&65535;ua=(Ma?Db:Xa)&65535;Xa=(la&65535)<(nb&65535);Db=(Xa?la:nb)&65535;Ma=(Xa?nb:la)&65535;la=(Cb&65535)<(Va&65535);nb=la?Cb:Va;Xa=la?Va:Cb;Cb=(nb&65535)<(Ya&65535);Va=Cb?nb:Ya;la=Cb?Ya:nb;nb=(Xa&65535)<(la&65535);Ya=nb?Xa:la;Cb=nb?la:Xa;Xa=(Ua&65535)<(hb&65535);la=Xa?Ua:hb;nb=Xa?hb:Ua;Ua=(la&65535)<(bb&65535);hb=Ua?la:bb;Xa=Ua?bb:la;la=(nb&65535)<(Xa&65535);bb=la?nb:Xa;Ua=la?Xa:nb;nb=(hb&65535)<(Va&65535);Xa=nb?hb:Va;la=nb?Va:hb;hb=(Ua&65535)<(Cb&65535);Va=hb?Ua:Cb;nb=hb?Cb:Ua;Ua=(la&65535)<(Va&65535);Cb=Ua?la:Va;hb=Ua?Va:la;la=(bb&65535)<(Ya&65535);Va=la?bb:Ya;Ua=la?Ya:bb;bb=(Cb&65535)<(Va&65535);Ya=bb?Cb:Va;la=bb?Va:Cb;Cb=(Ua&65535)<(hb&65535);Va=Cb?Ua:hb;bb=Cb?hb:Ua;Ua=(Eb&65535)<(Ga&65535);hb=Ua?Eb:Ga;Cb=Ua?Ga:Eb;Eb=(hb&65535)<(ab&65535);Ga=Eb?hb:ab;Ua=Eb?ab:hb;hb=(Cb&65535)<(Ua&65535);ab=hb?Cb:Ua;Eb=hb?Ua:Cb;Cb=(db&65535)<(Fb&65535);Ua=Cb?db:Fb;hb=Cb?Fb:db;db=($a&65535)<(ta&65535);Fb=db?$a:ta;Cb=db?ta:$a;$a=(Fb&65535)<(Ua&65535);ta=$a?Fb:Ua;db=$a?Ua:Fb;Fb=(Cb&65535)<(hb&65535);Ua=Fb?Cb:hb;$a=Fb?hb:Cb;Cb=(db&65535)<(Ua&65535);hb=Cb?db:Ua;Fb=Cb?Ua:db;db=(ta&65535)<(Ga&65535);Ua=db?ta:Ga;Cb=db?Ga:ta;ta=(Fb&65535)<(Eb&65535);Ga=ta?Fb:Eb;db=ta?Eb:Fb;Fb=(Cb&65535)<(Ga&65535);Eb=Fb?Cb:Ga;ta=Fb?Ga:Cb;Cb=(hb&65535)<(ab&65535);Ga=Cb?hb:ab;Fb=Cb?ab:hb;hb=($a&65535)<(Fb&65535);ab=hb?$a:Fb;Cb=hb?Fb:$a;$a=(Eb&65535)<(Ga&65535);Fb=$a?Eb:Ga;hb=$a?Ga:Eb;Eb=(ab&65535)<(ta&65535);Ga=Eb?ab:ta;$a=Eb?ta:ab;ab=(Cb&65535)<(db&65535);ta=ab?Cb:db;Eb=ab?db:Cb;Cb=(Ua&65535)<(Xa&65535);db=(Cb?Ua:Xa)&65535;ab=Cb?Xa:Ua;Ua=($a&65535)<(bb&65535);Xa=Ua?$a:bb;Cb=Ua?bb:$a;$a=(ab&65535)<(Xa&65535);bb=$a?ab:Xa;Ua=$a?Xa:ab;ab=(hb&65535)<(la&65535);Xa=ab?hb:la;$a=ab?la:hb;hb=(Eb&65535)<($a&65535);la=hb?Eb:$a;ab=hb?$a:Eb;Eb=(bb&65535)<(Xa&65535);$a=Eb?bb:Xa;hb=Eb?Xa:bb;bb=(la&65535)<(Ua&65535);Xa=bb?la:Ua;Eb=bb?Ua:la;la=(ab&65535)<(Cb&65535);Ua=la?ab:Cb;bb=la?Cb:ab;ab=(Fb&65535)<(Ya&65535);Cb=ab?Fb:Ya;la=ab?Ya:Fb;Fb=(ta&65535)<(nb&65535);Ya=Fb?ta:nb;ab=Fb?nb:ta;ta=(la&65535)<(Ya&65535);nb=ta?la:Ya;Fb=ta?Ya:la;la=(Ga&65535)<(Va&65535);Ya=la?Ga:Va;ta=la?Va:Ga;Ga=(nb&65535)<(Ya&65535);Va=Ga?nb:Ya;la=Ga?Ya:nb;nb=(ta&65535)<(Fb&65535);Ya=nb?ta:Fb;Ga=nb?Fb:ta;ta=($a&65535)<(Cb&65535);Fb=(ta?$a:Cb)&65535;nb=(ta?Cb:$a)&65535;$a=(hb&65535)<(Va&65535);Cb=($a?hb:Va)&65535;ta=($a?Va:hb)&65535;hb=(Xa&65535)<(la&65535);Va=(hb?Xa:la)&65535;$a=(hb?la:Xa)&65535;Xa=(Eb&65535)<(Ya&65535);la=(Xa?Eb:Ya)&65535;hb=(Xa?Ya:Eb)&65535;Eb=(Ua&65535)<(Ga&65535);Ya=(Eb?Ua:Ga)&65535;Xa=(Eb?Ga:Ua)&65535;Ua=(bb&65535)<(ab&65535);Ga=(Ua?bb:ab)&65535;Eb=(Ua?ab:bb)&65535;bb=db>>>0<va>>>0?va:db;db=hb>>>0<ua>>>0?hb:ua;ua=(bb|0)<(db|0)?db:bb;bb=ta>>>0<jb>>>0?jb:ta;ta=(Eb|0)<(bb|0)?Eb:bb;bb=(ta|0)<(ua|0)?ta:ua;ua=nb>>>0<kb>>>0?kb:nb;nb=Xa>>>0<Ma>>>0?Xa:Ma;Ma=(ua|0)<(nb|0)?ua:nb;nb=$a>>>0<ob>>>0?$a:ob;ob=(Ma|0)<(nb|0)?nb:Ma;Ma=(bb|0)<(ob|0)?ob:bb;bb=Fb>>>0<xa>>>0?xa:Fb;Fb=Ya>>>0<Db>>>0?Ya:Db;Db=(bb|0)<(Fb|0)?Fb:bb;bb=Va>>>0<Da>>>0?Da:Va;Va=(bb|0)<(Db|0)?bb:Db;Db=Cb>>>0<cb>>>0?cb:Cb;Cb=Ga>>>0<lb>>>0?Ga:lb;lb=(Db|0)<(Cb|0)?Db:Cb;Cb=la>>>0<mb>>>0?la:mb;mb=(lb|0)<(Cb|0)?Cb:lb;lb=(Va|0)<(mb|0)?Va:mb;d[Aa+(fc<<1)>>1]=(Ma|0)<(lb|0)?lb:Ma;Ma=fc+1|0;if((fc|0)<(La|0))fc=Ma;else{wa=Na;Ba=Ma;continue g}}}if((oa|0)==(ra|0))break;else Aa=Aa+(Ha<<1)|0}}break}default:{}}while(0);break a;break}case 3:{Ha=f[Q+16>>2]|0;ra=f[ca>>2]|0;Pa=(f[X>>2]|0)>>>1;Ka=(f[P+48>>2]|0)>>>1;ka=f[P+40>>2]|0;_a=f[ka+4>>2]|0;Ia=f[ka>>2]|0;ka=Ea>>>3;qa=ka&511;Ja=qa+1|0;b[i>>0]=0;h:do switch(e|0){case 3:{Qa=(Ia|0)==1;if((_a|0)==1|Qa){ia=Ia+_a|0;Aa=ia+-1|0;oa=Qa?Ja:Pa;Na=Qa?0:Pa-Ja|0;La=Qa?Ja:Ka;if((ia|0)<=1)break h;Qa=0-oa|0;za=ia+-2|0;ia=ra;pa=0;na=Ha;while(1){sa=(pa|0)>0?Qa:0;Ca=(pa|0)<(za|0)?oa:0;Oa=0;Ba=na;while(1){wa=d[Ba+(sa<<1)>>1]|0;ja=d[Ba>>1]|0;ya=d[Ba+(Ca<<1)>>1]|0;ea=ja<<16>>16<wa<<16>>16;Fa=(ea?ja:wa)<<16>>16;ga=(ea?wa:ja)<<16>>16;ja=(ya|0)<(ga|0)?ya:ga;d[ia+(Oa<<1)>>1]=(ja|0)<(Fa|0)?Fa:ja;Oa=Oa+1|0;if((Oa|0)==(Ja|0))break;else Ba=Ba+2|0}pa=pa+1|0;if((pa|0)>=(Aa|0))break h;else{ia=ia+(La<<1)|0;na=na+(Ja<<1)+(Na<<1)|0}}}Na=Y(_a,Ja)|0;if((Ia|0)>0){na=Ia+-1|0;La=(ka|-512)^511;ia=La+-1+Na|0;Aa=Na-Ja|0;pa=ra;oa=0;while(1){za=oa+-1|0;Qa=Ha+((Y((za|0)>0?za:0,Pa)|0)<<1)|0;za=Ha+((Y(oa,Pa)|0)<<1)|0;oa=oa+1|0;Ba=Ha+((Y((na|0)<(oa|0)?na:oa,Pa)|0)<<1)|0;Oa=b[i>>0]&1?Ja:Na;Ca=0;i:while(1){if((Ca|0)<(Oa|0)){sa=Ca;do{ja=sa-((sa|0)>(qa|0)?Ja:0)|0;Fa=((sa|0)<(Aa|0)?Ja:0)+sa|0;ga=d[Qa+(ja<<1)>>1]|0;ya=d[Qa+(sa<<1)>>1]|0;wa=d[Qa+(Fa<<1)>>1]|0;ea=d[za+(ja<<1)>>1]|0;Ma=d[za+(sa<<1)>>1]|0;lb=d[za+(Fa<<1)>>1]|0;mb=d[Ba+(ja<<1)>>1]|0;ja=d[Ba+(sa<<1)>>1]|0;Va=d[Ba+(Fa<<1)>>1]|0;Fa=wa<<16>>16<ya<<16>>16;Cb=Fa?wa:ya;la=Fa?ya:wa;wa=lb<<16>>16<Ma<<16>>16;ya=wa?lb:Ma;Fa=wa?Ma:lb;lb=Va<<16>>16<ja<<16>>16;Ma=lb?Va:ja;wa=lb?ja:Va;Va=Cb<<16>>16<ga<<16>>16;ja=(Va?Cb:ga)<<16>>16;lb=Va?ga:Cb;Cb=ya<<16>>16<ea<<16>>16;ga=(Cb?ya:ea)<<16>>16;Va=Cb?ea:ya;ya=Ma<<16>>16<mb<<16>>16;ea=(ya?Ma:mb)<<16>>16;Cb=ya?mb:Ma;Ma=la<<16>>16<lb<<16>>16;mb=(Ma?la:lb)<<16>>16;ya=(Ma?lb:la)<<16>>16;la=Fa<<16>>16<Va<<16>>16;lb=la?Fa:Va;Ma=(la?Va:Fa)<<16>>16;Fa=wa<<16>>16<Cb<<16>>16;Va=Fa?wa:Cb;la=(Fa?Cb:wa)<<16>>16;wa=(ga|0)<(ja|0)?ja:ga;ga=(la|0)<(Ma|0)?la:Ma;Ma=Va<<16>>16<lb<<16>>16;la=(Ma?Va:lb)<<16>>16;ja=(Ma?lb:Va)<<16>>16;Va=(ea|0)<(wa|0)?wa:ea;ea=(la|0)<(mb|0)?mb:la;la=(ga|0)<(ya|0)?ga:ya;ya=(ja|0)<(ea|0)?ja:ea;ea=(la|0)<(ya|0);ja=ea?la:ya;ga=ea?ya:la;la=(ja|0)<(Va|0)?Va:ja;d[pa+(sa<<1)>>1]=(ga|0)<(la|0)?ga:la;sa=sa+1|0}while((sa|0)!=(Oa|0));gc=Oa}else gc=Ca;if((Oa|0)==(Na|0))break;if((gc|0)>(ia|0)){Oa=Na;Ca=gc;continue}else hc=gc;while(1){sa=Qa+(hc<<1)|0;la=d[sa+(La<<1)>>1]|0;ga=d[sa>>1]|0;ja=d[sa+(Ja<<1)>>1]|0;sa=za+(hc<<1)|0;Va=d[sa+(La<<1)>>1]|0;ya=d[sa>>1]|0;ea=d[sa+(Ja<<1)>>1]|0;sa=Ba+(hc<<1)|0;mb=d[sa+(La<<1)>>1]|0;wa=d[sa>>1]|0;lb=d[sa+(Ja<<1)>>1]|0;sa=ja<<16>>16<ga<<16>>16;Ma=sa?ja:ga;Cb=sa?ga:ja;ja=ea<<16>>16<ya<<16>>16;ga=ja?ea:ya;sa=ja?ya:ea;ea=lb<<16>>16<wa<<16>>16;ya=ea?lb:wa;ja=ea?wa:lb;lb=Ma<<16>>16<la<<16>>16;wa=(lb?Ma:la)<<16>>16;ea=lb?la:Ma;Ma=ga<<16>>16<Va<<16>>16;la=(Ma?ga:Va)<<16>>16;lb=Ma?Va:ga;ga=ya<<16>>16<mb<<16>>16;Va=(ga?ya:mb)<<16>>16;Ma=ga?mb:ya;ya=Cb<<16>>16<ea<<16>>16;mb=(ya?Cb:ea)<<16>>16;ga=(ya?ea:Cb)<<16>>16;Cb=sa<<16>>16<lb<<16>>16;ea=Cb?sa:lb;ya=(Cb?lb:sa)<<16>>16;sa=ja<<16>>16<Ma<<16>>16;lb=sa?ja:Ma;Cb=(sa?Ma:ja)<<16>>16;ja=(la|0)<(wa|0)?wa:la;la=(Cb|0)<(ya|0)?Cb:ya;ya=lb<<16>>16<ea<<16>>16;Cb=(ya?lb:ea)<<16>>16;wa=(ya?ea:lb)<<16>>16;lb=(Va|0)<(ja|0)?ja:Va;Va=(Cb|0)<(mb|0)?mb:Cb;Cb=(la|0)<(ga|0)?la:ga;ga=(wa|0)<(Va|0)?wa:Va;Va=(Cb|0)<(ga|0);wa=Va?Cb:ga;la=Va?ga:Cb;Cb=(wa|0)<(lb|0)?lb:wa;d[pa+(hc<<1)>>1]=(la|0)<(Cb|0)?la:Cb;Cb=hc+1|0;if((hc|0)<(ia|0))hc=Cb;else{Oa=Na;Ca=Cb;continue i}}}if((oa|0)==(Ia|0))break;else pa=pa+(Ka<<1)|0}}break}case 5:{pa=(Ia|0)==1;if((_a|0)==1|pa){oa=Ia+_a|0;Na=oa+-1|0;ia=pa?Ja:Pa;La=pa?0:Pa-Ja|0;Aa=pa?Ja:Ka;if((oa|0)<=1)break h;pa=0-ia|0;na=pa<<1;Ca=oa+-2|0;Oa=oa+-3|0;oa=ia<<1;Ba=ra;za=0;Qa=Ha;while(1){Cb=(za|0)>0?pa:0;la=(za|0)>1?na:Cb;wa=(za|0)<(Ca|0)?ia:0;lb=(za|0)<(Oa|0)?oa:wa;ga=Qa;Va=0;while(1){mb=d[ga+(la<<1)>>1]|0;ja=d[ga+(Cb<<1)>>1]|0;ea=d[ga>>1]|0;ya=d[ga+(wa<<1)>>1]|0;Ma=d[ga+(lb<<1)>>1]|0;sa=ja<<16>>16<mb<<16>>16;Fa=(sa?ja:mb)<<16>>16;Db=(sa?mb:ja)<<16>>16;ja=Ma<<16>>16<ya<<16>>16;mb=ja?Ma:ya;sa=ja?ya:Ma;Ma=mb<<16>>16<ea<<16>>16;ya=(Ma?mb:ea)<<16>>16;ja=Ma?ea:mb;mb=sa<<16>>16<ja<<16>>16;ea=(mb?sa:ja)<<16>>16;Ma=(mb?ja:sa)<<16>>16;sa=(ya|0)<(Fa|0)?Fa:ya;ya=(Ma|0)<(sa|0)?Ma:sa;sa=(ea|0)<(Db|0)?ea:Db;d[Ba+(Va<<1)>>1]=(ya|0)<(sa|0)?sa:ya;Va=Va+1|0;if((Va|0)==(Ja|0))break;else ga=ga+2|0}za=za+1|0;if((za|0)>=(Na|0))break h;else{Ba=Ba+(Aa<<1)|0;Qa=Qa+(Ja<<1)+(La<<1)|0}}}La=Y(_a,Ja)|0;if((Ia|0)>0){Qa=Ia+-1|0;Aa=Ja<<1;Ba=0-Aa|0;Na=La+~Aa|0;za=(ka|-512)^511;oa=La-Ja|0;Oa=La-Aa|0;ia=ra;Ca=0;while(1){na=Ca+-2|0;pa=Ha+((Y((na|0)>0?na:0,Pa)|0)<<1)|0;na=Ca+-1|0;ga=Ha+((Y((na|0)>0?na:0,Pa)|0)<<1)|0;na=Ha+((Y(Ca,Pa)|0)<<1)|0;Va=Ca;Ca=Ca+1|0;lb=Ha+((Y((Qa|0)<(Ca|0)?Qa:Ca,Pa)|0)<<1)|0;wa=Va+2|0;Va=Ha+((Y((Qa|0)<(wa|0)?Qa:wa,Pa)|0)<<1)|0;wa=b[i>>0]&1?Aa:La;Cb=0;j:while(1){if((Cb|0)<(wa|0)){la=Cb;do{ya=la-((la|0)>(qa|0)?Ja:0)|0;sa=(la|0)<(Aa|0)?ya:la-Aa|0;Db=((la|0)<(oa|0)?Ja:0)+la|0;ea=(la|0)<(Oa|0)?la+Aa|0:Db;Ma=d[pa+(sa<<1)>>1]|0;Fa=d[pa+(ya<<1)>>1]|0;ja=d[pa+(la<<1)>>1]|0;mb=d[pa+(Db<<1)>>1]|0;Ga=d[pa+(ea<<1)>>1]|0;cb=d[ga+(sa<<1)>>1]|0;bb=d[ga+(ya<<1)>>1]|0;Da=d[ga+(la<<1)>>1]|0;Fb=d[ga+(Db<<1)>>1]|0;Ya=d[ga+(ea<<1)>>1]|0;xa=d[na+(sa<<1)>>1]|0;ob=d[na+(ya<<1)>>1]|0;nb=d[na+(la<<1)>>1]|0;$a=d[na+(Db<<1)>>1]|0;ua=d[na+(ea<<1)>>1]|0;Xa=d[lb+(sa<<1)>>1]|0;kb=d[lb+(ya<<1)>>1]|0;ta=d[lb+(la<<1)>>1]|0;Eb=d[lb+(Db<<1)>>1]|0;jb=d[lb+(ea<<1)>>1]|0;db=d[Va+(sa<<1)>>1]|0;sa=d[Va+(ya<<1)>>1]|0;ya=d[Va+(la<<1)>>1]|0;hb=d[Va+(Db<<1)>>1]|0;Db=d[Va+(ea<<1)>>1]|0;ea=ja<<16>>16<Fa<<16>>16?ja:Fa;va=ja<<16>>16>Fa<<16>>16?ja:Fa;Fa=ea<<16>>16<Ma<<16>>16;ja=Fa?ea:Ma;ab=Fa?Ma:ea;ea=va<<16>>16<ab<<16>>16;Ma=ea?va:ab;Fa=ea?ab:va;va=cb<<16>>16<Ga<<16>>16;ab=va?cb:Ga;ea=va?Ga:cb;cb=ab<<16>>16<mb<<16>>16;Ga=cb?ab:mb;va=cb?mb:ab;ab=ea<<16>>16<va<<16>>16;mb=ab?ea:va;cb=ab?va:ea;ea=Ga<<16>>16<ja<<16>>16;va=ea?Ga:ja;ab=ea?ja:Ga;Ga=cb<<16>>16<Fa<<16>>16;ja=Ga?cb:Fa;ea=Ga?Fa:cb;cb=ab<<16>>16<ja<<16>>16;Fa=cb?ab:ja;Ga=cb?ja:ab;ab=mb<<16>>16<Ma<<16>>16;ja=ab?mb:Ma;cb=ab?Ma:mb;mb=Fa<<16>>16<ja<<16>>16;Ma=mb?Fa:ja;ab=mb?ja:Fa;Fa=cb<<16>>16<Ga<<16>>16;ja=Fa?cb:Ga;mb=Fa?Ga:cb;cb=Fb<<16>>16<Da<<16>>16;Ga=cb?Fb:Da;Fa=cb?Da:Fb;Fb=Ga<<16>>16<bb<<16>>16;Da=Fb?Ga:bb;cb=Fb?bb:Ga;Ga=Fa<<16>>16<cb<<16>>16;bb=Ga?Fa:cb;Fb=Ga?cb:Fa;Fa=ob<<16>>16<xa<<16>>16;cb=Fa?ob:xa;Ga=Fa?xa:ob;ob=cb<<16>>16<Ya<<16>>16;xa=ob?cb:Ya;Fa=ob?Ya:cb;cb=Ga<<16>>16<Fa<<16>>16;Ya=cb?Ga:Fa;ob=cb?Fa:Ga;Ga=xa<<16>>16<Da<<16>>16;Fa=Ga?xa:Da;cb=Ga?Da:xa;xa=ob<<16>>16<Fb<<16>>16;Da=xa?ob:Fb;Ga=xa?Fb:ob;ob=cb<<16>>16<Da<<16>>16;Fb=ob?cb:Da;xa=ob?Da:cb;cb=Ya<<16>>16<bb<<16>>16;Da=cb?Ya:bb;ob=cb?bb:Ya;Ya=Fb<<16>>16<Da<<16>>16;bb=Ya?Fb:Da;cb=Ya?Da:Fb;Fb=ob<<16>>16<xa<<16>>16;Da=Fb?ob:xa;Ya=Fb?xa:ob;ob=Fa<<16>>16<va<<16>>16;xa=(ob?Fa:va)<<16>>16;Fb=ob?va:Fa;Fa=Ya<<16>>16<mb<<16>>16;va=Fa?Ya:mb;ob=Fa?mb:Ya;Ya=Fb<<16>>16<va<<16>>16;mb=Ya?Fb:va;Fa=Ya?va:Fb;Fb=cb<<16>>16<ab<<16>>16;va=Fb?cb:ab;Ya=Fb?ab:cb;cb=mb<<16>>16<va<<16>>16;ab=cb?mb:va;Fb=cb?va:mb;mb=Ya<<16>>16<Fa<<16>>16;va=mb?Ya:Fa;cb=mb?Fa:Ya;Ya=bb<<16>>16<Ma<<16>>16;Fa=Ya?bb:Ma;mb=Ya?Ma:bb;bb=Ga<<16>>16<ea<<16>>16;Ma=bb?Ga:ea;Ya=(bb?ea:Ga)<<16>>16;Ga=mb<<16>>16<Ma<<16>>16;ea=Ga?mb:Ma;bb=Ga?Ma:mb;mb=Da<<16>>16<ja<<16>>16;Ma=mb?Da:ja;Ga=mb?ja:Da;Da=ea<<16>>16<Ma<<16>>16;ja=Da?ea:Ma;mb=Da?Ma:ea;ea=Ga<<16>>16<bb<<16>>16;Ma=ea?Ga:bb;Da=ea?bb:Ga;Ga=ab<<16>>16<Fa<<16>>16;bb=(Ga?ab:Fa)<<16>>16;ea=(Ga?Fa:ab)<<16>>16;ab=Fb<<16>>16<ja<<16>>16;Fa=(ab?Fb:ja)<<16>>16;Ga=(ab?ja:Fb)<<16>>16;Fb=va<<16>>16<mb<<16>>16;ja=(Fb?va:mb)<<16>>16;ab=(Fb?mb:va)<<16>>16;va=cb<<16>>16<Ma<<16>>16;mb=(va?cb:Ma)<<16>>16;Fb=(va?Ma:cb)<<16>>16;cb=ob<<16>>16<Da<<16>>16;Ma=(cb?ob:Da)<<16>>16;va=(cb?Da:ob)<<16>>16;ob=ua<<16>>16<$a<<16>>16;Da=ob?ua:$a;cb=ob?$a:ua;ua=Da<<16>>16<nb<<16>>16;$a=ua?Da:nb;ob=ua?nb:Da;Da=cb<<16>>16<ob<<16>>16;nb=Da?cb:ob;ua=Da?ob:cb;cb=ta<<16>>16<kb<<16>>16;ob=cb?ta:kb;Da=cb?kb:ta;ta=ob<<16>>16<Xa<<16>>16;kb=ta?ob:Xa;cb=ta?Xa:ob;ob=Da<<16>>16<cb<<16>>16;Xa=ob?Da:cb;ta=ob?cb:Da;Da=kb<<16>>16<$a<<16>>16;cb=Da?kb:$a;ob=Da?$a:kb;kb=ta<<16>>16<ua<<16>>16;$a=kb?ta:ua;Da=kb?ua:ta;ta=ob<<16>>16<$a<<16>>16;ua=ta?ob:$a;kb=ta?$a:ob;ob=Xa<<16>>16<nb<<16>>16;$a=ob?Xa:nb;ta=ob?nb:Xa;Xa=ua<<16>>16<$a<<16>>16;nb=Xa?ua:$a;ob=Xa?$a:ua;ua=ta<<16>>16<kb<<16>>16;$a=ua?ta:kb;Xa=ua?kb:ta;ta=db<<16>>16<jb<<16>>16;kb=ta?db:jb;ua=ta?jb:db;db=kb<<16>>16<Eb<<16>>16;jb=db?kb:Eb;ta=db?Eb:kb;kb=ua<<16>>16<ta<<16>>16;Eb=kb?ua:ta;db=kb?ta:ua;ua=ya<<16>>16<sa<<16>>16;ta=ua?ya:sa;kb=ua?sa:ya;ya=Db<<16>>16<hb<<16>>16;sa=ya?Db:hb;ua=ya?hb:Db;Db=sa<<16>>16<ta<<16>>16;hb=Db?sa:ta;ya=Db?ta:sa;sa=ua<<16>>16<kb<<16>>16;ta=sa?ua:kb;Db=sa?kb:ua;ua=ya<<16>>16<ta<<16>>16;kb=ua?ya:ta;sa=ua?ta:ya;ya=hb<<16>>16<jb<<16>>16;ta=ya?hb:jb;ua=ya?jb:hb;hb=sa<<16>>16<db<<16>>16;jb=hb?sa:db;ya=hb?db:sa;sa=ua<<16>>16<jb<<16>>16;db=sa?ua:jb;hb=sa?jb:ua;ua=kb<<16>>16<Eb<<16>>16;jb=ua?kb:Eb;sa=ua?Eb:kb;kb=Db<<16>>16<sa<<16>>16;Eb=kb?Db:sa;ua=kb?sa:Db;Db=db<<16>>16<jb<<16>>16;sa=Db?db:jb;kb=Db?jb:db;db=Eb<<16>>16<hb<<16>>16;jb=db?Eb:hb;Db=db?hb:Eb;Eb=ua<<16>>16<ya<<16>>16;hb=Eb?ua:ya;db=Eb?ya:ua;ua=ta<<16>>16<cb<<16>>16;ya=(ua?ta:cb)<<16>>16;Eb=ua?cb:ta;ta=Db<<16>>16<Xa<<16>>16;cb=ta?Db:Xa;ua=ta?Xa:Db;Db=Eb<<16>>16<cb<<16>>16;Xa=Db?Eb:cb;ta=Db?cb:Eb;Eb=kb<<16>>16<ob<<16>>16;cb=Eb?kb:ob;Db=Eb?ob:kb;kb=db<<16>>16<Db<<16>>16;ob=kb?db:Db;Eb=kb?Db:db;db=Xa<<16>>16<cb<<16>>16;Db=db?Xa:cb;kb=db?cb:Xa;Xa=ob<<16>>16<ta<<16>>16;cb=Xa?ob:ta;db=Xa?ta:ob;ob=Eb<<16>>16<ua<<16>>16;ta=ob?Eb:ua;Xa=ob?ua:Eb;Eb=sa<<16>>16<nb<<16>>16;ua=Eb?sa:nb;ob=Eb?nb:sa;sa=hb<<16>>16<Da<<16>>16;nb=sa?hb:Da;Eb=sa?Da:hb;hb=ob<<16>>16<nb<<16>>16;Da=hb?ob:nb;sa=hb?nb:ob;ob=jb<<16>>16<$a<<16>>16;nb=ob?jb:$a;hb=ob?$a:jb;jb=Da<<16>>16<nb<<16>>16;$a=jb?Da:nb;ob=jb?nb:Da;Da=hb<<16>>16<sa<<16>>16;nb=Da?hb:sa;jb=Da?sa:hb;hb=Db<<16>>16<ua<<16>>16;sa=(hb?Db:ua)<<16>>16;Da=(hb?ua:Db)<<16>>16;Db=kb<<16>>16<$a<<16>>16;ua=(Db?kb:$a)<<16>>16;hb=(Db?$a:kb)<<16>>16;kb=cb<<16>>16<ob<<16>>16;$a=(kb?cb:ob)<<16>>16;Db=(kb?ob:cb)<<16>>16;cb=db<<16>>16<nb<<16>>16;ob=(cb?db:nb)<<16>>16;kb=(cb?nb:db)<<16>>16;db=ta<<16>>16<jb<<16>>16;nb=(db?ta:jb)<<16>>16;cb=(db?jb:ta)<<16>>16;ta=Xa<<16>>16<Eb<<16>>16;jb=(ta?Xa:Eb)<<16>>16;db=(ta?Eb:Xa)<<16>>16;Xa=(ya|0)<(xa|0)?xa:ya;ya=(kb|0)<(Fb|0)?kb:Fb;Fb=(Xa|0)<(ya|0)?ya:Xa;Xa=(hb|0)<(Ga|0)?Ga:hb;hb=(db|0)<(Xa|0)?db:Xa;Xa=(hb|0)<(Fb|0)?hb:Fb;Fb=(Da|0)<(ea|0)?ea:Da;Da=(cb|0)<(va|0)?cb:va;va=(Fb|0)<(Da|0)?Fb:Da;Da=(Db|0)<(ab|0)?Db:ab;ab=(va|0)<(Da|0)?Da:va;va=(Xa|0)<(ab|0)?ab:Xa;Xa=(sa|0)<(bb|0)?bb:sa;sa=(nb|0)<(Ma|0)?nb:Ma;Ma=(Xa|0)<(sa|0)?sa:Xa;Xa=($a|0)<(ja|0)?ja:$a;$a=(Xa|0)<(Ma|0)?Xa:Ma;Ma=(ua|0)<(Fa|0)?Fa:ua;ua=(jb|0)<(Ya|0)?jb:Ya;Ya=(Ma|0)<(ua|0)?Ma:ua;ua=(ob|0)<(mb|0)?ob:mb;mb=(Ya|0)<(ua|0)?ua:Ya;Ya=($a|0)<(mb|0)?$a:mb;d[ia+(la<<1)>>1]=(va|0)<(Ya|0)?Ya:va;la=la+1|0}while((la|0)!=(wa|0));ic=wa}else ic=Cb;if((wa|0)==(La|0))break;if((ic|0)>(Na|0)){wa=La;Cb=ic;continue}else jc=ic;while(1){la=pa+(jc<<1)|0;va=d[la+(Ba<<1)>>1]|0;Ya=d[la+(za<<1)>>1]|0;mb=d[la>>1]|0;$a=d[la+(Ja<<1)>>1]|0;ua=d[la+(Aa<<1)>>1]|0;la=ga+(jc<<1)|0;ob=d[la+(Ba<<1)>>1]|0;Ma=d[la+(za<<1)>>1]|0;jb=d[la>>1]|0;Fa=d[la+(Ja<<1)>>1]|0;Xa=d[la+(Aa<<1)>>1]|0;la=na+(jc<<1)|0;ja=d[la+(Ba<<1)>>1]|0;sa=d[la+(za<<1)>>1]|0;nb=d[la>>1]|0;bb=d[la+(Ja<<1)>>1]|0;ab=d[la+(Aa<<1)>>1]|0;la=lb+(jc<<1)|0;Da=d[la+(Ba<<1)>>1]|0;Db=d[la+(za<<1)>>1]|0;Fb=d[la>>1]|0;cb=d[la+(Ja<<1)>>1]|0;ea=d[la+(Aa<<1)>>1]|0;la=Va+(jc<<1)|0;hb=d[la+(Ba<<1)>>1]|0;db=d[la+(za<<1)>>1]|0;Ga=d[la>>1]|0;ya=d[la+(Ja<<1)>>1]|0;kb=d[la+(Aa<<1)>>1]|0;la=mb<<16>>16<Ya<<16>>16?mb:Ya;xa=mb<<16>>16>Ya<<16>>16?mb:Ya;Ya=la<<16>>16<va<<16>>16;mb=Ya?la:va;Eb=Ya?va:la;la=xa<<16>>16<Eb<<16>>16;va=la?xa:Eb;Ya=la?Eb:xa;xa=ob<<16>>16<ua<<16>>16;Eb=xa?ob:ua;la=xa?ua:ob;ob=Eb<<16>>16<$a<<16>>16;ua=ob?Eb:$a;xa=ob?$a:Eb;Eb=la<<16>>16<xa<<16>>16;$a=Eb?la:xa;ob=Eb?xa:la;la=ua<<16>>16<mb<<16>>16;xa=la?ua:mb;Eb=la?mb:ua;ua=ob<<16>>16<Ya<<16>>16;mb=ua?ob:Ya;la=ua?Ya:ob;ob=Eb<<16>>16<mb<<16>>16;Ya=ob?Eb:mb;ua=ob?mb:Eb;Eb=$a<<16>>16<va<<16>>16;mb=Eb?$a:va;ob=Eb?va:$a;$a=Ya<<16>>16<mb<<16>>16;va=$a?Ya:mb;Eb=$a?mb:Ya;Ya=ob<<16>>16<ua<<16>>16;mb=Ya?ob:ua;$a=Ya?ua:ob;ob=Fa<<16>>16<jb<<16>>16;ua=ob?Fa:jb;Ya=ob?jb:Fa;Fa=ua<<16>>16<Ma<<16>>16;jb=Fa?ua:Ma;ob=Fa?Ma:ua;ua=Ya<<16>>16<ob<<16>>16;Ma=ua?Ya:ob;Fa=ua?ob:Ya;Ya=sa<<16>>16<ja<<16>>16;ob=Ya?sa:ja;ua=Ya?ja:sa;sa=ob<<16>>16<Xa<<16>>16;ja=sa?ob:Xa;Ya=sa?Xa:ob;ob=ua<<16>>16<Ya<<16>>16;Xa=ob?ua:Ya;sa=ob?Ya:ua;ua=ja<<16>>16<jb<<16>>16;Ya=ua?ja:jb;ob=ua?jb:ja;ja=sa<<16>>16<Fa<<16>>16;jb=ja?sa:Fa;ua=ja?Fa:sa;sa=ob<<16>>16<jb<<16>>16;Fa=sa?ob:jb;ja=sa?jb:ob;ob=Xa<<16>>16<Ma<<16>>16;jb=ob?Xa:Ma;sa=ob?Ma:Xa;Xa=Fa<<16>>16<jb<<16>>16;Ma=Xa?Fa:jb;ob=Xa?jb:Fa;Fa=sa<<16>>16<ja<<16>>16;jb=Fa?sa:ja;Xa=Fa?ja:sa;sa=Ya<<16>>16<xa<<16>>16;ja=(sa?Ya:xa)<<16>>16;Fa=sa?xa:Ya;Ya=Xa<<16>>16<$a<<16>>16;xa=Ya?Xa:$a;sa=Ya?$a:Xa;Xa=Fa<<16>>16<xa<<16>>16;$a=Xa?Fa:xa;Ya=Xa?xa:Fa;Fa=ob<<16>>16<Eb<<16>>16;xa=Fa?ob:Eb;Xa=Fa?Eb:ob;ob=$a<<16>>16<xa<<16>>16;Eb=ob?$a:xa;Fa=ob?xa:$a;$a=Xa<<16>>16<Ya<<16>>16;xa=$a?Xa:Ya;ob=$a?Ya:Xa;Xa=Ma<<16>>16<va<<16>>16;Ya=Xa?Ma:va;$a=Xa?va:Ma;Ma=ua<<16>>16<la<<16>>16;va=Ma?ua:la;Xa=(Ma?la:ua)<<16>>16;ua=$a<<16>>16<va<<16>>16;la=ua?$a:va;Ma=ua?va:$a;$a=jb<<16>>16<mb<<16>>16;va=$a?jb:mb;ua=$a?mb:jb;jb=la<<16>>16<va<<16>>16;mb=jb?la:va;$a=jb?va:la;la=ua<<16>>16<Ma<<16>>16;va=la?ua:Ma;jb=la?Ma:ua;ua=Eb<<16>>16<Ya<<16>>16;Ma=(ua?Eb:Ya)<<16>>16;la=(ua?Ya:Eb)<<16>>16;Eb=Fa<<16>>16<mb<<16>>16;Ya=(Eb?Fa:mb)<<16>>16;ua=(Eb?mb:Fa)<<16>>16;Fa=xa<<16>>16<$a<<16>>16;mb=(Fa?xa:$a)<<16>>16;Eb=(Fa?$a:xa)<<16>>16;xa=ob<<16>>16<va<<16>>16;$a=(xa?ob:va)<<16>>16;Fa=(xa?va:ob)<<16>>16;ob=sa<<16>>16<jb<<16>>16;va=(ob?sa:jb)<<16>>16;xa=(ob?jb:sa)<<16>>16;sa=ab<<16>>16<bb<<16>>16;jb=sa?ab:bb;ob=sa?bb:ab;ab=jb<<16>>16<nb<<16>>16;bb=ab?jb:nb;sa=ab?nb:jb;jb=ob<<16>>16<sa<<16>>16;nb=jb?ob:sa;ab=jb?sa:ob;ob=Fb<<16>>16<Db<<16>>16;sa=ob?Fb:Db;jb=ob?Db:Fb;Fb=sa<<16>>16<Da<<16>>16;Db=Fb?sa:Da;ob=Fb?Da:sa;sa=jb<<16>>16<ob<<16>>16;Da=sa?jb:ob;Fb=sa?ob:jb;jb=Db<<16>>16<bb<<16>>16;ob=jb?Db:bb;sa=jb?bb:Db;Db=Fb<<16>>16<ab<<16>>16;bb=Db?Fb:ab;jb=Db?ab:Fb;Fb=sa<<16>>16<bb<<16>>16;ab=Fb?sa:bb;Db=Fb?bb:sa;sa=Da<<16>>16<nb<<16>>16;bb=sa?Da:nb;Fb=sa?nb:Da;Da=ab<<16>>16<bb<<16>>16;nb=Da?ab:bb;sa=Da?bb:ab;ab=Fb<<16>>16<Db<<16>>16;bb=ab?Fb:Db;Da=ab?Db:Fb;Fb=hb<<16>>16<ea<<16>>16;Db=Fb?hb:ea;ab=Fb?ea:hb;hb=Db<<16>>16<cb<<16>>16;ea=hb?Db:cb;Fb=hb?cb:Db;Db=ab<<16>>16<Fb<<16>>16;cb=Db?ab:Fb;hb=Db?Fb:ab;ab=Ga<<16>>16<db<<16>>16;Fb=ab?Ga:db;Db=ab?db:Ga;Ga=kb<<16>>16<ya<<16>>16;db=Ga?kb:ya;ab=Ga?ya:kb;kb=db<<16>>16<Fb<<16>>16;ya=kb?db:Fb;Ga=kb?Fb:db;db=ab<<16>>16<Db<<16>>16;Fb=db?ab:Db;kb=db?Db:ab;ab=Ga<<16>>16<Fb<<16>>16;Db=ab?Ga:Fb;db=ab?Fb:Ga;Ga=ya<<16>>16<ea<<16>>16;Fb=Ga?ya:ea;ab=Ga?ea:ya;ya=db<<16>>16<hb<<16>>16;ea=ya?db:hb;Ga=ya?hb:db;db=ab<<16>>16<ea<<16>>16;hb=db?ab:ea;ya=db?ea:ab;ab=Db<<16>>16<cb<<16>>16;ea=ab?Db:cb;db=ab?cb:Db;Db=kb<<16>>16<db<<16>>16;cb=Db?kb:db;ab=Db?db:kb;kb=hb<<16>>16<ea<<16>>16;db=kb?hb:ea;Db=kb?ea:hb;hb=cb<<16>>16<ya<<16>>16;ea=hb?cb:ya;kb=hb?ya:cb;cb=ab<<16>>16<Ga<<16>>16;ya=cb?ab:Ga;hb=cb?Ga:ab;ab=Fb<<16>>16<ob<<16>>16;Ga=(ab?Fb:ob)<<16>>16;cb=ab?ob:Fb;Fb=kb<<16>>16<Da<<16>>16;ob=Fb?kb:Da;ab=Fb?Da:kb;kb=cb<<16>>16<ob<<16>>16;Da=kb?cb:ob;Fb=kb?ob:cb;cb=Db<<16>>16<sa<<16>>16;ob=cb?Db:sa;kb=cb?sa:Db;Db=hb<<16>>16<kb<<16>>16;sa=Db?hb:kb;cb=Db?kb:hb;hb=Da<<16>>16<ob<<16>>16;kb=hb?Da:ob;Db=hb?ob:Da;Da=sa<<16>>16<Fb<<16>>16;ob=Da?sa:Fb;hb=Da?Fb:sa;sa=cb<<16>>16<ab<<16>>16;Fb=sa?cb:ab;Da=sa?ab:cb;cb=db<<16>>16<nb<<16>>16;ab=cb?db:nb;sa=cb?nb:db;db=ya<<16>>16<jb<<16>>16;nb=db?ya:jb;cb=db?jb:ya;ya=sa<<16>>16<nb<<16>>16;jb=ya?sa:nb;db=ya?nb:sa;sa=ea<<16>>16<bb<<16>>16;nb=sa?ea:bb;ya=sa?bb:ea;ea=jb<<16>>16<nb<<16>>16;bb=ea?jb:nb;sa=ea?nb:jb;jb=ya<<16>>16<db<<16>>16;nb=jb?ya:db;ea=jb?db:ya;ya=kb<<16>>16<ab<<16>>16;db=(ya?kb:ab)<<16>>16;jb=(ya?ab:kb)<<16>>16;kb=Db<<16>>16<bb<<16>>16;ab=(kb?Db:bb)<<16>>16;ya=(kb?bb:Db)<<16>>16;Db=ob<<16>>16<sa<<16>>16;bb=(Db?ob:sa)<<16>>16;kb=(Db?sa:ob)<<16>>16;ob=hb<<16>>16<nb<<16>>16;sa=(ob?hb:nb)<<16>>16;Db=(ob?nb:hb)<<16>>16;hb=Fb<<16>>16<ea<<16>>16;nb=(hb?Fb:ea)<<16>>16;ob=(hb?ea:Fb)<<16>>16;Fb=Da<<16>>16<cb<<16>>16;ea=(Fb?Da:cb)<<16>>16;hb=(Fb?cb:Da)<<16>>16;Da=(Ga|0)<(ja|0)?ja:Ga;Ga=(Db|0)<(Fa|0)?Db:Fa;Fa=(Da|0)<(Ga|0)?Ga:Da;Da=(ya|0)<(ua|0)?ua:ya;ya=(hb|0)<(Da|0)?hb:Da;Da=(ya|0)<(Fa|0)?ya:Fa;Fa=(jb|0)<(la|0)?la:jb;jb=(ob|0)<(xa|0)?ob:xa;xa=(Fa|0)<(jb|0)?Fa:jb;jb=(kb|0)<(Eb|0)?kb:Eb;Eb=(xa|0)<(jb|0)?jb:xa;xa=(Da|0)<(Eb|0)?Eb:Da;Da=(db|0)<(Ma|0)?Ma:db;db=(nb|0)<(va|0)?nb:va;va=(Da|0)<(db|0)?db:Da;Da=(bb|0)<(mb|0)?mb:bb;bb=(Da|0)<(va|0)?Da:va;va=(ab|0)<(Ya|0)?Ya:ab;ab=(ea|0)<(Xa|0)?ea:Xa;Xa=(va|0)<(ab|0)?va:ab;ab=(sa|0)<($a|0)?sa:$a;$a=(Xa|0)<(ab|0)?ab:Xa;Xa=(bb|0)<($a|0)?bb:$a;d[ia+(jc<<1)>>1]=(xa|0)<(Xa|0)?Xa:xa;xa=jc+1|0;if((jc|0)<(Na|0))jc=xa;else{wa=La;Cb=xa;continue j}}}if((Ca|0)==(Ia|0))break;else ia=ia+(Ka<<1)|0}}break}default:{}}while(0);break a;break}case 5:{Ka=f[Q+16>>2]|0;Ia=f[ca>>2]|0;Ja=(f[X>>2]|0)>>>2;qa=(f[P+48>>2]|0)>>>2;Pa=f[P+40>>2]|0;Ha=f[Pa+4>>2]|0;ra=f[Pa>>2]|0;Pa=Ea>>>3;ka=Pa&511;_a=ka+1|0;b[i>>0]=0;k:do switch(e|0){case 3:{ia=(ra|0)==1;if((Ha|0)==1|ia){Ca=ra+Ha|0;La=Ca+-1|0;Na=ia?_a:Ja;Aa=ia?0:Ja-_a|0;za=ia?_a:qa;if((Ca|0)<=1)break k;ia=0-Na|0;Ba=Ca+-2|0;Ca=Ka;Oa=Ia;oa=0;while(1){Qa=(oa|0)>0?ia:0;Cb=(oa|0)<(Ba|0)?Na:0;wa=0;Va=Ca;while(1){lb=f[Va+(Qa<<2)>>2]|0;f[k>>2]=lb;na=f[Va>>2]|0;f[l>>2]=na;ma=+n[Va+(Cb<<2)>>2];kc=(f[s>>2]=lb,+n[s>>2]);lc=(f[s>>2]=na,+n[s>>2]);na=lc<kc;mc=+n[(na?l:k)>>2];nc=na?kc:lc;lc=ma<nc?ma:nc;n[Oa+(wa<<2)>>2]=lc<mc?mc:lc;wa=wa+1|0;if((wa|0)==(_a|0))break;else Va=Va+4|0}oa=oa+1|0;if((oa|0)>=(La|0))break k;else{Ca=Ca+(_a<<2)+(Aa<<2)|0;Oa=Oa+(za<<2)|0}}}za=Y(Ha,_a)|0;if((ra|0)>0){Oa=ra+-1|0;Aa=(Pa|-512)^511;Ca=Aa+-1+za|0;La=za-_a|0;oa=Ia;Na=0;while(1){Ba=Na+-1|0;ia=Ka+((Y((Ba|0)>0?Ba:0,Ja)|0)<<2)|0;Ba=Ka+((Y(Na,Ja)|0)<<2)|0;Na=Na+1|0;Va=Ka+((Y((Oa|0)<(Na|0)?Oa:Na,Ja)|0)<<2)|0;wa=b[i>>0]&1?_a:za;Cb=0;l:while(1){if((Cb|0)<(wa|0)){Qa=Cb;do{na=Qa-((Qa|0)>(ka|0)?_a:0)|0;lb=((Qa|0)<(La|0)?_a:0)+Qa|0;ga=f[ia+(na<<2)>>2]|0;pa=f[ia+(Qa<<2)>>2]|0;f[k>>2]=pa;xa=f[ia+(lb<<2)>>2]|0;f[l>>2]=xa;Xa=f[Ba+(na<<2)>>2]|0;$a=f[Ba+(Qa<<2)>>2]|0;f[m>>2]=$a;bb=f[Ba+(lb<<2)>>2]|0;f[o>>2]=bb;ab=f[Va+(na<<2)>>2]|0;na=f[Va+(Qa<<2)>>2]|0;f[p>>2]=na;sa=f[Va+(lb<<2)>>2]|0;f[q>>2]=sa;lc=(f[s>>2]=pa,+n[s>>2]);mc=(f[s>>2]=xa,+n[s>>2]);xa=mc<lc;pa=f[(xa?l:k)>>2]|0;nc=xa?lc:mc;n[l>>2]=nc;mc=(f[s>>2]=$a,+n[s>>2]);lc=(f[s>>2]=bb,+n[s>>2]);bb=lc<mc;$a=f[(bb?o:m)>>2]|0;ma=bb?mc:lc;n[o>>2]=ma;lc=(f[s>>2]=na,+n[s>>2]);mc=(f[s>>2]=sa,+n[s>>2]);sa=mc<lc;na=f[(sa?q:p)>>2]|0;kc=sa?lc:mc;n[q>>2]=kc;mc=(f[s>>2]=ga,+n[s>>2]);lc=(f[s>>2]=pa,+n[s>>2]);sa=lc<mc;oc=sa?mc:lc;n[k>>2]=oc;lc=(f[s>>2]=Xa,+n[s>>2]);mc=(f[s>>2]=$a,+n[s>>2]);bb=mc<lc;pc=bb?lc:mc;n[m>>2]=pc;mc=(f[s>>2]=ab,+n[s>>2]);lc=(f[s>>2]=na,+n[s>>2]);xa=lc<mc;qc=xa?mc:lc;n[p>>2]=qc;lb=nc<oc;lc=lb?+n[l>>2]:+n[k>>2];mc=lb?oc:nc;n[l>>2]=mc;lb=ma<pc;va=f[(lb?o:m)>>2]|0;f[m>>2]=va;nc=lb?pc:ma;n[o>>2]=nc;lb=kc<qc;ea=f[(lb?q:p)>>2]|0;f[p>>2]=ea;ma=lb?qc:kc;n[q>>2]=ma;kc=(f[s>>2]=sa?pa:ga,+n[s>>2]);qc=(f[s>>2]=bb?$a:Xa,+n[s>>2]);pc=qc<kc?kc:qc;Xa=f[(ma<nc?q:o)>>2]|0;f[o>>2]=Xa;nc=(f[s>>2]=va,+n[s>>2]);ma=(f[s>>2]=ea,+n[s>>2]);ea=ma<nc;qc=ea?+n[p>>2]:+n[m>>2];kc=ea?nc:ma;n[p>>2]=kc;ma=(f[s>>2]=xa?na:ab,+n[s>>2]);nc=ma<pc?pc:ma;ma=qc<lc?lc:qc;n[m>>2]=ma;ab=f[((f[s>>2]=Xa,+n[s>>2])<mc?o:l)>>2]|0;f[l>>2]=ab;Xa=f[(kc<ma?p:m)>>2]|0;f[m>>2]=Xa;ma=(f[s>>2]=Xa,+n[s>>2]);kc=(f[s>>2]=ab,+n[s>>2]);ab=kc<ma;mc=ab?+n[l>>2]:(f[s>>2]=Xa,+n[s>>2]);qc=ab?ma:kc;n[l>>2]=qc;kc=mc<nc?nc:mc;n[m>>2]=kc;f[oa+(Qa<<2)>>2]=f[(qc<kc?l:m)>>2];Qa=Qa+1|0}while((Qa|0)!=(wa|0));rc=wa}else rc=Cb;if((wa|0)==(za|0))break;if((rc|0)>(Ca|0)){wa=za;Cb=rc;continue}else sc=rc;while(1){Qa=ia+(sc<<2)|0;ab=f[Qa+(Aa<<2)>>2]|0;Xa=f[Qa>>2]|0;f[k>>2]=Xa;na=f[Qa+(_a<<2)>>2]|0;f[l>>2]=na;Qa=Ba+(sc<<2)|0;xa=f[Qa+(Aa<<2)>>2]|0;ea=f[Qa>>2]|0;f[m>>2]=ea;va=f[Qa+(_a<<2)>>2]|0;f[o>>2]=va;Qa=Va+(sc<<2)|0;$a=f[Qa+(Aa<<2)>>2]|0;bb=f[Qa>>2]|0;f[p>>2]=bb;ga=f[Qa+(_a<<2)>>2]|0;f[q>>2]=ga;kc=(f[s>>2]=Xa,+n[s>>2]);qc=(f[s>>2]=na,+n[s>>2]);na=qc<kc;Xa=f[(na?l:k)>>2]|0;mc=na?kc:qc;n[l>>2]=mc;qc=(f[s>>2]=ea,+n[s>>2]);kc=(f[s>>2]=va,+n[s>>2]);va=kc<qc;ea=f[(va?o:m)>>2]|0;nc=va?qc:kc;n[o>>2]=nc;kc=(f[s>>2]=bb,+n[s>>2]);qc=(f[s>>2]=ga,+n[s>>2]);ga=qc<kc;bb=f[(ga?q:p)>>2]|0;ma=ga?kc:qc;n[q>>2]=ma;qc=(f[s>>2]=ab,+n[s>>2]);kc=(f[s>>2]=Xa,+n[s>>2]);ga=kc<qc;lc=ga?qc:kc;n[k>>2]=lc;kc=(f[s>>2]=xa,+n[s>>2]);qc=(f[s>>2]=ea,+n[s>>2]);va=qc<kc;pc=va?kc:qc;n[m>>2]=pc;qc=(f[s>>2]=$a,+n[s>>2]);kc=(f[s>>2]=bb,+n[s>>2]);na=kc<qc;oc=na?qc:kc;n[p>>2]=oc;Qa=mc<lc;kc=Qa?+n[l>>2]:+n[k>>2];qc=Qa?lc:mc;n[l>>2]=qc;Qa=nc<pc;pa=f[(Qa?o:m)>>2]|0;f[m>>2]=pa;mc=Qa?pc:nc;n[o>>2]=mc;Qa=ma<oc;sa=f[(Qa?q:p)>>2]|0;f[p>>2]=sa;nc=Qa?oc:ma;n[q>>2]=nc;ma=(f[s>>2]=ga?Xa:ab,+n[s>>2]);oc=(f[s>>2]=va?ea:xa,+n[s>>2]);pc=oc<ma?ma:oc;xa=f[(nc<mc?q:o)>>2]|0;f[o>>2]=xa;mc=(f[s>>2]=pa,+n[s>>2]);nc=(f[s>>2]=sa,+n[s>>2]);sa=nc<mc;oc=sa?+n[p>>2]:+n[m>>2];ma=sa?mc:nc;n[p>>2]=ma;nc=(f[s>>2]=na?bb:$a,+n[s>>2]);mc=nc<pc?pc:nc;nc=oc<kc?kc:oc;n[m>>2]=nc;$a=f[((f[s>>2]=xa,+n[s>>2])<qc?o:l)>>2]|0;f[l>>2]=$a;xa=f[(ma<nc?p:m)>>2]|0;f[m>>2]=xa;nc=(f[s>>2]=xa,+n[s>>2]);ma=(f[s>>2]=$a,+n[s>>2]);$a=ma<nc;qc=$a?+n[l>>2]:(f[s>>2]=xa,+n[s>>2]);oc=$a?nc:ma;n[l>>2]=oc;ma=qc<mc?mc:qc;n[m>>2]=ma;f[oa+(sc<<2)>>2]=f[(oc<ma?l:m)>>2];$a=sc+1|0;if((sc|0)<(Ca|0))sc=$a;else{wa=za;Cb=$a;continue l}}}if((Na|0)==(ra|0))break;else oa=oa+(qa<<2)|0}}break}case 5:{oa=(ra|0)==1;if((Ha|0)==1|oa){Na=ra+Ha|0;za=Na+-1|0;Ca=oa?_a:Ja;Aa=oa?0:Ja-_a|0;La=oa?_a:qa;if((Na|0)<=1)break k;oa=0-Ca|0;Oa=oa<<1;Cb=Na+-2|0;wa=Na+-3|0;Na=Ca<<1;Va=Ka;Ba=Ia;ia=0;while(1){$a=(ia|0)>0?oa:0;xa=(ia|0)>1?Oa:$a;bb=(ia|0)<(Cb|0)?Ca:0;na=(ia|0)<(wa|0)?Na:bb;sa=Va;pa=0;while(1){ea=f[sa+(xa<<2)>>2]|0;f[k>>2]=ea;va=f[sa+($a<<2)>>2]|0;f[l>>2]=va;ab=f[sa>>2]|0;f[m>>2]=ab;Xa=f[sa+(bb<<2)>>2]|0;f[o>>2]=Xa;ga=f[sa+(na<<2)>>2]|0;f[p>>2]=ga;ma=(f[s>>2]=ea,+n[s>>2]);oc=(f[s>>2]=va,+n[s>>2]);va=oc<ma;qc=+n[(va?l:k)>>2];mc=va?ma:oc;oc=(f[s>>2]=Xa,+n[s>>2]);ma=(f[s>>2]=ga,+n[s>>2]);ga=ma<oc;Xa=f[(ga?p:o)>>2]|0;f[o>>2]=Xa;nc=ga?oc:ma;n[p>>2]=nc;ma=(f[s>>2]=ab,+n[s>>2]);oc=(f[s>>2]=Xa,+n[s>>2]);ab=oc<ma;kc=ab?(f[s>>2]=Xa,+n[s>>2]):+n[m>>2];pc=ab?ma:oc;n[o>>2]=pc;ab=nc<pc;oc=ab?+n[p>>2]:pc;ma=ab?pc:nc;n[p>>2]=ma;nc=kc<qc?qc:kc;n[m>>2]=nc;kc=ma<nc?ma:nc;nc=oc<mc?oc:mc;n[Ba+(pa<<2)>>2]=kc<nc?nc:kc;pa=pa+1|0;if((pa|0)==(_a|0))break;else sa=sa+4|0}ia=ia+1|0;if((ia|0)>=(za|0))break k;else{Va=Va+(_a<<2)+(Aa<<2)|0;Ba=Ba+(La<<2)|0}}}La=Y(Ha,_a)|0;if((ra|0)>0){Ba=ra+-1|0;Aa=_a<<1;Va=0-Aa|0;za=La+~Aa|0;ia=(Pa|-512)^511;Na=La-_a|0;wa=La-Aa|0;Ca=Ia;Cb=0;while(1){Oa=Cb+-2|0;oa=Ka+((Y((Oa|0)>0?Oa:0,Ja)|0)<<2)|0;Oa=Cb+-1|0;sa=Ka+((Y((Oa|0)>0?Oa:0,Ja)|0)<<2)|0;Oa=Ka+((Y(Cb,Ja)|0)<<2)|0;pa=Cb;Cb=Cb+1|0;na=Ka+((Y((Ba|0)<(Cb|0)?Ba:Cb,Ja)|0)<<2)|0;bb=pa+2|0;pa=Ka+((Y((Ba|0)<(bb|0)?Ba:bb,Ja)|0)<<2)|0;bb=b[i>>0]&1?Aa:La;$a=0;m:while(1){if(($a|0)<(bb|0)){xa=$a;do{ab=xa-((xa|0)>(ka|0)?_a:0)|0;Xa=(xa|0)<(Aa|0)?ab:xa-Aa|0;ga=((xa|0)<(Na|0)?_a:0)+xa|0;va=(xa|0)<(wa|0)?xa+Aa|0:ga;f[k>>2]=f[oa+(Xa<<2)>>2];ea=f[oa+(ab<<2)>>2]|0;f[l>>2]=ea;Qa=f[oa+(xa<<2)>>2]|0;f[m>>2]=Qa;f[o>>2]=f[oa+(ga<<2)>>2];f[p>>2]=f[oa+(va<<2)>>2];f[q>>2]=f[sa+(Xa<<2)>>2];f[r>>2]=f[sa+(ab<<2)>>2];f[t>>2]=f[sa+(xa<<2)>>2];f[v>>2]=f[sa+(ga<<2)>>2];f[w>>2]=f[sa+(va<<2)>>2];f[x>>2]=f[Oa+(Xa<<2)>>2];f[y>>2]=f[Oa+(ab<<2)>>2];f[z>>2]=f[Oa+(xa<<2)>>2];f[A>>2]=f[Oa+(ga<<2)>>2];f[B>>2]=f[Oa+(va<<2)>>2];f[C>>2]=f[na+(Xa<<2)>>2];f[D>>2]=f[na+(ab<<2)>>2];f[E>>2]=f[na+(xa<<2)>>2];f[F>>2]=f[na+(ga<<2)>>2];f[G>>2]=f[na+(va<<2)>>2];f[H>>2]=f[pa+(Xa<<2)>>2];f[I>>2]=f[pa+(ab<<2)>>2];f[J>>2]=f[pa+(xa<<2)>>2];f[K>>2]=f[pa+(ga<<2)>>2];f[L>>2]=f[pa+(va<<2)>>2];kc=(f[s>>2]=ea,+n[s>>2]);nc=(f[s>>2]=Qa,+n[s>>2]);Qa=nc<kc;ea=f[(Qa?m:l)>>2]|0;f[l>>2]=ea;mc=Qa?kc:nc;n[m>>2]=mc;nc=+n[k>>2];kc=(f[s>>2]=ea,+n[s>>2]);ea=kc<nc;Qa=f[(ea?l:k)>>2]|0;f[k>>2]=Qa;oc=ea?nc:kc;n[l>>2]=oc;ea=mc<oc;va=f[(ea?m:l)>>2]|0;f[l>>2]=va;kc=ea?oc:mc;n[m>>2]=kc;mc=+n[p>>2];oc=+n[q>>2];ea=oc<mc;ga=f[(ea?q:p)>>2]|0;f[p>>2]=ga;nc=ea?mc:oc;n[q>>2]=nc;oc=+n[o>>2];mc=(f[s>>2]=ga,+n[s>>2]);ga=mc<oc;ea=f[(ga?p:o)>>2]|0;f[o>>2]=ea;ma=ga?oc:mc;n[p>>2]=ma;ga=nc<ma;ab=f[(ga?q:p)>>2]|0;f[p>>2]=ab;mc=ga?ma:nc;n[q>>2]=mc;nc=(f[s>>2]=Qa,+n[s>>2]);ma=(f[s>>2]=ea,+n[s>>2]);ea=ma<nc;f[k>>2]=f[(ea?o:k)>>2];oc=ea?nc:ma;n[o>>2]=oc;ea=mc<kc;Qa=f[(ea?q:m)>>2]|0;f[m>>2]=Qa;n[q>>2]=ea?kc:mc;mc=(f[s>>2]=Qa,+n[s>>2]);Qa=oc<mc;ea=f[(Qa?o:m)>>2]|0;f[m>>2]=ea;kc=Qa?mc:oc;n[o>>2]=kc;oc=(f[s>>2]=va,+n[s>>2]);mc=(f[s>>2]=ab,+n[s>>2]);ab=mc<oc;va=f[(ab?p:l)>>2]|0;f[l>>2]=va;ma=ab?oc:mc;n[p>>2]=ma;mc=(f[s>>2]=va,+n[s>>2]);oc=(f[s>>2]=ea,+n[s>>2]);ea=oc<mc;f[l>>2]=f[(ea?m:l)>>2];n[m>>2]=ea?mc:oc;ea=ma<kc;f[o>>2]=f[(ea?p:o)>>2];n[p>>2]=ea?kc:ma;ma=+n[t>>2];kc=+n[v>>2];ea=kc<ma;va=f[(ea?v:t)>>2]|0;f[t>>2]=va;oc=ea?ma:kc;n[v>>2]=oc;kc=+n[r>>2];ma=(f[s>>2]=va,+n[s>>2]);va=ma<kc;ea=f[(va?t:r)>>2]|0;f[r>>2]=ea;mc=va?kc:ma;n[t>>2]=mc;va=oc<mc;ab=f[(va?v:t)>>2]|0;f[t>>2]=ab;ma=va?mc:oc;n[v>>2]=ma;oc=+n[x>>2];mc=+n[y>>2];va=mc<oc;Qa=f[(va?y:x)>>2]|0;f[x>>2]=Qa;kc=va?oc:mc;n[y>>2]=kc;mc=+n[w>>2];oc=(f[s>>2]=Qa,+n[s>>2]);Qa=oc<mc;va=f[(Qa?x:w)>>2]|0;f[w>>2]=va;nc=Qa?mc:oc;n[x>>2]=nc;Qa=kc<nc;ga=f[(Qa?y:x)>>2]|0;f[x>>2]=ga;oc=Qa?nc:kc;n[y>>2]=oc;kc=(f[s>>2]=ea,+n[s>>2]);nc=(f[s>>2]=va,+n[s>>2]);va=nc<kc;ea=f[(va?w:r)>>2]|0;f[r>>2]=ea;mc=va?kc:nc;n[w>>2]=mc;va=oc<ma;Qa=f[(va?y:v)>>2]|0;f[v>>2]=Qa;nc=va?ma:oc;n[y>>2]=nc;oc=(f[s>>2]=Qa,+n[s>>2]);Qa=mc<oc;va=f[(Qa?w:v)>>2]|0;f[v>>2]=va;ma=Qa?oc:mc;n[w>>2]=ma;mc=(f[s>>2]=ab,+n[s>>2]);oc=(f[s>>2]=ga,+n[s>>2]);ga=oc<mc;ab=f[(ga?x:t)>>2]|0;f[t>>2]=ab;kc=ga?mc:oc;n[x>>2]=kc;oc=(f[s>>2]=ab,+n[s>>2]);mc=(f[s>>2]=va,+n[s>>2]);va=mc<oc;ab=f[(va?v:t)>>2]|0;f[t>>2]=ab;qc=va?oc:mc;n[v>>2]=qc;va=kc<ma;ga=f[(va?x:w)>>2]|0;f[w>>2]=ga;mc=va?ma:kc;n[x>>2]=mc;kc=+n[k>>2];ma=(f[s>>2]=ea,+n[s>>2]);ea=ma<kc;f[k>>2]=f[(ea?r:k)>>2];oc=ea?kc:ma;n[r>>2]=oc;ma=+n[p>>2];ea=mc<ma;va=f[(ea?x:p)>>2]|0;f[p>>2]=va;n[x>>2]=ea?ma:mc;mc=(f[s>>2]=va,+n[s>>2]);va=oc<mc;ea=f[(va?r:p)>>2]|0;f[p>>2]=ea;ma=va?mc:oc;n[r>>2]=ma;oc=+n[m>>2];va=qc<oc;Qa=f[(va?v:m)>>2]|0;f[m>>2]=Qa;mc=va?oc:qc;n[v>>2]=mc;qc=(f[s>>2]=Qa,+n[s>>2]);oc=(f[s>>2]=ea,+n[s>>2]);ea=oc<qc;Qa=f[(ea?p:m)>>2]|0;f[m>>2]=Qa;kc=ea?qc:oc;n[p>>2]=kc;ea=mc<ma;va=f[(ea?v:r)>>2]|0;f[r>>2]=va;oc=ea?ma:mc;n[v>>2]=oc;mc=+n[l>>2];ma=(f[s>>2]=ab,+n[s>>2]);ab=ma<mc;ea=f[(ab?t:l)>>2]|0;f[l>>2]=ea;qc=ab?mc:ma;n[t>>2]=qc;ma=+n[q>>2];ab=nc<ma;Xa=f[(ab?y:q)>>2]|0;f[q>>2]=Xa;n[y>>2]=ab?ma:nc;nc=(f[s>>2]=Xa,+n[s>>2]);Xa=qc<nc;ab=f[(Xa?t:q)>>2]|0;f[q>>2]=ab;ma=Xa?nc:qc;n[t>>2]=ma;qc=+n[o>>2];nc=(f[s>>2]=ga,+n[s>>2]);ga=nc<qc;Xa=f[(ga?w:o)>>2]|0;f[o>>2]=Xa;mc=ga?qc:nc;n[w>>2]=mc;nc=(f[s>>2]=Xa,+n[s>>2]);qc=(f[s>>2]=ab,+n[s>>2]);ab=qc<nc;Xa=f[(ab?q:o)>>2]|0;f[o>>2]=Xa;pc=ab?nc:qc;n[q>>2]=pc;ab=mc<ma;ga=f[(ab?w:t)>>2]|0;f[t>>2]=ga;qc=ab?ma:mc;n[w>>2]=qc;mc=(f[s>>2]=ea,+n[s>>2]);ma=(f[s>>2]=Qa,+n[s>>2]);Qa=ma<mc;f[l>>2]=f[(Qa?m:l)>>2];n[m>>2]=Qa?mc:ma;ma=(f[s>>2]=Xa,+n[s>>2]);Xa=kc<ma;f[o>>2]=f[(Xa?p:o)>>2];n[p>>2]=Xa?ma:kc;kc=(f[s>>2]=va,+n[s>>2]);va=kc<pc;f[q>>2]=f[(va?r:q)>>2];n[r>>2]=va?pc:kc;kc=(f[s>>2]=ga,+n[s>>2]);ga=oc<kc;f[t>>2]=f[(ga?v:t)>>2];n[v>>2]=ga?kc:oc;oc=+n[x>>2];ga=oc<qc;f[w>>2]=f[(ga?x:w)>>2];n[x>>2]=ga?qc:oc;oc=+n[A>>2];qc=+n[B>>2];ga=qc<oc;va=f[(ga?B:A)>>2]|0;f[A>>2]=va;kc=ga?oc:qc;n[B>>2]=kc;qc=+n[z>>2];oc=(f[s>>2]=va,+n[s>>2]);va=oc<qc;ga=f[(va?A:z)>>2]|0;f[z>>2]=ga;pc=va?qc:oc;n[A>>2]=pc;va=kc<pc;Xa=f[(va?B:A)>>2]|0;f[A>>2]=Xa;oc=va?pc:kc;n[B>>2]=oc;kc=+n[D>>2];pc=+n[E>>2];va=pc<kc;Qa=f[(va?E:D)>>2]|0;f[D>>2]=Qa;qc=va?kc:pc;n[E>>2]=qc;pc=+n[C>>2];kc=(f[s>>2]=Qa,+n[s>>2]);Qa=kc<pc;va=f[(Qa?D:C)>>2]|0;f[C>>2]=va;ma=Qa?pc:kc;n[D>>2]=ma;Qa=qc<ma;ea=f[(Qa?E:D)>>2]|0;f[D>>2]=ea;kc=Qa?ma:qc;n[E>>2]=kc;qc=(f[s>>2]=ga,+n[s>>2]);ma=(f[s>>2]=va,+n[s>>2]);va=ma<qc;f[z>>2]=f[(va?C:z)>>2];pc=va?qc:ma;n[C>>2]=pc;va=kc<oc;ga=f[(va?E:B)>>2]|0;f[B>>2]=ga;n[E>>2]=va?oc:kc;kc=(f[s>>2]=ga,+n[s>>2]);ga=pc<kc;va=f[(ga?C:B)>>2]|0;f[B>>2]=va;oc=ga?kc:pc;n[C>>2]=oc;pc=(f[s>>2]=Xa,+n[s>>2]);kc=(f[s>>2]=ea,+n[s>>2]);ea=kc<pc;Xa=f[(ea?D:A)>>2]|0;f[A>>2]=Xa;ma=ea?pc:kc;n[D>>2]=ma;kc=(f[s>>2]=Xa,+n[s>>2]);pc=(f[s>>2]=va,+n[s>>2]);va=pc<kc;f[A>>2]=f[(va?B:A)>>2];n[B>>2]=va?kc:pc;va=ma<oc;f[C>>2]=f[(va?D:C)>>2];n[D>>2]=va?oc:ma;ma=+n[G>>2];oc=+n[H>>2];va=oc<ma;Xa=f[(va?H:G)>>2]|0;f[G>>2]=Xa;pc=va?ma:oc;n[H>>2]=pc;oc=+n[F>>2];ma=(f[s>>2]=Xa,+n[s>>2]);Xa=ma<oc;va=f[(Xa?G:F)>>2]|0;f[F>>2]=va;kc=Xa?oc:ma;n[G>>2]=kc;Xa=pc<kc;ea=f[(Xa?H:G)>>2]|0;f[G>>2]=ea;ma=Xa?kc:pc;n[H>>2]=ma;pc=+n[I>>2];kc=+n[J>>2];Xa=kc<pc;ga=f[(Xa?J:I)>>2]|0;f[I>>2]=ga;oc=Xa?pc:kc;n[J>>2]=oc;kc=+n[K>>2];pc=+n[L>>2];Xa=pc<kc;Qa=f[(Xa?L:K)>>2]|0;f[K>>2]=Qa;qc=Xa?kc:pc;n[L>>2]=qc;pc=(f[s>>2]=ga,+n[s>>2]);kc=(f[s>>2]=Qa,+n[s>>2]);Qa=kc<pc;ga=f[(Qa?K:I)>>2]|0;f[I>>2]=ga;mc=Qa?pc:kc;n[K>>2]=mc;Qa=qc<oc;Xa=f[(Qa?L:J)>>2]|0;f[J>>2]=Xa;kc=Qa?oc:qc;n[L>>2]=kc;qc=(f[s>>2]=Xa,+n[s>>2]);Xa=mc<qc;Qa=f[(Xa?K:J)>>2]|0;f[J>>2]=Qa;oc=Xa?qc:mc;n[K>>2]=oc;mc=(f[s>>2]=va,+n[s>>2]);qc=(f[s>>2]=ga,+n[s>>2]);ga=qc<mc;va=f[(ga?I:F)>>2]|0;f[F>>2]=va;pc=ga?mc:qc;n[I>>2]=pc;ga=oc<ma;Xa=f[(ga?K:H)>>2]|0;f[H>>2]=Xa;qc=ga?ma:oc;n[K>>2]=qc;oc=(f[s>>2]=Xa,+n[s>>2]);Xa=pc<oc;ga=f[(Xa?I:H)>>2]|0;f[H>>2]=ga;ma=Xa?oc:pc;n[I>>2]=ma;pc=(f[s>>2]=ea,+n[s>>2]);oc=(f[s>>2]=Qa,+n[s>>2]);Qa=oc<pc;ea=f[(Qa?J:G)>>2]|0;f[G>>2]=ea;mc=Qa?pc:oc;n[J>>2]=mc;Qa=kc<mc;Xa=f[(Qa?L:J)>>2]|0;f[J>>2]=Xa;oc=Qa?mc:kc;n[L>>2]=oc;kc=(f[s>>2]=ea,+n[s>>2]);mc=(f[s>>2]=ga,+n[s>>2]);ga=mc<kc;ea=f[(ga?H:G)>>2]|0;f[G>>2]=ea;pc=ga?kc:mc;n[H>>2]=pc;mc=(f[s>>2]=Xa,+n[s>>2]);Xa=mc<ma;f[I>>2]=f[(Xa?J:I)>>2];kc=Xa?ma:mc;n[J>>2]=kc;Xa=oc<qc;ga=f[(Xa?L:K)>>2]|0;f[K>>2]=ga;mc=Xa?qc:oc;n[L>>2]=mc;oc=+n[z>>2];qc=(f[s>>2]=va,+n[s>>2]);va=qc<oc;f[z>>2]=f[(va?F:z)>>2];ma=va?oc:qc;n[F>>2]=ma;qc=+n[D>>2];va=kc<qc;Xa=f[(va?J:D)>>2]|0;f[D>>2]=Xa;oc=va?qc:kc;n[J>>2]=oc;kc=(f[s>>2]=Xa,+n[s>>2]);Xa=ma<kc;va=f[(Xa?F:D)>>2]|0;f[D>>2]=va;qc=Xa?kc:ma;n[F>>2]=qc;ma=+n[B>>2];Xa=pc<ma;Qa=f[(Xa?H:B)>>2]|0;f[B>>2]=Qa;kc=Xa?ma:pc;n[H>>2]=kc;Xa=mc<kc;ab=f[(Xa?L:H)>>2]|0;f[H>>2]=ab;pc=Xa?kc:mc;n[L>>2]=pc;mc=(f[s>>2]=Qa,+n[s>>2]);kc=(f[s>>2]=va,+n[s>>2]);va=kc<mc;Qa=f[(va?D:B)>>2]|0;f[B>>2]=Qa;ma=va?mc:kc;n[D>>2]=ma;kc=(f[s>>2]=ab,+n[s>>2]);ab=kc<qc;va=f[(ab?H:F)>>2]|0;f[F>>2]=va;mc=ab?qc:kc;n[H>>2]=mc;ab=pc<oc;Xa=f[(ab?L:J)>>2]|0;f[J>>2]=Xa;kc=ab?oc:pc;n[L>>2]=kc;pc=+n[A>>2];oc=(f[s>>2]=ea,+n[s>>2]);ea=oc<pc;ab=f[(ea?G:A)>>2]|0;f[A>>2]=ab;qc=ea?pc:oc;n[G>>2]=qc;oc=+n[E>>2];pc=(f[s>>2]=ga,+n[s>>2]);ga=pc<oc;ea=f[(ga?K:E)>>2]|0;f[E>>2]=ea;nc=ga?oc:pc;n[K>>2]=nc;pc=(f[s>>2]=ea,+n[s>>2]);ea=qc<pc;ga=f[(ea?G:E)>>2]|0;f[E>>2]=ga;oc=ea?pc:qc;n[G>>2]=oc;qc=+n[C>>2];pc=+n[I>>2];ea=pc<qc;lb=f[(ea?I:C)>>2]|0;f[C>>2]=lb;lc=ea?qc:pc;n[I>>2]=lc;pc=(f[s>>2]=lb,+n[s>>2]);qc=(f[s>>2]=ga,+n[s>>2]);ga=qc<pc;lb=f[(ga?E:C)>>2]|0;f[C>>2]=lb;tc=ga?pc:qc;n[E>>2]=tc;ga=lc<oc;ea=f[(ga?I:G)>>2]|0;f[G>>2]=ea;qc=ga?oc:lc;n[I>>2]=qc;lc=(f[s>>2]=ab,+n[s>>2]);oc=(f[s>>2]=Qa,+n[s>>2]);Qa=oc<lc;f[A>>2]=f[(Qa?B:A)>>2];pc=Qa?lc:oc;n[B>>2]=pc;oc=(f[s>>2]=lb,+n[s>>2]);lb=ma<oc;f[C>>2]=f[(lb?D:C)>>2];lc=lb?oc:ma;n[D>>2]=lc;ma=(f[s>>2]=va,+n[s>>2]);va=ma<tc;f[E>>2]=f[(va?F:E)>>2];oc=va?tc:ma;n[F>>2]=oc;ma=(f[s>>2]=ea,+n[s>>2]);ea=mc<ma;f[G>>2]=f[(ea?H:G)>>2];tc=ea?ma:mc;n[H>>2]=tc;mc=(f[s>>2]=Xa,+n[s>>2]);Xa=mc<qc;f[I>>2]=f[(Xa?J:I)>>2];ma=Xa?qc:mc;n[J>>2]=ma;Xa=kc<nc;f[K>>2]=f[(Xa?L:K)>>2];mc=Xa?nc:kc;n[L>>2]=mc;kc=+n[k>>2];nc=+n[z>>2];Xa=nc<kc;f[k>>2]=f[(Xa?z:k)>>2];qc=Xa?kc:nc;n[z>>2]=qc;nc=+n[v>>2];Xa=tc<nc;ea=f[(Xa?H:v)>>2]|0;f[v>>2]=ea;n[H>>2]=Xa?nc:tc;tc=(f[s>>2]=ea,+n[s>>2]);ea=qc<tc;f[v>>2]=f[(ea?z:v)>>2];nc=ea?tc:qc;n[z>>2]=nc;qc=+n[p>>2];ea=lc<qc;f[p>>2]=f[(ea?D:p)>>2];tc=ea?qc:lc;n[D>>2]=tc;ea=mc<tc;Xa=f[(ea?L:D)>>2]|0;f[D>>2]=Xa;n[L>>2]=ea?tc:mc;mc=(f[s>>2]=Xa,+n[s>>2]);Xa=mc<nc;ea=f[(Xa?D:z)>>2]|0;f[z>>2]=ea;n[D>>2]=Xa?nc:mc;mc=+n[m>>2];Xa=pc<mc;f[m>>2]=f[(Xa?B:m)>>2];nc=Xa?mc:pc;n[B>>2]=nc;Xa=f[(ma<+n[x>>2]?J:x)>>2]|0;f[x>>2]=Xa;va=f[(nc<(f[s>>2]=Xa,+n[s>>2])?B:x)>>2]|0;f[x>>2]=va;Xa=f[(oc<+n[r>>2]?F:r)>>2]|0;f[r>>2]=Xa;oc=(f[s>>2]=Xa,+n[s>>2]);nc=(f[s>>2]=va,+n[s>>2]);ma=nc<oc?oc:nc;n[x>>2]=ma;nc=(f[s>>2]=ea,+n[s>>2]);oc=nc<ma?ma:nc;nc=+n[l>>2];ma=+n[A>>2];pc=ma<nc?nc:ma;n[A>>2]=pc;ea=f[(+n[I>>2]<+n[w>>2]?I:w)>>2]|0;f[w>>2]=ea;ma=(f[s>>2]=ea,+n[s>>2]);nc=pc<ma?ma:pc;n[A>>2]=nc;pc=+n[q>>2];ma=+n[E>>2];mc=ma<pc?pc:ma;n[E>>2]=mc;ma=mc<nc?mc:+n[A>>2];mc=+n[o>>2];nc=+n[C>>2];pc=nc<mc?mc:nc;n[C>>2]=pc;ea=f[(+n[K>>2]<+n[y>>2]?K:y)>>2]|0;f[y>>2]=ea;va=pc<(f[s>>2]=ea,+n[s>>2]);pc=va?+n[C>>2]:(f[s>>2]=ea,+n[s>>2]);nc=+n[t>>2];mc=+n[G>>2];tc=mc<nc?mc:nc;nc=pc<tc?tc:pc;pc=ma<nc?ma:nc;n[Ca+(xa<<2)>>2]=oc<pc?pc:oc;xa=xa+1|0}while((xa|0)!=(bb|0));uc=bb}else uc=$a;if((bb|0)==(La|0))break;if((uc|0)>(za|0)){bb=La;$a=uc;continue}else vc=uc;while(1){xa=oa+(vc<<2)|0;f[k>>2]=f[xa+(Va<<2)>>2];ea=f[xa+(ia<<2)>>2]|0;f[l>>2]=ea;va=f[xa>>2]|0;f[m>>2]=va;f[o>>2]=f[xa+(_a<<2)>>2];f[p>>2]=f[xa+(Aa<<2)>>2];xa=sa+(vc<<2)|0;f[q>>2]=f[xa+(Va<<2)>>2];f[r>>2]=f[xa+(ia<<2)>>2];f[t>>2]=f[xa>>2];f[v>>2]=f[xa+(_a<<2)>>2];f[w>>2]=f[xa+(Aa<<2)>>2];xa=Oa+(vc<<2)|0;f[x>>2]=f[xa+(Va<<2)>>2];f[y>>2]=f[xa+(ia<<2)>>2];f[z>>2]=f[xa>>2];f[A>>2]=f[xa+(_a<<2)>>2];f[B>>2]=f[xa+(Aa<<2)>>2];xa=na+(vc<<2)|0;f[C>>2]=f[xa+(Va<<2)>>2];f[D>>2]=f[xa+(ia<<2)>>2];f[E>>2]=f[xa>>2];f[F>>2]=f[xa+(_a<<2)>>2];f[G>>2]=f[xa+(Aa<<2)>>2];xa=pa+(vc<<2)|0;f[H>>2]=f[xa+(Va<<2)>>2];f[I>>2]=f[xa+(ia<<2)>>2];f[J>>2]=f[xa>>2];f[K>>2]=f[xa+(_a<<2)>>2];f[L>>2]=f[xa+(Aa<<2)>>2];oc=(f[s>>2]=ea,+n[s>>2]);pc=(f[s>>2]=va,+n[s>>2]);va=pc<oc;ea=f[(va?m:l)>>2]|0;f[l>>2]=ea;nc=va?oc:pc;n[m>>2]=nc;pc=+n[k>>2];oc=(f[s>>2]=ea,+n[s>>2]);ea=oc<pc;va=f[(ea?l:k)>>2]|0;f[k>>2]=va;ma=ea?pc:oc;n[l>>2]=ma;ea=nc<ma;xa=f[(ea?m:l)>>2]|0;f[l>>2]=xa;oc=ea?ma:nc;n[m>>2]=oc;nc=+n[p>>2];ma=+n[q>>2];ea=ma<nc;Xa=f[(ea?q:p)>>2]|0;f[p>>2]=Xa;pc=ea?nc:ma;n[q>>2]=pc;ma=+n[o>>2];nc=(f[s>>2]=Xa,+n[s>>2]);Xa=nc<ma;ea=f[(Xa?p:o)>>2]|0;f[o>>2]=ea;tc=Xa?ma:nc;n[p>>2]=tc;Xa=pc<tc;lb=f[(Xa?q:p)>>2]|0;f[p>>2]=lb;nc=Xa?tc:pc;n[q>>2]=nc;pc=(f[s>>2]=va,+n[s>>2]);tc=(f[s>>2]=ea,+n[s>>2]);ea=tc<pc;f[k>>2]=f[(ea?o:k)>>2];ma=ea?pc:tc;n[o>>2]=ma;ea=nc<oc;va=f[(ea?q:m)>>2]|0;f[m>>2]=va;n[q>>2]=ea?oc:nc;nc=(f[s>>2]=va,+n[s>>2]);va=ma<nc;ea=f[(va?o:m)>>2]|0;f[m>>2]=ea;oc=va?nc:ma;n[o>>2]=oc;ma=(f[s>>2]=xa,+n[s>>2]);nc=(f[s>>2]=lb,+n[s>>2]);lb=nc<ma;xa=f[(lb?p:l)>>2]|0;f[l>>2]=xa;tc=lb?ma:nc;n[p>>2]=tc;nc=(f[s>>2]=xa,+n[s>>2]);ma=(f[s>>2]=ea,+n[s>>2]);ea=ma<nc;f[l>>2]=f[(ea?m:l)>>2];n[m>>2]=ea?nc:ma;ea=tc<oc;f[o>>2]=f[(ea?p:o)>>2];n[p>>2]=ea?oc:tc;tc=+n[t>>2];oc=+n[v>>2];ea=oc<tc;xa=f[(ea?v:t)>>2]|0;f[t>>2]=xa;ma=ea?tc:oc;n[v>>2]=ma;oc=+n[r>>2];tc=(f[s>>2]=xa,+n[s>>2]);xa=tc<oc;ea=f[(xa?t:r)>>2]|0;f[r>>2]=ea;nc=xa?oc:tc;n[t>>2]=nc;xa=ma<nc;lb=f[(xa?v:t)>>2]|0;f[t>>2]=lb;tc=xa?nc:ma;n[v>>2]=tc;ma=+n[x>>2];nc=+n[y>>2];xa=nc<ma;va=f[(xa?y:x)>>2]|0;f[x>>2]=va;oc=xa?ma:nc;n[y>>2]=oc;nc=+n[w>>2];ma=(f[s>>2]=va,+n[s>>2]);va=ma<nc;xa=f[(va?x:w)>>2]|0;f[w>>2]=xa;pc=va?nc:ma;n[x>>2]=pc;va=oc<pc;Xa=f[(va?y:x)>>2]|0;f[x>>2]=Xa;ma=va?pc:oc;n[y>>2]=ma;oc=(f[s>>2]=ea,+n[s>>2]);pc=(f[s>>2]=xa,+n[s>>2]);xa=pc<oc;ea=f[(xa?w:r)>>2]|0;f[r>>2]=ea;nc=xa?oc:pc;n[w>>2]=nc;xa=ma<tc;va=f[(xa?y:v)>>2]|0;f[v>>2]=va;pc=xa?tc:ma;n[y>>2]=pc;ma=(f[s>>2]=va,+n[s>>2]);va=nc<ma;xa=f[(va?w:v)>>2]|0;f[v>>2]=xa;tc=va?ma:nc;n[w>>2]=tc;nc=(f[s>>2]=lb,+n[s>>2]);ma=(f[s>>2]=Xa,+n[s>>2]);Xa=ma<nc;lb=f[(Xa?x:t)>>2]|0;f[t>>2]=lb;oc=Xa?nc:ma;n[x>>2]=oc;ma=(f[s>>2]=lb,+n[s>>2]);nc=(f[s>>2]=xa,+n[s>>2]);xa=nc<ma;lb=f[(xa?v:t)>>2]|0;f[t>>2]=lb;mc=xa?ma:nc;n[v>>2]=mc;xa=oc<tc;Xa=f[(xa?x:w)>>2]|0;f[w>>2]=Xa;nc=xa?tc:oc;n[x>>2]=nc;oc=+n[k>>2];tc=(f[s>>2]=ea,+n[s>>2]);ea=tc<oc;f[k>>2]=f[(ea?r:k)>>2];ma=ea?oc:tc;n[r>>2]=ma;tc=+n[p>>2];ea=nc<tc;xa=f[(ea?x:p)>>2]|0;f[p>>2]=xa;n[x>>2]=ea?tc:nc;nc=(f[s>>2]=xa,+n[s>>2]);xa=ma<nc;ea=f[(xa?r:p)>>2]|0;f[p>>2]=ea;tc=xa?nc:ma;n[r>>2]=tc;ma=+n[m>>2];xa=mc<ma;va=f[(xa?v:m)>>2]|0;f[m>>2]=va;nc=xa?ma:mc;n[v>>2]=nc;mc=(f[s>>2]=va,+n[s>>2]);ma=(f[s>>2]=ea,+n[s>>2]);ea=ma<mc;va=f[(ea?p:m)>>2]|0;f[m>>2]=va;oc=ea?mc:ma;n[p>>2]=oc;ea=nc<tc;xa=f[(ea?v:r)>>2]|0;f[r>>2]=xa;ma=ea?tc:nc;n[v>>2]=ma;nc=+n[l>>2];tc=(f[s>>2]=lb,+n[s>>2]);lb=tc<nc;ea=f[(lb?t:l)>>2]|0;f[l>>2]=ea;mc=lb?nc:tc;n[t>>2]=mc;tc=+n[q>>2];lb=pc<tc;Qa=f[(lb?y:q)>>2]|0;f[q>>2]=Qa;n[y>>2]=lb?tc:pc;pc=(f[s>>2]=Qa,+n[s>>2]);Qa=mc<pc;lb=f[(Qa?t:q)>>2]|0;f[q>>2]=lb;tc=Qa?pc:mc;n[t>>2]=tc;mc=+n[o>>2];pc=(f[s>>2]=Xa,+n[s>>2]);Xa=pc<mc;Qa=f[(Xa?w:o)>>2]|0;f[o>>2]=Qa;nc=Xa?mc:pc;n[w>>2]=nc;pc=(f[s>>2]=Qa,+n[s>>2]);mc=(f[s>>2]=lb,+n[s>>2]);lb=mc<pc;Qa=f[(lb?q:o)>>2]|0;f[o>>2]=Qa;lc=lb?pc:mc;n[q>>2]=lc;lb=nc<tc;Xa=f[(lb?w:t)>>2]|0;f[t>>2]=Xa;mc=lb?tc:nc;n[w>>2]=mc;nc=(f[s>>2]=ea,+n[s>>2]);tc=(f[s>>2]=va,+n[s>>2]);va=tc<nc;f[l>>2]=f[(va?m:l)>>2];n[m>>2]=va?nc:tc;tc=(f[s>>2]=Qa,+n[s>>2]);Qa=oc<tc;f[o>>2]=f[(Qa?p:o)>>2];n[p>>2]=Qa?tc:oc;oc=(f[s>>2]=xa,+n[s>>2]);xa=oc<lc;f[q>>2]=f[(xa?r:q)>>2];n[r>>2]=xa?lc:oc;oc=(f[s>>2]=Xa,+n[s>>2]);Xa=ma<oc;f[t>>2]=f[(Xa?v:t)>>2];n[v>>2]=Xa?oc:ma;ma=+n[x>>2];Xa=ma<mc;f[w>>2]=f[(Xa?x:w)>>2];n[x>>2]=Xa?mc:ma;ma=+n[A>>2];mc=+n[B>>2];Xa=mc<ma;xa=f[(Xa?B:A)>>2]|0;f[A>>2]=xa;oc=Xa?ma:mc;n[B>>2]=oc;mc=+n[z>>2];ma=(f[s>>2]=xa,+n[s>>2]);xa=ma<mc;Xa=f[(xa?A:z)>>2]|0;f[z>>2]=Xa;lc=xa?mc:ma;n[A>>2]=lc;xa=oc<lc;Qa=f[(xa?B:A)>>2]|0;f[A>>2]=Qa;ma=xa?lc:oc;n[B>>2]=ma;oc=+n[D>>2];lc=+n[E>>2];xa=lc<oc;va=f[(xa?E:D)>>2]|0;f[D>>2]=va;mc=xa?oc:lc;n[E>>2]=mc;lc=+n[C>>2];oc=(f[s>>2]=va,+n[s>>2]);va=oc<lc;xa=f[(va?D:C)>>2]|0;f[C>>2]=xa;tc=va?lc:oc;n[D>>2]=tc;va=mc<tc;ea=f[(va?E:D)>>2]|0;f[D>>2]=ea;oc=va?tc:mc;n[E>>2]=oc;mc=(f[s>>2]=Xa,+n[s>>2]);tc=(f[s>>2]=xa,+n[s>>2]);xa=tc<mc;f[z>>2]=f[(xa?C:z)>>2];lc=xa?mc:tc;n[C>>2]=lc;xa=oc<ma;Xa=f[(xa?E:B)>>2]|0;f[B>>2]=Xa;n[E>>2]=xa?ma:oc;oc=(f[s>>2]=Xa,+n[s>>2]);Xa=lc<oc;xa=f[(Xa?C:B)>>2]|0;f[B>>2]=xa;ma=Xa?oc:lc;n[C>>2]=ma;lc=(f[s>>2]=Qa,+n[s>>2]);oc=(f[s>>2]=ea,+n[s>>2]);ea=oc<lc;Qa=f[(ea?D:A)>>2]|0;f[A>>2]=Qa;tc=ea?lc:oc;n[D>>2]=tc;oc=(f[s>>2]=Qa,+n[s>>2]);lc=(f[s>>2]=xa,+n[s>>2]);xa=lc<oc;f[A>>2]=f[(xa?B:A)>>2];n[B>>2]=xa?oc:lc;xa=tc<ma;f[C>>2]=f[(xa?D:C)>>2];n[D>>2]=xa?ma:tc;tc=+n[G>>2];ma=+n[H>>2];xa=ma<tc;Qa=f[(xa?H:G)>>2]|0;f[G>>2]=Qa;lc=xa?tc:ma;n[H>>2]=lc;ma=+n[F>>2];tc=(f[s>>2]=Qa,+n[s>>2]);Qa=tc<ma;xa=f[(Qa?G:F)>>2]|0;f[F>>2]=xa;oc=Qa?ma:tc;n[G>>2]=oc;Qa=lc<oc;ea=f[(Qa?H:G)>>2]|0;f[G>>2]=ea;tc=Qa?oc:lc;n[H>>2]=tc;lc=+n[I>>2];oc=+n[J>>2];Qa=oc<lc;Xa=f[(Qa?J:I)>>2]|0;f[I>>2]=Xa;ma=Qa?lc:oc;n[J>>2]=ma;oc=+n[K>>2];lc=+n[L>>2];Qa=lc<oc;va=f[(Qa?L:K)>>2]|0;f[K>>2]=va;mc=Qa?oc:lc;n[L>>2]=mc;lc=(f[s>>2]=Xa,+n[s>>2]);oc=(f[s>>2]=va,+n[s>>2]);va=oc<lc;Xa=f[(va?K:I)>>2]|0;f[I>>2]=Xa;nc=va?lc:oc;n[K>>2]=nc;va=mc<ma;Qa=f[(va?L:J)>>2]|0;f[J>>2]=Qa;oc=va?ma:mc;n[L>>2]=oc;mc=(f[s>>2]=Qa,+n[s>>2]);Qa=nc<mc;va=f[(Qa?K:J)>>2]|0;f[J>>2]=va;ma=Qa?mc:nc;n[K>>2]=ma;nc=(f[s>>2]=xa,+n[s>>2]);mc=(f[s>>2]=Xa,+n[s>>2]);Xa=mc<nc;xa=f[(Xa?I:F)>>2]|0;f[F>>2]=xa;lc=Xa?nc:mc;n[I>>2]=lc;Xa=ma<tc;Qa=f[(Xa?K:H)>>2]|0;f[H>>2]=Qa;mc=Xa?tc:ma;n[K>>2]=mc;ma=(f[s>>2]=Qa,+n[s>>2]);Qa=lc<ma;Xa=f[(Qa?I:H)>>2]|0;f[H>>2]=Xa;tc=Qa?ma:lc;n[I>>2]=tc;lc=(f[s>>2]=ea,+n[s>>2]);ma=(f[s>>2]=va,+n[s>>2]);va=ma<lc;ea=f[(va?J:G)>>2]|0;f[G>>2]=ea;nc=va?lc:ma;n[J>>2]=nc;va=oc<nc;Qa=f[(va?L:J)>>2]|0;f[J>>2]=Qa;ma=va?nc:oc;n[L>>2]=ma;oc=(f[s>>2]=ea,+n[s>>2]);nc=(f[s>>2]=Xa,+n[s>>2]);Xa=nc<oc;ea=f[(Xa?H:G)>>2]|0;f[G>>2]=ea;lc=Xa?oc:nc;n[H>>2]=lc;nc=(f[s>>2]=Qa,+n[s>>2]);Qa=nc<tc;f[I>>2]=f[(Qa?J:I)>>2];oc=Qa?tc:nc;n[J>>2]=oc;Qa=ma<mc;Xa=f[(Qa?L:K)>>2]|0;f[K>>2]=Xa;nc=Qa?mc:ma;n[L>>2]=nc;ma=+n[z>>2];mc=(f[s>>2]=xa,+n[s>>2]);xa=mc<ma;f[z>>2]=f[(xa?F:z)>>2];tc=xa?ma:mc;n[F>>2]=tc;mc=+n[D>>2];xa=oc<mc;Qa=f[(xa?J:D)>>2]|0;f[D>>2]=Qa;ma=xa?mc:oc;n[J>>2]=ma;oc=(f[s>>2]=Qa,+n[s>>2]);Qa=tc<oc;xa=f[(Qa?F:D)>>2]|0;f[D>>2]=xa;mc=Qa?oc:tc;n[F>>2]=mc;tc=+n[B>>2];Qa=lc<tc;va=f[(Qa?H:B)>>2]|0;f[B>>2]=va;oc=Qa?tc:lc;n[H>>2]=oc;Qa=nc<oc;lb=f[(Qa?L:H)>>2]|0;f[H>>2]=lb;lc=Qa?oc:nc;n[L>>2]=lc;nc=(f[s>>2]=va,+n[s>>2]);oc=(f[s>>2]=xa,+n[s>>2]);xa=oc<nc;va=f[(xa?D:B)>>2]|0;f[B>>2]=va;tc=xa?nc:oc;n[D>>2]=tc;oc=(f[s>>2]=lb,+n[s>>2]);lb=oc<mc;xa=f[(lb?H:F)>>2]|0;f[F>>2]=xa;nc=lb?mc:oc;n[H>>2]=nc;lb=lc<ma;Qa=f[(lb?L:J)>>2]|0;f[J>>2]=Qa;oc=lb?ma:lc;n[L>>2]=oc;lc=+n[A>>2];ma=(f[s>>2]=ea,+n[s>>2]);ea=ma<lc;lb=f[(ea?G:A)>>2]|0;f[A>>2]=lb;mc=ea?lc:ma;n[G>>2]=mc;ma=+n[E>>2];lc=(f[s>>2]=Xa,+n[s>>2]);Xa=lc<ma;ea=f[(Xa?K:E)>>2]|0;f[E>>2]=ea;pc=Xa?ma:lc;n[K>>2]=pc;lc=(f[s>>2]=ea,+n[s>>2]);ea=mc<lc;Xa=f[(ea?G:E)>>2]|0;f[E>>2]=Xa;ma=ea?lc:mc;n[G>>2]=ma;mc=+n[C>>2];lc=+n[I>>2];ea=lc<mc;ab=f[(ea?I:C)>>2]|0;f[C>>2]=ab;qc=ea?mc:lc;n[I>>2]=qc;lc=(f[s>>2]=ab,+n[s>>2]);mc=(f[s>>2]=Xa,+n[s>>2]);Xa=mc<lc;ab=f[(Xa?E:C)>>2]|0;f[C>>2]=ab;kc=Xa?lc:mc;n[E>>2]=kc;Xa=qc<ma;ea=f[(Xa?I:G)>>2]|0;f[G>>2]=ea;mc=Xa?ma:qc;n[I>>2]=mc;qc=(f[s>>2]=lb,+n[s>>2]);ma=(f[s>>2]=va,+n[s>>2]);va=ma<qc;f[A>>2]=f[(va?B:A)>>2];lc=va?qc:ma;n[B>>2]=lc;ma=(f[s>>2]=ab,+n[s>>2]);ab=tc<ma;f[C>>2]=f[(ab?D:C)>>2];qc=ab?ma:tc;n[D>>2]=qc;tc=(f[s>>2]=xa,+n[s>>2]);xa=tc<kc;f[E>>2]=f[(xa?F:E)>>2];ma=xa?kc:tc;n[F>>2]=ma;tc=(f[s>>2]=ea,+n[s>>2]);ea=nc<tc;f[G>>2]=f[(ea?H:G)>>2];kc=ea?tc:nc;n[H>>2]=kc;nc=(f[s>>2]=Qa,+n[s>>2]);Qa=nc<mc;f[I>>2]=f[(Qa?J:I)>>2];tc=Qa?mc:nc;n[J>>2]=tc;Qa=oc<pc;f[K>>2]=f[(Qa?L:K)>>2];nc=Qa?pc:oc;n[L>>2]=nc;oc=+n[k>>2];pc=+n[z>>2];Qa=pc<oc;f[k>>2]=f[(Qa?z:k)>>2];mc=Qa?oc:pc;n[z>>2]=mc;pc=+n[v>>2];Qa=kc<pc;ea=f[(Qa?H:v)>>2]|0;f[v>>2]=ea;n[H>>2]=Qa?pc:kc;kc=(f[s>>2]=ea,+n[s>>2]);ea=mc<kc;f[v>>2]=f[(ea?z:v)>>2];pc=ea?kc:mc;n[z>>2]=pc;mc=+n[p>>2];ea=qc<mc;f[p>>2]=f[(ea?D:p)>>2];kc=ea?mc:qc;n[D>>2]=kc;ea=nc<kc;Qa=f[(ea?L:D)>>2]|0;f[D>>2]=Qa;n[L>>2]=ea?kc:nc;nc=(f[s>>2]=Qa,+n[s>>2]);Qa=nc<pc;ea=f[(Qa?D:z)>>2]|0;f[z>>2]=ea;n[D>>2]=Qa?pc:nc;nc=+n[m>>2];Qa=lc<nc;f[m>>2]=f[(Qa?B:m)>>2];pc=Qa?nc:lc;n[B>>2]=pc;Qa=f[(tc<+n[x>>2]?J:x)>>2]|0;f[x>>2]=Qa;xa=f[(pc<(f[s>>2]=Qa,+n[s>>2])?B:x)>>2]|0;f[x>>2]=xa;Qa=f[(ma<+n[r>>2]?F:r)>>2]|0;f[r>>2]=Qa;ma=(f[s>>2]=Qa,+n[s>>2]);pc=(f[s>>2]=xa,+n[s>>2]);tc=pc<ma?ma:pc;n[x>>2]=tc;pc=(f[s>>2]=ea,+n[s>>2]);ma=pc<tc?tc:pc;pc=+n[l>>2];tc=+n[A>>2];lc=tc<pc?pc:tc;n[A>>2]=lc;ea=f[(+n[I>>2]<+n[w>>2]?I:w)>>2]|0;f[w>>2]=ea;tc=(f[s>>2]=ea,+n[s>>2]);pc=lc<tc?tc:lc;n[A>>2]=pc;lc=+n[q>>2];tc=+n[E>>2];nc=tc<lc?lc:tc;n[E>>2]=nc;tc=nc<pc?nc:+n[A>>2];nc=+n[o>>2];pc=+n[C>>2];lc=pc<nc?nc:pc;n[C>>2]=lc;ea=f[(+n[K>>2]<+n[y>>2]?K:y)>>2]|0;f[y>>2]=ea;xa=lc<(f[s>>2]=ea,+n[s>>2]);lc=xa?+n[C>>2]:(f[s>>2]=ea,+n[s>>2]);pc=+n[t>>2];nc=+n[G>>2];kc=nc<pc?nc:pc;pc=lc<kc?kc:lc;lc=tc<pc?tc:pc;n[Ca+(vc<<2)>>2]=ma<lc?lc:ma;ea=vc+1|0;if((vc|0)<(za|0))vc=ea;else{bb=La;$a=ea;continue m}}}if((Cb|0)==(ra|0))break;else Ca=Ca+(qa<<2)|0}}break}default:{}}while(0);break a;break}default:{f[i>>2]=0;f[i+4>>2]=0;bO(-210,i,240819,237558,3176);bD(i);break a}}}while(0);i=Q+36|0;vc=f[i>>2]|0;if(vc|0?(G=vc+12|0,vc=f[G>>2]|0,f[G>>2]=vc+-1,(vc|0)==1):0)kL(Q);f[i>>2]=0;i=Q+16|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[V>>2]|0)>0){i=f[$>>2]|0;$=0;do{f[i+($<<2)>>2]=0;$=$+1|0}while(($|0)<(f[V>>2]|0))}V=f[Z>>2]|0;if((V|0)!=(X|0))UC(V);V=P+36|0;X=f[V>>2]|0;if(X|0?(Z=X+12|0,X=f[Z>>2]|0,f[Z>>2]=X+-1,(X|0)==1):0)kL(P);f[V>>2]=0;V=P+4|0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=0;f[ca+12>>2]=0;if((f[V>>2]|0)>0){ca=f[P+40>>2]|0;X=0;do{f[ca+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[V>>2]|0))}V=f[P+44>>2]|0;if((V|0)!=(P+48|0))UC(V);V=N+36|0;P=f[V>>2]|0;if(P|0?(X=P+12|0,P=f[X>>2]|0,f[X>>2]=P+-1,(P|0)==1):0)kL(N);f[V>>2]=0;V=N+4|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[V>>2]|0)>0){W=f[ba>>2]|0;ba=0;do{f[W+(ba<<2)>>2]=0;ba=ba+1|0}while((ba|0)<(f[V>>2]|0))}V=f[N+44>>2]|0;if((V|0)!=(N+48|0))UC(V)}else JM(a,c);if(!(f[M+4>>2]|0)){u=g;return}u=g;return}function H7(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0;e=u;u=u+128|0;g=e+120|0;i=e+100|0;j=e;k=f[a+16>>2]|0;l=f[c+16>>2]|0;m=f[a+48>>2]|0;n=f[c+48>>2]|0;o=f[c+40>>2]|0;c=f[o+4>>2]|0;p=f[o>>2]|0;o=(f[a>>2]|0)>>>3;a=o&511;q=a+1|0;b[g>>0]=0;switch(d|0){case 3:{d=(p|0)==1;if((c|0)==1|d){r=p+c|0;s=r+-1|0;t=d?q:m;v=d?0:m-q|0;w=d?q:n;if((r|0)<=1){u=e;return}d=0-t|0;x=r+-2|0;r=k;y=l;z=0;while(1){A=(z|0)>0?d:0;B=(z|0)<(x|0)?t:0;C=0;D=r;while(1){E=h[D+A>>0]|0;F=h[D>>0]|0;G=E-F+256|0;if(G>>>0<769)H=h[259297+G>>0]|0;else H=0;G=H+F|0;F=G-(h[D+B>>0]|0)+256|0;if(F>>>0<769)I=h[259297+F>>0]|0;else I=0;F=G-I|0;G=(E|256)-H-F|0;if(G>>>0<769)J=h[259297+G>>0]|0;else J=0;b[y+C>>0]=J+F;C=C+1|0;if((C|0)==(q|0))break;else D=D+1|0}z=z+1|0;if((z|0)>=(s|0))break;else{r=r+q+v|0;y=y+w|0}}u=e;return}w=Y(q,c)|0;if((p|0)<=0){u=e;return}y=p+-1|0;v=(o|-512)^511;r=v+-1+w|0;s=w-q|0;z=l;J=0;while(1){H=J+-1|0;I=k+(Y((H|0)>0?H:0,m)|0)|0;H=k+(Y(J,m)|0)|0;J=J+1|0;t=k+(Y((y|0)<(J|0)?y:J,m)|0)|0;x=b[g>>0]&1?q:w;d=0;a:while(1){if((d|0)<(x|0)){D=d;do{C=D-((D|0)>(a|0)?q:0)|0;B=((D|0)<(s|0)?q:0)+D|0;A=h[I+C>>0]|0;F=h[I+D>>0]|0;G=h[I+B>>0]|0;E=h[H+C>>0]|0;K=h[H+D>>0]|0;L=h[H+B>>0]|0;M=h[t+C>>0]|0;C=h[t+D>>0]|0;N=h[t+B>>0]|0;B=F-G+256|0;if(B>>>0<769)O=h[259297+B>>0]|0;else O=0;B=O+G|0;G=F-O|0;F=K-L+256|0;if(F>>>0<769)P=h[259297+F>>0]|0;else P=0;F=P+L|0;L=K-P|0;K=C-N+256|0;if(K>>>0<769)Q=h[259297+K>>0]|0;else Q=0;K=Q+N|0;N=C-Q|0;C=A-G+256|0;if(C>>>0<769)R=h[259297+C>>0]|0;else R=0;C=R+G|0;G=E-L+256|0;if(G>>>0<769)S=h[259297+G>>0]|0;else S=0;G=S+L|0;L=E-S|0;E=M-N+256|0;if(E>>>0<769)T=h[259297+E>>0]|0;else T=0;E=T+N|0;N=M-T|0;M=C-B+256|0;if(M>>>0<769)U=h[259297+M>>0]|0;else U=0;M=U+B|0;B=G-F+256|0;if(B>>>0<769)V=h[259297+B>>0]|0;else V=0;B=V+F|0;F=G-V|0;G=E-K+256|0;if(G>>>0<769)W=h[259297+G>>0]|0;else W=0;G=E-W|0;E=(A|256)-R-L|0;if(E>>>0<769)X=h[259297+E>>0]|0;else X=0;E=256-K+B-W|0;if(E>>>0<769)Z=h[259297+E>>0]|0;else Z=0;E=F-G+256|0;if(E>>>0<769)_=h[259297+E>>0]|0;else _=0;E=F-_|0;F=L+256-N+X|0;if(F>>>0<769)$=h[259297+F>>0]|0;else $=0;F=C+256-U-E|0;if(F>>>0<769)aa=h[259297+F>>0]|0;else aa=0;F=aa+E|0;E=M+256-B+Z|0;if(E>>>0<769)ba=h[259297+E>>0]|0;else ba=0;E=M-ba|0;M=256-G-_+F|0;if(M>>>0<769)ca=h[259297+M>>0]|0;else ca=0;M=F-ca|0;F=M-E+256|0;if(F>>>0<769)da=h[259297+F>>0]|0;else da=0;F=M-da|0;M=N+256+$-F|0;if(M>>>0<769)ea=h[259297+M>>0]|0;else ea=0;M=ea+F|0;F=256-E-da+M|0;if(F>>>0<769)fa=h[259297+F>>0]|0;else fa=0;b[z+D>>0]=M-fa;D=D+1|0}while((D|0)!=(x|0));ga=x}else ga=d;if((x|0)==(w|0))break;if((ga|0)>(r|0)){x=w;d=ga;continue}else ha=ga;while(1){D=I+ha|0;M=h[D+v>>0]|0;F=h[D>>0]|0;E=h[D+q>>0]|0;D=H+ha|0;N=h[D+v>>0]|0;G=h[D>>0]|0;B=h[D+q>>0]|0;D=t+ha|0;C=h[D+v>>0]|0;L=h[D>>0]|0;K=h[D+q>>0]|0;D=F-E+256|0;if(D>>>0<769)ia=h[259297+D>>0]|0;else ia=0;D=ia+E|0;E=F-ia|0;F=G-B+256|0;if(F>>>0<769)ja=h[259297+F>>0]|0;else ja=0;F=ja+B|0;B=G-ja|0;G=L-K+256|0;if(G>>>0<769)ka=h[259297+G>>0]|0;else ka=0;G=ka+K|0;K=L-ka|0;L=M-E+256|0;if(L>>>0<769)la=h[259297+L>>0]|0;else la=0;L=la+E|0;E=N-B+256|0;if(E>>>0<769)ma=h[259297+E>>0]|0;else ma=0;E=ma+B|0;B=N-ma|0;N=C-K+256|0;if(N>>>0<769)na=h[259297+N>>0]|0;else na=0;N=na+K|0;K=C-na|0;C=L-D+256|0;if(C>>>0<769)oa=h[259297+C>>0]|0;else oa=0;C=oa+D|0;D=E-F+256|0;if(D>>>0<769)pa=h[259297+D>>0]|0;else pa=0;D=pa+F|0;F=E-pa|0;E=N-G+256|0;if(E>>>0<769)qa=h[259297+E>>0]|0;else qa=0;E=N-qa|0;N=(M|256)-la-B|0;if(N>>>0<769)ra=h[259297+N>>0]|0;else ra=0;N=256-G+D-qa|0;if(N>>>0<769)sa=h[259297+N>>0]|0;else sa=0;N=F-E+256|0;if(N>>>0<769)ta=h[259297+N>>0]|0;else ta=0;N=F-ta|0;F=B+256-K+ra|0;if(F>>>0<769)ua=h[259297+F>>0]|0;else ua=0;F=L+256-oa-N|0;if(F>>>0<769)va=h[259297+F>>0]|0;else va=0;F=va+N|0;N=C+256-D+sa|0;if(N>>>0<769)wa=h[259297+N>>0]|0;else wa=0;N=C-wa|0;C=256-E-ta+F|0;if(C>>>0<769)xa=h[259297+C>>0]|0;else xa=0;C=F-xa|0;F=C-N+256|0;if(F>>>0<769)ya=h[259297+F>>0]|0;else ya=0;F=C-ya|0;C=K+256+ua-F|0;if(C>>>0<769)za=h[259297+C>>0]|0;else za=0;C=za+F|0;F=256-N-ya+C|0;if(F>>>0<769)Aa=h[259297+F>>0]|0;else Aa=0;b[z+ha>>0]=C-Aa;C=ha+1|0;if((ha|0)<(r|0))ha=C;else{x=w;d=C;continue a}}}if((J|0)==(p|0))break;else z=z+n|0}u=e;return}case 5:{z=(p|0)==1;if((c|0)==1|z){J=p+c|0;w=J+-1|0;ha=z?q:m;r=z?0:m-q|0;Aa=z?q:n;if((J|0)<=1){u=e;return}z=0-ha|0;ya=z<<1;za=J+-2|0;ua=J+-3|0;J=ha<<1;xa=k;ta=l;wa=0;while(1){sa=(wa|0)>0?z:0;va=(wa|0)>1?ya:sa;oa=(wa|0)<(za|0)?ha:0;ra=(wa|0)<(ua|0)?J:oa;qa=xa;la=0;while(1){pa=h[qa+va>>0]|0;na=h[qa+sa>>0]|0;ma=h[qa>>0]|0;ka=h[qa+oa>>0]|0;ja=h[qa+ra>>0]|0;ia=pa-na+256|0;if(ia>>>0<769)Ba=h[259297+ia>>0]|0;else Ba=0;ia=ka-ja+256|0;if(ia>>>0<769)Ca=h[259297+ia>>0]|0;else Ca=0;ia=Ca+ja|0;ja=ka-Ca|0;ka=ma-ja+256|0;if(ka>>>0<769)Da=h[259297+ka>>0]|0;else Da=0;ka=Da+ja|0;ja=ma-Da|0;ma=ka-ia+256|0;if(ma>>>0<769)Ea=h[259297+ma>>0]|0;else Ea=0;ma=(pa|256)-Ba-ja|0;if(ma>>>0<769)Fa=h[259297+ma>>0]|0;else Fa=0;ma=Fa+ja|0;ja=256-ia-Ea+ma|0;if(ja>>>0<769)Ga=h[259297+ja>>0]|0;else Ga=0;ja=ma-Ga|0;ma=Ba+na+256|0;na=ma-ka+Ea|0;if(na>>>0<769)Ha=h[259297+na>>0]|0;else Ha=0;na=ma-ja-Ha|0;if(na>>>0<769)Ia=h[259297+na>>0]|0;else Ia=0;b[ta+la>>0]=Ia+ja;la=la+1|0;if((la|0)==(q|0))break;else qa=qa+1|0}wa=wa+1|0;if((wa|0)>=(w|0))break;else{xa=xa+q+r|0;ta=ta+Aa|0}}u=e;return}Aa=Y(q,c)|0;if((p|0)<=0){u=e;return}c=i+4|0;ta=i+8|0;r=p+-1|0;xa=i+12|0;w=i+16|0;wa=q<<1;Ia=0-wa|0;Ha=Aa+-1-wa|0;Ea=(o|-512)^511;o=j+4|0;Ba=j+8|0;Ga=j+16|0;Fa=j+20|0;Da=j+12|0;Ca=j+28|0;J=j+32|0;ua=j+24|0;ha=j+40|0;za=j+44|0;ya=j+36|0;z=j+52|0;qa=j+56|0;la=j+48|0;ra=j+64|0;oa=j+68|0;sa=j+60|0;va=j+76|0;ja=j+80|0;na=j+72|0;ma=j+84|0;ka=j+88|0;ia=j+92|0;pa=j+96|0;v=Aa-q|0;ga=Aa-wa|0;fa=j+4|0;da=j+8|0;ea=j+16|0;$=j+20|0;ca=j+12|0;_=j+28|0;ba=j+32|0;Z=j+24|0;aa=j+40|0;U=j+44|0;X=j+36|0;W=j+52|0;R=j+56|0;V=j+48|0;T=j+64|0;S=j+68|0;Q=j+60|0;P=j+76|0;O=j+80|0;s=j+72|0;y=j+84|0;d=j+88|0;x=j+92|0;t=j+96|0;H=l;l=0;while(1){I=l+-2|0;C=k+(Y((I|0)>0?I:0,m)|0)|0;f[i>>2]=C;C=l+-1|0;I=k+(Y((C|0)>0?C:0,m)|0)|0;f[c>>2]=I;I=k+(Y(l,m)|0)|0;f[ta>>2]=I;I=l;l=l+1|0;C=k+(Y((r|0)<(l|0)?r:l,m)|0)|0;f[xa>>2]=C;C=I+2|0;I=k+(Y((r|0)<(C|0)?r:C,m)|0)|0;f[w>>2]=I;I=b[g>>0]&1?wa:Aa;C=0;b:while(1){if((C|0)<(I|0)){F=C;do{N=F-((F|0)>(a|0)?q:0)|0;K=(F|0)<(wa|0)?N:F-wa|0;E=((F|0)<(v|0)?q:0)+F|0;D=(F|0)<(ga|0)?F+wa|0:E;L=f[i>>2]|0;f[j>>2]=h[L+K>>0];B=h[L+N>>0]|0;f[fa>>2]=B;G=h[L+F>>0]|0;f[da>>2]=G;M=h[L+E>>0]|0;f[ca>>2]=M;A=h[L+D>>0]|0;f[ea>>2]=A;L=f[c>>2]|0;Ja=h[L+K>>0]|0;f[$>>2]=Ja;Ka=h[L+N>>0]|0;f[Z>>2]=Ka;La=h[L+F>>0]|0;f[_>>2]=La;Ma=h[L+E>>0]|0;f[ba>>2]=Ma;Na=h[L+D>>0]|0;f[X>>2]=Na;L=f[ta>>2]|0;Oa=h[L+K>>0]|0;f[aa>>2]=Oa;Pa=h[L+N>>0]|0;f[U>>2]=Pa;Qa=h[L+F>>0]|0;f[V>>2]=Qa;Ra=h[L+E>>0]|0;f[W>>2]=Ra;Sa=h[L+D>>0]|0;f[R>>2]=Sa;L=f[xa>>2]|0;Ta=h[L+K>>0]|0;f[Q>>2]=Ta;Ua=h[L+N>>0]|0;f[T>>2]=Ua;Va=h[L+F>>0]|0;f[S>>2]=Va;Wa=h[L+E>>0]|0;f[s>>2]=Wa;Xa=h[L+D>>0]|0;f[P>>2]=Xa;L=f[w>>2]|0;Ya=h[L+K>>0]|0;f[O>>2]=Ya;K=h[L+N>>0]|0;f[y>>2]=K;N=h[L+F>>0]|0;f[d>>2]=N;Za=h[L+E>>0]|0;f[x>>2]=Za;E=h[L+D>>0]|0;f[t>>2]=E;D=B-G+256|0;if(D>>>0<769)_a=h[259297+D>>0]|0;else _a=0;D=_a+G|0;f[da>>2]=D;G=(f[fa>>2]|0)-_a|0;f[fa>>2]=G;B=f[j>>2]|0;L=B-G+256|0;if(L>>>0<769)$a=h[259297+L>>0]|0;else $a=0;L=$a+G|0;f[fa>>2]=L;G=B-$a|0;f[j>>2]=G;B=L-D+256|0;if(B>>>0<769)ab=h[259297+B>>0]|0;else ab=0;B=ab+D|0;f[da>>2]=B;D=L-ab|0;f[fa>>2]=D;L=A-Ja+256|0;if(L>>>0<769)bb=h[259297+L>>0]|0;else bb=0;L=bb+Ja|0;f[$>>2]=L;Ja=A-bb|0;f[ea>>2]=Ja;A=M-Ja+256|0;if(A>>>0<769)cb=h[259297+A>>0]|0;else cb=0;A=cb+Ja|0;f[ea>>2]=A;Ja=M-cb|0;f[ca>>2]=Ja;M=A-L+256|0;if(M>>>0<769)db=h[259297+M>>0]|0;else db=0;M=db+L|0;f[$>>2]=M;L=A-db|0;f[ea>>2]=L;A=G-Ja+256|0;if(A>>>0<769)eb=h[259297+A>>0]|0;else eb=0;A=eb+Ja|0;f[ca>>2]=A;Ja=G-eb|0;f[j>>2]=Ja;G=B-M+256|0;if(G>>>0<769)fb=h[259297+G>>0]|0;else fb=0;G=fb+M|0;f[$>>2]=G;M=B-fb|0;f[da>>2]=M;B=M-A+256|0;if(B>>>0<769)gb=h[259297+B>>0]|0;else gb=0;B=gb+A|0;f[ca>>2]=B;A=M-gb|0;f[da>>2]=A;M=D-L+256|0;if(M>>>0<769)hb=h[259297+M>>0]|0;else hb=0;M=hb+L|0;f[ea>>2]=M;L=D-hb|0;f[fa>>2]=L;D=L-A+256|0;if(D>>>0<769)ib=h[259297+D>>0]|0;else ib=0;D=ib+A|0;f[da>>2]=D;A=L-ib|0;f[fa>>2]=A;L=B-M+256|0;if(L>>>0<769)jb=h[259297+L>>0]|0;else jb=0;L=jb+M|0;f[ea>>2]=L;M=B-jb|0;f[ca>>2]=M;B=La-Ma+256|0;if(B>>>0<769)kb=h[259297+B>>0]|0;else kb=0;B=kb+Ma|0;f[ba>>2]=B;Ma=La-kb|0;f[_>>2]=Ma;La=Ka-Ma+256|0;if(La>>>0<769)lb=h[259297+La>>0]|0;else lb=0;La=lb+Ma|0;f[_>>2]=La;Ma=Ka-lb|0;f[Z>>2]=Ma;Ka=La-B+256|0;if(Ka>>>0<769)mb=h[259297+Ka>>0]|0;else mb=0;Ka=mb+B|0;f[ba>>2]=Ka;B=La-mb|0;f[_>>2]=B;La=Oa-Pa+256|0;if(La>>>0<769)nb=h[259297+La>>0]|0;else nb=0;La=nb+Pa|0;f[U>>2]=La;Pa=Oa-nb|0;f[aa>>2]=Pa;Oa=Na-Pa+256|0;if(Oa>>>0<769)ob=h[259297+Oa>>0]|0;else ob=0;Oa=ob+Pa|0;f[aa>>2]=Oa;Pa=Na-ob|0;f[X>>2]=Pa;Na=Oa-La+256|0;if(Na>>>0<769)pb=h[259297+Na>>0]|0;else pb=0;Na=pb+La|0;f[U>>2]=Na;La=Oa-pb|0;f[aa>>2]=La;Oa=Ma-Pa+256|0;if(Oa>>>0<769)qb=h[259297+Oa>>0]|0;else qb=0;Oa=qb+Pa|0;f[X>>2]=Oa;Pa=Ma-qb|0;f[Z>>2]=Pa;Ma=Ka-Na+256|0;if(Ma>>>0<769)rb=h[259297+Ma>>0]|0;else rb=0;Ma=rb+Na|0;f[U>>2]=Ma;Na=Ka-rb|0;f[ba>>2]=Na;Ka=Na-Oa+256|0;if(Ka>>>0<769)sb=h[259297+Ka>>0]|0;else sb=0;Ka=sb+Oa|0;f[X>>2]=Ka;Oa=Na-sb|0;f[ba>>2]=Oa;Na=B-La+256|0;if(Na>>>0<769)tb=h[259297+Na>>0]|0;else tb=0;Na=tb+La|0;f[aa>>2]=Na;La=B-tb|0;f[_>>2]=La;B=La-Oa+256|0;if(B>>>0<769)ub=h[259297+B>>0]|0;else ub=0;B=ub+Oa|0;f[ba>>2]=B;Oa=La-ub|0;f[_>>2]=Oa;La=Ka-Na+256|0;if(La>>>0<769)vb=h[259297+La>>0]|0;else vb=0;La=vb+Na|0;f[aa>>2]=La;Na=Ka-vb|0;f[X>>2]=Na;Ka=Ja-Pa+256|0;if(Ka>>>0<769)wb=h[259297+Ka>>0]|0;else wb=0;Ka=wb+Pa|0;f[Z>>2]=Ka;Pa=Ja-wb|0;f[j>>2]=Pa;Ja=L-La+256|0;if(Ja>>>0<769)xb=h[259297+Ja>>0]|0;else xb=0;Ja=xb+La|0;f[aa>>2]=Ja;La=L-xb|0;f[ea>>2]=La;L=La-Ka+256|0;if(L>>>0<769)yb=h[259297+L>>0]|0;else yb=0;L=yb+Ka|0;f[Z>>2]=L;Ka=La-yb|0;f[ea>>2]=Ka;La=D-B+256|0;if(La>>>0<769)zb=h[259297+La>>0]|0;else zb=0;La=zb+B|0;f[ba>>2]=La;B=D-zb|0;f[da>>2]=B;D=B-Ka+256|0;if(D>>>0<769)Ab=h[259297+D>>0]|0;else Ab=0;D=Ab+Ka|0;f[ea>>2]=D;Ka=B-Ab|0;f[da>>2]=Ka;B=L-La+256|0;if(B>>>0<769)Bb=h[259297+B>>0]|0;else Bb=0;B=Bb+La|0;f[ba>>2]=B;La=L-Bb|0;f[Z>>2]=La;L=A-Oa+256|0;if(L>>>0<769)Cb=h[259297+L>>0]|0;else Cb=0;L=Cb+Oa|0;f[_>>2]=L;Oa=A-Cb|0;f[fa>>2]=Oa;A=G-Ma+256|0;if(A>>>0<769)Db=h[259297+A>>0]|0;else Db=0;A=Db+Ma|0;f[U>>2]=A;Ma=G-Db|0;f[$>>2]=Ma;G=Ma-L+256|0;if(G>>>0<769)Eb=h[259297+G>>0]|0;else Eb=0;G=Eb+L|0;f[_>>2]=G;L=Ma-Eb|0;f[$>>2]=L;Ma=M-Na+256|0;if(Ma>>>0<769)Fb=h[259297+Ma>>0]|0;else Fb=0;Ma=Fb+Na|0;f[X>>2]=Ma;Na=M-Fb|0;f[ca>>2]=Na;M=Na-L+256|0;if(M>>>0<769)Gb=h[259297+M>>0]|0;else Gb=0;M=Gb+L|0;f[$>>2]=M;L=Na-Gb|0;f[ca>>2]=L;Na=G-Ma+256|0;if(Na>>>0<769)Hb=h[259297+Na>>0]|0;else Hb=0;Na=Hb+Ma|0;f[X>>2]=Na;Ma=G-Hb|0;f[_>>2]=Ma;G=Oa-Ka+256|0;if(G>>>0<769)Ib=h[259297+G>>0]|0;else Ib=0;G=Ib+Ka|0;f[da>>2]=G;Ka=Oa-Ib|0;f[fa>>2]=Ka;Oa=L-D+256|0;if(Oa>>>0<769)Jb=h[259297+Oa>>0]|0;else Jb=0;Oa=Jb+D|0;f[ea>>2]=Oa;D=L-Jb|0;f[ca>>2]=D;L=M-La+256|0;if(L>>>0<769)Kb=h[259297+L>>0]|0;else Kb=0;L=Kb+La|0;f[Z>>2]=L;La=M-Kb|0;f[$>>2]=La;M=Ma-B+256|0;if(M>>>0<769)Lb=h[259297+M>>0]|0;else Lb=0;M=Lb+B|0;f[ba>>2]=M;B=Ma-Lb|0;f[_>>2]=B;Ma=Na-Ja+256|0;if(Ma>>>0<769)Mb=h[259297+Ma>>0]|0;else Mb=0;Ma=Mb+Ja|0;f[aa>>2]=Ma;Ja=Na-Mb|0;f[X>>2]=Ja;Na=Ra-Sa+256|0;if(Na>>>0<769)Nb=h[259297+Na>>0]|0;else Nb=0;Na=Nb+Sa|0;f[R>>2]=Na;Sa=Ra-Nb|0;f[W>>2]=Sa;Ra=Qa-Sa+256|0;if(Ra>>>0<769)Ob=h[259297+Ra>>0]|0;else Ob=0;Ra=Ob+Sa|0;f[W>>2]=Ra;Sa=Qa-Ob|0;f[V>>2]=Sa;Qa=Ra-Na+256|0;if(Qa>>>0<769)Pb=h[259297+Qa>>0]|0;else Pb=0;Qa=Pb+Na|0;f[R>>2]=Qa;Na=Ra-Pb|0;f[W>>2]=Na;Ra=Ua-Va+256|0;if(Ra>>>0<769)Qb=h[259297+Ra>>0]|0;else Qb=0;Ra=Qb+Va|0;f[S>>2]=Ra;Va=Ua-Qb|0;f[T>>2]=Va;Ua=Ta-Va+256|0;if(Ua>>>0<769)Rb=h[259297+Ua>>0]|0;else Rb=0;Ua=Rb+Va|0;f[T>>2]=Ua;Va=Ta-Rb|0;f[Q>>2]=Va;Ta=Ua-Ra+256|0;if(Ta>>>0<769)Sb=h[259297+Ta>>0]|0;else Sb=0;Ta=Sb+Ra|0;f[S>>2]=Ta;Ra=Ua-Sb|0;f[T>>2]=Ra;Ua=Sa-Va+256|0;if(Ua>>>0<769)Tb=h[259297+Ua>>0]|0;else Tb=0;Ua=Tb+Va|0;f[Q>>2]=Ua;Va=Sa-Tb|0;f[V>>2]=Va;Sa=Qa-Ta+256|0;if(Sa>>>0<769)Ub=h[259297+Sa>>0]|0;else Ub=0;Sa=Ub+Ta|0;f[S>>2]=Sa;Ta=Qa-Ub|0;f[R>>2]=Ta;Qa=Ta-Ua+256|0;if(Qa>>>0<769)Vb=h[259297+Qa>>0]|0;else Vb=0;Qa=Vb+Ua|0;f[Q>>2]=Qa;Ua=Ta-Vb|0;f[R>>2]=Ua;Ta=Na-Ra+256|0;if(Ta>>>0<769)Wb=h[259297+Ta>>0]|0;else Wb=0;Ta=Wb+Ra|0;f[T>>2]=Ta;Ra=Na-Wb|0;f[W>>2]=Ra;Na=Ra-Ua+256|0;if(Na>>>0<769)Xb=h[259297+Na>>0]|0;else Xb=0;Na=Xb+Ua|0;f[R>>2]=Na;Ua=Ra-Xb|0;f[W>>2]=Ua;Ra=Qa-Ta+256|0;if(Ra>>>0<769)Yb=h[259297+Ra>>0]|0;else Yb=0;Ra=Yb+Ta|0;f[T>>2]=Ra;Ta=Qa-Yb|0;f[Q>>2]=Ta;Qa=Xa-Ya+256|0;if(Qa>>>0<769)Zb=h[259297+Qa>>0]|0;else Zb=0;Qa=Zb+Ya|0;f[O>>2]=Qa;Ya=Xa-Zb|0;f[P>>2]=Ya;Xa=Wa-Ya+256|0;if(Xa>>>0<769)_b=h[259297+Xa>>0]|0;else _b=0;Xa=_b+Ya|0;f[P>>2]=Xa;Ya=Wa-_b|0;f[s>>2]=Ya;Wa=Xa-Qa+256|0;if(Wa>>>0<769)$b=h[259297+Wa>>0]|0;else $b=0;Wa=$b+Qa|0;f[O>>2]=Wa;Qa=Xa-$b|0;f[P>>2]=Qa;Xa=K-N+256|0;if(Xa>>>0<769)ac=h[259297+Xa>>0]|0;else ac=0;Xa=ac+N|0;f[d>>2]=Xa;N=K-ac|0;f[y>>2]=N;K=Za-E+256|0;if(K>>>0<769)bc=h[259297+K>>0]|0;else bc=0;K=bc+E|0;f[t>>2]=K;E=Za-bc|0;f[x>>2]=E;Za=N-E+256|0;if(Za>>>0<769)cc=h[259297+Za>>0]|0;else cc=0;Za=cc+E|0;f[x>>2]=Za;E=N-cc|0;f[y>>2]=E;N=Xa-K+256|0;if(N>>>0<769)dc=h[259297+N>>0]|0;else dc=0;N=dc+K|0;f[t>>2]=N;K=Xa-dc|0;f[d>>2]=K;Xa=K-Za+256|0;if(Xa>>>0<769)ec=h[259297+Xa>>0]|0;else ec=0;Xa=ec+Za|0;f[x>>2]=Xa;Za=K-ec|0;f[d>>2]=Za;K=Ya-E+256|0;if(K>>>0<769)fc=h[259297+K>>0]|0;else fc=0;K=fc+E|0;f[y>>2]=K;E=Ya-fc|0;f[s>>2]=E;Ya=Wa-Xa+256|0;if(Ya>>>0<769)gc=h[259297+Ya>>0]|0;else gc=0;Ya=gc+Xa|0;f[x>>2]=Ya;Xa=Wa-gc|0;f[O>>2]=Xa;Wa=Xa-K+256|0;if(Wa>>>0<769)hc=h[259297+Wa>>0]|0;else hc=0;Wa=hc+K|0;f[y>>2]=Wa;K=Xa-hc|0;f[O>>2]=K;Xa=Qa-Za+256|0;if(Xa>>>0<769)ic=h[259297+Xa>>0]|0;else ic=0;Xa=ic+Za|0;f[d>>2]=Xa;Za=Qa-ic|0;f[P>>2]=Za;Qa=Xa-N+256|0;if(Qa>>>0<769)jc=h[259297+Qa>>0]|0;else jc=0;Qa=jc+N|0;f[t>>2]=Qa;N=Xa-jc|0;f[d>>2]=N;Xa=Za-K+256|0;if(Xa>>>0<769)kc=h[259297+Xa>>0]|0;else kc=0;Xa=kc+K|0;f[O>>2]=Xa;K=Za-kc|0;f[P>>2]=K;Za=Wa-N+256|0;if(Za>>>0<769)lc=h[259297+Za>>0]|0;else lc=0;Za=lc+N|0;f[d>>2]=Za;N=Wa-lc|0;f[y>>2]=N;Wa=Ya-Qa+256|0;if(Wa>>>0<769)mc=h[259297+Wa>>0]|0;else mc=0;Wa=mc+Qa|0;f[t>>2]=Wa;Qa=Ya-mc|0;f[x>>2]=Qa;Ya=Va-E+256|0;if(Ya>>>0<769)nc=h[259297+Ya>>0]|0;else nc=0;Ya=nc+E|0;f[s>>2]=Ya;E=Va-nc|0;f[V>>2]=E;Va=Ra-Za+256|0;if(Va>>>0<769)oc=h[259297+Va>>0]|0;else oc=0;Va=oc+Za|0;f[d>>2]=Va;Za=Ra-oc|0;f[T>>2]=Za;Ra=Za-Ya+256|0;if(Ra>>>0<769)pc=h[259297+Ra>>0]|0;else pc=0;Ra=pc+Ya|0;f[s>>2]=Ra;Ya=Za-pc|0;f[T>>2]=Ya;Za=Na-Xa+256|0;if(Za>>>0<769)qc=h[259297+Za>>0]|0;else qc=0;Za=qc+Xa|0;f[O>>2]=Za;Xa=Na-qc|0;f[R>>2]=Xa;Na=Za-Wa+256|0;if(Na>>>0<769)rc=h[259297+Na>>0]|0;else rc=0;Na=rc+Wa|0;f[t>>2]=Na;Wa=Za-rc|0;f[O>>2]=Wa;Za=Xa-Ya+256|0;if(Za>>>0<769)sc=h[259297+Za>>0]|0;else sc=0;Za=sc+Ya|0;f[T>>2]=Za;Ya=Xa-sc|0;f[R>>2]=Ya;Xa=Ra-Wa+256|0;if(Xa>>>0<769)tc=h[259297+Xa>>0]|0;else tc=0;Xa=tc+Wa|0;f[O>>2]=Xa;Wa=Ra-tc|0;f[s>>2]=Wa;Ra=Va-Na+256|0;if(Ra>>>0<769)uc=h[259297+Ra>>0]|0;else uc=0;Ra=uc+Na|0;f[t>>2]=Ra;Na=Va-uc|0;f[d>>2]=Na;Va=Ua-K+256|0;if(Va>>>0<769)vc=h[259297+Va>>0]|0;else vc=0;Va=vc+K|0;f[P>>2]=Va;K=Ua-vc|0;f[W>>2]=K;Ua=Sa-Qa+256|0;if(Ua>>>0<769)wc=h[259297+Ua>>0]|0;else wc=0;Ua=wc+Qa|0;f[x>>2]=Ua;Qa=Sa-wc|0;f[S>>2]=Qa;Sa=Qa-Va+256|0;if(Sa>>>0<769)xc=h[259297+Sa>>0]|0;else xc=0;Sa=xc+Va|0;f[P>>2]=Sa;Va=Qa-xc|0;f[S>>2]=Va;Qa=Ta-N+256|0;if(Qa>>>0<769)yc=h[259297+Qa>>0]|0;else yc=0;Qa=yc+N|0;f[y>>2]=Qa;N=Ta-yc|0;f[Q>>2]=N;Ta=N-Va+256|0;if(Ta>>>0<769)zc=h[259297+Ta>>0]|0;else zc=0;Ta=zc+Va|0;f[S>>2]=Ta;Va=N-zc|0;f[Q>>2]=Va;N=Sa-Qa+256|0;if(N>>>0<769)Ac=h[259297+N>>0]|0;else Ac=0;N=Ac+Qa|0;f[y>>2]=N;Qa=Sa-Ac|0;f[P>>2]=Qa;Sa=K-Ya+256|0;if(Sa>>>0<769)Bc=h[259297+Sa>>0]|0;else Bc=0;Sa=Bc+Ya|0;f[R>>2]=Sa;Ya=K-Bc|0;f[W>>2]=Ya;K=Va-Za+256|0;if(K>>>0<769)Cc=h[259297+K>>0]|0;else Cc=0;K=Cc+Za|0;f[T>>2]=K;Za=Va-Cc|0;f[Q>>2]=Za;Va=Ta-Wa+256|0;if(Va>>>0<769)Dc=h[259297+Va>>0]|0;else Dc=0;Va=Dc+Wa|0;f[s>>2]=Va;Wa=Ta-Dc|0;f[S>>2]=Wa;Ta=Qa-Xa+256|0;if(Ta>>>0<769)Ec=h[259297+Ta>>0]|0;else Ec=0;Ta=Ec+Xa|0;f[O>>2]=Ta;Xa=Qa-Ec|0;f[P>>2]=Xa;Qa=N-Na+256|0;if(Qa>>>0<769)Fc=h[259297+Qa>>0]|0;else Fc=0;Qa=Fc+Na|0;f[d>>2]=Qa;Na=N-Fc|0;f[y>>2]=Na;N=Ua-Ra+256|0;if(N>>>0<769)Gc=h[259297+N>>0]|0;else Gc=0;N=Gc+Ra|0;f[t>>2]=N;Ra=Ua-Gc|0;f[x>>2]=Ra;Ua=Pa-E+256|0;if(Ua>>>0<769)Hc=h[259297+Ua>>0]|0;else Hc=0;Ua=Hc+E|0;f[V>>2]=Ua;f[j>>2]=Pa-Hc;Pa=M-Ta+256|0;if(Pa>>>0<769)Ic=h[259297+Pa>>0]|0;else Ic=0;f[O>>2]=Ic+Ta;Ta=M-Ic|0;f[ba>>2]=Ta;M=Ta-Ua+256|0;if(M>>>0<769)Jc=h[259297+M>>0]|0;else Jc=0;M=Jc+Ua|0;f[V>>2]=M;f[ba>>2]=Ta-Jc;Ta=Oa-K+256|0;if(Ta>>>0<769)Kc=h[259297+Ta>>0]|0;else Kc=0;Ta=Kc+K|0;f[T>>2]=Ta;f[ea>>2]=Oa-Kc;Oa=Ta-N+256|0;if(Oa>>>0<769)Lc=h[259297+Oa>>0]|0;else Lc=0;f[t>>2]=Lc+N;N=Ta-Lc|0;f[T>>2]=N;Ta=M-N+256|0;if(Ta>>>0<769)Mc=h[259297+Ta>>0]|0;else Mc=0;f[T>>2]=Mc+N;N=M-Mc|0;f[V>>2]=N;M=G-Sa+256|0;if(M>>>0<769)Nc=h[259297+M>>0]|0;else Nc=0;M=Nc+Sa|0;f[R>>2]=M;f[da>>2]=G-Nc;G=Ma-Qa+256|0;if(G>>>0<769)Oc=h[259297+G>>0]|0;else Oc=0;f[d>>2]=Oc+Qa;Qa=Ma-Oc|0;f[aa>>2]=Qa;Ma=Qa-M+256|0;if(Ma>>>0<769)Pc=h[259297+Ma>>0]|0;else Pc=0;f[R>>2]=Pc+M;M=Qa-Pc|0;f[aa>>2]=M;Qa=L-Va+256|0;if(Qa>>>0<769)Qc=h[259297+Qa>>0]|0;else Qc=0;f[s>>2]=Qc+Va;Va=L-Qc|0;f[Z>>2]=Va;L=Va-M+256|0;if(L>>>0<769)Rc=h[259297+L>>0]|0;else Rc=0;L=Rc+M|0;f[aa>>2]=L;f[Z>>2]=Va-Rc;Va=L-N+256|0;if(Va>>>0<769)Sc=h[259297+Va>>0]|0;else Sc=0;Va=Sc+N|0;f[V>>2]=Va;f[aa>>2]=L-Sc;L=Ka-Ya+256|0;if(L>>>0<769)Tc=h[259297+L>>0]|0;else Tc=0;L=Tc+Ya|0;f[W>>2]=L;f[fa>>2]=Ka-Tc;Ka=Ja-Na+256|0;if(Ka>>>0<769)Uc=h[259297+Ka>>0]|0;else Uc=0;f[y>>2]=Uc+Na;Na=Ja-Uc|0;f[X>>2]=Na;Ja=Na-L+256|0;if(Ja>>>0<769)Vc=h[259297+Ja>>0]|0;else Vc=0;Ja=Vc+L|0;f[W>>2]=Ja;f[X>>2]=Na-Vc;Na=La-Wa+256|0;if(Na>>>0<769)Wc=h[259297+Na>>0]|0;else Wc=0;Na=Wc+Wa|0;f[S>>2]=Na;f[$>>2]=La-Wc;La=Ja-Na+256|0;if(La>>>0<769)Xc=h[259297+La>>0]|0;else Xc=0;f[S>>2]=Xc+Na;Na=Ja-Xc|0;f[W>>2]=Na;Ja=D-Za+256|0;if(Ja>>>0<769)Yc=h[259297+Ja>>0]|0;else Yc=0;Ja=Yc+Za|0;f[Q>>2]=Ja;f[ca>>2]=D-Yc;D=A-Ra+256|0;if(D>>>0<769)Zc=h[259297+D>>0]|0;else Zc=0;f[x>>2]=Zc+Ra;Ra=A-Zc|0;f[U>>2]=Ra;A=Ra-Ja+256|0;if(A>>>0<769)_c=h[259297+A>>0]|0;else _c=0;f[Q>>2]=_c+Ja;Ja=Ra-_c|0;f[U>>2]=Ja;Ra=B-Xa+256|0;if(Ra>>>0<769)$c=h[259297+Ra>>0]|0;else $c=0;f[P>>2]=$c+Xa;Xa=B-$c|0;f[_>>2]=Xa;B=Xa-Ja+256|0;if(B>>>0<769)ad=h[259297+B>>0]|0;else ad=0;B=ad+Ja|0;f[U>>2]=B;f[_>>2]=Xa-ad;Xa=B-Na+256|0;if(Xa>>>0<769)bd=h[259297+Xa>>0]|0;else bd=0;f[W>>2]=bd+Na;Na=B-bd|0;f[U>>2]=Na;B=Na-Va+256|0;if(B>>>0<769)cd=h[259297+B>>0]|0;else cd=0;b[H+F>>0]=cd+Va;F=F+1|0}while((F|0)!=(I|0));dd=I}else dd=C;if((I|0)==(Aa|0))break;if((dd|0)>(Ha|0)){I=Aa;C=dd;continue}else ed=dd;while(1){F=(f[i>>2]|0)+ed|0;f[j>>2]=h[F+Ia>>0];Va=h[F+Ea>>0]|0;f[o>>2]=Va;B=h[F>>0]|0;f[Ba>>2]=B;Na=h[F+q>>0]|0;f[Da>>2]=Na;Xa=h[F+wa>>0]|0;f[Ga>>2]=Xa;F=(f[c>>2]|0)+ed|0;Ja=h[F+Ia>>0]|0;f[Fa>>2]=Ja;Ra=h[F+Ea>>0]|0;f[ua>>2]=Ra;A=h[F>>0]|0;f[Ca>>2]=A;D=h[F+q>>0]|0;f[J>>2]=D;Za=h[F+wa>>0]|0;f[ya>>2]=Za;F=(f[ta>>2]|0)+ed|0;La=h[F+Ia>>0]|0;f[ha>>2]=La;Wa=h[F+Ea>>0]|0;f[za>>2]=Wa;L=h[F>>0]|0;f[la>>2]=L;Ka=h[F+q>>0]|0;f[z>>2]=Ka;Ya=h[F+wa>>0]|0;f[qa>>2]=Ya;F=(f[xa>>2]|0)+ed|0;N=h[F+Ia>>0]|0;f[sa>>2]=N;M=h[F+Ea>>0]|0;f[ra>>2]=M;Qa=h[F>>0]|0;f[oa>>2]=Qa;Ma=h[F+q>>0]|0;f[na>>2]=Ma;G=h[F+wa>>0]|0;f[va>>2]=G;F=(f[w>>2]|0)+ed|0;Sa=h[F+Ia>>0]|0;f[ja>>2]=Sa;Ta=h[F+Ea>>0]|0;f[ma>>2]=Ta;Oa=h[F>>0]|0;f[ka>>2]=Oa;K=h[F+q>>0]|0;f[ia>>2]=K;Ua=h[F+wa>>0]|0;f[pa>>2]=Ua;F=Va-B+256|0;if(F>>>0<769)fd=h[259297+F>>0]|0;else fd=0;F=fd+B|0;f[Ba>>2]=F;B=(f[o>>2]|0)-fd|0;f[o>>2]=B;Va=f[j>>2]|0;Pa=Va-B+256|0;if(Pa>>>0<769)gd=h[259297+Pa>>0]|0;else gd=0;Pa=gd+B|0;f[o>>2]=Pa;B=Va-gd|0;f[j>>2]=B;Va=Pa-F+256|0;if(Va>>>0<769)hd=h[259297+Va>>0]|0;else hd=0;Va=hd+F|0;f[Ba>>2]=Va;F=Pa-hd|0;f[o>>2]=F;Pa=Xa-Ja+256|0;if(Pa>>>0<769)id=h[259297+Pa>>0]|0;else id=0;Pa=id+Ja|0;f[Fa>>2]=Pa;Ja=Xa-id|0;f[Ga>>2]=Ja;Xa=Na-Ja+256|0;if(Xa>>>0<769)jd=h[259297+Xa>>0]|0;else jd=0;Xa=jd+Ja|0;f[Ga>>2]=Xa;Ja=Na-jd|0;f[Da>>2]=Ja;Na=Xa-Pa+256|0;if(Na>>>0<769)kd=h[259297+Na>>0]|0;else kd=0;Na=kd+Pa|0;f[Fa>>2]=Na;Pa=Xa-kd|0;f[Ga>>2]=Pa;Xa=B-Ja+256|0;if(Xa>>>0<769)ld=h[259297+Xa>>0]|0;else ld=0;Xa=ld+Ja|0;f[Da>>2]=Xa;Ja=B-ld|0;f[j>>2]=Ja;B=Va-Na+256|0;if(B>>>0<769)md=h[259297+B>>0]|0;else md=0;B=md+Na|0;f[Fa>>2]=B;Na=Va-md|0;f[Ba>>2]=Na;Va=Na-Xa+256|0;if(Va>>>0<769)nd=h[259297+Va>>0]|0;else nd=0;Va=nd+Xa|0;f[Da>>2]=Va;Xa=Na-nd|0;f[Ba>>2]=Xa;Na=F-Pa+256|0;if(Na>>>0<769)od=h[259297+Na>>0]|0;else od=0;Na=od+Pa|0;f[Ga>>2]=Na;Pa=F-od|0;f[o>>2]=Pa;F=Pa-Xa+256|0;if(F>>>0<769)pd=h[259297+F>>0]|0;else pd=0;F=pd+Xa|0;f[Ba>>2]=F;Xa=Pa-pd|0;f[o>>2]=Xa;Pa=Va-Na+256|0;if(Pa>>>0<769)qd=h[259297+Pa>>0]|0;else qd=0;Pa=qd+Na|0;f[Ga>>2]=Pa;Na=Va-qd|0;f[Da>>2]=Na;Va=A-D+256|0;if(Va>>>0<769)rd=h[259297+Va>>0]|0;else rd=0;Va=rd+D|0;f[J>>2]=Va;D=A-rd|0;f[Ca>>2]=D;A=Ra-D+256|0;if(A>>>0<769)sd=h[259297+A>>0]|0;else sd=0;A=sd+D|0;f[Ca>>2]=A;D=Ra-sd|0;f[ua>>2]=D;Ra=A-Va+256|0;if(Ra>>>0<769)td=h[259297+Ra>>0]|0;else td=0;Ra=td+Va|0;f[J>>2]=Ra;Va=A-td|0;f[Ca>>2]=Va;A=La-Wa+256|0;if(A>>>0<769)ud=h[259297+A>>0]|0;else ud=0;A=ud+Wa|0;f[za>>2]=A;Wa=La-ud|0;f[ha>>2]=Wa;La=Za-Wa+256|0;if(La>>>0<769)vd=h[259297+La>>0]|0;else vd=0;La=vd+Wa|0;f[ha>>2]=La;Wa=Za-vd|0;f[ya>>2]=Wa;Za=La-A+256|0;if(Za>>>0<769)wd=h[259297+Za>>0]|0;else wd=0;Za=wd+A|0;f[za>>2]=Za;A=La-wd|0;f[ha>>2]=A;La=D-Wa+256|0;if(La>>>0<769)xd=h[259297+La>>0]|0;else xd=0;La=xd+Wa|0;f[ya>>2]=La;Wa=D-xd|0;f[ua>>2]=Wa;D=Ra-Za+256|0;if(D>>>0<769)yd=h[259297+D>>0]|0;else yd=0;D=yd+Za|0;f[za>>2]=D;Za=Ra-yd|0;f[J>>2]=Za;Ra=Za-La+256|0;if(Ra>>>0<769)zd=h[259297+Ra>>0]|0;else zd=0;Ra=zd+La|0;f[ya>>2]=Ra;La=Za-zd|0;f[J>>2]=La;Za=Va-A+256|0;if(Za>>>0<769)Ad=h[259297+Za>>0]|0;else Ad=0;Za=Ad+A|0;f[ha>>2]=Za;A=Va-Ad|0;f[Ca>>2]=A;Va=A-La+256|0;if(Va>>>0<769)Bd=h[259297+Va>>0]|0;else Bd=0;Va=Bd+La|0;f[J>>2]=Va;La=A-Bd|0;f[Ca>>2]=La;A=Ra-Za+256|0;if(A>>>0<769)Cd=h[259297+A>>0]|0;else Cd=0;A=Cd+Za|0;f[ha>>2]=A;Za=Ra-Cd|0;f[ya>>2]=Za;Ra=Ja-Wa+256|0;if(Ra>>>0<769)Dd=h[259297+Ra>>0]|0;else Dd=0;Ra=Dd+Wa|0;f[ua>>2]=Ra;Wa=Ja-Dd|0;f[j>>2]=Wa;Ja=Pa-A+256|0;if(Ja>>>0<769)Ed=h[259297+Ja>>0]|0;else Ed=0;Ja=Ed+A|0;f[ha>>2]=Ja;A=Pa-Ed|0;f[Ga>>2]=A;Pa=A-Ra+256|0;if(Pa>>>0<769)Fd=h[259297+Pa>>0]|0;else Fd=0;Pa=Fd+Ra|0;f[ua>>2]=Pa;Ra=A-Fd|0;f[Ga>>2]=Ra;A=F-Va+256|0;if(A>>>0<769)Gd=h[259297+A>>0]|0;else Gd=0;A=Gd+Va|0;f[J>>2]=A;Va=F-Gd|0;f[Ba>>2]=Va;F=Va-Ra+256|0;if(F>>>0<769)Hd=h[259297+F>>0]|0;else Hd=0;F=Hd+Ra|0;f[Ga>>2]=F;Ra=Va-Hd|0;f[Ba>>2]=Ra;Va=Pa-A+256|0;if(Va>>>0<769)Id=h[259297+Va>>0]|0;else Id=0;Va=Id+A|0;f[J>>2]=Va;A=Pa-Id|0;f[ua>>2]=A;Pa=Xa-La+256|0;if(Pa>>>0<769)Jd=h[259297+Pa>>0]|0;else Jd=0;Pa=Jd+La|0;f[Ca>>2]=Pa;La=Xa-Jd|0;f[o>>2]=La;Xa=B-D+256|0;if(Xa>>>0<769)Kd=h[259297+Xa>>0]|0;else Kd=0;Xa=Kd+D|0;f[za>>2]=Xa;D=B-Kd|0;f[Fa>>2]=D;B=D-Pa+256|0;if(B>>>0<769)Ld=h[259297+B>>0]|0;else Ld=0;B=Ld+Pa|0;f[Ca>>2]=B;Pa=D-Ld|0;f[Fa>>2]=Pa;D=Na-Za+256|0;if(D>>>0<769)Md=h[259297+D>>0]|0;else Md=0;D=Md+Za|0;f[ya>>2]=D;Za=Na-Md|0;f[Da>>2]=Za;Na=Za-Pa+256|0;if(Na>>>0<769)Nd=h[259297+Na>>0]|0;else Nd=0;Na=Nd+Pa|0;f[Fa>>2]=Na;Pa=Za-Nd|0;f[Da>>2]=Pa;Za=B-D+256|0;if(Za>>>0<769)Od=h[259297+Za>>0]|0;else Od=0;Za=Od+D|0;f[ya>>2]=Za;D=B-Od|0;f[Ca>>2]=D;B=La-Ra+256|0;if(B>>>0<769)Pd=h[259297+B>>0]|0;else Pd=0;B=Pd+Ra|0;f[Ba>>2]=B;Ra=La-Pd|0;f[o>>2]=Ra;La=Pa-F+256|0;if(La>>>0<769)Qd=h[259297+La>>0]|0;else Qd=0;La=Qd+F|0;f[Ga>>2]=La;F=Pa-Qd|0;f[Da>>2]=F;Pa=Na-A+256|0;if(Pa>>>0<769)Rd=h[259297+Pa>>0]|0;else Rd=0;Pa=Rd+A|0;f[ua>>2]=Pa;A=Na-Rd|0;f[Fa>>2]=A;Na=D-Va+256|0;if(Na>>>0<769)Sd=h[259297+Na>>0]|0;else Sd=0;Na=Sd+Va|0;f[J>>2]=Na;Va=D-Sd|0;f[Ca>>2]=Va;D=Za-Ja+256|0;if(D>>>0<769)Td=h[259297+D>>0]|0;else Td=0;D=Td+Ja|0;f[ha>>2]=D;Ja=Za-Td|0;f[ya>>2]=Ja;Za=Ka-Ya+256|0;if(Za>>>0<769)Ud=h[259297+Za>>0]|0;else Ud=0;Za=Ud+Ya|0;f[qa>>2]=Za;Ya=Ka-Ud|0;f[z>>2]=Ya;Ka=L-Ya+256|0;if(Ka>>>0<769)Vd=h[259297+Ka>>0]|0;else Vd=0;Ka=Vd+Ya|0;f[z>>2]=Ka;Ya=L-Vd|0;f[la>>2]=Ya;L=Ka-Za+256|0;if(L>>>0<769)Wd=h[259297+L>>0]|0;else Wd=0;L=Wd+Za|0;f[qa>>2]=L;Za=Ka-Wd|0;f[z>>2]=Za;Ka=M-Qa+256|0;if(Ka>>>0<769)Xd=h[259297+Ka>>0]|0;else Xd=0;Ka=Xd+Qa|0;f[oa>>2]=Ka;Qa=M-Xd|0;f[ra>>2]=Qa;M=N-Qa+256|0;if(M>>>0<769)Yd=h[259297+M>>0]|0;else Yd=0;M=Yd+Qa|0;f[ra>>2]=M;Qa=N-Yd|0;f[sa>>2]=Qa;N=M-Ka+256|0;if(N>>>0<769)Zd=h[259297+N>>0]|0;else Zd=0;N=Zd+Ka|0;f[oa>>2]=N;Ka=M-Zd|0;f[ra>>2]=Ka;M=Ya-Qa+256|0;if(M>>>0<769)_d=h[259297+M>>0]|0;else _d=0;M=_d+Qa|0;f[sa>>2]=M;Qa=Ya-_d|0;f[la>>2]=Qa;Ya=L-N+256|0;if(Ya>>>0<769)$d=h[259297+Ya>>0]|0;else $d=0;Ya=$d+N|0;f[oa>>2]=Ya;N=L-$d|0;f[qa>>2]=N;L=N-M+256|0;if(L>>>0<769)ae=h[259297+L>>0]|0;else ae=0;L=ae+M|0;f[sa>>2]=L;M=N-ae|0;f[qa>>2]=M;N=Za-Ka+256|0;if(N>>>0<769)be=h[259297+N>>0]|0;else be=0;N=be+Ka|0;f[ra>>2]=N;Ka=Za-be|0;f[z>>2]=Ka;Za=Ka-M+256|0;if(Za>>>0<769)ce=h[259297+Za>>0]|0;else ce=0;Za=ce+M|0;f[qa>>2]=Za;M=Ka-ce|0;f[z>>2]=M;Ka=L-N+256|0;if(Ka>>>0<769)de=h[259297+Ka>>0]|0;else de=0;Ka=de+N|0;f[ra>>2]=Ka;N=L-de|0;f[sa>>2]=N;L=G-Sa+256|0;if(L>>>0<769)ee=h[259297+L>>0]|0;else ee=0;L=ee+Sa|0;f[ja>>2]=L;Sa=G-ee|0;f[va>>2]=Sa;G=Ma-Sa+256|0;if(G>>>0<769)fe=h[259297+G>>0]|0;else fe=0;G=fe+Sa|0;f[va>>2]=G;Sa=Ma-fe|0;f[na>>2]=Sa;Ma=G-L+256|0;if(Ma>>>0<769)ge=h[259297+Ma>>0]|0;else ge=0;Ma=ge+L|0;f[ja>>2]=Ma;L=G-ge|0;f[va>>2]=L;G=Ta-Oa+256|0;if(G>>>0<769)he=h[259297+G>>0]|0;else he=0;G=he+Oa|0;f[ka>>2]=G;Oa=Ta-he|0;f[ma>>2]=Oa;Ta=K-Ua+256|0;if(Ta>>>0<769)ie=h[259297+Ta>>0]|0;else ie=0;Ta=ie+Ua|0;f[pa>>2]=Ta;Ua=K-ie|0;f[ia>>2]=Ua;K=Oa-Ua+256|0;if(K>>>0<769)je=h[259297+K>>0]|0;else je=0;K=je+Ua|0;f[ia>>2]=K;Ua=Oa-je|0;f[ma>>2]=Ua;Oa=G-Ta+256|0;if(Oa>>>0<769)ke=h[259297+Oa>>0]|0;else ke=0;Oa=ke+Ta|0;f[pa>>2]=Oa;Ta=G-ke|0;f[ka>>2]=Ta;G=Ta-K+256|0;if(G>>>0<769)le=h[259297+G>>0]|0;else le=0;G=le+K|0;f[ia>>2]=G;K=Ta-le|0;f[ka>>2]=K;Ta=Sa-Ua+256|0;if(Ta>>>0<769)me=h[259297+Ta>>0]|0;else me=0;Ta=me+Ua|0;f[ma>>2]=Ta;Ua=Sa-me|0;f[na>>2]=Ua;Sa=Ma-G+256|0;if(Sa>>>0<769)ne=h[259297+Sa>>0]|0;else ne=0;Sa=ne+G|0;f[ia>>2]=Sa;G=Ma-ne|0;f[ja>>2]=G;Ma=G-Ta+256|0;if(Ma>>>0<769)oe=h[259297+Ma>>0]|0;else oe=0;Ma=oe+Ta|0;f[ma>>2]=Ma;Ta=G-oe|0;f[ja>>2]=Ta;G=L-K+256|0;if(G>>>0<769)pe=h[259297+G>>0]|0;else pe=0;G=pe+K|0;f[ka>>2]=G;K=L-pe|0;f[va>>2]=K;L=G-Oa+256|0;if(L>>>0<769)qe=h[259297+L>>0]|0;else qe=0;L=qe+Oa|0;f[pa>>2]=L;Oa=G-qe|0;f[ka>>2]=Oa;G=K-Ta+256|0;if(G>>>0<769)re=h[259297+G>>0]|0;else re=0;G=re+Ta|0;f[ja>>2]=G;Ta=K-re|0;f[va>>2]=Ta;K=Ma-Oa+256|0;if(K>>>0<769)se=h[259297+K>>0]|0;else se=0;K=se+Oa|0;f[ka>>2]=K;Oa=Ma-se|0;f[ma>>2]=Oa;Ma=Sa-L+256|0;if(Ma>>>0<769)te=h[259297+Ma>>0]|0;else te=0;Ma=te+L|0;f[pa>>2]=Ma;L=Sa-te|0;f[ia>>2]=L;Sa=Qa-Ua+256|0;if(Sa>>>0<769)ue=h[259297+Sa>>0]|0;else ue=0;Sa=ue+Ua|0;f[na>>2]=Sa;Ua=Qa-ue|0;f[la>>2]=Ua;Qa=Ka-K+256|0;if(Qa>>>0<769)ve=h[259297+Qa>>0]|0;else ve=0;Qa=ve+K|0;f[ka>>2]=Qa;K=Ka-ve|0;f[ra>>2]=K;Ka=K-Sa+256|0;if(Ka>>>0<769)we=h[259297+Ka>>0]|0;else we=0;Ka=we+Sa|0;f[na>>2]=Ka;Sa=K-we|0;f[ra>>2]=Sa;K=Za-G+256|0;if(K>>>0<769)xe=h[259297+K>>0]|0;else xe=0;K=xe+G|0;f[ja>>2]=K;G=Za-xe|0;f[qa>>2]=G;Za=K-Ma+256|0;if(Za>>>0<769)ye=h[259297+Za>>0]|0;else ye=0;Za=ye+Ma|0;f[pa>>2]=Za;Ma=K-ye|0;f[ja>>2]=Ma;K=G-Sa+256|0;if(K>>>0<769)ze=h[259297+K>>0]|0;else ze=0;K=ze+Sa|0;f[ra>>2]=K;Sa=G-ze|0;f[qa>>2]=Sa;G=Ka-Ma+256|0;if(G>>>0<769)Ae=h[259297+G>>0]|0;else Ae=0;G=Ae+Ma|0;f[ja>>2]=G;Ma=Ka-Ae|0;f[na>>2]=Ma;Ka=Qa-Za+256|0;if(Ka>>>0<769)Be=h[259297+Ka>>0]|0;else Be=0;Ka=Be+Za|0;f[pa>>2]=Ka;Za=Qa-Be|0;f[ka>>2]=Za;Qa=M-Ta+256|0;if(Qa>>>0<769)Ce=h[259297+Qa>>0]|0;else Ce=0;Qa=Ce+Ta|0;f[va>>2]=Qa;Ta=M-Ce|0;f[z>>2]=Ta;M=Ya-L+256|0;if(M>>>0<769)De=h[259297+M>>0]|0;else De=0;M=De+L|0;f[ia>>2]=M;L=Ya-De|0;f[oa>>2]=L;Ya=L-Qa+256|0;if(Ya>>>0<769)Ee=h[259297+Ya>>0]|0;else Ee=0;Ya=Ee+Qa|0;f[va>>2]=Ya;Qa=L-Ee|0;f[oa>>2]=Qa;L=N-Oa+256|0;if(L>>>0<769)Fe=h[259297+L>>0]|0;else Fe=0;L=Fe+Oa|0;f[ma>>2]=L;Oa=N-Fe|0;f[sa>>2]=Oa;N=Oa-Qa+256|0;if(N>>>0<769)Ge=h[259297+N>>0]|0;else Ge=0;N=Ge+Qa|0;f[oa>>2]=N;Qa=Oa-Ge|0;f[sa>>2]=Qa;Oa=Ya-L+256|0;if(Oa>>>0<769)He=h[259297+Oa>>0]|0;else He=0;Oa=He+L|0;f[ma>>2]=Oa;L=Ya-He|0;f[va>>2]=L;Ya=Ta-Sa+256|0;if(Ya>>>0<769)Ie=h[259297+Ya>>0]|0;else Ie=0;Ya=Ie+Sa|0;f[qa>>2]=Ya;Sa=Ta-Ie|0;f[z>>2]=Sa;Ta=Qa-K+256|0;if(Ta>>>0<769)Je=h[259297+Ta>>0]|0;else Je=0;Ta=Je+K|0;f[ra>>2]=Ta;K=Qa-Je|0;f[sa>>2]=K;Qa=N-Ma+256|0;if(Qa>>>0<769)Ke=h[259297+Qa>>0]|0;else Ke=0;Qa=Ke+Ma|0;f[na>>2]=Qa;Ma=N-Ke|0;f[oa>>2]=Ma;N=L-G+256|0;if(N>>>0<769)Le=h[259297+N>>0]|0;else Le=0;N=Le+G|0;f[ja>>2]=N;G=L-Le|0;f[va>>2]=G;L=Oa-Za+256|0;if(L>>>0<769)Me=h[259297+L>>0]|0;else Me=0;L=Me+Za|0;f[ka>>2]=L;Za=Oa-Me|0;f[ma>>2]=Za;Oa=M-Ka+256|0;if(Oa>>>0<769)Ne=h[259297+Oa>>0]|0;else Ne=0;Oa=Ne+Ka|0;f[pa>>2]=Oa;Ka=M-Ne|0;f[ia>>2]=Ka;M=Wa-Ua+256|0;if(M>>>0<769)Oe=h[259297+M>>0]|0;else Oe=0;M=Oe+Ua|0;f[la>>2]=M;f[j>>2]=Wa-Oe;Wa=Na-N+256|0;if(Wa>>>0<769)Pe=h[259297+Wa>>0]|0;else Pe=0;f[ja>>2]=Pe+N;N=Na-Pe|0;f[J>>2]=N;Na=N-M+256|0;if(Na>>>0<769)Qe=h[259297+Na>>0]|0;else Qe=0;Na=Qe+M|0;f[la>>2]=Na;f[J>>2]=N-Qe;N=La-Ta+256|0;if(N>>>0<769)Re=h[259297+N>>0]|0;else Re=0;N=Re+Ta|0;f[ra>>2]=N;f[Ga>>2]=La-Re;La=N-Oa+256|0;if(La>>>0<769)Se=h[259297+La>>0]|0;else Se=0;f[pa>>2]=Se+Oa;Oa=N-Se|0;f[ra>>2]=Oa;N=Na-Oa+256|0;if(N>>>0<769)Te=h[259297+N>>0]|0;else Te=0;f[ra>>2]=Te+Oa;Oa=Na-Te|0;f[la>>2]=Oa;Na=B-Ya+256|0;if(Na>>>0<769)Ue=h[259297+Na>>0]|0;else Ue=0;Na=Ue+Ya|0;f[qa>>2]=Na;f[Ba>>2]=B-Ue;B=D-L+256|0;if(B>>>0<769)Ve=h[259297+B>>0]|0;else Ve=0;f[ka>>2]=Ve+L;L=D-Ve|0;f[ha>>2]=L;D=L-Na+256|0;if(D>>>0<769)We=h[259297+D>>0]|0;else We=0;f[qa>>2]=We+Na;Na=L-We|0;f[ha>>2]=Na;L=Pa-Qa+256|0;if(L>>>0<769)Xe=h[259297+L>>0]|0;else Xe=0;f[na>>2]=Xe+Qa;Qa=Pa-Xe|0;f[ua>>2]=Qa;Pa=Qa-Na+256|0;if(Pa>>>0<769)Ye=h[259297+Pa>>0]|0;else Ye=0;Pa=Ye+Na|0;f[ha>>2]=Pa;f[ua>>2]=Qa-Ye;Qa=Pa-Oa+256|0;if(Qa>>>0<769)Ze=h[259297+Qa>>0]|0;else Ze=0;Qa=Ze+Oa|0;f[la>>2]=Qa;f[ha>>2]=Pa-Ze;Pa=Ra-Sa+256|0;if(Pa>>>0<769)_e=h[259297+Pa>>0]|0;else _e=0;Pa=_e+Sa|0;f[z>>2]=Pa;f[o>>2]=Ra-_e;Ra=Ja-Za+256|0;if(Ra>>>0<769)$e=h[259297+Ra>>0]|0;else $e=0;f[ma>>2]=$e+Za;Za=Ja-$e|0;f[ya>>2]=Za;Ja=Za-Pa+256|0;if(Ja>>>0<769)af=h[259297+Ja>>0]|0;else af=0;Ja=af+Pa|0;f[z>>2]=Ja;f[ya>>2]=Za-af;Za=A-Ma+256|0;if(Za>>>0<769)bf=h[259297+Za>>0]|0;else bf=0;Za=bf+Ma|0;f[oa>>2]=Za;f[Fa>>2]=A-bf;A=Ja-Za+256|0;if(A>>>0<769)cf=h[259297+A>>0]|0;else cf=0;f[oa>>2]=cf+Za;Za=Ja-cf|0;f[z>>2]=Za;Ja=F-K+256|0;if(Ja>>>0<769)df=h[259297+Ja>>0]|0;else df=0;Ja=df+K|0;f[sa>>2]=Ja;f[Da>>2]=F-df;F=Xa-Ka+256|0;if(F>>>0<769)ef=h[259297+F>>0]|0;else ef=0;f[ia>>2]=ef+Ka;Ka=Xa-ef|0;f[za>>2]=Ka;Xa=Ka-Ja+256|0;if(Xa>>>0<769)ff=h[259297+Xa>>0]|0;else ff=0;f[sa>>2]=ff+Ja;Ja=Ka-ff|0;f[za>>2]=Ja;Ka=Va-G+256|0;if(Ka>>>0<769)gf=h[259297+Ka>>0]|0;else gf=0;f[va>>2]=gf+G;G=Va-gf|0;f[Ca>>2]=G;Va=G-Ja+256|0;if(Va>>>0<769)hf=h[259297+Va>>0]|0;else hf=0;Va=hf+Ja|0;f[za>>2]=Va;f[Ca>>2]=G-hf;G=Va-Za+256|0;if(G>>>0<769)jf=h[259297+G>>0]|0;else jf=0;f[z>>2]=jf+Za;Za=Va-jf|0;f[za>>2]=Za;Va=Za-Qa+256|0;if(Va>>>0<769)kf=h[259297+Va>>0]|0;else kf=0;b[H+ed>>0]=kf+Qa;Qa=ed+1|0;if((ed|0)<(Ha|0))ed=Qa;else{I=Aa;C=Qa;continue b}}}if((l|0)==(p|0))break;else H=H+n|0}u=e;return}default:{u=e;return}}}function I7(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,W=0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0,ea=0,fa=0;i=u;u=u+384|0;j=i+104|0;k=i+88|0;l=i+328|0;m=i+32|0;o=i+280|0;q=i;r=i+272|0;s=i+320|0;t=i+216|0;v=i+160|0;dQ(r,53764);AL(s,a,-1);vM(c,s,BL(a,-1)|0,-1,0,0);do if((yM(a)|0)==65536){s=f[a+4>>2]|0;f[t>>2]=f[s>>2];w=t+4|0;x=s+4|0;f[w>>2]=f[x>>2];y=t+8|0;f[y>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];f[t+20>>2]=f[s+20>>2];f[t+24>>2]=f[s+24>>2];f[t+28>>2]=f[s+28>>2];f[t+32>>2]=f[s+32>>2];z=f[s+36>>2]|0;f[t+36>>2]=z;f[t+40>>2]=y;y=t+48|0;A=t+44|0;f[A>>2]=y;f[y>>2]=0;f[t+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[s+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;jL(t,s);break}}else yL(t,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[v>>2]=f[a>>2];s=v+4|0;w=a+4|0;f[s>>2]=f[w>>2];x=v+8|0;f[x>>2]=f[a+8>>2];f[v+12>>2]=f[a+12>>2];f[v+16>>2]=f[a+16>>2];f[v+20>>2]=f[a+20>>2];f[v+24>>2]=f[a+24>>2];f[v+28>>2]=f[a+28>>2];f[v+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[v+36>>2]=y;f[v+40>>2]=x;x=v+48|0;A=v+44|0;f[A>>2]=x;f[x>>2]=0;f[v+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[a+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[s>>2]=0;jL(v,a);break}}else yL(v,c,-1);while(0);c=f[t>>2]|0;switch(c&7){case 0:{a=(c>>>3&511)+1|0;s=f[f[t+40>>2]>>2]|0;switch(c&4095){case 16:case 0:{if((f[t+16>>2]|0)==(f[v+16>>2]|0))B=18;break}default:B=18}if((B|0)==18){f[j>>2]=0;f[j+4>>2]=0;Vac(aD(j,140)|0,240998,140)|0;bO(-215,j,241139,237558,3474);bD(j)}C=!(e<=0.0)?e:1.0;D=!(g<=0.0)?g:1.0;E=-.5/(C*C);C=-.5/(D*D);if((d|0)<1)F=MVb(D*1.5)|0;else F=d>>>1;w=(F|0)>1?F:1;F=w<<1|1;f[j>>2]=1124007936;x=j+4|0;A=j+8|0;y=j+40|0;G=x;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[y>>2]=A;A=j+48|0;z=j+44|0;f[z>>2]=A;f[A>>2]=0;f[j+52>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=t;I=l+8|0;f[I>>2]=0;f[I+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;_P(k,l,w,w,w,w,h,m);I=a<<8;J=a<<10;K=L5b(J)|0;Nac(K|0,0,J|0)|0;J=Y(F,F)|0;f[k>>2]=0;F=k+4|0;f[F>>2]=0;f[k+8>>2]=0;if(J>>>0>1073741823)c4b(k);N=J<<2;O=L5b(N)|0;f[k>>2]=O;P=O+(J<<2)|0;f[k+8>>2]=P;Nac(O|0,0,N|0)|0;f[F>>2]=P;P=L5b(N)|0;Nac(P|0,0,N|0)|0;N=0;do{D=+V(+(E*+(Y(N,N)|0)));n[K+(N<<2)>>2]=D;N=N+1|0}while((N|0)!=(I|0));I=0-w|0;if((w|0)<(I|0))Q=0;else{E=+(w|0);N=f[A>>2]|0;J=0;R=I;while(1){D=+(R|0);S=D*D;T=Y(R,N)|0;U=I;W=J;while(1){D=+(U|0);X=+M(+(S+D*D));if(X>E)Z=W;else{_=(Y(U,a)|0)+T|0;D=+V(+(C*(X*X)));n[O+(W<<2)>>2]=D;f[P+(W<<2)>>2]=_;Z=W+1|0}if((U|0)<(w|0)){U=U+1|0;W=Z}else break}if((R|0)<(w|0)){J=Z;R=R+1|0}else{Q=Z;break}}}f[l>>2]=53792;f[l+4>>2]=j;f[l+8>>2]=v;f[l+12>>2]=w;f[l+16>>2]=Q;f[l+20>>2]=P;f[l+24>>2]=O;f[l+28>>2]=K;f[m>>2]=0;f[m+4>>2]=s;s=f[v+4>>2]|0;if((s|0)<3)$=Y(f[v+12>>2]|0,f[v+8>>2]|0)|0;else{O=f[v+40>>2]|0;Q=0;w=1;while(1){Z=Y(f[O+(Q<<2)>>2]|0,w)|0;Q=Q+1|0;if((Q|0)==(s|0)){$=Z;break}else w=Z}}RQ(m,l,+($>>>0)*.0000152587890625);O5b(P);P=f[k>>2]|0;if(P|0){$=f[F>>2]|0;if(($|0)!=(P|0))f[F>>2]=$+(~(($+-4-P|0)>>>2)<<2);O5b(P)}O5b(K);K=j+36|0;P=f[K>>2]|0;if(P|0?($=P+12|0,P=f[$>>2]|0,f[$>>2]=P+-1,(P|0)==1):0)kL(j);f[K>>2]=0;K=j+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[x>>2]|0)>0){K=f[y>>2]|0;y=0;do{f[K+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[z>>2]|0;if((x|0)!=(A|0))UC(x);break}case 5:{x=(c>>>3&511)+1|0;p[j>>3]=-1.0;p[k>>3]=1.0;A=f[f[t+40>>2]>>2]|0;switch(c&4095){case 21:case 5:{if((f[t+16>>2]|0)==(f[v+16>>2]|0))B=52;break}default:B=52}if((B|0)==52){f[l>>2]=0;f[l+4>>2]=0;Vac(aD(l,140)|0,241158,140)|0;bO(-215,l,241299,237558,3735);bD(l)}C=!(e<=0.0)?e:1.0;e=!(g<=0.0)?g:1.0;g=-.5/(C*C);E=-.5/(e*e);if((d|0)<1)aa=MVb(e*1.5)|0;else aa=d>>>1;d=(aa|0)>1?aa:1;aa=d<<1|1;WL(m,t,1,0);f[l+8>>2]=0;f[l+12>>2]=0;f[l>>2]=16842752;f[l+4>>2]=m;KG(l,j,k,0,0,UM()|0);B=m+36|0;c=f[B>>2]|0;if(c|0?(z=c+12|0,c=f[z>>2]|0,f[z>>2]=c+-1,(c|0)==1):0)kL(m);f[B>>2]=0;B=m+16|0;c=m+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[c>>2]|0)>0){B=f[m+40>>2]|0;z=0;do{f[B+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[c>>2]|0))}c=f[m+44>>2]|0;if((c|0)!=(m+48|0))UC(c);if(!(+L(+(+p[j>>3]-+p[k>>3]))<1.1920928955078125e-07)){f[l>>2]=1124007936;c=l+4|0;z=l+8|0;B=l+40|0;G=c;H=G+36|0;do{f[G>>2]=0;G=G+4|0}while((G|0)<(H|0));f[B>>2]=z;z=l+48|0;y=l+44|0;f[y>>2]=z;f[z>>2]=0;f[l+52>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=t;K=o+8|0;f[K>>2]=0;f[K+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q+16>>2]=0;f[q+20>>2]=0;f[q+24>>2]=0;f[q+28>>2]=0;_P(m,o,d,d,d,d,h,q);h=m+8|0;f[h>>2]=0;f[h+4>>2]=0;f[m>>2]=50397184;f[m+4>>2]=l;fP(m,C*-5.0);h=Y(aa,aa)|0;f[m>>2]=0;aa=m+4|0;f[aa>>2]=0;f[m+8>>2]=0;if(h>>>0>1073741823)c4b(m);K=h<<2;P=L5b(K)|0;f[m>>2]=P;$=P+(h<<2)|0;f[m+8>>2]=$;Nac(P|0,0,K|0)|0;f[aa>>2]=$;$=L5b(K)|0;Nac($|0,0,K|0)|0;C=+p[k>>3];e=+p[j>>3];k=x<<12;K=k|2;h=K<<2;F=L5b(h)|0;Nac(F|0,0,h|0)|0;S=+(k|0)/(+(x|0)*(C-e));k=0;e=1.0;while(1){if(e>0.0){C=+(k|0)/S;D=+V(+(g*(C*C)));ba=D;ca=D}else{ba=e;ca=0.0}n[F+(k<<2)>>2]=ca;k=k+1|0;if((k|0)==(K|0))break;else e=ba}K=0-d|0;if((d|0)<(K|0))da=0;else{ba=+(d|0);k=(f[z>>2]|0)>>>2;h=0;w=K;while(1){e=+(w|0);ca=e*e;s=Y(w,k)|0;Q=K;O=h;while(1){e=+(Q|0);g=+M(+(ca+e*e));if(g>ba)ea=O;else{Z=(Y(Q,x)|0)+s|0;e=+V(+(E*(g*g)));n[P+(O<<2)>>2]=e;f[$+(O<<2)>>2]=Z;ea=O+1|0}if((Q|0)<(d|0)){Q=Q+1|0;O=ea}else break}if((w|0)<(d|0)){h=ea;w=w+1|0}else{da=ea;break}}}f[o>>2]=53812;f[o+4>>2]=x;f[o+8>>2]=d;f[o+12>>2]=da;f[o+16>>2]=$;f[o+20>>2]=l;f[o+24>>2]=v;n[o+28>>2]=S;f[o+32>>2]=P;f[o+36>>2]=F;f[q>>2]=0;f[q+4>>2]=A;A=f[v+4>>2]|0;if((A|0)<3)fa=Y(f[v+12>>2]|0,f[v+8>>2]|0)|0;else{P=f[v+40>>2]|0;da=0;d=1;while(1){x=Y(f[P+(da<<2)>>2]|0,d)|0;da=da+1|0;if((da|0)==(A|0)){fa=x;break}else d=x}}RQ(q,o,+(fa>>>0)*.0000152587890625);O5b(F);O5b($);$=f[m>>2]|0;if($|0){m=f[aa>>2]|0;if((m|0)!=($|0))f[aa>>2]=m+(~((m+-4-$|0)>>>2)<<2);O5b($)}$=l+36|0;m=f[$>>2]|0;if(m|0?(aa=m+12|0,m=f[aa>>2]|0,f[aa>>2]=m+-1,(m|0)==1):0)kL(l);f[$>>2]=0;$=l+16|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[c>>2]|0)>0){$=f[B>>2]|0;B=0;do{f[$+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[c>>2]|0))}c=f[y>>2]|0;if((c|0)!=(z|0))UC(c)}else{c=l+8|0;f[c>>2]=0;f[c+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=v;SP(t,l)}break}default:{f[j>>2]=0;f[j+4>>2]=0;G=aD(j,61)|0;l=241319;H=G+61|0;do{b[G>>0]=b[l>>0]|0;G=G+1|0;l=l+1|0}while((G|0)<(H|0));bO(-210,j,241381,237558,3931);bD(j)}}j=v+36|0;l=f[j>>2]|0;if(l|0?(G=l+12|0,l=f[G>>2]|0,f[G>>2]=l+-1,(l|0)==1):0)kL(v);f[j>>2]=0;j=v+16|0;l=v+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[l>>2]|0)>0){j=f[v+40>>2]|0;G=0;do{f[j+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[l>>2]|0))}l=f[v+44>>2]|0;if((l|0)!=(v+48|0))UC(l);l=t+36|0;v=f[l>>2]|0;if(v|0?(G=v+12|0,v=f[G>>2]|0,f[G>>2]=v+-1,(v|0)==1):0)kL(t);f[l>>2]=0;l=t+16|0;v=t+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[v>>2]|0)>0){l=f[t+40>>2]|0;G=0;do{f[l+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[v>>2]|0))}v=f[t+44>>2]|0;if((v|0)!=(t+48|0))UC(v);if(!(f[r+4>>2]|0)){u=i;return}u=i;return}function J7(a){a=a|0;O5b(a);return}function K7(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,M=0.0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0,$=0.0,aa=0.0;d=u;u=u+16|0;e=d;g=a+24|0;h=f[g>>2]|0;i=f[(f[h+40>>2]|0)+4>>2]|0;j=f[c>>2]|0;k=c+4|0;if((j|0)>=(f[k>>2]|0)){u=d;return}c=a+20|0;l=a+8|0;m=a+4|0;o=e+4|0;p=i*3|0;q=(i|0)>0;r=a+12|0;s=a+16|0;t=a+28|0;v=a+32|0;w=a+36|0;a=j;j=h;while(1){h=f[c>>2]|0;x=f[l>>2]|0;y=(f[h+16>>2]|0)+(Y(f[f[h+44>>2]>>2]|0,x+a|0)|0)|0;h=f[m>>2]|0;z=y+((Y(h,x)|0)<<2)|0;x=(f[j+16>>2]|0)+(Y(f[f[j+44>>2]>>2]|0,a)|0)|0;a:do switch(h|0){case 1:{if(q){y=f[r>>2]|0;if((y|0)<=0){A=0;while(1){n[x+(A<<2)>>2]=C;A=A+1|0;if((A|0)==(i|0))break a}}A=f[s>>2]|0;B=f[v>>2]|0;D=f[w>>2]|0;E=0;do{F=+n[z+(E<<2)>>2];G=+n[t>>2];H=0;I=0.0;J=0.0;do{K=+n[z+((f[A+(H<<2)>>2]|0)+E<<2)>>2];M=+L(+(K-F))*G;N=~~M;O=N-(+(N|0)>M&1)|0;P=+n[D+(O<<2)>>2];Q=+n[B+(H<<2)>>2]*(P+(+n[D+(O+1<<2)>>2]-P)*(M-+(O|0)));I=I+K*Q;J=J+Q;H=H+1|0}while((H|0)<(y|0));n[x+(E<<2)>>2]=I/J;E=E+1|0}while((E|0)!=(i|0))}break}case 3:{R=12;break}default:{f[e>>2]=0;f[o>>2]=0;E=aD(e,7)|0;b[E>>0]=b[241397]|0;b[E+1>>0]=b[241398]|0;b[E+2>>0]=b[241399]|0;b[E+3>>0]=b[241400]|0;b[E+4>>0]=b[241401]|0;b[E+5>>0]=b[241402]|0;b[E+6>>0]=b[241403]|0;bO(-215,e,489445,237558,3618);bD(e);R=12}}while(0);b:do if((R|0)==12?(R=0,q):0){h=f[r>>2]|0;if((h|0)<=0){E=0;while(1){n[x+(E<<2)>>2]=C;n[x+(E+1<<2)>>2]=C;n[x+(E+2<<2)>>2]=C;E=E+3|0;if((E|0)>=(p|0))break b}}E=f[s>>2]|0;y=f[v>>2]|0;D=f[w>>2]|0;B=0;do{A=z+(B<<2)|0;G=+n[A>>2];H=B+1|0;F=+n[z+(H<<2)>>2];O=B+2|0;Q=+n[z+(O<<2)>>2];K=+n[t>>2];M=0.0;P=0.0;S=0.0;T=0.0;N=0;do{U=A+(f[E+(N<<2)>>2]<<2)|0;V=+n[U>>2];W=+n[U+4>>2];X=+n[U+8>>2];Z=(+L(+(V-G))+ +L(+(W-F))+ +L(+(X-Q)))*K;U=~~Z;_=U-(+(U|0)>Z&1)|0;$=+n[D+(_<<2)>>2];aa=+n[y+(N<<2)>>2]*($+(+n[D+(_+1<<2)>>2]-$)*(Z-+(_|0)));M=M+V*aa;P=P+W*aa;T=T+X*aa;S=S+aa;N=N+1|0}while((N|0)<(h|0));K=1.0/S;n[x+(B<<2)>>2]=K*M;n[x+(H<<2)>>2]=P*K;n[x+(O<<2)>>2]=T*K;B=B+3|0}while((B|0)<(p|0))}while(0);x=a+1|0;if((x|0)>=(f[k>>2]|0))break;a=x;j=f[g>>2]|0}u=d;return}function L7(a){a=a|0;O5b(a);return}function M7(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0;d=a+8|0;e=f[d>>2]|0;g=(f[e>>2]|0)>>>3&511;i=g+1|0;j=f[(f[e+40>>2]|0)+4>>2]|0;k=f[c>>2]|0;l=c+4|0;if((k|0)>=(f[l>>2]|0))return;c=a+4|0;m=a+12|0;o=(g|0)==0;g=(j|0)>0;p=a+16|0;q=a+20|0;r=a+24|0;s=a+28|0;a=j*3|0;t=k;k=e;while(1){e=f[c>>2]|0;u=f[m>>2]|0;v=(f[e+16>>2]|0)+(Y(f[f[e+44>>2]>>2]|0,u+t|0)|0)+(Y(u,i)|0)|0;u=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,t)|0)|0;if(o){if(g){e=0;do{w=h[v+e>>0]|0;x=f[p>>2]|0;if((x|0)>0){y=f[q>>2]|0;z=f[r>>2]|0;A=f[s>>2]|0;B=0;C=0.0;D=0.0;while(1){E=b[v+((f[y+(B<<2)>>2]|0)+e)>>0]|0;F=(E&255)-w|0;G=+n[z+(B<<2)>>2]*+n[A+(((F|0)>-1?F:0-F|0)<<2)>>2];H=C+ +(E&255)*G;I=D+G;B=B+1|0;if((B|0)>=(x|0)){J=H;K=I;break}else{C=H;D=I}}}else{J=0.0;K=0.0}x=(LVb(J/K)|0)&255;b[u+e>>0]=x;e=e+1|0}while((e|0)!=(j|0))}}else if(g){e=0;do{x=v+e|0;B=h[x>>0]|0;A=e+1|0;z=h[v+A>>0]|0;w=e+2|0;y=h[v+w>>0]|0;E=f[p>>2]|0;if((E|0)>0){F=f[q>>2]|0;L=f[r>>2]|0;M=f[s>>2]|0;D=0.0;C=0.0;I=0.0;H=0.0;N=0;while(1){O=x+(f[F+(N<<2)>>2]|0)|0;P=b[O>>0]|0;Q=b[O+1>>0]|0;R=b[O+2>>0]|0;O=(P&255)-B|0;S=(Q&255)-z|0;T=(R&255)-y|0;G=+n[L+(N<<2)>>2]*+n[M+(((S|0)>-1?S:0-S|0)+((O|0)>-1?O:0-O|0)+((T|0)>-1?T:0-T|0)<<2)>>2];U=H+ +(P&255)*G;V=I+ +(Q&255)*G;W=C+ +(R&255)*G;X=D+G;N=N+1|0;if((N|0)>=(E|0)){Z=X;_=W;$=V;aa=U;break}else{D=X;C=W;I=V;H=U}}}else{Z=0.0;_=0.0;$=0.0;aa=0.0}H=1.0/Z;E=LVb(aa*H)|0;N=LVb($*H)|0;M=LVb(_*H)|0;b[u+e>>0]=E;b[u+A>>0]=N;b[u+w>>0]=M;e=e+3|0}while((e|0)<(a|0))}e=t+1|0;if((e|0)>=(f[l>>2]|0))break;t=e;k=f[d>>2]|0}return}function N7(a,c,d,e){a=a|0;c=c|0;d=d|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0,t=0,v=0.0,w=0.0,x=0,y=0,z=0.0;g=u;u=u+320|0;h=g+304|0;i=g+248|0;j=g+192|0;k=g;dQ(h,53824);loa(k,a,0);roa(k,i);loa(k,c,0);roa(k,j);switch(d|0){case 1:{d=0;c=0;e=0.0;a=0;while(1){l=+p[i+(a<<3)>>3];m=+L(+l);n=+p[j+(a<<3)>>3];o=+L(+n);c=l!=l|0.0!=0.0|l==0.0?c:1;d=n!=n|0.0!=0.0|n==0.0?d:1;if(m>1.0e-05&o>1.0e-05){q=1.0/((l>0.0?1.0:l<0.0?-1.0:0.0)*+JVb(m));r=e+ +L(+(1.0/((n>0.0?1.0:n<0.0?-1.0:0.0)*+JVb(o))-q))}else r=e;a=a+1|0;if((a|0)==7)break;else e=r}s=(d&1)!=0;t=(c&1)!=0;v=r;break}case 2:{c=0;d=0;r=0.0;a=0;while(1){e=+p[i+(c<<3)>>3];q=+L(+e);o=+p[j+(c<<3)>>3];n=+L(+o);d=e!=e|0.0!=0.0|e==0.0?d:1;a=o!=o|0.0!=0.0|o==0.0?a:1;if(q>1.0e-05&n>1.0e-05){m=(e>0.0?1.0:e<0.0?-1.0:0.0)*+JVb(q);w=r+ +L(+((o>0.0?1.0:o<0.0?-1.0:0.0)*+JVb(n)-m))}else w=r;c=c+1|0;if((c|0)==7)break;else r=w}s=(a&1)!=0;t=(d&1)!=0;v=w;break}case 3:{d=0;a=0;c=0;w=0.0;while(1){r=+p[i+(d<<3)>>3];m=+L(+r);n=+p[j+(d<<3)>>3];o=+L(+n);x=c|r==r&0.0==0.0&r!=0.0;y=a|n==n&0.0==0.0&n!=0.0;if(m>1.0e-05&o>1.0e-05?(q=(r>0.0?1.0:r<0.0?-1.0:0.0)*+JVb(m),m=+L(+((q-(n>0.0?1.0:n<0.0?-1.0:0.0)*+JVb(o))/q)),w<m):0)z=m;else z=w;d=d+1|0;if((d|0)==7){s=y;t=x;v=z;break}else{a=y;c=x;w=z}}break}default:{f[k>>2]=0;f[k+4>>2]=0;c=aD(k,25)|0;a=241550;d=c+25|0;do{b[c>>0]=b[a>>0]|0;c=c+1|0;a=a+1|0}while((c|0)<(d|0));bO(-5,k,241576,241588,161);bD(k);s=0;t=0;v=0.0}}z=t^s?1797693134862315708145274.0e284:v;if(!(f[h+4>>2]|0)){u=g;return +z}u=g;return +z}function O7(a){a=a|0;return}function P7(a){a=a|0;O5b(a);return}function Q7(a){a=a|0;return}function R7(a){a=a|0;O5b(a);return}function S7(a){a=a|0;return}function T7(a){a=a|0;return}function U7(a){a=a|0;O5b(a);return}function V7(a){a=a|0;return}function W7(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=53920;b=a+192|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+196>>2]=0;b=a+184|0;c=f[b>>2]|0;if(c|0?(e=c+4|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+188>>2]=0;b=a+176|0;c=f[b>>2]|0;if(c|0?(d=c+4|0,e=f[d>>2]|0,f[d>>2]=e+-1,(e|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[b>>2]=0;f[a+180>>2]=0;b=f[a+164>>2]|0;if(b|0){c=a+168|0;e=f[c>>2]|0;if((e|0)!=(b|0))f[c>>2]=e+(~((e+-4-b|0)>>>2)<<2);O5b(b)}b=f[a+128>>2]|0;if(b|0){e=a+132|0;if((f[e>>2]|0)!=(b|0))f[e>>2]=b;O5b(b)}b=f[a+116>>2]|0;if(b|0){e=a+120|0;if((f[e>>2]|0)!=(b|0))f[e>>2]=b;O5b(b)}b=f[a+104>>2]|0;if(b|0){e=a+108|0;if((f[e>>2]|0)!=(b|0))f[e>>2]=b;O5b(b)}b=f[a+92>>2]|0;if(b|0){e=a+96|0;if((f[e>>2]|0)!=(b|0))f[e>>2]=b;O5b(b)}b=f[a+76>>2]|0;if(!b)return;e=a+80|0;a=f[e>>2]|0;if((a|0)!=(b|0))f[e>>2]=a+(~((a+-4-b|0)>>>2)<<2);O5b(b);return}function X7(a){a=a|0;W7(a);O5b(a);return}function Y7(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;g=u;u=u+16|0;h=g;i=f[c>>2]|0;j=a+36|0;f[j>>2]=i;k=f[c+4>>2]|0;c=a+40|0;f[c>>2]=k;l=f[e>>2]|0;m=f[e+4>>2]|0;e=f[d>>2]|0;n=f[d+4>>2]|0;d=a+44|0;f[d>>2]=l;o=a+48|0;f[o>>2]=m;p=a+52|0;f[p>>2]=e;q=a+56|0;f[q>>2]=n;if(((e+l|0)>(i|0)?1:(l|m|e|n|0)<0)|(n+m|0)>(k|0)){f[h>>2]=0;f[h+4>>2]=0;Vac(aD(h,143)|0,242111,143)|0;bO(-215,h,242255,241836,173);bD(h);r=f[p>>2]|0}else r=e;e=a+4|0;k=f[e>>2]|0;m=(k>>>3&511)+1<<(47696>>>(k<<1&14)&3);n=a+12|0;l=f[n>>2]|0;i=(l>>>3&511)+1<<(47696>>>(l<<1&14)&3);l=a+116|0;s=f[l>>2]|0;t=a+120|0;v=(s|0)==(f[t>>2]|0)?0:s;s=a+16|0;w=a+20|0;x=f[w>>2]|0;y=x+3|0;z=a+28|0;A=f[z>>2]|0;B=x-A+-1|0;x=((A|0)<(B|0)?B:A)<<1|1;A=(y|0)<(x|0)?x:y;y=a+32|0;x=f[y>>2]|0;if((x|0)>=(r|0)){B=a+164|0;C=a+168|0;D=f[C>>2]|0;E=f[B>>2]|0;if((A|0)==(D-E>>2|0))F=a+180|0;else{G=C;H=C;I=B;J=B;K=E;L=D;M=7}}else{D=a+168|0;E=a+164|0;G=D;H=D;I=E;J=E;K=f[E>>2]|0;L=f[D>>2]|0;M=7}do if((M|0)==7){D=L-K>>2;E=K;B=L;if(A>>>0<=D>>>0)if(A>>>0<D>>>0?(C=E+(A<<2)|0,(B|0)!=(C|0)):0){f[G>>2]=B+(~((B+-4-C|0)>>>2)<<2);N=x;O=r;P=k}else{N=x;O=r;P=k}else{Y2(J,A-D|0);N=f[y>>2]|0;O=f[p>>2]|0;P=f[e>>2]|0}D=(N|0)<(O|0)?O:N;f[y>>2]=D;C=(P>>>3&511)+1|0;B=a+104|0;E=Y(D+-1+(f[s>>2]|0)|0,m)|0;D=a+108|0;Q=f[D>>2]|0;R=f[B>>2]|0;S=Q-R|0;T=R;R=Q;if(E>>>0<=S>>>0){if(E>>>0<S>>>0?(Q=T+E|0,(R|0)!=(Q|0)):0)f[D>>2]=Q}else DL(B,E-S|0);if(!(f[a+72>>2]|0)){if(!v){f[h>>2]=0;f[h+4>>2]=0;U=aD(h,14)|0;V=242261;W=U+14|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));bO(-215,h,242255,241836,191);bD(h)}S=a+128|0;E=f[n>>2]|0;Q=f[y>>2]|0;D=f[s>>2]|0;R=Y((E>>>3&511)+1<<(47696>>>(E<<1&14)&3),Q+63+D|0)|0;E=a+132|0;T=f[E>>2]|0;X=f[S>>2]|0;Z=T-X|0;_=X;$=T;if(R>>>0<=Z>>>0)if(R>>>0<Z>>>0?(T=_+R|0,($|0)!=(T|0)):0){f[E>>2]=T;aa=X;ba=Q;ca=D}else{aa=X;ba=Q;ca=D}else{DL(S,R-Z|0);aa=f[S>>2]|0;ba=f[y>>2]|0;ca=f[s>>2]|0}S=aa+63&-64;Z=Y(ba+-1+ca|0,m)|0;R=a+180|0;D=f[R>>2]|0;if(!D)da=f[B>>2]|0;else da=S;if((Z|0)>0){Q=(f[t>>2]|0)-(f[l>>2]|0)|0;X=0;do{T=Z-X|0;Q=(T|0)<(Q|0)?T:Q;if((Q|0)>0){T=0;do{b[da+(T+X)>>0]=b[v+T>>0]|0;T=T+1|0}while((T|0)<(Q|0))}X=Q+X|0}while((Z|0)>(X|0));ea=f[R>>2]|0}else ea=D;if(!ea){X=f[a+188>>2]|0;uh[f[(f[X>>2]|0)+8>>2]&255](X,f[B>>2]|0,S,f[y>>2]|0,C);fa=R}else fa=R}else fa=a+180|0;if(!(f[fa>>2]|0))ga=0;else ga=(f[s>>2]|0)+-1|0;X=Y((f[y>>2]|0)+63+ga&-64,i)|0;Z=a+92|0;Q=(Y(X,(f[H>>2]|0)-(f[I>>2]|0)>>2)|0)+64|0;X=a+96|0;T=f[X>>2]|0;E=f[Z>>2]|0;$=T-E|0;if(Q>>>0>$>>>0){DL(Z,Q-$|0);F=fa;break}if(Q>>>0<$>>>0?($=E+Q|0,(T|0)!=($|0)):0){f[X>>2]=$;F=fa}else F=fa}while(0);fa=f[p>>2]|0;I=f[F>>2]|0;H=f[s>>2]|0;ga=Y(fa+15+((I|0)==0?0:H+-1|0)&-16,i)|0;i=a+140|0;f[i>>2]=ga;ga=f[a+24>>2]|0;y=f[d>>2]|0;d=ga-y|0;ea=(d|0)>0;da=a+60|0;f[da>>2]=ea?d:0;l=f[j>>2]|0;j=H+-1-ga+y+fa-l|0;fa=(j|0)>0;H=a+64|0;f[H>>2]=fa?j:0;a:do if(ea|fa){j=a+68|0;t=f[j>>2]|0;if(!t){if(!v){f[h>>2]=0;f[h+4>>2]=0;U=aD(h,14)|0;V=242261;W=U+14|0;do{b[U>>0]=b[V>>0]|0;U=U+1|0;V=V+1|0}while((U|0)<(W|0));bO(-215,h,242255,241836,225);bD(h);ha=f[F>>2]|0}else ha=I;if(ha){R=(f[a+168>>2]|0)-(f[a+164>>2]|0)|0;if((R|0)>0)ia=R>>2;else break}else ia=1;R=a+104|0;C=a+92|0;S=0;B=ha;while(1){if(!B)ja=f[R>>2]|0;else ja=((f[C>>2]|0)+63&-64)+(Y(f[i>>2]|0,S)|0)|0;Vac(ja|0,v|0,Y(f[da>>2]|0,m)|0)|0;D=f[H>>2]|0;Vac(ja+(Y((f[p>>2]|0)+-1+(f[s>>2]|0)-D|0,m)|0)|0,v|0,Y(D,m)|0)|0;D=S+1|0;if((D|0)==(ia|0))break a;S=D;B=f[F>>2]|0}}B=((ga|0)<(y|0)?ga:y)-y|0;S=f[a+88>>2]|0;C=f[a+76>>2]|0;b:do if(ea){if((S|0)>0){ka=0;la=d;ma=t}else{ZP(0-d|0,l,t)|0;R=f[da>>2]|0;if((R|0)>1){na=R;oa=1}else break;while(1){ZP(oa-na|0,l,f[j>>2]|0)|0;oa=oa+1|0;na=f[da>>2]|0;if((oa|0)>=(na|0))break b}}while(1){R=Y((ZP(ka-la|0,l,ma)|0)+B|0,S)|0;D=Y(ka,S)|0;ca=0;do{f[C+(ca+D<<2)>>2]=ca+R;ca=ca+1|0}while((ca|0)!=(S|0));ca=ka+1|0;R=f[da>>2]|0;if((ca|0)>=(R|0))break b;ka=ca;la=R;ma=f[j>>2]|0}}while(0);if((f[H>>2]|0)>0){if((S|0)>0)pa=0;else{t=0;while(1){ZP(t+l|0,l,f[j>>2]|0)|0;t=t+1|0;if((t|0)>=(f[H>>2]|0))break a}}do{t=Y((ZP(pa+l|0,l,f[j>>2]|0)|0)+B|0,S)|0;R=0;do{ca=C+((Y((f[da>>2]|0)+pa|0,S)|0)+R<<2)|0;f[ca>>2]=R+t;R=R+1|0}while((R|0)!=(S|0));pa=pa+1|0}while((pa|0)<(f[H>>2]|0))}}while(0);f[a+160>>2]=0;f[a+156>>2]=0;H=f[o>>2]|0;o=f[z>>2]|0;z=H-o|0;pa=(z|0)>0?z:0;f[a+148>>2]=pa;z=a+144|0;f[z>>2]=pa;pa=H+-1+(f[q>>2]|0)+(f[w>>2]|0)-o|0;o=f[c>>2]|0;f[a+152>>2]=(o|0)<(pa|0)?o:pa;pa=f[a+196>>2]|0;if(pa|0)bi[f[(f[pa>>2]|0)+12>>2]&2047](pa);pa=f[F>>2]|0;if(!pa){qa=f[z>>2]|0;u=g;return qa|0}bi[f[(f[pa>>2]|0)+12>>2]&2047](pa);qa=f[z>>2]|0;u=g;return qa|0}function Z7(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+16|0;g=e;h=f[(f[a>>2]|0)+8>>2]|0;i=f[b+40>>2]|0;b=f[i>>2]|0;f[g>>2]=f[i+4>>2];f[g+4>>2]=b;Dg[h&127](a,c,g,d)|0;u=e;return (f[a+144>>2]|0)-(f[d+4>>2]|0)|0}function _7(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;i=u;u=u+16|0;j=i;if(!((f[a+36>>2]|0)>0?(f[a+40>>2]|0)>0:0)){f[j>>2]=0;f[j+4>>2]=0;k=aD(j,43)|0;l=242001;m=k+43|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,j,242045,241836,288);bD(j)}n=f[a+76>>2]|0;o=a+4|0;p=f[o>>2]|0;q=(p>>>3&511)+1<<(47696>>>(p<<1&14)&3);p=f[a+88>>2]|0;r=f[a+164>>2]|0;s=(f[a+168>>2]|0)-r>>2;t=((f[a+12>>2]|0)>>>3&511)+1|0;v=a+52|0;w=f[v>>2]|0;x=f[a+16>>2]|0;y=f[a+20>>2]|0;z=f[a+28>>2]|0;A=f[a+60>>2]|0;B=f[a+64>>2]|0;C=f[a+24>>2]|0;D=f[a+44>>2]|0;E=a+180|0;F=(f[E>>2]|0)==0;if((A|0)>0|(B|0)>0)G=(f[a+68>>2]|0)!=0;else G=0;H=c+(Y((C|0)<(D|0)?C:D,0-q|0)|0)|0;D=a+144|0;C=a+156|0;c=(f[a+152>>2]|0)-(f[D>>2]|0)-(f[C>>2]|0)|0;I=(c|0)<(e|0)?c:e;if(!((g|0)!=0&(H|0)!=0&(I|0)>0)){f[j>>2]=0;f[j+4>>2]=0;k=aD(j,23)|0;l=242053;m=k+23|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,j,242045,241836,307);bD(j)}e=s-z|0;c=a+48|0;J=s+1-y|0;K=a+148|0;L=a+92|0;M=a+140|0;N=a+104|0;O=Y(A,q)|0;P=w+-1+x-B|0;x=Y(P-A|0,q)|0;Q=(p<<2|0)==(q|0);R=Y(A,p)|0;A=(R|0)>0;S=Y(B,p)|0;T=(S|0)>0;U=Y(P,p)|0;p=(O|0)>0;V=Y(B,q)|0;B=(V|0)>0;W=Y(P,q)|0;q=a+188|0;P=a+56|0;X=a+160|0;Z=y+-1|0;_=a+196|0;$=a+40|0;aa=a+72|0;ba=a+128|0;a=j+4|0;ca=H;H=g;g=0;da=I;while(1){I=f[D>>2]|0;ea=f[C>>2]|0;fa=e-I-ea+(f[c>>2]|0)|0;ga=(fa|0)>0?fa:J;fa=(da|0)<(ga|0)?da:ga;ga=da-fa|0;ha=fa+-1|0;do if((fa|0)>0){ia=Y(fa,d)|0;if(F){ja=ca;ka=I;la=ea;ma=ha;while(1){na=((f[L>>2]|0)+63&-64)+(Y(f[M>>2]|0,(ka-(f[K>>2]|0)+la|0)%(s|0)|0)|0)|0;oa=f[N>>2]|0;f[C>>2]=la+1;if((la|0)>=(s|0)){f[C>>2]=la;f[D>>2]=ka+1}Vac(oa+O|0,ja|0,x|0)|0;do if(G)if(Q){if(A){pa=0;do{f[oa+(pa<<2)>>2]=f[ja+(f[n+(pa<<2)>>2]<<2)>>2];pa=pa+1|0}while((pa|0)!=(R|0))}if(T)qa=0;else break;do{f[oa+(qa+U<<2)>>2]=f[ja+(f[n+(qa+R<<2)>>2]<<2)>>2];qa=qa+1|0}while((qa|0)!=(S|0))}else{if(p){pa=0;do{b[oa+pa>>0]=b[ja+(f[n+(pa<<2)>>2]|0)>>0]|0;pa=pa+1|0}while((pa|0)!=(O|0))}if(B)ra=0;else break;do{b[oa+(ra+W)>>0]=b[ja+(f[n+(ra+O<<2)>>2]|0)>>0]|0;ra=ra+1|0}while((ra|0)!=(V|0))}while(0);pa=f[q>>2]|0;uh[f[(f[pa>>2]|0)+8>>2]&255](pa,oa,na,w,((f[o>>2]|0)>>>3&511)+1|0);if((ma|0)<=0)break;ja=ja+d|0;ka=f[D>>2]|0;la=f[C>>2]|0;ma=ma+-1|0}sa=ca+ia|0;break}else{ma=ca;la=I;ka=ea;ja=ha;while(1){pa=((f[L>>2]|0)+63&-64)+(Y(f[M>>2]|0,(la-(f[K>>2]|0)+ka|0)%(s|0)|0)|0)|0;f[C>>2]=ka+1;if((ka|0)>=(s|0)){f[C>>2]=ka;f[D>>2]=la+1}Vac(pa+O|0,ma|0,x|0)|0;do if(G)if(Q){if(A){ta=0;do{f[pa+(ta<<2)>>2]=f[ma+(f[n+(ta<<2)>>2]<<2)>>2];ta=ta+1|0}while((ta|0)!=(R|0))}if(T)ua=0;else break;do{f[pa+(ua+U<<2)>>2]=f[ma+(f[n+(ua+R<<2)>>2]<<2)>>2];ua=ua+1|0}while((ua|0)!=(S|0))}else{if(p){ta=0;do{b[pa+ta>>0]=b[ma+(f[n+(ta<<2)>>2]|0)>>0]|0;ta=ta+1|0}while((ta|0)!=(O|0))}if(B)va=0;else break;do{b[pa+(va+W)>>0]=b[ma+(f[n+(va+O<<2)>>2]|0)>>0]|0;va=va+1|0}while((va|0)!=(V|0))}while(0);if((ja|0)<=0)break;ma=ma+d|0;la=f[D>>2]|0;ka=f[C>>2]|0;ja=ja+-1|0}sa=ca+ia|0;break}}else sa=ca;while(0);ha=f[X>>2]|0;ea=Z-g+(f[P>>2]|0)-ha|0;I=(ea|0)<(s|0)?ea:s;a:do if((I|0)>0){ea=g-z|0;fa=0;ja=ha;while(1){ka=ZP(ea+fa+ja+(f[c>>2]|0)|0,f[$>>2]|0,f[aa>>2]|0)|0;if((ka|0)<0)wa=(f[ba>>2]|0)+63&-64;else{la=f[D>>2]|0;if((ka|0)<(la|0)){f[j>>2]=0;f[a>>2]=0;k=aD(j,14)|0;l=242077;m=k+14|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,j,242045,241836,363);bD(j);xa=f[D>>2]|0}else xa=la;if((ka|0)>=((f[C>>2]|0)+xa|0)){ya=fa;break a}wa=((f[L>>2]|0)+63&-64)+(Y(f[M>>2]|0,(ka-(f[K>>2]|0)|0)%(s|0)|0)|0)|0}f[r+(fa<<2)>>2]=wa;ma=fa+1|0;if((ma|0)>=(I|0)){ya=ma;break a}fa=ma;ja=f[X>>2]|0}}else ya=0;while(0);if((ya|0)<(y|0))break;I=ya-Z|0;ha=f[E>>2]|0;if(!ha){ja=f[_>>2]|0;fa=Y(f[v>>2]|0,t)|0;Wg[f[(f[ja>>2]|0)+8>>2]&127](ja,r,H,h,I,fa)}else Qh[f[(f[ha>>2]|0)+8>>2]&127](ha,r,H,h,I,f[v>>2]|0,t);ca=sa;H=H+(Y(I,h)|0)|0;g=I+g|0;da=ga}da=(f[X>>2]|0)+g|0;f[X>>2]=da;if((da|0)<=(f[P>>2]|0)){u=i;return g|0}f[j>>2]=0;f[j+4>>2]=0;k=aD(j,18)|0;l=242092;m=k+18|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,j,242045,241836,380);bD(j);u=i;return g|0}function $7(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=u;u=u+16|0;i=h+8|0;j=h;dQ(i,53944);if(!((f[c>>2]&4095|0)==(f[a+4>>2]|0)?(f[d>>2]&4095|0)==(f[a+8>>2]|0):0)){f[j>>2]=0;f[j+4>>2]=0;k=aD(j,46)|0;l=241789;m=k+46|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,j,440399,241836,388);bD(j)}j=Dg[f[(f[a>>2]|0)+12>>2]&127](a,c,e,g)|0;g=f[c+48>>2]|0;e=(f[c+16>>2]|0)+(Y(g,j)|0)|0;Xf[f[(f[a>>2]|0)+16>>2]&127](a,e,g,(f[a+152>>2]|0)-(f[a+144>>2]|0)|0,f[d+16>>2]|0,f[d+48>>2]|0)|0;if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function a8(a){a=a|0;f[a>>2]=53852;f[a+8>>2]=-1;f[a+4>>2]=-1;return}function b8(a){a=a|0;f[a>>2]=53872;f[a+8>>2]=-1;f[a+4>>2]=-1;return}function c8(a){a=a|0;var b=0;f[a>>2]=53896;b=a+4|0;f[b>>2]=-1;f[b+4>>2]=-1;f[b+8>>2]=-1;f[b+12>>2]=-1;return}function d8(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0;f[a>>2]=53920;f[a+4>>2]=-1;f[a+8>>2]=-1;f[a+12>>2]=-1;l=a+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[a+36>>2]=-1;f[a+40>>2]=-1;l=a+44|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[a+68>>2]=1;f[a+72>>2]=1;l=a+76|0;m=l+124|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(m|0));e8(a,b,c,d,e,g,h,i,j,k);return}function e8(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;m=u;u=u+16|0;n=m;o=g&4095;p=a+4|0;f[p>>2]=o;q=(g>>>3&511)+1<<(47696>>>(o<<1&14)&3);f[a+8>>2]=h&4095;h=a+12|0;f[h>>2]=i&4095;i=a+176|0;o=f[c>>2]|0;g=f[c+4>>2]|0;if(o|0){c=o+4|0;f[c>>2]=(f[c>>2]|0)+1}c=f[i>>2]|0;f[i>>2]=o;o=a+180|0;f[o>>2]=g;if(c|0?(g=c+4|0,i=f[g>>2]|0,f[g>>2]=i+-1,(i|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);c=a+184|0;i=f[d>>2]|0;g=f[d+4>>2]|0;if(i|0){d=i+4|0;f[d>>2]=(f[d>>2]|0)+1}d=f[c>>2]|0;f[c>>2]=i;i=a+188|0;f[i>>2]=g;if(d|0?(g=d+4|0,c=f[g>>2]|0,f[g>>2]=c+-1,(c|0)==1):0)bi[f[(f[d>>2]|0)+8>>2]&2047](d);d=a+192|0;c=f[e>>2]|0;g=f[e+4>>2]|0;if(c|0){e=c+4|0;f[e>>2]=(f[e>>2]|0)+1}e=f[d>>2]|0;f[d>>2]=c;c=a+196|0;f[c>>2]=g;if(e|0?(g=e+4|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)bi[f[(f[e>>2]|0)+8>>2]&2047](e);e=(k|0)<0?j:k;k=a+68|0;f[k>>2]=j;j=a+72|0;f[j>>2]=e;if((e|0)==3){f[n>>2]=0;f[n+4>>2]=0;r=aD(n,31)|0;s=242296;t=r+31|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,n,242328,241836,127);bD(n)}e=f[o>>2]|0;if(!e){d=f[i>>2]|0;if((d|0)!=0?(g=f[c>>2]|0,(g|0)!=0):0){v=d;w=g}else{f[n>>2]=0;f[n+4>>2]=0;r=aD(n,25)|0;s=242333;t=r+25|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,n,242328,241836,131);bD(n);v=f[i>>2]|0;w=f[c>>2]|0}c=f[v+4>>2]|0;i=f[w+4>>2]|0;f[a+16>>2]=c;f[a+20>>2]=i;g=f[v+8>>2]|0;v=f[w+8>>2]|0;f[a+24>>2]=g;x=v;y=g;z=c;A=i}else{if((f[h>>2]|0)==(f[p>>2]|0))B=e;else{f[n>>2]=0;f[n+4>>2]=0;r=aD(n,18)|0;s=242359;t=r+18|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,n,242328,241836,137);bD(n);B=f[o>>2]|0}o=f[B+4>>2]|0;f[a+16>>2]=o;e=f[B+8>>2]|0;f[a+20>>2]=e;h=f[B+12>>2]|0;f[a+24>>2]=h;x=f[B+16>>2]|0;y=h;z=o;A=e}f[a+28>>2]=x;if((y|x|0)>-1&(y|0)<(z|0)&(x|0)<(A|0))C=z;else{f[n>>2]=0;f[n+4>>2]=0;r=aD(n,83)|0;s=242378;t=r+83|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,n,242328,241836,143);bD(n);C=f[a+16>>2]|0}n=q>>>((f[p>>2]|0)>>>1&2);f[a+88>>2]=n;s=C+-1|0;C=(s|0)>1?s:1;s=a+76|0;r=Y(C,n)|0;n=a+80|0;t=f[n>>2]|0;z=f[s>>2]|0;A=t-z>>2;x=z;z=t;if(r>>>0<=A>>>0){if(r>>>0<A>>>0?(t=x+(r<<2)|0,(z|0)!=(t|0)):0)f[n>>2]=z+(~((z+-4-t|0)>>>2)<<2)}else HC(s,r-A|0);f[a+140>>2]=0;f[a+32>>2]=0;A=f[a+128>>2]|0;r=a+132|0;if((f[r>>2]|0)!=(A|0))f[r>>2]=A;if(f[k>>2]|0?f[j>>2]|0:0){D=a+36|0;f[D>>2]=-1;E=a+40|0;f[E>>2]=-1;u=m;return}j=a+116|0;k=Y(C,q)|0;q=a+120|0;A=f[q>>2]|0;r=f[j>>2]|0;s=A-r|0;t=r;r=A;if(k>>>0<=s>>>0)if(k>>>0<s>>>0?(A=t+k|0,(r|0)!=(A|0)):0){f[q>>2]=A;F=t}else F=t;else{DL(j,k-s|0);F=f[j>>2]|0}j=f[p>>2]|0;p=j>>>3&511;s=p+1|0;xM(l,F,(s>>>0>4?24:p<<3)|j&7,Y(s,C)|0);D=a+36|0;f[D>>2]=-1;E=a+40|0;f[E>>2]=-1;u=m;return}function f8(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0;d=u;u=u+128|0;e=d+72|0;g=d+16|0;h=d;do if((yM(a)|0)==65536){i=f[a+4>>2]|0;f[e>>2]=f[i>>2];j=e+4|0;k=i+4|0;f[j>>2]=f[k>>2];l=e+8|0;f[l>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];f[e+16>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];f[e+28>>2]=f[i+28>>2];f[e+32>>2]=f[i+32>>2];m=f[i+36>>2]|0;f[e+36>>2]=m;f[e+40>>2]=l;l=e+48|0;n=e+44|0;f[n>>2]=l;f[l>>2]=0;f[e+52>>2]=0;if(m|0){l=m+12|0;f[l>>2]=(f[l>>2]|0)+1}if((f[k>>2]|0)<3){k=f[i+44>>2]|0;l=f[n>>2]|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];o=e;break}else{f[j>>2]=0;jL(e,i);o=e;break}}else{yL(e,a,-1);o=e}while(0);if(f[o>>2]&4088|0){f[g>>2]=0;f[g+4>>2]=0;q=aD(g,23)|0;o=242462;r=q+23|0;do{b[q>>0]=b[o>>0]|0;q=q+1|0;o=o+1|0}while((q|0)<(r|0));bO(-215,g,242486,241836,407);bD(g)}o=e+8|0;a=e+12|0;i=Y(f[a>>2]|0,f[o>>2]|0)|0;f[g>>2]=1124007936;j=g+4|0;k=g+8|0;l=g+40|0;q=j;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));f[l>>2]=k;k=g+48|0;q=g+44|0;f[q>>2]=k;f[k>>2]=0;f[g+52>>2]=0;r=h+8|0;f[r>>2]=0;f[r+4>>2]=0;f[h>>2]=33619968;f[h+4>>2]=g;OJ(e,h,6,1.0,0.0);h=g+16|0;r=f[h>>2]|0;n=f[o>>2]|0;o=f[a>>2]|0;if((n|0)==1|(o|0)==1?(f[c>>2]<<1|1|0)==(o|0):0)s=(f[c+4>>2]<<1|1|0)==(n|0)?15:12;else s=12;if((i|0)>0){n=i+-1|0;t=0.0;c=0;o=s;while(1){v=+p[r+(c<<3)>>3];w=+p[r+(n-c<<3)>>3];a=v!=w?o&-2:o;m=v!=-w?a&-3:a;a=v<0.0?m&-5:m;m=v!=+(MVb(v)|0);x=m?a&-9:a;w=t+v;c=c+1|0;if((c|0)==(i|0)){y=w;z=x;break}else{t=w;o=x}}}else{y=0.0;z=s}s=+L(+(y+-1.0))>(+L(+y)+1.0)*1.1920928955078125e-07;o=s?z&-5:z;z=g+36|0;s=f[z>>2]|0;if(s|0?(i=s+12|0,s=f[i>>2]|0,f[i>>2]=s+-1,(s|0)==1):0)kL(g);f[z>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[j>>2]|0)>0){h=f[l>>2]|0;l=0;do{f[h+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[j>>2]|0))}j=f[q>>2]|0;if((j|0)!=(k|0))UC(j);j=e+36|0;k=f[j>>2]|0;if(k|0?(q=k+12|0,k=f[q>>2]|0,f[q>>2]=k+-1,(k|0)==1):0)kL(e);f[j>>2]=0;j=e+16|0;k=e+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[k>>2]|0)>0){j=f[e+40>>2]|0;q=0;do{f[j+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[k>>2]|0))}k=f[e+44>>2]|0;if((k|0)==(e+48|0)){u=d;return o|0}UC(k);u=d;return o|0}function g8(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;i=u;u=u+80|0;j=i;k=i+64|0;l=i+8|0;do if((yM(e)|0)==65536){m=f[e+4>>2]|0;f[l>>2]=f[m>>2];n=l+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=l+8|0;f[p>>2]=f[m+8>>2];f[l+12>>2]=f[m+12>>2];f[l+16>>2]=f[m+16>>2];f[l+20>>2]=f[m+20>>2];f[l+24>>2]=f[m+24>>2];f[l+28>>2]=f[m+28>>2];f[l+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[l+36>>2]=q;f[l+40>>2]=p;p=l+48|0;r=l+44|0;f[r>>2]=p;f[p>>2]=0;f[l+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;jL(l,m);break}}else yL(l,e,-1);while(0);e=c&7;m=d&7;if(!((((d^c)&4088|0)==0?(m|0)>=((e>>>0>4?e:4)|0):0)?(f[l>>2]&4095|0)==(m|0):0)){f[k>>2]=0;f[k+4>>2]=0;n=aD(k,109)|0;o=242500;p=n+109|0;do{b[n>>0]=b[o>>0]|0;n=n+1|0;o=o+1|0}while((n|0)<(p|0));bO(-215,k,242610,241836,3605);bD(k)}o=(e|0)==0;n=o&(m|0)==4;do if(h&3|0?((f[l+12>>2]|0)+(f[l+8>>2]|0)|0)<7:0){if(n){p=L5b(76)|0;h8(p,l,g,h,k);r=L5b(16)|0;q=r+4|0;f[q>>2]=1;f[r>>2]=53972;f[r+8>>2]=p;f[a>>2]=r;f[a+4>>2]=p;f[q>>2]=(f[q>>2]|0)+1;p=f[q>>2]|0;f[q>>2]=p+-1;if((p|0)==1)bi[f[(f[r>>2]|0)+8>>2]&2047](r);break}if((e|0)==5&(m|0)==5){r=L5b(76)|0;i8(r,l,g,h,k);p=L5b(16)|0;q=p+4|0;f[q>>2]=1;f[p>>2]=53992;f[p+8>>2]=r;f[a>>2]=p;f[a+4>>2]=r;f[q>>2]=(f[q>>2]|0)+1;r=f[q>>2]|0;f[q>>2]=r+-1;if((r|0)==1)bi[f[(f[p>>2]|0)+8>>2]&2047](p)}else s=25}else if(n){p=L5b(72)|0;j8(p,l,g,k);r=L5b(16)|0;q=r+4|0;f[q>>2]=1;f[r>>2]=54012;f[r+8>>2]=p;f[a>>2]=r;f[a+4>>2]=p;f[q>>2]=(f[q>>2]|0)+1;p=f[q>>2]|0;f[q>>2]=p+-1;if((p|0)==1)bi[f[(f[r>>2]|0)+8>>2]&2047](r)}else s=25;while(0);do if((s|0)==25){n=(m|0)==5;if(o&n){h=L5b(72)|0;k8(h,l,g,k);r=L5b(16)|0;p=r+4|0;f[p>>2]=1;f[r>>2]=54032;f[r+8>>2]=h;f[a>>2]=r;f[a+4>>2]=h;f[p>>2]=(f[p>>2]|0)+1;h=f[p>>2]|0;f[p>>2]=h+-1;if((h|0)!=1)break;bi[f[(f[r>>2]|0)+8>>2]&2047](r);break}r=(m|0)==6;if(o&r){h=L5b(72)|0;l8(h,l,g,k);p=L5b(16)|0;q=p+4|0;f[q>>2]=1;f[p>>2]=54052;f[p+8>>2]=h;f[a>>2]=p;f[a+4>>2]=h;f[q>>2]=(f[q>>2]|0)+1;h=f[q>>2]|0;f[q>>2]=h+-1;if((h|0)!=1)break;bi[f[(f[p>>2]|0)+8>>2]&2047](p);break}p=(e|0)==2;if(p&n){h=L5b(72)|0;m8(h,l,g,k);q=L5b(16)|0;t=q+4|0;f[t>>2]=1;f[q>>2]=54072;f[q+8>>2]=h;f[a>>2]=q;f[a+4>>2]=h;f[t>>2]=(f[t>>2]|0)+1;h=f[t>>2]|0;f[t>>2]=h+-1;if((h|0)!=1)break;bi[f[(f[q>>2]|0)+8>>2]&2047](q);break}if(p&r){p=L5b(72)|0;n8(p,l,g,k);q=L5b(16)|0;h=q+4|0;f[h>>2]=1;f[q>>2]=54092;f[q+8>>2]=p;f[a>>2]=q;f[a+4>>2]=p;f[h>>2]=(f[h>>2]|0)+1;p=f[h>>2]|0;f[h>>2]=p+-1;if((p|0)!=1)break;bi[f[(f[q>>2]|0)+8>>2]&2047](q);break}q=(e|0)==3;if(q&n){p=L5b(72)|0;o8(p,l,g,k);h=L5b(16)|0;t=h+4|0;f[t>>2]=1;f[h>>2]=54112;f[h+8>>2]=p;f[a>>2]=h;f[a+4>>2]=p;f[t>>2]=(f[t>>2]|0)+1;p=f[t>>2]|0;f[t>>2]=p+-1;if((p|0)==1)bi[f[(f[h>>2]|0)+8>>2]&2047](h);break}if(q&r){q=L5b(72)|0;p8(q,l,g,k);h=L5b(16)|0;p=h+4|0;f[p>>2]=1;f[h>>2]=54132;f[h+8>>2]=q;f[a>>2]=h;f[a+4>>2]=q;f[p>>2]=(f[p>>2]|0)+1;q=f[p>>2]|0;f[p>>2]=q+-1;if((q|0)!=1)break;bi[f[(f[h>>2]|0)+8>>2]&2047](h);break}h=(e|0)==5;if(h&n){n=L5b(72)|0;q8(n,l,g,k);q=L5b(16)|0;p=q+4|0;f[p>>2]=1;f[q>>2]=54152;f[q+8>>2]=n;f[a>>2]=q;f[a+4>>2]=n;f[p>>2]=(f[p>>2]|0)+1;n=f[p>>2]|0;f[p>>2]=n+-1;if((n|0)==1)bi[f[(f[q>>2]|0)+8>>2]&2047](q);break}if(h&r){h=L5b(72)|0;r8(h,l,g,k);q=L5b(16)|0;n=q+4|0;f[n>>2]=1;f[q>>2]=54172;f[q+8>>2]=h;f[a>>2]=q;f[a+4>>2]=h;f[n>>2]=(f[n>>2]|0)+1;h=f[n>>2]|0;f[n>>2]=h+-1;if((h|0)!=1)break;bi[f[(f[q>>2]|0)+8>>2]&2047](q);break}if(!((e|0)==6&r)){f[j>>2]=c;f[j+4>>2]=d;hO(k,242629,j);bO(-213,k,242610,241836,3644);bD(k);f[a>>2]=0;f[a+4>>2]=0;break}r=L5b(72)|0;s8(r,l,g,k);q=L5b(16)|0;h=q+4|0;f[h>>2]=1;f[q>>2]=54192;f[q+8>>2]=r;f[a>>2]=q;f[a+4>>2]=r;f[h>>2]=(f[h>>2]|0)+1;r=f[h>>2]|0;f[h>>2]=r+-1;if((r|0)==1)bi[f[(f[q>>2]|0)+8>>2]&2047](q)}while(0);a=l+36|0;k=f[a>>2]|0;if(k|0?(g=k+12|0,k=f[g>>2]|0,f[g>>2]=k+-1,(k|0)==1):0)kL(l);f[a>>2]=0;a=l+16|0;k=l+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[k>>2]|0)>0){a=f[l+40>>2]|0;g=0;do{f[a+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[k>>2]|0))}k=f[l+44>>2]|0;if((k|0)==(l+48|0)){u=i;return}UC(k);u=i;return}function h8(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;z9(a,c,d,g);f[a>>2]=54452;f[a+72>>2]=e;if(e&3|0?(f[a+4>>2]|0)<6:0){u=h;return}f[i>>2]=0;f[i+4>>2]=0;a=aD(i,84)|0;e=244074;g=a+84|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));bO(-215,i,244159,241836,3112);bD(i);u=h;return}function i8(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0;h=u;u=u+16|0;i=h;r9(a,c,d,g);f[a>>2]=54412;f[a+72>>2]=e;if(e&3|0?(f[a+4>>2]|0)<6:0){u=h;return}f[i>>2]=0;f[i+4>>2]=0;a=aD(i,84)|0;e=244074;g=a+84|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));bO(-215,i,244159,241836,3112);bD(i);u=h;return}function j8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=54392;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){kL(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)jL(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;SP(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==4?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=aD(g,77)|0;l=242786;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));bO(-215,g,242864,241836,3053);bD(g);u=e;return}function k8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=54372;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){kL(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)jL(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;SP(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==5?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=aD(g,77)|0;l=242786;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));bO(-215,g,242864,241836,3053);bD(g);u=e;return}function l8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=54352;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){kL(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)jL(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;SP(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==6?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=aD(g,77)|0;l=242786;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));bO(-215,g,242864,241836,3053);bD(g);u=e;return}function m8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=54332;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){kL(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)jL(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;SP(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==5?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=aD(g,77)|0;l=242786;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));bO(-215,g,242864,241836,3053);bD(g);u=e;return}function n8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=54312;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){kL(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)jL(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;SP(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==6?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=aD(g,77)|0;l=242786;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));bO(-215,g,242864,241836,3053);bD(g);u=e;return}function o8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=54292;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){kL(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)jL(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;SP(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==5?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=aD(g,77)|0;l=242786;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));bO(-215,g,242864,241836,3053);bD(g);u=e;return}function p8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=54272;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){kL(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)jL(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;SP(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==6?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=aD(g,77)|0;l=242786;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));bO(-215,g,242864,241836,3053);bD(g);u=e;return}function q8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=54252;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){kL(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)jL(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;SP(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==5?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=aD(g,77)|0;l=242786;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));bO(-215,g,242864,241836,3053);bD(g);u=e;return}function r8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=54232;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){kL(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)jL(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;SP(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==6?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=aD(g,77)|0;l=242786;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));bO(-215,g,242864,241836,3053);bD(g);u=e;return}function s8(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=54212;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){kL(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)jL(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;SP(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==6?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=aD(g,77)|0;l=242786;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));bO(-215,g,242864,241836,3053);bD(g);u=e;return}function t8(a){a=a|0;O5b(a);return}function u8(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function v8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54212;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function w8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54212;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function x8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,q=0.0,r=0.0,s=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<3)|0;m=+p[h>>3];n=m*+p[l+8>>3];o=m*+p[l+16>>3];q=m*+p[l+24>>3];p[c+(k<<3)>>3]=m*+p[l>>3];p[c+((k|1)<<3)>>3]=n;p[c+((k|2)<<3)>>3]=o;p[c+((k|3)<<3)>>3]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<3)|0;q=+p[h>>3];l=k;o=q*+p[k+24>>3];n=q*+p[k+16>>3];m=q*+p[k+8>>3];r=q*+p[k>>3];k=1;do{l=l+(e<<3)|0;q=+p[h+(k<<3)>>3];r=r+q*+p[l>>3];m=m+q*+p[l+8>>3];n=n+q*+p[l+16>>3];o=o+q*+p[l+24>>3];k=k+1|0}while((k|0)!=(g|0));p[c+(j<<3)>>3]=r;p[c+((j|1)<<3)>>3]=m;p[c+((j|2)<<3)>>3]=n;p[c+((j|3)<<3)>>3]=o;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)s=i;else{d=i;do{p[c+(d<<3)>>3]=+p[h>>3]*+p[b+(d<<3)>>3];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(s<<3)|0;q=+p[h>>3]*+p[d>>3];i=d;d=1;do{i=i+(e<<3)|0;q=q+ +p[h+(d<<3)>>3]*+p[i>>3];d=d+1|0}while((d|0)!=(g|0));p[c+(s<<3)>>3]=q;s=s+1|0}while((s|0)!=(a|0));return}function y8(a){a=a|0;O5b(a);return}function z8(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function A8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54232;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function B8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54232;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function C8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<2)|0;m=+p[h>>3];o=m*+n[l+4>>2];q=m*+n[l+8>>2];r=m*+n[l+12>>2];p[c+(k<<3)>>3]=m*+n[l>>2];p[c+((k|1)<<3)>>3]=o;p[c+((k|2)<<3)>>3]=q;p[c+((k|3)<<3)>>3]=r;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<2)|0;r=+p[h>>3];l=k;q=r*+n[k+12>>2];o=r*+n[k+8>>2];m=r*+n[k+4>>2];s=r*+n[k>>2];k=1;do{l=l+(e<<2)|0;r=+p[h+(k<<3)>>3];s=s+r*+n[l>>2];m=m+r*+n[l+4>>2];o=o+r*+n[l+8>>2];q=q+r*+n[l+12>>2];k=k+1|0}while((k|0)!=(g|0));p[c+(j<<3)>>3]=s;p[c+((j|1)<<3)>>3]=m;p[c+((j|2)<<3)>>3]=o;p[c+((j|3)<<3)>>3]=q;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)t=i;else{d=i;do{p[c+(d<<3)>>3]=+p[h>>3]*+n[b+(d<<2)>>2];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(t<<2)|0;r=+p[h>>3]*+n[d>>2];i=d;d=1;do{i=i+(e<<2)|0;r=r+ +p[h+(d<<3)>>3]*+n[i>>2];d=d+1|0}while((d|0)!=(g|0));p[c+(t<<3)>>3]=r;t=t+1|0}while((t|0)!=(a|0));return}function D8(a){a=a|0;O5b(a);return}function E8(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function F8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54252;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function G8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54252;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function H8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<2)|0;m=+n[h>>2];o=m*+n[l+4>>2];p=m*+n[l+8>>2];q=m*+n[l+12>>2];n[c+(k<<2)>>2]=m*+n[l>>2];n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<2)|0;q=+n[h>>2];l=k;p=q*+n[k+12>>2];o=q*+n[k+8>>2];m=q*+n[k+4>>2];r=q*+n[k>>2];k=1;do{l=l+(e<<2)|0;q=+n[h+(k<<2)>>2];r=r+q*+n[l>>2];m=m+q*+n[l+4>>2];o=o+q*+n[l+8>>2];p=p+q*+n[l+12>>2];k=k+1|0}while((k|0)!=(g|0));n[c+(j<<2)>>2]=r;n[c+((j|1)<<2)>>2]=m;n[c+((j|2)<<2)>>2]=o;n[c+((j|3)<<2)>>2]=p;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)s=i;else{d=i;do{n[c+(d<<2)>>2]=+n[h>>2]*+n[b+(d<<2)>>2];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(s<<2)|0;q=+n[h>>2]*+n[d>>2];i=d;d=1;do{i=i+(e<<2)|0;q=q+ +n[h+(d<<2)>>2]*+n[i>>2];d=d+1|0}while((d|0)!=(g|0));n[c+(s<<2)>>2]=q;s=s+1|0}while((s|0)!=(a|0));return}function I8(a){a=a|0;O5b(a);return}function J8(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function K8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54272;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function L8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54272;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function M8(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0;h=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(g,e)|0;e=a+-4|0;do if((a|0)<4)j=0;else{if((h|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;n=+p[i>>3];o=n*+(d[m+2>>1]|0);q=n*+(d[m+4>>1]|0);r=n*+(d[m+6>>1]|0);p[c+(l<<3)>>3]=n*+(d[m>>1]|0);p[c+((l|1)<<3)>>3]=o;p[c+((l|2)<<3)>>3]=q;p[c+((l|3)<<3)>>3]=r;l=l+4|0}while((l|0)<=(e|0));j=a&-4;break}do{l=b+(k<<1)|0;r=+p[i>>3];m=l;q=r*+(d[l+6>>1]|0);o=r*+(d[l+4>>1]|0);n=r*+(d[l+2>>1]|0);s=r*+(d[l>>1]|0);l=1;do{m=m+(g<<1)|0;r=+p[i+(l<<3)>>3];s=s+r*+(d[m>>1]|0);n=n+r*+(d[m+2>>1]|0);o=o+r*+(d[m+4>>1]|0);q=q+r*+(d[m+6>>1]|0);l=l+1|0}while((l|0)!=(h|0));p[c+(k<<3)>>3]=s;p[c+((k|1)<<3)>>3]=n;p[c+((k|2)<<3)>>3]=o;p[c+((k|3)<<3)>>3]=q;k=k+4|0}while((k|0)<=(e|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((h|0)>1)t=j;else{e=j;do{p[c+(e<<3)>>3]=+p[i>>3]*+(d[b+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(a|0));return}do{e=b+(t<<1)|0;r=+p[i>>3]*+(d[e>>1]|0);j=e;e=1;do{j=j+(g<<1)|0;r=r+ +p[i+(e<<3)>>3]*+(d[j>>1]|0);e=e+1|0}while((e|0)!=(h|0));p[c+(t<<3)>>3]=r;t=t+1|0}while((t|0)!=(a|0));return}function N8(a){a=a|0;O5b(a);return}function O8(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function P8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54292;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function Q8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54292;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function R8(a,b,c,e,g){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0;h=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(g,e)|0;e=a+-4|0;do if((a|0)<4)j=0;else{if((h|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;o=+n[i>>2];p=o*+(d[m+2>>1]|0);q=o*+(d[m+4>>1]|0);r=o*+(d[m+6>>1]|0);n[c+(l<<2)>>2]=o*+(d[m>>1]|0);n[c+((l|1)<<2)>>2]=p;n[c+((l|2)<<2)>>2]=q;n[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(e|0));j=a&-4;break}do{l=b+(k<<1)|0;r=+n[i>>2];m=l;q=r*+(d[l+6>>1]|0);p=r*+(d[l+4>>1]|0);o=r*+(d[l+2>>1]|0);s=r*+(d[l>>1]|0);l=1;do{m=m+(g<<1)|0;r=+n[i+(l<<2)>>2];s=s+r*+(d[m>>1]|0);o=o+r*+(d[m+2>>1]|0);p=p+r*+(d[m+4>>1]|0);q=q+r*+(d[m+6>>1]|0);l=l+1|0}while((l|0)!=(h|0));n[c+(k<<2)>>2]=s;n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(e|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((h|0)>1)t=j;else{e=j;do{n[c+(e<<2)>>2]=+n[i>>2]*+(d[b+(e<<1)>>1]|0);e=e+1|0}while((e|0)!=(a|0));return}do{e=b+(t<<1)|0;r=+n[i>>2]*+(d[e>>1]|0);j=e;e=1;do{j=j+(g<<1)|0;r=r+ +n[i+(e<<2)>>2]*+(d[j>>1]|0);e=e+1|0}while((e|0)!=(h|0));n[c+(t<<2)>>2]=r;t=t+1|0}while((t|0)!=(a|0));return}function S8(a){a=a|0;O5b(a);return}function T8(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function U8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54312;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function V8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54312;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function W8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;n=+p[h>>3];o=n*+(j[m+2>>1]|0);q=n*+(j[m+4>>1]|0);r=n*+(j[m+6>>1]|0);p[c+(l<<3)>>3]=n*+(j[m>>1]|0);p[c+((l|1)<<3)>>3]=o;p[c+((l|2)<<3)>>3]=q;p[c+((l|3)<<3)>>3]=r;l=l+4|0}while((l|0)<=(d|0));i=a&-4;break}do{l=b+(k<<1)|0;r=+p[h>>3];m=l;q=r*+(j[l+6>>1]|0);o=r*+(j[l+4>>1]|0);n=r*+(j[l+2>>1]|0);s=r*+(j[l>>1]|0);l=1;do{m=m+(e<<1)|0;r=+p[h+(l<<3)>>3];s=s+r*+(j[m>>1]|0);n=n+r*+(j[m+2>>1]|0);o=o+r*+(j[m+4>>1]|0);q=q+r*+(j[m+6>>1]|0);l=l+1|0}while((l|0)!=(g|0));p[c+(k<<3)>>3]=s;p[c+((k|1)<<3)>>3]=n;p[c+((k|2)<<3)>>3]=o;p[c+((k|3)<<3)>>3]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)t=i;else{d=i;do{p[c+(d<<3)>>3]=+p[h>>3]*+(j[b+(d<<1)>>1]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(t<<1)|0;r=+p[h>>3]*+(j[d>>1]|0);i=d;d=1;do{i=i+(e<<1)|0;r=r+ +p[h+(d<<3)>>3]*+(j[i>>1]|0);d=d+1|0}while((d|0)!=(g|0));p[c+(t<<3)>>3]=r;t=t+1|0}while((t|0)!=(a|0));return}function X8(a){a=a|0;O5b(a);return}function Y8(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Z8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54332;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function _8(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54332;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function $8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+(l<<1)|0;o=+n[h>>2];p=o*+(j[m+2>>1]|0);q=o*+(j[m+4>>1]|0);r=o*+(j[m+6>>1]|0);n[c+(l<<2)>>2]=o*+(j[m>>1]|0);n[c+((l|1)<<2)>>2]=p;n[c+((l|2)<<2)>>2]=q;n[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));i=a&-4;break}do{l=b+(k<<1)|0;r=+n[h>>2];m=l;q=r*+(j[l+6>>1]|0);p=r*+(j[l+4>>1]|0);o=r*+(j[l+2>>1]|0);s=r*+(j[l>>1]|0);l=1;do{m=m+(e<<1)|0;r=+n[h+(l<<2)>>2];s=s+r*+(j[m>>1]|0);o=o+r*+(j[m+2>>1]|0);p=p+r*+(j[m+4>>1]|0);q=q+r*+(j[m+6>>1]|0);l=l+1|0}while((l|0)!=(g|0));n[c+(k<<2)>>2]=s;n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)t=i;else{d=i;do{n[c+(d<<2)>>2]=+n[h>>2]*+(j[b+(d<<1)>>1]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(t<<1)|0;r=+n[h>>2]*+(j[d>>1]|0);i=d;d=1;do{i=i+(e<<1)|0;r=r+ +n[h+(d<<2)>>2]*+(j[i>>1]|0);d=d+1|0}while((d|0)!=(g|0));n[c+(t<<2)>>2]=r;t=t+1|0}while((t|0)!=(a|0));return}function a9(a){a=a|0;O5b(a);return}function b9(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function c9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54352;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function d9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54352;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function e9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;n=+p[i>>3];o=n*+(h[m+1>>0]|0);q=n*+(h[m+2>>0]|0);r=n*+(h[m+3>>0]|0);p[c+(l<<3)>>3]=n*+(h[m>>0]|0);p[c+((l|1)<<3)>>3]=o;p[c+((l|2)<<3)>>3]=q;p[c+((l|3)<<3)>>3]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=+p[i>>3];m=l;q=r*+(h[l+3>>0]|0);o=r*+(h[l+2>>0]|0);n=r*+(h[l+1>>0]|0);s=r*+(h[l>>0]|0);l=1;do{m=m+e|0;r=+p[i+(l<<3)>>3];s=s+r*+(h[m>>0]|0);n=n+r*+(h[m+1>>0]|0);o=o+r*+(h[m+2>>0]|0);q=q+r*+(h[m+3>>0]|0);l=l+1|0}while((l|0)!=(g|0));p[c+(k<<3)>>3]=s;p[c+((k|1)<<3)>>3]=n;p[c+((k|2)<<3)>>3]=o;p[c+((k|3)<<3)>>3]=q;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)t=j;else{d=j;do{p[c+(d<<3)>>3]=+p[i>>3]*+(h[b+d>>0]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+t|0;r=+p[i>>3]*+(h[d>>0]|0);j=d;d=1;do{j=j+e|0;r=r+ +p[i+(d<<3)>>3]*+(h[j>>0]|0);d=d+1|0}while((d|0)!=(g|0));p[c+(t<<3)>>3]=r;t=t+1|0}while((t|0)!=(a|0));return}function f9(a){a=a|0;O5b(a);return}function g9(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function h9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54372;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function i9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54372;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function j9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;o=+n[i>>2];p=o*+(h[m+1>>0]|0);q=o*+(h[m+2>>0]|0);r=o*+(h[m+3>>0]|0);n[c+(l<<2)>>2]=o*+(h[m>>0]|0);n[c+((l|1)<<2)>>2]=p;n[c+((l|2)<<2)>>2]=q;n[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=+n[i>>2];m=l;q=r*+(h[l+3>>0]|0);p=r*+(h[l+2>>0]|0);o=r*+(h[l+1>>0]|0);s=r*+(h[l>>0]|0);l=1;do{m=m+e|0;r=+n[i+(l<<2)>>2];s=s+r*+(h[m>>0]|0);o=o+r*+(h[m+1>>0]|0);p=p+r*+(h[m+2>>0]|0);q=q+r*+(h[m+3>>0]|0);l=l+1|0}while((l|0)!=(g|0));n[c+(k<<2)>>2]=s;n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)t=j;else{d=j;do{n[c+(d<<2)>>2]=+n[i>>2]*+(h[b+d>>0]|0);d=d+1|0}while((d|0)!=(a|0));return}do{d=b+t|0;r=+n[i>>2]*+(h[d>>0]|0);j=d;d=1;do{j=j+e|0;r=r+ +n[i+(d<<2)>>2]*+(h[j>>0]|0);d=d+1|0}while((d|0)!=(g|0));n[c+(t<<2)>>2]=r;t=t+1|0}while((t|0)!=(a|0));return}function k9(a){a=a|0;O5b(a);return}function l9(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function m9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54392;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function n9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54392;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function o9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;n=f[i>>2]|0;o=Y(h[m>>0]|0,n)|0;p=Y(h[m+1>>0]|0,n)|0;q=Y(h[m+2>>0]|0,n)|0;r=Y(h[m+3>>0]|0,n)|0;f[c+(l<<2)>>2]=o;f[c+((l|1)<<2)>>2]=p;f[c+((l|2)<<2)>>2]=q;f[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=f[i>>2]|0;q=Y(h[l>>0]|0,r)|0;p=Y(h[l+1>>0]|0,r)|0;o=Y(h[l+2>>0]|0,r)|0;n=l;m=Y(h[l+3>>0]|0,r)|0;r=o;o=p;p=q;q=1;do{n=n+e|0;l=f[i+(q<<2)>>2]|0;p=(Y(h[n>>0]|0,l)|0)+p|0;o=(Y(h[n+1>>0]|0,l)|0)+o|0;r=(Y(h[n+2>>0]|0,l)|0)+r|0;m=(Y(h[n+3>>0]|0,l)|0)+m|0;q=q+1|0}while((q|0)!=(g|0));f[c+(k<<2)>>2]=p;f[c+((k|1)<<2)>>2]=o;f[c+((k|2)<<2)>>2]=r;f[c+((k|3)<<2)>>2]=m;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)s=j;else{d=j;do{j=Y(h[b+d>>0]|0,f[i>>2]|0)|0;f[c+(d<<2)>>2]=j;d=d+1|0}while((d|0)!=(a|0));return}do{d=b+s|0;j=Y(h[d>>0]|0,f[i>>2]|0)|0;k=d;d=1;do{k=k+e|0;j=(Y(h[k>>0]|0,f[i+(d<<2)>>2]|0)|0)+j|0;d=d+1|0}while((d|0)!=(g|0));f[c+(s<<2)>>2]=j;s=s+1|0}while((s|0)!=(a|0));return}function p9(a){a=a|0;O5b(a);return}function q9(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function r9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=54432;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){kL(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)jL(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;SP(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==5?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=aD(g,77)|0;l=242786;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));bO(-215,g,242864,241836,3053);bD(g);u=e;return}function s9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54432;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function t9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54432;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function u9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0;g=f[a+4>>2]|0;h=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)i=0;else{if((g|0)>1)j=0;else{k=0;do{l=b+(k<<2)|0;m=+n[h>>2];o=m*+n[l+4>>2];p=m*+n[l+8>>2];q=m*+n[l+12>>2];n[c+(k<<2)>>2]=m*+n[l>>2];n[c+((k|1)<<2)>>2]=o;n[c+((k|2)<<2)>>2]=p;n[c+((k|3)<<2)>>2]=q;k=k+4|0}while((k|0)<=(d|0));i=a&-4;break}do{k=b+(j<<2)|0;q=+n[h>>2];l=k;p=q*+n[k+12>>2];o=q*+n[k+8>>2];m=q*+n[k+4>>2];r=q*+n[k>>2];k=1;do{l=l+(e<<2)|0;q=+n[h+(k<<2)>>2];r=r+q*+n[l>>2];m=m+q*+n[l+4>>2];o=o+q*+n[l+8>>2];p=p+q*+n[l+12>>2];k=k+1|0}while((k|0)!=(g|0));n[c+(j<<2)>>2]=r;n[c+((j|1)<<2)>>2]=m;n[c+((j|2)<<2)>>2]=o;n[c+((j|3)<<2)>>2]=p;j=j+4|0}while((j|0)<=(d|0));i=a&-4}while(0);if((i|0)>=(a|0))return;if((g|0)>1)s=i;else{d=i;do{n[c+(d<<2)>>2]=+n[h>>2]*+n[b+(d<<2)>>2];d=d+1|0}while((d|0)!=(a|0));return}do{d=b+(s<<2)|0;q=+n[h>>2]*+n[d>>2];i=d;d=1;do{i=i+(e<<2)|0;q=q+ +n[h+(d<<2)>>2]*+n[i>>2];d=d+1|0}while((d|0)!=(g|0));n[c+(s<<2)>>2]=q;s=s+1|0}while((s|0)!=(a|0));return}function v9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54432;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function w9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0;g=f[a+4>>2]|0;h=(g|0)/2|0;i=Y(h,e)|0;j=(f[a+28>>2]|0)+(h<<2)|0;k=b+(i<<2)|0;l=Y(e,d)|0;if(!(f[a+72>>2]&1)){a:do switch(g|0){case 3:{m=+n[j+4>>2];a=l+-2|0;d=(l|0)<2;if(+n[j>>2]==0.0&m==1.0){if(d){o=k;p=0;break a}q=0-e|0;r=e+1|0;s=1-e|0;t=a>>>1;u=t<<1;v=b+((i<<2)+(t<<3)+8)|0;t=k;w=0;while(1){x=+n[t+(r<<2)>>2]-+n[t+(s<<2)>>2];n[c+(w<<2)>>2]=+n[t+(e<<2)>>2]-+n[t+(q<<2)>>2];n[c+((w|1)<<2)>>2]=x;w=w+2|0;if((w|0)>(a|0))break;else t=t+8|0}o=v;p=u+2|0;break a}else{if(d){o=k;p=0;break a}t=0-e|0;w=e+1|0;q=1-e|0;s=a>>>1;r=s<<1;y=b+((i<<2)+(s<<3)+8)|0;s=k;z=0;while(1){x=m*(+n[s+(w<<2)>>2]-+n[s+(q<<2)>>2]);n[c+(z<<2)>>2]=m*(+n[s+(e<<2)>>2]-+n[s+(t<<2)>>2]);n[c+((z|1)<<2)>>2]=x;z=z+2|0;if((z|0)>(a|0))break;else s=s+8|0}o=y;p=r+2|0;break a}break}case 5:{m=+n[j+4>>2];x=+n[j+8>>2];s=l+-2|0;if((l|0)<2){o=k;p=0}else{a=0-e|0;z=e<<1;t=a<<1;q=e+1|0;w=1-e|0;d=z|1;u=1-z|0;v=s>>>1;A=v<<1;B=b+((i<<2)+(v<<3)+8)|0;v=0;C=k;while(1){D=m*(+n[C+(q<<2)>>2]-+n[C+(w<<2)>>2])+x*(+n[C+(d<<2)>>2]-+n[C+(u<<2)>>2]);n[c+(v<<2)>>2]=m*(+n[C+(e<<2)>>2]-+n[C+(a<<2)>>2])+x*(+n[C+(z<<2)>>2]-+n[C+(t<<2)>>2]);n[c+((v|1)<<2)>>2]=D;v=v+2|0;if((v|0)>(s|0))break;else C=C+8|0}o=B;p=A+2|0}break}default:{o=k;p=0}}while(0);if((p|0)>=(l|0))return;if((g|0)<2){C=o;s=p;while(1){n[c+(s<<2)>>2]=+n[j>>2]*+n[C>>2];s=s+1|0;if((s|0)==(l|0))break;else C=C+4|0}return}else{E=o;F=p}while(1){x=+n[j>>2]*+n[E>>2];p=e;o=1;while(1){x=x+ +n[j+(o<<2)>>2]*(+n[E+(p<<2)>>2]-+n[E+(0-p<<2)>>2]);if((o|0)>=(h|0))break;else{p=p+e|0;o=o+1|0}}n[c+(F<<2)>>2]=x;F=F+1|0;if((F|0)==(l|0))break;else E=E+4|0}return}b:do switch(g|0){case 1:{if(+n[j>>2]==1.0?(E=l+-2|0,(l|0)>=2):0){F=E>>>1;o=F<<1;p=b+((i<<2)+(F<<3)+8)|0;F=0;A=k;while(1){B=F|1;C=f[k+(B<<2)>>2]|0;f[c+(F<<2)>>2]=f[A>>2];f[c+(B<<2)>>2]=C;C=F+2|0;if((C|0)>(E|0))break;else{F=C;A=k+(C<<2)|0}}G=p;H=o+2|0}else{G=k;H=0}break}case 3:{x=+n[j>>2];m=+n[j+4>>2];A=m==1.0;if(x==2.0&A){F=l+-2|0;if((l|0)<2){G=k;H=0;break b}E=0-e|0;C=1-e|0;B=e+1|0;s=F>>>1;v=s<<1;t=b+((i<<2)+(s<<3)+8)|0;s=k;z=0;while(1){D=+n[s+(B<<2)>>2]+(+n[s+(C<<2)>>2]+ +n[s+4>>2]*2.0);n[c+(z<<2)>>2]=+n[s+(e<<2)>>2]+(+n[s+(E<<2)>>2]+ +n[s>>2]*2.0);n[c+((z|1)<<2)>>2]=D;z=z+2|0;if((z|0)>(F|0))break;else s=s+8|0}G=t;H=v+2|0;break b}s=l+-2|0;F=(l|0)<2;if(x==-2.0&A){if(F){G=k;H=0;break b}z=0-e|0;E=1-e|0;C=e+1|0;B=s>>>1;o=B<<1;p=b+((i<<2)+(B<<3)+8)|0;B=k;a=0;while(1){D=+n[B+(C<<2)>>2]+(+n[B+(E<<2)>>2]-+n[B+4>>2]*2.0);n[c+(a<<2)>>2]=+n[B+(e<<2)>>2]+(+n[B+(z<<2)>>2]-+n[B>>2]*2.0);n[c+((a|1)<<2)>>2]=D;a=a+2|0;if((a|0)>(s|0))break;else B=B+8|0}G=p;H=o+2|0;break b}else{if(F){G=k;H=0;break b}B=0-e|0;a=1-e|0;z=e+1|0;E=s>>>1;C=E<<1;A=b+((i<<2)+(E<<3)+8)|0;E=k;v=0;while(1){D=x*+n[E+4>>2]+m*(+n[E+(a<<2)>>2]+ +n[E+(z<<2)>>2]);n[c+(v<<2)>>2]=x*+n[E>>2]+m*(+n[E+(B<<2)>>2]+ +n[E+(e<<2)>>2]);n[c+((v|1)<<2)>>2]=D;v=v+2|0;if((v|0)>(s|0))break;else E=E+8|0}G=A;H=C+2|0;break b}break}case 5:{m=+n[j>>2];x=+n[j+4>>2];D=+n[j+8>>2];E=l+-2|0;s=(l|0)<2;if(m==-2.0&x==0.0&D==1.0){if(s){G=k;H=0;break b}v=0-e<<1;B=e<<1;z=1-B|0;a=B|1;F=E>>>1;o=F<<1;p=b+((i<<2)+(F<<3)+8)|0;F=k;t=0;while(1){I=+n[F+(z<<2)>>2]-+n[F+4>>2]*2.0+ +n[F+(a<<2)>>2];n[c+(t<<2)>>2]=+n[F+(v<<2)>>2]-+n[F>>2]*2.0+ +n[F+(B<<2)>>2];n[c+((t|1)<<2)>>2]=I;t=t+2|0;if((t|0)>(E|0))break;else F=F+8|0}G=p;H=o+2|0;break b}else{if(s){G=k;H=0;break b}F=0-e|0;t=F<<1;B=e<<1;v=1-e|0;a=e+1|0;z=1-B|0;C=B|1;A=E>>>1;u=A<<1;d=b+((i<<2)+(A<<3)+8)|0;A=k;w=0;while(1){I=m*+n[A+4>>2]+x*(+n[A+(v<<2)>>2]+ +n[A+(a<<2)>>2])+D*(+n[A+(z<<2)>>2]+ +n[A+(C<<2)>>2]);n[c+(w<<2)>>2]=m*+n[A>>2]+x*(+n[A+(F<<2)>>2]+ +n[A+(e<<2)>>2])+D*(+n[A+(t<<2)>>2]+ +n[A+(B<<2)>>2]);n[c+((w|1)<<2)>>2]=I;w=w+2|0;if((w|0)>(E|0))break;else A=A+8|0}G=d;H=u+2|0;break b}break}default:{G=k;H=0}}while(0);if((H|0)>=(l|0))return;if((g|0)<2){g=G;k=H;while(1){n[c+(k<<2)>>2]=+n[j>>2]*+n[g>>2];k=k+1|0;if((k|0)==(l|0))break;else g=g+4|0}return}else{J=G;K=H}while(1){H=e;G=1;D=+n[j>>2]*+n[J>>2];while(1){D=D+ +n[j+(G<<2)>>2]*(+n[J+(H<<2)>>2]+ +n[J+(0-H<<2)>>2]);if((G|0)>=(h|0))break;else{H=H+e|0;G=G+1|0}}n[c+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(l|0))break;else J=J+4|0}return}function x9(a){a=a|0;O5b(a);return}function y9(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function z9(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+16|0;g=e;h=a+8|0;f[h>>2]=-1;i=a+4|0;f[i>>2]=-1;f[a>>2]=54472;j=a+12|0;f[j>>2]=1124007936;k=a+16|0;l=a+20|0;m=a+52|0;n=k;o=n+36|0;do{f[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f[m>>2]=l;p=a+60|0;q=a+56|0;f[q>>2]=p;f[p>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((j|0)!=(c|0)){p=c+36|0;r=f[p>>2]|0;if(r){s=r+12|0;f[s>>2]=(f[s>>2]|0)+1;s=a+48|0;r=f[s>>2]|0;if((r|0)!=0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0){kL(j);v=s}else v=s}else v=a+48|0;f[v>>2]=0;s=a+28|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[k>>2]|0)>0){r=f[m>>2]|0;m=0;do{f[r+(m<<2)>>2]=0;m=m+1|0;w=f[k>>2]|0}while((m|0)<(w|0));f[j>>2]=f[c>>2];if((w|0)<3)x=13;else x=15}else{f[j>>2]=f[c>>2];x=13}if((x|0)==13){w=f[c+4>>2]|0;if((w|0)<3){f[k>>2]=w;f[l>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];w=f[c+44>>2]|0;k=f[q>>2]|0;f[k>>2]=f[w>>2];f[k+4>>2]=f[w+4>>2]}else x=15}if((x|0)==15)jL(j,c);f[s>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[v>>2]=f[p>>2]}}else{p=g+8|0;f[p>>2]=0;f[p+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=j;SP(c,g)}f[h>>2]=d;d=f[l>>2]|0;l=f[a+24>>2]|0;f[i>>2]=d+-1+l;if((f[j>>2]&4095|0)==4?(d|0)==1|(l|0)==1:0){u=e;return}f[g>>2]=0;f[g+4>>2]=0;n=aD(g,77)|0;l=242786;o=n+77|0;do{b[n>>0]=b[l>>0]|0;n=n+1|0;l=l+1|0}while((n|0)<(o|0));bO(-215,g,242864,241836,3053);bD(g);u=e;return}function A9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54472;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function B9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54472;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function C9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=f[a+4>>2]|0;i=f[a+28>>2]|0;a=Y(e,d)|0;d=a+-4|0;do if((a|0)<4)j=0;else{if((g|0)>1)k=0;else{l=0;do{m=b+l|0;n=f[i>>2]|0;o=Y(h[m>>0]|0,n)|0;p=Y(h[m+1>>0]|0,n)|0;q=Y(h[m+2>>0]|0,n)|0;r=Y(h[m+3>>0]|0,n)|0;f[c+(l<<2)>>2]=o;f[c+((l|1)<<2)>>2]=p;f[c+((l|2)<<2)>>2]=q;f[c+((l|3)<<2)>>2]=r;l=l+4|0}while((l|0)<=(d|0));j=a&-4;break}do{l=b+k|0;r=f[i>>2]|0;q=Y(h[l>>0]|0,r)|0;p=Y(h[l+1>>0]|0,r)|0;o=Y(h[l+2>>0]|0,r)|0;n=l;m=Y(h[l+3>>0]|0,r)|0;r=o;o=p;p=q;q=1;do{n=n+e|0;l=f[i+(q<<2)>>2]|0;p=(Y(h[n>>0]|0,l)|0)+p|0;o=(Y(h[n+1>>0]|0,l)|0)+o|0;r=(Y(h[n+2>>0]|0,l)|0)+r|0;m=(Y(h[n+3>>0]|0,l)|0)+m|0;q=q+1|0}while((q|0)!=(g|0));f[c+(k<<2)>>2]=p;f[c+((k|1)<<2)>>2]=o;f[c+((k|2)<<2)>>2]=r;f[c+((k|3)<<2)>>2]=m;k=k+4|0}while((k|0)<=(d|0));j=a&-4}while(0);if((j|0)>=(a|0))return;if((g|0)>1)s=j;else{d=j;do{j=Y(h[b+d>>0]|0,f[i>>2]|0)|0;f[c+(d<<2)>>2]=j;d=d+1|0}while((d|0)!=(a|0));return}do{d=b+s|0;j=Y(h[d>>0]|0,f[i>>2]|0)|0;k=d;d=1;do{k=k+e|0;j=(Y(h[k>>0]|0,f[i+(d<<2)>>2]|0)|0)+j|0;d=d+1|0}while((d|0)!=(g|0));f[c+(s<<2)>>2]=j;s=s+1|0}while((s|0)!=(a|0));return}function D9(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54472;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function E9(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=f[a+4>>2]|0;i=(g|0)/2|0;j=Y(i,e)|0;k=(f[a+28>>2]|0)+(i<<2)|0;l=b+j|0;m=Y(e,d)|0;if(!(f[a+72>>2]&1)){a:do switch(g|0){case 3:{a=f[k+4>>2]|0;d=m+-2|0;n=(m|0)<2;if((f[k>>2]|0)==0&(a|0)==1){if(n){o=l;p=0;break a}q=0-e|0;r=e+1|0;s=1-e|0;t=d&-2;u=j+t+2|0;v=l;w=0;while(1){x=(h[v+r>>0]|0)-(h[v+s>>0]|0)|0;f[c+(w<<2)>>2]=(h[v+e>>0]|0)-(h[v+q>>0]|0);f[c+((w|1)<<2)>>2]=x;w=w+2|0;if((w|0)>(d|0))break;else v=v+2|0}o=b+u|0;p=t+2|0;break a}else{if(n){o=l;p=0;break a}v=0-e|0;w=e+1|0;q=1-e|0;s=d&-2;r=j+s+2|0;x=l;y=0;while(1){z=Y((h[x+e>>0]|0)-(h[x+v>>0]|0)|0,a)|0;A=Y((h[x+w>>0]|0)-(h[x+q>>0]|0)|0,a)|0;f[c+(y<<2)>>2]=z;f[c+((y|1)<<2)>>2]=A;y=y+2|0;if((y|0)>(d|0))break;else x=x+2|0}o=b+r|0;p=s+2|0;break a}break}case 5:{x=f[k+4>>2]|0;d=f[k+8>>2]|0;y=m+-2|0;if((m|0)<2){o=l;p=0}else{a=0-e|0;q=e<<1;w=a<<1;v=e+1|0;n=1-e|0;t=q|1;u=1-q|0;A=y&-2;z=j+A+2|0;B=0;C=l;while(1){D=Y((h[C+e>>0]|0)-(h[C+a>>0]|0)|0,x)|0;E=(Y((h[C+q>>0]|0)-(h[C+w>>0]|0)|0,d)|0)+D|0;D=Y((h[C+v>>0]|0)-(h[C+n>>0]|0)|0,x)|0;F=(Y((h[C+t>>0]|0)-(h[C+u>>0]|0)|0,d)|0)+D|0;f[c+(B<<2)>>2]=E;f[c+((B|1)<<2)>>2]=F;B=B+2|0;if((B|0)>(y|0))break;else C=C+2|0}o=b+z|0;p=A+2|0}break}default:{o=l;p=0}}while(0);if((p|0)>=(m|0))return;if((g|0)<2){C=o;y=p;while(1){B=Y(h[C>>0]|0,f[k>>2]|0)|0;f[c+(y<<2)>>2]=B;y=y+1|0;if((y|0)==(m|0))break;else C=C+1|0}return}else{G=o;H=p}while(1){p=Y(h[G>>0]|0,f[k>>2]|0)|0;o=e;C=1;while(1){p=(Y((h[G+o>>0]|0)-(h[G+(0-o)>>0]|0)|0,f[k+(C<<2)>>2]|0)|0)+p|0;if((C|0)>=(i|0))break;else{o=o+e|0;C=C+1|0}}f[c+(H<<2)>>2]=p;H=H+1|0;if((H|0)==(m|0))break;else G=G+1|0}return}b:do switch(g|0){case 1:{if((f[k>>2]|0)==1?(G=m+-2|0,(m|0)>=2):0){H=G&-2;C=j+H+2|0;o=0;A=l;while(1){z=o|1;y=h[l+z>>0]|0;f[c+(o<<2)>>2]=h[A>>0];f[c+(z<<2)>>2]=y;y=o+2|0;if((y|0)>(G|0))break;else{o=y;A=l+y|0}}I=b+C|0;J=H+2|0}else{I=l;J=0}break}case 3:{A=f[k>>2]|0;o=f[k+4>>2]|0;G=(o|0)==1;if((A|0)==2&G){p=m+-2|0;if((m|0)<2){I=l;J=0;break b}y=0-e|0;z=1-e|0;B=e+1|0;d=p&-2;u=j+d+2|0;t=l;x=0;while(1){n=((h[t+1>>0]|0)<<1)+(h[t+z>>0]|0)+(h[t+B>>0]|0)|0;f[c+(x<<2)>>2]=((h[t>>0]|0)<<1)+(h[t+y>>0]|0)+(h[t+e>>0]|0);f[c+((x|1)<<2)>>2]=n;x=x+2|0;if((x|0)>(p|0))break;else t=t+2|0}I=b+u|0;J=d+2|0;break b}t=m+-2|0;p=(m|0)<2;if((A|0)==-2&G){if(p){I=l;J=0;break b}x=0-e|0;y=1-e|0;B=e+1|0;z=t&-2;H=j+z+2|0;C=l;n=0;while(1){v=(h[C+y>>0]|0)-((h[C+1>>0]|0)<<1)+(h[C+B>>0]|0)|0;f[c+(n<<2)>>2]=(h[C+x>>0]|0)-((h[C>>0]|0)<<1)+(h[C+e>>0]|0);f[c+((n|1)<<2)>>2]=v;n=n+2|0;if((n|0)>(t|0))break;else C=C+2|0}I=b+H|0;J=z+2|0;break b}else{if(p){I=l;J=0;break b}C=0-e|0;n=1-e|0;x=e+1|0;B=t&-2;y=j+B+2|0;G=l;d=0;while(1){u=Y(h[G>>0]|0,A)|0;v=(Y((h[G+e>>0]|0)+(h[G+C>>0]|0)|0,o)|0)+u|0;u=Y(h[G+1>>0]|0,A)|0;w=(Y((h[G+x>>0]|0)+(h[G+n>>0]|0)|0,o)|0)+u|0;f[c+(d<<2)>>2]=v;f[c+((d|1)<<2)>>2]=w;d=d+2|0;if((d|0)>(t|0))break;else G=G+2|0}I=b+y|0;J=B+2|0;break b}break}case 5:{G=f[k>>2]|0;t=f[k+4>>2]|0;d=f[k+8>>2]|0;o=m+-2|0;n=(m|0)<2;if((G|0)==-2&(t|0)==0&(d|0)==1){if(n){I=l;J=0;break b}x=0-e<<1;A=e<<1;C=1-A|0;p=A|1;z=o&-2;H=j+z+2|0;w=l;v=0;while(1){u=Y(h[w>>0]|0,-2)|0;q=Y(h[w+1>>0]|0,-2)|0;a=q+(h[w+C>>0]|0)+(h[w+p>>0]|0)|0;f[c+(v<<2)>>2]=u+(h[w+x>>0]|0)+(h[w+A>>0]|0);f[c+((v|1)<<2)>>2]=a;v=v+2|0;if((v|0)>(o|0))break;else w=w+2|0}I=b+H|0;J=z+2|0;break b}else{if(n){I=l;J=0;break b}w=0-e|0;v=w<<1;A=e<<1;x=1-e|0;p=e+1|0;C=1-A|0;B=A|1;y=o&-2;a=j+y+2|0;u=l;q=0;while(1){s=Y(h[u>>0]|0,G)|0;r=(Y((h[u+e>>0]|0)+(h[u+w>>0]|0)|0,t)|0)+s|0;s=r+(Y((h[u+A>>0]|0)+(h[u+v>>0]|0)|0,d)|0)|0;r=Y(h[u+1>>0]|0,G)|0;F=(Y((h[u+p>>0]|0)+(h[u+x>>0]|0)|0,t)|0)+r|0;r=F+(Y((h[u+B>>0]|0)+(h[u+C>>0]|0)|0,d)|0)|0;f[c+(q<<2)>>2]=s;f[c+((q|1)<<2)>>2]=r;q=q+2|0;if((q|0)>(o|0))break;else u=u+2|0}I=b+a|0;J=y+2|0;break b}break}default:{I=l;J=0}}while(0);if((J|0)>=(m|0))return;if((g|0)<2){g=I;l=J;while(1){b=Y(h[g>>0]|0,f[k>>2]|0)|0;f[c+(l<<2)>>2]=b;l=l+1|0;if((l|0)==(m|0))break;else g=g+1|0}return}else{K=I;L=J}while(1){J=e;I=1;g=Y(h[K>>0]|0,f[k>>2]|0)|0;while(1){g=(Y((h[K+(0-J)>>0]|0)+(h[K+J>>0]|0)|0,f[k+(I<<2)>>2]|0)|0)+g|0;if((I|0)>=(i|0))break;else{J=J+e|0;I=I+1|0}}f[c+(L<<2)>>2]=g;L=L+1|0;if((L|0)==(m|0))break;else K=K+1|0}return}function F9(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;k=u;u=u+80|0;l=k;m=k+72|0;n=k+64|0;o=k+8|0;do if((yM(e)|0)==65536){p=f[e+4>>2]|0;f[o>>2]=f[p>>2];q=o+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=o+8|0;f[s>>2]=f[p+8>>2];f[o+12>>2]=f[p+12>>2];f[o+16>>2]=f[p+16>>2];f[o+20>>2]=f[p+20>>2];f[o+24>>2]=f[p+24>>2];f[o+28>>2]=f[p+28>>2];f[o+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[o+36>>2]=t;f[o+40>>2]=s;s=o+48|0;v=o+44|0;f[v>>2]=s;f[s>>2]=0;f[o+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;jL(o,p);break}}else yL(o,e,-1);while(0);e=c&7;p=d&7;if(!((((d^c)&4088|0)==0?(e|0)>=((p>>>0>4?p:4)|0):0)?(f[o>>2]&4095|0)==(e|0):0)){f[m>>2]=0;f[m+4>>2]=0;q=aD(m,109)|0;r=244475;s=q+109|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-215,m,244585,241836,3660);bD(m)}do if(!(h&3)){r=(p|0)==0;if((e|0)==4&r){f[n>>2]=j;f[n+4>>2]=(j|0)==0?0:1<<j+-1;q=L5b(84)|0;G9(q,o,g,i,n,m);s=L5b(16)|0;v=s+4|0;f[v>>2]=1;f[s>>2]=54492;f[s+8>>2]=q;f[a>>2]=s;f[a+4>>2]=q;f[v>>2]=(f[v>>2]|0)+1;q=f[v>>2]|0;f[v>>2]=q+-1;if((q|0)==1)bi[f[(f[s>>2]|0)+8>>2]&2047](s);break}s=(e|0)==5;if(s&r){q=L5b(76)|0;H9(q,o,g,i,m,n);v=L5b(16)|0;t=v+4|0;f[t>>2]=1;f[v>>2]=54512;f[v+8>>2]=q;f[a>>2]=v;f[a+4>>2]=q;f[t>>2]=(f[t>>2]|0)+1;q=f[t>>2]|0;f[t>>2]=q+-1;if((q|0)!=1)break;bi[f[(f[v>>2]|0)+8>>2]&2047](v);break}v=(e|0)==6;if(v&r){r=L5b(80)|0;I9(r,o,g,i,m,n);q=L5b(16)|0;t=q+4|0;f[t>>2]=1;f[q>>2]=54532;f[q+8>>2]=r;f[a>>2]=q;f[a+4>>2]=r;f[t>>2]=(f[t>>2]|0)+1;r=f[t>>2]|0;f[t>>2]=r+-1;if((r|0)!=1)break;bi[f[(f[q>>2]|0)+8>>2]&2047](q);break}q=(p|0)==2;if(s&q){r=L5b(76)|0;J9(r,o,g,i,m,n);t=L5b(16)|0;w=t+4|0;f[w>>2]=1;f[t>>2]=54552;f[t+8>>2]=r;f[a>>2]=t;f[a+4>>2]=r;f[w>>2]=(f[w>>2]|0)+1;r=f[w>>2]|0;f[w>>2]=r+-1;if((r|0)!=1)break;bi[f[(f[t>>2]|0)+8>>2]&2047](t);break}if(v&q){q=L5b(80)|0;K9(q,o,g,i,m,n);t=L5b(16)|0;r=t+4|0;f[r>>2]=1;f[t>>2]=54572;f[t+8>>2]=q;f[a>>2]=t;f[a+4>>2]=q;f[r>>2]=(f[r>>2]|0)+1;q=f[r>>2]|0;f[r>>2]=q+-1;if((q|0)!=1)break;bi[f[(f[t>>2]|0)+8>>2]&2047](t);break}t=(p|0)==3;if(s&t){q=L5b(76)|0;L9(q,o,g,i,m,n);r=L5b(16)|0;w=r+4|0;f[w>>2]=1;f[r>>2]=54592;f[r+8>>2]=q;f[a>>2]=r;f[a+4>>2]=q;f[w>>2]=(f[w>>2]|0)+1;q=f[w>>2]|0;f[w>>2]=q+-1;if((q|0)!=1)break;bi[f[(f[r>>2]|0)+8>>2]&2047](r);break}if(v&t){t=L5b(80)|0;M9(t,o,g,i,m,n);r=L5b(16)|0;q=r+4|0;f[q>>2]=1;f[r>>2]=54612;f[r+8>>2]=t;f[a>>2]=r;f[a+4>>2]=t;f[q>>2]=(f[q>>2]|0)+1;t=f[q>>2]|0;f[q>>2]=t+-1;if((t|0)!=1)break;bi[f[(f[r>>2]|0)+8>>2]&2047](r);break}if(s&(p|0)==5){s=L5b(76)|0;N9(s,o,g,i,m,n);r=L5b(16)|0;t=r+4|0;f[t>>2]=1;f[r>>2]=54632;f[r+8>>2]=s;f[a>>2]=r;f[a+4>>2]=s;f[t>>2]=(f[t>>2]|0)+1;s=f[t>>2]|0;f[t>>2]=s+-1;if((s|0)!=1)break;bi[f[(f[r>>2]|0)+8>>2]&2047](r);break}if(v&(p|0)==6){v=L5b(80)|0;O9(v,o,g,i,m,n);r=L5b(16)|0;s=r+4|0;f[s>>2]=1;f[r>>2]=54652;f[r+8>>2]=v;f[a>>2]=r;f[a+4>>2]=v;f[s>>2]=(f[s>>2]|0)+1;v=f[s>>2]|0;f[s>>2]=v+-1;if((v|0)==1)bi[f[(f[r>>2]|0)+8>>2]&2047](r)}else x=87}else{if(((f[o+12>>2]|0)+(f[o+8>>2]|0)|0)==4){r=(e|0)==4;if(r&(p|0)==0){f[m>>2]=j;f[m+4>>2]=(j|0)==0?0:1<<j+-1;v=L5b(88)|0;P9(v,o,g,i,h,m,n);s=L5b(16)|0;t=s+4|0;f[t>>2]=1;f[s>>2]=54672;f[s+8>>2]=v;f[a>>2]=s;f[a+4>>2]=v;f[t>>2]=(f[t>>2]|0)+1;v=f[t>>2]|0;f[t>>2]=v+-1;if((v|0)==1)bi[f[(f[s>>2]|0)+8>>2]&2047](s);break}if(r&(p|0)==3&(j|0)==0){r=L5b(80)|0;Q9(r,o,g,i,h,m,n);s=L5b(16)|0;v=s+4|0;f[v>>2]=1;f[s>>2]=54692;f[s+8>>2]=r;f[a>>2]=s;f[a+4>>2]=r;f[v>>2]=(f[v>>2]|0)+1;r=f[v>>2]|0;f[v>>2]=r+-1;if((r|0)==1)bi[f[(f[s>>2]|0)+8>>2]&2047](s);break}if((e|0)==5&(p|0)==5){s=L5b(80)|0;R9(s,o,g,i,h,m,n);r=L5b(16)|0;v=r+4|0;f[v>>2]=1;f[r>>2]=54712;f[r+8>>2]=s;f[a>>2]=r;f[a+4>>2]=s;f[v>>2]=(f[v>>2]|0)+1;s=f[v>>2]|0;f[v>>2]=s+-1;if((s|0)==1)bi[f[(f[r>>2]|0)+8>>2]&2047](r);break}}r=(p|0)==0;s=(e|0)==4;if(s&r){f[m>>2]=j;f[m+4>>2]=(j|0)==0?0:1<<j+-1;v=L5b(88)|0;S9(v,o,g,i,h,m,n);t=L5b(16)|0;q=t+4|0;f[q>>2]=1;f[t>>2]=54732;f[t+8>>2]=v;f[a>>2]=t;f[a+4>>2]=v;f[q>>2]=(f[q>>2]|0)+1;v=f[q>>2]|0;f[q>>2]=v+-1;if((v|0)==1)bi[f[(f[t>>2]|0)+8>>2]&2047](t);break}t=(e|0)==5;if(t&r){v=L5b(80)|0;T9(v,o,g,i,h,m,n);q=L5b(16)|0;w=q+4|0;f[w>>2]=1;f[q>>2]=54752;f[q+8>>2]=v;f[a>>2]=q;f[a+4>>2]=v;f[w>>2]=(f[w>>2]|0)+1;v=f[w>>2]|0;f[w>>2]=v+-1;if((v|0)!=1)break;bi[f[(f[q>>2]|0)+8>>2]&2047](q);break}q=(e|0)==6;if(q&r){r=L5b(88)|0;U9(r,o,g,i,h,m,n);v=L5b(16)|0;w=v+4|0;f[w>>2]=1;f[v>>2]=54772;f[v+8>>2]=r;f[a>>2]=v;f[a+4>>2]=r;f[w>>2]=(f[w>>2]|0)+1;r=f[w>>2]|0;f[w>>2]=r+-1;if((r|0)!=1)break;bi[f[(f[v>>2]|0)+8>>2]&2047](v);break}v=(p|0)==2;if(t&v){r=L5b(80)|0;V9(r,o,g,i,h,m,n);w=L5b(16)|0;y=w+4|0;f[y>>2]=1;f[w>>2]=54792;f[w+8>>2]=r;f[a>>2]=w;f[a+4>>2]=r;f[y>>2]=(f[y>>2]|0)+1;r=f[y>>2]|0;f[y>>2]=r+-1;if((r|0)!=1)break;bi[f[(f[w>>2]|0)+8>>2]&2047](w);break}if(q&v){v=L5b(88)|0;W9(v,o,g,i,h,m,n);w=L5b(16)|0;r=w+4|0;f[r>>2]=1;f[w>>2]=54812;f[w+8>>2]=v;f[a>>2]=w;f[a+4>>2]=v;f[r>>2]=(f[r>>2]|0)+1;v=f[r>>2]|0;f[r>>2]=v+-1;if((v|0)!=1)break;bi[f[(f[w>>2]|0)+8>>2]&2047](w);break}w=(p|0)==3;if(s&w){s=L5b(80)|0;X9(s,o,g,i,h,m,n);v=L5b(16)|0;r=v+4|0;f[r>>2]=1;f[v>>2]=54832;f[v+8>>2]=s;f[a>>2]=v;f[a+4>>2]=s;f[r>>2]=(f[r>>2]|0)+1;s=f[r>>2]|0;f[r>>2]=s+-1;if((s|0)!=1)break;bi[f[(f[v>>2]|0)+8>>2]&2047](v);break}if(t&w){v=L5b(80)|0;Y9(v,o,g,i,h,m,n);s=L5b(16)|0;r=s+4|0;f[r>>2]=1;f[s>>2]=54852;f[s+8>>2]=v;f[a>>2]=s;f[a+4>>2]=v;f[r>>2]=(f[r>>2]|0)+1;v=f[r>>2]|0;f[r>>2]=v+-1;if((v|0)==1)bi[f[(f[s>>2]|0)+8>>2]&2047](s);break}if(q&w){w=L5b(88)|0;Z9(w,o,g,i,h,m,n);s=L5b(16)|0;v=s+4|0;f[v>>2]=1;f[s>>2]=54872;f[s+8>>2]=w;f[a>>2]=s;f[a+4>>2]=w;f[v>>2]=(f[v>>2]|0)+1;w=f[v>>2]|0;f[v>>2]=w+-1;if((w|0)!=1)break;bi[f[(f[s>>2]|0)+8>>2]&2047](s);break}if(t&(p|0)==5){t=L5b(80)|0;_9(t,o,g,i,h,m,n);s=L5b(16)|0;w=s+4|0;f[w>>2]=1;f[s>>2]=54892;f[s+8>>2]=t;f[a>>2]=s;f[a+4>>2]=t;f[w>>2]=(f[w>>2]|0)+1;t=f[w>>2]|0;f[w>>2]=t+-1;if((t|0)==1)bi[f[(f[s>>2]|0)+8>>2]&2047](s);break}else{if(!(q&(p|0)==6)){x=87;break}q=L5b(88)|0;$9(q,o,g,i,h,m,n);s=L5b(16)|0;t=s+4|0;f[t>>2]=1;f[s>>2]=54912;f[s+8>>2]=q;f[a>>2]=s;f[a+4>>2]=q;f[t>>2]=(f[t>>2]|0)+1;q=f[t>>2]|0;f[t>>2]=q+-1;if((q|0)!=1)break;bi[f[(f[s>>2]|0)+8>>2]&2047](s);break}}while(0);if((x|0)==87){f[l>>2]=c;f[l+4>>2]=d;hO(m,244607,l);bO(-213,m,244585,241836,3741);bD(m);f[a>>2]=0;f[a+4>>2]=0}a=o+36|0;m=f[a>>2]|0;if(m|0?(l=m+12|0,m=f[l>>2]|0,f[l>>2]=m+-1,(m|0)==1):0)kL(o);f[a>>2]=0;a=o+16|0;m=o+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[m>>2]|0)>0){a=f[o+40>>2]|0;l=0;do{f[a+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[m>>2]|0))}m=f[o+44>>2]|0;if((m|0)==(o+48|0)){u=k;return}UC(m);u=k;return}function G9(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;h=u;u=u+16|0;i=h;j=a+8|0;f[j>>2]=-1;k=a+4|0;f[k>>2]=-1;f[a>>2]=55388;l=a+12|0;f[l>>2]=1124007936;m=a+16|0;n=a+20|0;o=a+52|0;p=m;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=n;r=a+60|0;s=a+56|0;f[s>>2]=r;t=a+68|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if(f[c>>2]&16384){if((l|0)!=(c|0)){r=c+36|0;v=f[r>>2]|0;if(v){w=v+12|0;f[w>>2]=(f[w>>2]|0)+1;w=a+48|0;v=f[w>>2]|0;if((v|0)!=0?(x=v+12|0,v=f[x>>2]|0,f[x>>2]=v+-1,(v|0)==1):0){kL(l);y=w}else y=w}else y=a+48|0;f[y>>2]=0;w=a+28|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[m>>2]|0)>0){v=f[o>>2]|0;o=0;do{f[v+(o<<2)>>2]=0;o=o+1|0;z=f[m>>2]|0}while((o|0)<(z|0));f[l>>2]=f[c>>2];if((z|0)<3)A=13;else A=15}else{f[l>>2]=f[c>>2];A=13}if((A|0)==13){z=f[c+4>>2]|0;if((z|0)<3){f[m>>2]=z;f[n>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];z=f[c+44>>2]|0;m=f[s>>2]|0;f[m>>2]=f[z>>2];f[m+4>>2]=f[z+4>>2]}else A=15}if((A|0)==15)jL(l,c);f[w>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[y>>2]=f[r>>2]}}else{r=i+8|0;f[r>>2]=0;f[r+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=l;SP(c,i)}f[j>>2]=d;d=f[n>>2]|0;n=f[a+24>>2]|0;f[k>>2]=d+-1+n;k=MVb(e)|0;f[a+80>>2]=k;k=g;g=f[k+4>>2]|0;a=t;f[a>>2]=f[k>>2];f[a+4>>2]=g;if((f[l>>2]&4095|0)==4?(d|0)==1|(n|0)==1:0){u=h;return}f[i>>2]=0;f[i+4>>2]=0;p=aD(i,77)|0;n=245846;q=p+77|0;do{b[p>>0]=b[n>>0]|0;p=p+1|0;n=n+1|0}while((p|0)<(q|0));bO(-215,i,245924,241836,3251);bD(i);u=h;return}function H9(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=55340;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){kL(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)jL(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;SP(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)==5?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;p=aD(g,77)|0;m=245846;q=p+77|0;do{b[p>>0]=b[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(q|0));bO(-215,g,245924,241836,3251);bD(g);u=h;return}function I9(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=55292;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){kL(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)jL(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;SP(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)==6?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;o=aD(g,77)|0;m=245846;q=o+77|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(q|0));bO(-215,g,245924,241836,3251);bD(g);u=h;return}function J9(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=55244;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){kL(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)jL(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;SP(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)==5?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;p=aD(g,77)|0;m=245846;q=p+77|0;do{b[p>>0]=b[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(q|0));bO(-215,g,245924,241836,3251);bD(g);u=h;return}function K9(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=55196;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){kL(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)jL(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;SP(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)==6?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;o=aD(g,77)|0;m=245846;q=o+77|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(q|0));bO(-215,g,245924,241836,3251);bD(g);u=h;return}function L9(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=55100;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){kL(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)jL(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;SP(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)==5?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;p=aD(g,77)|0;m=245846;q=p+77|0;do{b[p>>0]=b[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(q|0));bO(-215,g,245924,241836,3251);bD(g);u=h;return}function M9(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=55052;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){kL(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)jL(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;SP(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)==6?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;o=aD(g,77)|0;m=245846;q=o+77|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(q|0));bO(-215,g,245924,241836,3251);bD(g);u=h;return}function N9(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=55004;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){kL(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)jL(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;SP(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)==5?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;p=aD(g,77)|0;m=245846;q=p+77|0;do{b[p>>0]=b[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(q|0));bO(-215,g,245924,241836,3251);bD(g);u=h;return}function O9(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=54956;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;q=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(q|0));f[n>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){kL(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[n>>2]|0;n=0;do{f[t+(n<<2)>>2]=0;n=n+1|0;y=f[l>>2]|0}while((n|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)jL(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;SP(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;p[a+72>>3]=e;if((f[k>>2]&4095|0)==6?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;o=aD(g,77)|0;m=245846;q=o+77|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(q|0));bO(-215,g,245924,241836,3251);bD(g);u=h;return}function P9(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;S9(a,c,d,e,g,h,i);f[a>>2]=55556;if((f[a+4>>2]|0)==3){u=j;return}f[k>>2]=0;f[k+4>>2]=0;a=aD(k,16)|0;i=247169;h=a+16|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));bO(-215,k,247186,241836,3420);bD(k);u=j;return}function Q9(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;Eba(a,c,d,e,g,h,i);f[a>>2]=55484;if((f[a+4>>2]|0)==3){u=j;return}f[k>>2]=0;f[k+4>>2]=0;a=aD(k,16)|0;i=247169;h=a+16|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));bO(-215,k,247186,241836,3420);bD(k);u=j;return}function R9(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;tba(a,c,d,e,g,h,i);f[a>>2]=55412;if((f[a+4>>2]|0)==3){u=j;return}f[k>>2]=0;f[k+4>>2]=0;a=aD(k,16)|0;i=247169;h=a+16|0;do{b[a>>0]=b[i>>0]|0;a=a+1|0;i=i+1|0}while((a|0)<(h|0));bO(-215,k,247186,241836,3420);bD(k);u=j;return}function S9(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;G9(a,c,d,e,h,i);f[a>>2]=55364;f[a+84>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=aD(k,64)|0;a=244792;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));bO(-215,k,244857,241836,3314);bD(k);u=j;return}function T9(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;H9(a,c,d,e,h,i);f[a>>2]=55316;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=aD(k,64)|0;a=244792;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));bO(-215,k,244857,241836,3314);bD(k);u=j;return}function U9(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;I9(a,c,d,e,h,i);f[a>>2]=55268;f[a+80>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=aD(k,64)|0;a=244792;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));bO(-215,k,244857,241836,3314);bD(k);u=j;return}function V9(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;J9(a,c,d,e,h,i);f[a>>2]=55220;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=aD(k,64)|0;a=244792;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));bO(-215,k,244857,241836,3314);bD(k);u=j;return}function W9(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;K9(a,c,d,e,h,i);f[a>>2]=55172;f[a+80>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=aD(k,64)|0;a=244792;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));bO(-215,k,244857,241836,3314);bD(k);u=j;return}function X9(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;Eaa(a,c,d,e,h,i);f[a>>2]=55124;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=aD(k,64)|0;a=244792;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));bO(-215,k,244857,241836,3314);bD(k);u=j;return}function Y9(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;L9(a,c,d,e,h,i);f[a>>2]=55076;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=aD(k,64)|0;a=244792;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));bO(-215,k,244857,241836,3314);bD(k);u=j;return}function Z9(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;M9(a,c,d,e,h,i);f[a>>2]=55028;f[a+80>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=aD(k,64)|0;a=244792;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));bO(-215,k,244857,241836,3314);bD(k);u=j;return}function _9(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;N9(a,c,d,e,h,i);f[a>>2]=54980;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=aD(k,64)|0;a=244792;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));bO(-215,k,244857,241836,3314);bD(k);u=j;return}function $9(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;O9(a,c,d,e,h,i);f[a>>2]=54932;f[a+80>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=aD(k,64)|0;a=244792;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));bO(-215,k,244857,241836,3314);bD(k);u=j;return}function aaa(a){a=a|0;O5b(a);return}function baa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function caa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54956;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function daa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54956;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function eaa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0;h=f[a+28>>2]|0;i=+p[a+72>>3];j=f[a+4>>2]|0;if(!e)return;a=g+-4|0;k=(g|0)<4;l=(j|0)>1;m=g&-4;n=b;b=c;c=e;while(1){c=c+-1|0;a:do if(k)o=0;else{e=f[n>>2]|0;if(l)q=0;else{r=0;while(1){s=+p[h>>3];t=e+(r<<3)|0;u=i+s*+p[t+8>>3];v=i+s*+p[t+16>>3];w=i+s*+p[t+24>>3];p[b+(r<<3)>>3]=i+s*+p[t>>3];p[b+((r|1)<<3)>>3]=u;p[b+((r|2)<<3)>>3]=v;p[b+((r|3)<<3)>>3]=w;r=r+4|0;if((r|0)>(a|0)){o=m;break a}}}do{w=+p[h>>3];r=e+(q<<3)|0;v=i+w*+p[r+24>>3];u=i+w*+p[r+16>>3];s=i+w*+p[r+8>>3];x=i+w*+p[r>>3];r=1;do{t=(f[n+(r<<2)>>2]|0)+(q<<3)|0;w=+p[h+(r<<3)>>3];x=x+w*+p[t>>3];s=s+w*+p[t+8>>3];u=u+w*+p[t+16>>3];v=v+w*+p[t+24>>3];r=r+1|0}while((r|0)!=(j|0));p[b+(q<<3)>>3]=x;p[b+((q|1)<<3)>>3]=s;p[b+((q|2)<<3)>>3]=u;p[b+((q|3)<<3)>>3]=v;q=q+4|0}while((q|0)<=(a|0));o=m}while(0);b:do if((o|0)<(g|0)){e=f[n>>2]|0;if(l)y=o;else{r=o;while(1){p[b+(r<<3)>>3]=i+ +p[h>>3]*+p[e+(r<<3)>>3];r=r+1|0;if((r|0)==(g|0))break b}}do{w=i+ +p[h>>3]*+p[e+(y<<3)>>3];r=1;do{w=w+ +p[h+(r<<3)>>3]*+p[(f[n+(r<<2)>>2]|0)+(y<<3)>>3];r=r+1|0}while((r|0)!=(j|0));p[b+(y<<3)>>3]=w;y=y+1|0}while((y|0)!=(g|0))}while(0);if(!c)break;else{n=n+4|0;b=b+d|0}}return}function faa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=54956;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function gaa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0;h=f[a+4>>2]|0;i=(h|0)/2|0;j=(f[a+28>>2]|0)+(i<<3)|0;k=+p[a+72>>3];l=b+(i<<2)|0;b=e+-1|0;m=(e|0)==0;if(!(f[a+80>>2]&1)){if(m)return;a=g+-4|0;e=(g|0)<4;n=(h|0)<2;o=g&-4;q=c;r=l;s=b;while(1){a:do if(e)t=0;else{if(n){u=0;while(1){p[q+(u<<3)>>3]=k;p[q+((u|1)<<3)>>3]=k;p[q+((u|2)<<3)>>3]=k;p[q+((u|3)<<3)>>3]=k;u=u+4|0;if((u|0)>(a|0)){t=o;break a}}}else v=0;do{w=k;x=k;y=k;z=k;u=1;while(1){A=(f[r+(u<<2)>>2]|0)+(v<<3)|0;B=(f[r+(0-u<<2)>>2]|0)+(v<<3)|0;C=+p[j+(u<<3)>>3];z=z+C*(+p[A>>3]-+p[B>>3]);y=y+C*(+p[A+8>>3]-+p[B+8>>3]);x=x+C*(+p[A+16>>3]-+p[B+16>>3]);w=w+C*(+p[A+24>>3]-+p[B+24>>3]);if((u|0)>=(i|0))break;else u=u+1|0}p[q+(v<<3)>>3]=z;p[q+((v|1)<<3)>>3]=y;p[q+((v|2)<<3)>>3]=x;p[q+((v|3)<<3)>>3]=w;v=v+4|0}while((v|0)<=(a|0));t=o}while(0);b:do if((t|0)<(g|0)){if(n){u=t;while(1){p[q+(u<<3)>>3]=k;u=u+1|0;if((u|0)==(g|0))break b}}else D=t;do{C=k;u=1;while(1){C=C+ +p[j+(u<<3)>>3]*(+p[(f[r+(u<<2)>>2]|0)+(D<<3)>>3]-+p[(f[r+(0-u<<2)>>2]|0)+(D<<3)>>3]);if((u|0)>=(i|0))break;else u=u+1|0}p[q+(D<<3)>>3]=C;D=D+1|0}while((D|0)!=(g|0))}while(0);if(!s)break;else{q=q+d|0;r=r+4|0;s=s+-1|0}}return}else{if(m)return;m=g+-4|0;s=(g|0)<4;r=(h|0)<2;h=g&-4;q=l;l=c;c=b;while(1){c:do if(s)E=0;else{b=f[q>>2]|0;if(r){D=0;while(1){w=+p[j>>3];t=b+(D<<3)|0;x=k+w*+p[t+8>>3];y=k+w*+p[t+16>>3];z=k+w*+p[t+24>>3];p[l+(D<<3)>>3]=k+w*+p[t>>3];p[l+((D|1)<<3)>>3]=x;p[l+((D|2)<<3)>>3]=y;p[l+((D|3)<<3)>>3]=z;D=D+4|0;if((D|0)>(m|0)){E=h;break c}}}else F=0;do{z=+p[j>>3];D=b+(F<<3)|0;y=k+z*+p[D+24>>3];x=k+z*+p[D+16>>3];w=k+z*+p[D+8>>3];G=k+z*+p[D>>3];D=1;while(1){t=(f[q+(D<<2)>>2]|0)+(F<<3)|0;n=(f[q+(0-D<<2)>>2]|0)+(F<<3)|0;z=+p[j+(D<<3)>>3];G=G+z*(+p[t>>3]+ +p[n>>3]);w=w+z*(+p[t+8>>3]+ +p[n+8>>3]);x=x+z*(+p[t+16>>3]+ +p[n+16>>3]);y=y+z*(+p[t+24>>3]+ +p[n+24>>3]);if((D|0)>=(i|0))break;else D=D+1|0}p[l+(F<<3)>>3]=G;p[l+((F|1)<<3)>>3]=w;p[l+((F|2)<<3)>>3]=x;p[l+((F|3)<<3)>>3]=y;F=F+4|0}while((F|0)<=(m|0));E=h}while(0);d:do if((E|0)<(g|0)){b=f[q>>2]|0;if(r){D=E;while(1){p[l+(D<<3)>>3]=k+ +p[j>>3]*+p[b+(D<<3)>>3];D=D+1|0;if((D|0)==(g|0))break d}}else H=E;do{C=k+ +p[j>>3]*+p[b+(H<<3)>>3];D=1;while(1){C=C+ +p[j+(D<<3)>>3]*(+p[(f[q+(D<<2)>>2]|0)+(H<<3)>>3]+ +p[(f[q+(0-D<<2)>>2]|0)+(H<<3)>>3]);if((D|0)>=(i|0))break;else D=D+1|0}p[l+(H<<3)>>3]=C;H=H+1|0}while((H|0)!=(g|0))}while(0);if(!c)break;else{q=q+4|0;l=l+d|0;c=c+-1|0}}return}}function haa(a){a=a|0;O5b(a);return}function iaa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function jaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55004;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function kaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55004;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function laa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0;h=f[a+28>>2]|0;i=+n[a+72>>2];j=f[a+4>>2]|0;if(!e)return;a=g+-4|0;k=(g|0)<4;l=(j|0)>1;m=g&-4;o=b;b=c;c=e;while(1){c=c+-1|0;a:do if(k)p=0;else{e=f[o>>2]|0;if(l)q=0;else{r=0;while(1){s=+n[h>>2];t=e+(r<<2)|0;u=i+s*+n[t+4>>2];v=i+s*+n[t+8>>2];w=i+s*+n[t+12>>2];n[b+(r<<2)>>2]=i+s*+n[t>>2];n[b+((r|1)<<2)>>2]=u;n[b+((r|2)<<2)>>2]=v;n[b+((r|3)<<2)>>2]=w;r=r+4|0;if((r|0)>(a|0)){p=m;break a}}}do{w=+n[h>>2];r=e+(q<<2)|0;v=i+w*+n[r+12>>2];u=i+w*+n[r+8>>2];s=i+w*+n[r+4>>2];x=i+w*+n[r>>2];r=1;do{t=(f[o+(r<<2)>>2]|0)+(q<<2)|0;w=+n[h+(r<<2)>>2];x=x+w*+n[t>>2];s=s+w*+n[t+4>>2];u=u+w*+n[t+8>>2];v=v+w*+n[t+12>>2];r=r+1|0}while((r|0)!=(j|0));n[b+(q<<2)>>2]=x;n[b+((q|1)<<2)>>2]=s;n[b+((q|2)<<2)>>2]=u;n[b+((q|3)<<2)>>2]=v;q=q+4|0}while((q|0)<=(a|0));p=m}while(0);b:do if((p|0)<(g|0)){e=f[o>>2]|0;if(l)y=p;else{r=p;while(1){n[b+(r<<2)>>2]=i+ +n[h>>2]*+n[e+(r<<2)>>2];r=r+1|0;if((r|0)==(g|0))break b}}do{w=i+ +n[h>>2]*+n[e+(y<<2)>>2];r=1;do{w=w+ +n[h+(r<<2)>>2]*+n[(f[o+(r<<2)>>2]|0)+(y<<2)>>2];r=r+1|0}while((r|0)!=(j|0));n[b+(y<<2)>>2]=w;y=y+1|0}while((y|0)!=(g|0))}while(0);if(!c)break;else{o=o+4|0;b=b+d|0}}return}function maa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55004;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function naa(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0;h=f[a+4>>2]|0;i=(h|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=+n[a+72>>2];l=b+(i<<2)|0;b=e+-1|0;m=(e|0)==0;if(!(f[a+76>>2]&1)){if(m)return;a=g+-4|0;e=(g|0)<4;o=(h|0)<2;p=g&-4;q=c;r=l;s=b;while(1){a:do if(e)t=0;else{if(o){u=0;while(1){n[q+(u<<2)>>2]=k;n[q+((u|1)<<2)>>2]=k;n[q+((u|2)<<2)>>2]=k;n[q+((u|3)<<2)>>2]=k;u=u+4|0;if((u|0)>(a|0)){t=p;break a}}}else v=0;do{w=k;x=k;y=k;z=k;u=1;while(1){A=(f[r+(u<<2)>>2]|0)+(v<<2)|0;B=(f[r+(0-u<<2)>>2]|0)+(v<<2)|0;C=+n[j+(u<<2)>>2];z=z+C*(+n[A>>2]-+n[B>>2]);y=y+C*(+n[A+4>>2]-+n[B+4>>2]);x=x+C*(+n[A+8>>2]-+n[B+8>>2]);w=w+C*(+n[A+12>>2]-+n[B+12>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[q+(v<<2)>>2]=z;n[q+((v|1)<<2)>>2]=y;n[q+((v|2)<<2)>>2]=x;n[q+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(a|0));t=p}while(0);b:do if((t|0)<(g|0)){if(o){u=t;while(1){n[q+(u<<2)>>2]=k;u=u+1|0;if((u|0)==(g|0))break b}}else D=t;do{C=k;u=1;while(1){C=C+ +n[j+(u<<2)>>2]*(+n[(f[r+(u<<2)>>2]|0)+(D<<2)>>2]-+n[(f[r+(0-u<<2)>>2]|0)+(D<<2)>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[q+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(g|0))}while(0);if(!s)break;else{q=q+d|0;r=r+4|0;s=s+-1|0}}return}else{if(m)return;m=g+-4|0;s=(g|0)<4;r=(h|0)<2;h=g&-4;q=l;l=c;c=b;while(1){c:do if(s)E=0;else{b=f[q>>2]|0;if(r){D=0;while(1){w=+n[j>>2];t=b+(D<<2)|0;x=k+w*+n[t+4>>2];y=k+w*+n[t+8>>2];z=k+w*+n[t+12>>2];n[l+(D<<2)>>2]=k+w*+n[t>>2];n[l+((D|1)<<2)>>2]=x;n[l+((D|2)<<2)>>2]=y;n[l+((D|3)<<2)>>2]=z;D=D+4|0;if((D|0)>(m|0)){E=h;break c}}}else F=0;do{z=+n[j>>2];D=b+(F<<2)|0;y=k+z*+n[D+12>>2];x=k+z*+n[D+8>>2];w=k+z*+n[D+4>>2];G=k+z*+n[D>>2];D=1;while(1){t=(f[q+(D<<2)>>2]|0)+(F<<2)|0;o=(f[q+(0-D<<2)>>2]|0)+(F<<2)|0;z=+n[j+(D<<2)>>2];G=G+z*(+n[t>>2]+ +n[o>>2]);w=w+z*(+n[t+4>>2]+ +n[o+4>>2]);x=x+z*(+n[t+8>>2]+ +n[o+8>>2]);y=y+z*(+n[t+12>>2]+ +n[o+12>>2]);if((D|0)>=(i|0))break;else D=D+1|0}n[l+(F<<2)>>2]=G;n[l+((F|1)<<2)>>2]=w;n[l+((F|2)<<2)>>2]=x;n[l+((F|3)<<2)>>2]=y;F=F+4|0}while((F|0)<=(m|0));E=h}while(0);d:do if((E|0)<(g|0)){b=f[q>>2]|0;if(r){D=E;while(1){n[l+(D<<2)>>2]=k+ +n[j>>2]*+n[b+(D<<2)>>2];D=D+1|0;if((D|0)==(g|0))break d}}else H=E;do{C=k+ +n[j>>2]*+n[b+(H<<2)>>2];D=1;while(1){C=C+ +n[j+(D<<2)>>2]*(+n[(f[q+(D<<2)>>2]|0)+(H<<2)>>2]+ +n[(f[q+(0-D<<2)>>2]|0)+(H<<2)>>2]);if((D|0)>=(i|0))break;else D=D+1|0}n[l+(H<<2)>>2]=C;H=H+1|0}while((H|0)!=(g|0))}while(0);if(!c)break;else{q=q+4|0;l=l+d|0;c=c+-1|0}}return}}function oaa(a){a=a|0;O5b(a);return}function paa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function qaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55052;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function raa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55052;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function saa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+p[a+72>>3];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)q=0;else{r=+p[i>>3];g=f[o>>2]|0;if(m)s=0;else{t=0;while(1){u=g+(t<<3)|0;v=j+r*+p[u+8>>3];w=j+r*+p[u+16>>3];x=j+r*+p[u+24>>3];y=MVb(j+r*+p[u>>3])|0;d[b+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=MVb(v)|0;d[b+((t|1)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=MVb(w)|0;d[b+((t|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=MVb(x)|0;d[b+((t|3)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+4|0;if((t|0)>(a|0)){q=n;break a}}}do{t=g+(s<<3)|0;x=j+r*+p[t+24>>3];w=j+r*+p[t+16>>3];v=j+r*+p[t+8>>3];z=j+r*+p[t>>3];t=1;do{y=(f[o+(t<<2)>>2]|0)+(s<<3)|0;A=+p[i+(t<<3)>>3];z=z+A*+p[y>>3];v=v+A*+p[y+8>>3];w=w+A*+p[y+16>>3];x=x+A*+p[y+24>>3];t=t+1|0}while((t|0)!=(k|0));t=MVb(z)|0;d[b+(s<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=MVb(v)|0;d[b+((s|1)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=MVb(w)|0;d[b+((s|2)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=MVb(x)|0;d[b+((s|3)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;s=s+4|0}while((s|0)<=(a|0));q=n}while(0);b:do if((q|0)<(h|0)){r=+p[i>>3];g=f[o>>2]|0;if(m)B=q;else{t=q;while(1){y=MVb(j+r*+p[g+(t<<3)>>3])|0;d[b+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+1|0;if((t|0)==(h|0))break b}}do{A=j+r*+p[g+(B<<3)>>3];t=1;do{A=A+ +p[i+(t<<3)>>3]*+p[(f[o+(t<<2)>>2]|0)+(B<<3)>>3];t=t+1|0}while((t|0)!=(k|0));t=MVb(A)|0;d[b+(B<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!c)break;else{o=o+4|0;b=b+e|0}}return}function taa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55052;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function uaa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<3)|0;l=+p[a+72>>3];m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(f[a+80>>2]&1|0){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;q=h&-4;r=m;s=c;t=b;while(1){a:do if(g)u=0;else{v=+p[k>>3];w=f[r>>2]|0;if(o){x=0;while(1){y=w+(x<<3)|0;z=l+v*+p[y+8>>3];A=l+v*+p[y+16>>3];B=l+v*+p[y+24>>3];C=MVb(l+v*+p[y>>3])|0;d[s+(x<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=MVb(z)|0;d[s+((x|1)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=MVb(A)|0;d[s+((x|2)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=MVb(B)|0;d[s+((x|3)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<3)|0;B=l+v*+p[x+24>>3];A=l+v*+p[x+16>>3];z=l+v*+p[x+8>>3];E=l+v*+p[x>>3];x=1;while(1){C=(f[r+(x<<2)>>2]|0)+(D<<3)|0;y=(f[r+(0-x<<2)>>2]|0)+(D<<3)|0;F=+p[k+(x<<3)>>3];E=E+F*(+p[C>>3]+ +p[y>>3]);z=z+F*(+p[C+8>>3]+ +p[y+8>>3]);A=A+F*(+p[C+16>>3]+ +p[y+16>>3]);B=B+F*(+p[C+24>>3]+ +p[y+24>>3]);if((x|0)>=(j|0))break;else x=x+1|0}x=MVb(E)|0;d[s+(D<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=MVb(z)|0;d[s+((D|1)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=MVb(A)|0;d[s+((D|2)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=MVb(B)|0;d[s+((D|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+p[k>>3];w=f[r>>2]|0;if(o){x=u;while(1){y=MVb(l+v*+p[w+(x<<3)>>3])|0;d[s+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break b}}else G=u;do{F=l+v*+p[w+(G<<3)>>3];x=1;while(1){F=F+ +p[k+(x<<3)>>3]*(+p[(f[r+(x<<2)>>2]|0)+(G<<3)>>3]+ +p[(f[r+(0-x<<2)>>2]|0)+(G<<3)>>3]);if((x|0)>=(j|0))break;else x=x+1|0}x=MVb(F)|0;d[s+(G<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(n)return;n=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=m;m=b;while(1){c:do if(t)H=0;else{if(s){b=MVb(l)|0;G=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=0;while(1){d[r+(b<<1)>>1]=G;d[r+((b|1)<<1)>>1]=G;d[r+((b|2)<<1)>>1]=G;d[r+((b|3)<<1)>>1]=G;b=b+4|0;if((b|0)>(n|0)){H=i;break c}}}else I=0;do{v=l;B=l;A=l;z=l;b=1;while(1){G=(f[c+(b<<2)>>2]|0)+(I<<3)|0;u=(f[c+(0-b<<2)>>2]|0)+(I<<3)|0;E=+p[k+(b<<3)>>3];z=z+E*(+p[G>>3]-+p[u>>3]);A=A+E*(+p[G+8>>3]-+p[u+8>>3]);B=B+E*(+p[G+16>>3]-+p[u+16>>3]);v=v+E*(+p[G+24>>3]-+p[u+24>>3]);if((b|0)>=(j|0))break;else b=b+1|0}b=MVb(z)|0;d[r+(I<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=MVb(A)|0;d[r+((I|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=MVb(B)|0;d[r+((I|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=MVb(v)|0;d[r+((I|3)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;I=I+4|0}while((I|0)<=(n|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){b=MVb(l)|0;u=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=H;while(1){d[r+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(h|0))break d}}else J=H;do{F=l;b=1;while(1){F=F+ +p[k+(b<<3)>>3]*(+p[(f[c+(b<<2)>>2]|0)+(J<<3)>>3]-+p[(f[c+(0-b<<2)>>2]|0)+(J<<3)>>3]);if((b|0)>=(j|0))break;else b=b+1|0}b=MVb(F)|0;d[r+(J<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;c=c+4|0;m=m+-1|0}}return}function vaa(a){a=a|0;O5b(a);return}function waa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55100;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function yaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55100;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function zaa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+n[a+72>>2];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;o=h&-4;p=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)q=0;else{r=+n[i>>2];g=f[p>>2]|0;if(m)s=0;else{t=0;while(1){u=g+(t<<2)|0;v=j+r*+n[u+4>>2];w=j+r*+n[u+8>>2];x=j+r*+n[u+12>>2];y=LVb(j+r*+n[u>>2])|0;d[b+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=LVb(v)|0;d[b+((t|1)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=LVb(w)|0;d[b+((t|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;y=LVb(x)|0;d[b+((t|3)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+4|0;if((t|0)>(a|0)){q=o;break a}}}do{t=g+(s<<2)|0;x=j+r*+n[t+12>>2];w=j+r*+n[t+8>>2];v=j+r*+n[t+4>>2];z=j+r*+n[t>>2];t=1;do{y=(f[p+(t<<2)>>2]|0)+(s<<2)|0;A=+n[i+(t<<2)>>2];z=z+A*+n[y>>2];v=v+A*+n[y+4>>2];w=w+A*+n[y+8>>2];x=x+A*+n[y+12>>2];t=t+1|0}while((t|0)!=(k|0));t=LVb(z)|0;d[b+(s<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=LVb(v)|0;d[b+((s|1)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=LVb(w)|0;d[b+((s|2)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;t=LVb(x)|0;d[b+((s|3)<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;s=s+4|0}while((s|0)<=(a|0));q=o}while(0);b:do if((q|0)<(h|0)){r=+n[i>>2];g=f[p>>2]|0;if(m)B=q;else{t=q;while(1){y=LVb(j+r*+n[g+(t<<2)>>2])|0;d[b+(t<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;t=t+1|0;if((t|0)==(h|0))break b}}do{A=j+r*+n[g+(B<<2)>>2];t=1;do{A=A+ +n[i+(t<<2)>>2]*+n[(f[p+(t<<2)>>2]|0)+(B<<2)>>2];t=t+1|0}while((t|0)!=(k|0));t=LVb(A)|0;d[b+(B<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!c)break;else{p=p+4|0;b=b+e|0}}return}function Aaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55100;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function Baa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=+n[a+72>>2];m=b+(j<<2)|0;b=g+-1|0;o=(g|0)==0;if(f[a+76>>2]&1|0){if(o)return;a=h+-4|0;g=(h|0)<4;p=(i|0)<2;q=h&-4;r=m;s=c;t=b;while(1){a:do if(g)u=0;else{v=+n[k>>2];w=f[r>>2]|0;if(p){x=0;while(1){y=w+(x<<2)|0;z=l+v*+n[y+4>>2];A=l+v*+n[y+8>>2];B=l+v*+n[y+12>>2];C=LVb(l+v*+n[y>>2])|0;d[s+(x<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=LVb(z)|0;d[s+((x|1)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=LVb(A)|0;d[s+((x|2)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;C=LVb(B)|0;d[s+((x|3)<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<2)|0;B=l+v*+n[x+12>>2];A=l+v*+n[x+8>>2];z=l+v*+n[x+4>>2];E=l+v*+n[x>>2];x=1;while(1){C=(f[r+(x<<2)>>2]|0)+(D<<2)|0;y=(f[r+(0-x<<2)>>2]|0)+(D<<2)|0;F=+n[k+(x<<2)>>2];E=E+F*(+n[C>>2]+ +n[y>>2]);z=z+F*(+n[C+4>>2]+ +n[y+4>>2]);A=A+F*(+n[C+8>>2]+ +n[y+8>>2]);B=B+F*(+n[C+12>>2]+ +n[y+12>>2]);if((x|0)>=(j|0))break;else x=x+1|0}x=LVb(E)|0;d[s+(D<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=LVb(z)|0;d[s+((D|1)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=LVb(A)|0;d[s+((D|2)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;x=LVb(B)|0;d[s+((D|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+n[k>>2];w=f[r>>2]|0;if(p){x=u;while(1){y=LVb(l+v*+n[w+(x<<2)>>2])|0;d[s+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break b}}else G=u;do{F=l+v*+n[w+(G<<2)>>2];x=1;while(1){F=F+ +n[k+(x<<2)>>2]*(+n[(f[r+(x<<2)>>2]|0)+(G<<2)>>2]+ +n[(f[r+(0-x<<2)>>2]|0)+(G<<2)>>2]);if((x|0)>=(j|0))break;else x=x+1|0}x=LVb(F)|0;d[s+(G<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(o)return;o=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=m;m=b;while(1){c:do if(t)H=0;else{if(s){b=LVb(l)|0;G=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=0;while(1){d[r+(b<<1)>>1]=G;d[r+((b|1)<<1)>>1]=G;d[r+((b|2)<<1)>>1]=G;d[r+((b|3)<<1)>>1]=G;b=b+4|0;if((b|0)>(o|0)){H=i;break c}}}else I=0;do{v=l;B=l;A=l;z=l;b=1;while(1){G=(f[c+(b<<2)>>2]|0)+(I<<2)|0;u=(f[c+(0-b<<2)>>2]|0)+(I<<2)|0;E=+n[k+(b<<2)>>2];z=z+E*(+n[G>>2]-+n[u>>2]);A=A+E*(+n[G+4>>2]-+n[u+4>>2]);B=B+E*(+n[G+8>>2]-+n[u+8>>2]);v=v+E*(+n[G+12>>2]-+n[u+12>>2]);if((b|0)>=(j|0))break;else b=b+1|0}b=LVb(z)|0;d[r+(I<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=LVb(A)|0;d[r+((I|1)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=LVb(B)|0;d[r+((I|2)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;b=LVb(v)|0;d[r+((I|3)<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;I=I+4|0}while((I|0)<=(o|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){b=LVb(l)|0;u=((b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768)&65535;b=H;while(1){d[r+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(h|0))break d}}else J=H;do{F=l;b=1;while(1){F=F+ +n[k+(b<<2)>>2]*(+n[(f[c+(b<<2)>>2]|0)+(J<<2)>>2]-+n[(f[c+(0-b<<2)>>2]|0)+(J<<2)>>2]);if((b|0)>=(j|0))break;else b=b+1|0}b=LVb(F)|0;d[r+(J<<1)>>1]=(b+32768|0)>>>0<65536?b:(b|0)>0?32767:32768;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;c=c+4|0;m=m+-1|0}}return}function Caa(a){a=a|0;O5b(a);return}function Daa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Eaa(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=55148;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;n=a+52|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=m;q=a+60|0;r=a+56|0;f[r>>2]=q;f[q>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){q=c+36|0;s=f[q>>2]|0;if(s){t=s+12|0;f[t>>2]=(f[t>>2]|0)+1;t=a+48|0;s=f[t>>2]|0;if((s|0)!=0?(v=s+12|0,s=f[v>>2]|0,f[v>>2]=s+-1,(s|0)==1):0){kL(k);w=t}else w=t}else w=a+48|0;f[w>>2]=0;t=a+28|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[l>>2]|0)>0){s=f[n>>2]|0;n=0;do{f[s+(n<<2)>>2]=0;n=n+1|0;x=f[l>>2]|0}while((n|0)<(x|0));f[k>>2]=f[c>>2];if((x|0)<3)y=13;else y=15}else{f[k>>2]=f[c>>2];y=13}if((y|0)==13){x=f[c+4>>2]|0;if((x|0)<3){f[l>>2]=x;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];x=f[c+44>>2]|0;l=f[r>>2]|0;f[l>>2]=f[x>>2];f[l+4>>2]=f[x+4>>2]}else y=15}if((y|0)==15)jL(k,c);f[t>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[w>>2]=f[q>>2]}}else{q=g+8|0;f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;SP(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;j=MVb(e)|0;f[a+72>>2]=j;if((f[k>>2]&4095|0)==4?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;o=aD(g,77)|0;m=245846;p=o+77|0;do{b[o>>0]=b[m>>0]|0;o=o+1|0;m=m+1|0}while((o|0)<(p|0));bO(-215,g,245924,241836,3251);bD(g);u=h;return}function Faa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55148;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function Gaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55148;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function Haa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;i=f[a+28>>2]|0;j=f[a+72>>2]|0;k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)p=0;else{g=f[i>>2]|0;q=f[o>>2]|0;if(m)r=0;else{s=0;while(1){t=q+(s<<2)|0;u=(Y(f[t>>2]|0,g)|0)+j|0;v=(Y(f[t+4>>2]|0,g)|0)+j|0;w=(Y(f[t+8>>2]|0,g)|0)+j|0;x=(Y(f[t+12>>2]|0,g)|0)+j|0;d[b+(s<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;d[b+((s|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[b+((s|2)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[b+((s|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;s=s+4|0;if((s|0)>(a|0)){p=n;break a}}}do{s=q+(r<<2)|0;x=(Y(f[s>>2]|0,g)|0)+j|0;w=(Y(f[s+4>>2]|0,g)|0)+j|0;v=(Y(f[s+8>>2]|0,g)|0)+j|0;u=(Y(f[s+12>>2]|0,g)|0)+j|0;s=v;v=w;w=x;x=1;do{t=(f[o+(x<<2)>>2]|0)+(r<<2)|0;y=f[i+(x<<2)>>2]|0;w=(Y(f[t>>2]|0,y)|0)+w|0;v=(Y(f[t+4>>2]|0,y)|0)+v|0;s=(Y(f[t+8>>2]|0,y)|0)+s|0;u=(Y(f[t+12>>2]|0,y)|0)+u|0;x=x+1|0}while((x|0)!=(k|0));d[b+(r<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[b+((r|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[b+((r|2)<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[b+((r|3)<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;r=r+4|0}while((r|0)<=(a|0));p=n}while(0);b:do if((p|0)<(h|0)){g=f[i>>2]|0;q=f[o>>2]|0;if(m)z=p;else{x=p;while(1){y=(Y(f[q+(x<<2)>>2]|0,g)|0)+j|0;d[b+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break b}}do{x=(Y(f[q+(z<<2)>>2]|0,g)|0)+j|0;y=1;do{x=(Y(f[(f[o+(y<<2)>>2]|0)+(z<<2)>>2]|0,f[i+(y<<2)>>2]|0)|0)+x|0;y=y+1|0}while((y|0)!=(k|0));d[b+(z<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!c)break;else{o=o+4|0;b=b+e|0}}return}function Iaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55148;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function Jaa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=f[a+72>>2]|0;m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(!(f[a+76>>2]&1)){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;p=h&-4;q=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;r=((l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768)&65535;s=c;t=m;u=b;while(1){a:do if(g)v=0;else{if(o){w=0;while(1){d[s+(w<<1)>>1]=r;d[s+((w|1)<<1)>>1]=r;d[s+((w|2)<<1)>>1]=r;d[s+((w|3)<<1)>>1]=r;w=w+4|0;if((w|0)>(a|0)){v=p;break a}}}else x=0;do{w=l;y=l;z=l;A=l;B=1;while(1){C=(f[t+(B<<2)>>2]|0)+(x<<2)|0;D=(f[t+(0-B<<2)>>2]|0)+(x<<2)|0;E=f[k+(B<<2)>>2]|0;A=(Y((f[C>>2]|0)-(f[D>>2]|0)|0,E)|0)+A|0;z=(Y((f[C+4>>2]|0)-(f[D+4>>2]|0)|0,E)|0)+z|0;y=(Y((f[C+8>>2]|0)-(f[D+8>>2]|0)|0,E)|0)+y|0;w=(Y((f[C+12>>2]|0)-(f[D+12>>2]|0)|0,E)|0)+w|0;if((B|0)>=(j|0))break;else B=B+1|0}d[s+(x<<1)>>1]=(A+32768|0)>>>0<65536?A:(A|0)>0?32767:32768;d[s+((x|1)<<1)>>1]=(z+32768|0)>>>0<65536?z:(z|0)>0?32767:32768;d[s+((x|2)<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;d[s+((x|3)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;x=x+4|0}while((x|0)<=(a|0));v=p}while(0);b:do if((v|0)<(h|0)){if(o){B=v;while(1){d[s+(B<<1)>>1]=q;B=B+1|0;if((B|0)==(h|0))break b}}else F=v;do{B=l;E=1;while(1){B=(Y((f[(f[t+(E<<2)>>2]|0)+(F<<2)>>2]|0)-(f[(f[t+(0-E<<2)>>2]|0)+(F<<2)>>2]|0)|0,f[k+(E<<2)>>2]|0)|0)+B|0;if((E|0)>=(j|0))break;else E=E+1|0}d[s+(F<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;F=F+1|0}while((F|0)!=(h|0))}while(0);if(!u)break;else{s=s+e|0;t=t+4|0;u=u+-1|0}}return}else{if(n)return;n=h+-4|0;u=(h|0)<4;t=(i|0)<2;i=h&-4;s=m;m=c;c=b;while(1){c:do if(u)G=0;else{b=f[k>>2]|0;F=f[s>>2]|0;if(t){v=0;while(1){q=F+(v<<2)|0;o=(Y(f[q>>2]|0,b)|0)+l|0;p=(Y(f[q+4>>2]|0,b)|0)+l|0;a=(Y(f[q+8>>2]|0,b)|0)+l|0;x=(Y(f[q+12>>2]|0,b)|0)+l|0;d[m+(v<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;d[m+((v|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[m+((v|2)<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[m+((v|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;v=v+4|0;if((v|0)>(n|0)){G=i;break c}}}else H=0;do{v=F+(H<<2)|0;x=(Y(f[v>>2]|0,b)|0)+l|0;a=(Y(f[v+4>>2]|0,b)|0)+l|0;p=(Y(f[v+8>>2]|0,b)|0)+l|0;o=(Y(f[v+12>>2]|0,b)|0)+l|0;v=p;p=a;a=x;x=1;while(1){q=(f[s+(x<<2)>>2]|0)+(H<<2)|0;r=(f[s+(0-x<<2)>>2]|0)+(H<<2)|0;g=f[k+(x<<2)>>2]|0;a=(Y((f[r>>2]|0)+(f[q>>2]|0)|0,g)|0)+a|0;p=(Y((f[r+4>>2]|0)+(f[q+4>>2]|0)|0,g)|0)+p|0;v=(Y((f[r+8>>2]|0)+(f[q+8>>2]|0)|0,g)|0)+v|0;o=(Y((f[r+12>>2]|0)+(f[q+12>>2]|0)|0,g)|0)+o|0;if((x|0)>=(j|0))break;else x=x+1|0}d[m+(H<<1)>>1]=(a+32768|0)>>>0<65536?a:(a|0)>0?32767:32768;d[m+((H|1)<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[m+((H|2)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[m+((H|3)<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;H=H+4|0}while((H|0)<=(n|0));G=i}while(0);d:do if((G|0)<(h|0)){b=f[k>>2]|0;F=f[s>>2]|0;if(t){x=G;while(1){B=(Y(f[F+(x<<2)>>2]|0,b)|0)+l|0;d[m+(x<<1)>>1]=(B+32768|0)>>>0<65536?B:(B|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break d}}else I=G;do{x=(Y(f[F+(I<<2)>>2]|0,b)|0)+l|0;B=1;while(1){x=(Y((f[(f[s+(0-B<<2)>>2]|0)+(I<<2)>>2]|0)+(f[(f[s+(B<<2)>>2]|0)+(I<<2)>>2]|0)|0,f[k+(B<<2)>>2]|0)|0)+x|0;if((B|0)>=(j|0))break;else B=B+1|0}d[m+(I<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!c)break;else{s=s+4|0;m=m+e|0;c=c+-1|0}}return}}function Kaa(a){a=a|0;O5b(a);return}function Laa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Maa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55196;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function Naa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55196;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function Oaa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+p[a+72>>3];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)q=0;else{r=+p[i>>3];g=f[o>>2]|0;if(m)s=0;else{t=0;while(1){u=g+(t<<3)|0;v=j+r*+p[u+8>>3];w=j+r*+p[u+16>>3];x=j+r*+p[u+24>>3];y=MVb(j+r*+p[u>>3])|0;d[b+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=MVb(v)|0;d[b+((t|1)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=MVb(w)|0;d[b+((t|2)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=MVb(x)|0;d[b+((t|3)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+4|0;if((t|0)>(a|0)){q=n;break a}}}do{t=g+(s<<3)|0;x=j+r*+p[t+24>>3];w=j+r*+p[t+16>>3];v=j+r*+p[t+8>>3];z=j+r*+p[t>>3];t=1;do{y=(f[o+(t<<2)>>2]|0)+(s<<3)|0;A=+p[i+(t<<3)>>3];z=z+A*+p[y>>3];v=v+A*+p[y+8>>3];w=w+A*+p[y+16>>3];x=x+A*+p[y+24>>3];t=t+1|0}while((t|0)!=(k|0));t=MVb(z)|0;d[b+(s<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=MVb(v)|0;d[b+((s|1)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=MVb(w)|0;d[b+((s|2)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=MVb(x)|0;d[b+((s|3)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;s=s+4|0}while((s|0)<=(a|0));q=n}while(0);b:do if((q|0)<(h|0)){r=+p[i>>3];g=f[o>>2]|0;if(m)B=q;else{t=q;while(1){y=MVb(j+r*+p[g+(t<<3)>>3])|0;d[b+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+1|0;if((t|0)==(h|0))break b}}do{A=j+r*+p[g+(B<<3)>>3];t=1;do{A=A+ +p[i+(t<<3)>>3]*+p[(f[o+(t<<2)>>2]|0)+(B<<3)>>3];t=t+1|0}while((t|0)!=(k|0));t=MVb(A)|0;d[b+(B<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!c)break;else{o=o+4|0;b=b+e|0}}return}function Paa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55196;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function Qaa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<3)|0;l=+p[a+72>>3];m=b+(j<<2)|0;b=g+-1|0;n=(g|0)==0;if(f[a+80>>2]&1|0){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;q=h&-4;r=m;s=c;t=b;while(1){a:do if(g)u=0;else{v=+p[k>>3];w=f[r>>2]|0;if(o){x=0;while(1){y=w+(x<<3)|0;z=l+v*+p[y+8>>3];A=l+v*+p[y+16>>3];B=l+v*+p[y+24>>3];C=MVb(l+v*+p[y>>3])|0;d[s+(x<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=MVb(z)|0;d[s+((x|1)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=MVb(A)|0;d[s+((x|2)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=MVb(B)|0;d[s+((x|3)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<3)|0;B=l+v*+p[x+24>>3];A=l+v*+p[x+16>>3];z=l+v*+p[x+8>>3];E=l+v*+p[x>>3];x=1;while(1){C=(f[r+(x<<2)>>2]|0)+(D<<3)|0;y=(f[r+(0-x<<2)>>2]|0)+(D<<3)|0;F=+p[k+(x<<3)>>3];E=E+F*(+p[C>>3]+ +p[y>>3]);z=z+F*(+p[C+8>>3]+ +p[y+8>>3]);A=A+F*(+p[C+16>>3]+ +p[y+16>>3]);B=B+F*(+p[C+24>>3]+ +p[y+24>>3]);if((x|0)>=(j|0))break;else x=x+1|0}x=MVb(E)|0;d[s+(D<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=MVb(z)|0;d[s+((D|1)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=MVb(A)|0;d[s+((D|2)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=MVb(B)|0;d[s+((D|3)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+p[k>>3];w=f[r>>2]|0;if(o){x=u;while(1){y=MVb(l+v*+p[w+(x<<3)>>3])|0;d[s+(x<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;x=x+1|0;if((x|0)==(h|0))break b}}else G=u;do{F=l+v*+p[w+(G<<3)>>3];x=1;while(1){F=F+ +p[k+(x<<3)>>3]*(+p[(f[r+(x<<2)>>2]|0)+(G<<3)>>3]+ +p[(f[r+(0-x<<2)>>2]|0)+(G<<3)>>3]);if((x|0)>=(j|0))break;else x=x+1|0}x=MVb(F)|0;d[s+(G<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(n)return;n=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=m;m=b;while(1){c:do if(t)H=0;else{if(s){b=MVb(l)|0;G=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=0;while(1){d[r+(b<<1)>>1]=G;d[r+((b|1)<<1)>>1]=G;d[r+((b|2)<<1)>>1]=G;d[r+((b|3)<<1)>>1]=G;b=b+4|0;if((b|0)>(n|0)){H=i;break c}}}else I=0;do{v=l;B=l;A=l;z=l;b=1;while(1){G=(f[c+(b<<2)>>2]|0)+(I<<3)|0;u=(f[c+(0-b<<2)>>2]|0)+(I<<3)|0;E=+p[k+(b<<3)>>3];z=z+E*(+p[G>>3]-+p[u>>3]);A=A+E*(+p[G+8>>3]-+p[u+8>>3]);B=B+E*(+p[G+16>>3]-+p[u+16>>3]);v=v+E*(+p[G+24>>3]-+p[u+24>>3]);if((b|0)>=(j|0))break;else b=b+1|0}b=MVb(z)|0;d[r+(I<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=MVb(A)|0;d[r+((I|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=MVb(B)|0;d[r+((I|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=MVb(v)|0;d[r+((I|3)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;I=I+4|0}while((I|0)<=(n|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){b=MVb(l)|0;u=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=H;while(1){d[r+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(h|0))break d}}else J=H;do{F=l;b=1;while(1){F=F+ +p[k+(b<<3)>>3]*(+p[(f[c+(b<<2)>>2]|0)+(J<<3)>>3]-+p[(f[c+(0-b<<2)>>2]|0)+(J<<3)>>3]);if((b|0)>=(j|0))break;else b=b+1|0}b=MVb(F)|0;d[r+(J<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;c=c+4|0;m=m+-1|0}}return}function Raa(a){a=a|0;O5b(a);return}function Saa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Taa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55244;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function Uaa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55244;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function Vaa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0,B=0;i=f[a+28>>2]|0;j=+n[a+72>>2];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;o=h&-4;p=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)q=0;else{r=+n[i>>2];g=f[p>>2]|0;if(m)s=0;else{t=0;while(1){u=g+(t<<2)|0;v=j+r*+n[u+4>>2];w=j+r*+n[u+8>>2];x=j+r*+n[u+12>>2];y=LVb(j+r*+n[u>>2])|0;d[b+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=LVb(v)|0;d[b+((t|1)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=LVb(w)|0;d[b+((t|2)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;y=LVb(x)|0;d[b+((t|3)<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+4|0;if((t|0)>(a|0)){q=o;break a}}}do{t=g+(s<<2)|0;x=j+r*+n[t+12>>2];w=j+r*+n[t+8>>2];v=j+r*+n[t+4>>2];z=j+r*+n[t>>2];t=1;do{y=(f[p+(t<<2)>>2]|0)+(s<<2)|0;A=+n[i+(t<<2)>>2];z=z+A*+n[y>>2];v=v+A*+n[y+4>>2];w=w+A*+n[y+8>>2];x=x+A*+n[y+12>>2];t=t+1|0}while((t|0)!=(k|0));t=LVb(z)|0;d[b+(s<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=LVb(v)|0;d[b+((s|1)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=LVb(w)|0;d[b+((s|2)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;t=LVb(x)|0;d[b+((s|3)<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;s=s+4|0}while((s|0)<=(a|0));q=o}while(0);b:do if((q|0)<(h|0)){r=+n[i>>2];g=f[p>>2]|0;if(m)B=q;else{t=q;while(1){y=LVb(j+r*+n[g+(t<<2)>>2])|0;d[b+(t<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;t=t+1|0;if((t|0)==(h|0))break b}}do{A=j+r*+n[g+(B<<2)>>2];t=1;do{A=A+ +n[i+(t<<2)>>2]*+n[(f[p+(t<<2)>>2]|0)+(B<<2)>>2];t=t+1|0}while((t|0)!=(k|0));t=LVb(A)|0;d[b+(B<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;B=B+1|0}while((B|0)!=(h|0))}while(0);if(!c)break;else{p=p+4|0;b=b+e|0}}return}function Waa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55244;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function Xaa(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=+n[a+72>>2];m=b+(j<<2)|0;b=g+-1|0;o=(g|0)==0;if(f[a+76>>2]&1|0){if(o)return;a=h+-4|0;g=(h|0)<4;p=(i|0)<2;q=h&-4;r=m;s=c;t=b;while(1){a:do if(g)u=0;else{v=+n[k>>2];w=f[r>>2]|0;if(p){x=0;while(1){y=w+(x<<2)|0;z=l+v*+n[y+4>>2];A=l+v*+n[y+8>>2];B=l+v*+n[y+12>>2];C=LVb(l+v*+n[y>>2])|0;d[s+(x<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=LVb(z)|0;d[s+((x|1)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=LVb(A)|0;d[s+((x|2)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;C=LVb(B)|0;d[s+((x|3)<<1)>>1]=C>>>0<65536?C:(C|0)>0?65535:0;x=x+4|0;if((x|0)>(a|0)){u=q;break a}}}else D=0;do{x=w+(D<<2)|0;B=l+v*+n[x+12>>2];A=l+v*+n[x+8>>2];z=l+v*+n[x+4>>2];E=l+v*+n[x>>2];x=1;while(1){C=(f[r+(x<<2)>>2]|0)+(D<<2)|0;y=(f[r+(0-x<<2)>>2]|0)+(D<<2)|0;F=+n[k+(x<<2)>>2];E=E+F*(+n[C>>2]+ +n[y>>2]);z=z+F*(+n[C+4>>2]+ +n[y+4>>2]);A=A+F*(+n[C+8>>2]+ +n[y+8>>2]);B=B+F*(+n[C+12>>2]+ +n[y+12>>2]);if((x|0)>=(j|0))break;else x=x+1|0}x=LVb(E)|0;d[s+(D<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=LVb(z)|0;d[s+((D|1)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=LVb(A)|0;d[s+((D|2)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;x=LVb(B)|0;d[s+((D|3)<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;D=D+4|0}while((D|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){v=+n[k>>2];w=f[r>>2]|0;if(p){x=u;while(1){y=LVb(l+v*+n[w+(x<<2)>>2])|0;d[s+(x<<1)>>1]=y>>>0<65536?y:(y|0)>0?65535:0;x=x+1|0;if((x|0)==(h|0))break b}}else G=u;do{F=l+v*+n[w+(G<<2)>>2];x=1;while(1){F=F+ +n[k+(x<<2)>>2]*(+n[(f[r+(x<<2)>>2]|0)+(G<<2)>>2]+ +n[(f[r+(0-x<<2)>>2]|0)+(G<<2)>>2]);if((x|0)>=(j|0))break;else x=x+1|0}x=LVb(F)|0;d[s+(G<<1)>>1]=x>>>0<65536?x:(x|0)>0?65535:0;G=G+1|0}while((G|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(o)return;o=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=c;c=m;m=b;while(1){c:do if(t)H=0;else{if(s){b=LVb(l)|0;G=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=0;while(1){d[r+(b<<1)>>1]=G;d[r+((b|1)<<1)>>1]=G;d[r+((b|2)<<1)>>1]=G;d[r+((b|3)<<1)>>1]=G;b=b+4|0;if((b|0)>(o|0)){H=i;break c}}}else I=0;do{v=l;B=l;A=l;z=l;b=1;while(1){G=(f[c+(b<<2)>>2]|0)+(I<<2)|0;u=(f[c+(0-b<<2)>>2]|0)+(I<<2)|0;E=+n[k+(b<<2)>>2];z=z+E*(+n[G>>2]-+n[u>>2]);A=A+E*(+n[G+4>>2]-+n[u+4>>2]);B=B+E*(+n[G+8>>2]-+n[u+8>>2]);v=v+E*(+n[G+12>>2]-+n[u+12>>2]);if((b|0)>=(j|0))break;else b=b+1|0}b=LVb(z)|0;d[r+(I<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=LVb(A)|0;d[r+((I|1)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=LVb(B)|0;d[r+((I|2)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;b=LVb(v)|0;d[r+((I|3)<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;I=I+4|0}while((I|0)<=(o|0));H=i}while(0);d:do if((H|0)<(h|0)){if(s){b=LVb(l)|0;u=(b>>>0<65536?b:(b|0)>0?65535:0)&65535;b=H;while(1){d[r+(b<<1)>>1]=u;b=b+1|0;if((b|0)==(h|0))break d}}else J=H;do{F=l;b=1;while(1){F=F+ +n[k+(b<<2)>>2]*(+n[(f[c+(b<<2)>>2]|0)+(J<<2)>>2]-+n[(f[c+(0-b<<2)>>2]|0)+(J<<2)>>2]);if((b|0)>=(j|0))break;else b=b+1|0}b=LVb(F)|0;d[r+(J<<1)>>1]=b>>>0<65536?b:(b|0)>0?65535:0;J=J+1|0}while((J|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;c=c+4|0;m=m+-1|0}}return}function Yaa(a){a=a|0;O5b(a);return}function Zaa(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function _aa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55292;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function $aa(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55292;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function aba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0;i=f[a+28>>2]|0;j=+p[a+72>>3];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=c;c=d;d=g;while(1){d=d+-1|0;a:do if(l)q=0;else{if(m)r=0;else{g=0;while(1){s=+p[i>>3];t=(f[o>>2]|0)+(g<<3)|0;u=j+s*+p[t+8>>3];v=j+s*+p[t+16>>3];w=j+s*+p[t+24>>3];x=MVb(j+s*+p[t>>3])|0;b[c+g>>0]=x>>>0<256?x:(x|0)>0?255:0;x=MVb(u)|0;b[c+(g|1)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=MVb(v)|0;b[c+(g|2)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=MVb(w)|0;b[c+(g|3)>>0]=x>>>0<256?x:(x|0)>0?255:0;g=g+4|0;if((g|0)>(a|0)){q=n;break a}}}do{w=+p[i>>3];g=(f[o>>2]|0)+(r<<3)|0;v=j+w*+p[g+24>>3];u=j+w*+p[g+16>>3];s=j+w*+p[g+8>>3];y=j+w*+p[g>>3];g=1;do{x=(f[o+(g<<2)>>2]|0)+(r<<3)|0;w=+p[i+(g<<3)>>3];y=y+w*+p[x>>3];s=s+w*+p[x+8>>3];u=u+w*+p[x+16>>3];v=v+w*+p[x+24>>3];g=g+1|0}while((g|0)!=(k|0));g=MVb(y)|0;b[c+r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=MVb(s)|0;b[c+(r|1)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=MVb(u)|0;b[c+(r|2)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=MVb(v)|0;b[c+(r|3)>>0]=g>>>0<256?g:(g|0)>0?255:0;r=r+4|0}while((r|0)<=(a|0));q=n}while(0);b:do if((q|0)<(h|0)){if(m)z=q;else{g=q;while(1){x=MVb(j+ +p[i>>3]*+p[(f[o>>2]|0)+(g<<3)>>3])|0;b[c+g>>0]=x>>>0<256?x:(x|0)>0?255:0;g=g+1|0;if((g|0)==(h|0))break b}}do{w=j+ +p[i>>3]*+p[(f[o>>2]|0)+(z<<3)>>3];g=1;do{w=w+ +p[i+(g<<3)>>3]*+p[(f[o+(g<<2)>>2]|0)+(z<<3)>>3];g=g+1|0}while((g|0)!=(k|0));g=MVb(w)|0;b[c+z>>0]=g>>>0<256?g:(g|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!d)break;else{o=o+4|0;c=c+e|0}}return}function bba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55292;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function cba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<3)|0;l=+p[a+72>>3];m=c+(j<<2)|0;c=g+-1|0;n=(g|0)==0;if(f[a+80>>2]&1|0){if(n)return;a=h+-4|0;g=(h|0)<4;o=(i|0)<2;q=h&-4;r=m;s=d;t=c;while(1){a:do if(g)u=0;else{if(o){v=0;while(1){w=+p[k>>3];x=(f[r>>2]|0)+(v<<3)|0;y=l+w*+p[x+8>>3];z=l+w*+p[x+16>>3];A=l+w*+p[x+24>>3];B=MVb(l+w*+p[x>>3])|0;b[s+v>>0]=B>>>0<256?B:(B|0)>0?255:0;B=MVb(y)|0;b[s+(v|1)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=MVb(z)|0;b[s+(v|2)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=MVb(A)|0;b[s+(v|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;v=v+4|0;if((v|0)>(a|0)){u=q;break a}}}else C=0;do{A=+p[k>>3];v=(f[r>>2]|0)+(C<<3)|0;z=l+A*+p[v+24>>3];y=l+A*+p[v+16>>3];w=l+A*+p[v+8>>3];D=l+A*+p[v>>3];v=1;while(1){B=(f[r+(v<<2)>>2]|0)+(C<<3)|0;x=(f[r+(0-v<<2)>>2]|0)+(C<<3)|0;A=+p[k+(v<<3)>>3];D=D+A*(+p[B>>3]+ +p[x>>3]);w=w+A*(+p[B+8>>3]+ +p[x+8>>3]);y=y+A*(+p[B+16>>3]+ +p[x+16>>3]);z=z+A*(+p[B+24>>3]+ +p[x+24>>3]);if((v|0)>=(j|0))break;else v=v+1|0}v=MVb(D)|0;b[s+C>>0]=v>>>0<256?v:(v|0)>0?255:0;v=MVb(w)|0;b[s+(C|1)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=MVb(y)|0;b[s+(C|2)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=MVb(z)|0;b[s+(C|3)>>0]=v>>>0<256?v:(v|0)>0?255:0;C=C+4|0}while((C|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){if(o){v=u;while(1){x=MVb(l+ +p[k>>3]*+p[(f[r>>2]|0)+(v<<3)>>3])|0;b[s+v>>0]=x>>>0<256?x:(x|0)>0?255:0;v=v+1|0;if((v|0)==(h|0))break b}}else E=u;do{A=l+ +p[k>>3]*+p[(f[r>>2]|0)+(E<<3)>>3];v=1;while(1){A=A+ +p[k+(v<<3)>>3]*(+p[(f[r+(v<<2)>>2]|0)+(E<<3)>>3]+ +p[(f[r+(0-v<<2)>>2]|0)+(E<<3)>>3]);if((v|0)>=(j|0))break;else v=v+1|0}v=MVb(A)|0;b[s+E>>0]=v>>>0<256?v:(v|0)>0?255:0;E=E+1|0}while((E|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(n)return;n=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=d;d=m;m=c;while(1){c:do if(t)F=0;else{if(s){c=MVb(l)|0;E=(c>>>0<256?c:(c|0)>0?255:0)&255;c=0;while(1){b[r+c>>0]=E;b[r+(c|1)>>0]=E;b[r+(c|2)>>0]=E;b[r+(c|3)>>0]=E;c=c+4|0;if((c|0)>(n|0)){F=i;break c}}}else G=0;do{z=l;y=l;w=l;D=l;c=1;while(1){E=(f[d+(c<<2)>>2]|0)+(G<<3)|0;u=(f[d+(0-c<<2)>>2]|0)+(G<<3)|0;H=+p[k+(c<<3)>>3];D=D+H*(+p[E>>3]-+p[u>>3]);w=w+H*(+p[E+8>>3]-+p[u+8>>3]);y=y+H*(+p[E+16>>3]-+p[u+16>>3]);z=z+H*(+p[E+24>>3]-+p[u+24>>3]);if((c|0)>=(j|0))break;else c=c+1|0}c=MVb(D)|0;b[r+G>>0]=c>>>0<256?c:(c|0)>0?255:0;c=MVb(w)|0;b[r+(G|1)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=MVb(y)|0;b[r+(G|2)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=MVb(z)|0;b[r+(G|3)>>0]=c>>>0<256?c:(c|0)>0?255:0;G=G+4|0}while((G|0)<=(n|0));F=i}while(0);d:do if((F|0)<(h|0)){if(s){c=MVb(l)|0;u=(c>>>0<256?c:(c|0)>0?255:0)&255;c=F;while(1){b[r+c>>0]=u;c=c+1|0;if((c|0)==(h|0))break d}}else I=F;do{A=l;c=1;while(1){A=A+ +p[k+(c<<3)>>3]*(+p[(f[d+(c<<2)>>2]|0)+(I<<3)>>3]-+p[(f[d+(0-c<<2)>>2]|0)+(I<<3)>>3]);if((c|0)>=(j|0))break;else c=c+1|0}c=MVb(A)|0;b[r+I>>0]=c>>>0<256?c:(c|0)>0?255:0;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;d=d+4|0;m=m+-1|0}}return}function dba(a){a=a|0;O5b(a);return}function eba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function fba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55340;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function gba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55340;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function hba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0.0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0;i=f[a+28>>2]|0;j=+n[a+72>>2];k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;o=h&-4;p=c;c=d;d=g;while(1){d=d+-1|0;a:do if(l)q=0;else{if(m)r=0;else{g=0;while(1){s=+n[i>>2];t=(f[p>>2]|0)+(g<<2)|0;u=j+s*+n[t+4>>2];v=j+s*+n[t+8>>2];w=j+s*+n[t+12>>2];x=LVb(j+s*+n[t>>2])|0;b[c+g>>0]=x>>>0<256?x:(x|0)>0?255:0;x=LVb(u)|0;b[c+(g|1)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=LVb(v)|0;b[c+(g|2)>>0]=x>>>0<256?x:(x|0)>0?255:0;x=LVb(w)|0;b[c+(g|3)>>0]=x>>>0<256?x:(x|0)>0?255:0;g=g+4|0;if((g|0)>(a|0)){q=o;break a}}}do{w=+n[i>>2];g=(f[p>>2]|0)+(r<<2)|0;v=j+w*+n[g+12>>2];u=j+w*+n[g+8>>2];s=j+w*+n[g+4>>2];y=j+w*+n[g>>2];g=1;do{x=(f[p+(g<<2)>>2]|0)+(r<<2)|0;w=+n[i+(g<<2)>>2];y=y+w*+n[x>>2];s=s+w*+n[x+4>>2];u=u+w*+n[x+8>>2];v=v+w*+n[x+12>>2];g=g+1|0}while((g|0)!=(k|0));g=LVb(y)|0;b[c+r>>0]=g>>>0<256?g:(g|0)>0?255:0;g=LVb(s)|0;b[c+(r|1)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=LVb(u)|0;b[c+(r|2)>>0]=g>>>0<256?g:(g|0)>0?255:0;g=LVb(v)|0;b[c+(r|3)>>0]=g>>>0<256?g:(g|0)>0?255:0;r=r+4|0}while((r|0)<=(a|0));q=o}while(0);b:do if((q|0)<(h|0)){if(m)z=q;else{g=q;while(1){x=LVb(j+ +n[i>>2]*+n[(f[p>>2]|0)+(g<<2)>>2])|0;b[c+g>>0]=x>>>0<256?x:(x|0)>0?255:0;g=g+1|0;if((g|0)==(h|0))break b}}do{w=j+ +n[i>>2]*+n[(f[p>>2]|0)+(z<<2)>>2];g=1;do{w=w+ +n[i+(g<<2)>>2]*+n[(f[p+(g<<2)>>2]|0)+(z<<2)>>2];g=g+1|0}while((g|0)!=(k|0));g=LVb(w)|0;b[c+z>>0]=g>>>0<256?g:(g|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!d)break;else{p=p+4|0;c=c+e|0}}return}function iba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55340;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function jba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=+n[a+72>>2];m=c+(j<<2)|0;c=g+-1|0;o=(g|0)==0;if(f[a+76>>2]&1|0){if(o)return;a=h+-4|0;g=(h|0)<4;p=(i|0)<2;q=h&-4;r=m;s=d;t=c;while(1){a:do if(g)u=0;else{if(p){v=0;while(1){w=+n[k>>2];x=(f[r>>2]|0)+(v<<2)|0;y=l+w*+n[x+4>>2];z=l+w*+n[x+8>>2];A=l+w*+n[x+12>>2];B=LVb(l+w*+n[x>>2])|0;b[s+v>>0]=B>>>0<256?B:(B|0)>0?255:0;B=LVb(y)|0;b[s+(v|1)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=LVb(z)|0;b[s+(v|2)>>0]=B>>>0<256?B:(B|0)>0?255:0;B=LVb(A)|0;b[s+(v|3)>>0]=B>>>0<256?B:(B|0)>0?255:0;v=v+4|0;if((v|0)>(a|0)){u=q;break a}}}else C=0;do{A=+n[k>>2];v=(f[r>>2]|0)+(C<<2)|0;z=l+A*+n[v+12>>2];y=l+A*+n[v+8>>2];w=l+A*+n[v+4>>2];D=l+A*+n[v>>2];v=1;while(1){B=(f[r+(v<<2)>>2]|0)+(C<<2)|0;x=(f[r+(0-v<<2)>>2]|0)+(C<<2)|0;A=+n[k+(v<<2)>>2];D=D+A*(+n[B>>2]+ +n[x>>2]);w=w+A*(+n[B+4>>2]+ +n[x+4>>2]);y=y+A*(+n[B+8>>2]+ +n[x+8>>2]);z=z+A*(+n[B+12>>2]+ +n[x+12>>2]);if((v|0)>=(j|0))break;else v=v+1|0}v=LVb(D)|0;b[s+C>>0]=v>>>0<256?v:(v|0)>0?255:0;v=LVb(w)|0;b[s+(C|1)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=LVb(y)|0;b[s+(C|2)>>0]=v>>>0<256?v:(v|0)>0?255:0;v=LVb(z)|0;b[s+(C|3)>>0]=v>>>0<256?v:(v|0)>0?255:0;C=C+4|0}while((C|0)<=(a|0));u=q}while(0);b:do if((u|0)<(h|0)){if(p){v=u;while(1){x=LVb(l+ +n[k>>2]*+n[(f[r>>2]|0)+(v<<2)>>2])|0;b[s+v>>0]=x>>>0<256?x:(x|0)>0?255:0;v=v+1|0;if((v|0)==(h|0))break b}}else E=u;do{A=l+ +n[k>>2]*+n[(f[r>>2]|0)+(E<<2)>>2];v=1;while(1){A=A+ +n[k+(v<<2)>>2]*(+n[(f[r+(v<<2)>>2]|0)+(E<<2)>>2]+ +n[(f[r+(0-v<<2)>>2]|0)+(E<<2)>>2]);if((v|0)>=(j|0))break;else v=v+1|0}v=LVb(A)|0;b[s+E>>0]=v>>>0<256?v:(v|0)>0?255:0;E=E+1|0}while((E|0)!=(h|0))}while(0);if(!t)break;else{r=r+4|0;s=s+e|0;t=t+-1|0}}return}if(o)return;o=h+-4|0;t=(h|0)<4;s=(i|0)<2;i=h&-4;r=d;d=m;m=c;while(1){c:do if(t)F=0;else{if(s){c=LVb(l)|0;E=(c>>>0<256?c:(c|0)>0?255:0)&255;c=0;while(1){b[r+c>>0]=E;b[r+(c|1)>>0]=E;b[r+(c|2)>>0]=E;b[r+(c|3)>>0]=E;c=c+4|0;if((c|0)>(o|0)){F=i;break c}}}else G=0;do{z=l;y=l;w=l;D=l;c=1;while(1){E=(f[d+(c<<2)>>2]|0)+(G<<2)|0;u=(f[d+(0-c<<2)>>2]|0)+(G<<2)|0;H=+n[k+(c<<2)>>2];D=D+H*(+n[E>>2]-+n[u>>2]);w=w+H*(+n[E+4>>2]-+n[u+4>>2]);y=y+H*(+n[E+8>>2]-+n[u+8>>2]);z=z+H*(+n[E+12>>2]-+n[u+12>>2]);if((c|0)>=(j|0))break;else c=c+1|0}c=LVb(D)|0;b[r+G>>0]=c>>>0<256?c:(c|0)>0?255:0;c=LVb(w)|0;b[r+(G|1)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=LVb(y)|0;b[r+(G|2)>>0]=c>>>0<256?c:(c|0)>0?255:0;c=LVb(z)|0;b[r+(G|3)>>0]=c>>>0<256?c:(c|0)>0?255:0;G=G+4|0}while((G|0)<=(o|0));F=i}while(0);d:do if((F|0)<(h|0)){if(s){c=LVb(l)|0;u=(c>>>0<256?c:(c|0)>0?255:0)&255;c=F;while(1){b[r+c>>0]=u;c=c+1|0;if((c|0)==(h|0))break d}}else I=F;do{A=l;c=1;while(1){A=A+ +n[k+(c<<2)>>2]*(+n[(f[d+(c<<2)>>2]|0)+(I<<2)>>2]-+n[(f[d+(0-c<<2)>>2]|0)+(I<<2)>>2]);if((c|0)>=(j|0))break;else c=c+1|0}c=LVb(A)|0;b[r+I>>0]=c>>>0<256?c:(c|0)>0?255:0;I=I+1|0}while((I|0)!=(h|0))}while(0);if(!m)break;else{r=r+e|0;d=d+4|0;m=m+-1|0}}return}function kba(a){a=a|0;O5b(a);return}function lba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function mba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55388;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function nba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55388;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function oba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;i=f[a+28>>2]|0;j=f[a+80>>2]|0;k=f[a+4>>2]|0;l=a+68|0;a=f[l>>2]|0;m=f[l+4>>2]|0;if(!g)return;l=h+-4|0;n=(h|0)<4;o=(k|0)>1;p=h&-4;q=c;c=d;d=g;while(1){d=d+-1|0;a:do if(n)r=0;else{if(o)s=0;else{g=0;while(1){t=f[i>>2]|0;u=(f[q>>2]|0)+(g<<2)|0;v=(Y(f[u>>2]|0,t)|0)+j|0;w=(Y(f[u+4>>2]|0,t)|0)+j|0;x=(Y(f[u+8>>2]|0,t)|0)+j|0;y=(Y(f[u+12>>2]|0,t)|0)+j|0;t=v+m>>a;b[c+g>>0]=t>>>0<256?t:(t|0)>0?255:0;t=w+m>>a;b[c+(g|1)>>0]=t>>>0<256?t:(t|0)>0?255:0;t=x+m>>a;b[c+(g|2)>>0]=t>>>0<256?t:(t|0)>0?255:0;t=y+m>>a;b[c+(g|3)>>0]=t>>>0<256?t:(t|0)>0?255:0;g=g+4|0;if((g|0)>(l|0)){r=p;break a}}}do{g=f[i>>2]|0;t=(f[q>>2]|0)+(s<<2)|0;y=(Y(f[t>>2]|0,g)|0)+j|0;x=(Y(f[t+4>>2]|0,g)|0)+j|0;w=(Y(f[t+8>>2]|0,g)|0)+j|0;v=(Y(f[t+12>>2]|0,g)|0)+j|0;g=w;w=x;x=y;y=1;do{t=(f[q+(y<<2)>>2]|0)+(s<<2)|0;u=f[i+(y<<2)>>2]|0;x=(Y(f[t>>2]|0,u)|0)+x|0;w=(Y(f[t+4>>2]|0,u)|0)+w|0;g=(Y(f[t+8>>2]|0,u)|0)+g|0;v=(Y(f[t+12>>2]|0,u)|0)+v|0;y=y+1|0}while((y|0)!=(k|0));y=x+m>>a;b[c+s>>0]=y>>>0<256?y:(y|0)>0?255:0;y=w+m>>a;b[c+(s|1)>>0]=y>>>0<256?y:(y|0)>0?255:0;y=g+m>>a;b[c+(s|2)>>0]=y>>>0<256?y:(y|0)>0?255:0;y=v+m>>a;b[c+(s|3)>>0]=y>>>0<256?y:(y|0)>0?255:0;s=s+4|0}while((s|0)<=(l|0));r=p}while(0);b:do if((r|0)<(h|0)){if(o)z=r;else{y=r;while(1){u=(Y(f[(f[q>>2]|0)+(y<<2)>>2]|0,f[i>>2]|0)|0)+j+m>>a;b[c+y>>0]=u>>>0<256?u:(u|0)>0?255:0;y=y+1|0;if((y|0)==(h|0))break b}}do{y=(Y(f[(f[q>>2]|0)+(z<<2)>>2]|0,f[i>>2]|0)|0)+j|0;u=1;do{y=(Y(f[(f[q+(u<<2)>>2]|0)+(z<<2)>>2]|0,f[i+(u<<2)>>2]|0)|0)+y|0;u=u+1|0}while((u|0)!=(k|0));u=y+m>>a;b[c+z>>0]=u>>>0<256?u:(u|0)>0?255:0;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!d)break;else{q=q+4|0;c=c+e|0}}return}function pba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55388;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function qba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=f[a+4>>2]|0;j=(i|0)/2|0;k=(f[a+28>>2]|0)+(j<<2)|0;l=f[a+80>>2]|0;m=a+68|0;n=f[m>>2]|0;o=f[m+4>>2]|0;m=c+(j<<2)|0;c=g+-1|0;p=(g|0)==0;if(!(f[a+84>>2]&1)){if(p)return;a=h+-4|0;g=(h|0)<4;q=(i|0)<2;r=h&-4;s=l+o>>n;t=(s>>>0<256?s:(s|0)>0?255:0)&255;s=l+o>>n;u=(s>>>0<256?s:(s|0)>0?255:0)&255;s=d;v=m;w=c;while(1){a:do if(g)x=0;else{if(q){y=0;while(1){b[s+y>>0]=u;b[s+(y|1)>>0]=u;b[s+(y|2)>>0]=u;b[s+(y|3)>>0]=u;y=y+4|0;if((y|0)>(a|0)){x=r;break a}}}else z=0;do{y=l;A=l;B=l;C=l;D=1;while(1){E=(f[v+(D<<2)>>2]|0)+(z<<2)|0;F=(f[v+(0-D<<2)>>2]|0)+(z<<2)|0;G=f[k+(D<<2)>>2]|0;C=(Y((f[E>>2]|0)-(f[F>>2]|0)|0,G)|0)+C|0;B=(Y((f[E+4>>2]|0)-(f[F+4>>2]|0)|0,G)|0)+B|0;A=(Y((f[E+8>>2]|0)-(f[F+8>>2]|0)|0,G)|0)+A|0;y=(Y((f[E+12>>2]|0)-(f[F+12>>2]|0)|0,G)|0)+y|0;if((D|0)>=(j|0))break;else D=D+1|0}D=C+o>>n;b[s+z>>0]=D>>>0<256?D:(D|0)>0?255:0;D=B+o>>n;b[s+(z|1)>>0]=D>>>0<256?D:(D|0)>0?255:0;D=A+o>>n;b[s+(z|2)>>0]=D>>>0<256?D:(D|0)>0?255:0;D=y+o>>n;b[s+(z|3)>>0]=D>>>0<256?D:(D|0)>0?255:0;z=z+4|0}while((z|0)<=(a|0));x=r}while(0);b:do if((x|0)<(h|0)){if(q){D=x;while(1){b[s+D>>0]=t;D=D+1|0;if((D|0)==(h|0))break b}}else H=x;do{D=l;G=1;while(1){D=(Y((f[(f[v+(G<<2)>>2]|0)+(H<<2)>>2]|0)-(f[(f[v+(0-G<<2)>>2]|0)+(H<<2)>>2]|0)|0,f[k+(G<<2)>>2]|0)|0)+D|0;if((G|0)>=(j|0))break;else G=G+1|0}G=D+o>>n;b[s+H>>0]=G>>>0<256?G:(G|0)>0?255:0;H=H+1|0}while((H|0)!=(h|0))}while(0);if(!w)break;else{s=s+e|0;v=v+4|0;w=w+-1|0}}return}else{if(p)return;p=h+-4|0;w=(h|0)<4;v=(i|0)<2;i=h&-4;s=m;m=d;d=c;while(1){c:do if(w)I=0;else{if(v){c=0;while(1){H=f[k>>2]|0;x=(f[s>>2]|0)+(c<<2)|0;t=(Y(f[x>>2]|0,H)|0)+l|0;q=(Y(f[x+4>>2]|0,H)|0)+l|0;r=(Y(f[x+8>>2]|0,H)|0)+l|0;a=(Y(f[x+12>>2]|0,H)|0)+l|0;H=t+o>>n;b[m+c>>0]=H>>>0<256?H:(H|0)>0?255:0;H=q+o>>n;b[m+(c|1)>>0]=H>>>0<256?H:(H|0)>0?255:0;H=r+o>>n;b[m+(c|2)>>0]=H>>>0<256?H:(H|0)>0?255:0;H=a+o>>n;b[m+(c|3)>>0]=H>>>0<256?H:(H|0)>0?255:0;c=c+4|0;if((c|0)>(p|0)){I=i;break c}}}else J=0;do{c=f[k>>2]|0;H=(f[s>>2]|0)+(J<<2)|0;a=(Y(f[H>>2]|0,c)|0)+l|0;r=(Y(f[H+4>>2]|0,c)|0)+l|0;q=(Y(f[H+8>>2]|0,c)|0)+l|0;t=(Y(f[H+12>>2]|0,c)|0)+l|0;c=q;q=r;r=a;a=1;while(1){H=(f[s+(a<<2)>>2]|0)+(J<<2)|0;x=(f[s+(0-a<<2)>>2]|0)+(J<<2)|0;z=f[k+(a<<2)>>2]|0;r=(Y((f[x>>2]|0)+(f[H>>2]|0)|0,z)|0)+r|0;q=(Y((f[x+4>>2]|0)+(f[H+4>>2]|0)|0,z)|0)+q|0;c=(Y((f[x+8>>2]|0)+(f[H+8>>2]|0)|0,z)|0)+c|0;t=(Y((f[x+12>>2]|0)+(f[H+12>>2]|0)|0,z)|0)+t|0;if((a|0)>=(j|0))break;else a=a+1|0}a=r+o>>n;b[m+J>>0]=a>>>0<256?a:(a|0)>0?255:0;a=q+o>>n;b[m+(J|1)>>0]=a>>>0<256?a:(a|0)>0?255:0;a=c+o>>n;b[m+(J|2)>>0]=a>>>0<256?a:(a|0)>0?255:0;a=t+o>>n;b[m+(J|3)>>0]=a>>>0<256?a:(a|0)>0?255:0;J=J+4|0}while((J|0)<=(p|0));I=i}while(0);d:do if((I|0)<(h|0)){if(v){a=I;while(1){D=(Y(f[(f[s>>2]|0)+(a<<2)>>2]|0,f[k>>2]|0)|0)+l+o>>n;b[m+a>>0]=D>>>0<256?D:(D|0)>0?255:0;a=a+1|0;if((a|0)==(h|0))break d}}else K=I;do{a=(Y(f[(f[s>>2]|0)+(K<<2)>>2]|0,f[k>>2]|0)|0)+l|0;D=1;while(1){a=(Y((f[(f[s+(0-D<<2)>>2]|0)+(K<<2)>>2]|0)+(f[(f[s+(D<<2)>>2]|0)+(K<<2)>>2]|0)|0,f[k+(D<<2)>>2]|0)|0)+a|0;if((D|0)>=(j|0))break;else D=D+1|0}D=a+o>>n;b[m+K>>0]=D>>>0<256?D:(D|0)>0?255:0;K=K+1|0}while((K|0)!=(h|0))}while(0);if(!d)break;else{s=s+4|0;m=m+e|0;d=d+-1|0}}return}}function rba(a){a=a|0;O5b(a);return}function sba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function tba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;zba(a,c,d,e,h,i);f[a>>2]=55460;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=aD(k,64)|0;a=244792;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));bO(-215,k,244857,241836,3314);bD(k);u=j;return}function uba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55436;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function vba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55436;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function wba(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0;h=f[a+28>>2]|0;i=+n[a+72>>2];j=f[a+4>>2]|0;if(!e)return;a=g+-4|0;k=(g|0)<4;l=(j|0)>1;m=g&-4;o=b;b=c;c=e;while(1){c=c+-1|0;a:do if(k)p=0;else{e=f[o>>2]|0;if(l)q=0;else{r=0;while(1){s=+n[h>>2];t=e+(r<<2)|0;u=i+s*+n[t+4>>2];v=i+s*+n[t+8>>2];w=i+s*+n[t+12>>2];n[b+(r<<2)>>2]=i+s*+n[t>>2];n[b+((r|1)<<2)>>2]=u;n[b+((r|2)<<2)>>2]=v;n[b+((r|3)<<2)>>2]=w;r=r+4|0;if((r|0)>(a|0)){p=m;break a}}}do{w=+n[h>>2];r=e+(q<<2)|0;v=i+w*+n[r+12>>2];u=i+w*+n[r+8>>2];s=i+w*+n[r+4>>2];x=i+w*+n[r>>2];r=1;do{t=(f[o+(r<<2)>>2]|0)+(q<<2)|0;w=+n[h+(r<<2)>>2];x=x+w*+n[t>>2];s=s+w*+n[t+4>>2];u=u+w*+n[t+8>>2];v=v+w*+n[t+12>>2];r=r+1|0}while((r|0)!=(j|0));n[b+(q<<2)>>2]=x;n[b+((q|1)<<2)>>2]=s;n[b+((q|2)<<2)>>2]=u;n[b+((q|3)<<2)>>2]=v;q=q+4|0}while((q|0)<=(a|0));p=m}while(0);b:do if((p|0)<(g|0)){e=f[o>>2]|0;if(l)y=p;else{r=p;while(1){n[b+(r<<2)>>2]=i+ +n[h>>2]*+n[e+(r<<2)>>2];r=r+1|0;if((r|0)==(g|0))break b}}do{w=i+ +n[h>>2]*+n[e+(y<<2)>>2];r=1;do{w=w+ +n[h+(r<<2)>>2]*+n[(f[o+(r<<2)>>2]|0)+(y<<2)>>2];r=r+1|0}while((r|0)!=(j|0));n[b+(y<<2)>>2]=w;y=y+1|0}while((y|0)!=(g|0))}while(0);if(!c)break;else{o=o+4|0;b=b+d|0}}return}function xba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55436;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function yba(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0.0,m=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0;h=(f[a+4>>2]|0)/2|0;i=(f[a+28>>2]|0)+(h<<2)|0;j=(f[a+76>>2]&1|0)==0;k=+n[i>>2];l=+n[i+4>>2];i=l==1.0;m=k==2.0&i;o=k==-2.0&i;p=k!=0.0;q=p|i?p^1:l==-1.0;r=+n[a+72>>2];if(!e)return;a=l<0.0;p=g+-4|0;i=(g|0)<4;s=g&-4;t=c;c=b+(h<<2)|0;h=e;while(1){h=h+-1|0;e=f[c+-4>>2]|0;b=f[c>>2]|0;c=c+4|0;u=f[c>>2]|0;a:do if(j)if(q){v=a?u:e;w=a?e:u;if(i)x=0;else{y=w;z=v;A=0;do{B=A|1;C=r+(+n[y+(B<<2)>>2]-+n[z+(B<<2)>>2]);n[t+(A<<2)>>2]=r+(+n[y+(A<<2)>>2]-+n[z+(A<<2)>>2]);n[t+(B<<2)>>2]=C;B=A|2;D=A|3;C=r+(+n[y+(D<<2)>>2]-+n[z+(D<<2)>>2]);n[t+(B<<2)>>2]=r+(+n[y+(B<<2)>>2]-+n[z+(B<<2)>>2]);n[t+(D<<2)>>2]=C;A=A+4|0}while((A|0)<=(p|0));x=s}if((x|0)>=(g|0))break;A=w;z=v;y=x;do{n[t+(y<<2)>>2]=r+(+n[A+(y<<2)>>2]-+n[z+(y<<2)>>2]);y=y+1|0}while((y|0)!=(g|0))}else{if(i)E=0;else{y=u;z=e;A=0;do{v=A|1;C=r+l*(+n[y+(v<<2)>>2]-+n[z+(v<<2)>>2]);n[t+(A<<2)>>2]=r+l*(+n[y+(A<<2)>>2]-+n[z+(A<<2)>>2]);n[t+(v<<2)>>2]=C;v=A|2;w=A|3;C=r+l*(+n[y+(w<<2)>>2]-+n[z+(w<<2)>>2]);n[t+(v<<2)>>2]=r+l*(+n[y+(v<<2)>>2]-+n[z+(v<<2)>>2]);n[t+(w<<2)>>2]=C;A=A+4|0}while((A|0)<=(p|0));E=s}if((E|0)>=(g|0))break;A=u;z=e;y=E;do{n[t+(y<<2)>>2]=r+l*(+n[A+(y<<2)>>2]-+n[z+(y<<2)>>2]);y=y+1|0}while((y|0)!=(g|0))}else{if(m){if(i)F=0;else{y=e;z=u;A=0;do{w=A|1;C=r+(+n[z+(w<<2)>>2]+(+n[y+(w<<2)>>2]+ +n[b+(w<<2)>>2]*2.0));n[t+(A<<2)>>2]=r+(+n[z+(A<<2)>>2]+(+n[y+(A<<2)>>2]+ +n[b+(A<<2)>>2]*2.0));n[t+(w<<2)>>2]=C;w=A|2;v=A|3;C=r+(+n[z+(v<<2)>>2]+(+n[y+(v<<2)>>2]+ +n[b+(v<<2)>>2]*2.0));n[t+(w<<2)>>2]=r+(+n[z+(w<<2)>>2]+(+n[y+(w<<2)>>2]+ +n[b+(w<<2)>>2]*2.0));n[t+(v<<2)>>2]=C;A=A+4|0}while((A|0)<=(p|0));F=s}if((F|0)>=(g|0))break;A=e;y=u;z=F;while(1){n[t+(z<<2)>>2]=r+(+n[y+(z<<2)>>2]+(+n[A+(z<<2)>>2]+ +n[b+(z<<2)>>2]*2.0));z=z+1|0;if((z|0)==(g|0))break a}}if(o){if(i)G=0;else{z=e;A=u;y=0;do{v=y|1;C=r+(+n[A+(v<<2)>>2]+(+n[z+(v<<2)>>2]-+n[b+(v<<2)>>2]*2.0));n[t+(y<<2)>>2]=r+(+n[A+(y<<2)>>2]+(+n[z+(y<<2)>>2]-+n[b+(y<<2)>>2]*2.0));n[t+(v<<2)>>2]=C;v=y|2;w=y|3;C=r+(+n[A+(w<<2)>>2]+(+n[z+(w<<2)>>2]-+n[b+(w<<2)>>2]*2.0));n[t+(v<<2)>>2]=r+(+n[A+(v<<2)>>2]+(+n[z+(v<<2)>>2]-+n[b+(v<<2)>>2]*2.0));n[t+(w<<2)>>2]=C;y=y+4|0}while((y|0)<=(p|0));G=s}if((G|0)>=(g|0))break;y=e;z=u;A=G;do{n[t+(A<<2)>>2]=r+(+n[z+(A<<2)>>2]+(+n[y+(A<<2)>>2]-+n[b+(A<<2)>>2]*2.0));A=A+1|0}while((A|0)!=(g|0))}else{if(i)H=0;else{A=e;y=u;z=0;do{w=z|1;C=r+(l*(+n[A+(w<<2)>>2]+ +n[y+(w<<2)>>2])+k*+n[b+(w<<2)>>2]);n[t+(z<<2)>>2]=r+(l*(+n[A+(z<<2)>>2]+ +n[y+(z<<2)>>2])+k*+n[b+(z<<2)>>2]);n[t+(w<<2)>>2]=C;w=z|2;v=z|3;C=r+(l*(+n[A+(v<<2)>>2]+ +n[y+(v<<2)>>2])+k*+n[b+(v<<2)>>2]);n[t+(w<<2)>>2]=r+(l*(+n[A+(w<<2)>>2]+ +n[y+(w<<2)>>2])+k*+n[b+(w<<2)>>2]);n[t+(v<<2)>>2]=C;z=z+4|0}while((z|0)<=(p|0));H=s}if((H|0)>=(g|0))break;z=e;y=u;A=H;do{n[t+(A<<2)>>2]=r+(l*(+n[z+(A<<2)>>2]+ +n[y+(A<<2)>>2])+k*+n[b+(A<<2)>>2]);A=A+1|0}while((A|0)!=(g|0))}}while(0);if(!h)break;else t=t+d|0}return}function zba(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;h=u;u=u+16|0;g=h;i=a+8|0;f[i>>2]=-1;j=a+4|0;f[j>>2]=-1;f[a>>2]=55436;k=a+12|0;f[k>>2]=1124007936;l=a+16|0;m=a+20|0;o=a+52|0;p=l;q=p+36|0;do{f[p>>2]=0;p=p+4|0}while((p|0)<(q|0));f[o>>2]=m;r=a+60|0;s=a+56|0;f[s>>2]=r;f[r>>2]=0;f[a+64>>2]=0;if(f[c>>2]&16384){if((k|0)!=(c|0)){r=c+36|0;t=f[r>>2]|0;if(t){v=t+12|0;f[v>>2]=(f[v>>2]|0)+1;v=a+48|0;t=f[v>>2]|0;if((t|0)!=0?(w=t+12|0,t=f[w>>2]|0,f[w>>2]=t+-1,(t|0)==1):0){kL(k);x=v}else x=v}else x=a+48|0;f[x>>2]=0;v=a+28|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[l>>2]|0)>0){t=f[o>>2]|0;o=0;do{f[t+(o<<2)>>2]=0;o=o+1|0;y=f[l>>2]|0}while((o|0)<(y|0));f[k>>2]=f[c>>2];if((y|0)<3)z=13;else z=15}else{f[k>>2]=f[c>>2];z=13}if((z|0)==13){y=f[c+4>>2]|0;if((y|0)<3){f[l>>2]=y;f[m>>2]=f[c+8>>2];f[a+24>>2]=f[c+12>>2];y=f[c+44>>2]|0;l=f[s>>2]|0;f[l>>2]=f[y>>2];f[l+4>>2]=f[y+4>>2]}else z=15}if((z|0)==15)jL(k,c);f[v>>2]=f[c+16>>2];f[a+32>>2]=f[c+20>>2];f[a+36>>2]=f[c+24>>2];f[a+40>>2]=f[c+28>>2];f[a+44>>2]=f[c+32>>2];f[x>>2]=f[r>>2]}}else{r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;SP(c,g)}f[i>>2]=d;d=f[m>>2]|0;m=f[a+24>>2]|0;f[j>>2]=d+-1+m;n[a+72>>2]=e;if((f[k>>2]&4095|0)==5?(d|0)==1|(m|0)==1:0){u=h;return}f[g>>2]=0;f[g+4>>2]=0;p=aD(g,77)|0;m=245846;q=p+77|0;do{b[p>>0]=b[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(q|0));bO(-215,g,245924,241836,3251);bD(g);u=h;return}function Aba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55436;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function Bba(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0.0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0;h=f[a+4>>2]|0;i=(h|0)/2|0;j=(f[a+28>>2]|0)+(i<<2)|0;k=+n[a+72>>2];l=b+(i<<2)|0;b=e+-1|0;m=(e|0)==0;if(!(f[a+76>>2]&1)){if(m)return;a=g+-4|0;e=(g|0)<4;o=(h|0)<2;p=g&-4;q=c;r=l;s=b;while(1){a:do if(e)t=0;else{if(o){u=0;while(1){n[q+(u<<2)>>2]=k;n[q+((u|1)<<2)>>2]=k;n[q+((u|2)<<2)>>2]=k;n[q+((u|3)<<2)>>2]=k;u=u+4|0;if((u|0)>(a|0)){t=p;break a}}}else v=0;do{w=k;x=k;y=k;z=k;u=1;while(1){A=(f[r+(u<<2)>>2]|0)+(v<<2)|0;B=(f[r+(0-u<<2)>>2]|0)+(v<<2)|0;C=+n[j+(u<<2)>>2];z=z+C*(+n[A>>2]-+n[B>>2]);y=y+C*(+n[A+4>>2]-+n[B+4>>2]);x=x+C*(+n[A+8>>2]-+n[B+8>>2]);w=w+C*(+n[A+12>>2]-+n[B+12>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[q+(v<<2)>>2]=z;n[q+((v|1)<<2)>>2]=y;n[q+((v|2)<<2)>>2]=x;n[q+((v|3)<<2)>>2]=w;v=v+4|0}while((v|0)<=(a|0));t=p}while(0);b:do if((t|0)<(g|0)){if(o){u=t;while(1){n[q+(u<<2)>>2]=k;u=u+1|0;if((u|0)==(g|0))break b}}else D=t;do{C=k;u=1;while(1){C=C+ +n[j+(u<<2)>>2]*(+n[(f[r+(u<<2)>>2]|0)+(D<<2)>>2]-+n[(f[r+(0-u<<2)>>2]|0)+(D<<2)>>2]);if((u|0)>=(i|0))break;else u=u+1|0}n[q+(D<<2)>>2]=C;D=D+1|0}while((D|0)!=(g|0))}while(0);if(!s)break;else{q=q+d|0;r=r+4|0;s=s+-1|0}}return}else{if(m)return;m=g+-4|0;s=(g|0)<4;r=(h|0)<2;h=g&-4;q=l;l=c;c=b;while(1){c:do if(s)E=0;else{b=f[q>>2]|0;if(r){D=0;while(1){w=+n[j>>2];t=b+(D<<2)|0;x=k+w*+n[t+4>>2];y=k+w*+n[t+8>>2];z=k+w*+n[t+12>>2];n[l+(D<<2)>>2]=k+w*+n[t>>2];n[l+((D|1)<<2)>>2]=x;n[l+((D|2)<<2)>>2]=y;n[l+((D|3)<<2)>>2]=z;D=D+4|0;if((D|0)>(m|0)){E=h;break c}}}else F=0;do{z=+n[j>>2];D=b+(F<<2)|0;y=k+z*+n[D+12>>2];x=k+z*+n[D+8>>2];w=k+z*+n[D+4>>2];G=k+z*+n[D>>2];D=1;while(1){t=(f[q+(D<<2)>>2]|0)+(F<<2)|0;o=(f[q+(0-D<<2)>>2]|0)+(F<<2)|0;z=+n[j+(D<<2)>>2];G=G+z*(+n[t>>2]+ +n[o>>2]);w=w+z*(+n[t+4>>2]+ +n[o+4>>2]);x=x+z*(+n[t+8>>2]+ +n[o+8>>2]);y=y+z*(+n[t+12>>2]+ +n[o+12>>2]);if((D|0)>=(i|0))break;else D=D+1|0}n[l+(F<<2)>>2]=G;n[l+((F|1)<<2)>>2]=w;n[l+((F|2)<<2)>>2]=x;n[l+((F|3)<<2)>>2]=y;F=F+4|0}while((F|0)<=(m|0));E=h}while(0);d:do if((E|0)<(g|0)){b=f[q>>2]|0;if(r){D=E;while(1){n[l+(D<<2)>>2]=k+ +n[j>>2]*+n[b+(D<<2)>>2];D=D+1|0;if((D|0)==(g|0))break d}}else H=E;do{C=k+ +n[j>>2]*+n[b+(H<<2)>>2];D=1;while(1){C=C+ +n[j+(D<<2)>>2]*(+n[(f[q+(D<<2)>>2]|0)+(H<<2)>>2]+ +n[(f[q+(0-D<<2)>>2]|0)+(H<<2)>>2]);if((D|0)>=(i|0))break;else D=D+1|0}n[l+(H<<2)>>2]=C;H=H+1|0}while((H|0)!=(g|0))}while(0);if(!c)break;else{q=q+4|0;l=l+d|0;c=c+-1|0}}return}}function Cba(a){a=a|0;O5b(a);return}function Dba(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Eba(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;Kba(a,c,d,e,h,i);f[a>>2]=55532;f[a+76>>2]=g;if(g&3|0){u=j;return}f[k>>2]=0;f[k+4>>2]=0;g=aD(k,64)|0;a=244792;i=g+64|0;do{b[g>>0]=b[a>>0]|0;g=g+1|0;a=a+1|0}while((g|0)<(i|0));bO(-215,k,244857,241836,3314);bD(k);u=j;return}function Fba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55508;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0))return;UC(b);return}function Gba(a){a=a|0;var b=0,c=0,d=0,e=0;f[a>>2]=55508;b=a+12|0;c=a+48|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+28|0;b=a+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+52>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+56>>2]|0;if((b|0)==(a+60|0)){O5b(a);return}UC(b);O5b(a);return}function Hba(a,b,c,e,g,h){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;i=f[a+28>>2]|0;j=f[a+72>>2]|0;k=f[a+4>>2]|0;if(!g)return;a=h+-4|0;l=(h|0)<4;m=(k|0)>1;n=h&-4;o=b;b=c;c=g;while(1){c=c+-1|0;a:do if(l)p=0;else{g=f[i>>2]|0;q=f[o>>2]|0;if(m)r=0;else{s=0;while(1){t=q+(s<<2)|0;u=(Y(f[t>>2]|0,g)|0)+j|0;v=(Y(f[t+4>>2]|0,g)|0)+j|0;w=(Y(f[t+8>>2]|0,g)|0)+j|0;x=(Y(f[t+12>>2]|0,g)|0)+j|0;d[b+(s<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;d[b+((s|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[b+((s|2)<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[b+((s|3)<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;s=s+4|0;if((s|0)>(a|0)){p=n;break a}}}do{s=q+(r<<2)|0;x=(Y(f[s>>2]|0,g)|0)+j|0;w=(Y(f[s+4>>2]|0,g)|0)+j|0;v=(Y(f[s+8>>2]|0,g)|0)+j|0;u=(Y(f[s+12>>2]|0,g)|0)+j|0;s=v;v=w;w=x;x=1;do{t=(f[o+(x<<2)>>2]|0)+(r<<2)|0;y=f[i+(x<<2)>>2]|0;w=(Y(f[t>>2]|0,y)|0)+w|0;v=(Y(f[t+4>>2]|0,y)|0)+v|0;s=(Y(f[t+8>>2]|0,y)|0)+s|0;u=(Y(f[t+12>>2]|0,y)|0)+u|0;x=x+1|0}while((x|0)!=(k|0));d[b+(r<<1)>>1]=(w+32768|0)>>>0<65536?w:(w|0)>0?32767:32768;d[b+((r|1)<<1)>>1]=(v+32768|0)>>>0<65536?v:(v|0)>0?32767:32768;d[b+((r|2)<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[b+((r|3)<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;r=r+4|0}while((r|0)<=(a|0));p=n}while(0);b:do if((p|0)<(h|0)){g=f[i>>2]|0;q=f[o>>2]|0;if(m)z=p;else{x=p;while(1){y=(Y(f[q+(x<<2)>>2]|0,g)|0)+j|0;d[b+(x<<1)>>1]=(y+32768|0)>>>0<65536?y:(y|0)>0?32767:32768;x=x+1|0;if((x|0)==(h|0))break b}}do{x=(Y(f[q+(z<<2)>>2]|0,g)|0)+j|0;y=1;do{x=(Y(f[(f[o+(y<<2)>>2]|0)+(z<<2)>>2]|0,f[i+(y<<2)>>2]|0)|0)+x|0;y=y+1|0}while((y|0)!=(k|0));d[b+(z<<1)>>1]=(x+32768|0)>>>0<65536?x:(x|0)>0?32767:32768;z=z+1|0}while((z|0)!=(h|0))}while(0);if(!c)break;else{o=o+4|0;b=b+e|0}}return}
function nX(a,b,c,d,e,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;q=u;u=u+448|0;r=q+392|0;s=q+336|0;t=q+280|0;v=q+224|0;w=q+168|0;x=q+112|0;y=q+56|0;z=q;A=(o&2|0)==0;B=(o&1|0)!=0;C=B?l:m;D=B?m:l;B=A?C:n;E=A?n:C;C=(o&4|0)==0;A=C?D:n;F=C?n:D;f[r>>2]=1124007936;C=r+4|0;G=r+8|0;H=r+40|0;I=C;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[H>>2]=G;K=r+48|0;L=r+44|0;f[L>>2]=K;f[K>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;M=s+4|0;N=s+8|0;O=s+40|0;I=M;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[O>>2]=N;P=s+48|0;Q=s+44|0;f[Q>>2]=P;f[P>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;R=t+4|0;S=t+8|0;T=t+40|0;I=R;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[T>>2]=S;I=t+48|0;J=t+44|0;f[J>>2]=I;f[I>>2]=0;f[t+52>>2]=0;if(a|0){Qi(v,l,m,p,a,b);b=v+36|0;a=f[b>>2]|0;if(a|0){m=a+12|0;f[m>>2]=(f[m>>2]|0)+1}m=r+36|0;a=f[m>>2]|0;if(a|0?(l=a+12|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)kL(r);f[m>>2]=0;a=r+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[C>>2]|0)>0){l=f[H>>2]|0;U=0;do{f[l+(U<<2)>>2]=0;U=U+1|0;V=f[C>>2]|0}while((U|0)<(V|0));f[r>>2]=f[v>>2];if((V|0)<3)W=12;else W=14}else{f[r>>2]=f[v>>2];W=12}if((W|0)==12){V=f[v+4>>2]|0;if((V|0)<3){f[C>>2]=V;f[G>>2]=f[v+8>>2];f[r+12>>2]=f[v+12>>2];V=f[v+44>>2]|0;U=f[L>>2]|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2]}else W=14}if((W|0)==14)jL(r,v);V=v+16|0;f[a>>2]=f[V>>2];f[r+20>>2]=f[v+20>>2];f[r+24>>2]=f[v+24>>2];f[r+28>>2]=f[v+28>>2];f[r+32>>2]=f[v+32>>2];a=f[b>>2]|0;f[m>>2]=a;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)kL(v);f[b>>2]=0;b=v+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[b>>2]|0)>0){V=f[v+40>>2]|0;a=0;do{f[V+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0))}b=f[v+44>>2]|0;if((b|0)!=(v+48|0))UC(b)}if(c|0){Qi(v,B,E,p,c,d);d=v+36|0;c=f[d>>2]|0;if(c|0){E=c+12|0;f[E>>2]=(f[E>>2]|0)+1}E=s+36|0;c=f[E>>2]|0;if(c|0?(B=c+12|0,c=f[B>>2]|0,f[B>>2]=c+-1,(c|0)==1):0)kL(s);f[E>>2]=0;c=s+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[M>>2]|0)>0){B=f[O>>2]|0;b=0;do{f[B+(b<<2)>>2]=0;b=b+1|0;X=f[M>>2]|0}while((b|0)<(X|0));f[s>>2]=f[v>>2];if((X|0)<3)W=35;else W=37}else{f[s>>2]=f[v>>2];W=35}if((W|0)==35){X=f[v+4>>2]|0;if((X|0)<3){f[M>>2]=X;f[N>>2]=f[v+8>>2];f[s+12>>2]=f[v+12>>2];X=f[v+44>>2]|0;b=f[Q>>2]|0;f[b>>2]=f[X>>2];f[b+4>>2]=f[X+4>>2]}else W=37}if((W|0)==37)jL(s,v);X=v+16|0;f[c>>2]=f[X>>2];f[s+20>>2]=f[v+20>>2];f[s+24>>2]=f[v+24>>2];f[s+28>>2]=f[v+28>>2];f[s+32>>2]=f[v+32>>2];c=f[d>>2]|0;f[E>>2]=c;if(c|0?(E=c+12|0,c=f[E>>2]|0,f[E>>2]=c+-1,(c|0)==1):0)kL(v);f[d>>2]=0;d=v+4|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[d>>2]|0)>0){X=f[v+40>>2]|0;c=0;do{f[X+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[v+44>>2]|0;if((d|0)!=(v+48|0))UC(d)}if((g|0)!=0&i!=0.0){Qi(v,A,F,p,g,h);h=v+36|0;g=f[h>>2]|0;if(g|0){F=g+12|0;f[F>>2]=(f[F>>2]|0)+1}F=t+36|0;g=f[F>>2]|0;if(g|0?(A=g+12|0,g=f[A>>2]|0,f[A>>2]=g+-1,(g|0)==1):0)kL(t);f[F>>2]=0;g=t+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[R>>2]|0)>0){A=f[T>>2]|0;d=0;do{f[A+(d<<2)>>2]=0;d=d+1|0;Y=f[R>>2]|0}while((d|0)<(Y|0));f[t>>2]=f[v>>2];if((Y|0)<3)W=58;else W=60}else{f[t>>2]=f[v>>2];W=58}if((W|0)==58){Y=f[v+4>>2]|0;if((Y|0)<3){f[R>>2]=Y;f[S>>2]=f[v+8>>2];f[t+12>>2]=f[v+12>>2];Y=f[v+44>>2]|0;d=f[J>>2]|0;f[d>>2]=f[Y>>2];f[d+4>>2]=f[Y+4>>2]}else W=60}if((W|0)==60)jL(t,v);W=v+16|0;f[g>>2]=f[W>>2];f[t+20>>2]=f[v+20>>2];f[t+24>>2]=f[v+24>>2];f[t+28>>2]=f[v+28>>2];f[t+32>>2]=f[v+32>>2];g=f[h>>2]|0;f[F>>2]=g;if(g|0?(F=g+12|0,g=f[F>>2]|0,f[F>>2]=g+-1,(g|0)==1):0)kL(v);f[h>>2]=0;h=v+4|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[h>>2]|0)>0){W=f[v+40>>2]|0;g=0;do{f[W+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[h>>2]|0))}h=f[v+44>>2]|0;if((h|0)!=(v+48|0))UC(h)}Qi(v,D,n,p,j,k);f[w>>2]=f[r>>2];k=w+4|0;j=f[C>>2]|0;f[k>>2]=j;p=w+8|0;f[p>>2]=f[G>>2];f[w+12>>2]=f[r+12>>2];G=w+16|0;n=r+16|0;f[G>>2]=f[n>>2];f[w+20>>2]=f[r+20>>2];f[w+24>>2]=f[r+24>>2];f[w+28>>2]=f[r+28>>2];f[w+32>>2]=f[r+32>>2];D=w+36|0;h=r+36|0;g=f[h>>2]|0;f[D>>2]=g;W=w+40|0;f[W>>2]=p;p=w+48|0;F=w+44|0;f[F>>2]=p;f[p>>2]=0;f[w+52>>2]=0;if(!g)Z=j;else{j=g+12|0;f[j>>2]=(f[j>>2]|0)+1;Z=f[C>>2]|0}if((Z|0)<3){Z=f[L>>2]|0;j=f[F>>2]|0;f[j>>2]=f[Z>>2];f[j+4>>2]=f[Z+4>>2]}else{f[k>>2]=0;jL(w,r)}f[x>>2]=f[s>>2];Z=x+4|0;j=f[M>>2]|0;f[Z>>2]=j;g=x+8|0;f[g>>2]=f[N>>2];f[x+12>>2]=f[s+12>>2];N=x+16|0;Y=s+16|0;f[N>>2]=f[Y>>2];f[x+20>>2]=f[s+20>>2];f[x+24>>2]=f[s+24>>2];f[x+28>>2]=f[s+28>>2];f[x+32>>2]=f[s+32>>2];d=x+36|0;A=s+36|0;c=f[A>>2]|0;f[d>>2]=c;X=x+40|0;f[X>>2]=g;g=x+48|0;E=x+44|0;f[E>>2]=g;f[g>>2]=0;f[x+52>>2]=0;if(!c)_=j;else{j=c+12|0;f[j>>2]=(f[j>>2]|0)+1;_=f[M>>2]|0}if((_|0)<3){_=f[Q>>2]|0;j=f[E>>2]|0;f[j>>2]=f[_>>2];f[j+4>>2]=f[_+4>>2]}else{f[Z>>2]=0;jL(x,s)}f[y>>2]=f[t>>2];_=y+4|0;j=f[R>>2]|0;f[_>>2]=j;c=y+8|0;f[c>>2]=f[S>>2];f[y+12>>2]=f[t+12>>2];S=y+16|0;b=t+16|0;f[S>>2]=f[b>>2];f[y+20>>2]=f[t+20>>2];f[y+24>>2]=f[t+24>>2];f[y+28>>2]=f[t+28>>2];f[y+32>>2]=f[t+32>>2];B=y+36|0;a=t+36|0;V=f[a>>2]|0;f[B>>2]=V;m=y+40|0;f[m>>2]=c;c=y+48|0;U=y+44|0;f[U>>2]=c;f[c>>2]=0;f[y+52>>2]=0;if(!V)$=j;else{j=V+12|0;f[j>>2]=(f[j>>2]|0)+1;$=f[R>>2]|0}if(($|0)<3){$=f[J>>2]|0;j=f[U>>2]|0;f[j>>2]=f[$>>2];f[j+4>>2]=f[$+4>>2]}else{f[_>>2]=0;jL(y,t)}f[z>>2]=f[v>>2];$=z+4|0;j=v+4|0;V=f[j>>2]|0;f[$>>2]=V;l=z+8|0;f[l>>2]=f[v+8>>2];f[z+12>>2]=f[v+12>>2];aa=z+16|0;ba=v+16|0;f[aa>>2]=f[ba>>2];f[z+20>>2]=f[v+20>>2];f[z+24>>2]=f[v+24>>2];f[z+28>>2]=f[v+28>>2];f[z+32>>2]=f[v+32>>2];ca=z+36|0;da=v+36|0;ea=f[da>>2]|0;f[ca>>2]=ea;fa=z+40|0;f[fa>>2]=l;l=z+48|0;ga=z+44|0;f[ga>>2]=l;f[l>>2]=0;f[z+52>>2]=0;if(!ea)ha=V;else{V=ea+12|0;f[V>>2]=(f[V>>2]|0)+1;ha=f[j>>2]|0}if((ha|0)<3){ha=f[v+44>>2]|0;V=f[ga>>2]|0;f[V>>2]=f[ha>>2];f[V+4>>2]=f[ha+4>>2]}else{f[$>>2]=0;jL(z,v)}oX(w,x,e,y,i,z,o);o=f[ca>>2]|0;if(o|0?(ha=o+12|0,o=f[ha>>2]|0,f[ha>>2]=o+-1,(o|0)==1):0)kL(z);f[ca>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[$>>2]|0)>0){aa=f[fa>>2]|0;fa=0;do{f[aa+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[$>>2]|0))}$=f[ga>>2]|0;if(($|0)!=(l|0))UC($);$=f[B>>2]|0;if($|0?(l=$+12|0,$=f[l>>2]|0,f[l>>2]=$+-1,($|0)==1):0)kL(y);f[B>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[_>>2]|0)>0){S=f[m>>2]|0;m=0;do{f[S+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[_>>2]|0))}_=f[U>>2]|0;if((_|0)!=(c|0))UC(_);_=f[d>>2]|0;if(_|0?(c=_+12|0,_=f[c>>2]|0,f[c>>2]=_+-1,(_|0)==1):0)kL(x);f[d>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[Z>>2]|0)>0){N=f[X>>2]|0;X=0;do{f[N+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[Z>>2]|0))}Z=f[E>>2]|0;if((Z|0)!=(g|0))UC(Z);Z=f[D>>2]|0;do if(Z|0){g=Z+12|0;E=f[g>>2]|0;f[g>>2]=E+-1;if((E|0)!=1)break;kL(w)}while(0);f[D>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[k>>2]|0)>0){G=f[W>>2]|0;W=0;do{f[G+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[k>>2]|0))}k=f[F>>2]|0;if((k|0)!=(p|0))UC(k);k=f[da>>2]|0;do if(k|0){p=k+12|0;F=f[p>>2]|0;f[p>>2]=F+-1;if((F|0)!=1)break;kL(v)}while(0);f[da>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[j>>2]|0)>0){ba=f[v+40>>2]|0;da=0;do{f[ba+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[j>>2]|0))}j=f[v+44>>2]|0;if((j|0)!=(v+48|0))UC(j);j=f[a>>2]|0;do if(j|0){v=j+12|0;da=f[v>>2]|0;f[v>>2]=da+-1;if((da|0)!=1)break;kL(t)}while(0);f[a>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[R>>2]|0)>0){b=f[T>>2]|0;T=0;do{f[b+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[J>>2]|0;if((R|0)!=(I|0))UC(R);R=f[A>>2]|0;do if(R|0){I=R+12|0;J=f[I>>2]|0;f[I>>2]=J+-1;if((J|0)!=1)break;kL(s)}while(0);f[A>>2]=0;f[Y>>2]=0;f[Y+4>>2]=0;f[Y+8>>2]=0;f[Y+12>>2]=0;if((f[M>>2]|0)>0){Y=f[O>>2]|0;O=0;do{f[Y+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[M>>2]|0))}M=f[Q>>2]|0;if((M|0)!=(P|0))UC(M);M=f[h>>2]|0;do if(M|0){P=M+12|0;Q=f[P>>2]|0;f[P>>2]=Q+-1;if((Q|0)!=1)break;kL(r)}while(0);f[h>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[C>>2]|0)>0){n=f[H>>2]|0;H=0;do{f[n+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[C>>2]|0))}C=f[L>>2]|0;if((C|0)==(K|0)){u=q;return}UC(C);u=q;return}function oX(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;j=u;u=u+1120|0;k=j+1104|0;l=j+64|0;m=j+56|0;o=j+48|0;q=j+40|0;r=j+32|0;s=j+24|0;t=j+16|0;v=j+8|0;w=j;dQ(k,47240);x=f[a+40>>2]|0;y=f[x+4>>2]|0;z=f[x>>2]|0;x=f[a>>2]|0;A=x&4095;switch(i&3){case 0:{B=c+8|0;C=c+12|0;D=z;break}case 1:{B=c+8|0;C=c+12|0;D=y;break}case 2:{B=c+12|0;C=c+8|0;D=z;break}case 3:{B=c+12|0;C=c+8|0;D=y;break}default:{}}E=f[C>>2]|0;C=f[B>>2]|0;a:do if((i|0)==0&(C+-2|0)>>>0<3?(C|0)==(E|0)|(C|0)==(D|0):0){switch(x&4095){case 5:{B=f[h+16>>2]|0;F=f[a+16>>2]|0;G=f[c+16>>2]|0;H=f[e+16>>2]|0;I=f[h+48>>2]|0;J=I>>>2;K=f[a+48>>2]|0;L=K>>>2;M=f[c+48>>2]|0;N=M>>>2;if(!H)O=0;else O=(f[e+48>>2]|0)>>>2;P=(H|0)==0?503292:H;switch(C|0){case 2:{if(!((E|0)!=2|(G|0)==(B|0))){if((D|0)<=0)break a;Q=G+(N<<2)|0;R=G+4|0;S=G+(N+1<<2)|0;T=0;U=B;V=F;W=P;while(1){X=+n[V>>2];Z=+n[V+4>>2];_=X*+n[R>>2]+Z*+n[S>>2];n[U>>2]=(X*+n[G>>2]+Z*+n[Q>>2])*d+ +n[W>>2]*g;n[U+4>>2]=_*d+ +n[W+4>>2]*g;T=T+1|0;if((T|0)==(D|0))break a;else{U=U+(J<<2)|0;V=V+(L<<2)|0;W=W+(O<<2)|0}}}if((F|0)!=(B|0)){W=(P|0)==503292;V=(W^1)&1;U=W?1:O;if((E|0)<=0)break a;W=F+4|0;T=F+(L<<2)|0;Q=F+(L+1<<2)|0;S=G;R=0;$=B;aa=P;while(1){_=+n[S>>2];Z=+n[S+(N<<2)>>2];X=_*+n[T>>2]+Z*+n[Q>>2];n[$>>2]=(+n[F>>2]*_+ +n[W>>2]*Z)*d+ +n[aa>>2]*g;n[$+(J<<2)>>2]=X*d+ +n[aa+(U<<2)>>2]*g;R=R+1|0;if((R|0)==(E|0))break a;else{S=S+4|0;$=$+4|0;aa=aa+(V<<2)|0}}}break}case 3:{if(!((E|0)!=3|(G|0)==(B|0))){if((D|0)<=0)break a;V=G+(N<<2)|0;aa=N<<1;$=G+(aa<<2)|0;S=G+4|0;R=G+(N+1<<2)|0;U=G+((aa|1)<<2)|0;W=G+8|0;Q=G+(N+2<<2)|0;T=G+(aa+2<<2)|0;aa=F;ba=0;ca=B;da=P;while(1){X=+n[aa>>2];Z=+n[aa+4>>2];_=+n[aa+8>>2];ea=X*+n[S>>2]+Z*+n[R>>2]+_*+n[U>>2];fa=X*+n[W>>2]+Z*+n[Q>>2]+_*+n[T>>2];n[ca>>2]=(X*+n[G>>2]+Z*+n[V>>2]+_*+n[$>>2])*d+ +n[da>>2]*g;n[ca+4>>2]=ea*d+ +n[da+4>>2]*g;n[ca+8>>2]=fa*d+ +n[da+8>>2]*g;ba=ba+1|0;if((ba|0)==(D|0))break a;else{aa=aa+(L<<2)|0;ca=ca+(J<<2)|0;da=da+(O<<2)|0}}}if((F|0)!=(B|0)){da=(P|0)==503292;ca=(da^1)&1;aa=da?1:O;if((E|0)<=0)break a;da=F+4|0;ba=F+8|0;$=N<<1;V=F+(L<<2)|0;T=F+(L+1<<2)|0;Q=F+(L+2<<2)|0;W=L<<1;U=F+(W<<2)|0;R=F+((W|1)<<2)|0;S=F+(W+2<<2)|0;W=aa<<1;ga=J<<1;ha=G;ia=0;ja=B;ka=P;while(1){fa=+n[ha>>2];ea=+n[ha+(N<<2)>>2];_=+n[ha+($<<2)>>2];Z=fa*+n[V>>2]+ea*+n[T>>2]+_*+n[Q>>2];X=fa*+n[U>>2]+ea*+n[R>>2]+_*+n[S>>2];n[ja>>2]=(+n[F>>2]*fa+ +n[da>>2]*ea+ +n[ba>>2]*_)*d+ +n[ka>>2]*g;n[ja+(J<<2)>>2]=Z*d+ +n[ka+(aa<<2)>>2]*g;n[ja+(ga<<2)>>2]=X*d+ +n[ka+(W<<2)>>2]*g;ia=ia+1|0;if((ia|0)==(E|0))break a;else{ha=ha+4|0;ja=ja+4|0;ka=ka+(ca<<2)|0}}}break}case 4:{if(!((E|0)!=4|(G|0)==(B|0))){if((D|0)<=0)break a;ca=G+(N<<2)|0;ka=N<<1;ja=G+(ka<<2)|0;ha=N*3|0;ia=G+(ha<<2)|0;W=G+4|0;ga=G+(N+1<<2)|0;aa=G+((ka|1)<<2)|0;ba=G+(ha+1<<2)|0;da=G+8|0;S=G+(N+2<<2)|0;R=G+(ka+2<<2)|0;U=G+(ha+2<<2)|0;Q=G+12|0;T=G+(N+3<<2)|0;V=G+(ka+3<<2)|0;ka=G+(ha+3<<2)|0;ha=F;$=0;la=B;ma=P;while(1){X=+n[ha>>2];Z=+n[ha+4>>2];_=+n[ha+8>>2];ea=+n[ha+12>>2];fa=X*+n[W>>2]+Z*+n[ga>>2]+_*+n[aa>>2]+ea*+n[ba>>2];na=X*+n[da>>2]+Z*+n[S>>2]+_*+n[R>>2]+ea*+n[U>>2];oa=X*+n[Q>>2]+Z*+n[T>>2]+_*+n[V>>2]+ea*+n[ka>>2];n[la>>2]=(X*+n[G>>2]+Z*+n[ca>>2]+_*+n[ja>>2]+ea*+n[ia>>2])*d+ +n[ma>>2]*g;n[la+4>>2]=fa*d+ +n[ma+4>>2]*g;n[la+8>>2]=na*d+ +n[ma+8>>2]*g;n[la+12>>2]=oa*d+ +n[ma+12>>2]*g;$=$+1|0;if(($|0)==(D|0))break a;else{ha=ha+(L<<2)|0;la=la+(J<<2)|0;ma=ma+(O<<2)|0}}}if((F|0)!=(B|0)){ma=(P|0)==503292;la=(ma^1)&1;ha=ma?1:O;if((E|0)<=0)break a;ma=F+4|0;$=F+8|0;ia=N<<1;ja=F+12|0;ca=N*3|0;ka=F+(L<<2)|0;V=F+(L+1<<2)|0;T=F+(L+2<<2)|0;Q=F+(L+3<<2)|0;U=L<<1;R=F+(U<<2)|0;S=F+((U|1)<<2)|0;da=F+(U+2<<2)|0;ba=F+(U+3<<2)|0;U=L*3|0;aa=F+(U<<2)|0;ga=F+(U+1<<2)|0;W=F+(U+2<<2)|0;pa=F+(U+3<<2)|0;U=ha<<1;qa=J<<1;ra=ha*3|0;sa=J*3|0;ta=G;ua=0;va=B;wa=P;while(1){oa=+n[ta>>2];na=+n[ta+(N<<2)>>2];fa=+n[ta+(ia<<2)>>2];ea=+n[ta+(ca<<2)>>2];_=oa*+n[ka>>2]+na*+n[V>>2]+fa*+n[T>>2]+ea*+n[Q>>2];Z=oa*+n[R>>2]+na*+n[S>>2]+fa*+n[da>>2]+ea*+n[ba>>2];X=oa*+n[aa>>2]+na*+n[ga>>2]+fa*+n[W>>2]+ea*+n[pa>>2];n[va>>2]=(+n[F>>2]*oa+ +n[ma>>2]*na+ +n[$>>2]*fa+ +n[ja>>2]*ea)*d+ +n[wa>>2]*g;n[va+(J<<2)>>2]=_*d+ +n[wa+(ha<<2)>>2]*g;n[va+(qa<<2)>>2]=Z*d+ +n[wa+(U<<2)>>2]*g;n[va+(sa<<2)>>2]=X*d+ +n[wa+(ra<<2)>>2]*g;ua=ua+1|0;if((ua|0)==(E|0))break a;else{ta=ta+4|0;va=va+4|0;wa=wa+(la<<2)|0}}}break}default:{}}if((A|0)==6){xa=I;ya=K;za=M;Aa=H;Ba=H;Ca=G;Da=B;Ea=F}else{Fa=66;break a}break}case 6:{la=f[e+16>>2]|0;xa=f[h+48>>2]|0;ya=f[a+48>>2]|0;za=f[c+48>>2]|0;Aa=la;Ba=la;Ca=f[c+16>>2]|0;Da=f[h+16>>2]|0;Ea=f[a+16>>2]|0;break}default:{Fa=66;break a}}la=xa>>>3;wa=ya>>>3;va=za>>>3;if(!Aa)Ga=0;else Ga=(f[e+48>>2]|0)>>>3;ta=(Ba|0)==0?491056:Ba;switch(C|0){case 2:{if(!((E|0)!=2|(Ca|0)==(Da|0))){if((D|0)<=0)break a;ua=Ca+(va<<3)|0;ra=Ca+8|0;sa=Ca+(va+1<<3)|0;U=Da;qa=Ea;ha=ta;J=0;while(1){X=+p[qa>>3];Z=+p[qa+8>>3];_=X*+p[ra>>3]+Z*+p[sa>>3];p[U>>3]=(X*+p[Ca>>3]+Z*+p[ua>>3])*d+ +p[ha>>3]*g;p[U+8>>3]=_*d+ +p[ha+8>>3]*g;J=J+1|0;if((J|0)==(D|0))break a;else{U=U+(la<<3)|0;qa=qa+(wa<<3)|0;ha=ha+(Ga<<3)|0}}}if((Ea|0)==(Da|0)){Fa=66;break a}ha=(ta|0)==491056;qa=(ha^1)&1;U=ha?1:Ga;if((E|0)<=0)break a;ha=Ea+8|0;J=Ea+(wa<<3)|0;ua=Ea+(wa+1<<3)|0;sa=Ca;ra=Da;F=ta;B=0;while(1){_=+p[sa>>3];Z=+p[sa+(va<<3)>>3];X=_*+p[J>>3]+Z*+p[ua>>3];p[ra>>3]=(+p[Ea>>3]*_+ +p[ha>>3]*Z)*d+ +p[F>>3]*g;p[ra+(la<<3)>>3]=X*d+ +p[F+(U<<3)>>3]*g;B=B+1|0;if((B|0)==(E|0))break;else{sa=sa+8|0;ra=ra+8|0;F=F+(qa<<3)|0}}break}case 3:{if(!((E|0)!=3|(Ca|0)==(Da|0))){if((D|0)<=0)break a;qa=Ca+(va<<3)|0;F=va<<1;ra=Ca+(F<<3)|0;sa=Ca+8|0;B=Ca+(va+1<<3)|0;U=Ca+((F|1)<<3)|0;ha=Ca+16|0;ua=Ca+(va+2<<3)|0;J=Ca+(F+2<<3)|0;F=Ea;G=Da;H=ta;M=0;while(1){X=+p[F>>3];Z=+p[F+8>>3];_=+p[F+16>>3];ea=X*+p[sa>>3]+Z*+p[B>>3]+_*+p[U>>3];fa=X*+p[ha>>3]+Z*+p[ua>>3]+_*+p[J>>3];p[G>>3]=(X*+p[Ca>>3]+Z*+p[qa>>3]+_*+p[ra>>3])*d+ +p[H>>3]*g;p[G+8>>3]=ea*d+ +p[H+8>>3]*g;p[G+16>>3]=fa*d+ +p[H+16>>3]*g;M=M+1|0;if((M|0)==(D|0))break a;else{F=F+(wa<<3)|0;G=G+(la<<3)|0;H=H+(Ga<<3)|0}}}if((Ea|0)==(Da|0)){Fa=66;break a}H=(ta|0)==491056;G=(H^1)&1;F=H?1:Ga;if((E|0)<=0)break a;H=Ea+8|0;M=Ea+16|0;ra=va<<1;qa=Ea+(wa<<3)|0;J=Ea+(wa+1<<3)|0;ua=Ea+(wa+2<<3)|0;ha=wa<<1;U=Ea+(ha<<3)|0;B=Ea+((ha|1)<<3)|0;sa=Ea+(ha+2<<3)|0;ha=F<<1;K=la<<1;I=Ca;ja=Da;$=ta;ma=0;while(1){fa=+p[I>>3];ea=+p[I+(va<<3)>>3];_=+p[I+(ra<<3)>>3];Z=fa*+p[qa>>3]+ea*+p[J>>3]+_*+p[ua>>3];X=fa*+p[U>>3]+ea*+p[B>>3]+_*+p[sa>>3];p[ja>>3]=(+p[Ea>>3]*fa+ +p[H>>3]*ea+ +p[M>>3]*_)*d+ +p[$>>3]*g;p[ja+(la<<3)>>3]=Z*d+ +p[$+(F<<3)>>3]*g;p[ja+(K<<3)>>3]=X*d+ +p[$+(ha<<3)>>3]*g;ma=ma+1|0;if((ma|0)==(E|0))break;else{I=I+8|0;ja=ja+8|0;$=$+(G<<3)|0}}break}case 4:{if(!((E|0)!=4|(Ca|0)==(Da|0))){if((D|0)<=0)break a;G=Ca+(va<<3)|0;$=va<<1;ja=Ca+($<<3)|0;I=va*3|0;ma=Ca+(I<<3)|0;ha=Ca+8|0;K=Ca+(va+1<<3)|0;F=Ca+(($|1)<<3)|0;M=Ca+(I+1<<3)|0;H=Ca+16|0;sa=Ca+(va+2<<3)|0;B=Ca+($+2<<3)|0;U=Ca+(I+2<<3)|0;ua=Ca+24|0;J=Ca+(va+3<<3)|0;qa=Ca+($+3<<3)|0;$=Ca+(I+3<<3)|0;I=0;ra=Ea;pa=Da;W=ta;while(1){X=+p[ra>>3];Z=+p[ra+8>>3];_=+p[ra+16>>3];ea=+p[ra+24>>3];fa=X*+p[ha>>3]+Z*+p[K>>3]+_*+p[F>>3]+ea*+p[M>>3];na=X*+p[H>>3]+Z*+p[sa>>3]+_*+p[B>>3]+ea*+p[U>>3];oa=X*+p[ua>>3]+Z*+p[J>>3]+_*+p[qa>>3]+ea*+p[$>>3];p[pa>>3]=(X*+p[Ca>>3]+Z*+p[G>>3]+_*+p[ja>>3]+ea*+p[ma>>3])*d+ +p[W>>3]*g;p[pa+8>>3]=fa*d+ +p[W+8>>3]*g;p[pa+16>>3]=na*d+ +p[W+16>>3]*g;p[pa+24>>3]=oa*d+ +p[W+24>>3]*g;I=I+1|0;if((I|0)==(D|0))break a;else{ra=ra+(wa<<3)|0;pa=pa+(la<<3)|0;W=W+(Ga<<3)|0}}}if((E|0)>16|(Ea|0)==(Da|0)){Fa=66;break a}W=(ta|0)==491056;pa=W?1:Ga;ra=(W^1)&1;if((E|0)<=0)break a;W=Ea+8|0;I=Ea+16|0;ma=va<<1;ja=Ea+24|0;G=va*3|0;$=Ea+(wa<<3)|0;qa=Ea+(wa+1<<3)|0;J=Ea+(wa+2<<3)|0;ua=Ea+(wa+3<<3)|0;U=wa<<1;B=Ea+(U<<3)|0;sa=Ea+((U|1)<<3)|0;H=Ea+(U+2<<3)|0;M=Ea+(U+3<<3)|0;U=wa*3|0;F=Ea+(U<<3)|0;K=Ea+(U+1<<3)|0;ha=Ea+(U+2<<3)|0;ga=Ea+(U+3<<3)|0;U=pa<<1;aa=la<<1;ba=pa*3|0;da=la*3|0;S=0;R=Ca;Q=Da;T=ta;while(1){oa=+p[R>>3];na=+p[R+(va<<3)>>3];fa=+p[R+(ma<<3)>>3];ea=+p[R+(G<<3)>>3];_=oa*+p[$>>3]+na*+p[qa>>3]+fa*+p[J>>3]+ea*+p[ua>>3];Z=oa*+p[B>>3]+na*+p[sa>>3]+fa*+p[H>>3]+ea*+p[M>>3];X=oa*+p[F>>3]+na*+p[K>>3]+fa*+p[ha>>3]+ea*+p[ga>>3];p[Q>>3]=(+p[Ea>>3]*oa+ +p[W>>3]*na+ +p[I>>3]*fa+ +p[ja>>3]*ea)*d+ +p[T>>3]*g;p[Q+(la<<3)>>3]=_*d+ +p[T+(pa<<3)>>3]*g;p[Q+(aa<<3)>>3]=Z*d+ +p[T+(U<<3)>>3]*g;p[Q+(da<<3)>>3]=X*d+ +p[T+(ba<<3)>>3]*g;S=S+1|0;if((S|0)==(E|0))break;else{R=R+8|0;Q=Q+8|0;T=T+(ra<<3)|0}}break}default:{Fa=66;break a}}}else Fa=66;while(0);if((Fa|0)==66){Ea=f[c+48>>2]|0;Da=e+16|0;Ca=f[Da>>2]|0;if(!Ca)Ha=0;else Ha=f[e+48>>2]|0;Ga=l+8|0;f[l>>2]=Ga;Ba=l+4|0;f[Ba>>2]=1032;switch(x&4095){case 5:{Ia=2;Ja=104;Ka=1;break}case 6:{Ia=3;Ja=105;Ka=2;break}case 13:{Ia=4;Ja=106;Ka=3;break}case 14:{Fa=72;break}default:{f[m>>2]=0;f[m+4>>2]=0;Aa=aD(m,49)|0;za=212190;ya=Aa+49|0;do{b[Aa>>0]=b[za>>0]|0;Aa=Aa+1|0;za=za+1|0}while((Aa|0)<(ya|0));bO(-215,m,212240,212249,1218);bD(m);Fa=72}}if((Fa|0)==72){Ia=5;Ja=107;Ka=4}m=(E|0)==1;if((i&2|0)==0&(m|(C|0)==1)?(f[c>>2]&16384|0)!=0:0){if(m)La=0;else La=(x>>>3&511)+1<<(47696>>>(A<<1&14)&3);Ma=i|2;Na=La}else{Ma=i;Na=Ea}if((D|0)<65)if((C|0)<10001)Fa=83;else Fa=81;else if((C|0)<11|(E|0)<65&(C|0)<10001)Fa=83;else Fa=81;do if((Fa|0)==81){if((E|0)<129?(D|0)<129&(C|0)<129:0){Fa=83;break}Ea=x&7;i=(x>>>3&511)+1<<(47696>>>(Ea<<1)&3);La=i<<((Ea|0)==5&1);Ea=(Ma&1|0)!=0;A=a+48|0;m=f[A>>2]|0;za=Ea?i:m;Aa=Ea?m:i;m=(Ma&2|0)!=0;ya=m?i:Na;xa=m?Na:i;if(f[Da>>2]|0){O=f[e+4>>2]|0;if((O|0)<3)Oa=Y(f[e+12>>2]|0,f[e+8>>2]|0)|0;else{ra=f[e+40>>2]|0;T=0;Q=1;while(1){R=Y(f[ra+(T<<2)>>2]|0,Q)|0;T=T+1|0;if((T|0)==(O|0)){Oa=R;break}else Q=R}}if(!((O|0)==0|(Oa|0)==0)){Q=(Ma&4|0)==0;T=f[e+48>>2]|0;Pa=Q?i:T;Qa=Q?T:i;Ra=Ma}else Fa=90}else Fa=90;if((Fa|0)==90){Pa=0;Qa=0;Ra=Ma&-5}T=(D|0)<128?D:128;Q=(E|0)<128?E:128;ra=16384/(T|0)|0;R=16384/(Q|0)|0;S=(R|0)<(ra|0)?R:ra;ra=(C|0)<(S|0)?C:S;if((Y(ra,T)|0)>16384)Sa=16384/(ra|0)|0;else Sa=T;if((Y(ra,Q)|0)>16384)Ta=16384/(ra|0)|0;else Ta=Q;Q=((ra|0)/8|0)+ra|0;T=Y(Ta+2+((Ta|0)/8|0)&-2,Q+1|0)|0;R=Y(T,i)|0;ba=Y(T,La)|0;if(Ea){Ua=Y(Y(Q+2&-2,i)|0,Sa+1+((Sa|0)/8|0)|0)|0;Va=Ra&-2}else{Ua=0;Va=Ra}Q=ba+R+Ua|0;if((f[Ba>>2]|0)>>>0<Q>>>0){T=f[l>>2]|0;if((T|0)!=(Ga|0)){if(T|0)P5b(T);f[l>>2]=Ga;f[Ba>>2]=1032}f[Ba>>2]=Q;if(Q>>>0>1032){T=N5b(Q)|0;f[l>>2]=T;Wa=T}else Wa=Ga}else{f[Ba>>2]=Q;Wa=f[l>>2]|0}Q=Wa+ba|0;ba=Q+R|0;R=Ea?ba:0;if((D|0)>0){T=D<<3;da=(E|0)>0;U=h+16|0;aa=h+44|0;pa=h+48|0;la=E<<3;ja=(C|0)>(S|0);S=(C|0)>0;I=w+4|0;W=a+16|0;ga=c+16|0;ha=C<<3;K=Ea&(R|0)!=0;F=(i|0)==4;M=i&65535;H=i>>>2;sa=r+4|0;B=s+4|0;ua=t+4|0;J=v+4|0;qa=0;$=Va;while(1){G=qa+Sa|0;if((G|0)<(D|0)?((G<<3)+Sa|0)<=(T|0):0)Xa=Sa;else Xa=D-qa|0;if(da){G=Ca+(Y(qa,Qa)|0)|0;ma=Y(qa,za)|0;va=0;ta=$;while(1){wa=f[pa>>2]|0;V=Y(va,i)|0;ka=(f[U>>2]|0)+(Y(wa,qa)|0)+V|0;ca=G+(Y(va,Pa)|0)|0;ia=va+Ta|0;if((ia|0)<(E|0)?((ia<<3)+Ta|0)<=(la|0):0)Ya=Ta;else Ya=E-va|0;ia=ta&15;N=Y(Ya,La)|0;P=ja?Wa:ka;ka=ja?N:wa;if(S){wa=Y(va,xa)|0;N=(Ya|0)<(E|0);L=0;Za=ia;while(1){_a=(f[W>>2]|0)+ma+(Y(L,Aa)|0)|0;$a=f[A>>2]|0;ab=(f[ga>>2]|0)+(Y(L,ya)|0)+wa|0;bb=L+ra|0;if((bb|0)<(C|0)?((bb<<3)+ra|0)<=(ha|0):0)cb=ra;else cb=C-L|0;bb=Ea?Xa:cb;db=Ea?cb:Xa;b:do if(K){eb=Y(cb,i)|0;if((bb|0)<=0){fb=eb;gb=ba;hb=db;ib=bb;break}jb=(db|0)>0;if(F){if(jb){kb=_a;lb=ba;mb=0}else{fb=eb;gb=R;hb=db;ib=bb;break}while(1){nb=0;ob=kb;while(1){f[lb+(nb<<2)>>2]=f[ob>>2];nb=nb+1|0;if((nb|0)==(db|0))break;else ob=ob+$a|0}mb=mb+1|0;if((mb|0)==(bb|0)){fb=eb;gb=R;hb=db;ib=bb;break b}else{kb=kb+4|0;lb=lb+eb|0}}}ob=db<<2;nb=db<<1;switch(M&8191){case 16:{pb=_a;qb=ba;rb=0;while(1){if(jb){sb=pb;tb=0;while(1){ub=f[sb+4>>2]|0;f[qb+(tb<<2)>>2]=f[sb>>2];f[qb+((tb|1)<<2)>>2]=ub;ub=f[sb+12>>2]|0;f[qb+((tb|2)<<2)>>2]=f[sb+8>>2];f[qb+((tb|3)<<2)>>2]=ub;tb=tb+4|0;if((tb|0)>=(ob|0))break;else sb=sb+$a|0}}rb=rb+1|0;if((rb|0)==(bb|0)){fb=eb;gb=R;hb=db;ib=bb;break}else{pb=pb+i|0;qb=qb+eb|0}}break}case 8:{qb=_a;pb=ba;rb=0;while(1){if(jb){ob=qb;sb=0;while(1){tb=f[ob+4>>2]|0;f[pb+(sb<<2)>>2]=f[ob>>2];f[pb+((sb|1)<<2)>>2]=tb;sb=sb+2|0;if((sb|0)>=(nb|0))break;else ob=ob+$a|0}}rb=rb+1|0;if((rb|0)==(bb|0)){fb=eb;gb=R;hb=db;ib=bb;break}else{qb=qb+i|0;pb=pb+eb|0}}break}default:{fb=eb;gb=ba;hb=db;ib=bb;break b}}}else{fb=$a;gb=_a;hb=bb;ib=db}while(0);c:do if(N){db=m?cb:Ya;bb=m?Ya:cb;_a=Y(db,i)|0;$a=Y(db,H)|0;if(!bb){vb=_a;wb=Q;break}db=$a+-4|0;if(($a|0)<4){pb=($a|0)>0;qb=Q;rb=ab;nb=bb;while(1){nb=nb+-1|0;if(pb){jb=0;do{f[qb+(jb<<2)>>2]=f[rb+(jb<<2)>>2];jb=jb+1|0}while((jb|0)!=($a|0))}if(!nb){vb=_a;wb=Q;break c}else{qb=qb+_a|0;rb=rb+Na|0}}}rb=$a&-4;qb=(rb|0)<($a|0);nb=Q;pb=ab;eb=bb;while(1){jb=0;do{ob=jb|1;sb=f[pb+(ob<<2)>>2]|0;f[nb+(jb<<2)>>2]=f[pb+(jb<<2)>>2];f[nb+(ob<<2)>>2]=sb;sb=jb|2;ob=jb|3;tb=f[pb+(ob<<2)>>2]|0;f[nb+(sb<<2)>>2]=f[pb+(sb<<2)>>2];f[nb+(ob<<2)>>2]=tb;jb=jb+4|0}while((jb|0)<=(db|0));eb=eb+-1|0;if(qb){jb=rb;do{f[nb+(jb<<2)>>2]=f[pb+(jb<<2)>>2];jb=jb+1|0}while((jb|0)!=($a|0))}if(!eb){vb=_a;wb=Q;break}else{nb=nb+_a|0;pb=pb+Na|0}}}else{vb=Na;wb=ab}while(0);if(ja){f[r>>2]=hb;f[sa>>2]=ib;f[s>>2]=Ya;f[B>>2]=Xa;Th[Ja&127](gb,fb,wb,vb,P,ka,r,s,Za)}else{f[t>>2]=hb;f[ua>>2]=ib;f[v>>2]=Ya;f[J>>2]=Xa;Cg[Ka&7](gb,fb,wb,vb,ca,Ha,P,ka,t,v,d,g,Za)}ab=Za|16;L=cb+L|0;if((C|0)<=(L|0)){xb=ab;break}else Za=ab}}else xb=ia;if(ja){Za=(f[U>>2]|0)+(Y(f[f[aa>>2]>>2]|0,qa)|0)+V|0;L=f[pa>>2]|0;f[w>>2]=Ya;f[I>>2]=Xa;ei[Ia&7](ca,Ha,P,ka,Za,L,w,d,g,xb)}va=Ya+va|0;if((E|0)<=(va|0)){yb=xb;break}else ta=xb}}else yb=$;qa=Xa+qa|0;if((D|0)<=(qa|0))break;else $=yb}}}while(0);if((Fa|0)==83){Fa=f[a+16>>2]|0;yb=f[a+48>>2]|0;a=f[c+16>>2]|0;c=f[h+16>>2]|0;Xa=f[h+48>>2]|0;f[o>>2]=y;f[o+4>>2]=z;f[q>>2]=E;f[q+4>>2]=D;Cg[Ka&7](Fa,yb,a,Na,Ca,Ha,c,Xa,o,q,d,g,Ma)}Ma=f[l>>2]|0;if((Ma|0)!=(Ga|0)){if(Ma|0)P5b(Ma);f[l>>2]=Ga;f[Ba>>2]=1032}}if(!(f[k+4>>2]|0)){u=j;return}u=j;return}function pX(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0;o=u;u=u+2192|0;q=o+1096|0;r=o;s=f[j>>2]|0;t=f[j+4>>2]|0;j=f[k>>2]|0;v=f[k+4>>2]|0;k=q+8|0;f[q>>2]=k;w=q+4|0;f[w>>2]=136;x=b>>>3;y=d>>>3;z=g>>>3;g=i>>>3;i=(e|0)==0;A=(n&4|0)==0;B=i?0:A?z:1;C=i?0:A?1:z;if(n&1)if(b>>>0>15&(t|0)>1){f[w>>2]=t;if(t>>>0>136){z=N5b(t>>>0>536870911?-1:t<<3)|0;f[q>>2]=z;D=x;E=1;F=z;G=t;H=43}else{D=x;E=1;F=k;G=t;H=43}}else{I=x;J=1;K=t;H=5}else{I=1;J=x;K=s;H=5}if((H|0)==5)if((K|0)==1){s=r+8|0;f[r>>2]=s;z=r+4|0;f[z>>2]=136;if(b>>>0>15&(t|0)>1){f[w>>2]=v;if(v>>>0>136){t=N5b(v>>>0>536870911?-1:v<<3)|0;f[q>>2]=t;L=t}else L=k;if((v|0)>0){t=0;do{b=a+((Y(t,x)|0)<<3)|0;p[L+(t<<3)>>3]=+p[b>>3];t=t+1|0}while((t|0)!=(v|0));M=L}else M=L}else M=a;if(d>>>0>15){f[z>>2]=j;if(j>>>0>136){d=N5b(j>>>0>536870911?-1:j<<3)|0;f[r>>2]=d;N=d}else N=s;if((j|0)>0){d=0;do{L=c+((Y(d,y)|0)<<3)|0;p[N+(d<<3)>>3]=+p[L>>3];d=d+1|0}while((d|0)!=(j|0));O=N;P=N}else{O=N;P=N}}else{O=c;P=s}a:do if((v|0)>0){N=C<<1;if((j|0)<2){if((j|0)==1){Q=h;R=0;S=e}else break;while(1){T=+p[M+(R<<3)>>3]*l*+p[O>>3];if(!S)U=T;else U=T+ +p[S>>3]*m;p[Q>>3]=U;R=R+1|0;if((R|0)==(v|0))break a;else{Q=Q+(g<<3)|0;S=S+(B<<3)|0}}}d=j+-2|0;L=((d|0)>1?d:1)>>>1;t=Y(L,N)|0;x=(L<<1)+2|0;if((x|0)>=(j|0)){L=h;b=0;A=e;while(1){T=+p[M+(b<<3)>>3]*l;i=A;V=0;while(1){W=T*+p[O+(V<<3)>>3];X=V|1;Z=T*+p[O+(X<<3)>>3];if(!i){p[L+(V<<3)>>3]=W;_=Z}else{p[L+(V<<3)>>3]=W+ +p[i>>3]*m;_=Z+ +p[i+(C<<3)>>3]*m}p[L+(X<<3)>>3]=_;V=V+2|0;if((V|0)>(d|0))break;else i=i+(N<<3)|0}b=b+1|0;if((b|0)==(v|0))break a;else{L=L+(g<<3)|0;A=A+(B<<3)|0}}}A=h;L=0;b=e;i=e+(N<<3)|0;while(1){T=+p[M+(L<<3)>>3]*l;V=b;X=0;while(1){Z=T*+p[O+(X<<3)>>3];$=X|1;W=T*+p[O+($<<3)>>3];if(!V){p[A+(X<<3)>>3]=Z;aa=W}else{p[A+(X<<3)>>3]=Z+ +p[V>>3]*m;aa=W+ +p[V+(C<<3)>>3]*m}p[A+($<<3)>>3]=aa;X=X+2|0;if((X|0)>(d|0))break;else V=V+(N<<3)|0}V=i+(t<<3)|0;X=x;while(1){W=T*+p[O+(X<<3)>>3];if(!V)ba=W;else ba=W+ +p[V>>3]*m;p[A+(X<<3)>>3]=ba;X=X+1|0;if((X|0)==(j|0))break;else V=V+(C<<3)|0}L=L+1|0;if((L|0)==(v|0))break;else{A=A+(g<<3)|0;b=b+(B<<3)|0;i=i+(B<<3)|0}}}while(0);if((P|0)!=(s|0)){P5b(P);f[r>>2]=s;f[z>>2]=136}}else{D=I;E=J;F=0;G=K;H=43}b:do if((H|0)==43){if(n&2|0){if((v|0)<=0)break;K=(F|0)==0;J=(j|0)>0;I=G+-4|0;z=(G|0)<4;s=G&-4;P=K|(G|0)<1;O=(G|0)>0;M=(s|0)<(G|0);ba=l*0.0;S=a;Q=h;R=0;i=e;while(1){if(P)ca=K?S:F;else{b=0;do{A=S+((Y(b,D)|0)<<3)|0;p[F+(b<<3)>>3]=+p[A>>3];b=b+1|0}while((b|0)!=(G|0));ca=F}c:do if(J){if(z){if(O){da=c;ea=i;fa=0}else{b=i;A=0;while(1){if(!b)ga=ba;else ga=ba+ +p[b>>3]*m;p[Q+(A<<3)>>3]=ga;A=A+1|0;if((A|0)==(j|0))break c;else b=b+(C<<3)|0}}while(1){aa=0.0;b=0;do{aa=aa+ +p[ca+(b<<3)>>3]*+p[da+(b<<3)>>3];b=b+1|0}while((b|0)!=(G|0));_=(aa+0.0)*l;if(!ea)ha=_;else ha=_+ +p[ea>>3]*m;p[Q+(fa<<3)>>3]=ha;fa=fa+1|0;if((fa|0)==(j|0))break c;else{da=da+(y<<3)|0;ea=ea+(C<<3)|0}}}if(M){ia=c;ja=i;ka=0}else{b=c;A=i;L=0;while(1){_=0.0;U=0.0;T=0.0;W=0.0;x=0;do{W=W+ +p[ca+(x<<3)>>3]*+p[b+(x<<3)>>3];t=x|1;T=T+ +p[ca+(t<<3)>>3]*+p[b+(t<<3)>>3];t=x|2;U=U+ +p[ca+(t<<3)>>3]*+p[b+(t<<3)>>3];t=x|3;_=_+ +p[ca+(t<<3)>>3]*+p[b+(t<<3)>>3];x=x+4|0}while((x|0)<=(I|0));aa=(_+(U+(T+W)))*l;if(!A)la=aa;else la=aa+ +p[A>>3]*m;p[Q+(L<<3)>>3]=la;L=L+1|0;if((L|0)==(j|0))break c;else{b=b+(y<<3)|0;A=A+(C<<3)|0}}}while(1){aa=0.0;Z=0.0;ma=0.0;na=0.0;A=0;while(1){oa=na+ +p[ca+(A<<3)>>3]*+p[ia+(A<<3)>>3];b=A|1;ma=ma+ +p[ca+(b<<3)>>3]*+p[ia+(b<<3)>>3];b=A|2;Z=Z+ +p[ca+(b<<3)>>3]*+p[ia+(b<<3)>>3];b=A|3;aa=aa+ +p[ca+(b<<3)>>3]*+p[ia+(b<<3)>>3];A=A+4|0;if((A|0)>(I|0)){pa=oa;qa=s;break}else na=oa}do{pa=pa+ +p[ca+(qa<<3)>>3]*+p[ia+(qa<<3)>>3];qa=qa+1|0}while((qa|0)!=(G|0));na=(aa+(Z+(ma+pa)))*l;if(!ja)ra=na;else ra=na+ +p[ja>>3]*m;p[Q+(ka<<3)>>3]=ra;ka=ka+1|0;if((ka|0)==(j|0))break;else{ia=ia+(y<<3)|0;ja=ja+(C<<3)|0}}}while(0);R=R+1|0;if((R|0)==(v|0))break b;else{S=S+(E<<3)|0;Q=Q+(g<<3)|0;i=i+(B<<3)|0}}}i=j<<3;if(i>>>0<1601){if((v|0)<=0)break;Q=(F|0)==0;S=j+-4|0;R=(j|0)<4;s=(G|0)>0;I=C<<2;M=C<<1;O=C*3|0;z=S>>>2;J=(z<<2)+4|0;K=Q|(G|0)<1;ba=l*0.0;P=a;A=h;b=0;L=e;x=e+(Y((z<<5)+32|0,C)|0)|0;while(1){if(K)sa=Q?P:F;else{z=0;do{t=P+((Y(z,D)|0)<<3)|0;p[F+(z<<3)>>3]=+p[t>>3];z=z+1|0}while((z|0)!=(G|0));sa=F}d:do if(R){ta=L;ua=0}else{if(s){va=L;wa=0}else{z=L;t=0;while(1){N=t|1;d=t|2;if(!z){p[A+(t<<3)>>3]=ba;p[A+(N<<3)>>3]=ba;p[A+(d<<3)>>3]=ba;xa=ba}else{p[A+(t<<3)>>3]=ba+ +p[z>>3]*m;p[A+(N<<3)>>3]=ba+ +p[z+(C<<3)>>3]*m;p[A+(d<<3)>>3]=ba+ +p[z+(M<<3)>>3]*m;xa=ba+ +p[z+(O<<3)>>3]*m}p[A+((t|3)<<3)>>3]=xa;t=t+4|0;if((t|0)>(S|0)){ta=x;ua=J;break d}else z=z+(I<<3)|0}}while(1){na=0.0;W=0.0;T=0.0;U=0.0;z=c+(wa<<3)|0;t=0;while(1){_=+p[sa+(t<<3)>>3];U=U+_*+p[z>>3];T=T+_*+p[z+8>>3];W=W+_*+p[z+16>>3];na=na+_*+p[z+24>>3];t=t+1|0;if((t|0)==(G|0))break;else z=z+(y<<3)|0}ma=U*l;Z=na*l;z=wa|1;t=wa|2;aa=W*l;_=T*l;if(!va){p[A+(wa<<3)>>3]=ma;p[A+(z<<3)>>3]=_;p[A+(t<<3)>>3]=aa;ya=Z}else{p[A+(wa<<3)>>3]=ma+ +p[va>>3]*m;p[A+(z<<3)>>3]=_+ +p[va+(C<<3)>>3]*m;p[A+(t<<3)>>3]=aa+ +p[va+(M<<3)>>3]*m;ya=Z+ +p[va+(O<<3)>>3]*m}p[A+((wa|3)<<3)>>3]=ya;wa=wa+4|0;if((wa|0)>(S|0)){ta=x;ua=J;break}else va=va+(I<<3)|0}}while(0);e:do if((ua|0)<(j|0)){if(s){za=ta;Aa=ua}else{t=ta;z=ua;while(1){if(!t)Ba=ba;else Ba=ba+ +p[t>>3]*m;p[A+(z<<3)>>3]=Ba;z=z+1|0;if((z|0)==(j|0))break e;else t=t+(C<<3)|0}}while(1){Z=0.0;t=c+(Aa<<3)|0;z=0;while(1){Z=Z+ +p[sa+(z<<3)>>3]*+p[t>>3];z=z+1|0;if((z|0)==(G|0))break;else t=t+(y<<3)|0}T=Z*l;if(!za)Ca=T;else Ca=T+ +p[za>>3]*m;p[A+(Aa<<3)>>3]=Ca;Aa=Aa+1|0;if((Aa|0)==(j|0))break;else za=za+(C<<3)|0}}while(0);b=b+1|0;if((b|0)==(v|0))break b;else{P=P+(E<<3)|0;A=A+(g<<3)|0;L=L+(B<<3)|0;x=x+(B<<3)|0}}}x=r+8|0;f[r>>2]=x;L=r+4|0;f[L>>2]=j;if(j>>>0>136){A=N5b(j>>>0>536870911?-1:j<<3)|0;f[r>>2]=A;Da=A;Ea=A}else{Da=x;Ea=x}if((v|0)>0){A=(F|0)==0;P=(j|0)>0;b=(G|0)>0;s=j+-4|0;I=(j|0)<4;J=j&-4;S=A|(G|0)<1;O=(J|0)<(j|0);M=a;R=h;Q=0;K=e;while(1){if(S)Fa=A?M:F;else{t=0;do{z=M+((Y(t,D)|0)<<3)|0;p[F+(t<<3)>>3]=+p[z>>3];t=t+1|0}while((t|0)!=(G|0));Fa=F}if(P)Nac(Ea|0,0,i|0)|0;f:do if(b){if(I){if(P){Ga=c;Ha=0}else break;while(1){ba=+p[Fa+(Ha<<3)>>3];t=0;do{z=Ea+(t<<3)|0;p[z>>3]=+p[z>>3]+ba*+p[Ga+(t<<3)>>3];t=t+1|0}while((t|0)!=(j|0));Ha=Ha+1|0;if((Ha|0)==(G|0))break f;else Ga=Ga+(y<<3)|0}}if(O){Ia=c;Ja=0}else{t=c;z=0;while(1){ba=+p[Fa+(z<<3)>>3];d=0;do{N=Ea+(d<<3)|0;V=d|1;X=Ea+(V<<3)|0;Z=+p[X>>3]+ba*+p[t+(V<<3)>>3];p[N>>3]=+p[N>>3]+ba*+p[t+(d<<3)>>3];p[X>>3]=Z;X=d|2;N=Ea+(X<<3)|0;V=d|3;$=Ea+(V<<3)|0;Z=+p[$>>3]+ba*+p[t+(V<<3)>>3];p[N>>3]=+p[N>>3]+ba*+p[t+(X<<3)>>3];p[$>>3]=Z;d=d+4|0}while((d|0)<=(s|0));z=z+1|0;if((z|0)==(G|0))break f;else t=t+(y<<3)|0}}while(1){ba=+p[Fa+(Ja<<3)>>3];t=0;do{z=Ea+(t<<3)|0;d=t|1;$=Ea+(d<<3)|0;Z=+p[$>>3]+ba*+p[Ia+(d<<3)>>3];p[z>>3]=+p[z>>3]+ba*+p[Ia+(t<<3)>>3];p[$>>3]=Z;$=t|2;z=Ea+($<<3)|0;d=t|3;X=Ea+(d<<3)|0;Z=+p[X>>3]+ba*+p[Ia+(d<<3)>>3];p[z>>3]=+p[z>>3]+ba*+p[Ia+($<<3)>>3];p[X>>3]=Z;t=t+4|0}while((t|0)<=(s|0));Ka=J;do{t=Ea+(Ka<<3)|0;p[t>>3]=+p[t>>3]+ba*+p[Ia+(Ka<<3)>>3];Ka=Ka+1|0}while((Ka|0)!=(j|0));Ja=Ja+1|0;if((Ja|0)==(G|0))break;else Ia=Ia+(y<<3)|0}}while(0);if(!K){if(P){t=0;do{p[R+(t<<3)>>3]=+p[Ea+(t<<3)>>3]*l;t=t+1|0}while((t|0)!=(j|0))}}else if(P){t=0;X=K;while(1){p[R+(t<<3)>>3]=+p[Ea+(t<<3)>>3]*l+ +p[X>>3]*m;t=t+1|0;if((t|0)==(j|0))break;else X=X+(C<<3)|0}}Q=Q+1|0;if((Q|0)==(v|0)){La=Da;break}else{M=M+(E<<3)|0;R=R+(g<<3)|0;K=K+(B<<3)|0}}}else La=Ea;if((La|0)!=(x|0)){P5b(La);f[r>>2]=x;f[L>>2]=136}}while(0);r=f[q>>2]|0;if((r|0)==(k|0)){u=o;return}if(r|0)P5b(r);f[q>>2]=k;f[w>>2]=136;u=o;return}function qX(a,b,c,d,e,g,h,i,j,k,l,m,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0,Ra=0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;q=u;u=u+2256|0;r=q+1160|0;s=q;t=f[j>>2]|0;v=f[j+4>>2]|0;j=f[k>>2]|0;w=f[k+4>>2]|0;k=r+8|0;Nac(k|0,0,1088)|0;f[r>>2]=k;x=r+4|0;f[x>>2]=136;y=b>>>3;z=d>>>3;A=g>>>3;g=i>>>3;i=(e|0)==0;B=(o&4|0)==0;C=i?0:B?A:1;D=i?0:B?1:A;if(o&1)if(b>>>0>15&(v|0)>1){f[x>>2]=v;if(v>>>0>136){A=N5b(v>>>0>536870911?-1:v<<3)|0;Nac(A|0,0,v<<3|0)|0;f[r>>2]=A;E=y;F=1;G=A;H=v;I=33}else{E=y;F=1;G=k;H=v;I=33}}else{J=y;K=1;L=v;I=5}else{J=1;K=y;L=t;I=5}if((I|0)==5)if((L|0)==1){t=s+8|0;Nac(t|0,0,1088)|0;f[s>>2]=t;A=s+4|0;f[A>>2]=136;if(b>>>0>15&(v|0)>1){f[x>>2]=w;if(w>>>0>136){v=N5b(w>>>0>536870911?-1:w<<3)|0;Nac(v|0,0,w<<3|0)|0;f[r>>2]=v;M=v}else M=k;if((w|0)>0){v=0;do{b=a+((Y(v,y)|0)<<3)|0;B=f[b+4>>2]|0;i=M+(v<<3)|0;f[i>>2]=f[b>>2];f[i+4>>2]=B;v=v+1|0}while((v|0)!=(w|0));N=M}else N=M}else N=a;if(d>>>0>15){f[A>>2]=j;if(j>>>0>136){d=N5b(j>>>0>536870911?-1:j<<3)|0;Nac(d|0,0,j<<3|0)|0;f[s>>2]=d;O=d}else O=t;if((j|0)>0){d=0;do{M=c+((Y(d,z)|0)<<3)|0;v=f[M+4>>2]|0;y=O+(d<<3)|0;f[y>>2]=f[M>>2];f[y+4>>2]=v;d=d+1|0}while((d|0)<(j|0));P=O}else P=O}else P=c;if((w|0)>0){O=D<<1;d=(j|0)<2;v=j+-2|0;y=v>>>1;M=(y<<1)+2|0;B=e;i=0;b=h;Q=e+(Y(D,(y<<4)+16|0)|0)|0;while(1){R=+n[N+(i<<3)>>2]*l;S=+n[N+(i<<3)+4>>2]*l;if(d){T=B;U=0}else{y=B;V=0;while(1){W=+n[P+(V<<3)>>2];X=+n[P+(V<<3)+4>>2];Z=R*W-S*X;_=S*W+R*X;$=V|1;X=+n[P+($<<3)>>2];W=+n[P+($<<3)+4>>2];aa=R*X-S*W;ba=S*X+R*W;if(!y){n[b+(V<<3)>>2]=Z;n[b+(V<<3)+4>>2]=_;ca=ba;da=aa}else{W=_+ +n[y+4>>2]*m;n[b+(V<<3)>>2]=Z+ +n[y>>2]*m;n[b+(V<<3)+4>>2]=W;ca=ba+ +n[y+(D<<3)+4>>2]*m;da=aa+ +n[y+(D<<3)>>2]*m}n[b+($<<3)>>2]=da;n[b+($<<3)+4>>2]=ca;V=V+2|0;if((V|0)>(v|0)){T=Q;U=M;break}else y=y+(O<<3)|0}}if((U|0)<(j|0)){y=T;V=U;while(1){aa=+n[P+(V<<3)>>2];ba=+n[P+(V<<3)+4>>2];W=R*aa-S*ba;Z=S*aa+R*ba;if(!y){ea=W;fa=Z}else{ea=W+ +n[y>>2]*m;fa=Z+ +n[y+4>>2]*m}n[b+(V<<3)>>2]=ea;n[b+(V<<3)+4>>2]=fa;V=V+1|0;if((V|0)==(j|0))break;else y=y+(D<<3)|0}}i=i+1|0;if((i|0)==(w|0))break;else{B=B+(C<<3)|0;b=b+(g<<3)|0;Q=Q+(C<<3)|0}}}Q=f[s>>2]|0;if((Q|0)!=(t|0)){if(Q|0)P5b(Q);f[s>>2]=t;f[A>>2]=136}}else{E=J;F=K;G=0;H=L;I=33}a:do if((I|0)==33){if(o&2|0){if((w|0)<=0)break;L=(G|0)==0;K=H+-4|0;J=(H|0)<4;A=H&-4;t=L|(H|0)<1;Q=(j|0)>0;b=a;B=e;i=0;P=h;while(1){if(t)ga=L?b:G;else{U=0;do{T=b+((Y(U,E)|0)<<3)|0;O=f[T+4>>2]|0;M=G+(U<<3)|0;f[M>>2]=f[T>>2];f[M+4>>2]=O;U=U+1|0}while((U|0)!=(H|0));ga=G}if(Q){U=c;O=B;M=0;while(1){if(J){ha=0;ia=0.0;ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0;oa=0.0;pa=0.0}else{T=0;fa=0.0;ea=0.0;ca=0.0;da=0.0;R=0.0;S=0.0;Z=0.0;W=0.0;while(1){ba=+n[ga+(T<<3)>>2];aa=+n[ga+(T<<3)+4>>2];_=+n[U+(T<<3)>>2];X=+n[U+(T<<3)+4>>2];qa=da+(ba*_-aa*X);ra=R+(aa*_+ba*X);v=T|1;X=+n[ga+(v<<3)>>2];ba=+n[ga+(v<<3)+4>>2];_=+n[U+(v<<3)>>2];aa=+n[U+(v<<3)+4>>2];sa=ca+(X*_-ba*aa);ta=W+(ba*_+X*aa);v=T|2;aa=+n[ga+(v<<3)>>2];X=+n[ga+(v<<3)+4>>2];_=+n[U+(v<<3)>>2];ba=+n[U+(v<<3)+4>>2];ua=ea+(aa*_-X*ba);va=Z+(X*_+aa*ba);v=T|3;ba=+n[ga+(v<<3)>>2];aa=+n[ga+(v<<3)+4>>2];_=+n[U+(v<<3)>>2];X=+n[U+(v<<3)+4>>2];wa=fa+(ba*_-aa*X);xa=S+(aa*_+ba*X);T=T+4|0;if((T|0)>(K|0)){ha=A;ia=wa;ja=ua;ka=sa;la=qa;ma=ra;na=xa;oa=va;pa=ta;break}else{fa=wa;ea=ua;ca=sa;da=qa;R=ra;S=xa;Z=va;W=ta}}}if((ha|0)<(H|0)){T=ha;W=la;Z=ma;while(1){S=+n[ga+(T<<3)>>2];R=+n[ga+(T<<3)+4>>2];da=+n[U+(T<<3)>>2];ca=+n[U+(T<<3)+4>>2];ea=W+(S*da-R*ca);fa=Z+(R*da+S*ca);T=T+1|0;if((T|0)==(H|0)){ya=ea;za=fa;break}else{W=ea;Z=fa}}}else{ya=la;za=ma}Z=(ia+(ja+(ka+ya)))*l;W=(na+(oa+(pa+za)))*l;if(!O){Aa=W;Ba=Z}else{Aa=W+ +n[O+4>>2]*m;Ba=Z+ +n[O>>2]*m}n[P+(M<<3)>>2]=Ba;n[P+(M<<3)+4>>2]=Aa;M=M+1|0;if((M|0)==(j|0))break;else{U=U+(z<<3)|0;O=O+(D<<3)|0}}}i=i+1|0;if((i|0)==(w|0))break a;else{b=b+(F<<3)|0;B=B+(C<<3)|0;P=P+(g<<3)|0}}}if(j<<3>>>0<1601){if((w|0)<=0)break;P=(G|0)==0;B=j+-4|0;b=(j|0)<4;i=(H|0)>0;A=D<<2;K=D<<1;J=D*3|0;Q=B>>>2;L=(Q<<2)+4|0;t=P|(H|0)<1;Z=l*0.0;O=a;U=e;M=0;T=h;v=e+(Y((Q<<5)+32|0,D)|0)|0;while(1){if(t)Ca=P?O:G;else{Q=0;do{d=O+((Y(Q,E)|0)<<3)|0;N=f[d+4>>2]|0;y=G+(Q<<3)|0;f[y>>2]=f[d>>2];f[y+4>>2]=N;Q=Q+1|0}while((Q|0)!=(H|0));Ca=G}if(b){Da=U;Ea=0}else{Q=U;N=0;while(1){if(i){y=c+(N<<3)|0;d=0;W=0.0;fa=0.0;ea=0.0;ca=0.0;S=0.0;da=0.0;R=0.0;ta=0.0;while(1){va=+n[Ca+(d<<3)>>2];xa=+n[Ca+(d<<3)+4>>2];ra=+n[y>>2];qa=+n[y+4>>2];sa=ca+(va*ra-xa*qa);ua=ta+(xa*ra+va*qa);qa=+n[y+8>>2];ra=+n[y+12>>2];wa=ea+(va*qa-xa*ra);X=R+(xa*qa+va*ra);ra=+n[y+16>>2];qa=+n[y+20>>2];ba=fa+(va*ra-xa*qa);_=da+(xa*ra+va*qa);qa=+n[y+24>>2];ra=+n[y+28>>2];aa=W+(va*qa-xa*ra);Fa=S+(xa*qa+va*ra);d=d+1|0;if((d|0)==(H|0)){Ga=aa;Ha=ba;Ia=wa;Ja=sa;Ka=Fa;La=_;Ma=X;Na=ua;break}else{y=y+(z<<3)|0;W=aa;fa=ba;ea=wa;ca=sa;S=Fa;da=_;R=X;ta=ua}}}else{Ga=0.0;Ha=0.0;Ia=0.0;Ja=0.0;Ka=0.0;La=0.0;Ma=0.0;Na=0.0}ta=Ja*l;R=Na*l;if(!Q){n[T+(N<<3)>>2]=ta;n[T+(N<<3)+4>>2]=R;y=N|1;n[T+(y<<3)>>2]=Ia*l;n[T+(y<<3)+4>>2]=Ma*l;y=N|2;n[T+(y<<3)>>2]=Ha*l;n[T+(y<<3)+4>>2]=La*l;Oa=Ka*l;Pa=Ga*l}else{da=R+ +n[Q+4>>2]*m;n[T+(N<<3)>>2]=ta+ +n[Q>>2]*m;n[T+(N<<3)+4>>2]=da;da=Ma*l+ +n[Q+(D<<3)+4>>2]*m;y=N|1;n[T+(y<<3)>>2]=Ia*l+ +n[Q+(D<<3)>>2]*m;n[T+(y<<3)+4>>2]=da;da=La*l+ +n[Q+(K<<3)+4>>2]*m;y=N|2;n[T+(y<<3)>>2]=Ha*l+ +n[Q+(K<<3)>>2]*m;n[T+(y<<3)+4>>2]=da;Oa=Ka*l+ +n[Q+(J<<3)+4>>2]*m;Pa=Ga*l+ +n[Q+(J<<3)>>2]*m}y=N|3;n[T+(y<<3)>>2]=Pa;n[T+(y<<3)+4>>2]=Oa;N=N+4|0;if((N|0)>(B|0)){Da=v;Ea=L;break}else Q=Q+(A<<3)|0}}b:do if((Ea|0)<(j|0)){if(i){Qa=Da;Ra=Ea}else{Q=Da;N=Ea;while(1){if(!Q){Sa=Z;Ta=Z}else{Sa=Z+ +n[Q+4>>2]*m;Ta=Z+ +n[Q>>2]*m}n[T+(N<<3)>>2]=Ta;n[T+(N<<3)+4>>2]=Sa;N=N+1|0;if((N|0)==(j|0))break b;else Q=Q+(D<<3)|0}}while(1){Q=c+(Ra<<3)|0;N=0;da=0.0;ta=0.0;while(1){R=+n[Ca+(N<<3)>>2];S=+n[Ca+(N<<3)+4>>2];ca=+n[Q>>2];ea=+n[Q+4>>2];da=da+(R*ca-S*ea);ta=ta+(S*ca+R*ea);N=N+1|0;if((N|0)==(H|0))break;else Q=Q+(z<<3)|0}ea=da*l;R=ta*l;if(!Qa){Ua=R;Va=ea}else{Ua=R+ +n[Qa+4>>2]*m;Va=ea+ +n[Qa>>2]*m}n[T+(Ra<<3)>>2]=Va;n[T+(Ra<<3)+4>>2]=Ua;Ra=Ra+1|0;if((Ra|0)==(j|0))break;else Qa=Qa+(D<<3)|0}}while(0);M=M+1|0;if((M|0)==(w|0))break a;else{O=O+(F<<3)|0;U=U+(C<<3)|0;T=T+(g<<3)|0;v=v+(C<<3)|0}}}v=s+8|0;Nac(v|0,0,1152)|0;f[s>>2]=v;T=s+4|0;f[T>>2]=j;if(j>>>0>72){U=N5b(j>>>0>268435455?-1:j<<4)|0;Nac(U|0,0,j<<4|0)|0;f[s>>2]=U;Wa=U}else Wa=v;if((w|0)>0){U=(G|0)==0;O=(j|0)>0;M=(H|0)>0;i=j+-4|0;A=(j|0)<4;L=j<<4;B=j&-4;J=U|(H|0)<1;K=a;b=e;P=0;t=h;while(1){if(J)Xa=U?K:G;else{Q=0;do{N=K+((Y(Q,E)|0)<<3)|0;y=f[N+4>>2]|0;d=G+(Q<<3)|0;f[d>>2]=f[N>>2];f[d+4>>2]=y;Q=Q+1|0}while((Q|0)!=(H|0));Xa=G}if(O)Nac(Wa|0,0,L|0)|0;if(M){Q=c;y=0;while(1){Z=+n[Xa+(y<<3)>>2];ea=+n[Xa+(y<<3)+4>>2];if(A)Ya=0;else{d=0;do{R=+n[Q+(d<<3)>>2];ca=+n[Q+(d<<3)+4>>2];N=Wa+(d<<4)|0;V=Wa+(d<<4)+8|0;S=+p[V>>3]+(ea*R+Z*ca);$=d|1;fa=+n[Q+($<<3)>>2];W=+n[Q+($<<3)+4>>2];Za=Wa+($<<4)|0;_a=Wa+($<<4)+8|0;ua=+p[Za>>3]+(Z*fa-ea*W);X=+p[_a>>3]+(ea*fa+Z*W);p[N>>3]=+p[N>>3]+(Z*R-ea*ca);p[V>>3]=S;p[Za>>3]=ua;p[_a>>3]=X;_a=d|2;X=+n[Q+(_a<<3)>>2];ua=+n[Q+(_a<<3)+4>>2];Za=Wa+(_a<<4)|0;V=Wa+(_a<<4)+8|0;S=+p[V>>3]+(ea*X+Z*ua);_a=d|3;ca=+n[Q+(_a<<3)>>2];R=+n[Q+(_a<<3)+4>>2];N=Wa+(_a<<4)|0;$=Wa+(_a<<4)+8|0;W=+p[N>>3]+(Z*ca-ea*R);fa=+p[$>>3]+(ea*ca+Z*R);p[Za>>3]=+p[Za>>3]+(Z*X-ea*ua);p[V>>3]=S;p[N>>3]=W;p[$>>3]=fa;d=d+4|0}while((d|0)<=(i|0));Ya=B}if((Ya|0)<(j|0)){d=Ya;do{fa=+n[Q+(d<<3)>>2];W=+n[Q+(d<<3)+4>>2];$=Wa+(d<<4)|0;p[$>>3]=+p[$>>3]+(Z*fa-ea*W);$=Wa+(d<<4)+8|0;p[$>>3]=+p[$>>3]+(ea*fa+Z*W);d=d+1|0}while((d|0)!=(j|0))}y=y+1|0;if((y|0)==(H|0))break;else Q=Q+(z<<3)|0}}if(!b){if(O){Q=0;do{Z=+p[Wa+(Q<<4)+8>>3]*l;n[t+(Q<<3)>>2]=+p[Wa+(Q<<4)>>3]*l;n[t+(Q<<3)+4>>2]=Z;Q=Q+1|0}while((Q|0)!=(j|0))}}else if(O){Q=0;y=b;while(1){Z=+p[Wa+(Q<<4)+8>>3]*l+ +n[y+4>>2]*m;n[t+(Q<<3)>>2]=+p[Wa+(Q<<4)>>3]*l+ +n[y>>2]*m;n[t+(Q<<3)+4>>2]=Z;Q=Q+1|0;if((Q|0)==(j|0))break;else y=y+(D<<3)|0}}P=P+1|0;if((P|0)==(w|0))break;else{K=K+(F<<3)|0;b=b+(C<<3)|0;t=t+(g<<3)|0}}$a=f[s>>2]|0}else $a=Wa;if(($a|0)!=(v|0)){if($a|0)P5b($a);f[s>>2]=v;f[T>>2]=72}}while(0);s=f[r>>2]|0;if((s|0)==(k|0)){u=q;return}if(s|0)P5b(s);f[r>>2]=k;f[x>>2]=136;u=q;return}function rX(a,b,c,d,e,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0,Pa=0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;o=u;u=u+2320|0;q=o+1160|0;r=o;s=f[j>>2]|0;t=f[j+4>>2]|0;j=f[k>>2]|0;v=f[k+4>>2]|0;k=q+8|0;Nac(k|0,0,1152)|0;f[q>>2]=k;w=q+4|0;f[w>>2]=72;x=b>>>4;y=d>>>4;z=g>>>4;g=i>>>4;i=(e|0)==0;A=(n&4|0)==0;B=i?0:A?z:1;C=i?0:A?1:z;if(n&1)if(b>>>0>31&(t|0)>1){f[w>>2]=t;if(t>>>0>72){z=N5b(t>>>0>268435455?-1:t<<4)|0;Nac(z|0,0,t<<4|0)|0;f[q>>2]=z;D=x;E=1;F=z;G=t;H=40}else{D=x;E=1;F=k;G=t;H=40}}else{I=x;J=1;K=t;H=5}else{I=1;J=x;K=s;H=5}if((H|0)==5)if((K|0)==1){s=r+8|0;Nac(s|0,0,1152)|0;f[r>>2]=s;z=r+4|0;f[z>>2]=72;if(b>>>0>31&(t|0)>1){f[w>>2]=v;if(v>>>0>72){t=N5b(v>>>0>268435455?-1:v<<4)|0;Nac(t|0,0,v<<4|0)|0;f[q>>2]=t;L=t}else L=k;if((v|0)>0){t=0;do{b=a+((Y(t,x)|0)<<4)|0;A=L+(t<<4)|0;f[A>>2]=f[b>>2];f[A+4>>2]=f[b+4>>2];f[A+8>>2]=f[b+8>>2];f[A+12>>2]=f[b+12>>2];t=t+1|0}while((t|0)!=(v|0));M=L}else M=L}else M=a;if(d>>>0>31){f[z>>2]=j;if(j>>>0>72){d=N5b(j>>>0>268435455?-1:j<<4)|0;Nac(d|0,0,j<<4|0)|0;f[r>>2]=d;N=d}else N=s;if((j|0)>0){d=0;do{L=c+((Y(d,y)|0)<<4)|0;t=N+(d<<4)|0;f[t>>2]=f[L>>2];f[t+4>>2]=f[L+4>>2];f[t+8>>2]=f[L+8>>2];f[t+12>>2]=f[L+12>>2];d=d+1|0}while((d|0)<(j|0));O=N}else O=N}else O=c;a:do if((v|0)>0){N=C<<1;d=j+-2|0;if((j|0)<2){L=(j|0)==1;t=e;x=0;b=h;while(1){P=+p[M+(x<<4)>>3]*l;Q=+p[M+(x<<4)+8>>3]*l;if(L){A=t;i=0;while(1){R=+p[O+(i<<4)>>3];S=+p[O+(i<<4)+8>>3];T=P*R-Q*S;U=Q*R+P*S;if(!A){V=U;W=T}else{V=U+ +p[A+8>>3]*m;W=T+ +p[A>>3]*m}p[b+(i<<4)>>3]=W;p[b+(i<<4)+8>>3]=V;i=i+1|0;if((i|0)==(j|0))break;else A=A+(C<<4)|0}}x=x+1|0;if((x|0)==(v|0))break a;else{t=t+(B<<4)|0;b=b+(g<<4)|0}}}b=d>>>1;t=(b<<1)+2|0;x=(t|0)<(j|0);L=e;A=0;i=h;X=e+(Y(C,(b<<5)+32|0)|0)|0;while(1){P=+p[M+(A<<4)>>3]*l;Q=+p[M+(A<<4)+8>>3]*l;b=L;Z=0;while(1){T=+p[O+(Z<<4)>>3];U=+p[O+(Z<<4)+8>>3];S=P*T-Q*U;R=Q*T+P*U;_=Z|1;U=+p[O+(_<<4)>>3];T=+p[O+(_<<4)+8>>3];$=P*U-Q*T;aa=Q*U+P*T;if(!b){p[i+(Z<<4)>>3]=S;p[i+(Z<<4)+8>>3]=R;ba=aa;ca=$}else{T=R+ +p[b+8>>3]*m;p[i+(Z<<4)>>3]=S+ +p[b>>3]*m;p[i+(Z<<4)+8>>3]=T;ba=aa+ +p[b+(C<<4)+8>>3]*m;ca=$+ +p[b+(C<<4)>>3]*m}p[i+(_<<4)>>3]=ca;p[i+(_<<4)+8>>3]=ba;Z=Z+2|0;if((Z|0)>(d|0))break;else b=b+(N<<4)|0}if(x){b=X;Z=t;while(1){$=+p[O+(Z<<4)>>3];aa=+p[O+(Z<<4)+8>>3];T=P*$-Q*aa;S=Q*$+P*aa;if(!b){da=S;ea=T}else{da=S+ +p[b+8>>3]*m;ea=T+ +p[b>>3]*m}p[i+(Z<<4)>>3]=ea;p[i+(Z<<4)+8>>3]=da;Z=Z+1|0;if((Z|0)==(j|0))break;else b=b+(C<<4)|0}}A=A+1|0;if((A|0)==(v|0))break;else{L=L+(B<<4)|0;i=i+(g<<4)|0;X=X+(B<<4)|0}}}while(0);O=f[r>>2]|0;if((O|0)!=(s|0)){if(O|0)P5b(O);f[r>>2]=s;f[z>>2]=72}}else{D=I;E=J;F=0;G=K;H=40}b:do if((H|0)==40){if(n&2|0){if((v|0)<=0)break;K=(F|0)==0;J=G+-4|0;I=(G|0)<4;z=G&-4;s=K|(G|0)<1;O=(j|0)>0;M=a;X=e;i=0;L=h;while(1){if(s)fa=K?M:F;else{A=0;do{t=M+((Y(A,D)|0)<<4)|0;x=F+(A<<4)|0;f[x>>2]=f[t>>2];f[x+4>>2]=f[t+4>>2];f[x+8>>2]=f[t+8>>2];f[x+12>>2]=f[t+12>>2];A=A+1|0}while((A|0)!=(G|0));fa=F}if(O){A=c;t=X;x=0;while(1){if(I){ga=0;ha=0.0;ia=0.0;ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0;oa=0.0}else{N=0;da=0.0;ea=0.0;ba=0.0;ca=0.0;V=0.0;W=0.0;P=0.0;Q=0.0;while(1){T=+p[fa+(N<<4)>>3];S=+p[fa+(N<<4)+8>>3];aa=+p[A+(N<<4)>>3];$=+p[A+(N<<4)+8>>3];R=ca+(T*aa-S*$);U=V+(S*aa+T*$);d=N|1;$=+p[fa+(d<<4)>>3];T=+p[fa+(d<<4)+8>>3];aa=+p[A+(d<<4)>>3];S=+p[A+(d<<4)+8>>3];pa=ba+($*aa-T*S);qa=Q+(T*aa+$*S);d=N|2;S=+p[fa+(d<<4)>>3];$=+p[fa+(d<<4)+8>>3];aa=+p[A+(d<<4)>>3];T=+p[A+(d<<4)+8>>3];ra=ea+(S*aa-$*T);sa=P+($*aa+S*T);d=N|3;T=+p[fa+(d<<4)>>3];S=+p[fa+(d<<4)+8>>3];aa=+p[A+(d<<4)>>3];$=+p[A+(d<<4)+8>>3];ta=da+(T*aa-S*$);ua=W+(S*aa+T*$);N=N+4|0;if((N|0)>(J|0)){ga=z;ha=ta;ia=ra;ja=pa;ka=R;la=U;ma=ua;na=sa;oa=qa;break}else{da=ta;ea=ra;ba=pa;ca=R;V=U;W=ua;P=sa;Q=qa}}}if((ga|0)<(G|0)){N=ga;Q=ka;P=la;while(1){W=+p[fa+(N<<4)>>3];V=+p[fa+(N<<4)+8>>3];ca=+p[A+(N<<4)>>3];ba=+p[A+(N<<4)+8>>3];ea=Q+(W*ca-V*ba);da=P+(V*ca+W*ba);N=N+1|0;if((N|0)==(G|0)){va=ea;wa=da;break}else{Q=ea;P=da}}}else{va=ka;wa=la}P=(ha+(ia+(ja+va)))*l;Q=(ma+(na+(oa+wa)))*l;if(!t){xa=Q;ya=P}else{xa=Q+ +p[t+8>>3]*m;ya=P+ +p[t>>3]*m}p[L+(x<<4)>>3]=ya;p[L+(x<<4)+8>>3]=xa;x=x+1|0;if((x|0)==(j|0))break;else{A=A+(y<<4)|0;t=t+(C<<4)|0}}}i=i+1|0;if((i|0)==(v|0))break b;else{M=M+(E<<4)|0;X=X+(B<<4)|0;L=L+(g<<4)|0}}}L=j<<4;if(L>>>0<1601){if((v|0)<=0)break;X=(F|0)==0;M=j+-4|0;i=(j|0)<4;z=(G|0)>0;J=C<<2;I=C<<1;O=C*3|0;K=M>>>2;s=(K<<2)+4|0;t=X|(G|0)<1;P=l*0.0;A=a;x=e;N=0;d=h;b=e+(Y((K<<6)+64|0,C)|0)|0;while(1){if(t)za=X?A:F;else{K=0;do{Z=A+((Y(K,D)|0)<<4)|0;_=F+(K<<4)|0;f[_>>2]=f[Z>>2];f[_+4>>2]=f[Z+4>>2];f[_+8>>2]=f[Z+8>>2];f[_+12>>2]=f[Z+12>>2];K=K+1|0}while((K|0)!=(G|0));za=F}if(i){Aa=x;Ba=0}else{K=x;Z=0;while(1){if(z){_=c+(Z<<4)|0;Ca=0;Q=0.0;da=0.0;ea=0.0;ba=0.0;W=0.0;ca=0.0;V=0.0;qa=0.0;while(1){sa=+p[za+(Ca<<4)>>3];ua=+p[za+(Ca<<4)+8>>3];U=+p[_>>3];R=+p[_+8>>3];pa=da+(sa*U-ua*R);ra=V+(ua*U+sa*R);R=+p[_+16>>3];U=+p[_+24>>3];ta=Q+(sa*R-ua*U);$=ca+(ua*R+sa*U);U=+p[_+32>>3];R=+p[_+40>>3];T=ba+(sa*U-ua*R);aa=W+(ua*U+sa*R);R=+p[_+48>>3];U=+p[_+56>>3];S=ea+(sa*R-ua*U);Da=qa+(ua*R+sa*U);Ca=Ca+1|0;if((Ca|0)==(G|0)){Ea=ta;Fa=pa;Ga=S;Ha=T;Ia=aa;Ja=$;Ka=ra;La=Da;break}else{_=_+(y<<4)|0;Q=ta;da=pa;ea=S;ba=T;W=aa;ca=$;V=ra;qa=Da}}}else{Ea=0.0;Fa=0.0;Ga=0.0;Ha=0.0;Ia=0.0;Ja=0.0;Ka=0.0;La=0.0}qa=Fa*l;V=Ka*l;if(!K){p[d+(Z<<4)>>3]=qa;p[d+(Z<<4)+8>>3]=V;_=Z|1;p[d+(_<<4)>>3]=Ea*l;p[d+(_<<4)+8>>3]=Ja*l;_=Z|2;p[d+(_<<4)>>3]=Ha*l;p[d+(_<<4)+8>>3]=Ia*l;Ma=La*l;Na=Ga*l}else{ca=V+ +p[K+8>>3]*m;p[d+(Z<<4)>>3]=qa+ +p[K>>3]*m;p[d+(Z<<4)+8>>3]=ca;ca=Ja*l+ +p[K+(C<<4)+8>>3]*m;_=Z|1;p[d+(_<<4)>>3]=Ea*l+ +p[K+(C<<4)>>3]*m;p[d+(_<<4)+8>>3]=ca;ca=Ia*l+ +p[K+(I<<4)+8>>3]*m;_=Z|2;p[d+(_<<4)>>3]=Ha*l+ +p[K+(I<<4)>>3]*m;p[d+(_<<4)+8>>3]=ca;Ma=La*l+ +p[K+(O<<4)+8>>3]*m;Na=Ga*l+ +p[K+(O<<4)>>3]*m}_=Z|3;p[d+(_<<4)>>3]=Na;p[d+(_<<4)+8>>3]=Ma;Z=Z+4|0;if((Z|0)>(M|0)){Aa=b;Ba=s;break}else K=K+(J<<4)|0}}c:do if((Ba|0)<(j|0)){if(z){Oa=Aa;Pa=Ba}else{K=Aa;Z=Ba;while(1){if(!K){Qa=P;Ra=P}else{Qa=P+ +p[K+8>>3]*m;Ra=P+ +p[K>>3]*m}p[d+(Z<<4)>>3]=Ra;p[d+(Z<<4)+8>>3]=Qa;Z=Z+1|0;if((Z|0)==(j|0))break c;else K=K+(C<<4)|0}}while(1){K=c+(Pa<<4)|0;Z=0;ca=0.0;qa=0.0;while(1){V=+p[za+(Z<<4)>>3];W=+p[za+(Z<<4)+8>>3];ba=+p[K>>3];ea=+p[K+8>>3];ca=ca+(V*ba-W*ea);qa=qa+(W*ba+V*ea);Z=Z+1|0;if((Z|0)==(G|0))break;else K=K+(y<<4)|0}ea=ca*l;V=qa*l;if(!Oa){Sa=V;Ta=ea}else{Sa=V+ +p[Oa+8>>3]*m;Ta=ea+ +p[Oa>>3]*m}p[d+(Pa<<4)>>3]=Ta;p[d+(Pa<<4)+8>>3]=Sa;Pa=Pa+1|0;if((Pa|0)==(j|0))break;else Oa=Oa+(C<<4)|0}}while(0);N=N+1|0;if((N|0)==(v|0))break b;else{A=A+(E<<4)|0;x=x+(B<<4)|0;d=d+(g<<4)|0;b=b+(B<<4)|0}}}b=r+8|0;Nac(b|0,0,1152)|0;f[r>>2]=b;d=r+4|0;f[d>>2]=j;if(j>>>0>72){x=N5b(j>>>0>268435455?-1:j<<4)|0;Nac(x|0,0,L|0)|0;f[r>>2]=x;Ua=x}else Ua=b;if((v|0)>0){x=(F|0)==0;A=(j|0)>0;N=(G|0)>0;z=j+-4|0;J=(j|0)<4;s=j&-4;M=x|(G|0)<1;O=a;I=e;i=0;X=h;while(1){if(M)Va=x?O:F;else{t=0;do{K=O+((Y(t,D)|0)<<4)|0;Z=F+(t<<4)|0;f[Z>>2]=f[K>>2];f[Z+4>>2]=f[K+4>>2];f[Z+8>>2]=f[K+8>>2];f[Z+12>>2]=f[K+12>>2];t=t+1|0}while((t|0)!=(G|0));Va=F}if(A)Nac(Ua|0,0,L|0)|0;if(N){t=c;K=0;while(1){P=+p[Va+(K<<4)>>3];ea=+p[Va+(K<<4)+8>>3];if(J)Wa=0;else{Z=0;do{V=+p[t+(Z<<4)>>3];ba=+p[t+(Z<<4)+8>>3];_=Ua+(Z<<4)|0;Ca=Ua+(Z<<4)+8|0;W=+p[Ca>>3]+(ea*V+P*ba);Xa=Z|1;da=+p[t+(Xa<<4)>>3];Q=+p[t+(Xa<<4)+8>>3];Ya=Ua+(Xa<<4)|0;Za=Ua+(Xa<<4)+8|0;Da=+p[Ya>>3]+(P*da-ea*Q);ra=+p[Za>>3]+(ea*da+P*Q);p[_>>3]=+p[_>>3]+(P*V-ea*ba);p[Ca>>3]=W;p[Ya>>3]=Da;p[Za>>3]=ra;Za=Z|2;ra=+p[t+(Za<<4)>>3];Da=+p[t+(Za<<4)+8>>3];Ya=Ua+(Za<<4)|0;Ca=Ua+(Za<<4)+8|0;W=+p[Ca>>3]+(ea*ra+P*Da);Za=Z|3;ba=+p[t+(Za<<4)>>3];V=+p[t+(Za<<4)+8>>3];_=Ua+(Za<<4)|0;Xa=Ua+(Za<<4)+8|0;Q=+p[_>>3]+(P*ba-ea*V);da=+p[Xa>>3]+(ea*ba+P*V);p[Ya>>3]=+p[Ya>>3]+(P*ra-ea*Da);p[Ca>>3]=W;p[_>>3]=Q;p[Xa>>3]=da;Z=Z+4|0}while((Z|0)<=(z|0));Wa=s}if((Wa|0)<(j|0)){Z=Wa;do{da=+p[t+(Z<<4)>>3];Q=+p[t+(Z<<4)+8>>3];Xa=Ua+(Z<<4)|0;p[Xa>>3]=+p[Xa>>3]+(P*da-ea*Q);Xa=Ua+(Z<<4)+8|0;p[Xa>>3]=ea*da+P*Q+ +p[Xa>>3];Z=Z+1|0}while((Z|0)!=(j|0))}K=K+1|0;if((K|0)==(G|0))break;else t=t+(y<<4)|0}}if(!I){if(A){t=0;do{P=+p[Ua+(t<<4)+8>>3]*l;p[X+(t<<4)>>3]=+p[Ua+(t<<4)>>3]*l;p[X+(t<<4)+8>>3]=P;t=t+1|0}while((t|0)!=(j|0))}}else if(A){t=0;K=I;while(1){P=+p[Ua+(t<<4)+8>>3]*l+ +p[K+8>>3]*m;p[X+(t<<4)>>3]=+p[Ua+(t<<4)>>3]*l+ +p[K>>3]*m;p[X+(t<<4)+8>>3]=P;t=t+1|0;if((t|0)==(j|0))break;else K=K+(C<<4)|0}}i=i+1|0;if((i|0)==(v|0))break;else{O=O+(E<<4)|0;I=I+(B<<4)|0;X=X+(g<<4)|0}}_a=f[r>>2]|0}else _a=Ua;if((_a|0)!=(b|0)){if(_a|0)P5b(_a);f[r>>2]=b;f[d>>2]=72}}while(0);r=f[q>>2]|0;if((r|0)==(k|0)){u=o;return}if(r|0)P5b(r);f[q>>2]=k;f[w>>2]=72;u=o;return}function sX(a,b,c,d,e,g,h,i,j,k,l,m,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0.0,W=0,X=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0.0,ca=0.0,da=0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0;q=u;u=u+2160|0;r=q+1096|0;s=q;t=f[j>>2]|0;v=f[j+4>>2]|0;j=f[k>>2]|0;w=f[k+4>>2]|0;k=r+8|0;f[r>>2]=k;x=r+4|0;f[x>>2]=264;y=b>>>2;z=d>>>2;A=g>>>2;g=i>>>2;i=(e|0)==0;B=(o&4|0)==0;C=i?0:B?A:1;D=i?0:B?1:A;if(o&1)if(b>>>0>7&(v|0)>1){f[x>>2]=v;if(v>>>0>264){A=N5b(v>>>0>1073741823?-1:v<<2)|0;f[r>>2]=A;E=y;F=1;G=A;H=v;I=43}else{E=y;F=1;G=k;H=v;I=43}}else{J=y;K=1;L=v;I=5}else{J=1;K=y;L=t;I=5}if((I|0)==5)if((L|0)==1){t=s+8|0;f[s>>2]=t;A=s+4|0;f[A>>2]=264;if(b>>>0>7&(v|0)>1){f[x>>2]=w;if(w>>>0>264){v=N5b(w>>>0>1073741823?-1:w<<2)|0;f[r>>2]=v;M=v}else M=k;if((w|0)>0){v=0;do{b=a+((Y(v,y)|0)<<2)|0;f[M+(v<<2)>>2]=f[b>>2];v=v+1|0}while((v|0)!=(w|0));N=M}else N=M}else N=a;if(d>>>0>7){f[A>>2]=j;if(j>>>0>264){d=N5b(j>>>0>1073741823?-1:j<<2)|0;f[s>>2]=d;O=d}else O=t;if((j|0)>0){d=0;do{M=c+((Y(d,z)|0)<<2)|0;f[O+(d<<2)>>2]=f[M>>2];d=d+1|0}while((d|0)!=(j|0));P=O;Q=O}else{P=O;Q=O}}else{P=c;Q=t}a:do if((w|0)>0){O=D<<1;if((j|0)<2){if((j|0)==1){R=h;S=0;T=e}else break;while(1){U=+n[N+(S<<2)>>2]*l*+n[P>>2];if(!T)V=U;else V=U+ +n[T>>2]*m;n[R>>2]=V;S=S+1|0;if((S|0)==(w|0))break a;else{R=R+(g<<2)|0;T=T+(C<<2)|0}}}d=j+-2|0;M=((d|0)>1?d:1)>>>1;v=Y(M,O)|0;y=(M<<1)+2|0;if((y|0)>=(j|0)){M=h;b=0;B=e;while(1){U=+n[N+(b<<2)>>2]*l;i=B;W=0;while(1){X=U*+n[P+(W<<2)>>2];Z=W|1;_=U*+n[P+(Z<<2)>>2];if(!i){n[M+(W<<2)>>2]=X;$=_}else{n[M+(W<<2)>>2]=X+ +n[i>>2]*m;$=_+ +n[i+(D<<2)>>2]*m}n[M+(Z<<2)>>2]=$;W=W+2|0;if((W|0)>(d|0))break;else i=i+(O<<2)|0}b=b+1|0;if((b|0)==(w|0))break a;else{M=M+(g<<2)|0;B=B+(C<<2)|0}}}B=h;M=0;b=e;i=e+(O<<2)|0;while(1){U=+n[N+(M<<2)>>2]*l;W=b;Z=0;while(1){_=U*+n[P+(Z<<2)>>2];aa=Z|1;X=U*+n[P+(aa<<2)>>2];if(!W){n[B+(Z<<2)>>2]=_;ba=X}else{n[B+(Z<<2)>>2]=_+ +n[W>>2]*m;ba=X+ +n[W+(D<<2)>>2]*m}n[B+(aa<<2)>>2]=ba;Z=Z+2|0;if((Z|0)>(d|0))break;else W=W+(O<<2)|0}W=i+(v<<2)|0;Z=y;while(1){X=U*+n[P+(Z<<2)>>2];if(!W)ca=X;else ca=X+ +n[W>>2]*m;n[B+(Z<<2)>>2]=ca;Z=Z+1|0;if((Z|0)==(j|0))break;else W=W+(D<<2)|0}M=M+1|0;if((M|0)==(w|0))break;else{B=B+(g<<2)|0;b=b+(C<<2)|0;i=i+(C<<2)|0}}}while(0);if((Q|0)!=(t|0)){P5b(Q);f[s>>2]=t;f[A>>2]=264}}else{E=J;F=K;G=0;H=L;I=43}b:do if((I|0)==43){if(o&2|0){if((w|0)<=0)break;L=(G|0)==0;K=(j|0)>0;J=H+-4|0;A=(H|0)<4;t=H&-4;Q=L|(H|0)<1;P=(H|0)>0;N=(t|0)<(H|0);ca=l*0.0;T=a;R=h;S=0;i=e;while(1){if(Q)da=L?T:G;else{b=0;do{B=T+((Y(b,E)|0)<<2)|0;f[G+(b<<2)>>2]=f[B>>2];b=b+1|0}while((b|0)!=(H|0));da=G}c:do if(K){if(!A){b=c;B=i;M=0;while(1){ba=0.0;$=0.0;V=0.0;U=0.0;y=0;do{U=U+ +n[da+(y<<2)>>2]*+n[b+(y<<2)>>2];v=y|1;V=V+ +n[da+(v<<2)>>2]*+n[b+(v<<2)>>2];v=y|2;$=$+ +n[da+(v<<2)>>2]*+n[b+(v<<2)>>2];v=y|3;ba=ba+ +n[da+(v<<2)>>2]*+n[b+(v<<2)>>2];y=y+4|0}while((y|0)<=(J|0));if(N){X=U;y=t;while(1){_=X+ +n[da+(y<<2)>>2]*+n[b+(y<<2)>>2];y=y+1|0;if((y|0)==(H|0)){ea=_;break}else X=_}}else ea=U;X=(ba+($+(V+ea)))*l;if(!B)fa=X;else fa=X+ +n[B>>2]*m;n[R+(M<<2)>>2]=fa;M=M+1|0;if((M|0)==(j|0))break c;else{b=b+(z<<2)|0;B=B+(D<<2)|0}}}if(P){ga=c;ha=i;ia=0}else{B=i;b=0;while(1){if(!B)ja=ca;else ja=ca+ +n[B>>2]*m;n[R+(b<<2)>>2]=ja;b=b+1|0;if((b|0)==(j|0))break c;else B=B+(D<<2)|0}}while(1){X=0.0;B=0;do{X=X+ +n[da+(B<<2)>>2]*+n[ga+(B<<2)>>2];B=B+1|0}while((B|0)!=(H|0));V=(X+0.0)*l;if(!ha)ka=V;else ka=V+ +n[ha>>2]*m;n[R+(ia<<2)>>2]=ka;ia=ia+1|0;if((ia|0)==(j|0))break;else{ga=ga+(z<<2)|0;ha=ha+(D<<2)|0}}}while(0);S=S+1|0;if((S|0)==(w|0))break b;else{T=T+(F<<2)|0;R=R+(g<<2)|0;i=i+(C<<2)|0}}}if(j<<2>>>0<1601){if((w|0)<=0)break;i=(G|0)==0;R=j+-4|0;T=(j|0)<4;S=(H|0)>0;P=D<<2;t=D<<1;N=D*3|0;J=R>>>2;A=(J<<2)+4|0;K=i|(H|0)<1;ca=l*0.0;V=ca;L=a;Q=h;B=0;b=e;M=e+(Y((J<<4)+16|0,D)|0)|0;while(1){if(K)la=i?L:G;else{J=0;do{y=L+((Y(J,E)|0)<<2)|0;f[G+(J<<2)>>2]=f[y>>2];J=J+1|0}while((J|0)!=(H|0));la=G}d:do if(T){ma=b;na=0}else{if(S){oa=b;pa=0}else{J=b;y=0;while(1){v=y|2;O=y|1;if(!J){n[Q+(y<<2)>>2]=V;n[Q+(O<<2)>>2]=V;n[Q+(v<<2)>>2]=V;qa=ca}else{n[Q+(y<<2)>>2]=ca+ +n[J>>2]*m;n[Q+(O<<2)>>2]=ca+ +n[J+(D<<2)>>2]*m;n[Q+(v<<2)>>2]=ca+ +n[J+(t<<2)>>2]*m;qa=ca+ +n[J+(N<<2)>>2]*m}n[Q+((y|3)<<2)>>2]=qa;y=y+4|0;if((y|0)>(R|0)){ma=M;na=A;break d}else J=J+(P<<2)|0}}while(1){$=0.0;ba=0.0;U=0.0;_=0.0;J=c+(pa<<2)|0;y=0;while(1){ra=+n[la+(y<<2)>>2];_=_+ra*+n[J>>2];U=U+ra*+n[J+4>>2];ba=ba+ra*+n[J+8>>2];$=$+ra*+n[J+12>>2];y=y+1|0;if((y|0)==(H|0))break;else J=J+(z<<2)|0}X=_*l;J=pa|2;ra=U*l;y=pa|1;sa=ba*l;ta=$*l;if(!oa){n[Q+(pa<<2)>>2]=X;n[Q+(y<<2)>>2]=ra;n[Q+(J<<2)>>2]=sa;ua=ta}else{n[Q+(pa<<2)>>2]=X+ +n[oa>>2]*m;n[Q+(y<<2)>>2]=ra+ +n[oa+(D<<2)>>2]*m;n[Q+(J<<2)>>2]=sa+ +n[oa+(t<<2)>>2]*m;ua=ta+ +n[oa+(N<<2)>>2]*m}n[Q+((pa|3)<<2)>>2]=ua;pa=pa+4|0;if((pa|0)>(R|0)){ma=M;na=A;break}else oa=oa+(P<<2)|0}}while(0);e:do if((na|0)<(j|0)){if(S){va=ma;wa=na}else{J=ma;y=na;while(1){if(!J)xa=ca;else xa=ca+ +n[J>>2]*m;n[Q+(y<<2)>>2]=xa;y=y+1|0;if((y|0)==(j|0))break e;else J=J+(D<<2)|0}}while(1){ta=0.0;J=c+(wa<<2)|0;y=0;while(1){ta=ta+ +n[la+(y<<2)>>2]*+n[J>>2];y=y+1|0;if((y|0)==(H|0))break;else J=J+(z<<2)|0}$=ta*l;if(!va)ya=$;else ya=$+ +n[va>>2]*m;n[Q+(wa<<2)>>2]=ya;wa=wa+1|0;if((wa|0)==(j|0))break;else va=va+(D<<2)|0}}while(0);B=B+1|0;if((B|0)==(w|0))break b;else{L=L+(F<<2)|0;Q=Q+(g<<2)|0;b=b+(C<<2)|0;M=M+(C<<2)|0}}}M=s+8|0;f[s>>2]=M;b=s+4|0;f[b>>2]=j;if(j>>>0>136){Q=N5b(j>>>0>536870911?-1:j<<3)|0;f[s>>2]=Q;za=Q;Aa=Q}else{za=M;Aa=M}if((w|0)>0){Q=(G|0)==0;L=(j|0)>0;B=(H|0)>0;S=j+-4|0;P=(j|0)<4;A=j<<3;R=j&-4;N=Q|(H|0)<1;t=(R|0)<(j|0);T=a;i=h;K=0;J=e;while(1){if(N)Ba=Q?T:G;else{y=0;do{v=T+((Y(y,E)|0)<<2)|0;f[G+(y<<2)>>2]=f[v>>2];y=y+1|0}while((y|0)!=(H|0));Ba=G}if(L)Nac(Aa|0,0,A|0)|0;f:do if(B){if(P){if(L){Ca=c;Da=0}else break;while(1){ca=+n[Ba+(Da<<2)>>2];y=0;do{v=Aa+(y<<3)|0;p[v>>3]=+p[v>>3]+ca*+n[Ca+(y<<2)>>2];y=y+1|0}while((y|0)!=(j|0));Da=Da+1|0;if((Da|0)==(H|0))break f;else Ca=Ca+(z<<2)|0}}if(t){Ea=c;Fa=0}else{y=c;v=0;while(1){ca=+n[Ba+(v<<2)>>2];O=0;do{d=Aa+(O<<3)|0;W=O|1;Z=Aa+(W<<3)|0;ta=+p[Z>>3]+ca*+n[y+(W<<2)>>2];p[d>>3]=+p[d>>3]+ca*+n[y+(O<<2)>>2];p[Z>>3]=ta;Z=O|2;d=Aa+(Z<<3)|0;W=O|3;aa=Aa+(W<<3)|0;ta=+p[aa>>3]+ca*+n[y+(W<<2)>>2];p[d>>3]=+p[d>>3]+ca*+n[y+(Z<<2)>>2];p[aa>>3]=ta;O=O+4|0}while((O|0)<=(S|0));v=v+1|0;if((v|0)==(H|0))break f;else y=y+(z<<2)|0}}while(1){ca=+n[Ba+(Fa<<2)>>2];y=0;do{v=Aa+(y<<3)|0;O=y|1;aa=Aa+(O<<3)|0;ta=+p[aa>>3]+ca*+n[Ea+(O<<2)>>2];p[v>>3]=+p[v>>3]+ca*+n[Ea+(y<<2)>>2];p[aa>>3]=ta;aa=y|2;v=Aa+(aa<<3)|0;O=y|3;Z=Aa+(O<<3)|0;ta=+p[Z>>3]+ca*+n[Ea+(O<<2)>>2];p[v>>3]=+p[v>>3]+ca*+n[Ea+(aa<<2)>>2];p[Z>>3]=ta;y=y+4|0}while((y|0)<=(S|0));Ga=R;do{y=Aa+(Ga<<3)|0;p[y>>3]=+p[y>>3]+ca*+n[Ea+(Ga<<2)>>2];Ga=Ga+1|0}while((Ga|0)!=(j|0));Fa=Fa+1|0;if((Fa|0)==(H|0))break;else Ea=Ea+(z<<2)|0}}while(0);if(!J){if(L){y=0;do{n[i+(y<<2)>>2]=+p[Aa+(y<<3)>>3]*l;y=y+1|0}while((y|0)!=(j|0))}}else if(L){y=0;Z=J;while(1){n[i+(y<<2)>>2]=+p[Aa+(y<<3)>>3]*l+ +n[Z>>2]*m;y=y+1|0;if((y|0)==(j|0))break;else Z=Z+(D<<2)|0}}K=K+1|0;if((K|0)==(w|0)){Ha=za;break}else{T=T+(F<<2)|0;i=i+(g<<2)|0;J=J+(C<<2)|0}}}else Ha=Aa;if((Ha|0)!=(M|0)){P5b(Ha);f[s>>2]=M;f[b>>2]=136}}while(0);s=f[r>>2]|0;if((s|0)==(k|0)){u=q;return}if(s|0)P5b(s);f[r>>2]=k;f[x>>2]=264;u=q;return}function tX(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0.0,W=0.0,X=0.0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0.0;k=u;u=u+1104|0;l=k;m=f[h>>2]|0;n=f[h+4>>2]|0;h=f[i>>2]|0;o=f[i+4>>2]|0;i=l+8|0;f[l>>2]=i;q=l+4|0;f[q>>2]=136;r=j&16;s=b>>>3;b=d>>>3;d=g>>>3;if(j&1){f[q>>2]=n;if(n>>>0>136){g=N5b(n>>>0>536870911?-1:n<<3)|0;f[l>>2]=g;t=s;v=1;w=g;x=n;y=g}else{t=s;v=1;w=i;x=n;y=i}}else{t=1;v=s;w=0;x=m;y=i}m=(o|0)>0;if(!(j&2)){if(m){j=(w|0)==0;s=h+-4|0;n=(h|0)<4;g=(r|0)==0;z=(x|0)>0;A=h&-4;B=(x|0)<1|j;C=(s>>>2<<5)+32|0;D=e;E=0;F=a;while(1){G=e+((Y(d,E)|0)<<3)|0;if(B)H=j?F:w;else{I=0;do{J=F+((Y(I,t)|0)<<3)|0;p[w+(I<<3)>>3]=+p[J>>3];I=I+1|0}while((I|0)!=(x|0));H=w}a:do if(!n)if(g){if(z)K=0;else{Nac(G|0,0,C|0)|0;L=A;break}do{I=c+(K<<3)|0;M=0.0;N=0.0;O=0.0;P=0.0;J=0;while(1){Q=+p[H+(J<<3)>>3];P=P+Q*+p[I>>3];O=O+Q*+p[I+8>>3];N=N+Q*+p[I+16>>3];M=M+Q*+p[I+24>>3];J=J+1|0;if((J|0)==(x|0))break;else I=I+(b<<3)|0}p[D+(K<<3)>>3]=P;p[D+((K|1)<<3)>>3]=O;p[D+((K|2)<<3)>>3]=N;p[D+((K|3)<<3)>>3]=M;K=K+4|0}while((K|0)<=(s|0));L=A}else{if(z)R=0;else{I=0;while(1){I=I+4|0;if((I|0)>(s|0)){L=A;break a}}}do{I=D+((R|3)<<3)|0;J=D+((R|2)<<3)|0;S=D+((R|1)<<3)|0;T=D+(R<<3)|0;U=c+(R<<3)|0;Q=+p[I>>3];V=+p[J>>3];W=+p[S>>3];X=+p[T>>3];Z=0;while(1){_=+p[H+(Z<<3)>>3];X=X+_*+p[U>>3];W=W+_*+p[U+8>>3];V=V+_*+p[U+16>>3];Q=Q+_*+p[U+24>>3];Z=Z+1|0;if((Z|0)==(x|0))break;else U=U+(b<<3)|0}p[T>>3]=X;p[S>>3]=W;p[J>>3]=V;p[I>>3]=Q;R=R+4|0}while((R|0)<=(s|0));L=A}else L=0;while(0);b:do if((h|0)>(L|0)){if(!g){if(z)$=L;else break;while(1){U=D+($<<3)|0;Z=c+($<<3)|0;M=+p[U>>3];aa=0;while(1){M=M+ +p[H+(aa<<3)>>3]*+p[Z>>3];aa=aa+1|0;if((aa|0)==(x|0))break;else Z=Z+(b<<3)|0}p[U>>3]=M;$=$+1|0;if(($|0)==(h|0))break b}}if(z)ba=L;else{Nac(G+(L<<3)|0,0,h-L<<3|0)|0;break}do{Z=c+(ba<<3)|0;Q=0.0;aa=0;while(1){Q=Q+ +p[H+(aa<<3)>>3]*+p[Z>>3];aa=aa+1|0;if((aa|0)==(x|0))break;else Z=Z+(b<<3)|0}p[D+(ba<<3)>>3]=Q;ba=ba+1|0}while((ba|0)!=(h|0))}while(0);E=E+1|0;if((E|0)==(o|0))break;else{D=D+(d<<3)|0;F=F+(v<<3)|0}}}}else if(m){m=(w|0)==0;F=(h|0)>0;D=(r|0)==0;r=x+-2|0;E=(x|0)<2;ba=x&-2;H=(x|0)<1|m;L=(x|0)>0;z=(ba|0)<(x|0);$=(x|0)>0;g=(ba|0)<(x|0);A=e;e=0;s=a;while(1){if(H)ca=m?s:w;else{a=0;do{R=s+((Y(a,t)|0)<<3)|0;p[w+(a<<3)>>3]=+p[R>>3];a=a+1|0}while((a|0)!=(x|0));ca=w}c:do if(F)if(D){if(E){a=c;R=0;while(1){if(L){M=0.0;K=0;while(1){V=M+ +p[ca+(K<<3)>>3]*+p[a+(K<<3)>>3];K=K+1|0;if((K|0)==(x|0)){da=V;break}else M=V}}else da=0.0;p[A+(R<<3)>>3]=da+0.0;R=R+1|0;if((R|0)==(h|0))break c;else a=a+(b<<3)|0}}else{ea=c;fa=0}while(1){M=0.0;Q=0.0;a=0;do{Q=Q+ +p[ca+(a<<3)>>3]*+p[ea+(a<<3)>>3];R=a|1;M=M+ +p[ca+(R<<3)>>3]*+p[ea+(R<<3)>>3];a=a+2|0}while((a|0)<=(r|0));if(z){V=Q;a=ba;while(1){W=V+ +p[ca+(a<<3)>>3]*+p[ea+(a<<3)>>3];a=a+1|0;if((a|0)==(x|0)){ga=W;break}else V=W}}else ga=Q;p[A+(fa<<3)>>3]=M+ga;fa=fa+1|0;if((fa|0)==(h|0))break;else ea=ea+(b<<3)|0}}else{if(E){a=c;R=0;while(1){K=A+(R<<3)|0;V=+p[K>>3];if($){W=V;C=0;while(1){X=W+ +p[ca+(C<<3)>>3]*+p[a+(C<<3)>>3];C=C+1|0;if((C|0)==(x|0)){ha=X;break}else W=X}}else ha=V;p[K>>3]=ha+0.0;R=R+1|0;if((R|0)==(h|0))break c;else a=a+(b<<3)|0}}else{ia=c;ja=0}while(1){a=A+(ja<<3)|0;W=0.0;M=+p[a>>3];R=0;do{M=M+ +p[ca+(R<<3)>>3]*+p[ia+(R<<3)>>3];C=R|1;W=W+ +p[ca+(C<<3)>>3]*+p[ia+(C<<3)>>3];R=R+2|0}while((R|0)<=(r|0));if(g){V=M;R=ba;while(1){Q=V+ +p[ca+(R<<3)>>3]*+p[ia+(R<<3)>>3];R=R+1|0;if((R|0)==(x|0)){ka=Q;break}else V=Q}}else ka=M;p[a>>3]=W+ka;ja=ja+1|0;if((ja|0)==(h|0))break;else ia=ia+(b<<3)|0}}while(0);e=e+1|0;if((e|0)==(o|0))break;else{A=A+(d<<3)|0;s=s+(v<<3)|0}}}if((y|0)==(i|0)){u=k;return}P5b(y);f[l>>2]=i;f[q>>2]=136;u=k;return}function uX(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0,Ha=0,Ia=0.0,Ja=0.0;k=u;u=u+1104|0;l=k;m=f[h>>2]|0;o=f[h+4>>2]|0;h=f[i>>2]|0;q=f[i+4>>2]|0;i=l+8|0;Nac(i|0,0,1088)|0;f[l>>2]=i;r=l+4|0;f[r>>2]=136;s=j&16;t=b>>>3;b=d>>>3;d=g>>>4;if(j&1){f[r>>2]=o;if(o>>>0>136){g=N5b(o>>>0>536870911?-1:o<<3)|0;Nac(g|0,0,o<<3|0)|0;f[l>>2]=g;v=t;w=1;x=g;y=o}else{v=t;w=1;x=i;y=o}}else{v=1;w=t;x=0;y=m}m=(q|0)>0;if(!(j&2)){if(m){j=(x|0)==0;t=h+-4|0;o=(h|0)<4;g=(s|0)==0;z=(y|0)>0;A=h&-4;B=(y|0)<1|j;C=a;D=e;E=0;while(1){F=e+((Y(d,E)|0)<<4)|0;if(B)G=j?C:x;else{H=0;do{I=C+((Y(H,v)|0)<<3)|0;J=f[I+4>>2]|0;K=x+(H<<3)|0;f[K>>2]=f[I>>2];f[K+4>>2]=J;H=H+1|0}while((H|0)!=(y|0));G=x}if(o)L=0;else{H=0;do{if(g){M=0.0;N=0.0;O=0.0;P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0}else{J=H|1;K=H|2;I=H|3;M=+p[D+(K<<4)>>3];N=+p[D+(J<<4)>>3];O=+p[D+(H<<4)>>3];P=+p[D+(I<<4)>>3];Q=+p[D+(I<<4)+8>>3];R=+p[D+(K<<4)+8>>3];S=+p[D+(J<<4)+8>>3];T=+p[D+(H<<4)+8>>3]}if(z){J=c+(H<<3)|0;K=0;U=M;V=N;W=O;X=P;Z=Q;_=R;$=S;aa=T;while(1){ba=+n[G+(K<<3)>>2];ca=+n[G+(K<<3)+4>>2];da=+n[J>>2];ea=+n[J+4>>2];fa=W+(ba*da-ca*ea);ga=aa+(ca*da+ba*ea);ea=+n[J+8>>2];da=+n[J+12>>2];ha=V+(ba*ea-ca*da);ia=$+(ca*ea+ba*da);da=+n[J+16>>2];ea=+n[J+20>>2];ja=U+(ba*da-ca*ea);ka=_+(ca*da+ba*ea);ea=+n[J+24>>2];da=+n[J+28>>2];la=X+(ba*ea-ca*da);ma=Z+(ca*ea+ba*da);K=K+1|0;if((K|0)==(y|0)){na=ja;oa=ha;pa=fa;qa=la;ra=ma;sa=ka;ta=ia;ua=ga;break}else{J=J+(b<<3)|0;U=ja;V=ha;W=fa;X=la;Z=ma;_=ka;$=ia;aa=ga}}}else{na=M;oa=N;pa=O;qa=P;ra=Q;sa=R;ta=S;ua=T}p[D+(H<<4)>>3]=pa;p[D+(H<<4)+8>>3]=ua;J=H|1;p[D+(J<<4)>>3]=oa;p[D+(J<<4)+8>>3]=ta;J=H|2;p[D+(J<<4)>>3]=na;p[D+(J<<4)+8>>3]=sa;J=H|3;p[D+(J<<4)>>3]=qa;p[D+(J<<4)+8>>3]=ra;H=H+4|0}while((H|0)<=(t|0));L=A}a:do if((h|0)>(L|0))if(g){if(z)va=L;else{Nac(F+(L<<4)|0,0,h-L<<4|0)|0;break}do{H=c+(va<<3)|0;J=0;aa=0.0;$=0.0;while(1){_=+n[G+(J<<3)>>2];Z=+n[G+(J<<3)+4>>2];X=+n[H>>2];W=+n[H+4>>2];aa=aa+(_*X-Z*W);$=$+(Z*X+_*W);J=J+1|0;if((J|0)==(y|0))break;else H=H+(b<<3)|0}p[D+(va<<4)>>3]=aa;p[D+(va<<4)+8>>3]=$;va=va+1|0}while((va|0)!=(h|0))}else{if(z)wa=L;else{H=L;while(1){H=H+1|0;if((H|0)==(h|0))break a}}do{H=D+(wa<<4)+8|0;J=D+(wa<<4)|0;K=c+(wa<<3)|0;I=0;W=+p[J>>3];_=+p[H>>3];while(1){X=+n[G+(I<<3)>>2];Z=+n[G+(I<<3)+4>>2];V=+n[K>>2];U=+n[K+4>>2];W=W+(X*V-Z*U);_=_+(Z*V+X*U);I=I+1|0;if((I|0)==(y|0))break;else K=K+(b<<3)|0}p[J>>3]=W;p[H>>3]=_;wa=wa+1|0}while((wa|0)!=(h|0))}while(0);E=E+1|0;if((E|0)==(q|0))break;else{C=C+(w<<3)|0;D=D+(d<<4)|0}}}}else if(m){m=(x|0)==0;D=(s|0)==0;s=y+-2|0;C=(y|0)<2;E=y&-2;wa=(y|0)<1|m;G=(h|0)>0;L=(y|0)>0;z=(E|0)<(y|0);va=(y|0)>0;g=(E|0)<(y|0);A=a;a=e;e=0;while(1){if(wa)xa=m?A:x;else{t=0;do{o=A+((Y(t,v)|0)<<3)|0;j=f[o+4>>2]|0;B=x+(t<<3)|0;f[B>>2]=f[o>>2];f[B+4>>2]=j;t=t+1|0}while((t|0)!=(y|0));xa=x}b:do if(G)if(D){if(C){t=c;j=0;while(1){if(L){B=0;ra=0.0;qa=0.0;while(1){sa=+n[xa+(B<<3)>>2];na=+n[xa+(B<<3)+4>>2];ta=+n[t+(B<<3)>>2];oa=+n[t+(B<<3)+4>>2];ua=ra+(sa*ta-na*oa);pa=qa+(na*ta+sa*oa);B=B+1|0;if((B|0)==(y|0)){ya=ua;za=pa;break}else{ra=ua;qa=pa}}}else{ya=0.0;za=0.0}p[a+(j<<4)>>3]=ya+0.0;p[a+(j<<4)+8>>3]=za+0.0;j=j+1|0;if((j|0)==(h|0))break b;else t=t+(b<<3)|0}}else{Aa=c;Ba=0}while(1){t=0;qa=0.0;ra=0.0;_=0.0;W=0.0;do{pa=+n[xa+(t<<3)>>2];ua=+n[xa+(t<<3)+4>>2];oa=+n[Aa+(t<<3)>>2];sa=+n[Aa+(t<<3)+4>>2];ra=ra+(pa*oa-ua*sa);_=_+(ua*oa+pa*sa);j=t|1;sa=+n[xa+(j<<3)>>2];pa=+n[xa+(j<<3)+4>>2];oa=+n[Aa+(j<<3)>>2];ua=+n[Aa+(j<<3)+4>>2];qa=qa+(sa*oa-pa*ua);W=W+(pa*oa+sa*ua);t=t+2|0}while((t|0)<=(s|0));if(z){t=E;ua=ra;sa=_;while(1){oa=+n[xa+(t<<3)>>2];pa=+n[xa+(t<<3)+4>>2];ta=+n[Aa+(t<<3)>>2];na=+n[Aa+(t<<3)+4>>2];T=ua+(oa*ta-pa*na);S=sa+(pa*ta+oa*na);t=t+1|0;if((t|0)==(y|0)){Ca=T;Da=S;break}else{ua=T;sa=S}}}else{Ca=ra;Da=_}p[a+(Ba<<4)>>3]=qa+Ca;p[a+(Ba<<4)+8>>3]=W+Da;Ba=Ba+1|0;if((Ba|0)==(h|0))break;else Aa=Aa+(b<<3)|0}}else{if(C){t=c;j=0;while(1){B=a+(j<<4)+8|0;H=a+(j<<4)|0;sa=+p[H>>3];ua=+p[B>>3];if(va){J=0;S=sa;T=ua;while(1){na=+n[xa+(J<<3)>>2];oa=+n[xa+(J<<3)+4>>2];ta=+n[t+(J<<3)>>2];pa=+n[t+(J<<3)+4>>2];R=S+(na*ta-oa*pa);Q=T+(oa*ta+na*pa);J=J+1|0;if((J|0)==(y|0)){Ea=R;Fa=Q;break}else{S=R;T=Q}}}else{Ea=sa;Fa=ua}p[H>>3]=Ea+0.0;p[B>>3]=Fa+0.0;j=j+1|0;if((j|0)==(h|0))break b;else t=t+(b<<3)|0}}else{Ga=c;Ha=0}while(1){t=a+(Ha<<4)+8|0;j=a+(Ha<<4)|0;J=0;T=0.0;S=+p[j>>3];W=+p[t>>3];qa=0.0;do{_=+n[xa+(J<<3)>>2];ra=+n[xa+(J<<3)+4>>2];Q=+n[Ga+(J<<3)>>2];R=+n[Ga+(J<<3)+4>>2];S=S+(_*Q-ra*R);W=W+(ra*Q+_*R);o=J|1;R=+n[xa+(o<<3)>>2];_=+n[xa+(o<<3)+4>>2];Q=+n[Ga+(o<<3)>>2];ra=+n[Ga+(o<<3)+4>>2];T=T+(R*Q-_*ra);qa=qa+(_*Q+R*ra);J=J+2|0}while((J|0)<=(s|0));if(g){J=E;ua=S;sa=W;while(1){ra=+n[xa+(J<<3)>>2];R=+n[xa+(J<<3)+4>>2];Q=+n[Ga+(J<<3)>>2];_=+n[Ga+(J<<3)+4>>2];pa=ua+(ra*Q-R*_);na=sa+(R*Q+ra*_);J=J+1|0;if((J|0)==(y|0)){Ia=pa;Ja=na;break}else{ua=pa;sa=na}}}else{Ia=S;Ja=W}p[j>>3]=T+Ia;p[t>>3]=qa+Ja;Ha=Ha+1|0;if((Ha|0)==(h|0))break;else Ga=Ga+(b<<3)|0}}while(0);e=e+1|0;if((e|0)==(q|0))break;else{A=A+(w<<3)|0;a=a+(d<<4)|0}}}d=f[l>>2]|0;if((d|0)==(i|0)){u=k;return}if(d|0)P5b(d);f[l>>2]=i;f[r>>2]=136;u=k;return}function vX(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0,za=0,Aa=0.0,Ba=0.0;k=u;u=u+1168|0;l=k;m=f[h>>2]|0;n=f[h+4>>2]|0;h=f[i>>2]|0;o=f[i+4>>2]|0;i=l+8|0;Nac(i|0,0,1152)|0;f[l>>2]=i;q=l+4|0;f[q>>2]=72;r=j&16;s=b>>>4;b=d>>>4;d=g>>>4;if(j&1){f[q>>2]=n;if(n>>>0>72){g=N5b(n>>>0>268435455?-1:n<<4)|0;Nac(g|0,0,n<<4|0)|0;f[l>>2]=g;t=s;v=1;w=g;x=n}else{t=s;v=1;w=i;x=n}}else{t=1;v=s;w=0;x=m}m=(o|0)>0;if(!(j&2)){if(m){j=(w|0)==0;s=h+-4|0;n=(h|0)<4;g=(r|0)==0;y=(x|0)>0;z=h&-4;A=(x|0)<1|j;B=(s>>>2<<6)+64|0;C=a;D=e;E=0;while(1){F=e+((Y(d,E)|0)<<4)|0;if(A)G=j?C:w;else{H=0;do{I=C+((Y(H,t)|0)<<4)|0;J=w+(H<<4)|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];f[J+8>>2]=f[I+8>>2];f[J+12>>2]=f[I+12>>2];H=H+1|0}while((H|0)!=(x|0));G=w}a:do if(!n)if(g){if(y)K=0;else{Nac(F|0,0,B|0)|0;L=z;break}do{H=c+(K<<4)|0;I=0;M=0.0;N=0.0;O=0.0;P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;while(1){U=+p[G+(I<<4)>>3];V=+p[G+(I<<4)+8>>3];W=+p[H>>3];X=+p[H+8>>3];N=N+(U*W-V*X);T=T+(V*W+U*X);X=+p[H+16>>3];W=+p[H+24>>3];M=M+(U*X-V*W);R=R+(V*X+U*W);W=+p[H+32>>3];X=+p[H+40>>3];P=P+(U*W-V*X);S=S+(V*W+U*X);X=+p[H+48>>3];W=+p[H+56>>3];O=O+(U*X-V*W);Q=Q+(V*X+U*W);I=I+1|0;if((I|0)==(x|0))break;else H=H+(b<<4)|0}p[D+(K<<4)>>3]=N;p[D+(K<<4)+8>>3]=T;H=K|1;p[D+(H<<4)>>3]=M;p[D+(H<<4)+8>>3]=R;H=K|2;p[D+(H<<4)>>3]=P;p[D+(H<<4)+8>>3]=S;H=K|3;p[D+(H<<4)>>3]=O;p[D+(H<<4)+8>>3]=Q;K=K+4|0}while((K|0)<=(s|0));L=z}else{if(y)Z=0;else{H=0;while(1){H=H+4|0;if((H|0)>(s|0)){L=z;break a}}}do{H=D+(Z<<4)|0;I=D+(Z<<4)+8|0;J=Z|1;_=D+(J<<4)|0;$=D+(J<<4)+8|0;J=Z|2;aa=D+(J<<4)|0;ba=D+(J<<4)+8|0;J=Z|3;ca=D+(J<<4)|0;da=D+(J<<4)+8|0;J=c+(Z<<4)|0;ea=0;W=+p[_>>3];U=+p[H>>3];X=+p[ca>>3];V=+p[aa>>3];fa=+p[da>>3];ga=+p[$>>3];ha=+p[ba>>3];ia=+p[I>>3];while(1){ja=+p[G+(ea<<4)>>3];ka=+p[G+(ea<<4)+8>>3];la=+p[J>>3];ma=+p[J+8>>3];U=U+(ja*la-ka*ma);ia=ia+(ka*la+ja*ma);ma=+p[J+16>>3];la=+p[J+24>>3];W=W+(ja*ma-ka*la);ga=ga+(ka*ma+ja*la);la=+p[J+32>>3];ma=+p[J+40>>3];V=V+(ja*la-ka*ma);ha=ha+(ka*la+ja*ma);ma=+p[J+48>>3];la=+p[J+56>>3];X=X+(ja*ma-ka*la);fa=fa+(ka*ma+ja*la);ea=ea+1|0;if((ea|0)==(x|0))break;else J=J+(b<<4)|0}p[H>>3]=U;p[I>>3]=ia;p[_>>3]=W;p[$>>3]=ga;p[aa>>3]=V;p[ba>>3]=ha;p[ca>>3]=X;p[da>>3]=fa;Z=Z+4|0}while((Z|0)<=(s|0));L=z}else L=0;while(0);b:do if((h|0)>(L|0))if(g){if(y)na=L;else{Nac(F+(L<<4)|0,0,h-L<<4|0)|0;break}do{J=c+(na<<4)|0;ea=0;Q=0.0;O=0.0;while(1){S=+p[G+(ea<<4)>>3];P=+p[G+(ea<<4)+8>>3];R=+p[J>>3];M=+p[J+8>>3];Q=Q+(S*R-P*M);O=O+(P*R+S*M);ea=ea+1|0;if((ea|0)==(x|0))break;else J=J+(b<<4)|0}p[D+(na<<4)>>3]=Q;p[D+(na<<4)+8>>3]=O;na=na+1|0}while((na|0)!=(h|0))}else{if(y)oa=L;else{J=L;while(1){J=J+1|0;if((J|0)==(h|0))break b}}do{J=D+(oa<<4)+8|0;ea=D+(oa<<4)|0;da=c+(oa<<4)|0;ca=0;fa=+p[ea>>3];X=+p[J>>3];while(1){ha=+p[G+(ca<<4)>>3];V=+p[G+(ca<<4)+8>>3];ga=+p[da>>3];W=+p[da+8>>3];fa=fa+(ha*ga-V*W);X=X+(V*ga+ha*W);ca=ca+1|0;if((ca|0)==(x|0))break;else da=da+(b<<4)|0}p[ea>>3]=fa;p[J>>3]=X;oa=oa+1|0}while((oa|0)!=(h|0))}while(0);E=E+1|0;if((E|0)==(o|0))break;else{C=C+(v<<4)|0;D=D+(d<<4)|0}}}}else if(m){m=(w|0)==0;D=(r|0)==0;r=x+-2|0;C=(x|0)<2;E=x&-2;oa=(x|0)<1|m;G=(h|0)>0;L=(x|0)>0;y=(E|0)<(x|0);na=(x|0)>0;g=(E|0)<(x|0);z=a;a=e;e=0;while(1){if(oa)pa=m?z:w;else{s=0;do{Z=z+((Y(s,t)|0)<<4)|0;K=w+(s<<4)|0;f[K>>2]=f[Z>>2];f[K+4>>2]=f[Z+4>>2];f[K+8>>2]=f[Z+8>>2];f[K+12>>2]=f[Z+12>>2];s=s+1|0}while((s|0)!=(x|0));pa=w}c:do if(G)if(D){if(C){s=c;Z=0;while(1){if(L){K=0;O=0.0;Q=0.0;while(1){W=+p[pa+(K<<4)>>3];ha=+p[pa+(K<<4)+8>>3];ga=+p[s+(K<<4)>>3];V=+p[s+(K<<4)+8>>3];ia=O+(W*ga-ha*V);U=Q+(ha*ga+W*V);K=K+1|0;if((K|0)==(x|0)){qa=ia;ra=U;break}else{O=ia;Q=U}}}else{qa=0.0;ra=0.0}p[a+(Z<<4)>>3]=qa+0.0;p[a+(Z<<4)+8>>3]=ra+0.0;Z=Z+1|0;if((Z|0)==(h|0))break c;else s=s+(b<<4)|0}}else{sa=c;ta=0}while(1){s=0;Q=0.0;O=0.0;X=0.0;fa=0.0;do{U=+p[pa+(s<<4)>>3];ia=+p[pa+(s<<4)+8>>3];V=+p[sa+(s<<4)>>3];W=+p[sa+(s<<4)+8>>3];O=O+(U*V-ia*W);X=X+(ia*V+U*W);Z=s|1;W=+p[pa+(Z<<4)>>3];U=+p[pa+(Z<<4)+8>>3];V=+p[sa+(Z<<4)>>3];ia=+p[sa+(Z<<4)+8>>3];Q=Q+(W*V-U*ia);fa=fa+(U*V+W*ia);s=s+2|0}while((s|0)<=(r|0));if(y){s=E;ia=O;W=X;while(1){V=+p[pa+(s<<4)>>3];U=+p[pa+(s<<4)+8>>3];ga=+p[sa+(s<<4)>>3];ha=+p[sa+(s<<4)+8>>3];M=ia+(V*ga-U*ha);S=W+(U*ga+V*ha);s=s+1|0;if((s|0)==(x|0)){ua=M;va=S;break}else{ia=M;W=S}}}else{ua=O;va=X}p[a+(ta<<4)>>3]=Q+ua;p[a+(ta<<4)+8>>3]=fa+va;ta=ta+1|0;if((ta|0)==(h|0))break;else sa=sa+(b<<4)|0}}else{if(C){s=c;Z=0;while(1){K=a+(Z<<4)+8|0;J=a+(Z<<4)|0;W=+p[J>>3];ia=+p[K>>3];if(na){ea=0;S=W;M=ia;while(1){ha=+p[pa+(ea<<4)>>3];V=+p[pa+(ea<<4)+8>>3];ga=+p[s+(ea<<4)>>3];U=+p[s+(ea<<4)+8>>3];R=S+(ha*ga-V*U);P=M+(V*ga+ha*U);ea=ea+1|0;if((ea|0)==(x|0)){wa=R;xa=P;break}else{S=R;M=P}}}else{wa=W;xa=ia}p[J>>3]=wa+0.0;p[K>>3]=xa+0.0;Z=Z+1|0;if((Z|0)==(h|0))break c;else s=s+(b<<4)|0}}else{ya=c;za=0}while(1){s=a+(za<<4)+8|0;Z=a+(za<<4)|0;ea=0;M=0.0;S=+p[Z>>3];fa=+p[s>>3];Q=0.0;do{X=+p[pa+(ea<<4)>>3];O=+p[pa+(ea<<4)+8>>3];P=+p[ya+(ea<<4)>>3];R=+p[ya+(ea<<4)+8>>3];S=S+(X*P-O*R);fa=fa+(O*P+X*R);B=ea|1;R=+p[pa+(B<<4)>>3];X=+p[pa+(B<<4)+8>>3];P=+p[ya+(B<<4)>>3];O=+p[ya+(B<<4)+8>>3];M=M+(R*P-X*O);Q=Q+(X*P+R*O);ea=ea+2|0}while((ea|0)<=(r|0));if(g){ea=E;ia=S;W=fa;while(1){O=+p[pa+(ea<<4)>>3];R=+p[pa+(ea<<4)+8>>3];P=+p[ya+(ea<<4)>>3];X=+p[ya+(ea<<4)+8>>3];U=ia+(O*P-R*X);ha=W+(R*P+O*X);ea=ea+1|0;if((ea|0)==(x|0)){Aa=U;Ba=ha;break}else{ia=U;W=ha}}}else{Aa=S;Ba=fa}p[Z>>3]=M+Aa;p[s>>3]=Q+Ba;za=za+1|0;if((za|0)==(h|0))break;else ya=ya+(b<<4)|0}}while(0);e=e+1|0;if((e|0)==(o|0))break;else{z=z+(v<<4)|0;a=a+(d<<4)|0}}}d=f[l>>2]|0;if((d|0)==(i|0)){u=k;return}if(d|0)P5b(d);f[l>>2]=i;f[q>>2]=72;u=k;return}function wX(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0,la=0.0;k=u;u=u+1072|0;l=k;m=f[h>>2]|0;o=f[h+4>>2]|0;h=f[i>>2]|0;q=f[i+4>>2]|0;i=l+8|0;f[l>>2]=i;r=l+4|0;f[r>>2]=264;s=j&16;t=b>>>2;b=d>>>2;d=g>>>3;if(j&1){f[r>>2]=o;if(o>>>0>264){g=N5b(o>>>0>1073741823?-1:o<<2)|0;f[l>>2]=g;v=t;w=1;x=g;y=o;z=g}else{v=t;w=1;x=i;y=o;z=i}}else{v=1;w=t;x=0;y=m;z=i}m=(q|0)>0;if(!(j&2)){if(m){j=(x|0)==0;t=h+-4|0;o=(h|0)<4;g=(s|0)==0;A=(y|0)>0;B=h&-4;C=(y|0)<1|j;D=(t>>>2<<5)+32|0;E=e;F=0;G=a;while(1){H=e+((Y(d,F)|0)<<3)|0;if(C)I=j?G:x;else{J=0;do{K=G+((Y(J,v)|0)<<2)|0;f[x+(J<<2)>>2]=f[K>>2];J=J+1|0}while((J|0)!=(y|0));I=x}a:do if(!o)if(g){if(A)L=0;else{Nac(H|0,0,D|0)|0;M=B;break}do{J=c+(L<<2)|0;N=0.0;O=0.0;P=0.0;Q=0.0;K=0;while(1){R=+n[I+(K<<2)>>2];Q=Q+R*+n[J>>2];P=P+R*+n[J+4>>2];O=O+R*+n[J+8>>2];N=N+R*+n[J+12>>2];K=K+1|0;if((K|0)==(y|0))break;else J=J+(b<<2)|0}p[E+(L<<3)>>3]=Q;p[E+((L|1)<<3)>>3]=P;p[E+((L|2)<<3)>>3]=O;p[E+((L|3)<<3)>>3]=N;L=L+4|0}while((L|0)<=(t|0));M=B}else{if(A)S=0;else{J=0;while(1){J=J+4|0;if((J|0)>(t|0)){M=B;break a}}}do{J=E+((S|3)<<3)|0;K=E+((S|2)<<3)|0;T=E+((S|1)<<3)|0;U=E+(S<<3)|0;V=c+(S<<2)|0;R=+p[J>>3];W=+p[K>>3];X=+p[T>>3];Z=+p[U>>3];_=0;while(1){$=+n[I+(_<<2)>>2];Z=Z+$*+n[V>>2];X=X+$*+n[V+4>>2];W=W+$*+n[V+8>>2];R=R+$*+n[V+12>>2];_=_+1|0;if((_|0)==(y|0))break;else V=V+(b<<2)|0}p[U>>3]=Z;p[T>>3]=X;p[K>>3]=W;p[J>>3]=R;S=S+4|0}while((S|0)<=(t|0));M=B}else M=0;while(0);b:do if((h|0)>(M|0)){if(!g){if(A)aa=M;else break;while(1){V=E+(aa<<3)|0;_=c+(aa<<2)|0;N=+p[V>>3];ba=0;while(1){N=N+ +n[I+(ba<<2)>>2]*+n[_>>2];ba=ba+1|0;if((ba|0)==(y|0))break;else _=_+(b<<2)|0}p[V>>3]=N;aa=aa+1|0;if((aa|0)==(h|0))break b}}if(A)ca=M;else{Nac(H+(M<<3)|0,0,h-M<<3|0)|0;break}do{_=c+(ca<<2)|0;R=0.0;ba=0;while(1){R=R+ +n[I+(ba<<2)>>2]*+n[_>>2];ba=ba+1|0;if((ba|0)==(y|0))break;else _=_+(b<<2)|0}p[E+(ca<<3)>>3]=R;ca=ca+1|0}while((ca|0)!=(h|0))}while(0);F=F+1|0;if((F|0)==(q|0))break;else{E=E+(d<<3)|0;G=G+(w<<2)|0}}}}else if(m){m=(x|0)==0;G=(h|0)>0;E=(s|0)==0;s=y+-2|0;F=(y|0)<2;ca=y&-2;I=(y|0)<1|m;M=(y|0)>0;A=(ca|0)<(y|0);aa=(y|0)>0;g=(ca|0)<(y|0);B=e;e=0;t=a;while(1){if(I)da=m?t:x;else{a=0;do{S=t+((Y(a,v)|0)<<2)|0;f[x+(a<<2)>>2]=f[S>>2];a=a+1|0}while((a|0)!=(y|0));da=x}c:do if(G)if(E){if(F){a=c;S=0;while(1){if(M){N=0.0;L=0;while(1){W=N+ +n[da+(L<<2)>>2]*+n[a+(L<<2)>>2];L=L+1|0;if((L|0)==(y|0)){ea=W;break}else N=W}}else ea=0.0;p[B+(S<<3)>>3]=ea+0.0;S=S+1|0;if((S|0)==(h|0))break c;else a=a+(b<<2)|0}}else{fa=c;ga=0}while(1){N=0.0;R=0.0;a=0;do{R=R+ +n[da+(a<<2)>>2]*+n[fa+(a<<2)>>2];S=a|1;N=N+ +n[da+(S<<2)>>2]*+n[fa+(S<<2)>>2];a=a+2|0}while((a|0)<=(s|0));if(A){W=R;a=ca;while(1){X=W+ +n[da+(a<<2)>>2]*+n[fa+(a<<2)>>2];a=a+1|0;if((a|0)==(y|0)){ha=X;break}else W=X}}else ha=R;p[B+(ga<<3)>>3]=N+ha;ga=ga+1|0;if((ga|0)==(h|0))break;else fa=fa+(b<<2)|0}}else{if(F){a=c;S=0;while(1){L=B+(S<<3)|0;W=+p[L>>3];if(aa){X=W;D=0;while(1){Z=X+ +n[da+(D<<2)>>2]*+n[a+(D<<2)>>2];D=D+1|0;if((D|0)==(y|0)){ia=Z;break}else X=Z}}else ia=W;p[L>>3]=ia+0.0;S=S+1|0;if((S|0)==(h|0))break c;else a=a+(b<<2)|0}}else{ja=c;ka=0}while(1){a=B+(ka<<3)|0;X=0.0;N=+p[a>>3];S=0;do{N=N+ +n[da+(S<<2)>>2]*+n[ja+(S<<2)>>2];D=S|1;X=X+ +n[da+(D<<2)>>2]*+n[ja+(D<<2)>>2];S=S+2|0}while((S|0)<=(s|0));if(g){W=N;S=ca;while(1){R=W+ +n[da+(S<<2)>>2]*+n[ja+(S<<2)>>2];S=S+1|0;if((S|0)==(y|0)){la=R;break}else W=R}}else la=N;p[a>>3]=X+la;ka=ka+1|0;if((ka|0)==(h|0))break;else ja=ja+(b<<2)|0}}while(0);e=e+1|0;if((e|0)==(q|0))break;else{B=B+(d<<3)|0;t=t+(w<<2)|0}}}if((z|0)==(i|0)){u=k;return}P5b(z);f[l>>2]=i;f[r>>2]=264;u=k;return}function xX(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>3;b=d>>>3;d=g>>>3;g=(a|0)==0;n=(k&4|0)==0;k=g?0:n?h:1;o=g?0:n?1:h;if(!m)return;h=o<<1;n=o*3|0;g=o<<2;q=(l|0)<4;r=l+-4|0;s=(r|0)>3?r:3;t=(s&2147483644)+4|0;u=s>>>2;s=Y(u,g)|0;v=(u<<2)+4|0;u=c;c=e;e=a;w=m;m=a+(g<<3)|0;while(1){w=w+-1|0;if(!e){if(q)x=0;else{a=0;do{y=a|1;z=+p[u+(y<<3)>>3]*i;p[c+(a<<3)>>3]=+p[u+(a<<3)>>3]*i;p[c+(y<<3)>>3]=z;y=a|2;A=a|3;z=+p[u+(A<<3)>>3]*i;p[c+(y<<3)>>3]=+p[u+(y<<3)>>3]*i;p[c+(A<<3)>>3]=z;a=a+4|0}while((a|0)<=(r|0));x=t}if((x|0)<(l|0)){a=x;do{p[c+(a<<3)>>3]=+p[u+(a<<3)>>3]*i;a=a+1|0}while((a|0)!=(l|0))}}else{if(q){B=e;C=0}else{a=0;A=e;while(1){y=a|1;z=+p[u+(y<<3)>>3]*i+ +p[A+(o<<3)>>3]*j;p[c+(a<<3)>>3]=+p[u+(a<<3)>>3]*i+ +p[A>>3]*j;p[c+(y<<3)>>3]=z;y=a|2;D=a|3;z=+p[u+(D<<3)>>3]*i+ +p[A+(n<<3)>>3]*j;p[c+(y<<3)>>3]=+p[u+(y<<3)>>3]*i+ +p[A+(h<<3)>>3]*j;p[c+(D<<3)>>3]=z;a=a+4|0;if((a|0)>(r|0))break;else A=A+(g<<3)|0}B=m+(s<<3)|0;C=v}if((C|0)<(l|0)){A=C;a=B;while(1){p[c+(A<<3)>>3]=+p[u+(A<<3)>>3]*i+ +p[a>>3]*j;A=A+1|0;if((A|0)==(l|0))break;else a=a+(o<<3)|0}}}if(!w)break;else{u=u+(b<<3)|0;c=c+(d<<3)|0;e=e+(k<<3)|0;m=m+(k<<3)|0}}return}function yX(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>3;b=d>>>4;d=g>>>3;g=(a|0)==0;o=(k&4|0)==0;k=g?0:o?h:1;q=g?0:o?1:h;if(!m)return;h=q<<1;o=q*3|0;g=q<<2;r=(l|0)<4;s=l+-4|0;t=s>>>2;u=(t<<2)+4|0;v=c;c=e;e=a;w=m;m=a+(Y(q,(t<<5)+32|0)|0)|0;while(1){w=w+-1|0;if(!e){if(r)x=0;else{t=0;do{a=t|1;y=+p[v+(a<<4)>>3]*i;z=+p[v+(a<<4)+8>>3]*i;A=+p[v+(t<<4)+8>>3]*i;n[c+(t<<3)>>2]=+p[v+(t<<4)>>3]*i;n[c+(t<<3)+4>>2]=A;n[c+(a<<3)>>2]=y;n[c+(a<<3)+4>>2]=z;a=t|2;B=t|3;z=+p[v+(B<<4)>>3]*i;y=+p[v+(B<<4)+8>>3]*i;A=+p[v+(a<<4)+8>>3]*i;n[c+(a<<3)>>2]=+p[v+(a<<4)>>3]*i;n[c+(a<<3)+4>>2]=A;n[c+(B<<3)>>2]=z;n[c+(B<<3)+4>>2]=y;t=t+4|0}while((t|0)<=(s|0));x=u}if((x|0)<(l|0)){t=x;do{y=+p[v+(t<<4)+8>>3]*i;n[c+(t<<3)>>2]=+p[v+(t<<4)>>3]*i;n[c+(t<<3)+4>>2]=y;t=t+1|0}while((t|0)!=(l|0))}}else{if(r){C=e;D=0}else{t=e;B=0;while(1){a=B|1;y=+p[v+(a<<4)>>3]*i+ +n[t+(q<<3)>>2]*j;z=+p[v+(a<<4)+8>>3]*i+ +n[t+(q<<3)+4>>2]*j;A=+p[v+(B<<4)+8>>3]*i+ +n[t+4>>2]*j;n[c+(B<<3)>>2]=+p[v+(B<<4)>>3]*i+ +n[t>>2]*j;n[c+(B<<3)+4>>2]=A;n[c+(a<<3)>>2]=y;n[c+(a<<3)+4>>2]=z;a=B|2;E=B|3;z=+p[v+(E<<4)>>3]*i+ +n[t+(o<<3)>>2]*j;y=+p[v+(E<<4)+8>>3]*i+ +n[t+(o<<3)+4>>2]*j;A=+p[v+(a<<4)+8>>3]*i+ +n[t+(h<<3)+4>>2]*j;n[c+(a<<3)>>2]=+p[v+(a<<4)>>3]*i+ +n[t+(h<<3)>>2]*j;n[c+(a<<3)+4>>2]=A;n[c+(E<<3)>>2]=z;n[c+(E<<3)+4>>2]=y;B=B+4|0;if((B|0)>(s|0)){C=m;D=u;break}else t=t+(g<<3)|0}}if((D|0)<(l|0)){t=C;B=D;while(1){y=+p[v+(B<<4)+8>>3]*i+ +n[t+4>>2]*j;n[c+(B<<3)>>2]=+p[v+(B<<4)>>3]*i+ +n[t>>2]*j;n[c+(B<<3)+4>>2]=y;B=B+1|0;if((B|0)==(l|0))break;else t=t+(q<<3)|0}}}if(!w)break;else{v=v+(b<<4)|0;c=c+(d<<3)|0;e=e+(k<<3)|0;m=m+(k<<3)|0}}return}function zX(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>4;b=d>>>4;d=g>>>4;g=(a|0)==0;n=(k&4|0)==0;k=g?0:n?h:1;o=g?0:n?1:h;if(!m)return;h=o<<1;n=o*3|0;g=o<<2;q=(l|0)<4;r=l+-4|0;s=r>>>2;t=(s<<2)+4|0;u=a;v=c;c=e;e=m;m=a+(Y(o,(s<<6)+64|0)|0)|0;while(1){e=e+-1|0;if(!u){if(q)w=0;else{s=0;do{x=+p[v+(s<<4)+8>>3]*i;a=s|1;y=+p[v+(a<<4)>>3]*i;z=+p[v+(a<<4)+8>>3]*i;p[c+(s<<4)>>3]=+p[v+(s<<4)>>3]*i;p[c+(s<<4)+8>>3]=x;p[c+(a<<4)>>3]=y;p[c+(a<<4)+8>>3]=z;a=s|2;z=+p[v+(a<<4)+8>>3]*i;A=s|3;y=+p[v+(A<<4)>>3]*i;x=+p[v+(A<<4)+8>>3]*i;p[c+(a<<4)>>3]=+p[v+(a<<4)>>3]*i;p[c+(a<<4)+8>>3]=z;p[c+(A<<4)>>3]=y;p[c+(A<<4)+8>>3]=x;s=s+4|0}while((s|0)<=(r|0));w=t}if((w|0)<(l|0)){s=w;do{x=+p[v+(s<<4)+8>>3]*i;p[c+(s<<4)>>3]=+p[v+(s<<4)>>3]*i;p[c+(s<<4)+8>>3]=x;s=s+1|0}while((s|0)!=(l|0))}}else{if(q){B=0;C=u}else{s=0;A=u;while(1){a=s|1;x=+p[v+(s<<4)+8>>3]*i+ +p[A+8>>3]*j;y=+p[v+(a<<4)>>3]*i+ +p[A+(o<<4)>>3]*j;z=+p[v+(a<<4)+8>>3]*i+ +p[A+(o<<4)+8>>3]*j;p[c+(s<<4)>>3]=+p[v+(s<<4)>>3]*i+ +p[A>>3]*j;p[c+(s<<4)+8>>3]=x;p[c+(a<<4)>>3]=y;p[c+(a<<4)+8>>3]=z;a=s|2;D=s|3;z=+p[v+(a<<4)+8>>3]*i+ +p[A+(h<<4)+8>>3]*j;y=+p[v+(D<<4)>>3]*i+ +p[A+(n<<4)>>3]*j;x=+p[v+(D<<4)+8>>3]*i+ +p[A+(n<<4)+8>>3]*j;p[c+(a<<4)>>3]=+p[v+(a<<4)>>3]*i+ +p[A+(h<<4)>>3]*j;p[c+(a<<4)+8>>3]=z;p[c+(D<<4)>>3]=y;p[c+(D<<4)+8>>3]=x;s=s+4|0;if((s|0)>(r|0)){B=t;C=m;break}else A=A+(g<<4)|0}}if((B|0)<(l|0)){A=C;s=B;while(1){x=+p[v+(s<<4)+8>>3]*i+ +p[A+8>>3]*j;p[c+(s<<4)>>3]=+p[v+(s<<4)>>3]*i+ +p[A>>3]*j;p[c+(s<<4)+8>>3]=x;s=s+1|0;if((s|0)==(l|0))break;else A=A+(o<<4)|0}}}if(!e)break;else{u=u+(k<<4)|0;v=v+(b<<4)|0;c=c+(d<<4)|0;m=m+(k<<4)|0}}return}function AX(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0;l=f[h>>2]|0;m=f[h+4>>2]|0;h=b>>>2;b=d>>>3;d=g>>>2;g=(a|0)==0;o=(k&4|0)==0;k=g?0:o?h:1;q=g?0:o?1:h;if(!m)return;h=q<<1;o=q*3|0;g=q<<2;r=(l|0)<4;s=l+-4|0;t=(s|0)>3?s:3;u=(t&2147483644)+4|0;v=t>>>2;t=Y(v,g)|0;w=(v<<2)+4|0;v=c;c=e;e=a;x=m;m=a+(g<<2)|0;while(1){x=x+-1|0;if(!e){if(r)y=0;else{a=0;do{z=a|1;A=+p[v+(z<<3)>>3]*i;n[c+(a<<2)>>2]=+p[v+(a<<3)>>3]*i;n[c+(z<<2)>>2]=A;z=a|2;B=a|3;A=+p[v+(B<<3)>>3]*i;n[c+(z<<2)>>2]=+p[v+(z<<3)>>3]*i;n[c+(B<<2)>>2]=A;a=a+4|0}while((a|0)<=(s|0));y=u}if((y|0)<(l|0)){a=y;do{n[c+(a<<2)>>2]=+p[v+(a<<3)>>3]*i;a=a+1|0}while((a|0)!=(l|0))}}else{if(r){C=e;D=0}else{a=0;B=e;while(1){z=a|1;A=+p[v+(z<<3)>>3]*i+ +n[B+(q<<2)>>2]*j;n[c+(a<<2)>>2]=+p[v+(a<<3)>>3]*i+ +n[B>>2]*j;n[c+(z<<2)>>2]=A;z=a|2;E=a|3;A=+p[v+(E<<3)>>3]*i+ +n[B+(o<<2)>>2]*j;n[c+(z<<2)>>2]=+p[v+(z<<3)>>3]*i+ +n[B+(h<<2)>>2]*j;n[c+(E<<2)>>2]=A;a=a+4|0;if((a|0)>(s|0))break;else B=B+(g<<2)|0}C=m+(t<<2)|0;D=w}if((D|0)<(l|0)){B=D;a=C;while(1){n[c+(B<<2)>>2]=+p[v+(B<<3)>>3]*i+ +n[a>>2]*j;B=B+1|0;if((B|0)==(l|0))break;else a=a+(q<<2)|0}}}if(!x)break;else{v=v+(b<<3)|0;c=c+(d<<2)|0;e=e+(k<<2)|0;m=m+(k<<2)|0}}return}function BX(a,b,c,d,e,g,h,i,j,k,l,m,n,o,p){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;h=h|0;i=+i;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;q=u;u=u+448|0;r=q+392|0;s=q+336|0;t=q+280|0;v=q+224|0;w=q+168|0;x=q+112|0;y=q+56|0;z=q;A=(o&2|0)==0;B=(o&1|0)!=0;C=B?l:m;D=B?m:l;B=A?C:n;E=A?n:C;C=(o&4|0)==0;A=C?D:n;F=C?n:D;f[r>>2]=1124007936;C=r+4|0;G=r+8|0;H=r+40|0;I=C;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[H>>2]=G;K=r+48|0;L=r+44|0;f[L>>2]=K;f[K>>2]=0;f[r+52>>2]=0;f[s>>2]=1124007936;M=s+4|0;N=s+8|0;O=s+40|0;I=M;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[O>>2]=N;P=s+48|0;Q=s+44|0;f[Q>>2]=P;f[P>>2]=0;f[s+52>>2]=0;f[t>>2]=1124007936;R=t+4|0;S=t+8|0;T=t+40|0;I=R;J=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(J|0));f[T>>2]=S;I=t+48|0;J=t+44|0;f[J>>2]=I;f[I>>2]=0;f[t+52>>2]=0;if(a|0){Qi(v,l,m,p,a,b);b=v+36|0;a=f[b>>2]|0;if(a|0){m=a+12|0;f[m>>2]=(f[m>>2]|0)+1}m=r+36|0;a=f[m>>2]|0;if(a|0?(l=a+12|0,a=f[l>>2]|0,f[l>>2]=a+-1,(a|0)==1):0)kL(r);f[m>>2]=0;a=r+16|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[C>>2]|0)>0){l=f[H>>2]|0;U=0;do{f[l+(U<<2)>>2]=0;U=U+1|0;V=f[C>>2]|0}while((U|0)<(V|0));f[r>>2]=f[v>>2];if((V|0)<3)W=12;else W=14}else{f[r>>2]=f[v>>2];W=12}if((W|0)==12){V=f[v+4>>2]|0;if((V|0)<3){f[C>>2]=V;f[G>>2]=f[v+8>>2];f[r+12>>2]=f[v+12>>2];V=f[v+44>>2]|0;U=f[L>>2]|0;f[U>>2]=f[V>>2];f[U+4>>2]=f[V+4>>2]}else W=14}if((W|0)==14)jL(r,v);V=v+16|0;f[a>>2]=f[V>>2];f[r+20>>2]=f[v+20>>2];f[r+24>>2]=f[v+24>>2];f[r+28>>2]=f[v+28>>2];f[r+32>>2]=f[v+32>>2];a=f[b>>2]|0;f[m>>2]=a;if(a|0?(m=a+12|0,a=f[m>>2]|0,f[m>>2]=a+-1,(a|0)==1):0)kL(v);f[b>>2]=0;b=v+4|0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[b>>2]|0)>0){V=f[v+40>>2]|0;a=0;do{f[V+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[b>>2]|0))}b=f[v+44>>2]|0;if((b|0)!=(v+48|0))UC(b)}if(c|0){Qi(v,B,E,p,c,d);d=v+36|0;c=f[d>>2]|0;if(c|0){E=c+12|0;f[E>>2]=(f[E>>2]|0)+1}E=s+36|0;c=f[E>>2]|0;if(c|0?(B=c+12|0,c=f[B>>2]|0,f[B>>2]=c+-1,(c|0)==1):0)kL(s);f[E>>2]=0;c=s+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[M>>2]|0)>0){B=f[O>>2]|0;b=0;do{f[B+(b<<2)>>2]=0;b=b+1|0;X=f[M>>2]|0}while((b|0)<(X|0));f[s>>2]=f[v>>2];if((X|0)<3)W=35;else W=37}else{f[s>>2]=f[v>>2];W=35}if((W|0)==35){X=f[v+4>>2]|0;if((X|0)<3){f[M>>2]=X;f[N>>2]=f[v+8>>2];f[s+12>>2]=f[v+12>>2];X=f[v+44>>2]|0;b=f[Q>>2]|0;f[b>>2]=f[X>>2];f[b+4>>2]=f[X+4>>2]}else W=37}if((W|0)==37)jL(s,v);X=v+16|0;f[c>>2]=f[X>>2];f[s+20>>2]=f[v+20>>2];f[s+24>>2]=f[v+24>>2];f[s+28>>2]=f[v+28>>2];f[s+32>>2]=f[v+32>>2];c=f[d>>2]|0;f[E>>2]=c;if(c|0?(E=c+12|0,c=f[E>>2]|0,f[E>>2]=c+-1,(c|0)==1):0)kL(v);f[d>>2]=0;d=v+4|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[d>>2]|0)>0){X=f[v+40>>2]|0;c=0;do{f[X+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[d>>2]|0))}d=f[v+44>>2]|0;if((d|0)!=(v+48|0))UC(d)}if((g|0)!=0&i!=0.0){Qi(v,A,F,p,g,h);h=v+36|0;g=f[h>>2]|0;if(g|0){F=g+12|0;f[F>>2]=(f[F>>2]|0)+1}F=t+36|0;g=f[F>>2]|0;if(g|0?(A=g+12|0,g=f[A>>2]|0,f[A>>2]=g+-1,(g|0)==1):0)kL(t);f[F>>2]=0;g=t+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[R>>2]|0)>0){A=f[T>>2]|0;d=0;do{f[A+(d<<2)>>2]=0;d=d+1|0;Y=f[R>>2]|0}while((d|0)<(Y|0));f[t>>2]=f[v>>2];if((Y|0)<3)W=58;else W=60}else{f[t>>2]=f[v>>2];W=58}if((W|0)==58){Y=f[v+4>>2]|0;if((Y|0)<3){f[R>>2]=Y;f[S>>2]=f[v+8>>2];f[t+12>>2]=f[v+12>>2];Y=f[v+44>>2]|0;d=f[J>>2]|0;f[d>>2]=f[Y>>2];f[d+4>>2]=f[Y+4>>2]}else W=60}if((W|0)==60)jL(t,v);W=v+16|0;f[g>>2]=f[W>>2];f[t+20>>2]=f[v+20>>2];f[t+24>>2]=f[v+24>>2];f[t+28>>2]=f[v+28>>2];f[t+32>>2]=f[v+32>>2];g=f[h>>2]|0;f[F>>2]=g;if(g|0?(F=g+12|0,g=f[F>>2]|0,f[F>>2]=g+-1,(g|0)==1):0)kL(v);f[h>>2]=0;h=v+4|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[h>>2]|0)>0){W=f[v+40>>2]|0;g=0;do{f[W+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[h>>2]|0))}h=f[v+44>>2]|0;if((h|0)!=(v+48|0))UC(h)}Qi(v,D,n,p,j,k);f[w>>2]=f[r>>2];k=w+4|0;j=f[C>>2]|0;f[k>>2]=j;p=w+8|0;f[p>>2]=f[G>>2];f[w+12>>2]=f[r+12>>2];G=w+16|0;n=r+16|0;f[G>>2]=f[n>>2];f[w+20>>2]=f[r+20>>2];f[w+24>>2]=f[r+24>>2];f[w+28>>2]=f[r+28>>2];f[w+32>>2]=f[r+32>>2];D=w+36|0;h=r+36|0;g=f[h>>2]|0;f[D>>2]=g;W=w+40|0;f[W>>2]=p;p=w+48|0;F=w+44|0;f[F>>2]=p;f[p>>2]=0;f[w+52>>2]=0;if(!g)Z=j;else{j=g+12|0;f[j>>2]=(f[j>>2]|0)+1;Z=f[C>>2]|0}if((Z|0)<3){Z=f[L>>2]|0;j=f[F>>2]|0;f[j>>2]=f[Z>>2];f[j+4>>2]=f[Z+4>>2]}else{f[k>>2]=0;jL(w,r)}f[x>>2]=f[s>>2];Z=x+4|0;j=f[M>>2]|0;f[Z>>2]=j;g=x+8|0;f[g>>2]=f[N>>2];f[x+12>>2]=f[s+12>>2];N=x+16|0;Y=s+16|0;f[N>>2]=f[Y>>2];f[x+20>>2]=f[s+20>>2];f[x+24>>2]=f[s+24>>2];f[x+28>>2]=f[s+28>>2];f[x+32>>2]=f[s+32>>2];d=x+36|0;A=s+36|0;c=f[A>>2]|0;f[d>>2]=c;X=x+40|0;f[X>>2]=g;g=x+48|0;E=x+44|0;f[E>>2]=g;f[g>>2]=0;f[x+52>>2]=0;if(!c)_=j;else{j=c+12|0;f[j>>2]=(f[j>>2]|0)+1;_=f[M>>2]|0}if((_|0)<3){_=f[Q>>2]|0;j=f[E>>2]|0;f[j>>2]=f[_>>2];f[j+4>>2]=f[_+4>>2]}else{f[Z>>2]=0;jL(x,s)}f[y>>2]=f[t>>2];_=y+4|0;j=f[R>>2]|0;f[_>>2]=j;c=y+8|0;f[c>>2]=f[S>>2];f[y+12>>2]=f[t+12>>2];S=y+16|0;b=t+16|0;f[S>>2]=f[b>>2];f[y+20>>2]=f[t+20>>2];f[y+24>>2]=f[t+24>>2];f[y+28>>2]=f[t+28>>2];f[y+32>>2]=f[t+32>>2];B=y+36|0;a=t+36|0;V=f[a>>2]|0;f[B>>2]=V;m=y+40|0;f[m>>2]=c;c=y+48|0;U=y+44|0;f[U>>2]=c;f[c>>2]=0;f[y+52>>2]=0;if(!V)$=j;else{j=V+12|0;f[j>>2]=(f[j>>2]|0)+1;$=f[R>>2]|0}if(($|0)<3){$=f[J>>2]|0;j=f[U>>2]|0;f[j>>2]=f[$>>2];f[j+4>>2]=f[$+4>>2]}else{f[_>>2]=0;jL(y,t)}f[z>>2]=f[v>>2];$=z+4|0;j=v+4|0;V=f[j>>2]|0;f[$>>2]=V;l=z+8|0;f[l>>2]=f[v+8>>2];f[z+12>>2]=f[v+12>>2];aa=z+16|0;ba=v+16|0;f[aa>>2]=f[ba>>2];f[z+20>>2]=f[v+20>>2];f[z+24>>2]=f[v+24>>2];f[z+28>>2]=f[v+28>>2];f[z+32>>2]=f[v+32>>2];ca=z+36|0;da=v+36|0;ea=f[da>>2]|0;f[ca>>2]=ea;fa=z+40|0;f[fa>>2]=l;l=z+48|0;ga=z+44|0;f[ga>>2]=l;f[l>>2]=0;f[z+52>>2]=0;if(!ea)ha=V;else{V=ea+12|0;f[V>>2]=(f[V>>2]|0)+1;ha=f[j>>2]|0}if((ha|0)<3){ha=f[v+44>>2]|0;V=f[ga>>2]|0;f[V>>2]=f[ha>>2];f[V+4>>2]=f[ha+4>>2]}else{f[$>>2]=0;jL(z,v)}oX(w,x,e,y,i,z,o);o=f[ca>>2]|0;if(o|0?(ha=o+12|0,o=f[ha>>2]|0,f[ha>>2]=o+-1,(o|0)==1):0)kL(z);f[ca>>2]=0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[$>>2]|0)>0){aa=f[fa>>2]|0;fa=0;do{f[aa+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[$>>2]|0))}$=f[ga>>2]|0;if(($|0)!=(l|0))UC($);$=f[B>>2]|0;if($|0?(l=$+12|0,$=f[l>>2]|0,f[l>>2]=$+-1,($|0)==1):0)kL(y);f[B>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[_>>2]|0)>0){S=f[m>>2]|0;m=0;do{f[S+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[_>>2]|0))}_=f[U>>2]|0;if((_|0)!=(c|0))UC(_);_=f[d>>2]|0;if(_|0?(c=_+12|0,_=f[c>>2]|0,f[c>>2]=_+-1,(_|0)==1):0)kL(x);f[d>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[Z>>2]|0)>0){N=f[X>>2]|0;X=0;do{f[N+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[Z>>2]|0))}Z=f[E>>2]|0;if((Z|0)!=(g|0))UC(Z);Z=f[D>>2]|0;do if(Z|0){g=Z+12|0;E=f[g>>2]|0;f[g>>2]=E+-1;if((E|0)!=1)break;kL(w)}while(0);f[D>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[k>>2]|0)>0){G=f[W>>2]|0;W=0;do{f[G+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[k>>2]|0))}k=f[F>>2]|0;if((k|0)!=(p|0))UC(k);k=f[da>>2]|0;do if(k|0){p=k+12|0;F=f[p>>2]|0;f[p>>2]=F+-1;if((F|0)!=1)break;kL(v)}while(0);f[da>>2]=0;f[ba>>2]=0;f[ba+4>>2]=0;f[ba+8>>2]=0;f[ba+12>>2]=0;if((f[j>>2]|0)>0){ba=f[v+40>>2]|0;da=0;do{f[ba+(da<<2)>>2]=0;da=da+1|0}while((da|0)<(f[j>>2]|0))}j=f[v+44>>2]|0;if((j|0)!=(v+48|0))UC(j);j=f[a>>2]|0;do if(j|0){v=j+12|0;da=f[v>>2]|0;f[v>>2]=da+-1;if((da|0)!=1)break;kL(t)}while(0);f[a>>2]=0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;if((f[R>>2]|0)>0){b=f[T>>2]|0;T=0;do{f[b+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[J>>2]|0;if((R|0)!=(I|0))UC(R);R=f[A>>2]|0;do if(R|0){I=R+12|0;J=f[I>>2]|0;f[I>>2]=J+-1;if((J|0)!=1)break;kL(s)}while(0);f[A>>2]=0;f[Y>>2]=0;f[Y+4>>2]=0;f[Y+8>>2]=0;f[Y+12>>2]=0;if((f[M>>2]|0)>0){Y=f[O>>2]|0;O=0;do{f[Y+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[M>>2]|0))}M=f[Q>>2]|0;if((M|0)!=(P|0))UC(M);M=f[h>>2]|0;do if(M|0){P=M+12|0;Q=f[P>>2]|0;f[P>>2]=Q+-1;if((Q|0)!=1)break;kL(r)}while(0);f[h>>2]=0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[C>>2]|0)>0){n=f[H>>2]|0;H=0;do{f[n+(H<<2)>>2]=0;H=H+1|0}while((H|0)<(f[C>>2]|0))}C=f[L>>2]|0;if((C|0)==(K|0)){u=q;return}UC(C);u=q;return}function CX(a,c,d,e,g,h,i){a=a|0;c=c|0;d=+d;e=e|0;g=+g;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;j=u;u=u+352|0;k=j+336|0;l=j+280|0;m=j+224|0;n=j+168|0;o=j+112|0;p=j+56|0;q=j;do if((yM(a)|0)==65536){r=f[a+4>>2]|0;f[l>>2]=f[r>>2];s=l+4|0;t=r+4|0;f[s>>2]=f[t>>2];v=l+8|0;f[v>>2]=f[r+8>>2];f[l+12>>2]=f[r+12>>2];f[l+16>>2]=f[r+16>>2];f[l+20>>2]=f[r+20>>2];f[l+24>>2]=f[r+24>>2];f[l+28>>2]=f[r+28>>2];f[l+32>>2]=f[r+32>>2];w=f[r+36>>2]|0;f[l+36>>2]=w;f[l+40>>2]=v;v=l+48|0;x=l+44|0;f[x>>2]=v;f[v>>2]=0;f[l+52>>2]=0;if(w|0){v=w+12|0;f[v>>2]=(f[v>>2]|0)+1}if((f[t>>2]|0)<3){t=f[r+44>>2]|0;v=f[x>>2]|0;f[v>>2]=f[t>>2];f[v+4>>2]=f[t+4>>2];break}else{f[s>>2]=0;jL(l,r);break}}else yL(l,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[m>>2]=f[a>>2];r=m+4|0;s=a+4|0;f[r>>2]=f[s>>2];t=m+8|0;f[t>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];v=f[a+36>>2]|0;f[m+36>>2]=v;f[m+40>>2]=t;t=m+48|0;x=m+44|0;f[x>>2]=t;f[t>>2]=0;f[m+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[a+44>>2]|0;t=f[x>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;jL(m,a);break}}else yL(m,c,-1);while(0);do if(g!=0.0){if((yM(e)|0)!=65536){yL(n,e,-1);break}c=f[e+4>>2]|0;f[n>>2]=f[c>>2];a=n+4|0;r=c+4|0;f[a>>2]=f[r>>2];s=n+8|0;f[s>>2]=f[c+8>>2];f[n+12>>2]=f[c+12>>2];f[n+16>>2]=f[c+16>>2];f[n+20>>2]=f[c+20>>2];f[n+24>>2]=f[c+24>>2];f[n+28>>2]=f[c+28>>2];f[n+32>>2]=f[c+32>>2];t=f[c+36>>2]|0;f[n+36>>2]=t;f[n+40>>2]=s;s=n+48|0;x=n+44|0;f[x>>2]=s;f[s>>2]=0;f[n+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[c+44>>2]|0;s=f[x>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[a>>2]=0;jL(n,c);break}}else{f[n>>2]=1124007936;c=n+8|0;a=n+40|0;y=n+4|0;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[a>>2]=c;r=n+48|0;f[n+44>>2]=r;f[r>>2]=0;f[n+52>>2]=0}while(0);e=l+40|0;r=f[e>>2]|0;s=f[r+4>>2]|0;x=f[r>>2]|0;r=f[l>>2]|0;t=r&4095;if((t|0)!=(f[m>>2]&4095|0)){f[k>>2]=0;f[k+4>>2]=0;y=aD(k,16)|0;A=212392;z=y+16|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));bO(-215,k,212409,212249,1558);bD(k)}if(((r&4087)+-5|0)>>>0>=2){f[k>>2]=0;f[k+4>>2]=0;Vac(aD(k,210)|0,212414,210)|0;bO(-215,k,212409,212249,1558);bD(k)}switch(i&3){case 0:{v=f[m+12>>2]|0;if((s|0)==(f[m+8>>2]|0)){B=v;C=x}else{f[k>>2]=0;f[k+4>>2]=0;y=aD(k,19)|0;A=212625;z=y+19|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));bO(-215,k,212409,212249,1565);bD(k);B=v;C=x}break}case 1:{v=f[m+12>>2]|0;if((x|0)==(f[m+8>>2]|0)){B=v;C=s}else{f[k>>2]=0;f[k+4>>2]=0;y=aD(k,20)|0;A=212645;z=y+20|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));bO(-215,k,212409,212249,1570);bD(k);B=v;C=s}break}case 2:{v=f[m+8>>2]|0;if((s|0)==(f[m+12>>2]|0)){B=v;C=x}else{f[k>>2]=0;f[k+4>>2]=0;y=aD(k,19)|0;A=212625;z=y+19|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));bO(-215,k,212409,212249,1575);bD(k);B=v;C=x}break}case 3:{v=f[m+8>>2]|0;if((x|0)==(f[m+12>>2]|0)){B=v;C=s}else{f[k>>2]=0;f[k+4>>2]=0;y=aD(k,20)|0;A=212645;z=y+20|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));bO(-215,k,212409,212249,1580);bD(k);B=v;C=s}break}default:{}}v=n+16|0;do if(f[v>>2]|0){w=f[n+4>>2]|0;if((w|0)<3)D=Y(f[n+12>>2]|0,f[n+8>>2]|0)|0;else{E=f[n+40>>2]|0;F=0;G=1;while(1){H=Y(f[E+(F<<2)>>2]|0,G)|0;F=F+1|0;if((F|0)==(w|0)){D=H;break}else G=H}}if(!((w|0)==0|(D|0)==0)){if((f[n>>2]&4095|0)!=(t|0)){f[k>>2]=0;f[k+4>>2]=0;y=aD(k,16)|0;A=212666;z=y+16|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));bO(-215,k,212409,212249,1588);bD(k)}w=f[n+8>>2]|0;if(!(i&4)){if((w|0)==(C|0)?(f[n+12>>2]|0)==(B|0):0)break}else if((w|0)==(B|0)?(f[n+12>>2]|0)==(C|0):0)break;f[k>>2]=0;f[k+4>>2]=0;Vac(aD(k,158)|0,212683,158)|0;bO(-215,k,212409,212249,1588);bD(k)}}while(0);aM(h,C,B,t,-1,0,0);do if((yM(h)|0)==65536){t=f[h+4>>2]|0;f[o>>2]=f[t>>2];D=o+4|0;w=t+4|0;f[D>>2]=f[w>>2];G=o+8|0;f[G>>2]=f[t+8>>2];f[o+12>>2]=f[t+12>>2];f[o+16>>2]=f[t+16>>2];f[o+20>>2]=f[t+20>>2];f[o+24>>2]=f[t+24>>2];f[o+28>>2]=f[t+28>>2];f[o+32>>2]=f[t+32>>2];F=f[t+36>>2]|0;f[o+36>>2]=F;f[o+40>>2]=G;G=o+48|0;E=o+44|0;f[E>>2]=G;f[G>>2]=0;f[o+52>>2]=0;if(F|0){G=F+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;G=f[E>>2]|0;f[G>>2]=f[w>>2];f[G+4>>2]=f[w+4>>2];break}else{f[D>>2]=0;jL(o,t);break}}else yL(o,h,-1);while(0);if(i&4){h=o+16|0;if((f[v>>2]|0)==(f[h>>2]|0)){f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=n;t=p+8|0;f[t>>2]=0;f[t+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=n;ZL(k,p);I=i&-5;J=h}else{I=i;J=h}}else{I=i;J=o+16|0}f[p>>2]=1124007936;i=p+4|0;h=p+8|0;t=p+40|0;y=i;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[t>>2]=h;D=p+48|0;w=p+44|0;f[w>>2]=D;f[D>>2]=0;f[p+52>>2]=0;G=f[J>>2]|0;E=l+16|0;if((G|0)!=(f[E>>2]|0)?(G|0)!=(f[m+16>>2]|0):0)K=o;else{G=f[o>>2]&4095;f[q>>2]=1124007936;F=q+4|0;c=q+8|0;a=q+40|0;y=F;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[a>>2]=c;H=q+48|0;L=q+44|0;f[L>>2]=H;f[H>>2]=0;f[q+52>>2]=0;f[k>>2]=C;f[k+4>>2]=B;hL(q,2,k,G);G=q+36|0;B=f[G>>2]|0;if(B|0){C=B+12|0;f[C>>2]=(f[C>>2]|0)+1}C=p+36|0;B=f[C>>2]|0;if(B|0?(M=B+12|0,B=f[M>>2]|0,f[M>>2]=B+-1,(B|0)==1):0)kL(p);f[C>>2]=0;B=p+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[i>>2]|0)>0){M=f[t>>2]|0;N=0;do{f[M+(N<<2)>>2]=0;N=N+1|0;O=f[i>>2]|0}while((N|0)<(O|0));f[p>>2]=f[q>>2];if((O|0)<3)P=75;else P=77}else{f[p>>2]=f[q>>2];P=75}if((P|0)==75){O=f[F>>2]|0;if((O|0)<3){f[i>>2]=O;f[h>>2]=f[c>>2];f[p+12>>2]=f[q+12>>2];c=f[L>>2]|0;h=f[w>>2]|0;f[h>>2]=f[c>>2];f[h+4>>2]=f[c+4>>2]}else P=77}if((P|0)==77)jL(p,q);c=q+16|0;f[B>>2]=f[c>>2];f[p+20>>2]=f[q+20>>2];f[p+24>>2]=f[q+24>>2];f[p+28>>2]=f[q+28>>2];f[p+32>>2]=f[q+32>>2];B=f[G>>2]|0;f[C>>2]=B;if(B|0?(C=B+12|0,B=f[C>>2]|0,f[C>>2]=B+-1,(B|0)==1):0)kL(q);f[G>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[F>>2]|0)>0){c=f[a>>2]|0;a=0;do{f[c+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[F>>2]|0))}F=f[L>>2]|0;if((F|0)!=(H|0))UC(F);K=p}switch(r&4095){case 5:{nX(f[E>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[K+16>>2]|0,f[K+48>>2]|0,x,s,f[K+12>>2]|0,I,5);break}case 6:{BX(f[E>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[K+16>>2]|0,f[K+48>>2]|0,x,s,f[K+12>>2]|0,I,6);break}case 13:{nX(f[E>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[K+16>>2]|0,f[K+48>>2]|0,x,s,f[K+12>>2]|0,I,13);break}case 14:{P=92;break}default:{f[k>>2]=0;f[k+4>>2]=0;y=aD(k,49)|0;A=212190;z=y+49|0;do{b[y>>0]=b[A>>0]|0;y=y+1|0;A=A+1|0}while((y|0)<(z|0));bO(-215,k,212409,212249,1623);bD(k);P=92}}if((P|0)==92)BX(f[E>>2]|0,f[l+48>>2]|0,f[m+16>>2]|0,f[m+48>>2]|0,d,f[v>>2]|0,f[n+48>>2]|0,g,f[J>>2]|0,f[o+48>>2]|0,x,s,f[K+12>>2]|0,I,14);if((K|0)!=(o|0)){I=k+8|0;f[I>>2]=0;f[I+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=o;SP(K,k)}k=p+36|0;K=f[k>>2]|0;if(K|0?(I=K+12|0,K=f[I>>2]|0,f[I>>2]=K+-1,(K|0)==1):0)kL(p);f[k>>2]=0;k=p+16|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[t>>2]|0;t=0;do{f[k+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[i>>2]|0))}i=f[w>>2]|0;if((i|0)!=(D|0))UC(i);i=o+36|0;D=f[i>>2]|0;if(D|0?(w=D+12|0,D=f[w>>2]|0,f[w>>2]=D+-1,(D|0)==1):0)kL(o);f[i>>2]=0;i=o+4|0;f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=0;f[J+12>>2]=0;if((f[i>>2]|0)>0){J=f[o+40>>2]|0;D=0;do{f[J+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[i>>2]|0))}i=f[o+44>>2]|0;if((i|0)!=(o+48|0))UC(i);i=n+36|0;o=f[i>>2]|0;if(o|0?(D=o+12|0,o=f[D>>2]|0,f[D>>2]=o+-1,(o|0)==1):0)kL(n);f[i>>2]=0;i=n+4|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[i>>2]|0)>0){v=f[n+40>>2]|0;o=0;do{f[v+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[i>>2]|0))}i=f[n+44>>2]|0;if((i|0)!=(n+48|0))UC(i);i=m+36|0;n=f[i>>2]|0;do if(n|0){o=n+12|0;v=f[o>>2]|0;f[o>>2]=v+-1;if((v|0)!=1)break;kL(m)}while(0);f[i>>2]=0;i=m+16|0;n=m+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[n>>2]|0)>0){i=f[m+40>>2]|0;v=0;do{f[i+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))UC(n);n=l+36|0;m=f[n>>2]|0;do if(m|0){v=m+12|0;i=f[v>>2]|0;f[v>>2]=i+-1;if((i|0)!=1)break;kL(l)}while(0);f[n>>2]=0;n=l+4|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;if((f[n>>2]|0)>0){E=f[e>>2]|0;e=0;do{f[E+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)==(l+48|0)){u=j;return}UC(n);u=j;return}function DX(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Z=0.0,_=0.0,$=0;e=u;u=u+1424|0;g=e+1400|0;h=e+1392|0;i=e+1384|0;j=e+1328|0;k=e+1272|0;l=e+1264|0;m=e+1208|0;o=e;q=e+1152|0;r=e+1096|0;dQ(i,47260);do if((yM(a)|0)==65536){s=f[a+4>>2]|0;f[j>>2]=f[s>>2];t=j+4|0;v=s+4|0;f[t>>2]=f[v>>2];w=j+8|0;f[w>>2]=f[s+8>>2];f[j+12>>2]=f[s+12>>2];f[j+16>>2]=f[s+16>>2];f[j+20>>2]=f[s+20>>2];f[j+24>>2]=f[s+24>>2];f[j+28>>2]=f[s+28>>2];f[j+32>>2]=f[s+32>>2];x=f[s+36>>2]|0;f[j+36>>2]=x;f[j+40>>2]=w;w=j+48|0;y=j+44|0;f[y>>2]=w;f[w>>2]=0;f[j+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[y>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[t>>2]=0;jL(j,s);break}}else yL(j,a,-1);while(0);do if((yM(d)|0)==65536){a=f[d+4>>2]|0;f[k>>2]=f[a>>2];s=k+4|0;t=a+4|0;f[s>>2]=f[t>>2];v=k+8|0;f[v>>2]=f[a+8>>2];w=k+12|0;f[w>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];y=f[a+36>>2]|0;f[k+36>>2]=y;f[k+40>>2]=v;x=k+48|0;z=k+44|0;f[z>>2]=x;f[x>>2]=0;f[k+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[t>>2]|0)<3){t=f[a+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[t>>2];f[x+4>>2]=f[t+4>>2];A=w;B=v;break}else{f[s>>2]=0;jL(k,a);A=w;B=v;break}}else{yL(k,d,-1);A=k+12|0;B=k+8|0}while(0);d=f[j>>2]|0;v=d&7;w=d>>>3&511;d=w+1|0;a=f[B>>2]|0;s=f[A>>2]|0;t=w+2|0;if(!((d|0)==(s|0)|(t|0)==(s|0))){f[g>>2]=0;f[g+4>>2]=0;C=aD(g,34)|0;D=212842;E=C+34|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,g,212877,212249,2088);bD(g)}s=j+40|0;x=f[s>>2]|0;z=f[x>>2]|0;f[l>>2]=f[x+4>>2];f[l+4>>2]=z;vM(c,l,(a<<3)+-8|v,-1,0,0);do if((yM(c)|0)==65536){l=f[c+4>>2]|0;f[m>>2]=f[l>>2];z=m+4|0;x=l+4|0;f[z>>2]=f[x>>2];y=m+8|0;f[y>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];F=f[l+36>>2]|0;f[m+36>>2]=F;f[m+40>>2]=y;y=m+48|0;G=m+44|0;f[G>>2]=y;f[y>>2]=0;f[m+52>>2]=0;if(F|0){y=F+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[l+44>>2]|0;y=f[G>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[z>>2]=0;jL(m,l);break}}else yL(m,c,-1);while(0);c=(v|2|0)==6;l=c?6:5;z=o+8|0;f[o>>2]=z;x=o+4|0;f[x>>2]=136;y=f[k>>2]|0;if((f[A>>2]|0)==(t|0)&((y&16384|0)!=0&(y&4095|0)==(l|0)))H=f[k+16>>2]|0;else{y=Y(t,a)|0;f[x>>2]=y;if(y>>>0>136){G=N5b(y>>>0>536870911?-1:y<<3)|0;f[o>>2]=G;I=G}else I=z;Qi(q,a,t,l,I,0);G=q+16|0;y=f[G>>2]|0;F=q+44|0;J=q+4|0;K=f[J>>2]|0;if((K|0)<3)M=Y(f[q+12>>2]|0,f[q+8>>2]|0)|0;else{N=f[q+40>>2]|0;O=0;P=1;while(1){Q=Y(f[N+(O<<2)>>2]|0,P)|0;O=O+1|0;if((O|0)==(K|0)){M=Q;break}else P=Q}}if((K|0)>0)R=f[(f[F>>2]|0)+(K+-1<<2)>>2]|0;else R=0;Nac(y|0,0,Y(R,M)|0)|0;M=f[A>>2]|0;if((M|0)!=(t|0)){f[g>>2]=-2147483648;f[g+4>>2]=2147483647;f[h>>2]=0;f[h+4>>2]=M;lL(r,q,g,h);M=g+8|0;f[M>>2]=0;f[M+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=r;OJ(k,g,l,1.0,0.0);M=r+36|0;t=f[M>>2]|0;if(t|0?(R=t+12|0,t=f[R>>2]|0,f[R>>2]=t+-1,(t|0)==1):0)kL(r);f[M>>2]=0;M=r+16|0;t=r+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[t>>2]|0)>0){M=f[r+40>>2]|0;R=0;do{f[M+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[t>>2]|0))}t=f[r+44>>2]|0;if((t|0)!=(r+48|0))UC(t)}else{t=g+8|0;f[t>>2]=0;f[t+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=q;OJ(k,g,l,1.0,0.0)}l=q+36|0;t=f[l>>2]|0;if(t|0){r=t+12|0;f[r>>2]=(f[r>>2]|0)+1}r=k+36|0;t=f[r>>2]|0;if(t|0?(R=t+12|0,t=f[R>>2]|0,f[R>>2]=t+-1,(t|0)==1):0)kL(k);f[r>>2]=0;t=k+16|0;R=k+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[R>>2]|0)>0){M=f[k+40>>2]|0;y=0;do{f[M+(y<<2)>>2]=0;y=y+1|0;S=f[R>>2]|0}while((y|0)<(S|0));f[k>>2]=f[q>>2];if((S|0)<3)T=54;else T=56}else{f[k>>2]=f[q>>2];T=54}if((T|0)==54){S=f[J>>2]|0;if((S|0)<3){f[R>>2]=S;f[B>>2]=f[q+8>>2];f[A>>2]=f[q+12>>2];B=f[F>>2]|0;S=f[k+44>>2]|0;f[S>>2]=f[B>>2];f[S+4>>2]=f[B+4>>2]}else T=56}if((T|0)==56)jL(k,q);f[t>>2]=f[G>>2];f[k+20>>2]=f[q+20>>2];f[k+24>>2]=f[q+24>>2];f[k+28>>2]=f[q+28>>2];f[k+32>>2]=f[q+32>>2];t=f[l>>2]|0;f[r>>2]=t;if(t|0?(r=t+12|0,t=f[r>>2]|0,f[r>>2]=t+-1,(t|0)==1):0)kL(q);f[l>>2]=0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[J>>2]|0)>0){G=f[q+40>>2]|0;l=0;do{f[G+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[J>>2]|0))}J=f[F>>2]|0;if((J|0)!=(q+48|0))UC(J);H=I}a:do if((d|0)==(a|0)){U=c?2.220446049250313e-16:1.1920928955078125e-07;I=f[k+16>>2]|0;if(w|0){J=f[f[k+44>>2]>>2]|0;if(c){F=0;while(1){l=I+(Y(J,F)|0)|0;G=0;while(1){if((F|0)!=(G|0)?+L(+(+p[l+(G<<3)>>3]))>U:0){V=47280;T=96;break a}if((G|0)<(w|0))G=G+1|0;else break}if((F|0)<(w|0))F=F+1|0;else{V=47312;T=96;break a}}}else{F=0;while(1){G=I+(Y(J,F)|0)|0;l=0;while(1){if((F|0)!=(l|0)?+L(+(+n[G+(l<<2)>>2]))>U:0){V=47280;T=96;break a}if((l|0)<(w|0))l=l+1|0;else break}if((F|0)<(w|0))F=F+1|0;else{V=47312;T=96;break a}}}}if(c){U=+p[I>>3];do if((f[k>>2]&16384|0)==0?(F=f[k+40>>2]|0,(f[F>>2]|0)!=1):0){J=f[f[k+44>>2]>>2]|0;if((f[F+4>>2]|0)==1){W=I+J|0;break}else{F=f[A>>2]|0;l=(F+1|0)>>>0<3?F:0;W=I+(Y(l,J)|0)+(1-(Y(l,F)|0)<<3)|0;break}}else T=85;while(0);if((T|0)==85)W=I+8|0;X=+p[W>>3];Z=U}else{_=+n[I>>2];do if((f[k>>2]&16384|0)==0?(F=f[k+40>>2]|0,(f[F>>2]|0)!=1):0){l=f[f[k+44>>2]>>2]|0;if((f[F+4>>2]|0)==1){$=I+l|0;break}else{F=f[A>>2]|0;J=(F+1|0)>>>0<3?F:0;$=I+(Y(J,l)|0)+(1-(Y(J,F)|0)<<2)|0;break}}else T=78;while(0);if((T|0)==78)$=I+4|0;X=+n[$>>2];Z=_}F=g+8|0;f[F>>2]=0;f[F+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=m;OJ(j,g,f[m>>2]&4095,Z,X)}else{V=47280;T=96}while(0);if((T|0)==96){T=f[V+(v<<2)>>2]|0;if(!T){f[g>>2]=0;f[g+4>>2]=0;C=aD(g,9)|0;D=255890;E=C+9|0;do{b[C>>0]=b[D>>0]|0;C=C+1|0;D=D+1|0}while((C|0)<(E|0));bO(-215,g,212877,212249,2144);bD(g)}f[g>>2]=j;f[g+4>>2]=m;f[g+8>>2]=0;RN(q,g,h,-1);g=f[q+20>>2]|0;D=q+16|0;C=h+4|0;E=0;while(1){if(E>>>0>=(f[D>>2]|0)>>>0)break;Wg[T&127](f[h>>2]|0,f[C>>2]|0,H,g,d,a);aL(q)|0;E=E+1|0}}E=f[o>>2]|0;if((E|0)!=(z|0)){if(E|0)P5b(E);f[o>>2]=z;f[x>>2]=136}x=m+36|0;z=f[x>>2]|0;if(z|0?(o=z+12|0,z=f[o>>2]|0,f[o>>2]=z+-1,(z|0)==1):0)kL(m);f[x>>2]=0;x=m+16|0;z=m+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[z>>2]|0)>0){x=f[m+40>>2]|0;o=0;do{f[x+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[z>>2]|0))}z=f[m+44>>2]|0;if((z|0)!=(m+48|0))UC(z);z=k+36|0;m=f[z>>2]|0;if(m|0?(o=m+12|0,m=f[o>>2]|0,f[o>>2]=m+-1,(m|0)==1):0)kL(k);f[z>>2]=0;z=k+16|0;m=k+4|0;f[z>>2]=0;f[z+4>>2]=0;f[z+8>>2]=0;f[z+12>>2]=0;if((f[m>>2]|0)>0){z=f[k+40>>2]|0;o=0;do{f[z+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)!=(k+48|0))UC(m);m=j+36|0;k=f[m>>2]|0;if(k|0?(o=k+12|0,k=f[o>>2]|0,f[o>>2]=k+-1,(k|0)==1):0)kL(j);f[m>>2]=0;m=j+16|0;k=j+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[k>>2]|0)>0){m=f[s>>2]|0;s=0;do{f[m+(s<<2)>>2]=0;s=s+1|0}while((s|0)<(f[k>>2]|0))}k=f[j+44>>2]|0;if((k|0)!=(j+48|0))UC(k);if(!(f[i+4>>2]|0)){u=e;return}u=e;return}function EX(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;i=d+8|0;j=d+16|0;k=d+20|0;l=0;do{m=LVb(+n[i>>2]+ +n[d>>2]*+(h[a+l>>0]|0))|0;o=l|1;p=LVb(+n[k>>2]+ +n[j>>2]*+(h[a+o>>0]|0))|0;b[c+l>>0]=m>>>0<256?m:(m|0)>0?255:0;b[c+o>>0]=p>>>0<256?p:(p|0)>0?255:0;l=l+2|0}while((l|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;l=d+12|0;j=d+20|0;k=d+28|0;i=d+40|0;p=d+44|0;o=0;do{m=LVb(+n[l>>2]+ +n[d>>2]*+(h[a+o>>0]|0))|0;q=o+1|0;r=LVb(+n[k>>2]+ +n[j>>2]*+(h[a+q>>0]|0))|0;s=o+2|0;t=LVb(+n[p>>2]+ +n[i>>2]*+(h[a+s>>0]|0))|0;b[c+o>>0]=m>>>0<256?m:(m|0)>0?255:0;b[c+q>>0]=r>>>0<256?r:(r|0)>0?255:0;b[c+s>>0]=t>>>0<256?t:(t|0)>0?255:0;o=o+3|0}while((o|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;o=d+16|0;i=d+24|0;p=d+36|0;j=d+48|0;k=d+56|0;l=d+72|0;t=d+76|0;s=0;do{r=LVb(+n[o>>2]+ +n[d>>2]*+(h[a+s>>0]|0))|0;q=s|1;m=LVb(+n[p>>2]+ +n[i>>2]*+(h[a+q>>0]|0))|0;b[c+s>>0]=r>>>0<256?r:(r|0)>0?255:0;b[c+q>>0]=m>>>0<256?m:(m|0)>0?255:0;m=s|2;q=LVb(+n[k>>2]+ +n[j>>2]*+(h[a+m>>0]|0))|0;r=s|3;u=LVb(+n[t>>2]+ +n[l>>2]*+(h[a+r>>0]|0))|0;b[c+m>>0]=q>>>0<256?q:(q|0)>0?255:0;b[c+r>>0]=u>>>0<256?u:(u|0)>0?255:0;s=s+4|0}while((s|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){v=a;w=c;x=0}else return;while(1){c=d;a=0;while(1){s=LVb(+(h[v+a>>0]|0)*+n[c+(a<<2)>>2]+ +n[c+(f<<2)>>2])|0;b[w+a>>0]=s>>>0<256?s:(s|0)>0?255:0;a=a+1|0;if((a|0)==(f|0))break;else c=c+(g<<2)|0}x=x+1|0;if((x|0)==(e|0))break;else{v=v+f|0;w=w+f|0}}return}}}function FX(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;h=d+8|0;i=d+16|0;j=d+20|0;k=0;do{l=LVb(+n[h>>2]+ +n[d>>2]*+(b[a+k>>0]|0))|0;m=k|1;o=LVb(+n[j>>2]+ +n[i>>2]*+(b[a+m>>0]|0))|0;b[c+k>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[c+m>>0]=(o+128|0)>>>0<256?o:(o|0)>0?127:128;k=k+2|0}while((k|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;k=d+12|0;i=d+20|0;j=d+28|0;h=d+40|0;o=d+44|0;m=0;do{l=LVb(+n[k>>2]+ +n[d>>2]*+(b[a+m>>0]|0))|0;p=m+1|0;q=LVb(+n[j>>2]+ +n[i>>2]*+(b[a+p>>0]|0))|0;r=m+2|0;s=LVb(+n[o>>2]+ +n[h>>2]*+(b[a+r>>0]|0))|0;b[c+m>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;b[c+p>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[c+r>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;m=m+3|0}while((m|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;m=d+16|0;h=d+24|0;o=d+36|0;i=d+48|0;j=d+56|0;k=d+72|0;s=d+76|0;r=0;do{q=LVb(+n[m>>2]+ +n[d>>2]*+(b[a+r>>0]|0))|0;p=r|1;l=LVb(+n[o>>2]+ +n[h>>2]*+(b[a+p>>0]|0))|0;b[c+r>>0]=(q+128|0)>>>0<256?q:(q|0)>0?127:128;b[c+p>>0]=(l+128|0)>>>0<256?l:(l|0)>0?127:128;l=r|2;p=LVb(+n[j>>2]+ +n[i>>2]*+(b[a+l>>0]|0))|0;q=r|3;t=LVb(+n[s>>2]+ +n[k>>2]*+(b[a+q>>0]|0))|0;b[c+l>>0]=(p+128|0)>>>0<256?p:(p|0)>0?127:128;b[c+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;r=r+4|0}while((r|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){u=a;v=c;w=0}else return;while(1){c=d;a=0;while(1){r=LVb(+(b[u+a>>0]|0)*+n[c+(a<<2)>>2]+ +n[c+(f<<2)>>2])|0;b[v+a>>0]=(r+128|0)>>>0<256?r:(r|0)>0?127:128;a=a+1|0;if((a|0)==(f|0))break;else c=c+(g<<2)|0}w=w+1|0;if((w|0)==(e|0))break;else{u=u+f|0;v=v+f|0}}return}}}function GX(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,k=0.0,l=0.0,m=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0,y=0,z=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;h=+n[c>>2];i=+n[c+8>>2];k=+n[c+16>>2];l=+n[c+20>>2];m=0;do{o=LVb(i+h*+(j[a+(m<<1)>>1]|0))|0;p=m|1;q=LVb(l+k*+(j[a+(p<<1)>>1]|0))|0;d[b+(m<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;d[b+(p<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;m=m+2|0}while((m|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;k=+n[c>>2];l=+n[c+12>>2];h=+n[c+20>>2];i=+n[c+28>>2];r=+n[c+40>>2];s=+n[c+44>>2];m=0;do{q=LVb(l+k*+(j[a+(m<<1)>>1]|0))|0;p=m+1|0;o=LVb(i+h*+(j[a+(p<<1)>>1]|0))|0;t=m+2|0;u=LVb(s+r*+(j[a+(t<<1)>>1]|0))|0;d[b+(m<<1)>>1]=q>>>0<65536?q:(q|0)>0?65535:0;d[b+(p<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;d[b+(t<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;m=m+3|0}while((m|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;r=+n[c>>2];s=+n[c+16>>2];h=+n[c+24>>2];i=+n[c+36>>2];k=+n[c+48>>2];l=+n[c+56>>2];v=+n[c+72>>2];w=+n[c+76>>2];m=0;do{u=LVb(s+r*+(j[a+(m<<1)>>1]|0))|0;t=m|1;o=LVb(i+h*+(j[a+(t<<1)>>1]|0))|0;d[b+(m<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[b+(t<<1)>>1]=o>>>0<65536?o:(o|0)>0?65535:0;o=m|2;t=LVb(l+k*+(j[a+(o<<1)>>1]|0))|0;u=m|3;p=LVb(w+v*+(j[a+(u<<1)>>1]|0))|0;d[b+(o<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[b+(u<<1)>>1]=p>>>0<65536?p:(p|0)>0?65535:0;m=m+4|0}while((m|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){x=a;y=b;z=0}else return;while(1){b=c;a=0;while(1){m=LVb(+(j[x+(a<<1)>>1]|0)*+n[b+(a<<2)>>2]+ +n[b+(f<<2)>>2])|0;d[y+(a<<1)>>1]=m>>>0<65536?m:(m|0)>0?65535:0;a=a+1|0;if((a|0)==(f|0))break;else b=b+(g<<2)|0}z=z+1|0;if((z|0)==(e|0))break;else{x=x+(f<<1)|0;y=y+(f<<1)|0}}return}}}function HX(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0.0,j=0.0,k=0.0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0;switch(f|0){case 2:{g=e<<1;if((e|0)<=0)return;h=+n[c>>2];i=+n[c+8>>2];j=+n[c+16>>2];k=+n[c+20>>2];l=0;do{m=LVb(i+h*+(d[a+(l<<1)>>1]|0))|0;o=l|1;p=LVb(k+j*+(d[a+(o<<1)>>1]|0))|0;d[b+(l<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;d[b+(o<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;l=l+2|0}while((l|0)<(g|0));return}case 3:{g=e*3|0;if((e|0)<=0)return;j=+n[c>>2];k=+n[c+12>>2];h=+n[c+20>>2];i=+n[c+28>>2];q=+n[c+40>>2];r=+n[c+44>>2];l=0;do{p=LVb(k+j*+(d[a+(l<<1)>>1]|0))|0;o=l+1|0;m=LVb(i+h*+(d[a+(o<<1)>>1]|0))|0;s=l+2|0;t=LVb(r+q*+(d[a+(s<<1)>>1]|0))|0;d[b+(l<<1)>>1]=(p+32768|0)>>>0<65536?p:(p|0)>0?32767:32768;d[b+(o<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;d[b+(s<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;l=l+3|0}while((l|0)<(g|0));return}case 4:{g=e<<2;if((e|0)<=0)return;q=+n[c>>2];r=+n[c+16>>2];h=+n[c+24>>2];i=+n[c+36>>2];j=+n[c+48>>2];k=+n[c+56>>2];u=+n[c+72>>2];v=+n[c+76>>2];l=0;do{t=LVb(r+q*+(d[a+(l<<1)>>1]|0))|0;s=l|1;m=LVb(i+h*+(d[a+(s<<1)>>1]|0))|0;d[b+(l<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[b+(s<<1)>>1]=(m+32768|0)>>>0<65536?m:(m|0)>0?32767:32768;m=l|2;s=LVb(k+j*+(d[a+(m<<1)>>1]|0))|0;t=l|3;o=LVb(v+u*+(d[a+(t<<1)>>1]|0))|0;d[b+(m<<1)>>1]=(s+32768|0)>>>0<65536?s:(s|0)>0?32767:32768;d[b+(t<<1)>>1]=(o+32768|0)>>>0<65536?o:(o|0)>0?32767:32768;l=l+4|0}while((l|0)<(g|0));return}default:{if((e|0)<=0)return;g=f+1|0;if((f|0)>0){w=a;x=b;y=0}else return;while(1){b=c;a=0;while(1){l=LVb(+(d[w+(a<<1)>>1]|0)*+n[b+(a<<2)>>2]+ +n[b+(f<<2)>>2])|0;d[x+(a<<1)>>1]=(l+32768|0)>>>0<65536?l:(l|0)>0?32767:32768;a=a+1|0;if((a|0)==(f|0))break;else b=b+(g<<2)|0}y=y+1|0;if((y|0)==(e|0))break;else{w=w+(f<<1)|0;x=x+(f<<1)|0}}return}}}function IX(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0.0,i=0.0,j=0.0,k=0.0,l=0,m=0,n=0,o=0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0;switch(e|0){case 2:{g=d<<1;if((d|0)<=0)return;h=+p[c>>3];i=+p[c+16>>3];j=+p[c+32>>3];k=+p[c+40>>3];l=0;do{m=MVb(i+h*+(f[a+(l<<2)>>2]|0))|0;n=l|1;o=MVb(k+j*+(f[a+(n<<2)>>2]|0))|0;f[b+(l<<2)>>2]=m;f[b+(n<<2)>>2]=o;l=l+2|0}while((l|0)<(g|0));return}case 3:{g=d*3|0;if((d|0)<=0)return;j=+p[c>>3];k=+p[c+24>>3];h=+p[c+40>>3];i=+p[c+56>>3];q=+p[c+80>>3];r=+p[c+88>>3];l=0;do{o=MVb(k+j*+(f[a+(l<<2)>>2]|0))|0;n=l+1|0;m=MVb(i+h*+(f[a+(n<<2)>>2]|0))|0;s=l+2|0;t=MVb(r+q*+(f[a+(s<<2)>>2]|0))|0;f[b+(l<<2)>>2]=o;f[b+(n<<2)>>2]=m;f[b+(s<<2)>>2]=t;l=l+3|0}while((l|0)<(g|0));return}case 4:{g=d<<2;if((d|0)<=0)return;q=+p[c>>3];r=+p[c+32>>3];h=+p[c+48>>3];i=+p[c+72>>3];j=+p[c+96>>3];k=+p[c+112>>3];u=+p[c+144>>3];v=+p[c+152>>3];l=0;do{t=MVb(r+q*+(f[a+(l<<2)>>2]|0))|0;s=l|1;m=MVb(i+h*+(f[a+(s<<2)>>2]|0))|0;f[b+(l<<2)>>2]=t;f[b+(s<<2)>>2]=m;m=l|2;s=MVb(k+j*+(f[a+(m<<2)>>2]|0))|0;t=l|3;n=MVb(v+u*+(f[a+(t<<2)>>2]|0))|0;f[b+(m<<2)>>2]=s;f[b+(t<<2)>>2]=n;l=l+4|0}while((l|0)<(g|0));return}default:{if((d|0)<=0)return;g=e+1|0;if((e|0)>0){w=a;x=b;y=0}else return;while(1){b=c;a=0;while(1){l=MVb(+(f[w+(a<<2)>>2]|0)*+p[b+(a<<3)>>3]+ +p[b+(e<<3)>>3])|0;f[x+(a<<2)>>2]=l;a=a+1|0;if((a|0)==(e|0))break;else b=b+(g<<3)|0}y=y+1|0;if((y|0)==(d|0))break;else{w=w+(e<<2)|0;x=x+(e<<2)|0}}return}}}function JX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0;switch(e|0){case 2:{f=d<<1;if((d|0)<=0)return;g=c+8|0;h=c+16|0;i=c+20|0;j=0;do{k=j|1;l=+n[h>>2]*+n[a+(k<<2)>>2]+ +n[i>>2];n[b+(j<<2)>>2]=+n[c>>2]*+n[a+(j<<2)>>2]+ +n[g>>2];n[b+(k<<2)>>2]=l;j=j+2|0}while((j|0)<(f|0));return}case 3:{f=d*3|0;if((d|0)<=0)return;j=c+12|0;g=c+20|0;i=c+28|0;h=c+40|0;k=c+44|0;m=0;do{o=m+1|0;l=+n[g>>2]*+n[a+(o<<2)>>2]+ +n[i>>2];p=m+2|0;q=+n[h>>2]*+n[a+(p<<2)>>2]+ +n[k>>2];n[b+(m<<2)>>2]=+n[c>>2]*+n[a+(m<<2)>>2]+ +n[j>>2];n[b+(o<<2)>>2]=l;n[b+(p<<2)>>2]=q;m=m+3|0}while((m|0)<(f|0));return}case 4:{f=d<<2;if((d|0)<=0)return;m=c+16|0;j=c+24|0;k=c+36|0;h=c+48|0;i=c+56|0;g=c+72|0;p=c+76|0;o=0;do{r=o|1;q=+n[j>>2]*+n[a+(r<<2)>>2]+ +n[k>>2];n[b+(o<<2)>>2]=+n[c>>2]*+n[a+(o<<2)>>2]+ +n[m>>2];n[b+(r<<2)>>2]=q;r=o|2;s=o|3;q=+n[g>>2]*+n[a+(s<<2)>>2]+ +n[p>>2];n[b+(r<<2)>>2]=+n[h>>2]*+n[a+(r<<2)>>2]+ +n[i>>2];n[b+(s<<2)>>2]=q;o=o+4|0}while((o|0)<(f|0));return}default:{if((d|0)<=0)return;f=e+1|0;if((e|0)>0){t=a;u=b;v=0}else return;while(1){b=c;a=0;while(1){n[u+(a<<2)>>2]=+n[t+(a<<2)>>2]*+n[b+(a<<2)>>2]+ +n[b+(e<<2)>>2];a=a+1|0;if((a|0)==(e|0))break;else b=b+(f<<2)|0}v=v+1|0;if((v|0)==(d|0))break;else{t=t+(e<<2)|0;u=u+(e<<2)|0}}return}}}function KX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,q=0.0,r=0,s=0,t=0,u=0,v=0;switch(e|0){case 2:{f=d<<1;if((d|0)<=0)return;g=c+16|0;h=c+32|0;i=c+40|0;j=0;do{k=j|1;l=+p[h>>3]*+p[a+(k<<3)>>3]+ +p[i>>3];p[b+(j<<3)>>3]=+p[c>>3]*+p[a+(j<<3)>>3]+ +p[g>>3];p[b+(k<<3)>>3]=l;j=j+2|0}while((j|0)<(f|0));return}case 3:{f=d*3|0;if((d|0)<=0)return;j=c+24|0;g=c+40|0;i=c+56|0;h=c+80|0;k=c+88|0;m=0;do{n=m+1|0;l=+p[g>>3]*+p[a+(n<<3)>>3]+ +p[i>>3];o=m+2|0;q=+p[h>>3]*+p[a+(o<<3)>>3]+ +p[k>>3];p[b+(m<<3)>>3]=+p[c>>3]*+p[a+(m<<3)>>3]+ +p[j>>3];p[b+(n<<3)>>3]=l;p[b+(o<<3)>>3]=q;m=m+3|0}while((m|0)<(f|0));return}case 4:{f=d<<2;if((d|0)<=0)return;m=c+32|0;j=c+48|0;k=c+72|0;h=c+96|0;i=c+112|0;g=c+144|0;o=c+152|0;n=0;do{r=n|1;q=+p[j>>3]*+p[a+(r<<3)>>3]+ +p[k>>3];p[b+(n<<3)>>3]=+p[c>>3]*+p[a+(n<<3)>>3]+ +p[m>>3];p[b+(r<<3)>>3]=q;r=n|2;s=n|3;q=+p[g>>3]*+p[a+(s<<3)>>3]+ +p[o>>3];p[b+(r<<3)>>3]=+p[h>>3]*+p[a+(r<<3)>>3]+ +p[i>>3];p[b+(s<<3)>>3]=q;n=n+4|0}while((n|0)<(f|0));return}default:{if((d|0)<=0)return;f=e+1|0;if((e|0)>0){t=a;u=b;v=0}else return;while(1){b=c;a=0;while(1){p[u+(a<<3)>>3]=+p[t+(a<<3)>>3]*+p[b+(a<<3)>>3]+ +p[b+(e<<3)>>3];a=a+1|0;if((a|0)==(e|0))break;else b=b+(f<<3)|0}v=v+1|0;if((v|0)==(d|0))break;else{t=t+(e<<3)|0;u=u+(e<<3)|0}}return}}}function LX(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0;if((f|0)==2&(g|0)==2){i=e<<1;if((e|0)<=0)return;j=d+4|0;k=d+8|0;l=d+12|0;m=d+16|0;o=d+20|0;p=0;do{q=+(h[a+p>>0]|0);r=p|1;s=+(h[a+r>>0]|0);t=LVb(+n[k>>2]+(q*+n[d>>2]+s*+n[j>>2]))|0;u=LVb(+n[o>>2]+(q*+n[l>>2]+s*+n[m>>2]))|0;b[c+p>>0]=t>>>0<256?t:(t|0)>0?255:0;b[c+r>>0]=u>>>0<256?u:(u|0)>0?255:0;p=p+2|0}while((p|0)<(i|0));return}i=(f|0)==3;if(i&(g|0)==3){p=e*3|0;if((e|0)<=0)return;m=d+4|0;l=d+8|0;o=d+12|0;j=d+16|0;k=d+20|0;u=d+24|0;r=d+28|0;t=d+32|0;v=d+36|0;w=d+40|0;x=d+44|0;y=0;do{s=+(h[a+y>>0]|0);z=y+1|0;q=+(h[a+z>>0]|0);A=y+2|0;B=+(h[a+A>>0]|0);C=LVb(+n[o>>2]+(s*+n[d>>2]+q*+n[m>>2]+B*+n[l>>2]))|0;D=LVb(+n[r>>2]+(s*+n[j>>2]+q*+n[k>>2]+B*+n[u>>2]))|0;E=LVb(+n[x>>2]+(s*+n[t>>2]+q*+n[v>>2]+B*+n[w>>2]))|0;b[c+y>>0]=C>>>0<256?C:(C|0)>0?255:0;b[c+z>>0]=D>>>0<256?D:(D|0)>0?255:0;b[c+A>>0]=E>>>0<256?E:(E|0)>0?255:0;y=y+3|0}while((y|0)<(p|0));return}if(i&(g|0)==1){if((e|0)<=0)return;i=d+4|0;p=d+8|0;y=d+12|0;w=a;v=0;while(1){t=LVb(+n[y>>2]+(+n[d>>2]*+(h[w>>0]|0)+ +n[i>>2]*+(h[w+1>>0]|0)+ +n[p>>2]*+(h[w+2>>0]|0)))|0;b[c+v>>0]=t>>>0<256?t:(t|0)>0?255:0;v=v+1|0;if((v|0)==(e|0))break;else w=w+3|0}return}if((f|0)==4&(g|0)==4){w=e<<2;if((e|0)<=0)return;v=d+4|0;p=d+8|0;i=d+12|0;y=d+16|0;t=d+20|0;x=d+24|0;u=d+28|0;k=d+32|0;j=d+36|0;r=d+40|0;l=d+44|0;m=d+48|0;o=d+52|0;E=d+56|0;A=d+60|0;D=d+64|0;z=d+68|0;C=d+72|0;F=d+76|0;G=0;do{B=+(h[a+G>>0]|0);H=G|1;q=+(h[a+H>>0]|0);I=G|2;s=+(h[a+I>>0]|0);J=G|3;K=+(h[a+J>>0]|0);L=LVb(+n[y>>2]+(B*+n[d>>2]+q*+n[v>>2]+s*+n[p>>2]+K*+n[i>>2]))|0;M=LVb(+n[j>>2]+(B*+n[t>>2]+q*+n[x>>2]+s*+n[u>>2]+K*+n[k>>2]))|0;b[c+G>>0]=L>>>0<256?L:(L|0)>0?255:0;b[c+H>>0]=M>>>0<256?M:(M|0)>0?255:0;M=LVb(+n[E>>2]+(B*+n[r>>2]+q*+n[l>>2]+s*+n[m>>2]+K*+n[o>>2]))|0;H=LVb(+n[F>>2]+(B*+n[A>>2]+q*+n[D>>2]+s*+n[z>>2]+K*+n[C>>2]))|0;b[c+I>>0]=M>>>0<256?M:(M|0)>0?255:0;b[c+J>>0]=H>>>0<256?H:(H|0)>0?255:0;G=G+4|0}while((G|0)<(w|0));return}if((e|0)<=0)return;w=f+1|0;if((g|0)<=0)return;if((f|0)>0){N=c;O=a;P=0}else{a=c;c=0;while(1){G=0;C=d;while(1){z=LVb(+n[C+(f<<2)>>2])|0;b[a+G>>0]=z>>>0<256?z:(z|0)>0?255:0;G=G+1|0;if((G|0)==(g|0))break;else C=C+(w<<2)|0}c=c+1|0;if((c|0)==(e|0))break;else a=a+g|0}return}while(1){a=0;c=d;while(1){C=0;K=+n[c+(f<<2)>>2];do{K=K+ +n[c+(C<<2)>>2]*+(h[O+C>>0]|0);C=C+1|0}while((C|0)!=(f|0));C=LVb(K)|0;b[N+a>>0]=C>>>0<256?C:(C|0)>0?255:0;a=a+1|0;if((a|0)==(g|0))break;else c=c+(w<<2)|0}P=P+1|0;if((P|0)==(e|0))break;else{N=N+g|0;O=O+f|0}}return}function MX(a,c,d,e,f,g){a=a|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0;if((f|0)==2&(g|0)==2){h=e<<1;if((e|0)<=0)return;i=d+4|0;j=d+8|0;k=d+12|0;l=d+16|0;m=d+20|0;o=0;do{p=+(b[a+o>>0]|0);q=o|1;r=+(b[a+q>>0]|0);s=LVb(+n[j>>2]+(p*+n[d>>2]+r*+n[i>>2]))|0;t=LVb(+n[m>>2]+(p*+n[k>>2]+r*+n[l>>2]))|0;b[c+o>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;b[c+q>>0]=(t+128|0)>>>0<256?t:(t|0)>0?127:128;o=o+2|0}while((o|0)<(h|0));return}h=(f|0)==3;if(h&(g|0)==3){o=e*3|0;if((e|0)<=0)return;l=d+4|0;k=d+8|0;m=d+12|0;i=d+16|0;j=d+20|0;t=d+24|0;q=d+28|0;s=d+32|0;u=d+36|0;v=d+40|0;w=d+44|0;x=0;do{r=+(b[a+x>>0]|0);y=x+1|0;p=+(b[a+y>>0]|0);z=x+2|0;A=+(b[a+z>>0]|0);B=LVb(+n[m>>2]+(r*+n[d>>2]+p*+n[l>>2]+A*+n[k>>2]))|0;C=LVb(+n[q>>2]+(r*+n[i>>2]+p*+n[j>>2]+A*+n[t>>2]))|0;D=LVb(+n[w>>2]+(r*+n[s>>2]+p*+n[u>>2]+A*+n[v>>2]))|0;b[c+x>>0]=(B+128|0)>>>0<256?B:(B|0)>0?127:128;b[c+y>>0]=(C+128|0)>>>0<256?C:(C|0)>0?127:128;b[c+z>>0]=(D+128|0)>>>0<256?D:(D|0)>0?127:128;x=x+3|0}while((x|0)<(o|0));return}if(h&(g|0)==1){if((e|0)<=0)return;h=d+4|0;o=d+8|0;x=d+12|0;v=a;u=0;while(1){s=LVb(+n[x>>2]+(+n[d>>2]*+(b[v>>0]|0)+ +n[h>>2]*+(b[v+1>>0]|0)+ +n[o>>2]*+(b[v+2>>0]|0)))|0;b[c+u>>0]=(s+128|0)>>>0<256?s:(s|0)>0?127:128;u=u+1|0;if((u|0)==(e|0))break;else v=v+3|0}return}if((f|0)==4&(g|0)==4){v=e<<2;if((e|0)<=0)return;u=d+4|0;o=d+8|0;h=d+12|0;x=d+16|0;s=d+20|0;w=d+24|0;t=d+28|0;j=d+32|0;i=d+36|0;q=d+40|0;k=d+44|0;l=d+48|0;m=d+52|0;D=d+56|0;z=d+60|0;C=d+64|0;y=d+68|0;B=d+72|0;E=d+76|0;F=0;do{A=+(b[a+F>>0]|0);G=F|1;p=+(b[a+G>>0]|0);H=F|2;r=+(b[a+H>>0]|0);I=F|3;J=+(b[a+I>>0]|0);K=LVb(+n[x>>2]+(A*+n[d>>2]+p*+n[u>>2]+r*+n[o>>2]+J*+n[h>>2]))|0;L=LVb(+n[i>>2]+(A*+n[s>>2]+p*+n[w>>2]+r*+n[t>>2]+J*+n[j>>2]))|0;b[c+F>>0]=(K+128|0)>>>0<256?K:(K|0)>0?127:128;b[c+G>>0]=(L+128|0)>>>0<256?L:(L|0)>0?127:128;L=LVb(+n[D>>2]+(A*+n[q>>2]+p*+n[k>>2]+r*+n[l>>2]+J*+n[m>>2]))|0;G=LVb(+n[E>>2]+(A*+n[z>>2]+p*+n[C>>2]+r*+n[y>>2]+J*+n[B>>2]))|0;b[c+H>>0]=(L+128|0)>>>0<256?L:(L|0)>0?127:128;b[c+I>>0]=(G+128|0)>>>0<256?G:(G|0)>0?127:128;F=F+4|0}while((F|0)<(v|0));return}if((e|0)<=0)return;v=f+1|0;if((g|0)<=0)return;if((f|0)>0){M=c;N=a;O=0}else{a=c;c=0;while(1){F=0;B=d;while(1){y=LVb(+n[B+(f<<2)>>2])|0;b[a+F>>0]=(y+128|0)>>>0<256?y:(y|0)>0?127:128;F=F+1|0;if((F|0)==(g|0))break;else B=B+(v<<2)|0}c=c+1|0;if((c|0)==(e|0))break;else a=a+g|0}return}while(1){a=0;c=d;while(1){B=0;J=+n[c+(f<<2)>>2];do{J=J+ +n[c+(B<<2)>>2]*+(b[N+B>>0]|0);B=B+1|0}while((B|0)!=(f|0));B=LVb(J)|0;b[M+a>>0]=(B+128|0)>>>0<256?B:(B|0)>0?127:128;a=a+1|0;if((a|0)==(g|0))break;else c=c+(v<<2)|0}O=O+1|0;if((O|0)==(e|0))break;else{M=M+g|0;N=N+f|0}}return}function NX(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0;if((f|0)==2&(g|0)==2){h=e<<1;if((e|0)<=0)return;i=+n[c>>2];k=+n[c+4>>2];l=+n[c+8>>2];m=+n[c+12>>2];o=+n[c+16>>2];p=+n[c+20>>2];q=0;do{r=+(j[a+(q<<1)>>1]|0);s=q|1;t=+(j[a+(s<<1)>>1]|0);u=LVb(l+(i*r+k*t))|0;v=LVb(p+(m*r+o*t))|0;d[b+(q<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[b+(s<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;q=q+2|0}while((q|0)<(h|0));return}h=(f|0)==3;if(h&(g|0)==3){q=e*3|0;if((e|0)<=0)return;o=+n[c>>2];m=+n[c+4>>2];p=+n[c+8>>2];k=+n[c+12>>2];i=+n[c+16>>2];l=+n[c+20>>2];t=+n[c+24>>2];r=+n[c+28>>2];w=+n[c+32>>2];x=+n[c+36>>2];y=+n[c+40>>2];z=+n[c+44>>2];v=0;do{A=+(j[a+(v<<1)>>1]|0);s=v+1|0;B=+(j[a+(s<<1)>>1]|0);u=v+2|0;C=+(j[a+(u<<1)>>1]|0);D=LVb(k+(o*A+m*B+p*C))|0;E=LVb(r+(i*A+l*B+t*C))|0;F=LVb(z+(w*A+x*B+y*C))|0;d[b+(v<<1)>>1]=D>>>0<65536?D:(D|0)>0?65535:0;d[b+(s<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;d[b+(u<<1)>>1]=F>>>0<65536?F:(F|0)>0?65535:0;v=v+3|0}while((v|0)<(q|0));return}if(h&(g|0)==1){if((e|0)<=0)return;y=+n[c>>2];x=+n[c+4>>2];w=+n[c+8>>2];z=+n[c+12>>2];h=a;q=0;while(1){v=LVb(z+(y*+(j[h>>1]|0)+x*+(j[h+2>>1]|0)+w*+(j[h+4>>1]|0)))|0;d[b+(q<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;q=q+1|0;if((q|0)==(e|0))break;else h=h+6|0}return}if((f|0)==4&(g|0)==4){h=e<<2;if((e|0)<=0)return;w=+n[c>>2];x=+n[c+4>>2];y=+n[c+8>>2];z=+n[c+12>>2];t=+n[c+16>>2];l=+n[c+20>>2];i=+n[c+24>>2];r=+n[c+28>>2];p=+n[c+32>>2];m=+n[c+36>>2];o=+n[c+40>>2];k=+n[c+44>>2];C=+n[c+48>>2];B=+n[c+52>>2];A=+n[c+56>>2];G=+n[c+60>>2];H=+n[c+64>>2];I=+n[c+68>>2];J=+n[c+72>>2];K=+n[c+76>>2];q=0;do{L=+(j[a+(q<<1)>>1]|0);v=q|1;M=+(j[a+(v<<1)>>1]|0);F=q|2;N=+(j[a+(F<<1)>>1]|0);u=q|3;O=+(j[a+(u<<1)>>1]|0);E=LVb(t+(w*L+x*M+y*N+z*O))|0;s=LVb(m+(l*L+i*M+r*N+p*O))|0;d[b+(q<<1)>>1]=E>>>0<65536?E:(E|0)>0?65535:0;d[b+(v<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;s=LVb(A+(o*L+k*M+C*N+B*O))|0;v=LVb(K+(G*L+H*M+I*N+J*O))|0;d[b+(F<<1)>>1]=s>>>0<65536?s:(s|0)>0?65535:0;d[b+(u<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;q=q+4|0}while((q|0)<(h|0));return}if((e|0)<=0)return;h=f+1|0;if((g|0)<=0)return;if((f|0)>0){P=b;Q=a;R=0}else{a=b;b=0;while(1){q=0;v=c;while(1){u=LVb(+n[v+(f<<2)>>2])|0;d[a+(q<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;q=q+1|0;if((q|0)==(g|0))break;else v=v+(h<<2)|0}b=b+1|0;if((b|0)==(e|0))break;else a=a+(g<<1)|0}return}while(1){a=0;b=c;while(1){v=0;J=+n[b+(f<<2)>>2];do{J=J+ +n[b+(v<<2)>>2]*+(j[Q+(v<<1)>>1]|0);v=v+1|0}while((v|0)!=(f|0));v=LVb(J)|0;d[P+(a<<1)>>1]=v>>>0<65536?v:(v|0)>0?65535:0;a=a+1|0;if((a|0)==(g|0))break;else b=b+(h<<2)|0}R=R+1|0;if((R|0)==(e|0))break;else{P=P+(g<<1)|0;Q=Q+(f<<1)|0}}return}function OX(a,b,c,e,f,g){a=a|0;b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0;if((f|0)==2&(g|0)==2){h=e<<1;if((e|0)<=0)return;i=+n[c>>2];j=+n[c+4>>2];k=+n[c+8>>2];l=+n[c+12>>2];m=+n[c+16>>2];o=+n[c+20>>2];p=0;do{q=+(d[a+(p<<1)>>1]|0);r=p|1;s=+(d[a+(r<<1)>>1]|0);t=LVb(k+(i*q+j*s))|0;u=LVb(o+(l*q+m*s))|0;d[b+(p<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;d[b+(r<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;p=p+2|0}while((p|0)<(h|0));return}h=(f|0)==3;if(h&(g|0)==3){p=e*3|0;if((e|0)<=0)return;m=+n[c>>2];l=+n[c+4>>2];o=+n[c+8>>2];j=+n[c+12>>2];i=+n[c+16>>2];k=+n[c+20>>2];s=+n[c+24>>2];q=+n[c+28>>2];v=+n[c+32>>2];w=+n[c+36>>2];x=+n[c+40>>2];y=+n[c+44>>2];u=0;do{z=+(d[a+(u<<1)>>1]|0);r=u+1|0;A=+(d[a+(r<<1)>>1]|0);t=u+2|0;B=+(d[a+(t<<1)>>1]|0);C=LVb(j+(m*z+l*A+o*B))|0;D=LVb(q+(i*z+k*A+s*B))|0;E=LVb(y+(v*z+w*A+x*B))|0;d[b+(u<<1)>>1]=(C+32768|0)>>>0<65536?C:(C|0)>0?32767:32768;d[b+(r<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;d[b+(t<<1)>>1]=(E+32768|0)>>>0<65536?E:(E|0)>0?32767:32768;u=u+3|0}while((u|0)<(p|0));return}if(h&(g|0)==1){if((e|0)<=0)return;x=+n[c>>2];w=+n[c+4>>2];v=+n[c+8>>2];y=+n[c+12>>2];h=a;p=0;while(1){u=LVb(y+(x*+(d[h>>1]|0)+w*+(d[h+2>>1]|0)+v*+(d[h+4>>1]|0)))|0;d[b+(p<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;p=p+1|0;if((p|0)==(e|0))break;else h=h+6|0}return}if((f|0)==4&(g|0)==4){h=e<<2;if((e|0)<=0)return;v=+n[c>>2];w=+n[c+4>>2];x=+n[c+8>>2];y=+n[c+12>>2];s=+n[c+16>>2];k=+n[c+20>>2];i=+n[c+24>>2];q=+n[c+28>>2];o=+n[c+32>>2];l=+n[c+36>>2];m=+n[c+40>>2];j=+n[c+44>>2];B=+n[c+48>>2];A=+n[c+52>>2];z=+n[c+56>>2];F=+n[c+60>>2];G=+n[c+64>>2];H=+n[c+68>>2];I=+n[c+72>>2];J=+n[c+76>>2];p=0;do{K=+(d[a+(p<<1)>>1]|0);u=p|1;L=+(d[a+(u<<1)>>1]|0);E=p|2;M=+(d[a+(E<<1)>>1]|0);t=p|3;N=+(d[a+(t<<1)>>1]|0);D=LVb(s+(v*K+w*L+x*M+y*N))|0;r=LVb(l+(k*K+i*L+q*M+o*N))|0;d[b+(p<<1)>>1]=(D+32768|0)>>>0<65536?D:(D|0)>0?32767:32768;d[b+(u<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;r=LVb(z+(m*K+j*L+B*M+A*N))|0;u=LVb(J+(F*K+G*L+H*M+I*N))|0;d[b+(E<<1)>>1]=(r+32768|0)>>>0<65536?r:(r|0)>0?32767:32768;d[b+(t<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;p=p+4|0}while((p|0)<(h|0));return}if((e|0)<=0)return;h=f+1|0;if((g|0)<=0)return;if((f|0)>0){O=b;P=a;Q=0}else{a=b;b=0;while(1){p=0;u=c;while(1){t=LVb(+n[u+(f<<2)>>2])|0;d[a+(p<<1)>>1]=(t+32768|0)>>>0<65536?t:(t|0)>0?32767:32768;p=p+1|0;if((p|0)==(g|0))break;else u=u+(h<<2)|0}b=b+1|0;if((b|0)==(e|0))break;else a=a+(g<<1)|0}return}while(1){a=0;b=c;while(1){u=0;I=+n[b+(f<<2)>>2];do{I=I+ +n[b+(u<<2)>>2]*+(d[P+(u<<1)>>1]|0);u=u+1|0}while((u|0)!=(f|0));u=LVb(I)|0;d[O+(a<<1)>>1]=(u+32768|0)>>>0<65536?u:(u|0)>0?32767:32768;a=a+1|0;if((a|0)==(g|0))break;else b=b+(h<<2)|0}Q=Q+1|0;if((Q|0)==(e|0))break;else{O=O+(g<<1)|0;P=P+(f<<1)|0}}return}function PX(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0;if((e|0)==2&(g|0)==2){h=d<<1;if((d|0)<=0)return;i=+p[c>>3];j=+p[c+8>>3];k=+p[c+16>>3];l=+p[c+24>>3];m=+p[c+32>>3];n=+p[c+40>>3];o=0;do{q=+(f[a+(o<<2)>>2]|0);r=o|1;s=+(f[a+(r<<2)>>2]|0);t=MVb(k+(i*q+j*s))|0;u=MVb(n+(l*q+m*s))|0;f[b+(o<<2)>>2]=t;f[b+(r<<2)>>2]=u;o=o+2|0}while((o|0)<(h|0));return}h=(e|0)==3;if(h&(g|0)==3){o=d*3|0;if((d|0)<=0)return;m=+p[c>>3];l=+p[c+8>>3];n=+p[c+16>>3];j=+p[c+24>>3];i=+p[c+32>>3];k=+p[c+40>>3];s=+p[c+48>>3];q=+p[c+56>>3];v=+p[c+64>>3];w=+p[c+72>>3];x=+p[c+80>>3];y=+p[c+88>>3];u=0;do{z=+(f[a+(u<<2)>>2]|0);r=u+1|0;A=+(f[a+(r<<2)>>2]|0);t=u+2|0;B=+(f[a+(t<<2)>>2]|0);C=MVb(j+(m*z+l*A+n*B))|0;D=MVb(q+(i*z+k*A+s*B))|0;E=MVb(y+(v*z+w*A+x*B))|0;f[b+(u<<2)>>2]=C;f[b+(r<<2)>>2]=D;f[b+(t<<2)>>2]=E;u=u+3|0}while((u|0)<(o|0));return}if(h&(g|0)==1){if((d|0)<=0)return;x=+p[c>>3];w=+p[c+8>>3];v=+p[c+16>>3];y=+p[c+24>>3];h=a;o=0;while(1){u=MVb(y+(x*+(f[h>>2]|0)+w*+(f[h+4>>2]|0)+v*+(f[h+8>>2]|0)))|0;f[b+(o<<2)>>2]=u;o=o+1|0;if((o|0)==(d|0))break;else h=h+12|0}return}if((e|0)==4&(g|0)==4){h=d<<2;if((d|0)<=0)return;v=+p[c>>3];w=+p[c+8>>3];x=+p[c+16>>3];y=+p[c+24>>3];s=+p[c+32>>3];k=+p[c+40>>3];i=+p[c+48>>3];q=+p[c+56>>3];n=+p[c+64>>3];l=+p[c+72>>3];m=+p[c+80>>3];j=+p[c+88>>3];B=+p[c+96>>3];A=+p[c+104>>3];z=+p[c+112>>3];F=+p[c+120>>3];G=+p[c+128>>3];H=+p[c+136>>3];I=+p[c+144>>3];J=+p[c+152>>3];o=0;do{K=+(f[a+(o<<2)>>2]|0);u=o|1;L=+(f[a+(u<<2)>>2]|0);E=o|2;M=+(f[a+(E<<2)>>2]|0);t=o|3;N=+(f[a+(t<<2)>>2]|0);D=MVb(s+(v*K+w*L+x*M+y*N))|0;r=MVb(l+(k*K+i*L+q*M+n*N))|0;f[b+(o<<2)>>2]=D;f[b+(u<<2)>>2]=r;r=MVb(z+(m*K+j*L+B*M+A*N))|0;u=MVb(J+(F*K+G*L+H*M+I*N))|0;f[b+(E<<2)>>2]=r;f[b+(t<<2)>>2]=u;o=o+4|0}while((o|0)<(h|0));return}if((d|0)<=0)return;h=e+1|0;if((g|0)<=0)return;if((e|0)>0){O=b;P=a;Q=0}else{a=b;b=0;while(1){o=0;u=c;while(1){t=MVb(+p[u+(e<<3)>>3])|0;f[a+(o<<2)>>2]=t;o=o+1|0;if((o|0)==(g|0))break;else u=u+(h<<3)|0}b=b+1|0;if((b|0)==(d|0))break;else a=a+(g<<2)|0}return}while(1){a=0;b=c;while(1){u=0;I=+p[b+(e<<3)>>3];do{I=I+ +p[b+(u<<3)>>3]*+(f[P+(u<<2)>>2]|0);u=u+1|0}while((u|0)!=(e|0));u=MVb(I)|0;f[O+(a<<2)>>2]=u;a=a+1|0;if((a|0)==(g|0))break;else b=b+(h<<3)|0}Q=Q+1|0;if((Q|0)==(d|0))break;else{O=O+(g<<2)|0;P=P+(e<<2)|0}}return}function QX(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;if((e|0)==2&(g|0)==2){h=d<<1;if((d|0)<=0)return;i=c+4|0;j=c+8|0;k=c+12|0;l=c+16|0;m=c+20|0;o=0;do{p=+n[a+(o<<2)>>2];q=o|1;r=+n[a+(q<<2)>>2];s=+n[m>>2]+(p*+n[k>>2]+r*+n[l>>2]);n[b+(o<<2)>>2]=+n[j>>2]+(p*+n[c>>2]+r*+n[i>>2]);n[b+(q<<2)>>2]=s;o=o+2|0}while((o|0)<(h|0));return}h=(e|0)==3;if(h&(g|0)==3){o=d*3|0;if((d|0)<=0)return;i=c+4|0;j=c+8|0;l=c+12|0;k=c+16|0;m=c+20|0;q=c+24|0;t=c+28|0;u=c+32|0;v=c+36|0;w=c+40|0;x=c+44|0;y=0;do{s=+n[a+(y<<2)>>2];z=y+1|0;r=+n[a+(z<<2)>>2];A=y+2|0;p=+n[a+(A<<2)>>2];B=+n[t>>2]+(s*+n[k>>2]+r*+n[m>>2]+p*+n[q>>2]);C=+n[x>>2]+(s*+n[u>>2]+r*+n[v>>2]+p*+n[w>>2]);n[b+(y<<2)>>2]=+n[l>>2]+(s*+n[c>>2]+r*+n[i>>2]+p*+n[j>>2]);n[b+(z<<2)>>2]=B;n[b+(A<<2)>>2]=C;y=y+3|0}while((y|0)<(o|0));return}if(h&(g|0)==1){if((d|0)<=0)return;h=c+4|0;o=c+8|0;y=c+12|0;j=a;i=0;while(1){n[b+(i<<2)>>2]=+n[y>>2]+(+n[c>>2]*+n[j>>2]+ +n[h>>2]*+n[j+4>>2]+ +n[o>>2]*+n[j+8>>2]);i=i+1|0;if((i|0)==(d|0))break;else j=j+12|0}return}if((e|0)==4&(g|0)==4){j=d<<2;if((d|0)<=0)return;i=c+4|0;o=c+8|0;h=c+12|0;y=c+16|0;l=c+20|0;w=c+24|0;v=c+28|0;u=c+32|0;x=c+36|0;q=c+40|0;m=c+44|0;k=c+48|0;t=c+52|0;A=c+56|0;z=c+60|0;D=c+64|0;E=c+68|0;F=c+72|0;G=c+76|0;H=0;do{C=+n[a+(H<<2)>>2];I=H|1;B=+n[a+(I<<2)>>2];J=H|2;p=+n[a+(J<<2)>>2];K=H|3;r=+n[a+(K<<2)>>2];s=+n[x>>2]+(C*+n[l>>2]+B*+n[w>>2]+p*+n[v>>2]+r*+n[u>>2]);n[b+(H<<2)>>2]=+n[y>>2]+(C*+n[c>>2]+B*+n[i>>2]+p*+n[o>>2]+r*+n[h>>2]);n[b+(I<<2)>>2]=s;s=+n[G>>2]+(C*+n[z>>2]+B*+n[D>>2]+p*+n[E>>2]+r*+n[F>>2]);n[b+(J<<2)>>2]=+n[A>>2]+(C*+n[q>>2]+B*+n[m>>2]+p*+n[k>>2]+r*+n[t>>2]);n[b+(K<<2)>>2]=s;H=H+4|0}while((H|0)<(j|0));return}if((d|0)<=0)return;j=e+1|0;if((g|0)<=0)return;if((e|0)>0){L=b;M=a;N=0}else{a=b;b=0;while(1){H=0;t=c;while(1){f[a+(H<<2)>>2]=f[t+(e<<2)>>2];H=H+1|0;if((H|0)==(g|0))break;else t=t+(j<<2)|0}b=b+1|0;if((b|0)==(d|0))break;else a=a+(g<<2)|0}return}while(1){a=0;b=c;while(1){t=0;s=+n[b+(e<<2)>>2];do{s=s+ +n[b+(t<<2)>>2]*+n[M+(t<<2)>>2];t=t+1|0}while((t|0)!=(e|0));n[L+(a<<2)>>2]=s;a=a+1|0;if((a|0)==(g|0))break;else b=b+(j<<2)|0}N=N+1|0;if((N|0)==(d|0))break;else{L=L+(g<<2)|0;M=M+(e<<2)|0}}return}function RX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0.0,o=0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;if((e|0)==2&(f|0)==2){g=d<<1;if((d|0)<=0)return;h=c+8|0;i=c+16|0;j=c+24|0;k=c+32|0;l=c+40|0;m=0;do{n=+p[a+(m<<3)>>3];o=m|1;q=+p[a+(o<<3)>>3];r=+p[l>>3]+(n*+p[j>>3]+q*+p[k>>3]);p[b+(m<<3)>>3]=+p[i>>3]+(n*+p[c>>3]+q*+p[h>>3]);p[b+(o<<3)>>3]=r;m=m+2|0}while((m|0)<(g|0));return}g=(e|0)==3;if(g&(f|0)==3){m=d*3|0;if((d|0)<=0)return;h=c+8|0;i=c+16|0;k=c+24|0;j=c+32|0;l=c+40|0;o=c+48|0;s=c+56|0;t=c+64|0;u=c+72|0;v=c+80|0;w=c+88|0;x=0;do{r=+p[a+(x<<3)>>3];y=x+1|0;q=+p[a+(y<<3)>>3];z=x+2|0;n=+p[a+(z<<3)>>3];A=+p[s>>3]+(r*+p[j>>3]+q*+p[l>>3]+n*+p[o>>3]);B=+p[w>>3]+(r*+p[t>>3]+q*+p[u>>3]+n*+p[v>>3]);p[b+(x<<3)>>3]=+p[k>>3]+(r*+p[c>>3]+q*+p[h>>3]+n*+p[i>>3]);p[b+(y<<3)>>3]=A;p[b+(z<<3)>>3]=B;x=x+3|0}while((x|0)<(m|0));return}if(g&(f|0)==1){if((d|0)<=0)return;g=c+8|0;m=c+16|0;x=c+24|0;i=a;h=0;while(1){p[b+(h<<3)>>3]=+p[x>>3]+(+p[c>>3]*+p[i>>3]+ +p[g>>3]*+p[i+8>>3]+ +p[m>>3]*+p[i+16>>3]);h=h+1|0;if((h|0)==(d|0))break;else i=i+24|0}return}if((e|0)==4&(f|0)==4){i=d<<2;if((d|0)<=0)return;h=c+8|0;m=c+16|0;g=c+24|0;x=c+32|0;k=c+40|0;v=c+48|0;u=c+56|0;t=c+64|0;w=c+72|0;o=c+80|0;l=c+88|0;j=c+96|0;s=c+104|0;z=c+112|0;y=c+120|0;C=c+128|0;D=c+136|0;E=c+144|0;F=c+152|0;G=0;do{B=+p[a+(G<<3)>>3];H=G|1;A=+p[a+(H<<3)>>3];I=G|2;n=+p[a+(I<<3)>>3];J=G|3;q=+p[a+(J<<3)>>3];r=+p[w>>3]+(B*+p[k>>3]+A*+p[v>>3]+n*+p[u>>3]+q*+p[t>>3]);p[b+(G<<3)>>3]=+p[x>>3]+(B*+p[c>>3]+A*+p[h>>3]+n*+p[m>>3]+q*+p[g>>3]);p[b+(H<<3)>>3]=r;r=+p[F>>3]+(B*+p[y>>3]+A*+p[C>>3]+n*+p[D>>3]+q*+p[E>>3]);p[b+(I<<3)>>3]=+p[z>>3]+(B*+p[o>>3]+A*+p[l>>3]+n*+p[j>>3]+q*+p[s>>3]);p[b+(J<<3)>>3]=r;G=G+4|0}while((G|0)<(i|0));return}if((d|0)<=0)return;i=e+1|0;if((f|0)<=0)return;if((e|0)>0){K=b;L=a;M=0}else{a=b;b=0;while(1){G=0;s=c;while(1){p[a+(G<<3)>>3]=+p[s+(e<<3)>>3];G=G+1|0;if((G|0)==(f|0))break;else s=s+(i<<3)|0}b=b+1|0;if((b|0)==(d|0))break;else a=a+(f<<3)|0}return}while(1){a=0;b=c;while(1){s=0;r=+p[b+(e<<3)>>3];do{r=r+ +p[b+(s<<3)>>3]*+p[L+(s<<3)>>3];s=s+1|0}while((s|0)!=(e|0));p[K+(a<<3)>>3]=r;a=a+1|0;if((a|0)==(f|0))break;else b=b+(i<<3)|0}M=M+1|0;if((M|0)==(d|0))break;else{K=K+(f<<3)|0;L=L+(e<<3)|0}}return}function SX(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;e=u;u=u+1392|0;g=e+1368|0;h=e+1360|0;i=e+1304|0;j=e+1248|0;k=e+1240|0;l=e+1184|0;m=e;n=e+1128|0;o=e+1096|0;dQ(h,47344);do if((yM(a)|0)==65536){p=f[a+4>>2]|0;f[i>>2]=f[p>>2];q=i+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=i+8|0;f[s>>2]=f[p+8>>2];f[i+12>>2]=f[p+12>>2];f[i+16>>2]=f[p+16>>2];f[i+20>>2]=f[p+20>>2];f[i+24>>2]=f[p+24>>2];f[i+28>>2]=f[p+28>>2];f[i+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=s;s=i+48|0;v=i+44|0;f[v>>2]=s;f[s>>2]=0;f[i+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[v>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];break}else{f[q>>2]=0;jL(i,p);break}}else yL(i,a,-1);while(0);do if((yM(d)|0)==65536){a=f[d+4>>2]|0;f[j>>2]=f[a>>2];p=j+4|0;q=a+4|0;f[p>>2]=f[q>>2];r=j+8|0;f[r>>2]=f[a+8>>2];s=j+12|0;f[s>>2]=f[a+12>>2];f[j+16>>2]=f[a+16>>2];f[j+20>>2]=f[a+20>>2];f[j+24>>2]=f[a+24>>2];f[j+28>>2]=f[a+28>>2];f[j+32>>2]=f[a+32>>2];v=f[a+36>>2]|0;f[j+36>>2]=v;f[j+40>>2]=r;t=j+48|0;w=j+44|0;f[w>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[q>>2]|0)<3){q=f[a+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[q>>2];f[t+4>>2]=f[q+4>>2];x=r;y=s;break}else{f[p>>2]=0;jL(j,a);x=r;y=s;break}}else{yL(j,d,-1);x=j+8|0;y=j+12|0}while(0);d=f[i>>2]|0;s=d&7;r=d>>>3&511;d=r+1|0;a=f[x>>2]|0;p=a+-1|0;q=r+2|0;if((q|0)!=(f[y>>2]|0)){f[g>>2]=0;f[g+4>>2]=0;z=aD(g,17)|0;A=212943;B=z+17|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,g,212961,212249,2268);bD(g)}r=(s|0)==5;if((s+-5|0)>>>0>=2){f[g>>2]=0;f[g+4>>2]=0;z=aD(g,24)|0;A=212982;B=z+24|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,g,212961,212249,2269);bD(g)}t=i+40|0;w=f[t>>2]|0;v=f[w>>2]|0;f[k>>2]=f[w+4>>2];f[k+4>>2]=v;vM(c,k,(a<<3)+-16|s,-1,0,0);do if((yM(c)|0)==65536){s=f[c+4>>2]|0;f[l>>2]=f[s>>2];k=l+4|0;v=s+4|0;f[k>>2]=f[v>>2];w=l+8|0;f[w>>2]=f[s+8>>2];f[l+12>>2]=f[s+12>>2];f[l+16>>2]=f[s+16>>2];f[l+20>>2]=f[s+20>>2];f[l+24>>2]=f[s+24>>2];f[l+28>>2]=f[s+28>>2];f[l+32>>2]=f[s+32>>2];C=f[s+36>>2]|0;f[l+36>>2]=C;f[l+40>>2]=w;w=l+48|0;D=l+44|0;f[D>>2]=w;f[w>>2]=0;f[l+52>>2]=0;if(C|0){w=C+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[s+44>>2]|0;w=f[D>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];break}else{f[k>>2]=0;jL(l,s);break}}else yL(l,c,-1);while(0);c=m+8|0;f[m>>2]=c;s=m+4|0;f[s>>2]=136;if((f[j>>2]&20479|0)==16390)E=f[j+16>>2]|0;else{k=Y(q,a)|0;f[s>>2]=k;if(k>>>0>136){v=N5b(k>>>0>536870911?-1:k<<3)|0;f[m>>2]=v;F=v}else F=c;f[n>>2]=1124007942;v=n+4|0;f[v>>2]=2;w=n+8|0;f[w>>2]=a;a=n+12|0;f[a>>2]=q;D=n+16|0;f[D>>2]=F;C=n+20|0;f[C>>2]=F;G=n+24|0;H=n+28|0;I=n+40|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;f[I>>2]=w;J=n+48|0;K=n+44|0;f[K>>2]=J;f[n+52>>2]=0;f[J>>2]=0;if((k|0)!=0&(F|0)==0){f[g>>2]=0;f[g+4>>2]=0;z=aD(g,26)|0;A=426262;B=z+26|0;do{b[z>>0]=b[A>>0]|0;z=z+1|0;A=A+1|0}while((z|0)<(B|0));bO(-215,g,426289,431198,500);bD(g);L=f[a>>2]|0;M=f[n>>2]|0;N=f[K>>2]|0;O=f[C>>2]|0}else{L=q;M=1124007942;N=J;O=F}F=L<<3;f[n>>2]=M|16384;f[N>>2]=F;f[N+4>>2]=8;N=O+(Y(f[w>>2]|0,F)|0)|0;f[H>>2]=N;f[G>>2]=N+(0-F)+F;F=g+8|0;f[F>>2]=0;f[F+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=n;OJ(j,g,6,1.0,0.0);F=n+36|0;N=f[F>>2]|0;if(N|0){O=N+12|0;f[O>>2]=(f[O>>2]|0)+1}O=j+36|0;N=f[O>>2]|0;if(N|0?(M=N+12|0,N=f[M>>2]|0,f[M>>2]=N+-1,(N|0)==1):0)kL(j);f[O>>2]=0;N=j+16|0;M=j+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[M>>2]|0)>0){L=f[j+40>>2]|0;q=0;do{f[L+(q<<2)>>2]=0;q=q+1|0;P=f[M>>2]|0}while((q|0)<(P|0));f[j>>2]=f[n>>2];if((P|0)<3)Q=41;else Q=43}else{f[j>>2]=f[n>>2];Q=41}if((Q|0)==41){P=f[v>>2]|0;if((P|0)<3){f[M>>2]=P;f[x>>2]=f[w>>2];f[y>>2]=f[a>>2];a=f[K>>2]|0;y=f[j+44>>2]|0;f[y>>2]=f[a>>2];f[y+4>>2]=f[a+4>>2]}else Q=43}if((Q|0)==43)jL(j,n);f[N>>2]=f[D>>2];f[j+20>>2]=f[C>>2];f[j+24>>2]=f[G>>2];f[j+28>>2]=f[H>>2];f[j+32>>2]=f[n+32>>2];H=f[F>>2]|0;f[O>>2]=H;if(H|0?(O=H+12|0,H=f[O>>2]|0,f[O>>2]=H+-1,(H|0)==1):0)kL(n);f[F>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[v>>2]|0)>0){D=f[I>>2]|0;I=0;do{f[D+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[v>>2]|0))}v=f[K>>2]|0;if((v|0)!=(J|0))UC(v);E=c}v=r?126:125;f[g>>2]=i;f[g+4>>2]=l;f[g+8>>2]=0;RN(o,g,n,-1);g=f[o+20>>2]|0;r=o+16|0;J=n+4|0;K=0;while(1){if(K>>>0>=(f[r>>2]|0)>>>0)break;Wg[v&127](f[n>>2]|0,f[J>>2]|0,E,g,d,p);aL(o)|0;K=K+1|0}K=f[m>>2]|0;if((K|0)!=(c|0)){if(K|0)P5b(K);f[m>>2]=c;f[s>>2]=136}s=l+36|0;c=f[s>>2]|0;if(c|0?(m=c+12|0,c=f[m>>2]|0,f[m>>2]=c+-1,(c|0)==1):0)kL(l);f[s>>2]=0;s=l+16|0;c=l+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[c>>2]|0)>0){s=f[l+40>>2]|0;m=0;do{f[s+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[c>>2]|0))}c=f[l+44>>2]|0;if((c|0)!=(l+48|0))UC(c);c=j+36|0;l=f[c>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)kL(j);f[c>>2]=0;c=j+16|0;l=j+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[l>>2]|0)>0){c=f[j+40>>2]|0;m=0;do{f[c+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))UC(l);l=i+36|0;j=f[l>>2]|0;if(j|0?(m=j+12|0,j=f[m>>2]|0,f[m>>2]=j+-1,(j|0)==1):0)kL(i);f[l>>2]=0;l=i+16|0;j=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[j>>2]|0)>0){l=f[t>>2]|0;t=0;do{f[l+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)!=(i+48|0))UC(j);if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function TX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0.0,j=0.0,k=0.0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0;g=(f|0)==2;if((e|0)==2&g){h=d<<1;if((d|0)<=0)return;i=+p[c+48>>3];j=+p[c+56>>3];k=+p[c+64>>3];l=c+8|0;m=c+16|0;o=c+24|0;q=c+32|0;r=c+40|0;s=0;do{t=s|1;u=+n[a+(s<<2)>>2];v=+n[a+(t<<2)>>2];w=k+(i*u+j*v);if(+L(+w)>1.1920928955078125e-07){x=1.0/w;n[b+(s<<2)>>2]=x*(+p[m>>3]+(u*+p[c>>3]+v*+p[l>>3]));y=t;z=x*(+p[r>>3]+(u*+p[o>>3]+v*+p[q>>3]))}else{n[b+(t<<2)>>2]=0.0;y=s;z=0.0}n[b+(y<<2)>>2]=z;s=s+2|0}while((s|0)<(h|0));return}h=(e|0)==3;if(h&(f|0)==3){s=d*3|0;if((d|0)<=0)return;z=+p[c+96>>3];j=+p[c+104>>3];i=+p[c+112>>3];k=+p[c+120>>3];y=c+8|0;q=c+16|0;o=c+24|0;r=c+32|0;l=c+40|0;m=c+48|0;t=c+56|0;A=c+64|0;B=c+72|0;C=c+80|0;D=c+88|0;E=0;do{F=E+1|0;G=E+2|0;v=+n[a+(E<<2)>>2];u=+n[a+(F<<2)>>2];x=+n[a+(G<<2)>>2];w=k+(z*v+j*u+i*x);if(+L(+w)>1.1920928955078125e-07){H=1.0/w;n[b+(E<<2)>>2]=H*(+p[o>>3]+(v*+p[c>>3]+u*+p[y>>3]+x*+p[q>>3]));I=G;J=H*(+p[t>>3]+(v*+p[r>>3]+u*+p[l>>3]+x*+p[m>>3]));K=H*(+p[D>>3]+(v*+p[A>>3]+u*+p[B>>3]+x*+p[C>>3]))}else{n[b+(G<<2)>>2]=0.0;I=E;J=0.0;K=0.0}n[b+(F<<2)>>2]=J;n[b+(I<<2)>>2]=K;E=E+3|0}while((E|0)<(s|0));return}s=(d|0)>0;if(h&g){if(!s)return;K=+p[c+64>>3];J=+p[c+72>>3];i=+p[c+80>>3];j=+p[c+88>>3];g=c+8|0;h=c+16|0;E=c+24|0;I=c+32|0;C=c+40|0;B=c+48|0;A=c+56|0;D=a;m=b;l=0;while(1){z=+n[D>>2];k=+n[D+4>>2];x=+n[D+8>>2];u=j+(K*z+J*k+i*x);if(+L(+u)>1.1920928955078125e-07){v=1.0/u;n[m>>2]=v*(+p[E>>3]+(z*+p[c>>3]+k*+p[g>>3]+x*+p[h>>3]));M=m+4|0;N=v*(+p[A>>3]+(z*+p[I>>3]+k*+p[C>>3]+x*+p[B>>3]))}else{n[m+4>>2]=0.0;M=m;N=0.0}n[M>>2]=N;l=l+1|0;if((l|0)==(d|0))break;else{D=D+12|0;m=m+8|0}}return}if(!s)return;s=e+1|0;m=c+((Y(s,f)|0)<<3)|0;N=+p[m+(e<<3)>>3];D=(f|0)>0;l=f<<2;if((e|0)>0){if(D){O=a;P=b;Q=0}else return;while(1){a=b+((Y(Q,f)|0)<<2)|0;M=0;i=N;do{i=i+ +p[m+(M<<3)>>3]*+n[O+(M<<2)>>2];M=M+1|0}while((M|0)!=(e|0));if(+L(+i)>1.1920928955078125e-07){M=0;B=c;while(1){J=+p[B+(e<<3)>>3];C=0;do{J=J+ +p[B+(C<<3)>>3]*+n[O+(C<<2)>>2];C=C+1|0}while((C|0)!=(e|0));n[P+(M<<2)>>2]=i*J;M=M+1|0;if((M|0)==(f|0))break;else B=B+(s<<3)|0}}else Nac(a|0,0,l|0)|0;Q=Q+1|0;if((Q|0)==(d|0))break;else{O=O+(e<<2)|0;P=P+(f<<2)|0}}return}else{if(!(+L(+N)>1.1920928955078125e-07)){if(D)R=0;else return;do{Nac(b+((Y(R,f)|0)<<2)|0,0,l|0)|0;R=R+1|0}while((R|0)!=(d|0));return}if(D){S=b;T=0}else return;while(1){b=0;D=c;while(1){n[S+(b<<2)>>2]=N*+p[D+(e<<3)>>3];b=b+1|0;if((b|0)==(f|0))break;else D=D+(s<<3)|0}T=T+1|0;if((T|0)==(d|0))break;else S=S+(f<<2)|0}return}}function UX(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0.0,M=0,N=0,O=0,P=0,Q=0;g=(f|0)==2;if((e|0)==2&g){h=d<<1;if((d|0)<=0)return;i=c+48|0;j=c+56|0;k=c+64|0;l=c+8|0;m=c+16|0;n=c+24|0;o=c+32|0;q=c+40|0;r=0;do{s=+p[a+(r<<3)>>3];t=r|1;u=+p[a+(t<<3)>>3];v=+p[k>>3]+(s*+p[i>>3]+u*+p[j>>3]);if(+L(+v)>1.1920928955078125e-07){w=1.0/v;p[b+(r<<3)>>3]=w*(+p[m>>3]+(s*+p[c>>3]+u*+p[l>>3]));x=t;y=w*(+p[q>>3]+(s*+p[n>>3]+u*+p[o>>3]))}else{p[b+(t<<3)>>3]=0.0;x=r;y=0.0}p[b+(x<<3)>>3]=y;r=r+2|0}while((r|0)<(h|0));return}h=(e|0)==3;if(h&(f|0)==3){r=d*3|0;if((d|0)<=0)return;x=c+96|0;o=c+104|0;n=c+112|0;q=c+120|0;l=c+8|0;m=c+16|0;j=c+24|0;i=c+32|0;k=c+40|0;t=c+48|0;z=c+56|0;A=c+64|0;B=c+72|0;C=c+80|0;D=c+88|0;E=0;do{y=+p[a+(E<<3)>>3];F=E+1|0;u=+p[a+(F<<3)>>3];G=E+2|0;s=+p[a+(G<<3)>>3];w=+p[q>>3]+(y*+p[x>>3]+u*+p[o>>3]+s*+p[n>>3]);if(+L(+w)>1.1920928955078125e-07){v=1.0/w;p[b+(E<<3)>>3]=v*(+p[j>>3]+(y*+p[c>>3]+u*+p[l>>3]+s*+p[m>>3]));p[b+(F<<3)>>3]=v*(+p[z>>3]+(y*+p[i>>3]+u*+p[k>>3]+s*+p[t>>3]));H=G;I=v*(+p[D>>3]+(y*+p[A>>3]+u*+p[B>>3]+s*+p[C>>3]))}else{p[b+(G<<3)>>3]=0.0;p[b+(F<<3)>>3]=0.0;H=E;I=0.0}p[b+(H<<3)>>3]=I;E=E+3|0}while((E|0)<(r|0));return}r=(d|0)>0;if(h&g){if(!r)return;g=c+64|0;h=c+72|0;E=c+80|0;H=c+88|0;C=c+8|0;B=c+16|0;A=c+24|0;D=c+32|0;t=c+40|0;k=c+48|0;i=c+56|0;z=a;m=b;l=0;while(1){I=+p[z>>3];s=+p[z+8>>3];u=+p[z+16>>3];y=+p[H>>3]+(I*+p[g>>3]+s*+p[h>>3]+u*+p[E>>3]);if(+L(+y)>1.1920928955078125e-07){v=1.0/y;p[m>>3]=v*(+p[A>>3]+(I*+p[c>>3]+s*+p[C>>3]+u*+p[B>>3]));J=m+8|0;K=v*(+p[i>>3]+(I*+p[D>>3]+s*+p[t>>3]+u*+p[k>>3]))}else{p[m+8>>3]=0.0;J=m;K=0.0}p[J>>3]=K;l=l+1|0;if((l|0)==(d|0))break;else{z=z+24|0;m=m+16|0}}return}if(!r)return;r=e+1|0;m=c+((Y(r,f)|0)<<3)|0;z=m+(e<<3)|0;l=(f|0)>0;J=f<<3;if((e|0)<=0){if(l){M=b;N=0}else return;while(1){K=+p[z>>3];if(+L(+K)>1.1920928955078125e-07){k=0;t=c;while(1){p[M+(k<<3)>>3]=K*+p[t+(e<<3)>>3];k=k+1|0;if((k|0)==(f|0))break;else t=t+(r<<3)|0}}else Nac(b+((Y(N,f)|0)<<3)|0,0,J|0)|0;N=N+1|0;if((N|0)==(d|0))break;else M=M+(f<<3)|0}return}if(l){O=a;P=b;Q=0}else return;while(1){a=b+((Y(Q,f)|0)<<3)|0;l=0;K=+p[z>>3];do{K=K+ +p[m+(l<<3)>>3]*+p[O+(l<<3)>>3];l=l+1|0}while((l|0)!=(e|0));if(+L(+K)>1.1920928955078125e-07){l=0;M=c;while(1){u=+p[M+(e<<3)>>3];N=0;do{u=u+ +p[M+(N<<3)>>3]*+p[O+(N<<3)>>3];N=N+1|0}while((N|0)!=(e|0));p[P+(l<<3)>>3]=K*u;l=l+1|0;if((l|0)==(f|0))break;else M=M+(r<<3)|0}}else Nac(a|0,0,J|0)|0;Q=Q+1|0;if((Q|0)==(d|0))break;else{O=O+(e<<3)|0;P=P+(f<<3)|0}}return}function VX(a,c,d,e){a=a|0;c=+c;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;g=u;u=u+256|0;h=g;i=g+248|0;j=g+192|0;k=g+136|0;l=g+80|0;m=g+72|0;o=g+56|0;q=g+40|0;r=g+8|0;p[h>>3]=c;dQ(i,47364);s=BL(a,-1)|0;t=s&7;v=(s>>>3&511)+1|0;if((s|0)!=(BL(d,-1)|0)){f[j>>2]=0;f[j+4>>2]=0;w=aD(j,20)|0;x=213074;y=w+20|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,j,213095,212249,2415);bD(j)}if(t>>>0>=5){do if((yM(a)|0)==65536){z=f[a+4>>2]|0;f[j>>2]=f[z>>2];A=j+4|0;B=z+4|0;f[A>>2]=f[B>>2];C=j+8|0;f[C>>2]=f[z+8>>2];f[j+12>>2]=f[z+12>>2];f[j+16>>2]=f[z+16>>2];f[j+20>>2]=f[z+20>>2];f[j+24>>2]=f[z+24>>2];f[j+28>>2]=f[z+28>>2];f[j+32>>2]=f[z+32>>2];D=f[z+36>>2]|0;f[j+36>>2]=D;f[j+40>>2]=C;C=j+48|0;E=j+44|0;f[E>>2]=C;f[C>>2]=0;f[j+52>>2]=0;if(D|0){C=D+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[z+44>>2]|0;C=f[E>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];break}else{f[A>>2]=0;jL(j,z);break}}else yL(j,a,-1);while(0);do if((yM(d)|0)==65536){z=f[d+4>>2]|0;f[k>>2]=f[z>>2];A=k+4|0;B=z+4|0;f[A>>2]=f[B>>2];C=k+8|0;f[C>>2]=f[z+8>>2];f[k+12>>2]=f[z+12>>2];f[k+16>>2]=f[z+16>>2];f[k+20>>2]=f[z+20>>2];f[k+24>>2]=f[z+24>>2];f[k+28>>2]=f[z+28>>2];f[k+32>>2]=f[z+32>>2];E=f[z+36>>2]|0;f[k+36>>2]=E;D=k+40|0;f[D>>2]=C;C=k+48|0;F=k+44|0;f[F>>2]=C;f[C>>2]=0;f[k+52>>2]=0;if(E|0){C=E+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[B>>2]|0)<3){B=f[z+44>>2]|0;C=f[F>>2]|0;f[C>>2]=f[B>>2];f[C+4>>2]=f[B+4>>2];G=D;break}else{f[A>>2]=0;jL(k,z);G=D;break}}else{yL(k,d,-1);G=k+40|0}while(0);D=j+40|0;z=f[D>>2]|0;A=f[z+-4>>2]|0;B=f[G>>2]|0;a:do if((A|0)==(f[B+-4>>2]|0)){if((A|0)==2){if((f[z>>2]|0)!=(f[B>>2]|0)){H=26;break}if((f[z+4>>2]|0)==(f[B+4>>2]|0)){I=z;break}else{H=26;break}}if((A|0)>0){C=0;while(1){if((f[z+(C<<2)>>2]|0)!=(f[B+(C<<2)>>2]|0)){H=26;break a}C=C+1|0;if((C|0)>=(A|0)){I=z;break}}}else I=z}else H=26;while(0);if((H|0)==26){f[l>>2]=0;f[l+4>>2]=0;w=aD(l,22)|0;x=213104;y=w+22|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,l,213095,212249,2427);bD(l);I=f[D>>2]|0}x=j+4|0;wL(e,f[x>>2]|0,I,s,-1,0,0);do if((yM(e)|0)==65536){s=f[e+4>>2]|0;f[l>>2]=f[s>>2];I=l+4|0;w=s+4|0;f[I>>2]=f[w>>2];y=l+8|0;f[y>>2]=f[s+8>>2];f[l+12>>2]=f[s+12>>2];f[l+16>>2]=f[s+16>>2];f[l+20>>2]=f[s+20>>2];f[l+24>>2]=f[s+24>>2];f[l+28>>2]=f[s+28>>2];f[l+32>>2]=f[s+32>>2];H=f[s+36>>2]|0;f[l+36>>2]=H;f[l+40>>2]=y;y=l+48|0;z=l+44|0;f[z>>2]=y;f[y>>2]=0;f[l+52>>2]=0;if(H|0){y=H+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[w>>2]|0)<3){w=f[s+44>>2]|0;y=f[z>>2]|0;f[y>>2]=f[w>>2];f[y+4>>2]=f[w+4>>2];break}else{f[I>>2]=0;jL(l,s);break}}else yL(l,e,-1);while(0);n[m>>2]=+p[h>>3];s=(t|0)==5;I=s?m:h;m=s?149:148;if(((f[j>>2]&16384|0)!=0?(f[k>>2]&16384|0)!=0:0)?(f[l>>2]&16384|0)!=0:0){s=f[x>>2]|0;if((s|0)<3)J=Y(f[j+12>>2]|0,f[j+8>>2]|0)|0;else{w=f[D>>2]|0;y=0;z=1;while(1){H=Y(f[w+(y<<2)>>2]|0,z)|0;y=y+1|0;if((y|0)==(s|0)){J=H;break}else z=H}}z=Y(J,v)|0;uh[m&255](f[j+16>>2]|0,f[k+16>>2]|0,f[l+16>>2]|0,z,I)}else{f[o>>2]=j;f[o+4>>2]=k;f[o+8>>2]=l;f[o+12>>2]=0;RN(r,o,q,-1);o=Y(f[r+20>>2]|0,v)|0;v=r+16|0;z=q+4|0;J=q+8|0;s=0;while(1){if(s>>>0>=(f[v>>2]|0)>>>0)break;uh[m&255](f[q>>2]|0,f[z>>2]|0,f[J>>2]|0,o,I);aL(r)|0;s=s+1|0}}s=l+36|0;r=f[s>>2]|0;if(r|0?(I=r+12|0,r=f[I>>2]|0,f[I>>2]=r+-1,(r|0)==1):0)kL(l);f[s>>2]=0;s=l+16|0;r=l+4|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;if((f[r>>2]|0)>0){s=f[l+40>>2]|0;I=0;do{f[s+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[r>>2]|0))}r=f[l+44>>2]|0;if((r|0)!=(l+48|0))UC(r);r=k+36|0;l=f[r>>2]|0;if(l|0?(I=l+12|0,l=f[I>>2]|0,f[I>>2]=l+-1,(l|0)==1):0)kL(k);f[r>>2]=0;r=k+16|0;l=k+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[l>>2]|0)>0){r=f[G>>2]|0;G=0;do{f[r+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[l>>2]|0))}l=f[k+44>>2]|0;if((l|0)!=(k+48|0))UC(l);l=j+36|0;k=f[l>>2]|0;if(k|0?(G=k+12|0,k=f[G>>2]|0,f[G>>2]=k+-1,(k|0)==1):0)kL(j);f[l>>2]=0;l=j+16|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[x>>2]|0)>0){l=f[D>>2]|0;D=0;do{f[l+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[x>>2]|0))}x=f[j+44>>2]|0;if((x|0)!=(j+48|0))UC(x)}else jF(a,+p[h>>3],d,1.0,0.0,e,t);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function WX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0;f=+n[e>>2];if((d|0)>0)g=0;else return;do{n[c+(g<<2)>>2]=f*+n[a+(g<<2)>>2]+ +n[b+(g<<2)>>2];g=g+1|0}while((g|0)!=(d|0));return}function XX(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0.0,g=0;f=+p[e>>3];if((d|0)>0)g=0;else return;do{p[c+(g<<3)>>3]=f*+p[a+(g<<3)>>3]+ +p[b+(g<<3)>>3];g=g+1|0}while((g|0)!=(d|0));return}function YX(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;i=u;u=u+352|0;j=i+344|0;k=i+288|0;l=i+232|0;m=i+176|0;n=i+120|0;o=i+104|0;p=i+88|0;q=i+72|0;r=i+16|0;s=i;dQ(j,47384);do if((yM(a)|0)==65536){t=f[a+4>>2]|0;f[k>>2]=f[t>>2];v=k+4|0;w=t+4|0;f[v>>2]=f[w>>2];x=k+8|0;f[x>>2]=f[t+8>>2];f[k+12>>2]=f[t+12>>2];f[k+16>>2]=f[t+16>>2];f[k+20>>2]=f[t+20>>2];f[k+24>>2]=f[t+24>>2];f[k+28>>2]=f[t+28>>2];f[k+32>>2]=f[t+32>>2];y=f[t+36>>2]|0;f[k+36>>2]=y;f[k+40>>2]=x;x=k+48|0;z=k+44|0;f[z>>2]=x;f[x>>2]=0;f[k+52>>2]=0;if(y|0){x=y+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[w>>2]|0)<3){w=f[t+44>>2]|0;x=f[z>>2]|0;f[x>>2]=f[w>>2];f[x+4>>2]=f[w+4>>2];break}else{f[v>>2]=0;jL(k,t);break}}else yL(k,a,-1);while(0);do if((yM(e)|0)==65536){a=f[e+4>>2]|0;f[l>>2]=f[a>>2];t=l+4|0;v=a+4|0;f[t>>2]=f[v>>2];w=l+8|0;f[w>>2]=f[a+8>>2];f[l+12>>2]=f[a+12>>2];f[l+16>>2]=f[a+16>>2];f[l+20>>2]=f[a+20>>2];f[l+24>>2]=f[a+24>>2];f[l+28>>2]=f[a+28>>2];f[l+32>>2]=f[a+32>>2];x=f[a+36>>2]|0;f[l+36>>2]=x;f[l+40>>2]=w;w=l+48|0;z=l+44|0;f[z>>2]=w;f[w>>2]=0;f[l+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[a+44>>2]|0;w=f[z>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];A=l;break}else{f[t>>2]=0;jL(l,a);A=l;break}}else{yL(l,e,-1);A=l}while(0);e=f[k>>2]|0;a=e&4095;t=((h|0)>-1?h:e)&7;h=f[A>>2]&7;v=t>>>0<h>>>0?h:t;t=(v|0)>5?v:5;if(e&4088|0){f[m>>2]=0;f[m+4>>2]=0;B=aD(m,19)|0;C=213190;D=B+19|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,m,213210,212249,2888);bD(m)}e=l+16|0;if(f[e>>2]|0){h=f[l+4>>2]|0;if((h|0)<3)E=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;else{w=f[l+40>>2]|0;z=0;x=1;while(1){y=Y(f[w+(z<<2)>>2]|0,x)|0;z=z+1|0;if((z|0)==(h|0)){E=y;break}else x=y}}if(!((h|0)==0|(E|0)==0)){if(f[A>>2]&4088|0){f[m>>2]=0;f[m+4>>2]=0;B=aD(m,21)|0;C=213224;D=B+21|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,m,213210,212249,2894);bD(m)}E=f[l+8>>2]|0;if(!((E|0)==1?1:(E|0)==(f[k+8>>2]|0))){f[m>>2]=0;f[m+4>>2]=0;B=aD(m,43)|0;C=213246;D=B+43|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,m,213210,212249,2894);bD(m)}E=f[l+12>>2]|0;if(!((E|0)==1?1:(E|0)==(f[k+12>>2]|0))){f[m>>2]=0;f[m+4>>2]=0;B=aD(m,43)|0;C=213290;D=B+43|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,m,213210,212249,2894);bD(m)}if((f[A>>2]&4095|0)!=(t|0)){A=m+8|0;f[A>>2]=0;f[A+4>>2]=0;f[m>>2]=33619968;f[m+4>>2]=l;OJ(l,m,t,1.0,0.0)}}}A=k+8|0;C=k+12|0;E=d?f[C>>2]|0:f[A>>2]|0;aM(c,E,E,t,-1,0,0);do if((yM(c)|0)==65536){E=f[c+4>>2]|0;f[m>>2]=f[E>>2];h=m+4|0;x=E+4|0;f[h>>2]=f[x>>2];z=m+8|0;f[z>>2]=f[E+8>>2];f[m+12>>2]=f[E+12>>2];w=m+16|0;f[w>>2]=f[E+16>>2];f[m+20>>2]=f[E+20>>2];f[m+24>>2]=f[E+24>>2];f[m+28>>2]=f[E+28>>2];f[m+32>>2]=f[E+32>>2];y=f[E+36>>2]|0;f[m+36>>2]=y;f[m+40>>2]=z;z=m+48|0;F=m+44|0;f[F>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(y|0){z=y+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[x>>2]|0)<3){x=f[E+44>>2]|0;z=f[F>>2]|0;f[z>>2]=f[x>>2];f[z+4>>2]=f[x+4>>2];G=w;break}else{f[h>>2]=0;jL(m,E);G=w;break}}else{yL(m,c,-1);G=m+16|0}while(0);c=k+16|0;do if((f[c>>2]|0)==(f[G>>2]|0))H=42;else{if(((a|0)==(t|0)?(f[m+12>>2]|0)>99:0)?((f[C>>2]|0)>99?(f[m+8>>2]|0)>99:0)&(f[A>>2]|0)>99:0){H=42;break}w=(a|0)==0;E=(v|0)<6;do if(!(w&E)){h=(t|0)==6;if(w&h){I=d?22:21;break}x=(a|0)==2;if(x&E){I=d?24:23;break}if(x&h){I=d?26:25;break}x=(a|0)==3;if(x&E){I=d?28:27;break}if(x&h){I=d?30:29;break}x=(a|0)==5;if(x&E){I=d?32:31;break}if(x&h){I=d?34:33;break}if((a|0)==6&h)I=d?36:35;else{f[n>>2]=0;f[n+4>>2]=0;bO(-210,n,213210,212249,2989);bD(n)}}else I=d?20:19;while(0);oh[I&63](k,m,l,g);E=n+8|0;f[E>>2]=0;f[E+4>>2]=0;f[n>>2]=50397184;f[n+4>>2]=m;$M(n,0)}while(0);if((H|0)==42){f[n>>2]=1124007936;H=n+4|0;I=n+8|0;a=n+40|0;B=H;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[a>>2]=I;I=n+48|0;t=n+44|0;f[t>>2]=I;f[I>>2]=0;f[n+52>>2]=0;do if(f[e>>2]|0){v=f[l+4>>2]|0;if((v|0)<3)J=Y(f[l+12>>2]|0,f[l+8>>2]|0)|0;else{E=f[l+40>>2]|0;w=0;h=1;while(1){x=Y(f[E+(w<<2)>>2]|0,h)|0;w=w+1|0;if((w|0)==(v|0)){J=x;break}else h=x}}if(!((v|0)==0|(J|0)==0)){h=f[l+40>>2]|0;w=f[k+40>>2]|0;if((f[h>>2]|0)==(f[w>>2]|0)?(f[h+4>>2]|0)==(f[w+4>>2]|0):0){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=l;w=q+8|0;f[w>>2]=0;f[w+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=n;jE(o,p,q,UM()|0,-1);K=n;break}else{f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=l;w=f[A>>2]|0;h=f[l+8>>2]|0;E=f[C>>2]|0;x=f[l+12>>2]|0;z=p+8|0;f[z>>2]=0;f[z+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=n;YP(o,(w|0)/(h|0)|0,(E|0)/(x|0)|0,p);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=k;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=n;x=q+8|0;f[x>>2]=0;f[x+4>>2]=0;f[q>>2]=33619968;f[q+4>>2]=n;jE(o,p,q,UM()|0,-1);K=n;break}}else K=k}else K=k;while(0);f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=K;f[p+8>>2]=0;f[p+12>>2]=0;f[p>>2]=16842752;f[p+4>>2]=K;f[r>>2]=1124007936;K=r+4|0;C=r+8|0;A=r+40|0;B=K;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[A>>2]=C;C=r+48|0;B=r+44|0;f[B>>2]=C;f[C>>2]=0;f[r+52>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;f[q>>2]=16842752;f[q+4>>2]=r;D=s+8|0;f[D>>2]=0;f[D+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=m;CX(o,p,g,q,0.0,s,d?1:2);d=r+36|0;s=f[d>>2]|0;if(s|0?(q=s+12|0,s=f[q>>2]|0,f[q>>2]=s+-1,(s|0)==1):0)kL(r);f[d>>2]=0;d=r+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[K>>2]|0)>0){d=f[A>>2]|0;A=0;do{f[d+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[K>>2]|0))}K=f[B>>2]|0;if((K|0)!=(C|0))UC(K);K=n+36|0;C=f[K>>2]|0;if(C|0?(B=C+12|0,C=f[B>>2]|0,f[B>>2]=C+-1,(C|0)==1):0)kL(n);f[K>>2]=0;K=n+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[H>>2]|0)>0){K=f[a>>2]|0;a=0;do{f[K+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[H>>2]|0))}H=f[t>>2]|0;if((H|0)!=(I|0))UC(H)}H=m+36|0;I=f[H>>2]|0;if(I|0?(t=I+12|0,I=f[t>>2]|0,f[t>>2]=I+-1,(I|0)==1):0)kL(m);f[H>>2]=0;H=m+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[H>>2]|0)>0){G=f[m+40>>2]|0;I=0;do{f[G+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[H>>2]|0))}H=f[m+44>>2]|0;if((H|0)!=(m+48|0))UC(H);H=l+36|0;m=f[H>>2]|0;if(m|0?(I=m+12|0,m=f[I>>2]|0,f[I>>2]=m+-1,(m|0)==1):0)kL(l);f[H>>2]=0;H=l+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;if((f[H>>2]|0)>0){e=f[l+40>>2]|0;m=0;do{f[e+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[H>>2]|0))}H=f[l+44>>2]|0;if((H|0)!=(l+48|0))UC(H);H=k+36|0;l=f[H>>2]|0;if(l|0?(m=l+12|0,l=f[m>>2]|0,f[m>>2]=l+-1,(l|0)==1):0)kL(k);f[H>>2]=0;H=k+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[H>>2]|0)>0){c=f[k+40>>2]|0;l=0;do{f[c+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[H>>2]|0))}H=f[k+44>>2]|0;if((H|0)!=(k+48|0))UC(H);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function ZX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=f[a+48>>2]|0;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(o|0)<(a|0);o=r&s?p*20|0:p<<2;f[q>>2]=o;if(o>>>0>1032){t=N5b(o)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(p<<2)|0;if((p|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{o=k+((Y(A,b)|0)<<2)|0;B=f[o>>2]|0;o=A<<2;f[t+((o|3)<<2)>>2]=B;f[t+((o|2)<<2)>>2]=B;f[t+((o|1)<<2)>>2]=B;f[t+(o<<2)>>2]=B;A=A+1|0}while((A|0)!=(p|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){B=(y|0)!=0;o=(p|0)>0;C=a+-4|0;D=d*0.0;E=d*0.0;F=d*0.0;G=j;H=0;while(1){if(B){if(o){I=0;do{J=i+((Y(I,l)|0)+H)|0;K=y+((Y(I,z)|0)<<2)|0;n[v+(I<<2)>>2]=+(h[J>>0]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}}else if(o){I=0;do{t=i+((Y(I,l)|0)+H)|0;K=x+((Y(I,z)|0)+H<<2)|0;n[v+(I<<2)>>2]=+(h[t>>0]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}b:do if((H|0)>(C|0))L=H;else{if(o)M=H;else{I=H;while(1){n[G+(I<<2)>>2]=F;n[G+(I+1<<2)>>2]=F;n[G+(I+2<<2)>>2]=F;n[G+(I+3<<2)>>2]=F;K=I+4|0;if((K|0)>(C|0)){L=K;break b}else I=K}}while(1){I=B?y:x+(M<<2)|0;K=i+M|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+n[v+(t<<2)>>2];Q=Q+R*(+(h[K>>0]|0)-+n[I>>2]);P=P+R*(+(h[K+1>>0]|0)-+n[I+4>>2]);O=O+R*(+(h[K+2>>0]|0)-+n[I+8>>2]);N=N+R*(+(h[K+3>>0]|0)-+n[I+12>>2]);t=t+1|0;if((t|0)==(p|0))break;else{I=I+(z<<2)|0;K=K+l|0}}n[G+(M<<2)>>2]=Q*d;n[G+(M+1<<2)>>2]=P*d;n[G+(M+2<<2)>>2]=O*d;n[G+(M+3<<2)>>2]=N*d;K=M+4|0;if((K|0)>(C|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!o)if(B){K=L;while(1){n[G+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){n[G+(K<<2)>>2]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(B){K=L;do{I=i+K|0;R=0.0;t=y;J=0;while(1){R=R+ +n[v+(J<<2)>>2]*(+(h[I>>0]|0)-+n[t>>2]);J=J+1|0;if((J|0)==(p|0))break;else{I=I+l|0;t=t+(z<<2)|0}}n[G+(K<<2)>>2]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=i+K|0;N=0.0;I=x+(K<<2)|0;J=0;while(1){N=N+ +n[v+(J<<2)>>2]*(+(h[t>>0]|0)-+n[I>>2]);J=J+1|0;if((J|0)==(p|0))break;else{t=t+l|0;I=I+(z<<2)|0}}n[G+(K<<2)>>2]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<2)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(p|0)>0;z=a+-4|0;E=d*0.0;D=d*0.0;x=j;j=0;while(1){if(w){L=0;do{y=i+((Y(L,l)|0)+j)|0;n[v+(L<<2)>>2]=+(h[y>>0]|0);L=L+1|0}while((L|0)!=(p|0))}d:do if((j|0)>(z|0))S=j;else{if(w)T=j;else{L=j;while(1){n[x+(L<<2)>>2]=D;n[x+(L+1<<2)>>2]=D;n[x+(L+2<<2)>>2]=D;n[x+(L+3<<2)>>2]=D;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=i+T|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+n[v+(y<<2)>>2];P=P+Q*+(h[L>>0]|0);O=O+Q*+(h[L+1>>0]|0);R=R+Q*+(h[L+2>>0]|0);F=F+Q*+(h[L+3>>0]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+l|0}n[x+(T<<2)>>2]=P*d;n[x+(T+1<<2)>>2]=O*d;n[x+(T+2<<2)>>2]=R*d;n[x+(T+3<<2)>>2]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){n[x+(L<<2)>>2]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=i+U|0;Q=0.0;y=0;while(1){Q=Q+ +n[v+(y<<2)>>2]*+(h[L>>0]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+l|0}n[x+(U<<2)>>2]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);j=j+1|0;if((j|0)==(a|0))break;else x=x+(m<<2)|0}}if((v|0)==(c|0)){u=e;return}P5b(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function _X(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0;e=u;u=u+1056|0;g=e+1040|0;i=e;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=f[a+48>>2]|0;o=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;p=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;t=a&-4;v=(a|0)>0;w=(t|0)<(a|0);x=0;y=k;while(1){z=j+(Y(x,m)|0)|0;if(r){A=x;do{B=j+(Y(A,m)|0)|0;if(v){C=0;D=0.0;while(1){E=D+ +(h[z+C>>0]|0)*+(h[B+C>>0]|0);C=C+1|0;if((C|0)==(a|0)){F=E;break}else D=E}}else F=0.0;n[y+(A<<2)>>2]=F*d;A=A+1|0}while((A|0)!=(q|0))}else{A=x;do{C=j+(Y(A,m)|0)|0;B=0;D=0.0;do{G=B|1;H=B|2;I=B|3;D=D+(+(h[z+B>>0]|0)*+(h[C+B>>0]|0)+ +(h[z+G>>0]|0)*+(h[C+G>>0]|0)+ +(h[z+H>>0]|0)*+(h[C+H>>0]|0)+ +(h[z+I>>0]|0)*+(h[C+I>>0]|0));B=B+4|0}while((B|0)<=(c|0));if(w){B=t;E=D;while(1){J=E+ +(h[z+B>>0]|0)*+(h[C+B>>0]|0);B=B+1|0;if((B|0)==(a|0)){K=J;break}else E=J}}else K=D;n[y+(A<<2)>>2]=K*d;A=A+1|0}while((A|0)!=(q|0))}x=x+1|0;if((x|0)==(q|0))break;else y=y+(o<<2)|0}u=e;return}y=(p|0)==(a|0)?4:0;x=a<<2;t=i+8|0;f[i>>2]=t;w=i+4|0;f[w>>2]=x;if(x>>>0>1032){c=N5b(x)|0;f[i>>2]=c;L=c}else L=t;if((q|0)>0){c=(p|0)<(a|0);p=(a|0)>0;x=g+12|0;v=g+8|0;r=g+4|0;A=a+-4|0;z=(a|0)<4;B=a&-4;C=Y(y,B)|0;I=g+C|0;H=0;G=k;k=l+C|0;while(1){C=j+(Y(H,m)|0)|0;M=l+((Y(H,b)|0)<<2)|0;if(c)if(p){N=0;do{n[L+(N<<2)>>2]=+(h[C+N>>0]|0)-+n[M>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{P=H;O=22}else if(p){N=0;do{n[L+(N<<2)>>2]=+(h[C+N>>0]|0)-+n[M+(N<<2)>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{Q=H;R=k;O=31}if((O|0)==21){O=0;if(c){P=H;O=22}else{Q=H;R=k;O=31}}if((O|0)==22)while(1){O=0;N=j+(Y(P,m)|0)|0;M=l+((Y(P,b)|0)<<2)|0;C=f[M>>2]|0;f[x>>2]=C;f[v>>2]=C;f[r>>2]=C;f[g>>2]=C;a:do if(z){S=0.0;T=g;U=0}else{K=0.0;M=g;V=0;F=(f[s>>2]=C,+n[s>>2]);while(1){W=V|1;X=V|2;Z=V|3;E=K+(+n[L+(V<<2)>>2]*(+(h[N+V>>0]|0)-F)+ +n[L+(W<<2)>>2]*(+(h[N+W>>0]|0)-+n[M+4>>2])+ +n[L+(X<<2)>>2]*(+(h[N+X>>0]|0)-+n[M+8>>2])+ +n[L+(Z<<2)>>2]*(+(h[N+Z>>0]|0)-+n[M+12>>2]));Z=V+4|0;X=M+(y<<2)|0;if((Z|0)>(A|0)){S=E;T=I;U=B;break a}K=E;M=X;V=Z;F=+n[X>>2]}}while(0);if((U|0)<(a|0)){D=S;C=T;V=U;while(1){F=D+ +n[L+(V<<2)>>2]*(+(h[N+V>>0]|0)-+n[C>>2]);V=V+1|0;if((V|0)==(a|0)){_=F;break}else{D=F;C=C+4|0}}}else _=S;n[G+(P<<2)>>2]=_*d;P=P+1|0;if((P|0)==(q|0))break;else O=22}else if((O|0)==31)while(1){O=0;C=j+(Y(Q,m)|0)|0;V=l+((Y(Q,b)|0)<<2)|0;if(z){$=0.0;aa=V;ba=0}else{D=0.0;N=V;V=0;while(1){M=V|1;X=V|2;Z=V|3;F=D+(+n[L+(V<<2)>>2]*(+(h[C+V>>0]|0)-+n[N>>2])+ +n[L+(M<<2)>>2]*(+(h[C+M>>0]|0)-+n[N+4>>2])+ +n[L+(X<<2)>>2]*(+(h[C+X>>0]|0)-+n[N+8>>2])+ +n[L+(Z<<2)>>2]*(+(h[C+Z>>0]|0)-+n[N+12>>2]));V=V+4|0;if((V|0)>(A|0)){$=F;aa=R;ba=B;break}else{D=F;N=N+(y<<2)|0}}}if((ba|0)<(a|0)){D=$;N=aa;V=ba;while(1){F=D+ +n[L+(V<<2)>>2]*(+(h[C+V>>0]|0)-+n[N>>2]);V=V+1|0;if((V|0)==(a|0)){ca=F;break}else{D=F;N=N+4|0}}}else ca=$;n[G+(Q<<2)>>2]=ca*d;Q=Q+1|0;if((Q|0)==(q|0))break;else{R=R+(b<<2)|0;O=31}}H=H+1|0;if((H|0)==(q|0))break;else{G=G+(o<<2)|0;k=k+(b<<2)|0}}}if((L|0)!=(t|0)){P5b(L);f[i>>2]=t;f[w>>2]=1032}u=e;return}function $X(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=f[a+48>>2]|0;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(n|0)<(a|0);n=r&s?o*40|0:o<<3;f[q>>2]=n;if(n>>>0>1032){t=N5b(n)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{n=k+((Y(A,b)|0)<<3)|0;B=+p[n>>3];n=A<<2;p[t+((n|3)<<3)>>3]=B;p[t+((n|2)<<3)>>3]=B;p[t+((n|1)<<3)>>3]=B;p[t+(n<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){n=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=d*0.0;E=d*0.0;F=d*0.0;G=j;H=0;while(1){if(n){if(C){I=0;do{J=i+((Y(I,l)|0)+H)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+(h[J>>0]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=i+((Y(I,l)|0)+H)|0;K=x+((Y(I,z)|0)+H<<3)|0;p[v+(I<<3)>>3]=+(h[t>>0]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((H|0)>(D|0))L=H;else{if(C)M=H;else{I=H;while(1){p[G+(I<<3)>>3]=F;p[G+(I+1<<3)>>3]=F;p[G+(I+2<<3)>>3]=F;p[G+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=n?y:x+(M<<3)|0;K=i+M|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+p[v+(t<<3)>>3];Q=Q+R*(+(h[K>>0]|0)-+p[I>>3]);P=P+R*(+(h[K+1>>0]|0)-+p[I+8>>3]);O=O+R*(+(h[K+2>>0]|0)-+p[I+16>>3]);N=N+R*(+(h[K+3>>0]|0)-+p[I+24>>3]);t=t+1|0;if((t|0)==(o|0))break;else{I=I+(z<<3)|0;K=K+l|0}}p[G+(M<<3)>>3]=Q*d;p[G+(M+1<<3)>>3]=P*d;p[G+(M+2<<3)>>3]=O*d;p[G+(M+3<<3)>>3]=N*d;K=M+4|0;if((K|0)>(D|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!C)if(n){K=L;while(1){p[G+(K<<3)>>3]=B;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){p[G+(K<<3)>>3]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(n){K=L;do{I=i+K|0;R=0.0;t=y;J=0;while(1){R=R+ +p[v+(J<<3)>>3]*(+(h[I>>0]|0)-+p[t>>3]);J=J+1|0;if((J|0)==(o|0))break;else{I=I+l|0;t=t+(z<<3)|0}}p[G+(K<<3)>>3]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=i+K|0;N=0.0;I=x+(K<<3)|0;J=0;while(1){N=N+ +p[v+(J<<3)>>3]*(+(h[t>>0]|0)-+p[I>>3]);J=J+1|0;if((J|0)==(o|0))break;else{t=t+l|0;I=I+(z<<3)|0}}p[G+(K<<3)>>3]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=d*0.0;B=d*0.0;x=j;j=0;while(1){if(w){L=0;do{y=i+((Y(L,l)|0)+j)|0;p[v+(L<<3)>>3]=+(h[y>>0]|0);L=L+1|0}while((L|0)!=(o|0))}d:do if((j|0)>(z|0))S=j;else{if(w)T=j;else{L=j;while(1){p[x+(L<<3)>>3]=B;p[x+(L+1<<3)>>3]=B;p[x+(L+2<<3)>>3]=B;p[x+(L+3<<3)>>3]=B;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=i+T|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+p[v+(y<<3)>>3];P=P+Q*+(h[L>>0]|0);O=O+Q*+(h[L+1>>0]|0);R=R+Q*+(h[L+2>>0]|0);F=F+Q*+(h[L+3>>0]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+l|0}p[x+(T<<3)>>3]=P*d;p[x+(T+1<<3)>>3]=O*d;p[x+(T+2<<3)>>3]=R*d;p[x+(T+3<<3)>>3]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){p[x+(L<<3)>>3]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=i+U|0;Q=0.0;y=0;while(1){Q=Q+ +p[v+(y<<3)>>3]*+(h[L>>0]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+l|0}p[x+(U<<3)>>3]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);j=j+1|0;if((j|0)==(a|0))break;else x=x+(m<<3)|0}}if((v|0)==(c|0)){u=e;return}P5b(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function aY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0;e=u;u=u+1072|0;g=e;i=e+32|0;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=f[a+48>>2]|0;n=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=k;while(1){y=j+(Y(w,m)|0)|0;if(r){z=w;do{A=j+(Y(z,m)|0)|0;if(t){B=0;C=0.0;while(1){D=C+ +(h[y+B>>0]|0)*+(h[A+B>>0]|0);B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*d;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=j+(Y(z,m)|0)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+(h[y+A>>0]|0)*+(h[B+A>>0]|0)+ +(h[y+F>>0]|0)*+(h[B+F>>0]|0)+ +(h[y+G>>0]|0)*+(h[B+G>>0]|0)+ +(h[y+H>>0]|0)*+(h[B+H>>0]|0));A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +(h[y+A>>0]|0)*+(h[B+A>>0]|0);A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*d;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(n<<3)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=i+8|0;f[i>>2]=s;v=i+4|0;f[v>>2]=w;if(w>>>0>1032){c=N5b(w)|0;f[i>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+24|0;t=g+16|0;r=g+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=g+H|0;G=0;F=k;k=l+H|0;while(1){H=j+(Y(G,m)|0)|0;L=l+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+(h[H+M>>0]|0)-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+(h[H+M>>0]|0)-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=k;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=k;N=30}}if((N|0)==22)while(1){N=0;M=j+(Y(O,m)|0)|0;L=l+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[g>>3]=J;a:do if(y){R=0.0;S=g;T=0}else{E=0.0;L=g;H=0;D=J;while(1){U=H|1;V=H|2;W=H|3;I=E+(+p[K+(H<<3)>>3]*(+(h[M+H>>0]|0)-D)+ +p[K+(U<<3)>>3]*(+(h[M+U>>0]|0)-+p[L+8>>3])+ +p[K+(V<<3)>>3]*(+(h[M+V>>0]|0)-+p[L+16>>3])+ +p[K+(W<<3)>>3]*(+(h[M+W>>0]|0)-+p[L+24>>3]));W=H+4|0;V=L+(x<<3)|0;if((W|0)>(z|0)){R=I;S=A;T=B;break a}E=I;L=V;H=W;D=+p[V>>3]}}while(0);if((T|0)<(a|0)){J=R;H=S;L=T;while(1){C=J+ +p[K+(L<<3)>>3]*(+(h[M+L>>0]|0)-+p[H>>3]);L=L+1|0;if((L|0)==(a|0)){X=C;break}else{J=C;H=H+8|0}}}else X=R;p[F+(O<<3)>>3]=X*d;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;H=j+(Y(P,m)|0)|0;L=l+((Y(P,b)|0)<<3)|0;if(y){Z=0.0;_=L;$=0}else{J=0.0;M=L;L=0;while(1){V=L|1;W=L|2;U=L|3;C=J+(+p[K+(L<<3)>>3]*(+(h[H+L>>0]|0)-+p[M>>3])+ +p[K+(V<<3)>>3]*(+(h[H+V>>0]|0)-+p[M+8>>3])+ +p[K+(W<<3)>>3]*(+(h[H+W>>0]|0)-+p[M+16>>3])+ +p[K+(U<<3)>>3]*(+(h[H+U>>0]|0)-+p[M+24>>3]));L=L+4|0;if((L|0)>(z|0)){Z=C;_=Q;$=B;break}else{J=C;M=M+(x<<3)|0}}}if(($|0)<(a|0)){J=Z;M=_;L=$;while(1){C=J+ +p[K+(L<<3)>>3]*(+(h[H+L>>0]|0)-+p[M>>3]);L=L+1|0;if((L|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=Z;p[F+(P<<3)>>3]=aa*d;P=P+1|0;if((P|0)==(q|0))break;else{Q=Q+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(n<<3)|0;k=k+(b<<3)|0}}}if((K|0)!=(s|0)){P5b(K);f[i>>2]=s;f[v>>2]=1032}u=e;return}function bY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(o|0)<(a|0);o=r&s?p*20|0:p<<2;f[q>>2]=o;if(o>>>0>1032){t=N5b(o)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(p<<2)|0;if((p|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{o=k+((Y(A,b)|0)<<2)|0;B=f[o>>2]|0;o=A<<2;f[t+((o|3)<<2)>>2]=B;f[t+((o|2)<<2)>>2]=B;f[t+((o|1)<<2)>>2]=B;f[t+(o<<2)>>2]=B;A=A+1|0}while((A|0)!=(p|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){B=(y|0)!=0;o=(p|0)>0;C=a+-4|0;D=d*0.0;E=d*0.0;F=d*0.0;G=i;H=0;while(1){if(B){if(o){I=0;do{J=h+((Y(I,l)|0)+H<<1)|0;K=y+((Y(I,z)|0)<<2)|0;n[v+(I<<2)>>2]=+(j[J>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}}else if(o){I=0;do{t=h+((Y(I,l)|0)+H<<1)|0;K=x+((Y(I,z)|0)+H<<2)|0;n[v+(I<<2)>>2]=+(j[t>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}b:do if((H|0)>(C|0))L=H;else{if(o)M=H;else{I=H;while(1){n[G+(I<<2)>>2]=F;n[G+(I+1<<2)>>2]=F;n[G+(I+2<<2)>>2]=F;n[G+(I+3<<2)>>2]=F;K=I+4|0;if((K|0)>(C|0)){L=K;break b}else I=K}}while(1){I=B?y:x+(M<<2)|0;K=h+(M<<1)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+n[v+(t<<2)>>2];Q=Q+R*(+(j[K>>1]|0)-+n[I>>2]);P=P+R*(+(j[K+2>>1]|0)-+n[I+4>>2]);O=O+R*(+(j[K+4>>1]|0)-+n[I+8>>2]);N=N+R*(+(j[K+6>>1]|0)-+n[I+12>>2]);t=t+1|0;if((t|0)==(p|0))break;else{I=I+(z<<2)|0;K=K+(l<<1)|0}}n[G+(M<<2)>>2]=Q*d;n[G+(M+1<<2)>>2]=P*d;n[G+(M+2<<2)>>2]=O*d;n[G+(M+3<<2)>>2]=N*d;K=M+4|0;if((K|0)>(C|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!o)if(B){K=L;while(1){n[G+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){n[G+(K<<2)>>2]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(B){K=L;do{I=h+(K<<1)|0;R=0.0;t=y;J=0;while(1){R=R+ +n[v+(J<<2)>>2]*(+(j[I>>1]|0)-+n[t>>2]);J=J+1|0;if((J|0)==(p|0))break;else{I=I+(l<<1)|0;t=t+(z<<2)|0}}n[G+(K<<2)>>2]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=h+(K<<1)|0;N=0.0;I=x+(K<<2)|0;J=0;while(1){N=N+ +n[v+(J<<2)>>2]*(+(j[t>>1]|0)-+n[I>>2]);J=J+1|0;if((J|0)==(p|0))break;else{t=t+(l<<1)|0;I=I+(z<<2)|0}}n[G+(K<<2)>>2]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<2)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(p|0)>0;z=a+-4|0;E=d*0.0;D=d*0.0;x=i;i=0;while(1){if(w){L=0;do{y=h+((Y(L,l)|0)+i<<1)|0;n[v+(L<<2)>>2]=+(j[y>>1]|0);L=L+1|0}while((L|0)!=(p|0))}d:do if((i|0)>(z|0))S=i;else{if(w)T=i;else{L=i;while(1){n[x+(L<<2)>>2]=D;n[x+(L+1<<2)>>2]=D;n[x+(L+2<<2)>>2]=D;n[x+(L+3<<2)>>2]=D;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=h+(T<<1)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+n[v+(y<<2)>>2];P=P+Q*+(j[L>>1]|0);O=O+Q*+(j[L+2>>1]|0);R=R+Q*+(j[L+4>>1]|0);F=F+Q*+(j[L+6>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+(l<<1)|0}n[x+(T<<2)>>2]=P*d;n[x+(T+1<<2)>>2]=O*d;n[x+(T+2<<2)>>2]=R*d;n[x+(T+3<<2)>>2]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){n[x+(L<<2)>>2]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=h+(U<<1)|0;Q=0.0;y=0;while(1){Q=Q+ +n[v+(y<<2)>>2]*+(j[L>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+(l<<1)|0}n[x+(U<<2)>>2]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else x=x+(m<<2)|0}}if((v|0)==(c|0)){u=e;return}P5b(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function cY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0;e=u;u=u+1056|0;g=e+1040|0;h=e;i=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;o=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;p=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;t=a&-4;v=(a|0)>0;w=(t|0)<(a|0);x=0;y=k;while(1){z=i+((Y(x,m)|0)<<1)|0;if(r){A=x;do{B=i+((Y(A,m)|0)<<1)|0;if(v){C=0;D=0.0;while(1){E=D+ +(j[z+(C<<1)>>1]|0)*+(j[B+(C<<1)>>1]|0);C=C+1|0;if((C|0)==(a|0)){F=E;break}else D=E}}else F=0.0;n[y+(A<<2)>>2]=F*d;A=A+1|0}while((A|0)!=(q|0))}else{A=x;do{C=i+((Y(A,m)|0)<<1)|0;B=0;D=0.0;do{G=B|1;H=B|2;I=B|3;D=D+(+(j[z+(B<<1)>>1]|0)*+(j[C+(B<<1)>>1]|0)+ +(j[z+(G<<1)>>1]|0)*+(j[C+(G<<1)>>1]|0)+ +(j[z+(H<<1)>>1]|0)*+(j[C+(H<<1)>>1]|0)+ +(j[z+(I<<1)>>1]|0)*+(j[C+(I<<1)>>1]|0));B=B+4|0}while((B|0)<=(c|0));if(w){B=t;E=D;while(1){J=E+ +(j[z+(B<<1)>>1]|0)*+(j[C+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){K=J;break}else E=J}}else K=D;n[y+(A<<2)>>2]=K*d;A=A+1|0}while((A|0)!=(q|0))}x=x+1|0;if((x|0)==(q|0))break;else y=y+(o<<2)|0}u=e;return}y=(p|0)==(a|0)?4:0;x=a<<2;t=h+8|0;f[h>>2]=t;w=h+4|0;f[w>>2]=x;if(x>>>0>1032){c=N5b(x)|0;f[h>>2]=c;L=c}else L=t;if((q|0)>0){c=(p|0)<(a|0);p=(a|0)>0;x=g+12|0;v=g+8|0;r=g+4|0;A=a+-4|0;z=(a|0)<4;B=a&-4;C=Y(y,B)|0;I=g+C|0;H=0;G=k;k=l+C|0;while(1){C=i+((Y(H,m)|0)<<1)|0;M=l+((Y(H,b)|0)<<2)|0;if(c)if(p){N=0;do{n[L+(N<<2)>>2]=+(j[C+(N<<1)>>1]|0)-+n[M>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{P=H;O=22}else if(p){N=0;do{n[L+(N<<2)>>2]=+(j[C+(N<<1)>>1]|0)-+n[M+(N<<2)>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{Q=H;R=k;O=31}if((O|0)==21){O=0;if(c){P=H;O=22}else{Q=H;R=k;O=31}}if((O|0)==22)while(1){O=0;N=i+((Y(P,m)|0)<<1)|0;M=l+((Y(P,b)|0)<<2)|0;C=f[M>>2]|0;f[x>>2]=C;f[v>>2]=C;f[r>>2]=C;f[g>>2]=C;a:do if(z){S=0.0;T=g;U=0}else{K=0.0;M=g;V=0;F=(f[s>>2]=C,+n[s>>2]);while(1){W=V|1;X=V|2;Z=V|3;E=K+(+n[L+(V<<2)>>2]*(+(j[N+(V<<1)>>1]|0)-F)+ +n[L+(W<<2)>>2]*(+(j[N+(W<<1)>>1]|0)-+n[M+4>>2])+ +n[L+(X<<2)>>2]*(+(j[N+(X<<1)>>1]|0)-+n[M+8>>2])+ +n[L+(Z<<2)>>2]*(+(j[N+(Z<<1)>>1]|0)-+n[M+12>>2]));Z=V+4|0;X=M+(y<<2)|0;if((Z|0)>(A|0)){S=E;T=I;U=B;break a}K=E;M=X;V=Z;F=+n[X>>2]}}while(0);if((U|0)<(a|0)){D=S;C=T;V=U;while(1){F=D+ +n[L+(V<<2)>>2]*(+(j[N+(V<<1)>>1]|0)-+n[C>>2]);V=V+1|0;if((V|0)==(a|0)){_=F;break}else{D=F;C=C+4|0}}}else _=S;n[G+(P<<2)>>2]=_*d;P=P+1|0;if((P|0)==(q|0))break;else O=22}else if((O|0)==31)while(1){O=0;C=i+((Y(Q,m)|0)<<1)|0;V=l+((Y(Q,b)|0)<<2)|0;if(z){$=0.0;aa=V;ba=0}else{D=0.0;N=V;V=0;while(1){M=V|1;X=V|2;Z=V|3;F=D+(+n[L+(V<<2)>>2]*(+(j[C+(V<<1)>>1]|0)-+n[N>>2])+ +n[L+(M<<2)>>2]*(+(j[C+(M<<1)>>1]|0)-+n[N+4>>2])+ +n[L+(X<<2)>>2]*(+(j[C+(X<<1)>>1]|0)-+n[N+8>>2])+ +n[L+(Z<<2)>>2]*(+(j[C+(Z<<1)>>1]|0)-+n[N+12>>2]));V=V+4|0;if((V|0)>(A|0)){$=F;aa=R;ba=B;break}else{D=F;N=N+(y<<2)|0}}}if((ba|0)<(a|0)){D=$;N=aa;V=ba;while(1){F=D+ +n[L+(V<<2)>>2]*(+(j[C+(V<<1)>>1]|0)-+n[N>>2]);V=V+1|0;if((V|0)==(a|0)){ca=F;break}else{D=F;N=N+4|0}}}else ca=$;n[G+(Q<<2)>>2]=ca*d;Q=Q+1|0;if((Q|0)==(q|0))break;else{R=R+(b<<2)|0;O=31}}H=H+1|0;if((H|0)==(q|0))break;else{G=G+(o<<2)|0;k=k+(b<<2)|0}}}if((L|0)!=(t|0)){P5b(L);f[h>>2]=t;f[w>>2]=1032}u=e;return}function dY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(n|0)<(a|0);n=r&s?o*40|0:o<<3;f[q>>2]=n;if(n>>>0>1032){t=N5b(n)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{n=k+((Y(A,b)|0)<<3)|0;B=+p[n>>3];n=A<<2;p[t+((n|3)<<3)>>3]=B;p[t+((n|2)<<3)>>3]=B;p[t+((n|1)<<3)>>3]=B;p[t+(n<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){n=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=d*0.0;E=d*0.0;F=d*0.0;G=i;H=0;while(1){if(n){if(C){I=0;do{J=h+((Y(I,l)|0)+H<<1)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+(j[J>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=h+((Y(I,l)|0)+H<<1)|0;K=x+((Y(I,z)|0)+H<<3)|0;p[v+(I<<3)>>3]=+(j[t>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((H|0)>(D|0))L=H;else{if(C)M=H;else{I=H;while(1){p[G+(I<<3)>>3]=F;p[G+(I+1<<3)>>3]=F;p[G+(I+2<<3)>>3]=F;p[G+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=n?y:x+(M<<3)|0;K=h+(M<<1)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+p[v+(t<<3)>>3];Q=Q+R*(+(j[K>>1]|0)-+p[I>>3]);P=P+R*(+(j[K+2>>1]|0)-+p[I+8>>3]);O=O+R*(+(j[K+4>>1]|0)-+p[I+16>>3]);N=N+R*(+(j[K+6>>1]|0)-+p[I+24>>3]);t=t+1|0;if((t|0)==(o|0))break;else{I=I+(z<<3)|0;K=K+(l<<1)|0}}p[G+(M<<3)>>3]=Q*d;p[G+(M+1<<3)>>3]=P*d;p[G+(M+2<<3)>>3]=O*d;p[G+(M+3<<3)>>3]=N*d;K=M+4|0;if((K|0)>(D|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!C)if(n){K=L;while(1){p[G+(K<<3)>>3]=B;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){p[G+(K<<3)>>3]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(n){K=L;do{I=h+(K<<1)|0;R=0.0;t=y;J=0;while(1){R=R+ +p[v+(J<<3)>>3]*(+(j[I>>1]|0)-+p[t>>3]);J=J+1|0;if((J|0)==(o|0))break;else{I=I+(l<<1)|0;t=t+(z<<3)|0}}p[G+(K<<3)>>3]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=h+(K<<1)|0;N=0.0;I=x+(K<<3)|0;J=0;while(1){N=N+ +p[v+(J<<3)>>3]*(+(j[t>>1]|0)-+p[I>>3]);J=J+1|0;if((J|0)==(o|0))break;else{t=t+(l<<1)|0;I=I+(z<<3)|0}}p[G+(K<<3)>>3]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=d*0.0;B=d*0.0;x=i;i=0;while(1){if(w){L=0;do{y=h+((Y(L,l)|0)+i<<1)|0;p[v+(L<<3)>>3]=+(j[y>>1]|0);L=L+1|0}while((L|0)!=(o|0))}d:do if((i|0)>(z|0))S=i;else{if(w)T=i;else{L=i;while(1){p[x+(L<<3)>>3]=B;p[x+(L+1<<3)>>3]=B;p[x+(L+2<<3)>>3]=B;p[x+(L+3<<3)>>3]=B;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=h+(T<<1)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+p[v+(y<<3)>>3];P=P+Q*+(j[L>>1]|0);O=O+Q*+(j[L+2>>1]|0);R=R+Q*+(j[L+4>>1]|0);F=F+Q*+(j[L+6>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+(l<<1)|0}p[x+(T<<3)>>3]=P*d;p[x+(T+1<<3)>>3]=O*d;p[x+(T+2<<3)>>3]=R*d;p[x+(T+3<<3)>>3]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){p[x+(L<<3)>>3]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=h+(U<<1)|0;Q=0.0;y=0;while(1){Q=Q+ +p[v+(y<<3)>>3]*+(j[L>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+(l<<1)|0}p[x+(U<<3)>>3]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else x=x+(m<<3)|0}}if((v|0)==(c|0)){u=e;return}P5b(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function eY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0;e=u;u=u+1072|0;g=e;h=e+32|0;i=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;n=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=k;while(1){y=i+((Y(w,m)|0)<<1)|0;if(r){z=w;do{A=i+((Y(z,m)|0)<<1)|0;if(t){B=0;C=0.0;while(1){D=C+ +(j[y+(B<<1)>>1]|0)*+(j[A+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*d;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=i+((Y(z,m)|0)<<1)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+(j[y+(A<<1)>>1]|0)*+(j[B+(A<<1)>>1]|0)+ +(j[y+(F<<1)>>1]|0)*+(j[B+(F<<1)>>1]|0)+ +(j[y+(G<<1)>>1]|0)*+(j[B+(G<<1)>>1]|0)+ +(j[y+(H<<1)>>1]|0)*+(j[B+(H<<1)>>1]|0));A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +(j[y+(A<<1)>>1]|0)*+(j[B+(A<<1)>>1]|0);A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*d;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(n<<3)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=h+8|0;f[h>>2]=s;v=h+4|0;f[v>>2]=w;if(w>>>0>1032){c=N5b(w)|0;f[h>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+24|0;t=g+16|0;r=g+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=g+H|0;G=0;F=k;k=l+H|0;while(1){H=i+((Y(G,m)|0)<<1)|0;L=l+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+(j[H+(M<<1)>>1]|0)-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+(j[H+(M<<1)>>1]|0)-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=k;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=k;N=30}}if((N|0)==22)while(1){N=0;M=i+((Y(O,m)|0)<<1)|0;L=l+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[g>>3]=J;a:do if(y){R=0.0;S=g;T=0}else{E=0.0;L=g;H=0;D=J;while(1){U=H|1;V=H|2;W=H|3;I=E+(+p[K+(H<<3)>>3]*(+(j[M+(H<<1)>>1]|0)-D)+ +p[K+(U<<3)>>3]*(+(j[M+(U<<1)>>1]|0)-+p[L+8>>3])+ +p[K+(V<<3)>>3]*(+(j[M+(V<<1)>>1]|0)-+p[L+16>>3])+ +p[K+(W<<3)>>3]*(+(j[M+(W<<1)>>1]|0)-+p[L+24>>3]));W=H+4|0;V=L+(x<<3)|0;if((W|0)>(z|0)){R=I;S=A;T=B;break a}E=I;L=V;H=W;D=+p[V>>3]}}while(0);if((T|0)<(a|0)){J=R;H=S;L=T;while(1){C=J+ +p[K+(L<<3)>>3]*(+(j[M+(L<<1)>>1]|0)-+p[H>>3]);L=L+1|0;if((L|0)==(a|0)){X=C;break}else{J=C;H=H+8|0}}}else X=R;p[F+(O<<3)>>3]=X*d;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;H=i+((Y(P,m)|0)<<1)|0;L=l+((Y(P,b)|0)<<3)|0;if(y){Z=0.0;_=L;$=0}else{J=0.0;M=L;L=0;while(1){V=L|1;W=L|2;U=L|3;C=J+(+p[K+(L<<3)>>3]*(+(j[H+(L<<1)>>1]|0)-+p[M>>3])+ +p[K+(V<<3)>>3]*(+(j[H+(V<<1)>>1]|0)-+p[M+8>>3])+ +p[K+(W<<3)>>3]*(+(j[H+(W<<1)>>1]|0)-+p[M+16>>3])+ +p[K+(U<<3)>>3]*(+(j[H+(U<<1)>>1]|0)-+p[M+24>>3]));L=L+4|0;if((L|0)>(z|0)){Z=C;_=Q;$=B;break}else{J=C;M=M+(x<<3)|0}}}if(($|0)<(a|0)){J=Z;M=_;L=$;while(1){C=J+ +p[K+(L<<3)>>3]*(+(j[H+(L<<1)>>1]|0)-+p[M>>3]);L=L+1|0;if((L|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=Z;p[F+(P<<3)>>3]=aa*d;P=P+1|0;if((P|0)==(q|0))break;else{Q=Q+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(n<<3)|0;k=k+(b<<3)|0}}}if((K|0)!=(s|0)){P5b(K);f[h>>2]=s;f[v>>2]=1032}u=e;return}function fY(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;g=u;u=u+1040|0;h=g;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;c=h+8|0;f[h>>2]=c;q=h+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(o|0)<(a|0);o=r&s?p*20|0:p<<2;f[q>>2]=o;if(o>>>0>1032){t=N5b(o)|0;f[h>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(p<<2)|0;if((p|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{o=k+((Y(A,b)|0)<<2)|0;B=f[o>>2]|0;o=A<<2;f[t+((o|3)<<2)>>2]=B;f[t+((o|2)<<2)>>2]=B;f[t+((o|1)<<2)>>2]=B;f[t+(o<<2)>>2]=B;A=A+1|0}while((A|0)!=(p|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){B=(y|0)!=0;o=(p|0)>0;C=a+-4|0;D=e*0.0;E=e*0.0;F=e*0.0;G=j;H=0;while(1){if(B){if(o){I=0;do{J=i+((Y(I,l)|0)+H<<1)|0;K=y+((Y(I,z)|0)<<2)|0;n[v+(I<<2)>>2]=+(d[J>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}}else if(o){I=0;do{t=i+((Y(I,l)|0)+H<<1)|0;K=x+((Y(I,z)|0)+H<<2)|0;n[v+(I<<2)>>2]=+(d[t>>1]|0)-+n[K>>2];I=I+1|0}while((I|0)!=(p|0))}b:do if((H|0)>(C|0))L=H;else{if(o)M=H;else{I=H;while(1){n[G+(I<<2)>>2]=F;n[G+(I+1<<2)>>2]=F;n[G+(I+2<<2)>>2]=F;n[G+(I+3<<2)>>2]=F;K=I+4|0;if((K|0)>(C|0)){L=K;break b}else I=K}}while(1){I=B?y:x+(M<<2)|0;K=i+(M<<1)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+n[v+(t<<2)>>2];Q=Q+R*(+(d[K>>1]|0)-+n[I>>2]);P=P+R*(+(d[K+2>>1]|0)-+n[I+4>>2]);O=O+R*(+(d[K+4>>1]|0)-+n[I+8>>2]);N=N+R*(+(d[K+6>>1]|0)-+n[I+12>>2]);t=t+1|0;if((t|0)==(p|0))break;else{I=I+(z<<2)|0;K=K+(l<<1)|0}}n[G+(M<<2)>>2]=Q*e;n[G+(M+1<<2)>>2]=P*e;n[G+(M+2<<2)>>2]=O*e;n[G+(M+3<<2)>>2]=N*e;K=M+4|0;if((K|0)>(C|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!o)if(B){K=L;while(1){n[G+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){n[G+(K<<2)>>2]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(B){K=L;do{I=i+(K<<1)|0;R=0.0;t=y;J=0;while(1){R=R+ +n[v+(J<<2)>>2]*(+(d[I>>1]|0)-+n[t>>2]);J=J+1|0;if((J|0)==(p|0))break;else{I=I+(l<<1)|0;t=t+(z<<2)|0}}n[G+(K<<2)>>2]=R*e;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=i+(K<<1)|0;N=0.0;I=x+(K<<2)|0;J=0;while(1){N=N+ +n[v+(J<<2)>>2]*(+(d[t>>1]|0)-+n[I>>2]);J=J+1|0;if((J|0)==(p|0))break;else{t=t+(l<<1)|0;I=I+(z<<2)|0}}n[G+(K<<2)>>2]=N*e;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<2)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(p|0)>0;z=a+-4|0;E=e*0.0;D=e*0.0;x=j;j=0;while(1){if(w){L=0;do{y=i+((Y(L,l)|0)+j<<1)|0;n[v+(L<<2)>>2]=+(d[y>>1]|0);L=L+1|0}while((L|0)!=(p|0))}d:do if((j|0)>(z|0))S=j;else{if(w)T=j;else{L=j;while(1){n[x+(L<<2)>>2]=D;n[x+(L+1<<2)>>2]=D;n[x+(L+2<<2)>>2]=D;n[x+(L+3<<2)>>2]=D;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=i+(T<<1)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+n[v+(y<<2)>>2];P=P+Q*+(d[L>>1]|0);O=O+Q*+(d[L+2>>1]|0);R=R+Q*+(d[L+4>>1]|0);F=F+Q*+(d[L+6>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+(l<<1)|0}n[x+(T<<2)>>2]=P*e;n[x+(T+1<<2)>>2]=O*e;n[x+(T+2<<2)>>2]=R*e;n[x+(T+3<<2)>>2]=F*e;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){n[x+(L<<2)>>2]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=i+(U<<1)|0;Q=0.0;y=0;while(1){Q=Q+ +n[v+(y<<2)>>2]*+(d[L>>1]|0);y=y+1|0;if((y|0)==(p|0))break;else L=L+(l<<1)|0}n[x+(U<<2)>>2]=Q*e;U=U+1|0}while((U|0)!=(a|0))}while(0);j=j+1|0;if((j|0)==(a|0))break;else x=x+(m<<2)|0}}if((v|0)==(c|0)){u=g;return}P5b(v);f[h>>2]=c;f[q>>2]=1032;u=g;return}function gY(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0;g=u;u=u+1056|0;h=g+1040|0;i=g;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;o=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;p=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=g;return}c=a+-4|0;r=(a|0)<4;t=a&-4;v=(a|0)>0;w=(t|0)<(a|0);x=0;y=k;while(1){z=j+((Y(x,m)|0)<<1)|0;if(r){A=x;do{B=j+((Y(A,m)|0)<<1)|0;if(v){C=0;D=0.0;while(1){E=D+ +(d[z+(C<<1)>>1]|0)*+(d[B+(C<<1)>>1]|0);C=C+1|0;if((C|0)==(a|0)){F=E;break}else D=E}}else F=0.0;n[y+(A<<2)>>2]=F*e;A=A+1|0}while((A|0)!=(q|0))}else{A=x;do{C=j+((Y(A,m)|0)<<1)|0;B=0;D=0.0;do{G=B|1;H=B|2;I=B|3;D=D+(+(d[z+(B<<1)>>1]|0)*+(d[C+(B<<1)>>1]|0)+ +(d[z+(G<<1)>>1]|0)*+(d[C+(G<<1)>>1]|0)+ +(d[z+(H<<1)>>1]|0)*+(d[C+(H<<1)>>1]|0)+ +(d[z+(I<<1)>>1]|0)*+(d[C+(I<<1)>>1]|0));B=B+4|0}while((B|0)<=(c|0));if(w){B=t;E=D;while(1){J=E+ +(d[z+(B<<1)>>1]|0)*+(d[C+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){K=J;break}else E=J}}else K=D;n[y+(A<<2)>>2]=K*e;A=A+1|0}while((A|0)!=(q|0))}x=x+1|0;if((x|0)==(q|0))break;else y=y+(o<<2)|0}u=g;return}y=(p|0)==(a|0)?4:0;x=a<<2;t=i+8|0;f[i>>2]=t;w=i+4|0;f[w>>2]=x;if(x>>>0>1032){c=N5b(x)|0;f[i>>2]=c;L=c}else L=t;if((q|0)>0){c=(p|0)<(a|0);p=(a|0)>0;x=h+12|0;v=h+8|0;r=h+4|0;A=a+-4|0;z=(a|0)<4;B=a&-4;C=Y(y,B)|0;I=h+C|0;H=0;G=k;k=l+C|0;while(1){C=j+((Y(H,m)|0)<<1)|0;M=l+((Y(H,b)|0)<<2)|0;if(c)if(p){N=0;do{n[L+(N<<2)>>2]=+(d[C+(N<<1)>>1]|0)-+n[M>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{P=H;O=22}else if(p){N=0;do{n[L+(N<<2)>>2]=+(d[C+(N<<1)>>1]|0)-+n[M+(N<<2)>>2];N=N+1|0}while((N|0)!=(a|0));O=21}else{Q=H;R=k;O=31}if((O|0)==21){O=0;if(c){P=H;O=22}else{Q=H;R=k;O=31}}if((O|0)==22)while(1){O=0;N=j+((Y(P,m)|0)<<1)|0;M=l+((Y(P,b)|0)<<2)|0;C=f[M>>2]|0;f[x>>2]=C;f[v>>2]=C;f[r>>2]=C;f[h>>2]=C;a:do if(z){S=0.0;T=h;U=0}else{K=0.0;M=h;V=0;F=(f[s>>2]=C,+n[s>>2]);while(1){W=V|1;X=V|2;Z=V|3;E=K+(+n[L+(V<<2)>>2]*(+(d[N+(V<<1)>>1]|0)-F)+ +n[L+(W<<2)>>2]*(+(d[N+(W<<1)>>1]|0)-+n[M+4>>2])+ +n[L+(X<<2)>>2]*(+(d[N+(X<<1)>>1]|0)-+n[M+8>>2])+ +n[L+(Z<<2)>>2]*(+(d[N+(Z<<1)>>1]|0)-+n[M+12>>2]));Z=V+4|0;X=M+(y<<2)|0;if((Z|0)>(A|0)){S=E;T=I;U=B;break a}K=E;M=X;V=Z;F=+n[X>>2]}}while(0);if((U|0)<(a|0)){D=S;C=T;V=U;while(1){F=D+ +n[L+(V<<2)>>2]*(+(d[N+(V<<1)>>1]|0)-+n[C>>2]);V=V+1|0;if((V|0)==(a|0)){_=F;break}else{D=F;C=C+4|0}}}else _=S;n[G+(P<<2)>>2]=_*e;P=P+1|0;if((P|0)==(q|0))break;else O=22}else if((O|0)==31)while(1){O=0;C=j+((Y(Q,m)|0)<<1)|0;V=l+((Y(Q,b)|0)<<2)|0;if(z){$=0.0;aa=V;ba=0}else{D=0.0;N=V;V=0;while(1){M=V|1;X=V|2;Z=V|3;F=D+(+n[L+(V<<2)>>2]*(+(d[C+(V<<1)>>1]|0)-+n[N>>2])+ +n[L+(M<<2)>>2]*(+(d[C+(M<<1)>>1]|0)-+n[N+4>>2])+ +n[L+(X<<2)>>2]*(+(d[C+(X<<1)>>1]|0)-+n[N+8>>2])+ +n[L+(Z<<2)>>2]*(+(d[C+(Z<<1)>>1]|0)-+n[N+12>>2]));V=V+4|0;if((V|0)>(A|0)){$=F;aa=R;ba=B;break}else{D=F;N=N+(y<<2)|0}}}if((ba|0)<(a|0)){D=$;N=aa;V=ba;while(1){F=D+ +n[L+(V<<2)>>2]*(+(d[C+(V<<1)>>1]|0)-+n[N>>2]);V=V+1|0;if((V|0)==(a|0)){ca=F;break}else{D=F;N=N+4|0}}}else ca=$;n[G+(Q<<2)>>2]=ca*e;Q=Q+1|0;if((Q|0)==(q|0))break;else{R=R+(b<<2)|0;O=31}}H=H+1|0;if((H|0)==(q|0))break;else{G=G+(o<<2)|0;k=k+(b<<2)|0}}}if((L|0)!=(t|0)){P5b(L);f[i>>2]=t;f[w>>2]=1032}u=g;return}function hY(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;g=u;u=u+1040|0;h=g;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>1;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=h+8|0;f[h>>2]=c;q=h+4|0;f[q>>2]=1032;r=(k|0)!=0;s=(n|0)<(a|0);n=r&s?o*40|0:o<<3;f[q>>2]=n;if(n>>>0>1032){t=N5b(n)|0;f[h>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{n=k+((Y(A,b)|0)<<3)|0;B=+p[n>>3];n=A<<2;p[t+((n|3)<<3)>>3]=B;p[t+((n|2)<<3)>>3]=B;p[t+((n|1)<<3)>>3]=B;p[t+(n<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=k;y=0;z=b}while(0);if((a|0)>0){n=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=e*0.0;E=e*0.0;F=e*0.0;G=j;H=0;while(1){if(n){if(C){I=0;do{J=i+((Y(I,l)|0)+H<<1)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+(d[J>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=i+((Y(I,l)|0)+H<<1)|0;K=x+((Y(I,z)|0)+H<<3)|0;p[v+(I<<3)>>3]=+(d[t>>1]|0)-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((H|0)>(D|0))L=H;else{if(C)M=H;else{I=H;while(1){p[G+(I<<3)>>3]=F;p[G+(I+1<<3)>>3]=F;p[G+(I+2<<3)>>3]=F;p[G+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=n?y:x+(M<<3)|0;K=i+(M<<1)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+p[v+(t<<3)>>3];Q=Q+R*(+(d[K>>1]|0)-+p[I>>3]);P=P+R*(+(d[K+2>>1]|0)-+p[I+8>>3]);O=O+R*(+(d[K+4>>1]|0)-+p[I+16>>3]);N=N+R*(+(d[K+6>>1]|0)-+p[I+24>>3]);t=t+1|0;if((t|0)==(o|0))break;else{I=I+(z<<3)|0;K=K+(l<<1)|0}}p[G+(M<<3)>>3]=Q*e;p[G+(M+1<<3)>>3]=P*e;p[G+(M+2<<3)>>3]=O*e;p[G+(M+3<<3)>>3]=N*e;K=M+4|0;if((K|0)>(D|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!C)if(n){K=L;while(1){p[G+(K<<3)>>3]=B;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){p[G+(K<<3)>>3]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(n){K=L;do{I=i+(K<<1)|0;R=0.0;t=y;J=0;while(1){R=R+ +p[v+(J<<3)>>3]*(+(d[I>>1]|0)-+p[t>>3]);J=J+1|0;if((J|0)==(o|0))break;else{I=I+(l<<1)|0;t=t+(z<<3)|0}}p[G+(K<<3)>>3]=R*e;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=i+(K<<1)|0;N=0.0;I=x+(K<<3)|0;J=0;while(1){N=N+ +p[v+(J<<3)>>3]*(+(d[t>>1]|0)-+p[I>>3]);J=J+1|0;if((J|0)==(o|0))break;else{t=t+(l<<1)|0;I=I+(z<<3)|0}}p[G+(K<<3)>>3]=N*e;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(m<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=e*0.0;B=e*0.0;x=j;j=0;while(1){if(w){L=0;do{y=i+((Y(L,l)|0)+j<<1)|0;p[v+(L<<3)>>3]=+(d[y>>1]|0);L=L+1|0}while((L|0)!=(o|0))}d:do if((j|0)>(z|0))S=j;else{if(w)T=j;else{L=j;while(1){p[x+(L<<3)>>3]=B;p[x+(L+1<<3)>>3]=B;p[x+(L+2<<3)>>3]=B;p[x+(L+3<<3)>>3]=B;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=i+(T<<1)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+p[v+(y<<3)>>3];P=P+Q*+(d[L>>1]|0);O=O+Q*+(d[L+2>>1]|0);R=R+Q*+(d[L+4>>1]|0);F=F+Q*+(d[L+6>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+(l<<1)|0}p[x+(T<<3)>>3]=P*e;p[x+(T+1<<3)>>3]=O*e;p[x+(T+2<<3)>>3]=R*e;p[x+(T+3<<3)>>3]=F*e;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){p[x+(L<<3)>>3]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=i+(U<<1)|0;Q=0.0;y=0;while(1){Q=Q+ +p[v+(y<<3)>>3]*+(d[L>>1]|0);y=y+1|0;if((y|0)==(o|0))break;else L=L+(l<<1)|0}p[x+(U<<3)>>3]=Q*e;U=U+1|0}while((U|0)!=(a|0))}while(0);j=j+1|0;if((j|0)==(a|0))break;else x=x+(m<<3)|0}}if((v|0)==(c|0)){u=g;return}P5b(v);f[h>>2]=c;f[q>>2]=1032;u=g;return}function iY(a,b,c,e){a=a|0;b=b|0;c=c|0;e=+e;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0;g=u;u=u+1072|0;h=g;i=g+32|0;j=f[a+16>>2]|0;k=f[b+16>>2]|0;l=f[c+16>>2]|0;m=(f[a+48>>2]|0)>>>1;n=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!l){if((q|0)<=0){u=g;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=k;while(1){y=j+((Y(w,m)|0)<<1)|0;if(r){z=w;do{A=j+((Y(z,m)|0)<<1)|0;if(t){B=0;C=0.0;while(1){D=C+ +(d[y+(B<<1)>>1]|0)*+(d[A+(B<<1)>>1]|0);B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*e;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=j+((Y(z,m)|0)<<1)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+(d[y+(A<<1)>>1]|0)*+(d[B+(A<<1)>>1]|0)+ +(d[y+(F<<1)>>1]|0)*+(d[B+(F<<1)>>1]|0)+ +(d[y+(G<<1)>>1]|0)*+(d[B+(G<<1)>>1]|0)+ +(d[y+(H<<1)>>1]|0)*+(d[B+(H<<1)>>1]|0));A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +(d[y+(A<<1)>>1]|0)*+(d[B+(A<<1)>>1]|0);A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*e;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(n<<3)|0}u=g;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=i+8|0;f[i>>2]=s;v=i+4|0;f[v>>2]=w;if(w>>>0>1032){c=N5b(w)|0;f[i>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=h+24|0;t=h+16|0;r=h+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=h+H|0;G=0;F=k;k=l+H|0;while(1){H=j+((Y(G,m)|0)<<1)|0;L=l+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+(d[H+(M<<1)>>1]|0)-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+(d[H+(M<<1)>>1]|0)-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=k;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=k;N=30}}if((N|0)==22)while(1){N=0;M=j+((Y(O,m)|0)<<1)|0;L=l+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[h>>3]=J;a:do if(y){R=0.0;S=h;T=0}else{E=0.0;L=h;H=0;D=J;while(1){U=H|1;V=H|2;W=H|3;I=E+(+p[K+(H<<3)>>3]*(+(d[M+(H<<1)>>1]|0)-D)+ +p[K+(U<<3)>>3]*(+(d[M+(U<<1)>>1]|0)-+p[L+8>>3])+ +p[K+(V<<3)>>3]*(+(d[M+(V<<1)>>1]|0)-+p[L+16>>3])+ +p[K+(W<<3)>>3]*(+(d[M+(W<<1)>>1]|0)-+p[L+24>>3]));W=H+4|0;V=L+(x<<3)|0;if((W|0)>(z|0)){R=I;S=A;T=B;break a}E=I;L=V;H=W;D=+p[V>>3]}}while(0);if((T|0)<(a|0)){J=R;H=S;L=T;while(1){C=J+ +p[K+(L<<3)>>3]*(+(d[M+(L<<1)>>1]|0)-+p[H>>3]);L=L+1|0;if((L|0)==(a|0)){X=C;break}else{J=C;H=H+8|0}}}else X=R;p[F+(O<<3)>>3]=X*e;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;H=j+((Y(P,m)|0)<<1)|0;L=l+((Y(P,b)|0)<<3)|0;if(y){Z=0.0;_=L;$=0}else{J=0.0;M=L;L=0;while(1){V=L|1;W=L|2;U=L|3;C=J+(+p[K+(L<<3)>>3]*(+(d[H+(L<<1)>>1]|0)-+p[M>>3])+ +p[K+(V<<3)>>3]*(+(d[H+(V<<1)>>1]|0)-+p[M+8>>3])+ +p[K+(W<<3)>>3]*(+(d[H+(W<<1)>>1]|0)-+p[M+16>>3])+ +p[K+(U<<3)>>3]*(+(d[H+(U<<1)>>1]|0)-+p[M+24>>3]));L=L+4|0;if((L|0)>(z|0)){Z=C;_=Q;$=B;break}else{J=C;M=M+(x<<3)|0}}}if(($|0)<(a|0)){J=Z;M=_;L=$;while(1){C=J+ +p[K+(L<<3)>>3]*(+(d[H+(L<<1)>>1]|0)-+p[M>>3]);L=L+1|0;if((L|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=Z;p[F+(P<<3)>>3]=aa*e;P=P+1|0;if((P|0)==(q|0))break;else{Q=Q+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(n<<3)|0;k=k+(b<<3)|0}}}if((K|0)!=(s|0)){P5b(K);f[i>>2]=s;f[v>>2]=1032}u=g;return}function jY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;j=f[c+16>>2]|0;k=(f[a+48>>2]|0)>>>2;l=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;m=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;p=g+4|0;f[p>>2]=1032;q=(j|0)!=0;r=(m|0)<(a|0);m=q&r?o*20|0:o<<2;f[p>>2]=m;if(m>>>0>1032){s=N5b(m)|0;f[g>>2]=s;t=s}else t=c;a:do if(q){do if(r){s=t+(o<<2)|0;if((o|0)<=0)if(!s){v=11;break a}else{w=s;x=s;y=b|0?4:0;break}else z=0;do{m=j+((Y(z,b)|0)<<2)|0;A=f[m>>2]|0;m=z<<2;f[s+((m|3)<<2)>>2]=A;f[s+((m|2)<<2)>>2]=A;f[s+((m|1)<<2)>>2]=A;f[s+(m<<2)>>2]=A;z=z+1|0}while((z|0)!=(o|0));w=s;x=s;y=b|0?4:0}else{w=j;x=0;y=b}while(0);if((a|0)>0){A=(x|0)!=0;m=(o|0)>0;B=a+-4|0;C=d*0.0;D=d*0.0;E=d*0.0;F=i;G=0;while(1){if(A){if(m){H=0;do{I=h+((Y(H,k)|0)+G<<2)|0;J=x+((Y(H,y)|0)<<2)|0;n[t+(H<<2)>>2]=+n[I>>2]-+n[J>>2];H=H+1|0}while((H|0)!=(o|0))}}else if(m){H=0;do{s=h+((Y(H,k)|0)+G<<2)|0;J=w+((Y(H,y)|0)+G<<2)|0;n[t+(H<<2)>>2]=+n[s>>2]-+n[J>>2];H=H+1|0}while((H|0)!=(o|0))}b:do if((G|0)>(B|0))K=G;else{if(m)L=G;else{H=G;while(1){n[F+(H<<2)>>2]=E;n[F+(H+1<<2)>>2]=E;n[F+(H+2<<2)>>2]=E;n[F+(H+3<<2)>>2]=E;J=H+4|0;if((J|0)>(B|0)){K=J;break b}else H=J}}while(1){H=A?x:w+(L<<2)|0;J=h+(L<<2)|0;M=0.0;N=0.0;O=0.0;P=0.0;s=0;while(1){Q=+n[t+(s<<2)>>2];P=P+Q*(+n[J>>2]-+n[H>>2]);O=O+Q*(+n[J+4>>2]-+n[H+4>>2]);N=N+Q*(+n[J+8>>2]-+n[H+8>>2]);M=M+Q*(+n[J+12>>2]-+n[H+12>>2]);s=s+1|0;if((s|0)==(o|0))break;else{H=H+(y<<2)|0;J=J+(k<<2)|0}}n[F+(L<<2)>>2]=P*d;n[F+(L+1<<2)>>2]=O*d;n[F+(L+2<<2)>>2]=N*d;n[F+(L+3<<2)>>2]=M*d;J=L+4|0;if((J|0)>(B|0)){K=J;break}else L=J}}while(0);c:do if((K|0)<(a|0)){if(!m)if(A){J=K;while(1){n[F+(J<<2)>>2]=C;J=J+1|0;if((J|0)==(a|0))break c}}else{J=K;while(1){n[F+(J<<2)>>2]=D;J=J+1|0;if((J|0)==(a|0))break c}}if(A){J=K;do{H=h+(J<<2)|0;Q=0.0;s=x;I=0;while(1){Q=Q+ +n[t+(I<<2)>>2]*(+n[H>>2]-+n[s>>2]);I=I+1|0;if((I|0)==(o|0))break;else{H=H+(k<<2)|0;s=s+(y<<2)|0}}n[F+(J<<2)>>2]=Q*d;J=J+1|0}while((J|0)!=(a|0))}else{J=K;do{s=h+(J<<2)|0;M=0.0;H=w+(J<<2)|0;I=0;while(1){M=M+ +n[t+(I<<2)>>2]*(+n[s>>2]-+n[H>>2]);I=I+1|0;if((I|0)==(o|0))break;else{s=s+(k<<2)|0;H=H+(y<<2)|0}}n[F+(J<<2)>>2]=M*d;J=J+1|0}while((J|0)!=(a|0))}}while(0);G=G+1|0;if((G|0)==(a|0))break;else F=F+(l<<2)|0}}}else v=11;while(0);if((v|0)==11?(a|0)>0:0){v=(o|0)>0;y=a+-4|0;D=d*0.0;C=d*0.0;w=i;i=0;while(1){if(v){K=0;do{x=h+((Y(K,k)|0)+i<<2)|0;f[t+(K<<2)>>2]=f[x>>2];K=K+1|0}while((K|0)!=(o|0))}d:do if((i|0)>(y|0))R=i;else{if(v)S=i;else{K=i;while(1){n[w+(K<<2)>>2]=C;n[w+(K+1<<2)>>2]=C;n[w+(K+2<<2)>>2]=C;n[w+(K+3<<2)>>2]=C;x=K+4|0;if((x|0)>(y|0)){R=x;break d}else K=x}}while(1){K=h+(S<<2)|0;E=0.0;Q=0.0;N=0.0;O=0.0;x=0;while(1){P=+n[t+(x<<2)>>2];O=O+P*+n[K>>2];N=N+P*+n[K+4>>2];Q=Q+P*+n[K+8>>2];E=E+P*+n[K+12>>2];x=x+1|0;if((x|0)==(o|0))break;else K=K+(k<<2)|0}n[w+(S<<2)>>2]=O*d;n[w+(S+1<<2)>>2]=N*d;n[w+(S+2<<2)>>2]=Q*d;n[w+(S+3<<2)>>2]=E*d;K=S+4|0;if((K|0)>(y|0)){R=K;break}else S=K}}while(0);e:do if((R|0)<(a|0)){if(v)T=R;else{K=R;while(1){n[w+(K<<2)>>2]=D;K=K+1|0;if((K|0)==(a|0))break e}}do{K=h+(T<<2)|0;P=0.0;x=0;while(1){P=P+ +n[t+(x<<2)>>2]*+n[K>>2];x=x+1|0;if((x|0)==(o|0))break;else K=K+(k<<2)|0}n[w+(T<<2)>>2]=P*d;T=T+1|0}while((T|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else w=w+(l<<2)|0}}if((t|0)==(c|0)){u=e;return}P5b(t);f[g>>2]=c;f[p>>2]=1032;u=e;return}function kY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0.0,_=0.0,$=0,aa=0,ba=0.0;e=u;u=u+1056|0;g=e+1040|0;h=e;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>2;m=(f[b+48>>2]|0)>>>2;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>2:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;p=f[c>>2]|0;if(!k){if((p|0)<=0){u=e;return}c=a+-4|0;q=(a|0)<4;r=a&-4;t=(a|0)>0;v=(r|0)<(a|0);w=0;x=j;while(1){y=i+((Y(w,l)|0)<<2)|0;if(q){z=w;do{A=i+((Y(z,l)|0)<<2)|0;if(t){B=0;C=0.0;while(1){D=C+ +n[y+(B<<2)>>2]*+n[A+(B<<2)>>2];B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;n[x+(z<<2)>>2]=E*d;z=z+1|0}while((z|0)!=(p|0))}else{z=w;do{B=i+((Y(z,l)|0)<<2)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+n[y+(A<<2)>>2]*+n[B+(A<<2)>>2]+ +n[y+(F<<2)>>2]*+n[B+(F<<2)>>2]+ +n[y+(G<<2)>>2]*+n[B+(G<<2)>>2]+ +n[y+(H<<2)>>2]*+n[B+(H<<2)>>2]);A=A+4|0}while((A|0)<=(c|0));if(v){A=r;D=C;while(1){I=D+ +n[y+(A<<2)>>2]*+n[B+(A<<2)>>2];A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;n[x+(z<<2)>>2]=J*d;z=z+1|0}while((z|0)!=(p|0))}w=w+1|0;if((w|0)==(p|0))break;else x=x+(m<<2)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<2;r=h+8|0;f[h>>2]=r;v=h+4|0;f[v>>2]=w;if(w>>>0>1032){c=N5b(w)|0;f[h>>2]=c;K=c}else K=r;if((p|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+12|0;t=g+8|0;q=g+4|0;z=a+-4|0;y=(a|0)<4;A=a&-4;B=Y(x,A)|0;H=g+B|0;G=0;F=j;j=k+B|0;while(1){B=i+((Y(G,l)|0)<<2)|0;L=k+((Y(G,b)|0)<<2)|0;if(c)if(o){M=0;do{n[K+(M<<2)>>2]=+n[B+(M<<2)>>2]-+n[L>>2];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{n[K+(M<<2)>>2]=+n[B+(M<<2)>>2]-+n[L+(M<<2)>>2];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=j;N=31}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=j;N=31}}if((N|0)==22)while(1){N=0;M=i+((Y(O,l)|0)<<2)|0;L=k+((Y(O,b)|0)<<2)|0;B=f[L>>2]|0;f[w>>2]=B;f[t>>2]=B;f[q>>2]=B;f[g>>2]=B;a:do if(y){R=0.0;S=g;T=0}else{J=0.0;L=g;U=0;E=(f[s>>2]=B,+n[s>>2]);while(1){V=U|1;W=U|2;X=U|3;D=J+(+n[K+(U<<2)>>2]*(+n[M+(U<<2)>>2]-E)+ +n[K+(V<<2)>>2]*(+n[M+(V<<2)>>2]-+n[L+4>>2])+ +n[K+(W<<2)>>2]*(+n[M+(W<<2)>>2]-+n[L+8>>2])+ +n[K+(X<<2)>>2]*(+n[M+(X<<2)>>2]-+n[L+12>>2]));X=U+4|0;W=L+(x<<2)|0;if((X|0)>(z|0)){R=D;S=H;T=A;break a}J=D;L=W;U=X;E=+n[W>>2]}}while(0);if((T|0)<(a|0)){C=R;B=S;U=T;while(1){E=C+ +n[K+(U<<2)>>2]*(+n[M+(U<<2)>>2]-+n[B>>2]);U=U+1|0;if((U|0)==(a|0)){Z=E;break}else{C=E;B=B+4|0}}}else Z=R;n[F+(O<<2)>>2]=Z*d;O=O+1|0;if((O|0)==(p|0))break;else N=22}else if((N|0)==31)while(1){N=0;B=i+((Y(P,l)|0)<<2)|0;U=k+((Y(P,b)|0)<<2)|0;if(y){_=0.0;$=U;aa=0}else{C=0.0;M=U;U=0;while(1){L=U|1;W=U|2;X=U|3;E=C+(+n[K+(U<<2)>>2]*(+n[B+(U<<2)>>2]-+n[M>>2])+ +n[K+(L<<2)>>2]*(+n[B+(L<<2)>>2]-+n[M+4>>2])+ +n[K+(W<<2)>>2]*(+n[B+(W<<2)>>2]-+n[M+8>>2])+ +n[K+(X<<2)>>2]*(+n[B+(X<<2)>>2]-+n[M+12>>2]));U=U+4|0;if((U|0)>(z|0)){_=E;$=Q;aa=A;break}else{C=E;M=M+(x<<2)|0}}}if((aa|0)<(a|0)){C=_;M=$;U=aa;while(1){E=C+ +n[K+(U<<2)>>2]*(+n[B+(U<<2)>>2]-+n[M>>2]);U=U+1|0;if((U|0)==(a|0)){ba=E;break}else{C=E;M=M+4|0}}}else ba=_;n[F+(P<<2)>>2]=ba*d;P=P+1|0;if((P|0)==(p|0))break;else{Q=Q+(b<<2)|0;N=31}}G=G+1|0;if((G|0)==(p|0))break;else{F=F+(m<<2)|0;j=j+(b<<2)|0}}}if((K|0)!=(r|0)){P5b(K);f[h>>2]=r;f[v>>2]=1032}u=e;return}function lY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;j=f[c+16>>2]|0;k=(f[a+48>>2]|0)>>>2;l=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;m=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;c=g+8|0;f[g>>2]=c;q=g+4|0;f[q>>2]=1032;r=(j|0)!=0;s=(m|0)<(a|0);m=r&s?o*40|0:o<<3;f[q>>2]=m;if(m>>>0>1032){t=N5b(m)|0;f[g>>2]=t;v=t}else v=c;a:do if(r){do if(s){t=v+(o<<3)|0;if((o|0)<=0)if(!t){w=11;break a}else{x=t;y=t;z=b|0?4:0;break}else A=0;do{m=j+((Y(A,b)|0)<<3)|0;B=+p[m>>3];m=A<<2;p[t+((m|3)<<3)>>3]=B;p[t+((m|2)<<3)>>3]=B;p[t+((m|1)<<3)>>3]=B;p[t+(m<<3)>>3]=B;A=A+1|0}while((A|0)!=(o|0));x=t;y=t;z=b|0?4:0}else{x=j;y=0;z=b}while(0);if((a|0)>0){m=(y|0)!=0;C=(o|0)>0;D=a+-4|0;B=d*0.0;E=d*0.0;F=d*0.0;G=i;H=0;while(1){if(m){if(C){I=0;do{J=h+((Y(I,k)|0)+H<<2)|0;K=y+((Y(I,z)|0)<<3)|0;p[v+(I<<3)>>3]=+n[J>>2]-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}}else if(C){I=0;do{t=h+((Y(I,k)|0)+H<<2)|0;K=x+((Y(I,z)|0)+H<<3)|0;p[v+(I<<3)>>3]=+n[t>>2]-+p[K>>3];I=I+1|0}while((I|0)!=(o|0))}b:do if((H|0)>(D|0))L=H;else{if(C)M=H;else{I=H;while(1){p[G+(I<<3)>>3]=F;p[G+(I+1<<3)>>3]=F;p[G+(I+2<<3)>>3]=F;p[G+(I+3<<3)>>3]=F;K=I+4|0;if((K|0)>(D|0)){L=K;break b}else I=K}}while(1){I=m?y:x+(M<<3)|0;K=h+(M<<2)|0;N=0.0;O=0.0;P=0.0;Q=0.0;t=0;while(1){R=+p[v+(t<<3)>>3];Q=Q+R*(+n[K>>2]-+p[I>>3]);P=P+R*(+n[K+4>>2]-+p[I+8>>3]);O=O+R*(+n[K+8>>2]-+p[I+16>>3]);N=N+R*(+n[K+12>>2]-+p[I+24>>3]);t=t+1|0;if((t|0)==(o|0))break;else{I=I+(z<<3)|0;K=K+(k<<2)|0}}p[G+(M<<3)>>3]=Q*d;p[G+(M+1<<3)>>3]=P*d;p[G+(M+2<<3)>>3]=O*d;p[G+(M+3<<3)>>3]=N*d;K=M+4|0;if((K|0)>(D|0)){L=K;break}else M=K}}while(0);c:do if((L|0)<(a|0)){if(!C)if(m){K=L;while(1){p[G+(K<<3)>>3]=B;K=K+1|0;if((K|0)==(a|0))break c}}else{K=L;while(1){p[G+(K<<3)>>3]=E;K=K+1|0;if((K|0)==(a|0))break c}}if(m){K=L;do{I=h+(K<<2)|0;R=0.0;t=y;J=0;while(1){R=R+ +p[v+(J<<3)>>3]*(+n[I>>2]-+p[t>>3]);J=J+1|0;if((J|0)==(o|0))break;else{I=I+(k<<2)|0;t=t+(z<<3)|0}}p[G+(K<<3)>>3]=R*d;K=K+1|0}while((K|0)!=(a|0))}else{K=L;do{t=h+(K<<2)|0;N=0.0;I=x+(K<<3)|0;J=0;while(1){N=N+ +p[v+(J<<3)>>3]*(+n[t>>2]-+p[I>>3]);J=J+1|0;if((J|0)==(o|0))break;else{t=t+(k<<2)|0;I=I+(z<<3)|0}}p[G+(K<<3)>>3]=N*d;K=K+1|0}while((K|0)!=(a|0))}}while(0);H=H+1|0;if((H|0)==(a|0))break;else G=G+(l<<3)|0}}}else w=11;while(0);if((w|0)==11?(a|0)>0:0){w=(o|0)>0;z=a+-4|0;E=d*0.0;B=d*0.0;x=i;i=0;while(1){if(w){L=0;do{y=h+((Y(L,k)|0)+i<<2)|0;p[v+(L<<3)>>3]=+n[y>>2];L=L+1|0}while((L|0)!=(o|0))}d:do if((i|0)>(z|0))S=i;else{if(w)T=i;else{L=i;while(1){p[x+(L<<3)>>3]=B;p[x+(L+1<<3)>>3]=B;p[x+(L+2<<3)>>3]=B;p[x+(L+3<<3)>>3]=B;y=L+4|0;if((y|0)>(z|0)){S=y;break d}else L=y}}while(1){L=h+(T<<2)|0;F=0.0;R=0.0;O=0.0;P=0.0;y=0;while(1){Q=+p[v+(y<<3)>>3];P=P+Q*+n[L>>2];O=O+Q*+n[L+4>>2];R=R+Q*+n[L+8>>2];F=F+Q*+n[L+12>>2];y=y+1|0;if((y|0)==(o|0))break;else L=L+(k<<2)|0}p[x+(T<<3)>>3]=P*d;p[x+(T+1<<3)>>3]=O*d;p[x+(T+2<<3)>>3]=R*d;p[x+(T+3<<3)>>3]=F*d;L=T+4|0;if((L|0)>(z|0)){S=L;break}else T=L}}while(0);e:do if((S|0)<(a|0)){if(w)U=S;else{L=S;while(1){p[x+(L<<3)>>3]=E;L=L+1|0;if((L|0)==(a|0))break e}}do{L=h+(U<<2)|0;Q=0.0;y=0;while(1){Q=Q+ +p[v+(y<<3)>>3]*+n[L>>2];y=y+1|0;if((y|0)==(o|0))break;else L=L+(k<<2)|0}p[x+(U<<3)>>3]=Q*d;U=U+1|0}while((U|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else x=x+(l<<3)|0}}if((v|0)==(c|0)){u=e;return}P5b(v);f[g>>2]=c;f[q>>2]=1032;u=e;return}function mY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0,$=0,aa=0.0;e=u;u=u+1072|0;g=e;h=e+32|0;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>2;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;o=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;q=f[c>>2]|0;if(!k){if((q|0)<=0){u=e;return}c=a+-4|0;r=(a|0)<4;s=a&-4;t=(a|0)>0;v=(s|0)<(a|0);w=0;x=j;while(1){y=i+((Y(w,l)|0)<<2)|0;if(r){z=w;do{A=i+((Y(z,l)|0)<<2)|0;if(t){B=0;C=0.0;while(1){D=C+ +n[y+(B<<2)>>2]*+n[A+(B<<2)>>2];B=B+1|0;if((B|0)==(a|0)){E=D;break}else C=D}}else E=0.0;p[x+(z<<3)>>3]=E*d;z=z+1|0}while((z|0)!=(q|0))}else{z=w;do{B=i+((Y(z,l)|0)<<2)|0;A=0;C=0.0;do{F=A|1;G=A|2;H=A|3;C=C+(+n[y+(A<<2)>>2]*+n[B+(A<<2)>>2]+ +n[y+(F<<2)>>2]*+n[B+(F<<2)>>2]+ +n[y+(G<<2)>>2]*+n[B+(G<<2)>>2]+ +n[y+(H<<2)>>2]*+n[B+(H<<2)>>2]);A=A+4|0}while((A|0)<=(c|0));if(v){A=s;D=C;while(1){I=D+ +n[y+(A<<2)>>2]*+n[B+(A<<2)>>2];A=A+1|0;if((A|0)==(a|0)){J=I;break}else D=I}}else J=C;p[x+(z<<3)>>3]=J*d;z=z+1|0}while((z|0)!=(q|0))}w=w+1|0;if((w|0)==(q|0))break;else x=x+(m<<3)|0}u=e;return}x=(o|0)==(a|0)?4:0;w=a<<3;s=h+8|0;f[h>>2]=s;v=h+4|0;f[v>>2]=w;if(w>>>0>1032){c=N5b(w)|0;f[h>>2]=c;K=c}else K=s;if((q|0)>0){c=(o|0)<(a|0);o=(a|0)>0;w=g+24|0;t=g+16|0;r=g+8|0;z=a+-4|0;y=(a|0)<4;A=z>>>2;B=(A<<2)+4|0;H=Y(x,(A<<3)+8|0)|0;A=g+H|0;G=0;F=j;j=k+H|0;while(1){H=i+((Y(G,l)|0)<<2)|0;L=k+((Y(G,b)|0)<<3)|0;if(c)if(o){M=0;do{p[K+(M<<3)>>3]=+n[H+(M<<2)>>2]-+p[L>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{O=G;N=22}else if(o){M=0;do{p[K+(M<<3)>>3]=+n[H+(M<<2)>>2]-+p[L+(M<<3)>>3];M=M+1|0}while((M|0)!=(a|0));N=21}else{P=G;Q=j;N=30}if((N|0)==21){N=0;if(c){O=G;N=22}else{P=G;Q=j;N=30}}if((N|0)==22)while(1){N=0;M=i+((Y(O,l)|0)<<2)|0;L=k+((Y(O,b)|0)<<3)|0;J=+p[L>>3];p[w>>3]=J;p[t>>3]=J;p[r>>3]=J;p[g>>3]=J;a:do if(y){R=0.0;S=g;T=0}else{E=0.0;L=g;H=0;D=J;while(1){U=H|1;V=H|2;W=H|3;I=E+(+p[K+(H<<3)>>3]*(+n[M+(H<<2)>>2]-D)+ +p[K+(U<<3)>>3]*(+n[M+(U<<2)>>2]-+p[L+8>>3])+ +p[K+(V<<3)>>3]*(+n[M+(V<<2)>>2]-+p[L+16>>3])+ +p[K+(W<<3)>>3]*(+n[M+(W<<2)>>2]-+p[L+24>>3]));W=H+4|0;V=L+(x<<3)|0;if((W|0)>(z|0)){R=I;S=A;T=B;break a}E=I;L=V;H=W;D=+p[V>>3]}}while(0);if((T|0)<(a|0)){J=R;H=S;L=T;while(1){C=J+ +p[K+(L<<3)>>3]*(+n[M+(L<<2)>>2]-+p[H>>3]);L=L+1|0;if((L|0)==(a|0)){X=C;break}else{J=C;H=H+8|0}}}else X=R;p[F+(O<<3)>>3]=X*d;O=O+1|0;if((O|0)==(q|0))break;else N=22}else if((N|0)==30)while(1){N=0;H=i+((Y(P,l)|0)<<2)|0;L=k+((Y(P,b)|0)<<3)|0;if(y){Z=0.0;_=L;$=0}else{J=0.0;M=L;L=0;while(1){V=L|1;W=L|2;U=L|3;C=J+(+p[K+(L<<3)>>3]*(+n[H+(L<<2)>>2]-+p[M>>3])+ +p[K+(V<<3)>>3]*(+n[H+(V<<2)>>2]-+p[M+8>>3])+ +p[K+(W<<3)>>3]*(+n[H+(W<<2)>>2]-+p[M+16>>3])+ +p[K+(U<<3)>>3]*(+n[H+(U<<2)>>2]-+p[M+24>>3]));L=L+4|0;if((L|0)>(z|0)){Z=C;_=Q;$=B;break}else{J=C;M=M+(x<<3)|0}}}if(($|0)<(a|0)){J=Z;M=_;L=$;while(1){C=J+ +p[K+(L<<3)>>3]*(+n[H+(L<<2)>>2]-+p[M>>3]);L=L+1|0;if((L|0)==(a|0)){aa=C;break}else{J=C;M=M+8|0}}}else aa=Z;p[F+(P<<3)>>3]=aa*d;P=P+1|0;if((P|0)==(q|0))break;else{Q=Q+(b<<3)|0;N=30}}G=G+1|0;if((G|0)==(q|0))break;else{F=F+(m<<3)|0;j=j+(b<<3)|0}}}if((K|0)!=(s|0)){P5b(K);f[h>>2]=s;f[v>>2]=1032}u=e;return}function nY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0;e=u;u=u+1040|0;g=e;h=f[a+16>>2]|0;i=f[b+16>>2]|0;j=f[c+16>>2]|0;k=(f[a+48>>2]|0)>>>3;l=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;m=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;n=f[c>>2]|0;c=g+8|0;f[g>>2]=c;o=g+4|0;f[o>>2]=1032;q=(j|0)!=0;r=(m|0)<(a|0);m=q&r?n*40|0:n<<3;f[o>>2]=m;if(m>>>0>1032){s=N5b(m)|0;f[g>>2]=s;t=s}else t=c;a:do if(q){do if(r){s=t+(n<<3)|0;if((n|0)<=0)if(!s){v=11;break a}else{w=s;x=s;y=b|0?4:0;break}else z=0;do{m=j+((Y(z,b)|0)<<3)|0;A=+p[m>>3];m=z<<2;p[s+((m|3)<<3)>>3]=A;p[s+((m|2)<<3)>>3]=A;p[s+((m|1)<<3)>>3]=A;p[s+(m<<3)>>3]=A;z=z+1|0}while((z|0)!=(n|0));w=s;x=s;y=b|0?4:0}else{w=j;x=0;y=b}while(0);if((a|0)>0){m=(x|0)!=0;B=(n|0)>0;C=a+-4|0;A=d*0.0;D=d*0.0;E=d*0.0;F=i;G=0;while(1){if(m){if(B){H=0;do{I=h+((Y(H,k)|0)+G<<3)|0;J=x+((Y(H,y)|0)<<3)|0;p[t+(H<<3)>>3]=+p[I>>3]-+p[J>>3];H=H+1|0}while((H|0)!=(n|0))}}else if(B){H=0;do{s=h+((Y(H,k)|0)+G<<3)|0;J=w+((Y(H,y)|0)+G<<3)|0;p[t+(H<<3)>>3]=+p[s>>3]-+p[J>>3];H=H+1|0}while((H|0)!=(n|0))}b:do if((G|0)>(C|0))K=G;else{if(B)L=G;else{H=G;while(1){p[F+(H<<3)>>3]=E;p[F+(H+1<<3)>>3]=E;p[F+(H+2<<3)>>3]=E;p[F+(H+3<<3)>>3]=E;J=H+4|0;if((J|0)>(C|0)){K=J;break b}else H=J}}while(1){H=m?x:w+(L<<3)|0;J=h+(L<<3)|0;M=0.0;N=0.0;O=0.0;P=0.0;s=0;while(1){Q=+p[t+(s<<3)>>3];P=P+Q*(+p[J>>3]-+p[H>>3]);O=O+Q*(+p[J+8>>3]-+p[H+8>>3]);N=N+Q*(+p[J+16>>3]-+p[H+16>>3]);M=M+Q*(+p[J+24>>3]-+p[H+24>>3]);s=s+1|0;if((s|0)==(n|0))break;else{H=H+(y<<3)|0;J=J+(k<<3)|0}}p[F+(L<<3)>>3]=P*d;p[F+(L+1<<3)>>3]=O*d;p[F+(L+2<<3)>>3]=N*d;p[F+(L+3<<3)>>3]=M*d;J=L+4|0;if((J|0)>(C|0)){K=J;break}else L=J}}while(0);c:do if((K|0)<(a|0)){if(!B)if(m){J=K;while(1){p[F+(J<<3)>>3]=A;J=J+1|0;if((J|0)==(a|0))break c}}else{J=K;while(1){p[F+(J<<3)>>3]=D;J=J+1|0;if((J|0)==(a|0))break c}}if(m){J=K;do{H=h+(J<<3)|0;Q=0.0;s=x;I=0;while(1){Q=Q+ +p[t+(I<<3)>>3]*(+p[H>>3]-+p[s>>3]);I=I+1|0;if((I|0)==(n|0))break;else{H=H+(k<<3)|0;s=s+(y<<3)|0}}p[F+(J<<3)>>3]=Q*d;J=J+1|0}while((J|0)!=(a|0))}else{J=K;do{s=h+(J<<3)|0;M=0.0;H=w+(J<<3)|0;I=0;while(1){M=M+ +p[t+(I<<3)>>3]*(+p[s>>3]-+p[H>>3]);I=I+1|0;if((I|0)==(n|0))break;else{s=s+(k<<3)|0;H=H+(y<<3)|0}}p[F+(J<<3)>>3]=M*d;J=J+1|0}while((J|0)!=(a|0))}}while(0);G=G+1|0;if((G|0)==(a|0))break;else F=F+(l<<3)|0}}}else v=11;while(0);if((v|0)==11?(a|0)>0:0){v=(n|0)>0;y=a+-4|0;D=d*0.0;A=d*0.0;w=i;i=0;while(1){if(v){K=0;do{x=h+((Y(K,k)|0)+i<<3)|0;p[t+(K<<3)>>3]=+p[x>>3];K=K+1|0}while((K|0)!=(n|0))}d:do if((i|0)>(y|0))R=i;else{if(v)S=i;else{K=i;while(1){p[w+(K<<3)>>3]=A;p[w+(K+1<<3)>>3]=A;p[w+(K+2<<3)>>3]=A;p[w+(K+3<<3)>>3]=A;x=K+4|0;if((x|0)>(y|0)){R=x;break d}else K=x}}while(1){K=h+(S<<3)|0;E=0.0;Q=0.0;N=0.0;O=0.0;x=0;while(1){P=+p[t+(x<<3)>>3];O=O+P*+p[K>>3];N=N+P*+p[K+8>>3];Q=Q+P*+p[K+16>>3];E=E+P*+p[K+24>>3];x=x+1|0;if((x|0)==(n|0))break;else K=K+(k<<3)|0}p[w+(S<<3)>>3]=O*d;p[w+(S+1<<3)>>3]=N*d;p[w+(S+2<<3)>>3]=Q*d;p[w+(S+3<<3)>>3]=E*d;K=S+4|0;if((K|0)>(y|0)){R=K;break}else S=K}}while(0);e:do if((R|0)<(a|0)){if(v)T=R;else{K=R;while(1){p[w+(K<<3)>>3]=D;K=K+1|0;if((K|0)==(a|0))break e}}do{K=h+(T<<3)|0;P=0.0;x=0;while(1){P=P+ +p[t+(x<<3)>>3]*+p[K>>3];x=x+1|0;if((x|0)==(n|0))break;else K=K+(k<<3)|0}p[w+(T<<3)>>3]=P*d;T=T+1|0}while((T|0)!=(a|0))}while(0);i=i+1|0;if((i|0)==(a|0))break;else w=w+(l<<3)|0}}if((t|0)==(c|0)){u=e;return}P5b(t);f[g>>2]=c;f[o>>2]=1032;u=e;return}function oY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Z=0,_=0,$=0.0;e=u;u=u+1072|0;g=e;h=e+32|0;i=f[a+16>>2]|0;j=f[b+16>>2]|0;k=f[c+16>>2]|0;l=(f[a+48>>2]|0)>>>3;m=(f[b+48>>2]|0)>>>3;b=(f[c+8>>2]|0)>1?(f[c+48>>2]|0)>>>3:0;n=f[c+12>>2]|0;c=f[a+40>>2]|0;a=f[c+4>>2]|0;o=f[c>>2]|0;if(!k){if((o|0)<=0){u=e;return}c=a+-4|0;q=(a|0)<4;r=a&-4;s=(a|0)>0;t=(r|0)<(a|0);v=0;w=j;while(1){x=i+((Y(v,l)|0)<<3)|0;if(q){y=v;do{z=i+((Y(y,l)|0)<<3)|0;if(s){A=0;B=0.0;while(1){C=B+ +p[x+(A<<3)>>3]*+p[z+(A<<3)>>3];A=A+1|0;if((A|0)==(a|0)){D=C;break}else B=C}}else D=0.0;p[w+(y<<3)>>3]=D*d;y=y+1|0}while((y|0)!=(o|0))}else{y=v;do{A=i+((Y(y,l)|0)<<3)|0;z=0;B=0.0;do{E=z|1;F=z|2;G=z|3;B=B+(+p[x+(z<<3)>>3]*+p[A+(z<<3)>>3]+ +p[x+(E<<3)>>3]*+p[A+(E<<3)>>3]+ +p[x+(F<<3)>>3]*+p[A+(F<<3)>>3]+ +p[x+(G<<3)>>3]*+p[A+(G<<3)>>3]);z=z+4|0}while((z|0)<=(c|0));if(t){z=r;C=B;while(1){H=C+ +p[x+(z<<3)>>3]*+p[A+(z<<3)>>3];z=z+1|0;if((z|0)==(a|0)){I=H;break}else C=H}}else I=B;p[w+(y<<3)>>3]=I*d;y=y+1|0}while((y|0)!=(o|0))}v=v+1|0;if((v|0)==(o|0))break;else w=w+(m<<3)|0}u=e;return}w=(n|0)==(a|0)?4:0;v=a<<3;r=h+8|0;f[h>>2]=r;t=h+4|0;f[t>>2]=v;if(v>>>0>1032){c=N5b(v)|0;f[h>>2]=c;J=c}else J=r;if((o|0)>0){c=(n|0)<(a|0);n=(a|0)>0;v=g+24|0;s=g+16|0;q=g+8|0;y=a+-4|0;x=(a|0)<4;z=y>>>2;A=(z<<2)+4|0;G=Y(w,(z<<3)+8|0)|0;z=g+G|0;F=0;E=j;j=k+G|0;while(1){G=i+((Y(F,l)|0)<<3)|0;K=k+((Y(F,b)|0)<<3)|0;if(c)if(n){L=0;do{p[J+(L<<3)>>3]=+p[G+(L<<3)>>3]-+p[K>>3];L=L+1|0}while((L|0)!=(a|0));M=21}else{N=F;M=22}else if(n){L=0;do{p[J+(L<<3)>>3]=+p[G+(L<<3)>>3]-+p[K+(L<<3)>>3];L=L+1|0}while((L|0)!=(a|0));M=21}else{O=F;P=j;M=30}if((M|0)==21){M=0;if(c){N=F;M=22}else{O=F;P=j;M=30}}if((M|0)==22)while(1){M=0;L=i+((Y(N,l)|0)<<3)|0;K=k+((Y(N,b)|0)<<3)|0;I=+p[K>>3];p[v>>3]=I;p[s>>3]=I;p[q>>3]=I;p[g>>3]=I;a:do if(x){Q=0.0;R=g;S=0}else{D=0.0;K=g;G=0;C=I;while(1){T=G|1;U=G|2;V=G|3;H=D+(+p[J+(G<<3)>>3]*(+p[L+(G<<3)>>3]-C)+ +p[J+(T<<3)>>3]*(+p[L+(T<<3)>>3]-+p[K+8>>3])+ +p[J+(U<<3)>>3]*(+p[L+(U<<3)>>3]-+p[K+16>>3])+ +p[J+(V<<3)>>3]*(+p[L+(V<<3)>>3]-+p[K+24>>3]));V=G+4|0;U=K+(w<<3)|0;if((V|0)>(y|0)){Q=H;R=z;S=A;break a}D=H;K=U;G=V;C=+p[U>>3]}}while(0);if((S|0)<(a|0)){I=Q;G=R;K=S;while(1){B=I+ +p[J+(K<<3)>>3]*(+p[L+(K<<3)>>3]-+p[G>>3]);K=K+1|0;if((K|0)==(a|0)){W=B;break}else{I=B;G=G+8|0}}}else W=Q;p[E+(N<<3)>>3]=W*d;N=N+1|0;if((N|0)==(o|0))break;else M=22}else if((M|0)==30)while(1){M=0;G=i+((Y(O,l)|0)<<3)|0;K=k+((Y(O,b)|0)<<3)|0;if(x){X=0.0;Z=K;_=0}else{I=0.0;L=K;K=0;while(1){U=K|1;V=K|2;T=K|3;B=I+(+p[J+(K<<3)>>3]*(+p[G+(K<<3)>>3]-+p[L>>3])+ +p[J+(U<<3)>>3]*(+p[G+(U<<3)>>3]-+p[L+8>>3])+ +p[J+(V<<3)>>3]*(+p[G+(V<<3)>>3]-+p[L+16>>3])+ +p[J+(T<<3)>>3]*(+p[G+(T<<3)>>3]-+p[L+24>>3]));K=K+4|0;if((K|0)>(y|0)){X=B;Z=P;_=A;break}else{I=B;L=L+(w<<3)|0}}}if((_|0)<(a|0)){I=X;L=Z;K=_;while(1){B=I+ +p[J+(K<<3)>>3]*(+p[G+(K<<3)>>3]-+p[L>>3]);K=K+1|0;if((K|0)==(a|0)){$=B;break}else{I=B;L=L+8|0}}}else $=X;p[E+(O<<3)>>3]=$*d;O=O+1|0;if((O|0)==(o|0))break;else{P=P+(b<<3)|0;M=30}}F=F+1|0;if((F|0)==(o|0))break;else{E=E+(m<<3)|0;j=j+(b<<3)|0}}}if((J|0)!=(r|0)){P5b(J);f[h>>2]=r;f[t>>2]=1032}u=e;return}function pY(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0;d=u;u=u+128|0;e=d+112|0;g=d+56|0;h=d+40|0;i=d+32|0;j=d;dQ(e,47404);do if((yM(c)|0)==65536){k=f[c+4>>2]|0;f[g>>2]=f[k>>2];l=g+4|0;m=k+4|0;f[l>>2]=f[m>>2];n=g+8|0;f[n>>2]=f[k+8>>2];f[g+12>>2]=f[k+12>>2];f[g+16>>2]=f[k+16>>2];f[g+20>>2]=f[k+20>>2];f[g+24>>2]=f[k+24>>2];f[g+28>>2]=f[k+28>>2];f[g+32>>2]=f[k+32>>2];o=f[k+36>>2]|0;f[g+36>>2]=o;f[g+40>>2]=n;n=g+48|0;p=g+44|0;f[p>>2]=n;f[n>>2]=0;f[g+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[m>>2]|0)<3){m=f[k+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[m>>2];f[n+4>>2]=f[m+4>>2];q=g;break}else{f[l>>2]=0;jL(g,k);q=g;break}}else{yL(g,c,-1);q=g}while(0);c=f[a>>2]|0;k=(c>>>3&511)+1|0;l=c&7;m=f[47424+(l<<2)>>2]|0;if((f[q>>2]^c)&4095|0){f[h>>2]=0;f[h+4>>2]=0;r=aD(h,20)|0;s=213413;t=r+20|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,h,213434,212249,3295);bD(h)}c=g+40|0;n=f[c>>2]|0;p=f[n+-4>>2]|0;o=a+40|0;v=f[o>>2]|0;a:do if((p|0)==(f[v+-4>>2]|0)){if((p|0)==2){if((f[n>>2]|0)!=(f[v>>2]|0)){w=17;break}if((f[n+4>>2]|0)==(f[v+4>>2]|0))break;else{w=17;break}}if((p|0)>0){x=0;do{if((f[n+(x<<2)>>2]|0)!=(f[v+(x<<2)>>2]|0)){w=17;break a}x=x+1|0}while((x|0)<(p|0))}}else w=17;while(0);if((w|0)==17){f[h>>2]=0;f[h+4>>2]=0;r=aD(h,16)|0;s=213438;t=r+16|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,h,213434,212249,3295);bD(h)}if((l|0)==7){f[h>>2]=0;f[h+4>>2]=0;r=aD(h,9)|0;s=255890;t=r+9|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,h,213434,212249,3295);bD(h)}if((f[a>>2]&16384|0)!=0?(f[q>>2]&16384|0)!=0:0){q=f[a+4>>2]|0;if((q|0)<3)y=Y(f[a+12>>2]|0,f[a+8>>2]|0)|0;else{s=f[o>>2]|0;o=0;r=1;while(1){t=Y(f[s+(o<<2)>>2]|0,r)|0;o=o+1|0;if((o|0)==(q|0)){y=t;break}else r=t}}r=Y(y,k)|0;z=+fh[m&31](f[a+16>>2]|0,f[g+16>>2]|0,r)}else{f[h>>2]=a;f[h+4>>2]=g;f[h+8>>2]=0;RN(j,h,i,-1);h=Y(f[j+20>>2]|0,k)|0;k=j+16|0;a=i+4|0;r=0;A=0.0;while(1){if(r>>>0>=(f[k>>2]|0)>>>0)break;B=A+ +fh[m&31](f[i>>2]|0,f[a>>2]|0,h);aL(j)|0;r=r+1|0;A=B}z=A}r=g+36|0;j=f[r>>2]|0;if(j|0?(h=j+12|0,j=f[h>>2]|0,f[h>>2]=j+-1,(j|0)==1):0)kL(g);f[r>>2]=0;r=g+16|0;j=g+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[j>>2]|0)>0){r=f[c>>2]|0;c=0;do{f[r+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[j>>2]|0))}j=f[g+44>>2]|0;if((j|0)!=(g+48|0))UC(j);if(!(f[e+4>>2]|0)){u=d;return +z}u=d;return +z}function qY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;d=c+-4|0;if((c|0)<4){e=0.0;f=0}else{g=0;i=0.0;do{j=g|1;k=g|2;l=g|3;i=i+(+(h[a+g>>0]|0)*+(h[b+g>>0]|0)+ +(h[a+j>>0]|0)*+(h[b+j>>0]|0)+ +(h[a+k>>0]|0)*+(h[b+k>>0]|0)+ +(h[a+l>>0]|0)*+(h[b+l>>0]|0));g=g+4|0}while((g|0)<=(d|0));e=i;f=c&-4}if((f|0)<(c|0)){m=f;n=e}else{o=e;p=o+0.0;return +p}while(1){e=n+ +(h[a+m>>0]|0)*+(h[b+m>>0]|0);m=m+1|0;if((m|0)==(c|0)){o=e;break}else n=e}p=o+0.0;return +p}function rY(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=d+-4|0;if((d|0)<4){f=0.0;g=0}else{h=0;i=0.0;do{j=h|1;k=h|2;l=h|3;i=i+(+(b[a+h>>0]|0)*+(b[c+h>>0]|0)+ +(b[a+j>>0]|0)*+(b[c+j>>0]|0)+ +(b[a+k>>0]|0)*+(b[c+k>>0]|0)+ +(b[a+l>>0]|0)*+(b[c+l>>0]|0));h=h+4|0}while((h|0)<=(e|0));f=i;g=d&-4}if((g|0)<(d|0)){m=g;n=f}else{o=f;p=o+0.0;return +p}while(1){f=n+ +(b[a+m>>0]|0)*+(b[c+m>>0]|0);m=m+1|0;if((m|0)==(d|0)){o=f;break}else n=f}p=o+0.0;return +p}function sY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,h=0.0,i=0,k=0,l=0,m=0,n=0.0,o=0.0;d=c+-4|0;if((c|0)<4){e=0.0;f=0}else{g=0;h=0.0;do{i=g|1;k=g|2;l=g|3;h=h+(+(j[a+(g<<1)>>1]|0)*+(j[b+(g<<1)>>1]|0)+ +(j[a+(i<<1)>>1]|0)*+(j[b+(i<<1)>>1]|0)+ +(j[a+(k<<1)>>1]|0)*+(j[b+(k<<1)>>1]|0)+ +(j[a+(l<<1)>>1]|0)*+(j[b+(l<<1)>>1]|0));g=g+4|0}while((g|0)<=(d|0));e=h;f=c&-4}if((f|0)<(c|0)){m=f;n=e}else{o=e;return +o}while(1){e=n+ +(j[a+(m<<1)>>1]|0)*+(j[b+(m<<1)>>1]|0);m=m+1|0;if((m|0)==(c|0)){o=e;break}else n=e}return +o}function tY(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0.0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;e=c+-4|0;if((c|0)<4){f=0.0;g=0}else{h=0;i=0.0;do{j=h|1;k=h|2;l=h|3;i=i+(+(d[a+(h<<1)>>1]|0)*+(d[b+(h<<1)>>1]|0)+ +(d[a+(j<<1)>>1]|0)*+(d[b+(j<<1)>>1]|0)+ +(d[a+(k<<1)>>1]|0)*+(d[b+(k<<1)>>1]|0)+ +(d[a+(l<<1)>>1]|0)*+(d[b+(l<<1)>>1]|0));h=h+4|0}while((h|0)<=(e|0));f=i;g=c&-4}if((g|0)<(c|0)){m=g;n=f}else{o=f;return +o}while(1){f=n+ +(d[a+(m<<1)>>1]|0)*+(d[b+(m<<1)>>1]|0);m=m+1|0;if((m|0)==(c|0)){o=f;break}else n=f}return +o}function uY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,g=0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;d=c+-4|0;if((c|0)<4){e=0.0;g=0}else{h=0;i=0.0;do{j=h|1;k=h|2;l=h|3;i=i+(+(f[a+(h<<2)>>2]|0)*+(f[b+(h<<2)>>2]|0)+ +(f[a+(j<<2)>>2]|0)*+(f[b+(j<<2)>>2]|0)+ +(f[a+(k<<2)>>2]|0)*+(f[b+(k<<2)>>2]|0)+ +(f[a+(l<<2)>>2]|0)*+(f[b+(l<<2)>>2]|0));h=h+4|0}while((h|0)<=(d|0));e=i;g=c&-4}if((g|0)<(c|0)){m=g;n=e}else{o=e;return +o}while(1){e=n+ +(f[a+(m<<2)>>2]|0)*+(f[b+(m<<2)>>2]|0);m=m+1|0;if((m|0)==(c|0)){o=e;break}else n=e}return +o}function vY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,h=0.0,i=0,j=0,k=0,l=0,m=0.0,o=0.0,p=0.0;d=c+-4|0;if((c|0)<4){e=0.0;f=0}else{g=0;h=0.0;do{i=g|1;j=g|2;k=g|3;h=h+(+n[a+(g<<2)>>2]*+n[b+(g<<2)>>2]+ +n[a+(i<<2)>>2]*+n[b+(i<<2)>>2]+ +n[a+(j<<2)>>2]*+n[b+(j<<2)>>2]+ +n[a+(k<<2)>>2]*+n[b+(k<<2)>>2]);g=g+4|0}while((g|0)<=(d|0));e=h;f=c&-4}if((f|0)<(c|0)){l=f;m=e}else{o=e;p=o+0.0;return +p}while(1){e=m+ +n[a+(l<<2)>>2]*+n[b+(l<<2)>>2];l=l+1|0;if((l|0)==(c|0)){o=e;break}else m=e}p=o+0.0;return +p}function wY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0,h=0.0,i=0,j=0,k=0,l=0,m=0.0,n=0.0;d=c+-4|0;if((c|0)<4){e=0.0;f=0}else{g=0;h=0.0;do{i=g|1;j=g|2;k=g|3;h=h+(+p[a+(g<<3)>>3]*+p[b+(g<<3)>>3]+ +p[a+(i<<3)>>3]*+p[b+(i<<3)>>3]+ +p[a+(j<<3)>>3]*+p[b+(j<<3)>>3]+ +p[a+(k<<3)>>3]*+p[b+(k<<3)>>3]);g=g+4|0}while((g|0)<=(d|0));e=h;f=c&-4}if((f|0)<(c|0)){l=f;m=e}else{n=e;return +n}while(1){e=m+ +p[a+(l<<3)>>3]*+p[b+(l<<3)>>3];l=l+1|0;if((l|0)==(c|0)){n=e;break}else m=e}return +n}function xY(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[a>>2]=47464;dQ(c,47536);if(!(f[c+4>>2]|0)){u=b;return}u=b;return}function yY(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[a>>2]=47464;dQ(c,47536);if(!(f[c+4>>2]|0)){O5b(a);u=b;return}O5b(a);u=b;return}function zY(a){a=a|0;return}function AY(a,b){a=a|0;b=b|0;return}function BY(a,b){a=a|0;b=b|0;return}function CY(a){a=a|0;return 0}function DY(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+64|0;e=d+56|0;g=d+48|0;h=d+8|0;i=d;dQ(g,47516);f[e>>2]=0;f[e+4>>2]=0;dW(h,c,1,e);bD(e);zh[f[(f[a>>2]|0)+28>>2]&2047](i,a);c=gW(h,i)|0;f[e>>2]=0;f[e+4>>2]=0;j=aD(e,1)|0;b[j>>0]=123;gW(c,e)|0;bD(e);bD(i);zh[f[(f[a>>2]|0)+12>>2]&2047](a,h);f[e>>2]=0;f[e+4>>2]=0;a=aD(e,1)|0;b[a>>0]=125;gW(h,e)|0;bD(e);nT(h);if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function EY(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;c=u;u=u+16|0;d=c;dQ(d,47496);f[a>>2]=0;f[a+4>>2]=0;e=aD(a,9)|0;a=213493;g=e+9|0;do{b[e>>0]=b[a>>0]|0;e=e+1|0;a=a+1|0}while((e|0)<(g|0));if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function FY(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;f[a>>2]=47464;dQ(c,47556);if(!(f[c+4>>2]|0)){u=b;return}u=b;return}function GY(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+16|0;d=a+8|0;e=a;dQ(e,47576);f[d>>2]=0;f[d+4>>2]=0;g=aD(d,6)|0;b[g>>0]=b[213769]|0;b[g+1>>0]=b[213770]|0;b[g+2>>0]=b[213771]|0;b[g+3>>0]=b[213772]|0;b[g+4>>0]=b[213773]|0;b[g+5>>0]=b[213774]|0;g=gW(c,d)|0;bD(d);if(di[f[(f[c>>2]|0)+12>>2]&1023](g)|0){h=c+32|0;if((f[h>>2]|0)==6){f[d>>2]=0;f[d+4>>2]=0;i=aD(d,30)|0;j=363892;k=i+30|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-2,d,489622,363923,1181);bD(d)}oW(g,c+12|0,3);if(f[h>>2]&4|0)f[h>>2]=6}if(!(f[e+4>>2]|0)){u=a;return}u=a;return}function HY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0;g=u;u=u+16|0;h=g;dQ(h,47596);i=e?1.0:.01745329238474369;if((d|0)>0){e=0;do{j=+n[a+(e<<2)>>2];k=+n[b+(e<<2)>>2];l=+L(+k);m=+L(+j);if(!(l>=m)){o=l/(m+2.220446049250313e-16);p=o*o;q=90.0-o*(p*(p*(8.914000511169434-p*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{p=m/(l+2.220446049250313e-16);l=p*p;q=p*(l*(l*(8.914000511169434-l*2.539724588394165)+-18.66744613647461)+57.283626556396484)}l=k<0.0?180.0-q:q;n[c+(e<<2)>>2]=i*(j<0.0?360.0-l:l);e=e+1|0}while((e|0)!=(d|0))}if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function IY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,q=0.0;g=u;u=u+16|0;h=g;dQ(h,47616);i=e?1.0:.017453292519943295;if((d|0)>0){e=0;do{j=+p[a+(e<<3)>>3];k=+p[b+(e<<3)>>3];l=+L(+k);m=+L(+j);if(!(l>=m)){n=l/(m+2.220446049250313e-16);o=n*n;q=90.0-n*(o*(o*(8.914000511169434-o*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{o=m/(l+2.220446049250313e-16);l=o*o;q=o*(l*(l*(8.914000511169434-l*2.539724588394165)+-18.66744613647461)+57.283626556396484)}l=k<0.0?180.0-q:q;p[c+(e<<3)>>3]=i*(j<0.0?360.0-l:l);e=e+1|0}while((e|0)!=(d|0))}if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function JY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0,o=0.0,q=0,r=0.0,t=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+16|0;e=d;dQ(e,47756);g=c+-4|0;if((c|0)<4)h=0;else{i=0;do{j=+n[a+(i<<2)>>2];k=i|1;l=+n[a+(k<<2)>>2];m=i|2;o=+n[a+(m<<2)>>2];q=i|3;r=+n[a+(q<<2)>>2];t=(n[s>>2]=j,f[s>>2]|0);v=(t&2130706432)>>>0>1149239296?((t|0)<0?-192.0e3:192.0e3):j*92.33248261689366;t=(n[s>>2]=l,f[s>>2]|0);j=(t&2130706432)>>>0>1149239296?((t|0)<0?-192.0e3:192.0e3):l*92.33248261689366;t=(n[s>>2]=o,f[s>>2]|0);l=(t&2130706432)>>>0>1149239296?((t|0)<0?-192.0e3:192.0e3):o*92.33248261689366;t=(n[s>>2]=r,f[s>>2]|0);o=(t&2130706432)>>>0>1149239296?((t|0)<0?-192.0e3:192.0e3):r*92.33248261689366;t=MVb(v)|0;w=MVb(j)|0;x=MVb(l)|0;y=MVb(o)|0;r=(v-+(t|0))*.015625;v=(j-+(w|0))*.015625;j=(l-+(x|0))*.015625;l=(o-+(y|0))*.015625;z=t>>6;A=z+127|0;B=w>>6;C=B+127|0;D=x>>6;E=D+127|0;F=y>>6;G=F+127|0;o=+p[11008+((t&63)<<3)>>3]*(f[s>>2]=(A>>>0>255?((z|0)<-127?0:255):A)<<23,+n[s>>2])*(r*(r*(r*(r+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);r=+p[11008+((w&63)<<3)>>3]*(f[s>>2]=(C>>>0>255?((B|0)<-127?0:255):C)<<23,+n[s>>2])*(v*(v*(v*(v+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);n[b+(i<<2)>>2]=o;n[b+(k<<2)>>2]=r;r=+p[11008+((x&63)<<3)>>3]*(f[s>>2]=(E>>>0>255?((D|0)<-127?0:255):E)<<23,+n[s>>2])*(j*(j*(j*(j+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);j=+p[11008+((y&63)<<3)>>3]*(f[s>>2]=(G>>>0>255?((F|0)<-127?0:255):G)<<23,+n[s>>2])*(l*(l*(l*(l+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);n[b+(m<<2)>>2]=r;n[b+(q<<2)>>2]=j;i=i+4|0}while((i|0)<=(g|0));h=c&-4}if((h|0)<(c|0)){g=h;do{j=+n[a+(g<<2)>>2];h=(n[s>>2]=j,f[s>>2]|0);r=(h&2130706432)>>>0>1149239296?((h|0)<0?-192.0e3:192.0e3):j*92.33248261689366;h=MVb(r)|0;i=h>>6;q=i+127|0;j=(r-+(h|0))*.015625;n[b+(g<<2)>>2]=+p[11008+((h&63)<<3)>>3]*(f[s>>2]=(q>>>0>255?((i|0)<-127?0:255):q)<<23,+n[s>>2])*(j*(j*(j*(j+5.73953104019165)+24.84149932861328)+71.67741394042969)+103.40864562988281);g=g+1|0}while((g|0)!=(c|0))}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function KY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,q=0.0,r=0,t=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=u;u=u+16|0;e=d;dQ(e,47776);g=c+-4|0;if((c|0)<4)h=0;else{i=0;do{j=+p[a+(i<<3)>>3];k=i|1;l=+p[a+(k<<3)>>3];m=i|2;n=+p[a+(m<<3)>>3];o=i|3;q=+p[a+(o<<3)>>3];p[s>>3]=j;r=Rac(f[s>>2]|0,f[s+4>>2]|0,52)|0;t=(r&2046)>>>0>1033?((r|0)<0?-192.0e3:192.0e3):j*92.33248261689366;p[s>>3]=l;r=Rac(f[s>>2]|0,f[s+4>>2]|0,52)|0;j=(r&2046)>>>0>1033?((r|0)<0?-192.0e3:192.0e3):l*92.33248261689366;p[s>>3]=n;r=Rac(f[s>>2]|0,f[s+4>>2]|0,52)|0;l=(r&2046)>>>0>1033?((r|0)<0?-192.0e3:192.0e3):n*92.33248261689366;p[s>>3]=q;r=Rac(f[s>>2]|0,f[s+4>>2]|0,52)|0;n=(r&2046)>>>0>1033?((r|0)<0?-192.0e3:192.0e3):q*92.33248261689366;r=MVb(t)|0;v=MVb(j)|0;w=MVb(l)|0;x=MVb(n)|0;q=(t-+(r|0))*.015625;t=(j-+(v|0))*.015625;j=(l-+(w|0))*.015625;l=(n-+(x|0))*.015625;y=r>>6;z=y+1023|0;A=$ac((z>>>0>2047?((y|0)<-1023?0:2047):z)|0,0,52)|0;z=J;y=v>>6;B=y+1023|0;C=$ac((B>>>0>2047?((y|0)<-1023?0:2047):B)|0,0,52)|0;B=J;y=w>>6;D=y+1023|0;E=$ac((D>>>0>2047?((y|0)<-1023?0:2047):D)|0,0,52)|0;D=J;y=x>>6;F=y+1023|0;G=$ac((F>>>0>2047?((y|0)<-1023?0:2047):F)|0,0,52)|0;F=J;f[s>>2]=A;f[s+4>>2]=z;n=+p[11008+((r&63)<<3)>>3]*+p[s>>3]*(q*(q*(q*(q*(q*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);f[s>>2]=C;f[s+4>>2]=B;q=+p[11008+((v&63)<<3)>>3]*+p[s>>3]*(t*(t*(t*(t*(t*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);p[b+(i<<3)>>3]=n;p[b+(k<<3)>>3]=q;f[s>>2]=E;f[s+4>>2]=D;q=+p[11008+((w&63)<<3)>>3]*+p[s>>3]*(j*(j*(j*(j*(j*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);f[s>>2]=G;f[s+4>>2]=F;j=+p[11008+((x&63)<<3)>>3]*+p[s>>3]*(l*(l*(l*(l*(l*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);p[b+(m<<3)>>3]=q;p[b+(o<<3)>>3]=j;i=i+4|0}while((i|0)<=(g|0));h=c&-4}if((h|0)<(c|0)){g=h;do{j=+p[a+(g<<3)>>3];p[s>>3]=j;h=Rac(f[s>>2]|0,f[s+4>>2]|0,52)|0;q=(h&2046)>>>0>1033?((h|0)<0?-192.0e3:192.0e3):j*92.33248261689366;h=MVb(q)|0;i=h>>6;o=i+1023|0;m=$ac((o>>>0>2047?((i|0)<-1023?0:2047):o)|0,0,52)|0;o=J;j=(q-+(h|0))*.015625;f[s>>2]=m;f[s+4>>2]=o;p[b+(g<<3)>>3]=+p[11008+((h&63)<<3)>>3]*+p[s>>3]*(j*(j*(j*(j*(j*.13825440165858396+.9945944344074722)+5.7396048189422615)+24.841498169168357)+71.67741243389332)+103.4086474621308);g=g+1|0}while((g|0)!=(c|0))}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function LY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,t=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0;d=u;u=u+16|0;e=d;dQ(e,47796);g=c+-4|0;if((c|0)<4)h=0;else{i=0;do{j=f[a+(i<<2)>>2]|0;k=i|1;l=f[a+(k<<2)>>2]|0;m=j>>>14&510;o=l>>>14&510;q=i|2;r=f[a+(q<<2)>>2]|0;t=i|3;v=f[a+(t<<2)>>2]|0;w=((f[s>>2]=j&32767|1065353216,+n[s>>2])+-1.0)*+p[16+((m|1)<<3)>>3];x=((f[s>>2]=l&32767|1065353216,+n[s>>2])+-1.0)*+p[16+((o|1)<<3)>>3];y=r>>>14&510;z=v>>>14&510;A=+p[16+(y<<3)>>3]+ +((r>>>23&255)+-127|0)*.6931471805599453;B=+p[16+(z<<3)>>3]+ +((v>>>23&255)+-127|0)*.6931471805599453;C=((f[s>>2]=r&32767|1065353216,+n[s>>2])+-1.0)*+p[16+((y|1)<<3)>>3];D=((f[s>>2]=v&32767|1065353216,+n[s>>2])+-1.0)*+p[16+((z|1)<<3)>>3];E=w+ +n[47816+(((m|0)==510&1)<<2)>>2];w=x+ +n[47816+(((o|0)==510&1)<<2)>>2];x=+p[16+(o<<3)>>3]+ +((l>>>23&255)+-127|0)*.6931471805599453+w*(w*(w*.3333333432674408+-.5)+1.0);n[b+(i<<2)>>2]=+p[16+(m<<3)>>3]+ +((j>>>23&255)+-127|0)*.6931471805599453+E*(E*(E*.3333333432674408+-.5)+1.0);n[b+(k<<2)>>2]=x;x=C+ +n[47816+(((y|0)==510&1)<<2)>>2];C=D+ +n[47816+(((z|0)==510&1)<<2)>>2];n[b+(q<<2)>>2]=A+x*(x*(x*.3333333432674408+-.5)+1.0);n[b+(t<<2)>>2]=B+C*(C*(C*.3333333432674408+-.5)+1.0);i=i+4|0}while((i|0)<=(g|0));h=c&-4}if((h|0)<(c|0)){g=h;do{h=f[a+(g<<2)>>2]|0;i=h>>>14&510;C=+n[47816+(((i|0)==510&1)<<2)>>2]+ +p[16+((i|1)<<3)>>3]*((f[s>>2]=h&32767|1065353216,+n[s>>2])+-1.0);n[b+(g<<2)>>2]=+p[16+(i<<3)>>3]+ +((h>>>23&255)+-127|0)*.6931471805599453+C*(C*(C*.3333333432674408+-.5)+1.0);g=g+1|0}while((g|0)!=(c|0))}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function MY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0.0,r=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;d=u;u=u+16|0;e=d;dQ(e,47824);g=c+-4|0;if((c|0)<4)h=0;else{i=0;do{j=a+(i<<3)|0;k=i|1;l=a+(k<<3)|0;m=f[l>>2]|0;n=f[j+4>>2]|0;o=f[l+4>>2]|0;f[s>>2]=f[j>>2];f[s+4>>2]=n&4095|1072693248;q=+p[s>>3];f[s>>2]=m;f[s+4>>2]=o&4095|1072693248;m=i|2;j=a+(m<<3)|0;l=i|3;r=a+(l<<3)|0;t=f[r>>2]|0;v=n>>>11&510;w=o>>>11&510;x=+p[16+(v<<3)>>3]+ +((n>>>20&2047)+-1023|0)*.6931471805599453;y=+p[16+(w<<3)>>3]+ +((o>>>20&2047)+-1023|0)*.6931471805599453;o=f[j+4>>2]|0;n=f[r+4>>2]|0;z=(q+-1.0)*+p[16+((v|1)<<3)>>3];q=(+p[s>>3]+-1.0)*+p[16+((w|1)<<3)>>3];f[s>>2]=f[j>>2];f[s+4>>2]=o&4095|1072693248;A=+p[s>>3];f[s>>2]=t;f[s+4>>2]=n&4095|1072693248;t=o>>>11&510;j=n>>>11&510;B=+p[16+(t<<3)>>3]+ +((o>>>20&2047)+-1023|0)*.6931471805599453;C=+p[16+(j<<3)>>3]+ +((n>>>20&2047)+-1023|0)*.6931471805599453;D=+p[16+((t|1)<<3)>>3]*(A+-1.0);A=+p[16+((j|1)<<3)>>3]*(+p[s>>3]+-1.0);E=z+ +p[11520+(((v|0)==510&1)<<3)>>3];z=E*E;F=q+ +p[11520+(((w|0)==510&1)<<3)>>3];q=F*F;p[b+(i<<3)>>3]=x+(z*(z*(z*(-.16666666666666666-z*.125)+-.25)+-.5)+E*(z*(z*(z*.14285714285714288+.2)+.3333333333333333)+1.0));p[b+(k<<3)>>3]=y+(q*(q*(q*(-.16666666666666666-q*.125)+-.25)+-.5)+F*(q*(q*(q*.14285714285714288+.2)+.3333333333333333)+1.0));q=D+ +p[11520+(((t|0)==510&1)<<3)>>3];D=q*q;F=A+ +p[11520+(((j|0)==510&1)<<3)>>3];A=F*F;p[b+(m<<3)>>3]=B+(D*(D*(D*(-.16666666666666666-D*.125)+-.25)+-.5)+q*(D*(D*(D*.14285714285714288+.2)+.3333333333333333)+1.0));p[b+(l<<3)>>3]=C+(A*(A*(A*(-.16666666666666666-A*.125)+-.25)+-.5)+F*(A*(A*(A*.14285714285714288+.2)+.3333333333333333)+1.0));i=i+4|0}while((i|0)<=(g|0));h=c&-4}if((h|0)<(c|0)){g=h;do{h=a+(g<<3)|0;i=f[h+4>>2]|0;f[s>>2]=f[h>>2];f[s+4>>2]=i&4095|1072693248;h=i>>>11&510;A=+p[11520+(((h|0)==510&1)<<3)>>3]+ +p[16+((h|1)<<3)>>3]*(+p[s>>3]+-1.0);F=A*A;p[b+(g<<3)>>3]=+p[16+(h<<3)>>3]+ +((i>>>20&2047)+-1023|0)*.6931471805599453+(F*(F*(F*(-.16666666666666666-F*.125)+-.25)+-.5)+A*(F*(F*(F*.14285714285714288+.2)+.3333333333333333)+1.0));g=g+1|0}while((g|0)!=(c|0))}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function NY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;dQ(h,47844);HY(a,b,c,d,e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function OY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;dQ(h,47864);IY(a,b,c,d,e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function PY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0.0,j=0.0,k=0.0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(h,47884);dQ(g,47636);if((d|0)>0){g=0;do{i=+n[a+(g<<2)>>2];j=+n[b+(g<<2)>>2];k=+M(+(i*i+j*j));n[c+(g<<2)>>2]=k;g=g+1|0}while((g|0)!=(d|0))}if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function QY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0.0,j=0.0,k=0.0;e=u;u=u+16|0;g=e+8|0;h=e;dQ(h,47904);dQ(g,47656);if((d|0)>0){g=0;do{i=+p[a+(g<<3)>>3];j=+p[b+(g<<3)>>3];k=+M(+(i*i+j*j));p[c+(g<<3)>>3]=k;g=g+1|0}while((g|0)!=(d|0))}if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function RY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+16|0;e=d+8|0;g=d;dQ(g,47924);dQ(e,47676);if((c|0)>0){e=0;do{h=1.0/+M(+(+n[a+(e<<2)>>2]));n[b+(e<<2)>>2]=h;e=e+1|0}while((e|0)!=(c|0))}if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function SY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+16|0;e=d+8|0;g=d;dQ(g,47944);dQ(e,47696);if((c|0)>0){e=0;do{h=1.0/+M(+(+p[a+(e<<3)>>3]));p[b+(e<<3)>>3]=h;e=e+1|0}while((e|0)!=(c|0))}if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function TY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+16|0;e=d+8|0;g=d;dQ(g,47964);dQ(e,47716);if((c|0)>0){e=0;do{h=+M(+(+n[a+(e<<2)>>2]));n[b+(e<<2)>>2]=h;e=e+1|0}while((e|0)!=(c|0))}if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function UY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0;d=u;u=u+16|0;e=d+8|0;g=d;dQ(g,47984);dQ(e,47736);if((c|0)>0){e=0;do{h=+M(+(+p[a+(e<<3)>>3]));p[b+(e<<3)>>3]=h;e=e+1|0}while((e|0)!=(c|0))}if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function VY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;dQ(e,48004);JY(a,b,c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function WY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;dQ(e,48024);KY(a,b,c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function XY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;dQ(e,48044);LY(a,b,c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function YY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;dQ(e,48064);MY(a,b,c);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function ZY(a,b){a=+a;b=+b;var c=0.0,d=0.0,e=0.0,f=0.0,g=0.0;c=+L(+b);d=+L(+a);if(!(c>=d)){e=c/(d+2.220446049250313e-16);f=e*e;g=90.0-e*(f*(f*(8.914000511169434-f*2.539724588394165)+-18.66744613647461)+57.283626556396484)}else{f=d/(c+2.220446049250313e-16);c=f*f;g=f*(c*(c*(8.914000511169434-c*2.539724588394165)+-18.66744613647461)+57.283626556396484)}c=b<0.0?180.0-g:g;return +(a<0.0?360.0-c:c)}function _Y(a){a=a|0;var c=0,d=0,e=0,g=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[d>>2]=0;f[d+4>>2]=0;a=aD(d,44)|0;e=215603;g=a+44|0;do{b[a>>0]=b[e>>0]|0;a=a+1|0;e=e+1|0}while((a|0)<(g|0));bO(-216,d,215648,215662,107);bD(d);u=c;return}function $Y(){var a=0,c=0,d=0,e=0,g=0;a=u;u=u+16|0;c=a;f[c>>2]=0;f[c+4>>2]=0;d=aD(c,44)|0;e=215603;g=d+44|0;do{b[d>>0]=b[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(g|0));bO(-216,c,215648,215662,107);bD(c);if(b[491088]|0){u=a;return 503448}if(!(Cac(491088)|0)){u=a;return 503448}_Y(503448);zd(1473,503448,x|0)|0;u=a;return 503448}function aZ(a){a=a|0;var b=0,c=0,d=0;b=f[a>>2]|0;if(b|0?(c=b+4|0,d=f[c>>2]|0,f[c>>2]=d+-1,(d|0)==1):0)bi[f[(f[b>>2]|0)+8>>2]&2047](b);f[a>>2]=0;f[a+4>>2]=0;return}function bZ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[c>>2]|0;a:do if((h|0)==1){if((e|0)==1){Vac(g|0,a|0,d|0)|0;i=1;break}if((d|0)>0){j=0;k=0;while(1){b[g+j>>0]=b[a+k>>0]|0;j=j+1|0;if((j|0)==(d|0)){i=1;break}else k=k+e|0}}else return}else{k=f[c+4>>2]|0;if((h|0)==2)if((d|0)>0){j=0;l=0;while(1){b[g+l>>0]=b[a+j>>0]|0;b[k+l>>0]=b[a+(j+1)>>0]|0;l=l+1|0;if((l|0)==(d|0)){i=2;break a}else j=j+e|0}}else return;j=f[c+8>>2]|0;if((h|0)==3)if((d|0)>0){l=0;m=0;while(1){b[g+m>>0]=b[a+l>>0]|0;b[k+m>>0]=b[a+(l+1)>>0]|0;b[j+m>>0]=b[a+(l+2)>>0]|0;m=m+1|0;if((m|0)==(d|0)){i=3;break}else l=l+e|0}}else return;else{l=f[c+12>>2]|0;if((d|0)>0){m=0;n=0;while(1){b[g+n>>0]=b[a+m>>0]|0;b[k+n>>0]=b[a+(m+1)>>0]|0;b[j+n>>0]=b[a+(m+2)>>0]|0;b[l+n>>0]=b[a+(m+3)>>0]|0;n=n+1|0;if((n|0)==(d|0)){i=h;break}else m=m+e|0}}else return}}while(0);if((d|0)>0&(i|0)<(e|0))o=i;else return;do{i=f[c+(o<<2)>>2]|0;h=f[c+(o+1<<2)>>2]|0;g=f[c+(o+2<<2)>>2]|0;m=f[c+(o+3<<2)>>2]|0;n=o;l=0;while(1){b[i+l>>0]=b[a+n>>0]|0;b[h+l>>0]=b[a+(n+1)>>0]|0;b[g+l>>0]=b[a+(n+2)>>0]|0;b[m+l>>0]=b[a+(n+3)>>0]|0;l=l+1|0;if((l|0)==(d|0))break;else n=n+e|0}o=o+4|0}while((o|0)<(e|0));return}function cZ(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[b>>2]|0;a:do if((h|0)==1){if((e|0)==1){Vac(g|0,a|0,c<<1|0)|0;i=1;break}if((c|0)>0){j=0;k=0;while(1){d[g+(j<<1)>>1]=d[a+(k<<1)>>1]|0;j=j+1|0;if((j|0)==(c|0)){i=1;break}else k=k+e|0}}else return}else{k=f[b+4>>2]|0;if((h|0)==2)if((c|0)>0){j=0;l=0;while(1){d[g+(l<<1)>>1]=d[a+(j<<1)>>1]|0;d[k+(l<<1)>>1]=d[a+(j+1<<1)>>1]|0;l=l+1|0;if((l|0)==(c|0)){i=2;break a}else j=j+e|0}}else return;j=f[b+8>>2]|0;if((h|0)==3)if((c|0)>0){l=0;m=0;while(1){d[g+(m<<1)>>1]=d[a+(l<<1)>>1]|0;d[k+(m<<1)>>1]=d[a+(l+1<<1)>>1]|0;d[j+(m<<1)>>1]=d[a+(l+2<<1)>>1]|0;m=m+1|0;if((m|0)==(c|0)){i=3;break}else l=l+e|0}}else return;else{l=f[b+12>>2]|0;if((c|0)>0){m=0;n=0;while(1){d[g+(n<<1)>>1]=d[a+(m<<1)>>1]|0;d[k+(n<<1)>>1]=d[a+(m+1<<1)>>1]|0;d[j+(n<<1)>>1]=d[a+(m+2<<1)>>1]|0;d[l+(n<<1)>>1]=d[a+(m+3<<1)>>1]|0;n=n+1|0;if((n|0)==(c|0)){i=h;break}else m=m+e|0}}else return}}while(0);if((c|0)>0&(i|0)<(e|0))o=i;else return;do{i=f[b+(o<<2)>>2]|0;h=f[b+(o+1<<2)>>2]|0;g=f[b+(o+2<<2)>>2]|0;m=f[b+(o+3<<2)>>2]|0;n=o;l=0;while(1){d[i+(l<<1)>>1]=d[a+(n<<1)>>1]|0;d[h+(l<<1)>>1]=d[a+(n+1<<1)>>1]|0;d[g+(l<<1)>>1]=d[a+(n+2<<1)>>1]|0;d[m+(l<<1)>>1]=d[a+(n+3<<1)>>1]|0;l=l+1|0;if((l|0)==(c|0))break;else n=n+e|0}o=o+4|0}while((o|0)<(e|0));return}function dZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[b>>2]|0;a:do if((g|0)==1){if((d|0)==1){Vac(e|0,a|0,c<<2|0)|0;h=1;break}if((c|0)>0){i=0;j=0;while(1){f[e+(i<<2)>>2]=f[a+(j<<2)>>2];i=i+1|0;if((i|0)==(c|0)){h=1;break}else j=j+d|0}}else return}else{j=f[b+4>>2]|0;if((g|0)==2)if((c|0)>0){i=0;k=0;while(1){f[e+(k<<2)>>2]=f[a+(i<<2)>>2];f[j+(k<<2)>>2]=f[a+(i+1<<2)>>2];k=k+1|0;if((k|0)==(c|0)){h=2;break a}else i=i+d|0}}else return;i=f[b+8>>2]|0;if((g|0)==3)if((c|0)>0){k=0;l=0;while(1){f[e+(l<<2)>>2]=f[a+(k<<2)>>2];f[j+(l<<2)>>2]=f[a+(k+1<<2)>>2];f[i+(l<<2)>>2]=f[a+(k+2<<2)>>2];l=l+1|0;if((l|0)==(c|0)){h=3;break}else k=k+d|0}}else return;else{k=f[b+12>>2]|0;if((c|0)>0){l=0;m=0;while(1){f[e+(m<<2)>>2]=f[a+(l<<2)>>2];f[j+(m<<2)>>2]=f[a+(l+1<<2)>>2];f[i+(m<<2)>>2]=f[a+(l+2<<2)>>2];f[k+(m<<2)>>2]=f[a+(l+3<<2)>>2];m=m+1|0;if((m|0)==(c|0)){h=g;break}else l=l+d|0}}else return}}while(0);if((c|0)>0&(h|0)<(d|0))n=h;else return;do{h=f[b+(n<<2)>>2]|0;g=f[b+(n+1<<2)>>2]|0;e=f[b+(n+2<<2)>>2]|0;l=f[b+(n+3<<2)>>2]|0;m=n;k=0;while(1){f[h+(k<<2)>>2]=f[a+(m<<2)>>2];f[g+(k<<2)>>2]=f[a+(m+1<<2)>>2];f[e+(k<<2)>>2]=f[a+(m+2<<2)>>2];f[l+(k<<2)>>2]=f[a+(m+3<<2)>>2];k=k+1|0;if((k|0)==(c|0))break;else m=m+d|0}n=n+4|0}while((n|0)<(d|0));return}function eZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[b>>2]|0;a:do if((g|0)==1){if((d|0)==1){Vac(e|0,a|0,c<<3|0)|0;h=1;break}if((c|0)>0){i=0;j=0;while(1){k=a+(j<<3)|0;l=f[k+4>>2]|0;m=e+(i<<3)|0;f[m>>2]=f[k>>2];f[m+4>>2]=l;i=i+1|0;if((i|0)==(c|0)){h=1;break}else j=j+d|0}}else return}else{j=f[b+4>>2]|0;if((g|0)==2)if((c|0)>0){i=0;l=0;while(1){m=a+(i<<3)|0;k=f[m+4>>2]|0;n=e+(l<<3)|0;f[n>>2]=f[m>>2];f[n+4>>2]=k;k=a+(i+1<<3)|0;n=f[k+4>>2]|0;m=j+(l<<3)|0;f[m>>2]=f[k>>2];f[m+4>>2]=n;l=l+1|0;if((l|0)==(c|0)){h=2;break a}else i=i+d|0}}else return;i=f[b+8>>2]|0;if((g|0)==3)if((c|0)>0){l=0;n=0;while(1){m=a+(l<<3)|0;k=f[m+4>>2]|0;o=e+(n<<3)|0;f[o>>2]=f[m>>2];f[o+4>>2]=k;k=a+(l+1<<3)|0;o=f[k+4>>2]|0;m=j+(n<<3)|0;f[m>>2]=f[k>>2];f[m+4>>2]=o;o=a+(l+2<<3)|0;m=f[o+4>>2]|0;k=i+(n<<3)|0;f[k>>2]=f[o>>2];f[k+4>>2]=m;n=n+1|0;if((n|0)==(c|0)){h=3;break}else l=l+d|0}}else return;else{l=f[b+12>>2]|0;if((c|0)>0){n=0;m=0;while(1){k=a+(n<<3)|0;o=f[k+4>>2]|0;p=e+(m<<3)|0;f[p>>2]=f[k>>2];f[p+4>>2]=o;o=a+(n+1<<3)|0;p=f[o+4>>2]|0;k=j+(m<<3)|0;f[k>>2]=f[o>>2];f[k+4>>2]=p;p=a+(n+2<<3)|0;k=f[p+4>>2]|0;o=i+(m<<3)|0;f[o>>2]=f[p>>2];f[o+4>>2]=k;k=a+(n+3<<3)|0;o=f[k+4>>2]|0;p=l+(m<<3)|0;f[p>>2]=f[k>>2];f[p+4>>2]=o;m=m+1|0;if((m|0)==(c|0)){h=g;break}else n=n+d|0}}else return}}while(0);if((c|0)>0&(h|0)<(d|0))q=h;else return;do{h=f[b+(q<<2)>>2]|0;g=f[b+(q+1<<2)>>2]|0;e=f[b+(q+2<<2)>>2]|0;n=f[b+(q+3<<2)>>2]|0;m=q;l=0;while(1){i=a+(m<<3)|0;j=f[i+4>>2]|0;o=h+(l<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=j;j=a+(m+1<<3)|0;o=f[j+4>>2]|0;i=g+(l<<3)|0;f[i>>2]=f[j>>2];f[i+4>>2]=o;o=a+(m+2<<3)|0;i=f[o+4>>2]|0;j=e+(l<<3)|0;f[j>>2]=f[o>>2];f[j+4>>2]=i;i=a+(m+3<<3)|0;j=f[i+4>>2]|0;o=n+(l<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=j;l=l+1|0;if((l|0)==(c|0))break;else m=m+d|0}q=q+4|0}while((q|0)<(d|0));return}function fZ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[a>>2]|0;a:do if((h|0)==1)if((d|0)>0){i=0;j=0;while(1){b[c+j>>0]=b[g+i>>0]|0;i=i+1|0;if((i|0)==(d|0))break;else j=j+e|0}}else return;else{j=f[a+4>>2]|0;if((h|0)==2)if((d|0)>0){i=0;k=0;while(1){b[c+i>>0]=b[g+k>>0]|0;b[c+(i+1)>>0]=b[j+k>>0]|0;k=k+1|0;if((k|0)==(d|0))break a;else i=i+e|0}}else return;i=f[a+8>>2]|0;if((h|0)==3)if((d|0)>0){k=0;l=0;while(1){b[c+k>>0]=b[g+l>>0]|0;b[c+(k+1)>>0]=b[j+l>>0]|0;b[c+(k+2)>>0]=b[i+l>>0]|0;l=l+1|0;if((l|0)==(d|0))break;else k=k+e|0}}else return;else{k=f[a+12>>2]|0;if((d|0)>0){l=0;m=0;while(1){b[c+l>>0]=b[g+m>>0]|0;b[c+(l+1)>>0]=b[j+m>>0]|0;b[c+(l+2)>>0]=b[i+m>>0]|0;b[c+(l+3)>>0]=b[k+m>>0]|0;m=m+1|0;if((m|0)==(d|0))break;else l=l+e|0}}else return}}while(0);if((d|0)>0&(h|0)<(e|0))n=h;else return;do{h=f[a+(n<<2)>>2]|0;g=f[a+(n+1<<2)>>2]|0;l=f[a+(n+2<<2)>>2]|0;m=f[a+(n+3<<2)>>2]|0;k=n;i=0;while(1){b[c+k>>0]=b[h+i>>0]|0;b[c+(k+1)>>0]=b[g+i>>0]|0;b[c+(k+2)>>0]=b[l+i>>0]|0;b[c+(k+3)>>0]=b[m+i>>0]|0;i=i+1|0;if((i|0)==(d|0))break;else k=k+e|0}n=n+4|0}while((n|0)<(e|0));return}function gZ(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=(e|0)%4|0;h=(g|0)==0?4:g;g=f[a>>2]|0;a:do if((h|0)==1)if((c|0)>0){i=0;j=0;while(1){d[b+(j<<1)>>1]=d[g+(i<<1)>>1]|0;i=i+1|0;if((i|0)==(c|0))break;else j=j+e|0}}else return;else{j=f[a+4>>2]|0;if((h|0)==2)if((c|0)>0){i=0;k=0;while(1){d[b+(i<<1)>>1]=d[g+(k<<1)>>1]|0;d[b+(i+1<<1)>>1]=d[j+(k<<1)>>1]|0;k=k+1|0;if((k|0)==(c|0))break a;else i=i+e|0}}else return;i=f[a+8>>2]|0;if((h|0)==3)if((c|0)>0){k=0;l=0;while(1){d[b+(k<<1)>>1]=d[g+(l<<1)>>1]|0;d[b+(k+1<<1)>>1]=d[j+(l<<1)>>1]|0;d[b+(k+2<<1)>>1]=d[i+(l<<1)>>1]|0;l=l+1|0;if((l|0)==(c|0))break;else k=k+e|0}}else return;else{k=f[a+12>>2]|0;if((c|0)>0){l=0;m=0;while(1){d[b+(l<<1)>>1]=d[g+(m<<1)>>1]|0;d[b+(l+1<<1)>>1]=d[j+(m<<1)>>1]|0;d[b+(l+2<<1)>>1]=d[i+(m<<1)>>1]|0;d[b+(l+3<<1)>>1]=d[k+(m<<1)>>1]|0;m=m+1|0;if((m|0)==(c|0))break;else l=l+e|0}}else return}}while(0);if((c|0)>0&(h|0)<(e|0))n=h;else return;do{h=f[a+(n<<2)>>2]|0;g=f[a+(n+1<<2)>>2]|0;l=f[a+(n+2<<2)>>2]|0;m=f[a+(n+3<<2)>>2]|0;k=n;i=0;while(1){d[b+(k<<1)>>1]=d[h+(i<<1)>>1]|0;d[b+(k+1<<1)>>1]=d[g+(i<<1)>>1]|0;d[b+(k+2<<1)>>1]=d[l+(i<<1)>>1]|0;d[b+(k+3<<1)>>1]=d[m+(i<<1)>>1]|0;i=i+1|0;if((i|0)==(c|0))break;else k=k+e|0}n=n+4|0}while((n|0)<(e|0));return}function hZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[a>>2]|0;a:do if((g|0)==1)if((c|0)>0){h=0;i=0;while(1){f[b+(i<<2)>>2]=f[e+(h<<2)>>2];h=h+1|0;if((h|0)==(c|0))break;else i=i+d|0}}else return;else{i=f[a+4>>2]|0;if((g|0)==2)if((c|0)>0){h=0;j=0;while(1){f[b+(h<<2)>>2]=f[e+(j<<2)>>2];f[b+(h+1<<2)>>2]=f[i+(j<<2)>>2];j=j+1|0;if((j|0)==(c|0))break a;else h=h+d|0}}else return;h=f[a+8>>2]|0;if((g|0)==3)if((c|0)>0){j=0;k=0;while(1){f[b+(j<<2)>>2]=f[e+(k<<2)>>2];f[b+(j+1<<2)>>2]=f[i+(k<<2)>>2];f[b+(j+2<<2)>>2]=f[h+(k<<2)>>2];k=k+1|0;if((k|0)==(c|0))break;else j=j+d|0}}else return;else{j=f[a+12>>2]|0;if((c|0)>0){k=0;l=0;while(1){f[b+(k<<2)>>2]=f[e+(l<<2)>>2];f[b+(k+1<<2)>>2]=f[i+(l<<2)>>2];f[b+(k+2<<2)>>2]=f[h+(l<<2)>>2];f[b+(k+3<<2)>>2]=f[j+(l<<2)>>2];l=l+1|0;if((l|0)==(c|0))break;else k=k+d|0}}else return}}while(0);if((c|0)>0&(g|0)<(d|0))m=g;else return;do{g=f[a+(m<<2)>>2]|0;e=f[a+(m+1<<2)>>2]|0;k=f[a+(m+2<<2)>>2]|0;l=f[a+(m+3<<2)>>2]|0;j=m;h=0;while(1){f[b+(j<<2)>>2]=f[g+(h<<2)>>2];f[b+(j+1<<2)>>2]=f[e+(h<<2)>>2];f[b+(j+2<<2)>>2]=f[k+(h<<2)>>2];f[b+(j+3<<2)>>2]=f[l+(h<<2)>>2];h=h+1|0;if((h|0)==(c|0))break;else j=j+d|0}m=m+4|0}while((m|0)<(d|0));return}function iZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=(d|0)%4|0;g=(e|0)==0?4:e;e=f[a>>2]|0;a:do if((g|0)==1)if((c|0)>0){h=0;i=0;while(1){j=e+(h<<3)|0;k=f[j+4>>2]|0;l=b+(i<<3)|0;f[l>>2]=f[j>>2];f[l+4>>2]=k;h=h+1|0;if((h|0)==(c|0))break;else i=i+d|0}}else return;else{i=f[a+4>>2]|0;if((g|0)==2)if((c|0)>0){h=0;k=0;while(1){l=e+(k<<3)|0;j=f[l+4>>2]|0;m=b+(h<<3)|0;f[m>>2]=f[l>>2];f[m+4>>2]=j;j=i+(k<<3)|0;m=f[j+4>>2]|0;l=b+(h+1<<3)|0;f[l>>2]=f[j>>2];f[l+4>>2]=m;k=k+1|0;if((k|0)==(c|0))break a;else h=h+d|0}}else return;h=f[a+8>>2]|0;if((g|0)==3)if((c|0)>0){k=0;m=0;while(1){l=e+(m<<3)|0;j=f[l+4>>2]|0;n=b+(k<<3)|0;f[n>>2]=f[l>>2];f[n+4>>2]=j;j=i+(m<<3)|0;n=f[j+4>>2]|0;l=b+(k+1<<3)|0;f[l>>2]=f[j>>2];f[l+4>>2]=n;n=h+(m<<3)|0;l=f[n+4>>2]|0;j=b+(k+2<<3)|0;f[j>>2]=f[n>>2];f[j+4>>2]=l;m=m+1|0;if((m|0)==(c|0))break;else k=k+d|0}}else return;else{k=f[a+12>>2]|0;if((c|0)>0){m=0;l=0;while(1){j=e+(l<<3)|0;n=f[j+4>>2]|0;o=b+(m<<3)|0;f[o>>2]=f[j>>2];f[o+4>>2]=n;n=i+(l<<3)|0;o=f[n+4>>2]|0;j=b+(m+1<<3)|0;f[j>>2]=f[n>>2];f[j+4>>2]=o;o=h+(l<<3)|0;j=f[o+4>>2]|0;n=b+(m+2<<3)|0;f[n>>2]=f[o>>2];f[n+4>>2]=j;j=k+(l<<3)|0;n=f[j+4>>2]|0;o=b+(m+3<<3)|0;f[o>>2]=f[j>>2];f[o+4>>2]=n;l=l+1|0;if((l|0)==(c|0))break;else m=m+d|0}}else return}}while(0);if((c|0)>0&(g|0)<(d|0))p=g;else return;do{g=f[a+(p<<2)>>2]|0;e=f[a+(p+1<<2)>>2]|0;m=f[a+(p+2<<2)>>2]|0;l=f[a+(p+3<<2)>>2]|0;k=p;h=0;while(1){i=g+(h<<3)|0;n=f[i+4>>2]|0;o=b+(k<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=n;n=e+(h<<3)|0;o=f[n+4>>2]|0;i=b+(k+1<<3)|0;f[i>>2]=f[n>>2];f[i+4>>2]=o;o=m+(h<<3)|0;i=f[o+4>>2]|0;n=b+(k+2<<3)|0;f[n>>2]=f[o>>2];f[n+4>>2]=i;i=l+(h<<3)|0;n=f[i+4>>2]|0;o=b+(k+3<<3)|0;f[o>>2]=f[i>>2];f[o+4>>2]=n;h=h+1|0;if((h|0)==(c|0))break;else k=k+d|0}p=p+4|0}while((p|0)<(d|0));return}function jZ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h;dQ(i,48084);j=kZ(a,b,c,d,e,g)|0;if(!(f[i+4>>2]|0)){u=h;return j|0}u=h;return j|0}function kZ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0;h=b>>>2;b=e>>>2;e=(c|0)>0;a:do if(e){i=(d|0)==0;j=i|(g|0)<1;k=i|(g|0)<1;i=1;l=0;while(1){m=l;l=l+1|0;o=(l|0)<(c|0);if(o){p=m;q=l;while(1){r=a+((Y(q,h)|0)+m<<2)|0;s=+L(+(+n[r>>2]));r=a+((Y(p,h)|0)+m<<2)|0;t=s>+L(+(+n[r>>2]));r=t?q:p;q=q+1|0;if((q|0)==(c|0)){u=r;break}else p=r}}else u=m;p=Y(u,h)|0;if(+L(+(+n[a+(p+m<<2)>>2]))<1.1920928955078125e-06){v=0;break}if((u|0)==(m|0))w=i;else{q=Y(m,h)|0;r=m;do{t=a+(r+q<<2)|0;x=a+(r+p<<2)|0;y=f[t>>2]|0;f[t>>2]=f[x>>2];f[x>>2]=y;r=r+1|0}while((r|0)!=(c|0));if(!k){r=Y(m,b)|0;p=Y(u,b)|0;q=0;do{y=d+(q+r<<2)|0;x=d+(q+p<<2)|0;t=f[y>>2]|0;f[y>>2]=f[x>>2];f[x>>2]=t;q=q+1|0}while((q|0)!=(g|0))}w=0-i|0}q=Y(m,h)|0;s=-1.0/+n[a+(q+m<<2)>>2];if(!o){z=w;break a}p=Y(m,b)|0;r=l;do{t=Y(r,h)|0;A=s*+n[a+(t+m<<2)>>2];x=l;do{y=a+(x+t<<2)|0;n[y>>2]=+n[y>>2]+A*+n[a+(x+q<<2)>>2];x=x+1|0}while((x|0)!=(c|0));if(!j){x=Y(r,b)|0;t=0;do{y=d+(t+x<<2)|0;n[y>>2]=+n[y>>2]+A*+n[d+(t+p<<2)>>2];t=t+1|0}while((t|0)!=(g|0))}r=r+1|0}while((r|0)!=(c|0));if(!o){z=w;break a}else i=w}return v|0}else z=1;while(0);if(e&(d|0)!=0&(g|0)>0)B=c;else{v=z;return v|0}do{e=B;B=B+-1|0;w=Y(B,b)|0;u=Y(B,h)|0;i=a+(u+B<<2)|0;if((e|0)<(c|0)){j=0;do{l=d+(j+w<<2)|0;s=+n[l>>2];k=e;do{r=d+((Y(k,b)|0)+j<<2)|0;s=s-+n[a+(k+u<<2)>>2]*+n[r>>2];k=k+1|0}while((k|0)!=(c|0));n[l>>2]=s/+n[i>>2];j=j+1|0}while((j|0)!=(g|0))}else{j=0;do{u=d+(j+w<<2)|0;n[u>>2]=+n[u>>2]/+n[i>>2];j=j+1|0}while((j|0)!=(g|0))}}while((e|0)>1);v=z;return v|0}function lZ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h;dQ(i,48104);j=mZ(a,b,c,d,e,g)|0;if(!(f[i+4>>2]|0)){u=h;return j|0}u=h;return j|0}function mZ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0;g=b>>>3;b=e>>>3;e=(c|0)>0;a:do if(e){h=(d|0)==0;i=h|(f|0)<1;j=h|(f|0)<1;h=1;k=0;while(1){l=k;k=k+1|0;m=(k|0)<(c|0);if(m){n=l;o=k;while(1){q=a+((Y(o,g)|0)+l<<3)|0;r=+L(+(+p[q>>3]));q=a+((Y(n,g)|0)+l<<3)|0;s=r>+L(+(+p[q>>3]));q=s?o:n;o=o+1|0;if((o|0)==(c|0)){t=q;break}else n=q}}else t=l;n=Y(t,g)|0;if(+L(+(+p[a+(n+l<<3)>>3]))<2.220446049250313e-14){u=0;break}if((t|0)==(l|0))v=h;else{o=Y(l,g)|0;q=l;do{s=a+(q+o<<3)|0;w=a+(q+n<<3)|0;r=+p[s>>3];p[s>>3]=+p[w>>3];p[w>>3]=r;q=q+1|0}while((q|0)!=(c|0));if(!j){q=Y(l,b)|0;n=Y(t,b)|0;o=0;do{w=d+(o+q<<3)|0;s=d+(o+n<<3)|0;r=+p[w>>3];p[w>>3]=+p[s>>3];p[s>>3]=r;o=o+1|0}while((o|0)!=(f|0))}v=0-h|0}o=Y(l,g)|0;r=-1.0/+p[a+(o+l<<3)>>3];if(!m){x=v;break a}n=Y(l,b)|0;q=k;do{s=Y(q,g)|0;y=r*+p[a+(s+l<<3)>>3];w=k;do{z=a+(w+s<<3)|0;p[z>>3]=+p[z>>3]+y*+p[a+(w+o<<3)>>3];w=w+1|0}while((w|0)!=(c|0));if(!i){w=Y(q,b)|0;s=0;do{z=d+(s+w<<3)|0;p[z>>3]=+p[z>>3]+y*+p[d+(s+n<<3)>>3];s=s+1|0}while((s|0)!=(f|0))}q=q+1|0}while((q|0)!=(c|0));if(!m){x=v;break a}else h=v}return u|0}else x=1;while(0);if(e&(d|0)!=0&(f|0)>0)A=c;else{u=x;return u|0}do{e=A;A=A+-1|0;v=Y(A,b)|0;t=Y(A,g)|0;h=a+(t+A<<3)|0;if((e|0)<(c|0)){i=0;do{k=d+(i+v<<3)|0;r=+p[k>>3];j=e;do{q=d+((Y(j,b)|0)+i<<3)|0;r=r-+p[a+(j+t<<3)>>3]*+p[q>>3];j=j+1|0}while((j|0)!=(c|0));p[k>>3]=r/+p[h>>3];i=i+1|0}while((i|0)!=(f|0))}else{i=0;do{t=d+(i+v<<3)|0;p[t>>3]=+p[t>>3]/+p[h>>3];i=i+1|0}while((i|0)!=(f|0))}}while((e|0)>1);u=x;return u|0}function nZ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h;dQ(i,48124);j=oZ(a,b,c,d,e,g)|0;if(!(f[i+4>>2]|0)){u=h;return j|0}u=h;return j|0}function oZ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=b>>>2;b=e>>>2;e=(c|0)>0;a:do if(e){h=0;while(1){i=(h|0)>0;j=Y(h,g)|0;if(i){k=0;do{l=a+(k+j<<2)|0;m=+n[l>>2];o=Y(k,g)|0;if((k|0)>0){p=m;q=0;while(1){r=p-+n[a+(q+j<<2)>>2]*+n[a+(q+o<<2)>>2];q=q+1|0;if((q|0)==(k|0)){s=r;break}else p=r}}else s=m;n[l>>2]=s*+n[a+(o+k<<2)>>2];k=k+1|0}while((k|0)!=(h|0));k=a+(j+h<<2)|0;p=+n[k>>2];if(i){q=0;r=p;while(1){t=+n[a+(q+j<<2)>>2];u=r-t*t;q=q+1|0;if((q|0)==(h|0)){v=u;w=k;break}else r=u}}else{v=p;w=k}}else{q=a+(j+h<<2)|0;v=+n[q>>2];w=q}if(v<1.1920928955078125e-07){x=0;break}r=1.0/+M(+v);n[w>>2]=r;h=h+1|0;if((h|0)>=(c|0))break a}return x|0}while(0);if(!d){if(e)y=0;else{x=1;return x|0}do{w=a+((Y(y,g)|0)+y<<2)|0;n[w>>2]=1.0/+n[w>>2];y=y+1|0}while((y|0)!=(c|0));x=1;return x|0}if(!e){x=1;return x|0}if((f|0)>0){y=0;do{w=Y(y,b)|0;h=Y(y,g)|0;q=a+(h+y<<2)|0;if((y|0)>0){i=0;do{z=d+(i+w<<2)|0;A=0;v=+n[z>>2];do{B=d+((Y(A,b)|0)+i<<2)|0;v=v-+n[a+(A+h<<2)>>2]*+n[B>>2];A=A+1|0}while((A|0)!=(y|0));n[z>>2]=v*+n[q>>2];i=i+1|0}while((i|0)!=(f|0))}else{i=0;do{h=d+(i+w<<2)|0;n[h>>2]=+n[h>>2]*+n[q>>2];i=i+1|0}while((i|0)!=(f|0))}y=y+1|0}while((y|0)!=(c|0));y=c+-1|0;if(!e){x=1;return x|0}if((f|0)>0){i=y;while(1){q=Y(i,b)|0;w=a+((Y(i,g)|0)+i<<2)|0;if((y|0)>(i|0)){h=0;do{A=d+(h+q<<2)|0;j=y;p=+n[A>>2];do{k=a+((Y(j,g)|0)+i<<2)|0;B=d+((Y(j,b)|0)+h<<2)|0;p=p-+n[k>>2]*+n[B>>2];j=j+-1|0}while((j|0)>(i|0));n[A>>2]=p*+n[w>>2];h=h+1|0}while((h|0)!=(f|0))}else{h=0;do{j=d+(h+q<<2)|0;n[j>>2]=+n[j>>2]*+n[w>>2];h=h+1|0}while((h|0)!=(f|0))}if((i|0)>0)i=i+-1|0;else break}if(!e){x=1;return x|0}else C=0}else C=0}else C=0;do{e=a+((Y(C,g)|0)+C<<2)|0;n[e>>2]=1.0/+n[e>>2];C=C+1|0}while((C|0)!=(c|0));x=1;return x|0}function pZ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0;h=u;u=u+16|0;i=h;dQ(i,48144);j=qZ(a,b,c,d,e,g)|0;if(!(f[i+4>>2]|0)){u=h;return j|0}u=h;return j|0}function qZ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=b>>>3;b=e>>>3;e=(c|0)>0;a:do if(e){h=0;while(1){i=(h|0)>0;j=Y(h,g)|0;if(i){k=0;do{l=a+(k+j<<3)|0;m=+p[l>>3];n=Y(k,g)|0;if((k|0)>0){o=m;q=0;while(1){r=o-+p[a+(q+j<<3)>>3]*+p[a+(q+n<<3)>>3];q=q+1|0;if((q|0)==(k|0)){s=r;break}else o=r}}else s=m;p[l>>3]=s*+p[a+(n+k<<3)>>3];k=k+1|0}while((k|0)!=(h|0));k=a+(j+h<<3)|0;o=+p[k>>3];if(i){q=0;r=o;while(1){t=+p[a+(q+j<<3)>>3];u=r-t*t;q=q+1|0;if((q|0)==(h|0)){v=u;w=k;break}else r=u}}else{v=o;w=k}}else{q=a+(j+h<<3)|0;v=+p[q>>3];w=q}if(v<2.220446049250313e-16){x=0;break}r=1.0/+M(+v);p[w>>3]=r;h=h+1|0;if((h|0)>=(c|0))break a}return x|0}while(0);if(!d){if(e)y=0;else{x=1;return x|0}do{w=a+((Y(y,g)|0)+y<<3)|0;p[w>>3]=1.0/+p[w>>3];y=y+1|0}while((y|0)!=(c|0));x=1;return x|0}if(!e){x=1;return x|0}if((f|0)>0){y=0;do{w=Y(y,b)|0;h=Y(y,g)|0;q=a+(h+y<<3)|0;if((y|0)>0){i=0;do{z=d+(i+w<<3)|0;A=0;v=+p[z>>3];do{B=d+((Y(A,b)|0)+i<<3)|0;v=v-+p[a+(A+h<<3)>>3]*+p[B>>3];A=A+1|0}while((A|0)!=(y|0));p[z>>3]=v*+p[q>>3];i=i+1|0}while((i|0)!=(f|0))}else{i=0;do{h=d+(i+w<<3)|0;p[h>>3]=+p[h>>3]*+p[q>>3];i=i+1|0}while((i|0)!=(f|0))}y=y+1|0}while((y|0)!=(c|0));y=c+-1|0;if(!e){x=1;return x|0}if((f|0)>0){i=y;while(1){q=Y(i,b)|0;w=a+((Y(i,g)|0)+i<<3)|0;if((y|0)>(i|0)){h=0;do{A=d+(h+q<<3)|0;j=y;o=+p[A>>3];do{k=a+((Y(j,g)|0)+i<<3)|0;B=d+((Y(j,b)|0)+h<<3)|0;o=o-+p[k>>3]*+p[B>>3];j=j+-1|0}while((j|0)>(i|0));p[A>>3]=o*+p[w>>3];h=h+1|0}while((h|0)!=(f|0))}else{h=0;do{j=d+(h+q<<3)|0;p[j>>3]=+p[j>>3]*+p[w>>3];h=h+1|0}while((h|0)!=(f|0))}if((i|0)>0)i=i+-1|0;else break}if(!e){x=1;return x|0}else C=0}else C=0}else C=0;do{e=a+((Y(C,g)|0)+C<<3)|0;p[e>>3]=1.0/+p[e>>3];C=C+1|0}while((C|0)!=(c|0));x=1;return x|0}function rZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=u;u=u+1072|0;k=j+8|0;l=j;dQ(l,48164);m=b>>>2;b=h>>>2;h=k+8|0;f[k>>2]=h;o=k+4|0;p=(c|0)==0?(i|0)!=0&1:d+c|0;f[o>>2]=p;if(p>>>0>264){q=N5b(p>>>0>1073741823?-1:p<<2)|0;f[k>>2]=q;r=q}else r=h;q=(i|0)==0?r+(c<<2)|0:i;a:do if((d|0)>0){i=0;p=c;while(1){s=c-i|0;t=(s|0)>0;if(t){v=0;w=0.0;while(1){x=a+((Y(v+i|0,m)|0)+i<<2)|0;y=+n[x>>2];n[r+(v<<2)>>2]=y;z=w+y*y;v=v+1|0;if((v|0)==(p|0)){A=z;break}else w=z}}else A=0.0;w=+n[r>>2];z=w+ +M(+A)*(!(w>=0.0)?-1.0:1.0);n[r>>2]=z;y=+M(+(A+z*z-w*w));if(t?(n[r>>2]=z/y,(p|0)!=1):0){v=1;do{x=r+(v<<2)|0;n[x>>2]=+n[x>>2]/y;v=v+1|0}while((v|0)!=(p|0))}if((i|0)<(c|0)){v=i;do{t=i;y=0.0;do{x=a+((Y(t,m)|0)+v<<2)|0;y=y+ +n[r+(t-i<<2)>>2]*+n[x>>2];t=t+1|0}while((t|0)!=(c|0));B=i;do{t=a+((Y(B,m)|0)+v<<2)|0;n[t>>2]=+n[t>>2]-y*(+n[r+(B-i<<2)>>2]*2.0);B=B+1|0}while((B|0)!=(c|0));v=v+1|0}while((v|0)!=(d|0))}y=+n[r>>2];n[q+(i<<2)>>2]=y*y;if((s|0)>1){y=+n[r>>2];v=1;do{t=a+((Y(v+i|0,m)|0)+i<<2)|0;n[t>>2]=+n[r+(v<<2)>>2]/y;v=v+1|0}while((v|0)!=(p|0))}i=i+1|0;if((i|0)==(d|0))break;else p=p+-1|0}if(g){p=(e|0)>0;if(p){i=0;v=c;while(1){n[r>>2]=1.0;if((c-i|0)>1){s=1;do{t=a+((Y(s+i|0,m)|0)+i<<2)|0;f[r+(s<<2)>>2]=f[t>>2];s=s+1|0}while((s|0)!=(v|0))}s=q+(i<<2)|0;if((i|0)<(c|0)){t=0;do{x=i;y=0.0;do{C=g+((Y(x,b)|0)+t<<2)|0;y=y+ +n[r+(x-i<<2)>>2]*+n[C>>2];x=x+1|0}while((x|0)!=(c|0));D=i;do{x=g+((Y(D,b)|0)+t<<2)|0;n[x>>2]=+n[x>>2]-+n[s>>2]*(y*(+n[r+(D-i<<2)>>2]*2.0));D=D+1|0}while((D|0)!=(c|0));t=t+1|0}while((t|0)!=(e|0))}i=i+1|0;if((i|0)==(d|0))break;else v=v+-1|0}}else{v=0;i=c;while(1){n[r>>2]=1.0;if((c-v|0)>1){t=1;do{s=a+((Y(t+v|0,m)|0)+v<<2)|0;f[r+(t<<2)>>2]=f[s>>2];t=t+1|0}while((t|0)!=(i|0))}v=v+1|0;if((v|0)==(d|0))break;else i=i+-1|0}}i=d+-1|0;if(!p){v=i;while(1){t=a+((Y(v,m)|0)+v<<2)|0;if(+L(+(+n[t>>2]))<1.1920928955078125e-06){E=0;break a}if((v|0)>0)v=v+-1|0;else{E=1;break a}}}if((e|0)==1){v=i;while(1){p=Y(v,m)|0;if((i|0)>(v|0)){t=g+((Y(v,b)|0)<<2)|0;s=i;do{x=g+((Y(s,b)|0)<<2)|0;n[t>>2]=+n[t>>2]-+n[x>>2]*+n[a+(s+p<<2)>>2];s=s+-1|0}while((s|0)>(v|0))}y=+n[a+(p+v<<2)>>2];if(+L(+y)<1.1920928955078125e-06){E=0;break a}s=g+((Y(v,b)|0)<<2)|0;n[s>>2]=+n[s>>2]/y;if((v|0)>0)v=v+-1|0;else{E=1;break a}}}else F=i;while(1){v=Y(F,m)|0;if((i|0)>(F|0)){s=Y(F,b)|0;t=i;do{x=Y(t,b)|0;C=a+(t+v<<2)|0;G=0;do{H=g+(G+s<<2)|0;n[H>>2]=+n[H>>2]-+n[g+(G+x<<2)>>2]*+n[C>>2];G=G+1|0}while((G|0)!=(e|0));t=t+-1|0}while((t|0)>(F|0))}t=a+(v+F<<2)|0;y=+n[t>>2];if(+L(+y)<1.1920928955078125e-06){E=0;break a}s=Y(F,b)|0;p=g+(s<<2)|0;n[p>>2]=+n[p>>2]/y;p=1;do{G=g+(p+s<<2)|0;n[G>>2]=+n[G>>2]/+n[t>>2];p=p+1|0}while((p|0)!=(e|0));if((F|0)>0)F=F+-1|0;else{E=1;break}}}else E=1}else E=1;while(0);if((r|0)!=(h|0)){P5b(r);f[k>>2]=h;f[o>>2]=264}if(!(f[l+4>>2]|0)){u=j;return E|0}u=j;return E|0}function sZ(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=u;u=u+1104|0;k=j;l=j+1096|0;dQ(l,48184);m=b>>>3;b=h>>>3;h=k+8|0;f[k>>2]=h;n=k+4|0;o=(c|0)==0?(i|0)!=0&1:d+c|0;f[n>>2]=o;if(o>>>0>136){q=N5b(o>>>0>536870911?-1:o<<3)|0;f[k>>2]=q;r=q}else r=h;q=(i|0)==0?r+(c<<3)|0:i;a:do if((d|0)>0){i=0;o=c;while(1){s=c-i|0;t=(s|0)>0;if(t){v=0;w=0.0;while(1){x=a+((Y(v+i|0,m)|0)+i<<3)|0;y=+p[x>>3];p[r+(v<<3)>>3]=y;z=w+y*y;v=v+1|0;if((v|0)==(o|0)){A=z;break}else w=z}}else A=0.0;w=+p[r>>3];z=w+ +M(+A)*(!(w>=0.0)?-1.0:1.0);p[r>>3]=z;y=+M(+(A+z*z-w*w));if(t?(p[r>>3]=z/y,(o|0)!=1):0){v=1;do{x=r+(v<<3)|0;p[x>>3]=+p[x>>3]/y;v=v+1|0}while((v|0)!=(o|0))}if((i|0)<(c|0)){v=i;do{t=i;y=0.0;do{x=a+((Y(t,m)|0)+v<<3)|0;y=y+ +p[r+(t-i<<3)>>3]*+p[x>>3];t=t+1|0}while((t|0)!=(c|0));B=i;do{t=a+((Y(B,m)|0)+v<<3)|0;p[t>>3]=+p[t>>3]-y*(+p[r+(B-i<<3)>>3]*2.0);B=B+1|0}while((B|0)!=(c|0));v=v+1|0}while((v|0)!=(d|0))}y=+p[r>>3];p[q+(i<<3)>>3]=y*y;if((s|0)>1){y=+p[r>>3];v=1;do{t=a+((Y(v+i|0,m)|0)+i<<3)|0;p[t>>3]=+p[r+(v<<3)>>3]/y;v=v+1|0}while((v|0)!=(o|0))}i=i+1|0;if((i|0)==(d|0))break;else o=o+-1|0}if(g){o=(e|0)>0;if(o){i=0;v=c;while(1){p[r>>3]=1.0;if((c-i|0)>1){s=1;do{t=a+((Y(s+i|0,m)|0)+i<<3)|0;p[r+(s<<3)>>3]=+p[t>>3];s=s+1|0}while((s|0)!=(v|0))}s=q+(i<<3)|0;if((i|0)<(c|0)){t=0;do{x=i;y=0.0;do{C=g+((Y(x,b)|0)+t<<3)|0;y=y+ +p[r+(x-i<<3)>>3]*+p[C>>3];x=x+1|0}while((x|0)!=(c|0));D=i;do{x=g+((Y(D,b)|0)+t<<3)|0;p[x>>3]=+p[x>>3]-+p[s>>3]*(y*(+p[r+(D-i<<3)>>3]*2.0));D=D+1|0}while((D|0)!=(c|0));t=t+1|0}while((t|0)!=(e|0))}i=i+1|0;if((i|0)==(d|0))break;else v=v+-1|0}}else{v=0;i=c;while(1){p[r>>3]=1.0;if((c-v|0)>1){t=1;do{s=a+((Y(t+v|0,m)|0)+v<<3)|0;p[r+(t<<3)>>3]=+p[s>>3];t=t+1|0}while((t|0)!=(i|0))}v=v+1|0;if((v|0)==(d|0))break;else i=i+-1|0}}i=d+-1|0;if(!o){v=i;while(1){t=a+((Y(v,m)|0)+v<<3)|0;if(+L(+(+p[t>>3]))<2.220446049250313e-14){E=0;break a}if((v|0)>0)v=v+-1|0;else{E=1;break a}}}if((e|0)==1){v=i;while(1){o=Y(v,m)|0;if((i|0)>(v|0)){t=g+((Y(v,b)|0)<<3)|0;s=i;do{x=g+((Y(s,b)|0)<<3)|0;p[t>>3]=+p[t>>3]-+p[x>>3]*+p[a+(s+o<<3)>>3];s=s+-1|0}while((s|0)>(v|0))}y=+p[a+(o+v<<3)>>3];if(+L(+y)<2.220446049250313e-14){E=0;break a}s=g+((Y(v,b)|0)<<3)|0;p[s>>3]=+p[s>>3]/y;if((v|0)>0)v=v+-1|0;else{E=1;break a}}}else F=i;while(1){v=Y(F,m)|0;if((i|0)>(F|0)){s=Y(F,b)|0;t=i;do{x=Y(t,b)|0;C=a+(t+v<<3)|0;G=0;do{H=g+(G+s<<3)|0;p[H>>3]=+p[H>>3]-+p[g+(G+x<<3)>>3]*+p[C>>3];G=G+1|0}while((G|0)!=(e|0));t=t+-1|0}while((t|0)>(F|0))}t=a+(v+F<<3)|0;y=+p[t>>3];if(+L(+y)<2.220446049250313e-14){E=0;break a}s=Y(F,b)|0;o=g+(s<<3)|0;p[o>>3]=+p[o>>3]/y;o=1;do{G=g+(o+s<<3)|0;p[G>>3]=+p[G>>3]/+p[t>>3];o=o+1|0}while((o|0)!=(e|0));if((F|0)>0)F=F+-1|0;else{E=1;break}}}else E=1}else E=1;while(0);if((r|0)!=(h|0)){P5b(r);f[k>>2]=h;f[n>>2]=136}if(!(f[l+4>>2]|0)){u=j;return E|0}u=j;return E|0}function tZ(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;g=u;u=u+3376|0;h=g;i=g+3360|0;j=g+3304|0;k=g+2184|0;l=g+1120|0;m=g+56|0;o=g+3248|0;dQ(i,48204);p=a+4|0;q=c+4|0;if((f[p>>2]|0)==(f[q>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;r=aD(h,34)|0;s=216255;t=r+34|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,h,216290,216301,133);bD(h)}do if((yM(a)|0)==65536){v=f[p>>2]|0;f[j>>2]=f[v>>2];w=j+4|0;x=v+4|0;f[w>>2]=f[x>>2];y=j+8|0;f[y>>2]=f[v+8>>2];f[j+12>>2]=f[v+12>>2];f[j+16>>2]=f[v+16>>2];f[j+20>>2]=f[v+20>>2];f[j+24>>2]=f[v+24>>2];f[j+28>>2]=f[v+28>>2];f[j+32>>2]=f[v+32>>2];z=f[v+36>>2]|0;f[j+36>>2]=z;f[j+40>>2]=y;y=j+48|0;A=j+44|0;f[A>>2]=y;f[y>>2]=0;f[j+52>>2]=0;if(z|0){y=z+12|0;f[y>>2]=(f[y>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;y=f[A>>2]|0;f[y>>2]=f[x>>2];f[y+4>>2]=f[x+4>>2];break}else{f[w>>2]=0;jL(j,v);break}}else yL(j,a,-1);while(0);a=wM(j,2,-1,1)|0;p=f[j>>2]&7;if(!((a|0)>-1&(p|1|0)==5)){f[h>>2]=0;f[h+4>>2]=0;r=aD(h,40)|0;s=216374;t=r+40|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,h,216290,216301,137);bD(h)}if(a){if(MM(c)|0)B=(BL(c,-1)|0)!=4;else B=e;e=(p|0)==5;v=k+8|0;f[k>>2]=v;w=k+4|0;x=a>>>0>264;f[w>>2]=a;if(x){y=N5b(a>>>0>1073741823?-1:a<<2)|0;f[k>>2]=y;C=y}else C=v;y=a+2|0;A=l+8|0;f[l>>2]=A;z=l+4|0;f[z>>2]=y;if(y>>>0>264){D=N5b(y>>>0>1073741823?-1:y<<2)|0;f[l>>2]=D;E=D}else E=A;D=m+8|0;f[m>>2]=D;y=m+4|0;f[y>>2]=a;if(x){x=N5b(a>>>0>1073741823?-1:a<<2)|0;f[m>>2]=x;F=x}else F=D;x=f[j+16>>2]|0;if(!(f[j>>2]&16384)){f[h>>2]=0;f[h+4>>2]=0;r=aD(h,21)|0;s=216415;t=r+21|0;do{b[r>>0]=b[s>>0]|0;r=r+1|0;s=s+1|0}while((r|0)<(t|0));bO(-215,h,216290,216301,156);bD(h)}if((a|0)>0){s=0;do{f[C+(s<<2)>>2]=x+(s<<3);s=s+1|0}while((s|0)!=(a|0))}s=C+(a<<2)|0;if(e){vZ(C,s,h);if((a|0)>1){r=1;t=0;G=0;while(1){H=+n[(f[C+(r<<2)>>2]|0)+4>>2];I=+n[(f[C+(t<<2)>>2]|0)+4>>2]>H?r:t;J=+n[(f[C+(G<<2)>>2]|0)+4>>2]<H?r:G;r=r+1|0;if((r|0)==(a|0)){K=I;L=J;break}else{t=I;G=J}}}else{K=0;L=0}}else{uZ(C,s,h);if((a|0)>1){s=0;G=0;t=1;while(1){r=f[(f[C+(t<<2)>>2]|0)+4>>2]|0;J=(f[(f[C+(s<<2)>>2]|0)+4>>2]|0)>(r|0)?t:s;I=(f[(f[C+(G<<2)>>2]|0)+4>>2]|0)<(r|0)?t:G;t=t+1|0;if((t|0)==(a|0)){K=J;L=I;break}else{s=J;G=I}}}else{K=0;L=0}}G=f[C>>2]|0;s=a+-1|0;a=f[C+(s<<2)>>2]|0;if((f[G>>2]|0)==(f[a>>2]|0)?(f[G+4>>2]|0)==(f[a+4>>2]|0):0){f[F>>2]=0;M=1}else{a=E;if(e){G=xZ(C,0,L,E,-1,1)|0;t=E+(G<<2)|0;N=t;O=xZ(C,s,L,t,-1,-1)|0;P=G}else{G=wZ(C,0,L,E,-1,1)|0;t=E+(G<<2)|0;N=t;O=wZ(C,s,L,t,-1,-1)|0;P=G}G=N;N=d?a:G;t=d?P:O;L=d?G:a;G=d?O:P;P=t+-1|0;if((t|0)>1){O=N;I=x;J=0;do{f[F+(J<<2)>>2]=(f[C+(f[O+(J<<2)>>2]<<2)>>2]|0)-I>>3;J=J+1|0}while((J|0)!=(P|0));Q=P}else Q=0;if((G|0)>1){P=L;J=x;I=G+Q+-1|0;O=Q;r=G;do{r=r+-1|0;R=O;O=O+1|0;f[F+(R<<2)>>2]=(f[C+(f[P+(r<<2)>>2]<<2)>>2]|0)-J>>3}while((O|0)!=(I|0));if((G|0)>2){S=I;T=L+4|0;U=47}else{V=I;U=45}}else{V=Q;U=45}if((U|0)==45)if((t|0)>2){S=V;T=N+(t+-2<<2)|0;U=47}else{W=V;X=-1}if((U|0)==47){W=S;X=f[T>>2]|0}if(e){e=xZ(C,0,K,E,1,-1)|0;T=E+(e<<2)|0;Z=T;_=e;$=xZ(C,s,K,T,1,1)|0}else{T=wZ(C,0,K,E,1,-1)|0;e=E+(T<<2)|0;Z=e;_=T;$=wZ(C,s,K,e,1,1)|0}e=Z;Z=d?e:a;K=d?$:_;s=d?a:e;e=d?_:$;do if((X|0)>-1){do if((K|0)>2){aa=Z+4|0;U=56}else{if((K+e|0)<=2){ba=-1;break}aa=s+(2-K<<2)|0;U=56}while(0);if((U|0)==56)ba=f[aa>>2]|0;if((ba|0)!=(X|0)){if((ba|0)<=-1){U=62;break}$=f[C+(ba<<2)>>2]|0;_=f[C+(X<<2)>>2]|0;if((f[$>>2]|0)!=(f[_>>2]|0)){U=62;break}if((f[$+4>>2]|0)!=(f[_+4>>2]|0)){U=62;break}}_=(e|0)<2?e:2;if((K|0)<2){ca=_;da=W}else{ea=_;fa=2;ga=1;U=63}}else U=62;while(0);if((U|0)==62)if((K|0)>1){ea=e;fa=K;ga=K+-1|0;U=63}else{ca=e;da=W}if((U|0)==63){U=Z;Z=x;e=fa+W|0;fa=W;W=0;while(1){f[F+(fa<<2)>>2]=(f[C+(f[U+(W<<2)>>2]<<2)>>2]|0)-Z>>3;W=W+1|0;if((W|0)==(ga|0))break;else fa=fa+1|0}ca=ea;da=e+-1|0}if((ca|0)>1){e=s;s=x;ea=ca+da|0;fa=da;ga=ca;while(1){ga=ga+-1|0;f[F+(fa<<2)>>2]=(f[C+(f[e+(ga<<2)>>2]<<2)>>2]|0)-s>>3;if((ga|0)<=1)break;else fa=fa+1|0}M=ea+-1|0}else M=da}if(B){aM(c,M,1,p|8,-1,0,0);do if((yM(c)|0)==65536){p=f[q>>2]|0;f[h>>2]=f[p>>2];B=h+4|0;da=p+4|0;f[B>>2]=f[da>>2];ea=h+8|0;f[ea>>2]=f[p+8>>2];f[h+12>>2]=f[p+12>>2];f[h+16>>2]=f[p+16>>2];f[h+20>>2]=f[p+20>>2];f[h+24>>2]=f[p+24>>2];f[h+28>>2]=f[p+28>>2];f[h+32>>2]=f[p+32>>2];fa=f[p+36>>2]|0;f[h+36>>2]=fa;f[h+40>>2]=ea;ea=h+48|0;ga=h+44|0;f[ga>>2]=ea;f[ea>>2]=0;f[h+52>>2]=0;if(fa|0){ea=fa+12|0;f[ea>>2]=(f[ea>>2]|0)+1}if((f[da>>2]|0)<3){da=f[p+44>>2]|0;ea=f[ga>>2]|0;f[ea>>2]=f[da>>2];f[ea+4>>2]=f[da+4>>2];ha=h;break}else{f[B>>2]=0;jL(h,p);ha=h;break}}else{yL(h,c,-1);ha=h}while(0);if(!(f[ha>>2]&16384))ia=f[f[h+44>>2]>>2]|0;else ia=8;if((M|0)>0){ha=f[h+16>>2]|0;q=0;do{p=f[F+(q<<2)>>2]|0;B=ha+(Y(q,ia)|0)|0;f[B>>2]=f[x+(p<<3)>>2];f[B+4>>2]=f[x+(p<<3)+4>>2];q=q+1|0}while((q|0)!=(M|0))}q=h+36|0;x=f[q>>2]|0;do if(x|0){ia=x+12|0;ha=f[ia>>2]|0;f[ia>>2]=ha+-1;if((ha|0)!=1)break;kL(h)}while(0);f[q>>2]=0;q=h+16|0;x=h+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[x>>2]|0)>0){q=f[h+40>>2]|0;ha=0;do{f[q+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[x>>2]|0))}x=f[h+44>>2]|0;if((x|0)!=(h+48|0))UC(x)}else{x=o+4|0;f[x>>2]=2;h=o+8|0;f[h>>2]=M;f[o+12>>2]=1;M=o+16|0;f[M>>2]=F;f[o+20>>2]=F;ha=o+24|0;q=o+40|0;ia=ha+8|0;f[ia>>2]=0;f[ia+4>>2]=0;f[q>>2]=h;ia=o+48|0;p=o+44|0;f[p>>2]=ia;f[o>>2]=1124024324;f[ia>>2]=4;f[o+52>>2]=4;B=F+(f[h>>2]<<2)|0;f[o+28>>2]=B;f[ha>>2]=B+-4+4;SP(o,c);B=o+36|0;ha=f[B>>2]|0;if(ha|0?(h=ha+12|0,ha=f[h>>2]|0,f[h>>2]=ha+-1,(ha|0)==1):0)kL(o);f[B>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[x>>2]|0)>0){M=f[q>>2]|0;q=0;do{f[M+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[x>>2]|0))}x=f[p>>2]|0;if((x|0)!=(ia|0))UC(x)}x=f[m>>2]|0;if((x|0)!=(D|0)){if(x|0)P5b(x);f[m>>2]=D;f[y>>2]=264}y=f[l>>2]|0;if((y|0)!=(A|0)){if(y|0)P5b(y);f[l>>2]=A;f[z>>2]=264}z=f[k>>2]|0;if((z|0)!=(v|0)){if(z|0)P5b(z);f[k>>2]=v;f[w>>2]=264}}else $L(c);c=j+36|0;w=f[c>>2]|0;if(w|0?(v=w+12|0,w=f[v>>2]|0,f[v>>2]=w+-1,(w|0)==1):0)kL(j);f[c>>2]=0;c=j+16|0;w=j+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[w>>2]|0)>0){c=f[j+40>>2]|0;v=0;do{f[c+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[w>>2]|0))}w=f[j+44>>2]|0;if((w|0)!=(j+48|0))UC(w);if(!(f[i+4>>2]|0)){u=g;return}u=g;return}function uZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=a+-8|0;h=d;while(1){i=h;b:while(1){j=i;k=b-j|0;l=k>>2;switch(l|0){case 2:{m=5;break a;break}case 3:{m=9;break a;break}case 4:{m=27;break a;break}case 5:{m=28;break a;break}case 1:case 0:{m=107;break a;break}default:{}}if((k|0)<124){m=30;break a}n=i+(((l|0)/2|0)<<2)|0;do if((k|0)>3996){o=(l|0)/4|0;p=DZ(i,i+(o<<2)|0,n,n+(o<<2)|0,e,c)|0}else{o=f[n>>2]|0;q=f[i>>2]|0;r=f[o>>2]|0;s=f[q>>2]|0;t=o;u=q;if((r|0)>=(s|0))if((r|0)==(s|0))v=(f[o+4>>2]|0)<(f[q+4>>2]|0);else v=0;else v=1;w=f[e>>2]|0;x=f[w>>2]|0;y=w;if((x|0)>=(r|0))if((x|0)==(r|0))z=(f[w+4>>2]|0)<(f[o+4>>2]|0);else z=0;else z=1;if(!v){if(!z){p=0;break}f[n>>2]=y;f[e>>2]=t;o=f[n>>2]|0;w=f[i>>2]|0;r=f[o>>2]|0;x=f[w>>2]|0;A=w;B=o;if((r|0)>=(x|0)){if((r|0)!=(x|0)){p=1;break}if((f[o+4>>2]|0)>=(f[w+4>>2]|0)){p=1;break}}f[i>>2]=B;f[n>>2]=A;p=2;break}if(z){f[i>>2]=y;f[e>>2]=u;p=1;break}f[i>>2]=t;f[n>>2]=u;t=f[e>>2]|0;y=f[t>>2]|0;A=t;if((y|0)>=(s|0)){if((y|0)!=(s|0)){p=1;break}if((f[t+4>>2]|0)>=(f[q+4>>2]|0)){p=1;break}}f[n>>2]=A;f[e>>2]=u;p=2}while(0);C=f[i>>2]|0;l=f[n>>2]|0;k=f[C>>2]|0;u=f[l>>2]|0;if((k|0)<(u|0)){D=e;E=p;break}if((k|0)==(u|0)?(f[C+4>>2]|0)<(f[l+4>>2]|0):0){D=e;E=p;break}if((i|0)!=(g|0)){A=l+4|0;F=g;while(1){G=f[F>>2]|0;l=f[G>>2]|0;if((l|0)<(u|0)){m=82;break b}if((l|0)==(u|0)?(f[G+4>>2]|0)<(f[A>>2]|0):0){m=82;break b}l=F+-4|0;if((i|0)==(l|0))break;else F=l}}A=i+4|0;u=f[e>>2]|0;l=f[u>>2]|0;q=u;do if((k|0)<(l|0))H=A;else{if((k|0)==(l|0)?(f[C+4>>2]|0)<(f[u+4>>2]|0):0){H=A;break}if((A|0)==(e|0)){m=107;break a}t=C+4|0;s=A;while(1){I=f[s>>2]|0;y=f[I>>2]|0;if((k|0)<(y|0))break;if((k|0)==(y|0)?(f[t>>2]|0)<(f[I+4>>2]|0):0)break;y=s+4|0;if((y|0)==(e|0)){m=107;break a}else s=y}f[s>>2]=q;f[e>>2]=I;H=s+4|0}while(0);if((H|0)==(e|0)){m=107;break a}else{J=e;K=H}while(1){q=f[i>>2]|0;k=f[K>>2]|0;A=f[q>>2]|0;u=f[k>>2]|0;c:do if((A|0)<(u|0))L=K;else{l=q+4|0;t=K;y=u;B=k;while(1){if((A|0)==(y|0)?(f[l>>2]|0)<(f[B+4>>2]|0):0){L=t;break c}w=t+4|0;B=f[w>>2]|0;y=f[B>>2]|0;if((A|0)<(y|0)){L=w;break}else t=w}}while(0);k=q+4|0;u=J;while(1){s=u;u=u+-4|0;M=f[u>>2]|0;s=f[M>>2]|0;if((A|0)<(s|0)){u=u;continue}if((A|0)!=(s|0))break;if((f[k>>2]|0)>=(f[M+4>>2]|0))break}if(L>>>0>=u>>>0){i=L;continue b}k=f[L>>2]|0;f[L>>2]=M;f[u>>2]=k;J=u;K=L+4|0}}if((m|0)==82){m=0;f[i>>2]=G;f[F>>2]=C;D=F;E=p+1|0}k=i+4|0;d:do if(k>>>0<D>>>0){A=n;q=D;s=k;t=E;while(1){y=f[A>>2]|0;B=f[y>>2]|0;l=y+4|0;y=s;while(1){N=f[y>>2]|0;w=f[N>>2]|0;if((w|0)>=(B|0)){if((w|0)!=(B|0))break;if((f[N+4>>2]|0)>=(f[l>>2]|0))break}y=y+4|0}u=N;w=q+-4|0;o=f[w>>2]|0;x=f[o>>2]|0;e:do if((x|0)<(B|0))O=w;else{r=x;P=o;Q=w;while(1){if((r|0)==(B|0)?(f[P+4>>2]|0)<(f[l>>2]|0):0){O=Q;break e}R=Q+-4|0;P=f[R>>2]|0;r=f[P>>2]|0;if((r|0)<(B|0)){O=R;break}else Q=R}}while(0);if(y>>>0>O>>>0){S=A;T=t;U=y;break d}f[y>>2]=f[O>>2];f[O>>2]=u;A=(A|0)==(y|0)?O:A;q=O;s=y+4|0;t=t+1|0}}else{S=n;T=E;U=k}while(0);do if((U|0)==(S|0))V=T;else{k=f[S>>2]|0;t=f[U>>2]|0;s=f[k>>2]|0;q=f[t>>2]|0;A=t;B=k;if((s|0)>=(q|0)){if((s|0)!=(q|0)){V=T;break}if((f[k+4>>2]|0)>=(f[t+4>>2]|0)){V=T;break}}f[U>>2]=B;f[S>>2]=A;V=T+1|0}while(0);if(!V){W=FZ(i,U,c)|0;A=U+4|0;if(FZ(A,a,c)|0){m=106;break}if(W){h=A;continue}}A=U;if((A-j|0)>=(b-A|0)){m=105;break}uZ(i,U,c);h=U+4|0}if((m|0)==105){m=0;uZ(U+4|0,a,c);d=i;a=U;continue}else if((m|0)==106){m=0;if(W){m=107;break}else{d=i;a=U;continue}}}if((m|0)==5){U=f[e>>2]|0;d=f[i>>2]|0;W=f[U>>2]|0;j=f[d>>2]|0;V=d;T=U;if((W|0)>=(j|0)){if((W|0)!=(j|0))return;if((f[U+4>>2]|0)>=(f[d+4>>2]|0))return}f[i>>2]=T;f[e>>2]=V;return}else if((m|0)==9){V=i+4|0;T=f[V>>2]|0;d=f[i>>2]|0;U=f[T>>2]|0;j=f[d>>2]|0;W=T;S=d;if((U|0)>=(j|0))if((U|0)==(j|0))X=(f[T+4>>2]|0)<(f[d+4>>2]|0);else X=0;else X=1;E=f[e>>2]|0;n=f[E>>2]|0;O=E;if((n|0)>=(U|0))if((n|0)==(U|0))Y=(f[E+4>>2]|0)<(f[T+4>>2]|0);else Y=0;else Y=1;if(!X){if(!Y)return;f[V>>2]=O;f[e>>2]=W;X=f[V>>2]|0;T=f[i>>2]|0;E=f[X>>2]|0;U=f[T>>2]|0;n=T;N=X;if((E|0)>=(U|0)){if((E|0)!=(U|0))return;if((f[X+4>>2]|0)>=(f[T+4>>2]|0))return}f[i>>2]=N;f[V>>2]=n;return}if(Y){f[i>>2]=O;f[e>>2]=S;return}f[i>>2]=W;f[V>>2]=S;W=f[e>>2]|0;O=f[W>>2]|0;Y=W;if((O|0)>=(j|0)){if((O|0)!=(j|0))return;if((f[W+4>>2]|0)>=(f[d+4>>2]|0))return}f[V>>2]=Y;f[e>>2]=S;return}else if((m|0)==27){CZ(i,i+4|0,i+8|0,e,c)|0;return}else if((m|0)==28){DZ(i,i+4|0,i+8|0,i+12|0,e,c)|0;return}else if((m|0)==30){EZ(i,a,c);return}else if((m|0)==107)return}function vZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;d=a;a=b;a:while(1){b=a;e=a+-4|0;g=a+-8|0;h=d;while(1){i=h;b:while(1){j=i;k=b-j|0;l=k>>2;switch(l|0){case 2:{m=5;break a;break}case 3:{m=9;break a;break}case 4:{m=27;break a;break}case 5:{m=28;break a;break}case 1:case 0:{m=107;break a;break}default:{}}if((k|0)<124){m=30;break a}o=i+(((l|0)/2|0)<<2)|0;do if((k|0)>3996){p=(l|0)/4|0;q=zZ(i,i+(p<<2)|0,o,o+(p<<2)|0,e,c)|0}else{p=f[o>>2]|0;r=f[i>>2]|0;s=+n[p>>2];t=+n[r>>2];u=p;v=r;if(!(s<t))if(s==t)w=+n[p+4>>2]<+n[r+4>>2];else w=0;else w=1;x=f[e>>2]|0;y=+n[x>>2];z=x;if(!(y<s))if(y==s)A=+n[x+4>>2]<+n[p+4>>2];else A=0;else A=1;if(!w){if(!A){q=0;break}f[o>>2]=z;f[e>>2]=u;p=f[o>>2]|0;x=f[i>>2]|0;s=+n[p>>2];y=+n[x>>2];B=x;C=p;if(!(s<y)){if(!(s==y)){q=1;break}if(!(+n[p+4>>2]<+n[x+4>>2])){q=1;break}}f[i>>2]=C;f[o>>2]=B;q=2;break}if(A){f[i>>2]=z;f[e>>2]=v;q=1;break}f[i>>2]=u;f[o>>2]=v;u=f[e>>2]|0;y=+n[u>>2];z=u;if(!(y<t)){if(!(y==t)){q=1;break}if(!(+n[u+4>>2]<+n[r+4>>2])){q=1;break}}f[o>>2]=z;f[e>>2]=v;q=2}while(0);D=f[i>>2]|0;l=f[o>>2]|0;t=+n[D>>2];y=+n[l>>2];if(t<y){E=e;F=q;break}if(t==y?+n[D+4>>2]<+n[l+4>>2]:0){E=e;F=q;break}if((i|0)!=(g|0)){k=l+4|0;G=g;while(1){H=f[G>>2]|0;s=+n[H>>2];if(s<y){m=82;break b}if(s==y?+n[H+4>>2]<+n[k>>2]:0){m=82;break b}l=G+-4|0;if((i|0)==(l|0))break;else G=l}}k=i+4|0;l=f[e>>2]|0;y=+n[l>>2];v=l;do if(t<y)I=k;else{if(t==y?+n[D+4>>2]<+n[l+4>>2]:0){I=k;break}if((k|0)==(e|0)){m=107;break a}z=D+4|0;r=k;while(1){J=f[r>>2]|0;s=+n[J>>2];if(t<s)break;if(t==s?+n[z>>2]<+n[J+4>>2]:0)break;u=r+4|0;if((u|0)==(e|0)){m=107;break a}else r=u}f[r>>2]=v;f[e>>2]=J;I=r+4|0}while(0);if((I|0)==(e|0)){m=107;break a}else{K=e;L=I}while(1){v=f[i>>2]|0;k=f[L>>2]|0;t=+n[v>>2];y=+n[k>>2];c:do if(t<y)M=L;else{l=v+4|0;z=L;s=y;u=k;while(1){if(t==s?+n[l>>2]<+n[u+4>>2]:0){M=z;break c}B=z+4|0;u=f[B>>2]|0;s=+n[u>>2];if(t<s){M=B;break}else z=B}}while(0);k=v+4|0;r=K;while(1){z=r;r=r+-4|0;N=f[r>>2]|0;y=+n[N>>2];if(t<y){r=r;continue}if(!(t==y))break;if(!(+n[k>>2]<+n[N+4>>2]))break}if(M>>>0>=r>>>0){i=M;continue b}k=f[M>>2]|0;f[M>>2]=N;f[r>>2]=k;K=r;L=M+4|0}}if((m|0)==82){m=0;f[i>>2]=H;f[G>>2]=D;E=G;F=q+1|0}k=i+4|0;d:do if(k>>>0<E>>>0){v=o;z=E;u=k;l=F;while(1){B=f[v>>2]|0;t=+n[B>>2];C=B+4|0;B=u;while(1){O=f[B>>2]|0;y=+n[O>>2];if(!(y<t)){if(!(y==t))break;if(!(+n[O+4>>2]<+n[C>>2]))break}B=B+4|0}r=O;x=z+-4|0;p=f[x>>2]|0;y=+n[p>>2];e:do if(y<t)P=x;else{s=y;Q=p;R=x;while(1){if(s==t?+n[Q+4>>2]<+n[C>>2]:0){P=R;break e}S=R+-4|0;Q=f[S>>2]|0;s=+n[Q>>2];if(s<t){P=S;break}else R=S}}while(0);if(B>>>0>P>>>0){T=v;U=l;V=B;break d}f[B>>2]=f[P>>2];f[P>>2]=r;v=(v|0)==(B|0)?P:v;z=P;u=B+4|0;l=l+1|0}}else{T=o;U=F;V=k}while(0);do if((V|0)==(T|0))W=U;else{k=f[T>>2]|0;l=f[V>>2]|0;t=+n[k>>2];y=+n[l>>2];u=l;z=k;if(!(t<y)){if(!(t==y)){W=U;break}if(!(+n[k+4>>2]<+n[l+4>>2])){W=U;break}}f[V>>2]=z;f[T>>2]=u;W=U+1|0}while(0);if(!W){X=BZ(i,V,c)|0;u=V+4|0;if(BZ(u,a,c)|0){m=106;break}if(X){h=u;continue}}u=V;if((u-j|0)>=(b-u|0)){m=105;break}vZ(i,V,c);h=V+4|0}if((m|0)==105){m=0;vZ(V+4|0,a,c);d=i;a=V;continue}else if((m|0)==106){m=0;if(X){m=107;break}else{d=i;a=V;continue}}}if((m|0)==5){V=f[e>>2]|0;d=f[i>>2]|0;y=+n[V>>2];t=+n[d>>2];X=d;j=V;if(!(y<t)){if(!(y==t))return;if(!(+n[V+4>>2]<+n[d+4>>2]))return}f[i>>2]=j;f[e>>2]=X;return}else if((m|0)==9){X=i+4|0;j=f[X>>2]|0;d=f[i>>2]|0;t=+n[j>>2];y=+n[d>>2];V=j;W=d;if(!(t<y))if(t==y)Y=+n[j+4>>2]<+n[d+4>>2];else Y=0;else Y=1;U=f[e>>2]|0;s=+n[U>>2];T=U;if(!(s<t))if(s==t)Z=+n[U+4>>2]<+n[j+4>>2];else Z=0;else Z=1;if(!Y){if(!Z)return;f[X>>2]=T;f[e>>2]=V;Y=f[X>>2]|0;j=f[i>>2]|0;t=+n[Y>>2];s=+n[j>>2];U=j;F=Y;if(!(t<s)){if(!(t==s))return;if(!(+n[Y+4>>2]<+n[j+4>>2]))return}f[i>>2]=F;f[X>>2]=U;return}if(Z){f[i>>2]=T;f[e>>2]=W;return}f[i>>2]=V;f[X>>2]=W;V=f[e>>2]|0;s=+n[V>>2];T=V;if(!(s<y)){if(!(s==y))return;if(!(+n[V+4>>2]<+n[d+4>>2]))return}f[X>>2]=T;f[e>>2]=W;return}else if((m|0)==27){yZ(i,i+4|0,i+8|0,e,c)|0;return}else if((m|0)==28){zZ(i,i+4|0,i+8|0,i+12|0,e,c)|0;return}else if((m|0)==30){AZ(i,a,c);return}else if((m|0)==107)return}function wZ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;h=(c|0)>(b|0)?1:-1;i=h+b|0;j=i+h|0;do if((b|0)!=(c|0)){k=f[a+(b<<2)>>2]|0;l=f[a+(c<<2)>>2]|0;if((f[k>>2]|0)==(f[l>>2]|0)?(f[k+4>>2]|0)==(f[l+4>>2]|0):0)break;f[d>>2]=b;l=d+4|0;f[l>>2]=i;k=d+8|0;f[k>>2]=j;m=h+c|0;a:do if((j|0)==(m|0))n=3;else{o=b;p=i;q=j;r=3;while(1){s=d+(r+-1<<2)|0;t=a+(o<<2)|0;u=f[a+(p<<2)>>2]|0;b:do if((o|0)!=(b|0)){v=u+4|0;w=q;while(1){x=f[v>>2]|0;y=f[a+(w<<2)>>2]|0;z=(f[y+4>>2]|0)-x|0;if((((z|0)>0&1)-(z>>>31)|0)!=(e|0))break;A=w+h|0;f[s>>2]=A;if((A|0)==(m|0)){n=r;break a}else w=A}v=f[u>>2]|0;A=f[t>>2]|0;B=v-(f[A>>2]|0)|0;C=x-(f[A+4>>2]|0)|0;A=(Y(C,(f[y>>2]|0)-v|0)|0)-(Y(B,z)|0)|0;if((C|B|0)==0?1:(((A|0)>0&1)-(A>>>31)|0)!=(g|0)){f[d+(r+-2<<2)>>2]=w;D=f[d+(r+-4<<2)>>2]|0;E=o;F=w;G=-1}else{H=p;I=w;J=15}}else{A=p;B=q;C=u;while(1){v=C+4|0;K=B;while(1){L=f[v>>2]|0;M=f[a+(K<<2)>>2]|0;N=(f[M+4>>2]|0)-L|0;if((((N|0)>0&1)-(N>>>31)|0)!=(e|0))break;O=K+h|0;f[s>>2]=O;if((O|0)==(m|0)){n=r;break a}else K=O}v=f[C>>2]|0;O=f[t>>2]|0;P=v-(f[O>>2]|0)|0;Q=L-(f[O+4>>2]|0)|0;O=(Y(Q,(f[M>>2]|0)-v|0)|0)-(Y(P,N)|0)|0;if(!((Q|P|0)==0?1:(((O|0)>0&1)-(O>>>31)|0)!=(g|0))){H=A;I=K;J=15;break b}f[l>>2]=K;O=K+h|0;f[k>>2]=O;if((O|0)==(m|0)){n=r;break a}else{A=K;B=O;C=M}}}while(0);if((J|0)==15){J=0;t=I+h|0;f[d+(r<<2)>>2]=t;D=H;E=I;F=t;G=1}t=r+G|0;if((F|0)==(m|0)){n=t;break}else{o=D;p=E;q=F;r=t}}}while(0);R=n+-1|0;return R|0}while(0);f[d>>2]=b;R=1;return R|0}function xZ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0;h=(c|0)>(b|0)?1:-1;i=h+b|0;j=i+h|0;do if((b|0)!=(c|0)){k=f[a+(b<<2)>>2]|0;l=f[a+(c<<2)>>2]|0;if(+n[k>>2]==+n[l>>2]?+n[k+4>>2]==+n[l+4>>2]:0)break;f[d>>2]=b;l=d+4|0;f[l>>2]=i;k=d+8|0;f[k>>2]=j;m=h+c|0;a:do if((j|0)==(m|0))o=3;else{p=b;q=i;r=j;s=3;while(1){t=d+(s+-1<<2)|0;u=a+(p<<2)|0;v=f[a+(q<<2)>>2]|0;w=+n[v+4>>2];b:do if((p|0)==(b|0)){x=q;y=r;z=w;A=v;while(1){B=y;while(1){C=f[a+(B<<2)>>2]|0;D=+n[C+4>>2];E=D-z;if(((E>0.0&1)-(E<0.0&1)|0)!=(e|0))break;F=B+h|0;f[t>>2]=F;if((F|0)==(m|0)){o=s;break a}else B=F}G=+n[A>>2];F=f[u>>2]|0;H=G-+n[F>>2];I=z-+n[F+4>>2];J=(+n[C>>2]-G)*I-E*H;if(((J>0.0&1)-(J<0.0&1)|0)==(g|0)?H!=0.0|I!=0.0:0){K=x;L=B;M=16;break b}f[l>>2]=B;F=B+h|0;f[k>>2]=F;if((F|0)==(m|0)){o=s;break a}else{x=B;y=F;z=D;A=C}}}else{A=r;while(1){N=f[a+(A<<2)>>2]|0;O=+n[N+4>>2]-w;if(((O>0.0&1)-(O<0.0&1)|0)!=(e|0))break;y=A+h|0;f[t>>2]=y;if((y|0)==(m|0)){o=s;break a}else A=y}z=+n[v>>2];y=f[u>>2]|0;I=z-+n[y>>2];H=w-+n[y+4>>2];J=(+n[N>>2]-z)*H-O*I;if(((J>0.0&1)-(J<0.0&1)|0)==(g|0)?I!=0.0|H!=0.0:0){K=q;L=A;M=16;break}f[d+(s+-2<<2)>>2]=A;P=f[d+(s+-4<<2)>>2]|0;Q=p;R=A;S=-1}while(0);if((M|0)==16){M=0;u=L+h|0;f[d+(s<<2)>>2]=u;P=K;Q=L;R=u;S=1}u=s+S|0;if((R|0)==(m|0)){o=u;break}else{p=P;q=Q;r=R;s=u}}}while(0);T=o+-1|0;return T|0}while(0);f[d>>2]=b;T=1;return T|0}function yZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=f[b>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h<i))if(h==i)l=+n[e+4>>2]<+n[g+4>>2];else l=0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o<h))if(o==h)q=+n[m+4>>2]<+n[e+4>>2];else q=0;else q=1;do if(!l)if(q){f[b>>2]=p;f[c>>2]=j;r=f[b>>2]|0;s=f[a>>2]|0;h=+n[r>>2];o=+n[s>>2];t=s;u=r;if(!(h<o)){if(!(h==o)){v=1;w=e;x=j;break}if(!(+n[r+4>>2]<+n[s+4>>2])){v=1;w=e;x=j;break}}f[a>>2]=u;f[b>>2]=t;t=f[c>>2]|0;v=2;w=t;x=t}else{v=0;w=m;x=p}else{if(q){f[a>>2]=p;f[c>>2]=k;v=1;w=g;x=k;break}f[a>>2]=j;f[b>>2]=k;t=f[c>>2]|0;o=+n[t>>2];u=t;if(!(o<i)){if(!(o==i)){v=1;w=t;x=u;break}if(!(+n[t+4>>2]<+n[g+4>>2])){v=1;w=t;x=u;break}}f[b>>2]=u;f[c>>2]=k;v=2;w=g;x=k}while(0);k=f[d>>2]|0;i=+n[k>>2];o=+n[w>>2];g=k;if(!(i<o)){if(!(i==o)){y=v;return y|0}if(!(+n[k+4>>2]<+n[w+4>>2])){y=v;return y|0}}f[c>>2]=g;f[d>>2]=x;x=v+1|0;d=f[c>>2]|0;g=f[b>>2]|0;o=+n[d>>2];i=+n[g>>2];w=g;k=d;if(!(o<i)){if(!(o==i)){y=x;return y|0}if(!(+n[d+4>>2]<+n[g+4>>2])){y=x;return y|0}}f[b>>2]=k;f[c>>2]=w;w=v+2|0;c=f[b>>2]|0;k=f[a>>2]|0;i=+n[c>>2];o=+n[k>>2];x=k;g=c;if(!(i<o)){if(!(i==o)){y=w;return y|0}if(!(+n[c+4>>2]<+n[k+4>>2])){y=w;return y|0}}f[a>>2]=g;f[b>>2]=x;y=v+3|0;return y|0}function zZ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0.0,k=0.0,l=0,m=0,o=0;h=yZ(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=+n[g>>2];k=+n[i>>2];l=i;m=g;if(!(j<k)){if(!(j==k)){o=h;return o|0}if(!(+n[g+4>>2]<+n[i+4>>2])){o=h;return o|0}}f[d>>2]=m;f[e>>2]=l;l=h+1|0;e=f[d>>2]|0;m=f[c>>2]|0;k=+n[e>>2];j=+n[m>>2];i=m;g=e;if(!(k<j)){if(!(k==j)){o=l;return o|0}if(!(+n[e+4>>2]<+n[m+4>>2])){o=l;return o|0}}f[c>>2]=g;f[d>>2]=i;i=h+2|0;d=f[c>>2]|0;g=f[b>>2]|0;j=+n[d>>2];k=+n[g>>2];l=g;m=d;if(!(j<k)){if(!(j==k)){o=i;return o|0}if(!(+n[d+4>>2]<+n[g+4>>2])){o=i;return o|0}}f[b>>2]=m;f[c>>2]=l;l=h+3|0;c=f[b>>2]|0;m=f[a>>2]|0;k=+n[c>>2];j=+n[m>>2];i=m;g=c;if(!(k<j)){if(!(k==j)){o=l;return o|0}if(!(+n[c+4>>2]<+n[m+4>>2])){o=l;return o|0}}f[a>>2]=g;f[b>>2]=i;o=h+4|0;return o|0}function AZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=e;k=g;if(!(h<i))if(h==i)l=+n[e+4>>2]<+n[g+4>>2];else l=0;else l=1;m=f[c>>2]|0;o=+n[m>>2];p=m;if(!(o<h))if(o==h)q=+n[m+4>>2]<+n[e+4>>2];else q=0;else q=1;do if(!l)if(q){f[d>>2]=p;f[c>>2]=j;if(!(o<i)){if(!(o==i)){r=j;s=e;break}if(!(+n[m+4>>2]<+n[g+4>>2])){r=j;s=e;break}}f[a>>2]=p;f[d>>2]=k;r=j;s=e}else{r=p;s=m}else{if(q){f[a>>2]=p;f[c>>2]=k;r=k;s=g;break}f[a>>2]=j;f[d>>2]=k;if(!(o<i)){if(!(o==i)){r=p;s=m;break}if(!(+n[m+4>>2]<+n[g+4>>2])){r=p;s=m;break}}f[d>>2]=p;f[c>>2]=k;r=k;s=g}while(0);g=a+12|0;if((g|0)==(b|0))return;else{t=g;u=c;v=s;w=r}while(1){r=f[t>>2]|0;i=+n[r>>2];o=+n[v>>2];s=r;if(!(i<o)){if(i==o?(c=r+4|0,+n[c>>2]<+n[v+4>>2]):0){x=c;y=25}}else{x=r+4|0;y=25}if((y|0)==25){y=0;f[t>>2]=w;a:do if((u|0)==(a|0))z=u;else{r=u;c=u;while(1){g=c;c=r+-4|0;k=f[c>>2]|0;o=+n[k>>2];p=k;if(!(i<o)){if(!(i==o)){z=g;break a}if(!(+n[x>>2]<+n[k+4>>2])){z=g;break a}}f[g>>2]=p;if((c|0)==(a|0)){z=c;break}else r=c}}while(0);f[z>>2]=s}c=t+4|0;if((c|0)==(b|0))break;r=f[t>>2]|0;p=t;t=c;v=r;w=r;u=p}return}function BZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0.0,i=0.0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=+n[e>>2];i=+n[g>>2];j=g;k=e;if(!(h<i)){if(!(h==i)){l=1;return l|0}if(!(+n[e+4>>2]<+n[g+4>>2])){l=1;return l|0}}f[a>>2]=k;f[d>>2]=j;l=1;return l|0}case 3:{j=a+4|0;d=b+-4|0;k=f[j>>2]|0;g=f[a>>2]|0;i=+n[k>>2];h=+n[g>>2];e=k;m=g;if(!(i<h))if(i==h)o=+n[k+4>>2]<+n[g+4>>2];else o=0;else o=1;p=f[d>>2]|0;q=+n[p>>2];r=p;if(!(q<i))if(q==i)s=+n[p+4>>2]<+n[k+4>>2];else s=0;else s=1;if(!o){if(!s){l=1;return l|0}f[j>>2]=r;f[d>>2]=e;o=f[j>>2]|0;k=f[a>>2]|0;i=+n[o>>2];q=+n[k>>2];p=k;t=o;if(!(i<q)){if(!(i==q)){l=1;return l|0}if(!(+n[o+4>>2]<+n[k+4>>2])){l=1;return l|0}}f[a>>2]=t;f[j>>2]=p;l=1;return l|0}if(s){f[a>>2]=r;f[d>>2]=m;l=1;return l|0}f[a>>2]=e;f[j>>2]=m;e=f[d>>2]|0;q=+n[e>>2];r=e;if(!(q<h)){if(!(q==h)){l=1;return l|0}if(!(+n[e+4>>2]<+n[g+4>>2])){l=1;return l|0}}f[j>>2]=r;f[d>>2]=m;l=1;return l|0}case 4:{yZ(a,a+4|0,a+8|0,b+-4|0,c)|0;l=1;return l|0}case 5:{zZ(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;l=1;return l|0}case 1:case 0:{l=1;return l|0}default:{c=a+8|0;m=a+4|0;d=f[m>>2]|0;r=f[a>>2]|0;h=+n[d>>2];q=+n[r>>2];j=d;g=r;if(!(h<q))if(h==q)u=+n[d+4>>2]<+n[r+4>>2];else u=0;else u=1;e=f[c>>2]|0;i=+n[e>>2];s=e;if(!(i<h))if(i==h)v=+n[e+4>>2]<+n[d+4>>2];else v=0;else v=1;do if(!u)if(v){f[m>>2]=s;f[c>>2]=j;if(!(i<q)){if(!(i==q)){w=d;break}if(!(+n[e+4>>2]<+n[r+4>>2])){w=d;break}}f[a>>2]=s;f[m>>2]=g;w=d}else w=e;else{if(v){f[a>>2]=s;f[c>>2]=g;w=r;break}f[a>>2]=j;f[m>>2]=g;if(!(i<q)){if(!(i==q)){w=e;break}if(!(+n[e+4>>2]<+n[r+4>>2])){w=e;break}}f[m>>2]=s;f[c>>2]=g;w=r}while(0);r=a+12|0;a:do if((r|0)==(b|0)){x=1;y=0}else{g=r;s=0;m=c;e=w;while(1){j=f[g>>2]|0;q=+n[j>>2];i=+n[e>>2];v=j;if(!(q<i))if(q==i?(d=j+4|0,+n[d>>2]<+n[e+4>>2]):0){z=d;A=49}else B=s;else{z=j+4|0;A=49}if((A|0)==49){A=0;f[g>>2]=f[m>>2];b:do if((m|0)==(a|0))C=m;else{j=m;d=m;while(1){u=d;d=j+-4|0;p=f[d>>2]|0;i=+n[p>>2];t=p;if(!(q<i)){if(!(q==i)){C=u;break b}if(!(+n[z>>2]<+n[p+4>>2])){C=u;break b}}f[u>>2]=t;if((d|0)==(a|0)){C=d;break}else j=d}}while(0);f[C>>2]=v;d=s+1|0;if((d|0)==8){x=0;y=(g+4|0)==(b|0);break a}else B=d}d=g+4|0;if((d|0)==(b|0)){x=1;y=0;break a}j=f[g>>2]|0;t=g;g=d;s=B;e=j;m=t}}while(0);l=y|x;return l|0}}return 0}function CZ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=f[b>>2]|0;g=f[a>>2]|0;h=f[e>>2]|0;i=f[g>>2]|0;j=e;k=g;if((h|0)>=(i|0))if((h|0)==(i|0))l=(f[e+4>>2]|0)<(f[g+4>>2]|0);else l=0;else l=1;m=f[c>>2]|0;n=f[m>>2]|0;o=m;if((n|0)>=(h|0))if((n|0)==(h|0))p=(f[m+4>>2]|0)<(f[e+4>>2]|0);else p=0;else p=1;do if(!l)if(p){f[b>>2]=o;f[c>>2]=j;h=f[b>>2]|0;n=f[a>>2]|0;q=f[h>>2]|0;r=f[n>>2]|0;s=n;t=h;if((q|0)>=(r|0)){if((q|0)!=(r|0)){u=1;v=e;w=j;break}if((f[h+4>>2]|0)>=(f[n+4>>2]|0)){u=1;v=e;w=j;break}}f[a>>2]=t;f[b>>2]=s;s=f[c>>2]|0;u=2;v=s;w=s}else{u=0;v=m;w=o}else{if(p){f[a>>2]=o;f[c>>2]=k;u=1;v=g;w=k;break}f[a>>2]=j;f[b>>2]=k;s=f[c>>2]|0;t=f[s>>2]|0;n=s;if((t|0)>=(i|0)){if((t|0)!=(i|0)){u=1;v=s;w=n;break}if((f[s+4>>2]|0)>=(f[g+4>>2]|0)){u=1;v=s;w=n;break}}f[b>>2]=n;f[c>>2]=k;u=2;v=g;w=k}while(0);k=f[d>>2]|0;g=f[k>>2]|0;i=f[v>>2]|0;j=k;if((g|0)>=(i|0)){if((g|0)!=(i|0)){x=u;return x|0}if((f[k+4>>2]|0)>=(f[v+4>>2]|0)){x=u;return x|0}}f[c>>2]=j;f[d>>2]=w;w=u+1|0;d=f[c>>2]|0;j=f[b>>2]|0;v=f[d>>2]|0;k=f[j>>2]|0;i=j;g=d;if((v|0)>=(k|0)){if((v|0)!=(k|0)){x=w;return x|0}if((f[d+4>>2]|0)>=(f[j+4>>2]|0)){x=w;return x|0}}f[b>>2]=g;f[c>>2]=i;i=u+2|0;c=f[b>>2]|0;g=f[a>>2]|0;w=f[c>>2]|0;j=f[g>>2]|0;d=g;k=c;if((w|0)>=(j|0)){if((w|0)!=(j|0)){x=i;return x|0}if((f[c+4>>2]|0)>=(f[g+4>>2]|0)){x=i;return x|0}}f[a>>2]=k;f[b>>2]=d;x=u+3|0;return x|0}function DZ(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=CZ(a,b,c,d,g)|0;g=f[e>>2]|0;i=f[d>>2]|0;j=f[g>>2]|0;k=f[i>>2]|0;l=i;m=g;if((j|0)>=(k|0)){if((j|0)!=(k|0)){n=h;return n|0}if((f[g+4>>2]|0)>=(f[i+4>>2]|0)){n=h;return n|0}}f[d>>2]=m;f[e>>2]=l;l=h+1|0;e=f[d>>2]|0;m=f[c>>2]|0;i=f[e>>2]|0;g=f[m>>2]|0;k=m;j=e;if((i|0)>=(g|0)){if((i|0)!=(g|0)){n=l;return n|0}if((f[e+4>>2]|0)>=(f[m+4>>2]|0)){n=l;return n|0}}f[c>>2]=j;f[d>>2]=k;k=h+2|0;d=f[c>>2]|0;j=f[b>>2]|0;l=f[d>>2]|0;m=f[j>>2]|0;e=j;g=d;if((l|0)>=(m|0)){if((l|0)!=(m|0)){n=k;return n|0}if((f[d+4>>2]|0)>=(f[j+4>>2]|0)){n=k;return n|0}}f[b>>2]=g;f[c>>2]=e;e=h+3|0;c=f[b>>2]|0;g=f[a>>2]|0;k=f[c>>2]|0;j=f[g>>2]|0;d=g;m=c;if((k|0)>=(j|0)){if((k|0)!=(j|0)){n=e;return n|0}if((f[c+4>>2]|0)>=(f[g+4>>2]|0)){n=e;return n|0}}f[a>>2]=m;f[b>>2]=d;n=h+4|0;return n|0}function EZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;c=a+8|0;d=a+4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=f[e>>2]|0;i=f[g>>2]|0;j=e;k=g;if((h|0)>=(i|0))if((h|0)==(i|0))l=(f[e+4>>2]|0)<(f[g+4>>2]|0);else l=0;else l=1;m=f[c>>2]|0;n=f[m>>2]|0;o=m;if((n|0)>=(h|0))if((n|0)==(h|0))p=(f[m+4>>2]|0)<(f[e+4>>2]|0);else p=0;else p=1;do if(!l)if(p){f[d>>2]=o;f[c>>2]=j;if((n|0)>=(i|0)){if((n|0)!=(i|0)){q=j;r=e;break}if((f[m+4>>2]|0)>=(f[g+4>>2]|0)){q=j;r=e;break}}f[a>>2]=o;f[d>>2]=k;q=j;r=e}else{q=o;r=m}else{if(p){f[a>>2]=o;f[c>>2]=k;q=k;r=g;break}f[a>>2]=j;f[d>>2]=k;if((n|0)>=(i|0)){if((n|0)!=(i|0)){q=o;r=m;break}if((f[m+4>>2]|0)>=(f[g+4>>2]|0)){q=o;r=m;break}}f[d>>2]=o;f[c>>2]=k;q=k;r=g}while(0);g=a+12|0;if((g|0)==(b|0))return;else{s=g;t=c;u=r;v=q}while(1){q=f[s>>2]|0;r=f[q>>2]|0;c=f[u>>2]|0;g=q;if((r|0)>=(c|0)){if((r|0)==(c|0)?(c=q+4|0,(f[c>>2]|0)<(f[u+4>>2]|0)):0){w=c;x=25}}else{w=q+4|0;x=25}if((x|0)==25){x=0;f[s>>2]=v;a:do if((t|0)==(a|0))y=t;else{q=t;c=t;while(1){k=c;c=q+-4|0;o=f[c>>2]|0;d=f[o>>2]|0;m=o;if((r|0)>=(d|0)){if((r|0)!=(d|0)){y=k;break a}if((f[w>>2]|0)>=(f[o+4>>2]|0)){y=k;break a}}f[k>>2]=m;if((c|0)==(a|0)){y=c;break}else q=c}}while(0);f[y>>2]=g}r=s+4|0;if((r|0)==(b|0))break;c=f[s>>2]|0;q=s;s=r;u=c;v=c;t=q}return}function FZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;switch(b-a>>2|0){case 2:{d=b+-4|0;e=f[d>>2]|0;g=f[a>>2]|0;h=f[e>>2]|0;i=f[g>>2]|0;j=g;k=e;if((h|0)>=(i|0)){if((h|0)!=(i|0)){l=1;return l|0}if((f[e+4>>2]|0)>=(f[g+4>>2]|0)){l=1;return l|0}}f[a>>2]=k;f[d>>2]=j;l=1;return l|0}case 3:{j=a+4|0;d=b+-4|0;k=f[j>>2]|0;g=f[a>>2]|0;e=f[k>>2]|0;i=f[g>>2]|0;h=k;m=g;if((e|0)>=(i|0))if((e|0)==(i|0))n=(f[k+4>>2]|0)<(f[g+4>>2]|0);else n=0;else n=1;o=f[d>>2]|0;p=f[o>>2]|0;q=o;if((p|0)>=(e|0))if((p|0)==(e|0))r=(f[o+4>>2]|0)<(f[k+4>>2]|0);else r=0;else r=1;if(!n){if(!r){l=1;return l|0}f[j>>2]=q;f[d>>2]=h;n=f[j>>2]|0;k=f[a>>2]|0;o=f[n>>2]|0;e=f[k>>2]|0;p=k;s=n;if((o|0)>=(e|0)){if((o|0)!=(e|0)){l=1;return l|0}if((f[n+4>>2]|0)>=(f[k+4>>2]|0)){l=1;return l|0}}f[a>>2]=s;f[j>>2]=p;l=1;return l|0}if(r){f[a>>2]=q;f[d>>2]=m;l=1;return l|0}f[a>>2]=h;f[j>>2]=m;h=f[d>>2]|0;q=f[h>>2]|0;r=h;if((q|0)>=(i|0)){if((q|0)!=(i|0)){l=1;return l|0}if((f[h+4>>2]|0)>=(f[g+4>>2]|0)){l=1;return l|0}}f[j>>2]=r;f[d>>2]=m;l=1;return l|0}case 4:{CZ(a,a+4|0,a+8|0,b+-4|0,c)|0;l=1;return l|0}case 5:{DZ(a,a+4|0,a+8|0,a+12|0,b+-4|0,c)|0;l=1;return l|0}case 1:case 0:{l=1;return l|0}default:{c=a+8|0;m=a+4|0;d=f[m>>2]|0;r=f[a>>2]|0;j=f[d>>2]|0;g=f[r>>2]|0;h=d;i=r;if((j|0)>=(g|0))if((j|0)==(g|0))t=(f[d+4>>2]|0)<(f[r+4>>2]|0);else t=0;else t=1;q=f[c>>2]|0;p=f[q>>2]|0;s=q;if((p|0)>=(j|0))if((p|0)==(j|0))u=(f[q+4>>2]|0)<(f[d+4>>2]|0);else u=0;else u=1;do if(!t)if(u){f[m>>2]=s;f[c>>2]=h;if((p|0)>=(g|0)){if((p|0)!=(g|0)){v=d;break}if((f[q+4>>2]|0)>=(f[r+4>>2]|0)){v=d;break}}f[a>>2]=s;f[m>>2]=i;v=d}else v=q;else{if(u){f[a>>2]=s;f[c>>2]=i;v=r;break}f[a>>2]=h;f[m>>2]=i;if((p|0)>=(g|0)){if((p|0)!=(g|0)){v=q;break}if((f[q+4>>2]|0)>=(f[r+4>>2]|0)){v=q;break}}f[m>>2]=s;f[c>>2]=i;v=r}while(0);r=a+12|0;a:do if((r|0)==(b|0)){w=1;x=0}else{i=r;s=0;m=c;q=v;while(1){g=f[i>>2]|0;p=f[g>>2]|0;h=f[q>>2]|0;u=g;if((p|0)>=(h|0))if((p|0)==(h|0)?(h=g+4|0,(f[h>>2]|0)<(f[q+4>>2]|0)):0){y=h;z=49}else A=s;else{y=g+4|0;z=49}if((z|0)==49){z=0;f[i>>2]=f[m>>2];b:do if((m|0)==(a|0))B=m;else{g=m;h=m;while(1){d=h;h=g+-4|0;t=f[h>>2]|0;j=f[t>>2]|0;k=t;if((p|0)>=(j|0)){if((p|0)!=(j|0)){B=d;break b}if((f[y>>2]|0)>=(f[t+4>>2]|0)){B=d;break b}}f[d>>2]=k;if((h|0)==(a|0)){B=h;break}else g=h}}while(0);f[B>>2]=u;p=s+1|0;if((p|0)==8){w=0;x=(i+4|0)==(b|0);break a}else A=p}p=i+4|0;if((p|0)==(b|0)){w=1;x=0;break a}h=f[i>>2]|0;g=i;i=p;s=A;q=h;m=g}}while(0);l=x|w;return l|0}}return 0}function GZ(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0.0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0;e=u;u=u+208|0;g=e+200|0;h=e+144|0;i=e+88|0;j=e+72|0;k=e;l=e+16|0;dQ(g,48224);do if((yM(a)|0)==65536){m=f[a+4>>2]|0;f[h>>2]=f[m>>2];n=h+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=h+8|0;f[p>>2]=f[m+8>>2];f[h+12>>2]=f[m+12>>2];f[h+16>>2]=f[m+16>>2];f[h+20>>2]=f[m+20>>2];f[h+24>>2]=f[m+24>>2];f[h+28>>2]=f[m+28>>2];f[h+32>>2]=f[m+32>>2];q=f[m+36>>2]|0;f[h+36>>2]=q;f[h+40>>2]=p;p=h+48|0;r=h+44|0;f[r>>2]=p;f[p>>2]=0;f[h+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;jL(h,m);break}}else yL(h,a,-1);while(0);a=wM(h,2,4,1)|0;if((a|0)>-1)if((a|0)>=4){do if((yM(c)|0)==65536){m=f[c+4>>2]|0;f[i>>2]=f[m>>2];n=i+4|0;o=m+4|0;f[n>>2]=f[o>>2];p=i+8|0;f[p>>2]=f[m+8>>2];f[i+12>>2]=f[m+12>>2];f[i+16>>2]=f[m+16>>2];f[i+20>>2]=f[m+20>>2];f[i+24>>2]=f[m+24>>2];f[i+28>>2]=f[m+28>>2];f[i+32>>2]=f[m+32>>2];r=f[m+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=p;p=i+48|0;q=i+44|0;f[q>>2]=p;f[p>>2]=0;f[i+52>>2]=0;if(r|0){p=r+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[o>>2]|0)<3){o=f[m+44>>2]|0;p=f[q>>2]|0;f[p>>2]=f[o>>2];f[p+4>>2]=f[o+4>>2];break}else{f[n>>2]=0;jL(i,m);break}}else yL(i,c,-1);while(0);c=wM(i,1,4,1)|0;if((c|0)<=0){f[j>>2]=0;f[j+4>>2]=0;s=aD(j,11)|0;t=216524;v=s+11|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,j,216507,216301,284);bD(j)}m=f[h+16>>2]|0;n=i+16|0;o=f[n>>2]|0;p=i+44|0;f[j>>2]=0;q=j+4|0;f[q>>2]=0;f[j+8>>2]=0;if((c|0)>=3){r=f[o+4>>2]|0;w=f[o>>2]|0;x=f[o+8>>2]|0;y=(((x|0)>(r|0)&1)+((r|0)>(w|0)&1)+((w|0)>(x|0)&1)|0)!=2;x=c+-1|0;w=f[o+((y?0:x)<<2)>>2]|0;if(!((w|0)>-1&(w|0)<(a|0))){f[k>>2]=0;f[k+4>>2]=0;s=aD(k,29)|0;t=216536;v=s+29|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,k,216507,216301,300);bD(k)}r=k+4|0;z=k+8|0;A=k+12|0;B=j+8|0;C=k+4|0;D=0;E=w;do{w=E;E=f[o+((y?x-D|0:D)<<2)>>2]|0;if(!((E|0)>-1&(E|0)<(a|0))){f[k>>2]=0;f[C>>2]=0;s=aD(k,29)|0;t=216566;v=s+29|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,k,216507,216301,305);bD(k)}F=f[m+(w<<3)>>2]|0;G=f[m+(w<<3)+4>>2]|0;H=(f[m+(E<<3)>>2]|0)-F|0;I=+(H|0);J=(f[m+(E<<3)+4>>2]|0)-G|0;K=+(J|0);if(!(J|H))N=0.0;else N=1.0/+M(+(I*I+K*K));H=w+1|0;J=(H|0)<(a|0)?H:0;if((J|0)!=(E|0)){H=0;O=0.0;P=-1;Q=J;do{R=N*+L(+(I*+((f[m+(Q<<3)+4>>2]|0)-G|0)-K*+((f[m+(Q<<3)>>2]|0)-F|0)));J=R>O;P=J?Q:P;O=J?R:O;H=H|J;J=Q+1|0;Q=(J|0)<(a|0)?J:0}while((Q|0)!=(E|0));if(H){Q=MVb(O*256.0)|0;f[k>>2]=w;f[r>>2]=E;f[z>>2]=P;f[A>>2]=Q;Q=f[q>>2]|0;if((Q|0)==(f[B>>2]|0))HZ(j,k);else{f[Q>>2]=w;f[Q+4>>2]=f[r>>2];f[Q+8>>2]=f[z>>2];f[Q+12>>2]=f[A>>2];f[q>>2]=Q+16}}}D=D+1|0}while((c|0)>(D|0));f[l>>2]=1124024348;D=l+4|0;f[D>>2]=2;c=l+8|0;A=f[q>>2]|0;z=f[j>>2]|0;r=A-z|0;f[c>>2]=r>>4;f[l+12>>2]=1;k=l+16|0;B=l+40|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;f[B>>2]=c;c=l+48|0;E=l+44|0;f[E>>2]=c;f[c>>2]=0;a=l+52|0;f[a>>2]=0;m=z;if((m|0)!=(A|0)){f[a>>2]=16;f[c>>2]=16;f[k>>2]=m;f[l+20>>2]=m;m=z+r|0;f[l+24>>2]=m;f[l+28>>2]=m}SP(l,d);m=l+36|0;r=f[m>>2]|0;if(r|0?(z=r+12|0,r=f[z>>2]|0,f[z>>2]=r+-1,(r|0)==1):0)kL(l);f[m>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[D>>2]|0)>0){k=f[B>>2]|0;B=0;do{f[k+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[D>>2]|0))}D=f[E>>2]|0;if((D|0)!=(c|0))UC(D)}else $L(d);D=f[j>>2]|0;if(D|0){j=f[q>>2]|0;if((j|0)!=(D|0))f[q>>2]=j+(~((j+-16-D|0)>>>4)<<4);O5b(D)}D=i+36|0;j=f[D>>2]|0;if(j|0?(q=j+12|0,j=f[q>>2]|0,f[q>>2]=j+-1,(j|0)==1):0)kL(i);f[D>>2]=0;D=i+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[D>>2]|0)>0){n=f[i+40>>2]|0;j=0;do{f[n+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[D>>2]|0))}D=f[p>>2]|0;if((D|0)!=(i+48|0))UC(D)}else S=11;else{f[i>>2]=0;f[i+4>>2]=0;s=aD(i,12)|0;t=216494;v=s+12|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,i,216507,216301,274);bD(i);S=11}if((S|0)==11)$L(d);d=h+36|0;S=f[d>>2]|0;if(S|0?(i=S+12|0,S=f[i>>2]|0,f[i>>2]=S+-1,(S|0)==1):0)kL(h);f[d>>2]=0;d=h+16|0;S=h+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[S>>2]|0)>0){d=f[h+40>>2]|0;i=0;do{f[d+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[S>>2]|0))}S=f[h+44>>2]|0;if((S|0)!=(h+48|0))UC(S);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function HZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>4;h=g+1|0;i=e;j=d;if(h>>>0>268435455)c4b(a);d=a+8|0;k=(f[d>>2]|0)-e|0;l=k>>3;m=k>>4>>>0<134217727?(l>>>0<h>>>0?h:l):268435455;do if(m)if(m>>>0>268435455){l=ze(8)|0;T5b(l,477177);f[l>>2]=149528;If(l|0,25408,1411)}else{n=L5b(m<<4)|0;break}else n=0;while(0);l=n+(g<<4)|0;h=n+(m<<4)|0;f[l>>2]=f[b>>2];f[n+(g<<4)+4>>2]=f[b+4>>2];f[n+(g<<4)+8>>2]=f[b+8>>2];f[n+(g<<4)+12>>2]=f[b+12>>2];b=l+16|0;if((j|0)==(i|0))o=l;else{g=j+-16-e|0;n=j;j=l;while(1){m=n;n=n+-16|0;f[j+-16>>2]=f[n>>2];f[j+-12>>2]=f[m+-12>>2];f[j+-8>>2]=f[m+-8>>2];f[j+-4>>2]=f[m+-4>>2];if((n|0)==(i|0))break;else j=j+-16|0}o=l+(~(g>>>4)<<4)|0}f[a>>2]=o;f[c>>2]=b;f[d>>2]=h;if(!e)return;O5b(e);return}function IZ(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0;c=u;u=u+64|0;d=c+8|0;e=c;do if((yM(a)|0)==65536){g=f[a+4>>2]|0;f[d>>2]=f[g>>2];h=d+4|0;i=g+4|0;f[h>>2]=f[i>>2];j=d+8|0;f[j>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];f[d+16>>2]=f[g+16>>2];f[d+20>>2]=f[g+20>>2];f[d+24>>2]=f[g+24>>2];f[d+28>>2]=f[g+28>>2];f[d+32>>2]=f[g+32>>2];k=f[g+36>>2]|0;f[d+36>>2]=k;f[d+40>>2]=j;j=d+48|0;l=d+44|0;f[l>>2]=j;f[j>>2]=0;f[d+52>>2]=0;if(k|0){j=k+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[i>>2]|0)<3){i=f[g+44>>2]|0;j=f[l>>2]|0;f[j>>2]=f[i>>2];f[j+4>>2]=f[i+4>>2];break}else{f[h>>2]=0;jL(d,g);break}}else yL(d,a,-1);while(0);a=wM(d,2,-1,1)|0;g=f[d>>2]&7;if(!((a|0)>-1&(g|1|0)==5)){f[e>>2]=0;f[e+4>>2]=0;h=aD(e,40)|0;i=216374;j=h+40|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-215,e,216659,216301,392);bD(e)}a:do if(a){e=f[d+16>>2]|0;if((g|0)==4){i=((a<<1)+-2|0)%(a|0)|0;h=a+-1|0;j=f[e+(h<<3)>>2]|0;l=f[e+(h<<3)+4>>2]|0;if((a|0)<=0){m=1;break}h=j-(f[e+(i<<3)>>2]|0)|0;k=l-(f[e+(i<<3)+4>>2]|0)|0;i=0;o=0;p=j;j=l;while(1){l=p;p=f[e+(o<<3)>>2]|0;q=j;j=f[e+(o<<3)+4>>2]|0;r=h;h=p-l|0;l=k;k=j-q|0;q=Y(h,l)|0;l=Y(k,r)|0;i=((l|0)>(q|0)?1:(l|0)<(q|0)?2:3)|i;o=o+1|0;if((i|0)==3){m=0;break a}if((o|0)>=(a|0)){m=1;break}}}else{o=((a<<1)+-2|0)%(a|0)|0;i=a+-1|0;k=f[e+(i<<3)>>2]|0;h=f[e+(i<<3)+4>>2]|0;if((a|0)<=0){m=1;break}t=(f[s>>2]=h,+n[s>>2])-+n[e+(o<<3)+4>>2];v=(f[s>>2]=k,+n[s>>2])-+n[e+(o<<3)>>2];w=t;o=0;i=0;j=k;k=h;while(1){h=j;j=f[e+(i<<3)>>2]|0;p=k;k=f[e+(i<<3)+4>>2]|0;t=(f[s>>2]=j,+n[s>>2]);x=v;v=t-(f[s>>2]=h,+n[s>>2]);t=(f[s>>2]=k,+n[s>>2]);y=w;w=t-(f[s>>2]=p,+n[s>>2]);t=y*v;y=x*w;o=(y>t?1:y<t?2:3)|o;i=i+1|0;if((o|0)==3){m=0;break a}if((i|0)>=(a|0)){m=1;break}}}}else m=0;while(0);a=d+36|0;g=f[a>>2]|0;if(g|0?(i=g+12|0,g=f[i>>2]|0,f[i>>2]=g+-1,(g|0)==1):0)kL(d);f[a>>2]=0;a=d+16|0;g=d+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[g>>2]|0)>0){a=f[d+40>>2]|0;i=0;do{f[a+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[d+44>>2]|0;if((g|0)==(d+48|0)){u=c;return m|0}UC(g);u=c;return m|0}function JZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0;e=u;u=u+128|0;g=e+72|0;h=e+16|0;i=e;do if((yM(b)|0)==65536){j=f[b+4>>2]|0;f[g>>2]=f[j>>2];k=g+4|0;l=j+4|0;f[k>>2]=f[l>>2];m=g+8|0;f[m>>2]=f[j+8>>2];f[g+12>>2]=f[j+12>>2];f[g+16>>2]=f[j+16>>2];f[g+20>>2]=f[j+20>>2];f[g+24>>2]=f[j+24>>2];f[g+28>>2]=f[j+28>>2];f[g+32>>2]=f[j+32>>2];n=f[j+36>>2]|0;f[g+36>>2]=n;f[g+40>>2]=m;m=g+48|0;o=g+44|0;f[o>>2]=m;f[m>>2]=0;f[g+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[j+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2];break}else{f[k>>2]=0;jL(g,j);break}}else yL(g,b,-1);while(0);do if(!d?(b=f[g>>2]|0,(b&4095|0)==6):0){f[a>>2]=b;b=a+4|0;j=g+4|0;k=f[j>>2]|0;f[b>>2]=k;l=a+8|0;f[l>>2]=f[g+8>>2];f[a+12>>2]=f[g+12>>2];f[a+16>>2]=f[g+16>>2];f[a+20>>2]=f[g+20>>2];f[a+24>>2]=f[g+24>>2];f[a+28>>2]=f[g+28>>2];f[a+32>>2]=f[g+32>>2];m=g+36|0;o=f[m>>2]|0;f[a+36>>2]=o;f[a+40>>2]=l;l=a+48|0;n=a+44|0;f[n>>2]=l;f[l>>2]=0;f[a+52>>2]=0;if(!o)q=k;else{k=o+12|0;f[k>>2]=(f[k>>2]|0)+1;q=f[j>>2]|0}if((q|0)<3){j=f[g+44>>2]|0;k=f[n>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];r=m;break}else{f[b>>2]=0;jL(a,g);r=m;break}}else s=15;while(0);if((s|0)==15){f[h>>2]=1124007936;s=h+4|0;q=h+8|0;m=h+40|0;b=s;j=b+36|0;do{f[b>>2]=0;b=b+4|0}while((b|0)<(j|0));f[m>>2]=q;b=h+48|0;j=h+44|0;f[j>>2]=b;f[b>>2]=0;f[h+52>>2]=0;k=i+8|0;f[k>>2]=0;f[k+4>>2]=0;f[i>>2]=33619968;f[i+4>>2]=h;OJ(g,i,6,1.0,0.0);if(d){d=h+16|0;i=f[d>>2]|0;p[i+16>>3]=+((f[c>>2]|0)+-1|0)*.5;p[i+40>>3]=+((f[c+4>>2]|0)+-1|0)*.5;t=d;v=i}else{i=h+16|0;t=i;v=f[i>>2]|0}f[a>>2]=f[h>>2];i=a+4|0;d=f[s>>2]|0;f[i>>2]=d;c=a+8|0;f[c>>2]=f[q>>2];f[a+12>>2]=f[h+12>>2];f[a+16>>2]=v;f[a+20>>2]=f[h+20>>2];f[a+24>>2]=f[h+24>>2];f[a+28>>2]=f[h+28>>2];f[a+32>>2]=f[h+32>>2];v=h+36|0;q=f[v>>2]|0;f[a+36>>2]=q;f[a+40>>2]=c;c=a+48|0;k=a+44|0;f[k>>2]=c;f[c>>2]=0;f[a+52>>2]=0;if(!q)w=d;else{d=q+12|0;f[d>>2]=(f[d>>2]|0)+1;w=f[s>>2]|0}if((w|0)<3){w=f[j>>2]|0;d=f[k>>2]|0;f[d>>2]=f[w>>2];f[d+4>>2]=f[w+4>>2]}else{f[i>>2]=0;jL(a,h)}a=f[v>>2]|0;if(a|0?(i=a+12|0,a=f[i>>2]|0,f[i>>2]=a+-1,(a|0)==1):0)kL(h);f[v>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[m>>2]|0;m=0;do{f[t+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[s>>2]|0))}s=f[j>>2]|0;if((s|0)!=(b|0))UC(s);r=g+36|0}s=f[r>>2]|0;if(s|0?(b=s+12|0,s=f[b>>2]|0,f[b>>2]=s+-1,(s|0)==1):0)kL(g);f[r>>2]=0;r=g+16|0;s=g+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[s>>2]|0)>0){r=f[g+40>>2]|0;b=0;do{f[r+(b<<2)>>2]=0;b=b+1|0}while((b|0)<(f[s>>2]|0))}s=f[g+44>>2]|0;if((s|0)==(g+48|0)){u=e;return}UC(s);u=e;return}function KZ(a,c,e,g,h,i,j,k){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0;l=u;u=u+1552|0;m=l+672|0;o=l+1536|0;q=l+1480|0;r=l+1424|0;s=l+1368|0;t=l+1304|0;v=l+1360|0;w=l+1248|0;x=l+1184|0;y=l+1240|0;z=l+1128|0;A=l+448|0;B=l+1072|0;C=l+1016|0;D=l+1008|0;E=l+952|0;F=l+224|0;G=l;H=l+896|0;do if((yM(a)|0)==65536){I=f[a+4>>2]|0;f[q>>2]=f[I>>2];J=q+4|0;K=I+4|0;f[J>>2]=f[K>>2];L=q+8|0;f[L>>2]=f[I+8>>2];f[q+12>>2]=f[I+12>>2];f[q+16>>2]=f[I+16>>2];f[q+20>>2]=f[I+20>>2];f[q+24>>2]=f[I+24>>2];f[q+28>>2]=f[I+28>>2];f[q+32>>2]=f[I+32>>2];M=f[I+36>>2]|0;f[q+36>>2]=M;f[q+40>>2]=L;L=q+48|0;N=q+44|0;f[N>>2]=L;f[L>>2]=0;f[q+52>>2]=0;if(M|0){L=M+12|0;f[L>>2]=(f[L>>2]|0)+1}if((f[K>>2]|0)<3){K=f[I+44>>2]|0;L=f[N>>2]|0;f[L>>2]=f[K>>2];f[L+4>>2]=f[K+4>>2];break}else{f[J>>2]=0;jL(q,I);break}}else yL(q,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[r>>2]=f[a>>2];I=r+4|0;J=a+4|0;f[I>>2]=f[J>>2];K=r+8|0;f[K>>2]=f[a+8>>2];f[r+12>>2]=f[a+12>>2];f[r+16>>2]=f[a+16>>2];f[r+20>>2]=f[a+20>>2];f[r+24>>2]=f[a+24>>2];f[r+28>>2]=f[a+28>>2];f[r+32>>2]=f[a+32>>2];L=f[a+36>>2]|0;f[r+36>>2]=L;f[r+40>>2]=K;K=r+48|0;N=r+44|0;f[N>>2]=K;f[K>>2]=0;f[r+52>>2]=0;if(L|0){K=L+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[J>>2]|0)<3){J=f[a+44>>2]|0;K=f[N>>2]|0;f[K>>2]=f[J>>2];f[K+4>>2]=f[J+4>>2];break}else{f[I>>2]=0;jL(r,a);break}}else yL(r,c,-1);while(0);do if((yM(e)|0)==65536){c=f[e+4>>2]|0;f[s>>2]=f[c>>2];a=s+4|0;I=c+4|0;f[a>>2]=f[I>>2];J=s+8|0;f[J>>2]=f[c+8>>2];f[s+12>>2]=f[c+12>>2];f[s+16>>2]=f[c+16>>2];f[s+20>>2]=f[c+20>>2];f[s+24>>2]=f[c+24>>2];f[s+28>>2]=f[c+28>>2];f[s+32>>2]=f[c+32>>2];K=f[c+36>>2]|0;f[s+36>>2]=K;f[s+40>>2]=J;J=s+48|0;N=s+44|0;f[N>>2]=J;f[J>>2]=0;f[s+52>>2]=0;if(K|0){J=K+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[I>>2]|0)<3){I=f[c+44>>2]|0;J=f[N>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];break}else{f[a>>2]=0;jL(s,c);break}}else yL(s,e,-1);while(0);do if((yM(g)|0)==65536){e=f[g+4>>2]|0;f[t>>2]=f[e>>2];c=t+4|0;a=e+4|0;f[c>>2]=f[a>>2];I=t+8|0;f[I>>2]=f[e+8>>2];f[t+12>>2]=f[e+12>>2];f[t+16>>2]=f[e+16>>2];f[t+20>>2]=f[e+20>>2];f[t+24>>2]=f[e+24>>2];f[t+28>>2]=f[e+28>>2];f[t+32>>2]=f[e+32>>2];J=f[e+36>>2]|0;f[t+36>>2]=J;f[t+40>>2]=I;I=t+48|0;N=t+44|0;f[N>>2]=I;f[I>>2]=0;f[t+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[a>>2]|0)<3){a=f[e+44>>2]|0;I=f[N>>2]|0;f[I>>2]=f[a>>2];f[I+4>>2]=f[a+4>>2];break}else{f[c>>2]=0;jL(t,e);break}}else yL(t,g,-1);while(0);g=(i|0)<1?11:i;i=(g|0)==11;e=(g|0)==5;switch(g|0){case 5:case 11:case 13:break;default:{f[m>>2]=0;f[m+4>>2]=0;Vac(aD(m,161)|0,216675,161)|0;bO(-215,m,216837,216861,73);bD(m)}}f[v>>2]=f[h>>2];c=h+4|0;f[v+4>>2]=f[c>>2];vM(j,v,g,-1,0,0);do if((yM(j)|0)==65536){v=f[j+4>>2]|0;f[w>>2]=f[v>>2];a=w+4|0;I=v+4|0;f[a>>2]=f[I>>2];N=w+8|0;f[N>>2]=f[v+8>>2];f[w+12>>2]=f[v+12>>2];f[w+16>>2]=f[v+16>>2];f[w+20>>2]=f[v+20>>2];f[w+24>>2]=f[v+24>>2];f[w+28>>2]=f[v+28>>2];f[w+32>>2]=f[v+32>>2];J=f[v+36>>2]|0;f[w+36>>2]=J;f[w+40>>2]=N;N=w+48|0;K=w+44|0;f[K>>2]=N;f[N>>2]=0;f[w+52>>2]=0;if(J|0){N=J+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[I>>2]|0)<3){I=f[v+44>>2]|0;N=f[K>>2]|0;f[N>>2]=f[I>>2];f[N+4>>2]=f[I+4>>2];break}else{f[a>>2]=0;jL(w,v);break}}else yL(w,j,-1);while(0);f[x>>2]=1124007936;j=x+4|0;v=x+8|0;a=x+40|0;I=j;N=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(N|0));f[a>>2]=v;K=x+48|0;J=x+44|0;f[J>>2]=K;f[K>>2]=0;f[x+52>>2]=0;if((g|0)!=13){f[y>>2]=f[h>>2];f[y+4>>2]=f[c>>2];vM(k,y,i?2:5,-1,0,0);do if((yM(k)|0)==65536){y=f[k+4>>2]|0;f[m>>2]=f[y>>2];g=m+4|0;L=y+4|0;f[g>>2]=f[L>>2];M=m+8|0;f[M>>2]=f[y+8>>2];f[m+12>>2]=f[y+12>>2];f[m+16>>2]=f[y+16>>2];f[m+20>>2]=f[y+20>>2];f[m+24>>2]=f[y+24>>2];f[m+28>>2]=f[y+28>>2];f[m+32>>2]=f[y+32>>2];Q=m+36|0;R=f[y+36>>2]|0;f[Q>>2]=R;f[m+40>>2]=M;M=m+48|0;S=m+44|0;f[S>>2]=M;f[M>>2]=0;f[m+52>>2]=0;if(R|0){M=R+12|0;f[M>>2]=(f[M>>2]|0)+1}if((f[L>>2]|0)<3){L=f[y+44>>2]|0;M=f[S>>2]|0;f[M>>2]=f[L>>2];f[M+4>>2]=f[L+4>>2];T=Q;break}else{f[g>>2]=0;jL(m,y);T=Q;break}}else{yL(m,k,-1);T=m+36|0}while(0);Q=f[T>>2]|0;if(Q|0){y=Q+12|0;f[y>>2]=(f[y>>2]|0)+1}y=x+36|0;Q=f[y>>2]|0;if(Q|0?(g=Q+12|0,Q=f[g>>2]|0,f[g>>2]=Q+-1,(Q|0)==1):0)kL(x);f[y>>2]=0;Q=x+16|0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[j>>2]|0)>0){g=f[a>>2]|0;L=0;do{f[g+(L<<2)>>2]=0;L=L+1|0;U=f[j>>2]|0}while((L|0)<(U|0));f[x>>2]=f[m>>2];if((U|0)<3)V=56;else V=58}else{f[x>>2]=f[m>>2];V=56}if((V|0)==56){U=f[m+4>>2]|0;if((U|0)<3){f[j>>2]=U;f[v>>2]=f[m+8>>2];f[x+12>>2]=f[m+12>>2];U=f[m+44>>2]|0;L=f[J>>2]|0;f[L>>2]=f[U>>2];f[L+4>>2]=f[U+4>>2]}else V=58}if((V|0)==58)jL(x,m);U=m+16|0;f[Q>>2]=f[U>>2];f[x+20>>2]=f[m+20>>2];f[x+24>>2]=f[m+24>>2];f[x+28>>2]=f[m+28>>2];f[x+32>>2]=f[m+32>>2];Q=f[T>>2]|0;f[y>>2]=Q;if(Q|0?(y=Q+12|0,Q=f[y>>2]|0,f[y>>2]=Q+-1,(Q|0)==1):0)kL(m);f[T>>2]=0;T=m+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[T>>2]|0)>0){U=f[m+40>>2]|0;Q=0;do{f[U+(Q<<2)>>2]=0;Q=Q+1|0}while((Q|0)<(f[T>>2]|0))}T=f[m+44>>2]|0;if((T|0)!=(m+48|0))UC(T)}else $L(k);VS(A,3,3,6);LZ(z,A);Wi(A);MZ(B,q);A=C+4|0;k=C+8|0;T=C+40|0;I=A;N=I+36|0;do{f[I>>2]=0;I=I+4|0}while((I|0)<(N|0));f[T>>2]=k;k=C+48|0;Q=C+44|0;f[Q>>2]=k;f[k>>2]=0;f[C+52>>2]=0;f[C>>2]=1124007942;U=t+16|0;if(f[U>>2]|0){y=f[t+4>>2]|0;if((y|0)<3)W=Y(f[t+12>>2]|0,f[t+8>>2]|0)|0;else{L=f[t+40>>2]|0;g=0;M=1;while(1){S=Y(f[L+(g<<2)>>2]|0,M)|0;g=g+1|0;if((g|0)==(y|0)){W=S;break}else M=S}}if(!((y|0)==0|(W|0)==0)){MZ(m,t);NZ(C,m)|0;W=m+36|0;y=f[W>>2]|0;if(y|0?(M=y+12|0,y=f[M>>2]|0,f[M>>2]=y+-1,(y|0)==1):0)kL(m);f[W>>2]=0;W=m+16|0;y=m+4|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[y>>2]|0)>0){W=f[m+40>>2]|0;M=0;do{f[W+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[y>>2]|0))}y=f[m+44>>2]|0;if((y|0)!=(m+48|0))UC(y)}else V=84}else V=84;if((V|0)==84){f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=-2130640890;f[o+4>>2]=B;f[D>>2]=f[h>>2];f[D+4>>2]=f[c>>2];JZ(m,o,D,1);OZ(C,m)|0;D=m+36|0;y=f[D>>2]|0;if(y|0?(M=y+12|0,y=f[M>>2]|0,f[M>>2]=y+-1,(y|0)==1):0)kL(m);f[D>>2]=0;D=m+16|0;y=m+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[y>>2]|0)>0){D=f[m+40>>2]|0;M=0;do{f[D+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[y>>2]|0))}y=f[m+44>>2]|0;if((y|0)!=(m+48|0))UC(y)}y=s+16|0;if(f[y>>2]|0){M=f[s+4>>2]|0;if((M|0)<3)X=Y(f[s+12>>2]|0,f[s+8>>2]|0)|0;else{D=f[s+40>>2]|0;W=0;g=1;while(1){L=Y(f[D+(W<<2)>>2]|0,g)|0;W=W+1|0;if((W|0)==(M|0)){X=L;break}else g=L}}if(!((M|0)==0|(X|0)==0)){MZ(m,s);NZ(z,m)|0;X=m+36|0;M=f[X>>2]|0;if(M|0?(g=M+12|0,M=f[g>>2]|0,f[g>>2]=M+-1,(M|0)==1):0)kL(m);f[X>>2]=0;X=m+16|0;M=m+4|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[M>>2]|0)>0){X=f[m+40>>2]|0;g=0;do{f[X+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[M>>2]|0))}M=f[m+44>>2]|0;if((M|0)!=(m+48|0))UC(M)}}M=r+16|0;g=(f[M>>2]|0)==0;X=r+4|0;W=f[X>>2]|0;if(!g){if((W|0)<3)Z=Y(f[r+12>>2]|0,f[r+8>>2]|0)|0;else{D=f[r+40>>2]|0;L=0;S=1;while(1){R=Y(f[D+(L<<2)>>2]|0,S)|0;L=L+1|0;if((L|0)==(W|0)){Z=R;break}else S=R}}if(!((W|0)==0|(Z|0)==0)){MZ(m,r);Z=m+36|0;S=f[Z>>2]|0;if(S|0){L=S+12|0;f[L>>2]=(f[L>>2]|0)+1}L=r+36|0;S=f[L>>2]|0;if(S|0?(D=S+12|0,S=f[D>>2]|0,f[D>>2]=S+-1,(S|0)==1):0)kL(r);f[L>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[X>>2]|0)>0){S=f[r+40>>2]|0;D=0;do{f[S+(D<<2)>>2]=0;D=D+1|0;_=f[X>>2]|0}while((D|0)<(_|0));f[r>>2]=f[m>>2];if((_|0)<3)V=124;else V=126}else{f[r>>2]=f[m>>2];V=124}if((V|0)==124){_=f[m+4>>2]|0;if((_|0)<3){f[X>>2]=_;f[r+8>>2]=f[m+8>>2];f[r+12>>2]=f[m+12>>2];_=f[m+44>>2]|0;X=f[r+44>>2]|0;f[X>>2]=f[_>>2];f[X+4>>2]=f[_+4>>2]}else V=126}if((V|0)==126)jL(r,m);_=m+16|0;f[M>>2]=f[_>>2];f[r+20>>2]=f[m+20>>2];f[r+24>>2]=f[m+24>>2];f[r+28>>2]=f[m+28>>2];f[r+32>>2]=f[m+32>>2];X=f[Z>>2]|0;f[L>>2]=X;if(X|0?(L=X+12|0,X=f[L>>2]|0,f[L>>2]=X+-1,(X|0)==1):0)kL(m);f[Z>>2]=0;Z=m+4|0;f[_>>2]=0;f[_+4>>2]=0;f[_+8>>2]=0;f[_+12>>2]=0;if((f[Z>>2]|0)>0){_=f[m+40>>2]|0;X=0;do{f[_+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[Z>>2]|0))}Z=f[m+44>>2]|0;if((Z|0)!=(m+48|0))UC(Z)}else V=136}else V=136;if((V|0)==136){if(!((((W|0)<3?(f[r+8>>2]|0)==14:0)?(f[r+12>>2]|0)==1:0)?!((f[r>>2]&4095|0)!=6|g):0))V=140;if((V|0)==140){f[m>>2]=14;f[m+4>>2]=1;hL(r,2,m,6)};f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[m+28>>2]=0;UP(r,m)|0}V=B+40|0;g=f[V>>2]|0;if(!(((f[g>>2]|0)==3?(f[g+4>>2]|0)==3:0)?(g=f[z+40>>2]|0,(f[g>>2]|0)==3?(f[g+4>>2]|0)==3:0):0)){f[m>>2]=0;f[m+4>>2]=0;I=aD(m,45)|0;$=216935;N=I+45|0;do{b[I>>0]=b[$>>0]|0;I=I+1|0;$=$+1|0}while((I|0)<(N|0));bO(-215,m,216837,216861,103);bD(m)}g=f[T>>2]|0;if(!((f[g>>2]|0)==3?((f[g+4>>2]|0)+-3|0)>>>0<2:0)){f[m>>2]=0;f[m+4>>2]=0;I=aD(m,49)|0;$=216981;N=I+49|0;do{b[I>>0]=b[$>>0]|0;I=I+1|0;$=$+1|0}while((I|0)<(N|0));bO(-215,m,216837,216861,104);bD(m)}f[m>>2]=-2147483648;f[m+4>>2]=2147483647;f[o>>2]=0;f[o+4>>2]=3;lL(H,C,m,o);CS(G,H,z);rS(F,G,0);LZ(E,F);Wi(F);Wi(G);G=H+36|0;F=f[G>>2]|0;if(F|0?(o=F+12|0,F=f[o>>2]|0,f[o>>2]=F+-1,(F|0)==1):0)kL(H);f[G>>2]=0;G=H+16|0;F=H+4|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[F>>2]|0)>0){G=f[H+40>>2]|0;o=0;do{f[G+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[F>>2]|0))}F=f[H+44>>2]|0;if((F|0)!=(H+48|0))UC(F);F=E+16|0;H=f[F>>2]|0;o=B+16|0;G=f[o>>2]|0;g=B+44|0;aa=+p[G+16>>3];W=G+(f[f[g>>2]>>2]|0)|0;ba=+p[W+16>>3];ca=+p[G>>3];da=+p[W+8>>3];W=r+40|0;G=f[W>>2]|0;Z=f[G+4>>2]|0;X=f[G>>2]|0;G=(Z|0)==1;if(!(G&(X|0)==4)?(_=(X|0)==1,!((Z|0)==14&_|(G&(X|0)==14|((Z|0)==12&_|(G&(X|0)==12|((Z|0)==8&_|(G&(X|0)==8|((Z|0)==5&_|((Z|0)==4&_|G&(X|0)==5))))))))):0){f[m>>2]=0;f[m+4>>2]=0;Vac(aD(m,350)|0,217031,350)|0;bO(-215,m,216837,216861,115);bD(m)}X=r+8|0;G=f[X>>2]|0;if((G|0)!=1)if(!(f[r>>2]&16384)){NS(m,r);_=f[m>>2]|0;th[f[(f[_>>2]|0)+12>>2]&511](_,m,r,-1);Wi(m);ea=f[X>>2]|0}else ea=G;else ea=1;G=f[M>>2]|0;X=r+44|0;fa=+p[G>>3];ga=+p[G+8>>3];ha=+p[G+16>>3];ia=+p[G+24>>3];_=(f[r+12>>2]|0)+-1+ea|0;do if((_|0)>4){ja=+p[G+32>>3];if((_|0)>7){ka=+p[G+40>>3];la=+p[G+48>>3];ma=+p[G+56>>3];if((_|0)>11){na=+p[G+64>>3];oa=+p[G+72>>3];pa=+p[G+80>>3];qa=+p[G+88>>3];if((_|0)<=13){ra=0.0;sa=0.0;ta=ja;ua=ma;va=la;wa=ka;xa=na;ya=oa;za=pa;Aa=qa;break}ra=+p[G+96>>3];sa=+p[G+104>>3];ta=ja;ua=ma;va=la;wa=ka;xa=na;ya=oa;za=pa;Aa=qa}else{ra=0.0;sa=0.0;ta=ja;ua=ma;va=la;wa=ka;xa=0.0;ya=0.0;za=0.0;Aa=0.0}}else{ra=0.0;sa=0.0;ta=ja;ua=0.0;va=0.0;wa=0.0;xa=0.0;ya=0.0;za=0.0;Aa=0.0}}else{ra=0.0;sa=0.0;ta=0.0;ua=0.0;va=0.0;wa=0.0;xa=0.0;ya=0.0;za=0.0;Aa=0.0}while(0);ja=+O(+ra);ka=+P(+ra);ra=+O(+sa);la=+P(+sa);sa=la*0.0;ma=ra+0.0-sa;qa=ra*0.0;pa=qa+0.0;oa=ja*0.0;na=ka*la+(oa+pa);Ba=ka*0.0;Ca=Ba+pa-ja*la;pa=ja+0.0-Ba;Da=oa+(ka+0.0);Ea=qa+(la+0.0);la=sa+0.0;sa=oa+la-ka*ra;ka=ja*ra+(Ba+la);la=-Ca;Ba=-Da;ra=Ea*la+(ma*ka+0.0);ja=pa*0.0;oa=sa*la+(ja+(na*ka+0.0));qa=Da*0.0;Fa=ka*la+(qa+(Ca*ka+0.0));la=ma*0.0+0.0;ma=Ea*Ba+(la+ka*0.0);Ga=na*0.0+0.0;na=sa*Ba+(Ga+pa*ka);pa=Ca*0.0+0.0;Ca=ka*Ba+(pa+Da*ka);Da=Ea+la;la=sa+(ja+Ga);Ga=ka+(qa+pa);if((f[c>>2]|0)>0){G=w+16|0;_=w+44|0;ea=x+16|0;Z=H+8|0;L=H+16|0;D=H+32|0;S=H+40|0;R=H+56|0;Ha=H+64|0;Ia=m+4|0;Ja=m+4|0;Ka=m+4|0;La=H+24|0;Ma=H+48|0;Na=x+12|0;Oa=0;do{Pa=(f[G>>2]|0)+(Y(f[f[_>>2]>>2]|0,Oa)|0)|0;Qa=f[ea>>2]|0;do if(!Qa)Ra=0;else{Sa=f[j>>2]|0;if((Sa|0)<3)Ta=Y(f[Na>>2]|0,f[v>>2]|0)|0;else{Ua=f[a>>2]|0;Va=0;Wa=1;while(1){Xa=Y(f[Ua+(Va<<2)>>2]|0,Wa)|0;Va=Va+1|0;if((Va|0)==(Sa|0)){Ta=Xa;break}else Wa=Xa}}if((Sa|0)==0|(Ta|0)==0){Ra=0;break}Ra=Qa+(Y(f[f[J>>2]>>2]|0,Oa)|0)|0}while(0);pa=+(Oa|0);qa=pa*+p[Z>>3]+ +p[L>>3];ka=pa*+p[D>>3]+ +p[S>>3];ja=pa*+p[R>>3]+ +p[Ha>>3];do if(!i)if(e){if((Pa|0)!=0&(Ra|0)!=0)break;f[m>>2]=0;f[Ja>>2]=0;I=aD(m,22)|0;$=217403;N=I+22|0;do{b[I>>0]=b[$>>0]|0;I=I+1|0;$=$+1|0}while((I|0)<(N|0));bO(-215,m,216837,216861,157);bD(m);break}else{if(Pa|0)break;f[m>>2]=0;f[Ka>>2]=0;Sa=aD(m,8)|0;Qa=Sa;b[Qa>>0]=109;b[Qa+1>>0]=49;b[Qa+2>>0]=32;b[Qa+3>>0]=33;Qa=Sa+4|0;b[Qa>>0]=61;b[Qa+1>>0]=32;b[Qa+2>>0]=48;b[Qa+3>>0]=76;bO(-215,m,216837,216861,159);bD(m);break}else{if((Pa|0)!=0&(Ra|0)!=0)break;f[m>>2]=0;f[Ia>>2]=0;I=aD(m,20)|0;$=217382;N=I+20|0;do{b[I>>0]=b[$>>0]|0;I=I+1|0;$=$+1|0}while((I|0)<(N|0));bO(-215,m,216837,216861,155);bD(m)}while(0);Qa=f[h>>2]|0;if((Qa|0)>0){pa=+p[H>>3];sa=+p[La>>3];Ea=+p[Ma>>3];Sa=0;Ba=ja;Ya=ka;Za=qa;while(1){_a=1.0/Ba;$a=Za*_a;ab=Ya*_a;_a=$a*$a;bb=ab*ab;cb=_a+bb;db=ab*($a*2.0);eb=(cb*(fa+cb*(ga+ta*cb))+1.0)/(cb*(wa+cb*(va+ua*cb))+1.0);fb=cb*(ya*cb)+(xa*cb+(ia*(cb+_a*2.0)+(ha*db+$a*eb)));$a=cb*(Aa*cb)+(za*cb+(ia*db+(ha*(cb+bb*2.0)+ab*eb)));eb=Ga+(la*$a+(Da*fb+0.0));ab=eb!=0.0?1.0/eb:1.0;eb=aa+(Fa+(oa*$a+(ra*fb+0.0)))*(ca*ab);bb=ba+(Ca+(na*$a+(ma*fb+0.0)))*(da*ab);if(i){Wa=MVb(eb*32.0)|0;Va=MVb(bb*32.0)|0;d[Pa+(Sa<<2)>>1]=Wa>>>5;d[Pa+((Sa<<1|1)<<1)>>1]=Va>>>5;d[Ra+(Sa<<1)>>1]=Va<<5&992|Wa&31}else{ab=eb;if(e){n[Pa+(Sa<<2)>>2]=ab;gb=Ra+(Sa<<2)|0}else{Wa=Sa<<1;n[Pa+(Wa<<2)>>2]=ab;gb=Pa+((Wa|1)<<2)|0}n[gb>>2]=bb}Sa=Sa+1|0;if((Sa|0)>=(Qa|0))break;else{Ba=Ba+Ea;Ya=Ya+sa;Za=Za+pa}}}Oa=Oa+1|0}while((Oa|0)<(f[c>>2]|0))}c=E+36|0;Oa=f[c>>2]|0;do if(Oa|0){gb=Oa+12|0;Ra=f[gb>>2]|0;f[gb>>2]=Ra+-1;if((Ra|0)!=1)break;kL(E)}while(0);f[c>>2]=0;c=E+4|0;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;if((f[c>>2]|0)>0){F=f[E+40>>2]|0;Oa=0;do{f[F+(Oa<<2)>>2]=0;Oa=Oa+1|0}while((Oa|0)<(f[c>>2]|0))}c=f[E+44>>2]|0;if((c|0)!=(E+48|0))UC(c);c=C+36|0;E=f[c>>2]|0;do if(E|0){Oa=E+12|0;F=f[Oa>>2]|0;f[Oa>>2]=F+-1;if((F|0)!=1)break;kL(C)}while(0);f[c>>2]=0;c=C+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[A>>2]|0)>0){c=f[T>>2]|0;T=0;do{f[c+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[A>>2]|0))}A=f[Q>>2]|0;if((A|0)!=(k|0))UC(A);A=B+36|0;k=f[A>>2]|0;do if(k|0){Q=k+12|0;T=f[Q>>2]|0;f[Q>>2]=T+-1;if((T|0)!=1)break;kL(B)}while(0);f[A>>2]=0;A=B+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[A>>2]|0)>0){o=f[V>>2]|0;V=0;do{f[o+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[A>>2]|0))}A=f[g>>2]|0;if((A|0)!=(B+48|0))UC(A);A=z+36|0;B=f[A>>2]|0;do if(B|0){g=B+12|0;V=f[g>>2]|0;f[g>>2]=V+-1;if((V|0)!=1)break;kL(z)}while(0);f[A>>2]=0;A=z+16|0;B=z+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[B>>2]|0)>0){A=f[z+40>>2]|0;V=0;do{f[A+(V<<2)>>2]=0;V=V+1|0}while((V|0)<(f[B>>2]|0))}B=f[z+44>>2]|0;if((B|0)!=(z+48|0))UC(B);B=x+36|0;z=f[B>>2]|0;do if(z|0){V=z+12|0;A=f[V>>2]|0;f[V>>2]=A+-1;if((A|0)!=1)break;kL(x)}while(0);f[B>>2]=0;B=x+16|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[j>>2]|0)>0){B=f[a>>2]|0;a=0;do{f[B+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[j>>2]|0))}j=f[J>>2]|0;if((j|0)!=(K|0))UC(j);j=w+36|0;K=f[j>>2]|0;do if(K|0){J=K+12|0;a=f[J>>2]|0;f[J>>2]=a+-1;if((a|0)!=1)break;kL(w)}while(0);f[j>>2]=0;j=w+16|0;K=w+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[K>>2]|0)>0){j=f[w+40>>2]|0;a=0;do{f[j+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[K>>2]|0))}K=f[w+44>>2]|0;if((K|0)!=(w+48|0))UC(K);K=t+36|0;w=f[K>>2]|0;do if(w|0){a=w+12|0;j=f[a>>2]|0;f[a>>2]=j+-1;if((j|0)!=1)break;kL(t)}while(0);f[K>>2]=0;K=t+4|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[K>>2]|0)>0){U=f[t+40>>2]|0;w=0;do{f[U+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[K>>2]|0))}K=f[t+44>>2]|0;if((K|0)!=(t+48|0))UC(K);K=s+36|0;t=f[K>>2]|0;do if(t|0){w=t+12|0;U=f[w>>2]|0;f[w>>2]=U+-1;if((U|0)!=1)break;kL(s)}while(0);f[K>>2]=0;K=s+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[K>>2]|0)>0){y=f[s+40>>2]|0;t=0;do{f[y+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[K>>2]|0))}K=f[s+44>>2]|0;if((K|0)!=(s+48|0))UC(K);K=r+36|0;s=f[K>>2]|0;do if(s|0){t=s+12|0;y=f[t>>2]|0;f[t>>2]=y+-1;if((y|0)!=1)break;kL(r)}while(0);f[K>>2]=0;K=r+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[K>>2]|0)>0){M=f[W>>2]|0;W=0;do{f[M+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[K>>2]|0))}K=f[X>>2]|0;if((K|0)!=(r+48|0))UC(K);K=q+36|0;r=f[K>>2]|0;do if(r|0){X=r+12|0;W=f[X>>2]|0;f[X>>2]=W+-1;if((W|0)!=1)break;kL(q)}while(0);f[K>>2]=0;K=q+16|0;r=q+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[r>>2]|0)>0){K=f[q+40>>2]|0;W=0;do{f[K+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[r>>2]|0))}r=f[q+44>>2]|0;if((r|0)==(q+48|0)){u=l;return}UC(r);u=l;return}function LZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=a+40|0;e=a+4|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;f[a>>2]=1124007942;c=f[b>>2]|0;th[f[(f[c>>2]|0)+12>>2]&511](c,b,a,6);return}function MZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;c=a+8|0;d=a+40|0;e=a+4|0;g=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(g|0));f[d>>2]=c;c=a+48|0;f[a+44>>2]=c;f[c>>2]=0;f[a+52>>2]=0;f[a>>2]=1124007942;OZ(a,b)|0;return}function NZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;if((a|0)==(b|0))return a|0;c=b+36|0;d=f[c>>2]|0;if(d|0){e=d+12|0;f[e>>2]=(f[e>>2]|0)+1}e=a+36|0;d=f[e>>2]|0;if(d|0?(g=d+12|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)kL(a);f[e>>2]=0;d=a+16|0;g=a+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[g>>2]|0)>0){h=f[a+40>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0;j=f[g>>2]|0}while((i|0)<(j|0));f[a>>2]=f[b>>2];if((j|0)<3)k=12;else k=14}else{f[a>>2]=f[b>>2];k=12}if((k|0)==12){j=f[b+4>>2]|0;if((j|0)<3){f[g>>2]=j;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];j=f[b+44>>2]|0;g=f[a+44>>2]|0;f[g>>2]=f[j>>2];f[g+4>>2]=f[j+4>>2]}else k=14}if((k|0)==14)jL(a,b);f[d>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[e>>2]=f[c>>2];return a|0}function OZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+64|0;d=c;e=f[b>>2]|0;if((e&4095|0)!=6){if((e&7|0)!=6){e=d+8|0;f[e>>2]=0;f[e+4>>2]=0;f[d>>2]=-2113863674;f[d+4>>2]=a;OJ(b,d,6,1.0,0.0);g=a;u=c;return g|0}XL(d,b,1,f[b+4>>2]|0,0);e=OZ(a,d)|0;h=d+36|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)kL(d);f[h>>2]=0;h=d+16|0;i=d+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[i>>2]|0)>0){h=f[d+40>>2]|0;j=0;do{f[h+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[i>>2]|0))}i=f[d+44>>2]|0;if((i|0)!=(d+48|0))UC(i);g=e;u=c;return g|0}if((a|0)==(b|0)){g=a;u=c;return g|0}e=b+36|0;i=f[e>>2]|0;if(i|0){d=i+12|0;f[d>>2]=(f[d>>2]|0)+1}d=a+36|0;i=f[d>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)kL(a);f[d>>2]=0;i=a+16|0;j=a+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[j>>2]|0)>0){h=f[a+40>>2]|0;k=0;do{f[h+(k<<2)>>2]=0;k=k+1|0;l=f[j>>2]|0}while((k|0)<(l|0));f[a>>2]=f[b>>2];if((l|0)<3)m=13;else m=15}else{f[a>>2]=f[b>>2];m=13}if((m|0)==13){l=f[b+4>>2]|0;if((l|0)<3){f[j>>2]=l;f[a+8>>2]=f[b+8>>2];f[a+12>>2]=f[b+12>>2];l=f[b+44>>2]|0;j=f[a+44>>2]|0;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2]}else m=15}if((m|0)==15)jL(a,b);f[i>>2]=f[b+16>>2];f[a+20>>2]=f[b+20>>2];f[a+24>>2]=f[b+24>>2];f[a+28>>2]=f[b+28>>2];f[a+32>>2]=f[b+32>>2];f[d>>2]=f[e>>2];g=a;u=c;return g|0}function PZ(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0;h=u;u=u+1136|0;i=h+256|0;j=h+1112|0;k=h+1096|0;l=h+1040|0;m=h+984|0;n=h+928|0;o=h+872|0;q=h+1104|0;r=h+816|0;s=h+760|0;t=h+704|0;v=h+648|0;w=h+592|0;x=h+536|0;y=h+32|0;z=h+472|0;A=h+416|0;B=h+360|0;C=h+344|0;D=h+328|0;E=h+528|0;F=h;G=h+312|0;dQ(k,48244);do if((yM(a)|0)==65536){H=f[a+4>>2]|0;f[l>>2]=f[H>>2];I=l+4|0;J=H+4|0;f[I>>2]=f[J>>2];K=l+8|0;f[K>>2]=f[H+8>>2];f[l+12>>2]=f[H+12>>2];f[l+16>>2]=f[H+16>>2];f[l+20>>2]=f[H+20>>2];f[l+24>>2]=f[H+24>>2];f[l+28>>2]=f[H+28>>2];f[l+32>>2]=f[H+32>>2];L=f[H+36>>2]|0;f[l+36>>2]=L;f[l+40>>2]=K;K=l+48|0;M=l+44|0;f[M>>2]=K;f[K>>2]=0;f[l+52>>2]=0;if(L|0){K=L+12|0;f[K>>2]=(f[K>>2]|0)+1}if((f[J>>2]|0)<3){J=f[H+44>>2]|0;K=f[M>>2]|0;f[K>>2]=f[J>>2];f[K+4>>2]=f[J+4>>2];break}else{f[I>>2]=0;jL(l,H);break}}else yL(l,a,-1);while(0);do if((yM(d)|0)==65536){a=f[d+4>>2]|0;f[m>>2]=f[a>>2];H=m+4|0;I=a+4|0;f[H>>2]=f[I>>2];J=m+8|0;f[J>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];K=f[a+36>>2]|0;f[m+36>>2]=K;f[m+40>>2]=J;J=m+48|0;M=m+44|0;f[M>>2]=J;f[J>>2]=0;f[m+52>>2]=0;if(K|0){J=K+12|0;f[J>>2]=(f[J>>2]|0)+1}if((f[I>>2]|0)<3){I=f[a+44>>2]|0;J=f[M>>2]|0;f[J>>2]=f[I>>2];f[J+4>>2]=f[I+4>>2];break}else{f[H>>2]=0;jL(m,a);break}}else yL(m,d,-1);while(0);do if((yM(e)|0)==65536){d=f[e+4>>2]|0;f[n>>2]=f[d>>2];a=n+4|0;H=d+4|0;f[a>>2]=f[H>>2];I=n+8|0;f[I>>2]=f[d+8>>2];f[n+12>>2]=f[d+12>>2];f[n+16>>2]=f[d+16>>2];f[n+20>>2]=f[d+20>>2];f[n+24>>2]=f[d+24>>2];f[n+28>>2]=f[d+28>>2];f[n+32>>2]=f[d+32>>2];J=f[d+36>>2]|0;f[n+36>>2]=J;f[n+40>>2]=I;I=n+48|0;M=n+44|0;f[M>>2]=I;f[I>>2]=0;f[n+52>>2]=0;if(J|0){I=J+12|0;f[I>>2]=(f[I>>2]|0)+1}if((f[H>>2]|0)<3){H=f[d+44>>2]|0;I=f[M>>2]|0;f[I>>2]=f[H>>2];f[I+4>>2]=f[H+4>>2];break}else{f[a>>2]=0;jL(n,d);break}}else yL(n,e,-1);while(0);do if((yM(g)|0)==65536){e=f[g+4>>2]|0;f[o>>2]=f[e>>2];d=o+4|0;a=e+4|0;f[d>>2]=f[a>>2];H=o+8|0;f[H>>2]=f[e+8>>2];f[o+12>>2]=f[e+12>>2];f[o+16>>2]=f[e+16>>2];f[o+20>>2]=f[e+20>>2];f[o+24>>2]=f[e+24>>2];f[o+28>>2]=f[e+28>>2];f[o+32>>2]=f[e+32>>2];I=f[e+36>>2]|0;f[o+36>>2]=I;f[o+40>>2]=H;H=o+48|0;M=o+44|0;f[M>>2]=H;f[H>>2]=0;f[o+52>>2]=0;if(I|0){H=I+12|0;f[H>>2]=(f[H>>2]|0)+1}if((f[a>>2]|0)<3){a=f[e+44>>2]|0;H=f[M>>2]|0;f[H>>2]=f[a>>2];f[H+4>>2]=f[a+4>>2];break}else{f[d>>2]=0;jL(o,e);break}}else yL(o,g,-1);while(0);g=l+40|0;e=f[g>>2]|0;d=f[e>>2]|0;f[q>>2]=f[e+4>>2];f[q+4>>2]=d;vM(c,q,f[l>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){q=f[c+4>>2]|0;f[r>>2]=f[q>>2];d=r+4|0;e=q+4|0;f[d>>2]=f[e>>2];a=r+8|0;f[a>>2]=f[q+8>>2];f[r+12>>2]=f[q+12>>2];H=r+16|0;f[H>>2]=f[q+16>>2];f[r+20>>2]=f[q+20>>2];f[r+24>>2]=f[q+24>>2];f[r+28>>2]=f[q+28>>2];f[r+32>>2]=f[q+32>>2];M=f[q+36>>2]|0;f[r+36>>2]=M;f[r+40>>2]=a;a=r+48|0;I=r+44|0;f[I>>2]=a;f[a>>2]=0;f[r+52>>2]=0;if(M|0){a=M+12|0;f[a>>2]=(f[a>>2]|0)+1}if((f[e>>2]|0)<3){e=f[q+44>>2]|0;a=f[I>>2]|0;f[a>>2]=f[e>>2];f[a+4>>2]=f[e+4>>2];N=H;break}else{f[d>>2]=0;jL(r,q);N=H;break}}else{yL(r,c,-1);N=r+16|0}while(0);c=l+16|0;if((f[N>>2]|0)==(f[c>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;O=aD(i,20)|0;H=217426;P=O+20|0;do{b[O>>0]=b[H>>0]|0;O=O+1|0;H=H+1|0}while((O|0)<(P|0));bO(-215,i,217447,216861,212);bD(i)}H=l+12|0;q=f[H>>2]|0;d=4096/(((q|0)>1?q:1)>>>0)|0;e=l+8|0;a=f[e>>2]|0;I=d>>>0>1?d:1;d=(a|0)<(I|0)?a:I;f[s>>2]=1124007936;I=s+4|0;a=s+8|0;M=s+40|0;O=I;P=O+36|0;do{f[O>>2]=0;O=O+4|0}while((O|0)<(P|0));f[M>>2]=a;a=s+48|0;J=s+44|0;f[J>>2]=a;f[a>>2]=0;f[s+52>>2]=0;f[i>>2]=d;K=i+4|0;f[K>>2]=q;hL(s,2,i,11);q=f[H>>2]|0;f[t>>2]=1124007936;L=t+4|0;Q=t+8|0;R=t+40|0;O=L;P=O+36|0;do{f[O>>2]=0;O=O+4|0}while((O|0)<(P|0));f[R>>2]=Q;Q=t+48|0;S=t+44|0;f[S>>2]=Q;f[Q>>2]=0;f[t+52>>2]=0;f[i>>2]=d;f[K>>2]=q;hL(t,2,i,2);q=v+4|0;T=v+8|0;U=v+40|0;O=q;P=O+36|0;do{f[O>>2]=0;O=O+4|0}while((O|0)<(P|0));f[U>>2]=T;T=v+48|0;V=v+44|0;f[V>>2]=T;f[T>>2]=0;f[v+52>>2]=0;f[v>>2]=1124007942;W=w+4|0;X=w+8|0;Z=w+40|0;O=W;P=O+36|0;do{f[O>>2]=0;O=O+4|0}while((O|0)<(P|0));f[Z>>2]=X;X=w+48|0;O=w+44|0;f[O>>2]=X;f[X>>2]=0;f[w+52>>2]=0;f[w>>2]=1124007942;VS(y,3,3,6);LZ(x,y);Wi(y);y=i+8|0;f[y>>2]=0;f[y+4>>2]=0;f[i>>2]=-2113863674;f[i+4>>2]=v;OJ(m,i,6,1.0,0.0);y=n+16|0;P=(f[y>>2]|0)==0;_=n+4|0;$=f[_>>2]|0;if(!P){if(($|0)<3)aa=Y(f[n+12>>2]|0,f[n+8>>2]|0)|0;else{ba=f[n+40>>2]|0;ca=0;da=1;while(1){ea=Y(f[ba+(ca<<2)>>2]|0,da)|0;ca=ca+1|0;if((ca|0)==($|0)){aa=ea;break}else da=ea}}if(!(($|0)==0|(aa|0)==0)){MZ(i,n);aa=i+36|0;da=f[aa>>2]|0;if(da|0){ca=da+12|0;f[ca>>2]=(f[ca>>2]|0)+1}ca=n+36|0;da=f[ca>>2]|0;if(da|0?(ba=da+12|0,da=f[ba>>2]|0,f[ba>>2]=da+-1,(da|0)==1):0)kL(n);f[ca>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[_>>2]|0)>0){da=f[n+40>>2]|0;ba=0;do{f[da+(ba<<2)>>2]=0;ba=ba+1|0;fa=f[_>>2]|0}while((ba|0)<(fa|0));f[n>>2]=f[i>>2];if((fa|0)<3)ga=54;else ga=56}else{f[n>>2]=f[i>>2];ga=54}if((ga|0)==54){fa=f[i+4>>2]|0;if((fa|0)<3){f[_>>2]=fa;f[n+8>>2]=f[i+8>>2];f[n+12>>2]=f[i+12>>2];fa=f[i+44>>2]|0;_=f[n+44>>2]|0;f[_>>2]=f[fa>>2];f[_+4>>2]=f[fa+4>>2]}else ga=56}if((ga|0)==56)jL(n,i);fa=i+16|0;f[y>>2]=f[fa>>2];f[n+20>>2]=f[i+20>>2];f[n+24>>2]=f[i+24>>2];f[n+28>>2]=f[i+28>>2];f[n+32>>2]=f[i+32>>2];_=f[aa>>2]|0;f[ca>>2]=_;if(_|0?(ca=_+12|0,_=f[ca>>2]|0,f[ca>>2]=_+-1,(_|0)==1):0)kL(i);f[aa>>2]=0;aa=i+4|0;f[fa>>2]=0;f[fa+4>>2]=0;f[fa+8>>2]=0;f[fa+12>>2]=0;if((f[aa>>2]|0)>0){fa=f[i+40>>2]|0;_=0;do{f[fa+(_<<2)>>2]=0;_=_+1|0}while((_|0)<(f[aa>>2]|0))}aa=f[i+44>>2]|0;if((aa|0)!=(i+48|0))UC(aa)}else ga=66}else ga=66;if((ga|0)==66){if(!(((($|0)<3?(f[n+8>>2]|0)==5:0)?(f[n+12>>2]|0)==1:0)?!((f[n>>2]&4095|0)!=6|P):0))ga=70;if((ga|0)==70){f[i>>2]=5;f[K>>2]=1;hL(n,2,i,6)};f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;UP(n,i)|0}K=o+16|0;if(f[K>>2]|0){P=f[o+4>>2]|0;if((P|0)<3)ha=Y(f[o+12>>2]|0,f[o+8>>2]|0)|0;else{$=f[o+40>>2]|0;aa=0;_=1;while(1){fa=Y(f[$+(aa<<2)>>2]|0,_)|0;aa=aa+1|0;if((aa|0)==(P|0)){ha=fa;break}else _=fa}}if(!((P|0)==0|(ha|0)==0)){ha=i+8|0;f[ha>>2]=0;f[ha+4>>2]=0;f[i>>2]=-2113863674;f[i+4>>2]=w;OJ(o,i,6,1.0,0.0)}else ga=79}else ga=79;if((ga|0)==79){ga=i+8|0;f[ga>>2]=0;f[ga+4>>2]=0;f[i>>2]=-2113863674;f[i+4>>2]=w;SP(v,i)}ga=w+16|0;ia=+p[(f[ga>>2]|0)+(f[f[O>>2]>>2]|0)+16>>3];ha=f[e>>2]|0;if((ha|0)>0){P=i+4|0;_=j+4|0;aa=i+4|0;$=j+4|0;fa=i+4|0;ca=j+4|0;ba=i+8|0;da=i+12|0;ea=i+4|0;ja=j+8|0;ka=j+12|0;la=j+4|0;ma=C+8|0;na=C+12|0;oa=C+4|0;pa=D+8|0;qa=D+12|0;ra=D+4|0;sa=E+4|0;ta=F+8|0;ua=F+4|0;va=G+8|0;wa=G+4|0;xa=i+8|0;ya=i+12|0;za=i+4|0;Aa=j+8|0;Ba=j+4|0;Ca=C+8|0;Da=C+12|0;Ea=C+4|0;Fa=D+8|0;Ga=D+12|0;Ha=D+4|0;Ia=B+36|0;Ja=B+16|0;Ka=B+4|0;La=B+40|0;Ma=B+44|0;Na=B+48|0;Oa=A+36|0;Pa=A+16|0;Qa=A+4|0;Ra=A+40|0;Sa=A+44|0;Ta=A+48|0;Ua=z+36|0;Va=z+16|0;Wa=z+4|0;Xa=z+40|0;Ya=z+44|0;Za=z+48|0;_a=0;$a=ha;do{ha=$a-_a|0;ab=(ha|0)<(d|0)?ha:d;p[(f[ga>>2]|0)+(f[f[O>>2]>>2]|0)+16>>3]=ia-+(_a|0);f[i>>2]=0;f[P>>2]=ab;f[j>>2]=-2147483648;f[_>>2]=2147483647;lL(z,s,i,j);f[i>>2]=0;f[aa>>2]=ab;f[j>>2]=-2147483648;f[$>>2]=2147483647;lL(A,t,i,j);f[i>>2]=_a;f[fa>>2]=ab+_a;f[j>>2]=-2147483648;f[ca>>2]=2147483647;lL(B,r,i,j);f[ba>>2]=0;f[da>>2]=0;f[i>>2]=-2130640890;f[ea>>2]=v;f[ja>>2]=0;f[ka>>2]=0;f[j>>2]=16842752;f[la>>2]=n;f[ma>>2]=0;f[na>>2]=0;f[C>>2]=-2130640890;f[oa>>2]=x;f[pa>>2]=0;f[qa>>2]=0;f[D>>2]=-2130640890;f[ra>>2]=w;f[E>>2]=f[H>>2];f[sa>>2]=ab;ab=f[z>>2]&4095;ha=ta;f[ha>>2]=0;f[ha+4>>2]=0;f[F>>2]=33619968;f[ua>>2]=z;ha=va;f[ha>>2]=0;f[ha+4>>2]=0;f[G>>2]=33619968;f[wa>>2]=A;KZ(i,j,C,D,E,ab,F,G);f[xa>>2]=0;f[ya>>2]=0;f[i>>2]=16842752;f[za>>2]=l;ab=Aa;f[ab>>2]=0;f[ab+4>>2]=0;f[j>>2]=33619968;f[Ba>>2]=B;f[Ca>>2]=0;f[Da>>2]=0;f[C>>2]=16842752;f[Ea>>2]=z;f[Fa>>2]=0;f[Ga>>2]=0;f[D>>2]=16842752;f[Ha>>2]=A;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=0;f[F+12>>2]=0;f[F+16>>2]=0;f[F+20>>2]=0;f[F+24>>2]=0;f[F+28>>2]=0;una(i,j,C,D,1,0,F);ab=f[Ia>>2]|0;if(ab|0?(ha=ab+12|0,ab=f[ha>>2]|0,f[ha>>2]=ab+-1,(ab|0)==1):0)kL(B);f[Ia>>2]=0;f[Ja>>2]=0;f[Ja+4>>2]=0;f[Ja+8>>2]=0;f[Ja+12>>2]=0;if((f[Ka>>2]|0)>0){ab=f[La>>2]|0;ha=0;do{f[ab+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[Ka>>2]|0))}ha=f[Ma>>2]|0;if((ha|0)!=(Na|0))UC(ha);ha=f[Oa>>2]|0;if(ha|0?(ab=ha+12|0,ha=f[ab>>2]|0,f[ab>>2]=ha+-1,(ha|0)==1):0)kL(A);f[Oa>>2]=0;f[Pa>>2]=0;f[Pa+4>>2]=0;f[Pa+8>>2]=0;f[Pa+12>>2]=0;if((f[Qa>>2]|0)>0){ha=f[Ra>>2]|0;ab=0;do{f[ha+(ab<<2)>>2]=0;ab=ab+1|0}while((ab|0)<(f[Qa>>2]|0))}ab=f[Sa>>2]|0;if((ab|0)!=(Ta|0))UC(ab);ab=f[Ua>>2]|0;if(ab|0?(ha=ab+12|0,ab=f[ha>>2]|0,f[ha>>2]=ab+-1,(ab|0)==1):0)kL(z);f[Ua>>2]=0;f[Va>>2]=0;f[Va+4>>2]=0;f[Va+8>>2]=0;f[Va+12>>2]=0;if((f[Wa>>2]|0)>0){ab=f[Xa>>2]|0;ha=0;do{f[ab+(ha<<2)>>2]=0;ha=ha+1|0}while((ha|0)<(f[Wa>>2]|0))}ha=f[Ya>>2]|0;if((ha|0)!=(Za|0))UC(ha);_a=_a+d|0;$a=f[e>>2]|0}while(($a|0)>(_a|0))}_a=x+36|0;$a=f[_a>>2]|0;if($a|0?(e=$a+12|0,$a=f[e>>2]|0,f[e>>2]=$a+-1,($a|0)==1):0)kL(x);f[_a>>2]=0;_a=x+16|0;$a=x+4|0;f[_a>>2]=0;f[_a+4>>2]=0;f[_a+8>>2]=0;f[_a+12>>2]=0;if((f[$a>>2]|0)>0){_a=f[x+40>>2]|0;e=0;do{f[_a+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[$a>>2]|0))}$a=f[x+44>>2]|0;if(($a|0)!=(x+48|0))UC($a);$a=w+36|0;x=f[$a>>2]|0;if(x|0?(e=x+12|0,x=f[e>>2]|0,f[e>>2]=x+-1,(x|0)==1):0)kL(w);f[$a>>2]=0;f[ga>>2]=0;f[ga+4>>2]=0;f[ga+8>>2]=0;f[ga+12>>2]=0;if((f[W>>2]|0)>0){ga=f[Z>>2]|0;Z=0;do{f[ga+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[W>>2]|0))}W=f[O>>2]|0;if((W|0)!=(X|0))UC(W);W=v+36|0;X=f[W>>2]|0;if(X|0?(O=X+12|0,X=f[O>>2]|0,f[O>>2]=X+-1,(X|0)==1):0)kL(v);f[W>>2]=0;W=v+16|0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[q>>2]|0)>0){W=f[U>>2]|0;U=0;do{f[W+(U<<2)>>2]=0;U=U+1|0}while((U|0)<(f[q>>2]|0))}q=f[V>>2]|0;if((q|0)!=(T|0))UC(q);q=t+36|0;T=f[q>>2]|0;do if(T|0){V=T+12|0;U=f[V>>2]|0;f[V>>2]=U+-1;if((U|0)!=1)break;kL(t)}while(0);f[q>>2]=0;q=t+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[L>>2]|0)>0){q=f[R>>2]|0;R=0;do{f[q+(R<<2)>>2]=0;R=R+1|0}while((R|0)<(f[L>>2]|0))}L=f[S>>2]|0;if((L|0)!=(Q|0))UC(L);L=s+36|0;Q=f[L>>2]|0;do if(Q|0){S=Q+12|0;R=f[S>>2]|0;f[S>>2]=R+-1;if((R|0)!=1)break;kL(s)}while(0);f[L>>2]=0;L=s+16|0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[I>>2]|0)>0){L=f[M>>2]|0;M=0;do{f[L+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[I>>2]|0))}I=f[J>>2]|0;if((I|0)!=(a|0))UC(I);I=r+36|0;a=f[I>>2]|0;do if(a|0){J=a+12|0;M=f[J>>2]|0;f[J>>2]=M+-1;if((M|0)!=1)break;kL(r)}while(0);f[I>>2]=0;I=r+4|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[I>>2]|0)>0){N=f[r+40>>2]|0;a=0;do{f[N+(a<<2)>>2]=0;a=a+1|0}while((a|0)<(f[I>>2]|0))}I=f[r+44>>2]|0;if((I|0)!=(r+48|0))UC(I);I=o+36|0;r=f[I>>2]|0;do if(r|0){a=r+12|0;N=f[a>>2]|0;f[a>>2]=N+-1;if((N|0)!=1)break;kL(o)}while(0);f[I>>2]=0;I=o+4|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[I>>2]|0)>0){K=f[o+40>>2]|0;r=0;do{f[K+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[I>>2]|0))}I=f[o+44>>2]|0;if((I|0)!=(o+48|0))UC(I);I=n+36|0;o=f[I>>2]|0;do if(o|0){r=o+12|0;K=f[r>>2]|0;f[r>>2]=K+-1;if((K|0)!=1)break;kL(n)}while(0);f[I>>2]=0;I=n+4|0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[I>>2]|0)>0){y=f[n+40>>2]|0;o=0;do{f[y+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[I>>2]|0))}I=f[n+44>>2]|0;if((I|0)!=(n+48|0))UC(I);I=m+36|0;n=f[I>>2]|0;do if(n|0){o=n+12|0;y=f[o>>2]|0;f[o>>2]=y+-1;if((y|0)!=1)break;kL(m)}while(0);f[I>>2]=0;I=m+16|0;n=m+4|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;if((f[n>>2]|0)>0){I=f[m+40>>2]|0;y=0;do{f[I+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))UC(n);n=l+36|0;m=f[n>>2]|0;do if(m|0){y=m+12|0;I=f[y>>2]|0;f[y>>2]=I+-1;if((I|0)!=1)break;kL(l)}while(0);f[n>>2]=0;n=l+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[n>>2]|0)>0){c=f[g>>2]|0;g=0;do{f[c+(g<<2)>>2]=0;g=g+1|0}while((g|0)<(f[n>>2]|0))}n=f[l+44>>2]|0;if((n|0)!=(l+48|0))UC(n);if(!(f[k+4>>2]|0)){u=h;return}u=h;return}function QZ(){var a=0,b=0,c=0,d=0,e=0;a=u;u=u+32|0;b=a+8|0;c=a;d=a+16|0;e=491096;f[e>>2]=1149814285;f[e+4>>2]=1071277473;e=491104;f[e>>2]=963447064;f[e+4>>2]=1071047319;e=491112;f[e>>2]=-768008872;f[e+4>>2]=1070012441;e=491120;f[e>>2]=-1494786058;f[e+4>>2]=1070282957;e=491128;f[e>>2]=963447064;f[e+4>>2]=1072095895;e=491136;f[e>>2]=-423037099;f[e+4>>2]=1068661162;e=491144;f[e>>2]=-959598773;f[e+4>>2]=1066650698;e=491152;f[e>>2]=-1259765448;f[e+4>>2]=1069450094;e=491160;f[e>>2]=1947784849;f[e+4>>2]=1072588866;e=491168;f[e>>2]=1090715535;f[e+4>>2]=1074392192;e=491176;f[e>>2]=-1724858866;f[e+4>>2]=-1074227158;e=491184;f[e>>2]=1480217529;f[e+4>>2]=-1075845121;e=491192;f[e>>2]=682521843;f[e+4>>2]=-1074854875;e=491200;f[e>>2]=596210180;f[e+4>>2]=1073611791;e=491208;f[e>>2]=-102254581;f[e+4>>2]=1067796179;e=491216;f[e>>2]=137164076;f[e+4>>2]=1068269029;e=491224;f[e>>2]=-1107483087;f[e+4>>2]=-1077273068;e=491232;f[e>>2]=-261408890;f[e+4>>2]=1072753342;e=491240;f[e>>2]=-1282855192;f[e+4>>2]=1072589346;e=491248;f[e>>2]=0;f[e+4>>2]=1072693248;e=491256;f[e>>2]=1349925401;f[e+4>>2]=1072786313;Xlb(b,2048);Xlb(c,3);cmb(d,b,c);f[125873]=f[d>>2];Xlb(503496,-134);Xlb(503500,220);amb(503504,503500,503496);Xlb(503508,-140);Xlb(503512,122);amb(503516,503512,503508);gmb(b,809);gmb(c,2e4);tmb(491264,b,c);gmb(b,7827);gmb(c,25e5);tmb(491272,b,c);gmb(b,323);gmb(c,25);tmb(491280,b,c);gmb(b,12);gmb(c,5);tmb(491288,b,c);gmb(b,11);gmb(c,200);tmb(491296,b,c);Xlb(b,216);Xlb(c,24389);cmb(503520,b,c);Xlb(b,841);Xlb(c,108);cmb(503524,b,c);Xlb(b,16);Xlb(c,116);cmb(503528,b,c);Xlb(503532,255);u=a;return}function RZ(a,b,c,d,e,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=u;u=u+64|0;m=l+56|0;n=l+24|0;o=l+16|0;p=l;dQ(o,48264);q=k?2:0;switch(h|0){case 0:{f[p>>2]=i;f[p+4>>2]=j;f[p+8>>2]=q;f[m>>2]=0;f[m+4>>2]=g;f[n>>2]=48292;f[n+4>>2]=a;f[n+8>>2]=b;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;f[n+24>>2]=p;RQ(m,n,+(Y(g,e)|0)*.0000152587890625);break}case 2:{f[p>>2]=i;f[p+4>>2]=j;f[p+8>>2]=q;f[m>>2]=0;f[m+4>>2]=g;f[n>>2]=48312;f[n+4>>2]=a;f[n+8>>2]=b;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;f[n+24>>2]=p;RQ(m,n,+(Y(g,e)|0)*.0000152587890625);break}default:{f[p>>2]=i;f[p+4>>2]=j;f[p+8>>2]=q;f[m>>2]=0;f[m+4>>2]=g;f[n>>2]=48332;f[n+4>>2]=a;f[n+8>>2]=b;f[n+12>>2]=c;f[n+16>>2]=d;f[n+20>>2]=e;f[n+24>>2]=p;RQ(m,n,+(Y(g,e)|0)*.0000152587890625)}}if(!(f[o+4>>2]|0)){u=l;return}u=l;return}function SZ(a){a=a|0;O5b(a);return}function TZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,48344);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){UZ(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function UZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=f[a>>2]|0;g=f[a+8>>2]|0;if((f[a+4>>2]|0)==3){a=d*3|0;if((d|0)<=0)return;h=g^2;i=0;j=b;while(1){k=f[j+4>>2]|0;l=f[j+(h<<2)>>2]|0;f[c+(i<<2)>>2]=f[j+(g<<2)>>2];f[c+(i+1<<2)>>2]=k;f[c+(i+2<<2)>>2]=l;i=i+3|0;if((i|0)>=(a|0))break;else j=j+(e<<2)|0}return}if((e|0)==3){e=d*3|0;if((d|0)<=0)return;j=g^2;a=c;i=0;while(1){h=f[b+(i+1<<2)>>2]|0;l=f[b+(i+2<<2)>>2]|0;f[a+(g<<2)>>2]=f[b+(i<<2)>>2];f[a+4>>2]=h;f[a+(j<<2)>>2]=l;n[a+12>>2]=1.0;i=i+3|0;if((i|0)>=(e|0))break;else a=a+16|0}return}else{a=d<<2;if((d|0)<=0)return;d=g^2;e=0;do{i=e|1;j=f[b+(i<<2)>>2]|0;l=f[b+((e|2)<<2)>>2]|0;h=e|3;k=f[b+(h<<2)>>2]|0;f[c+(e+g<<2)>>2]=f[b+(e<<2)>>2];f[c+(i<<2)>>2]=j;f[c+(e+d<<2)>>2]=l;f[c+(h<<2)>>2]=k;e=e+4|0}while((e|0)<(a|0));return}}function VZ(a){a=a|0;O5b(a);return}function WZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,48364);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){XZ(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function XZ(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=f[a>>2]|0;h=f[a+8>>2]|0;if((f[a+4>>2]|0)==3){a=e*3|0;if((e|0)<=0)return;i=h^2;j=0;k=b;while(1){l=d[k+2>>1]|0;m=d[k+(i<<1)>>1]|0;d[c+(j<<1)>>1]=d[k+(h<<1)>>1]|0;d[c+(j+1<<1)>>1]=l;d[c+(j+2<<1)>>1]=m;j=j+3|0;if((j|0)>=(a|0))break;else k=k+(g<<1)|0}return}if((g|0)==3){g=e*3|0;if((e|0)<=0)return;k=h^2;a=c;j=0;while(1){i=d[b+(j+1<<1)>>1]|0;m=d[b+(j+2<<1)>>1]|0;d[a+(h<<1)>>1]=d[b+(j<<1)>>1]|0;d[a+2>>1]=i;d[a+(k<<1)>>1]=m;d[a+6>>1]=-1;j=j+3|0;if((j|0)>=(g|0))break;else a=a+8|0}return}else{a=e<<2;if((e|0)<=0)return;e=h^2;g=0;do{j=g|1;k=d[b+(j<<1)>>1]|0;m=d[b+((g|2)<<1)>>1]|0;i=g|3;l=d[b+(i<<1)>>1]|0;d[c+(g+h<<1)>>1]=d[b+(g<<1)>>1]|0;d[c+(j<<1)>>1]=k;d[c+(g+e<<1)>>1]=m;d[c+(i<<1)>>1]=l;g=g+4|0}while((g|0)<(a|0));return}}function YZ(a){a=a|0;O5b(a);return}function ZZ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,48384);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){_Z(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function _Z(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=f[a>>2]|0;h=f[a+8>>2]|0;if((f[a+4>>2]|0)==3){a=e*3|0;if((e|0)<=0)return;i=h^2;j=0;k=c;while(1){l=b[k+1>>0]|0;m=b[k+i>>0]|0;b[d+j>>0]=b[k+h>>0]|0;b[d+(j+1)>>0]=l;b[d+(j+2)>>0]=m;j=j+3|0;if((j|0)>=(a|0))break;else k=k+g|0}return}if((g|0)==3){g=e*3|0;if((e|0)<=0)return;k=h^2;a=d;j=0;while(1){i=b[c+(j+1)>>0]|0;m=b[c+(j+2)>>0]|0;b[a+h>>0]=b[c+j>>0]|0;b[a+1>>0]=i;b[a+k>>0]=m;b[a+3>>0]=-1;j=j+3|0;if((j|0)>=(g|0))break;else a=a+4|0}return}else{a=e<<2;if((e|0)<=0)return;e=h^2;g=0;do{j=g|1;k=b[c+j>>0]|0;m=b[c+(g|2)>>0]|0;i=g|3;l=b[c+i>>0]|0;b[d+(g+h)>>0]=b[c+g>>0]|0;b[d+j>>0]=k;b[d+(g+e)>>0]=m;b[d+i>>0]=l;g=g+4|0}while((g|0)<(a|0));return}}function $Z(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=u;u=u+64|0;l=k+56|0;m=k+24|0;n=k+16|0;o=k;dQ(n,48404);f[o>>2]=h;f[o+4>>2]=i?2:0;f[o+8>>2]=j;f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=48432;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;RQ(l,m,+(Y(g,e)|0)*.0000152587890625);if(!(f[n+4>>2]|0)){u=k;return}u=k;return}function a_(a){a=a|0;O5b(a);return}function b_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;dQ(d,48444);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;a=e;while(1){c_(f[j>>2]|0,b,l,f[k>>2]|0);a=a+1|0;if((a|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function c_(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var i=0,j=0,k=0,l=0,m=0;i=f[a+4>>2]|0;j=(f[a>>2]|0)==3;k=(g|0)>0;if((f[a+8>>2]|0)==6)if(j){if(!k)return;a=i^2;l=c;m=0;while(1){d[e+(m<<1)>>1]=(b[l+1>>0]&-4&255)<<3|(h[l+i>>0]|0)>>>3|(b[l+a>>0]&-8&255)<<8;m=m+1|0;if((m|0)==(g|0))break;else l=l+3|0}return}else{if(!k)return;l=i^2;m=c;a=0;while(1){d[e+(a<<1)>>1]=(b[m+1>>0]&-4&255)<<3|(h[m+i>>0]|0)>>>3|(b[m+l>>0]&-8&255)<<8;a=a+1|0;if((a|0)==(g|0))break;else m=m+4|0}return}else if(j){if(!k)return;j=i^2;m=c;a=0;while(1){d[e+(a<<1)>>1]=(b[m+1>>0]&-8&255)<<2|(h[m+i>>0]|0)>>>3|(b[m+j>>0]&-8&255)<<7;a=a+1|0;if((a|0)==(g|0))break;else m=m+3|0}return}else{if(!k)return;k=i^2;m=c;c=0;while(1){d[e+(c<<1)>>1]=(b[m+1>>0]&-8&255)<<2|(h[m+i>>0]|0)>>>3|(b[m+k>>0]&-8&255)<<7|(b[m+3>>0]|0?32768:0);c=c+1|0;if((c|0)==(g|0))break;else m=m+4|0}return}}function d_(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=u;u=u+64|0;l=k+56|0;m=k+24|0;n=k+16|0;o=k;dQ(n,48464);f[o>>2]=h;f[o+4>>2]=i?2:0;f[o+8>>2]=j;f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=48492;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;RQ(l,m,+(Y(g,e)|0)*.0000152587890625);if(!(f[n+4>>2]|0)){u=k;return}u=k;return}function e_(a){a=a|0;O5b(a);return}function f_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;dQ(d,48504);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;a=e;while(1){g_(f[j>>2]|0,b,l,f[k>>2]|0);a=a+1|0;if((a|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function g_(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0;g=f[a>>2]|0;h=f[a+4>>2]|0;i=(e|0)>0;if((f[a+8>>2]|0)==6){if(!i)return;a=h^2;if((g|0)==4){k=0;l=d;while(1){m=j[c+(k<<1)>>1]|0;b[l+h>>0]=m<<3;b[l+1>>0]=m>>>3&252;b[l+a>>0]=m>>>8&248;b[l+3>>0]=-1;k=k+1|0;if((k|0)==(e|0))break;else l=l+4|0}return}else{l=0;k=d;while(1){m=j[c+(l<<1)>>1]|0;b[k+h>>0]=m<<3;b[k+1>>0]=m>>>3&252;b[k+a>>0]=m>>>8&248;l=l+1|0;if((l|0)==(e|0))break;else k=k+g|0}return}}else{if(!i)return;i=h^2;if((g|0)==4){k=0;l=d;while(1){a=j[c+(k<<1)>>1]|0;b[l+h>>0]=a<<3;b[l+1>>0]=a>>>2&248;b[l+i>>0]=a>>>7&248;b[l+3>>0]=a<<16>>31;k=k+1|0;if((k|0)==(e|0))break;else l=l+4|0}return}else{l=0;k=d;while(1){d=j[c+(l<<1)>>1]|0;b[k+h>>0]=d<<3;b[k+1>>0]=d>>>2&248;b[k+i>>0]=d>>>7&248;l=l+1|0;if((l|0)==(e|0))break;else k=k+g|0}return}}}function h_(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=u;u=u+3136|0;l=k+3120|0;m=k+3088|0;n=k+3080|0;o=k;dQ(n,48524);p=j?2:0;switch(h|0){case 0:{f[o>>2]=i;h=f[48544+((p^2)<<2)>>2]|0;q=f[48544+(p<<2)>>2]|0;p=0;r=0;s=8192;t=0;while(1){f[o+4+(t<<2)>>2]=p;f[o+4+(t+256<<2)>>2]=r;f[o+4+(t+512<<2)>>2]=s;t=t+1|0;if((t|0)==256)break;else{p=p+h|0;r=r+9617|0;s=s+q|0}}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=48564;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;RQ(l,m,+(Y(g,e)|0)*.0000152587890625);break}case 2:{f[o>>2]=i;q=o+4|0;f[q>>2]=f[12136];f[q+4>>2]=f[12137];f[q+8>>2]=f[12138];if(!j){f[q>>2]=1868;f[o+12>>2]=4899}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=48584;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;RQ(l,m,+(Y(g,e)|0)*.0000152587890625);break}default:{f[o>>2]=i;i=o+4|0;f[i>>2]=f[12149];f[i+4>>2]=f[12150];f[i+8>>2]=f[12151];if(!j){f[i>>2]=1038710997;f[o+12>>2]=1050220167}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=48616;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=o;RQ(l,m,+(Y(g,e)|0)*.0000152587890625)}}if(!(f[n+4>>2]|0)){u=k;return}u=k;return}function i_(a){a=a|0;O5b(a);return}function j_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;c=u;u=u+16|0;d=c;dQ(d,48628);e=f[b>>2]|0;g=f[b+4>>2]|0;a:do if((e|0)<(g|0)){b=f[a+16>>2]|0;h=f[a+8>>2]|0;i=a+24|0;j=f[a+20>>2]|0;if((j|0)<=0){k=e;while(1){k=k+1|0;if((k|0)>=(g|0))break a}}k=(f[a+4>>2]|0)+(Y(h,e)|0)|0;l=(f[a+12>>2]|0)+(Y(b,e)|0)|0;m=e;o=k;while(1){k=f[i>>2]|0;p=f[k>>2]|0;q=+n[k+4>>2];r=+n[k+8>>2];s=+n[k+12>>2];k=o;t=0;while(1){n[l+(t<<2)>>2]=q*+n[k>>2]+r*+n[k+4>>2]+s*+n[k+8>>2];t=t+1|0;if((t|0)==(j|0))break;else k=k+(p<<2)|0}m=m+1|0;if((m|0)>=(g|0))break;else{l=l+b|0;o=o+h|0}}}while(0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function k_(a){a=a|0;O5b(a);return}function l_(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+16|0;e=c;dQ(e,48648);g=f[b>>2]|0;h=f[b+4>>2]|0;if((g|0)<(h|0)){b=f[a+16>>2]|0;i=(f[a+12>>2]|0)+(Y(b,g)|0)|0;k=f[a+8>>2]|0;l=(f[a+4>>2]|0)+(Y(k,g)|0)|0;m=a+24|0;n=f[a+20>>2]|0;a=(n|0)>0;o=i;i=l;l=g;while(1){g=f[m>>2]|0;p=f[g>>2]|0;q=f[g+4>>2]|0;r=f[g+8>>2]|0;s=f[g+12>>2]|0;if(a){g=i;t=0;while(1){v=Y(j[g>>1]|0,q)|0;w=Y(j[g+2>>1]|0,r)|0;x=(v+8192+w+(Y(j[g+4>>1]|0,s)|0)|0)>>>14&65535;d[o+(t<<1)>>1]=x;t=t+1|0;if((t|0)==(n|0))break;else g=g+(p<<1)|0}}l=l+1|0;if((l|0)>=(h|0))break;else{o=o+b|0;i=i+k|0}}}if(!(f[e+4>>2]|0)){u=c;return}u=c;return}function m_(a){a=a|0;O5b(a);return}function n_(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;d=u;u=u+16|0;e=d;dQ(e,48668);g=f[c>>2]|0;i=a+8|0;j=a+16|0;k=c+4|0;c=f[k>>2]|0;if((g|0)<(c|0)){l=f[j>>2]|0;m=(f[a+12>>2]|0)+(Y(l,g)|0)|0;n=f[i>>2]|0;o=a+24|0;p=a+20|0;q=m;m=(f[a+4>>2]|0)+(Y(n,g)|0)|0;a=g;g=c;c=l;l=n;while(1){n=f[o>>2]|0;r=f[p>>2]|0;s=f[n>>2]|0;if((r|0)>0){t=m;v=0;while(1){b[q+v>>0]=((f[n+4+((h[t+1>>0]|0|256)<<2)>>2]|0)+(f[n+4+((h[t>>0]|0)<<2)>>2]|0)+(f[n+4+((h[t+2>>0]|0|512)<<2)>>2]|0)|0)>>>14;v=v+1|0;if((v|0)==(r|0))break;else t=t+s|0}w=f[i>>2]|0;x=f[j>>2]|0;y=f[k>>2]|0}else{w=l;x=c;y=g}a=a+1|0;if((a|0)>=(y|0))break;else{q=q+x|0;m=m+w|0;g=y;c=x;l=w}}}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function o_(a,b,c,d,e,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0;j=u;u=u+64|0;k=j+48|0;l=j+16|0;m=j+8|0;n=j;dQ(m,48688);switch(h|0){case 0:{f[n>>2]=i;f[k>>2]=0;f[k+4>>2]=g;f[l>>2]=48716;f[l+4>>2]=a;f[l+8>>2]=b;f[l+12>>2]=c;f[l+16>>2]=d;f[l+20>>2]=e;f[l+24>>2]=n;RQ(k,l,+(Y(g,e)|0)*.0000152587890625);break}case 2:{f[n>>2]=i;f[k>>2]=0;f[k+4>>2]=g;f[l>>2]=48736;f[l+4>>2]=a;f[l+8>>2]=b;f[l+12>>2]=c;f[l+16>>2]=d;f[l+20>>2]=e;f[l+24>>2]=n;RQ(k,l,+(Y(g,e)|0)*.0000152587890625);break}default:{f[n>>2]=i;f[k>>2]=0;f[k+4>>2]=g;f[l>>2]=48756;f[l+4>>2]=a;f[l+8>>2]=b;f[l+12>>2]=c;f[l+16>>2]=d;f[l+20>>2]=e;f[l+24>>2]=n;RQ(k,l,+(Y(g,e)|0)*.0000152587890625)}}if(!(f[m+4>>2]|0)){u=j;return}u=j;return}function p_(a){a=a|0;O5b(a);return}function q_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0;c=u;u=u+16|0;d=c;dQ(d,48768);e=f[b>>2]|0;g=f[b+4>>2]|0;a:do if((e|0)<(g|0)){b=f[a+8>>2]|0;h=f[a+16>>2]|0;i=a+24|0;j=f[a+20>>2]|0;if((j|0)<=0){k=e;while(1){k=k+1|0;if((k|0)>=(g|0))break a}}k=(f[a+12>>2]|0)+(Y(h,e)|0)|0;l=k;k=(f[a+4>>2]|0)+(Y(b,e)|0)|0;m=e;while(1){if((f[f[i>>2]>>2]|0)==3){o=l;p=0;while(1){q=f[k+(p<<2)>>2]|0;f[o+8>>2]=q;f[o+4>>2]=q;f[o>>2]=q;p=p+1|0;if((p|0)==(j|0))break;else o=o+12|0}}else{o=0;p=l;while(1){q=f[k+(o<<2)>>2]|0;f[p+8>>2]=q;f[p+4>>2]=q;f[p>>2]=q;n[p+12>>2]=1.0;o=o+1|0;if((o|0)==(j|0))break;else p=p+16|0}}m=m+1|0;if((m|0)>=(g|0))break;else{l=l+h|0;k=k+b|0}}}while(0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function r_(a){a=a|0;O5b(a);return}function s_(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=u;u=u+16|0;e=c;dQ(e,48788);g=f[b>>2]|0;h=f[b+4>>2]|0;a:do if((g|0)<(h|0)){b=f[a+8>>2]|0;i=f[a+16>>2]|0;j=a+24|0;k=f[a+20>>2]|0;if((k|0)<=0){l=g;while(1){l=l+1|0;if((l|0)>=(h|0))break a}}l=(f[a+12>>2]|0)+(Y(i,g)|0)|0;m=l;l=(f[a+4>>2]|0)+(Y(b,g)|0)|0;n=g;while(1){if((f[f[j>>2]>>2]|0)==3){o=m;p=0;while(1){q=d[l+(p<<1)>>1]|0;d[o+4>>1]=q;d[o+2>>1]=q;d[o>>1]=q;p=p+1|0;if((p|0)==(k|0))break;else o=o+6|0}}else{o=0;p=m;while(1){q=d[l+(o<<1)>>1]|0;d[p+4>>1]=q;d[p+2>>1]=q;d[p>>1]=q;d[p+6>>1]=-1;o=o+1|0;if((o|0)==(k|0))break;else p=p+8|0}}n=n+1|0;if((n|0)>=(h|0))break;else{m=m+i|0;l=l+b|0}}}while(0);if(!(f[e+4>>2]|0)){u=c;return}u=c;return}function t_(a){a=a|0;O5b(a);return}function u_(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;dQ(e,48808);g=f[c>>2]|0;h=a+8|0;i=a+16|0;j=c+4|0;if((g|0)<(f[j>>2]|0)){c=(f[a+12>>2]|0)+(Y(f[i>>2]|0,g)|0)|0;k=a+24|0;l=a+20|0;m=c;c=(f[a+4>>2]|0)+(Y(f[h>>2]|0,g)|0)|0;a=g;while(1){g=f[l>>2]|0;n=(g|0)>0;if((f[f[k>>2]>>2]|0)==3){if(n){o=m;p=0;while(1){q=b[c+p>>0]|0;b[o+2>>0]=q;b[o+1>>0]=q;b[o>>0]=q;p=p+1|0;if((p|0)==(g|0))break;else o=o+3|0}}}else if(n){o=0;p=m;while(1){q=b[c+o>>0]|0;b[p+2>>0]=q;b[p+1>>0]=q;b[p>>0]=q;b[p+3>>0]=-1;o=o+1|0;if((o|0)==(g|0))break;else p=p+4|0}}a=a+1|0;if((a|0)>=(f[j>>2]|0))break;else{m=m+(f[i>>2]|0)|0;c=c+(f[h>>2]|0)|0}}}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function v_(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+48|0;k=i+16|0;l=i+8|0;m=i;dQ(l,48828);f[m>>2]=h;f[j>>2]=0;f[j+4>>2]=g;f[k>>2]=48856;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+16>>2]=d;f[k+20>>2]=e;f[k+24>>2]=m;RQ(j,k,+(Y(g,e)|0)*.0000152587890625);if(!(f[l+4>>2]|0)){u=i;return}u=i;return}function w_(a){a=a|0;O5b(a);return}function x_(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+16|0;e=d;dQ(e,48868);g=f[c>>2]|0;h=a+8|0;i=a+16|0;k=c+4|0;if((g|0)<(f[k>>2]|0)){c=(f[a+12>>2]|0)+(Y(f[i>>2]|0,g)|0)|0;l=a+24|0;m=a+20|0;n=c;c=(f[a+4>>2]|0)+(Y(f[h>>2]|0,g)|0)|0;a=g;while(1){g=f[m>>2]|0;o=(g|0)>0;if((f[f[l>>2]>>2]|0)==6){if(o){p=0;do{q=j[c+(p<<1)>>1]|0;b[n+p>>0]=(((q>>>3&252)*9617|0)+8192+((q<<3&248)*1868|0)+((q>>>8&248)*4899|0)|0)>>>14;p=p+1|0}while((p|0)!=(g|0))}}else if(o){p=0;do{q=j[c+(p<<1)>>1]|0;b[n+p>>0]=(((q>>>2&248)*9617|0)+8192+((q<<3&248)*1868|0)+((q>>>7&248)*4899|0)|0)>>>14;p=p+1|0}while((p|0)!=(g|0))}a=a+1|0;if((a|0)>=(f[k>>2]|0))break;else{n=n+(f[i>>2]|0)|0;c=c+(f[h>>2]|0)|0}}}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function y_(a,b,c,d,e,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;i=u;u=u+64|0;j=i+48|0;k=i+16|0;l=i+8|0;m=i;dQ(l,48888);f[m>>2]=h;f[j>>2]=0;f[j+4>>2]=g;f[k>>2]=48916;f[k+4>>2]=a;f[k+8>>2]=b;f[k+12>>2]=c;f[k+16>>2]=d;f[k+20>>2]=e;f[k+24>>2]=m;RQ(j,k,+(Y(g,e)|0)*.0000152587890625);if(!(f[l+4>>2]|0)){u=i;return}u=i;return}function z_(a){a=a|0;O5b(a);return}function A_(a,b){a=a|0;b=b|0;var c=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=u;u=u+16|0;e=c;dQ(e,48928);g=f[b>>2]|0;i=f[b+4>>2]|0;if((g|0)<(i|0)){b=f[a+16>>2]|0;j=(f[a+12>>2]|0)+(Y(b,g)|0)|0;k=f[a+8>>2]|0;l=(f[a+4>>2]|0)+(Y(k,g)|0)|0;m=a+24|0;n=f[a+20>>2]|0;a=(n|0)>0;o=j;j=l;l=g;while(1){if((f[f[m>>2]>>2]|0)==6){if(a){g=0;do{p=h[j+g>>0]|0;d[o+(g<<1)>>1]=p<<3&2016|p>>>3|p<<8&63488;g=g+1|0}while((g|0)!=(n|0))}}else if(a){g=0;do{p=(h[j+g>>0]|0)>>>3;d[o+(g<<1)>>1]=p<<5|p|p<<10;g=g+1|0}while((g|0)!=(n|0))}l=l+1|0;if((l|0)>=(i|0))break;else{o=o+b|0;j=j+k|0}}}if(!(f[e+4>>2]|0)){u=c;return}u=c;return}function B_(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;m=u;u=u+80|0;n=m+72|0;o=m+40|0;p=m+32|0;q=m;dQ(p,48948);r=k?2:0;switch(i|0){case 0:{f[q>>2]=j;f[q+4>>2]=r;b[q+8>>0]=l&1;i=q+12|0;s=l?48968:48988;f[i>>2]=f[s>>2];f[i+4>>2]=f[s+4>>2];f[i+8>>2]=f[s+8>>2];f[i+12>>2]=f[s+12>>2];f[i+16>>2]=f[s+16>>2];if(!k){s=q+20|0;t=f[i>>2]|0;f[i>>2]=f[s>>2];f[s>>2]=t}f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=49016;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=q;RQ(n,o,+(Y(h,g)|0)*.0000152587890625);break}case 2:{f[q>>2]=j;f[q+4>>2]=r;b[q+8>>0]=l&1;t=q+12|0;s=l?49028:49048;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];f[t+8>>2]=f[s+8>>2];f[t+12>>2]=f[s+12>>2];f[t+16>>2]=f[s+16>>2];if(!k){s=q+20|0;i=f[t>>2]|0;f[t>>2]=f[s>>2];f[s>>2]=i}f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=49076;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=q;RQ(n,o,+(Y(h,g)|0)*.0000152587890625);break}default:{f[q>>2]=j;f[q+4>>2]=r;b[q+8>>0]=l&1;r=q+12|0;j=l?49088:49108;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];f[r+16>>2]=f[j+16>>2];if(!k){k=q+20|0;j=f[r>>2]|0;f[r>>2]=f[k>>2];f[k>>2]=j}f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=49136;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=q;RQ(n,o,+(Y(h,g)|0)*.0000152587890625)}}if(!(f[p+4>>2]|0)){u=m;return}u=m;return}function C_(a){a=a|0;O5b(a);return}function D_(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0,C=0.0,D=0.0,E=0.0;d=u;u=u+16|0;e=d;dQ(e,49148);g=f[c>>2]|0;h=f[c+4>>2]|0;a:do if((g|0)<(h|0)){c=f[a+16>>2]|0;i=f[a+8>>2]|0;j=a+24|0;k=f[a+20>>2]|0;l=k*3|0;if((k|0)<=0){k=g;while(1){k=k+1|0;if((k|0)>=(h|0))break a}}k=(f[a+4>>2]|0)+(Y(i,g)|0)|0;m=(f[a+12>>2]|0)+(Y(c,g)|0)|0;o=g;p=k;while(1){k=f[j>>2]|0;q=f[k>>2]|0;r=f[k+4>>2]|0;s=(b[k+8>>0]^1)&255;t=+n[k+12>>2];v=+n[k+16>>2];w=+n[k+20>>2];x=+n[k+24>>2];y=+n[k+28>>2];k=r^2;z=s+1|0;A=2-s|0;s=0;B=p;while(1){C=t*+n[B>>2]+v*+n[B+4>>2]+w*+n[B+8>>2];D=x*(+n[B+(k<<2)>>2]-C)+.5;E=y*(+n[B+(r<<2)>>2]-C)+.5;n[m+(s<<2)>>2]=C;n[m+(z+s<<2)>>2]=D;n[m+(A+s<<2)>>2]=E;s=s+3|0;if((s|0)>=(l|0))break;else B=B+(q<<2)|0}o=o+1|0;if((o|0)>=(h|0))break;else{m=m+c|0;p=p+i|0}}}while(0);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function E_(a){a=a|0;O5b(a);return}function F_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,49168);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){G_(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function G_(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=f[a>>2]|0;i=f[a+4>>2]|0;k=(b[a+8>>0]^1)&255;l=f[a+12>>2]|0;m=f[a+16>>2]|0;n=f[a+20>>2]|0;o=f[a+24>>2]|0;p=f[a+28>>2]|0;a=g*3|0;if((g|0)<=0)return;g=i^2;q=k+1|0;r=2-k|0;k=0;s=c;while(1){c=Y(j[s>>1]|0,l)|0;t=Y(j[s+2>>1]|0,m)|0;u=c+8192+t+(Y(j[s+4>>1]|0,n)|0)>>14;t=(Y((j[s+(g<<1)>>1]|0)-u|0,o)|0)+536879104>>14;c=(Y((j[s+(i<<1)>>1]|0)-u|0,p)|0)+536879104>>14;d[e+(k<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[e+(q+k<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[e+(r+k<<1)>>1]=c>>>0<65536?c:(c|0)>0?65535:0;k=k+3|0;if((k|0)>=(a|0))break;else s=s+(h<<1)|0}return}function H_(a){a=a|0;O5b(a);return}function I_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;dQ(d,49188);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=e;m=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;while(1){J_(f[j>>2]|0,m,l,f[k>>2]|0);b=b+1|0;if((b|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;m=m+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function J_(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=f[a>>2]|0;i=f[a+4>>2]|0;j=(b[a+8>>0]^1)&255;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;o=f[a+28>>2]|0;a=e*3|0;if((e|0)<=0)return;e=i^2;p=j+1|0;q=2-j|0;j=0;r=c;while(1){c=Y(h[r>>0]|0,k)|0;s=Y(h[r+1>>0]|0,l)|0;t=c+8192+s+(Y(h[r+2>>0]|0,m)|0)>>14;s=(Y((h[r+e>>0]|0)-t|0,n)|0)+2105344>>14;c=(Y((h[r+i>>0]|0)-t|0,o)|0)+2105344>>14;b[d+j>>0]=t>>>0<256?t:(t|0)>0?255:0;b[d+(p+j)>>0]=s>>>0<256?s:(s|0)>0?255:0;b[d+(q+j)>>0]=c>>>0<256?c:(c|0)>0?255:0;j=j+3|0;if((j|0)>=(a|0))break;else r=r+g|0}return}function K_(a,c,d,e,g,h,i,j,k,l){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0;m=u;u=u+80|0;n=m+72|0;o=m+40|0;p=m+32|0;q=m;dQ(p,49208);r=k?2:0;switch(i|0){case 0:{f[q>>2]=j;f[q+4>>2]=r;b[q+8>>0]=l&1;i=q+12|0;k=l?49228:49244;f[i>>2]=f[k>>2];f[i+4>>2]=f[k+4>>2];f[i+8>>2]=f[k+8>>2];f[i+12>>2]=f[k+12>>2];f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=49268;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=q;RQ(n,o,+(Y(h,g)|0)*.0000152587890625);break}case 2:{f[q>>2]=j;f[q+4>>2]=r;b[q+8>>0]=l&1;k=q+12|0;i=l?49280:49296;f[k>>2]=f[i>>2];f[k+4>>2]=f[i+4>>2];f[k+8>>2]=f[i+8>>2];f[k+12>>2]=f[i+12>>2];f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=49320;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=q;RQ(n,o,+(Y(h,g)|0)*.0000152587890625);break}default:{f[q>>2]=j;f[q+4>>2]=r;b[q+8>>0]=l&1;r=q+12|0;j=l?49332:49348;f[r>>2]=f[j>>2];f[r+4>>2]=f[j+4>>2];f[r+8>>2]=f[j+8>>2];f[r+12>>2]=f[j+12>>2];f[n>>2]=0;f[n+4>>2]=h;f[o>>2]=49372;f[o+4>>2]=a;f[o+8>>2]=c;f[o+12>>2]=d;f[o+16>>2]=e;f[o+20>>2]=g;f[o+24>>2]=q;RQ(n,o,+(Y(h,g)|0)*.0000152587890625)}}if(!(f[p+4>>2]|0)){u=m;return}u=m;return}function L_(a){a=a|0;O5b(a);return}function M_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;dQ(d,49384);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;a=e;while(1){N_(f[j>>2]|0,b,l,f[k>>2]|0);a=a+1|0;if((a|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function N_(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0.0,k=0.0,l=0.0,m=0.0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0;g=f[a>>2]|0;h=f[a+4>>2]|0;i=(b[a+8>>0]^1)&255;j=+n[a+12>>2];k=+n[a+16>>2];l=+n[a+20>>2];m=+n[a+24>>2];a=e*3|0;if((e|0)<=0)return;e=i+1|0;o=2-i|0;i=h^2;if((g|0)==4){p=0;q=d;while(1){r=+n[c+(p<<2)>>2];s=+n[c+(o+p<<2)>>2]+-.5;t=+n[c+(e+p<<2)>>2]+-.5;n[q+(h<<2)>>2]=r+m*s;n[q+4>>2]=k*t+(r+l*s);n[q+(i<<2)>>2]=r+j*t;n[q+12>>2]=1.0;p=p+3|0;if((p|0)>=(a|0))break;else q=q+16|0}return}else{q=0;p=d;while(1){t=+n[c+(q<<2)>>2];r=+n[c+(o+q<<2)>>2]+-.5;s=+n[c+(e+q<<2)>>2]+-.5;n[p+(h<<2)>>2]=t+m*r;n[p+4>>2]=k*s+(t+l*r);n[p+(i<<2)>>2]=t+j*s;q=q+3|0;if((q|0)>=(a|0))break;else p=p+(g<<2)|0}return}}function O_(a){a=a|0;O5b(a);return}function P_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;dQ(d,49404);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;a=e;while(1){Q_(f[j>>2]|0,b,l,f[k>>2]|0);a=a+1|0;if((a|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function Q_(a,c,e,g){a=a|0;c=c|0;e=e|0;g=g|0;var h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=f[a>>2]|0;i=f[a+4>>2]|0;k=(b[a+8>>0]^1)&255;l=f[a+12>>2]|0;m=f[a+16>>2]|0;n=f[a+20>>2]|0;o=f[a+24>>2]|0;a=g*3|0;if((g|0)<=0)return;g=k+1|0;p=2-k|0;k=i^2;if((h|0)==4){q=0;r=e;while(1){s=j[c+(q<<1)>>1]|0;t=(j[c+(p+q<<1)>>1]|0)+-32768|0;u=((Y(t,o)|0)+8192>>14)+s|0;v=(j[c+(g+q<<1)>>1]|0)+-32768|0;w=((Y(v,m)|0)+8192+(Y(t,n)|0)>>14)+s|0;t=((Y(v,l)|0)+8192>>14)+s|0;d[r+(i<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[r+2>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[r+(k<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;d[r+6>>1]=-1;q=q+3|0;if((q|0)>=(a|0))break;else r=r+8|0}return}else{r=0;q=e;while(1){e=j[c+(r<<1)>>1]|0;t=(j[c+(p+r<<1)>>1]|0)+-32768|0;w=((Y(t,o)|0)+8192>>14)+e|0;u=(j[c+(g+r<<1)>>1]|0)+-32768|0;s=((Y(u,m)|0)+8192+(Y(t,n)|0)>>14)+e|0;t=((Y(u,l)|0)+8192>>14)+e|0;d[q+(i<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[q+2>>1]=s>>>0<65536?s:(s|0)>0?65535:0;d[q+(k<<1)>>1]=t>>>0<65536?t:(t|0)>0?65535:0;r=r+3|0;if((r|0)>=(a|0))break;else q=q+(h<<1)|0}return}}function R_(a){a=a|0;O5b(a);return}function S_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;dQ(d,49424);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;a=e;while(1){T_(f[j>>2]|0,b,l,f[k>>2]|0);a=a+1|0;if((a|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function T_(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=f[a>>2]|0;i=f[a+4>>2]|0;j=(b[a+8>>0]^1)&255;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;a=e*3|0;if((e|0)<=0)return;e=j+1|0;o=2-j|0;j=i^2;if((g|0)==4){p=0;q=d;while(1){r=h[c+p>>0]|0;s=(h[c+(o+p)>>0]|0)+-128|0;t=((Y(s,n)|0)+8192>>14)+r|0;u=(h[c+(e+p)>>0]|0)+-128|0;v=((Y(u,l)|0)+8192+(Y(s,m)|0)>>14)+r|0;s=((Y(u,k)|0)+8192>>14)+r|0;b[q+i>>0]=t>>>0<256?t:(t|0)>0?255:0;b[q+1>>0]=v>>>0<256?v:(v|0)>0?255:0;b[q+j>>0]=s>>>0<256?s:(s|0)>0?255:0;b[q+3>>0]=-1;p=p+3|0;if((p|0)>=(a|0))break;else q=q+4|0}return}else{q=0;p=d;while(1){d=h[c+q>>0]|0;s=(h[c+(o+q)>>0]|0)+-128|0;v=((Y(s,n)|0)+8192>>14)+d|0;t=(h[c+(e+q)>>0]|0)+-128|0;r=((Y(t,l)|0)+8192+(Y(s,m)|0)>>14)+d|0;s=((Y(t,k)|0)+8192>>14)+d|0;b[p+i>>0]=v>>>0<256?v:(v|0)>0?255:0;b[p+1>>0]=r>>>0<256?r:(r|0)>0?255:0;b[p+j>>0]=s>>>0<256?s:(s|0)>0?255:0;q=q+3|0;if((q|0)>=(a|0))break;else p=p+g|0}return}}function U_(a,b,c,d,e,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0;k=u;u=u+96|0;l=k+80|0;m=k+48|0;o=k+40|0;q=k;dQ(o,49444);switch(h|0){case 0:{f[q>>2]=i;h=q+4|0;f[h>>2]=1689;f[q+8>>2]=1465;r=q+12|0;f[r>>2]=739;s=q+16|0;f[s>>2]=871;f[q+20>>2]=2929;t=q+24|0;f[t>>2]=296;v=q+28|0;f[v>>2]=79;f[q+32>>2]=488;w=q+36|0;f[w>>2]=3892;if(!j){f[h>>2]=739;f[r>>2]=1689;f[s>>2]=296;f[t>>2]=871;f[v>>2]=3892;f[w>>2]=79}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=49472;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=q;RQ(l,m,+(Y(g,e)|0)*.0000152587890625);break}case 2:{f[q>>2]=i;w=q+4|0;f[w>>2]=1689;f[q+8>>2]=1465;v=q+12|0;f[v>>2]=739;t=q+16|0;f[t>>2]=871;f[q+20>>2]=2929;s=q+24|0;f[s>>2]=296;r=q+28|0;f[r>>2]=79;f[q+32>>2]=488;h=q+36|0;f[h>>2]=3892;if(!j){f[w>>2]=739;f[v>>2]=1689;f[t>>2]=296;f[s>>2]=871;f[r>>2]=3892;f[h>>2]=79}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=49492;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=q;RQ(l,m,+(Y(g,e)|0)*.0000152587890625);break}default:{f[q>>2]=i;x=+p[61387];i=q+4|0;n[i>>2]=x;n[q+8>>2]=+p[61388];y=+p[61389];h=q+12|0;n[h>>2]=y;z=+p[61390];r=q+16|0;n[r>>2]=z;n[q+20>>2]=+p[61391];A=+p[61392];s=q+24|0;n[s>>2]=A;B=+p[61393];t=q+28|0;n[t>>2]=B;n[q+32>>2]=+p[61394];C=+p[61395];v=q+36|0;n[v>>2]=C;if(!j){n[i>>2]=y;n[h>>2]=x;n[r>>2]=A;n[s>>2]=z;n[t>>2]=C;n[v>>2]=B}f[l>>2]=0;f[l+4>>2]=g;f[m>>2]=49512;f[m+4>>2]=a;f[m+8>>2]=b;f[m+12>>2]=c;f[m+16>>2]=d;f[m+20>>2]=e;f[m+24>>2]=q;RQ(l,m,+(Y(g,e)|0)*.0000152587890625)}}if(!(f[o+4>>2]|0)){u=k;return}u=k;return}function V_(a){a=a|0;O5b(a);return}function W_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0.0;c=u;u=u+16|0;d=c;dQ(d,49524);e=f[b>>2]|0;g=f[b+4>>2]|0;a:do if((e|0)<(g|0)){b=f[a+8>>2]|0;h=f[a+16>>2]|0;i=a+24|0;j=f[a+20>>2]|0;k=j*3|0;if((j|0)<=0){j=e;while(1){j=j+1|0;if((j|0)>=(g|0))break a}}j=(f[a+12>>2]|0)+(Y(h,e)|0)|0;l=j;j=(f[a+4>>2]|0)+(Y(b,e)|0)|0;m=e;while(1){o=f[i>>2]|0;p=f[o>>2]|0;q=+n[o+4>>2];r=+n[o+8>>2];s=+n[o+12>>2];t=+n[o+16>>2];v=+n[o+20>>2];w=+n[o+24>>2];x=+n[o+28>>2];y=+n[o+32>>2];z=+n[o+36>>2];o=0;A=j;while(1){B=+n[A>>2];C=+n[A+4>>2];D=+n[A+8>>2];n[l+(o<<2)>>2]=q*B+r*C+s*D;n[l+(o+1<<2)>>2]=t*B+v*C+w*D;n[l+(o+2<<2)>>2]=x*B+y*C+z*D;o=o+3|0;if((o|0)>=(k|0))break;else A=A+(p<<2)|0}m=m+1|0;if((m|0)>=(g|0))break;else{l=l+h|0;j=j+b|0}}}while(0);if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function X_(a){a=a|0;O5b(a);return}function Y_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;dQ(d,49544);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;a=e;while(1){Z_(f[j>>2]|0,b,l,f[k>>2]|0);a=a+1|0;if((a|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function Z_(a,b,c,e){a=a|0;b=b|0;c=c|0;e=e|0;var g=0,h=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=f[a>>2]|0;h=f[a+4>>2]|0;i=f[a+8>>2]|0;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;o=f[a+28>>2]|0;p=f[a+32>>2]|0;q=f[a+36>>2]|0;a=e*3|0;if((e|0)>0){r=0;s=b}else return;while(1){b=j[s>>1]|0;e=Y(b,h)|0;t=j[s+2>>1]|0;u=Y(t,i)|0;v=j[s+4>>1]|0;w=e+2048+u+(Y(v,k)|0)>>12;u=(Y(b,l)|0)+2048+(Y(t,m)|0)+(Y(v,n)|0)>>12;e=(Y(b,o)|0)+2048+(Y(t,p)|0)+(Y(v,q)|0)>>12;d[c+(r<<1)>>1]=w>>>0<65536?w:(w|0)>0?65535:0;d[c+(r+1<<1)>>1]=u>>>0<65536?u:(u|0)>0?65535:0;d[c+(r+2<<1)>>1]=e>>>0<65536?e:(e|0)>0?65535:0;r=r+3|0;if((r|0)>=(a|0))break;else s=s+(g<<1)|0}return}function __(a){a=a|0;O5b(a);return}function $_(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;dQ(d,49564);e=f[b>>2]|0;g=a+8|0;h=a+16|0;i=b+4|0;if((e|0)<(f[i>>2]|0)){b=(f[a+12>>2]|0)+(Y(f[h>>2]|0,e)|0)|0;j=a+24|0;k=a+20|0;l=b;b=(f[a+4>>2]|0)+(Y(f[g>>2]|0,e)|0)|0;a=e;while(1){a$(f[j>>2]|0,b,l,f[k>>2]|0);a=a+1|0;if((a|0)>=(f[i>>2]|0))break;else{l=l+(f[h>>2]|0)|0;b=b+(f[g>>2]|0)|0}}}if(!(f[d+4>>2]|0)){u=c;return}u=c;return}function a$(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=f[a>>2]|0;i=f[a+4>>2]|0;j=f[a+8>>2]|0;k=f[a+12>>2]|0;l=f[a+16>>2]|0;m=f[a+20>>2]|0;n=f[a+24>>2]|0;o=f[a+28>>2]|0;p=f[a+32>>2]|0;q=f[a+36>>2]|0;a=e*3|0;if((e|0)>0){r=0;s=c}else return;while(1){c=h[s>>0]|0;e=Y(c,i)|0;t=h[s+1>>0]|0;u=Y(t,j)|0;v=h[s+2>>0]|0;w=e+2048+u+(Y(v,k)|0)>>12;u=(Y(c,l)|0)+2048+(Y(t,m)|0)+(Y(v,n)|0)>>12;e=(Y(c,o)|0)+2048+(Y(t,p)|0)+(Y(v,q)|0)>>12;b[d+r>>0]=w>>>0<256?w:(w|0)>0?255:0;b[d+(r+1)>>0]=u>>>0<256?u:(u|0)>0?255:0;b[d+(r+2)>>0]=e>>>0<256?e:(e|0)>0?255:0;r=r+3|0;if((r|0)>=(a|0))break;else s=s+g|0}return}
function Gxa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+64|0;g=e+44|0;h=e+24|0;i=e;j=f[c>>2]|0;f[i>>2]=j;k=i+4|0;l=c+4|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];f[k+12>>2]=f[l+12>>2];l=i+20|0;f[l>>2]=f[c+20>>2];c=i+4|0;m=d+4|0;n=i+20|0;o=d+20|0;p=a+8|0;q=a+12|0;r=a+12|0;s=g+12|0;t=g+11|0;v=j;a:while(1){b:do if((v|0)==(f[d>>2]|0))switch(v|0){case 0:{w=6;break a;break}case 1:{if((f[n>>2]|0)==(f[o>>2]|0)){w=6;break a}else break b;break}default:if((f[c>>2]|0)==(f[m>>2]|0)){w=6;break a}else break b}while(0);j=f[((v|0)==1?(f[l>>2]|0)+20|0:(f[c>>2]|0)+12|0)>>2]|0;if(!(b[p>>0]|0)){wxa(g,f[q>>2]|0,j);x=2;y=0;z=f[g>>2]|0}else{x=1;y=Hxa(f[r>>2]|0,j)|0;z=0}j=(b[p>>0]|0)==0;c:do if((x|0)==((j?2:1)|0)){switch(x&3){case 0:break;case 1:{if(y|0)break c;break}default:if(z|0)break c}A=f[((f[i>>2]|0)==1?(f[l>>2]|0)+20|0:(f[c>>2]|0)+12|0)>>2]|0;B=A+16|0;if(j){C=f[r>>2]|0;X5b(g,A);f[s>>2]=0;Jxa(h,C,g);C=(f[h>>2]|0)+12|0;if((b[t>>0]|0)<0)O5b(f[g>>2]|0);D=C}else D=Ixa(f[r>>2]|0,A)|0;C=f[D>>2]|0;if(!C){E=Kxa(a,A)|0;f[D>>2]=E;F=E}else F=C;jHa(F+16|0,B)}while(0);if((f[i>>2]|0)==1){f[l>>2]=f[f[l>>2]>>2];v=1;continue}else{uxa(k)|0;v=f[i>>2]|0;continue}}if((w|0)==6){u=e;return}}function Hxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=b[c+11>>0]|0;e=d<<24>>24<0;g=e?f[c>>2]|0:c;h=b[g>>0]|0;if(!(h<<24>>24))i=0;else{j=g;k=0;l=h;while(1){m=(k*5|0)+(l<<24>>24)|0;j=j+1|0;l=b[j>>0]|0;if(!(l<<24>>24)){i=m;break}else k=m}}k=f[a+4>>2]|0;if(!k){n=0;return n|0}l=k+-1|0;j=(l&k|0)==0;if(!j)if(i>>>0<k>>>0)o=i;else o=(i>>>0)%(k>>>0)|0;else o=l&i;m=f[(f[a>>2]|0)+(o<<2)>>2]|0;if(!m){n=0;return n|0}a=f[m>>2]|0;if(!a){n=0;return n|0}m=e?f[c+4>>2]|0:d&255;d=(m|0)==0;if(j){j=a;a:while(1){c=f[j+4>>2]|0;e=(c|0)==(i|0);if(!(e|(c&l|0)==(o|0))){n=0;p=36;break}do if(e?(c=j+8|0,q=b[c+11>>0]|0,r=q<<24>>24<0,s=q&255,((r?f[j+12>>2]|0:s)|0)==(m|0)):0){q=f[c>>2]|0;t=r?q:c;if(r){if(d){n=j;p=36;break a}if(!(ZVb(t,g,m)|0)){n=j;p=36;break a}else break}if(d){n=j;p=36;break a}if((q&255)<<24>>24==h<<24>>24){q=c;c=s;s=g;do{c=c+-1|0;q=q+1|0;if(!c){n=j;p=36;break a}s=s+1|0}while((b[q>>0]|0)==(b[s>>0]|0))}}while(0);j=f[j>>2]|0;if(!j){n=0;p=36;break}}if((p|0)==36)return n|0}else u=a;b:while(1){a=f[u+4>>2]|0;j=(a|0)==(i|0);if(!j){if(a>>>0<k>>>0)v=a;else v=(a>>>0)%(k>>>0)|0;if((v|0)!=(o|0)){n=0;p=36;break}if(j)p=28}else p=28;do if((p|0)==28?(p=0,j=u+8|0,a=b[j+11>>0]|0,l=a<<24>>24<0,e=a&255,((l?f[u+12>>2]|0:e)|0)==(m|0)):0){a=f[j>>2]|0;s=l?a:j;if(l){if(d){n=u;p=36;break b}if(!(ZVb(s,g,m)|0)){n=u;p=36;break b}else break}if(d){n=u;p=36;break b}if((a&255)<<24>>24==h<<24>>24){a=j;j=e;e=g;do{j=j+-1|0;a=a+1|0;if(!j){n=u;p=36;break b}e=e+1|0}while((b[a>>0]|0)==(b[e>>0]|0))}}while(0);u=f[u>>2]|0;if(!u){n=0;p=36;break}}if((p|0)==36)return n|0;return 0}function Ixa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;e=Hxa(a,b)|0;if(e|0){g=e;h=g+20|0;u=c;return h|0}e=f[a+16>>2]|0;if(!e)i=L5b(24)|0;else i=znb(e,25536,24)|0;X5b(i+8|0,b);f[i+20>>2]=0;Wxa(d,a,i);g=f[d>>2]|0;h=g+20|0;u=c;return h|0}function Jxa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+20|0;h=e;wxa(g,c,d);i=f[g>>2]|0;if(i|0){j=f[g+4>>2]|0;k=f[g+8>>2]|0;l=f[g+12>>2]|0;f[a>>2]=i;f[a+4>>2]=j;f[a+8>>2]=k;f[a+12>>2]=l;b[a+16>>0]=0;u=e;return}l=(f[c>>2]|0)+1|0;k=f[c+4>>2]|0;j=k*12|0;i=j>>>4;if(i>>>0>l>>>0){if(k>>>0>8&j>>>6>>>0>=l>>>0){j=((l*5|0)>>>2)+1|0;l=1;while(1)if(j<<l>>>0<i>>>0)l=l+1|0;else break;i=k>>>l;l=i>>>0>8?i:8;if((l|0)!=(k|0)){Nxa(c,l);m=11}}}else if(k>>>0<=134217728){Nxa(c,k<<1);m=11}if((m|0)==11){wxa(h,c,d);f[g>>2]=f[h>>2];f[g+4>>2]=f[h+4>>2];f[g+8>>2]=f[h+8>>2];f[g+12>>2]=f[h+12>>2];f[g+16>>2]=f[h+16>>2]}m=f[g+16>>2]|0;g=f[c+20>>2]|0;if(!g)n=L5b(20)|0;else n=znb(g,25536,20)|0;X5b(n,d);f[n+12>>2]=f[d+12>>2];Oxa(h,c,m,n);f[c>>2]=(f[c>>2]|0)+1;f[a>>2]=f[h>>2];f[a+4>>2]=f[h+4>>2];f[a+8>>2]=f[h+8>>2];f[a+12>>2]=f[h+12>>2];b[a+16>>0]=1;u=e;return}function Kxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a>>2]|0;if(!c){d=L5b(40)|0;X5b(d,b);bHa(d+16|0);e=d;return e|0}else{d=znb(c,25536,40)|0;c=f[a>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;Lxa(c,d);gHa(d+16|0,f[a>>2]|0);_5b(d,b)|0;e=d;return e|0}return 0}function Lxa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1480);return}function Mxa(a){a=a|0;if((b[a+11>>0]|0)>=0)return;O5b(f[a>>2]|0);return}function Nxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=u;u=u+16|0;e=d;g=a+16|0;h=f[g>>2]|0;i=a+4|0;j=f[i>>2]|0;f[i>>2]=c;k=a+20|0;l=f[k>>2]|0;m=c<<2;if(!l)n=L5b(m)|0;else n=znb(l,25536,m)|0;Nac(n|0,0,m|0)|0;f[g>>2]=n;n=a+12|0;g=f[n>>2]|0;f[n>>2]=f[i>>2];if(g>>>0<j>>>0){n=a+8|0;m=g;do{g=f[h+(m<<2)>>2]|0;do if(!g)o=m;else{if((g|0)==(f[h+((m^1)<<2)>>2]|0)){Vxa(a,h,m);o=m+1|0;break}l=g;do{c=l;l=f[l+16>>2]|0;p=(b[c+11>>0]|0)<0?f[c>>2]|0:c;q=b[p>>0]|0;if(!(q<<24>>24))r=0;else{s=p;p=0;t=q;while(1){q=(p*5|0)+(t<<24>>24)|0;s=s+1|0;t=b[s>>0]|0;if(!(t<<24>>24)){r=q;break}else p=q}}Oxa(e,a,(f[i>>2]|0)+-1&(f[n>>2]|0)+r,c)}while((l|0)!=0);o=m}while(0);m=o+1|0}while(m>>>0<j>>>0)}if(f[k>>2]|0){u=d;return}O5b(h);u=d;return}function Oxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;h=f[b+16>>2]|0;i=h+(c<<2)|0;j=f[i>>2]|0;k=j;do if(!j){f[d+16>>2]=k;f[i>>2]=d;l=d;m=0;n=b;o=c}else{if((j|0)==(f[h+((c^1)<<2)>>2]|0)){Qxa(a,b,c,d);u=e;return}p=j;q=0;do{q=q+1|0;p=f[p+16>>2]|0}while((p|0)!=0);if(q>>>0>7){Pxa(b,c);Qxa(g,b,c,d);l=f[g>>2]|0;m=f[g+12>>2]|0;n=f[g+4>>2]|0;o=f[g+8>>2]|0;break}f[d+16>>2]=k;f[i>>2]=d;f[a>>2]=d;f[a+4>>2]=b;f[a+8>>2]=c;u=e;return}while(0);c=b+12|0;b=f[c>>2]|0;f[c>>2]=o>>>0<b>>>0?o:b;f[a>>2]=l;f[a+4>>2]=n;f[a+8>>2]=o;f[a+12>>2]=m;u=e;return}function Pxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+32|0;d=c+16|0;e=c;g=a+20|0;h=f[g>>2]|0;f[d>>2]=h;if(!h)i=L5b(16)|0;else i=znb(h,25536,16)|0;h=f[g>>2]|0;f[e+4>>2]=0;f[e+8>>2]=h;f[e+12>>2]=0;h=e+4|0;f[e>>2]=h;Sxa(d,i,e);Axa(e,f[h>>2]|0);Txa(a,b,i)|0;h=b^1;Txa(a,h,i)|0;e=a+16|0;f[(f[e>>2]|0)+(h<<2)>>2]=i;f[(f[e>>2]|0)+(b<<2)>>2]=i;u=c;return}function Qxa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+16|0;g=e+4|0;h=e;f[d+16>>2]=0;i=f[(f[b+16>>2]|0)+(c<<2)>>2]|0;f[h>>2]=d;d=Rxa(i,g,h)|0;j=f[d>>2]|0;if(j|0){k=j;l=k;m=c&-2;n=k+16|0;o=f[n>>2]|0;f[a>>2]=o;p=a+4|0;f[p>>2]=b;q=a+8|0;f[q>>2]=m;r=a+12|0;f[r>>2]=l;u=e;return}j=f[i+8>>2]|0;if(!j)s=L5b(20)|0;else s=znb(j,25536,20)|0;f[s+16>>2]=f[h>>2];h=f[g>>2]|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=h;f[d>>2]=s;h=f[f[i>>2]>>2]|0;if(!h)t=s;else{f[i>>2]=h;t=f[d>>2]|0}mP(f[i+4>>2]|0,t);t=i+12|0;f[t>>2]=(f[t>>2]|0)+1;k=s;l=k;m=c&-2;n=k+16|0;o=f[n>>2]|0;f[a>>2]=o;p=a+4|0;f[p>>2]=b;q=a+8|0;f[q>>2]=m;r=a+12|0;f[r>>2]=l;u=e;return}function Rxa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;e=a+4|0;g=f[e>>2]|0;h=a+4|0;if(!g){f[c>>2]=e;i=e;return i|0}e=f[d>>2]|0;d=b[e+11>>0]|0;a=d<<24>>24<0;j=f[e+4>>2]|0;k=d&255;d=a?j:k;a:do if(a){l=h;m=g;while(1){n=f[m+16>>2]|0;o=b[n+11>>0]|0;p=o<<24>>24<0;q=p?f[n+4>>2]|0:o&255;o=q>>>0<d>>>0?q:d;if((o|0)!=0?(r=ZVb(f[e>>2]|0,p?f[n>>2]|0:n,o)|0,(r|0)!=0):0)if((r|0)<0)s=12;else s=7;else if(d>>>0<q>>>0)s=12;else s=7;if((s|0)==7){s=0;r=j>>>0<q>>>0?j:q;if((r|0)!=0?(o=ZVb(p?f[n>>2]|0:n,f[e>>2]|0,r)|0,(o|0)!=0):0){if((o|0)>=0){t=l;u=m;s=27;break a}}else s=10;if((s|0)==10?(s=0,q>>>0>=j>>>0):0){t=l;u=m;s=27;break a}q=m+4|0;o=f[q>>2]|0;if(!o){v=m;w=q;s=26;break a}else{x=q;y=o}}else if((s|0)==12){s=0;o=f[m>>2]|0;if(!o){z=m;A=m;s=20;break a}else{x=m;y=o}}l=x;m=y}}else{m=h;l=g;while(1){o=f[l+16>>2]|0;q=b[o+11>>0]|0;r=q<<24>>24<0;n=r?f[o+4>>2]|0:q&255;q=n>>>0<d>>>0?n:d;if((q|0)!=0?(p=ZVb(e,r?f[o>>2]|0:o,q)|0,(p|0)!=0):0)if((p|0)<0)s=19;else s=21;else if(d>>>0<n>>>0)s=19;else s=21;if((s|0)==19){s=0;p=f[l>>2]|0;if(!p){z=l;A=l;s=20;break a}else{B=l;C=p}}else if((s|0)==21){s=0;p=k>>>0<n>>>0?k:n;if((p|0)!=0?(q=ZVb(r?f[o>>2]|0:o,e,p)|0,(q|0)!=0):0){if((q|0)>=0){t=m;u=l;s=27;break a}}else s=23;if((s|0)==23?(s=0,n>>>0>=k>>>0):0){t=m;u=l;s=27;break a}n=l+4|0;q=f[n>>2]|0;if(!q){v=l;w=n;s=26;break a}else{B=n;C=q}}m=B;l=C}}while(0);if((s|0)==20){f[c>>2]=z;i=A;return i|0}else if((s|0)==26){f[c>>2]=v;i=w;return i|0}else if((s|0)==27){f[c>>2]=u;i=t;return i|0}return 0}function Sxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=u;u=u+16|0;d=a+12|0;e=a+8|0;g=a+4|0;h=a;f[b>>2]=0;i=f[c+8>>2]|0;j=b+4|0;f[j>>2]=0;f[b+8>>2]=i;i=b+12|0;f[i>>2]=0;k=b+4|0;f[b>>2]=k;l=f[c>>2]|0;m=c+4|0;if((l|0)==(m|0)){u=a;return}c=k;k=b+8|0;n=l;while(1){l=n+16|0;f[h>>2]=c;f[d>>2]=f[h>>2];o=Uxa(b,d,e,g,l)|0;if(!(f[o>>2]|0)){p=f[k>>2]|0;if(!p)q=L5b(20)|0;else q=znb(p,25536,20)|0;f[q+16>>2]=f[l>>2];l=f[e>>2]|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=l;f[o>>2]=q;l=f[f[b>>2]>>2]|0;if(!l)r=q;else{f[b>>2]=l;r=f[o>>2]|0}mP(f[j>>2]|0,r);f[i>>2]=(f[i>>2]|0)+1}o=f[n+4>>2]|0;if(!o){l=n+8|0;p=f[l>>2]|0;if((f[p>>2]|0)==(n|0))s=p;else{p=l;do{l=f[p>>2]|0;p=l+8|0;t=f[p>>2]|0}while((f[t>>2]|0)!=(l|0));s=t}}else{p=o;while(1){t=f[p>>2]|0;if(!t)break;else p=t}s=p}if((s|0)==(m|0))break;else n=s}u=a;return}function Txa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+4|0;g=d;h=f[(f[a+16>>2]|0)+(b<<2)>>2]|0;if(!h){i=0;u=d;return i|0}b=c+8|0;a=c+4|0;j=c+12|0;k=h;h=0;while(1){f[g>>2]=k;l=Rxa(c,e,g)|0;if(!(f[l>>2]|0)){m=f[b>>2]|0;if(!m)n=L5b(20)|0;else n=znb(m,25536,20)|0;f[n+16>>2]=f[g>>2];m=f[e>>2]|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=m;f[l>>2]=n;m=f[f[c>>2]>>2]|0;if(!m)o=n;else{f[c>>2]=m;o=f[l>>2]|0}mP(f[a>>2]|0,o);f[j>>2]=(f[j>>2]|0)+1}l=h+1|0;m=k+16|0;k=f[m>>2]|0;f[m>>2]=0;if(!k){i=l;break}else h=l}u=d;return i|0}function Uxa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=a+4|0;i=f[c>>2]|0;c=i;do if((i|0)!=(h|0)){j=f[g>>2]|0;k=f[i+16>>2]|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[k+4>>2]|0:l&255;l=b[j+11>>0]|0;o=l<<24>>24<0;p=o?f[j+4>>2]|0:l&255;l=n>>>0<p>>>0;q=l?n:p;if((q|0)!=0?(r=ZVb(o?f[j>>2]|0:j,m?f[k>>2]|0:k,q)|0,(r|0)!=0):0){if((r|0)<0)break}else s=4;if((s|0)==4?p>>>0<n>>>0:0)break;r=p>>>0<n>>>0?p:n;if((r|0)!=0?(n=ZVb(m?f[k>>2]|0:k,o?f[j>>2]|0:j,r)|0,(n|0)!=0):0){if((n|0)>=0)s=36}else s=20;if((s|0)==20?!l:0)s=36;if((s|0)==36){f[d>>2]=c;f[e>>2]=c;t=e;return t|0}l=i+4|0;n=f[l>>2]|0;if(!n){r=i+8|0;k=f[r>>2]|0;if((f[k>>2]|0)==(i|0))u=k;else{k=r;do{r=f[k>>2]|0;k=r+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(r|0));u=m}}else{k=n;while(1){m=f[k>>2]|0;if(!m)break;else k=m}u=k}do if((u|0)!=(h|0)){n=f[u+16>>2]|0;m=b[n+11>>0]|0;r=m<<24>>24<0;q=r?f[n+4>>2]|0:m&255;m=q>>>0<p>>>0?q:p;if((m|0)!=0?(v=ZVb(o?f[j>>2]|0:j,r?f[n>>2]|0:n,m)|0,(v|0)!=0):0){if((v|0)<0)break}else s=30;if((s|0)==30?p>>>0<q>>>0:0)break;t=Rxa(a,d,g)|0;return t|0}while(0);if(!(f[i+4>>2]|0)){f[d>>2]=c;t=l;return t|0}else{f[d>>2]=u;t=u;return t|0}}while(0);u=f[i>>2]|0;do if((i|0)==(f[a>>2]|0))w=c;else{if(!u){h=i;while(1){e=f[h+8>>2]|0;if((f[e>>2]|0)==(h|0))h=e;else{x=e;break}}}else{h=u;while(1){l=f[h+4>>2]|0;if(!l){x=h;break}else h=l}}h=x;l=f[x+16>>2]|0;e=f[g>>2]|0;p=b[e+11>>0]|0;j=p<<24>>24<0;o=j?f[e+4>>2]|0:p&255;p=b[l+11>>0]|0;k=p<<24>>24<0;q=k?f[l+4>>2]|0:p&255;p=o>>>0<q>>>0?o:q;if((p|0)!=0?(v=ZVb(k?f[l>>2]|0:l,j?f[e>>2]|0:e,p)|0,(v|0)!=0):0){if((v|0)<0){w=h;break}}else s=12;if((s|0)==12?q>>>0<o>>>0:0){w=h;break}t=Rxa(a,d,g)|0;return t|0}while(0);if(!u){f[d>>2]=i;t=i;return t|0}else{i=w;f[d>>2]=i;t=i+4|0;return t|0}return 0}function Vxa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;h=f[c+(d<<2)>>2]|0;d=a+8|0;c=a+4|0;i=h+4|0;j=f[h>>2]|0;while(1){k=f[j+16>>2]|0;l=(b[k+11>>0]|0)<0?f[k>>2]|0:k;m=b[l>>0]|0;if(!(m<<24>>24))n=0;else{o=l;l=0;p=m;while(1){m=(l*5|0)+(p<<24>>24)|0;o=o+1|0;p=b[o>>0]|0;if(!(p<<24>>24)){n=m;break}else l=m}}Oxa(g,a,(f[c>>2]|0)+-1&(f[d>>2]|0)+n,k);l=f[j+4>>2]|0;if(!l){p=j+8|0;o=f[p>>2]|0;if((f[o>>2]|0)==(j|0))q=o;else{o=p;do{p=f[o>>2]|0;o=p+8|0;m=f[o>>2]|0}while((f[m>>2]|0)!=(p|0));q=m}}else{o=l;while(1){k=f[o>>2]|0;if(!k)break;else o=k}q=o}if((q|0)==(i|0))break;else j=q}q=f[a+20>>2]|0;Axa(h,f[i>>2]|0);if(q|0){u=e;return}O5b(h);u=e;return}function Wxa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0,M=0,N=0,O=0;e=d+8|0;g=b[e+11>>0]|0;h=g<<24>>24<0;i=h?f[e>>2]|0:e;e=b[i>>0]|0;if(!(e<<24>>24))j=0;else{k=i;l=0;m=e;while(1){e=(l*5|0)+(m<<24>>24)|0;k=k+1|0;m=b[k>>0]|0;if(!(m<<24>>24)){j=e;break}else l=e}}l=d+4|0;f[l>>2]=j;m=c+4|0;k=f[m>>2]|0;e=(k|0)==0;a:do if(!e){o=k+-1|0;p=(o&k|0)==0;if(!p)if(j>>>0<k>>>0)q=j;else q=(j>>>0)%(k>>>0)|0;else q=o&j;r=f[(f[c>>2]|0)+(q<<2)>>2]|0;if((r|0)!=0?(s=f[r>>2]|0,(s|0)!=0):0){r=d+12|0;t=g&255;if(p){p=s;b:while(1){if((f[p+4>>2]&o|0)!=(q|0)){u=q;break a}v=p+8|0;w=b[v+11>>0]|0;x=w<<24>>24<0;y=w&255;w=x?f[p+12>>2]|0:y;do if((w|0)==((h?f[r>>2]|0:t)|0)){z=f[v>>2]|0;A=x?z:v;B=(w|0)==0;if(x){if(B){C=0;D=p;E=47;break b}if(!(ZVb(A,i,w)|0)){C=0;D=p;E=47;break b}else break}if(B){C=0;D=p;E=47;break b}if((z&255)<<24>>24==(b[i>>0]|0)){z=v;B=y;A=i;do{B=B+-1|0;z=z+1|0;if(!B){C=0;D=p;E=47;break b}A=A+1|0}while((b[z>>0]|0)==(b[A>>0]|0))}}while(0);p=f[p>>2]|0;if(!p){u=q;break a}}if((E|0)==47){F=D;f[a>>2]=F;G=a+4|0;b[G>>0]=C;return}}else H=s;c:while(1){p=f[H+4>>2]|0;if(p>>>0<k>>>0)I=p;else I=(p>>>0)%(k>>>0)|0;if((I|0)!=(q|0)){u=q;break a}p=H+8|0;o=b[p+11>>0]|0;y=o<<24>>24<0;v=o&255;o=y?f[H+12>>2]|0:v;do if((o|0)==((h?f[r>>2]|0:t)|0)){w=f[p>>2]|0;x=y?w:p;A=(o|0)==0;if(y){if(A){C=0;D=H;E=47;break c}if(!(ZVb(x,i,o)|0)){C=0;D=H;E=47;break c}else break}if(A){C=0;D=H;E=47;break c}if((w&255)<<24>>24==(b[i>>0]|0)){w=p;A=v;x=i;do{A=A+-1|0;w=w+1|0;if(!A){C=0;D=H;E=47;break c}x=x+1|0}while((b[w>>0]|0)==(b[x>>0]|0))}}while(0);H=f[H>>2]|0;if(!H){u=q;break a}}if((E|0)==47){F=D;f[a>>2]=F;G=a+4|0;b[G>>0]=C;return}}else u=q}else u=0;while(0);q=c+20|0;J=+(((f[q>>2]|0)+1|0)>>>0);K=+n[c+24>>2];do if(e|J>+(k>>>0)*K){E=(k>>>0<3|(k+-1&k|0)!=0)&1|k<<1;H=~~+X(+(J/K))>>>0;Xxa(c,E>>>0<H>>>0?H:E);E=f[m>>2]|0;H=f[l>>2]|0;i=E+-1|0;if(!(i&E)){L=E;M=i&H;break}if(H>>>0<E>>>0){L=E;M=H}else{L=E;M=(H>>>0)%(E>>>0)|0}}else{L=k;M=u}while(0);u=f[(f[c>>2]|0)+(M<<2)>>2]|0;if(!u){k=c+12|0;f[d>>2]=f[k>>2];f[k>>2]=d;f[(f[c>>2]|0)+(M<<2)>>2]=k;k=f[d>>2]|0;if(!k)N=d;else{M=f[k+4>>2]|0;k=L+-1|0;if(k&L)if(M>>>0<L>>>0)O=M;else O=(M>>>0)%(L>>>0)|0;else O=M&k;f[(f[c>>2]|0)+(O<<2)>>2]=d;N=d}}else{f[d>>2]=f[u>>2];f[u>>2]=d;N=d}f[q>>2]=(f[q>>2]|0)+1;C=1;D=N;F=D;f[a>>2]=F;G=a+4|0;b[G>>0]=C;return}function Xxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if((b|0)!=1)if(!(b+-1&b))c=b;else c=yWb(b)|0;else c=2;b=f[a+4>>2]|0;if(c>>>0>b>>>0){Yxa(a,c);return}if(c>>>0>=b>>>0)return;d=~~+X(+(+((f[a+20>>2]|0)>>>0)/+n[a+24>>2]))>>>0;if(b>>>0>2&(b+-1&b|0)==0)e=1<<32-($(d+-1|0)|0);else e=yWb(d)|0;d=c>>>0<e>>>0?e:c;if(d>>>0>=b>>>0)return;Yxa(a,d);return}function Yxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=(c|0)!=0;if(d){e=f[a+8>>2]|0;g=c<<2;if(!e)h=L5b(g)|0;else h=znb(e,25536,g)|0;i=h}else i=0;h=f[a>>2]|0;f[a>>2]=i;if(h|0?(f[a+8>>2]|0)==0:0)O5b(h);f[a+4>>2]=c;if(d)j=0;else return;do{f[(f[a>>2]|0)+(j<<2)>>2]=0;j=j+1|0}while((j|0)!=(c|0));j=a+12|0;d=f[j>>2]|0;if(!d)return;h=f[d+4>>2]|0;i=c+-1|0;g=(i&c|0)==0;if(!g)if(h>>>0<c>>>0)k=h;else k=(h>>>0)%(c>>>0)|0;else k=h&i;f[(f[a>>2]|0)+(k<<2)>>2]=j;j=f[d>>2]|0;if(!j)return;else{l=k;m=d;n=j;o=d}a:while(1){d=m;j=n;k=o;b:while(1){p=j;while(1){h=f[p+4>>2]|0;if(!g)if(h>>>0<c>>>0)q=h;else q=(h>>>0)%(c>>>0)|0;else q=h&i;if((q|0)==(l|0))break;r=(f[a>>2]|0)+(q<<2)|0;if(!(f[r>>2]|0))break b;h=f[p>>2]|0;c:do if(!h)s=p;else{e=p+8|0;t=b[e+11>>0]|0;u=t<<24>>24<0;v=t&255;t=u?f[p+12>>2]|0:v;w=(t|0)==0;if(u){u=p;x=h;while(1){y=x+8|0;z=b[y+11>>0]|0;A=z<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:z&255)|0)){s=u;break c}if(!w?ZVb(f[e>>2]|0,A?f[y>>2]|0:y,t)|0:0){s=u;break c}y=f[x>>2]|0;if(!y){s=x;break c}else{A=x;x=y;u=A}}}if(w){u=p;x=h;while(1){A=b[x+8+11>>0]|0;if((A<<24>>24<0?f[x+12>>2]|0:A&255)|0){s=u;break c}A=f[x>>2]|0;if(!A){s=x;break c}else{y=x;x=A;u=y}}}u=p;x=h;while(1){w=x+8|0;y=b[w+11>>0]|0;A=y<<24>>24<0;if((t|0)!=((A?f[x+12>>2]|0:y&255)|0)){s=u;break c}y=A?f[w>>2]|0:w;if((f[e>>2]&255)<<24>>24==(b[y>>0]|0)){B=e;C=v;D=y}else{s=u;break c}while(1){C=C+-1|0;B=B+1|0;if(!C)break;D=D+1|0;if((b[B>>0]|0)!=(b[D>>0]|0)){s=u;break c}}y=f[x>>2]|0;if(!y){s=x;break}else{w=x;x=y;u=w}}}while(0);f[k>>2]=f[s>>2];f[s>>2]=f[f[(f[a>>2]|0)+(q<<2)>>2]>>2];f[f[(f[a>>2]|0)+(q<<2)>>2]>>2]=p;h=f[d>>2]|0;if(!h){E=43;break a}else p=h}j=f[p>>2]|0;if(!j){E=43;break a}else{d=p;k=p}}f[r>>2]=k;n=f[p>>2]|0;if(!n){E=43;break}else{l=q;m=p;o=p}}if((E|0)==43)return}function Zxa(a){a=a|0;var c=0,d=0,e=0,g=0;c=f[a+12>>2]|0;if(c|0){d=a+16|0;e=c;do{c=e;e=f[e>>2]|0;g=c+8|0;if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if(!(f[d>>2]|0))O5b(c)}while((e|0)!=0)}e=f[a>>2]|0;f[a>>2]=0;if(!e)return;if(f[a+8>>2]|0)return;O5b(e);return}function _xa(a){a=a|0;var b=0;b=a+16|0;if(!(f[b>>2]|0))return;zxa(a);if(f[a+20>>2]|0)return;O5b(f[b>>2]|0);return}function $xa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if((b|0)==(a|0))return a|0;switch(f[b>>2]|0){case 0:{c=L5b(16)|0;d=f[b+4>>2]|0;e=c+8|0;f[c>>2]=e;g=c+4|0;f[g>>2]=1;h=f[d+4>>2]|0;f[g>>2]=h;if(h>>>0<=1){if(h|0){i=e;j=6}}else{e=N5b(h>>>0>536870911?-1:h<<3)|0;f[c>>2]=e;i=e;j=6}if((j|0)==6){e=f[d>>2]|0;d=0;do{g=e+(d<<3)|0;k=f[g+4>>2]|0;l=i+(d<<3)|0;f[l>>2]=f[g>>2];f[l+4>>2]=k;d=d+1|0}while(d>>>0<h>>>0)}gua(a);f[a+4>>2]=c;break}case 3:{c=L5b(16)|0;jua(c,f[b+4>>2]|0);gua(a);f[a+4>>2]=c;break}case 2:{c=L5b(16)|0;h=f[b+4>>2]|0;d=c+8|0;f[c>>2]=d;i=c+4|0;f[i>>2]=1;e=f[h+4>>2]|0;f[i>>2]=e;if(e>>>0<=1){if(e|0){m=d;j=13}}else{d=N5b(e>>>0>536870911?-1:e<<3)|0;f[c>>2]=d;m=d;j=13}if((j|0)==13){j=f[h>>2]|0;h=0;do{p[m+(h<<3)>>3]=+p[j+(h<<3)>>3];h=h+1|0}while(h>>>0<e>>>0)}gua(a);f[a+4>>2]=c;break}default:{}}f[a>>2]=f[b>>2];return a|0}function aya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=(d-e|0)/12|0;h=g+1|0;i=e;j=d;if(h>>>0>357913941)c4b(a);k=a+8|0;l=((f[k>>2]|0)-e|0)/12|0;e=l<<1;m=l>>>0<178956970?(e>>>0<h>>>0?h:e):357913941;do if(m)if(m>>>0>357913941){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{n=L5b(m*12|0)|0;break}else n=0;while(0);e=n+(g*12|0)|0;h=e;l=n+(m*12|0)|0;m=f[b>>2]|0;f[e>>2]=m;f[n+(g*12|0)+4>>2]=f[b+4>>2];if(!m){o=j;p=i;q=d}else{d=m+-4|0;f[d>>2]=(f[d>>2]|0)+1;d=f[c>>2]|0;o=d;p=f[a>>2]|0;q=d}f[n+(g*12|0)+8>>2]=f[b+8>>2];b=e+12|0;if((o|0)==(p|0)){r=h;s=o;t=q}else{q=o;o=h;h=e;do{e=q;q=q+-12|0;g=f[q>>2]|0;f[h+-12>>2]=g;f[h+-8>>2]=f[e+-8>>2];if(g|0){n=g+-4|0;f[n>>2]=(f[n>>2]|0)+1}f[h+-4>>2]=f[e+-4>>2];h=o+-12|0;o=h}while((q|0)!=(p|0));r=o;s=f[a>>2]|0;t=f[c>>2]|0}f[a>>2]=r;f[c>>2]=b;f[k>>2]=l;l=s;k=t;while(1){t=k;if((t|0)==(l|0))break;b=t+-12|0;bD(b);k=b}if(!s)return;O5b(s);return}function bya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+48|0;e=d+24|0;g=d;h=d+44|0;i=a+8|0;if(!(b[i>>0]|0)){wxa(e,f[a+12>>2]|0,c);j=2;k=0;l=f[e>>2]|0}else{j=1;k=Hxa(f[a+12>>2]|0,c)|0;l=0}a:do if((j|0)==(((b[i>>0]|0)==0?2:1)|0)){switch(j&3){case 0:break;case 1:{if(k|0)break a;break}default:if(l|0)break a}zpb(g,3,471595,1529);xpb(h,vpb(g,371891)|0);Apb(g)}while(0);u=d;return (f[((j|0)==1?k+20|0:l+12|0)>>2]|0)+16|0}function cya(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;if(d>>>0>4294967279)V5b(g);if(d>>>0<11){b[g+11>>0]=d;if(!d)h=g;else{i=g;j=6}}else{k=d+16&-16;l=L5b(k)|0;f[g>>2]=l;f[g+8>>2]=k|-2147483648;f[g+4>>2]=d;i=l;j=6}if((j|0)==6){Vac(i|0,c|0,d|0)|0;h=i}b[h+d>>0]=0;d=f[a+4>>2]|0;h=d&-2;if(!(d&1))m=h;else m=f[h+4>>2]|0;h=a+152|0;a=f[h>>2]|0;if((a|0)==497760)dya(h,m,g);else _5b(a,g)|0;if((b[g+11>>0]|0)>=0){u=e;return}O5b(f[g>>2]|0);u=e;return}function dya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=L5b(12)|0;if(!c){f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0}else X5b(d,c);f[a>>2]=d;if(!b)return;eya(b,d);return}function eya(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1481);return}function fya(a){a=a|0;if(!a)return;if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a);return}function gya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=a+4|0;d=f[c>>2]|0;a:do if(!d){e=c;g=c;h=d;i=12}else{j=a+4|0;k=f[b>>2]|0;l=(k|0)==0?1124530:k;m=f[d+16>>2]|0;b:do if((k|0)!=(m|0)){n=j;o=d;p=m;q=d;while(1){r=(p|0)==0?1124530:p;if((gTb(l,r)|0)<0){s=f[o>>2]|0;if(!s){i=6;break}else{t=o;u=s}}else{if((gTb(r,l)|0)>=0){v=n;w=o;x=q;break b}y=o+4|0;r=f[y>>2]|0;if(!r){i=9;break}else{t=y;u=r}}p=f[u+16>>2]|0;if((k|0)==(p|0)){v=t;w=u;x=u;break b}else{n=t;o=u;q=u}}if((i|0)==6){z=o;A=o;break a}else if((i|0)==9){z=y;A=o;break a}}else{v=j;w=d;x=d}while(0);e=v;g=w;h=x;i=12}while(0);if((i|0)==12)if(!h){z=e;A=g}else{B=h;C=B+24|0;return C|0}h=L5b(32)|0;g=f[b>>2]|0;f[h+16>>2]=g;f[h+20>>2]=f[b+4>>2];if(g|0){b=g+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[h+24>>2]=0;f[h+28>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=A;f[z>>2]=h;A=f[f[a>>2]>>2]|0;if(!A)D=h;else{f[a>>2]=A;D=f[z>>2]|0}mP(f[a+4>>2]|0,D);D=a+8|0;f[D>>2]=(f[D>>2]|0)+1;B=h;C=B+24|0;return C|0}function hya(a,b){a=a|0;b=b|0;if(!b)return;hya(a,f[b>>2]|0);hya(a,f[b+4>>2]|0);bD(b+24|0);bD(b+16|0);O5b(b);return}function iya(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;d=u;u=u+176|0;e=d;jya(e,372976,373053,42,378737,380810,gAa(a,c)|0);c=e+21|0;f=e+32|0;while(1){if(!(b[c>>0]|0))break;g=rP(f,373088,31)|0;rP(g,a,kUb(a)|0)|0;lya(e)}kya(e+24|0);u=d;return}function jya(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0;j=u;u=u+16|0;k=j;f[a>>2]=c;f[a+4>>2]=d;f[a+8>>2]=g;f[a+12>>2]=h;f[a+16>>2]=e;b[a+20>>0]=i&1;b[a+21>>0]=1;i=a+24|0;e=a+88|0;h=a+32|0;f[h>>2]=106096;g=a+36|0;f[i>>2]=18124;f[e>>2]=18144;f[a+28>>2]=0;RXb(a+88|0,g);f[a+160>>2]=0;f[a+164>>2]=-1;f[i>>2]=106076;f[e>>2]=106116;f[h>>2]=106096;WXb(g);f[g>>2]=43284;h=a+68|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[a+84>>2]=24;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;qP(g,k);if((b[k+11>>0]|0)>=0){u=j;return}O5b(f[k>>2]|0);u=j;return}function kya(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=106076;c=a+64|0;f[c>>2]=106116;f[a+8>>2]=106096;d=a+12|0;f[d>>2]=43284;e=a+44|0;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);FWb(d);NXb(a,106128);AWb(c);return}function lya(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+48|0;d=c+40|0;e=c+32|0;g=c+24|0;h=c+16|0;i=c;b[a+21>>0]=0;j=f[a+12>>2]|0;if(!j){u=c;return}if(b[a+20>>0]|0){u=c;return}f[h>>2]=0;k=h+4|0;f[k>>2]=0;l=kUb(j)|0;if(!l)m=0;else{Vac(aD(h,l)|0,j|0,l|0)|0;m=f[k>>2]|0}f[g>>2]=0;l=g+4|0;f[l>>2]=0;aD(g,m+8|0)|0;m=f[g>>2]|0;j=m;b[j>>0]=70;b[j+1>>0]=65;b[j+2>>0]=73;b[j+3>>0]=76;j=m+4|0;b[j>>0]=69;b[j+1>>0]=68;b[j+2>>0]=58;b[j+3>>0]=32;j=f[k>>2]|0;if(j|0)Vac((f[g>>2]|0)+8|0,f[h>>2]|0,j|0)|0;f[e>>2]=0;j=e+4|0;f[j>>2]=0;aD(e,(f[l>>2]|0)+2|0)|0;k=f[l>>2]|0;if(!k)n=0;else{Vac(f[e>>2]|0,f[g>>2]|0,k|0)|0;n=f[l>>2]|0}l=(f[e>>2]|0)+n|0;b[l>>0]=46;b[l+1>>0]=32;sP(i,a+36|0);f[d>>2]=0;f[d+4>>2]=0;l=i+11|0;n=b[l>>0]|0;k=n<<24>>24<0?f[i+4>>2]|0:n&255;aD(d,(f[j>>2]|0)+k|0)|0;n=f[j>>2]|0;if(n|0)Vac(f[d>>2]|0,f[e>>2]|0,n|0)|0;if(k|0)Vac((f[d>>2]|0)+(f[j>>2]|0)|0,((b[l>>0]|0)<0?f[i>>2]|0:i)|0,k|0)|0;bO(-2,d,f[a+4>>2]|0,f[a>>2]|0,f[a+16>>2]|0);bD(d);if((b[l>>0]|0)<0)O5b(f[i>>2]|0);bD(e);bD(g);bD(h);u=c;return}function mya(a){a=a|0;kya(a);O5b(a);return}function nya(a){a=a|0;kya(a+-8|0);return}function oya(a){a=a|0;var b=0;b=a+-8|0;kya(b);O5b(b);return}function pya(a){a=a|0;kya(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function qya(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;kya(b);O5b(b);return}function rya(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0;d=u;u=u+176|0;e=d;jya(e,372976,373189,54,378737,380736,Sza(a,c)|0);c=e+21|0;f=e+32|0;while(1){if(!(b[c>>0]|0))break;g=rP(f,373088,31)|0;rP(g,a,kUb(a)|0)|0;lya(e)}kya(e+24|0);u=d;return}function sya(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+32|0;g=e+16|0;h=e;Fua(a);i=a+8|0;f[i>>2]=0;j=a+12|0;f[j>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;f[a+16>>2]=a+20;f[a+32>>2]=0;f[a+36>>2]=0;f[a+28>>2]=a+32;f[a+44>>2]=0;f[a+48>>2]=0;f[a+40>>2]=a+44;dQ(g,106204);f[a+56>>2]=0;f[a+52>>2]=0;f[a+60>>2]=0;a=f[c>>2]|0;k=f[c+4>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(k>>>0>4294967279)V5b(h);if(k>>>0<11){b[h+11>>0]=k;if(!k)l=h;else{m=h;n=6}}else{c=k+16&-16;o=L5b(c)|0;f[h>>2]=o;f[h+8>>2]=c|-2147483648;f[h+4>>2]=k;m=o;n=6}if((n|0)==6){Vac(m|0,a|0,k|0)|0;l=m}b[l+k>>0]=0;k=Ilb(h,411132,0)|0;if(!k){p=0;q=0;r=0;s=1}else{l=L5b(16)|0;f[l+4>>2]=1;f[l>>2]=106232;f[l+8>>2]=k;f[l+12>>2]=1482;m=l+4|0;f[m>>2]=(f[m>>2]|0)+1;p=l;q=l;r=l;s=0}l=f[i>>2]|0;f[i>>2]=p;f[j>>2]=k;if(l|0?(k=l+4|0,p=f[k>>2]|0,f[k>>2]=p+-1,(p|0)==1):0)bi[f[(f[l>>2]|0)+8>>2]&2047](l);if(!s?(s=q+4|0,l=f[s>>2]|0,f[s>>2]=l+-1,(l|0)==1):0)bi[f[(f[q>>2]|0)+8>>2]&2047](r);if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);r=f[j>>2]|0;if(!((r|0)!=0?(Clb(r)|0)!=0:0)){f[h>>2]=0;f[h+4>>2]=0;r=aD(h,29)|0;q=375956;l=r+29|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(l|0));bO(-215,h,375986,373222,127);bD(h)}h=f[j>>2]|0;if(d)Dlb(h);else Elb(h);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function tya(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;c=u;u=u+16|0;d=c;e=c+8|0;g=a+12|0;switch(Flb(f[g>>2]|0)|0){case 4:{h=Flb(f[g>>2]|0)|0;vya(a,h);i=a+16|0;j=a+20|0;k=f[j>>2]|0;do if(k){l=a+20|0;m=k;while(1){n=f[m+16>>2]|0;if((h|0)<(n|0)){o=f[m>>2]|0;if(!o){p=7;break}else{q=m;r=o}}else{if((n|0)>=(h|0)){p=11;break}s=m+4|0;n=f[s>>2]|0;if(!n){p=10;break}else{q=s;r=n}}l=q;m=r}if((p|0)==7){t=m;v=m;break}else if((p|0)==10){t=s;v=m;break}else if((p|0)==11){t=l;v=m;break}}else{t=j;v=j}while(0);if(f[t>>2]|0){u=c;return}j=L5b(20)|0;f[j+16>>2]=h;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=v;f[t>>2]=j;v=f[f[i>>2]>>2]|0;if(!v)w=j;else{f[i>>2]=v;w=f[t>>2]|0}mP(f[a+20>>2]|0,w);w=a+24|0;f[w>>2]=(f[w>>2]|0)+1;u=c;return}case 1:{+Hlb(f[g>>2]|0);u=c;return}case 5:{Flb(f[g>>2]|0)|0;u=c;return}case 2:{w=Flb(f[g>>2]|0)|0;f[d>>2]=0;f[d+4>>2]=0;if(!w)x=0;else{Nac(aD(d,w)|0,0,w|0)|0;x=f[d>>2]|0}tlb(f[g>>2]|0,(x|0)==0?1124530:x,w)|0;bD(d);u=c;return}case 3:{wya(a,-1);u=c;return}case 0:{u=c;return}default:{f[e>>2]=0;f[e+4>>2]=0;a=aD(e,20)|0;d=373303;w=a+20|0;do{b[a>>0]=b[d>>0]|0;a=a+1|0;d=d+1|0}while((a|0)<(w|0));bO(-213,e,373324,373222,977);bD(e);u=c;return}}}function uya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(!b)return;uya(a,f[b>>2]|0);uya(a,f[b+4>>2]|0);a=b+20|0;c=b+56|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(a);f[c>>2]=0;c=b+36|0;a=b+24|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[b+60>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[a>>2]|0))}a=f[b+64>>2]|0;if((a|0)!=(b+68|0))UC(a);O5b(b);return}function vya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0;d=u;u=u+736|0;e=d+712|0;g=d+720|0;h=d+704|0;i=d+692|0;j=d+680|0;k=d+672|0;l=d+616|0;m=d+560|0;o=d+504|0;q=d;r=d+232|0;s=d+488|0;t=d+8|0;v=d+480|0;w=d+472|0;x=d+464|0;y=d+456|0;f[e>>2]=c;z=a+16|0;A=a+20|0;B=f[A>>2]|0;a:do if(B|0){C=B;while(1){D=f[C+16>>2]|0;if((D|0)>(c|0))E=C;else{if((D|0)>=(c|0))break;E=C+4|0}C=f[E>>2]|0;if(!C)break a}u=d;return}while(0);xya(g,a);f[h>>2]=0;E=h+4|0;f[E>>2]=0;c=yya(g,373335,373342)|0;do if((c|0)>-1)zya(a,f[e>>2]|0,c);else{B=yya(g,373349,373342)|0;if((B|0)>-1){Aya(a,f[e>>2]|0,B);break}if(!(Bya(g,h)|0)){f[j>>2]=0;B=j+4|0;f[B>>2]=0;C=g+4|0;aD(j,(f[C>>2]|0)+25|0)|0;D=f[j>>2]|0;F=D;G=375316;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));I=f[C>>2]|0;if(I|0)Vac(D+25|0,f[g>>2]|0,I|0)|0;f[i>>2]=0;f[i+4>>2]=0;aD(i,(f[B>>2]|0)+1|0)|0;I=f[B>>2]|0;if(!I)K=0;else{Vac(f[i>>2]|0,f[j>>2]|0,I|0)|0;K=f[B>>2]|0}b[(f[i>>2]|0)+K>>0]=34;bO(-213,i,373550,373222,950);bD(i);bD(j);break}f[i+4>>2]=0;f[i+8>>2]=0;I=i+4|0;f[i>>2]=I;f[j+4>>2]=0;f[j+8>>2]=0;L=j+4|0;f[j>>2]=L;M=L5b(68)|0;f[l>>2]=0;N=l+4|0;f[N>>2]=0;O=f[h>>2]|0;f[M>>2]=O;f[M+4>>2]=f[E>>2];if(O){P=O+-4|0;f[P>>2]=(f[P>>2]|0)+1;P=f[l>>2]|0;O=f[N>>2]|0;f[M+8>>2]=P;f[M+12>>2]=O;if(P|0){O=P+-4|0;f[O>>2]=(f[O>>2]|0)+1}}else{f[M+8>>2]=0;f[M+12>>2]=0}O=M+20|0;f[O>>2]=0;f[M+24>>2]=0;f[M+16>>2]=O;F=M+28|0;H=F+40|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));B=L5b(16)|0;f[B+4>>2]=1;f[B>>2]=106172;f[B+8>>2]=M;f[k>>2]=B;B=k+4|0;f[B>>2]=M;bD(l);D=f[B>>2]|0;C=D+16|0;f[l>>2]=0;f[l+4>>2]=0;F=aD(l,11)|0;G=373357;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Wwa(C,l,e)|0;bD(l);M=f[h>>2]|0;b:do if((((((((M|0)!=373369?(O=(M|0)==0?1124530:M,!((gTb(O,373369)|0)==0|(M|0)==373380)):0)?!((gTb(O,373380)|0)==0|(M|0)==411848):0)?!((gTb(O,411848)|0)==0|(M|0)==373389):0)?!((gTb(O,373389)|0)==0|(M|0)==373401):0)?!((gTb(O,373401)|0)==0|(M|0)==373411):0)?!((gTb(O,373411)|0)==0|(M|0)==373423):0)?(gTb(O,373423)|0)!=0:0){if(((M|0)!=373474?!((gTb(O,373474)|0)==0|(M|0)==373493):0)?gTb(O,373493)|0:0){do if((M|0)!=373610){if(!(gTb(O,373610)|0))break;do if((M|0)!=373627){if((gTb(O,373627)|0)==0|(M|0)==373645)break;if(!(gTb(O,373645)|0))break;do if((M|0)!=373729){if(!(gTb(O,373729)|0))break;do if((M|0)!=410761){if((gTb(O,410761)|0)==0|(M|0)==373736)break;if(!(gTb(O,373736)|0))break;do if((M|0)!=380368){if(!(gTb(O,380368)|0))break;do if((M|0)!=373776){if(!(gTb(O,373776)|0))break;do if((M|0)!=410892){if(!(gTb(O,410892)|0))break;do if((M|0)!=373781){if((gTb(O,373781)|0)==0|(M|0)==373807)break;if((gTb(O,373807)|0)==0|(M|0)==373829)break;if(!(gTb(O,373829)|0))break;do if((M|0)!=410886){if(!(gTb(O,410886)|0))break;do if((M|0)!=374044){if((gTb(O,374044)|0)==0|(M|0)==410921)break;if(!(gTb(O,410921)|0))break;do if((M|0)!=374081){if((gTb(O,374081)|0)==0|(M|0)==374090)break;if(!(gTb(O,374090)|0))break;do if((M|0)!=410977){if(!(gTb(O,410977)|0))break;do if((M|0)!=410993){if(!(gTb(O,410993)|0))break;do if((M|0)!=374211){if(!(gTb(O,374211)|0))break;do if((M|0)!=374221){if(!(gTb(O,374221)|0))break;do if((M|0)!=374553){if(!(gTb(O,374553)|0))break;do if((M|0)!=374818){if(!(gTb(O,374818)|0))break;do if((M|0)!=374868){if(!(gTb(O,374868)|0))break;do if((M|0)!=374876){if(!(gTb(O,374876)|0))break;do if((M|0)!=374887){if(!(gTb(O,374887)|0))break;do if((M|0)!=374979){if((gTb(O,374979)|0)==0|(M|0)==374986)break;if((gTb(O,374986)|0)==0|(M|0)==433229)break;if(!(gTb(O,433229)|0))break;do if((M|0)!=374995){if(!(gTb(O,374995)|0))break;do if((M|0)!=375059){if((gTb(O,375059)|0)==0|(M|0)==375078)break;if(!(gTb(O,375078)|0))break;do if((M|0)!=375286){if(!(gTb(O,375286)|0))break;f[m>>2]=0;P=m+4|0;f[P>>2]=0;N=g+4|0;aD(m,(f[N>>2]|0)+18|0)|0;Q=f[m>>2]|0;F=Q;G=375297;H=F+18|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));R=f[N>>2]|0;if(R|0)Vac(Q+18|0,f[g>>2]|0,R|0)|0;f[l>>2]=0;f[l+4>>2]=0;aD(l,(f[P>>2]|0)+1|0)|0;R=f[P>>2]|0;if(!R)S=0;else{Vac(f[l>>2]|0,f[m>>2]|0,R|0)|0;S=f[P>>2]|0}b[(f[l>>2]|0)+S>>0]=34;bO(-213,l,373550,373222,945);bD(l);bD(m);break b}while(0);Dya(a,i,j);f[l>>2]=0;f[l+4>>2]=0;R=aD(l,4)|0;b[R>>0]=115;b[R+1>>0]=105;b[R+2>>0]=122;b[R+3>>0]=101;R=f[I>>2]|0;do if(R){T=f[l>>2]|0;U=(T|0)==0?1124530:T;V=R;while(1){W=f[V+16>>2]|0;if((T|0)==(W|0)){X=1129;break}Z=(W|0)==0?1124530:W;if((gTb(U,Z)|0)<0)_=V;else{if((gTb(Z,U)|0)>=0){X=1133;break}_=V+4|0}V=f[_>>2]|0;if(!V){X=1131;break}}if((X|0)==1129){bD(l);break}else if((X|0)==1131){bD(l);X=1132;break}else if((X|0)==1133){bD(l);break}}else{bD(l);X=1132}while(0);if((X|0)==1132){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,24)|0;G=373741;H=F+24|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,932);bD(l)}f[l>>2]=0;f[l+4>>2]=0;R=aD(l,4)|0;b[R>>0]=115;b[R+1>>0]=105;b[R+2>>0]=122;b[R+3>>0]=101;R=Gwa(Eya(i,l)|0,-1)|0;bD(l);V=~R;U=(f[B>>2]|0)+8|0;bD(U);T=aD(U,5)|0;b[T>>0]=b[410749]|0;b[T+1>>0]=b[410750]|0;b[T+2>>0]=b[410751]|0;b[T+3>>0]=b[410752]|0;b[T+4>>0]=b[410753]|0;f[l>>2]=0;f[l+4>>2]=0;T=aD(l,5)|0;b[T>>0]=b[426569]|0;b[T+1>>0]=b[426570]|0;b[T+2>>0]=b[426571]|0;b[T+3>>0]=b[426572]|0;b[T+4>>0]=b[426573]|0;T=L5b(16)|0;f[T>>2]=T+8;f[T+4>>2]=4;U=N5b(32)|0;f[T>>2]=U;f[m>>2]=0;f[m+4>>2]=T;T=((R|0)<0)<<31>>31;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;P=U+16|0;f[P>>2]=R;f[P+4>>2]=T;P=U+24|0;f[P>>2]=R;f[P+4>>2]=T;nxa(C,l,m)|0;gua(m);bD(l);f[l>>2]=0;f[l+4>>2]=0;T=aD(l,3)|0;b[T>>0]=b[426575]|0;b[T+1>>0]=b[426576]|0;b[T+2>>0]=b[426577]|0;T=L5b(16)|0;f[T>>2]=T+8;f[T+4>>2]=4;P=N5b(32)|0;f[T>>2]=P;f[m>>2]=0;f[m+4>>2]=T;T=((V|0)<0)<<31>>31;f[P>>2]=-1;f[P+4>>2]=-1;f[P+8>>2]=-1;f[P+12>>2]=-1;R=P+16|0;f[R>>2]=V;f[R+4>>2]=T;R=P+24|0;f[R>>2]=V;f[R+4>>2]=T;nxa(C,l,m)|0;gua(m);bD(l);T=f[a+56>>2]|0;R=T+60|0;V=f[R>>2]|0;if((V|0)==(f[T+64>>2]|0)){Cya(T+56|0,k);break b}T=f[k>>2]|0;f[V>>2]=T;f[V+4>>2]=f[B>>2];if(!T)$=V;else{V=T+4|0;f[V>>2]=(f[V>>2]|0)+1;$=f[R>>2]|0}f[R>>2]=$+8;break b}while(0);Dya(a,i,j);f[l>>2]=0;f[l+4>>2]=0;R=aD(l,5)|0;b[R>>0]=b[375103]|0;b[R+1>>0]=b[375104]|0;b[R+2>>0]=b[375105]|0;b[R+3>>0]=b[375106]|0;b[R+4>>0]=b[375107]|0;R=f[I>>2]|0;do if(R){V=f[l>>2]|0;T=(V|0)==0?1124530:V;P=R;while(1){U=f[P+16>>2]|0;if((V|0)==(U|0)){X=1064;break}Q=(U|0)==0?1124530:U;if((gTb(T,Q)|0)<0)aa=P;else{if((gTb(Q,T)|0)>=0){X=1068;break}aa=P+4|0}P=f[aa>>2]|0;if(!P){X=1066;break}}if((X|0)==1064){bD(l);break}else if((X|0)==1066){bD(l);X=1067;break}else if((X|0)==1068){bD(l);break}}else{bD(l);X=1067}while(0);if((X|0)==1067){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,25)|0;G=375109;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,902);bD(l)}f[l>>2]=0;f[l+4>>2]=0;R=aD(l,5)|0;b[R>>0]=b[375135]|0;b[R+1>>0]=b[375136]|0;b[R+2>>0]=b[375137]|0;b[R+3>>0]=b[375138]|0;b[R+4>>0]=b[375139]|0;R=f[I>>2]|0;do if(R){P=f[l>>2]|0;T=(P|0)==0?1124530:P;V=R;while(1){Q=f[V+16>>2]|0;if((P|0)==(Q|0)){X=1077;break}U=(Q|0)==0?1124530:Q;if((gTb(T,U)|0)<0)ba=V;else{if((gTb(U,T)|0)>=0){X=1081;break}ba=V+4|0}V=f[ba>>2]|0;if(!V){X=1079;break}}if((X|0)==1077){bD(l);break}else if((X|0)==1079){bD(l);X=1080;break}else if((X|0)==1081){bD(l);break}}else{bD(l);X=1080}while(0);if((X|0)==1080){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,25)|0;G=375141;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,902);bD(l)}f[l>>2]=0;f[l+4>>2]=0;R=aD(l,5)|0;b[R>>0]=b[375167]|0;b[R+1>>0]=b[375168]|0;b[R+2>>0]=b[375169]|0;b[R+3>>0]=b[375170]|0;b[R+4>>0]=b[375171]|0;R=f[I>>2]|0;do if(R){V=f[l>>2]|0;T=(V|0)==0?1124530:V;P=R;while(1){U=f[P+16>>2]|0;if((V|0)==(U|0)){X=1090;break}Q=(U|0)==0?1124530:U;if((gTb(T,Q)|0)<0)ca=P;else{if((gTb(Q,T)|0)>=0){X=1094;break}ca=P+4|0}P=f[ca>>2]|0;if(!P){X=1092;break}}if((X|0)==1090){bD(l);break}else if((X|0)==1092){bD(l);X=1093;break}else if((X|0)==1094){bD(l);break}}else{bD(l);X=1093}while(0);if((X|0)==1093){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,25)|0;G=375173;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,902);bD(l)}f[l>>2]=0;f[l+4>>2]=0;R=aD(l,5)|0;b[R>>0]=b[375199]|0;b[R+1>>0]=b[375200]|0;b[R+2>>0]=b[375201]|0;b[R+3>>0]=b[375202]|0;b[R+4>>0]=b[375203]|0;R=f[I>>2]|0;do if(R){P=f[l>>2]|0;T=(P|0)==0?1124530:P;V=R;while(1){Q=f[V+16>>2]|0;if((P|0)==(Q|0)){X=1103;break}U=(Q|0)==0?1124530:Q;if((gTb(T,U)|0)<0)da=V;else{if((gTb(U,T)|0)>=0){X=1107;break}da=V+4|0}V=f[da>>2]|0;if(!V){X=1105;break}}if((X|0)==1103){bD(l);break}else if((X|0)==1105){bD(l);X=1106;break}else if((X|0)==1107){bD(l);break}}else{bD(l);X=1106}while(0);if((X|0)==1106){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,25)|0;G=375205;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,902);bD(l)}f[l>>2]=0;f[l+4>>2]=0;R=aD(l,5)|0;b[R>>0]=b[375167]|0;b[R+1>>0]=b[375168]|0;b[R+2>>0]=b[375169]|0;b[R+3>>0]=b[375170]|0;b[R+4>>0]=b[375171]|0;R=Gwa(Eya(i,l)|0,-1)|0;V=J;bD(l);f[l>>2]=0;f[l+4>>2]=0;V=aD(l,5)|0;b[V>>0]=b[375103]|0;b[V+1>>0]=b[375104]|0;b[V+2>>0]=b[375105]|0;b[V+3>>0]=b[375106]|0;b[V+4>>0]=b[375107]|0;V=Gwa(Eya(i,l)|0,-1)|0;T=J;bD(l);f[l>>2]=0;f[l+4>>2]=0;T=aD(l,5)|0;b[T>>0]=b[375135]|0;b[T+1>>0]=b[375136]|0;b[T+2>>0]=b[375137]|0;b[T+3>>0]=b[375138]|0;b[T+4>>0]=b[375139]|0;T=Gwa(Eya(i,l)|0,-1)|0;P=J;bD(l);f[l>>2]=0;f[l+4>>2]=0;P=aD(l,5)|0;b[P>>0]=b[375199]|0;b[P+1>>0]=b[375200]|0;b[P+2>>0]=b[375201]|0;b[P+3>>0]=b[375202]|0;b[P+4>>0]=b[375203]|0;P=Gwa(Eya(i,l)|0,-1)|0;U=J;bD(l);if((V|R|T|P|0)<0){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,54)|0;G=375231;H=F+54|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-213,l,373550,373222,908);bD(l)}U=(f[B>>2]|0)+8|0;bD(U);Q=aD(U,7)|0;b[Q>>0]=b[410993]|0;b[Q+1>>0]=b[410994]|0;b[Q+2>>0]=b[410995]|0;b[Q+3>>0]=b[410996]|0;b[Q+4>>0]=b[410997]|0;b[Q+5>>0]=b[410998]|0;b[Q+6>>0]=b[410999]|0;Q=L5b(24)|0;U=Q;f[U>>2]=0;f[U+4>>2]=0;f[Q+8>>2]=R;f[Q+12>>2]=P;f[Q+16>>2]=V;f[Q+20>>2]=T;f[l>>2]=0;f[l+4>>2]=0;U=aD(l,8)|0;N=U;b[N>>0]=112;b[N+1>>0]=97;b[N+2>>0]=100;b[N+3>>0]=100;N=U+4|0;b[N>>0]=105;b[N+1>>0]=110;b[N+2>>0]=103;b[N+3>>0]=115;N=L5b(16)|0;f[N>>2]=N+8;f[N+4>>2]=6;U=N5b(48)|0;f[N>>2]=U;f[m>>2]=0;f[m+4>>2]=N;N=f[Q>>2]|0;Z=U;f[Z>>2]=N;f[Z+4>>2]=((N|0)<0)<<31>>31;N=f[Q+4>>2]|0;Z=U+8|0;f[Z>>2]=N;f[Z+4>>2]=((N|0)<0)<<31>>31;N=f[Q+8>>2]|0;Z=U+16|0;f[Z>>2]=N;f[Z+4>>2]=((N|0)<0)<<31>>31;N=f[Q+12>>2]|0;Z=U+24|0;f[Z>>2]=N;f[Z+4>>2]=((N|0)<0)<<31>>31;N=f[Q+16>>2]|0;Z=U+32|0;f[Z>>2]=N;f[Z+4>>2]=((N|0)<0)<<31>>31;N=f[Q+20>>2]|0;Z=U+40|0;f[Z>>2]=N;f[Z+4>>2]=((N|0)<0)<<31>>31;nxa(C,l,m)|0;gua(m);bD(l);f[l>>2]=0;f[l+4>>2]=0;F=aD(l,10)|0;G=418554;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[m>>2]=3;Wwa(C,l,m)|0;bD(l);T=f[h>>2]|0;if(!((T|0)!=375078?(gTb((T|0)==0?1124530:T,375078)|0)!=0:0)){f[l>>2]=0;f[l+4>>2]=0;T=aD(l,4)|0;b[T>>0]=116;b[T+1>>0]=121;b[T+2>>0]=112;b[T+3>>0]=101;Jya(C,l,419004)|0;bD(l)}T=f[a+56>>2]|0;V=T+60|0;P=f[V>>2]|0;if((P|0)==(f[T+64>>2]|0))Cya(T+56|0,k);else{T=f[k>>2]|0;f[P>>2]=T;f[P+4>>2]=f[B>>2];if(!T)ea=P;else{P=T+4|0;f[P>>2]=(f[P>>2]|0)+1;ea=f[V>>2]|0}f[V>>2]=ea+8}O5b(Q);break b}while(0);Dya(a,i,j);f[l>>2]=0;f[l+4>>2]=0;F=aD(l,15)|0;G=375007;H=F+15|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));V=f[I>>2]|0;do if(V){P=f[l>>2]|0;T=(P|0)==0?1124530:P;R=V;while(1){N=f[R+16>>2]|0;if((P|0)==(N|0)){X=1043;break}Z=(N|0)==0?1124530:N;if((gTb(T,Z)|0)<0)fa=R;else{if((gTb(Z,T)|0)>=0){X=1047;break}fa=R+4|0}R=f[fa>>2]|0;if(!R){X=1045;break}}if((X|0)==1043){bD(l);break}else if((X|0)==1045){bD(l);X=1046;break}else if((X|0)==1047){bD(l);break}}else{bD(l);X=1046}while(0);if((X|0)==1046){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,35)|0;G=375023;H=F+35|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,893);bD(l)}V=(f[B>>2]|0)+8|0;bD(V);R=aD(V,5)|0;b[R>>0]=b[433229]|0;b[R+1>>0]=b[433230]|0;b[R+2>>0]=b[433231]|0;b[R+3>>0]=b[433232]|0;b[R+4>>0]=b[433233]|0;f[l>>2]=0;f[l+4>>2]=0;R=aD(l,5)|0;b[R>>0]=b[439628]|0;b[R+1>>0]=b[439629]|0;b[R+2>>0]=b[439630]|0;b[R+3>>0]=b[439631]|0;b[R+4>>0]=b[439632]|0;f[o>>2]=0;f[o+4>>2]=0;F=aD(o,15)|0;G=375007;H=F+15|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));ga=+Hya(Eya(i,o)|0,-1);n[m>>2]=ga;Zwa(C,l,m)|0;bD(o);bD(l);R=f[a+56>>2]|0;V=R+60|0;T=f[V>>2]|0;if((T|0)==(f[R+64>>2]|0)){Cya(R+56|0,k);break b}R=f[k>>2]|0;f[T>>2]=R;f[T+4>>2]=f[B>>2];if(!R)ha=T;else{T=R+4|0;f[T>>2]=(f[T>>2]|0)+1;ha=f[V>>2]|0}f[V>>2]=ha+8;break b}while(0);Dya(a,i,j);V=f[h>>2]|0;c:do if((V|0)==374979)X=1009;else{T=(V|0)==0?1124530:V;if(!(gTb(T,374979)|0)){X=1009;break}do if((V|0)!=374986){if(!(gTb(T,374986)|0))break;if((V|0)!=433229?gTb(T,433229)|0:0)break c;f[m>>2]=0;f[m+4>>2]=0;R=aD(m,3)|0;b[R>>0]=b[374991]|0;b[R+1>>0]=b[374992]|0;b[R+2>>0]=b[374993]|0;R=f[I>>2]|0;do if(!R)ia=1.0;else{P=f[m>>2]|0;Q=(P|0)==0?1124530:P;Z=I;N=R;d:while(1){U=N;while(1){W=f[U+16>>2]|0;if((W|0)==(P|0))break;if((gTb((W|0)==0?1124530:W,Q)|0)>=0)break;W=f[U+4>>2]|0;if(!W){ja=Z;break d}else U=W}N=f[U>>2]|0;if(!N){ja=U;break}else Z=U}if((ja|0)==(I|0)){ia=1.0;break}Z=f[ja+16>>2]|0;if((P|0)!=(Z|0)?(gTb(Q,(Z|0)==0?1124530:Z)|0)<=-1:0){ia=1.0;break}ia=+Hya(ja+24|0,-1)}while(0);n[l>>2]=ia;bD(m);break c}while(0);n[l>>2]=.5}while(0);if((X|0)==1009)n[l>>2]=2.0;V=(f[B>>2]|0)+8|0;bD(V);T=aD(V,5)|0;b[T>>0]=b[433229]|0;b[T+1>>0]=b[433230]|0;b[T+2>>0]=b[433231]|0;b[T+3>>0]=b[433232]|0;b[T+4>>0]=b[433233]|0;f[m>>2]=0;f[m+4>>2]=0;T=aD(m,5)|0;b[T>>0]=b[439622]|0;b[T+1>>0]=b[439623]|0;b[T+2>>0]=b[439624]|0;b[T+3>>0]=b[439625]|0;b[T+4>>0]=b[439626]|0;Zwa(C,m,l)|0;bD(m);T=f[a+56>>2]|0;V=T+60|0;R=f[V>>2]|0;if((R|0)==(f[T+64>>2]|0))Cya(T+56|0,k);else{T=f[k>>2]|0;f[R>>2]=T;f[R+4>>2]=f[B>>2];if(!T)ka=R;else{R=T+4|0;f[R>>2]=(f[R>>2]|0)+1;ka=f[V>>2]|0}f[V>>2]=ka+8}break b}while(0);V=(f[B>>2]|0)+8|0;bD(V);R=aD(V,3)|0;b[R>>0]=b[410837]|0;b[R+1>>0]=b[410838]|0;b[R+2>>0]=b[410839]|0;Dya(a,i,j);f[l>>2]=0;f[l+4>>2]=0;R=aD(l,5)|0;b[R>>0]=b[412511]|0;b[R+1>>0]=b[412512]|0;b[R+2>>0]=b[412513]|0;b[R+3>>0]=b[412514]|0;b[R+4>>0]=b[412515]|0;R=f[I>>2]|0;do if(R){V=f[l>>2]|0;T=(V|0)==0?1124530:V;Z=R;while(1){N=f[Z+16>>2]|0;if((V|0)==(N|0)){X=954;break}W=(N|0)==0?1124530:N;if((gTb(T,W)|0)<0)la=Z;else{if((gTb(W,T)|0)>=0){X=958;break}la=Z+4|0}Z=f[la>>2]|0;if(!Z){X=956;break}}if((X|0)==954){bD(l);break}else if((X|0)==956){bD(l);X=957;break}else if((X|0)==958){bD(l);break}}else{bD(l);X=957}while(0);if((X|0)==957){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,25)|0;G=374906;H=F+25|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,863);bD(l)}f[l>>2]=0;f[l+4>>2]=0;R=aD(l,4)|0;b[R>>0]=98;b[R+1>>0]=101;b[R+2>>0]=116;b[R+3>>0]=97;R=f[I>>2]|0;do if(R){Z=f[l>>2]|0;T=(Z|0)==0?1124530:Z;V=R;while(1){W=f[V+16>>2]|0;if((Z|0)==(W|0)){X=967;break}N=(W|0)==0?1124530:W;if((gTb(T,N)|0)<0)ma=V;else{if((gTb(N,T)|0)>=0){X=971;break}ma=V+4|0}V=f[ma>>2]|0;if(!V){X=969;break}}if((X|0)==967){bD(l);break}else if((X|0)==969){bD(l);X=970;break}else if((X|0)==971){bD(l);break}}else{bD(l);X=970}while(0);if((X|0)==970){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,24)|0;G=374932;H=F+24|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,864);bD(l)}f[l>>2]=0;f[l+4>>2]=0;R=aD(l,1)|0;b[R>>0]=107;R=f[I>>2]|0;do if(R){V=f[l>>2]|0;T=(V|0)==0?1124530:V;Z=R;while(1){N=f[Z+16>>2]|0;if((V|0)==(N|0)){X=980;break}W=(N|0)==0?1124530:N;if((gTb(T,W)|0)<0)na=Z;else{if((gTb(W,T)|0)>=0){X=984;break}na=Z+4|0}Z=f[na>>2]|0;if(!Z){X=982;break}}if((X|0)==980){bD(l);break}else if((X|0)==982){bD(l);X=983;break}else if((X|0)==984){bD(l);break}}else{bD(l);X=983}while(0);if((X|0)==983){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,21)|0;G=374957;H=F+21|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,865);bD(l)}f[l>>2]=0;f[l+4>>2]=0;R=aD(l,4)|0;b[R>>0]=115;b[R+1>>0]=105;b[R+2>>0]=122;b[R+3>>0]=101;R=f[I>>2]|0;do if(R){Z=f[l>>2]|0;T=(Z|0)==0?1124530:Z;V=R;while(1){W=f[V+16>>2]|0;if((Z|0)==(W|0)){X=993;break}N=(W|0)==0?1124530:W;if((gTb(T,N)|0)<0)oa=V;else{if((gTb(N,T)|0)>=0){X=997;break}oa=V+4|0}V=f[oa>>2]|0;if(!V){X=995;break}}if((X|0)==993){bD(l);break}else if((X|0)==995){bD(l);X=996;break}else if((X|0)==997){bD(l);break}}else{bD(l);X=996}while(0);if((X|0)==996){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,24)|0;G=373741;H=F+24|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,866);bD(l)}f[l>>2]=0;f[l+4>>2]=0;F=aD(l,11)|0;G=412286;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Iya(C,l,412298)|0;bD(l);f[l>>2]=0;f[l+4>>2]=0;R=aD(l,5)|0;b[R>>0]=b[412511]|0;b[R+1>>0]=b[412512]|0;b[R+2>>0]=b[412513]|0;b[R+3>>0]=b[412514]|0;b[R+4>>0]=b[412515]|0;f[o>>2]=0;f[o+4>>2]=0;R=aD(o,5)|0;b[R>>0]=b[412511]|0;b[R+1>>0]=b[412512]|0;b[R+2>>0]=b[412513]|0;b[R+3>>0]=b[412514]|0;b[R+4>>0]=b[412515]|0;ga=+Hya(Eya(i,o)|0,-1);n[m>>2]=ga;Zwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;R=aD(l,4)|0;b[R>>0]=98;b[R+1>>0]=101;b[R+2>>0]=116;b[R+3>>0]=97;f[o>>2]=0;f[o+4>>2]=0;R=aD(o,4)|0;b[R>>0]=98;b[R+1>>0]=101;b[R+2>>0]=116;b[R+3>>0]=97;ga=+Hya(Eya(i,o)|0,-1);n[m>>2]=ga;Zwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;R=aD(l,4)|0;b[R>>0]=98;b[R+1>>0]=105;b[R+2>>0]=97;b[R+3>>0]=115;f[o>>2]=0;f[o+4>>2]=0;R=aD(o,1)|0;b[R>>0]=107;ga=+Hya(Eya(i,o)|0,-1);n[m>>2]=ga;Zwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;F=aD(l,10)|0;G=412441;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;R=aD(o,4)|0;b[R>>0]=115;b[R+1>>0]=105;b[R+2>>0]=122;b[R+3>>0]=101;R=Gwa(Eya(i,o)|0,-1)|0;f[m>>2]=R;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;F=aD(l,12)|0;G=412517;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));b[m>>0]=1;$wa(C,l,m)|0;bD(l);R=f[a+56>>2]|0;V=R+60|0;T=f[V>>2]|0;if((T|0)==(f[R+64>>2]|0)){Cya(R+56|0,k);break b}R=f[k>>2]|0;f[T>>2]=R;f[T+4>>2]=f[B>>2];if(!R)pa=T;else{T=R+4|0;f[T>>2]=(f[T>>2]|0)+1;pa=f[V>>2]|0}f[V>>2]=pa+8;break b}while(0);V=(f[B>>2]|0)+8|0;bD(V);T=aD(V,7)|0;b[T>>0]=b[374868]|0;b[T+1>>0]=b[374869]|0;b[T+2>>0]=b[374870]|0;b[T+3>>0]=b[374871]|0;b[T+4>>0]=b[374872]|0;b[T+5>>0]=b[374873]|0;b[T+6>>0]=b[374874]|0;f[l>>2]=0;f[l+4>>2]=0;F=aD(l,11)|0;G=430959;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));b[m>>0]=1;$wa(C,l,m)|0;bD(l);T=f[a+56>>2]|0;V=T+60|0;R=f[V>>2]|0;if((R|0)==(f[T+64>>2]|0)){Cya(T+56|0,k);break b}T=f[k>>2]|0;f[R>>2]=T;f[R+4>>2]=f[B>>2];if(!T)qa=R;else{R=T+4|0;f[R>>2]=(f[R>>2]|0)+1;qa=f[V>>2]|0}f[V>>2]=qa+8;break b}while(0);V=(f[B>>2]|0)+8|0;bD(V);R=aD(V,7)|0;b[R>>0]=b[374868]|0;b[R+1>>0]=b[374869]|0;b[R+2>>0]=b[374870]|0;b[R+3>>0]=b[374871]|0;b[R+4>>0]=b[374872]|0;b[R+5>>0]=b[374873]|0;b[R+6>>0]=b[374874]|0;R=f[a+56>>2]|0;V=R+60|0;T=f[V>>2]|0;if((T|0)==(f[R+64>>2]|0)){Cya(R+56|0,k);break b}R=f[k>>2]|0;f[T>>2]=R;f[T+4>>2]=f[B>>2];if(!R)ra=T;else{T=R+4|0;f[T>>2]=(f[T>>2]|0)+1;ra=f[V>>2]|0}f[V>>2]=ra+8;break b}while(0);Dya(a,i,j);f[l>>2]=0;f[l+4>>2]=0;V=aD(l,7)|0;b[V>>0]=b[373687]|0;b[V+1>>0]=b[373688]|0;b[V+2>>0]=b[373689]|0;b[V+3>>0]=b[373690]|0;b[V+4>>0]=b[373691]|0;b[V+5>>0]=b[373692]|0;b[V+6>>0]=b[373693]|0;V=f[L>>2]|0;e:do if(!V)sa=0;else{T=f[l>>2]|0;R=(T|0)==0?1124530:T;Z=V;while(1){N=f[Z+16>>2]|0;if((T|0)==(N|0)){sa=1;break e}W=(N|0)==0?1124530:N;if((gTb(R,W)|0)<0)ta=Z;else{if((gTb(W,R)|0)>=0){sa=1;break e}ta=Z+4|0}Z=f[ta>>2]|0;if(!Z){sa=0;break}}}while(0);bD(l);if(!sa){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,29)|0;G=374838;H=F+29|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,842);bD(l)}f[l>>2]=0;f[l+4>>2]=0;F=aD(l,15)|0;G=373671;H=F+15|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[m>>2]=0;f[m+4>>2]=0;V=aD(m,7)|0;b[V>>0]=b[373687]|0;b[V+1>>0]=b[373688]|0;b[V+2>>0]=b[373689]|0;b[V+3>>0]=b[373690]|0;b[V+4>>0]=b[373691]|0;b[V+5>>0]=b[373692]|0;b[V+6>>0]=b[373693]|0;Wwa(C,l,Fya(j,m)|0)|0;bD(m);bD(l);V=f[a+56>>2]|0;Z=V+60|0;R=f[Z>>2]|0;if((R|0)==(f[V+64>>2]|0)){Cya(V+56|0,k);break b}V=f[k>>2]|0;f[R>>2]=V;f[R+4>>2]=f[B>>2];if(!V)ua=R;else{R=V+4|0;f[R>>2]=(f[R>>2]|0)+1;ua=f[Z>>2]|0}f[Z>>2]=ua+8;break b}while(0);Dya(a,i,j);Z=(f[B>>2]|0)+8|0;bD(Z);F=aD(Z,13)|0;G=410799;H=F+13|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[l>>2]=0;f[l+4>>2]=0;Z=aD(l,4)|0;b[Z>>0]=112;b[Z+1>>0]=97;b[Z+2>>0]=100;b[Z+3>>0]=87;Z=f[I>>2]|0;do if(Z){R=f[l>>2]|0;V=(R|0)==0?1124530:R;T=Z;while(1){W=f[T+16>>2]|0;if((R|0)==(W|0))break;N=(W|0)==0?1124530:W;if((gTb(V,N)|0)<0)va=T;else{if((gTb(N,V)|0)>=0)break;va=T+4|0}T=f[va>>2]|0;if(!T){X=871;break}}if((X|0)==871){bD(l);X=880;break}f[m>>2]=0;f[m+4>>2]=0;T=aD(m,4)|0;b[T>>0]=112;b[T+1>>0]=97;b[T+2>>0]=100;b[T+3>>0]=72;T=f[I>>2]|0;if(!T){bD(m);bD(l);X=880;break}V=f[m>>2]|0;R=(V|0)==0?1124530:V;N=T;while(1){T=f[N+16>>2]|0;if((V|0)==(T|0))break;W=(T|0)==0?1124530:T;if((gTb(R,W)|0)<0)wa=N;else{if((gTb(W,R)|0)>=0)break;wa=N+4|0}N=f[wa>>2]|0;if(!N){X=873;break}}if((X|0)==873){bD(m);bD(l);X=880;break}f[o>>2]=0;f[o+4>>2]=0;N=aD(o,2)|0;b[N>>0]=100;b[N+1>>0]=87;N=f[I>>2]|0;if(!N){bD(o);bD(m);bD(l);X=880;break}R=f[o>>2]|0;V=(R|0)==0?1124530:R;W=N;while(1){N=f[W+16>>2]|0;if((R|0)==(N|0))break;T=(N|0)==0?1124530:N;if((gTb(V,T)|0)<0)xa=W;else{if((gTb(T,V)|0)>=0)break;xa=W+4|0}W=f[xa>>2]|0;if(!W){X=875;break}}if((X|0)==875){bD(o);bD(m);bD(l);X=880;break}f[q>>2]=0;f[q+4>>2]=0;W=aD(q,2)|0;b[W>>0]=100;b[W+1>>0]=72;W=f[I>>2]|0;if(!W){bD(q);bD(o);bD(m);bD(l);X=880;break}V=f[q>>2]|0;R=(V|0)==0?1124530:V;T=W;while(1){W=f[T+16>>2]|0;if((V|0)==(W|0))break;N=(W|0)==0?1124530:W;if((gTb(R,N)|0)<0)ya=T;else{if((gTb(N,R)|0)>=0)break;ya=T+4|0}T=f[ya>>2]|0;if(!T){X=877;break}}if((X|0)==877){bD(q);bD(o);bD(m);bD(l);X=880;break}f[s>>2]=0;f[s+4>>2]=0;T=aD(s,4)|0;b[T>>0]=97;b[T+1>>0]=100;b[T+2>>0]=106;b[T+3>>0]=87;T=f[I>>2]|0;if(!T){bD(s);bD(q);bD(o);bD(m);bD(l);X=880;break}R=f[s>>2]|0;V=(R|0)==0?1124530:R;N=T;while(1){T=f[N+16>>2]|0;if((R|0)==(T|0))break;W=(T|0)==0?1124530:T;if((gTb(V,W)|0)<0)za=N;else{if((gTb(W,V)|0)>=0)break;za=N+4|0}N=f[za>>2]|0;if(!N){X=879;break}}if((X|0)==879){bD(s);bD(q);bD(o);bD(m);bD(l);X=880;break}f[v>>2]=0;f[v+4>>2]=0;N=aD(v,4)|0;b[N>>0]=97;b[N+1>>0]=100;b[N+2>>0]=106;b[N+3>>0]=72;N=f[I>>2]|0;f:do if(!N)Aa=0;else{V=f[v>>2]|0;R=(V|0)==0?1124530:V;W=N;while(1){T=f[W+16>>2]|0;if((V|0)==(T|0))break;Ba=(T|0)==0?1124530:T;if((gTb(R,Ba)|0)<0)Ca=W;else{if((gTb(Ba,R)|0)>=0)break;Ca=W+4|0}W=f[Ca>>2]|0;if(!W){Aa=0;break f}}f[w>>2]=0;f[w+4>>2]=0;W=aD(w,2)|0;b[W>>0]=107;b[W+1>>0]=87;W=f[I>>2]|0;g:do if(!W)Da=0;else{R=f[w>>2]|0;V=(R|0)==0?1124530:R;Ba=W;while(1){T=f[Ba+16>>2]|0;if((R|0)==(T|0))break;Ea=(T|0)==0?1124530:T;if((gTb(V,Ea)|0)<0)Fa=Ba;else{if((gTb(Ea,V)|0)>=0)break;Fa=Ba+4|0}Ba=f[Fa>>2]|0;if(!Ba){Da=0;break g}}f[x>>2]=0;f[x+4>>2]=0;Ba=aD(x,2)|0;b[Ba>>0]=107;b[Ba+1>>0]=72;Ba=f[I>>2]|0;h:do if(!Ba)Ga=0;else{V=f[x>>2]|0;R=(V|0)==0?1124530:V;Ea=Ba;while(1){T=f[Ea+16>>2]|0;if((V|0)==(T|0))break;Ha=(T|0)==0?1124530:T;if((gTb(R,Ha)|0)<0)Ia=Ea;else{if((gTb(Ha,R)|0)>=0)break;Ia=Ea+4|0}Ea=f[Ia>>2]|0;if(!Ea){Ga=0;break h}}f[y>>2]=0;f[y+4>>2]=0;F=aD(y,12)|0;G=373566;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Ea=f[I>>2]|0;i:do if(!Ea)Ja=0;else{R=f[y>>2]|0;V=(R|0)==0?1124530:R;Ha=Ea;while(1){T=f[Ha+16>>2]|0;if((R|0)==(T|0)){Ja=1;break i}Ka=(T|0)==0?1124530:T;if((gTb(V,Ka)|0)<0)La=Ha;else{if((gTb(Ka,V)|0)>=0){Ja=1;break i}La=Ha+4|0}Ha=f[La>>2]|0;if(!Ha){Ja=0;break}}}while(0);bD(y);Ga=Ja}while(0);bD(x);Da=Ga}while(0);bD(w);Aa=Da}while(0);bD(v);bD(s);bD(q);bD(o);bD(m);bD(l);if(!Aa)X=880}else{bD(l);X=880}while(0);if((X|0)==880){f[l>>2]=0;f[l+4>>2]=0;Vac(aD(l,241)|0,374576,241)|0;bO(-215,l,373550,373222,818);bD(l)}f[l>>2]=0;f[l+4>>2]=0;Z=aD(l,8)|0;N=Z;b[N>>0]=107;b[N+1>>0]=101;b[N+2>>0]=114;b[N+3>>0]=110;N=Z+4|0;b[N>>0]=101;b[N+1>>0]=108;b[N+2>>0]=95;b[N+3>>0]=119;f[o>>2]=0;f[o+4>>2]=0;N=aD(o,2)|0;b[N>>0]=107;b[N+1>>0]=87;N=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=N;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;N=aD(l,8)|0;Z=N;b[Z>>0]=107;b[Z+1>>0]=101;b[Z+2>>0]=114;b[Z+3>>0]=110;Z=N+4|0;b[Z>>0]=101;b[Z+1>>0]=108;b[Z+2>>0]=95;b[Z+3>>0]=104;f[o>>2]=0;f[o+4>>2]=0;Z=aD(o,2)|0;b[Z>>0]=107;b[Z+1>>0]=72;Z=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=Z;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;Z=aD(l,5)|0;b[Z>>0]=b[374519]|0;b[Z+1>>0]=b[374520]|0;b[Z+2>>0]=b[374521]|0;b[Z+3>>0]=b[374522]|0;b[Z+4>>0]=b[374523]|0;f[o>>2]=0;f[o+4>>2]=0;Z=aD(o,4)|0;b[Z>>0]=112;b[Z+1>>0]=97;b[Z+2>>0]=100;b[Z+3>>0]=87;Z=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=Z;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;Z=aD(l,5)|0;b[Z>>0]=b[374525]|0;b[Z+1>>0]=b[374526]|0;b[Z+2>>0]=b[374527]|0;b[Z+3>>0]=b[374528]|0;b[Z+4>>0]=b[374529]|0;f[o>>2]=0;f[o+4>>2]=0;Z=aD(o,4)|0;b[Z>>0]=112;b[Z+1>>0]=97;b[Z+2>>0]=100;b[Z+3>>0]=72;Z=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=Z;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;Z=aD(l,8)|0;N=Z;b[N>>0]=115;b[N+1>>0]=116;b[N+2>>0]=114;b[N+3>>0]=105;N=Z+4|0;b[N>>0]=100;b[N+1>>0]=101;b[N+2>>0]=95;b[N+3>>0]=119;f[o>>2]=0;f[o+4>>2]=0;N=aD(o,2)|0;b[N>>0]=100;b[N+1>>0]=87;N=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=N;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;N=aD(l,8)|0;Z=N;b[Z>>0]=115;b[Z+1>>0]=116;b[Z+2>>0]=114;b[Z+3>>0]=105;Z=N+4|0;b[Z>>0]=100;b[Z+1>>0]=101;b[Z+2>>0]=95;b[Z+3>>0]=104;f[o>>2]=0;f[o+4>>2]=0;Z=aD(o,2)|0;b[Z>>0]=100;b[Z+1>>0]=72;Z=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=Z;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;Z=aD(l,5)|0;b[Z>>0]=b[414591]|0;b[Z+1>>0]=b[414592]|0;b[Z+2>>0]=b[414593]|0;b[Z+3>>0]=b[414594]|0;b[Z+4>>0]=b[414595]|0;f[o>>2]=0;f[o+4>>2]=0;Z=aD(o,4)|0;b[Z>>0]=97;b[Z+1>>0]=100;b[Z+2>>0]=106;b[Z+3>>0]=87;Z=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=Z;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;Z=aD(l,5)|0;b[Z>>0]=b[414585]|0;b[Z+1>>0]=b[414586]|0;b[Z+2>>0]=b[414587]|0;b[Z+3>>0]=b[414588]|0;b[Z+4>>0]=b[414589]|0;f[o>>2]=0;f[o+4>>2]=0;Z=aD(o,4)|0;b[Z>>0]=97;b[Z+1>>0]=100;b[Z+2>>0]=106;b[Z+3>>0]=72;Z=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=Z;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;F=aD(l,10)|0;G=424460;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=aD(o,12)|0;G=373566;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Z=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=Z;Wwa(C,l,m)|0;bD(o);bD(l);Z=D+28|0;f[l>>2]=0;f[l+4>>2]=0;N=aD(l,6)|0;b[N>>0]=b[373514]|0;b[N+1>>0]=b[373515]|0;b[N+2>>0]=b[373516]|0;b[N+3>>0]=b[373517]|0;b[N+4>>0]=b[373518]|0;b[N+5>>0]=b[373519]|0;N=Fya(j,l)|0;W=N+4|0;Ba=D+32|0;Ea=f[Ba>>2]|0;Ha=D+36|0;if((Ea|0)==(f[Ha>>2]|0))v2(Z,W);else{f[Ea>>2]=f[W>>2];V=Ea+4|0;R=N+8|0;f[V>>2]=f[R>>2];Ka=Ea+8|0;f[Ka>>2]=f[N+12>>2];f[Ea+12>>2]=f[N+16>>2];f[Ea+16>>2]=f[N+20>>2];f[Ea+20>>2]=f[N+24>>2];f[Ea+24>>2]=f[N+28>>2];f[Ea+28>>2]=f[N+32>>2];f[Ea+32>>2]=f[N+36>>2];T=f[N+40>>2]|0;f[Ea+36>>2]=T;f[Ea+40>>2]=Ka;Ka=Ea+48|0;Ma=Ea+44|0;f[Ma>>2]=Ka;f[Ka>>2]=0;f[Ea+52>>2]=0;if(T|0){Ka=T+12|0;f[Ka>>2]=(f[Ka>>2]|0)+1}if((f[R>>2]|0)<3){R=f[N+48>>2]|0;N=f[Ma>>2]|0;f[N>>2]=f[R>>2];f[N+4>>2]=f[R+4>>2]}else{f[V>>2]=0;jL(Ea,W)}f[Ba>>2]=(f[Ba>>2]|0)+56}bD(l);f[m>>2]=0;f[m+4>>2]=0;W=aD(m,4)|0;b[W>>0]=98;b[W+1>>0]=105;b[W+2>>0]=97;b[W+3>>0]=115;W=f[L>>2]|0;j:do if(!W)Na=0;else{Ea=f[m>>2]|0;V=(Ea|0)==0?1124530:Ea;R=W;while(1){N=f[R+16>>2]|0;if((Ea|0)==(N|0)){Na=1;break j}Ma=(N|0)==0?1124530:N;if((gTb(V,Ma)|0)<0)Oa=R;else{if((gTb(Ma,V)|0)>=0){Na=1;break j}Oa=R+4|0}R=f[Oa>>2]|0;if(!R){Na=0;break}}}while(0);bD(m);b[l>>0]=Na;f[m>>2]=0;f[m+4>>2]=0;F=aD(m,9)|0;G=434144;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));$wa(C,m,l)|0;bD(m);if(b[l>>0]|0){f[m>>2]=0;f[m+4>>2]=0;W=aD(m,4)|0;b[W>>0]=98;b[W+1>>0]=105;b[W+2>>0]=97;b[W+3>>0]=115;W=Fya(j,m)|0;R=W+4|0;V=f[Ba>>2]|0;if((V|0)==(f[Ha>>2]|0))v2(Z,R);else{f[V>>2]=f[R>>2];Ea=V+4|0;Ma=W+8|0;f[Ea>>2]=f[Ma>>2];N=V+8|0;f[N>>2]=f[W+12>>2];f[V+12>>2]=f[W+16>>2];f[V+16>>2]=f[W+20>>2];f[V+20>>2]=f[W+24>>2];f[V+24>>2]=f[W+28>>2];f[V+28>>2]=f[W+32>>2];f[V+32>>2]=f[W+36>>2];Ka=f[W+40>>2]|0;f[V+36>>2]=Ka;f[V+40>>2]=N;N=V+48|0;T=V+44|0;f[T>>2]=N;f[N>>2]=0;f[V+52>>2]=0;if(Ka|0){N=Ka+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[Ma>>2]|0)<3){Ma=f[W+48>>2]|0;W=f[T>>2]|0;f[W>>2]=f[Ma>>2];f[W+4>>2]=f[Ma+4>>2]}else{f[Ea>>2]=0;jL(V,R)}f[Ba>>2]=(f[Ba>>2]|0)+56}bD(m)}R=f[a+56>>2]|0;V=R+60|0;Ea=f[V>>2]|0;if((Ea|0)==(f[R+64>>2]|0))Cya(R+56|0,k);else{R=f[k>>2]|0;f[Ea>>2]=R;f[Ea+4>>2]=f[B>>2];if(!R)Pa=Ea;else{Ea=R+4|0;f[Ea>>2]=(f[Ea>>2]|0)+1;Pa=f[V>>2]|0}f[V>>2]=Pa+8}break b}while(0);Dya(a,i,j);V=(f[B>>2]|0)+8|0;bD(V);F=aD(V,11)|0;G=411994;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[l>>2]=0;f[l+4>>2]=0;V=aD(l,4)|0;b[V>>0]=112;b[V+1>>0]=97;b[V+2>>0]=100;b[V+3>>0]=87;V=f[I>>2]|0;do if(V){Ea=f[l>>2]|0;R=(Ea|0)==0?1124530:Ea;Ma=V;while(1){W=f[Ma+16>>2]|0;if((Ea|0)==(W|0))break;T=(W|0)==0?1124530:W;if((gTb(R,T)|0)<0)Qa=Ma;else{if((gTb(T,R)|0)>=0)break;Qa=Ma+4|0}Ma=f[Qa>>2]|0;if(!Ma){X=750;break}}if((X|0)==750){bD(l);X=759;break}f[m>>2]=0;f[m+4>>2]=0;Ma=aD(m,4)|0;b[Ma>>0]=112;b[Ma+1>>0]=97;b[Ma+2>>0]=100;b[Ma+3>>0]=72;Ma=f[I>>2]|0;if(!Ma){bD(m);bD(l);X=759;break}R=f[m>>2]|0;Ea=(R|0)==0?1124530:R;Ba=Ma;while(1){Ma=f[Ba+16>>2]|0;if((R|0)==(Ma|0))break;Z=(Ma|0)==0?1124530:Ma;if((gTb(Ea,Z)|0)<0)Ra=Ba;else{if((gTb(Z,Ea)|0)>=0)break;Ra=Ba+4|0}Ba=f[Ra>>2]|0;if(!Ba){X=752;break}}if((X|0)==752){bD(m);bD(l);X=759;break}f[o>>2]=0;f[o+4>>2]=0;Ba=aD(o,2)|0;b[Ba>>0]=100;b[Ba+1>>0]=87;Ba=f[I>>2]|0;if(!Ba){bD(o);bD(m);bD(l);X=759;break}Ea=f[o>>2]|0;R=(Ea|0)==0?1124530:Ea;Z=Ba;while(1){Ba=f[Z+16>>2]|0;if((Ea|0)==(Ba|0))break;Ma=(Ba|0)==0?1124530:Ba;if((gTb(R,Ma)|0)<0)Sa=Z;else{if((gTb(Ma,R)|0)>=0)break;Sa=Z+4|0}Z=f[Sa>>2]|0;if(!Z){X=754;break}}if((X|0)==754){bD(o);bD(m);bD(l);X=759;break}f[q>>2]=0;f[q+4>>2]=0;Z=aD(q,2)|0;b[Z>>0]=100;b[Z+1>>0]=72;Z=f[I>>2]|0;if(!Z){bD(q);bD(o);bD(m);bD(l);X=759;break}R=f[q>>2]|0;Ea=(R|0)==0?1124530:R;Ma=Z;while(1){Z=f[Ma+16>>2]|0;if((R|0)==(Z|0))break;Ba=(Z|0)==0?1124530:Z;if((gTb(Ea,Ba)|0)<0)Ta=Ma;else{if((gTb(Ba,Ea)|0)>=0)break;Ta=Ma+4|0}Ma=f[Ta>>2]|0;if(!Ma){X=756;break}}if((X|0)==756){bD(q);bD(o);bD(m);bD(l);X=759;break}f[s>>2]=0;f[s+4>>2]=0;F=aD(s,9)|0;G=374247;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Ma=f[I>>2]|0;if(!Ma){bD(s);bD(q);bD(o);bD(m);bD(l);X=759;break}Ea=f[s>>2]|0;R=(Ea|0)==0?1124530:Ea;Ba=Ma;while(1){Ma=f[Ba+16>>2]|0;if((Ea|0)==(Ma|0))break;Z=(Ma|0)==0?1124530:Ma;if((gTb(R,Z)|0)<0)Ua=Ba;else{if((gTb(Z,R)|0)>=0)break;Ua=Ba+4|0}Ba=f[Ua>>2]|0;if(!Ba){X=758;break}}if((X|0)==758){bD(s);bD(q);bD(o);bD(m);bD(l);X=759;break}f[v>>2]=0;f[v+4>>2]=0;F=aD(v,9)|0;G=374257;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Ba=f[I>>2]|0;k:do if(!Ba)Va=0;else{R=f[v>>2]|0;Ea=(R|0)==0?1124530:R;Z=Ba;while(1){Ma=f[Z+16>>2]|0;if((R|0)==(Ma|0))break;Ha=(Ma|0)==0?1124530:Ma;if((gTb(Ea,Ha)|0)<0)Wa=Z;else{if((gTb(Ha,Ea)|0)>=0)break;Wa=Z+4|0}Z=f[Wa>>2]|0;if(!Z){Va=0;break k}}f[w>>2]=0;f[w+4>>2]=0;Z=aD(w,2)|0;b[Z>>0]=107;b[Z+1>>0]=87;Z=f[I>>2]|0;l:do if(!Z)Xa=0;else{Ea=f[w>>2]|0;R=(Ea|0)==0?1124530:Ea;Ha=Z;while(1){Ma=f[Ha+16>>2]|0;if((Ea|0)==(Ma|0))break;T=(Ma|0)==0?1124530:Ma;if((gTb(R,T)|0)<0)Ya=Ha;else{if((gTb(T,R)|0)>=0)break;Ya=Ha+4|0}Ha=f[Ya>>2]|0;if(!Ha){Xa=0;break l}}f[x>>2]=0;f[x+4>>2]=0;Ha=aD(x,2)|0;b[Ha>>0]=107;b[Ha+1>>0]=72;Ha=f[I>>2]|0;m:do if(!Ha)Za=0;else{R=f[x>>2]|0;Ea=(R|0)==0?1124530:R;T=Ha;while(1){Ma=f[T+16>>2]|0;if((R|0)==(Ma|0))break;W=(Ma|0)==0?1124530:Ma;if((gTb(Ea,W)|0)<0)_a=T;else{if((gTb(W,Ea)|0)>=0)break;_a=T+4|0}T=f[_a>>2]|0;if(!T){Za=0;break m}}f[y>>2]=0;f[y+4>>2]=0;F=aD(y,12)|0;G=373566;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));T=f[I>>2]|0;n:do if(!T)$a=0;else{Ea=f[y>>2]|0;R=(Ea|0)==0?1124530:Ea;W=T;while(1){Ma=f[W+16>>2]|0;if((Ea|0)==(Ma|0)){$a=1;break n}N=(Ma|0)==0?1124530:Ma;if((gTb(R,N)|0)<0)ab=W;else{if((gTb(N,R)|0)>=0){$a=1;break n}ab=W+4|0}W=f[ab>>2]|0;if(!W){$a=0;break}}}while(0);bD(y);Za=$a}while(0);bD(x);Xa=Za}while(0);bD(w);Va=Xa}while(0);bD(v);bD(s);bD(q);bD(o);bD(m);bD(l);if(!Va)X=759}else{bD(l);X=759}while(0);if((X|0)==759){f[l>>2]=0;f[l+4>>2]=0;Vac(aD(l,251)|0,374267,251)|0;bO(-215,l,373550,373222,785);bD(l)}f[l>>2]=0;f[l+4>>2]=0;V=aD(l,8)|0;Ba=V;b[Ba>>0]=107;b[Ba+1>>0]=101;b[Ba+2>>0]=114;b[Ba+3>>0]=110;Ba=V+4|0;b[Ba>>0]=101;b[Ba+1>>0]=108;b[Ba+2>>0]=95;b[Ba+3>>0]=119;f[o>>2]=0;f[o+4>>2]=0;Ba=aD(o,2)|0;b[Ba>>0]=107;b[Ba+1>>0]=87;Ba=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=Ba;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;Ba=aD(l,8)|0;V=Ba;b[V>>0]=107;b[V+1>>0]=101;b[V+2>>0]=114;b[V+3>>0]=110;V=Ba+4|0;b[V>>0]=101;b[V+1>>0]=108;b[V+2>>0]=95;b[V+3>>0]=104;f[o>>2]=0;f[o+4>>2]=0;V=aD(o,2)|0;b[V>>0]=107;b[V+1>>0]=72;V=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=V;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;V=aD(l,5)|0;b[V>>0]=b[374519]|0;b[V+1>>0]=b[374520]|0;b[V+2>>0]=b[374521]|0;b[V+3>>0]=b[374522]|0;b[V+4>>0]=b[374523]|0;f[o>>2]=0;f[o+4>>2]=0;V=aD(o,4)|0;b[V>>0]=112;b[V+1>>0]=97;b[V+2>>0]=100;b[V+3>>0]=87;V=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=V;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;V=aD(l,5)|0;b[V>>0]=b[374525]|0;b[V+1>>0]=b[374526]|0;b[V+2>>0]=b[374527]|0;b[V+3>>0]=b[374528]|0;b[V+4>>0]=b[374529]|0;f[o>>2]=0;f[o+4>>2]=0;V=aD(o,4)|0;b[V>>0]=112;b[V+1>>0]=97;b[V+2>>0]=100;b[V+3>>0]=72;V=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=V;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;V=aD(l,8)|0;Ba=V;b[Ba>>0]=115;b[Ba+1>>0]=116;b[Ba+2>>0]=114;b[Ba+3>>0]=105;Ba=V+4|0;b[Ba>>0]=100;b[Ba+1>>0]=101;b[Ba+2>>0]=95;b[Ba+3>>0]=119;f[o>>2]=0;f[o+4>>2]=0;Ba=aD(o,2)|0;b[Ba>>0]=100;b[Ba+1>>0]=87;Ba=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=Ba;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;Ba=aD(l,8)|0;V=Ba;b[V>>0]=115;b[V+1>>0]=116;b[V+2>>0]=114;b[V+3>>0]=105;V=Ba+4|0;b[V>>0]=100;b[V+1>>0]=101;b[V+2>>0]=95;b[V+3>>0]=104;f[o>>2]=0;f[o+4>>2]=0;V=aD(o,2)|0;b[V>>0]=100;b[V+1>>0]=72;V=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=V;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;F=aD(l,10)|0;G=374531;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=aD(o,9)|0;G=374247;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));V=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=V;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;F=aD(l,10)|0;G=374542;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=aD(o,9)|0;G=374257;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));V=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=V;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;F=aD(l,10)|0;G=424460;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=aD(o,12)|0;G=373566;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));V=~~+Hya(Eya(i,o)|0,-1);f[m>>2]=V;Wwa(C,l,m)|0;bD(o);bD(l);V=D+28|0;f[l>>2]=0;f[l+4>>2]=0;Ba=aD(l,6)|0;b[Ba>>0]=b[373514]|0;b[Ba+1>>0]=b[373515]|0;b[Ba+2>>0]=b[373516]|0;b[Ba+3>>0]=b[373517]|0;b[Ba+4>>0]=b[373518]|0;b[Ba+5>>0]=b[373519]|0;Ba=Fya(j,l)|0;Z=Ba+4|0;Ha=D+32|0;T=f[Ha>>2]|0;W=D+36|0;if((T|0)==(f[W>>2]|0))v2(V,Z);else{f[T>>2]=f[Z>>2];R=T+4|0;Ea=Ba+8|0;f[R>>2]=f[Ea>>2];N=T+8|0;f[N>>2]=f[Ba+12>>2];f[T+12>>2]=f[Ba+16>>2];f[T+16>>2]=f[Ba+20>>2];f[T+20>>2]=f[Ba+24>>2];f[T+24>>2]=f[Ba+28>>2];f[T+28>>2]=f[Ba+32>>2];f[T+32>>2]=f[Ba+36>>2];Ma=f[Ba+40>>2]|0;f[T+36>>2]=Ma;f[T+40>>2]=N;N=T+48|0;Ka=T+44|0;f[Ka>>2]=N;f[N>>2]=0;f[T+52>>2]=0;if(Ma|0){N=Ma+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[Ea>>2]|0)<3){Ea=f[Ba+48>>2]|0;Ba=f[Ka>>2]|0;f[Ba>>2]=f[Ea>>2];f[Ba+4>>2]=f[Ea+4>>2]}else{f[R>>2]=0;jL(T,Z)}f[Ha>>2]=(f[Ha>>2]|0)+56}bD(l);f[m>>2]=0;f[m+4>>2]=0;Z=aD(m,4)|0;b[Z>>0]=98;b[Z+1>>0]=105;b[Z+2>>0]=97;b[Z+3>>0]=115;Z=f[L>>2]|0;o:do if(!Z)bb=0;else{T=f[m>>2]|0;R=(T|0)==0?1124530:T;Ea=Z;while(1){Ba=f[Ea+16>>2]|0;if((T|0)==(Ba|0)){bb=1;break o}Ka=(Ba|0)==0?1124530:Ba;if((gTb(R,Ka)|0)<0)cb=Ea;else{if((gTb(Ka,R)|0)>=0){bb=1;break o}cb=Ea+4|0}Ea=f[cb>>2]|0;if(!Ea){bb=0;break}}}while(0);bD(m);b[l>>0]=bb;f[m>>2]=0;f[m+4>>2]=0;F=aD(m,9)|0;G=434144;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));$wa(C,m,l)|0;bD(m);if(b[l>>0]|0){f[m>>2]=0;f[m+4>>2]=0;Z=aD(m,4)|0;b[Z>>0]=98;b[Z+1>>0]=105;b[Z+2>>0]=97;b[Z+3>>0]=115;Z=Fya(j,m)|0;Ea=Z+4|0;R=f[Ha>>2]|0;if((R|0)==(f[W>>2]|0))v2(V,Ea);else{f[R>>2]=f[Ea>>2];T=R+4|0;Ka=Z+8|0;f[T>>2]=f[Ka>>2];Ba=R+8|0;f[Ba>>2]=f[Z+12>>2];f[R+12>>2]=f[Z+16>>2];f[R+16>>2]=f[Z+20>>2];f[R+20>>2]=f[Z+24>>2];f[R+24>>2]=f[Z+28>>2];f[R+28>>2]=f[Z+32>>2];f[R+32>>2]=f[Z+36>>2];N=f[Z+40>>2]|0;f[R+36>>2]=N;f[R+40>>2]=Ba;Ba=R+48|0;Ma=R+44|0;f[Ma>>2]=Ba;f[Ba>>2]=0;f[R+52>>2]=0;if(N|0){Ba=N+12|0;f[Ba>>2]=(f[Ba>>2]|0)+1}if((f[Ka>>2]|0)<3){Ka=f[Z+48>>2]|0;Z=f[Ma>>2]|0;f[Z>>2]=f[Ka>>2];f[Z+4>>2]=f[Ka+4>>2]}else{f[T>>2]=0;jL(R,Ea)}f[Ha>>2]=(f[Ha>>2]|0)+56}bD(m)}Ea=f[a+56>>2]|0;R=Ea+60|0;T=f[R>>2]|0;if((T|0)==(f[Ea+64>>2]|0))Cya(Ea+56|0,k);else{Ea=f[k>>2]|0;f[T>>2]=Ea;f[T+4>>2]=f[B>>2];if(!Ea)db=T;else{T=Ea+4|0;f[T>>2]=(f[T>>2]|0)+1;db=f[R>>2]|0}f[R>>2]=db+8}break b}while(0);R=f[a+56>>2]|0;T=R+60|0;Ea=f[T>>2]|0;if((Ea|0)==(f[R+64>>2]|0))Cya(R+56|0,k);else{R=f[k>>2]|0;f[Ea>>2]=R;f[Ea+4>>2]=f[B>>2];if(!R)eb=Ea;else{Ea=R+4|0;f[Ea>>2]=(f[Ea>>2]|0)+1;eb=f[T>>2]|0}f[T>>2]=eb+8}tya(a);break b}while(0);Dya(a,i,j);T=(f[B>>2]|0)+8|0;bD(T);Ea=aD(T,7)|0;b[Ea>>0]=b[410993]|0;b[Ea+1>>0]=b[410994]|0;b[Ea+2>>0]=b[410995]|0;b[Ea+3>>0]=b[410996]|0;b[Ea+4>>0]=b[410997]|0;b[Ea+5>>0]=b[410998]|0;b[Ea+6>>0]=b[410999]|0;f[l>>2]=0;f[l+4>>2]=0;Ea=aD(l,3)|0;b[Ea>>0]=b[418063]|0;b[Ea+1>>0]=b[418064]|0;b[Ea+2>>0]=b[418065]|0;Ea=f[I>>2]|0;do if(Ea){T=f[l>>2]|0;R=(T|0)==0?1124530:T;Ka=Ea;while(1){Z=f[Ka+16>>2]|0;if((T|0)==(Z|0))break;Ma=(Z|0)==0?1124530:Z;if((gTb(R,Ma)|0)<0)fb=Ka;else{if((gTb(Ma,R)|0)>=0)break;fb=Ka+4|0}Ka=f[fb>>2]|0;if(!Ka){X=604;break}}if((X|0)==604){bD(l);X=607;break}f[m>>2]=0;f[m+4>>2]=0;Ka=aD(m,3)|0;b[Ka>>0]=b[429349]|0;b[Ka+1>>0]=b[429350]|0;b[Ka+2>>0]=b[429351]|0;Ka=f[I>>2]|0;if(!Ka){bD(m);bD(l);X=607;break}R=f[m>>2]|0;T=(R|0)==0?1124530:R;Ma=Ka;while(1){Ka=f[Ma+16>>2]|0;if((R|0)==(Ka|0)){X=608;break}Z=(Ka|0)==0?1124530:Ka;if((gTb(T,Z)|0)<0)gb=Ma;else{if((gTb(Z,T)|0)>=0){X=602;break}gb=Ma+4|0}Ma=f[gb>>2]|0;if(!Ma){X=606;break}}if((X|0)==602){bD(m);bD(l);break}else if((X|0)==606){bD(m);bD(l);X=607;break}else if((X|0)==608){bD(m);bD(l);break}}else{bD(l);X=607}while(0);if((X|0)==607){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,50)|0;G=374105;H=F+50|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,746);bD(l)}f[l>>2]=0;f[l+4>>2]=0;Ea=aD(l,5)|0;b[Ea>>0]=b[374156]|0;b[Ea+1>>0]=b[374157]|0;b[Ea+2>>0]=b[374158]|0;b[Ea+3>>0]=b[374159]|0;b[Ea+4>>0]=b[374160]|0;Ea=f[I>>2]|0;do if(!Ea)bD(l);else{Ma=f[l>>2]|0;T=(Ma|0)==0?1124530:Ma;R=Ea;while(1){Z=f[R+16>>2]|0;if((Ma|0)==(Z|0))break;Ka=(Z|0)==0?1124530:Z;if((gTb(T,Ka)|0)<0)hb=R;else{if((gTb(Ka,T)|0)>=0)break;hb=R+4|0}R=f[hb>>2]|0;if(!R){X=620;break}}if((X|0)==620){bD(l);break}f[m>>2]=0;f[m+4>>2]=0;R=aD(m,5)|0;b[R>>0]=b[374156]|0;b[R+1>>0]=b[374157]|0;b[R+2>>0]=b[374158]|0;b[R+3>>0]=b[374159]|0;b[R+4>>0]=b[374160]|0;R=Gwa(Eya(i,m)|0,-1)|0;bD(m);bD(l);if((R|0)==1)break;f[l>>2]=0;f[l+4>>2]=0;F=aD(l,38)|0;G=374162;H=F+38|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-213,l,373550,373222,748);bD(l)}while(0);f[l>>2]=0;f[l+4>>2]=0;Ea=aD(l,5)|0;b[Ea>>0]=b[471917]|0;b[Ea+1>>0]=b[471918]|0;b[Ea+2>>0]=b[471919]|0;b[Ea+3>>0]=b[471920]|0;b[Ea+4>>0]=b[471921]|0;Ea=f[I>>2]|0;do if(!Ea)bD(l);else{R=f[l>>2]|0;T=(R|0)==0?1124530:R;Ma=Ea;while(1){Ka=f[Ma+16>>2]|0;if((R|0)==(Ka|0)){X=629;break}Z=(Ka|0)==0?1124530:Ka;if((gTb(T,Z)|0)<0)ib=Ma;else{if((gTb(Z,T)|0)>=0){X=630;break}ib=Ma+4|0}Ma=f[ib>>2]|0;if(!Ma){X=633;break}}if((X|0)==629)bD(l);else if((X|0)==630)bD(l);else if((X|0)==633){bD(l);break}f[l>>2]=0;f[l+4>>2]=0;Ma=aD(l,5)|0;b[Ma>>0]=b[471917]|0;b[Ma+1>>0]=b[471918]|0;b[Ma+2>>0]=b[471919]|0;b[Ma+3>>0]=b[471920]|0;b[Ma+4>>0]=b[471921]|0;f[o>>2]=0;f[o+4>>2]=0;Ma=aD(o,5)|0;b[Ma>>0]=b[471917]|0;b[Ma+1>>0]=b[471918]|0;b[Ma+2>>0]=b[471919]|0;b[Ma+3>>0]=b[471920]|0;b[Ma+4>>0]=b[471921]|0;ga=+Hya(Eya(i,o)|0,-1);n[m>>2]=ga;Zwa(C,l,m)|0;bD(o);bD(l)}while(0);f[l>>2]=0;f[l+4>>2]=0;F=aD(l,9)|0;G=374201;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Ea=f[I>>2]|0;do if(!Ea)bD(l);else{Ma=f[l>>2]|0;T=(Ma|0)==0?1124530:Ma;R=Ea;while(1){Z=f[R+16>>2]|0;if((Ma|0)==(Z|0)){X=642;break}Ka=(Z|0)==0?1124530:Z;if((gTb(T,Ka)|0)<0)jb=R;else{if((gTb(Ka,T)|0)>=0){X=643;break}jb=R+4|0}R=f[jb>>2]|0;if(!R){X=646;break}}if((X|0)==642)bD(l);else if((X|0)==643)bD(l);else if((X|0)==646){bD(l);break}f[l>>2]=0;f[l+4>>2]=0;F=aD(l,10)|0;G=418554;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=aD(o,9)|0;G=374201;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));R=Gwa(Eya(i,o)|0,-1)|0;f[m>>2]=R;Wwa(C,l,m)|0;bD(o);bD(l)}while(0);f[l>>2]=0;f[l+4>>2]=0;Ea=aD(l,3)|0;b[Ea>>0]=b[429349]|0;b[Ea+1>>0]=b[429350]|0;b[Ea+2>>0]=b[429351]|0;Ea=Gwa(Eya(i,l)|0,-1)|0;bD(l);f[l>>2]=0;f[l+4>>2]=0;R=aD(l,3)|0;b[R>>0]=b[418063]|0;b[R+1>>0]=b[418064]|0;b[R+2>>0]=b[418065]|0;R=Gwa(Eya(i,l)|0,-1)|0;bD(l);T=Ea<<1;f[l>>2]=0;Ma=l+4|0;f[Ma>>2]=0;f[l+8>>2]=0;if(T>>>0>1073741823)c4b(l);Ka=Ea<<3;Ea=L5b(Ka)|0;f[l>>2]=Ea;Z=Ea+(T<<2)|0;f[l+8>>2]=Z;Nac(Ea|0,0,Ka|0)|0;f[Ma>>2]=Z;Z=(R|0)>0;f[Ea+((Z?-1:-2)+T<<2)>>2]=Z?R:0-R|0;f[m>>2]=0;f[m+4>>2]=0;R=aD(m,8)|0;Z=R;b[Z>>0]=112;b[Z+1>>0]=97;b[Z+2>>0]=100;b[Z+3>>0]=100;Z=R+4|0;b[Z>>0]=105;b[Z+1>>0]=110;b[Z+2>>0]=103;b[Z+3>>0]=115;Z=f[l>>2]|0;R=(f[Ma>>2]|0)-Z|0;T=R>>2;Ea=L5b(16)|0;Ka=Ea+8|0;f[Ea>>2]=Ka;f[Ea+4>>2]=T;if(T>>>0>1){Ba=N5b(T>>>0>536870911?-1:T<<3)|0;f[Ea>>2]=Ba;kb=Ba}else kb=Ka;f[o>>2]=0;f[o+4>>2]=Ea;if((R|0)>0){R=Z;Z=0;while(1){Ea=f[R>>2]|0;Ka=kb+(Z<<3)|0;f[Ka>>2]=Ea;f[Ka+4>>2]=((Ea|0)<0)<<31>>31;Z=Z+1|0;if((Z|0)==(T|0))break;else R=R+4|0}}nxa(C,m,o)|0;gua(o);bD(m);R=f[a+56>>2]|0;T=R+60|0;Z=f[T>>2]|0;if((Z|0)==(f[R+64>>2]|0))Cya(R+56|0,k);else{R=f[k>>2]|0;f[Z>>2]=R;f[Z+4>>2]=f[B>>2];if(!R)lb=Z;else{Z=R+4|0;f[Z>>2]=(f[Z>>2]|0)+1;lb=f[T>>2]|0}f[T>>2]=lb+8}T=f[l>>2]|0;if(T|0){Z=f[Ma>>2]|0;if((Z|0)!=(T|0))f[Ma>>2]=Z+(~((Z+-4-T|0)>>>2)<<2);O5b(T)}break b}while(0);Dya(a,i,j);f[l>>2]=0;f[l+4>>2]=0;T=aD(l,1)|0;b[T>>0]=112;T=f[I>>2]|0;do if(T){Z=f[l>>2]|0;R=(Z|0)==0?1124530:Z;Ea=T;while(1){Ka=f[Ea+16>>2]|0;if((Z|0)==(Ka|0)){X=561;break}Ba=(Ka|0)==0?1124530:Ka;if((gTb(R,Ba)|0)<0)mb=Ea;else{if((gTb(Ba,R)|0)>=0){X=565;break}mb=Ea+4|0}Ea=f[mb>>2]|0;if(!Ea){X=563;break}}if((X|0)==561){bD(l);break}else if((X|0)==563){bD(l);X=564;break}else if((X|0)==565){bD(l);break}}else{bD(l);X=564}while(0);if((X|0)==564){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,21)|0;G=374059;H=F+21|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,732);bD(l)}f[l>>2]=0;f[l+4>>2]=0;T=aD(l,1)|0;b[T>>0]=112;f[o>>2]=0;f[o+4>>2]=0;T=aD(o,1)|0;b[T>>0]=112;ga=+Hya(Eya(i,o)|0,-1);n[m>>2]=ga;Zwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;T=aD(l,3)|0;b[T>>0]=b[433709]|0;b[T+1>>0]=b[433710]|0;b[T+2>>0]=b[433711]|0;T=f[I>>2]|0;do if(!T)bD(l);else{Ea=f[l>>2]|0;R=(Ea|0)==0?1124530:Ea;Z=T;while(1){Ma=f[Z+16>>2]|0;if((Ea|0)==(Ma|0)){X=574;break}Ba=(Ma|0)==0?1124530:Ma;if((gTb(R,Ba)|0)<0)nb=Z;else{if((gTb(Ba,R)|0)>=0){X=575;break}nb=Z+4|0}Z=f[nb>>2]|0;if(!Z){X=578;break}}if((X|0)==574)bD(l);else if((X|0)==575)bD(l);else if((X|0)==578){bD(l);break}f[l>>2]=0;f[l+4>>2]=0;Z=aD(l,3)|0;b[Z>>0]=b[433709]|0;b[Z+1>>0]=b[433710]|0;b[Z+2>>0]=b[433711]|0;f[o>>2]=0;f[o+4>>2]=0;Z=aD(o,3)|0;b[Z>>0]=b[433709]|0;b[Z+1>>0]=b[433710]|0;b[Z+2>>0]=b[433711]|0;ga=+Hya(Eya(i,o)|0,-1);n[m>>2]=ga;Zwa(C,l,m)|0;bD(o);bD(l)}while(0);T=(f[B>>2]|0)+8|0;bD(T);F=aD(T,9)|0;G=410977;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));T=f[a+56>>2]|0;Z=T+60|0;R=f[Z>>2]|0;if((R|0)==(f[T+64>>2]|0)){Cya(T+56|0,k);break b}T=f[k>>2]|0;f[R>>2]=T;f[R+4>>2]=f[B>>2];if(!T)ob=R;else{R=T+4|0;f[R>>2]=(f[R>>2]|0)+1;ob=f[Z>>2]|0}f[Z>>2]=ob+8;break b}while(0);Dya(a,i,j);Z=(f[B>>2]|0)+8|0;bD(Z);R=aD(Z,8)|0;Z=R;b[Z>>0]=73;b[Z+1>>0]=100;b[Z+2>>0]=101;b[Z+3>>0]=110;Z=R+4|0;b[Z>>0]=116;b[Z+1>>0]=105;b[Z+2>>0]=116;b[Z+3>>0]=121;Z=f[a+56>>2]|0;R=Z+60|0;T=f[R>>2]|0;if((T|0)==(f[Z+64>>2]|0)){Cya(Z+56|0,k);break b}Z=f[k>>2]|0;f[T>>2]=Z;f[T+4>>2]=f[B>>2];if(!Z)pb=T;else{T=Z+4|0;f[T>>2]=(f[T>>2]|0)+1;pb=f[R>>2]|0}f[R>>2]=pb+8;break b}while(0);Dya(a,i,j);f[l>>2]=0;f[l+4>>2]=0;R=aD(l,1)|0;b[R>>0]=112;R=f[I>>2]|0;do if(R){T=f[l>>2]|0;Z=(T|0)==0?1124530:T;Ea=R;while(1){Ba=f[Ea+16>>2]|0;if((T|0)==(Ba|0)){X=518;break}Ma=(Ba|0)==0?1124530:Ba;if((gTb(Z,Ma)|0)<0)qb=Ea;else{if((gTb(Ma,Z)|0)>=0){X=522;break}qb=Ea+4|0}Ea=f[qb>>2]|0;if(!Ea){X=520;break}}if((X|0)==518){bD(l);break}else if((X|0)==520){bD(l);X=521;break}else if((X|0)==522){bD(l);break}}else{bD(l);X=521}while(0);if((X|0)==521){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,21)|0;G=374059;H=F+21|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,704);bD(l)}f[l>>2]=0;f[l+4>>2]=0;R=aD(l,2)|0;b[R>>0]=118;b[R+1>>0]=50;R=f[I>>2]|0;do if(!R){bD(l);X=535}else{Ea=f[l>>2]|0;Z=(Ea|0)==0?1124530:Ea;T=R;while(1){Ma=f[T+16>>2]|0;if((Ea|0)==(Ma|0))break;Ba=(Ma|0)==0?1124530:Ma;if((gTb(Z,Ba)|0)<0)rb=T;else{if((gTb(Ba,Z)|0)>=0)break;rb=T+4|0}T=f[rb>>2]|0;if(!T){X=534;break}}if((X|0)==534){bD(l);X=535;break}f[m>>2]=0;f[m+4>>2]=0;T=aD(m,2)|0;b[T>>0]=118;b[T+1>>0]=50;T=Gwa(Eya(i,m)|0,-1)|0;Z=J;bD(m);bD(l);if(!((T|0)!=0|(Z|0)!=0)){X=535;break}Z=(f[B>>2]|0)+8|0;bD(Z);T=aD(Z,8)|0;Z=T;b[Z>>0]=73;b[Z+1>>0]=100;b[Z+2>>0]=101;b[Z+3>>0]=110;Z=T+4|0;b[Z>>0]=116;b[Z+1>>0]=105;b[Z+2>>0]=116;b[Z+3>>0]=121}while(0);if((X|0)==535){f[m>>2]=0;f[m+4>>2]=0;R=aD(m,1)|0;b[R>>0]=112;ga=1.0-+Hya(Eya(i,m)|0,-1);bD(m);n[l>>2]=ga;if(!(ga>0.0)){f[m>>2]=0;f[m+4>>2]=0;F=aD(m,9)|0;G=433140;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,m,373550,373222,714);bD(m)}R=(f[B>>2]|0)+8|0;bD(R);Z=aD(R,5)|0;b[Z>>0]=b[433229]|0;b[Z+1>>0]=b[433230]|0;b[Z+2>>0]=b[433231]|0;b[Z+3>>0]=b[433232]|0;b[Z+4>>0]=b[433233]|0;f[m>>2]=0;f[m+4>>2]=0;Z=aD(m,5)|0;b[Z>>0]=b[439628]|0;b[Z+1>>0]=b[439629]|0;b[Z+2>>0]=b[439630]|0;b[Z+3>>0]=b[439631]|0;b[Z+4>>0]=b[439632]|0;Zwa(C,m,l)|0;bD(m)}Z=f[a+56>>2]|0;R=Z+60|0;T=f[R>>2]|0;if((T|0)==(f[Z+64>>2]|0)){Cya(Z+56|0,k);break b}Z=f[k>>2]|0;f[T>>2]=Z;f[T+4>>2]=f[B>>2];if(!Z)sb=T;else{T=Z+4|0;f[T>>2]=(f[T>>2]|0)+1;sb=f[R>>2]|0}f[R>>2]=sb+8;break b}while(0);Dya(a,i,j);f[l>>2]=0;f[l+4>>2]=0;R=aD(l,6)|0;b[R>>0]=b[373514]|0;b[R+1>>0]=b[373515]|0;b[R+2>>0]=b[373516]|0;b[R+3>>0]=b[373517]|0;b[R+4>>0]=b[373518]|0;b[R+5>>0]=b[373519]|0;R=f[L>>2]|0;p:do if(!R)tb=0;else{T=f[l>>2]|0;Z=(T|0)==0?1124530:T;Ea=R;while(1){Ba=f[Ea+16>>2]|0;if((T|0)==(Ba|0)){tb=1;break p}Ma=(Ba|0)==0?1124530:Ba;if((gTb(Z,Ma)|0)<0)ub=Ea;else{if((gTb(Ma,Z)|0)>=0){tb=1;break p}ub=Ea+4|0}Ea=f[ub>>2]|0;if(!Ea){tb=0;break}}}while(0);bD(l);if(!tb){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,28)|0;G=373521;H=F+28|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,681);bD(l)}f[l>>2]=0;f[l+4>>2]=0;F=aD(l,12)|0;G=373566;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));R=~~+Hya(Eya(i,l)|0,-1);bD(l);if(!R){f[l>>2]=0;f[l+4>>2]=0;Ea=aD(l,6)|0;b[Ea>>0]=b[373514]|0;b[Ea+1>>0]=b[373515]|0;b[Ea+2>>0]=b[373516]|0;b[Ea+3>>0]=b[373517]|0;b[Ea+4>>0]=b[373518]|0;b[Ea+5>>0]=b[373519]|0;Ea=Fya(j,l)|0;Z=f[Ea+8>>2]|0;if((Z|0)<3)vb=Y(f[Ea+16>>2]|0,f[Ea+12>>2]|0)|0;else{T=f[Ea+44>>2]|0;Ea=0;Ma=1;while(1){Ba=Y(f[T+(Ea<<2)>>2]|0,Ma)|0;Ea=Ea+1|0;if((Ea|0)==(Z|0)){vb=Ba;break}else Ma=Ba}}bD(l);if((vb|0)!=1){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,42)|0;G=374001;H=F+42|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,692);bD(l)}f[m>>2]=0;f[m+4>>2]=0;Ma=aD(m,6)|0;b[Ma>>0]=b[373514]|0;b[Ma+1>>0]=b[373515]|0;b[Ma+2>>0]=b[373516]|0;b[Ma+3>>0]=b[373517]|0;b[Ma+4>>0]=b[373518]|0;b[Ma+5>>0]=b[373519]|0;Ma=(Fya(j,m)|0)+20|0;Z=f[f[Ma>>2]>>2]|0;bD(m);f[l>>2]=Z;f[m>>2]=0;f[m+4>>2]=0;F=aD(m,14)|0;G=435388;H=F+14|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Zwa(C,m,l)|0;bD(m);Z=(f[B>>2]|0)+8|0;bD(Z);Ma=aD(Z,4)|0;b[Ma>>0]=82;b[Ma+1>>0]=101;b[Ma+2>>0]=76;b[Ma+3>>0]=85}else{f[l>>2]=0;f[l+4>>2]=0;Ma=aD(l,6)|0;b[Ma>>0]=b[373514]|0;b[Ma+1>>0]=b[373515]|0;b[Ma+2>>0]=b[373516]|0;b[Ma+3>>0]=b[373517]|0;b[Ma+4>>0]=b[373518]|0;b[Ma+5>>0]=b[373519]|0;Ma=Fya(j,l)|0;Z=f[Ma+8>>2]|0;if((Z|0)<3)wb=Y(f[Ma+16>>2]|0,f[Ma+12>>2]|0)|0;else{Ea=f[Ma+44>>2]|0;Ma=0;T=1;while(1){Ba=Y(f[Ea+(Ma<<2)>>2]|0,T)|0;Ma=Ma+1|0;if((Ma|0)==(Z|0)){wb=Ba;break}else T=Ba}}bD(l);if((wb|0)!=(R|0)){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,55)|0;G=373945;H=F+55|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,686);bD(l)}f[l>>2]=0;f[l+4>>2]=0;R=aD(l,6)|0;b[R>>0]=b[373514]|0;b[R+1>>0]=b[373515]|0;b[R+2>>0]=b[373516]|0;b[R+3>>0]=b[373517]|0;b[R+4>>0]=b[373518]|0;b[R+5>>0]=b[373519]|0;R=Fya(j,l)|0;T=R+4|0;Z=D+32|0;Ma=f[Z>>2]|0;if((Ma|0)==(f[D+36>>2]|0))v2(D+28|0,T);else{f[Ma>>2]=f[T>>2];Ea=Ma+4|0;Ba=R+8|0;f[Ea>>2]=f[Ba>>2];Ka=Ma+8|0;f[Ka>>2]=f[R+12>>2];f[Ma+12>>2]=f[R+16>>2];f[Ma+16>>2]=f[R+20>>2];f[Ma+20>>2]=f[R+24>>2];f[Ma+24>>2]=f[R+28>>2];f[Ma+28>>2]=f[R+32>>2];f[Ma+32>>2]=f[R+36>>2];N=f[R+40>>2]|0;f[Ma+36>>2]=N;f[Ma+40>>2]=Ka;Ka=Ma+48|0;xb=Ma+44|0;f[xb>>2]=Ka;f[Ka>>2]=0;f[Ma+52>>2]=0;if(N|0){Ka=N+12|0;f[Ka>>2]=(f[Ka>>2]|0)+1}if((f[Ba>>2]|0)<3){Ba=f[R+48>>2]|0;R=f[xb>>2]|0;f[R>>2]=f[Ba>>2];f[R+4>>2]=f[Ba+4>>2]}else{f[Ea>>2]=0;jL(Ma,T)}f[Z>>2]=(f[Z>>2]|0)+56}bD(l);Z=(f[B>>2]|0)+8|0;bD(Z);F=aD(Z,13)|0;G=410872;H=F+13|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0))}Z=f[a+56>>2]|0;T=Z+60|0;Ma=f[T>>2]|0;if((Ma|0)==(f[Z+64>>2]|0)){Cya(Z+56|0,k);break b}Z=f[k>>2]|0;f[Ma>>2]=Z;f[Ma+4>>2]=f[B>>2];if(!Z)yb=Ma;else{Ma=Z+4|0;f[Ma>>2]=(f[Ma>>2]|0)+1;yb=f[T>>2]|0}f[T>>2]=yb+8;break b}while(0);T=(f[B>>2]|0)+8|0;bD(T);F=aD(T,9)|0;G=411943;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Dya(a,i,j);f[l>>2]=0;f[l+4>>2]=0;T=aD(l,3)|0;b[T>>0]=b[433709]|0;b[T+1>>0]=b[433710]|0;b[T+2>>0]=b[433711]|0;T=f[I>>2]|0;do if(T){Ma=f[l>>2]|0;Z=(Ma|0)==0?1124530:Ma;Ea=T;while(1){Ba=f[Ea+16>>2]|0;if((Ma|0)==(Ba|0)){X=290;break}R=(Ba|0)==0?1124530:Ba;if((gTb(Z,R)|0)<0)zb=Ea;else{if((gTb(R,Z)|0)>=0){X=294;break}zb=Ea+4|0}Ea=f[zb>>2]|0;if(!Ea){X=292;break}}if((X|0)==290){bD(l);break}else if((X|0)==292){bD(l);X=293;break}else if((X|0)==294){bD(l);break}}else{bD(l);X=293}while(0);if((X|0)==293){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,23)|0;G=373848;H=F+23|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,623);bD(l)}f[m>>2]=0;f[m+4>>2]=0;T=aD(m,3)|0;b[T>>0]=b[433709]|0;b[T+1>>0]=b[433710]|0;b[T+2>>0]=b[433711]|0;ga=+Hya(Eya(i,m)|0,-1);bD(m);n[l>>2]=ga;f[m>>2]=0;f[m+4>>2]=0;T=aD(m,3)|0;b[T>>0]=b[433709]|0;b[T+1>>0]=b[433710]|0;b[T+2>>0]=b[433711]|0;Zwa(C,m,l)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;F=aD(m,12)|0;G=373872;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));T=f[L>>2]|0;q:do if(!T)Ab=0;else{Ea=f[m>>2]|0;Z=(Ea|0)==0?1124530:Ea;Ma=T;while(1){R=f[Ma+16>>2]|0;if((Ea|0)==(R|0)){Ab=1;break q}Ba=(R|0)==0?1124530:R;if((gTb(Z,Ba)|0)<0)Bb=Ma;else{if((gTb(Ba,Z)|0)>=0){Ab=1;break q}Bb=Ma+4|0}Ma=f[Bb>>2]|0;if(!Ma){Ab=0;break}}}while(0);bD(m);if(!Ab){f[m>>2]=0;f[m+4>>2]=0;T=aD(m,7)|0;b[T>>0]=b[373885]|0;b[T+1>>0]=b[373886]|0;b[T+2>>0]=b[373887]|0;b[T+3>>0]=b[373888]|0;b[T+4>>0]=b[373889]|0;b[T+5>>0]=b[373890]|0;b[T+6>>0]=b[373891]|0;T=f[I>>2]|0;do if(T){Ma=f[m>>2]|0;Z=(Ma|0)==0?1124530:Ma;Ea=T;while(1){Ba=f[Ea+16>>2]|0;if((Ma|0)==(Ba|0)){X=321;break}R=(Ba|0)==0?1124530:Ba;if((gTb(Z,R)|0)<0)Cb=Ea;else{if((gTb(R,Z)|0)>=0){X=325;break}Cb=Ea+4|0}Ea=f[Cb>>2]|0;if(!Ea){X=323;break}}if((X|0)==321){bD(m);break}else if((X|0)==323){bD(m);X=324;break}else if((X|0)==325){bD(m);break}}else{bD(m);X=324}while(0);if((X|0)==324){f[m>>2]=0;f[m+4>>2]=0;F=aD(m,27)|0;G=373893;H=F+27|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,m,373550,373222,633);bD(m)}T=D+28|0;f[o>>2]=0;f[o+4>>2]=0;Ea=aD(o,7)|0;b[Ea>>0]=b[373885]|0;b[Ea+1>>0]=b[373886]|0;b[Ea+2>>0]=b[373887]|0;b[Ea+3>>0]=b[373888]|0;b[Ea+4>>0]=b[373889]|0;b[Ea+5>>0]=b[373890]|0;b[Ea+6>>0]=b[373891]|0;Ea=Gwa(Eya(i,o)|0,-1)|0;QS(r,1,Ea,5);f[m>>2]=1124007936;Ea=m+4|0;Z=m+8|0;Ma=m+40|0;F=Ea;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[Ma>>2]=Z;R=m+48|0;Ba=m+44|0;f[Ba>>2]=R;f[R>>2]=0;f[m+52>>2]=0;xb=f[r>>2]|0;th[f[(f[xb>>2]|0)+12>>2]&511](xb,r,m,-1);xb=D+32|0;Ka=f[xb>>2]|0;if((Ka|0)==(f[D+36>>2]|0)){v2(T,m);Db=m+36|0}else{f[Ka>>2]=f[m>>2];N=Ka+4|0;f[N>>2]=f[Ea>>2];Eb=Ka+8|0;f[Eb>>2]=f[Z>>2];f[Ka+12>>2]=f[m+12>>2];f[Ka+16>>2]=f[m+16>>2];f[Ka+20>>2]=f[m+20>>2];f[Ka+24>>2]=f[m+24>>2];f[Ka+28>>2]=f[m+28>>2];f[Ka+32>>2]=f[m+32>>2];Fb=m+36|0;Gb=f[Fb>>2]|0;f[Ka+36>>2]=Gb;f[Ka+40>>2]=Eb;Eb=Ka+48|0;Hb=Ka+44|0;f[Hb>>2]=Eb;f[Eb>>2]=0;f[Ka+52>>2]=0;if(Gb|0){Eb=Gb+12|0;f[Eb>>2]=(f[Eb>>2]|0)+1}if((f[Ea>>2]|0)<3){Eb=f[Ba>>2]|0;Gb=f[Hb>>2]|0;f[Gb>>2]=f[Eb>>2];f[Gb+4>>2]=f[Eb+4>>2]}else{f[N>>2]=0;jL(Ka,m)}f[xb>>2]=(f[xb>>2]|0)+56;Db=Fb}Fb=f[Db>>2]|0;do if(Fb|0){xb=Fb+12|0;Ka=f[xb>>2]|0;f[xb>>2]=Ka+-1;if((Ka|0)!=1)break;kL(m)}while(0);f[Db>>2]=0;Fb=m+16|0;f[Fb>>2]=0;f[Fb+4>>2]=0;f[Fb+8>>2]=0;f[Fb+12>>2]=0;if((f[Ea>>2]|0)>0){Fb=f[Ma>>2]|0;Z=0;do{f[Fb+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[Ea>>2]|0))}Ea=f[Ba>>2]|0;if((Ea|0)!=(R|0))UC(Ea);Wi(r);bD(o)}else{Ea=D+28|0;f[m>>2]=0;f[m+4>>2]=0;F=aD(m,12)|0;G=373872;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));R=Fya(j,m)|0;Ba=R+4|0;Z=D+32|0;Fb=f[Z>>2]|0;if((Fb|0)==(f[D+36>>2]|0))v2(Ea,Ba);else{f[Fb>>2]=f[Ba>>2];Ma=Fb+4|0;T=R+8|0;f[Ma>>2]=f[T>>2];Ka=Fb+8|0;f[Ka>>2]=f[R+12>>2];f[Fb+12>>2]=f[R+16>>2];f[Fb+16>>2]=f[R+20>>2];f[Fb+20>>2]=f[R+24>>2];f[Fb+24>>2]=f[R+28>>2];f[Fb+28>>2]=f[R+32>>2];f[Fb+32>>2]=f[R+36>>2];xb=f[R+40>>2]|0;f[Fb+36>>2]=xb;f[Fb+40>>2]=Ka;Ka=Fb+48|0;N=Fb+44|0;f[N>>2]=Ka;f[Ka>>2]=0;f[Fb+52>>2]=0;if(xb|0){Ka=xb+12|0;f[Ka>>2]=(f[Ka>>2]|0)+1}if((f[T>>2]|0)<3){T=f[R+48>>2]|0;R=f[N>>2]|0;f[R>>2]=f[T>>2];f[R+4>>2]=f[T+4>>2]}else{f[Ma>>2]=0;jL(Fb,Ba)}f[Z>>2]=(f[Z>>2]|0)+56}bD(m)}f[m>>2]=0;f[m+4>>2]=0;F=aD(m,11)|0;G=373921;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Ea=f[L>>2]|0;r:do if(!Ea)Ib=0;else{Z=f[m>>2]|0;Ba=(Z|0)==0?1124530:Z;Fb=Ea;while(1){Ma=f[Fb+16>>2]|0;if((Z|0)==(Ma|0)){Ib=1;break r}T=(Ma|0)==0?1124530:Ma;if((gTb(Ba,T)|0)<0)Jb=Fb;else{if((gTb(T,Ba)|0)>=0){Ib=1;break r}Jb=Fb+4|0}Fb=f[Jb>>2]|0;if(!Fb){Ib=0;break}}}while(0);bD(m);do if(!Ib){f[m>>2]=0;f[m+4>>2]=0;F=aD(m,11)|0;G=373933;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Ea=f[L>>2]|0;s:do if(!Ea)Kb=0;else{Fb=f[m>>2]|0;Ba=(Fb|0)==0?1124530:Fb;Z=Ea;while(1){T=f[Z+16>>2]|0;if((Fb|0)==(T|0)){Kb=1;break s}Ma=(T|0)==0?1124530:T;if((gTb(Ba,Ma)|0)<0)Lb=Z;else{if((gTb(Ma,Ba)|0)>=0){Kb=1;break s}Lb=Z+4|0}Z=f[Lb>>2]|0;if(!Z){Kb=0;break}}}while(0);bD(m);if(Kb|0){Ea=D+28|0;f[m>>2]=0;f[m+4>>2]=0;F=aD(m,11)|0;G=373933;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Z=Fya(j,m)|0;Ba=Z+4|0;Fb=D+32|0;Ma=f[Fb>>2]|0;if((Ma|0)==(f[D+36>>2]|0))v2(Ea,Ba);else{f[Ma>>2]=f[Ba>>2];T=Ma+4|0;R=Z+8|0;f[T>>2]=f[R>>2];N=Ma+8|0;f[N>>2]=f[Z+12>>2];f[Ma+12>>2]=f[Z+16>>2];f[Ma+16>>2]=f[Z+20>>2];f[Ma+20>>2]=f[Z+24>>2];f[Ma+24>>2]=f[Z+28>>2];f[Ma+28>>2]=f[Z+32>>2];f[Ma+32>>2]=f[Z+36>>2];Ka=f[Z+40>>2]|0;f[Ma+36>>2]=Ka;f[Ma+40>>2]=N;N=Ma+48|0;xb=Ma+44|0;f[xb>>2]=N;f[N>>2]=0;f[Ma+52>>2]=0;if(Ka|0){N=Ka+12|0;f[N>>2]=(f[N>>2]|0)+1}if((f[R>>2]|0)<3){R=f[Z+48>>2]|0;Z=f[xb>>2]|0;f[Z>>2]=f[R>>2];f[Z+4>>2]=f[R+4>>2]}else{f[T>>2]=0;jL(Ma,Ba)}f[Fb>>2]=(f[Fb>>2]|0)+56}bD(m);Ba=(f[Fb>>2]|0)+-56|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=Ba;Ma=o+8|0;f[Ma>>2]=0;f[Ma+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=Ba;XO(m,-2.0,o);Ba=(f[Fb>>2]|0)+-56|0;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=Ba;p[q>>3]=+n[l>>2];f[o>>2]=-1056833530;f[o+4>>2]=q;f[o+8>>2]=1;f[o+12>>2]=1;Fb=s+8|0;f[Fb>>2]=0;f[Fb+4>>2]=0;f[s>>2]=33619968;f[s+4>>2]=Ba;jE(m,o,s,UM()|0,-1);break}f[m>>2]=0;f[m+4>>2]=0;Ba=aD(m,7)|0;b[Ba>>0]=b[373885]|0;b[Ba+1>>0]=b[373886]|0;b[Ba+2>>0]=b[373887]|0;b[Ba+3>>0]=b[373888]|0;b[Ba+4>>0]=b[373889]|0;b[Ba+5>>0]=b[373890]|0;b[Ba+6>>0]=b[373891]|0;Ba=f[I>>2]|0;do if(Ba){Fb=f[m>>2]|0;Ma=(Fb|0)==0?1124530:Fb;T=Ba;while(1){R=f[T+16>>2]|0;if((Fb|0)==(R|0)){X=387;break}Z=(R|0)==0?1124530:R;if((gTb(Ma,Z)|0)<0)Mb=T;else{if((gTb(Z,Ma)|0)>=0){X=391;break}Mb=T+4|0}T=f[Mb>>2]|0;if(!T){X=389;break}}if((X|0)==387){bD(m);break}else if((X|0)==389){bD(m);X=390;break}else if((X|0)==391){bD(m);break}}else{bD(m);X=390}while(0);if((X|0)==390){f[m>>2]=0;f[m+4>>2]=0;F=aD(m,27)|0;G=373893;H=F+27|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,m,373550,373222,649);bD(m)}Ba=D+28|0;f[o>>2]=0;f[o+4>>2]=0;Ea=aD(o,7)|0;b[Ea>>0]=b[373885]|0;b[Ea+1>>0]=b[373886]|0;b[Ea+2>>0]=b[373887]|0;b[Ea+3>>0]=b[373888]|0;b[Ea+4>>0]=b[373889]|0;b[Ea+5>>0]=b[373890]|0;b[Ea+6>>0]=b[373891]|0;Ea=Gwa(Eya(i,o)|0,-1)|0;TS(t,1,Ea,5);f[m>>2]=1124007936;Ea=m+4|0;T=m+8|0;Ma=m+40|0;F=Ea;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[Ma>>2]=T;Fb=m+48|0;Z=m+44|0;f[Z>>2]=Fb;f[Fb>>2]=0;f[m+52>>2]=0;R=f[t>>2]|0;th[f[(f[R>>2]|0)+12>>2]&511](R,t,m,-1);R=D+32|0;xb=f[R>>2]|0;if((xb|0)==(f[D+36>>2]|0)){v2(Ba,m);Nb=m+36|0}else{f[xb>>2]=f[m>>2];N=xb+4|0;f[N>>2]=f[Ea>>2];Ka=xb+8|0;f[Ka>>2]=f[T>>2];f[xb+12>>2]=f[m+12>>2];f[xb+16>>2]=f[m+16>>2];f[xb+20>>2]=f[m+20>>2];f[xb+24>>2]=f[m+24>>2];f[xb+28>>2]=f[m+28>>2];f[xb+32>>2]=f[m+32>>2];Eb=m+36|0;Gb=f[Eb>>2]|0;f[xb+36>>2]=Gb;f[xb+40>>2]=Ka;Ka=xb+48|0;Hb=xb+44|0;f[Hb>>2]=Ka;f[Ka>>2]=0;f[xb+52>>2]=0;if(Gb|0){Ka=Gb+12|0;f[Ka>>2]=(f[Ka>>2]|0)+1}if((f[Ea>>2]|0)<3){Ka=f[Z>>2]|0;Gb=f[Hb>>2]|0;f[Gb>>2]=f[Ka>>2];f[Gb+4>>2]=f[Ka+4>>2]}else{f[N>>2]=0;jL(xb,m)}f[R>>2]=(f[R>>2]|0)+56;Nb=Eb}Eb=f[Nb>>2]|0;do if(Eb|0){R=Eb+12|0;xb=f[R>>2]|0;f[R>>2]=xb+-1;if((xb|0)!=1)break;kL(m)}while(0);f[Nb>>2]=0;Eb=m+16|0;f[Eb>>2]=0;f[Eb+4>>2]=0;f[Eb+8>>2]=0;f[Eb+12>>2]=0;if((f[Ea>>2]|0)>0){Eb=f[Ma>>2]|0;T=0;do{f[Eb+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[Ea>>2]|0))}Ea=f[Z>>2]|0;if((Ea|0)!=(Fb|0))UC(Ea);Wi(t);bD(o)}else{Ea=D+28|0;f[m>>2]=0;f[m+4>>2]=0;F=aD(m,11)|0;G=373921;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Fb=Fya(j,m)|0;Z=Fb+4|0;T=D+32|0;Eb=f[T>>2]|0;if((Eb|0)==(f[D+36>>2]|0))v2(Ea,Z);else{f[Eb>>2]=f[Z>>2];Ma=Eb+4|0;Ba=Fb+8|0;f[Ma>>2]=f[Ba>>2];xb=Eb+8|0;f[xb>>2]=f[Fb+12>>2];f[Eb+12>>2]=f[Fb+16>>2];f[Eb+16>>2]=f[Fb+20>>2];f[Eb+20>>2]=f[Fb+24>>2];f[Eb+24>>2]=f[Fb+28>>2];f[Eb+28>>2]=f[Fb+32>>2];f[Eb+32>>2]=f[Fb+36>>2];R=f[Fb+40>>2]|0;f[Eb+36>>2]=R;f[Eb+40>>2]=xb;xb=Eb+48|0;N=Eb+44|0;f[N>>2]=xb;f[xb>>2]=0;f[Eb+52>>2]=0;if(R|0){xb=R+12|0;f[xb>>2]=(f[xb>>2]|0)+1}if((f[Ba>>2]|0)<3){Ba=f[Fb+48>>2]|0;Fb=f[N>>2]|0;f[Fb>>2]=f[Ba>>2];f[Fb+4>>2]=f[Ba+4>>2]}else{f[Ma>>2]=0;jL(Eb,Z)}f[T>>2]=(f[T>>2]|0)+56}bD(m)}while(0);f[m>>2]=0;f[m+4>>2]=0;T=aD(m,6)|0;b[T>>0]=b[373514]|0;b[T+1>>0]=b[373515]|0;b[T+2>>0]=b[373516]|0;b[T+3>>0]=b[373517]|0;b[T+4>>0]=b[373518]|0;b[T+5>>0]=b[373519]|0;T=f[L>>2]|0;t:do if(!T)Ob=0;else{Z=f[m>>2]|0;Eb=(Z|0)==0?1124530:Z;Ma=T;while(1){Ba=f[Ma+16>>2]|0;if((Z|0)==(Ba|0)){Ob=1;break t}Fb=(Ba|0)==0?1124530:Ba;if((gTb(Eb,Fb)|0)<0)Pb=Ma;else{if((gTb(Fb,Eb)|0)>=0){Ob=1;break t}Pb=Ma+4|0}Ma=f[Pb>>2]|0;if(!Ma){Ob=0;break}}}while(0);bD(m);if(Ob|0){f[m>>2]=0;f[m+4>>2]=0;F=aD(m,10)|0;G=422223;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));b[o>>0]=1;$wa(C,m,o)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;T=aD(m,6)|0;b[T>>0]=b[373514]|0;b[T+1>>0]=b[373515]|0;b[T+2>>0]=b[373516]|0;b[T+3>>0]=b[373517]|0;b[T+4>>0]=b[373518]|0;b[T+5>>0]=b[373519]|0;T=Fya(j,m)|0;Ma=T+4|0;Eb=D+32|0;Z=f[Eb>>2]|0;if((Z|0)==(f[D+36>>2]|0))v2(D+28|0,Ma);else{f[Z>>2]=f[Ma>>2];Ea=Z+4|0;Fb=T+8|0;f[Ea>>2]=f[Fb>>2];Ba=Z+8|0;f[Ba>>2]=f[T+12>>2];f[Z+12>>2]=f[T+16>>2];f[Z+16>>2]=f[T+20>>2];f[Z+20>>2]=f[T+24>>2];f[Z+24>>2]=f[T+28>>2];f[Z+28>>2]=f[T+32>>2];f[Z+32>>2]=f[T+36>>2];N=f[T+40>>2]|0;f[Z+36>>2]=N;f[Z+40>>2]=Ba;Ba=Z+48|0;xb=Z+44|0;f[xb>>2]=Ba;f[Ba>>2]=0;f[Z+52>>2]=0;if(N|0){Ba=N+12|0;f[Ba>>2]=(f[Ba>>2]|0)+1}if((f[Fb>>2]|0)<3){Fb=f[T+48>>2]|0;T=f[xb>>2]|0;f[T>>2]=f[Fb>>2];f[T+4>>2]=f[Fb+4>>2]}else{f[Ea>>2]=0;jL(Z,Ma)}f[Eb>>2]=(f[Eb>>2]|0)+56}bD(m)}f[m>>2]=0;f[m+4>>2]=0;Eb=aD(m,4)|0;b[Eb>>0]=98;b[Eb+1>>0]=105;b[Eb+2>>0]=97;b[Eb+3>>0]=115;Eb=f[L>>2]|0;u:do if(!Eb)Qb=0;else{Ma=f[m>>2]|0;Z=(Ma|0)==0?1124530:Ma;Ea=Eb;while(1){Fb=f[Ea+16>>2]|0;if((Ma|0)==(Fb|0)){Qb=1;break u}T=(Fb|0)==0?1124530:Fb;if((gTb(Z,T)|0)<0)Rb=Ea;else{if((gTb(T,Z)|0)>=0){Qb=1;break u}Rb=Ea+4|0}Ea=f[Rb>>2]|0;if(!Ea){Qb=0;break}}}while(0);bD(m);if(Qb|0){f[m>>2]=0;f[m+4>>2]=0;Eb=aD(m,8)|0;Ea=Eb;b[Ea>>0]=104;b[Ea+1>>0]=97;b[Ea+2>>0]=115;b[Ea+3>>0]=95;Ea=Eb+4|0;b[Ea>>0]=98;b[Ea+1>>0]=105;b[Ea+2>>0]=97;b[Ea+3>>0]=115;b[o>>0]=1;$wa(C,m,o)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;Ea=aD(m,4)|0;b[Ea>>0]=98;b[Ea+1>>0]=105;b[Ea+2>>0]=97;b[Ea+3>>0]=115;Ea=Fya(j,m)|0;Eb=Ea+4|0;Z=D+32|0;Ma=f[Z>>2]|0;if((Ma|0)==(f[D+36>>2]|0))v2(D+28|0,Eb);else{f[Ma>>2]=f[Eb>>2];T=Ma+4|0;Fb=Ea+8|0;f[T>>2]=f[Fb>>2];xb=Ma+8|0;f[xb>>2]=f[Ea+12>>2];f[Ma+12>>2]=f[Ea+16>>2];f[Ma+16>>2]=f[Ea+20>>2];f[Ma+20>>2]=f[Ea+24>>2];f[Ma+24>>2]=f[Ea+28>>2];f[Ma+28>>2]=f[Ea+32>>2];f[Ma+32>>2]=f[Ea+36>>2];Ba=f[Ea+40>>2]|0;f[Ma+36>>2]=Ba;f[Ma+40>>2]=xb;xb=Ma+48|0;N=Ma+44|0;f[N>>2]=xb;f[xb>>2]=0;f[Ma+52>>2]=0;if(Ba|0){xb=Ba+12|0;f[xb>>2]=(f[xb>>2]|0)+1}if((f[Fb>>2]|0)<3){Fb=f[Ea+48>>2]|0;Ea=f[N>>2]|0;f[Ea>>2]=f[Fb>>2];f[Ea+4>>2]=f[Fb+4>>2]}else{f[T>>2]=0;jL(Ma,Eb)}f[Z>>2]=(f[Z>>2]|0)+56}bD(m)}Z=f[h>>2]|0;Eb=Z;do if((Z|0)==373807)X=448;else{if(!(gTb((Z|0)==0?1124530:Z,373807)|0)){X=448;break}Sb=a+56|0}while(0);if((X|0)==448){Ma=L5b(68)|0;f[o>>2]=0;T=o+4|0;f[T>>2]=0;f[Ma>>2]=Eb;f[Ma+4>>2]=f[E>>2];do if(!Z){f[Ma+8>>2]=0;f[Ma+12>>2]=0}else{Fb=Z+-4|0;f[Fb>>2]=(f[Fb>>2]|0)+1;Fb=f[o>>2]|0;Ea=f[T>>2]|0;f[Ma+8>>2]=Fb;f[Ma+12>>2]=Ea;if(!Fb)break;Ea=Fb+-4|0;f[Ea>>2]=(f[Ea>>2]|0)+1}while(0);T=Ma+20|0;f[T>>2]=0;f[Ma+24>>2]=0;f[Ma+16>>2]=T;F=Ma+28|0;H=F+40|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));T=L5b(16)|0;f[T+4>>2]=1;f[T>>2]=106172;f[T+8>>2]=Ma;f[m>>2]=T;T=m+4|0;f[T>>2]=Ma;bD(o);Z=(f[T>>2]|0)+8|0;bD(Z);Eb=aD(Z,3)|0;b[Eb>>0]=b[410862]|0;b[Eb+1>>0]=b[410863]|0;b[Eb+2>>0]=b[410864]|0;Eb=a+56|0;Z=f[Eb>>2]|0;Ea=Z+60|0;Fb=f[Ea>>2]|0;if((Fb|0)==(f[Z+64>>2]|0))Cya(Z+56|0,m);else{Z=f[m>>2]|0;f[Fb>>2]=Z;f[Fb+4>>2]=f[T>>2];if(!Z)Tb=Fb;else{Fb=Z+4|0;f[Fb>>2]=(f[Fb>>2]|0)+1;Tb=f[Ea>>2]|0}f[Ea>>2]=Tb+8}Ea=D+28|0;Fb=f[Ea>>2]|0;p[q>>3]=0.0;f[o>>2]=-1056833530;f[o+4>>2]=q;f[o+8>>2]=1;f[o+12>>2]=1;VP(Fb,o,UM()|0)|0;Fb=f[Ea>>2]|0;p[q>>3]=1.0;f[o>>2]=-1056833530;f[o+4>>2]=q;f[o+8>>2]=1;f[o+12>>2]=1;VP(Fb+56|0,o,UM()|0)|0;Fb=f[m>>2]|0;do if(Fb|0){Ea=Fb+4|0;Z=f[Ea>>2]|0;f[Ea>>2]=Z+-1;if((Z|0)!=1)break;bi[f[(f[Fb>>2]|0)+8>>2]&2047](Fb)}while(0);Sb=Eb}Fb=f[Sb>>2]|0;Ma=Fb+60|0;Z=f[Ma>>2]|0;if((Z|0)==(f[Fb+64>>2]|0))Cya(Fb+56|0,k);else{Fb=f[k>>2]|0;f[Z>>2]=Fb;f[Z+4>>2]=f[B>>2];if(!Fb)Ub=Z;else{Z=Fb+4|0;f[Z>>2]=(f[Z>>2]|0)+1;Ub=f[Ma>>2]|0}f[Ma>>2]=Ub+8}break b}while(0);Ma=f[a+56>>2]|0;Z=Ma+56|0;Fb=L5b(68)|0;f[m>>2]=0;Ea=m+4|0;f[Ea>>2]=0;T=aD(m,7)|0;b[T>>0]=b[410892]|0;b[T+1>>0]=b[410893]|0;b[T+2>>0]=b[410894]|0;b[T+3>>0]=b[410895]|0;b[T+4>>0]=b[410896]|0;b[T+5>>0]=b[410897]|0;b[T+6>>0]=b[410898]|0;T=f[h>>2]|0;f[Fb>>2]=T;f[Fb+4>>2]=f[E>>2];if(T|0){N=T+-4|0;f[N>>2]=(f[N>>2]|0)+1}N=f[m>>2]|0;f[Fb+8>>2]=N;f[Fb+12>>2]=f[Ea>>2];if(N|0){Ea=N+-4|0;f[Ea>>2]=(f[Ea>>2]|0)+1}Ea=Fb+20|0;f[Ea>>2]=0;f[Fb+24>>2]=0;f[Fb+16>>2]=Ea;F=Fb+28|0;H=F+40|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));Ea=L5b(16)|0;f[Ea+4>>2]=1;f[Ea>>2]=106172;f[Ea+8>>2]=Fb;f[l>>2]=Ea;N=l+4|0;f[N>>2]=Fb;T=Ma+60|0;xb=f[T>>2]|0;if((xb|0)==(f[Ma+64>>2]|0))Cya(Z,l);else{f[xb>>2]=Ea;f[xb+4>>2]=Fb;xb=Ea+4|0;f[xb>>2]=(f[xb>>2]|0)+1;f[T>>2]=(f[T>>2]|0)+8}T=f[l>>2]|0;do if(T|0){xb=T+4|0;Ea=f[xb>>2]|0;f[xb>>2]=Ea+-1;if((Ea|0)!=1)break;bi[f[(f[T>>2]|0)+8>>2]&2047](T)}while(0);f[l>>2]=0;f[N>>2]=0;bD(m);tya(a);break b}while(0);T=f[a+56>>2]|0;Fb=T+56|0;Z=L5b(68)|0;f[m>>2]=0;Ma=m+4|0;f[Ma>>2]=0;Ea=aD(m,4)|0;b[Ea>>0]=84;b[Ea+1>>0]=97;b[Ea+2>>0]=110;b[Ea+3>>0]=72;Ea=f[h>>2]|0;f[Z>>2]=Ea;f[Z+4>>2]=f[E>>2];if(Ea|0){xb=Ea+-4|0;f[xb>>2]=(f[xb>>2]|0)+1}xb=f[m>>2]|0;f[Z+8>>2]=xb;f[Z+12>>2]=f[Ma>>2];if(xb|0){Ma=xb+-4|0;f[Ma>>2]=(f[Ma>>2]|0)+1}Ma=Z+20|0;f[Ma>>2]=0;f[Z+24>>2]=0;f[Z+16>>2]=Ma;F=Z+28|0;H=F+40|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));Ma=L5b(16)|0;f[Ma+4>>2]=1;f[Ma>>2]=106172;f[Ma+8>>2]=Z;f[l>>2]=Ma;xb=l+4|0;f[xb>>2]=Z;Ea=T+60|0;Ba=f[Ea>>2]|0;if((Ba|0)==(f[T+64>>2]|0))Cya(Fb,l);else{f[Ba>>2]=Ma;f[Ba+4>>2]=Z;Ba=Ma+4|0;f[Ba>>2]=(f[Ba>>2]|0)+1;f[Ea>>2]=(f[Ea>>2]|0)+8}Ea=f[l>>2]|0;do if(Ea|0){Ba=Ea+4|0;Ma=f[Ba>>2]|0;f[Ba>>2]=Ma+-1;if((Ma|0)!=1)break;bi[f[(f[Ea>>2]|0)+8>>2]&2047](Ea)}while(0);f[l>>2]=0;f[xb>>2]=0;bD(m);tya(a);break b}while(0);Ea=f[a+56>>2]|0;Z=Ea+56|0;Fb=L5b(68)|0;f[m>>2]=0;T=m+4|0;f[T>>2]=0;Ma=aD(m,4)|0;b[Ma>>0]=82;b[Ma+1>>0]=101;b[Ma+2>>0]=76;b[Ma+3>>0]=85;Ma=f[h>>2]|0;f[Fb>>2]=Ma;f[Fb+4>>2]=f[E>>2];if(Ma|0){Ba=Ma+-4|0;f[Ba>>2]=(f[Ba>>2]|0)+1}Ba=f[m>>2]|0;f[Fb+8>>2]=Ba;f[Fb+12>>2]=f[T>>2];if(Ba|0){T=Ba+-4|0;f[T>>2]=(f[T>>2]|0)+1}T=Fb+20|0;f[T>>2]=0;f[Fb+24>>2]=0;f[Fb+16>>2]=T;F=Fb+28|0;H=F+40|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));T=L5b(16)|0;f[T+4>>2]=1;f[T>>2]=106172;f[T+8>>2]=Fb;f[l>>2]=T;Ba=l+4|0;f[Ba>>2]=Fb;Ma=Ea+60|0;R=f[Ma>>2]|0;if((R|0)==(f[Ea+64>>2]|0))Cya(Z,l);else{f[R>>2]=T;f[R+4>>2]=Fb;R=T+4|0;f[R>>2]=(f[R>>2]|0)+1;f[Ma>>2]=(f[Ma>>2]|0)+8}Ma=f[l>>2]|0;do if(Ma|0){R=Ma+4|0;T=f[R>>2]|0;f[R>>2]=T+-1;if((T|0)!=1)break;bi[f[(f[Ma>>2]|0)+8>>2]&2047](Ma)}while(0);f[l>>2]=0;f[Ba>>2]=0;bD(m);tya(a);break b}while(0);Ma=(f[B>>2]|0)+8|0;bD(Ma);Fb=aD(Ma,7)|0;b[Fb>>0]=b[410761]|0;b[Fb+1>>0]=b[410762]|0;b[Fb+2>>0]=b[410763]|0;b[Fb+3>>0]=b[410764]|0;b[Fb+4>>0]=b[410765]|0;b[Fb+5>>0]=b[410766]|0;b[Fb+6>>0]=b[410767]|0;Dya(a,i,j);f[l>>2]=0;f[l+4>>2]=0;Fb=aD(l,4)|0;b[Fb>>0]=115;b[Fb+1>>0]=105;b[Fb+2>>0]=122;b[Fb+3>>0]=101;Fb=f[I>>2]|0;do if(Fb){Ma=f[l>>2]|0;Z=(Ma|0)==0?1124530:Ma;Ea=Fb;while(1){T=f[Ea+16>>2]|0;if((Ma|0)==(T|0)){X=216;break}R=(T|0)==0?1124530:T;if((gTb(Z,R)|0)<0)Vb=Ea;else{if((gTb(R,Z)|0)>=0){X=220;break}Vb=Ea+4|0}Ea=f[Vb>>2]|0;if(!Ea){X=218;break}}if((X|0)==216){bD(l);break}else if((X|0)==218){bD(l);X=219;break}else if((X|0)==220){bD(l);break}}else{bD(l);X=219}while(0);if((X|0)==219){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,24)|0;G=373741;H=F+24|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,592);bD(l)}f[m>>2]=0;f[m+4>>2]=0;Fb=aD(m,4)|0;b[Fb>>0]=115;b[Fb+1>>0]=105;b[Fb+2>>0]=122;b[Fb+3>>0]=101;iua(l,Eya(i,m)|0);bD(m);f[m>>2]=0;f[m+4>>2]=0;Fb=aD(m,3)|0;b[Fb>>0]=b[429349]|0;b[Fb+1>>0]=b[429350]|0;b[Fb+2>>0]=b[429351]|0;nxa(C,m,l)|0;bD(m);f[m>>2]=0;f[m+4>>2]=0;F=aD(m,9)|0;G=373766;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Fb=f[I>>2]|0;do if(!Fb)bD(m);else{Ea=f[m>>2]|0;Z=(Ea|0)==0?1124530:Ea;Ma=Fb;while(1){Ba=f[Ma+16>>2]|0;if((Ea|0)==(Ba|0))break;R=(Ba|0)==0?1124530:Ba;if((gTb(Z,R)|0)<0)Wb=Ma;else{if((gTb(R,Z)|0)>=0)break;Wb=Ma+4|0}Ma=f[Wb>>2]|0;if(!Ma){X=232;break}}if((X|0)==232){bD(m);break}f[o>>2]=0;f[o+4>>2]=0;F=aD(o,9)|0;G=373766;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Ma=Gwa(Eya(i,o)|0,-1)|0;Z=J;bD(o);bD(m);if(!((Ma|0)!=0|(Z|0)!=0))break;f[m>>2]=0;f[m+4>>2]=0;Z=aD(m,4)|0;b[Z>>0]=97;b[Z+1>>0]=120;b[Z+2>>0]=105;b[Z+3>>0]=115;f[o>>2]=1;Wwa(C,m,o)|0;bD(m)}while(0);Fb=f[a+56>>2]|0;Z=Fb+60|0;Ma=f[Z>>2]|0;if((Ma|0)==(f[Fb+64>>2]|0))Cya(Fb+56|0,k);else{Fb=f[k>>2]|0;f[Ma>>2]=Fb;f[Ma+4>>2]=f[B>>2];if(!Fb)Xb=Ma;else{Ma=Fb+4|0;f[Ma>>2]=(f[Ma>>2]|0)+1;Xb=f[Z>>2]|0}f[Z>>2]=Xb+8}gua(l);break b}while(0);Z=(f[B>>2]|0)+8|0;bD(Z);F=aD(Z,12)|0;G=410841;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Dya(a,i,j);f[l>>2]=0;f[l+4>>2]=0;Z=aD(l,6)|0;b[Z>>0]=b[373514]|0;b[Z+1>>0]=b[373515]|0;b[Z+2>>0]=b[373516]|0;b[Z+3>>0]=b[373517]|0;b[Z+4>>0]=b[373518]|0;b[Z+5>>0]=b[373519]|0;Z=f[L>>2]|0;v:do if(!Z)Yb=0;else{Ma=f[l>>2]|0;Fb=(Ma|0)==0?1124530:Ma;Ea=Z;while(1){R=f[Ea+16>>2]|0;if((Ma|0)==(R|0)){Yb=1;break v}Ba=(R|0)==0?1124530:R;if((gTb(Fb,Ba)|0)<0)Zb=Ea;else{if((gTb(Ba,Fb)|0)>=0){Yb=1;break v}Zb=Ea+4|0}Ea=f[Zb>>2]|0;if(!Ea){Yb=0;break}}}while(0);bD(l);if(!Yb){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,28)|0;G=373521;H=F+28|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,575);bD(l)}f[m>>2]=0;f[m+4>>2]=0;Z=aD(m,6)|0;b[Z>>0]=b[373514]|0;b[Z+1>>0]=b[373515]|0;b[Z+2>>0]=b[373516]|0;b[Z+3>>0]=b[373517]|0;b[Z+4>>0]=b[373518]|0;b[Z+5>>0]=b[373519]|0;Z=Fya(j,m)|0;Ea=Z+4|0;f[l>>2]=f[Ea>>2];Fb=l+4|0;Ma=Z+8|0;f[Fb>>2]=f[Ma>>2];Ba=l+8|0;f[Ba>>2]=f[Z+12>>2];R=l+12|0;f[R>>2]=f[Z+16>>2];T=l+16|0;f[T>>2]=f[Z+20>>2];Ka=l+20|0;f[Ka>>2]=f[Z+24>>2];Gb=l+24|0;f[Gb>>2]=f[Z+28>>2];Hb=l+28|0;f[Hb>>2]=f[Z+32>>2];_b=l+32|0;f[_b>>2]=f[Z+36>>2];$b=l+36|0;ac=f[Z+40>>2]|0;f[$b>>2]=ac;bc=l+40|0;f[bc>>2]=Ba;cc=l+48|0;dc=l+44|0;f[dc>>2]=cc;f[cc>>2]=0;f[l+52>>2]=0;if(ac|0){ec=ac+12|0;f[ec>>2]=(f[ec>>2]|0)+1}if((f[Ma>>2]|0)<3){Ma=f[Z+48>>2]|0;Z=f[dc>>2]|0;f[Z>>2]=f[Ma>>2];f[Z+4>>2]=f[Ma+4>>2]}else{f[Fb>>2]=0;jL(l,Ea)}bD(m);Ea=D+28|0;Ma=D+32|0;Z=f[Ma>>2]|0;ec=D+36|0;if((Z|0)==(f[ec>>2]|0))v2(Ea,l);else{f[Z>>2]=f[l>>2];ac=Z+4|0;f[ac>>2]=f[Fb>>2];fc=Z+8|0;f[fc>>2]=f[Ba>>2];f[Z+12>>2]=f[R>>2];f[Z+16>>2]=f[T>>2];f[Z+20>>2]=f[Ka>>2];f[Z+24>>2]=f[Gb>>2];f[Z+28>>2]=f[Hb>>2];f[Z+32>>2]=f[_b>>2];_b=f[$b>>2]|0;f[Z+36>>2]=_b;f[Z+40>>2]=fc;fc=Z+48|0;Hb=Z+44|0;f[Hb>>2]=fc;f[fc>>2]=0;f[Z+52>>2]=0;if(_b|0){fc=_b+12|0;f[fc>>2]=(f[fc>>2]|0)+1}if((f[Fb>>2]|0)<3){fc=f[dc>>2]|0;_b=f[Hb>>2]|0;f[_b>>2]=f[fc>>2];f[_b+4>>2]=f[fc+4>>2]}else{f[ac>>2]=0;jL(Z,l)}f[Ma>>2]=(f[Ma>>2]|0)+56}f[o>>2]=0;f[o+4>>2]=0;Z=aD(o,4)|0;b[Z>>0]=98;b[Z+1>>0]=105;b[Z+2>>0]=97;b[Z+3>>0]=115;Z=f[L>>2]|0;w:do if(!Z)gc=0;else{ac=f[o>>2]|0;fc=(ac|0)==0?1124530:ac;_b=Z;while(1){Hb=f[_b+16>>2]|0;if((ac|0)==(Hb|0)){gc=1;break w}Gb=(Hb|0)==0?1124530:Hb;if((gTb(fc,Gb)|0)<0)hc=_b;else{if((gTb(Gb,fc)|0)>=0){gc=1;break w}hc=_b+4|0}_b=f[hc>>2]|0;if(!_b){gc=0;break}}}while(0);bD(o);b[m>>0]=gc&1;if(gc){f[o>>2]=0;f[o+4>>2]=0;Z=aD(o,4)|0;b[Z>>0]=98;b[Z+1>>0]=105;b[Z+2>>0]=97;b[Z+3>>0]=115;Z=Fya(j,o)|0;_b=Z+4|0;fc=f[Ma>>2]|0;if((fc|0)==(f[ec>>2]|0))v2(Ea,_b);else{f[fc>>2]=f[_b>>2];ac=fc+4|0;Gb=Z+8|0;f[ac>>2]=f[Gb>>2];Hb=fc+8|0;f[Hb>>2]=f[Z+12>>2];f[fc+12>>2]=f[Z+16>>2];f[fc+16>>2]=f[Z+20>>2];f[fc+20>>2]=f[Z+24>>2];f[fc+24>>2]=f[Z+28>>2];f[fc+28>>2]=f[Z+32>>2];f[fc+32>>2]=f[Z+36>>2];Ka=f[Z+40>>2]|0;f[fc+36>>2]=Ka;f[fc+40>>2]=Hb;Hb=fc+48|0;R=fc+44|0;f[R>>2]=Hb;f[Hb>>2]=0;f[fc+52>>2]=0;if(Ka|0){Hb=Ka+12|0;f[Hb>>2]=(f[Hb>>2]|0)+1}if((f[Gb>>2]|0)<3){Gb=f[Z+48>>2]|0;Z=f[R>>2]|0;f[Z>>2]=f[Gb>>2];f[Z+4>>2]=f[Gb+4>>2]}else{f[ac>>2]=0;jL(fc,_b)}f[Ma>>2]=(f[Ma>>2]|0)+56}bD(o)}f[o>>2]=0;f[o+4>>2]=0;F=aD(o,9)|0;G=434144;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));$wa(C,o,m)|0;bD(o);f[o>>2]=0;f[o+4>>2]=0;F=aD(o,10)|0;G=424460;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Wwa(C,o,f[bc>>2]|0)|0;bD(o);Ma=f[a+56>>2]|0;Ea=Ma+60|0;ec=f[Ea>>2]|0;if((ec|0)==(f[Ma+64>>2]|0))Cya(Ma+56|0,k);else{Ma=f[k>>2]|0;f[ec>>2]=Ma;f[ec+4>>2]=f[B>>2];if(!Ma)ic=ec;else{ec=Ma+4|0;f[ec>>2]=(f[ec>>2]|0)+1;ic=f[Ea>>2]|0}f[Ea>>2]=ic+8}Ea=f[$b>>2]|0;do if(Ea|0){ec=Ea+12|0;Ma=f[ec>>2]|0;f[ec>>2]=Ma+-1;if((Ma|0)!=1)break;kL(l)}while(0);f[$b>>2]=0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;if((f[Fb>>2]|0)>0){Ea=f[bc>>2]|0;Ma=0;do{f[Ea+(Ma<<2)>>2]=0;Ma=Ma+1|0}while((Ma|0)<(f[Fb>>2]|0))}Fb=f[dc>>2]|0;if((Fb|0)!=(cc|0))UC(Fb);break b}while(0);Fb=(f[B>>2]|0)+8|0;bD(Fb);Ma=aD(Fb,7)|0;b[Ma>>0]=b[411904]|0;b[Ma+1>>0]=b[411905]|0;b[Ma+2>>0]=b[411906]|0;b[Ma+3>>0]=b[411907]|0;b[Ma+4>>0]=b[411908]|0;b[Ma+5>>0]=b[411909]|0;b[Ma+6>>0]=b[411910]|0;Dya(a,i,j);Ma=f[h>>2]|0;if((Ma|0)!=373627?(gTb((Ma|0)==0?1124530:Ma,373627)|0)!=0:0)jc=Ma;else{f[l>>2]=0;f[l+4>>2]=0;Ma=aD(l,4)|0;b[Ma>>0]=112;b[Ma+1>>0]=111;b[Ma+2>>0]=111;b[Ma+3>>0]=108;lxa(C,l,373667)|0;bD(l);f[l>>2]=0;f[l+4>>2]=0;F=aD(l,15)|0;G=373671;H=F+15|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[m>>2]=0;f[m+4>>2]=0;Ma=aD(m,7)|0;b[Ma>>0]=b[373687]|0;b[Ma+1>>0]=b[373688]|0;b[Ma+2>>0]=b[373689]|0;b[Ma+3>>0]=b[373690]|0;b[Ma+4>>0]=b[373691]|0;b[Ma+5>>0]=b[373692]|0;b[Ma+6>>0]=b[373693]|0;Wwa(C,l,Fya(j,m)|0)|0;bD(m);bD(l);jc=f[h>>2]|0}if(!((jc|0)!=373645?(gTb((jc|0)==0?1124530:jc,373645)|0)!=0:0)){f[l>>2]=0;f[l+4>>2]=0;Ma=aD(l,4)|0;b[Ma>>0]=112;b[Ma+1>>0]=111;b[Ma+2>>0]=111;b[Ma+3>>0]=108;lxa(C,l,373695)|0;bD(l)}Gya(i,C);f[l>>2]=0;f[l+4>>2]=0;F=aD(l,9)|0;G=442562;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Ma=f[I>>2]|0;do if(Ma){Fb=f[l>>2]|0;Ea=(Fb|0)==0?1124530:Fb;bc=Ma;while(1){T=f[bc+16>>2]|0;if((Fb|0)==(T|0)){X=138;break}$b=(T|0)==0?1124530:T;if((gTb(Ea,$b)|0)<0)kc=bc;else{if((gTb($b,Ea)|0)>=0){X=142;break}kc=bc+4|0}bc=f[kc>>2]|0;if(!bc){X=140;break}}if((X|0)==138){bD(l);break}else if((X|0)==140){bD(l);X=141;break}else if((X|0)==142){bD(l);break}}else{bD(l);X=141}while(0);if((X|0)==141){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,29)|0;G=373699;H=F+29|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,565);bD(l)}f[l>>2]=0;f[l+4>>2]=0;F=aD(l,9)|0;G=442562;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=aD(o,9)|0;G=442562;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Ma=Gwa(Eya(i,o)|0,-1)|0;b[m>>0]=((Ma|0)!=0|(J|0)!=0)&1;$wa(C,l,m)|0;bD(o);bD(l);Ma=f[a+56>>2]|0;bc=Ma+60|0;Ea=f[bc>>2]|0;if((Ea|0)==(f[Ma+64>>2]|0)){Cya(Ma+56|0,k);break b}Ma=f[k>>2]|0;f[Ea>>2]=Ma;f[Ea+4>>2]=f[B>>2];if(!Ma)lc=Ea;else{Ea=Ma+4|0;f[Ea>>2]=(f[Ea>>2]|0)+1;lc=f[bc>>2]|0}f[bc>>2]=lc+8;break b}while(0);Dya(a,i,j);break}O=(f[B>>2]|0)+8|0;bD(O);F=aD(O,11)|0;G=411994;H=F+11|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Dya(a,i,j);f[l>>2]=0;f[l+4>>2]=0;O=aD(l,6)|0;b[O>>0]=b[373514]|0;b[O+1>>0]=b[373515]|0;b[O+2>>0]=b[373516]|0;b[O+3>>0]=b[373517]|0;b[O+4>>0]=b[373518]|0;b[O+5>>0]=b[373519]|0;O=f[L>>2]|0;x:do if(!O)mc=0;else{bc=f[l>>2]|0;Ea=(bc|0)==0?1124530:bc;Ma=O;while(1){Fb=f[Ma+16>>2]|0;if((bc|0)==(Fb|0)){mc=1;break x}cc=(Fb|0)==0?1124530:Fb;if((gTb(Ea,cc)|0)<0)nc=Ma;else{if((gTb(cc,Ea)|0)>=0){mc=1;break x}nc=Ma+4|0}Ma=f[nc>>2]|0;if(!Ma){mc=0;break}}}while(0);bD(l);if(!mc){f[l>>2]=0;f[l+4>>2]=0;F=aD(l,28)|0;G=373521;H=F+28|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,l,373550,373222,510);bD(l)}O=D+28|0;f[l>>2]=0;f[l+4>>2]=0;Ma=aD(l,6)|0;b[Ma>>0]=b[373514]|0;b[Ma+1>>0]=b[373515]|0;b[Ma+2>>0]=b[373516]|0;b[Ma+3>>0]=b[373517]|0;b[Ma+4>>0]=b[373518]|0;b[Ma+5>>0]=b[373519]|0;Ma=Fya(j,l)|0;Ea=Ma+4|0;bc=D+32|0;cc=f[bc>>2]|0;Fb=D+36|0;if((cc|0)==(f[Fb>>2]|0))v2(O,Ea);else{f[cc>>2]=f[Ea>>2];dc=cc+4|0;$b=Ma+8|0;f[dc>>2]=f[$b>>2];T=cc+8|0;f[T>>2]=f[Ma+12>>2];f[cc+12>>2]=f[Ma+16>>2];f[cc+16>>2]=f[Ma+20>>2];f[cc+20>>2]=f[Ma+24>>2];f[cc+24>>2]=f[Ma+28>>2];f[cc+28>>2]=f[Ma+32>>2];f[cc+32>>2]=f[Ma+36>>2];ec=f[Ma+40>>2]|0;f[cc+36>>2]=ec;f[cc+40>>2]=T;T=cc+48|0;_b=cc+44|0;f[_b>>2]=T;f[T>>2]=0;f[cc+52>>2]=0;if(ec|0){T=ec+12|0;f[T>>2]=(f[T>>2]|0)+1}if((f[$b>>2]|0)<3){$b=f[Ma+48>>2]|0;Ma=f[_b>>2]|0;f[Ma>>2]=f[$b>>2];f[Ma+4>>2]=f[$b+4>>2]}else{f[dc>>2]=0;jL(cc,Ea)}f[bc>>2]=(f[bc>>2]|0)+56}bD(l);f[m>>2]=0;f[m+4>>2]=0;Ea=aD(m,4)|0;b[Ea>>0]=98;b[Ea+1>>0]=105;b[Ea+2>>0]=97;b[Ea+3>>0]=115;Ea=f[L>>2]|0;y:do if(!Ea)oc=0;else{cc=f[m>>2]|0;dc=(cc|0)==0?1124530:cc;$b=Ea;while(1){Ma=f[$b+16>>2]|0;if((cc|0)==(Ma|0)){oc=1;break y}_b=(Ma|0)==0?1124530:Ma;if((gTb(dc,_b)|0)<0)pc=$b;else{if((gTb(_b,dc)|0)>=0){oc=1;break y}pc=$b+4|0}$b=f[pc>>2]|0;if(!$b){oc=0;break}}}while(0);bD(m);b[l>>0]=oc;f[m>>2]=0;f[m+4>>2]=0;F=aD(m,9)|0;G=434144;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));$wa(C,m,l)|0;bD(m);if(b[l>>0]|0){f[m>>2]=0;f[m+4>>2]=0;Ea=aD(m,4)|0;b[Ea>>0]=98;b[Ea+1>>0]=105;b[Ea+2>>0]=97;b[Ea+3>>0]=115;Ea=Fya(j,m)|0;$b=Ea+4|0;dc=f[bc>>2]|0;if((dc|0)==(f[Fb>>2]|0))v2(O,$b);else{f[dc>>2]=f[$b>>2];cc=dc+4|0;_b=Ea+8|0;f[cc>>2]=f[_b>>2];Ma=dc+8|0;f[Ma>>2]=f[Ea+12>>2];f[dc+12>>2]=f[Ea+16>>2];f[dc+16>>2]=f[Ea+20>>2];f[dc+20>>2]=f[Ea+24>>2];f[dc+24>>2]=f[Ea+28>>2];f[dc+28>>2]=f[Ea+32>>2];f[dc+32>>2]=f[Ea+36>>2];T=f[Ea+40>>2]|0;f[dc+36>>2]=T;f[dc+40>>2]=Ma;Ma=dc+48|0;ec=dc+44|0;f[ec>>2]=Ma;f[Ma>>2]=0;f[dc+52>>2]=0;if(T|0){Ma=T+12|0;f[Ma>>2]=(f[Ma>>2]|0)+1}if((f[_b>>2]|0)<3){_b=f[Ea+48>>2]|0;Ea=f[ec>>2]|0;f[Ea>>2]=f[_b>>2];f[Ea+4>>2]=f[_b+4>>2]}else{f[cc>>2]=0;jL(dc,$b)}f[bc>>2]=(f[bc>>2]|0)+56}bD(m)}f[m>>2]=0;f[m+4>>2]=0;F=aD(m,10)|0;G=424460;H=F+10|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[q>>2]=0;f[q+4>>2]=0;F=aD(q,12)|0;G=373566;H=F+12|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bc=Gwa(Eya(i,q)|0,-1)|0;f[o>>2]=bc;Wwa(C,m,o)|0;bD(q);bD(m);Gya(i,C);bc=f[h>>2]|0;if(!((bc|0)!=373493?(gTb((bc|0)==0?1124530:bc,373493)|0)!=0:0)){bc=f[O>>2]|0;if((f[bc+4>>2]|0)==2)qc=bc;else{f[m>>2]=0;f[m+4>>2]=0;F=aD(m,30)|0;G=373579;H=F+30|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,m,373550,373222,525);bD(m);qc=f[O>>2]|0}bc=f[(f[qc+40>>2]|0)+4>>2]|0;f[m>>2]=0;Fb=m+4|0;f[Fb>>2]=0;f[m+8>>2]=0;$b=L5b(16)|0;f[m>>2]=$b;dc=$b+16|0;f[m+8>>2]=dc;f[$b>>2]=0;f[$b+4>>2]=0;f[$b+8>>2]=0;f[$b+12>>2]=0;f[Fb>>2]=dc;f[$b>>2]=f[f[(f[O>>2]|0)+40>>2]>>2];f[o>>2]=0;f[o+4>>2]=0;$b=aD(o,8)|0;dc=$b;b[dc>>0]=107;b[dc+1>>0]=101;b[dc+2>>0]=114;b[dc+3>>0]=110;dc=$b+4|0;b[dc>>0]=101;b[dc+1>>0]=108;b[dc+2>>0]=95;b[dc+3>>0]=104;dc=Gwa(Eya(C,o)|0,-1)|0;f[(f[m>>2]|0)+8>>2]=dc;bD(o);f[o>>2]=0;f[o+4>>2]=0;dc=aD(o,8)|0;$b=dc;b[$b>>0]=107;b[$b+1>>0]=101;b[$b+2>>0]=114;b[$b+3>>0]=110;$b=dc+4|0;b[$b>>0]=101;b[$b+1>>0]=108;b[$b+2>>0]=95;b[$b+3>>0]=119;$b=Gwa(Eya(C,o)|0,-1)|0;f[(f[m>>2]|0)+12>>2]=$b;bD(o);$b=f[m>>2]|0;dc=(bc|0)/(Y(f[$b+12>>2]|0,f[$b+8>>2]|0)|0)|0;f[$b+4>>2]=dc;PN(o,f[O>>2]|0,1,m);dc=f[O>>2]|0;$b=o+36|0;if((dc|0)!=(o|0)){bc=f[$b>>2]|0;if(bc|0){cc=bc+12|0;f[cc>>2]=(f[cc>>2]|0)+1}cc=dc+36|0;bc=f[cc>>2]|0;do if(bc|0){_b=bc+12|0;Ea=f[_b>>2]|0;f[_b>>2]=Ea+-1;if((Ea|0)!=1)break;kL(dc)}while(0);f[cc>>2]=0;bc=dc+16|0;O=dc+4|0;f[bc>>2]=0;f[bc+4>>2]=0;f[bc+8>>2]=0;f[bc+12>>2]=0;if((f[O>>2]|0)>0){Ea=f[dc+40>>2]|0;_b=0;do{f[Ea+(_b<<2)>>2]=0;_b=_b+1|0;rc=f[O>>2]|0}while((_b|0)<(rc|0));f[dc>>2]=f[o>>2];if((rc|0)<3)X=95;else X=97}else{f[dc>>2]=f[o>>2];X=95}do if((X|0)==95){_b=f[o+4>>2]|0;if((_b|0)>=3){X=97;break}f[O>>2]=_b;f[dc+8>>2]=f[o+8>>2];f[dc+12>>2]=f[o+12>>2];_b=f[o+44>>2]|0;Ea=f[dc+44>>2]|0;f[Ea>>2]=f[_b>>2];f[Ea+4>>2]=f[_b+4>>2]}while(0);if((X|0)==97)jL(dc,o);f[bc>>2]=f[o+16>>2];f[dc+20>>2]=f[o+20>>2];f[dc+24>>2]=f[o+24>>2];f[dc+28>>2]=f[o+28>>2];f[dc+32>>2]=f[o+32>>2];f[cc>>2]=f[$b>>2]}O=f[$b>>2]|0;do if(O|0){_b=O+12|0;Ea=f[_b>>2]|0;f[_b>>2]=Ea+-1;if((Ea|0)!=1)break;kL(o)}while(0);f[$b>>2]=0;O=o+16|0;cc=o+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[cc>>2]|0)>0){O=f[o+40>>2]|0;dc=0;do{f[O+(dc<<2)>>2]=0;dc=dc+1|0}while((dc|0)<(f[cc>>2]|0))}cc=f[o+44>>2]|0;if((cc|0)!=(o+48|0))UC(cc);cc=f[m>>2]|0;if(cc|0){dc=f[Fb>>2]|0;if((dc|0)!=(cc|0))f[Fb>>2]=dc+(~((dc+-4-cc|0)>>>2)<<2);O5b(cc)}}cc=f[a+56>>2]|0;dc=cc+60|0;O=f[dc>>2]|0;if((O|0)==(f[cc+64>>2]|0))Cya(cc+56|0,k);else{cc=f[k>>2]|0;f[O>>2]=cc;f[O+4>>2]=f[B>>2];if(!cc)sc=O;else{O=cc+4|0;f[O>>2]=(f[O>>2]|0)+1;sc=f[dc>>2]|0}f[dc>>2]=sc+8}}else X=24;while(0);do if((X|0)==24){D=a+56|0;M=f[D>>2]|0;dc=M+60|0;O=f[dc>>2]|0;if((O|0)==(f[M+64>>2]|0)){Cya(M+56|0,k);tc=B}else{cc=f[k>>2]|0;f[O>>2]=cc;f[O+4>>2]=f[B>>2];if(!cc)uc=O;else{O=cc+4|0;f[O>>2]=(f[O>>2]|0)+1;uc=f[dc>>2]|0}f[dc>>2]=uc+8;tc=B}f[D>>2]=f[tc>>2];Dya(a,i,j);f[D>>2]=M;M=f[h>>2]|0;if((M|0)!=373380?(gTb((M|0)==0?1124530:M,373380)|0)!=0:0)vc=M;else{f[l>>2]=0;f[l+4>>2]=0;F=aD(l,14)|0;G=373433;H=F+14|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=aD(o,14)|0;G=373433;H=F+14|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Fb=Gwa(Eya(i,o)|0,-1)|0;f[m>>2]=Fb;Wwa(C,l,m)|0;bD(o);bD(l);f[l>>2]=0;f[l+4>>2]=0;F=aD(l,15)|0;G=373448;H=F+15|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=aD(o,15)|0;G=373448;H=F+15|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Fb=Gwa(Eya(i,o)|0,-1)|0;f[m>>2]=Fb;Wwa(C,l,m)|0;bD(o);bD(l);vc=f[h>>2]|0}if((vc|0)!=411848?(gTb((vc|0)==0?1124530:vc,411848)|0)!=0:0)wc=vc;else{f[l>>2]=0;f[l+4>>2]=0;F=aD(l,9)|0;G=373464;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=aD(o,9)|0;G=373464;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Fb=Gwa(Eya(i,o)|0,-1)|0;f[m>>2]=Fb;Wwa(C,l,m)|0;bD(o);bD(l);wc=f[h>>2]|0}if((wc|0)!=373401?(gTb((wc|0)==0?1124530:wc,373401)|0)!=0:0)xc=wc;else{f[l>>2]=0;f[l+4>>2]=0;F=aD(l,9)|0;G=373464;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=aD(o,9)|0;G=373464;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Fb=Gwa(Eya(i,o)|0,-1)|0;f[m>>2]=Fb;Wwa(C,l,m)|0;bD(o);bD(l);xc=f[h>>2]|0}if((xc|0)!=373411?gTb((xc|0)==0?1124530:xc,373411)|0:0)break;f[l>>2]=0;f[l+4>>2]=0;F=aD(l,9)|0;G=373464;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));f[o>>2]=0;f[o+4>>2]=0;F=aD(o,9)|0;G=373464;H=F+9|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));Fb=Gwa(Eya(i,o)|0,-1)|0;f[m>>2]=Fb;Wwa(C,l,m)|0;bD(o);bD(l)}while(0);C=f[k>>2]|0;if(C|0?(B=C+4|0,Fb=f[B>>2]|0,f[B>>2]=Fb+-1,(Fb|0)==1):0)bi[f[(f[C>>2]|0)+8>>2]&2047](C);Kya(j,f[L>>2]|0);bua(i,f[I>>2]|0)}while(0);i=f[A>>2]|0;do if(i){j=f[e>>2]|0;k=a+20|0;l=i;while(1){o=f[l+16>>2]|0;if((j|0)<(o|0)){m=f[l>>2]|0;if(!m){X=1158;break}else{yc=l;zc=m}}else{if((o|0)>=(j|0)){X=1162;break}Ac=l+4|0;o=f[Ac>>2]|0;if(!o){X=1161;break}else{yc=Ac;zc=o}}k=yc;l=zc}if((X|0)==1158){Bc=l;Cc=l;break}else if((X|0)==1161){Bc=Ac;Cc=l;break}else if((X|0)==1162){Bc=k;Cc=l;break}}else{Bc=A;Cc=A}while(0);if(!(f[Bc>>2]|0)){A=L5b(20)|0;f[A+16>>2]=f[e>>2];f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=Cc;f[Bc>>2]=A;Cc=f[f[z>>2]>>2]|0;if(!Cc)Dc=A;else{f[z>>2]=Cc;Dc=f[Bc>>2]|0}mP(f[a+20>>2]|0,Dc);Dc=a+24|0;f[Dc>>2]=(f[Dc>>2]|0)+1}bD(h);bD(g);u=d;return}function wya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if((b|0)<0)c=Flb(f[a+12>>2]|0)|0;else c=b;b=a+16|0;d=a+20|0;e=f[d>>2]|0;do if(e){g=e;do{h=f[g+16>>2]|0;if((c|0)<(h|0))i=g;else{if((h|0)>=(c|0)){j=25;break}i=g+4|0}g=f[i>>2]|0}while((g|0)!=0);if((j|0)==25)return;g=a+20|0;h=e;while(1){k=f[h+16>>2]|0;if((c|0)<(k|0)){l=f[h>>2]|0;if(!l){j=13;break}else{m=h;n=l}}else{if((k|0)>=(c|0)){j=17;break}o=h+4|0;k=f[o>>2]|0;if(!k){j=16;break}else{m=o;n=k}}g=m;h=n}if((j|0)==13){p=h;q=h;break}else if((j|0)==16){p=o;q=h;break}else if((j|0)==17){p=g;q=h;break}}else{p=d;q=d}while(0);if(!(f[p>>2]|0)){d=L5b(20)|0;f[d+16>>2]=c;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=q;f[p>>2]=d;q=f[f[b>>2]>>2]|0;if(!q)r=d;else{f[b>>2]=q;r=f[p>>2]|0}mP(f[a+20>>2]|0,r);r=a+24|0;f[r>>2]=(f[r>>2]|0)+1}r=Flb(f[a+12>>2]|0)|0;if((r|0)>0)s=0;else return;do{tya(a);tya(a);s=s+1|0}while((s|0)!=(r|0));return}function xya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=c+12|0;c=Flb(f[g>>2]|0)|0;f[e>>2]=0;h=e+4|0;f[h>>2]=0;if(!c)i=0;else{Nac(aD(e,c)|0,0,c|0)|0;i=f[e>>2]|0}tlb(f[g>>2]|0,(i|0)==0?1124530:i,c)|0;c=f[e>>2]|0;i=f[h>>2]|0;h=c;a:do if(i|0?(j=c+i|0,(i|0)>0):0){k=c;while(1){if((b[k>>0]|0)==86){if(k>>>0>=j>>>0)break a;l=k+1|0;if((b[l>>0]|0)==32)break;else m=l}else m=k+1|0;if(m>>>0<j>>>0)k=m;else break a}if(l>>>0<j>>>0&(k|0)==(c|0)){n=Flb(f[g>>2]|0)|0;f[a>>2]=0;f[a+4>>2]=0;if(!n)o=0;else{Nac(aD(a,n)|0,0,n|0)|0;o=f[a>>2]|0}tlb(f[g>>2]|0,(o|0)==0?1124530:o,n)|0;bD(e);u=d;return}}while(0);f[a>>2]=h;f[a+4>>2]=i;if(!c){bD(e);u=d;return}i=c+-4|0;f[i>>2]=(f[i>>2]|0)+1;bD(e);u=d;return}function yya(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+48|0;g=e+32|0;h=e+24|0;i=e+16|0;j=e+8|0;k=e;l=f[a>>2]|0;m=a+4|0;n=f[m>>2]|0;o=l;if(!n){p=-1;u=e;return p|0}q=b[d>>0]|0;if(!(q<<24>>24)){p=-1;u=e;return p|0}r=l+n|0;if((n|0)>0)s=l;else{p=-1;u=e;return p|0}a:while(1){t=0;v=q;while(1){w=s+t|0;if(v<<24>>24!=(b[w>>0]|0))break;t=t+1|0;if(w>>>0>=r>>>0){p=-1;x=51;break a}v=b[d+t>>0]|0;if(!(v<<24>>24)){x=9;break a}}v=s+1|0;if(v>>>0<r>>>0)s=v;else{p=-1;x=51;break}}if((x|0)==9){if((s|0)!=(l|0)){p=-1;u=e;return p|0}s=kUb(c)|0;b:do if(n>>>0>=s>>>0?(r=n-s|0,q=l+r|0,(r|0)>=0):0){c:do if(!s)y=q;else{r=q;while(1){v=0;while(1){if((b[c+v>>0]|0)!=(b[r+v>>0]|0)){z=v;break}t=v+1|0;if(t>>>0<s>>>0)v=t;else{z=t;break}}if((z|0)==(s|0)){y=r;break c}r=r+-1|0;if(r>>>0<l>>>0){A=-1;break b}}}while(0);A=y-o|0}else A=-1;while(0);o=kUb(c)|0;if((A|0)!=(n-o|0)){p=-1;u=e;return p|0}A=kUb(d)|0;d=n-A-o|0;f[g>>2]=0;o=g+4|0;f[o>>2]=0;c=n>>>0<A>>>0?n:A;A=n-c|0;y=A>>>0>d>>>0?d:A;if(y){if((y|0)==(n|0)){n=l+-4|0;f[n>>2]=(f[n>>2]|0)+1;n=f[a>>2]|0;f[g>>2]=n;f[o>>2]=f[m>>2];B=n}else{n=aD(g,y)|0;Vac(n|0,(f[a>>2]|0)+c|0,y|0)|0;B=f[g>>2]|0}if((B|0)==375879)C=6;else{D=B;x=25}}else{D=0;x=25}do if((x|0)==25)if(gTb((D|0)==0?1124530:D,375879)|0)if(((D|0)!=375886?!((gTb((D|0)==0?1124530:D,375886)|0)==0|(D|0)==375892):0)?(gTb((D|0)==0?1124530:D,375892)|0)!=0:0)if((D|0)!=375897?(gTb((D|0)==0?1124530:D,375897)|0)!=0:0)if((D|0)!=375902?(gTb((D|0)==0?1124530:D,375902)|0)!=0:0)if((D|0)!=375907?(gTb((D|0)==0?1124530:D,375907)|0)!=0:0)if((D|0)==375913)C=4;else{if(!(gTb((D|0)==0?1124530:D,375913)|0)){C=4;break}if((D|0)==375917){C=7;break}if(!(gTb((D|0)==0?1124530:D,375917)|0)){C=7;break}f[k>>2]=0;B=k+4|0;f[B>>2]=0;aD(k,(f[o>>2]|0)+14|0)|0;y=f[k>>2]|0;c=y;n=376851;l=c+14|0;do{b[c>>0]=b[n>>0]|0;c=c+1|0;n=n+1|0}while((c|0)<(l|0));A=f[o>>2]|0;if(A|0)Vac(y+14|0,f[g>>2]|0,A|0)|0;f[j>>2]=0;A=j+4|0;f[A>>2]=0;aD(j,(f[B>>2]|0)+18|0)|0;d=f[B>>2]|0;if(!d)E=0;else{Vac(f[j>>2]|0,f[k>>2]|0,d|0)|0;E=f[B>>2]|0}c=(f[j>>2]|0)+E|0;n=375922;l=c+18|0;do{b[c>>0]=b[n>>0]|0;c=c+1|0;n=n+1|0}while((c|0)<(l|0));f[i>>2]=0;n=i+4|0;f[n>>2]=0;aD(i,(f[m>>2]|0)+(f[A>>2]|0)|0)|0;c=f[A>>2]|0;if(c|0)Vac(f[i>>2]|0,f[j>>2]|0,c|0)|0;c=f[m>>2]|0;if(c|0)Vac((f[i>>2]|0)+(f[A>>2]|0)|0,f[a>>2]|0,c|0)|0;f[h>>2]=0;f[h+4>>2]=0;aD(h,(f[n>>2]|0)+1|0)|0;c=f[n>>2]|0;if(!c)F=0;else{Vac(f[h>>2]|0,f[i>>2]|0,c|0)|0;F=f[n>>2]|0}b[(f[h>>2]|0)+F>>0]=34;bO(-213,h,375941,373222,218);bD(h);bD(i);bD(j);bD(k);bD(g);p=-1;u=e;return p|0}else C=3;else C=1;else C=0;else C=5;else C=6;while(0);bD(g);p=C;u=e;return p|0}else if((x|0)==51){u=e;return p|0}return 0}function zya(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0;e=u;u=u+560|0;g=e+544|0;h=e+40|0;i=e;j=e+428|0;k=e+368|0;l=e+488|0;m=e+256|0;n=e+200|0;o=e+140|0;p=e+80|0;q=e+312|0;r=a+12|0;s=Flb(f[r>>2]|0)|0;t=h+8|0;f[h>>2]=t;v=h+4|0;w=s>>>0>4;f[v>>2]=s;if(w){x=N5b(s>>>0>536870911?-1:s<<3)|0;f[h>>2]=x;y=x}else y=t;x=i+8|0;f[i>>2]=x;z=i+4|0;f[z>>2]=s;if(w){A=N5b(s>>>0>536870911?-1:s<<3)|0;f[i>>2]=A}wlb(f[r>>2]|0,y,s)|0;wlb(f[r>>2]|0,f[i>>2]|0,s)|0;y=Glb(f[r>>2]|0)|0;A=y+-1|0;y=Flb(f[r>>2]|0)|0;if(!((y|0)==4|(y|s|0)==0)){f[g>>2]=0;f[g+4>>2]=0;B=aD(g,60)|0;C=375690;D=B+60|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,g,375751,373222,377);bD(g)}if(!y){y=a+40|0;f[l>>2]=1124007936;E=l+4|0;F=l+8|0;G=l+40|0;B=E;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[G>>2]=F;F=l+48|0;H=l+44|0;f[H>>2]=F;f[F>>2]=0;f[l+52>>2]=0;f[k>>2]=c;I=k+4|0;f[I>>2]=1124007936;J=k+8|0;K=k+12|0;L=k+20|0;M=l+16|0;N=k+40|0;O=l+36|0;P=k+44|0;B=J;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[P>>2]=K;K=k+52|0;Q=k+48|0;f[Q>>2]=K;f[K>>2]=0;f[k+56>>2]=0;f[j>>2]=c;R=j+4|0;f[R>>2]=1124007936;S=j+8|0;T=j+12|0;U=j+20|0;V=j+40|0;W=j+44|0;B=S;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[W>>2]=T;T=j+52|0;X=j+48|0;f[X>>2]=T;f[T>>2]=0;f[j+56>>2]=0;Z=f[Q>>2]|0;f[T>>2]=f[Z>>2];f[j+56>>2]=f[Z+4>>2];Z=a+44|0;_=f[Z>>2]|0;do if(_){$=f[j>>2]|0;aa=a+44|0;ba=_;while(1){ca=f[ba+16>>2]|0;if(($|0)<(ca|0)){da=f[ba>>2]|0;if(!da){ea=13;break}else{fa=ba;ga=da}}else{if((ca|0)>=($|0)){ea=17;break}ha=ba+4|0;ca=f[ha>>2]|0;if(!ca){ea=16;break}else{fa=ha;ga=ca}}aa=fa;ba=ga}if((ea|0)==13){ia=ba;ja=ba;break}else if((ea|0)==16){ia=ha;ja=ba;break}else if((ea|0)==17){ia=aa;ja=ba;break}}else{ia=Z;ja=Z}while(0);if(!(f[ia>>2]|0)){Rya(g,y,j);Z=f[g>>2]|0;f[g>>2]=0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=ja;f[ia>>2]=Z;ja=f[f[y>>2]>>2]|0;if(!ja)ka=Z;else{f[y>>2]=ja;ka=f[ia>>2]|0}mP(f[a+44>>2]|0,ka);ka=a+48|0;f[ka>>2]=(f[ka>>2]|0)+1;ka=f[V>>2]|0;if(ka|0?(ia=ka+12|0,ka=f[ia>>2]|0,f[ia>>2]=ka+-1,(ka|0)==1):0)kL(R)}f[V>>2]=0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;if((f[S>>2]|0)>0){U=f[W>>2]|0;W=0;do{f[U+(W<<2)>>2]=0;W=W+1|0}while((W|0)<(f[S>>2]|0))}S=f[X>>2]|0;if((S|0)!=(T|0))UC(S);S=f[N>>2]|0;if(S|0?(T=S+12|0,S=f[T>>2]|0,f[T>>2]=S+-1,(S|0)==1):0)kL(I);f[N>>2]=0;f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=0;f[L+12>>2]=0;if((f[J>>2]|0)>0){L=f[P>>2]|0;P=0;do{f[L+(P<<2)>>2]=0;P=P+1|0}while((P|0)<(f[J>>2]|0))}J=f[Q>>2]|0;if((J|0)!=(K|0))UC(J);J=f[O>>2]|0;if(J|0?(K=J+12|0,J=f[K>>2]|0,f[K>>2]=J+-1,(J|0)==1):0)kL(l);f[O>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[E>>2]|0)>0){M=f[G>>2]|0;G=0;do{f[M+(G<<2)>>2]=0;G=G+1|0}while((G|0)<(f[E>>2]|0))}E=f[H>>2]|0;if((E|0)!=(F|0))UC(E)}else{E=Flb(f[r>>2]|0)|0;r=a+16|0;F=a+20|0;H=f[F>>2]|0;a:do if(!H)ea=54;else{G=H;while(1){M=f[G+16>>2]|0;if((E|0)<(M|0))la=G;else{if((M|0)>=(E|0))break;la=G+4|0}G=f[la>>2]|0;if(!G){ea=54;break a}}G=a+32|0;ma=d;na=a+28|0;oa=G;pa=G}while(0);if((ea|0)==54){xya(g,a);la=yya(g,373349,373342)|0;if(!((la|0)>-1&(la|0)==(d|0))){f[j>>2]=0;f[j+4>>2]=0;B=aD(j,45)|0;C=375767;D=B+45|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-215,j,375751,373222,390);bD(j)}Aya(a,E,la);la=a+28|0;d=a+32|0;H=f[d>>2]|0;do if(H){G=a+32|0;ba=H;aa=H;while(1){M=f[ba+16>>2]|0;if((E|0)<(M|0)){O=f[ba>>2]|0;if(!O){ea=61;break}else{qa=ba;ra=O}}else{if((M|0)>=(E|0)){ea=65;break}sa=ba+4|0;M=f[sa>>2]|0;if(!M){ea=64;break}else{qa=sa;ra=M}}G=qa;ba=ra;aa=ra}if((ea|0)==61){ta=ba;ua=ba;ea=68;break}else if((ea|0)==64){ta=sa;ua=ba;ea=68;break}else if((ea|0)==65){va=G;wa=ba;xa=aa;ea=67;break}}else{va=d;wa=d;xa=H;ea=67}while(0);if((ea|0)==67)if(!xa){ta=va;ua=wa;ea=68}else ya=xa;if((ea|0)==68){xa=L5b(76)|0;f[xa+16>>2]=E;f[xa+20>>2]=1124007936;wa=xa+28|0;va=xa+60|0;B=xa+24|0;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[va>>2]=wa;wa=xa+68|0;f[xa+64>>2]=wa;f[wa>>2]=0;f[xa+72>>2]=0;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=ua;f[ta>>2]=xa;ua=f[f[la>>2]>>2]|0;if(!ua)za=xa;else{f[la>>2]=ua;za=f[ta>>2]|0}mP(f[a+32>>2]|0,za);za=a+36|0;f[za>>2]=(f[za>>2]|0)+1;ya=xa}xa=f[ya+20>>2]&4095;ya=f[F>>2]|0;do if(ya){za=a+20|0;ta=ya;while(1){ua=f[ta+16>>2]|0;if((E|0)<(ua|0)){wa=f[ta>>2]|0;if(!wa){ea=76;break}else{Aa=ta;Ba=wa}}else{if((ua|0)>=(E|0)){ea=80;break}Ca=ta+4|0;ua=f[Ca>>2]|0;if(!ua){ea=79;break}else{Aa=Ca;Ba=ua}}za=Aa;ta=Ba}if((ea|0)==76){Da=ta;Ea=ta;break}else if((ea|0)==79){Da=Ca;Ea=ta;break}else if((ea|0)==80){Da=za;Ea=ta;break}}else{Da=F;Ea=F}while(0);if(!(f[Da>>2]|0)){F=L5b(20)|0;f[F+16>>2]=E;f[F>>2]=0;f[F+4>>2]=0;f[F+8>>2]=Ea;f[Da>>2]=F;Ea=f[f[r>>2]>>2]|0;if(!Ea)Fa=F;else{f[r>>2]=Ea;Fa=f[Da>>2]|0}mP(f[a+20>>2]|0,Fa);Fa=a+24|0;f[Fa>>2]=(f[Fa>>2]|0)+1}bD(g);ma=xa;na=la;oa=d;pa=d}d=(Y(f[f[h>>2]>>2]|0,f[f[i>>2]>>2]|0)|0)+A|0;la=f[pa>>2]|0;xa=a+32|0;do if(la){Fa=xa;Da=la;Ea=la;while(1){r=f[Da+16>>2]|0;if((E|0)<(r|0)){F=f[Da>>2]|0;if(!F){ea=92;break}else{Ga=Da;Ha=F}}else{if((r|0)>=(E|0)){ea=96;break}Ia=Da+4|0;r=f[Ia>>2]|0;if(!r){ea=95;break}else{Ga=Ia;Ha=r}}Fa=Ga;Da=Ha;Ea=Ha}if((ea|0)==92){Ja=Da;Ka=Da;ea=98;break}else if((ea|0)==95){Ja=Ia;Ka=Da;ea=98;break}else if((ea|0)==96){La=Fa;Ma=Da;Na=Ea;ea=97;break}}else{La=xa;Ma=oa;Na=la;ea=97}while(0);if((ea|0)==97)if(!Na){Ja=La;Ka=Ma;ea=98}else Oa=Na;if((ea|0)==98){Na=L5b(76)|0;f[Na+16>>2]=E;f[Na+20>>2]=1124007936;Ma=Na+28|0;La=Na+60|0;B=Na+24|0;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[La>>2]=Ma;Ma=Na+68|0;f[Na+64>>2]=Ma;f[Ma>>2]=0;f[Na+72>>2]=0;f[Na>>2]=0;f[Na+4>>2]=0;f[Na+8>>2]=Ka;f[Ja>>2]=Na;Ka=f[f[a+28>>2]>>2]|0;if(!Ka)Pa=Na;else{f[na>>2]=Ka;Pa=f[Ja>>2]|0}mP(f[a+32>>2]|0,Pa);Pa=a+36|0;f[Pa>>2]=(f[Pa>>2]|0)+1;Oa=Na}Na=f[Oa+24>>2]|0;if((Na|0)<3)Qa=Y(f[Oa+32>>2]|0,f[Oa+28>>2]|0)|0;else{Pa=f[Oa+60>>2]|0;Oa=0;Ja=1;while(1){Ka=Y(f[Pa+(Oa<<2)>>2]|0,Ja)|0;Oa=Oa+1|0;if((Oa|0)==(Na|0)){Qa=Ka;break}else Ja=Ka}}if(d>>>0>Qa>>>0){f[g>>2]=0;f[g+4>>2]=0;B=aD(g,65)|0;C=375813;D=B+65|0;do{b[B>>0]=b[C>>0]|0;B=B+1|0;C=C+1|0}while((B|0)<(D|0));bO(-201,g,375751,373222,400);bD(g)}C=j+8|0;f[j>>2]=C;Qa=j+4|0;f[Qa>>2]=s;if(w){d=N5b(s>>>0>1073741823?-1:s<<2)|0;f[j>>2]=d;Ra=d}else Ra=C;d=k+8|0;f[k>>2]=d;Ja=k+4|0;f[Ja>>2]=s;if(w){w=N5b(s>>>0>1073741823?-1:s<<2)|0;f[k>>2]=w;Sa=w}else Sa=d;if((s|0)>0){w=f[h>>2]|0;Na=f[i>>2]|0;Oa=(ma>>>3&511)+1<<(47696>>>(ma<<1&14)&3);Pa=s;do{Ka=Pa;Pa=Pa+-1|0;f[Ra+(Pa<<2)>>2]=f[w+(Pa<<3)>>2];Ma=Y(f[Na+(Pa<<3)>>2]|0,Oa)|0;f[Sa+(Pa<<2)>>2]=Ma}while((Ka|0)>1)}Pa=f[pa>>2]|0;pa=a+32|0;do if(Pa){Oa=pa;Na=Pa;w=Pa;while(1){Ka=f[Na+16>>2]|0;if((E|0)<(Ka|0)){Ma=f[Na>>2]|0;if(!Ma){ea=117;break}else{Ta=Na;Ua=Ma}}else{if((Ka|0)>=(E|0)){ea=121;break}Va=Na+4|0;Ka=f[Va>>2]|0;if(!Ka){ea=120;break}else{Ta=Va;Ua=Ka}}Oa=Ta;Na=Ua;w=Ua}if((ea|0)==117){Wa=Na;Xa=Na;ea=123;break}else if((ea|0)==120){Wa=Va;Xa=Na;ea=123;break}else if((ea|0)==121){Ya=Oa;Za=Na;_a=w;ea=122;break}}else{Ya=pa;Za=oa;_a=Pa;ea=122}while(0);if((ea|0)==122)if(!_a){Wa=Ya;Xa=Za;ea=123}else{$a=_a;ab=Sa}if((ea|0)==123){Sa=L5b(76)|0;f[Sa+16>>2]=E;f[Sa+20>>2]=1124007936;E=Sa+28|0;_a=Sa+60|0;B=Sa+24|0;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[_a>>2]=E;E=Sa+68|0;f[Sa+64>>2]=E;f[E>>2]=0;f[Sa+72>>2]=0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=Xa;f[Wa>>2]=Sa;Xa=f[f[a+28>>2]>>2]|0;if(!Xa)bb=Sa;else{f[na>>2]=Xa;bb=f[Wa>>2]|0}mP(f[a+32>>2]|0,bb);bb=a+36|0;f[bb>>2]=(f[bb>>2]|0)+1;$a=Sa;ab=f[k>>2]|0}oL(m,s,Ra,ma,(f[$a+36>>2]|0)+(Y((ma>>>3&511)+1<<(47696>>>(ma<<1&14)&3),A)|0)|0,ab);f[n>>2]=1124007936;ab=n+4|0;A=n+8|0;ma=n+40|0;B=ab;D=B+36|0;do{f[B>>2]=0;B=B+4|0}while((B|0)<(D|0));f[ma>>2]=A;B=n+48|0;D=n+44|0;f[D>>2]=B;f[B>>2]=0;f[n+52>>2]=0;$a=g+8|0;f[$a>>2]=0;f[$a+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=n;OJ(m,g,5,1.0,0.0);$a=a+40|0;f[q>>2]=f[n>>2];Ra=q+4|0;s=f[ab>>2]|0;f[Ra>>2]=s;Sa=q+8|0;f[Sa>>2]=f[A>>2];A=q+12|0;f[A>>2]=f[n+12>>2];bb=q+16|0;Wa=n+16|0;f[bb>>2]=f[Wa>>2];Xa=q+20|0;f[Xa>>2]=f[n+20>>2];na=q+24|0;f[na>>2]=f[n+24>>2];E=q+28|0;f[E>>2]=f[n+28>>2];_a=q+32|0;f[_a>>2]=f[n+32>>2];Za=q+36|0;Ya=n+36|0;Pa=f[Ya>>2]|0;f[Za>>2]=Pa;oa=q+40|0;f[oa>>2]=Sa;pa=q+48|0;Va=q+44|0;f[Va>>2]=pa;f[pa>>2]=0;f[q+52>>2]=0;if(!Pa)cb=s;else{s=Pa+12|0;f[s>>2]=(f[s>>2]|0)+1;cb=f[ab>>2]|0}if((cb|0)<3){cb=f[D>>2]|0;s=f[Va>>2]|0;f[s>>2]=f[cb>>2];f[s+4>>2]=f[cb+4>>2]}else{f[Ra>>2]=0;jL(q,n)}f[p>>2]=c;c=p+4|0;f[c>>2]=f[q>>2];cb=p+8|0;s=f[Ra>>2]|0;f[cb>>2]=s;Pa=p+12|0;f[Pa>>2]=f[Sa>>2];Sa=p+16|0;f[Sa>>2]=f[A>>2];A=p+20|0;f[A>>2]=f[bb>>2];Ua=p+24|0;f[Ua>>2]=f[Xa>>2];Xa=p+28|0;f[Xa>>2]=f[na>>2];na=p+32|0;f[na>>2]=f[E>>2];E=p+36|0;f[E>>2]=f[_a>>2];_a=p+40|0;Ta=f[Za>>2]|0;f[_a>>2]=Ta;Ea=p+44|0;f[Ea>>2]=Pa;Da=p+52|0;Fa=p+48|0;f[Fa>>2]=Da;f[Da>>2]=0;f[p+56>>2]=0;if(!Ta)db=s;else{s=Ta+12|0;f[s>>2]=(f[s>>2]|0)+1;db=f[Ra>>2]|0}if((db|0)<3){db=f[Va>>2]|0;s=f[Fa>>2]|0;f[s>>2]=f[db>>2];f[s+4>>2]=f[db+4>>2]}else{f[cb>>2]=0;jL(c,q)}f[o>>2]=f[p>>2];p=o+4|0;f[p>>2]=f[c>>2];db=o+8|0;s=f[cb>>2]|0;f[db>>2]=s;Ta=o+12|0;f[Ta>>2]=f[Pa>>2];f[o+16>>2]=f[Sa>>2];Sa=o+20|0;f[Sa>>2]=f[A>>2];f[o+24>>2]=f[Ua>>2];f[o+28>>2]=f[Xa>>2];f[o+32>>2]=f[na>>2];f[o+36>>2]=f[E>>2];E=o+40|0;na=f[_a>>2]|0;f[E>>2]=na;Xa=o+44|0;f[Xa>>2]=Ta;Ta=o+52|0;Ua=o+48|0;f[Ua>>2]=Ta;f[Ta>>2]=0;f[o+56>>2]=0;if(!na)eb=s;else{s=na+12|0;f[s>>2]=(f[s>>2]|0)+1;eb=f[cb>>2]|0}if((eb|0)<3){eb=f[Fa>>2]|0;s=f[Ua>>2]|0;f[s>>2]=f[eb>>2];f[s+4>>2]=f[eb+4>>2]}else{f[db>>2]=0;jL(p,c)}eb=a+44|0;s=f[eb>>2]|0;do if(s){na=f[o>>2]|0;Pa=a+44|0;Ka=s;while(1){Ma=f[Ka+16>>2]|0;if((na|0)<(Ma|0)){La=f[Ka>>2]|0;if(!La){ea=147;break}else{fb=Ka;gb=La}}else{if((Ma|0)>=(na|0)){ea=151;break}hb=Ka+4|0;Ma=f[hb>>2]|0;if(!Ma){ea=150;break}else{fb=hb;gb=Ma}}Pa=fb;Ka=gb}if((ea|0)==147){ib=Ka;jb=Ka;break}else if((ea|0)==150){ib=hb;jb=Ka;break}else if((ea|0)==151){ib=Pa;jb=Ka;break}}else{ib=eb;jb=eb}while(0);if(!(f[ib>>2]|0)){Rya(g,$a,o);o=f[g>>2]|0;f[g>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=jb;f[ib>>2]=o;jb=f[f[$a>>2]>>2]|0;if(!jb)kb=o;else{f[$a>>2]=jb;kb=f[ib>>2]|0}mP(f[a+44>>2]|0,kb);kb=a+48|0;f[kb>>2]=(f[kb>>2]|0)+1}kb=f[E>>2]|0;do if(kb|0){a=kb+12|0;ib=f[a>>2]|0;f[a>>2]=ib+-1;if((ib|0)!=1)break;kL(p)}while(0);f[E>>2]=0;f[Sa>>2]=0;f[Sa+4>>2]=0;f[Sa+8>>2]=0;f[Sa+12>>2]=0;if((f[db>>2]|0)>0){Sa=f[Xa>>2]|0;Xa=0;do{f[Sa+(Xa<<2)>>2]=0;Xa=Xa+1|0}while((Xa|0)<(f[db>>2]|0))}db=f[Ua>>2]|0;if((db|0)!=(Ta|0))UC(db);db=f[_a>>2]|0;do if(db|0){Ta=db+12|0;Ua=f[Ta>>2]|0;f[Ta>>2]=Ua+-1;if((Ua|0)!=1)break;kL(c)}while(0);f[_a>>2]=0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[cb>>2]|0)>0){A=f[Ea>>2]|0;Ea=0;do{f[A+(Ea<<2)>>2]=0;Ea=Ea+1|0}while((Ea|0)<(f[cb>>2]|0))}cb=f[Fa>>2]|0;if((cb|0)!=(Da|0))UC(cb);cb=f[Za>>2]|0;do if(cb|0){Da=cb+12|0;Fa=f[Da>>2]|0;f[Da>>2]=Fa+-1;if((Fa|0)!=1)break;kL(q)}while(0);f[Za>>2]=0;f[bb>>2]=0;f[bb+4>>2]=0;f[bb+8>>2]=0;f[bb+12>>2]=0;if((f[Ra>>2]|0)>0){bb=f[oa>>2]|0;oa=0;do{f[bb+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[Ra>>2]|0))}Ra=f[Va>>2]|0;if((Ra|0)!=(pa|0))UC(Ra);Ra=f[Ya>>2]|0;do if(Ra|0){pa=Ra+12|0;Va=f[pa>>2]|0;f[pa>>2]=Va+-1;if((Va|0)!=1)break;kL(n)}while(0);f[Ya>>2]=0;f[Wa>>2]=0;f[Wa+4>>2]=0;f[Wa+8>>2]=0;f[Wa+12>>2]=0;if((f[ab>>2]|0)>0){Wa=f[ma>>2]|0;ma=0;do{f[Wa+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[ab>>2]|0))}ab=f[D>>2]|0;if((ab|0)!=(B|0))UC(ab);ab=m+36|0;B=f[ab>>2]|0;do if(B|0){D=B+12|0;ma=f[D>>2]|0;f[D>>2]=ma+-1;if((ma|0)!=1)break;kL(m)}while(0);f[ab>>2]=0;ab=m+16|0;B=m+4|0;f[ab>>2]=0;f[ab+4>>2]=0;f[ab+8>>2]=0;f[ab+12>>2]=0;if((f[B>>2]|0)>0){ab=f[m+40>>2]|0;ma=0;do{f[ab+(ma<<2)>>2]=0;ma=ma+1|0}while((ma|0)<(f[B>>2]|0))}B=f[m+44>>2]|0;if((B|0)!=(m+48|0))UC(B);B=f[k>>2]|0;if((B|0)!=(d|0)){if(B|0)P5b(B);f[k>>2]=d;f[Ja>>2]=4}Ja=f[j>>2]|0;if((Ja|0)!=(C|0)){if(Ja|0)P5b(Ja);f[j>>2]=C;f[Qa>>2]=4}}Qa=f[i>>2]|0;if((Qa|0)!=(x|0)){if(Qa|0)P5b(Qa);f[i>>2]=x;f[z>>2]=4}z=f[h>>2]|0;if((z|0)==(t|0)){u=e;return}if(z|0)P5b(z);f[h>>2]=t;f[v>>2]=4;u=e;return}function Aya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=u;u=u+256|0;e=d+232|0;g=d+176|0;h=d+60|0;i=d;j=d+120|0;k=a+12|0;l=Glb(f[k>>2]|0)|0;m=(c|0)!=7;f[g>>2]=1124007936;n=g+4|0;o=g+8|0;q=g+40|0;r=n;s=r+36|0;do{f[r>>2]=0;r=r+4|0}while((r|0)<(s|0));f[q>>2]=o;r=g+48|0;s=g+44|0;f[s>>2]=r;f[r>>2]=0;f[g+52>>2]=0;f[e>>2]=1;f[e+4>>2]=l;hL(g,2,e,m?c&4095:6);switch(c|0){case 5:{c=g+16|0;xlb(f[k>>2]|0,f[c>>2]|0,l)|0;t=c;break}case 6:{c=g+16|0;ylb(f[k>>2]|0,f[c>>2]|0,l)|0;t=c;break}case 0:case 1:{c=g+16|0;slb(f[k>>2]|0,f[c>>2]|0,l)|0;t=c;break}case 2:case 3:{c=g+16|0;ulb(f[k>>2]|0,f[c>>2]|0,l)|0;t=c;break}case 4:{c=g+16|0;vlb(f[k>>2]|0,f[c>>2]|0,l)|0;t=c;break}case 7:{c=g+16|0;m=f[c>>2]|0;wlb(f[k>>2]|0,m,l)|0;if(!l)t=c;else{k=l;do{k=k+-1|0;l=m+(k<<3)|0;v=l;p[l>>3]=+((f[v>>2]|0)>>>0)+4294967296.0*+(f[v+4>>2]|0)}while((k|0)!=0);t=c}break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,375673,373222,268);bD(e);t=g+16|0}}c=a+28|0;f[j>>2]=f[g>>2];k=j+4|0;m=f[n>>2]|0;f[k>>2]=m;v=j+8|0;f[v>>2]=f[o>>2];o=j+12|0;f[o>>2]=f[g+12>>2];l=j+16|0;f[l>>2]=f[t>>2];w=j+20|0;f[w>>2]=f[g+20>>2];x=j+24|0;f[x>>2]=f[g+24>>2];y=j+28|0;f[y>>2]=f[g+28>>2];z=j+32|0;f[z>>2]=f[g+32>>2];A=j+36|0;B=g+36|0;C=f[B>>2]|0;f[A>>2]=C;D=j+40|0;f[D>>2]=v;E=j+48|0;F=j+44|0;f[F>>2]=E;f[E>>2]=0;f[j+52>>2]=0;if(!C)G=m;else{m=C+12|0;f[m>>2]=(f[m>>2]|0)+1;G=f[n>>2]|0}if((G|0)<3){G=f[s>>2]|0;m=f[F>>2]|0;f[m>>2]=f[G>>2];f[m+4>>2]=f[G+4>>2]}else{f[k>>2]=0;jL(j,g)}f[i>>2]=b;b=i+4|0;f[b>>2]=f[j>>2];G=i+8|0;m=f[k>>2]|0;f[G>>2]=m;C=i+12|0;f[C>>2]=f[v>>2];v=i+16|0;f[v>>2]=f[o>>2];o=i+20|0;f[o>>2]=f[l>>2];H=i+24|0;f[H>>2]=f[w>>2];w=i+28|0;f[w>>2]=f[x>>2];x=i+32|0;f[x>>2]=f[y>>2];y=i+36|0;f[y>>2]=f[z>>2];z=i+40|0;I=f[A>>2]|0;f[z>>2]=I;J=i+44|0;f[J>>2]=C;K=i+52|0;L=i+48|0;f[L>>2]=K;f[K>>2]=0;f[i+56>>2]=0;if(!I)M=m;else{m=I+12|0;f[m>>2]=(f[m>>2]|0)+1;M=f[k>>2]|0}if((M|0)<3){M=f[F>>2]|0;m=f[L>>2]|0;f[m>>2]=f[M>>2];f[m+4>>2]=f[M+4>>2]}else{f[G>>2]=0;jL(b,j)}f[h>>2]=f[i>>2];i=h+4|0;f[i>>2]=f[b>>2];M=h+8|0;m=f[G>>2]|0;f[M>>2]=m;I=h+12|0;f[I>>2]=f[C>>2];f[h+16>>2]=f[v>>2];v=h+20|0;f[v>>2]=f[o>>2];f[h+24>>2]=f[H>>2];f[h+28>>2]=f[w>>2];f[h+32>>2]=f[x>>2];f[h+36>>2]=f[y>>2];y=h+40|0;x=f[z>>2]|0;f[y>>2]=x;w=h+44|0;f[w>>2]=I;I=h+52|0;H=h+48|0;f[H>>2]=I;f[I>>2]=0;f[h+56>>2]=0;if(!x)N=m;else{m=x+12|0;f[m>>2]=(f[m>>2]|0)+1;N=f[G>>2]|0}if((N|0)<3){N=f[L>>2]|0;m=f[H>>2]|0;f[m>>2]=f[N>>2];f[m+4>>2]=f[N+4>>2]}else{f[M>>2]=0;jL(i,b)}N=a+32|0;m=f[N>>2]|0;do if(m){x=f[h>>2]|0;C=a+32|0;O=m;while(1){P=f[O+16>>2]|0;if((x|0)<(P|0)){Q=f[O>>2]|0;if(!Q){R=30;break}else{S=O;T=Q}}else{if((P|0)>=(x|0)){R=34;break}U=O+4|0;P=f[U>>2]|0;if(!P){R=33;break}else{S=U;T=P}}C=S;O=T}if((R|0)==30){V=O;W=O;break}else if((R|0)==33){V=U;W=O;break}else if((R|0)==34){V=C;W=O;break}}else{V=N;W=N}while(0);if(!(f[V>>2]|0)){Rya(e,c,h);h=f[e>>2]|0;f[e>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=W;f[V>>2]=h;W=f[f[c>>2]>>2]|0;if(!W)X=h;else{f[c>>2]=W;X=f[V>>2]|0}mP(f[a+32>>2]|0,X);X=a+36|0;f[X>>2]=(f[X>>2]|0)+1}X=f[y>>2]|0;if(X|0?(a=X+12|0,X=f[a>>2]|0,f[a>>2]=X+-1,(X|0)==1):0)kL(i);f[y>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[M>>2]|0)>0){v=f[w>>2]|0;w=0;do{f[v+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[M>>2]|0))}M=f[H>>2]|0;if((M|0)!=(I|0))UC(M);M=f[z>>2]|0;if(M|0?(I=M+12|0,M=f[I>>2]|0,f[I>>2]=M+-1,(M|0)==1):0)kL(b);f[z>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[G>>2]|0)>0){o=f[J>>2]|0;J=0;do{f[o+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[G>>2]|0))}G=f[L>>2]|0;if((G|0)!=(K|0))UC(G);G=f[A>>2]|0;if(G|0?(K=G+12|0,G=f[K>>2]|0,f[K>>2]=G+-1,(G|0)==1):0)kL(j);f[A>>2]=0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[k>>2]|0)>0){l=f[D>>2]|0;D=0;do{f[l+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[k>>2]|0))}k=f[F>>2]|0;if((k|0)!=(E|0))UC(k);k=f[B>>2]|0;if(k|0?(E=k+12|0,k=f[E>>2]|0,f[E>>2]=k+-1,(k|0)==1):0)kL(g);f[B>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[n>>2]|0)>0){t=f[q>>2]|0;q=0;do{f[t+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[n>>2]|0))}n=f[s>>2]|0;if((n|0)==(r|0)){u=d;return}UC(n);u=d;return}function Bya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;d=u;u=u+16|0;e=d;g=f[a>>2]|0;h=a+4|0;i=f[h>>2]|0;j=g+i|0;if((i|0)>0)k=g;else{l=0;u=d;return l|0}while(1){if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){m=g;n=16;break}o=k+1|0;if((b[o>>0]|0)==110){if(o>>>0>=j>>>0){m=g;n=16;break}p=k+2|0;if((b[p>>0]|0)==46){n=57;break}}}o=k+1|0;if(o>>>0<j>>>0)k=o;else{m=g;n=16;break}}if((n|0)==57)if(p>>>0<j>>>0&(k|0)==(g|0))q=106184;else{m=g;n=16}do if((n|0)==16){while(1){n=0;if((b[m>>0]|0)==99){if(m>>>0>=j>>>0){r=g;break}k=m+1|0;if((b[k>>0]|0)==117){if(k>>>0>=j>>>0){r=g;break}k=m+2|0;if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){r=g;break}k=m+3|0;if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){r=g;break}s=m+4|0;if((b[s>>0]|0)==46){n=54;break}}}}}k=m+1|0;if(k>>>0<j>>>0){m=k;n=16}else{r=g;break}}if((n|0)==54)if(s>>>0<j>>>0&(m|0)==(g|0)){q=106188;break}else r=g;while(1){if((b[r>>0]|0)==99){if(r>>>0>=j>>>0){t=g;break}k=r+1|0;if((b[k>>0]|0)==117){if(k>>>0>=j>>>0){t=g;break}k=r+2|0;if((b[k>>0]|0)==100){if(k>>>0>=j>>>0){t=g;break}k=r+3|0;if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){t=g;break}k=r+4|0;if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){t=g;break}v=r+5|0;if((b[v>>0]|0)==46){n=47;break}}}}}}k=r+1|0;if(k>>>0<j>>>0)r=k;else{t=g;break}}if((n|0)==47)if(v>>>0<j>>>0&(r|0)==(g|0)){q=106192;break}else t=g;while(1){if((b[t>>0]|0)==102){if(t>>>0>=j>>>0){l=0;n=15;break}k=t+1|0;if((b[k>>0]|0)==98){if(k>>>0>=j>>>0){l=0;n=15;break}k=t+2|0;if((b[k>>0]|0)==99){if(k>>>0>=j>>>0){l=0;n=15;break}k=t+3|0;if((b[k>>0]|0)==117){if(k>>>0>=j>>>0){l=0;n=15;break}k=t+4|0;if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){l=0;n=15;break}k=t+5|0;if((b[k>>0]|0)==110){if(k>>>0>=j>>>0){l=0;n=15;break}w=t+6|0;if((b[w>>0]|0)==46){n=38;break}}}}}}}k=t+1|0;if(k>>>0<j>>>0)t=k;else{l=0;n=15;break}}if((n|0)==15){u=d;return l|0}else if((n|0)==38){if(w>>>0<j>>>0&(t|0)==(g|0)){q=106196;break}else l=0;u=d;return l|0}}while(0);t=kUb(f[q>>2]|0)|0;f[e>>2]=0;q=e+4|0;f[q>>2]=0;j=i>>>0<t>>>0?i:t;t=i-j|0;do if(t|0)if(!j){i=g+-4|0;f[i>>2]=(f[i>>2]|0)+1;f[e>>2]=f[a>>2];f[q>>2]=f[h>>2];break}else{i=aD(e,t)|0;Vac(i|0,(f[a>>2]|0)+j|0,t|0)|0;break}while(0);if((e|0)!=(c|0)){bD(c);t=f[e>>2]|0;if(!t)x=0;else{j=t+-4|0;f[j>>2]=(f[j>>2]|0)+1;x=f[e>>2]|0}f[c>>2]=x;f[c+4>>2]=f[q>>2]}bD(e);l=1;u=d;return l|0}function Cya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)c4b(a);d=a+8|0;k=(f[d>>2]|0)-e|0;e=k>>2;l=k>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(l)if(l>>>0>536870911){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);e=m+(g<<3)|0;h=e;k=m+(l<<3)|0;l=f[b>>2]|0;f[e>>2]=l;f[m+(g<<3)+4>>2]=f[b+4>>2];if(!l){n=j;o=i}else{i=l+4|0;f[i>>2]=(f[i>>2]|0)+1;n=f[c>>2]|0;o=f[a>>2]|0}i=e+8|0;if((n|0)==(o|0)){p=h;q=n;r=n}else{l=n;n=h;h=e;do{e=l;l=l+-8|0;j=f[l>>2]|0;f[h+-8>>2]=j;f[h+-4>>2]=f[e+-4>>2];if(j|0){e=j+4|0;f[e>>2]=(f[e>>2]|0)+1}h=n+-8|0;n=h}while((l|0)!=(o|0));p=n;q=f[a>>2]|0;r=f[c>>2]|0}f[a>>2]=p;f[c>>2]=i;f[d>>2]=k;k=q;if((r|0)!=(k|0)){d=r;do{r=d;d=d+-8|0;i=f[d>>2]|0;if(i|0?(c=i+4|0,p=f[c>>2]|0,f[c>>2]=p+-1,(p|0)==1):0)bi[f[(f[i>>2]|0)+8>>2]&2047](i);f[d>>2]=0;f[r+-4>>2]=0}while((d|0)!=(k|0))}if(!q)return;O5b(q);return}function Dya(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0.0,cc=0;e=u;u=u+336|0;g=e;h=e+320|0;i=e+248|0;j=e+172|0;k=e+240|0;l=e+112|0;m=e+56|0;n=a+12|0;o=Flb(f[n>>2]|0)|0;q=Flb(f[n>>2]|0)|0;a:do if((o|0)==3){r=a+20|0;s=f[r>>2]|0;if(!s){t=r;v=a+16|0;w=20;break}else x=s;while(1){y=f[x+16>>2]|0;if((q|0)<(y|0))z=x;else{if((y|0)>=(q|0)){w=9;break a}z=x+4|0}x=f[z>>2]|0;if(!x){A=r;B=s;w=10;break}}}else w=9;while(0);if((w|0)==9){f[g>>2]=0;f[g+4>>2]=0;C=aD(g,56)|0;x=375471;D=C+56|0;do{b[C>>0]=b[x>>0]|0;C=C+1|0;x=x+1|0}while((C|0)<(D|0));bO(-215,g,375528,373222,280);bD(g);x=a+20|0;A=x;B=f[x>>2]|0;w=10}do if((w|0)==10){x=a+16|0;if(B){z=a+20|0;o=B;while(1){s=f[o+16>>2]|0;if((q|0)<(s|0)){r=f[o>>2]|0;if(!r){w=15;break}else{E=o;F=r}}else{if((s|0)>=(q|0)){w=19;break}G=o+4|0;s=f[G>>2]|0;if(!s){w=18;break}else{E=G;F=s}}z=E;o=F}if((w|0)==15){H=o;I=o;J=x;break}else if((w|0)==18){H=G;I=o;J=x;break}else if((w|0)==19){H=z;I=o;J=x;break}}else{t=A;v=x;w=20}}while(0);if((w|0)==20){H=a+20|0;I=t;J=v}if(!(f[H>>2]|0)){v=L5b(20)|0;f[v+16>>2]=q;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=I;f[H>>2]=v;I=f[f[J>>2]>>2]|0;if(!I)K=v;else{f[J>>2]=I;K=f[H>>2]|0}mP(f[a+20>>2]|0,K);K=a+24|0;f[K>>2]=(f[K>>2]|0)+1}K=Flb(f[n>>2]|0)|0;if((K|0)<=0){u=e;return}H=h+4|0;I=a+56|0;J=a+40|0;v=a+44|0;q=a+28|0;t=a+32|0;A=a+32|0;G=a+36|0;F=g+4|0;E=g+8|0;B=g+40|0;s=g+48|0;r=g+44|0;y=g+52|0;L=i+8|0;M=i+4|0;N=g+16|0;O=g+12|0;P=i+4|0;Q=g+36|0;R=k+4|0;S=a+44|0;T=a+48|0;U=m+4|0;V=m+8|0;W=m+12|0;X=m+16|0;Z=m+20|0;_=m+24|0;$=m+28|0;aa=m+32|0;ba=m+36|0;ca=m+40|0;da=m+48|0;ea=m+44|0;fa=m+52|0;ga=l+4|0;ha=l+8|0;ia=l+12|0;ja=l+16|0;ka=l+20|0;la=l+24|0;ma=l+28|0;na=l+32|0;oa=l+36|0;pa=l+40|0;qa=l+44|0;ra=l+52|0;sa=l+48|0;ta=l+56|0;ua=j+4|0;va=j+8|0;wa=j+12|0;xa=j+16|0;ya=j+20|0;za=j+24|0;Aa=j+28|0;Ba=j+32|0;Ca=j+36|0;Da=j+40|0;Ea=j+44|0;Fa=j+48|0;Ga=j+52|0;Ha=j+60|0;Ia=j+56|0;Ja=j+64|0;Ka=i+4|0;La=i+8|0;Ma=i+12|0;Na=i+16|0;Oa=i+20|0;Pa=i+24|0;Qa=i+28|0;Ra=i+32|0;Sa=i+36|0;Ta=i+40|0;Ua=i+44|0;Va=i+48|0;Wa=i+52|0;Xa=i+60|0;Ya=i+56|0;Za=i+64|0;_a=d+4|0;$a=d+4|0;ab=d+8|0;bb=g+4|0;cb=0;do{db=Alb(f[n>>2]|0)|0;if((Flb(f[n>>2]|0)|0)==2){eb=Flb(f[n>>2]|0)|0;f[h>>2]=0;f[H>>2]=0;if(!eb)fb=0;else{Nac(aD(h,eb)|0,0,eb|0)|0;fb=f[h>>2]|0}tlb(f[n>>2]|0,(fb|0)==0?1124530:fb,eb)|0;eb=Alb(f[n>>2]|0)|0;b:do switch(Flb(f[n>>2]|0)|0){case 4:{gb=Flb(f[n>>2]|0)|0;hb=f[I>>2]|0;ib=(f[hb+60>>2]|0)-(f[hb+56>>2]|0)|0;vya(a,gb);hb=f[v>>2]|0;c:do if(hb|0){jb=hb;while(1){kb=f[jb+16>>2]|0;if((gb|0)<(kb|0))lb=jb;else{if((kb|0)>=(gb|0))break;lb=jb+4|0}jb=f[lb>>2]|0;if(!jb)break c}jb=f[h>>2]|0;f[k>>2]=jb;f[R>>2]=f[H>>2];if(!jb)mb=hb;else{kb=jb+-4|0;f[kb>>2]=(f[kb>>2]|0)+1;mb=f[v>>2]|0}do if(mb){kb=S;jb=mb;nb=mb;while(1){ob=f[jb+16>>2]|0;if((gb|0)<(ob|0)){pb=f[jb>>2]|0;if(!pb){w=44;break}else{qb=jb;rb=pb}}else{if((ob|0)>=(gb|0)){w=48;break}sb=jb+4|0;ob=f[sb>>2]|0;if(!ob){w=47;break}else{qb=sb;rb=ob}}kb=qb;jb=rb;nb=rb}if((w|0)==44){w=0;tb=jb;ub=jb;w=50;break}else if((w|0)==47){w=0;tb=sb;ub=jb;w=50;break}else if((w|0)==48){w=0;vb=kb;wb=jb;xb=nb;w=49;break}}else{vb=v;wb=v;xb=mb;w=49}while(0);if((w|0)==49){w=0;if(!xb){tb=vb;ub=wb;w=50}else yb=xb}if((w|0)==50){w=0;ob=L5b(76)|0;f[ob+16>>2]=gb;f[ob+20>>2]=1124007936;pb=ob+28|0;zb=ob+60|0;C=ob+24|0;D=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(D|0));f[zb>>2]=pb;Ab=ob+68|0;f[ob+64>>2]=Ab;f[Ab>>2]=0;f[ob+72>>2]=0;f[ob>>2]=0;f[ob+4>>2]=0;f[ob+8>>2]=ub;f[tb>>2]=ob;Ab=f[f[J>>2]>>2]|0;if(!Ab)Bb=ob;else{f[J>>2]=Ab;Bb=f[tb>>2]|0}mP(f[S>>2]|0,Bb);f[T>>2]=(f[T>>2]|0)+1;yb=ob}Ab=yb+20|0;f[m>>2]=f[Ab>>2];Cb=yb+24|0;f[U>>2]=f[Cb>>2];f[V>>2]=f[yb+28>>2];f[W>>2]=f[yb+32>>2];f[X>>2]=f[yb+36>>2];f[Z>>2]=f[yb+40>>2];f[_>>2]=f[yb+44>>2];f[$>>2]=f[yb+48>>2];f[aa>>2]=f[yb+52>>2];Db=f[yb+56>>2]|0;f[ba>>2]=Db;f[ca>>2]=V;f[ea>>2]=da;f[da>>2]=0;f[fa>>2]=0;if(Db|0){Eb=Db+12|0;f[Eb>>2]=(f[Eb>>2]|0)+1}if((f[Cb>>2]|0)<3){Cb=f[yb+64>>2]|0;Eb=f[ea>>2]|0;f[Eb>>2]=f[Cb>>2];f[Eb+4>>2]=f[Cb+4>>2]}else{f[U>>2]=0;jL(m,Ab)}f[l>>2]=gb;f[ga>>2]=f[m>>2];Ab=f[U>>2]|0;f[ha>>2]=Ab;f[ia>>2]=f[V>>2];f[ja>>2]=f[W>>2];f[ka>>2]=f[X>>2];f[la>>2]=f[Z>>2];f[ma>>2]=f[_>>2];f[na>>2]=f[$>>2];f[oa>>2]=f[aa>>2];Cb=f[ba>>2]|0;f[pa>>2]=Cb;f[qa>>2]=ia;f[sa>>2]=ra;f[ra>>2]=0;f[ta>>2]=0;if(!Cb)Fb=Ab;else{Ab=Cb+12|0;f[Ab>>2]=(f[Ab>>2]|0)+1;Fb=f[U>>2]|0}if((Fb|0)<3){Ab=f[ea>>2]|0;Cb=f[sa>>2]|0;f[Cb>>2]=f[Ab>>2];f[Cb+4>>2]=f[Ab+4>>2]}else{f[ha>>2]=0;jL(ga,m)}Ab=f[k>>2]|0;f[j>>2]=Ab;f[ua>>2]=f[R>>2];if(Ab|0){Cb=Ab+-4|0;f[Cb>>2]=(f[Cb>>2]|0)+1}f[va>>2]=f[l>>2];f[wa>>2]=f[ga>>2];Cb=f[ha>>2]|0;f[xa>>2]=Cb;f[ya>>2]=f[ia>>2];f[za>>2]=f[ja>>2];f[Aa>>2]=f[ka>>2];f[Ba>>2]=f[la>>2];f[Ca>>2]=f[ma>>2];f[Da>>2]=f[na>>2];f[Ea>>2]=f[oa>>2];Ab=f[pa>>2]|0;f[Fa>>2]=Ab;f[Ga>>2]=ya;f[Ia>>2]=Ha;f[Ha>>2]=0;f[Ja>>2]=0;if(!Ab)Gb=Cb;else{Cb=Ab+12|0;f[Cb>>2]=(f[Cb>>2]|0)+1;Gb=f[ha>>2]|0}if((Gb|0)<3){Cb=f[sa>>2]|0;Ab=f[Ia>>2]|0;f[Ab>>2]=f[Cb>>2];f[Ab+4>>2]=f[Cb+4>>2]}else{f[xa>>2]=0;jL(wa,ga)}Cb=f[j>>2]|0;f[i>>2]=Cb;f[Ka>>2]=f[ua>>2];if(Cb|0){Ab=Cb+-4|0;f[Ab>>2]=(f[Ab>>2]|0)+1}f[La>>2]=f[va>>2];f[Ma>>2]=f[wa>>2];Ab=f[xa>>2]|0;f[Na>>2]=Ab;f[Oa>>2]=f[ya>>2];f[Pa>>2]=f[za>>2];f[Qa>>2]=f[Aa>>2];f[Ra>>2]=f[Ba>>2];f[Sa>>2]=f[Ca>>2];f[Ta>>2]=f[Da>>2];f[Ua>>2]=f[Ea>>2];Cb=f[Fa>>2]|0;f[Va>>2]=Cb;f[Wa>>2]=Oa;f[Ya>>2]=Xa;f[Xa>>2]=0;f[Za>>2]=0;if(!Cb)Hb=Ab;else{Ab=Cb+12|0;f[Ab>>2]=(f[Ab>>2]|0)+1;Hb=f[xa>>2]|0}if((Hb|0)<3){Ab=f[Ia>>2]|0;Cb=f[Ya>>2]|0;f[Cb>>2]=f[Ab>>2];f[Cb+4>>2]=f[Ab+4>>2]}else{f[Na>>2]=0;jL(Ma,wa)}Ab=f[_a>>2]|0;d:do if(!Ab){Ib=_a;Jb=_a}else{Cb=f[i>>2]|0;Eb=(Cb|0)==0?1124530:Cb;Db=f[Ab+16>>2]|0;e:do if((Cb|0)!=(Db|0)){Kb=$a;Lb=Ab;Mb=Db;while(1){Nb=(Mb|0)==0?1124530:Mb;if((gTb(Eb,Nb)|0)<0){Ob=f[Lb>>2]|0;if(!Ob){w=82;break}else{Pb=Lb;Qb=Ob}}else{if((gTb(Nb,Eb)|0)>=0){Rb=Kb;Sb=Lb;break e}Tb=Lb+4|0;Nb=f[Tb>>2]|0;if(!Nb){w=85;break}else{Pb=Tb;Qb=Nb}}Mb=f[Qb+16>>2]|0;if((Cb|0)==(Mb|0)){Rb=Pb;Sb=Qb;break e}else{Kb=Pb;Lb=Qb}}if((w|0)==82){w=0;Ib=Lb;Jb=Lb;break d}else if((w|0)==85){w=0;Ib=Tb;Jb=Lb;break d}}else{Rb=$a;Sb=Ab}while(0);Ib=Rb;Jb=Sb}while(0);if(!(f[Ib>>2]|0)){Lya(g,d,i);Ab=f[g>>2]|0;f[g>>2]=0;f[Ab>>2]=0;f[Ab+4>>2]=0;f[Ab+8>>2]=Jb;f[Ib>>2]=Ab;ob=f[f[d>>2]>>2]|0;if(!ob)Ub=Ab;else{f[d>>2]=ob;Ub=f[Ib>>2]|0}mP(f[$a>>2]|0,Ub);f[ab>>2]=(f[ab>>2]|0)+1}ob=f[Va>>2]|0;do if(ob|0){Ab=ob+12|0;pb=f[Ab>>2]|0;f[Ab>>2]=pb+-1;if((pb|0)!=1)break;kL(Ma)}while(0);f[Va>>2]=0;f[Qa>>2]=0;f[Qa+4>>2]=0;f[Qa+8>>2]=0;f[Qa+12>>2]=0;if((f[Na>>2]|0)>0){ob=f[Wa>>2]|0;pb=0;do{f[ob+(pb<<2)>>2]=0;pb=pb+1|0}while((pb|0)<(f[Na>>2]|0))}pb=f[Ya>>2]|0;if((pb|0)!=(Xa|0))UC(pb);bD(i);pb=f[Fa>>2]|0;do if(pb|0){ob=pb+12|0;Ab=f[ob>>2]|0;f[ob>>2]=Ab+-1;if((Ab|0)!=1)break;kL(wa)}while(0);f[Fa>>2]=0;f[Aa>>2]=0;f[Aa+4>>2]=0;f[Aa+8>>2]=0;f[Aa+12>>2]=0;if((f[xa>>2]|0)>0){pb=f[Ga>>2]|0;Ab=0;do{f[pb+(Ab<<2)>>2]=0;Ab=Ab+1|0}while((Ab|0)<(f[xa>>2]|0))}Ab=f[Ia>>2]|0;if((Ab|0)!=(Ha|0))UC(Ab);bD(j);Ab=f[pa>>2]|0;do if(Ab|0){pb=Ab+12|0;ob=f[pb>>2]|0;f[pb>>2]=ob+-1;if((ob|0)!=1)break;kL(ga)}while(0);f[pa>>2]=0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=0;f[ka+12>>2]=0;if((f[ha>>2]|0)>0){Ab=f[qa>>2]|0;ob=0;do{f[Ab+(ob<<2)>>2]=0;ob=ob+1|0}while((ob|0)<(f[ha>>2]|0))}ob=f[sa>>2]|0;if((ob|0)!=(ra|0))UC(ob);ob=f[ba>>2]|0;do if(ob|0){Ab=ob+12|0;pb=f[Ab>>2]|0;f[Ab>>2]=pb+-1;if((pb|0)!=1)break;kL(m)}while(0);f[ba>>2]=0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[U>>2]|0)>0){ob=f[ca>>2]|0;pb=0;do{f[ob+(pb<<2)>>2]=0;pb=pb+1|0}while((pb|0)<(f[U>>2]|0))}pb=f[ea>>2]|0;if((pb|0)!=(da|0))UC(pb);bD(k);break b}while(0);hb=f[t>>2]|0;f:do if(hb|0){pb=hb;while(1){ob=f[pb+16>>2]|0;if((gb|0)<(ob|0))Vb=pb;else{if((ob|0)>=(gb|0))break;Vb=pb+4|0}pb=f[Vb>>2]|0;if(!pb)break f}pb=A;ob=hb;Ab=hb;while(1){zb=f[ob+16>>2]|0;if((gb|0)<(zb|0)){Cb=f[ob>>2]|0;if(!Cb){Wb=ob;w=138;break}else{Xb=ob;Yb=Cb}}else{if((zb|0)>=(gb|0)){w=137;break}zb=ob+4|0;Cb=f[zb>>2]|0;if(!Cb){Wb=zb;w=138;break}else{Xb=zb;Yb=Cb}}pb=Xb;ob=Yb;Ab=Yb}if((w|0)==137){w=0;if(!Ab){Wb=pb;w=138}else Zb=Ab}if((w|0)==138){w=0;Cb=L5b(76)|0;f[Cb+16>>2]=gb;f[Cb+20>>2]=1124007936;zb=Cb+28|0;Eb=Cb+60|0;C=Cb+24|0;D=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(D|0));f[Eb>>2]=zb;Ab=Cb+68|0;f[Cb+64>>2]=Ab;f[Ab>>2]=0;f[Cb+72>>2]=0;f[Cb>>2]=0;f[Cb+4>>2]=0;f[Cb+8>>2]=ob;f[Wb>>2]=Cb;Ab=f[f[q>>2]>>2]|0;if(!Ab)_b=Cb;else{f[q>>2]=Ab;_b=f[Wb>>2]|0}mP(f[A>>2]|0,_b);f[G>>2]=(f[G>>2]|0)+1;Zb=Cb}Ab=Zb+20|0;f[g>>2]=1124007936;C=F;D=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(D|0));f[B>>2]=E;f[r>>2]=s;f[s>>2]=0;f[y>>2]=0;Cb=L;f[Cb>>2]=0;f[Cb+4>>2]=0;f[i>>2]=33619968;f[M>>2]=g;OJ(Ab,i,6,1.0,0.0);Cb=f[N>>2]|0;ob=f[F>>2]|0;if((ob|0)<3)$b=Y(f[O>>2]|0,f[E>>2]|0)|0;else{zb=f[B>>2]|0;Eb=0;pb=1;while(1){Db=Y(f[zb+(Eb<<2)>>2]|0,pb)|0;Eb=Eb+1|0;if((Eb|0)==(ob|0)){$b=Db;break}else pb=Db}}pb=L5b(16)|0;ob=pb+8|0;f[pb>>2]=ob;f[pb+4>>2]=$b;if($b>>>0>1){Eb=N5b($b>>>0>536870911?-1:$b<<3)|0;f[pb>>2]=Eb;ac=Eb}else ac=ob;f[i>>2]=2;f[P>>2]=pb;if(($b|0)>0){pb=Cb;ob=0;while(1){p[ac+(ob<<3)>>3]=+p[pb>>3];ob=ob+1|0;if((ob|0)==($b|0))break;else pb=pb+8|0}}nxa(c,h,i)|0;gua(i);pb=f[Q>>2]|0;if(pb|0?(ob=pb+12|0,pb=f[ob>>2]|0,f[ob>>2]=pb+-1,(pb|0)==1):0)kL(g);f[Q>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[F>>2]|0)>0){pb=f[B>>2]|0;ob=0;do{f[pb+(ob<<2)>>2]=0;ob=ob+1|0}while((ob|0)<(f[F>>2]|0))}ob=f[r>>2]|0;if((ob|0)!=(s|0))UC(ob);break b}while(0);gb=f[I>>2]|0;hb=gb+60|0;ob=f[hb>>2]|0;if((ob-(f[gb+56>>2]|0)|0)>>>0>ib>>>0){gb=ob;ob=hb;do{hb=gb;pb=hb+-8|0;Cb=hb;do{hb=Cb+-8|0;f[ob>>2]=hb;Eb=f[hb>>2]|0;if(Eb|0?(zb=Eb+4|0,Ab=f[zb>>2]|0,f[zb>>2]=Ab+-1,(Ab|0)==1):0)bi[f[(f[Eb>>2]|0)+8>>2]&2047](Eb);f[hb>>2]=0;f[Cb+-4>>2]=0;Cb=f[ob>>2]|0}while((Cb|0)!=(pb|0));pb=f[I>>2]|0;ob=pb+60|0;gb=f[ob>>2]|0}while((gb-(f[pb+56>>2]|0)|0)>>>0>ib>>>0)}break}case 1:{bc=+Hlb(f[n>>2]|0);p[g>>3]=bc;Mya(c,h,g)|0;break}case 2:{ib=Flb(f[n>>2]|0)|0;f[g>>2]=0;f[bb>>2]=0;if(!ib)cc=0;else{Nac(aD(g,ib)|0,0,ib|0)|0;cc=f[g>>2]|0}tlb(f[n>>2]|0,(cc|0)==0?1124530:cc,ib)|0;Nya(c,h,g)|0;bD(g);break}case 5:{ib=(Flb(f[n>>2]|0)|0)!=0&1;b[g>>0]=ib;$wa(c,h,g)|0;break}default:{zlb(f[n>>2]|0,eb);tya(a)}}while(0);bD(h)}else{zlb(f[n>>2]|0,db);tya(a);tya(a)}cb=cb+1|0}while((cb|0)<(K|0));u=e;return}function Eya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=u;u=u+16|0;e=d+8|0;g=d;h=a+4|0;a=f[h>>2]|0;if(a|0){i=f[c>>2]|0;j=(i|0)==0?1124530:i;k=h;l=a;a:while(1){a=l;while(1){m=f[a+16>>2]|0;if((m|0)==(i|0))break;if((gTb((m|0)==0?1124530:m,j)|0)>=0)break;m=f[a+4>>2]|0;if(!m){n=k;break a}else a=m}l=f[a>>2]|0;if(!l){n=a;break}else k=a}if((n|0)!=(h|0)){k=f[n+16>>2]|0;if((i|0)==(k|0)){o=n;p=o+24|0;u=d;return p|0}if((gTb(j,(k|0)==0?1124530:k)|0)>=0){o=n;p=o+24|0;u=d;return p|0}}}f[g>>2]=0;n=g+4|0;f[n>>2]=0;k=c+4|0;aD(g,(f[k>>2]|0)+19|0)|0;j=f[g>>2]|0;i=j;l=375423;m=i+19|0;do{b[i>>0]=b[l>>0]|0;i=i+1|0;l=l+1|0}while((i|0)<(m|0));q=f[k>>2]|0;if(q|0)Vac(j+19|0,f[c>>2]|0,q|0)|0;f[e>>2]=0;f[e+4>>2]=0;aD(e,(f[n>>2]|0)+27|0)|0;q=f[n>>2]|0;if(!q)r=0;else{Vac(f[e>>2]|0,f[g>>2]|0,q|0)|0;r=f[n>>2]|0}i=(f[e>>2]|0)+r|0;l=375443;m=i+27|0;do{b[i>>0]=b[l>>0]|0;i=i+1|0;l=l+1|0}while((i|0)<(m|0));bO(-204,e,375399,429358,326);bD(e);bD(g);o=h;p=o+24|0;u=d;return p|0}function Fya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;c=a+4|0;d=f[c>>2]|0;a:do if(!d){e=c;g=c;h=d;i=12}else{j=a+4|0;k=f[b>>2]|0;l=(k|0)==0?1124530:k;m=f[d+16>>2]|0;b:do if((k|0)!=(m|0)){n=j;o=d;p=m;q=d;while(1){r=(p|0)==0?1124530:p;if((gTb(l,r)|0)<0){s=f[o>>2]|0;if(!s){i=6;break}else{t=o;u=s}}else{if((gTb(r,l)|0)>=0){v=n;w=o;x=q;break b}y=o+4|0;r=f[y>>2]|0;if(!r){i=9;break}else{t=y;u=r}}p=f[u+16>>2]|0;if((k|0)==(p|0)){v=t;w=u;x=u;break b}else{n=t;o=u;q=u}}if((i|0)==6){z=o;A=o;break a}else if((i|0)==9){z=y;A=o;break a}}else{v=j;w=d;x=d}while(0);e=v;g=w;h=x;i=12}while(0);if((i|0)==12)if(!h){z=e;A=g}else{B=h;C=B+24|0;return C|0}h=L5b(84)|0;g=f[b>>2]|0;f[h+16>>2]=g;f[h+20>>2]=f[b+4>>2];if(g|0){b=g+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[h+24>>2]=0;f[h+28>>2]=1124007936;b=h+36|0;g=h+68|0;e=h+32|0;i=e+36|0;do{f[e>>2]=0;e=e+4|0}while((e|0)<(i|0));f[g>>2]=b;b=h+76|0;f[h+72>>2]=b;f[b>>2]=0;f[h+80>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=A;f[z>>2]=h;A=f[f[a>>2]>>2]|0;if(!A)D=h;else{f[a>>2]=A;D=f[z>>2]|0}mP(f[a+4>>2]|0,D);D=a+8|0;f[D>>2]=(f[D>>2]|0)+1;B=h;C=B+24|0;return C|0}function Gya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+32|0;e=d+16|0;g=d+8|0;h=d;f[e>>2]=0;f[e+4>>2]=0;i=aD(e,8)|0;j=i;b[j>>0]=107;b[j+1>>0]=101;b[j+2>>0]=114;b[j+3>>0]=110;j=i+4|0;b[j>>0]=101;b[j+1>>0]=108;b[j+2>>0]=95;b[j+3>>0]=104;f[h>>2]=0;f[h+4>>2]=0;j=aD(h,2)|0;b[j>>0]=107;b[j+1>>0]=72;j=Gwa(Eya(a,h)|0,-1)|0;f[g>>2]=j;Wwa(c,e,g)|0;bD(h);bD(e);f[e>>2]=0;f[e+4>>2]=0;j=aD(e,8)|0;i=j;b[i>>0]=107;b[i+1>>0]=101;b[i+2>>0]=114;b[i+3>>0]=110;i=j+4|0;b[i>>0]=101;b[i+1>>0]=108;b[i+2>>0]=95;b[i+3>>0]=119;f[h>>2]=0;f[h+4>>2]=0;i=aD(h,2)|0;b[i>>0]=107;b[i+1>>0]=87;i=Gwa(Eya(a,h)|0,-1)|0;f[g>>2]=i;Wwa(c,e,g)|0;bD(h);bD(e);f[e>>2]=0;f[e+4>>2]=0;i=aD(e,8)|0;j=i;b[j>>0]=115;b[j+1>>0]=116;b[j+2>>0]=114;b[j+3>>0]=105;j=i+4|0;b[j>>0]=100;b[j+1>>0]=101;b[j+2>>0]=95;b[j+3>>0]=104;f[h>>2]=0;f[h+4>>2]=0;j=aD(h,2)|0;b[j>>0]=100;b[j+1>>0]=72;j=Gwa(Eya(a,h)|0,-1)|0;f[g>>2]=j;Wwa(c,e,g)|0;bD(h);bD(e);f[e>>2]=0;f[e+4>>2]=0;j=aD(e,8)|0;i=j;b[i>>0]=115;b[i+1>>0]=116;b[i+2>>0]=114;b[i+3>>0]=105;i=j+4|0;b[i>>0]=100;b[i+1>>0]=101;b[i+2>>0]=95;b[i+3>>0]=119;f[h>>2]=0;f[h+4>>2]=0;i=aD(h,2)|0;b[i>>0]=100;b[i+1>>0]=87;i=Gwa(Eya(a,h)|0,-1)|0;f[g>>2]=i;Wwa(c,e,g)|0;bD(h);bD(e);f[e>>2]=0;f[e+4>>2]=0;i=aD(e,5)|0;b[i>>0]=b[374525]|0;b[i+1>>0]=b[374526]|0;b[i+2>>0]=b[374527]|0;b[i+3>>0]=b[374528]|0;b[i+4>>0]=b[374529]|0;f[h>>2]=0;f[h+4>>2]=0;i=aD(h,4)|0;b[i>>0]=112;b[i+1>>0]=97;b[i+2>>0]=100;b[i+3>>0]=72;i=a+4|0;a=f[i>>2]|0;do if(a){j=f[h>>2]|0;k=(j|0)==0?1124530:j;l=i;m=a;a:while(1){n=m;while(1){o=f[n+16>>2]|0;if((o|0)==(j|0))break;if((gTb((o|0)==0?1124530:o,k)|0)>=0)break;o=f[n+4>>2]|0;if(!o){p=l;break a}else n=o}m=f[n>>2]|0;if(!m){p=n;break}else l=n}if((p|0)!=(i|0)){l=f[p+16>>2]|0;if((j|0)!=(l|0)?(gTb(k,(l|0)==0?1124530:l)|0)<=-1:0){q=0;break}l=Gwa(p+24|0,-1)|0;q=l}else q=0}else q=0;while(0);f[g>>2]=q;Wwa(c,e,g)|0;bD(h);bD(e);f[e>>2]=0;f[e+4>>2]=0;q=aD(e,5)|0;b[q>>0]=b[374519]|0;b[q+1>>0]=b[374520]|0;b[q+2>>0]=b[374521]|0;b[q+3>>0]=b[374522]|0;b[q+4>>0]=b[374523]|0;f[h>>2]=0;f[h+4>>2]=0;q=aD(h,4)|0;b[q>>0]=112;b[q+1>>0]=97;b[q+2>>0]=100;b[q+3>>0]=87;q=f[i>>2]|0;if(!q){r=0;f[g>>2]=r;Wwa(c,e,g)|0;bD(h);bD(e);u=d;return}p=f[h>>2]|0;a=(p|0)==0?1124530:p;l=i;m=q;b:while(1){q=m;while(1){o=f[q+16>>2]|0;if((o|0)==(p|0))break;if((gTb((o|0)==0?1124530:o,a)|0)>=0)break;o=f[q+4>>2]|0;if(!o){s=l;break b}else q=o}m=f[q>>2]|0;if(!m){s=q;break}else l=q}if((s|0)==(i|0)){r=0;f[g>>2]=r;Wwa(c,e,g)|0;bD(h);bD(e);u=d;return}i=f[s+16>>2]|0;if((p|0)!=(i|0)?(gTb(a,(i|0)==0?1124530:i)|0)<=-1:0){r=0;f[g>>2]=r;Wwa(c,e,g)|0;bD(h);bD(e);u=d;return}i=Gwa(s+24|0,-1)|0;r=i;f[g>>2]=r;Wwa(c,e,g)|0;bD(h);bD(e);u=d;return}function Hya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0.0;d=u;u=u+16|0;e=d;g=(c|0)==-1;a:do if(g){switch(f[a>>2]|0){case 0:{h=(f[a+4>>2]|0)+4|0;break}case 3:{h=(f[a+4>>2]|0)+4|0;break}case 2:{h=(f[a+4>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);i=15;break a}}if((f[h>>2]|0)==1)j=a;else i=15}else if((c|0)>-1){switch(f[a>>2]|0){case 0:{k=f[(f[a+4>>2]|0)+4>>2]|0;break}case 3:{k=f[(f[a+4>>2]|0)+4>>2]|0;break}case 2:{k=f[(f[a+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);k=-1}}if((k|0)>(c|0))j=a;else i=15}else i=15;while(0);if((i|0)==15){f[e>>2]=0;f[e+4>>2]=0;l=aD(e,56)|0;m=375342;n=l+56|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,e,375399,429358,138);bD(e);j=a}i=g?0:c;c=f[j>>2]|0;switch(c|0){case 2:{o=+p[(f[f[a+4>>2]>>2]|0)+(i<<3)>>3];u=d;return +o}case 0:{j=(f[f[a+4>>2]>>2]|0)+(i<<3)|0;o=+((f[j>>2]|0)>>>0)+4294967296.0*+(f[j+4>>2]|0);u=d;return +o}default:{if((c|2|0)==2){o=0.0;u=d;return +o}f[e>>2]=0;f[e+4>>2]=0;l=aD(e,19)|0;m=375403;n=l+19|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,e,375399,429358,151);bD(e);o=0.0;u=d;return +o}}return +(0.0)}function Iya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1124530:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((gTb((r|0)==0?1124530:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=L5b(16)|0;p=o+8|0;f[p>>2]=0;f[o+12>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;bD(p);o=kUb(c)|0;if(o|0)Vac(aD(p,o)|0,c|0,o|0)|0;$xa(s+24|0,e)|0;gua(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=L5b(16)|0;t=b+8|0;f[t>>2]=0;f[b+12>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;bD(t);b=kUb(c)|0;if(b|0)Vac(aD(t,b)|0,c|0,b|0)|0;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;iua(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;iua(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1124530:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1124530:A;if((gTb(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=28;break}else{E=z;F=C}}else{if((gTb(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=31;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==28){v=z;w=z;break b}else if((D|0)==31){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=L5b(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}iua(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}mP(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}gua(t);bD(e);gua(s);bD(g);gua(i);bD(h);u=d;return c|0}function Jya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1124530:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((gTb((r|0)==0?1124530:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=L5b(16)|0;p=o+8|0;f[p>>2]=0;f[o+12>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;bD(p);o=kUb(c)|0;if(o|0)Vac(aD(p,o)|0,c|0,o|0)|0;$xa(s+24|0,e)|0;gua(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=L5b(16)|0;t=b+8|0;f[t>>2]=0;f[b+12>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;bD(t);b=kUb(c)|0;if(b|0)Vac(aD(t,b)|0,c|0,b|0)|0;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;iua(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;iua(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1124530:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1124530:A;if((gTb(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=28;break}else{E=z;F=C}}else{if((gTb(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=31;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==28){v=z;w=z;break b}else if((D|0)==31){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=L5b(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}iua(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}mP(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}gua(t);bD(e);gua(s);bD(g);gua(i);bD(h);u=d;return c|0}function Kya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;if(!b)return;Kya(a,f[b>>2]|0);Kya(a,f[b+4>>2]|0);a=b+16|0;c=b+28|0;d=b+64|0;e=f[d>>2]|0;if(e|0?(g=e+12|0,e=f[g>>2]|0,f[g>>2]=e+-1,(e|0)==1):0)kL(c);f[d>>2]=0;d=b+44|0;c=b+32|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[c>>2]|0)>0){d=f[b+68>>2]|0;e=0;do{f[d+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[c>>2]|0))}c=f[b+72>>2]|0;if((c|0)!=(b+76|0))UC(c);bD(a);O5b(b);return}function Lya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=L5b(84)|0;e=b+4|0;b=d;g=f[c>>2]|0;f[d+16>>2]=g;f[d+20>>2]=f[c+4>>2];if(g|0){h=g+-4|0;f[h>>2]=(f[h>>2]|0)+1}f[d+24>>2]=f[c+8>>2];h=d+28|0;g=c+12|0;f[h>>2]=f[g>>2];i=d+32|0;j=c+16|0;k=f[j>>2]|0;f[i>>2]=k;l=d+36|0;f[l>>2]=f[c+20>>2];f[d+40>>2]=f[c+24>>2];f[d+44>>2]=f[c+28>>2];f[d+48>>2]=f[c+32>>2];f[d+52>>2]=f[c+36>>2];f[d+56>>2]=f[c+40>>2];f[d+60>>2]=f[c+44>>2];m=f[c+48>>2]|0;f[d+64>>2]=m;f[d+68>>2]=l;l=d+76|0;n=d+72|0;f[n>>2]=l;f[l>>2]=0;f[d+80>>2]=0;if(!m)o=k;else{k=m+12|0;f[k>>2]=(f[k>>2]|0)+1;o=f[j>>2]|0}if((o|0)<3){o=f[c+56>>2]|0;c=f[n>>2]|0;f[c>>2]=f[o>>2];f[c+4>>2]=f[o+4>>2];f[a>>2]=b;p=a+4|0;q=p;r=q;f[r>>2]=e;s=q+4|0;t=s;f[t>>2]=1;return}else{f[i>>2]=0;jL(h,g);f[a>>2]=b;p=a+4|0;q=p;r=q;f[r>>2]=e;s=q+4|0;t=s;f[t>>2]=1;return}}function Mya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1124530:l;n=l;o=j;q=k;a:while(1){r=q;while(1){s=f[r+16>>2]|0;if((s|0)==(l|0))break;if((gTb((s|0)==0?1124530:s,m)|0)>=0)break;s=f[r+4>>2]|0;if(!s){t=o;break a}else r=s}q=f[r>>2]|0;if(!q){t=r;break}else o=r}if((t|0)==(j|0))v=n;else{o=f[t+16>>2]|0;if((l|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){v=n;break}w=+p[c>>3];f[e>>2]=2;o=L5b(16)|0;q=o+8|0;f[o>>2]=q;f[o+4>>2]=1;f[e+4>>2]=o;p[q>>3]=w;$xa(t+24|0,e)|0;gua(e);u=d;return c|0}}else v=f[b>>2]|0;while(0);f[h>>2]=v;t=h+4|0;f[t>>2]=f[b+4>>2];if(v|0){b=v+-4|0;f[b>>2]=(f[b>>2]|0)+1}w=+p[c>>3];f[i>>2]=2;b=L5b(16)|0;v=b+8|0;f[b>>2]=v;f[b+4>>2]=1;f[i+4>>2]=b;p[v>>3]=w;v=f[h>>2]|0;f[g>>2]=v;b=g+4|0;f[b>>2]=f[t>>2];if(v|0){t=v+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=g+8|0;iua(t,i);v=f[g>>2]|0;f[e>>2]=v;k=e+4|0;f[k>>2]=f[b>>2];if(v|0){b=v+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=e+8|0;iua(b,t);v=f[j>>2]|0;b:do if(!v){x=j;y=j}else{q=a+4|0;o=f[e>>2]|0;s=(o|0)==0?1124530:o;z=f[v+16>>2]|0;c:do if((o|0)!=(z|0)){A=q;B=v;C=z;while(1){D=(C|0)==0?1124530:C;if((gTb(s,D)|0)<0){E=f[B>>2]|0;if(!E){F=24;break}else{G=B;H=E}}else{if((gTb(D,s)|0)>=0){I=A;J=B;break c}K=B+4|0;D=f[K>>2]|0;if(!D){F=27;break}else{G=K;H=D}}C=f[H+16>>2]|0;if((o|0)==(C|0)){I=G;J=H;break c}else{A=G;B=H}}if((F|0)==24){x=B;y=B;break b}else if((F|0)==27){x=K;y=B;break b}}else{I=q;J=v}while(0);x=I;y=J}while(0);if(!(f[x>>2]|0)){J=L5b(32)|0;I=f[e>>2]|0;f[J+16>>2]=I;f[J+20>>2]=f[k>>2];if(I|0){k=I+-4|0;f[k>>2]=(f[k>>2]|0)+1}iua(J+24|0,b);f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=y;f[x>>2]=J;y=f[f[a>>2]>>2]|0;if(!y)L=J;else{f[a>>2]=y;L=f[x>>2]|0}mP(f[a+4>>2]|0,L);L=a+8|0;f[L>>2]=(f[L>>2]|0)+1}gua(b);bD(e);gua(t);bD(g);gua(i);bD(h);u=d;return c|0}function Nya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1124530:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((gTb((r|0)==0?1124530:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=L5b(16)|0;p=o+8|0;f[p>>2]=0;r=o+12|0;f[r>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;if((p|0)!=(c|0)){bD(p);o=f[c>>2]|0;if(!o)v=0;else{w=o+-4|0;f[w>>2]=(f[w>>2]|0)+1;v=f[c>>2]|0}f[p>>2]=v;f[r>>2]=f[c+4>>2]}$xa(s+24|0,e)|0;gua(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=L5b(16)|0;t=b+8|0;f[t>>2]=0;v=b+12|0;f[v>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;if((t|0)!=(c|0)){bD(t);b=f[c>>2]|0;if(!b)x=0;else{k=b+-4|0;f[k>>2]=(f[k>>2]|0)+1;x=f[c>>2]|0}f[t>>2]=x;f[v>>2]=f[c+4>>2]}v=f[h>>2]|0;f[g>>2]=v;x=g+4|0;f[x>>2]=f[s>>2];if(v|0){s=v+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;iua(s,i);v=f[g>>2]|0;f[e>>2]=v;t=e+4|0;f[t>>2]=f[x>>2];if(v|0){x=v+-4|0;f[x>>2]=(f[x>>2]|0)+1}x=e+8|0;iua(x,s);v=f[j>>2]|0;b:do if(!v){y=j;z=j}else{k=a+4|0;b=f[e>>2]|0;r=(b|0)==0?1124530:b;p=f[v+16>>2]|0;c:do if((b|0)!=(p|0)){w=k;o=v;A=p;while(1){B=(A|0)==0?1124530:A;if((gTb(r,B)|0)<0){C=f[o>>2]|0;if(!C){D=32;break}else{E=o;F=C}}else{if((gTb(B,r)|0)>=0){G=w;H=o;break c}I=o+4|0;B=f[I>>2]|0;if(!B){D=35;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((b|0)==(A|0)){G=E;H=F;break c}else{w=E;o=F}}if((D|0)==32){y=o;z=o;break b}else if((D|0)==35){y=I;z=o;break b}}else{G=k;H=v}while(0);y=G;z=H}while(0);if(!(f[y>>2]|0)){H=L5b(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[t>>2];if(G|0){t=G+-4|0;f[t>>2]=(f[t>>2]|0)+1}iua(H+24|0,x);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=z;f[y>>2]=H;z=f[f[a>>2]>>2]|0;if(!z)J=H;else{f[a>>2]=z;J=f[y>>2]|0}mP(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}gua(x);bD(e);gua(s);bD(g);gua(i);bD(h);u=d;return c|0}function Oya(a){a=a|0;O5b(a);return}function Pya(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0){Qya(b);O5b(b)}bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Qya(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=a+56|0;c=f[b>>2]|0;if(c|0){d=a+60|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;do{e=h+-8|0;f[d>>2]=e;i=f[e>>2]|0;if(i|0?(j=i+4|0,k=f[j>>2]|0,f[j>>2]=k+-1,(k|0)==1):0)bi[f[(f[i>>2]|0)+8>>2]&2047](i);f[e>>2]=0;f[h+-4>>2]=0;h=f[d>>2]|0}while((h|0)!=(c|0));g=f[b>>2]|0}O5b(g)}fua(a+16|0);bD(a+8|0);bD(a);return}function Rya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=L5b(76)|0;e=b+4|0;b=d;f[d+16>>2]=f[c>>2];g=d+20|0;h=c+4|0;f[g>>2]=f[h>>2];i=d+24|0;j=c+8|0;k=f[j>>2]|0;f[i>>2]=k;l=d+28|0;f[l>>2]=f[c+12>>2];f[d+32>>2]=f[c+16>>2];f[d+36>>2]=f[c+20>>2];f[d+40>>2]=f[c+24>>2];f[d+44>>2]=f[c+28>>2];f[d+48>>2]=f[c+32>>2];f[d+52>>2]=f[c+36>>2];m=f[c+40>>2]|0;f[d+56>>2]=m;f[d+60>>2]=l;l=d+68|0;n=d+64|0;f[n>>2]=l;f[l>>2]=0;f[d+72>>2]=0;if(!m)o=k;else{k=m+12|0;f[k>>2]=(f[k>>2]|0)+1;o=f[j>>2]|0}if((o|0)<3){o=f[c+48>>2]|0;c=f[n>>2]|0;f[c>>2]=f[o>>2];f[c+4>>2]=f[o+4>>2];f[a>>2]=b;p=a+4|0;q=p;r=q;f[r>>2]=e;s=q+4|0;t=s;f[t>>2]=1;return}else{f[i>>2]=0;jL(g,h);f[a>>2]=b;p=a+4|0;q=p;r=q;f[r>>2]=e;s=q+4|0;t=s;f[t>>2]=1;return}}function Sya(a){a=a|0;O5b(a);return}function Tya(a){a=a|0;bi[f[a+12>>2]&2047](f[a+8>>2]|0);if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function Uya(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=u;u=u+96|0;e=d+80|0;g=d+16|0;h=d+8|0;i=d;dQ(e,106244);j=f[b>>2]|0;f[h>>2]=j;f[h+4>>2]=f[b+4>>2];if(j|0){b=j+-4|0;f[b>>2]=(f[b>>2]|0)+1}sya(g,h,c);bD(h);Fua(a);h=f[a>>2]|0;f[i>>2]=h;f[i+4>>2]=f[a+4>>2];if(h|0){a=h+4|0;f[a>>2]=(f[a>>2]|0)+1}Vya(g,i);kva(i);uya(g+40|0,f[g+44>>2]|0);uya(g+28|0,f[g+32>>2]|0);Tua(g+16|0,f[g+20>>2]|0);i=g+8|0;a=f[i>>2]|0;if(a|0?(h=a+4|0,c=f[h>>2]|0,f[h>>2]=c+-1,(c|0)==1):0)bi[f[(f[a>>2]|0)+8>>2]&2047](a);f[i>>2]=0;f[g+12>>2]=0;kva(g);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function Vya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d+24|0;g=d+16|0;h=d;dQ(e,106264);i=a+52|0;if(f[i>>2]|0){f[g>>2]=0;f[g+4>>2]=0;j=aD(g,16)|0;k=376128;l=j+16|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,g,376145,373222,1174);bD(g)}Wya(g,373369);k=f[g+4>>2]|0;f[i>>2]=k;j=a+56|0;f[j>>2]=k;zlb(f[a+12>>2]|0,0);tya(a);k=f[c>>2]|0;l=f[c+4>>2]|0;if(k|0){c=k+4|0;f[c>>2]=(f[c>>2]|0)+1}c=f[a>>2]|0;f[a>>2]=k;f[a+4>>2]=l;if(c|0?(l=c+4|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)bi[f[(f[c>>2]|0)+8>>2]&2047](c);f[h>>2]=0;c=h+4|0;f[c>>2]=0;f[h+8>>2]=0;Xya(a,f[i>>2]|0,h,0,0)|0;f[i>>2]=0;f[j>>2]=0;j=f[h>>2]|0;if(j|0){h=f[c>>2]|0;if((h|0)!=(j|0))f[c>>2]=h+(~((h+-8-j|0)>>>3)<<3);O5b(j)}j=f[g>>2]|0;if(j|0?(g=j+4|0,h=f[g>>2]|0,f[g>>2]=h+-1,(h|0)==1):0)bi[f[(f[j>>2]|0)+8>>2]&2047](j);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function Wya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=u;u=u+16|0;d=c+8|0;e=c;g=L5b(68)|0;f[d>>2]=0;h=d+4|0;f[h>>2]=0;i=kUb(b)|0;if(!i){j=0;k=0}else{Vac(aD(d,i)|0,b|0,i|0)|0;j=f[d>>2]|0;k=f[h>>2]|0}f[e>>2]=0;h=e+4|0;f[h>>2]=0;f[g>>2]=j;f[g+4>>2]=k;if(j){k=j+-4|0;f[k>>2]=(f[k>>2]|0)+1;k=f[e>>2]|0;j=f[h>>2]|0;f[g+8>>2]=k;f[g+12>>2]=j;if(k|0){j=k+-4|0;f[j>>2]=(f[j>>2]|0)+1}}else{f[g+8>>2]=0;f[g+12>>2]=0}j=g+20|0;f[j>>2]=0;f[g+24>>2]=0;f[g+16>>2]=j;j=g+28|0;k=j+40|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=L5b(16)|0;f[j+4>>2]=1;f[j>>2]=106172;f[j+8>>2]=g;f[a>>2]=j;f[a+4>>2]=g;bD(e);bD(d);u=c;return}function Xya(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;h=u;u=u+176|0;i=h+88|0;j=h+136|0;k=h+48|0;l=h+8|0;m=h+120|0;n=h;o=h+112|0;p=h+104|0;if(!c){q=e;u=h;return q|0}r=c+8|0;if(f[c+12>>2]|0){Yya(i,a,r);s=lva(a,i,r,c+16|0)|0;bD(i);tva(a,e,g,s,0);f[i>>2]=s;f[i+4>>2]=c;r=d+4|0;t=f[r>>2]|0;if((t|0)==(f[d+8>>2]|0))Zya(d,i);else{v=i;w=f[v+4>>2]|0;x=t;f[x>>2]=f[v>>2];f[x+4>>2]=w;f[r>>2]=(f[r>>2]|0)+8}q=s;u=h;return q|0}s=f[c>>2]|0;if(((s|0)!=373369?(r=(s|0)==0?1124530:s,!((gTb(r,373369)|0)==0|(s|0)==373423)):0)?gTb(r,373423)|0:0){if((s|0)!=411848?gTb(r,411848)|0:0){if((s|0)!=373411?gTb(r,373411)|0:0){if((s|0)!=373380?gTb(r,373380)|0:0){if((s|0)!=373389?gTb(r,373389)|0:0){do if((s|0)!=373401){if(!(gTb(r,373401)|0))break;do if((s|0)!=374211){if(!(gTb(r,374211)|0))break;do if((s|0)!=374818){if(!(gTb(r,374818)|0))break;f[i>>2]=0;f[i+4>>2]=0;w=c+4|0;aD(i,(f[w>>2]|0)+28|0)|0;x=f[i>>2]|0;y=x;z=376293;A=y+28|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));v=f[w>>2]|0;if(v|0)Vac(x+28|0,f[c>>2]|0,v|0)|0;bO(-3,i,376245,373222,1166);bD(i);q=-1;u=h;return q|0}while(0);v=c+16|0;f[i>>2]=0;f[i+4>>2]=0;y=aD(i,15)|0;z=373671;A=y+15|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));t=f[c+20>>2]|0;a:do if(!t)B=105;else{C=f[i>>2]|0;D=(C|0)==0?1124530:C;E=t;while(1){F=f[E+16>>2]|0;if((C|0)==(F|0))break;G=(F|0)==0?1124530:F;if((gTb(D,G)|0)<0)H=E;else{if((gTb(G,D)|0)>=0)break;H=E+4|0}E=f[H>>2]|0;if(!E){B=105;break a}}bD(i)}while(0);if((B|0)==105){bD(i);f[i>>2]=0;f[i+4>>2]=0;y=aD(i,37)|0;z=376207;A=y+37|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,i,376245,373222,1132);bD(i)}f[i>>2]=0;f[i+4>>2]=0;y=aD(i,15)|0;z=373671;A=y+15|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));t=Gwa(Eya(v,i)|0,-1)|0;bD(i);E=d+4|0;D=f[d>>2]|0;b:do if((f[E>>2]|0)==(D|0)){I=-1;J=0}else{C=i+4|0;x=j+4|0;w=0;G=D;c:while(1){F=G;K=f[(f[F+(w<<3)+4>>2]|0)+8>>2]|0;if(!((K|0)!=411904?(gTb((K|0)==0?1124530:K,411904)|0)!=0:0))B=110;d:do if((B|0)==110){B=0;K=f[F+(w<<3)+4>>2]|0;f[i>>2]=0;f[C>>2]=0;y=aD(i,15)|0;z=373671;A=y+15|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));L=f[K+20>>2]|0;e:do if(L|0){M=f[i>>2]|0;N=(M|0)==0?1124530:M;O=L;while(1){P=f[O+16>>2]|0;if((M|0)==(P|0))break;Q=(P|0)==0?1124530:P;if((gTb(N,Q)|0)<0)R=O;else{if((gTb(Q,N)|0)>=0)break;R=O+4|0}O=f[R>>2]|0;if(!O)break e}O=f[(f[d>>2]|0)+(w<<3)+4>>2]|0;f[j>>2]=0;f[x>>2]=0;y=aD(j,15)|0;z=373671;A=y+15|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));N=Gwa(Eya(O+16|0,j)|0,-1)|0;bD(j);bD(i);if((N|0)==(t|0))break c;else break d}while(0);bD(i)}while(0);F=w+1|0;G=f[d>>2]|0;if(F>>>0>=(f[E>>2]|0)-G>>3>>>0){I=-1;J=0;break b}else w=F}G=f[d>>2]|0;I=f[G+(w<<3)>>2]|0;J=f[G+(w<<3)+4>>2]|0}while(0);f[i>>2]=0;f[i+4>>2]=0;E=aD(i,8)|0;t=E;b[t>>0]=112;b[t+1>>0]=111;b[t+2>>0]=111;b[t+3>>0]=108;t=E+4|0;b[t>>0]=95;b[t+1>>0]=107;b[t+2>>0]=95;b[t+3>>0]=104;f[k>>2]=0;f[k+4>>2]=0;t=aD(k,8)|0;E=t;b[E>>0]=107;b[E+1>>0]=101;b[E+2>>0]=114;b[E+3>>0]=110;E=t+4|0;b[E>>0]=101;b[E+1>>0]=108;b[E+2>>0]=95;b[E+3>>0]=104;E=J+16|0;t=Gwa(Eya(E,k)|0,-1)|0;f[j>>2]=t;Wwa(v,i,j)|0;bD(k);bD(i);f[i>>2]=0;f[i+4>>2]=0;t=aD(i,8)|0;D=t;b[D>>0]=112;b[D+1>>0]=111;b[D+2>>0]=111;b[D+3>>0]=108;D=t+4|0;b[D>>0]=95;b[D+1>>0]=107;b[D+2>>0]=95;b[D+3>>0]=119;f[k>>2]=0;f[k+4>>2]=0;D=aD(k,8)|0;t=D;b[t>>0]=107;b[t+1>>0]=101;b[t+2>>0]=114;b[t+3>>0]=110;t=D+4|0;b[t>>0]=101;b[t+1>>0]=108;b[t+2>>0]=95;b[t+3>>0]=119;t=Gwa(Eya(E,k)|0,-1)|0;f[j>>2]=t;Wwa(v,i,j)|0;bD(k);bD(i);f[i>>2]=0;f[i+4>>2]=0;y=aD(i,13)|0;z=421372;A=y+13|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));f[k>>2]=0;f[k+4>>2]=0;t=aD(k,8)|0;D=t;b[D>>0]=115;b[D+1>>0]=116;b[D+2>>0]=114;b[D+3>>0]=105;D=t+4|0;b[D>>0]=100;b[D+1>>0]=101;b[D+2>>0]=95;b[D+3>>0]=104;D=Gwa(Eya(E,k)|0,-1)|0;f[j>>2]=D;Wwa(v,i,j)|0;bD(k);bD(i);f[i>>2]=0;f[i+4>>2]=0;y=aD(i,13)|0;z=421358;A=y+13|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));f[k>>2]=0;f[k+4>>2]=0;D=aD(k,8)|0;t=D;b[t>>0]=115;b[t+1>>0]=116;b[t+2>>0]=114;b[t+3>>0]=105;t=D+4|0;b[t>>0]=100;b[t+1>>0]=101;b[t+2>>0]=95;b[t+3>>0]=119;t=Gwa(Eya(E,k)|0,-1)|0;f[j>>2]=t;Wwa(v,i,j)|0;bD(k);bD(i);f[i>>2]=0;f[i+4>>2]=0;y=aD(i,10)|0;z=421347;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));f[k>>2]=0;f[k+4>>2]=0;t=aD(k,5)|0;b[t>>0]=b[374525]|0;b[t+1>>0]=b[374526]|0;b[t+2>>0]=b[374527]|0;b[t+3>>0]=b[374528]|0;b[t+4>>0]=b[374529]|0;t=Gwa(Eya(E,k)|0,-1)|0;f[j>>2]=t;Wwa(v,i,j)|0;bD(k);bD(i);f[i>>2]=0;f[i+4>>2]=0;y=aD(i,10)|0;z=421336;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));f[k>>2]=0;f[k+4>>2]=0;t=aD(k,5)|0;b[t>>0]=b[374519]|0;b[t+1>>0]=b[374520]|0;b[t+2>>0]=b[374521]|0;b[t+3>>0]=b[374522]|0;b[t+4>>0]=b[374523]|0;t=Gwa(Eya(E,k)|0,-1)|0;f[j>>2]=t;Wwa(v,i,j)|0;bD(k);bD(i);f[j>>2]=0;f[j+4>>2]=0;y=aD(j,17)|0;z=376250;A=y+17|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Yya(i,a,j);bD(j);f[j>>2]=0;f[j+4>>2]=0;y=aD(j,9)|0;z=410911;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));E=lva(a,i,j,v)|0;bD(j);tva(a,e,0,E,0);if((I|0)==-1){f[j>>2]=0;f[j+4>>2]=0;y=aD(j,24)|0;z=376268;A=y+24|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));bO(-215,j,376245,373222,1159);bD(j)}tva(a,I,1,E,1);bD(i);q=E;u=h;return q|0}while(0);f[j>>2]=0;f[j+4>>2]=0;y=aD(j,14)|0;z=376192;A=y+14|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Yya(i,a,j);bD(j);Iwa(j,a);f[k+4>>2]=0;f[k+8>>2]=0;f[k>>2]=k+4;v=k+12|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;f[v+16>>2]=0;f[v+20>>2]=0;f[v+24>>2]=0;f[l>>2]=0;f[l+4>>2]=0;y=aD(l,9)|0;z=427507;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));lxa(k,l,427522)|0;bD(l);f[l>>2]=0;f[l+4>>2]=0;v=aD(l,7)|0;b[v>>0]=b[410937]|0;b[v+1>>0]=b[410938]|0;b[v+2>>0]=b[410939]|0;b[v+3>>0]=b[410940]|0;b[v+4>>0]=b[410941]|0;b[v+5>>0]=b[410942]|0;b[v+6>>0]=b[410943]|0;v=lva(a,i,l,k)|0;bD(l);t=j+4|0;D=f[j>>2]|0;if((f[t>>2]|0)!=(D|0)){G=0;x=D;do{tva(a,f[x+(G<<2)>>2]|0,0,v,G);G=G+1|0;x=f[j>>2]|0}while(G>>>0<(f[t>>2]|0)-x>>2>>>0)}f[l>>2]=v;f[l+4>>2]=c;x=d+4|0;G=f[x>>2]|0;if((G|0)==(f[d+8>>2]|0))Zya(d,l);else{D=l;C=f[D+4>>2]|0;F=G;f[F>>2]=f[D>>2];f[F+4>>2]=C;f[x>>2]=(f[x>>2]|0)+8}fua(k);x=f[j>>2]|0;if(x|0){C=f[t>>2]|0;if((C|0)!=(x|0))f[t>>2]=C+(~((C+-4-x|0)>>>2)<<2);O5b(x)}bD(i);q=v;u=h;return q|0}while(0);Iwa(i,a);f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=j+4;I=j+12|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;f[I+16>>2]=0;f[I+20>>2]=0;f[I+24>>2]=0;f[k>>2]=0;f[k+4>>2]=0;I=aD(k,4)|0;b[I>>0]=97;b[I+1>>0]=120;b[I+2>>0]=105;b[I+3>>0]=115;f[m>>2]=0;f[m+4>>2]=0;y=aD(m,9)|0;z=373464;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));I=Gwa(Eya(c+16|0,m)|0,-1)|0;f[l>>2]=I+-1;Wwa(j,k,l)|0;bD(m);bD(k);f[l>>2]=0;f[l+4>>2]=0;y=aD(l,10)|0;z=376157;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Yya(k,a,l);f[m>>2]=0;f[m+4>>2]=0;I=aD(m,6)|0;b[I>>0]=b[411848]|0;b[I+1>>0]=b[411849]|0;b[I+2>>0]=b[411850]|0;b[I+3>>0]=b[411851]|0;b[I+4>>0]=b[411852]|0;b[I+5>>0]=b[411853]|0;I=lva(a,k,m,j)|0;bD(m);bD(k);bD(l);f[k>>2]=I;f[k+4>>2]=c;J=d+4|0;R=f[J>>2]|0;if((R|0)==(f[d+8>>2]|0))Zya(d,k);else{B=k;H=f[B+4>>2]|0;r=R;f[r>>2]=f[B>>2];f[r+4>>2]=H;f[J>>2]=(f[J>>2]|0)+8}J=i+4|0;H=f[i>>2]|0;if((f[J>>2]|0)!=(H|0)){r=0;B=H;do{tva(a,f[B+(r<<2)>>2]|0,0,I,r);r=r+1|0;B=f[i>>2]|0}while(r>>>0<(f[J>>2]|0)-B>>2>>>0)}fua(j);B=f[i>>2]|0;if(B|0){r=f[J>>2]|0;if((r|0)!=(B|0))f[J>>2]=r+(~((r+-4-B|0)>>>2)<<2);O5b(B)}q=I;u=h;return q|0}I=a+60|0;f[I>>2]=(f[I>>2]|0)+1;I=c+56|0;B=c+60|0;r=f[I>>2]|0;if(((f[B>>2]|0)-r|0)>0){S=0;T=r}else{q=-1;u=h;return q|0}do{r=Xya(a,f[T+(S<<3)+4>>2]|0,d,e,g)|0;S=S+1|0;T=f[I>>2]|0}while((S|0)<((f[B>>2]|0)-T>>3|0));q=r;u=h;return q|0}f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=j+4;T=j+12|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;f[T+16>>2]=0;f[T+20>>2]=0;f[T+24>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k>>2]=k+4;T=k+12|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;f[T+16>>2]=0;f[T+20>>2]=0;f[T+24>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l>>2]=l+4;T=l+12|0;f[T>>2]=0;f[T+4>>2]=0;f[T+8>>2]=0;f[T+12>>2]=0;f[T+16>>2]=0;f[T+20>>2]=0;f[T+24>>2]=0;f[m>>2]=0;f[m+4>>2]=0;T=aD(m,4)|0;b[T>>0]=97;b[T+1>>0]=120;b[T+2>>0]=105;b[T+3>>0]=115;T=c+16|0;f[o>>2]=0;f[o+4>>2]=0;y=aD(o,14)|0;z=373433;A=y+14|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));B=Gwa(Eya(T,o)|0,-1)|0;f[n>>2]=B+-1;Wwa(j,m,n)|0;bD(o);bD(m);f[m>>2]=0;f[m+4>>2]=0;B=aD(m,4)|0;b[B>>0]=97;b[B+1>>0]=120;b[B+2>>0]=105;b[B+3>>0]=115;f[o>>2]=0;f[o+4>>2]=0;y=aD(o,15)|0;z=373448;A=y+15|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));B=Gwa(Eya(T,o)|0,-1)|0;f[n>>2]=B+-1;Wwa(k,m,n)|0;bD(o);bD(m);f[m>>2]=0;f[m+4>>2]=0;B=aD(m,4)|0;b[B>>0]=97;b[B+1>>0]=120;b[B+2>>0]=105;b[B+3>>0]=115;f[o>>2]=0;f[o+4>>2]=0;B=aD(o,4)|0;b[B>>0]=97;b[B+1>>0]=120;b[B+2>>0]=105;b[B+3>>0]=115;B=Gwa(Eya(j,o)|0,-1)|0;f[n>>2]=B;Wwa(l,m,n)|0;bD(o);bD(m);f[m>>2]=0;f[m+4>>2]=0;B=aD(m,8)|0;T=B;b[T>>0]=110;b[T+1>>0]=117;b[T+2>>0]=109;b[T+3>>0]=95;T=B+4|0;b[T>>0]=97;b[T+1>>0]=120;b[T+2>>0]=101;b[T+3>>0]=115;f[n>>2]=1;Wwa(l,m,n)|0;bD(m);f[n>>2]=0;f[n+4>>2]=0;y=aD(n,10)|0;z=376168;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Yya(m,a,n);f[o>>2]=0;f[o+4>>2]=0;T=aD(o,5)|0;b[T>>0]=b[410749]|0;b[T+1>>0]=b[410750]|0;b[T+2>>0]=b[410751]|0;b[T+3>>0]=b[410752]|0;b[T+4>>0]=b[410753]|0;T=lva(a,m,o,j)|0;bD(o);bD(m);bD(n);f[n>>2]=0;f[n+4>>2]=0;y=aD(n,12)|0;z=376179;A=y+12|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Yya(m,a,n);f[o>>2]=0;f[o+4>>2]=0;B=aD(o,7)|0;b[B>>0]=b[410761]|0;b[B+1>>0]=b[410762]|0;b[B+2>>0]=b[410763]|0;b[B+3>>0]=b[410764]|0;b[B+4>>0]=b[410765]|0;b[B+5>>0]=b[410766]|0;b[B+6>>0]=b[410767]|0;B=lva(a,m,o,l)|0;bD(o);bD(m);bD(n);tva(a,e,g,T,0);f[m>>2]=0;S=m+4|0;f[S>>2]=0;f[m+8>>2]=0;I=c+56|0;r=c+60|0;if(((f[r>>2]|0)-(f[I>>2]|0)|0)>0){J=m+8|0;H=0;do{tva(a,T,H,B,H);R=Xya(a,f[(f[I>>2]|0)+(H<<3)+4>>2]|0,d,B,H)|0;f[i>>2]=R;s=f[S>>2]|0;if((s|0)==(f[J>>2]|0))IO(m,i);else{f[s>>2]=R;f[S>>2]=s+4}H=H+1|0}while((H|0)<((f[r>>2]|0)-(f[I>>2]|0)>>3|0))}f[o>>2]=0;f[o+4>>2]=0;y=aD(o,10)|0;z=376157;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Yya(n,a,o);f[p>>2]=0;f[p+4>>2]=0;I=aD(p,6)|0;b[I>>0]=b[411848]|0;b[I+1>>0]=b[411849]|0;b[I+2>>0]=b[411850]|0;b[I+3>>0]=b[411851]|0;b[I+4>>0]=b[411852]|0;b[I+5>>0]=b[411853]|0;I=lva(a,n,p,k)|0;bD(p);bD(n);bD(o);o=f[m>>2]|0;if((f[S>>2]|0)!=(o|0)){p=0;r=o;do{tva(a,f[r+(p<<2)>>2]|0,0,I,p);p=p+1|0;r=f[m>>2]|0}while(p>>>0<(f[S>>2]|0)-r>>2>>>0)}f[n>>2]=I;f[n+4>>2]=c;r=d+4|0;p=f[r>>2]|0;if((p|0)==(f[d+8>>2]|0))Zya(d,n);else{o=n;H=f[o+4>>2]|0;J=p;f[J>>2]=f[o>>2];f[J+4>>2]=H;f[r>>2]=(f[r>>2]|0)+8}r=f[m>>2]|0;if(r|0){H=f[S>>2]|0;if((H|0)!=(r|0))f[S>>2]=H+(~((H+-4-r|0)>>>2)<<2);O5b(r)}fua(l);fua(k);fua(j);q=I;u=h;return q|0}f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=j+4;I=j+12|0;f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=0;f[I+12>>2]=0;f[I+16>>2]=0;f[I+20>>2]=0;f[I+24>>2]=0;f[k>>2]=0;f[k+4>>2]=0;I=aD(k,4)|0;b[I>>0]=97;b[I+1>>0]=120;b[I+2>>0]=105;b[I+3>>0]=115;f[m>>2]=0;f[m+4>>2]=0;y=aD(m,9)|0;z=373464;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));I=Gwa(Eya(c+16|0,m)|0,-1)|0;f[l>>2]=I+-1;Wwa(j,k,l)|0;bD(m);bD(k);f[k>>2]=0;f[k+4>>2]=0;I=aD(k,7)|0;b[I>>0]=b[441015]|0;b[I+1>>0]=b[441016]|0;b[I+2>>0]=b[441017]|0;b[I+3>>0]=b[441018]|0;b[I+4>>0]=b[441019]|0;b[I+5>>0]=b[441020]|0;b[I+6>>0]=b[441021]|0;b[l>>0]=1;$wa(j,k,l)|0;bD(k);f[k>>2]=0;I=k+4|0;f[I>>2]=0;f[k+8>>2]=0;r=c+56|0;H=c+60|0;S=f[r>>2]|0;if(((f[H>>2]|0)-S|0)>0){J=k+8|0;o=0;p=S;do{S=Xya(a,f[p+(o<<3)+4>>2]|0,d,e,g)|0;f[i>>2]=S;B=f[I>>2]|0;if((B|0)==(f[J>>2]|0))IO(k,i);else{f[B>>2]=S;f[I>>2]=B+4}o=o+1|0;p=f[r>>2]|0}while((o|0)<((f[H>>2]|0)-p>>3|0))}f[m>>2]=0;f[m+4>>2]=0;y=aD(m,10)|0;z=376157;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Yya(l,a,m);f[n>>2]=0;f[n+4>>2]=0;p=aD(n,6)|0;b[p>>0]=b[411848]|0;b[p+1>>0]=b[411849]|0;b[p+2>>0]=b[411850]|0;b[p+3>>0]=b[411851]|0;b[p+4>>0]=b[411852]|0;b[p+5>>0]=b[411853]|0;p=lva(a,l,n,j)|0;bD(n);bD(l);bD(m);H=f[k>>2]|0;if((f[I>>2]|0)!=(H|0)){o=0;r=H;do{tva(a,f[r+(o<<2)>>2]|0,0,p,o);o=o+1|0;r=f[k>>2]|0}while(o>>>0<(f[I>>2]|0)-r>>2>>>0)}f[l>>2]=p;f[l+4>>2]=c;r=d+4|0;o=f[r>>2]|0;if((o|0)==(f[d+8>>2]|0))Zya(d,l);else{H=l;J=f[H+4>>2]|0;B=o;f[B>>2]=f[H>>2];f[B+4>>2]=J;f[r>>2]=(f[r>>2]|0)+8}r=f[k>>2]|0;if(r|0){J=f[I>>2]|0;if((J|0)!=(r|0))f[I>>2]=J+(~((J+-4-r|0)>>>2)<<2);O5b(r)}fua(j);q=p;u=h;return q|0}f[j+4>>2]=0;f[j+8>>2]=0;f[j>>2]=j+4;p=j+12|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[p+24>>2]=0;f[k>>2]=0;f[k+4>>2]=0;p=aD(k,4)|0;b[p>>0]=97;b[p+1>>0]=120;b[p+2>>0]=105;b[p+3>>0]=115;f[m>>2]=0;f[m+4>>2]=0;y=aD(m,9)|0;z=373464;A=y+9|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));p=Gwa(Eya(c+16|0,m)|0,-1)|0;f[l>>2]=p+-1;Wwa(j,k,l)|0;bD(m);bD(k);f[k>>2]=0;p=k+4|0;f[p>>2]=0;f[k+8>>2]=0;r=c+56|0;J=c+60|0;I=f[r>>2]|0;if(((f[J>>2]|0)-I|0)>0){B=k+8|0;H=0;o=I;do{I=Xya(a,f[o+(H<<3)+4>>2]|0,d,e,g)|0;f[i>>2]=I;S=f[p>>2]|0;if((S|0)==(f[B>>2]|0))IO(k,i);else{f[S>>2]=I;f[p>>2]=S+4}H=H+1|0;o=f[r>>2]|0}while((H|0)<((f[J>>2]|0)-o>>3|0))}o=a+60|0;f[o>>2]=(f[o>>2]|0)+1;f[m>>2]=0;f[m+4>>2]=0;y=aD(m,10)|0;z=376157;A=y+10|0;do{b[y>>0]=b[z>>0]|0;y=y+1|0;z=z+1|0}while((y|0)<(A|0));Yya(l,a,m);f[n>>2]=0;f[n+4>>2]=0;z=aD(n,6)|0;b[z>>0]=b[411848]|0;b[z+1>>0]=b[411849]|0;b[z+2>>0]=b[411850]|0;b[z+3>>0]=b[411851]|0;b[z+4>>0]=b[411852]|0;b[z+5>>0]=b[411853]|0;z=lva(a,l,n,j)|0;bD(n);bD(l);bD(m);m=f[k>>2]|0;if((f[p>>2]|0)!=(m|0)){n=0;y=m;do{tva(a,f[y+(n<<2)>>2]|0,0,z,n);n=n+1|0;y=f[k>>2]|0}while(n>>>0<(f[p>>2]|0)-y>>2>>>0)}f[l>>2]=z;f[l+4>>2]=c;y=d+4|0;n=f[y>>2]|0;if((n|0)==(f[d+8>>2]|0))Zya(d,l);else{m=l;l=f[m+4>>2]|0;A=n;f[A>>2]=f[m>>2];f[A+4>>2]=l;f[y>>2]=(f[y>>2]|0)+8}y=f[k>>2]|0;if(y|0){k=f[p>>2]|0;if((k|0)!=(y|0))f[p>>2]=k+(~((k+-4-y|0)>>>2)<<2);O5b(y)}fua(j);q=z;u=h;return q|0}z=c+56|0;j=c+60|0;c=f[z>>2]|0;if((f[j>>2]|0)==(c|0)){q=e;u=h;return q|0}else{U=e;V=g;W=0;X=c}while(1){c=Xya(a,f[X+(W<<3)+4>>2]|0,d,U,V)|0;W=W+1|0;X=f[z>>2]|0;if(W>>>0>=(f[j>>2]|0)-X>>3>>>0){q=c;break}else{U=c;V=0}}u=h;return q|0}function Yya(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=u;u=u+176|0;g=e+160|0;h=e+24|0;i=e+16|0;j=e+8|0;k=e;l=c+60|0;f[l>>2]=(f[l>>2]|0)+1;c=h+56|0;m=h+4|0;f[h>>2]=18164;f[c>>2]=18184;RXb(h+56|0,m);f[h+128>>2]=0;f[h+132>>2]=-1;f[h>>2]=43248;f[c>>2]=43268;WXb(m);f[m>>2]=43284;c=h+36|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[h+52>>2]=16;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;qP(m,g);if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);iYb(h,f[l>>2]|0)|0;sP(g,m);f[k>>2]=0;m=k+4|0;f[m>>2]=0;l=g+11|0;c=b[l>>0]|0;n=c<<24>>24<0?f[g+4>>2]|0:c&255;if(!n)o=c;else{c=aD(k,n)|0;Vac(c|0,((b[l>>0]|0)<0?f[g>>2]|0:g)|0,n|0)|0;o=b[l>>0]|0}if(o<<24>>24<0)O5b(f[g>>2]|0);tP(h);f[j>>2]=0;h=j+4|0;f[h>>2]=0;aD(j,(f[m>>2]|0)+1|0)|0;b[f[j>>2]>>0]=108;g=f[m>>2]|0;if(g|0)Vac((f[j>>2]|0)+1|0,f[k>>2]|0,g|0)|0;f[i>>2]=0;g=i+4|0;f[g>>2]=0;aD(i,(f[h>>2]|0)+1|0)|0;m=f[h>>2]|0;if(!m)p=0;else{Vac(f[i>>2]|0,f[j>>2]|0,m|0)|0;p=f[h>>2]|0}b[(f[i>>2]|0)+p>>0]=95;f[a>>2]=0;f[a+4>>2]=0;p=d+4|0;aD(a,(f[p>>2]|0)+(f[g>>2]|0)|0)|0;h=f[g>>2]|0;if(h|0)Vac(f[a>>2]|0,f[i>>2]|0,h|0)|0;h=f[p>>2]|0;if(!h){bD(i);bD(j);bD(k);u=e;return}Vac((f[a>>2]|0)+(f[g>>2]|0)|0,f[d>>2]|0,h|0)|0;bD(i);bD(j);bD(k);u=e;return}function Zya(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>3;h=g+1|0;if(h>>>0>536870911)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>2;l=j>>3>>>0<268435455?(k>>>0<h>>>0?h:k):536870911;do if(l)if(l>>>0>536870911){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<3)|0;break}else m=0;while(0);k=m+(g<<3)|0;h=b;b=f[h+4>>2]|0;j=k;f[j>>2]=f[h>>2];f[j+4>>2]=b;b=k+(0-g<<3)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+8;f[i>>2]=m+(l<<3);if(!d)return;O5b(d);return}function _ya(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+256|0;g=e+240|0;h=e+8|0;i=e;j=f[c>>2]|0;c=f[d>>2]|0;d=(c|0)==0?1124530:c;N5a(h);c=h+104|0;N5a(c);f[h+208>>2]=0;k=h+212|0;f[k>>2]=0;f[h+216>>2]=0;f[h+224>>2]=0;f[h+228>>2]=0;l=h+224|0;f[h+220>>2]=l;dQ(g,106284);hAa((j|0)==0?1124530:j,h);if(b[d>>0]|0)iAa(d,c);Fua(a);d=f[a>>2]|0;f[i>>2]=d;f[i+4>>2]=f[a+4>>2];if(d|0){a=d+4|0;f[a>>2]=(f[a>>2]|0)+1}$ya(h,i);kva(i);Wta(h+220|0,f[l>>2]|0);l=h+208|0;i=f[l>>2]|0;if(!i){g6a(c);g6a(h);u=e;return}a=f[k>>2]|0;if((a|0)==(i|0))m=i;else{d=a;while(1){a=d+-20|0;f[k>>2]=a;if((b[a+11>>0]|0)<0){O5b(f[a>>2]|0);n=f[k>>2]|0}else n=a;if((n|0)==(i|0))break;else d=n}m=f[l>>2]|0}O5b(m);g6a(c);g6a(h);u=e;return}function $ya(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0;d=u;u=u+336|0;e=d+304|0;g=d+168|0;h=d+112|0;i=d+96|0;j=d+80|0;k=d+72|0;l=d+56|0;m=d+48|0;n=d+40|0;o=d;dQ(k,106304);p=f[a+64>>2]|0;q=a+220|0;r=a+224|0;Wta(q,f[r>>2]|0);f[a+228>>2]=0;f[q>>2]=r;f[r>>2]=0;r=a+208|0;s=f[r>>2]|0;t=a+212|0;v=f[t>>2]|0;if((v|0)==(s|0)){w=v;x=r;y=s}else{z=v;while(1){v=z+-20|0;f[t>>2]=v;if((b[v+11>>0]|0)<0){O5b(f[v>>2]|0);A=f[t>>2]|0}else A=v;if((A|0)==(s|0))break;else z=A}w=A;x=r;y=f[r>>2]|0}A=w;z=p+1|0;s=a+216|0;v=y;if((((f[s>>2]|0)-y|0)/20|0)>>>0<z>>>0){if(z>>>0>214748364){B=ze(8)|0;T5b(B,477177);f[B>>2]=149528;If(B|0,25408,1411)}B=L5b(z*20|0)|0;C=B+(((A-y|0)/20|0)*20|0)|0;y=C;D=B+(z*20|0)|0;if((w|0)==(v|0)){E=y;F=A;G=v}else{A=w;w=y;z=C;do{C=A;A=A+-20|0;X5b(z+-20|0,A);B=C+-8|0;C=f[B+4>>2]|0;H=z+-8|0;f[H>>2]=f[B>>2];f[H+4>>2]=C;z=w+-20|0;w=z}while((A|0)!=(v|0));E=w;F=f[x>>2]|0;G=f[t>>2]|0}f[x>>2]=E;f[t>>2]=y;f[s>>2]=D;D=F;if((G|0)!=(D|0)){y=G;do{y=y+-20|0;if((b[y+11>>0]|0)<0)O5b(f[y>>2]|0)}while((y|0)!=(D|0))}if(F|0)O5b(F)}F=a+20|0;aza(l,f[F>>2]|0);a:do if((f[F>>2]|0)>0){D=a+28|0;y=e+12|0;G=e+16|0;E=e+11|0;w=0;while(1){X5b(e,f[(f[D>>2]|0)+4+(w<<2)>>2]|0);f[y>>2]=0;f[G>>2]=w;v=f[t>>2]|0;A=f[s>>2]|0;z=A;if((v|0)==(A|0)){A=f[x>>2]|0;C=(v-A|0)/20|0;H=C+1|0;if(H>>>0>214748364){I=26;break}B=(z-A|0)/20|0;A=B<<1;z=B>>>0<107374182?(A>>>0<H>>>0?H:A):214748364;if(!z)J=0;else{if(z>>>0>214748364){I=29;break}J=L5b(z*20|0)|0}A=J+(C*20|0)|0;H=A;B=J+(z*20|0)|0;X5b(A,e);z=y;K=f[z+4>>2]|0;L=J+(C*20|0)+12|0;f[L>>2]=f[z>>2];f[L+4>>2]=K;K=A+20|0;L=f[r>>2]|0;z=f[t>>2]|0;if((z|0)==(L|0)){M=H;N=L;O=L}else{C=z;z=H;H=A;do{A=C;C=C+-20|0;X5b(H+-20|0,C);P=A+-8|0;A=f[P+4>>2]|0;Q=H+-8|0;f[Q>>2]=f[P>>2];f[Q+4>>2]=A;H=z+-20|0;z=H}while((C|0)!=(L|0));M=z;N=f[x>>2]|0;O=f[t>>2]|0}f[x>>2]=M;f[t>>2]=K;f[s>>2]=B;L=N;if((O|0)!=(L|0)){C=O;do{C=C+-20|0;if((b[C+11>>0]|0)<0)O5b(f[C>>2]|0)}while((C|0)!=(L|0))}if(N|0)O5b(N)}else{X5b(v,e);L=y;C=f[L+4>>2]|0;B=v+12|0;f[B>>2]=f[L>>2];f[B+4>>2]=C;f[t>>2]=(f[t>>2]|0)+20}if((b[E>>0]|0)<0)O5b(f[e>>2]|0);C=f[(f[D>>2]|0)+4+(w<<2)>>2]|0;B=(f[l>>2]|0)+(w<<3)|0;bD(B);L=C+11|0;K=b[L>>0]|0;z=K<<24>>24<0?f[C+4>>2]|0:K&255;if(z|0){K=aD(B,z)|0;Vac(K|0,((b[L>>0]|0)<0?f[C>>2]|0:C)|0,z|0)|0}w=w+1|0;if((w|0)>=(f[F>>2]|0))break a}if((I|0)==26)c4b(r);else if((I|0)==29){w=ze(8)|0;T5b(w,477177);f[w>>2]=149528;If(w|0,25408,1411)}}while(0);if((p|0)>0){F=a+72|0;N=m+4|0;O=n+4|0;s=o+4|0;M=o+8|0;J=o+4|0;w=o+12|0;D=a+168|0;E=a+176|0;y=o+12|0;G=g+4|0;z=g+8|0;C=g+8|0;L=e+11|0;K=e+4|0;B=i+8|0;H=i+12|0;A=i+4|0;Q=j+8|0;P=j+4|0;R=h+36|0;S=h+16|0;T=h+4|0;U=h+40|0;V=h+44|0;W=h+48|0;X=h+4|0;Z=e+4|0;_=e+4|0;$=l+4|0;aa=e+4|0;ba=l+8|0;ca=e+4|0;da=g+11|0;ea=g+4|0;fa=h+11|0;ga=i+4|0;ha=g+56|0;ia=g+4|0;ja=g+56|0;ka=g+128|0;la=g+132|0;ma=g+36|0;na=g+52|0;oa=e+11|0;pa=j+4|0;qa=e+11|0;ra=e+4|0;sa=h+4|0;ta=0;do{ua=f[(f[F>>2]|0)+4+(ta<<2)>>2]|0;va=ua+144|0;wa=f[va>>2]|0;f[m>>2]=0;f[N>>2]=0;xa=wa+11|0;ya=b[xa>>0]|0;za=ya<<24>>24<0?f[wa+4>>2]|0:ya&255;if(za|0){ya=aD(m,za)|0;Vac(ya|0,((b[xa>>0]|0)<0?f[wa>>2]|0:wa)|0,za|0)|0}za=f[ua+148>>2]|0;f[n>>2]=0;f[O>>2]=0;wa=za+11|0;xa=b[wa>>0]|0;ya=xa<<24>>24<0?f[za+4>>2]|0:xa&255;if(ya|0){xa=aD(n,ya)|0;Vac(xa|0,((b[wa>>0]|0)<0?f[za>>2]|0:za)|0,ya|0)|0}f[s>>2]=0;f[M>>2]=0;f[o>>2]=J;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;f[w+24>>2]=0;bza(ua,o,0);ya=f[va>>2]|0;va=f[D>>2]|0;b:do if(va){za=f[E>>2]|0;wa=b[ya+11>>0]|0;xa=wa<<24>>24<0;Aa=xa?f[ya+4>>2]|0:wa&255;wa=(Aa|0)==0;if(xa){if(wa){xa=0;while(1){Ba=f[(f[za+4+(xa<<2)>>2]|0)+144>>2]|0;Ca=b[Ba+11>>0]|0;if(!((Ca<<24>>24<0?f[Ba+4>>2]|0:Ca&255)|0)){Da=xa;I=75;break b}xa=xa+1|0;if((xa|0)==(va|0))break b}}else Ea=0;do{xa=f[(f[za+4+(Ea<<2)>>2]|0)+144>>2]|0;v=b[xa+11>>0]|0;Ca=v<<24>>24<0;Ba=v&255;do if(((Ca?f[xa+4>>2]|0:Ba)|0)==(Aa|0)){v=f[xa>>2]|0;Fa=f[ya>>2]|0;if(Ca)if(!(ZVb(v,Fa,Aa)|0)){Da=Ea;I=75;break b}else break;if((v&255)<<24>>24==(b[Fa>>0]|0)){v=xa;Ga=Ba;Ha=Fa;do{Ga=Ga+-1|0;v=v+1|0;if(!Ga){Da=Ea;I=75;break b}Ha=Ha+1|0}while((b[v>>0]|0)==(b[Ha>>0]|0))}}while(0);Ea=Ea+1|0}while((Ea|0)!=(va|0))}else{if(wa){Ba=0;while(1){xa=f[(f[za+4+(Ba<<2)>>2]|0)+144>>2]|0;Ca=b[xa+11>>0]|0;if(!((Ca<<24>>24<0?f[xa+4>>2]|0:Ca&255)|0)){Da=Ba;I=75;break b}Ba=Ba+1|0;if((Ba|0)==(va|0))break b}}else Ia=0;do{Ba=f[(f[za+4+(Ia<<2)>>2]|0)+144>>2]|0;wa=b[Ba+11>>0]|0;Ca=wa<<24>>24<0;xa=wa&255;do if(((Ca?f[Ba+4>>2]|0:xa)|0)==(Aa|0)){wa=f[Ba>>2]|0;if(Ca)if(!(ZVb(wa,ya,Aa)|0)){Da=Ia;I=75;break b}else break;if((wa&255)<<24>>24==(b[ya>>0]|0)){wa=Ba;Ha=xa;v=ya;do{Ha=Ha+-1|0;wa=wa+1|0;if(!Ha){Da=Ia;I=75;break b}v=v+1|0}while((b[wa>>0]|0)==(b[v>>0]|0))}}while(0);Ia=Ia+1|0}while((Ia|0)!=(va|0))}}else{Da=0;I=75}while(0);if((((I|0)==75?(I=0,(Da|0)!=(va|0)):0)?(ya=f[(f[E>>2]|0)+4+(Da<<2)>>2]|0,Aa=ya+88|0,za=f[Aa>>2]|0,za|0):0)?(SL(y,za),(f[Aa>>2]|0)>0):0){za=ya+96|0;ya=0;do{xa=f[(f[za>>2]|0)+4+(ya<<2)>>2]|0;Ba=f[y>>2]|0;Ca=Ba+(ya*56|0)|0;f[g>>2]=0;f[G>>2]=0;f[z>>2]=0;v=f[xa+8>>2]|0;c:do if(!(v&1920)){if(!(v&1)){f[e>>2]=1;Rr(g,1,e);break}wa=f[xa+84>>2]|0;Ha=(wa|0)==0?493e3:wa;wa=Ha+16|0;if((f[wa>>2]|0)>0){Ga=Ha+24|0;Ha=0;Fa=0;Ja=0;while(1){Ka=f[(f[Ga>>2]|0)+8+(Ha<<3)>>2]|0;f[e>>2]=Ka;if((Fa|0)==(Ja|0))IO(g,e);else{f[Fa>>2]=Ka;f[G>>2]=Fa+4}Ka=Ha+1|0;if((Ka|0)>=(f[wa>>2]|0))break c;Ha=Ka;Fa=f[G>>2]|0;Ja=f[C>>2]|0}}}else{f[e>>2]=f[xa+92>>2];IO(g,e);Ja=f[G>>2]|0;Fa=f[C>>2]|0;Ha=f[xa+96>>2]|0;f[e>>2]=Ha;if((Ja|0)==(Fa|0)){IO(g,e);La=f[G>>2]|0;Ma=f[C>>2]|0}else{f[Ja>>2]=Ha;Ha=Ja+4|0;f[G>>2]=Ha;La=Ha;Ma=Fa}Fa=f[xa+100>>2]|0;f[e>>2]=Fa;if((La|0)==(Ma|0)){IO(g,e);Na=f[G>>2]|0;Oa=f[C>>2]|0}else{f[La>>2]=Fa;Fa=La+4|0;f[G>>2]=Fa;Na=Fa;Oa=Ma}Fa=f[xa+104>>2]|0;f[e>>2]=Fa;if((Na|0)==(Oa|0))IO(g,e);else{f[Na>>2]=Fa;f[G>>2]=Na+4}}while(0);v=f[g>>2]|0;hL(Ca,(f[G>>2]|0)-v>>2,v,5);v=f[Ba+(ya*56|0)+16>>2]|0;Fa=xa+16|0;Ha=f[Fa>>2]|0;if(!Ha){if((f[xa+88>>2]|0)!=2){f[e>>2]=0;f[Z>>2]=0;Pa=aD(e,40)|0;Qa=376664;Ra=Pa+40|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,e,376569,376583,251);bD(e)}X5b(e,f[xa+80>>2]|0);Ja=b[L>>0]|0;wa=Ja<<24>>24<0?f[K>>2]|0:Ja&255;Ga=f[Ba+(ya*56|0)+4>>2]|0;if((Ga|0)<3)Sa=Y(f[Ba+(ya*56|0)+12>>2]|0,f[Ba+(ya*56|0)+8>>2]|0)|0;else{Ka=f[Ba+(ya*56|0)+40>>2]|0;Ta=0;Ua=1;while(1){Va=Y(f[Ka+(Ta<<2)>>2]|0,Ua)|0;Ta=Ta+1|0;if((Ta|0)==(Ga|0)){Sa=Va;break}else Ua=Va}}if((wa>>>1|0)==(Sa|0))Wa=Ja;else{f[h>>2]=0;f[X>>2]=0;Pa=aD(h,43)|0;Qa=376705;Ra=Pa+43|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,h,376569,376583,254);bD(h);Wa=b[L>>0]|0}Ja=f[g>>2]|0;oL(h,(f[G>>2]|0)-Ja>>2,Ja,3,Wa<<24>>24<0?f[e>>2]|0:e,0);f[B>>2]=0;f[H>>2]=0;f[i>>2]=16842752;f[A>>2]=h;Ja=Q;f[Ja>>2]=0;f[Ja+4>>2]=0;f[j>>2]=33619968;f[P>>2]=Ca;LJ(i,j);Ja=f[R>>2]|0;do if(Ja|0){wa=Ja+12|0;Ua=f[wa>>2]|0;f[wa>>2]=Ua+-1;if((Ua|0)!=1)break;kL(h)}while(0);f[R>>2]=0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[T>>2]|0)>0){Ja=f[U>>2]|0;Ca=0;do{f[Ja+(Ca<<2)>>2]=0;Ca=Ca+1|0}while((Ca|0)<(f[T>>2]|0))}Ca=f[V>>2]|0;if((Ca|0)!=(W|0))UC(Ca);if((b[L>>0]|0)<0)O5b(f[e>>2]|0)}else{Ca=f[Ba+(ya*56|0)+4>>2]|0;if((Ca|0)<3)Xa=Y(f[Ba+(ya*56|0)+12>>2]|0,f[Ba+(ya*56|0)+8>>2]|0)|0;else{Ja=f[Ba+(ya*56|0)+40>>2]|0;Ua=0;wa=1;while(1){Ga=Y(f[Ja+(Ua<<2)>>2]|0,wa)|0;Ua=Ua+1|0;if((Ua|0)==(Ca|0)){Xa=Ga;break}else wa=Ga}}if((Ha|0)==(Xa|0))Ya=Ha;else{f[e>>2]=0;f[_>>2]=0;Pa=aD(e,42)|0;Qa=376526;Ra=Pa+42|0;do{b[Pa>>0]=b[Qa>>0]|0;Pa=Pa+1|0;Qa=Qa+1|0}while((Pa|0)<(Ra|0));bO(-215,e,376569,376583,241);bD(e);Ya=f[Fa>>2]|0}if((Ya|0)>0){Ha=f[xa+24>>2]|0;wa=0;do{f[v+(wa<<2)>>2]=f[Ha+4+(wa<<2)>>2];wa=wa+1|0}while((wa|0)!=(Ya|0))}}wa=f[g>>2]|0;if(wa|0){Ha=f[G>>2]|0;if((Ha|0)!=(wa|0))f[G>>2]=Ha+(~((Ha+-4-wa|0)>>>2)<<2);O5b(wa)}ya=ya+1|0}while((ya|0)<(f[Aa>>2]|0))}Aa=cua(q,m)|0;ya=f[Aa>>2]|0;f[Aa>>2]=ya+1;if(ya|0){f[i>>2]=0;f[ga>>2]=0;Aa=aD(i,1)|0;b[Aa>>0]=95;f[g>>2]=18164;f[ha>>2]=18184;RXb(ja,ia);f[ka>>2]=0;f[la>>2]=-1;f[g>>2]=43248;f[ha>>2]=43268;WXb(ia);f[ia>>2]=43284;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;f[na>>2]=16;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;qP(ia,e);if((b[oa>>0]|0)<0)O5b(f[e>>2]|0);iYb(g,ya)|0;sP(e,ia);f[j>>2]=0;f[pa>>2]=0;ya=b[qa>>0]|0;Aa=ya<<24>>24<0?f[ra>>2]|0:ya&255;if(!Aa)Za=ya;else{ya=aD(j,Aa)|0;Vac(ya|0,((b[qa>>0]|0)<0?f[e>>2]|0:e)|0,Aa|0)|0;Za=b[qa>>0]|0}if(Za<<24>>24<0)O5b(f[e>>2]|0);tP(g);f[h>>2]=0;f[sa>>2]=0;aD(h,(f[pa>>2]|0)+(f[ga>>2]|0)|0)|0;Aa=f[ga>>2]|0;if(Aa|0)Vac(f[h>>2]|0,f[i>>2]|0,Aa|0)|0;Aa=f[pa>>2]|0;if(Aa|0)Vac((f[h>>2]|0)+(f[ga>>2]|0)|0,f[j>>2]|0,Aa|0)|0;eP(m,h)|0;bD(h);bD(j);bD(i)}Aa=f[n>>2]|0;d:do if((Aa|0)!=376749?(gTb((Aa|0)==0?1124530:Aa,376749)|0)!=0:0){ya=lva(c,m,n,o)|0;za=ua+28|0;va=f[za>>2]|0;if((va|0)>0){wa=ua+36|0;Ha=0;while(1){v=f[(f[wa>>2]|0)+4+(Ha<<2)>>2]|0;xa=f[x>>2]|0;Fa=(f[t>>2]|0)-xa|0;Ca=xa;e:do if((Fa|0)>0){xa=(Fa>>>0)/20|0;Ua=b[v+11>>0]|0;Ja=Ua<<24>>24<0;Ba=Ja?f[v+4>>2]|0:Ua&255;Ua=Ja?f[v>>2]|0:v;f:do if(Ba){Ja=xa;g:while(1){_a=Ja+-1|0;Ga=Ca+(_a*20|0)|0;Ta=b[Ga+11>>0]|0;Ka=Ta<<24>>24<0;Va=Ta&255;do if(((Ka?f[Ca+(_a*20|0)+4>>2]|0:Va)|0)==(Ba|0)){Ta=f[Ga>>2]|0;if(Ka)if(!(ZVb(Ta,Ua,Ba)|0)){$a=_a;break f}else break;if((Ta&255)<<24>>24!=(b[Ua>>0]|0))break;Ta=Ga;ab=Va;bb=Ua;do{ab=ab+-1|0;Ta=Ta+1|0;if(!ab)break g;bb=bb+1|0}while((b[Ta>>0]|0)==(b[bb>>0]|0))}while(0);if((Ja|0)>1)Ja=_a;else{I=174;break e}}if((Ja|0)<1){I=174;break e}else $a=_a}else{Va=xa;while(1){Ga=Va;Va=Va+-1|0;Ka=b[Ca+(Va*20|0)+11>>0]|0;if(!((Ka<<24>>24<0?f[Ca+(Va*20|0)+4>>2]|0:Ka&255)|0)){$a=Va;break f}if((Ga|0)<=1){I=174;break e}}}while(0);tva(c,f[Ca+($a*20|0)+12>>2]|0,f[Ca+($a*20|0)+16>>2]|0,ya,Ha)}else I=174;while(0);if((I|0)==174){I=0;dua(h,376755,v);eua(g,h,476054);f[e>>2]=0;f[ca>>2]=0;Ca=b[da>>0]|0;Fa=Ca<<24>>24<0?f[ea>>2]|0:Ca&255;if(Fa|0){Ca=aD(e,Fa)|0;Vac(Ca|0,((b[da>>0]|0)<0?f[g>>2]|0:g)|0,Fa|0)|0}bO(-204,e,376780,376583,387);bD(e);if((b[da>>0]|0)<0)O5b(f[g>>2]|0);if((b[fa>>0]|0)<0)O5b(f[h>>2]|0)}Ha=Ha+1|0;Fa=f[za>>2]|0;if((Ha|0)>=(Fa|0)){cb=Fa;break}}}else cb=va;Ha=ua+44|0;if((f[Ha>>2]|0)>0){wa=ua+36|0;Fa=ua+52|0;Ca=0;xa=cb;while(1){cza(a,xa,f[wa>>2]|0,f[Fa>>2]|0,ya,Ca);Ua=Ca+1|0;if((Ua|0)>=(f[Ha>>2]|0))break d;Ca=Ua;xa=f[za>>2]|0}}}else I=147;while(0);if((I|0)==147?(I=0,Aa=ua+44|0,(f[Aa>>2]|0)>0):0){za=ua+28|0;xa=ua+36|0;Ca=ua+52|0;Ha=0;do{cza(a,f[za>>2]|0,f[xa>>2]|0,f[Ca>>2]|0,0,Ha);ya=f[$>>2]|0;Fa=f[t>>2]|0;f[Fa+-4>>2]=ya-(f[l>>2]|0)>>3;wa=Fa+-20|0;f[e>>2]=0;f[aa>>2]=0;va=wa+11|0;Ua=b[va>>0]|0;Ba=Ua<<24>>24<0?f[Fa+-16>>2]|0:Ua&255;if(!Ba)db=ya;else{ya=aD(e,Ba)|0;Vac(ya|0,((b[va>>0]|0)<0?f[wa>>2]|0:wa)|0,Ba|0)|0;db=f[$>>2]|0}if((db|0)==(f[ba>>2]|0))awa(l,e);else{Ba=f[e>>2]|0;f[db>>2]=Ba;f[db+4>>2]=f[aa>>2];if(!Ba)eb=db;else{wa=Ba+-4|0;f[wa>>2]=(f[wa>>2]|0)+1;eb=f[$>>2]|0}f[$>>2]=eb+8}bD(e);Ha=Ha+1|0}while((Ha|0)<(f[Aa>>2]|0))}fua(o);bD(n);bD(m);ta=ta+1|0}while((ta|0)<(p|0))}Dwa(c,l);c=f[r>>2]|0;r=f[t>>2]|0;if((r|0)!=(c|0)){p=r;while(1){r=p+-20|0;f[t>>2]=r;if((b[r+11>>0]|0)<0){O5b(f[r>>2]|0);fb=f[t>>2]|0}else fb=r;if((fb|0)==(c|0))break;else p=fb}}fb=f[l>>2]|0;if(fb|0){p=l+4|0;while(1){c=f[p>>2]|0;if((c|0)==(fb|0))break;t=c+-8|0;f[p>>2]=t;bD(t)}O5b(f[l>>2]|0)}if(!(f[k+4>>2]|0)){u=d;return}u=d;return}function aza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;if(!b)return;if(b>>>0>536870911)c4b(a);d=b<<3;e=L5b(d)|0;f[a>>2]=e;g=e+(b<<3)|0;f[a+8>>2]=g;Nac(e|0,0,d|0)|0;f[c>>2]=g;return}function bza(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0,ua=0,va=0;e=u;u=u+48|0;g=e+40|0;i=e;j=e+32|0;k=e+24|0;l=e+16|0;m=e+12|0;zh[f[(f[a>>2]|0)+96>>2]&2047](g,a);o=f[g>>2]|0;q=di[f[(f[a>>2]|0)+92>>2]&1023](a)|0;r=o+24|0;if((f[r>>2]|0)<=0){u=e;return}s=o+28|0;o=j+4|0;t=i+4|0;v=g+4|0;w=g+4|0;y=i+4|0;z=g+4|0;A=g+4|0;B=i+4|0;C=g+4|0;D=g+4|0;E=i+4|0;F=g+4|0;G=g+4|0;H=i+4|0;I=g+4|0;J=g+4|0;K=i+4|0;L=g+4|0;M=g+4|0;N=i+4|0;O=g+4|0;P=g+4|0;Q=i+4|0;R=g+4|0;S=i+4|0;T=g+4|0;U=i+11|0;V=j+4|0;W=i+4|0;X=g+4|0;Y=0;do{Z=f[s>>2]|0;_=Z+(Y*88|0)|0;if(!d){$=f[_>>2]|0;if((b[491776]|0)==0?Cac(491776)|0:0){f[212947]=0;f[212948]=0;f[212949]=0;b[851799]=6;b[851788]=b[376844]|0;b[851789]=b[376845]|0;b[851790]=b[376846]|0;b[851791]=b[376847]|0;b[851792]=b[376848]|0;b[851793]=b[376849]|0;b[851794]=0;zd(1483,851788,x|0)|0}aa=b[$+11>>0]|0;ba=aa<<24>>24<0?f[$+4>>2]|0:aa&255;aa=b[851799]|0;ca=aa<<24>>24<0;da=ca?f[212948]|0:aa&255;if(ba>>>0>=da>>>0?(u6b($,ba-da|0,da,ca?f[212947]|0:851788,da)|0)==0:0)ea=10}else ea=10;do if((ea|0)==10){ea=0;da=Z+(Y*88|0)+36|0;ca=f[da>>2]|0;switch(ca|0){case 2:break;case 1:{if(!(li[f[(f[q>>2]|0)+20>>2]&511](q,a,_)|0)){fa=f[da>>2]|0;ea=13}break}default:{fa=ca;ea=13}}if((ea|0)==13){ea=0;if((fa|0)!=3)break;if((li[f[(f[q>>2]|0)+24>>2]&511](q,a,_)|0)<=0)break}ca=Z+(Y*88|0)+32|0;if((f[136e3+(f[ca>>2]<<2)>>2]|0)==10)if((f[da>>2]|0)==3){bza(Dg[f[(f[q>>2]|0)+208>>2]&127](q,a,_,0)|0,c,1);break}else{bza(Dg[f[(f[q>>2]|0)+108>>2]&127](q,a,_,0)|0,c,1);break}ba=di[f[(f[a>>2]|0)+92>>2]&1023](a)|0;$=f[ca>>2]|0;ca=(f[da>>2]|0)==3;da=f[_>>2]|0;a:do switch(f[136e3+($<<2)>>2]|0){case 1:{if(!ca){f[g>>2]=0;f[z>>2]=0;aa=da+11|0;ga=b[aa>>0]|0;ha=ga<<24>>24<0?f[da+4>>2]|0:ga&255;if(ha|0){ga=aD(g,ha)|0;Vac(ga|0,((b[aa>>0]|0)<0?f[da>>2]|0:da)|0,ha|0)|0}ha=li[f[(f[ba>>2]|0)+68>>2]&511](ba,a,_)|0;f[i>>2]=ha;Wwa(c,g,i)|0;bD(g);break a}ha=DNb(ba,a,_)|0;f[g>>2]=0;f[w>>2]=0;aa=da+11|0;ga=b[aa>>0]|0;ia=ga<<24>>24<0?f[da+4>>2]|0:ga&255;if(ia|0){ga=aD(g,ia)|0;Vac(ga|0,((b[aa>>0]|0)<0?f[da>>2]|0:da)|0,ia|0)|0}ia=f[ha+8>>2]|0;aa=f[ha>>2]|0;ha=L5b(16)|0;ga=ha+8|0;f[ha>>2]=ga;f[ha+4>>2]=aa;if(aa>>>0>1){ja=N5b(aa>>>0>536870911?-1:aa<<3)|0;f[ha>>2]=ja;ka=ja}else ka=ga;f[i>>2]=0;f[y>>2]=ha;if((aa|0)>0){ha=(ia|0)==0?0:ia+4|0;ia=0;while(1){ga=f[ha>>2]|0;ja=ka+(ia<<3)|0;f[ja>>2]=ga;f[ja+4>>2]=((ga|0)<0)<<31>>31;ia=ia+1|0;if((ia|0)==(aa|0))break;else ha=ha+4|0}}nxa(c,g,i)|0;gua(i);bD(g);break}case 3:{if(!ca){f[g>>2]=0;f[C>>2]=0;ha=da+11|0;aa=b[ha>>0]|0;ia=aa<<24>>24<0?f[da+4>>2]|0:aa&255;if(ia|0){aa=aD(g,ia)|0;Vac(aa|0,((b[ha>>0]|0)<0?f[da>>2]|0:da)|0,ia|0)|0}ia=li[f[(f[ba>>2]|0)+76>>2]&511](ba,a,_)|0;f[i>>2]=ia;dza(c,g,i)|0;bD(g);break a}ia=FNb(ba,a,_)|0;f[g>>2]=0;f[A>>2]=0;ha=da+11|0;aa=b[ha>>0]|0;ga=aa<<24>>24<0?f[da+4>>2]|0:aa&255;if(ga|0){aa=aD(g,ga)|0;Vac(aa|0,((b[ha>>0]|0)<0?f[da>>2]|0:da)|0,ga|0)|0}ga=f[ia+8>>2]|0;ha=f[ia>>2]|0;ia=L5b(16)|0;aa=ia+8|0;f[ia>>2]=aa;f[ia+4>>2]=ha;if(ha>>>0>1){ja=N5b(ha>>>0>536870911?-1:ha<<3)|0;f[ia>>2]=ja;la=ja}else la=aa;f[i>>2]=0;f[B>>2]=ia;if((ha|0)>0){ia=(ga|0)==0?0:ga+4|0;ga=0;while(1){aa=la+(ga<<3)|0;f[aa>>2]=f[ia>>2];f[aa+4>>2]=0;ga=ga+1|0;if((ga|0)==(ha|0))break;else ia=ia+4|0}}nxa(c,g,i)|0;gua(i);bD(g);break}case 2:{if(!ca){f[g>>2]=0;f[F>>2]=0;ia=da+11|0;ha=b[ia>>0]|0;ga=ha<<24>>24<0?f[da+4>>2]|0:ha&255;if(ga|0){ha=aD(g,ga)|0;Vac(ha|0,((b[ia>>0]|0)<0?f[da>>2]|0:da)|0,ga|0)|0}ga=li[f[(f[ba>>2]|0)+68>>2]&511](ba,a,_)|0;f[i>>2]=ga;Wwa(c,g,i)|0;bD(g);break a}ga=ENb(ba,a,_)|0;f[g>>2]=0;f[D>>2]=0;ia=da+11|0;ha=b[ia>>0]|0;aa=ha<<24>>24<0?f[da+4>>2]|0:ha&255;if(aa|0){ha=aD(g,aa)|0;Vac(ha|0,((b[ia>>0]|0)<0?f[da>>2]|0:da)|0,aa|0)|0}aa=f[ga+8>>2]|0;ia=f[ga>>2]|0;ga=L5b(16)|0;ha=ga+8|0;f[ga>>2]=ha;f[ga+4>>2]=ia;if(ia>>>0>1){ja=N5b(ia>>>0>536870911?-1:ia<<3)|0;f[ga>>2]=ja;ma=ja}else ma=ha;f[i>>2]=0;f[E>>2]=ga;if((ia|0)>0){ga=(aa|0)==0?0:aa+8|0;aa=0;while(1){ha=ga;ja=f[ha+4>>2]|0;na=ma+(aa<<3)|0;f[na>>2]=f[ha>>2];f[na+4>>2]=ja;aa=aa+1|0;if((aa|0)==(ia|0))break;else ga=ga+8|0}}nxa(c,g,i)|0;gua(i);bD(g);break}case 4:{if(!ca){f[g>>2]=0;f[I>>2]=0;ga=da+11|0;ia=b[ga>>0]|0;aa=ia<<24>>24<0?f[da+4>>2]|0:ia&255;if(aa|0){ia=aD(g,aa)|0;Vac(ia|0,((b[ga>>0]|0)<0?f[da>>2]|0:da)|0,aa|0)|0}aa=li[f[(f[ba>>2]|0)+76>>2]&511](ba,a,_)|0;f[i>>2]=aa;dza(c,g,i)|0;bD(g);break a}aa=GNb(ba,a,_)|0;f[g>>2]=0;f[G>>2]=0;ga=da+11|0;ia=b[ga>>0]|0;ja=ia<<24>>24<0?f[da+4>>2]|0:ia&255;if(ja|0){ia=aD(g,ja)|0;Vac(ia|0,((b[ga>>0]|0)<0?f[da>>2]|0:da)|0,ja|0)|0}ja=f[aa+8>>2]|0;ga=f[aa>>2]|0;aa=L5b(16)|0;ia=aa+8|0;f[aa>>2]=ia;f[aa+4>>2]=ga;if(ga>>>0>1){na=N5b(ga>>>0>536870911?-1:ga<<3)|0;f[aa>>2]=na;oa=na}else oa=ia;f[i>>2]=0;f[H>>2]=aa;if((ga|0)>0){aa=(ja|0)==0?0:ja+8|0;ja=0;while(1){ia=aa;na=f[ia+4>>2]|0;ha=oa+(ja<<3)|0;f[ha>>2]=f[ia>>2];f[ha+4>>2]=na;ja=ja+1|0;if((ja|0)==(ga|0))break;else aa=aa+8|0}}nxa(c,g,i)|0;gua(i);bD(g);break}case 7:{if(!ca){f[g>>2]=0;f[L>>2]=0;aa=da+11|0;ga=b[aa>>0]|0;ja=ga<<24>>24<0?f[da+4>>2]|0:ga&255;if(ja|0){ga=aD(g,ja)|0;Vac(ga|0,((b[aa>>0]|0)<0?f[da>>2]|0:da)|0,ja|0)|0}ja=(li[f[(f[ba>>2]|0)+92>>2]&511](ba,a,_)|0)&1;b[i>>0]=ja;$wa(c,g,i)|0;bD(g);break a}ja=JNb(ba,a,_)|0;f[g>>2]=0;f[J>>2]=0;aa=da+11|0;ga=b[aa>>0]|0;na=ga<<24>>24<0?f[da+4>>2]|0:ga&255;if(na|0){ga=aD(g,na)|0;Vac(ga|0,((b[aa>>0]|0)<0?f[da>>2]|0:da)|0,na|0)|0}na=f[ja+8>>2]|0;aa=f[ja>>2]|0;ja=L5b(16)|0;ga=ja+8|0;f[ja>>2]=ga;f[ja+4>>2]=aa;if(aa>>>0>1){ha=N5b(aa>>>0>536870911?-1:aa<<3)|0;f[ja>>2]=ha;pa=ha}else pa=ga;f[i>>2]=0;f[K>>2]=ja;if((aa|0)>0){ja=(na|0)==0?0:na+4|0;na=0;while(1){ga=pa+(na<<3)|0;f[ga>>2]=h[ja>>0];f[ga+4>>2]=0;na=na+1|0;if((na|0)==(aa|0))break;else ja=ja+1|0}}nxa(c,g,i)|0;gua(i);bD(g);break}case 5:{if(!ca){f[g>>2]=0;f[O>>2]=0;ja=da+11|0;aa=b[ja>>0]|0;na=aa<<24>>24<0?f[da+4>>2]|0:aa&255;if(na|0){aa=aD(g,na)|0;Vac(aa|0,((b[ja>>0]|0)<0?f[da>>2]|0:da)|0,na|0)|0}qa=+fh[f[(f[ba>>2]|0)+88>>2]&31](ba,a,_);p[i>>3]=qa;Mya(c,g,i)|0;bD(g);break a}na=INb(ba,a,_)|0;f[g>>2]=0;f[M>>2]=0;ja=da+11|0;aa=b[ja>>0]|0;ga=aa<<24>>24<0?f[da+4>>2]|0:aa&255;if(ga|0){aa=aD(g,ga)|0;Vac(aa|0,((b[ja>>0]|0)<0?f[da>>2]|0:da)|0,ga|0)|0}ga=f[na+8>>2]|0;ja=f[na>>2]|0;na=L5b(16)|0;aa=na+8|0;f[na>>2]=aa;f[na+4>>2]=ja;if(ja>>>0>1){ha=N5b(ja>>>0>536870911?-1:ja<<3)|0;f[na>>2]=ha;ra=ha}else ra=aa;f[i>>2]=2;f[N>>2]=na;if((ja|0)>0){na=(ga|0)==0?0:ga+8|0;ga=0;while(1){p[ra+(ga<<3)>>3]=+p[na>>3];ga=ga+1|0;if((ga|0)==(ja|0))break;else na=na+8|0}}nxa(c,g,i)|0;gua(i);bD(g);break}case 6:{if(!ca){f[g>>2]=0;f[R>>2]=0;na=da+11|0;ja=b[na>>0]|0;ga=ja<<24>>24<0?f[da+4>>2]|0:ja&255;if(ga|0){ja=aD(g,ga)|0;Vac(ja|0,((b[na>>0]|0)<0?f[da>>2]|0:da)|0,ga|0)|0}qa=+fh[f[(f[ba>>2]|0)+84>>2]&31](ba,a,_);n[i>>2]=qa;Zwa(c,g,i)|0;bD(g);break a}ga=HNb(ba,a,_)|0;f[g>>2]=0;f[P>>2]=0;na=da+11|0;ja=b[na>>0]|0;aa=ja<<24>>24<0?f[da+4>>2]|0:ja&255;if(aa|0){ja=aD(g,aa)|0;Vac(ja|0,((b[na>>0]|0)<0?f[da>>2]|0:da)|0,aa|0)|0}aa=f[ga+8>>2]|0;na=f[ga>>2]|0;ga=L5b(16)|0;ja=ga+8|0;f[ga>>2]=ja;f[ga+4>>2]=na;if(na>>>0>1){ha=N5b(na>>>0>536870911?-1:na<<3)|0;f[ga>>2]=ha;sa=ha}else sa=ja;f[i>>2]=2;f[Q>>2]=ga;if((na|0)>0){ga=(aa|0)==0?0:aa+4|0;aa=0;while(1){p[sa+(aa<<3)>>3]=+n[ga>>2];aa=aa+1|0;if((aa|0)==(na|0))break;else ga=ga+4|0}}nxa(c,g,i)|0;gua(i);bD(g);break}case 9:{if(ca){ga=KNb(ba,a,_,1)|0;f[i>>2]=0;f[S>>2]=0;na=da+11|0;aa=b[na>>0]|0;ja=aa<<24>>24<0?f[da+4>>2]|0:aa&255;if(ja|0){aa=aD(i,ja)|0;Vac(aa|0,((b[na>>0]|0)<0?f[da>>2]|0:da)|0,ja|0)|0}ja=f[ga+12>>2]|0;f[k>>2]=(ja|0)==0?0:ja+4|0;ja=f[ga+4>>2]|0;f[g>>2]=f[k>>2];eza(j,g,ja);nxa(c,i,j)|0;gua(j);bD(i);break a}f[g>>2]=0;f[T>>2]=0;ja=da+11|0;ga=b[ja>>0]|0;na=ga<<24>>24<0?f[da+4>>2]|0:ga&255;if(na|0){ga=aD(g,na)|0;Vac(ga|0,((b[ja>>0]|0)<0?f[da>>2]|0:da)|0,na|0)|0}th[f[(f[ba>>2]|0)+96>>2]&511](i,ba,a,_);rxa(c,g,i)|0;if((b[U>>0]|0)<0)O5b(f[i>>2]|0);bD(g);break}case 8:{if(!ca){f[g>>2]=0;f[X>>2]=0;na=da+11|0;ja=b[na>>0]|0;ga=ja<<24>>24<0?f[da+4>>2]|0:ja&255;if(ga|0){ja=aD(g,ga)|0;Vac(ja|0,((b[na>>0]|0)<0?f[da>>2]|0:da)|0,ga|0)|0}ga=li[f[(f[ba>>2]|0)+100>>2]&511](ba,a,_)|0;rxa(c,g,f[ga>>2]|0)|0;bD(g);break a}ga=li[f[(f[ba>>2]|0)+24>>2]&511](ba,a,_)|0;aza(i,ga);if((ga|0)>0){na=0;do{ja=Dg[f[(f[ba>>2]|0)+200>>2]&127](ba,a,_,na)|0;aa=f[ja>>2]|0;ja=(f[i>>2]|0)+(na<<3)|0;bD(ja);ha=aa+11|0;ia=b[ha>>0]|0;ta=ia<<24>>24<0?f[aa+4>>2]|0:ia&255;if(ta|0){ia=aD(ja,ta)|0;Vac(ia|0,((b[ha>>0]|0)<0?f[aa>>2]|0:aa)|0,ta|0)|0}na=na+1|0}while((na|0)<(ga|0))}f[j>>2]=0;f[V>>2]=0;na=da+11|0;ta=b[na>>0]|0;aa=ta<<24>>24<0?f[da+4>>2]|0:ta&255;if(aa|0){ta=aD(j,aa)|0;Vac(ta|0,((b[na>>0]|0)<0?f[da>>2]|0:da)|0,aa|0)|0}f[m>>2]=f[i>>2];f[g>>2]=f[m>>2];fza(l,g,ga);nxa(c,j,l)|0;gua(l);bD(j);aa=f[i>>2]|0;if(aa|0){while(1){na=f[W>>2]|0;if((na|0)==(aa|0))break;ta=na+-8|0;f[W>>2]=ta;bD(ta)}O5b(f[i>>2]|0)}break}default:{aa=f[136076+($<<2)>>2]|0;f[j>>2]=0;f[o>>2]=0;if((aa|0)!=0?(ga=kUb(aa)|0,(ga|0)!=0):0){Vac(aD(j,ga)|0,aa|0,ga|0)|0;ua=(f[o>>2]|0)+14|0}else ua=14;f[i>>2]=0;f[t>>2]=0;aD(i,ua)|0;ga=f[i>>2]|0;aa=ga;ta=376851;na=aa+14|0;do{b[aa>>0]=b[ta>>0]|0;aa=aa+1|0;ta=ta+1|0}while((aa|0)<(na|0));ha=f[o>>2]|0;if(ha|0)Vac(ga+14|0,f[j>>2]|0,ha|0)|0;f[g>>2]=0;f[v>>2]=0;aD(g,(f[t>>2]|0)+13|0)|0;ha=f[t>>2]|0;if(!ha)va=0;else{Vac(f[g>>2]|0,f[i>>2]|0,ha|0)|0;va=f[t>>2]|0}aa=(f[g>>2]|0)+va|0;ta=376866;na=aa+13|0;do{b[aa>>0]=b[ta>>0]|0;aa=aa+1|0;ta=ta+1|0}while((aa|0)<(na|0));bO(-2,g,376880,376583,167);bD(g);bD(i);bD(j)}}while(0)}while(0);Y=Y+1|0}while((Y|0)<(f[r>>2]|0));u=e;return}function cza(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;i=u;u=u+32|0;j=i;k=f[e+4+(h<<2)>>2]|0;e=a+208|0;l=a+212|0;m=f[e>>2]|0;n=(f[l>>2]|0)-m|0;o=((n|0)/20|0)+-1|0;p=m;a:do if((n|0)>0){m=b[k+11>>0]|0;q=m<<24>>24<0;r=q?f[k+4>>2]|0:m&255;m=(r|0)==0;b:do if(q){s=o;while(1){t=p+(s*20|0)|0;v=b[t+11>>0]|0;w=v<<24>>24<0;x=v&255;do if(((w?f[p+(s*20|0)+4>>2]|0:x)|0)==(r|0)){v=f[t>>2]|0;y=w?v:t;z=f[k>>2]|0;if(w){if(m)break b;if(!(ZVb(y,z,r)|0))break b;else break}if(m)break b;if((v&255)<<24>>24==(b[z>>0]|0)){v=t;y=x;A=z;do{y=y+-1|0;v=v+1|0;if(!y)break b;A=A+1|0}while((b[v>>0]|0)==(b[A>>0]|0))}}while(0);if((s|0)>0)s=s+-1|0;else break a}}else{s=o;while(1){x=p+(s*20|0)|0;t=b[x+11>>0]|0;w=t<<24>>24<0;A=t&255;do if(((w?f[p+(s*20|0)+4>>2]|0:A)|0)==(r|0)){t=f[x>>2]|0;v=w?t:x;if(w){if(m)break b;if(!(ZVb(v,k,r)|0))break b;else break}if(m)break b;if((t&255)<<24>>24==(b[k>>0]|0)){t=x;v=A;y=k;do{v=v+-1|0;t=t+1|0;if(!v)break b;y=y+1|0}while((b[t>>0]|0)==(b[y>>0]|0))}}while(0);if((s|0)>0)s=s+-1|0;else break a}}while(0);do if((c|0)>(h|0)?(m=f[d+4+(h<<2)>>2]|0,s=b[m+11>>0]|0,A=s<<24>>24<0,x=s&255,((A?f[m+4>>2]|0:x)|0)==(r|0)):0){s=f[m>>2]|0;w=A?s:m;y=q?f[k>>2]|0:k;t=(r|0)==0;if(A){if(t)break a;if(!(ZVb(w,y,r)|0))break a;else break}if(t)break a;if((s&255)<<24>>24==(b[y>>0]|0)){s=m;m=x;x=y;do{m=m+-1|0;s=s+1|0;if(!m)break a;x=x+1|0}while((b[s>>0]|0)==(b[x>>0]|0))}}while(0);f[j>>2]=0;f[j+4>>2]=0;r=aD(j,44)|0;q=376789;x=r+44|0;do{b[r>>0]=b[q>>0]|0;r=r+1|0;q=q+1|0}while((r|0)<(x|0));bO(-5,j,376834,376583,370);bD(j)}while(0);X5b(j,k);k=j+12|0;f[k>>2]=g;f[j+16>>2]=h;h=f[l>>2]|0;g=a+216|0;a=f[g>>2]|0;d=a;if((h|0)==(a|0)){a=f[e>>2]|0;c=(h-a|0)/20|0;p=c+1|0;if(p>>>0>214748364)c4b(e);o=(d-a|0)/20|0;a=o<<1;d=o>>>0<107374182?(a>>>0<p>>>0?p:a):214748364;do if(d)if(d>>>0>214748364){a=ze(8)|0;T5b(a,477177);f[a>>2]=149528;If(a|0,25408,1411)}else{B=L5b(d*20|0)|0;break}else B=0;while(0);a=B+(c*20|0)|0;p=a;o=B+(d*20|0)|0;X5b(a,j);d=k;n=f[d+4>>2]|0;q=B+(c*20|0)+12|0;f[q>>2]=f[d>>2];f[q+4>>2]=n;n=a+20|0;q=f[e>>2]|0;d=f[l>>2]|0;if((d|0)==(q|0)){C=p;D=q;E=q}else{c=d;d=p;p=a;do{a=c;c=c+-20|0;X5b(p+-20|0,c);B=a+-8|0;a=f[B+4>>2]|0;r=p+-8|0;f[r>>2]=f[B>>2];f[r+4>>2]=a;p=d+-20|0;d=p}while((c|0)!=(q|0));C=d;D=f[e>>2]|0;E=f[l>>2]|0}f[e>>2]=C;f[l>>2]=n;f[g>>2]=o;o=D;if((E|0)!=(o|0)){g=E;do{g=g+-20|0;if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0)}while((g|0)!=(o|0))}if(D|0)O5b(D)}else{X5b(h,j);D=k;k=f[D+4>>2]|0;o=h+12|0;f[o>>2]=f[D>>2];f[o+4>>2]=k;f[l>>2]=(f[l>>2]|0)+20}if((b[j+11>>0]|0)>=0){u=i;return}O5b(f[j>>2]|0);u=i;return}function dza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1124530:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((gTb((r|0)==0?1124530:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){t=n;break}o=f[c>>2]|0;f[e>>2]=0;p=L5b(16)|0;r=p+8|0;f[p>>2]=r;f[p+4>>2]=1;f[e+4>>2]=p;p=r;f[p>>2]=o;f[p+4>>2]=0;$xa(s+24|0,e)|0;gua(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[i>>2]=0;t=L5b(16)|0;k=t+8|0;f[t>>2]=k;f[t+4>>2]=1;f[i+4>>2]=t;t=k;f[t>>2]=b;f[t+4>>2]=0;t=f[h>>2]|0;f[g>>2]=t;b=g+4|0;f[b>>2]=f[s>>2];if(t|0){s=t+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;iua(s,i);t=f[g>>2]|0;f[e>>2]=t;k=e+4|0;f[k>>2]=f[b>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=e+8|0;iua(b,s);t=f[j>>2]|0;b:do if(!t){v=j;w=j}else{p=a+4|0;o=f[e>>2]|0;r=(o|0)==0?1124530:o;x=f[t+16>>2]|0;c:do if((o|0)!=(x|0)){y=p;z=t;A=x;while(1){B=(A|0)==0?1124530:A;if((gTb(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=24;break}else{E=z;F=C}}else{if((gTb(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=27;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((o|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==24){v=z;w=z;break b}else if((D|0)==27){v=I;w=z;break b}}else{G=p;H=t}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=L5b(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}iua(H+24|0,b);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}mP(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}gua(b);bD(e);gua(s);bD(g);gua(i);bD(h);u=d;return c|0}function eza(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=L5b(16)|0;g=e+8|0;f[g>>2]=0;f[e+12>>2]=0;f[e>>2]=g;f[e+4>>2]=1;gza(e,d);f[a>>2]=3;g=a+4|0;f[g>>2]=e;if((d|0)<=0)return;a=f[c>>2]|0;h=0;i=a;j=e;e=a;while(1){a=f[i>>2]|0;k=(f[j>>2]|0)+(h<<3)|0;bD(k);l=a+11|0;m=b[l>>0]|0;n=m<<24>>24<0?f[a+4>>2]|0:m&255;if(n|0){m=aD(k,n)|0;Vac(m|0,((b[l>>0]|0)<0?f[a>>2]|0:a)|0,n|0)|0}n=e+4|0;f[c>>2]=n;a=h+1|0;if((a|0)>=(d|0))break;h=a;i=n;j=f[g>>2]|0;e=n}return}function fza(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=L5b(16)|0;e=d+8|0;f[e>>2]=0;f[d+12>>2]=0;f[d>>2]=e;f[d+4>>2]=1;gza(d,c);f[a>>2]=3;e=a+4|0;f[e>>2]=d;if((c|0)<=0)return;a=0;g=d;d=f[b>>2]|0;while(1){h=f[g>>2]|0;i=h+(a<<3)|0;if((d|0)==(i|0))j=d;else{bD(i);k=f[d>>2]|0;if(!k){l=d;m=0}else{n=k+-4|0;f[n>>2]=(f[n>>2]|0)+1;l=f[b>>2]|0;m=f[d>>2]|0}f[i>>2]=m;f[h+(a<<3)+4>>2]=f[d+4>>2];j=l}h=j+8|0;f[b>>2]=h;i=a+1|0;if((i|0)>=(c|0))break;a=i;g=f[e>>2]|0;d=h}return}function gza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=a+4|0;if((f[c>>2]|0)>>>0>=b>>>0){f[c>>2]=b;return}d=f[a>>2]|0;e=a+8|0;if((d|0)!=(e|0)){if(d|0){g=d+-4|0;h=f[g>>2]|0;if(h|0){i=d+(h<<3)|0;do{i=i+-8|0;bD(i)}while((i|0)!=(d|0))}P5b(g)}f[a>>2]=e;f[c>>2]=1}f[c>>2]=b;if(b>>>0<=1)return;c=b<<3;e=N5b(b>>>0>536870911|c>>>0>4294967291?-1:c+4|0)|0;f[e>>2]=b;c=e+4|0;Nac(c|0,0,b<<3|0)|0;f[a>>2]=c;return}function hza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+112|0;e=d;N5a(e);iza(a,e);bi[f[(f[c>>2]|0)+28>>2]&2047](c);a=e+8|0;do if(f[a>>2]&1|0){g=f[e+92>>2]|0;h=c+8|0;f[h>>2]=f[h>>2]|1;h=c+92|0;i=f[h>>2]|0;if((i|0)==497760){jza(h,g);break}else{_5b(i,g)|0;break}}while(0);g=e+80|0;if((f[g>>2]|0)>0){i=e+88|0;h=c+76|0;j=c+88|0;k=c+84|0;l=c+80|0;m=0;n=1;while(1){o=f[(f[i>>2]|0)+4+(m<<2)>>2]|0;p=f[j>>2]|0;do if(p){q=f[l>>2]|0;r=f[p>>2]|0;if((q|0)>=(r|0))if((r|0)==(f[k>>2]|0)){s=r;t=14;break}else{v=r;w=p;t=15;break}else{f[l>>2]=q+1;x=f[p+4+(q<<2)>>2]|0;break}}else{s=f[k>>2]|0;t=14}while(0);if((t|0)==14){t=0;cpb(h,s+1|0);p=f[j>>2]|0;v=f[p>>2]|0;w=p;t=15}if((t|0)==15){t=0;f[w>>2]=v+1;p=kza(0,f[h>>2]|0)|0;q=f[j>>2]|0;r=f[l>>2]|0;f[l>>2]=r+1;f[q+4+(r<<2)>>2]=p;x=p}p=n&(lza(o,x)|0);m=m+1|0;if((m|0)>=(f[g>>2]|0)){y=p;break}else n=p}}else y=1;n=e+20|0;if((f[n>>2]|0)>0){g=e+28|0;m=c+16|0;x=0;do{l=f[(f[g>>2]|0)+4+(x<<2)>>2]|0;_5b(mza(m)|0,l)|0;x=x+1|0}while((x|0)<(f[n>>2]|0))}n=e+48|0;if((f[n>>2]|0)>0){x=e+56|0;m=c+48|0;g=c+52|0;l=c+56|0;j=0;do{h=f[(f[x>>2]|0)+4+(j<<2)>>2]|0;v=f[m>>2]|0;if((v|0)==(f[g>>2]|0)){nza(m,v+1|0);z=f[m>>2]|0}else z=v;v=f[l>>2]|0;f[m>>2]=z+1;f[v+4+(z<<2)>>2]=h;j=j+1|0}while((j|0)<(f[n>>2]|0))}if(!(f[a>>2]&16)){g6a(e);u=d;return y|0}a=b[e+100>>0]|0;n=c+8|0;f[n>>2]=f[n>>2]|16;b[c+100>>0]=a;g6a(e);u=d;return y|0}function iza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;d=u;u=u+192|0;e=d+168|0;g=d;bi[f[(f[c>>2]|0)+28>>2]&2047](c);T8a(c,a);h=c+80|0;i=f[h>>2]|0;if((i|0)>0){j=f[c+88>>2]|0;k=0;do{l=f[j+4+(k<<2)>>2]|0;k=k+1|0;bi[f[(f[l>>2]|0)+28>>2]&2047](l)}while((k|0)!=(i|0));f[h>>2]=0}f[e+4>>2]=0;f[e+8>>2]=0;i=e+4|0;f[e>>2]=i;k=a+20|0;if((f[k>>2]|0)>0){j=a+28|0;l=0;do{m=wza(e,f[(f[j>>2]|0)+4+(l<<2)>>2]|0)|0;f[m>>2]=-1;l=l+1|0}while((l|0)<(f[k>>2]|0))}k=a+80|0;if((f[k>>2]|0)<=0){n=e;o=f[i>>2]|0;xza(n,o);u=d;return}l=a+88|0;a=c+76|0;j=c+88|0;m=c+84|0;c=g+21|0;p=g+32|0;q=g+24|0;r=g+21|0;s=g+32|0;t=g+24|0;v=g+21|0;w=g+32|0;x=g+24|0;y=g+21|0;z=g+32|0;A=g+24|0;B=g+21|0;C=g+32|0;D=g+24|0;E=0;do{F=f[(f[l>>2]|0)+4+(E<<2)>>2]|0;G=f[F+284>>2]|0;H=((G|0)==0?497e3:G)+60|0;G=f[H>>2]|0;I=b[G+11>>0]|0;if(!(((I<<24>>24<0?f[G+4>>2]|0:I&255)|0)==7?!(u6b(G,0,-1,441015,7)|0):0)){G=f[j>>2]|0;do if(G){I=f[h>>2]|0;J=f[G>>2]|0;if((I|0)>=(J|0))if((J|0)==(f[m>>2]|0)){K=J;L=21;break}else{M=J;N=G;L=22;break}else{f[h>>2]=I+1;O=f[G+4+(I<<2)>>2]|0;break}}else{K=f[m>>2]|0;L=21}while(0);if((L|0)==21){L=0;cpb(a,K+1|0);G=f[j>>2]|0;M=f[G>>2]|0;N=G;L=22}if((L|0)==22){L=0;f[N>>2]=M+1;G=kza(0,f[a>>2]|0)|0;I=f[j>>2]|0;J=f[h>>2]|0;f[h>>2]=J+1;f[I+4+(J<<2)>>2]=G;O=G}A9a(O,F)}G=F+20|0;if((f[G>>2]|0)>0){J=F+28|0;I=0;do{P=f[(f[J>>2]|0)+4+(I<<2)>>2]|0;if((yza(e,P)|0)==(i|0)){jya(g,377137,378683,233,450217,0,1);Q=P+11|0;R=P+4|0;while(1){if(!(b[c>>0]|0))break;S=rP(p,378706,19)|0;T=b[Q>>0]|0;U=T<<24>>24<0;iYb(rP(rP(S,U?f[P>>2]|0:P,U?f[R>>2]|0:T&255)|0,378726,10)|0,I)|0;lya(g)}kya(q)}R=wza(e,P)|0;Q=f[R>>2]|0;if(((Q|0)!=-1?(R=f[(f[l>>2]|0)+4+(Q<<2)>>2]|0,Q=R+284|0,T=f[Q>>2]|0,U=f[((T|0)==0?497e3:T)+60>>2]|0,T=b[U+11>>0]|0,((T<<24>>24<0?f[U+4>>2]|0:T&255)|0)==7):0)?(u6b(U,0,-1,441015,7)|0)==0:0){U=f[H>>2]|0;T=b[U+11>>0]|0;S=f[U+4>>2]|0;if(((T<<24>>24<0?S:T&255)|0)==4)if(!(u6b(U,0,-1,377119,4)|0))V=1;else{W=f[H>>2]|0;X=b[W+11>>0]|0;Y=f[W+4>>2]|0;Z=W;L=37}else{X=T;Y=S;Z=U;L=37}if((L|0)==37){L=0;if(((X<<24>>24<0?Y:X&255)|0)==4)V=(u6b(Z,0,-1,377418,4)|0)==0;else V=0}jya(g,377137,378683,245,378737,378743,V);while(1){if(!(b[r>>0]|0))break;U=rP(s,378808,66)|0;S=f[H>>2]|0;T=b[S+11>>0]|0;W=T<<24>>24<0;rP(U,W?f[S>>2]|0:S,W?f[S+4>>2]|0:T&255)|0;lya(g)}kya(t);jya(g,377137,378683,249,378737,378875,(f[G>>2]|0)==1);while(1){if(!(b[v>>0]|0))break;rP(w,378908,40)|0;lya(g)}kya(x);jya(g,377137,378683,251,378737,378949,(f[R+20>>2]|0)==1);while(1){if(!(b[y>>0]|0))break;rP(z,378978,43)|0;lya(g)}kya(A);jya(g,377137,378683,253,378737,379022,(f[R+36>>2]|0)==1);while(1){if(!(b[B>>0]|0))break;rP(C,379048,47)|0;lya(g)}kya(D);P=(f[h>>2]|0)+-1|0;T=f[(f[j>>2]|0)+4+(P<<2)>>2]|0;S=T+12|0;f[S>>2]=f[S>>2]|1024;S=T+284|0;W=f[S>>2]|0;if(!W){U=L5b(196)|0;jOa(U);f[S>>2]=U;_=U;$=f[(f[j>>2]|0)+4+(P<<2)>>2]|0}else{_=W;$=T}T=f[Q>>2]|0;W=f[((T|0)==0?497e3:T)+92>>2]|0;T=_+8|0;f[T>>2]=f[T>>2]|64;f[_+92>>2]=W;_5b(f[(f[$+28>>2]|0)+4+(I<<2)>>2]|0,f[(f[R+28>>2]|0)+4>>2]|0)|0}I=I+1|0}while((I|0)<(f[G>>2]|0))}G=F+36|0;if((f[G>>2]|0)>0){I=F+44|0;H=0;do{J=wza(e,f[(f[I>>2]|0)+4+(H<<2)>>2]|0)|0;f[J>>2]=E;H=H+1|0}while((H|0)<(f[G>>2]|0))}E=E+1|0}while((E|0)<(f[k>>2]|0));n=e;o=f[i>>2]|0;xza(n,o);u=d;return}function jza(a,b){a=a|0;b=b|0;var c=0;c=L5b(12)|0;if(!b){f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[a>>2]=c;return}else{X5b(c,b);f[a>>2]=c;return}}function kza(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=uza(b,c)|0;u=a;return d|0}function lza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0;d=u;u=u+176|0;e=d;bi[f[(f[c>>2]|0)+28>>2]&2047](c);g=a+20|0;if((f[g>>2]|0)>0){h=a+28|0;i=c+16|0;j=0;do{k=f[(f[h>>2]|0)+4+(j<<2)>>2]|0;_5b(mza(i)|0,k)|0;j=j+1|0}while((j|0)<(f[g>>2]|0))}g=a+36|0;if((f[g>>2]|0)>0){j=a+44|0;i=c+32|0;h=0;do{k=f[(f[j>>2]|0)+4+(h<<2)>>2]|0;_5b(mza(i)|0,k)|0;h=h+1|0}while((h|0)<(f[g>>2]|0))}if(!(f[a+12>>2]&1024)){l=1;u=d;return l|0}g=f[a+284>>2]|0;a=(g|0)==0?497e3:g;g=a+8|0;do if(f[g>>2]&1|0){h=f[a+56>>2]|0;i=c+8|0;f[i>>2]=f[i>>2]|4;i=c+160|0;j=f[i>>2]|0;if((j|0)==497760){jza(i,h);break}else{_5b(j,h)|0;break}}while(0);h=f[a+60>>2]|0;if(f[g>>2]&2|0){j=oza(h)|0;i=c+8|0;f[i>>2]=f[i>>2]|32;f[c+288>>2]=j}j=a+20|0;if((f[j>>2]|0)>0){i=c+80|0;k=c+92|0;m=c+88|0;n=c+84|0;o=a+28|0;p=0;do{q=f[k>>2]|0;do if(q){r=f[n>>2]|0;s=f[q>>2]|0;if((r|0)>=(s|0))if((s|0)==(f[m>>2]|0)){t=s;v=23;break}else{w=s;x=q;v=24;break}else{f[n>>2]=r+1;y=f[q+4+(r<<2)>>2]|0;break}}else{t=f[m>>2]|0;v=23}while(0);if((v|0)==23){v=0;cpb(i,t+1|0);q=f[k>>2]|0;w=f[q>>2]|0;x=q;v=24}if((v|0)==24){v=0;f[x>>2]=w+1;q=pza(0,f[i>>2]|0)|0;r=f[k>>2]|0;s=f[n>>2]|0;f[n>>2]=s+1;f[r+4+(s<<2)>>2]=q;y=q}Q8a(y,f[(f[o>>2]|0)+4+(p<<2)>>2]|0);p=p+1|0}while((p|0)<(f[j>>2]|0))}j=a+32|0;if((f[j>>2]|0)>0){p=a+40|0;o=c+124|0;y=c+128|0;n=c+132|0;k=0;i=f[o>>2]|0;do{w=f[(f[p>>2]|0)+4+(k<<2)>>2]|0;if((i|0)==(f[y>>2]|0)){qza(o,i+1|0);z=f[o>>2]|0}else z=i;x=f[n>>2]|0;i=z+1|0;f[o>>2]=i;f[x+4+(z<<2)>>2]=w;k=k+1|0}while((k|0)<(f[j>>2]|0))}j=a+44|0;if((f[j>>2]|0)>0){k=a+52|0;z=c+136|0;i=c+140|0;o=c+144|0;n=0;y=f[z>>2]|0;do{p=f[(f[k>>2]|0)+4+(n<<2)>>2]|0;if((y|0)==(f[i>>2]|0)){qza(z,y+1|0);A=f[z>>2]|0}else A=y;w=f[o>>2]|0;y=A+1|0;f[z>>2]=y;f[w+4+(A<<2)>>2]=p;n=n+1|0}while((n|0)<(f[j>>2]|0))}a:do if(!(f[g>>2]&4))B=1;else{j=h+11|0;n=b[j>>0]|0;A=h+4|0;y=f[A>>2]|0;do if(((n<<24>>24<0?y:n&255)|0)==4){if(u6b(h,0,-1,377119,4)|0){C=b[j>>0]|0;D=f[A>>2]|0;break}z=c+8|0;f[z>>2]=f[z>>2]|65536;z=c+180|0;o=f[z>>2]|0;if(!o){i=L5b(120)|0;IOa(i);f[z>>2]=i;E=i}else E=o;o=f[a+88>>2]|0;i=E+8|0;f[i>>2]=f[i>>2]|1;f[E+72>>2]=o;B=1;break a}else{C=n;D=y}while(0);if(((C<<24>>24<0?D:C&255)|0)==12?(u6b(h,0,-1,377124,12)|0)==0:0){y=c+8|0;f[y>>2]=f[y>>2]|134217728;y=c+224|0;n=f[y>>2]|0;if(!n){o=L5b(36)|0;YOa(o);f[y>>2]=o;F=o}else F=n;n=f[a+88>>2]|0;o=F+8|0;f[o>>2]=f[o>>2]|1;f[F+24>>2]=n;B=1;break}jya(e,377137,377212,305,450605,0,1);n=e+21|0;o=e+32|0;while(1){if(!(b[n>>0]|0))break;y=rP(o,377236,44)|0;i=b[j>>0]|0;z=i<<24>>24<0;rP(y,z?f[h>>2]|0:h,z?f[A>>2]|0:i&255)|0;lya(e)}kya(e+24|0);B=0}while(0);b:do if(!(f[g>>2]&8))G=B;else{F=h+11|0;C=b[F>>0]|0;D=h+4|0;E=f[D>>2]|0;do if(((C<<24>>24<0?E:C&255)|0)==4){if(u6b(h,0,-1,377119,4)|0){H=b[F>>0]|0;I=f[D>>2]|0;break}A=c+8|0;f[A>>2]=f[A>>2]|65536;A=c+180|0;j=f[A>>2]|0;if(!j){o=L5b(120)|0;IOa(o);f[A>>2]=o;J=o}else J=j;j=b[a+144>>0]|0;o=J+8|0;f[o>>2]=f[o>>2]|2;b[J+112>>0]=j;G=B;break b}else{H=C;I=E}while(0);if(((H<<24>>24<0?I:H&255)|0)==12?(u6b(h,0,-1,377124,12)|0)==0:0){E=c+8|0;f[E>>2]=f[E>>2]|134217728;E=c+224|0;C=f[E>>2]|0;if(!C){j=L5b(36)|0;YOa(j);f[E>>2]=j;K=j}else K=C;C=b[a+144>>0]|0;j=K+8|0;f[j>>2]=f[j>>2]|2;b[K+29>>0]=C;G=B;break}jya(e,377137,377212,317,450605,0,1);C=e+21|0;j=e+32|0;while(1){if(!(b[C>>0]|0))break;E=rP(j,377281,42)|0;o=b[F>>0]|0;A=o<<24>>24<0;rP(E,A?f[h>>2]|0:h,A?f[D>>2]|0:o&255)|0;lya(e)}kya(e+24|0);G=0}while(0);c:do if(!(f[g>>2]&16))L=G;else{B=h+11|0;K=b[B>>0]|0;H=h+4|0;I=f[H>>2]|0;do if(((K<<24>>24<0?I:K&255)|0)==4){if(u6b(h,0,-1,377119,4)|0){M=b[B>>0]|0;N=f[H>>2]|0;break}J=c+8|0;f[J>>2]=f[J>>2]|65536;J=c+180|0;D=f[J>>2]|0;if(!D){F=L5b(120)|0;IOa(F);f[J>>2]=F;O=F}else O=D;D=O+8|0;f[D>>2]=f[D>>2]|8192;D=O+64|0;F=f[D>>2]|0;if(!F){J=L5b(48)|0;GNa(J);f[D>>2]=J;P=J}else P=F;F=f[a+76>>2]|0;R8a(P,(F|0)==0?493544:F);L=G;break c}else{M=K;N=I}while(0);if(((M<<24>>24<0?N:M&255)|0)==12?(u6b(h,0,-1,377124,12)|0)==0:0){I=c+8|0;f[I>>2]=f[I>>2]|134217728;I=c+224|0;K=f[I>>2]|0;if(!K){F=L5b(36)|0;YOa(F);f[I>>2]=F;Q=F}else Q=K;K=Q+8|0;f[K>>2]=f[K>>2]|4;K=Q+16|0;F=f[K>>2]|0;if(!F){I=L5b(48)|0;GNa(I);f[K>>2]=I;R=I}else R=F;F=f[a+76>>2]|0;R8a(R,(F|0)==0?493544:F);L=G;break}jya(e,377137,377212,329,450605,0,1);F=e+21|0;I=e+32|0;while(1){if(!(b[F>>0]|0))break;K=rP(I,377324,47)|0;J=b[B>>0]|0;D=J<<24>>24<0;rP(K,D?f[h>>2]|0:h,D?f[H>>2]|0:J&255)|0;lya(e)}kya(e+24|0);L=0}while(0);d:do if(!(f[g>>2]&32))S=L;else{G=h+11|0;R=b[G>>0]|0;Q=h+4|0;M=f[Q>>2]|0;do if(((R<<24>>24<0?M:R&255)|0)==4){if(u6b(h,0,-1,377119,4)|0){T=b[G>>0]|0;U=f[Q>>2]|0;break}N=c+8|0;f[N>>2]=f[N>>2]|65536;N=c+180|0;P=f[N>>2]|0;if(!P){O=L5b(120)|0;IOa(O);f[N>>2]=O;V=O}else V=P;P=V+8|0;f[P>>2]=f[P>>2]|16384;P=V+68|0;O=f[P>>2]|0;if(!O){N=L5b(48)|0;GNa(N);f[P>>2]=N;W=N}else W=O;O=f[a+80>>2]|0;R8a(W,(O|0)==0?493544:O);S=L;break d}else{T=R;U=M}while(0);if(((T<<24>>24<0?U:T&255)|0)==12?(u6b(h,0,-1,377124,12)|0)==0:0){M=c+8|0;f[M>>2]=f[M>>2]|134217728;M=c+224|0;R=f[M>>2]|0;if(!R){O=L5b(36)|0;YOa(O);f[M>>2]=O;X=O}else X=R;R=X+8|0;f[R>>2]=f[R>>2]|8;R=X+20|0;O=f[R>>2]|0;if(!O){M=L5b(48)|0;GNa(M);f[R>>2]=M;Y=M}else Y=O;O=f[a+80>>2]|0;R8a(Y,(O|0)==0?493544:O);S=L;break}jya(e,377137,377212,341,450605,0,1);O=e+21|0;M=e+32|0;while(1){if(!(b[O>>0]|0))break;R=rP(M,377372,45)|0;N=b[G>>0]|0;P=N<<24>>24<0;rP(R,P?f[h>>2]|0:h,P?f[Q>>2]|0:N&255)|0;lya(e)}kya(e+24|0);S=0}while(0);e:do if(!(f[g>>2]&64))Z=S;else{L=h+11|0;Y=b[L>>0]|0;X=h+4|0;T=f[X>>2]|0;do if(((Y<<24>>24<0?T:Y&255)|0)==4){if(u6b(h,0,-1,377119,4)|0){_=b[L>>0]|0;$=f[X>>2]|0;break}U=c+8|0;f[U>>2]=f[U>>2]|65536;U=c+180|0;W=f[U>>2]|0;if(!W){V=L5b(120)|0;IOa(V);f[U>>2]=V;aa=V}else aa=W;W=f[a+92>>2]|0;V=aa+16|0;U=f[V>>2]|0;if((U|0)==(f[aa+20>>2]|0)){rza(V,U+1|0);ba=f[V>>2]|0}else ba=U;U=f[aa+24>>2]|0;f[V>>2]=ba+1;f[U+4+(ba<<2)>>2]=W;Z=S;break e}else{_=Y;$=T}while(0);if(((_<<24>>24<0?$:_&255)|0)==4?(u6b(h,0,-1,377418,4)|0)==0:0){T=c+8|0;f[T>>2]=f[T>>2]|-2147483648;T=c+240|0;Y=f[T>>2]|0;if(!Y){W=L5b(68)|0;dPa(W);f[T>>2]=W;ca=W}else ca=Y;Y=f[a+92>>2]|0;W=ca+8|0;f[W>>2]=f[W>>2]|2;f[ca+20>>2]=Y;Z=S;break}jya(e,377137,377212,351,450605,0,1);Y=e+21|0;W=e+32|0;while(1){if(!(b[Y>>0]|0))break;T=rP(W,377423,37)|0;U=b[L>>0]|0;V=U<<24>>24<0;rP(T,V?f[h>>2]|0:h,V?f[X>>2]|0:U&255)|0;lya(e)}kya(e+24|0);Z=0}while(0);f:do if(!(f[g>>2]&128))da=Z;else{S=h+11|0;ca=b[S>>0]|0;_=h+4|0;$=f[_>>2]|0;do if(((ca<<24>>24<0?$:ca&255)|0)==4){if(u6b(h,0,-1,377119,4)|0){ea=b[S>>0]|0;fa=f[_>>2]|0;break}ba=c+8|0;f[ba>>2]=f[ba>>2]|65536;ba=c+180|0;aa=f[ba>>2]|0;if(!aa){X=L5b(120)|0;IOa(X);f[ba>>2]=X;ga=X}else ga=aa;aa=f[a+96>>2]|0;X=ga+28|0;ba=f[X>>2]|0;if((ba|0)==(f[ga+32>>2]|0)){rza(X,ba+1|0);ha=f[X>>2]|0}else ha=ba;ba=f[ga+36>>2]|0;f[X>>2]=ha+1;f[ba+4+(ha<<2)>>2]=aa;da=Z;break f}else{ea=ca;fa=$}while(0);if(((ea<<24>>24<0?fa:ea&255)|0)==4?(u6b(h,0,-1,377418,4)|0)==0:0){$=c+8|0;f[$>>2]=f[$>>2]|-2147483648;$=c+240|0;ca=f[$>>2]|0;if(!ca){aa=L5b(68)|0;dPa(aa);f[$>>2]=aa;ia=aa}else ia=ca;ca=f[a+96>>2]|0;aa=ia+8|0;f[aa>>2]=f[aa>>2]|16;f[ia+32>>2]=ca;da=Z;break}jya(e,377137,377212,363,450605,0,1);ca=e+21|0;aa=e+32|0;while(1){if(!(b[ca>>0]|0))break;$=rP(aa,377461,44)|0;ba=b[S>>0]|0;X=ba<<24>>24<0;rP($,X?f[h>>2]|0:h,X?f[_>>2]|0:ba&255)|0;lya(e)}kya(e+24|0);da=0}while(0);do if(!(f[g>>2]&256))ja=da;else{Z=h+11|0;ia=b[Z>>0]|0;ea=h+4|0;if(((ia<<24>>24<0?f[ea>>2]|0:ia&255)|0)==4?(u6b(h,0,-1,377119,4)|0)==0:0){ia=c+8|0;f[ia>>2]=f[ia>>2]|65536;ia=c+180|0;fa=f[ia>>2]|0;if(!fa){ha=L5b(120)|0;IOa(ha);f[ia>>2]=ha;ka=ha}else ka=fa;fa=f[a+148>>2]|0;ha=ka+8|0;f[ha>>2]=f[ha>>2]|4096;f[ka+116>>2]=fa;ja=da;break}jya(e,377137,377212,372,450605,0,1);fa=e+21|0;ha=e+32|0;while(1){if(!(b[fa>>0]|0))break;ia=rP(ha,377506,39)|0;ga=b[Z>>0]|0;_=ga<<24>>24<0;rP(ia,_?f[h>>2]|0:h,_?f[ea>>2]|0:ga&255)|0;lya(e)}kya(e+24|0);ja=0}while(0);g:do if(!(f[g>>2]&512))la=ja;else{da=h+11|0;ka=b[da>>0]|0;ea=h+4|0;Z=f[ea>>2]|0;do if(((ka<<24>>24<0?Z:ka&255)|0)==4){if(u6b(h,0,-1,377119,4)|0){ma=b[da>>0]|0;na=f[ea>>2]|0;break}ha=c+8|0;f[ha>>2]=f[ha>>2]|65536;ha=c+180|0;fa=f[ha>>2]|0;if(!fa){ga=L5b(120)|0;IOa(ga);f[ha>>2]=ga;oa=ga}else oa=fa;fa=f[a+152>>2]|0;ga=oa+40|0;ha=f[ga>>2]|0;if((ha|0)==(f[oa+44>>2]|0)){rza(ga,ha+1|0);pa=f[ga>>2]|0}else pa=ha;ha=f[oa+48>>2]|0;f[ga>>2]=pa+1;f[ha+4+(pa<<2)>>2]=fa;la=ja;break g}else{ma=ka;na=Z}while(0);do if(((ma<<24>>24<0?na:ma&255)|0)==4){if(u6b(h,0,-1,377418,4)|0)break;Z=c+8|0;f[Z>>2]=f[Z>>2]|-2147483648;Z=c+240|0;ka=f[Z>>2]|0;if(!ka){fa=L5b(68)|0;dPa(fa);f[Z>>2]=fa;qa=fa}else qa=ka;ka=f[a+152>>2]|0;fa=qa+8|0;f[fa>>2]=f[fa>>2]|128;f[qa+60>>2]=ka;la=ja;break g}while(0);jya(e,377137,377212,384,450605,0,1);ka=e+21|0;fa=e+32|0;while(1){if(!(b[ka>>0]|0))break;Z=rP(fa,377546,40)|0;ha=b[da>>0]|0;ga=ha<<24>>24<0;rP(Z,ga?f[h>>2]|0:h,ga?f[ea>>2]|0:ha&255)|0;lya(e)}kya(e+24|0);la=0}while(0);h:do if(!(f[g>>2]&1024))ra=la;else{ja=h+11|0;qa=b[ja>>0]|0;ma=h+4|0;do if(((qa<<24>>24<0?f[ma>>2]|0:qa&255)|0)==4){if(u6b(h,0,-1,377418,4)|0)break;na=f[a+100>>2]|0;switch(na|0){case 0:{pa=c+8|0;f[pa>>2]=f[pa>>2]|-2147483648;pa=c+240|0;oa=f[pa>>2]|0;if(!oa){ea=L5b(68)|0;dPa(ea);f[pa>>2]=ea;sa=ea}else sa=oa;oa=sa+8|0;f[oa>>2]=f[oa>>2]|1;f[sa+16>>2]=0;ra=la;break h;break}case 1:{oa=c+8|0;f[oa>>2]=f[oa>>2]|-2147483648;oa=c+240|0;ea=f[oa>>2]|0;if(!ea){pa=L5b(68)|0;dPa(pa);f[oa>>2]=pa;ta=pa}else ta=ea;ea=ta+8|0;f[ea>>2]=f[ea>>2]|1;f[ta+16>>2]=1;ra=la;break h;break}case 2:{ea=c+8|0;f[ea>>2]=f[ea>>2]|-2147483648;ea=c+240|0;pa=f[ea>>2]|0;if(!pa){oa=L5b(68)|0;dPa(oa);f[ea>>2]=oa;ua=oa}else ua=pa;pa=ua+8|0;f[pa>>2]=f[pa>>2]|1;f[ua+16>>2]=2;ra=la;break h;break}default:{jya(e,377137,377212,405,450605,0,1);pa=e+21|0;oa=e+32|0;while(1){if(!(b[pa>>0]|0))break;iYb(rP(oa,377587,20)|0,na)|0;lya(e)}kya(e+24|0);ra=0;break h}}}while(0);jya(e,377137,377212,409,450605,0,1);qa=e+21|0;na=e+32|0;while(1){if(!(b[qa>>0]|0))break;oa=rP(na,377608,38)|0;pa=b[ja>>0]|0;ea=pa<<24>>24<0;rP(oa,ea?f[h>>2]|0:h,ea?f[ma>>2]|0:pa&255)|0;lya(e)}kya(e+24|0);ra=0}while(0);i:do if(!(f[g>>2]&2048))va=ra;else{la=h+11|0;ua=b[la>>0]|0;ta=h+4|0;do if(((ua<<24>>24<0?f[ta>>2]|0:ua&255)|0)==7){if(u6b(h,0,-1,377647,7)|0)break;sa=c+8|0;f[sa>>2]=f[sa>>2]|262144;sa=c+188|0;ma=f[sa>>2]|0;if(!ma){ja=L5b(24)|0;MOa(ja);f[sa>>2]=ja;wa=ja}else wa=ma;ma=f[a+156>>2]|0;ja=wa+8|0;f[ja>>2]=f[ja>>2]|1;f[wa+16>>2]=ma;va=ra;break i}while(0);jya(e,377137,377212,418,450605,0,1);ua=e+21|0;ma=e+32|0;while(1){if(!(b[ua>>0]|0))break;ja=rP(ma,377655,47)|0;sa=b[la>>0]|0;na=sa<<24>>24<0;rP(ja,na?f[h>>2]|0:h,na?f[ta>>2]|0:sa&255)|0;lya(e)}kya(e+24|0);va=0}while(0);j:do if(!(f[g>>2]&4096))xa=va;else{ra=h+11|0;wa=b[ra>>0]|0;ta=h+4|0;do if(((wa<<24>>24<0?f[ta>>2]|0:wa&255)|0)==3){if(u6b(h,0,-1,377703,3)|0)break;la=c+8|0;f[la>>2]=f[la>>2]|268435456;la=c+228|0;ma=f[la>>2]|0;if(!ma){ua=L5b(40)|0;_Oa(ua);f[la>>2]=ua;ya=ua}else ya=ma;ma=f[a+160>>2]|0;ua=ya+8|0;f[ua>>2]=f[ua>>2]|1;f[ya+24>>2]=ma;xa=va;break j}while(0);jya(e,377137,377212,427,450605,0,1);wa=e+21|0;ma=e+32|0;while(1){if(!(b[wa>>0]|0))break;ua=rP(ma,377707,44)|0;la=b[ra>>0]|0;sa=la<<24>>24<0;rP(ua,sa?f[h>>2]|0:h,sa?f[ta>>2]|0:la&255)|0;lya(e)}kya(e+24|0);xa=0}while(0);k:do if(!(f[g>>2]&8192))za=xa;else{va=h+11|0;ya=b[va>>0]|0;ta=h+4|0;do if(((ya<<24>>24<0?f[ta>>2]|0:ya&255)|0)==3){if(u6b(h,0,-1,377703,3)|0)break;ra=c+8|0;f[ra>>2]=f[ra>>2]|268435456;ra=c+228|0;ma=f[ra>>2]|0;if(!ma){wa=L5b(40)|0;_Oa(wa);f[ra>>2]=wa;Aa=wa}else Aa=ma;ma=f[a+164>>2]|0;wa=Aa+8|0;f[wa>>2]=f[wa>>2]|2;f[Aa+28>>2]=ma;za=xa;break k}while(0);jya(e,377137,377212,435,450605,0,1);ya=e+21|0;ma=e+32|0;while(1){if(!(b[ya>>0]|0))break;wa=rP(ma,377752,39)|0;ra=b[va>>0]|0;la=ra<<24>>24<0;rP(wa,la?f[h>>2]|0:h,la?f[ta>>2]|0:ra&255)|0;lya(e)}kya(e+24|0);za=0}while(0);l:do if(!(f[g>>2]&16384))Ba=za;else{xa=h+11|0;Aa=b[xa>>0]|0;ta=h+4|0;do if(((Aa<<24>>24<0?f[ta>>2]|0:Aa&255)|0)==3){if(u6b(h,0,-1,377703,3)|0)break;va=c+8|0;f[va>>2]=f[va>>2]|268435456;va=c+228|0;ma=f[va>>2]|0;if(!ma){ya=L5b(40)|0;_Oa(ya);f[va>>2]=ya;Ca=ya}else Ca=ma;ma=f[a+168>>2]|0;ya=Ca+8|0;f[ya>>2]=f[ya>>2]|4;f[Ca+32>>2]=ma;Ba=za;break l}while(0);jya(e,377137,377212,443,450605,0,1);Aa=e+21|0;ma=e+32|0;while(1){if(!(b[Aa>>0]|0))break;ya=rP(ma,377792,38)|0;va=b[xa>>0]|0;ra=va<<24>>24<0;rP(ya,ra?f[h>>2]|0:h,ra?f[ta>>2]|0:va&255)|0;lya(e)}kya(e+24|0);Ba=0}while(0);m:do if(!(f[g>>2]&32768))Da=Ba;else{za=h+11|0;Ca=b[za>>0]|0;ta=h+4|0;do if(((Ca<<24>>24<0?f[ta>>2]|0:Ca&255)|0)==3){if(u6b(h,0,-1,377703,3)|0)break;xa=c+8|0;f[xa>>2]=f[xa>>2]|268435456;xa=c+228|0;ma=f[xa>>2]|0;if(!ma){Aa=L5b(40)|0;_Oa(Aa);f[xa>>2]=Aa;Ea=Aa}else Ea=ma;ma=f[a+172>>2]|0;Aa=Ea+8|0;f[Aa>>2]=f[Aa>>2]|16;f[Ea+36>>2]=ma;Da=Ba;break m}while(0);jya(e,377137,377212,451,450605,0,1);Ca=e+21|0;ma=e+32|0;while(1){if(!(b[Ca>>0]|0))break;Aa=rP(ma,377831,35)|0;xa=b[za>>0]|0;va=xa<<24>>24<0;rP(Aa,va?f[h>>2]|0:h,va?f[ta>>2]|0:xa&255)|0;lya(e)}kya(e+24|0);Da=0}while(0);n:do if(!(f[g>>2]&65536))Fa=Da;else{Ba=h+11|0;Ea=b[Ba>>0]|0;ta=h+4|0;za=f[ta>>2]|0;do if(((Ea<<24>>24<0?za:Ea&255)|0)==4){if(u6b(h,0,-1,377867,4)|0){Ga=b[Ba>>0]|0;Ha=f[ta>>2]|0;break}ma=c+8|0;f[ma>>2]=f[ma>>2]|131072;ma=c+184|0;Ca=f[ma>>2]|0;if(!Ca){xa=L5b(52)|0;KOa(xa);f[ma>>2]=xa;Ia=xa}else Ia=Ca;Ca=f[a+64>>2]|0;xa=Ia+8|0;f[xa>>2]=f[xa>>2]|1;xa=Ia+16|0;ma=f[xa>>2]|0;if((ma|0)==497760){jza(xa,Ca);Fa=Da;break n}else{_5b(ma,Ca)|0;Fa=Da;break n}}else{Ga=Ea;Ha=za}while(0);do if(((Ga<<24>>24<0?Ha:Ga&255)|0)==9){if(u6b(h,0,-1,377872,9)|0){Ja=b[Ba>>0]|0;Ka=f[ta>>2]|0;break}za=c+8|0;f[za>>2]=f[za>>2]|4194304;za=c+204|0;Ea=f[za>>2]|0;if(!Ea){Ca=L5b(28)|0;SOa(Ca);f[za>>2]=Ca;La=Ca}else La=Ea;Ea=f[a+64>>2]|0;Ca=La+8|0;f[Ca>>2]=f[Ca>>2]|1;Ca=La+16|0;za=f[Ca>>2]|0;if((za|0)==497760){jza(Ca,Ea);Fa=Da;break n}else{_5b(za,Ea)|0;Fa=Da;break n}}else{Ja=Ga;Ka=Ha}while(0);do if(((Ja<<24>>24<0?Ka:Ja&255)|0)==6){if(u6b(h,0,-1,377882,6)|0){Ma=f[ta>>2]|0;Na=b[Ba>>0]|0;break}Ea=c+8|0;f[Ea>>2]=f[Ea>>2]|33554432;Ea=c+216|0;za=f[Ea>>2]|0;if(!za){Ca=L5b(60)|0;VOa(Ca);f[Ea>>2]=Ca;Oa=Ca}else Oa=za;za=f[a+64>>2]|0;Ca=Oa+8|0;f[Ca>>2]=f[Ca>>2]|1;Ca=Oa+16|0;Ea=f[Ca>>2]|0;if((Ea|0)==497760){jza(Ca,za);Fa=Da;break n}else{_5b(Ea,za)|0;Fa=Da;break n}}else{Ma=Ka;Na=Ja}while(0);do if(((Na<<24>>24<0?Ma:Na&255)|0)==11){if(u6b(h,0,-1,377889,11)|0){Pa=b[Ba>>0]|0;Qa=f[ta>>2]|0;break}za=c+12|0;f[za>>2]=f[za>>2]|128;za=c+272|0;Ea=f[za>>2]|0;if(!Ea){Ca=L5b(64)|0;nPa(Ca);f[za>>2]=Ca;Ra=Ca}else Ra=Ea;Ea=f[a+64>>2]|0;Ca=Ra+8|0;f[Ca>>2]=f[Ca>>2]|1;Ca=Ra+16|0;za=f[Ca>>2]|0;if((za|0)==497760){jza(Ca,Ea);Fa=Da;break n}else{_5b(za,Ea)|0;Fa=Da;break n}}else{Pa=Na;Qa=Ma}while(0);do if(((Pa<<24>>24<0?Qa:Pa&255)|0)==13){if(u6b(h,0,-1,377901,13)|0)break;Ea=c+8|0;f[Ea>>2]=f[Ea>>2]|67108864;Ea=c+220|0;za=f[Ea>>2]|0;if(!za){Ca=L5b(20)|0;XOa(Ca);f[Ea>>2]=Ca;Sa=Ca}else Sa=za;za=f[a+64>>2]|0;Ca=Sa+8|0;f[Ca>>2]=f[Ca>>2]|1;Ca=Sa+16|0;Ea=f[Ca>>2]|0;if((Ea|0)==497760){jza(Ca,za);Fa=Da;break n}else{_5b(Ea,za)|0;Fa=Da;break n}}while(0);jya(e,377137,377212,471,450605,0,1);za=e+21|0;Ea=e+32|0;while(1){if(!(b[za>>0]|0))break;Ca=rP(Ea,377915,40)|0;ma=b[Ba>>0]|0;xa=ma<<24>>24<0;rP(Ca,xa?f[h>>2]|0:h,xa?f[ta>>2]|0:ma&255)|0;lya(e)}kya(e+24|0);Fa=0}while(0);Da=f[g>>2]|0;if(!(Da&131072))Ta=Da;else{Da=c+12|0;f[Da>>2]=f[Da>>2]|256;Da=c+276|0;Sa=f[Da>>2]|0;if(!Sa){Pa=L5b(44)|0;pPa(Pa);f[Da>>2]=Pa;Ua=Pa}else Ua=Sa;Sa=f[a+176>>2]|0;Pa=Ua+8|0;f[Pa>>2]=f[Pa>>2]|1;f[Ua+40>>2]=Sa;Ta=f[g>>2]|0}do if(Ta&262144|0){Sa=c+12|0;f[Sa>>2]=f[Sa>>2]|256;Sa=c+276|0;Ua=f[Sa>>2]|0;if(!Ua){Pa=L5b(44)|0;pPa(Pa);f[Sa>>2]=Pa;Va=Pa}else Va=Ua;Ua=f[a+68>>2]|0;Pa=Va+8|0;f[Pa>>2]=f[Pa>>2]|8;Pa=Va+28|0;Sa=f[Pa>>2]|0;if((Sa|0)==497760){jza(Pa,Ua);break}else{_5b(Sa,Ua)|0;break}}while(0);o:do if(!(f[g>>2]&524288))Wa=Fa;else{Va=h+11|0;Ta=b[Va>>0]|0;Ua=h+4|0;Sa=f[Ua>>2]|0;do if(((Ta<<24>>24<0?Sa:Ta&255)|0)==4){if(u6b(h,0,-1,377867,4)|0){Xa=b[Va>>0]|0;Ya=f[Ua>>2]|0;break}Pa=c+8|0;f[Pa>>2]=f[Pa>>2]|131072;Pa=c+184|0;Da=f[Pa>>2]|0;if(!Da){Qa=L5b(52)|0;KOa(Qa);f[Pa>>2]=Qa;Za=Qa}else Za=Da;Da=f[a+104>>2]|0;Qa=Za+8|0;f[Qa>>2]=f[Qa>>2]|2;f[Za+24>>2]=Da;Wa=Fa;break o}else{Xa=Ta;Ya=Sa}while(0);do if(((Xa<<24>>24<0?Ya:Xa&255)|0)==9){if(u6b(h,0,-1,377872,9)|0){_a=b[Va>>0]|0;$a=f[Ua>>2]|0;break}Sa=c+8|0;f[Sa>>2]=f[Sa>>2]|4194304;Sa=c+204|0;Ta=f[Sa>>2]|0;if(!Ta){Da=L5b(28)|0;SOa(Da);f[Sa>>2]=Da;ab=Da}else ab=Ta;Ta=f[a+104>>2]|0;Da=ab+8|0;f[Da>>2]=f[Da>>2]|2;f[ab+20>>2]=Ta;Wa=Fa;break o}else{_a=Xa;$a=Ya}while(0);do if(((_a<<24>>24<0?$a:_a&255)|0)==6){if(u6b(h,0,-1,377882,6)|0){bb=b[Va>>0]|0;cb=f[Ua>>2]|0;break}Ta=c+8|0;f[Ta>>2]=f[Ta>>2]|33554432;Ta=c+216|0;Da=f[Ta>>2]|0;if(!Da){Sa=L5b(60)|0;VOa(Sa);f[Ta>>2]=Sa;db=Sa}else db=Da;Da=f[a+104>>2]|0;Sa=db+8|0;f[Sa>>2]=f[Sa>>2]|2;f[db+52>>2]=Da;Wa=Fa;break o}else{bb=_a;cb=$a}while(0);do if(((bb<<24>>24<0?cb:bb&255)|0)==11){if(u6b(h,0,-1,377889,11)|0)break;Da=c+12|0;f[Da>>2]=f[Da>>2]|128;Da=c+272|0;Sa=f[Da>>2]|0;if(!Sa){Ta=L5b(64)|0;nPa(Ta);f[Da>>2]=Ta;eb=Ta}else eb=Sa;Sa=f[a+104>>2]|0;Ta=eb+8|0;f[Ta>>2]=f[Ta>>2]|8;f[eb+32>>2]=Sa;Wa=Fa;break o}while(0);jya(e,377137,377212,497,450605,0,1);Sa=e+21|0;Ta=e+32|0;while(1){if(!(b[Sa>>0]|0))break;Da=rP(Ta,377956,43)|0;Qa=b[Va>>0]|0;Pa=Qa<<24>>24<0;rP(Da,Pa?f[h>>2]|0:h,Pa?f[Ua>>2]|0:Qa&255)|0;lya(e)}kya(e+24|0);Wa=0}while(0);Fa=f[g>>2]|0;if(!(Fa&1048576))fb=Fa;else{Fa=c+12|0;f[Fa>>2]=f[Fa>>2]|256;Fa=c+276|0;eb=f[Fa>>2]|0;if(!eb){bb=L5b(44)|0;pPa(bb);f[Fa>>2]=bb;gb=bb}else gb=eb;eb=f[a+108>>2]|0;bb=gb+8|0;f[bb>>2]=f[bb>>2]|4;f[gb+32>>2]=eb;fb=f[g>>2]|0}if(!(fb&2097152))hb=fb;else{fb=c+12|0;f[fb>>2]=f[fb>>2]|256;fb=c+276|0;eb=f[fb>>2]|0;if(!eb){gb=L5b(44)|0;pPa(gb);f[fb>>2]=gb;ib=gb}else ib=eb;eb=b[a+116>>0]|0;gb=ib+8|0;f[gb>>2]=f[gb>>2]|2;b[ib+36>>0]=eb;hb=f[g>>2]|0}p:do if(!(hb&33554432))jb=Wa;else{eb=h+11|0;ib=b[eb>>0]|0;gb=h+4|0;fb=f[gb>>2]|0;do if(((ib<<24>>24<0?fb:ib&255)|0)==4){if(u6b(h,0,-1,377867,4)|0){kb=b[eb>>0]|0;lb=f[gb>>2]|0;break}bb=c+8|0;f[bb>>2]=f[bb>>2]|131072;bb=c+184|0;Fa=f[bb>>2]|0;if(!Fa){cb=L5b(52)|0;KOa(cb);f[bb>>2]=cb;mb=cb}else mb=Fa;Fa=f[a+112>>2]|0;cb=mb+8|0;f[cb>>2]=f[cb>>2]|4;f[mb+28>>2]=Fa;jb=Wa;break p}else{kb=ib;lb=fb}while(0);do if(((kb<<24>>24<0?lb:kb&255)|0)==6){if(u6b(h,0,-1,377882,6)|0)break;fb=c+8|0;f[fb>>2]=f[fb>>2]|33554432;fb=c+216|0;ib=f[fb>>2]|0;if(!ib){Fa=L5b(60)|0;VOa(Fa);f[fb>>2]=Fa;nb=Fa}else nb=ib;ib=f[a+112>>2]|0;Fa=nb+8|0;f[Fa>>2]=f[Fa>>2]|4;f[nb+28>>2]=ib;jb=Wa;break p}while(0);jya(e,377137,377212,517,450605,0,1);ib=e+21|0;Fa=e+32|0;while(1){if(!(b[ib>>0]|0))break;fb=rP(Fa,378e3,43)|0;cb=b[eb>>0]|0;bb=cb<<24>>24<0;rP(fb,bb?f[h>>2]|0:h,bb?f[gb>>2]|0:cb&255)|0;lya(e)}kya(e+24|0);jb=0}while(0);Wa=a+12|0;q:do if(!(f[Wa>>2]&8))ob=jb;else{nb=h+11|0;kb=b[nb>>0]|0;lb=h+4|0;do if(((kb<<24>>24<0?f[lb>>2]|0:kb&255)|0)==6){if(u6b(h,0,-1,377882,6)|0)break;mb=c+8|0;f[mb>>2]=f[mb>>2]|33554432;mb=c+216|0;hb=f[mb>>2]|0;if(!hb){gb=L5b(60)|0;VOa(gb);f[mb>>2]=gb;pb=gb}else pb=hb;hb=b[a+117>>0]|0;gb=pb+8|0;f[gb>>2]=f[gb>>2]|8;b[pb+40>>0]=hb;ob=jb;break q}while(0);jya(e,377137,377212,526,450605,0,1);kb=e+21|0;hb=e+32|0;while(1){if(!(b[kb>>0]|0))break;gb=rP(hb,378044,41)|0;mb=b[nb>>0]|0;eb=mb<<24>>24<0;rP(gb,eb?f[h>>2]|0:h,eb?f[lb>>2]|0:mb&255)|0;lya(e)}kya(e+24|0);ob=0}while(0);r:do if(!(f[Wa>>2]&2))qb=ob;else{jb=h+11|0;pb=b[jb>>0]|0;lb=h+4|0;do if(((pb<<24>>24<0?f[lb>>2]|0:pb&255)|0)==6){if(u6b(h,0,-1,377882,6)|0)break;nb=c+8|0;f[nb>>2]=f[nb>>2]|33554432;nb=c+216|0;hb=f[nb>>2]|0;if(!hb){kb=L5b(60)|0;VOa(kb);f[nb>>2]=kb;rb=kb}else rb=hb;hb=f[a+132>>2]|0;kb=rb+8|0;f[kb>>2]=f[kb>>2]|16;f[rb+32>>2]=hb;qb=ob;break r}while(0);jya(e,377137,377212,535,450605,0,1);pb=e+21|0;hb=e+32|0;while(1){if(!(b[pb>>0]|0))break;kb=rP(hb,378086,44)|0;nb=b[jb>>0]|0;mb=nb<<24>>24<0;rP(kb,mb?f[h>>2]|0:h,mb?f[lb>>2]|0:nb&255)|0;lya(e)}kya(e+24|0);qb=0}while(0);s:do if(!(f[Wa>>2]&4))sb=qb;else{ob=h+11|0;rb=b[ob>>0]|0;lb=h+4|0;do if(((rb<<24>>24<0?f[lb>>2]|0:rb&255)|0)==6){if(u6b(h,0,-1,377882,6)|0)break;jb=c+8|0;f[jb>>2]=f[jb>>2]|33554432;jb=c+216|0;hb=f[jb>>2]|0;if(!hb){pb=L5b(60)|0;VOa(pb);f[jb>>2]=pb;tb=pb}else tb=hb;hb=f[a+136>>2]|0;pb=tb+8|0;f[pb>>2]=f[pb>>2]|32;f[tb+36>>2]=hb;sb=qb;break s}while(0);jya(e,377137,377212,544,450605,0,1);rb=e+21|0;hb=e+32|0;while(1){if(!(b[rb>>0]|0))break;pb=rP(hb,378131,43)|0;jb=b[ob>>0]|0;nb=jb<<24>>24<0;rP(pb,nb?f[h>>2]|0:h,nb?f[lb>>2]|0:jb&255)|0;lya(e)}kya(e+24|0);sb=0}while(0);t:do if(!(f[Wa>>2]&16))ub=sb;else{qb=h+11|0;tb=b[qb>>0]|0;lb=h+4|0;do if(((tb<<24>>24<0?f[lb>>2]|0:tb&255)|0)==6){if(u6b(h,0,-1,378175,6)|0)break;ob=c+8|0;f[ob>>2]=f[ob>>2]|16384;ob=c+172|0;hb=f[ob>>2]|0;if(!hb){rb=L5b(24)|0;GOa(rb);f[ob>>2]=rb;vb=rb}else vb=hb;hb=f[a+140>>2]|0;rb=vb+8|0;f[rb>>2]=f[rb>>2]|2;f[vb+20>>2]=hb;ub=sb;break t}while(0);jya(e,377137,377212,553,450605,0,1);tb=e+21|0;hb=e+32|0;while(1){if(!(b[tb>>0]|0))break;rb=rP(hb,378182,44)|0;ob=b[qb>>0]|0;jb=ob<<24>>24<0;rP(rb,jb?f[h>>2]|0:h,jb?f[lb>>2]|0:ob&255)|0;lya(e)}kya(e+24|0);ub=0}while(0);u:do if(!(f[g>>2]&67108864))wb=ub;else{sb=h+11|0;vb=b[sb>>0]|0;lb=h+4|0;do if(((vb<<24>>24<0?f[lb>>2]|0:vb&255)|0)==11){if(u6b(h,0,-1,377889,11)|0)break;qb=c+12|0;f[qb>>2]=f[qb>>2]|128;qb=c+272|0;hb=f[qb>>2]|0;if(!hb){tb=L5b(64)|0;nPa(tb);f[qb>>2]=tb;xb=tb}else xb=hb;hb=f[a+180>>2]|0;tb=xb+8|0;f[tb>>2]=f[tb>>2]|64;f[xb+52>>2]=hb;wb=ub;break u}while(0);jya(e,377137,377212,562,450605,0,1);vb=e+21|0;hb=e+32|0;while(1){if(!(b[vb>>0]|0))break;tb=rP(hb,378227,50)|0;qb=b[sb>>0]|0;ob=qb<<24>>24<0;rP(tb,ob?f[h>>2]|0:h,ob?f[lb>>2]|0:qb&255)|0;lya(e)}kya(e+24|0);wb=0}while(0);v:do if(!(f[g>>2]&134217728))yb=wb;else{ub=h+11|0;xb=b[ub>>0]|0;lb=h+4|0;do if(((xb<<24>>24<0?f[lb>>2]|0:xb&255)|0)==11){if(u6b(h,0,-1,377889,11)|0)break;sb=c+12|0;f[sb>>2]=f[sb>>2]|128;sb=c+272|0;hb=f[sb>>2]|0;if(!hb){vb=L5b(64)|0;nPa(vb);f[sb>>2]=vb;zb=vb}else zb=hb;hb=f[a+184>>2]|0;vb=zb+8|0;f[vb>>2]=f[vb>>2]|128;f[zb+56>>2]=hb;yb=wb;break v}while(0);jya(e,377137,377212,572,450605,0,1);xb=e+21|0;hb=e+32|0;while(1){if(!(b[xb>>0]|0))break;vb=rP(hb,378278,50)|0;sb=b[ub>>0]|0;qb=sb<<24>>24<0;rP(vb,qb?f[h>>2]|0:h,qb?f[lb>>2]|0:sb&255)|0;lya(e)}kya(e+24|0);yb=0}while(0);w:do if(!(f[g>>2]&268435456))Ab=yb;else{wb=h+11|0;zb=b[wb>>0]|0;lb=h+4|0;do if(((zb<<24>>24<0?f[lb>>2]|0:zb&255)|0)==11){if(u6b(h,0,-1,377889,11)|0)break;ub=c+12|0;f[ub>>2]=f[ub>>2]|128;ub=c+272|0;hb=f[ub>>2]|0;if(!hb){xb=L5b(64)|0;nPa(xb);f[ub>>2]=xb;Bb=xb}else Bb=hb;hb=f[a+188>>2]|0;xb=Bb+8|0;f[xb>>2]=f[xb>>2]|256;f[Bb+60>>2]=hb;Ab=yb;break w}while(0);jya(e,377137,377212,582,450605,0,1);zb=e+21|0;hb=e+32|0;while(1){if(!(b[zb>>0]|0))break;xb=rP(hb,378329,49)|0;ub=b[wb>>0]|0;sb=ub<<24>>24<0;rP(xb,sb?f[h>>2]|0:h,sb?f[lb>>2]|0:ub&255)|0;lya(e)}kya(e+24|0);Ab=0}while(0);x:do if(!(f[g>>2]&536870912))Cb=Ab;else{yb=h+11|0;Bb=b[yb>>0]|0;lb=h+4|0;do if(((Bb<<24>>24<0?f[lb>>2]|0:Bb&255)|0)==11){if(u6b(h,0,-1,377889,11)|0)break;wb=c+12|0;f[wb>>2]=f[wb>>2]|128;wb=c+272|0;hb=f[wb>>2]|0;if(!hb){zb=L5b(64)|0;nPa(zb);f[wb>>2]=zb;Db=zb}else Db=hb;hb=f[a+120>>2]|0;zb=Db+8|0;f[zb>>2]=f[zb>>2]|512;f[Db+44>>2]=hb;Cb=Ab;break x}while(0);jya(e,377137,377212,592,450605,0,1);Bb=e+21|0;hb=e+32|0;while(1){if(!(b[Bb>>0]|0))break;zb=rP(hb,378379,49)|0;wb=b[yb>>0]|0;ub=wb<<24>>24<0;rP(zb,ub?f[h>>2]|0:h,ub?f[lb>>2]|0:wb&255)|0;lya(e)}kya(e+24|0);Cb=0}while(0);y:do if(!(f[g>>2]&1073741824))Eb=Cb;else{Ab=h+11|0;Db=b[Ab>>0]|0;lb=h+4|0;do if(((Db<<24>>24<0?f[lb>>2]|0:Db&255)|0)==11){if(u6b(h,0,-1,377889,11)|0)break;yb=c+12|0;f[yb>>2]=f[yb>>2]|128;yb=c+272|0;hb=f[yb>>2]|0;if(!hb){Bb=L5b(64)|0;nPa(Bb);f[yb>>2]=Bb;Fb=Bb}else Fb=hb;hb=f[a+72>>2]|0;Bb=Fb+8|0;f[Bb>>2]=f[Bb>>2]|1024;Bb=Fb+24|0;yb=f[Bb>>2]|0;if((yb|0)==(f[213031]|0)){jza(Bb,hb);Eb=Cb;break y}else{_5b(yb,hb)|0;Eb=Cb;break y}}while(0);jya(e,377137,377212,602,450605,0,1);Db=e+21|0;hb=e+32|0;while(1){if(!(b[Db>>0]|0))break;yb=rP(hb,378429,47)|0;Bb=b[Ab>>0]|0;wb=Bb<<24>>24<0;rP(yb,wb?f[h>>2]|0:h,wb?f[lb>>2]|0:Bb&255)|0;lya(e)}kya(e+24|0);Eb=0}while(0);z:do if(!(f[Wa>>2]&32))Gb=Eb;else{Cb=h+11|0;Fb=b[Cb>>0]|0;g=h+4|0;do if(((Fb<<24>>24<0?f[g>>2]|0:Fb&255)|0)==11){if(u6b(h,0,-1,378477,11)|0)break;lb=c+8|0;f[lb>>2]=f[lb>>2]|8388608;lb=c+208|0;Ab=f[lb>>2]|0;if(!Ab){hb=L5b(20)|0;cOa(hb);f[lb>>2]=hb;Hb=hb}else Hb=Ab;Ab=f[a+84>>2]|0;h9a(Hb,(Ab|0)==0?495568:Ab);Gb=Eb;break z}while(0);jya(e,377137,377212,612,450605,0,1);Fb=e+21|0;Ab=e+32|0;while(1){if(!(b[Fb>>0]|0))break;hb=rP(Ab,378489,51)|0;lb=b[Cb>>0]|0;Db=lb<<24>>24<0;rP(hb,Db?f[h>>2]|0:h,Db?f[g>>2]|0:lb&255)|0;lya(e)}kya(e+24|0);Gb=0}while(0);l=(Gb&1)!=0;u=d;return l|0}function mza(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=a+12|0;c=f[b>>2]|0;do if(!c){d=f[a+8>>2]|0;e=6}else{g=a+4|0;h=f[g>>2]|0;i=f[c>>2]|0;if((h|0)>=(i|0))if((i|0)==(f[a+8>>2]|0)){d=i;e=6;break}else{j=i;k=c;break}f[g>>2]=h+1;l=f[c+4+(h<<2)>>2]|0;return l|0}while(0);if((e|0)==6){cpb(a,d+1|0);d=f[b>>2]|0;j=f[d>>2]|0;k=d}f[k>>2]=j+1;j=f[a>>2]|0;if(!j){d=L5b(12)|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;m=d;n=k}else{k=znb(j,8992,12)|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;xnb(j,k,1480);m=k;n=f[b>>2]|0}b=a+4|0;a=f[b>>2]|0;f[b>>2]=a+1;f[n+4+(a<<2)>>2]=m;l=m;return l|0}function nza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=a+4|0;g=f[e>>2]|0;if((g|0)>=(b|0)){u=c;return}h=a+8|0;i=f[h>>2]|0;j=(i|0)==0;if(j)k=0;else k=f[i>>2]|0;l=g<<1;g=(l|0)<(b|0)?b:l;l=(g|0)>4?g:4;if(l>>>0>1073741822){zpb(d,3,468430,1285);xpb(c+24|0,vpb(vpb(d,468525)|0,468650)|0);Apb(d)}d=(l<<2)+4|0;if(!k)m=L5b(d)|0;else m=znb(k,25528,d)|0;f[h>>2]=m;f[m>>2]=k;f[e>>2]=l;e=m+4|0;if((l|0)>0){l=m+d|0;d=m+8|0;Nac(e|0,0,(l>>>0>d>>>0?l:d)+(-5-m)+4&-4|0)|0}m=f[a>>2]|0;if((m|0)>0)Vac(e|0,i+4|0,m<<2|0)|0;if(j){u=c;return}if(f[i>>2]|0){u=c;return}O5b(i);u=c;return}function oza(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;c=u;u=u+176|0;d=c;e=a+11|0;g=b[e>>0]|0;h=a+4|0;i=f[h>>2]|0;do if(((g<<24>>24<0?i:g&255)|0)==8)if(!(u6b(a,0,-1,378541,8)|0)){j=1;u=c;return j|0}else{k=b[e>>0]|0;l=f[h>>2]|0;break}else{k=g;l=i}while(0);do if(((k<<24>>24<0?l:k&255)|0)==4)if(!(u6b(a,0,-1,378550,4)|0)){j=2;u=c;return j|0}else{m=b[e>>0]|0;n=f[h>>2]|0;break}else{m=k;n=l}while(0);do if(((m<<24>>24<0?n:m&255)|0)==6)if(!(u6b(a,0,-1,378175,6)|0)){j=3;u=c;return j|0}else{o=b[e>>0]|0;p=f[h>>2]|0;break}else{o=m;p=n}while(0);do if(((o<<24>>24<0?p:o&255)|0)==4)if(!(u6b(a,0,-1,377119,4)|0)){j=4;u=c;return j|0}else{q=b[e>>0]|0;r=f[h>>2]|0;break}else{q=o;r=p}while(0);do if(((q<<24>>24<0?r:q&255)|0)==4)if(!(u6b(a,0,-1,377867,4)|0)){j=5;u=c;return j|0}else{s=b[e>>0]|0;t=f[h>>2]|0;break}else{s=q;t=r}while(0);do if(((s<<24>>24<0?t:s&255)|0)==7)if(!(u6b(a,0,-1,377647,7)|0)){j=6;u=c;return j|0}else{v=b[e>>0]|0;w=f[h>>2]|0;break}else{v=s;w=t}while(0);do if(((v<<24>>24<0?w:v&255)|0)==14)if(!(u6b(a,0,-1,378555,14)|0)){j=7;u=c;return j|0}else{x=b[e>>0]|0;y=f[h>>2]|0;break}else{x=v;y=w}while(0);do if(((x<<24>>24<0?y:x&255)|0)==7)if(!(u6b(a,0,-1,378570,7)|0)){j=8;u=c;return j|0}else{z=b[e>>0]|0;A=f[h>>2]|0;break}else{z=x;A=y}while(0);do if(((z<<24>>24<0?A:z&255)|0)==9)if(!(u6b(a,0,-1,377872,9)|0)){j=9;u=c;return j|0}else{B=b[e>>0]|0;C=f[h>>2]|0;break}else{B=z;C=A}while(0);do if(((B<<24>>24<0?C:B&255)|0)==11)if(!(u6b(a,0,-1,378477,11)|0)){j=10;u=c;return j|0}else{D=b[e>>0]|0;E=f[h>>2]|0;break}else{D=B;E=C}while(0);do if(((D<<24>>24<0?E:D&255)|0)==6)if(!(u6b(a,0,-1,378578,6)|0)){j=11;u=c;return j|0}else{F=b[e>>0]|0;G=f[h>>2]|0;break}else{F=D;G=E}while(0);do if(((F<<24>>24<0?G:F&255)|0)==6)if(!(u6b(a,0,-1,377882,6)|0)){j=12;u=c;return j|0}else{H=b[e>>0]|0;I=f[h>>2]|0;break}else{H=F;I=G}while(0);do if(((H<<24>>24<0?I:H&255)|0)==13)if(!(u6b(a,0,-1,377901,13)|0)){j=13;u=c;return j|0}else{J=b[e>>0]|0;K=f[h>>2]|0;break}else{J=H;K=I}while(0);do if(((J<<24>>24<0?K:J&255)|0)==12)if(!(u6b(a,0,-1,377124,12)|0)){j=14;u=c;return j|0}else{L=b[e>>0]|0;M=f[h>>2]|0;break}else{L=J;M=K}while(0);do if(((L<<24>>24<0?M:L&255)|0)==3)if(!(u6b(a,0,-1,377703,3)|0)){j=15;u=c;return j|0}else{N=b[e>>0]|0;O=f[h>>2]|0;break}else{N=L;O=M}while(0);do if(((N<<24>>24<0?O:N&255)|0)==25)if(!(u6b(a,0,-1,378585,25)|0)){j=16;u=c;return j|0}else{P=b[e>>0]|0;Q=f[h>>2]|0;break}else{P=N;Q=O}while(0);do if(((P<<24>>24<0?Q:P&255)|0)==4)if(!(u6b(a,0,-1,377418,4)|0)){j=17;u=c;return j|0}else{R=b[e>>0]|0;S=f[h>>2]|0;break}else{R=P;S=Q}while(0);do if(((R<<24>>24<0?S:R&255)|0)==4)if(!(u6b(a,0,-1,378611,4)|0)){j=18;u=c;return j|0}else{T=b[e>>0]|0;U=f[h>>2]|0;break}else{T=R;U=S}while(0);do if(((T<<24>>24<0?U:T&255)|0)==7)if(!(u6b(a,0,-1,378616,7)|0)){j=19;u=c;return j|0}else{V=b[e>>0]|0;W=f[h>>2]|0;break}else{V=T;W=U}while(0);do if(((V<<24>>24<0?W:V&255)|0)==7)if(!(u6b(a,0,-1,430334,7)|0)){j=20;u=c;return j|0}else{X=b[e>>0]|0;Y=f[h>>2]|0;break}else{X=V;Y=W}while(0);do if(((X<<24>>24<0?Y:X&255)|0)==12)if(!(u6b(a,0,-1,378624,12)|0)){j=21;u=c;return j|0}else{Z=b[e>>0]|0;_=f[h>>2]|0;break}else{Z=X;_=Y}while(0);do if(((Z<<24>>24<0?_:Z&255)|0)==5)if(!(u6b(a,0,-1,378637,5)|0)){j=22;u=c;return j|0}else{$=b[e>>0]|0;aa=f[h>>2]|0;break}else{$=Z;aa=_}while(0);do if((($<<24>>24<0?aa:$&255)|0)==4)if(!(u6b(a,0,-1,423942,4)|0)){j=23;u=c;return j|0}else{ba=b[e>>0]|0;ca=f[h>>2]|0;break}else{ba=$;ca=aa}while(0);do if(((ba<<24>>24<0?ca:ba&255)|0)==11){if(!(u6b(a,0,-1,377889,11)|0))j=24;else break;u=c;return j|0}while(0);jya(d,377137,378643,671,450217,0,1);ba=d+21|0;ca=d+32|0;while(1){if(!(b[ba>>0]|0))break;aa=rP(ca,378662,20)|0;$=b[e>>0]|0;_=$<<24>>24<0;rP(aa,_?f[a>>2]|0:a,_?f[h>>2]|0:$&255)|0;lya(d)}kya(d+24|0);j=0;u=c;return j|0}function pza(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=sza(b,c)|0;u=a;return d|0}function qza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=a+4|0;g=f[e>>2]|0;if((g|0)>=(b|0)){u=c;return}h=a+8|0;i=f[h>>2]|0;j=(i|0)==0;if(j)k=0;else k=f[i>>2]|0;l=g<<1;g=(l|0)<(b|0)?b:l;l=(g|0)>4?g:4;if(l>>>0>1073741822){zpb(d,3,468430,1285);xpb(c+24|0,vpb(vpb(d,468525)|0,468650)|0);Apb(d)}d=(l<<2)+4|0;if(!k)m=L5b(d)|0;else m=znb(k,25528,d)|0;f[h>>2]=m;f[m>>2]=k;f[e>>2]=l;e=m+4|0;if((l|0)>0){l=m+d|0;d=m+8|0;Nac(e|0,0,(l>>>0>d>>>0?l:d)+(-5-m)+4&-4|0)|0}m=f[a>>2]|0;if((m|0)>0)Vac(e|0,i+4|0,m<<2|0)|0;if(j){u=c;return}if(f[i>>2]|0){u=c;return}O5b(i);u=c;return}function rza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+32|0;d=c;e=a+4|0;g=f[e>>2]|0;if((g|0)>=(b|0)){u=c;return}h=a+8|0;i=f[h>>2]|0;j=(i|0)==0;if(j)k=0;else k=f[i>>2]|0;l=g<<1;g=(l|0)<(b|0)?b:l;l=(g|0)>4?g:4;if(l>>>0>1073741822){zpb(d,3,468430,1285);xpb(c+24|0,vpb(vpb(d,468525)|0,468650)|0);Apb(d)}d=(l<<2)+4|0;if(!k)m=L5b(d)|0;else m=znb(k,25528,d)|0;f[h>>2]=m;f[m>>2]=k;f[e>>2]=l;e=m+4|0;if((l|0)>0){l=m+d|0;d=m+8|0;Nac(e|0,0,(l>>>0>d>>>0?l:d)+(-5-m)+4&-4|0)|0}m=f[a>>2]|0;if((m|0)>0)Vac(e|0,i+4|0,m<<2|0)|0;if(j){u=c;return}if(f[i>>2]|0){u=c;return}O5b(i);u=c;return}function sza(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(108)|0;M8a(b);c=b;return c|0}else{b=znb(a,19880,108)|0;M8a(b);xnb(a,b,1484);c=b;return c|0}return 0}function tza(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function uza(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(296)|0;CQa(b);c=b;return c|0}else{b=znb(a,18872,296)|0;CQa(b);xnb(a,b,1485);c=b;return c|0}return 0}function vza(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function wza(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+16|0;d=c;e=zza(a,d,b)|0;g=f[e>>2]|0;if(g|0){h=g;i=h+28|0;u=c;return i|0}g=L5b(32)|0;X5b(g+16|0,b);f[g+28>>2]=0;b=f[d>>2]|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=b;f[e>>2]=g;b=f[f[a>>2]>>2]|0;if(!b)j=g;else{f[a>>2]=b;j=f[e>>2]|0}mP(f[a+4>>2]|0,j);j=a+8|0;f[j>>2]=(f[j>>2]|0)+1;h=g;i=h+28|0;u=c;return i|0}function xza(a,c){a=a|0;c=c|0;if(!c)return;xza(a,f[c>>2]|0);xza(a,f[c+4>>2]|0);a=c+16|0;if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(c);return}function yza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=a+4|0;a=f[d>>2]|0;do if(a|0){e=b[c+11>>0]|0;g=e<<24>>24<0;h=g?f[c+4>>2]|0:e&255;e=g?f[c>>2]|0:c;g=d;i=a;a:while(1){j=i;while(1){k=j+16|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[j+20>>2]|0:l&255;l=h>>>0<n>>>0?h:n;if((l|0)!=0?(o=ZVb(m?f[k>>2]|0:k,e,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=6;if((p|0)==6?(p=0,n>>>0>=h>>>0):0)break;n=f[j+4>>2]|0;if(!n){q=g;break a}else j=n}i=f[j>>2]|0;if(!i){q=j;break}else g=j}if((q|0)!=(d|0)){g=q+16|0;i=b[g+11>>0]|0;n=i<<24>>24<0;o=n?f[q+20>>2]|0:i&255;i=o>>>0<h>>>0?o:h;if(i|0?(l=ZVb(e,n?f[g>>2]|0:g,i)|0,l|0):0){if((l|0)<0)break;else r=q;return r|0}if(h>>>0>=o>>>0){r=q;return r|0}}}while(0);r=d;return r|0}function zza(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=a+4|0;g=f[e>>2]|0;if(!g){f[c>>2]=e;h=e;return h|0}e=b[d+11>>0]|0;i=e<<24>>24<0;j=i?f[d+4>>2]|0:e&255;e=i?f[d>>2]|0:d;d=a+4|0;a=g;while(1){g=a+16|0;i=b[g+11>>0]|0;k=i<<24>>24<0;l=k?f[a+20>>2]|0:i&255;i=l>>>0<j>>>0;m=i?l:j;if((m|0)!=0?(n=ZVb(e,k?f[g>>2]|0:g,m)|0,(n|0)!=0):0)if((n|0)<0)o=8;else o=10;else if(j>>>0<l>>>0)o=8;else o=10;if((o|0)==8){o=0;n=f[a>>2]|0;if(!n){o=9;break}else{p=a;q=n}}else if((o|0)==10){o=0;n=j>>>0<l>>>0?j:l;if((n|0)!=0?(l=ZVb(k?f[g>>2]|0:g,e,n)|0,(l|0)!=0):0){if((l|0)>=0){o=16;break}}else o=12;if((o|0)==12?(o=0,!i):0){o=16;break}r=a+4|0;i=f[r>>2]|0;if(!i){o=15;break}else{p=r;q=i}}d=p;a=q}if((o|0)==9){f[c>>2]=a;h=a;return h|0}else if((o|0)==15){f[c>>2]=a;h=r;return h|0}else if((o|0)==16){f[c>>2]=a;h=d;return h|0}return 0}function Aza(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;b=u;u=u+64|0;c=b;d=a+80|0;if((f[d>>2]|0)<=0){e=0;u=b;return e|0}g=a+88|0;a=c+8|0;h=c+8|0;i=c+8|0;j=0;while(1){k=f[(f[g>>2]|0)+4+(j<<2)>>2]|0;l=f[k+288>>2]|0;if((l|0)==5){m=f[k+184>>2]|0;a9a(c,(m|0)==0?495040:m);m=f[a>>2]|0;if(!(m&48))n=m&64|0?1:m>>>7&1;else n=1;e0a(c);if(n|0){e=1;o=18;break}m=f[(f[g>>2]|0)+4+(j<<2)>>2]|0;p=f[m+288>>2]|0;q=m}else{p=l;q=k}if((p|0)==12){k=f[q+216>>2]|0;j9a(c,(k|0)==0?495632:k);k=f[h>>2]|0;if(!(k&384))r=k&512|0?1:k>>>10&1;else r=1;cYa(c);if(r|0){e=1;o=18;break}k=f[(f[g>>2]|0)+4+(j<<2)>>2]|0;s=f[k+288>>2]|0;t=k}else{s=p;t=q}if((s|0)==24){k=f[t+272>>2]|0;y9a(c,(k|0)==0?496584:k);k=f[i>>2]|0;if(!(k&6))v=k&16|0?1:k>>>5&1;else v=1;XQa(c);if(v|0){e=1;o=18;break}}j=j+1|0;if((j|0)>=(f[d>>2]|0)){e=0;o=18;break}}if((o|0)==18){u=b;return e|0}return 0}function Bza(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;c=a+80|0;if((f[c>>2]|0)<=0)return;d=a+88|0;a=0;do{e=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;if((f[e+288>>2]|0)==5){g=e+8|0;f[g>>2]=f[g>>2]|131072;g=e+184|0;h=f[g>>2]|0;if(!h){i=L5b(52)|0;KOa(i);f[g>>2]=i;j=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;k=i}else{j=e;k=h}h=j+12|0;f[h>>2]=f[h>>2]|256;h=j+276|0;e=f[h>>2]|0;if(!e){i=L5b(44)|0;pPa(i);f[h>>2]=i;l=i}else l=e;e=k+8|0;i=f[e>>2]|0;if(!(i&16))m=i;else{i=k+44|0;h=f[i>>2]|0;g=l+8|0;f[g>>2]=f[g>>2]|1;f[l+40>>2]=h;n[i>>2]=1.0;i=f[e>>2]&-17;f[e>>2]=i;m=i}if(!(m&32))o=m;else{i=k+20|0;h=f[i>>2]|0;g=l+8|0;f[g>>2]=f[g>>2]|8;g=l+28|0;p=f[g>>2]|0;if((p|0)==497760)jza(g,h);else _5b(p,h)|0;h=f[i>>2]|0;do if((h|0)!=497760){i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[i>>0]=0;break}}while(0);h=f[e>>2]&-33;f[e>>2]=h;o=h}if(!(o&64))q=o;else{h=k+36|0;i=f[h>>2]|0;p=l+8|0;f[p>>2]=f[p>>2]|4;f[l+32>>2]=i;f[h>>2]=0;h=f[e>>2]&-65;f[e>>2]=h;q=h}if(q&128|0){h=k+40|0;i=b[h>>0]|0;p=l+8|0;f[p>>2]=f[p>>2]|2;b[l+36>>0]=i;b[h>>0]=0;f[e>>2]=f[e>>2]&-129}}h=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;if((f[h+288>>2]|0)==12){i=h+8|0;f[i>>2]=f[i>>2]|33554432;i=h+216|0;p=f[i>>2]|0;if(!p){g=L5b(60)|0;VOa(g);f[i>>2]=g;r=g;s=f[(f[d>>2]|0)+4+(a<<2)>>2]|0}else{r=p;s=h}h=s+12|0;f[h>>2]=f[h>>2]|256;h=s+276|0;p=f[h>>2]|0;if(!p){g=L5b(44)|0;pPa(g);f[h>>2]=g;t=g}else t=p;p=r+8|0;g=f[p>>2]|0;if(!(g&128))u=g;else{g=r+48|0;h=f[g>>2]|0;i=t+8|0;f[i>>2]=f[i>>2]|1;f[t+40>>2]=h;n[g>>2]=1.0;g=f[p>>2]&-129;f[p>>2]=g;u=g}if(!(u&256))v=u;else{g=r+20|0;h=f[g>>2]|0;i=t+8|0;f[i>>2]=f[i>>2]|8;i=t+28|0;w=f[i>>2]|0;if((w|0)==497760)jza(i,h);else _5b(w,h)|0;h=f[g>>2]|0;do if((h|0)!=497760){g=h+11|0;if((b[g>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0;break}else{b[h>>0]=0;b[g>>0]=0;break}}while(0);h=f[p>>2]&-257;f[p>>2]=h;v=h}if(!(v&512))x=v;else{h=r+44|0;e=f[h>>2]|0;g=t+8|0;f[g>>2]=f[g>>2]|4;f[t+32>>2]=e;f[h>>2]=0;h=f[p>>2]&-513;f[p>>2]=h;x=h}if(x&1024|0){h=r+41|0;e=b[h>>0]|0;g=t+8|0;f[g>>2]=f[g>>2]|2;b[t+36>>0]=e;b[h>>0]=0;f[p>>2]=f[p>>2]&-1025}}h=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;if((f[h+288>>2]|0)==24){e=h+12|0;g=f[e>>2]|128;f[e>>2]=g;e=h+272|0;w=f[e>>2]|0;if(!w){i=L5b(64)|0;nPa(i);f[e>>2]=i;e=f[(f[d>>2]|0)+4+(a<<2)>>2]|0;y=e;z=f[e+12>>2]|0;A=i}else{y=h;z=g;A=w}f[y+12>>2]=z|256;w=y+276|0;g=f[w>>2]|0;if(!g){h=L5b(44)|0;pPa(h);f[w>>2]=h;B=h}else B=g;g=A+8|0;h=f[g>>2]|0;if(!(h&2))C=h;else{h=A+48|0;w=f[h>>2]|0;i=B+8|0;f[i>>2]=f[i>>2]|1;f[B+40>>2]=w;n[h>>2]=1.0;h=f[g>>2]&-3;f[g>>2]=h;C=h}if(!(C&4))D=C;else{h=A+20|0;w=f[h>>2]|0;i=B+8|0;f[i>>2]=f[i>>2]|8;i=B+28|0;e=f[i>>2]|0;if((e|0)==497760)jza(i,w);else _5b(e,w)|0;w=f[h>>2]|0;do if((w|0)!=497760){h=w+11|0;if((b[h>>0]|0)<0){b[f[w>>2]>>0]=0;f[w+4>>2]=0;break}else{b[w>>0]=0;b[h>>0]=0;break}}while(0);w=f[g>>2]&-5;f[g>>2]=w;D=w}if(!(D&16))E=D;else{w=A+36|0;p=f[w>>2]|0;h=B+8|0;f[h>>2]=f[h>>2]|4;f[B+32>>2]=p;f[w>>2]=0;w=f[g>>2]&-17;f[g>>2]=w;E=w}if(E&32|0){w=A+40|0;p=b[w>>0]|0;h=B+8|0;f[h>>2]=f[h>>2]|2;b[B+36>>0]=p;b[w>>0]=0;f[g>>2]=f[g>>2]&-33}}a=a+1|0}while((a|0)<(f[c>>2]|0));return}function Cza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+336|0;e=d+168|0;g=d;h=c+80|0;i=f[h>>2]|0;a:do if((i|0)>0){j=f[c+88>>2]|0;k=0;while(1){if(f[(f[j+4+(k<<2)>>2]|0)+12>>2]&1024|0)break;k=k+1|0;if((k|0)>=(i|0)){l=1;break a}}jya(e,377137,379096,742,450605,0,1);k=e+21|0;j=e+32|0;m=a+11|0;n=a+4|0;while(1){if(!(b[k>>0]|0))break;o=rP(rP(j,379115,60)|0,379176,18)|0;p=b[m>>0]|0;q=p<<24>>24<0;rP(o,q?f[a>>2]|0:a,q?f[n>>2]|0:p&255)|0;lya(e)}kya(e+24|0);S8a(e,c);if(hza(e,c)|0){jya(g,377137,379096,750,450204,0,1);n=g+21|0;m=g+32|0;while(1){if(!(b[n>>0]|0))break;rP(rP(m,379303,54)|0,379358,16)|0;lya(g)}kya(g+24|0);r=1}else{jya(g,377137,379096,747,450605,0,1);m=g+21|0;n=g+32|0;while(1){if(!(b[m>>0]|0))break;rP(rP(n,379195,44)|0,379240,62)|0;lya(g)}kya(g+24|0);r=0}jya(g,377137,379096,753,450605,0,1);n=g+21|0;m=g+32|0;while(1){if(!(b[n>>0]|0))break;rP(rP(rP(rP(m,379375,49)|0,379425,61)|0,379487,62)|0,379550,64)|0;lya(g)}kya(g+24|0);g6a(e);l=r}else l=1;while(0);if(Aza(c)|0){jya(e,377137,379096,760,450605,0,1);r=e+21|0;i=e+32|0;m=a+11|0;n=a+4|0;while(1){if(!(b[r>>0]|0))break;j=rP(rP(i,379115,60)|0,379615,27)|0;k=b[m>>0]|0;p=k<<24>>24<0;rP(j,p?f[a>>2]|0:a,p?f[n>>2]|0:k&255)|0;lya(e)}kya(e+24|0);Bza(c);jya(e,377137,379096,763,450204,0,1);n=e+21|0;m=e+32|0;while(1){if(!(b[n>>0]|0))break;rP(rP(m,379303,54)|0,379643,31)|0;lya(e)}kya(e+24|0);jya(e,377137,379096,765,450605,0,1);m=e+21|0;n=e+32|0;while(1){if(!(b[m>>0]|0))break;rP(rP(n,379675,50)|0,379726,51)|0;lya(e)}kya(e+24|0)}if((f[h>>2]|0)>0){jya(e,377137,379096,769,450605,0,1);h=e+21|0;n=e+32|0;m=a+11|0;i=a+4|0;while(1){if(!(b[h>>0]|0))break;r=rP(rP(n,379115,60)|0,379778,18)|0;k=b[m>>0]|0;p=k<<24>>24<0;rP(r,p?f[a>>2]|0:a,p?f[i>>2]|0:k&255)|0;lya(e)}kya(e+24|0);S8a(e,c);if(Dza(e,c)|0){jya(g,377137,379096,777,450204,0,1);i=g+21|0;m=g+32|0;while(1){if(!(b[i>>0]|0))break;rP(rP(m,379303,54)|0,379846,16)|0;lya(g)}kya(g+24|0);s=l}else{jya(g,377137,379096,774,450605,0,1);m=g+21|0;i=g+32|0;while(1){if(!(b[m>>0]|0))break;rP(rP(i,379195,44)|0,379797,48)|0;lya(g)}kya(g+24|0);s=0}g6a(e);t=s}else t=l;l=c+64|0;if((f[l>>2]|0)<=0){u=d;return t|0}s=c+72|0;g=0;while(1){i=f[(f[(f[s>>2]|0)+4+(g<<2)>>2]|0)+148>>2]|0;m=b[i+11>>0]|0;if((((m<<24>>24<0?f[i+4>>2]|0:m&255)|0)==9?(u6b(i,0,-1,411943,9)|0)==0:0)?(f[(f[(f[s>>2]|0)+4+(g<<2)>>2]|0)+72>>2]|0)==3:0)break;g=g+1|0;if((g|0)>=(f[l>>2]|0)){v=59;break}}if((v|0)==59){u=d;return t|0}jya(e,377137,379096,783,450204,0,1);v=e+21|0;l=e+32|0;g=a+11|0;s=a+4|0;while(1){if(!(b[v>>0]|0))break;i=rP(rP(l,379863,57)|0,379921,8)|0;m=b[g>>0]|0;n=m<<24>>24<0;rP(i,n?f[a>>2]|0:a,n?f[s>>2]|0:m&255)|0;lya(e)}kya(e+24|0);Eza(c);jya(e,377137,379096,786,450204,0,1);c=e+21|0;s=e+32|0;while(1){if(!(b[c>>0]|0))break;rP(rP(s,379930,57)|0,379988,7)|0;lya(e)}kya(e+24|0);u=d;return t|0}function Dza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0;d=u;u=u+176|0;e=d;if((f[a+64>>2]|0)>0){jya(e,377137,379996,795,450605,0,1);g=e+21|0;h=e+32|0;while(1){if(!(b[g>>0]|0))break;rP(rP(h,380009,60)|0,380070,46)|0;lya(e)}kya(e+24|0);i=0}else i=1;T8a(c,a);h=c+80|0;g=f[h>>2]|0;if((g|0)>0){j=f[c+88>>2]|0;k=0;do{l=f[j+4+(k<<2)>>2]|0;k=k+1|0;bi[f[(f[l>>2]|0)+28>>2]&2047](l)}while((k|0)!=(g|0));f[h>>2]=0}h=c+64|0;g=f[h>>2]|0;if((g|0)>0){k=f[c+72>>2]|0;j=0;do{l=f[k+4+(j<<2)>>2]|0;j=j+1|0;bi[f[(f[l>>2]|0)+28>>2]&2047](l)}while((j|0)!=(g|0));f[h>>2]=0}g=a+80|0;if((f[g>>2]|0)<=0){m=i;u=d;return m|0}j=a+88|0;a=c+60|0;k=c+72|0;l=c+68|0;c=e+21|0;n=e+32|0;o=e+24|0;p=0;q=i;while(1){i=f[(f[j>>2]|0)+4+(p<<2)>>2]|0;r=f[k>>2]|0;do if(r){s=f[h>>2]|0;t=f[r>>2]|0;if((s|0)>=(t|0))if((t|0)==(f[l>>2]|0)){v=t;w=22;break}else{x=t;y=r;w=23;break}else{f[h>>2]=s+1;z=f[r+4+(s<<2)>>2]|0;break}}else{v=f[l>>2]|0;w=22}while(0);if((w|0)==22){w=0;cpb(a,v+1|0);r=f[k>>2]|0;x=f[r>>2]|0;y=r;w=23}if((w|0)==23){w=0;f[y>>2]=x+1;r=Fza(0,f[a>>2]|0)|0;s=f[k>>2]|0;t=f[h>>2]|0;f[h>>2]=t+1;f[s+4+(t<<2)>>2]=r;z=r}if(Gza(i,z)|0)A=q;else{jya(e,377137,379996,805,450605,0,1);while(1){if(!(b[c>>0]|0))break;rP(iYb(rP(n,380117,23)|0,p)|0,380141,8)|0;lya(e)}kya(o);A=0}p=p+1|0;if((p|0)>=(f[g>>2]|0)){m=A;break}else q=A}u=d;return m|0}function Eza(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=a+64|0;if((f[c>>2]|0)<=0)return;d=a+72|0;a=0;do{e=f[(f[(f[d>>2]|0)+4+(a<<2)>>2]|0)+148>>2]|0;g=b[e+11>>0]|0;if((((g<<24>>24<0?f[e+4>>2]|0:g&255)|0)==9?(u6b(e,0,-1,411943,9)|0)==0:0)?(e=f[(f[d>>2]|0)+4+(a<<2)>>2]|0,g=e+72|0,(f[g>>2]|0)==3):0){h=f[e+80>>2]|0;e=f[h+4>>2]|0;bi[f[(f[e>>2]|0)+28>>2]&2047](e);e=f[h+8>>2]|0;bi[f[(f[e>>2]|0)+28>>2]&2047](e);e=f[h+12>>2]|0;bi[f[(f[e>>2]|0)+28>>2]&2047](e);f[g>>2]=0}a=a+1|0}while((a|0)<(f[c>>2]|0));return}function Fza(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=Pza(b,c)|0;u=a;return d|0}function Gza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0;d=u;u=u+176|0;e=d;bi[f[(f[c>>2]|0)+28>>2]&2047](c);g=a+20|0;if((f[g>>2]|0)>0){h=a+28|0;i=c+24|0;j=0;do{k=f[(f[h>>2]|0)+4+(j<<2)>>2]|0;_5b(mza(i)|0,k)|0;j=j+1|0}while((j|0)<(f[g>>2]|0))}g=a+36|0;if((f[g>>2]|0)>0){j=a+44|0;i=c+40|0;h=0;do{k=f[(f[j>>2]|0)+4+(h<<2)>>2]|0;_5b(mza(i)|0,k)|0;h=h+1|0}while((h|0)<(f[g>>2]|0))}g=a+8|0;do if(f[g>>2]&4|0){h=f[a+160>>2]|0;i=c+8|0;f[i>>2]=f[i>>2]|1;i=c+144|0;j=f[i>>2]|0;if((j|0)==497760){jza(i,h);break}else{_5b(j,h)|0;break}}while(0);h=a+52|0;if((f[h>>2]|0)>0){j=c+112|0;i=c+124|0;k=c+120|0;l=c+116|0;m=a+60|0;n=0;do{o=f[i>>2]|0;do if(o){p=f[l>>2]|0;q=f[o>>2]|0;if((p|0)>=(q|0))if((q|0)==(f[k>>2]|0)){r=q;s=20;break}else{t=q;v=o;s=21;break}else{f[l>>2]=p+1;w=f[o+4+(p<<2)>>2]|0;break}}else{r=f[k>>2]|0;s=20}while(0);if((s|0)==20){s=0;cpb(j,r+1|0);o=f[i>>2]|0;t=f[o>>2]|0;v=o;s=21}if((s|0)==21){s=0;f[v>>2]=t+1;o=Hza(0,f[j>>2]|0)|0;p=f[i>>2]|0;q=f[l>>2]|0;f[l>>2]=q+1;f[p+4+(q<<2)>>2]=o;w=o}U8a(w,f[(f[m>>2]|0)+4+(n<<2)>>2]|0);n=n+1|0}while((n|0)<(f[h>>2]|0))}h=a+68|0;if((f[h>>2]|0)>0){n=c+128|0;m=c+140|0;w=c+136|0;l=c+132|0;i=a+76|0;j=0;do{t=f[m>>2]|0;do if(t){v=f[l>>2]|0;r=f[t>>2]|0;if((v|0)>=(r|0))if((r|0)==(f[w>>2]|0)){x=r;s=29;break}else{y=r;z=t;s=30;break}else{f[l>>2]=v+1;A=f[t+4+(v<<2)>>2]|0;break}}else{x=f[w>>2]|0;s=29}while(0);if((s|0)==29){s=0;cpb(n,x+1|0);t=f[m>>2]|0;y=f[t>>2]|0;z=t;s=30}if((s|0)==30){s=0;f[z>>2]=y+1;t=Hza(0,f[n>>2]|0)|0;v=f[m>>2]|0;r=f[l>>2]|0;f[l>>2]=r+1;f[v+4+(r<<2)>>2]=t;A=t}U8a(A,f[(f[i>>2]|0)+4+(j<<2)>>2]|0);j=j+1|0}while((j|0)<(f[h>>2]|0))}if(f[g>>2]&32|0)Jza(c,Iza(f[a+288>>2]|0)|0);h=a+84|0;if((f[h>>2]|0)>0){j=c+84|0;i=c+96|0;A=c+92|0;l=c+88|0;m=a+92|0;n=0;do{y=f[i>>2]|0;do if(y){z=f[l>>2]|0;x=f[y>>2]|0;if((z|0)>=(x|0))if((x|0)==(f[A>>2]|0)){B=x;s=42;break}else{C=x;D=y;s=43;break}else{f[l>>2]=z+1;E=f[y+4+(z<<2)>>2]|0;break}}else{B=f[A>>2]|0;s=42}while(0);if((s|0)==42){s=0;cpb(j,B+1|0);y=f[i>>2]|0;C=f[y>>2]|0;D=y;s=43}if((s|0)==43){s=0;f[D>>2]=C+1;y=pza(0,f[j>>2]|0)|0;z=f[i>>2]|0;x=f[l>>2]|0;f[l>>2]=x+1;f[z+4+(x<<2)>>2]=y;E=y}Q8a(E,f[(f[m>>2]|0)+4+(n<<2)>>2]|0);n=n+1|0}while((n|0)<(f[h>>2]|0))}h=a+100|0;if((f[h>>2]|0)>0){n=c+72|0;m=c+80|0;E=a+108|0;l=c+68|0;i=c+76|0;j=0;do{C=f[n>>2]|0;if((C|0)<=(j|0)){D=C;while(1){C=f[m>>2]|0;do if(C){B=f[C>>2]|0;if((D|0)>=(B|0))if((B|0)==(f[i>>2]|0)){F=B;s=54;break}else{G=B;H=C;s=55;break}else{B=D+1|0;f[n>>2]=B;I=B;break}}else{F=f[i>>2]|0;s=54}while(0);if((s|0)==54){s=0;cpb(l,F+1|0);C=f[m>>2]|0;G=f[C>>2]|0;H=C;s=55}if((s|0)==55){s=0;f[H>>2]=G+1;C=Kza(0,f[l>>2]|0)|0;B=f[m>>2]|0;A=f[n>>2]|0;y=A+1|0;f[n>>2]=y;f[B+4+(A<<2)>>2]=C;I=y}if((I|0)>(j|0))break;else D=I}}D=f[(f[m>>2]|0)+4+(j<<2)>>2]|0;y=f[(f[E>>2]|0)+4+(j<<2)>>2]|0;C=D+8|0;f[C>>2]=f[C>>2]|1;C=D+16|0;D=f[C>>2]|0;if((D|0)==497760)jza(C,y);else _5b(D,y)|0;j=j+1|0}while((j|0)<(f[h>>2]|0))}h=a+112|0;if((f[h>>2]|0)>0){j=c+72|0;E=a+120|0;m=c+80|0;I=e+21|0;n=e+32|0;l=e+24|0;G=c+68|0;H=c+76|0;F=0;i=0;while(1){y=f[j>>2]|0;if((y|0)<=(F|0)){D=y;while(1){y=f[m>>2]|0;do if(y){C=f[y>>2]|0;if((D|0)>=(C|0))if((C|0)==(f[H>>2]|0)){J=C;s=69;break}else{K=C;L=y;s=70;break}else{C=D+1|0;f[j>>2]=C;M=C;break}}else{J=f[H>>2]|0;s=69}while(0);if((s|0)==69){s=0;cpb(G,J+1|0);y=f[m>>2]|0;K=f[y>>2]|0;L=y;s=70}if((s|0)==70){s=0;f[L>>2]=K+1;y=Kza(0,f[G>>2]|0)|0;C=f[m>>2]|0;A=f[j>>2]|0;B=A+1|0;f[j>>2]=B;f[C+4+(A<<2)>>2]=y;M=B}if((M|0)>(F|0))break;else D=M}}D=f[(f[E>>2]|0)+4+(F<<2)>>2]|0;if(D>>>0<2)N=D;else{jya(e,377137,380150,875,450217,0,1);while(1){if(!(b[I>>0]|0))break;D=rP(n,380174,25)|0;iYb(D,f[(f[E>>2]|0)+4+(F<<2)>>2]|0)|0;lya(e)}kya(l);N=i}D=f[(f[m>>2]|0)+4+(F<<2)>>2]|0;B=D+8|0;f[B>>2]=f[B>>2]|2;f[D+20>>2]=N;F=F+1|0;if((F|0)>=(f[h>>2]|0))break;else i=N}}N=a+124|0;if((f[N>>2]|0)>0){i=c+72|0;h=c+80|0;F=a+132|0;m=c+68|0;l=c+76|0;E=0;do{n=f[i>>2]|0;if((n|0)<=(E|0)){I=n;while(1){n=f[h>>2]|0;do if(n){M=f[n>>2]|0;if((I|0)>=(M|0))if((M|0)==(f[l>>2]|0)){O=M;s=86;break}else{P=M;Q=n;s=87;break}else{M=I+1|0;f[i>>2]=M;R=M;break}}else{O=f[l>>2]|0;s=86}while(0);if((s|0)==86){s=0;cpb(m,O+1|0);n=f[h>>2]|0;P=f[n>>2]|0;Q=n;s=87}if((s|0)==87){s=0;f[Q>>2]=P+1;n=Kza(0,f[m>>2]|0)|0;M=f[h>>2]|0;j=f[i>>2]|0;G=j+1|0;f[i>>2]=G;f[M+4+(j<<2)>>2]=n;R=G}if((R|0)>(E|0))break;else I=R}}I=f[(f[h>>2]|0)+4+(E<<2)>>2]|0;G=f[(f[F>>2]|0)+4+(E<<2)>>2]|0;n=I+8|0;f[n>>2]=f[n>>2]|4;f[I+24>>2]=G;E=E+1|0}while((E|0)<(f[N>>2]|0))}N=a+136|0;if((f[N>>2]|0)>0){E=c+72|0;F=c+80|0;h=a+144|0;R=c+68|0;i=c+76|0;m=0;do{P=f[E>>2]|0;if((P|0)<=(m|0)){Q=P;while(1){P=f[F>>2]|0;do if(P){O=f[P>>2]|0;if((Q|0)>=(O|0))if((O|0)==(f[i>>2]|0)){S=O;s=98;break}else{T=O;U=P;s=99;break}else{O=Q+1|0;f[E>>2]=O;V=O;break}}else{S=f[i>>2]|0;s=98}while(0);if((s|0)==98){s=0;cpb(R,S+1|0);P=f[F>>2]|0;T=f[P>>2]|0;U=P;s=99}if((s|0)==99){s=0;f[U>>2]=T+1;P=Kza(0,f[R>>2]|0)|0;O=f[F>>2]|0;l=f[E>>2]|0;G=l+1|0;f[E>>2]=G;f[O+4+(l<<2)>>2]=P;V=G}if((V|0)>(m|0))break;else Q=V}}Q=f[(f[F>>2]|0)+4+(m<<2)>>2]|0;G=f[(f[h>>2]|0)+4+(m<<2)>>2]|0;P=Q+8|0;f[P>>2]=f[P>>2]|8;f[Q+28>>2]=G;m=m+1|0}while((m|0)<(f[N>>2]|0))}N=a+148|0;if((f[N>>2]|0)>0){m=a+156|0;h=c+56|0;F=c+60|0;V=c+64|0;E=0;R=f[h>>2]|0;do{T=f[(f[m>>2]|0)+4+(E<<2)>>2]|0;if((R|0)==(f[F>>2]|0)){qza(h,R+1|0);W=f[h>>2]|0}else W=R;U=f[V>>2]|0;R=W+1|0;f[h>>2]=R;f[U+4+(W<<2)>>2]=T;E=E+1|0}while((E|0)<(f[N>>2]|0))}N=f[g>>2]|0;if(!(N&4096))X=N;else{N=c+8|0;f[N>>2]=f[N>>2]|8192;N=c+160|0;E=f[N>>2]|0;if(!E){W=L5b(28)|0;EOa(W);f[N>>2]=W;Y=W}else Y=E;E=f[a+164>>2]|0;X8a(Y,(E|0)==0?494648:E);X=f[g>>2]|0}if(!(X&8192))Z=X;else{X=c+8|0;f[X>>2]=f[X>>2]|16384;X=c+164|0;E=f[X>>2]|0;if(!E){Y=L5b(28)|0;FOa(Y);f[X>>2]=Y;_=Y}else _=E;E=f[a+168>>2]|0;Y8a(_,(E|0)==0?494688:E);Z=f[g>>2]|0}if(!(Z&16384))$=Z;else{Z=c+8|0;f[Z>>2]=f[Z>>2]|131072;Z=c+176|0;E=f[Z>>2]|0;if(!E){_=L5b(24)|0;GOa(_);f[Z>>2]=_;aa=_}else aa=E;E=f[a+172>>2]|0;Z8a(aa,(E|0)==0?494728:E);$=f[g>>2]|0}if(!($&32768))ba=$;else{$=c+8|0;f[$>>2]=f[$>>2]|262144;$=c+180|0;E=f[$>>2]|0;if(!E){aa=L5b(24)|0;HOa(aa);f[$>>2]=aa;ca=aa}else ca=E;E=f[a+176>>2]|0;_8a(ca,(E|0)==0?494840:E);ba=f[g>>2]|0}if(!(ba&65536))da=ba;else{ba=c+8|0;f[ba>>2]=f[ba>>2]|524288;ba=c+184|0;E=f[ba>>2]|0;if(!E){ca=L5b(120)|0;IOa(ca);f[ba>>2]=ca;ea=ca}else ea=E;E=f[a+180>>2]|0;$8a(ea,(E|0)==0?494872:E);da=f[g>>2]|0}if(!(da&131072))fa=da;else{da=c+8|0;f[da>>2]=f[da>>2]|2097152;da=c+192|0;E=f[da>>2]|0;if(!E){ea=L5b(52)|0;KOa(ea);f[da>>2]=ea;ga=ea}else ga=E;E=f[a+184>>2]|0;b9a(ga,(E|0)==0?495040:E);fa=f[g>>2]|0}if(!(fa&262144))ha=fa;else{fa=c+8|0;f[fa>>2]=f[fa>>2]|8388608;fa=c+200|0;E=f[fa>>2]|0;if(!E){ga=L5b(24)|0;MOa(ga);f[fa>>2]=ga;ia=ga}else ia=E;E=f[a+188>>2]|0;c9a(ia,(E|0)==0?495192:E);ha=f[g>>2]|0}if(!(ha&524288))ja=ha;else{ha=c+8|0;f[ha>>2]=f[ha>>2]|16777216;ha=c+204|0;E=f[ha>>2]|0;if(!E){ia=L5b(96)|0;NOa(ia);f[ha>>2]=ia;ka=ia}else ka=E;E=f[a+192>>2]|0;d9a(ka,(E|0)==0?495224:E);ja=f[g>>2]|0}if(!(ja&1048576))la=ja;else{ja=c+8|0;f[ja>>2]=f[ja>>2]|33554432;ja=c+208|0;E=f[ja>>2]|0;if(!E){ka=L5b(36)|0;POa(ka);f[ja>>2]=ka;ma=ka}else ma=E;E=f[a+196>>2]|0;e9a(ma,(E|0)==0?495328:E);la=f[g>>2]|0}if(!(la&2097152))na=la;else{la=c+8|0;f[la>>2]=f[la>>2]|268435456;la=c+220|0;E=f[la>>2]|0;if(!E){ma=L5b(28)|0;ROa(ma);f[la>>2]=ma;oa=ma}else oa=E;E=f[a+200>>2]|0;f9a(oa,(E|0)==0?495456:E);na=f[g>>2]|0}if(!(na&4194304))pa=na;else{na=c+8|0;f[na>>2]=f[na>>2]|1073741824;na=c+228|0;E=f[na>>2]|0;if(!E){oa=L5b(28)|0;SOa(oa);f[na>>2]=oa;qa=oa}else qa=E;E=f[a+204>>2]|0;g9a(qa,(E|0)==0?495528:E);pa=f[g>>2]|0}if(!(pa&8388608))ra=pa;else{pa=c+8|0;f[pa>>2]=f[pa>>2]|-2147483648;pa=c+232|0;E=f[pa>>2]|0;if(!E){qa=L5b(20)|0;cOa(qa);f[pa>>2]=qa;sa=qa}else sa=E;E=f[a+208>>2]|0;h9a(sa,(E|0)==0?495568:E);ra=f[g>>2]|0}if(!(ra&16777216))ta=ra;else{ra=c+12|0;f[ra>>2]=f[ra>>2]|1;ra=c+236|0;E=f[ra>>2]|0;if(!E){sa=L5b(20)|0;UOa(sa);f[ra>>2]=sa;ua=sa}else ua=E;E=f[a+212>>2]|0;i9a(ua,(E|0)==0?495600:E);ta=f[g>>2]|0}if(!(ta&33554432))va=ta;else{ta=c+12|0;f[ta>>2]=f[ta>>2]|2;ta=c+240|0;E=f[ta>>2]|0;if(!E){ua=L5b(60)|0;VOa(ua);f[ta>>2]=ua;wa=ua}else wa=E;E=f[a+216>>2]|0;k9a(wa,(E|0)==0?495632:E);va=f[g>>2]|0}if(!(va&67108864))xa=va;else{va=c+12|0;f[va>>2]=f[va>>2]|4;va=c+244|0;E=f[va>>2]|0;if(!E){wa=L5b(20)|0;XOa(wa);f[va>>2]=wa;ya=wa}else ya=E;E=f[a+220>>2]|0;l9a(ya,(E|0)==0?495704:E);xa=f[g>>2]|0}if(!(xa&134217728))za=xa;else{xa=c+12|0;f[xa>>2]=f[xa>>2]|8;xa=c+248|0;E=f[xa>>2]|0;if(!E){ya=L5b(36)|0;YOa(ya);f[xa>>2]=ya;Aa=ya}else Aa=E;E=f[a+224>>2]|0;m9a(Aa,(E|0)==0?495736:E);za=f[g>>2]|0}if(!(za&268435456))Ba=za;else{za=c+12|0;f[za>>2]=f[za>>2]|64;za=c+260|0;E=f[za>>2]|0;if(!E){Aa=L5b(40)|0;_Oa(Aa);f[za>>2]=Aa;Ca=Aa}else Ca=E;E=f[a+228>>2]|0;n9a(Ca,(E|0)==0?495864:E);Ba=f[g>>2]|0}if(!(Ba&536870912))Da=Ba;else{Ba=c+12|0;f[Ba>>2]=f[Ba>>2]|128;Ba=c+264|0;E=f[Ba>>2]|0;if(!E){Ca=L5b(32)|0;aPa(Ca);f[Ba>>2]=Ca;Ea=Ca}else Ea=E;E=f[a+232>>2]|0;o9a(Ea,(E|0)==0?495912:E);Da=f[g>>2]|0}if(!(Da&1073741824))Fa=Da;else{Da=c+12|0;f[Da>>2]=f[Da>>2]|256;Da=c+268|0;E=f[Da>>2]|0;if(!E){Ea=L5b(24)|0;cPa(Ea);f[Da>>2]=Ea;Ga=Ea}else Ga=E;E=f[a+236>>2]|0;p9a(Ga,(E|0)==0?495952:E);Fa=f[g>>2]|0}if((Fa|0)<0){Fa=c+12|0;f[Fa>>2]=f[Fa>>2]|4096;Fa=c+284|0;g=f[Fa>>2]|0;if(!g){E=L5b(68)|0;dPa(E);f[Fa>>2]=E;Ha=E}else Ha=g;g=f[a+240>>2]|0;q9a(Ha,(g|0)==0?496016:g)}g=a+12|0;Ha=f[g>>2]|0;if(!(Ha&1))Ia=Ha;else{Ha=c+12|0;f[Ha>>2]=f[Ha>>2]|8192;Ha=c+288|0;E=f[Ha>>2]|0;if(!E){Fa=L5b(28)|0;fPa(Fa);f[Ha>>2]=Fa;Ja=Fa}else Ja=E;E=f[a+244>>2]|0;r9a(Ja,(E|0)==0?496096:E);Ia=f[g>>2]|0}if(!(Ia&2))Ka=Ia;else{Ia=c+12|0;f[Ia>>2]=f[Ia>>2]|2097152;Ia=c+320|0;E=f[Ia>>2]|0;if(!E){Ja=L5b(24)|0;gPa(Ja);f[Ia>>2]=Ja;La=Ja}else La=E;E=f[a+248>>2]|0;s9a(La,(E|0)==0?496256:E);Ka=f[g>>2]|0}if(!(Ka&4))Ma=Ka;else{Ka=c+12|0;f[Ka>>2]=f[Ka>>2]|33554432;Ka=c+336|0;E=f[Ka>>2]|0;if(!E){La=L5b(20)|0;hPa(La);f[Ka>>2]=La;Na=La}else Na=E;E=f[a+252>>2]|0;t9a(Na,(E|0)==0?496376:E);Ma=f[g>>2]|0}if(!(Ma&8))Oa=Ma;else{Ma=c+12|0;f[Ma>>2]=f[Ma>>2]|67108864;Ma=c+340|0;E=f[Ma>>2]|0;if(!E){Na=L5b(24)|0;iPa(Na);f[Ma>>2]=Na;Pa=Na}else Pa=E;E=f[a+256>>2]|0;v9a(Pa,(E|0)==0?496456:E);Oa=f[g>>2]|0}if(!(Oa&16))Qa=Oa;else{Oa=c+12|0;f[Oa>>2]=f[Oa>>2]|268435456;Oa=c+348|0;E=f[Oa>>2]|0;if(!E){Pa=L5b(36)|0;jPa(Pa);f[Oa>>2]=Pa;Ra=Pa}else Ra=E;E=f[a+260>>2]|0;u9a(Ra,(E|0)==0?496408:E);Qa=f[g>>2]|0}if(!(Qa&32))Sa=Qa;else{Qa=c+12|0;f[Qa>>2]=f[Qa>>2]|536870912;Qa=c+352|0;E=f[Qa>>2]|0;if(!E){Ra=L5b(20)|0;lPa(Ra);f[Qa>>2]=Ra;Ta=Ra}else Ta=E;E=f[a+264>>2]|0;w9a(Ta,(E|0)==0?496488:E);Sa=f[g>>2]|0}if(!(Sa&64))Ua=Sa;else{Sa=c+12|0;f[Sa>>2]=f[Sa>>2]|1073741824;Sa=c+356|0;E=f[Sa>>2]|0;if(!E){Ta=L5b(20)|0;mPa(Ta);f[Sa>>2]=Ta;Va=Ta}else Va=E;E=f[a+268>>2]|0;x9a(Va,(E|0)==0?496552:E);Ua=f[g>>2]|0}if(!(Ua&128))Wa=Ua;else{Ua=c+16|0;f[Ua>>2]=f[Ua>>2]|1;Ua=c+364|0;E=f[Ua>>2]|0;if(!E){Va=L5b(64)|0;nPa(Va);f[Ua>>2]=Va;Xa=Va}else Xa=E;E=f[a+272>>2]|0;z9a(Xa,(E|0)==0?496584:E);Wa=f[g>>2]|0}if(!(Wa&256))Ya=Wa;else{Wa=c+8|0;f[Wa>>2]=f[Wa>>2]|2048;Wa=c+152|0;E=f[Wa>>2]|0;if(!E){Xa=L5b(44)|0;pPa(Xa);f[Wa>>2]=Xa;Za=Xa}else Za=E;E=f[a+276>>2]|0;V8a(Za,(E|0)==0?494552:E);Ya=f[g>>2]|0}if(!(Ya&512))_a=Ya;else{Ya=c+8|0;f[Ya>>2]=f[Ya>>2]|4096;Ya=c+156|0;c=f[Ya>>2]|0;if(!c){E=L5b(28)|0;rPa(E);f[Ya>>2]=E;$a=E}else $a=c;c=f[a+280>>2]|0;W8a($a,(c|0)==0?494608:c);_a=f[g>>2]|0}if(!(_a&1024)){ab=1;u=d;return ab|0}jya(e,377137,380150,1014,450605,0,1);_a=e+21|0;g=e+32|0;while(1){if(!(b[_a>>0]|0))break;rP(g,380200,44)|0;lya(e)}kya(e+24|0);ab=0;u=d;return ab|0}function Hza(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=Nza(b,c)|0;u=a;return d|0}function Iza(a){a=a|0;var c=0,d=0,e=0,f=0,g=0;c=u;u=u+176|0;d=c;do switch(a|0){case 0:{e=1124530;break}case 35:{e=410904;break}case 1:{e=380529;break}case 30:{e=380522;break}case 2:{e=380517;break}case 3:{e=411848;break}case 37:{e=380501;break}case 4:{e=411994;break}case 39:{e=410799;break}case 5:{e=380496;break}case 6:{e=410921;break}case 32:{e=380486;break}case 7:{e=380472;break}case 25:{e=410937;break}case 38:{e=380468;break}case 8:{e=410769;break}case 9:{e=380459;break}case 10:{e=380448;break}case 28:{e=380438;break}case 11:{e=380431;break}case 12:{e=380421;break}case 13:{e=380408;break}case 14:{e=410841;break}case 15:{e=410837;break}case 29:{e=380397;break}case 16:{e=380373;break}case 34:{e=410862;break}case 17:{e=411904;break}case 26:{e=433229;break}case 18:{e=380368;break}case 19:{e=410892;break}case 27:{e=380344;break}case 36:{e=410929;break}case 20:{e=410854;break}case 21:{e=380328;break}case 22:{e=410755;break}case 33:{e=410749;break}case 23:{e=380323;break}case 24:{e=380312;break}case 31:{e=380302;break}default:{jya(d,377137,380245,1103,450217,0,1);f=d+21|0;g=d+32|0;while(1){if(!(b[f>>0]|0))break;iYb(rP(g,380264,37)|0,a)|0;lya(d)}kya(d+24|0);e=1124530}}while(0);u=c;return e|0}function Jza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+16|0;e=d;g=a+8|0;f[g>>2]=f[g>>2]|2;g=a+148|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=kUb(c)|0;if(a>>>0>4294967279)V5b(e);if(a>>>0<11){b[e+11>>0]=a;if(!a)h=e;else{i=e;j=6}}else{k=a+16&-16;l=L5b(k)|0;f[e>>2]=l;f[e+8>>2]=k|-2147483648;f[e+4>>2]=a;i=l;j=6}if((j|0)==6){Vac(i|0,c|0,a|0)|0;h=i}b[h+a>>0]=0;a=f[g>>2]|0;if((a|0)==497760)jza(g,e);else _5b(a,e)|0;if((b[e+11>>0]|0)>=0){u=d;return}O5b(f[e>>2]|0);u=d;return}function Kza(a,b){a=a|0;b=b|0;var c=0,d=0;a=u;u=u+16|0;c=a;f[c>>2]=0;d=Lza(b,c)|0;u=a;return d|0}function Lza(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(32)|0;t4a(b);c=b;return c|0}else{b=znb(a,19688,32)|0;t4a(b);xnb(a,b,1486);c=b;return c|0}return 0}function Mza(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function Nza(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(60)|0;J4a(b);c=b;return c|0}else{b=znb(a,19704,60)|0;J4a(b);xnb(a,b,1487);c=b;return c|0}return 0}function Oza(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function Pza(a,b){a=a|0;b=b|0;var c=0;if(!a){b=L5b(372)|0;c4a(b);c=b;return c|0}else{b=znb(a,19672,372)|0;c4a(b);xnb(a,b,1488);c=b;return c|0}return 0}function Qza(a){a=a|0;bi[f[f[a>>2]>>2]&2047](a);return}function Rza(a,b){a=a|0;b=b|0;var c=0,e=0;c=u;u=u+64|0;e=c;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=a;a=e+12|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;d[a+12>>1]=0;f[e+28>>2]=2147483647;f[e+32>>2]=0;f[e+36>>2]=67108864;f[e+40>>2]=33554432;a=f[33911]|0;f[e+44>>2]=a;f[e+48>>2]=a;f[e+52>>2]=0;f[e+56>>2]=0;Mnb(e)|0;Rnb(e,2147483647,536870912);a=Tob(b,e)|0;Fnb(e);u=c;return a|0}function Sza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+368|0;e=d+168|0;g=d;h=e+108|0;i=e+8|0;f[e>>2]=18252;f[h>>2]=18272;f[e+4>>2]=0;RXb(e+108|0,i);f[e+180>>2]=0;f[e+184>>2]=-1;f[e>>2]=106336;f[h>>2]=106356;Tza(i);j=e+72|0;if((f[j>>2]|0)==0?(k=YUb(a,411132)|0,f[j>>2]=k,(k|0)!=0):0){f[e+96>>2]=8;l=k}else{k=e+(f[(f[e>>2]|0)+-12>>2]|0)|0;QXb(k,f[k+16>>2]|4);l=f[j>>2]|0}jya(g,377137,380538,1119,378737,380560,(l|0)!=0);l=g+21|0;j=g+32|0;while(1){if(!(b[l>>0]|0))break;k=rP(j,380573,12)|0;rP(rP(k,a,kUb(a)|0)|0,476054,1)|0;lya(g)}kya(g+24|0);PIb(g,e,-1);a=zPb(g,c)|0;GIb(g);f[e>>2]=106336;f[h>>2]=106356;Uza(i);rXb(e,106368);AWb(h);u=d;return a|0}function Tza(a){a=a|0;var c=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=u;u=u+16|0;e=c;WXb(a);f[a>>2]=106388;f[a+32>>2]=0;f[a+36>>2]=0;f[a+40>>2]=0;g=a+52|0;h=a+68|0;i=a+98|0;j=g;k=j+44|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));d[g+44>>1]=0;b[g+46>>0]=0;g=a+4|0;z5b(e,g);j=C5b(e,857292)|0;yZb(e);if(!j){l=f[a>>2]|0;m=l+12|0;n=f[m>>2]|0;li[n&511](a,0,4096)|0;u=c;return}z5b(e,g);g=xZb(e,857292)|0;f[h>>2]=g;yZb(e);e=f[h>>2]|0;h=(di[f[(f[e>>2]|0)+28>>2]&1023](e)|0)&1;b[i>>0]=h;l=f[a>>2]|0;m=l+12|0;n=f[m>>2]|0;li[n&511](a,0,4096)|0;u=c;return}function Uza(a){a=a|0;var c=0,d=0;f[a>>2]=106388;c=a+64|0;d=f[c>>2]|0;if(d|0?(Vza(a)|0,(yUb(d)|0)==0):0)f[c>>2]=0;if(b[a+96>>0]|0?(c=f[a+32>>2]|0,c|0):0)P5b(c);if(b[a+97>>0]|0?(c=f[a+56>>2]|0,c|0):0)P5b(c);FWb(a);return}function Vza(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+16|0;d=c;e=a+64|0;if(!(f[e>>2]|0)){g=0;u=c;return g|0}h=a+68|0;i=f[h>>2]|0;if(!i){j=ze(4)|0;A7b(j);If(j|0,25440,1415)}j=a+92|0;k=f[j>>2]|0;do if(!(k&16)){if(k&8|0){l=a+80|0;m=f[l+4>>2]|0;n=d;f[n>>2]=f[l>>2];f[n+4>>2]=m;do if(!(b[a+98>>0]|0)){m=di[f[(f[i>>2]|0)+24>>2]&1023](i)|0;n=a+36|0;l=f[n>>2]|0;o=(f[a+40>>2]|0)-l|0;if((m|0)>0){p=0;q=(Y((f[a+16>>2]|0)-(f[a+12>>2]|0)|0,m)|0)+o|0;break}m=f[a+12>>2]|0;if((m|0)==(f[a+16>>2]|0)){p=0;q=o}else{r=f[h>>2]|0;s=a+32|0;t=nh[f[(f[r>>2]|0)+32>>2]&127](r,d,f[s>>2]|0,l,m-(f[a+8>>2]|0)|0)|0;p=1;q=o-t+(f[n>>2]|0)-(f[s>>2]|0)|0}}else{p=0;q=(f[a+16>>2]|0)-(f[a+12>>2]|0)|0}while(0);if(UUb(f[e>>2]|0,0-q|0,1)|0){g=-1;u=c;return g|0}if(p){s=d;n=f[s+4>>2]|0;t=a+72|0;f[t>>2]=f[s>>2];f[t+4>>2]=n}n=f[a+32>>2]|0;f[a+40>>2]=n;f[a+36>>2]=n;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[j>>2]=0}}else{if((f[a+24>>2]|0)!=(f[a+20>>2]|0)?(Uh[f[(f[a>>2]|0)+52>>2]&1023](a,-1)|0)==-1:0){g=-1;u=c;return g|0}n=a+72|0;t=a+32|0;s=a+52|0;a:while(1){o=f[h>>2]|0;m=f[t>>2]|0;l=nh[f[(f[o>>2]|0)+20>>2]&127](o,n,m,m+(f[s>>2]|0)|0,d)|0;m=f[t>>2]|0;o=(f[d>>2]|0)-m|0;if((lUb(m,1,o,f[e>>2]|0)|0)!=(o|0)){g=-1;v=24;break}switch(l|0){case 1:break;case 2:{g=-1;v=24;break a;break}default:{v=10;break a}}}if((v|0)==10){if(!(AUb(f[e>>2]|0)|0))break;else g=-1;u=c;return g|0}else if((v|0)==24){u=c;return g|0}}while(0);g=0;u=c;return g|0}function Wza(a){a=a|0;Uza(a);O5b(a);return}function Xza(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;di[f[(f[a>>2]|0)+24>>2]&1023](a)|0;d=xZb(c,857292)|0;f[a+68>>2]=d;c=a+98|0;e=b[c>>0]|0;g=di[f[(f[d>>2]|0)+28>>2]&1023](d)|0;b[c>>0]=g&1;if((e&255|0)==(g&1|0))return;e=a+8|0;c=a+96|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;e=(b[c>>0]|0)!=0;if(g){g=a+32|0;if(e?(d=f[g>>2]|0,d|0):0)P5b(d);d=a+97|0;b[c>>0]=b[d>>0]|0;h=a+60|0;f[a+52>>2]=f[h>>2];i=a+56|0;f[g>>2]=f[i>>2];f[h>>2]=0;f[i>>2]=0;b[d>>0]=0;return}d=f[a+52>>2]|0;f[a+60>>2]=d;if(!e?(e=a+32|0,i=f[e>>2]|0,(i|0)!=(a+44|0)):0){f[a+56>>2]=i;b[a+97>>0]=0;i=N5b(d)|0;f[e>>2]=i;b[c>>0]=1;return}c=N5b(d)|0;f[a+56>>2]=c;b[a+97>>0]=1;return}function Yza(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=a+8|0;g=a+96|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;if(b[g>>0]|0?(e=f[a+32>>2]|0,e|0):0)P5b(e);e=a+97|0;if(b[e>>0]|0?(h=f[a+56>>2]|0,h|0):0)P5b(h);h=a+52|0;f[h>>2]=d;if(d>>>0>8){i=b[a+98>>0]|0;if((c|0)!=0&i<<24>>24!=0){j=0;k=c}else{j=1;k=N5b(d)|0}f[a+32>>2]=k;l=j;m=i}else{f[a+32>>2]=a+44;f[h>>2]=8;l=0;m=b[a+98>>0]|0}b[g>>0]=l;if(m<<24>>24){f[a+60>>2]=0;n=0;o=0;p=a+56|0;f[p>>2]=o;b[e>>0]=n;return a|0}m=(d|0)>8?d:8;f[a+60>>2]=m;if((c|0)!=0&m>>>0>7){n=0;o=c;p=a+56|0;f[p>>2]=o;b[e>>0]=n;return a|0}n=1;o=N5b(m)|0;p=a+56|0;f[p>>2]=o;b[e>>0]=n;return a|0}function Zza(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=f[b+68>>2]|0;if(!g){h=ze(4)|0;A7b(h);If(h|0,25440,1415)}h=di[f[(f[g>>2]|0)+24>>2]&1023](g)|0;g=b+64|0;if((((f[g>>2]|0)!=0?!(((c|0)!=0|(d|0)!=0)&(h|0)<1):0)?e>>>0<3&(di[f[(f[b>>2]|0)+24>>2]&1023](b)|0)==0:0)?(i=f[g>>2]|0,j=cbc(h|0,((h|0)<0)<<31>>31|0,c|0,d|0)|0,(UUb(i,(h|0)>0?j:0,e)|0)==0):0){e=qUb(f[g>>2]|0)|0;g=b+72|0;k=f[g>>2]|0;l=f[g+4>>2]|0;m=e;n=((e|0)<0)<<31>>31}else{k=0;l=0;m=-1;n=-1}e=a;f[e>>2]=k;f[e+4>>2]=l;l=a+8|0;f[l>>2]=m;f[l+4>>2]=n;return}function _za(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;d=b+64|0;if(f[d>>2]|0?(di[f[(f[b>>2]|0)+24>>2]&1023](b)|0)==0:0)if(!(UUb(f[d>>2]|0,f[c+8>>2]|0,0)|0)){d=c;e=f[d+4>>2]|0;g=b+72|0;f[g>>2]=f[d>>2];f[g+4>>2]=e;f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];return}else{c=a;f[c>>2]=0;f[c+4>>2]=0;c=a+8|0;f[c>>2]=-1;f[c+4>>2]=-1;return}c=a;f[c>>2]=0;f[c+4>>2]=0;c=a+8|0;f[c>>2]=-1;f[c+4>>2]=-1;return}function $za(a){a=a|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;c=u;u=u+16|0;d=c+4|0;e=c;g=a+64|0;if(!(f[g>>2]|0)){i=-1;u=c;return i|0}j=a+92|0;if(!(f[j>>2]&8)){f[a+24>>2]=0;f[a+20>>2]=0;f[a+28>>2]=0;k=(b[a+98>>0]|0)==0;l=f[(k?a+56|0:a+32|0)>>2]|0;m=l+(f[(k?a+60|0:a+52|0)>>2]|0)|0;f[a+8>>2]=l;l=a+12|0;f[l>>2]=m;f[a+16>>2]=m;f[j>>2]=8;n=1;o=l;p=m}else{m=a+12|0;n=0;o=m;p=f[m>>2]|0}if(!p){m=d+1|0;f[a+8>>2]=d;f[o>>2]=m;f[a+16>>2]=m;q=m}else q=p;p=a+16|0;if(n){r=f[p>>2]|0;s=0}else{n=f[p>>2]|0;m=(n-(f[a+8>>2]|0)|0)/2|0;r=n;s=m>>>0<4?m:4}do if((q|0)==(r|0)){m=a+8|0;Xac(f[m>>2]|0,q+(0-s)|0,s|0)|0;if(b[a+98>>0]|0){n=f[m>>2]|0;l=oUb(n+s|0,1,(f[p>>2]|0)-s-n|0,f[g>>2]|0)|0;if(!l){t=-1;v=m;break}n=(f[m>>2]|0)+s|0;f[o>>2]=n;f[p>>2]=n+l;t=h[n>>0]|0;v=m;break}n=a+40|0;l=f[n>>2]|0;j=a+36|0;k=f[j>>2]|0;w=l;x=k;if((l|0)==(k|0)){y=a+32|0;z=x;A=w}else{l=a+32|0;Xac(f[l>>2]|0,k|0,w-x|0)|0;y=l;z=f[j>>2]|0;A=f[n>>2]|0}l=f[y>>2]|0;x=l+(A-z)|0;f[j>>2]=x;if((l|0)==(a+44|0))B=8;else B=f[a+52>>2]|0;w=l+B|0;f[n>>2]=w;l=a+60|0;k=(f[l>>2]|0)-s|0;C=w-x|0;w=a+72|0;D=w;E=f[D+4>>2]|0;F=a+80|0;f[F>>2]=f[D>>2];f[F+4>>2]=E;E=oUb(x,1,C>>>0<k>>>0?C:k,f[g>>2]|0)|0;if(!E){t=-1;v=m}else{k=f[a+68>>2]|0;if(!k){C=ze(4)|0;A7b(C);If(C|0,25440,1415)}C=(f[j>>2]|0)+E|0;f[n>>2]=C;E=f[m>>2]|0;if((Di[f[(f[k>>2]|0)+16>>2]&15](k,w,f[y>>2]|0,C,j,E+s|0,E+(f[l>>2]|0)|0,e)|0)!=3){l=f[e>>2]|0;E=(f[m>>2]|0)+s|0;if((l|0)==(E|0))G=-1;else{H=l;I=E;J=25}}else{E=f[y>>2]|0;l=f[n>>2]|0;f[m>>2]=E;H=l;I=E;J=25}if((J|0)==25){f[o>>2]=I;f[p>>2]=H;G=h[I>>0]|0}t=G;v=m}}else{t=h[q>>0]|0;v=a+8|0}while(0);if((f[v>>2]|0)==(d|0)){f[v>>2]=0;f[o>>2]=0;f[p>>2]=0}i=t;u=c;return i|0}function aAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;if(!(f[a+64>>2]|0)){d=-1;return d|0}e=a+12|0;g=f[e>>2]|0;if((f[a+8>>2]|0)>>>0>=g>>>0){d=-1;return d|0}if((c|0)==-1){f[e>>2]=g+-1;d=0;return d|0}if(!(f[a+88>>2]&16)){a=c&255;h=g+-1|0;if(a<<24>>24==(b[h>>0]|0)){i=a;j=h}else{d=-1;return d|0}}else{i=c&255;j=g+-1|0}f[e>>2]=j;b[j>>0]=i;d=c;return d|0}function bAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+16|0;e=d+8|0;g=d+4|0;h=d;i=a+64|0;if(!(f[i>>2]|0)){j=-1;u=d;return j|0}k=a+92|0;if(!(f[k>>2]&16)){f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;l=f[a+52>>2]|0;do if(l>>>0>8)if(!(b[a+98>>0]|0)){m=f[a+56>>2]|0;n=m+((f[a+60>>2]|0)+-1)|0;o=m;break}else{m=f[a+32>>2]|0;n=m+(l+-1)|0;o=m;break}else{n=0;o=0}while(0);f[a+24>>2]=o;l=a+20|0;f[l>>2]=o;m=a+28|0;f[m>>2]=n;f[k>>2]=16;p=l;q=m;r=m;s=l;t=o;v=n;w=o}else{o=a+20|0;n=f[o>>2]|0;l=a+28|0;p=o;q=l;r=l;s=o;t=n;v=f[l>>2]|0;w=n}n=(c|0)==-1;l=a+24|0;o=f[l>>2]|0;if(n){x=o;y=w}else{if(!o){f[l>>2]=e;f[s>>2]=e;f[q>>2]=e+1;z=e}else z=o;b[z>>0]=c;z=(f[l>>2]|0)+1|0;f[l>>2]=z;x=z;y=f[s>>2]|0}a:do if((x|0)==(y|0))A=32;else{b:do if(!(b[a+98>>0]|0)){z=a+32|0;o=f[z>>2]|0;f[g>>2]=o;e=a+68|0;w=f[e>>2]|0;if(!w){B=ze(4)|0;A7b(B);If(B|0,25440,1415)}m=o;o=a+72|0;k=a+52|0;C=Di[f[(f[w>>2]|0)+12>>2]&15](w,o,y,x,h,m,m+(f[k>>2]|0)|0,g)|0;m=f[s>>2]|0;c:do if((f[h>>2]|0)!=(m|0)){w=C;D=m;while(1){if((w|0)==3){A=21;break}if((w|1|0)!=1)break c;E=f[z>>2]|0;F=(f[g>>2]|0)-E|0;if((lUb(E,1,F,f[i>>2]|0)|0)!=(F|0))break c;if((w|0)!=1){A=28;break}F=f[h>>2]|0;E=f[l>>2]|0;f[p>>2]=F;f[q>>2]=E;G=F;H=G+(E-F)|0;f[l>>2]=H;F=f[e>>2]|0;if(!F){A=19;break}E=f[z>>2]|0;w=Di[f[(f[F>>2]|0)+12>>2]&15](F,o,G,H,h,E,E+(f[k>>2]|0)|0,g)|0;E=f[s>>2]|0;if((f[h>>2]|0)==(E|0))break c;else D=E}if((A|0)==19){B=ze(4)|0;A7b(B);If(B|0,25440,1415)}else if((A|0)==21){w=(f[l>>2]|0)-D|0;if((lUb(D,1,w,f[i>>2]|0)|0)!=(w|0))break}I=l;break b}while(0);J=-1;break a}else{k=x-y|0;if((lUb(y,1,k,f[i>>2]|0)|0)!=(k|0)){J=-1;break a}I=l}while(0);f[I>>2]=t;f[p>>2]=t;f[r>>2]=v;A=32}while(0);if((A|0)==32)J=n?0:c;j=J;u=d;return j|0}function cAa(a){a=a|0;var b=0;f[a>>2]=106336;b=a+108|0;f[b>>2]=106356;Uza(a+8|0);rXb(a,106368);AWb(b);return}function dAa(a){a=a|0;var b=0;f[a>>2]=106336;b=a+108|0;f[b>>2]=106356;Uza(a+8|0);rXb(a,106368);AWb(b);O5b(a);return}function eAa(a){a=a|0;var b=0;b=a+(f[(f[a>>2]|0)+-12>>2]|0)|0;f[b>>2]=106336;a=b+108|0;f[a>>2]=106356;Uza(b+8|0);rXb(b,106368);AWb(a);return}function fAa(a){a=a|0;dAa(a+(f[(f[a>>2]|0)+-12>>2]|0)|0);return}function gAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+368|0;e=d+168|0;g=d;h=e+108|0;i=e+8|0;f[e>>2]=18252;f[h>>2]=18272;f[e+4>>2]=0;RXb(e+108|0,i);f[e+180>>2]=0;f[e+184>>2]=-1;f[e>>2]=106336;f[h>>2]=106356;Tza(i);j=e+72|0;if((f[j>>2]|0)==0?(k=YUb(a,443948)|0,f[j>>2]=k,(k|0)!=0):0){f[e+96>>2]=12;l=k}else{k=e+(f[(f[e>>2]|0)+-12>>2]|0)|0;QXb(k,f[k+16>>2]|4);l=f[j>>2]|0}jya(g,377137,380681,1126,378737,380560,(l|0)!=0);l=g+21|0;j=g+32|0;while(1){if(!(b[l>>0]|0))break;k=rP(j,380573,12)|0;rP(rP(k,a,kUb(a)|0)|0,476054,1)|0;lya(g)}kya(g+24|0);PIb(g,e,-1);a=Rza(g,c)|0;GIb(g);f[e>>2]=106336;f[h>>2]=106356;Uza(i);rXb(e,106368);AWb(h);u=d;return a|0}function hAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+176|0;e=d;jya(e,377137,380705,1145,378737,380736,Sza(a,c)|0);g=e+21|0;h=e+32|0;while(1){if(!(b[g>>0]|0))break;i=rP(h,412144,35)|0;rP(i,a,kUb(a)|0)|0;lya(e)}kya(e+24|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;h=kUb(a)|0;if(h>>>0>4294967279)V5b(e);if(h>>>0<11){b[e+11>>0]=h;if(!h)j=e;else{k=e;l=8}}else{g=h+16&-16;i=L5b(g)|0;f[e>>2]=i;f[e+8>>2]=g|-2147483648;f[e+4>>2]=h;k=i;l=8}if((l|0)==8){Vac(k|0,a|0,h|0)|0;j=k}b[j+h>>0]=0;Cza(e,c)|0;if((b[e+11>>0]|0)>=0){u=d;return}O5b(f[e>>2]|0);u=d;return}function iAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+176|0;e=d;jya(e,377137,380777,1159,378737,380810,gAa(a,c)|0);g=e+21|0;h=e+32|0;while(1){if(!(b[g>>0]|0))break;i=rP(h,412144,35)|0;rP(i,a,kUb(a)|0)|0;lya(e)}kya(e+24|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;h=kUb(a)|0;if(h>>>0>4294967279)V5b(e);if(h>>>0<11){b[e+11>>0]=h;if(!h)j=e;else{k=e;l=8}}else{g=h+16&-16;i=L5b(g)|0;f[e>>2]=i;f[e+8>>2]=g|-2147483648;f[e+4>>2]=h;k=i;l=8}if((l|0)==8){Vac(k|0,a|0,h|0)|0;j=k}b[j+h>>0]=0;Cza(e,c)|0;if((b[e+11>>0]|0)>=0){u=d;return}O5b(f[e>>2]|0);u=d;return}function jAa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=106452;c=a+4|0;d=f[c>>2]|0;e=d&-2;if(!(d&1))g=e;else g=f[e+4>>2]|0;if(!g){g=a+8|0;a=f[g>>2]|0;if((a|0)==497760|(a|0)==0)h=d;else{if((b[a+11>>0]|0)<0)O5b(f[a>>2]|0);O5b(a);h=f[c>>2]|0}f[g>>2]=497760;i=h}else i=d;if(!(i&1)){f[c>>2]=0;return}d=i&-2;i=d;if((d|0)==0|(f[i+4>>2]|0)!=0){f[c>>2]=0;return}if(f[i>>2]|0)GPb(i);O5b(d);f[c>>2]=0;return}function kAa(a){a=a|0;jAa(a);O5b(a);return}function lAa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function mAa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(32)|0;cBa(a);c=a;return c|0}else{a=znb(b,18312,32)|0;f[a>>2]=106452;f[a+4>>2]=b;f[a+8>>2]=497760;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;f[a+24>>2]=0;c=a;return c|0}return 0}function nAa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function oAa(a){a=a|0;return f[a+4>>2]|0}function pAa(a){a=a|0;var c=0;c=a+16|0;f[c>>2]=0;f[c+4>>2]=0;c=f[a+8>>2]|0;if((c|0)==497760)return;a=c+11|0;if((b[a>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;return}else{b[c>>0]=0;b[a>>0]=0;return}}function qAa(a){a=a|0;return 1}function rAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+16|0;j=e+8|0;k=a+8|0;l=a+4|0;m=a+8|0;a=c+32|0;n=c+12|0;o=c+28|0;a:while(1){p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0){q=b[p>>0]|0;r=q&255;if(q<<24>>24>0){f[h>>2]=r;f[c>>2]=p+1;s=r;t=6}else{v=r;t=5}}else{v=0;t=5}if((t|0)==5){t=0;r=_nb(c,v)|0;f[h>>2]=r;if((r+-1|0)>>>0<127){s=r;t=6}else{w=r;t=31}}b:do if((t|0)==6){t=0;switch(s>>>3&536870911|0){case 1:{switch(s|0){case 0:{x=1;t=34;break a;break}case 8:break;default:{y=s;break b}}r=f[c>>2]|0;p=f[g>>2]|0;if(r>>>0<p>>>0?(q=b[r>>0]|0,q<<24>>24>-1):0){z=r+1|0;f[c>>2]=z;A=q&255;B=0;C=z;D=p}else{Lnb(e,c);p=e;if(!(b[j>>0]|0)){x=0;t=34;break a}A=f[p>>2]|0;B=f[p+4>>2]|0;C=f[c>>2]|0;D=f[g>>2]|0}p=i;f[p>>2]=A;f[p+4>>2]=B;if(C>>>0>=D>>>0)continue a;if((b[C>>0]|0)!=18)continue a;f[c>>2]=C+1;break}case 2:{switch(s|0){case 0:{x=1;t=34;break a;break}case 18:break;default:{y=s;break b}}break}default:{w=s;t=31;break b}}p=f[l>>2]|0;z=p&-2;if(!(p&1))E=z;else E=f[z+4>>2]|0;z=f[k>>2]|0;if((z|0)==497760){dya(k,E,497760);F=f[k>>2]|0}else F=z;if(!(fqb(c,F)|0)){x=0;t=34;break a}z=f[m>>2]|0;p=b[z+11>>0]|0;if(p<<24>>24<0){G=f[z>>2]|0;H=f[z+4>>2]|0}else{G=z;H=p&255}if(!(gqb(G,H,0,381209)|0)){x=0;t=34;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[a>>2]|0){t=30;break a}if((f[n>>2]|0)==(f[o>>2]|0)){t=30;break a}else continue a}while(0);if((t|0)==31){t=0;if(!w){x=1;t=34;break}else y=w}if((y&7|0)==4){x=1;t=34;break}if(!(Lpb(c,y)|0)){x=0;t=34;break}}if((t|0)==30){f[h>>2]=0;b[c+24>>0]=1;x=1;u=d;return x|0}else if((t|0)==34){u=d;return x|0}return 0}function sAa(a){a=a|0;return di[f[(f[a>>2]|0)+52>>2]&1023](a)|0}function tAa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+16|0;d=f[c>>2]|0;e=f[c+4>>2]|0;if((d|0)==0&(e|0)==0)g=0;else g=(job(d,e)|0)+1|0;e=f[a+8>>2]|0;d=b[e+11>>0]|0;c=d<<24>>24<0;if(c)h=f[e+4>>2]|0;else h=d&255;if(!h){i=g;j=a+24|0;f[j>>2]=i;return i|0}if(c){c=f[e+4>>2]|0;if(c>>>0<128){k=1;l=c}else{k=iob(c)|0;l=c}}else{k=1;l=d&255}i=g+1+l+k|0;j=a+24|0;f[j>>2]=i;return i|0}function uAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0;d=a+16|0;e=f[d>>2]|0;g=f[d+4>>2]|0;if(!((e|0)==0&(g|0)==0))Npb(1,e,g,c);g=a+8|0;a=f[g>>2]|0;e=b[a+11>>0]|0;d=e<<24>>24<0;if(d)h=f[a+4>>2]|0;else h=e&255;if(!h)return;if(d){i=f[a>>2]|0;j=f[a+4>>2]|0}else{i=a;j=e&255}gqb(i,j,1,381209)|0;$pb(2,f[g>>2]|0,c);return}function vAa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function wAa(a){a=a|0;return f[a+24>>2]|0}function xAa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=a+16|0;e=f[c>>2]|0;g=f[c+4>>2]|0;if((e|0)==0&(g|0)==0)h=d;else{b[d>>0]=8;h=hob(e,g,d+1|0)|0}d=a+8|0;a=f[d>>2]|0;g=b[a+11>>0]|0;e=g<<24>>24<0;if(e)i=f[a+4>>2]|0;else i=g&255;if(!i){j=h;return j|0}if(e){k=f[a>>2]|0;l=f[a+4>>2]|0}else{k=a;l=g&255}gqb(k,l,1,381209)|0;l=f[d>>2]|0;b[h>>0]=18;j=kob(l,h+1|0)|0;return j|0}function yAa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function zAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((a|0)==(c|0))_Aa(374);d=T6b(c,23288,18312,0)|0;if(!d){cOb(c,a);return}c=d+16|0;e=f[c>>2]|0;g=f[c+4>>2]|0;if(!((e|0)==0&(g|0)==0)){c=a+16|0;f[c>>2]=e;f[c+4>>2]=g}g=f[d+8>>2]|0;d=b[g+11>>0]|0;if(d<<24>>24<0)h=f[g+4>>2]|0;else h=d&255;if(!h)return;h=a+8|0;d=f[a+4>>2]|0;a=d&-2;if(!(d&1))i=a;else i=f[a+4>>2]|0;a=f[h>>2]|0;if((a|0)==497760){dya(h,i,g);return}else{_5b(a,g)|0;return}}function AAa(a,b){a=a|0;b=b|0;f[a+24>>2]=b;return}function BAa(a){a=a|0;var b=0,c=0;b=u;u=u+16|0;c=b;zh[f[(f[a>>2]|0)+96>>2]&2047](c,a);u=b;return f[c+4>>2]|0}function CAa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[212954]|0)!=2){f[d>>2]=135812;f[d+4>>2]=3;b[d+8>>0]=0;Gpb(851816,d);hpb(d)}f[a>>2]=f[212955];f[a+4>>2]=f[212956];u=c;return}function DAa(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+48|0;c=a+24|0;d=a;e=a+36|0;if((f[212953]|0)!=2){f[c>>2]=135812;f[c+4>>2]=4;b[c+8>>0]=0;Gpb(851812,c);hpb(c)}g=drb()|0;h=L5b(32)|0;f[c>>2]=h;f[c+8>>2]=-2147483616;f[c+4>>2]=18;i=h;j=380853;k=i+18|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+18>>0]=0;h=hrb(g,c)|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if(!h){zpb(d,3,380872,40);xpb(e,vpb(d,459532)|0);Apb(d)}d=f[h+40>>2]|0;f[212957]=d;h=pIb(d,491784,106552,-1,-1,-1,32,4,-1)|0;f[212958]=h;h=f[(f[212957]|0)+44>>2]|0;f[212955]=h;d=pIb(h,491824,106560,-1,-1,-1,32,4,-1)|0;f[212956]=d;u=a;return}function EAa(){var a=0,c=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,380872);if((f[212952]|0)!=2){f[c>>2]=135812;f[c+4>>2]=5;b[c+8>>0]=0;Gpb(851808,c);hpb(c)}grb(380959,216);SNb(380853,1489);spb(6);u=a;return}function FAa(){var a=0,c=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,380872);f[122946]=106576;f[122947]=0;f[122948]=0;f[122949]=0;f[122950]=0;f[122951]=0;b[491808]=0;f[122953]=0;b[491816]=1;if((f[213345]|0)!=2){f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c)}f[122956]=106452;f[122957]=0;f[122958]=497760;c=491840;f[c>>2]=0;f[c+4>>2]=0;f[122962]=0;b[491856]=1;u=a;return}function GAa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[212954]|0)!=2){f[c>>2]=135812;f[c+4>>2]=3;b[c+8>>0]=0;Gpb(851816,c);hpb(c)}WNb(f[212957]|0,491784);WNb(f[212955]|0,491824);u=a;return}function HAa(){var a=0;if(b[491816]|0){b[491816]=0;bi[f[f[122946]>>2]&2047](491784)}a=f[212958]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[491856]|0){b[491856]=0;bi[f[f[122956]>>2]&2047](491824)}a=f[212956]|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function IAa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=106576;b=a+20|0;c=f[b>>2]|0;if(c|0?(f[a+8>>2]|0)==0:0){d=f[c>>2]|0;if((d|0)>0){e=0;do{g=f[c+4+(e<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);e=e+1|0}while((e|0)!=(d|0));h=f[b>>2]|0}else h=c;O5b(h)}f[b>>2]=0;b=a+4|0;a=f[b>>2]|0;if(!(a&1)){f[b>>2]=0;return}h=a&-2;a=h;if((h|0)==0|(f[a+4>>2]|0)!=0){f[b>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(h);f[b>>2]=0;return}function JAa(a){a=a|0;IAa(a);O5b(a);return}function KAa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function LAa(a,c){a=a|0;c=c|0;var d=0,e=0;if(!c){a=L5b(32)|0;dBa(a);d=a;return d|0}else{a=c;e=znb(c,18328,32)|0;f[e>>2]=106576;f[e+4>>2]=a;f[e+8>>2]=a;a=e+12|0;f[e+28>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+12>>0]=0;d=e;return d|0}return 0}function MAa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function NAa(a){a=a|0;return f[a+4>>2]|0}function OAa(a){a=a|0;var c=0,d=0,e=0,g=0;b[a+24>>0]=0;c=a+12|0;d=f[c>>2]|0;if((d|0)<=0)return;e=f[a+20>>2]|0;a=0;do{g=f[e+4+(a<<2)>>2]|0;a=a+1|0;bi[f[(f[g>>2]|0)+28>>2]&2047](g)}while((a|0)!=(d|0));f[c>>2]=0;return}function PAa(a){a=a|0;return 1}function QAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=c+44|0;j=a+8|0;k=a+20|0;l=a+16|0;m=a+12|0;n=a+24|0;a=c+32|0;o=c+12|0;p=c+28|0;q=e+8|0;a:while(1){r=f[c>>2]|0;if(r>>>0<(f[g>>2]|0)>>>0){s=b[r>>0]|0;t=s&255;if(s<<24>>24>0){f[h>>2]=t;f[c>>2]=r+1;v=t;w=6}else{x=t;w=5}}else{x=0;w=5}if((w|0)==5){w=0;t=_nb(c,x)|0;f[h>>2]=t;if((t+-1|0)>>>0<127){v=t;w=6}else{y=t;w=35}}b:do if((w|0)==6){w=0;switch(v>>>3&536870911|0){case 2:{switch(v|0){case 0:{z=1;w=38;break a;break}case 18:break;default:{A=v;break b}}t=f[i>>2]|0;f[i>>2]=t+-1;if((t|0)<=0){z=0;w=38;break a}while(1){t=f[k>>2]|0;do if(t){r=f[m>>2]|0;s=f[t>>2]|0;if((r|0)>=(s|0))if((s|0)==(f[l>>2]|0)){B=s;w=14;break}else{C=s;D=t;w=15;break}else{f[m>>2]=r+1;E=f[t+4+(r<<2)>>2]|0;break}}else{B=f[l>>2]|0;w=14}while(0);if((w|0)==14){w=0;cpb(j,B+1|0);t=f[k>>2]|0;C=f[t>>2]|0;D=t;w=15}if((w|0)==15){w=0;f[D>>2]=C+1;t=bBa(0,f[j>>2]|0)|0;r=f[k>>2]|0;s=f[m>>2]|0;f[m>>2]=s+1;f[r+4+(s<<2)>>2]=t;E=t}t=Jnb(c)|0;if(!(rAa(E,c)|0)){z=0;w=38;break a}if(!(Pnb(c,t)|0)){z=0;w=38;break a}F=f[c>>2]|0;G=f[g>>2]|0;if(F>>>0>=G>>>0){w=19;break}if((b[F>>0]|0)!=18)break;f[c>>2]=F+1}if((w|0)==19){w=0;f[i>>2]=(f[i>>2]|0)+1;continue a}f[i>>2]=(f[i>>2]|0)+1;if((b[F>>0]|0)!=24)continue a;t=F+1|0;f[c>>2]=t;H=t;I=G;break}case 3:{switch(v|0){case 0:{z=1;w=38;break a;break}case 24:break;default:{A=v;break b}}H=f[c>>2]|0;I=f[g>>2]|0;break}default:{y=v;w=35;break b}}if(H>>>0<I>>>0?(t=b[H>>0]|0,t<<24>>24>-1):0){s=H+1|0;f[c>>2]=s;J=t<<24>>24!=0;K=s;L=I}else{Lnb(e,c);s=e;if(!(b[q>>0]|0)){z=0;w=38;break a}J=(f[s>>2]|0)!=0|(f[s+4>>2]|0)!=0;K=f[c>>2]|0;L=f[g>>2]|0}b[n>>0]=J&1;if((K|0)!=(L|0))continue a;if(f[a>>2]|0){w=34;break a}if((f[o>>2]|0)==(f[p>>2]|0)){w=34;break a}else continue a}while(0);if((w|0)==35){w=0;if(!y){z=1;w=38;break}else A=y}if((A&7|0)==4){z=1;w=38;break}if(!(Lpb(c,A)|0)){z=0;w=38;break}}if((w|0)==34){f[h>>2]=0;b[c+24>>0]=1;z=1;u=d;return z|0}else if((w|0)==38){u=d;return z|0}return 0}function RAa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;c=f[a+12>>2]|0;d=(b[a+24>>0]|0?2:0)+c|0;if(!c){e=d;g=a+28|0;f[g>>2]=e;return e|0}h=a+20|0;i=0;j=d;while(1){d=f[(f[h>>2]|0)+4+(i<<2)>>2]|0;k=d+16|0;l=f[k>>2]|0;m=f[k+4>>2]|0;if((l|0)==0&(m|0)==0)n=0;else n=(job(l,m)|0)+1|0;m=f[d+8>>2]|0;l=b[m+11>>0]|0;k=l<<24>>24<0;if(k)o=f[m+4>>2]|0;else o=l&255;if(!o)p=n;else{if(k){k=f[m+4>>2]|0;if(k>>>0<128){q=1;r=k}else{q=iob(k)|0;r=k}}else{q=1;r=l&255}p=n+1+r+q|0}f[d+24>>2]=p;if(p>>>0<128)s=1;else s=iob(p)|0;d=p+j+s|0;i=i+1|0;if((i|0)==(c|0)){e=d;break}else j=d}g=a+28|0;f[g>>2]=e;return e|0}function SAa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=f[a+12>>2]|0;if(d|0){e=a+20|0;g=0;do{eqb(2,f[(f[e>>2]|0)+4+(g<<2)>>2]|0,c);g=g+1|0}while((g|0)!=(d|0))}if(!(b[a+24>>0]|0))return;Ypb(3,1,c);return}function TAa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function UAa(a){a=a|0;return f[a+28>>2]|0}function VAa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=f[a+12>>2]|0;if(!c)e=d;else{g=a+20|0;h=0;i=d;while(1){d=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=18;j=i+1|0;k=f[d+24>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=j;q=k}b[p>>0]=q;m=li[f[(f[d>>2]|0)+68>>2]&511](d,0,p+1|0)|0;h=h+1|0;if((h|0)==(c|0)){e=m;break}else i=m}}if(!(b[a+24>>0]|0)){r=e;return r|0}b[e>>0]=24;b[e+1>>0]=1;r=e+2|0;return r|0}function WAa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function XAa(a,c){a=a|0;c=c|0;var d=0;if((a|0)==(c|0))_Aa(672);d=T6b(c,23288,18328,0)|0;if(!d){cOb(c,a);return}$Aa(a+8|0,d+8|0);if(!(b[d+24>>0]|0))return;b[a+24>>0]=1;return}function YAa(a,b){a=a|0;b=b|0;f[a+28>>2]=b;return}function ZAa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[212954]|0)!=2){f[d>>2]=135812;f[d+4>>2]=3;b[d+8>>0]=0;Gpb(851816,d);hpb(d)}f[a>>2]=f[212957];f[a+4>>2]=f[212958];u=c;return}function _Aa(a){a=a|0;Enb(380872,a)}function $Aa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=f[b+4>>2]|0;if(!c)return;d=f[b+12>>2]|0;b=bpb(a,c)|0;e=a+12|0;g=a+4|0;h=(f[f[e>>2]>>2]|0)-(f[g>>2]|0)|0;if((c|0)>0&(h|0)>0){i=0;do{aBa(f[d+4+(i<<2)>>2]|0,f[b+(i<<2)>>2]|0);i=i+1|0}while((i|0)<(h|0)&(i|0)<(c|0))}i=f[a>>2]|0;if((h|0)<(c|0)){a=h;do{h=f[d+4+(a<<2)>>2]|0;j=bBa(h,i)|0;aBa(h,j);f[b+(a<<2)>>2]=j;a=a+1|0}while((a|0)!=(c|0))}a=(f[g>>2]|0)+c|0;f[g>>2]=a;g=f[e>>2]|0;if((f[g>>2]|0)>=(a|0))return;f[g>>2]=a;return}function aBa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;if((a|0)==(c|0))_Aa(392);d=a+16|0;e=f[d>>2]|0;g=f[d+4>>2]|0;if(!((e|0)==0&(g|0)==0)){d=c+16|0;f[d>>2]=e;f[d+4>>2]=g}g=f[a+8>>2]|0;a=b[g+11>>0]|0;if(a<<24>>24<0)h=f[g+4>>2]|0;else h=a&255;if(!h)return;h=c+8|0;a=f[c+4>>2]|0;c=a&-2;if(!(a&1))i=c;else i=f[c+4>>2]|0;c=f[h>>2]|0;if((c|0)==497760){dya(h,i,g);return}else{_5b(c,g)|0;return}}function bBa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(32)|0;cBa(a);c=a;return c|0}else{a=znb(b,18312,32)|0;f[a>>2]=106452;f[a+4>>2]=b;f[a+8>>2]=497760;b=a+16|0;f[b>>2]=0;f[b+4>>2]=0;f[a+24>>2]=0;c=a;return c|0}return 0}function cBa(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=106452;f[a+4>>2]=0;if((a|0)!=491824?(f[212952]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=5;b[d+8>>0]=0;Gpb(851808,d);hpb(d)}f[a+8>>2]=497760;d=a+16|0;f[d>>2]=0;f[d+4>>2]=0;f[a+24>>2]=0;u=c;return}function dBa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=106576;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;if((a|0)!=491784?(f[212952]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=5;b[d+8>>0]=0;Gpb(851808,d);hpb(d)}b[a+24>>0]=0;f[a+28>>2]=0;u=c;return}function eBa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212953]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=4;b[c+8>>0]=0;Gpb(851812,c);hpb(c);u=a;return}function fBa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212953]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=4;b[c+8>>0]=0;Gpb(851812,c);hpb(c);u=a;return}function gBa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212952]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=5;b[c+8>>0]=0;Gpb(851808,c);hpb(c);u=a;return}function hBa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;c=b&-2;if(!(b&1))d=c;else d=f[c+4>>2]|0;if(!d){c=L5b(8)|0;b=c;f[b>>2]=0;f[b+4>>2]=0;f[c>>2]=0;e=c;g=e;h=g|1;i=h;f[a>>2]=i;j=e+4|0;f[j>>2]=d;return e|0}else{c=znb(d,18344,8)|0;b=c;f[b>>2]=0;f[b+4>>2]=0;f[c>>2]=0;xnb(d,c,1490);e=c;g=e;h=g|1;i=h;f[a>>2]=i;j=e+4|0;f[j>>2]=d;return e|0}return 0}function iBa(a){a=a|0;if(!(f[a>>2]|0))return;GPb(a);return}function jBa(a,c){a=a|0;c=c|0;f[a>>2]=106576;f[a+4>>2]=c;f[a+8>>2]=c;c=a+12|0;f[a+28>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;b[c+12>>0]=0;return}function kBa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212952]|0)==2){u=a;return 491784}f[c>>2]=135812;f[c+4>>2]=5;b[c+8>>0]=0;Gpb(851808,c);hpb(c);u=a;return 491784}function lBa(a,c){a=a|0;c=c|0;if((c|0)==(a|0))_Aa(690);$Aa(a+8|0,c+8|0);if(!(b[c+24>>0]|0))return;b[a+24>>0]=1;return}function mBa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;f[a>>2]=106684;b=a+4|0;c=f[b>>2]|0;d=c&-2;if(!(c&1))e=d;else e=f[d+4>>2]|0;if(!((a|0)==491864|(e|0)!=0)){e=f[a+24>>2]|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);e=f[a+28>>2]|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e)}e=a+20|0;d=f[e>>2]|0;if(d|0?(f[a+8>>2]|0)==0:0){a=f[d>>2]|0;if((a|0)>0){c=0;do{g=f[d+4+(c<<2)>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+4>>2]&2047](g);c=c+1|0}while((c|0)!=(a|0));h=f[e>>2]|0}else h=d;O5b(h)}f[e>>2]=0;e=f[b>>2]|0;if(!(e&1)){f[b>>2]=0;return}h=e&-2;e=h;if((h|0)==0|(f[e+4>>2]|0)!=0){f[b>>2]=0;return}if(f[e>>2]|0)GPb(e);O5b(h);f[b>>2]=0;return}function nBa(a){a=a|0;mBa(a);O5b(a);return}function oBa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function pBa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){a=L5b(40)|0;nEa(a);c=a;return c|0}else{a=b;d=znb(b,18352,40)|0;f[d>>2]=106684;f[d+4>>2]=a;f[d+8>>2]=a;a=d+12|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=0;c=d;return c|0}return 0}function qBa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function rBa(a){a=a|0;return f[a+4>>2]|0}function sBa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=a+4|0;c=f[b>>2]|0;d=c&-2;if(!(c&1))e=d;else e=f[d+4>>2]|0;d=a+24|0;if((e|0)==0?(e=f[d>>2]|0,(e|0)!=0):0){bi[f[(f[e>>2]|0)+4>>2]&2047](e);g=f[b>>2]|0}else g=c;f[d>>2]=0;f[a+32>>2]=0;d=g&-2;if(!(g&1))h=d;else h=f[d+4>>2]|0;d=a+28|0;if((h|0)==0?(h=f[d>>2]|0,h|0):0)bi[f[(f[h>>2]|0)+4>>2]&2047](h);f[d>>2]=0;d=a+12|0;h=f[d>>2]|0;if((h|0)<=0)return;g=f[a+20>>2]|0;a=0;do{c=f[g+4+(a<<2)>>2]|0;a=a+1|0;bi[f[(f[c>>2]|0)+28>>2]&2047](c)}while((a|0)!=(h|0));f[d>>2]=0;return}function tBa(a){a=a|0;return 1}function uBa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=c+44|0;j=a+8|0;k=a+20|0;l=a+16|0;m=a+12|0;n=a+28|0;o=a+4|0;p=e+4|0;q=a+32|0;r=a+24|0;a=e+4|0;s=c+32|0;t=c+12|0;v=c+28|0;a:while(1){w=f[c>>2]|0;if(w>>>0<(f[g>>2]|0)>>>0){x=b[w>>0]|0;y=x&255;if(x<<24>>24>0){f[h>>2]=y;f[c>>2]=w+1;z=y;A=6}else{B=y;A=5}}else{B=0;A=5}if((A|0)==5){A=0;y=_nb(c,B)|0;f[h>>2]=y;if((y+-1|0)>>>0<127){z=y;A=6}else{C=y;A=75}}b:do if((A|0)==6){A=0;switch(z>>>3&536870911|0){case 1:{switch(z|0){case 0:{D=1;A=78;break a;break}case 10:break;default:{E=z;break b}}y=f[i>>2]|0;f[i>>2]=y+-1;if((y|0)<=0){D=0;A=78;break a}while(1){y=f[k>>2]|0;do if(y){w=f[m>>2]|0;x=f[y>>2]|0;if((w|0)>=(x|0))if((x|0)==(f[l>>2]|0)){F=x;A=14;break}else{G=x;H=y;A=15;break}else{f[m>>2]=w+1;I=f[y+4+(w<<2)>>2]|0;break}}else{F=f[l>>2]|0;A=14}while(0);if((A|0)==14){A=0;cpb(j,F+1|0);y=f[k>>2]|0;G=f[y>>2]|0;H=y;A=15}if((A|0)==15){A=0;f[H>>2]=G+1;y=mEa(0,f[j>>2]|0)|0;w=f[k>>2]|0;x=f[m>>2]|0;f[m>>2]=x+1;f[w+4+(x<<2)>>2]=y;I=y}y=Jnb(c)|0;if(!(IDa(I,c)|0)){D=0;A=78;break a}if(!(Pnb(c,y)|0)){D=0;A=78;break a}K=f[c>>2]|0;if(K>>>0>=(f[g>>2]|0)>>>0){A=19;break}if((b[K>>0]|0)!=10)break;f[c>>2]=K+1}if((A|0)==19){A=0;f[i>>2]=(f[i>>2]|0)+1;continue a}f[i>>2]=(f[i>>2]|0)+1;if((b[K>>0]|0)!=18)continue a;f[c>>2]=K+1;A=25;break}case 2:{switch(z|0){case 0:{D=1;A=78;break a;break}case 18:{A=25;break}default:{E=z;break b}}break}case 3:{switch(z|0){case 0:{D=1;A=78;break a;break}case 24:break;default:{E=z;break b}}L=f[c>>2]|0;M=f[g>>2]|0;A=46;break}case 4:{switch(z|0){case 0:{D=1;A=78;break a;break}case 34:break;default:{E=z;break b}}break}default:{C=z;A=75;break b}}if((A|0)==25){A=0;y=f[n>>2]|0;if(!y){x=f[o>>2]|0;w=x&-2;if(!(x&1))N=w;else N=f[w+4>>2]|0;if(!N){w=L5b(44)|0;_Ia(w);O=w}else{w=znb(N,18616,44)|0;cJa(w,N);O=w}f[n>>2]=O;P=O}else P=y;y=f[c>>2]|0;if(y>>>0<(f[g>>2]|0)>>>0?(w=b[y>>0]|0,w<<24>>24>-1):0){f[c>>2]=y+1;Q=w&255}else{w=Znb(c)|0;if((w|0)>-1)Q=w;else{D=0;A=78;break a}}Inb(e,c,Q);if((f[p>>2]|0)<0){A=39;break a}if(!(tHa(P,c)|0)){A=39;break a}if(!(Onb(c,f[e>>2]|0)|0)){D=0;A=78;break a}w=f[c>>2]|0;y=f[g>>2]|0;if(w>>>0>=y>>>0)continue a;if((b[w>>0]|0)!=24)continue a;x=w+1|0;f[c>>2]=x;L=x;M=y;A=46}if((A|0)==46){A=0;if(L>>>0<M>>>0){y=b[L>>0]|0;x=y&255;if(y<<24>>24>-1){y=L+1|0;f[c>>2]=y;R=x;S=y;T=M}else{U=x;A=49}}else{U=0;A=49}if((A|0)==49){A=0;x=Knb(c,U)|0;y=J;if(!((y|0)>-1|(y|0)==-1&x>>>0>4294967295)){D=0;A=78;break a}R=x;S=f[c>>2]|0;T=f[g>>2]|0}f[q>>2]=R;if(S>>>0>=T>>>0)continue a;if((b[S>>0]|0)!=34)continue a;f[c>>2]=S+1}x=f[r>>2]|0;if(!x){y=f[o>>2]|0;w=y&-2;if(!(y&1))V=w;else V=f[w+4>>2]|0;if(!V){w=L5b(36)|0;QEa(w);W=w}else{w=znb(V,18536,36)|0;REa(w,V);W=w}f[r>>2]=W;X=W}else X=x;x=f[c>>2]|0;if(x>>>0<(f[g>>2]|0)>>>0?(w=b[x>>0]|0,w<<24>>24>-1):0){f[c>>2]=x+1;Y=w&255}else{w=Znb(c)|0;if((w|0)>-1)Y=w;else{D=0;A=78;break a}}Inb(e,c,Y);if((f[a>>2]|0)<0){A=69;break a}if(!(zEa(X,c)|0)){A=69;break a}if(!(Onb(c,f[e>>2]|0)|0)){D=0;A=78;break a}if((f[c>>2]|0)!=(f[g>>2]|0))continue a;if(f[s>>2]|0){A=74;break a}if((f[t>>2]|0)==(f[v>>2]|0)){A=74;break a}else continue a}while(0);if((A|0)==75){A=0;if(!C){D=1;A=78;break}else E=C}if((E&7|0)==4){D=1;A=78;break}if(!(Lpb(c,E)|0)){D=0;A=78;break}}if((A|0)==39){D=0;u=d;return D|0}else if((A|0)==69){D=0;u=d;return D|0}else if((A|0)==74){f[h>>2]=0;b[c+24>>0]=1;D=1;u=d;return D|0}else if((A|0)==78){u=d;return D|0}return 0}function vBa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;b=(a|0)==491864;if(!b?(c=f[a+24>>2]|0,(c|0)!=0):0){d=AEa(c)|0;if(d>>>0<128)e=1;else e=iob(d)|0;g=d+1+e|0}else g=0;e=f[a+32>>2]|0;if(!e)h=g;else{if((e|0)>=0)if(e>>>0<128)i=2;else i=(iob(e)|0)+1|0;else i=11;h=i+g|0}if(!b?(b=f[a+28>>2]|0,(b|0)!=0):0){g=uHa(b)|0;if(g>>>0<128)j=1;else j=iob(g)|0;k=h+1+g+j|0}else k=h;h=f[a+12>>2]|0;j=h+k|0;if(!h){l=j;m=a+36|0;f[m>>2]=l;return l|0}k=a+20|0;g=0;b=j;while(1){j=JDa(f[(f[k>>2]|0)+4+(g<<2)>>2]|0)|0;if(j>>>0<128)n=1;else n=iob(j)|0;i=j+b+n|0;g=g+1|0;if((g|0)==(h|0)){l=i;break}else b=i}m=a+36|0;f[m>>2]=l;return l|0}function wBa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=f[a+12>>2]|0;if(c|0){d=a+20|0;e=0;do{eqb(1,f[(f[d>>2]|0)+4+(e<<2)>>2]|0,b);e=e+1|0}while((e|0)!=(c|0))}c=(a|0)==491864;if(!c?(e=f[a+28>>2]|0,e|0):0)eqb(2,e,b);e=f[a+32>>2]|0;if(e|0)Mpb(3,e,b);if(c)return;c=f[a+24>>2]|0;if(!c)return;eqb(4,c,b);return}function xBa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function yBa(a){a=a|0;return f[a+36>>2]|0}function zBa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c=f[a+12>>2]|0;if(!c)e=d;else{g=a+20|0;h=0;i=d;while(1){d=f[(f[g>>2]|0)+4+(h<<2)>>2]|0;b[i>>0]=10;j=i+1|0;k=f[d+80>>2]|0;if(k>>>0>127){l=k;m=j;while(1){b[m>>0]=l|128;n=l>>>7;o=m+1|0;if(l>>>0>16383){l=n;m=o}else{p=o;q=n;break}}}else{p=j;q=k}b[p>>0]=q;m=li[f[(f[d>>2]|0)+68>>2]&511](d,0,p+1|0)|0;h=h+1|0;if((h|0)==(c|0)){e=m;break}else i=m}}i=(a|0)==491864;if(!i?(c=f[a+28>>2]|0,(c|0)!=0):0){b[e>>0]=18;h=e+1|0;p=f[c+40>>2]|0;if(p>>>0>127){q=p;g=h;while(1){b[g>>0]=q|128;m=q>>>7;l=g+1|0;if(q>>>0>16383){q=m;g=l}else{r=l;s=m;break}}}else{r=h;s=p}b[r>>0]=s;t=li[f[(f[c>>2]|0)+68>>2]&511](c,0,r+1|0)|0}else t=e;e=f[a+32>>2]|0;do if(!e)u=t;else{b[t>>0]=24;r=t+1|0;if((e|0)<0){u=hob(e,((e|0)<0)<<31>>31,r)|0;break}if(e>>>0>127){c=e;s=r;while(1){b[s>>0]=c|128;p=c>>>7;h=s+1|0;if(c>>>0>16383){c=p;s=h}else{v=h;w=p;break}}}else{v=r;w=e}b[v>>0]=w;u=v+1|0}while(0);if(i){x=u;return x|0}i=f[a+24>>2]|0;if(!i){x=u;return x|0}b[u>>0]=34;a=u+1|0;u=f[i+32>>2]|0;if(u>>>0>127){v=u;w=a;while(1){b[w>>0]=v|128;e=v>>>7;t=w+1|0;if(v>>>0>16383){v=e;w=t}else{y=t;z=e;break}}}else{y=a;z=u}b[y>>0]=z;x=li[f[(f[i>>2]|0)+68>>2]&511](i,0,y+1|0)|0;return x|0}function ABa(a,b){a=a|0;b=b|0;if((a|0)==(b|0))return;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function BBa(a,b){a=a|0;b=b|0;var c=0;if((a|0)==(b|0))SDa(573);c=T6b(b,23288,18352,0)|0;if(!c){cOb(b,a);return}else{jEa(a,c);return}}function CBa(a,b){a=a|0;b=b|0;f[a+36>>2]=b;return}function DBa(a,c){a=a|0;c=c|0;var d=0;c=u;u=u+16|0;d=c;if((f[212961]|0)!=2){f[d>>2]=135812;f[d+4>>2]=8;b[d+8>>0]=0;Gpb(851844,d);hpb(d)}f[a>>2]=f[212962];f[a+4>>2]=f[212963];u=c;return}function EBa(){var a=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;a=u;u=u+48|0;c=a+24|0;d=a;e=a+36|0;if((f[212960]|0)!=2){f[c>>2]=135812;f[c+4>>2]=9;b[c+8>>0]=0;Gpb(851840,c);hpb(c)}g=drb()|0;h=L5b(16)|0;f[c>>2]=h;f[c+8>>2]=-2147483632;f[c+4>>2]=11;i=h;j=381348;k=i+11|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));b[h+11>>0]=0;h=hrb(g,c)|0;if((b[c+11>>0]|0)<0)O5b(f[c>>2]|0);if(!h){zpb(d,3,381360,41);xpb(e,vpb(d,459532)|0);Apb(d)}d=h+40|0;h=f[d>>2]|0;f[212962]=h;e=pIb(h,491864,106784,-1,-1,-1,40,4,-1)|0;f[212963]=e;e=(f[d>>2]|0)+88|0;f[212964]=e;d=pIb(e,491912,106800,-1,-1,-1,84,4,-1)|0;f[212965]=d;f[212966]=f[(f[212964]|0)+44>>2];u=a;return}function FBa(){var a=0,c=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,381360);if((f[212959]|0)!=2){f[c>>2]=135812;f[c+4>>2]=10;b[c+8>>0]=0;Gpb(851836,c);hpb(c)}grb(381440,471);SNb(381348,1491);dHa();aJa();TEa();spb(11);u=a;return}function GBa(){var a=0,c=0;a=u;u=u+16|0;c=a;kpb(3001e3,3001e3,381360);eHa();bJa();UEa();f[122966]=106684;f[122967]=0;f[122968]=0;f[122969]=0;f[122970]=0;f[122971]=0;f[122972]=0;f[122973]=0;f[122974]=0;f[122975]=0;b[491904]=1;if((f[213345]|0)==2){uCa(491912);b[492e3]=1;f[122972]=492008;f[122973]=492488;u=a;return}f[c>>2]=135812;f[c+4>>2]=7;b[c+8>>0]=0;Gpb(853380,c);hpb(c);uCa(491912);b[492e3]=1;f[122972]=492008;f[122973]=492488;u=a;return}function HBa(a){a=a|0;var c=0;a=u;u=u+16|0;c=a;if((f[212961]|0)!=2){f[c>>2]=135812;f[c+4>>2]=8;b[c+8>>0]=0;Gpb(851844,c);hpb(c)}WNb(f[212962]|0,491864);WNb(f[212964]|0,491912);c=f[212966]|0;WNb(c,JBa(c)|0);u=a;return}function IBa(){var a=0;if(b[491904]|0){b[491904]=0;bi[f[f[122966]>>2]&2047](491864)}a=f[212963]|0;if(a|0)bi[f[(f[a>>2]|0)+4>>2]&2047](a);if(b[492e3]|0){b[492e3]=0;bi[f[f[122978]>>2]&2047](491912)}a=f[212965]|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function JBa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;b=L5b(48)|0;c=b+4|0;f[c>>2]=0;d=b+8|0;f[d>>2]=0;f[b>>2]=106828;f[b+12>>2]=0;f[b+16>>2]=0;e=b+20|0;f[e>>2]=0;g=b+24|0;f[g>>2]=106944;h=b+28|0;f[h>>2]=0;f[b+40>>2]=0;f[b+32>>2]=497760;i=b+36|0;f[i>>2]=0;f[b+44>>2]=0;j=L5b(52)|0;k=drb()|0;mIb(j,a,b,107024,44,12,-1,k,LNb()|0,48,16);f[c>>2]=a;f[d>>2]=j;f[e>>2]=b;f[h>>2]=g;g=hHa()|0;f[i>>2]=g;mKb(b);return b|0}function KBa(a){a=a|0;var c=0,d=0;f[a>>2]=106944;if((f[a+4>>2]|0)==(a|0))return;if(f[a+16>>2]|0)return;c=a+8|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=f[a+12>>2]|0;if(!c)return;bi[f[(f[c>>2]|0)+4>>2]&2047](c);return}function LBa(a){a=a|0;var c=0,d=0;f[a>>2]=106944;if((f[a+4>>2]|0)==(a|0)){O5b(a);return}if(f[a+16>>2]|0){O5b(a);return}c=a+8|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=f[a+12>>2]|0;if(!c){O5b(a);return}bi[f[(f[c>>2]|0)+4>>2]&2047](c);O5b(a);return}function MBa(a,b){a=a|0;b=b|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;return}function NBa(a){a=a|0;var b=0;b=L5b(24)|0;f[b>>2]=106944;f[b+16>>2]=0;f[b+8>>2]=497760;f[b+12>>2]=0;f[b+20>>2]=0;f[b+4>>2]=f[a+4>>2];return b|0}function OBa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b){c=L5b(24)|0;f[c>>2]=106944;f[c+4>>2]=0;f[c+16>>2]=0;d=c}else{c=znb(b,18368,24)|0;f[c>>2]=106944;f[c+4>>2]=0;f[c+16>>2]=b;d=c}f[d+8>>2]=497760;f[d+12>>2]=0;f[d+20>>2]=0;f[d+4>>2]=f[a+4>>2];return d|0}function PBa(a){a=a|0;return f[a+16>>2]|0}function QBa(a){a=a|0;return di[f[(f[a>>2]|0)+20>>2]&1023](a)|0}function RBa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=f[a+8>>2]|0;do if((c|0)!=497760){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+12>>2]|0;if(!c){e=a+20|0;g=f[e>>2]|0;h=g&-4;f[e>>2]=h;return}bi[f[(f[c>>2]|0)+28>>2]&2047](c);e=a+20|0;g=f[e>>2]|0;h=g&-4;f[e>>2]=h;return}function SBa(a){a=a|0;var b=0;b=f[a+12>>2]|0;return di[f[(f[b>>2]|0)+32>>2]&1023](b)|0}function TBa(a,b){a=a|0;b=b|0;aCa(a,b);return}function UBa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+4|0;h=c+20|0;i=a+20|0;j=a+8|0;k=a+16|0;l=a+12|0;a=e+4|0;m=c+32|0;n=c+12|0;o=c+28|0;a:while(1){p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0){q=b[p>>0]|0;r=q&255;if(q<<24>>24>-1){f[h>>2]=r;f[c>>2]=p+1;s=r}else{t=r;v=5}}else{t=0;v=5}if((v|0)==5){v=0;r=_nb(c,t)|0;f[h>>2]=r;s=r}switch(s|0){case 0:{w=1;v=33;break a;break}case 10:{f[i>>2]=f[i>>2]|1;r=f[j>>2]|0;if((r|0)==497760){dya(j,f[k>>2]|0,497760);x=f[j>>2]|0}else x=r;if(!(fqb(c,x)|0)){w=0;v=33;break a}r=f[i>>2]|1;f[i>>2]=r;p=f[c>>2]|0;if(p>>>0>=(f[g>>2]|0)>>>0)continue a;if((b[p>>0]|0)!=18)continue a;f[c>>2]=p+1;y=r;break}case 18:{y=f[i>>2]|0;break}default:{if((s&7|0)==4){w=1;v=33;break a}if(Lpb(c,s)|0)continue a;else{w=0;v=33;break a}}}f[i>>2]=y|2;r=f[k>>2]|0;p=f[l>>2]|0;if(!p){if(!r){q=L5b(24)|0;bHa(q);z=q}else{q=znb(r,18600,24)|0;gHa(q,r);z=q}f[l>>2]=z;A=z}else A=p;p=f[c>>2]|0;if(p>>>0<(f[g>>2]|0)>>>0?(q=b[p>>0]|0,q<<24>>24>-1):0){f[c>>2]=p+1;B=q&255}else{q=Znb(c)|0;if((q|0)>-1)B=q;else{w=0;v=33;break}}Inb(e,c,B);if((f[a>>2]|0)<0){v=25;break}if(!(JGa(A,c)|0)){v=25;break}if(!(Onb(c,f[e>>2]|0)|0)){w=0;v=33;break}f[i>>2]=f[i>>2]|2;if((f[c>>2]|0)!=(f[g>>2]|0))continue;if(f[m>>2]|0){v=30;break}if((f[n>>2]|0)==(f[o>>2]|0)){v=30;break}}if((v|0)==25){w=0;u=d;return w|0}else if((v|0)==30){f[h>>2]=0;b[c+24>>0]=1;w=1;u=d;return w|0}else if((v|0)==33){u=d;return w|0}return 0}function VBa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+20|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=di[f[(f[a>>2]|0)+72>>2]&1023](a)|0;h=b[d+11>>0]|0;if(h<<24>>24<0){i=f[d+4>>2]|0;if(i>>>0<128){j=1;k=i}else{j=iob(i)|0;k=i}}else{j=1;k=h&255}e=f[c>>2]|0;g=k+1+j|0}if(!(e&2)){l=0;m=l+g|0;return m|0}e=zGa(di[f[(f[a>>2]|0)+76>>2]&1023](a)|0)|0;if(e>>>0<128)n=1;else n=iob(e)|0;l=e+1+n|0;m=l+g|0;return m|0}function WBa(a,b){a=a|0;b=b|0;_pb(1,di[f[(f[a>>2]|0)+72>>2]&1023](a)|0,b);eqb(2,di[f[(f[a>>2]|0)+76>>2]&1023](a)|0,b);return}function XBa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function YBa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+20|0;d=f[c>>2]|0;if(!(d&1)){e=d;g=0}else{d=di[f[(f[a>>2]|0)+72>>2]&1023](a)|0;h=b[d+11>>0]|0;if(h<<24>>24<0){i=f[d+4>>2]|0;if(i>>>0<128){j=1;k=i}else{j=iob(i)|0;k=i}}else{j=1;k=h&255}e=f[c>>2]|0;g=k+1+j|0}if(!(e&2)){l=0;m=l+g|0;return m|0}e=di[f[(f[a>>2]|0)+76>>2]&1023](a)|0;a=di[f[(f[e>>2]|0)+64>>2]&1023](e)|0;if(a>>>0<128)n=1;else n=iob(a)|0;l=a+1+n|0;m=l+g|0;return m|0}function ZBa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=di[f[(f[a>>2]|0)+72>>2]&1023](a)|0;b[d>>0]=10;g=kob(e,d+1|0)|0;d=di[f[(f[a>>2]|0)+76>>2]&1023](a)|0;b[g>>0]=18;a=g+1|0;g=di[f[(f[d>>2]|0)+64>>2]&1023](d)|0;if(g>>>0>127){e=g;h=a;while(1){b[h>>0]=e|128;i=e>>>7;j=h+1|0;if(e>>>0>16383){e=i;h=j}else{k=j;l=i;break}}}else{k=a;l=g}b[k>>0]=l;return li[f[(f[d>>2]|0)+68>>2]&511](d,c,k+1|0)|0}function _Ba(a){a=a|0;return f[a+8>>2]|0}function $Ba(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;d=a+4|0;e=f[d>>2]|0;if(!e){zpb(c,3,381912,139);xpb(b+24|0,vpb(c,382007)|0);Apb(c);g=f[d>>2]|0}else g=e;e=f[a+12>>2]|0;u=b;return (e|0?e:f[g+12>>2]|0)|0}function aCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=b+20|0;d=f[c>>2]|0;if(!d)return;if(!(d&1))e=d;else{d=a+8|0;g=a+16|0;if((f[d>>2]|0)==497760)dya(d,f[g>>2]|0,497760);h=di[f[(f[b>>2]|0)+72>>2]&1023](b)|0;i=f[d>>2]|0;if((i|0)==497760)dya(d,f[g>>2]|0,h);else _5b(i,h)|0;h=a+20|0;f[h>>2]=f[h>>2]|1;e=f[c>>2]|0}if(!(e&2))return;e=a+12|0;c=f[a+16>>2]|0;if(!(f[e>>2]|0)){if(!c){h=L5b(24)|0;bHa(h);j=h}else{h=znb(c,18600,24)|0;gHa(h,c);j=h}f[e>>2]=j}j=di[f[(f[b>>2]|0)+76>>2]&1023](b)|0;iHa(f[e>>2]|0,j);j=a+20|0;f[j>>2]=f[j>>2]|2;return}function bCa(a){a=a|0;var c=0,d=0,e=0;f[a>>2]=106828;if((f[a+20>>2]|0)==(a|0)?(c=f[a+8>>2]|0,c|0):0)bi[f[(f[c>>2]|0)+4>>2]&2047](c);c=a+24|0;f[c>>2]=106944;if((f[a+28>>2]|0)!=(c|0)?(f[a+40>>2]|0)==0:0){c=a+32|0;d=f[c>>2]|0;if(!((d|0)==497760|(d|0)==0)){if((b[d+11>>0]|0)<0)O5b(f[d>>2]|0);O5b(d)}f[c>>2]=0;c=f[a+36>>2]|0;if(c|0)bi[f[(f[c>>2]|0)+4>>2]&2047](c)}c=a+16|0;d=f[c>>2]|0;if(d&1|0?(e=d&-2,d=e,!((e|0)==0|(f[d+4>>2]|0)!=0)):0){if(f[d>>2]|0)GPb(d);O5b(e)}f[c>>2]=0;c=a+12|0;if(!(f[c>>2]|0))return;GPb(c);return}function cCa(a){a=a|0;bCa(a);O5b(a);return}function dCa(a){a=a|0;var b=0,c=0;b=L5b(48)|0;f[b>>2]=106828;f[b+12>>2]=0;f[b+16>>2]=0;f[b+24>>2]=106944;f[b+40>>2]=0;f[b+32>>2]=497760;f[b+36>>2]=0;f[b+44>>2]=0;f[b+4>>2]=f[a+4>>2];f[b+8>>2]=f[a+8>>2];c=f[a+20>>2]|0;f[b+20>>2]=c;f[b+28>>2]=c+24;return b|0}function eCa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;if(!b){c=L5b(48)|0;f[c+4>>2]=0;f[c+8>>2]=0;f[c>>2]=106828;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;f[c+24>>2]=106944;f[c+28>>2]=0;f[c+40>>2]=0;d=c}else{c=b;e=znb(b,18384,48)|0;f[e+4>>2]=0;f[e+8>>2]=0;f[e>>2]=106828;f[e+12>>2]=0;f[e+16>>2]=c;f[e+20>>2]=0;f[e+24>>2]=106944;f[e+28>>2]=0;f[e+40>>2]=c;d=e}f[d+32>>2]=497760;f[d+36>>2]=0;f[d+44>>2]=0;f[d+4>>2]=f[a+4>>2];f[d+8>>2]=f[a+8>>2];e=f[a+20>>2]|0;f[d+20>>2]=e;f[d+28>>2]=e+24;return d|0}function fCa(a){a=a|0;return f[a+40>>2]|0}function gCa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0;c=f[a+32>>2]|0;do if((c|0)!=497760){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+36>>2]|0;if(!c){e=a+44|0;g=f[e>>2]|0;h=g&-4;f[e>>2]=h;return}bi[f[(f[c>>2]|0)+28>>2]&2047](c);e=a+44|0;g=f[e>>2]|0;h=g&-4;f[e>>2]=h;return}function hCa(a){a=a|0;var b=0;b=f[a+36>>2]|0;return di[f[(f[b>>2]|0)+32>>2]&1023](b)|0}function iCa(a,b){a=a|0;b=b|0;return UBa(a+24|0,b)|0}function jCa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+24|0;d=a+44|0;a=f[d>>2]|0;if(!(a&1)){e=a;g=0}else{a=di[f[(f[c>>2]|0)+72>>2]&1023](c)|0;h=b[a+11>>0]|0;if(h<<24>>24<0){i=f[a+4>>2]|0;if(i>>>0<128){j=1;k=i}else{j=iob(i)|0;k=i}}else{j=1;k=h&255}e=f[d>>2]|0;g=k+1+j|0}if(!(e&2)){l=0;m=l+g|0;return m|0}e=zGa(di[f[(f[c>>2]|0)+76>>2]&1023](c)|0)|0;if(e>>>0<128)n=1;else n=iob(e)|0;l=e+1+n|0;m=l+g|0;return m|0}function kCa(a,b){a=a|0;b=b|0;var c=0;c=a+24|0;_pb(1,di[f[(f[c>>2]|0)+72>>2]&1023](c)|0,b);eqb(2,di[f[(f[c>>2]|0)+76>>2]&1023](c)|0,b);return}function lCa(a,b){a=a|0;b=b|0;return li[f[(f[a>>2]|0)+68>>2]&511](a,0,b)|0}function mCa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;c=a+24|0;d=a+44|0;a=f[d>>2]|0;if(!(a&1)){e=a;g=0}else{a=di[f[(f[c>>2]|0)+72>>2]&1023](c)|0;h=b[a+11>>0]|0;if(h<<24>>24<0){i=f[a+4>>2]|0;if(i>>>0<128){j=1;k=i}else{j=iob(i)|0;k=i}}else{j=1;k=h&255}e=f[d>>2]|0;g=k+1+j|0}if(!(e&2)){l=0;m=l+g|0;return m|0}e=di[f[(f[c>>2]|0)+76>>2]&1023](c)|0;c=di[f[(f[e>>2]|0)+64>>2]&1023](e)|0;if(c>>>0<128)n=1;else n=iob(c)|0;l=c+1+n|0;m=l+g|0;return m|0}function nCa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+24|0;a=di[f[(f[e>>2]|0)+72>>2]&1023](e)|0;b[d>>0]=10;g=kob(a,d+1|0)|0;d=di[f[(f[e>>2]|0)+76>>2]&1023](e)|0;b[g>>0]=18;e=g+1|0;g=di[f[(f[d>>2]|0)+64>>2]&1023](d)|0;if(g>>>0>127){a=g;h=e;while(1){b[h>>0]=a|128;i=a>>>7;j=h+1|0;if(a>>>0>16383){a=i;h=j}else{k=j;l=i;break}}}else{k=e;l=g}b[k>>0]=l;return li[f[(f[d>>2]|0)+68>>2]&511](d,c,k+1|0)|0}function oCa(a,b){a=a|0;b=b|0;bi[f[(f[a>>2]|0)+28>>2]&2047](a);zh[f[(f[a>>2]|0)+76>>2]&2047](a,b);return}function pCa(a,b){a=a|0;b=b|0;var c=0,d=0;c=u;u=u+32|0;d=c;if((a|0)==(b|0)){zpb(d,3,382226,211);xpb(c+24|0,vpb(d,382316)|0);Apb(d)}d=T6b(b,23288,18384,0)|0;if(!d){cOb(b,a);u=c;return}else{aCa(a+24|0,d+24|0);u=c;return}}function qCa(a){a=a|0;var b=0;b=f[a+36>>2]|0;return (di[f[(f[b>>2]|0)+84>>2]&1023](b)|0)+76|0}function rCa(a,b){a=a|0;b=b|0;f[a>>2]=f[b+4>>2];f[a+4>>2]=f[b+8>>2];return}function sCa(a){a=a|0;return f[a+32>>2]|0}function tCa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;d=a+28|0;e=f[d>>2]|0;if(!e){zpb(c,3,381912,139);xpb(b+24|0,vpb(c,382007)|0);Apb(c);g=f[d>>2]|0}else g=e;e=f[a+36>>2]|0;u=b;return (e|0?e:f[g+12>>2]|0)|0}function uCa(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=107040;e=a+4|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;vCa(a+24|0);if((a|0)!=491912?(f[212959]|0)!=2:0){f[d>>2]=135812;f[d+4>>2]=10;b[d+8>>0]=0;Gpb(851836,d);hpb(d)}f[a+40>>2]=12;f[a+36>>2]=851864;f[a+68>>2]=497760;f[a+72>>2]=497760;f[a+76>>2]=497760;f[a+80>>2]=0;u=c;return}function vCa(a){a=a|0;var c=0,d=0;f[a>>2]=140148;c=a+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;Bpb(a+20|0);f[a+24>>2]=0;f[a>>2]=107196;c=a+28|0;f[c>>2]=107148;f[a+32>>2]=0;d=L5b(16)|0;f[d>>2]=0;f[d+4>>2]=0;b[d+8>>0]=1;Fxa(d);f[a+36>>2]=d;d=(di[f[(f[c>>2]|0)+36>>2]&1023](c)|0)+4|0;f[d>>2]=0;f[a>>2]=107280;f[c>>2]=107384;f[a+40>>2]=0;return}function wCa(){var a=0,c=0;a=u;u=u+16|0;c=a;if((f[212961]|0)==2){u=a;return}f[c>>2]=135812;f[c+4>>2]=8;b[c+8>>0]=0;Gpb(851844,c);hpb(c);u=a;return}function xCa(a){a=a|0;var b=0;f[a>>2]=107148;b=f[a+8>>2]|0;if(!b)return;txa(b);O5b(b);return}function yCa(a){a=a|0;var b=0;f[a>>2]=107148;b=f[a+8>>2]|0;if(!b){O5b(a);return}txa(b);O5b(b);O5b(a);return}function zCa(a){a=a|0;return f[a+8>>2]|0}function ACa(a){a=a|0;return f[a+8>>2]|0}function BCa(a){a=a|0;var c=0,d=0,e=0;c=f[a+8>>2]|0;a=c+12|0;if(!(b[c+8>>0]|0)){d=f[a>>2]|0;e=f[d>>2]|0;return e|0}else{d=(f[a>>2]|0)+20|0;e=f[d>>2]|0;return e|0}return 0}function CCa(a){a=a|0;yxa(f[a+8>>2]|0);return}function DCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+32|0;e=d;g=c+8|0;c=f[g>>2]|0;if(!(b[c+8>>0]|0)){h=f[c+12>>2]|0;i=f[h+12>>2]|0;j=f[h+4>>2]|0;a:do if(j>>>0>i>>>0){k=f[h+16>>2]|0;l=i;while(1){m=f[k+(l<<2)>>2]|0;if(m|0)break;n=l+1|0;if(n>>>0<j>>>0)l=n;else{o=0;p=n;q=0;break a}}if((m|0)==(f[k+((l^1)<<2)>>2]|0)){n=f[m>>2]|0;o=f[n+16>>2]|0;p=l;q=n;break}else{o=m;p=l;q=0;break}}else{o=0;p=i;q=0}while(0);i=e+4|0;f[i>>2]=o;f[e+8>>2]=h;f[e+12>>2]=p;f[e+16>>2]=q;q=e+20|0;f[q>>2]=0;p=e+20|0;r=q;s=p;t=p;v=i;w=e+4|0;x=2}else{i=f[(f[c+12>>2]|0)+12>>2]|0;p=e+4|0;f[p>>2]=0;q=e+20|0;f[q>>2]=i;r=e+20|0;s=q;t=q;v=e+4|0;w=p;x=1}f[e>>2]=x;p=a+8|0;a=c;c=x;b:while(1){c:do if((c|0)==(((b[a+8>>0]|0)==0?2:1)|0))switch(c|0){case 0:{y=16;break b;break}case 1:{if(!(f[r>>2]|0)){y=16;break b}else break c;break}default:if(!(f[w>>2]|0)){y=16;break b}else break c}while(0);l=f[((c|0)==1?(f[s>>2]|0)+20|0:(f[w>>2]|0)+12|0)>>2]|0;jHa(HCa(f[p>>2]|0,l)|0,l+16|0);if((f[e>>2]|0)==1){f[t>>2]=f[f[s>>2]>>2];z=1}else{uxa(v)|0;z=f[e>>2]|0}a=f[g>>2]|0;c=z}if((y|0)==16){u=d;return}}function ECa(a,b){a=a|0;b=b|0;var c=0;c=a+8|0;a=b+8|0;b=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=b;return}function FCa(a){a=a|0;return f[a+8>>2]|0}function GCa(a){a=a|0;return f[a+8>>2]|0}function HCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+48|0;e=d+24|0;g=d;h=a+12|0;if(!(b[a+8>>0]|0)){i=f[h>>2]|0;X5b(e,c);f[e+12>>2]=0;Jxa(g,i,e);i=(f[g>>2]|0)+12|0;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);j=i}else j=Ixa(f[h>>2]|0,c)|0;h=f[j>>2]|0;if(h|0){k=h;l=k+16|0;u=d;return l|0}h=Kxa(a,c)|0;f[j>>2]=h;k=h;l=k+16|0;u=d;return l|0}function ICa(a){a=a|0;var b=0;f[a+28>>2]=107148;b=f[a+36>>2]|0;if(!b){QIb(a);return}txa(b);O5b(b);QIb(a);return}function JCa(a){a=a|0;ICa(a);O5b(a);return}function KCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+32|0;e=d+12|0;g=d;h=di[f[(f[a>>2]|0)+64>>2]&1023](a)|0;X5b(g,xDa(c)|0);c=h+8|0;if(!(b[c>>0]|0)){wxa(e,f[h+12>>2]|0,g);i=2;j=0;k=f[e>>2]|0}else{i=1;j=Hxa(f[h+12>>2]|0,g)|0;k=0}do if((i|0)==(((b[c>>0]|0)==0?2:1)|0))if((i|0)==1){l=(j|0)==0;break}else{l=(k|0)==0;break}else l=0;while(0);k=l^1;if((b[g+11>>0]|0)>=0){u=d;return k|0}O5b(f[g>>2]|0);u=d;return k|0}function LCa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=u;u=u+32|0;g=e+12|0;h=e;i=di[f[(f[a>>2]|0)+68>>2]&1023](a)|0;X5b(h,xDa(c)|0);c=i+8|0;if(!(b[c>>0]|0)){wxa(g,f[i+12>>2]|0,h);j=2;k=0;l=f[g>>2]|0}else{j=1;k=Hxa(f[i+12>>2]|0,h)|0;l=0}g=(b[c>>0]|0)==0;do if(((g?2:1)|0)==(j|0)){if(g){if(l|0){m=9;break}}else if(k|0){m=9;break}n=1;o=HCa(i,h)|0}else m=9;while(0);if((m|0)==9){n=0;o=(f[((j|0)==1?k+20|0:l+12|0)>>2]|0)+16|0}f[d>>2]=o;if((b[h+11>>0]|0)>=0){u=e;return n|0}O5b(f[h>>2]|0);u=e;return n|0}function MCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+96|0;e=d+64|0;g=d+40|0;h=d+16|0;i=d;X5b(i,xDa(c)|0);c=di[f[(f[a>>2]|0)+68>>2]&1023](a)|0;a=c+8|0;if(!(b[a>>0]|0)){wxa(e,f[c+12>>2]|0,i);j=2;k=f[e+12>>2]|0;l=0;m=f[e>>2]|0;n=f[e+4>>2]|0;o=f[e+8>>2]|0}else{j=1;k=0;l=Hxa(f[c+12>>2]|0,i)|0;m=0;n=0;o=0}a:do if((j|0)==(((b[a>>0]|0)==0?2:1)|0))switch(j&3){case 0:{p=0;break a;break}case 1:{if(!l){p=0;break a}else{q=8;break a}break}default:if(!m){p=0;break a}else{q=8;break a}}else q=8;while(0);if((q|0)==8){f[g>>2]=j;f[g+4>>2]=m;f[g+8>>2]=n;f[g+12>>2]=o;f[g+16>>2]=k;f[g+20>>2]=l;f[e>>2]=f[g>>2];f[e+4>>2]=f[g+4>>2];f[e+8>>2]=f[g+8>>2];f[e+12>>2]=f[g+12>>2];f[e+16>>2]=f[g+16>>2];f[e+20>>2]=f[g+20>>2];Bxa(h,c,e);p=1}if((b[i+11>>0]|0)>=0){u=d;return p|0}O5b(f[i>>2]|0);u=d;return p|0}function NCa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=f[b>>2]|0;b=f[c>>2]|0;c=f[a>>2]|0;if((c|0)!=(f[b>>2]|0)){d=0;return d|0}switch(c|0){case 1:{d=(f[a+20>>2]|0)==(f[b+20>>2]|0);return d|0}case 0:{d=1;return d|0}default:{d=(f[a+4>>2]|0)==(f[b+4>>2]|0);return d|0}}return 0}function OCa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=di[f[(f[a>>2]|0)+64>>2]&1023](a)|0;if(!(b[d+8>>0]|0)){e=f[d+12>>2]|0;g=f[e+12>>2]|0;h=f[e+4>>2]|0;a:do if(h>>>0>g>>>0){i=f[e+16>>2]|0;j=g;while(1){k=f[i+(j<<2)>>2]|0;if(k|0)break;l=j+1|0;if(l>>>0<h>>>0)j=l;else{m=0;n=l;o=0;break a}}if((k|0)==(f[i+((j^1)<<2)>>2]|0)){l=f[k>>2]|0;m=f[l+16>>2]|0;n=j;o=l;break}else{m=k;n=j;o=0;break}}else{m=0;n=g;o=0}while(0);p=2;q=0;r=m;s=e;t=n;u=o}else{p=1;q=f[(f[d+12>>2]|0)+12>>2]|0;r=0;s=0;t=0;u=0}d=f[c>>2]|0;f[d>>2]=p;f[d+4>>2]=r;f[d+8>>2]=s;f[d+12>>2]=t;f[d+16>>2]=u;f[d+20>>2]=q;zh[f[(f[a>>2]|0)+72>>2]&2047](a,c);return}function PCa(a,c){a=a|0;c=c|0;var d=0;d=(di[f[(f[a>>2]|0)+64>>2]&1023](a)|0)+8|0;a=f[c>>2]|0;f[a>>2]=(b[d>>0]|0)==0?2:1;f[a+4>>2]=0;f[a+20>>2]=0;return}function QCa(a){a=a|0;var c=0,d=0,e=0;tKb(a);c=f[a+36>>2]|0;a=c+12|0;if(!(b[c+8>>0]|0)){d=f[a>>2]|0;e=f[d>>2]|0;return e|0}else{d=(f[a>>2]|0)+20|0;e=f[d>>2]|0;return e|0}return 0}function RCa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;c=u;u=u+32|0;d=c;e=f[a+8>>2]|0;if(!e)g=16;else{h=f[e+8>>2]<<2;i=e+12|0;e=f[i>>2]|0;if(!e)j=h;else{if((f[e>>2]|0)>0){k=0;l=h;m=e;while(1){e=f[m+4+(k<<2)>>2]|0;n=(di[f[(f[e>>2]|0)+84>>2]&1023](e)|0)+l|0;k=k+1|0;m=f[i>>2]|0;if((k|0)>=(f[m>>2]|0)){o=n;break}else l=n}}else o=h;j=o+4|0}g=j+16|0}j=di[f[(f[a>>2]|0)+92>>2]&1023](a)|0;a=j+8|0;if(!(b[a>>0]|0)){o=f[j+12>>2]|0;h=f[o+12>>2]|0;l=f[o+4>>2]|0;a:do if(l>>>0>h>>>0){m=f[o+16>>2]|0;k=h;while(1){p=f[m+(k<<2)>>2]|0;if(p|0)break;i=k+1|0;if(i>>>0<l>>>0)k=i;else{q=0;r=i;s=0;break a}}if((p|0)==(f[m+((k^1)<<2)>>2]|0)){i=f[p>>2]|0;q=f[i+16>>2]|0;r=k;s=i;break}else{q=p;r=k;s=0;break}}else{q=0;r=h;s=0}while(0);f[d>>2]=2;h=d+4|0;f[h>>2]=q;f[d+8>>2]=o;f[d+12>>2]=r;f[d+16>>2]=s;s=d+20|0;f[s>>2]=0;r=d+20|0;t=d+4|0;v=s;w=r;x=r;y=h;z=d;A=2}else{h=f[(f[j+12>>2]|0)+12>>2]|0;f[d>>2]=1;j=d+4|0;f[j>>2]=0;r=d+20|0;f[r>>2]=h;t=j;v=d+20|0;w=r;x=r;y=d+4|0;z=d;A=1}d=g;g=A;b:while(1){c:do if((g|0)==(((b[a>>0]|0)==0?2:1)|0))switch(g|0){case 0:{B=22;break b;break}case 1:{if(!(f[v>>2]|0)){B=22;break b}else break c;break}default:if(!(f[t>>2]|0)){B=22;break b}else break c}while(0);k=(f[((g|0)==1?(f[w>>2]|0)+20|0:(f[t>>2]|0)+12|0)>>2]|0)+16|0;m=d+12+(di[f[(f[k>>2]|0)+84>>2]&1023](k)|0)|0;if((f[z>>2]|0)==1){f[x>>2]=f[f[w>>2]>>2];d=m;g=1;continue}else{Cxa(y)|0;d=m;g=f[z>>2]|0;continue}}if((B|0)==22){u=c;return d|0}return 0}function SCa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;c=u;u=u+64|0;d=c;e=c+32|0;g=c+8|0;h=c+56|0;i=a+8|0;if(!(f[i>>2]|0)){j=f[a+4>>2]|0;if(j){f[d>>2]=0;k=pDa(d)|0;d=znb(j,18456,16)|0;f[d>>2]=j;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if(k)l=d;else{xnb(j,d,1492);l=d}}else{d=L5b(16)|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;l=d}f[i>>2]=l}l=di[f[(f[a>>2]|0)+88>>2]&1023](a)|0;d=f[i>>2]|0;i=d+4|0;j=f[i>>2]|0;if((j|0)>0){k=f[d+12>>2]|0;m=0;do{n=f[k+4+(m<<2)>>2]|0;m=m+1|0;bi[f[(f[n>>2]|0)+28>>2]&2047](n)}while((m|0)!=(j|0));f[i>>2]=0}j=l+8|0;if(!(b[j>>0]|0)){m=f[l+12>>2]|0;k=f[m+12>>2]|0;n=f[m+4>>2]|0;a:do if(n>>>0>k>>>0){o=f[m+16>>2]|0;p=k;while(1){q=f[o+(p<<2)>>2]|0;if(q|0)break;r=p+1|0;if(r>>>0<n>>>0)p=r;else{s=0;t=r;v=0;break a}}if((q|0)==(f[o+((p^1)<<2)>>2]|0)){r=f[q>>2]|0;s=f[r+16>>2]|0;t=p;v=r;break}else{s=q;t=p;v=0;break}}else{s=0;t=k;v=0}while(0);k=e+4|0;f[k>>2]=s;f[e+8>>2]=m;f[e+12>>2]=t;f[e+16>>2]=v;v=e+20|0;f[v>>2]=0;f[e>>2]=2;t=e+20|0;w=e+4|0;x=v;y=t;z=t;A=k;B=e;C=2}else{k=f[(f[l+12>>2]|0)+12>>2]|0;f[e>>2]=1;l=e+4|0;f[l>>2]=0;t=e+20|0;f[t>>2]=k;w=l;x=e+20|0;y=t;z=t;A=e+4|0;B=e;C=1}e=a+40|0;t=a+4|0;l=d+12|0;k=d+8|0;v=C;b:while(1){c:do if((v|0)==(((b[j>>0]|0)==0?2:1)|0))switch(v|0){case 0:{D=26;break b;break}case 1:{if(!(f[x>>2]|0)){D=26;break b}else break c;break}default:if(!(f[w>>2]|0)){D=26;break b}else break c}while(0);rDa(a);p=f[e>>2]|0;if(!p){zpb(g,3,382821,414);xpb(h,vpb(g,382969)|0);Apb(g);E=f[e>>2]|0}else E=p;p=Uh[f[(f[E>>2]|0)+16>>2]&1023](E,f[t>>2]|0)|0;o=p+40|0;C=f[o>>2]|0;m=f[d>>2]|0;if(((m|0)==(C|0)?(s=f[l>>2]|0,(s|0)!=0):0)?(q=f[s>>2]|0,(q|0)<(f[k>>2]|0)):0){n=f[i>>2]|0;if((n|0)<(q|0)){r=s+4+(n<<2)|0;f[s+4+(q<<2)>>2]=f[r>>2];F=r}else F=s+4+(n<<2)|0;f[F>>2]=p;f[i>>2]=n+1;n=f[l>>2]|0;f[n>>2]=(f[n>>2]|0)+1}else sDa(d,p,C,m);m=f[((f[B>>2]|0)==1?(f[y>>2]|0)+20|0:(f[w>>2]|0)+12|0)>>2]|0;C=p+44|0;f[C>>2]=f[C>>2]|1;n=p+32|0;s=f[n>>2]|0;if((s|0)==497760){dya(n,f[o>>2]|0,497760);G=f[n>>2]|0}else G=s;_5b(G,m)|0;m=(f[((f[B>>2]|0)==1?(f[y>>2]|0)+20|0:(f[w>>2]|0)+12|0)>>2]|0)+16|0;f[C>>2]=f[C>>2]|2;C=p+36|0;p=f[o>>2]|0;o=f[C>>2]|0;if(!o){if(!p){s=L5b(24)|0;bHa(s);H=s}else{s=znb(p,18600,24)|0;gHa(s,p);H=s}f[C>>2]=H;I=H}else I=o;jHa(I,m);if((f[B>>2]|0)==1){f[z>>2]=f[f[y>>2]>>2];v=1;continue}else{uxa(A)|0;v=f[B>>2]|0;continue}}if((D|0)==26){u=c;return}}function TCa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0;b=u;u=u+32|0;c=b;d=di[f[(f[a>>2]|0)+92>>2]&1023](a)|0;e=f[a+8>>2]|0;if(!e){zpb(c,3,382821,434);xpb(b+24|0,vpb(c,382915)|0);Apb(c)}yxa(d);c=e+12|0;a=f[c>>2]|0;g=e+4|0;if(!(f[g>>2]|0)){u=b;return}e=(a|0)==0?0:a+4|0;do{a=f[e>>2]|0;h=di[f[(f[a>>2]|0)+104>>2]&1023](a)|0;a=f[e>>2]|0;jHa(HCa(d,di[f[(f[a>>2]|0)+100>>2]&1023](a)|0)|0,h);e=e+4|0;h=f[c>>2]|0}while((e|0)!=(((h|0)==0?0:h+4|0)+(f[g>>2]<<2)|0));u=b;return}function UCa(a,b){a=a|0;b=b|0;a=L5b(24)|0;f[a>>2]=0;f[a+4>>2]=0;f[a+20>>2]=0;f[b>>2]=a;return}function VCa(a,b){a=a|0;b=b|0;a=f[b>>2]|0;if(!a)return;O5b(a);return}function WCa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=f[d>>2]|0;g=f[c>>2]|0;f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];f[g+16>>2]=f[e+16>>2];f[g+20>>2]=f[e+20>>2];e=c+8|0;g=oDa(d+8|0)|0;h=c+16|0;i=f[h>>2]|0;if((i|0)!=(g|0)){if((i|0)==9?(i=f[e>>2]|0,i|0):0){if((b[i+11>>0]|0)<0)O5b(f[i>>2]|0);O5b(i)}f[h>>2]=g;if((g|0)==9){g=L5b(12)|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[e>>2]=g}}f[c+28>>2]=f[d+28>>2];zh[f[(f[a>>2]|0)+72>>2]&2047](a,c);return}function XCa(a,b){a=a|0;b=b|0;var c=0,d=0;c=f[b>>2]|0;if((f[c>>2]|0)==1){d=c+20|0;f[d>>2]=f[f[d>>2]>>2]}else uxa(c+4|0)|0;zh[f[(f[a>>2]|0)+72>>2]&2047](a,b);return}function YCa(a){a=a|0;tKb(a);return f[a+36>>2]|0}function ZCa(a){a=a|0;var b=0;tKb(a);b=f[a+36>>2]|0;sKb(a);return b|0}function _Ca(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=di[f[(f[a>>2]|0)+64>>2]&1023](a)|0;a=f[c>>2]|0;e=f[a>>2]|0;g=f[a+4>>2]|0;h=f[a+20>>2]|0;a:do if((e|0)!=(((b[d+8>>0]|0)==0?2:1)|0)){a=c+8|0;if((e|0)==1){i=a;j=8}else{k=a;j=9}}else switch(e|0){case 1:{if(!h)return;else{i=c+8|0;j=8;break a}break}case 0:return;default:if(!g)return;else{k=c+8|0;j=9;break a}}while(0);if((j|0)==8){l=h+20|0;m=i;n=1}else if((j|0)==9){l=g+12|0;m=k;n=0}k=f[l>>2]|0;l=m+8|0;if((f[l>>2]|0)==9)o=f[m>>2]|0;else{f[l>>2]=9;l=L5b(12)|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[m>>2]=l;o=l}_5b(o,k)|0;f[c+24>>2]=(f[(n?h+20|0:g+12|0)>>2]|0)+16;return}function $Ca(a){a=a|0;tKb(a);yxa(f[a+36>>2]|0);sKb(a);return}function aDa(a,b){a=a|0;b=b|0;tKb(a);tKb(b+-28|0);DCa(a+28|0,b);sKb(a);return}function bDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;e=(b|0)==0?0:b+-28|0;g=a+8|0;h=e+8|0;i=f[g>>2]|0;f[g>>2]=f[h>>2];f[h>>2]=i;i=a+36|0;h=b+8|0;b=f[i>>2]|0;f[i>>2]=f[h>>2];f[h>>2]=b;b=a+24|0;a=e+24|0;f[d>>2]=f[b>>2];f[b>>2]=f[a>>2];f[a>>2]=f[d>>2];u=c;return}function cDa(a){a=a|0;return f[a+36>>2]|0}function dDa(a){a=a|0;return f[a+36>>2]|0}function eDa(a){a=a|0;var b=0;b=a+-28|0;f[b+28>>2]=107148;a=f[b+36>>2]|0;if(!a){QIb(b);return}txa(a);O5b(a);QIb(b);return}function fDa(a){a=a|0;var b=0;b=a+-28|0;f[b+28>>2]=107148;a=f[b+36>>2]|0;if(a|0){txa(a);O5b(a)}QIb(b);O5b(b);return}function gDa(a){a=a|0;var b=0;b=a+-28|0;tKb(b);return f[b+36>>2]|0}function hDa(a){a=a|0;var b=0;b=a+-28|0;tKb(b);a=f[b+36>>2]|0;sKb(b);return a|0}function iDa(a){a=a|0;var c=0,d=0,e=0;c=a+-28|0;tKb(c);a=f[c+36>>2]|0;c=a+12|0;if(!(b[a+8>>0]|0)){d=f[c>>2]|0;e=f[d>>2]|0;return e|0}else{d=(f[c>>2]|0)+20|0;e=f[d>>2]|0;return e|0}return 0}function jDa(a){a=a|0;var b=0;b=a+-28|0;tKb(b);yxa(f[b+36>>2]|0);sKb(b);return}function kDa(a,b){a=a|0;b=b|0;var c=0;c=a+-28|0;tKb(c);tKb(b+-28|0);DCa(c+28|0,b);sKb(c);return}function lDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=u;u=u+16|0;d=c;e=a+-28|0;a=(b|0)==0?0:b+-28|0;g=e+8|0;h=a+8|0;i=f[g>>2]|0;f[g>>2]=f[h>>2];f[h>>2]=i;i=e+36|0;h=b+8|0;b=f[i>>2]|0;f[i>>2]=f[h>>2];f[h>>2]=b;b=e+24|0;e=a+24|0;f[d>>2]=f[b>>2];f[b>>2]=f[e>>2];f[e>>2]=f[d>>2];u=c;return}function mDa(a){a=a|0;return f[a+-28+36>>2]|0}function nDa(a){a=a|0;return f[a+-28+36>>2]|0}function oDa(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+32|0;c=b;d=a+8|0;a=f[d>>2]|0;if(a|0){e=a;u=b;return e|0}zpb(c,3,471595,116);xpb(b+24|0,vpb(vpb(vpb(c,471718)|0,382741)|0,382782)|0);Apb(c);e=f[d>>2]|0;u=b;return e|0}function pDa(a){a=a|0;return 0}function qDa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=a+12|0;c=f[b>>2]|0;if(!c){f[b>>2]=0;return}if(f[a>>2]|0){f[b>>2]=0;return}a=f[c>>2]|0;if((a|0)>0){d=0;do{e=f[c+4+(d<<2)>>2]|0;if(e|0)bi[f[(f[e>>2]|0)+4>>2]&2047](e);d=d+1|0}while((d|0)!=(a|0));g=f[b>>2]|0}else g=c;O5b(g);f[b>>2]=0;return}function rDa(a){a=a|0;var b=0,c=0,d=0,e=0;b=u;u=u+32|0;c=b;d=a+40|0;if(f[d>>2]|0){u=b;return}rKb(a);e=a+12|0;if(!(f[f[e>>2]>>2]|0)){zpb(c,3,382821,478);xpb(b+24|0,vpb(c,383008)|0);Apb(c)}c=LNb()|0;a=Uh[f[(f[c>>2]|0)+8>>2]&1023](c,f[f[e>>2]>>2]|0)|0;f[d>>2]=a;u=b;return}function sDa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!((c|0)==0&(d|0)!=0))if((d|0)!=(c|0)){e=uDa(b,d)|0;vDa(b,e);if((b|0)==0|(c|0)!=0)g=e;else{bi[f[(f[b>>2]|0)+4>>2]&2047](b);g=e}}else g=b;else{tDa(d,b);g=b}b=a+12|0;d=f[b>>2]|0;e=f[a+8>>2]|0;c=a+4|0;do if((d|0)!=0?(h=f[c>>2]|0,(h|0)!=(e|0)):0){i=f[d>>2]|0;if((i|0)==(e|0)){j=f[d+4+(h<<2)>>2]|0;if((j|0)==0|(f[a>>2]|0)!=0){k=d;break}bi[f[(f[j>>2]|0)+4>>2]&2047](j);k=f[b>>2]|0;break}if((h|0)<(i|0)){f[d+4+(i<<2)>>2]=f[d+4+(h<<2)>>2];h=f[b>>2]|0;l=h;m=f[h>>2]|0}else{l=d;m=i}f[l>>2]=m+1;k=l}else n=8;while(0);if((n|0)==8){cpb(a,e+1|0);e=f[b>>2]|0;f[e>>2]=(f[e>>2]|0)+1;k=e}e=f[c>>2]|0;f[c>>2]=e+1;f[k+4+(e<<2)>>2]=g;return}function tDa(a,b){a=a|0;b=b|0;if(!b)return;xnb(a,b,1493);return}function uDa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;if(!b){a=L5b(48)|0;f[a+4>>2]=0;f[a+8>>2]=0;f[a>>2]=106828;f[a+12>>2]=0;f[a+16>>2]=0;f[a+20>>2]=0;f[a+24>>2]=106944;f[a+28>>2]=0;f[a+40>>2]=0;c=a;d=c+32|0;f[d>>2]=497760;e=c+36|0;f[e>>2]=0;g=c+44|0;f[g>>2]=0;return c|0}else{a=b;h=znb(b,18384,48)|0;f[h+4>>2]=0;f[h+8>>2]=0;f[h>>2]=106828;f[h+12>>2]=0;f[h+16>>2]=a;f[h+20>>2]=0;f[h+24>>2]=106944;f[h+28>>2]=0;f[h+40>>2]=a;c=h;d=c+32|0;f[d>>2]=497760;e=c+36|0;f[e>>2]=0;g=c+44|0;f[g>>2]=0;return c|0}return 0}function vDa(a,b){a=a|0;b=b|0;aCa(b+24|0,a+24|0);return}function wDa(a){a=a|0;if(!a)return;bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function xDa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0;b=u;u=u+32|0;c=b;if((oDa(a)|0)==9){d=f[a>>2]|0;u=b;return d|0}zpb(c,3,471595,176);e=vpb(vpb(vpb(vpb(c,471718)|0,383167)|0,471773)|0,471795)|0;g=vpb(vpb(vpb(e,f[34047]|0)|0,475789)|0,471809)|0;e=136152+((oDa(a)|0)<<2)|0;xpb(b+24|0,vpb(g,f[e>>2]|0)|0);Apb(c);d=f[a>>2]|0;u=b;return d|0}function yDa(a){a=a|0;QIb(a);O5b(a);return}function zDa(a){a=a|0;return}function ADa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;f[a>>2]=107040;iEa(a);f[a+52>>2]=107148;c=f[a+60>>2]|0;if(c|0){txa(c);O5b(c)}QIb(a+24|0);c=a+20|0;d=f[c>>2]|0;if(d|0?(f[a+8>>2]|0)==0:0){e=f[d>>2]|0;if((e|0)>0){g=0;do{h=f[d+4+(g<<2)>>2]|0;if(h|0){if((b[h+11>>0]|0)<0)O5b(f[h>>2]|0);O5b(h)}g=g+1|0}while((g|0)!=(e|0));i=f[c>>2]|0}else i=d;O5b(i)}f[c>>2]=0;c=a+4|0;a=f[c>>2]|0;if(!(a&1)){f[c>>2]=0;return}i=a&-2;a=i;if((i|0)==0|(f[a+4>>2]|0)!=0){f[c>>2]=0;return}if(f[a>>2]|0)GPb(a);O5b(i);f[c>>2]=0;return}function BDa(a){a=a|0;ADa(a);O5b(a);return}function CDa(a){a=a|0;return Uh[f[(f[a>>2]|0)+16>>2]&1023](a,0)|0}function DDa(a,b){a=a|0;b=b|0;var c=0;if(!b){a=L5b(84)|0;uCa(a);c=a;return c|0}else{a=znb(b,18496,84)|0;fEa(a,b);c=a;return c|0}return 0}function EDa(a){a=a|0;var b=0,c=0;b=f[a+4>>2]|0;a=b&-2;if(!(b&1)){c=a;return c|0}else{c=f[a+4>>2]|0;return c|0}return 0}function FDa(a){a=a|0;return f[a+4>>2]|0}function GDa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=f[a+68>>2]|0;do if((c|0)!=497760){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+72>>2]|0;do if((c|0)!=497760){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=f[a+76>>2]|0;do if((c|0)!=497760){d=c+11|0;if((b[d>>0]|0)<0){b[f[c>>2]>>0]=0;f[c+4>>2]=0;break}else{b[c>>0]=0;b[d>>0]=0;break}}while(0);c=a+12|0;d=f[c>>2]|0;if((d|0)>0){e=f[a+20>>2]|0;g=0;do{h=f[e+4+(g<<2)>>2]|0;g=g+1|0;i=h+11|0;if((b[i>>0]|0)<0){b[f[h>>2]>>0]=0;f[h+4>>2]=0}else{b[h>>0]=0;b[i>>0]=0}}while((g|0)!=(d|0));f[c>>2]=0}c=a+24|0;tKb(c);yxa(f[a+60>>2]|0);sKb(c);return}function HDa(a){a=a|0;return 1}function IDa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;d=u;u=u+48|0;e=d+32|0;g=d;h=c+4|0;i=c+20|0;j=a+68|0;k=a+4|0;l=a+68|0;m=a+72|0;n=a+72|0;o=a+8|0;p=a+12|0;q=a+20|0;r=a+76|0;s=a+76|0;t=c+44|0;v=a+24|0;a=g+4|0;w=g+8|0;x=g+24|0;y=e+4|0;z=w+11|0;A=g+12|0;B=c+32|0;C=c+12|0;D=c+28|0;a:while(1){E=f[c>>2]|0;if(E>>>0<(f[h>>2]|0)>>>0){F=b[E>>0]|0;G=F&255;if(F<<24>>24>0){f[i>>2]=G;f[c>>2]=E+1;H=G;I=6}else{J=G;I=5}}else{J=0;I=5}if((I|0)==5){I=0;G=_nb(c,J)|0;f[i>>2]=G;if((G+-1|0)>>>0<127){H=G;I=6}else{K=G;I=82}}b:do if((I|0)==6){I=0;switch(H>>>3&536870911|0){case 1:{switch(H|0){case 0:{L=1;I=86;break a;break}case 10:break;default:{M=H;break b}}G=f[k>>2]|0;E=G&-2;if(!(G&1))N=E;else N=f[E+4>>2]|0;E=f[j>>2]|0;if((E|0)==497760){dya(j,N,497760);O=f[j>>2]|0}else O=E;if(!(fqb(c,O)|0)){L=0;I=86;break a}E=f[l>>2]|0;G=b[E+11>>0]|0;if(G<<24>>24<0){P=f[E>>2]|0;Q=f[E+4>>2]|0}else{P=E;Q=G&255}if(!(gqb(P,Q,0,383505)|0)){L=0;I=86;break a}G=f[c>>2]|0;if(G>>>0>=(f[h>>2]|0)>>>0)continue a;if((b[G>>0]|0)!=18)continue a;f[c>>2]=G+1;I=22;break}case 2:{switch(H|0){case 0:{L=1;I=86;break a;break}case 18:{I=22;break}default:{M=H;break b}}break}case 3:{switch(H|0){case 0:{L=1;I=86;break a;break}case 26:{I=36;break}default:{M=H;break b}}break}case 4:{switch(H|0){case 0:{L=1;I=86;break a;break}case 34:{I=46;break}default:{M=H;break b}}break}case 5:{switch(H|0){case 0:{L=1;I=86;break a;break}case 42:{I=60;break}default:{M=H;break b}}break}default:{K=H;I=82;break b}}if((I|0)==22){I=0;G=f[k>>2]|0;E=G&-2;if(!(G&1))R=E;else R=f[E+4>>2]|0;E=f[m>>2]|0;if((E|0)==497760){dya(m,R,497760);S=f[m>>2]|0}else S=E;if(!(fqb(c,S)|0)){L=0;I=86;break a}E=f[n>>2]|0;G=b[E+11>>0]|0;if(G<<24>>24<0){T=f[E>>2]|0;U=f[E+4>>2]|0}else{T=E;U=G&255}if(!(gqb(T,U,0,383529)|0)){L=0;I=86;break a}G=f[c>>2]|0;if(G>>>0>=(f[h>>2]|0)>>>0)continue a;if((b[G>>0]|0)==26){V=G;I=35}else continue a}while(1)if((I|0)==35){I=0;f[c>>2]=V+1;I=36;continue}else if((I|0)==36){I=0;if(!(fqb(c,mza(o)|0)|0)){L=0;I=86;break a}G=f[(f[q>>2]|0)+4+((f[p>>2]|0)+-1<<2)>>2]|0;E=b[G+11>>0]|0;if(E<<24>>24<0){W=f[G>>2]|0;X=f[G+4>>2]|0}else{W=G;X=E&255}if(!(gqb(W,X,0,383551)|0)){L=0;I=86;break a}E=f[c>>2]|0;if(E>>>0>=(f[h>>2]|0)>>>0)continue a;if((b[E>>0]|0)==26){V=E;I=35;continue}if((b[E>>0]|0)!=34)continue a;f[c>>2]=E+1;I=46;continue}else if((I|0)==46){I=0;E=f[k>>2]|0;G=E&-2;if(!(E&1))Y=G;else Y=f[G+4>>2]|0;G=f[r>>2]|0;if((G|0)==497760){dya(r,Y,497760);Z=f[r>>2]|0}else Z=G;if(!(fqb(c,Z)|0)){L=0;I=86;break a}G=f[s>>2]|0;E=b[G+11>>0]|0;if(E<<24>>24<0){_=f[G>>2]|0;$=f[G+4>>2]|0}else{_=G;$=E&255}if(!(gqb(_,$,0,383576)|0)){L=0;I=86;break a}E=f[c>>2]|0;if(E>>>0>=(f[h>>2]|0)>>>0)continue a;if((b[E>>0]|0)!=42)continue a;f[c>>2]=E+1;I=60;continue}else if((I|0)==60){I=0;E=f[t>>2]|0;f[t>>2]=E+-1;if((E|0)>0)break;else{L=0;I=86;break a}}while(1){f[g>>2]=v;E=di[f[(f[v>>2]|0)+68>>2]&1023](v)|0;f[a>>2]=E;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[x>>2]=0;E=f[c>>2]|0;if(E>>>0<(f[h>>2]|0)>>>0?(G=b[E>>0]|0,G<<24>>24>-1):0){f[c>>2]=E+1;aa=G&255;I=65}else{G=Znb(c)|0;if((G|0)>-1){aa=G;I=65}else ba=6}do if((I|0)==65){I=0;Inb(e,c,aa);if((f[y>>2]|0)>=0?cEa(g,c)|0:0){if(!(Onb(c,f[e>>2]|0)|0)){ba=6;break}G=b[z>>0]|0;E=G<<24>>24<0;F=gqb(E?f[w>>2]|0:w,E?f[A>>2]|0:G&255,0,383602)|0;ba=F?0:6;break}ba=6}while(0);F=f[x>>2]|0;if(F|0)bi[f[(f[F>>2]|0)+4>>2]&2047](F);if((b[z>>0]|0)<0)O5b(f[w>>2]|0);switch(ba&7){case 6:{L=0;I=86;break a;break}case 0:break;default:{I=85;break a}}ca=f[c>>2]|0;da=f[h>>2]|0;if(ca>>>0>=da>>>0)break;if((b[ca>>0]|0)!=42)break;f[c>>2]=ca+1}f[t>>2]=(f[t>>2]|0)+1;if((ca|0)!=(da|0))continue a;if(f[B>>2]|0){I=81;break a}if((f[C>>2]|0)==(f[D>>2]|0)){I=81;break a}else continue a}while(0);if((I|0)==82){I=0;if(!K){L=1;I=86;break}else M=K}if((M&7|0)==4){L=1;I=86;break}if(!(Lpb(c,M)|0)){L=0;I=86;break}}if((I|0)==81){f[i>>2]=0;b[c+24>>0]=1;L=1;u=d;return L|0}else if((I|0)==85){L=1;u=d;return L|0}else if((I|0)==86){u=d;return L|0}return 0}function JDa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;c=u;u=u+32|0;d=c;e=f[a+68>>2]|0;g=b[e+11>>0]|0;h=g<<24>>24<0;if(h)i=f[e+4>>2]|0;else i=g&255;if(!i)j=0;else{if(h){h=f[e+4>>2]|0;if(h>>>0<128){k=1;l=h}else{k=iob(h)|0;l=h}}else{k=1;l=g&255}j=l+1+k|0}k=f[a+72>>2]|0;l=b[k+11>>0]|0;g=l<<24>>24<0;if(g)m=f[k+4>>2]|0;else m=l&255;if(!m)n=j;else{if(g){g=f[k+4>>2]|0;if(g>>>0<128){o=1;p=g}else{o=iob(g)|0;p=g}}else{o=1;p=l&255}n=j+1+p+o|0}o=f[a+76>>2]|0;p=b[o+11>>0]|0;j=p<<24>>24<0;if(j)q=f[o+4>>2]|0;else q=p&255;if(!q)r=n;else{if(j){j=f[o+4>>2]|0;if(j>>>0<128){s=1;t=j}else{s=iob(j)|0;t=j}}else{s=1;t=p&255}r=n+1+t+s|0}s=a+12|0;t=f[s>>2]|0;n=t+r|0;if((t|0)>0){r=a+20|0;p=0;j=n;o=t;while(1){t=f[(f[r>>2]|0)+4+(p<<2)>>2]|0;q=b[t+11>>0]|0;if(q<<24>>24<0){l=f[t+4>>2]|0;if(l>>>0<128){v=1;w=l;x=o}else{t=iob(l)|0;v=t;w=l;x=f[s>>2]|0}}else{v=1;w=q&255;x=o}q=w+j+v|0;p=p+1|0;if((p|0)>=(x|0)){y=q;break}else{j=q;o=x}}}else y=n;n=a+24|0;tKb(n);x=a+60|0;o=f[x>>2]|0;j=o+12|0;if(!(b[o+8>>0]|0))z=f[j>>2]|0;else z=(f[j>>2]|0)+20|0;j=f[z>>2]|0;tKb(n);z=f[x>>2]|0;o=j+y|0;if(!(b[z+8>>0]|0)){y=f[z+12>>2]|0;j=f[y+12>>2]|0;p=f[y+4>>2]|0;a:do if(p>>>0>j>>>0){v=f[y+16>>2]|0;w=j;while(1){A=f[v+(w<<2)>>2]|0;if(A|0)break;s=w+1|0;if(s>>>0<p>>>0)w=s;else{B=0;C=s;D=0;break a}}if((A|0)==(f[v+((w^1)<<2)>>2]|0)){s=f[A>>2]|0;B=f[s+16>>2]|0;C=w;D=s;break}else{B=A;C=w;D=0;break}}else{B=0;C=j;D=0}while(0);j=d+4|0;f[j>>2]=B;f[d+8>>2]=y;f[d+12>>2]=C;f[d+16>>2]=D;D=d+20|0;f[D>>2]=0;f[d>>2]=2;C=d+20|0;E=d+4|0;F=D;G=C;H=C;I=j;J=d}else{j=f[(f[z+12>>2]|0)+12>>2]|0;f[d>>2]=1;z=d+4|0;f[z>>2]=0;C=d+20|0;f[C>>2]=j;E=z;F=d+20|0;G=C;H=C;I=d+4|0;J=d}d=a+56|0;C=o;o=0;b:while(1){tKb(n);z=(b[(f[x>>2]|0)+8>>0]|0)==0?2:1;j=f[J>>2]|0;c:do if((j|0)==(z|0))switch(z&3){case 0:{break b;break}case 1:{if(!(f[F>>2]|0))break b;else break c;break}default:if(!(f[E>>2]|0))break b;else break c}while(0);if(!o){K=0;L=j}else{z=(di[f[(f[o>>2]|0)+20>>2]&1023](o)|0)==0;K=z?o:0;L=f[J>>2]|0}z=f[((L|0)==1?(f[G>>2]|0)+20|0:(f[E>>2]|0)+12|0)>>2]|0;w=f[d>>2]|0;if(!w){v=L5b(32)|0;f[v+4>>2]=0;f[v+16>>2]=0;M=v}else{v=znb(w,18512,32)|0;f[v+4>>2]=0;f[v+16>>2]=w;M=v}f[M+8>>2]=497760;f[M+12>>2]=0;f[M>>2]=107432;f[M+24>>2]=z;f[M+28>>2]=z+16;f[M+20>>2]=3;if((K|0)!=(M|0))if(!K)N=M;else{bi[f[(f[K>>2]|0)+4>>2]&2047](K);N=M}else N=K;z=N+20|0;v=f[z>>2]|0;if(!(v&1)){O=v;P=0}else{v=di[f[(f[N>>2]|0)+72>>2]&1023](N)|0;w=b[v+11>>0]|0;if(w<<24>>24<0){D=f[v+4>>2]|0;if(D>>>0<128){Q=1;R=D}else{Q=iob(D)|0;R=D}}else{Q=1;R=w&255}O=f[z>>2]|0;P=R+1+Q|0}if(!(O&2))S=0;else{z=zGa(di[f[(f[N>>2]|0)+76>>2]&1023](N)|0)|0;if(z>>>0<128)T=1;else T=iob(z)|0;S=z+1+T|0}z=S+P|0;if(z>>>0<128)U=1;else U=iob(z)|0;w=z+C+U|0;if((f[J>>2]|0)==1){f[H>>2]=f[f[G>>2]>>2];C=w;o=N;continue}else{uxa(I)|0;C=w;o=N;continue}}if(!o){V=a+80|0;f[V>>2]=C;u=c;return C|0}if(di[f[(f[o>>2]|0)+20>>2]&1023](o)|0){V=a+80|0;f[V>>2]=C;u=c;return C|0}bi[f[(f[o>>2]|0)+4>>2]&2047](o);V=a+80|0;f[V>>2]=C;u=c;return C|0}
function Wva(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0;e=u;u=u+272|0;g=e;h=e+260|0;i=e+248|0;j=e+192|0;k=e+136|0;l=e+116|0;m=e+112|0;n=e+104|0;o=e+100|0;p=e+88|0;q=e+80|0;r=e+128|0;s=e+72|0;t=e+108|0;v=e+56|0;f[r>>2]=c;dQ(s,105792);c=a+32|0;w=Jva(c,r)|0;x=w+236|0;if(!(f[x>>2]|0)){y=w+60|0;z=w+64|0;A=f[y>>2]|0;B=(f[z>>2]|0)-A>>3;C=(B|0)==0;a:do if(C)D=w+76|0;else{E=w+72|0;F=w+76|0;G=w+76|0;H=w+80|0;I=0;J=A;while(1){K=J+(I<<3)|0;L=f[F>>2]|0;do if(L){M=f[K>>2]|0;N=G;O=L;while(1){P=f[O+16>>2]|0;if((M|0)<(P|0)){Q=f[O>>2]|0;if(!Q){R=12;break}else{S=O;T=Q}}else{if((P|0)>=(M|0)){R=16;break}U=O+4|0;P=f[U>>2]|0;if(!P){R=15;break}else{S=U;T=P}}N=S;O=T}if((R|0)==12){R=0;V=O;W=O;break}else if((R|0)==15){R=0;V=U;W=O;break}else if((R|0)==16){R=0;V=N;W=O;break}}else{V=F;W=F}while(0);if(!(f[V>>2]|0)){L=L5b(20)|0;f[L+16>>2]=f[K>>2];f[L>>2]=0;f[L+4>>2]=0;f[L+8>>2]=W;f[V>>2]=L;M=f[f[E>>2]>>2]|0;if(!M)X=L;else{f[E>>2]=M;X=f[V>>2]|0}mP(f[G>>2]|0,X);f[H>>2]=(f[H>>2]|0)+1}M=I+1|0;if(M>>>0>=B>>>0){D=F;break a}I=M;J=f[y>>2]|0}}while(0);X=f[w+72>>2]|0;if((X|0)!=(D|0)){V=X;while(1){Wva(a,f[V+16>>2]|0,d);X=f[V+4>>2]|0;if(!X){W=V+8|0;U=f[W>>2]|0;if((f[U>>2]|0)==(V|0))Z=U;else{U=W;do{W=f[U>>2]|0;U=W+8|0;T=f[U>>2]|0}while((f[T>>2]|0)!=(W|0));Z=T}}else{U=X;while(1){T=f[U>>2]|0;if(!T)break;else U=T}Z=U}if((Z|0)==(D|0))break;else V=Z}f[t>>2]=V}V=a+112|0;if(!(f[V>>2]|0))_=(f[a+116>>2]|0)==1;else _=0;t=w+152|0;Z=w+156|0;D=f[Z>>2]|0;X=f[t>>2]|0;T=D-X>>2;W=X;X=D;if(B>>>0<=T>>>0){if(B>>>0<T>>>0?(D=W+(B<<2)|0,(X|0)!=(D|0)):0)f[Z>>2]=X+(~((X+-4-D|0)>>>2)<<2)}else ewa(t,B-T|0);do if(_){T=w+188|0;D=w+192|0;X=f[D>>2]|0;W=f[T>>2]|0;S=(X-W|0)/48|0;A=X;if(B>>>0>S>>>0){TL(T,B-S|0);break}if(B>>>0<S>>>0?(S=W+(B*48|0)|0,(A|0)!=(S|0)):0){W=A;do{A=W+-48|0;f[D>>2]=A;hI(A);W=f[D>>2]|0}while((W|0)!=(S|0))}}while(0);S=w+120|0;W=w+124|0;D=f[W>>2]|0;U=f[S>>2]|0;A=D-U>>3;T=U;U=D;if(B>>>0<=A>>>0){if(B>>>0<A>>>0?(D=T+(B<<3)|0,(U|0)!=(D|0)):0){T=U;do{U=T+-8|0;f[W>>2]=U;X=f[U>>2]|0;if(X|0?(J=X+4|0,I=f[J>>2]|0,f[J>>2]=I+-1,(I|0)==1):0)bi[f[(f[X>>2]|0)+8>>2]&2047](X);f[U>>2]=0;f[T+-4>>2]=0;T=f[W>>2]|0}while((T|0)!=(D|0))}}else fwa(S,B-A|0);if(!C){C=g+4|0;A=w+188|0;D=h+4|0;T=0;do{W=(f[y>>2]|0)+(T<<3)|0;U=f[W>>2]|0;X=f[W+4>>2]|0;W=g;f[W>>2]=U;f[W+4>>2]=X;if((U|X|0)<=-1){f[h>>2]=0;f[D>>2]=0;$=aD(h,12)|0;aa=367690;ba=$+12|0;do{b[$>>0]=b[aa>>0]|0;$=$+1|0;aa=aa+1|0}while(($|0)<(ba|0));bO(-215,h,367703,364488,1101);bD(h)}X=Jva(c,g)|0;f[(f[t>>2]|0)+(T<<2)>>2]=(f[X+140>>2]|0)+((f[C>>2]|0)*56|0);if(_?(X=Jva(c,g)|0,U=f[C>>2]|0,W=f[X+176>>2]|0,X=W+(U*48|0)|0,I=f[A>>2]|0,J=I+(T*48|0)|0,(J|0)!=(X|0)):0){F=W+(U*48|0)+24|0;H=f[F>>2]|0;if(H|0){G=H+8|0;f[G>>2]=(f[G>>2]|0)+1}G=I+(T*48|0)+24|0;H=f[G>>2]|0;if(H|0?(E=H+8|0,H=f[E>>2]|0,f[E>>2]=H+-1,(H|0)==1):0)iI(J);H=I+(T*48|0)+4|0;if((f[H>>2]|0)>0){E=f[I+(T*48|0)+32>>2]|0;M=0;do{f[E+(M<<2)>>2]=0;M=M+1|0;ca=f[H>>2]|0}while((M|0)<(ca|0));f[G>>2]=0;f[J>>2]=f[X>>2];if((ca|0)<3)R=74;else R=76}else{f[G>>2]=0;f[J>>2]=f[X>>2];R=74}if((R|0)==74){R=0;M=f[W+(U*48|0)+4>>2]|0;if((M|0)<3){f[H>>2]=M;f[I+(T*48|0)+8>>2]=f[W+(U*48|0)+8>>2];f[I+(T*48|0)+12>>2]=f[W+(U*48|0)+12>>2];M=f[W+(U*48|0)+36>>2]|0;E=f[I+(T*48|0)+36>>2]|0;f[E>>2]=f[M>>2];f[E+4>>2]=f[M+4>>2]}else R=76}if((R|0)==76){R=0;gI(J,X)}f[I+(T*48|0)+16>>2]=f[W+(U*48|0)+16>>2];M=I+(T*48|0)+20|0;if(!(f[M>>2]|0))f[M>>2]=f[W+(U*48|0)+20>>2];f[G>>2]=f[F>>2];f[I+(T*48|0)+28>>2]=f[W+(U*48|0)+28>>2]}M=Jva(c,g)|0;E=f[C>>2]|0;L=f[M+108>>2]|0;M=f[S>>2]|0;P=M+(T<<3)|0;Q=f[L+(E<<3)>>2]|0;da=f[L+(E<<3)+4>>2]|0;if(Q|0){E=Q+4|0;f[E>>2]=(f[E>>2]|0)+1}E=f[P>>2]|0;f[P>>2]=Q;f[M+(T<<3)+4>>2]=da;if(E|0?(da=E+4|0,M=f[da>>2]|0,f[da>>2]=M+-1,(M|0)==1):0)bi[f[(f[E>>2]|0)+8>>2]&2047](E);T=T+1|0}while(T>>>0<B>>>0)}B=f[r>>2]|0;r=d+4|0;d=f[r>>2]|0;if(d){T=r;S=d;b:while(1){d=S;while(1){if((f[d+16>>2]|0)>=(B|0))break;C=f[d+4>>2]|0;if(!C){ea=T;break b}else d=C}S=f[d>>2]|0;if(!S){ea=d;break}else T=d}if((ea|0)!=(r|0)?(f[ea+16>>2]|0)<=(B|0):0)fa=ea;else R=86}else R=86;if((R|0)==86){f[g>>2]=0;f[g+4>>2]=0;$=aD(g,35)|0;aa=367717;ba=$+35|0;do{b[$>>0]=b[aa>>0]|0;$=$+1|0;aa=aa+1|0}while(($|0)<(ba|0));bO(-215,g,367703,364488,1111);bD(g);fa=r}f[v>>2]=0;r=v+4|0;f[r>>2]=0;f[v+8>>2]=0;ea=a+56|0;B=(f[V>>2]|0)==1;dQ(j,105812);if(!(f[a+108>>2]|0))ga=(f[a+104>>2]|0)==1;else ga=0;V=f[v>>2]|0;T=f[r>>2]|0;if((T|0)!=(V|0))f[r>>2]=T+(~((T+-8-V|0)>>>3)<<3);V=w+140|0;T=w+164|0;S=w+176|0;U=w+200|0;W=fa+32|0;gwa(k,fa+44|0);I=fa+36|0;F=((f[I>>2]|0)-(f[W>>2]|0)|0)/12|0;SL(V,F>>>0>1?F:1);F=k+4|0;SL(T,((f[F>>2]|0)-(f[k>>2]|0)|0)/12|0);do if(ga){G=((f[I>>2]|0)-(f[W>>2]|0)|0)/12|0;X=G>>>0>1?G:1;G=w+180|0;J=f[G>>2]|0;H=f[S>>2]|0;C=(J-H|0)/48|0;c=H;H=J;if(X>>>0<=C>>>0){if(X>>>0<C>>>0?(J=c+(X*48|0)|0,(H|0)!=(J|0)):0){c=H;do{H=c+-48|0;f[G>>2]=H;hI(H);c=f[G>>2]|0}while((c|0)!=(J|0))}}else TL(S,X-C|0);J=((f[F>>2]|0)-(f[k>>2]|0)|0)/12|0;c=w+204|0;G=f[c>>2]|0;d=f[U>>2]|0;H=(G-d|0)/48|0;ca=G;if(J>>>0>H>>>0){TL(U,J-H|0);break}if(J>>>0<H>>>0?(H=d+(J*48|0)|0,(ca|0)!=(H|0)):0){J=ca;do{ca=J+-48|0;f[c>>2]=ca;hI(ca);J=f[c>>2]|0}while((J|0)!=(H|0))}}while(0);if((f[w+92>>2]|0)>>>0>(((f[I>>2]|0)-(f[W>>2]|0)|0)/12|0)>>>0){f[g>>2]=0;f[g+4>>2]=0;$=aD(g,45)|0;aa=367753;ba=$+45|0;do{b[$>>0]=b[aa>>0]|0;$=$+1|0;aa=aa+1|0}while(($|0)<(ba|0));bO(-215,g,367799,364488,487);bD(g)}if((b[fa+56>>0]|0)!=0?((f[Z>>2]|0)-(f[t>>2]|0)|0)==4:0)ha=(hwa(ea,f[w+60>>2]|0)|0)==1;else ha=0;gwa(l,W);Z=l+4|0;f[m>>2]=f[Z>>2];f[n>>2]=f[k>>2];f[o>>2]=f[F>>2];f[i>>2]=f[m>>2];f[h>>2]=f[n>>2];f[g>>2]=f[o>>2];iwa(l,i,h,g)|0;f[h>>2]=0;o=h+4|0;f[o>>2]=0;f[h+8>>2]=0;f[i>>2]=0;n=i+4|0;f[n>>2]=0;f[i+8>>2]=0;m=w+144|0;fa=f[V>>2]|0;H=fa;c:do if((f[m>>2]|0)!=(fa|0)){J=h+8|0;c=i+8|0;if(ga){ia=0;ja=H;ka=0;la=0}else{C=0;X=H;ca=0;d=0;while(1){G=X+(C*56|0)|0;f[g>>2]=G;if((ca|0)==(d|0))jwa(h,g);else{f[ca>>2]=G;f[o>>2]=(f[o>>2]|0)+4}G=C+1|0;A=f[V>>2]|0;if(G>>>0>=(((f[m>>2]|0)-A|0)/56|0)>>>0)break c;C=G;X=A;ca=f[o>>2]|0;d=f[J>>2]|0}}while(1){d=ja+(ia*56|0)|0;f[g>>2]=d;if((ka|0)==(la|0))jwa(h,g);else{f[ka>>2]=d;f[o>>2]=(f[o>>2]|0)+4}d=(f[S>>2]|0)+(ia*48|0)|0;f[g>>2]=d;ca=f[n>>2]|0;if((ca|0)==(f[c>>2]|0))kwa(i,g);else{f[ca>>2]=d;f[n>>2]=(f[n>>2]|0)+4}d=ia+1|0;ca=f[V>>2]|0;if(d>>>0>=(((f[m>>2]|0)-ca|0)/56|0)>>>0)break c;ia=d;ja=ca;ka=f[o>>2]|0;la=f[J>>2]|0}}while(0);la=w+168|0;ka=f[T>>2]|0;d:do if((f[la>>2]|0)!=(ka|0)){ja=h+8|0;ia=i+8|0;H=g+4|0;fa=v+8|0;J=g+4|0;if(ga){ma=0;na=ka}else{c=0;ca=ka;while(1){d=ca+(c*56|0)|0;f[g>>2]=d;X=f[o>>2]|0;if((X|0)==(f[ja>>2]|0))jwa(h,g);else{f[X>>2]=d;f[o>>2]=(f[o>>2]|0)+4}d=f[k>>2]|0;X=f[d+(c*12|0)+4>>2]|0;C=f[d+(c*12|0)>>2]|0;d=X-C|0;A=d>>2;G=C;e:do if((G|0)!=(X|0)){do if((d|0)>-4){if((d|0)>0){oa=0;pa=1}else break;do{pa=Y(f[G+(oa<<2)>>2]|0,pa)|0;oa=oa+1|0}while((oa|0)<(A|0));if(!pa)break e}else{f[g>>2]=0;f[J>>2]=0;$=aD(g,70)|0;aa=442586;ba=$+70|0;do{b[$>>0]=b[aa>>0]|0;$=$+1|0;aa=aa+1|0}while(($|0)<(ba|0));bO(-215,g,442657,442663,160);bD(g)}while(0);O=(((f[m>>2]|0)-(f[V>>2]|0)|0)/56|0)+c|0;f[g>>2]=f[w>>2];f[H>>2]=O;O=f[r>>2]|0;if((O|0)==(f[fa>>2]|0))qva(v,g);else{N=g;C=f[N+4>>2]|0;D=O;f[D>>2]=f[N>>2];f[D+4>>2]=C;f[r>>2]=(f[r>>2]|0)+8}}while(0);c=c+1|0;ca=f[T>>2]|0;if(c>>>0>=(((f[la>>2]|0)-ca|0)/56|0)>>>0)break d}}do{ca=na+(ma*56|0)|0;f[g>>2]=ca;c=f[o>>2]|0;if((c|0)==(f[ja>>2]|0))jwa(h,g);else{f[c>>2]=ca;f[o>>2]=(f[o>>2]|0)+4}ca=(f[U>>2]|0)+(ma*48|0)|0;f[g>>2]=ca;c=f[n>>2]|0;if((c|0)==(f[ia>>2]|0))kwa(i,g);else{f[c>>2]=ca;f[n>>2]=(f[n>>2]|0)+4}ca=f[k>>2]|0;c=f[ca+(ma*12|0)+4>>2]|0;A=f[ca+(ma*12|0)>>2]|0;ca=c-A|0;G=ca>>2;d=A;f:do if((d|0)!=(c|0)){do if((ca|0)>-4){if((ca|0)>0){qa=0;ra=1}else break;do{ra=Y(f[d+(qa<<2)>>2]|0,ra)|0;qa=qa+1|0}while((qa|0)<(G|0));if(!ra)break f}else{f[g>>2]=0;f[J>>2]=0;$=aD(g,70)|0;aa=442586;ba=$+70|0;do{b[$>>0]=b[aa>>0]|0;$=$+1|0;aa=aa+1|0}while(($|0)<(ba|0));bO(-215,g,442657,442663,160);bD(g)}while(0);A=(((f[m>>2]|0)-(f[V>>2]|0)|0)/56|0)+ma|0;f[g>>2]=f[w>>2];f[H>>2]=A;A=f[r>>2]|0;if((A|0)==(f[fa>>2]|0))qva(v,g);else{X=g;K=f[X+4>>2]|0;C=A;f[C>>2]=f[X>>2];f[C+4>>2]=K;f[r>>2]=(f[r>>2]|0)+8}}while(0);ma=ma+1|0;na=f[T>>2]|0}while(ma>>>0<(((f[la>>2]|0)-na|0)/56|0)>>>0)}while(0);na=f[r>>2]|0;la=f[v>>2]|0;if((na|0)!=(la|0)){ma=a+60|0;T=0;ra=na;na=la;while(1){la=na;qa=la+(T<<3)|0;U=f[ma>>2]|0;do if(!U)R=155;else{pa=f[qa>>2]|0;oa=f[la+(T<<3)+4>>2]|0;ka=ma;fa=U;g:while(1){H=fa;while(1){J=f[H+16>>2]|0;if((J|0)>=(pa|0)){if((J|0)!=(pa|0))break;if((f[H+20>>2]|0)>=(oa|0))break}J=f[H+4>>2]|0;if(!J){sa=ka;break g}else H=J}fa=f[H>>2]|0;if(!fa){sa=H;break}else ka=H}if((sa|0)==(ma|0)){R=155;break}ka=f[sa+16>>2]|0;if((pa|0)<(ka|0)){R=155;break}if((pa|0)==(ka|0)?(oa|0)<(f[sa+20>>2]|0):0){R=155;break}ka=sa+24|0;f[ka>>2]=(f[ka>>2]|0)+1;ta=na;ua=ra}while(0);if((R|0)==155){R=0;U=Vva(ea,qa)|0;f[U>>2]=1;ta=f[v>>2]|0;ua=f[r>>2]|0}T=T+1|0;if(T>>>0>=ua-ta>>3>>>0)break;else{ra=ua;na=ta}}}ta=p+4|0;f[ta>>2]=0;na=p+8|0;f[na>>2]=0;ua=p+4|0;f[p>>2]=ua;f[q>>2]=0;ra=f[l>>2]|0;if((f[Z>>2]|0)!=(ra|0)){T=g+4|0;sa=ra;ra=0;do{ma=sa;U=f[ma+(ra*12|0)+4>>2]|0;la=f[ma+(ra*12|0)>>2]|0;ma=U-la|0;ka=ma>>2;fa=la;do if((fa|0)==(U|0))va=0;else{if((ma|0)<=-4){f[g>>2]=0;f[T>>2]=0;$=aD(g,70)|0;aa=442586;ba=$+70|0;do{b[$>>0]=b[aa>>0]|0;$=$+1|0;aa=aa+1|0}while(($|0)<(ba|0));bO(-215,g,442657,442663,160);bD(g);va=1;break}if((ma|0)>0){wa=0;xa=1}else{va=1;break}while(1){oa=Y(f[fa+(wa<<2)>>2]|0,xa)|0;wa=wa+1|0;if((wa|0)>=(ka|0)){va=oa;break}else xa=oa}}while(0);ka=f[ua>>2]|0;do if(ka){fa=ta;ma=ka;U=ka;while(1){qa=f[ma+16>>2]|0;if((va|0)<(qa|0)){oa=f[ma>>2]|0;if(!oa){R=184;break}else{ya=ma;za=oa}}else{if((qa|0)>=(va|0)){R=188;break}Aa=ma+4|0;qa=f[Aa>>2]|0;if(!qa){R=187;break}else{ya=Aa;za=qa}}fa=ya;ma=za;U=za}if((R|0)==184){R=0;Ba=ma;Ca=ma;R=190;break}else if((R|0)==187){R=0;Ba=Aa;Ca=ma;R=190;break}else if((R|0)==188){R=0;Da=fa;Ea=ma;Fa=U;R=189;break}}else{Da=ua;Ea=ua;Fa=ka;R=189}while(0);if((R|0)==189){R=0;if(!Fa){Ba=Da;Ca=Ea;R=190}else Ga=Fa}if((R|0)==190){R=0;ka=L5b(32)|0;f[ka+16>>2]=va;f[ka+20>>2]=0;f[ka+24>>2]=0;f[ka+28>>2]=0;f[ka>>2]=0;f[ka+4>>2]=0;f[ka+8>>2]=Ca;f[Ba>>2]=ka;qa=f[f[p>>2]>>2]|0;if(!qa)Ha=ka;else{f[p>>2]=qa;Ha=f[Ba>>2]|0}mP(f[ta>>2]|0,Ha);f[na>>2]=(f[na>>2]|0)+1;Ga=ka}ka=Ga+24|0;qa=f[ka>>2]|0;if((qa|0)==(f[Ga+28>>2]|0))IO(Ga+20|0,q);else{f[qa>>2]=f[q>>2];f[ka>>2]=qa+4}ra=(f[q>>2]|0)+1|0;f[q>>2]=ra;sa=f[l>>2]|0}while(ra>>>0<(((f[Z>>2]|0)-sa|0)/12|0)>>>0)}if(B)Ia=0;else Ia=(f[z>>2]|0)-(f[y>>2]|0)>>3>>>0>1;if((ua|0)!=(f[p>>2]|0)){B=q+4|0;sa=ha^1;ha=w+188|0;ra=g+24|0;Ga=g+4|0;na=g+8|0;Ha=g+12|0;ta=g+36|0;Ba=g+16|0;Ca=g+20|0;va=g+28|0;Fa=g+4|0;Ea=g+4|0;Da=w+60|0;Aa=w+152|0;za=g+36|0;ya=g+16|0;xa=g+4|0;wa=g+40|0;T=g+44|0;qa=g+48|0;ka=g+8|0;oa=g+12|0;pa=g+20|0;la=g+24|0;J=g+28|0;ia=g+32|0;ja=g+4|0;G=g+4|0;d=g+4|0;ca=ua;c=ua;while(1){K=ca;C=0;while(1){Ja=f[c>>2]|0;Ka=(Ja|0)==0;if(Ka){X=K;while(1){A=f[X+8>>2]|0;if((f[A>>2]|0)==(X|0))X=A;else{La=A;break}}}else{X=Ja;while(1){U=f[X+4>>2]|0;if(!U){La=X;break}else X=U}}X=La+20|0;if(C>>>0>=(f[X+4>>2]|0)-(f[X>>2]|0)>>2>>>0)break;if(Ka){X=K;while(1){U=f[X+8>>2]|0;if((f[U>>2]|0)==(X|0))X=U;else{Ma=U;break}}}else{X=Ja;while(1){U=f[X+4>>2]|0;if(!U){Ma=X;break}else X=U}}X=f[(f[Ma+20>>2]|0)+(C<<2)>>2]|0;U=f[l>>2]|0;ma=f[U+(X*12|0)+4>>2]|0;fa=f[U+(X*12|0)>>2]|0;U=ma-fa|0;A=U>>2;D=fa;h:do if((D|0)!=(ma|0)){do if((U|0)>-4){if((U|0)>0){Na=0;Oa=1}else break;do{Oa=Y(f[D+(Na<<2)>>2]|0,Oa)|0;Na=Na+1|0}while((Na|0)<(A|0));if(!Oa)break h}else{f[g>>2]=0;f[d>>2]=0;$=aD(g,70)|0;aa=442586;ba=$+70|0;do{b[$>>0]=b[aa>>0]|0;$=$+1|0;aa=aa+1|0}while(($|0)<(ba|0));bO(-215,g,442657,442663,160);bD(g)}while(0);f[q>>2]=f[w>>2];f[B>>2]=X;do if(Ia|(X>>>0>=(((f[I>>2]|0)-(f[W>>2]|0)|0)/12|0)>>>0|sa)){H=(f[l>>2]|0)+(X*12|0)|0;if(ga){mwa(ea,H,q,f[(f[i>>2]|0)+(X<<2)>>2]|0,Ia);break}else{nwa(ea,H,q,f[(f[h>>2]|0)+(X<<2)>>2]|0,Ia);break}}else{if(!ga){H=f[f[Aa>>2]>>2]|0;fa=f[H+4>>2]|0;if((fa|0)<3)Pa=Y(f[H+12>>2]|0,f[H+8>>2]|0)|0;else{N=f[H+40>>2]|0;H=0;O=1;while(1){E=Y(f[N+(H<<2)>>2]|0,O)|0;H=H+1|0;if((H|0)==(fa|0)){Pa=E;break}else O=E}}O=f[l>>2]|0;fa=f[O+(X*12|0)+4>>2]|0;H=f[O+(X*12|0)>>2]|0;O=fa-H|0;N=O>>2;E=H;do if((E|0)==(fa|0))Qa=0;else{if((O|0)<=-4){f[g>>2]=0;f[G>>2]=0;$=aD(g,70)|0;aa=442586;ba=$+70|0;do{b[$>>0]=b[aa>>0]|0;$=$+1|0;aa=aa+1|0}while(($|0)<(ba|0));bO(-215,g,442657,442663,160);bD(g);Qa=1;break}if((O|0)>0){Ra=0;Sa=1}else{Qa=1;break}while(1){H=Y(f[E+(Ra<<2)>>2]|0,Sa)|0;Ra=Ra+1|0;if((Ra|0)>=(N|0)){Qa=H;break}else Sa=H}}while(0);if((Pa|0)!=(Qa|0)){f[g>>2]=0;f[ja>>2]=0;$=aD(g,49)|0;aa=367875;ba=$+49|0;do{b[$>>0]=b[aa>>0]|0;$=$+1|0;aa=aa+1|0}while(($|0)<(ba|0));bO(-215,g,367799,364488,553);bD(g)}PN(g,f[f[Aa>>2]>>2]|0,1,(f[l>>2]|0)+(X*12|0)|0);N=f[V>>2]|0;E=N+(X*56|0)|0;if((E|0)!=(g|0)){O=f[za>>2]|0;if(O|0){fa=O+12|0;f[fa>>2]=(f[fa>>2]|0)+1}fa=N+(X*56|0)+36|0;O=f[fa>>2]|0;do if(O|0){H=O+12|0;M=f[H>>2]|0;f[H>>2]=M+-1;if((M|0)!=1)break;kL(E)}while(0);f[fa>>2]=0;O=N+(X*56|0)+16|0;M=N+(X*56|0)+4|0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[M>>2]|0)>0){H=f[N+(X*56|0)+40>>2]|0;da=0;do{f[H+(da<<2)>>2]=0;da=da+1|0;Ta=f[M>>2]|0}while((da|0)<(Ta|0));f[E>>2]=f[g>>2];if((Ta|0)<3)R=270;else R=272}else{f[E>>2]=f[g>>2];R=270}do if((R|0)==270){R=0;da=f[xa>>2]|0;if((da|0)>=3){R=272;break}f[M>>2]=da;f[N+(X*56|0)+8>>2]=f[ka>>2];f[N+(X*56|0)+12>>2]=f[oa>>2];da=f[T>>2]|0;H=f[N+(X*56|0)+44>>2]|0;f[H>>2]=f[da>>2];f[H+4>>2]=f[da+4>>2]}while(0);if((R|0)==272){R=0;jL(E,g)}f[O>>2]=f[ya>>2];f[N+(X*56|0)+20>>2]=f[pa>>2];f[N+(X*56|0)+24>>2]=f[la>>2];f[N+(X*56|0)+28>>2]=f[J>>2];f[N+(X*56|0)+32>>2]=f[ia>>2];f[fa>>2]=f[za>>2]}M=f[za>>2]|0;do if(M|0){da=M+12|0;H=f[da>>2]|0;f[da>>2]=H+-1;if((H|0)!=1)break;kL(g)}while(0);f[za>>2]=0;f[ya>>2]=0;f[ya+4>>2]=0;f[ya+8>>2]=0;f[ya+12>>2]=0;if((f[xa>>2]|0)>0){M=f[wa>>2]|0;fa=0;do{f[M+(fa<<2)>>2]=0;fa=fa+1|0}while((fa|0)<(f[xa>>2]|0))}fa=f[T>>2]|0;if((fa|0)!=(qa|0))UC(fa)}else{fa=f[ha>>2]|0;M=f[fa+4>>2]|0;if((M|0)<3)Ua=Y(f[fa+12>>2]|0,f[fa+8>>2]|0)|0;else{N=f[fa+32>>2]|0;fa=0;O=1;while(1){E=Y(f[N+(fa<<2)>>2]|0,O)|0;fa=fa+1|0;if((fa|0)==(M|0)){Ua=E;break}else O=E}}O=f[l>>2]|0;M=f[O+(X*12|0)+4>>2]|0;fa=f[O+(X*12|0)>>2]|0;O=M-fa|0;N=O>>2;E=fa;do if((E|0)==(M|0))Va=0;else{if((O|0)<=-4){f[g>>2]=0;f[Ea>>2]=0;$=aD(g,70)|0;aa=442586;ba=$+70|0;do{b[$>>0]=b[aa>>0]|0;$=$+1|0;aa=aa+1|0}while(($|0)<(ba|0));bO(-215,g,442657,442663,160);bD(g);Va=1;break}if((O|0)>0){Wa=0;Xa=1}else{Va=1;break}while(1){fa=Y(f[E+(Wa<<2)>>2]|0,Xa)|0;Wa=Wa+1|0;if((Wa|0)>=(N|0)){Va=fa;break}else Xa=fa}}while(0);if((Ua|0)!=(Va|0)){f[g>>2]=0;f[Fa>>2]=0;$=aD(g,53)|0;aa=367821;ba=$+53|0;do{b[$>>0]=b[aa>>0]|0;$=$+1|0;aa=aa+1|0}while(($|0)<(ba|0));bO(-215,g,367799,364488,546);bD(g)}N=f[l>>2]|0;E=f[N+(X*12|0)>>2]|0;rI(g,f[ha>>2]|0,1,(f[N+(X*12|0)+4>>2]|0)-E>>2,E);E=f[S>>2]|0;N=E+(X*48|0)|0;if((N|0)!=(g|0)){O=f[ra>>2]|0;if(O|0){M=O+8|0;f[M>>2]=(f[M>>2]|0)+1}M=E+(X*48|0)+24|0;O=f[M>>2]|0;do if(O|0){fa=O+8|0;H=f[fa>>2]|0;f[fa>>2]=H+-1;if((H|0)!=1)break;iI(N)}while(0);O=E+(X*48|0)+4|0;if((f[O>>2]|0)>0){H=f[E+(X*48|0)+32>>2]|0;fa=0;do{f[H+(fa<<2)>>2]=0;fa=fa+1|0;Ya=f[O>>2]|0}while((fa|0)<(Ya|0));f[M>>2]=0;f[N>>2]=f[g>>2];if((Ya|0)<3)R=241;else R=243}else{f[M>>2]=0;f[N>>2]=f[g>>2];R=241}do if((R|0)==241){R=0;fa=f[Ga>>2]|0;if((fa|0)>=3){R=243;break}f[O>>2]=fa;f[E+(X*48|0)+8>>2]=f[na>>2];f[E+(X*48|0)+12>>2]=f[Ha>>2];fa=f[ta>>2]|0;H=f[E+(X*48|0)+36>>2]|0;f[H>>2]=f[fa>>2];f[H+4>>2]=f[fa+4>>2]}while(0);if((R|0)==243){R=0;gI(N,g)}f[E+(X*48|0)+16>>2]=f[Ba>>2];O=E+(X*48|0)+20|0;if(!(f[O>>2]|0))f[O>>2]=f[Ca>>2];f[M>>2]=f[ra>>2];f[E+(X*48|0)+28>>2]=f[va>>2]}hI(g)}lwa(ea,f[Da>>2]|0,q)}while(0)}while(0);C=C+1|0}if(Ka){C=K;while(1){X=f[C+8>>2]|0;if((f[X>>2]|0)==(C|0))C=X;else{Za=X;break}}}else{C=Ja;while(1){K=f[C+4>>2]|0;if(!K){Za=C;break}else C=K}}if((Za|0)==(f[p>>2]|0))break;else{ca=Za;c=Za}}}owa(p,f[ua>>2]|0);ua=f[i>>2]|0;if(ua|0){p=f[n>>2]|0;if((p|0)!=(ua|0))f[n>>2]=p+(~((p+-4-ua|0)>>>2)<<2);O5b(ua)}ua=f[h>>2]|0;if(ua|0){p=f[o>>2]|0;if((p|0)!=(ua|0))f[o>>2]=p+(~((p+-4-ua|0)>>>2)<<2);O5b(ua)}ua=f[l>>2]|0;if(ua|0){p=f[Z>>2]|0;if((p|0)==(ua|0))_a=ua;else{o=p;while(1){p=o+-12|0;f[Z>>2]=p;n=f[p>>2]|0;if(!n)$a=p;else{p=o+-8|0;Za=f[p>>2]|0;if((Za|0)!=(n|0))f[p>>2]=Za+(~((Za+-4-n|0)>>>2)<<2);O5b(n);$a=f[Z>>2]|0}if(($a|0)==(ua|0))break;else o=$a}_a=f[l>>2]|0}O5b(_a)}_a=f[k>>2]|0;if(_a|0){l=f[F>>2]|0;if((l|0)==(_a|0))ab=_a;else{$a=l;while(1){l=$a+-12|0;f[F>>2]=l;o=f[l>>2]|0;if(!o)bb=l;else{l=$a+-8|0;ua=f[l>>2]|0;if((ua|0)!=(o|0))f[l>>2]=ua+(~((ua+-4-o|0)>>>2)<<2);O5b(o);bb=f[F>>2]|0}if((bb|0)==(_a|0))break;else $a=bb}ab=f[k>>2]|0}O5b(ab)}ab=w+108|0;bb=((f[m>>2]|0)-(f[V>>2]|0)|0)/56|0;$a=w+112|0;_a=f[$a>>2]|0;F=f[ab>>2]|0;o=_a-F>>3;ua=F;F=_a;do if(bb>>>0>o>>>0)fwa(ab,bb-o|0);else{if(bb>>>0>=o>>>0)break;_a=ua+(bb<<3)|0;if((F|0)==(_a|0))break;else cb=F;do{l=cb+-8|0;f[$a>>2]=l;Z=f[l>>2]|0;do if(Z|0){n=Z+4|0;Za=f[n>>2]|0;f[n>>2]=Za+-1;if((Za|0)!=1)break;bi[f[(f[Z>>2]|0)+8>>2]&2047](Z)}while(0);f[l>>2]=0;f[cb+-4>>2]=0;cb=f[$a>>2]|0}while((cb|0)!=(_a|0))}while(0);cb=f[V>>2]|0;if((f[m>>2]|0)!=(cb|0)){$a=g+4|0;F=0;bb=cb;do{pwa(g,a,bb+(F*56|0)|0);cb=f[ab>>2]|0;ua=cb+(F<<3)|0;o=f[g>>2]|0;_a=f[$a>>2]|0;if(o|0){Z=o+4|0;f[Z>>2]=(f[Z>>2]|0)+1}Z=f[ua>>2]|0;f[ua>>2]=o;f[cb+(F<<3)+4>>2]=_a;do if(Z|0){_a=Z+4|0;cb=f[_a>>2]|0;f[_a>>2]=cb+-1;if((cb|0)!=1)break;bi[f[(f[Z>>2]|0)+8>>2]&2047](Z)}while(0);Z=f[g>>2]|0;do if(Z|0){cb=Z+4|0;_a=f[cb>>2]|0;f[cb>>2]=_a+-1;if((_a|0)!=1)break;bi[f[(f[Z>>2]|0)+8>>2]&2047](Z)}while(0);F=F+1|0;bb=f[V>>2]|0}while(F>>>0<(((f[m>>2]|0)-bb|0)/56|0)>>>0)}xva(g,w);if(_){_=w+188|0;bb=(f[w+192>>2]|0)-(f[_>>2]|0)|0;m=(bb|0)/48|0;f[h>>2]=0;F=h+4|0;f[F>>2]=0;f[h+8>>2]=0;if(!bb){db=0;eb=0}else{if(m>>>0>1073741823)c4b(h);bb=L5b(m<<2)|0;f[F>>2]=bb;f[h>>2]=bb;f[h+8>>2]=bb+(m<<2);$a=bb;ab=m;m=bb;do{f[m>>2]=0;m=(f[F>>2]|0)+4|0;f[F>>2]=m;ab=ab+-1|0}while((ab|0)!=0);db=m;eb=$a}$a=(f[w+180>>2]|0)-(f[S>>2]|0)|0;w=($a|0)/48|0;f[i>>2]=0;m=i+4|0;f[m>>2]=0;f[i+8>>2]=0;if(!$a){fb=0;gb=0}else{if(w>>>0>76695844)c4b(i);$a=w*56|0;ab=L5b($a)|0;f[m>>2]=ab;f[i>>2]=ab;f[i+8>>2]=ab+(w*56|0);bb=ab+$a|0;$a=ab;Z=w;w=ab;while(1){f[w>>2]=1124007936;ab=w+8|0;_a=w+40|0;$=w+4|0;ba=$+36|0;do{f[$>>2]=0;$=$+4|0}while(($|0)<(ba|0));f[_a>>2]=ab;cb=w+48|0;f[w+44>>2]=cb;f[cb>>2]=0;f[w+52>>2]=0;Z=Z+-1|0;if(!Z)break;else w=w+56|0}f[m>>2]=bb;fb=$a;gb=bb}f[j>>2]=1124007936;bb=j+4|0;$a=j+8|0;w=j+40|0;$=bb;ba=$+36|0;do{f[$>>2]=0;$=$+4|0}while(($|0)<(ba|0));f[w>>2]=$a;$=j+48|0;ba=j+44|0;f[ba>>2]=$;f[$>>2]=0;f[j+52>>2]=0;if((db|0)==(eb|0)){hb=m;ib=i;jb=gb;kb=fb}else{fb=k+36|0;gb=j+36|0;eb=j+16|0;db=k+4|0;Z=k+8|0;cb=k+12|0;o=j+12|0;ua=k+44|0;Za=k+16|0;n=k+20|0;p=j+20|0;c=k+24|0;ca=j+24|0;Ja=k+28|0;Ka=j+28|0;q=k+32|0;Da=j+32|0;va=k+40|0;ra=k+48|0;Ca=0;do{qI(k,(f[_>>2]|0)+(Ca*48|0)|0,16777216);Ba=f[fb>>2]|0;if(Ba|0){ta=Ba+12|0;f[ta>>2]=(f[ta>>2]|0)+1}ta=f[gb>>2]|0;do if(ta|0){Ba=ta+12|0;Ha=f[Ba>>2]|0;f[Ba>>2]=Ha+-1;if((Ha|0)!=1)break;kL(j)}while(0);f[gb>>2]=0;f[eb>>2]=0;f[eb+4>>2]=0;f[eb+8>>2]=0;f[eb+12>>2]=0;if((f[bb>>2]|0)>0){ta=f[w>>2]|0;ab=0;do{f[ta+(ab<<2)>>2]=0;ab=ab+1|0;lb=f[bb>>2]|0}while((ab|0)<(lb|0));f[j>>2]=f[k>>2];if((lb|0)<3)R=366;else R=368}else{f[j>>2]=f[k>>2];R=366}do if((R|0)==366){R=0;ab=f[db>>2]|0;if((ab|0)>=3){R=368;break}f[bb>>2]=ab;f[$a>>2]=f[Z>>2];f[o>>2]=f[cb>>2];ab=f[ua>>2]|0;ta=f[ba>>2]|0;f[ta>>2]=f[ab>>2];f[ta+4>>2]=f[ab+4>>2]}while(0);if((R|0)==368){R=0;jL(j,k)}f[eb>>2]=f[Za>>2];f[p>>2]=f[n>>2];f[ca>>2]=f[c>>2];f[Ka>>2]=f[Ja>>2];f[Da>>2]=f[q>>2];ab=f[fb>>2]|0;f[gb>>2]=ab;do if(ab|0){ta=ab+12|0;_a=f[ta>>2]|0;f[ta>>2]=_a+-1;if((_a|0)!=1)break;kL(k)}while(0);f[fb>>2]=0;f[Za>>2]=0;f[Za+4>>2]=0;f[Za+8>>2]=0;f[Za+12>>2]=0;if((f[db>>2]|0)>0){ab=f[va>>2]|0;_a=0;do{f[ab+(_a<<2)>>2]=0;_a=_a+1|0}while((_a|0)<(f[db>>2]|0))}_a=f[ua>>2]|0;if((_a|0)!=(ra|0))UC(_a);f[(f[h>>2]|0)+(Ca<<2)>>2]=j;Ca=Ca+1|0}while(Ca>>>0<(f[F>>2]|0)-(f[h>>2]|0)>>2>>>0);hb=m;ib=i;jb=f[m>>2]|0;kb=f[i>>2]|0}if((jb|0)!=(kb|0)){kb=k+36|0;jb=k+16|0;m=k+4|0;Ca=k+40|0;ra=k+44|0;ua=k+48|0;db=k+8|0;va=k+12|0;Za=k+20|0;fb=k+24|0;gb=k+28|0;q=k+32|0;Da=0;do{qI(k,(f[S>>2]|0)+(Da*48|0)|0,16777216);Ja=f[i>>2]|0;Ka=Ja+(Da*56|0)|0;if((Ka|0)!=(k|0)){c=f[kb>>2]|0;if(c|0){ca=c+12|0;f[ca>>2]=(f[ca>>2]|0)+1}ca=Ja+(Da*56|0)+36|0;c=f[ca>>2]|0;do if(c|0){n=c+12|0;p=f[n>>2]|0;f[n>>2]=p+-1;if((p|0)!=1)break;kL(Ka)}while(0);f[ca>>2]=0;c=Ja+(Da*56|0)+16|0;p=Ja+(Da*56|0)+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){n=f[Ja+(Da*56|0)+40>>2]|0;eb=0;do{f[n+(eb<<2)>>2]=0;eb=eb+1|0;mb=f[p>>2]|0}while((eb|0)<(mb|0));f[Ka>>2]=f[k>>2];if((mb|0)<3)R=390;else R=392}else{f[Ka>>2]=f[k>>2];R=390}do if((R|0)==390){R=0;eb=f[m>>2]|0;if((eb|0)>=3){R=392;break}f[p>>2]=eb;f[Ja+(Da*56|0)+8>>2]=f[db>>2];f[Ja+(Da*56|0)+12>>2]=f[va>>2];eb=f[ra>>2]|0;n=f[Ja+(Da*56|0)+44>>2]|0;f[n>>2]=f[eb>>2];f[n+4>>2]=f[eb+4>>2]}while(0);if((R|0)==392){R=0;jL(Ka,k)}f[c>>2]=f[jb>>2];f[Ja+(Da*56|0)+20>>2]=f[Za>>2];f[Ja+(Da*56|0)+24>>2]=f[fb>>2];f[Ja+(Da*56|0)+28>>2]=f[gb>>2];f[Ja+(Da*56|0)+32>>2]=f[q>>2];f[ca>>2]=f[kb>>2]}p=f[kb>>2]|0;do if(p|0){eb=p+12|0;n=f[eb>>2]|0;f[eb>>2]=n+-1;if((n|0)!=1)break;kL(k)}while(0);f[kb>>2]=0;f[jb>>2]=0;f[jb+4>>2]=0;f[jb+8>>2]=0;f[jb+12>>2]=0;if((f[m>>2]|0)>0){p=f[Ca>>2]|0;ca=0;do{f[p+(ca<<2)>>2]=0;ca=ca+1|0}while((ca|0)<(f[m>>2]|0))}ca=f[ra>>2]|0;if((ca|0)!=(ua|0))UC(ca);Da=Da+1|0}while(Da>>>0<(((f[hb>>2]|0)-(f[ib>>2]|0)|0)/56|0)>>>0)}ib=g+4|0;hb=f[ib>>2]|0;_h[f[(f[hb>>2]|0)+32>>2]&255](hb,h,i);hb=j+36|0;Da=f[hb>>2]|0;do if(Da|0){ua=Da+12|0;ra=f[ua>>2]|0;f[ua>>2]=ra+-1;if((ra|0)!=1)break;kL(j)}while(0);f[hb>>2]=0;hb=j+16|0;f[hb>>2]=0;f[hb+4>>2]=0;f[hb+8>>2]=0;f[hb+12>>2]=0;if((f[bb>>2]|0)>0){hb=f[w>>2]|0;w=0;do{f[hb+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[bb>>2]|0))}bb=f[ba>>2]|0;if((bb|0)!=($|0))UC(bb);et(i);i=f[h>>2]|0;if(i|0){h=f[F>>2]|0;if((h|0)!=(i|0))f[F>>2]=h+(~((h+-4-i|0)>>>2)<<2);O5b(i)}nb=ib}else{ib=g+4|0;i=f[ib>>2]|0;_h[f[(f[i>>2]|0)+32>>2]&255](i,t,V);nb=ib}f[(f[nb>>2]|0)+32>>2]=f[a+116>>2];a=f[y>>2]|0;if((f[z>>2]|0)!=(a|0)){ib=0;V=a;do{qwa(ea,V+(ib<<3)|0);ib=ib+1|0;V=f[y>>2]|0}while(ib>>>0<(f[z>>2]|0)-V>>3>>>0)}V=f[v>>2]|0;if((f[r>>2]|0)!=(V|0)){z=0;ib=V;do{qwa(ea,ib+(z<<3)|0);z=z+1|0;ib=f[v>>2]|0}while(z>>>0<(f[r>>2]|0)-ib>>3>>>0)}f[x>>2]=1;x=f[g>>2]|0;do if(x|0){g=x+4|0;ib=f[g>>2]|0;f[g>>2]=ib+-1;if((ib|0)!=1)break;bi[f[(f[x>>2]|0)+8>>2]&2047](x)}while(0);f[nb>>2]=0;nb=f[v>>2]|0;if(nb|0){v=f[r>>2]|0;if((v|0)!=(nb|0))f[r>>2]=v+(~((v+-8-nb|0)>>>3)<<3);O5b(nb)}}if(!(f[s+4>>2]|0)){u=e;return}u=e;return}function Xva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;i=h;if(e-h>>3>>>0>=b>>>0){j=b;k=i;while(1){l=c;m=f[l+4>>2]|0;n=k;f[n>>2]=f[l>>2];f[n+4>>2]=m;j=j+-1|0;if(!j)break;else k=k+8|0}f[g>>2]=i+(b<<3);return}i=f[a>>2]|0;k=h-i|0;h=k>>3;j=h+b|0;if(j>>>0>536870911)c4b(a);m=e-i|0;e=m>>2;n=m>>3>>>0<268435455?(e>>>0<j>>>0?j:e):536870911;do if(n)if(n>>>0>536870911){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{o=L5b(n<<3)|0;break}else o=0;while(0);e=o+(h<<3)|0;j=o+(n<<3)|0;n=b;o=e;while(1){m=c;l=f[m+4>>2]|0;p=o;f[p>>2]=f[m>>2];f[p+4>>2]=l;n=n+-1|0;if(!n)break;else o=o+8|0}o=e+(0-h<<3)|0;if((k|0)>0)Vac(o|0,i|0,k|0)|0;f[a>>2]=o;f[g>>2]=e+(b<<3);f[d>>2]=j;if(!i)return;O5b(i);return}function Yva(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0;d=u;u=u+160|0;e=d+148|0;g=d+136|0;h=d+16|0;i=d+8|0;j=d+128|0;k=d+116|0;l=d+104|0;m=d+48|0;n=d;if(!(b[a+145>>0]|0)){u=d;return}if(f[a+112>>2]|0){u=d;return}dQ(j,105772);f[k>>2]=0;j=k+4|0;f[j>>2]=0;f[k+8>>2]=0;o=f[c>>2]|0;p=f[c+4>>2]|0;c=l+4|0;f[c>>2]=0;q=l+8|0;f[q>>2]=0;r=l+4|0;f[l>>2]=r;if((o|0)!=(p|0)){s=r;t=o;do{f[i>>2]=s;f[e>>2]=f[i>>2];o=_va(l,e,g,h,t)|0;if(!(f[o>>2]|0)){v=L5b(24)|0;w=t;x=f[w+4>>2]|0;y=v+16|0;f[y>>2]=f[w>>2];f[y+4>>2]=x;x=f[g>>2]|0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=x;f[o>>2]=v;x=f[f[l>>2]>>2]|0;if(!x)z=v;else{f[l>>2]=x;z=f[o>>2]|0}mP(f[c>>2]|0,z);f[q>>2]=(f[q>>2]|0)+1}t=t+8|0}while((t|0)!=(p|0))}p=a+32|0;t=f[p>>2]|0;q=a+36|0;a:do if((t|0)==(q|0))A=r;else{z=k+8|0;c=a+116|0;s=g+4|0;o=h+4|0;x=i+4|0;v=m+4|0;y=n+4|0;w=m+4|0;B=g+4|0;C=g+8|0;D=g+8|0;E=h+4|0;F=h+8|0;G=h+12|0;H=h+16|0;I=h+20|0;J=h+24|0;K=h+28|0;L=i+4|0;M=n+4|0;N=m+36|0;O=m+16|0;P=m+4|0;Q=m+40|0;R=m+44|0;S=m+48|0;T=n+4|0;U=m+8|0;V=m+12|0;W=m+20|0;X=m+24|0;Y=m+28|0;Z=m+32|0;_=t;b:while(1){f[e>>2]=f[_+16>>2];$=Jva(p,e)|0;aa=$+224|0;ba=$+228|0;ca=f[ba>>2]|0;do if(ca){da=$+228|0;ea=ca;fa=ca;while(1){ga=f[ea+16>>2]|0;if((ga|0)>0){ha=f[ea>>2]|0;if(!ha){ia=18;break}else{ja=ea;ka=ha}}else{if((ga|0)>=0){ia=22;break}la=ea+4|0;ga=f[la>>2]|0;if(!ga){ia=21;break}else{ja=la;ka=ga}}da=ja;ea=ka;fa=ka}if((ia|0)==18){ia=0;ma=ea;na=ea;ia=25;break}else if((ia|0)==21){ia=0;ma=la;na=ea;ia=25;break}else if((ia|0)==22){ia=0;oa=da;pa=ea;qa=fa;ia=24;break}}else{oa=ba;pa=ba;qa=ca;ia=24}while(0);if((ia|0)==24){ia=0;if(!qa){ma=oa;na=pa;ia=25}else ra=qa}if((ia|0)==25){ia=0;ca=L5b(24)|0;f[ca+16>>2]=0;b[ca+20>>0]=0;f[ca>>2]=0;f[ca+4>>2]=0;f[ca+8>>2]=na;f[ma>>2]=ca;ga=f[f[aa>>2]>>2]|0;if(!ga)sa=ca;else{f[aa>>2]=ga;sa=f[ma>>2]|0}mP(f[$+228>>2]|0,sa);ga=$+232|0;f[ga>>2]=(f[ga>>2]|0)+1;ra=ca}do if(!(b[ra+20>>0]|0)){ca=$+96|0;ga=$+100|0;do if((f[ga>>2]|0)==(f[ca>>2]|0)){ha=f[$+136>>2]|0;ta=ha+16|0;ua=f[j>>2]|0;if((ua|0)==(f[z>>2]|0)){awa(k,ta);break}va=f[ta>>2]|0;f[ua>>2]=va;f[ua+4>>2]=f[ha+20>>2];if(!va)wa=ua;else{ua=va+-4|0;f[ua>>2]=(f[ua>>2]|0)+1;wa=f[j>>2]|0}f[j>>2]=wa+8}while(0);if((f[c>>2]|0)==1){if(!(jP()|0))break;fa=f[(f[$+136>>2]|0)+24>>2]|0;if((fa|0)!=411994?gTb((fa|0)==0?1124530:fa,411994)|0:0)break}fa=$+132|0;ea=f[ca>>2]|0;da=ea;c:do if(((f[ga>>2]|0)-ea|0)==8){ua=f[e>>2]|0;va=f[r>>2]|0;if(va|0){ha=va;do{va=f[ha+16>>2]|0;do if((ua|0)<(va|0))ia=44;else{ta=(ua|0)==(va|0);if(ta?(f[ha+20>>2]|0)>0:0){ia=44;break}if((va|0)>=(ua|0)){if(!ta)break c;if((f[ha+20>>2]|0)>=0)break c}xa=ha+4|0}while(0);if((ia|0)==44){ia=0;xa=ha}ha=f[xa>>2]|0}while((ha|0)!=0)}ha=Jva(p,da)|0;ua=f[ha+136>>2]|0;if(!ua)ya=0;else ya=T6b(ua,17800,17864,0)|0;ua=f[ha+132>>2]|0;f[g>>2]=ua;f[s>>2]=ya;if(!ua)za=ya;else{va=ua+4|0;f[va>>2]=(f[va>>2]|0)+1;za=f[s>>2]|0}va=f[f[ca>>2]>>2]|0;f[h>>2]=va;f[o>>2]=0;d:do if(!za){Aa=ha;ia=89}else{ua=f[r>>2]|0;if(ua|0){ta=ua;do{ua=f[ta+16>>2]|0;do if((va|0)<(ua|0))ia=59;else{Ba=(va|0)==(ua|0);if(Ba?(f[ta+20>>2]|0)>0:0){ia=59;break}if((ua|0)>=(va|0)){if(!Ba){Aa=ha;ia=89;break d}if((f[ta+20>>2]|0)>=0){Aa=ha;ia=89;break d}}Ca=ta+4|0}while(0);if((ia|0)==59){ia=0;Ca=ta}ta=f[Ca>>2]|0}while((ta|0)!=0)}ta=f[$+136>>2]|0;do if(Uh[f[(f[ta>>2]|0)+72>>2]&1023](ta,g)|0){ua=ha+224|0;Ba=ha+228|0;Da=f[Ba>>2]|0;do if(Da){Ea=ha+228|0;Fa=Da;Ga=Da;while(1){Ha=f[Fa+16>>2]|0;if((Ha|0)>0){Ia=f[Fa>>2]|0;if(!Ia){ia=71;break}else{Ja=Fa;Ka=Ia}}else{if((Ha|0)>=0){ia=75;break}La=Fa+4|0;Ha=f[La>>2]|0;if(!Ha){ia=74;break}else{Ja=La;Ka=Ha}}Ea=Ja;Fa=Ka;Ga=Ka}if((ia|0)==71){ia=0;Ma=Fa;Na=Fa;ia=78;break}else if((ia|0)==74){ia=0;Ma=La;Na=Fa;ia=78;break}else if((ia|0)==75){ia=0;Oa=Ea;Pa=Fa;Qa=Ga;ia=77;break}}else{Oa=Ba;Pa=Ba;Qa=Da;ia=77}while(0);if((ia|0)==77){ia=0;if(!Qa){Ma=Oa;Na=Pa;ia=78}else Ra=Qa}if((ia|0)==78){ia=0;Da=L5b(24)|0;f[Da+16>>2]=0;b[Da+20>>0]=0;f[Da>>2]=0;f[Da+4>>2]=0;f[Da+8>>2]=Na;f[Ma>>2]=Da;Ba=f[f[ua>>2]>>2]|0;if(!Ba)Sa=Da;else{f[ua>>2]=Ba;Sa=f[Ma>>2]|0}mP(f[ha+228>>2]|0,Sa);Ba=ha+232|0;f[Ba>>2]=(f[Ba>>2]|0)+1;Ra=Da}b[Ra+20>>0]=1;Da=(f[c>>2]|0)==1;Ba=Jva(p,h)|0;Ha=($|0)==(Ba|0);do if(Da){if(Ha)break;bwa($+176|0,f[Ba+176>>2]|0,f[Ba+180>>2]|0)}else{if(Ha)break;cwa($+140|0,f[Ba+140>>2]|0,f[Ba+144>>2]|0)}while(0);Ba=ha+96|0;Ha=f[Ba>>2]|0;if(((f[ha+100>>2]|0)-Ha|0)!=8)break;Da=Jva(p,Ha)|0;Ha=h;f[Ha>>2]=f[f[Ba>>2]>>2];f[Ha+4>>2]=0;Aa=Da;ia=89;break d}while(0);f[i>>2]=0;f[x>>2]=0;Ta=0}while(0);e:do if((ia|0)==89){ia=0;f[i>>2]=0;f[x>>2]=0;ha=f[Aa+136>>2]|0;if(!ha)Ua=0;else Ua=T6b(ha,17800,17880,0)|0;ha=f[Aa+132>>2]|0;va=Ua;if(!ha){f[i>>2]=ha;f[x>>2]=va;Va=Ua}else{ta=ha+4|0;f[ta>>2]=(f[ta>>2]|0)+1;f[ta>>2]=(f[ta>>2]|0)+1;ta=f[i>>2]|0;f[i>>2]=ha;f[x>>2]=va;do if(ta|0){va=ta+4|0;Da=f[va>>2]|0;f[va>>2]=Da+-1;if((Da|0)!=1)break;bi[f[(f[ta>>2]|0)+8>>2]&2047](ta)}while(0);ta=ha;Da=ta+4|0;va=f[Da>>2]|0;f[Da>>2]=va+-1;if((va|0)==1)bi[f[(f[ha>>2]|0)+8>>2]&2047](ta);Va=f[x>>2]|0}if(!Va){Ta=Aa;break}ta=f[r>>2]|0;if(ta|0){va=f[h>>2]|0;Da=f[o>>2]|0;Ha=ta;do{ta=f[Ha+16>>2]|0;do if((va|0)<(ta|0))ia=105;else{Ba=(va|0)==(ta|0);if(Ba?(Da|0)<(f[Ha+20>>2]|0):0){ia=105;break}if((ta|0)>=(va|0)){if(!Ba){Ta=Aa;break e}if((f[Ha+20>>2]|0)>=(Da|0)){Ta=Aa;break e}}Wa=Ha+4|0}while(0);if((ia|0)==105){ia=0;Wa=Ha}Ha=f[Wa>>2]|0}while((Ha|0)!=0)}Ha=f[$+136>>2]|0;if(!(Uh[f[(f[Ha>>2]|0)+76>>2]&1023](Ha,i)|0)){Ta=0;break}Ha=Aa+224|0;Da=Aa+228|0;va=f[Da>>2]|0;do if(va){ha=Aa+228|0;ta=va;Ba=va;while(1){ua=f[ta+16>>2]|0;if((ua|0)>0){Ia=f[ta>>2]|0;if(!Ia){ia=117;break}else{Xa=ta;Ya=Ia}}else{if((ua|0)>=0){ia=121;break}Za=ta+4|0;ua=f[Za>>2]|0;if(!ua){ia=120;break}else{Xa=Za;Ya=ua}}ha=Xa;ta=Ya;Ba=Ya}if((ia|0)==117){ia=0;_a=ta;$a=ta;ia=124;break}else if((ia|0)==120){ia=0;_a=Za;$a=ta;ia=124;break}else if((ia|0)==121){ia=0;ab=ha;bb=ta;cb=Ba;ia=123;break}}else{ab=Da;bb=Da;cb=va;ia=123}while(0);if((ia|0)==123){ia=0;if(!cb){_a=ab;$a=bb;ia=124}else db=cb}if((ia|0)==124){ia=0;va=L5b(24)|0;f[va+16>>2]=0;b[va+20>>0]=0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=$a;f[_a>>2]=va;Da=f[f[Ha>>2]>>2]|0;if(!Da)eb=va;else{f[Ha>>2]=Da;eb=f[_a>>2]|0}mP(f[Aa+228>>2]|0,eb);Da=Aa+232|0;f[Da>>2]=(f[Da>>2]|0)+1;db=va}b[db+20>>0]=1;va=(f[c>>2]|0)==1;Da=Jva(p,h)|0;ua=($|0)==(Da|0);do if(va){if(ua)break;bwa($+176|0,f[Da+176>>2]|0,f[Da+180>>2]|0)}else{if(ua)break;cwa($+140|0,f[Da+140>>2]|0,f[Da+144>>2]|0)}while(0);Da=Aa+96|0;ua=f[Da>>2]|0;if(((f[Aa+100>>2]|0)-ua|0)!=8){Ta=0;break}va=Jva(p,ua)|0;ua=h;f[ua>>2]=f[f[Da>>2]>>2];f[ua+4>>2]=0;Ta=va}while(0);f:do if((f[c>>2]|0)==1){if(Ta|0){va=f[Ta+12>>2]|0;do if((va|0)!=380368){ua=(va|0)==0?1124530:va;if((gTb(ua,380368)|0)==0|(va|0)==410872)break;if((gTb(ua,410872)|0)==0|(va|0)==433229)break;if(gTb(ua,433229)|0){fb=Ta;ia=191;break f}}while(0);f[m>>2]=0;f[w>>2]=0;ia=142}}else{f[m>>2]=0;f[w>>2]=0;if(!Ta){gb=0;ia=187}else ia=142}while(0);g:do if((ia|0)==142){ia=0;va=f[Ta+136>>2]|0;if(!va)hb=0;else hb=T6b(va,17800,17896,0)|0;va=f[Ta+132>>2]|0;ua=hb;if(!va){f[m>>2]=va;f[w>>2]=ua;ib=hb}else{Da=va+4|0;f[Da>>2]=(f[Da>>2]|0)+1;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[m>>2]|0;f[m>>2]=va;f[w>>2]=ua;do if(Da|0){ua=Da+4|0;Ha=f[ua>>2]|0;f[ua>>2]=Ha+-1;if((Ha|0)!=1)break;bi[f[(f[Da>>2]|0)+8>>2]&2047](Da)}while(0);Da=va;Ha=Da+4|0;ua=f[Ha>>2]|0;f[Ha>>2]=ua+-1;if((ua|0)==1)bi[f[(f[va>>2]|0)+8>>2]&2047](Da);ib=f[w>>2]|0}if(!ib){gb=Ta;ia=187;break}Da=f[r>>2]|0;if(Da|0){ua=f[h>>2]|0;Ha=f[o>>2]|0;Ia=Da;do{Da=f[Ia+16>>2]|0;do if((ua|0)<(Da|0))ia=158;else{jb=(ua|0)==(Da|0);if(jb?(Ha|0)<(f[Ia+20>>2]|0):0){ia=158;break}if((Da|0)>=(ua|0)){if(!jb){gb=Ta;ia=187;break g}if((f[Ia+20>>2]|0)>=(Ha|0)){gb=Ta;ia=187;break g}}kb=Ia+4|0}while(0);if((ia|0)==158){ia=0;kb=Ia}Ia=f[kb>>2]|0}while((Ia|0)!=0)}Ia=f[$+136>>2]|0;if(!(Uh[f[(f[Ia>>2]|0)+68>>2]&1023](Ia,m)|0)){gb=Ta;ia=187;break}Ia=Ta+224|0;Ha=Ta+228|0;ua=f[Ha>>2]|0;do if(ua){va=Ta+228|0;Da=ua;Ba=ua;while(1){ta=f[Da+16>>2]|0;if((ta|0)>0){ha=f[Da>>2]|0;if(!ha){ia=170;break}else{lb=Da;mb=ha}}else{if((ta|0)>=0){ia=174;break}nb=Da+4|0;ta=f[nb>>2]|0;if(!ta){ia=173;break}else{lb=nb;mb=ta}}va=lb;Da=mb;Ba=mb}if((ia|0)==170){ia=0;ob=Da;pb=Da;ia=177;break}else if((ia|0)==173){ia=0;ob=nb;pb=Da;ia=177;break}else if((ia|0)==174){ia=0;qb=va;rb=Da;sb=Ba;ia=176;break}}else{qb=Ha;rb=Ha;sb=ua;ia=176}while(0);if((ia|0)==176){ia=0;if(!sb){ob=qb;pb=rb;ia=177}else tb=sb}if((ia|0)==177){ia=0;ua=L5b(24)|0;f[ua+16>>2]=0;b[ua+20>>0]=0;f[ua>>2]=0;f[ua+4>>2]=0;f[ua+8>>2]=pb;f[ob>>2]=ua;Ha=f[f[Ia>>2]>>2]|0;if(!Ha)ub=ua;else{f[Ia>>2]=Ha;ub=f[ob>>2]|0}mP(f[Ta+228>>2]|0,ub);Ha=Ta+232|0;f[Ha>>2]=(f[Ha>>2]|0)+1;tb=ua}b[tb+20>>0]=1;ua=(f[c>>2]|0)==1;Ha=Jva(p,h)|0;ta=($|0)==(Ha|0);do if(ua){if(ta)break;bwa($+176|0,f[Ha+176>>2]|0,f[Ha+180>>2]|0)}else{if(ta)break;cwa($+140|0,f[Ha+140>>2]|0,f[Ha+144>>2]|0)}while(0);if((f[c>>2]|0)!=1){gb=Ta;ia=187;break}Ha=Ta+96|0;ta=Jva(p,f[Ha>>2]|0)|0;ua=h;f[ua>>2]=f[f[Ha>>2]>>2];f[ua+4>>2]=0;gb=ta;ia=187}while(0);if((ia|0)==187){ia=0;ta=f[m>>2]|0;do if(ta|0){ua=ta+4|0;Ha=f[ua>>2]|0;f[ua>>2]=Ha+-1;if((Ha|0)!=1)break;bi[f[(f[ta>>2]|0)+8>>2]&2047](ta)}while(0);if(!((f[c>>2]|0)!=1|(gb|0)==0)){fb=gb;ia=191}}do if((ia|0)==191){ia=0;ta=f[fb+136>>2]|0;if(!ta)vb=0;else vb=T6b(ta,17800,17912,0)|0;ta=f[fb+132>>2]|0;do if(!ta)wb=0;else{Ha=ta;ua=Ha+4|0;f[ua>>2]=(f[ua>>2]|0)+1;f[ua>>2]=(f[ua>>2]|0)+1;ua=Ha+4|0;Ia=f[ua>>2]|0;f[ua>>2]=Ia+-1;if((Ia|0)!=1){wb=ta;break}bi[f[(f[ta>>2]|0)+8>>2]&2047](Ha);wb=ta}while(0);h:do if(vb|0){ta=f[r>>2]|0;if(ta|0){Ha=f[h>>2]|0;Ia=f[o>>2]|0;ua=ta;do{ta=f[ua+16>>2]|0;do if((Ha|0)<(ta|0))ia=202;else{ha=(Ha|0)==(ta|0);if(ha?(Ia|0)<(f[ua+20>>2]|0):0){ia=202;break}if((ta|0)>=(Ha|0)){if(!ha)break h;if((f[ua+20>>2]|0)>=(Ia|0))break h}xb=ua+4|0}while(0);if((ia|0)==202){ia=0;xb=ua}ua=f[xb>>2]|0}while((ua|0)!=0)}ua=fb+60|0;Ia=ua;Ha=1;while(1){yb=Jva(p,(f[Ia>>2]|0)+(Ha<<3)|0)|0;Ba=yb+224|0;Da=yb+228|0;va=f[Da>>2]|0;do if(va){ta=yb+228|0;Ga=va;Fa=va;while(1){Ea=f[Ga+16>>2]|0;if((Ea|0)>0){ha=f[Ga>>2]|0;if(!ha){ia=214;break}else{zb=Ga;Ab=ha}}else{if((Ea|0)>=0){ia=218;break}Bb=Ga+4|0;Ea=f[Bb>>2]|0;if(!Ea){ia=217;break}else{zb=Bb;Ab=Ea}}ta=zb;Ga=Ab;Fa=Ab}if((ia|0)==214){ia=0;Cb=Ga;Db=Ga;ia=221;break}else if((ia|0)==217){ia=0;Cb=Bb;Db=Ga;ia=221;break}else if((ia|0)==218){ia=0;Eb=ta;Fb=Ga;Gb=Fa;ia=220;break}}else{Eb=Da;Fb=Da;Gb=va;ia=220}while(0);if((ia|0)==220){ia=0;if(!Gb){Cb=Eb;Db=Fb;ia=221}else Hb=Gb}if((ia|0)==221){ia=0;va=L5b(24)|0;f[va+16>>2]=0;b[va+20>>0]=0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=Db;f[Cb>>2]=va;Da=f[f[Ba>>2]>>2]|0;if(!Da)Ib=va;else{f[Ba>>2]=Da;Ib=f[Cb>>2]|0}mP(f[yb+228>>2]|0,Ib);Da=yb+232|0;f[Da>>2]=(f[Da>>2]|0)+1;Hb=va}if(!(b[Hb+20>>0]|0))break;Ia=yb+60|0;Ha=0}if((f[$>>2]|0)==(f[yb>>2]|0)){Jb=0;Kb=ua}else break;while(1){Lb=Jva(p,(f[Kb>>2]|0)+(Jb<<3)|0)|0;Ha=Lb+224|0;Ia=Lb+228|0;va=f[Ia>>2]|0;do if(va){Da=Lb+228|0;Ea=va;ha=va;while(1){jb=f[Ea+16>>2]|0;if((jb|0)>0){Mb=f[Ea>>2]|0;if(!Mb){ia=232;break}else{Nb=Ea;Ob=Mb}}else{if((jb|0)>=0){ia=236;break}Pb=Ea+4|0;jb=f[Pb>>2]|0;if(!jb){ia=235;break}else{Nb=Pb;Ob=jb}}Da=Nb;Ea=Ob;ha=Ob}if((ia|0)==232){ia=0;Qb=Ea;Rb=Ea;ia=239;break}else if((ia|0)==235){ia=0;Qb=Pb;Rb=Ea;ia=239;break}else if((ia|0)==236){ia=0;Sb=Da;Tb=Ea;Ub=ha;ia=238;break}}else{Sb=Ia;Tb=Ia;Ub=va;ia=238}while(0);if((ia|0)==238){ia=0;if(!Ub){Qb=Sb;Rb=Tb;ia=239}else Vb=Ub}if((ia|0)==239){ia=0;va=L5b(24)|0;f[va+16>>2]=0;b[va+20>>0]=0;f[va>>2]=0;f[va+4>>2]=0;f[va+8>>2]=Rb;f[Qb>>2]=va;Ia=f[f[Ha>>2]>>2]|0;if(!Ia)Wb=va;else{f[Ha>>2]=Ia;Wb=f[Qb>>2]|0}mP(f[Lb+228>>2]|0,Wb);Ia=Lb+232|0;f[Ia>>2]=(f[Ia>>2]|0)+1;Vb=va}if(!(b[Vb+20>>0]|0))break;va=f[Lb+12>>2]|0;if((va|0)!=410937?(gTb((va|0)==0?1124530:va,410937)|0)!=0:0)Xb=0;else Xb=1;Jb=Xb;Kb=Lb+60|0}ua=f[Lb+136>>2]|0;if(!ua)Yb=0;else Yb=T6b(ua,17800,17928,0)|0;ua=f[Lb+132>>2]|0;va=(ua|0)==0;Ia=ua;do if(!va){Ba=Ia+4|0;f[Ba>>2]=(f[Ba>>2]|0)+1;f[Ba>>2]=(f[Ba>>2]|0)+1;Ba=Ia+4|0;Fa=f[Ba>>2]|0;f[Ba>>2]=Fa+-1;if((Fa|0)!=1)break;bi[f[(f[ua>>2]|0)+8>>2]&2047](Ia)}while(0);if(Yb|0){Fa=fb+96|0;Ba=Jva(p,f[Fa>>2]|0)|0;Ga=h;f[Ga>>2]=f[f[Fa>>2]>>2];f[Ga+4>>2]=0;f[m>>2]=0;f[v>>2]=0;Ga=f[Ba+136>>2]|0;if(!Ga)Zb=0;else Zb=T6b(Ga,17800,17896,0)|0;Ga=f[Ba+132>>2]|0;Fa=Zb;if(!Ga){f[m>>2]=Ga;f[v>>2]=Fa;_b=Zb}else{ta=Ga+4|0;f[ta>>2]=(f[ta>>2]|0)+1;f[ta>>2]=(f[ta>>2]|0)+1;ta=f[m>>2]|0;f[m>>2]=Ga;f[v>>2]=Fa;do if(ta|0){Fa=ta+4|0;jb=f[Fa>>2]|0;f[Fa>>2]=jb+-1;if((jb|0)!=1)break;bi[f[(f[ta>>2]|0)+8>>2]&2047](ta)}while(0);ta=Ga;jb=ta+4|0;Fa=f[jb>>2]|0;f[jb>>2]=Fa+-1;if((Fa|0)==1)bi[f[(f[Ga>>2]|0)+8>>2]&2047](ta);_b=f[v>>2]|0}i:do if(_b|0){ta=f[r>>2]|0;if(ta|0){Fa=f[h>>2]|0;jb=f[o>>2]|0;Mb=ta;do{ta=f[Mb+16>>2]|0;do if((Fa|0)<(ta|0))ia=269;else{$b=(Fa|0)==(ta|0);if($b?(jb|0)<(f[Mb+20>>2]|0):0){ia=269;break}if((ta|0)>=(Fa|0)){if(!$b)break i;if((f[Mb+20>>2]|0)>=(jb|0))break i}ac=Mb+4|0}while(0);if((ia|0)==269){ia=0;ac=Mb}Mb=f[ac>>2]|0}while((Mb|0)!=0)}Mb=f[Ba+12>>2]|0;do if((Mb|0)!=380368){jb=(Mb|0)==0?1124530:Mb;if((gTb(jb,380368)|0)==0|(Mb|0)==410872)break;if((gTb(jb,410872)|0)==0|(Mb|0)==433229)break;if(gTb(jb,433229)|0)break i}while(0);Mb=f[$+136>>2]|0;if(!(Uh[f[(f[Mb>>2]|0)+68>>2]&1023](Mb,m)|0))break;Mb=Lb+176|0;jb=f[Mb>>2]|0;Fa=jb;do if(((f[Lb+180>>2]|0)-jb|0)==48){Ha=$+192|0;ta=f[Ha>>2]|0;if((ta-(f[$+188>>2]|0)|0)!=48){ia=283;break}bc=Ha;cc=ta;dc=Fa}else ia=283;while(0);if((ia|0)==283){ia=0;f[n>>2]=0;f[y>>2]=0;ec=aD(n,82)|0;fc=367065;gc=ec+82|0;do{b[ec>>0]=b[fc>>0]|0;ec=ec+1|0;fc=fc+1|0}while((ec|0)<(gc|0));bO(-215,n,367148,364488,1340);bD(n);Fa=$+192|0;bc=Fa;cc=f[Fa>>2]|0;dc=f[Mb>>2]|0}if((cc|0)==(f[$+196>>2]|0))Ipa($+188|0,dc);else{f[cc>>2]=f[dc>>2];Fa=cc+4|0;jb=dc+4|0;f[Fa>>2]=f[jb>>2];ta=cc+8|0;f[ta>>2]=f[dc+8>>2];f[cc+12>>2]=f[dc+12>>2];f[cc+16>>2]=f[dc+16>>2];f[cc+20>>2]=f[dc+20>>2];Ha=f[dc+24>>2]|0;f[cc+24>>2]=Ha;f[cc+28>>2]=f[dc+28>>2];f[cc+32>>2]=ta;ta=cc+40|0;ha=cc+36|0;f[ha>>2]=ta;f[cc+44>>2]=0;f[ta>>2]=0;if(Ha|0){ta=Ha+8|0;f[ta>>2]=(f[ta>>2]|0)+1}if((f[jb>>2]|0)<3){jb=f[dc+36>>2]|0;ta=f[ha>>2]|0;f[ta>>2]=f[jb>>2];f[ta+4>>2]=f[jb+4>>2]}else{f[Fa>>2]=0;gI(cc,dc)}f[bc>>2]=(f[bc>>2]|0)+48}Fa=fb+224|0;jb=fb+228|0;ta=f[jb>>2]|0;do if(ta){ha=fb+228|0;Ha=ta;Ea=ta;while(1){Da=f[Ha+16>>2]|0;if((Da|0)>0){$b=f[Ha>>2]|0;if(!$b){ia=297;break}else{hc=Ha;ic=$b}}else{if((Da|0)>=0){ia=301;break}jc=Ha+4|0;Da=f[jc>>2]|0;if(!Da){ia=300;break}else{hc=jc;ic=Da}}ha=hc;Ha=ic;Ea=ic}if((ia|0)==297){ia=0;kc=Ha;lc=Ha;ia=304;break}else if((ia|0)==300){ia=0;kc=jc;lc=Ha;ia=304;break}else if((ia|0)==301){ia=0;mc=ha;nc=Ha;oc=Ea;ia=303;break}}else{mc=jb;nc=jb;oc=ta;ia=303}while(0);if((ia|0)==303){ia=0;if(!oc){kc=mc;lc=nc;ia=304}else pc=oc}if((ia|0)==304){ia=0;ta=L5b(24)|0;f[ta+16>>2]=0;b[ta+20>>0]=0;f[ta>>2]=0;f[ta+4>>2]=0;f[ta+8>>2]=lc;f[kc>>2]=ta;jb=f[f[Fa>>2]>>2]|0;if(!jb)qc=ta;else{f[Fa>>2]=jb;qc=f[kc>>2]|0}mP(f[fb+228>>2]|0,qc);jb=fb+232|0;f[jb>>2]=(f[jb>>2]|0)+1;pc=ta}b[pc+20>>0]=1;ta=Ba+224|0;jb=Ba+228|0;Mb=f[jb>>2]|0;do if(Mb){Da=Ba+228|0;$b=Mb;rc=Mb;while(1){sc=f[$b+16>>2]|0;if((sc|0)>0){tc=f[$b>>2]|0;if(!tc){ia=312;break}else{uc=$b;vc=tc}}else{if((sc|0)>=0){ia=316;break}wc=$b+4|0;sc=f[wc>>2]|0;if(!sc){ia=315;break}else{uc=wc;vc=sc}}Da=uc;$b=vc;rc=vc}if((ia|0)==312){ia=0;xc=$b;yc=$b;ia=319;break}else if((ia|0)==315){ia=0;xc=wc;yc=$b;ia=319;break}else if((ia|0)==316){ia=0;zc=Da;Ac=$b;Bc=rc;ia=318;break}}else{zc=jb;Ac=jb;Bc=Mb;ia=318}while(0);if((ia|0)==318){ia=0;if(!Bc){xc=zc;yc=Ac;ia=319}else Cc=Bc}if((ia|0)==319){ia=0;Mb=L5b(24)|0;f[Mb+16>>2]=0;b[Mb+20>>0]=0;f[Mb>>2]=0;f[Mb+4>>2]=0;f[Mb+8>>2]=yc;f[xc>>2]=Mb;jb=f[f[ta>>2]>>2]|0;if(!jb)Dc=Mb;else{f[ta>>2]=jb;Dc=f[xc>>2]|0}mP(f[Ba+228>>2]|0,Dc);jb=Ba+232|0;f[jb>>2]=(f[jb>>2]|0)+1;Cc=Mb}b[Cc+20>>0]=1;Mb=Jva(p,h)|0;if(($|0)==(Mb|0))break;bwa($+176|0,f[Mb+176>>2]|0,f[Mb+180>>2]|0)}while(0);Ba=f[m>>2]|0;do if(Ba|0){Ga=Ba+4|0;Mb=f[Ga>>2]|0;f[Ga>>2]=Mb+-1;if((Mb|0)!=1)break;bi[f[(f[Ba>>2]|0)+8>>2]&2047](Ba)}while(0)}if(va)break;Ba=Ia+4|0;Mb=f[Ba>>2]|0;f[Ba>>2]=Mb+-1;if((Mb|0)!=1)break;bi[f[(f[ua>>2]|0)+8>>2]&2047](Ia)}while(0);Mb=wb;if(!wb)break;Ba=Mb+4|0;Ga=f[Ba>>2]|0;f[Ba>>2]=Ga+-1;if((Ga|0)!=1)break;bi[f[(f[wb>>2]|0)+8>>2]&2047](Mb)}while(0);Mb=f[i>>2]|0;do if(Mb|0){Ga=Mb+4|0;Ba=f[Ga>>2]|0;f[Ga>>2]=Ba+-1;if((Ba|0)!=1)break;bi[f[(f[Mb>>2]|0)+8>>2]&2047](Mb)}while(0);Mb=f[g>>2]|0;do if(Mb|0){Ba=Mb+4|0;Ga=f[Ba>>2]|0;f[Ba>>2]=Ga+-1;if((Ga|0)!=1)break;bi[f[(f[Mb>>2]|0)+8>>2]&2047](Mb)}while(0)}while(0);da=$+136|0;ea=f[da>>2]|0;if(!ea)Ec=0;else Ec=T6b(ea,17800,17944,0)|0;ea=f[fa>>2]|0;Mb=(ea|0)==0;if(!Mb){Ga=ea+4|0;f[Ga>>2]=(f[Ga>>2]|0)+1}j:do if(Ec|0?(Ga=f[ca>>2]|0,Ba=f[ga>>2]|0,(Ga|0)!=(Ba|0)):0){jb=Ba-Ga>>3;if(jb|0){Ba=0;do{if((f[Ga+(Ba<<3)+4>>2]|0)>0)break j;Ba=Ba+1|0}while(Ba>>>0<jb>>>0)}b[Ec+65>>0]=0}while(0);ga=f[da>>2]|0;if(!ga)Fc=0;else Fc=T6b(ga,17800,17960,0)|0;ga=f[fa>>2]|0;ca=(ga|0)==0;if(!ca){jb=ga+4|0;f[jb>>2]=(f[jb>>2]|0)+1}do if(Fc|0?(f[Fc+36>>2]|0)==1:0){if(b[Fc+40>>0]|0)break;jb=f[$+140>>2]|0;Ba=jb;if(((f[$+144>>2]|0)-jb|0)!=56)break;if((f[Ba+4>>2]|0)!=4)break;if((f[f[Ba+40>>2]>>2]|0)!=1)break;jb=$+60|0;Ga=(f[$+64>>2]|0)-(f[jb>>2]|0)|0;Fa=Ga>>3;f[g>>2]=0;f[B>>2]=0;f[C>>2]=0;Ea=(Fa|0)==0;do if(Ea){f[h>>2]=-2147483648;f[E>>2]=2147483647;f[F>>2]=-2147483648;f[G>>2]=2147483647;f[H>>2]=-2147483648;f[I>>2]=2147483647;f[J>>2]=-2147483648;f[K>>2]=2147483647;ia=441}else{if(Fa>>>0>536870911)break b;Ha=L5b(Ga)|0;f[g>>2]=Ha;ha=Ha+(Fa<<3)|0;f[D>>2]=ha;Nac(Ha|0,-1,Ga|0)|0;f[B>>2]=ha;ha=0;do{Ha=(f[jb>>2]|0)+(ha<<3)|0;sc=f[Ha+4>>2]|0;tc=h;f[tc>>2]=f[Ha>>2];f[tc+4>>2]=sc;while(1){Gc=Jva(p,h)|0;Hc=Gc+224|0;Ic=Gc+228|0;sc=f[Ic>>2]|0;do if(sc){tc=Gc+228|0;Ha=sc;Jc=sc;while(1){Kc=f[Ha+16>>2]|0;if((Kc|0)>0){Lc=f[Ha>>2]|0;if(!Lc){ia=371;break}else{Mc=Ha;Nc=Lc}}else{if((Kc|0)>=0){ia=375;break}Oc=Ha+4|0;Kc=f[Oc>>2]|0;if(!Kc){ia=374;break}else{Mc=Oc;Nc=Kc}}tc=Mc;Ha=Nc;Jc=Nc}if((ia|0)==371){ia=0;Pc=Ha;Qc=Ha;ia=378;break}else if((ia|0)==374){ia=0;Pc=Oc;Qc=Ha;ia=378;break}else if((ia|0)==375){ia=0;Rc=tc;Sc=Ha;Tc=Jc;ia=377;break}}else{Rc=Ic;Sc=Ic;Tc=sc;ia=377}while(0);if((ia|0)==377){ia=0;if(!Tc){Pc=Rc;Qc=Sc;ia=378}else Uc=Tc}if((ia|0)==378){ia=0;sc=L5b(24)|0;f[sc+16>>2]=0;b[sc+20>>0]=0;f[sc>>2]=0;f[sc+4>>2]=0;f[sc+8>>2]=Qc;f[Pc>>2]=sc;ta=f[f[Hc>>2]>>2]|0;if(!ta)Vc=sc;else{f[Hc>>2]=ta;Vc=f[Pc>>2]|0}mP(f[Gc+228>>2]|0,Vc);ta=Gc+232|0;f[ta>>2]=(f[ta>>2]|0)+1;Uc=sc}if(!(b[Uc+20>>0]|0))break;sc=f[Gc+60>>2]|0;if(((f[Gc+64>>2]|0)-sc|0)!=8)break;ta=sc;sc=f[ta+4>>2]|0;rc=h;f[rc>>2]=f[ta>>2];f[rc+4>>2]=sc}Ia=f[Ic>>2]|0;do if(Ia){ua=Gc+228|0;va=Ia;sc=Ia;while(1){rc=f[va+16>>2]|0;if((rc|0)>0){ta=f[va>>2]|0;if(!ta){ia=389;break}else{Wc=va;Xc=ta}}else{if((rc|0)>=0){ia=393;break}Yc=va+4|0;rc=f[Yc>>2]|0;if(!rc){ia=392;break}else{Wc=Yc;Xc=rc}}ua=Wc;va=Xc;sc=Xc}if((ia|0)==389){ia=0;Zc=va;_c=va;ia=396;break}else if((ia|0)==392){ia=0;Zc=Yc;_c=va;ia=396;break}else if((ia|0)==393){ia=0;$c=ua;ad=va;bd=sc;ia=395;break}}else{$c=Ic;ad=Ic;bd=Ia;ia=395}while(0);if((ia|0)==395){ia=0;if(!bd){Zc=$c;_c=ad;ia=396}else cd=bd}if((ia|0)==396){ia=0;Ia=L5b(24)|0;f[Ia+16>>2]=0;b[Ia+20>>0]=0;f[Ia>>2]=0;f[Ia+4>>2]=0;f[Ia+8>>2]=_c;f[Zc>>2]=Ia;rc=f[f[Hc>>2]>>2]|0;if(!rc)dd=Ia;else{f[Hc>>2]=rc;dd=f[Zc>>2]|0}mP(f[Gc+228>>2]|0,dd);rc=Gc+232|0;f[rc>>2]=(f[rc>>2]|0)+1;cd=Ia}if(b[cd+20>>0]|0){ia=402;break}if(((f[Gc+100>>2]|0)-(f[Gc+96>>2]|0)|0)!=8){ia=402;break}Ia=h;rc=f[Ia+4>>2]|0;ta=(f[g>>2]|0)+(ha<<3)|0;f[ta>>2]=f[Ia>>2];f[ta+4>>2]=rc;ha=ha+1|0}while(ha>>>0<Fa>>>0);if((ia|0)==402){ia=0;break}f[h>>2]=-2147483648;f[E>>2]=2147483647;f[F>>2]=-2147483648;f[G>>2]=2147483647;f[H>>2]=-2147483648;f[I>>2]=2147483647;f[J>>2]=-2147483648;f[K>>2]=2147483647;if(Ea){ia=441;break}ha=$+152|0;rc=0;ta=0;while(1){Ia=(f[g>>2]|0)+(ta<<3)|0;$b=f[Ia+4>>2]|0;Da=i;f[Da>>2]=f[Ia>>2];f[Da+4>>2]=$b;$b=Jva(p,i)|0;Da=rc;rc=(f[(f[(f[(f[ha>>2]|0)+(ta<<2)>>2]|0)+40>>2]|0)+4>>2]|0)+rc|0;Ia=F;f[Ia>>2]=Da;f[Ia+4>>2]=rc;mL(m,Ba,h);Ia=f[L>>2]|0;Da=f[$b+140>>2]|0;$b=Da+(Ia*56|0)|0;k:do if(!(f[m>>2]&16384))ia=413;else{Kc=f[Q>>2]|0;Lc=f[Kc+-4>>2]|0;ed=f[Da+(Ia*56|0)+40>>2]|0;if((Lc|0)!=(f[ed+-4>>2]|0)){ia=413;break}if((Lc|0)==2){if((f[Kc>>2]|0)!=(f[ed>>2]|0)){ia=413;break}if((f[Kc+4>>2]|0)==(f[ed+4>>2]|0))break;else{ia=413;break}}if((Lc|0)>0)fd=0;else break;do{if((f[Kc+(fd<<2)>>2]|0)!=(f[ed+(fd<<2)>>2]|0)){ia=413;break k}fd=fd+1|0}while((fd|0)<(Lc|0))}while(0);if((ia|0)==413){ia=0;f[n>>2]=0;f[M>>2]=0;ec=aD(n,68)|0;fc=367159;gc=ec+68|0;do{b[ec>>0]=b[fc>>0]|0;ec=ec+1|0;fc=fc+1|0}while((ec|0)<(gc|0));bO(-215,n,367148,364488,1430);bD(n)}if(($b|0)!=(m|0)){Lc=f[N>>2]|0;if(Lc|0){ed=Lc+12|0;f[ed>>2]=(f[ed>>2]|0)+1}ed=Da+(Ia*56|0)+36|0;Lc=f[ed>>2]|0;do if(Lc|0){Kc=Lc+12|0;sc=f[Kc>>2]|0;f[Kc>>2]=sc+-1;if((sc|0)!=1)break;kL($b)}while(0);f[ed>>2]=0;Lc=Da+(Ia*56|0)+16|0;sc=Da+(Ia*56|0)+4|0;f[Lc>>2]=0;f[Lc+4>>2]=0;f[Lc+8>>2]=0;f[Lc+12>>2]=0;if((f[sc>>2]|0)>0){Kc=f[Da+(Ia*56|0)+40>>2]|0;va=0;do{f[Kc+(va<<2)>>2]=0;va=va+1|0;gd=f[sc>>2]|0}while((va|0)<(gd|0));f[$b>>2]=f[m>>2];if((gd|0)<3)ia=425;else ia=427}else{f[$b>>2]=f[m>>2];ia=425}do if((ia|0)==425){ia=0;va=f[P>>2]|0;if((va|0)>=3){ia=427;break}f[sc>>2]=va;f[Da+(Ia*56|0)+8>>2]=f[U>>2];f[Da+(Ia*56|0)+12>>2]=f[V>>2];va=f[R>>2]|0;Kc=f[Da+(Ia*56|0)+44>>2]|0;f[Kc>>2]=f[va>>2];f[Kc+4>>2]=f[va+4>>2]}while(0);if((ia|0)==427){ia=0;jL($b,m)}f[Lc>>2]=f[O>>2];f[Da+(Ia*56|0)+20>>2]=f[W>>2];f[Da+(Ia*56|0)+24>>2]=f[X>>2];f[Da+(Ia*56|0)+28>>2]=f[Y>>2];f[Da+(Ia*56|0)+32>>2]=f[Z>>2];f[ed>>2]=f[N>>2]}sc=(f[jb>>2]|0)+(ta<<3)|0;va=f[sc+4>>2]|0;Kc=i;f[Kc>>2]=f[sc>>2];f[Kc+4>>2]=va;va=Jva(p,i)|0;Kc=va+96|0;sc=va+100|0;va=f[Kc>>2]|0;if((f[sc>>2]|0)!=(va|0)){ua=0;hd=va;do{va=hd+(ua<<3)|0;id=f[va+4>>2]|0;jd=n;f[jd>>2]=f[va>>2];f[jd+4>>2]=id;id=Jva(p,n)|0;f[(f[id+152>>2]|0)+(f[T>>2]<<2)>>2]=$b;ua=ua+1|0;hd=f[Kc>>2]|0}while(ua>>>0<(f[sc>>2]|0)-hd>>3>>>0)}hd=f[N>>2]|0;do if(hd|0){sc=hd+12|0;ua=f[sc>>2]|0;f[sc>>2]=ua+-1;if((ua|0)!=1)break;kL(m)}while(0);f[N>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[P>>2]|0)>0){hd=f[Q>>2]|0;ua=0;do{f[hd+(ua<<2)>>2]=0;ua=ua+1|0}while((ua|0)<(f[P>>2]|0))}ua=f[R>>2]|0;if((ua|0)!=(S|0))UC(ua);ta=ta+1|0;if(ta>>>0>=Fa>>>0){ia=441;break}}}while(0);if((ia|0)==441){ia=0;Fa=f[ba>>2]|0;do if(Fa){jb=$+228|0;Ba=Fa;Ea=Fa;while(1){Ga=f[Ba+16>>2]|0;if((Ga|0)>0){ta=f[Ba>>2]|0;if(!ta){ia=446;break}else{kd=Ba;ld=ta}}else{if((Ga|0)>=0){ia=450;break}md=Ba+4|0;Ga=f[md>>2]|0;if(!Ga){ia=449;break}else{kd=md;ld=Ga}}jb=kd;Ba=ld;Ea=ld}if((ia|0)==446){ia=0;nd=Ba;od=Ba;ia=453;break}else if((ia|0)==449){ia=0;nd=md;od=Ba;ia=453;break}else if((ia|0)==450){ia=0;pd=jb;qd=Ba;rd=Ea;ia=452;break}}else{pd=ba;qd=ba;rd=Fa;ia=452}while(0);if((ia|0)==452){ia=0;if(!rd){nd=pd;od=qd;ia=453}else sd=rd}if((ia|0)==453){ia=0;Fa=L5b(24)|0;f[Fa+16>>2]=0;b[Fa+20>>0]=0;f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=od;f[nd>>2]=Fa;Ga=f[f[aa>>2]>>2]|0;if(!Ga)td=Fa;else{f[aa>>2]=Ga;td=f[nd>>2]|0}mP(f[$+228>>2]|0,td);Ga=$+232|0;f[Ga>>2]=(f[Ga>>2]|0)+1;sd=Fa}b[sd+20>>0]=1}Fa=f[g>>2]|0;if(Fa|0){Ga=f[B>>2]|0;if((Ga|0)!=(Fa|0))f[B>>2]=Ga+(~((Ga+-8-Fa|0)>>>3)<<3);O5b(Fa)}}while(0);fa=ga;do if(!ca){da=fa+4|0;Fa=f[da>>2]|0;f[da>>2]=Fa+-1;if((Fa|0)!=1)break;bi[f[(f[ga>>2]|0)+8>>2]&2047](fa)}while(0);fa=ea;if(!Mb){ga=fa+4|0;ca=f[ga>>2]|0;f[ga>>2]=ca+-1;if((ca|0)!=1)break;bi[f[(f[ea>>2]|0)+8>>2]&2047](fa)}}while(0);$=f[_+4>>2]|0;if(!$){aa=_+8|0;ba=f[aa>>2]|0;if((f[ba>>2]|0)==(_|0))ud=ba;else{ba=aa;do{aa=f[ba>>2]|0;ba=aa+8|0;fa=f[ba>>2]|0}while((f[fa>>2]|0)!=(aa|0));ud=fa}}else{ba=$;while(1){fa=f[ba>>2]|0;if(!fa)break;else ba=fa}ud=ba}if((ud|0)==(q|0)){A=r;break a}else _=ud}c4b(g)}while(0);$va(l,f[A>>2]|0);A=f[k>>2]|0;if(A|0){while(1){l=f[j>>2]|0;if((l|0)==(A|0))break;g=l+-8|0;f[j>>2]=g;bD(g)}O5b(f[k>>2]|0)}u=d;return}function Zva(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if(!b)return;Zva(a,f[b>>2]|0);Zva(a,f[b+4>>2]|0);a=b+44|0;c=f[a>>2]|0;if(c|0){d=b+48|0;e=f[d>>2]|0;if((e|0)==(c|0))g=c;else{h=e;while(1){e=h+-12|0;f[d>>2]=e;i=f[e>>2]|0;if(!i)j=e;else{e=h+-8|0;k=f[e>>2]|0;if((k|0)!=(i|0))f[e>>2]=k+(~((k+-4-i|0)>>>2)<<2);O5b(i);j=f[d>>2]|0}if((j|0)==(c|0))break;else h=j}g=f[a>>2]|0}O5b(g)}g=b+32|0;a=f[g>>2]|0;if(a|0){j=b+36|0;h=f[j>>2]|0;if((h|0)==(a|0))l=a;else{c=h;while(1){h=c+-12|0;f[j>>2]=h;d=f[h>>2]|0;if(!d)m=h;else{h=c+-8|0;i=f[h>>2]|0;if((i|0)!=(d|0))f[h>>2]=i+(~((i+-4-d|0)>>>2)<<2);O5b(d);m=f[j>>2]|0}if((m|0)==(a|0))break;else c=m}l=f[g>>2]|0}O5b(l)}l=b+20|0;g=f[l>>2]|0;if(g|0){m=b+24|0;c=f[m>>2]|0;if((c|0)==(g|0))n=g;else{a=c;while(1){c=a+-12|0;f[m>>2]=c;j=f[c>>2]|0;if(!j)o=c;else{c=a+-8|0;d=f[c>>2]|0;if((d|0)!=(j|0))f[c>>2]=d+(~((d+-4-j|0)>>>2)<<2);O5b(j);o=f[m>>2]|0}if((o|0)==(g|0))break;else a=o}n=f[l>>2]|0}O5b(n)}O5b(b);return}function _va(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=a+4|0;h=f[b>>2]|0;b=h;do if((h|0)!=(g|0)?(i=f[e>>2]|0,j=f[h+16>>2]|0,(i|0)>=(j|0)):0){k=(i|0)==(j|0);if(k?(f[e+4>>2]|0)<(f[h+20>>2]|0):0)break;do if((j|0)>=(i|0)){if(k?(f[h+20>>2]|0)<(f[e+4>>2]|0):0)break;f[c>>2]=b;f[d>>2]=b;l=d;return l|0}while(0);k=h+4|0;j=f[k>>2]|0;if(!j){m=h+8|0;n=f[m>>2]|0;if((f[n>>2]|0)==(h|0))o=n;else{n=m;do{m=f[n>>2]|0;n=m+8|0;p=f[n>>2]|0}while((f[p>>2]|0)!=(m|0));o=p}}else{n=j;while(1){p=f[n>>2]|0;if(!p)break;else n=p}o=n}do if((o|0)!=(g|0)?(j=f[o+16>>2]|0,(i|0)>=(j|0)):0){if((i|0)==(j|0)?(f[e+4>>2]|0)<(f[o+20>>2]|0):0)break;j=f[g>>2]|0;if(!j){f[c>>2]=g;l=g;return l|0}p=f[e+4>>2]|0;m=a+4|0;q=j;a:while(1){j=f[q+16>>2]|0;do if((i|0)>=(j|0)){r=(i|0)==(j|0);if(r?(p|0)<(f[q+20>>2]|0):0){s=51;break}if((j|0)>=(i|0)){if(!r){s=58;break a}if((f[q+20>>2]|0)>=(p|0)){s=58;break a}}t=q+4|0;r=f[t>>2]|0;if(!r){s=57;break a}else{u=t;v=r}}else s=51;while(0);if((s|0)==51){s=0;j=f[q>>2]|0;if(!j){s=52;break}else{u=q;v=j}}m=u;q=v}if((s|0)==52){f[c>>2]=q;l=q;return l|0}else if((s|0)==57){f[c>>2]=q;l=t;return l|0}else if((s|0)==58){f[c>>2]=q;l=m;return l|0}}while(0);if(!(f[h+4>>2]|0)){f[c>>2]=b;l=k;return l|0}else{f[c>>2]=o;l=o;return l|0}}while(0);o=f[h>>2]|0;do if((h|0)!=(f[a>>2]|0)){if(!o){t=h;while(1){v=f[t+8>>2]|0;if((f[v>>2]|0)==(t|0))t=v;else{w=v;break}}}else{t=o;while(1){k=f[t+4>>2]|0;if(!k){w=t;break}else t=k}}t=w;k=f[w+16>>2]|0;v=f[e>>2]|0;if((k|0)>=(v|0)){if((k|0)==(v|0)?(f[w+20>>2]|0)<(f[e+4>>2]|0):0){x=t;break}k=f[g>>2]|0;if(!k){f[c>>2]=g;l=g;return l|0}u=f[e+4>>2]|0;d=a+4|0;i=k;b:while(1){k=f[i+16>>2]|0;do if((v|0)>=(k|0)){n=(v|0)==(k|0);if(n?(u|0)<(f[i+20>>2]|0):0){s=21;break}if((k|0)>=(v|0)){if(!n){s=28;break b}if((f[i+20>>2]|0)>=(u|0)){s=28;break b}}y=i+4|0;n=f[y>>2]|0;if(!n){s=27;break b}else{z=y;A=n}}else s=21;while(0);if((s|0)==21){s=0;k=f[i>>2]|0;if(!k){s=22;break}else{z=i;A=k}}d=z;i=A}if((s|0)==22){f[c>>2]=i;l=i;return l|0}else if((s|0)==27){f[c>>2]=i;l=y;return l|0}else if((s|0)==28){f[c>>2]=i;l=d;return l|0}}else x=t}else x=b;while(0);if(!o){f[c>>2]=h;l=h;return l|0}else{h=x;f[c>>2]=h;l=h+4|0;return l|0}return 0}function $va(a,b){a=a|0;b=b|0;if(!b)return;else{$va(a,f[b>>2]|0);$va(a,f[b+4>>2]|0);O5b(b);return}}function awa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=d-e>>3;h=g+1|0;i=e;j=d;if(h>>>0>536870911)c4b(a);k=a+8|0;l=(f[k>>2]|0)-e|0;e=l>>2;m=l>>3>>>0<268435455?(e>>>0<h>>>0?h:e):536870911;do if(m)if(m>>>0>536870911){e=ze(8)|0;T5b(e,477177);f[e>>2]=149528;If(e|0,25408,1411)}else{n=L5b(m<<3)|0;break}else n=0;while(0);e=n+(g<<3)|0;h=e;l=n+(m<<3)|0;m=f[b>>2]|0;f[e>>2]=m;f[n+(g<<3)+4>>2]=f[b+4>>2];if(!m){o=j;p=i;q=d}else{d=m+-4|0;f[d>>2]=(f[d>>2]|0)+1;d=f[c>>2]|0;o=d;p=f[a>>2]|0;q=d}d=e+8|0;if((o|0)==(p|0)){r=h;s=o;t=q}else{q=o;o=h;h=e;do{e=q;q=q+-8|0;m=f[q>>2]|0;f[h+-8>>2]=m;f[h+-4>>2]=f[e+-4>>2];if(m|0){e=m+-4|0;f[e>>2]=(f[e>>2]|0)+1}h=o+-8|0;o=h}while((q|0)!=(p|0));r=o;s=f[a>>2]|0;t=f[c>>2]|0}f[a>>2]=r;f[c>>2]=d;f[k>>2]=l;l=s;k=t;while(1){t=k;if((t|0)==(l|0))break;d=t+-8|0;bD(d);k=d}if(!s)return;O5b(s);return}function bwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=(c-b|0)/48|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0>((g-h|0)/48|0)>>>0){if(!h)j=g;else{g=a+4|0;while(1){k=f[g>>2]|0;if((k|0)==(i|0))break;l=k+-48|0;f[g>>2]=l;hI(l)}O5b(f[a>>2]|0);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;j=0}if(d>>>0>89478485)c4b(a);g=(j|0)/48|0;j=g<<1;l=g>>>0<44739242?(j>>>0<d>>>0?d:j):89478485;if(l>>>0>89478485)c4b(a);j=L5b(l*48|0)|0;g=a+4|0;f[g>>2]=j;f[a>>2]=j;f[e>>2]=j+(l*48|0);if((b|0)==(c|0))return;l=b;e=j;do{f[e>>2]=f[l>>2];j=e+4|0;k=l+4|0;f[j>>2]=f[k>>2];m=e+8|0;f[m>>2]=f[l+8>>2];f[e+12>>2]=f[l+12>>2];f[e+16>>2]=f[l+16>>2];f[e+20>>2]=f[l+20>>2];n=f[l+24>>2]|0;f[e+24>>2]=n;f[e+28>>2]=f[l+28>>2];f[e+32>>2]=m;m=e+40|0;o=e+36|0;f[o>>2]=m;f[e+44>>2]=0;f[m>>2]=0;if(n|0){m=n+8|0;f[m>>2]=(f[m>>2]|0)+1}if((f[k>>2]|0)<3){k=f[l+36>>2]|0;m=f[o>>2]|0;f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2]}else{f[j>>2]=0;gI(e,l)}l=l+48|0;e=(f[g>>2]|0)+48|0;f[g>>2]=e}while((l|0)!=(c|0));return}l=a+4|0;a=((f[l>>2]|0)-h|0)/48|0;h=d>>>0>a>>>0;d=b+(a*48|0)|0;a=h?d:c;if((a|0)==(b|0))p=i;else{e=i;i=b;while(1){if((e|0)!=(i|0)){b=i+24|0;g=f[b>>2]|0;if(g|0){j=g+8|0;f[j>>2]=(f[j>>2]|0)+1}j=e+24|0;g=f[j>>2]|0;if(g|0?(k=g+8|0,g=f[k>>2]|0,f[k>>2]=g+-1,(g|0)==1):0)iI(e);g=e+4|0;if((f[g>>2]|0)>0){k=f[e+32>>2]|0;m=0;do{f[k+(m<<2)>>2]=0;m=m+1|0;q=f[g>>2]|0}while((m|0)<(q|0));f[j>>2]=0;f[e>>2]=f[i>>2];if((q|0)<3)r=14;else r=16}else{f[j>>2]=0;f[e>>2]=f[i>>2];r=14}if((r|0)==14){r=0;m=f[i+4>>2]|0;if((m|0)<3){f[g>>2]=m;f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];m=f[i+36>>2]|0;k=f[e+36>>2]|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2]}else r=16}if((r|0)==16){r=0;gI(e,i)}f[e+16>>2]=f[i+16>>2];m=e+20|0;if(!(f[m>>2]|0))f[m>>2]=f[i+20>>2];f[j>>2]=f[b>>2];f[e+28>>2]=f[i+28>>2]}i=i+48|0;m=e+48|0;if((i|0)==(a|0)){p=m;break}else e=m}}if(!h){while(1){h=f[l>>2]|0;if((h|0)==(p|0))break;e=h+-48|0;f[l>>2]=e;hI(e)}return}if((a|0)==(c|0))return;a=d;d=f[l>>2]|0;do{f[d>>2]=f[a>>2];p=d+4|0;e=a+4|0;f[p>>2]=f[e>>2];h=d+8|0;f[h>>2]=f[a+8>>2];f[d+12>>2]=f[a+12>>2];f[d+16>>2]=f[a+16>>2];f[d+20>>2]=f[a+20>>2];i=f[a+24>>2]|0;f[d+24>>2]=i;f[d+28>>2]=f[a+28>>2];f[d+32>>2]=h;h=d+40|0;r=d+36|0;f[r>>2]=h;f[d+44>>2]=0;f[h>>2]=0;if(i|0){h=i+8|0;f[h>>2]=(f[h>>2]|0)+1}if((f[e>>2]|0)<3){e=f[a+36>>2]|0;h=f[r>>2]|0;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2]}else{f[p>>2]=0;gI(d,a)}a=a+48|0;d=(f[l>>2]|0)+48|0;f[l>>2]=d}while((a|0)!=(c|0));return}function cwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=(c-b|0)/56|0;e=a+8|0;g=f[a>>2]|0;h=g;if(d>>>0>(((f[e>>2]|0)-g|0)/56|0)>>>0){dwa(a);if(d>>>0>76695844)c4b(a);i=((f[e>>2]|0)-(f[a>>2]|0)|0)/56|0;j=i<<1;k=i>>>0<38347922?(j>>>0<d>>>0?d:j):76695844;if(k>>>0>76695844)c4b(a);j=L5b(k*56|0)|0;i=a+4|0;f[i>>2]=j;f[a>>2]=j;f[e>>2]=j+(k*56|0);if((b|0)==(c|0))return;k=b;e=j;do{f[e>>2]=f[k>>2];j=e+4|0;l=k+4|0;f[j>>2]=f[l>>2];m=e+8|0;f[m>>2]=f[k+8>>2];f[e+12>>2]=f[k+12>>2];f[e+16>>2]=f[k+16>>2];f[e+20>>2]=f[k+20>>2];f[e+24>>2]=f[k+24>>2];f[e+28>>2]=f[k+28>>2];f[e+32>>2]=f[k+32>>2];n=f[k+36>>2]|0;f[e+36>>2]=n;f[e+40>>2]=m;m=e+48|0;o=e+44|0;f[o>>2]=m;f[m>>2]=0;f[e+52>>2]=0;if(n|0){m=n+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[l>>2]|0)<3){l=f[k+44>>2]|0;m=f[o>>2]|0;f[m>>2]=f[l>>2];f[m+4>>2]=f[l+4>>2]}else{f[j>>2]=0;jL(e,k)}k=k+56|0;e=(f[i>>2]|0)+56|0;f[i>>2]=e}while((k|0)!=(c|0));return}k=a+4|0;a=((f[k>>2]|0)-g|0)/56|0;g=d>>>0>a>>>0;d=b+(a*56|0)|0;a=g?d:c;if((a|0)==(b|0))p=h;else{e=h;h=b;while(1){if((e|0)!=(h|0)){b=h+36|0;i=f[b>>2]|0;if(i|0){j=i+12|0;f[j>>2]=(f[j>>2]|0)+1}j=e+36|0;i=f[j>>2]|0;if(i|0?(l=i+12|0,i=f[l>>2]|0,f[l>>2]=i+-1,(i|0)==1):0)kL(e);f[j>>2]=0;i=e+16|0;l=e+4|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[l>>2]|0)>0){m=f[e+40>>2]|0;o=0;do{f[m+(o<<2)>>2]=0;o=o+1|0;q=f[l>>2]|0}while((o|0)<(q|0));f[e>>2]=f[h>>2];if((q|0)<3)r=14;else r=16}else{f[e>>2]=f[h>>2];r=14}if((r|0)==14){r=0;o=f[h+4>>2]|0;if((o|0)<3){f[l>>2]=o;f[e+8>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];o=f[h+44>>2]|0;m=f[e+44>>2]|0;f[m>>2]=f[o>>2];f[m+4>>2]=f[o+4>>2]}else r=16}if((r|0)==16){r=0;jL(e,h)}f[i>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];f[j>>2]=f[b>>2]}h=h+56|0;o=e+56|0;if((h|0)==(a|0)){p=o;break}else e=o}}if(g){if((a|0)==(c|0))return;a=d;d=f[k>>2]|0;do{f[d>>2]=f[a>>2];g=d+4|0;e=a+4|0;f[g>>2]=f[e>>2];h=d+8|0;f[h>>2]=f[a+8>>2];f[d+12>>2]=f[a+12>>2];f[d+16>>2]=f[a+16>>2];f[d+20>>2]=f[a+20>>2];f[d+24>>2]=f[a+24>>2];f[d+28>>2]=f[a+28>>2];f[d+32>>2]=f[a+32>>2];r=f[a+36>>2]|0;f[d+36>>2]=r;f[d+40>>2]=h;h=d+48|0;q=d+44|0;f[q>>2]=h;f[h>>2]=0;f[d+52>>2]=0;if(r|0){h=r+12|0;f[h>>2]=(f[h>>2]|0)+1}if((f[e>>2]|0)<3){e=f[a+44>>2]|0;h=f[q>>2]|0;f[h>>2]=f[e>>2];f[h+4>>2]=f[e+4>>2]}else{f[g>>2]=0;jL(d,a)}a=a+56|0;d=(f[k>>2]|0)+56|0;f[k>>2]=d}while((a|0)!=(c|0));return}c=f[k>>2]|0;if((c|0)==(p|0))return;else s=c;do{c=s+-56|0;f[k>>2]=c;a=s+-20|0;d=f[a>>2]|0;if(d|0?(g=d+12|0,d=f[g>>2]|0,f[g>>2]=d+-1,(d|0)==1):0)kL(c);f[a>>2]=0;a=s+-40|0;c=s+-52|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[c>>2]|0)>0){a=f[s+-16>>2]|0;d=0;do{f[a+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[c>>2]|0))}c=f[s+-12>>2]|0;if((c|0)!=(s+-8|0))UC(c);s=f[k>>2]|0}while((s|0)!=(p|0));return}function dwa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=f[a>>2]|0;if(!b)return;c=a+4|0;d=f[c>>2]|0;if((d|0)==(b|0))e=b;else{g=d;do{d=g+-56|0;f[c>>2]=d;h=g+-20|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)kL(d);f[h>>2]=0;h=g+-40|0;d=g+-52|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[d>>2]|0)>0){h=f[g+-16>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[d>>2]|0))}d=f[g+-12>>2]|0;if((d|0)!=(g+-8|0))UC(d);g=f[c>>2]|0}while((g|0)!=(b|0));e=f[a>>2]|0}O5b(e);f[a+8>>2]=0;f[c>>2]=0;f[a>>2]=0;return}function ewa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;if(d-g>>2>>>0>=b>>>0){h=b;i=g;do{f[i>>2]=0;i=(f[e>>2]|0)+4|0;f[e>>2]=i;h=h+-1|0}while((h|0)!=0);return}h=f[a>>2]|0;i=g-h>>2;g=i+b|0;if(g>>>0>1073741823)c4b(a);j=d-h|0;h=j>>1;d=j>>2>>>0<536870911?(h>>>0<g>>>0?g:h):1073741823;do if(d)if(d>>>0>1073741823){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{k=L5b(d<<2)|0;break}else k=0;while(0);h=k+(i<<2)|0;i=k+(d<<2)|0;d=b;b=h;k=h;do{f[k>>2]=0;k=b+4|0;b=k;d=d+-1|0}while((d|0)!=0);d=f[a>>2]|0;k=(f[e>>2]|0)-d|0;g=h+(0-(k>>2)<<2)|0;if((k|0)>0)Vac(g|0,d|0,k|0)|0;f[a>>2]=g;f[e>>2]=b;f[c>>2]=i;if(!d)return;O5b(d);return}function fwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=a+8|0;d=f[c>>2]|0;e=a+4|0;g=f[e>>2]|0;h=g;if(d-g>>3>>>0>=b>>>0){Nac(g|0,0,b<<3|0)|0;f[e>>2]=h+(b<<3);return}i=f[a>>2]|0;j=g-i>>3;k=j+b|0;l=i;if(k>>>0>536870911)c4b(a);m=d-i|0;i=m>>2;d=m>>3>>>0<268435455?(i>>>0<k>>>0?k:i):536870911;do if(d)if(d>>>0>536870911){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{n=L5b(d<<3)|0;break}else n=0;while(0);i=n+(j<<3)|0;j=i;k=n+(d<<3)|0;Nac(i|0,0,b<<3|0)|0;d=i+(b<<3)|0;if((h|0)==(l|0)){o=j;p=g;q=h}else{g=h;h=j;j=i;do{i=g;g=g+-8|0;b=f[g>>2]|0;f[j+-8>>2]=b;f[j+-4>>2]=f[i+-4>>2];if(b|0){i=b+4|0;f[i>>2]=(f[i>>2]|0)+1}j=h+-8|0;h=j}while((g|0)!=(l|0));o=h;p=f[a>>2]|0;q=f[e>>2]|0}f[a>>2]=o;f[e>>2]=d;f[c>>2]=k;k=p;if((q|0)!=(k|0)){c=q;do{q=c;c=c+-8|0;d=f[c>>2]|0;if(d|0?(e=d+4|0,o=f[e>>2]|0,f[e>>2]=o+-1,(o|0)==1):0)bi[f[(f[d>>2]|0)+8>>2]&2047](d);f[c>>2]=0;f[q+-4>>2]=0}while((c|0)!=(k|0))}if(!p)return;O5b(p);return}function gwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;f[a>>2]=0;c=a+4|0;f[c>>2]=0;f[a+8>>2]=0;d=b+4|0;e=(f[d>>2]|0)-(f[b>>2]|0)|0;g=(e|0)/12|0;if(!e)return;if(g>>>0>357913941)c4b(a);h=L5b(e)|0;f[c>>2]=h;f[a>>2]=h;f[a+8>>2]=h+(g*12|0);g=f[b>>2]|0;b=f[d>>2]|0;if((g|0)==(b|0))return;d=g;g=h;do{Bua(g,d);d=d+12|0;g=(f[c>>2]|0)+12|0;f[c>>2]=g}while((d|0)!=(b|0));return}function hwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;g=a+16|0;h=f[g>>2]|0;if(h){i=f[c>>2]|0;j=f[c+4>>2]|0;c=g;k=h;a:while(1){h=k;while(1){l=f[h+16>>2]|0;if((l|0)>=(i|0)){if((l|0)!=(i|0))break;if((f[h+20>>2]|0)>=(j|0))break}l=f[h+4>>2]|0;if(!l){m=c;break a}else h=l}k=f[h>>2]|0;if(!k){m=h;break}else c=h}if((m|0)!=(g|0)?(c=f[m+16>>2]|0,(i|0)>=(c|0)):0)if((i|0)==(c|0)?(j|0)<(f[m+20>>2]|0):0)n=13;else o=m;else n=13}else n=13;if((n|0)==13){f[e>>2]=0;f[e+4>>2]=0;p=aD(e,23)|0;q=367925;r=p+23|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,e,368208,364488,322);bD(e);o=g}g=o+24|0;o=f[g>>2]|0;n=f[g+4>>2]|0;g=a+4|0;a=f[g>>2]|0;if(a|0){m=g;j=a;b:while(1){a=j;while(1){c=f[a+16>>2]|0;if((c|0)>=(o|0)){if((c|0)!=(o|0))break;if((f[a+20>>2]|0)>=(n|0))break}c=f[a+4>>2]|0;if(!c){s=m;break b}else a=c}j=f[a>>2]|0;if(!j){s=a;break}else m=a}if((s|0)!=(g|0)?(m=f[s+16>>2]|0,(o|0)>=(m|0)):0){if((o|0)!=(m|0)){t=s;v=t+24|0;w=f[v>>2]|0;u=d;return w|0}if((n|0)>=(f[s+20>>2]|0)){t=s;v=t+24|0;w=f[v>>2]|0;u=d;return w|0}}}f[e>>2]=0;f[e+4>>2]=0;p=aD(e,25)|0;q=367966;r=p+25|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,e,368208,364488,326);bD(e);t=g;v=t+24|0;w=f[v>>2]|0;u=d;return w|0}function iwa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=f[a>>2]|0;g=e;h=(f[b>>2]|0)-g|0;b=e+(((h|0)/12|0)*12|0)|0;i=f[c>>2]|0;c=f[d>>2]|0;d=c-i|0;j=(d|0)/12|0;k=i;i=c;if((d|0)<=0){l=b;return l|0}d=a+8|0;m=f[d>>2]|0;n=a+4|0;o=f[n>>2]|0;p=o;if((j|0)<=((m-p|0)/12|0|0)){q=p-b|0;r=(q|0)/12|0;if((j|0)>(r|0)){s=k+(r*12|0)|0;r=s;if((s|0)==(i|0))t=o;else{u=o;v=s;while(1){Bua(u,v);v=v+12|0;s=(f[n>>2]|0)+12|0;f[n>>2]=s;if((v|0)==(i|0)){t=s;break}else u=s}}if((q|0)>0){w=r;x=t}else{l=b;return l|0}}else{w=c;x=o}c=x-(b+(j*12|0))|0;t=b+(((c|0)/12|0)*12|0)|0;if(t>>>0<o>>>0){r=t;q=x;do{Bua(q,r);r=r+12|0;q=(f[n>>2]|0)+12|0;f[n>>2]=q}while(r>>>0<o>>>0)}if(c|0){c=t;t=x;do{x=c;c=c+-12|0;o=t;t=t+-12|0;if((o|0)!=(x|0))r2(t,f[c>>2]|0,f[x+-8>>2]|0)}while((c|0)!=(b|0))}c=w;if((k|0)==(c|0)){l=b;return l|0}else{y=b;z=k}while(1){if((y|0)!=(z|0))r2(y,f[z>>2]|0,f[z+4>>2]|0);z=z+12|0;if((z|0)==(c|0)){l=b;break}else y=y+12|0}return l|0}y=((p-g|0)/12|0)+j|0;if(y>>>0>357913941)c4b(a);j=(m-g|0)/12|0;g=j<<1;m=j>>>0<178956970?(g>>>0<y>>>0?y:g):357913941;g=(h|0)/12|0;do if(m)if(m>>>0>357913941){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}else{A=L5b(m*12|0)|0;break}else A=0;while(0);h=A+(g*12|0)|0;g=h;y=A+(m*12|0)|0;if((k|0)==(i|0)){B=g;C=e}else{e=g;m=h;A=k;do{Bua(m,A);m=e+12|0;e=m;A=A+12|0}while((A|0)!=(i|0));B=e;C=f[a>>2]|0}if((C|0)==(b|0)){D=h;E=g}else{e=b;i=g;g=h;while(1){e=e+-12|0;Bua(g+-12|0,e);A=i+-12|0;m=A;if((e|0)==(C|0)){D=A;E=m;break}else{i=m;g=A}}}g=f[n>>2]|0;if((g|0)==(b|0)){F=B;G=D;H=b}else{D=b;b=B;i=B;do{Bua(i,D);D=D+12|0;i=b+12|0;b=i}while((D|0)!=(g|0));F=b;G=E;H=f[n>>2]|0}E=f[a>>2]|0;f[a>>2]=G;f[n>>2]=F;f[d>>2]=y;if((H|0)!=(E|0)){y=H;do{H=y;y=y+-12|0;d=f[y>>2]|0;if(d|0){F=H+-8|0;H=f[F>>2]|0;if((H|0)!=(d|0))f[F>>2]=H+(~((H+-4-d|0)>>>2)<<2);O5b(d)}}while((y|0)!=(E|0))}if(!E){l=h;return l|0}O5b(E);l=h;return l|0}function jwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function kwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=a+4|0;d=f[a>>2]|0;e=(f[c>>2]|0)-d|0;g=e>>2;h=g+1|0;if(h>>>0>1073741823)c4b(a);i=a+8|0;j=(f[i>>2]|0)-d|0;k=j>>1;l=j>>2>>>0<536870911?(k>>>0<h>>>0?h:k):1073741823;do if(l)if(l>>>0>1073741823){k=ze(8)|0;T5b(k,477177);f[k>>2]=149528;If(k|0,25408,1411)}else{m=L5b(l<<2)|0;break}else m=0;while(0);k=m+(g<<2)|0;f[k>>2]=f[b>>2];b=k+(0-g<<2)|0;if((e|0)>0)Vac(b|0,d|0,e|0)|0;f[a>>2]=b;f[c>>2]=k+4;f[i>>2]=m+(l<<2);if(!d)return;O5b(d);return}function lwa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=u;u=u+16|0;g=e;h=a+12|0;i=a+16|0;j=f[i>>2]|0;if(j){k=f[d>>2]|0;l=f[d+4>>2]|0;m=i;n=j;a:while(1){o=n;while(1){p=f[o+16>>2]|0;if((p|0)>=(k|0)){if((p|0)!=(k|0))break;if((f[o+20>>2]|0)>=(l|0))break}p=f[o+4>>2]|0;if(!p){q=m;break a}else o=p}n=f[o>>2]|0;if(!n){q=o;break}else m=o}do if((q|0)!=(i|0)?(m=f[q+16>>2]|0,(k|0)>=(m|0)):0){if((k|0)==(m|0)?(l|0)<(f[q+20>>2]|0):0){r=j;break}f[g>>2]=0;f[g+4>>2]=0;s=aD(g,37)|0;t=368126;v=s+37|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,g,368164,364488,333);bD(g);r=f[i>>2]|0}else r=j;while(0);if(r){j=f[c>>2]|0;q=f[c+4>>2]|0;l=i;k=r;b:while(1){r=k;while(1){o=f[r+16>>2]|0;if((o|0)>=(j|0)){if((o|0)!=(j|0))break;if((f[r+20>>2]|0)>=(q|0))break}o=f[r+4>>2]|0;if(!o){w=l;break b}else r=o}k=f[r>>2]|0;if(!k){w=r;break}else l=r}if((w|0)!=(i|0)?(i=f[w+16>>2]|0,(j|0)>=(i|0)):0){if((j|0)==(i|0)?(q|0)<(f[w+20>>2]|0):0)x=26}else x=26}else x=26}else x=26;if((x|0)==26){f[g>>2]=0;f[g+4>>2]=0;s=aD(g,37)|0;t=368170;v=s+37|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,g,368164,364488,334);bD(g)}g=swa(h,c)|0;c=f[g>>2]|0;t=f[g+4>>2]|0;g=swa(h,d)|0;f[g>>2]=c;f[g+4>>2]=t;g=a+4|0;h=f[g>>2]|0;if(!h){u=e;return}else{y=g;z=h}c:while(1){s=z;while(1){v=f[s+16>>2]|0;if((v|0)>=(c|0)){if((v|0)!=(c|0))break;if((f[s+20>>2]|0)>=(t|0))break}v=f[s+4>>2]|0;if(!v){A=y;break c}else s=v}z=f[s>>2]|0;if(!z){A=s;break}else y=s}if((A|0)==(g|0)){u=e;return}y=f[A+16>>2]|0;if((c|0)<(y|0)){u=e;return}if((c|0)==(y|0)?(t|0)<(f[A+20>>2]|0):0){u=e;return}A=f[d>>2]|0;y=f[d+4>>2]|0;d=g;z=h;d:while(1){r=z;while(1){v=f[r+16>>2]|0;if((v|0)>=(A|0)){if((v|0)!=(A|0))break;if((f[r+20>>2]|0)>=(y|0))break}v=f[r+4>>2]|0;if(!v){B=d;break d}else r=v}z=f[r>>2]|0;if(!z){B=r;break}else d=r}do if((B|0)!=(g|0)?(d=f[B+16>>2]|0,(A|0)>=(d|0)):0){if((A|0)==(d|0)?(y|0)<(f[B+20>>2]|0):0)break;d=f[B+24>>2]|0;z=a+4|0;s=h;v=h;e:while(1){w=f[s+16>>2]|0;do if((c|0)>=(w|0)){q=(c|0)==(w|0);if(q?(t|0)<(f[s+20>>2]|0):0){x=54;break}if((w|0)>=(c|0)){if(!q){x=59;break e}if((f[s+20>>2]|0)>=(t|0)){x=59;break e}}q=s+4|0;i=f[q>>2]|0;if(!i){C=q;x=60;break e}else{D=q;E=i}}else x=54;while(0);if((x|0)==54){x=0;w=f[s>>2]|0;if(!w){C=s;x=60;break}else{D=s;E=w}}z=D;s=E;v=E}if((x|0)==59)if(!v){C=z;x=60}else F=v;if((x|0)==60){r=L5b(28)|0;w=r+16|0;f[w>>2]=c;f[w+4>>2]=t;f[r+24>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=s;f[C>>2]=r;w=f[f[a>>2]>>2]|0;if(!w)G=r;else{f[a>>2]=w;G=f[C>>2]|0}mP(f[a+4>>2]|0,G);w=a+8|0;f[w>>2]=(f[w>>2]|0)+1;F=r}r=F+24|0;f[r>>2]=(f[r>>2]|0)+d;r=f[B+4>>2]|0;if(!r){w=B+8|0;i=f[w>>2]|0;if((f[i>>2]|0)==(B|0))H=i;else{i=w;do{w=f[i>>2]|0;i=w+8|0;q=f[i>>2]|0}while((f[q>>2]|0)!=(w|0));H=q}}else{i=r;while(1){d=f[i>>2]|0;if(!d)break;else i=d}H=i}if((f[a>>2]|0)==(B|0))f[a>>2]=H;r=a+8|0;f[r>>2]=(f[r>>2]|0)+-1;wwa(f[a+4>>2]|0,B);O5b(B);u=e;return}while(0);B=a+4|0;H=h;F=h;f:while(1){h=f[H+16>>2]|0;do if((c|0)>=(h|0)){G=(c|0)==(h|0);if(G?(t|0)<(f[H+20>>2]|0):0){x=76;break}if((h|0)>=(c|0)){if(!G){x=81;break f}if((f[H+20>>2]|0)>=(t|0)){x=81;break f}}G=H+4|0;C=f[G>>2]|0;if(!C){I=G;x=82;break f}else{J=G;K=C}}else x=76;while(0);if((x|0)==76){x=0;h=f[H>>2]|0;if(!h){I=H;x=82;break}else{J=H;K=h}}B=J;H=K;F=K}if((x|0)==81)if(!F){I=B;x=82}else L=F;if((x|0)==82){x=L5b(28)|0;F=x+16|0;f[F>>2]=c;f[F+4>>2]=t;f[x+24>>2]=0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=H;f[I>>2]=x;H=f[f[a>>2]>>2]|0;if(!H)M=x;else{f[a>>2]=H;M=f[I>>2]|0}mP(f[a+4>>2]|0,M);M=a+8|0;f[M>>2]=(f[M>>2]|0)+1;L=x}x=L+24|0;f[x>>2]=(f[x>>2]|0)+1;u=e;return}function mwa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;h=u;u=u+64|0;i=h+56|0;j=h+8|0;k=h;f[j>>2]=1124007936;l=j+4|0;m=j+8|0;n=j+20|0;o=j+24|0;p=j+28|0;q=j+32|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;f[l+24>>2]=0;f[q>>2]=m;r=j+40|0;s=j+36|0;f[s>>2]=r;f[j+44>>2]=0;f[r>>2]=0;f[k>>2]=-1;f[k+4>>2]=-1;if(!g){g=f[c+4>>2]|0;r=f[c>>2]|0;t=g-r|0;v=t>>2;w=r;do if((w|0)!=(g|0)){if((t|0)<=-4){f[i>>2]=0;f[i+4>>2]=0;r=aD(i,70)|0;x=442586;y=r+70|0;do{b[r>>0]=b[x>>0]|0;r=r+1|0;x=x+1|0}while((r|0)<(y|0));bO(-215,i,442657,442663,160);bD(i);z=1;break}if((t|0)>0){x=0;r=1;while(1){y=Y(f[w+(x<<2)>>2]|0,r)|0;x=x+1|0;if((x|0)>=(v|0)){z=y;break}else r=y}}else z=1}else z=0;while(0);v=f[a+36>>2]|0;w=a+40|0;if((v|0)!=(w|0)){t=a+4|0;i=j+12|0;g=j+16|0;r=2147483647;x=v;while(1){v=x+16|0;y=f[t>>2]|0;do if(y){A=f[v>>2]|0;B=f[x+20>>2]|0;C=t;D=y;a:while(1){E=D;while(1){F=f[E+16>>2]|0;if((F|0)>=(A|0)){if((F|0)!=(A|0))break;if((f[E+20>>2]|0)>=(B|0))break}F=f[E+4>>2]|0;if(!F){G=C;break a}else E=F}D=f[E>>2]|0;if(!D){G=E;break}else C=E}if((G|0)!=(t|0)?(C=f[G+16>>2]|0,(A|0)>=(C|0)):0){if((A|0)==(C|0)?(B|0)<(f[G+20>>2]|0):0){H=r;break}if(!(f[G+24>>2]|0)){C=x+24|0;D=x+28|0;F=f[D>>2]|0;I=(F|0)<3;if(I)J=Y(f[x+36>>2]|0,f[x+32>>2]|0)|0;else{K=f[x+56>>2]|0;L=0;M=1;while(1){N=Y(f[K+(L<<2)>>2]|0,M)|0;L=L+1|0;if((L|0)==(F|0)){J=N;break}else M=N}}if(J>>>0>=z>>>0){if(I)O=Y(f[x+36>>2]|0,f[x+32>>2]|0)|0;else{M=f[x+56>>2]|0;L=0;K=1;while(1){B=Y(f[M+(L<<2)>>2]|0,K)|0;L=L+1|0;if((L|0)==(F|0)){O=B;break}else K=B}}if(O>>>0<r>>>0){K=v;L=f[K+4>>2]|0;M=k;f[M>>2]=f[K>>2];f[M+4>>2]=L;if((j|0)==(C|0))P=F;else{L=x+48|0;M=f[L>>2]|0;if(M|0){K=M+8|0;f[K>>2]=(f[K>>2]|0)+1}K=f[o>>2]|0;do if(K|0){M=K+8|0;I=f[M>>2]|0;f[M>>2]=I+-1;if((I|0)!=1)break;iI(j)}while(0);if((f[l>>2]|0)>0){K=f[q>>2]|0;F=0;do{f[K+(F<<2)>>2]=0;F=F+1|0;Q=f[l>>2]|0}while((F|0)<(Q|0));f[o>>2]=0;f[j>>2]=f[C>>2];if((Q|0)<3)R=43;else R=45}else{f[o>>2]=0;f[j>>2]=f[C>>2];R=43}do if((R|0)==43){R=0;F=f[D>>2]|0;if((F|0)>=3){R=45;break}f[l>>2]=F;f[m>>2]=f[x+32>>2];f[i>>2]=f[x+36>>2];F=f[x+60>>2]|0;K=f[s>>2]|0;f[K>>2]=f[F>>2];f[K+4>>2]=f[F+4>>2]}while(0);if((R|0)==45){R=0;gI(j,C)}f[g>>2]=f[x+40>>2];if(!(f[n>>2]|0))f[n>>2]=f[x+44>>2];f[o>>2]=f[L>>2];f[p>>2]=f[x+52>>2];P=f[D>>2]|0}if((P|0)<3){H=Y(f[x+36>>2]|0,f[x+32>>2]|0)|0;break}F=f[x+56>>2]|0;K=0;I=1;while(1){M=Y(f[F+(K<<2)>>2]|0,I)|0;K=K+1|0;if((K|0)==(P|0)){H=M;break}else I=M}}else H=r}else H=r}else H=r}else H=r}else H=r;while(0);v=f[x+4>>2]|0;if(!v){y=x+8|0;I=f[y>>2]|0;if((f[I>>2]|0)==(x|0))S=I;else{I=y;do{y=f[I>>2]|0;I=y+8|0;K=f[I>>2]|0}while((f[K>>2]|0)!=(y|0));S=K}}else{I=v;while(1){K=f[I>>2]|0;if(!K)break;else I=K}S=I}if((S|0)==(w|0))break;else{r=H;x=S}}}}if(f[o>>2]|0){o=f[l>>2]|0;if((o|0)<3)T=Y(f[j+12>>2]|0,f[m>>2]|0)|0;else{m=f[q>>2]|0;q=0;l=1;while(1){S=Y(f[m+(q<<2)>>2]|0,l)|0;q=q+1|0;if((q|0)==(o|0)){T=S;break}else l=S}}if(!((o|0)==0|(T|0)==0)){lwa(a,k,d);fI(e,c,5,0);hI(j);u=h;return}}fI(e,c,5,0);uwa(a,d,e);hI(j);u=h;return}function nwa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0;h=u;u=u+128|0;i=h+64|0;j=h+8|0;k=h;f[j>>2]=1124007936;l=j+4|0;m=j+8|0;n=j+40|0;o=l;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[n>>2]=m;q=j+48|0;r=j+44|0;f[r>>2]=q;f[q>>2]=0;f[j+52>>2]=0;f[k>>2]=-1;f[k+4>>2]=-1;if(!g){g=f[c+4>>2]|0;s=f[c>>2]|0;t=g-s|0;v=t>>2;w=s;do if((w|0)!=(g|0)){if((t|0)<=-4){f[i>>2]=0;f[i+4>>2]=0;o=aD(i,70)|0;s=442586;p=o+70|0;do{b[o>>0]=b[s>>0]|0;o=o+1|0;s=s+1|0}while((o|0)<(p|0));bO(-215,i,442657,442663,160);bD(i);x=1;break}if((t|0)>0){s=0;y=1;while(1){z=Y(f[w+(s<<2)>>2]|0,y)|0;s=s+1|0;if((s|0)>=(v|0)){x=z;break}else y=z}}else x=1}else x=0;while(0);v=f[a+24>>2]|0;w=a+28|0;if((v|0)!=(w|0)){t=a+4|0;o=j+36|0;p=j+16|0;g=j+12|0;y=j+20|0;s=j+24|0;z=j+28|0;A=j+32|0;B=2147483647;C=v;while(1){v=C+16|0;D=f[t>>2]|0;do if(D){E=f[v>>2]|0;F=f[C+20>>2]|0;G=t;H=D;a:while(1){I=H;while(1){J=f[I+16>>2]|0;if((J|0)>=(E|0)){if((J|0)!=(E|0))break;if((f[I+20>>2]|0)>=(F|0))break}J=f[I+4>>2]|0;if(!J){K=G;break a}else I=J}H=f[I>>2]|0;if(!H){K=I;break}else G=I}if((K|0)!=(t|0)?(G=f[K+16>>2]|0,(E|0)>=(G|0)):0){if((E|0)==(G|0)?(F|0)<(f[K+20>>2]|0):0){L=B;break}if(!(f[K+24>>2]|0)){G=C+24|0;H=C+28|0;J=f[H>>2]|0;M=(J|0)<3;if(M)N=Y(f[C+36>>2]|0,f[C+32>>2]|0)|0;else{O=f[C+64>>2]|0;P=0;Q=1;while(1){R=Y(f[O+(P<<2)>>2]|0,Q)|0;P=P+1|0;if((P|0)==(J|0)){N=R;break}else Q=R}}if(N>>>0>=x>>>0){if(M)S=Y(f[C+36>>2]|0,f[C+32>>2]|0)|0;else{Q=f[C+64>>2]|0;P=0;O=1;while(1){F=Y(f[Q+(P<<2)>>2]|0,O)|0;P=P+1|0;if((P|0)==(J|0)){S=F;break}else O=F}}if(S>>>0<B>>>0){O=v;P=f[O+4>>2]|0;Q=k;f[Q>>2]=f[O>>2];f[Q+4>>2]=P;if((j|0)==(G|0))T=J;else{P=C+60|0;Q=f[P>>2]|0;if(Q|0){O=Q+12|0;f[O>>2]=(f[O>>2]|0)+1}O=f[o>>2]|0;do if(O|0){Q=O+12|0;M=f[Q>>2]|0;f[Q>>2]=M+-1;if((M|0)!=1)break;kL(j)}while(0);f[o>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[l>>2]|0)>0){O=f[n>>2]|0;J=0;do{f[O+(J<<2)>>2]=0;J=J+1|0;U=f[l>>2]|0}while((J|0)<(U|0));f[j>>2]=f[G>>2];if((U|0)<3)V=43;else V=45}else{f[j>>2]=f[G>>2];V=43}do if((V|0)==43){V=0;J=f[H>>2]|0;if((J|0)>=3){V=45;break}f[l>>2]=J;f[m>>2]=f[C+32>>2];f[g>>2]=f[C+36>>2];J=f[C+68>>2]|0;O=f[r>>2]|0;f[O>>2]=f[J>>2];f[O+4>>2]=f[J+4>>2]}while(0);if((V|0)==45){V=0;jL(j,G)}f[p>>2]=f[C+40>>2];f[y>>2]=f[C+44>>2];f[s>>2]=f[C+48>>2];f[z>>2]=f[C+52>>2];f[A>>2]=f[C+56>>2];f[o>>2]=f[P>>2];T=f[H>>2]|0}if((T|0)<3){L=Y(f[C+36>>2]|0,f[C+32>>2]|0)|0;break}J=f[C+64>>2]|0;O=0;M=1;while(1){Q=Y(f[J+(O<<2)>>2]|0,M)|0;O=O+1|0;if((O|0)==(T|0)){L=Q;break}else M=Q}}else L=B}else L=B}else L=B}else L=B}else L=B;while(0);v=f[C+4>>2]|0;if(!v){D=C+8|0;M=f[D>>2]|0;if((f[M>>2]|0)==(C|0))W=M;else{M=D;do{D=f[M>>2]|0;M=D+8|0;O=f[M>>2]|0}while((f[O>>2]|0)!=(D|0));W=O}}else{M=v;while(1){O=f[M>>2]|0;if(!O)break;else M=O}W=M}if((W|0)==(w|0))break;else{B=L;C=W}}}}W=j+16|0;if(f[W>>2]|0){C=f[l>>2]|0;if((C|0)<3)X=Y(f[j+12>>2]|0,f[m>>2]|0)|0;else{m=f[n>>2]|0;L=0;B=1;while(1){w=Y(f[m+(L<<2)>>2]|0,B)|0;L=L+1|0;if((L|0)==(C|0)){X=w;break}else B=w}}if(!((C|0)==0|(X|0)==0)){lwa(a,k,d);pL(i,c,5,f[W>>2]|0,0);if((i|0)==(e|0)){Z=i+36|0;_=f[e+36>>2]|0}else{k=i+36|0;X=f[k>>2]|0;if(X|0){C=X+12|0;f[C>>2]=(f[C>>2]|0)+1}C=e+36|0;X=f[C>>2]|0;if(X|0?(B=X+12|0,X=f[B>>2]|0,f[B>>2]=X+-1,(X|0)==1):0)kL(e);f[C>>2]=0;X=e+16|0;B=e+4|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[B>>2]|0)>0){L=f[e+40>>2]|0;m=0;do{f[L+(m<<2)>>2]=0;m=m+1|0;$=f[B>>2]|0}while((m|0)<($|0));f[e>>2]=f[i>>2];if(($|0)<3)V=75;else V=77}else{f[e>>2]=f[i>>2];V=75}if((V|0)==75){$=f[i+4>>2]|0;if(($|0)<3){f[B>>2]=$;f[e+8>>2]=f[i+8>>2];f[e+12>>2]=f[i+12>>2];$=f[i+44>>2]|0;B=f[e+44>>2]|0;f[B>>2]=f[$>>2];f[B+4>>2]=f[$+4>>2]}else V=77}if((V|0)==77)jL(e,i);f[X>>2]=f[i+16>>2];f[e+20>>2]=f[i+20>>2];f[e+24>>2]=f[i+24>>2];f[e+28>>2]=f[i+28>>2];f[e+32>>2]=f[i+32>>2];X=f[k>>2]|0;f[C>>2]=X;Z=k;_=X}if(_|0?(X=_+12|0,_=f[X>>2]|0,f[X>>2]=_+-1,(_|0)==1):0)kL(i);f[Z>>2]=0;Z=i+16|0;_=i+4|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[_>>2]|0)>0){Z=f[i+40>>2]|0;X=0;do{f[Z+(X<<2)>>2]=0;X=X+1|0}while((X|0)<(f[_>>2]|0))}_=f[i+44>>2]|0;if((_|0)!=(i+48|0))UC(_)}else V=88}else V=88;if((V|0)==88){iL(e,c,5);rwa(a,d,e)}e=j+36|0;d=f[e>>2]|0;if(d|0?(a=d+12|0,d=f[a>>2]|0,f[a>>2]=d+-1,(d|0)==1):0)kL(j);f[e>>2]=0;f[W>>2]=0;f[W+4>>2]=0;f[W+8>>2]=0;f[W+12>>2]=0;if((f[l>>2]|0)>0){W=f[n>>2]|0;n=0;do{f[W+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}l=f[r>>2]|0;if((l|0)==(q|0)){u=h;return}UC(l);u=h;return}function owa(a,b){a=a|0;b=b|0;var c=0,d=0;if(!b)return;owa(a,f[b>>2]|0);owa(a,f[b+4>>2]|0);a=f[b+20>>2]|0;if(a|0){c=b+24|0;d=f[c>>2]|0;if((d|0)!=(a|0))f[c>>2]=d+(~((d+-4-a|0)>>>2)<<2);O5b(a)}O5b(b);return}function pwa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;e=u;u=u+32|0;g=e+16|0;h=e;i=c+112|0;if(!(f[i>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;u=e;return}j=d+4|0;k=f[j>>2]|0;f[h>>2]=0;l=h+4|0;f[l>>2]=0;f[h+8>>2]=0;if(k|0){if(k>>>0>1073741823)c4b(h);m=k<<2;n=L5b(m)|0;f[h>>2]=n;o=n+(k<<2)|0;f[h+8>>2]=o;Nac(n|0,0,m|0)|0;f[l>>2]=o;o=f[d+40>>2]|0;m=0;do{f[n+(m<<2)>>2]=f[o+(m<<2)>>2];m=m+1|0}while((m|0)<(f[j>>2]|0))}j=f[d+16>>2]|0;d=c+128|0;m=c+132|0;o=f[m>>2]|0;if(o|0){n=j;k=m;p=o;a:while(1){q=p;while(1){if((f[q+16>>2]|0)>>>0>=n>>>0)break;r=f[q+4>>2]|0;if(!r){s=k;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else k=q}if((s|0)!=(m|0)?n>>>0>=(f[s+16>>2]|0)>>>0:0){s=c+132|0;k=o;p=o;while(1){o=f[k+16>>2]|0;if(n>>>0<o>>>0){r=f[k>>2]|0;if(!r){t=k;v=23;break}else{w=k;x=r}}else{if(o>>>0>=n>>>0){v=22;break}o=k+4|0;r=f[o>>2]|0;if(!r){t=o;v=23;break}else{w=o;x=r}}s=w;k=x;p=x}if((v|0)==22)if(!p){t=s;v=23}else y=p;if((v|0)==23){p=L5b(28)|0;f[p+16>>2]=j;f[p+20>>2]=0;f[p+24>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=k;f[t>>2]=p;k=f[f[d>>2]>>2]|0;if(!k)z=p;else{f[d>>2]=k;z=f[t>>2]|0}mP(f[c+132>>2]|0,z);z=c+136|0;f[z>>2]=(f[z>>2]|0)+1;y=p}p=f[y+20>>2]|0;y=(p|0)==0;if(!y){z=p+4|0;f[z>>2]=(f[z>>2]|0)+1}if((f[i>>2]|0)==1){if(!(Owa()|0)){f[g>>2]=0;f[g+4>>2]=0;A=aD(g,12)|0;B=368010;C=A+12|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,g,368023,364488,695);bD(g)}}else{f[g>>2]=0;f[g+4>>2]=0;A=aD(g,26)|0;B=366466;C=A+26|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-213,g,368023,364488,701);bD(g)}z=p;if(!y?(y=z+4|0,t=f[y>>2]|0,f[y>>2]=t+-1,(t|0)==1):0)bi[f[(f[p>>2]|0)+8>>2]&2047](z)}}switch(f[i>>2]|0){case 0:break;case 1:{if(!(Owa()|0)){f[g>>2]=0;f[g+4>>2]=0;A=aD(g,12)|0;B=368010;C=A+12|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-215,g,368028,364488,627);bD(g)}break}default:{f[g>>2]=0;f[g+4>>2]=0;A=aD(g,26)|0;B=366466;C=A+26|0;do{b[A>>0]=b[B>>0]|0;A=A+1|0;B=B+1|0}while((A|0)<(C|0));bO(-213,g,368028,364488,633);bD(g)}}g=f[m>>2]|0;do if(g){B=j;A=c+132|0;C=g;i=g;while(1){z=f[C+16>>2]|0;if(B>>>0<z>>>0){p=f[C>>2]|0;if(!p){v=44;break}else{D=C;E=p}}else{if(z>>>0>=B>>>0){v=48;break}F=C+4|0;z=f[F>>2]|0;if(!z){v=47;break}else{D=F;E=z}}A=D;C=E;i=E}if((v|0)==44){G=C;H=C;v=51;break}else if((v|0)==47){G=F;H=C;v=51;break}else if((v|0)==48){I=A;J=C;K=i;v=50;break}}else{I=m;J=m;K=g;v=50}while(0);if((v|0)==50)if(!K){G=I;H=J;v=51}else L=K;if((v|0)==51){v=L5b(28)|0;f[v+16>>2]=j;f[v+20>>2]=0;f[v+24>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=H;f[G>>2]=v;H=f[f[d>>2]>>2]|0;if(!H)M=v;else{f[d>>2]=H;M=f[G>>2]|0}mP(f[c+132>>2]|0,M);M=c+136|0;f[M>>2]=(f[M>>2]|0)+1;L=v}v=L+20|0;M=f[v>>2]|0;f[v>>2]=0;f[L+24>>2]=0;if(M|0?(L=M+4|0,v=f[L>>2]|0,f[L>>2]=v+-1,(v|0)==1):0)bi[f[(f[M>>2]|0)+8>>2]&2047](M);f[a>>2]=0;f[a+4>>2]=0;a=f[h>>2]|0;if(a|0){h=f[l>>2]|0;if((h|0)!=(a|0))f[l>>2]=h+(~((h+-4-a|0)>>>2)<<2);O5b(a)}u=e;return}function qwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;d=u;u=u+16|0;e=d;g=a+16|0;h=f[g>>2]|0;if(h){i=f[c>>2]|0;j=f[c+4>>2]|0;c=g;k=h;a:while(1){h=k;while(1){l=f[h+16>>2]|0;if((l|0)>=(i|0)){if((l|0)!=(i|0))break;if((f[h+20>>2]|0)>=(j|0))break}l=f[h+4>>2]|0;if(!l){m=c;break a}else h=l}k=f[h>>2]|0;if(!k){m=h;break}else c=h}if((m|0)!=(g|0)?(c=f[m+16>>2]|0,(i|0)>=(c|0)):0)if((i|0)==(c|0)?(j|0)<(f[m+20>>2]|0):0)n=13;else o=m;else n=13}else n=13;if((n|0)==13){f[e>>2]=0;f[e+4>>2]=0;p=aD(e,23)|0;q=367925;r=p+23|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,e,367949,364488,354);bD(e);o=g}g=a+4|0;a=f[g>>2]|0;if(a){m=f[o+24>>2]|0;j=f[o+28>>2]|0;o=g;c=a;b:while(1){a=c;while(1){i=f[a+16>>2]|0;if((i|0)>=(m|0)){if((i|0)!=(m|0))break;if((f[a+20>>2]|0)>=(j|0))break}i=f[a+4>>2]|0;if(!i){s=o;break b}else a=i}c=f[a>>2]|0;if(!c){s=a;break}else o=a}if((s|0)!=(g|0)?(o=f[s+16>>2]|0,(m|0)>=(o|0)):0)if((m|0)==(o|0)?(j|0)<(f[s+20>>2]|0):0)n=26;else t=s;else n=26}else n=26;if((n|0)==26){f[e>>2]=0;f[e+4>>2]=0;p=aD(e,25)|0;q=367966;r=p+25|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,e,367949,364488,357);bD(e);t=g}g=t+24|0;t=f[g>>2]|0;if((t|0)>0){v=t;w=v+-1|0;f[g>>2]=w;u=d;return}f[e>>2]=0;f[e+4>>2]=0;p=aD(e,17)|0;q=367992;r=p+17|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,e,367949,364488,358);bD(e);v=f[g>>2]|0;w=v+-1|0;f[g>>2]=w;u=d;return}function rwa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+16|0;g=e;h=a+24|0;i=a+28|0;j=f[i>>2]|0;do if(j|0){k=f[c>>2]|0;l=f[c+4>>2]|0;m=i;n=j;a:while(1){o=n;while(1){p=f[o+16>>2]|0;if((p|0)>=(k|0)){if((p|0)!=(k|0))break;if((f[o+20>>2]|0)>=(l|0))break}p=f[o+4>>2]|0;if(!p){q=m;break a}else o=p}n=f[o>>2]|0;if(!n){q=o;break}else m=o}if((q|0)!=(i|0)?(m=f[q+16>>2]|0,(k|0)>=(m|0)):0){if((k|0)==(m|0)?(l|0)<(f[q+20>>2]|0):0)break;f[g>>2]=0;f[g+4>>2]=0;m=aD(g,35)|0;n=368036;p=m+35|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(p|0));bO(-215,g,368072,364488,597);bD(g)}}while(0);g=swa(a+12|0,c)|0;a=c;q=f[a+4>>2]|0;i=g;f[i>>2]=f[a>>2];f[i+4>>2]=q;q=twa(h,c)|0;if((q|0)==(d|0)){u=e;return}c=d+36|0;h=f[c>>2]|0;if(h|0){i=h+12|0;f[i>>2]=(f[i>>2]|0)+1}i=q+36|0;h=f[i>>2]|0;if(h|0?(a=h+12|0,h=f[a>>2]|0,f[a>>2]=h+-1,(h|0)==1):0)kL(q);f[i>>2]=0;h=q+16|0;a=q+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[a>>2]|0)>0){g=f[q+40>>2]|0;j=0;do{f[g+(j<<2)>>2]=0;j=j+1|0;r=f[a>>2]|0}while((j|0)<(r|0));f[q>>2]=f[d>>2];if((r|0)<3)s=25;else s=27}else{f[q>>2]=f[d>>2];s=25}if((s|0)==25){r=f[d+4>>2]|0;if((r|0)<3){f[a>>2]=r;f[q+8>>2]=f[d+8>>2];f[q+12>>2]=f[d+12>>2];r=f[d+44>>2]|0;a=f[q+44>>2]|0;f[a>>2]=f[r>>2];f[a+4>>2]=f[r+4>>2]}else s=27}if((s|0)==27)jL(q,d);f[h>>2]=f[d+16>>2];f[q+20>>2]=f[d+20>>2];f[q+24>>2]=f[d+24>>2];f[q+28>>2]=f[d+28>>2];f[q+32>>2]=f[d+32>>2];f[i>>2]=f[c>>2];u=e;return}function swa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+4|0;d=f[c>>2]|0;do if(d){e=f[b>>2]|0;g=f[b+4>>2]|0;h=a+4|0;i=d;j=d;a:while(1){k=f[i+16>>2]|0;do if((e|0)>=(k|0)){l=(e|0)==(k|0);if(l?(g|0)<(f[i+20>>2]|0):0){m=7;break}if((k|0)>=(e|0)){if(!l){m=14;break a}if((f[i+20>>2]|0)>=(g|0)){m=14;break a}}n=i+4|0;l=f[n>>2]|0;if(!l){m=13;break a}else{o=n;p=l}}else m=7;while(0);if((m|0)==7){m=0;k=f[i>>2]|0;if(!k){m=8;break}else{o=i;p=k}}h=o;i=p;j=p}if((m|0)==8){q=i;r=i;break}else if((m|0)==13){q=n;r=i;break}else if((m|0)==14){s=h;t=i;u=j;m=16;break}}else{s=c;t=c;u=d;m=16}while(0);if((m|0)==16)if(!u){q=s;r=t}else{v=u;w=v+24|0;return w|0}u=L5b(32)|0;t=b;b=f[t+4>>2]|0;s=u+16|0;f[s>>2]=f[t>>2];f[s+4>>2]=b;f[u+24>>2]=-1;f[u+28>>2]=-1;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=r;f[q>>2]=u;r=f[f[a>>2]>>2]|0;if(!r)x=u;else{f[a>>2]=r;x=f[q>>2]|0}mP(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;v=u;w=v+24|0;return w|0}function twa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+4|0;d=f[c>>2]|0;do if(d){e=f[b>>2]|0;g=f[b+4>>2]|0;h=a+4|0;i=d;j=d;a:while(1){k=f[i+16>>2]|0;do if((e|0)>=(k|0)){l=(e|0)==(k|0);if(l?(g|0)<(f[i+20>>2]|0):0){m=7;break}if((k|0)>=(e|0)){if(!l){m=14;break a}if((f[i+20>>2]|0)>=(g|0)){m=14;break a}}n=i+4|0;l=f[n>>2]|0;if(!l){m=13;break a}else{o=n;p=l}}else m=7;while(0);if((m|0)==7){m=0;k=f[i>>2]|0;if(!k){m=8;break}else{o=i;p=k}}h=o;i=p;j=p}if((m|0)==8){q=i;r=i;break}else if((m|0)==13){q=n;r=i;break}else if((m|0)==14){s=h;t=i;u=j;m=16;break}}else{s=c;t=c;u=d;m=16}while(0);if((m|0)==16)if(!u){q=s;r=t}else{v=u;w=v+24|0;return w|0}u=L5b(80)|0;t=b;b=f[t+4>>2]|0;s=u+16|0;f[s>>2]=f[t>>2];f[s+4>>2]=b;f[u+24>>2]=1124007936;b=u+32|0;s=u+64|0;t=u+28|0;m=t+36|0;do{f[t>>2]=0;t=t+4|0}while((t|0)<(m|0));f[s>>2]=b;b=u+72|0;f[u+68>>2]=b;f[b>>2]=0;f[u+76>>2]=0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=r;f[q>>2]=u;r=f[f[a>>2]>>2]|0;if(!r)x=u;else{f[a>>2]=r;x=f[q>>2]|0}mP(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;v=u;w=v+24|0;return w|0}function uwa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=u;u=u+16|0;g=e;h=a+36|0;i=a+40|0;j=f[i>>2]|0;do if(j|0){k=f[c>>2]|0;l=f[c+4>>2]|0;m=i;n=j;a:while(1){o=n;while(1){p=f[o+16>>2]|0;if((p|0)>=(k|0)){if((p|0)!=(k|0))break;if((f[o+20>>2]|0)>=(l|0))break}p=f[o+4>>2]|0;if(!p){q=m;break a}else o=p}n=f[o>>2]|0;if(!n){q=o;break}else m=o}if((q|0)!=(i|0)?(m=f[q+16>>2]|0,(k|0)>=(m|0)):0){if((k|0)==(m|0)?(l|0)<(f[q+20>>2]|0):0)break;f[g>>2]=0;f[g+4>>2]=0;m=aD(g,45)|0;n=368080;p=m+45|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(p|0));bO(-215,g,368072,364488,604);bD(g)}}while(0);g=swa(a+12|0,c)|0;a=c;q=f[a+4>>2]|0;i=g;f[i>>2]=f[a>>2];f[i+4>>2]=q;q=vwa(h,c)|0;if((q|0)==(d|0)){u=e;return}c=d+24|0;h=f[c>>2]|0;if(h|0){i=h+8|0;f[i>>2]=(f[i>>2]|0)+1}i=q+24|0;h=f[i>>2]|0;if(h|0?(a=h+8|0,h=f[a>>2]|0,f[a>>2]=h+-1,(h|0)==1):0)iI(q);h=q+4|0;if((f[h>>2]|0)>0){a=f[q+32>>2]|0;g=0;do{f[a+(g<<2)>>2]=0;g=g+1|0;r=f[h>>2]|0}while((g|0)<(r|0));f[i>>2]=0;f[q>>2]=f[d>>2];if((r|0)<3)s=25;else s=27}else{f[i>>2]=0;f[q>>2]=f[d>>2];s=25}if((s|0)==25){r=f[d+4>>2]|0;if((r|0)<3){f[h>>2]=r;f[q+8>>2]=f[d+8>>2];f[q+12>>2]=f[d+12>>2];r=f[d+36>>2]|0;h=f[q+36>>2]|0;f[h>>2]=f[r>>2];f[h+4>>2]=f[r+4>>2]}else s=27}if((s|0)==27)gI(q,d);f[q+16>>2]=f[d+16>>2];s=q+20|0;if(!(f[s>>2]|0))f[s>>2]=f[d+20>>2];f[i>>2]=f[c>>2];f[q+28>>2]=f[d+28>>2];u=e;return}function vwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;c=a+4|0;d=f[c>>2]|0;do if(d){e=f[b>>2]|0;g=f[b+4>>2]|0;h=a+4|0;i=d;j=d;a:while(1){k=f[i+16>>2]|0;do if((e|0)>=(k|0)){l=(e|0)==(k|0);if(l?(g|0)<(f[i+20>>2]|0):0){m=7;break}if((k|0)>=(e|0)){if(!l){m=14;break a}if((f[i+20>>2]|0)>=(g|0)){m=14;break a}}n=i+4|0;l=f[n>>2]|0;if(!l){m=13;break a}else{o=n;p=l}}else m=7;while(0);if((m|0)==7){m=0;k=f[i>>2]|0;if(!k){m=8;break}else{o=i;p=k}}h=o;i=p;j=p}if((m|0)==8){q=i;r=i;break}else if((m|0)==13){q=n;r=i;break}else if((m|0)==14){s=h;t=i;u=j;m=16;break}}else{s=c;t=c;u=d;m=16}while(0);if((m|0)==16)if(!u){q=s;r=t}else{v=u;w=v+24|0;return w|0}u=L5b(72)|0;t=b;b=f[t+4>>2]|0;s=u+16|0;f[s>>2]=f[t>>2];f[s+4>>2]=b;f[u+24>>2]=1124007936;b=u+28|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[u+56>>2]=u+32;b=u+64|0;f[u+60>>2]=b;f[u+68>>2]=0;f[b>>2]=0;f[u>>2]=0;f[u+4>>2]=0;f[u+8>>2]=r;f[q>>2]=u;r=f[f[a>>2]>>2]|0;if(!r)x=u;else{f[a>>2]=r;x=f[q>>2]|0}mP(f[a+4>>2]|0,x);x=a+8|0;f[x>>2]=(f[x>>2]|0)+1;v=u;w=v+24|0;return w|0}function wwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=f[c>>2]|0;if(d){e=f[c+4>>2]|0;if(!e){g=c;h=d}else{d=e;while(1){e=f[d>>2]|0;if(!e){g=d;h=0;break}else d=e}}}else{g=c;h=0}d=g+4|0;e=f[(h|0?g:d)>>2]|0;h=(e|0)==0;i=g+8|0;if(!h)f[e+8>>2]=f[i>>2];j=f[i>>2]|0;if((f[j>>2]|0)==(g|0)){f[j>>2]=e;if((g|0)==(a|0)){k=e;l=0}else{m=j+4|0;n=10}}else{f[j+4>>2]=e;m=j;n=10}if((n|0)==10){k=a;l=f[m>>2]|0}m=g+12|0;a=(b[m>>0]|0)==0;if((g|0)==(c|0))o=k;else{j=c+8|0;p=f[j>>2]|0;f[i>>2]=p;f[((f[f[j>>2]>>2]|0)==(c|0)?p:p+4|0)>>2]=g;p=f[c>>2]|0;f[g>>2]=p;f[p+8>>2]=g;p=f[c+4>>2]|0;f[d>>2]=p;if(p|0)f[p+8>>2]=g;b[m>>0]=b[c+12>>0]|0;o=(k|0)==(c|0)?g:k}if(a|(o|0)==0)return;if(h){q=l;r=o}else{b[e+12>>0]=1;return}while(1){e=f[q+8>>2]|0;o=q+12|0;l=(b[o>>0]|0)!=0;if((f[e>>2]|0)==(q|0)){if(l){s=q;t=r}else{b[o>>0]=1;b[e+12>>0]=0;h=f[e>>2]|0;a=h+4|0;k=f[a>>2]|0;f[e>>2]=k;if(k|0)f[k+8>>2]=e;k=e+8|0;f[h+8>>2]=f[k>>2];g=f[k>>2]|0;f[((f[g>>2]|0)==(e|0)?g:g+4|0)>>2]=h;f[a>>2]=e;f[k>>2]=h;h=f[q+4>>2]|0;s=f[h>>2]|0;t=(r|0)==(h|0)?q:r}u=f[s>>2]|0;v=(u|0)==0;if(!v?(b[u+12>>0]|0)==0:0){n=50;break}h=f[s+4>>2]|0;if(h|0?(b[h+12>>0]|0)==0:0){n=49;break}b[s+12>>0]=0;h=f[s+8>>2]|0;w=h+12|0;if((h|0)==(t|0)|(b[w>>0]|0)==0){n=48;break}else{x=t;y=h}}else{if(l){z=q;A=r}else{b[o>>0]=1;b[e+12>>0]=0;o=e+4|0;l=f[o>>2]|0;h=f[l>>2]|0;f[o>>2]=h;if(h|0)f[h+8>>2]=e;h=e+8|0;f[l+8>>2]=f[h>>2];o=f[h>>2]|0;f[((f[o>>2]|0)==(e|0)?o:o+4|0)>>2]=l;f[l>>2]=e;f[h>>2]=l;l=f[q>>2]|0;z=f[l+4>>2]|0;A=(r|0)==(l|0)?q:r}B=f[z>>2]|0;if(B|0?(b[B+12>>0]|0)==0:0){n=31;break}l=f[z+4>>2]|0;if(l|0?(b[l+12>>0]|0)==0:0){C=l;n=32;break}b[z+12>>0]=0;l=f[z+8>>2]|0;if((l|0)==(A|0)){D=A;n=30;break}if(!(b[l+12>>0]|0)){D=l;n=30;break}else{x=A;y=l}}l=f[y+8>>2]|0;q=f[((f[l>>2]|0)==(y|0)?l+4|0:l)>>2]|0;r=x}if((n|0)==30){b[D+12>>0]=1;return}else if((n|0)==31){D=f[z+4>>2]|0;if(!D)n=33;else{C=D;n=32}}else if((n|0)==48){b[w>>0]=1;return}else if((n|0)==49)if(v)n=51;else n=50;if((n|0)==32)if(!(b[C+12>>0]|0)){E=z;F=C;n=36}else n=33;else if((n|0)==50)if(!(b[u+12>>0]|0)){G=s;H=u;n=54}else n=51;if((n|0)==33){b[B+12>>0]=1;b[z+12>>0]=0;u=B+4|0;C=f[u>>2]|0;f[z>>2]=C;if(C|0)f[C+8>>2]=z;C=z+8|0;f[B+8>>2]=f[C>>2];v=f[C>>2]|0;f[((f[v>>2]|0)==(z|0)?v:v+4|0)>>2]=B;f[u>>2]=z;f[C>>2]=B;E=B;F=z;n=36}else if((n|0)==51){z=s+4|0;B=f[z>>2]|0;b[B+12>>0]=1;b[s+12>>0]=0;C=f[B>>2]|0;f[z>>2]=C;if(C|0)f[C+8>>2]=s;C=s+8|0;f[B+8>>2]=f[C>>2];z=f[C>>2]|0;f[((f[z>>2]|0)==(s|0)?z:z+4|0)>>2]=B;f[B>>2]=s;f[C>>2]=B;G=B;H=s;n=54}if((n|0)==36){s=f[E+8>>2]|0;B=s+12|0;b[E+12>>0]=b[B>>0]|0;b[B>>0]=1;b[F+12>>0]=1;F=s+4|0;B=f[F>>2]|0;E=f[B>>2]|0;f[F>>2]=E;if(E|0)f[E+8>>2]=s;E=s+8|0;f[B+8>>2]=f[E>>2];F=f[E>>2]|0;f[((f[F>>2]|0)==(s|0)?F:F+4|0)>>2]=B;f[B>>2]=s;f[E>>2]=B;return}else if((n|0)==54){n=f[G+8>>2]|0;B=n+12|0;b[G+12>>0]=b[B>>0]|0;b[B>>0]=1;b[H+12>>0]=1;H=f[n>>2]|0;B=H+4|0;G=f[B>>2]|0;f[n>>2]=G;if(G|0)f[G+8>>2]=n;G=n+8|0;f[H+8>>2]=f[G>>2];E=f[G>>2]|0;f[((f[E>>2]|0)==(n|0)?E:E+4|0)>>2]=H;f[B>>2]=n;f[G>>2]=H;return}}function xwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=(c-b|0)/12|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0>((g-h|0)/12|0)>>>0){if(!h)j=g;else{g=a+4|0;k=f[g>>2]|0;if((k|0)==(i|0))l=h;else{m=k;while(1){k=m+-12|0;f[g>>2]=k;n=f[k>>2]|0;if(!n)o=k;else{k=m+-8|0;p=f[k>>2]|0;if((p|0)!=(n|0))f[k>>2]=p+(~((p+-4-n|0)>>>2)<<2);O5b(n);o=f[g>>2]|0}if((o|0)==(i|0))break;else m=o}l=f[a>>2]|0}O5b(l);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;j=0}if(d>>>0>357913941)c4b(a);g=(j|0)/12|0;j=g<<1;l=g>>>0<178956970?(j>>>0<d>>>0?d:j):357913941;if(l>>>0>357913941)c4b(a);j=L5b(l*12|0)|0;g=a+4|0;f[g>>2]=j;f[a>>2]=j;f[e>>2]=j+(l*12|0);if((b|0)==(c|0))return;l=b;e=j;do{Bua(e,l);l=l+12|0;e=(f[g>>2]|0)+12|0;f[g>>2]=e}while((l|0)!=(c|0));return}else{l=a+4|0;a=((f[l>>2]|0)-h|0)/12|0;h=d>>>0>a>>>0;d=b+(a*12|0)|0;a=h?d:c;if((a|0)==(b|0))q=i;else{e=b;b=i;while(1){if((b|0)!=(e|0))r2(b,f[e>>2]|0,f[e+4>>2]|0);e=e+12|0;i=b+12|0;if((e|0)==(a|0)){q=i;break}else b=i}}if(h){if((a|0)==(c|0))return;a=d;d=f[l>>2]|0;do{Bua(d,a);a=a+12|0;d=(f[l>>2]|0)+12|0;f[l>>2]=d}while((a|0)!=(c|0));return}c=f[l>>2]|0;if((c|0)==(q|0))return;else r=c;while(1){c=r+-12|0;f[l>>2]=c;a=f[c>>2]|0;if(!a)s=c;else{c=r+-8|0;d=f[c>>2]|0;if((d|0)!=(a|0))f[c>>2]=d+(~((d+-4-a|0)>>>2)<<2);O5b(a);s=f[l>>2]|0}if((s|0)==(q|0))break;else r=s}return}}function ywa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0;e=u;u=u+16|0;g=e+8|0;h=e;f[g>>2]=c;c=a+32|0;i=Jva(c,g)|0;j=i+60|0;k=f[g>>2]|0;l=d+4|0;m=f[l>>2]|0;do if(m){n=d+4|0;o=m;p=m;while(1){q=f[o+16>>2]|0;if((q|0)>(k|0)){r=f[o>>2]|0;if(!r){s=6;break}else{t=o;v=r}}else{if((q|0)>=(k|0)){s=10;break}w=o+4|0;q=f[w>>2]|0;if(!q){s=9;break}else{t=w;v=q}}n=t;o=v;p=v}if((s|0)==6){x=o;y=o;s=13;break}else if((s|0)==9){x=w;y=o;s=13;break}else if((s|0)==10){z=o;A=n;B=p;s=12;break}}else{z=l;A=l;B=m;s=12}while(0);if((s|0)==12)if(!B){x=A;y=z;s=13}else C=B;if((s|0)==13){B=L5b(60)|0;f[B+16>>2]=k;k=B+20|0;D=k;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[k+36>>0]=0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=y;f[x>>2]=B;y=f[f[d>>2]>>2]|0;if(!y)F=B;else{f[d>>2]=y;F=f[x>>2]|0}mP(f[d+4>>2]|0,F);F=d+8|0;f[F>>2]=(f[F>>2]|0)+1;C=B}if((f[C+20>>2]|0)==(f[C+24>>2]|0)?(C=i+64|0,i=f[j>>2]|0,(f[C>>2]|0)!=(i|0)):0){B=d+4|0;F=d+8|0;x=0;y=i;do{i=f[y+(x<<3)>>2]|0;k=f[l>>2]|0;if(k){z=l;A=k;a:while(1){m=A;while(1){if((f[m+16>>2]|0)>=(i|0))break;w=f[m+4>>2]|0;if(!w){G=z;break a}else m=w}A=f[m>>2]|0;if(!A){G=m;break}else z=m}if(((G|0)!=(l|0)?(f[G+16>>2]|0)<=(i|0):0)?(f[G+32>>2]|0)!=(f[G+36>>2]|0):0)H=k;else s=27}else s=27;if((s|0)==27){s=0;ywa(a,i,d);H=f[l>>2]|0}do if(H){z=B;A=H;p=H;while(1){n=f[A+16>>2]|0;if((n|0)>(i|0)){o=f[A>>2]|0;if(!o){s=32;break}else{I=A;J=o}}else{if((n|0)>=(i|0)){s=36;break}K=A+4|0;n=f[K>>2]|0;if(!n){s=35;break}else{I=K;J=n}}z=I;A=J;p=J}if((s|0)==32){s=0;L=A;M=A;s=38;break}else if((s|0)==35){s=0;L=K;M=A;s=38;break}else if((s|0)==36){s=0;N=A;O=z;P=p;s=37;break}}else{N=l;O=l;P=H;s=37}while(0);if((s|0)==37){s=0;if(!P){L=O;M=N;s=38}else{Q=P;R=H}}if((s|0)==38){s=0;k=L5b(60)|0;f[k+16>>2]=i;m=k+20|0;D=m;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[m+36>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=M;f[L>>2]=k;i=f[f[d>>2]>>2]|0;if(!i)S=k;else{f[d>>2]=i;S=f[L>>2]|0}mP(f[B>>2]|0,S);f[F>>2]=(f[F>>2]|0)+1;Q=k;R=f[l>>2]|0}i=(f[Q+32>>2]|0)+((f[(f[j>>2]|0)+(x<<3)+4>>2]|0)*12|0)|0;n=f[g>>2]|0;do if(R){o=B;w=R;v=R;while(1){t=f[w+16>>2]|0;if((t|0)>(n|0)){q=f[w>>2]|0;if(!q){s=45;break}else{T=w;U=q}}else{if((t|0)>=(n|0)){s=49;break}V=w+4|0;t=f[V>>2]|0;if(!t){s=48;break}else{T=V;U=t}}o=T;w=U;v=U}if((s|0)==45){s=0;W=w;X=w;s=51;break}else if((s|0)==48){s=0;W=V;X=w;s=51;break}else if((s|0)==49){s=0;Y=w;Z=o;_=v;s=50;break}}else{Y=l;Z=l;_=R;s=50}while(0);if((s|0)==50){s=0;if(!_){W=Z;X=Y;s=51}else $=_}if((s|0)==51){s=0;k=L5b(60)|0;f[k+16>>2]=n;m=k+20|0;D=m;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[m+36>>0]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=X;f[W>>2]=k;n=f[f[d>>2]>>2]|0;if(!n)aa=k;else{f[d>>2]=n;aa=f[W>>2]|0}mP(f[B>>2]|0,aa);f[F>>2]=(f[F>>2]|0)+1;$=k}n=$+24|0;p=f[n>>2]|0;if((p|0)==(f[$+28>>2]|0))Sva($+20|0,i);else{Bua(p,i);f[n>>2]=(f[n>>2]|0)+12}x=x+1|0;y=f[j>>2]|0}while(x>>>0<(f[C>>2]|0)-y>>3>>>0)}y=f[g>>2]|0;C=f[l>>2]|0;do if(C){x=d+4|0;j=C;$=C;while(1){F=f[j+16>>2]|0;if((F|0)>(y|0)){aa=f[j>>2]|0;if(!aa){s=63;break}else{ba=j;ca=aa}}else{if((F|0)>=(y|0)){s=67;break}da=j+4|0;F=f[da>>2]|0;if(!F){s=66;break}else{ba=da;ca=F}}x=ba;j=ca;$=ca}if((s|0)==63){ea=j;fa=j;s=70;break}else if((s|0)==66){ea=da;fa=j;s=70;break}else if((s|0)==67){ga=j;ha=x;ia=$;s=69;break}}else{ga=l;ha=l;ia=C;s=69}while(0);if((s|0)==69)if(!ia){ea=ha;fa=ga;s=70}else{ja=ia;ka=y;la=C}if((s|0)==70){C=L5b(60)|0;f[C+16>>2]=y;y=C+20|0;D=y;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[y+36>>0]=0;f[C>>2]=0;f[C+4>>2]=0;f[C+8>>2]=fa;f[ea>>2]=C;fa=f[f[d>>2]>>2]|0;if(!fa)ma=C;else{f[d>>2]=fa;ma=f[ea>>2]|0}mP(f[d+4>>2]|0,ma);ma=d+8|0;f[ma>>2]=(f[ma>>2]|0)+1;ja=C;ka=f[g>>2]|0;la=f[l>>2]|0}C=ja+20|0;do if(la){ja=d+4|0;ma=la;ea=la;while(1){fa=f[ma+16>>2]|0;if((fa|0)>(ka|0)){y=f[ma>>2]|0;if(!y){s=78;break}else{na=ma;oa=y}}else{if((fa|0)>=(ka|0)){s=82;break}pa=ma+4|0;fa=f[pa>>2]|0;if(!fa){s=81;break}else{na=pa;oa=fa}}ja=na;ma=oa;ea=oa}if((s|0)==78){qa=ma;ra=ma;s=85;break}else if((s|0)==81){qa=pa;ra=ma;s=85;break}else if((s|0)==82){sa=ma;ta=ja;ua=ea;s=84;break}}else{sa=l;ta=l;ua=la;s=84}while(0);if((s|0)==84)if(!ua){qa=ta;ra=sa;s=85}else{va=ua;wa=ka;xa=la}if((s|0)==85){la=L5b(60)|0;f[la+16>>2]=ka;ka=la+20|0;D=ka;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[ka+36>>0]=0;f[la>>2]=0;f[la+4>>2]=0;f[la+8>>2]=ra;f[qa>>2]=la;ra=f[f[d>>2]>>2]|0;if(!ra)ya=la;else{f[d>>2]=ra;ya=f[qa>>2]|0}mP(f[d+4>>2]|0,ya);ya=d+8|0;f[ya>>2]=(f[ya>>2]|0)+1;va=la;wa=f[g>>2]|0;xa=f[l>>2]|0}la=va+32|0;do if(xa){va=d+4|0;ya=xa;qa=xa;while(1){ra=f[ya+16>>2]|0;if((ra|0)>(wa|0)){ka=f[ya>>2]|0;if(!ka){s=93;break}else{za=ya;Aa=ka}}else{if((ra|0)>=(wa|0)){s=97;break}Ba=ya+4|0;ra=f[Ba>>2]|0;if(!ra){s=96;break}else{za=Ba;Aa=ra}}va=za;ya=Aa;qa=Aa}if((s|0)==93){Ca=ya;Da=ya;s=100;break}else if((s|0)==96){Ca=Ba;Da=ya;s=100;break}else if((s|0)==97){Ea=ya;Fa=va;Ga=qa;s=99;break}}else{Ea=l;Fa=l;Ga=xa;s=99}while(0);if((s|0)==99)if(!Ga){Ca=Fa;Da=Ea;s=100}else Ha=Ga;if((s|0)==100){Ga=L5b(60)|0;f[Ga+16>>2]=wa;wa=Ga+20|0;D=wa;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[wa+36>>0]=0;f[Ga>>2]=0;f[Ga+4>>2]=0;f[Ga+8>>2]=Da;f[Ca>>2]=Ga;Da=f[f[d>>2]>>2]|0;if(!Da)Ia=Ga;else{f[d>>2]=Da;Ia=f[Ca>>2]|0}mP(f[d+4>>2]|0,Ia);Ia=d+8|0;f[Ia>>2]=(f[Ia>>2]|0)+1;Ha=Ga}Ga=(Jva(c,g)|0)+92|0;Ia=f[Ga>>2]|0;xva(h,Jva(c,g)|0);c=f[h+4>>2]|0;Ga=nh[f[(f[c>>2]|0)+84>>2]&127](c,C,Ia,la,Ha+44|0)|0;Ha=f[g>>2]|0;g=f[l>>2]|0;do if(g){la=d+4|0;Ia=g;C=g;while(1){c=f[Ia+16>>2]|0;if((c|0)>(Ha|0)){Ca=f[Ia>>2]|0;if(!Ca){s=108;break}else{Ja=Ia;Ka=Ca}}else{if((c|0)>=(Ha|0)){s=112;break}La=Ia+4|0;c=f[La>>2]|0;if(!c){s=111;break}else{Ja=La;Ka=c}}la=Ja;Ia=Ka;C=Ka}if((s|0)==108){Ma=Ia;Na=Ia;s=115;break}else if((s|0)==111){Ma=La;Na=Ia;s=115;break}else if((s|0)==112){Oa=Ia;Pa=la;Qa=C;s=114;break}}else{Oa=l;Pa=l;Qa=g;s=114}while(0);if((s|0)==114)if(!Qa){Ma=Pa;Na=Oa;s=115}else Ra=Qa;if((s|0)==115){s=L5b(60)|0;f[s+16>>2]=Ha;Ha=s+20|0;D=Ha;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));b[Ha+36>>0]=0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=Na;f[Ma>>2]=s;Na=f[f[d>>2]>>2]|0;if(!Na)Sa=s;else{f[d>>2]=Na;Sa=f[Ma>>2]|0}mP(f[d+4>>2]|0,Sa);Sa=d+8|0;f[Sa>>2]=(f[Sa>>2]|0)+1;Ra=s}b[Ra+56>>0]=Ga&1;Ga=f[h>>2]|0;if(!Ga){u=e;return}h=Ga+4|0;Ra=f[h>>2]|0;f[h>>2]=Ra+-1;if((Ra|0)!=1){u=e;return}bi[f[(f[Ga>>2]|0)+8>>2]&2047](Ga);u=e;return}function zwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;c=a+8|0;d=f[a>>2]|0;e=d;if((f[c>>2]|0)-d>>3>>>0>=b>>>0)return;g=a+4|0;if(b>>>0>536870911){h=ze(8)|0;T5b(h,477177);f[h>>2]=149528;If(h|0,25408,1411)}h=f[g>>2]|0;i=L5b(b<<3)|0;j=i+(h-d>>3<<3)|0;d=j;k=i+(b<<3)|0;b=h;if((b|0)==(e|0)){l=d;m=h;n=h}else{h=b;b=d;i=j;do{j=h;h=h+-8|0;o=f[h>>2]|0;f[i+-8>>2]=o;f[i+-4>>2]=f[j+-4>>2];if(o|0){j=o+-4|0;f[j>>2]=(f[j>>2]|0)+1}i=b+-8|0;b=i}while((h|0)!=(e|0));l=b;m=f[a>>2]|0;n=f[g>>2]|0}f[a>>2]=l;f[g>>2]=d;f[c>>2]=k;k=m;c=n;while(1){n=c;if((n|0)==(k|0))break;d=n+-8|0;bD(d);c=d}if(!m)return;O5b(m);return}function Awa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;d=u;u=u+128|0;e=d+112|0;g=d+104|0;h=d+80|0;i=d+88|0;j=d+72|0;k=d+8|0;l=d+64|0;m=d;dQ(g,105872);n=a+4|0;o=f[n>>2]|0;f[e>>2]=0;p=e+4|0;f[p>>2]=0;f[e+8>>2]=0;Fva(o,e);o=f[e>>2]|0;if(o|0){q=f[p>>2]|0;if((q|0)!=(o|0))f[p>>2]=q+(~((q+-8-o|0)>>>3)<<3);O5b(o)}o=f[c>>2]|0;f[h>>2]=o;q=h+4|0;p=f[c+4>>2]|0;f[q>>2]=p;if(!o)r=p;else{p=o+-4|0;f[p>>2]=(f[p>>2]|0)+1;r=f[q>>2]|0}if(!r){Eva(i,a);a=i+4|0;r=f[a>>2]|0;p=r+-8|0;if((p|0)!=(h|0)){bD(h);o=f[p>>2]|0;if(!o)s=0;else{c=o+-4|0;f[c>>2]=(f[c>>2]|0)+1;s=f[p>>2]|0}f[h>>2]=s;f[q>>2]=f[r+-4>>2]}r=f[i>>2]|0;if(r|0){while(1){s=f[a>>2]|0;if((s|0)==(r|0))break;p=s+-8|0;f[a>>2]=p;bD(p)}O5b(f[i>>2]|0)}}i=f[n>>2]|0;Hva(i,Gva(i,h)|0,1);uva(j,f[n>>2]|0,h);i=Jva((f[n>>2]|0)+32|0,j)|0;do if((yM(b)|0)==655360){if((f[i+180>>2]|0)!=(f[i+176>>2]|0)){f[k>>2]=1124007936;j=k+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;f[j+16>>2]=0;f[j+20>>2]=0;f[j+24>>2]=0;f[k+32>>2]=k+8;j=k+40|0;f[k+36>>2]=j;f[k+44>>2]=0;f[j>>2]=0;j=f[n>>2]|0;a=f[h>>2]|0;f[l>>2]=a;f[l+4>>2]=f[q>>2];if(a|0){r=a+-4|0;f[r>>2]=(f[r>>2]|0)+1}uva(e,j,l);Bwa(j,k,e);bD(l);RM(b,k);hI(k)}}else{if((yM(b)|0)!=65536){if((yM(b)|0)!=327680){if((yM(b)|0)!=720896)break;j=i+176|0;r=f[i+180>>2]|0;a=f[j>>2]|0;if((r|0)==(a|0))break;p=f[b+4>>2]|0;if((p|0)==(j|0))break;bwa(p,a,r);break}r=i+176|0;a=i+180|0;p=f[r>>2]|0;if((f[a>>2]|0)!=(p|0)){j=i+140|0;s=e+8|0;c=e+4|0;o=0;t=p;do{p=(f[j>>2]|0)+(o*56|0)|0;v=s;f[v>>2]=0;f[v+4>>2]=0;f[e>>2]=33619968;f[c>>2]=p;oI(t+(o*48|0)|0,e);o=o+1|0;t=f[r>>2]|0}while(o>>>0<(((f[a>>2]|0)-t|0)/48|0)>>>0)}t=f[b+4>>2]|0;a=i+140|0;if((t|0)==(a|0))break;cwa(t,f[a>>2]|0,f[i+144>>2]|0);break}a=f[n>>2]|0;t=f[h>>2]|0;f[m>>2]=t;f[m+4>>2]=f[q>>2];if(t|0){o=t+-4|0;f[o>>2]=(f[o>>2]|0)+1}uva(e,a,m);Iva(k,a,e);SM(b,k);a=k+36|0;o=f[a>>2]|0;if(o|0?(t=o+12|0,o=f[t>>2]|0,f[t>>2]=o+-1,(o|0)==1):0)kL(k);f[a>>2]=0;a=k+16|0;o=k+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[o>>2]|0)>0){a=f[k+40>>2]|0;t=0;do{f[a+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[o>>2]|0))}o=f[k+44>>2]|0;if((o|0)!=(k+48|0))UC(o);bD(m)}while(0);bD(h);if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function Bwa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;e=u;u=u+128|0;g=e+112|0;h=e+64|0;i=e+56|0;j=e+48|0;k=e+40|0;l=e+32|0;m=e+24|0;n=e+16|0;o=e+8|0;p=e;dQ(g,105892);if(!((f[d>>2]|0)>-1?(f[d+4>>2]|0)>-1:0)){f[h>>2]=0;f[h+4>>2]=0;q=aD(h,24)|0;r=366206;s=q+24|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-204,h,366231,364488,1674);bD(h)}t=Jva(a+32|0,d)|0;a=d+4|0;d=t+140|0;v=t+144|0;if((f[a>>2]|0)>>>0>=(((f[v>>2]|0)-(f[d>>2]|0)|0)/56|0)>>>0){f[m>>2]=0;w=m+4|0;f[w>>2]=0;x=t+8|0;aD(m,(f[x>>2]|0)+7|0)|0;y=f[m>>2]|0;b[y>>0]=b[365374]|0;b[y+1>>0]=b[365375]|0;b[y+2>>0]=b[365376]|0;b[y+3>>0]=b[365377]|0;b[y+4>>0]=b[365378]|0;b[y+5>>0]=b[365379]|0;b[y+6>>0]=b[365380]|0;y=f[x>>2]|0;if(y|0)Vac((f[m>>2]|0)+7|0,f[t+4>>2]|0,y|0)|0;f[l>>2]=0;y=l+4|0;f[y>>2]=0;aD(l,(f[w>>2]|0)+15|0)|0;x=f[w>>2]|0;if(!x)z=0;else{Vac(f[l>>2]|0,f[m>>2]|0,x|0)|0;z=f[w>>2]|0}q=(f[l>>2]|0)+z|0;r=366239;s=q+15|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));f[o>>2]=((f[v>>2]|0)-(f[d>>2]|0)|0)/56|0;Kva(n,o);f[k>>2]=0;o=k+4|0;f[o>>2]=0;d=n+4|0;aD(k,(f[d>>2]|0)+(f[y>>2]|0)|0)|0;v=f[y>>2]|0;if(v|0)Vac(f[k>>2]|0,f[l>>2]|0,v|0)|0;v=f[d>>2]|0;if(v|0)Vac((f[k>>2]|0)+(f[y>>2]|0)|0,f[n>>2]|0,v|0)|0;f[j>>2]=0;v=j+4|0;f[v>>2]=0;aD(j,(f[o>>2]|0)+15|0)|0;y=f[o>>2]|0;if(!y)A=0;else{Vac(f[j>>2]|0,f[k>>2]|0,y|0)|0;A=f[o>>2]|0}q=(f[j>>2]|0)+A|0;r=366255;s=q+15|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));sva(p,a);f[i>>2]=0;A=i+4|0;f[A>>2]=0;o=p+4|0;aD(i,(f[o>>2]|0)+(f[v>>2]|0)|0)|0;y=f[v>>2]|0;if(y|0)Vac(f[i>>2]|0,f[j>>2]|0,y|0)|0;y=f[o>>2]|0;if(y|0)Vac((f[i>>2]|0)+(f[v>>2]|0)|0,f[p>>2]|0,y|0)|0;f[h>>2]=0;f[h+4>>2]=0;aD(h,(f[A>>2]|0)+13|0)|0;y=f[A>>2]|0;if(!y)B=0;else{Vac(f[h>>2]|0,f[i>>2]|0,y|0)|0;B=f[A>>2]|0}q=(f[h>>2]|0)+B|0;r=366271;s=q+13|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-211,h,366231,364488,1680);bD(h);bD(i);bD(p);bD(j);bD(k);bD(n);bD(l);bD(m)}m=f[t+176>>2]|0;l=m;if((f[t+180>>2]|0)!=(m|0)?(m=f[a>>2]|0,a=l+(m*48|0)+24|0,t=f[a>>2]|0,(t|0)!=0):0){n=l+(m*48|0)+4|0;k=f[n>>2]|0;if((k|0)<3)C=Y(f[l+(m*48|0)+12>>2]|0,f[l+(m*48|0)+8>>2]|0)|0;else{j=f[l+(m*48|0)+32>>2]|0;p=0;i=1;while(1){r=Y(f[j+(p<<2)>>2]|0,i)|0;p=p+1|0;if((p|0)==(k|0)){C=r;break}else i=r}}if(!((k|0)==0|(C|0)==0)){C=l+(m*48|0)|0;if((C|0)!=(c|0)){k=t+8|0;f[k>>2]=(f[k>>2]|0)+1;k=c+24|0;t=f[k>>2]|0;if(t|0?(i=t+8|0,t=f[i>>2]|0,f[i>>2]=t+-1,(t|0)==1):0)iI(c);t=c+4|0;if((f[t>>2]|0)>0){i=f[c+32>>2]|0;p=0;do{f[i+(p<<2)>>2]=0;p=p+1|0;D=f[t>>2]|0}while((p|0)<(D|0));f[k>>2]=0;f[c>>2]=f[C>>2];if((D|0)<3)E=38;else E=40}else{f[k>>2]=0;f[c>>2]=f[C>>2];E=38}if((E|0)==38){D=f[n>>2]|0;if((D|0)<3){f[t>>2]=D;f[c+8>>2]=f[l+(m*48|0)+8>>2];f[c+12>>2]=f[l+(m*48|0)+12>>2];D=f[l+(m*48|0)+36>>2]|0;t=f[c+36>>2]|0;f[t>>2]=f[D>>2];f[t+4>>2]=f[D+4>>2]}else E=40}if((E|0)==40)gI(c,C);f[c+16>>2]=f[l+(m*48|0)+16>>2];C=c+20|0;if(!(f[C>>2]|0))f[C>>2]=f[l+(m*48|0)+20>>2];f[k>>2]=f[a>>2];f[c+28>>2]=f[l+(m*48|0)+28>>2]}}else E=44}else E=44;if((E|0)==44){f[h>>2]=1124007936;m=h+4|0;l=h+8|0;a=h+20|0;k=h+24|0;C=h+28|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;f[m+16>>2]=0;f[m+20>>2]=0;f[m+24>>2]=0;f[h+32>>2]=l;D=h+40|0;t=h+36|0;f[t>>2]=D;f[h+44>>2]=0;f[D>>2]=0;if((h|0)!=(c|0)){D=c+24|0;n=f[D>>2]|0;if(n|0?(p=n+8|0,n=f[p>>2]|0,f[p>>2]=n+-1,(n|0)==1):0)iI(c);n=c+4|0;if((f[n>>2]|0)>0){p=f[c+32>>2]|0;i=0;do{f[p+(i<<2)>>2]=0;i=i+1|0;F=f[n>>2]|0}while((i|0)<(F|0));f[D>>2]=0;f[c>>2]=f[h>>2];if((F|0)<3)E=53;else E=55}else{f[D>>2]=0;f[c>>2]=f[h>>2];E=53}if((E|0)==53){F=f[m>>2]|0;if((F|0)<3){f[n>>2]=F;f[c+8>>2]=f[l>>2];f[c+12>>2]=f[h+12>>2];l=f[t>>2]|0;t=f[c+36>>2]|0;f[t>>2]=f[l>>2];f[t+4>>2]=f[l+4>>2]}else E=55}if((E|0)==55)gI(c,h);f[c+16>>2]=f[h+16>>2];E=c+20|0;if(!(f[E>>2]|0))f[E>>2]=f[a>>2];f[D>>2]=f[k>>2];f[c+28>>2]=f[C>>2]}hI(h)}if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Cwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+96|0;e=d+88|0;g=d+72|0;h=d;i=d+16|0;dQ(e,105912);f[g>>2]=0;j=g+4|0;f[j>>2]=0;f[g+8>>2]=0;k=c+4|0;l=f[c>>2]|0;if((f[k>>2]|0)==(l|0))m=a+4|0;else{n=a+4|0;a=g+8|0;o=0;p=l;do{uva(h,f[n>>2]|0,p+(o<<3)|0);l=f[j>>2]|0;if((l|0)==(f[a>>2]|0))qva(g,h);else{q=h;r=f[q+4>>2]|0;s=l;f[s>>2]=f[q>>2];f[s+4>>2]=r;f[j>>2]=(f[j>>2]|0)+8}o=o+1|0;p=f[c>>2]|0}while(o>>>0<(f[k>>2]|0)-p>>3>>>0);m=n}Fva(f[m>>2]|0,g);n=f[g>>2]|0;p=f[j>>2]|0;a:do if((n|0)!=(p|0)?(k=n+8|0,(k|0)!=(p|0)):0){o=n;c=k;k=f[n>>2]|0;while(1){a=o+4|0;r=o;s=c;while(1){q=f[s>>2]|0;if((k|0)<(q|0)){t=q;break}if((k|0)==(q|0)?(f[a>>2]|0)<(f[r+12>>2]|0):0){t=k;break}q=s+8|0;if((q|0)==(p|0)){v=o;break a}else{l=s;s=q;r=l}}c=s+8|0;if((c|0)==(p|0)){v=s;break}else{o=s;k=t}}}else v=n;while(0);n=f[m>>2]|0;Hva(n,ova(n,f[v>>2]|0)|0,1);f[h>>2]=0;v=h+4|0;f[v>>2]=0;f[h+8>>2]=0;n=f[g>>2]|0;if((f[j>>2]|0)!=(n|0)){t=h+8|0;p=i+36|0;k=i+16|0;o=i+4|0;c=i+40|0;r=i+44|0;a=i+48|0;l=i+8|0;q=i+12|0;w=i+20|0;x=i+24|0;y=i+28|0;z=i+32|0;A=0;B=n;do{Iva(i,f[m>>2]|0,B+(A<<3)|0);n=f[v>>2]|0;if((n|0)==(f[t>>2]|0))v2(h,i);else{f[n>>2]=f[i>>2];C=n+4|0;f[C>>2]=f[o>>2];D=n+8|0;f[D>>2]=f[l>>2];f[n+12>>2]=f[q>>2];f[n+16>>2]=f[k>>2];f[n+20>>2]=f[w>>2];f[n+24>>2]=f[x>>2];f[n+28>>2]=f[y>>2];f[n+32>>2]=f[z>>2];E=f[p>>2]|0;f[n+36>>2]=E;f[n+40>>2]=D;D=n+48|0;F=n+44|0;f[F>>2]=D;f[D>>2]=0;f[n+52>>2]=0;if(E|0){D=E+12|0;f[D>>2]=(f[D>>2]|0)+1}if((f[o>>2]|0)<3){D=f[r>>2]|0;E=f[F>>2]|0;f[E>>2]=f[D>>2];f[E+4>>2]=f[D+4>>2]}else{f[C>>2]=0;jL(n,i)}f[v>>2]=(f[v>>2]|0)+56}n=f[p>>2]|0;if(n|0?(C=n+12|0,n=f[C>>2]|0,f[C>>2]=n+-1,(n|0)==1):0)kL(i);f[p>>2]=0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[o>>2]|0)>0){n=f[c>>2]|0;C=0;do{f[n+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[o>>2]|0))}C=f[r>>2]|0;if((C|0)!=(a|0))UC(C);A=A+1|0;B=f[g>>2]|0}while(A>>>0<(f[j>>2]|0)-B>>3>>>0)}B=f[b+4>>2]|0;if((B|0)!=(h|0))cwa(B,f[h>>2]|0,f[v>>2]|0);et(h);h=f[g>>2]|0;if(h|0){g=f[j>>2]|0;if((g|0)!=(h|0))f[j>>2]=g+(~((g+-8-h|0)>>>3)<<3);O5b(h)}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function Dwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0;c=u;u=u+32|0;d=c+20|0;e=c+16|0;g=c+12|0;h=c+8|0;i=c;dQ(i,105932);j=(f[(f[a+4>>2]|0)+4>>2]|0)+36|0;f[g>>2]=f[b>>2];f[h>>2]=f[b+4>>2];f[e>>2]=f[g>>2];f[d>>2]=f[h>>2];Ewa(j,e,d);if(!(f[i+4>>2]|0)){u=c;return}u=c;return}function Ewa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=f[b>>2]|0;b=f[c>>2]|0;e=b-d>>3;g=a+8|0;h=f[g>>2]|0;i=f[a>>2]|0;j=d;k=i;l=b;if(e>>>0>h-i>>3>>>0){if(!i)m=h;else{h=a+4|0;while(1){n=f[h>>2]|0;if((n|0)==(k|0))break;o=n+-8|0;f[h>>2]=o;bD(o)}O5b(f[a>>2]|0);f[g>>2]=0;f[h>>2]=0;f[a>>2]=0;m=0}if(e>>>0>536870911)c4b(a);h=m>>2;o=m>>3>>>0<268435455?(h>>>0<e>>>0?e:h):536870911;if(o>>>0>536870911)c4b(a);h=L5b(o<<3)|0;m=a+4|0;f[m>>2]=h;f[a>>2]=h;f[g>>2]=h+(o<<3);if((j|0)==(l|0))return;o=d;d=j;g=h;while(1){h=f[d>>2]|0;f[g>>2]=h;f[g+4>>2]=f[d+4>>2];if(!h)p=d;else{n=h+-4|0;f[n>>2]=(f[n>>2]|0)+1;p=o}n=p+8|0;h=(f[m>>2]|0)+8|0;f[m>>2]=h;if((n|0)==(l|0))break;else{o=n;d=n;g=h}}return}g=a+4|0;a=(f[g>>2]|0)-i>>3;i=e>>>0>a>>>0;e=j+(a<<3)|0;a=i?e:b;if((j|0)==(a|0))q=k;else{b=k;k=j;while(1){if((k|0)!=(b|0)){bD(b);j=f[k>>2]|0;if(!j)r=0;else{d=j+-4|0;f[d>>2]=(f[d>>2]|0)+1;r=f[k>>2]|0}f[b>>2]=r;f[b+4>>2]=f[k+4>>2]}k=k+8|0;d=b+8|0;if((k|0)==(a|0)){q=d;break}else b=d}}if(!i){while(1){i=f[g>>2]|0;if((i|0)==(q|0))break;b=i+-8|0;f[g>>2]=b;bD(b)}return}q=f[c>>2]|0;if((a|0)==(q|0))return;c=e;e=a;a=f[g>>2]|0;while(1){b=f[e>>2]|0;f[a>>2]=b;f[a+4>>2]=f[e+4>>2];if(!b)s=e;else{i=b+-4|0;f[i>>2]=(f[i>>2]|0)+1;s=c}i=s+8|0;b=(f[g>>2]|0)+8|0;f[g>>2]=b;if((i|0)==(q|0))break;else{c=i;e=i;a=b}}return}function Fwa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=u;u=u+160|0;g=e+144|0;h=e+136|0;i=e+128|0;j=e+112|0;k=e+56|0;l=e;dQ(h,105952);m=i+4|0;f[m>>2]=-1;f[i>>2]=0;n=a+4|0;a=f[n>>2]|0;o=wva(a,ova(a,0)|0,d)|0;f[m>>2]=o;if((f[i>>2]|o|0)<0){f[j>>2]=0;o=j+4|0;f[o>>2]=0;a=d+4|0;aD(j,(f[a>>2]|0)+16|0)|0;p=f[j>>2]|0;q=p;r=369299;s=q+16|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));t=f[a>>2]|0;if(t|0)Vac(p+16|0,f[d>>2]|0,t|0)|0;f[g>>2]=0;f[g+4>>2]=0;aD(g,(f[o>>2]|0)+11|0)|0;t=f[o>>2]|0;if(!t)v=0;else{Vac(f[g>>2]|0,f[j>>2]|0,t|0)|0;v=f[o>>2]|0}q=(f[g>>2]|0)+v|0;r=366735;s=q+11|0;do{b[q>>0]=b[r>>0]|0;q=q+1|0;r=r+1|0}while((q|0)<(s|0));bO(-204,g,369316,364488,1925);bD(g);bD(j)}r=Jva((f[n>>2]|0)+32|0,i)|0;i=r+140|0;v=(f[m>>2]|0)+1|0;o=r+92|0;t=f[o>>2]|0;SL(i,(v|0)<(t|0)?t:v);v=f[n>>2]|0;do if((f[v+112>>2]|0)==0?(f[v+116>>2]|0)==1:0){t=(f[m>>2]|0)+1|0;d=f[o>>2]|0;p=r+176|0;a=(t|0)<(d|0)?d:t;t=r+180|0;d=f[t>>2]|0;w=f[p>>2]|0;x=(d-w|0)/48|0;y=d;if(a>>>0>x>>>0){TL(p,a-x|0);z=1;break}if(a>>>0<x>>>0?(x=w+(a*48|0)|0,(y|0)!=(x|0)):0){a=y;do{y=a+-48|0;f[t>>2]=y;hI(y);a=f[t>>2]|0}while((a|0)!=(x|0));z=1}else z=1}else z=0;while(0);o=r+108|0;v=((f[r+144>>2]|0)-(f[i>>2]|0)|0)/56|0;x=r+112|0;a=f[x>>2]|0;t=f[o>>2]|0;y=a-t>>3;w=t;t=a;if(v>>>0<=y>>>0){if(v>>>0<y>>>0?(a=w+(v<<3)|0,(t|0)!=(a|0)):0){w=t;do{t=w+-8|0;f[x>>2]=t;p=f[t>>2]|0;if(p|0?(d=p+4|0,A=f[d>>2]|0,f[d>>2]=A+-1,(A|0)==1):0)bi[f[(f[p>>2]|0)+8>>2]&2047](p);f[t>>2]=0;f[w+-4>>2]=0;w=f[x>>2]|0}while((w|0)!=(a|0))}}else fwa(o,v-y|0);y=f[m>>2]|0;v=f[i>>2]|0;a=f[v+(y*56|0)+4>>2]|0;w=f[v+(y*56|0)+40>>2]|0;f[j>>2]=0;y=j+4|0;f[y>>2]=0;f[j+8>>2]=0;Rva(j,w,w+(a<<2)|0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[k>>2]=f[a>>2];w=k+4|0;v=a+4|0;f[w>>2]=f[v>>2];x=k+8|0;f[x>>2]=f[a+8>>2];f[k+12>>2]=f[a+12>>2];f[k+16>>2]=f[a+16>>2];f[k+20>>2]=f[a+20>>2];f[k+24>>2]=f[a+24>>2];f[k+28>>2]=f[a+28>>2];f[k+32>>2]=f[a+32>>2];t=f[a+36>>2]|0;f[k+36>>2]=t;p=k+40|0;f[p>>2]=x;x=k+48|0;A=k+44|0;f[A>>2]=x;f[x>>2]=0;f[k+52>>2]=0;if(t|0){x=t+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[v>>2]|0)<3){v=f[a+44>>2]|0;x=f[A>>2]|0;f[x>>2]=f[v>>2];f[x+4>>2]=f[v+4>>2];B=w;C=p;break}else{f[w>>2]=0;jL(k,a);B=w;C=p;break}}else{yL(k,c,-1);B=k+4|0;C=k+40|0}while(0);c=f[B>>2]|0;p=f[C>>2]|0;f[g>>2]=0;w=g+4|0;f[w>>2]=0;f[g+8>>2]=0;Rva(g,p,p+(c<<2)|0);c=f[y>>2]|0;p=f[j>>2]|0;a=f[w>>2]|0;v=f[g>>2]|0;x=p;A=c;t=v;d=a;a:do if((c-p|0)==(a-v|0))if((x|0)==(A|0))D=1;else{E=x;F=t;while(1){if((f[E>>2]|0)!=(f[F>>2]|0)){D=0;break a}E=E+4|0;if((E|0)==(A|0)){D=1;break}else F=F+4|0}}else D=0;while(0);A=v;if(v|0){if((d|0)!=(t|0))f[w>>2]=d+(~((d+-4-v|0)>>>2)<<2);O5b(A)}if(D){A=(f[i>>2]|0)+((f[m>>2]|0)*56|0)|0;v=g+8|0;f[v>>2]=0;f[v+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=A;SP(k,g);if(z){A=(f[r+176>>2]|0)+((f[m>>2]|0)*48|0)|0;v=g+8|0;f[v>>2]=0;f[v+4>>2]=0;f[g>>2]=34209792;f[g+4>>2]=A;SP(k,g)}}else{f[l>>2]=1124007936;A=l+4|0;v=l+8|0;d=l+40|0;q=A;s=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(s|0));f[d>>2]=v;q=l+48|0;s=l+44|0;f[s>>2]=q;f[q>>2]=0;f[l+52>>2]=0;w=g+8|0;f[w>>2]=0;f[w+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=l;SP(k,g);w=f[m>>2]|0;t=f[i>>2]|0;i=t+(w*56|0)|0;x=l+36|0;if((i|0)!=(l|0)){a=f[x>>2]|0;if(a|0){p=a+12|0;f[p>>2]=(f[p>>2]|0)+1}p=t+(w*56|0)+36|0;a=f[p>>2]|0;if(a|0?(c=a+12|0,a=f[c>>2]|0,f[c>>2]=a+-1,(a|0)==1):0)kL(i);f[p>>2]=0;a=t+(w*56|0)+16|0;c=t+(w*56|0)+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[c>>2]|0)>0){F=f[t+(w*56|0)+40>>2]|0;E=0;do{f[F+(E<<2)>>2]=0;E=E+1|0;G=f[c>>2]|0}while((E|0)<(G|0));f[i>>2]=f[l>>2];if((G|0)<3)H=53;else H=55}else{f[i>>2]=f[l>>2];H=53}if((H|0)==53){G=f[A>>2]|0;if((G|0)<3){f[c>>2]=G;f[t+(w*56|0)+8>>2]=f[v>>2];f[t+(w*56|0)+12>>2]=f[l+12>>2];v=f[s>>2]|0;G=f[t+(w*56|0)+44>>2]|0;f[G>>2]=f[v>>2];f[G+4>>2]=f[v+4>>2]}else H=55}if((H|0)==55)jL(i,l);f[a>>2]=f[l+16>>2];f[t+(w*56|0)+20>>2]=f[l+20>>2];f[t+(w*56|0)+24>>2]=f[l+24>>2];f[t+(w*56|0)+28>>2]=f[l+28>>2];f[t+(w*56|0)+32>>2]=f[l+32>>2];f[p>>2]=f[x>>2]}p=f[x>>2]|0;if(p|0?(w=p+12|0,p=f[w>>2]|0,f[w>>2]=p+-1,(p|0)==1):0)kL(l);f[x>>2]=0;x=l+16|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[A>>2]|0)>0){x=f[d>>2]|0;d=0;do{f[x+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[A>>2]|0))}A=f[s>>2]|0;if((A|0)!=(q|0))UC(A);if(z){z=(f[r+176>>2]|0)+((f[m>>2]|0)*48|0)|0;r=g+8|0;f[r>>2]=0;f[r+4>>2]=0;f[g>>2]=34209792;f[g+4>>2]=z;SP(k,g)}}g=f[(f[o>>2]|0)+(f[m>>2]<<3)+4>>2]|0;if(g|0)bi[f[(f[g>>2]|0)+12>>2]&2047](g);g=(f[n>>2]|0)+144|0;b[g>>0]=D&(b[g>>0]|0)!=0&1;g=k+36|0;D=f[g>>2]|0;if(D|0?(n=D+12|0,D=f[n>>2]|0,f[n>>2]=D+-1,(D|0)==1):0)kL(k);f[g>>2]=0;g=k+16|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[B>>2]|0)>0){g=f[C>>2]|0;C=0;do{f[g+(C<<2)>>2]=0;C=C+1|0}while((C|0)<(f[B>>2]|0))}B=f[k+44>>2]|0;if((B|0)!=(k+48|0))UC(B);B=f[j>>2]|0;if(B|0){j=f[y>>2]|0;if((j|0)!=(B|0))f[y>>2]=j+(~((j+-4-B|0)>>>2)<<2);O5b(B)}if(!(f[h+4>>2]|0)){u=e;return}u=e;return}function Gwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0;d=u;u=u+16|0;e=d;g=d+8|0;h=(c|0)==-1;a:do if(h){switch(f[a>>2]|0){case 0:{i=(f[a+4>>2]|0)+4|0;break}case 3:{i=(f[a+4>>2]|0)+4|0;break}case 2:{i=(f[a+4>>2]|0)+4|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);j=15;break a}}if((f[i>>2]|0)==1)k=a;else j=15}else if((c|0)>-1){switch(f[a>>2]|0){case 0:{l=f[(f[a+4>>2]|0)+4>>2]|0;break}case 3:{l=f[(f[a+4>>2]|0)+4>>2]|0;break}case 2:{l=f[(f[a+4>>2]|0)+4>>2]|0;break}default:{f[e>>2]=0;f[e+4>>2]=0;bO(-3,e,429353,429358,272);bD(e);l=-1}}if((l|0)>(c|0))k=a;else j=15}else j=15;while(0);if((j|0)==15){f[e>>2]=0;f[e+4>>2]=0;m=aD(e,56)|0;n=375342;o=m+56|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,e,375399,429358,88);bD(e);k=a}j=h?0:c;c=f[k>>2]|0;switch(c|0){case 0:{k=(f[f[a+4>>2]>>2]|0)+(j<<3)|0;q=f[k+4>>2]|0;r=f[k>>2]|0;J=q;u=d;return r|0}case 2:{s=+p[(f[f[a+4>>2]>>2]|0)+(j<<3)>>3];if(!(+IVb(s,e)==0.0)){f[g>>2]=0;f[g+4>>2]=0;m=aD(g,15)|0;n=369487;o=m+15|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,g,375399,429358,101);bD(g)}q=+L(s)>=1.0?(s>0.0?~~+Z(+K(s/4294967296.0),4294967295.0)>>>0:~~+X((s-+(~~s>>>0))/4294967296.0)>>>0):0;r=~~s>>>0;J=q;u=d;return r|0}default:{if((c|2|0)==2){q=0;r=0;J=q;u=d;return r|0}f[e>>2]=0;f[e+4>>2]=0;m=aD(e,19)|0;n=369503;o=m+19|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,e,375399,429358,107);bD(e);q=0;r=0;J=q;u=d;return r|0}}return 0}function Hwa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+16|0;g=e;if((f[c>>2]|0)!=3){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,10)|0;i=369406;j=h+10|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-215,g,375399,429358,170);bD(g)}k=(d|0)==-1;if(k){l=f[c+4>>2]|0;if((f[l+4>>2]|0)==1)m=l;else n=7}else if((d|0)>-1?(l=f[c+4>>2]|0,(f[l+4>>2]|0)>(d|0)):0)m=l;else n=7;if((n|0)==7){f[g>>2]=0;f[g+4>>2]=0;h=aD(g,69)|0;i=369417;j=h+69|0;do{b[h>>0]=b[i>>0]|0;h=h+1|0;i=i+1|0}while((h|0)<(j|0));bO(-215,g,375399,429358,171);bD(g);m=f[c+4>>2]|0}c=f[m>>2]|0;m=k?0:d;d=f[c+(m<<3)>>2]|0;f[a>>2]=d;f[a+4>>2]=f[c+(m<<3)+4>>2];if(!d){u=e;return}m=d+-4|0;f[m>>2]=(f[m>>2]|0)+1;u=e;return}function Iwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;c=u;u=u+16|0;d=c;f[a>>2]=0;e=a+4|0;f[e>>2]=0;f[a+8>>2]=0;g=b+4|0;b=f[g>>2]|0;h=f[b+32>>2]|0;if((h|0)==(b+36|0)){u=c;return}b=a+8|0;i=h;while(1){h=f[i+16>>2]|0;f[d>>2]=h;do if(!(f[i+112>>2]|0)){j=f[e>>2]|0;if((j|0)==(f[b>>2]|0)){IO(a,d);break}else{f[j>>2]=h;f[e>>2]=j+4;break}}while(0);h=f[i+4>>2]|0;if(!h){j=i+8|0;k=f[j>>2]|0;if((f[k>>2]|0)==(i|0))l=k;else{k=j;do{j=f[k>>2]|0;k=j+8|0;m=f[k>>2]|0}while((f[m>>2]|0)!=(j|0));l=m}}else{k=h;while(1){m=f[k>>2]|0;if(!m)break;else k=m}l=k}if((l|0)==((f[g>>2]|0)+36|0))break;else i=l}u=c;return}function Jwa(a){a=a|0;var b=0;FY(a);f[a>>2]=105216;b=a+4|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;f[b+12>>2]=0;f[b+16>>2]=0;f[b+20>>2]=0;f[b+24>>2]=0;f[b+28>>2]=0;return}function Kwa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0;c=b+12|0;d=a+4|0;if((d|0)!=(c|0))cwa(d,f[c>>2]|0,f[b+16>>2]|0);c=b+24|0;d=a+16|0;if((c|0)!=(d|0)){bD(d);e=f[c>>2]|0;if(!e)g=0;else{h=e+-4|0;f[h>>2]=(f[h>>2]|0)+1;g=f[c>>2]|0}f[d>>2]=g;f[a+20>>2]=f[b+28>>2]}g=b+32|0;d=a+24|0;if((g|0)==(d|0))return;bD(d);c=f[g>>2]|0;if(!c)i=0;else{h=c+-4|0;f[h>>2]=(f[h>>2]|0)+1;i=f[g>>2]|0}f[d>>2]=i;f[a+28>>2]=f[b+36>>2];return}function Lwa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+64|0;g=e+48|0;h=e+36|0;i=e+24|0;j=e+12|0;k=e;dQ(g,105984);f[h>>2]=0;l=h+4|0;f[l>>2]=0;f[h+8>>2]=0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;AM(b,h);AM(c,i);AM(d,j);b=f[l>>2]|0;m=f[h>>2]|0;n=b-m|0;o=(n|0)/56|0;f[k>>2]=0;p=k+4|0;f[p>>2]=0;f[k+8>>2]=0;if(!n){q=b;r=0}else{if(o>>>0>1073741823)c4b(k);b=L5b(o<<2)|0;f[p>>2]=b;f[k>>2]=b;f[k+8>>2]=b+(o<<2);n=o;o=b;do{f[o>>2]=0;o=(f[p>>2]|0)+4|0;f[p>>2]=o;n=n+-1|0}while((n|0)!=0);q=f[l>>2]|0;r=b}if((q|0)!=(m|0)?(f[r>>2]=m,m=f[h>>2]|0,(((f[l>>2]|0)-m|0)/56|0)>>>0>1):0){r=m;m=1;do{f[(f[k>>2]|0)+(m<<2)>>2]=r+(m*56|0);m=m+1|0;r=f[h>>2]|0}while(m>>>0<(((f[l>>2]|0)-r|0)/56|0)>>>0)}th[f[(f[a>>2]|0)+36>>2]&511](a,k,i,j);TM(c,i);TM(d,j);d=f[k>>2]|0;if(d|0){k=f[p>>2]|0;if((k|0)!=(d|0))f[p>>2]=k+(~((k+-4-d|0)>>>2)<<2);O5b(d)}et(j);et(i);et(h);if(!(f[g+4>>2]|0)){u=e;return}u=e;return}function Mwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+64|0;e=d+40|0;g=d+32|0;h=d+24|0;i=d;j=d+16|0;dQ(g,106016);k=zva()|0;PO(k);l=f[a>>2]|0;if(!l){f[h>>2]=0;f[h+4>>2]=0}else{m=a+4|0;n=f[m>>2]|0;f[e>>2]=0;o=e+4|0;f[o>>2]=0;if(n|0?(Vac(aD(e,n)|0,l|0,n|0)|0,f[m>>2]|0):0){n=0;do{l=(gVb(b[(f[a>>2]|0)+n>>0]|0)|0)&255;b[(f[e>>2]|0)+n>>0]=l;n=n+1|0}while(n>>>0<(f[m>>2]|0)>>>0)}m=f[e>>2]|0;f[h>>2]=m;f[h+4>>2]=f[o>>2];if(m|0){o=m+-4|0;f[o>>2]=(f[o>>2]|0)+1}bD(e)}o=(Ava()|0)+4|0;m=f[o>>2]|0;if(m){n=f[h>>2]|0;a=(n|0)==0?1124530:n;l=o;p=m;a:while(1){m=p;while(1){q=f[m+16>>2]|0;if((q|0)==(n|0))break;if((gTb((q|0)==0?1124530:q,a)|0)>=0)break;q=f[m+4>>2]|0;if(!q){r=l;break a}else m=q}p=f[m>>2]|0;if(!p){r=m;break}else l=m}if((r|0)!=(o|0)){l=f[r+16>>2]|0;if((n|0)!=(l|0)?(gTb(a,(l|0)==0?1124530:l)|0)<0:0)s=21;else t=r}else s=21}else s=21;if((s|0)==21)t=o;if((t|0)!=((Ava()|0)+4|0)?(f[t+24>>2]|0)!=(c|0):0){f[i>>2]=0;t=i+4|0;f[t>>2]=0;o=h+4|0;aD(i,(f[o>>2]|0)+7|0)|0;r=f[i>>2]|0;b[r>>0]=b[365374]|0;b[r+1>>0]=b[365375]|0;b[r+2>>0]=b[365376]|0;b[r+3>>0]=b[365377]|0;b[r+4>>0]=b[365378]|0;b[r+5>>0]=b[365379]|0;b[r+6>>0]=b[365380]|0;r=f[o>>2]|0;if(r|0)Vac((f[i>>2]|0)+7|0,f[h>>2]|0,r|0)|0;f[e>>2]=0;f[e+4>>2]=0;aD(e,(f[t>>2]|0)+24|0)|0;r=f[t>>2]|0;if(!r)v=0;else{Vac(f[e>>2]|0,f[i>>2]|0,r|0)|0;v=f[t>>2]|0}t=(f[e>>2]|0)+v|0;v=369644;r=t+24|0;do{b[t>>0]=b[v>>0]|0;t=t+1|0;v=v+1|0}while((t|0)<(r|0));bO(-5,e,369669,364488,2543);bD(e);bD(i)}v=Ava()|0;t=f[h>>2]|0;f[j>>2]=t;r=j+4|0;o=f[h+4>>2]|0;f[r>>2]=o;if(t){l=t+-4|0;f[l>>2]=(f[l>>2]|0)+1;l=f[j>>2]|0;t=f[r>>2]|0;r=c;f[i>>2]=l;a=i+4|0;f[a>>2]=t;if(l){n=l+-4|0;f[n>>2]=(f[n>>2]|0)+1;n=f[i>>2]|0;l=f[a>>2]|0;a=i+8|0;f[a>>2]=r;f[e>>2]=n;p=e+4|0;f[p>>2]=l;if(!n){w=r;x=e;y=p}else{l=n+-4|0;f[l>>2]=(f[l>>2]|0)+1;w=f[a>>2]|0;x=e;y=p}}else{z=r;A=t;s=32}}else{f[i>>2]=0;f[i+4>>2]=o;z=c;A=o;s=32}if((s|0)==32){f[i+8>>2]=z;f[e>>2]=0;o=e+4|0;f[o>>2]=A;w=z;x=e;y=o}o=e+8|0;f[o>>2]=w;z=v+4|0;A=f[z>>2]|0;b:do if(!A){B=z;C=z}else{c=v+4|0;t=f[e>>2]|0;r=(t|0)==0?1124530:t;p=f[A+16>>2]|0;c:do if((t|0)!=(p|0)){a=c;l=A;n=p;while(1){q=(n|0)==0?1124530:n;if((gTb(r,q)|0)<0){D=f[l>>2]|0;if(!D){s=40;break}else{E=l;F=D}}else{if((gTb(q,r)|0)>=0){G=a;H=l;break c}I=l+4|0;q=f[I>>2]|0;if(!q){s=43;break}else{E=I;F=q}}n=f[F+16>>2]|0;if((t|0)==(n|0)){G=E;H=F;break c}else{a=E;l=F}}if((s|0)==40){B=l;C=l;break b}else if((s|0)==43){B=I;C=l;break b}}else{G=c;H=A}while(0);B=G;C=H}while(0);if(!(f[B>>2]|0)){H=L5b(28)|0;G=f[x>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[y>>2];if(!G)J=w;else{w=G+-4|0;f[w>>2]=(f[w>>2]|0)+1;J=f[o>>2]|0}f[H+24>>2]=J;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=C;f[B>>2]=H;C=f[f[v>>2]>>2]|0;if(!C)K=H;else{f[v>>2]=C;K=f[B>>2]|0}mP(f[v+4>>2]|0,K);K=v+8|0;f[K>>2]=(f[K>>2]|0)+1}bD(e);bD(i);bD(j);bD(h);QO(k);if(!(f[g+4>>2]|0)){u=d;return}u=d;return}function Nwa(a,b){a=a|0;b=b|0;return}function Owa(){return 0}function Pwa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=u;u=u+96|0;g=e+8|0;h=e;i=f[c>>2]|0;c=(i|0)==0?1124530:i;i=f[d>>2]|0;d=(i|0)==0?1124530:i;nEa(g);i=g+40|0;nEa(i);if(b[c>>0]|0)iya(c,g);if(b[d>>0]|0)rya(d,i);Fua(a);d=f[a>>2]|0;f[h>>2]=d;f[h+4>>2]=f[a+4>>2];if(d|0){a=d+4|0;f[a>>2]=(f[a>>2]|0)+1}Qwa(g,h);kva(h);mBa(i);mBa(g);u=e;return}function Qwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,ei=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,Zj=0,_j=0,$j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0,hk=0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0,ok=0,pk=0,qk=0,rk=0,sk=0,tk=0,uk=0,vk=0,wk=0,xk=0,yk=0,zk=0,Ak=0,Bk=0,Ck=0,Dk=0,Ek=0,Fk=0,Gk=0,Hk=0,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0,$k=0,al=0,bl=0,cl=0,dl=0,el=0,fl=0,gl=0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0,nl=0,ol=0,pl=0,ql=0,rl=0,sl=0,tl=0,ul=0,vl=0,wl=0,xl=0,yl=0,zl=0,Al=0,Bl=0,Cl=0,Dl=0,El=0,Fl=0,Gl=0,Hl=0,Il=0,Jl=0,Kl=0,Ll=0,Ml=0,Nl=0,Ol=0,Pl=0,Ql=0,Rl=0,Sl=0,Tl=0,Ul=0,Vl=0,Wl=0,Xl=0,Yl=0,Zl=0,_l=0,$l=0,am=0,bm=0,cm=0,dm=0,em=0,fm=0,gm=0,hm=0,im=0,jm=0,km=0,lm=0,mm=0,nm=0,om=0,pm=0,qm=0,rm=0,sm=0,tm=0,um=0,vm=0,wm=0,xm=0,ym=0,zm=0,Am=0,Bm=0,Cm=0,Dm=0,Em=0,Fm=0,Gm=0,Hm=0,Im=0,Jm=0,Km=0,Lm=0,Mm=0,Nm=0,Om=0,Pm=0,Qm=0,Rm=0,Sm=0,Tm=0,Um=0,Vm=0,Wm=0,Xm=0,Ym=0,Zm=0,_m=0,$m=0,an=0,bn=0,cn=0,dn=0,en=0,fn=0,gn=0,hn=0,jn=0,kn=0,ln=0,mn=0,nn=0,on=0,pn=0,qn=0,rn=0,sn=0,tn=0,un=0,vn=0,wn=0,xn=0,yn=0,zn=0,An=0,Bn=0,Cn=0,Dn=0,En=0,Fn=0,Gn=0,Hn=0,In=0,Jn=0,Kn=0,Ln=0,Mn=0,Nn=0,On=0,Pn=0,Qn=0,Rn=0,Sn=0,Tn=0,Un=0,Vn=0,Wn=0,Xn=0,Yn=0,Zn=0,_n=0,$n=0,ao=0,bo=0,co=0,eo=0,fo=0,go=0,ho=0,io=0,jo=0,ko=0,lo=0,mo=0,no=0,oo=0,po=0,qo=0,ro=0,so=0,to=0,uo=0,vo=0,wo=0,xo=0,yo=0,zo=0,Ao=0,Bo=0,Co=0,Do=0,Eo=0,Fo=0,Go=0,Ho=0,Io=0,Jo=0,Ko=0,Lo=0,Mo=0,No=0,Oo=0,Po=0,Qo=0,Ro=0,So=0,To=0,Uo=0,Vo=0,Wo=0,Xo=0,Yo=0,Zo=0,_o=0,$o=0,ap=0,bp=0,cp=0,dp=0,ep=0,fp=0,gp=0,hp=0,ip=0,jp=0,kp=0,lp=0,mp=0,np=0,op=0,pp=0,qp=0,rp=0,sp=0,tp=0,up=0,vp=0,wp=0,xp=0,yp=0,zp=0,Ap=0,Bp=0,Cp=0,Dp=0,Ep=0,Fp=0,Gp=0,Hp=0,Ip=0.0,Jp=0,Kp=0,Lp=0,Mp=0,Np=0,Op=0,Pp=0,Qp=0,Rp=0,Sp=0,Tp=0,Up=0,Vp=0,Wp=0,Xp=0,Yp=0,Zp=0,_p=0,$p=0,aq=0,bq=0,cq=0,dq=0,eq=0,fq=0,gq=0,hq=0,iq=0,jq=0,kq=0,lq=0,mq=0,nq=0,oq=0,pq=0,qq=0,rq=0,sq=0,tq=0,uq=0,vq=0,wq=0,xq=0,yq=0,zq=0,Aq=0,Bq=0,Cq=0,Dq=0,Eq=0,Fq=0,Gq=0,Hq=0,Iq=0,Jq=0,Kq=0,Lq=0,Mq=0,Nq=0,Oq=0,Pq=0,Qq=0,Rq=0,Sq=0,Tq=0,Uq=0,Vq=0,Wq=0,Xq=0,Yq=0,Zq=0,_q=0,$q=0,ar=0,br=0,cr=0,dr=0,er=0,fr=0,gr=0,hr=0,ir=0,jr=0,kr=0,lr=0,mr=0,nr=0,or=0,pr=0,qr=0,rr=0,sr=0,tr=0,ur=0,vr=0,wr=0,xr=0,yr=0,zr=0,Ar=0,Br=0,Cr=0,Dr=0,Er=0,Fr=0,Gr=0,Hr=0,Ir=0,Jr=0,Kr=0,Lr=0,Mr=0,Nr=0,Or=0,Pr=0,Qr=0,Rr=0,Sr=0,Tr=0,Ur=0,Vr=0,Wr=0,Xr=0,Yr=0,Zr=0,_r=0,$r=0,as=0,bs=0,cs=0,ds=0,es=0,fs=0,gs=0,hs=0,is=0,js=0,ks=0,ls=0,ms=0,ns=0,os=0,ps=0,qs=0,rs=0,ss=0,ts=0,us=0,vs=0,ws=0,xs=0,ys=0,zs=0,As=0,Bs=0,Cs=0,Ds=0,Es=0,Fs=0,Gs=0,Hs=0,Is=0,Js=0,Ks=0,Ls=0,Ms=0,Ns=0,Os=0,Ps=0,Qs=0,Rs=0,Ss=0,Ts=0,Us=0,Vs=0,Xs=0,Ys=0,Zs=0,_s=0,$s=0,at=0,bt=0,ct=0,dt=0,et=0,ft=0,gt=0,ht=0,it=0,jt=0,kt=0,lt=0,mt=0,nt=0,ot=0,pt=0,qt=0,rt=0,st=0,tt=0,ut=0,vt=0,wt=0,xt=0,yt=0,zt=0,At=0,Bt=0,Ct=0;d=u;u=u+1744|0;e=d+512|0;g=d+280|0;h=d+224|0;i=d;j=d+1496|0;k=d+1256|0;l=d+1244|0;m=d+1232|0;o=d+1220|0;q=d+1136|0;r=d+1128|0;s=d+1120|0;t=d+1080|0;v=d+908|0;w=d+736|0;x=d+1724|0;y=d+680|0;z=d+1712|0;A=d+1700|0;B=d+1688|0;C=d+1676|0;D=d+1664|0;E=d+1652|0;F=d+288|0;G=d+1640|0;H=d+1632|0;I=d+1624|0;J=d+1608|0;K=d+1596|0;L=d+1584|0;M=d+1572|0;N=d+1560|0;O=d+1548|0;P=d+1536|0;Q=d+1524|0;R=d+1512|0;S=d+1480|0;T=d+1468|0;U=d+1456|0;V=d+1444|0;W=d+1432|0;X=d+624|0;Z=d+1420|0;_=d+1408|0;$=d+1352|0;aa=d+1296|0;ba=d+568|0;ca=d+1280|0;da=d+1268|0;Rwa(a);ea=a+40|0;Rwa(ea);fa=k+4|0;f[fa>>2]=0;ga=k+8|0;f[ga>>2]=0;ha=k+4|0;f[k>>2]=ha;ia=(di[f[(f[ea>>2]|0)+52>>2]&1023](ea)|0)!=0;ja=ia?ea:a;ia=f[ja+12>>2]|0;f[l+4>>2]=0;f[l+8>>2]=0;ka=l+4|0;f[l>>2]=ka;f[m+4>>2]=0;f[m+8>>2]=0;la=m+4|0;f[m>>2]=la;Swa(a,m,k);Swa(ea,m,k);f[o+4>>2]=0;f[o+8>>2]=0;ea=o+4|0;f[o>>2]=ea;if((ia|0)<=0){ma=la;na=ka;oa=ha;pa=0;Wta(o,pa);qa=f[ma>>2]|0;Wta(m,qa);ra=f[na>>2]|0;Wta(l,ra);sa=f[oa>>2]|0;vxa(k,sa);u=d;return}ta=ja+20|0;ua=q+68|0;va=r+4|0;wa=q+72|0;xa=s+4|0;ya=t+4|0;za=t+8|0;Aa=t+4|0;Ba=t+12|0;Ca=q+12|0;Da=q+20|0;Ea=e+4|0;Fa=x+4|0;Ga=x+8|0;Ha=x+4|0;Ia=e+4|0;Ja=e+4|0;Ka=e+4|0;La=y+4|0;Ma=y+8|0;Na=y+40|0;Oa=y+48|0;Pa=y+44|0;Qa=y+52|0;Ra=z+4|0;Sa=z+8|0;Ta=z+4|0;Ua=e+4|0;Va=e+8|0;Wa=h+4|0;Xa=h+8|0;Ya=h+12|0;Za=y+12|0;_a=y+16|0;$a=h+16|0;ab=i+4|0;bb=i+4|0;cb=h+36|0;db=h+40|0;eb=h+44|0;fb=h+48|0;gb=e+4|0;hb=e+4|0;ib=h+4|0;jb=e+4|0;kb=y+36|0;lb=h+4|0;mb=i+4|0;nb=Ta;ob=w+4|0;pb=w+4|0;qb=Ha;rb=e+4|0;sb=e+4|0;tb=t+12|0;ub=e+4|0;vb=w+4|0;wb=e+4|0;xb=A+4|0;yb=A+8|0;zb=A+4|0;Ab=zb;Bb=B+4|0;Cb=B+8|0;Db=B+4|0;Eb=h+4|0;Fb=h+8|0;Gb=h+40|0;Hb=h+48|0;Ib=h+44|0;Jb=h+52|0;Kb=e+8|0;Lb=e+4|0;Mb=h+16|0;Nb=h+36|0;Ob=e+4|0;Pb=e+4|0;Qb=e+4|0;Rb=h+4|0;Sb=e+4|0;Tb=e+4|0;Ub=e+11|0;Vb=e+8|0;Wb=e+4|0;Xb=e+11|0;Yb=h+8|0;Zb=h+4|0;_b=q+24|0;$b=q+60|0;ac=h+11|0;bc=e+11|0;cc=e+4|0;dc=h+4|0;ec=i+11|0;fc=i+4|0;gc=v+11|0;hc=e+4|0;ic=e+4|0;jc=Db;kc=h+4|0;lc=e+11|0;mc=e+4|0;nc=C+4|0;oc=C+8|0;pc=C+4|0;qc=e+4|0;rc=e+11|0;sc=pc;tc=e+4|0;uc=e+4|0;vc=e+4|0;wc=h+4|0;xc=e+11|0;yc=e+4|0;zc=h+4|0;Ac=i+11|0;Bc=i+4|0;Cc=h+4|0;Dc=e+12|0;Ec=e+4|0;Fc=e+4|0;Gc=v+4|0;Hc=h+4|0;Ic=e+4|0;Jc=e+4|0;Kc=D+4|0;Lc=D+8|0;Mc=D+4|0;Nc=Mc;Oc=E+4|0;Pc=E+8|0;Qc=E+4|0;Rc=h+4|0;Sc=h+8|0;Tc=h+40|0;Uc=h+48|0;Vc=h+44|0;Wc=h+52|0;Xc=i+4|0;Yc=i+8|0;Zc=i+40|0;_c=i+48|0;$c=i+44|0;ad=i+52|0;bd=e+8|0;cd=e+4|0;dd=i+36|0;ed=i+16|0;fd=h+36|0;gd=h+16|0;hd=i+12|0;id=i+20|0;jd=i+24|0;kd=i+28|0;ld=i+32|0;md=e+4|0;nd=e+4|0;od=e+11|0;pd=Qc;qd=e+4|0;rd=G+4|0;sd=G+8|0;td=G+4|0;ud=e+4|0;vd=e+4|0;wd=e+4|0;xd=e+8|0;yd=e+4|0;zd=e+12|0;Ad=h+4|0;Bd=i+4|0;Cd=H+4|0;Dd=h+11|0;Ed=i+4|0;Fd=h+4|0;Gd=i+4|0;Hd=j+4|0;Id=i+4|0;Jd=i+12|0;Kd=v+12|0;Ld=i+11|0;Md=i+4|0;Nd=h+8|0;Od=e+4|0;Pd=e+4|0;Qd=v+11|0;Rd=w+4|0;Sd=w+4|0;Td=td;Ud=h+4|0;Vd=h+4|0;Wd=h+8|0;Xd=h+4|0;Yd=h+12|0;Zd=i+4|0;_d=j+4|0;$d=I+4|0;ae=i+11|0;be=j+4|0;ce=i+4|0;de=j+4|0;ee=v+4|0;fe=j+4|0;ge=j+12|0;he=e+12|0;ie=j+11|0;je=j+4|0;ke=i+8|0;le=h+4|0;me=e+11|0;ne=J+4|0;oe=J+8|0;pe=J+4|0;qe=v+16|0;re=v+4|0;se=v+8|0;te=v+12|0;ue=e+4|0;ve=e+4|0;we=e+4|0;xe=e+11|0;ye=e+4|0;ze=e+4|0;Ae=v+36|0;Be=v+40|0;Ce=v+44|0;De=v+48|0;Ee=e+4|0;Fe=h+4|0;Ge=e+4|0;He=e+11|0;Ie=e+4|0;Je=pe;Ke=e+11|0;Le=e+5|0;Me=e+4|0;Ne=i+11|0;Oe=i+5|0;Pe=e+11|0;Qe=e+4|0;Re=e+4|0;Se=i+11|0;Te=i+4|0;Ue=e+8|0;Ve=e+4|0;We=e+11|0;Xe=e+8|0;Ye=e+4|0;Ze=e+11|0;_e=e+4|0;$e=e+11|0;af=e+4|0;bf=e+4|0;cf=i+11|0;df=i+4|0;ef=e+4|0;ff=e+4|0;gf=e+11|0;hf=K+4|0;jf=K+8|0;kf=K+4|0;lf=e+4|0;mf=e+4|0;nf=h+4|0;of=e+11|0;pf=e+4|0;qf=h+4|0;rf=i+11|0;sf=i+4|0;tf=h+4|0;uf=e+12|0;vf=kf;wf=e+4|0;xf=e+4|0;yf=e+11|0;zf=e+4|0;Af=e+4|0;Bf=e+11|0;Cf=e+4|0;Df=e+8|0;Ef=e+8|0;Ff=L+4|0;Gf=L+8|0;Hf=L+4|0;If=e+4|0;Jf=e+4|0;Kf=e+11|0;Lf=Hf;Mf=e+4|0;Nf=M+4|0;Of=M+8|0;Pf=M+4|0;Qf=N+4|0;Rf=N+8|0;Sf=N+4|0;Tf=v+152|0;Uf=w+152|0;Vf=v+160|0;Wf=w+160|0;Xf=e+11|0;Yf=e+4|0;Zf=i+4|0;_f=h+11|0;$f=h+4|0;ag=i+4|0;bg=i+4|0;cg=j+4|0;dg=i+4|0;eg=j+4|0;fg=i+4|0;gg=i+11|0;hg=i+4|0;ig=i+4|0;jg=i+4|0;kg=Sf;lg=Pf;mg=e+4|0;ng=h+4|0;og=e+11|0;pg=e+4|0;qg=O+4|0;rg=O+8|0;sg=O+4|0;tg=v+4|0;ug=v+8|0;vg=v+12|0;wg=e+4|0;xg=v+16|0;yg=e+4|0;zg=h+4|0;Ag=e+11|0;Bg=e+4|0;Cg=h+11|0;Dg=v+36|0;Eg=v+40|0;Fg=v+44|0;Gg=v+48|0;Hg=h+11|0;Ig=e+4|0;Jg=w+4|0;Kg=e+4|0;Lg=e+4|0;Mg=P+4|0;Ng=P+8|0;Og=P+4|0;Pg=t+16|0;Qg=Og;Rg=e+4|0;Sg=sg;Tg=e+4|0;Ug=e+4|0;Vg=e+4|0;Wg=e+4|0;Xg=h+4|0;Yg=e+11|0;Zg=e+4|0;_g=h+4|0;$g=i+11|0;ah=i+4|0;bh=h+4|0;ch=e+12|0;dh=Q+4|0;eh=Q+8|0;fh=Q+4|0;gh=v+4|0;hh=v+8|0;ih=v+12|0;jh=v+16|0;kh=v+44|0;lh=e+4|0;mh=h+4|0;nh=e+4|0;oh=e+11|0;ph=v+36|0;qh=v+40|0;rh=v+48|0;sh=e+4|0;uh=fh;vh=R+4|0;wh=R+8|0;xh=R+4|0;yh=S+4|0;zh=S+8|0;Ah=S+4|0;Bh=T+4|0;Ch=T+8|0;Dh=T+4|0;Eh=U+4|0;Fh=U+8|0;Gh=U+4|0;Hh=e+11|0;Ih=e+7|0;Jh=e+4|0;Kh=i+11|0;Lh=i+7|0;Mh=e+4|0;Nh=e+4|0;Oh=e+4|0;Ph=e+11|0;Qh=Gh;Rh=Dh;Sh=Ah;Th=xh;Vh=e+4|0;Wh=e+4|0;Xh=e+4|0;Yh=v+4|0;Zh=e+4|0;_h=V+4|0;$h=V+8|0;ai=V+4|0;bi=ai;ci=W+4|0;ei=W+8|0;fi=W+4|0;gi=e+4|0;hi=e+4|0;ii=e+4|0;ji=e+4|0;ki=e+11|0;li=fi;mi=e+4|0;ni=e+8|0;oi=e+4|0;pi=e+11|0;qi=e+4|0;ri=i+8|0;si=i+4|0;ti=i+11|0;ui=e+8|0;vi=e+4|0;wi=e+11|0;xi=h+11|0;yi=h+9|0;zi=h+4|0;Ai=h+4|0;Bi=v+4|0;Ci=v+8|0;Di=v+40|0;Ei=v+48|0;Fi=v+44|0;Gi=v+52|0;Hi=w+4|0;Ii=w+8|0;Ji=w+40|0;Ki=w+48|0;Li=w+44|0;Mi=w+52|0;Ni=y+4|0;Oi=y+8|0;Pi=y+40|0;Qi=y+48|0;Ri=y+44|0;Si=y+52|0;Ti=X+4|0;Ui=X+8|0;Vi=X+40|0;Xi=X+48|0;Yi=X+44|0;Zi=X+52|0;_i=Z+4|0;$i=Z+8|0;aj=Z+4|0;bj=_+4|0;cj=_+8|0;dj=_+4|0;ej=v+12|0;fj=v+16|0;gj=e+4|0;hj=h+4|0;ij=$+36|0;jj=$+16|0;kj=$+4|0;lj=$+40|0;mj=$+44|0;nj=$+48|0;oj=e+4|0;pj=h+4|0;qj=aa+36|0;rj=aa+16|0;sj=aa+4|0;tj=aa+40|0;uj=aa+44|0;vj=aa+48|0;wj=e+8|0;xj=e+4|0;yj=e+11|0;zj=e+8|0;Aj=e+4|0;Bj=e+11|0;Cj=e+4|0;Dj=ba+4|0;Ej=ba+8|0;Fj=ba+40|0;Gj=ba+48|0;Hj=ba+44|0;Ij=ba+52|0;Jj=ca+4|0;Kj=ca+8|0;Lj=ca+4|0;Mj=ba+12|0;Nj=e+36|0;Oj=ba+36|0;Pj=ba+16|0;Qj=e+4|0;Rj=e+8|0;Sj=e+12|0;Tj=e+44|0;Uj=e+16|0;Vj=e+20|0;Wj=ba+20|0;Xj=e+24|0;Yj=ba+24|0;Zj=e+28|0;_j=ba+28|0;$j=e+32|0;ak=ba+32|0;bk=e+40|0;ck=e+48|0;dk=e+36|0;ek=e+4|0;fk=e+8|0;gk=e+12|0;hk=e+44|0;ik=e+16|0;jk=e+20|0;kk=e+24|0;lk=e+28|0;mk=e+32|0;nk=e+40|0;ok=e+48|0;pk=Lj;qk=e+4|0;rk=e+11|0;sk=X+36|0;tk=X+16|0;uk=y+36|0;vk=y+16|0;wk=w+36|0;xk=w+16|0;yk=v+36|0;zk=X+12|0;Ak=X+20|0;Bk=X+24|0;Ck=X+28|0;Dk=X+32|0;Ek=y+12|0;Fk=y+20|0;Gk=y+24|0;Hk=y+28|0;Ik=y+32|0;Jk=w+12|0;Kk=w+20|0;Lk=w+24|0;Mk=w+28|0;Nk=w+32|0;Ok=dj;Pk=aj;Qk=e+4|0;Rk=da+4|0;Sk=da+8|0;Tk=da+4|0;Uk=v+4|0;Vk=v+8|0;Wk=v+12|0;Xk=e+4|0;Yk=v+16|0;Zk=v+44|0;_k=e+4|0;$k=e+8|0;al=e+4|0;bl=e+11|0;cl=e+4|0;dl=i+8|0;el=i+4|0;fl=i+11|0;gl=e+4|0;hl=e+11|0;il=v+36|0;jl=v+40|0;kl=v+48|0;ll=e+4|0;ml=e+4|0;nl=Tk;ol=e+11|0;pl=e+8|0;ql=e+4|0;rl=i+11|0;sl=i+8|0;tl=e+11|0;ul=e+8|0;vl=e+4|0;wl=i+11|0;xl=i+8|0;yl=e+11|0;zl=e+4|0;Al=e+4|0;Bl=i+11|0;Cl=i+4|0;Dl=e+11|0;El=e+4|0;Fl=e+4|0;Gl=i+11|0;Hl=i+4|0;Il=e+11|0;Jl=e+6|0;Kl=e+4|0;Ll=i+11|0;Ml=i+6|0;Nl=e+11|0;Ol=e+8|0;Pl=h+11|0;Ql=h+8|0;Rl=h+4|0;Sl=e+16|0;Tl=e+4|0;Ul=e+8|0;Vl=e+12|0;Wl=i+4|0;Xl=e+36|0;Yl=e+40|0;Zl=e+44|0;_l=e+48|0;$l=e+8|0;am=e+4|0;bm=e+11|0;cm=h+8|0;dm=h+4|0;em=h+11|0;fm=h+4|0;gm=e+16|0;hm=e+4|0;im=e+8|0;jm=e+12|0;km=i+4|0;lm=e+36|0;mm=e+40|0;nm=e+44|0;om=e+48|0;pm=e+11|0;qm=e+6|0;rm=h+11|0;sm=h+6|0;tm=h+4|0;um=e+16|0;vm=e+4|0;wm=e+8|0;xm=e+12|0;ym=i+4|0;zm=e+36|0;Am=e+40|0;Bm=e+44|0;Cm=e+48|0;Dm=e+4|0;Em=e+11|0;Fm=e+11|0;Gm=e+8|0;Hm=e+4|0;Im=e+11|0;Jm=e+4|0;Km=i+8|0;Lm=i+4|0;Mm=i+11|0;Nm=e+8|0;Om=e+4|0;Pm=e+11|0;Qm=e+4|0;Rm=i+8|0;Sm=i+4|0;Tm=i+11|0;Um=e+8|0;Vm=e+4|0;Wm=e+11|0;Xm=e+4|0;Ym=i+8|0;Zm=i+4|0;_m=i+11|0;$m=e+8|0;an=e+4|0;bn=e+11|0;cn=e+4|0;dn=i+8|0;en=i+4|0;fn=i+11|0;gn=e+11|0;hn=e+5|0;jn=e+4|0;kn=i+11|0;ln=i+5|0;mn=e+11|0;nn=e+9|0;on=e+4|0;pn=h+11|0;qn=h+9|0;rn=e+11|0;sn=e+10|0;tn=e+4|0;un=i+11|0;vn=i+10|0;wn=e+8|0;xn=e+4|0;yn=e+11|0;zn=e+4|0;An=i+8|0;Bn=i+4|0;Cn=i+11|0;Dn=e+8|0;En=e+4|0;Fn=e+11|0;Gn=e+4|0;Hn=i+8|0;In=i+4|0;Jn=i+11|0;Kn=e+4|0;Ln=e+11|0;Mn=e+11|0;Nn=h+4|0;On=e+4|0;Pn=h+11|0;Qn=e+8|0;Rn=h+8|0;Sn=h+12|0;Tn=i+4|0;Un=i+8|0;Vn=i+12|0;Wn=i+16|0;Xn=i+20|0;Yn=i+4|0;Zn=i+20|0;_n=e+4|0;$n=h+12|0;ao=e+8|0;bo=i+8|0;co=0;a:while(1){pEa(q,f[(f[ta>>2]|0)+4+(co<<2)>>2]|0);eo=f[ua>>2]|0;f[r>>2]=0;f[va>>2]=0;fo=eo+11|0;go=b[fo>>0]|0;ho=go<<24>>24<0?f[eo+4>>2]|0:go&255;if(ho|0){go=aD(r,ho)|0;Vac(go|0,((b[fo>>0]|0)<0?f[eo>>2]|0:eo)|0,ho|0)|0}ho=f[wa>>2]|0;f[s>>2]=0;f[xa>>2]=0;eo=ho+11|0;fo=b[eo>>0]|0;go=fo<<24>>24<0?f[ho+4>>2]|0:fo&255;if(go|0){fo=aD(s,go)|0;Vac(fo|0,((b[eo>>0]|0)<0?f[ho>>2]|0:ho)|0,go|0)|0}f[ya>>2]=0;f[za>>2]=0;f[t>>2]=Aa;f[Ba>>2]=0;f[Ba+4>>2]=0;f[Ba+8>>2]=0;f[Ba+12>>2]=0;f[Ba+16>>2]=0;f[Ba+20>>2]=0;f[Ba+24>>2]=0;go=f[ha>>2]|0;if(go){ho=f[r>>2]|0;eo=(ho|0)==0?1124530:ho;fo=ha;io=go;b:while(1){go=io;while(1){jo=f[go+16>>2]|0;if((jo|0)==(ho|0))break;if((gTb((jo|0)==0?1124530:jo,eo)|0)>=0)break;jo=f[go+4>>2]|0;if(!jo){ko=fo;break b}else go=jo}io=f[go>>2]|0;if(!io){ko=go;break}else fo=go}if((ko|0)!=(ha|0)){fo=f[ko+16>>2]|0;if((ho|0)!=(fo|0)?(gTb(eo,(fo|0)==0?1124530:fo)|0)<=-1:0)lo=18}else lo=18}else lo=18;c:do if((lo|0)==18){lo=0;fo=f[Ca>>2]|0;d:do if((fo|0)>0){io=2;jo=0;while(1){mo=f[(f[Da>>2]|0)+4+(jo<<2)>>2]|0;f[e>>2]=0;f[Ea>>2]=0;no=mo+11|0;oo=b[no>>0]|0;po=oo<<24>>24<0?f[mo+4>>2]|0:oo&255;if(po|0){oo=aD(e,po)|0;Vac(oo|0,((b[no>>0]|0)<0?f[mo>>2]|0:mo)|0,po|0)|0}po=f[ka>>2]|0;if(po){mo=f[e>>2]|0;no=(mo|0)==0?1124530:mo;oo=ka;qo=po;e:while(1){po=qo;while(1){ro=f[po+16>>2]|0;if((ro|0)==(mo|0))break;if((gTb((ro|0)==0?1124530:ro,no)|0)>=0)break;ro=f[po+4>>2]|0;if(!ro){so=oo;break e}else po=ro}qo=f[po>>2]|0;if(!qo){so=po;break}else oo=po}if((so|0)!=(ka|0)){oo=f[so+16>>2]|0;if((mo|0)!=(oo|0)?(gTb(no,(oo|0)==0?1124530:oo)|0)<0:0)lo=31;else to=so}else lo=31}else lo=31;if((lo|0)==31){lo=0;to=ka}bD(e);if((to|0)!=(ka|0)){oo=f[to+24>>2]|0;if((oo|0)==2){uo=2;break d}if((oo|0)!=(io|0))if((io|0)==2)vo=oo;else{uo=2;break d}else vo=io}else vo=io;jo=jo+1|0;if((jo|0)>=(fo|0)){uo=vo;break}else io=vo}}else uo=2;while(0);fo=cua(l,r)|0;f[fo>>2]=uo;fo=f[s>>2]|0;if((((fo|0)!=369785?(go=(fo|0)==0?1124530:fo,!((gTb(go,369785)|0)==0|(fo|0)==369792)):0)?!((gTb(go,369792)|0)==0|(fo|0)==369807):0)?gTb(go,369807)|0:0){if(((fo|0)!=370098?!((gTb(go,370098)|0)==0|(fo|0)==370171):0)?gTb(go,370171)|0:0){if((fo|0)!=370237?gTb(go,370237)|0:0){do if((fo|0)!=410761){if(!(gTb(go,410761)|0))break;do if((fo|0)!=410769){if(!(gTb(go,410769)|0))break;do if((fo|0)!=370316){if(!(gTb(go,370316)|0))break;if((fo|0)==370428)break c;if(!(gTb(go,370428)|0))break c;do if((fo|0)!=410837){if(!(gTb(go,410837)|0))break;do if((fo|0)==411848)wo=0;else{do if(!(gTb(go,411848)|0))xo=go;else{if((fo|0)==370447){xo=370447;break}if(!(gTb(go,370447)|0)){xo=go;break}do if((fo|0)!=370456){if(!(gTb(go,370456)|0))break;do if((fo|0)!=370464){if(!(gTb(go,370464)|0))break;do if((fo|0)!=370472){if(!(gTb(go,370472)|0))break;do if((fo|0)!=410755){if(!(gTb(go,410755)|0))break;do if((fo|0)!=410749){if(!(gTb(go,410749)|0))break;do if((fo|0)!=370638){if(!(gTb(go,370638)|0))break;do if((fo|0)!=370703){if(!(gTb(go,370703)|0))break;do if((fo|0)!=370768){if(!(gTb(go,370768)|0))break;do if((fo|0)!=370826){if(!(gTb(go,370826)|0))break;do if((fo|0)!=370893){if(!(gTb(go,370893)|0))break;do if((fo|0)!=410777){if(!(gTb(go,410777)|0))break;do if((fo|0)!=371017){if(!(gTb(go,371017)|0))break;do if((fo|0)!=431508){if(!(gTb(go,431508)|0))break;do if((fo|0)!=371026){if((gTb(go,371026)|0)==0|(fo|0)==373776)break;if((gTb(go,373776)|0)==0|(fo|0)==410892)break;if((gTb(go,410892)|0)==0|(fo|0)==371030)break;if((gTb(go,371030)|0)==0|(fo|0)==371035)break;if((gTb(go,371035)|0)==0|(fo|0)==410854)break;if((gTb(go,410854)|0)==0|(fo|0)==374081)break;if((gTb(go,374081)|0)==0|(fo|0)==371039)break;if(!(gTb(go,371039)|0))break;TXb(e,854628+(f[(f[213657]|0)+-12>>2]|0)|0);io=xZb(e,855500)|0;jo=Uh[f[(f[io>>2]|0)+28>>2]&1023](io,10)|0;yZb(e);mYb(854628,jo)|0;ZXb(854628)|0;jo=f[ua>>2]|0;io=b[jo+11>>0]|0;oo=io<<24>>24<0;qo=rP(rP(854628,oo?f[jo>>2]|0:jo,oo?f[jo+4>>2]|0:io&255)|0,476117,1)|0;io=f[wa>>2]|0;jo=b[io+11>>0]|0;oo=jo<<24>>24<0;rP(qo,oo?f[io>>2]|0:io,oo?f[io+4>>2]|0:jo&255)|0;if((f[Ca>>2]|0)>0){jo=0;do{io=rP(854628,489103,1)|0;oo=f[(f[Da>>2]|0)+4+(jo<<2)>>2]|0;qo=b[oo+11>>0]|0;ro=qo<<24>>24<0;rP(rP(io,ro?f[oo>>2]|0:oo,ro?f[oo+4>>2]|0:qo&255)|0,489101,1)|0;jo=jo+1|0}while((jo|0)<(f[Ca>>2]|0))}TXb(e,854628+(f[(f[213657]|0)+-12>>2]|0)|0);jo=xZb(e,855500)|0;qo=Uh[f[(f[jo>>2]|0)+28>>2]&1023](jo,10)|0;yZb(e);mYb(854628,qo)|0;ZXb(854628)|0;tKb(_b);sxa(h,f[$b>>2]|0);qo=b[Rn>>0]|0;if(!(qo<<24>>24)){jo=f[Sn>>2]|0;oo=f[jo+12>>2]|0;ro=f[jo+4>>2]|0;f:do if(ro>>>0>oo>>>0){io=f[jo+16>>2]|0;yo=oo;while(1){zo=f[io+(yo<<2)>>2]|0;if(zo|0)break;Ao=yo+1|0;if(Ao>>>0<ro>>>0)yo=Ao;else{Bo=0;Co=Ao;Do=0;break f}}if((zo|0)==(f[io+((yo^1)<<2)>>2]|0)){Ao=f[zo>>2]|0;Bo=f[Ao+16>>2]|0;Co=yo;Do=Ao;break}else{Bo=zo;Co=yo;Do=0;break}}else{Bo=0;Co=oo;Do=0}while(0);f[Tn>>2]=Bo;f[Un>>2]=jo;f[Vn>>2]=Co;f[Wn>>2]=Do;f[Xn>>2]=0;Eo=2}else{oo=f[(f[$n>>2]|0)+12>>2]|0;f[Yn>>2]=0;f[Zn>>2]=oo;Eo=1}f[i>>2]=Eo;oo=Eo;ro=qo;g:while(1){h:do if((oo|0)==((ro<<24>>24==0?2:1)|0))switch(oo|0){case 0:{break g;break}case 1:{if(!(f[Xn>>2]|0))break g;else break h;break}default:if(!(f[Yn>>2]|0))break g;else break h}while(0);yo=f[((oo|0)==1?(f[Zn>>2]|0)+20|0:(f[Yn>>2]|0)+12|0)>>2]|0;io=b[yo+11>>0]|0;Ao=io<<24>>24<0;rP(rP(854628,Ao?f[yo>>2]|0:yo,Ao?f[yo+4>>2]|0:io&255)|0,476117,1)|0;io=f[i>>2]|0;yo=f[Yn>>2]|0;Ao=f[Zn>>2]|0;Fo=f[((io|0)==1?Ao+20|0:yo+12|0)>>2]|0;Go=b[Fo+11>>0]|0;do if(((Go<<24>>24<0?f[Fo+4>>2]|0:Go&255)|0)==5){if(!(u6b(Fo,0,-1,371045,5)|0)){lo=1590;break}Ho=f[i>>2]|0;Io=f[Yn>>2]|0;Jo=f[Zn>>2]|0;lo=1587}else{Ho=io;Io=yo;Jo=Ao;lo=1587}while(0);i:do if((lo|0)==1587){lo=0;Ao=f[((Ho|0)==1?Jo+20|0:Io+12|0)>>2]|0;yo=b[Ao+11>>0]|0;if(((yo<<24>>24<0?f[Ao+4>>2]|0:yo&255)|0)==1){if(!(u6b(Ao,0,-1,371051,1)|0)){lo=1590;break}Ko=f[i>>2]|0;Lo=f[Yn>>2]|0;Mo=f[Zn>>2]|0}else{Ko=Ho;Lo=Io;Mo=Jo}Ao=f[((Ko|0)==1?Mo+20|0:Lo+12|0)>>2]|0;yo=b[Ao+11>>0]|0;do if(((yo<<24>>24<0?f[Ao+4>>2]|0:yo&255)|0)==7){io=(u6b(Ao,0,-1,441015,7)|0)==0;Fo=f[i>>2]|0;if(!io){No=Fo;Oo=f[Yn>>2]|0;Po=f[Zn>>2]|0;break}io=f[((Fo|0)==1?(f[Zn>>2]|0)+20|0:(f[Yn>>2]|0)+12|0)>>2]|0;if((f[io+36>>2]|0)==2){Fo=f[io+24>>2]|0;Qo=Fo;Ro=Fo}else{Qo=497760;Ro=497760}Fo=b[Ro+11>>0]|0;io=Fo<<24>>24<0;rP(854628,io?f[Qo>>2]|0:Qo,io?f[Qo+4>>2]|0:Fo&255)|0;break i}else{No=Ko;Oo=Lo;Po=Mo}while(0);Ao=f[((No|0)==1?Po+20|0:Oo+12|0)>>2]|0;yo=b[Ao+11>>0]|0;do if(((yo<<24>>24<0?f[Ao+4>>2]|0:yo&255)|0)==11){if(!(u6b(Ao,0,-1,371053,11)|0))break;So=f[i>>2]|0;To=f[Yn>>2]|0;Uo=f[Zn>>2]|0;lo=1602}else{So=No;To=Oo;Uo=Po;lo=1602}while(0);do if((lo|0)==1602){lo=0;Ao=f[((So|0)==1?Uo+20|0:To+12|0)>>2]|0;yo=b[Ao+11>>0]|0;if(((yo<<24>>24<0?f[Ao+4>>2]|0:yo&255)|0)==11){if(!(u6b(Ao,0,-1,371065,11)|0))break;Vo=f[i>>2]|0;Wo=f[Yn>>2]|0;Xo=f[Zn>>2]|0}else{Vo=So;Wo=To;Xo=Uo}Ao=f[((Vo|0)==1?Xo+20|0:Wo+12|0)>>2]|0;yo=b[Ao+11>>0]|0;do if(((yo<<24>>24<0?f[Ao+4>>2]|0:yo&255)|0)==7){if(!(u6b(Ao,0,-1,371077,7)|0))break;Yo=f[i>>2]|0;Zo=f[Yn>>2]|0;_o=f[Zn>>2]|0;lo=1611}else{Yo=Vo;Zo=Wo;_o=Xo;lo=1611}while(0);do if((lo|0)==1611){lo=0;Ao=f[((Yo|0)==1?_o+20|0:Zo+12|0)>>2]|0;yo=b[Ao+11>>0]|0;if(((yo<<24>>24<0?f[Ao+4>>2]|0:yo&255)|0)==5){if(!(u6b(Ao,0,-1,371085,5)|0))break;$o=f[i>>2]|0;ap=f[Yn>>2]|0;bp=f[Zn>>2]|0}else{$o=Yo;ap=Zo;bp=_o}Ao=f[(($o|0)==1?bp+20|0:ap+12|0)>>2]|0;if((f[Ao+36>>2]|0)==8)cp=f[Ao+24>>2]|0;else cp=GFa()|0;Ao=f[cp+156>>2]|0;yo=(Ao|0)==0?491784:Ao;rP(854628,371094,2)|0;Ao=yo+12|0;if((f[Ao>>2]|0)>0){Fo=yo+20|0;yo=0;do{io=f[(f[(f[Fo>>2]|0)+4+(yo<<2)>>2]|0)+8>>2]|0;Go=b[io+11>>0]|0;dp=Go<<24>>24<0;ep=rP(rP(854628,dp?f[io>>2]|0:io,dp?f[io+4>>2]|0:Go&255)|0,476117,1)|0;Go=(f[(f[Fo>>2]|0)+4+(yo<<2)>>2]|0)+16|0;rP(kYb(ep,f[Go>>2]|0,f[Go+4>>2]|0)|0,489135,1)|0;yo=yo+1|0}while((yo|0)<(f[Ao>>2]|0))}rP(854628,489150,1)|0;Ao=f[cp+152>>2]|0;yo=b[Ao+11>>0]|0;Fo=yo<<24>>24<0;if(Fo)fp=f[Ao+4>>2]|0;else fp=yo&255;if(!fp)break i;switch(f[cp+160>>2]|0){case 1:{if(Fo){gp=f[Ao+4>>2]|0;hp=f[Ao>>2]|0}else{gp=yo&255;hp=Ao}Go=gp>>>2;ep=Go>>>0<10?Go:10;if((ep|0)>0){io=0;do{dp=rP(854628,489135,1)|0;lYb(dp,+n[hp+(io<<2)>>2])|0;io=io+1|0}while((io|0)<(ep|0))}if(gp>>>0<=43)break i;rP(iYb(rP(854628,371097,5)|0,Go+-10|0)|0,371103,5)|0;break i;break}case 3:{if(Fo){ip=f[Ao+4>>2]|0;jp=f[Ao>>2]|0}else{ip=yo&255;jp=Ao}ep=ip>>>2;io=ep>>>0<10?ep:10;if((io|0)>0){dp=0;do{kp=rP(854628,489135,1)|0;iYb(kp,f[jp+(dp<<2)>>2]|0)|0;dp=dp+1|0}while((dp|0)<(io|0))}if(ip>>>0<=43)break i;rP(iYb(rP(854628,371097,5)|0,ep+-10|0)|0,371103,5)|0;break i;break}default:{f[e>>2]=0;f[_n>>2]=0;lp=aD(e,28)|0;mp=371109;np=lp+28|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-2,e,371138,369853,272);bD(e);break i}}}while(0);ep=f[((f[i>>2]|0)==1?(f[Zn>>2]|0)+20|0:(f[Yn>>2]|0)+12|0)>>2]|0;if((f[ep+36>>2]|0)==1)op=f[ep+24>>2]|0;else op=fHa()|0;rP(854628,489103,1)|0;ep=op+24|0;if((f[ep>>2]|0)>0){io=op+32|0;dp=0;do{Ao=rP(854628,489135,1)|0;yo=(f[io>>2]|0)+8+(dp<<3)|0;kYb(Ao,f[yo>>2]|0,f[yo+4>>2]|0)|0;dp=dp+1|0}while((dp|0)<(f[ep>>2]|0))}rP(854628,371091,2)|0;break i}while(0);ep=f[((f[i>>2]|0)==1?(f[Zn>>2]|0)+20|0:(f[Yn>>2]|0)+12|0)>>2]|0;if((f[ep+36>>2]|0)==5)pp=(b[ep+24>>0]|0)!=0;else pp=0;hYb(854628,pp)|0}while(0);if((lo|0)==1590){lo=0;ep=f[((f[i>>2]|0)==1?(f[Zn>>2]|0)+20|0:(f[Yn>>2]|0)+12|0)>>2]|0;if((f[ep+36>>2]|0)==3){dp=ep+24|0;qp=f[dp>>2]|0;rp=f[dp+4>>2]|0}else{qp=0;rp=0}kYb(854628,qp,rp)|0}TXb(e,854628+(f[(f[213657]|0)+-12>>2]|0)|0);dp=xZb(e,855500)|0;ep=Uh[f[(f[dp>>2]|0)+28>>2]&1023](dp,10)|0;yZb(e);mYb(854628,ep)|0;ZXb(854628)|0;if((f[i>>2]|0)==1){f[Zn>>2]=f[f[Zn>>2]>>2];sp=1}else{uxa(Tn)|0;sp=f[i>>2]|0}oo=sp;ro=b[Rn>>0]|0}txa(h);ro=f[s>>2]|0;oo=f[r>>2]|0;f[g>>2]=(ro|0)==0?1124530:ro;f[g+4>>2]=(oo|0)==0?1124530:oo;hO(e,371150,g);bO(-2,e,376145,369853,1487);bD(e);break c}while(0);oo=f[xa>>2]|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;if(oo>>>0>4294967279){lo=1537;break a}if(oo>>>0<11){b[Mn>>0]=oo;if(!oo)tp=e;else{up=e;lo=1541}}else{ro=oo+16&-16;qo=L5b(ro)|0;f[e>>2]=qo;f[Qn>>2]=ro|-2147483648;f[On>>2]=oo;up=qo;lo=1541}if((lo|0)==1541){lo=0;Vac(up|0,fo|0,oo|0)|0;tp=up}b[tp+oo>>0]=0;oo=f[s>>2]|0;j:do if((oo|0)==371026)lo=1544;else{qo=(oo|0)==0?1124530:oo;if(!(gTb(qo,371026)|0)){lo=1544;break}do if((oo|0)!=373776){if(!(gTb(qo,373776)|0))break;do if((oo|0)!=371030){if(!(gTb(qo,371030)|0))break;do if((oo|0)!=371039){if(!(gTb(qo,371039)|0))break;if((oo|0)!=371035?gTb(qo,371035)|0:0)break j;d6b(e,410900)|0;break j}while(0);d6b(e,410866)|0;break j}while(0);d6b(e,380368)|0;break j}while(0);d6b(e,380323)|0}while(0);if((lo|0)==1544){lo=0;d6b(e,410904)|0}f[h>>2]=0;f[Nn>>2]=0;oo=b[Mn>>0]|0;qo=oo<<24>>24<0?f[On>>2]|0:oo&255;if(qo|0){oo=aD(h,qo)|0;Vac(oo|0,((b[Mn>>0]|0)<0?f[e>>2]|0:e)|0,qo|0)|0}qo=lva(c,r,h,t)|0;bD(h);oo=cua(o,r)|0;f[oo>>2]=qo;hxa(h,f[(f[Da>>2]|0)+4>>2]|0);oo=f[Ca>>2]|0;if((oo|0)>0){ro=0;do{ixa(o,c,h,qo,ro);ro=ro+1|0}while((ro|0)!=(oo|0))}if((b[Pn>>0]|0)<0)O5b(f[h>>2]|0);if((b[Mn>>0]|0)<0)O5b(f[e>>2]|0);break c}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;oo=L5b(16)|0;f[e>>2]=oo;f[Gm>>2]=-2147483632;f[Hm>>2]=11;lp=oo;mp=431612;np=lp+11|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[oo+11>>0]=0;ro=jxa(q,e)|0;if((b[Im>>0]|0)<0)O5b(f[e>>2]|0);if(ro){f[e>>2]=0;f[Jm>>2]=0;lp=aD(e,11)|0;mp=431612;np=lp+11|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;oo=L5b(16)|0;f[i>>2]=oo;f[Km>>2]=-2147483632;f[Lm>>2]=11;lp=oo;mp=431612;np=lp+11|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[oo+11>>0]=0;tKb(_b);ro=kxa(f[$b>>2]|0,i)|0;qo=(f[ro+20>>2]|0)==3;jo=ro+8|0;ro=qo?f[jo+4>>2]|0:0;ep=h;f[ep>>2]=qo?f[jo>>2]|0:0;f[ep+4>>2]=ro;qxa(t,e,h)|0;if((b[Mm>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;ro=L5b(16)|0;f[e>>2]=ro;f[Nm>>2]=-2147483632;f[Om>>2]=14;lp=ro;mp=431624;np=lp+14|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[ro+14>>0]=0;oo=jxa(q,e)|0;if((b[Pm>>0]|0)<0)O5b(f[e>>2]|0);if(oo){f[e>>2]=0;f[Qm>>2]=0;lp=aD(e,14)|0;mp=431624;np=lp+14|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;ro=L5b(16)|0;f[i>>2]=ro;f[Rm>>2]=-2147483632;f[Sm>>2]=14;lp=ro;mp=431624;np=lp+14|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[ro+14>>0]=0;tKb(_b);oo=kxa(f[$b>>2]|0,i)|0;b[h>>0]=(b[oo+8>>0]|0?(f[oo+20>>2]|0)==5:0)&1;$wa(t,e,h)|0;if((b[Tm>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;oo=L5b(32)|0;f[e>>2]=oo;f[Um>>2]=-2147483616;f[Vm>>2]=19;lp=oo;mp=431639;np=lp+19|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[oo+19>>0]=0;ro=jxa(q,e)|0;if((b[Wm>>0]|0)<0)O5b(f[e>>2]|0);if(ro){f[e>>2]=0;f[Xm>>2]=0;lp=aD(e,19)|0;mp=431639;np=lp+19|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;oo=L5b(32)|0;f[i>>2]=oo;f[Ym>>2]=-2147483616;f[Zm>>2]=19;lp=oo;mp=431639;np=lp+19|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[oo+19>>0]=0;tKb(_b);ro=kxa(f[$b>>2]|0,i)|0;ep=(f[ro+20>>2]|0)==3;jo=ro+8|0;ro=ep?f[jo+4>>2]|0:0;qo=h;f[qo>>2]=ep?f[jo>>2]|0:0;f[qo+4>>2]=ro;qxa(t,e,h)|0;if((b[_m>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;ro=L5b(16)|0;f[e>>2]=ro;f[$m>>2]=-2147483632;f[an>>2]=13;lp=ro;mp=431760;np=lp+13|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[ro+13>>0]=0;oo=jxa(q,e)|0;if((b[bn>>0]|0)<0)O5b(f[e>>2]|0);if(oo){f[e>>2]=0;f[cn>>2]=0;lp=aD(e,13)|0;mp=431760;np=lp+13|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;ro=L5b(16)|0;f[i>>2]=ro;f[dn>>2]=-2147483632;f[en>>2]=13;lp=ro;mp=431760;np=lp+13|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[ro+13>>0]=0;tKb(_b);oo=kxa(f[$b>>2]|0,i)|0;n[h>>2]=(f[oo+20>>2]|0)==4?+n[oo+8>>2]:0.0;Zwa(t,e,h)|0;if((b[fn>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[gn>>0]=5;b[e>>0]=b[431718]|0;b[e+1>>0]=b[431719]|0;b[e+2>>0]=b[431720]|0;b[e+3>>0]=b[431721]|0;b[e+4>>0]=b[431722]|0;b[hn>>0]=0;oo=jxa(q,e)|0;if((b[gn>>0]|0)<0)O5b(f[e>>2]|0);if(oo){f[e>>2]=0;f[jn>>2]=0;oo=aD(e,5)|0;b[oo>>0]=b[431718]|0;b[oo+1>>0]=b[431719]|0;b[oo+2>>0]=b[431720]|0;b[oo+3>>0]=b[431721]|0;b[oo+4>>0]=b[431722]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[kn>>0]=5;b[i>>0]=b[431718]|0;b[i+1>>0]=b[431719]|0;b[i+2>>0]=b[431720]|0;b[i+3>>0]=b[431721]|0;b[i+4>>0]=b[431722]|0;b[ln>>0]=0;tKb(_b);oo=kxa(f[$b>>2]|0,i)|0;qo=(f[oo+20>>2]|0)==3;jo=oo+8|0;oo=qo?f[jo+4>>2]|0:0;ep=h;f[ep>>2]=qo?f[jo>>2]|0:0;f[ep+4>>2]=oo;qxa(t,e,h)|0;if((b[kn>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[mn>>0]=9;lp=e;mp=431908;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[nn>>0]=0;ro=jxa(q,e)|0;if((b[mn>>0]|0)<0)O5b(f[e>>2]|0);if(ro){f[e>>2]=0;f[on>>2]=0;lp=aD(e,9)|0;mp=431908;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[pn>>0]=9;lp=h;mp=431908;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[qn>>0]=0;tKb(_b);ro=kxa(f[$b>>2]|0,h)|0;rxa(t,e,(f[ro+20>>2]|0)==2?f[ro+8>>2]|0:497760)|0;if((b[pn>>0]|0)<0)O5b(f[h>>2]|0);bD(e)}b[rn>>0]=10;lp=e;mp=431686;np=lp+10|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[sn>>0]=0;ro=jxa(q,e)|0;if((b[rn>>0]|0)<0)O5b(f[e>>2]|0);if(ro){f[e>>2]=0;f[tn>>2]=0;lp=aD(e,10)|0;mp=431686;np=lp+10|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[un>>0]=10;lp=i;mp=431686;np=lp+10|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[vn>>0]=0;tKb(_b);ro=kxa(f[$b>>2]|0,i)|0;oo=(f[ro+20>>2]|0)==3;ep=ro+8|0;ro=oo?f[ep+4>>2]|0:0;jo=h;f[jo>>2]=oo?f[ep>>2]|0:0;f[jo+4>>2]=ro;qxa(t,e,h)|0;if((b[un>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;ro=L5b(32)|0;f[e>>2]=ro;f[wn>>2]=-2147483616;f[xn>>2]=20;lp=ro;mp=431697;np=lp+20|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[ro+20>>0]=0;jo=jxa(q,e)|0;if((b[yn>>0]|0)<0)O5b(f[e>>2]|0);if(jo){f[e>>2]=0;f[zn>>2]=0;lp=aD(e,20)|0;mp=431697;np=lp+20|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;ro=L5b(32)|0;f[i>>2]=ro;f[An>>2]=-2147483616;f[Bn>>2]=20;lp=ro;mp=431697;np=lp+20|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[ro+20>>0]=0;tKb(_b);jo=kxa(f[$b>>2]|0,i)|0;n[h>>2]=(f[jo+20>>2]|0)==4?+n[jo+8>>2]:0.0;Zwa(t,e,h)|0;if((b[Cn>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;jo=L5b(32)|0;f[e>>2]=jo;f[Dn>>2]=-2147483616;f[En>>2]=19;lp=jo;mp=431724;np=lp+19|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[jo+19>>0]=0;ro=jxa(q,e)|0;if((b[Fn>>0]|0)<0)O5b(f[e>>2]|0);if(ro){f[e>>2]=0;f[Gn>>2]=0;lp=aD(e,19)|0;mp=431724;np=lp+19|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;jo=L5b(32)|0;f[i>>2]=jo;f[Hn>>2]=-2147483616;f[In>>2]=19;lp=jo;mp=431724;np=lp+19|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[jo+19>>0]=0;tKb(_b);ro=kxa(f[$b>>2]|0,i)|0;b[h>>0]=(b[ro+8>>0]|0?(f[ro+20>>2]|0)==5:0)&1;$wa(t,e,h)|0;if((b[Jn>>0]|0)<0)O5b(f[i>>2]|0);bD(e)}f[e>>2]=0;f[Kn>>2]=0;lp=aD(e,15)|0;mp=431508;np=lp+15|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));jo=lva(c,r,e,t)|0;bD(e);ro=cua(o,r)|0;f[ro>>2]=jo;hxa(e,f[(f[Da>>2]|0)+4>>2]|0);ixa(o,c,e,jo,0);if((b[Ln>>0]|0)<0)O5b(f[e>>2]|0);hxa(e,f[(f[Da>>2]|0)+8>>2]|0);ixa(o,c,e,jo,1);if((b[Ln>>0]|0)<0)O5b(f[e>>2]|0);hxa(e,f[(f[Da>>2]|0)+12>>2]|0);ixa(o,c,e,jo,2);if((b[Ln>>0]|0)<0)O5b(f[e>>2]|0);jo=cua(l,r)|0;f[jo>>2]=2;break c}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[ol>>0]=8;jo=e;f[jo>>2]=1601071469;f[jo+4>>2]=1702521203;b[pl>>0]=0;jo=jxa(q,e)|0;if((b[ol>>0]|0)<0)O5b(f[e>>2]|0);if(jo){f[e>>2]=0;f[ql>>2]=0;jo=aD(e,8)|0;ro=jo;b[ro>>0]=109;b[ro+1>>0]=105;b[ro+2>>0]=110;b[ro+3>>0]=95;ro=jo+4|0;b[ro>>0]=115;b[ro+1>>0]=105;b[ro+2>>0]=122;b[ro+3>>0]=101;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[rl>>0]=8;ro=i;f[ro>>2]=1601071469;f[ro+4>>2]=1702521203;b[sl>>0]=0;tKb(_b);ro=kxa(f[$b>>2]|0,i)|0;jo=(f[ro+20>>2]|0)==3;ep=ro+8|0;ro=jo?f[ep+4>>2]|0:0;oo=h;f[oo>>2]=jo?f[ep>>2]|0:0;f[oo+4>>2]=ro;qxa(t,e,h)|0;if((b[rl>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[tl>>0]=8;ro=e;f[ro>>2]=1601724781;f[ro+4>>2]=1702521203;b[ul>>0]=0;ro=jxa(q,e)|0;if((b[tl>>0]|0)<0)O5b(f[e>>2]|0);if(ro){f[e>>2]=0;f[vl>>2]=0;ro=aD(e,8)|0;oo=ro;b[oo>>0]=109;b[oo+1>>0]=97;b[oo+2>>0]=120;b[oo+3>>0]=95;oo=ro+4|0;b[oo>>0]=115;b[oo+1>>0]=105;b[oo+2>>0]=122;b[oo+3>>0]=101;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[wl>>0]=8;oo=i;f[oo>>2]=1601724781;f[oo+4>>2]=1702521203;b[xl>>0]=0;tKb(_b);oo=kxa(f[$b>>2]|0,i)|0;ro=(f[oo+20>>2]|0)==3;ep=oo+8|0;oo=ro?f[ep+4>>2]|0:0;jo=h;f[jo>>2]=ro?f[ep>>2]|0:0;f[jo+4>>2]=oo;qxa(t,e,h)|0;if((b[wl>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[yl>>0]=4;f[e>>2]=1885957222;b[zl>>0]=0;oo=jxa(q,e)|0;if((b[yl>>0]|0)<0)O5b(f[e>>2]|0);if(oo){f[e>>2]=0;f[Al>>2]=0;oo=aD(e,4)|0;b[oo>>0]=102;b[oo+1>>0]=108;b[oo+2>>0]=105;b[oo+3>>0]=112;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[Bl>>0]=4;f[i>>2]=1885957222;b[Cl>>0]=0;tKb(_b);oo=kxa(f[$b>>2]|0,i)|0;b[h>>0]=(b[oo+8>>0]|0?(f[oo+20>>2]|0)==5:0)&1;$wa(t,e,h)|0;if((b[Bl>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Dl>>0]=4;f[e>>2]=1885957219;b[El>>0]=0;oo=jxa(q,e)|0;if((b[Dl>>0]|0)<0)O5b(f[e>>2]|0);if(oo){f[e>>2]=0;f[Fl>>2]=0;oo=aD(e,4)|0;b[oo>>0]=99;b[oo+1>>0]=108;b[oo+2>>0]=105;b[oo+3>>0]=112;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[Gl>>0]=4;f[i>>2]=1885957219;b[Hl>>0]=0;tKb(_b);oo=kxa(f[$b>>2]|0,i)|0;b[h>>0]=(b[oo+8>>0]|0?(f[oo+20>>2]|0)==5:0)&1;$wa(t,e,h)|0;if((b[Gl>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Il>>0]=6;b[e>>0]=b[425782]|0;b[e+1>>0]=b[425783]|0;b[e+2>>0]=b[425784]|0;b[e+3>>0]=b[425785]|0;b[e+4>>0]=b[425786]|0;b[e+5>>0]=b[425787]|0;b[Jl>>0]=0;oo=jxa(q,e)|0;if((b[Il>>0]|0)<0)O5b(f[e>>2]|0);if(oo){f[e>>2]=0;f[Kl>>2]=0;oo=aD(e,6)|0;b[oo>>0]=b[425782]|0;b[oo+1>>0]=b[425783]|0;b[oo+2>>0]=b[425784]|0;b[oo+3>>0]=b[425785]|0;b[oo+4>>0]=b[425786]|0;b[oo+5>>0]=b[425787]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[Ll>>0]=6;b[i>>0]=b[425782]|0;b[i+1>>0]=b[425783]|0;b[i+2>>0]=b[425784]|0;b[i+3>>0]=b[425785]|0;b[i+4>>0]=b[425786]|0;b[i+5>>0]=b[425787]|0;b[Ml>>0]=0;tKb(_b);oo=kxa(f[$b>>2]|0,i)|0;n[h>>2]=(f[oo+20>>2]|0)==4?+n[oo+8>>2]:0.0;Zwa(t,e,h)|0;if((b[Ll>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Nl>>0]=8;oo=e;f[oo>>2]=1769103734;f[oo+4>>2]=1701015137;b[Ol>>0]=0;oo=jxa(q,e)|0;if((b[Nl>>0]|0)<0)O5b(f[e>>2]|0);if(oo){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[Pl>>0]=8;oo=h;f[oo>>2]=1769103734;f[oo+4>>2]=1701015137;b[Ql>>0]=0;tKb(_b);oo=kxa(f[$b>>2]|0,h)|0;if((f[oo+20>>2]|0)==8)vp=f[oo+8>>2]|0;else vp=GFa()|0;Ywa(e,vp);if((b[Pl>>0]|0)<0)O5b(f[h>>2]|0);f[h>>2]=0;f[Rl>>2]=0;oo=aD(h,8)|0;jo=oo;b[jo>>0]=118;b[jo+1>>0]=97;b[jo+2>>0]=114;b[jo+3>>0]=105;jo=oo+4|0;b[jo>>0]=97;b[jo+1>>0]=110;b[jo+2>>0]=99;b[jo+3>>0]=101;jo=f[Sl>>2]|0;oo=f[Tl>>2]|0;if((oo|0)<3)wp=Y(f[Vl>>2]|0,f[Ul>>2]|0)|0;else{ep=f[Yl>>2]|0;ro=0;qo=1;while(1){dp=Y(f[ep+(ro<<2)>>2]|0,qo)|0;ro=ro+1|0;if((ro|0)==(oo|0)){wp=dp;break}else qo=dp}}qo=L5b(16)|0;oo=qo+8|0;f[qo>>2]=oo;f[qo+4>>2]=wp;if(wp>>>0>1){ro=N5b(wp>>>0>536870911?-1:wp<<3)|0;f[qo>>2]=ro;xp=ro}else xp=oo;f[i>>2]=2;f[Wl>>2]=qo;if((wp|0)>0){qo=jo;oo=0;while(1){p[xp+(oo<<3)>>3]=+n[qo>>2];oo=oo+1|0;if((oo|0)==(wp|0))break;else qo=qo+4|0}}nxa(t,h,i)|0;gua(i);bD(h);qo=f[Xl>>2]|0;do if(qo|0){oo=qo+12|0;jo=f[oo>>2]|0;f[oo>>2]=jo+-1;if((jo|0)!=1)break;kL(e)}while(0);f[Xl>>2]=0;f[Sl>>2]=0;f[Sl+4>>2]=0;f[Sl+8>>2]=0;f[Sl+12>>2]=0;if((f[Tl>>2]|0)>0){qo=f[Yl>>2]|0;jo=0;do{f[qo+(jo<<2)>>2]=0;jo=jo+1|0}while((jo|0)<(f[Tl>>2]|0))}jo=f[Zl>>2]|0;if((jo|0)!=(_l|0))UC(jo)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;jo=L5b(16)|0;f[e>>2]=jo;f[$l>>2]=-2147483632;f[am>>2]=12;lp=jo;mp=425964;np=lp+12|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[jo+12>>0]=0;qo=jxa(q,e)|0;if((b[bm>>0]|0)<0)O5b(f[e>>2]|0);if(qo){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;qo=L5b(16)|0;f[h>>2]=qo;f[cm>>2]=-2147483632;f[dm>>2]=12;lp=qo;mp=425964;np=lp+12|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[qo+12>>0]=0;tKb(_b);jo=kxa(f[$b>>2]|0,h)|0;if((f[jo+20>>2]|0)==8)yp=f[jo+8>>2]|0;else yp=GFa()|0;Ywa(e,yp);if((b[em>>0]|0)<0)O5b(f[h>>2]|0);f[h>>2]=0;f[fm>>2]=0;lp=aD(h,12)|0;mp=425964;np=lp+12|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));qo=f[gm>>2]|0;jo=f[hm>>2]|0;if((jo|0)<3)zp=Y(f[jm>>2]|0,f[im>>2]|0)|0;else{oo=f[mm>>2]|0;ro=0;ep=1;while(1){dp=Y(f[oo+(ro<<2)>>2]|0,ep)|0;ro=ro+1|0;if((ro|0)==(jo|0)){zp=dp;break}else ep=dp}}ep=L5b(16)|0;jo=ep+8|0;f[ep>>2]=jo;f[ep+4>>2]=zp;if(zp>>>0>1){ro=N5b(zp>>>0>536870911?-1:zp<<3)|0;f[ep>>2]=ro;Ap=ro}else Ap=jo;f[i>>2]=2;f[km>>2]=ep;if((zp|0)>0){ep=qo;jo=0;while(1){p[Ap+(jo<<3)>>3]=+n[ep>>2];jo=jo+1|0;if((jo|0)==(zp|0))break;else ep=ep+4|0}}nxa(t,h,i)|0;gua(i);bD(h);ep=f[lm>>2]|0;do if(ep|0){jo=ep+12|0;qo=f[jo>>2]|0;f[jo>>2]=qo+-1;if((qo|0)!=1)break;kL(e)}while(0);f[lm>>2]=0;f[gm>>2]=0;f[gm+4>>2]=0;f[gm+8>>2]=0;f[gm+12>>2]=0;if((f[hm>>2]|0)>0){ep=f[mm>>2]|0;qo=0;do{f[ep+(qo<<2)>>2]=0;qo=qo+1|0}while((qo|0)<(f[hm>>2]|0))}qo=f[nm>>2]|0;if((qo|0)!=(om|0))UC(qo)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[pm>>0]=6;b[e>>0]=b[425456]|0;b[e+1>>0]=b[425457]|0;b[e+2>>0]=b[425458]|0;b[e+3>>0]=b[425459]|0;b[e+4>>0]=b[425460]|0;b[e+5>>0]=b[425461]|0;b[qm>>0]=0;qo=jxa(q,e)|0;if((b[pm>>0]|0)<0)O5b(f[e>>2]|0);if(qo){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[rm>>0]=6;b[h>>0]=b[425456]|0;b[h+1>>0]=b[425457]|0;b[h+2>>0]=b[425458]|0;b[h+3>>0]=b[425459]|0;b[h+4>>0]=b[425460]|0;b[h+5>>0]=b[425461]|0;b[sm>>0]=0;tKb(_b);qo=kxa(f[$b>>2]|0,h)|0;if((f[qo+20>>2]|0)==8)Bp=f[qo+8>>2]|0;else Bp=GFa()|0;Ywa(e,Bp);if((b[rm>>0]|0)<0)O5b(f[h>>2]|0);f[h>>2]=0;f[tm>>2]=0;qo=aD(h,6)|0;b[qo>>0]=b[425456]|0;b[qo+1>>0]=b[425457]|0;b[qo+2>>0]=b[425458]|0;b[qo+3>>0]=b[425459]|0;b[qo+4>>0]=b[425460]|0;b[qo+5>>0]=b[425461]|0;qo=f[um>>2]|0;ep=f[vm>>2]|0;if((ep|0)<3)Cp=Y(f[xm>>2]|0,f[wm>>2]|0)|0;else{jo=f[Am>>2]|0;ro=0;oo=1;while(1){dp=Y(f[jo+(ro<<2)>>2]|0,oo)|0;ro=ro+1|0;if((ro|0)==(ep|0)){Cp=dp;break}else oo=dp}}oo=L5b(16)|0;ep=oo+8|0;f[oo>>2]=ep;f[oo+4>>2]=Cp;if(Cp>>>0>1){ro=N5b(Cp>>>0>536870911?-1:Cp<<3)|0;f[oo>>2]=ro;Dp=ro}else Dp=ep;f[i>>2]=2;f[ym>>2]=oo;if((Cp|0)>0){oo=qo;ep=0;while(1){p[Dp+(ep<<3)>>3]=+n[oo>>2];ep=ep+1|0;if((ep|0)==(Cp|0))break;else oo=oo+4|0}}nxa(t,h,i)|0;gua(i);bD(h);oo=f[zm>>2]|0;do if(oo|0){ep=oo+12|0;qo=f[ep>>2]|0;f[ep>>2]=qo+-1;if((qo|0)!=1)break;kL(e)}while(0);f[zm>>2]=0;f[um>>2]=0;f[um+4>>2]=0;f[um+8>>2]=0;f[um+12>>2]=0;if((f[vm>>2]|0)>0){oo=f[Am>>2]|0;qo=0;do{f[oo+(qo<<2)>>2]=0;qo=qo+1|0}while((qo|0)<(f[vm>>2]|0))}qo=f[Bm>>2]|0;if((qo|0)!=(Cm|0))UC(qo)}f[e>>2]=0;f[Dm>>2]=0;qo=aD(e,8)|0;oo=qo;b[oo>>0]=80;b[oo+1>>0]=114;b[oo+2>>0]=105;b[oo+3>>0]=111;oo=qo+4|0;b[oo>>0]=114;b[oo+1>>0]=66;b[oo+2>>0]=111;b[oo+3>>0]=120;oo=lva(c,r,e,t)|0;bD(e);qo=cua(o,r)|0;f[qo>>2]=oo;hxa(e,f[(f[Da>>2]|0)+4>>2]|0);ixa(o,c,e,oo,0);if((b[Em>>0]|0)<0)O5b(f[e>>2]|0);hxa(e,f[(f[Da>>2]|0)+8>>2]|0);ixa(o,c,e,oo,1);if((b[Fm>>0]|0)<0)O5b(f[e>>2]|0);oo=cua(l,r)|0;f[oo>>2]=2;break c}while(0);f[Rk>>2]=0;f[Sk>>2]=0;f[da>>2]=Tk;oo=f[m>>2]|0;if((oo|0)!=(la|0)){qo=oo;while(1){oo=qo+16|0;f[j>>2]=nl;f[e>>2]=f[j>>2];ep=Twa(da,e,h,i,oo)|0;if(!(f[ep>>2]|0)){ro=L5b(28)|0;jo=f[oo>>2]|0;f[ro+16>>2]=jo;f[ro+20>>2]=f[qo+20>>2];if(jo|0){oo=jo+-4|0;f[oo>>2]=(f[oo>>2]|0)+1}f[ro+24>>2]=f[qo+24>>2];oo=f[h>>2]|0;f[ro>>2]=0;f[ro+4>>2]=0;f[ro+8>>2]=oo;f[ep>>2]=ro;oo=f[f[da>>2]>>2]|0;if(!oo)Ep=ro;else{f[da>>2]=oo;Ep=f[ep>>2]|0}mP(f[Rk>>2]|0,Ep);f[Sk>>2]=(f[Sk>>2]|0)+1}ep=f[qo+4>>2]|0;do if(!ep){oo=qo+8|0;ro=f[oo>>2]|0;if((f[ro>>2]|0)==(qo|0)){Fp=ro;break}else Gp=oo;do{oo=f[Gp>>2]|0;Gp=oo+8|0;ro=f[Gp>>2]|0}while((f[ro>>2]|0)!=(oo|0));Fp=ro}else{ro=ep;while(1){oo=f[ro>>2]|0;if(!oo)break;else ro=oo}Fp=ro}while(0);if((Fp|0)==(la|0))break;else qo=Fp}}Ywa(v,Uwa(a,q,da,1,0)|0);Wta(da,f[Tk>>2]|0);if((f[v>>2]&4095|0)!=4){f[e>>2]=0;f[ml>>2]=0;lp=aD(e,59)|0;mp=370936;np=lp+59|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,1389);bD(e)}qo=f[Uk>>2]|0;if((qo|0)<3)Hp=Y(f[Wk>>2]|0,f[Vk>>2]|0)|0;else{ep=f[jl>>2]|0;oo=0;jo=1;while(1){dp=Y(f[ep+(oo<<2)>>2]|0,jo)|0;oo=oo+1|0;if((oo|0)==(qo|0)){Hp=dp;break}else jo=dp}}if((Hp|0)!=2){f[e>>2]=0;f[ll>>2]=0;lp=aD(e,20)|0;mp=370996;np=lp+20|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,1389);bD(e)}f[e>>2]=0;f[Xk>>2]=0;jo=aD(e,6)|0;b[jo>>0]=b[434884]|0;b[jo+1>>0]=b[434885]|0;b[jo+2>>0]=b[434886]|0;b[jo+3>>0]=b[434887]|0;b[jo+4>>0]=b[434888]|0;b[jo+5>>0]=b[434889]|0;Wwa(t,e,f[Yk>>2]|0)|0;bD(e);f[e>>2]=0;f[_k>>2]=0;jo=aD(e,5)|0;b[jo>>0]=b[434730]|0;b[jo+1>>0]=b[434731]|0;b[jo+2>>0]=b[434732]|0;b[jo+3>>0]=b[434733]|0;b[jo+4>>0]=b[434734]|0;Wwa(t,e,(f[Yk>>2]|0)+4|0)|0;bD(e);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;jo=L5b(16)|0;f[e>>2]=jo;f[$k>>2]=-2147483632;f[al>>2]=13;lp=jo;mp=434912;np=lp+13|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[jo+13>>0]=0;qo=jxa(q,e)|0;if((b[bl>>0]|0)<0)O5b(f[e>>2]|0);if(qo){f[e>>2]=0;f[cl>>2]=0;lp=aD(e,13)|0;mp=434912;np=lp+13|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;jo=L5b(16)|0;f[i>>2]=jo;f[dl>>2]=-2147483632;f[el>>2]=13;lp=jo;mp=434912;np=lp+13|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[jo+13>>0]=0;tKb(_b);qo=kxa(f[$b>>2]|0,i)|0;b[h>>0]=(b[qo+8>>0]|0?(f[qo+20>>2]|0)==5:0)&1;$wa(t,e,h)|0;if((b[fl>>0]|0)<0)O5b(f[i>>2]|0);bD(e)}f[e>>2]=0;f[gl>>2]=0;lp=aD(e,21)|0;mp=410777;np=lp+21|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));jo=lva(c,r,e,t)|0;bD(e);qo=cua(o,r)|0;f[qo>>2]=jo;hxa(e,f[(f[Da>>2]|0)+4>>2]|0);ixa(o,c,e,jo,0);if((b[hl>>0]|0)<0)O5b(f[e>>2]|0);jo=f[il>>2]|0;do if(jo|0){qo=jo+12|0;oo=f[qo>>2]|0;f[qo>>2]=oo+-1;if((oo|0)!=1)break;kL(v)}while(0);f[il>>2]=0;f[Yk>>2]=0;f[Yk+4>>2]=0;f[Yk+8>>2]=0;f[Yk+12>>2]=0;if((f[Uk>>2]|0)>0){jo=f[jl>>2]|0;oo=0;do{f[jo+(oo<<2)>>2]=0;oo=oo+1|0}while((oo|0)<(f[Uk>>2]|0))}oo=f[Zk>>2]|0;if((oo|0)!=(kl|0))UC(oo);break c}while(0);if((f[Ca>>2]|0)!=9){f[e>>2]=0;f[Qk>>2]=0;lp=aD(e,32)|0;mp=370903;np=lp+32|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-213,e,376145,369853,1322);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;oo=L5b(16)|0;f[e>>2]=oo;f[ni>>2]=-2147483632;f[oi>>2]=11;lp=oo;mp=423416;np=lp+11|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[oo+11>>0]=0;jo=jxa(q,e)|0;if((b[pi>>0]|0)<0)O5b(f[e>>2]|0);if(jo){f[e>>2]=0;f[qi>>2]=0;lp=aD(e,11)|0;mp=423416;np=lp+11|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;oo=L5b(16)|0;f[i>>2]=oo;f[ri>>2]=-2147483632;f[si>>2]=11;lp=oo;mp=423416;np=lp+11|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[oo+11>>0]=0;tKb(_b);jo=kxa(f[$b>>2]|0,i)|0;n[h>>2]=(f[jo+20>>2]|0)==4?+n[jo+8>>2]:0.0;Zwa(t,e,h)|0;if((b[ti>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;jo=L5b(16)|0;f[e>>2]=jo;f[ui>>2]=-2147483632;f[vi>>2]=11;lp=jo;mp=423416;np=lp+11|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[jo+11>>0]=0;oo=jxa(q,e)|0;if((b[wi>>0]|0)<0)O5b(f[e>>2]|0);if(oo){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;b[xi>>0]=9;lp=h;mp=423428;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[yi>>0]=0;tKb(_b);jo=kxa(f[$b>>2]|0,h)|0;Ip=(f[jo+20>>2]|0)==4?+n[jo+8>>2]:0.0;if((b[xi>>0]|0)<0)O5b(f[h>>2]|0);n[e>>2]=Ip;if(Ip>=0.0){f[h>>2]=0;f[zi>>2]=0;lp=aD(h,13)|0;mp=423438;np=lp+13|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[i>>0]=1;$wa(t,h,i)|0;bD(h);f[h>>2]=0;f[Ai>>2]=0;lp=aD(h,9)|0;mp=423428;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));Zwa(t,h,e)|0;bD(h)}}f[v>>2]=1124007936;lp=Bi;np=lp+36|0;do{f[lp>>2]=0;lp=lp+4|0}while((lp|0)<(np|0));f[Di>>2]=Ci;f[Fi>>2]=Ei;f[Ei>>2]=0;f[Gi>>2]=0;f[w>>2]=1124007936;lp=Hi;np=lp+36|0;do{f[lp>>2]=0;lp=lp+4|0}while((lp|0)<(np|0));f[Ji>>2]=Ii;f[Li>>2]=Ki;f[Ki>>2]=0;f[Mi>>2]=0;f[y>>2]=1124007936;lp=Ni;np=lp+36|0;do{f[lp>>2]=0;lp=lp+4|0}while((lp|0)<(np|0));f[Pi>>2]=Oi;f[Ri>>2]=Qi;f[Qi>>2]=0;f[Si>>2]=0;f[X>>2]=1124007936;lp=Ti;np=lp+36|0;do{f[lp>>2]=0;lp=lp+4|0}while((lp|0)<(np|0));f[Vi>>2]=Ui;f[Yi>>2]=Xi;f[Xi>>2]=0;f[Zi>>2]=0;f[_i>>2]=0;f[$i>>2]=0;f[Z>>2]=aj;jo=f[m>>2]|0;if((jo|0)!=(la|0)){oo=jo;while(1){jo=oo+16|0;f[j>>2]=Pk;f[e>>2]=f[j>>2];qo=Twa(Z,e,h,i,jo)|0;if(!(f[qo>>2]|0)){ep=L5b(28)|0;dp=f[jo>>2]|0;f[ep+16>>2]=dp;f[ep+20>>2]=f[oo+20>>2];if(dp|0){jo=dp+-4|0;f[jo>>2]=(f[jo>>2]|0)+1}f[ep+24>>2]=f[oo+24>>2];jo=f[h>>2]|0;f[ep>>2]=0;f[ep+4>>2]=0;f[ep+8>>2]=jo;f[qo>>2]=ep;jo=f[f[Z>>2]>>2]|0;if(!jo)Jp=ep;else{f[Z>>2]=jo;Jp=f[qo>>2]|0}mP(f[_i>>2]|0,Jp);f[$i>>2]=(f[$i>>2]|0)+1}qo=f[oo+4>>2]|0;do if(!qo){jo=oo+8|0;ep=f[jo>>2]|0;if((f[ep>>2]|0)==(oo|0)){Kp=ep;break}else Lp=jo;do{jo=f[Lp>>2]|0;Lp=jo+8|0;ep=f[Lp>>2]|0}while((f[ep>>2]|0)!=(jo|0));Kp=ep}else{ep=qo;while(1){jo=f[ep>>2]|0;if(!jo)break;else ep=jo}Kp=ep}while(0);if((Kp|0)==(la|0))break;else oo=Kp}}axa(Uwa(a,q,Z,4,0)|0,v);Wta(Z,f[aj>>2]|0);f[bj>>2]=0;f[cj>>2]=0;f[_>>2]=dj;oo=f[m>>2]|0;if((oo|0)!=(la|0)){qo=oo;while(1){oo=qo+16|0;f[j>>2]=Ok;f[e>>2]=f[j>>2];jo=Twa(_,e,h,i,oo)|0;if(!(f[jo>>2]|0)){dp=L5b(28)|0;io=f[oo>>2]|0;f[dp+16>>2]=io;f[dp+20>>2]=f[qo+20>>2];if(io|0){oo=io+-4|0;f[oo>>2]=(f[oo>>2]|0)+1}f[dp+24>>2]=f[qo+24>>2];oo=f[h>>2]|0;f[dp>>2]=0;f[dp+4>>2]=0;f[dp+8>>2]=oo;f[jo>>2]=dp;oo=f[f[_>>2]>>2]|0;if(!oo)Mp=dp;else{f[_>>2]=oo;Mp=f[jo>>2]|0}mP(f[bj>>2]|0,Mp);f[cj>>2]=(f[cj>>2]|0)+1}jo=f[qo+4>>2]|0;do if(!jo){oo=qo+8|0;dp=f[oo>>2]|0;if((f[dp>>2]|0)==(qo|0)){Np=dp;break}else Op=oo;do{oo=f[Op>>2]|0;Op=oo+8|0;dp=f[Op>>2]|0}while((f[dp>>2]|0)!=(oo|0));Np=dp}else{ep=jo;while(1){dp=f[ep>>2]|0;if(!dp)break;else ep=dp}Np=ep}while(0);if((Np|0)==(la|0))break;else qo=Np}}axa(Uwa(a,q,_,8,0)|0,X);Wta(_,f[dj>>2]|0);qo=f[ej>>2]|0;jo=(qo|0)/4|0;dp=f[fj>>2]|0;oo=f[Ci>>2]|0;do if((oo|0)>0){io=jo<<1;yo=jo*3|0;if((qo|0)>3)Pp=0;else break;do{Ao=Y(qo,Pp)|0;Fo=0;do{Go=dp+(Fo+jo+Ao<<2)|0;kp=dp+(Fo+io+Ao<<2)|0;Qp=f[Go>>2]|0;f[Go>>2]=f[kp>>2];f[kp>>2]=Qp;Go=dp+(Fo+yo+Ao<<2)|0;f[kp>>2]=f[Go>>2];f[Go>>2]=Qp;Fo=Fo+1|0}while((Fo|0)<(jo|0));Pp=Pp+1|0}while((Pp|0)<(oo|0))}while(0);f[e>>2]=0;f[gj>>2]=oo-jo;f[h>>2]=-2147483648;f[hj>>2]=2147483647;lL($,v,e,h);NS(i,$);dp=f[i>>2]|0;th[f[(f[dp>>2]|0)+12>>2]&511](dp,i,y,-1);Wi(i);dp=f[ij>>2]|0;do if(dp|0){qo=dp+12|0;yo=f[qo>>2]|0;f[qo>>2]=yo+-1;if((yo|0)!=1)break;kL($)}while(0);f[ij>>2]=0;f[jj>>2]=0;f[jj+4>>2]=0;f[jj+8>>2]=0;f[jj+12>>2]=0;if((f[kj>>2]|0)>0){dp=f[lj>>2]|0;oo=0;do{f[dp+(oo<<2)>>2]=0;oo=oo+1|0}while((oo|0)<(f[kj>>2]|0))}oo=f[mj>>2]|0;if((oo|0)!=(nj|0))UC(oo);oo=f[Ci>>2]|0;f[e>>2]=oo-jo;f[oj>>2]=oo;f[h>>2]=-2147483648;f[pj>>2]=2147483647;lL(aa,v,e,h);NS(i,aa);oo=f[i>>2]|0;th[f[(f[oo>>2]|0)+12>>2]&511](oo,i,w,-1);Wi(i);oo=f[qj>>2]|0;do if(oo|0){dp=oo+12|0;yo=f[dp>>2]|0;f[dp>>2]=yo+-1;if((yo|0)!=1)break;kL(aa)}while(0);f[qj>>2]=0;f[rj>>2]=0;f[rj+4>>2]=0;f[rj+8>>2]=0;f[rj+12>>2]=0;if((f[sj>>2]|0)>0){oo=f[tj>>2]|0;jo=0;do{f[oo+(jo<<2)>>2]=0;jo=jo+1|0}while((jo|0)<(f[sj>>2]|0))}jo=f[uj>>2]|0;if((jo|0)!=(vj|0))UC(jo);SL(tb,3);jo=f[tb>>2]|0;if((jo|0)==(w|0))Rp=w;else{oo=f[wk>>2]|0;if(oo|0){yo=oo+12|0;f[yo>>2]=(f[yo>>2]|0)+1}yo=jo+36|0;oo=f[yo>>2]|0;do if(oo|0){dp=oo+12|0;qo=f[dp>>2]|0;f[dp>>2]=qo+-1;if((qo|0)!=1)break;kL(jo)}while(0);f[yo>>2]=0;oo=jo+16|0;qo=jo+4|0;f[oo>>2]=0;f[oo+4>>2]=0;f[oo+8>>2]=0;f[oo+12>>2]=0;if((f[qo>>2]|0)>0){dp=f[jo+40>>2]|0;io=0;do{f[dp+(io<<2)>>2]=0;io=io+1|0;Sp=f[qo>>2]|0}while((io|0)<(Sp|0));f[jo>>2]=f[w>>2];if((Sp|0)<3)lo=1157;else lo=1159}else{f[jo>>2]=f[w>>2];lo=1157}do if((lo|0)==1157){lo=0;io=f[Hi>>2]|0;if((io|0)>=3){lo=1159;break}f[qo>>2]=io;f[jo+8>>2]=f[Ii>>2];f[jo+12>>2]=f[Jk>>2];io=f[Li>>2]|0;dp=f[jo+44>>2]|0;f[dp>>2]=f[io>>2];f[dp+4>>2]=f[io+4>>2]}while(0);if((lo|0)==1159){lo=0;jL(jo,w)}f[oo>>2]=f[xk>>2];f[jo+20>>2]=f[Kk>>2];f[jo+24>>2]=f[Lk>>2];f[jo+28>>2]=f[Mk>>2];f[jo+32>>2]=f[Nk>>2];f[yo>>2]=f[wk>>2];Rp=f[tb>>2]|0}qo=Rp+56|0;if((qo|0)==(y|0))Tp=Rp;else{io=f[uk>>2]|0;if(io|0){dp=io+12|0;f[dp>>2]=(f[dp>>2]|0)+1}dp=Rp+92|0;io=f[dp>>2]|0;do if(io|0){Fo=io+12|0;Ao=f[Fo>>2]|0;f[Fo>>2]=Ao+-1;if((Ao|0)!=1)break;kL(qo)}while(0);f[dp>>2]=0;io=Rp+72|0;yo=Rp+60|0;f[io>>2]=0;f[io+4>>2]=0;f[io+8>>2]=0;f[io+12>>2]=0;if((f[yo>>2]|0)>0){jo=f[Rp+96>>2]|0;oo=0;do{f[jo+(oo<<2)>>2]=0;oo=oo+1|0;Up=f[yo>>2]|0}while((oo|0)<(Up|0));f[qo>>2]=f[y>>2];if((Up|0)<3)lo=1172;else lo=1174}else{f[qo>>2]=f[y>>2];lo=1172}do if((lo|0)==1172){lo=0;oo=f[Ni>>2]|0;if((oo|0)>=3){lo=1174;break}f[yo>>2]=oo;f[Rp+64>>2]=f[Oi>>2];f[Rp+68>>2]=f[Ek>>2];oo=f[Ri>>2]|0;jo=f[Rp+100>>2]|0;f[jo>>2]=f[oo>>2];f[jo+4>>2]=f[oo+4>>2]}while(0);if((lo|0)==1174){lo=0;jL(qo,y)}f[io>>2]=f[vk>>2];f[Rp+76>>2]=f[Fk>>2];f[Rp+80>>2]=f[Gk>>2];f[Rp+84>>2]=f[Hk>>2];f[Rp+88>>2]=f[Ik>>2];f[dp>>2]=f[uk>>2];Tp=f[tb>>2]|0}yo=Tp+112|0;if((yo|0)!=(X|0)){oo=f[sk>>2]|0;if(oo|0){jo=oo+12|0;f[jo>>2]=(f[jo>>2]|0)+1}jo=Tp+148|0;oo=f[jo>>2]|0;do if(oo|0){Ao=oo+12|0;Fo=f[Ao>>2]|0;f[Ao>>2]=Fo+-1;if((Fo|0)!=1)break;kL(yo)}while(0);f[jo>>2]=0;oo=Tp+128|0;dp=Tp+116|0;f[oo>>2]=0;f[oo+4>>2]=0;f[oo+8>>2]=0;f[oo+12>>2]=0;if((f[dp>>2]|0)>0){io=f[Tp+152>>2]|0;qo=0;do{f[io+(qo<<2)>>2]=0;qo=qo+1|0;Vp=f[dp>>2]|0}while((qo|0)<(Vp|0));f[yo>>2]=f[X>>2];if((Vp|0)<3)lo=1187;else lo=1189}else{f[yo>>2]=f[X>>2];lo=1187}do if((lo|0)==1187){lo=0;qo=f[Ti>>2]|0;if((qo|0)>=3){lo=1189;break}f[dp>>2]=qo;f[Tp+120>>2]=f[Ui>>2];f[Tp+124>>2]=f[zk>>2];qo=f[Yi>>2]|0;io=f[Tp+156>>2]|0;f[io>>2]=f[qo>>2];f[io+4>>2]=f[qo+4>>2]}while(0);if((lo|0)==1189){lo=0;jL(yo,X)}f[oo>>2]=f[tk>>2];f[Tp+132>>2]=f[Ak>>2];f[Tp+136>>2]=f[Bk>>2];f[Tp+140>>2]=f[Ck>>2];f[Tp+144>>2]=f[Dk>>2];f[jo>>2]=f[sk>>2]};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;dp=L5b(16)|0;f[e>>2]=dp;f[wj>>2]=-2147483632;f[xj>>2]=12;lp=dp;mp=423452;np=lp+12|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[dp+12>>0]=0;jo=jxa(q,e)|0;if((b[yj>>0]|0)<0)O5b(f[e>>2]|0);do if(jo){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;oo=L5b(16)|0;f[e>>2]=oo;f[zj>>2]=-2147483632;f[Aj>>2]=12;lp=oo;mp=423452;np=lp+12|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[oo+12>>0]=0;tKb(_b);yo=kxa(f[$b>>2]|0,e)|0;qo=b[yo+8>>0]|0?(f[yo+20>>2]|0)==5:0;if((b[Bj>>0]|0)<0)O5b(f[e>>2]|0);if(!qo)break;f[e>>2]=0;f[Cj>>2]=0;lp=aD(e,12)|0;mp=423452;np=lp+12|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[h>>0]=1;$wa(t,e,h)|0;bD(e);SL(tb,6);oo=0;do{f[ba>>2]=1124007936;lp=Dj;np=lp+36|0;do{f[lp>>2]=0;lp=lp+4|0}while((lp|0)<(np|0));f[Fj>>2]=Ej;f[Hj>>2]=Gj;f[Gj>>2]=0;f[Ij>>2]=0;f[Jj>>2]=0;f[Kj>>2]=0;f[ca>>2]=Lj;qo=f[m>>2]|0;if((qo|0)!=(la|0)){yo=qo;while(1){qo=yo+16|0;f[j>>2]=pk;f[e>>2]=f[j>>2];io=Twa(ca,e,h,i,qo)|0;if(!(f[io>>2]|0)){Fo=L5b(28)|0;Ao=f[qo>>2]|0;f[Fo+16>>2]=Ao;f[Fo+20>>2]=f[yo+20>>2];if(Ao|0){qo=Ao+-4|0;f[qo>>2]=(f[qo>>2]|0)+1}f[Fo+24>>2]=f[yo+24>>2];qo=f[h>>2]|0;f[Fo>>2]=0;f[Fo+4>>2]=0;f[Fo+8>>2]=qo;f[io>>2]=Fo;qo=f[f[ca>>2]>>2]|0;if(!qo)Wp=Fo;else{f[ca>>2]=qo;Wp=f[io>>2]|0}mP(f[Jj>>2]|0,Wp);f[Kj>>2]=(f[Kj>>2]|0)+1}io=f[yo+4>>2]|0;do if(!io){qo=yo+8|0;Fo=f[qo>>2]|0;if((f[Fo>>2]|0)==(yo|0)){Xp=Fo;break}else Yp=qo;do{qo=f[Yp>>2]|0;Yp=qo+8|0;Fo=f[Yp>>2]|0}while((f[Fo>>2]|0)!=(qo|0));Xp=Fo}else{Fo=io;while(1){qo=f[Fo>>2]|0;if(!qo)break;else Fo=qo}Xp=Fo}while(0);if((Xp|0)==(la|0))break;else yo=Xp}}axa(Uwa(a,q,ca,oo+5|0,0)|0,ba);Wta(ca,f[Lj>>2]|0);yo=f[Dj>>2]|0;if((yo|0)<3)Zp=Y(f[Mj>>2]|0,f[Ej>>2]|0)|0;else{io=f[Fj>>2]|0;ro=0;qo=1;while(1){Ao=Y(f[io+(ro<<2)>>2]|0,qo)|0;ro=ro+1|0;if((ro|0)==(yo|0)){Zp=Ao;break}else qo=Ao}}WL(e,ba,1,Zp);qo=f[Nj>>2]|0;if(qo|0){yo=qo+12|0;f[yo>>2]=(f[yo>>2]|0)+1}yo=f[Oj>>2]|0;do if(yo|0){qo=yo+12|0;ro=f[qo>>2]|0;f[qo>>2]=ro+-1;if((ro|0)!=1)break;kL(ba)}while(0);f[Oj>>2]=0;f[Pj>>2]=0;f[Pj+4>>2]=0;f[Pj+8>>2]=0;f[Pj+12>>2]=0;if((f[Dj>>2]|0)>0){yo=f[Fj>>2]|0;ro=0;do{f[yo+(ro<<2)>>2]=0;ro=ro+1|0;_p=f[Dj>>2]|0}while((ro|0)<(_p|0));f[ba>>2]=f[e>>2];if((_p|0)<3)lo=1225;else lo=1227}else{f[ba>>2]=f[e>>2];lo=1225}do if((lo|0)==1225){lo=0;ro=f[Qj>>2]|0;if((ro|0)>=3){lo=1227;break}f[Dj>>2]=ro;f[Ej>>2]=f[Rj>>2];f[Mj>>2]=f[Sj>>2];ro=f[Tj>>2]|0;yo=f[Hj>>2]|0;f[yo>>2]=f[ro>>2];f[yo+4>>2]=f[ro+4>>2]}while(0);if((lo|0)==1227){lo=0;jL(ba,e)}f[Pj>>2]=f[Uj>>2];f[Wj>>2]=f[Vj>>2];f[Yj>>2]=f[Xj>>2];f[_j>>2]=f[Zj>>2];f[ak>>2]=f[$j>>2];ro=f[Nj>>2]|0;f[Oj>>2]=ro;do if(ro|0){yo=ro+12|0;qo=f[yo>>2]|0;f[yo>>2]=qo+-1;if((qo|0)!=1)break;kL(e)}while(0);f[Nj>>2]=0;f[Uj>>2]=0;f[Uj+4>>2]=0;f[Uj+8>>2]=0;f[Uj+12>>2]=0;if((f[Qj>>2]|0)>0){ro=f[bk>>2]|0;qo=0;do{f[ro+(qo<<2)>>2]=0;qo=qo+1|0}while((qo|0)<(f[Qj>>2]|0))}qo=f[Tj>>2]|0;if((qo|0)!=(ck|0))UC(qo);YL(e,ba);qo=f[dk>>2]|0;if(qo|0){ro=qo+12|0;f[ro>>2]=(f[ro>>2]|0)+1}ro=f[Oj>>2]|0;do if(ro|0){qo=ro+12|0;yo=f[qo>>2]|0;f[qo>>2]=yo+-1;if((yo|0)!=1)break;kL(ba)}while(0);f[Oj>>2]=0;f[Pj>>2]=0;f[Pj+4>>2]=0;f[Pj+8>>2]=0;f[Pj+12>>2]=0;if((f[Dj>>2]|0)>0){ro=f[Fj>>2]|0;yo=0;do{f[ro+(yo<<2)>>2]=0;yo=yo+1|0;$p=f[Dj>>2]|0}while((yo|0)<($p|0));f[ba>>2]=f[e>>2];if(($p|0)<3)lo=1246;else lo=1248}else{f[ba>>2]=f[e>>2];lo=1246}do if((lo|0)==1246){lo=0;yo=f[ek>>2]|0;if((yo|0)>=3){lo=1248;break}f[Dj>>2]=yo;f[Ej>>2]=f[fk>>2];f[Mj>>2]=f[gk>>2];yo=f[hk>>2]|0;ro=f[Hj>>2]|0;f[ro>>2]=f[yo>>2];f[ro+4>>2]=f[yo+4>>2]}while(0);if((lo|0)==1248){lo=0;jL(ba,e)}f[Pj>>2]=f[ik>>2];f[Wj>>2]=f[jk>>2];f[Yj>>2]=f[kk>>2];f[_j>>2]=f[lk>>2];f[ak>>2]=f[mk>>2];yo=f[dk>>2]|0;f[Oj>>2]=yo;do if(yo|0){ro=yo+12|0;qo=f[ro>>2]|0;f[ro>>2]=qo+-1;if((qo|0)!=1)break;kL(e)}while(0);f[dk>>2]=0;f[ik>>2]=0;f[ik+4>>2]=0;f[ik+8>>2]=0;f[ik+12>>2]=0;if((f[ek>>2]|0)>0){yo=f[nk>>2]|0;qo=0;do{f[yo+(qo<<2)>>2]=0;qo=qo+1|0}while((qo|0)<(f[ek>>2]|0))}qo=f[hk>>2]|0;if((qo|0)!=(ok|0))UC(qo);qo=oo+3|0;yo=f[tb>>2]|0;ro=yo+(qo*56|0)|0;if((ro|0)!=(ba|0)){io=f[Oj>>2]|0;if(io|0){Ao=io+12|0;f[Ao>>2]=(f[Ao>>2]|0)+1}Ao=yo+(qo*56|0)+36|0;io=f[Ao>>2]|0;do if(io|0){ep=io+12|0;Qp=f[ep>>2]|0;f[ep>>2]=Qp+-1;if((Qp|0)!=1)break;kL(ro)}while(0);f[Ao>>2]=0;io=yo+(qo*56|0)+16|0;Qp=yo+(qo*56|0)+4|0;f[io>>2]=0;f[io+4>>2]=0;f[io+8>>2]=0;f[io+12>>2]=0;if((f[Qp>>2]|0)>0){ep=f[yo+(qo*56|0)+40>>2]|0;Go=0;do{f[ep+(Go<<2)>>2]=0;Go=Go+1|0;aq=f[Qp>>2]|0}while((Go|0)<(aq|0));f[ro>>2]=f[ba>>2];if((aq|0)<3)lo=1268;else lo=1270}else{f[ro>>2]=f[ba>>2];lo=1268}do if((lo|0)==1268){lo=0;Go=f[Dj>>2]|0;if((Go|0)>=3){lo=1270;break}f[Qp>>2]=Go;f[yo+(qo*56|0)+8>>2]=f[Ej>>2];f[yo+(qo*56|0)+12>>2]=f[Mj>>2];Go=f[Hj>>2]|0;ep=f[yo+(qo*56|0)+44>>2]|0;f[ep>>2]=f[Go>>2];f[ep+4>>2]=f[Go+4>>2]}while(0);if((lo|0)==1270){lo=0;jL(ro,ba)}f[io>>2]=f[Pj>>2];f[yo+(qo*56|0)+20>>2]=f[Wj>>2];f[yo+(qo*56|0)+24>>2]=f[Yj>>2];f[yo+(qo*56|0)+28>>2]=f[_j>>2];f[yo+(qo*56|0)+32>>2]=f[ak>>2];f[Ao>>2]=f[Oj>>2]}Qp=f[Oj>>2]|0;do if(Qp|0){Go=Qp+12|0;ep=f[Go>>2]|0;f[Go>>2]=ep+-1;if((ep|0)!=1)break;kL(ba)}while(0);f[Oj>>2]=0;f[Pj>>2]=0;f[Pj+4>>2]=0;f[Pj+8>>2]=0;f[Pj+12>>2]=0;if((f[Dj>>2]|0)>0){Qp=f[Fj>>2]|0;Ao=0;do{f[Qp+(Ao<<2)>>2]=0;Ao=Ao+1|0}while((Ao|0)<(f[Dj>>2]|0))}Ao=f[Hj>>2]|0;if((Ao|0)!=(Gj|0))UC(Ao);oo=oo+1|0}while((oo|0)<3)}while(0);f[e>>2]=0;f[qk>>2]=0;jo=aD(e,4)|0;b[jo>>0]=76;b[jo+1>>0]=83;b[jo+2>>0]=84;b[jo+3>>0]=77;jo=lva(c,r,e,t)|0;bD(e);dp=cua(o,r)|0;f[dp>>2]=jo;hxa(e,f[(f[Da>>2]|0)+8>>2]|0);ixa(o,c,e,jo,0);if((b[rk>>0]|0)<0)O5b(f[e>>2]|0);jo=cua(l,r)|0;f[jo>>2]=2;jo=f[sk>>2]|0;do if(jo|0){dp=jo+12|0;oo=f[dp>>2]|0;f[dp>>2]=oo+-1;if((oo|0)!=1)break;kL(X)}while(0);f[sk>>2]=0;f[tk>>2]=0;f[tk+4>>2]=0;f[tk+8>>2]=0;f[tk+12>>2]=0;if((f[Ti>>2]|0)>0){jo=f[Vi>>2]|0;oo=0;do{f[jo+(oo<<2)>>2]=0;oo=oo+1|0}while((oo|0)<(f[Ti>>2]|0))}oo=f[Yi>>2]|0;if((oo|0)!=(Xi|0))UC(oo);oo=f[uk>>2]|0;do if(oo|0){jo=oo+12|0;dp=f[jo>>2]|0;f[jo>>2]=dp+-1;if((dp|0)!=1)break;kL(y)}while(0);f[uk>>2]=0;f[vk>>2]=0;f[vk+4>>2]=0;f[vk+8>>2]=0;f[vk+12>>2]=0;if((f[Ni>>2]|0)>0){oo=f[Pi>>2]|0;dp=0;do{f[oo+(dp<<2)>>2]=0;dp=dp+1|0}while((dp|0)<(f[Ni>>2]|0))}dp=f[Ri>>2]|0;if((dp|0)!=(Qi|0))UC(dp);dp=f[wk>>2]|0;do if(dp|0){oo=dp+12|0;jo=f[oo>>2]|0;f[oo>>2]=jo+-1;if((jo|0)!=1)break;kL(w)}while(0);f[wk>>2]=0;f[xk>>2]=0;f[xk+4>>2]=0;f[xk+8>>2]=0;f[xk+12>>2]=0;if((f[Hi>>2]|0)>0){dp=f[Ji>>2]|0;jo=0;do{f[dp+(jo<<2)>>2]=0;jo=jo+1|0}while((jo|0)<(f[Hi>>2]|0))}jo=f[Li>>2]|0;if((jo|0)!=(Ki|0))UC(jo);jo=f[yk>>2]|0;do if(jo|0){dp=jo+12|0;oo=f[dp>>2]|0;f[dp>>2]=oo+-1;if((oo|0)!=1)break;kL(v)}while(0);f[yk>>2]=0;f[fj>>2]=0;f[fj+4>>2]=0;f[fj+8>>2]=0;f[fj+12>>2]=0;if((f[Bi>>2]|0)>0){jo=f[Di>>2]|0;oo=0;do{f[jo+(oo<<2)>>2]=0;oo=oo+1|0}while((oo|0)<(f[Bi>>2]|0))}oo=f[Fi>>2]|0;if((oo|0)!=(Ei|0))UC(oo);break c}while(0);if((f[Ca>>2]|0)!=3){f[e>>2]=0;f[mi>>2]=0;lp=aD(e,46)|0;mp=370846;np=lp+46|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-213,e,376145,369853,1275);bD(e)}f[e>>2]=0;f[Wh>>2]=0;lp=aD(e,9)|0;mp=434144;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[h>>0]=0;$wa(t,e,h)|0;bD(e);SL(tb,1);f[e>>2]=0;f[Xh>>2]=0;oo=aD(e,7)|0;b[oo>>0]=b[370098]|0;b[oo+1>>0]=b[370099]|0;b[oo+2>>0]=b[370100]|0;b[oo+3>>0]=b[370101]|0;b[oo+4>>0]=b[370102]|0;b[oo+5>>0]=b[370103]|0;b[oo+6>>0]=b[370104]|0;_wa(v,ja,r,e);bD(e);do if(((f[Yh>>2]|0)-(f[v>>2]|0)|0)==12){f[e>>2]=0;f[Zh>>2]=0;lp=aD(e,9)|0;mp=434144;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[h>>0]=1;$wa(t,e,h)|0;bD(e);SL(tb,2);oo=f[(f[v>>2]|0)+8>>2]|0;jo=f[(f[ta>>2]|0)+4+(oo<<2)>>2]|0;f[_h>>2]=0;f[$h>>2]=0;f[V>>2]=ai;dp=f[m>>2]|0;if((dp|0)!=(la|0)){Ao=dp;while(1){dp=Ao+16|0;f[j>>2]=bi;f[e>>2]=f[j>>2];Qp=Twa(V,e,h,i,dp)|0;if(!(f[Qp>>2]|0)){qo=L5b(28)|0;yo=f[dp>>2]|0;f[qo+16>>2]=yo;f[qo+20>>2]=f[Ao+20>>2];if(yo|0){dp=yo+-4|0;f[dp>>2]=(f[dp>>2]|0)+1}f[qo+24>>2]=f[Ao+24>>2];dp=f[h>>2]|0;f[qo>>2]=0;f[qo+4>>2]=0;f[qo+8>>2]=dp;f[Qp>>2]=qo;dp=f[f[V>>2]>>2]|0;if(!dp)bq=qo;else{f[V>>2]=dp;bq=f[Qp>>2]|0}mP(f[_h>>2]|0,bq);f[$h>>2]=(f[$h>>2]|0)+1}Qp=f[Ao+4>>2]|0;do if(!Qp){dp=Ao+8|0;qo=f[dp>>2]|0;if((f[qo>>2]|0)==(Ao|0)){cq=qo;break}else dq=dp;do{dp=f[dq>>2]|0;dq=dp+8|0;qo=f[dq>>2]|0}while((f[qo>>2]|0)!=(dp|0));cq=qo}else{qo=Qp;while(1){dp=f[qo>>2]|0;if(!dp)break;else qo=dp}cq=qo}while(0);if((cq|0)==(la|0))break;else Ao=cq}}Ao=Uwa(a,jo,V,-1,0)|0;axa(Ao,(f[tb>>2]|0)+56|0);Wta(V,f[ai>>2]|0);bxa(ja,oo);Ao=f[v>>2]|0;Qp=f[ha>>2]|0;k:do if(!Qp){eq=ha;fq=ha}else{dp=f[Ao>>2]|0;yo=(dp|0)==0?1124530:dp;io=f[Qp+16>>2]|0;l:do if((dp|0)!=(io|0)){ro=fa;ep=Qp;Go=io;while(1){kp=(Go|0)==0?1124530:Go;if((gTb(yo,kp)|0)<0){gq=f[ep>>2]|0;if(!gq){lo=1050;break}else{hq=ep;iq=gq}}else{if((gTb(kp,yo)|0)>=0){jq=ro;kq=ep;break l}lq=ep+4|0;kp=f[lq>>2]|0;if(!kp){lo=1053;break}else{hq=lq;iq=kp}}Go=f[iq+16>>2]|0;if((dp|0)==(Go|0)){jq=hq;kq=iq;break l}else{ro=hq;ep=iq}}if((lo|0)==1050){lo=0;eq=ep;fq=ep;break k}else if((lo|0)==1053){lo=0;eq=lq;fq=ep;break k}}else{jq=fa;kq=Qp}while(0);eq=jq;fq=kq}while(0);if(f[eq>>2]|0)break;Qp=L5b(24)|0;oo=f[Ao>>2]|0;f[Qp+16>>2]=oo;f[Qp+20>>2]=f[Ao+4>>2];if(oo|0){jo=oo+-4|0;f[jo>>2]=(f[jo>>2]|0)+1}f[Qp>>2]=0;f[Qp+4>>2]=0;f[Qp+8>>2]=fq;f[eq>>2]=Qp;jo=f[f[k>>2]>>2]|0;if(!jo)mq=Qp;else{f[k>>2]=jo;mq=f[eq>>2]|0}mP(f[fa>>2]|0,mq);f[ga>>2]=(f[ga>>2]|0)+1}while(0);f[ci>>2]=0;f[ei>>2]=0;f[W>>2]=fi;jo=f[m>>2]|0;if((jo|0)!=(la|0)){Qp=jo;while(1){jo=Qp+16|0;f[j>>2]=li;f[e>>2]=f[j>>2];oo=Twa(W,e,h,i,jo)|0;if(!(f[oo>>2]|0)){dp=L5b(28)|0;yo=f[jo>>2]|0;f[dp+16>>2]=yo;f[dp+20>>2]=f[Qp+20>>2];if(yo|0){jo=yo+-4|0;f[jo>>2]=(f[jo>>2]|0)+1}f[dp+24>>2]=f[Qp+24>>2];jo=f[h>>2]|0;f[dp>>2]=0;f[dp+4>>2]=0;f[dp+8>>2]=jo;f[oo>>2]=dp;jo=f[f[W>>2]>>2]|0;if(!jo)nq=dp;else{f[W>>2]=jo;nq=f[oo>>2]|0}mP(f[ci>>2]|0,nq);f[ei>>2]=(f[ei>>2]|0)+1}oo=f[Qp+4>>2]|0;do if(!oo){jo=Qp+8|0;dp=f[jo>>2]|0;if((f[dp>>2]|0)==(Qp|0)){oq=dp;break}else pq=jo;do{jo=f[pq>>2]|0;pq=jo+8|0;dp=f[pq>>2]|0}while((f[dp>>2]|0)!=(jo|0));oq=dp}else{dp=oo;while(1){jo=f[dp>>2]|0;if(!jo)break;else dp=jo}oq=dp}while(0);if((oq|0)==(la|0))break;else Qp=oq}}Qp=Uwa(a,q,W,1,0)|0;cxa(Qp,f[tb>>2]|0);Wta(W,f[fi>>2]|0);Qp=f[(f[tb>>2]|0)+40>>2]|0;f[e>>2]=0;f[gi>>2]=0;oo=aD(e,8)|0;Ao=oo;b[Ao>>0]=107;b[Ao+1>>0]=101;b[Ao+2>>0]=114;b[Ao+3>>0]=110;Ao=oo+4|0;b[Ao>>0]=101;b[Ao+1>>0]=108;b[Ao+2>>0]=95;b[Ao+3>>0]=104;Wwa(t,e,Qp+8|0)|0;bD(e);f[e>>2]=0;f[hi>>2]=0;Ao=aD(e,8)|0;oo=Ao;b[oo>>0]=107;b[oo+1>>0]=101;b[oo+2>>0]=114;b[oo+3>>0]=110;oo=Ao+4|0;b[oo>>0]=101;b[oo+1>>0]=108;b[oo+2>>0]=95;b[oo+3>>0]=119;Wwa(t,e,Qp+12|0)|0;bD(e);f[e>>2]=0;f[ii>>2]=0;lp=aD(e,10)|0;mp=424460;np=lp+10|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));Wwa(t,e,Qp+4|0)|0;bD(e);dxa(t,q);exa(t,q);f[e>>2]=0;f[ji>>2]=0;lp=aD(e,13)|0;mp=410799;np=lp+13|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));Qp=lva(c,r,e,t)|0;bD(e);oo=cua(o,r)|0;f[oo>>2]=Qp;hxa(e,f[(f[Da>>2]|0)+12>>2]|0);ixa(o,c,e,Qp,0);if((b[ki>>0]|0)<0)O5b(f[e>>2]|0);Qp=f[v>>2]|0;if(Qp|0){while(1){oo=f[Yh>>2]|0;if((oo|0)==(Qp|0))break;Ao=oo+-12|0;f[Yh>>2]=Ao;bD(Ao)}O5b(f[v>>2]|0)}break c}while(0);if((f[Ca>>2]|0)!=5){f[e>>2]=0;f[Vh>>2]=0;lp=aD(e,34)|0;mp=370783;np=lp+34|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-213,e,376145,369853,1243);bD(e)}SL(tb,4);f[vh>>2]=0;f[wh>>2]=0;f[R>>2]=xh;Qp=f[m>>2]|0;if((Qp|0)!=(la|0)){Ao=Qp;while(1){Qp=Ao+16|0;f[j>>2]=Th;f[e>>2]=f[j>>2];oo=Twa(R,e,h,i,Qp)|0;if(!(f[oo>>2]|0)){jo=L5b(28)|0;yo=f[Qp>>2]|0;f[jo+16>>2]=yo;f[jo+20>>2]=f[Ao+20>>2];if(yo|0){Qp=yo+-4|0;f[Qp>>2]=(f[Qp>>2]|0)+1}f[jo+24>>2]=f[Ao+24>>2];Qp=f[h>>2]|0;f[jo>>2]=0;f[jo+4>>2]=0;f[jo+8>>2]=Qp;f[oo>>2]=jo;Qp=f[f[R>>2]>>2]|0;if(!Qp)qq=jo;else{f[R>>2]=Qp;qq=f[oo>>2]|0}mP(f[vh>>2]|0,qq);f[wh>>2]=(f[wh>>2]|0)+1}oo=f[Ao+4>>2]|0;do if(!oo){Qp=Ao+8|0;jo=f[Qp>>2]|0;if((f[jo>>2]|0)==(Ao|0)){rq=jo;break}else sq=Qp;do{Qp=f[sq>>2]|0;sq=Qp+8|0;jo=f[sq>>2]|0}while((f[jo>>2]|0)!=(Qp|0));rq=jo}else{jo=oo;while(1){Qp=f[jo>>2]|0;if(!Qp)break;else jo=Qp}rq=jo}while(0);if((rq|0)==(la|0))break;else Ao=rq}}Ao=Uwa(a,q,R,1,0)|0;axa(Ao,(f[tb>>2]|0)+112|0);Wta(R,f[xh>>2]|0);f[yh>>2]=0;f[zh>>2]=0;f[S>>2]=Ah;Ao=f[m>>2]|0;if((Ao|0)!=(la|0)){oo=Ao;while(1){Ao=oo+16|0;f[j>>2]=Sh;f[e>>2]=f[j>>2];Qp=Twa(S,e,h,i,Ao)|0;if(!(f[Qp>>2]|0)){yo=L5b(28)|0;io=f[Ao>>2]|0;f[yo+16>>2]=io;f[yo+20>>2]=f[oo+20>>2];if(io|0){Ao=io+-4|0;f[Ao>>2]=(f[Ao>>2]|0)+1}f[yo+24>>2]=f[oo+24>>2];Ao=f[h>>2]|0;f[yo>>2]=0;f[yo+4>>2]=0;f[yo+8>>2]=Ao;f[Qp>>2]=yo;Ao=f[f[S>>2]>>2]|0;if(!Ao)tq=yo;else{f[S>>2]=Ao;tq=f[Qp>>2]|0}mP(f[yh>>2]|0,tq);f[zh>>2]=(f[zh>>2]|0)+1}Qp=f[oo+4>>2]|0;do if(!Qp){Ao=oo+8|0;yo=f[Ao>>2]|0;if((f[yo>>2]|0)==(oo|0)){uq=yo;break}else vq=Ao;do{Ao=f[vq>>2]|0;vq=Ao+8|0;yo=f[vq>>2]|0}while((f[yo>>2]|0)!=(Ao|0));uq=yo}else{jo=Qp;while(1){yo=f[jo>>2]|0;if(!yo)break;else jo=yo}uq=jo}while(0);if((uq|0)==(la|0))break;else oo=uq}}oo=Uwa(a,q,S,2,0)|0;axa(oo,(f[tb>>2]|0)+168|0);Wta(S,f[Ah>>2]|0);f[Bh>>2]=0;f[Ch>>2]=0;f[T>>2]=Dh;oo=f[m>>2]|0;if((oo|0)!=(la|0)){Qp=oo;while(1){oo=Qp+16|0;f[j>>2]=Rh;f[e>>2]=f[j>>2];yo=Twa(T,e,h,i,oo)|0;if(!(f[yo>>2]|0)){Ao=L5b(28)|0;io=f[oo>>2]|0;f[Ao+16>>2]=io;f[Ao+20>>2]=f[Qp+20>>2];if(io|0){oo=io+-4|0;f[oo>>2]=(f[oo>>2]|0)+1}f[Ao+24>>2]=f[Qp+24>>2];oo=f[h>>2]|0;f[Ao>>2]=0;f[Ao+4>>2]=0;f[Ao+8>>2]=oo;f[yo>>2]=Ao;oo=f[f[T>>2]>>2]|0;if(!oo)wq=Ao;else{f[T>>2]=oo;wq=f[yo>>2]|0}mP(f[Bh>>2]|0,wq);f[Ch>>2]=(f[Ch>>2]|0)+1}yo=f[Qp+4>>2]|0;do if(!yo){oo=Qp+8|0;Ao=f[oo>>2]|0;if((f[Ao>>2]|0)==(Qp|0)){xq=Ao;break}else yq=oo;do{oo=f[yq>>2]|0;yq=oo+8|0;Ao=f[yq>>2]|0}while((f[Ao>>2]|0)!=(oo|0));xq=Ao}else{jo=yo;while(1){Ao=f[jo>>2]|0;if(!Ao)break;else jo=Ao}xq=jo}while(0);if((xq|0)==(la|0))break;else Qp=xq}}Qp=Uwa(a,q,T,3,0)|0;axa(Qp,f[tb>>2]|0);Wta(T,f[Dh>>2]|0);f[Eh>>2]=0;f[Fh>>2]=0;f[U>>2]=Gh;Qp=f[m>>2]|0;if((Qp|0)!=(la|0)){yo=Qp;while(1){Qp=yo+16|0;f[j>>2]=Qh;f[e>>2]=f[j>>2];Ao=Twa(U,e,h,i,Qp)|0;if(!(f[Ao>>2]|0)){oo=L5b(28)|0;io=f[Qp>>2]|0;f[oo+16>>2]=io;f[oo+20>>2]=f[yo+20>>2];if(io|0){Qp=io+-4|0;f[Qp>>2]=(f[Qp>>2]|0)+1}f[oo+24>>2]=f[yo+24>>2];Qp=f[h>>2]|0;f[oo>>2]=0;f[oo+4>>2]=0;f[oo+8>>2]=Qp;f[Ao>>2]=oo;Qp=f[f[U>>2]>>2]|0;if(!Qp)zq=oo;else{f[U>>2]=Qp;zq=f[Ao>>2]|0}mP(f[Eh>>2]|0,zq);f[Fh>>2]=(f[Fh>>2]|0)+1}Ao=f[yo+4>>2]|0;do if(!Ao){Qp=yo+8|0;oo=f[Qp>>2]|0;if((f[oo>>2]|0)==(yo|0)){Aq=oo;break}else Bq=Qp;do{Qp=f[Bq>>2]|0;Bq=Qp+8|0;oo=f[Bq>>2]|0}while((f[oo>>2]|0)!=(Qp|0));Aq=oo}else{jo=Ao;while(1){oo=f[jo>>2]|0;if(!oo)break;else jo=oo}Aq=jo}while(0);if((Aq|0)==(la|0))break;else yo=Aq}}yo=Uwa(a,q,U,4,0)|0;axa(yo,(f[tb>>2]|0)+56|0);Wta(U,f[Gh>>2]|0);f[ao>>2]=0;b[Hh>>0]=7;b[e>>0]=b[370818]|0;b[e+1>>0]=b[370819]|0;b[e+2>>0]=b[370820]|0;b[e+3>>0]=b[370821]|0;b[e+4>>0]=b[370822]|0;b[e+5>>0]=b[370823]|0;b[e+6>>0]=b[370824]|0;b[Ih>>0]=0;yo=jxa(q,e)|0;if((b[Hh>>0]|0)<0)O5b(f[e>>2]|0);if(yo){f[e>>2]=0;f[Jh>>2]=0;yo=aD(e,3)|0;b[yo>>0]=b[433709]|0;b[yo+1>>0]=b[433710]|0;b[yo+2>>0]=b[433711]|0;f[bo>>2]=0;b[Kh>>0]=7;b[i>>0]=b[370818]|0;b[i+1>>0]=b[370819]|0;b[i+2>>0]=b[370820]|0;b[i+3>>0]=b[370821]|0;b[i+4>>0]=b[370822]|0;b[i+5>>0]=b[370823]|0;b[i+6>>0]=b[370824]|0;b[Lh>>0]=0;tKb(_b);yo=kxa(f[$b>>2]|0,i)|0;n[h>>2]=(f[yo+20>>2]|0)==4?+n[yo+8>>2]:0.0;Zwa(t,e,h)|0;if((b[Kh>>0]|0)<0)O5b(f[i>>2]|0);bD(e)}f[e>>2]=0;f[Mh>>2]=0;lp=aD(e,10)|0;mp=422223;np=lp+10|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[h>>0]=1;$wa(t,e,h)|0;bD(e);f[e>>2]=0;f[Nh>>2]=0;yo=aD(e,8)|0;Ao=yo;b[Ao>>0]=104;b[Ao+1>>0]=97;b[Ao+2>>0]=115;b[Ao+3>>0]=95;Ao=yo+4|0;b[Ao>>0]=98;b[Ao+1>>0]=105;b[Ao+2>>0]=97;b[Ao+3>>0]=115;b[h>>0]=1;$wa(t,e,h)|0;bD(e);f[e>>2]=0;f[Oh>>2]=0;lp=aD(e,9)|0;mp=411943;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));Ao=lva(c,r,e,t)|0;bD(e);yo=cua(o,r)|0;f[yo>>2]=Ao;hxa(e,f[(f[Da>>2]|0)+4>>2]|0);ixa(o,c,e,Ao,0);if((b[Ph>>0]|0)<0)O5b(f[e>>2]|0);break c}while(0);f[dh>>2]=0;f[eh>>2]=0;f[Q>>2]=fh;Ao=f[m>>2]|0;if((Ao|0)!=(la|0)){yo=Ao;while(1){Ao=yo+16|0;f[j>>2]=uh;f[e>>2]=f[j>>2];oo=Twa(Q,e,h,i,Ao)|0;if(!(f[oo>>2]|0)){Qp=L5b(28)|0;io=f[Ao>>2]|0;f[Qp+16>>2]=io;f[Qp+20>>2]=f[yo+20>>2];if(io|0){Ao=io+-4|0;f[Ao>>2]=(f[Ao>>2]|0)+1}f[Qp+24>>2]=f[yo+24>>2];Ao=f[h>>2]|0;f[Qp>>2]=0;f[Qp+4>>2]=0;f[Qp+8>>2]=Ao;f[oo>>2]=Qp;Ao=f[f[Q>>2]>>2]|0;if(!Ao)Cq=Qp;else{f[Q>>2]=Ao;Cq=f[oo>>2]|0}mP(f[dh>>2]|0,Cq);f[eh>>2]=(f[eh>>2]|0)+1}oo=f[yo+4>>2]|0;do if(!oo){Ao=yo+8|0;Qp=f[Ao>>2]|0;if((f[Qp>>2]|0)==(yo|0)){Dq=Qp;break}else Eq=Ao;do{Ao=f[Eq>>2]|0;Eq=Ao+8|0;Qp=f[Eq>>2]|0}while((f[Qp>>2]|0)!=(Ao|0));Dq=Qp}else{Qp=oo;while(1){Ao=f[Qp>>2]|0;if(!Ao)break;else Qp=Ao}Dq=Qp}while(0);if((Dq|0)==(la|0))break;else yo=Dq}}Ywa(v,Uwa(a,q,Q,1,0)|0);Wta(Q,f[fh>>2]|0);if((f[v>>2]&4095|0)!=4){f[e>>2]=0;f[sh>>2]=0;lp=aD(e,60)|0;mp=370707;np=lp+60|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,1211);bD(e)}yo=f[gh>>2]|0;if((yo|0)<3)Fq=Y(f[ih>>2]|0,f[hh>>2]|0)|0;else{oo=f[qh>>2]|0;Ao=0;io=1;while(1){ro=Y(f[oo+(Ao<<2)>>2]|0,io)|0;Ao=Ao+1|0;if((Ao|0)==(yo|0)){Fq=ro;break}else io=ro}}if((Fq|0)==8){io=f[jh>>2]|0;yo=(f[kh>>2]|0)+4|0;Ao=f[yo>>2]|0;oo=io+(Ao<<1)|0;ro=io+(Ao*6|0)|0;Ao=f[oo>>2]|0;f[oo>>2]=f[ro>>2];f[ro>>2]=Ao;Ao=f[yo>>2]|0;ro=io+(Ao*3|0)|0;oo=io+(Ao*7|0)|0;Ao=f[ro>>2]|0;f[ro>>2]=f[oo>>2];f[oo>>2]=Ao;Ao=f[yo>>2]|0;oo=io+(Ao<<2)|0;ro=io+(Ao*6|0)|0;Ao=f[oo>>2]|0;f[oo>>2]=f[ro>>2];f[ro>>2]=Ao;Ao=f[yo>>2]|0;yo=io+(Ao*5|0)|0;ro=io+(Ao*7|0)|0;Ao=f[yo>>2]|0;f[yo>>2]=f[ro>>2];f[ro>>2]=Ao}f[e>>2]=0;f[lh>>2]=0;Ao=aD(e,8)|0;ro=Ao;b[ro>>0]=112;b[ro+1>>0]=97;b[ro+2>>0]=100;b[ro+3>>0]=100;ro=Ao+4|0;b[ro>>0]=105;b[ro+1>>0]=110;b[ro+2>>0]=103;b[ro+3>>0]=115;ro=f[jh>>2]|0;Ao=f[gh>>2]|0;if((Ao|0)<3)Gq=Y(f[ih>>2]|0,f[hh>>2]|0)|0;else{yo=f[qh>>2]|0;io=0;oo=1;while(1){Go=Y(f[yo+(io<<2)>>2]|0,oo)|0;io=io+1|0;if((io|0)==(Ao|0)){Gq=Go;break}else oo=Go}}oo=L5b(16)|0;Ao=oo+8|0;f[oo>>2]=Ao;f[oo+4>>2]=Gq;if(Gq>>>0>1){io=N5b(Gq>>>0>536870911?-1:Gq<<3)|0;f[oo>>2]=io;Hq=io}else Hq=Ao;f[h>>2]=0;f[mh>>2]=oo;if((Gq|0)>0){oo=ro;Ao=0;while(1){io=f[oo>>2]|0;yo=Hq+(Ao<<3)|0;f[yo>>2]=io;f[yo+4>>2]=((io|0)<0)<<31>>31;Ao=Ao+1|0;if((Ao|0)==(Gq|0))break;else oo=oo+4|0}}nxa(t,e,h)|0;gua(h);bD(e);f[e>>2]=0;f[nh>>2]=0;oo=aD(e,7)|0;b[oo>>0]=b[410993]|0;b[oo+1>>0]=b[410994]|0;b[oo+2>>0]=b[410995]|0;b[oo+3>>0]=b[410996]|0;b[oo+4>>0]=b[410997]|0;b[oo+5>>0]=b[410998]|0;b[oo+6>>0]=b[410999]|0;oo=lva(c,r,e,t)|0;bD(e);Ao=cua(o,r)|0;f[Ao>>2]=oo;hxa(e,f[(f[Da>>2]|0)+4>>2]|0);ixa(o,c,e,oo,0);if((b[oh>>0]|0)<0)O5b(f[e>>2]|0);oo=f[ph>>2]|0;do if(oo|0){Ao=oo+12|0;ro=f[Ao>>2]|0;f[Ao>>2]=ro+-1;if((ro|0)!=1)break;kL(v)}while(0);f[ph>>2]=0;f[jh>>2]=0;f[jh+4>>2]=0;f[jh+8>>2]=0;f[jh+12>>2]=0;if((f[gh>>2]|0)>0){oo=f[qh>>2]|0;ro=0;do{f[oo+(ro<<2)>>2]=0;ro=ro+1|0}while((ro|0)<(f[gh>>2]|0))}ro=f[kh>>2]|0;if((ro|0)!=(rh|0))UC(ro);break c}while(0);ro=0;oo=f[Ca>>2]|0;while(1){if((ro|0)>=(oo|0)){lo=895;break}hxa(e,f[(f[Da>>2]|0)+4+(ro<<2)>>2]|0);f[h>>2]=0;f[ng>>2]=0;Ao=b[og>>0]|0;io=Ao<<24>>24<0?f[pg>>2]|0:Ao&255;if(io|0){Ao=aD(h,io)|0;Vac(Ao|0,((b[og>>0]|0)<0?f[e>>2]|0:e)|0,io|0)|0}io=f[la>>2]|0;do if(io){Ao=f[h>>2]|0;yo=(Ao|0)==0?1124530:Ao;Go=la;qo=io;m:while(1){kp=qo;while(1){gq=f[kp+16>>2]|0;if((gq|0)==(Ao|0))break;if((gTb((gq|0)==0?1124530:gq,yo)|0)>=0)break;gq=f[kp+4>>2]|0;if(!gq){Iq=Go;break m}else kp=gq}qo=f[kp>>2]|0;if(!qo){Iq=kp;break}else Go=kp}if((Iq|0)==(la|0)){lo=801;break}Go=f[Iq+16>>2]|0;if((Ao|0)==(Go|0)){Jq=Iq;break}if((gTb(yo,(Go|0)==0?1124530:Go)|0)>=0)Jq=Iq;else lo=801}else lo=801;while(0);if((lo|0)==801){lo=0;Jq=la}bD(h);if((b[og>>0]|0)<0)O5b(f[e>>2]|0);oo=f[Ca>>2]|0;if((Jq|0)!=(la|0))break;else ro=ro+1|0}if((lo|0)==895){lo=0;f[e>>2]=0;f[Vg>>2]=0;lp=aD(e,9)|0;mp=427507;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));pxa(t,e,427517)|0;bD(e);f[e>>2]=0;f[Wg>>2]=0;ro=aD(e,7)|0;b[ro>>0]=b[410937]|0;b[ro+1>>0]=b[410938]|0;b[ro+2>>0]=b[410939]|0;b[ro+3>>0]=b[410940]|0;b[ro+4>>0]=b[410941]|0;b[ro+5>>0]=b[410942]|0;b[ro+6>>0]=b[410943]|0;ro=lva(c,r,e,t)|0;bD(e);io=cua(o,r)|0;f[io>>2]=ro;if((f[Ca>>2]|0)>0)Kq=0;else break c;while(1){hxa(e,f[(f[Da>>2]|0)+4+(Kq<<2)>>2]|0);f[h>>2]=0;f[Xg>>2]=0;io=b[Yg>>0]|0;Go=io<<24>>24<0?f[Zg>>2]|0:io&255;if(Go|0){io=aD(h,Go)|0;Vac(io|0,((b[Yg>>0]|0)<0?f[e>>2]|0:e)|0,Go|0)|0}Go=f[ea>>2]|0;do if(Go){io=f[h>>2]|0;qo=(io|0)==0?1124530:io;Qp=ea;gq=Go;n:while(1){Lq=gq;while(1){Mq=f[Lq+16>>2]|0;if((Mq|0)==(io|0))break;if((gTb((Mq|0)==0?1124530:Mq,qo)|0)>=0)break;Mq=f[Lq+4>>2]|0;if(!Mq){Nq=Qp;break n}else Lq=Mq}gq=f[Lq>>2]|0;if(!gq){Nq=Lq;break}else Qp=Lq}if((Nq|0)==(ea|0)){lo=908;break}Qp=f[Nq+16>>2]|0;if((io|0)==(Qp|0)){Oq=Nq;break}if((gTb(qo,(Qp|0)==0?1124530:Qp)|0)>=0)Oq=Nq;else lo=908}else lo=908;while(0);if((lo|0)==908){lo=0;Oq=ea}bD(h);if((Oq|0)==(ea|0)){dua(i,370213,e);f[h>>2]=0;f[_g>>2]=0;Go=b[$g>>0]|0;Qp=Go<<24>>24<0?f[ah>>2]|0:Go&255;if(Qp|0){Go=aD(h,Qp)|0;Vac(Go|0,((b[$g>>0]|0)<0?f[i>>2]|0:i)|0,Qp|0)|0}bO(-2,h,376145,369853,1203);bD(h);if((b[$g>>0]|0)<0)O5b(f[i>>2]|0)}f[h>>2]=0;f[bh>>2]=0;Qp=b[Yg>>0]|0;Go=Qp<<24>>24<0?f[Zg>>2]|0:Qp&255;if(Go|0){Qp=aD(h,Go)|0;Vac(Qp|0,((b[Yg>>0]|0)<0?f[e>>2]|0:e)|0,Go|0)|0}Go=mxa(o,h)|0;tva(c,f[Go>>2]|0,f[ch>>2]|0,ro,Kq);bD(h);if((b[Yg>>0]|0)<0)O5b(f[e>>2]|0);Kq=Kq+1|0;if((Kq|0)>=(f[Ca>>2]|0))break c}}do if((oo|0)!=2){f[e>>2]=0;f[Tg>>2]=0;lp=aD(e,37)|0;mp=370175;np=lp+37|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,1151);bD(e);if((f[Ca>>2]|0)==2)break;f[e>>2]=0;f[Ug>>2]=0;lp=aD(e,23)|0;mp=370244;np=lp+23|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,1156);bD(e)}while(0);f[qg>>2]=0;f[rg>>2]=0;f[O>>2]=sg;oo=f[m>>2]|0;if((oo|0)!=(la|0)){ro=oo;while(1){oo=ro+16|0;f[j>>2]=Sg;f[e>>2]=f[j>>2];Go=Twa(O,e,h,i,oo)|0;if(!(f[Go>>2]|0)){Qp=L5b(28)|0;gq=f[oo>>2]|0;f[Qp+16>>2]=gq;f[Qp+20>>2]=f[ro+20>>2];if(gq|0){oo=gq+-4|0;f[oo>>2]=(f[oo>>2]|0)+1}f[Qp+24>>2]=f[ro+24>>2];oo=f[h>>2]|0;f[Qp>>2]=0;f[Qp+4>>2]=0;f[Qp+8>>2]=oo;f[Go>>2]=Qp;oo=f[f[O>>2]>>2]|0;if(!oo)Pq=Qp;else{f[O>>2]=oo;Pq=f[Go>>2]|0}mP(f[qg>>2]|0,Pq);f[rg>>2]=(f[rg>>2]|0)+1}Go=f[ro+4>>2]|0;do if(!Go){oo=ro+8|0;Qp=f[oo>>2]|0;if((f[Qp>>2]|0)==(ro|0)){Qq=Qp;break}else Rq=oo;do{oo=f[Rq>>2]|0;Rq=oo+8|0;Qp=f[Rq>>2]|0}while((f[Qp>>2]|0)!=(oo|0));Qq=Qp}else{qo=Go;while(1){io=f[qo>>2]|0;if(!io)break;else qo=io}Qq=qo}while(0);if((Qq|0)==(la|0))break;else ro=Qq}}Ywa(v,Uwa(a,q,O,-1,0)|0);Wta(O,f[sg>>2]|0);if((f[v>>2]&4095|0)!=5){f[e>>2]=0;f[Rg>>2]=0;lp=aD(e,60)|0;mp=370642;np=lp+60|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,1158);bD(e)}ro=f[tg>>2]|0;if((ro|0)<3)Sq=Y(f[vg>>2]|0,f[ug>>2]|0)|0;else{Go=f[Eg>>2]|0;io=0;Qp=1;while(1){oo=Y(f[Go+(io<<2)>>2]|0,Qp)|0;io=io+1|0;if((io|0)==(ro|0)){Sq=oo;break}else Qp=oo}}if((Sq|0)==1){f[e>>2]=0;f[wg>>2]=0;Qp=aD(e,5)|0;b[Qp>>0]=b[439628]|0;b[Qp+1>>0]=b[439629]|0;b[Qp+2>>0]=b[439630]|0;b[Qp+3>>0]=b[439631]|0;b[Qp+4>>0]=b[439632]|0;Zwa(t,e,f[xg>>2]|0)|0;bD(e);f[e>>2]=0;f[yg>>2]=0;Qp=aD(e,5)|0;b[Qp>>0]=b[433229]|0;b[Qp+1>>0]=b[433230]|0;b[Qp+2>>0]=b[433231]|0;b[Qp+3>>0]=b[433232]|0;b[Qp+4>>0]=b[433233]|0;Qp=lva(c,r,e,t)|0;bD(e);Tq=Qp}else{Ws(tb,1,v);f[e>>2]=0;f[Ig>>2]=0;Qp=aD(e,3)|0;b[Qp>>0]=b[370171]|0;b[Qp+1>>0]=b[370172]|0;b[Qp+2>>0]=b[370173]|0;_wa(w,ja,r,e);bD(e);do if((f[w>>2]|0)!=(f[Jg>>2]|0)){f[e>>2]=0;f[Lg>>2]=0;lp=aD(e,9)|0;mp=434144;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[h>>0]=1;$wa(t,e,h)|0;bD(e);SL(tb,2);Qp=f[(f[w>>2]|0)+8>>2]|0;ro=f[(f[ta>>2]|0)+4+(Qp<<2)>>2]|0;f[Mg>>2]=0;f[Ng>>2]=0;f[P>>2]=Og;io=f[m>>2]|0;if((io|0)!=(la|0)){Go=io;while(1){io=Go+16|0;f[j>>2]=Qg;f[e>>2]=f[j>>2];oo=Twa(P,e,h,i,io)|0;if(!(f[oo>>2]|0)){gq=L5b(28)|0;yo=f[io>>2]|0;f[gq+16>>2]=yo;f[gq+20>>2]=f[Go+20>>2];if(yo|0){io=yo+-4|0;f[io>>2]=(f[io>>2]|0)+1}f[gq+24>>2]=f[Go+24>>2];io=f[h>>2]|0;f[gq>>2]=0;f[gq+4>>2]=0;f[gq+8>>2]=io;f[oo>>2]=gq;io=f[f[P>>2]>>2]|0;if(!io)Uq=gq;else{f[P>>2]=io;Uq=f[oo>>2]|0}mP(f[Mg>>2]|0,Uq);f[Ng>>2]=(f[Ng>>2]|0)+1}oo=f[Go+4>>2]|0;do if(!oo){io=Go+8|0;gq=f[io>>2]|0;if((f[gq>>2]|0)==(Go|0)){Vq=gq;break}else Wq=io;do{io=f[Wq>>2]|0;Wq=io+8|0;gq=f[Wq>>2]|0}while((f[gq>>2]|0)!=(io|0));Vq=gq}else{Lq=oo;while(1){gq=f[Lq>>2]|0;if(!gq)break;else Lq=gq}Vq=Lq}while(0);if((Vq|0)==(la|0))break;else Go=Vq}}Go=Uwa(a,ro,P,-1,0)|0;axa(Go,(f[Pg>>2]|0)+-56|0);Wta(P,f[Og>>2]|0);bxa(ja,Qp);Go=f[w>>2]|0;oo=f[ha>>2]|0;o:do if(!oo){Xq=ha;Yq=ha}else{qo=f[Go>>2]|0;gq=(qo|0)==0?1124530:qo;io=f[oo+16>>2]|0;p:do if((qo|0)!=(io|0)){yo=fa;Ao=oo;kp=io;while(1){Mq=(kp|0)==0?1124530:kp;if((gTb(gq,Mq)|0)<0){Zq=f[Ao>>2]|0;if(!Zq){lo=848;break}else{_q=Ao;$q=Zq}}else{if((gTb(Mq,gq)|0)>=0){ar=yo;br=Ao;break p}cr=Ao+4|0;Mq=f[cr>>2]|0;if(!Mq){lo=851;break}else{_q=cr;$q=Mq}}kp=f[$q+16>>2]|0;if((qo|0)==(kp|0)){ar=_q;br=$q;break p}else{yo=_q;Ao=$q}}if((lo|0)==848){lo=0;Xq=Ao;Yq=Ao;break o}else if((lo|0)==851){lo=0;Xq=cr;Yq=Ao;break o}}else{ar=fa;br=oo}while(0);Xq=ar;Yq=br}while(0);if(f[Xq>>2]|0)break;oo=L5b(24)|0;Qp=f[Go>>2]|0;f[oo+16>>2]=Qp;f[oo+20>>2]=f[Go+4>>2];if(Qp|0){ro=Qp+-4|0;f[ro>>2]=(f[ro>>2]|0)+1}f[oo>>2]=0;f[oo+4>>2]=0;f[oo+8>>2]=Yq;f[Xq>>2]=oo;ro=f[f[k>>2]>>2]|0;if(!ro)dr=oo;else{f[k>>2]=ro;dr=f[Xq>>2]|0}mP(f[fa>>2]|0,dr);f[ga>>2]=(f[ga>>2]|0)+1}while(0);f[e>>2]=0;f[Kg>>2]=0;ro=aD(e,5)|0;b[ro>>0]=b[411001]|0;b[ro+1>>0]=b[411002]|0;b[ro+2>>0]=b[411003]|0;b[ro+3>>0]=b[411004]|0;b[ro+4>>0]=b[411005]|0;ro=lva(c,r,e,t)|0;bD(e);oo=f[w>>2]|0;if(oo|0){while(1){Qp=f[Jg>>2]|0;if((Qp|0)==(oo|0))break;qo=Qp+-12|0;f[Jg>>2]=qo;bD(qo)}O5b(f[w>>2]|0)}Tq=ro}oo=cua(o,r)|0;f[oo>>2]=Tq;hxa(e,f[(f[Da>>2]|0)+4>>2]|0);f[h>>2]=0;f[zg>>2]=0;oo=b[Ag>>0]|0;qo=oo<<24>>24<0?f[Bg>>2]|0:oo&255;if(qo|0){oo=aD(h,qo)|0;Vac(oo|0,((b[Ag>>0]|0)<0?f[e>>2]|0:e)|0,qo|0)|0}qo=f[ea>>2]|0;do if(qo){oo=f[h>>2]|0;Qp=(oo|0)==0?1124530:oo;gq=ea;io=qo;q:while(1){yo=io;while(1){kp=f[yo+16>>2]|0;if((kp|0)==(oo|0))break;if((gTb((kp|0)==0?1124530:kp,Qp)|0)>=0)break;kp=f[yo+4>>2]|0;if(!kp){er=gq;break q}else yo=kp}io=f[yo>>2]|0;if(!io){er=yo;break}else gq=yo}if((er|0)==(ea|0)){lo=876;break}gq=f[er+16>>2]|0;if((oo|0)==(gq|0)){fr=er;break}if((gTb(Qp,(gq|0)==0?1124530:gq)|0)>=0)fr=er;else lo=876}else lo=876;while(0);if((lo|0)==876){lo=0;fr=ea}bD(h);if((fr|0)==(ea|0)){hxa(h,f[(f[Da>>2]|0)+8>>2]|0);ixa(o,c,h,Tq,0);if((b[Cg>>0]|0)<0)O5b(f[h>>2]|0)}else{hxa(h,f[(f[Da>>2]|0)+4>>2]|0);ixa(o,c,h,Tq,0);if((b[Hg>>0]|0)<0)O5b(f[h>>2]|0)}if((b[Ag>>0]|0)<0)O5b(f[e>>2]|0);qo=f[Dg>>2]|0;do if(qo|0){ro=qo+12|0;gq=f[ro>>2]|0;f[ro>>2]=gq+-1;if((gq|0)!=1)break;kL(v)}while(0);f[Dg>>2]=0;f[xg>>2]=0;f[xg+4>>2]=0;f[xg+8>>2]=0;f[xg+12>>2]=0;if((f[tg>>2]|0)>0){qo=f[Eg>>2]|0;gq=0;do{f[qo+(gq<<2)>>2]=0;gq=gq+1|0}while((gq|0)<(f[tg>>2]|0))}gq=f[Fg>>2]|0;if((gq|0)!=(Gg|0))UC(gq);break c}while(0);if((f[Ca>>2]|0)!=3){f[e>>2]=0;f[mg>>2]=0;lp=aD(e,23)|0;mp=369829;np=lp+23|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,1121);bD(e)}f[Nf>>2]=0;f[Of>>2]=0;f[M>>2]=Pf;gq=f[m>>2]|0;if((gq|0)!=(la|0)){qo=gq;while(1){gq=qo+16|0;f[j>>2]=lg;f[e>>2]=f[j>>2];ro=Twa(M,e,h,i,gq)|0;if(!(f[ro>>2]|0)){io=L5b(28)|0;Go=f[gq>>2]|0;f[io+16>>2]=Go;f[io+20>>2]=f[qo+20>>2];if(Go|0){gq=Go+-4|0;f[gq>>2]=(f[gq>>2]|0)+1}f[io+24>>2]=f[qo+24>>2];gq=f[h>>2]|0;f[io>>2]=0;f[io+4>>2]=0;f[io+8>>2]=gq;f[ro>>2]=io;gq=f[f[M>>2]>>2]|0;if(!gq)gr=io;else{f[M>>2]=gq;gr=f[ro>>2]|0}mP(f[Nf>>2]|0,gr);f[Of>>2]=(f[Of>>2]|0)+1}ro=f[qo+4>>2]|0;do if(!ro){gq=qo+8|0;io=f[gq>>2]|0;if((f[io>>2]|0)==(qo|0)){hr=io;break}else ir=gq;do{gq=f[ir>>2]|0;ir=gq+8|0;io=f[ir>>2]|0}while((f[io>>2]|0)!=(gq|0));hr=io}else{Qp=ro;while(1){oo=f[Qp>>2]|0;if(!oo)break;else Qp=oo}hr=Qp}while(0);if((hr|0)==(la|0))break;else qo=hr}}FFa(v,Uwa(a,q,M,1,0)|0);Wta(M,f[Pf>>2]|0);f[Qf>>2]=0;f[Rf>>2]=0;f[N>>2]=Sf;qo=f[m>>2]|0;if((qo|0)!=(la|0)){ro=qo;while(1){qo=ro+16|0;f[j>>2]=kg;f[e>>2]=f[j>>2];oo=Twa(N,e,h,i,qo)|0;if(!(f[oo>>2]|0)){io=L5b(28)|0;gq=f[qo>>2]|0;f[io+16>>2]=gq;f[io+20>>2]=f[ro+20>>2];if(gq|0){qo=gq+-4|0;f[qo>>2]=(f[qo>>2]|0)+1}f[io+24>>2]=f[ro+24>>2];qo=f[h>>2]|0;f[io>>2]=0;f[io+4>>2]=0;f[io+8>>2]=qo;f[oo>>2]=io;qo=f[f[N>>2]>>2]|0;if(!qo)jr=io;else{f[N>>2]=qo;jr=f[oo>>2]|0}mP(f[Qf>>2]|0,jr);f[Rf>>2]=(f[Rf>>2]|0)+1}oo=f[ro+4>>2]|0;do if(!oo){qo=ro+8|0;io=f[qo>>2]|0;if((f[io>>2]|0)==(ro|0)){kr=io;break}else lr=qo;do{qo=f[lr>>2]|0;lr=qo+8|0;io=f[lr>>2]|0}while((f[io>>2]|0)!=(qo|0));kr=io}else{Qp=oo;while(1){io=f[Qp>>2]|0;if(!io)break;else Qp=io}kr=Qp}while(0);if((kr|0)==(la|0))break;else ro=kr}}FFa(w,Uwa(a,q,N,2,0)|0);Wta(N,f[Sf>>2]|0);X5b(e,f[Tf>>2]|0);X5b(h,f[Uf>>2]|0);if((f[Vf>>2]|0)!=3){f[i>>2]=0;f[jg>>2]=0;lp=aD(i,38)|0;mp=370484;np=lp+38|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,i,376145,369853,1127);bD(i)}if((f[Wf>>2]|0)!=3){f[i>>2]=0;f[ig>>2]=0;lp=aD(i,37)|0;mp=370523;np=lp+37|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,i,376145,369853,1128);bD(i)}ro=b[Xf>>0]|0;if(!((ro<<24>>24<0?f[Yf>>2]|0:ro&255)|0)){f[i>>2]=0;f[Zf>>2]=0;lp=aD(i,19)|0;mp=370561;np=lp+19|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,i,376145,369853,1129);bD(i)}ro=b[_f>>0]|0;oo=f[$f>>2]|0;if(!((ro<<24>>24<0?oo:ro&255)|0)){f[i>>2]=0;f[ag>>2]=0;lp=aD(i,18)|0;mp=370581;np=lp+18|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,i,376145,369853,1130);bD(i);mr=b[_f>>0]|0;nr=f[$f>>2]|0}else{mr=ro;nr=oo}io=b[Xf>>0]|0;if(((io<<24>>24<0?f[Yf>>2]|0:io&255)|0)!=((mr<<24>>24<0?nr:mr&255)|0)){f[i>>2]=0;f[hg>>2]=0;lp=aD(i,37)|0;mp=370600;np=lp+37|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,i,376145,369853,1131);bD(i)}f[i>>2]=0;f[bg>>2]=0;oo=aD(i,5)|0;b[oo>>0]=b[426569]|0;b[oo+1>>0]=b[426570]|0;b[oo+2>>0]=b[426571]|0;b[oo+3>>0]=b[426572]|0;b[oo+4>>0]=b[426573]|0;oo=b[Xf>>0]|0;ro=oo<<24>>24<0;io=ro?f[e>>2]|0:e;qo=ro?f[Yf>>2]|0:oo&255;oo=qo>>>2;ro=L5b(16)|0;gq=ro+8|0;f[ro>>2]=gq;f[ro+4>>2]=oo;if(qo>>>0<=7){f[j>>2]=0;f[cg>>2]=ro;if(oo|0){or=gq;lo=771}}else{gq=N5b(oo>>>0>536870911?-1:oo<<3)|0;f[ro>>2]=gq;f[j>>2]=0;f[cg>>2]=ro;or=gq;lo=771}if((lo|0)==771){lo=0;gq=io;io=0;while(1){ro=f[gq>>2]|0;qo=or+(io<<3)|0;f[qo>>2]=ro;f[qo+4>>2]=((ro|0)<0)<<31>>31;io=io+1|0;if((io|0)==(oo|0))break;else gq=gq+4|0}}nxa(t,i,j)|0;gua(j);bD(i);f[i>>2]=0;f[dg>>2]=0;gq=aD(i,4)|0;b[gq>>0]=115;b[gq+1>>0]=105;b[gq+2>>0]=122;b[gq+3>>0]=101;gq=b[_f>>0]|0;oo=gq<<24>>24<0;io=oo?f[h>>2]|0:h;ro=oo?f[$f>>2]|0:gq&255;gq=ro>>>2;oo=L5b(16)|0;qo=oo+8|0;f[oo>>2]=qo;f[oo+4>>2]=gq;if(ro>>>0<=7){f[j>>2]=0;f[eg>>2]=oo;if(gq|0){pr=qo;lo=776}}else{qo=N5b(gq>>>0>536870911?-1:gq<<3)|0;f[oo>>2]=qo;f[j>>2]=0;f[eg>>2]=oo;pr=qo;lo=776}if((lo|0)==776){lo=0;qo=io;io=0;while(1){oo=f[qo>>2]|0;ro=pr+(io<<3)|0;f[ro>>2]=oo;f[ro+4>>2]=((oo|0)<0)<<31>>31;io=io+1|0;if((io|0)==(gq|0))break;else qo=qo+4|0}}nxa(t,i,j)|0;gua(j);bD(i);f[i>>2]=0;f[fg>>2]=0;qo=aD(i,5)|0;b[qo>>0]=b[410749]|0;b[qo+1>>0]=b[410750]|0;b[qo+2>>0]=b[410751]|0;b[qo+3>>0]=b[410752]|0;b[qo+4>>0]=b[410753]|0;qo=lva(c,r,i,t)|0;bD(i);gq=cua(o,r)|0;f[gq>>2]=qo;hxa(i,f[(f[Da>>2]|0)+4>>2]|0);ixa(o,c,i,qo,0);if((b[gg>>0]|0)<0)O5b(f[i>>2]|0);if((b[_f>>0]|0)<0)O5b(f[h>>2]|0);if((b[Xf>>0]|0)<0)O5b(f[e>>2]|0);WEa(w);WEa(v);break c}while(0);if((f[Ca>>2]|0)!=2){f[e>>2]=0;f[Mf>>2]=0;lp=aD(e,23)|0;mp=370244;np=lp+23|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,1103);bD(e)}f[Ff>>2]=0;f[Gf>>2]=0;f[L>>2]=Hf;qo=f[m>>2]|0;if((qo|0)!=(la|0)){gq=qo;while(1){qo=gq+16|0;f[j>>2]=Lf;f[e>>2]=f[j>>2];io=Twa(L,e,h,i,qo)|0;if(!(f[io>>2]|0)){oo=L5b(28)|0;ro=f[qo>>2]|0;f[oo+16>>2]=ro;f[oo+20>>2]=f[gq+20>>2];if(ro|0){qo=ro+-4|0;f[qo>>2]=(f[qo>>2]|0)+1}f[oo+24>>2]=f[gq+24>>2];qo=f[h>>2]|0;f[oo>>2]=0;f[oo+4>>2]=0;f[oo+8>>2]=qo;f[io>>2]=oo;qo=f[f[L>>2]>>2]|0;if(!qo)qr=oo;else{f[L>>2]=qo;qr=f[io>>2]|0}mP(f[Ff>>2]|0,qr);f[Gf>>2]=(f[Gf>>2]|0)+1}io=f[gq+4>>2]|0;do if(!io){qo=gq+8|0;oo=f[qo>>2]|0;if((f[oo>>2]|0)==(gq|0)){rr=oo;break}else sr=qo;do{qo=f[sr>>2]|0;sr=qo+8|0;oo=f[sr>>2]|0}while((f[oo>>2]|0)!=(qo|0));rr=oo}else{oo=io;while(1){qo=f[oo>>2]|0;if(!qo)break;else oo=qo}rr=oo}while(0);if((rr|0)==(la|0))break;else gq=rr}}gq=(Uwa(a,q,L,0,0)|0)+64|0;io=f[(f[gq>>2]|0)+4>>2]|0;Wta(L,f[Hf>>2]|0);f[e>>2]=0;f[If>>2]=0;gq=aD(e,4)|0;b[gq>>0]=97;b[gq+1>>0]=120;b[gq+2>>0]=105;b[gq+3>>0]=115;Wwa(t,e,106048+(io<<2)|0)|0;bD(e);f[e>>2]=0;f[Jf>>2]=0;io=aD(e,5)|0;b[io>>0]=b[410749]|0;b[io+1>>0]=b[410750]|0;b[io+2>>0]=b[410751]|0;b[io+3>>0]=b[410752]|0;b[io+4>>0]=b[410753]|0;io=lva(c,r,e,t)|0;bD(e);gq=cua(o,r)|0;f[gq>>2]=io;hxa(e,f[(f[Da>>2]|0)+8>>2]|0);ixa(o,c,e,io,0);if((b[Kf>>0]|0)<0)O5b(f[e>>2]|0);break c}while(0);f[e>>2]=0;f[Cf>>2]=0;f[Df>>2]=0;io=L5b(8)|0;f[e>>2]=io;gq=io+8|0;f[Ef>>2]=gq;qo=io;f[qo>>2]=0;f[qo+4>>2]=0;f[Cf>>2]=gq;bD(io);gq=f[r>>2]|0;if(!gq)tr=0;else{qo=gq+-4|0;f[qo>>2]=(f[qo>>2]|0)+1;tr=f[r>>2]|0}f[io>>2]=tr;f[io+4>>2]=f[va>>2];io=cua(o,r)|0;f[io>>2]=0;Dwa(c,e);io=f[e>>2]|0;if(io|0){while(1){qo=f[Cf>>2]|0;if((qo|0)==(io|0))break;gq=qo+-8|0;f[Cf>>2]=gq;bD(gq)}O5b(f[e>>2]|0)}break c}while(0);f[e>>2]=0;f[zf>>2]=0;io=aD(e,4)|0;b[io>>0]=112;b[io+1>>0]=111;b[io+2>>0]=111;b[io+3>>0]=108;lxa(t,e,442374)|0;bD(e);oxa(t,q);dxa(t,q);exa(t,q);f[e>>2]=0;f[Af>>2]=0;io=aD(e,7)|0;b[io>>0]=b[411904]|0;b[io+1>>0]=b[411905]|0;b[io+2>>0]=b[411906]|0;b[io+3>>0]=b[411907]|0;b[io+4>>0]=b[411908]|0;b[io+5>>0]=b[411909]|0;b[io+6>>0]=b[411910]|0;io=lva(c,r,e,t)|0;bD(e);gq=cua(o,r)|0;f[gq>>2]=io;hxa(e,f[(f[Da>>2]|0)+4>>2]|0);gq=f[Ca>>2]|0;if((gq|0)>0){qo=0;do{ixa(o,c,e,io,qo);qo=qo+1|0}while((qo|0)!=(gq|0))}if((b[Bf>>0]|0)<0)O5b(f[e>>2]|0);break c}while(0);f[e>>2]=0;f[wf>>2]=0;gq=aD(e,4)|0;b[gq>>0]=112;b[gq+1>>0]=111;b[gq+2>>0]=111;b[gq+3>>0]=108;lxa(t,e,442370)|0;bD(e);oxa(t,q);dxa(t,q);exa(t,q);f[e>>2]=0;f[xf>>2]=0;gq=aD(e,7)|0;b[gq>>0]=b[411904]|0;b[gq+1>>0]=b[411905]|0;b[gq+2>>0]=b[411906]|0;b[gq+3>>0]=b[411907]|0;b[gq+4>>0]=b[411908]|0;b[gq+5>>0]=b[411909]|0;b[gq+6>>0]=b[411910]|0;gq=lva(c,r,e,t)|0;bD(e);qo=cua(o,r)|0;f[qo>>2]=gq;hxa(e,f[(f[Da>>2]|0)+4>>2]|0);qo=f[Ca>>2]|0;if((qo|0)>0){io=0;do{ixa(o,c,e,gq,io);io=io+1|0}while((io|0)!=(qo|0))}if((b[yf>>0]|0)<0)O5b(f[e>>2]|0);break c}while(0);if(!(gTb(xo,411848)|0)){wo=0;break}wo=(f[Ca>>2]|0)+-1|0}while(0);f[hf>>2]=0;f[jf>>2]=0;f[K>>2]=kf;qo=f[m>>2]|0;if((qo|0)!=(la|0)){io=qo;while(1){qo=io+16|0;f[j>>2]=vf;f[e>>2]=f[j>>2];gq=Twa(K,e,h,i,qo)|0;if(!(f[gq>>2]|0)){ro=L5b(28)|0;Go=f[qo>>2]|0;f[ro+16>>2]=Go;f[ro+20>>2]=f[io+20>>2];if(Go|0){qo=Go+-4|0;f[qo>>2]=(f[qo>>2]|0)+1}f[ro+24>>2]=f[io+24>>2];qo=f[h>>2]|0;f[ro>>2]=0;f[ro+4>>2]=0;f[ro+8>>2]=qo;f[gq>>2]=ro;qo=f[f[K>>2]>>2]|0;if(!qo)ur=ro;else{f[K>>2]=qo;ur=f[gq>>2]|0}mP(f[hf>>2]|0,ur);f[jf>>2]=(f[jf>>2]|0)+1}gq=f[io+4>>2]|0;do if(!gq){qo=io+8|0;ro=f[qo>>2]|0;if((f[ro>>2]|0)==(io|0)){vr=ro;break}else wr=qo;do{qo=f[wr>>2]|0;wr=qo+8|0;ro=f[wr>>2]|0}while((f[ro>>2]|0)!=(qo|0));vr=ro}else{ro=gq;while(1){qo=f[ro>>2]|0;if(!qo)break;else ro=qo}vr=ro}while(0);if((vr|0)==(la|0))break;else io=vr}}io=(Uwa(a,q,K,wo,0)|0)+64|0;gq=f[(f[io>>2]|0)+4>>2]|0;Wta(K,f[kf>>2]|0);f[v>>2]=gq;f[e>>2]=0;f[lf>>2]=0;gq=aD(e,4)|0;b[gq>>0]=97;b[gq+1>>0]=120;b[gq+2>>0]=105;b[gq+3>>0]=115;gq=f[v>>2]|0;Wwa(t,e,gq>>>0<4?106048+(gq<<2)|0:v)|0;bD(e);f[e>>2]=0;f[mf>>2]=0;gq=aD(e,6)|0;b[gq>>0]=b[411848]|0;b[gq+1>>0]=b[411849]|0;b[gq+2>>0]=b[411850]|0;b[gq+3>>0]=b[411851]|0;b[gq+4>>0]=b[411852]|0;b[gq+5>>0]=b[411853]|0;gq=lva(c,r,e,t)|0;bD(e);io=cua(o,r)|0;f[io>>2]=gq;io=f[s>>2]|0;do if((io|0)==411848){xr=1;lo=657}else{qo=(gTb((io|0)==0?1124530:io,411848)|0)==0;Go=qo&1;if(qo){xr=Go;lo=657;break}yr=Go;zr=(f[Ca>>2]|0)+-1|0}while(0);if((lo|0)==657){lo=0;yr=xr;zr=f[Ca>>2]|0}if((yr|0)<(zr|0)){io=yr;do{hxa(e,f[(f[Da>>2]|0)+4+(io<<2)>>2]|0);f[h>>2]=0;f[nf>>2]=0;Go=b[of>>0]|0;qo=Go<<24>>24<0?f[pf>>2]|0:Go&255;if(qo|0){Go=aD(h,qo)|0;Vac(Go|0,((b[of>>0]|0)<0?f[e>>2]|0:e)|0,qo|0)|0}qo=f[ea>>2]|0;do if(qo){Go=f[h>>2]|0;kp=(Go|0)==0?1124530:Go;Lq=ea;Mq=qo;r:while(1){Zq=Mq;while(1){Ar=f[Zq+16>>2]|0;if((Ar|0)==(Go|0))break;if((gTb((Ar|0)==0?1124530:Ar,kp)|0)>=0)break;Ar=f[Zq+4>>2]|0;if(!Ar){Br=Lq;break r}else Zq=Ar}Mq=f[Zq>>2]|0;if(!Mq){Br=Zq;break}else Lq=Zq}if((Br|0)==(ea|0)){lo=673;break}Lq=f[Br+16>>2]|0;if((Go|0)==(Lq|0)){Cr=Br;break}if((gTb(kp,(Lq|0)==0?1124530:Lq)|0)>=0)Cr=Br;else lo=673}else lo=673;while(0);if((lo|0)==673){lo=0;Cr=ea}bD(h);if((Cr|0)==(ea|0)){dua(i,370213,e);f[h>>2]=0;f[qf>>2]=0;qo=b[rf>>0]|0;Lq=qo<<24>>24<0?f[sf>>2]|0:qo&255;if(Lq|0){qo=aD(h,Lq)|0;Vac(qo|0,((b[rf>>0]|0)<0?f[i>>2]|0:i)|0,Lq|0)|0}bO(-2,h,376145,369853,1061);bD(h);if((b[rf>>0]|0)<0)O5b(f[i>>2]|0)}f[h>>2]=0;f[tf>>2]=0;Lq=b[of>>0]|0;qo=Lq<<24>>24<0?f[pf>>2]|0:Lq&255;if(qo|0){Lq=aD(h,qo)|0;Vac(Lq|0,((b[of>>0]|0)<0?f[e>>2]|0:e)|0,qo|0)|0}qo=mxa(o,h)|0;tva(c,f[qo>>2]|0,f[uf>>2]|0,gq,io-yr|0);bD(h);if((b[of>>0]|0)<0)O5b(f[e>>2]|0);io=io+1|0}while((io|0)<(zr|0))}break c}while(0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Ke>>0]=5;b[e>>0]=b[412511]|0;b[e+1>>0]=b[412512]|0;b[e+2>>0]=b[412513]|0;b[e+3>>0]=b[412514]|0;b[e+4>>0]=b[412515]|0;b[Le>>0]=0;po=jxa(q,e)|0;if((b[Ke>>0]|0)<0)O5b(f[e>>2]|0);if(po){f[e>>2]=0;f[Me>>2]=0;po=aD(e,5)|0;b[po>>0]=b[412511]|0;b[po+1>>0]=b[412512]|0;b[po+2>>0]=b[412513]|0;b[po+3>>0]=b[412514]|0;b[po+4>>0]=b[412515]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[Ne>>0]=5;b[i>>0]=b[412511]|0;b[i+1>>0]=b[412512]|0;b[i+2>>0]=b[412513]|0;b[i+3>>0]=b[412514]|0;b[i+4>>0]=b[412515]|0;b[Oe>>0]=0;tKb(_b);po=kxa(f[$b>>2]|0,i)|0;n[h>>2]=(f[po+20>>2]|0)==4?+n[po+8>>2]:0.0;Zwa(t,e,h)|0;if((b[Ne>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[Pe>>0]=4;f[e>>2]=1635018082;b[Qe>>0]=0;po=jxa(q,e)|0;if((b[Pe>>0]|0)<0)O5b(f[e>>2]|0);if(po){f[e>>2]=0;f[Re>>2]=0;po=aD(e,4)|0;b[po>>0]=98;b[po+1>>0]=101;b[po+2>>0]=116;b[po+3>>0]=97;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[Se>>0]=4;f[i>>2]=1635018082;b[Te>>0]=0;tKb(_b);po=kxa(f[$b>>2]|0,i)|0;n[h>>2]=(f[po+20>>2]|0)==4?+n[po+8>>2]:0.0;Zwa(t,e,h)|0;if((b[Se>>0]|0)<0)O5b(f[i>>2]|0);bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;po=L5b(16)|0;f[e>>2]=po;f[Ue>>2]=-2147483632;f[Ve>>2]=12;lp=po;mp=370434;np=lp+12|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[po+12>>0]=0;io=jxa(q,e)|0;if((b[We>>0]|0)<0)O5b(f[e>>2]|0);if(io){f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;io=L5b(16)|0;f[e>>2]=io;f[Xe>>2]=-2147483632;f[Ye>>2]=12;lp=io;mp=370434;np=lp+12|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[io+12>>0]=0;tKb(_b);po=kxa(f[$b>>2]|0,e)|0;gq=(f[po+20>>2]|0)==3;qo=f[po+8>>2]|0;if((b[Ze>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[_e>>2]=0;lp=aD(e,10)|0;mp=412441;np=lp+10|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));f[h>>2]=gq?qo<<1|1:1;Wwa(t,e,h)|0;bD(e)};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;b[$e>>0]=4;f[e>>2]=1935763810;b[af>>0]=0;io=jxa(q,e)|0;if((b[$e>>0]|0)<0)O5b(f[e>>2]|0);if(io){f[e>>2]=0;f[bf>>2]=0;io=aD(e,4)|0;b[io>>0]=98;b[io+1>>0]=105;b[io+2>>0]=97;b[io+3>>0]=115;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;b[cf>>0]=4;f[i>>2]=1935763810;b[df>>0]=0;tKb(_b);io=kxa(f[$b>>2]|0,i)|0;n[h>>2]=(f[io+20>>2]|0)==4?+n[io+8>>2]:0.0;Zwa(t,e,h)|0;if((b[cf>>0]|0)<0)O5b(f[i>>2]|0);bD(e)}f[e>>2]=0;f[ef>>2]=0;lp=aD(e,12)|0;mp=412517;np=lp+12|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[h>>0]=0;$wa(t,e,h)|0;bD(e);f[e>>2]=0;f[ff>>2]=0;qo=aD(e,3)|0;b[qo>>0]=b[410837]|0;b[qo+1>>0]=b[410838]|0;b[qo+2>>0]=b[410839]|0;qo=lva(c,r,e,t)|0;bD(e);gq=cua(o,r)|0;f[gq>>2]=qo;hxa(e,f[(f[Da>>2]|0)+4>>2]|0);gq=f[Ca>>2]|0;if((gq|0)>0){io=0;do{ixa(o,c,e,qo,io);io=io+1|0}while((io|0)!=(gq|0))}if((b[gf>>0]|0)<0)O5b(f[e>>2]|0);break c}while(0);f[ne>>2]=0;f[oe>>2]=0;f[J>>2]=pe;no=f[m>>2]|0;if((no|0)!=(la|0)){mo=no;while(1){no=mo+16|0;f[j>>2]=Je;f[e>>2]=f[j>>2];gq=Twa(J,e,h,i,no)|0;if(!(f[gq>>2]|0)){io=L5b(28)|0;qo=f[no>>2]|0;f[io+16>>2]=qo;f[io+20>>2]=f[mo+20>>2];if(qo|0){no=qo+-4|0;f[no>>2]=(f[no>>2]|0)+1}f[io+24>>2]=f[mo+24>>2];no=f[h>>2]|0;f[io>>2]=0;f[io+4>>2]=0;f[io+8>>2]=no;f[gq>>2]=io;no=f[f[J>>2]>>2]|0;if(!no)Dr=io;else{f[J>>2]=no;Dr=f[gq>>2]|0}mP(f[ne>>2]|0,Dr);f[oe>>2]=(f[oe>>2]|0)+1}gq=f[mo+4>>2]|0;do if(!gq){no=mo+8|0;io=f[no>>2]|0;if((f[io>>2]|0)==(mo|0)){Er=io;break}else Fr=no;do{no=f[Fr>>2]|0;Fr=no+8|0;io=f[Fr>>2]|0}while((f[io>>2]|0)!=(no|0));Er=io}else{io=gq;while(1){no=f[io>>2]|0;if(!no)break;else io=no}Er=io}while(0);if((Er|0)==(la|0))break;else mo=Er}}Ywa(v,Uwa(a,q,J,1,0)|0);Wta(J,f[pe>>2]|0);if((f[v>>2]&4095|0)!=4){f[e>>2]=0;f[Ie>>2]=0;lp=aD(e,56)|0;mp=370326;np=lp+56|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,962);bD(e)}mo=f[qe>>2]|0;gq=f[re>>2]|0;if((gq|0)<3)Gr=Y(f[te>>2]|0,f[se>>2]|0)|0;else{no=f[Be>>2]|0;qo=0;po=1;while(1){Lq=Y(f[no+(qo<<2)>>2]|0,po)|0;qo=qo+1|0;if((qo|0)==(gq|0)){Gr=Lq;break}else po=Lq}}if((Gr|0)==4){po=f[(f[Da>>2]|0)+4>>2]|0;f[e>>2]=0;f[ue>>2]=0;gq=po+11|0;qo=b[gq>>0]|0;no=qo<<24>>24<0?f[po+4>>2]|0:qo&255;if(no|0){qo=aD(e,no)|0;Vac(qo|0,((b[gq>>0]|0)<0?f[po>>2]|0:po)|0,no|0)|0}no=cua(l,e)|0;po=f[no>>2]|0;bD(e);s:do if(!po){t:do if(!(f[mo>>2]|0))switch(f[mo+4>>2]|0){case 3:{if((f[mo+8>>2]|0)!=1)break t;if((f[mo+12>>2]|0)!=2)break t;no=cua(l,r)|0;f[no>>2]=1;break s;break}case 1:{if((f[mo+8>>2]|0)!=2)break t;if((f[mo+12>>2]|0)!=3)break t;no=cua(l,r)|0;f[no>>2]=0;break s;break}default:break t}while(0);f[e>>2]=0;f[ve>>2]=0;lp=aD(e,44)|0;mp=370383;np=lp+44|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-212,e,376145,369853,983);bD(e)}else{no=f[(f[Da>>2]|0)+4>>2]|0;f[e>>2]=0;f[ye>>2]=0;gq=no+11|0;qo=b[gq>>0]|0;Lq=qo<<24>>24<0?f[no+4>>2]|0:qo&255;if(Lq|0){qo=aD(e,Lq)|0;Vac(qo|0,((b[gq>>0]|0)<0?f[no>>2]|0:no)|0,Lq|0)|0}Lq=cua(l,e)|0;no=f[Lq>>2]|0;bD(e);if((no|0)!=1)break;u:do if(!(f[mo>>2]|0))switch(f[mo+4>>2]|0){case 2:{if((f[mo+8>>2]|0)!=3)break u;if((f[mo+12>>2]|0)!=1)break u;no=cua(l,r)|0;f[no>>2]=0;break s;break}case 1:{if((f[mo+8>>2]|0)!=2)break u;if((f[mo+12>>2]|0)!=3)break u;no=cua(l,r)|0;f[no>>2]=1;break s;break}default:break u}while(0);f[e>>2]=0;f[ze>>2]=0;lp=aD(e,44)|0;mp=370383;np=lp+44|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-212,e,376145,369853,1e3);bD(e)}while(0);f[e>>2]=0;f[we>>2]=0;po=aD(e,8)|0;no=po;b[no>>0]=73;b[no+1>>0]=100;b[no+2>>0]=101;b[no+3>>0]=110;no=po+4|0;b[no>>0]=116;b[no+1>>0]=105;b[no+2>>0]=116;b[no+3>>0]=121;no=lva(c,r,e,t)|0;bD(e);po=cua(o,r)|0;f[po>>2]=no;hxa(e,f[(f[Da>>2]|0)+4>>2]|0);ixa(o,c,e,no,0);if((b[xe>>0]|0)<0)O5b(f[e>>2]|0)}else{f[e>>2]=0;f[Ee>>2]=0;no=aD(e,5)|0;b[no>>0]=b[428511]|0;b[no+1>>0]=b[428512]|0;b[no+2>>0]=b[428513]|0;b[no+3>>0]=b[428514]|0;b[no+4>>0]=b[428515]|0;no=f[re>>2]|0;if((no|0)<3)Hr=Y(f[te>>2]|0,f[se>>2]|0)|0;else{po=f[Be>>2]|0;Lq=0;gq=1;while(1){qo=Y(f[po+(Lq<<2)>>2]|0,gq)|0;Lq=Lq+1|0;if((Lq|0)==(no|0)){Hr=qo;break}else gq=qo}}gq=L5b(16)|0;no=gq+8|0;f[gq>>2]=no;f[gq+4>>2]=Hr;if(Hr>>>0>1){Lq=N5b(Hr>>>0>536870911?-1:Hr<<3)|0;f[gq>>2]=Lq;Ir=Lq}else Ir=no;f[h>>2]=0;f[Fe>>2]=gq;if((Hr|0)>0){gq=mo;no=0;while(1){Lq=f[gq>>2]|0;po=Ir+(no<<3)|0;f[po>>2]=Lq;f[po+4>>2]=((Lq|0)<0)<<31>>31;no=no+1|0;if((no|0)==(Hr|0))break;else gq=gq+4|0}}nxa(t,e,h)|0;gua(h);bD(e);f[e>>2]=0;f[Ge>>2]=0;gq=aD(e,7)|0;b[gq>>0]=b[411791]|0;b[gq+1>>0]=b[411792]|0;b[gq+2>>0]=b[411793]|0;b[gq+3>>0]=b[411794]|0;b[gq+4>>0]=b[411795]|0;b[gq+5>>0]=b[411796]|0;b[gq+6>>0]=b[411797]|0;gq=lva(c,r,e,t)|0;bD(e);no=cua(o,r)|0;f[no>>2]=gq;hxa(e,f[(f[Da>>2]|0)+4>>2]|0);ixa(o,c,e,gq,0);if((b[He>>0]|0)<0)O5b(f[e>>2]|0);gq=cua(l,r)|0;f[gq>>2]=2}gq=f[Ae>>2]|0;do if(gq|0){no=gq+12|0;mo=f[no>>2]|0;f[no>>2]=mo+-1;if((mo|0)!=1)break;kL(v)}while(0);f[Ae>>2]=0;f[qe>>2]=0;f[qe+4>>2]=0;f[qe+8>>2]=0;f[qe+12>>2]=0;if((f[re>>2]|0)>0){gq=f[Be>>2]|0;mo=0;do{f[gq+(mo<<2)>>2]=0;mo=mo+1|0}while((mo|0)<(f[re>>2]|0))}mo=f[Ce>>2]|0;if((mo|0)!=(De|0))UC(mo);break c}while(0);hxa(e,f[(f[Da>>2]|0)+4>>2]|0);mo=f[(f[Da>>2]|0)+4>>2]|0;f[h>>2]=0;f[Ud>>2]=0;gq=mo+11|0;no=b[gq>>0]|0;Lq=no<<24>>24<0?f[mo+4>>2]|0:no&255;if(Lq|0){no=aD(h,Lq)|0;Vac(no|0,((b[gq>>0]|0)<0?f[mo>>2]|0:mo)|0,Lq|0)|0}Lq=cua(l,h)|0;mo=f[Lq>>2]|0;bD(h);if(!mo){f[Vd>>2]=0;f[Wd>>2]=0;f[h>>2]=Xd;f[Yd>>2]=0;f[Yd+4>>2]=0;f[Yd+8>>2]=0;f[Yd+12>>2]=0;f[Yd+16>>2]=0;f[Yd+20>>2]=0;f[Yd+24>>2]=0;f[i>>2]=0;f[Zd>>2]=0;mo=aD(i,5)|0;b[mo>>0]=b[428511]|0;b[mo+1>>0]=b[428512]|0;b[mo+2>>0]=b[428513]|0;b[mo+3>>0]=b[428514]|0;b[mo+4>>0]=b[428515]|0;mo=L5b(16)|0;f[mo>>2]=mo+8;f[mo+4>>2]=4;Lq=N5b(32)|0;f[mo>>2]=Lq;f[j>>2]=0;f[_d>>2]=mo;mo=Lq;f[mo>>2]=0;f[mo+4>>2]=0;mo=Lq+8|0;f[mo>>2]=2;f[mo+4>>2]=0;mo=Lq+16|0;f[mo>>2]=3;f[mo+4>>2]=0;mo=Lq+24|0;f[mo>>2]=1;f[mo+4>>2]=0;nxa(h,i,j)|0;gua(j);bD(i);f[I>>2]=0;f[$d>>2]=0;aD(I,(f[va>>2]|0)+5|0)|0;mo=f[va>>2]|0;if(!mo)Jr=0;else{Vac(f[I>>2]|0,f[r>>2]|0,mo|0)|0;Jr=f[va>>2]|0}mo=(f[I>>2]|0)+Jr|0;b[mo>>0]=b[370268]|0;b[mo+1>>0]=b[370269]|0;b[mo+2>>0]=b[370270]|0;b[mo+3>>0]=b[370271]|0;b[mo+4>>0]=b[370272]|0;mo=f[I>>2]|0;Lq=f[$d>>2]|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(Lq>>>0>4294967279){lo=502;break a}if(Lq>>>0<11){b[ae>>0]=Lq;if(!Lq)Kr=i;else{Lr=i;lo=506}}else{gq=Lq+16&-16;no=L5b(gq)|0;f[i>>2]=no;f[ke>>2]=gq|-2147483648;f[ce>>2]=Lq;Lr=no;lo=506}if((lo|0)==506){lo=0;Vac(Lr|0,mo|0,Lq|0)|0;Kr=Lr}b[Kr+Lq>>0]=0;bD(I);f[j>>2]=0;f[be>>2]=0;Lq=b[ae>>0]|0;mo=Lq<<24>>24<0?f[ce>>2]|0:Lq&255;if(mo|0){Lq=aD(j,mo)|0;Vac(Lq|0,((b[ae>>0]|0)<0?f[i>>2]|0:i)|0,mo|0)|0}mo=f[ea>>2]|0;do if(mo){Lq=f[j>>2]|0;no=(Lq|0)==0?1124530:Lq;gq=ea;po=mo;v:while(1){qo=po;while(1){Mq=f[qo+16>>2]|0;if((Mq|0)==(Lq|0))break;if((gTb((Mq|0)==0?1124530:Mq,no)|0)>=0)break;Mq=f[qo+4>>2]|0;if(!Mq){Mr=gq;break v}else qo=Mq}po=f[qo>>2]|0;if(!po){Mr=qo;break}else gq=qo}if((Mr|0)==(ea|0)){lo=519;break}gq=f[Mr+16>>2]|0;if((Lq|0)==(gq|0)){Nr=Mr;break}if((gTb(no,(gq|0)==0?1124530:gq)|0)>=0)Nr=Mr;else lo=519}else lo=519;while(0);if((lo|0)==519){lo=0;Nr=ea}bD(j);if((Nr|0)!=(ea|0)){f[j>>2]=0;f[je>>2]=0;lp=aD(j,41)|0;mp=370274;np=lp+41|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,j,376145,369853,948);bD(j)}f[j>>2]=0;f[de>>2]=0;mo=b[ae>>0]|0;gq=mo<<24>>24<0?f[ce>>2]|0:mo&255;if(gq|0){mo=aD(j,gq)|0;Vac(mo|0,((b[ae>>0]|0)<0?f[i>>2]|0:i)|0,gq|0)|0}f[v>>2]=0;f[ee>>2]=0;gq=aD(v,7)|0;b[gq>>0]=b[411791]|0;b[gq+1>>0]=b[411792]|0;b[gq+2>>0]=b[411793]|0;b[gq+3>>0]=b[411794]|0;b[gq+4>>0]=b[411795]|0;b[gq+5>>0]=b[411796]|0;b[gq+6>>0]=b[411797]|0;gq=lva(c,j,v,h)|0;bD(v);bD(j);f[j>>2]=0;f[fe>>2]=0;mo=b[ae>>0]|0;po=mo<<24>>24<0?f[ce>>2]|0:mo&255;if(po|0){mo=aD(j,po)|0;Vac(mo|0,((b[ae>>0]|0)<0?f[i>>2]|0:i)|0,po|0)|0}po=cua(o,j)|0;f[po>>2]=gq;bD(j);ixa(o,c,e,gq,0);X5b(j,i);f[ge>>2]=0;_5b(e,j)|0;f[he>>2]=f[ge>>2];if((b[ie>>0]|0)<0)O5b(f[j>>2]|0);if((b[ae>>0]|0)<0)O5b(f[i>>2]|0);fua(h)}f[h>>2]=0;f[le>>2]=0;gq=aD(h,7)|0;b[gq>>0]=b[410769]|0;b[gq+1>>0]=b[410770]|0;b[gq+2>>0]=b[410771]|0;b[gq+3>>0]=b[410772]|0;b[gq+4>>0]=b[410773]|0;b[gq+5>>0]=b[410774]|0;b[gq+6>>0]=b[410775]|0;gq=lva(c,r,h,t)|0;bD(h);po=cua(o,r)|0;f[po>>2]=gq;ixa(o,c,e,gq,0);gq=cua(l,r)|0;f[gq>>2]=2;if((b[me>>0]|0)<0)O5b(f[e>>2]|0);break c}while(0);hxa(v,f[(f[Da>>2]|0)+4>>2]|0);f[rd>>2]=0;f[sd>>2]=0;f[G>>2]=td;fo=f[m>>2]|0;if((fo|0)!=(la|0)){go=fo;while(1){fo=go+16|0;f[j>>2]=Td;f[e>>2]=f[j>>2];gq=Twa(G,e,h,i,fo)|0;if(!(f[gq>>2]|0)){po=L5b(28)|0;mo=f[fo>>2]|0;f[po+16>>2]=mo;f[po+20>>2]=f[go+20>>2];if(mo|0){fo=mo+-4|0;f[fo>>2]=(f[fo>>2]|0)+1}f[po+24>>2]=f[go+24>>2];fo=f[h>>2]|0;f[po>>2]=0;f[po+4>>2]=0;f[po+8>>2]=fo;f[gq>>2]=po;fo=f[f[G>>2]>>2]|0;if(!fo)Or=po;else{f[G>>2]=fo;Or=f[gq>>2]|0}mP(f[rd>>2]|0,Or);f[sd>>2]=(f[sd>>2]|0)+1}gq=f[go+4>>2]|0;do if(!gq){fo=go+8|0;po=f[fo>>2]|0;if((f[po>>2]|0)==(go|0)){Pr=po;break}else Qr=fo;do{fo=f[Qr>>2]|0;Qr=fo+8|0;po=f[Qr>>2]|0}while((f[po>>2]|0)!=(fo|0));Pr=po}else{no=gq;while(1){Lq=f[no>>2]|0;if(!Lq)break;else no=Lq}Pr=no}while(0);if((Pr|0)==(la|0))break;else go=Pr}}Vwa(w,Uwa(a,q,G,1,0)|0);Wta(G,f[td>>2]|0);switch(f[w>>2]|0){case 0:{Rr=(f[Rd>>2]|0)+4|0;lo=455;break}case 3:{Rr=(f[Sd>>2]|0)+4|0;lo=455;break}case 2:{Rr=(f[Sd>>2]|0)+4|0;lo=455;break}default:{f[e>>2]=0;f[ud>>2]=0;bO(-3,e,429353,429358,272);bD(e);lo=456}}if((lo|0)==455?(lo=0,(f[Rr>>2]|0)!=4):0)lo=456;do if((lo|0)==456){lo=0;go=f[(f[Da>>2]|0)+4>>2]|0;f[e>>2]=0;f[vd>>2]=0;gq=go+11|0;Lq=b[gq>>0]|0;po=Lq<<24>>24<0?f[go+4>>2]|0:Lq&255;if(po|0){Lq=aD(e,po)|0;Vac(Lq|0,((b[gq>>0]|0)<0?f[go>>2]|0:go)|0,po|0)|0}po=cua(l,e)|0;go=f[po>>2]|0;bD(e);if(go|0)break;f[wd>>2]=0;f[xd>>2]=0;f[e>>2]=yd;f[zd>>2]=0;f[zd+4>>2]=0;f[zd+8>>2]=0;f[zd+12>>2]=0;f[zd+16>>2]=0;f[zd+20>>2]=0;f[zd+24>>2]=0;f[h>>2]=0;f[Ad>>2]=0;go=aD(h,5)|0;b[go>>0]=b[428511]|0;b[go+1>>0]=b[428512]|0;b[go+2>>0]=b[428513]|0;b[go+3>>0]=b[428514]|0;b[go+4>>0]=b[428515]|0;go=L5b(16)|0;f[go>>2]=go+8;f[go+4>>2]=4;po=N5b(32)|0;f[go>>2]=po;f[i>>2]=0;f[Bd>>2]=go;go=po;f[go>>2]=0;f[go+4>>2]=0;go=po+8|0;f[go>>2]=2;f[go+4>>2]=0;go=po+16|0;f[go>>2]=3;f[go+4>>2]=0;go=po+24|0;f[go>>2]=1;f[go+4>>2]=0;nxa(e,h,i)|0;gua(i);bD(h);f[H>>2]=0;f[Cd>>2]=0;aD(H,(f[va>>2]|0)+5|0)|0;go=f[va>>2]|0;if(!go)Sr=0;else{Vac(f[H>>2]|0,f[r>>2]|0,go|0)|0;Sr=f[va>>2]|0}go=(f[H>>2]|0)+Sr|0;b[go>>0]=b[370268]|0;b[go+1>>0]=b[370269]|0;b[go+2>>0]=b[370270]|0;b[go+3>>0]=b[370271]|0;b[go+4>>0]=b[370272]|0;go=f[H>>2]|0;po=f[Cd>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(po>>>0>4294967279){lo=462;break a}if(po>>>0<11){b[Dd>>0]=po;if(!po)Tr=h;else{Ur=h;lo=466}}else{gq=po+16&-16;Lq=L5b(gq)|0;f[h>>2]=Lq;f[Nd>>2]=gq|-2147483648;f[Fd>>2]=po;Ur=Lq;lo=466}if((lo|0)==466){lo=0;Vac(Ur|0,go|0,po|0)|0;Tr=Ur}b[Tr+po>>0]=0;bD(H);f[i>>2]=0;f[Ed>>2]=0;po=b[Dd>>0]|0;go=po<<24>>24<0?f[Fd>>2]|0:po&255;if(go|0){po=aD(i,go)|0;Vac(po|0,((b[Dd>>0]|0)<0?f[h>>2]|0:h)|0,go|0)|0}go=f[ea>>2]|0;do if(go){po=f[i>>2]|0;Lq=(po|0)==0?1124530:po;gq=ea;fo=go;w:while(1){mo=fo;while(1){Mq=f[mo+16>>2]|0;if((Mq|0)==(po|0))break;if((gTb((Mq|0)==0?1124530:Mq,Lq)|0)>=0)break;Mq=f[mo+4>>2]|0;if(!Mq){Vr=gq;break w}else mo=Mq}fo=f[mo>>2]|0;if(!fo){Vr=mo;break}else gq=mo}if((Vr|0)==(ea|0)){lo=479;break}gq=f[Vr+16>>2]|0;if((po|0)==(gq|0)){Wr=Vr;break}if((gTb(Lq,(gq|0)==0?1124530:gq)|0)>=0)Wr=Vr;else lo=479}else lo=479;while(0);if((lo|0)==479){lo=0;Wr=ea}bD(i);if((Wr|0)!=(ea|0)){f[i>>2]=0;f[Md>>2]=0;lp=aD(i,41)|0;mp=370274;np=lp+41|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,i,376145,369853,923);bD(i)}f[i>>2]=0;f[Gd>>2]=0;go=b[Dd>>0]|0;gq=go<<24>>24<0?f[Fd>>2]|0:go&255;if(gq|0){go=aD(i,gq)|0;Vac(go|0,((b[Dd>>0]|0)<0?f[h>>2]|0:h)|0,gq|0)|0}f[j>>2]=0;f[Hd>>2]=0;gq=aD(j,7)|0;b[gq>>0]=b[411791]|0;b[gq+1>>0]=b[411792]|0;b[gq+2>>0]=b[411793]|0;b[gq+3>>0]=b[411794]|0;b[gq+4>>0]=b[411795]|0;b[gq+5>>0]=b[411796]|0;b[gq+6>>0]=b[411797]|0;gq=lva(c,i,j,e)|0;bD(j);bD(i);f[i>>2]=0;f[Id>>2]=0;go=b[Dd>>0]|0;fo=go<<24>>24<0?f[Fd>>2]|0:go&255;if(fo|0){go=aD(i,fo)|0;Vac(go|0,((b[Dd>>0]|0)<0?f[h>>2]|0:h)|0,fo|0)|0}fo=cua(o,i)|0;f[fo>>2]=gq;bD(i);ixa(o,c,v,gq,0);X5b(i,h);f[Jd>>2]=0;_5b(v,i)|0;f[Kd>>2]=f[Jd>>2];if((b[Ld>>0]|0)<0)O5b(f[i>>2]|0);if((b[Dd>>0]|0)<0)O5b(f[h>>2]|0);fua(e)}while(0);f[e>>2]=0;f[Od>>2]=0;gq=aD(e,3)|0;b[gq>>0]=b[429349]|0;b[gq+1>>0]=b[429350]|0;b[gq+2>>0]=b[429351]|0;nxa(t,e,w)|0;bD(e);f[e>>2]=0;f[Pd>>2]=0;gq=aD(e,7)|0;b[gq>>0]=b[410761]|0;b[gq+1>>0]=b[410762]|0;b[gq+2>>0]=b[410763]|0;b[gq+3>>0]=b[410764]|0;b[gq+4>>0]=b[410765]|0;b[gq+5>>0]=b[410766]|0;b[gq+6>>0]=b[410767]|0;gq=lva(c,r,e,t)|0;bD(e);fo=cua(o,r)|0;f[fo>>2]=gq;ixa(o,c,v,gq,0);gq=cua(l,r)|0;f[gq>>2]=2;gua(w);if((b[Qd>>0]|0)<0)O5b(f[v>>2]|0);break}if((f[Ca>>2]|0)!=2){f[e>>2]=0;f[qd>>2]=0;lp=aD(e,23)|0;mp=370244;np=lp+23|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,873);bD(e)}f[e>>2]=0;f[Ec>>2]=0;lp=aD(e,9)|0;mp=434144;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[h>>0]=0;$wa(t,e,h)|0;bD(e);SL(tb,1);f[e>>2]=0;f[Fc>>2]=0;gq=aD(e,7)|0;b[gq>>0]=b[370098]|0;b[gq+1>>0]=b[370099]|0;b[gq+2>>0]=b[370100]|0;b[gq+3>>0]=b[370101]|0;b[gq+4>>0]=b[370102]|0;b[gq+5>>0]=b[370103]|0;b[gq+6>>0]=b[370104]|0;_wa(v,ja,r,e);bD(e);gq=f[v>>2]|0;fo=f[Gc>>2]|0;go=fo;no=gq;if((gq|0)==(fo|0)){f[h>>2]=0;f[Hc>>2]=0;fo=aD(h,3)|0;b[fo>>0]=b[370171]|0;b[fo+1>>0]=b[370172]|0;b[fo+2>>0]=b[370173]|0;_wa(e,ja,r,h);fxa(v,f[e>>2]|0,f[Ic>>2]|0);fo=f[e>>2]|0;if(fo|0){while(1){gq=f[Ic>>2]|0;if((gq|0)==(fo|0))break;qo=gq+-12|0;f[Ic>>2]=qo;bD(qo)}O5b(f[e>>2]|0)}bD(h);Xr=f[v>>2]|0;Yr=f[Gc>>2]|0}else{Xr=no;Yr=go}do if((Yr-Xr|0)==12){f[e>>2]=0;f[Jc>>2]=0;lp=aD(e,9)|0;mp=434144;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[h>>0]=1;$wa(t,e,h)|0;bD(e);SL(tb,2);fo=f[(f[v>>2]|0)+8>>2]|0;qo=f[(f[ta>>2]|0)+4+(fo<<2)>>2]|0;f[Kc>>2]=0;f[Lc>>2]=0;f[D>>2]=Mc;gq=f[m>>2]|0;if((gq|0)!=(la|0)){Mq=gq;while(1){gq=Mq+16|0;f[j>>2]=Nc;f[e>>2]=f[j>>2];ro=Twa(D,e,h,i,gq)|0;if(!(f[ro>>2]|0)){Ar=L5b(28)|0;Zr=f[gq>>2]|0;f[Ar+16>>2]=Zr;f[Ar+20>>2]=f[Mq+20>>2];if(Zr|0){gq=Zr+-4|0;f[gq>>2]=(f[gq>>2]|0)+1}f[Ar+24>>2]=f[Mq+24>>2];gq=f[h>>2]|0;f[Ar>>2]=0;f[Ar+4>>2]=0;f[Ar+8>>2]=gq;f[ro>>2]=Ar;gq=f[f[D>>2]>>2]|0;if(!gq)_r=Ar;else{f[D>>2]=gq;_r=f[ro>>2]|0}mP(f[Kc>>2]|0,_r);f[Lc>>2]=(f[Lc>>2]|0)+1}ro=f[Mq+4>>2]|0;do if(!ro){gq=Mq+8|0;Ar=f[gq>>2]|0;if((f[Ar>>2]|0)==(Mq|0)){$r=Ar;break}else as=gq;do{gq=f[as>>2]|0;as=gq+8|0;Ar=f[as>>2]|0}while((f[Ar>>2]|0)!=(gq|0));$r=Ar}else{mo=ro;while(1){Ar=f[mo>>2]|0;if(!Ar)break;else mo=Ar}$r=mo}while(0);if(($r|0)==(la|0))break;else Mq=$r}}Mq=Uwa(a,qo,D,-1,0)|0;axa(Mq,(f[tb>>2]|0)+56|0);Wta(D,f[Mc>>2]|0);bxa(ja,fo);Mq=f[v>>2]|0;ro=f[ha>>2]|0;x:do if(!ro){bs=ha;cs=ha}else{Lq=f[Mq>>2]|0;po=(Lq|0)==0?1124530:Lq;Ar=f[ro+16>>2]|0;y:do if((Lq|0)!=(Ar|0)){gq=fa;Zr=ro;ds=Ar;while(1){es=(ds|0)==0?1124530:ds;if((gTb(po,es)|0)<0){fs=f[Zr>>2]|0;if(!fs){lo=371;break}else{gs=Zr;hs=fs}}else{if((gTb(es,po)|0)>=0){is=gq;js=Zr;break y}ks=Zr+4|0;es=f[ks>>2]|0;if(!es){lo=374;break}else{gs=ks;hs=es}}ds=f[hs+16>>2]|0;if((Lq|0)==(ds|0)){is=gs;js=hs;break y}else{gq=gs;Zr=hs}}if((lo|0)==371){lo=0;bs=Zr;cs=Zr;break x}else if((lo|0)==374){lo=0;bs=ks;cs=Zr;break x}}else{is=fa;js=ro}while(0);bs=is;cs=js}while(0);if(f[bs>>2]|0)break;ro=L5b(24)|0;fo=f[Mq>>2]|0;f[ro+16>>2]=fo;f[ro+20>>2]=f[Mq+4>>2];if(fo|0){qo=fo+-4|0;f[qo>>2]=(f[qo>>2]|0)+1}f[ro>>2]=0;f[ro+4>>2]=0;f[ro+8>>2]=cs;f[bs>>2]=ro;qo=f[f[k>>2]>>2]|0;if(!qo)ls=ro;else{f[k>>2]=qo;ls=f[bs>>2]|0}mP(f[fa>>2]|0,ls);f[ga>>2]=(f[ga>>2]|0)+1}while(0);f[w>>2]=-1;f[Oc>>2]=0;f[Pc>>2]=0;f[E>>2]=Qc;go=f[m>>2]|0;if((go|0)!=(la|0)){no=go;while(1){go=no+16|0;f[j>>2]=pd;f[e>>2]=f[j>>2];qo=Twa(E,e,h,i,go)|0;if(!(f[qo>>2]|0)){ro=L5b(28)|0;fo=f[go>>2]|0;f[ro+16>>2]=fo;f[ro+20>>2]=f[no+20>>2];if(fo|0){go=fo+-4|0;f[go>>2]=(f[go>>2]|0)+1}f[ro+24>>2]=f[no+24>>2];go=f[h>>2]|0;f[ro>>2]=0;f[ro+4>>2]=0;f[ro+8>>2]=go;f[qo>>2]=ro;go=f[f[E>>2]>>2]|0;if(!go)ms=ro;else{f[E>>2]=go;ms=f[qo>>2]|0}mP(f[Oc>>2]|0,ms);f[Pc>>2]=(f[Pc>>2]|0)+1}qo=f[no+4>>2]|0;do if(!qo){go=no+8|0;ro=f[go>>2]|0;if((f[ro>>2]|0)==(no|0)){ns=ro;break}else os=go;do{go=f[os>>2]|0;os=go+8|0;ro=f[os>>2]|0}while((f[ro>>2]|0)!=(go|0));ns=ro}else{ro=qo;while(1){go=f[ro>>2]|0;if(!go)break;else ro=go}ns=ro}while(0);if((ns|0)==(la|0))break;else no=ns}}no=Uwa(a,q,E,-1,w)|0;axa(no,f[tb>>2]|0);Wta(E,f[Qc>>2]|0);if((f[w>>2]|0)==1){NS(F,f[tb>>2]|0);f[h>>2]=1124007936;lp=Rc;np=lp+36|0;do{f[lp>>2]=0;lp=lp+4|0}while((lp|0)<(np|0));f[Tc>>2]=Sc;f[Vc>>2]=Uc;f[Uc>>2]=0;f[Wc>>2]=0;no=f[F>>2]|0;th[f[(f[no>>2]|0)+12>>2]&511](no,F,h,-1);Wi(F);f[i>>2]=1124007936;lp=Xc;np=lp+36|0;do{f[lp>>2]=0;lp=lp+4|0}while((lp|0)<(np|0));f[Zc>>2]=Yc;f[$c>>2]=_c;f[_c>>2]=0;f[ad>>2]=0;no=bd;f[no>>2]=0;f[no+4>>2]=0;f[e>>2]=33619968;f[cd>>2]=i;SP(h,e);no=f[tb>>2]|0;if((no|0)!=(i|0)){qo=f[dd>>2]|0;if(qo|0){Mq=qo+12|0;f[Mq>>2]=(f[Mq>>2]|0)+1}Mq=no+36|0;qo=f[Mq>>2]|0;do if(qo|0){go=qo+12|0;fo=f[go>>2]|0;f[go>>2]=fo+-1;if((fo|0)!=1)break;kL(no)}while(0);f[Mq>>2]=0;qo=no+16|0;fo=no+4|0;f[qo>>2]=0;f[qo+4>>2]=0;f[qo+8>>2]=0;f[qo+12>>2]=0;if((f[fo>>2]|0)>0){go=f[no+40>>2]|0;Lq=0;do{f[go+(Lq<<2)>>2]=0;Lq=Lq+1|0;ps=f[fo>>2]|0}while((Lq|0)<(ps|0));f[no>>2]=f[i>>2];if((ps|0)<3)lo=407;else lo=409}else{f[no>>2]=f[i>>2];lo=407}do if((lo|0)==407){lo=0;Lq=f[Xc>>2]|0;if((Lq|0)>=3){lo=409;break}f[fo>>2]=Lq;f[no+8>>2]=f[Yc>>2];f[no+12>>2]=f[hd>>2];Lq=f[$c>>2]|0;go=f[no+44>>2]|0;f[go>>2]=f[Lq>>2];f[go+4>>2]=f[Lq+4>>2]}while(0);if((lo|0)==409){lo=0;jL(no,i)}f[qo>>2]=f[ed>>2];f[no+20>>2]=f[id>>2];f[no+24>>2]=f[jd>>2];f[no+28>>2]=f[kd>>2];f[no+32>>2]=f[ld>>2];f[Mq>>2]=f[dd>>2]}fo=f[dd>>2]|0;do if(fo|0){Lq=fo+12|0;go=f[Lq>>2]|0;f[Lq>>2]=go+-1;if((go|0)!=1)break;kL(i)}while(0);f[dd>>2]=0;f[ed>>2]=0;f[ed+4>>2]=0;f[ed+8>>2]=0;f[ed+12>>2]=0;if((f[Xc>>2]|0)>0){fo=f[Zc>>2]|0;Mq=0;do{f[fo+(Mq<<2)>>2]=0;Mq=Mq+1|0}while((Mq|0)<(f[Xc>>2]|0))}Mq=f[$c>>2]|0;if((Mq|0)!=(_c|0))UC(Mq);Mq=f[fd>>2]|0;do if(Mq|0){fo=Mq+12|0;no=f[fo>>2]|0;f[fo>>2]=no+-1;if((no|0)!=1)break;kL(h)}while(0);f[fd>>2]=0;f[gd>>2]=0;f[gd+4>>2]=0;f[gd+8>>2]=0;f[gd+12>>2]=0;if((f[Rc>>2]|0)>0){Mq=f[Tc>>2]|0;no=0;do{f[Mq+(no<<2)>>2]=0;no=no+1|0}while((no|0)<(f[Rc>>2]|0))}no=f[Vc>>2]|0;if((no|0)!=(Uc|0))UC(no)}f[e>>2]=0;f[md>>2]=0;lp=aD(e,10)|0;mp=424460;np=lp+10|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));Wwa(t,e,f[(f[tb>>2]|0)+40>>2]|0)|0;bD(e);f[e>>2]=0;f[nd>>2]=0;lp=aD(e,12)|0;mp=410841;np=lp+12|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));no=lva(c,r,e,t)|0;bD(e);Mq=cua(o,r)|0;f[Mq>>2]=no;hxa(e,f[(f[Da>>2]|0)+4+(((f[w>>2]|0)==0&1)<<2)>>2]|0);ixa(o,c,e,no,0);if((b[od>>0]|0)<0)O5b(f[e>>2]|0);no=cua(l,r)|0;f[no>>2]=2;no=f[v>>2]|0;if(no|0){while(1){Mq=f[Gc>>2]|0;if((Mq|0)==(no|0))break;fo=Mq+-12|0;f[Gc>>2]=fo;bD(fo)}O5b(f[v>>2]|0)}break}no=0;fo=f[Ca>>2]|0;while(1){if((no|0)>=(fo|0))break;hxa(e,f[(f[Da>>2]|0)+4+(no<<2)>>2]|0);f[h>>2]=0;f[kc>>2]=0;Mq=b[lc>>0]|0;qo=Mq<<24>>24<0?f[mc>>2]|0:Mq&255;if(qo|0){Mq=aD(h,qo)|0;Vac(Mq|0,((b[lc>>0]|0)<0?f[e>>2]|0:e)|0,qo|0)|0}qo=f[la>>2]|0;if(qo){Mq=f[h>>2]|0;go=(Mq|0)==0?1124530:Mq;Lq=la;po=qo;z:while(1){qo=po;while(1){Ar=f[qo+16>>2]|0;if((Ar|0)==(Mq|0))break;if((gTb((Ar|0)==0?1124530:Ar,go)|0)>=0)break;Ar=f[qo+4>>2]|0;if(!Ar){qs=Lq;break z}else qo=Ar}po=f[qo>>2]|0;if(!po){qs=qo;break}else Lq=qo}if((qs|0)!=(la|0)){Lq=f[qs+16>>2]|0;if((Mq|0)!=(Lq|0)?(gTb(go,(Lq|0)==0?1124530:Lq)|0)<0:0)lo=295;else rs=qs}else lo=295}else lo=295;if((lo|0)==295){lo=0;rs=la}bD(h);if((b[lc>>0]|0)<0)O5b(f[e>>2]|0);fo=f[Ca>>2]|0;if((rs|0)!=(la|0)){lo=299;break}else no=no+1|0}if((lo|0)==299){lo=0;if((fo|0)!=2){f[e>>2]=0;f[tc>>2]=0;lp=aD(e,37)|0;mp=370175;np=lp+37|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,843);bD(e)}SL(tb,1);f[nc>>2]=0;f[oc>>2]=0;f[C>>2]=pc;fo=f[m>>2]|0;if((fo|0)!=(la|0)){no=fo;while(1){fo=no+16|0;f[j>>2]=sc;f[e>>2]=f[j>>2];Lq=Twa(C,e,h,i,fo)|0;if(!(f[Lq>>2]|0)){po=L5b(28)|0;ro=f[fo>>2]|0;f[po+16>>2]=ro;f[po+20>>2]=f[no+20>>2];if(ro|0){fo=ro+-4|0;f[fo>>2]=(f[fo>>2]|0)+1}f[po+24>>2]=f[no+24>>2];fo=f[h>>2]|0;f[po>>2]=0;f[po+4>>2]=0;f[po+8>>2]=fo;f[Lq>>2]=po;fo=f[f[C>>2]>>2]|0;if(!fo)ss=po;else{f[C>>2]=fo;ss=f[Lq>>2]|0}mP(f[nc>>2]|0,ss);f[oc>>2]=(f[oc>>2]|0)+1}Lq=f[no+4>>2]|0;do if(!Lq){fo=no+8|0;po=f[fo>>2]|0;if((f[po>>2]|0)==(no|0)){ts=po;break}else us=fo;do{fo=f[us>>2]|0;us=fo+8|0;po=f[us>>2]|0}while((f[po>>2]|0)!=(fo|0));ts=po}else{qo=Lq;while(1){po=f[qo>>2]|0;if(!po)break;else qo=po}ts=qo}while(0);if((ts|0)==(la|0))break;else no=ts}}no=Uwa(a,q,C,-1,0)|0;axa(no,f[tb>>2]|0);Wta(C,f[pc>>2]|0);f[e>>2]=0;f[qc>>2]=0;no=aD(e,5)|0;b[no>>0]=b[410987]|0;b[no+1>>0]=b[410988]|0;b[no+2>>0]=b[410989]|0;b[no+3>>0]=b[410990]|0;b[no+4>>0]=b[410991]|0;no=lva(c,r,e,t)|0;bD(e);Lq=cua(o,r)|0;f[Lq>>2]=no;hxa(e,f[(f[Da>>2]|0)+4>>2]|0);ixa(o,c,e,no,0);if((b[rc>>0]|0)<0)O5b(f[e>>2]|0);break}f[e>>2]=0;f[uc>>2]=0;lp=aD(e,9)|0;mp=427507;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));lxa(t,e,427522)|0;bD(e);f[e>>2]=0;f[vc>>2]=0;no=aD(e,7)|0;b[no>>0]=b[410937]|0;b[no+1>>0]=b[410938]|0;b[no+2>>0]=b[410939]|0;b[no+3>>0]=b[410940]|0;b[no+4>>0]=b[410941]|0;b[no+5>>0]=b[410942]|0;b[no+6>>0]=b[410943]|0;no=lva(c,r,e,t)|0;bD(e);Lq=cua(o,r)|0;f[Lq>>2]=no;if((f[Ca>>2]|0)>0)vs=0;else break;while(1){hxa(e,f[(f[Da>>2]|0)+4+(vs<<2)>>2]|0);f[h>>2]=0;f[wc>>2]=0;Lq=b[xc>>0]|0;go=Lq<<24>>24<0?f[yc>>2]|0:Lq&255;if(go|0){Lq=aD(h,go)|0;Vac(Lq|0,((b[xc>>0]|0)<0?f[e>>2]|0:e)|0,go|0)|0}go=f[ea>>2]|0;if(go){Lq=f[h>>2]|0;Mq=(Lq|0)==0?1124530:Lq;po=ea;fo=go;A:while(1){go=fo;while(1){ro=f[go+16>>2]|0;if((ro|0)==(Lq|0))break;if((gTb((ro|0)==0?1124530:ro,Mq)|0)>=0)break;ro=f[go+4>>2]|0;if(!ro){ws=po;break A}else go=ro}fo=f[go>>2]|0;if(!fo){ws=go;break}else po=go}if((ws|0)!=(ea|0)){po=f[ws+16>>2]|0;if((Lq|0)!=(po|0)?(gTb(Mq,(po|0)==0?1124530:po)|0)<0:0)lo=330;else xs=ws}else lo=330}else lo=330;if((lo|0)==330){lo=0;xs=ea}bD(h);if((xs|0)==(ea|0)){dua(i,370213,e);f[h>>2]=0;f[zc>>2]=0;po=b[Ac>>0]|0;fo=po<<24>>24<0?f[Bc>>2]|0:po&255;if(fo|0){po=aD(h,fo)|0;Vac(po|0,((b[Ac>>0]|0)<0?f[i>>2]|0:i)|0,fo|0)|0}bO(-2,h,376145,369853,866);bD(h);if((b[Ac>>0]|0)<0)O5b(f[i>>2]|0)}f[h>>2]=0;f[Cc>>2]=0;fo=b[xc>>0]|0;po=fo<<24>>24<0?f[yc>>2]|0:fo&255;if(po|0){fo=aD(h,po)|0;Vac(fo|0,((b[xc>>0]|0)<0?f[e>>2]|0:e)|0,po|0)|0}po=mxa(o,h)|0;tva(c,f[po>>2]|0,f[Dc>>2]|0,no,vs);bD(h);if((b[xc>>0]|0)<0)O5b(f[e>>2]|0);vs=vs+1|0;if((vs|0)>=(f[Ca>>2]|0))break c}}X5b(v,f[(f[Da>>2]|0)+4>>2]|0);no=f[s>>2]|0;if(!((no|0)!=369792?(gTb((no|0)==0?1124530:no,369792)|0)!=0:0)){if((f[Ca>>2]|0)!=3){f[e>>2]=0;f[rb>>2]=0;lp=aD(e,23)|0;mp=369829;np=lp+23|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,737);bD(e)}f[Fa>>2]=0;f[Ga>>2]=0;f[x>>2]=Ha;no=f[m>>2]|0;if((no|0)!=(la|0)){po=no;while(1){no=po+16|0;f[j>>2]=qb;f[e>>2]=f[j>>2];fo=Twa(x,e,h,i,no)|0;if(!(f[fo>>2]|0)){qo=L5b(28)|0;ro=f[no>>2]|0;f[qo+16>>2]=ro;f[qo+20>>2]=f[po+20>>2];if(ro|0){no=ro+-4|0;f[no>>2]=(f[no>>2]|0)+1}f[qo+24>>2]=f[po+24>>2];no=f[h>>2]|0;f[qo>>2]=0;f[qo+4>>2]=0;f[qo+8>>2]=no;f[fo>>2]=qo;no=f[f[x>>2]>>2]|0;if(!no)ys=qo;else{f[x>>2]=no;ys=f[fo>>2]|0}mP(f[Fa>>2]|0,ys);f[Ga>>2]=(f[Ga>>2]|0)+1}fo=f[po+4>>2]|0;if(!fo){no=po+8|0;qo=f[no>>2]|0;if((f[qo>>2]|0)==(po|0))zs=qo;else{qo=no;do{no=f[qo>>2]|0;qo=no+8|0;ro=f[qo>>2]|0}while((f[ro>>2]|0)!=(no|0));zs=ro}}else{qo=fo;while(1){Mq=f[qo>>2]|0;if(!Mq)break;else qo=Mq}zs=qo}if((zs|0)==(la|0))break;else po=zs}}Vwa(w,Uwa(a,q,x,1,0)|0);Wta(x,f[Ha>>2]|0);switch(f[w>>2]|0){case 0:{As=(f[ob>>2]|0)+4|0;lo=63;break}case 3:{As=(f[pb>>2]|0)+4|0;lo=63;break}case 2:{As=(f[pb>>2]|0)+4|0;lo=63;break}default:{f[e>>2]=0;f[Ia>>2]=0;bO(-3,e,429353,429358,272);bD(e);lo=65}}if((lo|0)==63){lo=0;if(!((f[As>>2]|0)==2?(po=Gwa(w,0)|0,fo=Gwa(w,1)|0,(po|0)==(fo|0)):0))lo=65}if((lo|0)==65){lo=0;f[e>>2]=0;f[Ja>>2]=0;lp=aD(e,68)|0;mp=369936;np=lp+68|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,740);bD(e)}f[e>>2]=0;f[Ka>>2]=0;fo=aD(e,8)|0;po=fo;b[po>>0]=100;b[po+1>>0]=105;b[po+2>>0]=108;b[po+3>>0]=97;po=fo+4|0;b[po>>0]=116;b[po+1>>0]=105;b[po+2>>0]=111;b[po+3>>0]=110;po=Gwa(w,0)|0;f[h>>2]=po;Wwa(t,e,h)|0;bD(e);f[y>>2]=1124007936;lp=La;np=lp+36|0;do{f[lp>>2]=0;lp=lp+4|0}while((lp|0)<(np|0));f[Na>>2]=Ma;f[Pa>>2]=Oa;f[Oa>>2]=0;f[Qa>>2]=0;f[Ra>>2]=0;f[Sa>>2]=0;f[z>>2]=Ta;po=f[m>>2]|0;if((po|0)!=(la|0)){fo=po;while(1){po=fo+16|0;f[j>>2]=nb;f[e>>2]=f[j>>2];Mq=Twa(z,e,h,i,po)|0;if(!(f[Mq>>2]|0)){Lq=L5b(28)|0;ro=f[po>>2]|0;f[Lq+16>>2]=ro;f[Lq+20>>2]=f[fo+20>>2];if(ro|0){po=ro+-4|0;f[po>>2]=(f[po>>2]|0)+1}f[Lq+24>>2]=f[fo+24>>2];po=f[h>>2]|0;f[Lq>>2]=0;f[Lq+4>>2]=0;f[Lq+8>>2]=po;f[Mq>>2]=Lq;po=f[f[z>>2]>>2]|0;if(!po)Bs=Lq;else{f[z>>2]=po;Bs=f[Mq>>2]|0}mP(f[Ra>>2]|0,Bs);f[Sa>>2]=(f[Sa>>2]|0)+1}Mq=f[fo+4>>2]|0;if(!Mq){po=fo+8|0;Lq=f[po>>2]|0;if((f[Lq>>2]|0)==(fo|0))Cs=Lq;else{Lq=po;do{po=f[Lq>>2]|0;Lq=po+8|0;ro=f[Lq>>2]|0}while((f[ro>>2]|0)!=(po|0));Cs=ro}}else{Lq=Mq;while(1){qo=f[Lq>>2]|0;if(!qo)break;else Lq=qo}Cs=Lq}if((Cs|0)==(la|0))break;else fo=Cs}}fo=Uwa(a,q,z,2,0)|0;f[e>>2]=0;f[Ua>>2]=0;f[Va>>2]=0;Xwa(fo,e);Mq=f[e>>2]|0;qo=((f[Ua>>2]|0)-Mq|0)==16;ro=Mq;if(qo){Mq=ro+8|0;po=ro+12|0;no=f[po>>2]|0;f[po>>2]=f[Mq>>2];po=ro+4|0;ro=f[po>>2]|0;f[po>>2]=no;f[Mq>>2]=ro}iL(y,e,5);Ywa(h,fo);fo=f[Wa>>2]|0;if((fo|0)<3)Ds=Y(f[Ya>>2]|0,f[Xa>>2]|0)|0;else{ro=f[db>>2]|0;Mq=0;no=1;while(1){po=Y(f[ro+(Mq<<2)>>2]|0,no)|0;Mq=Mq+1|0;if((Mq|0)==(fo|0)){Ds=po;break}else no=po}}no=f[La>>2]|0;if((no|0)<3)Es=Y(f[Za>>2]|0,f[Ma>>2]|0)|0;else{fo=f[Na>>2]|0;Mq=0;ro=1;while(1){po=Y(f[fo+(Mq<<2)>>2]|0,ro)|0;Mq=Mq+1|0;if((Mq|0)==(no|0)){Es=po;break}else ro=po}}if((Ds|0)!=(Es|0)){f[i>>2]=0;f[mb>>2]=0;lp=aD(i,28)|0;mp=370005;np=lp+28|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,i,370034,369853,179);bD(i)}ro=f[_a>>2]|0;no=f[$a>>2]|0;if(qo){Mq=f[e>>2]|0;fo=f[Mq>>2]|0;po=f[Mq+4>>2]|0;Ar=f[Mq+8>>2]|0;gq=f[Mq+12>>2]|0;ds=Y(Y(Y(po,fo)|0,Ar)|0,gq)|0;if((fo|0)>0){mo=Y(Y(Ar,po)|0,gq)|0;es=0;fs=po;Fs=fo;fo=Mq;while(1){if((fs|0)>0){Mq=Y(mo,es)|0;Gs=0;Hs=fo;while(1){if((f[Hs+8>>2]|0)>0){Is=Y(Gs,Ar)|0;Js=Gs+Mq|0;Ks=0;Ls=Hs;while(1){if((f[Ls+12>>2]|0)>0){Ms=(Y(Ks+Is|0,gq)|0)+Mq|0;Ns=Y(Ks,gq)|0;Os=0;do{Ps=Ms+Os|0;Qs=Js+(Y(Os+Ns|0,po)|0)|0;if((Ps|0)>=(ds|0)){f[i>>2]=0;f[bb>>2]=0;lp=aD(i,13)|0;mp=370046;np=lp+13|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,i,370034,369853,195);bD(i)}if((Qs|0)>=(ds|0)){f[i>>2]=0;f[ab>>2]=0;lp=aD(i,13)|0;mp=370060;np=lp+13|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,i,370034,369853,196);bD(i)}n[ro+(Ps<<2)>>2]=+(f[no+(Qs<<2)>>2]|0);Os=Os+1|0;io=f[e>>2]|0}while((Os|0)<(f[io+12>>2]|0));Rs=io}else Rs=Ls;Ks=Ks+1|0;if((Ks|0)>=(f[Rs+8>>2]|0)){Ss=Rs;break}else Ls=Rs}}else Ss=Hs;Gs=Gs+1|0;Ts=f[Ss+4>>2]|0;if((Gs|0)>=(Ts|0))break;else Hs=Ss}Us=Ts;Vs=f[Ss>>2]|0;Xs=Ss}else{Us=fs;Vs=Fs;Xs=fo}es=es+1|0;if((es|0)>=(Vs|0))break;else{fs=Us;Fs=Vs;fo=Xs}}}}else if((Ds|0)>0){fo=0;do{n[ro+(fo<<2)>>2]=+(f[no+(fo<<2)>>2]|0);fo=fo+1|0}while((fo|0)!=(Ds|0))}fo=f[cb>>2]|0;do if(fo|0){no=fo+12|0;ro=f[no>>2]|0;f[no>>2]=ro+-1;if((ro|0)!=1)break;kL(h)}while(0);f[cb>>2]=0;f[$a>>2]=0;f[$a+4>>2]=0;f[$a+8>>2]=0;f[$a+12>>2]=0;if((f[Wa>>2]|0)>0){fo=f[db>>2]|0;ro=0;do{f[fo+(ro<<2)>>2]=0;ro=ro+1|0}while((ro|0)<(f[Wa>>2]|0))}ro=f[eb>>2]|0;if((ro|0)!=(fb|0))UC(ro);ro=f[e>>2]|0;if(ro|0){fo=f[Ua>>2]|0;if((fo|0)!=(ro|0))f[Ua>>2]=fo+(~((fo+-4-ro|0)>>>2)<<2);O5b(ro)}Wta(z,f[Ta>>2]|0);f[e>>2]=0;f[gb>>2]=0;ro=aD(e,5)|0;b[ro>>0]=b[374525]|0;b[ro+1>>0]=b[374526]|0;b[ro+2>>0]=b[374527]|0;b[ro+3>>0]=b[374528]|0;b[ro+4>>0]=b[374529]|0;Zwa(t,e,f[_a>>2]|0)|0;bD(e);f[e>>2]=0;f[hb>>2]=0;ro=aD(e,5)|0;b[ro>>0]=b[374519]|0;b[ro+1>>0]=b[374520]|0;b[ro+2>>0]=b[374521]|0;b[ro+3>>0]=b[374522]|0;b[ro+4>>0]=b[374523]|0;ro=f[_a>>2]|0;do if(!(f[y>>2]&16384)){fo=f[Na>>2]|0;if((f[fo>>2]|0)==1){lo=125;break}no=f[f[Pa>>2]>>2]|0;if((f[fo+4>>2]|0)==1){Ys=ro+(no<<1)|0;break}else{fo=f[Za>>2]|0;Fs=2/(fo|0)|0;Ys=ro+(Y(Fs,no)|0)+(2-(Y(Fs,fo)|0)<<2)|0;break}}else lo=125;while(0);if((lo|0)==125){lo=0;Ys=ro+8|0}Zwa(t,e,Ys)|0;bD(e);f[h>>2]=0;f[ib>>2]=0;fo=aD(h,6)|0;b[fo>>0]=b[369785]|0;b[fo+1>>0]=b[369786]|0;b[fo+2>>0]=b[369787]|0;b[fo+3>>0]=b[369788]|0;b[fo+4>>0]=b[369789]|0;b[fo+5>>0]=b[369790]|0;_wa(e,ja,r,h);bD(h);fo=f[e>>2]|0;if(((f[jb>>2]|0)-fo|0)==12)Zs=fo;else{f[h>>2]=0;f[lb>>2]=0;lp=aD(h,23)|0;mp=370074;np=lp+23|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,h,376145,369853,751);bD(h);Zs=f[e>>2]|0}qEa(q,f[(f[ta>>2]|0)+4+(f[Zs+8>>2]<<2)>>2]|0);ro=f[e>>2]|0;fo=f[ha>>2]|0;B:do if(!fo){_s=ha;$s=ha}else{Fs=f[ro>>2]|0;no=(Fs|0)==0?1124530:Fs;fs=f[fo+16>>2]|0;C:do if((Fs|0)!=(fs|0)){es=fa;ds=fo;po=fs;while(1){gq=(po|0)==0?1124530:po;if((gTb(no,gq)|0)<0){Ar=f[ds>>2]|0;if(!Ar){lo=136;break}else{at=ds;bt=Ar}}else{if((gTb(gq,no)|0)>=0){ct=es;dt=ds;break C}et=ds+4|0;gq=f[et>>2]|0;if(!gq){lo=139;break}else{at=et;bt=gq}}po=f[bt+16>>2]|0;if((Fs|0)==(po|0)){ct=at;dt=bt;break C}else{es=at;ds=bt}}if((lo|0)==136){lo=0;_s=ds;$s=ds;break B}else if((lo|0)==139){lo=0;_s=et;$s=ds;break B}}else{ct=fa;dt=fo}while(0);_s=ct;$s=dt}while(0);if(!(f[_s>>2]|0)){fo=L5b(24)|0;Fs=f[ro>>2]|0;f[fo+16>>2]=Fs;f[fo+20>>2]=f[ro+4>>2];if(Fs|0){no=Fs+-4|0;f[no>>2]=(f[no>>2]|0)+1}f[fo>>2]=0;f[fo+4>>2]=0;f[fo+8>>2]=$s;f[_s>>2]=fo;no=f[f[k>>2]>>2]|0;if(!no)ft=fo;else{f[k>>2]=no;ft=f[_s>>2]|0}mP(f[fa>>2]|0,ft);f[ga>>2]=(f[ga>>2]|0)+1}no=f[ua>>2]|0;bD(r);fo=no+11|0;Fs=b[fo>>0]|0;fs=Fs<<24>>24<0?f[no+4>>2]|0:Fs&255;if(fs|0){Fs=aD(r,fs)|0;Vac(Fs|0,((b[fo>>0]|0)<0?f[no>>2]|0:no)|0,fs|0)|0}fs=f[wa>>2]|0;bD(s);no=fs+11|0;fo=b[no>>0]|0;Fs=fo<<24>>24<0?f[fs+4>>2]|0:fo&255;if(Fs|0){fo=aD(s,Fs)|0;Vac(fo|0,((b[no>>0]|0)<0?f[fs>>2]|0:fs)|0,Fs|0)|0}Fs=f[e>>2]|0;if(Fs|0){while(1){fs=f[jb>>2]|0;if((fs|0)==(Fs|0))break;no=fs+-12|0;f[jb>>2]=no;bD(no)}O5b(f[e>>2]|0)}Fs=f[kb>>2]|0;do if(Fs|0){ro=Fs+12|0;no=f[ro>>2]|0;f[ro>>2]=no+-1;if((no|0)!=1)break;kL(y)}while(0);f[kb>>2]=0;f[_a>>2]=0;f[_a+4>>2]=0;f[_a+8>>2]=0;f[_a+12>>2]=0;if((f[La>>2]|0)>0){Fs=f[Na>>2]|0;no=0;do{f[Fs+(no<<2)>>2]=0;no=no+1|0}while((no|0)<(f[La>>2]|0))}no=f[Pa>>2]|0;if((no|0)!=(Oa|0))UC(no);gua(w)}f[e>>2]=0;f[sb>>2]=0;lp=aD(e,9)|0;mp=434144;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[h>>0]=0;$wa(t,e,h)|0;bD(e);SL(tb,1);f[e>>2]=0;f[ub>>2]=0;no=aD(e,7)|0;b[no>>0]=b[370098]|0;b[no+1>>0]=b[370099]|0;b[no+2>>0]=b[370100]|0;b[no+3>>0]=b[370101]|0;b[no+4>>0]=b[370102]|0;b[no+5>>0]=b[370103]|0;b[no+6>>0]=b[370104]|0;_wa(w,ja,r,e);bD(e);if(((f[vb>>2]|0)-(f[w>>2]|0)|0)==12){f[e>>2]=0;f[wb>>2]=0;lp=aD(e,9)|0;mp=434144;np=lp+9|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[h>>0]=1;$wa(t,e,h)|0;bD(e);SL(tb,2);no=f[(f[w>>2]|0)+8>>2]|0;Fs=f[(f[ta>>2]|0)+4+(no<<2)>>2]|0;f[xb>>2]=0;f[yb>>2]=0;f[A>>2]=zb;ro=f[m>>2]|0;if((ro|0)!=(la|0)){fs=ro;while(1){ro=fs+16|0;f[j>>2]=Ab;f[e>>2]=f[j>>2];fo=Twa(A,e,h,i,ro)|0;if(!(f[fo>>2]|0)){es=L5b(28)|0;po=f[ro>>2]|0;f[es+16>>2]=po;f[es+20>>2]=f[fs+20>>2];if(po|0){ro=po+-4|0;f[ro>>2]=(f[ro>>2]|0)+1}f[es+24>>2]=f[fs+24>>2];ro=f[h>>2]|0;f[es>>2]=0;f[es+4>>2]=0;f[es+8>>2]=ro;f[fo>>2]=es;ro=f[f[A>>2]>>2]|0;if(!ro)gt=es;else{f[A>>2]=ro;gt=f[fo>>2]|0}mP(f[xb>>2]|0,gt);f[yb>>2]=(f[yb>>2]|0)+1}fo=f[fs+4>>2]|0;if(!fo){ro=fs+8|0;es=f[ro>>2]|0;if((f[es>>2]|0)==(fs|0))ht=es;else{es=ro;do{ro=f[es>>2]|0;es=ro+8|0;po=f[es>>2]|0}while((f[po>>2]|0)!=(ro|0));ht=po}}else{es=fo;while(1){po=f[es>>2]|0;if(!po)break;else es=po}ht=es}if((ht|0)==(la|0))break;else fs=ht}}fs=Uwa(a,Fs,A,-1,0)|0;axa(fs,(f[tb>>2]|0)+56|0);Wta(A,f[zb>>2]|0);bxa(ja,no);fs=f[w>>2]|0;fo=f[ha>>2]|0;D:do if(!fo){it=ha;jt=ha}else{po=f[fs>>2]|0;ro=(po|0)==0?1124530:po;gq=f[fo+16>>2]|0;E:do if((po|0)!=(gq|0)){Ar=fa;mo=fo;qo=gq;while(1){Hs=(qo|0)==0?1124530:qo;if((gTb(ro,Hs)|0)<0){Gs=f[mo>>2]|0;if(!Gs){lo=183;break}else{kt=mo;lt=Gs}}else{if((gTb(Hs,ro)|0)>=0){mt=Ar;nt=mo;break E}ot=mo+4|0;Hs=f[ot>>2]|0;if(!Hs){lo=186;break}else{kt=ot;lt=Hs}}qo=f[lt+16>>2]|0;if((po|0)==(qo|0)){mt=kt;nt=lt;break E}else{Ar=kt;mo=lt}}if((lo|0)==183){lo=0;it=mo;jt=mo;break D}else if((lo|0)==186){lo=0;it=ot;jt=mo;break D}}else{mt=fa;nt=fo}while(0);it=mt;jt=nt}while(0);if(!(f[it>>2]|0)){fo=L5b(24)|0;no=f[fs>>2]|0;f[fo+16>>2]=no;f[fo+20>>2]=f[fs+4>>2];if(no|0){Fs=no+-4|0;f[Fs>>2]=(f[Fs>>2]|0)+1}f[fo>>2]=0;f[fo+4>>2]=0;f[fo+8>>2]=jt;f[it>>2]=fo;Fs=f[f[k>>2]>>2]|0;if(!Fs)pt=fo;else{f[k>>2]=Fs;pt=f[it>>2]|0}mP(f[fa>>2]|0,pt);f[ga>>2]=(f[ga>>2]|0)+1}}f[Bb>>2]=0;f[Cb>>2]=0;f[B>>2]=Db;Fs=f[m>>2]|0;if((Fs|0)!=(la|0)){fo=Fs;while(1){Fs=fo+16|0;f[j>>2]=jc;f[e>>2]=f[j>>2];no=Twa(B,e,h,i,Fs)|0;if(!(f[no>>2]|0)){po=L5b(28)|0;ro=f[Fs>>2]|0;f[po+16>>2]=ro;f[po+20>>2]=f[fo+20>>2];if(ro|0){Fs=ro+-4|0;f[Fs>>2]=(f[Fs>>2]|0)+1}f[po+24>>2]=f[fo+24>>2];Fs=f[h>>2]|0;f[po>>2]=0;f[po+4>>2]=0;f[po+8>>2]=Fs;f[no>>2]=po;Fs=f[f[B>>2]>>2]|0;if(!Fs)qt=po;else{f[B>>2]=Fs;qt=f[no>>2]|0}mP(f[Bb>>2]|0,qt);f[Cb>>2]=(f[Cb>>2]|0)+1}no=f[fo+4>>2]|0;if(!no){Fs=fo+8|0;po=f[Fs>>2]|0;if((f[po>>2]|0)==(fo|0))rt=po;else{po=Fs;do{Fs=f[po>>2]|0;po=Fs+8|0;ro=f[po>>2]|0}while((f[ro>>2]|0)!=(Fs|0));rt=ro}}else{po=no;while(1){ro=f[po>>2]|0;if(!ro)break;else po=ro}rt=po}if((rt|0)==(la|0))break;else fo=rt}}fo=Uwa(a,q,B,-1,0)|0;cxa(fo,f[tb>>2]|0);Wta(B,f[Db>>2]|0);fo=f[tb>>2]|0;fs=f[fo+40>>2]|0;no=f[s>>2]|0;if(!((no|0)!=369807?(gTb((no|0)==0?1124530:no,369807)|0)!=0:0)){no=f[fs>>2]|0;ro=fs+4|0;Fs=f[ro>>2]|0;gq=f[fs+8>>2]|0;es=f[fs+12>>2]|0;f[h>>2]=1124007936;lp=Eb;np=lp+36|0;do{f[lp>>2]=0;lp=lp+4|0}while((lp|0)<(np|0));f[Gb>>2]=Fb;f[Ib>>2]=Hb;f[Hb>>2]=0;f[Jb>>2]=0;Ar=Kb;f[Ar>>2]=0;f[Ar+4>>2]=0;f[e>>2]=33619968;f[Lb>>2]=h;SP(fo,e);Ar=f[Mb>>2]|0;qo=f[tb>>2]|0;ds=f[qo+16>>2]|0;if((no|0)>0?(Hs=Y(es,gq)|0,Gs=(Hs|0)>0,(Fs|0)>0):0){Mq=0;do{Lq=Y(Mq,Fs)|0;if(Gs){Ls=0;do{Ks=Y(Hs,Ls+Lq|0)|0;Js=Y(Hs,(Y(Ls,no)|0)+Mq|0)|0;Is=0;do{f[ds+(Is+Js<<2)>>2]=f[Ar+(Is+Ks<<2)>>2];Is=Is+1|0}while((Is|0)!=(Hs|0));Ls=Ls+1|0}while((Ls|0)!=(Fs|0))}Mq=Mq+1|0}while((Mq|0)!=(no|0))}Mq=Y(Fs,no)|0;f[fs>>2]=Mq;f[ro>>2]=1;Mq=f[qo+44>>2]|0;f[Mq>>2]=f[Mq+4>>2];Mq=f[Nb>>2]|0;if(Mq|0?(Hs=Mq+12|0,Mq=f[Hs>>2]|0,f[Hs>>2]=Mq+-1,(Mq|0)==1):0)kL(h);f[Nb>>2]=0;f[Mb>>2]=0;f[Mb+4>>2]=0;f[Mb+8>>2]=0;f[Mb+12>>2]=0;if((f[Eb>>2]|0)>0){Mq=f[Gb>>2]|0;Hs=0;do{f[Mq+(Hs<<2)>>2]=0;Hs=Hs+1|0}while((Hs|0)<(f[Eb>>2]|0))}Hs=f[Ib>>2]|0;if((Hs|0)!=(Hb|0))UC(Hs)}f[e>>2]=0;f[Ob>>2]=0;Hs=aD(e,8)|0;Mq=Hs;b[Mq>>0]=107;b[Mq+1>>0]=101;b[Mq+2>>0]=114;b[Mq+3>>0]=110;Mq=Hs+4|0;b[Mq>>0]=101;b[Mq+1>>0]=108;b[Mq+2>>0]=95;b[Mq+3>>0]=104;Wwa(t,e,fs+8|0)|0;bD(e);f[e>>2]=0;f[Pb>>2]=0;Mq=aD(e,8)|0;Hs=Mq;b[Hs>>0]=107;b[Hs+1>>0]=101;b[Hs+2>>0]=114;b[Hs+3>>0]=110;Hs=Mq+4|0;b[Hs>>0]=101;b[Hs+1>>0]=108;b[Hs+2>>0]=95;b[Hs+3>>0]=119;Wwa(t,e,fs+12|0)|0;bD(e);f[e>>2]=0;f[Qb>>2]=0;lp=aD(e,10)|0;mp=424460;np=lp+10|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));Wwa(t,e,fs)|0;bD(e);dxa(t,q);exa(t,q);f[h>>2]=0;f[Rb>>2]=0;lp=aD(h,14)|0;mp=370106;np=lp+14|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));_wa(e,ja,r,h);fxa(w,f[e>>2]|0,f[Sb>>2]|0);fs=f[e>>2]|0;if(fs|0){while(1){Hs=f[Sb>>2]|0;if((Hs|0)==(fs|0))break;Mq=Hs+-12|0;f[Sb>>2]=Mq;bD(Mq)}O5b(f[e>>2]|0)}bD(h);if((f[w>>2]|0)!=(f[vb>>2]|0)){f[e>>2]=0;f[hc>>2]=0;fs=aD(e,8)|0;Mq=fs;b[Mq>>0]=112;b[Mq+1>>0]=97;b[Mq+2>>0]=100;b[Mq+3>>0]=95;Mq=fs+4|0;b[Mq>>0]=109;b[Mq+1>>0]=111;b[Mq+2>>0]=100;b[Mq+3>>0]=101;gxa(t,e,1124530)|0;bD(e);Mq=f[w>>2]|0;if(((f[vb>>2]|0)-Mq|0)==12)st=Mq;else{f[e>>2]=0;f[ic>>2]=0;lp=aD(e,23)|0;mp=370074;np=lp+23|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));bO(-215,e,376145,369853,811);bD(e);st=f[w>>2]|0}bxa(ja,f[st+8>>2]|0);Mq=f[w>>2]|0;fs=f[ha>>2]|0;F:do if(!fs){tt=ha;ut=ha}else{Hs=f[Mq>>2]|0;qo=(Hs|0)==0?1124530:Hs;ro=f[fs+16>>2]|0;G:do if((Hs|0)!=(ro|0)){no=fa;Fs=fs;Ar=ro;while(1){ds=(Ar|0)==0?1124530:Ar;if((gTb(qo,ds)|0)<0){Gs=f[Fs>>2]|0;if(!Gs){lo=237;break}else{vt=Fs;wt=Gs}}else{if((gTb(ds,qo)|0)>=0){xt=no;yt=Fs;break G}zt=Fs+4|0;ds=f[zt>>2]|0;if(!ds){lo=240;break}else{vt=zt;wt=ds}}Ar=f[wt+16>>2]|0;if((Hs|0)==(Ar|0)){xt=vt;yt=wt;break G}else{no=vt;Fs=wt}}if((lo|0)==237){lo=0;tt=Fs;ut=Fs;break F}else if((lo|0)==240){lo=0;tt=zt;ut=Fs;break F}}else{xt=fa;yt=fs}while(0);tt=xt;ut=yt}while(0);if(!(f[tt>>2]|0)){fs=L5b(24)|0;Hs=f[Mq>>2]|0;f[fs+16>>2]=Hs;f[fs+20>>2]=f[Mq+4>>2];if(Hs|0){qo=Hs+-4|0;f[qo>>2]=(f[qo>>2]|0)+1}f[fs>>2]=0;f[fs+4>>2]=0;f[fs+8>>2]=ut;f[tt>>2]=fs;qo=f[f[k>>2]>>2]|0;if(!qo)At=fs;else{f[k>>2]=qo;At=f[tt>>2]|0}mP(f[fa>>2]|0,At);f[ga>>2]=(f[ga>>2]|0)+1}}f[e>>2]=0;f[Tb>>2]=0;lp=aD(e,11)|0;mp=411994;np=lp+11|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));Mq=lva(c,r,e,t)|0;bD(e);qo=cua(o,r)|0;f[qo>>2]=Mq;hxa(e,v);ixa(o,c,e,Mq,0);if((b[Ub>>0]|0)<0)O5b(f[e>>2]|0);f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;Mq=L5b(16)|0;f[e>>2]=Mq;f[Vb>>2]=-2147483632;f[Wb>>2]=11;lp=Mq;mp=370121;np=lp+11|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[Mq+11>>0]=0;qo=jxa(q,e)|0;if((b[Xb>>0]|0)<0)O5b(f[e>>2]|0);if(qo){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;qo=L5b(16)|0;f[h>>2]=qo;f[Yb>>2]=-2147483632;f[Zb>>2]=11;lp=qo;mp=370121;np=lp+11|0;do{b[lp>>0]=b[mp>>0]|0;lp=lp+1|0;mp=mp+1|0}while((lp|0)<(np|0));b[qo+11>>0]=0;tKb(_b);Mq=kxa(f[$b>>2]|0,h)|0;X5b(e,(f[Mq+20>>2]|0)==2?f[Mq+8>>2]|0:497760);if((b[ac>>0]|0)<0)O5b(f[h>>2]|0);Mq=b[bc>>0]|0;fs=f[cc>>2]|0;do if(((Mq<<24>>24<0?fs:Mq&255)|0)==4)if(!(u6b(e,0,-1,370133,4)|0)){Hs=cua(l,r)|0;f[Hs>>2]=0;break}else{Bt=b[bc>>0]|0;Ct=f[cc>>2]|0;lo=259;break}else{Bt=Mq;Ct=fs;lo=259}while(0);H:do if((lo|0)==259){lo=0;do if(((Bt<<24>>24<0?Ct:Bt&255)|0)==4){if(u6b(e,0,-1,370138,4)|0)break;fs=cua(l,r)|0;f[fs>>2]=1;break H}while(0);dua(i,370143,e);f[h>>2]=0;f[dc>>2]=0;fs=b[ec>>0]|0;Mq=fs<<24>>24<0?f[fc>>2]|0:fs&255;if(Mq|0){fs=aD(h,Mq)|0;Vac(fs|0,((b[ec>>0]|0)<0?f[i>>2]|0:i)|0,Mq|0)|0}bO(-212,h,376145,369853,830);bD(h);if((b[ec>>0]|0)<0)O5b(f[i>>2]|0)}while(0);if((b[bc>>0]|0)<0)O5b(f[e>>2]|0)}else{Mq=cua(l,r)|0;f[Mq>>2]=0}Mq=f[w>>2]|0;if(Mq|0){while(1){fs=f[vb>>2]|0;if((fs|0)==(Mq|0))break;qo=fs+-12|0;f[vb>>2]=qo;bD(qo)}O5b(f[w>>2]|0)}if((b[gc>>0]|0)<0)O5b(f[v>>2]|0)}while(0);fua(t);bD(s);bD(r);ADa(q);co=co+1|0;if((co|0)>=(ia|0)){lo=1652;break}}if((lo|0)==462)V5b(h);else if((lo|0)==502)V5b(i);else if((lo|0)==1537)V5b(e);else if((lo|0)==1652){ma=la;na=ka;oa=ha;pa=f[ea>>2]|0;Wta(o,pa);qa=f[ma>>2]|0;Wta(m,qa);ra=f[na>>2]|0;Wta(l,ra);sa=f[oa>>2]|0;vxa(k,sa);u=d;return}}function Rwa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;c=u;u=u+64|0;d=c;e=c+40|0;g=c+28|0;h=c+16|0;i=c+8|0;f[e+4>>2]=0;f[e+8>>2]=0;j=e+4|0;f[e>>2]=j;f[g>>2]=0;k=g+4|0;f[k>>2]=0;f[g+8>>2]=0;l=f[a+12>>2]|0;f[d>>2]=0;m=(l|0)>0;a:do if(m){n=a+20|0;o=h+4|0;p=g+8|0;q=i+4|0;r=0;do{s=f[(f[n>>2]|0)+4+(r<<2)>>2]|0;t=f[s+72>>2]|0;f[h>>2]=0;f[o>>2]=0;v=t+11|0;w=b[v>>0]|0;x=w<<24>>24<0?f[t+4>>2]|0:w&255;if(x){w=aD(h,x)|0;Vac(w|0,((b[v>>0]|0)<0?f[t>>2]|0:t)|0,x|0)|0;x=f[h>>2]|0;if((x|0)==374081)y=10;else{z=x;y=8}}else{z=0;y=8}if((y|0)==8){y=0;x=(z|0)==0?1124530:z;if(!(!((gTb(x,374081)|0)==0|(z|0)==410921)?(gTb(x,410921)|0)!=0:0))y=10}if((y|0)==10){y=0;x=f[k>>2]|0;if((x|0)==(f[p>>2]|0))IO(g,d);else{f[x>>2]=f[d>>2];f[k>>2]=x+4}x=f[(f[s+20>>2]|0)+4>>2]|0;t=f[s+68>>2]|0;f[i>>2]=0;f[q>>2]=0;s=t+11|0;v=b[s>>0]|0;w=v<<24>>24<0?f[t+4>>2]|0:v&255;if(w|0){v=aD(i,w)|0;Vac(v|0,((b[s>>0]|0)<0?f[t>>2]|0:t)|0,w|0)|0}w=gya(e,i)|0;bD(w);t=x+11|0;s=b[t>>0]|0;v=s<<24>>24<0?f[x+4>>2]|0:s&255;if(v|0){s=aD(w,v)|0;Vac(s|0,((b[t>>0]|0)<0?f[x>>2]|0:x)|0,v|0)|0}bD(i)}bD(h);r=(f[d>>2]|0)+1|0;f[d>>2]=r}while((r|0)<(l|0));if(m){r=a+20|0;q=d+4|0;p=h+11|0;o=h+8|0;n=h+4|0;v=0;b:while(1){x=f[(f[r>>2]|0)+4+(v<<2)>>2]|0;t=x+12|0;if((f[t>>2]|0)>0){s=x+20|0;x=0;do{w=f[(f[s>>2]|0)+4+(x<<2)>>2]|0;f[d>>2]=0;f[q>>2]=0;A=w+11|0;B=b[A>>0]|0;C=B<<24>>24<0?f[w+4>>2]|0:B&255;if(C|0){B=aD(d,C)|0;Vac(B|0,((b[A>>0]|0)<0?f[w>>2]|0:w)|0,C|0)|0}C=f[j>>2]|0;do if(C|0){w=f[d>>2]|0;A=(w|0)==0?1124530:w;B=j;D=C;c:while(1){E=D;while(1){F=f[E+16>>2]|0;if((F|0)==(w|0))break;if((gTb((F|0)==0?1124530:F,A)|0)>=0)break;F=f[E+4>>2]|0;if(!F){G=B;break c}else E=F}D=f[E>>2]|0;if(!D){G=E;break}else B=E}if((G|0)!=(j|0)){B=f[G+16>>2]|0;if((w|0)!=(B|0)?(gTb(A,(B|0)==0?1124530:B)|0)<=-1:0)break;B=f[G+24>>2]|0;D=f[G+28>>2]|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;if(D>>>0>4294967279)break b;if(D>>>0<11){b[p>>0]=D;if(!D)H=h;else{I=h;y=41}}else{F=D+16&-16;J=L5b(F)|0;f[h>>2]=J;f[o>>2]=F|-2147483648;f[n>>2]=D;I=J;y=41}if((y|0)==41){y=0;Vac(I|0,B|0,D|0)|0;H=I}b[H+D>>0]=0;_5b(f[(f[s>>2]|0)+4+(x<<2)>>2]|0,h)|0;if((b[p>>0]|0)<0)O5b(f[h>>2]|0)}}while(0);bD(d);x=x+1|0}while((x|0)<(f[t>>2]|0))}v=v+1|0;if((v|0)>=(l|0))break a}V5b(h)}}while(0);sWb(f[g>>2]|0,f[k>>2]|0,d);d=f[k>>2]|0;h=f[g>>2]|0;l=h;if((d|0)==(h|0)){K=d;L=l}else{d=a+8|0;h=a+20|0;a=0;H=l;while(1){l=(f[H+(a<<2)>>2]|0)-a|0;I=f[(f[h>>2]|0)+4+(l<<2)>>2]|0;if(!((I|0)==0|(f[d>>2]|0)!=0))bi[f[(f[I>>2]|0)+4>>2]&2047](I);dpb(d,l,1);a=a+1|0;l=f[k>>2]|0;I=f[g>>2]|0;y=I;if(a>>>0>=l-I>>2>>>0){K=l;L=y;break}else H=y}}H=K;if(!L){M=f[j>>2]|0;hya(e,M);u=c;return}if((H|0)!=(L|0))f[k>>2]=H+(~((H+-4-L|0)>>>2)<<2);O5b(L);M=f[j>>2]|0;hya(e,M);u=c;return}function Swa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0;e=u;u=u+208|0;g=e+152|0;h=e+144|0;i=e+136|0;j=e+72|0;k=e+16|0;l=e;m=e+128|0;o=a+12|0;if((f[o>>2]|0)<=0){u=e;return}p=a+20|0;q=h+4|0;r=i+4|0;s=g+4|0;t=g+4|0;v=c+4|0;w=g+4|0;x=g+11|0;y=g+4|0;z=j+11|0;A=j+4|0;B=g+4|0;C=g+4|0;D=g+4|0;E=g+11|0;F=g+5|0;G=j+11|0;H=j+5|0;I=k+11|0;J=k+5|0;K=g+4|0;L=g+8|0;M=g+12|0;N=j+4|0;O=j+8|0;P=j+12|0;Q=g+16|0;R=j+16|0;S=l+4|0;T=l+8|0;U=l+4|0;V=k+16|0;W=k+4|0;X=k+8|0;Z=k+12|0;_=d+4|0;$=d+4|0;aa=d+8|0;ba=k+36|0;ca=k+40|0;da=k+44|0;ea=k+48|0;fa=j+36|0;ga=j+40|0;ha=j+44|0;ia=j+48|0;ja=g+36|0;ka=g+40|0;la=g+44|0;ma=g+48|0;na=k+4|0;oa=k+4|0;pa=k+4|0;qa=k+4|0;ra=g+4|0;sa=g+4|0;ta=j+11|0;ua=j+5|0;va=m+4|0;wa=j+4|0;xa=j+8|0;ya=g+4|0;za=g+8|0;Aa=c+4|0;Ba=c+8|0;Ca=g+4|0;Da=0;do{Ea=f[(f[p>>2]|0)+4+(Da<<2)>>2]|0;Fa=f[Ea+68>>2]|0;f[h>>2]=0;f[q>>2]=0;Ga=Fa+11|0;Ha=b[Ga>>0]|0;Ia=Ha<<24>>24<0?f[Fa+4>>2]|0:Ha&255;if(Ia|0){Ha=aD(h,Ia)|0;Vac(Ha|0,((b[Ga>>0]|0)<0?f[Fa>>2]|0:Fa)|0,Ia|0)|0}Ia=f[Ea+72>>2]|0;f[i>>2]=0;f[r>>2]=0;Fa=Ia+11|0;Ga=b[Fa>>0]|0;Ha=Ga<<24>>24<0?f[Ia+4>>2]|0:Ga&255;if(Ha){Ga=aD(i,Ha)|0;Vac(Ga|0,((b[Fa>>0]|0)<0?f[Ia>>2]|0:Ia)|0,Ha|0)|0;Ha=f[i>>2]|0;if((Ha|0)==372547)Ja=9;else{Ka=Ha;Ja=8}}else{Ka=0;Ja=8}do if((Ja|0)==8){Ja=0;Ha=(Ka|0)==0?1124530:Ka;if(gTb(Ha,372547)|0){if((Ka|0)!=370428?gTb(Ha,370428)|0:0)break;Ha=Ea+24|0;tKb(Ha);Ia=Ea+60|0;Fa=f[Ia>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[ta>>0]=5;b[j>>0]=b[471917]|0;b[j+1>>0]=b[471918]|0;b[j+2>>0]=b[471919]|0;b[j+3>>0]=b[471920]|0;b[j+4>>0]=b[471921]|0;b[ua>>0]=0;if(!(b[Fa+8>>0]|0)){wxa(g,f[Fa+12>>2]|0,j);La=2;Ma=0;Na=f[g>>2]|0}else{La=1;Ma=Hxa(f[Fa+12>>2]|0,j)|0;Na=0}tKb(Ha);do if((La|0)==(((b[(f[Ia>>2]|0)+8>>0]|0)==0?2:1)|0))if((La|0)==1){Oa=(Ma|0)==0;break}else{Oa=(Na|0)==0;break}else Oa=0;while(0);if((b[ta>>0]|0)<0)O5b(f[j>>2]|0);do if(!Oa){Ia=f[h>>2]|0;f[m>>2]=Ia;Ha=f[q>>2]|0;f[va>>2]=Ha;if(Ia){Fa=Ia+-4|0;f[Fa>>2]=(f[Fa>>2]|0)+1;Fa=f[m>>2]|0;Ia=f[va>>2]|0;f[j>>2]=Fa;f[wa>>2]=Ia;if(Fa){Ga=Fa+-4|0;f[Ga>>2]=(f[Ga>>2]|0)+1;Ga=f[j>>2]|0;Fa=f[wa>>2]|0;f[xa>>2]=Da;f[g>>2]=Ga;f[ya>>2]=Fa;if(!Ga)Pa=Da;else{Fa=Ga+-4|0;f[Fa>>2]=(f[Fa>>2]|0)+1;Pa=f[xa>>2]|0}}else{Qa=Ia;Ja=145}}else{f[j>>2]=0;f[wa>>2]=Ha;Qa=Ha;Ja=145}if((Ja|0)==145){Ja=0;f[xa>>2]=Da;f[g>>2]=0;f[ya>>2]=Qa;Pa=Da}f[za>>2]=Pa;Ha=f[v>>2]|0;a:do if(!Ha){Ra=v;Sa=v}else{Ia=f[g>>2]|0;Fa=(Ia|0)==0?1124530:Ia;Ga=f[Ha+16>>2]|0;b:do if((Ia|0)!=(Ga|0)){Ta=Aa;Ua=Ha;Va=Ga;while(1){Wa=(Va|0)==0?1124530:Va;if((gTb(Fa,Wa)|0)<0){Xa=f[Ua>>2]|0;if(!Xa){Ja=153;break}else{Ya=Ua;Za=Xa}}else{if((gTb(Wa,Fa)|0)>=0){_a=Ta;$a=Ua;break b}ab=Ua+4|0;Wa=f[ab>>2]|0;if(!Wa){Ja=156;break}else{Ya=ab;Za=Wa}}Va=f[Za+16>>2]|0;if((Ia|0)==(Va|0)){_a=Ya;$a=Za;break b}else{Ta=Ya;Ua=Za}}if((Ja|0)==153){Ja=0;Ra=Ua;Sa=Ua;break a}else if((Ja|0)==156){Ja=0;Ra=ab;Sa=Ua;break a}}else{_a=Aa;$a=Ha}while(0);Ra=_a;Sa=$a}while(0);if(f[Ra>>2]|0){bD(g);bD(j);bD(m);f[g>>2]=0;f[Ca>>2]=0;bb=aD(g,52)|0;cb=372923;db=bb+52|0;do{b[bb>>0]=b[cb>>0]|0;bb=bb+1|0;cb=cb+1|0}while((bb|0)<(db|0));bO(-215,g,372558,369853,663);bD(g);break}Ha=L5b(28)|0;Ia=f[g>>2]|0;f[Ha+16>>2]=Ia;f[Ha+20>>2]=f[ya>>2];if(!Ia)eb=Pa;else{Fa=Ia+-4|0;f[Fa>>2]=(f[Fa>>2]|0)+1;eb=f[za>>2]|0}f[Ha+24>>2]=eb;f[Ha>>2]=0;f[Ha+4>>2]=0;f[Ha+8>>2]=Sa;f[Ra>>2]=Ha;Fa=f[f[c>>2]>>2]|0;if(!Fa)fb=Ha;else{f[c>>2]=Fa;fb=f[Ra>>2]|0}mP(f[Aa>>2]|0,fb);f[Ba>>2]=(f[Ba>>2]|0)+1;bD(g);bD(j);bD(m)}while(0);Fa=f[_>>2]|0;c:do if(!Fa){gb=_;hb=_}else{Ha=f[h>>2]|0;Ia=(Ha|0)==0?1124530:Ha;Ga=f[Fa+16>>2]|0;d:do if((Ha|0)!=(Ga|0)){Ta=$;Va=Fa;Wa=Ga;while(1){Xa=(Wa|0)==0?1124530:Wa;if((gTb(Ia,Xa)|0)<0){ib=f[Va>>2]|0;if(!ib){Ja=170;break}else{jb=Va;kb=ib}}else{if((gTb(Xa,Ia)|0)>=0){lb=Ta;mb=Va;break d}nb=Va+4|0;Xa=f[nb>>2]|0;if(!Xa){Ja=173;break}else{jb=nb;kb=Xa}}Wa=f[kb+16>>2]|0;if((Ha|0)==(Wa|0)){lb=jb;mb=kb;break d}else{Ta=jb;Va=kb}}if((Ja|0)==170){Ja=0;gb=Va;hb=Va;break c}else if((Ja|0)==173){Ja=0;gb=nb;hb=Va;break c}}else{lb=$;mb=Fa}while(0);gb=lb;hb=mb}while(0);if(!(f[gb>>2]|0)){Fa=L5b(24)|0;Ha=f[h>>2]|0;f[Fa+16>>2]=Ha;f[Fa+20>>2]=f[q>>2];if(Ha|0){Ia=Ha+-4|0;f[Ia>>2]=(f[Ia>>2]|0)+1}f[Fa>>2]=0;f[Fa+4>>2]=0;f[Fa+8>>2]=hb;f[gb>>2]=Fa;Ia=f[f[d>>2]>>2]|0;if(!Ia)ob=Fa;else{f[d>>2]=Ia;ob=f[gb>>2]|0}mP(f[$>>2]|0,ob);f[aa>>2]=(f[aa>>2]|0)+1}}else Ja=9}while(0);if((Ja|0)==9){Ja=0;if((f[Ea+12>>2]|0)!=3){f[g>>2]=0;f[s>>2]=0;bb=aD(g,23)|0;cb=369829;db=bb+23|0;do{b[bb>>0]=b[cb>>0]|0;bb=bb+1|0;cb=cb+1|0}while((bb|0)<(db|0));bO(-215,g,372558,369853,623);bD(g)}Ia=Ea+20|0;Fa=0;do{Ha=f[(f[Ia>>2]|0)+4+(Fa<<2)>>2]|0;f[g>>2]=0;f[t>>2]=0;Ga=Ha+11|0;Ta=b[Ga>>0]|0;Wa=Ta<<24>>24<0?f[Ha+4>>2]|0:Ta&255;if(Wa|0){Ta=aD(g,Wa)|0;Vac(Ta|0,((b[Ga>>0]|0)<0?f[Ha>>2]|0:Ha)|0,Wa|0)|0}Wa=f[v>>2]|0;if(Wa){Ha=f[g>>2]|0;Ga=(Ha|0)==0?1124530:Ha;Ta=v;Xa=Wa;e:while(1){Wa=Xa;while(1){ib=f[Wa+16>>2]|0;if((ib|0)==(Ha|0))break;if((gTb((ib|0)==0?1124530:ib,Ga)|0)>=0)break;ib=f[Wa+4>>2]|0;if(!ib){pb=Ta;break e}else Wa=ib}Xa=f[Wa>>2]|0;if(!Xa){pb=Wa;break}else Ta=Wa}if((pb|0)!=(v|0)){Ta=f[pb+16>>2]|0;if((Ha|0)!=(Ta|0)?(gTb(Ga,(Ta|0)==0?1124530:Ta)|0)<0:0)Ja=25;else qb=pb}else Ja=25}else Ja=25;if((Ja|0)==25){Ja=0;qb=v}bD(g);if((qb|0)==(v|0)){f[g>>2]=0;f[w>>2]=0;bb=aD(g,55)|0;cb=372572;db=bb+55|0;do{b[bb>>0]=b[cb>>0]|0;bb=bb+1|0;cb=cb+1|0}while((bb|0)<(db|0));bO(-215,g,372558,369853,625);bD(g)}Fa=Fa+1|0}while((Fa|0)<3);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[x>>0]=4;f[g>>2]=1701080941;b[y>>0]=0;if(jxa(Ea,g)|0){f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[z>>0]=4;f[j>>2]=1701080941;b[A>>0]=0;tKb(Ea+24|0);Fa=kxa(f[Ea+60>>2]|0,j)|0;Ga=(f[Fa+20>>2]|0)==2?f[Fa+8>>2]|0:497760;Fa=b[Ga+11>>0]|0;if(((Fa<<24>>24<0?f[Ga+4>>2]|0:Fa&255)|0)==9)rb=(u6b(Ga,0,-1,372628,9)|0)==0;else rb=0;if((b[z>>0]|0)<0)O5b(f[j>>2]|0);sb=rb}else sb=0;if((b[x>>0]|0)<0)O5b(f[g>>2]|0);if(!sb){f[g>>2]=0;f[sa>>2]=0;bb=aD(g,77)|0;cb=372638;db=bb+77|0;do{b[bb>>0]=b[cb>>0]|0;bb=bb+1|0;cb=cb+1|0}while((bb|0)<(db|0));bO(-215,g,372558,369853,627);bD(g)}Ea=f[(f[Ia>>2]|0)+4>>2]|0;f[g>>2]=0;f[B>>2]=0;Ga=Ea+11|0;Fa=b[Ga>>0]|0;Ha=Fa<<24>>24<0?f[Ea+4>>2]|0:Fa&255;if(Ha|0){Fa=aD(g,Ha)|0;Vac(Fa|0,((b[Ga>>0]|0)<0?f[Ea>>2]|0:Ea)|0,Ha|0)|0}Ha=cua(c,g)|0;Ea=f[Ha>>2]|0;bD(g);Ha=f[(f[Ia>>2]|0)+8>>2]|0;f[g>>2]=0;f[C>>2]=0;Ga=Ha+11|0;Fa=b[Ga>>0]|0;Ta=Fa<<24>>24<0?f[Ha+4>>2]|0:Fa&255;if(Ta|0){Fa=aD(g,Ta)|0;Vac(Fa|0,((b[Ga>>0]|0)<0?f[Ha>>2]|0:Ha)|0,Ta|0)|0}Ta=cua(c,g)|0;Ha=f[Ta>>2]|0;bD(g);Ta=f[(f[Ia>>2]|0)+12>>2]|0;f[g>>2]=0;f[D>>2]=0;Ga=Ta+11|0;Fa=b[Ga>>0]|0;Xa=Fa<<24>>24<0?f[Ta+4>>2]|0:Fa&255;if(Xa|0){Fa=aD(g,Xa)|0;Vac(Fa|0,((b[Ga>>0]|0)<0?f[Ta>>2]|0:Ta)|0,Xa|0)|0}Xa=cua(c,g)|0;Ta=f[Xa>>2]|0;bD(g);Xa=f[(f[p>>2]|0)+4+(Ea<<2)>>2]|0;Ea=Xa+24|0;tKb(Ea);Ga=f[Xa+60>>2]|0;sKb(Ea);f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;b[E>>0]=5;b[g>>0]=b[471917]|0;b[g+1>>0]=b[471918]|0;b[g+2>>0]=b[471919]|0;b[g+3>>0]=b[471920]|0;b[g+4>>0]=b[471921]|0;b[F>>0]=0;Ea=bya(Ga,g)|0;Ga=Ea+20|0;if((f[Ga>>2]|0)==8)tb=f[Ea+8>>2]|0;else{TGa(Ea);f[Ga>>2]=8;Ga=f[Ea+4>>2]|0;Xa=Ga&-2;if(!(Ga&1))ub=Xa;else ub=f[Xa+4>>2]|0;if(!ub){Xa=L5b(172)|0;AFa(Xa);vb=Xa}else{Xa=znb(ub,18552,172)|0;BFa(Xa,ub);vb=Xa}f[Ea+8>>2]=vb;tb=vb}if((b[E>>0]|0)<0)O5b(f[g>>2]|0);Ea=tb+160|0;if((f[Ea>>2]|0)!=12){f[g>>2]=0;f[ra>>2]=0;bb=aD(g,40)|0;cb=372716;db=bb+40|0;do{b[bb>>0]=b[cb>>0]|0;bb=bb+1|0;cb=cb+1|0}while((bb|0)<(db|0));bO(-215,g,372558,369853,636);bD(g)}Ia=f[(f[p>>2]|0)+4+(Ha<<2)>>2]|0;tKb(Ia+24|0);Xa=f[Ia+60>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b[G>>0]=5;b[j>>0]=b[471917]|0;b[j+1>>0]=b[471918]|0;b[j+2>>0]=b[471919]|0;b[j+3>>0]=b[471920]|0;b[j+4>>0]=b[471921]|0;b[H>>0]=0;Ia=kxa(Xa,j)|0;if((f[Ia+20>>2]|0)==8)wb=f[Ia+8>>2]|0;else wb=GFa()|0;Ywa(g,wb);if((b[G>>0]|0)<0)O5b(f[j>>2]|0);Ia=f[(f[p>>2]|0)+4+(Ta<<2)>>2]|0;tKb(Ia+24|0);Xa=f[Ia+60>>2]|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;b[I>>0]=5;b[k>>0]=b[471917]|0;b[k+1>>0]=b[471918]|0;b[k+2>>0]=b[471919]|0;b[k+3>>0]=b[471920]|0;b[k+4>>0]=b[471921]|0;b[J>>0]=0;Ia=kxa(Xa,k)|0;if((f[Ia+20>>2]|0)==8)xb=f[Ia+8>>2]|0;else xb=GFa()|0;Ywa(j,xb);if((b[I>>0]|0)<0)O5b(f[k>>2]|0);Ia=f[K>>2]|0;if((Ia|0)<3)yb=Y(f[M>>2]|0,f[L>>2]|0)|0;else{Xa=f[ka>>2]|0;Ga=0;Fa=1;while(1){ib=Y(f[Xa+(Ga<<2)>>2]|0,Fa)|0;Ga=Ga+1|0;if((Ga|0)==(Ia|0)){yb=ib;break}else Fa=ib}}if((yb|0)!=1){f[k>>2]=0;f[qa>>2]=0;bb=aD(k,17)|0;cb=372757;db=bb+17|0;do{b[bb>>0]=b[cb>>0]|0;bb=bb+1|0;cb=cb+1|0}while((bb|0)<(db|0));bO(-215,k,372558,369853,641);bD(k)}if((f[g>>2]&4095|0)!=5){f[k>>2]=0;f[pa>>2]=0;bb=aD(k,56)|0;cb=372775;db=bb+56|0;do{b[bb>>0]=b[cb>>0]|0;bb=bb+1|0;cb=cb+1|0}while((bb|0)<(db|0));bO(-215,k,372558,369853,641);bD(k)}Fa=f[N>>2]|0;if((Fa|0)<3)zb=Y(f[P>>2]|0,f[O>>2]|0)|0;else{Ia=f[ga>>2]|0;Ga=0;Xa=1;while(1){Ta=Y(f[Ia+(Ga<<2)>>2]|0,Xa)|0;Ga=Ga+1|0;if((Ga|0)==(Fa|0)){zb=Ta;break}else Xa=Ta}}if((zb|0)!=1){f[k>>2]=0;f[oa>>2]=0;bb=aD(k,17)|0;cb=372832;db=bb+17|0;do{b[bb>>0]=b[cb>>0]|0;bb=bb+1|0;cb=cb+1|0}while((bb|0)<(db|0));bO(-215,k,372558,369853,641);bD(k)}if((f[j>>2]&4095|0)!=5){f[k>>2]=0;f[na>>2]=0;bb=aD(k,56)|0;cb=372850;db=bb+56|0;do{b[bb>>0]=b[cb>>0]|0;bb=bb+1|0;cb=cb+1|0}while((bb|0)<(db|0));bO(-215,k,372558,369853,641);bD(k)}Ywa(k,tb);Ab=+n[f[Q>>2]>>2];Bb=(+n[f[R>>2]>>2]-Ab)/255.0;if(!(Bb>=0.0)){f[l>>2]=0;f[S>>2]=0;bb=aD(l,15)|0;cb=372907;db=bb+15|0;do{b[bb>>0]=b[cb>>0]|0;bb=bb+1|0;cb=cb+1|0}while((bb|0)<(db|0));bO(-215,l,372558,369853,647);bD(l)}Xa=T;f[Xa>>2]=0;f[Xa+4>>2]=0;f[l>>2]=33619968;f[U>>2]=k;OJ(k,l,5,Bb,Bb*+(LVb(Ab/Bb)|0));f[Ea>>2]=1;Xa=f[V>>2]|0;Fa=f[W>>2]|0;if((Fa|0)<3)Cb=Y(f[Z>>2]|0,f[X>>2]|0)|0;else{Ga=f[ca>>2]|0;Ia=0;Ta=1;while(1){Ha=Y(f[Ga+(Ia<<2)>>2]|0,Ta)|0;Ia=Ia+1|0;if((Ia|0)==(Fa|0)){Cb=Ha;break}else Ta=Ha}}cya(tb,Xa,Y(1212424721>>>(f[k>>2]<<2&28)&15,Cb)|0);bxa(a,Da);Ta=f[_>>2]|0;f:do if(!Ta){Db=_;Eb=_}else{Fa=f[h>>2]|0;Ia=(Fa|0)==0?1124530:Fa;Ga=f[Ta+16>>2]|0;g:do if((Fa|0)!=(Ga|0)){Ea=$;Ha=Ta;ib=Ga;while(1){Fb=(ib|0)==0?1124530:ib;if((gTb(Ia,Fb)|0)<0){Gb=f[Ha>>2]|0;if(!Gb){Ja=94;break}else{Hb=Ha;Ib=Gb}}else{if((gTb(Fb,Ia)|0)>=0){Jb=Ea;Kb=Ha;break g}Lb=Ha+4|0;Fb=f[Lb>>2]|0;if(!Fb){Ja=97;break}else{Hb=Lb;Ib=Fb}}ib=f[Ib+16>>2]|0;if((Fa|0)==(ib|0)){Jb=Hb;Kb=Ib;break g}else{Ea=Hb;Ha=Ib}}if((Ja|0)==94){Ja=0;Db=Ha;Eb=Ha;break f}else if((Ja|0)==97){Ja=0;Db=Lb;Eb=Ha;break f}}else{Jb=$;Kb=Ta}while(0);Db=Jb;Eb=Kb}while(0);if(!(f[Db>>2]|0)){Ta=L5b(24)|0;Xa=f[h>>2]|0;f[Ta+16>>2]=Xa;f[Ta+20>>2]=f[q>>2];if(Xa|0){Fa=Xa+-4|0;f[Fa>>2]=(f[Fa>>2]|0)+1}f[Ta>>2]=0;f[Ta+4>>2]=0;f[Ta+8>>2]=Eb;f[Db>>2]=Ta;Fa=f[f[d>>2]>>2]|0;if(!Fa)Mb=Ta;else{f[d>>2]=Fa;Mb=f[Db>>2]|0}mP(f[$>>2]|0,Mb);f[aa>>2]=(f[aa>>2]|0)+1}Fa=f[ba>>2]|0;do if(Fa|0){Ta=Fa+12|0;Xa=f[Ta>>2]|0;f[Ta>>2]=Xa+-1;if((Xa|0)!=1)break;kL(k)}while(0);f[ba>>2]=0;f[V>>2]=0;f[V+4>>2]=0;f[V+8>>2]=0;f[V+12>>2]=0;if((f[W>>2]|0)>0){Fa=f[ca>>2]|0;Xa=0;do{f[Fa+(Xa<<2)>>2]=0;Xa=Xa+1|0}while((Xa|0)<(f[W>>2]|0))}Xa=f[da>>2]|0;if((Xa|0)!=(ea|0))UC(Xa);Xa=f[fa>>2]|0;do if(Xa|0){Fa=Xa+12|0;Ta=f[Fa>>2]|0;f[Fa>>2]=Ta+-1;if((Ta|0)!=1)break;kL(j)}while(0);f[fa>>2]=0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[N>>2]|0)>0){Xa=f[ga>>2]|0;Ta=0;do{f[Xa+(Ta<<2)>>2]=0;Ta=Ta+1|0}while((Ta|0)<(f[N>>2]|0))}Ta=f[ha>>2]|0;if((Ta|0)!=(ia|0))UC(Ta);Ta=f[ja>>2]|0;do if(Ta|0){Xa=Ta+12|0;Fa=f[Xa>>2]|0;f[Xa>>2]=Fa+-1;if((Fa|0)!=1)break;kL(g)}while(0);f[ja>>2]=0;f[Q>>2]=0;f[Q+4>>2]=0;f[Q+8>>2]=0;f[Q+12>>2]=0;if((f[K>>2]|0)>0){Ta=f[ka>>2]|0;Fa=0;do{f[Ta+(Fa<<2)>>2]=0;Fa=Fa+1|0}while((Fa|0)<(f[K>>2]|0))}Fa=f[la>>2]|0;if((Fa|0)!=(ma|0))UC(Fa)}bD(i);bD(h);Da=Da+1|0}while((Da|0)<(f[o>>2]|0));u=e;return}function Twa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=a+4|0;h=f[b>>2]|0;b=h;do if((h|0)!=(g|0)){i=f[e>>2]|0;j=f[h+16>>2]|0;if((i|0)!=(j|0)){if((gTb((i|0)==0?1124530:i,(j|0)==0?1124530:j)|0)<0)break;k=(i|0)==0?1124530:i;if((gTb((j|0)==0?1124530:j,k)|0)<0){j=h+4|0;l=f[j>>2]|0;if(!l){m=h+8|0;n=f[m>>2]|0;if((f[n>>2]|0)==(h|0))o=n;else{n=m;do{m=f[n>>2]|0;n=m+8|0;p=f[n>>2]|0}while((f[p>>2]|0)!=(m|0));o=p}}else{n=l;while(1){p=f[n>>2]|0;if(!p)break;else n=p}o=n}do if((o|0)!=(g|0)){l=f[o+16>>2]|0;if((i|0)!=(l|0)?(gTb(k,(l|0)==0?1124530:l)|0)<0:0)break;l=f[g>>2]|0;if(!l){f[c>>2]=g;q=g;return q|0}p=a+4|0;m=f[l+16>>2]|0;a:do if((i|0)!=(m|0)){r=p;s=l;t=m;while(1){u=(t|0)==0?1124530:t;if((gTb(k,u)|0)<0){v=f[s>>2]|0;if(!v){w=41;break}else{x=s;y=v}}else{if((gTb(u,k)|0)>=0){z=r;A=s;break a}B=s+4|0;u=f[B>>2]|0;if(!u){w=44;break}else{x=B;y=u}}t=f[y+16>>2]|0;if((i|0)==(t|0)){z=x;A=y;break a}else{r=x;s=y}}if((w|0)==41){f[c>>2]=s;q=s;return q|0}else if((w|0)==44){f[c>>2]=s;q=B;return q|0}}else{z=p;A=l}while(0);f[c>>2]=A;q=z;return q|0}while(0);if(!(f[h+4>>2]|0)){f[c>>2]=b;q=j;return q|0}else{f[c>>2]=o;q=o;return q|0}}}f[c>>2]=b;f[d>>2]=b;q=d;return q|0}while(0);d=f[h>>2]|0;do if((h|0)==(f[a>>2]|0))C=b;else{if(!d){o=h;while(1){z=f[o+8>>2]|0;if((f[z>>2]|0)==(o|0))o=z;else{D=z;break}}}else{o=d;while(1){j=f[o+4>>2]|0;if(!j){D=o;break}else o=j}}o=f[D+16>>2]|0;j=f[e>>2]|0;if((o|0)!=(j|0)?(gTb((o|0)==0?1124530:o,(j|0)==0?1124530:j)|0)<0:0){C=D;break}o=f[g>>2]|0;if(!o){f[c>>2]=g;q=g;return q|0}z=a+4|0;A=(j|0)==0?1124530:j;B=f[o+16>>2]|0;b:do if((j|0)!=(B|0)){y=z;x=o;i=B;while(1){k=(i|0)==0?1124530:i;if((gTb(A,k)|0)<0){n=f[x>>2]|0;if(!n){w=18;break}else{E=x;F=n}}else{if((gTb(k,A)|0)>=0){G=y;H=x;break b}I=x+4|0;k=f[I>>2]|0;if(!k){w=21;break}else{E=I;F=k}}i=f[F+16>>2]|0;if((j|0)==(i|0)){G=E;H=F;break b}else{y=E;x=F}}if((w|0)==18){f[c>>2]=x;q=x;return q|0}else if((w|0)==21){f[c>>2]=x;q=I;return q|0}}else{G=z;H=o}while(0);f[c>>2]=H;q=G;return q|0}while(0);if(!d){f[c>>2]=h;q=h;return q|0}else{h=C;f[c>>2]=h;q=h+4|0;return q|0}return 0}function Uwa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;h=u;u=u+32|0;i=h+16|0;j=h;do if((e|0)==-1){k=c+12|0;if((f[k>>2]|0)>0){l=c+20|0;m=j+4|0;n=i+11|0;o=i+4|0;p=d+4|0;q=j+4|0;r=0;s=-1;while(1){hxa(i,f[(f[l>>2]|0)+4+(r<<2)>>2]|0);f[j>>2]=0;f[m>>2]=0;t=b[n>>0]|0;v=t<<24>>24<0?f[o>>2]|0:t&255;if(v|0){t=aD(j,v)|0;Vac(t|0,((b[n>>0]|0)<0?f[i>>2]|0:i)|0,v|0)|0}v=f[p>>2]|0;if(v){t=f[j>>2]|0;w=(t|0)==0?1124530:t;x=p;y=v;a:while(1){v=y;while(1){z=f[v+16>>2]|0;if((z|0)==(t|0))break;if((gTb((z|0)==0?1124530:z,w)|0)>=0)break;z=f[v+4>>2]|0;if(!z){A=x;break a}else v=z}y=f[v>>2]|0;if(!y){A=v;break}else x=v}if((A|0)!=(p|0)){x=f[A+16>>2]|0;if((t|0)!=(x|0)?(gTb(w,(x|0)==0?1124530:x)|0)<0:0)B=16;else C=A}else B=16}else B=16;if((B|0)==16){B=0;C=p}bD(j);if((C|0)!=(p|0))if((s|0)==-1)D=r;else{f[j>>2]=0;f[q>>2]=0;E=aD(j,31)|0;F=372333;G=E+31|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-2,j,372365,369853,571);bD(j);D=r}else D=s;if((b[n>>0]|0)<0)O5b(f[i>>2]|0);r=r+1|0;if((r|0)>=(f[k>>2]|0))break;else s=D}if((D|0)!=-1){H=D;break}}f[i>>2]=0;f[i+4>>2]=0;E=aD(i,38)|0;F=372378;G=E+38|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-2,i,372365,369853,579);bD(i);H=-1}else H=e;while(0);hxa(i,f[(f[c+20>>2]|0)+4+(H<<2)>>2]|0);f[j>>2]=0;f[j+4>>2]=0;c=i+11|0;e=b[c>>0]|0;D=i+4|0;C=e<<24>>24<0?f[D>>2]|0:e&255;if(C|0){e=aD(j,C)|0;Vac(e|0,((b[c>>0]|0)<0?f[i>>2]|0:i)|0,C|0)|0}C=d+4|0;e=f[C>>2]|0;if(e){A=f[j>>2]|0;s=(A|0)==0?1124530:A;k=C;r=e;b:while(1){e=r;while(1){n=f[e+16>>2]|0;if((n|0)==(A|0))break;if((gTb((n|0)==0?1124530:n,s)|0)>=0)break;n=f[e+4>>2]|0;if(!n){I=k;break b}else e=n}r=f[e>>2]|0;if(!r){I=e;break}else k=e}if((I|0)!=(C|0)){k=f[I+16>>2]|0;if((A|0)!=(k|0)?(gTb(s,(k|0)==0?1124530:k)|0)<0:0)B=37;else J=I}else B=37}else B=37;if((B|0)==37)J=C;bD(j);if((J|0)==(C|0)){f[j>>2]=0;f[j+4>>2]=0;E=aD(j,28)|0;F=372417;G=E+28|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-2,j,372365,369853,583);bD(j)}if(f[i+12>>2]|0){f[j>>2]=0;f[j+4>>2]=0;E=aD(j,24)|0;F=372446;G=E+24|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-2,j,372365,369853,585);bD(j)}if(g|0)f[g>>2]=H;f[j>>2]=0;f[j+4>>2]=0;H=b[c>>0]|0;g=H<<24>>24<0?f[D>>2]|0:H&255;if(g|0){H=aD(j,g)|0;Vac(H|0,((b[c>>0]|0)<0?f[i>>2]|0:i)|0,g|0)|0}g=mxa(d,j)|0;d=f[g>>2]|0;bD(j);c:do if((d|0)<(f[a+12>>2]|0)?(g=f[(f[a+20>>2]|0)+4+(d<<2)>>2]|0,H=f[g+68>>2]|0,C=b[H+11>>0]|0,J=C<<24>>24<0,I=C&255,C=J?f[H+4>>2]|0:I,k=b[c>>0]|0,s=k<<24>>24<0,(C|0)==((s?f[D>>2]|0:k&255)|0)):0){k=f[H>>2]|0;A=J?k:H;r=s?f[i>>2]|0:i;s=(C|0)==0;d:do if(J){if(!s?ZVb(A,r,C)|0:0){B=61;break c}}else if(!s){if((k&255)<<24>>24==(b[r>>0]|0)){K=H;L=I;M=r}else{B=61;break c}while(1){L=L+-1|0;K=K+1|0;if(!L)break d;M=M+1|0;if((b[K>>0]|0)!=(b[M>>0]|0)){B=61;break c}}}while(0);tKb(g+24|0);r=f[g+60>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;I=j+11|0;b[I>>0]=5;b[j>>0]=b[471917]|0;b[j+1>>0]=b[471918]|0;b[j+2>>0]=b[471919]|0;b[j+3>>0]=b[471920]|0;b[j+4>>0]=b[471921]|0;b[j+5>>0]=0;H=kxa(r,j)|0;if((f[H+20>>2]|0)==8)N=f[H+8>>2]|0;else N=GFa()|0;if((b[I>>0]|0)<0)O5b(f[j>>2]|0);O=N}else B=61;while(0);if((B|0)==61){if((d|0)>=(f[a+52>>2]|0)){f[j>>2]=0;f[j+4>>2]=0;E=aD(j,28)|0;F=372471;G=E+28|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-215,j,372365,369853,599);bD(j)}N=a+60|0;a=f[(f[N>>2]|0)+4+(d<<2)>>2]|0;M=f[a+68>>2]|0;K=b[M+11>>0]|0;L=K<<24>>24<0;I=K&255;K=L?f[M+4>>2]|0:I;H=b[c>>0]|0;r=H<<24>>24<0;e:do if((K|0)==((r?f[D>>2]|0:H&255)|0)){k=f[M>>2]|0;s=L?k:M;C=r?f[i>>2]|0:i;A=(K|0)==0;if(L){if(A){P=a;break}if(!(ZVb(s,C,K)|0)){P=a;break}else{B=71;break}}if(!A)if((k&255)<<24>>24==(b[C>>0]|0)){k=M;A=I;s=C;while(1){A=A+-1|0;k=k+1|0;if(!A){P=a;break e}s=s+1|0;if((b[k>>0]|0)!=(b[s>>0]|0)){B=71;break}}}else B=71;else P=a}else B=71;while(0);if((B|0)==71){f[j>>2]=0;f[j+4>>2]=0;E=aD(j,46)|0;F=372500;G=E+46|0;do{b[E>>0]=b[F>>0]|0;E=E+1|0;F=F+1|0}while((E|0)<(G|0));bO(-215,j,372365,369853,599);bD(j);P=f[(f[N>>2]|0)+4+(d<<2)>>2]|0}tKb(P+24|0);d=f[P+60>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;P=j+11|0;b[P>>0]=5;b[j>>0]=b[471917]|0;b[j+1>>0]=b[471918]|0;b[j+2>>0]=b[471919]|0;b[j+3>>0]=b[471920]|0;b[j+4>>0]=b[471921]|0;b[j+5>>0]=0;N=kxa(d,j)|0;if((f[N+20>>2]|0)==8)Q=f[N+8>>2]|0;else Q=GFa()|0;if((b[P>>0]|0)<0)O5b(f[j>>2]|0);O=Q}if((b[c>>0]|0)>=0){u=h;return O|0}O5b(f[i>>2]|0);u=h;return O|0}function Vwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=u;u=u+80|0;e=d+64|0;g=d+8|0;h=d;f[e>>2]=0;i=e+4|0;f[i>>2]=0;f[e+8>>2]=0;Xwa(c,e);j=(f[i>>2]|0)-(f[e>>2]|0)|0;if((f[c+160>>2]|0)!=3){f[g>>2]=0;f[g+4>>2]=0;k=aD(g,38)|0;l=372215;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,372254,369853,334);bD(g)}if((j|0)!=4){f[g>>2]=0;f[g+4>>2]=0;k=aD(g,9)|0;l=372264;m=k+9|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,372254,369853,335);bD(g)}Ywa(g,c);if((f[g>>2]&4095|0)!=4){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,58)|0;l=372274;m=k+58|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,372254,369853,338);bD(h)}h=g+16|0;l=f[h>>2]|0;k=g+4|0;m=f[k>>2]|0;if((m|0)<3)n=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{c=f[g+40>>2]|0;j=0;o=1;while(1){p=Y(f[c+(j<<2)>>2]|0,o)|0;j=j+1|0;if((j|0)==(m|0)){n=p;break}else o=p}}o=L5b(16)|0;m=o+8|0;f[o>>2]=m;f[o+4>>2]=n;if(n>>>0>1){j=N5b(n>>>0>536870911?-1:n<<3)|0;f[o>>2]=j;q=j}else q=m;f[a>>2]=0;f[a+4>>2]=o;if((n|0)>0){o=l;l=0;while(1){a=f[o>>2]|0;m=q+(l<<3)|0;f[m>>2]=a;f[m+4>>2]=((a|0)<0)<<31>>31;l=l+1|0;if((l|0)==(n|0))break;else o=o+4|0}}o=g+36|0;n=f[o>>2]|0;if(n|0?(l=n+12|0,n=f[l>>2]|0,f[l>>2]=n+-1,(n|0)==1):0)kL(g);f[o>>2]=0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[k>>2]|0)>0){h=f[g+40>>2]|0;o=0;do{f[h+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[k>>2]|0))}k=f[g+44>>2]|0;if((k|0)!=(g+48|0))UC(k);k=f[e>>2]|0;if(!k){u=d;return}e=f[i>>2]|0;if((e|0)!=(k|0))f[i>>2]=e+(~((e+-4-k|0)>>>2)<<2);O5b(k);u=d;return}function Wwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1124530:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((gTb((r|0)==0?1124530:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){t=n;break}o=f[c>>2]|0;f[e>>2]=0;p=L5b(16)|0;r=p+8|0;f[p>>2]=r;f[p+4>>2]=1;f[e+4>>2]=p;p=r;f[p>>2]=o;f[p+4>>2]=((o|0)<0)<<31>>31;$xa(s+24|0,e)|0;gua(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=f[c>>2]|0;f[i>>2]=0;t=L5b(16)|0;k=t+8|0;f[t>>2]=k;f[t+4>>2]=1;f[i+4>>2]=t;t=k;f[t>>2]=b;f[t+4>>2]=((b|0)<0)<<31>>31;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;iua(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;iua(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1124530:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1124530:A;if((gTb(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=24;break}else{E=z;F=C}}else{if((gTb(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=27;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==24){v=z;w=z;break b}else if((D|0)==27){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=L5b(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}iua(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}mP(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}gua(t);bD(e);gua(s);bD(g);gua(i);bD(h);u=d;return c|0}function Xwa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+16|0;e=d;g=f[c>>2]|0;h=c+4|0;i=f[h>>2]|0;j=g;if((i|0)==(g|0))k=i;else{l=i+(~((i+-4-j|0)>>>2)<<2)|0;f[h>>2]=l;k=l}l=k;if((a|0)!=492056?(i=f[a+156>>2]|0,i|0):0){a=f[i+12>>2]|0;if(!a){f[e>>2]=1;switch(l-j>>2|0){case 0:{Rr(c,1,e);break}case 1:break;default:{m=g+4|0;if((k|0)!=(m|0))f[h>>2]=k+(~((k+-4-m|0)>>>2)<<2)}}u=d;return}m=l-j>>2;if(a>>>0<=m>>>0){if(a>>>0<m>>>0?(j=g+(a<<2)|0,(k|0)!=(j|0)):0)f[h>>2]=k+(~((k+-4-j|0)>>>2)<<2)}else HC(c,a-m|0);if((a|0)<=0){u=d;return}m=f[i+20>>2]|0;i=f[c>>2]|0;c=0;do{f[i+(c<<2)>>2]=f[(f[m+4+(c<<2)>>2]|0)+16>>2];c=c+1|0}while((c|0)!=(a|0));u=d;return}f[e>>2]=0;f[e+4>>2]=0;a=aD(e,29)|0;c=372165;m=a+29|0;do{b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0}while((a|0)<(m|0));bO(-2,e,372195,369853,86);bD(e);u=d;return}function Ywa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0;d=u;u=u+560|0;e=d+536|0;g=d+128|0;h=d+480|0;i=d+424|0;j=d+368|0;k=d+312|0;l=d+256|0;m=d+200|0;n=d+72|0;o=d+16|0;p=d;q=d+144|0;X5b(g,f[c+152>>2]|0);a:do switch(f[c+160>>2]|0){case 1:{r=g+11|0;s=b[r>>0]|0;t=s<<24>>24<0;v=t?f[g+4>>2]|0:s&255;if(v|0){s=v>>>2;v=t?f[g>>2]|0:g;f[h>>2]=1124007941;t=h+4|0;f[t>>2]=2;w=h+8|0;f[w>>2]=1;x=h+12|0;f[x>>2]=s;y=h+16|0;f[y>>2]=v;z=h+20|0;f[z>>2]=v;A=h+24|0;B=h+28|0;C=h+40|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;f[C>>2]=w;D=h+48|0;E=h+44|0;f[E>>2]=D;f[h+52>>2]=0;f[D>>2]=0;if((s|0)!=0&(v|0)==0){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,26)|0;G=426262;H=F+26|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,426289,431198,500);bD(e);I=f[x>>2]|0;J=f[h>>2]|0;K=f[E>>2]|0;L=f[z>>2]|0}else{I=s;J=1124007941;K=D;L=v}M=I<<2;f[h>>2]=J|16384;f[K>>2]=M;f[K+4>>2]=4;N=L+(Y(f[w>>2]|0,M)|0)|0;f[B>>2]=N;f[A>>2]=N+(0-M)+M;f[a>>2]=1124007936;M=a+8|0;N=a+40|0;F=a+4|0;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[N>>2]=M;A=a+48|0;f[a+44>>2]=A;f[A>>2]=0;f[a+52>>2]=0;A=e+8|0;f[A>>2]=0;f[A+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;SP(h,e);A=h+36|0;B=f[A>>2]|0;if(B|0?(w=B+12|0,B=f[w>>2]|0,f[w>>2]=B+-1,(B|0)==1):0)kL(h);f[A>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[t>>2]|0)>0){A=f[C>>2]|0;B=0;do{f[A+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[t>>2]|0))}t=f[E>>2]|0;if((t|0)==(D|0)){O=r;break a}UC(t);O=r;break a}t=c+24|0;B=f[t>>2]|0;if(!B){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,14)|0;G=372116;H=F+14|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,372131,369853,102);bD(e);P=f[t>>2]|0}else P=B;D=f[c+32>>2]|0;E=(D|0)==0?0:D+4|0;f[i>>2]=1124007941;D=i+4|0;f[D>>2]=2;A=i+8|0;f[A>>2]=1;C=i+12|0;f[C>>2]=P;y=i+16|0;f[y>>2]=E;M=i+20|0;f[M>>2]=E;N=i+24|0;w=i+28|0;v=i+40|0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;f[v>>2]=A;s=i+48|0;z=i+44|0;f[z>>2]=s;f[i+52>>2]=0;f[s>>2]=0;if((P|0)!=0&(E|0)==0){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,26)|0;G=426262;H=F+26|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,426289,431198,500);bD(e);Q=f[C>>2]|0;R=f[i>>2]|0;S=f[z>>2]|0;T=f[M>>2]|0}else{Q=P;R=1124007941;S=s;T=E}B=Q<<2;f[i>>2]=R|16384;f[S>>2]=B;f[S+4>>2]=4;t=T+(Y(f[A>>2]|0,B)|0)|0;f[w>>2]=t;f[N>>2]=t+(0-B)+B;f[a>>2]=1124007936;B=a+8|0;t=a+40|0;F=a+4|0;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[t>>2]=B;N=a+48|0;f[a+44>>2]=N;f[N>>2]=0;f[a+52>>2]=0;N=e+8|0;f[N>>2]=0;f[N+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;SP(i,e);N=i+36|0;w=f[N>>2]|0;if(w|0?(A=w+12|0,w=f[A>>2]|0,f[A>>2]=w+-1,(w|0)==1):0)kL(i);f[N>>2]=0;f[y>>2]=0;f[y+4>>2]=0;f[y+8>>2]=0;f[y+12>>2]=0;if((f[D>>2]|0)>0){N=f[v>>2]|0;w=0;do{f[N+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[D>>2]|0))}D=f[z>>2]|0;if((D|0)==(s|0))O=r;else{UC(D);O=r}break}case 2:{D=g+11|0;w=b[D>>0]|0;N=w<<24>>24<0;v=N?f[g+4>>2]|0:w&255;if(v|0){w=v>>>3;v=N?f[g>>2]|0:g;f[j>>2]=1124007942;N=j+4|0;f[N>>2]=2;y=j+8|0;f[y>>2]=1;B=j+12|0;f[B>>2]=w;t=j+16|0;f[t>>2]=v;A=j+20|0;f[A>>2]=v;E=j+24|0;M=j+28|0;C=j+40|0;f[E>>2]=0;f[E+4>>2]=0;f[E+8>>2]=0;f[E+12>>2]=0;f[C>>2]=y;x=j+48|0;U=j+44|0;f[U>>2]=x;f[j+52>>2]=0;f[x>>2]=0;if((w|0)!=0&(v|0)==0){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,26)|0;G=426262;H=F+26|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,426289,431198,500);bD(e);V=f[B>>2]|0;W=f[j>>2]|0;X=f[U>>2]|0;Z=f[A>>2]|0}else{V=w;W=1124007942;X=x;Z=v}r=V<<3;f[j>>2]=W|16384;f[X>>2]=r;f[X+4>>2]=8;s=Z+(Y(f[y>>2]|0,r)|0)|0;f[M>>2]=s;f[E>>2]=s+(0-r)+r;f[a>>2]=1124007936;r=a+8|0;s=a+40|0;F=a+4|0;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[s>>2]=r;E=a+48|0;f[a+44>>2]=E;f[E>>2]=0;f[a+52>>2]=0;E=e+8|0;f[E>>2]=0;f[E+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;SP(j,e);E=j+36|0;M=f[E>>2]|0;if(M|0?(y=M+12|0,M=f[y>>2]|0,f[y>>2]=M+-1,(M|0)==1):0)kL(j);f[E>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[N>>2]|0)>0){E=f[C>>2]|0;M=0;do{f[E+(M<<2)>>2]=0;M=M+1|0}while((M|0)<(f[N>>2]|0))}N=f[U>>2]|0;if((N|0)==(x|0)){O=D;break a}UC(N);O=D;break a}N=c+40|0;M=f[N>>2]|0;if(!M){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,14)|0;G=372116;H=F+14|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,372131,369853,113);bD(e);_=f[N>>2]|0}else _=M;x=f[c+48>>2]|0;U=(x|0)==0?0:x+8|0;f[k>>2]=1124007942;x=k+4|0;f[x>>2]=2;E=k+8|0;f[E>>2]=1;C=k+12|0;f[C>>2]=_;t=k+16|0;f[t>>2]=U;r=k+20|0;f[r>>2]=U;s=k+24|0;y=k+28|0;v=k+40|0;f[s>>2]=0;f[s+4>>2]=0;f[s+8>>2]=0;f[s+12>>2]=0;f[v>>2]=E;w=k+48|0;A=k+44|0;f[A>>2]=w;f[k+52>>2]=0;f[w>>2]=0;if((_|0)!=0&(U|0)==0){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,26)|0;G=426262;H=F+26|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,426289,431198,500);bD(e);$=f[C>>2]|0;aa=f[k>>2]|0;ba=f[A>>2]|0;ca=f[r>>2]|0}else{$=_;aa=1124007942;ba=w;ca=U}M=$<<3;f[k>>2]=aa|16384;f[ba>>2]=M;f[ba+4>>2]=8;N=ca+(Y(f[E>>2]|0,M)|0)|0;f[y>>2]=N;f[s>>2]=N+(0-M)+M;f[a>>2]=1124007936;M=a+8|0;N=a+40|0;F=a+4|0;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[N>>2]=M;s=a+48|0;f[a+44>>2]=s;f[s>>2]=0;f[a+52>>2]=0;s=e+8|0;f[s>>2]=0;f[s+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;SP(k,e);s=k+36|0;y=f[s>>2]|0;if(y|0?(E=y+12|0,y=f[E>>2]|0,f[E>>2]=y+-1,(y|0)==1):0)kL(k);f[s>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[x>>2]|0)>0){s=f[v>>2]|0;y=0;do{f[s+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[x>>2]|0))}x=f[A>>2]|0;if((x|0)==(w|0))O=D;else{UC(x);O=D}break}case 3:{x=g+11|0;y=b[x>>0]|0;s=y<<24>>24<0;v=s?f[g+4>>2]|0:y&255;if(v|0){y=v>>>2;v=s?f[g>>2]|0:g;f[l>>2]=1124007940;s=l+4|0;f[s>>2]=2;t=l+8|0;f[t>>2]=1;M=l+12|0;f[M>>2]=y;N=l+16|0;f[N>>2]=v;E=l+20|0;f[E>>2]=v;U=l+24|0;r=l+28|0;C=l+40|0;f[U>>2]=0;f[U+4>>2]=0;f[U+8>>2]=0;f[U+12>>2]=0;f[C>>2]=t;B=l+48|0;z=l+44|0;f[z>>2]=B;f[l+52>>2]=0;f[B>>2]=0;if((y|0)!=0&(v|0)==0){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,26)|0;G=426262;H=F+26|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,426289,431198,500);bD(e);da=f[M>>2]|0;ea=f[l>>2]|0;fa=f[z>>2]|0;ga=f[E>>2]|0}else{da=y;ea=1124007940;fa=B;ga=v}D=da<<2;f[l>>2]=ea|16384;f[fa>>2]=D;f[fa+4>>2]=4;w=ga+(Y(f[t>>2]|0,D)|0)|0;f[r>>2]=w;f[U>>2]=w+(0-D)+D;f[a>>2]=1124007936;D=a+8|0;w=a+40|0;F=a+4|0;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[w>>2]=D;U=a+48|0;f[a+44>>2]=U;f[U>>2]=0;f[a+52>>2]=0;U=e+8|0;f[U>>2]=0;f[U+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;SP(l,e);U=l+36|0;r=f[U>>2]|0;if(r|0?(t=r+12|0,r=f[t>>2]|0,f[t>>2]=r+-1,(r|0)==1):0)kL(l);f[U>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[s>>2]|0)>0){U=f[C>>2]|0;r=0;do{f[U+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[s>>2]|0))}s=f[z>>2]|0;if((s|0)==(B|0)){O=x;break a}UC(s);O=x;break a}s=c+56|0;r=f[s>>2]|0;if(!r){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,14)|0;G=372116;H=F+14|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,372131,369853,124);bD(e);ha=f[s>>2]|0}else ha=r;B=f[c+64>>2]|0;z=(B|0)==0?0:B+4|0;f[m>>2]=1124007940;B=m+4|0;f[B>>2]=2;U=m+8|0;f[U>>2]=1;C=m+12|0;f[C>>2]=ha;N=m+16|0;f[N>>2]=z;D=m+20|0;f[D>>2]=z;w=m+24|0;t=m+28|0;v=m+40|0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[v>>2]=U;y=m+48|0;E=m+44|0;f[E>>2]=y;f[m+52>>2]=0;f[y>>2]=0;if((ha|0)!=0&(z|0)==0){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,26)|0;G=426262;H=F+26|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,426289,431198,500);bD(e);ia=f[C>>2]|0;ja=f[m>>2]|0;ka=f[E>>2]|0;la=f[D>>2]|0}else{ia=ha;ja=1124007940;ka=y;la=z}r=ia<<2;f[m>>2]=ja|16384;f[ka>>2]=r;f[ka+4>>2]=4;s=la+(Y(f[U>>2]|0,r)|0)|0;f[t>>2]=s;f[w>>2]=s+(0-r)+r;f[a>>2]=1124007936;r=a+8|0;s=a+40|0;F=a+4|0;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[s>>2]=r;w=a+48|0;f[a+44>>2]=w;f[w>>2]=0;f[a+52>>2]=0;w=e+8|0;f[w>>2]=0;f[w+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;SP(m,e);w=m+36|0;t=f[w>>2]|0;if(t|0?(U=t+12|0,t=f[U>>2]|0,f[U>>2]=t+-1,(t|0)==1):0)kL(m);f[w>>2]=0;f[N>>2]=0;f[N+4>>2]=0;f[N+8>>2]=0;f[N+12>>2]=0;if((f[B>>2]|0)>0){w=f[v>>2]|0;t=0;do{f[w+(t<<2)>>2]=0;t=t+1|0}while((t|0)<(f[B>>2]|0))}B=f[E>>2]|0;if((B|0)==(y|0))O=x;else{UC(B);O=x}break}case 19:{f[n>>2]=1124007936;B=n+4|0;t=n+8|0;w=n+40|0;F=B;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[w>>2]=t;x=n+48|0;y=n+44|0;f[y>>2]=x;f[x>>2]=0;f[n+52>>2]=0;E=g+11|0;v=b[E>>0]|0;N=v<<24>>24<0;r=N?f[g+4>>2]|0:v&255;if(!r){v=c+8|0;s=f[v>>2]|0;if(!s){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,14)|0;G=372116;H=F+14|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,372131,369853,139);bD(e);ma=f[v>>2]|0}else ma=s;U=f[c+16>>2]|0;z=(U|0)==0?0:U+4|0;f[o>>2]=1124007940;U=o+4|0;f[U>>2]=2;D=o+8|0;f[D>>2]=1;C=o+12|0;f[C>>2]=ma;M=o+16|0;f[M>>2]=z;A=o+20|0;f[A>>2]=z;na=o+24|0;oa=o+28|0;pa=o+40|0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;f[pa>>2]=D;qa=o+48|0;ra=o+44|0;f[ra>>2]=qa;f[o+52>>2]=0;f[qa>>2]=0;if((ma|0)!=0&(z|0)==0){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,26)|0;G=426262;H=F+26|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,426289,431198,500);bD(e);sa=f[C>>2]|0;ta=f[o>>2]|0;ua=f[ra>>2]|0;va=f[A>>2]|0}else{sa=ma;ta=1124007940;ua=qa;va=z}s=sa<<2;f[o>>2]=ta|16384;f[ua>>2]=s;f[ua+4>>2]=4;v=va+(Y(f[D>>2]|0,s)|0)|0;f[oa>>2]=v;f[na>>2]=v+(0-s)+s;s=e+8|0;f[s>>2]=0;f[s+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=n;OJ(o,e,2,1.0,0.0);s=o+36|0;v=f[s>>2]|0;if(v|0?(wa=v+12|0,v=f[wa>>2]|0,f[wa>>2]=v+-1,(v|0)==1):0)kL(o);f[s>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[U>>2]|0)>0){s=f[pa>>2]|0;v=0;do{f[s+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[U>>2]|0))}U=f[ra>>2]|0;if((U|0)!=(qa|0))UC(U);xa=n+16|0}else{U=r>>>1;v=N?f[g>>2]|0:g;f[o>>2]=1124007938;s=o+4|0;f[s>>2]=2;pa=o+8|0;f[pa>>2]=1;M=o+12|0;f[M>>2]=U;na=o+16|0;f[na>>2]=v;oa=o+20|0;f[oa>>2]=v;D=o+24|0;z=o+28|0;A=o+40|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;f[A>>2]=pa;C=o+48|0;wa=o+44|0;f[wa>>2]=C;f[o+52>>2]=0;f[C>>2]=0;if((U|0)!=0&(v|0)==0){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,26)|0;G=426262;H=F+26|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,426289,431198,500);bD(e);N=o+36|0;ya=N;za=f[M>>2]|0;Aa=f[o>>2]|0;Ba=f[wa>>2]|0;Ca=f[oa>>2]|0;Da=f[N>>2]|0}else{ya=o+36|0;za=U;Aa=1124007938;Ba=C;Ca=v;Da=0}N=za<<1;f[o>>2]=Aa|16384;f[Ba>>2]=N;f[Ba+4>>2]=2;r=Ca+(Y(f[pa>>2]|0,N)|0)|0;f[z>>2]=r;f[D>>2]=r+(0-N)+N;if(Da|0){N=Da+12|0;f[N>>2]=(f[N>>2]|0)+1}N=n+36|0;r=f[N>>2]|0;if(r|0?(qa=r+12|0,r=f[qa>>2]|0,f[qa>>2]=r+-1,(r|0)==1):0)kL(n);f[N>>2]=0;r=n+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[B>>2]|0)>0){qa=f[w>>2]|0;ra=0;do{f[qa+(ra<<2)>>2]=0;ra=ra+1|0;Ea=f[B>>2]|0}while((ra|0)<(Ea|0));f[n>>2]=f[o>>2];if((Ea|0)<3)Fa=85;else Fa=87}else{f[n>>2]=f[o>>2];Fa=85}if((Fa|0)==85){ra=f[s>>2]|0;if((ra|0)<3){f[B>>2]=ra;f[t>>2]=f[pa>>2];f[n+12>>2]=f[M>>2];ra=f[wa>>2]|0;qa=f[y>>2]|0;f[qa>>2]=f[ra>>2];f[qa+4>>2]=f[ra+4>>2]}else Fa=87}if((Fa|0)==87)jL(n,o);f[r>>2]=f[na>>2];f[n+20>>2]=f[oa>>2];f[n+24>>2]=f[D>>2];f[n+28>>2]=f[z>>2];f[n+32>>2]=f[o+32>>2];ra=f[ya>>2]|0;f[N>>2]=ra;if(ra|0?(qa=ra+12|0,ra=f[qa>>2]|0,f[qa>>2]=ra+-1,(ra|0)==1):0)kL(o);f[ya>>2]=0;f[na>>2]=0;f[na+4>>2]=0;f[na+8>>2]=0;f[na+12>>2]=0;if((f[s>>2]|0)>0){ra=f[A>>2]|0;qa=0;do{f[ra+(qa<<2)>>2]=0;qa=qa+1|0}while((qa|0)<(f[s>>2]|0))}s=f[wa>>2]|0;if((s|0)!=(C|0))UC(s);xa=r}s=f[w>>2]|0;qa=f[s+4>>2]|0;ra=f[s>>2]|0;A=f[xa>>2]|0;f[o>>2]=1124007939;na=o+4|0;f[na>>2]=2;N=o+8|0;f[N>>2]=ra;z=o+12|0;f[z>>2]=qa;D=o+16|0;f[D>>2]=A;oa=o+20|0;f[oa>>2]=A;M=o+24|0;pa=o+28|0;t=o+40|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;f[t>>2]=N;v=o+48|0;U=o+44|0;f[U>>2]=v;f[o+52>>2]=0;f[v>>2]=0;if((Y(ra,qa)|0)!=0&(A|0)==0){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,26)|0;G=426262;H=F+26|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,426289,431198,533);bD(e);Ga=f[z>>2]|0;Ha=f[o>>2]|0;Ia=f[U>>2]|0;Ja=f[oa>>2]|0;Ka=f[w>>2]|0}else{Ga=qa;Ha=1124007939;Ia=v;Ja=A;Ka=s}r=Ga<<1;f[o>>2]=Ha|16384;f[Ia>>2]=r;f[Ia+4>>2]=2;C=Ja+(Y(f[N>>2]|0,r)|0)|0;f[pa>>2]=C;f[M>>2]=C+(0-r)+r;r=f[Ka+4>>2]|0;C=f[Ka>>2]|0;f[a>>2]=1124007936;wa=a+8|0;ra=a+40|0;F=a+4|0;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[ra>>2]=wa;M=a+48|0;f[a+44>>2]=M;f[M>>2]=0;f[a+52>>2]=0;f[e>>2]=C;f[e+4>>2]=r;hL(a,2,e,5);f[e+8>>2]=0;f[e+12>>2]=0;f[e>>2]=16842752;f[e+4>>2]=o;M=p+8|0;f[M>>2]=0;f[M+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=a;LJ(e,p);M=o+36|0;pa=f[M>>2]|0;if(pa|0?(N=pa+12|0,pa=f[N>>2]|0,f[N>>2]=pa+-1,(pa|0)==1):0)kL(o);f[M>>2]=0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[na>>2]|0)>0){M=f[t>>2]|0;pa=0;do{f[M+(pa<<2)>>2]=0;pa=pa+1|0}while((pa|0)<(f[na>>2]|0))}na=f[U>>2]|0;if((na|0)!=(v|0))UC(na);na=n+36|0;pa=f[na>>2]|0;if(pa|0?(M=pa+12|0,pa=f[M>>2]|0,f[M>>2]=pa+-1,(pa|0)==1):0)kL(n);f[na>>2]=0;f[xa>>2]=0;f[xa+4>>2]=0;f[xa+8>>2]=0;f[xa+12>>2]=0;if((f[B>>2]|0)>0){na=f[w>>2]|0;pa=0;do{f[na+(pa<<2)>>2]=0;pa=pa+1|0}while((pa|0)<(f[B>>2]|0))}B=f[y>>2]|0;if((B|0)!=(x|0))UC(B);O=E;break}case 12:{B=g+11|0;pa=b[B>>0]|0;na=g+4|0;w=f[na>>2]|0;if(!((pa<<24>>24<0?w:pa&255)|0)){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,16)|0;G=372148;H=F+16|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,372131,369853,151);bD(e);La=b[B>>0]|0;Ma=f[na>>2]|0}else{La=pa;Ma=w}E=La<<24>>24<0;x=E?Ma:La&255;y=E?f[g>>2]|0:g;f[q>>2]=1124007936;E=q+4|0;f[E>>2]=2;v=q+8|0;f[v>>2]=1;U=q+12|0;f[U>>2]=x;M=q+16|0;f[M>>2]=y;t=q+20|0;f[t>>2]=y;D=q+24|0;r=q+28|0;C=q+40|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;f[C>>2]=v;wa=q+48|0;ra=q+44|0;f[ra>>2]=wa;f[q+52>>2]=0;f[wa>>2]=0;if((x|0)!=0&(y|0)==0){f[e>>2]=0;f[e+4>>2]=0;F=aD(e,26)|0;G=426262;H=F+26|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-215,e,426289,431198,500);bD(e);Na=f[q>>2]|0;Oa=f[U>>2]|0;Pa=f[ra>>2]|0;Qa=f[t>>2]|0}else{Na=1124007936;Oa=x;Pa=wa;Qa=y}f[q>>2]=Na|16384;f[Pa>>2]=Oa;f[Pa+4>>2]=1;w=Qa+(Y(f[v>>2]|0,Oa)|0)|0;f[r>>2]=w;f[D>>2]=w+(0-Oa)+Oa;f[a>>2]=1124007936;w=a+8|0;pa=a+40|0;F=a+4|0;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[pa>>2]=w;D=a+48|0;f[a+44>>2]=D;f[D>>2]=0;f[a+52>>2]=0;D=e+8|0;f[D>>2]=0;f[D+4>>2]=0;f[e>>2]=33619968;f[e+4>>2]=a;SP(q,e);D=q+36|0;r=f[D>>2]|0;if(r|0?(v=r+12|0,r=f[v>>2]|0,f[v>>2]=r+-1,(r|0)==1):0)kL(q);f[D>>2]=0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[E>>2]|0)>0){D=f[C>>2]|0;r=0;do{f[D+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[E>>2]|0))}E=f[ra>>2]|0;if((E|0)==(wa|0))O=B;else{UC(E);O=B}break}default:{f[e>>2]=0;f[e+4>>2]=0;F=aD(e,35)|0;G=372065;H=F+35|0;do{b[F>>0]=b[G>>0]|0;F=F+1|0;G=G+1|0}while((F|0)<(H|0));bO(-2,e,372131,369853,155);bD(e);f[a>>2]=1124007936;B=a+8|0;wa=a+40|0;F=a+4|0;H=F+36|0;do{f[F>>2]=0;F=F+4|0}while((F|0)<(H|0));f[wa>>2]=B;ra=a+48|0;f[a+44>>2]=ra;f[ra>>2]=0;f[a+52>>2]=0;O=g+11|0}}while(0);if((b[O>>0]|0)>=0){u=d;return}O5b(f[g>>2]|0);u=d;return}function Zwa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1124530:l;o=l;q=j;r=k;a:while(1){s=r;while(1){t=f[s+16>>2]|0;if((t|0)==(l|0))break;if((gTb((t|0)==0?1124530:t,m)|0)>=0)break;t=f[s+4>>2]|0;if(!t){v=q;break a}else s=t}r=f[s>>2]|0;if(!r){v=s;break}else q=s}if((v|0)==(j|0))w=o;else{q=f[v+16>>2]|0;if((l|0)!=(q|0)?(gTb(m,(q|0)==0?1124530:q)|0)<=-1:0){w=o;break}x=+n[c>>2];f[e>>2]=2;q=L5b(16)|0;r=q+8|0;f[q>>2]=r;f[q+4>>2]=1;f[e+4>>2]=q;p[r>>3]=x;$xa(v+24|0,e)|0;gua(e);u=d;return c|0}}else w=f[b>>2]|0;while(0);f[h>>2]=w;v=h+4|0;f[v>>2]=f[b+4>>2];if(w|0){b=w+-4|0;f[b>>2]=(f[b>>2]|0)+1}x=+n[c>>2];f[i>>2]=2;b=L5b(16)|0;w=b+8|0;f[b>>2]=w;f[b+4>>2]=1;f[i+4>>2]=b;p[w>>3]=x;w=f[h>>2]|0;f[g>>2]=w;b=g+4|0;f[b>>2]=f[v>>2];if(w|0){v=w+-4|0;f[v>>2]=(f[v>>2]|0)+1}v=g+8|0;iua(v,i);w=f[g>>2]|0;f[e>>2]=w;k=e+4|0;f[k>>2]=f[b>>2];if(w|0){b=w+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=e+8|0;iua(b,v);w=f[j>>2]|0;b:do if(!w){y=j;z=j}else{r=a+4|0;q=f[e>>2]|0;t=(q|0)==0?1124530:q;A=f[w+16>>2]|0;c:do if((q|0)!=(A|0)){B=r;C=w;D=A;while(1){E=(D|0)==0?1124530:D;if((gTb(t,E)|0)<0){F=f[C>>2]|0;if(!F){G=24;break}else{H=C;I=F}}else{if((gTb(E,t)|0)>=0){J=B;K=C;break c}L=C+4|0;E=f[L>>2]|0;if(!E){G=27;break}else{H=L;I=E}}D=f[I+16>>2]|0;if((q|0)==(D|0)){J=H;K=I;break c}else{B=H;C=I}}if((G|0)==24){y=C;z=C;break b}else if((G|0)==27){y=L;z=C;break b}}else{J=r;K=w}while(0);y=J;z=K}while(0);if(!(f[y>>2]|0)){K=L5b(32)|0;J=f[e>>2]|0;f[K+16>>2]=J;f[K+20>>2]=f[k>>2];if(J|0){k=J+-4|0;f[k>>2]=(f[k>>2]|0)+1}iua(K+24|0,b);f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=z;f[y>>2]=K;z=f[f[a>>2]>>2]|0;if(!z)M=K;else{f[a>>2]=z;M=f[y>>2]|0}mP(f[a+4>>2]|0,M);M=a+8|0;f[M>>2]=(f[M>>2]|0)+1}gua(b);bD(e);gua(v);bD(g);gua(i);bD(h);u=d;return c|0}function _wa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;g=u;u=u+64|0;h=g+48|0;i=g+32|0;j=g;k=g+16|0;f[a>>2]=0;l=a+4|0;f[l>>2]=0;f[a+8>>2]=0;m=c+12|0;n=f[m>>2]|0;if((n|0)<=0){u=g;return}o=c+20|0;c=h+4|0;p=i+11|0;q=i+4|0;r=e+4|0;s=j+12|0;t=i+4|0;v=j+11|0;w=j+4|0;x=i+8|0;y=a+8|0;z=k+11|0;A=i+4|0;B=0;C=n;while(1){n=f[(f[o>>2]|0)+4+(B<<2)>>2]|0;D=n+12|0;if((f[D>>2]|0)>0){E=n+20|0;F=n+68|0;G=n+72|0;n=0;do{hxa(i,f[(f[E>>2]|0)+4+(n<<2)>>2]|0);f[h>>2]=0;f[c>>2]=0;H=b[p>>0]|0;I=H<<24>>24<0?f[q>>2]|0:H&255;if(!I)J=H;else{H=aD(h,I)|0;Vac(H|0,((b[p>>0]|0)<0?f[i>>2]|0:i)|0,I|0)|0;J=b[p>>0]|0}if(J<<24>>24<0)O5b(f[i>>2]|0);if(!(f[r>>2]|0))K=1;else{I=f[G>>2]|0;f[i>>2]=0;f[A>>2]=0;H=I+11|0;L=b[H>>0]|0;M=L<<24>>24<0?f[I+4>>2]|0:L&255;if(!M)N=0;else{L=aD(i,M)|0;Vac(L|0,((b[H>>0]|0)<0?f[I>>2]|0:I)|0,M|0)|0;N=f[i>>2]|0}M=f[e>>2]|0;if((M|0)==(N|0))O=1;else O=(gTb((M|0)==0?1124530:M,(N|0)==0?1124530:N)|0)==0;bD(i);K=O}M=f[h>>2]|0;I=f[d>>2]|0;if((M|0)==(I|0))P=1;else P=(gTb((M|0)==0?1124530:M,(I|0)==0?1124530:I)|0)==0;if(K&P){X5b(k,f[F>>2]|0);X5b(j,k);f[s>>2]=B;f[i>>2]=0;f[t>>2]=0;I=b[v>>0]|0;M=I<<24>>24<0?f[w>>2]|0:I&255;if(!M)Q=B;else{I=aD(i,M)|0;Vac(I|0,((b[v>>0]|0)<0?f[j>>2]|0:j)|0,M|0)|0;Q=f[s>>2]|0}f[x>>2]=Q;M=f[l>>2]|0;if((M|0)==(f[y>>2]|0))aya(a,i);else{I=f[i>>2]|0;f[M>>2]=I;f[M+4>>2]=f[t>>2];if(!I){R=Q;S=M}else{H=I+-4|0;f[H>>2]=(f[H>>2]|0)+1;R=f[x>>2]|0;S=f[l>>2]|0}f[M+8>>2]=R;f[l>>2]=S+12}bD(i);if((b[v>>0]|0)<0)O5b(f[j>>2]|0);if((b[z>>0]|0)<0)O5b(f[k>>2]|0)}bD(h);n=n+1|0}while((n|0)<(f[D>>2]|0));T=f[m>>2]|0}else T=C;B=B+1|0;if((B|0)>=(T|0))break;else C=T}u=g;return}function $wa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=u;u=u+48|0;g=e+32|0;h=e+8|0;i=e+24|0;j=e;k=a+4|0;l=f[k>>2]|0;do if(l){m=f[c>>2]|0;n=(m|0)==0?1124530:m;o=m;p=k;q=l;a:while(1){r=q;while(1){s=f[r+16>>2]|0;if((s|0)==(m|0))break;if((gTb((s|0)==0?1124530:s,n)|0)>=0)break;s=f[r+4>>2]|0;if(!s){t=p;break a}else r=s}q=f[r>>2]|0;if(!q){t=r;break}else p=r}if((t|0)==(k|0))v=o;else{p=f[t+16>>2]|0;if((m|0)!=(p|0)?(gTb(n,(p|0)==0?1124530:p)|0)<=-1:0){v=o;break}p=b[d>>0]|0;f[g>>2]=0;q=L5b(16)|0;s=q+8|0;f[q>>2]=s;f[q+4>>2]=1;f[g+4>>2]=q;q=s;f[q>>2]=p&255;f[q+4>>2]=0;$xa(t+24|0,g)|0;gua(g);u=e;return d|0}}else v=f[c>>2]|0;while(0);f[i>>2]=v;t=i+4|0;f[t>>2]=f[c+4>>2];if(v|0){c=v+-4|0;f[c>>2]=(f[c>>2]|0)+1}c=b[d>>0]|0;f[j>>2]=0;v=L5b(16)|0;l=v+8|0;f[v>>2]=l;f[v+4>>2]=1;f[j+4>>2]=v;v=l;f[v>>2]=c&255;f[v+4>>2]=0;v=f[i>>2]|0;f[h>>2]=v;c=h+4|0;f[c>>2]=f[t>>2];if(v|0){t=v+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=h+8|0;iua(t,j);v=f[h>>2]|0;f[g>>2]=v;l=g+4|0;f[l>>2]=f[c>>2];if(v|0){c=v+-4|0;f[c>>2]=(f[c>>2]|0)+1}c=g+8|0;iua(c,t);v=f[k>>2]|0;b:do if(!v){w=k;x=k}else{q=a+4|0;p=f[g>>2]|0;s=(p|0)==0?1124530:p;y=f[v+16>>2]|0;c:do if((p|0)!=(y|0)){z=q;A=v;B=y;while(1){C=(B|0)==0?1124530:B;if((gTb(s,C)|0)<0){D=f[A>>2]|0;if(!D){E=24;break}else{F=A;G=D}}else{if((gTb(C,s)|0)>=0){H=z;I=A;break c}J=A+4|0;C=f[J>>2]|0;if(!C){E=27;break}else{F=J;G=C}}B=f[G+16>>2]|0;if((p|0)==(B|0)){H=F;I=G;break c}else{z=F;A=G}}if((E|0)==24){w=A;x=A;break b}else if((E|0)==27){w=J;x=A;break b}}else{H=q;I=v}while(0);w=H;x=I}while(0);if(!(f[w>>2]|0)){I=L5b(32)|0;H=f[g>>2]|0;f[I+16>>2]=H;f[I+20>>2]=f[l>>2];if(H|0){l=H+-4|0;f[l>>2]=(f[l>>2]|0)+1}iua(I+24|0,c);f[I>>2]=0;f[I+4>>2]=0;f[I+8>>2]=x;f[w>>2]=I;x=f[f[a>>2]>>2]|0;if(!x)K=I;else{f[a>>2]=x;K=f[w>>2]|0}mP(f[a+4>>2]|0,K);K=a+8|0;f[K>>2]=(f[K>>2]|0)+1}gua(c);bD(g);gua(t);bD(h);gua(j);bD(i);u=e;return d|0}function axa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0;d=u;u=u+80|0;e=d+64|0;g=d+8|0;h=d;switch(f[a+160>>2]|0){case 19:case 1:{f[e>>2]=0;i=e+4|0;f[i>>2]=0;f[e+8>>2]=0;Xwa(a,e);j=f[e>>2]|0;k=((f[i>>2]|0)-j|0)==16;l=j;if(k){j=l+8|0;m=l+12|0;o=f[m>>2]|0;f[m>>2]=f[j>>2];m=l+4|0;l=f[m>>2]|0;f[m>>2]=o;f[j>>2]=l}iL(c,e,5);Ywa(g,a);l=g+4|0;j=f[l>>2]|0;if((j|0)<3)q=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{o=f[g+40>>2]|0;m=0;r=1;while(1){s=Y(f[o+(m<<2)>>2]|0,r)|0;m=m+1|0;if((m|0)==(j|0)){q=s;break}else r=s}}r=f[c+4>>2]|0;if((r|0)<3)t=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{j=f[c+40>>2]|0;m=0;o=1;while(1){s=Y(f[j+(m<<2)>>2]|0,o)|0;m=m+1|0;if((m|0)==(r|0)){t=s;break}else o=s}}if((q|0)!=(t|0)){f[h>>2]=0;f[h+4>>2]=0;v=aD(h,28)|0;w=370005;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,h,370034,369853,179);bD(h)}t=f[c+16>>2]|0;o=g+16|0;r=f[o>>2]|0;if(k){k=f[e>>2]|0;m=f[k>>2]|0;j=f[k+4>>2]|0;s=f[k+8>>2]|0;y=f[k+12>>2]|0;z=Y(Y(Y(j,m)|0,s)|0,y)|0;if((m|0)>0){A=Y(Y(s,j)|0,y)|0;B=h+4|0;C=h+4|0;D=0;E=m;m=k;k=j;while(1){if((k|0)>0){F=Y(A,D)|0;G=0;H=m;while(1){if((f[H+8>>2]|0)>0){I=Y(G,s)|0;J=G+F|0;K=0;L=H;while(1){if((f[L+12>>2]|0)>0){M=(Y(K+I|0,y)|0)+F|0;N=Y(K,y)|0;O=0;do{P=M+O|0;Q=J+(Y(O+N|0,j)|0)|0;if((P|0)>=(z|0)){f[h>>2]=0;f[C>>2]=0;v=aD(h,13)|0;w=370046;x=v+13|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,h,370034,369853,195);bD(h)}if((Q|0)>=(z|0)){f[h>>2]=0;f[B>>2]=0;v=aD(h,13)|0;w=370060;x=v+13|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,h,370034,369853,196);bD(h)}f[t+(P<<2)>>2]=f[r+(Q<<2)>>2];O=O+1|0;R=f[e>>2]|0}while((O|0)<(f[R+12>>2]|0));S=R}else S=L;K=K+1|0;if((K|0)>=(f[S+8>>2]|0)){T=S;break}else L=S}}else T=H;G=G+1|0;U=f[T+4>>2]|0;if((G|0)>=(U|0))break;else H=T}V=U;W=T;X=f[T>>2]|0}else{V=k;W=m;X=E}D=D+1|0;if((D|0)>=(X|0))break;else{E=X;m=W;k=V}}}}else if((q|0)>0){V=0;do{f[t+(V<<2)>>2]=f[r+(V<<2)>>2];V=V+1|0}while((V|0)!=(q|0))}q=g+36|0;V=f[q>>2]|0;if(V|0?(r=V+12|0,V=f[r>>2]|0,f[r>>2]=V+-1,(V|0)==1):0)kL(g);f[q>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[l>>2]|0)>0){o=f[g+40>>2]|0;q=0;do{f[o+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[l>>2]|0))}l=f[g+44>>2]|0;if((l|0)!=(g+48|0))UC(l);l=f[e>>2]|0;if(l|0){q=f[i>>2]|0;if((q|0)!=(l|0))f[i>>2]=q+(~((q+-4-l|0)>>>2)<<2);O5b(l)}u=d;return}case 2:{f[e>>2]=0;l=e+4|0;f[l>>2]=0;f[e+8>>2]=0;Xwa(a,e);q=f[e>>2]|0;i=((f[l>>2]|0)-q|0)==16;o=q;if(i){q=o+8|0;V=o+12|0;r=f[V>>2]|0;f[V>>2]=f[q>>2];V=o+4|0;o=f[V>>2]|0;f[V>>2]=r;f[q>>2]=o}iL(c,e,5);Ywa(g,a);a=g+4|0;o=f[a>>2]|0;if((o|0)<3)Z=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{q=f[g+40>>2]|0;r=0;V=1;while(1){t=Y(f[q+(r<<2)>>2]|0,V)|0;r=r+1|0;if((r|0)==(o|0)){Z=t;break}else V=t}}V=f[c+4>>2]|0;if((V|0)<3)_=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{o=f[c+40>>2]|0;r=0;q=1;while(1){t=Y(f[o+(r<<2)>>2]|0,q)|0;r=r+1|0;if((r|0)==(V|0)){_=t;break}else q=t}}if((Z|0)!=(_|0)){f[h>>2]=0;f[h+4>>2]=0;v=aD(h,28)|0;w=370005;x=v+28|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,h,370034,369853,179);bD(h)}_=f[c+16>>2]|0;c=g+16|0;q=f[c>>2]|0;if(i){i=f[e>>2]|0;V=f[i>>2]|0;r=f[i+4>>2]|0;o=f[i+8>>2]|0;t=f[i+12>>2]|0;k=Y(Y(Y(r,V)|0,o)|0,t)|0;if((V|0)>0){W=Y(Y(o,r)|0,t)|0;m=h+4|0;X=h+4|0;E=0;D=r;T=V;V=i;while(1){if((D|0)>0){i=Y(W,E)|0;U=0;S=V;while(1){if((f[S+8>>2]|0)>0){B=Y(U,o)|0;z=U+i|0;C=0;j=S;while(1){if((f[j+12>>2]|0)>0){y=(Y(C+B|0,t)|0)+i|0;s=Y(C,t)|0;A=0;do{H=y+A|0;G=z+(Y(A+s|0,r)|0)|0;if((H|0)>=(k|0)){f[h>>2]=0;f[X>>2]=0;v=aD(h,13)|0;w=370046;x=v+13|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,h,370034,369853,195);bD(h)}if((G|0)>=(k|0)){f[h>>2]=0;f[m>>2]=0;v=aD(h,13)|0;w=370060;x=v+13|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-215,h,370034,369853,196);bD(h)}n[_+(H<<2)>>2]=+p[q+(G<<3)>>3];A=A+1|0;Q=f[e>>2]|0}while((A|0)<(f[Q+12>>2]|0));$=Q}else $=j;C=C+1|0;if((C|0)>=(f[$+8>>2]|0)){aa=$;break}else j=$}}else aa=S;U=U+1|0;ba=f[aa+4>>2]|0;if((U|0)>=(ba|0))break;else S=aa}ca=ba;da=f[aa>>2]|0;ea=aa}else{ca=D;da=T;ea=V}E=E+1|0;if((E|0)>=(da|0))break;else{D=ca;T=da;V=ea}}}}else if((Z|0)>0){ea=0;do{n[_+(ea<<2)>>2]=+p[q+(ea<<3)>>3];ea=ea+1|0}while((ea|0)!=(Z|0))}Z=g+36|0;ea=f[Z>>2]|0;if(ea|0?(q=ea+12|0,ea=f[q>>2]|0,f[q>>2]=ea+-1,(ea|0)==1):0)kL(g);f[Z>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[g+40>>2]|0;Z=0;do{f[c+(Z<<2)>>2]=0;Z=Z+1|0}while((Z|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)!=(g+48|0))UC(a);a=f[e>>2]|0;if(a|0){g=f[l>>2]|0;if((g|0)!=(a|0))f[l>>2]=g+(~((g+-4-a|0)>>>2)<<2);O5b(a)}u=d;return}default:{f[e>>2]=0;f[e+4>>2]=0;v=aD(e,35)|0;w=372065;x=v+35|0;do{b[v>>0]=b[w>>0]|0;v=v+1|0;w=w+1|0}while((v|0)<(x|0));bO(-2,e,372101,369853,220);bD(e);u=d;return}}}function bxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=u;u=u+64|0;e=d+48|0;g=d+32|0;h=d+24|0;i=d+16|0;j=d;k=a+20|0;l=f[(f[(f[k>>2]|0)+4+(c<<2)>>2]|0)+68>>2]|0;f[e>>2]=0;f[e+4>>2]=0;m=l+11|0;n=b[m>>0]|0;o=n<<24>>24<0?f[l+4>>2]|0:n&255;if(o|0){n=aD(e,o)|0;Vac(n|0,((b[m>>0]|0)<0?f[l>>2]|0:l)|0,o|0)|0}f[h>>2]=0;f[h+4>>2]=0;_wa(g,a,e,h);bD(h);a=f[(f[(f[(f[k>>2]|0)+4+(c<<2)>>2]|0)+20>>2]|0)+4>>2]|0;f[h>>2]=0;c=h+4|0;f[c>>2]=0;o=a+11|0;l=b[o>>0]|0;m=l<<24>>24<0?f[a+4>>2]|0:l&255;if(m|0){l=aD(h,m)|0;Vac(l|0,((b[o>>0]|0)<0?f[a>>2]|0:a)|0,m|0)|0}m=g+4|0;a=f[m>>2]|0;o=f[g>>2]|0;a:do if((a|0)!=(o|0)){l=i+4|0;n=j+11|0;p=j+8|0;q=j+4|0;r=0;s=a;t=o;b:while(1){v=f[(f[k>>2]|0)+4+(f[t+(r*12|0)+8>>2]<<2)>>2]|0;w=v+12|0;if((f[w>>2]|0)>0){x=v+20|0;v=0;do{y=f[(f[x>>2]|0)+4+(v<<2)>>2]|0;f[i>>2]=0;f[l>>2]=0;z=y+11|0;A=b[z>>0]|0;B=A<<24>>24<0?f[y+4>>2]|0:A&255;if(!B)C=0;else{A=aD(i,B)|0;Vac(A|0,((b[z>>0]|0)<0?f[y>>2]|0:y)|0,B|0)|0;C=f[i>>2]|0}B=f[e>>2]|0;if(!((C|0)!=(B|0)?(gTb((C|0)==0?1124530:C,(B|0)==0?1124530:B)|0)!=0:0)){B=f[h>>2]|0;y=f[c>>2]|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;if(y>>>0>4294967279)break b;if(y>>>0<11){b[n>>0]=y;if(!y)D=j;else{E=j;F=20}}else{z=y+16&-16;A=L5b(z)|0;f[j>>2]=A;f[p>>2]=z|-2147483648;f[q>>2]=y;E=A;F=20}if((F|0)==20){F=0;Vac(E|0,B|0,y|0)|0;D=E}b[D+y>>0]=0;_5b(f[(f[x>>2]|0)+4+(v<<2)>>2]|0,j)|0;if((b[n>>0]|0)<0)O5b(f[j>>2]|0)}bD(i);v=v+1|0}while((v|0)<(f[w>>2]|0));G=f[g>>2]|0;H=f[m>>2]|0}else{G=t;H=s}r=r+1|0;if(r>>>0>=((H-G|0)/12|0)>>>0)break a;else{s=H;t=G}}V5b(j)}while(0);bD(h);h=f[g>>2]|0;if(!h){bD(e);u=d;return}while(1){j=f[m>>2]|0;if((j|0)==(h|0))break;G=j+-12|0;f[m>>2]=G;bD(G)}O5b(f[g>>2]|0);bD(e);u=d;return}function cxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;d=u;u=u+80|0;e=d+64|0;g=d+8|0;h=d;f[e>>2]=0;i=e+4|0;f[i>>2]=0;f[e+8>>2]=0;Xwa(a,e);j=(f[i>>2]|0)-(f[e>>2]|0)|0;switch(f[a+160>>2]|0){case 19:case 1:break;default:{f[g>>2]=0;f[g+4>>2]=0;k=aD(g,79)|0;l=371958;m=k+79|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,372038,369853,514);bD(g)}}if((j|0)!=16){f[g>>2]=0;f[g+4>>2]=0;k=aD(g,9)|0;l=372055;m=k+9|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,g,372038,369853,515);bD(g)}j=f[e>>2]|0;n=j+8|0;o=f[n>>2]|0;f[n>>2]=f[j>>2];n=j+4|0;p=j+12|0;q=f[p>>2]|0;f[p>>2]=f[n>>2];f[j>>2]=q;f[n>>2]=o;iL(c,e,5);Ywa(g,a);a=g+4|0;o=f[a>>2]|0;if((o|0)<3)r=Y(f[g+12>>2]|0,f[g+8>>2]|0)|0;else{n=f[g+40>>2]|0;q=0;j=1;while(1){p=Y(f[n+(q<<2)>>2]|0,j)|0;q=q+1|0;if((q|0)==(o|0)){r=p;break}else j=p}}j=f[c+4>>2]|0;if((j|0)<3)s=Y(f[c+12>>2]|0,f[c+8>>2]|0)|0;else{o=f[c+40>>2]|0;q=0;n=1;while(1){p=Y(f[o+(q<<2)>>2]|0,n)|0;q=q+1|0;if((q|0)==(j|0)){s=p;break}else n=p}}if((r|0)!=(s|0)){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,28)|0;l=370005;m=k+28|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,372038,369853,526);bD(h)}s=f[c+16>>2]|0;c=g+16|0;r=f[c>>2]|0;n=f[e>>2]|0;j=f[n>>2]|0;q=f[n+4>>2]|0;o=f[n+8>>2]|0;p=f[n+12>>2]|0;n=Y(q,j)|0;t=Y(Y(n,o)|0,p)|0;if((j|0)>0){v=(q|0)>0;w=(o|0)>0;x=(p|0)>0;y=h+4|0;z=h+4|0;A=0;do{if(v){B=Y(A,q)|0;C=0;do{if(w?(D=Y(C+B|0,o)|0,E=(Y(C,j)|0)+A|0,x):0){F=0;do{G=Y(D+F|0,p)|0;H=Y(F,p)|0;I=0;do{J=I+G|0;K=E+(Y(I+H|0,n)|0)|0;if((J|0)>=(t|0)){f[h>>2]=0;f[z>>2]=0;k=aD(h,13)|0;l=370046;m=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,372038,369853,539);bD(h)}if((K|0)>=(t|0)){f[h>>2]=0;f[y>>2]=0;k=aD(h,13)|0;l=370060;m=k+13|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,372038,369853,540);bD(h)}f[s+(J<<2)>>2]=f[r+(K<<2)>>2];I=I+1|0}while((I|0)<(p|0));F=F+1|0}while((F|0)<(o|0))}C=C+1|0}while((C|0)<(q|0))}A=A+1|0}while((A|0)<(j|0))}j=g+36|0;A=f[j>>2]|0;if(A|0?(q=A+12|0,A=f[q>>2]|0,f[q>>2]=A+-1,(A|0)==1):0)kL(g);f[j>>2]=0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[a>>2]|0)>0){c=f[g+40>>2]|0;j=0;do{f[c+(j<<2)>>2]=0;j=j+1|0}while((j|0)<(f[a>>2]|0))}a=f[g+44>>2]|0;if((a|0)!=(g+48|0))UC(a);a=f[e>>2]|0;if(!a){u=d;return}e=f[i>>2]|0;if((e|0)!=(a|0))f[i>>2]=e+(~((e+-4-a|0)>>>2)<<2);O5b(a);u=d;return}function dxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+4|0;g=d;f[e+8>>2]=0;h=e+11|0;b[h>>0]=7;b[e>>0]=b[371077]|0;b[e+1>>0]=b[371078]|0;b[e+2>>0]=b[371079]|0;b[e+3>>0]=b[371080]|0;b[e+4>>0]=b[371081]|0;b[e+5>>0]=b[371082]|0;b[e+6>>0]=b[371083]|0;b[e+7>>0]=0;i=jxa(c,e)|0;if((b[h>>0]|0)<0)O5b(f[e>>2]|0);if(!i){u=d;return}f[e+8>>2]=0;i=e+11|0;b[i>>0]=7;b[e>>0]=b[371077]|0;b[e+1>>0]=b[371078]|0;b[e+2>>0]=b[371079]|0;b[e+3>>0]=b[371080]|0;b[e+4>>0]=b[371081]|0;b[e+5>>0]=b[371082]|0;b[e+6>>0]=b[371083]|0;b[e+7>>0]=0;tKb(c+24|0);h=kxa(f[c+60>>2]|0,e)|0;if((b[i>>0]|0)<0)O5b(f[e>>2]|0);i=h+20|0;if((f[i>>2]|0)==1)j=f[h+8>>2]|0;else j=fHa()|0;if((f[j+24>>2]|0)==4){if((f[i>>2]|0)==1)k=f[h+8>>2]|0;else k=fHa()|0;j=(f[k+32>>2]|0)+8|0;if((f[j>>2]|0)==1&(f[j+4>>2]|0)==0){if((f[i>>2]|0)==1)l=f[h+8>>2]|0;else l=fHa()|0;j=(f[l+32>>2]|0)+32|0;if(!((f[j>>2]|0)==1&(f[j+4>>2]|0)==0))m=18}else m=18}else m=18;if((m|0)==18){f[e>>2]=0;f[e+4>>2]=0;m=aD(e,19)|0;j=371927;l=m+19|0;do{b[m>>0]=b[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(l|0));bO(-2,e,371947,369853,323);bD(e)}f[e>>2]=0;f[e+4>>2]=0;j=aD(e,8)|0;m=j;b[m>>0]=115;b[m+1>>0]=116;b[m+2>>0]=114;b[m+3>>0]=105;m=j+4|0;b[m>>0]=100;b[m+1>>0]=101;b[m+2>>0]=95;b[m+3>>0]=104;if((f[i>>2]|0)==1)n=f[h+8>>2]|0;else n=fHa()|0;f[g>>2]=f[(f[n+32>>2]|0)+16>>2];Wwa(a,e,g)|0;bD(e);f[e>>2]=0;f[e+4>>2]=0;n=aD(e,8)|0;m=n;b[m>>0]=115;b[m+1>>0]=116;b[m+2>>0]=114;b[m+3>>0]=105;m=n+4|0;b[m>>0]=100;b[m+1>>0]=101;b[m+2>>0]=95;b[m+3>>0]=119;if((f[i>>2]|0)==1)o=f[h+8>>2]|0;else o=fHa()|0;f[g>>2]=f[(f[o+32>>2]|0)+24>>2];Wwa(a,e,g)|0;bD(e);u=d;return}function exa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0;d=u;u=u+32|0;e=d+12|0;g=d;f[e+8>>2]=0;h=e+11|0;b[h>>0]=7;b[e>>0]=b[441015]|0;b[e+1>>0]=b[441016]|0;b[e+2>>0]=b[441017]|0;b[e+3>>0]=b[441018]|0;b[e+4>>0]=b[441019]|0;b[e+5>>0]=b[441020]|0;b[e+6>>0]=b[441021]|0;b[e+7>>0]=0;i=jxa(c,e)|0;if((b[h>>0]|0)<0)O5b(f[e>>2]|0);if(!i){u=d;return}f[e>>2]=0;f[e+4>>2]=0;i=aD(e,8)|0;h=i;b[h>>0]=112;b[h+1>>0]=97;b[h+2>>0]=100;b[h+3>>0]=95;h=i+4|0;b[h>>0]=109;b[h+1>>0]=111;b[h+2>>0]=100;b[h+3>>0]=101;f[g+8>>2]=0;h=g+11|0;b[h>>0]=7;b[g>>0]=b[441015]|0;b[g+1>>0]=b[441016]|0;b[g+2>>0]=b[441017]|0;b[g+3>>0]=b[441018]|0;b[g+4>>0]=b[441019]|0;b[g+5>>0]=b[441020]|0;b[g+6>>0]=b[441021]|0;b[g+7>>0]=0;tKb(c+24|0);i=kxa(f[c+60>>2]|0,g)|0;rxa(a,e,(f[i+20>>2]|0)==2?f[i+8>>2]|0:497760)|0;if((b[h>>0]|0)<0)O5b(f[g>>2]|0);bD(e);u=d;return}function fxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=(c-b|0)/12|0;e=a+8|0;g=f[e>>2]|0;h=f[a>>2]|0;i=h;if(d>>>0>((g-h|0)/12|0)>>>0){if(!h)j=g;else{g=a+4|0;while(1){k=f[g>>2]|0;if((k|0)==(i|0))break;l=k+-12|0;f[g>>2]=l;bD(l)}O5b(f[a>>2]|0);f[e>>2]=0;f[g>>2]=0;f[a>>2]=0;j=0}if(d>>>0>357913941)c4b(a);g=(j|0)/12|0;j=g<<1;l=g>>>0<178956970?(j>>>0<d>>>0?d:j):357913941;if(l>>>0>357913941)c4b(a);j=L5b(l*12|0)|0;g=a+4|0;f[g>>2]=j;f[a>>2]=j;f[e>>2]=j+(l*12|0);if((b|0)==(c|0))return;l=b;e=j;do{j=f[l>>2]|0;f[e>>2]=j;f[e+4>>2]=f[l+4>>2];if(j|0){k=j+-4|0;f[k>>2]=(f[k>>2]|0)+1}f[e+8>>2]=f[l+8>>2];l=l+12|0;e=(f[g>>2]|0)+12|0;f[g>>2]=e}while((l|0)!=(c|0));return}l=a+4|0;a=((f[l>>2]|0)-h|0)/12|0;h=d>>>0>a>>>0;d=b+(a*12|0)|0;a=h?d:c;if((a|0)==(b|0))m=i;else{e=b;b=i;while(1){if((e|0)!=(b|0)){bD(b);i=f[e>>2]|0;if(!i)n=0;else{g=i+-4|0;f[g>>2]=(f[g>>2]|0)+1;n=f[e>>2]|0}f[b>>2]=n;f[b+4>>2]=f[e+4>>2]}f[b+8>>2]=f[e+8>>2];e=e+12|0;g=b+12|0;if((e|0)==(a|0)){m=g;break}else b=g}}if(!h){while(1){h=f[l>>2]|0;if((h|0)==(m|0))break;b=h+-12|0;f[l>>2]=b;bD(b)}return}if((a|0)==(c|0))return;a=d;d=f[l>>2]|0;do{m=f[a>>2]|0;f[d>>2]=m;f[d+4>>2]=f[a+4>>2];if(m|0){b=m+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[d+8>>2]=f[a+8>>2];a=a+12|0;d=(f[l>>2]|0)+12|0;f[l>>2]=d}while((a|0)!=(c|0));return}function gxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1124530:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((gTb((r|0)==0?1124530:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=L5b(16)|0;p=o+8|0;f[p>>2]=0;f[o+12>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;bD(p);o=kUb(c)|0;if(o|0)Vac(aD(p,o)|0,c|0,o|0)|0;$xa(s+24|0,e)|0;gua(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=L5b(16)|0;t=b+8|0;f[t>>2]=0;f[b+12>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;bD(t);b=kUb(c)|0;if(b|0)Vac(aD(t,b)|0,c|0,b|0)|0;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;iua(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;iua(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1124530:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1124530:A;if((gTb(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=28;break}else{E=z;F=C}}else{if((gTb(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=31;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==28){v=z;w=z;break b}else if((D|0)==31){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=L5b(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}iua(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}mP(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}gua(t);bD(e);gua(s);bD(g);gua(i);bD(h);u=d;return c|0}function hxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=u;u=u+160|0;e=d+140|0;g=d;X5b(a,c);h=a+12|0;f[h>>2]=0;i=b[c+11>>0]|0;j=i<<24>>24<0;k=j?f[c>>2]|0:c;l=j?f[c+4>>2]|0:i&255;if(!l){u=d;return}i=k+l|0;l=k;while(1){if((b[l>>0]|0)==58)break;j=l+1|0;if((j|0)==(i|0)){m=11;break}else l=j}if((m|0)==11){u=d;return}m=l-k|0;if((l|0)==(i|0)|(m|0)==-1){u=d;return}Y5b(e,c,0,m,c);_5b(a,e)|0;if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);Y5b(e,c,m+1|0,-1,c);c=g+60|0;m=g+8|0;f[g>>2]=10956;f[c>>2]=10976;f[g+4>>2]=0;RXb(g+60|0,m);f[g+132>>2]=0;f[g+136>>2]=-1;f[g>>2]=47196;f[c>>2]=47216;WXb(m);f[m>>2]=43284;c=g+40|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[g+56>>2]=8;qP(m,e);aYb(g,h)|0;GU(g);if((b[e+11>>0]|0)<0)O5b(f[e>>2]|0);u=d;return}function ixa(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;h=u;u=u+32|0;i=h+16|0;j=h;f[i>>2]=0;f[i+4>>2]=0;k=d+11|0;l=b[k>>0]|0;m=l<<24>>24<0?f[d+4>>2]|0:l&255;if(m|0){l=aD(i,m)|0;Vac(l|0,((b[k>>0]|0)<0?f[d>>2]|0:d)|0,m|0)|0}m=a+4|0;a=f[m>>2]|0;if(a){k=f[i>>2]|0;l=(k|0)==0?1124530:k;n=m;o=a;a:while(1){a=o;while(1){p=f[a+16>>2]|0;if((p|0)==(k|0))break;if((gTb((p|0)==0?1124530:p,l)|0)>=0)break;p=f[a+4>>2]|0;if(!p){q=n;break a}else a=p}o=f[a>>2]|0;if(!o){q=a;break}else n=a}if((q|0)!=(m|0)){n=f[q+16>>2]|0;if((k|0)!=(n|0)?(gTb(l,(n|0)==0?1124530:n)|0)<0:0)r=13;else s=q}else r=13}else r=13;if((r|0)==13)s=m;bD(i);if((s|0)!=(m|0)){t=s+24|0;v=f[t>>2]|0;w=d+12|0;x=f[w>>2]|0;tva(c,v,x,e,g);u=h;return}dua(j,370213,d);f[i>>2]=0;f[i+4>>2]=0;m=j+11|0;r=b[m>>0]|0;q=r<<24>>24<0?f[j+4>>2]|0:r&255;if(q|0){r=aD(i,q)|0;Vac(r|0,((b[m>>0]|0)<0?f[j>>2]|0:j)|0,q|0)|0}bO(-2,i,371919,369853,553);bD(i);if((b[m>>0]|0)<0)O5b(f[j>>2]|0);t=s+24|0;v=f[t>>2]|0;w=d+12|0;x=f[w>>2]|0;tva(c,v,x,e,g);u=h;return}function jxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+48|0;e=d+16|0;g=d;tKb(a+24|0);sxa(g,f[a+60>>2]|0);a=g+8|0;if(!(b[a>>0]|0)){wxa(e,f[g+12>>2]|0,c);h=2;i=0;j=f[e>>2]|0}else{h=1;i=Hxa(f[g+12>>2]|0,c)|0;j=0}do if((h|0)==(((b[a>>0]|0)==0?2:1)|0))if((h|0)==1){k=(i|0)==0;break}else{k=(j|0)==0;break}else k=0;while(0);txa(g);u=d;return k^1|0}function kxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=u;u=u+48|0;e=d+24|0;g=d;h=d+44|0;i=a+8|0;if(!(b[i>>0]|0)){wxa(e,f[a+12>>2]|0,c);j=2;k=0;l=f[e>>2]|0}else{j=1;k=Hxa(f[a+12>>2]|0,c)|0;l=0}a:do if((j|0)==(((b[i>>0]|0)==0?2:1)|0)){switch(j&3){case 0:break;case 1:{if(k|0)break a;break}default:if(l|0)break a}zpb(g,3,471595,1524);xpb(h,vpb(g,371891)|0);Apb(g)}while(0);u=d;return (f[((j|0)==1?k+20|0:l+12|0)>>2]|0)+16|0}function lxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1124530:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((gTb((r|0)==0?1124530:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=L5b(16)|0;p=o+8|0;f[p>>2]=0;f[o+12>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;bD(p);o=kUb(c)|0;if(o|0)Vac(aD(p,o)|0,c|0,o|0)|0;$xa(s+24|0,e)|0;gua(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=L5b(16)|0;t=b+8|0;f[t>>2]=0;f[b+12>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;bD(t);b=kUb(c)|0;if(b|0)Vac(aD(t,b)|0,c|0,b|0)|0;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;iua(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;iua(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1124530:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1124530:A;if((gTb(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=28;break}else{E=z;F=C}}else{if((gTb(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=31;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==28){v=z;w=z;break b}else if((D|0)==31){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=L5b(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}iua(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}mP(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}gua(t);bD(e);gua(s);bD(g);gua(i);bD(h);u=d;return c|0}function mxa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;c=f[a+4>>2]|0;a:do if(c|0){d=a+4|0;e=f[b>>2]|0;g=(e|0)==0?1124530:e;h=f[c+16>>2]|0;if((e|0)==(h|0)){i=d;j=f[i>>2]|0;k=j+24|0;return k|0}else{l=d;m=c;n=h}while(1){h=(n|0)==0?1124530:n;if((gTb(g,h)|0)<0){d=f[m>>2]|0;if(!d)break a;else{o=m;p=d}}else{if((gTb(h,g)|0)>=0){i=l;q=9;break}h=m+4|0;d=f[h>>2]|0;if(!d)break a;else{o=h;p=d}}n=f[p+16>>2]|0;if((e|0)==(n|0)){i=o;q=9;break}else{l=o;m=p}}if((q|0)==9){j=f[i>>2]|0;k=j+24|0;return k|0}}while(0);k=ze(8)|0;T5b(k,371867);f[k>>2]=149548;If(k|0,25424,1411);return 0}function nxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1124530:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((gTb((r|0)==0?1124530:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){t=n;break}iua(e,c);$xa(s+24|0,e)|0;gua(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}iua(i,c);b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;iua(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;iua(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1124530:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1124530:A;if((gTb(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=24;break}else{E=z;F=C}}else{if((gTb(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=27;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==24){v=z;w=z;break b}else if((D|0)==27){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=L5b(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}iua(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}mP(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}gua(t);bD(e);gua(s);bD(g);gua(i);bD(h);u=d;return c|0}function oxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d+4|0;g=d;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;h=e+11|0;b[h>>0]=5;b[e>>0]=b[371085]|0;b[e+1>>0]=b[371086]|0;b[e+2>>0]=b[371087]|0;b[e+3>>0]=b[371088]|0;b[e+4>>0]=b[371089]|0;b[e+5>>0]=0;i=jxa(c,e)|0;if((b[h>>0]|0)<0)O5b(f[e>>2]|0);if(!i){f[e>>2]=0;f[e+4>>2]=0;i=aD(e,8)|0;h=i;b[h>>0]=107;b[h+1>>0]=101;b[h+2>>0]=114;b[h+3>>0]=110;h=i+4|0;b[h>>0]=101;b[h+1>>0]=108;b[h+2>>0]=95;b[h+3>>0]=104;f[g>>2]=1;Wwa(a,e,g)|0;bD(e);f[e>>2]=0;f[e+4>>2]=0;h=aD(e,8)|0;i=h;b[i>>0]=107;b[i+1>>0]=101;b[i+2>>0]=114;b[i+3>>0]=110;i=h+4|0;b[i>>0]=101;b[i+1>>0]=108;b[i+2>>0]=95;b[i+3>>0]=119;f[g>>2]=1;Wwa(a,e,g)|0;bD(e);u=d;return};f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;i=e+11|0;b[i>>0]=5;b[e>>0]=b[371085]|0;b[e+1>>0]=b[371086]|0;b[e+2>>0]=b[371087]|0;b[e+3>>0]=b[371088]|0;b[e+4>>0]=b[371089]|0;b[e+5>>0]=0;tKb(c+24|0);h=kxa(f[c+60>>2]|0,e)|0;if((b[i>>0]|0)<0)O5b(f[e>>2]|0);i=h+20|0;if((f[i>>2]|0)==1)j=f[h+8>>2]|0;else j=fHa()|0;if((f[j+24>>2]|0)==4){if((f[i>>2]|0)==1)k=f[h+8>>2]|0;else k=fHa()|0;j=(f[k+32>>2]|0)+8|0;if((f[j>>2]|0)==1&(f[j+4>>2]|0)==0){if((f[i>>2]|0)==1)l=f[h+8>>2]|0;else l=fHa()|0;j=(f[l+32>>2]|0)+32|0;if(!((f[j>>2]|0)==1&(f[j+4>>2]|0)==0))m=18}else m=18}else m=18;if((m|0)==18){f[e>>2]=0;f[e+4>>2]=0;m=aD(e,17)|0;j=371840;l=m+17|0;do{b[m>>0]=b[j>>0]|0;m=m+1|0;j=j+1|0}while((m|0)<(l|0));bO(-2,e,371858,369853,350);bD(e)}f[e>>2]=0;f[e+4>>2]=0;j=aD(e,8)|0;m=j;b[m>>0]=107;b[m+1>>0]=101;b[m+2>>0]=114;b[m+3>>0]=110;m=j+4|0;b[m>>0]=101;b[m+1>>0]=108;b[m+2>>0]=95;b[m+3>>0]=104;if((f[i>>2]|0)==1)n=f[h+8>>2]|0;else n=fHa()|0;f[g>>2]=f[(f[n+32>>2]|0)+16>>2];Wwa(a,e,g)|0;bD(e);f[e>>2]=0;f[e+4>>2]=0;n=aD(e,8)|0;m=n;b[m>>0]=107;b[m+1>>0]=101;b[m+2>>0]=114;b[m+3>>0]=110;m=n+4|0;b[m>>0]=101;b[m+1>>0]=108;b[m+2>>0]=95;b[m+3>>0]=119;if((f[i>>2]|0)==1)o=f[h+8>>2]|0;else o=fHa()|0;f[g>>2]=f[(f[o+32>>2]|0)+24>>2];Wwa(a,e,g)|0;bD(e);u=d;return}function pxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1124530:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((gTb((r|0)==0?1124530:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){t=n;break}f[e>>2]=3;o=L5b(16)|0;p=o+8|0;f[p>>2]=0;f[o+12>>2]=0;f[o>>2]=p;f[o+4>>2]=1;f[e+4>>2]=o;bD(p);o=kUb(c)|0;if(o|0)Vac(aD(p,o)|0,c|0,o|0)|0;$xa(s+24|0,e)|0;gua(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}f[i>>2]=3;b=L5b(16)|0;t=b+8|0;f[t>>2]=0;f[b+12>>2]=0;f[b>>2]=t;f[b+4>>2]=1;f[i+4>>2]=b;bD(t);b=kUb(c)|0;if(b|0)Vac(aD(t,b)|0,c|0,b|0)|0;b=f[h>>2]|0;f[g>>2]=b;t=g+4|0;f[t>>2]=f[s>>2];if(b|0){s=b+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;iua(s,i);b=f[g>>2]|0;f[e>>2]=b;k=e+4|0;f[k>>2]=f[t>>2];if(b|0){t=b+-4|0;f[t>>2]=(f[t>>2]|0)+1}t=e+8|0;iua(t,s);b=f[j>>2]|0;b:do if(!b){v=j;w=j}else{o=a+4|0;p=f[e>>2]|0;r=(p|0)==0?1124530:p;x=f[b+16>>2]|0;c:do if((p|0)!=(x|0)){y=o;z=b;A=x;while(1){B=(A|0)==0?1124530:A;if((gTb(r,B)|0)<0){C=f[z>>2]|0;if(!C){D=28;break}else{E=z;F=C}}else{if((gTb(B,r)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=31;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((p|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==28){v=z;w=z;break b}else if((D|0)==31){v=I;w=z;break b}}else{G=o;H=b}while(0);v=G;w=H}while(0);if(!(f[v>>2]|0)){H=L5b(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[k>>2];if(G|0){k=G+-4|0;f[k>>2]=(f[k>>2]|0)+1}iua(H+24|0,t);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=w;f[v>>2]=H;w=f[f[a>>2]>>2]|0;if(!w)J=H;else{f[a>>2]=w;J=f[v>>2]|0}mP(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}gua(t);bD(e);gua(s);bD(g);gua(i);bD(h);u=d;return c|0}function qxa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=u;u=u+48|0;e=d+32|0;g=d+8|0;h=d+24|0;i=d;j=a+4|0;k=f[j>>2]|0;do if(k){l=f[b>>2]|0;m=(l|0)==0?1124530:l;n=l;o=j;p=k;a:while(1){q=p;while(1){r=f[q+16>>2]|0;if((r|0)==(l|0))break;if((gTb((r|0)==0?1124530:r,m)|0)>=0)break;r=f[q+4>>2]|0;if(!r){s=o;break a}else q=r}p=f[q>>2]|0;if(!p){s=q;break}else o=q}if((s|0)==(j|0))t=n;else{o=f[s+16>>2]|0;if((l|0)!=(o|0)?(gTb(m,(o|0)==0?1124530:o)|0)<=-1:0){t=n;break}o=c;p=f[o>>2]|0;r=f[o+4>>2]|0;f[e>>2]=0;o=L5b(16)|0;v=o+8|0;f[o>>2]=v;f[o+4>>2]=1;f[e+4>>2]=o;o=v;f[o>>2]=p;f[o+4>>2]=r;$xa(s+24|0,e)|0;gua(e);u=d;return c|0}}else t=f[b>>2]|0;while(0);f[h>>2]=t;s=h+4|0;f[s>>2]=f[b+4>>2];if(t|0){b=t+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=c;t=f[b>>2]|0;k=f[b+4>>2]|0;f[i>>2]=0;b=L5b(16)|0;r=b+8|0;f[b>>2]=r;f[b+4>>2]=1;f[i+4>>2]=b;b=r;f[b>>2]=t;f[b+4>>2]=k;k=f[h>>2]|0;f[g>>2]=k;b=g+4|0;f[b>>2]=f[s>>2];if(k|0){s=k+-4|0;f[s>>2]=(f[s>>2]|0)+1}s=g+8|0;iua(s,i);k=f[g>>2]|0;f[e>>2]=k;t=e+4|0;f[t>>2]=f[b>>2];if(k|0){b=k+-4|0;f[b>>2]=(f[b>>2]|0)+1}b=e+8|0;iua(b,s);k=f[j>>2]|0;b:do if(!k){w=j;x=j}else{r=a+4|0;o=f[e>>2]|0;p=(o|0)==0?1124530:o;v=f[k+16>>2]|0;c:do if((o|0)!=(v|0)){y=r;z=k;A=v;while(1){B=(A|0)==0?1124530:A;if((gTb(p,B)|0)<0){C=f[z>>2]|0;if(!C){D=24;break}else{E=z;F=C}}else{if((gTb(B,p)|0)>=0){G=y;H=z;break c}I=z+4|0;B=f[I>>2]|0;if(!B){D=27;break}else{E=I;F=B}}A=f[F+16>>2]|0;if((o|0)==(A|0)){G=E;H=F;break c}else{y=E;z=F}}if((D|0)==24){w=z;x=z;break b}else if((D|0)==27){w=I;x=z;break b}}else{G=r;H=k}while(0);w=G;x=H}while(0);if(!(f[w>>2]|0)){H=L5b(32)|0;G=f[e>>2]|0;f[H+16>>2]=G;f[H+20>>2]=f[t>>2];if(G|0){t=G+-4|0;f[t>>2]=(f[t>>2]|0)+1}iua(H+24|0,b);f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=x;f[w>>2]=H;x=f[f[a>>2]>>2]|0;if(!x)J=H;else{f[a>>2]=x;J=f[w>>2]|0}mP(f[a+4>>2]|0,J);J=a+8|0;f[J>>2]=(f[J>>2]|0)+1}gua(b);bD(e);gua(s);bD(g);gua(i);bD(h);u=d;return c|0}function rxa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e+16|0;j=e+8|0;k=e;l=a+4|0;m=f[l>>2]|0;do if(m){n=f[c>>2]|0;o=(n|0)==0?1124530:n;p=n;q=l;r=m;a:while(1){s=r;while(1){t=f[s+16>>2]|0;if((t|0)==(n|0))break;if((gTb((t|0)==0?1124530:t,o)|0)>=0)break;t=f[s+4>>2]|0;if(!t){v=q;break a}else s=t}r=f[s>>2]|0;if(!r){v=s;break}else q=s}if((v|0)==(l|0))w=p;else{q=f[v+16>>2]|0;if((n|0)!=(q|0)?(gTb(o,(q|0)==0?1124530:q)|0)<=-1:0){w=p;break}f[h>>2]=0;q=h+4|0;f[q>>2]=0;r=d+11|0;t=b[r>>0]|0;x=t<<24>>24<0?f[d+4>>2]|0:t&255;if(x|0){t=aD(h,x)|0;Vac(t|0,((b[r>>0]|0)<0?f[d>>2]|0:d)|0,x|0)|0}f[g>>2]=3;x=L5b(16)|0;r=x+8|0;f[r>>2]=0;t=x+12|0;f[t>>2]=0;f[x>>2]=r;f[x+4>>2]=1;f[g+4>>2]=x;bD(r);x=f[h>>2]|0;if(!x)y=0;else{z=x+-4|0;f[z>>2]=(f[z>>2]|0)+1;y=f[h>>2]|0}f[r>>2]=y;f[t>>2]=f[q>>2];$xa(v+24|0,g)|0;gua(g);bD(h);u=e;return d|0}}else w=f[c>>2]|0;while(0);f[i>>2]=w;v=i+4|0;f[v>>2]=f[c+4>>2];if(w|0){c=w+-4|0;f[c>>2]=(f[c>>2]|0)+1}f[k>>2]=0;c=k+4|0;f[c>>2]=0;w=d+11|0;y=b[w>>0]|0;m=y<<24>>24<0?f[d+4>>2]|0:y&255;if(m|0){y=aD(k,m)|0;Vac(y|0,((b[w>>0]|0)<0?f[d>>2]|0:d)|0,m|0)|0}f[j>>2]=3;m=L5b(16)|0;w=m+8|0;f[w>>2]=0;y=m+12|0;f[y>>2]=0;f[m>>2]=w;f[m+4>>2]=1;f[j+4>>2]=m;bD(w);m=f[k>>2]|0;if(!m)A=0;else{q=m+-4|0;f[q>>2]=(f[q>>2]|0)+1;A=f[k>>2]|0}f[w>>2]=A;f[y>>2]=f[c>>2];c=f[i>>2]|0;f[h>>2]=c;y=h+4|0;f[y>>2]=f[v>>2];if(c|0){v=c+-4|0;f[v>>2]=(f[v>>2]|0)+1}v=h+8|0;iua(v,j);c=f[h>>2]|0;f[g>>2]=c;A=g+4|0;f[A>>2]=f[y>>2];if(c|0){y=c+-4|0;f[y>>2]=(f[y>>2]|0)+1}y=g+8|0;iua(y,v);c=f[l>>2]|0;b:do if(!c){B=l;C=l}else{w=a+4|0;q=f[g>>2]|0;m=(q|0)==0?1124530:q;t=f[c+16>>2]|0;c:do if((q|0)!=(t|0)){r=w;z=c;x=t;while(1){D=(x|0)==0?1124530:x;if((gTb(m,D)|0)<0){E=f[z>>2]|0;if(!E){F=32;break}else{G=z;H=E}}else{if((gTb(D,m)|0)>=0){I=r;J=z;break c}K=z+4|0;D=f[K>>2]|0;if(!D){F=35;break}else{G=K;H=D}}x=f[H+16>>2]|0;if((q|0)==(x|0)){I=G;J=H;break c}else{r=G;z=H}}if((F|0)==32){B=z;C=z;break b}else if((F|0)==35){B=K;C=z;break b}}else{I=w;J=c}while(0);B=I;C=J}while(0);if(!(f[B>>2]|0)){J=L5b(32)|0;I=f[g>>2]|0;f[J+16>>2]=I;f[J+20>>2]=f[A>>2];if(I|0){A=I+-4|0;f[A>>2]=(f[A>>2]|0)+1}iua(J+24|0,y);f[J>>2]=0;f[J+4>>2]=0;f[J+8>>2]=C;f[B>>2]=J;C=f[f[a>>2]>>2]|0;if(!C)L=J;else{f[a>>2]=C;L=f[B>>2]|0}mP(f[a+4>>2]|0,L);L=a+8|0;f[L>>2]=(f[L>>2]|0)+1}gua(y);bD(g);gua(v);bD(h);gua(j);bD(k);bD(i);u=e;return d|0}function sxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=u;u=u+48|0;e=d+24|0;g=d;f[a>>2]=0;f[a+4>>2]=f[c+4>>2];h=c+8|0;b[a+8>>0]=b[h>>0]|0;Fxa(a);i=(b[h>>0]|0)==0;if(i){h=f[c+12>>2]|0;j=f[h+12>>2]|0;k=f[h+4>>2]|0;a:do if(k>>>0>j>>>0){l=f[h+16>>2]|0;m=j;while(1){n=f[l+(m<<2)>>2]|0;if(n|0)break;o=m+1|0;if(o>>>0<k>>>0)m=o;else{p=0;q=o;r=0;break a}}if((n|0)==(f[l+((m^1)<<2)>>2]|0)){o=f[n>>2]|0;p=f[o+16>>2]|0;q=m;r=o;break}else{p=n;q=m;r=0;break}}else{p=0;q=j;r=0}while(0);f[e+4>>2]=p;f[e+8>>2]=h;f[e+12>>2]=q;f[e+16>>2]=r;f[e+20>>2]=0;f[e>>2]=2;if(i){f[g+4>>2]=0;f[g+20>>2]=0;s=2;f[g>>2]=s;Gxa(a,e,g);u=d;return}}else{i=f[(f[c+12>>2]|0)+12>>2]|0;f[e>>2]=1;f[e+4>>2]=0;f[e+20>>2]=i}f[g+4>>2]=0;f[g+20>>2]=0;s=1;f[g>>2]=s;Gxa(a,e,g);u=d;return}function txa(a){a=a|0;var c=0,d=0,e=0,g=0;yxa(a);if(f[a>>2]|0)return;c=a+12|0;if(!(b[a+8>>0]|0)){a=f[c>>2]|0;if(!a)return;d=a+16|0;if(f[d>>2]|0?(zxa(a),(f[a+20>>2]|0)==0):0)O5b(f[d>>2]|0);O5b(a);return}a=f[c>>2]|0;if(!a)return;c=f[a+12>>2]|0;if(c|0){d=a+16|0;e=c;do{c=e;e=f[e>>2]|0;g=c+8|0;if((b[g+11>>0]|0)<0)O5b(f[g>>2]|0);if(!(f[d>>2]|0))O5b(c)}while((e|0)!=0)}e=f[a>>2]|0;f[a>>2]=0;if(e|0?(f[a+8>>2]|0)==0:0)O5b(e);O5b(a);return}function uxa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;b=u;u=u+32|0;c=b;d=f[a>>2]|0;e=f[d+16>>2]|0;if(e|0){f[a>>2]=e;u=b;return a|0}e=a+4|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]&(f[g+4>>2]|0)+-1;f[h>>2]=i;j=f[g+16>>2]|0;k=f[j+(i<<2)>>2]|0;a:do if((k|0)!=(d|0)){b:do if(k|0?(k|0)!=(f[j+((i^1)<<2)>>2]|0):0){l=k;while(1){l=f[l+16>>2]|0;if(!l)break b;if((l|0)==(d|0)){m=i;n=g;break a}}}while(0);wxa(c,g,d);l=f[c+8>>2]|0;o=f[c+12>>2]|0;f[h>>2]=l;p=a+12|0;f[p>>2]=o;q=f[e>>2]|0;r=f[q+16>>2]|0;s=f[r+(l<<2)>>2]|0;t=o;if((s|0)!=0?(s|0)==(f[r+((l^1)<<2)>>2]|0):0){o=f[t+4>>2]|0;if(!o){v=t+8|0;w=f[v>>2]|0;if((f[w>>2]|0)==(t|0))x=w;else{w=v;do{v=f[w>>2]|0;w=v+8|0;t=f[w>>2]|0}while((f[t>>2]|0)!=(v|0));x=t}}else{w=o;while(1){t=f[w>>2]|0;if(!t)break;else w=t}x=w}f[p>>2]=x;if((x|0)!=(s+4|0)){f[a>>2]=f[x+16>>2];u=b;return a|0}o=l+2|0;f[a>>2]=0;f[h>>2]=o;t=f[q+4>>2]|0;if(t>>>0>o>>>0)y=o;else{u=b;return a|0}while(1){z=f[r+(y<<2)>>2]|0;if(z|0)break;o=y+1|0;f[h>>2]=o;if(o>>>0<t>>>0)y=o;else{A=32;break}}if((A|0)==32){u=b;return a|0}if((z|0)==(f[r+((y^1)<<2)>>2]|0)){t=f[z>>2]|0;f[a+12>>2]=t;B=f[t+16>>2]|0}else B=z;f[a>>2]=B;u=b;return a|0}else{m=l;n=q}}else{m=i;n=g}while(0);g=m+1|0;f[a>>2]=0;f[h>>2]=g;m=f[n+4>>2]|0;if(m>>>0<=g>>>0){u=b;return a|0}i=f[n+16>>2]|0;n=g;while(1){C=f[i+(n<<2)>>2]|0;if(C|0)break;g=n+1|0;f[h>>2]=g;if(g>>>0<m>>>0)n=g;else{A=32;break}}if((A|0)==32){u=b;return a|0}if((C|0)==(f[i+((n^1)<<2)>>2]|0)){n=f[C>>2]|0;f[a+12>>2]=n;D=f[n+16>>2]|0}else D=C;f[a>>2]=D;u=b;return a|0}function vxa(a,b){a=a|0;b=b|0;if(!b)return;vxa(a,f[b>>2]|0);vxa(a,f[b+4>>2]|0);bD(b+16|0);O5b(b);return}function wxa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=u;u=u+16|0;g=e+12|0;h=e;i=b[d+11>>0]|0;j=i<<24>>24<0;k=j?f[d>>2]|0:d;l=b[k>>0]|0;if(!(l<<24>>24))m=0;else{n=k;o=0;p=l;while(1){q=(o*5|0)+(p<<24>>24)|0;n=n+1|0;p=b[n>>0]|0;if(!(p<<24>>24)){m=q;break}else o=q}}o=(f[c+4>>2]|0)+-1&(f[c+8>>2]|0)+m;m=f[c+16>>2]|0;p=f[m+(o<<2)>>2]|0;a:do if(!p)r=o;else{if((p|0)==(f[m+((o^1)<<2)>>2]|0)){if((p|0)!=(f[m+((o^1)<<2)>>2]|0)){r=o;break}n=o&-2;q=f[m+(n<<2)>>2]|0;f[g>>2]=d;s=q+4|0;t=xxa(q,g,f[s>>2]|0,s)|0;do if((t|0)!=(s|0)){q=f[g>>2]|0;v=f[t+16>>2]|0;w=b[v+11>>0]|0;x=w<<24>>24<0;y=x?f[v+4>>2]|0:w&255;w=b[q+11>>0]|0;z=w<<24>>24<0;A=z?f[q+4>>2]|0:w&255;w=y>>>0<A>>>0?y:A;B=v;if((w|0)!=0?(C=ZVb(z?f[q>>2]|0:q,x?f[v>>2]|0:v,w)|0,(C|0)!=0):0){if((C|0)<0)break}else D=20;if((D|0)==20?A>>>0<y>>>0:0)break;f[a>>2]=B;f[a+4>>2]=c;f[a+8>>2]=n;f[a+12>>2]=t;f[a+16>>2]=n;u=e;return}while(0);r=n;break}t=j?f[d+4>>2]|0:i&255;s=(t|0)==0;B=p;b:while(1){y=b[B+11>>0]|0;A=y<<24>>24<0;C=y&255;do if(((A?f[B+4>>2]|0:C)|0)==(t|0)){y=f[B>>2]|0;w=A?y:B;if(A){if(s)break b;if(!(ZVb(w,k,t)|0))break b;else break}if(s)break b;if((y&255)<<24>>24==l<<24>>24){y=B;w=C;v=k;do{w=w+-1|0;y=y+1|0;if(!w)break b;v=v+1|0}while((b[y>>0]|0)==(b[v>>0]|0))}}while(0);C=f[B+16>>2]|0;if(!C){r=o;break a}else B=C}f[a>>2]=B;f[a+4>>2]=c;f[a+8>>2]=o;f[a+16>>2]=o;u=e;return}while(0);f[a>>2]=0;o=a+4|0;f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];f[o+8>>2]=f[h+8>>2];f[a+16>>2]=r;u=e;return}function xxa(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(!d){g=e;return g|0}a=f[c>>2]|0;c=b[a+11>>0]|0;h=c<<24>>24<0;i=h?f[a+4>>2]|0:c&255;if(h){h=e;c=d;a:while(1){j=c;while(1){k=f[j+16>>2]|0;l=b[k+11>>0]|0;m=l<<24>>24<0;n=m?f[k+4>>2]|0:l&255;l=i>>>0<n>>>0?i:n;if((l|0)!=0?(o=ZVb(m?f[k>>2]|0:k,f[a>>2]|0,l)|0,(o|0)!=0):0){if((o|0)>=0)break}else p=7;if((p|0)==7?(p=0,n>>>0>=i>>>0):0)break;n=f[j+4>>2]|0;if(!n){g=h;p=17;break a}else j=n}c=f[j>>2]|0;if(!c){g=j;p=17;break}else h=j}if((p|0)==17)return g|0}else{h=e;e=d;b:while(1){d=e;while(1){c=f[d+16>>2]|0;n=b[c+11>>0]|0;o=n<<24>>24<0;l=o?f[c+4>>2]|0:n&255;n=i>>>0<l>>>0?i:l;if((n|0)!=0?(k=ZVb(o?f[c>>2]|0:c,a,n)|0,(k|0)!=0):0){if((k|0)>=0)break}else p=13;if((p|0)==13?(p=0,l>>>0>=i>>>0):0)break;l=f[d+4>>2]|0;if(!l){g=h;p=17;break b}else d=l}e=f[d>>2]|0;if(!e){g=d;p=17;break}else h=d}if((p|0)==17)return g|0}return 0}function yxa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+80|0;d=c+48|0;e=c+24|0;g=c;h=(b[a+8>>0]|0)==0;a:do if(h){i=f[a+12>>2]|0;j=f[i+12>>2]|0;k=f[i+4>>2]|0;if(k>>>0>j>>>0){l=f[i+16>>2]|0;m=j;while(1){n=f[l+(m<<2)>>2]|0;if(n|0)break;o=m+1|0;if(o>>>0<k>>>0)m=o;else{p=2;q=0;r=i;s=o;t=0;v=0;break a}}if((n|0)==(f[l+((m^1)<<2)>>2]|0)){k=f[n>>2]|0;p=2;q=f[k+16>>2]|0;r=i;s=m;t=k;v=0;break}else{p=2;q=n;r=i;s=m;t=0;v=0;break}}else{p=2;q=0;r=i;s=j;t=0;v=0}}else{p=1;q=0;r=0;s=0;t=0;v=f[(f[a+12>>2]|0)+12>>2]|0}while(0);n=h?2:1;f[g>>2]=p;f[g+4>>2]=q;f[g+8>>2]=r;f[g+12>>2]=s;f[g+16>>2]=t;f[g+20>>2]=v;t=g+4|0;s=g+20|0;r=(p|0)==(n|0);if(h){if(r&(q|0)==0){u=c;return}do{f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];f[d+8>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];f[d+16>>2]=f[g+16>>2];f[d+20>>2]=f[g+20>>2];Bxa(e,a,d);f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];f[g+16>>2]=f[e+16>>2];f[g+20>>2]=f[e+20>>2]}while(!((f[t>>2]|0)==0?(f[g>>2]|0)==(n|0):0));u=c;return}else{if(r&(v|0)==0){u=c;return}do{f[d>>2]=f[g>>2];f[d+4>>2]=f[g+4>>2];f[d+8>>2]=f[g+8>>2];f[d+12>>2]=f[g+12>>2];f[d+16>>2]=f[g+16>>2];f[d+20>>2]=f[g+20>>2];Bxa(e,a,d);f[g>>2]=f[e>>2];f[g+4>>2]=f[e+4>>2];f[g+8>>2]=f[e+8>>2];f[g+12>>2]=f[e+12>>2];f[g+16>>2]=f[e+16>>2];f[g+20>>2]=f[e+20>>2]}while(!((f[s>>2]|0)==0?(f[g>>2]|0)==(n|0):0));u=c;return}}function zxa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;c=a+4|0;if(!(f[c>>2]|0)){d=0;f[a>>2]=0;e=a+12|0;f[e>>2]=d;return}g=a+16|0;h=a+20|0;i=0;while(1){j=f[g>>2]|0;k=j+(i<<2)|0;l=f[k>>2]|0;a:do if(l){if((l|0)!=(f[j+((i^1)<<2)>>2]|0)){f[k>>2]=0;m=l;while(1){n=m;m=f[m+16>>2]|0;if((b[n+11>>0]|0)<0)O5b(f[n>>2]|0);if(!(f[h>>2]|0))O5b(n);if(!m){o=i;break a}}}if((l|0)==(f[j+((i^1)<<2)>>2]|0)){m=i+1|0;f[j+(m<<2)>>2]=0;f[(f[g>>2]|0)+(i<<2)>>2]=0;n=l+12|0;p=l+4|0;q=l+8|0;r=l+4|0;s=f[l>>2]|0;do{t=s;u=f[t+16>>2]|0;v=s;w=f[v+4>>2]|0;if(!w){x=v+8|0;y=f[x>>2]|0;if((f[y>>2]|0)==(v|0))z=y;else{y=x;do{x=f[y>>2]|0;y=x+8|0;A=f[y>>2]|0}while((f[A>>2]|0)!=(x|0));z=A}}else{y=w;while(1){A=f[y>>2]|0;if(!A)break;else y=A}z=y}w=f[t+4>>2]|0;if(!w){A=t+8|0;x=f[A>>2]|0;if((f[x>>2]|0)==(v|0))B=x;else{x=A;do{A=f[x>>2]|0;x=A+8|0;C=f[x>>2]|0}while((f[C>>2]|0)!=(A|0));B=C}}else{x=w;while(1){y=f[x>>2]|0;if(!y)break;else x=y}B=x}if((f[l>>2]|0)==(t|0))f[l>>2]=B;f[n>>2]=(f[n>>2]|0)+-1;wwa(f[p>>2]|0,v);if(!(f[q>>2]|0))O5b(s);s=z;if((b[u+11>>0]|0)<0)O5b(f[u>>2]|0);if(!(f[h>>2]|0))O5b(u)}while((z|0)!=(r|0));s=f[h>>2]|0;Axa(l,f[r>>2]|0);if(!s){O5b(l);o=m}else o=m}else o=i}else o=i;while(0);i=o+1|0;l=f[c>>2]|0;if(i>>>0>=l>>>0){d=l;break}}f[a>>2]=0;e=a+12|0;f[e>>2]=d;return}function Axa(a,b){a=a|0;b=b|0;if(!b)return;Axa(a,f[b>>2]|0);Axa(a,f[b+4>>2]|0);if(f[a+8>>2]|0)return;O5b(b);return}function Bxa(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+48|0;g=e+32|0;h=e;i=e+16|0;if(!(f[c>>2]|0)){if((f[d>>2]|0)==1)j=(f[d+20>>2]|0)+20|0;else j=(f[d+4>>2]|0)+12|0;k=f[j>>2]|0;if(k|0){BGa(k+16|0);if((b[k+11>>0]|0)<0)O5b(f[k>>2]|0);O5b(k)}}if((f[d>>2]|0)==1){k=d+20|0;j=f[k>>2]|0;f[k>>2]=f[j>>2];l=0;m=j}else{j=f[d+4>>2]|0;k=d+8|0;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];Cxa(d+4|0)|0;l=j;m=0}j=c+12|0;if(!(b[c+8>>0]|0)){c=f[j>>2]|0;f[i>>2]=l;l=i+4|0;f[l>>2]=f[h>>2];f[l+4>>2]=f[h+4>>2];f[l+8>>2]=f[h+8>>2];f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];f[g+12>>2]=f[i+12>>2];Dxa(c,g);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];f[a+8>>2]=f[d+8>>2];f[a+12>>2]=f[d+12>>2];f[a+16>>2]=f[d+16>>2];f[a+20>>2]=f[d+20>>2];u=e;return}g=f[j>>2]|0;j=m;c=f[g+4>>2]|0;i=f[j+4>>2]|0;h=c+-1|0;l=(h&c|0)==0;if(!l)if(i>>>0<c>>>0)n=i;else n=(i>>>0)%(c>>>0)|0;else n=h&i;i=(f[g>>2]|0)+(n<<2)|0;k=f[i>>2]|0;while(1){o=f[k>>2]|0;if((o|0)==(j|0))break;else k=o}if((k|0)!=(g+12|0)){o=f[k+4>>2]|0;if(!l)if(o>>>0<c>>>0)p=o;else p=(o>>>0)%(c>>>0)|0;else p=o&h;if((p|0)==(n|0))q=j;else r=26}else r=26;do if((r|0)==26){p=f[j>>2]|0;if(p|0){o=f[p+4>>2]|0;if(!l)if(o>>>0<c>>>0)s=o;else s=(o>>>0)%(c>>>0)|0;else s=o&h;if((s|0)==(n|0)){q=j;break}}f[i>>2]=0;q=j}while(0);j=f[q>>2]|0;i=j;if(j){s=f[j+4>>2]|0;if(!l)if(s>>>0<c>>>0)t=s;else t=(s>>>0)%(c>>>0)|0;else t=s&h;if((t|0)!=(n|0)){f[(f[g>>2]|0)+(t<<2)>>2]=k;v=f[m>>2]|0}else v=i}else v=i;f[k>>2]=v;f[q>>2]=0;q=g+20|0;f[q>>2]=(f[q>>2]|0)+-1;if(!m){f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];f[a+8>>2]=f[d+8>>2];f[a+12>>2]=f[d+12>>2];f[a+16>>2]=f[d+16>>2];f[a+20>>2]=f[d+20>>2];u=e;return}q=m+8|0;if((b[q+11>>0]|0)<0)O5b(f[q>>2]|0);if(f[g+16>>2]|0){f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];f[a+8>>2]=f[d+8>>2];f[a+12>>2]=f[d+12>>2];f[a+16>>2]=f[d+16>>2];f[a+20>>2]=f[d+20>>2];u=e;return}O5b(m);f[a>>2]=f[d>>2];f[a+4>>2]=f[d+4>>2];f[a+8>>2]=f[d+8>>2];f[a+12>>2]=f[d+12>>2];f[a+16>>2]=f[d+16>>2];f[a+20>>2]=f[d+20>>2];u=e;return}function Cxa(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;b=u;u=u+32|0;c=b;d=f[a>>2]|0;e=f[d+16>>2]|0;if(e|0){f[a>>2]=e;u=b;return a|0}e=a+4|0;g=f[e>>2]|0;h=a+8|0;i=f[h>>2]&(f[g+4>>2]|0)+-1;f[h>>2]=i;j=f[g+16>>2]|0;k=f[j+(i<<2)>>2]|0;a:do if((k|0)!=(d|0)){b:do if(k|0?(k|0)!=(f[j+((i^1)<<2)>>2]|0):0){l=k;while(1){l=f[l+16>>2]|0;if(!l)break b;if((l|0)==(d|0)){m=i;n=g;break a}}}while(0);wxa(c,g,d);l=f[c+8>>2]|0;o=f[c+12>>2]|0;f[h>>2]=l;p=a+12|0;f[p>>2]=o;q=f[e>>2]|0;r=f[q+16>>2]|0;s=f[r+(l<<2)>>2]|0;t=o;if((s|0)!=0?(s|0)==(f[r+((l^1)<<2)>>2]|0):0){o=f[t+4>>2]|0;if(!o){v=t+8|0;w=f[v>>2]|0;if((f[w>>2]|0)==(t|0))x=w;else{w=v;do{v=f[w>>2]|0;w=v+8|0;t=f[w>>2]|0}while((f[t>>2]|0)!=(v|0));x=t}}else{w=o;while(1){t=f[w>>2]|0;if(!t)break;else w=t}x=w}f[p>>2]=x;if((x|0)!=(s+4|0)){f[a>>2]=f[x+16>>2];u=b;return a|0}o=l+2|0;f[a>>2]=0;f[h>>2]=o;t=f[q+4>>2]|0;if(t>>>0>o>>>0)y=o;else{u=b;return a|0}while(1){z=f[r+(y<<2)>>2]|0;if(z|0)break;o=y+1|0;f[h>>2]=o;if(o>>>0<t>>>0)y=o;else{A=32;break}}if((A|0)==32){u=b;return a|0}if((z|0)==(f[r+((y^1)<<2)>>2]|0)){t=f[z>>2]|0;f[a+12>>2]=t;B=f[t+16>>2]|0}else B=z;f[a>>2]=B;u=b;return a|0}else{m=l;n=q}}else{m=i;n=g}while(0);g=m+1|0;f[a>>2]=0;f[h>>2]=g;m=f[n+4>>2]|0;if(m>>>0<=g>>>0){u=b;return a|0}i=f[n+16>>2]|0;n=g;while(1){C=f[i+(n<<2)>>2]|0;if(C|0)break;g=n+1|0;f[h>>2]=g;if(g>>>0<m>>>0)n=g;else{A=32;break}}if((A|0)==32){u=b;return a|0}if((C|0)==(f[i+((n^1)<<2)>>2]|0)){n=f[C>>2]|0;f[a+12>>2]=n;D=f[n+16>>2]|0}else D=C;f[a>>2]=D;u=b;return a|0}function Dxa(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=u;u=u+32|0;e=d;g=f[c+4>>2]|0;h=c+8|0;i=f[h>>2]&(f[g+4>>2]|0)+-1;f[h>>2]=i;j=g+16|0;k=f[j>>2]|0;l=f[k+(i<<2)>>2]|0;m=f[c>>2]|0;a:do if((l|0)!=(m|0)){b:do if(l|0?(l|0)!=(f[k+((i^1)<<2)>>2]|0):0){n=l;while(1){n=f[n+16>>2]|0;if(!n)break b;if((n|0)==(m|0)){o=i;p=7;break a}}}while(0);wxa(e,g,m);n=f[e+8>>2]|0;q=f[e+12>>2]|0;f[h>>2]=n;f[c+12>>2]=q;r=f[j>>2]|0;s=f[r+(n<<2)>>2]|0;t=q;if(s){v=a+16|0;w=(f[v>>2]|0)+(n<<2)|0;if((s|0)==(f[r+((n^1)<<2)>>2]|0)){r=f[w>>2]|0;s=f[t+4>>2]|0;if(!s){x=t+8|0;y=f[x>>2]|0;if((f[y>>2]|0)==(q|0))z=y;else{y=x;do{x=f[y>>2]|0;y=x+8|0;A=f[y>>2]|0}while((f[A>>2]|0)!=(x|0));z=A}}else{y=s;while(1){A=f[y>>2]|0;if(!A)break;else y=A}z=y}if((f[r>>2]|0)==(t|0))f[r>>2]=z;s=r+12|0;f[s>>2]=(f[s>>2]|0)+-1;wwa(f[r+4>>2]|0,q);if(!(f[r+8>>2]|0))O5b(q);if(!(f[s>>2]|0)){s=n&-2;A=f[a+20>>2]|0;Axa(r,f[r+4>>2]|0);if(!A)O5b(r);f[(f[v>>2]|0)+((n|1)<<2)>>2]=0;f[(f[v>>2]|0)+(s<<2)>>2]=0;B=s;C=v}else{B=n;C=v}}else{D=w;E=v;F=n;p=9}}else{o=n;p=7}}else{o=i;p=7}while(0);if((p|0)==7){i=a+16|0;D=(f[i>>2]|0)+(o<<2)|0;E=i;F=o;p=9}if((p|0)==9){o=Exa(a,m,f[D>>2]|0)|0;f[(f[E>>2]|0)+(F<<2)>>2]=o;B=F;C=E}if((b[m+11>>0]|0)<0)O5b(f[m>>2]|0);if(!(f[a+20>>2]|0))O5b(m);f[a>>2]=(f[a>>2]|0)+-1;m=a+12|0;if((B|0)!=(f[m>>2]|0)){u=d;return}E=f[a+4>>2]|0;if(B>>>0>=E>>>0){u=d;return}a=f[C>>2]|0;C=B;while(1){if(f[a+(C<<2)>>2]|0){p=32;break}C=C+1|0;f[m>>2]=C;if(C>>>0>=E>>>0){p=32;break}}if((p|0)==32){u=d;return}}function Exa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=c+16|0;e=f[d>>2]|0;if((c|0)==(b|0))return e|0;else{g=Exa(a,b,e)|0;f[d>>2]=g;return c|0}return 0}function Fxa(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0;c=f[a>>2]|0;d=c;e=(c|0)==0;if(!(b[a+8>>0]|0)){if(e){g=L5b(24)|0;f[g>>2]=0;f[g+8>>2]=g;h=g+16|0;f[h>>2]=0;f[g+20>>2]=d;i=L5b(32)|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;f[i+16>>2]=0;f[i+20>>2]=0;f[i+24>>2]=0;f[i+28>>2]=0;f[h>>2]=i;f[g+12>>2]=8;f[g+4>>2]=8;j=g}else{g=znb(c,18008,24)|0;f[g>>2]=0;f[g+8>>2]=g;i=g+16|0;f[i>>2]=0;f[g+20>>2]=d;h=znb(c,25536,32)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;f[h+16>>2]=0;f[h+20>>2]=0;f[h+24>>2]=0;f[h+28>>2]=0;f[i>>2]=h;f[g+12>>2]=8;f[g+4>>2]=8;xnb(c,g,1479);j=g}f[a+12>>2]=j;return}else{if(e){e=L5b(28)|0;f[e>>2]=0;j=e+4|0;f[j>>2]=0;f[j+4>>2]=d;f[e+12>>2]=0;f[e+16>>2]=d;f[e+20>>2]=0;n[e+24>>2]=1.0;Xxa(e,0);k=e}else{e=znb(c,17992,28)|0;f[e>>2]=0;j=e+4|0;f[j>>2]=0;f[j+4>>2]=d;f[e+12>>2]=0;f[e+16>>2]=d;f[e+20>>2]=0;n[e+24>>2]=1.0;Xxa(e,0);xnb(c,e,1478);k=e}f[a+12>>2]=k;return}}
function h4(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0.0;a=u;u=u+16|0;i=a;k=c+8|0;l=e+8|0;if((f[k>>2]|0)!=(f[l>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,26)|0;n=235286;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,489445,235014,2594);bD(i)}q=c+12|0;r=e+12|0;if((f[q>>2]|0)!=(f[r>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,26)|0;n=235313;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,489445,235014,2595);bD(i)}if((g|0)!=8){f[i>>2]=0;f[i+4>>2]=0;m=aD(i,17)|0;n=235340;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,i,489445,235014,2596);bD(i)}i=f[k>>2]|0;k=f[q>>2]|0;q=TC((Y(((i+1|0)/2|0)<<1,(k+1|0)/2|0)|0)+2|0)|0;d[q>>1]=0;if((i|0)>0){n=c+16|0;m=c+44|0;o=e+16|0;g=e+44|0;s=(k|0)>0;t=1;v=0;while(1){w=f[f[m>>2]>>2]|0;x=(f[n>>2]|0)+(Y(w,v)|0)|0;y=0-w|0;z=x+y|0;A=z+y|0;y=x+w|0;w=f[f[g>>2]>>2]|0;B=(f[o>>2]|0)+(Y(w,v)|0)|0;C=0-w|0;w=B+C+C|0;if(s){C=(v|1|0)<(i|0);D=(v|0)>0;E=D^1;F=(v+-2|0)>-1;G=0;H=t;while(1){a:do if(!(b[x+G>>0]|0)){I=G|1;K=(I|0)<(k|0);if(C?b[y+G>>0]|0:0){L=G+-1|0;M=(G|0)>0;if(K?b[x+I>>0]|0:0){do if(M){if(b[x+L>>0]|0){do if(D){if(b[z+I>>0]|0){if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}do if(F){if(!(b[A+G>>0]|0))break;O=G+-2|0;if(b[z+L>>0]|0){d[B+(G<<1)>>1]=d[B+(O<<1)>>1]|0;N=H;break a}do if((O|0)>-1){if(!(b[z+O>>0]|0))break;if(b[A+L>>0]|0){d[B+(G<<1)>>1]=d[B+(O<<1)>>1]|0;N=H;break a}P=d[w+(G<<1)>>1]|0;Q=d[B+(O<<1)>>1]|0;R=P;while(1){S=d[q+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}if(P<<16>>16==Q<<16>>16)T=R;else{S=Q;while(1){U=d[q+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}U=(R&65535)>(S&65535)?S:R;V=Q;do{W=q+((V&65535)<<1)|0;X=V;V=d[W>>1]|0;d[W>>1]=U}while((V&65535)<(X&65535));T=U}U=P;do{V=q+((U&65535)<<1)|0;Q=U;U=d[V>>1]|0;d[V>>1]=T}while((U&65535)<(Q&65535));d[B+(G<<1)>>1]=T;N=H;break a}while(0);U=d[w+(G<<1)>>1]|0;P=d[B+(O<<1)>>1]|0;Q=U;while(1){V=d[q+((Q&65535)<<1)>>1]|0;if((V&65535)<(Q&65535))Q=V;else break}if(U<<16>>16==P<<16>>16)Z=Q;else{O=P;while(1){V=d[q+((O&65535)<<1)>>1]|0;if((V&65535)<(O&65535))O=V;else break}V=(Q&65535)>(O&65535)?O:Q;R=P;do{S=q+((R&65535)<<1)|0;X=R;R=d[S>>1]|0;d[S>>1]=V}while((R&65535)<(X&65535));Z=V}V=U;do{R=q+((V&65535)<<1)|0;P=V;V=d[R>>1]|0;d[R>>1]=Z}while((V&65535)<(P&65535));d[B+(G<<1)>>1]=Z;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;U=d[B+(G+-2<<1)>>1]|0;P=V;while(1){R=d[q+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(V<<16>>16==U<<16>>16)_=P;else{R=U;while(1){Q=d[q+((R&65535)<<1)>>1]|0;if((Q&65535)<(R&65535))R=Q;else break}Q=(P&65535)>(R&65535)?R:P;O=U;do{X=q+((O&65535)<<1)|0;S=O;O=d[X>>1]|0;d[X>>1]=Q}while((O&65535)<(S&65535));_=Q}Q=V;do{O=q+((Q&65535)<<1)|0;U=Q;Q=d[O>>1]|0;d[O>>1]=_}while((Q&65535)<(U&65535));d[B+(G<<1)>>1]=_;N=H;break a}Q=G+2|0;if((Q|0)>=(k|0))break;if(!(b[z+Q>>0]|0))break;do if(F){if(!(b[A+I>>0]|0))break;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}if(!(b[A+G>>0]|0)){V=d[w+(Q<<1)>>1]|0;U=d[B+(G+-2<<1)>>1]|0;O=V;while(1){P=d[q+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}if(V<<16>>16==U<<16>>16)$=O;else{P=U;while(1){R=d[q+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}R=(O&65535)>(P&65535)?P:O;S=U;do{X=q+((S&65535)<<1)|0;W=S;S=d[X>>1]|0;d[X>>1]=R}while((S&65535)<(W&65535));$=R}R=V;do{S=q+((R&65535)<<1)|0;U=R;R=d[S>>1]|0;d[S>>1]=$}while((R&65535)<(U&65535));d[B+(G<<1)>>1]=$;N=H;break a}R=G+-2|0;if(b[z+L>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}do if((R|0)>-1){if(!(b[z+R>>0]|0))break;if(b[A+L>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}V=d[w+(Q<<1)>>1]|0;U=d[B+(R<<1)>>1]|0;S=V;while(1){O=d[q+((S&65535)<<1)>>1]|0;if((O&65535)<(S&65535))S=O;else break}if(V<<16>>16==U<<16>>16)aa=S;else{O=U;while(1){P=d[q+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(S&65535)>(O&65535)?O:S;W=U;do{X=q+((W&65535)<<1)|0;ba=W;W=d[X>>1]|0;d[X>>1]=P}while((W&65535)<(ba&65535));aa=P}P=V;do{W=q+((P&65535)<<1)|0;U=P;P=d[W>>1]|0;d[W>>1]=aa}while((P&65535)<(U&65535));d[B+(G<<1)>>1]=aa;N=H;break a}while(0);P=d[w+(Q<<1)>>1]|0;V=d[B+(R<<1)>>1]|0;U=P;while(1){W=d[q+((U&65535)<<1)>>1]|0;if((W&65535)<(U&65535))U=W;else break}if(P<<16>>16==V<<16>>16)ca=U;else{R=V;while(1){W=d[q+((R&65535)<<1)>>1]|0;if((W&65535)<(R&65535))R=W;else break}W=(U&65535)>(R&65535)?R:U;S=V;do{O=q+((S&65535)<<1)|0;ba=S;S=d[O>>1]|0;d[O>>1]=W}while((S&65535)<(ba&65535));ca=W}W=P;do{S=q+((W&65535)<<1)|0;V=W;W=d[S>>1]|0;d[S>>1]=ca}while((W&65535)<(V&65535));d[B+(G<<1)>>1]=ca;N=H;break a}while(0);W=d[w+(Q<<1)>>1]|0;P=d[B+(G+-2<<1)>>1]|0;V=W;while(1){S=d[q+((V&65535)<<1)>>1]|0;if((S&65535)<(V&65535))V=S;else break}if(W<<16>>16==P<<16>>16)da=V;else{Q=P;while(1){S=d[q+((Q&65535)<<1)>>1]|0;if((S&65535)<(Q&65535))Q=S;else break}S=(V&65535)>(Q&65535)?Q:V;U=P;do{R=q+((U&65535)<<1)|0;ba=U;U=d[R>>1]|0;d[R>>1]=S}while((U&65535)<(ba&65535));da=S}S=W;do{U=q+((S&65535)<<1)|0;P=S;S=d[U>>1]|0;d[U>>1]=da}while((S&65535)<(P&65535));d[B+(G<<1)>>1]=da;N=H;break a}while(0);d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}if(!(b[y+L>>0]|0))break;do if(D){if(b[z+I>>0]|0){S=G+-2|0;do if((S|0)>-1){if(!(b[x+S>>0]|0))break;if(b[z+L>>0]|0){W=d[B+(S<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}do if(F){if(!(b[A+G>>0]|0))break;d[B+(G<<1)>>1]=W;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;U=P;while(1){V=d[q+((U&65535)<<1)>>1]|0;if((V&65535)<(U&65535))U=V;else break}if(P<<16>>16==W<<16>>16)ea=U;else{V=W;while(1){Q=d[q+((V&65535)<<1)>>1]|0;if((Q&65535)<(V&65535))V=Q;else break}Q=(U&65535)>(V&65535)?V:U;ba=W;do{R=q+((ba&65535)<<1)|0;O=ba;ba=d[R>>1]|0;d[R>>1]=Q}while((ba&65535)<(O&65535));ea=Q}Q=P;do{ba=q+((Q&65535)<<1)|0;W=Q;Q=d[ba>>1]|0;d[ba>>1]=ea}while((Q&65535)<(W&65535));d[B+(G<<1)>>1]=ea;N=H;break a}if(!(b[z+S>>0]|0)){Q=d[w+(G<<1)>>1]|0;P=d[B+(S<<1)>>1]|0;W=Q;while(1){ba=d[q+((W&65535)<<1)>>1]|0;if((ba&65535)<(W&65535))W=ba;else break}if(Q<<16>>16==P<<16>>16)fa=W;else{ba=P;while(1){U=d[q+((ba&65535)<<1)>>1]|0;if((U&65535)<(ba&65535))ba=U;else break}U=(W&65535)>(ba&65535)?ba:W;V=P;do{O=q+((V&65535)<<1)|0;R=V;V=d[O>>1]|0;d[O>>1]=U}while((V&65535)<(R&65535));fa=U}U=Q;do{V=q+((U&65535)<<1)|0;P=U;U=d[V>>1]|0;d[V>>1]=fa}while((U&65535)<(P&65535));d[B+(G<<1)>>1]=fa;N=H;break a}do if(F){if(!(b[A+L>>0]|0))break;U=d[B+(S<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=U;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=U;N=H;break a}Q=d[w+(G<<1)>>1]|0;P=Q;while(1){V=d[q+((P&65535)<<1)>>1]|0;if((V&65535)<(P&65535))P=V;else break}if(Q<<16>>16==U<<16>>16)ga=P;else{V=U;while(1){W=d[q+((V&65535)<<1)>>1]|0;if((W&65535)<(V&65535))V=W;else break}W=(P&65535)>(V&65535)?V:P;ba=U;do{R=q+((ba&65535)<<1)|0;O=ba;ba=d[R>>1]|0;d[R>>1]=W}while((ba&65535)<(O&65535));ga=W}W=Q;do{ba=q+((W&65535)<<1)|0;U=W;W=d[ba>>1]|0;d[ba>>1]=ga}while((W&65535)<(U&65535));d[B+(G<<1)>>1]=ga;N=H;break a}while(0);W=d[w+(G<<1)>>1]|0;Q=d[B+(S<<1)>>1]|0;U=W;while(1){ba=d[q+((U&65535)<<1)>>1]|0;if((ba&65535)<(U&65535))U=ba;else break}if(W<<16>>16==Q<<16>>16)ha=U;else{ba=Q;while(1){P=d[q+((ba&65535)<<1)>>1]|0;if((P&65535)<(ba&65535))ba=P;else break}P=(U&65535)>(ba&65535)?ba:U;V=Q;do{O=q+((V&65535)<<1)|0;R=V;V=d[O>>1]|0;d[O>>1]=P}while((V&65535)<(R&65535));ha=P}P=W;do{V=q+((P&65535)<<1)|0;Q=P;P=d[V>>1]|0;d[V>>1]=ha}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=ha;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;W=d[B+(S<<1)>>1]|0;Q=P;while(1){V=d[q+((Q&65535)<<1)>>1]|0;if((V&65535)<(Q&65535))Q=V;else break}if(P<<16>>16==W<<16>>16)ia=Q;else{S=W;while(1){V=d[q+((S&65535)<<1)>>1]|0;if((V&65535)<(S&65535))S=V;else break}V=(Q&65535)>(S&65535)?S:Q;U=W;do{ba=q+((U&65535)<<1)|0;R=U;U=d[ba>>1]|0;d[ba>>1]=V}while((U&65535)<(R&65535));ia=V}V=P;do{U=q+((V&65535)<<1)|0;W=V;V=d[U>>1]|0;d[U>>1]=ia}while((V&65535)<(W&65535));d[B+(G<<1)>>1]=ia;N=H;break a}V=G+2|0;do if(!((V|0)>=(k|0)|E)){if(!(b[z+V>>0]|0))break;do if(F){if(!(b[A+I>>0]|0))break;P=G+-2|0;do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[z+L>>0]|0){W=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}U=d[w+(V<<1)>>1]|0;Q=U;while(1){S=d[q+((Q&65535)<<1)>>1]|0;if((S&65535)<(Q&65535))Q=S;else break}if(U<<16>>16==W<<16>>16)ja=Q;else{S=W;while(1){R=d[q+((S&65535)<<1)>>1]|0;if((R&65535)<(S&65535))S=R;else break}R=(Q&65535)>(S&65535)?S:Q;ba=W;do{O=q+((ba&65535)<<1)|0;X=ba;ba=d[O>>1]|0;d[O>>1]=R}while((ba&65535)<(X&65535));ja=R}R=U;do{ba=q+((R&65535)<<1)|0;W=R;R=d[ba>>1]|0;d[ba>>1]=ja}while((R&65535)<(W&65535));d[B+(G<<1)>>1]=ja;N=H;break a}if(!(b[z+P>>0]|0)){R=d[w+(V<<1)>>1]|0;U=d[B+(P<<1)>>1]|0;W=R;while(1){ba=d[q+((W&65535)<<1)>>1]|0;if((ba&65535)<(W&65535))W=ba;else break}if(R<<16>>16==U<<16>>16)ka=W;else{ba=U;while(1){Q=d[q+((ba&65535)<<1)>>1]|0;if((Q&65535)<(ba&65535))ba=Q;else break}Q=(W&65535)>(ba&65535)?ba:W;S=U;do{X=q+((S&65535)<<1)|0;O=S;S=d[X>>1]|0;d[X>>1]=Q}while((S&65535)<(O&65535));ka=Q}Q=R;do{S=q+((Q&65535)<<1)|0;U=Q;Q=d[S>>1]|0;d[S>>1]=ka}while((Q&65535)<(U&65535));d[B+(G<<1)>>1]=ka;N=H;break a}if(!(b[A+L>>0]|0)){Q=d[w+(V<<1)>>1]|0;R=d[B+(P<<1)>>1]|0;U=Q;while(1){S=d[q+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}if(Q<<16>>16==R<<16>>16)la=U;else{S=R;while(1){W=d[q+((S&65535)<<1)>>1]|0;if((W&65535)<(S&65535))S=W;else break}W=(U&65535)>(S&65535)?S:U;ba=R;do{O=q+((ba&65535)<<1)|0;X=ba;ba=d[O>>1]|0;d[O>>1]=W}while((ba&65535)<(X&65535));la=W}W=Q;do{ba=q+((W&65535)<<1)|0;R=W;W=d[ba>>1]|0;d[ba>>1]=la}while((W&65535)<(R&65535));d[B+(G<<1)>>1]=la;N=H;break a}W=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}Q=d[w+(V<<1)>>1]|0;R=Q;while(1){ba=d[q+((R&65535)<<1)>>1]|0;if((ba&65535)<(R&65535))R=ba;else break}if(Q<<16>>16==W<<16>>16)ma=R;else{ba=W;while(1){U=d[q+((ba&65535)<<1)>>1]|0;if((U&65535)<(ba&65535))ba=U;else break}U=(R&65535)>(ba&65535)?ba:R;S=W;do{X=q+((S&65535)<<1)|0;O=S;S=d[X>>1]|0;d[X>>1]=U}while((S&65535)<(O&65535));ma=U}U=Q;do{S=q+((U&65535)<<1)|0;W=U;U=d[S>>1]|0;d[S>>1]=ma}while((U&65535)<(W&65535));d[B+(G<<1)>>1]=ma;N=H;break a}while(0);U=d[w+(V<<1)>>1]|0;Q=d[B+(P<<1)>>1]|0;W=U;while(1){S=d[q+((W&65535)<<1)>>1]|0;if((S&65535)<(W&65535))W=S;else break}if(U<<16>>16==Q<<16>>16)na=W;else{P=Q;while(1){S=d[q+((P&65535)<<1)>>1]|0;if((S&65535)<(P&65535))P=S;else break}S=(W&65535)>(P&65535)?P:W;R=Q;do{ba=q+((R&65535)<<1)|0;O=R;R=d[ba>>1]|0;d[ba>>1]=S}while((R&65535)<(O&65535));na=S}S=U;do{R=q+((S&65535)<<1)|0;Q=S;S=d[R>>1]|0;d[R>>1]=na}while((S&65535)<(Q&65535));d[B+(G<<1)>>1]=na;N=H;break a}while(0);S=G+-2|0;if(!(b[z+G>>0]|0)){U=d[w+(V<<1)>>1]|0;Q=d[B+(S<<1)>>1]|0;R=U;while(1){W=d[q+((R&65535)<<1)>>1]|0;if((W&65535)<(R&65535))R=W;else break}if(U<<16>>16==Q<<16>>16)oa=R;else{W=Q;while(1){P=d[q+((W&65535)<<1)>>1]|0;if((P&65535)<(W&65535))W=P;else break}P=(R&65535)>(W&65535)?W:R;O=Q;do{ba=q+((O&65535)<<1)|0;X=O;O=d[ba>>1]|0;d[ba>>1]=P}while((O&65535)<(X&65535));oa=P}P=U;do{O=q+((P&65535)<<1)|0;Q=P;P=d[O>>1]|0;d[O>>1]=oa}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=oa;N=H;break a}do if((S|0)>-1){if(!(b[x+S>>0]|0))break;if(b[z+L>>0]|0){P=d[w+(V<<1)>>1]|0;U=d[B+(S<<1)>>1]|0;Q=P;while(1){O=d[q+((Q&65535)<<1)>>1]|0;if((O&65535)<(Q&65535))Q=O;else break}if(P<<16>>16==U<<16>>16)pa=Q;else{O=U;while(1){R=d[q+((O&65535)<<1)>>1]|0;if((R&65535)<(O&65535))O=R;else break}R=(Q&65535)>(O&65535)?O:Q;W=U;do{X=q+((W&65535)<<1)|0;ba=W;W=d[X>>1]|0;d[X>>1]=R}while((W&65535)<(ba&65535));pa=R}R=P;do{W=q+((R&65535)<<1)|0;U=R;R=d[W>>1]|0;d[W>>1]=pa}while((R&65535)<(U&65535));d[B+(G<<1)>>1]=pa;N=H;break a}if(!(b[z+S>>0]|0)){R=d[w+(G<<1)>>1]|0;P=d[w+(V<<1)>>1]|0;U=R;while(1){W=d[q+((U&65535)<<1)>>1]|0;if((W&65535)<(U&65535))U=W;else break}if(R<<16>>16==P<<16>>16)qa=U;else{W=P;while(1){Q=d[q+((W&65535)<<1)>>1]|0;if((Q&65535)<(W&65535))W=Q;else break}Q=(U&65535)>(W&65535)?W:U;O=P;do{ba=q+((O&65535)<<1)|0;X=O;O=d[ba>>1]|0;d[ba>>1]=Q}while((O&65535)<(X&65535));qa=Q}Q=R;do{O=q+((Q&65535)<<1)|0;P=Q;Q=d[O>>1]|0;d[O>>1]=qa}while((Q&65535)<(P&65535));Q=d[B+(S<<1)>>1]|0;R=qa;while(1){P=d[q+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}if(qa<<16>>16==Q<<16>>16)ra=R;else{P=Q;while(1){O=d[q+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}O=(R&65535)>(P&65535)?P:R;U=Q;do{W=q+((U&65535)<<1)|0;X=U;U=d[W>>1]|0;d[W>>1]=O}while((U&65535)<(X&65535));ra=O}O=qa;do{U=q+((O&65535)<<1)|0;Q=O;O=d[U>>1]|0;d[U>>1]=ra}while((O&65535)<(Q&65535));d[B+(G<<1)>>1]=ra;N=H;break a}do if(F){if(!(b[A+L>>0]|0))break;O=d[w+(V<<1)>>1]|0;Q=d[B+(S<<1)>>1]|0;U=O;while(1){R=d[q+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}if(O<<16>>16==Q<<16>>16)sa=U;else{R=Q;while(1){P=d[q+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(U&65535)>(R&65535)?R:U;X=Q;do{W=q+((X&65535)<<1)|0;ba=X;X=d[W>>1]|0;d[W>>1]=P}while((X&65535)<(ba&65535));sa=P}P=O;do{X=q+((P&65535)<<1)|0;Q=P;P=d[X>>1]|0;d[X>>1]=sa}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=sa;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;O=d[w+(V<<1)>>1]|0;Q=P;while(1){X=d[q+((Q&65535)<<1)>>1]|0;if((X&65535)<(Q&65535))Q=X;else break}if(P<<16>>16==O<<16>>16)ta=Q;else{X=O;while(1){U=d[q+((X&65535)<<1)>>1]|0;if((U&65535)<(X&65535))X=U;else break}U=(Q&65535)>(X&65535)?X:Q;R=O;do{ba=q+((R&65535)<<1)|0;W=R;R=d[ba>>1]|0;d[ba>>1]=U}while((R&65535)<(W&65535));ta=U}U=P;do{R=q+((U&65535)<<1)|0;O=U;U=d[R>>1]|0;d[R>>1]=ta}while((U&65535)<(O&65535));U=d[B+(S<<1)>>1]|0;P=ta;while(1){O=d[q+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}if(ta<<16>>16==U<<16>>16)ua=P;else{O=U;while(1){R=d[q+((O&65535)<<1)>>1]|0;if((R&65535)<(O&65535))O=R;else break}R=(P&65535)>(O&65535)?O:P;Q=U;do{X=q+((Q&65535)<<1)|0;W=Q;Q=d[X>>1]|0;d[X>>1]=R}while((Q&65535)<(W&65535));ua=R}R=ta;do{Q=q+((R&65535)<<1)|0;U=R;R=d[Q>>1]|0;d[Q>>1]=ua}while((R&65535)<(U&65535));d[B+(G<<1)>>1]=ua;N=H;break a}while(0);R=d[w+(G<<1)>>1]|0;U=d[w+(V<<1)>>1]|0;Q=R;while(1){P=d[q+((Q&65535)<<1)>>1]|0;if((P&65535)<(Q&65535))Q=P;else break}if(R<<16>>16==U<<16>>16)va=Q;else{P=U;while(1){O=d[q+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}O=(Q&65535)>(P&65535)?P:Q;W=U;do{X=q+((W&65535)<<1)|0;ba=W;W=d[X>>1]|0;d[X>>1]=O}while((W&65535)<(ba&65535));va=O}O=R;do{W=q+((O&65535)<<1)|0;U=O;O=d[W>>1]|0;d[W>>1]=va}while((O&65535)<(U&65535));O=d[B+(S<<1)>>1]|0;R=va;while(1){U=d[q+((R&65535)<<1)>>1]|0;if((U&65535)<(R&65535))R=U;else break}if(va<<16>>16==O<<16>>16)wa=R;else{S=O;while(1){U=d[q+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}U=(R&65535)>(S&65535)?S:R;W=O;do{Q=q+((W&65535)<<1)|0;P=W;W=d[Q>>1]|0;d[Q>>1]=U}while((W&65535)<(P&65535));wa=U}U=va;do{W=q+((U&65535)<<1)|0;O=U;U=d[W>>1]|0;d[W>>1]=wa}while((U&65535)<(O&65535));d[B+(G<<1)>>1]=wa;N=H;break a}while(0);V=G+-2|0;if(!(b[z+G>>0]|0)){xa=V;break}do if((V|0)>-1){if(!(b[x+V>>0]|0))break;if(b[z+L>>0]|0){d[B+(G<<1)>>1]=d[B+(V<<1)>>1]|0;N=H;break a}if(!(b[z+V>>0]|0)){U=d[w+(G<<1)>>1]|0;O=d[B+(V<<1)>>1]|0;W=U;while(1){R=d[q+((W&65535)<<1)>>1]|0;if((R&65535)<(W&65535))W=R;else break}if(U<<16>>16==O<<16>>16)ya=W;else{R=O;while(1){S=d[q+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(W&65535)>(R&65535)?R:W;P=O;do{Q=q+((P&65535)<<1)|0;ba=P;P=d[Q>>1]|0;d[Q>>1]=S}while((P&65535)<(ba&65535));ya=S}S=U;do{P=q+((S&65535)<<1)|0;O=S;S=d[P>>1]|0;d[P>>1]=ya}while((S&65535)<(O&65535));d[B+(G<<1)>>1]=ya;N=H;break a}do if(F){if(!(b[A+L>>0]|0))break;d[B+(G<<1)>>1]=d[B+(V<<1)>>1]|0;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;U=d[B+(V<<1)>>1]|0;O=S;while(1){P=d[q+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}if(S<<16>>16==U<<16>>16)za=O;else{P=U;while(1){W=d[q+((P&65535)<<1)>>1]|0;if((W&65535)<(P&65535))P=W;else break}W=(O&65535)>(P&65535)?P:O;R=U;do{ba=q+((R&65535)<<1)|0;Q=R;R=d[ba>>1]|0;d[ba>>1]=W}while((R&65535)<(Q&65535));za=W}W=S;do{R=q+((W&65535)<<1)|0;U=W;W=d[R>>1]|0;d[R>>1]=za}while((W&65535)<(U&65535));d[B+(G<<1)>>1]=za;N=H;break a}while(0);W=d[w+(G<<1)>>1]|0;S=d[B+(V<<1)>>1]|0;U=W;while(1){R=d[q+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}if(W<<16>>16==S<<16>>16)Aa=U;else{V=S;while(1){R=d[q+((V&65535)<<1)>>1]|0;if((R&65535)<(V&65535))V=R;else break}R=(U&65535)>(V&65535)?V:U;O=S;do{P=q+((O&65535)<<1)|0;Q=O;O=d[P>>1]|0;d[P>>1]=R}while((O&65535)<(Q&65535));Aa=R}R=W;do{O=q+((R&65535)<<1)|0;S=R;R=d[O>>1]|0;d[O>>1]=Aa}while((R&65535)<(S&65535));d[B+(G<<1)>>1]=Aa;N=H;break a}else xa=G+-2|0;while(0);d[B+(G<<1)>>1]=d[B+(xa<<1)>>1]|0;N=H;break a}while(0);do if(D){if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}R=G+2|0;do if(!((R|0)>=(k|0)|E)){if(!(b[z+R>>0]|0))break;if(!(b[z+G>>0]|0)){d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}while(0);W=d[w+(G<<1)>>1]|0;S=d[w+(R<<1)>>1]|0;O=W;while(1){U=d[q+((O&65535)<<1)>>1]|0;if((U&65535)<(O&65535))O=U;else break}if(W<<16>>16==S<<16>>16)Ba=O;else{U=S;while(1){V=d[q+((U&65535)<<1)>>1]|0;if((V&65535)<(U&65535))U=V;else break}V=(O&65535)>(U&65535)?U:O;Q=S;do{P=q+((Q&65535)<<1)|0;ba=Q;Q=d[P>>1]|0;d[P>>1]=V}while((Q&65535)<(ba&65535));Ba=V}V=W;do{Q=q+((V&65535)<<1)|0;S=V;V=d[Q>>1]|0;d[Q>>1]=Ba}while((V&65535)<(S&65535));d[B+(G<<1)>>1]=Ba;N=H;break a}while(0);if(!(b[z+G>>0]|0))break;d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}while(0);d[B+(G<<1)>>1]=H;R=H&65535;d[q+(R<<1)>>1]=H;N=R+1&65535;break}if(M){if(b[y+L>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}if(b[x+L>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}}d[B+(G<<1)>>1]=H;R=H&65535;d[q+(R<<1)>>1]=H;N=R+1&65535;break}do if(K){if(!(b[x+I>>0]|0)){if(!C)break;if(!(b[y+I>>0]|0))break;d[B+(G<<1)>>1]=H;R=H&65535;d[q+(R<<1)>>1]=H;N=R+1&65535;break a}if(D){if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}R=G+2|0;do if(!((R|0)>=(k|0)|E)){if(!(b[z+R>>0]|0))break;if(!(b[z+G>>0]|0)){d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[w+(R<<1)>>1]|0;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;W=d[w+(R<<1)>>1]|0;S=V;while(1){Q=d[q+((S&65535)<<1)>>1]|0;if((Q&65535)<(S&65535))S=Q;else break}if(V<<16>>16==W<<16>>16)Ca=S;else{Q=W;while(1){O=d[q+((Q&65535)<<1)>>1]|0;if((O&65535)<(Q&65535))Q=O;else break}O=(S&65535)>(Q&65535)?Q:S;U=W;do{ba=q+((U&65535)<<1)|0;P=U;U=d[ba>>1]|0;d[ba>>1]=O}while((U&65535)<(P&65535));Ca=O}O=V;do{U=q+((O&65535)<<1)|0;W=O;O=d[U>>1]|0;d[U>>1]=Ca}while((O&65535)<(W&65535));d[B+(G<<1)>>1]=Ca;N=H;break a}while(0);if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break a}}d[B+(G<<1)>>1]=H;R=H&65535;d[q+(R<<1)>>1]=H;N=R+1&65535;break a}while(0);d[B+(G<<1)>>1]=0;N=H}else{I=G+-1|0;K=(G|0)>0;if(K){if(b[x+I>>0]|0){L=G|1;M=(L|0)<(k|0);if(D&M?b[z+L>>0]|0:0){if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}do if(F){if(!(b[A+G>>0]|0))break;R=G+-2|0;if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}do if((R|0)>-1){if(!(b[z+R>>0]|0))break;if(b[A+I>>0]|0){d[B+(G<<1)>>1]=d[B+(R<<1)>>1]|0;N=H;break a}O=d[w+(G<<1)>>1]|0;V=d[B+(R<<1)>>1]|0;W=O;while(1){U=d[q+((W&65535)<<1)>>1]|0;if((U&65535)<(W&65535))W=U;else break}if(O<<16>>16==V<<16>>16)Da=W;else{U=V;while(1){S=d[q+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(W&65535)>(U&65535)?U:W;Q=V;do{P=q+((Q&65535)<<1)|0;ba=Q;Q=d[P>>1]|0;d[P>>1]=S}while((Q&65535)<(ba&65535));Da=S}S=O;do{Q=q+((S&65535)<<1)|0;V=S;S=d[Q>>1]|0;d[Q>>1]=Da}while((S&65535)<(V&65535));d[B+(G<<1)>>1]=Da;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;O=d[B+(R<<1)>>1]|0;V=S;while(1){Q=d[q+((V&65535)<<1)>>1]|0;if((Q&65535)<(V&65535))V=Q;else break}if(S<<16>>16==O<<16>>16)Ea=V;else{R=O;while(1){Q=d[q+((R&65535)<<1)>>1]|0;if((Q&65535)<(R&65535))R=Q;else break}Q=(V&65535)>(R&65535)?R:V;W=O;do{U=q+((W&65535)<<1)|0;ba=W;W=d[U>>1]|0;d[U>>1]=Q}while((W&65535)<(ba&65535));Ea=Q}Q=S;do{W=q+((Q&65535)<<1)|0;O=Q;Q=d[W>>1]|0;d[W>>1]=Ea}while((Q&65535)<(O&65535));d[B+(G<<1)>>1]=Ea;N=H;break a}while(0);Q=d[w+(G<<1)>>1]|0;S=d[B+(G+-2<<1)>>1]|0;O=Q;while(1){W=d[q+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}if(Q<<16>>16==S<<16>>16)Fa=O;else{W=S;while(1){V=d[q+((W&65535)<<1)>>1]|0;if((V&65535)<(W&65535))W=V;else break}V=(O&65535)>(W&65535)?W:O;R=S;do{ba=q+((R&65535)<<1)|0;U=R;R=d[ba>>1]|0;d[ba>>1]=V}while((R&65535)<(U&65535));Fa=V}V=Q;do{R=q+((V&65535)<<1)|0;S=V;V=d[R>>1]|0;d[R>>1]=Fa}while((V&65535)<(S&65535));d[B+(G<<1)>>1]=Fa;N=H;break}if(M?b[x+L>>0]|0:0){V=G+2|0;do if(D&(V|0)<(k|0)){if(!(b[z+V>>0]|0))break;do if(F){if(!(b[A+L>>0]|0))break;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break a}if(!(b[A+G>>0]|0)){Q=d[w+(V<<1)>>1]|0;S=d[B+(G+-2<<1)>>1]|0;R=Q;while(1){O=d[q+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(Q<<16>>16==S<<16>>16)Ga=R;else{O=S;while(1){W=d[q+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}W=(R&65535)>(O&65535)?O:R;U=S;do{ba=q+((U&65535)<<1)|0;P=U;U=d[ba>>1]|0;d[ba>>1]=W}while((U&65535)<(P&65535));Ga=W}W=Q;do{U=q+((W&65535)<<1)|0;S=W;W=d[U>>1]|0;d[U>>1]=Ga}while((W&65535)<(S&65535));d[B+(G<<1)>>1]=Ga;N=H;break a}W=G+-2|0;if(b[z+I>>0]|0){d[B+(G<<1)>>1]=d[B+(W<<1)>>1]|0;N=H;break a}do if((W|0)>-1){if(!(b[z+W>>0]|0))break;if(b[A+I>>0]|0){d[B+(G<<1)>>1]=d[B+(W<<1)>>1]|0;N=H;break a}Q=d[w+(V<<1)>>1]|0;S=d[B+(W<<1)>>1]|0;U=Q;while(1){R=d[q+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}if(Q<<16>>16==S<<16>>16)Ha=U;else{R=S;while(1){O=d[q+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}O=(U&65535)>(R&65535)?R:U;P=S;do{ba=q+((P&65535)<<1)|0;X=P;P=d[ba>>1]|0;d[ba>>1]=O}while((P&65535)<(X&65535));Ha=O}O=Q;do{P=q+((O&65535)<<1)|0;S=O;O=d[P>>1]|0;d[P>>1]=Ha}while((O&65535)<(S&65535));d[B+(G<<1)>>1]=Ha;N=H;break a}while(0);O=d[w+(V<<1)>>1]|0;Q=d[B+(W<<1)>>1]|0;S=O;while(1){P=d[q+((S&65535)<<1)>>1]|0;if((P&65535)<(S&65535))S=P;else break}if(O<<16>>16==Q<<16>>16)Ia=S;else{W=Q;while(1){P=d[q+((W&65535)<<1)>>1]|0;if((P&65535)<(W&65535))W=P;else break}P=(S&65535)>(W&65535)?W:S;U=Q;do{R=q+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=P}while((U&65535)<(X&65535));Ia=P}P=O;do{U=q+((P&65535)<<1)|0;Q=P;P=d[U>>1]|0;d[U>>1]=Ia}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=Ia;N=H;break a}while(0);P=d[w+(V<<1)>>1]|0;O=d[B+(G+-2<<1)>>1]|0;Q=P;while(1){U=d[q+((Q&65535)<<1)>>1]|0;if((U&65535)<(Q&65535))Q=U;else break}if(P<<16>>16==O<<16>>16)Ja=Q;else{U=O;while(1){S=d[q+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(Q&65535)>(U&65535)?U:Q;W=O;do{X=q+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=S}while((W&65535)<(R&65535));Ja=S}S=P;do{W=q+((S&65535)<<1)|0;O=S;S=d[W>>1]|0;d[W>>1]=Ja}while((S&65535)<(O&65535));d[B+(G<<1)>>1]=Ja;N=H;break a}while(0);d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}d[B+(G<<1)>>1]=d[B+(G+-2<<1)>>1]|0;N=H;break}if(C?b[y+I>>0]|0:0){V=G|1;L=(V|0)<(k|0);if(!(E|L^1)?b[z+V>>0]|0:0){M=G+-2|0;do if((M|0)>-1){if(!(b[x+M>>0]|0))break;if(b[z+I>>0]|0){S=d[B+(M<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=S;N=H;break a}do if(F){if(!(b[A+G>>0]|0))break;d[B+(G<<1)>>1]=S;N=H;break a}while(0);P=d[w+(G<<1)>>1]|0;O=P;while(1){W=d[q+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}if(P<<16>>16==S<<16>>16)Ka=O;else{W=S;while(1){Q=d[q+((W&65535)<<1)>>1]|0;if((Q&65535)<(W&65535))W=Q;else break}Q=(O&65535)>(W&65535)?W:O;U=S;do{R=q+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=Q}while((U&65535)<(X&65535));Ka=Q}Q=P;do{U=q+((Q&65535)<<1)|0;S=Q;Q=d[U>>1]|0;d[U>>1]=Ka}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=Ka;N=H;break a}if(!(b[z+M>>0]|0)){Q=d[w+(G<<1)>>1]|0;P=d[B+(M<<1)>>1]|0;S=Q;while(1){U=d[q+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}if(Q<<16>>16==P<<16>>16)La=S;else{U=P;while(1){O=d[q+((U&65535)<<1)>>1]|0;if((O&65535)<(U&65535))U=O;else break}O=(S&65535)>(U&65535)?U:S;W=P;do{X=q+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=O}while((W&65535)<(R&65535));La=O}O=Q;do{W=q+((O&65535)<<1)|0;P=O;O=d[W>>1]|0;d[W>>1]=La}while((O&65535)<(P&65535));d[B+(G<<1)>>1]=La;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;O=d[B+(M<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=O;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=O;N=H;break a}Q=d[w+(G<<1)>>1]|0;P=Q;while(1){W=d[q+((P&65535)<<1)>>1]|0;if((W&65535)<(P&65535))P=W;else break}if(Q<<16>>16==O<<16>>16)Ma=P;else{W=O;while(1){S=d[q+((W&65535)<<1)>>1]|0;if((S&65535)<(W&65535))W=S;else break}S=(P&65535)>(W&65535)?W:P;U=O;do{R=q+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=S}while((U&65535)<(X&65535));Ma=S}S=Q;do{U=q+((S&65535)<<1)|0;O=S;S=d[U>>1]|0;d[U>>1]=Ma}while((S&65535)<(O&65535));d[B+(G<<1)>>1]=Ma;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;Q=d[B+(M<<1)>>1]|0;O=S;while(1){U=d[q+((O&65535)<<1)>>1]|0;if((U&65535)<(O&65535))O=U;else break}if(S<<16>>16==Q<<16>>16)Na=O;else{U=Q;while(1){P=d[q+((U&65535)<<1)>>1]|0;if((P&65535)<(U&65535))U=P;else break}P=(O&65535)>(U&65535)?U:O;W=Q;do{X=q+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=P}while((W&65535)<(R&65535));Na=P}P=S;do{W=q+((P&65535)<<1)|0;Q=P;P=d[W>>1]|0;d[W>>1]=Na}while((P&65535)<(Q&65535));d[B+(G<<1)>>1]=Na;N=H;break a}while(0);if(b[z+G>>0]|0){P=d[w+(G<<1)>>1]|0;S=d[B+(M<<1)>>1]|0;Q=P;while(1){W=d[q+((Q&65535)<<1)>>1]|0;if((W&65535)<(Q&65535))Q=W;else break}if(P<<16>>16==S<<16>>16)Oa=Q;else{W=S;while(1){O=d[q+((W&65535)<<1)>>1]|0;if((O&65535)<(W&65535))W=O;else break}O=(Q&65535)>(W&65535)?W:Q;U=S;do{R=q+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=O}while((U&65535)<(X&65535));Oa=O}O=P;do{U=q+((O&65535)<<1)|0;S=O;O=d[U>>1]|0;d[U>>1]=Oa}while((O&65535)<(S&65535));d[B+(G<<1)>>1]=Oa;N=H;break}O=d[w+(G<<1)>>1]|0;if(!(b[z+I>>0]|0)){P=d[B+(M<<1)>>1]|0;S=O;while(1){U=d[q+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}if(O<<16>>16==P<<16>>16)Pa=S;else{U=P;while(1){Q=d[q+((U&65535)<<1)>>1]|0;if((Q&65535)<(U&65535))U=Q;else break}Q=(S&65535)>(U&65535)?U:S;W=P;do{X=q+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=Q}while((W&65535)<(R&65535));Pa=Q}Q=O;do{W=q+((Q&65535)<<1)|0;P=Q;Q=d[W>>1]|0;d[W>>1]=Pa}while((Q&65535)<(P&65535));d[B+(G<<1)>>1]=Pa;N=H;break}do if(F){if(!(b[A+G>>0]|0))break;Q=d[B+(M<<1)>>1]|0;P=O;while(1){W=d[q+((P&65535)<<1)>>1]|0;if((W&65535)<(P&65535))P=W;else break}if(O<<16>>16==Q<<16>>16)Qa=P;else{W=Q;while(1){S=d[q+((W&65535)<<1)>>1]|0;if((S&65535)<(W&65535))W=S;else break}S=(P&65535)>(W&65535)?W:P;U=Q;do{R=q+((U&65535)<<1)|0;X=U;U=d[R>>1]|0;d[R>>1]=S}while((U&65535)<(X&65535));Qa=S}S=O;do{U=q+((S&65535)<<1)|0;Q=S;S=d[U>>1]|0;d[U>>1]=Qa}while((S&65535)<(Q&65535));d[B+(G<<1)>>1]=Qa;N=H;break a}while(0);S=d[w+(M<<1)>>1]|0;Q=S;while(1){U=d[q+((Q&65535)<<1)>>1]|0;if((U&65535)<(Q&65535))Q=U;else break}if(S<<16>>16==O<<16>>16)Ra=Q;else{U=O;while(1){P=d[q+((U&65535)<<1)>>1]|0;if((P&65535)<(U&65535))U=P;else break}P=(Q&65535)>(U&65535)?U:Q;W=O;do{X=q+((W&65535)<<1)|0;R=W;W=d[X>>1]|0;d[X>>1]=P}while((W&65535)<(R&65535));Ra=P}P=S;do{W=q+((P&65535)<<1)|0;O=P;P=d[W>>1]|0;d[W>>1]=Ra}while((P&65535)<(O&65535));P=d[B+(M<<1)>>1]|0;S=Ra;while(1){O=d[q+((S&65535)<<1)>>1]|0;if((O&65535)<(S&65535))S=O;else break}if(Ra<<16>>16==P<<16>>16)Sa=S;else{M=P;while(1){O=d[q+((M&65535)<<1)>>1]|0;if((O&65535)<(M&65535))M=O;else break}O=(S&65535)>(M&65535)?M:S;W=P;do{Q=q+((W&65535)<<1)|0;U=W;W=d[Q>>1]|0;d[Q>>1]=O}while((W&65535)<(U&65535));Sa=O}O=Ra;do{W=q+((O&65535)<<1)|0;P=O;O=d[W>>1]|0;d[W>>1]=Sa}while((O&65535)<(P&65535));d[B+(G<<1)>>1]=Sa;N=H;break}if(L?b[x+V>>0]|0:0){O=G+2|0;do if(!((O|0)>=(k|0)|E)){if(!(b[z+O>>0]|0))break;P=G+-2|0;do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[z+I>>0]|0){do if(F){if(!(b[A+V>>0]|0))break;W=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=W;N=H;break a}S=d[w+(O<<1)>>1]|0;M=S;while(1){U=d[q+((M&65535)<<1)>>1]|0;if((U&65535)<(M&65535))M=U;else break}if(S<<16>>16==W<<16>>16)Ta=M;else{U=W;while(1){Q=d[q+((U&65535)<<1)>>1]|0;if((Q&65535)<(U&65535))U=Q;else break}Q=(M&65535)>(U&65535)?U:M;R=W;do{X=q+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=Q}while((R&65535)<(ba&65535));Ta=Q}Q=S;do{R=q+((Q&65535)<<1)|0;W=Q;Q=d[R>>1]|0;d[R>>1]=Ta}while((Q&65535)<(W&65535));d[B+(G<<1)>>1]=Ta;N=H;break a}while(0);Q=d[w+(O<<1)>>1]|0;S=d[B+(P<<1)>>1]|0;W=Q;while(1){R=d[q+((W&65535)<<1)>>1]|0;if((R&65535)<(W&65535))W=R;else break}if(Q<<16>>16==S<<16>>16)Ua=W;else{R=S;while(1){M=d[q+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(W&65535)>(R&65535)?R:W;U=S;do{ba=q+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=M}while((U&65535)<(X&65535));Ua=M}M=Q;do{U=q+((M&65535)<<1)|0;S=M;M=d[U>>1]|0;d[U>>1]=Ua}while((M&65535)<(S&65535));d[B+(G<<1)>>1]=Ua;N=H;break a}do if(F){if(!(b[A+V>>0]|0))break;if(!(b[z+P>>0]|0)){M=d[w+(O<<1)>>1]|0;Q=d[B+(P<<1)>>1]|0;S=M;while(1){U=d[q+((S&65535)<<1)>>1]|0;if((U&65535)<(S&65535))S=U;else break}if(M<<16>>16==Q<<16>>16)Va=S;else{U=Q;while(1){W=d[q+((U&65535)<<1)>>1]|0;if((W&65535)<(U&65535))U=W;else break}W=(S&65535)>(U&65535)?U:S;R=Q;do{X=q+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=W}while((R&65535)<(ba&65535));Va=W}W=M;do{R=q+((W&65535)<<1)|0;Q=W;W=d[R>>1]|0;d[R>>1]=Va}while((W&65535)<(Q&65535));d[B+(G<<1)>>1]=Va;N=H;break a}if(!(b[A+I>>0]|0)){W=d[w+(O<<1)>>1]|0;M=d[B+(P<<1)>>1]|0;Q=W;while(1){R=d[q+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}if(W<<16>>16==M<<16>>16)Wa=Q;else{R=M;while(1){S=d[q+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(Q&65535)>(R&65535)?R:Q;U=M;do{ba=q+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=S}while((U&65535)<(X&65535));Wa=S}S=W;do{U=q+((S&65535)<<1)|0;M=S;S=d[U>>1]|0;d[U>>1]=Wa}while((S&65535)<(M&65535));d[B+(G<<1)>>1]=Wa;N=H;break a}S=d[B+(P<<1)>>1]|0;if(b[z+G>>0]|0){d[B+(G<<1)>>1]=S;N=H;break a}if(b[A+G>>0]|0){d[B+(G<<1)>>1]=S;N=H;break a}W=d[w+(O<<1)>>1]|0;M=W;while(1){U=d[q+((M&65535)<<1)>>1]|0;if((U&65535)<(M&65535))M=U;else break}if(W<<16>>16==S<<16>>16)Xa=M;else{U=S;while(1){Q=d[q+((U&65535)<<1)>>1]|0;if((Q&65535)<(U&65535))U=Q;else break}Q=(M&65535)>(U&65535)?U:M;R=S;do{X=q+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=Q}while((R&65535)<(ba&65535));Xa=Q}Q=W;do{R=q+((Q&65535)<<1)|0;S=Q;Q=d[R>>1]|0;d[R>>1]=Xa}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=Xa;N=H;break a}while(0);if(!(b[z+G>>0]|0)){Q=d[w+(O<<1)>>1]|0;W=d[B+(P<<1)>>1]|0;S=Q;while(1){R=d[q+((S&65535)<<1)>>1]|0;if((R&65535)<(S&65535))S=R;else break}if(Q<<16>>16==W<<16>>16)Ya=S;else{R=W;while(1){M=d[q+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(S&65535)>(R&65535)?R:S;U=W;do{ba=q+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=M}while((U&65535)<(X&65535));Ya=M}M=Q;do{U=q+((M&65535)<<1)|0;W=M;M=d[U>>1]|0;d[U>>1]=Ya}while((M&65535)<(W&65535));d[B+(G<<1)>>1]=Ya;N=H;break a}if(!(b[z+P>>0]|0)){M=d[w+(G<<1)>>1]|0;Q=d[w+(O<<1)>>1]|0;W=M;while(1){U=d[q+((W&65535)<<1)>>1]|0;if((U&65535)<(W&65535))W=U;else break}if(M<<16>>16==Q<<16>>16)Za=W;else{U=Q;while(1){S=d[q+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(W&65535)>(U&65535)?U:W;R=Q;do{X=q+((R&65535)<<1)|0;ba=R;R=d[X>>1]|0;d[X>>1]=S}while((R&65535)<(ba&65535));Za=S}S=M;do{R=q+((S&65535)<<1)|0;Q=S;S=d[R>>1]|0;d[R>>1]=Za}while((S&65535)<(Q&65535));S=d[B+(P<<1)>>1]|0;M=Za;while(1){Q=d[q+((M&65535)<<1)>>1]|0;if((Q&65535)<(M&65535))M=Q;else break}if(Za<<16>>16==S<<16>>16)_a=M;else{Q=S;while(1){R=d[q+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}R=(M&65535)>(Q&65535)?Q:M;W=S;do{U=q+((W&65535)<<1)|0;ba=W;W=d[U>>1]|0;d[U>>1]=R}while((W&65535)<(ba&65535));_a=R}R=Za;do{W=q+((R&65535)<<1)|0;S=R;R=d[W>>1]|0;d[W>>1]=_a}while((R&65535)<(S&65535));d[B+(G<<1)>>1]=_a;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;R=d[w+(O<<1)>>1]|0;S=d[B+(P<<1)>>1]|0;W=R;while(1){M=d[q+((W&65535)<<1)>>1]|0;if((M&65535)<(W&65535))W=M;else break}if(R<<16>>16==S<<16>>16)$a=W;else{M=S;while(1){Q=d[q+((M&65535)<<1)>>1]|0;if((Q&65535)<(M&65535))M=Q;else break}Q=(W&65535)>(M&65535)?M:W;ba=S;do{U=q+((ba&65535)<<1)|0;X=ba;ba=d[U>>1]|0;d[U>>1]=Q}while((ba&65535)<(X&65535));$a=Q}Q=R;do{ba=q+((Q&65535)<<1)|0;S=Q;Q=d[ba>>1]|0;d[ba>>1]=$a}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=$a;N=H;break a}while(0);Q=d[w+(G<<1)>>1]|0;R=d[w+(O<<1)>>1]|0;S=Q;while(1){ba=d[q+((S&65535)<<1)>>1]|0;if((ba&65535)<(S&65535))S=ba;else break}if(Q<<16>>16==R<<16>>16)ab=S;else{ba=R;while(1){W=d[q+((ba&65535)<<1)>>1]|0;if((W&65535)<(ba&65535))ba=W;else break}W=(S&65535)>(ba&65535)?ba:S;M=R;do{X=q+((M&65535)<<1)|0;U=M;M=d[X>>1]|0;d[X>>1]=W}while((M&65535)<(U&65535));ab=W}W=Q;do{M=q+((W&65535)<<1)|0;R=W;W=d[M>>1]|0;d[M>>1]=ab}while((W&65535)<(R&65535));W=d[B+(P<<1)>>1]|0;Q=ab;while(1){R=d[q+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}if(ab<<16>>16==W<<16>>16)bb=Q;else{R=W;while(1){M=d[q+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(Q&65535)>(R&65535)?R:Q;S=W;do{ba=q+((S&65535)<<1)|0;U=S;S=d[ba>>1]|0;d[ba>>1]=M}while((S&65535)<(U&65535));bb=M}M=ab;do{S=q+((M&65535)<<1)|0;W=M;M=d[S>>1]|0;d[S>>1]=bb}while((M&65535)<(W&65535));d[B+(G<<1)>>1]=bb;N=H;break a}while(0);if(b[z+G>>0]|0){do if(F){if(!(b[A+V>>0]|0))break;M=d[w+(O<<1)>>1]|0;W=d[B+(P<<1)>>1]|0;S=M;while(1){Q=d[q+((S&65535)<<1)>>1]|0;if((Q&65535)<(S&65535))S=Q;else break}if(M<<16>>16==W<<16>>16)cb=S;else{Q=W;while(1){R=d[q+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}R=(S&65535)>(Q&65535)?Q:S;U=W;do{ba=q+((U&65535)<<1)|0;X=U;U=d[ba>>1]|0;d[ba>>1]=R}while((U&65535)<(X&65535));cb=R}R=M;do{U=q+((R&65535)<<1)|0;W=R;R=d[U>>1]|0;d[U>>1]=cb}while((R&65535)<(W&65535));d[B+(G<<1)>>1]=cb;N=H;break a}while(0);R=d[w+(G<<1)>>1]|0;M=d[w+(O<<1)>>1]|0;W=R;while(1){U=d[q+((W&65535)<<1)>>1]|0;if((U&65535)<(W&65535))W=U;else break}if(R<<16>>16==M<<16>>16)db=W;else{U=M;while(1){S=d[q+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(W&65535)>(U&65535)?U:W;Q=M;do{X=q+((Q&65535)<<1)|0;ba=Q;Q=d[X>>1]|0;d[X>>1]=S}while((Q&65535)<(ba&65535));db=S}S=R;do{Q=q+((S&65535)<<1)|0;M=S;S=d[Q>>1]|0;d[Q>>1]=db}while((S&65535)<(M&65535));S=d[B+(P<<1)>>1]|0;R=db;while(1){M=d[q+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}if(db<<16>>16==S<<16>>16)eb=R;else{M=S;while(1){Q=d[q+((M&65535)<<1)>>1]|0;if((Q&65535)<(M&65535))M=Q;else break}Q=(R&65535)>(M&65535)?M:R;W=S;do{U=q+((W&65535)<<1)|0;ba=W;W=d[U>>1]|0;d[U>>1]=Q}while((W&65535)<(ba&65535));eb=Q}Q=db;do{W=q+((Q&65535)<<1)|0;S=Q;Q=d[W>>1]|0;d[W>>1]=eb}while((Q&65535)<(S&65535));d[B+(G<<1)>>1]=eb;N=H;break a}if(!(b[z+I>>0]|0)){Q=d[w+(O<<1)>>1]|0;S=d[B+(P<<1)>>1]|0;W=Q;while(1){R=d[q+((W&65535)<<1)>>1]|0;if((R&65535)<(W&65535))W=R;else break}if(Q<<16>>16==S<<16>>16)fb=W;else{R=S;while(1){M=d[q+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(W&65535)>(R&65535)?R:W;ba=S;do{U=q+((ba&65535)<<1)|0;X=ba;ba=d[U>>1]|0;d[U>>1]=M}while((ba&65535)<(X&65535));fb=M}M=Q;do{ba=q+((M&65535)<<1)|0;S=M;M=d[ba>>1]|0;d[ba>>1]=fb}while((M&65535)<(S&65535));d[B+(G<<1)>>1]=fb;N=H;break a}do if(F){if(!(b[A+V>>0]|0))break;M=d[w+(O<<1)>>1]|0;if(b[A+G>>0]|0){Q=d[B+(P<<1)>>1]|0;S=M;while(1){ba=d[q+((S&65535)<<1)>>1]|0;if((ba&65535)<(S&65535))S=ba;else break}if(M<<16>>16==Q<<16>>16)gb=S;else{ba=Q;while(1){W=d[q+((ba&65535)<<1)>>1]|0;if((W&65535)<(ba&65535))ba=W;else break}W=(S&65535)>(ba&65535)?ba:S;R=Q;do{X=q+((R&65535)<<1)|0;U=R;R=d[X>>1]|0;d[X>>1]=W}while((R&65535)<(U&65535));gb=W}W=M;do{R=q+((W&65535)<<1)|0;Q=W;W=d[R>>1]|0;d[R>>1]=gb}while((W&65535)<(Q&65535));d[B+(G<<1)>>1]=gb;N=H;break a}W=d[w+(P<<1)>>1]|0;Q=W;while(1){R=d[q+((Q&65535)<<1)>>1]|0;if((R&65535)<(Q&65535))Q=R;else break}if(W<<16>>16==M<<16>>16)hb=Q;else{R=M;while(1){S=d[q+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(Q&65535)>(R&65535)?R:Q;ba=M;do{U=q+((ba&65535)<<1)|0;X=ba;ba=d[U>>1]|0;d[U>>1]=S}while((ba&65535)<(X&65535));hb=S}S=W;do{ba=q+((S&65535)<<1)|0;M=S;S=d[ba>>1]|0;d[ba>>1]=hb}while((S&65535)<(M&65535));S=d[B+(P<<1)>>1]|0;W=hb;while(1){M=d[q+((W&65535)<<1)>>1]|0;if((M&65535)<(W&65535))W=M;else break}if(hb<<16>>16==S<<16>>16)ib=W;else{M=S;while(1){ba=d[q+((M&65535)<<1)>>1]|0;if((ba&65535)<(M&65535))M=ba;else break}ba=(W&65535)>(M&65535)?M:W;Q=S;do{R=q+((Q&65535)<<1)|0;X=Q;Q=d[R>>1]|0;d[R>>1]=ba}while((Q&65535)<(X&65535));ib=ba}ba=hb;do{Q=q+((ba&65535)<<1)|0;S=ba;ba=d[Q>>1]|0;d[Q>>1]=ib}while((ba&65535)<(S&65535));d[B+(G<<1)>>1]=ib;N=H;break a}while(0);ba=d[w+(P<<1)>>1]|0;S=d[w+(O<<1)>>1]|0;Q=ba;while(1){W=d[q+((Q&65535)<<1)>>1]|0;if((W&65535)<(Q&65535))Q=W;else break}if(ba<<16>>16==S<<16>>16)jb=Q;else{W=S;while(1){M=d[q+((W&65535)<<1)>>1]|0;if((M&65535)<(W&65535))W=M;else break}M=(Q&65535)>(W&65535)?W:Q;X=S;do{R=q+((X&65535)<<1)|0;U=X;X=d[R>>1]|0;d[R>>1]=M}while((X&65535)<(U&65535));jb=M}M=ba;do{X=q+((M&65535)<<1)|0;S=M;M=d[X>>1]|0;d[X>>1]=jb}while((M&65535)<(S&65535));M=d[B+(P<<1)>>1]|0;ba=jb;while(1){S=d[q+((ba&65535)<<1)>>1]|0;if((S&65535)<(ba&65535))ba=S;else break}if(jb<<16>>16==M<<16>>16)kb=ba;else{P=M;while(1){S=d[q+((P&65535)<<1)>>1]|0;if((S&65535)<(P&65535))P=S;else break}S=(ba&65535)>(P&65535)?P:ba;X=M;do{Q=q+((X&65535)<<1)|0;W=X;X=d[Q>>1]|0;d[Q>>1]=S}while((X&65535)<(W&65535));kb=S}S=jb;do{X=q+((S&65535)<<1)|0;M=S;S=d[X>>1]|0;d[X>>1]=kb}while((S&65535)<(M&65535));d[B+(G<<1)>>1]=kb;N=H;break a}while(0);do if(D){O=G+-2|0;if(b[z+I>>0]|0){V=d[B+(O<<1)>>1]|0;do if((O|0)>-1){if(!(b[x+O>>0]|0))break;d[B+(G<<1)>>1]=V;N=H;break a}while(0);L=d[w+(O<<1)>>1]|0;S=L;while(1){M=d[q+((S&65535)<<1)>>1]|0;if((M&65535)<(S&65535))S=M;else break}if(L<<16>>16==V<<16>>16)lb=S;else{M=V;while(1){X=d[q+((M&65535)<<1)>>1]|0;if((X&65535)<(M&65535))M=X;else break}X=(S&65535)>(M&65535)?M:S;ba=V;do{P=q+((ba&65535)<<1)|0;W=ba;ba=d[P>>1]|0;d[P>>1]=X}while((ba&65535)<(W&65535));lb=X}X=L;do{ba=q+((X&65535)<<1)|0;V=X;X=d[ba>>1]|0;d[ba>>1]=lb}while((X&65535)<(V&65535));d[B+(G<<1)>>1]=lb;N=H;break a}if(!(b[z+G>>0]|0)){mb=O;break}do if((O|0)>-1){if(!(b[x+O>>0]|0))break;if(!(b[z+O>>0]|0)){X=d[w+(G<<1)>>1]|0;L=d[B+(O<<1)>>1]|0;V=X;while(1){ba=d[q+((V&65535)<<1)>>1]|0;if((ba&65535)<(V&65535))V=ba;else break}if(X<<16>>16==L<<16>>16)nb=V;else{ba=L;while(1){S=d[q+((ba&65535)<<1)>>1]|0;if((S&65535)<(ba&65535))ba=S;else break}S=(V&65535)>(ba&65535)?ba:V;M=L;do{W=q+((M&65535)<<1)|0;P=M;M=d[W>>1]|0;d[W>>1]=S}while((M&65535)<(P&65535));nb=S}S=X;do{M=q+((S&65535)<<1)|0;L=S;S=d[M>>1]|0;d[M>>1]=nb}while((S&65535)<(L&65535));d[B+(G<<1)>>1]=nb;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[B+(O<<1)>>1]|0;N=H;break a}while(0);S=d[w+(G<<1)>>1]|0;X=d[B+(O<<1)>>1]|0;L=S;while(1){M=d[q+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}if(S<<16>>16==X<<16>>16)ob=L;else{M=X;while(1){V=d[q+((M&65535)<<1)>>1]|0;if((V&65535)<(M&65535))M=V;else break}V=(L&65535)>(M&65535)?M:L;ba=X;do{P=q+((ba&65535)<<1)|0;W=ba;ba=d[P>>1]|0;d[P>>1]=V}while((ba&65535)<(W&65535));ob=V}V=S;do{ba=q+((V&65535)<<1)|0;X=V;V=d[ba>>1]|0;d[ba>>1]=ob}while((V&65535)<(X&65535));d[B+(G<<1)>>1]=ob;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;S=d[B+(O<<1)>>1]|0;X=V;while(1){ba=d[q+((X&65535)<<1)>>1]|0;if((ba&65535)<(X&65535))X=ba;else break}if(V<<16>>16==S<<16>>16)pb=X;else{O=S;while(1){ba=d[q+((O&65535)<<1)>>1]|0;if((ba&65535)<(O&65535))O=ba;else break}ba=(X&65535)>(O&65535)?O:X;L=S;do{M=q+((L&65535)<<1)|0;W=L;L=d[M>>1]|0;d[M>>1]=ba}while((L&65535)<(W&65535));pb=ba}ba=V;do{L=q+((ba&65535)<<1)|0;S=ba;ba=d[L>>1]|0;d[L>>1]=pb}while((ba&65535)<(S&65535));d[B+(G<<1)>>1]=pb;N=H;break a}else mb=G+-2|0;while(0);d[B+(G<<1)>>1]=d[B+(mb<<1)>>1]|0;N=H;break}do if(D){ba=G+-2|0;if(b[z+I>>0]|0){V=d[B+(ba<<1)>>1]|0;do if((ba|0)>-1){if(!(b[x+ba>>0]|0))break;d[B+(G<<1)>>1]=V;N=H;break a}while(0);S=d[w+(ba<<1)>>1]|0;L=S;while(1){X=d[q+((L&65535)<<1)>>1]|0;if((X&65535)<(L&65535))L=X;else break}if(S<<16>>16==V<<16>>16)qb=L;else{X=V;while(1){O=d[q+((X&65535)<<1)>>1]|0;if((O&65535)<(X&65535))X=O;else break}O=(L&65535)>(X&65535)?X:L;W=V;do{M=q+((W&65535)<<1)|0;P=W;W=d[M>>1]|0;d[M>>1]=O}while((W&65535)<(P&65535));qb=O}O=S;do{W=q+((O&65535)<<1)|0;V=O;O=d[W>>1]|0;d[W>>1]=qb}while((O&65535)<(V&65535));d[B+(G<<1)>>1]=qb;N=H;break a}if(!(b[z+G>>0]|0)){rb=ba;break}do if((ba|0)>-1){if(!(b[x+ba>>0]|0))break;if(!(b[z+ba>>0]|0)){O=d[w+(G<<1)>>1]|0;S=d[B+(ba<<1)>>1]|0;V=O;while(1){W=d[q+((V&65535)<<1)>>1]|0;if((W&65535)<(V&65535))V=W;else break}if(O<<16>>16==S<<16>>16)sb=V;else{W=S;while(1){L=d[q+((W&65535)<<1)>>1]|0;if((L&65535)<(W&65535))W=L;else break}L=(V&65535)>(W&65535)?W:V;X=S;do{P=q+((X&65535)<<1)|0;M=X;X=d[P>>1]|0;d[P>>1]=L}while((X&65535)<(M&65535));sb=L}L=O;do{X=q+((L&65535)<<1)|0;S=L;L=d[X>>1]|0;d[X>>1]=sb}while((L&65535)<(S&65535));d[B+(G<<1)>>1]=sb;N=H;break a}do if(F){if(!(b[A+I>>0]|0))break;d[B+(G<<1)>>1]=d[B+(ba<<1)>>1]|0;N=H;break a}while(0);L=d[w+(G<<1)>>1]|0;O=d[B+(ba<<1)>>1]|0;S=L;while(1){X=d[q+((S&65535)<<1)>>1]|0;if((X&65535)<(S&65535))S=X;else break}if(L<<16>>16==O<<16>>16)tb=S;else{X=O;while(1){V=d[q+((X&65535)<<1)>>1]|0;if((V&65535)<(X&65535))X=V;else break}V=(S&65535)>(X&65535)?X:S;W=O;do{M=q+((W&65535)<<1)|0;P=W;W=d[M>>1]|0;d[M>>1]=V}while((W&65535)<(P&65535));tb=V}V=L;do{W=q+((V&65535)<<1)|0;O=V;V=d[W>>1]|0;d[W>>1]=tb}while((V&65535)<(O&65535));d[B+(G<<1)>>1]=tb;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;L=d[B+(ba<<1)>>1]|0;O=V;while(1){W=d[q+((O&65535)<<1)>>1]|0;if((W&65535)<(O&65535))O=W;else break}if(V<<16>>16==L<<16>>16)ub=O;else{ba=L;while(1){W=d[q+((ba&65535)<<1)>>1]|0;if((W&65535)<(ba&65535))ba=W;else break}W=(O&65535)>(ba&65535)?ba:O;S=L;do{X=q+((S&65535)<<1)|0;P=S;S=d[X>>1]|0;d[X>>1]=W}while((S&65535)<(P&65535));ub=W}W=V;do{S=q+((W&65535)<<1)|0;L=W;W=d[S>>1]|0;d[S>>1]=ub}while((W&65535)<(L&65535));d[B+(G<<1)>>1]=ub;N=H;break a}else rb=G+-2|0;while(0);d[B+(G<<1)>>1]=d[B+(rb<<1)>>1]|0;N=H;break}}W=G|1;V=(W|0)<(k|0);if(!(E|V^1)?b[z+W>>0]|0:0){if(b[z+G>>0]|0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}if(K?b[z+I>>0]|0:0){L=d[w+(G<<1)>>1]|0;do if(F){if(!(b[A+G>>0]|0))break;d[B+(G<<1)>>1]=L;N=H;break a}while(0);S=d[w+(G+-2<<1)>>1]|0;O=S;while(1){ba=d[q+((O&65535)<<1)>>1]|0;if((ba&65535)<(O&65535))O=ba;else break}if(S<<16>>16==L<<16>>16)vb=O;else{ba=L;while(1){P=d[q+((ba&65535)<<1)>>1]|0;if((P&65535)<(ba&65535))ba=P;else break}P=(O&65535)>(ba&65535)?ba:O;X=L;do{M=q+((X&65535)<<1)|0;Q=X;X=d[M>>1]|0;d[M>>1]=P}while((X&65535)<(Q&65535));vb=P}P=S;do{X=q+((P&65535)<<1)|0;L=P;P=d[X>>1]|0;d[X>>1]=vb}while((P&65535)<(L&65535));d[B+(G<<1)>>1]=vb;N=H;break}d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}if(V?b[x+W>>0]|0:0){P=G+2|0;if(!((P|0)>=(k|0)|E)?b[z+P>>0]|0:0){if(b[z+G>>0]|0){do if(F){if(!(b[A+W>>0]|0))break;d[B+(G<<1)>>1]=d[w+(P<<1)>>1]|0;N=H;break a}while(0);V=d[w+(G<<1)>>1]|0;S=d[w+(P<<1)>>1]|0;L=V;while(1){X=d[q+((L&65535)<<1)>>1]|0;if((X&65535)<(L&65535))L=X;else break}if(V<<16>>16==S<<16>>16)wb=L;else{X=S;while(1){O=d[q+((X&65535)<<1)>>1]|0;if((O&65535)<(X&65535))X=O;else break}O=(L&65535)>(X&65535)?X:L;ba=S;do{Q=q+((ba&65535)<<1)|0;M=ba;ba=d[Q>>1]|0;d[Q>>1]=O}while((ba&65535)<(M&65535));wb=O}O=V;do{ba=q+((O&65535)<<1)|0;S=O;O=d[ba>>1]|0;d[ba>>1]=wb}while((O&65535)<(S&65535));d[B+(G<<1)>>1]=wb;N=H;break}do if(K){if(!(b[z+I>>0]|0))break;do if(F){if(!(b[A+W>>0]|0))break;O=d[w+(P<<1)>>1]|0;if(b[A+G>>0]|0){d[B+(G<<1)>>1]=O;N=H;break a}V=d[w+(G+-2<<1)>>1]|0;S=V;while(1){ba=d[q+((S&65535)<<1)>>1]|0;if((ba&65535)<(S&65535))S=ba;else break}if(V<<16>>16==O<<16>>16)xb=S;else{ba=O;while(1){L=d[q+((ba&65535)<<1)>>1]|0;if((L&65535)<(ba&65535))ba=L;else break}L=(S&65535)>(ba&65535)?ba:S;X=O;do{M=q+((X&65535)<<1)|0;Q=X;X=d[M>>1]|0;d[M>>1]=L}while((X&65535)<(Q&65535));xb=L}L=V;do{X=q+((L&65535)<<1)|0;O=L;L=d[X>>1]|0;d[X>>1]=xb}while((L&65535)<(O&65535));d[B+(G<<1)>>1]=xb;N=H;break a}while(0);L=d[w+(G+-2<<1)>>1]|0;V=d[w+(P<<1)>>1]|0;O=L;while(1){X=d[q+((O&65535)<<1)>>1]|0;if((X&65535)<(O&65535))O=X;else break}if(L<<16>>16==V<<16>>16)yb=O;else{X=V;while(1){S=d[q+((X&65535)<<1)>>1]|0;if((S&65535)<(X&65535))X=S;else break}S=(O&65535)>(X&65535)?X:O;ba=V;do{Q=q+((ba&65535)<<1)|0;M=ba;ba=d[Q>>1]|0;d[Q>>1]=S}while((ba&65535)<(M&65535));yb=S}S=L;do{ba=q+((S&65535)<<1)|0;V=S;S=d[ba>>1]|0;d[ba>>1]=yb}while((S&65535)<(V&65535));d[B+(G<<1)>>1]=yb;N=H;break a}while(0);d[B+(G<<1)>>1]=d[w+(P<<1)>>1]|0;N=H;break}if(D?b[z+G>>0]|0:0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}do if(!(E|K^1)){if(!(b[z+I>>0]|0))break;d[B+(G<<1)>>1]=d[w+(G+-2<<1)>>1]|0;N=H;break a}while(0);d[B+(G<<1)>>1]=H;P=H&65535;d[q+(P<<1)>>1]=H;N=P+1&65535;break}if(D?b[z+G>>0]|0:0){d[B+(G<<1)>>1]=d[w+(G<<1)>>1]|0;N=H;break}if(!(E|K^1)?b[z+I>>0]|0:0){d[B+(G<<1)>>1]=d[w+(G+-2<<1)>>1]|0;N=H;break}d[B+(G<<1)>>1]=H;P=H&65535;d[q+(P<<1)>>1]=H;N=P+1&65535}while(0);G=G+2|0;if((G|0)>=(k|0)){zb=N;break}else H=N}}else zb=t;v=v+2|0;if((v|0)>=(i|0))break;else t=zb}if((zb&65535)>1){t=zb&65535;zb=1;i=1;while(1){v=q+(i<<1)|0;N=j[v>>1]|0;if(N>>>0<i>>>0){d[v>>1]=d[q+(N<<1)>>1]|0;Ab=zb}else{d[v>>1]=zb;Ab=(zb&65535)+1&65535}i=i+1|0;if((i|0)==(t|0)){Bb=Ab;break}else zb=Ab}}else Bb=1}else Bb=1;l4(h,Bb&65535);Ab=f[l>>2]|0;zb=f[r>>2]|0;t=(zb&1|0)!=0;i=(Ab|0)>0;b:do if(!(Ab&1)){if(!t){if(!i)break;v=c+16|0;N=c+44|0;k=e+16|0;yb=e+44|0;xb=h+20|0;wb=h+120|0;vb=h+48|0;rb=0;ub=zb;tb=Ab;while(1){sb=f[f[N>>2]>>2]|0;qb=(f[v>>2]|0)+(Y(sb,rb)|0)|0;mb=qb+sb|0;sb=f[f[yb>>2]>>2]|0;pb=(f[k>>2]|0)+(Y(sb,rb)|0)|0;ob=pb+sb|0;if((ub|0)>0){sb=((rb|0)<0)<<31>>31;nb=rb|1;lb=((nb|0)<0)<<31>>31;kb=0;do{jb=pb+(kb<<1)|0;ib=d[jb>>1]|0;do if(ib<<16>>16){hb=d[q+((ib&65535)<<1)>>1]|0;if(!(b[qb+kb>>0]|0)){d[jb>>1]=0;gb=f[xb>>2]|0;fb=f[gb>>2]|0;f[gb>>2]=(fb|0)>(kb|0)?kb:fb;fb=gb+8|0;eb=f[fb>>2]|0;f[fb>>2]=(eb|0)<(kb|0)?kb:eb;eb=gb+4|0;fb=f[eb>>2]|0;f[eb>>2]=(fb|0)>(rb|0)?rb:fb;fb=gb+12|0;eb=f[fb>>2]|0;f[fb>>2]=(eb|0)<(rb|0)?rb:eb;eb=gb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=f[wb>>2]|0;fb=eb;db=Kac(f[fb>>2]|0,f[fb+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;fb=eb;f[fb>>2]=db;f[fb+4>>2]=J;Cb=eb+8|0;Db=gb;Eb=eb}else{d[jb>>1]=hb;eb=hb&65535;gb=f[xb>>2]|0;fb=gb+(Y(f[f[vb>>2]>>2]|0,eb)|0)|0;db=f[fb>>2]|0;f[fb>>2]=(db|0)>(kb|0)?kb:db;db=fb+8|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(kb|0)?kb:cb;cb=fb+4|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)>(rb|0)?rb:db;db=fb+12|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(rb|0)?rb:cb;cb=fb+16|0;f[cb>>2]=(f[cb>>2]|0)+1;cb=f[wb>>2]|0;fb=cb+(eb<<4)|0;db=fb;bb=Kac(f[db>>2]|0,f[db+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;db=fb;f[db>>2]=bb;f[db+4>>2]=J;Cb=cb+(eb<<4)+8|0;Db=gb;Eb=cb}cb=Cb;gb=Kac(f[cb>>2]|0,f[cb+4>>2]|0,rb|0,sb|0)|0;cb=Cb;f[cb>>2]=gb;f[cb+4>>2]=J;cb=kb|1;gb=pb+(cb<<1)|0;if(!(b[qb+cb>>0]|0)){d[gb>>1]=0;Fb=0;Gb=Db}else{d[gb>>1]=hb;gb=hb&65535;Fb=gb;Gb=Db+(Y(f[f[vb>>2]>>2]|0,gb)|0)|0}gb=f[Gb>>2]|0;f[Gb>>2]=(gb|0)>(cb|0)?cb:gb;gb=Gb+8|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)<(cb|0)?cb:eb;eb=Gb+4|0;gb=f[eb>>2]|0;f[eb>>2]=(gb|0)>(rb|0)?rb:gb;gb=Gb+12|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)<(rb|0)?rb:eb;eb=Gb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Eb+(Fb<<4)|0;gb=eb;db=Kac(f[gb>>2]|0,f[gb+4>>2]|0,cb|0,((cb|0)<0)<<31>>31|0)|0;gb=eb;f[gb>>2]=db;f[gb+4>>2]=J;gb=Eb+(Fb<<4)+8|0;db=gb;eb=Kac(f[db>>2]|0,f[db+4>>2]|0,rb|0,sb|0)|0;db=gb;f[db>>2]=eb;f[db+4>>2]=J;db=ob+(kb<<1)|0;if(!(b[mb+kb>>0]|0)){d[db>>1]=0;Hb=0;Ib=Db}else{d[db>>1]=hb;db=hb&65535;Hb=db;Ib=Db+(Y(f[f[vb>>2]>>2]|0,db)|0)|0}db=f[Ib>>2]|0;f[Ib>>2]=(db|0)>(kb|0)?kb:db;db=Ib+8|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(kb|0)?kb:eb;eb=Ib+4|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(nb|0)?nb:db;db=Ib+12|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(nb|0)?nb:eb;eb=Ib+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Eb+(Hb<<4)|0;db=eb;gb=Kac(f[db>>2]|0,f[db+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;db=eb;f[db>>2]=gb;f[db+4>>2]=J;db=Eb+(Hb<<4)+8|0;gb=db;eb=Kac(f[gb>>2]|0,f[gb+4>>2]|0,nb|0,lb|0)|0;gb=db;f[gb>>2]=eb;f[gb+4>>2]=J;gb=ob+(cb<<1)|0;if(!(b[mb+cb>>0]|0)){d[gb>>1]=0;eb=f[Db>>2]|0;f[Db>>2]=(eb|0)>(cb|0)?cb:eb;eb=Db+8|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)<(cb|0)?cb:db;db=Db+4|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)>(nb|0)?nb:eb;eb=Db+12|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)<(nb|0)?nb:db;db=Db+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Eb;eb=Kac(f[db>>2]|0,f[db+4>>2]|0,cb|0,((cb|0)<0)<<31>>31|0)|0;db=Eb;f[db>>2]=eb;f[db+4>>2]=J;Jb=Eb+8|0;break}else{d[gb>>1]=hb;gb=hb&65535;hb=Db+(Y(f[f[vb>>2]>>2]|0,gb)|0)|0;db=f[hb>>2]|0;f[hb>>2]=(db|0)>(cb|0)?cb:db;db=hb+8|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(cb|0)?cb:eb;eb=hb+4|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(nb|0)?nb:db;db=hb+12|0;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(nb|0)?nb:eb;eb=hb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Eb+(gb<<4)|0;hb=eb;db=Kac(f[hb>>2]|0,f[hb+4>>2]|0,cb|0,((cb|0)<0)<<31>>31|0)|0;cb=eb;f[cb>>2]=db;f[cb+4>>2]=J;Jb=Eb+(gb<<4)+8|0;break}}else{d[jb>>1]=0;gb=kb|1;d[pb+(gb<<1)>>1]=0;d[ob+(kb<<1)>>1]=0;d[ob+(gb<<1)>>1]=0;cb=f[xb>>2]|0;db=f[cb>>2]|0;eb=(db|0)>(kb|0)?kb:db;db=cb+8|0;hb=f[db>>2]|0;bb=(hb|0)<(kb|0)?kb:hb;hb=cb+4|0;fb=f[hb>>2]|0;ab=(fb|0)>(rb|0)?rb:fb;fb=cb+12|0;$a=f[fb>>2]|0;_a=($a|0)<(rb|0)?rb:$a;$a=cb+16|0;Za=f[$a>>2]|0;Ya=f[wb>>2]|0;Xa=((kb|0)<0)<<31>>31;Wa=Ya;Va=Kac(f[Wa>>2]|0,f[Wa+4>>2]|0,kb|0,Xa|0)|0;Wa=J;Ua=Ya+8|0;Ta=Ua;Sa=Kac(f[Ta>>2]|0,f[Ta+4>>2]|0,rb|0,sb|0)|0;Ta=J;Ra=(eb|0)>(gb|0)?gb:eb;eb=((gb|0)<0)<<31>>31;Qa=Kac(Va|0,Wa|0,gb|0,eb|0)|0;Wa=J;Va=Kac(Sa|0,Ta|0,rb|0,sb|0)|0;Ta=J;Sa=Kac(Qa|0,Wa|0,kb|0,Xa|0)|0;Xa=J;Wa=Kac(Va|0,Ta|0,nb|0,lb|0)|0;Ta=Ua;f[Ta>>2]=Wa;f[Ta+4>>2]=J;f[cb>>2]=(Ra|0)>(kb|0)?kb:Ra;f[db>>2]=(bb|0)<(gb|0)?gb:bb;f[hb>>2]=(ab|0)>(nb|0)?nb:ab;f[fb>>2]=(_a|0)<(nb|0)?nb:_a;f[$a>>2]=Za+4;Za=Kac(Sa|0,Xa|0,gb|0,eb|0)|0;eb=Ya;f[eb>>2]=Za;f[eb+4>>2]=J;Jb=Ua}while(0);jb=Jb;ib=Kac(f[jb>>2]|0,f[jb+4>>2]|0,nb|0,lb|0)|0;jb=Jb;f[jb>>2]=ib;f[jb+4>>2]=J;kb=kb+2|0;Kb=f[r>>2]|0}while((kb|0)<(Kb|0));Lb=f[l>>2]|0;Mb=Kb}else{Lb=tb;Mb=ub}rb=rb+2|0;if((rb|0)>=(Lb|0))break b;else{ub=Mb;tb=Lb}}}if(i){tb=h+20|0;ub=h+120|0;rb=h+48|0;wb=f[c+16>>2]|0;xb=f[c+44>>2]|0;vb=f[e+16>>2]|0;k=f[e+44>>2]|0;yb=0;v=zb;N=Ab;while(1){kb=f[xb>>2]|0;lb=wb+(Y(kb,yb)|0)|0;nb=lb+kb|0;kb=f[k>>2]|0;sb=vb+(Y(kb,yb)|0)|0;ob=sb+kb|0;if((v|0)>0){kb=((yb|0)<0)<<31>>31;pb=yb|1;mb=((pb|0)<0)<<31>>31;qb=0;do{jb=sb+(qb<<1)|0;ib=d[jb>>1]|0;do if(!(ib<<16>>16)){d[jb>>1]=0;d[ob+(qb<<1)>>1]=0;I=f[tb>>2]|0;K=f[I>>2]|0;Ua=(K|0)>(qb|0)?qb:K;K=I+8|0;eb=f[K>>2]|0;Za=(eb|0)<(qb|0)?qb:eb;eb=I+4|0;Ya=f[eb>>2]|0;gb=(Ya|0)>(yb|0)?yb:Ya;Ya=I+12|0;Xa=f[Ya>>2]|0;Sa=(Xa|0)<(yb|0)?yb:Xa;Xa=I+16|0;$a=f[Xa>>2]|0;_a=f[ub>>2]|0;fb=((qb|0)<0)<<31>>31;ab=_a;hb=Kac(f[ab>>2]|0,f[ab+4>>2]|0,qb|0,fb|0)|0;ab=J;bb=_a+8|0;db=bb;Ra=Kac(f[db>>2]|0,f[db+4>>2]|0,yb|0,kb|0)|0;db=J;f[I>>2]=Ua;f[K>>2]=Za;cb=(gb|0)>(pb|0)?pb:gb;f[eb>>2]=cb;gb=(Sa|0)<(pb|0)?pb:Sa;f[Ya>>2]=gb;f[Xa>>2]=$a+2;Sa=Kac(hb|0,ab|0,qb|0,fb|0)|0;fb=J;ab=_a;f[ab>>2]=Sa;f[ab+4>>2]=fb;ab=Kac(Ra|0,db|0,pb|0,mb|0)|0;db=J;Ra=bb;f[Ra>>2]=ab;f[Ra+4>>2]=db;Ra=qb|1;if((Ra|0)<(f[r>>2]|0)){d[sb+(Ra<<1)>>1]=0;d[ob+(Ra<<1)>>1]=0;hb=((Ra|0)<0)<<31>>31;Ta=Kac(Sa|0,fb|0,Ra|0,hb|0)|0;fb=J;Sa=Kac(ab|0,db|0,yb|0,kb|0)|0;db=J;f[I>>2]=(Ua|0)>(Ra|0)?Ra:Ua;f[K>>2]=(Za|0)<(Ra|0)?Ra:Za;f[eb>>2]=(cb|0)>(yb|0)?yb:cb;f[Ya>>2]=gb;f[Xa>>2]=$a+4;$a=Kac(Ta|0,fb|0,Ra|0,hb|0)|0;hb=_a;f[hb>>2]=$a;f[hb+4>>2]=J;hb=Kac(Sa|0,db|0,pb|0,mb|0)|0;db=bb;f[db>>2]=hb;f[db+4>>2]=J}}else{db=d[q+((ib&65535)<<1)>>1]|0;if(!(b[lb+qb>>0]|0)){d[jb>>1]=0;hb=f[tb>>2]|0;bb=f[hb>>2]|0;f[hb>>2]=(bb|0)>(qb|0)?qb:bb;bb=hb+8|0;Sa=f[bb>>2]|0;f[bb>>2]=(Sa|0)<(qb|0)?qb:Sa;Sa=hb+4|0;bb=f[Sa>>2]|0;f[Sa>>2]=(bb|0)>(yb|0)?yb:bb;bb=hb+12|0;Sa=f[bb>>2]|0;f[bb>>2]=(Sa|0)<(yb|0)?yb:Sa;Sa=hb+16|0;f[Sa>>2]=(f[Sa>>2]|0)+1;Sa=f[ub>>2]|0;bb=Sa;$a=Kac(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,((qb|0)<0)<<31>>31|0)|0;bb=Sa;f[bb>>2]=$a;f[bb+4>>2]=J;Nb=Sa+8|0;Ob=hb;Pb=Sa}else{d[jb>>1]=db;Sa=db&65535;hb=f[tb>>2]|0;bb=hb+(Y(f[f[rb>>2]>>2]|0,Sa)|0)|0;$a=f[bb>>2]|0;f[bb>>2]=($a|0)>(qb|0)?qb:$a;$a=bb+8|0;_a=f[$a>>2]|0;f[$a>>2]=(_a|0)<(qb|0)?qb:_a;_a=bb+4|0;$a=f[_a>>2]|0;f[_a>>2]=($a|0)>(yb|0)?yb:$a;$a=bb+12|0;_a=f[$a>>2]|0;f[$a>>2]=(_a|0)<(yb|0)?yb:_a;_a=bb+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=f[ub>>2]|0;bb=_a+(Sa<<4)|0;$a=bb;Ra=Kac(f[$a>>2]|0,f[$a+4>>2]|0,qb|0,((qb|0)<0)<<31>>31|0)|0;$a=bb;f[$a>>2]=Ra;f[$a+4>>2]=J;Nb=_a+(Sa<<4)+8|0;Ob=hb;Pb=_a}_a=Nb;hb=Kac(f[_a>>2]|0,f[_a+4>>2]|0,yb|0,kb|0)|0;_a=Nb;f[_a>>2]=hb;f[_a+4>>2]=J;_a=ob+(qb<<1)|0;if(!(b[nb+qb>>0]|0)){d[_a>>1]=0;Qb=0;Rb=Ob}else{d[_a>>1]=db;_a=db&65535;Qb=_a;Rb=Ob+(Y(f[f[rb>>2]>>2]|0,_a)|0)|0}_a=f[Rb>>2]|0;f[Rb>>2]=(_a|0)>(qb|0)?qb:_a;_a=Rb+8|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)<(qb|0)?qb:hb;hb=Rb+4|0;_a=f[hb>>2]|0;f[hb>>2]=(_a|0)>(pb|0)?pb:_a;_a=Rb+12|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)<(pb|0)?pb:hb;hb=Rb+16|0;f[hb>>2]=(f[hb>>2]|0)+1;hb=Pb+(Qb<<4)|0;_a=hb;Sa=Kac(f[_a>>2]|0,f[_a+4>>2]|0,qb|0,((qb|0)<0)<<31>>31|0)|0;_a=hb;f[_a>>2]=Sa;f[_a+4>>2]=J;_a=Pb+(Qb<<4)+8|0;Sa=_a;hb=Kac(f[Sa>>2]|0,f[Sa+4>>2]|0,pb|0,mb|0)|0;Sa=_a;f[Sa>>2]=hb;f[Sa+4>>2]=J;Sa=qb|1;if((Sa|0)<(f[r>>2]|0)){hb=sb+(Sa<<1)|0;if(!(b[lb+Sa>>0]|0)){d[hb>>1]=0;Sb=0;Tb=Ob}else{d[hb>>1]=db;hb=db&65535;Sb=hb;Tb=Ob+(Y(f[f[rb>>2]>>2]|0,hb)|0)|0}hb=f[Tb>>2]|0;f[Tb>>2]=(hb|0)>(Sa|0)?Sa:hb;hb=Tb+8|0;_a=f[hb>>2]|0;f[hb>>2]=(_a|0)<(Sa|0)?Sa:_a;_a=Tb+4|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)>(yb|0)?yb:hb;hb=Tb+12|0;_a=f[hb>>2]|0;f[hb>>2]=(_a|0)<(yb|0)?yb:_a;_a=Tb+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=Pb+(Sb<<4)|0;hb=_a;$a=Kac(f[hb>>2]|0,f[hb+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;hb=_a;f[hb>>2]=$a;f[hb+4>>2]=J;hb=Pb+(Sb<<4)+8|0;$a=hb;_a=Kac(f[$a>>2]|0,f[$a+4>>2]|0,yb|0,kb|0)|0;$a=hb;f[$a>>2]=_a;f[$a+4>>2]=J;$a=ob+(Sa<<1)|0;if(!(b[nb+Sa>>0]|0)){d[$a>>1]=0;_a=f[Ob>>2]|0;f[Ob>>2]=(_a|0)>(Sa|0)?Sa:_a;_a=Ob+8|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)<(Sa|0)?Sa:hb;hb=Ob+4|0;_a=f[hb>>2]|0;f[hb>>2]=(_a|0)>(pb|0)?pb:_a;_a=Ob+12|0;hb=f[_a>>2]|0;f[_a>>2]=(hb|0)<(pb|0)?pb:hb;hb=Ob+16|0;f[hb>>2]=(f[hb>>2]|0)+1;hb=Pb;_a=Kac(f[hb>>2]|0,f[hb+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;hb=Pb;f[hb>>2]=_a;f[hb+4>>2]=J;hb=Pb+8|0;_a=hb;Ra=Kac(f[_a>>2]|0,f[_a+4>>2]|0,pb|0,mb|0)|0;_a=hb;f[_a>>2]=Ra;f[_a+4>>2]=J;break}else{d[$a>>1]=db;$a=db&65535;db=Ob+(Y(f[f[rb>>2]>>2]|0,$a)|0)|0;_a=f[db>>2]|0;f[db>>2]=(_a|0)>(Sa|0)?Sa:_a;_a=db+8|0;Ra=f[_a>>2]|0;f[_a>>2]=(Ra|0)<(Sa|0)?Sa:Ra;Ra=db+4|0;_a=f[Ra>>2]|0;f[Ra>>2]=(_a|0)>(pb|0)?pb:_a;_a=db+12|0;Ra=f[_a>>2]|0;f[_a>>2]=(Ra|0)<(pb|0)?pb:Ra;Ra=db+16|0;f[Ra>>2]=(f[Ra>>2]|0)+1;Ra=Pb+($a<<4)|0;db=Ra;_a=Kac(f[db>>2]|0,f[db+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;Sa=Ra;f[Sa>>2]=_a;f[Sa+4>>2]=J;Sa=Pb+($a<<4)+8|0;$a=Sa;_a=Kac(f[$a>>2]|0,f[$a+4>>2]|0,pb|0,mb|0)|0;$a=Sa;f[$a>>2]=_a;f[$a+4>>2]=J;break}}}while(0);qb=qb+2|0;Ub=f[r>>2]|0}while((qb|0)<(Ub|0));Vb=f[l>>2]|0;Wb=Ub}else{Vb=N;Wb=v}yb=yb+2|0;if((yb|0)>=(Vb|0))break;else{v=Wb;N=Vb}}}}else{if(!t){if(!i)break;N=h+20|0;v=h+120|0;yb=h+48|0;rb=f[c+16>>2]|0;ub=f[c+44>>2]|0;tb=f[e+16>>2]|0;vb=f[e+44>>2]|0;k=0;wb=zb;xb=Ab;while(1){qb=f[ub>>2]|0;mb=rb+(Y(qb,k)|0)|0;pb=mb+qb|0;qb=f[vb>>2]|0;nb=tb+(Y(qb,k)|0)|0;ob=nb+qb|0;if((wb|0)>0){qb=((k|0)<0)<<31>>31;kb=k|1;lb=((kb|0)<0)<<31>>31;sb=0;do{jb=nb+(sb<<1)|0;ib=d[jb>>1]|0;do if(!(ib<<16>>16)){d[jb>>1]=0;$a=sb|1;d[nb+($a<<1)>>1]=0;_a=f[N>>2]|0;Sa=f[_a>>2]|0;Ra=(Sa|0)>(sb|0)?sb:Sa;Sa=_a+8|0;db=f[Sa>>2]|0;hb=(db|0)<(sb|0)?sb:db;db=_a+4|0;bb=f[db>>2]|0;fb=(bb|0)>(k|0)?k:bb;bb=_a+12|0;Ta=f[bb>>2]|0;Xa=(Ta|0)<(k|0)?k:Ta;Ta=_a+16|0;gb=f[Ta>>2]|0;Ya=f[v>>2]|0;cb=((sb|0)<0)<<31>>31;eb=Ya;Za=Kac(f[eb>>2]|0,f[eb+4>>2]|0,sb|0,cb|0)|0;eb=J;K=Ya+8|0;Ua=K;I=Kac(f[Ua>>2]|0,f[Ua+4>>2]|0,k|0,qb|0)|0;Ua=J;ab=(Ra|0)>($a|0)?$a:Ra;f[_a>>2]=ab;Ra=(hb|0)<($a|0)?$a:hb;f[Sa>>2]=Ra;f[db>>2]=fb;f[bb>>2]=Xa;f[Ta>>2]=gb+2;hb=(($a|0)<0)<<31>>31;Wa=Kac(Za|0,eb|0,$a|0,hb|0)|0;eb=J;Za=Ya;f[Za>>2]=Wa;f[Za+4>>2]=eb;Za=Kac(I|0,Ua|0,k|0,qb|0)|0;Ua=J;I=K;f[I>>2]=Za;f[I+4>>2]=Ua;if((kb|0)<(f[l>>2]|0)){d[ob+(sb<<1)>>1]=0;d[ob+($a<<1)>>1]=0;I=Kac(Wa|0,eb|0,sb|0,cb|0)|0;cb=J;eb=Kac(Za|0,Ua|0,kb|0,lb|0)|0;Ua=J;f[_a>>2]=(ab|0)>(sb|0)?sb:ab;f[Sa>>2]=Ra;f[db>>2]=(fb|0)>(kb|0)?kb:fb;f[bb>>2]=(Xa|0)<(kb|0)?kb:Xa;f[Ta>>2]=gb+4;gb=Kac(I|0,cb|0,$a|0,hb|0)|0;hb=Ya;f[hb>>2]=gb;f[hb+4>>2]=J;hb=Kac(eb|0,Ua|0,kb|0,lb|0)|0;Ua=K;f[Ua>>2]=hb;f[Ua+4>>2]=J}}else{Ua=d[q+((ib&65535)<<1)>>1]|0;if(!(b[mb+sb>>0]|0)){d[jb>>1]=0;hb=f[N>>2]|0;K=f[hb>>2]|0;f[hb>>2]=(K|0)>(sb|0)?sb:K;K=hb+8|0;eb=f[K>>2]|0;f[K>>2]=(eb|0)<(sb|0)?sb:eb;eb=hb+4|0;K=f[eb>>2]|0;f[eb>>2]=(K|0)>(k|0)?k:K;K=hb+12|0;eb=f[K>>2]|0;f[K>>2]=(eb|0)<(k|0)?k:eb;eb=hb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=f[v>>2]|0;K=eb;gb=Kac(f[K>>2]|0,f[K+4>>2]|0,sb|0,((sb|0)<0)<<31>>31|0)|0;K=eb;f[K>>2]=gb;f[K+4>>2]=J;Xb=eb+8|0;Yb=hb;Zb=eb}else{d[jb>>1]=Ua;eb=Ua&65535;hb=f[N>>2]|0;K=hb+(Y(f[f[yb>>2]>>2]|0,eb)|0)|0;gb=f[K>>2]|0;f[K>>2]=(gb|0)>(sb|0)?sb:gb;gb=K+8|0;Ya=f[gb>>2]|0;f[gb>>2]=(Ya|0)<(sb|0)?sb:Ya;Ya=K+4|0;gb=f[Ya>>2]|0;f[Ya>>2]=(gb|0)>(k|0)?k:gb;gb=K+12|0;Ya=f[gb>>2]|0;f[gb>>2]=(Ya|0)<(k|0)?k:Ya;Ya=K+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[v>>2]|0;K=Ya+(eb<<4)|0;gb=K;$a=Kac(f[gb>>2]|0,f[gb+4>>2]|0,sb|0,((sb|0)<0)<<31>>31|0)|0;gb=K;f[gb>>2]=$a;f[gb+4>>2]=J;Xb=Ya+(eb<<4)+8|0;Yb=hb;Zb=Ya}Ya=Xb;hb=Kac(f[Ya>>2]|0,f[Ya+4>>2]|0,k|0,qb|0)|0;Ya=Xb;f[Ya>>2]=hb;f[Ya+4>>2]=J;Ya=sb|1;hb=nb+(Ya<<1)|0;if(!(b[mb+Ya>>0]|0)){d[hb>>1]=0;_b=0;$b=Yb}else{d[hb>>1]=Ua;hb=Ua&65535;_b=hb;$b=Yb+(Y(f[f[yb>>2]>>2]|0,hb)|0)|0}hb=f[$b>>2]|0;f[$b>>2]=(hb|0)>(Ya|0)?Ya:hb;hb=$b+8|0;eb=f[hb>>2]|0;f[hb>>2]=(eb|0)<(Ya|0)?Ya:eb;eb=$b+4|0;hb=f[eb>>2]|0;f[eb>>2]=(hb|0)>(k|0)?k:hb;hb=$b+12|0;eb=f[hb>>2]|0;f[hb>>2]=(eb|0)<(k|0)?k:eb;eb=$b+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Zb+(_b<<4)|0;hb=eb;gb=Kac(f[hb>>2]|0,f[hb+4>>2]|0,Ya|0,((Ya|0)<0)<<31>>31|0)|0;hb=eb;f[hb>>2]=gb;f[hb+4>>2]=J;hb=Zb+(_b<<4)+8|0;gb=hb;eb=Kac(f[gb>>2]|0,f[gb+4>>2]|0,k|0,qb|0)|0;gb=hb;f[gb>>2]=eb;f[gb+4>>2]=J;if((kb|0)<(f[l>>2]|0)){gb=ob+(sb<<1)|0;if(!(b[pb+sb>>0]|0)){d[gb>>1]=0;ac=0;bc=Yb}else{d[gb>>1]=Ua;gb=Ua&65535;ac=gb;bc=Yb+(Y(f[f[yb>>2]>>2]|0,gb)|0)|0}gb=f[bc>>2]|0;f[bc>>2]=(gb|0)>(sb|0)?sb:gb;gb=bc+8|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)<(sb|0)?sb:eb;eb=bc+4|0;gb=f[eb>>2]|0;f[eb>>2]=(gb|0)>(kb|0)?kb:gb;gb=bc+12|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)<(kb|0)?kb:eb;eb=bc+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Zb+(ac<<4)|0;gb=eb;hb=Kac(f[gb>>2]|0,f[gb+4>>2]|0,sb|0,((sb|0)<0)<<31>>31|0)|0;gb=eb;f[gb>>2]=hb;f[gb+4>>2]=J;gb=Zb+(ac<<4)+8|0;hb=gb;eb=Kac(f[hb>>2]|0,f[hb+4>>2]|0,kb|0,lb|0)|0;hb=gb;f[hb>>2]=eb;f[hb+4>>2]=J;hb=ob+(Ya<<1)|0;if(!(b[pb+Ya>>0]|0)){d[hb>>1]=0;eb=f[Yb>>2]|0;f[Yb>>2]=(eb|0)>(Ya|0)?Ya:eb;eb=Yb+8|0;gb=f[eb>>2]|0;f[eb>>2]=(gb|0)<(Ya|0)?Ya:gb;gb=Yb+4|0;eb=f[gb>>2]|0;f[gb>>2]=(eb|0)>(kb|0)?kb:eb;eb=Yb+12|0;gb=f[eb>>2]|0;f[eb>>2]=(gb|0)<(kb|0)?kb:gb;gb=Yb+16|0;f[gb>>2]=(f[gb>>2]|0)+1;gb=Zb;eb=Kac(f[gb>>2]|0,f[gb+4>>2]|0,Ya|0,((Ya|0)<0)<<31>>31|0)|0;gb=Zb;f[gb>>2]=eb;f[gb+4>>2]=J;gb=Zb+8|0;eb=gb;$a=Kac(f[eb>>2]|0,f[eb+4>>2]|0,kb|0,lb|0)|0;eb=gb;f[eb>>2]=$a;f[eb+4>>2]=J;break}else{d[hb>>1]=Ua;hb=Ua&65535;Ua=Yb+(Y(f[f[yb>>2]>>2]|0,hb)|0)|0;eb=f[Ua>>2]|0;f[Ua>>2]=(eb|0)>(Ya|0)?Ya:eb;eb=Ua+8|0;$a=f[eb>>2]|0;f[eb>>2]=($a|0)<(Ya|0)?Ya:$a;$a=Ua+4|0;eb=f[$a>>2]|0;f[$a>>2]=(eb|0)>(kb|0)?kb:eb;eb=Ua+12|0;$a=f[eb>>2]|0;f[eb>>2]=($a|0)<(kb|0)?kb:$a;$a=Ua+16|0;f[$a>>2]=(f[$a>>2]|0)+1;$a=Zb+(hb<<4)|0;Ua=$a;eb=Kac(f[Ua>>2]|0,f[Ua+4>>2]|0,Ya|0,((Ya|0)<0)<<31>>31|0)|0;Ya=$a;f[Ya>>2]=eb;f[Ya+4>>2]=J;Ya=Zb+(hb<<4)+8|0;hb=Ya;eb=Kac(f[hb>>2]|0,f[hb+4>>2]|0,kb|0,lb|0)|0;hb=Ya;f[hb>>2]=eb;f[hb+4>>2]=J;break}}}while(0);sb=sb+2|0;cc=f[r>>2]|0}while((sb|0)<(cc|0));dc=f[l>>2]|0;ec=cc}else{dc=xb;ec=wb}k=k+2|0;if((k|0)>=(dc|0))break b;else{wb=ec;xb=dc}}}if(i){xb=h+20|0;wb=h+120|0;k=h+48|0;yb=f[c+16>>2]|0;v=f[c+44>>2]|0;N=f[e+16>>2]|0;tb=f[e+44>>2]|0;vb=0;rb=zb;ub=Ab;while(1){sb=f[v>>2]|0;lb=yb+(Y(sb,vb)|0)|0;kb=lb+sb|0;sb=f[tb>>2]|0;pb=N+(Y(sb,vb)|0)|0;ob=pb+sb|0;if((rb|0)>0){sb=((vb|0)<0)<<31>>31;qb=vb|1;mb=((qb|0)<0)<<31>>31;nb=0;do{jb=pb+(nb<<1)|0;ib=d[jb>>1]|0;do if(!(ib<<16>>16)){d[jb>>1]=0;hb=f[xb>>2]|0;eb=f[hb>>2]|0;Ya=(eb|0)>(nb|0)?nb:eb;f[hb>>2]=Ya;eb=hb+8|0;$a=f[eb>>2]|0;Ua=($a|0)<(nb|0)?nb:$a;f[eb>>2]=Ua;$a=hb+4|0;gb=f[$a>>2]|0;K=(gb|0)>(vb|0)?vb:gb;f[$a>>2]=K;gb=hb+12|0;cb=f[gb>>2]|0;I=(cb|0)<(vb|0)?vb:cb;f[gb>>2]=I;cb=hb+16|0;Ta=f[cb>>2]|0;f[cb>>2]=Ta+1;Xa=f[wb>>2]|0;bb=((nb|0)<0)<<31>>31;fb=Xa;db=Kac(f[fb>>2]|0,f[fb+4>>2]|0,nb|0,bb|0)|0;fb=J;Ra=Xa;f[Ra>>2]=db;f[Ra+4>>2]=fb;Ra=Xa+8|0;Sa=Ra;ab=Kac(f[Sa>>2]|0,f[Sa+4>>2]|0,vb|0,sb|0)|0;Sa=J;_a=Ra;f[_a>>2]=ab;f[_a+4>>2]=Sa;_a=nb|1;if((_a|0)<(f[r>>2]|0)){d[pb+(_a<<1)>>1]=0;Za=(Ya|0)>(_a|0)?_a:Ya;f[hb>>2]=Za;Wa=(Ua|0)<(_a|0)?_a:Ua;f[eb>>2]=Wa;f[$a>>2]=K;f[gb>>2]=I;f[cb>>2]=Ta+2;Va=((_a|0)<0)<<31>>31;Qa=Kac(db|0,fb|0,_a|0,Va|0)|0;Pa=J;Oa=Xa;f[Oa>>2]=Qa;f[Oa+4>>2]=Pa;Oa=Kac(ab|0,Sa|0,vb|0,sb|0)|0;Na=J;Ma=Ra;f[Ma>>2]=Oa;f[Ma+4>>2]=Na;if((qb|0)>=(f[l>>2]|0))break;d[ob+(nb<<1)>>1]=0;d[ob+(_a<<1)>>1]=0;Ma=Kac(Qa|0,Pa|0,nb|0,bb|0)|0;Pa=J;Qa=Kac(Oa|0,Na|0,qb|0,mb|0)|0;Na=J;f[hb>>2]=(Za|0)>(nb|0)?nb:Za;f[eb>>2]=Wa;f[$a>>2]=(K|0)>(qb|0)?qb:K;f[gb>>2]=(I|0)<(qb|0)?qb:I;f[cb>>2]=Ta+4;Wa=Kac(Ma|0,Pa|0,_a|0,Va|0)|0;Va=Xa;f[Va>>2]=Wa;f[Va+4>>2]=J;Va=Kac(Qa|0,Na|0,qb|0,mb|0)|0;Na=Ra;f[Na>>2]=Va;f[Na+4>>2]=J;break}else{if((qb|0)>=(f[l>>2]|0))break;d[ob+(nb<<1)>>1]=0;f[hb>>2]=Ya;f[eb>>2]=Ua;f[$a>>2]=(K|0)>(qb|0)?qb:K;f[gb>>2]=(I|0)<(qb|0)?qb:I;f[cb>>2]=Ta+2;Ta=Kac(db|0,fb|0,nb|0,bb|0)|0;bb=Xa;f[bb>>2]=Ta;f[bb+4>>2]=J;bb=Kac(ab|0,Sa|0,qb|0,mb|0)|0;Sa=Ra;f[Sa>>2]=bb;f[Sa+4>>2]=J;break}}else{Sa=d[q+((ib&65535)<<1)>>1]|0;if(!(b[lb+nb>>0]|0)){d[jb>>1]=0;bb=f[xb>>2]|0;Ra=f[bb>>2]|0;f[bb>>2]=(Ra|0)>(nb|0)?nb:Ra;Ra=bb+8|0;ab=f[Ra>>2]|0;f[Ra>>2]=(ab|0)<(nb|0)?nb:ab;ab=bb+4|0;Ra=f[ab>>2]|0;f[ab>>2]=(Ra|0)>(vb|0)?vb:Ra;Ra=bb+12|0;ab=f[Ra>>2]|0;f[Ra>>2]=(ab|0)<(vb|0)?vb:ab;ab=bb+16|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=f[wb>>2]|0;Ra=ab;Ta=Kac(f[Ra>>2]|0,f[Ra+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;Ra=ab;f[Ra>>2]=Ta;f[Ra+4>>2]=J;fc=ab+8|0;gc=bb;hc=ab}else{d[jb>>1]=Sa;ab=Sa&65535;bb=f[xb>>2]|0;Ra=bb+(Y(f[f[k>>2]>>2]|0,ab)|0)|0;Ta=f[Ra>>2]|0;f[Ra>>2]=(Ta|0)>(nb|0)?nb:Ta;Ta=Ra+8|0;Xa=f[Ta>>2]|0;f[Ta>>2]=(Xa|0)<(nb|0)?nb:Xa;Xa=Ra+4|0;Ta=f[Xa>>2]|0;f[Xa>>2]=(Ta|0)>(vb|0)?vb:Ta;Ta=Ra+12|0;Xa=f[Ta>>2]|0;f[Ta>>2]=(Xa|0)<(vb|0)?vb:Xa;Xa=Ra+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=f[wb>>2]|0;Ra=Xa+(ab<<4)|0;Ta=Ra;fb=Kac(f[Ta>>2]|0,f[Ta+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;Ta=Ra;f[Ta>>2]=fb;f[Ta+4>>2]=J;fc=Xa+(ab<<4)+8|0;gc=bb;hc=Xa}Xa=fc;bb=Kac(f[Xa>>2]|0,f[Xa+4>>2]|0,vb|0,sb|0)|0;Xa=fc;f[Xa>>2]=bb;f[Xa+4>>2]=J;Xa=nb|1;if((Xa|0)>=(f[r>>2]|0)){if((qb|0)>=(f[l>>2]|0))break;bb=ob+(nb<<1)|0;if(!(b[kb+nb>>0]|0)){d[bb>>1]=0;ab=f[gc>>2]|0;f[gc>>2]=(ab|0)>(nb|0)?nb:ab;ab=gc+8|0;Ta=f[ab>>2]|0;f[ab>>2]=(Ta|0)<(nb|0)?nb:Ta;Ta=gc+4|0;ab=f[Ta>>2]|0;f[Ta>>2]=(ab|0)>(qb|0)?qb:ab;ab=gc+12|0;Ta=f[ab>>2]|0;f[ab>>2]=(Ta|0)<(qb|0)?qb:Ta;Ta=gc+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=hc;ab=Kac(f[Ta>>2]|0,f[Ta+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;Ta=hc;f[Ta>>2]=ab;f[Ta+4>>2]=J;Ta=hc+8|0;ab=Ta;fb=Kac(f[ab>>2]|0,f[ab+4>>2]|0,qb|0,mb|0)|0;ab=Ta;f[ab>>2]=fb;f[ab+4>>2]=J;break}else{d[bb>>1]=Sa;bb=Sa&65535;ab=gc+(Y(f[f[k>>2]>>2]|0,bb)|0)|0;fb=f[ab>>2]|0;f[ab>>2]=(fb|0)>(nb|0)?nb:fb;fb=ab+8|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(nb|0)?nb:Ta;Ta=ab+4|0;fb=f[Ta>>2]|0;f[Ta>>2]=(fb|0)>(qb|0)?qb:fb;fb=ab+12|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(qb|0)?qb:Ta;Ta=ab+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=hc+(bb<<4)|0;ab=Ta;fb=Kac(f[ab>>2]|0,f[ab+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;ab=Ta;f[ab>>2]=fb;f[ab+4>>2]=J;ab=hc+(bb<<4)+8|0;bb=ab;fb=Kac(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,mb|0)|0;bb=ab;f[bb>>2]=fb;f[bb+4>>2]=J;break}}bb=pb+(Xa<<1)|0;if(!(b[lb+Xa>>0]|0)){d[bb>>1]=0;ic=0;jc=gc}else{d[bb>>1]=Sa;bb=Sa&65535;ic=bb;jc=gc+(Y(f[f[k>>2]>>2]|0,bb)|0)|0}bb=f[jc>>2]|0;f[jc>>2]=(bb|0)>(Xa|0)?Xa:bb;bb=jc+8|0;fb=f[bb>>2]|0;f[bb>>2]=(fb|0)<(Xa|0)?Xa:fb;fb=jc+4|0;bb=f[fb>>2]|0;f[fb>>2]=(bb|0)>(vb|0)?vb:bb;bb=jc+12|0;fb=f[bb>>2]|0;f[bb>>2]=(fb|0)<(vb|0)?vb:fb;fb=jc+16|0;f[fb>>2]=(f[fb>>2]|0)+1;fb=hc+(ic<<4)|0;bb=fb;ab=Kac(f[bb>>2]|0,f[bb+4>>2]|0,Xa|0,((Xa|0)<0)<<31>>31|0)|0;bb=fb;f[bb>>2]=ab;f[bb+4>>2]=J;bb=hc+(ic<<4)+8|0;ab=bb;fb=Kac(f[ab>>2]|0,f[ab+4>>2]|0,vb|0,sb|0)|0;ab=bb;f[ab>>2]=fb;f[ab+4>>2]=J;if((qb|0)<(f[l>>2]|0)){ab=ob+(nb<<1)|0;if(!(b[kb+nb>>0]|0)){d[ab>>1]=0;kc=0;lc=gc}else{d[ab>>1]=Sa;ab=Sa&65535;kc=ab;lc=gc+(Y(f[f[k>>2]>>2]|0,ab)|0)|0}ab=f[lc>>2]|0;f[lc>>2]=(ab|0)>(nb|0)?nb:ab;ab=lc+8|0;fb=f[ab>>2]|0;f[ab>>2]=(fb|0)<(nb|0)?nb:fb;fb=lc+4|0;ab=f[fb>>2]|0;f[fb>>2]=(ab|0)>(qb|0)?qb:ab;ab=lc+12|0;fb=f[ab>>2]|0;f[ab>>2]=(fb|0)<(qb|0)?qb:fb;fb=lc+16|0;f[fb>>2]=(f[fb>>2]|0)+1;fb=hc+(kc<<4)|0;ab=fb;bb=Kac(f[ab>>2]|0,f[ab+4>>2]|0,nb|0,((nb|0)<0)<<31>>31|0)|0;ab=fb;f[ab>>2]=bb;f[ab+4>>2]=J;ab=hc+(kc<<4)+8|0;bb=ab;fb=Kac(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,mb|0)|0;bb=ab;f[bb>>2]=fb;f[bb+4>>2]=J;bb=ob+(Xa<<1)|0;if(!(b[kb+Xa>>0]|0)){d[bb>>1]=0;fb=f[gc>>2]|0;f[gc>>2]=(fb|0)>(Xa|0)?Xa:fb;fb=gc+8|0;ab=f[fb>>2]|0;f[fb>>2]=(ab|0)<(Xa|0)?Xa:ab;ab=gc+4|0;fb=f[ab>>2]|0;f[ab>>2]=(fb|0)>(qb|0)?qb:fb;fb=gc+12|0;ab=f[fb>>2]|0;f[fb>>2]=(ab|0)<(qb|0)?qb:ab;ab=gc+16|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=hc;fb=Kac(f[ab>>2]|0,f[ab+4>>2]|0,Xa|0,((Xa|0)<0)<<31>>31|0)|0;ab=hc;f[ab>>2]=fb;f[ab+4>>2]=J;ab=hc+8|0;fb=ab;Ta=Kac(f[fb>>2]|0,f[fb+4>>2]|0,qb|0,mb|0)|0;fb=ab;f[fb>>2]=Ta;f[fb+4>>2]=J;break}else{d[bb>>1]=Sa;bb=Sa&65535;Sa=gc+(Y(f[f[k>>2]>>2]|0,bb)|0)|0;fb=f[Sa>>2]|0;f[Sa>>2]=(fb|0)>(Xa|0)?Xa:fb;fb=Sa+8|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(Xa|0)?Xa:Ta;Ta=Sa+4|0;fb=f[Ta>>2]|0;f[Ta>>2]=(fb|0)>(qb|0)?qb:fb;fb=Sa+12|0;Ta=f[fb>>2]|0;f[fb>>2]=(Ta|0)<(qb|0)?qb:Ta;Ta=Sa+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=hc+(bb<<4)|0;Sa=Ta;fb=Kac(f[Sa>>2]|0,f[Sa+4>>2]|0,Xa|0,((Xa|0)<0)<<31>>31|0)|0;Xa=Ta;f[Xa>>2]=fb;f[Xa+4>>2]=J;Xa=hc+(bb<<4)+8|0;bb=Xa;fb=Kac(f[bb>>2]|0,f[bb+4>>2]|0,qb|0,mb|0)|0;bb=Xa;f[bb>>2]=fb;f[bb+4>>2]=J;break}}}while(0);nb=nb+2|0;mc=f[r>>2]|0}while((nb|0)<(mc|0));nc=f[l>>2]|0;oc=mc}else{nc=ub;oc=rb}vb=vb+2|0;if((vb|0)>=(nc|0))break;else{rb=oc;ub=nc}}}}while(0);nc=h+12|0;if((f[nc>>2]|0)<=0){UC(q);u=a;return Bb|0}oc=f[h+20>>2]|0;mc=f[h+48>>2]|0;l=f[h+120>>2]|0;r=f[h+80>>2]|0;hc=f[h+108>>2]|0;h=0;do{gc=oc+(Y(f[mc>>2]|0,h)|0)|0;kc=gc+8|0;f[kc>>2]=(f[kc>>2]|0)+1-(f[gc>>2]|0);kc=gc+12|0;f[kc>>2]=(f[kc>>2]|0)+1-(f[gc+4>>2]|0);kc=r+(Y(f[hc>>2]|0,h)|0)|0;pc=+((f[gc+16>>2]|0)>>>0);gc=l+(h<<4)|0;p[kc>>3]=(+((f[gc>>2]|0)>>>0)+4294967296.0*+((f[gc+4>>2]|0)>>>0))/pc;gc=l+(h<<4)+8|0;p[kc+8>>3]=(+((f[gc>>2]|0)>>>0)+4294967296.0*+((f[gc+4>>2]|0)>>>0))/pc;h=h+1|0}while((h|0)<(f[nc>>2]|0));UC(q);u=a;return Bb|0}function i4(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0.0;a=u;u=u+16|0;h=a;i=c+8|0;j=d+8|0;if((f[i>>2]|0)!=(f[j>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,26)|0;l=235286;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,489445,235014,2594);bD(h)}n=c+12|0;o=d+12|0;if((f[n>>2]|0)!=(f[o>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,26)|0;l=235313;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,489445,235014,2595);bD(h)}if((e|0)!=8){f[h>>2]=0;f[h+4>>2]=0;k=aD(h,17)|0;l=235340;m=k+17|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,h,489445,235014,2596);bD(h)}h=f[i>>2]|0;i=f[n>>2]|0;n=TC((Y(((h+1|0)/2|0)<<2,(i+1|0)/2|0)|0)+4|0)|0;f[n>>2]=0;if((h|0)>0){l=c+16|0;k=c+44|0;m=d+16|0;e=d+44|0;q=(i|0)>0;r=1;s=0;while(1){t=f[f[k>>2]>>2]|0;v=(f[l>>2]|0)+(Y(t,s)|0)|0;w=0-t|0;x=v+w|0;y=x+w|0;w=v+t|0;t=f[f[e>>2]>>2]|0;z=(f[m>>2]|0)+(Y(t,s)|0)|0;A=0-t|0;t=z+A+A|0;if(q){A=(s|1|0)<(h|0);B=(s|0)>0;C=B^1;D=(s+-2|0)>-1;E=0;F=r;while(1){a:do if(!(b[v+E>>0]|0)){G=E|1;H=(G|0)<(i|0);if(A?b[w+E>>0]|0:0){I=E+-1|0;K=(E|0)>0;if(H?b[v+G>>0]|0:0){do if(K){if(b[v+I>>0]|0){do if(B){if(b[x+G>>0]|0){if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}do if(D){if(!(b[y+E>>0]|0))break;M=E+-2|0;if(b[x+I>>0]|0){f[z+(E<<2)>>2]=f[z+(M<<2)>>2];L=F;break a}do if((M|0)>-1){if(!(b[x+M>>0]|0))break;if(b[y+I>>0]|0){f[z+(E<<2)>>2]=f[z+(M<<2)>>2];L=F;break a}N=f[t+(E<<2)>>2]|0;O=f[z+(M<<2)>>2]|0;P=N;while(1){Q=f[n+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}if((N|0)==(O|0))R=P;else{Q=O;while(1){S=f[n+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}S=(P|0)>(Q|0)?Q:P;T=O;do{U=n+(T<<2)|0;V=T;T=f[U>>2]|0;f[U>>2]=S}while((T|0)<(V|0));R=S}S=N;do{T=n+(S<<2)|0;O=S;S=f[T>>2]|0;f[T>>2]=R}while((S|0)<(O|0));f[z+(E<<2)>>2]=R;L=F;break a}while(0);S=f[t+(E<<2)>>2]|0;N=f[z+(M<<2)>>2]|0;O=S;while(1){T=f[n+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((S|0)==(N|0))W=O;else{M=N;while(1){T=f[n+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}T=(O|0)>(M|0)?M:O;P=N;do{Q=n+(P<<2)|0;V=P;P=f[Q>>2]|0;f[Q>>2]=T}while((P|0)<(V|0));W=T}T=S;do{P=n+(T<<2)|0;N=T;T=f[P>>2]|0;f[P>>2]=W}while((T|0)<(N|0));f[z+(E<<2)>>2]=W;L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;S=f[z+(E+-2<<2)>>2]|0;N=T;while(1){P=f[n+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((T|0)==(S|0))X=N;else{P=S;while(1){O=f[n+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(N|0)>(P|0)?P:N;M=S;do{V=n+(M<<2)|0;Q=M;M=f[V>>2]|0;f[V>>2]=O}while((M|0)<(Q|0));X=O}O=T;do{M=n+(O<<2)|0;S=O;O=f[M>>2]|0;f[M>>2]=X}while((O|0)<(S|0));f[z+(E<<2)>>2]=X;L=F;break a}O=E+2|0;if((O|0)>=(i|0))break;if(!(b[x+O>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}if(!(b[y+E>>0]|0)){T=f[t+(O<<2)>>2]|0;S=f[z+(E+-2<<2)>>2]|0;M=T;while(1){N=f[n+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}if((T|0)==(S|0))Z=M;else{N=S;while(1){P=f[n+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(M|0)>(N|0)?N:M;Q=S;do{V=n+(Q<<2)|0;U=Q;Q=f[V>>2]|0;f[V>>2]=P}while((Q|0)<(U|0));Z=P}P=T;do{Q=n+(P<<2)|0;S=P;P=f[Q>>2]|0;f[Q>>2]=Z}while((P|0)<(S|0));f[z+(E<<2)>>2]=Z;L=F;break a}P=E+-2|0;if(b[x+I>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[y+I>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}T=f[t+(O<<2)>>2]|0;S=f[z+(P<<2)>>2]|0;Q=T;while(1){M=f[n+(Q<<2)>>2]|0;if((M|0)<(Q|0))Q=M;else break}if((T|0)==(S|0))_=Q;else{M=S;while(1){N=f[n+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(Q|0)>(M|0)?M:Q;U=S;do{V=n+(U<<2)|0;$=U;U=f[V>>2]|0;f[V>>2]=N}while((U|0)<($|0));_=N}N=T;do{U=n+(N<<2)|0;S=N;N=f[U>>2]|0;f[U>>2]=_}while((N|0)<(S|0));f[z+(E<<2)>>2]=_;L=F;break a}while(0);N=f[t+(O<<2)>>2]|0;T=f[z+(P<<2)>>2]|0;S=N;while(1){U=f[n+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((N|0)==(T|0))aa=S;else{P=T;while(1){U=f[n+(P<<2)>>2]|0;if((U|0)<(P|0))P=U;else break}U=(S|0)>(P|0)?P:S;Q=T;do{M=n+(Q<<2)|0;$=Q;Q=f[M>>2]|0;f[M>>2]=U}while((Q|0)<($|0));aa=U}U=N;do{Q=n+(U<<2)|0;T=U;U=f[Q>>2]|0;f[Q>>2]=aa}while((U|0)<(T|0));f[z+(E<<2)>>2]=aa;L=F;break a}while(0);U=f[t+(O<<2)>>2]|0;N=f[z+(E+-2<<2)>>2]|0;T=U;while(1){Q=f[n+(T<<2)>>2]|0;if((Q|0)<(T|0))T=Q;else break}if((U|0)==(N|0))ba=T;else{O=N;while(1){Q=f[n+(O<<2)>>2]|0;if((Q|0)<(O|0))O=Q;else break}Q=(T|0)>(O|0)?O:T;S=N;do{P=n+(S<<2)|0;$=S;S=f[P>>2]|0;f[P>>2]=Q}while((S|0)<($|0));ba=Q}Q=U;do{S=n+(Q<<2)|0;N=Q;Q=f[S>>2]|0;f[S>>2]=ba}while((Q|0)<(N|0));f[z+(E<<2)>>2]=ba;L=F;break a}while(0);f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}if(!(b[w+I>>0]|0))break;do if(B){if(b[x+G>>0]|0){Q=E+-2|0;do if((Q|0)>-1){if(!(b[v+Q>>0]|0))break;if(b[x+I>>0]|0){U=f[z+(Q<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}do if(D){if(!(b[y+E>>0]|0))break;f[z+(E<<2)>>2]=U;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;S=N;while(1){T=f[n+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}if((N|0)==(U|0))ca=S;else{T=U;while(1){O=f[n+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}O=(S|0)>(T|0)?T:S;$=U;do{P=n+($<<2)|0;M=$;$=f[P>>2]|0;f[P>>2]=O}while(($|0)<(M|0));ca=O}O=N;do{$=n+(O<<2)|0;U=O;O=f[$>>2]|0;f[$>>2]=ca}while((O|0)<(U|0));f[z+(E<<2)>>2]=ca;L=F;break a}if(!(b[x+Q>>0]|0)){O=f[t+(E<<2)>>2]|0;N=f[z+(Q<<2)>>2]|0;U=O;while(1){$=f[n+(U<<2)>>2]|0;if(($|0)<(U|0))U=$;else break}if((O|0)==(N|0))da=U;else{$=N;while(1){S=f[n+($<<2)>>2]|0;if((S|0)<($|0))$=S;else break}S=(U|0)>($|0)?$:U;T=N;do{M=n+(T<<2)|0;P=T;T=f[M>>2]|0;f[M>>2]=S}while((T|0)<(P|0));da=S}S=O;do{T=n+(S<<2)|0;N=S;S=f[T>>2]|0;f[T>>2]=da}while((S|0)<(N|0));f[z+(E<<2)>>2]=da;L=F;break a}do if(D){if(!(b[y+I>>0]|0))break;S=f[z+(Q<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=S;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=S;L=F;break a}O=f[t+(E<<2)>>2]|0;N=O;while(1){T=f[n+(N<<2)>>2]|0;if((T|0)<(N|0))N=T;else break}if((O|0)==(S|0))ea=N;else{T=S;while(1){U=f[n+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}U=(N|0)>(T|0)?T:N;$=S;do{P=n+($<<2)|0;M=$;$=f[P>>2]|0;f[P>>2]=U}while(($|0)<(M|0));ea=U}U=O;do{$=n+(U<<2)|0;S=U;U=f[$>>2]|0;f[$>>2]=ea}while((U|0)<(S|0));f[z+(E<<2)>>2]=ea;L=F;break a}while(0);U=f[t+(E<<2)>>2]|0;O=f[z+(Q<<2)>>2]|0;S=U;while(1){$=f[n+(S<<2)>>2]|0;if(($|0)<(S|0))S=$;else break}if((U|0)==(O|0))fa=S;else{$=O;while(1){N=f[n+($<<2)>>2]|0;if((N|0)<($|0))$=N;else break}N=(S|0)>($|0)?$:S;T=O;do{M=n+(T<<2)|0;P=T;T=f[M>>2]|0;f[M>>2]=N}while((T|0)<(P|0));fa=N}N=U;do{T=n+(N<<2)|0;O=N;N=f[T>>2]|0;f[T>>2]=fa}while((N|0)<(O|0));f[z+(E<<2)>>2]=fa;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;U=f[z+(Q<<2)>>2]|0;O=N;while(1){T=f[n+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((N|0)==(U|0))ga=O;else{Q=U;while(1){T=f[n+(Q<<2)>>2]|0;if((T|0)<(Q|0))Q=T;else break}T=(O|0)>(Q|0)?Q:O;S=U;do{$=n+(S<<2)|0;P=S;S=f[$>>2]|0;f[$>>2]=T}while((S|0)<(P|0));ga=T}T=N;do{S=n+(T<<2)|0;U=T;T=f[S>>2]|0;f[S>>2]=ga}while((T|0)<(U|0));f[z+(E<<2)>>2]=ga;L=F;break a}T=E+2|0;do if(!((T|0)>=(i|0)|C)){if(!(b[x+T>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;N=E+-2|0;do if((N|0)>-1){if(!(b[v+N>>0]|0))break;if(b[x+I>>0]|0){U=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}S=f[t+(T<<2)>>2]|0;O=S;while(1){Q=f[n+(O<<2)>>2]|0;if((Q|0)<(O|0))O=Q;else break}if((S|0)==(U|0))ha=O;else{Q=U;while(1){P=f[n+(Q<<2)>>2]|0;if((P|0)<(Q|0))Q=P;else break}P=(O|0)>(Q|0)?Q:O;$=U;do{M=n+($<<2)|0;V=$;$=f[M>>2]|0;f[M>>2]=P}while(($|0)<(V|0));ha=P}P=S;do{$=n+(P<<2)|0;U=P;P=f[$>>2]|0;f[$>>2]=ha}while((P|0)<(U|0));f[z+(E<<2)>>2]=ha;L=F;break a}if(!(b[x+N>>0]|0)){P=f[t+(T<<2)>>2]|0;S=f[z+(N<<2)>>2]|0;U=P;while(1){$=f[n+(U<<2)>>2]|0;if(($|0)<(U|0))U=$;else break}if((P|0)==(S|0))ia=U;else{$=S;while(1){O=f[n+($<<2)>>2]|0;if((O|0)<($|0))$=O;else break}O=(U|0)>($|0)?$:U;Q=S;do{V=n+(Q<<2)|0;M=Q;Q=f[V>>2]|0;f[V>>2]=O}while((Q|0)<(M|0));ia=O}O=P;do{Q=n+(O<<2)|0;S=O;O=f[Q>>2]|0;f[Q>>2]=ia}while((O|0)<(S|0));f[z+(E<<2)>>2]=ia;L=F;break a}if(!(b[y+I>>0]|0)){O=f[t+(T<<2)>>2]|0;P=f[z+(N<<2)>>2]|0;S=O;while(1){Q=f[n+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}if((O|0)==(P|0))ja=S;else{Q=P;while(1){U=f[n+(Q<<2)>>2]|0;if((U|0)<(Q|0))Q=U;else break}U=(S|0)>(Q|0)?Q:S;$=P;do{M=n+($<<2)|0;V=$;$=f[M>>2]|0;f[M>>2]=U}while(($|0)<(V|0));ja=U}U=O;do{$=n+(U<<2)|0;P=U;U=f[$>>2]|0;f[$>>2]=ja}while((U|0)<(P|0));f[z+(E<<2)>>2]=ja;L=F;break a}U=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}O=f[t+(T<<2)>>2]|0;P=O;while(1){$=f[n+(P<<2)>>2]|0;if(($|0)<(P|0))P=$;else break}if((O|0)==(U|0))ka=P;else{$=U;while(1){S=f[n+($<<2)>>2]|0;if((S|0)<($|0))$=S;else break}S=(P|0)>($|0)?$:P;Q=U;do{V=n+(Q<<2)|0;M=Q;Q=f[V>>2]|0;f[V>>2]=S}while((Q|0)<(M|0));ka=S}S=O;do{Q=n+(S<<2)|0;U=S;S=f[Q>>2]|0;f[Q>>2]=ka}while((S|0)<(U|0));f[z+(E<<2)>>2]=ka;L=F;break a}while(0);S=f[t+(T<<2)>>2]|0;O=f[z+(N<<2)>>2]|0;U=S;while(1){Q=f[n+(U<<2)>>2]|0;if((Q|0)<(U|0))U=Q;else break}if((S|0)==(O|0))la=U;else{N=O;while(1){Q=f[n+(N<<2)>>2]|0;if((Q|0)<(N|0))N=Q;else break}Q=(U|0)>(N|0)?N:U;P=O;do{$=n+(P<<2)|0;M=P;P=f[$>>2]|0;f[$>>2]=Q}while((P|0)<(M|0));la=Q}Q=S;do{P=n+(Q<<2)|0;O=Q;Q=f[P>>2]|0;f[P>>2]=la}while((Q|0)<(O|0));f[z+(E<<2)>>2]=la;L=F;break a}while(0);Q=E+-2|0;if(!(b[x+E>>0]|0)){S=f[t+(T<<2)>>2]|0;O=f[z+(Q<<2)>>2]|0;P=S;while(1){U=f[n+(P<<2)>>2]|0;if((U|0)<(P|0))P=U;else break}if((S|0)==(O|0))ma=P;else{U=O;while(1){N=f[n+(U<<2)>>2]|0;if((N|0)<(U|0))U=N;else break}N=(P|0)>(U|0)?U:P;M=O;do{$=n+(M<<2)|0;V=M;M=f[$>>2]|0;f[$>>2]=N}while((M|0)<(V|0));ma=N}N=S;do{M=n+(N<<2)|0;O=N;N=f[M>>2]|0;f[M>>2]=ma}while((N|0)<(O|0));f[z+(E<<2)>>2]=ma;L=F;break a}do if((Q|0)>-1){if(!(b[v+Q>>0]|0))break;if(b[x+I>>0]|0){N=f[t+(T<<2)>>2]|0;S=f[z+(Q<<2)>>2]|0;O=N;while(1){M=f[n+(O<<2)>>2]|0;if((M|0)<(O|0))O=M;else break}if((N|0)==(S|0))na=O;else{M=S;while(1){P=f[n+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}P=(O|0)>(M|0)?M:O;U=S;do{V=n+(U<<2)|0;$=U;U=f[V>>2]|0;f[V>>2]=P}while((U|0)<($|0));na=P}P=N;do{U=n+(P<<2)|0;S=P;P=f[U>>2]|0;f[U>>2]=na}while((P|0)<(S|0));f[z+(E<<2)>>2]=na;L=F;break a}if(!(b[x+Q>>0]|0)){P=f[t+(E<<2)>>2]|0;N=f[t+(T<<2)>>2]|0;S=P;while(1){U=f[n+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((P|0)==(N|0))oa=S;else{U=N;while(1){O=f[n+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(S|0)>(U|0)?U:S;M=N;do{$=n+(M<<2)|0;V=M;M=f[$>>2]|0;f[$>>2]=O}while((M|0)<(V|0));oa=O}O=P;do{M=n+(O<<2)|0;N=O;O=f[M>>2]|0;f[M>>2]=oa}while((O|0)<(N|0));O=f[z+(Q<<2)>>2]|0;P=oa;while(1){N=f[n+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}if((oa|0)==(O|0))pa=P;else{N=O;while(1){M=f[n+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}M=(P|0)>(N|0)?N:P;S=O;do{U=n+(S<<2)|0;V=S;S=f[U>>2]|0;f[U>>2]=M}while((S|0)<(V|0));pa=M}M=oa;do{S=n+(M<<2)|0;O=M;M=f[S>>2]|0;f[S>>2]=pa}while((M|0)<(O|0));f[z+(E<<2)>>2]=pa;L=F;break a}do if(D){if(!(b[y+I>>0]|0))break;M=f[t+(T<<2)>>2]|0;O=f[z+(Q<<2)>>2]|0;S=M;while(1){P=f[n+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}if((M|0)==(O|0))qa=S;else{P=O;while(1){N=f[n+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(S|0)>(P|0)?P:S;V=O;do{U=n+(V<<2)|0;$=V;V=f[U>>2]|0;f[U>>2]=N}while((V|0)<($|0));qa=N}N=M;do{V=n+(N<<2)|0;O=N;N=f[V>>2]|0;f[V>>2]=qa}while((N|0)<(O|0));f[z+(E<<2)>>2]=qa;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;M=f[t+(T<<2)>>2]|0;O=N;while(1){V=f[n+(O<<2)>>2]|0;if((V|0)<(O|0))O=V;else break}if((N|0)==(M|0))ra=O;else{V=M;while(1){S=f[n+(V<<2)>>2]|0;if((S|0)<(V|0))V=S;else break}S=(O|0)>(V|0)?V:O;P=M;do{$=n+(P<<2)|0;U=P;P=f[$>>2]|0;f[$>>2]=S}while((P|0)<(U|0));ra=S}S=N;do{P=n+(S<<2)|0;M=S;S=f[P>>2]|0;f[P>>2]=ra}while((S|0)<(M|0));S=f[z+(Q<<2)>>2]|0;N=ra;while(1){M=f[n+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}if((ra|0)==(S|0))sa=N;else{M=S;while(1){P=f[n+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}P=(N|0)>(M|0)?M:N;O=S;do{V=n+(O<<2)|0;U=O;O=f[V>>2]|0;f[V>>2]=P}while((O|0)<(U|0));sa=P}P=ra;do{O=n+(P<<2)|0;S=P;P=f[O>>2]|0;f[O>>2]=sa}while((P|0)<(S|0));f[z+(E<<2)>>2]=sa;L=F;break a}while(0);P=f[t+(E<<2)>>2]|0;S=f[t+(T<<2)>>2]|0;O=P;while(1){N=f[n+(O<<2)>>2]|0;if((N|0)<(O|0))O=N;else break}if((P|0)==(S|0))ta=O;else{N=S;while(1){M=f[n+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}M=(O|0)>(N|0)?N:O;U=S;do{V=n+(U<<2)|0;$=U;U=f[V>>2]|0;f[V>>2]=M}while((U|0)<($|0));ta=M}M=P;do{U=n+(M<<2)|0;S=M;M=f[U>>2]|0;f[U>>2]=ta}while((M|0)<(S|0));M=f[z+(Q<<2)>>2]|0;P=ta;while(1){S=f[n+(P<<2)>>2]|0;if((S|0)<(P|0))P=S;else break}if((ta|0)==(M|0))ua=P;else{Q=M;while(1){S=f[n+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}S=(P|0)>(Q|0)?Q:P;U=M;do{O=n+(U<<2)|0;N=U;U=f[O>>2]|0;f[O>>2]=S}while((U|0)<(N|0));ua=S}S=ta;do{U=n+(S<<2)|0;M=S;S=f[U>>2]|0;f[U>>2]=ua}while((S|0)<(M|0));f[z+(E<<2)>>2]=ua;L=F;break a}while(0);T=E+-2|0;if(!(b[x+E>>0]|0)){va=T;break}do if((T|0)>-1){if(!(b[v+T>>0]|0))break;if(b[x+I>>0]|0){f[z+(E<<2)>>2]=f[z+(T<<2)>>2];L=F;break a}if(!(b[x+T>>0]|0)){S=f[t+(E<<2)>>2]|0;M=f[z+(T<<2)>>2]|0;U=S;while(1){P=f[n+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((S|0)==(M|0))wa=U;else{P=M;while(1){Q=f[n+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(U|0)>(P|0)?P:U;N=M;do{O=n+(N<<2)|0;$=N;N=f[O>>2]|0;f[O>>2]=Q}while((N|0)<($|0));wa=Q}Q=S;do{N=n+(Q<<2)|0;M=Q;Q=f[N>>2]|0;f[N>>2]=wa}while((Q|0)<(M|0));f[z+(E<<2)>>2]=wa;L=F;break a}do if(D){if(!(b[y+I>>0]|0))break;f[z+(E<<2)>>2]=f[z+(T<<2)>>2];L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;S=f[z+(T<<2)>>2]|0;M=Q;while(1){N=f[n+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}if((Q|0)==(S|0))xa=M;else{N=S;while(1){U=f[n+(N<<2)>>2]|0;if((U|0)<(N|0))N=U;else break}U=(M|0)>(N|0)?N:M;P=S;do{$=n+(P<<2)|0;O=P;P=f[$>>2]|0;f[$>>2]=U}while((P|0)<(O|0));xa=U}U=Q;do{P=n+(U<<2)|0;S=U;U=f[P>>2]|0;f[P>>2]=xa}while((U|0)<(S|0));f[z+(E<<2)>>2]=xa;L=F;break a}while(0);U=f[t+(E<<2)>>2]|0;Q=f[z+(T<<2)>>2]|0;S=U;while(1){P=f[n+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}if((U|0)==(Q|0))ya=S;else{T=Q;while(1){P=f[n+(T<<2)>>2]|0;if((P|0)<(T|0))T=P;else break}P=(S|0)>(T|0)?T:S;M=Q;do{N=n+(M<<2)|0;O=M;M=f[N>>2]|0;f[N>>2]=P}while((M|0)<(O|0));ya=P}P=U;do{M=n+(P<<2)|0;Q=P;P=f[M>>2]|0;f[M>>2]=ya}while((P|0)<(Q|0));f[z+(E<<2)>>2]=ya;L=F;break a}else va=E+-2|0;while(0);f[z+(E<<2)>>2]=f[z+(va<<2)>>2];L=F;break a}while(0);do if(B){if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}P=E+2|0;do if(!((P|0)>=(i|0)|C)){if(!(b[x+P>>0]|0))break;if(!(b[x+E>>0]|0)){f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}while(0);U=f[t+(E<<2)>>2]|0;Q=f[t+(P<<2)>>2]|0;M=U;while(1){S=f[n+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((U|0)==(Q|0))za=M;else{S=Q;while(1){T=f[n+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}T=(M|0)>(S|0)?S:M;O=Q;do{N=n+(O<<2)|0;$=O;O=f[N>>2]|0;f[N>>2]=T}while((O|0)<($|0));za=T}T=U;do{O=n+(T<<2)|0;Q=T;T=f[O>>2]|0;f[O>>2]=za}while((T|0)<(Q|0));f[z+(E<<2)>>2]=za;L=F;break a}while(0);if(!(b[x+E>>0]|0))break;f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}while(0);f[z+(E<<2)>>2]=F;f[n+(F<<2)>>2]=F;L=F+1|0;break}if(K){if(b[w+I>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}if(b[v+I>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}}f[z+(E<<2)>>2]=F;f[n+(F<<2)>>2]=F;L=F+1|0;break}do if(H){if(!(b[v+G>>0]|0)){if(!A)break;if(!(b[w+G>>0]|0))break;f[z+(E<<2)>>2]=F;f[n+(F<<2)>>2]=F;L=F+1|0;break a}if(B){if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}P=E+2|0;do if(!((P|0)>=(i|0)|C)){if(!(b[x+P>>0]|0))break;if(!(b[x+E>>0]|0)){f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[t+(P<<2)>>2];L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;U=f[t+(P<<2)>>2]|0;Q=T;while(1){O=f[n+(Q<<2)>>2]|0;if((O|0)<(Q|0))Q=O;else break}if((T|0)==(U|0))Aa=Q;else{O=U;while(1){M=f[n+(O<<2)>>2]|0;if((M|0)<(O|0))O=M;else break}M=(Q|0)>(O|0)?O:Q;S=U;do{$=n+(S<<2)|0;N=S;S=f[$>>2]|0;f[$>>2]=M}while((S|0)<(N|0));Aa=M}M=T;do{S=n+(M<<2)|0;U=M;M=f[S>>2]|0;f[S>>2]=Aa}while((M|0)<(U|0));f[z+(E<<2)>>2]=Aa;L=F;break a}while(0);if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break a}}f[z+(E<<2)>>2]=F;f[n+(F<<2)>>2]=F;L=F+1|0;break a}while(0);f[z+(E<<2)>>2]=0;L=F}else{G=E+-1|0;H=(E|0)>0;if(H){if(b[v+G>>0]|0){I=E|1;K=(I|0)<(i|0);if(B&K?b[x+I>>0]|0:0){if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}do if(D){if(!(b[y+E>>0]|0))break;P=E+-2|0;if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}do if((P|0)>-1){if(!(b[x+P>>0]|0))break;if(b[y+G>>0]|0){f[z+(E<<2)>>2]=f[z+(P<<2)>>2];L=F;break a}M=f[t+(E<<2)>>2]|0;T=f[z+(P<<2)>>2]|0;U=M;while(1){S=f[n+(U<<2)>>2]|0;if((S|0)<(U|0))U=S;else break}if((M|0)==(T|0))Ba=U;else{S=T;while(1){Q=f[n+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(U|0)>(S|0)?S:U;O=T;do{N=n+(O<<2)|0;$=O;O=f[N>>2]|0;f[N>>2]=Q}while((O|0)<($|0));Ba=Q}Q=M;do{O=n+(Q<<2)|0;T=Q;Q=f[O>>2]|0;f[O>>2]=Ba}while((Q|0)<(T|0));f[z+(E<<2)>>2]=Ba;L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;T=Q;while(1){O=f[n+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}if((Q|0)==(M|0))Ca=T;else{P=M;while(1){O=f[n+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(T|0)>(P|0)?P:T;U=M;do{S=n+(U<<2)|0;$=U;U=f[S>>2]|0;f[S>>2]=O}while((U|0)<($|0));Ca=O}O=Q;do{U=n+(O<<2)|0;M=O;O=f[U>>2]|0;f[U>>2]=Ca}while((O|0)<(M|0));f[z+(E<<2)>>2]=Ca;L=F;break a}while(0);O=f[t+(E<<2)>>2]|0;Q=f[z+(E+-2<<2)>>2]|0;M=O;while(1){U=f[n+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}if((O|0)==(Q|0))Da=M;else{U=Q;while(1){T=f[n+(U<<2)>>2]|0;if((T|0)<(U|0))U=T;else break}T=(M|0)>(U|0)?U:M;P=Q;do{$=n+(P<<2)|0;S=P;P=f[$>>2]|0;f[$>>2]=T}while((P|0)<(S|0));Da=T}T=O;do{P=n+(T<<2)|0;Q=T;T=f[P>>2]|0;f[P>>2]=Da}while((T|0)<(Q|0));f[z+(E<<2)>>2]=Da;L=F;break}if(K?b[v+I>>0]|0:0){T=E+2|0;do if(B&(T|0)<(i|0)){if(!(b[x+T>>0]|0))break;do if(D){if(!(b[y+I>>0]|0))break;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break a}if(!(b[y+E>>0]|0)){O=f[t+(T<<2)>>2]|0;Q=f[z+(E+-2<<2)>>2]|0;P=O;while(1){M=f[n+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((O|0)==(Q|0))Ea=P;else{M=Q;while(1){U=f[n+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}U=(P|0)>(M|0)?M:P;S=Q;do{$=n+(S<<2)|0;N=S;S=f[$>>2]|0;f[$>>2]=U}while((S|0)<(N|0));Ea=U}U=O;do{S=n+(U<<2)|0;Q=U;U=f[S>>2]|0;f[S>>2]=Ea}while((U|0)<(Q|0));f[z+(E<<2)>>2]=Ea;L=F;break a}U=E+-2|0;if(b[x+G>>0]|0){f[z+(E<<2)>>2]=f[z+(U<<2)>>2];L=F;break a}do if((U|0)>-1){if(!(b[x+U>>0]|0))break;if(b[y+G>>0]|0){f[z+(E<<2)>>2]=f[z+(U<<2)>>2];L=F;break a}O=f[t+(T<<2)>>2]|0;Q=f[z+(U<<2)>>2]|0;S=O;while(1){P=f[n+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}if((O|0)==(Q|0))Fa=S;else{P=Q;while(1){M=f[n+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}M=(S|0)>(P|0)?P:S;N=Q;do{$=n+(N<<2)|0;V=N;N=f[$>>2]|0;f[$>>2]=M}while((N|0)<(V|0));Fa=M}M=O;do{N=n+(M<<2)|0;Q=M;M=f[N>>2]|0;f[N>>2]=Fa}while((M|0)<(Q|0));f[z+(E<<2)>>2]=Fa;L=F;break a}while(0);M=f[t+(T<<2)>>2]|0;O=f[z+(U<<2)>>2]|0;Q=M;while(1){N=f[n+(Q<<2)>>2]|0;if((N|0)<(Q|0))Q=N;else break}if((M|0)==(O|0))Ga=Q;else{U=O;while(1){N=f[n+(U<<2)>>2]|0;if((N|0)<(U|0))U=N;else break}N=(Q|0)>(U|0)?U:Q;S=O;do{P=n+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=N}while((S|0)<(V|0));Ga=N}N=M;do{S=n+(N<<2)|0;O=N;N=f[S>>2]|0;f[S>>2]=Ga}while((N|0)<(O|0));f[z+(E<<2)>>2]=Ga;L=F;break a}while(0);N=f[t+(T<<2)>>2]|0;M=f[z+(E+-2<<2)>>2]|0;O=N;while(1){S=f[n+(O<<2)>>2]|0;if((S|0)<(O|0))O=S;else break}if((N|0)==(M|0))Ha=O;else{S=M;while(1){Q=f[n+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(O|0)>(S|0)?S:O;U=M;do{V=n+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=Q}while((U|0)<(P|0));Ha=Q}Q=N;do{U=n+(Q<<2)|0;M=Q;Q=f[U>>2]|0;f[U>>2]=Ha}while((Q|0)<(M|0));f[z+(E<<2)>>2]=Ha;L=F;break a}while(0);f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}f[z+(E<<2)>>2]=f[z+(E+-2<<2)>>2];L=F;break}if(A?b[w+G>>0]|0:0){T=E|1;I=(T|0)<(i|0);if(!(C|I^1)?b[x+T>>0]|0:0){K=E+-2|0;do if((K|0)>-1){if(!(b[v+K>>0]|0))break;if(b[x+G>>0]|0){Q=f[z+(K<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=Q;L=F;break a}do if(D){if(!(b[y+E>>0]|0))break;f[z+(E<<2)>>2]=Q;L=F;break a}while(0);N=f[t+(E<<2)>>2]|0;M=N;while(1){U=f[n+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}if((N|0)==(Q|0))Ia=M;else{U=Q;while(1){O=f[n+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(M|0)>(U|0)?U:M;S=Q;do{P=n+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=O}while((S|0)<(V|0));Ia=O}O=N;do{S=n+(O<<2)|0;Q=O;O=f[S>>2]|0;f[S>>2]=Ia}while((O|0)<(Q|0));f[z+(E<<2)>>2]=Ia;L=F;break a}if(!(b[x+K>>0]|0)){O=f[t+(E<<2)>>2]|0;N=f[z+(K<<2)>>2]|0;Q=O;while(1){S=f[n+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}if((O|0)==(N|0))Ja=Q;else{S=N;while(1){M=f[n+(S<<2)>>2]|0;if((M|0)<(S|0))S=M;else break}M=(Q|0)>(S|0)?S:Q;U=N;do{V=n+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=M}while((U|0)<(P|0));Ja=M}M=O;do{U=n+(M<<2)|0;N=M;M=f[U>>2]|0;f[U>>2]=Ja}while((M|0)<(N|0));f[z+(E<<2)>>2]=Ja;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;M=f[z+(K<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=M;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=M;L=F;break a}O=f[t+(E<<2)>>2]|0;N=O;while(1){U=f[n+(N<<2)>>2]|0;if((U|0)<(N|0))N=U;else break}if((O|0)==(M|0))Ka=N;else{U=M;while(1){Q=f[n+(U<<2)>>2]|0;if((Q|0)<(U|0))U=Q;else break}Q=(N|0)>(U|0)?U:N;S=M;do{P=n+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=Q}while((S|0)<(V|0));Ka=Q}Q=O;do{S=n+(Q<<2)|0;M=Q;Q=f[S>>2]|0;f[S>>2]=Ka}while((Q|0)<(M|0));f[z+(E<<2)>>2]=Ka;L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;O=f[z+(K<<2)>>2]|0;M=Q;while(1){S=f[n+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((Q|0)==(O|0))La=M;else{S=O;while(1){N=f[n+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(M|0)>(S|0)?S:M;U=O;do{V=n+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=N}while((U|0)<(P|0));La=N}N=Q;do{U=n+(N<<2)|0;O=N;N=f[U>>2]|0;f[U>>2]=La}while((N|0)<(O|0));f[z+(E<<2)>>2]=La;L=F;break a}while(0);if(b[x+E>>0]|0){N=f[t+(E<<2)>>2]|0;Q=f[z+(K<<2)>>2]|0;O=N;while(1){U=f[n+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if((N|0)==(Q|0))Ma=O;else{U=Q;while(1){M=f[n+(U<<2)>>2]|0;if((M|0)<(U|0))U=M;else break}M=(O|0)>(U|0)?U:O;S=Q;do{P=n+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=M}while((S|0)<(V|0));Ma=M}M=N;do{S=n+(M<<2)|0;Q=M;M=f[S>>2]|0;f[S>>2]=Ma}while((M|0)<(Q|0));f[z+(E<<2)>>2]=Ma;L=F;break}M=f[t+(E<<2)>>2]|0;if(!(b[x+G>>0]|0)){N=f[z+(K<<2)>>2]|0;Q=M;while(1){S=f[n+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}if((M|0)==(N|0))Na=Q;else{S=N;while(1){O=f[n+(S<<2)>>2]|0;if((O|0)<(S|0))S=O;else break}O=(Q|0)>(S|0)?S:Q;U=N;do{V=n+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=O}while((U|0)<(P|0));Na=O}O=M;do{U=n+(O<<2)|0;N=O;O=f[U>>2]|0;f[U>>2]=Na}while((O|0)<(N|0));f[z+(E<<2)>>2]=Na;L=F;break}do if(D){if(!(b[y+E>>0]|0))break;O=f[z+(K<<2)>>2]|0;N=M;while(1){U=f[n+(N<<2)>>2]|0;if((U|0)<(N|0))N=U;else break}if((M|0)==(O|0))Oa=N;else{U=O;while(1){Q=f[n+(U<<2)>>2]|0;if((Q|0)<(U|0))U=Q;else break}Q=(N|0)>(U|0)?U:N;S=O;do{P=n+(S<<2)|0;V=S;S=f[P>>2]|0;f[P>>2]=Q}while((S|0)<(V|0));Oa=Q}Q=M;do{S=n+(Q<<2)|0;O=Q;Q=f[S>>2]|0;f[S>>2]=Oa}while((Q|0)<(O|0));f[z+(E<<2)>>2]=Oa;L=F;break a}while(0);Q=f[t+(K<<2)>>2]|0;O=Q;while(1){S=f[n+(O<<2)>>2]|0;if((S|0)<(O|0))O=S;else break}if((Q|0)==(M|0))Pa=O;else{S=M;while(1){N=f[n+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(O|0)>(S|0)?S:O;U=M;do{V=n+(U<<2)|0;P=U;U=f[V>>2]|0;f[V>>2]=N}while((U|0)<(P|0));Pa=N}N=Q;do{U=n+(N<<2)|0;M=N;N=f[U>>2]|0;f[U>>2]=Pa}while((N|0)<(M|0));N=f[z+(K<<2)>>2]|0;Q=Pa;while(1){M=f[n+(Q<<2)>>2]|0;if((M|0)<(Q|0))Q=M;else break}if((Pa|0)==(N|0))Qa=Q;else{K=N;while(1){M=f[n+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(Q|0)>(K|0)?K:Q;U=N;do{O=n+(U<<2)|0;S=U;U=f[O>>2]|0;f[O>>2]=M}while((U|0)<(S|0));Qa=M}M=Pa;do{U=n+(M<<2)|0;N=M;M=f[U>>2]|0;f[U>>2]=Qa}while((M|0)<(N|0));f[z+(E<<2)>>2]=Qa;L=F;break}if(I?b[v+T>>0]|0:0){M=E+2|0;do if(!((M|0)>=(i|0)|C)){if(!(b[x+M>>0]|0))break;N=E+-2|0;do if((N|0)>-1){if(!(b[v+N>>0]|0))break;if(b[x+G>>0]|0){do if(D){if(!(b[y+T>>0]|0))break;U=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=U;L=F;break a}Q=f[t+(M<<2)>>2]|0;K=Q;while(1){S=f[n+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}if((Q|0)==(U|0))Ra=K;else{S=U;while(1){O=f[n+(S<<2)>>2]|0;if((O|0)<(S|0))S=O;else break}O=(K|0)>(S|0)?S:K;P=U;do{V=n+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=O}while((P|0)<($|0));Ra=O}O=Q;do{P=n+(O<<2)|0;U=O;O=f[P>>2]|0;f[P>>2]=Ra}while((O|0)<(U|0));f[z+(E<<2)>>2]=Ra;L=F;break a}while(0);O=f[t+(M<<2)>>2]|0;Q=f[z+(N<<2)>>2]|0;U=O;while(1){P=f[n+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((O|0)==(Q|0))Sa=U;else{P=Q;while(1){K=f[n+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(U|0)>(P|0)?P:U;S=Q;do{$=n+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=K}while((S|0)<(V|0));Sa=K}K=O;do{S=n+(K<<2)|0;Q=K;K=f[S>>2]|0;f[S>>2]=Sa}while((K|0)<(Q|0));f[z+(E<<2)>>2]=Sa;L=F;break a}do if(D){if(!(b[y+T>>0]|0))break;if(!(b[x+N>>0]|0)){K=f[t+(M<<2)>>2]|0;O=f[z+(N<<2)>>2]|0;Q=K;while(1){S=f[n+(Q<<2)>>2]|0;if((S|0)<(Q|0))Q=S;else break}if((K|0)==(O|0))Ta=Q;else{S=O;while(1){U=f[n+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}U=(Q|0)>(S|0)?S:Q;P=O;do{V=n+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=U}while((P|0)<($|0));Ta=U}U=K;do{P=n+(U<<2)|0;O=U;U=f[P>>2]|0;f[P>>2]=Ta}while((U|0)<(O|0));f[z+(E<<2)>>2]=Ta;L=F;break a}if(!(b[y+G>>0]|0)){U=f[t+(M<<2)>>2]|0;K=f[z+(N<<2)>>2]|0;O=U;while(1){P=f[n+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((U|0)==(K|0))Ua=O;else{P=K;while(1){Q=f[n+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(O|0)>(P|0)?P:O;S=K;do{$=n+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=Q}while((S|0)<(V|0));Ua=Q}Q=U;do{S=n+(Q<<2)|0;K=Q;Q=f[S>>2]|0;f[S>>2]=Ua}while((Q|0)<(K|0));f[z+(E<<2)>>2]=Ua;L=F;break a}Q=f[z+(N<<2)>>2]|0;if(b[x+E>>0]|0){f[z+(E<<2)>>2]=Q;L=F;break a}if(b[y+E>>0]|0){f[z+(E<<2)>>2]=Q;L=F;break a}U=f[t+(M<<2)>>2]|0;K=U;while(1){S=f[n+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}if((U|0)==(Q|0))Va=K;else{S=Q;while(1){O=f[n+(S<<2)>>2]|0;if((O|0)<(S|0))S=O;else break}O=(K|0)>(S|0)?S:K;P=Q;do{V=n+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=O}while((P|0)<($|0));Va=O}O=U;do{P=n+(O<<2)|0;Q=O;O=f[P>>2]|0;f[P>>2]=Va}while((O|0)<(Q|0));f[z+(E<<2)>>2]=Va;L=F;break a}while(0);if(!(b[x+E>>0]|0)){O=f[t+(M<<2)>>2]|0;U=f[z+(N<<2)>>2]|0;Q=O;while(1){P=f[n+(Q<<2)>>2]|0;if((P|0)<(Q|0))Q=P;else break}if((O|0)==(U|0))Wa=Q;else{P=U;while(1){K=f[n+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(Q|0)>(P|0)?P:Q;S=U;do{$=n+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=K}while((S|0)<(V|0));Wa=K}K=O;do{S=n+(K<<2)|0;U=K;K=f[S>>2]|0;f[S>>2]=Wa}while((K|0)<(U|0));f[z+(E<<2)>>2]=Wa;L=F;break a}if(!(b[x+N>>0]|0)){K=f[t+(E<<2)>>2]|0;O=f[t+(M<<2)>>2]|0;U=K;while(1){S=f[n+(U<<2)>>2]|0;if((S|0)<(U|0))U=S;else break}if((K|0)==(O|0))Xa=U;else{S=O;while(1){Q=f[n+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(U|0)>(S|0)?S:U;P=O;do{V=n+(P<<2)|0;$=P;P=f[V>>2]|0;f[V>>2]=Q}while((P|0)<($|0));Xa=Q}Q=K;do{P=n+(Q<<2)|0;O=Q;Q=f[P>>2]|0;f[P>>2]=Xa}while((Q|0)<(O|0));Q=f[z+(N<<2)>>2]|0;K=Xa;while(1){O=f[n+(K<<2)>>2]|0;if((O|0)<(K|0))K=O;else break}if((Xa|0)==(Q|0))Ya=K;else{O=Q;while(1){P=f[n+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}P=(K|0)>(O|0)?O:K;U=Q;do{S=n+(U<<2)|0;$=U;U=f[S>>2]|0;f[S>>2]=P}while((U|0)<($|0));Ya=P}P=Xa;do{U=n+(P<<2)|0;Q=P;P=f[U>>2]|0;f[U>>2]=Ya}while((P|0)<(Q|0));f[z+(E<<2)>>2]=Ya;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;P=f[t+(M<<2)>>2]|0;Q=f[z+(N<<2)>>2]|0;U=P;while(1){K=f[n+(U<<2)>>2]|0;if((K|0)<(U|0))U=K;else break}if((P|0)==(Q|0))Za=U;else{K=Q;while(1){O=f[n+(K<<2)>>2]|0;if((O|0)<(K|0))K=O;else break}O=(U|0)>(K|0)?K:U;$=Q;do{S=n+($<<2)|0;V=$;$=f[S>>2]|0;f[S>>2]=O}while(($|0)<(V|0));Za=O}O=P;do{$=n+(O<<2)|0;Q=O;O=f[$>>2]|0;f[$>>2]=Za}while((O|0)<(Q|0));f[z+(E<<2)>>2]=Za;L=F;break a}while(0);O=f[t+(E<<2)>>2]|0;P=f[t+(M<<2)>>2]|0;Q=O;while(1){$=f[n+(Q<<2)>>2]|0;if(($|0)<(Q|0))Q=$;else break}if((O|0)==(P|0))_a=Q;else{$=P;while(1){U=f[n+($<<2)>>2]|0;if((U|0)<($|0))$=U;else break}U=(Q|0)>($|0)?$:Q;K=P;do{V=n+(K<<2)|0;S=K;K=f[V>>2]|0;f[V>>2]=U}while((K|0)<(S|0));_a=U}U=O;do{K=n+(U<<2)|0;P=U;U=f[K>>2]|0;f[K>>2]=_a}while((U|0)<(P|0));U=f[z+(N<<2)>>2]|0;O=_a;while(1){P=f[n+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((_a|0)==(U|0))$a=O;else{P=U;while(1){K=f[n+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(O|0)>(P|0)?P:O;Q=U;do{$=n+(Q<<2)|0;S=Q;Q=f[$>>2]|0;f[$>>2]=K}while((Q|0)<(S|0));$a=K}K=_a;do{Q=n+(K<<2)|0;U=K;K=f[Q>>2]|0;f[Q>>2]=$a}while((K|0)<(U|0));f[z+(E<<2)>>2]=$a;L=F;break a}while(0);if(b[x+E>>0]|0){do if(D){if(!(b[y+T>>0]|0))break;K=f[t+(M<<2)>>2]|0;U=f[z+(N<<2)>>2]|0;Q=K;while(1){O=f[n+(Q<<2)>>2]|0;if((O|0)<(Q|0))Q=O;else break}if((K|0)==(U|0))ab=Q;else{O=U;while(1){P=f[n+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}P=(Q|0)>(O|0)?O:Q;S=U;do{$=n+(S<<2)|0;V=S;S=f[$>>2]|0;f[$>>2]=P}while((S|0)<(V|0));ab=P}P=K;do{S=n+(P<<2)|0;U=P;P=f[S>>2]|0;f[S>>2]=ab}while((P|0)<(U|0));f[z+(E<<2)>>2]=ab;L=F;break a}while(0);P=f[t+(E<<2)>>2]|0;K=f[t+(M<<2)>>2]|0;U=P;while(1){S=f[n+(U<<2)>>2]|0;if((S|0)<(U|0))U=S;else break}if((P|0)==(K|0))bb=U;else{S=K;while(1){Q=f[n+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(U|0)>(S|0)?S:U;O=K;do{V=n+(O<<2)|0;$=O;O=f[V>>2]|0;f[V>>2]=Q}while((O|0)<($|0));bb=Q}Q=P;do{O=n+(Q<<2)|0;K=Q;Q=f[O>>2]|0;f[O>>2]=bb}while((Q|0)<(K|0));Q=f[z+(N<<2)>>2]|0;P=bb;while(1){K=f[n+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}if((bb|0)==(Q|0))cb=P;else{K=Q;while(1){O=f[n+(K<<2)>>2]|0;if((O|0)<(K|0))K=O;else break}O=(P|0)>(K|0)?K:P;U=Q;do{S=n+(U<<2)|0;$=U;U=f[S>>2]|0;f[S>>2]=O}while((U|0)<($|0));cb=O}O=bb;do{U=n+(O<<2)|0;Q=O;O=f[U>>2]|0;f[U>>2]=cb}while((O|0)<(Q|0));f[z+(E<<2)>>2]=cb;L=F;break a}if(!(b[x+G>>0]|0)){O=f[t+(M<<2)>>2]|0;Q=f[z+(N<<2)>>2]|0;U=O;while(1){P=f[n+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((O|0)==(Q|0))db=U;else{P=Q;while(1){K=f[n+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(U|0)>(P|0)?P:U;$=Q;do{S=n+($<<2)|0;V=$;$=f[S>>2]|0;f[S>>2]=K}while(($|0)<(V|0));db=K}K=O;do{$=n+(K<<2)|0;Q=K;K=f[$>>2]|0;f[$>>2]=db}while((K|0)<(Q|0));f[z+(E<<2)>>2]=db;L=F;break a}do if(D){if(!(b[y+T>>0]|0))break;K=f[t+(M<<2)>>2]|0;if(b[y+E>>0]|0){O=f[z+(N<<2)>>2]|0;Q=K;while(1){$=f[n+(Q<<2)>>2]|0;if(($|0)<(Q|0))Q=$;else break}if((K|0)==(O|0))eb=Q;else{$=O;while(1){U=f[n+($<<2)>>2]|0;if((U|0)<($|0))$=U;else break}U=(Q|0)>($|0)?$:Q;P=O;do{V=n+(P<<2)|0;S=P;P=f[V>>2]|0;f[V>>2]=U}while((P|0)<(S|0));eb=U}U=K;do{P=n+(U<<2)|0;O=U;U=f[P>>2]|0;f[P>>2]=eb}while((U|0)<(O|0));f[z+(E<<2)>>2]=eb;L=F;break a}U=f[t+(N<<2)>>2]|0;O=U;while(1){P=f[n+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((U|0)==(K|0))fb=O;else{P=K;while(1){Q=f[n+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(O|0)>(P|0)?P:O;$=K;do{S=n+($<<2)|0;V=$;$=f[S>>2]|0;f[S>>2]=Q}while(($|0)<(V|0));fb=Q}Q=U;do{$=n+(Q<<2)|0;K=Q;Q=f[$>>2]|0;f[$>>2]=fb}while((Q|0)<(K|0));Q=f[z+(N<<2)>>2]|0;U=fb;while(1){K=f[n+(U<<2)>>2]|0;if((K|0)<(U|0))U=K;else break}if((fb|0)==(Q|0))gb=U;else{K=Q;while(1){$=f[n+(K<<2)>>2]|0;if(($|0)<(K|0))K=$;else break}$=(U|0)>(K|0)?K:U;O=Q;do{P=n+(O<<2)|0;V=O;O=f[P>>2]|0;f[P>>2]=$}while((O|0)<(V|0));gb=$}$=fb;do{O=n+($<<2)|0;Q=$;$=f[O>>2]|0;f[O>>2]=gb}while(($|0)<(Q|0));f[z+(E<<2)>>2]=gb;L=F;break a}while(0);$=f[t+(N<<2)>>2]|0;Q=f[t+(M<<2)>>2]|0;O=$;while(1){U=f[n+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if(($|0)==(Q|0))hb=O;else{U=Q;while(1){K=f[n+(U<<2)>>2]|0;if((K|0)<(U|0))U=K;else break}K=(O|0)>(U|0)?U:O;V=Q;do{P=n+(V<<2)|0;S=V;V=f[P>>2]|0;f[P>>2]=K}while((V|0)<(S|0));hb=K}K=$;do{V=n+(K<<2)|0;Q=K;K=f[V>>2]|0;f[V>>2]=hb}while((K|0)<(Q|0));K=f[z+(N<<2)>>2]|0;$=hb;while(1){Q=f[n+($<<2)>>2]|0;if((Q|0)<($|0))$=Q;else break}if((hb|0)==(K|0))ib=$;else{N=K;while(1){Q=f[n+(N<<2)>>2]|0;if((Q|0)<(N|0))N=Q;else break}Q=($|0)>(N|0)?N:$;V=K;do{O=n+(V<<2)|0;U=V;V=f[O>>2]|0;f[O>>2]=Q}while((V|0)<(U|0));ib=Q}Q=hb;do{V=n+(Q<<2)|0;K=Q;Q=f[V>>2]|0;f[V>>2]=ib}while((Q|0)<(K|0));f[z+(E<<2)>>2]=ib;L=F;break a}while(0);do if(B){M=E+-2|0;if(b[x+G>>0]|0){T=f[z+(M<<2)>>2]|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;f[z+(E<<2)>>2]=T;L=F;break a}while(0);I=f[t+(M<<2)>>2]|0;Q=I;while(1){K=f[n+(Q<<2)>>2]|0;if((K|0)<(Q|0))Q=K;else break}if((I|0)==(T|0))jb=Q;else{K=T;while(1){V=f[n+(K<<2)>>2]|0;if((V|0)<(K|0))K=V;else break}V=(Q|0)>(K|0)?K:Q;$=T;do{N=n+($<<2)|0;U=$;$=f[N>>2]|0;f[N>>2]=V}while(($|0)<(U|0));jb=V}V=I;do{$=n+(V<<2)|0;T=V;V=f[$>>2]|0;f[$>>2]=jb}while((V|0)<(T|0));f[z+(E<<2)>>2]=jb;L=F;break a}if(!(b[x+E>>0]|0)){kb=M;break}do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(!(b[x+M>>0]|0)){V=f[t+(E<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;T=V;while(1){$=f[n+(T<<2)>>2]|0;if(($|0)<(T|0))T=$;else break}if((V|0)==(I|0))lb=T;else{$=I;while(1){Q=f[n+($<<2)>>2]|0;if((Q|0)<($|0))$=Q;else break}Q=(T|0)>($|0)?$:T;K=I;do{U=n+(K<<2)|0;N=K;K=f[U>>2]|0;f[U>>2]=Q}while((K|0)<(N|0));lb=Q}Q=V;do{K=n+(Q<<2)|0;I=Q;Q=f[K>>2]|0;f[K>>2]=lb}while((Q|0)<(I|0));f[z+(E<<2)>>2]=lb;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[z+(M<<2)>>2];L=F;break a}while(0);Q=f[t+(E<<2)>>2]|0;V=f[z+(M<<2)>>2]|0;I=Q;while(1){K=f[n+(I<<2)>>2]|0;if((K|0)<(I|0))I=K;else break}if((Q|0)==(V|0))mb=I;else{K=V;while(1){T=f[n+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}T=(I|0)>(K|0)?K:I;$=V;do{N=n+($<<2)|0;U=$;$=f[N>>2]|0;f[N>>2]=T}while(($|0)<(U|0));mb=T}T=Q;do{$=n+(T<<2)|0;V=T;T=f[$>>2]|0;f[$>>2]=mb}while((T|0)<(V|0));f[z+(E<<2)>>2]=mb;L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;Q=f[z+(M<<2)>>2]|0;V=T;while(1){$=f[n+(V<<2)>>2]|0;if(($|0)<(V|0))V=$;else break}if((T|0)==(Q|0))nb=V;else{M=Q;while(1){$=f[n+(M<<2)>>2]|0;if(($|0)<(M|0))M=$;else break}$=(V|0)>(M|0)?M:V;I=Q;do{K=n+(I<<2)|0;U=I;I=f[K>>2]|0;f[K>>2]=$}while((I|0)<(U|0));nb=$}$=T;do{I=n+($<<2)|0;Q=$;$=f[I>>2]|0;f[I>>2]=nb}while(($|0)<(Q|0));f[z+(E<<2)>>2]=nb;L=F;break a}else kb=E+-2|0;while(0);f[z+(E<<2)>>2]=f[z+(kb<<2)>>2];L=F;break}do if(B){$=E+-2|0;if(b[x+G>>0]|0){T=f[z+($<<2)>>2]|0;do if(($|0)>-1){if(!(b[v+$>>0]|0))break;f[z+(E<<2)>>2]=T;L=F;break a}while(0);Q=f[t+($<<2)>>2]|0;I=Q;while(1){V=f[n+(I<<2)>>2]|0;if((V|0)<(I|0))I=V;else break}if((Q|0)==(T|0))ob=I;else{V=T;while(1){M=f[n+(V<<2)>>2]|0;if((M|0)<(V|0))V=M;else break}M=(I|0)>(V|0)?V:I;U=T;do{K=n+(U<<2)|0;N=U;U=f[K>>2]|0;f[K>>2]=M}while((U|0)<(N|0));ob=M}M=Q;do{U=n+(M<<2)|0;T=M;M=f[U>>2]|0;f[U>>2]=ob}while((M|0)<(T|0));f[z+(E<<2)>>2]=ob;L=F;break a}if(!(b[x+E>>0]|0)){pb=$;break}do if(($|0)>-1){if(!(b[v+$>>0]|0))break;if(!(b[x+$>>0]|0)){M=f[t+(E<<2)>>2]|0;Q=f[z+($<<2)>>2]|0;T=M;while(1){U=f[n+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}if((M|0)==(Q|0))qb=T;else{U=Q;while(1){I=f[n+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}I=(T|0)>(U|0)?U:T;V=Q;do{N=n+(V<<2)|0;K=V;V=f[N>>2]|0;f[N>>2]=I}while((V|0)<(K|0));qb=I}I=M;do{V=n+(I<<2)|0;Q=I;I=f[V>>2]|0;f[V>>2]=qb}while((I|0)<(Q|0));f[z+(E<<2)>>2]=qb;L=F;break a}do if(D){if(!(b[y+G>>0]|0))break;f[z+(E<<2)>>2]=f[z+($<<2)>>2];L=F;break a}while(0);I=f[t+(E<<2)>>2]|0;M=f[z+($<<2)>>2]|0;Q=I;while(1){V=f[n+(Q<<2)>>2]|0;if((V|0)<(Q|0))Q=V;else break}if((I|0)==(M|0))rb=Q;else{V=M;while(1){T=f[n+(V<<2)>>2]|0;if((T|0)<(V|0))V=T;else break}T=(Q|0)>(V|0)?V:Q;U=M;do{K=n+(U<<2)|0;N=U;U=f[K>>2]|0;f[K>>2]=T}while((U|0)<(N|0));rb=T}T=I;do{U=n+(T<<2)|0;M=T;T=f[U>>2]|0;f[U>>2]=rb}while((T|0)<(M|0));f[z+(E<<2)>>2]=rb;L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;I=f[z+($<<2)>>2]|0;M=T;while(1){U=f[n+(M<<2)>>2]|0;if((U|0)<(M|0))M=U;else break}if((T|0)==(I|0))sb=M;else{$=I;while(1){U=f[n+($<<2)>>2]|0;if((U|0)<($|0))$=U;else break}U=(M|0)>($|0)?$:M;Q=I;do{V=n+(Q<<2)|0;N=Q;Q=f[V>>2]|0;f[V>>2]=U}while((Q|0)<(N|0));sb=U}U=T;do{Q=n+(U<<2)|0;I=U;U=f[Q>>2]|0;f[Q>>2]=sb}while((U|0)<(I|0));f[z+(E<<2)>>2]=sb;L=F;break a}else pb=E+-2|0;while(0);f[z+(E<<2)>>2]=f[z+(pb<<2)>>2];L=F;break}}U=E|1;T=(U|0)<(i|0);if(!(C|T^1)?b[x+U>>0]|0:0){if(b[x+E>>0]|0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}if(H?b[x+G>>0]|0:0){I=f[t+(E<<2)>>2]|0;do if(D){if(!(b[y+E>>0]|0))break;f[z+(E<<2)>>2]=I;L=F;break a}while(0);Q=f[t+(E+-2<<2)>>2]|0;M=Q;while(1){$=f[n+(M<<2)>>2]|0;if(($|0)<(M|0))M=$;else break}if((Q|0)==(I|0))tb=M;else{$=I;while(1){N=f[n+($<<2)>>2]|0;if((N|0)<($|0))$=N;else break}N=(M|0)>($|0)?$:M;V=I;do{K=n+(V<<2)|0;O=V;V=f[K>>2]|0;f[K>>2]=N}while((V|0)<(O|0));tb=N}N=Q;do{V=n+(N<<2)|0;I=N;N=f[V>>2]|0;f[V>>2]=tb}while((N|0)<(I|0));f[z+(E<<2)>>2]=tb;L=F;break}f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}if(T?b[v+U>>0]|0:0){N=E+2|0;if(!((N|0)>=(i|0)|C)?b[x+N>>0]|0:0){if(b[x+E>>0]|0){do if(D){if(!(b[y+U>>0]|0))break;f[z+(E<<2)>>2]=f[t+(N<<2)>>2];L=F;break a}while(0);T=f[t+(E<<2)>>2]|0;Q=f[t+(N<<2)>>2]|0;I=T;while(1){V=f[n+(I<<2)>>2]|0;if((V|0)<(I|0))I=V;else break}if((T|0)==(Q|0))ub=I;else{V=Q;while(1){M=f[n+(V<<2)>>2]|0;if((M|0)<(V|0))V=M;else break}M=(I|0)>(V|0)?V:I;$=Q;do{O=n+($<<2)|0;K=$;$=f[O>>2]|0;f[O>>2]=M}while(($|0)<(K|0));ub=M}M=T;do{$=n+(M<<2)|0;Q=M;M=f[$>>2]|0;f[$>>2]=ub}while((M|0)<(Q|0));f[z+(E<<2)>>2]=ub;L=F;break}do if(H){if(!(b[x+G>>0]|0))break;do if(D){if(!(b[y+U>>0]|0))break;M=f[t+(N<<2)>>2]|0;if(b[y+E>>0]|0){f[z+(E<<2)>>2]=M;L=F;break a}T=f[t+(E+-2<<2)>>2]|0;Q=T;while(1){$=f[n+(Q<<2)>>2]|0;if(($|0)<(Q|0))Q=$;else break}if((T|0)==(M|0))vb=Q;else{$=M;while(1){I=f[n+($<<2)>>2]|0;if((I|0)<($|0))$=I;else break}I=(Q|0)>($|0)?$:Q;V=M;do{K=n+(V<<2)|0;O=V;V=f[K>>2]|0;f[K>>2]=I}while((V|0)<(O|0));vb=I}I=T;do{V=n+(I<<2)|0;M=I;I=f[V>>2]|0;f[V>>2]=vb}while((I|0)<(M|0));f[z+(E<<2)>>2]=vb;L=F;break a}while(0);I=f[t+(E+-2<<2)>>2]|0;T=f[t+(N<<2)>>2]|0;M=I;while(1){V=f[n+(M<<2)>>2]|0;if((V|0)<(M|0))M=V;else break}if((I|0)==(T|0))wb=M;else{V=T;while(1){Q=f[n+(V<<2)>>2]|0;if((Q|0)<(V|0))V=Q;else break}Q=(M|0)>(V|0)?V:M;$=T;do{O=n+($<<2)|0;K=$;$=f[O>>2]|0;f[O>>2]=Q}while(($|0)<(K|0));wb=Q}Q=I;do{$=n+(Q<<2)|0;T=Q;Q=f[$>>2]|0;f[$>>2]=wb}while((Q|0)<(T|0));f[z+(E<<2)>>2]=wb;L=F;break a}while(0);f[z+(E<<2)>>2]=f[t+(N<<2)>>2];L=F;break}if(B?b[x+E>>0]|0:0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}do if(!(C|H^1)){if(!(b[x+G>>0]|0))break;f[z+(E<<2)>>2]=f[t+(E+-2<<2)>>2];L=F;break a}while(0);f[z+(E<<2)>>2]=F;f[n+(F<<2)>>2]=F;L=F+1|0;break}if(B?b[x+E>>0]|0:0){f[z+(E<<2)>>2]=f[t+(E<<2)>>2];L=F;break}if(!(C|H^1)?b[x+G>>0]|0:0){f[z+(E<<2)>>2]=f[t+(E+-2<<2)>>2];L=F;break}f[z+(E<<2)>>2]=F;f[n+(F<<2)>>2]=F;L=F+1|0}while(0);E=E+2|0;if((E|0)>=(i|0)){xb=L;break}else F=L}}else xb=r;s=s+2|0;if((s|0)>=(h|0))break;else r=xb}if((xb|0)>1){r=1;h=1;while(1){s=n+(h<<2)|0;L=f[s>>2]|0;if((L|0)<(h|0)){f[s>>2]=f[n+(L<<2)>>2];yb=r}else{f[s>>2]=r;yb=r+1|0}h=h+1|0;if((h|0)==(xb|0)){zb=yb;break}else r=yb}}else zb=1}else zb=1;l4(g,zb);yb=f[j>>2]|0;r=f[o>>2]|0;xb=(r&1|0)!=0;h=(yb|0)>0;b:do if(!(yb&1)){if(!xb){if(!h)break;s=c+16|0;L=c+44|0;i=d+16|0;wb=d+44|0;vb=g+20|0;ub=g+120|0;tb=g+48|0;pb=0;sb=r;rb=yb;while(1){qb=f[f[L>>2]>>2]|0;ob=(f[s>>2]|0)+(Y(qb,pb)|0)|0;kb=ob+qb|0;qb=f[f[wb>>2]>>2]|0;nb=(f[i>>2]|0)+(Y(qb,pb)|0)|0;mb=nb+qb|0;if((sb|0)>0){qb=((pb|0)<0)<<31>>31;lb=pb|1;jb=((lb|0)<0)<<31>>31;ib=0;do{hb=nb+(ib<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){fb=f[n+(gb<<2)>>2]|0;if(!(b[ob+ib>>0]|0)){f[hb>>2]=0;eb=f[vb>>2]|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(ib|0)?ib:db;db=eb+8|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(ib|0)?ib:cb;cb=eb+4|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)>(pb|0)?pb:db;db=eb+12|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)<(pb|0)?pb:cb;cb=eb+16|0;f[cb>>2]=(f[cb>>2]|0)+1;cb=f[ub>>2]|0;db=cb;bb=Kac(f[db>>2]|0,f[db+4>>2]|0,ib|0,((ib|0)<0)<<31>>31|0)|0;db=cb;f[db>>2]=bb;f[db+4>>2]=J;Ab=cb+8|0;Bb=eb;Cb=cb}else{f[hb>>2]=fb;cb=f[vb>>2]|0;eb=cb+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0;db=f[eb>>2]|0;f[eb>>2]=(db|0)>(ib|0)?ib:db;db=eb+8|0;bb=f[db>>2]|0;f[db>>2]=(bb|0)<(ib|0)?ib:bb;bb=eb+4|0;db=f[bb>>2]|0;f[bb>>2]=(db|0)>(pb|0)?pb:db;db=eb+12|0;bb=f[db>>2]|0;f[db>>2]=(bb|0)<(pb|0)?pb:bb;bb=eb+16|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=f[ub>>2]|0;eb=bb+(fb<<4)|0;db=eb;ab=Kac(f[db>>2]|0,f[db+4>>2]|0,ib|0,((ib|0)<0)<<31>>31|0)|0;db=eb;f[db>>2]=ab;f[db+4>>2]=J;Ab=bb+(fb<<4)+8|0;Bb=cb;Cb=bb}bb=Ab;cb=Kac(f[bb>>2]|0,f[bb+4>>2]|0,pb|0,qb|0)|0;bb=Ab;f[bb>>2]=cb;f[bb+4>>2]=J;bb=ib|1;cb=nb+(bb<<2)|0;if(!(b[ob+bb>>0]|0)){f[cb>>2]=0;Db=0;Eb=Bb}else{f[cb>>2]=fb;Db=fb;Eb=Bb+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0}cb=f[Eb>>2]|0;f[Eb>>2]=(cb|0)>(bb|0)?bb:cb;cb=Eb+8|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)<(bb|0)?bb:db;db=Eb+4|0;cb=f[db>>2]|0;f[db>>2]=(cb|0)>(pb|0)?pb:cb;cb=Eb+12|0;db=f[cb>>2]|0;f[cb>>2]=(db|0)<(pb|0)?pb:db;db=Eb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Cb+(Db<<4)|0;cb=db;ab=Kac(f[cb>>2]|0,f[cb+4>>2]|0,bb|0,((bb|0)<0)<<31>>31|0)|0;cb=db;f[cb>>2]=ab;f[cb+4>>2]=J;cb=Cb+(Db<<4)+8|0;ab=cb;db=Kac(f[ab>>2]|0,f[ab+4>>2]|0,pb|0,qb|0)|0;ab=cb;f[ab>>2]=db;f[ab+4>>2]=J;ab=mb+(ib<<2)|0;if(!(b[kb+ib>>0]|0)){f[ab>>2]=0;Fb=0;Gb=Bb}else{f[ab>>2]=fb;Fb=fb;Gb=Bb+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0}ab=f[Gb>>2]|0;f[Gb>>2]=(ab|0)>(ib|0)?ib:ab;ab=Gb+8|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(ib|0)?ib:db;db=Gb+4|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)>(lb|0)?lb:ab;ab=Gb+12|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(lb|0)?lb:db;db=Gb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Cb+(Fb<<4)|0;ab=db;cb=Kac(f[ab>>2]|0,f[ab+4>>2]|0,ib|0,((ib|0)<0)<<31>>31|0)|0;ab=db;f[ab>>2]=cb;f[ab+4>>2]=J;ab=Cb+(Fb<<4)+8|0;cb=ab;db=Kac(f[cb>>2]|0,f[cb+4>>2]|0,lb|0,jb|0)|0;cb=ab;f[cb>>2]=db;f[cb+4>>2]=J;cb=mb+(bb<<2)|0;if(!(b[kb+bb>>0]|0)){f[cb>>2]=0;db=f[Bb>>2]|0;f[Bb>>2]=(db|0)>(bb|0)?bb:db;db=Bb+8|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)<(bb|0)?bb:ab;ab=Bb+4|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)>(lb|0)?lb:db;db=Bb+12|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)<(lb|0)?lb:ab;ab=Bb+16|0;f[ab>>2]=(f[ab>>2]|0)+1;ab=Cb;db=Kac(f[ab>>2]|0,f[ab+4>>2]|0,bb|0,((bb|0)<0)<<31>>31|0)|0;ab=Cb;f[ab>>2]=db;f[ab+4>>2]=J;Hb=Cb+8|0;break}else{f[cb>>2]=fb;cb=Bb+(Y(f[f[tb>>2]>>2]|0,fb)|0)|0;ab=f[cb>>2]|0;f[cb>>2]=(ab|0)>(bb|0)?bb:ab;ab=cb+8|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(bb|0)?bb:db;db=cb+4|0;ab=f[db>>2]|0;f[db>>2]=(ab|0)>(lb|0)?lb:ab;ab=cb+12|0;db=f[ab>>2]|0;f[ab>>2]=(db|0)<(lb|0)?lb:db;db=cb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Cb+(fb<<4)|0;cb=db;ab=Kac(f[cb>>2]|0,f[cb+4>>2]|0,bb|0,((bb|0)<0)<<31>>31|0)|0;bb=db;f[bb>>2]=ab;f[bb+4>>2]=J;Hb=Cb+(fb<<4)+8|0;break}}else{f[hb>>2]=0;fb=ib|1;f[nb+(fb<<2)>>2]=0;f[mb+(ib<<2)>>2]=0;f[mb+(fb<<2)>>2]=0;bb=f[vb>>2]|0;ab=f[bb>>2]|0;db=(ab|0)>(ib|0)?ib:ab;ab=bb+8|0;cb=f[ab>>2]|0;eb=(cb|0)<(ib|0)?ib:cb;cb=bb+4|0;$a=f[cb>>2]|0;_a=($a|0)>(pb|0)?pb:$a;$a=bb+12|0;Za=f[$a>>2]|0;Ya=(Za|0)<(pb|0)?pb:Za;Za=bb+16|0;Xa=f[Za>>2]|0;Wa=f[ub>>2]|0;Va=((ib|0)<0)<<31>>31;Ua=Wa;Ta=Kac(f[Ua>>2]|0,f[Ua+4>>2]|0,ib|0,Va|0)|0;Ua=J;Sa=Wa+8|0;Ra=Sa;Qa=Kac(f[Ra>>2]|0,f[Ra+4>>2]|0,pb|0,qb|0)|0;Ra=J;Pa=(db|0)>(fb|0)?fb:db;db=((fb|0)<0)<<31>>31;Oa=Kac(Ta|0,Ua|0,fb|0,db|0)|0;Ua=J;Ta=Kac(Qa|0,Ra|0,pb|0,qb|0)|0;Ra=J;Qa=Kac(Oa|0,Ua|0,ib|0,Va|0)|0;Va=J;Ua=Kac(Ta|0,Ra|0,lb|0,jb|0)|0;Ra=Sa;f[Ra>>2]=Ua;f[Ra+4>>2]=J;f[bb>>2]=(Pa|0)>(ib|0)?ib:Pa;f[ab>>2]=(eb|0)<(fb|0)?fb:eb;f[cb>>2]=(_a|0)>(lb|0)?lb:_a;f[$a>>2]=(Ya|0)<(lb|0)?lb:Ya;f[Za>>2]=Xa+4;Xa=Kac(Qa|0,Va|0,fb|0,db|0)|0;db=Wa;f[db>>2]=Xa;f[db+4>>2]=J;Hb=Sa}while(0);hb=Hb;gb=Kac(f[hb>>2]|0,f[hb+4>>2]|0,lb|0,jb|0)|0;hb=Hb;f[hb>>2]=gb;f[hb+4>>2]=J;ib=ib+2|0;Ib=f[o>>2]|0}while((ib|0)<(Ib|0));Jb=f[j>>2]|0;Kb=Ib}else{Jb=rb;Kb=sb}pb=pb+2|0;if((pb|0)>=(Jb|0))break b;else{sb=Kb;rb=Jb}}}if(h){rb=g+20|0;sb=g+120|0;pb=g+48|0;ub=f[c+16>>2]|0;vb=f[c+44>>2]|0;tb=f[d+16>>2]|0;i=f[d+44>>2]|0;wb=0;s=r;L=yb;while(1){ib=f[vb>>2]|0;jb=ub+(Y(ib,wb)|0)|0;lb=jb+ib|0;ib=f[i>>2]|0;qb=tb+(Y(ib,wb)|0)|0;mb=qb+ib|0;if((s|0)>0){ib=((wb|0)<0)<<31>>31;nb=wb|1;kb=((nb|0)<0)<<31>>31;ob=0;do{hb=qb+(ob<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){G=f[n+(gb<<2)>>2]|0;if(!(b[jb+ob>>0]|0)){f[hb>>2]=0;H=f[rb>>2]|0;Sa=f[H>>2]|0;f[H>>2]=(Sa|0)>(ob|0)?ob:Sa;Sa=H+8|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(ob|0)?ob:db;db=H+4|0;Sa=f[db>>2]|0;f[db>>2]=(Sa|0)>(wb|0)?wb:Sa;Sa=H+12|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(wb|0)?wb:db;db=H+16|0;f[db>>2]=(f[db>>2]|0)+1;db=f[sb>>2]|0;Sa=db;Xa=Kac(f[Sa>>2]|0,f[Sa+4>>2]|0,ob|0,((ob|0)<0)<<31>>31|0)|0;Sa=db;f[Sa>>2]=Xa;f[Sa+4>>2]=J;Lb=db+8|0;Mb=H;Nb=db}else{f[hb>>2]=G;db=f[rb>>2]|0;H=db+(Y(f[f[pb>>2]>>2]|0,G)|0)|0;Sa=f[H>>2]|0;f[H>>2]=(Sa|0)>(ob|0)?ob:Sa;Sa=H+8|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(ob|0)?ob:Xa;Xa=H+4|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(wb|0)?wb:Sa;Sa=H+12|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(wb|0)?wb:Xa;Xa=H+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=f[sb>>2]|0;H=Xa+(G<<4)|0;Sa=H;Wa=Kac(f[Sa>>2]|0,f[Sa+4>>2]|0,ob|0,((ob|0)<0)<<31>>31|0)|0;Sa=H;f[Sa>>2]=Wa;f[Sa+4>>2]=J;Lb=Xa+(G<<4)+8|0;Mb=db;Nb=Xa}Xa=Lb;db=Kac(f[Xa>>2]|0,f[Xa+4>>2]|0,wb|0,ib|0)|0;Xa=Lb;f[Xa>>2]=db;f[Xa+4>>2]=J;Xa=mb+(ob<<2)|0;if(!(b[lb+ob>>0]|0)){f[Xa>>2]=0;Ob=0;Pb=Mb}else{f[Xa>>2]=G;Ob=G;Pb=Mb+(Y(f[f[pb>>2]>>2]|0,G)|0)|0}Xa=f[Pb>>2]|0;f[Pb>>2]=(Xa|0)>(ob|0)?ob:Xa;Xa=Pb+8|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(ob|0)?ob:db;db=Pb+4|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)>(nb|0)?nb:Xa;Xa=Pb+12|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(nb|0)?nb:db;db=Pb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Nb+(Ob<<4)|0;Xa=db;Sa=Kac(f[Xa>>2]|0,f[Xa+4>>2]|0,ob|0,((ob|0)<0)<<31>>31|0)|0;Xa=db;f[Xa>>2]=Sa;f[Xa+4>>2]=J;Xa=Nb+(Ob<<4)+8|0;Sa=Xa;db=Kac(f[Sa>>2]|0,f[Sa+4>>2]|0,nb|0,kb|0)|0;Sa=Xa;f[Sa>>2]=db;f[Sa+4>>2]=J;Sa=ob|1;if((Sa|0)<(f[o>>2]|0)){db=qb+(Sa<<2)|0;if(!(b[jb+Sa>>0]|0)){f[db>>2]=0;Qb=0;Rb=Mb}else{f[db>>2]=G;Qb=G;Rb=Mb+(Y(f[f[pb>>2]>>2]|0,G)|0)|0}db=f[Rb>>2]|0;f[Rb>>2]=(db|0)>(Sa|0)?Sa:db;db=Rb+8|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)<(Sa|0)?Sa:Xa;Xa=Rb+4|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)>(wb|0)?wb:db;db=Rb+12|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)<(wb|0)?wb:Xa;Xa=Rb+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=Nb+(Qb<<4)|0;db=Xa;Wa=Kac(f[db>>2]|0,f[db+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;db=Xa;f[db>>2]=Wa;f[db+4>>2]=J;db=Nb+(Qb<<4)+8|0;Wa=db;Xa=Kac(f[Wa>>2]|0,f[Wa+4>>2]|0,wb|0,ib|0)|0;Wa=db;f[Wa>>2]=Xa;f[Wa+4>>2]=J;Wa=mb+(Sa<<2)|0;if(!(b[lb+Sa>>0]|0)){f[Wa>>2]=0;Xa=f[Mb>>2]|0;f[Mb>>2]=(Xa|0)>(Sa|0)?Sa:Xa;Xa=Mb+8|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(Sa|0)?Sa:db;db=Mb+4|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)>(nb|0)?nb:Xa;Xa=Mb+12|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(nb|0)?nb:db;db=Mb+16|0;f[db>>2]=(f[db>>2]|0)+1;db=Nb;Xa=Kac(f[db>>2]|0,f[db+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;db=Nb;f[db>>2]=Xa;f[db+4>>2]=J;db=Nb+8|0;Xa=db;H=Kac(f[Xa>>2]|0,f[Xa+4>>2]|0,nb|0,kb|0)|0;Xa=db;f[Xa>>2]=H;f[Xa+4>>2]=J;break}else{f[Wa>>2]=G;Wa=Mb+(Y(f[f[pb>>2]>>2]|0,G)|0)|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)>(Sa|0)?Sa:Xa;Xa=Wa+8|0;H=f[Xa>>2]|0;f[Xa>>2]=(H|0)<(Sa|0)?Sa:H;H=Wa+4|0;Xa=f[H>>2]|0;f[H>>2]=(Xa|0)>(nb|0)?nb:Xa;Xa=Wa+12|0;H=f[Xa>>2]|0;f[Xa>>2]=(H|0)<(nb|0)?nb:H;H=Wa+16|0;f[H>>2]=(f[H>>2]|0)+1;H=Nb+(G<<4)|0;Wa=H;Xa=Kac(f[Wa>>2]|0,f[Wa+4>>2]|0,Sa|0,((Sa|0)<0)<<31>>31|0)|0;Sa=H;f[Sa>>2]=Xa;f[Sa+4>>2]=J;Sa=Nb+(G<<4)+8|0;G=Sa;Xa=Kac(f[G>>2]|0,f[G+4>>2]|0,nb|0,kb|0)|0;G=Sa;f[G>>2]=Xa;f[G+4>>2]=J;break}}}else{f[hb>>2]=0;f[mb+(ob<<2)>>2]=0;G=f[rb>>2]|0;Xa=f[G>>2]|0;Sa=G+8|0;H=f[Sa>>2]|0;Wa=G+4|0;db=f[Wa>>2]|0;fb=(db|0)>(wb|0)?wb:db;db=G+12|0;Va=f[db>>2]|0;Qa=(Va|0)<(wb|0)?wb:Va;Va=G+16|0;Za=f[Va>>2]|0;Ya=f[sb>>2]|0;$a=((ob|0)<0)<<31>>31;_a=Ya;cb=Kac(f[_a>>2]|0,f[_a+4>>2]|0,ob|0,$a|0)|0;_a=J;eb=Ya+8|0;ab=eb;Pa=Kac(f[ab>>2]|0,f[ab+4>>2]|0,wb|0,ib|0)|0;ab=J;f[G>>2]=(Xa|0)>(ob|0)?ob:Xa;f[Sa>>2]=(H|0)<(ob|0)?ob:H;f[Wa>>2]=(fb|0)>(nb|0)?nb:fb;f[db>>2]=(Qa|0)<(nb|0)?nb:Qa;f[Va>>2]=Za+2;Za=Kac(cb|0,_a|0,ob|0,$a|0)|0;$a=J;_a=Ya;f[_a>>2]=Za;f[_a+4>>2]=$a;_a=Kac(Pa|0,ab|0,nb|0,kb|0)|0;ab=J;Pa=eb;f[Pa>>2]=_a;f[Pa+4>>2]=ab;Pa=ob|1;if((Pa|0)<(f[o>>2]|0)){f[qb+(Pa<<2)>>2]=0;f[mb+(Pa<<2)>>2]=0;cb=f[G>>2]|0;Qa=f[Sa>>2]|0;fb=f[Wa>>2]|0;H=(fb|0)>(wb|0)?wb:fb;fb=f[db>>2]|0;Xa=(fb|0)<(wb|0)?wb:fb;fb=f[Va>>2]|0;bb=((Pa|0)<0)<<31>>31;Ra=Kac(Za|0,$a|0,Pa|0,bb|0)|0;$a=J;Za=Kac(_a|0,ab|0,wb|0,ib|0)|0;ab=J;f[G>>2]=(cb|0)>(Pa|0)?Pa:cb;f[Sa>>2]=(Qa|0)<(Pa|0)?Pa:Qa;f[Wa>>2]=(H|0)>(nb|0)?nb:H;f[db>>2]=(Xa|0)<(nb|0)?nb:Xa;f[Va>>2]=fb+2;fb=Kac(Ra|0,$a|0,Pa|0,bb|0)|0;bb=Ya;f[bb>>2]=fb;f[bb+4>>2]=J;bb=Kac(Za|0,ab|0,nb|0,kb|0)|0;ab=eb;f[ab>>2]=bb;f[ab+4>>2]=J}}while(0);ob=ob+2|0;Sb=f[o>>2]|0}while((ob|0)<(Sb|0));Tb=f[j>>2]|0;Ub=Sb}else{Tb=L;Ub=s}wb=wb+2|0;if((wb|0)>=(Tb|0))break;else{s=Ub;L=Tb}}}}else{if(!xb){if(!h)break;L=g+20|0;s=g+120|0;wb=g+48|0;sb=f[c+16>>2]|0;rb=f[c+44>>2]|0;pb=f[d+16>>2]|0;tb=f[d+44>>2]|0;i=0;ub=r;vb=yb;while(1){ob=f[rb>>2]|0;kb=sb+(Y(ob,i)|0)|0;nb=kb+ob|0;ob=f[tb>>2]|0;ib=pb+(Y(ob,i)|0)|0;mb=ib+ob|0;if((ub|0)>0){ob=((i|0)<0)<<31>>31;qb=i|1;lb=((qb|0)<0)<<31>>31;jb=0;do{hb=ib+(jb<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){ab=f[n+(gb<<2)>>2]|0;if(!(b[kb+jb>>0]|0)){f[hb>>2]=0;bb=f[L>>2]|0;eb=f[bb>>2]|0;f[bb>>2]=(eb|0)>(jb|0)?jb:eb;eb=bb+8|0;Za=f[eb>>2]|0;f[eb>>2]=(Za|0)<(jb|0)?jb:Za;Za=bb+4|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)>(i|0)?i:eb;eb=bb+12|0;Za=f[eb>>2]|0;f[eb>>2]=(Za|0)<(i|0)?i:Za;Za=bb+16|0;f[Za>>2]=(f[Za>>2]|0)+1;Za=f[s>>2]|0;eb=Za;fb=Kac(f[eb>>2]|0,f[eb+4>>2]|0,jb|0,((jb|0)<0)<<31>>31|0)|0;eb=Za;f[eb>>2]=fb;f[eb+4>>2]=J;Vb=Za+8|0;Wb=bb;Xb=Za}else{f[hb>>2]=ab;Za=f[L>>2]|0;bb=Za+(Y(f[f[wb>>2]>>2]|0,ab)|0)|0;eb=f[bb>>2]|0;f[bb>>2]=(eb|0)>(jb|0)?jb:eb;eb=bb+8|0;fb=f[eb>>2]|0;f[eb>>2]=(fb|0)<(jb|0)?jb:fb;fb=bb+4|0;eb=f[fb>>2]|0;f[fb>>2]=(eb|0)>(i|0)?i:eb;eb=bb+12|0;fb=f[eb>>2]|0;f[eb>>2]=(fb|0)<(i|0)?i:fb;fb=bb+16|0;f[fb>>2]=(f[fb>>2]|0)+1;fb=f[s>>2]|0;bb=fb+(ab<<4)|0;eb=bb;Ya=Kac(f[eb>>2]|0,f[eb+4>>2]|0,jb|0,((jb|0)<0)<<31>>31|0)|0;eb=bb;f[eb>>2]=Ya;f[eb+4>>2]=J;Vb=fb+(ab<<4)+8|0;Wb=Za;Xb=fb}fb=Vb;Za=Kac(f[fb>>2]|0,f[fb+4>>2]|0,i|0,ob|0)|0;fb=Vb;f[fb>>2]=Za;f[fb+4>>2]=J;fb=jb|1;Za=ib+(fb<<2)|0;if(!(b[kb+fb>>0]|0)){f[Za>>2]=0;Yb=0;Zb=Wb}else{f[Za>>2]=ab;Yb=ab;Zb=Wb+(Y(f[f[wb>>2]>>2]|0,ab)|0)|0}Za=f[Zb>>2]|0;f[Zb>>2]=(Za|0)>(fb|0)?fb:Za;Za=Zb+8|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)<(fb|0)?fb:eb;eb=Zb+4|0;Za=f[eb>>2]|0;f[eb>>2]=(Za|0)>(i|0)?i:Za;Za=Zb+12|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)<(i|0)?i:eb;eb=Zb+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Xb+(Yb<<4)|0;Za=eb;Ya=Kac(f[Za>>2]|0,f[Za+4>>2]|0,fb|0,((fb|0)<0)<<31>>31|0)|0;Za=eb;f[Za>>2]=Ya;f[Za+4>>2]=J;Za=Xb+(Yb<<4)+8|0;Ya=Za;eb=Kac(f[Ya>>2]|0,f[Ya+4>>2]|0,i|0,ob|0)|0;Ya=Za;f[Ya>>2]=eb;f[Ya+4>>2]=J;if((qb|0)<(f[j>>2]|0)){Ya=mb+(jb<<2)|0;if(!(b[nb+jb>>0]|0)){f[Ya>>2]=0;_b=0;$b=Wb}else{f[Ya>>2]=ab;_b=ab;$b=Wb+(Y(f[f[wb>>2]>>2]|0,ab)|0)|0}Ya=f[$b>>2]|0;f[$b>>2]=(Ya|0)>(jb|0)?jb:Ya;Ya=$b+8|0;eb=f[Ya>>2]|0;f[Ya>>2]=(eb|0)<(jb|0)?jb:eb;eb=$b+4|0;Ya=f[eb>>2]|0;f[eb>>2]=(Ya|0)>(qb|0)?qb:Ya;Ya=$b+12|0;eb=f[Ya>>2]|0;f[Ya>>2]=(eb|0)<(qb|0)?qb:eb;eb=$b+16|0;f[eb>>2]=(f[eb>>2]|0)+1;eb=Xb+(_b<<4)|0;Ya=eb;Za=Kac(f[Ya>>2]|0,f[Ya+4>>2]|0,jb|0,((jb|0)<0)<<31>>31|0)|0;Ya=eb;f[Ya>>2]=Za;f[Ya+4>>2]=J;Ya=Xb+(_b<<4)+8|0;Za=Ya;eb=Kac(f[Za>>2]|0,f[Za+4>>2]|0,qb|0,lb|0)|0;Za=Ya;f[Za>>2]=eb;f[Za+4>>2]=J;Za=mb+(fb<<2)|0;if(!(b[nb+fb>>0]|0)){f[Za>>2]=0;eb=f[Wb>>2]|0;f[Wb>>2]=(eb|0)>(fb|0)?fb:eb;eb=Wb+8|0;Ya=f[eb>>2]|0;f[eb>>2]=(Ya|0)<(fb|0)?fb:Ya;Ya=Wb+4|0;eb=f[Ya>>2]|0;f[Ya>>2]=(eb|0)>(qb|0)?qb:eb;eb=Wb+12|0;Ya=f[eb>>2]|0;f[eb>>2]=(Ya|0)<(qb|0)?qb:Ya;Ya=Wb+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=Xb;eb=Kac(f[Ya>>2]|0,f[Ya+4>>2]|0,fb|0,((fb|0)<0)<<31>>31|0)|0;Ya=Xb;f[Ya>>2]=eb;f[Ya+4>>2]=J;Ya=Xb+8|0;eb=Ya;bb=Kac(f[eb>>2]|0,f[eb+4>>2]|0,qb|0,lb|0)|0;eb=Ya;f[eb>>2]=bb;f[eb+4>>2]=J;break}else{f[Za>>2]=ab;Za=Wb+(Y(f[f[wb>>2]>>2]|0,ab)|0)|0;eb=f[Za>>2]|0;f[Za>>2]=(eb|0)>(fb|0)?fb:eb;eb=Za+8|0;bb=f[eb>>2]|0;f[eb>>2]=(bb|0)<(fb|0)?fb:bb;bb=Za+4|0;eb=f[bb>>2]|0;f[bb>>2]=(eb|0)>(qb|0)?qb:eb;eb=Za+12|0;bb=f[eb>>2]|0;f[eb>>2]=(bb|0)<(qb|0)?qb:bb;bb=Za+16|0;f[bb>>2]=(f[bb>>2]|0)+1;bb=Xb+(ab<<4)|0;Za=bb;eb=Kac(f[Za>>2]|0,f[Za+4>>2]|0,fb|0,((fb|0)<0)<<31>>31|0)|0;fb=bb;f[fb>>2]=eb;f[fb+4>>2]=J;fb=Xb+(ab<<4)+8|0;ab=fb;eb=Kac(f[ab>>2]|0,f[ab+4>>2]|0,qb|0,lb|0)|0;ab=fb;f[ab>>2]=eb;f[ab+4>>2]=J;break}}}else{f[hb>>2]=0;ab=jb|1;f[ib+(ab<<2)>>2]=0;eb=f[L>>2]|0;fb=f[eb>>2]|0;bb=(fb|0)>(jb|0)?jb:fb;fb=eb+8|0;Za=f[fb>>2]|0;Ya=(Za|0)<(jb|0)?jb:Za;Za=eb+4|0;Pa=f[Za>>2]|0;$a=eb+12|0;Ra=f[$a>>2]|0;Va=eb+16|0;Xa=f[Va>>2]|0;db=f[s>>2]|0;H=((jb|0)<0)<<31>>31;Wa=db;Qa=Kac(f[Wa>>2]|0,f[Wa+4>>2]|0,jb|0,H|0)|0;Wa=J;Sa=db+8|0;cb=Sa;G=Kac(f[cb>>2]|0,f[cb+4>>2]|0,i|0,ob|0)|0;cb=J;f[eb>>2]=(bb|0)>(ab|0)?ab:bb;f[fb>>2]=(Ya|0)<(ab|0)?ab:Ya;f[Za>>2]=(Pa|0)>(i|0)?i:Pa;f[$a>>2]=(Ra|0)<(i|0)?i:Ra;f[Va>>2]=Xa+2;Xa=((ab|0)<0)<<31>>31;Ra=Kac(Qa|0,Wa|0,ab|0,Xa|0)|0;Wa=J;Qa=db;f[Qa>>2]=Ra;f[Qa+4>>2]=Wa;Qa=Kac(G|0,cb|0,i|0,ob|0)|0;cb=J;G=Sa;f[G>>2]=Qa;f[G+4>>2]=cb;if((qb|0)<(f[j>>2]|0)){f[mb+(jb<<2)>>2]=0;f[mb+(ab<<2)>>2]=0;G=f[eb>>2]|0;Pa=(G|0)>(jb|0)?jb:G;G=f[fb>>2]|0;Ya=(G|0)<(jb|0)?jb:G;G=f[Za>>2]|0;bb=f[$a>>2]|0;_a=f[Va>>2]|0;Ua=Kac(Ra|0,Wa|0,jb|0,H|0)|0;H=J;Wa=Kac(Qa|0,cb|0,qb|0,lb|0)|0;cb=J;f[eb>>2]=(Pa|0)>(ab|0)?ab:Pa;f[fb>>2]=(Ya|0)<(ab|0)?ab:Ya;f[Za>>2]=(G|0)>(qb|0)?qb:G;f[$a>>2]=(bb|0)<(qb|0)?qb:bb;f[Va>>2]=_a+2;_a=Kac(Ua|0,H|0,ab|0,Xa|0)|0;Xa=db;f[Xa>>2]=_a;f[Xa+4>>2]=J;Xa=Kac(Wa|0,cb|0,qb|0,lb|0)|0;cb=Sa;f[cb>>2]=Xa;f[cb+4>>2]=J}}while(0);jb=jb+2|0;ac=f[o>>2]|0}while((jb|0)<(ac|0));bc=f[j>>2]|0;cc=ac}else{bc=vb;cc=ub}i=i+2|0;if((i|0)>=(bc|0))break b;else{ub=cc;vb=bc}}}if(h){vb=g+20|0;ub=g+120|0;i=g+48|0;s=f[c+16>>2]|0;L=f[c+44>>2]|0;wb=f[d+16>>2]|0;pb=f[d+44>>2]|0;tb=0;sb=r;rb=yb;while(1){jb=f[L>>2]|0;lb=s+(Y(jb,tb)|0)|0;qb=lb+jb|0;jb=f[pb>>2]|0;mb=wb+(Y(jb,tb)|0)|0;ob=mb+jb|0;if((sb|0)>0){jb=((tb|0)<0)<<31>>31;ib=tb|1;nb=((ib|0)<0)<<31>>31;kb=0;do{hb=mb+(kb<<2)|0;gb=f[hb>>2]|0;do if((gb|0)>0){cb=f[n+(gb<<2)>>2]|0;if(!(b[lb+kb>>0]|0)){f[hb>>2]=0;Xa=f[vb>>2]|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=Xa+8|0;Wa=f[Sa>>2]|0;f[Sa>>2]=(Wa|0)<(kb|0)?kb:Wa;Wa=Xa+4|0;Sa=f[Wa>>2]|0;f[Wa>>2]=(Sa|0)>(tb|0)?tb:Sa;Sa=Xa+12|0;Wa=f[Sa>>2]|0;f[Sa>>2]=(Wa|0)<(tb|0)?tb:Wa;Wa=Xa+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=f[ub>>2]|0;Sa=Wa;_a=Kac(f[Sa>>2]|0,f[Sa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Sa=Wa;f[Sa>>2]=_a;f[Sa+4>>2]=J;dc=Wa+8|0;ec=Xa;fc=Wa}else{f[hb>>2]=cb;Wa=f[vb>>2]|0;Xa=Wa+(Y(f[f[i>>2]>>2]|0,cb)|0)|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=Xa+8|0;_a=f[Sa>>2]|0;f[Sa>>2]=(_a|0)<(kb|0)?kb:_a;_a=Xa+4|0;Sa=f[_a>>2]|0;f[_a>>2]=(Sa|0)>(tb|0)?tb:Sa;Sa=Xa+12|0;_a=f[Sa>>2]|0;f[Sa>>2]=(_a|0)<(tb|0)?tb:_a;_a=Xa+16|0;f[_a>>2]=(f[_a>>2]|0)+1;_a=f[ub>>2]|0;Xa=_a+(cb<<4)|0;Sa=Xa;db=Kac(f[Sa>>2]|0,f[Sa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Sa=Xa;f[Sa>>2]=db;f[Sa+4>>2]=J;dc=_a+(cb<<4)+8|0;ec=Wa;fc=_a}_a=dc;Wa=Kac(f[_a>>2]|0,f[_a+4>>2]|0,tb|0,jb|0)|0;_a=dc;f[_a>>2]=Wa;f[_a+4>>2]=J;_a=kb|1;if((_a|0)>=(f[o>>2]|0)){if((ib|0)>=(f[j>>2]|0))break;Wa=ob+(kb<<2)|0;if(!(b[qb+kb>>0]|0)){f[Wa>>2]=0;Sa=f[ec>>2]|0;f[ec>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=ec+8|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(kb|0)?kb:db;db=ec+4|0;Sa=f[db>>2]|0;f[db>>2]=(Sa|0)>(ib|0)?ib:Sa;Sa=ec+12|0;db=f[Sa>>2]|0;f[Sa>>2]=(db|0)<(ib|0)?ib:db;db=ec+16|0;f[db>>2]=(f[db>>2]|0)+1;db=fc;Sa=Kac(f[db>>2]|0,f[db+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;db=fc;f[db>>2]=Sa;f[db+4>>2]=J;db=fc+8|0;Sa=db;Xa=Kac(f[Sa>>2]|0,f[Sa+4>>2]|0,ib|0,nb|0)|0;Sa=db;f[Sa>>2]=Xa;f[Sa+4>>2]=J;break}else{f[Wa>>2]=cb;Wa=ec+(Y(f[f[i>>2]>>2]|0,cb)|0)|0;Sa=f[Wa>>2]|0;f[Wa>>2]=(Sa|0)>(kb|0)?kb:Sa;Sa=Wa+8|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(kb|0)?kb:Xa;Xa=Wa+4|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(ib|0)?ib:Sa;Sa=Wa+12|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(ib|0)?ib:Xa;Xa=Wa+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=fc+(cb<<4)|0;Wa=Xa;Sa=Kac(f[Wa>>2]|0,f[Wa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Wa=Xa;f[Wa>>2]=Sa;f[Wa+4>>2]=J;Wa=fc+(cb<<4)+8|0;Sa=Wa;Xa=Kac(f[Sa>>2]|0,f[Sa+4>>2]|0,ib|0,nb|0)|0;Sa=Wa;f[Sa>>2]=Xa;f[Sa+4>>2]=J;break}}Sa=mb+(_a<<2)|0;if(!(b[lb+_a>>0]|0)){f[Sa>>2]=0;gc=0;hc=ec}else{f[Sa>>2]=cb;gc=cb;hc=ec+(Y(f[f[i>>2]>>2]|0,cb)|0)|0}Sa=f[hc>>2]|0;f[hc>>2]=(Sa|0)>(_a|0)?_a:Sa;Sa=hc+8|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(_a|0)?_a:Xa;Xa=hc+4|0;Sa=f[Xa>>2]|0;f[Xa>>2]=(Sa|0)>(tb|0)?tb:Sa;Sa=hc+12|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)<(tb|0)?tb:Xa;Xa=hc+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=fc+(gc<<4)|0;Sa=Xa;Wa=Kac(f[Sa>>2]|0,f[Sa+4>>2]|0,_a|0,((_a|0)<0)<<31>>31|0)|0;Sa=Xa;f[Sa>>2]=Wa;f[Sa+4>>2]=J;Sa=fc+(gc<<4)+8|0;Wa=Sa;Xa=Kac(f[Wa>>2]|0,f[Wa+4>>2]|0,tb|0,jb|0)|0;Wa=Sa;f[Wa>>2]=Xa;f[Wa+4>>2]=J;if((ib|0)<(f[j>>2]|0)){Wa=ob+(kb<<2)|0;if(!(b[qb+kb>>0]|0)){f[Wa>>2]=0;ic=0;jc=ec}else{f[Wa>>2]=cb;ic=cb;jc=ec+(Y(f[f[i>>2]>>2]|0,cb)|0)|0}Wa=f[jc>>2]|0;f[jc>>2]=(Wa|0)>(kb|0)?kb:Wa;Wa=jc+8|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)<(kb|0)?kb:Xa;Xa=jc+4|0;Wa=f[Xa>>2]|0;f[Xa>>2]=(Wa|0)>(ib|0)?ib:Wa;Wa=jc+12|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)<(ib|0)?ib:Xa;Xa=jc+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=fc+(ic<<4)|0;Wa=Xa;Sa=Kac(f[Wa>>2]|0,f[Wa+4>>2]|0,kb|0,((kb|0)<0)<<31>>31|0)|0;Wa=Xa;f[Wa>>2]=Sa;f[Wa+4>>2]=J;Wa=fc+(ic<<4)+8|0;Sa=Wa;Xa=Kac(f[Sa>>2]|0,f[Sa+4>>2]|0,ib|0,nb|0)|0;Sa=Wa;f[Sa>>2]=Xa;f[Sa+4>>2]=J;Sa=ob+(_a<<2)|0;if(!(b[qb+_a>>0]|0)){f[Sa>>2]=0;Xa=f[ec>>2]|0;f[ec>>2]=(Xa|0)>(_a|0)?_a:Xa;Xa=ec+8|0;Wa=f[Xa>>2]|0;f[Xa>>2]=(Wa|0)<(_a|0)?_a:Wa;Wa=ec+4|0;Xa=f[Wa>>2]|0;f[Wa>>2]=(Xa|0)>(ib|0)?ib:Xa;Xa=ec+12|0;Wa=f[Xa>>2]|0;f[Xa>>2]=(Wa|0)<(ib|0)?ib:Wa;Wa=ec+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=fc;Xa=Kac(f[Wa>>2]|0,f[Wa+4>>2]|0,_a|0,((_a|0)<0)<<31>>31|0)|0;Wa=fc;f[Wa>>2]=Xa;f[Wa+4>>2]=J;Wa=fc+8|0;Xa=Wa;db=Kac(f[Xa>>2]|0,f[Xa+4>>2]|0,ib|0,nb|0)|0;Xa=Wa;f[Xa>>2]=db;f[Xa+4>>2]=J;break}else{f[Sa>>2]=cb;Sa=ec+(Y(f[f[i>>2]>>2]|0,cb)|0)|0;Xa=f[Sa>>2]|0;f[Sa>>2]=(Xa|0)>(_a|0)?_a:Xa;Xa=Sa+8|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(_a|0)?_a:db;db=Sa+4|0;Xa=f[db>>2]|0;f[db>>2]=(Xa|0)>(ib|0)?ib:Xa;Xa=Sa+12|0;db=f[Xa>>2]|0;f[Xa>>2]=(db|0)<(ib|0)?ib:db;db=Sa+16|0;f[db>>2]=(f[db>>2]|0)+1;db=fc+(cb<<4)|0;Sa=db;Xa=Kac(f[Sa>>2]|0,f[Sa+4>>2]|0,_a|0,((_a|0)<0)<<31>>31|0)|0;_a=db;f[_a>>2]=Xa;f[_a+4>>2]=J;_a=fc+(cb<<4)+8|0;cb=_a;Xa=Kac(f[cb>>2]|0,f[cb+4>>2]|0,ib|0,nb|0)|0;cb=_a;f[cb>>2]=Xa;f[cb+4>>2]=J;break}}}else{f[hb>>2]=0;cb=f[vb>>2]|0;Xa=f[cb>>2]|0;f[cb>>2]=(Xa|0)>(kb|0)?kb:Xa;Xa=cb+8|0;_a=f[Xa>>2]|0;f[Xa>>2]=(_a|0)<(kb|0)?kb:_a;_a=cb+4|0;db=f[_a>>2]|0;f[_a>>2]=(db|0)>(tb|0)?tb:db;db=cb+12|0;Sa=f[db>>2]|0;f[db>>2]=(Sa|0)<(tb|0)?tb:Sa;Sa=cb+16|0;f[Sa>>2]=(f[Sa>>2]|0)+1;Wa=f[ub>>2]|0;ab=((kb|0)<0)<<31>>31;H=Wa;Ua=Kac(f[H>>2]|0,f[H+4>>2]|0,kb|0,ab|0)|0;H=J;Va=Wa;f[Va>>2]=Ua;f[Va+4>>2]=H;Va=Wa+8|0;bb=Va;$a=Kac(f[bb>>2]|0,f[bb+4>>2]|0,tb|0,jb|0)|0;bb=J;G=Va;f[G>>2]=$a;f[G+4>>2]=bb;G=kb|1;if((G|0)<(f[o>>2]|0)){f[mb+(G<<2)>>2]=0;Za=f[cb>>2]|0;f[cb>>2]=(Za|0)>(G|0)?G:Za;Za=f[Xa>>2]|0;f[Xa>>2]=(Za|0)<(G|0)?G:Za;Za=f[_a>>2]|0;f[_a>>2]=(Za|0)>(tb|0)?tb:Za;Za=f[db>>2]|0;f[db>>2]=(Za|0)<(tb|0)?tb:Za;f[Sa>>2]=(f[Sa>>2]|0)+1;Za=((G|0)<0)<<31>>31;Ya=Kac(Ua|0,H|0,G|0,Za|0)|0;fb=J;Pa=Wa;f[Pa>>2]=Ya;f[Pa+4>>2]=fb;Pa=Kac($a|0,bb|0,tb|0,jb|0)|0;eb=J;Qa=Va;f[Qa>>2]=Pa;f[Qa+4>>2]=eb;if((ib|0)>=(f[j>>2]|0))break;f[ob+(kb<<2)>>2]=0;f[ob+(G<<2)>>2]=0;Qa=f[cb>>2]|0;Ra=(Qa|0)>(kb|0)?kb:Qa;Qa=f[Xa>>2]|0;Ta=(Qa|0)<(kb|0)?kb:Qa;Qa=f[_a>>2]|0;Oa=f[db>>2]|0;Na=f[Sa>>2]|0;Ma=Kac(Ya|0,fb|0,kb|0,ab|0)|0;fb=J;Ya=Kac(Pa|0,eb|0,ib|0,nb|0)|0;eb=J;f[cb>>2]=(Ra|0)>(G|0)?G:Ra;f[Xa>>2]=(Ta|0)<(G|0)?G:Ta;f[_a>>2]=(Qa|0)>(ib|0)?ib:Qa;f[db>>2]=(Oa|0)<(ib|0)?ib:Oa;f[Sa>>2]=Na+2;Na=Kac(Ma|0,fb|0,G|0,Za|0)|0;Za=Wa;f[Za>>2]=Na;f[Za+4>>2]=J;Za=Kac(Ya|0,eb|0,ib|0,nb|0)|0;eb=Va;f[eb>>2]=Za;f[eb+4>>2]=J;break}else{if((ib|0)>=(f[j>>2]|0))break;f[ob+(kb<<2)>>2]=0;eb=f[cb>>2]|0;f[cb>>2]=(eb|0)>(kb|0)?kb:eb;eb=f[Xa>>2]|0;f[Xa>>2]=(eb|0)<(kb|0)?kb:eb;eb=f[_a>>2]|0;f[_a>>2]=(eb|0)>(ib|0)?ib:eb;eb=f[db>>2]|0;f[db>>2]=(eb|0)<(ib|0)?ib:eb;f[Sa>>2]=(f[Sa>>2]|0)+1;Sa=Kac(Ua|0,H|0,kb|0,ab|0)|0;ab=Wa;f[ab>>2]=Sa;f[ab+4>>2]=J;ab=Kac($a|0,bb|0,ib|0,nb|0)|0;bb=Va;f[bb>>2]=ab;f[bb+4>>2]=J;break}}while(0);kb=kb+2|0;kc=f[o>>2]|0}while((kb|0)<(kc|0));lc=f[j>>2]|0;mc=kc}else{lc=rb;mc=sb}tb=tb+2|0;if((tb|0)>=(lc|0))break;else{sb=mc;rb=lc}}}}while(0);lc=g+12|0;if((f[lc>>2]|0)<=0){UC(n);u=a;return zb|0}mc=f[g+20>>2]|0;kc=f[g+48>>2]|0;j=f[g+120>>2]|0;o=f[g+80>>2]|0;fc=f[g+108>>2]|0;g=0;do{ec=mc+(Y(f[kc>>2]|0,g)|0)|0;ic=ec+8|0;f[ic>>2]=(f[ic>>2]|0)+1-(f[ec>>2]|0);ic=ec+12|0;f[ic>>2]=(f[ic>>2]|0)+1-(f[ec+4>>2]|0);ic=o+(Y(f[fc>>2]|0,g)|0)|0;nc=+((f[ec+16>>2]|0)>>>0);ec=j+(g<<4)|0;p[ic>>3]=(+((f[ec>>2]|0)>>>0)+4294967296.0*+((f[ec+4>>2]|0)>>>0))/nc;ec=j+(g<<4)+8|0;p[ic+8>>3]=(+((f[ec>>2]|0)>>>0)+4294967296.0*+((f[ec+4>>2]|0)>>>0))/nc;g=g+1|0}while((g|0)<(f[lc>>2]|0));UC(n);u=a;return zb|0}function j4(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0.0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;a=u;u=u+64|0;h=a+48|0;i=a+28|0;j=a;k=c+8|0;l=d+8|0;if((f[k>>2]|0)!=(f[l>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=aD(h,26)|0;n=235286;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,489445,235014,2529);bD(h)}q=c+12|0;if((f[q>>2]|0)!=(f[d+12>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=aD(h,26)|0;n=235313;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,489445,235014,2530);bD(h)}if((e|0)!=8){f[h>>2]=0;f[h+4>>2]=0;m=aD(h,17)|0;n=235340;o=m+17|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,489445,235014,2531);bD(h)}n=UQ()|0;e=f[k>>2]|0;k=((f[q>>2]|0)+1|0)/2|0;q=TC(e<<2)|0;r=TC((Y(((e+1|0)/2|0)<<2,k)|0)+4|0)|0;f[r>>2]=0;f[h>>2]=0;f[h+4>>2]=e;f[i>>2]=51992;f[i+4>>2]=c;f[i+8>>2]=d;f[i+12>>2]=r;f[i+16>>2]=q;s=+(n|0);RQ(h,i,s);k4(c,d,r,q);f[i>>2]=1;if((e|0)>0){n=0;do{t=n+1|0;v=(Y((t|0)/2|0,k)|0)+1|0;w=f[q+(t<<2)>>2]|0;t=w+v|0;if((w|0)>0){w=v;do{v=r+(w<<2)|0;x=f[v>>2]|0;if((x|0)<(w|0))f[v>>2]=f[r+(x<<2)>>2];else{f[v>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}w=w+1|0}while((w|0)<(t|0))}n=f[q+(n<<2)>>2]|0}while((n|0)<(e|0))}n=e*136|0;k=N5b(e>>>0>31580641|n>>>0>4294967291?-1:n+4|0)|0;f[k>>2]=e;n=k+4|0;if(e|0){t=n+(e*136|0)|0;e=n;do{f[e>>2]=0;f[e+4>>2]=1124007936;w=e+12|0;v=e+44|0;m=e+8|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[v>>2]=w;x=e+52|0;f[e+48>>2]=x;f[x>>2]=0;f[e+56>>2]=0;f[e+60>>2]=0;f[e+64>>2]=1124007936;x=e+72|0;y=e+104|0;m=e+68|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[y>>2]=x;w=e+112|0;f[e+108>>2]=w;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;f[w+16>>2]=0;f[w+20>>2]=0;e=e+136|0}while((e|0)!=(t|0))}l4(g,f[i>>2]|0);f[j>>2]=52012;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=r;f[j+16>>2]=g;f[j+20>>2]=n;f[j+24>>2]=i;RQ(h,j,s);j=f[l>>2]|0;l=f[g+132>>2]|0;if((l|0)<(j|0)){h=g+20|0;d=g+48|0;c=g+120|0;t=l;l=f[i>>2]|0;while(1){if((l|0)>0){e=n+(t*136|0)+120|0;m=f[n+(t*136|0)+20>>2]|0;o=f[n+(t*136|0)+48>>2]|0;w=0;v=l;while(1){z=m+(Y(f[o>>2]|0,w)|0)|0;A=z+16|0;if((f[A>>2]|0)>0){B=(f[h>>2]|0)+(Y(f[f[d>>2]>>2]|0,w)|0)|0;C=f[B>>2]|0;D=f[z>>2]|0;f[B>>2]=(C|0)>(D|0)?D:C;C=B+8|0;f[C>>2]=f[((f[C>>2]|0)<(f[z+8>>2]|0)?z:B)+8>>2];C=B+4|0;f[C>>2]=f[((f[C>>2]|0)>(f[z+4>>2]|0)?z:B)+4>>2];C=B+12|0;f[C>>2]=f[((f[C>>2]|0)<(f[z+12>>2]|0)?z:B)+12>>2];z=B+16|0;f[z>>2]=(f[z>>2]|0)+(f[A>>2]|0);A=f[e>>2]|0;z=A+(w<<4)|0;B=f[c>>2]|0;C=B+(w<<4)|0;D=C;E=Kac(f[D>>2]|0,f[D+4>>2]|0,f[z>>2]|0,f[z+4>>2]|0)|0;z=C;f[z>>2]=E;f[z+4>>2]=J;z=A+(w<<4)+8|0;A=B+(w<<4)+8|0;B=A;E=Kac(f[B>>2]|0,f[B+4>>2]|0,f[z>>2]|0,f[z+4>>2]|0)|0;z=A;f[z>>2]=E;f[z+4>>2]=J;F=f[i>>2]|0}else F=v;w=w+1|0;if((w|0)>=(F|0)){G=F;break}else v=F}}else G=l;t=f[n+(t*136|0)+132>>2]|0;if((t|0)>=(j|0))break;else l=G}}G=g+12|0;if((f[G>>2]|0)>0){l=f[g+20>>2]|0;j=f[g+48>>2]|0;t=f[g+120>>2]|0;F=f[g+80>>2]|0;c=f[g+108>>2]|0;g=0;do{d=l+(Y(f[j>>2]|0,g)|0)|0;h=d+8|0;f[h>>2]=(f[h>>2]|0)+1-(f[d>>2]|0);h=d+12|0;f[h>>2]=(f[h>>2]|0)+1-(f[d+4>>2]|0);h=F+(Y(f[c>>2]|0,g)|0)|0;s=+((f[d+16>>2]|0)>>>0);d=t+(g<<4)|0;p[h>>3]=(+((f[d>>2]|0)>>>0)+4294967296.0*+((f[d+4>>2]|0)>>>0))/s;d=t+(g<<4)+8|0;p[h+8>>3]=(+((f[d>>2]|0)>>>0)+4294967296.0*+((f[d+4>>2]|0)>>>0))/s;g=g+1|0}while((g|0)<(f[G>>2]|0))}G=n+((f[k>>2]|0)*136|0)|0;if((n|0)==(G|0)){P5b(k);UC(q);UC(r);H=f[i>>2]|0;u=a;return H|0}else I=G;do{I=I+-136|0;d4(I)}while((I|0)!=(n|0));P5b(k);UC(q);UC(r);H=f[i>>2]|0;u=a;return H|0}function k4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=f[c+12>>2]|0;h=f[c+8>>2]|0;i=f[e>>2]|0;if((i|0)>=(h|0))return;j=(g|0)>0;k=g+-1|0;l=g+-2|0;m=f[c+16>>2]|0;n=f[c+44>>2]|0;c=f[a+16>>2]|0;o=f[a+44>>2]|0;a=i;do{i=f[n>>2]|0;p=m+(Y(i,a)|0)|0;q=0-i|0;i=p+q+q|0;q=f[o>>2]|0;r=c+(Y(q,a)|0)|0;s=r+(0-q)|0;if(j){q=0;do{t=p+(q<<2)|0;u=f[t>>2]|0;if((u|0)>0){if((((q|0)>1?(v=f[i+(q+-2<<2)>>2]|0,(v|0)>0):0)?(b[r+q>>0]|0)!=0:0)?(b[s+(q+-1)>>0]|0)!=0:0){w=v;while(1){x=f[d+(w<<2)>>2]|0;if((x|0)<(w|0))w=x;else break}if((v|0)==(u|0))y=w;else{x=u;while(1){z=f[d+(x<<2)>>2]|0;if((z|0)<(x|0))x=z;else break}z=(w|0)>(x|0)?x:w;A=u;do{B=d+(A<<2)|0;C=A;A=f[B>>2]|0;f[B>>2]=z}while((A|0)<(C|0));y=z}z=v;do{A=d+(z<<2)|0;w=z;z=f[A>>2]|0;f[A>>2]=y}while((z|0)<(w|0));f[t>>2]=y;D=y}else D=u;z=f[i+(q<<2)>>2]|0;a:do if((z|0)>0){v=b[r+q>>0]|0;w=v<<24>>24!=0;if((q|0)>=(k|0)){if(!w){E=D;break}if(!(b[s+q>>0]|0)){E=D;break}else F=z;while(1){A=f[d+(F<<2)>>2]|0;if((A|0)<(F|0))F=A;else break}if((z|0)==(D|0))G=F;else{A=D;while(1){x=f[d+(A<<2)>>2]|0;if((x|0)<(A|0))A=x;else break}x=(F|0)>(A|0)?A:F;C=D;do{B=d+(C<<2)|0;H=C;C=f[B>>2]|0;f[B>>2]=x}while((C|0)<(H|0));G=x}x=z;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=G}while((x|0)<(A|0));f[t>>2]=G;E=G;break}if(w?(b[s+q>>0]|0)!=0:0)I=z;else J=23;do if((J|0)==23){J=0;x=q|1;A=(b[r+x>>0]|0)!=0;if(A?b[s+q>>0]|0:0){I=z;break}if(v<<24>>24?b[s+x>>0]|0:0){I=z;break}if(!A){E=D;break a}if(!(b[s+x>>0]|0)){E=D;break a}else I=z}while(0);while(1){v=f[d+(I<<2)>>2]|0;if((v|0)<(I|0))I=v;else break}if((z|0)==(D|0))K=I;else{v=D;while(1){w=f[d+(v<<2)>>2]|0;if((w|0)<(v|0))v=w;else break}w=(I|0)>(v|0)?v:I;x=D;do{A=d+(x<<2)|0;C=x;x=f[A>>2]|0;f[A>>2]=w}while((x|0)<(C|0));K=w}w=z;do{x=d+(w<<2)|0;v=w;w=f[x>>2]|0;f[x>>2]=K}while((w|0)<(v|0));f[t>>2]=K;E=K}else E=D;while(0);if((((q|0)<(l|0)?(z=q+2|0,u=f[i+(z<<2)>>2]|0,(u|0)>0):0)?b[r+(q|1)>>0]|0:0)?b[s+z>>0]|0:0){z=u;while(1){w=f[d+(z<<2)>>2]|0;if((w|0)<(z|0))z=w;else break}if((u|0)==(E|0))L=z;else{w=E;while(1){v=f[d+(w<<2)>>2]|0;if((v|0)<(w|0))w=v;else break}v=(z|0)>(w|0)?w:z;x=E;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=v}while((x|0)<(A|0));L=v}v=u;do{x=d+(v<<2)|0;z=v;v=f[x>>2]|0;f[x>>2]=L}while((v|0)<(z|0));f[t>>2]=L}}q=q+2|0}while((q|0)<(g|0))}a=f[e+(a<<2)>>2]|0}while((a|0)<(h|0));return}function l4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+80|0;d=c+64|0;e=c;g=c+56|0;h=f[a>>2]|0;f[d>>2]=5;f[d+4>>2]=b;vM(h,d,4,-1,0,0);d=f[a>>2]|0;do if((yM(d)|0)==65536){h=f[d+4>>2]|0;f[e>>2]=f[h>>2];i=e+4|0;j=h+4|0;f[i>>2]=f[j>>2];k=e+8|0;f[k>>2]=f[h+8>>2];f[e+12>>2]=f[h+12>>2];f[e+16>>2]=f[h+16>>2];f[e+20>>2]=f[h+20>>2];f[e+24>>2]=f[h+24>>2];f[e+28>>2]=f[h+28>>2];f[e+32>>2]=f[h+32>>2];l=f[h+36>>2]|0;f[e+36>>2]=l;f[e+40>>2]=k;k=e+48|0;m=e+44|0;f[m>>2]=k;f[k>>2]=0;f[e+52>>2]=0;if(l|0){k=l+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[j>>2]|0)<3){j=f[h+44>>2]|0;k=f[m>>2]|0;f[k>>2]=f[j>>2];f[k+4>>2]=f[j+4>>2];break}else{f[i>>2]=0;jL(e,h);break}}else yL(e,d,-1);while(0);d=a+4|0;h=e+36|0;i=f[h>>2]|0;if((d|0)==(e|0))n=i;else{if(i|0){j=i+12|0;f[j>>2]=(f[j>>2]|0)+1}j=a+40|0;i=f[j>>2]|0;if(i|0?(k=i+12|0,i=f[k>>2]|0,f[k>>2]=i+-1,(i|0)==1):0)kL(d);f[j>>2]=0;i=a+20|0;k=a+8|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[k>>2]|0)>0){m=f[a+44>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0;o=f[k>>2]|0}while((l|0)<(o|0));f[d>>2]=f[e>>2];if((o|0)<3)p=19;else p=21}else{f[d>>2]=f[e>>2];p=19}if((p|0)==19){o=f[e+4>>2]|0;if((o|0)<3){f[k>>2]=o;f[a+12>>2]=f[e+8>>2];f[a+16>>2]=f[e+12>>2];o=f[e+44>>2]|0;k=f[a+48>>2]|0;f[k>>2]=f[o>>2];f[k+4>>2]=f[o+4>>2]}else p=21}if((p|0)==21)jL(d,e);f[i>>2]=f[e+16>>2];f[a+24>>2]=f[e+20>>2];f[a+28>>2]=f[e+24>>2];f[a+32>>2]=f[e+28>>2];f[a+36>>2]=f[e+32>>2];i=f[h>>2]|0;f[j>>2]=i;n=i}if(n|0?(i=n+12|0,n=f[i>>2]|0,f[i>>2]=n+-1,(n|0)==1):0)kL(e);f[h>>2]=0;h=e+16|0;n=e+4|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;f[h+12>>2]=0;if((f[n>>2]|0)>0){h=f[e+40>>2]|0;i=0;do{f[h+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[n>>2]|0))}n=f[e+44>>2]|0;if((n|0)!=(e+48|0))UC(n);n=a+60|0;i=f[n>>2]|0;f[g>>2]=2;f[g+4>>2]=b;vM(i,g,6,-1,0,0);g=f[n>>2]|0;do if((yM(g)|0)==65536){n=f[g+4>>2]|0;f[e>>2]=f[n>>2];i=e+4|0;h=n+4|0;f[i>>2]=f[h>>2];j=e+8|0;f[j>>2]=f[n+8>>2];f[e+12>>2]=f[n+12>>2];f[e+16>>2]=f[n+16>>2];f[e+20>>2]=f[n+20>>2];f[e+24>>2]=f[n+24>>2];f[e+28>>2]=f[n+28>>2];f[e+32>>2]=f[n+32>>2];d=f[n+36>>2]|0;f[e+36>>2]=d;f[e+40>>2]=j;j=e+48|0;o=e+44|0;f[o>>2]=j;f[j>>2]=0;f[e+52>>2]=0;if(d|0){j=d+12|0;f[j>>2]=(f[j>>2]|0)+1}if((f[h>>2]|0)<3){h=f[n+44>>2]|0;j=f[o>>2]|0;f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];break}else{f[i>>2]=0;jL(e,n);break}}else yL(e,g,-1);while(0);g=a+64|0;n=e+36|0;i=f[n>>2]|0;if((g|0)==(e|0))q=i;else{if(i|0){h=i+12|0;f[h>>2]=(f[h>>2]|0)+1}h=a+100|0;i=f[h>>2]|0;if(i|0?(j=i+12|0,i=f[j>>2]|0,f[j>>2]=i+-1,(i|0)==1):0)kL(g);f[h>>2]=0;i=a+80|0;j=a+68|0;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;f[i+12>>2]=0;if((f[j>>2]|0)>0){o=f[a+104>>2]|0;d=0;do{f[o+(d<<2)>>2]=0;d=d+1|0;r=f[j>>2]|0}while((d|0)<(r|0));f[g>>2]=f[e>>2];if((r|0)<3)p=49;else p=51}else{f[g>>2]=f[e>>2];p=49}if((p|0)==49){r=f[e+4>>2]|0;if((r|0)<3){f[j>>2]=r;f[a+72>>2]=f[e+8>>2];f[a+76>>2]=f[e+12>>2];r=f[e+44>>2]|0;j=f[a+108>>2]|0;f[j>>2]=f[r>>2];f[j+4>>2]=f[r+4>>2]}else p=51}if((p|0)==51)jL(g,e);f[i>>2]=f[e+16>>2];f[a+84>>2]=f[e+20>>2];f[a+88>>2]=f[e+24>>2];f[a+92>>2]=f[e+28>>2];f[a+96>>2]=f[e+32>>2];i=f[n>>2]|0;f[h>>2]=i;q=i}if(q|0?(i=q+12|0,q=f[i>>2]|0,f[i>>2]=q+-1,(q|0)==1):0)kL(e);f[n>>2]=0;n=e+16|0;q=e+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[q>>2]|0)>0){n=f[e+40>>2]|0;i=0;do{f[n+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[q>>2]|0))}q=f[e+44>>2]|0;if((q|0)!=(e+48|0))UC(q);if((b|0)>0){q=f[a+20>>2]|0;i=f[a+48>>2]|0;n=0;do{h=q+(Y(f[i>>2]|0,n)|0)|0;f[h>>2]=2147483647;f[h+4>>2]=2147483647;f[h+8>>2]=-2147483648;f[h+12>>2]=-2147483648;f[h+16>>2]=0;n=n+1|0}while((n|0)!=(b|0))}n=a+120|0;i=a+124|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;a=f[i>>2]|0;q=f[n>>2]|0;h=a-q>>4;g=a;if(h>>>0<b>>>0){p4(n,b-h|0,e);u=c;return}if(h>>>0<=b>>>0){u=c;return}h=q+(b<<4)|0;if((g|0)==(h|0)){u=c;return}f[i>>2]=g+(~((g+-16-h|0)>>>4)<<4);u=c;return}function m4(a){a=a|0;O5b(a);return}function n4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=f[c+4>>2]|0;c=((d|0)%2|0)+d|0;if((e|0)>0){d=a+20|0;o4((f[d>>2]|0)+(e*136|0)|0,f[f[a+24>>2]>>2]|0);g=f[d>>2]|0;f[g+(e*136|0)+132>>2]=c;d=a+8|0;h=f[d>>2]|0;i=f[h+12>>2]|0;j=(i&1|0)!=0;k=(e|0)<(c|0);if(!(f[h+8>>2]&1)){if(!j){if(!k)return;l=a+4|0;m=a+12|0;n=g+(e*136|0)+20|0;o=g+(e*136|0)+120|0;p=g+(e*136|0)+20|0;q=g+(e*136|0)+48|0;r=g+(e*136|0)+48|0;s=g+(e*136|0)+48|0;t=g+(e*136|0)+20|0;u=g+(e*136|0)+48|0;v=g+(e*136|0)+120|0;w=g+(e*136|0)+20|0;x=g+(e*136|0)+120|0;y=e;z=h;A=i;while(1){B=f[l>>2]|0;C=f[f[B+44>>2]>>2]|0;D=(f[B+16>>2]|0)+(Y(C,y)|0)|0;B=D+C|0;C=f[f[z+44>>2]>>2]|0;E=(f[z+16>>2]|0)+(Y(C,y)|0)|0;F=E+C|0;if((A|0)>0){C=((y|0)<0)<<31>>31;G=y+1|0;H=((G|0)<0)<<31>>31;I=0;do{K=E+(I<<2)|0;L=f[K>>2]|0;do if((L|0)>0){M=f[(f[m>>2]|0)+(L<<2)>>2]|0;if(!(b[D+I>>0]|0)){f[K>>2]=0;N=f[n>>2]|0;O=f[N>>2]|0;f[N>>2]=(O|0)>(I|0)?I:O;O=N+8|0;P=f[O>>2]|0;f[O>>2]=(P|0)<(I|0)?I:P;P=N+4|0;O=f[P>>2]|0;f[P>>2]=(O|0)>(y|0)?y:O;O=N+12|0;P=f[O>>2]|0;f[O>>2]=(P|0)<(y|0)?y:P;P=N+16|0;f[P>>2]=(f[P>>2]|0)+1;P=f[o>>2]|0;O=P;Q=Kac(f[O>>2]|0,f[O+4>>2]|0,I|0,((I|0)<0)<<31>>31|0)|0;O=P;f[O>>2]=Q;f[O+4>>2]=J;R=P+8|0;S=N;T=P}else{f[K>>2]=M;P=f[t>>2]|0;N=P+(Y(f[f[u>>2]>>2]|0,M)|0)|0;O=f[N>>2]|0;f[N>>2]=(O|0)>(I|0)?I:O;O=N+8|0;Q=f[O>>2]|0;f[O>>2]=(Q|0)<(I|0)?I:Q;Q=N+4|0;O=f[Q>>2]|0;f[Q>>2]=(O|0)>(y|0)?y:O;O=N+12|0;Q=f[O>>2]|0;f[O>>2]=(Q|0)<(y|0)?y:Q;Q=N+16|0;f[Q>>2]=(f[Q>>2]|0)+1;Q=f[v>>2]|0;N=Q+(M<<4)|0;O=N;U=Kac(f[O>>2]|0,f[O+4>>2]|0,I|0,((I|0)<0)<<31>>31|0)|0;O=N;f[O>>2]=U;f[O+4>>2]=J;R=Q+(M<<4)+8|0;S=P;T=Q}Q=R;P=Kac(f[Q>>2]|0,f[Q+4>>2]|0,y|0,C|0)|0;Q=R;f[Q>>2]=P;f[Q+4>>2]=J;Q=I|1;P=E+(Q<<2)|0;if(!(b[D+Q>>0]|0)){f[P>>2]=0;V=0;W=S}else{f[P>>2]=M;V=M;W=S+(Y(f[f[s>>2]>>2]|0,M)|0)|0}P=f[W>>2]|0;f[W>>2]=(P|0)>(Q|0)?Q:P;P=W+8|0;O=f[P>>2]|0;f[P>>2]=(O|0)<(Q|0)?Q:O;O=W+4|0;P=f[O>>2]|0;f[O>>2]=(P|0)>(y|0)?y:P;P=W+12|0;O=f[P>>2]|0;f[P>>2]=(O|0)<(y|0)?y:O;O=W+16|0;f[O>>2]=(f[O>>2]|0)+1;O=T+(V<<4)|0;P=O;U=Kac(f[P>>2]|0,f[P+4>>2]|0,Q|0,((Q|0)<0)<<31>>31|0)|0;P=O;f[P>>2]=U;f[P+4>>2]=J;P=T+(V<<4)+8|0;U=P;O=Kac(f[U>>2]|0,f[U+4>>2]|0,y|0,C|0)|0;U=P;f[U>>2]=O;f[U+4>>2]=J;U=F+(I<<2)|0;if(!(b[B+I>>0]|0)){f[U>>2]=0;X=0;Z=S}else{f[U>>2]=M;X=M;Z=S+(Y(f[f[r>>2]>>2]|0,M)|0)|0}U=f[Z>>2]|0;f[Z>>2]=(U|0)>(I|0)?I:U;U=Z+8|0;O=f[U>>2]|0;f[U>>2]=(O|0)<(I|0)?I:O;O=Z+4|0;U=f[O>>2]|0;f[O>>2]=(U|0)>(G|0)?G:U;U=Z+12|0;O=f[U>>2]|0;f[U>>2]=(O|0)<(G|0)?G:O;O=Z+16|0;f[O>>2]=(f[O>>2]|0)+1;O=T+(X<<4)|0;U=O;P=Kac(f[U>>2]|0,f[U+4>>2]|0,I|0,((I|0)<0)<<31>>31|0)|0;U=O;f[U>>2]=P;f[U+4>>2]=J;U=T+(X<<4)+8|0;P=U;O=Kac(f[P>>2]|0,f[P+4>>2]|0,G|0,H|0)|0;P=U;f[P>>2]=O;f[P+4>>2]=J;P=F+(Q<<2)|0;O=f[p>>2]|0;if(!(b[B+Q>>0]|0)){f[P>>2]=0;U=f[O>>2]|0;f[O>>2]=(U|0)>(Q|0)?Q:U;U=O+8|0;N=f[U>>2]|0;f[U>>2]=(N|0)<(Q|0)?Q:N;N=O+4|0;U=f[N>>2]|0;f[N>>2]=(U|0)>(G|0)?G:U;U=O+12|0;N=f[U>>2]|0;f[U>>2]=(N|0)<(G|0)?G:N;N=O+16|0;f[N>>2]=(f[N>>2]|0)+1;N=T;U=Kac(f[N>>2]|0,f[N+4>>2]|0,Q|0,((Q|0)<0)<<31>>31|0)|0;N=T;f[N>>2]=U;f[N+4>>2]=J;_=T+8|0;break}else{f[P>>2]=M;P=O+(Y(f[f[q>>2]>>2]|0,M)|0)|0;O=f[P>>2]|0;f[P>>2]=(O|0)>(Q|0)?Q:O;O=P+8|0;N=f[O>>2]|0;f[O>>2]=(N|0)<(Q|0)?Q:N;N=P+4|0;O=f[N>>2]|0;f[N>>2]=(O|0)>(G|0)?G:O;O=P+12|0;N=f[O>>2]|0;f[O>>2]=(N|0)<(G|0)?G:N;N=P+16|0;f[N>>2]=(f[N>>2]|0)+1;N=T+(M<<4)|0;P=N;O=Kac(f[P>>2]|0,f[P+4>>2]|0,Q|0,((Q|0)<0)<<31>>31|0)|0;Q=N;f[Q>>2]=O;f[Q+4>>2]=J;_=T+(M<<4)+8|0;break}}else{f[K>>2]=0;M=I|1;f[E+(M<<2)>>2]=0;f[F+(I<<2)>>2]=0;f[F+(M<<2)>>2]=0;Q=f[w>>2]|0;O=f[Q>>2]|0;N=(O|0)>(I|0)?I:O;O=Q+8|0;P=f[O>>2]|0;U=(P|0)<(I|0)?I:P;P=Q+4|0;$=f[P>>2]|0;aa=($|0)>(y|0)?y:$;$=Q+12|0;ba=f[$>>2]|0;ca=(ba|0)<(y|0)?y:ba;ba=Q+16|0;da=f[ba>>2]|0;ea=f[x>>2]|0;fa=((I|0)<0)<<31>>31;ga=ea;ha=Kac(f[ga>>2]|0,f[ga+4>>2]|0,I|0,fa|0)|0;ga=J;ia=ea+8|0;ja=ia;ka=Kac(f[ja>>2]|0,f[ja+4>>2]|0,y|0,C|0)|0;ja=J;la=(N|0)>(M|0)?M:N;N=((M|0)<0)<<31>>31;ma=Kac(ha|0,ga|0,M|0,N|0)|0;ga=J;ha=Kac(ka|0,ja|0,y|0,C|0)|0;ja=J;ka=Kac(ma|0,ga|0,I|0,fa|0)|0;fa=J;ga=Kac(ha|0,ja|0,G|0,H|0)|0;ja=ia;f[ja>>2]=ga;f[ja+4>>2]=J;f[Q>>2]=(la|0)>(I|0)?I:la;f[O>>2]=(U|0)<(M|0)?M:U;f[P>>2]=(aa|0)>(G|0)?G:aa;f[$>>2]=(ca|0)<(G|0)?G:ca;f[ba>>2]=da+4;da=Kac(ka|0,fa|0,M|0,N|0)|0;N=ea;f[N>>2]=da;f[N+4>>2]=J;_=ia}while(0);K=_;L=Kac(f[K>>2]|0,f[K+4>>2]|0,G|0,H|0)|0;K=_;f[K>>2]=L;f[K+4>>2]=J;I=I+2|0;K=f[d>>2]|0;L=f[K+12>>2]|0}while((I|0)<(L|0));na=L;oa=K}else{na=A;oa=z}y=y+2|0;if((y|0)>=(c|0))break;else{z=oa;A=na}}return}if(!k)return;na=a+4|0;A=a+12|0;oa=g+(e*136|0)+20|0;z=g+(e*136|0)+120|0;y=g+(e*136|0)+20|0;_=g+(e*136|0)+48|0;x=g+(e*136|0)+48|0;w=g+(e*136|0)+48|0;T=g+(e*136|0)+20|0;q=g+(e*136|0)+48|0;p=g+(e*136|0)+120|0;X=g+(e*136|0)+20|0;Z=g+(e*136|0)+120|0;r=e;S=h;V=i;while(1){W=f[na>>2]|0;s=f[f[W+44>>2]>>2]|0;R=(f[W+16>>2]|0)+(Y(s,r)|0)|0;W=R+s|0;s=f[f[S+44>>2]>>2]|0;v=(f[S+16>>2]|0)+(Y(s,r)|0)|0;u=v+s|0;if((V|0)>0){s=((r|0)<0)<<31>>31;t=r+1|0;o=((t|0)<0)<<31>>31;n=0;do{m=v+(n<<2)|0;l=f[m>>2]|0;do if((l|0)>0){I=f[(f[A>>2]|0)+(l<<2)>>2]|0;if(!(b[R+n>>0]|0)){f[m>>2]=0;H=f[oa>>2]|0;G=f[H>>2]|0;f[H>>2]=(G|0)>(n|0)?n:G;G=H+8|0;C=f[G>>2]|0;f[G>>2]=(C|0)<(n|0)?n:C;C=H+4|0;G=f[C>>2]|0;f[C>>2]=(G|0)>(r|0)?r:G;G=H+12|0;C=f[G>>2]|0;f[G>>2]=(C|0)<(r|0)?r:C;C=H+16|0;f[C>>2]=(f[C>>2]|0)+1;C=f[z>>2]|0;G=C;F=Kac(f[G>>2]|0,f[G+4>>2]|0,n|0,((n|0)<0)<<31>>31|0)|0;G=C;f[G>>2]=F;f[G+4>>2]=J;pa=C+8|0;qa=H;ra=C}else{f[m>>2]=I;C=f[T>>2]|0;H=C+(Y(f[f[q>>2]>>2]|0,I)|0)|0;G=f[H>>2]|0;f[H>>2]=(G|0)>(n|0)?n:G;G=H+8|0;F=f[G>>2]|0;f[G>>2]=(F|0)<(n|0)?n:F;F=H+4|0;G=f[F>>2]|0;f[F>>2]=(G|0)>(r|0)?r:G;G=H+12|0;F=f[G>>2]|0;f[G>>2]=(F|0)<(r|0)?r:F;F=H+16|0;f[F>>2]=(f[F>>2]|0)+1;F=f[p>>2]|0;H=F+(I<<4)|0;G=H;E=Kac(f[G>>2]|0,f[G+4>>2]|0,n|0,((n|0)<0)<<31>>31|0)|0;G=H;f[G>>2]=E;f[G+4>>2]=J;pa=F+(I<<4)+8|0;qa=C;ra=F}F=pa;C=Kac(f[F>>2]|0,f[F+4>>2]|0,r|0,s|0)|0;F=pa;f[F>>2]=C;f[F+4>>2]=J;F=u+(n<<2)|0;if(!(b[W+n>>0]|0)){f[F>>2]=0;sa=0;ta=qa}else{f[F>>2]=I;sa=I;ta=qa+(Y(f[f[w>>2]>>2]|0,I)|0)|0}F=f[ta>>2]|0;f[ta>>2]=(F|0)>(n|0)?n:F;F=ta+8|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(n|0)?n:C;C=ta+4|0;F=f[C>>2]|0;f[C>>2]=(F|0)>(t|0)?t:F;F=ta+12|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(t|0)?t:C;C=ta+16|0;f[C>>2]=(f[C>>2]|0)+1;C=ra+(sa<<4)|0;F=C;G=Kac(f[F>>2]|0,f[F+4>>2]|0,n|0,((n|0)<0)<<31>>31|0)|0;F=C;f[F>>2]=G;f[F+4>>2]=J;F=ra+(sa<<4)+8|0;G=F;C=Kac(f[G>>2]|0,f[G+4>>2]|0,t|0,o|0)|0;G=F;f[G>>2]=C;f[G+4>>2]=J;G=n|1;if((G|0)<(f[(f[d>>2]|0)+12>>2]|0)){C=v+(G<<2)|0;if(!(b[R+G>>0]|0)){f[C>>2]=0;ua=0;va=qa}else{f[C>>2]=I;ua=I;va=qa+(Y(f[f[x>>2]>>2]|0,I)|0)|0}C=f[va>>2]|0;f[va>>2]=(C|0)>(G|0)?G:C;C=va+8|0;F=f[C>>2]|0;f[C>>2]=(F|0)<(G|0)?G:F;F=va+4|0;C=f[F>>2]|0;f[F>>2]=(C|0)>(r|0)?r:C;C=va+12|0;F=f[C>>2]|0;f[C>>2]=(F|0)<(r|0)?r:F;F=va+16|0;f[F>>2]=(f[F>>2]|0)+1;F=ra+(ua<<4)|0;C=F;E=Kac(f[C>>2]|0,f[C+4>>2]|0,G|0,((G|0)<0)<<31>>31|0)|0;C=F;f[C>>2]=E;f[C+4>>2]=J;C=ra+(ua<<4)+8|0;E=C;F=Kac(f[E>>2]|0,f[E+4>>2]|0,r|0,s|0)|0;E=C;f[E>>2]=F;f[E+4>>2]=J;E=u+(G<<2)|0;F=f[y>>2]|0;if(!(b[W+G>>0]|0)){f[E>>2]=0;C=f[F>>2]|0;f[F>>2]=(C|0)>(G|0)?G:C;C=F+8|0;H=f[C>>2]|0;f[C>>2]=(H|0)<(G|0)?G:H;H=F+4|0;C=f[H>>2]|0;f[H>>2]=(C|0)>(t|0)?t:C;C=F+12|0;H=f[C>>2]|0;f[C>>2]=(H|0)<(t|0)?t:H;H=F+16|0;f[H>>2]=(f[H>>2]|0)+1;H=ra;C=Kac(f[H>>2]|0,f[H+4>>2]|0,G|0,((G|0)<0)<<31>>31|0)|0;H=ra;f[H>>2]=C;f[H+4>>2]=J;H=ra+8|0;C=H;B=Kac(f[C>>2]|0,f[C+4>>2]|0,t|0,o|0)|0;C=H;f[C>>2]=B;f[C+4>>2]=J;break}else{f[E>>2]=I;E=F+(Y(f[f[_>>2]>>2]|0,I)|0)|0;F=f[E>>2]|0;f[E>>2]=(F|0)>(G|0)?G:F;F=E+8|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(G|0)?G:C;C=E+4|0;F=f[C>>2]|0;f[C>>2]=(F|0)>(t|0)?t:F;F=E+12|0;C=f[F>>2]|0;f[F>>2]=(C|0)<(t|0)?t:C;C=E+16|0;f[C>>2]=(f[C>>2]|0)+1;C=ra+(I<<4)|0;E=C;F=Kac(f[E>>2]|0,f[E+4>>2]|0,G|0,((G|0)<0)<<31>>31|0)|0;G=C;f[G>>2]=F;f[G+4>>2]=J;G=ra+(I<<4)+8|0;I=G;F=Kac(f[I>>2]|0,f[I+4>>2]|0,t|0,o|0)|0;I=G;f[I>>2]=F;f[I+4>>2]=J;break}}}else{f[m>>2]=0;f[u+(n<<2)>>2]=0;I=f[X>>2]|0;F=f[I>>2]|0;G=I+8|0;C=f[G>>2]|0;E=I+4|0;B=f[E>>2]|0;H=(B|0)>(r|0)?r:B;B=I+12|0;D=f[B>>2]|0;K=(D|0)<(r|0)?r:D;D=I+16|0;L=f[D>>2]|0;ia=f[Z>>2]|0;N=((n|0)<0)<<31>>31;da=ia;ea=Kac(f[da>>2]|0,f[da+4>>2]|0,n|0,N|0)|0;da=J;M=ia+8|0;fa=M;ka=Kac(f[fa>>2]|0,f[fa+4>>2]|0,r|0,s|0)|0;fa=J;f[I>>2]=(F|0)>(n|0)?n:F;f[G>>2]=(C|0)<(n|0)?n:C;f[E>>2]=(H|0)>(t|0)?t:H;f[B>>2]=(K|0)<(t|0)?t:K;f[D>>2]=L+2;L=Kac(ea|0,da|0,n|0,N|0)|0;N=J;da=ia;f[da>>2]=L;f[da+4>>2]=N;da=Kac(ka|0,fa|0,t|0,o|0)|0;fa=J;ka=M;f[ka>>2]=da;f[ka+4>>2]=fa;ka=n|1;if((ka|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[v+(ka<<2)>>2]=0;f[u+(ka<<2)>>2]=0;ea=f[I>>2]|0;K=f[G>>2]|0;H=f[E>>2]|0;C=(H|0)>(r|0)?r:H;H=f[B>>2]|0;F=(H|0)<(r|0)?r:H;H=f[D>>2]|0;ba=((ka|0)<0)<<31>>31;ca=Kac(L|0,N|0,ka|0,ba|0)|0;N=J;L=Kac(da|0,fa|0,r|0,s|0)|0;fa=J;f[I>>2]=(ea|0)>(ka|0)?ka:ea;f[G>>2]=(K|0)<(ka|0)?ka:K;f[E>>2]=(C|0)>(t|0)?t:C;f[B>>2]=(F|0)<(t|0)?t:F;f[D>>2]=H+2;H=Kac(ca|0,N|0,ka|0,ba|0)|0;ba=ia;f[ba>>2]=H;f[ba+4>>2]=J;ba=Kac(L|0,fa|0,t|0,o|0)|0;fa=M;f[fa>>2]=ba;f[fa+4>>2]=J}}while(0);n=n+2|0;m=f[d>>2]|0;l=f[m+12>>2]|0}while((n|0)<(l|0));wa=l;xa=m}else{wa=V;xa=S}r=r+2|0;if((r|0)>=(c|0))break;else{S=xa;V=wa}}return}if(!j){if(!k)return;j=a+4|0;wa=a+12|0;V=g+(e*136|0)+20|0;xa=g+(e*136|0)+120|0;S=g+(e*136|0)+20|0;r=g+(e*136|0)+48|0;Z=g+(e*136|0)+48|0;X=g+(e*136|0)+48|0;ra=g+(e*136|0)+20|0;_=g+(e*136|0)+48|0;y=g+(e*136|0)+120|0;ua=g+(e*136|0)+20|0;va=g+(e*136|0)+120|0;x=e;qa=h;sa=i;while(1){ta=f[j>>2]|0;w=f[f[ta+44>>2]>>2]|0;pa=(f[ta+16>>2]|0)+(Y(w,x)|0)|0;ta=pa+w|0;w=f[f[qa+44>>2]>>2]|0;p=(f[qa+16>>2]|0)+(Y(w,x)|0)|0;q=p+w|0;if((sa|0)>0){w=((x|0)<0)<<31>>31;T=x+1|0;z=((T|0)<0)<<31>>31;oa=0;do{A=p+(oa<<2)|0;na=f[A>>2]|0;do if((na|0)>0){n=f[(f[wa>>2]|0)+(na<<2)>>2]|0;if(!(b[pa+oa>>0]|0)){f[A>>2]=0;o=f[V>>2]|0;t=f[o>>2]|0;f[o>>2]=(t|0)>(oa|0)?oa:t;t=o+8|0;s=f[t>>2]|0;f[t>>2]=(s|0)<(oa|0)?oa:s;s=o+4|0;t=f[s>>2]|0;f[s>>2]=(t|0)>(x|0)?x:t;t=o+12|0;s=f[t>>2]|0;f[t>>2]=(s|0)<(x|0)?x:s;s=o+16|0;f[s>>2]=(f[s>>2]|0)+1;s=f[xa>>2]|0;t=s;u=Kac(f[t>>2]|0,f[t+4>>2]|0,oa|0,((oa|0)<0)<<31>>31|0)|0;t=s;f[t>>2]=u;f[t+4>>2]=J;ya=s+8|0;za=o;Aa=s}else{f[A>>2]=n;s=f[ra>>2]|0;o=s+(Y(f[f[_>>2]>>2]|0,n)|0)|0;t=f[o>>2]|0;f[o>>2]=(t|0)>(oa|0)?oa:t;t=o+8|0;u=f[t>>2]|0;f[t>>2]=(u|0)<(oa|0)?oa:u;u=o+4|0;t=f[u>>2]|0;f[u>>2]=(t|0)>(x|0)?x:t;t=o+12|0;u=f[t>>2]|0;f[t>>2]=(u|0)<(x|0)?x:u;u=o+16|0;f[u>>2]=(f[u>>2]|0)+1;u=f[y>>2]|0;o=u+(n<<4)|0;t=o;v=Kac(f[t>>2]|0,f[t+4>>2]|0,oa|0,((oa|0)<0)<<31>>31|0)|0;t=o;f[t>>2]=v;f[t+4>>2]=J;ya=u+(n<<4)+8|0;za=s;Aa=u}u=ya;s=Kac(f[u>>2]|0,f[u+4>>2]|0,x|0,w|0)|0;u=ya;f[u>>2]=s;f[u+4>>2]=J;u=oa|1;s=p+(u<<2)|0;if(!(b[pa+u>>0]|0)){f[s>>2]=0;Ba=0;Ca=za}else{f[s>>2]=n;Ba=n;Ca=za+(Y(f[f[X>>2]>>2]|0,n)|0)|0}s=f[Ca>>2]|0;f[Ca>>2]=(s|0)>(u|0)?u:s;s=Ca+8|0;t=f[s>>2]|0;f[s>>2]=(t|0)<(u|0)?u:t;t=Ca+4|0;s=f[t>>2]|0;f[t>>2]=(s|0)>(x|0)?x:s;s=Ca+12|0;t=f[s>>2]|0;f[s>>2]=(t|0)<(x|0)?x:t;t=Ca+16|0;f[t>>2]=(f[t>>2]|0)+1;t=Aa+(Ba<<4)|0;s=t;v=Kac(f[s>>2]|0,f[s+4>>2]|0,u|0,((u|0)<0)<<31>>31|0)|0;s=t;f[s>>2]=v;f[s+4>>2]=J;s=Aa+(Ba<<4)+8|0;v=s;t=Kac(f[v>>2]|0,f[v+4>>2]|0,x|0,w|0)|0;v=s;f[v>>2]=t;f[v+4>>2]=J;if((T|0)<(f[(f[d>>2]|0)+8>>2]|0)){v=q+(oa<<2)|0;if(!(b[ta+oa>>0]|0)){f[v>>2]=0;Da=0;Ea=za}else{f[v>>2]=n;Da=n;Ea=za+(Y(f[f[Z>>2]>>2]|0,n)|0)|0}v=f[Ea>>2]|0;f[Ea>>2]=(v|0)>(oa|0)?oa:v;v=Ea+8|0;t=f[v>>2]|0;f[v>>2]=(t|0)<(oa|0)?oa:t;t=Ea+4|0;v=f[t>>2]|0;f[t>>2]=(v|0)>(T|0)?T:v;v=Ea+12|0;t=f[v>>2]|0;f[v>>2]=(t|0)<(T|0)?T:t;t=Ea+16|0;f[t>>2]=(f[t>>2]|0)+1;t=Aa+(Da<<4)|0;v=t;s=Kac(f[v>>2]|0,f[v+4>>2]|0,oa|0,((oa|0)<0)<<31>>31|0)|0;v=t;f[v>>2]=s;f[v+4>>2]=J;v=Aa+(Da<<4)+8|0;s=v;t=Kac(f[s>>2]|0,f[s+4>>2]|0,T|0,z|0)|0;s=v;f[s>>2]=t;f[s+4>>2]=J;s=q+(u<<2)|0;t=f[S>>2]|0;if(!(b[ta+u>>0]|0)){f[s>>2]=0;v=f[t>>2]|0;f[t>>2]=(v|0)>(u|0)?u:v;v=t+8|0;o=f[v>>2]|0;f[v>>2]=(o|0)<(u|0)?u:o;o=t+4|0;v=f[o>>2]|0;f[o>>2]=(v|0)>(T|0)?T:v;v=t+12|0;o=f[v>>2]|0;f[v>>2]=(o|0)<(T|0)?T:o;o=t+16|0;f[o>>2]=(f[o>>2]|0)+1;o=Aa;v=Kac(f[o>>2]|0,f[o+4>>2]|0,u|0,((u|0)<0)<<31>>31|0)|0;o=Aa;f[o>>2]=v;f[o+4>>2]=J;o=Aa+8|0;v=o;W=Kac(f[v>>2]|0,f[v+4>>2]|0,T|0,z|0)|0;v=o;f[v>>2]=W;f[v+4>>2]=J;break}else{f[s>>2]=n;s=t+(Y(f[f[r>>2]>>2]|0,n)|0)|0;t=f[s>>2]|0;f[s>>2]=(t|0)>(u|0)?u:t;t=s+8|0;v=f[t>>2]|0;f[t>>2]=(v|0)<(u|0)?u:v;v=s+4|0;t=f[v>>2]|0;f[v>>2]=(t|0)>(T|0)?T:t;t=s+12|0;v=f[t>>2]|0;f[t>>2]=(v|0)<(T|0)?T:v;v=s+16|0;f[v>>2]=(f[v>>2]|0)+1;v=Aa+(n<<4)|0;s=v;t=Kac(f[s>>2]|0,f[s+4>>2]|0,u|0,((u|0)<0)<<31>>31|0)|0;u=v;f[u>>2]=t;f[u+4>>2]=J;u=Aa+(n<<4)+8|0;n=u;t=Kac(f[n>>2]|0,f[n+4>>2]|0,T|0,z|0)|0;n=u;f[n>>2]=t;f[n+4>>2]=J;break}}}else{f[A>>2]=0;n=oa|1;f[p+(n<<2)>>2]=0;t=f[ua>>2]|0;u=f[t>>2]|0;v=(u|0)>(oa|0)?oa:u;u=t+8|0;s=f[u>>2]|0;W=(s|0)<(oa|0)?oa:s;s=t+4|0;o=f[s>>2]|0;R=t+12|0;m=f[R>>2]|0;l=t+16|0;fa=f[l>>2]|0;ba=f[va>>2]|0;M=((oa|0)<0)<<31>>31;L=ba;H=Kac(f[L>>2]|0,f[L+4>>2]|0,oa|0,M|0)|0;L=J;ia=ba+8|0;ka=ia;N=Kac(f[ka>>2]|0,f[ka+4>>2]|0,x|0,w|0)|0;ka=J;f[t>>2]=(v|0)>(n|0)?n:v;f[u>>2]=(W|0)<(n|0)?n:W;f[s>>2]=(o|0)>(x|0)?x:o;f[R>>2]=(m|0)<(x|0)?x:m;f[l>>2]=fa+2;fa=((n|0)<0)<<31>>31;m=Kac(H|0,L|0,n|0,fa|0)|0;L=J;H=ba;f[H>>2]=m;f[H+4>>2]=L;H=Kac(N|0,ka|0,x|0,w|0)|0;ka=J;N=ia;f[N>>2]=H;f[N+4>>2]=ka;if((T|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[q+(oa<<2)>>2]=0;f[q+(n<<2)>>2]=0;N=f[t>>2]|0;o=(N|0)>(oa|0)?oa:N;N=f[u>>2]|0;W=(N|0)<(oa|0)?oa:N;N=f[s>>2]|0;v=f[R>>2]|0;ca=f[l>>2]|0;D=Kac(m|0,L|0,oa|0,M|0)|0;M=J;L=Kac(H|0,ka|0,T|0,z|0)|0;ka=J;f[t>>2]=(o|0)>(n|0)?n:o;f[u>>2]=(W|0)<(n|0)?n:W;f[s>>2]=(N|0)>(T|0)?T:N;f[R>>2]=(v|0)<(T|0)?T:v;f[l>>2]=ca+2;ca=Kac(D|0,M|0,n|0,fa|0)|0;fa=ba;f[fa>>2]=ca;f[fa+4>>2]=J;fa=Kac(L|0,ka|0,T|0,z|0)|0;ka=ia;f[ka>>2]=fa;f[ka+4>>2]=J}}while(0);oa=oa+2|0;A=f[d>>2]|0;na=f[A+12>>2]|0}while((oa|0)<(na|0));Fa=na;Ga=A}else{Fa=sa;Ga=qa}x=x+2|0;if((x|0)>=(c|0))break;else{qa=Ga;sa=Fa}}return}if(!k)return;k=a+4|0;Fa=a+12|0;sa=g+(e*136|0)+20|0;Ga=g+(e*136|0)+120|0;qa=g+(e*136|0)+20|0;x=g+(e*136|0)+48|0;va=g+(e*136|0)+48|0;ua=g+(e*136|0)+48|0;Aa=g+(e*136|0)+20|0;r=g+(e*136|0)+48|0;S=g+(e*136|0)+20|0;Da=g+(e*136|0)+48|0;Ea=g+(e*136|0)+120|0;Z=g+(e*136|0)+20|0;za=g+(e*136|0)+120|0;g=e;Ba=h;h=i;while(1){i=f[k>>2]|0;Ca=f[f[i+44>>2]>>2]|0;X=(f[i+16>>2]|0)+(Y(Ca,g)|0)|0;i=X+Ca|0;Ca=f[f[Ba+44>>2]>>2]|0;ya=(f[Ba+16>>2]|0)+(Y(Ca,g)|0)|0;y=ya+Ca|0;if((h|0)>0){Ca=((g|0)<0)<<31>>31;_=g+1|0;ra=((_|0)<0)<<31>>31;xa=0;do{V=ya+(xa<<2)|0;wa=f[V>>2]|0;do if((wa|0)>0){j=f[(f[Fa>>2]|0)+(wa<<2)>>2]|0;if(!(b[X+xa>>0]|0)){f[V>>2]=0;oa=f[sa>>2]|0;z=f[oa>>2]|0;f[oa>>2]=(z|0)>(xa|0)?xa:z;z=oa+8|0;T=f[z>>2]|0;f[z>>2]=(T|0)<(xa|0)?xa:T;T=oa+4|0;z=f[T>>2]|0;f[T>>2]=(z|0)>(g|0)?g:z;z=oa+12|0;T=f[z>>2]|0;f[z>>2]=(T|0)<(g|0)?g:T;T=oa+16|0;f[T>>2]=(f[T>>2]|0)+1;T=f[Ga>>2]|0;z=T;q=Kac(f[z>>2]|0,f[z+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;z=T;f[z>>2]=q;f[z+4>>2]=J;Ha=T+8|0;Ia=oa;Ja=T}else{f[V>>2]=j;T=f[S>>2]|0;oa=T+(Y(f[f[Da>>2]>>2]|0,j)|0)|0;z=f[oa>>2]|0;f[oa>>2]=(z|0)>(xa|0)?xa:z;z=oa+8|0;q=f[z>>2]|0;f[z>>2]=(q|0)<(xa|0)?xa:q;q=oa+4|0;z=f[q>>2]|0;f[q>>2]=(z|0)>(g|0)?g:z;z=oa+12|0;q=f[z>>2]|0;f[z>>2]=(q|0)<(g|0)?g:q;q=oa+16|0;f[q>>2]=(f[q>>2]|0)+1;q=f[Ea>>2]|0;oa=q+(j<<4)|0;z=oa;w=Kac(f[z>>2]|0,f[z+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;z=oa;f[z>>2]=w;f[z+4>>2]=J;Ha=q+(j<<4)+8|0;Ia=T;Ja=q}q=Ha;T=Kac(f[q>>2]|0,f[q+4>>2]|0,g|0,Ca|0)|0;q=Ha;f[q>>2]=T;f[q+4>>2]=J;q=xa|1;T=f[d>>2]|0;if((q|0)>=(f[T+12>>2]|0)){if((_|0)>=(f[T+8>>2]|0))break;T=y+(xa<<2)|0;z=f[Aa>>2]|0;if(!(b[i+xa>>0]|0)){f[T>>2]=0;w=f[z>>2]|0;f[z>>2]=(w|0)>(xa|0)?xa:w;w=z+8|0;oa=f[w>>2]|0;f[w>>2]=(oa|0)<(xa|0)?xa:oa;oa=z+4|0;w=f[oa>>2]|0;f[oa>>2]=(w|0)>(_|0)?_:w;w=z+12|0;oa=f[w>>2]|0;f[w>>2]=(oa|0)<(_|0)?_:oa;oa=z+16|0;f[oa>>2]=(f[oa>>2]|0)+1;oa=Ja;w=Kac(f[oa>>2]|0,f[oa+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;oa=Ja;f[oa>>2]=w;f[oa+4>>2]=J;oa=Ja+8|0;w=oa;p=Kac(f[w>>2]|0,f[w+4>>2]|0,_|0,ra|0)|0;w=oa;f[w>>2]=p;f[w+4>>2]=J;break}else{f[T>>2]=j;T=z+(Y(f[f[r>>2]>>2]|0,j)|0)|0;z=f[T>>2]|0;f[T>>2]=(z|0)>(xa|0)?xa:z;z=T+8|0;w=f[z>>2]|0;f[z>>2]=(w|0)<(xa|0)?xa:w;w=T+4|0;z=f[w>>2]|0;f[w>>2]=(z|0)>(_|0)?_:z;z=T+12|0;w=f[z>>2]|0;f[z>>2]=(w|0)<(_|0)?_:w;w=T+16|0;f[w>>2]=(f[w>>2]|0)+1;w=Ja+(j<<4)|0;T=w;z=Kac(f[T>>2]|0,f[T+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;T=w;f[T>>2]=z;f[T+4>>2]=J;T=Ja+(j<<4)+8|0;z=T;w=Kac(f[z>>2]|0,f[z+4>>2]|0,_|0,ra|0)|0;z=T;f[z>>2]=w;f[z+4>>2]=J;break}}z=ya+(q<<2)|0;if(!(b[X+q>>0]|0)){f[z>>2]=0;Ka=0;La=Ia}else{f[z>>2]=j;Ka=j;La=Ia+(Y(f[f[ua>>2]>>2]|0,j)|0)|0}z=f[La>>2]|0;f[La>>2]=(z|0)>(q|0)?q:z;z=La+8|0;w=f[z>>2]|0;f[z>>2]=(w|0)<(q|0)?q:w;w=La+4|0;z=f[w>>2]|0;f[w>>2]=(z|0)>(g|0)?g:z;z=La+12|0;w=f[z>>2]|0;f[z>>2]=(w|0)<(g|0)?g:w;w=La+16|0;f[w>>2]=(f[w>>2]|0)+1;w=Ja+(Ka<<4)|0;z=w;T=Kac(f[z>>2]|0,f[z+4>>2]|0,q|0,((q|0)<0)<<31>>31|0)|0;z=w;f[z>>2]=T;f[z+4>>2]=J;z=Ja+(Ka<<4)+8|0;T=z;w=Kac(f[T>>2]|0,f[T+4>>2]|0,g|0,Ca|0)|0;T=z;f[T>>2]=w;f[T+4>>2]=J;if((_|0)<(f[(f[d>>2]|0)+8>>2]|0)){T=y+(xa<<2)|0;if(!(b[i+xa>>0]|0)){f[T>>2]=0;Ma=0;Na=Ia}else{f[T>>2]=j;Ma=j;Na=Ia+(Y(f[f[va>>2]>>2]|0,j)|0)|0}T=f[Na>>2]|0;f[Na>>2]=(T|0)>(xa|0)?xa:T;T=Na+8|0;w=f[T>>2]|0;f[T>>2]=(w|0)<(xa|0)?xa:w;w=Na+4|0;T=f[w>>2]|0;f[w>>2]=(T|0)>(_|0)?_:T;T=Na+12|0;w=f[T>>2]|0;f[T>>2]=(w|0)<(_|0)?_:w;w=Na+16|0;f[w>>2]=(f[w>>2]|0)+1;w=Ja+(Ma<<4)|0;T=w;z=Kac(f[T>>2]|0,f[T+4>>2]|0,xa|0,((xa|0)<0)<<31>>31|0)|0;T=w;f[T>>2]=z;f[T+4>>2]=J;T=Ja+(Ma<<4)+8|0;z=T;w=Kac(f[z>>2]|0,f[z+4>>2]|0,_|0,ra|0)|0;z=T;f[z>>2]=w;f[z+4>>2]=J;z=y+(q<<2)|0;w=f[qa>>2]|0;if(!(b[i+q>>0]|0)){f[z>>2]=0;T=f[w>>2]|0;f[w>>2]=(T|0)>(q|0)?q:T;T=w+8|0;p=f[T>>2]|0;f[T>>2]=(p|0)<(q|0)?q:p;p=w+4|0;T=f[p>>2]|0;f[p>>2]=(T|0)>(_|0)?_:T;T=w+12|0;p=f[T>>2]|0;f[T>>2]=(p|0)<(_|0)?_:p;p=w+16|0;f[p>>2]=(f[p>>2]|0)+1;p=Ja;T=Kac(f[p>>2]|0,f[p+4>>2]|0,q|0,((q|0)<0)<<31>>31|0)|0;p=Ja;f[p>>2]=T;f[p+4>>2]=J;p=Ja+8|0;T=p;oa=Kac(f[T>>2]|0,f[T+4>>2]|0,_|0,ra|0)|0;T=p;f[T>>2]=oa;f[T+4>>2]=J;break}else{f[z>>2]=j;z=w+(Y(f[f[x>>2]>>2]|0,j)|0)|0;w=f[z>>2]|0;f[z>>2]=(w|0)>(q|0)?q:w;w=z+8|0;T=f[w>>2]|0;f[w>>2]=(T|0)<(q|0)?q:T;T=z+4|0;w=f[T>>2]|0;f[T>>2]=(w|0)>(_|0)?_:w;w=z+12|0;T=f[w>>2]|0;f[w>>2]=(T|0)<(_|0)?_:T;T=z+16|0;f[T>>2]=(f[T>>2]|0)+1;T=Ja+(j<<4)|0;z=T;w=Kac(f[z>>2]|0,f[z+4>>2]|0,q|0,((q|0)<0)<<31>>31|0)|0;q=T;f[q>>2]=w;f[q+4>>2]=J;q=Ja+(j<<4)+8|0;j=q;w=Kac(f[j>>2]|0,f[j+4>>2]|0,_|0,ra|0)|0;j=q;f[j>>2]=w;f[j+4>>2]=J;break}}}else{f[V>>2]=0;j=f[Z>>2]|0;w=f[j>>2]|0;f[j>>2]=(w|0)>(xa|0)?xa:w;w=j+8|0;q=f[w>>2]|0;f[w>>2]=(q|0)<(xa|0)?xa:q;q=j+4|0;T=f[q>>2]|0;f[q>>2]=(T|0)>(g|0)?g:T;T=j+12|0;z=f[T>>2]|0;f[T>>2]=(z|0)<(g|0)?g:z;z=j+16|0;f[z>>2]=(f[z>>2]|0)+1;oa=f[za>>2]|0;p=((xa|0)<0)<<31>>31;ta=oa;pa=Kac(f[ta>>2]|0,f[ta+4>>2]|0,xa|0,p|0)|0;ta=J;A=oa;f[A>>2]=pa;f[A+4>>2]=ta;A=oa+8|0;na=A;ka=Kac(f[na>>2]|0,f[na+4>>2]|0,g|0,Ca|0)|0;na=J;fa=A;f[fa>>2]=ka;f[fa+4>>2]=na;fa=xa|1;ia=f[d>>2]|0;if((fa|0)<(f[ia+12>>2]|0)){f[ya+(fa<<2)>>2]=0;L=f[j>>2]|0;f[j>>2]=(L|0)>(fa|0)?fa:L;L=f[w>>2]|0;f[w>>2]=(L|0)<(fa|0)?fa:L;L=f[q>>2]|0;f[q>>2]=(L|0)>(g|0)?g:L;L=f[T>>2]|0;f[T>>2]=(L|0)<(g|0)?g:L;f[z>>2]=(f[z>>2]|0)+1;L=((fa|0)<0)<<31>>31;ca=Kac(pa|0,ta|0,fa|0,L|0)|0;ba=J;n=oa;f[n>>2]=ca;f[n+4>>2]=ba;n=Kac(ka|0,na|0,g|0,Ca|0)|0;M=J;D=A;f[D>>2]=n;f[D+4>>2]=M;if((_|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[y+(xa<<2)>>2]=0;f[y+(fa<<2)>>2]=0;D=f[j>>2]|0;l=(D|0)>(xa|0)?xa:D;D=f[w>>2]|0;v=(D|0)<(xa|0)?xa:D;D=f[q>>2]|0;R=f[T>>2]|0;N=f[z>>2]|0;s=Kac(ca|0,ba|0,xa|0,p|0)|0;ba=J;ca=Kac(n|0,M|0,_|0,ra|0)|0;M=J;f[j>>2]=(l|0)>(fa|0)?fa:l;f[w>>2]=(v|0)<(fa|0)?fa:v;f[q>>2]=(D|0)>(_|0)?_:D;f[T>>2]=(R|0)<(_|0)?_:R;f[z>>2]=N+2;N=Kac(s|0,ba|0,fa|0,L|0)|0;L=oa;f[L>>2]=N;f[L+4>>2]=J;L=Kac(ca|0,M|0,_|0,ra|0)|0;M=A;f[M>>2]=L;f[M+4>>2]=J;break}else{if((_|0)>=(f[ia+8>>2]|0))break;f[y+(xa<<2)>>2]=0;ia=f[j>>2]|0;f[j>>2]=(ia|0)>(xa|0)?xa:ia;ia=f[w>>2]|0;f[w>>2]=(ia|0)<(xa|0)?xa:ia;ia=f[q>>2]|0;f[q>>2]=(ia|0)>(_|0)?_:ia;ia=f[T>>2]|0;f[T>>2]=(ia|0)<(_|0)?_:ia;f[z>>2]=(f[z>>2]|0)+1;z=Kac(pa|0,ta|0,xa|0,p|0)|0;p=oa;f[p>>2]=z;f[p+4>>2]=J;p=Kac(ka|0,na|0,_|0,ra|0)|0;na=A;f[na>>2]=p;f[na+4>>2]=J;break}}while(0);xa=xa+2|0;V=f[d>>2]|0;wa=f[V+12>>2]|0}while((xa|0)<(wa|0));Oa=wa;Pa=V}else{Oa=h;Pa=Ba}g=g+2|0;if((g|0)>=(c|0))break;else{Ba=Pa;h=Oa}}return}else{Oa=a+16|0;f[(f[Oa>>2]|0)+132>>2]=c;h=a+8|0;Pa=f[h>>2]|0;Ba=f[Pa+12>>2]|0;g=(Ba&1|0)!=0;d=(e|0)<(c|0);if(!(f[Pa+8>>2]&1)){if(!g){if(!d)return;za=a+4|0;Z=a+12|0;Ja=e;x=Pa;qa=Ba;while(1){Ma=f[za>>2]|0;Na=f[f[Ma+44>>2]>>2]|0;va=(f[Ma+16>>2]|0)+(Y(Na,Ja)|0)|0;Ma=va+Na|0;Na=f[f[x+44>>2]>>2]|0;Ia=(f[x+16>>2]|0)+(Y(Na,Ja)|0)|0;Ka=Ia+Na|0;if((qa|0)>0){Na=((Ja|0)<0)<<31>>31;La=Ja+1|0;ua=((La|0)<0)<<31>>31;r=0;do{Aa=Ia+(r<<2)|0;Ha=f[Aa>>2]|0;do if((Ha|0)>0){Ea=f[(f[Z>>2]|0)+(Ha<<2)>>2]|0;if(!(b[va+r>>0]|0)){f[Aa>>2]=0;Da=f[Oa>>2]|0;S=f[Da+20>>2]|0;Ga=f[S>>2]|0;f[S>>2]=(Ga|0)>(r|0)?r:Ga;Ga=S+8|0;sa=f[Ga>>2]|0;f[Ga>>2]=(sa|0)<(r|0)?r:sa;sa=S+4|0;Ga=f[sa>>2]|0;f[sa>>2]=(Ga|0)>(Ja|0)?Ja:Ga;Ga=S+12|0;sa=f[Ga>>2]|0;f[Ga>>2]=(sa|0)<(Ja|0)?Ja:sa;sa=S+16|0;f[sa>>2]=(f[sa>>2]|0)+1;sa=f[Da+120>>2]|0;Da=sa;S=Kac(f[Da>>2]|0,f[Da+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Da=sa;f[Da>>2]=S;f[Da+4>>2]=J;Qa=sa+8|0}else{f[Aa>>2]=Ea;sa=f[Oa>>2]|0;Da=(f[sa+20>>2]|0)+(Y(f[f[sa+48>>2]>>2]|0,Ea)|0)|0;S=f[Da>>2]|0;f[Da>>2]=(S|0)>(r|0)?r:S;S=Da+8|0;Ga=f[S>>2]|0;f[S>>2]=(Ga|0)<(r|0)?r:Ga;Ga=Da+4|0;S=f[Ga>>2]|0;f[Ga>>2]=(S|0)>(Ja|0)?Ja:S;S=Da+12|0;Ga=f[S>>2]|0;f[S>>2]=(Ga|0)<(Ja|0)?Ja:Ga;Ga=Da+16|0;f[Ga>>2]=(f[Ga>>2]|0)+1;Ga=f[sa+120>>2]|0;sa=Ga+(Ea<<4)|0;Da=sa;S=Kac(f[Da>>2]|0,f[Da+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Da=sa;f[Da>>2]=S;f[Da+4>>2]=J;Qa=Ga+(Ea<<4)+8|0}Ga=Qa;Da=Kac(f[Ga>>2]|0,f[Ga+4>>2]|0,Ja|0,Na|0)|0;Ga=Qa;f[Ga>>2]=Da;f[Ga+4>>2]=J;Ga=r|1;Da=Ia+(Ga<<2)|0;if(!(b[va+Ga>>0]|0)){f[Da>>2]=0;S=f[Oa>>2]|0;sa=f[S+20>>2]|0;Fa=f[sa>>2]|0;f[sa>>2]=(Fa|0)>(Ga|0)?Ga:Fa;Fa=sa+8|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)<(Ga|0)?Ga:k;k=sa+4|0;Fa=f[k>>2]|0;f[k>>2]=(Fa|0)>(Ja|0)?Ja:Fa;Fa=sa+12|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)<(Ja|0)?Ja:k;k=sa+16|0;f[k>>2]=(f[k>>2]|0)+1;k=f[S+120>>2]|0;S=k;sa=Kac(f[S>>2]|0,f[S+4>>2]|0,Ga|0,((Ga|0)<0)<<31>>31|0)|0;S=k;f[S>>2]=sa;f[S+4>>2]=J;Ra=k+8|0}else{f[Da>>2]=Ea;Da=f[Oa>>2]|0;k=(f[Da+20>>2]|0)+(Y(f[f[Da+48>>2]>>2]|0,Ea)|0)|0;S=f[k>>2]|0;f[k>>2]=(S|0)>(Ga|0)?Ga:S;S=k+8|0;sa=f[S>>2]|0;f[S>>2]=(sa|0)<(Ga|0)?Ga:sa;sa=k+4|0;S=f[sa>>2]|0;f[sa>>2]=(S|0)>(Ja|0)?Ja:S;S=k+12|0;sa=f[S>>2]|0;f[S>>2]=(sa|0)<(Ja|0)?Ja:sa;sa=k+16|0;f[sa>>2]=(f[sa>>2]|0)+1;sa=f[Da+120>>2]|0;Da=sa+(Ea<<4)|0;k=Da;S=Kac(f[k>>2]|0,f[k+4>>2]|0,Ga|0,((Ga|0)<0)<<31>>31|0)|0;k=Da;f[k>>2]=S;f[k+4>>2]=J;Ra=sa+(Ea<<4)+8|0}sa=Ra;k=Kac(f[sa>>2]|0,f[sa+4>>2]|0,Ja|0,Na|0)|0;sa=Ra;f[sa>>2]=k;f[sa+4>>2]=J;sa=Ka+(r<<2)|0;if(!(b[Ma+r>>0]|0)){f[sa>>2]=0;k=f[Oa>>2]|0;S=f[k+20>>2]|0;Da=f[S>>2]|0;f[S>>2]=(Da|0)>(r|0)?r:Da;Da=S+8|0;Fa=f[Da>>2]|0;f[Da>>2]=(Fa|0)<(r|0)?r:Fa;Fa=S+4|0;Da=f[Fa>>2]|0;f[Fa>>2]=(Da|0)>(La|0)?La:Da;Da=S+12|0;Fa=f[Da>>2]|0;f[Da>>2]=(Fa|0)<(La|0)?La:Fa;Fa=S+16|0;f[Fa>>2]=(f[Fa>>2]|0)+1;Fa=f[k+120>>2]|0;k=Fa;S=Kac(f[k>>2]|0,f[k+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;k=Fa;f[k>>2]=S;f[k+4>>2]=J;Sa=Fa+8|0}else{f[sa>>2]=Ea;sa=f[Oa>>2]|0;Fa=(f[sa+20>>2]|0)+(Y(f[f[sa+48>>2]>>2]|0,Ea)|0)|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)>(r|0)?r:k;k=Fa+8|0;S=f[k>>2]|0;f[k>>2]=(S|0)<(r|0)?r:S;S=Fa+4|0;k=f[S>>2]|0;f[S>>2]=(k|0)>(La|0)?La:k;k=Fa+12|0;S=f[k>>2]|0;f[k>>2]=(S|0)<(La|0)?La:S;S=Fa+16|0;f[S>>2]=(f[S>>2]|0)+1;S=f[sa+120>>2]|0;sa=S+(Ea<<4)|0;Fa=sa;k=Kac(f[Fa>>2]|0,f[Fa+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Fa=sa;f[Fa>>2]=k;f[Fa+4>>2]=J;Sa=S+(Ea<<4)+8|0}S=Sa;Fa=Kac(f[S>>2]|0,f[S+4>>2]|0,La|0,ua|0)|0;S=Sa;f[S>>2]=Fa;f[S+4>>2]=J;S=Ka+(Ga<<2)|0;if(!(b[Ma+Ga>>0]|0)){f[S>>2]=0;Fa=f[Oa>>2]|0;k=f[Fa+20>>2]|0;sa=f[k>>2]|0;f[k>>2]=(sa|0)>(Ga|0)?Ga:sa;sa=k+8|0;Da=f[sa>>2]|0;f[sa>>2]=(Da|0)<(Ga|0)?Ga:Da;Da=k+4|0;sa=f[Da>>2]|0;f[Da>>2]=(sa|0)>(La|0)?La:sa;sa=k+12|0;Da=f[sa>>2]|0;f[sa>>2]=(Da|0)<(La|0)?La:Da;Da=k+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[Fa+120>>2]|0;Fa=Da;k=Kac(f[Fa>>2]|0,f[Fa+4>>2]|0,Ga|0,((Ga|0)<0)<<31>>31|0)|0;Fa=Da;f[Fa>>2]=k;f[Fa+4>>2]=J;Ta=Da+8|0;break}else{f[S>>2]=Ea;S=f[Oa>>2]|0;Da=(f[S+20>>2]|0)+(Y(f[f[S+48>>2]>>2]|0,Ea)|0)|0;Fa=f[Da>>2]|0;f[Da>>2]=(Fa|0)>(Ga|0)?Ga:Fa;Fa=Da+8|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)<(Ga|0)?Ga:k;k=Da+4|0;Fa=f[k>>2]|0;f[k>>2]=(Fa|0)>(La|0)?La:Fa;Fa=Da+12|0;k=f[Fa>>2]|0;f[Fa>>2]=(k|0)<(La|0)?La:k;k=Da+16|0;f[k>>2]=(f[k>>2]|0)+1;k=f[S+120>>2]|0;S=k+(Ea<<4)|0;Da=S;Fa=Kac(f[Da>>2]|0,f[Da+4>>2]|0,Ga|0,((Ga|0)<0)<<31>>31|0)|0;Ga=S;f[Ga>>2]=Fa;f[Ga+4>>2]=J;Ta=k+(Ea<<4)+8|0;break}}else{f[Aa>>2]=0;Ea=r|1;f[Ia+(Ea<<2)>>2]=0;f[Ka+(r<<2)>>2]=0;f[Ka+(Ea<<2)>>2]=0;k=f[Oa>>2]|0;Ga=f[k+20>>2]|0;Fa=f[Ga>>2]|0;f[Ga>>2]=(Fa|0)>(r|0)?r:Fa;Fa=Ga+8|0;S=f[Fa>>2]|0;f[Fa>>2]=(S|0)<(r|0)?r:S;S=Ga+4|0;Fa=f[S>>2]|0;f[S>>2]=(Fa|0)>(Ja|0)?Ja:Fa;Fa=Ga+12|0;S=f[Fa>>2]|0;f[Fa>>2]=(S|0)<(Ja|0)?Ja:S;S=Ga+16|0;f[S>>2]=(f[S>>2]|0)+1;S=f[k+120>>2]|0;k=((r|0)<0)<<31>>31;Ga=S;Fa=Kac(f[Ga>>2]|0,f[Ga+4>>2]|0,r|0,k|0)|0;Ga=S;f[Ga>>2]=Fa;f[Ga+4>>2]=J;Ga=S+8|0;S=Ga;Fa=Kac(f[S>>2]|0,f[S+4>>2]|0,Ja|0,Na|0)|0;S=Ga;f[S>>2]=Fa;f[S+4>>2]=J;S=f[Oa>>2]|0;Fa=f[S+20>>2]|0;Ga=f[Fa>>2]|0;f[Fa>>2]=(Ga|0)>(Ea|0)?Ea:Ga;Ga=Fa+8|0;Da=f[Ga>>2]|0;f[Ga>>2]=(Da|0)<(Ea|0)?Ea:Da;Da=Fa+4|0;Ga=f[Da>>2]|0;f[Da>>2]=(Ga|0)>(Ja|0)?Ja:Ga;Ga=Fa+12|0;Da=f[Ga>>2]|0;f[Ga>>2]=(Da|0)<(Ja|0)?Ja:Da;Da=Fa+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[S+120>>2]|0;S=((Ea|0)<0)<<31>>31;Fa=Da;Ga=Kac(f[Fa>>2]|0,f[Fa+4>>2]|0,Ea|0,S|0)|0;Fa=Da;f[Fa>>2]=Ga;f[Fa+4>>2]=J;Fa=Da+8|0;Da=Fa;Ga=Kac(f[Da>>2]|0,f[Da+4>>2]|0,Ja|0,Na|0)|0;Da=Fa;f[Da>>2]=Ga;f[Da+4>>2]=J;Da=f[Oa>>2]|0;Ga=f[Da+20>>2]|0;Fa=f[Ga>>2]|0;f[Ga>>2]=(Fa|0)>(r|0)?r:Fa;Fa=Ga+8|0;sa=f[Fa>>2]|0;f[Fa>>2]=(sa|0)<(r|0)?r:sa;sa=Ga+4|0;Fa=f[sa>>2]|0;f[sa>>2]=(Fa|0)>(La|0)?La:Fa;Fa=Ga+12|0;sa=f[Fa>>2]|0;f[Fa>>2]=(sa|0)<(La|0)?La:sa;sa=Ga+16|0;f[sa>>2]=(f[sa>>2]|0)+1;sa=f[Da+120>>2]|0;Da=sa;Ga=Kac(f[Da>>2]|0,f[Da+4>>2]|0,r|0,k|0)|0;k=sa;f[k>>2]=Ga;f[k+4>>2]=J;k=sa+8|0;sa=k;Ga=Kac(f[sa>>2]|0,f[sa+4>>2]|0,La|0,ua|0)|0;sa=k;f[sa>>2]=Ga;f[sa+4>>2]=J;sa=f[Oa>>2]|0;Ga=f[sa+20>>2]|0;k=f[Ga>>2]|0;f[Ga>>2]=(k|0)>(Ea|0)?Ea:k;k=Ga+8|0;Da=f[k>>2]|0;f[k>>2]=(Da|0)<(Ea|0)?Ea:Da;Da=Ga+4|0;k=f[Da>>2]|0;f[Da>>2]=(k|0)>(La|0)?La:k;k=Ga+12|0;Da=f[k>>2]|0;f[k>>2]=(Da|0)<(La|0)?La:Da;Da=Ga+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[sa+120>>2]|0;sa=Da;Ga=Kac(f[sa>>2]|0,f[sa+4>>2]|0,Ea|0,S|0)|0;S=Da;f[S>>2]=Ga;f[S+4>>2]=J;Ta=Da+8|0}while(0);Aa=Ta;Ha=Kac(f[Aa>>2]|0,f[Aa+4>>2]|0,La|0,ua|0)|0;Aa=Ta;f[Aa>>2]=Ha;f[Aa+4>>2]=J;r=r+2|0;Aa=f[h>>2]|0;Ha=f[Aa+12>>2]|0}while((r|0)<(Ha|0));Ua=Ha;Va=Aa}else{Ua=qa;Va=x}Ja=Ja+2|0;if((Ja|0)>=(c|0))break;else{x=Va;qa=Ua}}return}if(!d)return;Ua=a+4|0;qa=a+12|0;Va=e;x=Pa;Ja=Ba;while(1){Ta=f[Ua>>2]|0;Sa=f[f[Ta+44>>2]>>2]|0;Ra=(f[Ta+16>>2]|0)+(Y(Sa,Va)|0)|0;Ta=Ra+Sa|0;Sa=f[f[x+44>>2]>>2]|0;Qa=(f[x+16>>2]|0)+(Y(Sa,Va)|0)|0;Z=Qa+Sa|0;if((Ja|0)>0){Sa=((Va|0)<0)<<31>>31;za=Va+1|0;r=((za|0)<0)<<31>>31;ua=0;do{La=Qa+(ua<<2)|0;Na=f[La>>2]|0;do if((Na|0)>0){Ka=f[(f[qa>>2]|0)+(Na<<2)>>2]|0;if(!(b[Ra+ua>>0]|0)){f[La>>2]=0;Ia=f[Oa>>2]|0;Ma=f[Ia+20>>2]|0;va=f[Ma>>2]|0;f[Ma>>2]=(va|0)>(ua|0)?ua:va;va=Ma+8|0;Aa=f[va>>2]|0;f[va>>2]=(Aa|0)<(ua|0)?ua:Aa;Aa=Ma+4|0;va=f[Aa>>2]|0;f[Aa>>2]=(va|0)>(Va|0)?Va:va;va=Ma+12|0;Aa=f[va>>2]|0;f[va>>2]=(Aa|0)<(Va|0)?Va:Aa;Aa=Ma+16|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=f[Ia+120>>2]|0;Ia=Aa;Ma=Kac(f[Ia>>2]|0,f[Ia+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ia=Aa;f[Ia>>2]=Ma;f[Ia+4>>2]=J;Wa=Aa+8|0}else{f[La>>2]=Ka;Aa=f[Oa>>2]|0;Ia=(f[Aa+20>>2]|0)+(Y(f[f[Aa+48>>2]>>2]|0,Ka)|0)|0;Ma=f[Ia>>2]|0;f[Ia>>2]=(Ma|0)>(ua|0)?ua:Ma;Ma=Ia+8|0;va=f[Ma>>2]|0;f[Ma>>2]=(va|0)<(ua|0)?ua:va;va=Ia+4|0;Ma=f[va>>2]|0;f[va>>2]=(Ma|0)>(Va|0)?Va:Ma;Ma=Ia+12|0;va=f[Ma>>2]|0;f[Ma>>2]=(va|0)<(Va|0)?Va:va;va=Ia+16|0;f[va>>2]=(f[va>>2]|0)+1;va=f[Aa+120>>2]|0;Aa=va+(Ka<<4)|0;Ia=Aa;Ma=Kac(f[Ia>>2]|0,f[Ia+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ia=Aa;f[Ia>>2]=Ma;f[Ia+4>>2]=J;Wa=va+(Ka<<4)+8|0}va=Wa;Ia=Kac(f[va>>2]|0,f[va+4>>2]|0,Va|0,Sa|0)|0;va=Wa;f[va>>2]=Ia;f[va+4>>2]=J;va=Z+(ua<<2)|0;if(!(b[Ta+ua>>0]|0)){f[va>>2]=0;Ia=f[Oa>>2]|0;Ma=f[Ia+20>>2]|0;Aa=f[Ma>>2]|0;f[Ma>>2]=(Aa|0)>(ua|0)?ua:Aa;Aa=Ma+8|0;Ha=f[Aa>>2]|0;f[Aa>>2]=(Ha|0)<(ua|0)?ua:Ha;Ha=Ma+4|0;Aa=f[Ha>>2]|0;f[Ha>>2]=(Aa|0)>(za|0)?za:Aa;Aa=Ma+12|0;Ha=f[Aa>>2]|0;f[Aa>>2]=(Ha|0)<(za|0)?za:Ha;Ha=Ma+16|0;f[Ha>>2]=(f[Ha>>2]|0)+1;Ha=f[Ia+120>>2]|0;Ia=Ha;Ma=Kac(f[Ia>>2]|0,f[Ia+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ia=Ha;f[Ia>>2]=Ma;f[Ia+4>>2]=J;Xa=Ha+8|0}else{f[va>>2]=Ka;va=f[Oa>>2]|0;Ha=(f[va+20>>2]|0)+(Y(f[f[va+48>>2]>>2]|0,Ka)|0)|0;Ia=f[Ha>>2]|0;f[Ha>>2]=(Ia|0)>(ua|0)?ua:Ia;Ia=Ha+8|0;Ma=f[Ia>>2]|0;f[Ia>>2]=(Ma|0)<(ua|0)?ua:Ma;Ma=Ha+4|0;Ia=f[Ma>>2]|0;f[Ma>>2]=(Ia|0)>(za|0)?za:Ia;Ia=Ha+12|0;Ma=f[Ia>>2]|0;f[Ia>>2]=(Ma|0)<(za|0)?za:Ma;Ma=Ha+16|0;f[Ma>>2]=(f[Ma>>2]|0)+1;Ma=f[va+120>>2]|0;va=Ma+(Ka<<4)|0;Ha=va;Ia=Kac(f[Ha>>2]|0,f[Ha+4>>2]|0,ua|0,((ua|0)<0)<<31>>31|0)|0;Ha=va;f[Ha>>2]=Ia;f[Ha+4>>2]=J;Xa=Ma+(Ka<<4)+8|0}Ma=Xa;Ha=Kac(f[Ma>>2]|0,f[Ma+4>>2]|0,za|0,r|0)|0;Ma=Xa;f[Ma>>2]=Ha;f[Ma+4>>2]=J;Ma=ua|1;if((Ma|0)<(f[(f[h>>2]|0)+12>>2]|0)){Ha=Qa+(Ma<<2)|0;if(!(b[Ra+Ma>>0]|0)){f[Ha>>2]=0;Ia=f[Oa>>2]|0;va=f[Ia+20>>2]|0;Aa=f[va>>2]|0;f[va>>2]=(Aa|0)>(Ma|0)?Ma:Aa;Aa=va+8|0;Da=f[Aa>>2]|0;f[Aa>>2]=(Da|0)<(Ma|0)?Ma:Da;Da=va+4|0;Aa=f[Da>>2]|0;f[Da>>2]=(Aa|0)>(Va|0)?Va:Aa;Aa=va+12|0;Da=f[Aa>>2]|0;f[Aa>>2]=(Da|0)<(Va|0)?Va:Da;Da=va+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[Ia+120>>2]|0;Ia=Da;va=Kac(f[Ia>>2]|0,f[Ia+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Ia=Da;f[Ia>>2]=va;f[Ia+4>>2]=J;Ya=Da+8|0}else{f[Ha>>2]=Ka;Ha=f[Oa>>2]|0;Da=(f[Ha+20>>2]|0)+(Y(f[f[Ha+48>>2]>>2]|0,Ka)|0)|0;Ia=f[Da>>2]|0;f[Da>>2]=(Ia|0)>(Ma|0)?Ma:Ia;Ia=Da+8|0;va=f[Ia>>2]|0;f[Ia>>2]=(va|0)<(Ma|0)?Ma:va;va=Da+4|0;Ia=f[va>>2]|0;f[va>>2]=(Ia|0)>(Va|0)?Va:Ia;Ia=Da+12|0;va=f[Ia>>2]|0;f[Ia>>2]=(va|0)<(Va|0)?Va:va;va=Da+16|0;f[va>>2]=(f[va>>2]|0)+1;va=f[Ha+120>>2]|0;Ha=va+(Ka<<4)|0;Da=Ha;Ia=Kac(f[Da>>2]|0,f[Da+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Da=Ha;f[Da>>2]=Ia;f[Da+4>>2]=J;Ya=va+(Ka<<4)+8|0}va=Ya;Da=Kac(f[va>>2]|0,f[va+4>>2]|0,Va|0,Sa|0)|0;va=Ya;f[va>>2]=Da;f[va+4>>2]=J;va=Z+(Ma<<2)|0;if(!(b[Ta+Ma>>0]|0)){f[va>>2]=0;Da=f[Oa>>2]|0;Ia=f[Da+20>>2]|0;Ha=f[Ia>>2]|0;f[Ia>>2]=(Ha|0)>(Ma|0)?Ma:Ha;Ha=Ia+8|0;Aa=f[Ha>>2]|0;f[Ha>>2]=(Aa|0)<(Ma|0)?Ma:Aa;Aa=Ia+4|0;Ha=f[Aa>>2]|0;f[Aa>>2]=(Ha|0)>(za|0)?za:Ha;Ha=Ia+12|0;Aa=f[Ha>>2]|0;f[Ha>>2]=(Aa|0)<(za|0)?za:Aa;Aa=Ia+16|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=f[Da+120>>2]|0;Da=Aa;Ia=Kac(f[Da>>2]|0,f[Da+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Da=Aa;f[Da>>2]=Ia;f[Da+4>>2]=J;Da=Aa+8|0;Aa=Da;Ia=Kac(f[Aa>>2]|0,f[Aa+4>>2]|0,za|0,r|0)|0;Aa=Da;f[Aa>>2]=Ia;f[Aa+4>>2]=J;break}else{f[va>>2]=Ka;va=f[Oa>>2]|0;Aa=(f[va+20>>2]|0)+(Y(f[f[va+48>>2]>>2]|0,Ka)|0)|0;Ia=f[Aa>>2]|0;f[Aa>>2]=(Ia|0)>(Ma|0)?Ma:Ia;Ia=Aa+8|0;Da=f[Ia>>2]|0;f[Ia>>2]=(Da|0)<(Ma|0)?Ma:Da;Da=Aa+4|0;Ia=f[Da>>2]|0;f[Da>>2]=(Ia|0)>(za|0)?za:Ia;Ia=Aa+12|0;Da=f[Ia>>2]|0;f[Ia>>2]=(Da|0)<(za|0)?za:Da;Da=Aa+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[va+120>>2]|0;va=Da+(Ka<<4)|0;Aa=va;Ia=Kac(f[Aa>>2]|0,f[Aa+4>>2]|0,Ma|0,((Ma|0)<0)<<31>>31|0)|0;Ma=va;f[Ma>>2]=Ia;f[Ma+4>>2]=J;Ma=Da+(Ka<<4)+8|0;Ka=Ma;Da=Kac(f[Ka>>2]|0,f[Ka+4>>2]|0,za|0,r|0)|0;Ka=Ma;f[Ka>>2]=Da;f[Ka+4>>2]=J;break}}}else{f[La>>2]=0;f[Z+(ua<<2)>>2]=0;Ka=f[Oa>>2]|0;Da=f[Ka+20>>2]|0;Ma=f[Da>>2]|0;f[Da>>2]=(Ma|0)>(ua|0)?ua:Ma;Ma=Da+8|0;Ia=f[Ma>>2]|0;f[Ma>>2]=(Ia|0)<(ua|0)?ua:Ia;Ia=Da+4|0;Ma=f[Ia>>2]|0;f[Ia>>2]=(Ma|0)>(Va|0)?Va:Ma;Ma=Da+12|0;Ia=f[Ma>>2]|0;f[Ma>>2]=(Ia|0)<(Va|0)?Va:Ia;Ia=Da+16|0;f[Ia>>2]=(f[Ia>>2]|0)+1;Ia=f[Ka+120>>2]|0;Ka=((ua|0)<0)<<31>>31;Da=Ia;Ma=Kac(f[Da>>2]|0,f[Da+4>>2]|0,ua|0,Ka|0)|0;Da=Ia;f[Da>>2]=Ma;f[Da+4>>2]=J;Da=Ia+8|0;Ia=Da;Ma=Kac(f[Ia>>2]|0,f[Ia+4>>2]|0,Va|0,Sa|0)|0;Ia=Da;f[Ia>>2]=Ma;f[Ia+4>>2]=J;Ia=f[Oa>>2]|0;Ma=f[Ia+20>>2]|0;Da=f[Ma>>2]|0;f[Ma>>2]=(Da|0)>(ua|0)?ua:Da;Da=Ma+8|0;va=f[Da>>2]|0;f[Da>>2]=(va|0)<(ua|0)?ua:va;va=Ma+4|0;Da=f[va>>2]|0;f[va>>2]=(Da|0)>(za|0)?za:Da;Da=Ma+12|0;va=f[Da>>2]|0;f[Da>>2]=(va|0)<(za|0)?za:va;va=Ma+16|0;f[va>>2]=(f[va>>2]|0)+1;va=f[Ia+120>>2]|0;Ia=va;Ma=Kac(f[Ia>>2]|0,f[Ia+4>>2]|0,ua|0,Ka|0)|0;Ka=va;f[Ka>>2]=Ma;f[Ka+4>>2]=J;Ka=va+8|0;va=Ka;Ma=Kac(f[va>>2]|0,f[va+4>>2]|0,za|0,r|0)|0;va=Ka;f[va>>2]=Ma;f[va+4>>2]=J;va=ua|1;if((va|0)<(f[(f[h>>2]|0)+12>>2]|0)){f[Qa+(va<<2)>>2]=0;f[Z+(va<<2)>>2]=0;Ma=f[Oa>>2]|0;Ka=f[Ma+20>>2]|0;Ia=f[Ka>>2]|0;f[Ka>>2]=(Ia|0)>(va|0)?va:Ia;Ia=Ka+8|0;Da=f[Ia>>2]|0;f[Ia>>2]=(Da|0)<(va|0)?va:Da;Da=Ka+4|0;Ia=f[Da>>2]|0;f[Da>>2]=(Ia|0)>(Va|0)?Va:Ia;Ia=Ka+12|0;Da=f[Ia>>2]|0;f[Ia>>2]=(Da|0)<(Va|0)?Va:Da;Da=Ka+16|0;f[Da>>2]=(f[Da>>2]|0)+1;Da=f[Ma+120>>2]|0;Ma=((va|0)<0)<<31>>31;Ka=Da;Ia=Kac(f[Ka>>2]|0,f[Ka+4>>2]|0,va|0,Ma|0)|0;Ka=Da;f[Ka>>2]=Ia;f[Ka+4>>2]=J;Ka=Da+8|0;Da=Ka;Ia=Kac(f[Da>>2]|0,f[Da+4>>2]|0,Va|0,Sa|0)|0;Da=Ka;f[Da>>2]=Ia;f[Da+4>>2]=J;Da=f[Oa>>2]|0;Ia=f[Da+20>>2]|0;Ka=f[Ia>>2]|0;f[Ia>>2]=(Ka|0)>(va|0)?va:Ka;Ka=Ia+8|0;Aa=f[Ka>>2]|0;f[Ka>>2]=(Aa|0)<(va|0)?va:Aa;Aa=Ia+4|0;Ka=f[Aa>>2]|0;f[Aa>>2]=(Ka|0)>(za|0)?za:Ka;Ka=Ia+12|0;Aa=f[Ka>>2]|0;f[Ka>>2]=(Aa|0)<(za|0)?za:Aa;Aa=Ia+16|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=f[Da+120>>2]|0;Da=Aa;Ia=Kac(f[Da>>2]|0,f[Da+4>>2]|0,va|0,Ma|0)|0;Ma=Aa;f[Ma>>2]=Ia;f[Ma+4>>2]=J;Ma=Aa+8|0;Aa=Ma;Ia=Kac(f[Aa>>2]|0,f[Aa+4>>2]|0,za|0,r|0)|0;Aa=Ma;f[Aa>>2]=Ia;f[Aa+4>>2]=J}}while(0);ua=ua+2|0;La=f[h>>2]|0;Na=f[La+12>>2]|0}while((ua|0)<(Na|0));Za=Na;_a=La}else{Za=Ja;_a=x}Va=Va+2|0;if((Va|0)>=(c|0))break;else{x=_a;Ja=Za}}return}if(!g){if(!d)return;g=a+4|0;Za=a+12|0;Ja=e;_a=Pa;x=Ba;while(1){Va=f[g>>2]|0;Ya=f[f[Va+44>>2]>>2]|0;Xa=(f[Va+16>>2]|0)+(Y(Ya,Ja)|0)|0;Va=Xa+Ya|0;Ya=f[f[_a+44>>2]>>2]|0;Wa=(f[_a+16>>2]|0)+(Y(Ya,Ja)|0)|0;qa=Wa+Ya|0;if((x|0)>0){Ya=((Ja|0)<0)<<31>>31;Ua=Ja+1|0;ua=((Ua|0)<0)<<31>>31;r=0;do{za=Wa+(r<<2)|0;Sa=f[za>>2]|0;do if((Sa|0)>0){Z=f[(f[Za>>2]|0)+(Sa<<2)>>2]|0;if(!(b[Xa+r>>0]|0)){f[za>>2]=0;Qa=f[Oa>>2]|0;Ta=f[Qa+20>>2]|0;Ra=f[Ta>>2]|0;f[Ta>>2]=(Ra|0)>(r|0)?r:Ra;Ra=Ta+8|0;La=f[Ra>>2]|0;f[Ra>>2]=(La|0)<(r|0)?r:La;La=Ta+4|0;Ra=f[La>>2]|0;f[La>>2]=(Ra|0)>(Ja|0)?Ja:Ra;Ra=Ta+12|0;La=f[Ra>>2]|0;f[Ra>>2]=(La|0)<(Ja|0)?Ja:La;La=Ta+16|0;f[La>>2]=(f[La>>2]|0)+1;La=f[Qa+120>>2]|0;Qa=La;Ta=Kac(f[Qa>>2]|0,f[Qa+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Qa=La;f[Qa>>2]=Ta;f[Qa+4>>2]=J;$a=La+8|0}else{f[za>>2]=Z;La=f[Oa>>2]|0;Qa=(f[La+20>>2]|0)+(Y(f[f[La+48>>2]>>2]|0,Z)|0)|0;Ta=f[Qa>>2]|0;f[Qa>>2]=(Ta|0)>(r|0)?r:Ta;Ta=Qa+8|0;Ra=f[Ta>>2]|0;f[Ta>>2]=(Ra|0)<(r|0)?r:Ra;Ra=Qa+4|0;Ta=f[Ra>>2]|0;f[Ra>>2]=(Ta|0)>(Ja|0)?Ja:Ta;Ta=Qa+12|0;Ra=f[Ta>>2]|0;f[Ta>>2]=(Ra|0)<(Ja|0)?Ja:Ra;Ra=Qa+16|0;f[Ra>>2]=(f[Ra>>2]|0)+1;Ra=f[La+120>>2]|0;La=Ra+(Z<<4)|0;Qa=La;Ta=Kac(f[Qa>>2]|0,f[Qa+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Qa=La;f[Qa>>2]=Ta;f[Qa+4>>2]=J;$a=Ra+(Z<<4)+8|0}Ra=$a;Qa=Kac(f[Ra>>2]|0,f[Ra+4>>2]|0,Ja|0,Ya|0)|0;Ra=$a;f[Ra>>2]=Qa;f[Ra+4>>2]=J;Ra=r|1;Qa=Wa+(Ra<<2)|0;if(!(b[Xa+Ra>>0]|0)){f[Qa>>2]=0;Ta=f[Oa>>2]|0;La=f[Ta+20>>2]|0;Na=f[La>>2]|0;f[La>>2]=(Na|0)>(Ra|0)?Ra:Na;Na=La+8|0;Aa=f[Na>>2]|0;f[Na>>2]=(Aa|0)<(Ra|0)?Ra:Aa;Aa=La+4|0;Na=f[Aa>>2]|0;f[Aa>>2]=(Na|0)>(Ja|0)?Ja:Na;Na=La+12|0;Aa=f[Na>>2]|0;f[Na>>2]=(Aa|0)<(Ja|0)?Ja:Aa;Aa=La+16|0;f[Aa>>2]=(f[Aa>>2]|0)+1;Aa=f[Ta+120>>2]|0;Ta=Aa;La=Kac(f[Ta>>2]|0,f[Ta+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Ta=Aa;f[Ta>>2]=La;f[Ta+4>>2]=J;ab=Aa+8|0}else{f[Qa>>2]=Z;Qa=f[Oa>>2]|0;Aa=(f[Qa+20>>2]|0)+(Y(f[f[Qa+48>>2]>>2]|0,Z)|0)|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)>(Ra|0)?Ra:Ta;Ta=Aa+8|0;La=f[Ta>>2]|0;f[Ta>>2]=(La|0)<(Ra|0)?Ra:La;La=Aa+4|0;Ta=f[La>>2]|0;f[La>>2]=(Ta|0)>(Ja|0)?Ja:Ta;Ta=Aa+12|0;La=f[Ta>>2]|0;f[Ta>>2]=(La|0)<(Ja|0)?Ja:La;La=Aa+16|0;f[La>>2]=(f[La>>2]|0)+1;La=f[Qa+120>>2]|0;Qa=La+(Z<<4)|0;Aa=Qa;Ta=Kac(f[Aa>>2]|0,f[Aa+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Aa=Qa;f[Aa>>2]=Ta;f[Aa+4>>2]=J;ab=La+(Z<<4)+8|0}La=ab;Aa=Kac(f[La>>2]|0,f[La+4>>2]|0,Ja|0,Ya|0)|0;La=ab;f[La>>2]=Aa;f[La+4>>2]=J;if((Ua|0)<(f[(f[h>>2]|0)+8>>2]|0)){La=qa+(r<<2)|0;if(!(b[Va+r>>0]|0)){f[La>>2]=0;Aa=f[Oa>>2]|0;Ta=f[Aa+20>>2]|0;Qa=f[Ta>>2]|0;f[Ta>>2]=(Qa|0)>(r|0)?r:Qa;Qa=Ta+8|0;Na=f[Qa>>2]|0;f[Qa>>2]=(Na|0)<(r|0)?r:Na;Na=Ta+4|0;Qa=f[Na>>2]|0;f[Na>>2]=(Qa|0)>(Ua|0)?Ua:Qa;Qa=Ta+12|0;Na=f[Qa>>2]|0;f[Qa>>2]=(Na|0)<(Ua|0)?Ua:Na;Na=Ta+16|0;f[Na>>2]=(f[Na>>2]|0)+1;Na=f[Aa+120>>2]|0;Aa=Na;Ta=Kac(f[Aa>>2]|0,f[Aa+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Aa=Na;f[Aa>>2]=Ta;f[Aa+4>>2]=J;bb=Na+8|0}else{f[La>>2]=Z;La=f[Oa>>2]|0;Na=(f[La+20>>2]|0)+(Y(f[f[La+48>>2]>>2]|0,Z)|0)|0;Aa=f[Na>>2]|0;f[Na>>2]=(Aa|0)>(r|0)?r:Aa;Aa=Na+8|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)<(r|0)?r:Ta;Ta=Na+4|0;Aa=f[Ta>>2]|0;f[Ta>>2]=(Aa|0)>(Ua|0)?Ua:Aa;Aa=Na+12|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)<(Ua|0)?Ua:Ta;Ta=Na+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=f[La+120>>2]|0;La=Ta+(Z<<4)|0;Na=La;Aa=Kac(f[Na>>2]|0,f[Na+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;Na=La;f[Na>>2]=Aa;f[Na+4>>2]=J;bb=Ta+(Z<<4)+8|0}Ta=bb;Na=Kac(f[Ta>>2]|0,f[Ta+4>>2]|0,Ua|0,ua|0)|0;Ta=bb;f[Ta>>2]=Na;f[Ta+4>>2]=J;Ta=qa+(Ra<<2)|0;if(!(b[Va+Ra>>0]|0)){f[Ta>>2]=0;Na=f[Oa>>2]|0;Aa=f[Na+20>>2]|0;La=f[Aa>>2]|0;f[Aa>>2]=(La|0)>(Ra|0)?Ra:La;La=Aa+8|0;Qa=f[La>>2]|0;f[La>>2]=(Qa|0)<(Ra|0)?Ra:Qa;Qa=Aa+4|0;La=f[Qa>>2]|0;f[Qa>>2]=(La|0)>(Ua|0)?Ua:La;La=Aa+12|0;Qa=f[La>>2]|0;f[La>>2]=(Qa|0)<(Ua|0)?Ua:Qa;Qa=Aa+16|0;f[Qa>>2]=(f[Qa>>2]|0)+1;Qa=f[Na+120>>2]|0;Na=Qa;Aa=Kac(f[Na>>2]|0,f[Na+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Na=Qa;f[Na>>2]=Aa;f[Na+4>>2]=J;Na=Qa+8|0;Qa=Na;Aa=Kac(f[Qa>>2]|0,f[Qa+4>>2]|0,Ua|0,ua|0)|0;Qa=Na;f[Qa>>2]=Aa;f[Qa+4>>2]=J;break}else{f[Ta>>2]=Z;Ta=f[Oa>>2]|0;Qa=(f[Ta+20>>2]|0)+(Y(f[f[Ta+48>>2]>>2]|0,Z)|0)|0;Aa=f[Qa>>2]|0;f[Qa>>2]=(Aa|0)>(Ra|0)?Ra:Aa;Aa=Qa+8|0;Na=f[Aa>>2]|0;f[Aa>>2]=(Na|0)<(Ra|0)?Ra:Na;Na=Qa+4|0;Aa=f[Na>>2]|0;f[Na>>2]=(Aa|0)>(Ua|0)?Ua:Aa;Aa=Qa+12|0;Na=f[Aa>>2]|0;f[Aa>>2]=(Na|0)<(Ua|0)?Ua:Na;Na=Qa+16|0;f[Na>>2]=(f[Na>>2]|0)+1;Na=f[Ta+120>>2]|0;Ta=Na+(Z<<4)|0;Qa=Ta;Aa=Kac(f[Qa>>2]|0,f[Qa+4>>2]|0,Ra|0,((Ra|0)<0)<<31>>31|0)|0;Ra=Ta;f[Ra>>2]=Aa;f[Ra+4>>2]=J;Ra=Na+(Z<<4)+8|0;Z=Ra;Na=Kac(f[Z>>2]|0,f[Z+4>>2]|0,Ua|0,ua|0)|0;Z=Ra;f[Z>>2]=Na;f[Z+4>>2]=J;break}}}else{f[za>>2]=0;Z=r|1;f[Wa+(Z<<2)>>2]=0;Na=f[Oa>>2]|0;Ra=f[Na+20>>2]|0;Aa=f[Ra>>2]|0;f[Ra>>2]=(Aa|0)>(r|0)?r:Aa;Aa=Ra+8|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)<(r|0)?r:Ta;Ta=Ra+4|0;Aa=f[Ta>>2]|0;f[Ta>>2]=(Aa|0)>(Ja|0)?Ja:Aa;Aa=Ra+12|0;Ta=f[Aa>>2]|0;f[Aa>>2]=(Ta|0)<(Ja|0)?Ja:Ta;Ta=Ra+16|0;f[Ta>>2]=(f[Ta>>2]|0)+1;Ta=f[Na+120>>2]|0;Na=((r|0)<0)<<31>>31;Ra=Ta;Aa=Kac(f[Ra>>2]|0,f[Ra+4>>2]|0,r|0,Na|0)|0;Ra=Ta;f[Ra>>2]=Aa;f[Ra+4>>2]=J;Ra=Ta+8|0;Ta=Ra;Aa=Kac(f[Ta>>2]|0,f[Ta+4>>2]|0,Ja|0,Ya|0)|0;Ta=Ra;f[Ta>>2]=Aa;f[Ta+4>>2]=J;Ta=f[Oa>>2]|0;Aa=f[Ta+20>>2]|0;Ra=f[Aa>>2]|0;f[Aa>>2]=(Ra|0)>(Z|0)?Z:Ra;Ra=Aa+8|0;Qa=f[Ra>>2]|0;f[Ra>>2]=(Qa|0)<(Z|0)?Z:Qa;Qa=Aa+4|0;Ra=f[Qa>>2]|0;f[Qa>>2]=(Ra|0)>(Ja|0)?Ja:Ra;Ra=Aa+12|0;Qa=f[Ra>>2]|0;f[Ra>>2]=(Qa|0)<(Ja|0)?Ja:Qa;Qa=Aa+16|0;f[Qa>>2]=(f[Qa>>2]|0)+1;Qa=f[Ta+120>>2]|0;Ta=((Z|0)<0)<<31>>31;Aa=Qa;Ra=Kac(f[Aa>>2]|0,f[Aa+4>>2]|0,Z|0,Ta|0)|0;Aa=Qa;f[Aa>>2]=Ra;f[Aa+4>>2]=J;Aa=Qa+8|0;Qa=Aa;Ra=Kac(f[Qa>>2]|0,f[Qa+4>>2]|0,Ja|0,Ya|0)|0;Qa=Aa;f[Qa>>2]=Ra;f[Qa+4>>2]=J;if((Ua|0)<(f[(f[h>>2]|0)+8>>2]|0)){f[qa+(r<<2)>>2]=0;f[qa+(Z<<2)>>2]=0;Qa=f[Oa>>2]|0;Ra=f[Qa+20>>2]|0;Aa=f[Ra>>2]|0;f[Ra>>2]=(Aa|0)>(r|0)?r:Aa;Aa=Ra+8|0;La=f[Aa>>2]|0;f[Aa>>2]=(La|0)<(r|0)?r:La;La=Ra+4|0;Aa=f[La>>2]|0;f[La>>2]=(Aa|0)>(Ua|0)?Ua:Aa;Aa=Ra+12|0;La=f[Aa>>2]|0;f[Aa>>2]=(La|0)<(Ua|0)?Ua:La;La=Ra+16|0;f[La>>2]=(f[La>>2]|0)+1;La=f[Qa+120>>2]|0;Qa=La;Ra=Kac(f[Qa>>2]|0,f[Qa+4>>2]|0,r|0,Na|0)|0;Na=La;f[Na>>2]=Ra;f[Na+4>>2]=J;Na=La+8|0;La=Na;Ra=Kac(f[La>>2]|0,f[La+4>>2]|0,Ua|0,ua|0)|0;La=Na;f[La>>2]=Ra;f[La+4>>2]=J;La=f[Oa>>2]|0;Ra=f[La+20>>2]|0;Na=f[Ra>>2]|0;f[Ra>>2]=(Na|0)>(Z|0)?Z:Na;Na=Ra+8|0;Qa=f[Na>>2]|0;f[Na>>2]=(Qa|0)<(Z|0)?Z:Qa;Qa=Ra+4|0;Na=f[Qa>>2]|0;f[Qa>>2]=(Na|0)>(Ua|0)?Ua:Na;Na=Ra+12|0;Qa=f[Na>>2]|0;f[Na>>2]=(Qa|0)<(Ua|0)?Ua:Qa;Qa=Ra+16|0;f[Qa>>2]=(f[Qa>>2]|0)+1;Qa=f[La+120>>2]|0;La=Qa;Ra=Kac(f[La>>2]|0,f[La+4>>2]|0,Z|0,Ta|0)|0;Ta=Qa;f[Ta>>2]=Ra;f[Ta+4>>2]=J;Ta=Qa+8|0;Qa=Ta;Ra=Kac(f[Qa>>2]|0,f[Qa+4>>2]|0,Ua|0,ua|0)|0;Qa=Ta;f[Qa>>2]=Ra;f[Qa+4>>2]=J}}while(0);r=r+2|0;za=f[h>>2]|0;Sa=f[za+12>>2]|0}while((r|0)<(Sa|0));cb=Sa;db=za}else{cb=x;db=_a}Ja=Ja+2|0;if((Ja|0)>=(c|0))break;else{_a=db;x=cb}}return}if(!d)return;d=a+4|0;cb=a+12|0;a=e;e=Pa;Pa=Ba;while(1){Ba=f[d>>2]|0;x=f[f[Ba+44>>2]>>2]|0;db=(f[Ba+16>>2]|0)+(Y(x,a)|0)|0;Ba=db+x|0;x=f[f[e+44>>2]>>2]|0;_a=(f[e+16>>2]|0)+(Y(x,a)|0)|0;Ja=_a+x|0;if((Pa|0)>0){x=((a|0)<0)<<31>>31;bb=a+1|0;ab=((bb|0)<0)<<31>>31;$a=0;do{Za=_a+($a<<2)|0;g=f[Za>>2]|0;do if((g|0)>0){r=f[(f[cb>>2]|0)+(g<<2)>>2]|0;if(!(b[db+$a>>0]|0)){f[Za>>2]=0;ua=f[Oa>>2]|0;Ua=f[ua+20>>2]|0;qa=f[Ua>>2]|0;f[Ua>>2]=(qa|0)>($a|0)?$a:qa;qa=Ua+8|0;Ya=f[qa>>2]|0;f[qa>>2]=(Ya|0)<($a|0)?$a:Ya;Ya=Ua+4|0;qa=f[Ya>>2]|0;f[Ya>>2]=(qa|0)>(a|0)?a:qa;qa=Ua+12|0;Ya=f[qa>>2]|0;f[qa>>2]=(Ya|0)<(a|0)?a:Ya;Ya=Ua+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[ua+120>>2]|0;ua=Ya;Ua=Kac(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;ua=Ya;f[ua>>2]=Ua;f[ua+4>>2]=J;eb=Ya+8|0}else{f[Za>>2]=r;Ya=f[Oa>>2]|0;ua=(f[Ya+20>>2]|0)+(Y(f[f[Ya+48>>2]>>2]|0,r)|0)|0;Ua=f[ua>>2]|0;f[ua>>2]=(Ua|0)>($a|0)?$a:Ua;Ua=ua+8|0;qa=f[Ua>>2]|0;f[Ua>>2]=(qa|0)<($a|0)?$a:qa;qa=ua+4|0;Ua=f[qa>>2]|0;f[qa>>2]=(Ua|0)>(a|0)?a:Ua;Ua=ua+12|0;qa=f[Ua>>2]|0;f[Ua>>2]=(qa|0)<(a|0)?a:qa;qa=ua+16|0;f[qa>>2]=(f[qa>>2]|0)+1;qa=f[Ya+120>>2]|0;Ya=qa+(r<<4)|0;ua=Ya;Ua=Kac(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;ua=Ya;f[ua>>2]=Ua;f[ua+4>>2]=J;eb=qa+(r<<4)+8|0}qa=eb;ua=Kac(f[qa>>2]|0,f[qa+4>>2]|0,a|0,x|0)|0;qa=eb;f[qa>>2]=ua;f[qa+4>>2]=J;qa=$a|1;ua=f[h>>2]|0;if((qa|0)>=(f[ua+12>>2]|0)){if((bb|0)>=(f[ua+8>>2]|0))break;ua=Ja+($a<<2)|0;if(!(b[Ba+$a>>0]|0)){f[ua>>2]=0;Ua=f[Oa>>2]|0;Ya=f[Ua+20>>2]|0;Wa=f[Ya>>2]|0;f[Ya>>2]=(Wa|0)>($a|0)?$a:Wa;Wa=Ya+8|0;Va=f[Wa>>2]|0;f[Wa>>2]=(Va|0)<($a|0)?$a:Va;Va=Ya+4|0;Wa=f[Va>>2]|0;f[Va>>2]=(Wa|0)>(bb|0)?bb:Wa;Wa=Ya+12|0;Va=f[Wa>>2]|0;f[Wa>>2]=(Va|0)<(bb|0)?bb:Va;Va=Ya+16|0;f[Va>>2]=(f[Va>>2]|0)+1;Va=f[Ua+120>>2]|0;Ua=Va;Ya=Kac(f[Ua>>2]|0,f[Ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;Ua=Va;f[Ua>>2]=Ya;f[Ua+4>>2]=J;Ua=Va+8|0;Va=Ua;Ya=Kac(f[Va>>2]|0,f[Va+4>>2]|0,bb|0,ab|0)|0;Va=Ua;f[Va>>2]=Ya;f[Va+4>>2]=J;break}else{f[ua>>2]=r;ua=f[Oa>>2]|0;Va=(f[ua+20>>2]|0)+(Y(f[f[ua+48>>2]>>2]|0,r)|0)|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)>($a|0)?$a:Ya;Ya=Va+8|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)<($a|0)?$a:Ua;Ua=Va+4|0;Ya=f[Ua>>2]|0;f[Ua>>2]=(Ya|0)>(bb|0)?bb:Ya;Ya=Va+12|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)<(bb|0)?bb:Ua;Ua=Va+16|0;f[Ua>>2]=(f[Ua>>2]|0)+1;Ua=f[ua+120>>2]|0;ua=Ua+(r<<4)|0;Va=ua;Ya=Kac(f[Va>>2]|0,f[Va+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;Va=ua;f[Va>>2]=Ya;f[Va+4>>2]=J;Va=Ua+(r<<4)+8|0;Ua=Va;Ya=Kac(f[Ua>>2]|0,f[Ua+4>>2]|0,bb|0,ab|0)|0;Ua=Va;f[Ua>>2]=Ya;f[Ua+4>>2]=J;break}}Ua=_a+(qa<<2)|0;if(!(b[db+qa>>0]|0)){f[Ua>>2]=0;Ya=f[Oa>>2]|0;Va=f[Ya+20>>2]|0;ua=f[Va>>2]|0;f[Va>>2]=(ua|0)>(qa|0)?qa:ua;ua=Va+8|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)<(qa|0)?qa:Wa;Wa=Va+4|0;ua=f[Wa>>2]|0;f[Wa>>2]=(ua|0)>(a|0)?a:ua;ua=Va+12|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)<(a|0)?a:Wa;Wa=Va+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=f[Ya+120>>2]|0;Ya=Wa;Va=Kac(f[Ya>>2]|0,f[Ya+4>>2]|0,qa|0,((qa|0)<0)<<31>>31|0)|0;Ya=Wa;f[Ya>>2]=Va;f[Ya+4>>2]=J;fb=Wa+8|0}else{f[Ua>>2]=r;Ua=f[Oa>>2]|0;Wa=(f[Ua+20>>2]|0)+(Y(f[f[Ua+48>>2]>>2]|0,r)|0)|0;Ya=f[Wa>>2]|0;f[Wa>>2]=(Ya|0)>(qa|0)?qa:Ya;Ya=Wa+8|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)<(qa|0)?qa:Va;Va=Wa+4|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)>(a|0)?a:Ya;Ya=Wa+12|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)<(a|0)?a:Va;Va=Wa+16|0;f[Va>>2]=(f[Va>>2]|0)+1;Va=f[Ua+120>>2]|0;Ua=Va+(r<<4)|0;Wa=Ua;Ya=Kac(f[Wa>>2]|0,f[Wa+4>>2]|0,qa|0,((qa|0)<0)<<31>>31|0)|0;Wa=Ua;f[Wa>>2]=Ya;f[Wa+4>>2]=J;fb=Va+(r<<4)+8|0}Va=fb;Wa=Kac(f[Va>>2]|0,f[Va+4>>2]|0,a|0,x|0)|0;Va=fb;f[Va>>2]=Wa;f[Va+4>>2]=J;if((bb|0)<(f[(f[h>>2]|0)+8>>2]|0)){Va=Ja+($a<<2)|0;if(!(b[Ba+$a>>0]|0)){f[Va>>2]=0;Wa=f[Oa>>2]|0;Ya=f[Wa+20>>2]|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)>($a|0)?$a:Ua;Ua=Ya+8|0;ua=f[Ua>>2]|0;f[Ua>>2]=(ua|0)<($a|0)?$a:ua;ua=Ya+4|0;Ua=f[ua>>2]|0;f[ua>>2]=(Ua|0)>(bb|0)?bb:Ua;Ua=Ya+12|0;ua=f[Ua>>2]|0;f[Ua>>2]=(ua|0)<(bb|0)?bb:ua;ua=Ya+16|0;f[ua>>2]=(f[ua>>2]|0)+1;ua=f[Wa+120>>2]|0;Wa=ua;Ya=Kac(f[Wa>>2]|0,f[Wa+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;Wa=ua;f[Wa>>2]=Ya;f[Wa+4>>2]=J;gb=ua+8|0}else{f[Va>>2]=r;Va=f[Oa>>2]|0;ua=(f[Va+20>>2]|0)+(Y(f[f[Va+48>>2]>>2]|0,r)|0)|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)>($a|0)?$a:Wa;Wa=ua+8|0;Ya=f[Wa>>2]|0;f[Wa>>2]=(Ya|0)<($a|0)?$a:Ya;Ya=ua+4|0;Wa=f[Ya>>2]|0;f[Ya>>2]=(Wa|0)>(bb|0)?bb:Wa;Wa=ua+12|0;Ya=f[Wa>>2]|0;f[Wa>>2]=(Ya|0)<(bb|0)?bb:Ya;Ya=ua+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[Va+120>>2]|0;Va=Ya+(r<<4)|0;ua=Va;Wa=Kac(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,(($a|0)<0)<<31>>31|0)|0;ua=Va;f[ua>>2]=Wa;f[ua+4>>2]=J;gb=Ya+(r<<4)+8|0}Ya=gb;ua=Kac(f[Ya>>2]|0,f[Ya+4>>2]|0,bb|0,ab|0)|0;Ya=gb;f[Ya>>2]=ua;f[Ya+4>>2]=J;Ya=Ja+(qa<<2)|0;if(!(b[Ba+qa>>0]|0)){f[Ya>>2]=0;ua=f[Oa>>2]|0;Wa=f[ua+20>>2]|0;Va=f[Wa>>2]|0;f[Wa>>2]=(Va|0)>(qa|0)?qa:Va;Va=Wa+8|0;Ua=f[Va>>2]|0;f[Va>>2]=(Ua|0)<(qa|0)?qa:Ua;Ua=Wa+4|0;Va=f[Ua>>2]|0;f[Ua>>2]=(Va|0)>(bb|0)?bb:Va;Va=Wa+12|0;Ua=f[Va>>2]|0;f[Va>>2]=(Ua|0)<(bb|0)?bb:Ua;Ua=Wa+16|0;f[Ua>>2]=(f[Ua>>2]|0)+1;Ua=f[ua+120>>2]|0;ua=Ua;Wa=Kac(f[ua>>2]|0,f[ua+4>>2]|0,qa|0,((qa|0)<0)<<31>>31|0)|0;ua=Ua;f[ua>>2]=Wa;f[ua+4>>2]=J;ua=Ua+8|0;Ua=ua;Wa=Kac(f[Ua>>2]|0,f[Ua+4>>2]|0,bb|0,ab|0)|0;Ua=ua;f[Ua>>2]=Wa;f[Ua+4>>2]=J;break}else{f[Ya>>2]=r;Ya=f[Oa>>2]|0;Ua=(f[Ya+20>>2]|0)+(Y(f[f[Ya+48>>2]>>2]|0,r)|0)|0;Wa=f[Ua>>2]|0;f[Ua>>2]=(Wa|0)>(qa|0)?qa:Wa;Wa=Ua+8|0;ua=f[Wa>>2]|0;f[Wa>>2]=(ua|0)<(qa|0)?qa:ua;ua=Ua+4|0;Wa=f[ua>>2]|0;f[ua>>2]=(Wa|0)>(bb|0)?bb:Wa;Wa=Ua+12|0;ua=f[Wa>>2]|0;f[Wa>>2]=(ua|0)<(bb|0)?bb:ua;ua=Ua+16|0;f[ua>>2]=(f[ua>>2]|0)+1;ua=f[Ya+120>>2]|0;Ya=ua+(r<<4)|0;Ua=Ya;Wa=Kac(f[Ua>>2]|0,f[Ua+4>>2]|0,qa|0,((qa|0)<0)<<31>>31|0)|0;qa=Ya;f[qa>>2]=Wa;f[qa+4>>2]=J;qa=ua+(r<<4)+8|0;r=qa;ua=Kac(f[r>>2]|0,f[r+4>>2]|0,bb|0,ab|0)|0;r=qa;f[r>>2]=ua;f[r+4>>2]=J;break}}}else{f[Za>>2]=0;r=f[Oa>>2]|0;ua=f[r+20>>2]|0;qa=f[ua>>2]|0;f[ua>>2]=(qa|0)>($a|0)?$a:qa;qa=ua+8|0;Wa=f[qa>>2]|0;f[qa>>2]=(Wa|0)<($a|0)?$a:Wa;Wa=ua+4|0;qa=f[Wa>>2]|0;f[Wa>>2]=(qa|0)>(a|0)?a:qa;qa=ua+12|0;Wa=f[qa>>2]|0;f[qa>>2]=(Wa|0)<(a|0)?a:Wa;Wa=ua+16|0;f[Wa>>2]=(f[Wa>>2]|0)+1;Wa=f[r+120>>2]|0;r=(($a|0)<0)<<31>>31;ua=Wa;qa=Kac(f[ua>>2]|0,f[ua+4>>2]|0,$a|0,r|0)|0;ua=Wa;f[ua>>2]=qa;f[ua+4>>2]=J;ua=Wa+8|0;Wa=ua;qa=Kac(f[Wa>>2]|0,f[Wa+4>>2]|0,a|0,x|0)|0;Wa=ua;f[Wa>>2]=qa;f[Wa+4>>2]=J;Wa=$a|1;qa=f[h>>2]|0;if((Wa|0)<(f[qa+12>>2]|0)){f[_a+(Wa<<2)>>2]=0;ua=f[Oa>>2]|0;Ya=f[ua+20>>2]|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)>(Wa|0)?Wa:Ua;Ua=Ya+8|0;Va=f[Ua>>2]|0;f[Ua>>2]=(Va|0)<(Wa|0)?Wa:Va;Va=Ya+4|0;Ua=f[Va>>2]|0;f[Va>>2]=(Ua|0)>(a|0)?a:Ua;Ua=Ya+12|0;Va=f[Ua>>2]|0;f[Ua>>2]=(Va|0)<(a|0)?a:Va;Va=Ya+16|0;f[Va>>2]=(f[Va>>2]|0)+1;Va=f[ua+120>>2]|0;ua=((Wa|0)<0)<<31>>31;Ya=Va;Ua=Kac(f[Ya>>2]|0,f[Ya+4>>2]|0,Wa|0,ua|0)|0;Ya=Va;f[Ya>>2]=Ua;f[Ya+4>>2]=J;Ya=Va+8|0;Va=Ya;Ua=Kac(f[Va>>2]|0,f[Va+4>>2]|0,a|0,x|0)|0;Va=Ya;f[Va>>2]=Ua;f[Va+4>>2]=J;if((bb|0)>=(f[(f[h>>2]|0)+8>>2]|0))break;f[Ja+($a<<2)>>2]=0;f[Ja+(Wa<<2)>>2]=0;Va=f[Oa>>2]|0;Ua=f[Va+20>>2]|0;Ya=f[Ua>>2]|0;f[Ua>>2]=(Ya|0)>($a|0)?$a:Ya;Ya=Ua+8|0;Xa=f[Ya>>2]|0;f[Ya>>2]=(Xa|0)<($a|0)?$a:Xa;Xa=Ua+4|0;Ya=f[Xa>>2]|0;f[Xa>>2]=(Ya|0)>(bb|0)?bb:Ya;Ya=Ua+12|0;Xa=f[Ya>>2]|0;f[Ya>>2]=(Xa|0)<(bb|0)?bb:Xa;Xa=Ua+16|0;f[Xa>>2]=(f[Xa>>2]|0)+1;Xa=f[Va+120>>2]|0;Va=Xa;Ua=Kac(f[Va>>2]|0,f[Va+4>>2]|0,$a|0,r|0)|0;Va=Xa;f[Va>>2]=Ua;f[Va+4>>2]=J;Va=Xa+8|0;Xa=Va;Ua=Kac(f[Xa>>2]|0,f[Xa+4>>2]|0,bb|0,ab|0)|0;Xa=Va;f[Xa>>2]=Ua;f[Xa+4>>2]=J;Xa=f[Oa>>2]|0;Ua=f[Xa+20>>2]|0;Va=f[Ua>>2]|0;f[Ua>>2]=(Va|0)>(Wa|0)?Wa:Va;Va=Ua+8|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)<(Wa|0)?Wa:Ya;Ya=Ua+4|0;Va=f[Ya>>2]|0;f[Ya>>2]=(Va|0)>(bb|0)?bb:Va;Va=Ua+12|0;Ya=f[Va>>2]|0;f[Va>>2]=(Ya|0)<(bb|0)?bb:Ya;Ya=Ua+16|0;f[Ya>>2]=(f[Ya>>2]|0)+1;Ya=f[Xa+120>>2]|0;Xa=Ya;Ua=Kac(f[Xa>>2]|0,f[Xa+4>>2]|0,Wa|0,ua|0)|0;ua=Ya;f[ua>>2]=Ua;f[ua+4>>2]=J;ua=Ya+8|0;Ya=ua;Ua=Kac(f[Ya>>2]|0,f[Ya+4>>2]|0,bb|0,ab|0)|0;Ya=ua;f[Ya>>2]=Ua;f[Ya+4>>2]=J;break}else{if((bb|0)>=(f[qa+8>>2]|0))break;f[Ja+($a<<2)>>2]=0;qa=f[Oa>>2]|0;Ya=f[qa+20>>2]|0;Ua=f[Ya>>2]|0;f[Ya>>2]=(Ua|0)>($a|0)?$a:Ua;Ua=Ya+8|0;ua=f[Ua>>2]|0;f[Ua>>2]=(ua|0)<($a|0)?$a:ua;ua=Ya+4|0;Ua=f[ua>>2]|0;f[ua>>2]=(Ua|0)>(bb|0)?bb:Ua;Ua=Ya+12|0;ua=f[Ua>>2]|0;f[Ua>>2]=(ua|0)<(bb|0)?bb:ua;ua=Ya+16|0;f[ua>>2]=(f[ua>>2]|0)+1;ua=f[qa+120>>2]|0;qa=ua;Ya=Kac(f[qa>>2]|0,f[qa+4>>2]|0,$a|0,r|0)|0;r=ua;f[r>>2]=Ya;f[r+4>>2]=J;r=ua+8|0;ua=r;Ya=Kac(f[ua>>2]|0,f[ua+4>>2]|0,bb|0,ab|0)|0;ua=r;f[ua>>2]=Ya;f[ua+4>>2]=J;break}}while(0);$a=$a+2|0;Za=f[h>>2]|0;g=f[Za+12>>2]|0}while(($a|0)<(g|0));hb=g;ib=Za}else{hb=Pa;ib=e}a=a+2|0;if((a|0)>=(c|0))break;else{e=ib;Pa=hb}}return}}function o4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;c=u;u=u+80|0;d=c;e=c+16|0;f[e>>2]=1124007936;g=e+4|0;h=e+8|0;i=e+40|0;j=g;k=j+36|0;do{f[j>>2]=0;j=j+4|0}while((j|0)<(k|0));f[i>>2]=h;j=e+48|0;k=e+44|0;f[k>>2]=j;f[j>>2]=0;f[e+52>>2]=0;f[d>>2]=b;f[d+4>>2]=5;hL(e,2,d,4);l=a+4|0;m=e+36|0;n=f[m>>2]|0;if((l|0)==(e|0))o=n;else{if(n|0){p=n+12|0;f[p>>2]=(f[p>>2]|0)+1}p=a+40|0;n=f[p>>2]|0;if(n|0?(q=n+12|0,n=f[q>>2]|0,f[q>>2]=n+-1,(n|0)==1):0)kL(l);f[p>>2]=0;n=a+20|0;q=a+8|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[q>>2]|0)>0){r=f[a+44>>2]|0;s=0;do{f[r+(s<<2)>>2]=0;s=s+1|0;t=f[q>>2]|0}while((s|0)<(t|0));f[l>>2]=f[e>>2];if((t|0)<3)v=12;else v=14}else{f[l>>2]=f[e>>2];v=12}if((v|0)==12){t=f[g>>2]|0;if((t|0)<3){f[q>>2]=t;f[a+12>>2]=f[h>>2];f[a+16>>2]=f[e+12>>2];h=f[k>>2]|0;t=f[a+48>>2]|0;f[t>>2]=f[h>>2];f[t+4>>2]=f[h+4>>2]}else v=14}if((v|0)==14)jL(l,e);f[n>>2]=f[e+16>>2];f[a+24>>2]=f[e+20>>2];f[a+28>>2]=f[e+24>>2];f[a+32>>2]=f[e+28>>2];f[a+36>>2]=f[e+32>>2];n=f[m>>2]|0;f[p>>2]=n;o=n}if(o|0?(n=o+12|0,o=f[n>>2]|0,f[n>>2]=o+-1,(o|0)==1):0)kL(e);f[m>>2]=0;m=e+16|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[g>>2]|0)>0){m=f[i>>2]|0;i=0;do{f[m+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[g>>2]|0))}g=f[k>>2]|0;if((g|0)!=(j|0))UC(g);if((b|0)>0){g=f[a+20>>2]|0;j=f[a+48>>2]|0;k=0;do{i=g+(Y(f[j>>2]|0,k)|0)|0;f[i>>2]=2147483647;f[i+4>>2]=2147483647;f[i+8>>2]=-2147483648;f[i+12>>2]=-2147483648;f[i+16>>2]=0;k=k+1|0}while((k|0)!=(b|0))}k=a+120|0;j=a+124|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;a=f[j>>2]|0;g=f[k>>2]|0;i=a-g>>4;m=a;if(i>>>0<b>>>0){p4(k,b-i|0,d);u=c;return}if(i>>>0<=b>>>0){u=c;return}i=g+(b<<4)|0;if((m|0)==(i|0)){u=c;return}f[j>>2]=m+(~((m+-16-i|0)>>>4)<<4);u=c;return}function p4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;d=a+8|0;e=f[d>>2]|0;g=a+4|0;h=f[g>>2]|0;if(e-h>>4>>>0>=b>>>0){i=b;j=h;do{f[j>>2]=f[c>>2];f[j+4>>2]=f[c+4>>2];f[j+8>>2]=f[c+8>>2];f[j+12>>2]=f[c+12>>2];j=(f[g>>2]|0)+16|0;f[g>>2]=j;i=i+-1|0}while((i|0)!=0);return}i=f[a>>2]|0;j=h-i>>4;h=j+b|0;if(h>>>0>268435455)c4b(a);k=e-i|0;i=k>>3;e=k>>4>>>0<134217727?(i>>>0<h>>>0?h:i):268435455;do if(e)if(e>>>0>268435455){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}else{l=L5b(e<<4)|0;break}else l=0;while(0);i=l+(j<<4)|0;j=l+(e<<4)|0;e=b;b=i;l=i;do{f[b>>2]=f[c>>2];f[b+4>>2]=f[c+4>>2];f[b+8>>2]=f[c+8>>2];f[b+12>>2]=f[c+12>>2];b=l+16|0;l=b;e=e+-1|0}while((e|0)!=0);e=f[a>>2]|0;b=(f[g>>2]|0)-e|0;c=i+(0-(b>>4)<<4)|0;if((b|0)>0)Vac(c|0,e|0,b|0)|0;f[a>>2]=c;f[g>>2]=l;f[d>>2]=j;if(!e)return;O5b(e);return}function q4(a){a=a|0;O5b(a);return}function r4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=c+4|0;c=f[d>>2]|0;g=a+16|0;h=f[g>>2]|0;f[h+(e<<2)>>2]=((c|0)%2|0)+c;c=e+1|0;i=a+8|0;j=(Y(((f[(f[i>>2]|0)+12>>2]|0)+1|0)/2|0,(c|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+8>>2]|0;n=f[l+12>>2]|0;if((e|0)>=(f[d>>2]|0)){o=j;p=h;q=o-j|0;r=p+(c<<2)|0;f[r>>2]=q;return}h=(n|0)>0;l=a+12|0;a=e;s=j;while(1){t=f[k>>2]|0;u=f[f[t+44>>2]>>2]|0;v=(f[t+16>>2]|0)+(Y(u,a)|0)|0;t=0-u|0;w=v+t|0;x=w+t|0;t=v+u|0;u=f[i>>2]|0;y=f[f[u+44>>2]>>2]|0;z=(f[u+16>>2]|0)+(Y(y,a)|0)|0;u=0-y|0;y=z+u+u|0;if(h){u=(a+1|0)<(m|0);A=(a|0)>(e|0);B=A^1;C=(a|0)>(c|0);D=0;E=s;while(1){a:do if(!(b[v+D>>0]|0)){F=D|1;G=(F|0)<(n|0);if(u?b[t+D>>0]|0:0){H=D+-1|0;I=(D|0)>0;if(G?b[v+F>>0]|0:0){if(I){if(b[v+H>>0]|0){do if(A){if(b[w+F>>0]|0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;K=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}do if((K|0)>-1){if(!(b[w+K>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}L=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;N=f[z+(K<<2)>>2]|0;O=M;while(1){P=f[L+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((M|0)==(N|0))Q=O;else{P=N;while(1){R=f[L+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(O|0)>(P|0)?P:O;S=N;do{T=L+(S<<2)|0;U=S;S=f[T>>2]|0;f[T>>2]=R}while((S|0)<(U|0));Q=R}R=M;do{S=L+(R<<2)|0;N=R;R=f[S>>2]|0;f[S>>2]=Q}while((R|0)<(N|0));f[z+(D<<2)>>2]=Q;J=E;break a}while(0);R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[z+(K<<2)>>2]|0;N=L;while(1){S=f[R+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((L|0)==(M|0))V=N;else{K=M;while(1){S=f[R+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}S=(N|0)>(K|0)?K:N;O=M;do{P=R+(O<<2)|0;U=O;O=f[P>>2]|0;f[P>>2]=S}while((O|0)<(U|0));V=S}S=L;do{O=R+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=V}while((S|0)<(M|0));f[z+(D<<2)>>2]=V;J=E;break a}while(0);S=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;M=R;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((R|0)==(L|0))W=M;else{O=L;while(1){N=f[S+(O<<2)>>2]|0;if((N|0)<(O|0))O=N;else break}N=(M|0)>(O|0)?O:M;K=L;do{U=S+(K<<2)|0;P=K;K=f[U>>2]|0;f[U>>2]=N}while((K|0)<(P|0));W=N}N=R;do{K=S+(N<<2)|0;L=N;N=f[K>>2]|0;f[K>>2]=W}while((N|0)<(L|0));f[z+(D<<2)>>2]=W;J=E;break a}N=D+2|0;if((N|0)>=(n|0))break;if(!(b[w+N>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;K=R;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((R|0)==(L|0))X=K;else{M=L;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;P=L;do{U=S+(P<<2)|0;T=P;P=f[U>>2]|0;f[U>>2]=O}while((P|0)<(T|0));X=O}O=R;do{P=S+(O<<2)|0;L=O;O=f[P>>2]|0;f[P>>2]=X}while((O|0)<(L|0));f[z+(D<<2)>>2]=X;J=E;break a}O=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}do if((O|0)>-1){if(!(b[w+O>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(O<<2)>>2]|0;P=R;while(1){K=f[S+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}if((R|0)==(L|0))Z=P;else{K=L;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(P|0)>(K|0)?K:P;T=L;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=M}while((T|0)<(_|0));Z=M}M=R;do{T=S+(M<<2)|0;L=M;M=f[T>>2]|0;f[T>>2]=Z}while((M|0)<(L|0));f[z+(D<<2)>>2]=Z;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(N<<2)>>2]|0;R=f[z+(O<<2)>>2]|0;L=S;while(1){T=f[M+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((S|0)==(R|0))$=L;else{O=R;while(1){T=f[M+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}T=(L|0)>(O|0)?O:L;P=R;do{K=M+(P<<2)|0;_=P;P=f[K>>2]|0;f[K>>2]=T}while((P|0)<(_|0));$=T}T=S;do{P=M+(T<<2)|0;R=T;T=f[P>>2]|0;f[P>>2]=$}while((T|0)<(R|0));f[z+(D<<2)>>2]=$;J=E;break a}while(0);T=f[l>>2]|0;M=f[y+(N<<2)>>2]|0;S=f[z+(D+-2<<2)>>2]|0;R=M;while(1){P=f[T+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((M|0)==(S|0))aa=R;else{N=S;while(1){P=f[T+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;L=S;do{O=T+(L<<2)|0;_=L;L=f[O>>2]|0;f[O>>2]=P}while((L|0)<(_|0));aa=P}P=M;do{L=T+(P<<2)|0;S=P;P=f[L>>2]|0;f[L>>2]=aa}while((P|0)<(S|0));f[z+(D<<2)>>2]=aa;J=E;break a}while(0);f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[t+H>>0]|0){do if(A){if(b[w+F>>0]|0){P=D+-2|0;do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=T;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=S;while(1){R=f[M+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((S|0)==(T|0))ba=L;else{R=T;while(1){N=f[M+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(L|0)>(R|0)?R:L;_=T;do{O=M+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=N}while((_|0)<(K|0));ba=N}N=S;do{_=M+(N<<2)|0;T=N;N=f[_>>2]|0;f[_>>2]=ba}while((N|0)<(T|0));f[z+(D<<2)>>2]=ba;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(P<<2)>>2]|0;T=M;while(1){_=f[N+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((M|0)==(S|0))ca=T;else{_=S;while(1){L=f[N+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(T|0)>(_|0)?_:T;R=S;do{K=N+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=L}while((R|0)<(O|0));ca=L}L=M;do{R=N+(L<<2)|0;S=L;L=f[R>>2]|0;f[R>>2]=ca}while((L|0)<(S|0));f[z+(D<<2)>>2]=ca;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;L=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=M;while(1){R=f[N+(S<<2)>>2]|0;if((R|0)<(S|0))S=R;else break}if((M|0)==(L|0))da=S;else{R=L;while(1){T=f[N+(R<<2)>>2]|0;if((T|0)<(R|0))R=T;else break}T=(S|0)>(R|0)?R:S;_=L;do{O=N+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=T}while((_|0)<(K|0));da=T}T=M;do{_=N+(T<<2)|0;L=T;T=f[_>>2]|0;f[_>>2]=da}while((T|0)<(L|0));f[z+(D<<2)>>2]=da;J=E;break a}while(0);T=f[l>>2]|0;N=f[y+(D<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;L=N;while(1){_=f[T+(L<<2)>>2]|0;if((_|0)<(L|0))L=_;else break}if((N|0)==(M|0))ea=L;else{_=M;while(1){S=f[T+(_<<2)>>2]|0;if((S|0)<(_|0))_=S;else break}S=(L|0)>(_|0)?_:L;R=M;do{K=T+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=S}while((R|0)<(O|0));ea=S}S=N;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ea}while((S|0)<(M|0));f[z+(D<<2)>>2]=ea;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;N=f[z+(P<<2)>>2]|0;M=T;while(1){R=f[S+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}if((T|0)==(N|0))fa=M;else{P=N;while(1){R=f[S+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(M|0)>(P|0)?P:M;L=N;do{_=S+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(O|0));fa=R}R=T;do{L=S+(R<<2)|0;N=R;R=f[L>>2]|0;f[L>>2]=fa}while((R|0)<(N|0));f[z+(D<<2)>>2]=fa;J=E;break a}R=D+2|0;do if(!((R|0)>=(n|0)|B)){if(!(b[w+R>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;S=D+-2|0;do if((S|0)>-1){if(!(b[v+S>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}N=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=L;while(1){P=f[N+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}if((L|0)==(T|0))ga=M;else{P=T;while(1){O=f[N+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(M|0)>(P|0)?P:M;_=T;do{K=N+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=O}while((_|0)<(U|0));ga=O}O=L;do{_=N+(O<<2)|0;T=O;O=f[_>>2]|0;f[_>>2]=ga}while((O|0)<(T|0));f[z+(D<<2)>>2]=ga;J=E;break a}if(!(b[w+S>>0]|0)){O=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;L=f[z+(S<<2)>>2]|0;T=N;while(1){_=f[O+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((N|0)==(L|0))ha=T;else{_=L;while(1){M=f[O+(_<<2)>>2]|0;if((M|0)<(_|0))_=M;else break}M=(T|0)>(_|0)?_:T;P=L;do{U=O+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=M}while((P|0)<(K|0));ha=M}M=N;do{P=O+(M<<2)|0;L=M;M=f[P>>2]|0;f[P>>2]=ha}while((M|0)<(L|0));f[z+(D<<2)>>2]=ha;J=E;break a}if(!(b[x+H>>0]|0)){M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=f[z+(S<<2)>>2]|0;L=O;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((O|0)==(N|0))ia=L;else{P=N;while(1){T=f[M+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(L|0)>(P|0)?P:L;_=N;do{K=M+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=T}while((_|0)<(U|0));ia=T}T=O;do{_=M+(T<<2)|0;N=T;T=f[_>>2]|0;f[_>>2]=ia}while((T|0)<(N|0));f[z+(D<<2)>>2]=ia;J=E;break a}T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=O;while(1){_=f[M+(N<<2)>>2]|0;if((_|0)<(N|0))N=_;else break}if((O|0)==(T|0))ja=N;else{_=T;while(1){L=f[M+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(N|0)>(_|0)?_:N;P=T;do{U=M+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=L}while((P|0)<(K|0));ja=L}L=O;do{P=M+(L<<2)|0;T=L;L=f[P>>2]|0;f[P>>2]=ja}while((L|0)<(T|0));f[z+(D<<2)>>2]=ja;J=E;break a}while(0);L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(S<<2)>>2]|0;T=M;while(1){P=f[L+(T<<2)>>2]|0;if((P|0)<(T|0))T=P;else break}if((M|0)==(O|0))ka=T;else{S=O;while(1){P=f[L+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}P=(T|0)>(S|0)?S:T;N=O;do{_=L+(N<<2)|0;K=N;N=f[_>>2]|0;f[_>>2]=P}while((N|0)<(K|0));ka=P}P=M;do{N=L+(P<<2)|0;O=P;P=f[N>>2]|0;f[N>>2]=ka}while((P|0)<(O|0));f[z+(D<<2)>>2]=ka;J=E;break a}while(0);P=D+-2|0;if(!(b[w+D>>0]|0)){L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;N=M;while(1){T=f[L+(N<<2)>>2]|0;if((T|0)<(N|0))N=T;else break}if((M|0)==(O|0))la=N;else{T=O;while(1){S=f[L+(T<<2)>>2]|0;if((S|0)<(T|0))T=S;else break}S=(N|0)>(T|0)?T:N;K=O;do{_=L+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=S}while((K|0)<(U|0));la=S}S=M;do{K=L+(S<<2)|0;O=S;S=f[K>>2]|0;f[K>>2]=la}while((S|0)<(O|0));f[z+(D<<2)>>2]=la;J=E;break a}do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){S=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))ma=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));ma=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=ma}while((N|0)<(M|0));f[z+(D<<2)>>2]=ma;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=f[y+(R<<2)>>2]|0;M=S;while(1){T=f[N+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((S|0)==(L|0))na=M;else{T=L;while(1){O=f[N+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}O=(M|0)>(T|0)?T:M;K=L;do{_=N+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=O}while((K|0)<(U|0));na=O}O=S;do{K=N+(O<<2)|0;L=O;O=f[K>>2]|0;f[K>>2]=na}while((O|0)<(L|0));O=f[z+(P<<2)>>2]|0;S=na;while(1){L=f[N+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((na|0)==(O|0))oa=S;else{L=O;while(1){K=f[N+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(S|0)>(L|0)?L:S;M=O;do{T=N+(M<<2)|0;U=M;M=f[T>>2]|0;f[T>>2]=K}while((M|0)<(U|0));oa=K}K=na;do{M=N+(K<<2)|0;O=K;K=f[M>>2]|0;f[M>>2]=oa}while((K|0)<(O|0));f[z+(D<<2)>>2]=oa;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;K=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;M=N;while(1){S=f[K+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((N|0)==(O|0))pa=M;else{S=O;while(1){L=f[K+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}L=(M|0)>(S|0)?S:M;U=O;do{T=K+(U<<2)|0;_=U;U=f[T>>2]|0;f[T>>2]=L}while((U|0)<(_|0));pa=L}L=N;do{U=K+(L<<2)|0;O=L;L=f[U>>2]|0;f[U>>2]=pa}while((L|0)<(O|0));f[z+(D<<2)>>2]=pa;J=E;break a}while(0);L=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;N=f[y+(R<<2)>>2]|0;O=K;while(1){U=f[L+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if((K|0)==(N|0))qa=O;else{U=N;while(1){M=f[L+(U<<2)>>2]|0;if((M|0)<(U|0))U=M;else break}M=(O|0)>(U|0)?U:O;S=N;do{_=L+(S<<2)|0;T=S;S=f[_>>2]|0;f[_>>2]=M}while((S|0)<(T|0));qa=M}M=K;do{S=L+(M<<2)|0;N=M;M=f[S>>2]|0;f[S>>2]=qa}while((M|0)<(N|0));M=f[z+(P<<2)>>2]|0;K=qa;while(1){N=f[L+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}if((qa|0)==(M|0))ra=K;else{N=M;while(1){S=f[L+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}S=(K|0)>(N|0)?N:K;O=M;do{U=L+(O<<2)|0;T=O;O=f[U>>2]|0;f[U>>2]=S}while((O|0)<(T|0));ra=S}S=qa;do{O=L+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=ra}while((S|0)<(M|0));f[z+(D<<2)>>2]=ra;J=E;break a}while(0);S=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[y+(R<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))sa=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));sa=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=sa}while((N|0)<(M|0));N=f[z+(P<<2)>>2]|0;L=sa;while(1){M=f[S+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((sa|0)==(N|0))ta=L;else{P=N;while(1){M=f[S+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}M=(L|0)>(P|0)?P:L;T=N;do{O=S+(T<<2)|0;K=T;T=f[O>>2]|0;f[O>>2]=M}while((T|0)<(K|0));ta=M}M=sa;do{T=S+(M<<2)|0;N=M;M=f[T>>2]|0;f[T>>2]=ta}while((M|0)<(N|0));f[z+(D<<2)>>2]=ta;J=E;break a}while(0);R=D+-2|0;if(!(b[w+D>>0]|0)){ua=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}if(!(b[w+R>>0]|0)){M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;N=f[z+(R<<2)>>2]|0;T=S;while(1){L=f[M+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}if((S|0)==(N|0))va=T;else{L=N;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(T|0)>(L|0)?L:T;K=N;do{O=M+(K<<2)|0;_=K;K=f[O>>2]|0;f[O>>2]=P}while((K|0)<(_|0));va=P}P=S;do{K=M+(P<<2)|0;N=P;P=f[K>>2]|0;f[K>>2]=va}while((P|0)<(N|0));f[z+(D<<2)>>2]=va;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);P=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;N=M;while(1){K=f[P+(N<<2)>>2]|0;if((K|0)<(N|0))N=K;else break}if((M|0)==(S|0))wa=N;else{K=S;while(1){T=f[P+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}T=(N|0)>(K|0)?K:N;L=S;do{_=P+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=T}while((L|0)<(O|0));wa=T}T=M;do{L=P+(T<<2)|0;S=T;T=f[L>>2]|0;f[L>>2]=wa}while((T|0)<(S|0));f[z+(D<<2)>>2]=wa;J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(R<<2)>>2]|0;S=P;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((P|0)==(M|0))xa=S;else{R=M;while(1){L=f[T+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(S|0)>(R|0)?R:S;N=M;do{K=T+(N<<2)|0;O=N;N=f[K>>2]|0;f[K>>2]=L}while((N|0)<(O|0));xa=L}L=P;do{N=T+(L<<2)|0;M=L;L=f[N>>2]|0;f[N>>2]=xa}while((L|0)<(M|0));f[z+(D<<2)>>2]=xa;J=E;break a}else ua=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(ua<<2)>>2];J=E;break}}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}L=D+2|0;if(!((L|0)>=(n|0)|B)?b[w+L>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(L<<2)>>2]|0;N=P;while(1){S=f[T+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((P|0)==(M|0))ya=N;else{L=M;while(1){S=f[T+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(N|0)>(L|0)?L:N;R=M;do{O=T+(R<<2)|0;K=R;R=f[O>>2]|0;f[O>>2]=S}while((R|0)<(K|0));ya=S}S=P;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ya}while((S|0)<(M|0));f[z+(D<<2)>>2]=ya;J=E;break}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(I){if(b[t+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[v+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}do if(G){if(!(b[v+F>>0]|0)){if(!u)break;if(!(b[t+F>>0]|0))break;f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(S<<2)>>2]|0;R=P;while(1){N=f[T+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((P|0)==(M|0))za=R;else{S=M;while(1){N=f[T+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(R|0)>(S|0)?S:R;L=M;do{K=T+(L<<2)|0;O=L;L=f[K>>2]|0;f[K>>2]=N}while((L|0)<(O|0));za=N}N=P;do{L=T+(N<<2)|0;M=N;N=f[L>>2]|0;f[L>>2]=za}while((N|0)<(M|0));f[z+(D<<2)>>2]=za;J=E;break a}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}while(0);f[z+(D<<2)>>2]=0;J=E}else{F=D+-1|0;G=(D|0)>0;if(G){if(b[v+F>>0]|0){H=D|1;I=(H|0)<(n|0);if(A&I?b[w+H>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(C?b[x+D>>0]|0:0){N=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break}do if((N|0)>-1){if(!(b[w+N>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break a}T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(N<<2)>>2]|0;L=P;while(1){R=f[T+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((P|0)==(M|0))Aa=L;else{R=M;while(1){S=f[T+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}S=(L|0)>(R|0)?R:L;O=M;do{K=T+(O<<2)|0;_=O;O=f[K>>2]|0;f[K>>2]=S}while((O|0)<(_|0));Aa=S}S=P;do{O=T+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=Aa}while((S|0)<(M|0));f[z+(D<<2)>>2]=Aa;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;P=f[z+(N<<2)>>2]|0;M=T;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((T|0)==(P|0))Ba=M;else{N=P;while(1){O=f[S+(N<<2)>>2]|0;if((O|0)<(N|0))N=O;else break}O=(M|0)>(N|0)?N:M;L=P;do{R=S+(L<<2)|0;_=L;L=f[R>>2]|0;f[R>>2]=O}while((L|0)<(_|0));Ba=O}O=T;do{L=S+(O<<2)|0;P=O;O=f[L>>2]|0;f[L>>2]=Ba}while((O|0)<(P|0));f[z+(D<<2)>>2]=Ba;J=E;break}O=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;P=S;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((S|0)==(T|0))Ca=P;else{L=T;while(1){M=f[O+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(P|0)>(L|0)?L:P;N=T;do{_=O+(N<<2)|0;R=N;N=f[_>>2]|0;f[_>>2]=M}while((N|0)<(R|0));Ca=M}M=S;do{N=O+(M<<2)|0;T=M;M=f[N>>2]|0;f[N>>2]=Ca}while((M|0)<(T|0));f[z+(D<<2)>>2]=Ca;J=E;break}if(I?b[v+H>>0]|0:0){M=D+2|0;if(A&(M|0)<(n|0)?b[w+M>>0]|0:0){do if(C){if(!(b[x+H>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;N=S;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((S|0)==(T|0))Da=N;else{P=T;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(N|0)>(P|0)?P:N;R=T;do{_=O+(R<<2)|0;K=R;R=f[_>>2]|0;f[_>>2]=L}while((R|0)<(K|0));Da=L}L=S;do{R=O+(L<<2)|0;T=L;L=f[R>>2]|0;f[R>>2]=Da}while((L|0)<(T|0));f[z+(D<<2)>>2]=Da;J=E;break a}L=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}do if((L|0)>-1){if(!(b[w+L>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(L<<2)>>2]|0;R=S;while(1){N=f[O+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((S|0)==(T|0))Ea=R;else{N=T;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;K=T;do{_=O+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=P}while((K|0)<(U|0));Ea=P}P=S;do{K=O+(P<<2)|0;T=P;P=f[K>>2]|0;f[K>>2]=Ea}while((P|0)<(T|0));f[z+(D<<2)>>2]=Ea;J=E;break a}while(0);P=f[l>>2]|0;O=f[y+(M<<2)>>2]|0;S=f[z+(L<<2)>>2]|0;T=O;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((O|0)==(S|0))Fa=T;else{L=S;while(1){K=f[P+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(T|0)>(L|0)?L:T;R=S;do{N=P+(R<<2)|0;U=R;R=f[N>>2]|0;f[N>>2]=K}while((R|0)<(U|0));Fa=K}K=O;do{R=P+(K<<2)|0;S=K;K=f[R>>2]|0;f[R>>2]=Fa}while((K|0)<(S|0));f[z+(D<<2)>>2]=Fa;J=E;break a}while(0);H=f[l>>2]|0;I=f[y+(M<<2)>>2]|0;K=f[z+(D+-2<<2)>>2]|0;P=I;while(1){O=f[H+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}if((I|0)==(K|0))Ga=P;else{M=K;while(1){O=f[H+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(P|0)>(M|0)?M:P;S=K;do{R=H+(S<<2)|0;T=S;S=f[R>>2]|0;f[R>>2]=O}while((S|0)<(T|0));Ga=O}O=I;do{S=H+(O<<2)|0;K=O;O=f[S>>2]|0;f[S>>2]=Ga}while((O|0)<(K|0));f[z+(D<<2)>>2]=Ga;J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(u?b[t+F>>0]|0:0){O=D|1;H=(O|0)<(n|0);if(!(B|H^1)?b[w+O>>0]|0:0){I=D+-2|0;if((I|0)>-1?b[v+I>>0]|0:0){if(b[w+F>>0]|0){K=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=K;J=E;break a}while(0);S=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=P;while(1){T=f[S+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((P|0)==(K|0))Ha=M;else{T=K;while(1){R=f[S+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(M|0)>(T|0)?T:M;L=K;do{U=S+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Ha=R}R=P;do{L=S+(R<<2)|0;K=R;R=f[L>>2]|0;f[L>>2]=Ha}while((R|0)<(K|0));f[z+(D<<2)>>2]=Ha;J=E;break}if(!(b[w+I>>0]|0)){R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=f[z+(I<<2)>>2]|0;K=S;while(1){L=f[R+(K<<2)>>2]|0;if((L|0)<(K|0))K=L;else break}if((S|0)==(P|0))Ia=K;else{L=P;while(1){M=f[R+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(K|0)>(L|0)?L:K;T=P;do{N=R+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=M}while((T|0)<(U|0));Ia=M}M=S;do{T=R+(M<<2)|0;P=M;M=f[T>>2]|0;f[T>>2]=Ia}while((M|0)<(P|0));f[z+(D<<2)>>2]=Ia;J=E;break}do if(C){if(!(b[x+F>>0]|0))break;M=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=S;while(1){T=f[R+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}if((S|0)==(M|0))Ja=P;else{T=M;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(P|0)>(T|0)?T:P;L=M;do{U=R+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=K}while((L|0)<(N|0));Ja=K}K=S;do{L=R+(K<<2)|0;M=K;K=f[L>>2]|0;f[L>>2]=Ja}while((K|0)<(M|0));f[z+(D<<2)>>2]=Ja;J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;M=R;while(1){L=f[K+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}if((R|0)==(S|0))Ka=M;else{L=S;while(1){P=f[K+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(M|0)>(L|0)?L:M;T=S;do{N=K+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=P}while((T|0)<(U|0));Ka=P}P=R;do{T=K+(P<<2)|0;S=P;P=f[T>>2]|0;f[T>>2]=Ka}while((P|0)<(S|0));f[z+(D<<2)>>2]=Ka;J=E;break}if(b[w+D>>0]|0){P=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;S=K;while(1){T=f[P+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}if((K|0)==(R|0))La=S;else{T=R;while(1){M=f[P+(T<<2)>>2]|0;if((M|0)<(T|0))T=M;else break}M=(S|0)>(T|0)?T:S;L=R;do{U=P+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=M}while((L|0)<(N|0));La=M}M=K;do{L=P+(M<<2)|0;R=M;M=f[L>>2]|0;f[L>>2]=La}while((M|0)<(R|0));f[z+(D<<2)>>2]=La;J=E;break}if(!(b[w+F>>0]|0)){M=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;K=f[z+(I<<2)>>2]|0;R=P;while(1){L=f[M+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(K|0))Ma=R;else{L=K;while(1){S=f[M+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(R|0)>(L|0)?L:R;T=K;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=S}while((T|0)<(U|0));Ma=S}S=P;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Ma}while((S|0)<(K|0));f[z+(D<<2)>>2]=Ma;J=E;break}S=f[y+(D<<2)>>2]|0;M=f[l>>2]|0;do if(C){if(!(b[x+D>>0]|0))break;P=f[z+(I<<2)>>2]|0;K=S;while(1){T=f[M+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((S|0)==(P|0))Na=K;else{T=P;while(1){R=f[M+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(K|0)>(T|0)?T:K;L=P;do{U=M+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Na=R}R=S;do{L=M+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Na}while((R|0)<(P|0));f[z+(D<<2)>>2]=Na;J=E;break a}while(0);R=f[y+(I<<2)>>2]|0;P=R;while(1){L=f[M+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((R|0)==(S|0))Oa=P;else{L=S;while(1){K=f[M+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(P|0)>(L|0)?L:P;T=S;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=K}while((T|0)<(U|0));Oa=K}K=R;do{T=M+(K<<2)|0;S=K;K=f[T>>2]|0;f[T>>2]=Oa}while((K|0)<(S|0));K=f[z+(I<<2)>>2]|0;R=Oa;while(1){S=f[M+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}if((Oa|0)==(K|0))Pa=R;else{I=K;while(1){S=f[M+(I<<2)>>2]|0;if((S|0)<(I|0))I=S;else break}S=(R|0)>(I|0)?I:R;T=K;do{P=M+(T<<2)|0;L=T;T=f[P>>2]|0;f[P>>2]=S}while((T|0)<(L|0));Pa=S}S=Oa;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Pa}while((S|0)<(K|0));f[z+(D<<2)>>2]=Pa;J=E;break}if(H?b[v+O>>0]|0:0){S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){M=D+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+F>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;K=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}T=f[l>>2]|0;R=f[y+(S<<2)>>2]|0;I=R;while(1){L=f[T+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((R|0)==(K|0))Qa=I;else{L=K;while(1){P=f[T+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(I|0)>(L|0)?L:I;U=K;do{N=T+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=P}while((U|0)<(_|0));Qa=P}P=R;do{U=T+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=Qa}while((P|0)<(K|0));f[z+(D<<2)>>2]=Qa;J=E;break a}while(0);P=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;K=T;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((T|0)==(R|0))Ra=K;else{U=R;while(1){I=f[P+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}I=(K|0)>(U|0)?U:K;L=R;do{_=P+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=I}while((L|0)<(N|0));Ra=I}I=T;do{L=P+(I<<2)|0;R=I;I=f[L>>2]|0;f[L>>2]=Ra}while((I|0)<(R|0));f[z+(D<<2)>>2]=Ra;J=E;break a}do if(C){if(!(b[x+O>>0]|0))break;if(!(b[w+M>>0]|0)){I=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;T=f[z+(M<<2)>>2]|0;R=P;while(1){L=f[I+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(T|0))Sa=R;else{L=T;while(1){K=f[I+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(R|0)>(L|0)?L:R;U=T;do{N=I+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=K}while((U|0)<(_|0));Sa=K}K=P;do{U=I+(K<<2)|0;T=K;K=f[U>>2]|0;f[U>>2]=Sa}while((K|0)<(T|0));f[z+(D<<2)>>2]=Sa;J=E;break a}if(!(b[x+F>>0]|0)){K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=f[z+(M<<2)>>2]|0;T=I;while(1){U=f[K+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}if((I|0)==(P|0))Ta=T;else{U=P;while(1){R=f[K+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(T|0)>(U|0)?U:T;L=P;do{_=K+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(N|0));Ta=R}R=I;do{L=K+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Ta}while((R|0)<(P|0));f[z+(D<<2)>>2]=Ta;J=E;break a}R=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=I;while(1){L=f[K+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((I|0)==(R|0))Ua=P;else{L=R;while(1){T=f[K+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}T=(P|0)>(L|0)?L:P;U=R;do{N=K+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=T}while((U|0)<(_|0));Ua=T}T=I;do{U=K+(T<<2)|0;R=T;T=f[U>>2]|0;f[U>>2]=Ua}while((T|0)<(R|0));f[z+(D<<2)>>2]=Ua;J=E;break a}while(0);if(!(b[w+D>>0]|0)){T=f[l>>2]|0;K=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;R=K;while(1){U=f[T+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}if((K|0)==(I|0))Va=R;else{U=I;while(1){P=f[T+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}P=(R|0)>(U|0)?U:R;L=I;do{_=T+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=P}while((L|0)<(N|0));Va=P}P=K;do{L=T+(P<<2)|0;I=P;P=f[L>>2]|0;f[L>>2]=Va}while((P|0)<(I|0));f[z+(D<<2)>>2]=Va;J=E;break a}if(!(b[w+M>>0]|0)){P=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;K=f[y+(S<<2)>>2]|0;I=T;while(1){L=f[P+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(K|0))Wa=I;else{L=K;while(1){R=f[P+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}R=(I|0)>(L|0)?L:I;U=K;do{N=P+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=R}while((U|0)<(_|0));Wa=R}R=T;do{U=P+(R<<2)|0;K=R;R=f[U>>2]|0;f[U>>2]=Wa}while((R|0)<(K|0));R=f[z+(M<<2)>>2]|0;T=Wa;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((Wa|0)==(R|0))Xa=T;else{K=R;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}U=(T|0)>(K|0)?K:T;I=R;do{L=P+(I<<2)|0;_=I;I=f[L>>2]|0;f[L>>2]=U}while((I|0)<(_|0));Xa=U}U=Wa;do{I=P+(U<<2)|0;R=U;U=f[I>>2]|0;f[I>>2]=Xa}while((U|0)<(R|0));f[z+(D<<2)>>2]=Xa;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;U=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;I=P;while(1){T=f[U+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}if((P|0)==(R|0))Ya=I;else{T=R;while(1){K=f[U+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(I|0)>(T|0)?T:I;_=R;do{L=U+(_<<2)|0;N=_;_=f[L>>2]|0;f[L>>2]=K}while((_|0)<(N|0));Ya=K}K=P;do{_=U+(K<<2)|0;R=K;K=f[_>>2]|0;f[_>>2]=Ya}while((K|0)<(R|0));f[z+(D<<2)>>2]=Ya;J=E;break a}while(0);K=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;P=f[y+(S<<2)>>2]|0;R=U;while(1){_=f[K+(R<<2)>>2]|0;if((_|0)<(R|0))R=_;else break}if((U|0)==(P|0))Za=R;else{_=P;while(1){I=f[K+(_<<2)>>2]|0;if((I|0)<(_|0))_=I;else break}I=(R|0)>(_|0)?_:R;T=P;do{N=K+(T<<2)|0;L=T;T=f[N>>2]|0;f[N>>2]=I}while((T|0)<(L|0));Za=I}I=U;do{T=K+(I<<2)|0;P=I;I=f[T>>2]|0;f[T>>2]=Za}while((I|0)<(P|0));I=f[z+(M<<2)>>2]|0;U=Za;while(1){P=f[K+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((Za|0)==(I|0))_a=U;else{P=I;while(1){T=f[K+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(U|0)>(P|0)?P:U;R=I;do{_=K+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=T}while((R|0)<(L|0));_a=T}T=Za;do{R=K+(T<<2)|0;I=T;T=f[R>>2]|0;f[R>>2]=_a}while((T|0)<(I|0));f[z+(D<<2)>>2]=_a;J=E;break a}while(0);if(b[w+D>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;H=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;K=f[z+(M<<2)>>2]|0;I=T;while(1){R=f[H+(I<<2)>>2]|0;if((R|0)<(I|0))I=R;else break}if((T|0)==(K|0))$a=I;else{R=K;while(1){U=f[H+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}U=(I|0)>(R|0)?R:I;P=K;do{L=H+(P<<2)|0;_=P;P=f[L>>2]|0;f[L>>2]=U}while((P|0)<(_|0));$a=U}U=T;do{P=H+(U<<2)|0;K=U;U=f[P>>2]|0;f[P>>2]=$a}while((U|0)<(K|0));f[z+(D<<2)>>2]=$a;J=E;break a}while(0);U=f[l>>2]|0;H=f[y+(D<<2)>>2]|0;T=f[y+(S<<2)>>2]|0;K=H;while(1){P=f[U+(K<<2)>>2]|0;if((P|0)<(K|0))K=P;else break}if((H|0)==(T|0))ab=K;else{P=T;while(1){I=f[U+(P<<2)>>2]|0;if((I|0)<(P|0))P=I;else break}I=(K|0)>(P|0)?P:K;R=T;do{_=U+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=I}while((R|0)<(L|0));ab=I}I=H;do{R=U+(I<<2)|0;T=I;I=f[R>>2]|0;f[R>>2]=ab}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;H=ab;while(1){T=f[U+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}if((ab|0)==(I|0))bb=H;else{T=I;while(1){R=f[U+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(H|0)>(T|0)?T:H;K=I;do{P=U+(K<<2)|0;L=K;K=f[P>>2]|0;f[P>>2]=R}while((K|0)<(L|0));bb=R}R=ab;do{K=U+(R<<2)|0;I=R;R=f[K>>2]|0;f[K>>2]=bb}while((R|0)<(I|0));f[z+(D<<2)>>2]=bb;J=E;break}if(!(b[w+F>>0]|0)){R=f[l>>2]|0;U=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;K=U;while(1){H=f[R+(K<<2)>>2]|0;if((H|0)<(K|0))K=H;else break}if((U|0)==(I|0))cb=K;else{H=I;while(1){T=f[R+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}T=(K|0)>(H|0)?H:K;L=I;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=T}while((L|0)<(_|0));cb=T}T=U;do{L=R+(T<<2)|0;I=T;T=f[L>>2]|0;f[L>>2]=cb}while((T|0)<(I|0));f[z+(D<<2)>>2]=cb;J=E;break}do if(C){if(!(b[x+O>>0]|0))break;T=f[y+(S<<2)>>2]|0;R=f[l>>2]|0;if(b[x+D>>0]|0){U=f[z+(M<<2)>>2]|0;I=T;while(1){L=f[R+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(U|0))db=I;else{L=U;while(1){K=f[R+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(I|0)>(L|0)?L:I;H=U;do{_=R+(H<<2)|0;P=H;H=f[_>>2]|0;f[_>>2]=K}while((H|0)<(P|0));db=K}K=T;do{H=R+(K<<2)|0;U=K;K=f[H>>2]|0;f[H>>2]=db}while((K|0)<(U|0));f[z+(D<<2)>>2]=db;J=E;break a}K=f[y+(M<<2)>>2]|0;U=K;while(1){H=f[R+(U<<2)>>2]|0;if((H|0)<(U|0))U=H;else break}if((K|0)==(T|0))eb=U;else{H=T;while(1){I=f[R+(H<<2)>>2]|0;if((I|0)<(H|0))H=I;else break}I=(U|0)>(H|0)?H:U;L=T;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=I}while((L|0)<(_|0));eb=I}I=K;do{L=R+(I<<2)|0;T=I;I=f[L>>2]|0;f[L>>2]=eb}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;K=eb;while(1){T=f[R+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((eb|0)==(I|0))fb=K;else{T=I;while(1){L=f[R+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}L=(K|0)>(T|0)?T:K;U=I;do{H=R+(U<<2)|0;_=U;U=f[H>>2]|0;f[H>>2]=L}while((U|0)<(_|0));fb=L}L=eb;do{U=R+(L<<2)|0;I=L;L=f[U>>2]|0;f[U>>2]=fb}while((L|0)<(I|0));f[z+(D<<2)>>2]=fb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(M<<2)>>2]|0;R=f[y+(S<<2)>>2]|0;I=L;while(1){U=f[O+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}if((L|0)==(R|0))gb=I;else{S=R;while(1){U=f[O+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}U=(I|0)>(S|0)?S:I;K=R;do{T=O+(K<<2)|0;_=K;K=f[T>>2]|0;f[T>>2]=U}while((K|0)<(_|0));gb=U}U=L;do{K=O+(U<<2)|0;R=U;U=f[K>>2]|0;f[K>>2]=gb}while((U|0)<(R|0));U=f[z+(M<<2)>>2]|0;L=gb;while(1){R=f[O+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((gb|0)==(U|0))hb=L;else{M=U;while(1){R=f[O+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}R=(L|0)>(M|0)?M:L;K=U;do{I=O+(K<<2)|0;S=K;K=f[I>>2]|0;f[I>>2]=R}while((K|0)<(S|0));hb=R}R=gb;do{K=O+(R<<2)|0;U=R;R=f[K>>2]|0;f[K>>2]=hb}while((R|0)<(U|0));f[z+(D<<2)>>2]=hb;J=E;break}do if(A){R=D+-2|0;if(b[w+F>>0]|0){O=f[z+(R<<2)>>2]|0;do if((R|0)>-1){if(!(b[v+R>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);U=f[l>>2]|0;K=f[y+(R<<2)>>2]|0;L=K;while(1){M=f[U+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(O|0))ib=L;else{M=O;while(1){S=f[U+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}S=(L|0)>(M|0)?M:L;I=O;do{_=U+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=S}while((I|0)<(T|0));ib=S}S=K;do{I=U+(S<<2)|0;O=S;S=f[I>>2]|0;f[I>>2]=ib}while((S|0)<(O|0));f[z+(D<<2)>>2]=ib;J=E;break a}if(!(b[w+D>>0]|0)){jb=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(!(b[w+R>>0]|0)){S=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;K=f[z+(R<<2)>>2]|0;O=U;while(1){I=f[S+(O<<2)>>2]|0;if((I|0)<(O|0))O=I;else break}if((U|0)==(K|0))kb=O;else{I=K;while(1){L=f[S+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}L=(O|0)>(I|0)?I:O;M=K;do{T=S+(M<<2)|0;_=M;M=f[T>>2]|0;f[T>>2]=L}while((M|0)<(_|0));kb=L}L=U;do{M=S+(L<<2)|0;K=L;L=f[M>>2]|0;f[M>>2]=kb}while((L|0)<(K|0));f[z+(D<<2)>>2]=kb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;U=f[z+(R<<2)>>2]|0;K=S;while(1){M=f[L+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((S|0)==(U|0))lb=K;else{M=U;while(1){O=f[L+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;I=U;do{_=L+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=O}while((I|0)<(T|0));lb=O}O=S;do{I=L+(O<<2)|0;U=O;O=f[I>>2]|0;f[I>>2]=lb}while((O|0)<(U|0));f[z+(D<<2)>>2]=lb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;U=L;while(1){I=f[O+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}if((L|0)==(S|0))mb=U;else{R=S;while(1){I=f[O+(R<<2)>>2]|0;if((I|0)<(R|0))R=I;else break}I=(U|0)>(R|0)?R:U;K=S;do{M=O+(K<<2)|0;T=K;K=f[M>>2]|0;f[M>>2]=I}while((K|0)<(T|0));mb=I}I=L;do{K=O+(I<<2)|0;S=I;I=f[K>>2]|0;f[K>>2]=mb}while((I|0)<(S|0));f[z+(D<<2)>>2]=mb;J=E;break a}else jb=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(jb<<2)>>2];J=E;break}if(A){I=D+-2|0;if(b[w+F>>0]|0){O=f[z+(I<<2)>>2]|0;do if((I|0)>-1){if(!(b[v+I>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(I<<2)>>2]|0;K=S;while(1){U=f[L+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((S|0)==(O|0))nb=K;else{U=O;while(1){R=f[L+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(K|0)>(U|0)?U:K;T=O;do{M=L+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=R}while((T|0)<(_|0));nb=R}R=S;do{T=L+(R<<2)|0;O=R;R=f[T>>2]|0;f[T>>2]=nb}while((R|0)<(O|0));f[z+(D<<2)>>2]=nb;J=E;break}if(!(b[w+D>>0]|0))ob=I;else{do if((I|0)>-1){if(!(b[v+I>>0]|0))break;if(!(b[w+I>>0]|0)){R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;O=L;while(1){T=f[R+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((L|0)==(S|0))pb=O;else{T=S;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(O|0)>(T|0)?T:O;U=S;do{_=R+(U<<2)|0;M=U;U=f[_>>2]|0;f[_>>2]=K}while((U|0)<(M|0));pb=K}K=L;do{U=R+(K<<2)|0;S=K;K=f[U>>2]|0;f[U>>2]=pb}while((K|0)<(S|0));f[z+(D<<2)>>2]=pb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(I<<2)>>2];J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(I<<2)>>2]|0;S=R;while(1){U=f[K+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((R|0)==(L|0))qb=S;else{U=L;while(1){O=f[K+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(S|0)>(U|0)?U:S;T=L;do{M=K+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=O}while((T|0)<(_|0));qb=O}O=R;do{T=K+(O<<2)|0;L=O;O=f[T>>2]|0;f[T>>2]=qb}while((O|0)<(L|0));f[z+(D<<2)>>2]=qb;J=E;break a}while(0);O=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;L=K;while(1){T=f[O+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((K|0)==(R|0))rb=L;else{I=R;while(1){T=f[O+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}T=(L|0)>(I|0)?I:L;S=R;do{U=O+(S<<2)|0;_=S;S=f[U>>2]|0;f[U>>2]=T}while((S|0)<(_|0));rb=T}T=K;do{S=O+(T<<2)|0;R=T;T=f[S>>2]|0;f[S>>2]=rb}while((T|0)<(R|0));f[z+(D<<2)>>2]=rb;J=E;break}}else ob=D+-2|0;f[z+(D<<2)>>2]=f[z+(ob<<2)>>2];J=E;break}}T=D|1;O=(T|0)<(n|0);if(!(B|O^1)?b[w+T>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(G?b[w+F>>0]|0:0){K=f[y+(D<<2)>>2]|0;if(C?b[x+D>>0]|0:0){f[z+(D<<2)>>2]=K;J=E;break}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;L=S;while(1){I=f[R+(L<<2)>>2]|0;if((I|0)<(L|0))L=I;else break}if((S|0)==(K|0))sb=L;else{I=K;while(1){_=f[R+(I<<2)>>2]|0;if((_|0)<(I|0))I=_;else break}_=(L|0)>(I|0)?I:L;U=K;do{M=R+(U<<2)|0;H=U;U=f[M>>2]|0;f[M>>2]=_}while((U|0)<(H|0));sb=_}_=S;do{U=R+(_<<2)|0;K=_;_=f[U>>2]|0;f[U>>2]=sb}while((_|0)<(K|0));f[z+(D<<2)>>2]=sb;J=E;break}f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(O?b[v+T>>0]|0:0){_=D+2|0;if(!((_|0)>=(n|0)|B)?b[w+_>>0]|0:0){if(b[w+D>>0]|0){if(C?b[x+T>>0]|0:0){f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;K=f[y+(_<<2)>>2]|0;U=S;while(1){L=f[R+(U<<2)>>2]|0;if((L|0)<(U|0))U=L;else break}if((S|0)==(K|0))tb=U;else{O=K;while(1){L=f[R+(O<<2)>>2]|0;if((L|0)<(O|0))O=L;else break}L=(U|0)>(O|0)?O:U;I=K;do{H=R+(I<<2)|0;M=I;I=f[H>>2]|0;f[H>>2]=L}while((I|0)<(M|0));tb=L}L=S;do{I=R+(L<<2)|0;K=L;L=f[I>>2]|0;f[I>>2]=tb}while((L|0)<(K|0));f[z+(D<<2)>>2]=tb;J=E;break}if(G?b[w+F>>0]|0:0){do if(C){if(!(b[x+T>>0]|0))break;L=f[y+(_<<2)>>2]|0;if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;K=S;while(1){I=f[R+(K<<2)>>2]|0;if((I|0)<(K|0))K=I;else break}if((S|0)==(L|0))ub=K;else{I=L;while(1){U=f[R+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}U=(K|0)>(I|0)?I:K;O=L;do{M=R+(O<<2)|0;H=O;O=f[M>>2]|0;f[M>>2]=U}while((O|0)<(H|0));ub=U}U=S;do{O=R+(U<<2)|0;L=U;U=f[O>>2]|0;f[O>>2]=ub}while((U|0)<(L|0));f[z+(D<<2)>>2]=ub;J=E;break a}while(0);T=f[l>>2]|0;U=f[y+(D+-2<<2)>>2]|0;R=f[y+(_<<2)>>2]|0;S=U;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((U|0)==(R|0))vb=S;else{L=R;while(1){O=f[T+(L<<2)>>2]|0;if((O|0)<(L|0))L=O;else break}O=(S|0)>(L|0)?L:S;K=R;do{I=T+(K<<2)|0;H=K;K=f[I>>2]|0;f[I>>2]=O}while((K|0)<(H|0));vb=O}O=U;do{K=T+(O<<2)|0;R=O;O=f[K>>2]|0;f[K>>2]=vb}while((O|0)<(R|0));f[z+(D<<2)>>2]=vb;J=E;break}f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0}while(0);D=D+2|0;if((D|0)>=(n|0)){wb=J;break}else E=J}}else wb=s;a=a+2|0;if((a|0)>=(f[d>>2]|0))break;else s=wb}o=wb;p=f[g>>2]|0;q=o-j|0;r=p+(c<<2)|0;f[r>>2]=q;return}function s4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[a+12>>2]|0;e=f[a+8>>2]|0;g=f[c>>2]|0;if((g|0)>=(e|0))return;h=f[a+16>>2]|0;i=f[a+44>>2]|0;a=(d|0)>0;j=d+-1|0;k=g;do{g=f[i>>2]|0;l=h+(Y(g,k)|0)|0;m=l+(0-g)|0;if(a){g=0;do{n=l+(g<<2)|0;o=f[n>>2]|0;if((o|0)>0){if((g|0)>0?(p=f[m+(g+-1<<2)>>2]|0,(p|0)>0):0){q=p;while(1){r=f[b+(q<<2)>>2]|0;if((r|0)<(q|0))q=r;else break}if((p|0)==(o|0))s=q;else{r=o;while(1){t=f[b+(r<<2)>>2]|0;if((t|0)<(r|0))r=t;else break}t=(q|0)>(r|0)?r:q;u=o;do{v=b+(u<<2)|0;w=u;u=f[v>>2]|0;f[v>>2]=t}while((u|0)<(w|0));s=t}t=p;do{u=b+(t<<2)|0;q=t;t=f[u>>2]|0;f[u>>2]=s}while((t|0)<(q|0));f[n>>2]=s;x=s}else x=o;if((g|0)<(j|0)?(t=f[m+(g+1<<2)>>2]|0,(t|0)>0):0){p=t;while(1){q=f[b+(p<<2)>>2]|0;if((q|0)<(p|0))p=q;else break}if((t|0)==(x|0))y=p;else{o=x;while(1){q=f[b+(o<<2)>>2]|0;if((q|0)<(o|0))o=q;else break}q=(p|0)>(o|0)?o:p;u=x;do{r=b+(u<<2)|0;w=u;u=f[r>>2]|0;f[r>>2]=q}while((u|0)<(w|0));y=q}q=t;do{u=b+(q<<2)|0;p=q;q=f[u>>2]|0;f[u>>2]=y}while((q|0)<(p|0));f[n>>2]=y;z=y}else z=x;q=f[m+(g<<2)>>2]|0;if((q|0)>0){t=q;while(1){p=f[b+(t<<2)>>2]|0;if((p|0)<(t|0))t=p;else break}if((q|0)==(z|0))A=t;else{p=z;while(1){u=f[b+(p<<2)>>2]|0;if((u|0)<(p|0))p=u;else break}u=(t|0)>(p|0)?p:t;o=z;do{w=b+(o<<2)|0;r=o;o=f[w>>2]|0;f[w>>2]=u}while((o|0)<(r|0));A=u}u=q;do{o=b+(u<<2)|0;t=u;u=f[o>>2]|0;f[o>>2]=A}while((u|0)<(t|0));f[n>>2]=A}}g=g+1|0}while((g|0)!=(d|0))}k=f[c+(k<<2)>>2]|0}while((k|0)<(e|0));return}function t4(a){a=a|0;O5b(a);return}function u4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=f[b>>2]|0;d=f[b+4>>2]|0;if((c|0)>0){b=a+16|0;o4((f[b>>2]|0)+(c*136|0)|0,f[f[a+20>>2]>>2]|0);e=f[b>>2]|0;f[e+(c*136|0)+132>>2]=d;if((c|0)>=(d|0))return;b=a+4|0;g=a+8|0;h=e+(c*136|0)+20|0;i=e+(c*136|0)+48|0;j=e+(c*136|0)+120|0;e=c;do{k=f[b>>2]|0;l=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,e)|0)|0;m=l+(f[k+12>>2]<<2)|0;if((l|0)!=(m|0)){k=f[g>>2]|0;n=f[h>>2]|0;o=f[i>>2]|0;p=f[j>>2]|0;q=((e|0)<0)<<31>>31;r=0;s=l;while(1){l=f[k+(f[s>>2]<<2)>>2]|0;f[s>>2]=l;t=n+(Y(f[o>>2]|0,l)|0)|0;u=f[t>>2]|0;f[t>>2]=(u|0)>(r|0)?r:u;u=t+8|0;v=f[u>>2]|0;f[u>>2]=(v|0)<(r|0)?r:v;v=t+4|0;u=f[v>>2]|0;f[v>>2]=(u|0)>(e|0)?e:u;u=t+12|0;v=f[u>>2]|0;f[u>>2]=(v|0)<(e|0)?e:v;v=t+16|0;f[v>>2]=(f[v>>2]|0)+1;v=p+(l<<4)|0;t=v;u=Kac(f[t>>2]|0,f[t+4>>2]|0,r|0,((r|0)<0)<<31>>31|0)|0;t=v;f[t>>2]=u;f[t+4>>2]=J;t=p+(l<<4)+8|0;l=t;u=Kac(f[l>>2]|0,f[l+4>>2]|0,e|0,q|0)|0;l=t;f[l>>2]=u;f[l+4>>2]=J;s=s+4|0;if((s|0)==(m|0))break;else r=r+1|0}}e=e+1|0}while((e|0)!=(d|0));return}else{e=a+12|0;f[(f[e>>2]|0)+132>>2]=d;if((c|0)>=(d|0))return;j=a+4|0;i=a+8|0;a=c;do{c=f[j>>2]|0;h=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,a)|0)|0;g=h+(f[c+12>>2]<<2)|0;if((h|0)!=(g|0)){c=f[i>>2]|0;b=((a|0)<0)<<31>>31;r=h;h=0;while(1){m=f[c+(f[r>>2]<<2)>>2]|0;f[r>>2]=m;s=f[e>>2]|0;q=(f[s+20>>2]|0)+(Y(f[f[s+48>>2]>>2]|0,m)|0)|0;p=f[q>>2]|0;f[q>>2]=(p|0)>(h|0)?h:p;p=q+8|0;o=f[p>>2]|0;f[p>>2]=(o|0)<(h|0)?h:o;o=q+4|0;p=f[o>>2]|0;f[o>>2]=(p|0)>(a|0)?a:p;p=q+12|0;o=f[p>>2]|0;f[p>>2]=(o|0)<(a|0)?a:o;o=q+16|0;f[o>>2]=(f[o>>2]|0)+1;o=f[s+120>>2]|0;s=o+(m<<4)|0;q=s;p=Kac(f[q>>2]|0,f[q+4>>2]|0,h|0,((h|0)<0)<<31>>31|0)|0;q=s;f[q>>2]=p;f[q+4>>2]=J;q=o+(m<<4)+8|0;m=q;o=Kac(f[m>>2]|0,f[m+4>>2]|0,a|0,b|0)|0;m=q;f[m>>2]=o;f[m+4>>2]=J;r=r+4|0;if((r|0)==(g|0))break;else h=h+1|0}}a=a+1|0}while((a|0)!=(d|0));return}}function v4(a){a=a|0;O5b(a);return}function w4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=a+8|0;h=f[g>>2]|0;i=(((Y(f[h+12>>2]|0,d)|0)+1|0)/2|0)+1|0;j=a+4|0;k=f[j>>2]|0;l=f[k+12>>2]|0;if((d|0)==(f[e>>2]|0)){m=i;n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}q=(l|0)>0;r=a+12|0;a=d;s=i;t=k;k=h;while(1){h=f[f[t+44>>2]>>2]|0;u=(f[t+16>>2]|0)+(Y(h,a)|0)|0;v=u+(0-h)|0;h=f[f[k+44>>2]>>2]|0;w=(f[k+16>>2]|0)+(Y(h,a)|0)|0;x=w+(0-h)|0;a:do if(q){if((a|0)>(d|0)){y=0;z=s}else{h=0;A=s;while(1){do if(!(b[u+h>>0]|0)){f[w+(h<<2)>>2]=0;B=A}else{if((h|0)>0?(C=h+-1|0,b[u+C>>0]|0):0){f[w+(h<<2)>>2]=f[w+(C<<2)>>2];B=A;break}f[w+(h<<2)>>2]=A;f[(f[r>>2]|0)+(A<<2)>>2]=A;B=A+1|0}while(0);h=h+1|0;if((h|0)==(l|0)){D=B;break a}else A=B}}while(1){do if(!(b[u+y>>0]|0)){f[w+(y<<2)>>2]=0;E=z}else{A=(y|0)>0;if(!(b[v+y>>0]|0)){if(A?(h=y+-1|0,b[u+h>>0]|0):0){f[w+(y<<2)>>2]=f[w+(h<<2)>>2];E=z;break}f[w+(y<<2)>>2]=z;f[(f[r>>2]|0)+(z<<2)>>2]=z;E=z+1|0;break}h=f[x+(y<<2)>>2]|0;if(A?(A=y+-1|0,(b[u+A>>0]|0)!=0):0){C=f[r>>2]|0;F=f[w+(A<<2)>>2]|0;A=F;while(1){G=f[C+(A<<2)>>2]|0;if((G|0)<(A|0))A=G;else break}if((F|0)==(h|0))H=A;else{G=h;while(1){I=f[C+(G<<2)>>2]|0;if((I|0)<(G|0))G=I;else break}I=(A|0)>(G|0)?G:A;J=h;do{K=C+(J<<2)|0;L=J;J=f[K>>2]|0;f[K>>2]=I}while((J|0)<(L|0));H=I}I=F;do{J=C+(I<<2)|0;A=I;I=f[J>>2]|0;f[J>>2]=H}while((I|0)<(A|0));M=H}else M=h;f[w+(y<<2)>>2]=M;E=z}while(0);y=y+1|0;if((y|0)==(l|0)){D=E;break}else z=E}}else D=s;while(0);w=a+1|0;if((w|0)==(f[e>>2]|0)){m=D;break}a=w;s=D;t=f[j>>2]|0;k=f[g>>2]|0}n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}function x4(a){a=a|0;O5b(a);return}function y4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=d+1|0;h=a+8|0;i=f[h>>2]|0;j=(Y(((f[i+12>>2]|0)+1|0)/2|0,(g|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+12>>2]|0;n=f[e>>2]|0;if((d|0)==(n|0)){o=j;p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}r=(m|0)>0;s=m+-1|0;t=a+12|0;a=d;u=j;v=n;n=l;l=i;while(1){i=f[f[n+44>>2]>>2]|0;w=(f[n+16>>2]|0)+(Y(i,a)|0)|0;x=w+(0-i)|0;i=f[f[l+44>>2]>>2]|0;y=(f[l+16>>2]|0)+(Y(i,a)|0)|0;z=y+(0-i)|0;if(r){i=(a|0)>(d|0);A=i^1;B=0;C=u;while(1){a:do if(!(b[w+B>>0]|0)){f[y+(B<<2)>>2]=0;D=C}else{if(i){if(b[x+B>>0]|0){f[y+(B<<2)>>2]=f[z+(B<<2)>>2];D=C;break}if(!((B|0)>=(s|0)|A)){E=B+1|0;if(!(b[x+E>>0]|0))F=0;else{do if((B|0)>0){G=B+-1|0;if(!(b[x+G>>0]|0)){H=f[z+(E<<2)>>2]|0;if(!(b[w+G>>0]|0)){I=H;break}J=f[t>>2]|0;K=f[y+(G<<2)>>2]|0;L=K;while(1){M=f[J+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(H|0))N=L;else{M=H;while(1){O=f[J+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(L|0)>(M|0)?M:L;P=H;do{Q=J+(P<<2)|0;R=P;P=f[Q>>2]|0;f[Q>>2]=O}while((P|0)<(R|0));N=O}O=K;do{P=J+(O<<2)|0;H=O;O=f[P>>2]|0;f[P>>2]=N}while((O|0)<(H|0));I=N}else{O=f[t>>2]|0;J=f[z+(G<<2)>>2]|0;K=f[z+(E<<2)>>2]|0;H=J;while(1){P=f[O+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((J|0)==(K|0))S=H;else{G=K;while(1){P=f[O+(G<<2)>>2]|0;if((P|0)<(G|0))G=P;else break}P=(H|0)>(G|0)?G:H;L=K;do{M=O+(L<<2)|0;R=L;L=f[M>>2]|0;f[M>>2]=P}while((L|0)<(R|0));S=P}P=J;do{L=O+(P<<2)|0;K=P;P=f[L>>2]|0;f[L>>2]=S}while((P|0)<(K|0));f[y+(B<<2)>>2]=S;D=C;break a}}else I=f[z+(E<<2)>>2]|0;while(0);f[y+(B<<2)>>2]=I;D=C;break}}else F=A}else F=A;E=(B|0)>0;if(!(F|E^1)?(P=B+-1|0,b[x+P>>0]|0):0){f[y+(B<<2)>>2]=f[z+(P<<2)>>2];D=C;break}if(E?(E=B+-1|0,b[w+E>>0]|0):0){f[y+(B<<2)>>2]=f[y+(E<<2)>>2];D=C;break}f[y+(B<<2)>>2]=C;f[(f[t>>2]|0)+(C<<2)>>2]=C;D=C+1|0}while(0);B=B+1|0;if((B|0)==(m|0))break;else C=D}T=D;U=f[e>>2]|0}else{T=u;U=v}C=a+1|0;if((C|0)==(U|0)){o=T;break}a=C;u=T;v=U;n=f[k>>2]|0;l=f[h>>2]|0}p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}function z4(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;g=u;u=u+1312|0;i=g+112|0;j=g+92|0;k=g+32|0;l=g+8|0;m=g;o=a+24|0;p=(f[o>>2]|0)+8|0;q=i+8|0;f[q>>2]=0;f[i+12>>2]=0;f[i+28>>2]=0;f[i+32>>2]=0;f[i+48>>2]=0;f[i+52>>2]=0;f[i+68>>2]=0;f[i+72>>2]=0;f[i+88>>2]=0;f[i+92>>2]=0;f[i+108>>2]=0;f[i+112>>2]=0;f[i+128>>2]=0;f[i+132>>2]=0;f[i+148>>2]=0;f[i+152>>2]=0;f[i+168>>2]=0;f[i+172>>2]=0;f[i+188>>2]=0;f[i+192>>2]=0;f[i+208>>2]=0;f[i+212>>2]=0;f[i+228>>2]=0;f[i+232>>2]=0;f[i+248>>2]=0;f[i+252>>2]=0;f[i+268>>2]=0;f[i+272>>2]=0;f[i+288>>2]=0;f[i+292>>2]=0;f[i+308>>2]=0;f[i+312>>2]=0;f[i+328>>2]=0;f[i+332>>2]=0;f[i+348>>2]=0;f[i+352>>2]=0;f[i+368>>2]=0;f[i+372>>2]=0;f[i+388>>2]=0;f[i+392>>2]=0;f[i+408>>2]=0;f[i+412>>2]=0;f[i+428>>2]=0;f[i+432>>2]=0;f[i+448>>2]=0;f[i+452>>2]=0;f[i+468>>2]=0;f[i+472>>2]=0;f[i+488>>2]=0;f[i+492>>2]=0;f[i+508>>2]=0;f[i+512>>2]=0;f[i+528>>2]=0;f[i+532>>2]=0;f[i+548>>2]=0;f[i+552>>2]=0;f[i+568>>2]=0;f[i+572>>2]=0;f[i+588>>2]=0;f[i+592>>2]=0;f[i+608>>2]=0;f[i+612>>2]=0;f[i+628>>2]=0;f[i+632>>2]=0;f[i+648>>2]=0;f[i+652>>2]=0;f[i+668>>2]=0;f[i+672>>2]=0;f[i+688>>2]=0;f[i+692>>2]=0;f[i+708>>2]=0;f[i+712>>2]=0;f[i+728>>2]=0;f[i+732>>2]=0;f[i+748>>2]=0;f[i+752>>2]=0;f[i+768>>2]=0;f[i+772>>2]=0;f[i+788>>2]=0;f[i+792>>2]=0;f[i+808>>2]=0;f[i+812>>2]=0;f[i+828>>2]=0;f[i+832>>2]=0;f[i+848>>2]=0;f[i+852>>2]=0;f[i+868>>2]=0;f[i+872>>2]=0;f[i+888>>2]=0;f[i+892>>2]=0;f[i+908>>2]=0;f[i+912>>2]=0;f[i+928>>2]=0;f[i+932>>2]=0;f[i+948>>2]=0;f[i+952>>2]=0;f[i+968>>2]=0;f[i+972>>2]=0;f[i+988>>2]=0;f[i+992>>2]=0;f[i+1008>>2]=0;f[i+1012>>2]=0;f[i+1028>>2]=0;f[i+1032>>2]=0;f[i+1048>>2]=0;f[i+1052>>2]=0;f[i+1068>>2]=0;f[i+1072>>2]=0;f[i+1088>>2]=0;f[i+1092>>2]=0;f[i+1108>>2]=0;f[i+1112>>2]=0;f[i+1128>>2]=0;f[i+1132>>2]=0;f[i+1148>>2]=0;f[i+1152>>2]=0;f[i+1168>>2]=0;f[i+1172>>2]=0;f[i>>2]=q;r=i+4|0;f[r>>2]=p;if(p>>>0>59){t=N5b(p>>>0>214748364?-1:p*20|0)|0;v=t+(p*20|0)|0;p=t;do{f[p>>2]=0;f[p+4>>2]=0;p=p+20|0}while((p|0)!=(v|0));f[i>>2]=t;w=t}else w=q;f[j>>2]=0;f[j+4>>2]=0;t=f[o>>2]|0;f[k+36>>2]=0;v=k+40|0;f[v>>2]=0;p=a+56|0;x=f[p>>2]|0;y=f[p+4>>2]|0;p=f[a>>2]|0;if(!((p&12288|0)==4096?!((p&16384|0)==0?1:(f[a+28>>2]|0)!=1):0)){f[m>>2]=0;f[m+4>>2]=0;Vac(aD(m,129)|0,236252,129)|0;bO(-215,m,236382,236406,74);bD(m)}if((c|0)<=87){f[m>>2]=0;f[m+4>>2]=0;p=aD(m,37)|0;z=236477;A=p+37|0;do{b[p>>0]=b[z>>0]|0;p=p+1|0;z=z+1|0}while((p|0)<(A|0));bO(-215,m,236382,236406,75);bD(m)}QW(f[a>>2]&-4096|12,c,8,d,l);if(f[o>>2]|0){o=k+32|0;b[o>>0]=0;xea(a,k);a=j+16|0;f[a>>2]=0;a:do if((t|0)>0){d=k+28|0;c=k+12|0;m=k+36|0;z=(e|0)==1;p=l+12|0;A=l+20|0;B=k+20|0;if((e|0)<3)C=0;else{D=j;E=0;while(1){F=b[f[d>>2]>>0]|0;G=f[c>>2]|0;f[d>>2]=G;H=m;I=f[H>>2]|0;J=f[H+4>>2]|0;H=G;if(!G)K=b[o>>0]|0;else{G=b[H>>0]|0;b[o>>0]=G;L=H+1|0;f[c>>2]=L;if(L>>>0<(f[B>>2]|0)>>>0){N=G;O=I}else{VW(k,1);N=b[o>>0]|0;O=f[m>>2]|0}G=N<<24>>24;f[m>>2]=O+(b[k+44+(G<<1)>>0]|0);f[v>>2]=(f[v>>2]|0)+(b[k+44+(G<<1)+1>>0]|0);K=N}G=(K<<24>>24)-F|0;F=f[52084+(G+7<<2)>>2]|0;L=w+(E*20|0)|0;if(!G)P=D;else{f[D+16>>2]=L;P=L}f[w+(E*20|0)+12>>2]=F;F=w+(E*20|0)|0;f[F>>2]=I;f[F+4>>2]=J;J=E+1|0;if((J|0)<(t|0)){D=P;E=J}else{Q=P;R=J;break a}}}while(1){E=b[f[d>>2]>>0]|0;D=f[c>>2]|0;f[d>>2]=D;J=m;F=f[J>>2]|0;I=f[J+4>>2]|0;J=D;if(!D)S=b[o>>0]|0;else{D=b[J>>0]|0;b[o>>0]=D;L=J+1|0;f[c>>2]=L;if(L>>>0<(f[B>>2]|0)>>>0){T=D;U=F}else{VW(k,1);T=b[o>>0]|0;U=f[m>>2]|0}D=T<<24>>24;f[m>>2]=U+(b[k+44+(D<<1)>>0]|0);f[v>>2]=(f[v>>2]|0)+(b[k+44+(D<<1)+1>>0]|0);S=T}if(z|S<<24>>24!=E<<24>>24){E=f[p>>2]|0;if(E>>>0<(f[A>>2]|0)>>>0)V=E;else{TW(l);V=f[p>>2]|0}E=V;D=E;b[D>>0]=F;b[D+1>>0]=F>>8;b[D+2>>0]=F>>16;b[D+3>>0]=F>>24;F=E+4|0;b[F>>0]=I;b[F+1>>0]=I>>8;b[F+2>>0]=I>>16;b[F+3>>0]=I>>24;f[p>>2]=(f[p>>2]|0)+8}I=C+1|0;if((I|0)<(t|0))C=I;else{Q=j;R=I;break}}}else{Q=j;R=0}while(0);if((e|0)>=3){f[Q+16>>2]=0;Q=f[a>>2]|0;C=w;t=(e|0)==4;e=Q;do{V=(e-C|0)/20|0;S=e;T=f[S>>2]|0;k=f[S+4>>2]|0;S=1;v=0;U=0;while(1){o=V-S|0;P=((o|0)<0?R:0)+o|0;o=S+V|0;K=o-((o|0)>=(R|0)?R:0)|0;o=f[w+(P*20|0)>>2]|0;N=(f[w+(K*20|0)>>2]|0)-o|0;O=f[w+(P*20|0)+4>>2]|0;P=(f[w+(K*20|0)+4>>2]|0)-O|0;K=(Y(P,P)|0)+(Y(N,N)|0)|0;p=(Y(P,T-o|0)|0)-(Y(k-O|0,N)|0)|0;N=(n[s>>2]=+(v|0)*+(K|0)-+(U|0)*+(p|0),f[s>>2]|0);if((S|0)>1){if((U|0)>=(K|0))break;if((v|0)>0&(N|0)<1)break;if((v|0)<0&(N|0)>-1)break}S=S+1|0;v=p;U=K}U=S+-1|0;f[e+8>>2]=U;if(t){v=U;K=0;while(1){p=V-v|0;N=((p|0)<0?R:0)+p|0;p=v+V|0;O=p-((p|0)>=(R|0)?R:0)|0;p=(f[w+(N*20|0)>>2]|0)-T|0;o=(f[w+(N*20|0)+4>>2]|0)-k|0;N=(f[w+(O*20|0)>>2]|0)-T|0;P=(f[w+(O*20|0)+4>>2]|0)-k|0;if((o|p|0)==0|(P|N|0)==0){W=K;break}X=+(p|0);Z=+(o|0);_=+(N|0);$=+(P|0);aa=+((Y(P,o)|0)+(Y(N,p)|0)|0)/+M(+((X*X+Z*Z)*(_*_+$*$)))+1.1;p=(n[s>>2]=aa,f[s>>2]|0);if(!((v|0)>=(U|0)|(p|0)>(K|0))){W=K;break}if((v|0)>1){v=v+-1|0;K=p}else{W=p;break}}f[e+12>>2]=W}e=f[e+16>>2]|0}while((e|0)!=0);ba=j;ca=Q;while(1){Q=f[ca+8>>2]>>1;e=ca+12|0;W=f[e>>2]|0;K=(ca-C|0)/20|0;b:do if((Q|0)<1)da=ca;else{v=1;while(1){U=K-v|0;if((f[w+((((U|0)<0?R:0)+U|0)*20|0)+12>>2]|0)>(W|0))break;U=v+K|0;if((f[w+((U-((U|0)>=(R|0)?R:0)|0)*20|0)+12>>2]|0)>(W|0))break;if((v|0)<(Q|0))v=v+1|0;else{da=ca;break b}}f[ba+16>>2]=f[ca+16>>2];f[e>>2]=0;da=ba}while(0);ca=f[ca+16>>2]|0;if(!ca)break;else ba=da}da=j;ba=f[a>>2]|0;while(1){do if((f[ba+8>>2]|0)==1){ca=ba+12|0;e=f[ca>>2]|0;Q=ba-C|0;W=(Q|0)/20|0;K=W+1|0;if((e|0)>(f[w+((W+-1+((Q|0)<20?R:0)|0)*20|0)+12>>2]|0)?(e|0)>(f[w+((K-((K|0)>=(R|0)?R:0)|0)*20|0)+12>>2]|0):0){ea=ba;break}f[da+16>>2]=f[ba+16>>2];f[ca>>2]=0;ea=da}else ea=ba;while(0);ba=f[ba+16>>2]|0;if(!ba)break;else da=ea}do if(!t){if(f[w+12>>2]|0?(ea=R+-1|0,f[w+(ea*20|0)+12>>2]|0):0){c:do if((R|0)>1){da=1;while(1){if(!(f[w+(da*20|0)+12>>2]|0)){fa=da;break c}f[w+((da+-1|0)*20|0)+12>>2]=0;ba=da+1|0;if((ba|0)<(R|0))da=ba;else{fa=ba;break}}}else fa=1;while(0);if((fa|0)==(R|0))break;da=fa+-1|0;d:do if((R|0)>2){ba=R+-2|0;ca=ea;while(1){if(!(f[w+(ba*20|0)+12>>2]|0)){ga=ca;break d}f[w+(ba*20|0)+16>>2]=0;f[w+(ca*20|0)+12>>2]=0;if((ba|0)>1){K=ba;ba=ba+-1|0;ca=K}else{ga=ba;break}}}else ga=ea;while(0);if((da|0)==0&(ga|0)==(ea|0)){ba=((f[w+16>>2]|0)-C|0)/20|0;ca=w+(R*20|0)|0;f[ca>>2]=f[w>>2];f[ca+4>>2]=f[w+4>>2];f[ca+8>>2]=f[w+8>>2];f[ca+12>>2]=f[w+12>>2];f[ca+16>>2]=f[w+16>>2];f[w+(R*20|0)+16>>2]=0;f[w+(ea*20|0)+16>>2]=ca;ha=ba}else ha=da;f[a>>2]=w+(ha*20|0)}ba=j;ca=f[a>>2]|0;while(1){K=ca+16|0;e=f[K>>2]|0;e:do if(!e){ia=1;ja=ba;ka=ca;la=e;ma=K}else{Q=1;W=ba;v=ca;U=e;k=K;while(1){if((U-v|0)!=20){ia=Q;ja=W;ka=v;la=U;ma=k;break e}T=Q+1|0;V=U+16|0;S=f[V>>2]|0;if(!S){ia=T;ja=v;ka=U;la=S;ma=V;break}else{p=U;N=v;Q=T;U=S;k=V;v=p;W=N}}}while(0);if((ia|0)>1){do if((ia|0)==2){K=f[ja+12>>2]|0;e=f[ka+12>>2]|0;if((K|0)<=(e|0)){if((K|0)!=(e|0)){na=ka;oa=ba;break}if((f[ja+8>>2]|0)>(f[ka+8>>2]|0)){na=ka;oa=ba;break}}na=la;oa=ja}else{na=ka;oa=f[ba+16>>2]|0}while(0);f[oa+16>>2]=na;pa=f[ma>>2]|0}else pa=la;if(!pa)break;else{ba=ka;ca=pa}}}while(0);pa=l+12|0;ka=l+20|0;la=f[a>>2]|0;a=f[pa>>2]|0;do{if(a>>>0<(f[ka>>2]|0)>>>0)qa=a;else{TW(l);qa=f[pa>>2]|0}ma=la;na=ma;oa=h[na>>0]|h[na+1>>0]<<8|h[na+2>>0]<<16|h[na+3>>0]<<24;na=ma+4|0;ma=h[na>>0]|h[na+1>>0]<<8|h[na+2>>0]<<16|h[na+3>>0]<<24;na=qa;ja=na;b[ja>>0]=oa;b[ja+1>>0]=oa>>8;b[ja+2>>0]=oa>>16;b[ja+3>>0]=oa>>24;oa=na+4|0;b[oa>>0]=ma;b[oa+1>>0]=ma>>8;b[oa+2>>0]=ma>>16;b[oa+3>>0]=ma>>24;a=(f[pa>>2]|0)+8|0;f[pa>>2]=a;la=f[la+16>>2]|0}while((la|0)!=0)}}else{la=l+12|0;a=f[la>>2]|0;if(a>>>0<(f[l+20>>2]|0)>>>0)ra=a;else{TW(l);ra=f[la>>2]|0}a=ra;ra=a;b[ra>>0]=x;b[ra+1>>0]=x>>8;b[ra+2>>0]=x>>16;b[ra+3>>0]=x>>24;x=a+4|0;b[x>>0]=y;b[x+1>>0]=y>>8;b[x+2>>0]=y>>16;b[x+3>>0]=y>>24;f[la>>2]=(f[la>>2]|0)+8}la=SW(l)|0;l=f[i>>2]|0;if((l|0)==(q|0)){u=g;return la|0}if(l|0)P5b(l);f[i>>2]=q;f[r>>2]=59;u=g;return la|0}function A4(a,c,d,e){a=a|0;c=c|0;d=+d;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;g=u;u=u+2320|0;h=g+2312|0;i=g+2256|0;j=g+1160|0;k=g+64|0;l=g;m=g+8|0;dQ(h,52144);do if((yM(a)|0)==65536){n=f[a+4>>2]|0;f[i>>2]=f[n>>2];o=i+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[n+8>>2];f[i+12>>2]=f[n+12>>2];f[i+16>>2]=f[n+16>>2];f[i+20>>2]=f[n+20>>2];f[i+24>>2]=f[n+24>>2];f[i+28>>2]=f[n+28>>2];f[i+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=q;q=i+48|0;s=i+44|0;f[s>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[s>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;jL(i,n);break}}else yL(i,a,-1);while(0);a=wM(i,2,-1,1)|0;n=f[i>>2]|0;o=n&7;if(!((a|0)>-1&(o|1|0)==5)){f[j>>2]=0;f[j+4>>2]=0;p=aD(j,42)|0;q=236515;s=p+42|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(s|0));bO(-215,j,236558,236406,682);bD(j)}if(a){q=j+8|0;Nac(q|0,0,1088)|0;f[j>>2]=q;p=j+4|0;s=a>>>0>136;f[p>>2]=a;if(s){r=N5b(a>>>0>536870911?-1:a<<3)|0;Nac(r|0,0,a<<3|0)|0;f[j>>2]=r;t=r}else t=q;r=k+8|0;Nac(r|0,0,1088)|0;f[k>>2]=r;v=k+4|0;f[v>>2]=a;if(s){s=N5b(a>>>0>536870911?-1:a<<3)|0;Nac(s|0,0,a<<3|0)|0;f[k>>2]=s}switch(n&7){case 4:{w=B4(f[i+16>>2]|0,a,t,e,d,k)|0;break}case 5:{w=C4(f[i+16>>2]|0,a,t,e,d,k)|0;break}default:{f[l>>2]=0;f[l+4>>2]=0;bO(-210,l,236558,236406,700);bD(l);w=0}}Qi(m,w,1,o|8,t,0);SP(m,c);t=m+36|0;o=f[t>>2]|0;if(o|0?(w=o+12|0,o=f[w>>2]|0,f[w>>2]=o+-1,(o|0)==1):0)kL(m);f[t>>2]=0;t=m+16|0;o=m+4|0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[o>>2]|0)>0){t=f[m+40>>2]|0;w=0;do{f[t+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)!=(m+48|0))UC(o);o=f[k>>2]|0;if((o|0)!=(r|0)){if(o|0)P5b(o);f[k>>2]=r;f[v>>2]=136}v=f[j>>2]|0;if((v|0)!=(q|0)){if(v|0)P5b(v);f[j>>2]=q;f[p>>2]=136}}else $L(c);c=i+36|0;p=f[c>>2]|0;if(p|0?(q=p+12|0,p=f[q>>2]|0,f[q>>2]=p+-1,(p|0)==1):0)kL(i);f[c>>2]=0;c=i+16|0;p=i+4|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[p>>2]|0)>0){c=f[i+40>>2]|0;q=0;do{f[c+(q<<2)>>2]=0;q=q+1|0}while((q|0)<(f[p>>2]|0))}p=f[i+44>>2]|0;if((p|0)!=(i+48|0))UC(p);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function B4(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0,H=0.0,I=0,J=0,K=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;h=g+4|0;i=f[h>>2]|0;j=f[g>>2]|0;if(!b){k=0;return k|0}l=e*e;if(!d){m=b+-1|0;if((f[a+(m<<3)>>2]|0)==(f[a>>2]|0)?(f[a+(m<<3)+4>>2]|0)==(f[a+4>>2]|0):0){n=1;o=7}else{if(!i){f[h>>2]=0;p=0}else p=i;q=j;f[q>>2]=0;f[q+4>>2]=m;r=1;s=j;t=p;u=0;v=b;o=41}}else{n=3;o=7}do if((o|0)==7){if((b|0)>1){p=0;m=0;q=0;while(1){w=(m+q|0)%(b|0)|0;x=f[a+(w<<3)>>2]|0;y=f[a+(w<<3)+4>>2]|0;z=w+1|0;w=1;e=0.0;A=(z|0)>=(b|0)?0:z;z=q;do{B=A+1|0;C=A;A=(B|0)>=(b|0)?0:B;D=+((f[a+(C<<3)>>2]|0)-x|0);E=+((f[a+(C<<3)+4>>2]|0)-y|0);F=D*D+E*E;C=F>e;z=C?w:z;e=C?F:e;w=w+1|0}while((w|0)!=(b|0));p=p+1|0;if((p|0)>=(n|0)){G=A;H=e;I=x;J=z;K=y;break}else{m=A;q=z}}}else{q=0;m=0;do{M=(m|0)%(b|0)|0;p=M+1|0;m=(p|0)>=(b|0)?0:p;q=q+1|0}while((q|0)<(n|0));G=m;H=0.0;I=f[a+(M<<3)>>2]|0;J=0;K=f[a+(M<<3)+4>>2]|0}if(H<=l){f[c>>2]=I;f[c+4>>2]=K;N=1;break}q=(G|0)%(b|0)|0;p=(q+J|0)%(b|0)|0;if(!i){w=(i*3|0)>>>1;C=f[h>>2]|0;if(C>>>0<w>>>0){B=f[g>>2]|0;O=g+8|0;f[g>>2]=O;f[h>>2]=w;if((C|0)!=0&(O|0)!=(B|0)){P=B;Q=f[P+4>>2]|0;R=O;f[R>>2]=f[P>>2];f[R+4>>2]=Q;if((C|0)!=1){Q=B+8|0;R=f[Q+4>>2]|0;P=g+16|0;f[P>>2]=f[Q>>2];f[P+4>>2]=R;if((C|0)==2)S=C;else{R=2;do{P=B+(R<<3)|0;Q=f[P+4>>2]|0;O=(f[g>>2]|0)+(R<<3)|0;f[O>>2]=f[P>>2];f[O+4>>2]=Q;R=R+1|0}while((R|0)!=(C|0));S=C}}else S=1}else S=C;do{R=(f[g>>2]|0)+(S<<3)|0;f[R>>2]=0;f[R+4>>2]=0;S=S+1|0}while((S|0)!=(w|0));if(!((B|0)==(g+8|0)|(B|0)==0))P5b(B)}else f[h>>2]=w;T=f[g>>2]|0;U=f[h>>2]|0}else{T=j;U=i}C=T;f[C>>2]=p;f[C+4>>2]=q;if(U>>>0>1){V=T;W=U}else{C=U*3|0;R=C>>>1;m=f[h>>2]|0;if(m>>>0<R>>>0){Q=f[g>>2]|0;if(C>>>0>273){C=N5b(R>>>0>536870911?-1:R<<3)|0;Nac(C|0,0,R<<3|0)|0;X=C}else X=g+8|0;f[g>>2]=X;f[h>>2]=R;if((m|0)!=0&(X|0)!=(Q|0)){C=Q;O=f[C+4>>2]|0;P=X;f[P>>2]=f[C>>2];f[P+4>>2]=O;if((m|0)!=1){O=Q+8|0;P=f[O+4>>2]|0;C=X+8|0;f[C>>2]=f[O>>2];f[C+4>>2]=P;if((m|0)==2)Z=m;else{P=2;do{C=Q+(P<<3)|0;O=f[C+4>>2]|0;_=(f[g>>2]|0)+(P<<3)|0;f[_>>2]=f[C>>2];f[_+4>>2]=O;P=P+1|0}while((P|0)!=(m|0));Z=m}}else Z=1}else Z=m;do{P=(f[g>>2]|0)+(Z<<3)|0;f[P>>2]=0;f[P+4>>2]=0;Z=Z+1|0}while((Z|0)!=(R|0));if(!((Q|0)==(g+8|0)|(Q|0)==0))P5b(Q)}else f[h>>2]=R;V=f[g>>2]|0;W=f[h>>2]|0}m=V+8|0;f[m>>2]=q;f[m+4>>2]=p;r=2;s=V;t=W;u=1;v=p;o=41}while(0);if((o|0)==41){o=b+-1|0;W=g+8|0;V=0;Z=r;r=s;s=t;t=v;a:while(1){v=V;X=Z;U=t;while(1){$=X+-1|0;T=r+($<<3)|0;aa=f[T>>2]|0;ba=f[T+4>>2]|0;T=f[a+(aa<<3)>>2]|0;i=f[a+(aa<<3)+4>>2]|0;j=aa+1|0;S=(j|0)>=(b|0)?0:j;if((S|0)!=(ba|0)){H=+((f[a+(ba<<3)>>2]|0)-T|0);F=+((f[a+(ba<<3)+4>>2]|0)-i|0);E=0.0;j=S;ca=U;b:while(1){S=j;do{if((S|0)==(ba|0))break b;J=S+1|0;G=S;S=(J|0)>=(b|0)?0:J;da=+L(+(H*+((f[a+(G<<3)+4>>2]|0)-i|0)-F*+((f[a+(G<<3)>>2]|0)-T|0)))}while(!(da>E));E=da;j=S;ca=(o+S|0)%(b|0)|0}if(!(E*E<=l*(F*F+H*H)))break;else ea=ca}else ea=U;j=v+1|0;f[c+(v<<3)>>2]=T;f[c+(v<<3)+4>>2]=i;if(!$){fa=j;break a}else{v=j;X=$;U=ea}}if($>>>0<s>>>0){ga=r;ha=s}else{U=s*3|0;p=U>>>1;q=f[h>>2]|0;if(q>>>0<p>>>0){R=f[g>>2]|0;if(U>>>0>273){U=N5b(p>>>0>536870911?-1:p<<3)|0;Nac(U|0,0,p<<3|0)|0;ia=U}else ia=W;f[g>>2]=ia;f[h>>2]=p;if((q|0)!=0&(ia|0)!=(R|0)){U=R;Q=f[U+4>>2]|0;j=ia;f[j>>2]=f[U>>2];f[j+4>>2]=Q;if((q|0)!=1){Q=R+8|0;j=f[Q+4>>2]|0;U=ia+8|0;f[U>>2]=f[Q>>2];f[U+4>>2]=j;if((q|0)==2)ja=q;else{j=2;do{U=R+(j<<3)|0;Q=f[U+4>>2]|0;z=(f[g>>2]|0)+(j<<3)|0;f[z>>2]=f[U>>2];f[z+4>>2]=Q;j=j+1|0}while((j|0)!=(q|0));ja=q}}else ja=1}else ja=q;do{j=(f[g>>2]|0)+(ja<<3)|0;f[j>>2]=0;f[j+4>>2]=0;ja=ja+1|0}while((ja|0)!=(p|0));if(!((R|0)==(W|0)|(R|0)==0))P5b(R)}else f[h>>2]=p;ga=f[g>>2]|0;ha=f[h>>2]|0}q=ga+($<<3)|0;f[q>>2]=ca;f[q+4>>2]=ba;if(X>>>0<ha>>>0){ka=ga;la=ha}else{q=ha*3|0;j=q>>>1;Q=f[h>>2]|0;if(Q>>>0<j>>>0){z=f[g>>2]|0;if(q>>>0>273){q=N5b(j>>>0>536870911?-1:j<<3)|0;Nac(q|0,0,j<<3|0)|0;ma=q}else ma=W;f[g>>2]=ma;f[h>>2]=j;if((Q|0)!=0&(ma|0)!=(z|0)){q=z;U=f[q+4>>2]|0;A=ma;f[A>>2]=f[q>>2];f[A+4>>2]=U;if((Q|0)!=1){U=z+8|0;A=f[U+4>>2]|0;q=ma+8|0;f[q>>2]=f[U>>2];f[q+4>>2]=A;if((Q|0)==2)na=Q;else{A=2;do{q=z+(A<<3)|0;U=f[q+4>>2]|0;y=(f[g>>2]|0)+(A<<3)|0;f[y>>2]=f[q>>2];f[y+4>>2]=U;A=A+1|0}while((A|0)!=(Q|0));na=Q}}else na=1}else na=Q;do{A=(f[g>>2]|0)+(na<<3)|0;f[A>>2]=0;f[A+4>>2]=0;na=na+1|0}while((na|0)!=(j|0));if(!((z|0)==(W|0)|(z|0)==0))P5b(z)}else f[h>>2]=j;ka=f[g>>2]|0;la=f[h>>2]|0}Z=X+1|0;Q=ka+(X<<3)|0;f[Q>>2]=aa;f[Q+4>>2]=ca;if(!Z){fa=v;break}else{V=v;r=ka;s=la;t=ca}}if(u)N=fa;else{f[c+(fa<<3)>>2]=f[a+(o<<3)>>2];f[c+(fa<<3)+4>>2]=f[a+(o<<3)+4>>2];N=fa+1|0}}fa=d?N+-1|0:0;o=fa+1|0;a=(o|0)>=(N|0)?0:o;o=f[c+(a<<3)>>2]|0;u=f[c+(a<<3)+4>>2]|0;ca=a+1|0;t=(d^1)&1;la=N-t|0;if((N|0)>2&(t|0)<(la|0)){da=l*.5;s=a;ka=t;t=N;r=(ca|0)>=(N|0)?0:ca;ca=o;V=f[c+(fa<<3)>>2]|0;Z=u;aa=f[c+(fa<<3)+4>>2]|0;while(1){fa=f[c+(r<<3)>>2]|0;h=f[c+(r<<3)+4>>2]|0;g=r+1|0;W=(g|0)>=(N|0)?0:g;g=fa-V|0;l=+(g|0);na=h-aa|0;e=+(na|0);ma=ca-V|0;ha=Z-aa|0;D=+L(+(+(ma|0)*e-+(ha|0)*l));if(((Y(h-Z|0,ha)|0)+(Y(fa-ca|0,ma)|0)|0)>-1&((na|0)!=0&(g|0?D*D<=da*(l*l+e*e):0))){f[c+(s<<3)>>2]=fa;f[c+(s<<3)+4>>2]=h;g=s+1|0;na=W+1|0;oa=(g|0)>=(N|0)?0:g;pa=ka+1|0;qa=t+-1|0;ra=(na|0)>=(N|0)?0:na;sa=f[c+(W<<3)>>2]|0;ta=fa;ua=f[c+(W<<3)+4>>2]|0;va=h}else{f[c+(s<<3)>>2]=ca;f[c+(s<<3)+4>>2]=Z;na=s+1|0;oa=(na|0)>=(N|0)?0:na;pa=ka;qa=t;ra=W;sa=fa;ta=ca;ua=h;va=Z}ka=pa+1|0;if(!((qa|0)>2&(ka|0)<(la|0))){wa=oa;xa=qa;ya=sa;za=ua;break}else{s=oa;t=qa;r=ra;ca=sa;V=ta;Z=ua;aa=va}}}else{wa=a;xa=N;ya=o;za=u}if(d){k=xa;return k|0}f[c+(wa<<3)>>2]=ya;f[c+(wa<<3)+4>>2]=za;k=xa;return k|0}function C4(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0.0,m=0,o=0,p=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0;h=g+4|0;i=f[h>>2]|0;j=f[g>>2]|0;if(!b){k=0;return k|0}l=e*e;do if(d){m=3;o=8}else{p=b+-1|0;if(!(+n[a+(p<<3)>>2]!=+n[a>>2])?!(+n[a+(p<<3)+4>>2]!=+n[a+4>>2]):0){m=1;o=8;break}if(!i){f[h>>2]=0;q=0}else q=i;r=j;f[r>>2]=0;f[r+4>>2]=p;t=1;u=j;v=q;w=0;x=b;o=42}while(0);do if((o|0)==8){if((b|0)>1){q=0;p=0;r=0;while(1){y=(p+r|0)%(b|0)|0;z=f[a+(y<<3)>>2]|0;A=f[a+(y<<3)+4>>2]|0;B=y+1|0;e=(f[s>>2]=z,+n[s>>2]);C=(f[s>>2]=A,+n[s>>2]);y=1;D=0.0;E=(B|0)>=(b|0)?0:B;B=r;do{F=E+1|0;G=E;E=(F|0)>=(b|0)?0:F;H=+n[a+(G<<3)>>2]-e;I=+n[a+(G<<3)+4>>2]-C;J=H*H+I*I;G=J>D;B=G?y:B;D=G?J:D;y=y+1|0}while((y|0)!=(b|0));q=q+1|0;if((q|0)>=(m|0)){K=E;M=D;N=z;O=B;P=A;break}else{p=E;r=B}}}else{r=0;p=0;do{Q=(p|0)%(b|0)|0;q=Q+1|0;p=(q|0)>=(b|0)?0:q;r=r+1|0}while((r|0)<(m|0));K=p;M=0.0;N=f[a+(Q<<3)>>2]|0;O=0;P=f[a+(Q<<3)+4>>2]|0}if(M<=l){f[c>>2]=N;f[c+4>>2]=P;R=1;break}r=(K|0)%(b|0)|0;q=(r+O|0)%(b|0)|0;if(!i){y=(i*3|0)>>>1;G=f[h>>2]|0;if(G>>>0<y>>>0){F=f[g>>2]|0;S=g+8|0;f[g>>2]=S;f[h>>2]=y;if((G|0)!=0&(S|0)!=(F|0)){T=F;U=f[T+4>>2]|0;V=S;f[V>>2]=f[T>>2];f[V+4>>2]=U;if((G|0)!=1){U=F+8|0;V=f[U+4>>2]|0;T=g+16|0;f[T>>2]=f[U>>2];f[T+4>>2]=V;if((G|0)==2)W=G;else{V=2;do{T=F+(V<<3)|0;U=f[T+4>>2]|0;S=(f[g>>2]|0)+(V<<3)|0;f[S>>2]=f[T>>2];f[S+4>>2]=U;V=V+1|0}while((V|0)!=(G|0));W=G}}else W=1}else W=G;do{V=(f[g>>2]|0)+(W<<3)|0;f[V>>2]=0;f[V+4>>2]=0;W=W+1|0}while((W|0)!=(y|0));if(!((F|0)==(g+8|0)|(F|0)==0))P5b(F)}else f[h>>2]=y;X=f[g>>2]|0;Y=f[h>>2]|0}else{X=j;Y=i}G=X;f[G>>2]=q;f[G+4>>2]=r;if(Y>>>0>1){Z=X;_=Y}else{G=Y*3|0;V=G>>>1;p=f[h>>2]|0;if(p>>>0<V>>>0){U=f[g>>2]|0;if(G>>>0>273){G=N5b(V>>>0>536870911?-1:V<<3)|0;Nac(G|0,0,V<<3|0)|0;$=G}else $=g+8|0;f[g>>2]=$;f[h>>2]=V;if((p|0)!=0&($|0)!=(U|0)){G=U;S=f[G+4>>2]|0;T=$;f[T>>2]=f[G>>2];f[T+4>>2]=S;if((p|0)!=1){S=U+8|0;T=f[S+4>>2]|0;G=$+8|0;f[G>>2]=f[S>>2];f[G+4>>2]=T;if((p|0)==2)aa=p;else{T=2;do{G=U+(T<<3)|0;S=f[G+4>>2]|0;ba=(f[g>>2]|0)+(T<<3)|0;f[ba>>2]=f[G>>2];f[ba+4>>2]=S;T=T+1|0}while((T|0)!=(p|0));aa=p}}else aa=1}else aa=p;do{T=(f[g>>2]|0)+(aa<<3)|0;f[T>>2]=0;f[T+4>>2]=0;aa=aa+1|0}while((aa|0)!=(V|0));if(!((U|0)==(g+8|0)|(U|0)==0))P5b(U)}else f[h>>2]=V;Z=f[g>>2]|0;_=f[h>>2]|0}p=Z+8|0;f[p>>2]=r;f[p+4>>2]=q;t=2;u=Z;v=_;w=1;x=q;o=42}while(0);if((o|0)==42){o=b+-1|0;_=g+8|0;Z=0;aa=t;t=u;u=v;v=x;a:while(1){x=Z;$=aa;Y=v;while(1){ca=$+-1|0;X=t+(ca<<3)|0;da=f[X>>2]|0;ea=f[X+4>>2]|0;X=f[a+(da<<3)>>2]|0;i=f[a+(da<<3)+4>>2]|0;j=da+1|0;W=(j|0)>=(b|0)?0:j;if((W|0)!=(ea|0)){M=(f[s>>2]=X,+n[s>>2]);C=+n[a+(ea<<3)>>2]-M;e=(f[s>>2]=i,+n[s>>2]);J=+n[a+(ea<<3)+4>>2]-e;I=0.0;j=W;fa=Y;b:while(1){W=j;do{if((W|0)==(ea|0))break b;O=W+1|0;K=W;W=(O|0)>=(b|0)?0:O;ga=+L(+(C*(+n[a+(K<<3)+4>>2]-e)-J*(+n[a+(K<<3)>>2]-M)))}while(!(ga>I));I=ga;j=W;fa=(o+W|0)%(b|0)|0}if(!(I*I<=l*(J*J+C*C)))break;else ha=fa}else ha=Y;j=x+1|0;f[c+(x<<3)>>2]=X;f[c+(x<<3)+4>>2]=i;if(!ca){ia=j;break a}else{x=j;$=ca;Y=ha}}if(ca>>>0<u>>>0){ja=t;ka=u}else{Y=u*3|0;q=Y>>>1;r=f[h>>2]|0;if(r>>>0<q>>>0){V=f[g>>2]|0;if(Y>>>0>273){Y=N5b(q>>>0>536870911?-1:q<<3)|0;Nac(Y|0,0,q<<3|0)|0;la=Y}else la=_;f[g>>2]=la;f[h>>2]=q;if((r|0)!=0&(la|0)!=(V|0)){Y=V;U=f[Y+4>>2]|0;j=la;f[j>>2]=f[Y>>2];f[j+4>>2]=U;if((r|0)!=1){U=V+8|0;j=f[U+4>>2]|0;Y=la+8|0;f[Y>>2]=f[U>>2];f[Y+4>>2]=j;if((r|0)==2)ma=r;else{j=2;do{Y=V+(j<<3)|0;U=f[Y+4>>2]|0;B=(f[g>>2]|0)+(j<<3)|0;f[B>>2]=f[Y>>2];f[B+4>>2]=U;j=j+1|0}while((j|0)!=(r|0));ma=r}}else ma=1}else ma=r;do{j=(f[g>>2]|0)+(ma<<3)|0;f[j>>2]=0;f[j+4>>2]=0;ma=ma+1|0}while((ma|0)!=(q|0));if(!((V|0)==(_|0)|(V|0)==0))P5b(V)}else f[h>>2]=q;ja=f[g>>2]|0;ka=f[h>>2]|0}r=ja+(ca<<3)|0;f[r>>2]=fa;f[r+4>>2]=ea;if($>>>0<ka>>>0){na=ja;oa=ka}else{r=ka*3|0;j=r>>>1;U=f[h>>2]|0;if(U>>>0<j>>>0){B=f[g>>2]|0;if(r>>>0>273){r=N5b(j>>>0>536870911?-1:j<<3)|0;Nac(r|0,0,j<<3|0)|0;pa=r}else pa=_;f[g>>2]=pa;f[h>>2]=j;if((U|0)!=0&(pa|0)!=(B|0)){r=B;Y=f[r+4>>2]|0;E=pa;f[E>>2]=f[r>>2];f[E+4>>2]=Y;if((U|0)!=1){Y=B+8|0;E=f[Y+4>>2]|0;r=pa+8|0;f[r>>2]=f[Y>>2];f[r+4>>2]=E;if((U|0)==2)qa=U;else{E=2;do{r=B+(E<<3)|0;Y=f[r+4>>2]|0;A=(f[g>>2]|0)+(E<<3)|0;f[A>>2]=f[r>>2];f[A+4>>2]=Y;E=E+1|0}while((E|0)!=(U|0));qa=U}}else qa=1}else qa=U;do{E=(f[g>>2]|0)+(qa<<3)|0;f[E>>2]=0;f[E+4>>2]=0;qa=qa+1|0}while((qa|0)!=(j|0));if(!((B|0)==(_|0)|(B|0)==0))P5b(B)}else f[h>>2]=j;na=f[g>>2]|0;oa=f[h>>2]|0}aa=$+1|0;U=na+($<<3)|0;f[U>>2]=da;f[U+4>>2]=fa;if(!aa){ia=x;break}else{Z=x;t=na;u=oa;v=fa}}if(w)R=ia;else{f[c+(ia<<3)>>2]=f[a+(o<<3)>>2];f[c+(ia<<3)+4>>2]=f[a+(o<<3)+4>>2];R=ia+1|0}}ia=d?R+-1|0:0;o=ia+1|0;a=(o|0)>=(R|0)?0:o;o=f[c+(a<<3)>>2]|0;w=f[c+(a<<3)+4>>2]|0;fa=a+1|0;v=(d^1)&1;oa=R-v|0;if((R|0)>2&(v|0)<(oa|0)){ga=l*.5;u=a;na=v;v=R;t=(fa|0)>=(R|0)?0:fa;fa=o;Z=f[c+(ia<<3)>>2]|0;aa=w;da=f[c+(ia<<3)+4>>2]|0;while(1){ia=f[c+(t<<3)>>2]|0;h=f[c+(t<<3)+4>>2]|0;g=t+1|0;_=(g|0)>=(R|0)?0:g;l=(f[s>>2]=ia,+n[s>>2]);M=(f[s>>2]=Z,+n[s>>2]);e=l-M;D=e;H=(f[s>>2]=h,+n[s>>2]);ra=(f[s>>2]=da,+n[s>>2]);sa=H-ra;ta=sa;ua=(f[s>>2]=fa,+n[s>>2]);va=ua-M;M=(f[s>>2]=aa,+n[s>>2]);wa=M-ra;ra=+L(+(va*ta-wa*D));if(va*(l-ua)+wa*(H-M)>=0.0&(sa!=0.0&(e!=0.0?ra*ra<=ga*(D*D+ta*ta):0))){f[c+(u<<3)>>2]=ia;f[c+(u<<3)+4>>2]=h;g=u+1|0;qa=_+1|0;xa=(g|0)>=(R|0)?0:g;ya=na+1|0;za=v+-1|0;Aa=(qa|0)>=(R|0)?0:qa;Ba=f[c+(_<<3)>>2]|0;Ca=ia;Da=f[c+(_<<3)+4>>2]|0;Ea=h}else{f[c+(u<<3)>>2]=fa;f[c+(u<<3)+4>>2]=aa;qa=u+1|0;xa=(qa|0)>=(R|0)?0:qa;ya=na;za=v;Aa=_;Ba=ia;Ca=fa;Da=h;Ea=aa}na=ya+1|0;if(!((za|0)>2&(na|0)<(oa|0))){Fa=xa;Ga=za;Ha=Ba;Ia=Da;break}else{u=xa;v=za;t=Aa;fa=Ba;Z=Ca;aa=Da;da=Ea}}}else{Fa=a;Ga=R;Ha=o;Ia=w}if(d){k=Ga;return k|0}f[c+(Fa<<3)>>2]=Ha;f[c+(Fa<<3)+4>>2]=Ia;k=Ga;return k|0}function D4(a,c,d,e,g,h){a=a|0;c=c|0;d=+d;e=+e;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;i=u;u=u+368|0;j=i+352|0;k=i+344|0;l=i+280|0;m=i+336|0;n=i+216|0;o=i+160|0;p=i+272|0;q=i+104|0;r=i+80|0;s=i+72|0;t=i+24|0;v=i+16|0;w=i;dQ(j,52164);if(FM(a,-1)|0){f[k>>2]=0;f[k+4>>2]=0;x=aD(k,17)|0;y=236632;z=x+17|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,k,236650,236656,930);bD(k)}AL(k,a,-1);A=c+4|0;B=a+4|0;if((f[A>>2]|0)==(f[B>>2]|0)?BL(a,-1)|0:0){f[l>>2]=0;f[l+4>>2]=0;Vac(aD(l,134)|0,236726,134)|0;bO(-215,l,236650,236656,935);bD(l)}f[m>>2]=f[k>>2];f[m+4>>2]=f[k+4>>2];vM(c,m,0,-1,0,0);m=(g|0)<0&(h^1);k=m|h;h=m?g&2147483647:g;if(!(h&1))C=8;else switch(h|0){case 3:case 4:case 5:case 6:case 7:case -1:break;default:C=8}if((C|0)==8){f[l>>2]=0;f[l+4>>2]=0;x=aD(l,43)|0;y=236861;z=x+43|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-206,l,236650,236656,947);bD(l)}y=d>e;D=y?d:e;E=y?e:d;do if((yM(a)|0)==65536){y=f[B>>2]|0;f[l>>2]=f[y>>2];C=l+4|0;g=y+4|0;f[C>>2]=f[g>>2];m=l+8|0;f[m>>2]=f[y+8>>2];f[l+12>>2]=f[y+12>>2];f[l+16>>2]=f[y+16>>2];f[l+20>>2]=f[y+20>>2];f[l+24>>2]=f[y+24>>2];f[l+28>>2]=f[y+28>>2];f[l+32>>2]=f[y+32>>2];F=f[y+36>>2]|0;f[l+36>>2]=F;f[l+40>>2]=m;m=l+48|0;G=l+44|0;f[G>>2]=m;f[m>>2]=0;f[l+52>>2]=0;if(F|0){m=F+12|0;f[m>>2]=(f[m>>2]|0)+1}if((f[g>>2]|0)<3){g=f[y+44>>2]|0;m=f[G>>2]|0;f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];break}else{f[C>>2]=0;jL(l,y);break}}else yL(l,a,-1);while(0);do if((yM(c)|0)==65536){a=f[A>>2]|0;f[n>>2]=f[a>>2];B=n+4|0;y=a+4|0;f[B>>2]=f[y>>2];C=n+8|0;f[C>>2]=f[a+8>>2];f[n+12>>2]=f[a+12>>2];f[n+16>>2]=f[a+16>>2];f[n+20>>2]=f[a+20>>2];f[n+24>>2]=f[a+24>>2];f[n+28>>2]=f[a+28>>2];f[n+32>>2]=f[a+32>>2];g=f[a+36>>2]|0;f[n+36>>2]=g;f[n+40>>2]=C;C=n+48|0;m=n+44|0;f[m>>2]=C;f[C>>2]=0;f[n+52>>2]=0;if(g|0){C=g+12|0;f[C>>2]=(f[C>>2]|0)+1}if((f[y>>2]|0)<3){y=f[a+44>>2]|0;C=f[m>>2]|0;f[C>>2]=f[y>>2];f[C+4>>2]=f[y+4>>2];break}else{f[B>>2]=0;jL(n,a);break}}else yL(n,c,-1);while(0);c=l+40|0;A=f[c>>2]|0;a=f[A>>2]|0;f[p>>2]=f[A+4>>2];f[p+4>>2]=a;a=l+16|0;A=l+48|0;JF(o,p,f[l>>2]&4095,f[a>>2]|0,f[A>>2]|0);p=o+16|0;B=n+16|0;y=o+12|0;C=o+8|0;if(k){d=E<32767.0?E:32767.0;e=D<32767.0?D:32767.0;H=d>0.0?d*d:d;if(e>0.0){I=e*e;J=H}else{I=e;J=H}}else{I=D;J=E}m=~~J;g=m-(+(m|0)>J&1)|0;m=~~I;G=m-(+(m|0)>I&1)|0;m=SQ()|0;F=UQ()|0;K=(F|0)<(m|0)?F:m;m=(K|0)>1?K:1;K=f[C>>2]|0;F=(h|0)<0?4:(((h|0)/2|0)<<1)+2|0;if(((K|0)/(m|0)|0|0)<(F|0)){L=(K|0)/(F|0)|0;M=(L|0)>1?L:1}else M=m;f[q>>2]=1124007936;m=q+4|0;L=q+8|0;F=q+40|0;x=m;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[F>>2]=L;L=q+48|0;x=q+44|0;f[x>>2]=L;f[L>>2]=0;f[q+52>>2]=0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;f[r+16>>2]=0;f[r+20>>2]=0;f[s>>2]=0;f[s+4>>2]=K;E4(t,o,q,r,g,G,h,k);RQ(s,t,+(M|0));f[t>>2]=52192;OO(t+44|0);dQ(s,52204);s=f[q+12>>2]|0;M=r+20|0;k=f[M>>2]|0;if(k|0){h=r+16|0;G=r+4|0;g=r+8|0;K=0-s|0;z=~s;N=1-s|0;O=s+-1|0;P=s+1|0;Q=k;while(1){k=f[h>>2]|0;R=Q+-1|0;S=k+R|0;T=f[G>>2]|0;U=f[(f[T+(S>>>10<<2)>>2]|0)+((S&1023)<<2)>>2]|0;f[M>>2]=R;R=f[g>>2]|0;S=R-T|0;if((1-Q-k+((S|0)==0?0:(S<<8)+-1|0)|0)>>>0>2047){O5b(f[R+-4>>2]|0);f[g>>2]=(f[g>>2]|0)+-4}R=U+K|0;if(!(b[U+z>>0]|0)){S=R+-1|0;b[S>>0]=2;k=f[G>>2]|0;T=(f[g>>2]|0)-k|0;V=f[h>>2]|0;W=f[M>>2]|0;if((((T|0)==0?0:(T<<8)+-1|0)|0)==(W+V|0)){F4(r);X=f[h>>2]|0;Z=f[M>>2]|0;_=f[G>>2]|0}else{X=V;Z=W;_=k}k=Z+X|0;f[(f[_+(k>>>10<<2)>>2]|0)+((k&1023)<<2)>>2]=S;f[M>>2]=Z+1}if(!(b[R>>0]|0)){b[R>>0]=2;S=f[G>>2]|0;k=(f[g>>2]|0)-S|0;W=f[h>>2]|0;V=f[M>>2]|0;if((((k|0)==0?0:(k<<8)+-1|0)|0)==(V+W|0)){F4(r);$=f[h>>2]|0;aa=f[M>>2]|0;ba=f[G>>2]|0}else{$=W;aa=V;ba=S}S=aa+$|0;f[(f[ba+(S>>>10<<2)>>2]|0)+((S&1023)<<2)>>2]=R;f[M>>2]=aa+1}if(!(b[U+N>>0]|0)){R=U+K+1|0;b[R>>0]=2;S=f[G>>2]|0;V=(f[g>>2]|0)-S|0;W=f[h>>2]|0;k=f[M>>2]|0;if((((V|0)==0?0:(V<<8)+-1|0)|0)==(k+W|0)){F4(r);ca=f[h>>2]|0;da=f[M>>2]|0;ea=f[G>>2]|0}else{ca=W;da=k;ea=S}S=da+ca|0;f[(f[ea+(S>>>10<<2)>>2]|0)+((S&1023)<<2)>>2]=R;f[M>>2]=da+1}R=U+-1|0;if(!(b[R>>0]|0)){b[R>>0]=2;S=f[G>>2]|0;k=(f[g>>2]|0)-S|0;W=f[h>>2]|0;V=f[M>>2]|0;if((((k|0)==0?0:(k<<8)+-1|0)|0)==(V+W|0)){F4(r);fa=f[h>>2]|0;ga=f[M>>2]|0;ha=f[G>>2]|0}else{fa=W;ga=V;ha=S}S=ga+fa|0;f[(f[ha+(S>>>10<<2)>>2]|0)+((S&1023)<<2)>>2]=R;f[M>>2]=ga+1}R=U+1|0;if(!(b[R>>0]|0)){b[R>>0]=2;S=f[G>>2]|0;V=(f[g>>2]|0)-S|0;W=f[h>>2]|0;k=f[M>>2]|0;if((((V|0)==0?0:(V<<8)+-1|0)|0)==(k+W|0)){F4(r);ia=f[h>>2]|0;ja=f[M>>2]|0;ka=f[G>>2]|0}else{ia=W;ja=k;ka=S}S=ja+ia|0;f[(f[ka+(S>>>10<<2)>>2]|0)+((S&1023)<<2)>>2]=R;f[M>>2]=ja+1}R=U+s|0;if(!(b[U+O>>0]|0)){S=R+-1|0;b[S>>0]=2;k=f[G>>2]|0;W=(f[g>>2]|0)-k|0;V=f[h>>2]|0;T=f[M>>2]|0;if((((W|0)==0?0:(W<<8)+-1|0)|0)==(T+V|0)){F4(r);la=f[h>>2]|0;ma=f[M>>2]|0;na=f[G>>2]|0}else{la=V;ma=T;na=k}k=ma+la|0;f[(f[na+(k>>>10<<2)>>2]|0)+((k&1023)<<2)>>2]=S;f[M>>2]=ma+1}if(!(b[R>>0]|0)){b[R>>0]=2;S=f[G>>2]|0;k=(f[g>>2]|0)-S|0;T=f[h>>2]|0;V=f[M>>2]|0;if((((k|0)==0?0:(k<<8)+-1|0)|0)==(V+T|0)){F4(r);oa=f[h>>2]|0;pa=f[M>>2]|0;qa=f[G>>2]|0}else{oa=T;pa=V;qa=S}S=pa+oa|0;f[(f[qa+(S>>>10<<2)>>2]|0)+((S&1023)<<2)>>2]=R;f[M>>2]=pa+1}if(!(b[U+P>>0]|0)){R=U+s+1|0;b[R>>0]=2;U=f[G>>2]|0;S=(f[g>>2]|0)-U|0;V=f[h>>2]|0;T=f[M>>2]|0;if((((S|0)==0?0:(S<<8)+-1|0)|0)==(T+V|0)){F4(r);ra=f[h>>2]|0;sa=f[M>>2]|0;ta=f[G>>2]|0}else{ra=V;sa=T;ta=U}U=sa+ra|0;f[(f[ta+(U>>>10<<2)>>2]|0)+((U&1023)<<2)>>2]=R;R=sa+1|0;f[M>>2]=R;ua=R}else ua=f[M>>2]|0;if(!ua)break;else Q=ua}}dQ(t,52224);t=f[C>>2]|0;f[v>>2]=0;f[v+4>>2]=t;f[w>>2]=52252;f[w+4>>2]=q;f[w+8>>2]=n;C=o+4|0;ua=f[C>>2]|0;if((ua|0)<3)va=Y(f[y>>2]|0,t)|0;else{t=f[o+40>>2]|0;y=0;Q=1;while(1){M=Y(f[t+(y<<2)>>2]|0,Q)|0;y=y+1|0;if((y|0)==(ua|0)){va=M;break}else Q=M}}RQ(v,w,+(va>>>0)*.0000152587890625);G4(r);r=q+36|0;va=f[r>>2]|0;if(va|0?(w=va+12|0,va=f[w>>2]|0,f[w>>2]=va+-1,(va|0)==1):0)kL(q);f[r>>2]=0;r=q+16|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[m>>2]|0)>0){r=f[F>>2]|0;F=0;do{f[r+(F<<2)>>2]=0;F=F+1|0}while((F|0)<(f[m>>2]|0))}m=f[x>>2]|0;if((m|0)!=(L|0))UC(m);m=o+36|0;L=f[m>>2]|0;if(L|0?(x=L+12|0,L=f[x>>2]|0,f[x>>2]=L+-1,(L|0)==1):0)kL(o);f[m>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[C>>2]|0)>0){p=f[o+40>>2]|0;m=0;do{f[p+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[C>>2]|0))}C=f[o+44>>2]|0;if((C|0)!=(o+48|0))UC(C);C=n+36|0;o=f[C>>2]|0;if(o|0?(m=o+12|0,o=f[m>>2]|0,f[m>>2]=o+-1,(o|0)==1):0)kL(n);f[C>>2]=0;C=n+4|0;f[B>>2]=0;f[B+4>>2]=0;f[B+8>>2]=0;f[B+12>>2]=0;if((f[C>>2]|0)>0){B=f[n+40>>2]|0;o=0;do{f[B+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[C>>2]|0))}C=f[n+44>>2]|0;if((C|0)!=(n+48|0))UC(C);C=l+36|0;n=f[C>>2]|0;do if(n|0){o=n+12|0;B=f[o>>2]|0;f[o>>2]=B+-1;if((B|0)!=1)break;kL(l)}while(0);f[C>>2]=0;C=l+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[C>>2]|0)>0){a=f[c>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[C>>2]|0))}C=f[l+44>>2]|0;if((C|0)!=(A|0))UC(C);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function E4(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=u;u=u+144|0;l=k+120|0;m=k;n=k+64|0;o=k+8|0;f[a>>2]=52192;q=a+4|0;f[q>>2]=c;f[a+8>>2]=c;c=a+12|0;f[c>>2]=d;f[a+16>>2]=e;f[a+20>>2]=g;f[a+24>>2]=h;f[a+28>>2]=i;b[a+32>>0]=j&1;NO(a+44|0);j=f[q>>2]|0;i=(f[j+8>>2]|0)+2|0;h=(f[j+12>>2]|0)+2|0;j=d+4|0;if(!(((((f[j>>2]|0)<3?(f[d+8>>2]|0)==(i|0):0)?(f[d+12>>2]|0)==(h|0):0)?(f[d>>2]&4095|0)==0:0)?(f[d+16>>2]|0)!=0:0)){f[l>>2]=i;f[l+4>>2]=h;hL(d,2,l,0)}h=f[c>>2]|0;if((h|0)==(d|0))r=d;else{i=d+36|0;g=f[i>>2]|0;if(g|0){e=g+12|0;f[e>>2]=(f[e>>2]|0)+1}e=h+36|0;g=f[e>>2]|0;if(g|0?(s=g+12|0,g=f[s>>2]|0,f[s>>2]=g+-1,(g|0)==1):0)kL(h);f[e>>2]=0;g=h+16|0;s=h+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[s>>2]|0)>0){t=f[h+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0;w=f[s>>2]|0}while((v|0)<(w|0));f[h>>2]=f[d>>2];if((w|0)<3)x=18;else x=20}else{f[h>>2]=f[d>>2];x=18}if((x|0)==18){w=f[j>>2]|0;if((w|0)<3){f[s>>2]=w;f[h+8>>2]=f[d+8>>2];f[h+12>>2]=f[d+12>>2];w=f[d+44>>2]|0;s=f[h+44>>2]|0;f[s>>2]=f[w>>2];f[s+4>>2]=f[w+4>>2]}else x=20}if((x|0)==20)jL(h,d);f[g>>2]=f[d+16>>2];f[h+20>>2]=f[d+20>>2];f[h+24>>2]=f[d+24>>2];f[h+28>>2]=f[d+28>>2];f[h+32>>2]=f[d+32>>2];f[e>>2]=f[i>>2];r=f[c>>2]|0}f[l>>2]=0;f[l+4>>2]=1;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;lL(n,r,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;VP(n,l,UM()|0)|0;r=n+36|0;i=f[r>>2]|0;if(i|0?(e=i+12|0,i=f[e>>2]|0,f[e>>2]=i+-1,(i|0)==1):0)kL(n);f[r>>2]=0;r=n+16|0;i=n+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[i>>2]|0)>0){r=f[n+40>>2]|0;e=0;do{f[r+(e<<2)>>2]=0;e=e+1|0}while((e|0)<(f[i>>2]|0))}i=f[n+44>>2]|0;if((i|0)!=(n+48|0))UC(i);i=f[c>>2]|0;n=f[(f[q>>2]|0)+8>>2]|0;f[l>>2]=n+1;f[l+4>>2]=n+2;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;lL(o,i,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;VP(o,l,UM()|0)|0;l=o+36|0;m=f[l>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)kL(o);f[l>>2]=0;l=o+16|0;m=o+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[o+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[o+44>>2]|0;if((m|0)==(o+48|0)){y=f[c>>2]|0;z=y+12|0;A=f[z>>2]|0;B=a+36|0;f[B>>2]=A;C=a+33|0;b[C>>0]=1;D=f[q>>2]|0;E=f[D>>2]|0;F=E>>>3;G=F&511;H=G+1|0;I=a+40|0;f[I>>2]=H;u=k;return}UC(m);y=f[c>>2]|0;z=y+12|0;A=f[z>>2]|0;B=a+36|0;f[B>>2]=A;C=a+33|0;b[C>>0]=1;D=f[q>>2]|0;E=f[D>>2]|0;F=E>>>3;G=F&511;H=G+1|0;I=a+40|0;f[I>>2]=H;u=k;return}function F4(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;b=u;u=u+32|0;c=b;d=a+16|0;e=f[d>>2]|0;if(e>>>0>1023){f[d>>2]=e+-1024;e=a+4|0;d=f[e>>2]|0;g=f[d>>2]|0;h=d+4|0;f[e>>2]=h;d=a+8|0;i=f[d>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;m=i;do if((i|0)==(k|0)){n=f[a>>2]|0;o=n;if(h>>>0>n>>>0){p=h;q=((p-o>>2)+1|0)/-2|0;r=h+(q<<2)|0;s=m-p|0;p=s>>2;if(!p)t=h;else{Xac(r|0,h|0,s|0)|0;t=f[e>>2]|0}s=r+(p<<2)|0;f[d>>2]=s;f[e>>2]=t+(q<<2);v=s;break}s=l-o>>1;o=(s|0)==0?1:s;if(o>>>0>1073741823){s=ze(8)|0;T5b(s,477177);f[s>>2]=149528;If(s|0,25408,1411)}s=L5b(o<<2)|0;q=s;p=s+(o>>>2<<2)|0;r=p;w=s+(o<<2)|0;if((h|0)==(i|0)){x=r;y=n}else{n=p;p=r;o=h;do{f[n>>2]=f[o>>2];n=p+4|0;p=n;o=o+4|0}while((o|0)!=(i|0));x=p;y=f[a>>2]|0}f[a>>2]=q;f[e>>2]=r;f[d>>2]=x;f[j>>2]=w;if(!y)v=x;else{O5b(y);v=f[d>>2]|0}}else v=i;while(0);f[v>>2]=g;f[d>>2]=(f[d>>2]|0)+4;u=b;return}d=a+8|0;g=f[d>>2]|0;v=a+4|0;i=f[v>>2]|0;y=g-i|0;x=a+12|0;j=f[x>>2]|0;e=f[a>>2]|0;h=j-e|0;l=g;t=j;m=i;k=e;if(y>>>0>=h>>>0){o=h>>1;n=(o|0)==0?1:o;f[c+12>>2]=0;f[c+16>>2]=a+12;if(n>>>0>1073741823){o=ze(8)|0;T5b(o,477177);f[o>>2]=149528;If(o|0,25408,1411)}o=y>>2;s=L5b(n<<2)|0;f[c>>2]=s;z=s+(o<<2)|0;A=c+8|0;f[A>>2]=z;B=c+4|0;f[B>>2]=z;C=s+(n<<2)|0;D=c+12|0;f[D>>2]=C;E=s;F=L5b(4096)|0;G=C;C=z;do if((o|0)==(n|0)){if(z>>>0>s>>>0){H=z+((((C-E>>2)+1|0)/-2|0)<<2)|0;f[A>>2]=H;f[B>>2]=H;I=H;break}H=G-E>>1;J=(H|0)==0?1:H;if(J>>>0>1073741823){H=ze(8)|0;T5b(H,477177);f[H>>2]=149528;If(H|0,25408,1411)}else{H=L5b(J<<2)|0;K=H+(J>>>2<<2)|0;L=K;f[c>>2]=H;f[B>>2]=L;f[A>>2]=L;f[D>>2]=H+(J<<2);O5b(s);I=K;break}}else I=z;while(0);f[I>>2]=F;f[A>>2]=(f[A>>2]|0)+4;F=f[d>>2]|0;while(1){M=f[v>>2]|0;if((F|0)==(M|0))break;I=F+-4|0;K4(c,I);F=I}I=M;M=f[a>>2]|0;f[a>>2]=f[c>>2];f[c>>2]=M;f[v>>2]=f[B>>2];f[B>>2]=I;B=f[d>>2]|0;f[d>>2]=f[A>>2];f[A>>2]=B;z=f[x>>2]|0;f[x>>2]=f[D>>2];f[D>>2]=z;z=B;if((z|0)!=(F|0))f[A>>2]=z+(~((z+-4-I|0)>>>2)<<2);if(M|0)O5b(M);u=b;return}if((j|0)==(g|0)){j=L5b(4096)|0;f[c>>2]=j;J4(a,c);c=f[v>>2]|0;j=f[c>>2]|0;M=c+4|0;f[v>>2]=M;c=f[d>>2]|0;I=f[x>>2]|0;z=I;A=c;do if((c|0)==(I|0)){F=f[a>>2]|0;B=F;if(M>>>0>F>>>0){D=M;s=((D-B>>2)+1|0)/-2|0;E=M+(s<<2)|0;G=A-D|0;D=G>>2;if(!D)N=M;else{Xac(E|0,M|0,G|0)|0;N=f[v>>2]|0}G=E+(D<<2)|0;f[d>>2]=G;f[v>>2]=N+(s<<2);O=G;break}G=z-B>>1;B=(G|0)==0?1:G;if(B>>>0>1073741823){G=ze(8)|0;T5b(G,477177);f[G>>2]=149528;If(G|0,25408,1411)}G=L5b(B<<2)|0;s=G;D=G+(B>>>2<<2)|0;E=D;C=G+(B<<2)|0;if((M|0)==(c|0)){P=E;Q=F}else{F=D;D=E;B=M;do{f[F>>2]=f[B>>2];F=D+4|0;D=F;B=B+4|0}while((B|0)!=(c|0));P=D;Q=f[a>>2]|0}f[a>>2]=s;f[v>>2]=E;f[d>>2]=P;f[x>>2]=C;if(!Q)O=P;else{O5b(Q);O=f[d>>2]|0}}else O=c;while(0);f[O>>2]=j;f[d>>2]=(f[d>>2]|0)+4;u=b;return}else{j=L5b(4096)|0;O=g;do if((l|0)==(t|0)){if(m>>>0>k>>>0){g=((i-e>>2)+1|0)/-2|0;c=m+(g<<2)|0;Q=y>>2;if(!Q)R=m;else{Xac(c|0,i|0,y|0)|0;R=f[v>>2]|0}P=c+(Q<<2)|0;f[d>>2]=P;f[v>>2]=R+(g<<2);S=P;break}P=h>>1;g=(P|0)==0?1:P;if(g>>>0>1073741823){P=ze(8)|0;T5b(P,477177);f[P>>2]=149528;If(P|0,25408,1411)}P=L5b(g<<2)|0;Q=P;c=P+(g>>>2<<2)|0;M=c;z=P+(g<<2)|0;if((m|0)==(l|0)){T=M;U=k}else{g=c;c=M;P=m;do{f[g>>2]=f[P>>2];g=c+4|0;c=g;P=P+4|0}while((P|0)!=(l|0));T=c;U=f[a>>2]|0}f[a>>2]=Q;f[v>>2]=M;f[d>>2]=T;f[x>>2]=z;if(!U)S=T;else{O5b(U);S=f[d>>2]|0}}else S=O;while(0);f[S>>2]=j;f[d>>2]=(f[d>>2]|0)+4;u=b;return}}function G4(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=a+4|0;c=f[b>>2]|0;d=a+16|0;e=f[d>>2]|0;g=c+(e>>>10<<2)|0;h=a+8|0;i=f[h>>2]|0;j=i;k=c;if((i|0)==(c|0)){l=0;m=a+20|0;n=0}else{i=a+20|0;o=(f[i>>2]|0)+e|0;l=(f[c+(o>>>10<<2)>>2]|0)+((o&1023)<<2)|0;m=i;n=(f[g>>2]|0)+((e&1023)<<2)|0}e=g;g=n;a:while(1){n=g;do{i=n;if((i|0)==(l|0))break a;n=i+4|0}while((n-(f[e>>2]|0)|0)!=4096);n=e+4|0;e=n;g=f[n>>2]|0}f[m>>2]=0;m=j-k>>2;if(m>>>0>2){k=c;do{O5b(f[k>>2]|0);k=(f[b>>2]|0)+4|0;f[b>>2]=k;c=(f[h>>2]|0)-k>>2}while(c>>>0>2);p=c}else p=m;switch(p|0){case 1:{q=512;r=13;break}case 2:{q=1024;r=13;break}default:{}}if((r|0)==13)f[d>>2]=q;q=f[b>>2]|0;d=f[h>>2]|0;if((q|0)!=(d|0)){r=q;do{O5b(f[r>>2]|0);r=r+4|0}while((r|0)!=(d|0));d=f[b>>2]|0;b=f[h>>2]|0;if((b|0)!=(d|0))f[h>>2]=b+(~((b+-4-d|0)>>>2)<<2)}d=f[a>>2]|0;if(!d)return;O5b(d);return}function H4(a){a=a|0;O5b(a);return}function I4(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=f[c>>2]|0;e=c+4|0;c=f[e>>2]|0;if((d|0)>=(c|0))return;g=a+8|0;i=a+4|0;a=d;d=f[g>>2]|0;j=c;while(1){c=(f[d+16>>2]|0)+(Y(f[f[d+44>>2]>>2]|0,a)|0)|0;k=f[i>>2]|0;a=a+1|0;l=(f[k+16>>2]|0)+(Y(f[f[k+44>>2]>>2]|0,a)|0)+1|0;if((f[d+12>>2]|0)>0){k=0;do{b[c+k>>0]=0-((h[l+k>>0]|0)>>>1);k=k+1|0;m=f[g>>2]|0}while((k|0)<(f[m+12>>2]|0));n=f[e>>2]|0;o=m}else{n=j;o=d}if((a|0)>=(n|0))break;else{d=o;j=n}}return}function J4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{Xac(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=ze(8)|0;T5b(m,477177);f[m>>2]=149528;If(m|0,25408,1411)}m=L5b(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{O5b(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function K4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=a+4|0;d=f[c>>2]|0;e=f[a>>2]|0;g=e;do if((d|0)==(e|0)){h=a+8|0;i=f[h>>2]|0;j=a+12|0;k=f[j>>2]|0;l=k;if(i>>>0<k>>>0){k=i;m=((l-k>>2)+1|0)/2|0;n=i+(m<<2)|0;o=k-d|0;k=o>>2;p=n+(0-k<<2)|0;if(!k){q=n;r=i}else{Xac(p|0,d|0,o|0)|0;q=p;r=f[h>>2]|0}f[c>>2]=q;f[h>>2]=r+(m<<2);s=q;break}m=l-g>>1;l=(m|0)==0?1:m;if(l>>>0>1073741823){m=ze(8)|0;T5b(m,477177);f[m>>2]=149528;If(m|0,25408,1411)}m=L5b(l<<2)|0;p=m;o=m+((l+3|0)>>>2<<2)|0;n=o;k=m+(l<<2)|0;if((d|0)==(i|0)){t=n;u=d}else{l=o;m=n;v=d;do{f[l>>2]=f[v>>2];l=m+4|0;m=l;v=v+4|0}while((v|0)!=(i|0));t=m;u=f[a>>2]|0}f[a>>2]=p;f[c>>2]=n;f[h>>2]=t;f[j>>2]=k;if(!u)s=o;else{O5b(u);s=f[c>>2]|0}}else s=d;while(0);f[s+-4>>2]=f[b>>2];f[c>>2]=(f[c>>2]|0)+-4;return}function L4(a){a=a|0;f[a>>2]=52192;OO(a+44|0);return}function M4(a){a=a|0;f[a>>2]=52192;OO(a+44|0);O5b(a);return}function N4(a,c){a=a|0;c=c|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0;e=u;u=u+3520|0;g=e+3496|0;h=e+3488|0;i=e+3432|0;j=e+3424|0;k=e+3368|0;l=e+3312|0;m=e+2256|0;n=e+1200|0;o=e+1168|0;p=e+1144|0;q=e+1136|0;r=e+1080|0;s=e+16|0;t=e+8|0;v=e+3304|0;w=e+2248|0;x=e+1192|0;y=e;dQ(j,52264);f[k>>2]=1124007936;z=k+4|0;A=k+8|0;B=k+40|0;C=z;D=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(D|0));f[B>>2]=A;E=k+48|0;F=k+44|0;f[F>>2]=E;f[E>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;G=l+4|0;H=l+8|0;I=l+40|0;C=G;D=C+36|0;do{f[C>>2]=0;C=C+4|0}while((C|0)<(D|0));f[I>>2]=H;C=l+48|0;D=l+44|0;f[D>>2]=C;f[C>>2]=0;f[l+52>>2]=0;J=m+8|0;f[m>>2]=J;K=m+4|0;f[K>>2]=0;L=n+8|0;f[n>>2]=L;M=n+4|0;f[M>>2]=0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;N=f[c>>2]|0;O=N+-1|0;P=(O|0)>0?O:0;O=a+4|0;Q=c+4|0;R=(f[Q>>2]|0)+1|0;S=f[(f[O>>2]|0)+8>>2]|0;T=(R|0)<(S|0)?R:S;dQ(q,52284);if(!(b[a+33>>0]|0)){q=f[O>>2]|0;f[g>>2]=P;f[g+4>>2]=T;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;lL(i,q,g,h);q=i+36|0;S=f[q>>2]|0;if(S|0){R=S+12|0;f[R>>2]=(f[R>>2]|0)+1}R=k+36|0;S=f[R>>2]|0;if(S|0?(U=S+12|0,S=f[U>>2]|0,f[U>>2]=S+-1,(S|0)==1):0)kL(k);f[R>>2]=0;S=k+16|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[z>>2]|0)>0){U=f[B>>2]|0;V=0;do{f[U+(V<<2)>>2]=0;V=V+1|0;W=f[z>>2]|0}while((V|0)<(W|0));f[k>>2]=f[i>>2];if((W|0)<3)X=29;else X=31}else{f[k>>2]=f[i>>2];X=29}if((X|0)==29){W=f[i+4>>2]|0;if((W|0)<3){f[z>>2]=W;f[A>>2]=f[i+8>>2];f[k+12>>2]=f[i+12>>2];A=f[i+44>>2]|0;W=f[F>>2]|0;f[W>>2]=f[A>>2];f[W+4>>2]=f[A+4>>2]}else X=31}if((X|0)==31)jL(k,i);A=i+16|0;f[S>>2]=f[A>>2];f[k+20>>2]=f[i+20>>2];f[k+24>>2]=f[i+24>>2];f[k+28>>2]=f[i+28>>2];f[k+32>>2]=f[i+32>>2];S=f[q>>2]|0;f[R>>2]=S;if(S|0?(R=S+12|0,S=f[R>>2]|0,f[R>>2]=S+-1,(S|0)==1):0)kL(i);f[q>>2]=0;q=i+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[q>>2]|0)>0){A=f[i+40>>2]|0;S=0;do{f[A+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[q>>2]|0))}q=f[i+44>>2]|0;if((q|0)!=(i+48|0))UC(q);q=f[a+8>>2]|0;f[g>>2]=P;f[g+4>>2]=T;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;lL(i,q,g,h);q=i+36|0;S=f[q>>2]|0;if(S|0){A=S+12|0;f[A>>2]=(f[A>>2]|0)+1}A=l+36|0;S=f[A>>2]|0;if(S|0?(R=S+12|0,S=f[R>>2]|0,f[R>>2]=S+-1,(S|0)==1):0)kL(l);f[A>>2]=0;S=l+16|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[G>>2]|0)>0){R=f[I>>2]|0;W=0;do{f[R+(W<<2)>>2]=0;W=W+1|0;Z=f[G>>2]|0}while((W|0)<(Z|0));f[l>>2]=f[i>>2];if((Z|0)<3)X=50;else X=52}else{f[l>>2]=f[i>>2];X=50}if((X|0)==50){Z=f[i+4>>2]|0;if((Z|0)<3){f[G>>2]=Z;f[H>>2]=f[i+8>>2];f[l+12>>2]=f[i+12>>2];H=f[i+44>>2]|0;Z=f[D>>2]|0;f[Z>>2]=f[H>>2];f[Z+4>>2]=f[H+4>>2]}else X=52}if((X|0)==52)jL(l,i);H=i+16|0;f[S>>2]=f[H>>2];f[l+20>>2]=f[i+20>>2];f[l+24>>2]=f[i+24>>2];f[l+28>>2]=f[i+28>>2];f[l+32>>2]=f[i+32>>2];S=f[q>>2]|0;f[A>>2]=S;if(S|0?(A=S+12|0,S=f[A>>2]|0,f[A>>2]=S+-1,(S|0)==1):0)kL(i);f[q>>2]=0;q=i+4|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[q>>2]|0)>0){H=f[i+40>>2]|0;S=0;do{f[H+(S<<2)>>2]=0;S=S+1|0}while((S|0)<(f[q>>2]|0))}q=f[i+44>>2]|0;if((q|0)!=(i+48|0))UC(q)}else{q=f[O>>2]|0;f[g>>2]=P;f[g+4>>2]=T;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;lL(r,q,g,h);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=r;q=g+8|0;f[q>>2]=0;f[q+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=k;q=a+28|0;z2(i,g,3,1,0,f[q>>2]|0,1.0,0.0,1);S=r+36|0;H=f[S>>2]|0;if(H|0?(A=H+12|0,H=f[A>>2]|0,f[A>>2]=H+-1,(H|0)==1):0)kL(r);f[S>>2]=0;S=r+16|0;H=r+4|0;f[S>>2]=0;f[S+4>>2]=0;f[S+8>>2]=0;f[S+12>>2]=0;if((f[H>>2]|0)>0){S=f[r+40>>2]|0;A=0;do{f[S+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[H>>2]|0))}H=f[r+44>>2]|0;if((H|0)!=(r+48|0))UC(H);H=f[O>>2]|0;f[g>>2]=P;f[g+4>>2]=T;f[h>>2]=-2147483648;f[h+4>>2]=2147483647;lL(r,H,g,h);f[i+8>>2]=0;f[i+12>>2]=0;f[i>>2]=16842752;f[i+4>>2]=r;H=g+8|0;f[H>>2]=0;f[H+4>>2]=0;f[g>>2]=33619968;f[g+4>>2]=l;z2(i,g,3,0,1,f[q>>2]|0,1.0,0.0,1);q=r+36|0;H=f[q>>2]|0;if(H|0?(A=H+12|0,H=f[A>>2]|0,f[A>>2]=H+-1,(H|0)==1):0)kL(r);f[q>>2]=0;q=r+16|0;H=r+4|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[H>>2]|0)>0){q=f[r+40>>2]|0;A=0;do{f[q+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[H>>2]|0))}H=f[r+44>>2]|0;if((H|0)!=(r+48|0))UC(H)}dQ(r,52304);r=a+40|0;H=f[r>>2]|0;if((H|0)>1){A=k+12|0;q=f[A>>2]<<1;if((f[K>>2]|0)>>>0<q>>>0){S=f[m>>2]|0;if((S|0)!=(J|0)){if(S|0)P5b(S);f[m>>2]=J;f[K>>2]=520}f[K>>2]=q;if(q>>>0>520){S=N5b(q>>>0>2147483647?-1:q<<1)|0;f[m>>2]=S}}else f[K>>2]=q;q=l+12|0;S=f[q>>2]<<1;if((f[M>>2]|0)>>>0<S>>>0){Z=f[n>>2]|0;if((Z|0)!=(L|0)){if(Z|0)P5b(Z);f[n>>2]=L;f[M>>2]=520}f[M>>2]=S;if(S>>>0>520){Z=N5b(S>>>0>2147483647?-1:S<<1)|0;f[n>>2]=Z;_=Z}else _=L}else{f[M>>2]=S;_=f[n>>2]|0}S=f[m>>2]|0;$=_+(f[q>>2]<<1)|0;aa=S+(f[A>>2]<<1)|0;ba=_;ca=S;da=f[r>>2]|0}else{$=0;aa=0;ba=0;ca=0;da=H}H=a+36|0;S=f[H>>2]|0;_=Y(S*3|0,da)|0;A=s+8|0;f[s>>2]=A;q=s+4|0;f[q>>2]=_;if(_>>>0>264){Z=N5b(_>>>0>1073741823?-1:_<<2)|0;f[s>>2]=Z;ea=Z}else ea=A;Z=ea+4|0;_=Y(da,S)|0;da=Z+(_<<2)|0;W=da+(_<<2)|0;_=W+-4|0;if((P|0)==(f[c>>2]|0))Nac(_|0,0,S<<2|0)|0;else{f[_>>2]=0;f[W+(f[(f[O>>2]|0)+12>>2]<<2)>>2]=0}f[ea>>2]=0;f[Z+(f[(f[O>>2]|0)+12>>2]<<2)>>2]=0;f[da+-4>>2]=0;f[da+(f[(f[O>>2]|0)+12>>2]<<2)>>2]=0;ea=f[Q>>2]|0;if((P|0)>(ea|0)){fa=ea;ga=a+12|0}else{ea=k+16|0;_=l+16|0;S=a+32|0;R=a+12|0;V=a+20|0;U=a+24|0;ha=o+8|0;ia=o+4|0;ja=o+16|0;ka=o+20|0;la=P;ma=$;$=aa;aa=ba;ba=ca;ca=W;W=da;da=Z;while(1){if((la|0)<(T|0)){Z=la-P|0;na=(f[ea>>2]|0)+(Y(f[f[F>>2]>>2]|0,Z)|0)|0;oa=(f[_>>2]|0)+(Y(f[f[D>>2]>>2]|0,Z)|0)|0;Z=Y(f[r>>2]|0,f[(f[O>>2]|0)+12>>2]|0)|0;pa=(Z|0)>0;if(!(b[S>>0]|0)){if(pa){qa=da;ra=0;do{sa=d[na+(ra<<1)>>1]|0;ta=sa<<16>>16;ua=d[oa+(ra<<1)>>1]|0;va=ua<<16>>16;f[qa+(ra<<2)>>2]=(ua<<16>>16>-1?va:0-va|0)+(sa<<16>>16>-1?ta:0-ta|0);ra=ra+1|0}while((ra|0)!=(Z|0))}}else if(pa){ra=da;qa=0;do{ta=d[na+(qa<<1)>>1]|0;sa=Y(ta,ta)|0;ta=d[oa+(qa<<1)>>1]|0;va=(Y(ta,ta)|0)+sa|0;f[ra+(qa<<2)>>2]=va;qa=qa+1|0}while((qa|0)!=(Z|0))}Z=f[r>>2]|0;if((Z|0)>1){qa=f[(f[O>>2]|0)+12>>2]|0;ra=da;if((qa|0)>0){pa=ba;va=aa;sa=0;ta=0;ua=Z;while(1){Z=f[ra+(ta<<2)>>2]|0;if((ua|0)>1){wa=ta;xa=1;ya=Z;while(1){za=xa+ta|0;Aa=(f[ra+(za<<2)>>2]|0)>(ya|0)?za:wa;xa=xa+1|0;za=f[ra+(Aa<<2)>>2]|0;if((xa|0)>=(ua|0)){Ba=Aa;Ca=za;break}else{wa=Aa;ya=za}}}else{Ba=ta;Ca=Z}f[ra+(sa<<2)>>2]=Ca;d[pa+(sa<<1)>>1]=d[na+(Ba<<1)>>1]|0;d[va+(sa<<1)>>1]=d[oa+(Ba<<1)>>1]|0;sa=sa+1|0;ya=f[r>>2]|0;wa=f[(f[O>>2]|0)+12>>2]|0;if((sa|0)>=(wa|0)){Da=wa;break}else{ta=ya+ta|0;ua=ya}}}else Da=qa;f[ra+(Da<<2)>>2]=0;Ea=aa;Fa=ba;Ga=ma;Ha=$}else{Ea=ma;Fa=$;Ga=aa;Ha=ba}if((la|0)>(f[c>>2]|0)){Ia=Ea;Ja=Fa;Ka=Ga;La=Ha;X=106}else{Ma=Ea;Na=Fa;Oa=Ga;Pa=Ha}}else{Nac(da+-4|0,0,f[H>>2]<<2|0)|0;ua=(f[r>>2]|0)>1;Ia=ua?aa:ma;Ja=ua?ba:$;Ka=ua?ma:aa;La=ua?$:ba;X=106}if((X|0)==106){X=0;ua=f[R>>2]|0;ta=(f[ua+16>>2]|0)+(Y(f[f[ua+44>>2]>>2]|0,la)|0)|0;ua=ta+1|0;b[ta>>0]=1;b[ua+(f[(f[O>>2]|0)+12>>2]|0)>>0]=1;if((f[r>>2]|0)==1){ta=la-P+-1|0;sa=(f[ea>>2]|0)+(Y(f[f[F>>2]>>2]|0,ta)|0)|0;Qa=sa;Ra=(f[_>>2]|0)+(Y(f[f[D>>2]>>2]|0,ta)|0)|0}else{Qa=La;Ra=Ka}if((f[(f[O>>2]|0)+12>>2]|0)>0){ta=ca;sa=W;oa=da;va=0;do{na=f[ta+(va<<2)>>2]|0;do if((na|0)>(f[V>>2]|0)){pa=d[Qa+(va<<1)>>1]|0;ya=d[Ra+(va<<1)>>1]|0;wa=pa<<16>>16;xa=pa<<16>>16>-1?wa:0-wa|0;wa=ya<<16>>16;za=(ya<<16>>16>-1?wa:0-wa|0)<<15;if((za|0)<(xa*13573|0)){if((na|0)<=(f[ta+(va+-1<<2)>>2]|0)){X=135;break}if((na|0)<(f[ta+(va+1<<2)>>2]|0)){X=135;break}wa=ua+va|0;if((na|0)<=(f[U>>2]|0)){b[wa>>0]=0;break}b[wa>>0]=2;Aa=f[ia>>2]|0;Sa=(f[ha>>2]|0)-Aa|0;Ta=f[ja>>2]|0;Ua=f[ka>>2]|0;if((((Sa|0)==0?0:(Sa<<8)+-1|0)|0)==(Ua+Ta|0)){F4(o);Va=f[ja>>2]|0;Wa=f[ka>>2]|0;Xa=f[ia>>2]|0}else{Va=Ta;Wa=Ua;Xa=Aa}Aa=Wa+Va|0;f[(f[Xa+(Aa>>>10<<2)>>2]|0)+((Aa&1023)<<2)>>2]=wa;f[ka>>2]=Wa+1;break}if((za|0)>(xa*79109|0)){if((na|0)<=(f[sa+(va<<2)>>2]|0)){X=135;break}if((na|0)<(f[oa+(va<<2)>>2]|0)){X=135;break}xa=ua+va|0;if((na|0)<=(f[U>>2]|0)){b[xa>>0]=0;break}b[xa>>0]=2;za=f[ia>>2]|0;wa=(f[ha>>2]|0)-za|0;Aa=f[ja>>2]|0;Ua=f[ka>>2]|0;if((((wa|0)==0?0:(wa<<8)+-1|0)|0)==(Ua+Aa|0)){F4(o);Ya=f[ja>>2]|0;Za=f[ka>>2]|0;_a=f[ia>>2]|0}else{Ya=Aa;Za=Ua;_a=za}za=Za+Ya|0;f[(f[_a+(za>>>10<<2)>>2]|0)+((za&1023)<<2)>>2]=xa;f[ka>>2]=Za+1;break}else{xa=(ya^pa)<<16>>16<0?-1:1;if((na|0)<=(f[sa+(va-xa<<2)>>2]|0)){X=135;break}if((na|0)<=(f[oa+(xa+va<<2)>>2]|0)){X=135;break}xa=ua+va|0;if((na|0)<=(f[U>>2]|0)){b[xa>>0]=0;break}b[xa>>0]=2;pa=f[ia>>2]|0;ya=(f[ha>>2]|0)-pa|0;za=f[ja>>2]|0;Ua=f[ka>>2]|0;if((((ya|0)==0?0:(ya<<8)+-1|0)|0)==(Ua+za|0)){F4(o);$a=f[ja>>2]|0;ab=f[ka>>2]|0;bb=f[ia>>2]|0}else{$a=za;ab=Ua;bb=pa}pa=ab+$a|0;f[(f[bb+(pa>>>10<<2)>>2]|0)+((pa&1023)<<2)>>2]=xa;f[ka>>2]=ab+1;break}}else X=135;while(0);if((X|0)==135){X=0;b[ua+va>>0]=1}va=va+1|0}while((va|0)<(f[(f[O>>2]|0)+12>>2]|0));Ma=Ia;Na=Ja;Oa=Ka;Pa=La}else{Ma=Ia;Na=Ja;Oa=Ka;Pa=La}}va=f[Q>>2]|0;if((la|0)<(va|0)){ua=da;la=la+1|0;ma=Ma;$=Na;aa=Oa;ba=Pa;da=W;W=ca;ca=ua}else{fa=va;ga=R;break}}}R=f[ga>>2]|0;ga=f[R+16>>2]|0;if((N|0)<2)cb=ga;else cb=ga+(Y((f[c>>2]|0)+2|0,f[H>>2]|0)|0)|0;if((T|0)==(f[(f[O>>2]|0)+8>>2]|0))db=f[R+28>>2]|0;else db=ga+(Y(f[H>>2]|0,fa)|0)|0;fa=cb;ga=db-fa|0;dQ(t,52324);t=o+20|0;db=f[t>>2]|0;if(!db)eb=p+20|0;else{R=o+16|0;O=o+4|0;T=o+8|0;c=p+8|0;N=p+4|0;ca=p+16|0;W=p+20|0;da=db;while(1){db=f[R>>2]|0;Pa=da+-1|0;ba=db+Pa|0;Oa=f[O>>2]|0;aa=f[(f[Oa+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]|0;f[t>>2]=Pa;Pa=f[T>>2]|0;ba=Pa-Oa|0;if((1-da-db+((ba|0)==0?0:(ba<<8)+-1|0)|0)>>>0>2047){O5b(f[Pa+-4>>2]|0);f[T>>2]=(f[T>>2]|0)+-4}Pa=aa;do if((aa-fa|0)>>>0>=ga>>>0){ba=f[N>>2]|0;db=(f[c>>2]|0)-ba|0;Oa=f[ca>>2]|0;Na=f[W>>2]|0;if((((db|0)==0?0:(db<<8)+-1|0)|0)==(Na+Oa|0)){F4(p);fb=f[ca>>2]|0;gb=f[W>>2]|0;hb=f[N>>2]|0}else{fb=Oa;gb=Na;hb=ba}ba=gb+fb|0;f[(f[hb+(ba>>>10<<2)>>2]|0)+((ba&1023)<<2)>>2]=aa;f[W>>2]=gb+1;ba=f[H>>2]|0;Na=Pa>>>0<cb>>>0?ba:0-ba|0;ba=Pa+-1|0;if(!(b[ba>>0]|0)){b[ba>>0]=2;Oa=f[O>>2]|0;db=(f[T>>2]|0)-Oa|0;$=f[R>>2]|0;Ma=f[t>>2]|0;if((((db|0)==0?0:(db<<8)+-1|0)|0)==(Ma+$|0)){F4(o);ib=f[R>>2]|0;jb=f[t>>2]|0;kb=f[O>>2]|0}else{ib=$;jb=Ma;kb=Oa}Oa=jb+ib|0;f[(f[kb+(Oa>>>10<<2)>>2]|0)+((Oa&1023)<<2)>>2]=ba;f[t>>2]=jb+1}ba=Pa+1|0;if(!(b[ba>>0]|0)){b[ba>>0]=2;Oa=f[O>>2]|0;Ma=(f[T>>2]|0)-Oa|0;$=f[R>>2]|0;db=f[t>>2]|0;if((((Ma|0)==0?0:(Ma<<8)+-1|0)|0)==(db+$|0)){F4(o);lb=f[R>>2]|0;mb=f[t>>2]|0;nb=f[O>>2]|0}else{lb=$;mb=db;nb=Oa}Oa=mb+lb|0;f[(f[nb+(Oa>>>10<<2)>>2]|0)+((Oa&1023)<<2)>>2]=ba;f[t>>2]=mb+1}ba=Pa+Na|0;if(!(b[Pa+(Na+-1)>>0]|0)){Oa=ba+-1|0;b[Oa>>0]=2;db=f[O>>2]|0;$=(f[T>>2]|0)-db|0;Ma=f[R>>2]|0;ma=f[t>>2]|0;if(((($|0)==0?0:($<<8)+-1|0)|0)==(ma+Ma|0)){F4(o);ob=f[R>>2]|0;pb=f[t>>2]|0;qb=f[O>>2]|0}else{ob=Ma;pb=ma;qb=db}db=pb+ob|0;f[(f[qb+(db>>>10<<2)>>2]|0)+((db&1023)<<2)>>2]=Oa;f[t>>2]=pb+1}if(!(b[ba>>0]|0)){b[ba>>0]=2;Oa=f[O>>2]|0;db=(f[T>>2]|0)-Oa|0;ma=f[R>>2]|0;Ma=f[t>>2]|0;if((((db|0)==0?0:(db<<8)+-1|0)|0)==(Ma+ma|0)){F4(o);rb=f[R>>2]|0;sb=f[t>>2]|0;tb=f[O>>2]|0}else{rb=ma;sb=Ma;tb=Oa}Oa=sb+rb|0;f[(f[tb+(Oa>>>10<<2)>>2]|0)+((Oa&1023)<<2)>>2]=ba;f[t>>2]=sb+1}if(!(b[Pa+(Na+1)>>0]|0)){ba=Pa+Na+1|0;b[ba>>0]=2;Na=f[O>>2]|0;Oa=(f[T>>2]|0)-Na|0;Ma=f[R>>2]|0;ma=f[t>>2]|0;if((((Oa|0)==0?0:(Oa<<8)+-1|0)|0)==(ma+Ma|0)){F4(o);ub=f[R>>2]|0;vb=f[t>>2]|0;wb=f[O>>2]|0}else{ub=Ma;vb=ma;wb=Na}Na=vb+ub|0;f[(f[wb+(Na>>>10<<2)>>2]|0)+((Na&1023)<<2)>>2]=ba;ba=vb+1|0;f[t>>2]=ba;xb=ba}else X=202}else{ba=f[H>>2]|0;if(!(b[Pa+~ba>>0]|0)){b[Pa+(0-ba)+-1>>0]=2;Na=f[H>>2]|0;ma=f[O>>2]|0;Ma=(f[T>>2]|0)-ma|0;Oa=f[R>>2]|0;db=f[t>>2]|0;if((((Ma|0)==0?0:(Ma<<8)+-1|0)|0)==(db+Oa|0)){F4(o);yb=f[H>>2]|0;zb=f[R>>2]|0;Ab=f[t>>2]|0;Bb=f[O>>2]|0}else{yb=Na;zb=Oa;Ab=db;Bb=ma}ma=Ab+zb|0;f[(f[Bb+(ma>>>10<<2)>>2]|0)+((ma&1023)<<2)>>2]=Pa+(0-Na)+-1;f[t>>2]=Ab+1;Cb=yb}else Cb=ba;ba=Pa+(0-Cb)|0;if(!(b[ba>>0]|0)){b[ba>>0]=2;ba=f[H>>2]|0;Na=f[O>>2]|0;ma=(f[T>>2]|0)-Na|0;db=f[R>>2]|0;Oa=f[t>>2]|0;if((((ma|0)==0?0:(ma<<8)+-1|0)|0)==(Oa+db|0)){F4(o);Db=f[H>>2]|0;Eb=f[R>>2]|0;Fb=f[t>>2]|0;Gb=f[O>>2]|0}else{Db=ba;Eb=db;Fb=Oa;Gb=Na}Na=Fb+Eb|0;f[(f[Gb+(Na>>>10<<2)>>2]|0)+((Na&1023)<<2)>>2]=Pa+(0-ba);f[t>>2]=Fb+1;Hb=Db}else Hb=Cb;if(!(b[Pa+(1-Hb)>>0]|0)){b[Pa+(0-Hb)+1>>0]=2;ba=Pa+(0-(f[H>>2]|0))+1|0;Na=f[O>>2]|0;Oa=(f[T>>2]|0)-Na|0;db=f[R>>2]|0;ma=f[t>>2]|0;if((((Oa|0)==0?0:(Oa<<8)+-1|0)|0)==(ma+db|0)){F4(o);Ib=f[R>>2]|0;Jb=f[t>>2]|0;Kb=f[O>>2]|0}else{Ib=db;Jb=ma;Kb=Na}Na=Jb+Ib|0;f[(f[Kb+(Na>>>10<<2)>>2]|0)+((Na&1023)<<2)>>2]=ba;f[t>>2]=Jb+1}ba=Pa+-1|0;if(!(b[ba>>0]|0)){b[ba>>0]=2;Na=f[O>>2]|0;ma=(f[T>>2]|0)-Na|0;db=f[R>>2]|0;Oa=f[t>>2]|0;if((((ma|0)==0?0:(ma<<8)+-1|0)|0)==(Oa+db|0)){F4(o);Lb=f[R>>2]|0;Mb=f[t>>2]|0;Nb=f[O>>2]|0}else{Lb=db;Mb=Oa;Nb=Na}Na=Mb+Lb|0;f[(f[Nb+(Na>>>10<<2)>>2]|0)+((Na&1023)<<2)>>2]=ba;f[t>>2]=Mb+1}ba=Pa+1|0;if(!(b[ba>>0]|0)){b[ba>>0]=2;Na=f[O>>2]|0;Oa=(f[T>>2]|0)-Na|0;db=f[R>>2]|0;ma=f[t>>2]|0;if((((Oa|0)==0?0:(Oa<<8)+-1|0)|0)==(ma+db|0)){F4(o);Ob=f[R>>2]|0;Pb=f[t>>2]|0;Qb=f[O>>2]|0}else{Ob=db;Pb=ma;Qb=Na}Na=Pb+Ob|0;f[(f[Qb+(Na>>>10<<2)>>2]|0)+((Na&1023)<<2)>>2]=ba;f[t>>2]=Pb+1}ba=f[H>>2]|0;if(!(b[Pa+(ba+-1)>>0]|0)){b[Pa+ba+-1>>0]=2;Na=f[H>>2]|0;ma=f[O>>2]|0;db=(f[T>>2]|0)-ma|0;Oa=f[R>>2]|0;Ma=f[t>>2]|0;if((((db|0)==0?0:(db<<8)+-1|0)|0)==(Ma+Oa|0)){F4(o);Rb=f[H>>2]|0;Sb=f[R>>2]|0;Tb=f[t>>2]|0;Ub=f[O>>2]|0}else{Rb=Na;Sb=Oa;Tb=Ma;Ub=ma}ma=Tb+Sb|0;f[(f[Ub+(ma>>>10<<2)>>2]|0)+((ma&1023)<<2)>>2]=Pa+Na+-1;f[t>>2]=Tb+1;Vb=Rb}else Vb=ba;ba=Pa+Vb|0;if(!(b[ba>>0]|0)){b[ba>>0]=2;ba=f[H>>2]|0;Na=f[O>>2]|0;ma=(f[T>>2]|0)-Na|0;Ma=f[R>>2]|0;Oa=f[t>>2]|0;if((((ma|0)==0?0:(ma<<8)+-1|0)|0)==(Oa+Ma|0)){F4(o);Wb=f[H>>2]|0;Xb=f[R>>2]|0;Yb=f[t>>2]|0;Zb=f[O>>2]|0}else{Wb=ba;Xb=Ma;Yb=Oa;Zb=Na}Na=Yb+Xb|0;f[(f[Zb+(Na>>>10<<2)>>2]|0)+((Na&1023)<<2)>>2]=Pa+ba;f[t>>2]=Yb+1;_b=Wb}else _b=Vb;if(b[Pa+(_b+1)>>0]|0){X=202;break}b[Pa+_b+1>>0]=2;ba=Pa+(f[H>>2]|0)+1|0;Na=f[O>>2]|0;Oa=(f[T>>2]|0)-Na|0;Ma=f[R>>2]|0;ma=f[t>>2]|0;if((((Oa|0)==0?0:(Oa<<8)+-1|0)|0)==(ma+Ma|0)){F4(o);$b=f[R>>2]|0;ac=f[t>>2]|0;bc=f[O>>2]|0}else{$b=Ma;ac=ma;bc=Na}Na=ac+$b|0;f[(f[bc+(Na>>>10<<2)>>2]|0)+((Na&1023)<<2)>>2]=ba;ba=ac+1|0;f[t>>2]=ba;xb=ba}while(0);if((X|0)==202){X=0;xb=f[t>>2]|0}if(!xb){eb=W;break}else da=xb}}if(f[eb>>2]|0){xb=a+44|0;PO(xb);da=f[a+16>>2]|0;a=(f[da+16>>2]|0)+(f[da+20>>2]|0)|0;W=f[da+4>>2]|0;t=W+(a>>>10<<2)|0;if((f[da+8>>2]|0)==(W|0))cc=0;else cc=(f[t>>2]|0)+((a&1023)<<2)|0;f[v>>2]=t;f[v+4>>2]=cc;cc=f[p+4>>2]|0;t=f[p+16>>2]|0;a=cc+(t>>>10<<2)|0;W=(f[p+8>>2]|0)==(cc|0);if(W)dc=0;else dc=(f[a>>2]|0)+((t&1023)<<2)|0;f[w>>2]=a;f[w+4>>2]=dc;dc=t+(f[eb>>2]|0)|0;eb=cc+(dc>>>10<<2)|0;if(W)ec=0;else ec=(f[eb>>2]|0)+((dc&1023)<<2)|0;f[x>>2]=eb;f[x+4>>2]=ec;f[i>>2]=f[v>>2];f[i+4>>2]=f[v+4>>2];f[h>>2]=f[w>>2];f[h+4>>2]=f[w+4>>2];f[g>>2]=f[x>>2];f[g+4>>2]=f[x+4>>2];O4(y,da,i,h,g,0);QO(xb)}xb=f[s>>2]|0;if((xb|0)!=(A|0)){if(xb|0)P5b(xb);f[s>>2]=A;f[q>>2]=264}G4(p);G4(o);o=f[n>>2]|0;if((o|0)!=(L|0)){if(o|0)P5b(o);f[n>>2]=L;f[M>>2]=520}M=f[m>>2]|0;if((M|0)!=(J|0)){if(M|0)P5b(M);f[m>>2]=J;f[K>>2]=520}K=l+36|0;J=f[K>>2]|0;if(J|0?(m=J+12|0,J=f[m>>2]|0,f[m>>2]=J+-1,(J|0)==1):0)kL(l);f[K>>2]=0;K=l+16|0;f[K>>2]=0;f[K+4>>2]=0;f[K+8>>2]=0;f[K+12>>2]=0;if((f[G>>2]|0)>0){K=f[I>>2]|0;I=0;do{f[K+(I<<2)>>2]=0;I=I+1|0}while((I|0)<(f[G>>2]|0))}G=f[D>>2]|0;if((G|0)!=(C|0))UC(G);G=k+36|0;C=f[G>>2]|0;do if(C|0){D=C+12|0;I=f[D>>2]|0;f[D>>2]=I+-1;if((I|0)!=1)break;kL(k)}while(0);f[G>>2]=0;G=k+16|0;f[G>>2]=0;f[G+4>>2]=0;f[G+8>>2]=0;f[G+12>>2]=0;if((f[z>>2]|0)>0){G=f[B>>2]|0;B=0;do{f[G+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[z>>2]|0))}z=f[F>>2]|0;if((z|0)!=(E|0))UC(z);if(!(f[j+4>>2]|0)){u=e;return}u=e;return}function O4(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0;g=u;u=u+128|0;h=g+120|0;i=g+112|0;j=g+104|0;k=g+24|0;l=g+96|0;m=g+88|0;n=g+80|0;o=g+72|0;p=g+64|0;q=g+56|0;r=g+48|0;s=g+40|0;t=g+32|0;v=g+16|0;w=g+8|0;x=g;y=d;z=f[y>>2]|0;A=f[y+4>>2]|0;y=e;B=f[y>>2]|0;C=f[y+4>>2]|0;if((C|0)==(A|0))D=0;else D=(C-(f[B>>2]|0)>>2)+(B-z<<8)-(A-(f[z>>2]|0)>>2)|0;y=b+4|0;E=f[y>>2]|0;F=b+16|0;G=f[F>>2]|0;H=E+(G>>>10<<2)|0;I=b+8|0;J=f[I>>2]|0;K=J;L=E;if((J|0)==(E|0))M=0;else M=(f[H>>2]|0)+((G&1023)<<2)|0;N=f[c+4>>2]|0;if((N|0)==(M|0))O=0;else{P=f[c>>2]|0;O=(N-(f[P>>2]|0)>>2)+(P-H<<8)-(M-(f[H>>2]|0)>>2)|0}H=b+20|0;M=f[H>>2]|0;if(O>>>0<(M-O|0)>>>0){if(D>>>0>G>>>0){P4(b,D-G|0);Q=f[F>>2]|0;R=f[y>>2]|0;S=f[I>>2]|0}else{Q=G;R=E;S=J}P=R+(Q>>>10<<2)|0;if((S|0)==(R|0))T=0;else T=(f[P>>2]|0)+((Q&1023)<<2)|0;R=P;S=T;if(D>>>0>O>>>0){if(O>>>0<D>>>1>>>0)if(!O){U=B;V=C}else{N=B;c=(C-(f[B>>2]|0)>>2)-O|0;if((c|0)>0){W=N+(c>>>10<<2)|0;X=(f[W>>2]|0)+((c&1023)<<2)|0;Y=W}else{W=1023-c|0;c=N+(((W|0)/-1024|0)<<2)|0;X=(f[c>>2]|0)+(1023-((W|0)%1024|0)<<2)|0;Y=c}U=Y;V=X}else{X=D-O|0;if(!X){U=z;V=A}else{Y=z;c=(A-(f[z>>2]|0)>>2)+X|0;if((c|0)>0){X=Y+(c>>>10<<2)|0;Z=(f[X>>2]|0)+((c&1023)<<2)|0;_=X}else{X=1023-c|0;c=Y+(((X|0)/-1024|0)<<2)|0;Z=(f[c>>2]|0)+(1023-((X|0)%1024|0)<<2)|0;_=c}U=_;V=Z}}Z=V;_=d+4|0;if((Z|0)==(f[_>>2]|0)){$=O;aa=Q;ba=R;ca=S;da=U;ea=V}else{c=U;X=R;Y=S;W=Z;Z=Q;N=f[H>>2]|0;while(1){fa=Y;ga=X;if((fa|0)==(f[ga>>2]|0)){ha=ga+-4|0;ia=ha;ja=(f[ha>>2]|0)+4096|0}else{ia=X;ja=fa}fa=ja+-4|0;Y=fa;ha=c;if((W|0)==(f[ha>>2]|0)){ga=ha+-4|0;ka=ga;la=(f[ga>>2]|0)+4096|0}else{ka=c;la=W}W=la+-4|0;f[fa>>2]=f[W>>2];Z=Z+-1|0;N=N+1|0;if((W|0)==(f[_>>2]|0))break;else{c=ka;X=ia}}f[F>>2]=Z;f[H>>2]=N;$=O;aa=Z;ba=ia;ca=Y;da=U;ea=V}}else{$=D;aa=Q;ba=R;ca=S;da=z;ea=A}if($|0){Q=(S-(f[P>>2]|0)>>2)+$|0;if((Q|0)>0){V=P+(Q>>>10<<2)|0;ma=(f[V>>2]|0)+((Q&1023)<<2)|0;na=V}else{V=1023-Q|0;Q=P+(((V|0)/-1024|0)<<2)|0;ma=(f[Q>>2]|0)+(1023-((V|0)%1024|0)<<2)|0;na=Q}Q=na;na=ma;if((ma|0)!=(T|0)){V=Q;U=ba;ba=ca;ca=ma;ma=aa;aa=f[H>>2]|0;while(1){Y=ba;ia=U;if((Y|0)==(f[ia>>2]|0)){Z=ia+-4|0;oa=Z;pa=(f[Z>>2]|0)+4096|0}else{oa=U;pa=Y}ba=pa+-4|0;Y=V;if((ca|0)==(f[Y>>2]|0)){Z=Y+-4|0;qa=Z;ra=(f[Z>>2]|0)+4096|0}else{qa=V;ra=ca}ca=ra+-4|0;f[ba>>2]=f[ca>>2];ma=ma+-1|0;aa=aa+1|0;if((ca|0)==(T|0))break;else{V=qa;U=oa}}f[F>>2]=ma;f[H>>2]=aa}if($>>>0<O>>>0){f[l>>2]=Q;f[l+4>>2]=na;na=m;f[na>>2]=R;f[na+4>>2]=S;na=(S-(f[P>>2]|0)>>2)+O|0;if((na|0)>0){Q=P+(na>>>10<<2)|0;f[m>>2]=Q;sa=(f[Q>>2]|0)+((na&1023)<<2)|0}else{Q=1023-na|0;na=P+(((Q|0)/-1024|0)<<2)|0;f[m>>2]=na;sa=(f[na>>2]|0)+(1023-((Q|0)%1024|0)<<2)|0}f[m+4>>2]=sa;f[n>>2]=R;f[n+4>>2]=S;f[j>>2]=f[l>>2];f[j+4>>2]=f[l+4>>2];f[i>>2]=f[m>>2];f[i+4>>2]=f[m+4>>2];f[h>>2]=f[n>>2];f[h+4>>2]=f[n+4>>2];Q4(k,j,i,h);ta=f[k>>2]|0;ua=f[k+4>>2]|0}else{ta=R;ua=S}S=o;f[S>>2]=da;f[S+4>>2]=ea;ea=e;S=f[ea+4>>2]|0;da=p;f[da>>2]=f[ea>>2];f[da+4>>2]=S;f[q>>2]=ta;f[q+4>>2]=ua;f[j>>2]=f[o>>2];f[j+4>>2]=f[o+4>>2];f[i>>2]=f[p>>2];f[i+4>>2]=f[p+4>>2];f[h>>2]=f[q>>2];f[h+4>>2]=f[q+4>>2];R4(k,j,i,h)}}else{q=K-L|0;L=((q|0)==0?0:(q<<8)+-1|0)-(M+G)|0;if(D>>>0>L>>>0){S4(b,D-L|0);va=f[H>>2]|0;wa=f[F>>2]|0;xa=f[y>>2]|0;ya=f[I>>2]|0}else{va=M;wa=G;xa=E;ya=J}J=wa+va|0;wa=xa+(J>>>10<<2)|0;if((ya|0)==(xa|0))za=0;else za=(f[wa>>2]|0)+((J&1023)<<2)|0;J=wa;xa=za;ya=va-O|0;if(D>>>0>ya>>>0){if(ya>>>0<D>>>1>>>0)if(!ya){Aa=z;Ba=A}else{E=z;G=(A-(f[z>>2]|0)>>2)+ya|0;if((G|0)>0){z=E+(G>>>10<<2)|0;Ca=(f[z>>2]|0)+((G&1023)<<2)|0;Da=z}else{z=1023-G|0;G=E+(((z|0)/-1024|0)<<2)|0;Ca=(f[G>>2]|0)+(1023-((z|0)%1024|0)<<2)|0;Da=G}Aa=Da;Ba=Ca}else{Ca=D-ya|0;if(!Ca){Aa=B;Ba=C}else{Da=B;G=(C-(f[B>>2]|0)>>2)-Ca|0;if((G|0)>0){Ca=Da+(G>>>10<<2)|0;Ea=(f[Ca>>2]|0)+((G&1023)<<2)|0;Fa=Ca}else{Ca=1023-G|0;G=Da+(((Ca|0)/-1024|0)<<2)|0;Ea=(f[G>>2]|0)+(1023-((Ca|0)%1024|0)<<2)|0;Fa=G}Aa=Fa;Ba=Ea}}Ea=Ba;Fa=e+4|0;if((Ea|0)==(f[Fa>>2]|0)){Ga=ya;Ha=va;Ia=J;Ja=xa;Ka=Aa;La=Ba}else{e=Aa;G=J;Ca=Ba;Da=xa;z=Ea;Ea=va;while(1){f[Da>>2]=f[Ca>>2];E=Da+4|0;if((E-(f[G>>2]|0)|0)==4096){A=G+4|0;Ma=A;Na=f[A>>2]|0}else{Ma=G;Na=E}E=z+4|0;if((E-(f[e>>2]|0)|0)==4096){A=e+4|0;Oa=A;Pa=f[A>>2]|0}else{Oa=e;Pa=E}Ea=Ea+1|0;z=Pa;if((z|0)==(f[Fa>>2]|0))break;else{e=Oa;G=Ma;Ca=Pa;Da=Na}}f[H>>2]=Ea;Ga=ya;Ha=Ea;Ia=Ma;Ja=Na;Ka=Aa;La=Ba}}else{Ga=D;Ha=va;Ia=J;Ja=xa;Ka=B;La=C}if(Ga|0){C=(xa-(f[wa>>2]|0)>>2)-Ga|0;if((C|0)>0){B=wa+(C>>>10<<2)|0;Qa=(f[B>>2]|0)+((C&1023)<<2)|0;Ra=B}else{B=1023-C|0;C=wa+(((B|0)/-1024|0)<<2)|0;Qa=(f[C>>2]|0)+(1023-((B|0)%1024|0)<<2)|0;Ra=C}C=Ra;Ra=Qa;if((Qa|0)!=(za|0)){B=C;va=Ia;Ia=Ra;D=Ja;Ja=Qa;Qa=Ha;while(1){f[D>>2]=f[Ia>>2];Ha=D+4|0;if((Ha-(f[va>>2]|0)|0)==4096){Ba=va+4|0;Sa=Ba;Ta=f[Ba>>2]|0}else{Sa=va;Ta=Ha}Ha=Ja+4|0;if((Ha-(f[B>>2]|0)|0)==4096){Ba=B+4|0;Ua=Ba;Va=f[Ba>>2]|0}else{Ua=B;Va=Ha}Qa=Qa+1|0;Ja=Va;if((Ja|0)==(za|0))break;else{B=Ua;va=Sa;Ia=Va;D=Ta}}f[H>>2]=Qa}if(Ga>>>0<ya>>>0){Ga=r;f[Ga>>2]=J;f[Ga+4>>2]=xa;Ga=(xa-(f[wa>>2]|0)>>2)-ya|0;if((Ga|0)>0){ya=wa+(Ga>>>10<<2)|0;f[r>>2]=ya;Wa=(f[ya>>2]|0)+((Ga&1023)<<2)|0}else{ya=1023-Ga|0;Ga=wa+(((ya|0)/-1024|0)<<2)|0;f[r>>2]=Ga;Wa=(f[Ga>>2]|0)+(1023-((ya|0)%1024|0)<<2)|0}f[r+4>>2]=Wa;f[s>>2]=C;f[s+4>>2]=Ra;f[t>>2]=J;f[t+4>>2]=xa;f[j>>2]=f[r>>2];f[j+4>>2]=f[r+4>>2];f[i>>2]=f[s>>2];f[i+4>>2]=f[s+4>>2];f[h>>2]=f[t>>2];f[h+4>>2]=f[t+4>>2];T4(k,j,i,h);Xa=f[k>>2]|0;Ya=f[k+4>>2]|0}else{Xa=J;Ya=xa}xa=d;d=f[xa+4>>2]|0;J=v;f[J>>2]=f[xa>>2];f[J+4>>2]=d;d=w;f[d>>2]=Ka;f[d+4>>2]=La;f[x>>2]=Xa;f[x+4>>2]=Ya;f[j>>2]=f[v>>2];f[j+4>>2]=f[v+4>>2];f[i>>2]=f[w>>2];f[i+4>>2]=f[w+4>>2];f[h>>2]=f[x>>2];f[h+4>>2]=f[x+4>>2];U4(k,j,i,h)}}h=f[y>>2]|0;y=f[F>>2]|0;F=h+(y>>>10<<2)|0;if((f[I>>2]|0)==(h|0)){Za=0;_a=0}else{Za=0;_a=(f[F>>2]|0)+((y&1023)<<2)|0}y=a;f[y>>2]=Za|F;f[y+4>>2]=_a;if(!O){u=g;return}y=(_a-(f[F>>2]|0)>>2)+O|0;if((y|0)>0){O=F+(y>>>10<<2)|0;f[a>>2]=O;$a=(f[O>>2]|0)+((y&1023)<<2)|0}else{O=1023-y|0;y=F+(((O|0)/-1024|0)<<2)|0;f[a>>2]=y;$a=(f[y>>2]|0)+(1023-((O|0)%1024|0)<<2)|0}f[a+4>>2]=$a;u=g;return}function P4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;c=u;u=u+16|0;d=c;e=a+8|0;g=f[e>>2]|0;h=a+4|0;i=f[h>>2]|0;j=(g|0)==(i|0);k=(j&1)+b|0;b=((k&1023|0)!=0&1)+(k>>>10)|0;k=i;i=g-k|0;l=a+16|0;m=f[l>>2]|0;n=(((i|0)==0?0:(i<<8)+-1|0)-((f[a+20>>2]|0)+m)|0)>>>10;o=b>>>0<n>>>0?b:n;n=b-o|0;if(!n){f[l>>2]=(o<<10)+m;if(!o){u=c;return}m=g+-4|0;f[d>>2]=f[m>>2];f[e>>2]=m;J4(a,d);m=o+-1|0;if(!m){u=c;return}else p=m;do{m=(f[e>>2]|0)+-4|0;f[d>>2]=f[m>>2];f[e>>2]=m;J4(a,d);p=p+-1|0}while((p|0)!=0);u=c;return}p=a+12|0;m=f[a>>2]|0;q=(f[p>>2]|0)-m|0;r=i>>2;if(n>>>0<=((q>>2)-r|0)>>>0){do if((k|0)!=(m|0)){i=n;while(1){s=L5b(4096)|0;f[d>>2]=s;J4(a,d);i=i+-1|0;t=f[e>>2]|0;s=f[h>>2]|0;v=(f[l>>2]|0)+1024+(((t-s|0)==4)<<31>>31)|0;f[l>>2]=v;if(!i){w=25;break}if((s|0)==(f[a>>2]|0)){w=7;break}}if((w|0)==7){x=i;y=t;w=8;break}else if((w|0)==25){z=o;A=v;B=t;break}}else{x=n;y=g;w=8}while(0);do if((w|0)==8){g=o;t=x;v=y;a:while(1){m=L5b(4096)|0;k=f[p>>2]|0;s=k;C=v;do if((v|0)==(k|0)){D=f[h>>2]|0;E=f[a>>2]|0;F=E;if(D>>>0>E>>>0){G=D;H=((G-F>>2)+1|0)/-2|0;I=D+(H<<2)|0;J=C-G|0;G=J>>2;if(!G)K=D;else{Xac(I|0,D|0,J|0)|0;K=f[h>>2]|0}J=I+(G<<2)|0;f[e>>2]=J;f[h>>2]=K+(H<<2);L=J;break}J=s-F>>1;F=(J|0)==0?1:J;if(F>>>0>1073741823){w=17;break a}J=L5b(F<<2)|0;H=J;G=J+(F>>>2<<2)|0;I=G;M=J+(F<<2)|0;if((D|0)==(v|0)){N=I;O=E}else{E=G;G=I;F=D;do{f[E>>2]=f[F>>2];E=G+4|0;G=E;F=F+4|0}while((F|0)!=(v|0));N=G;O=f[a>>2]|0}f[a>>2]=H;f[h>>2]=I;f[e>>2]=N;f[p>>2]=M;if(!O)L=N;else{O5b(O);L=f[e>>2]|0}}else L=v;while(0);f[L>>2]=m;v=(f[e>>2]|0)+4|0;f[e>>2]=v;t=t+-1|0;g=g+1|0;if(!t){w=24;break}}if((w|0)==17){t=ze(8)|0;T5b(t,477177);f[t>>2]=149528;If(t|0,25408,1411)}else if((w|0)==24){z=g;A=f[l>>2]|0;B=v;break}}while(0);f[l>>2]=A+(z<<10);if(!z){u=c;return}A=B+-4|0;f[d>>2]=f[A>>2];f[e>>2]=A;J4(a,d);A=z+-1|0;if(!A){u=c;return}else P=A;do{A=(f[e>>2]|0)+-4|0;f[d>>2]=f[A>>2];f[e>>2]=A;J4(a,d);P=P+-1|0}while((P|0)!=0);u=c;return}P=(b<<10)+(j<<31>>31)|0;j=q>>1;q=r+n|0;r=j>>>0<q>>>0?q:j;do if(r)if(r>>>0>1073741823){j=ze(8)|0;T5b(j,477177);f[j>>2]=149528;If(j|0,25408,1411)}else{Q=L5b(r<<2)|0;break}else Q=0;while(0);j=Q;q=n;n=j;b=j;d=j;j=Q+(r<<2)|0;b:while(1){r=L5b(4096)|0;Q=d;A=d;do if((Q|0)==(j|0)){z=b;if(z>>>0>n>>>0){B=z+((((b-n>>2)+1|0)/-2|0)<<2)|0;L=d-b|0;O=L>>2;if(O|0)Xac(B|0,b|0,L|0)|0;L=B+(O<<2)|0;R=n;S=B;T=L;U=j;V=L;break}L=j-n>>1;B=(L|0)==0?1:L;if(B>>>0>1073741823){w=41;break b}L=L5b(B<<2)|0;O=L;N=L+(B>>>2<<2)|0;K=N;y=L+(B<<2)|0;if((z|0)==(Q|0))W=K;else{B=N;N=K;L=z;while(1){f[B>>2]=f[L>>2];B=N+4|0;z=B;L=L+4|0;if((L|0)==(Q|0)){W=z;break}else N=z}}N=W;if(!n){R=O;S=K;T=W;U=y;V=N}else{O5b(n);R=O;S=K;T=W;U=y;V=N}}else{R=n;S=b;T=d;U=j;V=A}while(0);f[V>>2]=r;d=T+4|0;q=q+-1|0;if(!q)break;else{n=R;b=S;j=U}}if((w|0)==41){w=ze(8)|0;T5b(w,477177);f[w>>2]=149528;If(w|0,25408,1411)}w=f[e>>2]|0;c:do if(!o){X=R;Y=S;Z=d;_=U;$=w}else{j=o;b=R;n=S;q=d;T=U;V=w;d:while(1){W=V+-4|0;A=q;Q=q;do if((A|0)==(T|0)){v=n;if(v>>>0>b>>>0){g=v+((((n-b>>2)+1|0)/-2|0)<<2)|0;N=q-n|0;L=N>>2;if(L|0)Xac(g|0,n|0,N|0)|0;N=g+(L<<2)|0;aa=b;ba=g;ca=N;da=T;ea=N;break}N=T-b>>1;g=(N|0)==0?1:N;if(g>>>0>1073741823)break d;N=L5b(g<<2)|0;L=N;B=N+(g>>>2<<2)|0;m=B;z=N+(g<<2)|0;if((v|0)==(A|0))fa=m;else{g=B;B=m;N=v;while(1){f[g>>2]=f[N>>2];g=B+4|0;v=g;N=N+4|0;if((N|0)==(A|0)){fa=v;break}else B=v}}B=fa;if(!b){aa=L;ba=m;ca=fa;da=z;ea=B}else{O5b(b);aa=L;ba=m;ca=fa;da=z;ea=B}}else{aa=b;ba=n;ca=q;da=T;ea=Q}while(0);f[ea>>2]=f[W>>2];Q=ca+4|0;A=(f[e>>2]|0)+-4|0;f[e>>2]=A;j=j+-1|0;if(!j){X=aa;Y=ba;Z=Q;_=da;$=A;break c}else{b=aa;n=ba;q=Q;T=da;V=A}}V=ze(8)|0;T5b(V,477177);f[V>>2]=149528;If(V|0,25408,1411)}while(0);da=f[h>>2]|0;e:do if((da|0)==($|0)){ga=X;ha=Y;ia=Z;ja=_}else{ba=da;aa=X;ca=Y;ea=Z;fa=_;f:while(1){w=ea;U=ea;do if((w|0)==(fa|0)){d=ca;if(d>>>0>aa>>>0){S=d+((((ca-aa>>2)+1|0)/-2|0)<<2)|0;R=ea-ca|0;o=R>>2;if(o|0)Xac(S|0,ca|0,R|0)|0;R=S+(o<<2)|0;ka=aa;la=S;ma=R;na=fa;oa=R;break}R=fa-aa>>1;S=(R|0)==0?1:R;if(S>>>0>1073741823)break f;R=L5b(S<<2)|0;o=R;V=R+(S>>>2<<2)|0;T=V;q=R+(S<<2)|0;if((d|0)==(w|0))pa=T;else{S=V;V=T;R=d;while(1){f[S>>2]=f[R>>2];S=V+4|0;d=S;R=R+4|0;if((R|0)==(w|0)){pa=d;break}else V=d}}V=pa;if(!aa){ka=o;la=T;ma=pa;na=q;oa=V}else{O5b(aa);ka=o;la=T;ma=pa;na=q;oa=V}}else{ka=aa;la=ca;ma=ea;na=fa;oa=U}while(0);f[oa>>2]=f[ba>>2];U=ma+4|0;ba=ba+4|0;if((ba|0)==(f[e>>2]|0)){ga=ka;ha=la;ia=U;ja=na;break e}else{aa=ka;ca=la;ea=U;fa=na}}fa=ze(8)|0;T5b(fa,477177);f[fa>>2]=149528;If(fa|0,25408,1411)}while(0);na=f[a>>2]|0;f[a>>2]=ga;f[h>>2]=ha;f[e>>2]=ia;f[p>>2]=ja;f[l>>2]=P+(f[l>>2]|0);if(!na){u=c;return}O5b(na);u=c;return}function Q4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=f[c+4>>2]|0;g=b+4|0;h=f[g>>2]|0;if((e|0)!=(h|0)?(i=f[c>>2]|0,c=f[b>>2]|0,j=(e-(f[i>>2]|0)>>2)+(i-c<<8)-(h-(f[c>>2]|0)>>2)|0,(j|0)>0):0){c=d;i=j;j=f[c>>2]|0;e=f[c+4>>2]|0;c=h;while(1){h=(f[f[b>>2]>>2]|0)+4096|0;k=h-c>>2;l=(k|0)>(i|0);m=l?c+(i<<2)|0:h;h=l?i:k;if((c|0)==(m|0)){n=j;o=e}else{k=m;l=c;p=e;q=j;r=e;while(1){s=q;t=(f[s>>2]|0)+4096-p>>2;u=l;v=k-u>>2;w=(v|0)>(t|0);x=w?t:v;v=l;l=w?l+(t<<2)|0:m;t=l-u|0;if(t|0)Xac(p|0,v|0,t|0)|0;if(!x){y=p;z=q;A=r}else{t=(r-(f[q>>2]|0)>>2)+x|0;if((t|0)>0){x=s+(t>>>10<<2)|0;B=(f[x>>2]|0)+((t&1023)<<2)|0;C=x}else{x=1023-t|0;t=s+(((x|0)/-1024|0)<<2)|0;B=(f[t>>2]|0)+(1023-((x|0)%1024|0)<<2)|0;C=t}y=B;z=C;A=B}if((l|0)==(m|0)){n=z;o=A;break}else{p=y;q=z;r=A}}}r=d;f[r>>2]=n;f[r+4>>2]=o;r=i-h|0;if(h|0){q=f[b>>2]|0;p=((f[g>>2]|0)-(f[q>>2]|0)>>2)+h|0;if((p|0)>0){m=q+(p>>>10<<2)|0;f[b>>2]=m;D=(f[m>>2]|0)+((p&1023)<<2)|0}else{m=1023-p|0;p=q+(((m|0)/-1024|0)<<2)|0;f[b>>2]=p;D=(f[p>>2]|0)+(1023-((m|0)%1024|0)<<2)|0}f[g>>2]=D}if((r|0)<=0){E=n;F=o;break}i=r;j=n;e=o;c=f[g>>2]|0}G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}g=d;E=f[g>>2]|0;F=f[g+4>>2]|0;G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}function R4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;e=f[c+4>>2]|0;g=b+4|0;h=f[g>>2]|0;if((e|0)!=(h|0)?(i=f[c>>2]|0,c=f[b>>2]|0,j=(e-(f[i>>2]|0)>>2)+(i-c<<8)-(h-(f[c>>2]|0)>>2)|0,(j|0)>0):0){c=d;i=j;j=f[c>>2]|0;e=f[c+4>>2]|0;c=h;while(1){h=(f[f[b>>2]>>2]|0)+4096|0;k=h-c>>2;l=(k|0)>(i|0);m=l?c+(i<<2)|0:h;h=l?i:k;if((c|0)==(m|0)){n=j;o=e}else{k=m;l=c;p=e;q=j;r=e;while(1){s=q;t=(f[s>>2]|0)+4096-p>>2;u=l;v=k-u>>2;w=(v|0)>(t|0);x=w?t:v;v=l;l=w?l+(t<<2)|0:m;t=l-u|0;if(t|0)Xac(p|0,v|0,t|0)|0;if(!x){y=p;z=q;A=r}else{t=(r-(f[q>>2]|0)>>2)+x|0;if((t|0)>0){x=s+(t>>>10<<2)|0;B=(f[x>>2]|0)+((t&1023)<<2)|0;C=x}else{x=1023-t|0;t=s+(((x|0)/-1024|0)<<2)|0;B=(f[t>>2]|0)+(1023-((x|0)%1024|0)<<2)|0;C=t}y=B;z=C;A=B}if((l|0)==(m|0)){n=z;o=A;break}else{p=y;q=z;r=A}}}r=d;f[r>>2]=n;f[r+4>>2]=o;r=i-h|0;if(h|0){q=f[b>>2]|0;p=((f[g>>2]|0)-(f[q>>2]|0)>>2)+h|0;if((p|0)>0){m=q+(p>>>10<<2)|0;f[b>>2]=m;D=(f[m>>2]|0)+((p&1023)<<2)|0}else{m=1023-p|0;p=q+(((m|0)/-1024|0)<<2)|0;f[b>>2]=p;D=(f[p>>2]|0)+(1023-((m|0)%1024|0)<<2)|0}f[g>>2]=D}if((r|0)<=0){E=n;F=o;break}i=r;j=n;e=o;c=f[g>>2]|0}G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}g=d;E=f[g>>2]|0;F=f[g+4>>2]|0;G=a;H=G;f[H>>2]=E;I=G+4|0;J=I;f[J>>2]=F;return}function S4(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;c=u;u=u+32|0;d=c;e=a+8|0;g=f[e>>2]|0;h=a+4|0;i=f[h>>2]|0;j=((g|0)==(i|0)&1)+b|0;b=((j&1023|0)!=0&1)+(j>>>10)|0;j=a+16|0;k=f[j>>2]|0;l=k>>>10;m=b>>>0<l>>>0?b:l;n=b-m|0;o=g;if(!n){f[j>>2]=k-(m<<10);if(!m){u=c;return}k=a+12|0;p=m;q=i;r=g;a:while(1){s=f[q>>2]|0;t=q+4|0;f[h>>2]=t;v=f[k>>2]|0;w=v;x=r;do if((r|0)==(v|0)){y=f[a>>2]|0;z=y;if(t>>>0>y>>>0){A=t;B=((A-z>>2)+1|0)/-2|0;C=t+(B<<2)|0;D=x-A|0;A=D>>2;if(!A)E=t;else{Xac(C|0,t|0,D|0)|0;E=f[h>>2]|0}D=C+(A<<2)|0;f[e>>2]=D;f[h>>2]=E+(B<<2);F=D;break}D=w-z>>1;z=(D|0)==0?1:D;if(z>>>0>1073741823){G=10;break a}D=L5b(z<<2)|0;B=D;A=D+(z>>>2<<2)|0;C=A;H=D+(z<<2)|0;if((t|0)==(r|0)){I=C;J=y}else{y=A;A=C;z=t;do{f[y>>2]=f[z>>2];y=A+4|0;A=y;z=z+4|0}while((z|0)!=(r|0));I=A;J=f[a>>2]|0}f[a>>2]=B;f[h>>2]=C;f[e>>2]=I;f[k>>2]=H;if(!J)F=I;else{O5b(J);F=f[e>>2]|0}}else F=r;while(0);f[F>>2]=s;t=(f[e>>2]|0)+4|0;f[e>>2]=t;w=p+-1|0;if(!w){G=92;break}p=w;q=f[h>>2]|0;r=t}if((G|0)==10){r=ze(8)|0;T5b(r,477177);f[r>>2]=149528;If(r|0,25408,1411)}else if((G|0)==92){u=c;return}}r=a+12|0;q=f[r>>2]|0;p=q-(f[a>>2]|0)|0;F=o-i>>2;if(n>>>0<=((p>>2)-F|0)>>>0){b:do if((q|0)!=(o|0)){i=n;J=q;I=g;c:while(1){k=J;E=L5b(4096)|0;t=I;do if((I|0)==(k|0)){w=f[h>>2]|0;x=f[a>>2]|0;v=x;if(w>>>0>x>>>0){z=w;y=((z-v>>2)+1|0)/-2|0;D=w+(y<<2)|0;K=t-z|0;z=K>>2;if(!z)L=w;else{Xac(D|0,w|0,K|0)|0;L=f[h>>2]|0}K=D+(z<<2)|0;f[e>>2]=K;f[h>>2]=L+(y<<2);M=K;break}K=J-v>>1;v=(K|0)==0?1:K;if(v>>>0>1073741823){G=28;break c}K=L5b(v<<2)|0;y=K;z=K+(v>>>2<<2)|0;D=z;N=K+(v<<2)|0;if((w|0)==(k|0)){O=D;P=x}else{x=z;z=D;v=w;do{f[x>>2]=f[v>>2];x=z+4|0;z=x;v=v+4|0}while((v|0)!=(k|0));O=z;P=f[a>>2]|0}f[a>>2]=y;f[h>>2]=D;f[e>>2]=O;f[r>>2]=N;if(!P)M=O;else{O5b(P);M=f[e>>2]|0}}else M=I;while(0);f[M>>2]=E;I=(f[e>>2]|0)+4|0;f[e>>2]=I;k=i+-1|0;if(!k){G=20;break}J=f[r>>2]|0;if((J|0)==(I|0)){Q=k;G=21;break b}else i=k}if((G|0)==20){R=m;S=f[j>>2]|0;T=I;break}else if((G|0)==28){i=ze(8)|0;T5b(i,477177);f[i>>2]=149528;If(i|0,25408,1411)}}else{Q=n;G=21}while(0);if((G|0)==21){M=~(b>>>0>l>>>0?l:b);b=Q;do{l=L5b(4096)|0;f[d>>2]=l;J4(a,d);b=b+-1|0;U=f[e>>2]|0;V=(f[j>>2]|0)+1024+(((U-(f[h>>2]|0)|0)==4)<<31>>31)|0;f[j>>2]=V}while((b|0)!=0);R=Q+-1-M|0;S=V;T=U}f[j>>2]=S-(R<<10);if(!R){u=c;return}S=R;R=T;d:while(1){T=f[h>>2]|0;U=f[T>>2]|0;V=T+4|0;f[h>>2]=V;T=f[r>>2]|0;M=T;Q=R;do if((R|0)==(T|0)){b=f[a>>2]|0;l=b;if(V>>>0>b>>>0){P=V;O=((P-l>>2)+1|0)/-2|0;L=V+(O<<2)|0;g=Q-P|0;P=g>>2;if(!P)W=V;else{Xac(L|0,V|0,g|0)|0;W=f[h>>2]|0}g=L+(P<<2)|0;f[e>>2]=g;f[h>>2]=W+(O<<2);X=g;break}g=M-l>>1;l=(g|0)==0?1:g;if(l>>>0>1073741823){G=46;break d}g=L5b(l<<2)|0;O=g;P=g+(l>>>2<<2)|0;L=P;q=g+(l<<2)|0;if((V|0)==(R|0)){Y=L;Z=b}else{b=P;P=L;l=V;do{f[b>>2]=f[l>>2];b=P+4|0;P=b;l=l+4|0}while((l|0)!=(R|0));Y=P;Z=f[a>>2]|0}f[a>>2]=O;f[h>>2]=L;f[e>>2]=Y;f[r>>2]=q;if(!Z)X=Y;else{O5b(Z);X=f[e>>2]|0}}else X=R;while(0);f[X>>2]=U;R=(f[e>>2]|0)+4|0;f[e>>2]=R;S=S+-1|0;if(!S){G=92;break}}if((G|0)==46){S=ze(8)|0;T5b(S,477177);f[S>>2]=149528;If(S|0,25408,1411)}else if((G|0)==92){u=c;return}}S=m<<10;R=p>>1;p=F+n|0;X=R>>>0<p>>>0?p:R;R=F-m|0;f[d+12>>2]=0;f[d+16>>2]=a+12;do if(X)if(X>>>0>1073741823){F=ze(8)|0;T5b(F,477177);f[F>>2]=149528;If(F|0,25408,1411)}else{_=L5b(X<<2)|0;break}else _=0;while(0);f[d>>2]=_;F=_+(R<<2)|0;R=d+8|0;f[R>>2]=F;p=d+4|0;f[p>>2]=F;Z=d+12|0;f[Z>>2]=_+(X<<2);X=n;n=F;e:do{F=L5b(4096)|0;_=f[Z>>2]|0;Y=_;W=n;do if((n|0)==(_|0)){V=f[p>>2]|0;M=f[d>>2]|0;Q=M;if(V>>>0>M>>>0){T=V;I=V+((((T-Q>>2)+1|0)/-2|0)<<2)|0;l=W-T|0;T=l>>2;if(T|0)Xac(I|0,V|0,l|0)|0;l=I+(T<<2)|0;f[R>>2]=l;f[p>>2]=I;$=l;break}l=Y-Q>>1;Q=(l|0)==0?1:l;if(Q>>>0>1073741823){G=66;break e}l=L5b(Q<<2)|0;I=l;T=l+(Q>>>2<<2)|0;b=T;E=l+(Q<<2)|0;if((V|0)==(n|0))aa=b;else{Q=T;T=b;l=V;while(1){f[Q>>2]=f[l>>2];Q=T+4|0;V=Q;l=l+4|0;if((l|0)==(n|0)){aa=V;break}else T=V}}f[d>>2]=I;f[p>>2]=b;f[R>>2]=aa;f[Z>>2]=E;T=aa;if(!M)$=T;else{O5b(M);$=T}}else $=n;while(0);f[$>>2]=F;n=(f[R>>2]|0)+4|0;f[R>>2]=n;X=X+-1|0}while((X|0)!=0);if((G|0)==66){G=ze(8)|0;T5b(G,477177);f[G>>2]=149528;If(G|0,25408,1411)}f:do if(m|0){G=m;X=n;$=f[h>>2]|0;g:while(1){aa=f[Z>>2]|0;Y=aa;W=X;do if((X|0)==(aa|0)){_=f[p>>2]|0;U=f[d>>2]|0;T=U;if(_>>>0>U>>>0){l=_;Q=_+((((l-T>>2)+1|0)/-2|0)<<2)|0;q=W-l|0;l=q>>2;if(l|0)Xac(Q|0,_|0,q|0)|0;q=Q+(l<<2)|0;f[R>>2]=q;f[p>>2]=Q;ba=q;break}q=Y-T>>1;T=(q|0)==0?1:q;if(T>>>0>1073741823)break g;q=L5b(T<<2)|0;Q=q;l=q+(T>>>2<<2)|0;L=l;O=q+(T<<2)|0;if((_|0)==(X|0))ca=L;else{T=l;l=L;q=_;while(1){f[T>>2]=f[q>>2];T=l+4|0;_=T;q=q+4|0;if((q|0)==(X|0)){ca=_;break}else l=_}}f[d>>2]=Q;f[p>>2]=L;f[R>>2]=ca;f[Z>>2]=O;l=ca;if(!U)ba=l;else{O5b(U);ba=l}}else ba=X;while(0);f[ba>>2]=f[$>>2];X=(f[R>>2]|0)+4|0;f[R>>2]=X;$=(f[h>>2]|0)+4|0;f[h>>2]=$;G=G+-1|0;if(!G)break f}G=ze(8)|0;T5b(G,477177);f[G>>2]=149528;If(G|0,25408,1411)}while(0);ba=f[e>>2]|0;while(1){da=f[h>>2]|0;if((ba|0)==(da|0))break;ca=ba+-4|0;K4(d,ca);ba=ca}ca=da;da=f[a>>2]|0;f[a>>2]=f[d>>2];f[d>>2]=da;f[h>>2]=f[p>>2];f[p>>2]=ca;p=f[e>>2]|0;f[e>>2]=f[R>>2];f[R>>2]=p;e=f[r>>2]|0;f[r>>2]=f[Z>>2];f[Z>>2]=e;f[j>>2]=(f[j>>2]|0)-S;S=p;if((S|0)!=(ba|0))f[R>>2]=S+(~((S+-4-ca|0)>>>2)<<2);if(da|0)O5b(da);u=c;return}function T4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=c+4|0;g=f[e>>2]|0;h=f[b+4>>2]|0;if((g|0)!=(h|0)?(i=f[c>>2]|0,j=f[b>>2]|0,b=(g-(f[i>>2]|0)>>2)+(i-j<<8)-(h-(f[j>>2]|0)>>2)|0,(b|0)>0):0){j=b;b=f[c>>2]|0;h=g;while(1){if((h|0)==(f[b>>2]|0)){g=b+-4|0;f[c>>2]=g;i=(f[g>>2]|0)+4096|0;f[e>>2]=i;k=i;l=g}else{k=h;l=b}g=k+-4|0;f[e>>2]=g;i=f[l>>2]|0;m=k-i>>2;n=(m|0)>(j|0);o=n?k+(0-j<<2)|0:i;i=n?j:m;m=d;n=f[m>>2]|0;p=f[m+4>>2]|0;m=g;if((k|0)==(o|0)){q=n;r=p}else{s=o;t=k;u=n;n=p;while(1){p=u;v=u;w=n-(f[v>>2]|0)|0;x=w>>2;y=x+-1|0;if((w|0)>4){w=p+(y>>>10<<2)|0;z=(f[w>>2]|0)+((y&1023)<<2)|0;A=w}else{w=1024-x|0;x=p+(((w|0)/-1024|0)<<2)|0;z=(f[x>>2]|0)+(1023-((w|0)%1024|0)<<2)|0;A=x}x=z+4|0;w=x-(f[A>>2]|0)>>2;y=t;B=y-s>>2;C=(B|0)>(w|0);D=C?w:B;t=C?t+(0-w<<2)|0:o;w=y-t|0;y=w>>2;if(y|0)Xac(x+(0-y<<2)|0,t|0,w|0)|0;if(!D){E=u;F=n}else{w=(n-(f[v>>2]|0)>>2)-D|0;if((w|0)>0){D=p+(w>>>10<<2)|0;G=(f[D>>2]|0)+((w&1023)<<2)|0;H=D}else{D=1023-w|0;w=p+(((D|0)/-1024|0)<<2)|0;G=(f[w>>2]|0)+(1023-((D|0)%1024|0)<<2)|0;H=w}E=H;F=G}if((t|0)==(o|0)){q=E;r=F;break}else{u=E;n=F}}}n=d;f[n>>2]=q;f[n+4>>2]=r;j=j-i|0;n=i+-1|0;if(!n){I=l;J=g}else{u=(m-(f[l>>2]|0)>>2)-n|0;if((u|0)>0){n=l+(u>>>10<<2)|0;f[c>>2]=n;K=(f[n>>2]|0)+((u&1023)<<2)|0;L=n}else{n=1023-u|0;u=l+(((n|0)/-1024|0)<<2)|0;f[c>>2]=u;K=(f[u>>2]|0)+(1023-((n|0)%1024|0)<<2)|0;L=u}f[e>>2]=K;I=L;J=K}if((j|0)<=0){M=q;N=r;break}else{b=I;h=J}}O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}J=d;M=f[J>>2]|0;N=f[J+4>>2]|0;O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}function U4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=c+4|0;g=f[e>>2]|0;h=f[b+4>>2]|0;if((g|0)!=(h|0)?(i=f[c>>2]|0,j=f[b>>2]|0,b=(g-(f[i>>2]|0)>>2)+(i-j<<8)-(h-(f[j>>2]|0)>>2)|0,(b|0)>0):0){j=b;b=f[c>>2]|0;h=g;while(1){if((h|0)==(f[b>>2]|0)){g=b+-4|0;f[c>>2]=g;i=(f[g>>2]|0)+4096|0;f[e>>2]=i;k=i;l=g}else{k=h;l=b}g=k+-4|0;f[e>>2]=g;i=f[l>>2]|0;m=k-i>>2;n=(m|0)>(j|0);o=n?k+(0-j<<2)|0:i;i=n?j:m;m=d;n=f[m>>2]|0;p=f[m+4>>2]|0;m=g;if((k|0)==(o|0)){q=n;r=p}else{s=o;t=k;u=n;n=p;while(1){p=u;v=u;w=n-(f[v>>2]|0)|0;x=w>>2;y=x+-1|0;if((w|0)>4){w=p+(y>>>10<<2)|0;z=(f[w>>2]|0)+((y&1023)<<2)|0;A=w}else{w=1024-x|0;x=p+(((w|0)/-1024|0)<<2)|0;z=(f[x>>2]|0)+(1023-((w|0)%1024|0)<<2)|0;A=x}x=z+4|0;w=x-(f[A>>2]|0)>>2;y=t;B=y-s>>2;C=(B|0)>(w|0);D=C?w:B;t=C?t+(0-w<<2)|0:o;w=y-t|0;y=w>>2;if(y|0)Xac(x+(0-y<<2)|0,t|0,w|0)|0;if(!D){E=u;F=n}else{w=(n-(f[v>>2]|0)>>2)-D|0;if((w|0)>0){D=p+(w>>>10<<2)|0;G=(f[D>>2]|0)+((w&1023)<<2)|0;H=D}else{D=1023-w|0;w=p+(((D|0)/-1024|0)<<2)|0;G=(f[w>>2]|0)+(1023-((D|0)%1024|0)<<2)|0;H=w}E=H;F=G}if((t|0)==(o|0)){q=E;r=F;break}else{u=E;n=F}}}n=d;f[n>>2]=q;f[n+4>>2]=r;j=j-i|0;n=i+-1|0;if(!n){I=l;J=g}else{u=(m-(f[l>>2]|0)>>2)-n|0;if((u|0)>0){n=l+(u>>>10<<2)|0;f[c>>2]=n;K=(f[n>>2]|0)+((u&1023)<<2)|0;L=n}else{n=1023-u|0;u=l+(((n|0)/-1024|0)<<2)|0;f[c>>2]=u;K=(f[u>>2]|0)+(1023-((n|0)%1024|0)<<2)|0;L=u}f[e>>2]=K;I=L;J=K}if((j|0)<=0){M=q;N=r;break}else{b=I;h=J}}O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}J=d;M=f[J>>2]|0;N=f[J+4>>2]|0;O=a;P=O;f[P>>2]=M;Q=O+4|0;R=Q;f[R>>2]=N;return}function V4(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;i=u;u=u+352|0;j=i+344|0;k=i+336|0;l=i+328|0;m=i+272|0;n=i+216|0;o=i+160|0;p=i+136|0;q=i+80|0;r=i+72|0;s=i+24|0;t=i+16|0;v=i;dQ(j,52344);if((_L(a,-1)|0)!=2){f[k>>2]=0;f[k+4>>2]=0;w=aD(k,15)|0;x=237135;y=w+15|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,k,236650,236656,1038);bD(k)}if((BL(a,-1)|0)!=3?(BL(a,-1)|0)!=19:0){f[k>>2]=0;f[k+4>>2]=0;w=aD(k,114)|0;x=237151;y=w+114|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,k,236650,236656,1039);bD(k)}z=BL(c,-1)|0;if((z|0)!=(BL(a,-1)|0)){f[k>>2]=0;f[k+4>>2]=0;w=aD(k,24)|0;x=237266;y=w+24|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,k,236650,236656,1040);bD(k)}if(!(DM(a,c)|0)){f[k>>2]=0;f[k+4>>2]=0;w=aD(k,17)|0;x=237291;y=w+17|0;do{b[w>>0]=b[x>>0]|0;w=w+1|0;x=x+1|0}while((w|0)<(y|0));bO(-215,k,236650,236656,1041);bD(k)}x=e>g;A=x?e:g;B=x?g:e;AL(k,a,-1);f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];vM(d,l,0,-1,0,0);do if((yM(d)|0)==65536){l=f[d+4>>2]|0;f[m>>2]=f[l>>2];k=m+4|0;x=l+4|0;f[k>>2]=f[x>>2];z=m+8|0;f[z>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];C=f[l+36>>2]|0;f[m+36>>2]=C;f[m+40>>2]=z;z=m+48|0;D=m+44|0;f[D>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(C|0){z=C+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[x>>2]|0)<3){x=f[l+44>>2]|0;z=f[D>>2]|0;f[z>>2]=f[x>>2];f[z+4>>2]=f[x+4>>2];break}else{f[k>>2]=0;jL(m,l);break}}else yL(m,d,-1);while(0);do if((yM(a)|0)==65536){d=f[a+4>>2]|0;f[n>>2]=f[d>>2];l=n+4|0;k=d+4|0;f[l>>2]=f[k>>2];x=n+8|0;f[x>>2]=f[d+8>>2];f[n+12>>2]=f[d+12>>2];f[n+16>>2]=f[d+16>>2];f[n+20>>2]=f[d+20>>2];f[n+24>>2]=f[d+24>>2];f[n+28>>2]=f[d+28>>2];f[n+32>>2]=f[d+32>>2];z=f[d+36>>2]|0;f[n+36>>2]=z;f[n+40>>2]=x;x=n+48|0;D=n+44|0;f[D>>2]=x;f[x>>2]=0;f[n+52>>2]=0;if(z|0){x=z+12|0;f[x>>2]=(f[x>>2]|0)+1}if((f[k>>2]|0)<3){k=f[d+44>>2]|0;x=f[D>>2]|0;f[x>>2]=f[k>>2];f[x+4>>2]=f[k+4>>2];break}else{f[l>>2]=0;jL(n,d);break}}else yL(n,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[o>>2]=f[a>>2];d=o+4|0;l=a+4|0;f[d>>2]=f[l>>2];k=o+8|0;f[k>>2]=f[a+8>>2];f[o+12>>2]=f[a+12>>2];f[o+16>>2]=f[a+16>>2];f[o+20>>2]=f[a+20>>2];f[o+24>>2]=f[a+24>>2];f[o+28>>2]=f[a+28>>2];f[o+32>>2]=f[a+32>>2];x=f[a+36>>2]|0;f[o+36>>2]=x;f[o+40>>2]=k;k=o+48|0;D=o+44|0;f[D>>2]=k;f[k>>2]=0;f[o+52>>2]=0;if(x|0){k=x+12|0;f[k>>2]=(f[k>>2]|0)+1}if((f[l>>2]|0)<3){l=f[a+44>>2]|0;k=f[D>>2]|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];break}else{f[d>>2]=0;jL(o,a);break}}else yL(o,c,-1);while(0);if(h){e=B<32767.0?B:32767.0;g=A<32767.0?A:32767.0;E=e>0.0?e*e:e;if(g>0.0){F=g*g;G=E}else{F=g;G=E}}else{F=A;G=B}c=~~G;a=c-(+(c|0)>G&1)|0;c=~~F;d=c-(+(c|0)>F&1)|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;f[p+16>>2]=0;f[p+20>>2]=0;f[q>>2]=1124007936;c=q+4|0;l=q+8|0;k=q+40|0;w=c;y=w+36|0;do{f[w>>2]=0;w=w+4|0}while((w|0)<(y|0));f[k>>2]=l;l=q+48|0;w=q+44|0;f[w>>2]=l;f[l>>2]=0;f[q+52>>2]=0;y=SQ()|0;D=UQ()|0;x=(D|0)<(y|0)?D:y;y=(x|0)>1?x:1;x=n+8|0;D=f[x>>2]|0;if(((D|0)/(y|0)|0|0)<3){z=(D|0)/3|0;H=(z|0)>1?z:1}else H=y;f[r>>2]=0;f[r+4>>2]=D;W4(s,n,o,q,p,a,d,h);RQ(r,s,+(H|0));f[s>>2]=52192;OO(s+44|0);dQ(r,52364);r=f[q+12>>2]|0;H=p+20|0;h=f[H>>2]|0;if(h|0){d=p+16|0;a=p+4|0;D=p+8|0;y=0-r|0;z=~r;C=1-r|0;I=r+-1|0;J=r+1|0;K=h;while(1){h=f[d>>2]|0;L=K+-1|0;M=h+L|0;N=f[a>>2]|0;O=f[(f[N+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]|0;f[H>>2]=L;L=f[D>>2]|0;M=L-N|0;if((1-K-h+((M|0)==0?0:(M<<8)+-1|0)|0)>>>0>2047){O5b(f[L+-4>>2]|0);f[D>>2]=(f[D>>2]|0)+-4}L=O+y|0;if(!(b[O+z>>0]|0)){M=L+-1|0;b[M>>0]=2;h=f[a>>2]|0;N=(f[D>>2]|0)-h|0;P=f[d>>2]|0;Q=f[H>>2]|0;if((((N|0)==0?0:(N<<8)+-1|0)|0)==(Q+P|0)){F4(p);R=f[d>>2]|0;S=f[H>>2]|0;T=f[a>>2]|0}else{R=P;S=Q;T=h}h=S+R|0;f[(f[T+(h>>>10<<2)>>2]|0)+((h&1023)<<2)>>2]=M;f[H>>2]=S+1}if(!(b[L>>0]|0)){b[L>>0]=2;M=f[a>>2]|0;h=(f[D>>2]|0)-M|0;Q=f[d>>2]|0;P=f[H>>2]|0;if((((h|0)==0?0:(h<<8)+-1|0)|0)==(P+Q|0)){F4(p);U=f[d>>2]|0;V=f[H>>2]|0;W=f[a>>2]|0}else{U=Q;V=P;W=M}M=V+U|0;f[(f[W+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]=L;f[H>>2]=V+1}if(!(b[O+C>>0]|0)){L=O+y+1|0;b[L>>0]=2;M=f[a>>2]|0;P=(f[D>>2]|0)-M|0;Q=f[d>>2]|0;h=f[H>>2]|0;if((((P|0)==0?0:(P<<8)+-1|0)|0)==(h+Q|0)){F4(p);X=f[d>>2]|0;Z=f[H>>2]|0;_=f[a>>2]|0}else{X=Q;Z=h;_=M}M=Z+X|0;f[(f[_+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]=L;f[H>>2]=Z+1}L=O+-1|0;if(!(b[L>>0]|0)){b[L>>0]=2;M=f[a>>2]|0;h=(f[D>>2]|0)-M|0;Q=f[d>>2]|0;P=f[H>>2]|0;if((((h|0)==0?0:(h<<8)+-1|0)|0)==(P+Q|0)){F4(p);$=f[d>>2]|0;aa=f[H>>2]|0;ba=f[a>>2]|0}else{$=Q;aa=P;ba=M}M=aa+$|0;f[(f[ba+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]=L;f[H>>2]=aa+1}L=O+1|0;if(!(b[L>>0]|0)){b[L>>0]=2;M=f[a>>2]|0;P=(f[D>>2]|0)-M|0;Q=f[d>>2]|0;h=f[H>>2]|0;if((((P|0)==0?0:(P<<8)+-1|0)|0)==(h+Q|0)){F4(p);ca=f[d>>2]|0;da=f[H>>2]|0;ea=f[a>>2]|0}else{ca=Q;da=h;ea=M}M=da+ca|0;f[(f[ea+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]=L;f[H>>2]=da+1}L=O+r|0;if(!(b[O+I>>0]|0)){M=L+-1|0;b[M>>0]=2;h=f[a>>2]|0;Q=(f[D>>2]|0)-h|0;P=f[d>>2]|0;N=f[H>>2]|0;if((((Q|0)==0?0:(Q<<8)+-1|0)|0)==(N+P|0)){F4(p);fa=f[d>>2]|0;ga=f[H>>2]|0;ha=f[a>>2]|0}else{fa=P;ga=N;ha=h}h=ga+fa|0;f[(f[ha+(h>>>10<<2)>>2]|0)+((h&1023)<<2)>>2]=M;f[H>>2]=ga+1}if(!(b[L>>0]|0)){b[L>>0]=2;M=f[a>>2]|0;h=(f[D>>2]|0)-M|0;N=f[d>>2]|0;P=f[H>>2]|0;if((((h|0)==0?0:(h<<8)+-1|0)|0)==(P+N|0)){F4(p);ia=f[d>>2]|0;ja=f[H>>2]|0;ka=f[a>>2]|0}else{ia=N;ja=P;ka=M}M=ja+ia|0;f[(f[ka+(M>>>10<<2)>>2]|0)+((M&1023)<<2)>>2]=L;f[H>>2]=ja+1}if(!(b[O+J>>0]|0)){L=O+r+1|0;b[L>>0]=2;O=f[a>>2]|0;M=(f[D>>2]|0)-O|0;P=f[d>>2]|0;N=f[H>>2]|0;if((((M|0)==0?0:(M<<8)+-1|0)|0)==(N+P|0)){F4(p);la=f[d>>2]|0;ma=f[H>>2]|0;na=f[a>>2]|0}else{la=P;ma=N;na=O}O=ma+la|0;f[(f[na+(O>>>10<<2)>>2]|0)+((O&1023)<<2)>>2]=L;L=ma+1|0;f[H>>2]=L;oa=L}else oa=f[H>>2]|0;if(!oa)break;else K=oa}}dQ(s,52384);s=f[x>>2]|0;f[t>>2]=0;f[t+4>>2]=s;f[v>>2]=52252;f[v+4>>2]=q;f[v+8>>2]=m;x=n+4|0;oa=f[x>>2]|0;if((oa|0)<3)pa=Y(f[n+12>>2]|0,s)|0;else{s=f[n+40>>2]|0;K=0;H=1;while(1){ma=Y(f[s+(K<<2)>>2]|0,H)|0;K=K+1|0;if((K|0)==(oa|0)){pa=ma;break}else H=ma}}RQ(t,v,+(pa>>>0)*.0000152587890625);pa=q+36|0;v=f[pa>>2]|0;if(v|0?(t=v+12|0,v=f[t>>2]|0,f[t>>2]=v+-1,(v|0)==1):0)kL(q);f[pa>>2]=0;pa=q+16|0;f[pa>>2]=0;f[pa+4>>2]=0;f[pa+8>>2]=0;f[pa+12>>2]=0;if((f[c>>2]|0)>0){pa=f[k>>2]|0;k=0;do{f[pa+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[c>>2]|0))}c=f[w>>2]|0;if((c|0)!=(l|0))UC(c);G4(p);p=o+36|0;c=f[p>>2]|0;if(c|0?(l=c+12|0,c=f[l>>2]|0,f[l>>2]=c+-1,(c|0)==1):0)kL(o);f[p>>2]=0;p=o+16|0;c=o+4|0;f[p>>2]=0;f[p+4>>2]=0;f[p+8>>2]=0;f[p+12>>2]=0;if((f[c>>2]|0)>0){p=f[o+40>>2]|0;l=0;do{f[p+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[c>>2]|0))}c=f[o+44>>2]|0;if((c|0)!=(o+48|0))UC(c);c=n+36|0;o=f[c>>2]|0;do if(o|0){l=o+12|0;p=f[l>>2]|0;f[l>>2]=p+-1;if((p|0)!=1)break;kL(n)}while(0);f[c>>2]=0;c=n+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[x>>2]|0)>0){c=f[n+40>>2]|0;o=0;do{f[c+(o<<2)>>2]=0;o=o+1|0}while((o|0)<(f[x>>2]|0))}x=f[n+44>>2]|0;if((x|0)!=(n+48|0))UC(x);x=m+36|0;n=f[x>>2]|0;do if(n|0){o=n+12|0;c=f[o>>2]|0;f[o>>2]=c+-1;if((c|0)!=1)break;kL(m)}while(0);f[x>>2]=0;x=m+16|0;n=m+4|0;f[x>>2]=0;f[x+4>>2]=0;f[x+8>>2]=0;f[x+12>>2]=0;if((f[n>>2]|0)>0){x=f[m+40>>2]|0;c=0;do{f[x+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[n>>2]|0))}n=f[m+44>>2]|0;if((n|0)!=(m+48|0))UC(n);if(!(f[j+4>>2]|0)){u=i;return}u=i;return}function W4(a,c,d,e,g,h,i,j){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=u;u=u+144|0;l=k+120|0;m=k;n=k+64|0;o=k+8|0;f[a>>2]=52192;q=a+4|0;f[q>>2]=c;f[a+8>>2]=d;d=a+12|0;f[d>>2]=e;f[a+16>>2]=g;f[a+20>>2]=h;f[a+24>>2]=i;f[a+28>>2]=0;b[a+32>>0]=j&1;NO(a+44|0);j=f[q>>2]|0;i=(f[j+8>>2]|0)+2|0;h=(f[j+12>>2]|0)+2|0;j=e+4|0;if(!(((((f[j>>2]|0)<3?(f[e+8>>2]|0)==(i|0):0)?(f[e+12>>2]|0)==(h|0):0)?(f[e>>2]&4095|0)==0:0)?(f[e+16>>2]|0)!=0:0)){f[l>>2]=i;f[l+4>>2]=h;hL(e,2,l,0)}h=f[d>>2]|0;if((h|0)==(e|0))r=e;else{i=e+36|0;g=f[i>>2]|0;if(g|0){c=g+12|0;f[c>>2]=(f[c>>2]|0)+1}c=h+36|0;g=f[c>>2]|0;if(g|0?(s=g+12|0,g=f[s>>2]|0,f[s>>2]=g+-1,(g|0)==1):0)kL(h);f[c>>2]=0;g=h+16|0;s=h+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[s>>2]|0)>0){t=f[h+40>>2]|0;v=0;do{f[t+(v<<2)>>2]=0;v=v+1|0;w=f[s>>2]|0}while((v|0)<(w|0));f[h>>2]=f[e>>2];if((w|0)<3)x=18;else x=20}else{f[h>>2]=f[e>>2];x=18}if((x|0)==18){w=f[j>>2]|0;if((w|0)<3){f[s>>2]=w;f[h+8>>2]=f[e+8>>2];f[h+12>>2]=f[e+12>>2];w=f[e+44>>2]|0;s=f[h+44>>2]|0;f[s>>2]=f[w>>2];f[s+4>>2]=f[w+4>>2]}else x=20}if((x|0)==20)jL(h,e);f[g>>2]=f[e+16>>2];f[h+20>>2]=f[e+20>>2];f[h+24>>2]=f[e+24>>2];f[h+28>>2]=f[e+28>>2];f[h+32>>2]=f[e+32>>2];f[c>>2]=f[i>>2];r=f[d>>2]|0}f[l>>2]=0;f[l+4>>2]=1;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;lL(n,r,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;VP(n,l,UM()|0)|0;r=n+36|0;i=f[r>>2]|0;if(i|0?(c=i+12|0,i=f[c>>2]|0,f[c>>2]=i+-1,(i|0)==1):0)kL(n);f[r>>2]=0;r=n+16|0;i=n+4|0;f[r>>2]=0;f[r+4>>2]=0;f[r+8>>2]=0;f[r+12>>2]=0;if((f[i>>2]|0)>0){r=f[n+40>>2]|0;c=0;do{f[r+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[i>>2]|0))}i=f[n+44>>2]|0;if((i|0)!=(n+48|0))UC(i);i=f[d>>2]|0;n=f[(f[q>>2]|0)+8>>2]|0;f[l>>2]=n+1;f[l+4>>2]=n+2;f[m>>2]=-2147483648;f[m+4>>2]=2147483647;lL(o,i,l,m);p[m>>3]=1.0;f[l>>2]=-1056833530;f[l+4>>2]=m;f[l+8>>2]=1;f[l+12>>2]=1;VP(o,l,UM()|0)|0;l=o+36|0;m=f[l>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)kL(o);f[l>>2]=0;l=o+16|0;m=o+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[m>>2]|0)>0){l=f[o+40>>2]|0;i=0;do{f[l+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[m>>2]|0))}m=f[o+44>>2]|0;if((m|0)==(o+48|0)){y=f[d>>2]|0;z=y+12|0;A=f[z>>2]|0;B=a+36|0;f[B>>2]=A;C=a+33|0;b[C>>0]=0;D=f[q>>2]|0;E=f[D>>2]|0;F=E>>>3;G=F&511;H=G+1|0;I=a+40|0;f[I>>2]=H;u=k;return}UC(m);y=f[d>>2]|0;z=y+12|0;A=f[z>>2]|0;B=a+36|0;f[B>>2]=A;C=a+33|0;b[C>>0]=0;D=f[q>>2]|0;E=f[D>>2]|0;F=E>>>3;G=F&511;H=G+1|0;I=a+40|0;f[I>>2]=H;u=k;return}function X4(a,c,d,e,g){a=a|0;c=c|0;d=+d;e=+e;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+144|0;i=h+88|0;j=h+32|0;k=h+16|0;l=h;tL(i,a,0,1,0,0);tL(j,c,0,1,0,0);c=i+40|0;a=f[c>>2]|0;m=f[a+-4>>2]|0;n=j+40|0;o=f[n>>2]|0;a:do if((m|0)==(f[o+-4>>2]|0)){if((m|0)==2){if((f[a>>2]|0)!=(f[o>>2]|0)){p=10;break}if((f[a+4>>2]|0)!=(f[o+4>>2]|0)){p=10;break}}else if((m|0)>0){q=0;do{if((f[a+(q<<2)>>2]|0)!=(f[o+(q<<2)>>2]|0)){p=10;break a}q=q+1|0}while((q|0)<(m|0))}if(!((f[i>>2]&7|0)==0?!(f[j>>2]&4095|0):0))p=10}else p=10;while(0);if((p|0)==10){f[k>>2]=0;f[k+4>>2]=0;p=aD(k,59)|0;m=237383;o=p+59|0;do{b[p>>0]=b[m>>0]|0;p=p+1|0;m=m+1|0}while((p|0)<(o|0));bO(-215,k,237443,236656,1110);bD(k)}f[k+8>>2]=0;f[k+12>>2]=0;f[k>>2]=16842752;f[k+4>>2]=i;m=l+8|0;f[m>>2]=0;f[m+4>>2]=0;f[l>>2]=33619968;f[l+4>>2]=j;D4(k,l,d,e,g&255,(g|0)<0);g=j+36|0;l=f[g>>2]|0;if(l|0?(k=l+12|0,l=f[k>>2]|0,f[k>>2]=l+-1,(l|0)==1):0)kL(j);f[g>>2]=0;g=j+16|0;l=j+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[l>>2]|0)>0){g=f[n>>2]|0;n=0;do{f[g+(n<<2)>>2]=0;n=n+1|0}while((n|0)<(f[l>>2]|0))}l=f[j+44>>2]|0;if((l|0)!=(j+48|0))UC(l);l=i+36|0;j=f[l>>2]|0;if(j|0?(n=j+12|0,j=f[n>>2]|0,f[n>>2]=j+-1,(j|0)==1):0)kL(i);f[l>>2]=0;l=i+16|0;j=i+4|0;f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;if((f[j>>2]|0)>0){l=f[c>>2]|0;c=0;do{f[l+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[j>>2]|0))}j=f[i+44>>2]|0;if((j|0)==(i+48|0)){u=h;return}UC(j);u=h;return}function Y4(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=u;u=u+16|0;i=h;j=h+8|0;k=c&7;l=d&7;if((d^c)&4088|0){f[j>>2]=0;f[j+4>>2]=0;m=aD(j,90)|0;n=237451;o=m+90|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,j,237542,237558,1302);bD(j)}n=(g|0)<0?(e|0)/2|0:g;g=(k|0)==0;m=(l|0)==4;if(g&m){o=L5b(12)|0;a8(o);f[o>>2]=52412;f[o+4>>2]=e;f[o+8>>2]=n;p=L5b(16)|0;q=p+4|0;f[q>>2]=1;f[p>>2]=52432;f[p+8>>2]=o;f[a>>2]=p;f[a+4>>2]=o;f[q>>2]=(f[q>>2]|0)+1;o=f[q>>2]|0;f[q>>2]=o+-1;if((o|0)!=1){u=h;return}bi[f[(f[p>>2]|0)+8>>2]&2047](p);u=h;return}if(g&(l|0)==2){p=L5b(12)|0;a8(p);f[p>>2]=52452;f[p+4>>2]=e;f[p+8>>2]=n;o=L5b(16)|0;q=o+4|0;f[q>>2]=1;f[o>>2]=52472;f[o+8>>2]=p;f[a>>2]=o;f[a+4>>2]=p;f[q>>2]=(f[q>>2]|0)+1;p=f[q>>2]|0;f[q>>2]=p+-1;if((p|0)!=1){u=h;return}bi[f[(f[o>>2]|0)+8>>2]&2047](o);u=h;return}o=(l|0)==6;if(g&o){g=L5b(12)|0;a8(g);f[g>>2]=52492;f[g+4>>2]=e;f[g+8>>2]=n;l=L5b(16)|0;p=l+4|0;f[p>>2]=1;f[l>>2]=52512;f[l+8>>2]=g;f[a>>2]=l;f[a+4>>2]=g;f[p>>2]=(f[p>>2]|0)+1;g=f[p>>2]|0;f[p>>2]=g+-1;if((g|0)!=1){u=h;return}bi[f[(f[l>>2]|0)+8>>2]&2047](l);u=h;return}l=(k|0)==2;if(l&m){g=L5b(12)|0;a8(g);f[g>>2]=52532;f[g+4>>2]=e;f[g+8>>2]=n;p=L5b(16)|0;q=p+4|0;f[q>>2]=1;f[p>>2]=52552;f[p+8>>2]=g;f[a>>2]=p;f[a+4>>2]=g;f[q>>2]=(f[q>>2]|0)+1;g=f[q>>2]|0;f[q>>2]=g+-1;if((g|0)!=1){u=h;return}bi[f[(f[p>>2]|0)+8>>2]&2047](p);u=h;return}if(l&o){l=L5b(12)|0;a8(l);f[l>>2]=52572;f[l+4>>2]=e;f[l+8>>2]=n;p=L5b(16)|0;g=p+4|0;f[g>>2]=1;f[p>>2]=52592;f[p+8>>2]=l;f[a>>2]=p;f[a+4>>2]=l;f[g>>2]=(f[g>>2]|0)+1;l=f[g>>2]|0;f[g>>2]=l+-1;if((l|0)!=1){u=h;return}bi[f[(f[p>>2]|0)+8>>2]&2047](p);u=h;return}p=(k|0)==3;if(p&m){l=L5b(12)|0;a8(l);f[l>>2]=52612;f[l+4>>2]=e;f[l+8>>2]=n;g=L5b(16)|0;q=g+4|0;f[q>>2]=1;f[g>>2]=52632;f[g+8>>2]=l;f[a>>2]=g;f[a+4>>2]=l;f[q>>2]=(f[q>>2]|0)+1;l=f[q>>2]|0;f[q>>2]=l+-1;if((l|0)!=1){u=h;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}if((k|0)==4&m){m=L5b(12)|0;a8(m);f[m>>2]=52652;f[m+4>>2]=e;f[m+8>>2]=n;g=L5b(16)|0;l=g+4|0;f[l>>2]=1;f[g>>2]=52672;f[g+8>>2]=m;f[a>>2]=g;f[a+4>>2]=m;f[l>>2]=(f[l>>2]|0)+1;m=f[l>>2]|0;f[l>>2]=m+-1;if((m|0)!=1){u=h;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}if(p&o){p=L5b(12)|0;a8(p);f[p>>2]=52692;f[p+4>>2]=e;f[p+8>>2]=n;g=L5b(16)|0;m=g+4|0;f[m>>2]=1;f[g>>2]=52712;f[g+8>>2]=p;f[a>>2]=g;f[a+4>>2]=p;f[m>>2]=(f[m>>2]|0)+1;p=f[m>>2]|0;f[m>>2]=p+-1;if((p|0)!=1){u=h;return}bi[f[(f[g>>2]|0)+8>>2]&2047](g);u=h;return}if((k|0)==5&o){g=L5b(12)|0;a8(g);f[g>>2]=52732;f[g+4>>2]=e;f[g+8>>2]=n;p=L5b(16)|0;m=p+4|0;f[m>>2]=1;f[p>>2]=52752;f[p+8>>2]=g;f[a>>2]=p;f[a+4>>2]=g;f[m>>2]=(f[m>>2]|0)+1;g=f[m>>2]|0;f[m>>2]=g+-1;if((g|0)!=1){u=h;return}bi[f[(f[p>>2]|0)+8>>2]&2047](p);u=h;return}if(!((k|0)==6&o)){f[i>>2]=c;f[i+4>>2]=d;hO(j,242629,i);bO(-213,j,237542,237558,1330);bD(j);f[a>>2]=0;f[a+4>>2]=0;u=h;return}j=L5b(12)|0;a8(j);f[j>>2]=52772;f[j+4>>2]=e;f[j+8>>2]=n;n=L5b(16)|0;e=n+4|0;f[e>>2]=1;f[n>>2]=52792;f[n+8>>2]=j;f[a>>2]=n;f[a+4>>2]=j;f[e>>2]=(f[e>>2]|0)+1;j=f[e>>2]|0;f[e>>2]=j+-1;if((j|0)!=1){u=h;return}bi[f[(f[n>>2]|0)+8>>2]&2047](n);u=h;return}function Z4(a){a=a|0;O5b(a);return}function _4(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function $4(a){a=a|0;O5b(a);return}function a5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0,L=0;g=f[a+4>>2]|0;a=Y(g,e)|0;h=Y(d+-1|0,e)|0;switch(g|0){case 3:{g=Y(e,d)|0;if((g|0)<=0)return;i=e<<1;j=0;do{p[c+(j<<3)>>3]=+p[b+(j<<3)>>3]+ +p[b+(j+e<<3)>>3]+ +p[b+(j+i<<3)>>3];j=j+1|0}while((j|0)!=(g|0));return}case 5:{g=Y(e,d)|0;if((g|0)<=0)return;d=e<<1;j=e*3|0;i=e<<2;k=0;do{p[c+(k<<3)>>3]=+p[b+(k<<3)>>3]+ +p[b+(k+e<<3)>>3]+ +p[b+(k+d<<3)>>3]+ +p[b+(k+j<<3)>>3]+ +p[b+(k+i<<3)>>3];k=k+1|0}while((k|0)!=(g|0));return}default:switch(e|0){case 1:{if((a|0)>0){l=0.0;g=0;while(1){m=l+ +p[b+(g<<3)>>3];g=g+1|0;if((g|0)==(a|0)){n=m;break}else l=m}}else n=0.0;p[c>>3]=n;if((h|0)>0){o=n;q=0}else return;do{o=o+(+p[b+(q+a<<3)>>3]-+p[b+(q<<3)>>3]);q=q+1|0;p[c+(q<<3)>>3]=o}while((q|0)!=(h|0));return}case 3:{if((a|0)>0){o=0.0;n=0.0;l=0.0;q=0;while(1){m=l+ +p[b+(q<<3)>>3];r=n+ +p[b+(q+1<<3)>>3];s=o+ +p[b+(q+2<<3)>>3];q=q+3|0;if((q|0)>=(a|0)){t=s;u=r;v=m;break}else{o=s;n=r;l=m}}}else{t=0.0;u=0.0;v=0.0}p[c>>3]=v;p[c+8>>3]=u;p[c+16>>3]=t;if((h|0)>0){w=t;x=u;y=v;z=0}else return;do{q=z+a|0;y=y+(+p[b+(q<<3)>>3]-+p[b+(z<<3)>>3]);x=x+(+p[b+(q+1<<3)>>3]-+p[b+(z+1<<3)>>3]);w=w+(+p[b+(q+2<<3)>>3]-+p[b+(z+2<<3)>>3]);q=z;z=z+3|0;p[c+(z<<3)>>3]=y;p[c+(q+4<<3)>>3]=x;p[c+(q+5<<3)>>3]=w}while((z|0)<(h|0));return}case 4:{if((a|0)>0){w=0.0;x=0.0;y=0.0;v=0.0;z=0;while(1){u=v+ +p[b+(z<<3)>>3];t=y+ +p[b+((z|1)<<3)>>3];l=x+ +p[b+((z|2)<<3)>>3];n=w+ +p[b+((z|3)<<3)>>3];z=z+4|0;if((z|0)>=(a|0)){A=n;B=l;C=t;D=u;break}else{w=n;x=l;y=t;v=u}}}else{A=0.0;B=0.0;C=0.0;D=0.0}p[c>>3]=D;p[c+8>>3]=C;p[c+16>>3]=B;p[c+24>>3]=A;if((h|0)>0){E=A;F=B;G=C;H=D;I=0}else return;do{z=I+a|0;H=H+(+p[b+(z<<3)>>3]-+p[b+(I<<3)>>3]);G=G+(+p[b+(z+1<<3)>>3]-+p[b+((I|1)<<3)>>3]);F=F+(+p[b+(z+2<<3)>>3]-+p[b+((I|2)<<3)>>3]);E=E+(+p[b+(z+3<<3)>>3]-+p[b+((I|3)<<3)>>3]);z=I;I=I+4|0;p[c+(I<<3)>>3]=H;p[c+(z+5<<3)>>3]=G;p[c+(z+6<<3)>>3]=F;p[c+(z+7<<3)>>3]=E}while((I|0)<(h|0));return}default:{if((e|0)<=0)return;I=(h|0)>0;if((a|0)>0){z=0;q=c;g=b;while(1){E=0.0;k=0;do{E=E+ +p[g+(k<<3)>>3];k=k+e|0}while((k|0)<(a|0));p[q>>3]=E;if(I){F=E;k=0;do{F=F+(+p[g+(k+a<<3)>>3]-+p[g+(k<<3)>>3]);k=k+e|0;p[q+(k<<3)>>3]=F}while((k|0)<(h|0))}z=z+1|0;if((z|0)==(e|0))break;else{q=q+8|0;g=g+8|0}}return}if(I){J=0;K=c;L=b}else{Nac(c|0,0,e<<3|0)|0;return}while(1){p[K>>3]=0.0;F=0.0;c=0;do{F=F+(+p[L+(c+a<<3)>>3]-+p[L+(c<<3)>>3]);c=c+e|0;p[K+(c<<3)>>3]=F}while((c|0)<(h|0));J=J+1|0;if((J|0)==(e|0))break;else{K=K+8|0;L=L+8|0}}return}}}}function b5(a){a=a|0;O5b(a);return}function c5(a){a=a|0;var b=0;b=f[a+8>>2]|0;if(b|0)bi[f[(f[b>>2]|0)+4>>2]&2047](b);bi[f[(f[a>>2]|0)+4>>2]&2047](a);return}function d5(a){a=a|0;O5b(a);return}
function b3(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0.0,J=0.0,K=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,X=0.0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0.0;e=u;u=u+288|0;g=e+280|0;h=e+224|0;i=e+168|0;j=e+152|0;k=e+40|0;l=e+8|0;m=e;dQ(g,51724);do if((yM(a)|0)==65536){o=f[a+4>>2]|0;f[h>>2]=f[o>>2];p=h+4|0;q=o+4|0;f[p>>2]=f[q>>2];r=h+8|0;f[r>>2]=f[o+8>>2];f[h+12>>2]=f[o+12>>2];f[h+16>>2]=f[o+16>>2];f[h+20>>2]=f[o+20>>2];f[h+24>>2]=f[o+24>>2];f[h+28>>2]=f[o+28>>2];f[h+32>>2]=f[o+32>>2];s=f[o+36>>2]|0;f[h+36>>2]=s;f[h+40>>2]=r;r=h+48|0;t=h+44|0;f[t>>2]=r;f[r>>2]=0;f[h+52>>2]=0;if(s|0){r=s+12|0;f[r>>2]=(f[r>>2]|0)+1}if((f[q>>2]|0)<3){q=f[o+44>>2]|0;r=f[t>>2]|0;f[r>>2]=f[q>>2];f[r+4>>2]=f[q+4>>2];break}else{f[p>>2]=0;jL(h,o);break}}else yL(h,a,-1);while(0);do if((yM(c)|0)==65536){a=f[c+4>>2]|0;f[i>>2]=f[a>>2];o=i+4|0;p=a+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[a+8>>2];f[i+12>>2]=f[a+12>>2];f[i+16>>2]=f[a+16>>2];f[i+20>>2]=f[a+20>>2];f[i+24>>2]=f[a+24>>2];f[i+28>>2]=f[a+28>>2];f[i+32>>2]=f[a+32>>2];r=f[a+36>>2]|0;f[i+36>>2]=r;f[i+40>>2]=q;q=i+48|0;t=i+44|0;f[t>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[a+44>>2]|0;q=f[t>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];break}else{f[o>>2]=0;jL(i,a);break}}else yL(i,c,-1);while(0);f[j>>2]=h;f[j+4>>2]=i;f[j+8>>2]=0;f[k>>2]=1124007936;c=k+8|0;a=k+40|0;o=k+4|0;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[a>>2]=c;c=k+48|0;f[k+44>>2]=c;f[c>>2]=0;f[k+52>>2]=0;f[k+56>>2]=1124007936;c=k+64|0;a=k+96|0;o=k+60|0;p=o+36|0;do{f[o>>2]=0;o=o+4|0}while((o|0)<(p|0));f[a>>2]=c;c=k+104|0;f[k+100>>2]=c;f[c>>2]=0;f[k+108>>2]=0;QN(l,j,k,-1);j=f[h>>2]|0;if(!((j&7|0)==5?((f[i>>2]^j)&4095|0)==0:0)){f[m>>2]=0;f[m+4>>2]=0;o=aD(m,41)|0;v=233675;p=o+41|0;do{b[o>>0]=b[v>>0]|0;o=o+1|0;v=v+1|0}while((o|0)<(p|0));bO(-215,m,233717,231932,2514);bD(m)}j=l+4|0;c=f[j>>2]|0;if(!((f[c>>2]&16384|0)!=0?(f[c+56>>2]&16384|0)!=0:0)){f[m>>2]=0;f[m+4>>2]=0;o=aD(m,58)|0;v=233729;p=o+58|0;do{b[o>>0]=b[v>>0]|0;o=o+1|0;v=v+1|0}while((o|0)<(p|0));bO(-215,m,233717,231932,2518);bD(m)}c=l+16|0;a=(d|0)==1;q=m+4|0;w=0.0;x=0.0;y=0.0;z=0.0;A=0.0;B=0.0;t=0;while(1){if(t>>>0>=(f[c>>2]|0)>>>0)break;r=f[j>>2]|0;s=f[r+16>>2]|0;C=f[r+72>>2]|0;D=Y(f[r+12>>2]|0,f[r+8>>2]|0)|0;r=Y(D,((f[h>>2]|0)>>>3&511)+1|0)|0;switch(d|0){case 1:case 4:{if((r|0)>0)if(a){D=0;E=w;while(1){F=+n[s+(D<<2)>>2];G=F-+n[C+(D<<2)>>2];H=+L(+F)>2.220446049250313e-16;I=H?E+G*G/F:E;D=D+1|0;if((D|0)==(r|0)){J=z;K=A;N=B;O=x;P=y;Q=I;break}else E=I}}else{D=0;E=w;while(1){I=+n[s+(D<<2)>>2];F=+n[C+(D<<2)>>2];G=I-F;R=I+F;H=+L(+R)>2.220446049250313e-16;F=H?E+G*G/R:E;D=D+1|0;if((D|0)==(r|0)){J=z;K=A;N=B;O=x;P=y;Q=F;break}else E=F}}else{J=z;K=A;N=B;O=x;P=y;Q=w}break}case 0:{if((r|0)>0){D=0;E=x;F=y;R=z;G=A;I=B;while(1){S=+n[s+(D<<2)>>2];T=+n[C+(D<<2)>>2];U=G+S*T;V=E+S;X=R+S*S;S=F+T;Z=I+T*T;D=D+1|0;if((D|0)==(r|0)){J=X;K=U;N=Z;O=V;P=S;Q=w;break}else{E=V;F=S;R=X;G=U;I=Z}}}else{J=z;K=A;N=B;O=x;P=y;Q=w}break}case 2:{if((r|0)>0){D=0;I=w;while(1){G=+n[C+(D<<2)>>2];R=+n[s+(D<<2)>>2];F=I+(G<R?G:R);D=D+1|0;if((D|0)==(r|0)){J=z;K=A;N=B;O=x;P=y;Q=F;break}else I=F}}else{J=z;K=A;N=B;O=x;P=y;Q=w}break}case 3:{if((r|0)>0){I=x;F=y;D=0;R=w;while(1){G=+n[s+(D<<2)>>2];E=+n[C+(D<<2)>>2];Z=R+ +M(+(G*E));U=I+G;G=F+E;D=D+1|0;if((D|0)==(r|0)){J=z;K=A;N=B;O=U;P=G;Q=Z;break}else{I=U;F=G;R=Z}}}else{J=z;K=A;N=B;O=x;P=y;Q=w}break}case 5:{if((r|0)>0){D=0;R=w;while(1){F=+n[s+(D<<2)>>2];I=F;Z=+n[C+(D<<2)>>2];if(!(+L(+F)<=2.220446049250313e-16)){H=!(+L(+Z)<=2.220446049250313e-16);_=R+I*+W(+(I/(H?Z:1.0e-10)))}else _=R;D=D+1|0;if((D|0)==(r|0)){J=z;K=A;N=B;O=x;P=y;Q=_;break}else R=_}}else{J=z;K=A;N=B;O=x;P=y;Q=w}break}default:{f[m>>2]=0;f[q>>2]=0;o=aD(m,25)|0;v=241550;p=o+25|0;do{b[o>>0]=b[v>>0]|0;o=o+1|0;v=v+1|0}while((o|0)<(p|0));bO(-5,m,233717,231932,2687);bD(m);J=z;K=A;N=B;O=x;P=y;Q=w}}aL(l)|0;w=Q;x=O;y=P;z=J;A=K;B=N;t=t+1|0}switch(d|0){case 4:{$=w*2.0;break}case 0:{d=f[h+4>>2]|0;if((d|0)<3)aa=Y(f[h+12>>2]|0,f[h+8>>2]|0)|0;else{t=f[h+40>>2]|0;l=0;m=1;while(1){v=Y(f[t+(l<<2)>>2]|0,m)|0;l=l+1|0;if((l|0)==(d|0)){aa=v;break}else m=v}}N=1.0/+(aa>>>0);K=(z-x*x*N)*(B-y*y*N);if(+L(+K)>2.220446049250313e-16)$=(A-y*x*N)/+M(+K);else $=1.0;break}case 3:{K=y*x;if(+L(+K)>1.1920928955078125e-07)ba=1.0/+M(+K);else ba=1.0;K=1.0-w*ba;$=+M(+(K<0.0?0.0:K));break}default:$=w}aa=k+56|0;m=k+92|0;d=f[m>>2]|0;if(d|0?(l=d+12|0,d=f[l>>2]|0,f[l>>2]=d+-1,(d|0)==1):0)kL(aa);f[m>>2]=0;m=k+72|0;aa=k+60|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[aa>>2]|0)>0){m=f[k+96>>2]|0;d=0;do{f[m+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[aa>>2]|0))}aa=f[k+100>>2]|0;if((aa|0)!=(k+104|0))UC(aa);aa=k+36|0;d=f[aa>>2]|0;if(d|0?(m=d+12|0,d=f[m>>2]|0,f[m>>2]=d+-1,(d|0)==1):0)kL(k);f[aa>>2]=0;aa=k+16|0;d=k+4|0;f[aa>>2]=0;f[aa+4>>2]=0;f[aa+8>>2]=0;f[aa+12>>2]=0;if((f[d>>2]|0)>0){aa=f[k+40>>2]|0;m=0;do{f[aa+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[d>>2]|0))}d=f[k+44>>2]|0;if((d|0)!=(k+48|0))UC(d);d=i+36|0;k=f[d>>2]|0;if(k|0?(m=k+12|0,k=f[m>>2]|0,f[m>>2]=k+-1,(k|0)==1):0)kL(i);f[d>>2]=0;d=i+16|0;k=i+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[k>>2]|0)>0){d=f[i+40>>2]|0;m=0;do{f[d+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)!=(i+48|0))UC(k);k=h+36|0;i=f[k>>2]|0;if(i|0?(m=i+12|0,i=f[m>>2]|0,f[m>>2]=i+-1,(i|0)==1):0)kL(h);f[k>>2]=0;k=h+16|0;i=h+4|0;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;if((f[i>>2]|0)>0){k=f[h+40>>2]|0;m=0;do{f[k+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)!=(h+48|0))UC(i);if(!(f[g+4>>2]|0)){u=e;return +$}u=e;return +$}function c3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0;d=u;u=u+2256|0;e=d+2240|0;g=d+2184|0;h=d+2176|0;i=d+2120|0;j=d+2112|0;k=d+1088|0;l=d+64|0;m=d+48|0;n=d+32|0;o=d+24|0;q=d+8|0;r=d;dQ(e,51744);if(BL(a,-1)|0){f[g>>2]=0;f[g+4>>2]=0;s=aD(g,56)|0;t=233840;v=s+56|0;do{b[s>>0]=b[t>>0]|0;s=s+1|0;t=t+1|0}while((s|0)<(v|0));bO(-215,g,233897,231932,3913);bD(g)}if(!(HM(a)|0)){do if((yM(a)|0)==65536){t=f[a+4>>2]|0;f[g>>2]=f[t>>2];s=g+4|0;v=t+4|0;f[s>>2]=f[v>>2];w=g+8|0;f[w>>2]=f[t+8>>2];f[g+12>>2]=f[t+12>>2];f[g+16>>2]=f[t+16>>2];f[g+20>>2]=f[t+20>>2];f[g+24>>2]=f[t+24>>2];f[g+28>>2]=f[t+28>>2];f[g+32>>2]=f[t+32>>2];x=f[t+36>>2]|0;f[g+36>>2]=x;y=g+40|0;f[y>>2]=w;w=g+48|0;z=g+44|0;f[z>>2]=w;f[w>>2]=0;f[g+52>>2]=0;if(x|0){w=x+12|0;f[w>>2]=(f[w>>2]|0)+1}if((f[v>>2]|0)<3){v=f[t+44>>2]|0;w=f[z>>2]|0;f[w>>2]=f[v>>2];f[w+4>>2]=f[v+4>>2];A=g;B=y;break}else{f[s>>2]=0;jL(g,t);A=g;B=y;break}}else{yL(g,a,-1);A=g;B=g+40|0}while(0);a=f[B>>2]|0;y=f[a>>2]|0;f[h>>2]=f[a+4>>2];f[h+4>>2]=y;vM(c,h,f[A>>2]&4095,-1,0,0);do if((yM(c)|0)==65536){A=f[c+4>>2]|0;f[i>>2]=f[A>>2];h=i+4|0;y=A+4|0;f[h>>2]=f[y>>2];a=i+8|0;f[a>>2]=f[A+8>>2];f[i+12>>2]=f[A+12>>2];f[i+16>>2]=f[A+16>>2];f[i+20>>2]=f[A+20>>2];f[i+24>>2]=f[A+24>>2];f[i+28>>2]=f[A+28>>2];f[i+32>>2]=f[A+32>>2];t=f[A+36>>2]|0;f[i+36>>2]=t;f[i+40>>2]=a;a=i+48|0;s=i+44|0;f[s>>2]=a;f[a>>2]=0;f[i+52>>2]=0;if(t|0){a=t+12|0;f[a>>2]=(f[a>>2]|0)+1}if((f[y>>2]|0)<3){y=f[A+44>>2]|0;a=f[s>>2]|0;f[a>>2]=f[y>>2];f[a+4>>2]=f[y+4>>2];break}else{f[h>>2]=0;jL(i,A);break}}else yL(i,c,-1);while(0);NO(j);Nac(k|0,0,1024)|0;f[m>>2]=51772;f[m+4>>2]=g;f[m+8>>2]=k;f[m+12>>2]=j;f[n>>2]=51792;f[n+4>>2]=g;f[n+8>>2]=i;f[n+12>>2]=l;c=g+8|0;A=f[c>>2]|0;f[o>>2]=0;f[o+4>>2]=A;h=g+4|0;y=f[h>>2]|0;if((y|0)<3)C=Y(f[g+12>>2]|0,A)|0;else{A=f[B>>2]|0;a=0;s=1;while(1){t=Y(f[A+(a<<2)>>2]|0,s)|0;a=a+1|0;if((a|0)==(y|0)){C=t;break}else s=t}}if(C>>>0>307199){RQ(o,m,-1.0);D=0}else{d3(m,o);D=0}while(1){E=f[k+(D<<2)>>2]|0;F=D+1|0;if(!E)D=F;else break}m=f[h>>2]|0;C=(m|0)<3;if(C)G=Y(f[g+12>>2]|0,f[c>>2]|0)|0;else{s=f[B>>2]|0;y=0;a=1;while(1){A=Y(f[s+(y<<2)>>2]|0,a)|0;y=y+1|0;if((y|0)==(m|0)){G=A;break}else a=A}}do if((G|0)!=(E|0)){H=255.0/+(G-E|0);f[l+(D<<2)>>2]=0;if((F|0)<256){a=0;y=F;do{a=(f[k+(y<<2)>>2]|0)+a|0;s=LVb(H*+(a|0))|0;f[l+(y<<2)>>2]=(s>>>0<256?s:(s|0)>0?255:0)&255;y=y+1|0}while((y|0)!=256)}if(C)I=Y(f[g+12>>2]|0,f[c>>2]|0)|0;else{y=f[B>>2]|0;a=0;s=1;while(1){A=Y(f[y+(a<<2)>>2]|0,s)|0;a=a+1|0;if((a|0)==(m|0)){I=A;break}else s=A}}if(I>>>0>307199){RQ(o,n,-1.0);break}else{e3(n,o);break}}else{p[r>>3]=+(D|0);f[q>>2]=-1056833530;f[q+4>>2]=r;f[q+8>>2]=1;f[q+12>>2]=1;VP(i,q,UM()|0)|0}while(0);OO(j);j=i+36|0;q=f[j>>2]|0;if(q|0?(r=q+12|0,q=f[r>>2]|0,f[r>>2]=q+-1,(q|0)==1):0)kL(i);f[j>>2]=0;j=i+16|0;q=i+4|0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[q>>2]|0)>0){j=f[i+40>>2]|0;r=0;do{f[j+(r<<2)>>2]=0;r=r+1|0}while((r|0)<(f[q>>2]|0))}q=f[i+44>>2]|0;if((q|0)!=(i+48|0))UC(q);q=g+36|0;i=f[q>>2]|0;if(i|0?(r=i+12|0,i=f[r>>2]|0,f[r>>2]=i+-1,(i|0)==1):0)kL(g);f[q>>2]=0;q=g+16|0;f[q>>2]=0;f[q+4>>2]=0;f[q+8>>2]=0;f[q+12>>2]=0;if((f[h>>2]|0)>0){q=f[B>>2]|0;B=0;do{f[q+(B<<2)>>2]=0;B=B+1|0}while((B|0)<(f[h>>2]|0))}h=f[g+44>>2]|0;if((h|0)!=(g+48|0))UC(h)}if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function d3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c=u;u=u+1024|0;d=c;Nac(d|0,0,1024)|0;e=f[a+4>>2]|0;g=f[e+48>>2]|0;i=f[b>>2]|0;j=(f[b+4>>2]|0)-i|0;b=(f[e>>2]&16384|0)!=0;k=Y(b?j:1,f[e+12>>2]|0)|0;l=(f[e+16>>2]|0)+(Y(f[f[e+44>>2]>>2]|0,i)|0)|0;i=b?1:j;j=i+-1|0;a:do if(i|0){b=k+-4|0;if((k|0)<4){e=(k|0)>0;m=l;n=j;while(1){if(e){o=0;do{p=d+((h[m+o>>0]|0)<<2)|0;f[p>>2]=(f[p>>2]|0)+1;o=o+1|0}while((o|0)!=(k|0))}if(!n)break a;else{m=m+g|0;n=n+-1|0}}}n=k&-4;m=(n|0)<(k|0);e=l;o=j;while(1){p=0;do{q=h[e+(p|1)>>0]|0;r=d+((h[e+p>>0]|0)<<2)|0;f[r>>2]=(f[r>>2]|0)+1;r=d+(q<<2)|0;f[r>>2]=(f[r>>2]|0)+1;r=h[e+(p|3)>>0]|0;q=d+((h[e+(p|2)>>0]|0)<<2)|0;f[q>>2]=(f[q>>2]|0)+1;q=d+(r<<2)|0;f[q>>2]=(f[q>>2]|0)+1;p=p+4|0}while((p|0)<=(b|0));if(m){p=n;do{q=d+((h[e+p>>0]|0)<<2)|0;f[q>>2]=(f[q>>2]|0)+1;p=p+1|0}while((p|0)!=(k|0))}if(!o)break;else{e=e+g|0;o=o+-1|0}}}while(0);g=f[a+12>>2]|0;PO(g);k=f[a+8>>2]|0;a=0;do{j=k+(a<<2)|0;f[j>>2]=(f[j>>2]|0)+(f[d+(a<<2)>>2]|0);a=a+1|0}while((a|0)!=256);QO(g);u=c;return}function e3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=f[a+4>>2]|0;e=f[d+48>>2]|0;g=f[a+8>>2]|0;i=f[g+48>>2]|0;j=f[d+12>>2]|0;k=f[c>>2]|0;l=(f[c+4>>2]|0)-k|0;c=f[a+12>>2]|0;if(!(f[d>>2]&16384)){m=j;n=l}else{a=(f[g>>2]&16384|0)!=0;o=Y(a?l:1,j)|0;m=o;n=a?1:l}l=(f[d+16>>2]|0)+(Y(f[f[d+44>>2]>>2]|0,k)|0)|0;d=(f[g+16>>2]|0)+(Y(f[f[g+44>>2]>>2]|0,k)|0)|0;k=n+-1|0;if(!n)return;n=m+-4|0;if((m|0)<4){g=(m|0)>0;a=l;o=d;j=k;while(1){if(g){p=0;do{b[o+p>>0]=f[c+((h[a+p>>0]|0)<<2)>>2];p=p+1|0}while((p|0)!=(m|0))}if(!j)break;else{a=a+e|0;o=o+i|0;j=j+-1|0}}return}j=m&-4;o=(j|0)<(m|0);a=l;l=d;d=k;while(1){k=0;do{g=k|1;p=f[c+((h[a+g>>0]|0)<<2)>>2]|0;b[l+k>>0]=f[c+((h[a+k>>0]|0)<<2)>>2];b[l+g>>0]=p;p=k|2;g=k|3;q=f[c+((h[a+g>>0]|0)<<2)>>2]|0;b[l+p>>0]=f[c+((h[a+p>>0]|0)<<2)>>2];b[l+g>>0]=q;k=k+4|0}while((k|0)<=(n|0));if(o){k=j;do{b[l+k>>0]=f[c+((h[a+k>>0]|0)<<2)>>2];k=k+1|0}while((k|0)!=(m|0))}if(!d)break;else{a=a+e|0;l=l+i|0;d=d+-1|0}}return}function f3(a){a=a|0;O5b(a);return}function g3(a){a=a|0;O5b(a);return}function h3(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=+e;g=+g;h=+h;var i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,N=0.0,Q=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0;i=u;u=u+1232|0;j=i+168|0;k=i+144|0;l=i+80|0;m=i+24|0;o=i;p=i+88|0;dQ(l,51804);do if((yM(a)|0)==65536){q=f[a+4>>2]|0;f[m>>2]=f[q>>2];r=m+4|0;s=q+4|0;f[r>>2]=f[s>>2];t=m+8|0;f[t>>2]=f[q+8>>2];f[m+12>>2]=f[q+12>>2];f[m+16>>2]=f[q+16>>2];f[m+20>>2]=f[q+20>>2];f[m+24>>2]=f[q+24>>2];f[m+28>>2]=f[q+28>>2];f[m+32>>2]=f[q+32>>2];v=f[q+36>>2]|0;f[m+36>>2]=v;f[m+40>>2]=t;t=m+48|0;w=m+44|0;f[w>>2]=t;f[t>>2]=0;f[m+52>>2]=0;if(v|0){t=v+12|0;f[t>>2]=(f[t>>2]|0)+1}if((f[s>>2]|0)<3){s=f[q+44>>2]|0;t=f[w>>2]|0;f[t>>2]=f[s>>2];f[t+4>>2]=f[s+4>>2];break}else{f[r>>2]=0;jL(m,q);break}}else yL(m,a,-1);while(0);f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;a=wM(m,2,-1,0)|0;q=wM(m,3,-1,0)|0;r=(a|0)>-1;if((q&a|0)<=-1){f[j>>2]=0;f[j+4>>2]=0;x=aD(j,30)|0;y=234014;z=x+30|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-215,j,234045,234053,605);bD(j)}if((f[m>>2]&16391|0)==16389)A=m+16|0;else{f[j>>2]=1124007936;s=j+4|0;t=j+8|0;w=j+40|0;x=s;z=x+36|0;do{f[x>>2]=0;x=x+4|0}while((x|0)<(z|0));f[w>>2]=t;v=j+48|0;B=j+44|0;f[B>>2]=v;f[v>>2]=0;f[j+52>>2]=0;C=k+8|0;f[C>>2]=0;f[C+4>>2]=0;f[k>>2]=33619968;f[k+4>>2]=j;OJ(m,k,5,1.0,0.0);C=j+36|0;D=f[C>>2]|0;if(D|0){E=D+12|0;f[E>>2]=(f[E>>2]|0)+1}E=m+36|0;D=f[E>>2]|0;if(D|0?(F=D+12|0,D=f[F>>2]|0,f[F>>2]=D+-1,(D|0)==1):0)kL(m);f[E>>2]=0;D=m+16|0;F=m+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[F>>2]|0)>0){G=f[m+40>>2]|0;H=0;do{f[G+(H<<2)>>2]=0;H=H+1|0;I=f[F>>2]|0}while((H|0)<(I|0));f[m>>2]=f[j>>2];if((I|0)<3)K=22;else K=24}else{f[m>>2]=f[j>>2];K=22}if((K|0)==22){I=f[s>>2]|0;if((I|0)<3){f[F>>2]=I;f[m+8>>2]=f[t>>2];f[m+12>>2]=f[j+12>>2];t=f[B>>2]|0;I=f[m+44>>2]|0;f[I>>2]=f[t>>2];f[I+4>>2]=f[t+4>>2]}else K=24}if((K|0)==24)jL(m,j);t=j+16|0;f[D>>2]=f[t>>2];f[m+20>>2]=f[j+20>>2];f[m+24>>2]=f[j+24>>2];f[m+28>>2]=f[j+28>>2];f[m+32>>2]=f[j+32>>2];I=f[C>>2]|0;f[E>>2]=I;if(I|0?(E=I+12|0,I=f[E>>2]|0,f[E>>2]=I+-1,(I|0)==1):0)kL(j);f[C>>2]=0;f[t>>2]=0;f[t+4>>2]=0;f[t+8>>2]=0;f[t+12>>2]=0;if((f[s>>2]|0)>0){t=f[w>>2]|0;w=0;do{f[t+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[s>>2]|0))}s=f[B>>2]|0;if((s|0)!=(v|0))UC(s);A=D}D=f[A>>2]|0;if(r){N=e;Q=g;S=h;T=+(a|0);V=T*1.1920928955078125e-07;W=Q!=0.0?Q:1.0;r=S!=0.0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;switch(d|0){case 2:{if((a|0)>0){s=0;Q=0.0;X=0.0;Y=0.0;Z=0.0;_=0.0;while(1){$=+n[D+(s<<3)>>2];aa=_+$;ba=+n[D+(s<<3)+4>>2];ca=Q+ba;da=X+$*$;ea=Y+ba*ba;fa=Z+$*ba;s=s+1|0;if((s|0)==(a|0)){ga=aa;ha=ca;ia=da;ja=ea;ka=fa;break}else{Q=ca;X=da;Y=ea;Z=fa;_=aa}}}else{ga=0.0;ha=0.0;ia=0.0;ja=0.0;ka=0.0}_=T;T=ga/_;ga=ha/_;ha=+U(+((ka/_-ga*T)*2.0),+(ia/_-T*T-(ja/_-ga*ga)))*.5;_=+O(+ha);n[o>>2]=_;_=+P(+ha);n[o+4>>2]=_;n[o+8>>2]=T;n[o+12>>2]=ga;break}case 1:{la=253;ma=0;K=44;break}case 4:{la=254;ma=0;K=44;break}case 5:{la=0;ma=37;K=44;break}case 6:{la=0;ma=38;K=44;break}case 7:{la=0;ma=39;K=44;break}default:{f[j>>2]=0;f[j+4>>2]=0;x=aD(j,21)|0;y=234125;z=x+21|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-5,j,234147,234053,359);bD(j);la=0;ma=0;K=44}}if((K|0)==44){s=a<<1;v=j+8|0;f[j>>2]=v;B=j+4|0;f[B>>2]=s;if(s>>>0>264){w=N5b(s>>>0>1073741823?-1:s<<2)|0;f[j>>2]=w;na=w}else na=v;w=na+(a<<2)|0;s=(a|0)>0;t=(a|0)<10?a:10;C=k+4|0;ga=r?S:.009999999776482582;r=k+8|0;I=k+12|0;E=(la|0)==0;F=a<<2;H=(a|0)==0|s^1;G=0;S=0.0;T=1797693134862315708145274.0e284;_=0.0;ha=0.0;ja=0.0;ia=0.0;oa=-1;pa=-1;while(1){if(s)Nac(na|0,0,F|0)|0;if(H){qa=oa;ra=pa}else{sa=0;ta=oa;ua=pa;while(1){va=ta;wa=ua;do{xa=cbc(va|0,0,-130063606,0)|0;va=Kac(xa|0,J|0,wa|0,0)|0;wa=J;ya=na+(((va>>>0)%(a>>>0)|0)<<2)|0}while(!(+n[ya>>2]<1.1920928955078125e-07));sa=sa+1|0;n[ya>>2]=1.0;if((sa|0)>=(t|0)){qa=va;ra=wa;break}else{ta=va;ua=wa}}}n3(D,a,na,k);ua=0;ka=S;ta=0;Z=_;Y=ha;X=ja;Q=ia;while(1){if(ua){aa=+n[k>>2];fa=+n[C>>2];ea=Z*aa+Y*fa;da=ea<-1.0?-1.0:ea;if(+L(+(+R(+(da>1.0?1.0:da))))<ga?(da=+L(+(+n[r>>2]-X)),ea=+L(+(+n[I>>2]-Q)),(da>ea?da:ea)<W):0){za=ka;Aa=Z;Ba=Y;Ca=X;Da=Q;break}else{Ea=aa;Fa=fa}}else{Ea=+n[k>>2];Fa=+n[C>>2]}fa=+n[r>>2];aa=+n[I>>2];if(s){ea=0.0;sa=0;while(1){da=+L(+(Fa*(+n[D+(sa<<3)>>2]-fa)-Ea*(+n[D+(sa<<3)+4>>2]-aa)));n[w+(sa<<2)>>2]=da;ca=ea+da;sa=sa+1|0;if((sa|0)==(a|0)){Ga=ca;break}else ea=ca}}else Ga=0.0;if(Ga<V){za=Ga;Aa=Z;Ba=Y;Ca=X;Da=Q;break}if(E)oh[ma&63](w,a,na,N);else _h[la&255](w,a,na);if(s){sa=0;ea=0.0;while(1){ca=ea+ +n[na+(sa<<2)>>2];sa=sa+1|0;if((sa|0)==(a|0)){Ha=ca;break}else ea=ca}}else Ha=0.0;if(+L(+Ha)>1.1920928955078125e-07){ea=1.0/Ha;if(s){sa=0;do{wa=na+(sa<<2)|0;n[wa>>2]=ea*+n[wa>>2];sa=sa+1|0}while((sa|0)!=(a|0))}}else if(s){sa=0;do{n[na+(sa<<2)>>2]=1.0;sa=sa+1|0}while((sa|0)!=(a|0))}n3(D,a,na,k);ta=ta+1|0;if((ta|0)>=30){za=Ga;Aa=Ea;Ba=Fa;Ca=fa;Da=aa;break}else{ua=1;ka=Ga;Z=Ea;Y=Fa;X=fa;Q=aa}}if(za<T){f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[o+8>>2]=f[k+8>>2];f[o+12>>2]=f[k+12>>2];if(za<V)break;else Ia=za}else Ia=T;G=G+1|0;if((G|0)>=20)break;else{S=za;T=Ia;_=Aa;ha=Ba;ja=Ca;ia=Da;oa=qa;pa=ra}}ra=f[j>>2]|0;if((ra|0)!=(v|0)){if(ra|0)P5b(ra);f[j>>2]=v;f[B>>2]=264}}}else{Da=e;e=g;g=h;h=+(q|0)*1.1920928955078125e-07;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;f[k+12>>2]=0;f[k+16>>2]=0;f[k+20>>2]=0;ia=e!=0.0?e:1.0;B=g!=0.0;switch(d|0){case 2:{o3(D,q,0,o);break}case 1:{Ja=253;Ka=0;K=88;break}case 4:{Ja=254;Ka=0;K=88;break}case 5:{Ja=0;Ka=37;K=88;break}case 6:{Ja=0;Ka=38;K=88;break}case 7:{Ja=0;Ka=39;K=88;break}default:{f[j>>2]=0;f[j+4>>2]=0;x=aD(j,16)|0;y=234157;z=x+16|0;do{b[x>>0]=b[y>>0]|0;x=x+1|0;y=y+1|0}while((x|0)<(z|0));bO(-5,j,234174,234053,494);bD(j);Ja=0;Ka=0;K=88}}if((K|0)==88){K=q<<1;y=j+8|0;f[j>>2]=y;x=j+4|0;f[x>>2]=K;if(K>>>0>264){z=N5b(K>>>0>1073741823?-1:K<<2)|0;f[j>>2]=z;La=z}else La=y;z=La+(q<<2)|0;K=(q|0)>0;d=(q|0)<10?q:10;v=k+4|0;ra=k+8|0;e=B?g:.009999999776482582;B=k+12|0;pa=k+16|0;qa=k+20|0;oa=(Ja|0)==0;G=q<<2;na=(q|0)==0|K^1;s=0;g=1797693134862315708145274.0e284;Ca=0.0;ja=0.0;Ba=0.0;ha=0.0;Aa=0.0;_=0.0;Ia=0.0;w=-1;la=-1;while(1){if(K)Nac(La|0,0,G|0)|0;if(na){Ma=w;Na=la}else{ma=0;E=w;I=la;while(1){r=E;C=I;do{t=cbc(r|0,0,-130063606,0)|0;r=Kac(t|0,J|0,C|0,0)|0;C=J;Oa=La+(((r>>>0)%(q>>>0)|0)<<2)|0}while(!(+n[Oa>>2]<1.1920928955078125e-07));ma=ma+1|0;n[Oa>>2]=1.0;if((ma|0)>=(d|0)){Ma=r;Na=C;break}else{E=r;I=C}}}o3(D,q,La,k);I=0;aa=Ca;E=0;fa=ja;T=Ba;za=ha;S=Aa;V=_;Fa=Ia;while(1){Ea=+n[k>>2];if(I){Ga=+n[v>>2];Ha=+n[ra>>2];N=fa*Ea+V*Ga+Fa*Ha;W=N<-1.0?-1.0:N;if(+L(+(+R(+(W>1.0?1.0:W))))<e?(W=+n[B>>2]-T,N=+n[pa>>2]-za,ga=+n[qa>>2]-S,Q=Ea-fa,X=Ga-V,Y=Ha-Fa,Z=+L(+(Y*N-X*ga)),ka=+L(+(Q*ga-Y*W)),Y=+L(+(X*W-Q*N)),N=Z>ka?Z:ka,(N>Y?N:Y)<ia):0){Pa=aa;Qa=fa;Ra=T;Sa=za;Ta=S;Ua=V;Va=Fa;break}else{Wa=Ga;Xa=Ha}}else{Wa=+n[v>>2];Xa=+n[ra>>2]}Ha=+n[B>>2];Ga=+n[pa>>2];Y=+n[qa>>2];if(K){N=0.0;ma=0;while(1){ka=+n[D+(ma*12|0)>>2]-Ha;Z=+n[D+(ma*12|0)+4>>2]-Ga;Q=+n[D+(ma*12|0)+8>>2]-Y;W=Wa*Q-Xa*Z;X=Xa*ka-Ea*Q;Q=Ea*Z-Wa*ka;ka=+M(+(Q*Q+(W*W+X*X)));n[z+(ma<<2)>>2]=ka;X=N+ka;ma=ma+1|0;if((ma|0)==(q|0)){Ya=X;break}else N=X}}else Ya=0.0;if(oa)oh[Ka&63](z,q,La,Da);else _h[Ja&255](z,q,La);if(K){ma=0;N=0.0;while(1){X=N+ +n[La+(ma<<2)>>2];ma=ma+1|0;if((ma|0)==(q|0)){Za=X;break}else N=X}}else Za=0.0;if(+L(+Za)>1.1920928955078125e-07){N=1.0/Za;if(K){ma=0;do{C=La+(ma<<2)|0;n[C>>2]=N*+n[C>>2];ma=ma+1|0}while((ma|0)!=(q|0))}}else if(K){ma=0;do{n[La+(ma<<2)>>2]=1.0;ma=ma+1|0}while((ma|0)!=(q|0))}o3(D,q,La,k);E=E+1|0;if((E|0)>=30){Pa=Ya;Qa=Ea;Ra=Ha;Sa=Ga;Ta=Y;Ua=Wa;Va=Xa;break}else{I=1;aa=Ya;fa=Ea;T=Ha;za=Ga;S=Y;V=Wa;Fa=Xa}}if(Pa<g){f[o>>2]=f[k>>2];f[o+4>>2]=f[k+4>>2];f[o+8>>2]=f[k+8>>2];f[o+12>>2]=f[k+12>>2];f[o+16>>2]=f[k+16>>2];f[o+20>>2]=f[k+20>>2];if(Pa<h)break;else _a=Pa}else _a=g;s=s+1|0;if((s|0)>=20)break;else{g=_a;Ca=Pa;ja=Qa;Ba=Ra;ha=Sa;Aa=Ta;_=Ua;Ia=Va;w=Ma;la=Na}}Na=f[j>>2]|0;if((Na|0)!=(y|0)){if(Na|0)P5b(Na);f[j>>2]=y;f[x>>2]=264}}}x=a>>31&2|4;a=p+4|0;f[a>>2]=2;y=p+8|0;f[y>>2]=x;f[p+12>>2]=1;j=p+16|0;f[j>>2]=o;f[p+20>>2]=o;Na=p+24|0;la=p+40|0;Ma=Na+8|0;f[Ma>>2]=0;f[Ma+4>>2]=0;f[la>>2]=y;y=p+48|0;Ma=p+44|0;f[Ma>>2]=y;f[p>>2]=1124024325;f[y>>2]=4;f[p+52>>2]=4;w=o+(x<<2)|0;f[p+28>>2]=w;f[Na>>2]=w;SP(p,c);c=p+36|0;w=f[c>>2]|0;if(w|0?(Na=w+12|0,w=f[Na>>2]|0,f[Na>>2]=w+-1,(w|0)==1):0)kL(p);f[c>>2]=0;f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;f[j+12>>2]=0;if((f[a>>2]|0)>0){j=f[la>>2]|0;la=0;do{f[j+(la<<2)>>2]=0;la=la+1|0}while((la|0)<(f[a>>2]|0))}a=f[Ma>>2]|0;if((a|0)!=(y|0))UC(a);a=m+36|0;y=f[a>>2]|0;if(y|0?(Ma=y+12|0,y=f[Ma>>2]|0,f[Ma>>2]=y+-1,(y|0)==1):0)kL(m);f[a>>2]=0;a=m+4|0;f[A>>2]=0;f[A+4>>2]=0;f[A+8>>2]=0;f[A+12>>2]=0;if((f[a>>2]|0)>0){A=f[m+40>>2]|0;y=0;do{f[A+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[a>>2]|0))}a=f[m+44>>2]|0;if((a|0)!=(m+48|0))UC(a);if(!(f[l+4>>2]|0)){u=i;return}u=i;return}function i3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0;e=d<=0.0?1.3450000286102295:d;if((b|0)>0)f=0;else return;do{d=+n[a+(f<<2)>>2];n[c+(f<<2)>>2]=d<e?1.0:e/d;f=f+1|0}while((f|0)!=(b|0));return}function j3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0,g=0.0;e=d==0.0?.3350532650947571:1.0/d;if((b|0)>0)f=0;else return;do{d=+n[a+(f<<2)>>2];g=+V(+-(e*(e*(d*d))));n[c+(f<<2)>>2]=g;f=f+1|0}while((f|0)!=(b|0));return}function k3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;var e=0.0,f=0;e=d==0.0?.7143877744674683:1.0/d;if((b|0)>0)f=0;else return;do{n[c+(f<<2)>>2]=1.0/(e*+n[a+(f<<2)>>2]+1.0);f=f+1|0}while((f|0)!=(b|0));return}function l3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0,f=0.0;if((b|0)>0)d=0;else return;do{e=+n[a+(d<<2)>>2];f=1.0/+M(+(e*e*.5+1.0));n[c+(d<<2)>>2]=f;d=d+1|0}while((d|0)!=(b|0));return}function m3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0.0;if((b|0)>0)d=0;else return;do{e=+L(+(+n[a+(d<<2)>>2]));n[c+(d<<2)>>2]=1.0/(e<1.0e-06?1.0e-06:e);d=d+1|0}while((d|0)!=(b|0));return}function n3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0.0,g=0,h=0.0,i=0.0,j=0.0,k=0.0,l=0.0,m=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0;e=(b|0)>0;if(c)if(e){f=0.0;g=0;h=0.0;i=0.0;j=0.0;k=0.0;l=0.0;while(1){m=+n[c+(g<<2)>>2];o=+n[a+(g<<3)>>2];p=m*o;q=l+p;r=+n[a+(g<<3)+4>>2];s=m*r;t=h+s;u=i+o*p;o=j+r*s;s=k+p*r;r=f+m;g=g+1|0;if((g|0)==(b|0)){v=r;w=q;x=t;y=u;z=o;A=s;break}else{f=r;h=t;i=u;j=o;k=s;l=q}}}else{v=0.0;w=0.0;x=0.0;y=0.0;z=0.0;A=0.0}else{if(e){e=0;l=0.0;k=0.0;j=0.0;i=0.0;h=0.0;while(1){f=+n[a+(e<<3)>>2];q=h+f;s=+n[a+(e<<3)+4>>2];o=l+s;u=k+f*f;t=j+s*s;r=i+f*s;e=e+1|0;if((e|0)==(b|0)){B=q;C=o;D=u;E=t;F=r;break}else{l=o;k=u;j=t;i=r;h=q}}}else{B=0.0;C=0.0;D=0.0;E=0.0;F=0.0}v=+(b|0);w=B;x=C;y=D;z=E;A=F}F=w/v;w=x/v;x=+U(+((A/v-w*F)*2.0),+(y/v-F*F-(z/v-w*w)))*.5;v=+O(+x);n[d>>2]=v;v=+P(+x);n[d+4>>2]=v;n[d+8>>2]=F;n[d+12>>2]=w;return}function o3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;e=u;u=u+304|0;g=e+264|0;h=e+228|0;i=e+216|0;j=e+160|0;k=e+104|0;l=e+48|0;m=e+32|0;o=e+16|0;p=e;f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;q=h;r=q+36|0;do{f[q>>2]=0;q=q+4|0}while((q|0)<(r|0));q=(b|0)>0;if(c)if(q){r=0;s=0.0;t=0.0;v=0.0;w=0.0;x=0.0;y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;while(1){D=+n[a+(r*12|0)>>2];E=+n[a+(r*12|0)+4>>2];F=+n[a+(r*12|0)+8>>2];G=+n[c+(r<<2)>>2];H=x+D*D*G;I=A+D*E*G;J=C+D*F*G;K=y+E*E*G;L=B+E*F*G;N=z+F*F*G;O=t+D*G;D=v+E*G;E=w+F*G;F=s+G;r=r+1|0;if((r|0)==(b|0)){P=F;Q=O;R=D;S=E;T=H;U=K;V=N;W=I;X=L;Y=J;break}else{s=F;t=O;v=D;w=E;x=H;y=K;z=N;A=I;B=L;C=J}}}else{P=0.0;Q=0.0;R=0.0;S=0.0;T=0.0;U=0.0;V=0.0;W=0.0;X=0.0;Y=0.0}else{if(q){q=0;C=0.0;B=0.0;A=0.0;z=0.0;y=0.0;x=0.0;w=0.0;v=0.0;t=0.0;while(1){s=+n[a+(q*12|0)>>2];J=+n[a+(q*12|0)+4>>2];L=+n[a+(q*12|0)+8>>2];I=z+s*s;N=w+s*J;K=t+s*L;H=y+J*J;E=v+J*L;D=x+L*L;O=C+s;s=B+J;J=A+L;q=q+1|0;if((q|0)==(b|0)){Z=O;_=s;$=J;aa=I;ba=H;ca=D;da=N;ea=E;fa=K;break}else{C=O;B=s;A=J;z=I;y=H;x=D;w=N;v=E;t=K}}}else{Z=0.0;_=0.0;$=0.0;aa=0.0;ba=0.0;ca=0.0;da=0.0;ea=0.0;fa=0.0}P=+(b|0);Q=Z;R=_;S=$;T=aa;U=ba;V=ca;W=da;X=ea;Y=fa}fa=Q/P;Q=R/P;R=S/P;S=T/P-fa*fa;T=U/P-Q*Q;U=V/P-R*R;n[g>>2]=U+T;V=-(W/P-fa*Q);n[g+4>>2]=V;W=-(Y/P-fa*R);n[g+8>>2]=W;n[g+12>>2]=V;n[g+16>>2]=S+U;U=-(X/P-Q*R);n[g+20>>2]=U;n[g+24>>2]=W;n[g+28>>2]=U;n[g+32>>2]=T+S;b=j+4|0;f[b>>2]=2;q=j+8|0;f[q>>2]=3;f[j+12>>2]=3;a=j+16|0;f[a>>2]=g;f[j+20>>2]=g;r=j+24|0;c=j+40|0;ga=r+8|0;f[ga>>2]=0;f[ga+4>>2]=0;f[c>>2]=q;q=j+48|0;ga=j+44|0;f[ga>>2]=q;f[j>>2]=1124024325;f[q>>2]=12;f[j+52>>2]=4;f[j+28>>2]=g+36;f[r>>2]=g+36;g=k+4|0;f[g>>2]=2;r=k+8|0;f[r>>2]=3;f[k+12>>2]=3;ha=k+16|0;f[ha>>2]=h;f[k+20>>2]=h;ia=k+24|0;ja=k+40|0;ka=ia+8|0;f[ka>>2]=0;f[ka+4>>2]=0;f[ja>>2]=r;r=k+48|0;ka=k+44|0;f[ka>>2]=r;f[k>>2]=1124024325;f[r>>2]=12;f[k+52>>2]=4;f[k+28>>2]=h+36;f[ia>>2]=h+36;ia=l+4|0;f[ia>>2]=2;la=l+8|0;f[la>>2]=3;f[l+12>>2]=1;ma=l+16|0;f[ma>>2]=i;f[l+20>>2]=i;na=l+24|0;oa=l+40|0;pa=na+8|0;f[pa>>2]=0;f[pa+4>>2]=0;f[oa>>2]=la;la=l+48|0;pa=l+44|0;f[pa>>2]=la;f[l>>2]=1124024325;f[la>>2]=4;f[l+52>>2]=4;f[l+28>>2]=i+12;f[na>>2]=i+12;f[m+8>>2]=0;f[m+12>>2]=0;f[m>>2]=16842752;f[m+4>>2]=j;na=o+8|0;f[na>>2]=0;f[na+4>>2]=0;f[o>>2]=33619968;f[o+4>>2]=l;na=p+8|0;f[na>>2]=0;f[na+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=k;dT(m,o,p)|0;p=!(+n[i>>2]<+n[i+4>>2]);o=h+((+n[i+((p&1)<<2)>>2]<+n[i+8>>2]?(p?3:0):6)<<2)|0;S=+n[o>>2];T=S;U=+n[o+4>>2];W=U;P=+n[o+8>>2];X=P;V=+M(+(T*T+W*W+X*X));X=V<1.0e-06?1.0e-06:V;n[d>>2]=S/X;n[d+4>>2]=U/X;n[d+8>>2]=P/X;n[d+12>>2]=fa;n[d+16>>2]=Q;n[d+20>>2]=R;d=l+36|0;o=f[d>>2]|0;if(o|0?(p=o+12|0,o=f[p>>2]|0,f[p>>2]=o+-1,(o|0)==1):0)kL(l);f[d>>2]=0;f[ma>>2]=0;f[ma+4>>2]=0;f[ma+8>>2]=0;f[ma+12>>2]=0;if((f[ia>>2]|0)>0){ma=f[oa>>2]|0;oa=0;do{f[ma+(oa<<2)>>2]=0;oa=oa+1|0}while((oa|0)<(f[ia>>2]|0))}ia=f[pa>>2]|0;if((ia|0)!=(la|0))UC(ia);ia=k+36|0;la=f[ia>>2]|0;if(la|0?(pa=la+12|0,la=f[pa>>2]|0,f[pa>>2]=la+-1,(la|0)==1):0)kL(k);f[ia>>2]=0;f[ha>>2]=0;f[ha+4>>2]=0;f[ha+8>>2]=0;f[ha+12>>2]=0;if((f[g>>2]|0)>0){ha=f[ja>>2]|0;ja=0;do{f[ha+(ja<<2)>>2]=0;ja=ja+1|0}while((ja|0)<(f[g>>2]|0))}g=f[ka>>2]|0;if((g|0)!=(r|0))UC(g);g=j+36|0;r=f[g>>2]|0;if(r|0?(ka=r+12|0,r=f[ka>>2]|0,f[ka>>2]=r+-1,(r|0)==1):0)kL(j);f[g>>2]=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[b>>2]|0)>0){a=f[c>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[ga>>2]|0;if((b|0)==(q|0)){u=e;return}UC(b);u=e;return}function p3(a,b,c,d,e,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0;p=u;u=u+16|0;q=p;r=(a|0)==0;s=r&(b|0)==4;t=(c|0)==6;if(s&t){q3(d,e,g,h,i,j,k,l,m,n,o);u=p;return}v=(c|0)==5;if(s&v){r3(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(s&(c|0)==4){s3(d,e,g,h,i,j,k,l,m,n,o);u=p;return}c=(b|0)==5;s=r&c;if(s&t){t3(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(s&v){u3(d,e,g,h,i,j,k,l,m,n,o);u=p;return}s=(b|0)==6;if(r&s&t){v3(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if((a|0)==2&s&t){w3(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if((a|0)==3&s&t){x3(d,e,g,h,i,j,k,l,m,n,o);u=p;return}r=(a|0)==5;b=r&c;if(b&t){y3(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(b&v){z3(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if(r&s&t){A3(d,e,g,h,i,j,k,l,m,n,o);u=p;return}if((a|0)==6&s&t){B3(d,e,g,h,i,j,k,l,m,n,o);u=p;return}else{f[q>>2]=0;f[q+4>>2]=0;bO(-210,q,234255,234264,488);bD(q);u=p;return}}function q3(a,c,d,e,g,i,j,k,l,m,n){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;o=u;u=u+1072|0;q=0-n|0;r=o;s=e>>>2;e=k>>>2;k=0-e|0;t=i>>>3;i=Y(n,l)|0;l=i+n|0;v=l<<2;Nac(d|0,0,v|0)|0;w=d+(s+n<<2)|0;if(!g)x=0;else{Nac(g|0,0,l<<3|0)|0;x=g+(t+n<<3)|0}if(!j)y=0;else{Nac(j|0,0,v|0)|0;y=j+(e+n<<2)|0}j=(y|0)==0;if((x|0)==0&j){if((m|0)<=0){u=o;return}v=(i|0)>0;g=c-n|0;z=s-n|0;if((n|0)<=0){u=o;return}A=n+-1|0;B=n<<2;C=w;D=0;E=a;while(1){if(v){F=0;G=C;H=E;while(1){f[G+(q<<2)>>2]=0;I=0;J=0;do{I=(h[H+J>>0]|0)+I|0;f[G+(J<<2)>>2]=I+(f[G+(J-s<<2)>>2]|0);J=J+n|0}while((J|0)<(i|0));F=F+1|0;if((F|0)==(n|0))break;else{G=G+4|0;H=H+1|0}}}else Nac(C+(q<<2)|0,0,B|0)|0;D=D+1|0;if((D|0)==(m|0))break;else{C=C+(A<<2)+4+(z<<2)|0;E=E+A+1+g|0}}u=o;return}if(j){if((m|0)<=0){u=o;return}j=(i|0)>0;g=c-n|0;A=s-n|0;E=t-n|0;if((n|0)<=0){u=o;return}z=n+-1|0;C=x;D=0;B=w;v=a;while(1){if(j){H=0;G=C;F=B;J=v;while(1){f[F+(q<<2)>>2]=0;p[G+(q<<3)>>3]=0.0;K=0.0;I=0;L=0;do{M=b[J+L>>0]|0;I=(M&255)+I|0;N=+(M&255);K=K+N*N;N=+p[G+(L-t<<3)>>3]+K;f[F+(L<<2)>>2]=I+(f[F+(L-s<<2)>>2]|0);p[G+(L<<3)>>3]=N;L=L+n|0}while((L|0)<(i|0));H=H+1|0;if((H|0)==(n|0))break;else{G=G+8|0;F=F+4|0;J=J+1|0}}}else{J=0;F=C;G=B;while(1){f[G+(q<<2)>>2]=0;p[F+(q<<3)>>3]=0.0;J=J+1|0;if((J|0)==(n|0))break;else{F=F+8|0;G=G+4|0}}}D=D+1|0;if((D|0)==(m|0))break;else{C=C+(z<<3)+8+(E<<3)|0;B=B+(z<<2)+4+(A<<2)|0;v=v+z+1+g|0}}u=o;return}g=r+8|0;f[r>>2]=g;z=r+4|0;f[z>>2]=l;if(l>>>0>264){v=N5b(l>>>0>1073741823?-1:l<<2)|0;f[r>>2]=v;O=v}else O=g;v=(n|0)>0;do if(v){l=(i|0)==(n|0);A=s+(n<<1)|0;B=y+(n<<2)|0;if((i|0)>0){P=O;Q=y;R=0;S=x;T=w;U=a}else{E=O;C=y;D=0;j=x;G=w;while(1){f[C+(q<<2)>>2]=0;f[G+(q<<2)>>2]=0;if(l)f[E+(n<<2)>>2]=0;if(!j)V=0;else{p[j+(q<<3)>>3]=0.0;V=j+8|0}D=D+1|0;if((D|0)==(n|0))break;else{E=E+4|0;C=C+4|0;j=V;G=G+4|0}}W=O+(n<<2)|0;X=B;Z=V;_=a+n|0;$=d+(A<<2)|0;break}while(1){f[Q+(q<<2)>>2]=0;f[T+(q<<2)>>2]=0;G=(S|0)!=0;if(G){K=0.0;j=0;C=0;do{E=b[U+C>>0]|0;D=E&255;f[Q+(C<<2)>>2]=D;f[P+(C<<2)>>2]=D;j=D+j|0;N=+(E&255);K=K+N*N;f[T+(C<<2)>>2]=j;p[S+(C<<3)>>3]=K;C=C+n|0}while((C|0)<(i|0))}else{C=0;j=0;do{E=h[U+j>>0]|0;f[Q+(j<<2)>>2]=E;f[P+(j<<2)>>2]=E;C=E+C|0;f[T+(j<<2)>>2]=C;j=j+n|0}while((j|0)<(i|0))}if(l)f[P+(n<<2)>>2]=0;if(G){p[S+(q<<3)>>3]=0.0;aa=S+8|0}else aa=0;R=R+1|0;if((R|0)==(n|0))break;else{P=P+4|0;Q=Q+4|0;S=aa;T=T+4|0;U=U+1|0}}W=O+(n<<2)|0;X=B;Z=aa;_=a+n|0;$=d+(A<<2)|0}else{W=O;X=y;Z=x;_=a;$=w}while(0);if((m|0)>1){w=c-n|0;a=s-n|0;x=e-n|0;y=t-n|0;d=0-s|0;aa=0-t|0;U=i-n|0;T=(U|0)>(n|0);S=e+n|0;Q=(i|0)>(n|0);i=W;W=X;X=1;P=$;$=Z;Z=_;while(1){_=Z+w|0;R=P+(a<<2)|0;V=W+(x<<2)|0;l=i+(q<<2)|0;j=($|0)==0?0:$+(y<<3)|0;if(v){C=P+(s<<2)|0;E=l;D=V;F=0;J=R;H=_;L=j;while(1){I=b[H>>0]|0;M=I&255;K=+(I&255);N=K*K;f[J+(q<<2)>>2]=0;I=(L|0)!=0;if(I)p[L+(q<<3)>>3]=0.0;ba=D+(k<<2)|0;f[D+(q<<2)>>2]=f[ba>>2];f[J>>2]=(f[J+(d<<2)>>2]|0)+M;if(I)p[L>>3]=N+ +p[L+(aa<<3)>>3];f[D>>2]=(f[ba>>2]|0)+M+(f[E+(n<<2)>>2]|0);if(T)if(I){ba=M;K=N;ca=M;da=n;while(1){ea=f[E+(da<<2)>>2]|0;f[E+(da-n<<2)>>2]=ea+ba;fa=b[H+da>>0]|0;ga=fa&255;ha=+(fa&255);fa=ga+ca|0;ia=K+ha*ha;f[J+(da<<2)>>2]=fa+(f[J+(da-s<<2)>>2]|0);p[L+(da<<3)>>3]=ia+ +p[L+(da-t<<3)>>3];ja=da+n|0;f[D+(da<<2)>>2]=ga+ea+(f[E+(ja<<2)>>2]|0)+(f[D+(da-S<<2)>>2]|0);if((ja|0)<(U|0)){ba=ga;K=ia;ca=fa;da=ja}else{ka=ga;la=ia;ma=fa;na=ja;break}}}else{da=M;K=N;ca=M;ba=n;while(1){G=f[E+(ba<<2)>>2]|0;f[E+(ba-n<<2)>>2]=G+da;ja=b[H+ba>>0]|0;fa=ja&255;ia=+(ja&255);ja=fa+ca|0;ha=K+ia*ia;f[J+(ba<<2)>>2]=ja+(f[J+(ba-s<<2)>>2]|0);ga=ba+n|0;f[D+(ba<<2)>>2]=fa+G+(f[E+(ga<<2)>>2]|0)+(f[D+(ba-S<<2)>>2]|0);if((ga|0)<(U|0)){da=fa;K=ha;ca=ja;ba=ga}else{ka=fa;la=ha;ma=ja;na=ga;break}}}else{ka=M;la=N;ma=M;na=n}if(Q){ba=E+(na<<2)|0;ca=f[ba>>2]|0;f[E+(na-n<<2)>>2]=ca+ka;da=b[H+na>>0]|0;ga=da&255;f[J+(na<<2)>>2]=ga+ma+(f[J+(na-s<<2)>>2]|0);K=+(da&255);if(I)p[L+(na<<3)>>3]=la+K*K+ +p[L+(na-t<<3)>>3];f[D+(na<<2)>>2]=ga+ca+(f[D+(na-S<<2)>>2]|0);f[ba>>2]=ga}L=I?L+8|0:0;F=F+1|0;if((F|0)==(n|0))break;else{E=E+4|0;D=D+4|0;J=J+4|0;H=H+1|0}}oa=i;pa=W+(e<<2)|0;qa=Z+c|0;ra=C;sa=L}else{oa=l;pa=V;qa=_;ra=R;sa=j}X=X+1|0;if((X|0)==(m|0))break;else{i=oa;W=pa;P=ra;$=sa;Z=qa}}}if((O|0)!=(g|0)){P5b(O);f[r>>2]=g;f[z>>2]=264}u=o;return}function r3(a,c,d,e,g,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;p=u;u=u+1072|0;q=0-o|0;r=p;s=e>>>2;e=k>>>2;k=0-e|0;t=i>>>2;i=Y(o,l)|0;l=i+o|0;v=l<<2;Nac(d|0,0,v|0)|0;w=d+(s+o<<2)|0;if(!g)x=0;else{Nac(g|0,0,v|0)|0;x=g+(t+o<<2)|0}if(!j)y=0;else{Nac(j|0,0,v|0)|0;y=j+(e+o<<2)|0}j=(y|0)==0;if((x|0)==0&j){if((m|0)<=0){u=p;return}v=(i|0)>0;g=c-o|0;z=s-o|0;if((o|0)<=0){u=p;return}A=o+-1|0;B=o<<2;C=w;D=0;E=a;while(1){if(v){F=0;G=C;H=E;while(1){f[G+(q<<2)>>2]=0;I=0;J=0;do{I=(h[H+J>>0]|0)+I|0;f[G+(J<<2)>>2]=I+(f[G+(J-s<<2)>>2]|0);J=J+o|0}while((J|0)<(i|0));F=F+1|0;if((F|0)==(o|0))break;else{G=G+4|0;H=H+1|0}}}else Nac(C+(q<<2)|0,0,B|0)|0;D=D+1|0;if((D|0)==(m|0))break;else{C=C+(A<<2)+4+(z<<2)|0;E=E+A+1+g|0}}u=p;return}if(j){if((m|0)<=0){u=p;return}j=(i|0)>0;g=c-o|0;A=s-o|0;E=t-o|0;if((o|0)<=0){u=p;return}z=o+-1|0;C=x;D=0;B=w;v=a;while(1){if(j){H=0;G=C;F=B;J=v;while(1){f[F+(q<<2)>>2]=0;n[G+(q<<2)>>2]=0.0;K=0.0;I=0;L=0;do{M=b[J+L>>0]|0;I=(M&255)+I|0;N=+(M&255);K=K+N*N;N=+n[G+(L-t<<2)>>2]+K;f[F+(L<<2)>>2]=I+(f[F+(L-s<<2)>>2]|0);n[G+(L<<2)>>2]=N;L=L+o|0}while((L|0)<(i|0));H=H+1|0;if((H|0)==(o|0))break;else{G=G+4|0;F=F+4|0;J=J+1|0}}}else{J=0;F=C;G=B;while(1){f[G+(q<<2)>>2]=0;n[F+(q<<2)>>2]=0.0;J=J+1|0;if((J|0)==(o|0))break;else{F=F+4|0;G=G+4|0}}}D=D+1|0;if((D|0)==(m|0))break;else{C=C+(z<<2)+4+(E<<2)|0;B=B+(z<<2)+4+(A<<2)|0;v=v+z+1+g|0}}u=p;return}g=r+8|0;f[r>>2]=g;z=r+4|0;f[z>>2]=l;if(l>>>0>264){v=N5b(l>>>0>1073741823?-1:l<<2)|0;f[r>>2]=v;O=v}else O=g;v=(o|0)>0;do if(v){l=(i|0)==(o|0);A=s+(o<<1)|0;B=y+(o<<2)|0;if((i|0)>0){P=O;Q=y;R=0;S=x;T=w;U=a}else{E=O;C=y;D=0;j=x;G=w;while(1){f[C+(q<<2)>>2]=0;f[G+(q<<2)>>2]=0;if(l)f[E+(o<<2)>>2]=0;if(!j)V=0;else{n[j+(q<<2)>>2]=0.0;V=j+4|0}D=D+1|0;if((D|0)==(o|0))break;else{E=E+4|0;C=C+4|0;j=V;G=G+4|0}}W=O+(o<<2)|0;X=B;Z=V;_=a+o|0;$=d+(A<<2)|0;break}while(1){f[Q+(q<<2)>>2]=0;f[T+(q<<2)>>2]=0;G=(S|0)!=0;if(G){K=0.0;j=0;C=0;do{E=b[U+C>>0]|0;D=E&255;f[Q+(C<<2)>>2]=D;f[P+(C<<2)>>2]=D;j=D+j|0;N=+(E&255);K=K+N*N;f[T+(C<<2)>>2]=j;n[S+(C<<2)>>2]=K;C=C+o|0}while((C|0)<(i|0))}else{C=0;j=0;do{E=h[U+j>>0]|0;f[Q+(j<<2)>>2]=E;f[P+(j<<2)>>2]=E;C=E+C|0;f[T+(j<<2)>>2]=C;j=j+o|0}while((j|0)<(i|0))}if(l)f[P+(o<<2)>>2]=0;if(G){n[S+(q<<2)>>2]=0.0;aa=S+4|0}else aa=0;R=R+1|0;if((R|0)==(o|0))break;else{P=P+4|0;Q=Q+4|0;S=aa;T=T+4|0;U=U+1|0}}W=O+(o<<2)|0;X=B;Z=aa;_=a+o|0;$=d+(A<<2)|0}else{W=O;X=y;Z=x;_=a;$=w}while(0);if((m|0)>1){w=c-o|0;a=s-o|0;x=e-o|0;y=t-o|0;d=0-s|0;aa=0-t|0;U=i-o|0;T=(U|0)>(o|0);S=e+o|0;Q=(i|0)>(o|0);i=W;W=X;X=1;P=$;$=Z;Z=_;while(1){_=Z+w|0;R=P+(a<<2)|0;V=W+(x<<2)|0;l=i+(q<<2)|0;j=($|0)==0?0:$+(y<<2)|0;if(v){C=P+(s<<2)|0;E=l;D=V;F=0;J=R;H=_;L=j;while(1){I=b[H>>0]|0;M=I&255;K=+(I&255);N=K*K;f[J+(q<<2)>>2]=0;I=(L|0)!=0;if(I)n[L+(q<<2)>>2]=0.0;ba=D+(k<<2)|0;f[D+(q<<2)>>2]=f[ba>>2];f[J>>2]=(f[J+(d<<2)>>2]|0)+M;if(I)n[L>>2]=N+ +n[L+(aa<<2)>>2];f[D>>2]=(f[ba>>2]|0)+M+(f[E+(o<<2)>>2]|0);if(T)if(I){ba=M;K=N;ca=M;da=o;while(1){ea=f[E+(da<<2)>>2]|0;f[E+(da-o<<2)>>2]=ea+ba;fa=b[H+da>>0]|0;ga=fa&255;ha=+(fa&255);fa=ga+ca|0;ia=K+ha*ha;f[J+(da<<2)>>2]=fa+(f[J+(da-s<<2)>>2]|0);n[L+(da<<2)>>2]=ia+ +n[L+(da-t<<2)>>2];ja=da+o|0;f[D+(da<<2)>>2]=ga+ea+(f[E+(ja<<2)>>2]|0)+(f[D+(da-S<<2)>>2]|0);if((ja|0)<(U|0)){ba=ga;K=ia;ca=fa;da=ja}else{ka=ga;la=ia;ma=fa;na=ja;break}}}else{da=M;K=N;ca=M;ba=o;while(1){G=f[E+(ba<<2)>>2]|0;f[E+(ba-o<<2)>>2]=G+da;ja=b[H+ba>>0]|0;fa=ja&255;ia=+(ja&255);ja=fa+ca|0;ha=K+ia*ia;f[J+(ba<<2)>>2]=ja+(f[J+(ba-s<<2)>>2]|0);ga=ba+o|0;f[D+(ba<<2)>>2]=fa+G+(f[E+(ga<<2)>>2]|0)+(f[D+(ba-S<<2)>>2]|0);if((ga|0)<(U|0)){da=fa;K=ha;ca=ja;ba=ga}else{ka=fa;la=ha;ma=ja;na=ga;break}}}else{ka=M;la=N;ma=M;na=o}if(Q){ba=E+(na<<2)|0;ca=f[ba>>2]|0;f[E+(na-o<<2)>>2]=ca+ka;da=b[H+na>>0]|0;ga=da&255;f[J+(na<<2)>>2]=ga+ma+(f[J+(na-s<<2)>>2]|0);K=+(da&255);if(I)n[L+(na<<2)>>2]=la+K*K+ +n[L+(na-t<<2)>>2];f[D+(na<<2)>>2]=ga+ca+(f[D+(na-S<<2)>>2]|0);f[ba>>2]=ga}L=I?L+4|0:0;F=F+1|0;if((F|0)==(o|0))break;else{E=E+4|0;D=D+4|0;J=J+4|0;H=H+1|0}}oa=i;pa=W+(e<<2)|0;qa=Z+c|0;ra=C;sa=L}else{oa=l;pa=V;qa=_;ra=R;sa=j}X=X+1|0;if((X|0)==(m|0))break;else{i=oa;W=pa;P=ra;$=sa;Z=qa}}}if((O|0)!=(g|0)){P5b(O);f[r>>2]=g;f[z>>2]=264}u=p;return}function s3(a,b,c,d,e,g,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;n=u;u=u+1072|0;o=0-m|0;p=n;q=d>>>2;d=j>>>2;j=0-d|0;r=g>>>2;g=Y(m,k)|0;k=g+m|0;s=k<<2;Nac(c|0,0,s|0)|0;t=c+(q+m<<2)|0;if(!e)v=0;else{Nac(e|0,0,s|0)|0;v=e+(r+m<<2)|0}if(!i)w=0;else{Nac(i|0,0,s|0)|0;w=i+(d+m<<2)|0}i=(w|0)==0;if((v|0)==0&i){if((l|0)<=0){u=n;return}s=(g|0)>0;e=b-m|0;x=q-m|0;if((m|0)<=0){u=n;return}y=m+-1|0;z=m<<2;A=t;B=0;C=a;while(1){if(s){D=0;E=A;F=C;while(1){f[E+(o<<2)>>2]=0;G=0;H=0;do{G=(h[F+H>>0]|0)+G|0;f[E+(H<<2)>>2]=G+(f[E+(H-q<<2)>>2]|0);H=H+m|0}while((H|0)<(g|0));D=D+1|0;if((D|0)==(m|0))break;else{E=E+4|0;F=F+1|0}}}else Nac(A+(o<<2)|0,0,z|0)|0;B=B+1|0;if((B|0)==(l|0))break;else{A=A+(y<<2)+4+(x<<2)|0;C=C+y+1+e|0}}u=n;return}if(i){if((l|0)<=0){u=n;return}i=(g|0)>0;e=b-m|0;y=q-m|0;C=r-m|0;if((m|0)<=0){u=n;return}x=m+-1|0;A=v;B=0;z=t;s=a;while(1){if(i){F=0;E=A;D=z;H=s;while(1){f[D+(o<<2)>>2]=0;f[E+(o<<2)>>2]=0;G=0;I=0;J=0;do{K=h[H+J>>0]|0;I=K+I|0;G=(Y(K,K)|0)+G|0;K=G+(f[E+(J-r<<2)>>2]|0)|0;f[D+(J<<2)>>2]=I+(f[D+(J-q<<2)>>2]|0);f[E+(J<<2)>>2]=K;J=J+m|0}while((J|0)<(g|0));F=F+1|0;if((F|0)==(m|0))break;else{E=E+4|0;D=D+4|0;H=H+1|0}}}else{H=0;D=A;E=z;while(1){f[E+(o<<2)>>2]=0;f[D+(o<<2)>>2]=0;H=H+1|0;if((H|0)==(m|0))break;else{D=D+4|0;E=E+4|0}}}B=B+1|0;if((B|0)==(l|0))break;else{A=A+(x<<2)+4+(C<<2)|0;z=z+(x<<2)+4+(y<<2)|0;s=s+x+1+e|0}}u=n;return}e=p+8|0;f[p>>2]=e;x=p+4|0;f[x>>2]=k;if(k>>>0>264){s=N5b(k>>>0>1073741823?-1:k<<2)|0;f[p>>2]=s;L=s}else L=e;s=(m|0)>0;do if(s){k=(g|0)==(m|0);y=q+(m<<1)|0;z=w+(m<<2)|0;if((g|0)>0){M=L;N=w;O=0;P=v;Q=t;R=a}else{C=L;A=w;B=0;i=v;E=t;while(1){f[A+(o<<2)>>2]=0;f[E+(o<<2)>>2]=0;if(k)f[C+(m<<2)>>2]=0;if(!i)S=0;else{f[i+(o<<2)>>2]=0;S=i+4|0}B=B+1|0;if((B|0)==(m|0))break;else{C=C+4|0;A=A+4|0;i=S;E=E+4|0}}T=L+(m<<2)|0;U=z;V=S;W=a+m|0;X=c+(y<<2)|0;break}while(1){f[N+(o<<2)>>2]=0;f[Q+(o<<2)>>2]=0;E=(P|0)!=0;if(E){i=0;A=0;C=0;do{B=h[R+C>>0]|0;f[N+(C<<2)>>2]=B;f[M+(C<<2)>>2]=B;A=B+A|0;i=(Y(B,B)|0)+i|0;f[Q+(C<<2)>>2]=A;f[P+(C<<2)>>2]=i;C=C+m|0}while((C|0)<(g|0))}else{C=0;i=0;do{A=h[R+i>>0]|0;f[N+(i<<2)>>2]=A;f[M+(i<<2)>>2]=A;C=A+C|0;f[Q+(i<<2)>>2]=C;i=i+m|0}while((i|0)<(g|0))}if(k)f[M+(m<<2)>>2]=0;if(E){f[P+(o<<2)>>2]=0;Z=P+4|0}else Z=0;O=O+1|0;if((O|0)==(m|0))break;else{M=M+4|0;N=N+4|0;P=Z;Q=Q+4|0;R=R+1|0}}T=L+(m<<2)|0;U=z;V=Z;W=a+m|0;X=c+(y<<2)|0}else{T=L;U=w;V=v;W=a;X=t}while(0);if((l|0)>1){t=b-m|0;a=q-m|0;v=d-m|0;w=r-m|0;c=0-q|0;Z=0-r|0;R=g-m|0;Q=(R|0)>(m|0);P=d+m|0;N=(g|0)>(m|0);g=T;T=U;U=1;M=X;X=V;V=W;while(1){W=V+t|0;O=M+(a<<2)|0;S=T+(v<<2)|0;k=g+(o<<2)|0;i=(X|0)==0?0:X+(w<<2)|0;if(s){C=M+(q<<2)|0;A=k;B=S;D=0;H=O;F=W;J=i;while(1){I=h[F>>0]|0;G=Y(I,I)|0;f[H+(o<<2)>>2]=0;K=(J|0)!=0;if(K)f[J+(o<<2)>>2]=0;_=B+(j<<2)|0;f[B+(o<<2)>>2]=f[_>>2];f[H>>2]=(f[H+(c<<2)>>2]|0)+I;if(K)f[J>>2]=(f[J+(Z<<2)>>2]|0)+G;f[B>>2]=(f[_>>2]|0)+I+(f[A+(m<<2)>>2]|0);if(Q)if(K){_=I;$=G;aa=I;ba=m;while(1){ca=f[A+(ba<<2)>>2]|0;f[A+(ba-m<<2)>>2]=ca+_;da=h[F+ba>>0]|0;ea=da+aa|0;fa=(Y(da,da)|0)+$|0;f[H+(ba<<2)>>2]=ea+(f[H+(ba-q<<2)>>2]|0);f[J+(ba<<2)>>2]=(f[J+(ba-r<<2)>>2]|0)+fa;ga=ba+m|0;f[B+(ba<<2)>>2]=da+ca+(f[A+(ga<<2)>>2]|0)+(f[B+(ba-P<<2)>>2]|0);if((ga|0)<(R|0)){_=da;$=fa;aa=ea;ba=ga}else{ha=da;ia=fa;ja=ea;ka=ga;break}}}else{ba=I;aa=G;$=I;_=m;while(1){E=f[A+(_<<2)>>2]|0;f[A+(_-m<<2)>>2]=E+ba;ga=h[F+_>>0]|0;ea=ga+$|0;fa=(Y(ga,ga)|0)+aa|0;f[H+(_<<2)>>2]=ea+(f[H+(_-q<<2)>>2]|0);da=_+m|0;f[B+(_<<2)>>2]=ga+E+(f[A+(da<<2)>>2]|0)+(f[B+(_-P<<2)>>2]|0);if((da|0)<(R|0)){ba=ga;aa=fa;$=ea;_=da}else{ha=ga;ia=fa;ja=ea;ka=da;break}}}else{ha=I;ia=G;ja=I;ka=m}if(N){_=A+(ka<<2)|0;$=f[_>>2]|0;f[A+(ka-m<<2)>>2]=$+ha;aa=h[F+ka>>0]|0;f[H+(ka<<2)>>2]=aa+ja+(f[H+(ka-q<<2)>>2]|0);if(K){ba=(Y(aa,aa)|0)+ia|0;f[J+(ka<<2)>>2]=ba+(f[J+(ka-r<<2)>>2]|0)}f[B+(ka<<2)>>2]=aa+$+(f[B+(ka-P<<2)>>2]|0);f[_>>2]=aa}J=K?J+4|0:0;D=D+1|0;if((D|0)==(m|0))break;else{A=A+4|0;B=B+4|0;H=H+4|0;F=F+1|0}}la=g;ma=T+(d<<2)|0;na=V+b|0;oa=C;pa=J}else{la=k;ma=S;na=W;oa=O;pa=i}U=U+1|0;if((U|0)==(l|0))break;else{g=la;T=ma;M=oa;X=pa;V=na}}}if((L|0)!=(e|0)){P5b(L);f[p>>2]=e;f[x>>2]=264}u=n;return}function t3(a,c,d,e,g,i,j,k,l,m,o){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;o=o|0;var q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0;q=u;u=u+1072|0;r=0-o|0;s=q;t=e>>>2;e=k>>>2;k=0-e|0;v=i>>>3;i=Y(o,l)|0;l=i+o|0;w=l<<2;Nac(d|0,0,w|0)|0;x=d+(t+o<<2)|0;if(!g)y=0;else{Nac(g|0,0,l<<3|0)|0;y=g+(v+o<<3)|0}if(!j)z=0;else{Nac(j|0,0,w|0)|0;z=j+(e+o<<2)|0}j=(z|0)==0;if((y|0)==0&j){if((m|0)<=0){u=q;return}w=(i|0)>0;g=c-o|0;A=t-o|0;if((o|0)<=0){u=q;return}B=o+-1|0;C=o<<2;D=x;E=0;F=a;while(1){if(w){G=0;H=D;I=F;while(1){n[H+(r<<2)>>2]=0.0;J=0.0;K=0;do{J=J+ +(h[I+K>>0]|0);n[H+(K<<2)>>2]=+n[H+(K-t<<2)>>2]+J;K=K+o|0}while((K|0)<(i|0));G=G+1|0;if((G|0)==(o|0))break;else{H=H+4|0;I=I+1|0}}}else Nac(D+(r<<2)|0,0,C|0)|0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+(B<<2)+4+(A<<2)|0;F=F+B+1+g|0}}u=q;return}if(j){if((m|0)<=0){u=q;return}j=(i|0)>0;g=c-o|0;B=t-o|0;F=v-o|0;if((o|0)<=0){u=q;return}A=o+-1|0;D=y;E=0;C=x;w=a;while(1){if(j){I=0;H=D;G=C;K=w;while(1){n[G+(r<<2)>>2]=0.0;p[H+(r<<3)>>3]=0.0;J=0.0;L=0.0;M=0;do{N=b[K+M>>0]|0;L=L+ +(N&255);O=+(N&255);J=J+O*O;O=+p[H+(M-v<<3)>>3]+J;n[G+(M<<2)>>2]=+n[G+(M-t<<2)>>2]+L;p[H+(M<<3)>>3]=O;M=M+o|0}while((M|0)<(i|0));I=I+1|0;if((I|0)==(o|0))break;else{H=H+8|0;G=G+4|0;K=K+1|0}}}else{K=0;G=D;H=C;while(1){n[H+(r<<2)>>2]=0.0;p[G+(r<<3)>>3]=0.0;K=K+1|0;if((K|0)==(o|0))break;else{G=G+8|0;H=H+4|0}}}E=E+1|0;if((E|0)==(m|0))break;else{D=D+(A<<3)+8+(F<<3)|0;C=C+(A<<2)+4+(B<<2)|0;w=w+A+1+g|0}}u=q;return}g=s+8|0;f[s>>2]=g;A=s+4|0;f[A>>2]=l;if(l>>>0>264){w=N5b(l>>>0>1073741823?-1:l<<2)|0;f[s>>2]=w;P=w}else P=g;w=(o|0)>0;do if(w){l=(i|0)==(o|0);B=t+(o<<1)|0;C=z+(o<<2)|0;if((i|0)>0){Q=P;R=z;S=0;T=y;U=x;V=a}else{F=P;D=z;E=0;j=y;H=x;while(1){n[D+(r<<2)>>2]=0.0;n[H+(r<<2)>>2]=0.0;if(l)n[F+(o<<2)>>2]=0.0;if(!j)W=0;else{p[j+(r<<3)>>3]=0.0;W=j+8|0}E=E+1|0;if((E|0)==(o|0))break;else{F=F+4|0;D=D+4|0;j=W;H=H+4|0}}X=P+(o<<2)|0;Z=C;_=W;$=a+o|0;aa=d+(B<<2)|0;break}while(1){n[R+(r<<2)>>2]=0.0;n[U+(r<<2)>>2]=0.0;H=(T|0)!=0;if(H){L=0.0;J=0.0;j=0;do{D=b[V+j>>0]|0;O=+(D&255);n[R+(j<<2)>>2]=O;n[Q+(j<<2)>>2]=O;J=J+O;O=+(D&255);L=L+O*O;n[U+(j<<2)>>2]=J;p[T+(j<<3)>>3]=L;j=j+o|0}while((j|0)<(i|0))}else{L=0.0;j=0;do{J=+(h[V+j>>0]|0);n[R+(j<<2)>>2]=J;n[Q+(j<<2)>>2]=J;L=L+J;n[U+(j<<2)>>2]=L;j=j+o|0}while((j|0)<(i|0))}if(l)n[Q+(o<<2)>>2]=0.0;if(H){p[T+(r<<3)>>3]=0.0;ba=T+8|0}else ba=0;S=S+1|0;if((S|0)==(o|0))break;else{Q=Q+4|0;R=R+4|0;T=ba;U=U+4|0;V=V+1|0}}X=P+(o<<2)|0;Z=C;_=ba;$=a+o|0;aa=d+(B<<2)|0}else{X=P;Z=z;_=y;$=a;aa=x}while(0);if((m|0)>1){x=c-o|0;a=t-o|0;y=e-o|0;z=v-o|0;d=0-t|0;ba=0-v|0;V=i-o|0;U=(V|0)>(o|0);T=e+o|0;R=(i|0)>(o|0);i=X;X=Z;Z=1;Q=aa;aa=_;_=$;while(1){$=_+x|0;S=Q+(a<<2)|0;W=X+(y<<2)|0;l=i+(r<<2)|0;j=(aa|0)==0?0:aa+(z<<3)|0;if(w){D=Q+(t<<2)|0;F=l;E=W;G=0;K=S;I=$;M=j;while(1){N=b[I>>0]|0;L=+(N&255);J=+(N&255);O=J*J;n[K+(r<<2)>>2]=0.0;N=(M|0)!=0;if(N)p[M+(r<<3)>>3]=0.0;ca=E+(k<<2)|0;f[E+(r<<2)>>2]=f[ca>>2];n[K>>2]=L+ +n[K+(d<<2)>>2];if(N)p[M>>3]=O+ +p[M+(ba<<3)>>3];n[E>>2]=L+ +n[ca>>2]+ +n[F+(o<<2)>>2];if(U)if(N){J=L;da=O;ea=L;ca=o;while(1){fa=+n[F+(ca<<2)>>2];n[F+(ca-o<<2)>>2]=J+fa;ga=b[I+ca>>0]|0;ha=+(ga&255);ia=+(ga&255);ja=ea+ha;ka=da+ia*ia;n[K+(ca<<2)>>2]=+n[K+(ca-t<<2)>>2]+ja;p[M+(ca<<3)>>3]=ka+ +p[M+(ca-v<<3)>>3];ga=ca+o|0;n[E+(ca<<2)>>2]=fa+(ha+ +n[F+(ga<<2)>>2]+ +n[E+(ca-T<<2)>>2]);if((ga|0)<(V|0)){J=ha;da=ka;ea=ja;ca=ga}else{la=ha;ma=ka;na=ja;oa=ga;break}}}else{ea=L;da=O;J=L;ca=o;while(1){ja=+n[F+(ca<<2)>>2];n[F+(ca-o<<2)>>2]=ea+ja;H=b[I+ca>>0]|0;ka=+(H&255);ha=+(H&255);fa=J+ka;ia=da+ha*ha;n[K+(ca<<2)>>2]=+n[K+(ca-t<<2)>>2]+fa;H=ca+o|0;n[E+(ca<<2)>>2]=ja+(ka+ +n[F+(H<<2)>>2]+ +n[E+(ca-T<<2)>>2]);if((H|0)<(V|0)){ea=ka;da=ia;J=fa;ca=H}else{la=ka;ma=ia;na=fa;oa=H;break}}}else{la=L;ma=O;na=L;oa=o}if(R){ca=F+(oa<<2)|0;J=+n[ca>>2];n[F+(oa-o<<2)>>2]=la+J;H=b[I+oa>>0]|0;da=+(H&255);n[K+(oa<<2)>>2]=+n[K+(oa-t<<2)>>2]+(na+da);ea=+(H&255);if(N)p[M+(oa<<3)>>3]=ma+ea*ea+ +p[M+(oa-v<<3)>>3];n[E+(oa<<2)>>2]=J+da+ +n[E+(oa-T<<2)>>2];n[ca>>2]=da}M=N?M+8|0:0;G=G+1|0;if((G|0)==(o|0))break;else{F=F+4|0;E=E+4|0;K=K+4|0;I=I+1|0}}pa=i;qa=X+(e<<2)|0;ra=_+c|0;sa=D;ta=M}else{pa=l;qa=W;ra=$;sa=S;ta=j}Z=Z+1|0;if((Z|0)==(m|0))break;else{i=pa;X=qa;Q=sa;aa=ta;_=ra}}}if((P|0)!=(g|0)){P5b(P);f[s>>2]=g;f[A>>2]=264}u=q;return}function u3(a,b,c,d,e,g,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;o=u;u=u+1072|0;p=0-m|0;q=o;r=d>>>2;d=j>>>2;j=0-d|0;s=g>>>2;g=Y(m,k)|0;k=g+m|0;t=k<<2;Nac(c|0,0,t|0)|0;v=c+(r+m<<2)|0;if(!e)w=0;else{Nac(e|0,0,t|0)|0;w=e+(s+m<<2)|0}if(!i)x=0;else{Nac(i|0,0,t|0)|0;x=i+(d+m<<2)|0}i=(x|0)==0;if((w|0)==0&i){if((l|0)<=0){u=o;return}t=(g|0)>0;e=b-m|0;y=r-m|0;if((m|0)<=0){u=o;return}z=m+-1|0;A=m<<2;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){n[F+(p<<2)>>2]=0.0;H=0.0;I=0;do{H=H+ +(h[G+I>>0]|0);n[F+(I<<2)>>2]=+n[F+(I-r<<2)>>2]+H;I=I+m|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+4|0;G=G+1|0}}}else Nac(B+(p<<2)|0,0,A|0)|0;C=C+1|0;if((C|0)==(l|0))break;else{B=B+(z<<2)+4+(y<<2)|0;D=D+z+1+e|0}}u=o;return}if(i){if((l|0)<=0){u=o;return}i=(g|0)>0;e=b-m|0;z=r-m|0;D=s-m|0;if((m|0)<=0){u=o;return}y=m+-1|0;B=w;C=0;A=v;t=a;while(1){if(i){G=0;F=B;E=A;I=t;while(1){n[E+(p<<2)>>2]=0.0;n[F+(p<<2)>>2]=0.0;H=0.0;J=0.0;K=0;do{L=+(h[I+K>>0]|0);J=J+L;H=H+L*L;L=+n[F+(K-s<<2)>>2]+H;n[E+(K<<2)>>2]=+n[E+(K-r<<2)>>2]+J;n[F+(K<<2)>>2]=L;K=K+m|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+4|0;E=E+4|0;I=I+1|0}}}else{I=0;E=B;F=A;while(1){n[F+(p<<2)>>2]=0.0;n[E+(p<<2)>>2]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+4|0;F=F+4|0}}}C=C+1|0;if((C|0)==(l|0))break;else{B=B+(y<<2)+4+(D<<2)|0;A=A+(y<<2)+4+(z<<2)|0;t=t+y+1+e|0}}u=o;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=k;if(k>>>0>264){t=N5b(k>>>0>1073741823?-1:k<<2)|0;f[q>>2]=t;M=t}else M=e;t=(m|0)>0;do if(t){k=(g|0)==(m|0);z=r+(m<<1)|0;A=x+(m<<2)|0;if((g|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;i=w;F=v;while(1){n[B+(p<<2)>>2]=0.0;n[F+(p<<2)>>2]=0.0;if(k)n[D+(m<<2)>>2]=0.0;if(!i)T=0;else{n[i+(p<<2)>>2]=0.0;T=i+4|0}C=C+1|0;if((C|0)==(m|0))break;else{D=D+4|0;B=B+4|0;i=T;F=F+4|0}}U=M+(m<<2)|0;V=A;W=T;X=a+m|0;Z=c+(z<<2)|0;break}while(1){n[O+(p<<2)>>2]=0.0;n[R+(p<<2)>>2]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;i=0;do{L=+(h[S+i>>0]|0);n[O+(i<<2)>>2]=L;n[N+(i<<2)>>2]=L;H=H+L;J=J+L*L;n[R+(i<<2)>>2]=H;n[Q+(i<<2)>>2]=J;i=i+m|0}while((i|0)<(g|0))}else{J=0.0;i=0;do{H=+(h[S+i>>0]|0);n[O+(i<<2)>>2]=H;n[N+(i<<2)>>2]=H;J=J+H;n[R+(i<<2)>>2]=J;i=i+m|0}while((i|0)<(g|0))}if(k)n[N+(m<<2)>>2]=0.0;if(F){n[Q+(p<<2)>>2]=0.0;_=Q+4|0}else _=0;P=P+1|0;if((P|0)==(m|0))break;else{N=N+4|0;O=O+4|0;Q=_;R=R+4|0;S=S+1|0}}U=M+(m<<2)|0;V=A;W=_;X=a+m|0;Z=c+(z<<2)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((l|0)>1){v=b-m|0;a=r-m|0;w=d-m|0;x=s-m|0;c=0-r|0;_=0-s|0;S=g-m|0;R=(S|0)>(m|0);Q=d+m|0;O=(g|0)>(m|0);g=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+v|0;P=N+(a<<2)|0;T=U+(w<<2)|0;k=g+(p<<2)|0;i=(Z|0)==0?0:Z+(x<<2)|0;if(t){B=N+(r<<2)|0;D=k;C=T;E=0;I=P;G=X;K=i;while(1){J=+(h[G>>0]|0);H=J*J;n[I+(p<<2)>>2]=0.0;$=(K|0)!=0;if($)n[K+(p<<2)>>2]=0.0;aa=C+(j<<2)|0;f[C+(p<<2)>>2]=f[aa>>2];n[I>>2]=J+ +n[I+(c<<2)>>2];if($)n[K>>2]=H+ +n[K+(_<<2)>>2];n[C>>2]=J+ +n[aa>>2]+ +n[D+(m<<2)>>2];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+n[D+(aa<<2)>>2];n[D+(aa-m<<2)>>2]=L+da;ea=+(h[G+aa>>0]|0);fa=ca+ea;ga=ba+ea*ea;n[I+(aa<<2)>>2]=+n[I+(aa-r<<2)>>2]+fa;n[K+(aa<<2)>>2]=ga+ +n[K+(aa-s<<2)>>2];ha=aa+m|0;n[C+(aa<<2)>>2]=da+(ea+ +n[D+(ha<<2)>>2]+ +n[C+(aa-Q<<2)>>2]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){fa=+n[D+(aa<<2)>>2];n[D+(aa-m<<2)>>2]=ca+fa;ga=+(h[G+aa>>0]|0);ea=L+ga;da=ba+ga*ga;n[I+(aa<<2)>>2]=+n[I+(aa-r<<2)>>2]+ea;F=aa+m|0;n[C+(aa<<2)>>2]=fa+(ga+ +n[D+(F<<2)>>2]+ +n[C+(aa-Q<<2)>>2]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(O){aa=D+(la<<2)|0;L=+n[aa>>2];n[D+(la-m<<2)>>2]=ia+L;ba=+(h[G+la>>0]|0);n[I+(la<<2)>>2]=+n[I+(la-r<<2)>>2]+(ka+ba);if($)n[K+(la<<2)>>2]=ja+ba*ba+ +n[K+(la-s<<2)>>2];n[C+(la<<2)>>2]=L+ba+ +n[C+(la-Q<<2)>>2];n[aa>>2]=ba}K=$?K+4|0:0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+4|0;C=C+4|0;I=I+4|0;G=G+1|0}}ma=g;na=U+(d<<2)|0;oa=W+b|0;pa=B;qa=K}else{ma=k;na=T;oa=X;pa=P;qa=i}V=V+1|0;if((V|0)==(l|0))break;else{g=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(e|0)){P5b(M);f[q>>2]=e;f[y>>2]=264}u=o;return}function v3(a,b,c,d,e,g,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;n=u;u=u+1104|0;o=0-m|0;q=n;r=d>>>3;d=j>>>3;j=0-d|0;s=g>>>3;g=Y(m,k)|0;k=g+m|0;t=k<<3;Nac(c|0,0,t|0)|0;v=c+(r+m<<3)|0;if(!e)w=0;else{Nac(e|0,0,t|0)|0;w=e+(s+m<<3)|0}if(!i)x=0;else{Nac(i|0,0,t|0)|0;x=i+(d+m<<3)|0}i=(x|0)==0;if((w|0)==0&i){if((l|0)<=0){u=n;return}t=(g|0)>0;e=b-m|0;y=r-m|0;if((m|0)<=0){u=n;return}z=m+-1|0;A=m<<3;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){p[F+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +(h[G+I>>0]|0);p[F+(I<<3)>>3]=+p[F+(I-r<<3)>>3]+H;I=I+m|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+8|0;G=G+1|0}}}else Nac(B+(o<<3)|0,0,A|0)|0;C=C+1|0;if((C|0)==(l|0))break;else{B=B+(z<<3)+8+(y<<3)|0;D=D+z+1+e|0}}u=n;return}if(i){if((l|0)<=0){u=n;return}i=(g|0)>0;e=b-m|0;z=r-m|0;D=s-m|0;if((m|0)<=0){u=n;return}y=m+-1|0;B=w;C=0;A=v;t=a;while(1){if(i){G=0;F=B;E=A;I=t;while(1){p[E+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+(h[I+K>>0]|0);J=J+L;H=H+L*L;L=+p[F+(K-s<<3)>>3]+H;p[E+(K<<3)>>3]=+p[E+(K-r<<3)>>3]+J;p[F+(K<<3)>>3]=L;K=K+m|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+8|0;E=E+8|0;I=I+1|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+8|0;F=F+8|0}}}C=C+1|0;if((C|0)==(l|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<3)+8+(z<<3)|0;t=t+y+1+e|0}}u=n;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=k;if(k>>>0>136){t=N5b(k>>>0>536870911?-1:k<<3)|0;f[q>>2]=t;M=t}else M=e;t=(m|0)>0;do if(t){k=(g|0)==(m|0);z=r+(m<<1)|0;A=x+(m<<3)|0;if((g|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;i=w;F=v;while(1){p[B+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;if(k)p[D+(m<<3)>>3]=0.0;if(!i)T=0;else{p[i+(o<<3)>>3]=0.0;T=i+8|0}C=C+1|0;if((C|0)==(m|0))break;else{D=D+8|0;B=B+8|0;i=T;F=F+8|0}}U=M+(m<<3)|0;V=A;W=T;X=a+m|0;Z=c+(z<<3)|0;break}while(1){p[O+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;i=0;do{L=+(h[S+i>>0]|0);p[O+(i<<3)>>3]=L;p[N+(i<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(i<<3)>>3]=H;p[Q+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(g|0))}else{J=0.0;i=0;do{H=+(h[S+i>>0]|0);p[O+(i<<3)>>3]=H;p[N+(i<<3)>>3]=H;J=J+H;p[R+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(g|0))}if(k)p[N+(m<<3)>>3]=0.0;if(F){p[Q+(o<<3)>>3]=0.0;_=Q+8|0}else _=0;P=P+1|0;if((P|0)==(m|0))break;else{N=N+8|0;O=O+8|0;Q=_;R=R+8|0;S=S+1|0}}U=M+(m<<3)|0;V=A;W=_;X=a+m|0;Z=c+(z<<3)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((l|0)>1){v=b-m|0;a=r-m|0;w=d-m|0;x=s-m|0;c=0-r|0;_=0-s|0;S=g-m|0;R=(S|0)>(m|0);Q=d+m|0;O=(g|0)>(m|0);g=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+v|0;P=N+(a<<3)|0;T=U+(w<<3)|0;k=g+(o<<3)|0;i=(Z|0)==0?0:Z+(x<<3)|0;if(t){B=N+(r<<3)|0;D=k;C=T;E=0;I=P;G=X;K=i;while(1){J=+(h[G>>0]|0);H=J*J;p[I+(o<<3)>>3]=0.0;$=(K|0)!=0;if($)p[K+(o<<3)>>3]=0.0;aa=C+(j<<3)|0;p[C+(o<<3)>>3]=+p[aa>>3];p[I>>3]=J+ +p[I+(c<<3)>>3];if($)p[K>>3]=H+ +p[K+(_<<3)>>3];p[C>>3]=J+ +p[aa>>3]+ +p[D+(m<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=L+da;ea=+(h[G+aa>>0]|0);fa=ca+ea;ga=ba+ea*ea;p[I+(aa<<3)>>3]=+p[I+(aa-r<<3)>>3]+fa;p[K+(aa<<3)>>3]=ga+ +p[K+(aa-s<<3)>>3];ha=aa+m|0;p[C+(aa<<3)>>3]=da+(ea+ +p[D+(ha<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){fa=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=ca+fa;ga=+(h[G+aa>>0]|0);ea=L+ga;da=ba+ga*ga;p[I+(aa<<3)>>3]=+p[I+(aa-r<<3)>>3]+ea;F=aa+m|0;p[C+(aa<<3)>>3]=fa+(ga+ +p[D+(F<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(O){aa=D+(la<<3)|0;L=+p[aa>>3];p[D+(la-m<<3)>>3]=ia+L;ba=+(h[G+la>>0]|0);p[I+(la<<3)>>3]=+p[I+(la-r<<3)>>3]+(ka+ba);if($)p[K+(la<<3)>>3]=ja+ba*ba+ +p[K+(la-s<<3)>>3];p[C+(la<<3)>>3]=L+ba+ +p[C+(la-Q<<3)>>3];p[aa>>3]=ba}K=$?K+8|0:0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+8|0;C=C+8|0;I=I+8|0;G=G+1|0}}ma=g;na=U+(d<<3)|0;oa=W+b|0;pa=B;qa=K}else{ma=k;na=T;oa=X;pa=P;qa=i}V=V+1|0;if((V|0)==(l|0))break;else{g=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(e|0)){P5b(M);f[q>>2]=e;f[y>>2]=136}u=n;return}function w3(a,b,c,d,e,g,h,i,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;n=u;u=u+1104|0;o=0-m|0;q=n;r=b>>>1;b=d>>>3;d=i>>>3;i=0-d|0;s=g>>>3;g=Y(m,k)|0;k=g+m|0;t=k<<3;Nac(c|0,0,t|0)|0;v=c+(b+m<<3)|0;if(!e)w=0;else{Nac(e|0,0,t|0)|0;w=e+(s+m<<3)|0}if(!h)x=0;else{Nac(h|0,0,t|0)|0;x=h+(d+m<<3)|0}h=(x|0)==0;if((w|0)==0&h){if((l|0)<=0){u=n;return}t=(g|0)>0;e=r-m|0;y=b-m|0;if((m|0)<=0){u=n;return}z=m+-1|0;A=m<<3;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){p[F+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +(j[G+(I<<1)>>1]|0);p[F+(I<<3)>>3]=+p[F+(I-b<<3)>>3]+H;I=I+m|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+8|0;G=G+2|0}}}else Nac(B+(o<<3)|0,0,A|0)|0;C=C+1|0;if((C|0)==(l|0))break;else{B=B+(z<<3)+8+(y<<3)|0;D=D+(z<<1)+2+(e<<1)|0}}u=n;return}if(h){if((l|0)<=0){u=n;return}h=(g|0)>0;e=r-m|0;z=b-m|0;D=s-m|0;if((m|0)<=0){u=n;return}y=m+-1|0;B=w;C=0;A=v;t=a;while(1){if(h){G=0;F=B;E=A;I=t;while(1){p[E+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+(j[I+(K<<1)>>1]|0);J=J+L;H=H+L*L;L=+p[F+(K-s<<3)>>3]+H;p[E+(K<<3)>>3]=+p[E+(K-b<<3)>>3]+J;p[F+(K<<3)>>3]=L;K=K+m|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+8|0;E=E+8|0;I=I+2|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+8|0;F=F+8|0}}}C=C+1|0;if((C|0)==(l|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<3)+8+(z<<3)|0;t=t+(y<<1)+2+(e<<1)|0}}u=n;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=k;if(k>>>0>136){t=N5b(k>>>0>536870911?-1:k<<3)|0;f[q>>2]=t;M=t}else M=e;t=(m|0)>0;do if(t){k=(g|0)==(m|0);z=b+(m<<1)|0;A=x+(m<<3)|0;if((g|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;h=w;F=v;while(1){p[B+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;if(k)p[D+(m<<3)>>3]=0.0;if(!h)T=0;else{p[h+(o<<3)>>3]=0.0;T=h+8|0}C=C+1|0;if((C|0)==(m|0))break;else{D=D+8|0;B=B+8|0;h=T;F=F+8|0}}U=M+(m<<3)|0;V=A;W=T;X=a+(m<<1)|0;Z=c+(z<<3)|0;break}while(1){p[O+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;h=0;do{L=+(j[S+(h<<1)>>1]|0);p[O+(h<<3)>>3]=L;p[N+(h<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(h<<3)>>3]=H;p[Q+(h<<3)>>3]=J;h=h+m|0}while((h|0)<(g|0))}else{J=0.0;h=0;do{H=+(j[S+(h<<1)>>1]|0);p[O+(h<<3)>>3]=H;p[N+(h<<3)>>3]=H;J=J+H;p[R+(h<<3)>>3]=J;h=h+m|0}while((h|0)<(g|0))}if(k)p[N+(m<<3)>>3]=0.0;if(F){p[Q+(o<<3)>>3]=0.0;_=Q+8|0}else _=0;P=P+1|0;if((P|0)==(m|0))break;else{N=N+8|0;O=O+8|0;Q=_;R=R+8|0;S=S+2|0}}U=M+(m<<3)|0;V=A;W=_;X=a+(m<<1)|0;Z=c+(z<<3)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((l|0)>1){v=r-m|0;a=b-m|0;w=d-m|0;x=s-m|0;c=0-b|0;_=0-s|0;S=g-m|0;R=(S|0)>(m|0);Q=d+m|0;O=(g|0)>(m|0);g=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+(v<<1)|0;P=N+(a<<3)|0;T=U+(w<<3)|0;k=g+(o<<3)|0;h=(Z|0)==0?0:Z+(x<<3)|0;if(t){B=N+(b<<3)|0;D=k;C=T;E=0;I=P;G=X;K=h;while(1){J=+(j[G>>1]|0);H=J*J;p[I+(o<<3)>>3]=0.0;$=(K|0)!=0;if($)p[K+(o<<3)>>3]=0.0;aa=C+(i<<3)|0;p[C+(o<<3)>>3]=+p[aa>>3];p[I>>3]=J+ +p[I+(c<<3)>>3];if($)p[K>>3]=H+ +p[K+(_<<3)>>3];p[C>>3]=J+ +p[aa>>3]+ +p[D+(m<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=L+da;ea=+(j[G+(aa<<1)>>1]|0);fa=ca+ea;ga=ba+ea*ea;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+fa;p[K+(aa<<3)>>3]=ga+ +p[K+(aa-s<<3)>>3];ha=aa+m|0;p[C+(aa<<3)>>3]=da+(ea+ +p[D+(ha<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){fa=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=ca+fa;ga=+(j[G+(aa<<1)>>1]|0);ea=L+ga;da=ba+ga*ga;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+ea;F=aa+m|0;p[C+(aa<<3)>>3]=fa+(ga+ +p[D+(F<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(O){aa=D+(la<<3)|0;L=+p[aa>>3];p[D+(la-m<<3)>>3]=ia+L;ba=+(j[G+(la<<1)>>1]|0);p[I+(la<<3)>>3]=+p[I+(la-b<<3)>>3]+(ka+ba);if($)p[K+(la<<3)>>3]=ja+ba*ba+ +p[K+(la-s<<3)>>3];p[C+(la<<3)>>3]=L+ba+ +p[C+(la-Q<<3)>>3];p[aa>>3]=ba}K=$?K+8|0:0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+8|0;C=C+8|0;I=I+8|0;G=G+2|0}}ma=g;na=U+(d<<3)|0;oa=W+(r<<1)|0;pa=B;qa=K}else{ma=k;na=T;oa=X;pa=P;qa=h}V=V+1|0;if((V|0)==(l|0))break;else{g=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(e|0)){P5b(M);f[q>>2]=e;f[y>>2]=136}u=n;return}function x3(a,b,c,e,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;n=u;u=u+1104|0;o=0-m|0;q=n;r=b>>>1;b=e>>>3;e=j>>>3;j=0-e|0;s=h>>>3;h=Y(m,k)|0;k=h+m|0;t=k<<3;Nac(c|0,0,t|0)|0;v=c+(b+m<<3)|0;if(!g)w=0;else{Nac(g|0,0,t|0)|0;w=g+(s+m<<3)|0}if(!i)x=0;else{Nac(i|0,0,t|0)|0;x=i+(e+m<<3)|0}i=(x|0)==0;if((w|0)==0&i){if((l|0)<=0){u=n;return}t=(h|0)>0;g=r-m|0;y=b-m|0;if((m|0)<=0){u=n;return}z=m+-1|0;A=m<<3;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){p[F+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +(d[G+(I<<1)>>1]|0);p[F+(I<<3)>>3]=+p[F+(I-b<<3)>>3]+H;I=I+m|0}while((I|0)<(h|0));E=E+1|0;if((E|0)==(m|0))break;else{F=F+8|0;G=G+2|0}}}else Nac(B+(o<<3)|0,0,A|0)|0;C=C+1|0;if((C|0)==(l|0))break;else{B=B+(z<<3)+8+(y<<3)|0;D=D+(z<<1)+2+(g<<1)|0}}u=n;return}if(i){if((l|0)<=0){u=n;return}i=(h|0)>0;g=r-m|0;z=b-m|0;D=s-m|0;if((m|0)<=0){u=n;return}y=m+-1|0;B=w;C=0;A=v;t=a;while(1){if(i){G=0;F=B;E=A;I=t;while(1){p[E+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+(d[I+(K<<1)>>1]|0);J=J+L;H=H+L*L;L=+p[F+(K-s<<3)>>3]+H;p[E+(K<<3)>>3]=+p[E+(K-b<<3)>>3]+J;p[F+(K<<3)>>3]=L;K=K+m|0}while((K|0)<(h|0));G=G+1|0;if((G|0)==(m|0))break;else{F=F+8|0;E=E+8|0;I=I+2|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(m|0))break;else{E=E+8|0;F=F+8|0}}}C=C+1|0;if((C|0)==(l|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<3)+8+(z<<3)|0;t=t+(y<<1)+2+(g<<1)|0}}u=n;return}g=q+8|0;f[q>>2]=g;y=q+4|0;f[y>>2]=k;if(k>>>0>136){t=N5b(k>>>0>536870911?-1:k<<3)|0;f[q>>2]=t;M=t}else M=g;t=(m|0)>0;do if(t){k=(h|0)==(m|0);z=b+(m<<1)|0;A=x+(m<<3)|0;if((h|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;i=w;F=v;while(1){p[B+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;if(k)p[D+(m<<3)>>3]=0.0;if(!i)T=0;else{p[i+(o<<3)>>3]=0.0;T=i+8|0}C=C+1|0;if((C|0)==(m|0))break;else{D=D+8|0;B=B+8|0;i=T;F=F+8|0}}U=M+(m<<3)|0;V=A;W=T;X=a+(m<<1)|0;Z=c+(z<<3)|0;break}while(1){p[O+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;i=0;do{L=+(d[S+(i<<1)>>1]|0);p[O+(i<<3)>>3]=L;p[N+(i<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(i<<3)>>3]=H;p[Q+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(h|0))}else{J=0.0;i=0;do{H=+(d[S+(i<<1)>>1]|0);p[O+(i<<3)>>3]=H;p[N+(i<<3)>>3]=H;J=J+H;p[R+(i<<3)>>3]=J;i=i+m|0}while((i|0)<(h|0))}if(k)p[N+(m<<3)>>3]=0.0;if(F){p[Q+(o<<3)>>3]=0.0;_=Q+8|0}else _=0;P=P+1|0;if((P|0)==(m|0))break;else{N=N+8|0;O=O+8|0;Q=_;R=R+8|0;S=S+2|0}}U=M+(m<<3)|0;V=A;W=_;X=a+(m<<1)|0;Z=c+(z<<3)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((l|0)>1){v=r-m|0;a=b-m|0;w=e-m|0;x=s-m|0;c=0-b|0;_=0-s|0;S=h-m|0;R=(S|0)>(m|0);Q=e+m|0;O=(h|0)>(m|0);h=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+(v<<1)|0;P=N+(a<<3)|0;T=U+(w<<3)|0;k=h+(o<<3)|0;i=(Z|0)==0?0:Z+(x<<3)|0;if(t){B=N+(b<<3)|0;D=k;C=T;E=0;I=P;G=X;K=i;while(1){J=+(d[G>>1]|0);H=J*J;p[I+(o<<3)>>3]=0.0;$=(K|0)!=0;if($)p[K+(o<<3)>>3]=0.0;aa=C+(j<<3)|0;p[C+(o<<3)>>3]=+p[aa>>3];p[I>>3]=J+ +p[I+(c<<3)>>3];if($)p[K>>3]=H+ +p[K+(_<<3)>>3];p[C>>3]=J+ +p[aa>>3]+ +p[D+(m<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=m;while(1){da=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=L+da;ea=+(d[G+(aa<<1)>>1]|0);fa=ca+ea;ga=ba+ea*ea;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+fa;p[K+(aa<<3)>>3]=ga+ +p[K+(aa-s<<3)>>3];ha=aa+m|0;p[C+(aa<<3)>>3]=da+(ea+ +p[D+(ha<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=m;while(1){fa=+p[D+(aa<<3)>>3];p[D+(aa-m<<3)>>3]=ca+fa;ga=+(d[G+(aa<<1)>>1]|0);ea=L+ga;da=ba+ga*ga;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+ea;F=aa+m|0;p[C+(aa<<3)>>3]=fa+(ga+ +p[D+(F<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=m}if(O){aa=D+(la<<3)|0;L=+p[aa>>3];p[D+(la-m<<3)>>3]=ia+L;ba=+(d[G+(la<<1)>>1]|0);p[I+(la<<3)>>3]=+p[I+(la-b<<3)>>3]+(ka+ba);if($)p[K+(la<<3)>>3]=ja+ba*ba+ +p[K+(la-s<<3)>>3];p[C+(la<<3)>>3]=L+ba+ +p[C+(la-Q<<3)>>3];p[aa>>3]=ba}K=$?K+8|0:0;E=E+1|0;if((E|0)==(m|0))break;else{D=D+8|0;C=C+8|0;I=I+8|0;G=G+2|0}}ma=h;na=U+(e<<3)|0;oa=W+(r<<1)|0;pa=B;qa=K}else{ma=k;na=T;oa=X;pa=P;qa=i}V=V+1|0;if((V|0)==(l|0))break;else{h=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(g|0)){P5b(M);f[q>>2]=g;f[y>>2]=136}u=n;return}function y3(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0;m=u;u=u+1072|0;o=0-l|0;q=m;r=b>>>2;b=d>>>2;d=i>>>2;i=0-d|0;s=g>>>3;g=Y(l,j)|0;j=g+l|0;t=j<<2;Nac(c|0,0,t|0)|0;v=c+(b+l<<2)|0;if(!e)w=0;else{Nac(e|0,0,j<<3|0)|0;w=e+(s+l<<3)|0}if(!h)x=0;else{Nac(h|0,0,t|0)|0;x=h+(d+l<<2)|0}h=(x|0)==0;if((w|0)==0&h){if((k|0)<=0){u=m;return}t=(g|0)>0;e=r-l|0;y=b-l|0;if((l|0)<=0){u=m;return}z=l+-1|0;A=l<<2;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){n[F+(o<<2)>>2]=0.0;H=0.0;I=0;do{H=H+ +n[G+(I<<2)>>2];n[F+(I<<2)>>2]=+n[F+(I-b<<2)>>2]+H;I=I+l|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(l|0))break;else{F=F+4|0;G=G+4|0}}}else Nac(B+(o<<2)|0,0,A|0)|0;C=C+1|0;if((C|0)==(k|0))break;else{B=B+(z<<2)+4+(y<<2)|0;D=D+(z<<2)+4+(e<<2)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;e=r-l|0;z=b-l|0;D=s-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;B=w;C=0;A=v;t=a;while(1){if(h){G=0;F=B;E=A;I=t;while(1){n[E+(o<<2)>>2]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+n[I+(K<<2)>>2];J=J+L;M=L;H=H+M*M;M=+p[F+(K-s<<3)>>3]+H;n[E+(K<<2)>>2]=+n[E+(K-b<<2)>>2]+J;p[F+(K<<3)>>3]=M;K=K+l|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(l|0))break;else{F=F+8|0;E=E+4|0;I=I+4|0}}}else{I=0;E=B;F=A;while(1){n[F+(o<<2)>>2]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(l|0))break;else{E=E+8|0;F=F+4|0}}}C=C+1|0;if((C|0)==(k|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<2)+4+(z<<2)|0;t=t+(y<<2)+4+(e<<2)|0}}u=m;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=j;if(j>>>0>264){t=N5b(j>>>0>1073741823?-1:j<<2)|0;f[q>>2]=t;N=t}else N=e;t=(l|0)>0;do if(t){j=(g|0)==(l|0);z=b+(l<<1)|0;A=x+(l<<2)|0;if((g|0)>0){O=N;P=x;Q=0;R=w;S=v;T=a}else{D=N;B=x;C=0;h=w;F=v;while(1){n[B+(o<<2)>>2]=0.0;n[F+(o<<2)>>2]=0.0;if(j)n[D+(l<<2)>>2]=0.0;if(!h)U=0;else{p[h+(o<<3)>>3]=0.0;U=h+8|0}C=C+1|0;if((C|0)==(l|0))break;else{D=D+4|0;B=B+4|0;h=U;F=F+4|0}}V=N+(l<<2)|0;W=A;X=U;Z=a+(l<<2)|0;_=c+(z<<2)|0;break}while(1){n[P+(o<<2)>>2]=0.0;n[S+(o<<2)>>2]=0.0;F=(R|0)!=0;if(F){J=0.0;H=0.0;h=0;do{M=+n[T+(h<<2)>>2];n[P+(h<<2)>>2]=M;n[O+(h<<2)>>2]=M;H=H+M;L=M;J=J+L*L;n[S+(h<<2)>>2]=H;p[R+(h<<3)>>3]=J;h=h+l|0}while((h|0)<(g|0))}else{J=0.0;h=0;do{H=+n[T+(h<<2)>>2];n[P+(h<<2)>>2]=H;n[O+(h<<2)>>2]=H;J=J+H;n[S+(h<<2)>>2]=J;h=h+l|0}while((h|0)<(g|0))}if(j)n[O+(l<<2)>>2]=0.0;if(F){p[R+(o<<3)>>3]=0.0;$=R+8|0}else $=0;Q=Q+1|0;if((Q|0)==(l|0))break;else{O=O+4|0;P=P+4|0;R=$;S=S+4|0;T=T+4|0}}V=N+(l<<2)|0;W=A;X=$;Z=a+(l<<2)|0;_=c+(z<<2)|0}else{V=N;W=x;X=w;Z=a;_=v}while(0);if((k|0)>1){v=r-l|0;a=b-l|0;w=d-l|0;x=s-l|0;c=0-b|0;$=0-s|0;T=g-l|0;S=(T|0)>(l|0);R=d+l|0;P=(g|0)>(l|0);g=V;V=W;W=1;O=_;_=X;X=Z;while(1){Z=X+(v<<2)|0;Q=O+(a<<2)|0;U=V+(w<<2)|0;j=g+(o<<2)|0;h=(_|0)==0?0:_+(x<<3)|0;if(t){B=O+(b<<2)|0;D=j;C=U;E=0;I=Q;G=Z;K=h;while(1){J=+n[G>>2];H=J;L=H*H;n[I+(o<<2)>>2]=0.0;aa=(K|0)!=0;if(aa)p[K+(o<<3)>>3]=0.0;ba=C+(i<<2)|0;f[C+(o<<2)>>2]=f[ba>>2];n[I>>2]=J+ +n[I+(c<<2)>>2];if(aa)p[K>>3]=L+ +p[K+($<<3)>>3];n[C>>2]=J+ +n[ba>>2]+ +n[D+(l<<2)>>2];if(S)if(aa){H=J;M=L;ca=J;ba=l;while(1){da=+n[D+(ba<<2)>>2];n[D+(ba-l<<2)>>2]=H+da;ea=+n[G+(ba<<2)>>2];fa=ea;ga=ca+ea;ha=M+fa*fa;n[I+(ba<<2)>>2]=+n[I+(ba-b<<2)>>2]+ga;p[K+(ba<<3)>>3]=ha+ +p[K+(ba-s<<3)>>3];ia=ba+l|0;n[C+(ba<<2)>>2]=da+(ea+ +n[D+(ia<<2)>>2]+ +n[C+(ba-R<<2)>>2]);if((ia|0)<(T|0)){H=ea;M=ha;ca=ga;ba=ia}else{ja=ea;ka=ha;la=ga;ma=ia;break}}}else{ca=J;M=L;H=J;ba=l;while(1){ga=+n[D+(ba<<2)>>2];n[D+(ba-l<<2)>>2]=ca+ga;ha=+n[G+(ba<<2)>>2];ea=ha;da=H+ha;fa=M+ea*ea;n[I+(ba<<2)>>2]=+n[I+(ba-b<<2)>>2]+da;F=ba+l|0;n[C+(ba<<2)>>2]=ga+(ha+ +n[D+(F<<2)>>2]+ +n[C+(ba-R<<2)>>2]);if((F|0)<(T|0)){ca=ha;M=fa;H=da;ba=F}else{ja=ha;ka=fa;la=da;ma=F;break}}}else{ja=J;ka=L;la=J;ma=l}if(P){ba=D+(ma<<2)|0;H=+n[ba>>2];n[D+(ma-l<<2)>>2]=ja+H;M=+n[G+(ma<<2)>>2];ca=M;n[I+(ma<<2)>>2]=+n[I+(ma-b<<2)>>2]+(la+M);if(aa)p[K+(ma<<3)>>3]=ka+ca*ca+ +p[K+(ma-s<<3)>>3];n[C+(ma<<2)>>2]=H+M+ +n[C+(ma-R<<2)>>2];n[ba>>2]=M}K=aa?K+8|0:0;E=E+1|0;if((E|0)==(l|0))break;else{D=D+4|0;C=C+4|0;I=I+4|0;G=G+4|0}}na=g;oa=V+(d<<2)|0;pa=X+(r<<2)|0;qa=B;ra=K}else{na=j;oa=U;pa=Z;qa=Q;ra=h}W=W+1|0;if((W|0)==(k|0))break;else{g=na;V=oa;O=qa;_=ra;X=pa}}}if((N|0)!=(e|0)){P5b(N);f[q>>2]=e;f[y>>2]=264}u=m;return}function z3(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;m=u;u=u+1072|0;o=0-l|0;p=m;q=b>>>2;b=d>>>2;d=i>>>2;i=0-d|0;r=g>>>2;g=Y(l,j)|0;j=g+l|0;s=j<<2;Nac(c|0,0,s|0)|0;t=c+(b+l<<2)|0;if(!e)v=0;else{Nac(e|0,0,s|0)|0;v=e+(r+l<<2)|0}if(!h)w=0;else{Nac(h|0,0,s|0)|0;w=h+(d+l<<2)|0}h=(w|0)==0;if((v|0)==0&h){if((k|0)<=0){u=m;return}s=(g|0)>0;e=q-l|0;x=b-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;z=l<<2;A=t;B=0;C=a;while(1){if(s){D=0;E=A;F=C;while(1){n[E+(o<<2)>>2]=0.0;G=0.0;H=0;do{G=G+ +n[F+(H<<2)>>2];n[E+(H<<2)>>2]=+n[E+(H-b<<2)>>2]+G;H=H+l|0}while((H|0)<(g|0));D=D+1|0;if((D|0)==(l|0))break;else{E=E+4|0;F=F+4|0}}}else Nac(A+(o<<2)|0,0,z|0)|0;B=B+1|0;if((B|0)==(k|0))break;else{A=A+(y<<2)+4+(x<<2)|0;C=C+(y<<2)+4+(e<<2)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;e=q-l|0;y=b-l|0;C=r-l|0;if((l|0)<=0){u=m;return}x=l+-1|0;A=v;B=0;z=t;s=a;while(1){if(h){F=0;E=A;D=z;H=s;while(1){n[D+(o<<2)>>2]=0.0;n[E+(o<<2)>>2]=0.0;G=0.0;I=0.0;J=0;do{K=+n[H+(J<<2)>>2];I=I+K;G=G+K*K;K=+n[E+(J-r<<2)>>2]+G;n[D+(J<<2)>>2]=+n[D+(J-b<<2)>>2]+I;n[E+(J<<2)>>2]=K;J=J+l|0}while((J|0)<(g|0));F=F+1|0;if((F|0)==(l|0))break;else{E=E+4|0;D=D+4|0;H=H+4|0}}}else{H=0;D=A;E=z;while(1){n[E+(o<<2)>>2]=0.0;n[D+(o<<2)>>2]=0.0;H=H+1|0;if((H|0)==(l|0))break;else{D=D+4|0;E=E+4|0}}}B=B+1|0;if((B|0)==(k|0))break;else{A=A+(x<<2)+4+(C<<2)|0;z=z+(x<<2)+4+(y<<2)|0;s=s+(x<<2)+4+(e<<2)|0}}u=m;return}e=p+8|0;f[p>>2]=e;x=p+4|0;f[x>>2]=j;if(j>>>0>264){s=N5b(j>>>0>1073741823?-1:j<<2)|0;f[p>>2]=s;L=s}else L=e;s=(l|0)>0;do if(s){j=(g|0)==(l|0);y=b+(l<<1)|0;z=w+(l<<2)|0;if((g|0)>0){M=L;N=w;O=0;P=v;Q=t;R=a}else{C=L;A=w;B=0;h=v;E=t;while(1){n[A+(o<<2)>>2]=0.0;n[E+(o<<2)>>2]=0.0;if(j)n[C+(l<<2)>>2]=0.0;if(!h)S=0;else{n[h+(o<<2)>>2]=0.0;S=h+4|0}B=B+1|0;if((B|0)==(l|0))break;else{C=C+4|0;A=A+4|0;h=S;E=E+4|0}}T=L+(l<<2)|0;U=z;V=S;W=a+(l<<2)|0;X=c+(y<<2)|0;break}while(1){n[N+(o<<2)>>2]=0.0;n[Q+(o<<2)>>2]=0.0;E=(P|0)!=0;if(E){I=0.0;G=0.0;h=0;do{K=+n[R+(h<<2)>>2];n[N+(h<<2)>>2]=K;n[M+(h<<2)>>2]=K;G=G+K;I=I+K*K;n[Q+(h<<2)>>2]=G;n[P+(h<<2)>>2]=I;h=h+l|0}while((h|0)<(g|0))}else{I=0.0;h=0;do{G=+n[R+(h<<2)>>2];n[N+(h<<2)>>2]=G;n[M+(h<<2)>>2]=G;I=I+G;n[Q+(h<<2)>>2]=I;h=h+l|0}while((h|0)<(g|0))}if(j)n[M+(l<<2)>>2]=0.0;if(E){n[P+(o<<2)>>2]=0.0;Z=P+4|0}else Z=0;O=O+1|0;if((O|0)==(l|0))break;else{M=M+4|0;N=N+4|0;P=Z;Q=Q+4|0;R=R+4|0}}T=L+(l<<2)|0;U=z;V=Z;W=a+(l<<2)|0;X=c+(y<<2)|0}else{T=L;U=w;V=v;W=a;X=t}while(0);if((k|0)>1){t=q-l|0;a=b-l|0;v=d-l|0;w=r-l|0;c=0-b|0;Z=0-r|0;R=g-l|0;Q=(R|0)>(l|0);P=d+l|0;N=(g|0)>(l|0);g=T;T=U;U=1;M=X;X=V;V=W;while(1){W=V+(t<<2)|0;O=M+(a<<2)|0;S=T+(v<<2)|0;j=g+(o<<2)|0;h=(X|0)==0?0:X+(w<<2)|0;if(s){A=M+(b<<2)|0;C=j;B=S;D=0;H=O;F=W;J=h;while(1){I=+n[F>>2];G=I*I;n[H+(o<<2)>>2]=0.0;_=(J|0)!=0;if(_)n[J+(o<<2)>>2]=0.0;$=B+(i<<2)|0;f[B+(o<<2)>>2]=f[$>>2];n[H>>2]=I+ +n[H+(c<<2)>>2];if(_)n[J>>2]=G+ +n[J+(Z<<2)>>2];n[B>>2]=I+ +n[$>>2]+ +n[C+(l<<2)>>2];if(Q)if(_){K=I;aa=G;ba=I;$=l;while(1){ca=+n[C+($<<2)>>2];n[C+($-l<<2)>>2]=K+ca;da=+n[F+($<<2)>>2];ea=ba+da;fa=aa+da*da;n[H+($<<2)>>2]=+n[H+($-b<<2)>>2]+ea;n[J+($<<2)>>2]=fa+ +n[J+($-r<<2)>>2];ga=$+l|0;n[B+($<<2)>>2]=ca+(da+ +n[C+(ga<<2)>>2]+ +n[B+($-P<<2)>>2]);if((ga|0)<(R|0)){K=da;aa=fa;ba=ea;$=ga}else{ha=da;ia=fa;ja=ea;ka=ga;break}}}else{ba=I;aa=G;K=I;$=l;while(1){ea=+n[C+($<<2)>>2];n[C+($-l<<2)>>2]=ba+ea;fa=+n[F+($<<2)>>2];da=K+fa;ca=aa+fa*fa;n[H+($<<2)>>2]=+n[H+($-b<<2)>>2]+da;E=$+l|0;n[B+($<<2)>>2]=ea+(fa+ +n[C+(E<<2)>>2]+ +n[B+($-P<<2)>>2]);if((E|0)<(R|0)){ba=fa;aa=ca;K=da;$=E}else{ha=fa;ia=ca;ja=da;ka=E;break}}}else{ha=I;ia=G;ja=I;ka=l}if(N){$=C+(ka<<2)|0;K=+n[$>>2];n[C+(ka-l<<2)>>2]=ha+K;aa=+n[F+(ka<<2)>>2];n[H+(ka<<2)>>2]=+n[H+(ka-b<<2)>>2]+(ja+aa);if(_)n[J+(ka<<2)>>2]=ia+aa*aa+ +n[J+(ka-r<<2)>>2];n[B+(ka<<2)>>2]=K+aa+ +n[B+(ka-P<<2)>>2];n[$>>2]=aa}J=_?J+4|0:0;D=D+1|0;if((D|0)==(l|0))break;else{C=C+4|0;B=B+4|0;H=H+4|0;F=F+4|0}}la=g;ma=T+(d<<2)|0;na=V+(q<<2)|0;oa=A;pa=J}else{la=j;ma=S;na=W;oa=O;pa=h}U=U+1|0;if((U|0)==(k|0))break;else{g=la;T=ma;M=oa;X=pa;V=na}}}if((L|0)!=(e|0)){P5b(L);f[p>>2]=e;f[x>>2]=264}u=m;return}function A3(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0.0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;m=u;u=u+1104|0;o=0-l|0;q=m;r=b>>>2;b=d>>>3;d=i>>>3;i=0-d|0;s=g>>>3;g=Y(l,j)|0;j=g+l|0;t=j<<3;Nac(c|0,0,t|0)|0;v=c+(b+l<<3)|0;if(!e)w=0;else{Nac(e|0,0,t|0)|0;w=e+(s+l<<3)|0}if(!h)x=0;else{Nac(h|0,0,t|0)|0;x=h+(d+l<<3)|0}h=(x|0)==0;if((w|0)==0&h){if((k|0)<=0){u=m;return}t=(g|0)>0;e=r-l|0;y=b-l|0;if((l|0)<=0){u=m;return}z=l+-1|0;A=l<<3;B=v;C=0;D=a;while(1){if(t){E=0;F=B;G=D;while(1){p[F+(o<<3)>>3]=0.0;H=0.0;I=0;do{H=H+ +n[G+(I<<2)>>2];p[F+(I<<3)>>3]=+p[F+(I-b<<3)>>3]+H;I=I+l|0}while((I|0)<(g|0));E=E+1|0;if((E|0)==(l|0))break;else{F=F+8|0;G=G+4|0}}}else Nac(B+(o<<3)|0,0,A|0)|0;C=C+1|0;if((C|0)==(k|0))break;else{B=B+(z<<3)+8+(y<<3)|0;D=D+(z<<2)+4+(e<<2)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;e=r-l|0;z=b-l|0;D=s-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;B=w;C=0;A=v;t=a;while(1){if(h){G=0;F=B;E=A;I=t;while(1){p[E+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;H=0.0;J=0.0;K=0;do{L=+n[I+(K<<2)>>2];J=J+L;H=H+L*L;L=+p[F+(K-s<<3)>>3]+H;p[E+(K<<3)>>3]=+p[E+(K-b<<3)>>3]+J;p[F+(K<<3)>>3]=L;K=K+l|0}while((K|0)<(g|0));G=G+1|0;if((G|0)==(l|0))break;else{F=F+8|0;E=E+8|0;I=I+4|0}}}else{I=0;E=B;F=A;while(1){p[F+(o<<3)>>3]=0.0;p[E+(o<<3)>>3]=0.0;I=I+1|0;if((I|0)==(l|0))break;else{E=E+8|0;F=F+8|0}}}C=C+1|0;if((C|0)==(k|0))break;else{B=B+(y<<3)+8+(D<<3)|0;A=A+(y<<3)+8+(z<<3)|0;t=t+(y<<2)+4+(e<<2)|0}}u=m;return}e=q+8|0;f[q>>2]=e;y=q+4|0;f[y>>2]=j;if(j>>>0>136){t=N5b(j>>>0>536870911?-1:j<<3)|0;f[q>>2]=t;M=t}else M=e;t=(l|0)>0;do if(t){j=(g|0)==(l|0);z=b+(l<<1)|0;A=x+(l<<3)|0;if((g|0)>0){N=M;O=x;P=0;Q=w;R=v;S=a}else{D=M;B=x;C=0;h=w;F=v;while(1){p[B+(o<<3)>>3]=0.0;p[F+(o<<3)>>3]=0.0;if(j)p[D+(l<<3)>>3]=0.0;if(!h)T=0;else{p[h+(o<<3)>>3]=0.0;T=h+8|0}C=C+1|0;if((C|0)==(l|0))break;else{D=D+8|0;B=B+8|0;h=T;F=F+8|0}}U=M+(l<<3)|0;V=A;W=T;X=a+(l<<2)|0;Z=c+(z<<3)|0;break}while(1){p[O+(o<<3)>>3]=0.0;p[R+(o<<3)>>3]=0.0;F=(Q|0)!=0;if(F){J=0.0;H=0.0;h=0;do{L=+n[S+(h<<2)>>2];p[O+(h<<3)>>3]=L;p[N+(h<<3)>>3]=L;H=H+L;J=J+L*L;p[R+(h<<3)>>3]=H;p[Q+(h<<3)>>3]=J;h=h+l|0}while((h|0)<(g|0))}else{J=0.0;h=0;do{H=+n[S+(h<<2)>>2];p[O+(h<<3)>>3]=H;p[N+(h<<3)>>3]=H;J=J+H;p[R+(h<<3)>>3]=J;h=h+l|0}while((h|0)<(g|0))}if(j)p[N+(l<<3)>>3]=0.0;if(F){p[Q+(o<<3)>>3]=0.0;_=Q+8|0}else _=0;P=P+1|0;if((P|0)==(l|0))break;else{N=N+8|0;O=O+8|0;Q=_;R=R+8|0;S=S+4|0}}U=M+(l<<3)|0;V=A;W=_;X=a+(l<<2)|0;Z=c+(z<<3)|0}else{U=M;V=x;W=w;X=a;Z=v}while(0);if((k|0)>1){v=r-l|0;a=b-l|0;w=d-l|0;x=s-l|0;c=0-b|0;_=0-s|0;S=g-l|0;R=(S|0)>(l|0);Q=d+l|0;O=(g|0)>(l|0);g=U;U=V;V=1;N=Z;Z=W;W=X;while(1){X=W+(v<<2)|0;P=N+(a<<3)|0;T=U+(w<<3)|0;j=g+(o<<3)|0;h=(Z|0)==0?0:Z+(x<<3)|0;if(t){B=N+(b<<3)|0;D=j;C=T;E=0;I=P;G=X;K=h;while(1){J=+n[G>>2];H=J*J;p[I+(o<<3)>>3]=0.0;$=(K|0)!=0;if($)p[K+(o<<3)>>3]=0.0;aa=C+(i<<3)|0;p[C+(o<<3)>>3]=+p[aa>>3];p[I>>3]=J+ +p[I+(c<<3)>>3];if($)p[K>>3]=H+ +p[K+(_<<3)>>3];p[C>>3]=J+ +p[aa>>3]+ +p[D+(l<<3)>>3];if(R)if($){L=J;ba=H;ca=J;aa=l;while(1){da=+p[D+(aa<<3)>>3];p[D+(aa-l<<3)>>3]=L+da;ea=+n[G+(aa<<2)>>2];fa=ca+ea;ga=ba+ea*ea;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+fa;p[K+(aa<<3)>>3]=ga+ +p[K+(aa-s<<3)>>3];ha=aa+l|0;p[C+(aa<<3)>>3]=da+(ea+ +p[D+(ha<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((ha|0)<(S|0)){L=ea;ba=ga;ca=fa;aa=ha}else{ia=ea;ja=ga;ka=fa;la=ha;break}}}else{ca=J;ba=H;L=J;aa=l;while(1){fa=+p[D+(aa<<3)>>3];p[D+(aa-l<<3)>>3]=ca+fa;ga=+n[G+(aa<<2)>>2];ea=L+ga;da=ba+ga*ga;p[I+(aa<<3)>>3]=+p[I+(aa-b<<3)>>3]+ea;F=aa+l|0;p[C+(aa<<3)>>3]=fa+(ga+ +p[D+(F<<3)>>3]+ +p[C+(aa-Q<<3)>>3]);if((F|0)<(S|0)){ca=ga;ba=da;L=ea;aa=F}else{ia=ga;ja=da;ka=ea;la=F;break}}}else{ia=J;ja=H;ka=J;la=l}if(O){aa=D+(la<<3)|0;L=+p[aa>>3];p[D+(la-l<<3)>>3]=ia+L;ba=+n[G+(la<<2)>>2];p[I+(la<<3)>>3]=+p[I+(la-b<<3)>>3]+(ka+ba);if($)p[K+(la<<3)>>3]=ja+ba*ba+ +p[K+(la-s<<3)>>3];p[C+(la<<3)>>3]=L+ba+ +p[C+(la-Q<<3)>>3];p[aa>>3]=ba}K=$?K+8|0:0;E=E+1|0;if((E|0)==(l|0))break;else{D=D+8|0;C=C+8|0;I=I+8|0;G=G+4|0}}ma=g;na=U+(d<<3)|0;oa=W+(r<<2)|0;pa=B;qa=K}else{ma=j;na=T;oa=X;pa=P;qa=h}V=V+1|0;if((V|0)==(k|0))break;else{g=ma;U=na;N=pa;Z=qa;W=oa}}}if((M|0)!=(e|0)){P5b(M);f[q>>2]=e;f[y>>2]=136}u=m;return}function B3(a,b,c,d,e,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0,J=0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0;m=u;u=u+1104|0;n=0-l|0;o=m;q=b>>>3;b=d>>>3;d=i>>>3;i=0-d|0;r=g>>>3;g=Y(l,j)|0;j=g+l|0;s=j<<3;Nac(c|0,0,s|0)|0;t=c+(b+l<<3)|0;if(!e)v=0;else{Nac(e|0,0,s|0)|0;v=e+(r+l<<3)|0}if(!h)w=0;else{Nac(h|0,0,s|0)|0;w=h+(d+l<<3)|0}h=(w|0)==0;if((v|0)==0&h){if((k|0)<=0){u=m;return}s=(g|0)>0;e=q-l|0;x=b-l|0;if((l|0)<=0){u=m;return}y=l+-1|0;z=l<<3;A=t;B=0;C=a;while(1){if(s){D=0;E=A;F=C;while(1){p[E+(n<<3)>>3]=0.0;G=0.0;H=0;do{G=G+ +p[F+(H<<3)>>3];p[E+(H<<3)>>3]=+p[E+(H-b<<3)>>3]+G;H=H+l|0}while((H|0)<(g|0));D=D+1|0;if((D|0)==(l|0))break;else{E=E+8|0;F=F+8|0}}}else Nac(A+(n<<3)|0,0,z|0)|0;B=B+1|0;if((B|0)==(k|0))break;else{A=A+(y<<3)+8+(x<<3)|0;C=C+(y<<3)+8+(e<<3)|0}}u=m;return}if(h){if((k|0)<=0){u=m;return}h=(g|0)>0;e=q-l|0;y=b-l|0;C=r-l|0;if((l|0)<=0){u=m;return}x=l+-1|0;A=v;B=0;z=t;s=a;while(1){if(h){F=0;E=A;D=z;H=s;while(1){p[D+(n<<3)>>3]=0.0;p[E+(n<<3)>>3]=0.0;G=0.0;I=0.0;J=0;do{K=+p[H+(J<<3)>>3];I=I+K;G=G+K*K;K=+p[E+(J-r<<3)>>3]+G;p[D+(J<<3)>>3]=+p[D+(J-b<<3)>>3]+I;p[E+(J<<3)>>3]=K;J=J+l|0}while((J|0)<(g|0));F=F+1|0;if((F|0)==(l|0))break;else{E=E+8|0;D=D+8|0;H=H+8|0}}}else{H=0;D=A;E=z;while(1){p[E+(n<<3)>>3]=0.0;p[D+(n<<3)>>3]=0.0;H=H+1|0;if((H|0)==(l|0))break;else{D=D+8|0;E=E+8|0}}}B=B+1|0;if((B|0)==(k|0))break;else{A=A+(x<<3)+8+(C<<3)|0;z=z+(x<<3)+8+(y<<3)|0;s=s+(x<<3)+8+(e<<3)|0}}u=m;return}e=o+8|0;f[o>>2]=e;x=o+4|0;f[x>>2]=j;if(j>>>0>136){s=N5b(j>>>0>536870911?-1:j<<3)|0;f[o>>2]=s;L=s}else L=e;s=(l|0)>0;do if(s){j=(g|0)==(l|0);y=b+(l<<1)|0;z=w+(l<<3)|0;if((g|0)>0){M=L;N=w;O=0;P=v;Q=t;R=a}else{C=L;A=w;B=0;h=v;E=t;while(1){p[A+(n<<3)>>3]=0.0;p[E+(n<<3)>>3]=0.0;if(j)p[C+(l<<3)>>3]=0.0;if(!h)S=0;else{p[h+(n<<3)>>3]=0.0;S=h+8|0}B=B+1|0;if((B|0)==(l|0))break;else{C=C+8|0;A=A+8|0;h=S;E=E+8|0}}T=L+(l<<3)|0;U=z;V=S;W=a+(l<<3)|0;X=c+(y<<3)|0;break}while(1){p[N+(n<<3)>>3]=0.0;p[Q+(n<<3)>>3]=0.0;E=(P|0)!=0;if(E){I=0.0;G=0.0;h=0;do{K=+p[R+(h<<3)>>3];p[N+(h<<3)>>3]=K;p[M+(h<<3)>>3]=K;G=G+K;I=I+K*K;p[Q+(h<<3)>>3]=G;p[P+(h<<3)>>3]=I;h=h+l|0}while((h|0)<(g|0))}else{I=0.0;h=0;do{G=+p[R+(h<<3)>>3];p[N+(h<<3)>>3]=G;p[M+(h<<3)>>3]=G;I=I+G;p[Q+(h<<3)>>3]=I;h=h+l|0}while((h|0)<(g|0))}if(j)p[M+(l<<3)>>3]=0.0;if(E){p[P+(n<<3)>>3]=0.0;Z=P+8|0}else Z=0;O=O+1|0;if((O|0)==(l|0))break;else{M=M+8|0;N=N+8|0;P=Z;Q=Q+8|0;R=R+8|0}}T=L+(l<<3)|0;U=z;V=Z;W=a+(l<<3)|0;X=c+(y<<3)|0}else{T=L;U=w;V=v;W=a;X=t}while(0);if((k|0)>1){t=q-l|0;a=b-l|0;v=d-l|0;w=r-l|0;c=0-b|0;Z=0-r|0;R=g-l|0;Q=(R|0)>(l|0);P=d+l|0;N=(g|0)>(l|0);g=T;T=U;U=1;M=X;X=V;V=W;while(1){W=V+(t<<3)|0;O=M+(a<<3)|0;S=T+(v<<3)|0;j=g+(n<<3)|0;h=(X|0)==0?0:X+(w<<3)|0;if(s){A=M+(b<<3)|0;C=j;B=S;D=0;H=O;F=W;J=h;while(1){I=+p[F>>3];G=I*I;p[H+(n<<3)>>3]=0.0;_=(J|0)!=0;if(_)p[J+(n<<3)>>3]=0.0;$=B+(i<<3)|0;p[B+(n<<3)>>3]=+p[$>>3];p[H>>3]=I+ +p[H+(c<<3)>>3];if(_)p[J>>3]=G+ +p[J+(Z<<3)>>3];p[B>>3]=I+ +p[$>>3]+ +p[C+(l<<3)>>3];if(Q)if(_){K=I;aa=G;ba=I;$=l;while(1){ca=+p[C+($<<3)>>3];p[C+($-l<<3)>>3]=K+ca;da=+p[F+($<<3)>>3];ea=ba+da;fa=aa+da*da;p[H+($<<3)>>3]=+p[H+($-b<<3)>>3]+ea;p[J+($<<3)>>3]=fa+ +p[J+($-r<<3)>>3];ga=$+l|0;p[B+($<<3)>>3]=ca+(da+ +p[C+(ga<<3)>>3]+ +p[B+($-P<<3)>>3]);if((ga|0)<(R|0)){K=da;aa=fa;ba=ea;$=ga}else{ha=da;ia=fa;ja=ea;ka=ga;break}}}else{ba=I;aa=G;K=I;$=l;while(1){ea=+p[C+($<<3)>>3];p[C+($-l<<3)>>3]=ba+ea;fa=+p[F+($<<3)>>3];da=K+fa;ca=aa+fa*fa;p[H+($<<3)>>3]=+p[H+($-b<<3)>>3]+da;E=$+l|0;p[B+($<<3)>>3]=ea+(fa+ +p[C+(E<<3)>>3]+ +p[B+($-P<<3)>>3]);if((E|0)<(R|0)){ba=fa;aa=ca;K=da;$=E}else{ha=fa;ia=ca;ja=da;ka=E;break}}}else{ha=I;ia=G;ja=I;ka=l}if(N){$=C+(ka<<3)|0;K=+p[$>>3];p[C+(ka-l<<3)>>3]=ha+K;aa=+p[F+(ka<<3)>>3];p[H+(ka<<3)>>3]=+p[H+(ka-b<<3)>>3]+(ja+aa);if(_)p[J+(ka<<3)>>3]=ia+aa*aa+ +p[J+(ka-r<<3)>>3];p[B+(ka<<3)>>3]=K+aa+ +p[B+(ka-P<<3)>>3];p[$>>3]=aa}J=_?J+8|0:0;D=D+1|0;if((D|0)==(l|0))break;else{C=C+8|0;B=B+8|0;H=H+8|0;F=F+8|0}}la=g;ma=T+(d<<3)|0;na=V+(q<<3)|0;oa=A;pa=J}else{la=j;ma=S;na=W;oa=O;pa=h}U=U+1|0;if((U|0)==(k|0))break;else{g=la;T=ma;M=oa;X=pa;V=na}}}if((L|0)!=(e|0)){P5b(L);f[o>>2]=e;f[x>>2]=136}u=m;return}function C3(a,b,c,d,e,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;h=u;u=u+320|0;i=h+312|0;j=h+304|0;k=h+240|0;l=h+248|0;m=h+184|0;n=h+128|0;o=h+72|0;p=h+8|0;q=h+16|0;r=h;dQ(i,51824);s=BL(a,-1)|0;t=s&7;v=s>>>3&511;s=v+1|0;w=((e|0)<1?((t|0)==0?4:6):e)&7;e=(g|0)<1?6:g&7;AL(j,a,-1);g=(f[j>>2]|0)+1|0;x=(f[j+4>>2]|0)+1|0;f[k>>2]=g;f[k+4>>2]=x;j=v<<3;v=w|j;vM(b,k,v,-1,0,0);do if((yM(a)|0)==65536){k=f[a+4>>2]|0;f[l>>2]=f[k>>2];y=l+4|0;z=k+4|0;f[y>>2]=f[z>>2];A=l+8|0;f[A>>2]=f[k+8>>2];f[l+12>>2]=f[k+12>>2];f[l+16>>2]=f[k+16>>2];f[l+20>>2]=f[k+20>>2];f[l+24>>2]=f[k+24>>2];f[l+28>>2]=f[k+28>>2];f[l+32>>2]=f[k+32>>2];B=f[k+36>>2]|0;f[l+36>>2]=B;f[l+40>>2]=A;A=l+48|0;C=l+44|0;f[C>>2]=A;f[A>>2]=0;f[l+52>>2]=0;if(B|0){A=B+12|0;f[A>>2]=(f[A>>2]|0)+1}if((f[z>>2]|0)<3){z=f[k+44>>2]|0;A=f[C>>2]|0;f[A>>2]=f[z>>2];f[A+4>>2]=f[z+4>>2];break}else{f[y>>2]=0;jL(l,k);break}}else yL(l,a,-1);while(0);do if((yM(b)|0)==65536){a=f[b+4>>2]|0;f[m>>2]=f[a>>2];k=m+4|0;y=a+4|0;f[k>>2]=f[y>>2];z=m+8|0;f[z>>2]=f[a+8>>2];f[m+12>>2]=f[a+12>>2];f[m+16>>2]=f[a+16>>2];f[m+20>>2]=f[a+20>>2];f[m+24>>2]=f[a+24>>2];f[m+28>>2]=f[a+28>>2];f[m+32>>2]=f[a+32>>2];A=f[a+36>>2]|0;f[m+36>>2]=A;f[m+40>>2]=z;z=m+48|0;C=m+44|0;f[C>>2]=z;f[z>>2]=0;f[m+52>>2]=0;if(A|0){z=A+12|0;f[z>>2]=(f[z>>2]|0)+1}if((f[y>>2]|0)<3){y=f[a+44>>2]|0;z=f[C>>2]|0;f[z>>2]=f[y>>2];f[z+4>>2]=f[y+4>>2];break}else{f[k>>2]=0;jL(m,a);break}}else yL(m,b,-1);while(0);f[n>>2]=1124007936;b=n+4|0;a=n+8|0;k=n+40|0;y=b;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[k>>2]=a;C=n+48|0;A=n+44|0;f[A>>2]=C;f[C>>2]=0;f[n+52>>2]=0;f[o>>2]=1124007936;B=o+4|0;D=o+8|0;E=o+40|0;y=B;z=y+36|0;do{f[y>>2]=0;y=y+4|0}while((y|0)<(z|0));f[E>>2]=D;y=o+48|0;z=o+44|0;f[z>>2]=y;f[y>>2]=0;f[o+52>>2]=0;if(PM(c)|0){f[p>>2]=g;f[p+4>>2]=x;vM(c,p,j|e,-1,0,0);do if((yM(c)|0)==65536){j=f[c+4>>2]|0;f[q>>2]=f[j>>2];p=q+4|0;F=j+4|0;f[p>>2]=f[F>>2];G=q+8|0;f[G>>2]=f[j+8>>2];f[q+12>>2]=f[j+12>>2];f[q+16>>2]=f[j+16>>2];f[q+20>>2]=f[j+20>>2];f[q+24>>2]=f[j+24>>2];f[q+28>>2]=f[j+28>>2];f[q+32>>2]=f[j+32>>2];H=q+36|0;I=f[j+36>>2]|0;f[H>>2]=I;f[q+40>>2]=G;G=q+48|0;J=q+44|0;f[J>>2]=G;f[G>>2]=0;f[q+52>>2]=0;if(I|0){G=I+12|0;f[G>>2]=(f[G>>2]|0)+1}if((f[F>>2]|0)<3){F=f[j+44>>2]|0;G=f[J>>2]|0;f[G>>2]=f[F>>2];f[G+4>>2]=f[F+4>>2];K=H;break}else{f[p>>2]=0;jL(q,j);K=H;break}}else{yL(q,c,-1);K=q+36|0}while(0);c=f[K>>2]|0;if(c|0){H=c+12|0;f[H>>2]=(f[H>>2]|0)+1}H=n+36|0;c=f[H>>2]|0;if(c|0?(j=c+12|0,c=f[j>>2]|0,f[j>>2]=c+-1,(c|0)==1):0)kL(n);f[H>>2]=0;c=n+16|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){j=f[k>>2]|0;p=0;do{f[j+(p<<2)>>2]=0;p=p+1|0;L=f[b>>2]|0}while((p|0)<(L|0));f[n>>2]=f[q>>2];if((L|0)<3)M=33;else M=35}else{f[n>>2]=f[q>>2];M=33}if((M|0)==33){L=f[q+4>>2]|0;if((L|0)<3){f[b>>2]=L;f[a>>2]=f[q+8>>2];f[n+12>>2]=f[q+12>>2];a=f[q+44>>2]|0;L=f[A>>2]|0;f[L>>2]=f[a>>2];f[L+4>>2]=f[a+4>>2]}else M=35}if((M|0)==35)jL(n,q);a=q+16|0;f[c>>2]=f[a>>2];f[n+20>>2]=f[q+20>>2];f[n+24>>2]=f[q+24>>2];f[n+28>>2]=f[q+28>>2];f[n+32>>2]=f[q+32>>2];c=f[K>>2]|0;f[H>>2]=c;if(c|0?(H=c+12|0,c=f[H>>2]|0,f[H>>2]=c+-1,(c|0)==1):0)kL(q);f[K>>2]=0;K=q+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[K>>2]|0)>0){a=f[q+40>>2]|0;c=0;do{f[a+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[K>>2]|0))}K=f[q+44>>2]|0;if((K|0)!=(q+48|0))UC(K)}if(PM(d)|0){f[r>>2]=g;f[r+4>>2]=x;vM(d,r,v,-1,0,0);do if((yM(d)|0)==65536){v=f[d+4>>2]|0;f[q>>2]=f[v>>2];r=q+4|0;x=v+4|0;f[r>>2]=f[x>>2];g=q+8|0;f[g>>2]=f[v+8>>2];f[q+12>>2]=f[v+12>>2];f[q+16>>2]=f[v+16>>2];f[q+20>>2]=f[v+20>>2];f[q+24>>2]=f[v+24>>2];f[q+28>>2]=f[v+28>>2];f[q+32>>2]=f[v+32>>2];K=q+36|0;c=f[v+36>>2]|0;f[K>>2]=c;f[q+40>>2]=g;g=q+48|0;a=q+44|0;f[a>>2]=g;f[g>>2]=0;f[q+52>>2]=0;if(c|0){g=c+12|0;f[g>>2]=(f[g>>2]|0)+1}if((f[x>>2]|0)<3){x=f[v+44>>2]|0;g=f[a>>2]|0;f[g>>2]=f[x>>2];f[g+4>>2]=f[x+4>>2];N=K;break}else{f[r>>2]=0;jL(q,v);N=K;break}}else{yL(q,d,-1);N=q+36|0}while(0);d=f[N>>2]|0;if(d|0){K=d+12|0;f[K>>2]=(f[K>>2]|0)+1}K=o+36|0;d=f[K>>2]|0;if(d|0?(v=d+12|0,d=f[v>>2]|0,f[v>>2]=d+-1,(d|0)==1):0)kL(o);f[K>>2]=0;d=o+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[B>>2]|0)>0){v=f[E>>2]|0;r=0;do{f[v+(r<<2)>>2]=0;r=r+1|0;O=f[B>>2]|0}while((r|0)<(O|0));f[o>>2]=f[q>>2];if((O|0)<3)M=64;else M=66}else{f[o>>2]=f[q>>2];M=64}if((M|0)==64){O=f[q+4>>2]|0;if((O|0)<3){f[B>>2]=O;f[D>>2]=f[q+8>>2];f[o+12>>2]=f[q+12>>2];D=f[q+44>>2]|0;O=f[z>>2]|0;f[O>>2]=f[D>>2];f[O+4>>2]=f[D+4>>2]}else M=66}if((M|0)==66)jL(o,q);M=q+16|0;f[d>>2]=f[M>>2];f[o+20>>2]=f[q+20>>2];f[o+24>>2]=f[q+24>>2];f[o+28>>2]=f[q+28>>2];f[o+32>>2]=f[q+32>>2];D=f[N>>2]|0;f[K>>2]=D;if(D|0?(K=D+12|0,D=f[K>>2]|0,f[K>>2]=D+-1,(D|0)==1):0)kL(q);f[N>>2]=0;N=q+4|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[N>>2]|0)>0){M=f[q+40>>2]|0;D=0;do{f[M+(D<<2)>>2]=0;D=D+1|0}while((D|0)<(f[N>>2]|0))}N=f[q+44>>2]|0;if((N|0)!=(q+48|0))UC(N);P=d}else P=o+16|0;d=l+16|0;N=l+44|0;q=l+48|0;D=m+16|0;M=m+44|0;K=m+48|0;O=n+16|0;p3(t,w,e,f[d>>2]|0,f[q>>2]|0,f[D>>2]|0,f[K>>2]|0,f[O>>2]|0,f[C>>2]|0,f[P>>2]|0,f[y>>2]|0,f[l+12>>2]|0,f[l+8>>2]|0,s);s=o+36|0;e=f[s>>2]|0;if(e|0?(w=e+12|0,e=f[w>>2]|0,f[w>>2]=e+-1,(e|0)==1):0)kL(o);f[s>>2]=0;f[P>>2]=0;f[P+4>>2]=0;f[P+8>>2]=0;f[P+12>>2]=0;if((f[B>>2]|0)>0){P=f[E>>2]|0;E=0;do{f[P+(E<<2)>>2]=0;E=E+1|0}while((E|0)<(f[B>>2]|0))}B=f[z>>2]|0;if((B|0)!=(y|0))UC(B);B=n+36|0;y=f[B>>2]|0;if(y|0?(z=y+12|0,y=f[z>>2]|0,f[z>>2]=y+-1,(y|0)==1):0)kL(n);f[B>>2]=0;f[O>>2]=0;f[O+4>>2]=0;f[O+8>>2]=0;f[O+12>>2]=0;if((f[b>>2]|0)>0){O=f[k>>2]|0;k=0;do{f[O+(k<<2)>>2]=0;k=k+1|0}while((k|0)<(f[b>>2]|0))}b=f[A>>2]|0;if((b|0)!=(C|0))UC(b);b=m+36|0;C=f[b>>2]|0;if(C|0?(A=C+12|0,C=f[A>>2]|0,f[A>>2]=C+-1,(C|0)==1):0)kL(m);f[b>>2]=0;b=m+4|0;f[D>>2]=0;f[D+4>>2]=0;f[D+8>>2]=0;f[D+12>>2]=0;if((f[b>>2]|0)>0){D=f[m+40>>2]|0;m=0;do{f[D+(m<<2)>>2]=0;m=m+1|0}while((m|0)<(f[b>>2]|0))}b=f[M>>2]|0;if((b|0)!=(K|0))UC(b);b=l+36|0;K=f[b>>2]|0;if(K|0?(M=K+12|0,K=f[M>>2]|0,f[M>>2]=K+-1,(K|0)==1):0)kL(l);f[b>>2]=0;b=l+4|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[l+40>>2]|0;l=0;do{f[d+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[b>>2]|0))}b=f[N>>2]|0;if((b|0)!=(q|0))UC(b);if(!(f[i+4>>2]|0)){u=h;return}u=h;return}function D3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;dQ(e,51844);g=UM()|0;C3(a,b,g,UM()|0,c,-1);if(!(f[e+4>>2]|0)){u=d;return}u=d;return}function E3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0;g=u;u=u+16|0;h=g;dQ(h,51864);C3(a,b,c,UM()|0,d,e);if(!(f[h+4>>2]|0)){u=g;return}u=g;return}function F3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;g=u;u=u+496|0;h=g+440|0;i=g+384|0;j=g+328|0;k=g+272|0;l=g+216|0;m=g+160|0;n=g+104|0;o=g+48|0;p=g+32|0;q=g+16|0;r=g;tL(h,a,0,1,0,0);tL(i,c,0,1,0,0);f[j>>2]=f[i>>2];c=j+4|0;a=i+4|0;s=f[a>>2]|0;f[c>>2]=s;t=j+8|0;f[t>>2]=f[i+8>>2];f[j+12>>2]=f[i+12>>2];v=j+16|0;w=i+16|0;f[v>>2]=f[w>>2];f[j+20>>2]=f[i+20>>2];f[j+24>>2]=f[i+24>>2];f[j+28>>2]=f[i+28>>2];f[j+32>>2]=f[i+32>>2];x=j+36|0;y=i+36|0;z=f[y>>2]|0;f[x>>2]=z;A=j+40|0;f[A>>2]=t;t=j+48|0;B=j+44|0;f[B>>2]=t;f[t>>2]=0;f[j+52>>2]=0;if(!z)C=s;else{s=z+12|0;f[s>>2]=(f[s>>2]|0)+1;C=f[a>>2]|0}if((C|0)<3){C=f[i+44>>2]|0;s=f[B>>2]|0;f[s>>2]=f[C>>2];f[s+4>>2]=f[C+4>>2]}else{f[c>>2]=0;jL(j,i)}f[k>>2]=1124007936;C=k+4|0;s=k+8|0;z=k+40|0;D=C;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[z>>2]=s;F=k+48|0;G=k+44|0;f[G>>2]=F;f[F>>2]=0;f[k+52>>2]=0;f[l>>2]=1124007936;H=l+4|0;I=l+8|0;J=l+40|0;D=H;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[J>>2]=I;K=l+48|0;L=l+44|0;f[L>>2]=K;f[K>>2]=0;f[l+52>>2]=0;f[m>>2]=1124007936;M=m+4|0;N=m+8|0;O=m+40|0;D=M;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[O>>2]=N;P=m+48|0;Q=m+44|0;f[Q>>2]=P;f[P>>2]=0;f[m+52>>2]=0;f[n>>2]=1124007936;R=n+4|0;S=n+8|0;T=n+40|0;D=R;E=D+36|0;do{f[D>>2]=0;D=D+4|0}while((D|0)<(E|0));f[T>>2]=S;U=n+48|0;V=n+44|0;f[V>>2]=U;f[U>>2]=0;f[n+52>>2]=0;if(!d)W=0;else{tL(o,d,0,1,0,0);d=o+36|0;X=f[d>>2]|0;if(X|0){Y=X+12|0;f[Y>>2]=(f[Y>>2]|0)+1}Y=l+36|0;X=f[Y>>2]|0;if(X|0?(Z=X+12|0,X=f[Z>>2]|0,f[Z>>2]=X+-1,(X|0)==1):0)kL(l);f[Y>>2]=0;X=l+16|0;f[X>>2]=0;f[X+4>>2]=0;f[X+8>>2]=0;f[X+12>>2]=0;if((f[H>>2]|0)>0){Z=f[J>>2]|0;_=0;do{f[Z+(_<<2)>>2]=0;_=_+1|0;$=f[H>>2]|0}while((_|0)<($|0));f[l>>2]=f[o>>2];if(($|0)<3)aa=17;else aa=19}else{f[l>>2]=f[o>>2];aa=17}if((aa|0)==17){$=f[o+4>>2]|0;if(($|0)<3){f[H>>2]=$;f[I>>2]=f[o+8>>2];f[l+12>>2]=f[o+12>>2];$=f[o+44>>2]|0;_=f[L>>2]|0;f[_>>2]=f[$>>2];f[_+4>>2]=f[$+4>>2]}else aa=19}if((aa|0)==19)jL(l,o);$=o+16|0;f[X>>2]=f[$>>2];_=l+20|0;f[_>>2]=f[o+20>>2];Z=l+24|0;f[Z>>2]=f[o+24>>2];ba=l+28|0;f[ba>>2]=f[o+28>>2];ca=l+32|0;f[ca>>2]=f[o+32>>2];da=f[d>>2]|0;f[Y>>2]=da;if(da|0){ea=da+12|0;f[ea>>2]=(f[ea>>2]|0)+1}ea=k+36|0;da=f[ea>>2]|0;if(da|0?(fa=da+12|0,da=f[fa>>2]|0,f[fa>>2]=da+-1,(da|0)==1):0)kL(k);f[ea>>2]=0;da=k+16|0;f[da>>2]=0;f[da+4>>2]=0;f[da+8>>2]=0;f[da+12>>2]=0;if((f[C>>2]|0)>0){fa=f[z>>2]|0;ga=0;do{f[fa+(ga<<2)>>2]=0;ga=ga+1|0;ha=f[C>>2]|0}while((ga|0)<(ha|0));f[k>>2]=f[l>>2];if((ha|0)<3)aa=30;else aa=32}else{f[k>>2]=f[l>>2];aa=30}if((aa|0)==30){ha=f[H>>2]|0;if((ha|0)<3){f[C>>2]=ha;f[s>>2]=f[I>>2];f[k+12>>2]=f[l+12>>2];I=f[L>>2]|0;s=f[G>>2]|0;f[s>>2]=f[I>>2];f[s+4>>2]=f[I+4>>2]}else aa=32}if((aa|0)==32)jL(k,l);f[da>>2]=f[X>>2];f[k+20>>2]=f[_>>2];f[k+24>>2]=f[Z>>2];f[k+28>>2]=f[ba>>2];f[k+32>>2]=f[ca>>2];f[ea>>2]=f[Y>>2];Y=f[d>>2]|0;if(Y|0?(ea=Y+12|0,Y=f[ea>>2]|0,f[ea>>2]=Y+-1,(Y|0)==1):0)kL(o);f[d>>2]=0;d=o+4|0;f[$>>2]=0;f[$+4>>2]=0;f[$+8>>2]=0;f[$+12>>2]=0;if((f[d>>2]|0)>0){$=f[o+40>>2]|0;Y=0;do{f[$+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[d>>2]|0))}d=f[o+44>>2]|0;if((d|0)!=(o+48|0))UC(d);W=l}if(!e)ia=0;else{tL(o,e,0,1,0,0);e=o+36|0;d=f[e>>2]|0;if(d|0){Y=d+12|0;f[Y>>2]=(f[Y>>2]|0)+1}Y=n+36|0;d=f[Y>>2]|0;if(d|0?($=d+12|0,d=f[$>>2]|0,f[$>>2]=d+-1,(d|0)==1):0)kL(n);f[Y>>2]=0;d=n+16|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[R>>2]|0)>0){$=f[T>>2]|0;ea=0;do{f[$+(ea<<2)>>2]=0;ea=ea+1|0;ja=f[R>>2]|0}while((ea|0)<(ja|0));f[n>>2]=f[o>>2];if((ja|0)<3)aa=53;else aa=55}else{f[n>>2]=f[o>>2];aa=53}if((aa|0)==53){ja=f[o+4>>2]|0;if((ja|0)<3){f[R>>2]=ja;f[S>>2]=f[o+8>>2];f[n+12>>2]=f[o+12>>2];ja=f[o+44>>2]|0;ea=f[V>>2]|0;f[ea>>2]=f[ja>>2];f[ea+4>>2]=f[ja+4>>2]}else aa=55}if((aa|0)==55)jL(n,o);ja=o+16|0;f[d>>2]=f[ja>>2];ea=n+20|0;f[ea>>2]=f[o+20>>2];$=n+24|0;f[$>>2]=f[o+24>>2];ca=n+28|0;f[ca>>2]=f[o+28>>2];ba=n+32|0;f[ba>>2]=f[o+32>>2];Z=f[e>>2]|0;f[Y>>2]=Z;if(Z|0){_=Z+12|0;f[_>>2]=(f[_>>2]|0)+1}_=m+36|0;Z=f[_>>2]|0;if(Z|0?(X=Z+12|0,Z=f[X>>2]|0,f[X>>2]=Z+-1,(Z|0)==1):0)kL(m);f[_>>2]=0;Z=m+16|0;f[Z>>2]=0;f[Z+4>>2]=0;f[Z+8>>2]=0;f[Z+12>>2]=0;if((f[M>>2]|0)>0){X=f[O>>2]|0;da=0;do{f[X+(da<<2)>>2]=0;da=da+1|0;ka=f[M>>2]|0}while((da|0)<(ka|0));f[m>>2]=f[n>>2];if((ka|0)<3)aa=66;else aa=68}else{f[m>>2]=f[n>>2];aa=66}if((aa|0)==66){ka=f[R>>2]|0;if((ka|0)<3){f[M>>2]=ka;f[N>>2]=f[S>>2];f[m+12>>2]=f[n+12>>2];S=f[V>>2]|0;N=f[Q>>2]|0;f[N>>2]=f[S>>2];f[N+4>>2]=f[S+4>>2]}else aa=68}if((aa|0)==68)jL(m,n);f[Z>>2]=f[d>>2];f[m+20>>2]=f[ea>>2];f[m+24>>2]=f[$>>2];f[m+28>>2]=f[ca>>2];f[m+32>>2]=f[ba>>2];f[_>>2]=f[Y>>2];Y=f[e>>2]|0;if(Y|0?(_=Y+12|0,Y=f[_>>2]|0,f[_>>2]=Y+-1,(Y|0)==1):0)kL(o);f[e>>2]=0;e=o+4|0;f[ja>>2]=0;f[ja+4>>2]=0;f[ja+8>>2]=0;f[ja+12>>2]=0;if((f[e>>2]|0)>0){ja=f[o+40>>2]|0;Y=0;do{f[ja+(Y<<2)>>2]=0;Y=Y+1|0}while((Y|0)<(f[e>>2]|0))}e=f[o+44>>2]|0;if((e|0)!=(o+48|0))UC(e);ia=n}f[o+8>>2]=0;f[o+12>>2]=0;f[o>>2]=16842752;f[o+4>>2]=h;e=p+8|0;f[e>>2]=0;f[e+4>>2]=0;f[p>>2]=33619968;f[p+4>>2]=i;e=q+8|0;f[e>>2]=0;f[e+4>>2]=0;if(!W){f[q>>2]=33554432;f[q+4>>2]=0}else{f[q>>2]=33619968;f[q+4>>2]=W}W=r+8|0;f[W>>2]=0;f[W+4>>2]=0;if(!ia){f[r>>2]=33554432;f[r+4>>2]=0}else{f[r>>2]=33619968;f[r+4>>2]=ia}C3(o,p,q,r,f[i>>2]&7,-1);if(!(((f[w>>2]|0)==(f[v>>2]|0)?(f[l+16>>2]|0)==(f[k+16>>2]|0):0)?(f[n+16>>2]|0)==(f[m+16>>2]|0):0)){f[o>>2]=0;f[o+4>>2]=0;D=aD(o,81)|0;r=234531;E=D+81|0;do{b[D>>0]=b[r>>0]|0;D=D+1|0;r=r+1|0}while((D|0)<(E|0));bO(-215,o,234613,234264,570);bD(o)}o=n+36|0;r=f[o>>2]|0;if(r|0?(D=r+12|0,r=f[D>>2]|0,f[D>>2]=r+-1,(r|0)==1):0)kL(n);f[o>>2]=0;o=n+16|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[R>>2]|0)>0){o=f[T>>2]|0;T=0;do{f[o+(T<<2)>>2]=0;T=T+1|0}while((T|0)<(f[R>>2]|0))}R=f[V>>2]|0;if((R|0)!=(U|0))UC(R);R=m+36|0;U=f[R>>2]|0;if(U|0?(V=U+12|0,U=f[V>>2]|0,f[V>>2]=U+-1,(U|0)==1):0)kL(m);f[R>>2]=0;R=m+16|0;f[R>>2]=0;f[R+4>>2]=0;f[R+8>>2]=0;f[R+12>>2]=0;if((f[M>>2]|0)>0){R=f[O>>2]|0;O=0;do{f[R+(O<<2)>>2]=0;O=O+1|0}while((O|0)<(f[M>>2]|0))}M=f[Q>>2]|0;if((M|0)!=(P|0))UC(M);M=l+36|0;P=f[M>>2]|0;if(P|0?(Q=P+12|0,P=f[Q>>2]|0,f[Q>>2]=P+-1,(P|0)==1):0)kL(l);f[M>>2]=0;M=l+16|0;f[M>>2]=0;f[M+4>>2]=0;f[M+8>>2]=0;f[M+12>>2]=0;if((f[H>>2]|0)>0){M=f[J>>2]|0;J=0;do{f[M+(J<<2)>>2]=0;J=J+1|0}while((J|0)<(f[H>>2]|0))}H=f[L>>2]|0;if((H|0)!=(K|0))UC(H);H=k+36|0;K=f[H>>2]|0;if(K|0?(L=K+12|0,K=f[L>>2]|0,f[L>>2]=K+-1,(K|0)==1):0)kL(k);f[H>>2]=0;H=k+16|0;f[H>>2]=0;f[H+4>>2]=0;f[H+8>>2]=0;f[H+12>>2]=0;if((f[C>>2]|0)>0){H=f[z>>2]|0;z=0;do{f[H+(z<<2)>>2]=0;z=z+1|0}while((z|0)<(f[C>>2]|0))}C=f[G>>2]|0;if((C|0)!=(F|0))UC(C);C=f[x>>2]|0;do if(C|0){F=C+12|0;G=f[F>>2]|0;f[F>>2]=G+-1;if((G|0)!=1)break;kL(j)}while(0);f[x>>2]=0;f[v>>2]=0;f[v+4>>2]=0;f[v+8>>2]=0;f[v+12>>2]=0;if((f[c>>2]|0)>0){v=f[A>>2]|0;A=0;do{f[v+(A<<2)>>2]=0;A=A+1|0}while((A|0)<(f[c>>2]|0))}c=f[B>>2]|0;if((c|0)!=(t|0))UC(c);c=f[y>>2]|0;do if(c|0){t=c+12|0;B=f[t>>2]|0;f[t>>2]=B+-1;if((B|0)!=1)break;kL(i)}while(0);f[y>>2]=0;f[w>>2]=0;f[w+4>>2]=0;f[w+8>>2]=0;f[w+12>>2]=0;if((f[a>>2]|0)>0){w=f[i+40>>2]|0;y=0;do{f[w+(y<<2)>>2]=0;y=y+1|0}while((y|0)<(f[a>>2]|0))}a=f[i+44>>2]|0;if((a|0)!=(i+48|0))UC(a);a=h+36|0;i=f[a>>2]|0;do if(i|0){y=i+12|0;w=f[y>>2]|0;f[y>>2]=w+-1;if((w|0)!=1)break;kL(h)}while(0);f[a>>2]=0;a=h+16|0;i=h+4|0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;f[a+12>>2]=0;if((f[i>>2]|0)>0){a=f[h+40>>2]|0;w=0;do{f[a+(w<<2)>>2]=0;w=w+1|0}while((w|0)<(f[i>>2]|0))}i=f[h+44>>2]|0;if((i|0)==(h+48|0)){u=g;return}UC(i);u=g;return}function G3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;g=u;u=u+48|0;h=g+8|0;i=g;if(!((c|0)!=0&(d|0)!=0&(e|0)!=0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,45)|0;k=234624;l=j+45|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,234670,234688,47);bD(h);if(!c){m=c;n=h;o=8}else{p=c;q=h;o=4}}else{p=c;q=h;o=4}if((o|0)==4){r=f[c>>2]|0;if((((r&-65536|0)==1111621632?(f[c+24>>2]|0)>0:0)?(f[c+20>>2]|0)>0:0)?(f[c+16>>2]|0)!=0:0){s=r;t=p;v=q}else{m=p;n=q;o=8}}if((o|0)==8){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,33)|0;k=234758;l=j+33|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-5,i,234670,234688,54);bD(i);s=f[c>>2]|0;t=m;v=n}if((s&4088|0)==0?(f[c+24>>2]|0)==2:0){FQ(c,h,2,0)|0;w=h}else w=t;t=f[w>>2]|0;h=t&4095;if((t&4094|0)!=12){f[i>>2]=0;f[i+4>>2]=0;j=aD(i,87)|0;k=234792;l=j+87|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-210,i,234670,234688,63);bD(i)}c=w+24|0;s=f[c>>2]|0;if(!((s|0)!=1?(f[w+20>>2]|0)!=1:0))o=16;if((o|0)==16?f[w>>2]&16384|0:0){x=s;y=a&28672;z=h|y;A=t>>>3;B=A&511;C=B+1|0;D=t<<1;E=D&14;F=47696>>>E;G=F&3;H=C<<G;I=w+16|0;J=f[I>>2]|0;K=w+20|0;L=f[K>>2]|0;M=Y(L,x)|0;OW(z,88,H,J,M,d,e)|0;u=g;return d|0}f[i>>2]=0;f[i+4>>2]=0;j=aD(i,75)|0;k=234880;l=j+75|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-5,i,234670,234688,68);bD(i);x=f[c>>2]|0;y=a&28672;z=h|y;A=t>>>3;B=A&511;C=B+1|0;D=t<<1;E=D&14;F=47696>>>E;G=F&3;H=C<<G;I=w+16|0;J=f[I>>2]|0;K=w+20|0;L=f[K>>2]|0;M=Y(L,x)|0;OW(z,88,H,J,M,d,e)|0;u=g;return d|0}function H3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return I3(a,b,c,d,-1)|0}function I3(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0;h=u;u=u+144|0;i=h+72|0;j=h+8|0;k=h+16|0;l=h+128|0;m=h;do if((yM(a)|0)==65536){n=f[a+4>>2]|0;f[i>>2]=f[n>>2];o=i+4|0;p=n+4|0;f[o>>2]=f[p>>2];q=i+8|0;f[q>>2]=f[n+8>>2];f[i+12>>2]=f[n+12>>2];f[i+16>>2]=f[n+16>>2];f[i+20>>2]=f[n+20>>2];f[i+24>>2]=f[n+24>>2];f[i+28>>2]=f[n+28>>2];f[i+32>>2]=f[n+32>>2];r=f[n+36>>2]|0;f[i+36>>2]=r;s=i+40|0;f[s>>2]=q;q=i+48|0;t=i+44|0;f[t>>2]=q;f[q>>2]=0;f[i+52>>2]=0;if(r|0){q=r+12|0;f[q>>2]=(f[q>>2]|0)+1}if((f[p>>2]|0)<3){p=f[n+44>>2]|0;q=f[t>>2]|0;f[q>>2]=f[p>>2];f[q+4>>2]=f[p+4>>2];v=s;break}else{f[o>>2]=0;jL(i,n);v=s;break}}else{yL(i,a,-1);v=i+40|0}while(0);a=f[v>>2]|0;s=f[a>>2]|0;f[j>>2]=f[a+4>>2];f[j+4>>2]=s;vM(c,j,e&7,-1,0,0);do if((yM(c)|0)==65536){j=f[c+4>>2]|0;f[k>>2]=f[j>>2];s=k+4|0;a=j+4|0;f[s>>2]=f[a>>2];n=k+8|0;f[n>>2]=f[j+8>>2];f[k+12>>2]=f[j+12>>2];f[k+16>>2]=f[j+16>>2];f[k+20>>2]=f[j+20>>2];f[k+24>>2]=f[j+24>>2];f[k+28>>2]=f[j+28>>2];f[k+32>>2]=f[j+32>>2];o=f[j+36>>2]|0;f[k+36>>2]=o;f[k+40>>2]=n;n=k+48|0;p=k+44|0;f[p>>2]=n;f[n>>2]=0;f[k+52>>2]=0;if(o|0){n=o+12|0;f[n>>2]=(f[n>>2]|0)+1}if((f[a>>2]|0)<3){a=f[j+44>>2]|0;n=f[p>>2]|0;f[n>>2]=f[a>>2];f[n+4>>2]=f[a+4>>2];break}else{f[s>>2]=0;jL(k,j);break}}else yL(k,c,-1);while(0);switch(e|0){case 2:{w=J3(i,k,d,g,l)|0;break}case 4:{w=J3(i,k,d,g,l)|0;break}default:{f[m>>2]=0;f[m+4>>2]=0;l=aD(m,37)|0;g=234956;d=l+37|0;do{b[l>>0]=b[g>>0]|0;l=l+1|0;g=g+1|0}while((l|0)<(d|0));bO(-210,m,234994,235014,4010);bD(m);w=0}}m=k+36|0;g=f[m>>2]|0;if(g|0?(l=g+12|0,g=f[l>>2]|0,f[l>>2]=g+-1,(g|0)==1):0)kL(k);f[m>>2]=0;m=k+16|0;g=k+4|0;f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;f[m+12>>2]=0;if((f[g>>2]|0)>0){m=f[k+40>>2]|0;l=0;do{f[m+(l<<2)>>2]=0;l=l+1|0}while((l|0)<(f[g>>2]|0))}g=f[k+44>>2]|0;if((g|0)!=(k+48|0))UC(g);g=i+36|0;k=f[g>>2]|0;if(k|0?(l=k+12|0,k=f[l>>2]|0,f[l>>2]=k+-1,(k|0)==1):0)kL(i);f[g>>2]=0;g=i+16|0;k=i+4|0;f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;f[g+12>>2]=0;if((f[k>>2]|0)>0){g=f[v>>2]|0;v=0;do{f[g+(v<<2)>>2]=0;v=v+1|0}while((v|0)<(f[k>>2]|0))}k=f[i+44>>2]|0;if((k|0)==(i+48|0)){u=h;return w|0}UC(k);u=h;return w|0}function J3(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=u;u=u+16|0;i=h;j=h+13|0;k=h+12|0;l=h+11|0;m=h+10|0;n=h+9|0;o=h+8|0;if(!((f[c>>2]&4088|0)==0?!(f[a>>2]&4088|0):0)){f[i>>2]=0;f[i+4>>2]=0;p=aD(i,38)|0;q=235098;r=p+38|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,i,235137,235014,3932);bD(i)}s=(d|0)==8;t=(d|0)==4;switch(d|0){case 4:case 8:break;default:{f[i>>2]=0;f[i+4>>2]=0;p=aD(i,38)|0;q=267207;r=p+38|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,i,235137,235014,3933);bD(i)}}v=(e|0)==1;w=(e|0)==0;x=(e|0)==-1;switch(e|0){case 0:case 1:case -1:break;default:{f[i>>2]=0;f[i+4>>2]=0;p=aD(i,67)|0;q=235162;r=p+67|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,i,235137,235014,3934);bD(i)}}e=f[c>>2]|0;y=e&7;z=f[a>>2]&6;A=VQ()|0;B=UQ()|0;if((z|1|0)!=1){f[i>>2]=0;f[i+4>>2]=0;p=aD(i,26)|0;q=235230;r=p+26|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,i,235137,235014,3941);bD(i)}if((A|0)!=0&(B|0)>1)C=((f[c+8>>2]|0)/(B|0)|0|0)>1;else C=0;B=(y|0)==0;a:do if(t|w){if(!B){switch(e&7){case 2:{D=(K3(j,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=M3(l,a,c,d,g)|0;u=h;return D|0}else{D=L3(k,a,c,d,g)|0;u=h;return D|0}}}else if(!(B|s&(v|x)^1)){switch(e&7){case 2:{D=(N3(m,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=P3(o,a,c,d,g)|0;u=h;return D|0}else{D=O3(n,a,c,d,g)|0;u=h;return D|0}}while(0);f[i>>2]=0;f[i+4>>2]=0;p=aD(i,28)|0;q=235257;r=p+28|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-210,i,235137,235014,3987);bD(i);D=-1;u=h;return D|0}function K3(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;h=u;u=u+16|0;a=h;i=c+8|0;if((f[e+8>>2]|0)!=(f[i>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;k=aD(a,26)|0;l=235751;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,a,489445,235014,659);bD(a)}n=c+12|0;if((f[e+12>>2]|0)!=(f[n>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;k=aD(a,26)|0;l=235778;m=k+26|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,a,489445,235014,660);bD(a)}o=(g|0)==8;switch(g|0){case 4:case 8:break;default:{f[a>>2]=0;f[a+4>>2]=0;k=aD(a,38)|0;l=267207;m=k+38|0;do{b[k>>0]=b[l>>0]|0;k=k+1|0;l=l+1|0}while((k|0)<(m|0));bO(-215,a,489445,235014,661);bD(a)}}a=f[i>>2]|0;i=f[n>>2]|0;n=TC((Y(i,a)|0)+3&-2)|0;d[n>>1]=0;l=(a|0)>0;if(o){if(!l){p=1;UC(n);u=h;return p|0}o=(i|0)>0;k=i+-1|0;m=f[c+16>>2]|0;g=f[f[c+44>>2]>>2]|0;q=f[e+16>>2]|0;r=f[f[e+44>>2]>>2]|0;s=0-g|0;t=0-r|0;v=1;w=0;while(1){x=m+(Y(g,w)|0)|0;y=x+s|0;z=q+(Y(r,w)|0)|0;A=z+t|0;if(o){B=(w|0)>0;C=0;D=v;while(1){a:do if(!(b[x+C>>0]|0)){d[z+(C<<1)>>1]=0;E=D}else{if(B){if(b[y+C>>0]|0){d[z+(C<<1)>>1]=d[A+(C<<1)>>1]|0;E=D;break}F=(C|0)>0;if((C|0)<(k|0)?(G=C+1|0,b[y+G>>0]|0):0){H=d[A+(G<<1)>>1]|0;do if(F){G=C+-1|0;if(!(b[y+G>>0]|0)){I=C+-1|0;if(!(b[x+I>>0]|0)){J=H;break}K=d[z+(I<<1)>>1]|0;I=K;while(1){L=d[n+((I&65535)<<1)>>1]|0;if((L&65535)<(I&65535))I=L;else break}if(K<<16>>16==H<<16>>16)M=I;else{L=H;while(1){N=d[n+((L&65535)<<1)>>1]|0;if((N&65535)<(L&65535))L=N;else break}N=(I&65535)>(L&65535)?L:I;O=H;do{P=n+((O&65535)<<1)|0;Q=O;O=d[P>>1]|0;d[P>>1]=N}while((O&65535)<(Q&65535));M=N}N=K;do{O=n+((N&65535)<<1)|0;I=N;N=d[O>>1]|0;d[O>>1]=M}while((N&65535)<(I&65535));J=M}else{N=d[A+(G<<1)>>1]|0;K=N;while(1){I=d[n+((K&65535)<<1)>>1]|0;if((I&65535)<(K&65535))K=I;else break}if(N<<16>>16==H<<16>>16)R=K;else{G=H;while(1){I=d[n+((G&65535)<<1)>>1]|0;if((I&65535)<(G&65535))G=I;else break}I=(K&65535)>(G&65535)?G:K;O=H;do{L=n+((O&65535)<<1)|0;Q=O;O=d[L>>1]|0;d[L>>1]=I}while((O&65535)<(Q&65535));R=I}I=N;do{O=n+((I&65535)<<1)|0;K=I;I=d[O>>1]|0;d[O>>1]=R}while((I&65535)<(K&65535));d[z+(C<<1)>>1]=R;E=D;break a}}else J=H;while(0);d[z+(C<<1)>>1]=J;E=D;break}if(F){H=C+-1|0;if(!(b[y+H>>0]|0))S=46;else{d[z+(C<<1)>>1]=d[A+(H<<1)>>1]|0;E=D;break}}}else if((C|0)>0)S=46;if((S|0)==46?(S=0,H=C+-1|0,b[x+H>>0]|0):0){d[z+(C<<1)>>1]=d[z+(H<<1)>>1]|0;E=D;break}d[z+(C<<1)>>1]=D;H=D&65535;d[n+(H<<1)>>1]=D;E=H+1&65535}while(0);C=C+1|0;if((C|0)==(i|0)){T=E;break}else D=E}}else T=v;w=w+1|0;if((w|0)==(a|0)){U=T;break}else v=T}}else{if(!l){p=1;UC(n);u=h;return p|0}T=(i|0)>0;v=f[c+16>>2]|0;w=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;E=f[f[e+44>>2]>>2]|0;S=0-w|0;J=0-E|0;R=0;M=1;while(1){k=v+(Y(w,R)|0)|0;o=k+S|0;t=c+(Y(E,R)|0)|0;r=t+J|0;b:do if(T){if((R|0)>0){V=0;W=M}else{q=0;s=M;while(1){do if(!(b[k+q>>0]|0)){d[t+(q<<1)>>1]=0;X=s}else{if((q|0)>0?(g=q+-1|0,b[k+g>>0]|0):0){d[t+(q<<1)>>1]=d[t+(g<<1)>>1]|0;X=s;break}d[t+(q<<1)>>1]=s;g=s&65535;d[n+(g<<1)>>1]=s;X=g+1&65535}while(0);q=q+1|0;if((q|0)==(i|0)){Z=X;break b}else s=X}}while(1){do if(!(b[k+V>>0]|0)){d[t+(V<<1)>>1]=0;_=W}else{s=(V|0)>0;if(!(b[o+V>>0]|0)){if(s?(q=V+-1|0,b[k+q>>0]|0):0){d[t+(V<<1)>>1]=d[t+(q<<1)>>1]|0;_=W;break}d[t+(V<<1)>>1]=W;q=W&65535;d[n+(q<<1)>>1]=W;_=q+1&65535;break}q=d[r+(V<<1)>>1]|0;if(s?(s=V+-1|0,(b[k+s>>0]|0)!=0):0){F=d[t+(s<<1)>>1]|0;s=F;while(1){g=d[n+((s&65535)<<1)>>1]|0;if((g&65535)<(s&65535))s=g;else break}if(F<<16>>16==q<<16>>16)$=s;else{g=q;while(1){m=d[n+((g&65535)<<1)>>1]|0;if((m&65535)<(g&65535))g=m;else break}m=(s&65535)>(g&65535)?g:s;D=q;do{C=n+((D&65535)<<1)|0;z=D;D=d[C>>1]|0;d[C>>1]=m}while((D&65535)<(z&65535));$=m}m=F;do{D=n+((m&65535)<<1)|0;s=m;m=d[D>>1]|0;d[D>>1]=$}while((m&65535)<(s&65535));aa=$}else aa=q;d[t+(V<<1)>>1]=aa;_=W}while(0);V=V+1|0;if((V|0)==(i|0)){Z=_;break}else W=_}}else Z=M;while(0);R=R+1|0;if((R|0)==(a|0)){U=Z;break}else M=Z}}if((U&65535)>1){Z=U&65535;U=1;M=1;while(1){R=n+(M<<1)|0;_=j[R>>1]|0;if(_>>>0<M>>>0){d[R>>1]=d[n+(_<<1)>>1]|0;ba=U}else{d[R>>1]=U;ba=(U&65535)+1&65535}M=M+1|0;if((M|0)==(Z|0)){ca=ba;break}else U=ba}}else ca=1;if(!l){p=ca;UC(n);u=h;return p|0}l=f[e+16>>2]|0;ba=f[f[e+44>>2]>>2]|0;e=0;do{U=l+(Y(ba,e)|0)|0;Z=U+(i<<1)|0;if((U|0)!=(Z|0)){M=U;do{d[M>>1]=d[n+(j[M>>1]<<1)>>1]|0;M=M+2|0}while((M|0)!=(Z|0))}e=e+1|0}while((e|0)!=(a|0));p=ca;UC(n);u=h;return p|0}function L3(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0;g=u;u=u+16|0;a=g;h=c+8|0;if((f[d+8>>2]|0)!=(f[h>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;i=aD(a,26)|0;j=235751;k=i+26|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,a,489445,235014,659);bD(a)}l=c+12|0;if((f[d+12>>2]|0)!=(f[l>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;i=aD(a,26)|0;j=235778;k=i+26|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,a,489445,235014,660);bD(a)}m=(e|0)==8;switch(e|0){case 4:case 8:break;default:{f[a>>2]=0;f[a+4>>2]=0;i=aD(a,38)|0;j=267207;k=i+38|0;do{b[i>>0]=b[j>>0]|0;i=i+1|0;j=j+1|0}while((i|0)<(k|0));bO(-215,a,489445,235014,661);bD(a)}}a=f[h>>2]|0;h=f[l>>2]|0;l=TC((((Y(h,a)|0)+1|0)>>>1<<2)+4|0)|0;f[l>>2]=0;j=(a|0)>0;if(m){if(!j){n=1;UC(l);u=g;return n|0}m=(h|0)>0;i=h+-1|0;k=f[c+16>>2]|0;e=f[c+44>>2]|0;o=f[d+16>>2]|0;p=f[d+44>>2]|0;q=1;r=0;while(1){s=f[e>>2]|0;t=k+(Y(s,r)|0)|0;v=t+(0-s)|0;s=f[p>>2]|0;w=o+(Y(s,r)|0)|0;x=w+(0-s)|0;if(m){s=(r|0)>0;y=0;z=q;while(1){a:do if(!(b[t+y>>0]|0)){f[w+(y<<2)>>2]=0;A=z}else{if(s){if(b[v+y>>0]|0){f[w+(y<<2)>>2]=f[x+(y<<2)>>2];A=z;break}B=(y|0)>0;if((y|0)<(i|0)?(C=y+1|0,b[v+C>>0]|0):0){D=f[x+(C<<2)>>2]|0;do if(B){C=y+-1|0;if(!(b[v+C>>0]|0)){E=y+-1|0;if(!(b[t+E>>0]|0)){F=D;break}G=f[w+(E<<2)>>2]|0;E=G;while(1){H=f[l+(E<<2)>>2]|0;if((H|0)<(E|0))E=H;else break}if((G|0)==(D|0))I=E;else{H=D;while(1){J=f[l+(H<<2)>>2]|0;if((J|0)<(H|0))H=J;else break}J=(E|0)>(H|0)?H:E;K=D;do{L=l+(K<<2)|0;M=K;K=f[L>>2]|0;f[L>>2]=J}while((K|0)<(M|0));I=J}J=G;do{K=l+(J<<2)|0;E=J;J=f[K>>2]|0;f[K>>2]=I}while((J|0)<(E|0));F=I}else{J=f[x+(C<<2)>>2]|0;G=J;while(1){E=f[l+(G<<2)>>2]|0;if((E|0)<(G|0))G=E;else break}if((J|0)==(D|0))N=G;else{C=D;while(1){E=f[l+(C<<2)>>2]|0;if((E|0)<(C|0))C=E;else break}E=(G|0)>(C|0)?C:G;K=D;do{H=l+(K<<2)|0;M=K;K=f[H>>2]|0;f[H>>2]=E}while((K|0)<(M|0));N=E}E=J;do{K=l+(E<<2)|0;G=E;E=f[K>>2]|0;f[K>>2]=N}while((E|0)<(G|0));f[w+(y<<2)>>2]=N;A=z;break a}}else F=D;while(0);f[w+(y<<2)>>2]=F;A=z;break}if(B){D=y+-1|0;if(!(b[v+D>>0]|0))O=46;else{f[w+(y<<2)>>2]=f[x+(D<<2)>>2];A=z;break}}}else if((y|0)>0)O=46;if((O|0)==46?(O=0,D=y+-1|0,b[t+D>>0]|0):0){f[w+(y<<2)>>2]=f[w+(D<<2)>>2];A=z;break}f[w+(y<<2)>>2]=z;f[l+(z<<2)>>2]=z;A=z+1|0}while(0);y=y+1|0;if((y|0)==(h|0)){P=A;break}else z=A}}else P=q;r=r+1|0;if((r|0)==(a|0)){Q=P;break}else q=P}}else{if(!j){n=1;UC(l);u=g;return n|0}P=(h|0)>0;q=f[c+16>>2]|0;r=f[c+44>>2]|0;c=f[d+16>>2]|0;A=f[d+44>>2]|0;O=0;F=1;while(1){N=f[r>>2]|0;I=q+(Y(N,O)|0)|0;i=I+(0-N)|0;N=f[A>>2]|0;m=c+(Y(N,O)|0)|0;o=m+(0-N)|0;b:do if(P){if((O|0)>0){R=0;S=F}else{N=0;p=F;while(1){do if(!(b[I+N>>0]|0)){f[m+(N<<2)>>2]=0;T=p}else{if((N|0)>0?(k=N+-1|0,b[I+k>>0]|0):0){f[m+(N<<2)>>2]=f[m+(k<<2)>>2];T=p;break}f[m+(N<<2)>>2]=p;f[l+(p<<2)>>2]=p;T=p+1|0}while(0);N=N+1|0;if((N|0)==(h|0)){U=T;break b}else p=T}}while(1){do if(!(b[I+R>>0]|0)){f[m+(R<<2)>>2]=0;V=S}else{p=(R|0)>0;if(!(b[i+R>>0]|0)){if(p?(N=R+-1|0,b[I+N>>0]|0):0){f[m+(R<<2)>>2]=f[m+(N<<2)>>2];V=S;break}f[m+(R<<2)>>2]=S;f[l+(S<<2)>>2]=S;V=S+1|0;break}N=f[o+(R<<2)>>2]|0;if(p?(p=R+-1|0,(b[I+p>>0]|0)!=0):0){B=f[m+(p<<2)>>2]|0;p=B;while(1){k=f[l+(p<<2)>>2]|0;if((k|0)<(p|0))p=k;else break}if((B|0)==(N|0))W=p;else{k=N;while(1){e=f[l+(k<<2)>>2]|0;if((e|0)<(k|0))k=e;else break}e=(p|0)>(k|0)?k:p;z=N;do{y=l+(z<<2)|0;w=z;z=f[y>>2]|0;f[y>>2]=e}while((z|0)<(w|0));W=e}e=B;do{z=l+(e<<2)|0;p=e;e=f[z>>2]|0;f[z>>2]=W}while((e|0)<(p|0));X=W}else X=N;f[m+(R<<2)>>2]=X;V=S}while(0);R=R+1|0;if((R|0)==(h|0)){U=V;break}else S=V}}else U=F;while(0);O=O+1|0;if((O|0)==(a|0)){Q=U;break}else F=U}}if((Q|0)>1){U=1;F=1;while(1){O=l+(F<<2)|0;V=f[O>>2]|0;if((V|0)<(F|0)){f[O>>2]=f[l+(V<<2)>>2];Z=U}else{f[O>>2]=U;Z=U+1|0}F=F+1|0;if((F|0)==(Q|0)){_=Z;break}else U=Z}}else _=1;if(!j){n=_;UC(l);u=g;return n|0}j=f[d+16>>2]|0;Z=f[d+44>>2]|0;d=0;do{U=j+(Y(f[Z>>2]|0,d)|0)|0;Q=U+(h<<2)|0;if((U|0)!=(Q|0)){F=U;do{f[F>>2]=f[l+(f[F>>2]<<2)>>2];F=F+4|0}while((F|0)!=(Q|0))}d=d+1|0}while((d|0)!=(a|0));n=_;UC(l);u=g;return n|0}function M3(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;a=u;u=u+48|0;h=a+32|0;i=a+24|0;j=a;k=c+8|0;l=d+8|0;if((f[k>>2]|0)!=(f[l>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=aD(h,26)|0;n=235286;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,489445,235014,578);bD(h)}p=c+12|0;q=d+12|0;if((f[p>>2]|0)!=(f[q>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=aD(h,26)|0;n=235313;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,489445,235014,579);bD(h)}r=(e|0)==8;switch(e|0){case 4:case 8:break;default:{f[h>>2]=0;f[h+4>>2]=0;m=aD(h,38)|0;n=267207;o=m+38|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,489445,235014,580);bD(h)}}n=UQ()|0;m=f[k>>2]|0;k=f[p>>2]|0;p=((Y(k,m)|0)+1|0)>>>1;o=TC(m<<2)|0;e=TC((p<<2)+4|0)|0;f[e>>2]=0;f[h>>2]=0;f[h+4>>2]=m;f[i>>2]=1;if(r){f[j>>2]=51932;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=e;f[j+16>>2]=o;RQ(h,j,+(n|0));V3(d,e,o);if((m|0)>0){r=(k+1|0)/2|0;p=0;do{s=p+1|0;t=(Y((s|0)/2|0,r)|0)+1|0;v=f[o+(s<<2)>>2]|0;s=v+t|0;if((v|0)>0){v=t;do{t=e+(v<<2)|0;w=f[t>>2]|0;if((w|0)<(v|0))f[t>>2]=f[e+(w<<2)>>2];else{f[t>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}v=v+1|0}while((v|0)<(s|0))}p=f[o+(p<<2)>>2]|0}while((p|0)<(m|0))}}else{f[j>>2]=51952;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=e;f[j+16>>2]=o;RQ(h,j,+(n|0));c=f[q>>2]|0;q=f[l>>2]|0;l=f[o>>2]|0;a:do if((l|0)<(q|0)){p=f[d+16>>2]|0;r=f[d+44>>2]|0;if((c|0)>0)x=l;else{s=l;while(1){s=f[o+(s<<2)>>2]|0;if((s|0)>=(q|0))break a}}do{s=f[r>>2]|0;v=p+(Y(s,x)|0)|0;t=v+(0-s)|0;s=0;do{w=v+(s<<2)|0;y=f[w>>2]|0;if((y|0)>0?(z=f[t+(s<<2)>>2]|0,(z|0)>0):0){A=z;while(1){B=f[e+(A<<2)>>2]|0;if((B|0)<(A|0))A=B;else break}if((z|0)==(y|0))C=A;else{B=y;while(1){D=f[e+(B<<2)>>2]|0;if((D|0)<(B|0))B=D;else break}D=(A|0)>(B|0)?B:A;E=y;do{F=e+(E<<2)|0;G=E;E=f[F>>2]|0;f[F>>2]=D}while((E|0)<(G|0));C=D}D=z;do{E=e+(D<<2)|0;y=D;D=f[E>>2]|0;f[E>>2]=C}while((D|0)<(y|0));f[w>>2]=C}s=s+1|0}while((s|0)!=(c|0));x=f[o+(x<<2)>>2]|0}while((x|0)<(q|0))}while(0);if((m|0)>0){q=0;do{x=(((Y(q,k)|0)+1|0)/2|0)+1|0;c=f[o+(q+1<<2)>>2]|0;C=c+x|0;if((c|0)>0){c=x;do{x=e+(c<<2)|0;l=f[x>>2]|0;if((l|0)<(c|0))f[x>>2]=f[e+(l<<2)>>2];else{f[x>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}c=c+1|0}while((c|0)<(C|0))}q=f[o+(q<<2)>>2]|0}while((q|0)<(m|0))}}q=N5b((m|0)>-1?m:-1)|0;f[j>>2]=51972;f[j+4>>2]=d;f[j+8>>2]=e;f[j+12>>2]=g;f[j+16>>2]=q;f[j+20>>2]=i;RQ(h,j,+(n|0));P5b(q);UC(o);UC(e);u=a;return f[i>>2]|0}function N3(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0;h=u;u=u+16|0;a=h;i=c+8|0;k=e+8|0;if((f[i>>2]|0)!=(f[k>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;l=aD(a,26)|0;m=235286;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,a,489445,235014,2594);bD(a)}o=c+12|0;p=e+12|0;if((f[o>>2]|0)!=(f[p>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;l=aD(a,26)|0;m=235313;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,a,489445,235014,2595);bD(a)}if((g|0)!=8){f[a>>2]=0;f[a+4>>2]=0;l=aD(a,17)|0;m=235340;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,a,489445,235014,2596);bD(a)}a=f[i>>2]|0;i=f[o>>2]|0;o=TC((Y(((a+1|0)/2|0)<<1,(i+1|0)/2|0)|0)+2|0)|0;d[o>>1]=0;if((a|0)>0){m=c+16|0;l=c+44|0;n=e+16|0;g=e+44|0;q=(i|0)>0;r=1;s=0;while(1){t=f[f[l>>2]>>2]|0;v=(f[m>>2]|0)+(Y(t,s)|0)|0;w=0-t|0;x=v+w|0;y=x+w|0;w=v+t|0;t=f[f[g>>2]>>2]|0;z=(f[n>>2]|0)+(Y(t,s)|0)|0;A=0-t|0;t=z+A+A|0;if(q){A=(s|1|0)<(a|0);B=(s|0)>0;C=B^1;D=(s+-2|0)>-1;E=0;F=r;while(1){a:do if(!(b[v+E>>0]|0)){G=E|1;H=(G|0)<(i|0);if(A?b[w+E>>0]|0:0){I=E+-1|0;J=(E|0)>0;if(H?b[v+G>>0]|0:0){do if(J){if(b[v+I>>0]|0){do if(B){if(b[x+G>>0]|0){if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}do if(D){if(!(b[y+E>>0]|0))break;L=E+-2|0;if(b[x+I>>0]|0){d[z+(E<<1)>>1]=d[z+(L<<1)>>1]|0;K=F;break a}do if((L|0)>-1){if(!(b[x+L>>0]|0))break;if(b[y+I>>0]|0){d[z+(E<<1)>>1]=d[z+(L<<1)>>1]|0;K=F;break a}M=d[t+(E<<1)>>1]|0;N=d[z+(L<<1)>>1]|0;O=M;while(1){P=d[o+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}if(M<<16>>16==N<<16>>16)Q=O;else{P=N;while(1){R=d[o+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}R=(O&65535)>(P&65535)?P:O;S=N;do{T=o+((S&65535)<<1)|0;U=S;S=d[T>>1]|0;d[T>>1]=R}while((S&65535)<(U&65535));Q=R}R=M;do{S=o+((R&65535)<<1)|0;N=R;R=d[S>>1]|0;d[S>>1]=Q}while((R&65535)<(N&65535));d[z+(E<<1)>>1]=Q;K=F;break a}while(0);R=d[t+(E<<1)>>1]|0;M=d[z+(L<<1)>>1]|0;N=R;while(1){S=d[o+((N&65535)<<1)>>1]|0;if((S&65535)<(N&65535))N=S;else break}if(R<<16>>16==M<<16>>16)V=N;else{L=M;while(1){S=d[o+((L&65535)<<1)>>1]|0;if((S&65535)<(L&65535))L=S;else break}S=(N&65535)>(L&65535)?L:N;O=M;do{P=o+((O&65535)<<1)|0;U=O;O=d[P>>1]|0;d[P>>1]=S}while((O&65535)<(U&65535));V=S}S=R;do{O=o+((S&65535)<<1)|0;M=S;S=d[O>>1]|0;d[O>>1]=V}while((S&65535)<(M&65535));d[z+(E<<1)>>1]=V;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;R=d[z+(E+-2<<1)>>1]|0;M=S;while(1){O=d[o+((M&65535)<<1)>>1]|0;if((O&65535)<(M&65535))M=O;else break}if(S<<16>>16==R<<16>>16)W=M;else{O=R;while(1){N=d[o+((O&65535)<<1)>>1]|0;if((N&65535)<(O&65535))O=N;else break}N=(M&65535)>(O&65535)?O:M;L=R;do{U=o+((L&65535)<<1)|0;P=L;L=d[U>>1]|0;d[U>>1]=N}while((L&65535)<(P&65535));W=N}N=S;do{L=o+((N&65535)<<1)|0;R=N;N=d[L>>1]|0;d[L>>1]=W}while((N&65535)<(R&65535));d[z+(E<<1)>>1]=W;K=F;break a}N=E+2|0;if((N|0)>=(i|0))break;if(!(b[x+N>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}if(!(b[y+E>>0]|0)){S=d[t+(N<<1)>>1]|0;R=d[z+(E+-2<<1)>>1]|0;L=S;while(1){M=d[o+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}if(S<<16>>16==R<<16>>16)X=L;else{M=R;while(1){O=d[o+((M&65535)<<1)>>1]|0;if((O&65535)<(M&65535))M=O;else break}O=(L&65535)>(M&65535)?M:L;P=R;do{U=o+((P&65535)<<1)|0;T=P;P=d[U>>1]|0;d[U>>1]=O}while((P&65535)<(T&65535));X=O}O=S;do{P=o+((O&65535)<<1)|0;R=O;O=d[P>>1]|0;d[P>>1]=X}while((O&65535)<(R&65535));d[z+(E<<1)>>1]=X;K=F;break a}O=E+-2|0;if(b[x+I>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}do if((O|0)>-1){if(!(b[x+O>>0]|0))break;if(b[y+I>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}S=d[t+(N<<1)>>1]|0;R=d[z+(O<<1)>>1]|0;P=S;while(1){L=d[o+((P&65535)<<1)>>1]|0;if((L&65535)<(P&65535))P=L;else break}if(S<<16>>16==R<<16>>16)Z=P;else{L=R;while(1){M=d[o+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}M=(P&65535)>(L&65535)?L:P;T=R;do{U=o+((T&65535)<<1)|0;_=T;T=d[U>>1]|0;d[U>>1]=M}while((T&65535)<(_&65535));Z=M}M=S;do{T=o+((M&65535)<<1)|0;R=M;M=d[T>>1]|0;d[T>>1]=Z}while((M&65535)<(R&65535));d[z+(E<<1)>>1]=Z;K=F;break a}while(0);M=d[t+(N<<1)>>1]|0;S=d[z+(O<<1)>>1]|0;R=M;while(1){T=d[o+((R&65535)<<1)>>1]|0;if((T&65535)<(R&65535))R=T;else break}if(M<<16>>16==S<<16>>16)$=R;else{O=S;while(1){T=d[o+((O&65535)<<1)>>1]|0;if((T&65535)<(O&65535))O=T;else break}T=(R&65535)>(O&65535)?O:R;P=S;do{L=o+((P&65535)<<1)|0;_=P;P=d[L>>1]|0;d[L>>1]=T}while((P&65535)<(_&65535));$=T}T=M;do{P=o+((T&65535)<<1)|0;S=T;T=d[P>>1]|0;d[P>>1]=$}while((T&65535)<(S&65535));d[z+(E<<1)>>1]=$;K=F;break a}while(0);T=d[t+(N<<1)>>1]|0;M=d[z+(E+-2<<1)>>1]|0;S=T;while(1){P=d[o+((S&65535)<<1)>>1]|0;if((P&65535)<(S&65535))S=P;else break}if(T<<16>>16==M<<16>>16)aa=S;else{N=M;while(1){P=d[o+((N&65535)<<1)>>1]|0;if((P&65535)<(N&65535))N=P;else break}P=(S&65535)>(N&65535)?N:S;R=M;do{O=o+((R&65535)<<1)|0;_=R;R=d[O>>1]|0;d[O>>1]=P}while((R&65535)<(_&65535));aa=P}P=T;do{R=o+((P&65535)<<1)|0;M=P;P=d[R>>1]|0;d[R>>1]=aa}while((P&65535)<(M&65535));d[z+(E<<1)>>1]=aa;K=F;break a}while(0);d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}if(!(b[w+I>>0]|0))break;do if(B){if(b[x+G>>0]|0){P=E+-2|0;do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[x+I>>0]|0){T=d[z+(P<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}do if(D){if(!(b[y+E>>0]|0))break;d[z+(E<<1)>>1]=T;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;R=M;while(1){S=d[o+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}if(M<<16>>16==T<<16>>16)ba=R;else{S=T;while(1){N=d[o+((S&65535)<<1)>>1]|0;if((N&65535)<(S&65535))S=N;else break}N=(R&65535)>(S&65535)?S:R;_=T;do{O=o+((_&65535)<<1)|0;L=_;_=d[O>>1]|0;d[O>>1]=N}while((_&65535)<(L&65535));ba=N}N=M;do{_=o+((N&65535)<<1)|0;T=N;N=d[_>>1]|0;d[_>>1]=ba}while((N&65535)<(T&65535));d[z+(E<<1)>>1]=ba;K=F;break a}if(!(b[x+P>>0]|0)){N=d[t+(E<<1)>>1]|0;M=d[z+(P<<1)>>1]|0;T=N;while(1){_=d[o+((T&65535)<<1)>>1]|0;if((_&65535)<(T&65535))T=_;else break}if(N<<16>>16==M<<16>>16)ca=T;else{_=M;while(1){R=d[o+((_&65535)<<1)>>1]|0;if((R&65535)<(_&65535))_=R;else break}R=(T&65535)>(_&65535)?_:T;S=M;do{L=o+((S&65535)<<1)|0;O=S;S=d[L>>1]|0;d[L>>1]=R}while((S&65535)<(O&65535));ca=R}R=N;do{S=o+((R&65535)<<1)|0;M=R;R=d[S>>1]|0;d[S>>1]=ca}while((R&65535)<(M&65535));d[z+(E<<1)>>1]=ca;K=F;break a}do if(D){if(!(b[y+I>>0]|0))break;R=d[z+(P<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=R;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=R;K=F;break a}N=d[t+(E<<1)>>1]|0;M=N;while(1){S=d[o+((M&65535)<<1)>>1]|0;if((S&65535)<(M&65535))M=S;else break}if(N<<16>>16==R<<16>>16)da=M;else{S=R;while(1){T=d[o+((S&65535)<<1)>>1]|0;if((T&65535)<(S&65535))S=T;else break}T=(M&65535)>(S&65535)?S:M;_=R;do{O=o+((_&65535)<<1)|0;L=_;_=d[O>>1]|0;d[O>>1]=T}while((_&65535)<(L&65535));da=T}T=N;do{_=o+((T&65535)<<1)|0;R=T;T=d[_>>1]|0;d[_>>1]=da}while((T&65535)<(R&65535));d[z+(E<<1)>>1]=da;K=F;break a}while(0);T=d[t+(E<<1)>>1]|0;N=d[z+(P<<1)>>1]|0;R=T;while(1){_=d[o+((R&65535)<<1)>>1]|0;if((_&65535)<(R&65535))R=_;else break}if(T<<16>>16==N<<16>>16)ea=R;else{_=N;while(1){M=d[o+((_&65535)<<1)>>1]|0;if((M&65535)<(_&65535))_=M;else break}M=(R&65535)>(_&65535)?_:R;S=N;do{L=o+((S&65535)<<1)|0;O=S;S=d[L>>1]|0;d[L>>1]=M}while((S&65535)<(O&65535));ea=M}M=T;do{S=o+((M&65535)<<1)|0;N=M;M=d[S>>1]|0;d[S>>1]=ea}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=ea;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;T=d[z+(P<<1)>>1]|0;N=M;while(1){S=d[o+((N&65535)<<1)>>1]|0;if((S&65535)<(N&65535))N=S;else break}if(M<<16>>16==T<<16>>16)fa=N;else{P=T;while(1){S=d[o+((P&65535)<<1)>>1]|0;if((S&65535)<(P&65535))P=S;else break}S=(N&65535)>(P&65535)?P:N;R=T;do{_=o+((R&65535)<<1)|0;O=R;R=d[_>>1]|0;d[_>>1]=S}while((R&65535)<(O&65535));fa=S}S=M;do{R=o+((S&65535)<<1)|0;T=S;S=d[R>>1]|0;d[R>>1]=fa}while((S&65535)<(T&65535));d[z+(E<<1)>>1]=fa;K=F;break a}S=E+2|0;do if(!((S|0)>=(i|0)|C)){if(!(b[x+S>>0]|0))break;do if(D){if(!(b[y+G>>0]|0))break;M=E+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[x+I>>0]|0){T=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}R=d[t+(S<<1)>>1]|0;N=R;while(1){P=d[o+((N&65535)<<1)>>1]|0;if((P&65535)<(N&65535))N=P;else break}if(R<<16>>16==T<<16>>16)ga=N;else{P=T;while(1){O=d[o+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}O=(N&65535)>(P&65535)?P:N;_=T;do{L=o+((_&65535)<<1)|0;U=_;_=d[L>>1]|0;d[L>>1]=O}while((_&65535)<(U&65535));ga=O}O=R;do{_=o+((O&65535)<<1)|0;T=O;O=d[_>>1]|0;d[_>>1]=ga}while((O&65535)<(T&65535));d[z+(E<<1)>>1]=ga;K=F;break a}if(!(b[x+M>>0]|0)){O=d[t+(S<<1)>>1]|0;R=d[z+(M<<1)>>1]|0;T=O;while(1){_=d[o+((T&65535)<<1)>>1]|0;if((_&65535)<(T&65535))T=_;else break}if(O<<16>>16==R<<16>>16)ha=T;else{_=R;while(1){N=d[o+((_&65535)<<1)>>1]|0;if((N&65535)<(_&65535))_=N;else break}N=(T&65535)>(_&65535)?_:T;P=R;do{U=o+((P&65535)<<1)|0;L=P;P=d[U>>1]|0;d[U>>1]=N}while((P&65535)<(L&65535));ha=N}N=O;do{P=o+((N&65535)<<1)|0;R=N;N=d[P>>1]|0;d[P>>1]=ha}while((N&65535)<(R&65535));d[z+(E<<1)>>1]=ha;K=F;break a}if(!(b[y+I>>0]|0)){N=d[t+(S<<1)>>1]|0;O=d[z+(M<<1)>>1]|0;R=N;while(1){P=d[o+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}if(N<<16>>16==O<<16>>16)ia=R;else{P=O;while(1){T=d[o+((P&65535)<<1)>>1]|0;if((T&65535)<(P&65535))P=T;else break}T=(R&65535)>(P&65535)?P:R;_=O;do{L=o+((_&65535)<<1)|0;U=_;_=d[L>>1]|0;d[L>>1]=T}while((_&65535)<(U&65535));ia=T}T=N;do{_=o+((T&65535)<<1)|0;O=T;T=d[_>>1]|0;d[_>>1]=ia}while((T&65535)<(O&65535));d[z+(E<<1)>>1]=ia;K=F;break a}T=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}N=d[t+(S<<1)>>1]|0;O=N;while(1){_=d[o+((O&65535)<<1)>>1]|0;if((_&65535)<(O&65535))O=_;else break}if(N<<16>>16==T<<16>>16)ja=O;else{_=T;while(1){R=d[o+((_&65535)<<1)>>1]|0;if((R&65535)<(_&65535))_=R;else break}R=(O&65535)>(_&65535)?_:O;P=T;do{U=o+((P&65535)<<1)|0;L=P;P=d[U>>1]|0;d[U>>1]=R}while((P&65535)<(L&65535));ja=R}R=N;do{P=o+((R&65535)<<1)|0;T=R;R=d[P>>1]|0;d[P>>1]=ja}while((R&65535)<(T&65535));d[z+(E<<1)>>1]=ja;K=F;break a}while(0);R=d[t+(S<<1)>>1]|0;N=d[z+(M<<1)>>1]|0;T=R;while(1){P=d[o+((T&65535)<<1)>>1]|0;if((P&65535)<(T&65535))T=P;else break}if(R<<16>>16==N<<16>>16)ka=T;else{M=N;while(1){P=d[o+((M&65535)<<1)>>1]|0;if((P&65535)<(M&65535))M=P;else break}P=(T&65535)>(M&65535)?M:T;O=N;do{_=o+((O&65535)<<1)|0;L=O;O=d[_>>1]|0;d[_>>1]=P}while((O&65535)<(L&65535));ka=P}P=R;do{O=o+((P&65535)<<1)|0;N=P;P=d[O>>1]|0;d[O>>1]=ka}while((P&65535)<(N&65535));d[z+(E<<1)>>1]=ka;K=F;break a}while(0);P=E+-2|0;if(!(b[x+E>>0]|0)){R=d[t+(S<<1)>>1]|0;N=d[z+(P<<1)>>1]|0;O=R;while(1){T=d[o+((O&65535)<<1)>>1]|0;if((T&65535)<(O&65535))O=T;else break}if(R<<16>>16==N<<16>>16)la=O;else{T=N;while(1){M=d[o+((T&65535)<<1)>>1]|0;if((M&65535)<(T&65535))T=M;else break}M=(O&65535)>(T&65535)?T:O;L=N;do{_=o+((L&65535)<<1)|0;U=L;L=d[_>>1]|0;d[_>>1]=M}while((L&65535)<(U&65535));la=M}M=R;do{L=o+((M&65535)<<1)|0;N=M;M=d[L>>1]|0;d[L>>1]=la}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=la;K=F;break a}do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[x+I>>0]|0){M=d[t+(S<<1)>>1]|0;R=d[z+(P<<1)>>1]|0;N=M;while(1){L=d[o+((N&65535)<<1)>>1]|0;if((L&65535)<(N&65535))N=L;else break}if(M<<16>>16==R<<16>>16)ma=N;else{L=R;while(1){O=d[o+((L&65535)<<1)>>1]|0;if((O&65535)<(L&65535))L=O;else break}O=(N&65535)>(L&65535)?L:N;T=R;do{U=o+((T&65535)<<1)|0;_=T;T=d[U>>1]|0;d[U>>1]=O}while((T&65535)<(_&65535));ma=O}O=M;do{T=o+((O&65535)<<1)|0;R=O;O=d[T>>1]|0;d[T>>1]=ma}while((O&65535)<(R&65535));d[z+(E<<1)>>1]=ma;K=F;break a}if(!(b[x+P>>0]|0)){O=d[t+(E<<1)>>1]|0;M=d[t+(S<<1)>>1]|0;R=O;while(1){T=d[o+((R&65535)<<1)>>1]|0;if((T&65535)<(R&65535))R=T;else break}if(O<<16>>16==M<<16>>16)na=R;else{T=M;while(1){N=d[o+((T&65535)<<1)>>1]|0;if((N&65535)<(T&65535))T=N;else break}N=(R&65535)>(T&65535)?T:R;L=M;do{_=o+((L&65535)<<1)|0;U=L;L=d[_>>1]|0;d[_>>1]=N}while((L&65535)<(U&65535));na=N}N=O;do{L=o+((N&65535)<<1)|0;M=N;N=d[L>>1]|0;d[L>>1]=na}while((N&65535)<(M&65535));N=d[z+(P<<1)>>1]|0;O=na;while(1){M=d[o+((O&65535)<<1)>>1]|0;if((M&65535)<(O&65535))O=M;else break}if(na<<16>>16==N<<16>>16)oa=O;else{M=N;while(1){L=d[o+((M&65535)<<1)>>1]|0;if((L&65535)<(M&65535))M=L;else break}L=(O&65535)>(M&65535)?M:O;R=N;do{T=o+((R&65535)<<1)|0;U=R;R=d[T>>1]|0;d[T>>1]=L}while((R&65535)<(U&65535));oa=L}L=na;do{R=o+((L&65535)<<1)|0;N=L;L=d[R>>1]|0;d[R>>1]=oa}while((L&65535)<(N&65535));d[z+(E<<1)>>1]=oa;K=F;break a}do if(D){if(!(b[y+I>>0]|0))break;L=d[t+(S<<1)>>1]|0;N=d[z+(P<<1)>>1]|0;R=L;while(1){O=d[o+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(L<<16>>16==N<<16>>16)pa=R;else{O=N;while(1){M=d[o+((O&65535)<<1)>>1]|0;if((M&65535)<(O&65535))O=M;else break}M=(R&65535)>(O&65535)?O:R;U=N;do{T=o+((U&65535)<<1)|0;_=U;U=d[T>>1]|0;d[T>>1]=M}while((U&65535)<(_&65535));pa=M}M=L;do{U=o+((M&65535)<<1)|0;N=M;M=d[U>>1]|0;d[U>>1]=pa}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=pa;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;L=d[t+(S<<1)>>1]|0;N=M;while(1){U=d[o+((N&65535)<<1)>>1]|0;if((U&65535)<(N&65535))N=U;else break}if(M<<16>>16==L<<16>>16)qa=N;else{U=L;while(1){R=d[o+((U&65535)<<1)>>1]|0;if((R&65535)<(U&65535))U=R;else break}R=(N&65535)>(U&65535)?U:N;O=L;do{_=o+((O&65535)<<1)|0;T=O;O=d[_>>1]|0;d[_>>1]=R}while((O&65535)<(T&65535));qa=R}R=M;do{O=o+((R&65535)<<1)|0;L=R;R=d[O>>1]|0;d[O>>1]=qa}while((R&65535)<(L&65535));R=d[z+(P<<1)>>1]|0;M=qa;while(1){L=d[o+((M&65535)<<1)>>1]|0;if((L&65535)<(M&65535))M=L;else break}if(qa<<16>>16==R<<16>>16)ra=M;else{L=R;while(1){O=d[o+((L&65535)<<1)>>1]|0;if((O&65535)<(L&65535))L=O;else break}O=(M&65535)>(L&65535)?L:M;N=R;do{U=o+((N&65535)<<1)|0;T=N;N=d[U>>1]|0;d[U>>1]=O}while((N&65535)<(T&65535));ra=O}O=qa;do{N=o+((O&65535)<<1)|0;R=O;O=d[N>>1]|0;d[N>>1]=ra}while((O&65535)<(R&65535));d[z+(E<<1)>>1]=ra;K=F;break a}while(0);O=d[t+(E<<1)>>1]|0;R=d[t+(S<<1)>>1]|0;N=O;while(1){M=d[o+((N&65535)<<1)>>1]|0;if((M&65535)<(N&65535))N=M;else break}if(O<<16>>16==R<<16>>16)sa=N;else{M=R;while(1){L=d[o+((M&65535)<<1)>>1]|0;if((L&65535)<(M&65535))M=L;else break}L=(N&65535)>(M&65535)?M:N;T=R;do{U=o+((T&65535)<<1)|0;_=T;T=d[U>>1]|0;d[U>>1]=L}while((T&65535)<(_&65535));sa=L}L=O;do{T=o+((L&65535)<<1)|0;R=L;L=d[T>>1]|0;d[T>>1]=sa}while((L&65535)<(R&65535));L=d[z+(P<<1)>>1]|0;O=sa;while(1){R=d[o+((O&65535)<<1)>>1]|0;if((R&65535)<(O&65535))O=R;else break}if(sa<<16>>16==L<<16>>16)ta=O;else{P=L;while(1){R=d[o+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}R=(O&65535)>(P&65535)?P:O;T=L;do{N=o+((T&65535)<<1)|0;M=T;T=d[N>>1]|0;d[N>>1]=R}while((T&65535)<(M&65535));ta=R}R=sa;do{T=o+((R&65535)<<1)|0;L=R;R=d[T>>1]|0;d[T>>1]=ta}while((R&65535)<(L&65535));d[z+(E<<1)>>1]=ta;K=F;break a}while(0);S=E+-2|0;if(!(b[x+E>>0]|0)){ua=S;break}do if((S|0)>-1){if(!(b[v+S>>0]|0))break;if(b[x+I>>0]|0){d[z+(E<<1)>>1]=d[z+(S<<1)>>1]|0;K=F;break a}if(!(b[x+S>>0]|0)){R=d[t+(E<<1)>>1]|0;L=d[z+(S<<1)>>1]|0;T=R;while(1){O=d[o+((T&65535)<<1)>>1]|0;if((O&65535)<(T&65535))T=O;else break}if(R<<16>>16==L<<16>>16)va=T;else{O=L;while(1){P=d[o+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(T&65535)>(O&65535)?O:T;M=L;do{N=o+((M&65535)<<1)|0;_=M;M=d[N>>1]|0;d[N>>1]=P}while((M&65535)<(_&65535));va=P}P=R;do{M=o+((P&65535)<<1)|0;L=P;P=d[M>>1]|0;d[M>>1]=va}while((P&65535)<(L&65535));d[z+(E<<1)>>1]=va;K=F;break a}do if(D){if(!(b[y+I>>0]|0))break;d[z+(E<<1)>>1]=d[z+(S<<1)>>1]|0;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;R=d[z+(S<<1)>>1]|0;L=P;while(1){M=d[o+((L&65535)<<1)>>1]|0;if((M&65535)<(L&65535))L=M;else break}if(P<<16>>16==R<<16>>16)wa=L;else{M=R;while(1){T=d[o+((M&65535)<<1)>>1]|0;if((T&65535)<(M&65535))M=T;else break}T=(L&65535)>(M&65535)?M:L;O=R;do{_=o+((O&65535)<<1)|0;N=O;O=d[_>>1]|0;d[_>>1]=T}while((O&65535)<(N&65535));wa=T}T=P;do{O=o+((T&65535)<<1)|0;R=T;T=d[O>>1]|0;d[O>>1]=wa}while((T&65535)<(R&65535));d[z+(E<<1)>>1]=wa;K=F;break a}while(0);T=d[t+(E<<1)>>1]|0;P=d[z+(S<<1)>>1]|0;R=T;while(1){O=d[o+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(T<<16>>16==P<<16>>16)xa=R;else{S=P;while(1){O=d[o+((S&65535)<<1)>>1]|0;if((O&65535)<(S&65535))S=O;else break}O=(R&65535)>(S&65535)?S:R;L=P;do{M=o+((L&65535)<<1)|0;N=L;L=d[M>>1]|0;d[M>>1]=O}while((L&65535)<(N&65535));xa=O}O=T;do{L=o+((O&65535)<<1)|0;P=O;O=d[L>>1]|0;d[L>>1]=xa}while((O&65535)<(P&65535));d[z+(E<<1)>>1]=xa;K=F;break a}else ua=E+-2|0;while(0);d[z+(E<<1)>>1]=d[z+(ua<<1)>>1]|0;K=F;break a}while(0);do if(B){if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}O=E+2|0;do if(!((O|0)>=(i|0)|C)){if(!(b[x+O>>0]|0))break;if(!(b[x+E>>0]|0)){d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}while(0);T=d[t+(E<<1)>>1]|0;P=d[t+(O<<1)>>1]|0;L=T;while(1){R=d[o+((L&65535)<<1)>>1]|0;if((R&65535)<(L&65535))L=R;else break}if(T<<16>>16==P<<16>>16)ya=L;else{R=P;while(1){S=d[o+((R&65535)<<1)>>1]|0;if((S&65535)<(R&65535))R=S;else break}S=(L&65535)>(R&65535)?R:L;N=P;do{M=o+((N&65535)<<1)|0;_=N;N=d[M>>1]|0;d[M>>1]=S}while((N&65535)<(_&65535));ya=S}S=T;do{N=o+((S&65535)<<1)|0;P=S;S=d[N>>1]|0;d[N>>1]=ya}while((S&65535)<(P&65535));d[z+(E<<1)>>1]=ya;K=F;break a}while(0);if(!(b[x+E>>0]|0))break;d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}while(0);d[z+(E<<1)>>1]=F;O=F&65535;d[o+(O<<1)>>1]=F;K=O+1&65535;break}if(J){if(b[w+I>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}if(b[v+I>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}}d[z+(E<<1)>>1]=F;O=F&65535;d[o+(O<<1)>>1]=F;K=O+1&65535;break}do if(H){if(!(b[v+G>>0]|0)){if(!A)break;if(!(b[w+G>>0]|0))break;d[z+(E<<1)>>1]=F;O=F&65535;d[o+(O<<1)>>1]=F;K=O+1&65535;break a}if(B){if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}O=E+2|0;do if(!((O|0)>=(i|0)|C)){if(!(b[x+O>>0]|0))break;if(!(b[x+E>>0]|0)){d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[t+(O<<1)>>1]|0;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;T=d[t+(O<<1)>>1]|0;P=S;while(1){N=d[o+((P&65535)<<1)>>1]|0;if((N&65535)<(P&65535))P=N;else break}if(S<<16>>16==T<<16>>16)za=P;else{N=T;while(1){L=d[o+((N&65535)<<1)>>1]|0;if((L&65535)<(N&65535))N=L;else break}L=(P&65535)>(N&65535)?N:P;R=T;do{_=o+((R&65535)<<1)|0;M=R;R=d[_>>1]|0;d[_>>1]=L}while((R&65535)<(M&65535));za=L}L=S;do{R=o+((L&65535)<<1)|0;T=L;L=d[R>>1]|0;d[R>>1]=za}while((L&65535)<(T&65535));d[z+(E<<1)>>1]=za;K=F;break a}while(0);if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break a}}d[z+(E<<1)>>1]=F;O=F&65535;d[o+(O<<1)>>1]=F;K=O+1&65535;break a}while(0);d[z+(E<<1)>>1]=0;K=F}else{G=E+-1|0;H=(E|0)>0;if(H){if(b[v+G>>0]|0){I=E|1;J=(I|0)<(i|0);if(B&J?b[x+I>>0]|0:0){if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}do if(D){if(!(b[y+E>>0]|0))break;O=E+-2|0;if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}do if((O|0)>-1){if(!(b[x+O>>0]|0))break;if(b[y+G>>0]|0){d[z+(E<<1)>>1]=d[z+(O<<1)>>1]|0;K=F;break a}L=d[t+(E<<1)>>1]|0;S=d[z+(O<<1)>>1]|0;T=L;while(1){R=d[o+((T&65535)<<1)>>1]|0;if((R&65535)<(T&65535))T=R;else break}if(L<<16>>16==S<<16>>16)Aa=T;else{R=S;while(1){P=d[o+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(T&65535)>(R&65535)?R:T;N=S;do{M=o+((N&65535)<<1)|0;_=N;N=d[M>>1]|0;d[M>>1]=P}while((N&65535)<(_&65535));Aa=P}P=L;do{N=o+((P&65535)<<1)|0;S=P;P=d[N>>1]|0;d[N>>1]=Aa}while((P&65535)<(S&65535));d[z+(E<<1)>>1]=Aa;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;L=d[z+(O<<1)>>1]|0;S=P;while(1){N=d[o+((S&65535)<<1)>>1]|0;if((N&65535)<(S&65535))S=N;else break}if(P<<16>>16==L<<16>>16)Ba=S;else{O=L;while(1){N=d[o+((O&65535)<<1)>>1]|0;if((N&65535)<(O&65535))O=N;else break}N=(S&65535)>(O&65535)?O:S;T=L;do{R=o+((T&65535)<<1)|0;_=T;T=d[R>>1]|0;d[R>>1]=N}while((T&65535)<(_&65535));Ba=N}N=P;do{T=o+((N&65535)<<1)|0;L=N;N=d[T>>1]|0;d[T>>1]=Ba}while((N&65535)<(L&65535));d[z+(E<<1)>>1]=Ba;K=F;break a}while(0);N=d[t+(E<<1)>>1]|0;P=d[z+(E+-2<<1)>>1]|0;L=N;while(1){T=d[o+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}if(N<<16>>16==P<<16>>16)Ca=L;else{T=P;while(1){S=d[o+((T&65535)<<1)>>1]|0;if((S&65535)<(T&65535))T=S;else break}S=(L&65535)>(T&65535)?T:L;O=P;do{_=o+((O&65535)<<1)|0;R=O;O=d[_>>1]|0;d[_>>1]=S}while((O&65535)<(R&65535));Ca=S}S=N;do{O=o+((S&65535)<<1)|0;P=S;S=d[O>>1]|0;d[O>>1]=Ca}while((S&65535)<(P&65535));d[z+(E<<1)>>1]=Ca;K=F;break}if(J?b[v+I>>0]|0:0){S=E+2|0;do if(B&(S|0)<(i|0)){if(!(b[x+S>>0]|0))break;do if(D){if(!(b[y+I>>0]|0))break;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break a}if(!(b[y+E>>0]|0)){N=d[t+(S<<1)>>1]|0;P=d[z+(E+-2<<1)>>1]|0;O=N;while(1){L=d[o+((O&65535)<<1)>>1]|0;if((L&65535)<(O&65535))O=L;else break}if(N<<16>>16==P<<16>>16)Da=O;else{L=P;while(1){T=d[o+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}T=(O&65535)>(L&65535)?L:O;R=P;do{_=o+((R&65535)<<1)|0;M=R;R=d[_>>1]|0;d[_>>1]=T}while((R&65535)<(M&65535));Da=T}T=N;do{R=o+((T&65535)<<1)|0;P=T;T=d[R>>1]|0;d[R>>1]=Da}while((T&65535)<(P&65535));d[z+(E<<1)>>1]=Da;K=F;break a}T=E+-2|0;if(b[x+G>>0]|0){d[z+(E<<1)>>1]=d[z+(T<<1)>>1]|0;K=F;break a}do if((T|0)>-1){if(!(b[x+T>>0]|0))break;if(b[y+G>>0]|0){d[z+(E<<1)>>1]=d[z+(T<<1)>>1]|0;K=F;break a}N=d[t+(S<<1)>>1]|0;P=d[z+(T<<1)>>1]|0;R=N;while(1){O=d[o+((R&65535)<<1)>>1]|0;if((O&65535)<(R&65535))R=O;else break}if(N<<16>>16==P<<16>>16)Ea=R;else{O=P;while(1){L=d[o+((O&65535)<<1)>>1]|0;if((L&65535)<(O&65535))O=L;else break}L=(R&65535)>(O&65535)?O:R;M=P;do{_=o+((M&65535)<<1)|0;U=M;M=d[_>>1]|0;d[_>>1]=L}while((M&65535)<(U&65535));Ea=L}L=N;do{M=o+((L&65535)<<1)|0;P=L;L=d[M>>1]|0;d[M>>1]=Ea}while((L&65535)<(P&65535));d[z+(E<<1)>>1]=Ea;K=F;break a}while(0);L=d[t+(S<<1)>>1]|0;N=d[z+(T<<1)>>1]|0;P=L;while(1){M=d[o+((P&65535)<<1)>>1]|0;if((M&65535)<(P&65535))P=M;else break}if(L<<16>>16==N<<16>>16)Fa=P;else{T=N;while(1){M=d[o+((T&65535)<<1)>>1]|0;if((M&65535)<(T&65535))T=M;else break}M=(P&65535)>(T&65535)?T:P;R=N;do{O=o+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=M}while((R&65535)<(U&65535));Fa=M}M=L;do{R=o+((M&65535)<<1)|0;N=M;M=d[R>>1]|0;d[R>>1]=Fa}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=Fa;K=F;break a}while(0);M=d[t+(S<<1)>>1]|0;L=d[z+(E+-2<<1)>>1]|0;N=M;while(1){R=d[o+((N&65535)<<1)>>1]|0;if((R&65535)<(N&65535))N=R;else break}if(M<<16>>16==L<<16>>16)Ga=N;else{R=L;while(1){P=d[o+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(N&65535)>(R&65535)?R:N;T=L;do{U=o+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=P}while((T&65535)<(O&65535));Ga=P}P=M;do{T=o+((P&65535)<<1)|0;L=P;P=d[T>>1]|0;d[T>>1]=Ga}while((P&65535)<(L&65535));d[z+(E<<1)>>1]=Ga;K=F;break a}while(0);d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}d[z+(E<<1)>>1]=d[z+(E+-2<<1)>>1]|0;K=F;break}if(A?b[w+G>>0]|0:0){S=E|1;I=(S|0)<(i|0);if(!(C|I^1)?b[x+S>>0]|0:0){J=E+-2|0;do if((J|0)>-1){if(!(b[v+J>>0]|0))break;if(b[x+G>>0]|0){P=d[z+(J<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=P;K=F;break a}do if(D){if(!(b[y+E>>0]|0))break;d[z+(E<<1)>>1]=P;K=F;break a}while(0);M=d[t+(E<<1)>>1]|0;L=M;while(1){T=d[o+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}if(M<<16>>16==P<<16>>16)Ha=L;else{T=P;while(1){N=d[o+((T&65535)<<1)>>1]|0;if((N&65535)<(T&65535))T=N;else break}N=(L&65535)>(T&65535)?T:L;R=P;do{O=o+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=N}while((R&65535)<(U&65535));Ha=N}N=M;do{R=o+((N&65535)<<1)|0;P=N;N=d[R>>1]|0;d[R>>1]=Ha}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=Ha;K=F;break a}if(!(b[x+J>>0]|0)){N=d[t+(E<<1)>>1]|0;M=d[z+(J<<1)>>1]|0;P=N;while(1){R=d[o+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(N<<16>>16==M<<16>>16)Ia=P;else{R=M;while(1){L=d[o+((R&65535)<<1)>>1]|0;if((L&65535)<(R&65535))R=L;else break}L=(P&65535)>(R&65535)?R:P;T=M;do{U=o+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=L}while((T&65535)<(O&65535));Ia=L}L=N;do{T=o+((L&65535)<<1)|0;M=L;L=d[T>>1]|0;d[T>>1]=Ia}while((L&65535)<(M&65535));d[z+(E<<1)>>1]=Ia;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;L=d[z+(J<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=L;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=L;K=F;break a}N=d[t+(E<<1)>>1]|0;M=N;while(1){T=d[o+((M&65535)<<1)>>1]|0;if((T&65535)<(M&65535))M=T;else break}if(N<<16>>16==L<<16>>16)Ja=M;else{T=L;while(1){P=d[o+((T&65535)<<1)>>1]|0;if((P&65535)<(T&65535))T=P;else break}P=(M&65535)>(T&65535)?T:M;R=L;do{O=o+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=P}while((R&65535)<(U&65535));Ja=P}P=N;do{R=o+((P&65535)<<1)|0;L=P;P=d[R>>1]|0;d[R>>1]=Ja}while((P&65535)<(L&65535));d[z+(E<<1)>>1]=Ja;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;N=d[z+(J<<1)>>1]|0;L=P;while(1){R=d[o+((L&65535)<<1)>>1]|0;if((R&65535)<(L&65535))L=R;else break}if(P<<16>>16==N<<16>>16)Ka=L;else{R=N;while(1){M=d[o+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(L&65535)>(R&65535)?R:L;T=N;do{U=o+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=M}while((T&65535)<(O&65535));Ka=M}M=P;do{T=o+((M&65535)<<1)|0;N=M;M=d[T>>1]|0;d[T>>1]=Ka}while((M&65535)<(N&65535));d[z+(E<<1)>>1]=Ka;K=F;break a}while(0);if(b[x+E>>0]|0){M=d[t+(E<<1)>>1]|0;P=d[z+(J<<1)>>1]|0;N=M;while(1){T=d[o+((N&65535)<<1)>>1]|0;if((T&65535)<(N&65535))N=T;else break}if(M<<16>>16==P<<16>>16)La=N;else{T=P;while(1){L=d[o+((T&65535)<<1)>>1]|0;if((L&65535)<(T&65535))T=L;else break}L=(N&65535)>(T&65535)?T:N;R=P;do{O=o+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=L}while((R&65535)<(U&65535));La=L}L=M;do{R=o+((L&65535)<<1)|0;P=L;L=d[R>>1]|0;d[R>>1]=La}while((L&65535)<(P&65535));d[z+(E<<1)>>1]=La;K=F;break}L=d[t+(E<<1)>>1]|0;if(!(b[x+G>>0]|0)){M=d[z+(J<<1)>>1]|0;P=L;while(1){R=d[o+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(L<<16>>16==M<<16>>16)Ma=P;else{R=M;while(1){N=d[o+((R&65535)<<1)>>1]|0;if((N&65535)<(R&65535))R=N;else break}N=(P&65535)>(R&65535)?R:P;T=M;do{U=o+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=N}while((T&65535)<(O&65535));Ma=N}N=L;do{T=o+((N&65535)<<1)|0;M=N;N=d[T>>1]|0;d[T>>1]=Ma}while((N&65535)<(M&65535));d[z+(E<<1)>>1]=Ma;K=F;break}do if(D){if(!(b[y+E>>0]|0))break;N=d[z+(J<<1)>>1]|0;M=L;while(1){T=d[o+((M&65535)<<1)>>1]|0;if((T&65535)<(M&65535))M=T;else break}if(L<<16>>16==N<<16>>16)Na=M;else{T=N;while(1){P=d[o+((T&65535)<<1)>>1]|0;if((P&65535)<(T&65535))T=P;else break}P=(M&65535)>(T&65535)?T:M;R=N;do{O=o+((R&65535)<<1)|0;U=R;R=d[O>>1]|0;d[O>>1]=P}while((R&65535)<(U&65535));Na=P}P=L;do{R=o+((P&65535)<<1)|0;N=P;P=d[R>>1]|0;d[R>>1]=Na}while((P&65535)<(N&65535));d[z+(E<<1)>>1]=Na;K=F;break a}while(0);P=d[t+(J<<1)>>1]|0;N=P;while(1){R=d[o+((N&65535)<<1)>>1]|0;if((R&65535)<(N&65535))N=R;else break}if(P<<16>>16==L<<16>>16)Oa=N;else{R=L;while(1){M=d[o+((R&65535)<<1)>>1]|0;if((M&65535)<(R&65535))R=M;else break}M=(N&65535)>(R&65535)?R:N;T=L;do{U=o+((T&65535)<<1)|0;O=T;T=d[U>>1]|0;d[U>>1]=M}while((T&65535)<(O&65535));Oa=M}M=P;do{T=o+((M&65535)<<1)|0;L=M;M=d[T>>1]|0;d[T>>1]=Oa}while((M&65535)<(L&65535));M=d[z+(J<<1)>>1]|0;P=Oa;while(1){L=d[o+((P&65535)<<1)>>1]|0;if((L&65535)<(P&65535))P=L;else break}if(Oa<<16>>16==M<<16>>16)Pa=P;else{J=M;while(1){L=d[o+((J&65535)<<1)>>1]|0;if((L&65535)<(J&65535))J=L;else break}L=(P&65535)>(J&65535)?J:P;T=M;do{N=o+((T&65535)<<1)|0;R=T;T=d[N>>1]|0;d[N>>1]=L}while((T&65535)<(R&65535));Pa=L}L=Oa;do{T=o+((L&65535)<<1)|0;M=L;L=d[T>>1]|0;d[T>>1]=Pa}while((L&65535)<(M&65535));d[z+(E<<1)>>1]=Pa;K=F;break}if(I?b[v+S>>0]|0:0){L=E+2|0;do if(!((L|0)>=(i|0)|C)){if(!(b[x+L>>0]|0))break;M=E+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[x+G>>0]|0){do if(D){if(!(b[y+S>>0]|0))break;T=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=T;K=F;break a}P=d[t+(L<<1)>>1]|0;J=P;while(1){R=d[o+((J&65535)<<1)>>1]|0;if((R&65535)<(J&65535))J=R;else break}if(P<<16>>16==T<<16>>16)Qa=J;else{R=T;while(1){N=d[o+((R&65535)<<1)>>1]|0;if((N&65535)<(R&65535))R=N;else break}N=(J&65535)>(R&65535)?R:J;O=T;do{U=o+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=N}while((O&65535)<(_&65535));Qa=N}N=P;do{O=o+((N&65535)<<1)|0;T=N;N=d[O>>1]|0;d[O>>1]=Qa}while((N&65535)<(T&65535));d[z+(E<<1)>>1]=Qa;K=F;break a}while(0);N=d[t+(L<<1)>>1]|0;P=d[z+(M<<1)>>1]|0;T=N;while(1){O=d[o+((T&65535)<<1)>>1]|0;if((O&65535)<(T&65535))T=O;else break}if(N<<16>>16==P<<16>>16)Ra=T;else{O=P;while(1){J=d[o+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(T&65535)>(O&65535)?O:T;R=P;do{_=o+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=J}while((R&65535)<(U&65535));Ra=J}J=N;do{R=o+((J&65535)<<1)|0;P=J;J=d[R>>1]|0;d[R>>1]=Ra}while((J&65535)<(P&65535));d[z+(E<<1)>>1]=Ra;K=F;break a}do if(D){if(!(b[y+S>>0]|0))break;if(!(b[x+M>>0]|0)){J=d[t+(L<<1)>>1]|0;N=d[z+(M<<1)>>1]|0;P=J;while(1){R=d[o+((P&65535)<<1)>>1]|0;if((R&65535)<(P&65535))P=R;else break}if(J<<16>>16==N<<16>>16)Sa=P;else{R=N;while(1){T=d[o+((R&65535)<<1)>>1]|0;if((T&65535)<(R&65535))R=T;else break}T=(P&65535)>(R&65535)?R:P;O=N;do{U=o+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=T}while((O&65535)<(_&65535));Sa=T}T=J;do{O=o+((T&65535)<<1)|0;N=T;T=d[O>>1]|0;d[O>>1]=Sa}while((T&65535)<(N&65535));d[z+(E<<1)>>1]=Sa;K=F;break a}if(!(b[y+G>>0]|0)){T=d[t+(L<<1)>>1]|0;J=d[z+(M<<1)>>1]|0;N=T;while(1){O=d[o+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}if(T<<16>>16==J<<16>>16)Ta=N;else{O=J;while(1){P=d[o+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(N&65535)>(O&65535)?O:N;R=J;do{_=o+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=P}while((R&65535)<(U&65535));Ta=P}P=T;do{R=o+((P&65535)<<1)|0;J=P;P=d[R>>1]|0;d[R>>1]=Ta}while((P&65535)<(J&65535));d[z+(E<<1)>>1]=Ta;K=F;break a}P=d[z+(M<<1)>>1]|0;if(b[x+E>>0]|0){d[z+(E<<1)>>1]=P;K=F;break a}if(b[y+E>>0]|0){d[z+(E<<1)>>1]=P;K=F;break a}T=d[t+(L<<1)>>1]|0;J=T;while(1){R=d[o+((J&65535)<<1)>>1]|0;if((R&65535)<(J&65535))J=R;else break}if(T<<16>>16==P<<16>>16)Ua=J;else{R=P;while(1){N=d[o+((R&65535)<<1)>>1]|0;if((N&65535)<(R&65535))R=N;else break}N=(J&65535)>(R&65535)?R:J;O=P;do{U=o+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=N}while((O&65535)<(_&65535));Ua=N}N=T;do{O=o+((N&65535)<<1)|0;P=N;N=d[O>>1]|0;d[O>>1]=Ua}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=Ua;K=F;break a}while(0);if(!(b[x+E>>0]|0)){N=d[t+(L<<1)>>1]|0;T=d[z+(M<<1)>>1]|0;P=N;while(1){O=d[o+((P&65535)<<1)>>1]|0;if((O&65535)<(P&65535))P=O;else break}if(N<<16>>16==T<<16>>16)Va=P;else{O=T;while(1){J=d[o+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(P&65535)>(O&65535)?O:P;R=T;do{_=o+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=J}while((R&65535)<(U&65535));Va=J}J=N;do{R=o+((J&65535)<<1)|0;T=J;J=d[R>>1]|0;d[R>>1]=Va}while((J&65535)<(T&65535));d[z+(E<<1)>>1]=Va;K=F;break a}if(!(b[x+M>>0]|0)){J=d[t+(E<<1)>>1]|0;N=d[t+(L<<1)>>1]|0;T=J;while(1){R=d[o+((T&65535)<<1)>>1]|0;if((R&65535)<(T&65535))T=R;else break}if(J<<16>>16==N<<16>>16)Wa=T;else{R=N;while(1){P=d[o+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(T&65535)>(R&65535)?R:T;O=N;do{U=o+((O&65535)<<1)|0;_=O;O=d[U>>1]|0;d[U>>1]=P}while((O&65535)<(_&65535));Wa=P}P=J;do{O=o+((P&65535)<<1)|0;N=P;P=d[O>>1]|0;d[O>>1]=Wa}while((P&65535)<(N&65535));P=d[z+(M<<1)>>1]|0;J=Wa;while(1){N=d[o+((J&65535)<<1)>>1]|0;if((N&65535)<(J&65535))J=N;else break}if(Wa<<16>>16==P<<16>>16)Xa=J;else{N=P;while(1){O=d[o+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}O=(J&65535)>(N&65535)?N:J;T=P;do{R=o+((T&65535)<<1)|0;_=T;T=d[R>>1]|0;d[R>>1]=O}while((T&65535)<(_&65535));Xa=O}O=Wa;do{T=o+((O&65535)<<1)|0;P=O;O=d[T>>1]|0;d[T>>1]=Xa}while((O&65535)<(P&65535));d[z+(E<<1)>>1]=Xa;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;O=d[t+(L<<1)>>1]|0;P=d[z+(M<<1)>>1]|0;T=O;while(1){J=d[o+((T&65535)<<1)>>1]|0;if((J&65535)<(T&65535))T=J;else break}if(O<<16>>16==P<<16>>16)Ya=T;else{J=P;while(1){N=d[o+((J&65535)<<1)>>1]|0;if((N&65535)<(J&65535))J=N;else break}N=(T&65535)>(J&65535)?J:T;_=P;do{R=o+((_&65535)<<1)|0;U=_;_=d[R>>1]|0;d[R>>1]=N}while((_&65535)<(U&65535));Ya=N}N=O;do{_=o+((N&65535)<<1)|0;P=N;N=d[_>>1]|0;d[_>>1]=Ya}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=Ya;K=F;break a}while(0);N=d[t+(E<<1)>>1]|0;O=d[t+(L<<1)>>1]|0;P=N;while(1){_=d[o+((P&65535)<<1)>>1]|0;if((_&65535)<(P&65535))P=_;else break}if(N<<16>>16==O<<16>>16)Za=P;else{_=O;while(1){T=d[o+((_&65535)<<1)>>1]|0;if((T&65535)<(_&65535))_=T;else break}T=(P&65535)>(_&65535)?_:P;J=O;do{U=o+((J&65535)<<1)|0;R=J;J=d[U>>1]|0;d[U>>1]=T}while((J&65535)<(R&65535));Za=T}T=N;do{J=o+((T&65535)<<1)|0;O=T;T=d[J>>1]|0;d[J>>1]=Za}while((T&65535)<(O&65535));T=d[z+(M<<1)>>1]|0;N=Za;while(1){O=d[o+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}if(Za<<16>>16==T<<16>>16)_a=N;else{O=T;while(1){J=d[o+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(N&65535)>(O&65535)?O:N;P=T;do{_=o+((P&65535)<<1)|0;R=P;P=d[_>>1]|0;d[_>>1]=J}while((P&65535)<(R&65535));_a=J}J=Za;do{P=o+((J&65535)<<1)|0;T=J;J=d[P>>1]|0;d[P>>1]=_a}while((J&65535)<(T&65535));d[z+(E<<1)>>1]=_a;K=F;break a}while(0);if(b[x+E>>0]|0){do if(D){if(!(b[y+S>>0]|0))break;J=d[t+(L<<1)>>1]|0;T=d[z+(M<<1)>>1]|0;P=J;while(1){N=d[o+((P&65535)<<1)>>1]|0;if((N&65535)<(P&65535))P=N;else break}if(J<<16>>16==T<<16>>16)$a=P;else{N=T;while(1){O=d[o+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}O=(P&65535)>(N&65535)?N:P;R=T;do{_=o+((R&65535)<<1)|0;U=R;R=d[_>>1]|0;d[_>>1]=O}while((R&65535)<(U&65535));$a=O}O=J;do{R=o+((O&65535)<<1)|0;T=O;O=d[R>>1]|0;d[R>>1]=$a}while((O&65535)<(T&65535));d[z+(E<<1)>>1]=$a;K=F;break a}while(0);O=d[t+(E<<1)>>1]|0;J=d[t+(L<<1)>>1]|0;T=O;while(1){R=d[o+((T&65535)<<1)>>1]|0;if((R&65535)<(T&65535))T=R;else break}if(O<<16>>16==J<<16>>16)ab=T;else{R=J;while(1){P=d[o+((R&65535)<<1)>>1]|0;if((P&65535)<(R&65535))R=P;else break}P=(T&65535)>(R&65535)?R:T;N=J;do{U=o+((N&65535)<<1)|0;_=N;N=d[U>>1]|0;d[U>>1]=P}while((N&65535)<(_&65535));ab=P}P=O;do{N=o+((P&65535)<<1)|0;J=P;P=d[N>>1]|0;d[N>>1]=ab}while((P&65535)<(J&65535));P=d[z+(M<<1)>>1]|0;O=ab;while(1){J=d[o+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}if(ab<<16>>16==P<<16>>16)bb=O;else{J=P;while(1){N=d[o+((J&65535)<<1)>>1]|0;if((N&65535)<(J&65535))J=N;else break}N=(O&65535)>(J&65535)?J:O;T=P;do{R=o+((T&65535)<<1)|0;_=T;T=d[R>>1]|0;d[R>>1]=N}while((T&65535)<(_&65535));bb=N}N=ab;do{T=o+((N&65535)<<1)|0;P=N;N=d[T>>1]|0;d[T>>1]=bb}while((N&65535)<(P&65535));d[z+(E<<1)>>1]=bb;K=F;break a}if(!(b[x+G>>0]|0)){N=d[t+(L<<1)>>1]|0;P=d[z+(M<<1)>>1]|0;T=N;while(1){O=d[o+((T&65535)<<1)>>1]|0;if((O&65535)<(T&65535))T=O;else break}if(N<<16>>16==P<<16>>16)cb=T;else{O=P;while(1){J=d[o+((O&65535)<<1)>>1]|0;if((J&65535)<(O&65535))O=J;else break}J=(T&65535)>(O&65535)?O:T;_=P;do{R=o+((_&65535)<<1)|0;U=_;_=d[R>>1]|0;d[R>>1]=J}while((_&65535)<(U&65535));cb=J}J=N;do{_=o+((J&65535)<<1)|0;P=J;J=d[_>>1]|0;d[_>>1]=cb}while((J&65535)<(P&65535));d[z+(E<<1)>>1]=cb;K=F;break a}do if(D){if(!(b[y+S>>0]|0))break;J=d[t+(L<<1)>>1]|0;if(b[y+E>>0]|0){N=d[z+(M<<1)>>1]|0;P=J;while(1){_=d[o+((P&65535)<<1)>>1]|0;if((_&65535)<(P&65535))P=_;else break}if(J<<16>>16==N<<16>>16)db=P;else{_=N;while(1){T=d[o+((_&65535)<<1)>>1]|0;if((T&65535)<(_&65535))_=T;else break}T=(P&65535)>(_&65535)?_:P;O=N;do{U=o+((O&65535)<<1)|0;R=O;O=d[U>>1]|0;d[U>>1]=T}while((O&65535)<(R&65535));db=T}T=J;do{O=o+((T&65535)<<1)|0;N=T;T=d[O>>1]|0;d[O>>1]=db}while((T&65535)<(N&65535));d[z+(E<<1)>>1]=db;K=F;break a}T=d[t+(M<<1)>>1]|0;N=T;while(1){O=d[o+((N&65535)<<1)>>1]|0;if((O&65535)<(N&65535))N=O;else break}if(T<<16>>16==J<<16>>16)eb=N;else{O=J;while(1){P=d[o+((O&65535)<<1)>>1]|0;if((P&65535)<(O&65535))O=P;else break}P=(N&65535)>(O&65535)?O:N;_=J;do{R=o+((_&65535)<<1)|0;U=_;_=d[R>>1]|0;d[R>>1]=P}while((_&65535)<(U&65535));eb=P}P=T;do{_=o+((P&65535)<<1)|0;J=P;P=d[_>>1]|0;d[_>>1]=eb}while((P&65535)<(J&65535));P=d[z+(M<<1)>>1]|0;T=eb;while(1){J=d[o+((T&65535)<<1)>>1]|0;if((J&65535)<(T&65535))T=J;else break}if(eb<<16>>16==P<<16>>16)fb=T;else{J=P;while(1){_=d[o+((J&65535)<<1)>>1]|0;if((_&65535)<(J&65535))J=_;else break}_=(T&65535)>(J&65535)?J:T;N=P;do{O=o+((N&65535)<<1)|0;U=N;N=d[O>>1]|0;d[O>>1]=_}while((N&65535)<(U&65535));fb=_}_=eb;do{N=o+((_&65535)<<1)|0;P=_;_=d[N>>1]|0;d[N>>1]=fb}while((_&65535)<(P&65535));d[z+(E<<1)>>1]=fb;K=F;break a}while(0);_=d[t+(M<<1)>>1]|0;P=d[t+(L<<1)>>1]|0;N=_;while(1){T=d[o+((N&65535)<<1)>>1]|0;if((T&65535)<(N&65535))N=T;else break}if(_<<16>>16==P<<16>>16)gb=N;else{T=P;while(1){J=d[o+((T&65535)<<1)>>1]|0;if((J&65535)<(T&65535))T=J;else break}J=(N&65535)>(T&65535)?T:N;U=P;do{O=o+((U&65535)<<1)|0;R=U;U=d[O>>1]|0;d[O>>1]=J}while((U&65535)<(R&65535));gb=J}J=_;do{U=o+((J&65535)<<1)|0;P=J;J=d[U>>1]|0;d[U>>1]=gb}while((J&65535)<(P&65535));J=d[z+(M<<1)>>1]|0;_=gb;while(1){P=d[o+((_&65535)<<1)>>1]|0;if((P&65535)<(_&65535))_=P;else break}if(gb<<16>>16==J<<16>>16)hb=_;else{M=J;while(1){P=d[o+((M&65535)<<1)>>1]|0;if((P&65535)<(M&65535))M=P;else break}P=(_&65535)>(M&65535)?M:_;U=J;do{N=o+((U&65535)<<1)|0;T=U;U=d[N>>1]|0;d[N>>1]=P}while((U&65535)<(T&65535));hb=P}P=gb;do{U=o+((P&65535)<<1)|0;J=P;P=d[U>>1]|0;d[U>>1]=hb}while((P&65535)<(J&65535));d[z+(E<<1)>>1]=hb;K=F;break a}while(0);do if(B){L=E+-2|0;if(b[x+G>>0]|0){S=d[z+(L<<1)>>1]|0;do if((L|0)>-1){if(!(b[v+L>>0]|0))break;d[z+(E<<1)>>1]=S;K=F;break a}while(0);I=d[t+(L<<1)>>1]|0;P=I;while(1){J=d[o+((P&65535)<<1)>>1]|0;if((J&65535)<(P&65535))P=J;else break}if(I<<16>>16==S<<16>>16)ib=P;else{J=S;while(1){U=d[o+((J&65535)<<1)>>1]|0;if((U&65535)<(J&65535))J=U;else break}U=(P&65535)>(J&65535)?J:P;_=S;do{M=o+((_&65535)<<1)|0;T=_;_=d[M>>1]|0;d[M>>1]=U}while((_&65535)<(T&65535));ib=U}U=I;do{_=o+((U&65535)<<1)|0;S=U;U=d[_>>1]|0;d[_>>1]=ib}while((U&65535)<(S&65535));d[z+(E<<1)>>1]=ib;K=F;break a}if(!(b[x+E>>0]|0)){jb=L;break}do if((L|0)>-1){if(!(b[v+L>>0]|0))break;if(!(b[x+L>>0]|0)){U=d[t+(E<<1)>>1]|0;I=d[z+(L<<1)>>1]|0;S=U;while(1){_=d[o+((S&65535)<<1)>>1]|0;if((_&65535)<(S&65535))S=_;else break}if(U<<16>>16==I<<16>>16)kb=S;else{_=I;while(1){P=d[o+((_&65535)<<1)>>1]|0;if((P&65535)<(_&65535))_=P;else break}P=(S&65535)>(_&65535)?_:S;J=I;do{T=o+((J&65535)<<1)|0;M=J;J=d[T>>1]|0;d[T>>1]=P}while((J&65535)<(M&65535));kb=P}P=U;do{J=o+((P&65535)<<1)|0;I=P;P=d[J>>1]|0;d[J>>1]=kb}while((P&65535)<(I&65535));d[z+(E<<1)>>1]=kb;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[z+(L<<1)>>1]|0;K=F;break a}while(0);P=d[t+(E<<1)>>1]|0;U=d[z+(L<<1)>>1]|0;I=P;while(1){J=d[o+((I&65535)<<1)>>1]|0;if((J&65535)<(I&65535))I=J;else break}if(P<<16>>16==U<<16>>16)lb=I;else{J=U;while(1){S=d[o+((J&65535)<<1)>>1]|0;if((S&65535)<(J&65535))J=S;else break}S=(I&65535)>(J&65535)?J:I;_=U;do{M=o+((_&65535)<<1)|0;T=_;_=d[M>>1]|0;d[M>>1]=S}while((_&65535)<(T&65535));lb=S}S=P;do{_=o+((S&65535)<<1)|0;U=S;S=d[_>>1]|0;d[_>>1]=lb}while((S&65535)<(U&65535));d[z+(E<<1)>>1]=lb;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;P=d[z+(L<<1)>>1]|0;U=S;while(1){_=d[o+((U&65535)<<1)>>1]|0;if((_&65535)<(U&65535))U=_;else break}if(S<<16>>16==P<<16>>16)mb=U;else{L=P;while(1){_=d[o+((L&65535)<<1)>>1]|0;if((_&65535)<(L&65535))L=_;else break}_=(U&65535)>(L&65535)?L:U;I=P;do{J=o+((I&65535)<<1)|0;T=I;I=d[J>>1]|0;d[J>>1]=_}while((I&65535)<(T&65535));mb=_}_=S;do{I=o+((_&65535)<<1)|0;P=_;_=d[I>>1]|0;d[I>>1]=mb}while((_&65535)<(P&65535));d[z+(E<<1)>>1]=mb;K=F;break a}else jb=E+-2|0;while(0);d[z+(E<<1)>>1]=d[z+(jb<<1)>>1]|0;K=F;break}do if(B){_=E+-2|0;if(b[x+G>>0]|0){S=d[z+(_<<1)>>1]|0;do if((_|0)>-1){if(!(b[v+_>>0]|0))break;d[z+(E<<1)>>1]=S;K=F;break a}while(0);P=d[t+(_<<1)>>1]|0;I=P;while(1){U=d[o+((I&65535)<<1)>>1]|0;if((U&65535)<(I&65535))I=U;else break}if(P<<16>>16==S<<16>>16)nb=I;else{U=S;while(1){L=d[o+((U&65535)<<1)>>1]|0;if((L&65535)<(U&65535))U=L;else break}L=(I&65535)>(U&65535)?U:I;T=S;do{J=o+((T&65535)<<1)|0;M=T;T=d[J>>1]|0;d[J>>1]=L}while((T&65535)<(M&65535));nb=L}L=P;do{T=o+((L&65535)<<1)|0;S=L;L=d[T>>1]|0;d[T>>1]=nb}while((L&65535)<(S&65535));d[z+(E<<1)>>1]=nb;K=F;break a}if(!(b[x+E>>0]|0)){ob=_;break}do if((_|0)>-1){if(!(b[v+_>>0]|0))break;if(!(b[x+_>>0]|0)){L=d[t+(E<<1)>>1]|0;P=d[z+(_<<1)>>1]|0;S=L;while(1){T=d[o+((S&65535)<<1)>>1]|0;if((T&65535)<(S&65535))S=T;else break}if(L<<16>>16==P<<16>>16)pb=S;else{T=P;while(1){I=d[o+((T&65535)<<1)>>1]|0;if((I&65535)<(T&65535))T=I;else break}I=(S&65535)>(T&65535)?T:S;U=P;do{M=o+((U&65535)<<1)|0;J=U;U=d[M>>1]|0;d[M>>1]=I}while((U&65535)<(J&65535));pb=I}I=L;do{U=o+((I&65535)<<1)|0;P=I;I=d[U>>1]|0;d[U>>1]=pb}while((I&65535)<(P&65535));d[z+(E<<1)>>1]=pb;K=F;break a}do if(D){if(!(b[y+G>>0]|0))break;d[z+(E<<1)>>1]=d[z+(_<<1)>>1]|0;K=F;break a}while(0);I=d[t+(E<<1)>>1]|0;L=d[z+(_<<1)>>1]|0;P=I;while(1){U=d[o+((P&65535)<<1)>>1]|0;if((U&65535)<(P&65535))P=U;else break}if(I<<16>>16==L<<16>>16)qb=P;else{U=L;while(1){S=d[o+((U&65535)<<1)>>1]|0;if((S&65535)<(U&65535))U=S;else break}S=(P&65535)>(U&65535)?U:P;T=L;do{J=o+((T&65535)<<1)|0;M=T;T=d[J>>1]|0;d[J>>1]=S}while((T&65535)<(M&65535));qb=S}S=I;do{T=o+((S&65535)<<1)|0;L=S;S=d[T>>1]|0;d[T>>1]=qb}while((S&65535)<(L&65535));d[z+(E<<1)>>1]=qb;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;I=d[z+(_<<1)>>1]|0;L=S;while(1){T=d[o+((L&65535)<<1)>>1]|0;if((T&65535)<(L&65535))L=T;else break}if(S<<16>>16==I<<16>>16)rb=L;else{_=I;while(1){T=d[o+((_&65535)<<1)>>1]|0;if((T&65535)<(_&65535))_=T;else break}T=(L&65535)>(_&65535)?_:L;P=I;do{U=o+((P&65535)<<1)|0;M=P;P=d[U>>1]|0;d[U>>1]=T}while((P&65535)<(M&65535));rb=T}T=S;do{P=o+((T&65535)<<1)|0;I=T;T=d[P>>1]|0;d[P>>1]=rb}while((T&65535)<(I&65535));d[z+(E<<1)>>1]=rb;K=F;break a}else ob=E+-2|0;while(0);d[z+(E<<1)>>1]=d[z+(ob<<1)>>1]|0;K=F;break}}T=E|1;S=(T|0)<(i|0);if(!(C|S^1)?b[x+T>>0]|0:0){if(b[x+E>>0]|0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}if(H?b[x+G>>0]|0:0){I=d[t+(E<<1)>>1]|0;do if(D){if(!(b[y+E>>0]|0))break;d[z+(E<<1)>>1]=I;K=F;break a}while(0);P=d[t+(E+-2<<1)>>1]|0;L=P;while(1){_=d[o+((L&65535)<<1)>>1]|0;if((_&65535)<(L&65535))L=_;else break}if(P<<16>>16==I<<16>>16)sb=L;else{_=I;while(1){M=d[o+((_&65535)<<1)>>1]|0;if((M&65535)<(_&65535))_=M;else break}M=(L&65535)>(_&65535)?_:L;U=I;do{J=o+((U&65535)<<1)|0;N=U;U=d[J>>1]|0;d[J>>1]=M}while((U&65535)<(N&65535));sb=M}M=P;do{U=o+((M&65535)<<1)|0;I=M;M=d[U>>1]|0;d[U>>1]=sb}while((M&65535)<(I&65535));d[z+(E<<1)>>1]=sb;K=F;break}d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}if(S?b[v+T>>0]|0:0){M=E+2|0;if(!((M|0)>=(i|0)|C)?b[x+M>>0]|0:0){if(b[x+E>>0]|0){do if(D){if(!(b[y+T>>0]|0))break;d[z+(E<<1)>>1]=d[t+(M<<1)>>1]|0;K=F;break a}while(0);S=d[t+(E<<1)>>1]|0;P=d[t+(M<<1)>>1]|0;I=S;while(1){U=d[o+((I&65535)<<1)>>1]|0;if((U&65535)<(I&65535))I=U;else break}if(S<<16>>16==P<<16>>16)tb=I;else{U=P;while(1){L=d[o+((U&65535)<<1)>>1]|0;if((L&65535)<(U&65535))U=L;else break}L=(I&65535)>(U&65535)?U:I;_=P;do{N=o+((_&65535)<<1)|0;J=_;_=d[N>>1]|0;d[N>>1]=L}while((_&65535)<(J&65535));tb=L}L=S;do{_=o+((L&65535)<<1)|0;P=L;L=d[_>>1]|0;d[_>>1]=tb}while((L&65535)<(P&65535));d[z+(E<<1)>>1]=tb;K=F;break}do if(H){if(!(b[x+G>>0]|0))break;do if(D){if(!(b[y+T>>0]|0))break;L=d[t+(M<<1)>>1]|0;if(b[y+E>>0]|0){d[z+(E<<1)>>1]=L;K=F;break a}S=d[t+(E+-2<<1)>>1]|0;P=S;while(1){_=d[o+((P&65535)<<1)>>1]|0;if((_&65535)<(P&65535))P=_;else break}if(S<<16>>16==L<<16>>16)ub=P;else{_=L;while(1){I=d[o+((_&65535)<<1)>>1]|0;if((I&65535)<(_&65535))_=I;else break}I=(P&65535)>(_&65535)?_:P;U=L;do{J=o+((U&65535)<<1)|0;N=U;U=d[J>>1]|0;d[J>>1]=I}while((U&65535)<(N&65535));ub=I}I=S;do{U=o+((I&65535)<<1)|0;L=I;I=d[U>>1]|0;d[U>>1]=ub}while((I&65535)<(L&65535));d[z+(E<<1)>>1]=ub;K=F;break a}while(0);I=d[t+(E+-2<<1)>>1]|0;S=d[t+(M<<1)>>1]|0;L=I;while(1){U=d[o+((L&65535)<<1)>>1]|0;if((U&65535)<(L&65535))L=U;else break}if(I<<16>>16==S<<16>>16)vb=L;else{U=S;while(1){P=d[o+((U&65535)<<1)>>1]|0;if((P&65535)<(U&65535))U=P;else break}P=(L&65535)>(U&65535)?U:L;_=S;do{N=o+((_&65535)<<1)|0;J=_;_=d[N>>1]|0;d[N>>1]=P}while((_&65535)<(J&65535));vb=P}P=I;do{_=o+((P&65535)<<1)|0;S=P;P=d[_>>1]|0;d[_>>1]=vb}while((P&65535)<(S&65535));d[z+(E<<1)>>1]=vb;K=F;break a}while(0);d[z+(E<<1)>>1]=d[t+(M<<1)>>1]|0;K=F;break}if(B?b[x+E>>0]|0:0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}do if(!(C|H^1)){if(!(b[x+G>>0]|0))break;d[z+(E<<1)>>1]=d[t+(E+-2<<1)>>1]|0;K=F;break a}while(0);d[z+(E<<1)>>1]=F;M=F&65535;d[o+(M<<1)>>1]=F;K=M+1&65535;break}if(B?b[x+E>>0]|0:0){d[z+(E<<1)>>1]=d[t+(E<<1)>>1]|0;K=F;break}if(!(C|H^1)?b[x+G>>0]|0:0){d[z+(E<<1)>>1]=d[t+(E+-2<<1)>>1]|0;K=F;break}d[z+(E<<1)>>1]=F;M=F&65535;d[o+(M<<1)>>1]=F;K=M+1&65535}while(0);E=E+2|0;if((E|0)>=(i|0)){wb=K;break}else F=K}}else wb=r;s=s+2|0;if((s|0)>=(a|0))break;else r=wb}if((wb&65535)>1){r=wb&65535;wb=1;a=1;while(1){s=o+(a<<1)|0;K=j[s>>1]|0;if(K>>>0<a>>>0){d[s>>1]=d[o+(K<<1)>>1]|0;xb=wb}else{d[s>>1]=wb;xb=(wb&65535)+1&65535}a=a+1|0;if((a|0)==(r|0)){yb=xb;break}else wb=xb}}else yb=1}else yb=1;xb=f[k>>2]|0;k=f[p>>2]|0;p=(k&1|0)!=0;wb=(xb|0)>0;if(!(xb&1)){if(!p){if(!wb){UC(o);u=h;return yb|0}r=f[c+16>>2]|0;a=f[f[c+44>>2]>>2]|0;s=f[e+16>>2]|0;K=f[f[e+44>>2]>>2]|0;i=(k|0)>0;vb=0;do{ub=r+(Y(a,vb)|0)|0;tb=ub+a|0;sb=s+(Y(K,vb)|0)|0;ob=sb+K|0;if(i){rb=0;do{qb=sb+(rb<<1)|0;pb=d[qb>>1]|0;do if(pb<<16>>16){nb=d[o+((pb&65535)<<1)>>1]|0;d[qb>>1]=(b[ub+rb>>0]|0)==0?0:nb;jb=rb|1;d[sb+(jb<<1)>>1]=(b[ub+jb>>0]|0)==0?0:nb;d[ob+(rb<<1)>>1]=(b[tb+rb>>0]|0)==0?0:nb;mb=ob+(jb<<1)|0;if(!(b[tb+jb>>0]|0)){d[mb>>1]=0;break}else{d[mb>>1]=nb;break}}else{d[qb>>1]=0;nb=rb|1;d[sb+(nb<<1)>>1]=0;d[ob+(rb<<1)>>1]=0;d[ob+(nb<<1)>>1]=0}while(0);rb=rb+2|0}while((rb|0)<(k|0))}vb=vb+2|0}while((vb|0)<(xb|0));UC(o);u=h;return yb|0}if(!wb){UC(o);u=h;return yb|0}vb=f[c+16>>2]|0;i=f[f[c+44>>2]>>2]|0;K=f[e+16>>2]|0;s=f[f[e+44>>2]>>2]|0;a=(k|0)>0;r=0;do{rb=vb+(Y(i,r)|0)|0;ob=rb+i|0;sb=K+(Y(s,r)|0)|0;tb=sb+s|0;if(a){ub=0;do{qb=sb+(ub<<1)|0;pb=d[qb>>1]|0;do if(!(pb<<16>>16)){d[qb>>1]=0;d[tb+(ub<<1)>>1]=0;nb=ub|1;if((nb|0)<(k|0)){d[sb+(nb<<1)>>1]=0;d[tb+(nb<<1)>>1]=0}}else{nb=d[o+((pb&65535)<<1)>>1]|0;d[qb>>1]=(b[rb+ub>>0]|0)==0?0:nb;d[tb+(ub<<1)>>1]=(b[ob+ub>>0]|0)==0?0:nb;mb=ub|1;if((mb|0)<(k|0)){d[sb+(mb<<1)>>1]=(b[rb+mb>>0]|0)==0?0:nb;jb=tb+(mb<<1)|0;if(!(b[ob+mb>>0]|0)){d[jb>>1]=0;break}else{d[jb>>1]=nb;break}}}while(0);ub=ub+2|0}while((ub|0)<(k|0))}r=r+2|0}while((r|0)<(xb|0));UC(o);u=h;return yb|0}if(!p){if(!wb){UC(o);u=h;return yb|0}p=f[c+16>>2]|0;r=f[f[c+44>>2]>>2]|0;a=f[e+16>>2]|0;s=f[f[e+44>>2]>>2]|0;K=(k|0)>0;i=0;do{vb=p+(Y(r,i)|0)|0;ub=vb+r|0;ob=a+(Y(s,i)|0)|0;tb=ob+s|0;if(K){rb=i|1;sb=(rb|0)<(xb|0);qb=(rb|0)<(xb|0);rb=0;do{pb=ob+(rb<<1)|0;nb=d[pb>>1]|0;do if(!(nb<<16>>16)){d[pb>>1]=0;jb=rb|1;d[ob+(jb<<1)>>1]=0;if(sb){d[tb+(rb<<1)>>1]=0;d[tb+(jb<<1)>>1]=0}}else{jb=d[o+((nb&65535)<<1)>>1]|0;d[pb>>1]=(b[vb+rb>>0]|0)==0?0:jb;mb=rb|1;d[ob+(mb<<1)>>1]=(b[vb+mb>>0]|0)==0?0:jb;if(qb){d[tb+(rb<<1)>>1]=(b[ub+rb>>0]|0)==0?0:jb;lb=tb+(mb<<1)|0;if(!(b[ub+mb>>0]|0)){d[lb>>1]=0;break}else{d[lb>>1]=jb;break}}}while(0);rb=rb+2|0}while((rb|0)<(k|0))}i=i+2|0}while((i|0)<(xb|0));UC(o);u=h;return yb|0}if(!wb){UC(o);u=h;return yb|0}wb=f[c+16>>2]|0;i=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;K=f[f[e+44>>2]>>2]|0;e=(k|0)>0;s=0;do{a=wb+(Y(i,s)|0)|0;r=a+i|0;p=c+(Y(K,s)|0)|0;rb=p+K|0;if(e){ub=s|1;tb=(ub|0)<(xb|0);qb=(ub|0)<(xb|0);vb=(ub|0)<(xb|0);ob=(ub|0)<(xb|0);ub=0;do{sb=p+(ub<<1)|0;pb=d[sb>>1]|0;do if(!(pb<<16>>16)){d[sb>>1]=0;nb=ub|1;if((nb|0)<(k|0)){d[p+(nb<<1)>>1]=0;if(!tb)break;d[rb+(ub<<1)>>1]=0;d[rb+(nb<<1)>>1]=0;break}else{if(!qb)break;d[rb+(ub<<1)>>1]=0;break}}else{nb=d[o+((pb&65535)<<1)>>1]|0;d[sb>>1]=(b[a+ub>>0]|0)==0?0:nb;jb=ub|1;if((jb|0)<(k|0)){d[p+(jb<<1)>>1]=(b[a+jb>>0]|0)==0?0:nb;if(!vb)break;d[rb+(ub<<1)>>1]=(b[r+ub>>0]|0)==0?0:nb;lb=rb+(jb<<1)|0;if(!(b[r+jb>>0]|0)){d[lb>>1]=0;break}else{d[lb>>1]=nb;break}}else{if(!ob)break;lb=rb+(ub<<1)|0;if(!(b[r+ub>>0]|0)){d[lb>>1]=0;break}else{d[lb>>1]=nb;break}}}while(0);ub=ub+2|0}while((ub|0)<(k|0))}s=s+2|0}while((s|0)<(xb|0));UC(o);u=h;return yb|0}function O3(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0;g=u;u=u+16|0;a=g;h=c+8|0;i=d+8|0;if((f[h>>2]|0)!=(f[i>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;j=aD(a,26)|0;k=235286;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,a,489445,235014,2594);bD(a)}m=c+12|0;n=d+12|0;if((f[m>>2]|0)!=(f[n>>2]|0)){f[a>>2]=0;f[a+4>>2]=0;j=aD(a,26)|0;k=235313;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,a,489445,235014,2595);bD(a)}if((e|0)!=8){f[a>>2]=0;f[a+4>>2]=0;j=aD(a,17)|0;k=235340;l=j+17|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,a,489445,235014,2596);bD(a)}a=f[h>>2]|0;h=f[m>>2]|0;m=TC((Y(((a+1|0)/2|0)<<2,(h+1|0)/2|0)|0)+4|0)|0;f[m>>2]=0;if((a|0)>0){k=c+16|0;j=c+44|0;l=d+16|0;e=d+44|0;o=(h|0)>0;p=1;q=0;while(1){r=f[f[j>>2]>>2]|0;s=(f[k>>2]|0)+(Y(r,q)|0)|0;t=0-r|0;v=s+t|0;w=v+t|0;t=s+r|0;r=f[f[e>>2]>>2]|0;x=(f[l>>2]|0)+(Y(r,q)|0)|0;y=0-r|0;r=x+y+y|0;if(o){y=(q|1|0)<(a|0);z=(q|0)>0;A=z^1;B=(q+-2|0)>-1;C=0;D=p;while(1){a:do if(!(b[s+C>>0]|0)){E=C|1;F=(E|0)<(h|0);if(y?b[t+C>>0]|0:0){G=C+-1|0;H=(C|0)>0;if(F?b[s+E>>0]|0:0){do if(H){if(b[s+G>>0]|0){do if(z){if(b[v+E>>0]|0){if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}do if(B){if(!(b[w+C>>0]|0))break;J=C+-2|0;if(b[v+G>>0]|0){f[x+(C<<2)>>2]=f[x+(J<<2)>>2];I=D;break a}do if((J|0)>-1){if(!(b[v+J>>0]|0))break;if(b[w+G>>0]|0){f[x+(C<<2)>>2]=f[x+(J<<2)>>2];I=D;break a}K=f[r+(C<<2)>>2]|0;L=f[x+(J<<2)>>2]|0;M=K;while(1){N=f[m+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}if((K|0)==(L|0))O=M;else{N=L;while(1){P=f[m+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(M|0)>(N|0)?N:M;Q=L;do{R=m+(Q<<2)|0;S=Q;Q=f[R>>2]|0;f[R>>2]=P}while((Q|0)<(S|0));O=P}P=K;do{Q=m+(P<<2)|0;L=P;P=f[Q>>2]|0;f[Q>>2]=O}while((P|0)<(L|0));f[x+(C<<2)>>2]=O;I=D;break a}while(0);P=f[r+(C<<2)>>2]|0;K=f[x+(J<<2)>>2]|0;L=P;while(1){Q=f[m+(L<<2)>>2]|0;if((Q|0)<(L|0))L=Q;else break}if((P|0)==(K|0))T=L;else{J=K;while(1){Q=f[m+(J<<2)>>2]|0;if((Q|0)<(J|0))J=Q;else break}Q=(L|0)>(J|0)?J:L;M=K;do{N=m+(M<<2)|0;S=M;M=f[N>>2]|0;f[N>>2]=Q}while((M|0)<(S|0));T=Q}Q=P;do{M=m+(Q<<2)|0;K=Q;Q=f[M>>2]|0;f[M>>2]=T}while((Q|0)<(K|0));f[x+(C<<2)>>2]=T;I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;P=f[x+(C+-2<<2)>>2]|0;K=Q;while(1){M=f[m+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((Q|0)==(P|0))U=K;else{M=P;while(1){L=f[m+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}L=(K|0)>(M|0)?M:K;J=P;do{S=m+(J<<2)|0;N=J;J=f[S>>2]|0;f[S>>2]=L}while((J|0)<(N|0));U=L}L=Q;do{J=m+(L<<2)|0;P=L;L=f[J>>2]|0;f[J>>2]=U}while((L|0)<(P|0));f[x+(C<<2)>>2]=U;I=D;break a}L=C+2|0;if((L|0)>=(h|0))break;if(!(b[v+L>>0]|0))break;do if(B){if(!(b[w+E>>0]|0))break;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}if(!(b[w+C>>0]|0)){Q=f[r+(L<<2)>>2]|0;P=f[x+(C+-2<<2)>>2]|0;J=Q;while(1){K=f[m+(J<<2)>>2]|0;if((K|0)<(J|0))J=K;else break}if((Q|0)==(P|0))V=J;else{K=P;while(1){M=f[m+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(J|0)>(K|0)?K:J;N=P;do{S=m+(N<<2)|0;R=N;N=f[S>>2]|0;f[S>>2]=M}while((N|0)<(R|0));V=M}M=Q;do{N=m+(M<<2)|0;P=M;M=f[N>>2]|0;f[N>>2]=V}while((M|0)<(P|0));f[x+(C<<2)>>2]=V;I=D;break a}M=C+-2|0;if(b[v+G>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+G>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}Q=f[r+(L<<2)>>2]|0;P=f[x+(M<<2)>>2]|0;N=Q;while(1){J=f[m+(N<<2)>>2]|0;if((J|0)<(N|0))N=J;else break}if((Q|0)==(P|0))W=N;else{J=P;while(1){K=f[m+(J<<2)>>2]|0;if((K|0)<(J|0))J=K;else break}K=(N|0)>(J|0)?J:N;R=P;do{S=m+(R<<2)|0;X=R;R=f[S>>2]|0;f[S>>2]=K}while((R|0)<(X|0));W=K}K=Q;do{R=m+(K<<2)|0;P=K;K=f[R>>2]|0;f[R>>2]=W}while((K|0)<(P|0));f[x+(C<<2)>>2]=W;I=D;break a}while(0);K=f[r+(L<<2)>>2]|0;Q=f[x+(M<<2)>>2]|0;P=K;while(1){R=f[m+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}if((K|0)==(Q|0))Z=P;else{M=Q;while(1){R=f[m+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}R=(P|0)>(M|0)?M:P;N=Q;do{J=m+(N<<2)|0;X=N;N=f[J>>2]|0;f[J>>2]=R}while((N|0)<(X|0));Z=R}R=K;do{N=m+(R<<2)|0;Q=R;R=f[N>>2]|0;f[N>>2]=Z}while((R|0)<(Q|0));f[x+(C<<2)>>2]=Z;I=D;break a}while(0);R=f[r+(L<<2)>>2]|0;K=f[x+(C+-2<<2)>>2]|0;Q=R;while(1){N=f[m+(Q<<2)>>2]|0;if((N|0)<(Q|0))Q=N;else break}if((R|0)==(K|0))_=Q;else{L=K;while(1){N=f[m+(L<<2)>>2]|0;if((N|0)<(L|0))L=N;else break}N=(Q|0)>(L|0)?L:Q;P=K;do{M=m+(P<<2)|0;X=P;P=f[M>>2]|0;f[M>>2]=N}while((P|0)<(X|0));_=N}N=R;do{P=m+(N<<2)|0;K=N;N=f[P>>2]|0;f[P>>2]=_}while((N|0)<(K|0));f[x+(C<<2)>>2]=_;I=D;break a}while(0);f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}if(!(b[t+G>>0]|0))break;do if(z){if(b[v+E>>0]|0){N=C+-2|0;do if((N|0)>-1){if(!(b[s+N>>0]|0))break;if(b[v+G>>0]|0){R=f[x+(N<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}do if(B){if(!(b[w+C>>0]|0))break;f[x+(C<<2)>>2]=R;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;P=K;while(1){Q=f[m+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}if((K|0)==(R|0))$=P;else{Q=R;while(1){L=f[m+(Q<<2)>>2]|0;if((L|0)<(Q|0))Q=L;else break}L=(P|0)>(Q|0)?Q:P;X=R;do{M=m+(X<<2)|0;J=X;X=f[M>>2]|0;f[M>>2]=L}while((X|0)<(J|0));$=L}L=K;do{X=m+(L<<2)|0;R=L;L=f[X>>2]|0;f[X>>2]=$}while((L|0)<(R|0));f[x+(C<<2)>>2]=$;I=D;break a}if(!(b[v+N>>0]|0)){L=f[r+(C<<2)>>2]|0;K=f[x+(N<<2)>>2]|0;R=L;while(1){X=f[m+(R<<2)>>2]|0;if((X|0)<(R|0))R=X;else break}if((L|0)==(K|0))aa=R;else{X=K;while(1){P=f[m+(X<<2)>>2]|0;if((P|0)<(X|0))X=P;else break}P=(R|0)>(X|0)?X:R;Q=K;do{J=m+(Q<<2)|0;M=Q;Q=f[J>>2]|0;f[J>>2]=P}while((Q|0)<(M|0));aa=P}P=L;do{Q=m+(P<<2)|0;K=P;P=f[Q>>2]|0;f[Q>>2]=aa}while((P|0)<(K|0));f[x+(C<<2)>>2]=aa;I=D;break a}do if(B){if(!(b[w+G>>0]|0))break;P=f[x+(N<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=P;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=P;I=D;break a}L=f[r+(C<<2)>>2]|0;K=L;while(1){Q=f[m+(K<<2)>>2]|0;if((Q|0)<(K|0))K=Q;else break}if((L|0)==(P|0))ba=K;else{Q=P;while(1){R=f[m+(Q<<2)>>2]|0;if((R|0)<(Q|0))Q=R;else break}R=(K|0)>(Q|0)?Q:K;X=P;do{M=m+(X<<2)|0;J=X;X=f[M>>2]|0;f[M>>2]=R}while((X|0)<(J|0));ba=R}R=L;do{X=m+(R<<2)|0;P=R;R=f[X>>2]|0;f[X>>2]=ba}while((R|0)<(P|0));f[x+(C<<2)>>2]=ba;I=D;break a}while(0);R=f[r+(C<<2)>>2]|0;L=f[x+(N<<2)>>2]|0;P=R;while(1){X=f[m+(P<<2)>>2]|0;if((X|0)<(P|0))P=X;else break}if((R|0)==(L|0))ca=P;else{X=L;while(1){K=f[m+(X<<2)>>2]|0;if((K|0)<(X|0))X=K;else break}K=(P|0)>(X|0)?X:P;Q=L;do{J=m+(Q<<2)|0;M=Q;Q=f[J>>2]|0;f[J>>2]=K}while((Q|0)<(M|0));ca=K}K=R;do{Q=m+(K<<2)|0;L=K;K=f[Q>>2]|0;f[Q>>2]=ca}while((K|0)<(L|0));f[x+(C<<2)>>2]=ca;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;R=f[x+(N<<2)>>2]|0;L=K;while(1){Q=f[m+(L<<2)>>2]|0;if((Q|0)<(L|0))L=Q;else break}if((K|0)==(R|0))da=L;else{N=R;while(1){Q=f[m+(N<<2)>>2]|0;if((Q|0)<(N|0))N=Q;else break}Q=(L|0)>(N|0)?N:L;P=R;do{X=m+(P<<2)|0;M=P;P=f[X>>2]|0;f[X>>2]=Q}while((P|0)<(M|0));da=Q}Q=K;do{P=m+(Q<<2)|0;R=Q;Q=f[P>>2]|0;f[P>>2]=da}while((Q|0)<(R|0));f[x+(C<<2)>>2]=da;I=D;break a}Q=C+2|0;do if(!((Q|0)>=(h|0)|A)){if(!(b[v+Q>>0]|0))break;do if(B){if(!(b[w+E>>0]|0))break;K=C+-2|0;do if((K|0)>-1){if(!(b[s+K>>0]|0))break;if(b[v+G>>0]|0){R=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}P=f[r+(Q<<2)>>2]|0;L=P;while(1){N=f[m+(L<<2)>>2]|0;if((N|0)<(L|0))L=N;else break}if((P|0)==(R|0))ea=L;else{N=R;while(1){M=f[m+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}M=(L|0)>(N|0)?N:L;X=R;do{J=m+(X<<2)|0;S=X;X=f[J>>2]|0;f[J>>2]=M}while((X|0)<(S|0));ea=M}M=P;do{X=m+(M<<2)|0;R=M;M=f[X>>2]|0;f[X>>2]=ea}while((M|0)<(R|0));f[x+(C<<2)>>2]=ea;I=D;break a}if(!(b[v+K>>0]|0)){M=f[r+(Q<<2)>>2]|0;P=f[x+(K<<2)>>2]|0;R=M;while(1){X=f[m+(R<<2)>>2]|0;if((X|0)<(R|0))R=X;else break}if((M|0)==(P|0))fa=R;else{X=P;while(1){L=f[m+(X<<2)>>2]|0;if((L|0)<(X|0))X=L;else break}L=(R|0)>(X|0)?X:R;N=P;do{S=m+(N<<2)|0;J=N;N=f[S>>2]|0;f[S>>2]=L}while((N|0)<(J|0));fa=L}L=M;do{N=m+(L<<2)|0;P=L;L=f[N>>2]|0;f[N>>2]=fa}while((L|0)<(P|0));f[x+(C<<2)>>2]=fa;I=D;break a}if(!(b[w+G>>0]|0)){L=f[r+(Q<<2)>>2]|0;M=f[x+(K<<2)>>2]|0;P=L;while(1){N=f[m+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}if((L|0)==(M|0))ga=P;else{N=M;while(1){R=f[m+(N<<2)>>2]|0;if((R|0)<(N|0))N=R;else break}R=(P|0)>(N|0)?N:P;X=M;do{J=m+(X<<2)|0;S=X;X=f[J>>2]|0;f[J>>2]=R}while((X|0)<(S|0));ga=R}R=L;do{X=m+(R<<2)|0;M=R;R=f[X>>2]|0;f[X>>2]=ga}while((R|0)<(M|0));f[x+(C<<2)>>2]=ga;I=D;break a}R=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}L=f[r+(Q<<2)>>2]|0;M=L;while(1){X=f[m+(M<<2)>>2]|0;if((X|0)<(M|0))M=X;else break}if((L|0)==(R|0))ha=M;else{X=R;while(1){P=f[m+(X<<2)>>2]|0;if((P|0)<(X|0))X=P;else break}P=(M|0)>(X|0)?X:M;N=R;do{S=m+(N<<2)|0;J=N;N=f[S>>2]|0;f[S>>2]=P}while((N|0)<(J|0));ha=P}P=L;do{N=m+(P<<2)|0;R=P;P=f[N>>2]|0;f[N>>2]=ha}while((P|0)<(R|0));f[x+(C<<2)>>2]=ha;I=D;break a}while(0);P=f[r+(Q<<2)>>2]|0;L=f[x+(K<<2)>>2]|0;R=P;while(1){N=f[m+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((P|0)==(L|0))ia=R;else{K=L;while(1){N=f[m+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(R|0)>(K|0)?K:R;M=L;do{X=m+(M<<2)|0;J=M;M=f[X>>2]|0;f[X>>2]=N}while((M|0)<(J|0));ia=N}N=P;do{M=m+(N<<2)|0;L=N;N=f[M>>2]|0;f[M>>2]=ia}while((N|0)<(L|0));f[x+(C<<2)>>2]=ia;I=D;break a}while(0);N=C+-2|0;if(!(b[v+C>>0]|0)){P=f[r+(Q<<2)>>2]|0;L=f[x+(N<<2)>>2]|0;M=P;while(1){R=f[m+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}if((P|0)==(L|0))ja=M;else{R=L;while(1){K=f[m+(R<<2)>>2]|0;if((K|0)<(R|0))R=K;else break}K=(M|0)>(R|0)?R:M;J=L;do{X=m+(J<<2)|0;S=J;J=f[X>>2]|0;f[X>>2]=K}while((J|0)<(S|0));ja=K}K=P;do{J=m+(K<<2)|0;L=K;K=f[J>>2]|0;f[J>>2]=ja}while((K|0)<(L|0));f[x+(C<<2)>>2]=ja;I=D;break a}do if((N|0)>-1){if(!(b[s+N>>0]|0))break;if(b[v+G>>0]|0){K=f[r+(Q<<2)>>2]|0;P=f[x+(N<<2)>>2]|0;L=K;while(1){J=f[m+(L<<2)>>2]|0;if((J|0)<(L|0))L=J;else break}if((K|0)==(P|0))ka=L;else{J=P;while(1){M=f[m+(J<<2)>>2]|0;if((M|0)<(J|0))J=M;else break}M=(L|0)>(J|0)?J:L;R=P;do{S=m+(R<<2)|0;X=R;R=f[S>>2]|0;f[S>>2]=M}while((R|0)<(X|0));ka=M}M=K;do{R=m+(M<<2)|0;P=M;M=f[R>>2]|0;f[R>>2]=ka}while((M|0)<(P|0));f[x+(C<<2)>>2]=ka;I=D;break a}if(!(b[v+N>>0]|0)){M=f[r+(C<<2)>>2]|0;K=f[r+(Q<<2)>>2]|0;P=M;while(1){R=f[m+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}if((M|0)==(K|0))la=P;else{R=K;while(1){L=f[m+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(P|0)>(R|0)?R:P;J=K;do{X=m+(J<<2)|0;S=J;J=f[X>>2]|0;f[X>>2]=L}while((J|0)<(S|0));la=L}L=M;do{J=m+(L<<2)|0;K=L;L=f[J>>2]|0;f[J>>2]=la}while((L|0)<(K|0));L=f[x+(N<<2)>>2]|0;M=la;while(1){K=f[m+(M<<2)>>2]|0;if((K|0)<(M|0))M=K;else break}if((la|0)==(L|0))ma=M;else{K=L;while(1){J=f[m+(K<<2)>>2]|0;if((J|0)<(K|0))K=J;else break}J=(M|0)>(K|0)?K:M;P=L;do{R=m+(P<<2)|0;S=P;P=f[R>>2]|0;f[R>>2]=J}while((P|0)<(S|0));ma=J}J=la;do{P=m+(J<<2)|0;L=J;J=f[P>>2]|0;f[P>>2]=ma}while((J|0)<(L|0));f[x+(C<<2)>>2]=ma;I=D;break a}do if(B){if(!(b[w+G>>0]|0))break;J=f[r+(Q<<2)>>2]|0;L=f[x+(N<<2)>>2]|0;P=J;while(1){M=f[m+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((J|0)==(L|0))na=P;else{M=L;while(1){K=f[m+(M<<2)>>2]|0;if((K|0)<(M|0))M=K;else break}K=(P|0)>(M|0)?M:P;S=L;do{R=m+(S<<2)|0;X=S;S=f[R>>2]|0;f[R>>2]=K}while((S|0)<(X|0));na=K}K=J;do{S=m+(K<<2)|0;L=K;K=f[S>>2]|0;f[S>>2]=na}while((K|0)<(L|0));f[x+(C<<2)>>2]=na;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;J=f[r+(Q<<2)>>2]|0;L=K;while(1){S=f[m+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}if((K|0)==(J|0))oa=L;else{S=J;while(1){P=f[m+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}P=(L|0)>(S|0)?S:L;M=J;do{X=m+(M<<2)|0;R=M;M=f[X>>2]|0;f[X>>2]=P}while((M|0)<(R|0));oa=P}P=K;do{M=m+(P<<2)|0;J=P;P=f[M>>2]|0;f[M>>2]=oa}while((P|0)<(J|0));P=f[x+(N<<2)>>2]|0;K=oa;while(1){J=f[m+(K<<2)>>2]|0;if((J|0)<(K|0))K=J;else break}if((oa|0)==(P|0))pa=K;else{J=P;while(1){M=f[m+(J<<2)>>2]|0;if((M|0)<(J|0))J=M;else break}M=(K|0)>(J|0)?J:K;L=P;do{S=m+(L<<2)|0;R=L;L=f[S>>2]|0;f[S>>2]=M}while((L|0)<(R|0));pa=M}M=oa;do{L=m+(M<<2)|0;P=M;M=f[L>>2]|0;f[L>>2]=pa}while((M|0)<(P|0));f[x+(C<<2)>>2]=pa;I=D;break a}while(0);M=f[r+(C<<2)>>2]|0;P=f[r+(Q<<2)>>2]|0;L=M;while(1){K=f[m+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}if((M|0)==(P|0))qa=L;else{K=P;while(1){J=f[m+(K<<2)>>2]|0;if((J|0)<(K|0))K=J;else break}J=(L|0)>(K|0)?K:L;R=P;do{S=m+(R<<2)|0;X=R;R=f[S>>2]|0;f[S>>2]=J}while((R|0)<(X|0));qa=J}J=M;do{R=m+(J<<2)|0;P=J;J=f[R>>2]|0;f[R>>2]=qa}while((J|0)<(P|0));J=f[x+(N<<2)>>2]|0;M=qa;while(1){P=f[m+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}if((qa|0)==(J|0))ra=M;else{N=J;while(1){P=f[m+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(M|0)>(N|0)?N:M;R=J;do{L=m+(R<<2)|0;K=R;R=f[L>>2]|0;f[L>>2]=P}while((R|0)<(K|0));ra=P}P=qa;do{R=m+(P<<2)|0;J=P;P=f[R>>2]|0;f[R>>2]=ra}while((P|0)<(J|0));f[x+(C<<2)>>2]=ra;I=D;break a}while(0);Q=C+-2|0;if(!(b[v+C>>0]|0)){sa=Q;break}do if((Q|0)>-1){if(!(b[s+Q>>0]|0))break;if(b[v+G>>0]|0){f[x+(C<<2)>>2]=f[x+(Q<<2)>>2];I=D;break a}if(!(b[v+Q>>0]|0)){P=f[r+(C<<2)>>2]|0;J=f[x+(Q<<2)>>2]|0;R=P;while(1){M=f[m+(R<<2)>>2]|0;if((M|0)<(R|0))R=M;else break}if((P|0)==(J|0))ta=R;else{M=J;while(1){N=f[m+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(R|0)>(M|0)?M:R;K=J;do{L=m+(K<<2)|0;X=K;K=f[L>>2]|0;f[L>>2]=N}while((K|0)<(X|0));ta=N}N=P;do{K=m+(N<<2)|0;J=N;N=f[K>>2]|0;f[K>>2]=ta}while((N|0)<(J|0));f[x+(C<<2)>>2]=ta;I=D;break a}do if(B){if(!(b[w+G>>0]|0))break;f[x+(C<<2)>>2]=f[x+(Q<<2)>>2];I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;P=f[x+(Q<<2)>>2]|0;J=N;while(1){K=f[m+(J<<2)>>2]|0;if((K|0)<(J|0))J=K;else break}if((N|0)==(P|0))ua=J;else{K=P;while(1){R=f[m+(K<<2)>>2]|0;if((R|0)<(K|0))K=R;else break}R=(J|0)>(K|0)?K:J;M=P;do{X=m+(M<<2)|0;L=M;M=f[X>>2]|0;f[X>>2]=R}while((M|0)<(L|0));ua=R}R=N;do{M=m+(R<<2)|0;P=R;R=f[M>>2]|0;f[M>>2]=ua}while((R|0)<(P|0));f[x+(C<<2)>>2]=ua;I=D;break a}while(0);R=f[r+(C<<2)>>2]|0;N=f[x+(Q<<2)>>2]|0;P=R;while(1){M=f[m+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((R|0)==(N|0))va=P;else{Q=N;while(1){M=f[m+(Q<<2)>>2]|0;if((M|0)<(Q|0))Q=M;else break}M=(P|0)>(Q|0)?Q:P;J=N;do{K=m+(J<<2)|0;L=J;J=f[K>>2]|0;f[K>>2]=M}while((J|0)<(L|0));va=M}M=R;do{J=m+(M<<2)|0;N=M;M=f[J>>2]|0;f[J>>2]=va}while((M|0)<(N|0));f[x+(C<<2)>>2]=va;I=D;break a}else sa=C+-2|0;while(0);f[x+(C<<2)>>2]=f[x+(sa<<2)>>2];I=D;break a}while(0);do if(z){if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}M=C+2|0;do if(!((M|0)>=(h|0)|A)){if(!(b[v+M>>0]|0))break;if(!(b[v+C>>0]|0)){f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}while(0);R=f[r+(C<<2)>>2]|0;N=f[r+(M<<2)>>2]|0;J=R;while(1){P=f[m+(J<<2)>>2]|0;if((P|0)<(J|0))J=P;else break}if((R|0)==(N|0))wa=J;else{P=N;while(1){Q=f[m+(P<<2)>>2]|0;if((Q|0)<(P|0))P=Q;else break}Q=(J|0)>(P|0)?P:J;L=N;do{K=m+(L<<2)|0;X=L;L=f[K>>2]|0;f[K>>2]=Q}while((L|0)<(X|0));wa=Q}Q=R;do{L=m+(Q<<2)|0;N=Q;Q=f[L>>2]|0;f[L>>2]=wa}while((Q|0)<(N|0));f[x+(C<<2)>>2]=wa;I=D;break a}while(0);if(!(b[v+C>>0]|0))break;f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}while(0);f[x+(C<<2)>>2]=D;f[m+(D<<2)>>2]=D;I=D+1|0;break}if(H){if(b[t+G>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}if(b[s+G>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}}f[x+(C<<2)>>2]=D;f[m+(D<<2)>>2]=D;I=D+1|0;break}do if(F){if(!(b[s+E>>0]|0)){if(!y)break;if(!(b[t+E>>0]|0))break;f[x+(C<<2)>>2]=D;f[m+(D<<2)>>2]=D;I=D+1|0;break a}if(z){if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}M=C+2|0;do if(!((M|0)>=(h|0)|A)){if(!(b[v+M>>0]|0))break;if(!(b[v+C>>0]|0)){f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[r+(M<<2)>>2];I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;R=f[r+(M<<2)>>2]|0;N=Q;while(1){L=f[m+(N<<2)>>2]|0;if((L|0)<(N|0))N=L;else break}if((Q|0)==(R|0))xa=N;else{L=R;while(1){J=f[m+(L<<2)>>2]|0;if((J|0)<(L|0))L=J;else break}J=(N|0)>(L|0)?L:N;P=R;do{X=m+(P<<2)|0;K=P;P=f[X>>2]|0;f[X>>2]=J}while((P|0)<(K|0));xa=J}J=Q;do{P=m+(J<<2)|0;R=J;J=f[P>>2]|0;f[P>>2]=xa}while((J|0)<(R|0));f[x+(C<<2)>>2]=xa;I=D;break a}while(0);if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break a}}f[x+(C<<2)>>2]=D;f[m+(D<<2)>>2]=D;I=D+1|0;break a}while(0);f[x+(C<<2)>>2]=0;I=D}else{E=C+-1|0;F=(C|0)>0;if(F){if(b[s+E>>0]|0){G=C|1;H=(G|0)<(h|0);if(z&H?b[v+G>>0]|0:0){if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}do if(B){if(!(b[w+C>>0]|0))break;M=C+-2|0;if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+E>>0]|0){f[x+(C<<2)>>2]=f[x+(M<<2)>>2];I=D;break a}J=f[r+(C<<2)>>2]|0;Q=f[x+(M<<2)>>2]|0;R=J;while(1){P=f[m+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((J|0)==(Q|0))ya=R;else{P=Q;while(1){N=f[m+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(R|0)>(P|0)?P:R;L=Q;do{K=m+(L<<2)|0;X=L;L=f[K>>2]|0;f[K>>2]=N}while((L|0)<(X|0));ya=N}N=J;do{L=m+(N<<2)|0;Q=N;N=f[L>>2]|0;f[L>>2]=ya}while((N|0)<(Q|0));f[x+(C<<2)>>2]=ya;I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;J=f[x+(M<<2)>>2]|0;Q=N;while(1){L=f[m+(Q<<2)>>2]|0;if((L|0)<(Q|0))Q=L;else break}if((N|0)==(J|0))za=Q;else{M=J;while(1){L=f[m+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}L=(Q|0)>(M|0)?M:Q;R=J;do{P=m+(R<<2)|0;X=R;R=f[P>>2]|0;f[P>>2]=L}while((R|0)<(X|0));za=L}L=N;do{R=m+(L<<2)|0;J=L;L=f[R>>2]|0;f[R>>2]=za}while((L|0)<(J|0));f[x+(C<<2)>>2]=za;I=D;break a}while(0);L=f[r+(C<<2)>>2]|0;N=f[x+(C+-2<<2)>>2]|0;J=L;while(1){R=f[m+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}if((L|0)==(N|0))Aa=J;else{R=N;while(1){Q=f[m+(R<<2)>>2]|0;if((Q|0)<(R|0))R=Q;else break}Q=(J|0)>(R|0)?R:J;M=N;do{X=m+(M<<2)|0;P=M;M=f[X>>2]|0;f[X>>2]=Q}while((M|0)<(P|0));Aa=Q}Q=L;do{M=m+(Q<<2)|0;N=Q;Q=f[M>>2]|0;f[M>>2]=Aa}while((Q|0)<(N|0));f[x+(C<<2)>>2]=Aa;I=D;break}if(H?b[s+G>>0]|0:0){Q=C+2|0;do if(z&(Q|0)<(h|0)){if(!(b[v+Q>>0]|0))break;do if(B){if(!(b[w+G>>0]|0))break;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break a}if(!(b[w+C>>0]|0)){L=f[r+(Q<<2)>>2]|0;N=f[x+(C+-2<<2)>>2]|0;M=L;while(1){J=f[m+(M<<2)>>2]|0;if((J|0)<(M|0))M=J;else break}if((L|0)==(N|0))Ba=M;else{J=N;while(1){R=f[m+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}R=(M|0)>(J|0)?J:M;P=N;do{X=m+(P<<2)|0;K=P;P=f[X>>2]|0;f[X>>2]=R}while((P|0)<(K|0));Ba=R}R=L;do{P=m+(R<<2)|0;N=R;R=f[P>>2]|0;f[P>>2]=Ba}while((R|0)<(N|0));f[x+(C<<2)>>2]=Ba;I=D;break a}R=C+-2|0;if(b[v+E>>0]|0){f[x+(C<<2)>>2]=f[x+(R<<2)>>2];I=D;break a}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(b[w+E>>0]|0){f[x+(C<<2)>>2]=f[x+(R<<2)>>2];I=D;break a}L=f[r+(Q<<2)>>2]|0;N=f[x+(R<<2)>>2]|0;P=L;while(1){M=f[m+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}if((L|0)==(N|0))Ca=P;else{M=N;while(1){J=f[m+(M<<2)>>2]|0;if((J|0)<(M|0))M=J;else break}J=(P|0)>(M|0)?M:P;K=N;do{X=m+(K<<2)|0;S=K;K=f[X>>2]|0;f[X>>2]=J}while((K|0)<(S|0));Ca=J}J=L;do{K=m+(J<<2)|0;N=J;J=f[K>>2]|0;f[K>>2]=Ca}while((J|0)<(N|0));f[x+(C<<2)>>2]=Ca;I=D;break a}while(0);J=f[r+(Q<<2)>>2]|0;L=f[x+(R<<2)>>2]|0;N=J;while(1){K=f[m+(N<<2)>>2]|0;if((K|0)<(N|0))N=K;else break}if((J|0)==(L|0))Da=N;else{R=L;while(1){K=f[m+(R<<2)>>2]|0;if((K|0)<(R|0))R=K;else break}K=(N|0)>(R|0)?R:N;P=L;do{M=m+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=K}while((P|0)<(S|0));Da=K}K=J;do{P=m+(K<<2)|0;L=K;K=f[P>>2]|0;f[P>>2]=Da}while((K|0)<(L|0));f[x+(C<<2)>>2]=Da;I=D;break a}while(0);K=f[r+(Q<<2)>>2]|0;J=f[x+(C+-2<<2)>>2]|0;L=K;while(1){P=f[m+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((K|0)==(J|0))Ea=L;else{P=J;while(1){N=f[m+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(L|0)>(P|0)?P:L;R=J;do{S=m+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=N}while((R|0)<(M|0));Ea=N}N=K;do{R=m+(N<<2)|0;J=N;N=f[R>>2]|0;f[R>>2]=Ea}while((N|0)<(J|0));f[x+(C<<2)>>2]=Ea;I=D;break a}while(0);f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}f[x+(C<<2)>>2]=f[x+(C+-2<<2)>>2];I=D;break}if(y?b[t+E>>0]|0:0){Q=C|1;G=(Q|0)<(h|0);if(!(A|G^1)?b[v+Q>>0]|0:0){H=C+-2|0;do if((H|0)>-1){if(!(b[s+H>>0]|0))break;if(b[v+E>>0]|0){N=f[x+(H<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=N;I=D;break a}do if(B){if(!(b[w+C>>0]|0))break;f[x+(C<<2)>>2]=N;I=D;break a}while(0);K=f[r+(C<<2)>>2]|0;J=K;while(1){R=f[m+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}if((K|0)==(N|0))Fa=J;else{R=N;while(1){L=f[m+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(J|0)>(R|0)?R:J;P=N;do{M=m+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=L}while((P|0)<(S|0));Fa=L}L=K;do{P=m+(L<<2)|0;N=L;L=f[P>>2]|0;f[P>>2]=Fa}while((L|0)<(N|0));f[x+(C<<2)>>2]=Fa;I=D;break a}if(!(b[v+H>>0]|0)){L=f[r+(C<<2)>>2]|0;K=f[x+(H<<2)>>2]|0;N=L;while(1){P=f[m+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((L|0)==(K|0))Ga=N;else{P=K;while(1){J=f[m+(P<<2)>>2]|0;if((J|0)<(P|0))P=J;else break}J=(N|0)>(P|0)?P:N;R=K;do{S=m+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=J}while((R|0)<(M|0));Ga=J}J=L;do{R=m+(J<<2)|0;K=J;J=f[R>>2]|0;f[R>>2]=Ga}while((J|0)<(K|0));f[x+(C<<2)>>2]=Ga;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;J=f[x+(H<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=J;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=J;I=D;break a}L=f[r+(C<<2)>>2]|0;K=L;while(1){R=f[m+(K<<2)>>2]|0;if((R|0)<(K|0))K=R;else break}if((L|0)==(J|0))Ha=K;else{R=J;while(1){N=f[m+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(K|0)>(R|0)?R:K;P=J;do{M=m+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=N}while((P|0)<(S|0));Ha=N}N=L;do{P=m+(N<<2)|0;J=N;N=f[P>>2]|0;f[P>>2]=Ha}while((N|0)<(J|0));f[x+(C<<2)>>2]=Ha;I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;L=f[x+(H<<2)>>2]|0;J=N;while(1){P=f[m+(J<<2)>>2]|0;if((P|0)<(J|0))J=P;else break}if((N|0)==(L|0))Ia=J;else{P=L;while(1){K=f[m+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(J|0)>(P|0)?P:J;R=L;do{S=m+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=K}while((R|0)<(M|0));Ia=K}K=N;do{R=m+(K<<2)|0;L=K;K=f[R>>2]|0;f[R>>2]=Ia}while((K|0)<(L|0));f[x+(C<<2)>>2]=Ia;I=D;break a}while(0);if(b[v+C>>0]|0){K=f[r+(C<<2)>>2]|0;N=f[x+(H<<2)>>2]|0;L=K;while(1){R=f[m+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((K|0)==(N|0))Ja=L;else{R=N;while(1){J=f[m+(R<<2)>>2]|0;if((J|0)<(R|0))R=J;else break}J=(L|0)>(R|0)?R:L;P=N;do{M=m+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=J}while((P|0)<(S|0));Ja=J}J=K;do{P=m+(J<<2)|0;N=J;J=f[P>>2]|0;f[P>>2]=Ja}while((J|0)<(N|0));f[x+(C<<2)>>2]=Ja;I=D;break}J=f[r+(C<<2)>>2]|0;if(!(b[v+E>>0]|0)){K=f[x+(H<<2)>>2]|0;N=J;while(1){P=f[m+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((J|0)==(K|0))Ka=N;else{P=K;while(1){L=f[m+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(N|0)>(P|0)?P:N;R=K;do{S=m+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=L}while((R|0)<(M|0));Ka=L}L=J;do{R=m+(L<<2)|0;K=L;L=f[R>>2]|0;f[R>>2]=Ka}while((L|0)<(K|0));f[x+(C<<2)>>2]=Ka;I=D;break}do if(B){if(!(b[w+C>>0]|0))break;L=f[x+(H<<2)>>2]|0;K=J;while(1){R=f[m+(K<<2)>>2]|0;if((R|0)<(K|0))K=R;else break}if((J|0)==(L|0))La=K;else{R=L;while(1){N=f[m+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(K|0)>(R|0)?R:K;P=L;do{M=m+(P<<2)|0;S=P;P=f[M>>2]|0;f[M>>2]=N}while((P|0)<(S|0));La=N}N=J;do{P=m+(N<<2)|0;L=N;N=f[P>>2]|0;f[P>>2]=La}while((N|0)<(L|0));f[x+(C<<2)>>2]=La;I=D;break a}while(0);N=f[r+(H<<2)>>2]|0;L=N;while(1){P=f[m+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((N|0)==(J|0))Ma=L;else{P=J;while(1){K=f[m+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}K=(L|0)>(P|0)?P:L;R=J;do{S=m+(R<<2)|0;M=R;R=f[S>>2]|0;f[S>>2]=K}while((R|0)<(M|0));Ma=K}K=N;do{R=m+(K<<2)|0;J=K;K=f[R>>2]|0;f[R>>2]=Ma}while((K|0)<(J|0));K=f[x+(H<<2)>>2]|0;N=Ma;while(1){J=f[m+(N<<2)>>2]|0;if((J|0)<(N|0))N=J;else break}if((Ma|0)==(K|0))Na=N;else{H=K;while(1){J=f[m+(H<<2)>>2]|0;if((J|0)<(H|0))H=J;else break}J=(N|0)>(H|0)?H:N;R=K;do{L=m+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=J}while((R|0)<(P|0));Na=J}J=Ma;do{R=m+(J<<2)|0;K=J;J=f[R>>2]|0;f[R>>2]=Na}while((J|0)<(K|0));f[x+(C<<2)>>2]=Na;I=D;break}if(G?b[s+Q>>0]|0:0){J=C+2|0;do if(!((J|0)>=(h|0)|A)){if(!(b[v+J>>0]|0))break;K=C+-2|0;do if((K|0)>-1){if(!(b[s+K>>0]|0))break;if(b[v+E>>0]|0){do if(B){if(!(b[w+Q>>0]|0))break;R=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=R;I=D;break a}N=f[r+(J<<2)>>2]|0;H=N;while(1){P=f[m+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((N|0)==(R|0))Oa=H;else{P=R;while(1){L=f[m+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(H|0)>(P|0)?P:H;M=R;do{S=m+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=L}while((M|0)<(X|0));Oa=L}L=N;do{M=m+(L<<2)|0;R=L;L=f[M>>2]|0;f[M>>2]=Oa}while((L|0)<(R|0));f[x+(C<<2)>>2]=Oa;I=D;break a}while(0);L=f[r+(J<<2)>>2]|0;N=f[x+(K<<2)>>2]|0;R=L;while(1){M=f[m+(R<<2)>>2]|0;if((M|0)<(R|0))R=M;else break}if((L|0)==(N|0))Pa=R;else{M=N;while(1){H=f[m+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(R|0)>(M|0)?M:R;P=N;do{X=m+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=H}while((P|0)<(S|0));Pa=H}H=L;do{P=m+(H<<2)|0;N=H;H=f[P>>2]|0;f[P>>2]=Pa}while((H|0)<(N|0));f[x+(C<<2)>>2]=Pa;I=D;break a}do if(B){if(!(b[w+Q>>0]|0))break;if(!(b[v+K>>0]|0)){H=f[r+(J<<2)>>2]|0;L=f[x+(K<<2)>>2]|0;N=H;while(1){P=f[m+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((H|0)==(L|0))Qa=N;else{P=L;while(1){R=f[m+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(N|0)>(P|0)?P:N;M=L;do{S=m+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=R}while((M|0)<(X|0));Qa=R}R=H;do{M=m+(R<<2)|0;L=R;R=f[M>>2]|0;f[M>>2]=Qa}while((R|0)<(L|0));f[x+(C<<2)>>2]=Qa;I=D;break a}if(!(b[w+E>>0]|0)){R=f[r+(J<<2)>>2]|0;H=f[x+(K<<2)>>2]|0;L=R;while(1){M=f[m+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((R|0)==(H|0))Ra=L;else{M=H;while(1){N=f[m+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(L|0)>(M|0)?M:L;P=H;do{X=m+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=N}while((P|0)<(S|0));Ra=N}N=R;do{P=m+(N<<2)|0;H=N;N=f[P>>2]|0;f[P>>2]=Ra}while((N|0)<(H|0));f[x+(C<<2)>>2]=Ra;I=D;break a}N=f[x+(K<<2)>>2]|0;if(b[v+C>>0]|0){f[x+(C<<2)>>2]=N;I=D;break a}if(b[w+C>>0]|0){f[x+(C<<2)>>2]=N;I=D;break a}R=f[r+(J<<2)>>2]|0;H=R;while(1){P=f[m+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((R|0)==(N|0))Sa=H;else{P=N;while(1){L=f[m+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(H|0)>(P|0)?P:H;M=N;do{S=m+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=L}while((M|0)<(X|0));Sa=L}L=R;do{M=m+(L<<2)|0;N=L;L=f[M>>2]|0;f[M>>2]=Sa}while((L|0)<(N|0));f[x+(C<<2)>>2]=Sa;I=D;break a}while(0);if(!(b[v+C>>0]|0)){L=f[r+(J<<2)>>2]|0;R=f[x+(K<<2)>>2]|0;N=L;while(1){M=f[m+(N<<2)>>2]|0;if((M|0)<(N|0))N=M;else break}if((L|0)==(R|0))Ta=N;else{M=R;while(1){H=f[m+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(N|0)>(M|0)?M:N;P=R;do{X=m+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=H}while((P|0)<(S|0));Ta=H}H=L;do{P=m+(H<<2)|0;R=H;H=f[P>>2]|0;f[P>>2]=Ta}while((H|0)<(R|0));f[x+(C<<2)>>2]=Ta;I=D;break a}if(!(b[v+K>>0]|0)){H=f[r+(C<<2)>>2]|0;L=f[r+(J<<2)>>2]|0;R=H;while(1){P=f[m+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((H|0)==(L|0))Ua=R;else{P=L;while(1){N=f[m+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(R|0)>(P|0)?P:R;M=L;do{S=m+(M<<2)|0;X=M;M=f[S>>2]|0;f[S>>2]=N}while((M|0)<(X|0));Ua=N}N=H;do{M=m+(N<<2)|0;L=N;N=f[M>>2]|0;f[M>>2]=Ua}while((N|0)<(L|0));N=f[x+(K<<2)>>2]|0;H=Ua;while(1){L=f[m+(H<<2)>>2]|0;if((L|0)<(H|0))H=L;else break}if((Ua|0)==(N|0))Va=H;else{L=N;while(1){M=f[m+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(H|0)>(L|0)?L:H;R=N;do{P=m+(R<<2)|0;X=R;R=f[P>>2]|0;f[P>>2]=M}while((R|0)<(X|0));Va=M}M=Ua;do{R=m+(M<<2)|0;N=M;M=f[R>>2]|0;f[R>>2]=Va}while((M|0)<(N|0));f[x+(C<<2)>>2]=Va;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;M=f[r+(J<<2)>>2]|0;N=f[x+(K<<2)>>2]|0;R=M;while(1){H=f[m+(R<<2)>>2]|0;if((H|0)<(R|0))R=H;else break}if((M|0)==(N|0))Wa=R;else{H=N;while(1){L=f[m+(H<<2)>>2]|0;if((L|0)<(H|0))H=L;else break}L=(R|0)>(H|0)?H:R;X=N;do{P=m+(X<<2)|0;S=X;X=f[P>>2]|0;f[P>>2]=L}while((X|0)<(S|0));Wa=L}L=M;do{X=m+(L<<2)|0;N=L;L=f[X>>2]|0;f[X>>2]=Wa}while((L|0)<(N|0));f[x+(C<<2)>>2]=Wa;I=D;break a}while(0);L=f[r+(C<<2)>>2]|0;M=f[r+(J<<2)>>2]|0;N=L;while(1){X=f[m+(N<<2)>>2]|0;if((X|0)<(N|0))N=X;else break}if((L|0)==(M|0))Xa=N;else{X=M;while(1){R=f[m+(X<<2)>>2]|0;if((R|0)<(X|0))X=R;else break}R=(N|0)>(X|0)?X:N;H=M;do{S=m+(H<<2)|0;P=H;H=f[S>>2]|0;f[S>>2]=R}while((H|0)<(P|0));Xa=R}R=L;do{H=m+(R<<2)|0;M=R;R=f[H>>2]|0;f[H>>2]=Xa}while((R|0)<(M|0));R=f[x+(K<<2)>>2]|0;L=Xa;while(1){M=f[m+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((Xa|0)==(R|0))Ya=L;else{M=R;while(1){H=f[m+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(L|0)>(M|0)?M:L;N=R;do{X=m+(N<<2)|0;P=N;N=f[X>>2]|0;f[X>>2]=H}while((N|0)<(P|0));Ya=H}H=Xa;do{N=m+(H<<2)|0;R=H;H=f[N>>2]|0;f[N>>2]=Ya}while((H|0)<(R|0));f[x+(C<<2)>>2]=Ya;I=D;break a}while(0);if(b[v+C>>0]|0){do if(B){if(!(b[w+Q>>0]|0))break;H=f[r+(J<<2)>>2]|0;R=f[x+(K<<2)>>2]|0;N=H;while(1){L=f[m+(N<<2)>>2]|0;if((L|0)<(N|0))N=L;else break}if((H|0)==(R|0))Za=N;else{L=R;while(1){M=f[m+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(N|0)>(L|0)?L:N;P=R;do{X=m+(P<<2)|0;S=P;P=f[X>>2]|0;f[X>>2]=M}while((P|0)<(S|0));Za=M}M=H;do{P=m+(M<<2)|0;R=M;M=f[P>>2]|0;f[P>>2]=Za}while((M|0)<(R|0));f[x+(C<<2)>>2]=Za;I=D;break a}while(0);M=f[r+(C<<2)>>2]|0;H=f[r+(J<<2)>>2]|0;R=M;while(1){P=f[m+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((M|0)==(H|0))_a=R;else{P=H;while(1){N=f[m+(P<<2)>>2]|0;if((N|0)<(P|0))P=N;else break}N=(R|0)>(P|0)?P:R;L=H;do{S=m+(L<<2)|0;X=L;L=f[S>>2]|0;f[S>>2]=N}while((L|0)<(X|0));_a=N}N=M;do{L=m+(N<<2)|0;H=N;N=f[L>>2]|0;f[L>>2]=_a}while((N|0)<(H|0));N=f[x+(K<<2)>>2]|0;M=_a;while(1){H=f[m+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}if((_a|0)==(N|0))$a=M;else{H=N;while(1){L=f[m+(H<<2)>>2]|0;if((L|0)<(H|0))H=L;else break}L=(M|0)>(H|0)?H:M;R=N;do{P=m+(R<<2)|0;X=R;R=f[P>>2]|0;f[P>>2]=L}while((R|0)<(X|0));$a=L}L=_a;do{R=m+(L<<2)|0;N=L;L=f[R>>2]|0;f[R>>2]=$a}while((L|0)<(N|0));f[x+(C<<2)>>2]=$a;I=D;break a}if(!(b[v+E>>0]|0)){L=f[r+(J<<2)>>2]|0;N=f[x+(K<<2)>>2]|0;R=L;while(1){M=f[m+(R<<2)>>2]|0;if((M|0)<(R|0))R=M;else break}if((L|0)==(N|0))ab=R;else{M=N;while(1){H=f[m+(M<<2)>>2]|0;if((H|0)<(M|0))M=H;else break}H=(R|0)>(M|0)?M:R;X=N;do{P=m+(X<<2)|0;S=X;X=f[P>>2]|0;f[P>>2]=H}while((X|0)<(S|0));ab=H}H=L;do{X=m+(H<<2)|0;N=H;H=f[X>>2]|0;f[X>>2]=ab}while((H|0)<(N|0));f[x+(C<<2)>>2]=ab;I=D;break a}do if(B){if(!(b[w+Q>>0]|0))break;H=f[r+(J<<2)>>2]|0;if(b[w+C>>0]|0){L=f[x+(K<<2)>>2]|0;N=H;while(1){X=f[m+(N<<2)>>2]|0;if((X|0)<(N|0))N=X;else break}if((H|0)==(L|0))bb=N;else{X=L;while(1){R=f[m+(X<<2)>>2]|0;if((R|0)<(X|0))X=R;else break}R=(N|0)>(X|0)?X:N;M=L;do{S=m+(M<<2)|0;P=M;M=f[S>>2]|0;f[S>>2]=R}while((M|0)<(P|0));bb=R}R=H;do{M=m+(R<<2)|0;L=R;R=f[M>>2]|0;f[M>>2]=bb}while((R|0)<(L|0));f[x+(C<<2)>>2]=bb;I=D;break a}R=f[r+(K<<2)>>2]|0;L=R;while(1){M=f[m+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((R|0)==(H|0))cb=L;else{M=H;while(1){N=f[m+(M<<2)>>2]|0;if((N|0)<(M|0))M=N;else break}N=(L|0)>(M|0)?M:L;X=H;do{P=m+(X<<2)|0;S=X;X=f[P>>2]|0;f[P>>2]=N}while((X|0)<(S|0));cb=N}N=R;do{X=m+(N<<2)|0;H=N;N=f[X>>2]|0;f[X>>2]=cb}while((N|0)<(H|0));N=f[x+(K<<2)>>2]|0;R=cb;while(1){H=f[m+(R<<2)>>2]|0;if((H|0)<(R|0))R=H;else break}if((cb|0)==(N|0))db=R;else{H=N;while(1){X=f[m+(H<<2)>>2]|0;if((X|0)<(H|0))H=X;else break}X=(R|0)>(H|0)?H:R;L=N;do{M=m+(L<<2)|0;S=L;L=f[M>>2]|0;f[M>>2]=X}while((L|0)<(S|0));db=X}X=cb;do{L=m+(X<<2)|0;N=X;X=f[L>>2]|0;f[L>>2]=db}while((X|0)<(N|0));f[x+(C<<2)>>2]=db;I=D;break a}while(0);X=f[r+(K<<2)>>2]|0;N=f[r+(J<<2)>>2]|0;L=X;while(1){R=f[m+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((X|0)==(N|0))eb=L;else{R=N;while(1){H=f[m+(R<<2)>>2]|0;if((H|0)<(R|0))R=H;else break}H=(L|0)>(R|0)?R:L;S=N;do{M=m+(S<<2)|0;P=S;S=f[M>>2]|0;f[M>>2]=H}while((S|0)<(P|0));eb=H}H=X;do{S=m+(H<<2)|0;N=H;H=f[S>>2]|0;f[S>>2]=eb}while((H|0)<(N|0));H=f[x+(K<<2)>>2]|0;X=eb;while(1){N=f[m+(X<<2)>>2]|0;if((N|0)<(X|0))X=N;else break}if((eb|0)==(H|0))fb=X;else{K=H;while(1){N=f[m+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(X|0)>(K|0)?K:X;S=H;do{L=m+(S<<2)|0;R=S;S=f[L>>2]|0;f[L>>2]=N}while((S|0)<(R|0));fb=N}N=eb;do{S=m+(N<<2)|0;H=N;N=f[S>>2]|0;f[S>>2]=fb}while((N|0)<(H|0));f[x+(C<<2)>>2]=fb;I=D;break a}while(0);do if(z){J=C+-2|0;if(b[v+E>>0]|0){Q=f[x+(J<<2)>>2]|0;do if((J|0)>-1){if(!(b[s+J>>0]|0))break;f[x+(C<<2)>>2]=Q;I=D;break a}while(0);G=f[r+(J<<2)>>2]|0;N=G;while(1){H=f[m+(N<<2)>>2]|0;if((H|0)<(N|0))N=H;else break}if((G|0)==(Q|0))gb=N;else{H=Q;while(1){S=f[m+(H<<2)>>2]|0;if((S|0)<(H|0))H=S;else break}S=(N|0)>(H|0)?H:N;X=Q;do{K=m+(X<<2)|0;R=X;X=f[K>>2]|0;f[K>>2]=S}while((X|0)<(R|0));gb=S}S=G;do{X=m+(S<<2)|0;Q=S;S=f[X>>2]|0;f[X>>2]=gb}while((S|0)<(Q|0));f[x+(C<<2)>>2]=gb;I=D;break a}if(!(b[v+C>>0]|0)){hb=J;break}do if((J|0)>-1){if(!(b[s+J>>0]|0))break;if(!(b[v+J>>0]|0)){S=f[r+(C<<2)>>2]|0;G=f[x+(J<<2)>>2]|0;Q=S;while(1){X=f[m+(Q<<2)>>2]|0;if((X|0)<(Q|0))Q=X;else break}if((S|0)==(G|0))ib=Q;else{X=G;while(1){N=f[m+(X<<2)>>2]|0;if((N|0)<(X|0))X=N;else break}N=(Q|0)>(X|0)?X:Q;H=G;do{R=m+(H<<2)|0;K=H;H=f[R>>2]|0;f[R>>2]=N}while((H|0)<(K|0));ib=N}N=S;do{H=m+(N<<2)|0;G=N;N=f[H>>2]|0;f[H>>2]=ib}while((N|0)<(G|0));f[x+(C<<2)>>2]=ib;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[x+(J<<2)>>2];I=D;break a}while(0);N=f[r+(C<<2)>>2]|0;S=f[x+(J<<2)>>2]|0;G=N;while(1){H=f[m+(G<<2)>>2]|0;if((H|0)<(G|0))G=H;else break}if((N|0)==(S|0))jb=G;else{H=S;while(1){Q=f[m+(H<<2)>>2]|0;if((Q|0)<(H|0))H=Q;else break}Q=(G|0)>(H|0)?H:G;X=S;do{K=m+(X<<2)|0;R=X;X=f[K>>2]|0;f[K>>2]=Q}while((X|0)<(R|0));jb=Q}Q=N;do{X=m+(Q<<2)|0;S=Q;Q=f[X>>2]|0;f[X>>2]=jb}while((Q|0)<(S|0));f[x+(C<<2)>>2]=jb;I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;N=f[x+(J<<2)>>2]|0;S=Q;while(1){X=f[m+(S<<2)>>2]|0;if((X|0)<(S|0))S=X;else break}if((Q|0)==(N|0))kb=S;else{J=N;while(1){X=f[m+(J<<2)>>2]|0;if((X|0)<(J|0))J=X;else break}X=(S|0)>(J|0)?J:S;G=N;do{H=m+(G<<2)|0;R=G;G=f[H>>2]|0;f[H>>2]=X}while((G|0)<(R|0));kb=X}X=Q;do{G=m+(X<<2)|0;N=X;X=f[G>>2]|0;f[G>>2]=kb}while((X|0)<(N|0));f[x+(C<<2)>>2]=kb;I=D;break a}else hb=C+-2|0;while(0);f[x+(C<<2)>>2]=f[x+(hb<<2)>>2];I=D;break}do if(z){X=C+-2|0;if(b[v+E>>0]|0){Q=f[x+(X<<2)>>2]|0;do if((X|0)>-1){if(!(b[s+X>>0]|0))break;f[x+(C<<2)>>2]=Q;I=D;break a}while(0);N=f[r+(X<<2)>>2]|0;G=N;while(1){S=f[m+(G<<2)>>2]|0;if((S|0)<(G|0))G=S;else break}if((N|0)==(Q|0))lb=G;else{S=Q;while(1){J=f[m+(S<<2)>>2]|0;if((J|0)<(S|0))S=J;else break}J=(G|0)>(S|0)?S:G;R=Q;do{H=m+(R<<2)|0;K=R;R=f[H>>2]|0;f[H>>2]=J}while((R|0)<(K|0));lb=J}J=N;do{R=m+(J<<2)|0;Q=J;J=f[R>>2]|0;f[R>>2]=lb}while((J|0)<(Q|0));f[x+(C<<2)>>2]=lb;I=D;break a}if(!(b[v+C>>0]|0)){mb=X;break}do if((X|0)>-1){if(!(b[s+X>>0]|0))break;if(!(b[v+X>>0]|0)){J=f[r+(C<<2)>>2]|0;N=f[x+(X<<2)>>2]|0;Q=J;while(1){R=f[m+(Q<<2)>>2]|0;if((R|0)<(Q|0))Q=R;else break}if((J|0)==(N|0))nb=Q;else{R=N;while(1){G=f[m+(R<<2)>>2]|0;if((G|0)<(R|0))R=G;else break}G=(Q|0)>(R|0)?R:Q;S=N;do{K=m+(S<<2)|0;H=S;S=f[K>>2]|0;f[K>>2]=G}while((S|0)<(H|0));nb=G}G=J;do{S=m+(G<<2)|0;N=G;G=f[S>>2]|0;f[S>>2]=nb}while((G|0)<(N|0));f[x+(C<<2)>>2]=nb;I=D;break a}do if(B){if(!(b[w+E>>0]|0))break;f[x+(C<<2)>>2]=f[x+(X<<2)>>2];I=D;break a}while(0);G=f[r+(C<<2)>>2]|0;J=f[x+(X<<2)>>2]|0;N=G;while(1){S=f[m+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((G|0)==(J|0))ob=N;else{S=J;while(1){Q=f[m+(S<<2)>>2]|0;if((Q|0)<(S|0))S=Q;else break}Q=(N|0)>(S|0)?S:N;R=J;do{H=m+(R<<2)|0;K=R;R=f[H>>2]|0;f[H>>2]=Q}while((R|0)<(K|0));ob=Q}Q=G;do{R=m+(Q<<2)|0;J=Q;Q=f[R>>2]|0;f[R>>2]=ob}while((Q|0)<(J|0));f[x+(C<<2)>>2]=ob;I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;G=f[x+(X<<2)>>2]|0;J=Q;while(1){R=f[m+(J<<2)>>2]|0;if((R|0)<(J|0))J=R;else break}if((Q|0)==(G|0))pb=J;else{X=G;while(1){R=f[m+(X<<2)>>2]|0;if((R|0)<(X|0))X=R;else break}R=(J|0)>(X|0)?X:J;N=G;do{S=m+(N<<2)|0;K=N;N=f[S>>2]|0;f[S>>2]=R}while((N|0)<(K|0));pb=R}R=Q;do{N=m+(R<<2)|0;G=R;R=f[N>>2]|0;f[N>>2]=pb}while((R|0)<(G|0));f[x+(C<<2)>>2]=pb;I=D;break a}else mb=C+-2|0;while(0);f[x+(C<<2)>>2]=f[x+(mb<<2)>>2];I=D;break}}R=C|1;Q=(R|0)<(h|0);if(!(A|Q^1)?b[v+R>>0]|0:0){if(b[v+C>>0]|0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}if(F?b[v+E>>0]|0:0){G=f[r+(C<<2)>>2]|0;do if(B){if(!(b[w+C>>0]|0))break;f[x+(C<<2)>>2]=G;I=D;break a}while(0);N=f[r+(C+-2<<2)>>2]|0;J=N;while(1){X=f[m+(J<<2)>>2]|0;if((X|0)<(J|0))J=X;else break}if((N|0)==(G|0))qb=J;else{X=G;while(1){K=f[m+(X<<2)>>2]|0;if((K|0)<(X|0))X=K;else break}K=(J|0)>(X|0)?X:J;S=G;do{H=m+(S<<2)|0;L=S;S=f[H>>2]|0;f[H>>2]=K}while((S|0)<(L|0));qb=K}K=N;do{S=m+(K<<2)|0;G=K;K=f[S>>2]|0;f[S>>2]=qb}while((K|0)<(G|0));f[x+(C<<2)>>2]=qb;I=D;break}f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}if(Q?b[s+R>>0]|0:0){K=C+2|0;if(!((K|0)>=(h|0)|A)?b[v+K>>0]|0:0){if(b[v+C>>0]|0){do if(B){if(!(b[w+R>>0]|0))break;f[x+(C<<2)>>2]=f[r+(K<<2)>>2];I=D;break a}while(0);Q=f[r+(C<<2)>>2]|0;N=f[r+(K<<2)>>2]|0;G=Q;while(1){S=f[m+(G<<2)>>2]|0;if((S|0)<(G|0))G=S;else break}if((Q|0)==(N|0))rb=G;else{S=N;while(1){J=f[m+(S<<2)>>2]|0;if((J|0)<(S|0))S=J;else break}J=(G|0)>(S|0)?S:G;X=N;do{L=m+(X<<2)|0;H=X;X=f[L>>2]|0;f[L>>2]=J}while((X|0)<(H|0));rb=J}J=Q;do{X=m+(J<<2)|0;N=J;J=f[X>>2]|0;f[X>>2]=rb}while((J|0)<(N|0));f[x+(C<<2)>>2]=rb;I=D;break}do if(F){if(!(b[v+E>>0]|0))break;do if(B){if(!(b[w+R>>0]|0))break;J=f[r+(K<<2)>>2]|0;if(b[w+C>>0]|0){f[x+(C<<2)>>2]=J;I=D;break a}Q=f[r+(C+-2<<2)>>2]|0;N=Q;while(1){X=f[m+(N<<2)>>2]|0;if((X|0)<(N|0))N=X;else break}if((Q|0)==(J|0))sb=N;else{X=J;while(1){G=f[m+(X<<2)>>2]|0;if((G|0)<(X|0))X=G;else break}G=(N|0)>(X|0)?X:N;S=J;do{H=m+(S<<2)|0;L=S;S=f[H>>2]|0;f[H>>2]=G}while((S|0)<(L|0));sb=G}G=Q;do{S=m+(G<<2)|0;J=G;G=f[S>>2]|0;f[S>>2]=sb}while((G|0)<(J|0));f[x+(C<<2)>>2]=sb;I=D;break a}while(0);G=f[r+(C+-2<<2)>>2]|0;Q=f[r+(K<<2)>>2]|0;J=G;while(1){S=f[m+(J<<2)>>2]|0;if((S|0)<(J|0))J=S;else break}if((G|0)==(Q|0))tb=J;else{S=Q;while(1){N=f[m+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(J|0)>(S|0)?S:J;X=Q;do{L=m+(X<<2)|0;H=X;X=f[L>>2]|0;f[L>>2]=N}while((X|0)<(H|0));tb=N}N=G;do{X=m+(N<<2)|0;Q=N;N=f[X>>2]|0;f[X>>2]=tb}while((N|0)<(Q|0));f[x+(C<<2)>>2]=tb;I=D;break a}while(0);f[x+(C<<2)>>2]=f[r+(K<<2)>>2];I=D;break}if(z?b[v+C>>0]|0:0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}do if(!(A|F^1)){if(!(b[v+E>>0]|0))break;f[x+(C<<2)>>2]=f[r+(C+-2<<2)>>2];I=D;break a}while(0);f[x+(C<<2)>>2]=D;f[m+(D<<2)>>2]=D;I=D+1|0;break}if(z?b[v+C>>0]|0:0){f[x+(C<<2)>>2]=f[r+(C<<2)>>2];I=D;break}if(!(A|F^1)?b[v+E>>0]|0:0){f[x+(C<<2)>>2]=f[r+(C+-2<<2)>>2];I=D;break}f[x+(C<<2)>>2]=D;f[m+(D<<2)>>2]=D;I=D+1|0}while(0);C=C+2|0;if((C|0)>=(h|0)){ub=I;break}else D=I}}else ub=p;q=q+2|0;if((q|0)>=(a|0))break;else p=ub}if((ub|0)>1){p=1;a=1;while(1){q=m+(a<<2)|0;I=f[q>>2]|0;if((I|0)<(a|0)){f[q>>2]=f[m+(I<<2)>>2];vb=p}else{f[q>>2]=p;vb=p+1|0}a=a+1|0;if((a|0)==(ub|0)){wb=vb;break}else p=vb}}else wb=1}else wb=1;vb=f[i>>2]|0;p=f[n>>2]|0;ub=(p&1|0)!=0;a=(vb|0)>0;if(!(vb&1)){if(!ub){if(!a){UC(m);u=g;return wb|0}q=f[c+16>>2]|0;I=f[c+44>>2]|0;h=f[d+16>>2]|0;tb=f[d+44>>2]|0;sb=0;rb=p;qb=vb;while(1){mb=f[I>>2]|0;pb=q+(Y(mb,sb)|0)|0;ob=pb+mb|0;mb=f[tb>>2]|0;nb=h+(Y(mb,sb)|0)|0;lb=nb+mb|0;if((rb|0)>0){mb=0;do{hb=nb+(mb<<2)|0;kb=f[hb>>2]|0;do if((kb|0)>0){jb=f[m+(kb<<2)>>2]|0;f[hb>>2]=(b[pb+mb>>0]|0)==0?0:jb;ib=mb|1;f[nb+(ib<<2)>>2]=(b[pb+ib>>0]|0)==0?0:jb;f[lb+(mb<<2)>>2]=(b[ob+mb>>0]|0)==0?0:jb;gb=lb+(ib<<2)|0;if(!(b[ob+ib>>0]|0)){f[gb>>2]=0;break}else{f[gb>>2]=jb;break}}else{f[hb>>2]=0;jb=mb|1;f[nb+(jb<<2)>>2]=0;f[lb+(mb<<2)>>2]=0;f[lb+(jb<<2)>>2]=0}while(0);mb=mb+2|0;xb=f[n>>2]|0}while((mb|0)<(xb|0));yb=f[i>>2]|0;zb=xb}else{yb=qb;zb=rb}sb=sb+2|0;if((sb|0)>=(yb|0))break;else{rb=zb;qb=yb}}UC(m);u=g;return wb|0}if(!a){UC(m);u=g;return wb|0}yb=f[c+16>>2]|0;qb=f[c+44>>2]|0;zb=f[d+16>>2]|0;rb=f[d+44>>2]|0;sb=0;xb=p;h=vb;while(1){tb=f[qb>>2]|0;q=yb+(Y(tb,sb)|0)|0;I=q+tb|0;tb=f[rb>>2]|0;mb=zb+(Y(tb,sb)|0)|0;lb=mb+tb|0;if((xb|0)>0){tb=0;do{nb=mb+(tb<<2)|0;ob=f[nb>>2]|0;do if((ob|0)>0){pb=f[m+(ob<<2)>>2]|0;f[nb>>2]=(b[q+tb>>0]|0)==0?0:pb;f[lb+(tb<<2)>>2]=(b[I+tb>>0]|0)==0?0:pb;hb=tb|1;if((hb|0)<(f[n>>2]|0)){f[mb+(hb<<2)>>2]=(b[q+hb>>0]|0)==0?0:pb;kb=lb+(hb<<2)|0;if(!(b[I+hb>>0]|0)){f[kb>>2]=0;break}else{f[kb>>2]=pb;break}}}else{f[nb>>2]=0;f[lb+(tb<<2)>>2]=0;pb=tb|1;if((pb|0)<(f[n>>2]|0)){f[mb+(pb<<2)>>2]=0;f[lb+(pb<<2)>>2]=0}}while(0);tb=tb+2|0;Ab=f[n>>2]|0}while((tb|0)<(Ab|0));Bb=f[i>>2]|0;Cb=Ab}else{Bb=h;Cb=xb}sb=sb+2|0;if((sb|0)>=(Bb|0))break;else{xb=Cb;h=Bb}}UC(m);u=g;return wb|0}if(!ub){if(!a){UC(m);u=g;return wb|0}ub=f[c+16>>2]|0;Bb=f[c+44>>2]|0;h=f[d+16>>2]|0;Cb=f[d+44>>2]|0;xb=0;sb=p;Ab=vb;while(1){zb=f[Bb>>2]|0;rb=ub+(Y(zb,xb)|0)|0;yb=rb+zb|0;zb=f[Cb>>2]|0;qb=h+(Y(zb,xb)|0)|0;tb=qb+zb|0;if((sb|0)>0){zb=xb|1;lb=0;do{mb=qb+(lb<<2)|0;I=f[mb>>2]|0;do if((I|0)>0){q=f[m+(I<<2)>>2]|0;f[mb>>2]=(b[rb+lb>>0]|0)==0?0:q;nb=lb|1;f[qb+(nb<<2)>>2]=(b[rb+nb>>0]|0)==0?0:q;if((zb|0)<(f[i>>2]|0)){f[tb+(lb<<2)>>2]=(b[yb+lb>>0]|0)==0?0:q;ob=tb+(nb<<2)|0;if(!(b[yb+nb>>0]|0)){f[ob>>2]=0;break}else{f[ob>>2]=q;break}}}else{f[mb>>2]=0;q=lb|1;f[qb+(q<<2)>>2]=0;if((zb|0)<(f[i>>2]|0)){f[tb+(lb<<2)>>2]=0;f[tb+(q<<2)>>2]=0}}while(0);lb=lb+2|0;Db=f[n>>2]|0}while((lb|0)<(Db|0));Eb=f[i>>2]|0;Fb=Db}else{Eb=Ab;Fb=sb}xb=xb+2|0;if((xb|0)>=(Eb|0))break;else{sb=Fb;Ab=Eb}}UC(m);u=g;return wb|0}if(!a){UC(m);u=g;return wb|0}a=f[c+16>>2]|0;Eb=f[c+44>>2]|0;c=f[d+16>>2]|0;Ab=f[d+44>>2]|0;d=0;Fb=p;p=vb;while(1){vb=f[Eb>>2]|0;sb=a+(Y(vb,d)|0)|0;xb=sb+vb|0;vb=f[Ab>>2]|0;Db=c+(Y(vb,d)|0)|0;h=Db+vb|0;if((Fb|0)>0){vb=d|1;Cb=0;do{ub=Db+(Cb<<2)|0;Bb=f[ub>>2]|0;do if((Bb|0)>0){lb=f[m+(Bb<<2)>>2]|0;f[ub>>2]=(b[sb+Cb>>0]|0)==0?0:lb;tb=Cb|1;if((tb|0)<(f[n>>2]|0)){f[Db+(tb<<2)>>2]=(b[sb+tb>>0]|0)==0?0:lb;if((vb|0)>=(f[i>>2]|0))break;f[h+(Cb<<2)>>2]=(b[xb+Cb>>0]|0)==0?0:lb;zb=h+(tb<<2)|0;if(!(b[xb+tb>>0]|0)){f[zb>>2]=0;break}else{f[zb>>2]=lb;break}}else{if((vb|0)>=(f[i>>2]|0))break;zb=h+(Cb<<2)|0;if(!(b[xb+Cb>>0]|0)){f[zb>>2]=0;break}else{f[zb>>2]=lb;break}}}else{f[ub>>2]=0;lb=Cb|1;if((lb|0)<(f[n>>2]|0)){f[Db+(lb<<2)>>2]=0;if((vb|0)>=(f[i>>2]|0))break;f[h+(Cb<<2)>>2]=0;f[h+(lb<<2)>>2]=0;break}else{if((vb|0)>=(f[i>>2]|0))break;f[h+(Cb<<2)>>2]=0;break}}while(0);Cb=Cb+2|0;Gb=f[n>>2]|0}while((Cb|0)<(Gb|0));Hb=f[i>>2]|0;Ib=Gb}else{Hb=p;Ib=Fb}d=d+2|0;if((d|0)>=(Hb|0))break;else{Fb=Ib;p=Hb}}UC(m);u=g;return wb|0}function P3(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;a=u;u=u+64|0;h=a+48|0;i=a+28|0;j=a;k=c+8|0;if((f[k>>2]|0)!=(f[d+8>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;l=aD(h,26)|0;m=235286;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,h,489445,235014,2529);bD(h)}o=c+12|0;if((f[o>>2]|0)!=(f[d+12>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;l=aD(h,26)|0;m=235313;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,h,489445,235014,2530);bD(h)}if((e|0)!=8){f[h>>2]=0;f[h+4>>2]=0;l=aD(h,17)|0;m=235340;n=l+17|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,h,489445,235014,2531);bD(h)}m=UQ()|0;l=f[k>>2]|0;k=((f[o>>2]|0)+1|0)/2|0;o=TC(l<<2)|0;n=TC((Y(((l+1|0)/2|0)<<2,k)|0)+4|0)|0;f[n>>2]=0;f[h>>2]=0;f[h+4>>2]=l;f[i>>2]=51892;f[i+4>>2]=c;f[i+8>>2]=d;f[i+12>>2]=n;f[i+16>>2]=o;p=+(m|0);RQ(h,i,p);Q3(c,d,n,o);f[i>>2]=1;if((l|0)>0)q=0;else{r=(l|0)>-1;s=r?l:-1;t=N5b(s)|0;f[j>>2]=51912;v=j+4|0;f[v>>2]=c;w=j+8|0;f[w>>2]=d;x=j+12|0;f[x>>2]=n;y=j+16|0;f[y>>2]=g;z=j+20|0;f[z>>2]=t;A=j+24|0;f[A>>2]=i;RQ(h,j,p);P5b(t);UC(o);UC(n);B=f[i>>2]|0;u=a;return B|0}do{m=q+1|0;e=(Y((m|0)/2|0,k)|0)+1|0;C=f[o+(m<<2)>>2]|0;m=C+e|0;if((C|0)>0){C=e;do{e=n+(C<<2)|0;D=f[e>>2]|0;if((D|0)<(C|0))f[e>>2]=f[n+(D<<2)>>2];else{f[e>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}C=C+1|0}while((C|0)<(m|0))}q=f[o+(q<<2)>>2]|0}while((q|0)<(l|0));r=(l|0)>-1;s=r?l:-1;t=N5b(s)|0;f[j>>2]=51912;v=j+4|0;f[v>>2]=c;w=j+8|0;f[w>>2]=d;x=j+12|0;f[x>>2]=n;y=j+16|0;f[y>>2]=g;z=j+20|0;f[z>>2]=t;A=j+24|0;f[A>>2]=i;RQ(h,j,p);P5b(t);UC(o);UC(n);B=f[i>>2]|0;u=a;return B|0}function Q3(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=f[c+12>>2]|0;h=f[c+8>>2]|0;i=f[e>>2]|0;if((i|0)>=(h|0))return;j=(g|0)>0;k=g+-1|0;l=g+-2|0;m=f[c+16>>2]|0;n=f[c+44>>2]|0;c=f[a+16>>2]|0;o=f[a+44>>2]|0;a=i;do{i=f[n>>2]|0;p=m+(Y(i,a)|0)|0;q=0-i|0;i=p+q+q|0;q=f[o>>2]|0;r=c+(Y(q,a)|0)|0;s=r+(0-q)|0;if(j){q=0;do{t=p+(q<<2)|0;u=f[t>>2]|0;if((u|0)>0){if((((q|0)>1?(v=f[i+(q+-2<<2)>>2]|0,(v|0)>0):0)?(b[r+q>>0]|0)!=0:0)?(b[s+(q+-1)>>0]|0)!=0:0){w=v;while(1){x=f[d+(w<<2)>>2]|0;if((x|0)<(w|0))w=x;else break}if((v|0)==(u|0))y=w;else{x=u;while(1){z=f[d+(x<<2)>>2]|0;if((z|0)<(x|0))x=z;else break}z=(w|0)>(x|0)?x:w;A=u;do{B=d+(A<<2)|0;C=A;A=f[B>>2]|0;f[B>>2]=z}while((A|0)<(C|0));y=z}z=v;do{A=d+(z<<2)|0;w=z;z=f[A>>2]|0;f[A>>2]=y}while((z|0)<(w|0));f[t>>2]=y;D=y}else D=u;z=f[i+(q<<2)>>2]|0;a:do if((z|0)>0){v=b[r+q>>0]|0;w=v<<24>>24!=0;if((q|0)>=(k|0)){if(!w){E=D;break}if(!(b[s+q>>0]|0)){E=D;break}else F=z;while(1){A=f[d+(F<<2)>>2]|0;if((A|0)<(F|0))F=A;else break}if((z|0)==(D|0))G=F;else{A=D;while(1){x=f[d+(A<<2)>>2]|0;if((x|0)<(A|0))A=x;else break}x=(F|0)>(A|0)?A:F;C=D;do{B=d+(C<<2)|0;H=C;C=f[B>>2]|0;f[B>>2]=x}while((C|0)<(H|0));G=x}x=z;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=G}while((x|0)<(A|0));f[t>>2]=G;E=G;break}if(w?(b[s+q>>0]|0)!=0:0)I=z;else J=23;do if((J|0)==23){J=0;x=q|1;A=(b[r+x>>0]|0)!=0;if(A?b[s+q>>0]|0:0){I=z;break}if(v<<24>>24?b[s+x>>0]|0:0){I=z;break}if(!A){E=D;break a}if(!(b[s+x>>0]|0)){E=D;break a}else I=z}while(0);while(1){v=f[d+(I<<2)>>2]|0;if((v|0)<(I|0))I=v;else break}if((z|0)==(D|0))K=I;else{v=D;while(1){w=f[d+(v<<2)>>2]|0;if((w|0)<(v|0))v=w;else break}w=(I|0)>(v|0)?v:I;x=D;do{A=d+(x<<2)|0;C=x;x=f[A>>2]|0;f[A>>2]=w}while((x|0)<(C|0));K=w}w=z;do{x=d+(w<<2)|0;v=w;w=f[x>>2]|0;f[x>>2]=K}while((w|0)<(v|0));f[t>>2]=K;E=K}else E=D;while(0);if((((q|0)<(l|0)?(z=q+2|0,u=f[i+(z<<2)>>2]|0,(u|0)>0):0)?b[r+(q|1)>>0]|0:0)?b[s+z>>0]|0:0){z=u;while(1){w=f[d+(z<<2)>>2]|0;if((w|0)<(z|0))z=w;else break}if((u|0)==(E|0))L=z;else{w=E;while(1){v=f[d+(w<<2)>>2]|0;if((v|0)<(w|0))w=v;else break}v=(z|0)>(w|0)?w:z;x=E;do{C=d+(x<<2)|0;A=x;x=f[C>>2]|0;f[C>>2]=v}while((x|0)<(A|0));L=v}v=u;do{x=d+(v<<2)|0;z=v;v=f[x>>2]|0;f[x>>2]=L}while((v|0)<(z|0));f[t>>2]=L}}q=q+2|0}while((q|0)<(g|0))}a=f[e+(a<<2)>>2]|0}while((a|0)<(h|0));return}function R3(a){a=a|0;O5b(a);return}function S3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=f[c+4>>2]|0;c=((d|0)%2|0)+d|0;d=a+8|0;g=f[d>>2]|0;h=(f[g+8>>2]&1|0)==0;i=f[g+12>>2]|0;j=(i&1|0)!=0;k=(e|0)<(c|0);if((e|0)>0){if(h){if(!j){if(!k)return;l=a+4|0;m=a+12|0;n=e;o=g;p=i;while(1){q=f[l>>2]|0;r=f[f[q+44>>2]>>2]|0;s=(f[q+16>>2]|0)+(Y(r,n)|0)|0;q=s+r|0;r=f[f[o+44>>2]>>2]|0;t=(f[o+16>>2]|0)+(Y(r,n)|0)|0;u=t+r|0;if((p|0)>0){r=0;do{v=t+(r<<2)|0;w=f[v>>2]|0;do if((w|0)>0){x=f[(f[m>>2]|0)+(w<<2)>>2]|0;f[v>>2]=(b[s+r>>0]|0)==0?0:x;y=r|1;f[t+(y<<2)>>2]=(b[s+y>>0]|0)==0?0:x;f[u+(r<<2)>>2]=(b[q+r>>0]|0)==0?0:x;z=u+(y<<2)|0;if(!(b[q+y>>0]|0)){f[z>>2]=0;break}else{f[z>>2]=x;break}}else{f[v>>2]=0;x=r|1;f[t+(x<<2)>>2]=0;f[u+(r<<2)>>2]=0;f[u+(x<<2)>>2]=0}while(0);r=r+2|0;v=f[d>>2]|0;w=f[v+12>>2]|0}while((r|0)<(w|0));A=w;B=v}else{A=p;B=o}n=n+2|0;if((n|0)>=(c|0))break;else{o=B;p=A}}return}if(!k)return;A=a+4|0;p=a+12|0;B=e;o=g;n=i;while(1){m=f[A>>2]|0;l=f[f[m+44>>2]>>2]|0;r=(f[m+16>>2]|0)+(Y(l,B)|0)|0;m=r+l|0;l=f[f[o+44>>2]>>2]|0;u=(f[o+16>>2]|0)+(Y(l,B)|0)|0;t=u+l|0;if((n|0)>0){l=0;do{q=u+(l<<2)|0;s=f[q>>2]|0;do if((s|0)>0){v=f[(f[p>>2]|0)+(s<<2)>>2]|0;f[q>>2]=(b[r+l>>0]|0)==0?0:v;f[t+(l<<2)>>2]=(b[m+l>>0]|0)==0?0:v;w=l|1;if((w|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[u+(w<<2)>>2]=(b[r+w>>0]|0)==0?0:v;x=t+(w<<2)|0;if(!(b[m+w>>0]|0)){f[x>>2]=0;break}else{f[x>>2]=v;break}}}else{f[q>>2]=0;f[t+(l<<2)>>2]=0;v=l|1;if((v|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[u+(v<<2)>>2]=0;f[t+(v<<2)>>2]=0}}while(0);l=l+2|0;q=f[d>>2]|0;s=f[q+12>>2]|0}while((l|0)<(s|0));C=s;D=q}else{C=n;D=o}B=B+2|0;if((B|0)>=(c|0))break;else{o=D;n=C}}return}if(!j){if(!k)return;C=a+4|0;n=a+12|0;D=e;o=g;B=i;while(1){p=f[C>>2]|0;A=f[f[p+44>>2]>>2]|0;l=(f[p+16>>2]|0)+(Y(A,D)|0)|0;p=l+A|0;A=f[f[o+44>>2]>>2]|0;t=(f[o+16>>2]|0)+(Y(A,D)|0)|0;u=t+A|0;if((B|0)>0){A=D+1|0;m=0;do{r=t+(m<<2)|0;q=f[r>>2]|0;do if((q|0)>0){s=f[(f[n>>2]|0)+(q<<2)>>2]|0;f[r>>2]=(b[l+m>>0]|0)==0?0:s;v=m|1;f[t+(v<<2)>>2]=(b[l+v>>0]|0)==0?0:s;if((A|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[u+(m<<2)>>2]=(b[p+m>>0]|0)==0?0:s;x=u+(v<<2)|0;if(!(b[p+v>>0]|0)){f[x>>2]=0;break}else{f[x>>2]=s;break}}}else{f[r>>2]=0;s=m|1;f[t+(s<<2)>>2]=0;if((A|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[u+(m<<2)>>2]=0;f[u+(s<<2)>>2]=0}}while(0);m=m+2|0;r=f[d>>2]|0;q=f[r+12>>2]|0}while((m|0)<(q|0));E=q;F=r}else{E=B;F=o}D=D+2|0;if((D|0)>=(c|0))break;else{o=F;B=E}}return}if(!k)return;E=a+4|0;B=a+12|0;F=e;o=g;D=i;while(1){n=f[E>>2]|0;C=f[f[n+44>>2]>>2]|0;m=(f[n+16>>2]|0)+(Y(C,F)|0)|0;n=m+C|0;C=f[f[o+44>>2]>>2]|0;u=(f[o+16>>2]|0)+(Y(C,F)|0)|0;A=u+C|0;if((D|0)>0){C=F+1|0;t=0;do{p=u+(t<<2)|0;l=f[p>>2]|0;do if((l|0)>0){r=f[(f[B>>2]|0)+(l<<2)>>2]|0;f[p>>2]=(b[m+t>>0]|0)==0?0:r;q=t|1;s=f[d>>2]|0;if((q|0)<(f[s+12>>2]|0)){f[u+(q<<2)>>2]=(b[m+q>>0]|0)==0?0:r;if((C|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[A+(t<<2)>>2]=(b[n+t>>0]|0)==0?0:r;x=A+(q<<2)|0;if(!(b[n+q>>0]|0)){f[x>>2]=0;break}else{f[x>>2]=r;break}}else{if((C|0)>=(f[s+8>>2]|0))break;s=A+(t<<2)|0;if(!(b[n+t>>0]|0)){f[s>>2]=0;break}else{f[s>>2]=r;break}}}else{f[p>>2]=0;r=t|1;s=f[d>>2]|0;if((r|0)<(f[s+12>>2]|0)){f[u+(r<<2)>>2]=0;if((C|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[A+(t<<2)>>2]=0;f[A+(r<<2)>>2]=0;break}else{if((C|0)>=(f[s+8>>2]|0))break;f[A+(t<<2)>>2]=0;break}}while(0);t=t+2|0;p=f[d>>2]|0;l=f[p+12>>2]|0}while((t|0)<(l|0));G=l;H=p}else{G=D;H=o}F=F+2|0;if((F|0)>=(c|0))break;else{o=H;D=G}}return}else{if(h){if(!j){if(!k)return;h=a+4|0;G=a+12|0;D=e;H=g;o=i;while(1){F=f[h>>2]|0;B=f[f[F+44>>2]>>2]|0;E=(f[F+16>>2]|0)+(Y(B,D)|0)|0;F=E+B|0;B=f[f[H+44>>2]>>2]|0;t=(f[H+16>>2]|0)+(Y(B,D)|0)|0;A=t+B|0;if((o|0)>0){B=0;do{C=t+(B<<2)|0;u=f[C>>2]|0;do if((u|0)>0){n=f[(f[G>>2]|0)+(u<<2)>>2]|0;f[C>>2]=(b[E+B>>0]|0)==0?0:n;m=B|1;f[t+(m<<2)>>2]=(b[E+m>>0]|0)==0?0:n;f[A+(B<<2)>>2]=(b[F+B>>0]|0)==0?0:n;p=A+(m<<2)|0;if(!(b[F+m>>0]|0)){f[p>>2]=0;break}else{f[p>>2]=n;break}}else{f[C>>2]=0;n=B|1;f[t+(n<<2)>>2]=0;f[A+(B<<2)>>2]=0;f[A+(n<<2)>>2]=0}while(0);B=B+2|0;C=f[d>>2]|0;u=f[C+12>>2]|0}while((B|0)<(u|0));I=u;J=C}else{I=o;J=H}D=D+2|0;if((D|0)>=(c|0))break;else{H=J;o=I}}return}if(!k)return;I=a+4|0;o=a+12|0;J=e;H=g;D=i;while(1){G=f[I>>2]|0;h=f[f[G+44>>2]>>2]|0;B=(f[G+16>>2]|0)+(Y(h,J)|0)|0;G=B+h|0;h=f[f[H+44>>2]>>2]|0;A=(f[H+16>>2]|0)+(Y(h,J)|0)|0;t=A+h|0;if((D|0)>0){h=0;do{F=A+(h<<2)|0;E=f[F>>2]|0;do if((E|0)>0){C=f[(f[o>>2]|0)+(E<<2)>>2]|0;f[F>>2]=(b[B+h>>0]|0)==0?0:C;f[t+(h<<2)>>2]=(b[G+h>>0]|0)==0?0:C;u=h|1;if((u|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[A+(u<<2)>>2]=(b[B+u>>0]|0)==0?0:C;n=t+(u<<2)|0;if(!(b[G+u>>0]|0)){f[n>>2]=0;break}else{f[n>>2]=C;break}}}else{f[F>>2]=0;f[t+(h<<2)>>2]=0;C=h|1;if((C|0)<(f[(f[d>>2]|0)+12>>2]|0)){f[A+(C<<2)>>2]=0;f[t+(C<<2)>>2]=0}}while(0);h=h+2|0;F=f[d>>2]|0;E=f[F+12>>2]|0}while((h|0)<(E|0));K=E;L=F}else{K=D;L=H}J=J+2|0;if((J|0)>=(c|0))break;else{H=L;D=K}}return}if(!j){if(!k)return;j=a+4|0;K=a+12|0;D=e;L=g;H=i;while(1){J=f[j>>2]|0;o=f[f[J+44>>2]>>2]|0;I=(f[J+16>>2]|0)+(Y(o,D)|0)|0;J=I+o|0;o=f[f[L+44>>2]>>2]|0;h=(f[L+16>>2]|0)+(Y(o,D)|0)|0;t=h+o|0;if((H|0)>0){o=D+1|0;A=0;do{G=h+(A<<2)|0;B=f[G>>2]|0;do if((B|0)>0){F=f[(f[K>>2]|0)+(B<<2)>>2]|0;f[G>>2]=(b[I+A>>0]|0)==0?0:F;E=A|1;f[h+(E<<2)>>2]=(b[I+E>>0]|0)==0?0:F;if((o|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[t+(A<<2)>>2]=(b[J+A>>0]|0)==0?0:F;C=t+(E<<2)|0;if(!(b[J+E>>0]|0)){f[C>>2]=0;break}else{f[C>>2]=F;break}}}else{f[G>>2]=0;F=A|1;f[h+(F<<2)>>2]=0;if((o|0)<(f[(f[d>>2]|0)+8>>2]|0)){f[t+(A<<2)>>2]=0;f[t+(F<<2)>>2]=0}}while(0);A=A+2|0;G=f[d>>2]|0;B=f[G+12>>2]|0}while((A|0)<(B|0));M=B;N=G}else{M=H;N=L}D=D+2|0;if((D|0)>=(c|0))break;else{L=N;H=M}}return}if(!k)return;k=a+4|0;M=a+12|0;a=e;e=g;g=i;while(1){i=f[k>>2]|0;H=f[f[i+44>>2]>>2]|0;N=(f[i+16>>2]|0)+(Y(H,a)|0)|0;i=N+H|0;H=f[f[e+44>>2]>>2]|0;L=(f[e+16>>2]|0)+(Y(H,a)|0)|0;D=L+H|0;if((g|0)>0){H=a+1|0;K=0;do{j=L+(K<<2)|0;A=f[j>>2]|0;do if((A|0)>0){t=f[(f[M>>2]|0)+(A<<2)>>2]|0;f[j>>2]=(b[N+K>>0]|0)==0?0:t;o=K|1;h=f[d>>2]|0;if((o|0)<(f[h+12>>2]|0)){f[L+(o<<2)>>2]=(b[N+o>>0]|0)==0?0:t;if((H|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[D+(K<<2)>>2]=(b[i+K>>0]|0)==0?0:t;J=D+(o<<2)|0;if(!(b[i+o>>0]|0)){f[J>>2]=0;break}else{f[J>>2]=t;break}}else{if((H|0)>=(f[h+8>>2]|0))break;h=D+(K<<2)|0;if(!(b[i+K>>0]|0)){f[h>>2]=0;break}else{f[h>>2]=t;break}}}else{f[j>>2]=0;t=K|1;h=f[d>>2]|0;if((t|0)<(f[h+12>>2]|0)){f[L+(t<<2)>>2]=0;if((H|0)>=(f[(f[d>>2]|0)+8>>2]|0))break;f[D+(K<<2)>>2]=0;f[D+(t<<2)>>2]=0;break}else{if((H|0)>=(f[h+8>>2]|0))break;f[D+(K<<2)>>2]=0;break}}while(0);K=K+2|0;j=f[d>>2]|0;A=f[j+12>>2]|0}while((K|0)<(A|0));O=A;P=j}else{O=g;P=e}a=a+2|0;if((a|0)>=(c|0))break;else{e=P;g=O}}return}}function T3(a){a=a|0;O5b(a);return}function U3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0;d=f[c>>2]|0;e=((d|0)%2|0)+d|0;d=c+4|0;c=f[d>>2]|0;g=a+16|0;h=f[g>>2]|0;f[h+(e<<2)>>2]=((c|0)%2|0)+c;c=e+1|0;i=a+8|0;j=(Y(((f[(f[i>>2]|0)+12>>2]|0)+1|0)/2|0,(c|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+8>>2]|0;n=f[l+12>>2]|0;if((e|0)>=(f[d>>2]|0)){o=j;p=h;q=o-j|0;r=p+(c<<2)|0;f[r>>2]=q;return}h=(n|0)>0;l=a+12|0;a=e;s=j;while(1){t=f[k>>2]|0;u=f[f[t+44>>2]>>2]|0;v=(f[t+16>>2]|0)+(Y(u,a)|0)|0;t=0-u|0;w=v+t|0;x=w+t|0;t=v+u|0;u=f[i>>2]|0;y=f[f[u+44>>2]>>2]|0;z=(f[u+16>>2]|0)+(Y(y,a)|0)|0;u=0-y|0;y=z+u+u|0;if(h){u=(a+1|0)<(m|0);A=(a|0)>(e|0);B=A^1;C=(a|0)>(c|0);D=0;E=s;while(1){a:do if(!(b[v+D>>0]|0)){F=D|1;G=(F|0)<(n|0);if(u?b[t+D>>0]|0:0){H=D+-1|0;I=(D|0)>0;if(G?b[v+F>>0]|0:0){if(I){if(b[v+H>>0]|0){do if(A){if(b[w+F>>0]|0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;K=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}do if((K|0)>-1){if(!(b[w+K>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(K<<2)>>2];J=E;break a}L=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;N=f[z+(K<<2)>>2]|0;O=M;while(1){P=f[L+(O<<2)>>2]|0;if((P|0)<(O|0))O=P;else break}if((M|0)==(N|0))Q=O;else{P=N;while(1){R=f[L+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(O|0)>(P|0)?P:O;S=N;do{T=L+(S<<2)|0;U=S;S=f[T>>2]|0;f[T>>2]=R}while((S|0)<(U|0));Q=R}R=M;do{S=L+(R<<2)|0;N=R;R=f[S>>2]|0;f[S>>2]=Q}while((R|0)<(N|0));f[z+(D<<2)>>2]=Q;J=E;break a}while(0);R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[z+(K<<2)>>2]|0;N=L;while(1){S=f[R+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((L|0)==(M|0))V=N;else{K=M;while(1){S=f[R+(K<<2)>>2]|0;if((S|0)<(K|0))K=S;else break}S=(N|0)>(K|0)?K:N;O=M;do{P=R+(O<<2)|0;U=O;O=f[P>>2]|0;f[P>>2]=S}while((O|0)<(U|0));V=S}S=L;do{O=R+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=V}while((S|0)<(M|0));f[z+(D<<2)>>2]=V;J=E;break a}while(0);S=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;M=R;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((R|0)==(L|0))W=M;else{O=L;while(1){N=f[S+(O<<2)>>2]|0;if((N|0)<(O|0))O=N;else break}N=(M|0)>(O|0)?O:M;K=L;do{U=S+(K<<2)|0;P=K;K=f[U>>2]|0;f[U>>2]=N}while((K|0)<(P|0));W=N}N=R;do{K=S+(N<<2)|0;L=N;N=f[K>>2]|0;f[K>>2]=W}while((N|0)<(L|0));f[z+(D<<2)>>2]=W;J=E;break a}N=D+2|0;if((N|0)>=(n|0))break;if(!(b[w+N>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(D+-2<<2)>>2]|0;K=R;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((R|0)==(L|0))X=K;else{M=L;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;P=L;do{U=S+(P<<2)|0;T=P;P=f[U>>2]|0;f[U>>2]=O}while((P|0)<(T|0));X=O}O=R;do{P=S+(O<<2)|0;L=O;O=f[P>>2]|0;f[P>>2]=X}while((O|0)<(L|0));f[z+(D<<2)>>2]=X;J=E;break a}O=D+-2|0;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}do if((O|0)>-1){if(!(b[w+O>>0]|0))break;if(b[x+H>>0]|0){f[z+(D<<2)>>2]=f[z+(O<<2)>>2];J=E;break a}S=f[l>>2]|0;R=f[y+(N<<2)>>2]|0;L=f[z+(O<<2)>>2]|0;P=R;while(1){K=f[S+(P<<2)>>2]|0;if((K|0)<(P|0))P=K;else break}if((R|0)==(L|0))Z=P;else{K=L;while(1){M=f[S+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}M=(P|0)>(K|0)?K:P;T=L;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=M}while((T|0)<(_|0));Z=M}M=R;do{T=S+(M<<2)|0;L=M;M=f[T>>2]|0;f[T>>2]=Z}while((M|0)<(L|0));f[z+(D<<2)>>2]=Z;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(N<<2)>>2]|0;R=f[z+(O<<2)>>2]|0;L=S;while(1){T=f[M+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((S|0)==(R|0))$=L;else{O=R;while(1){T=f[M+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}T=(L|0)>(O|0)?O:L;P=R;do{K=M+(P<<2)|0;_=P;P=f[K>>2]|0;f[K>>2]=T}while((P|0)<(_|0));$=T}T=S;do{P=M+(T<<2)|0;R=T;T=f[P>>2]|0;f[P>>2]=$}while((T|0)<(R|0));f[z+(D<<2)>>2]=$;J=E;break a}while(0);T=f[l>>2]|0;M=f[y+(N<<2)>>2]|0;S=f[z+(D+-2<<2)>>2]|0;R=M;while(1){P=f[T+(R<<2)>>2]|0;if((P|0)<(R|0))R=P;else break}if((M|0)==(S|0))aa=R;else{N=S;while(1){P=f[T+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;L=S;do{O=T+(L<<2)|0;_=L;L=f[O>>2]|0;f[O>>2]=P}while((L|0)<(_|0));aa=P}P=M;do{L=T+(P<<2)|0;S=P;P=f[L>>2]|0;f[L>>2]=aa}while((P|0)<(S|0));f[z+(D<<2)>>2]=aa;J=E;break a}while(0);f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[t+H>>0]|0){do if(A){if(b[w+F>>0]|0){P=D+-2|0;do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=T;J=E;break a}while(0);M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=S;while(1){R=f[M+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((S|0)==(T|0))ba=L;else{R=T;while(1){N=f[M+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}N=(L|0)>(R|0)?R:L;_=T;do{O=M+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=N}while((_|0)<(K|0));ba=N}N=S;do{_=M+(N<<2)|0;T=N;N=f[_>>2]|0;f[_>>2]=ba}while((N|0)<(T|0));f[z+(D<<2)>>2]=ba;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(P<<2)>>2]|0;T=M;while(1){_=f[N+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((M|0)==(S|0))ca=T;else{_=S;while(1){L=f[N+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(T|0)>(_|0)?_:T;R=S;do{K=N+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=L}while((R|0)<(O|0));ca=L}L=M;do{R=N+(L<<2)|0;S=L;L=f[R>>2]|0;f[R>>2]=ca}while((L|0)<(S|0));f[z+(D<<2)>>2]=ca;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;L=f[z+(P<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}N=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=M;while(1){R=f[N+(S<<2)>>2]|0;if((R|0)<(S|0))S=R;else break}if((M|0)==(L|0))da=S;else{R=L;while(1){T=f[N+(R<<2)>>2]|0;if((T|0)<(R|0))R=T;else break}T=(S|0)>(R|0)?R:S;_=L;do{O=N+(_<<2)|0;K=_;_=f[O>>2]|0;f[O>>2]=T}while((_|0)<(K|0));da=T}T=M;do{_=N+(T<<2)|0;L=T;T=f[_>>2]|0;f[_>>2]=da}while((T|0)<(L|0));f[z+(D<<2)>>2]=da;J=E;break a}while(0);T=f[l>>2]|0;N=f[y+(D<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;L=N;while(1){_=f[T+(L<<2)>>2]|0;if((_|0)<(L|0))L=_;else break}if((N|0)==(M|0))ea=L;else{_=M;while(1){S=f[T+(_<<2)>>2]|0;if((S|0)<(_|0))_=S;else break}S=(L|0)>(_|0)?_:L;R=M;do{K=T+(R<<2)|0;O=R;R=f[K>>2]|0;f[K>>2]=S}while((R|0)<(O|0));ea=S}S=N;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ea}while((S|0)<(M|0));f[z+(D<<2)>>2]=ea;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;N=f[z+(P<<2)>>2]|0;M=T;while(1){R=f[S+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}if((T|0)==(N|0))fa=M;else{P=N;while(1){R=f[S+(P<<2)>>2]|0;if((R|0)<(P|0))P=R;else break}R=(M|0)>(P|0)?P:M;L=N;do{_=S+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(O|0));fa=R}R=T;do{L=S+(R<<2)|0;N=R;R=f[L>>2]|0;f[L>>2]=fa}while((R|0)<(N|0));f[z+(D<<2)>>2]=fa;J=E;break a}R=D+2|0;do if(!((R|0)>=(n|0)|B)){if(!(b[w+R>>0]|0))break;do if(C){if(!(b[x+F>>0]|0))break;S=D+-2|0;do if((S|0)>-1){if(!(b[v+S>>0]|0))break;if(b[w+H>>0]|0){T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}N=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=L;while(1){P=f[N+(M<<2)>>2]|0;if((P|0)<(M|0))M=P;else break}if((L|0)==(T|0))ga=M;else{P=T;while(1){O=f[N+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}O=(M|0)>(P|0)?P:M;_=T;do{K=N+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=O}while((_|0)<(U|0));ga=O}O=L;do{_=N+(O<<2)|0;T=O;O=f[_>>2]|0;f[_>>2]=ga}while((O|0)<(T|0));f[z+(D<<2)>>2]=ga;J=E;break a}if(!(b[w+S>>0]|0)){O=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;L=f[z+(S<<2)>>2]|0;T=N;while(1){_=f[O+(T<<2)>>2]|0;if((_|0)<(T|0))T=_;else break}if((N|0)==(L|0))ha=T;else{_=L;while(1){M=f[O+(_<<2)>>2]|0;if((M|0)<(_|0))_=M;else break}M=(T|0)>(_|0)?_:T;P=L;do{U=O+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=M}while((P|0)<(K|0));ha=M}M=N;do{P=O+(M<<2)|0;L=M;M=f[P>>2]|0;f[P>>2]=ha}while((M|0)<(L|0));f[z+(D<<2)>>2]=ha;J=E;break a}if(!(b[x+H>>0]|0)){M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=f[z+(S<<2)>>2]|0;L=O;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}if((O|0)==(N|0))ia=L;else{P=N;while(1){T=f[M+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(L|0)>(P|0)?P:L;_=N;do{K=M+(_<<2)|0;U=_;_=f[K>>2]|0;f[K>>2]=T}while((_|0)<(U|0));ia=T}T=O;do{_=M+(T<<2)|0;N=T;T=f[_>>2]|0;f[_>>2]=ia}while((T|0)<(N|0));f[z+(D<<2)>>2]=ia;J=E;break a}T=f[z+(S<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=T;J=E;break a}M=f[l>>2]|0;O=f[y+(R<<2)>>2]|0;N=O;while(1){_=f[M+(N<<2)>>2]|0;if((_|0)<(N|0))N=_;else break}if((O|0)==(T|0))ja=N;else{_=T;while(1){L=f[M+(_<<2)>>2]|0;if((L|0)<(_|0))_=L;else break}L=(N|0)>(_|0)?_:N;P=T;do{U=M+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=L}while((P|0)<(K|0));ja=L}L=O;do{P=M+(L<<2)|0;T=L;L=f[P>>2]|0;f[P>>2]=ja}while((L|0)<(T|0));f[z+(D<<2)>>2]=ja;J=E;break a}while(0);L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(S<<2)>>2]|0;T=M;while(1){P=f[L+(T<<2)>>2]|0;if((P|0)<(T|0))T=P;else break}if((M|0)==(O|0))ka=T;else{S=O;while(1){P=f[L+(S<<2)>>2]|0;if((P|0)<(S|0))S=P;else break}P=(T|0)>(S|0)?S:T;N=O;do{_=L+(N<<2)|0;K=N;N=f[_>>2]|0;f[_>>2]=P}while((N|0)<(K|0));ka=P}P=M;do{N=L+(P<<2)|0;O=P;P=f[N>>2]|0;f[N>>2]=ka}while((P|0)<(O|0));f[z+(D<<2)>>2]=ka;J=E;break a}while(0);P=D+-2|0;if(!(b[w+D>>0]|0)){L=f[l>>2]|0;M=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;N=M;while(1){T=f[L+(N<<2)>>2]|0;if((T|0)<(N|0))N=T;else break}if((M|0)==(O|0))la=N;else{T=O;while(1){S=f[L+(T<<2)>>2]|0;if((S|0)<(T|0))T=S;else break}S=(N|0)>(T|0)?T:N;K=O;do{_=L+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=S}while((K|0)<(U|0));la=S}S=M;do{K=L+(S<<2)|0;O=S;S=f[K>>2]|0;f[K>>2]=la}while((S|0)<(O|0));f[z+(D<<2)>>2]=la;J=E;break a}do if((P|0)>-1){if(!(b[v+P>>0]|0))break;if(b[w+H>>0]|0){S=f[l>>2]|0;L=f[y+(R<<2)>>2]|0;M=f[z+(P<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))ma=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));ma=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=ma}while((N|0)<(M|0));f[z+(D<<2)>>2]=ma;J=E;break a}if(!(b[w+P>>0]|0)){N=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;L=f[y+(R<<2)>>2]|0;M=S;while(1){T=f[N+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((S|0)==(L|0))na=M;else{T=L;while(1){O=f[N+(T<<2)>>2]|0;if((O|0)<(T|0))T=O;else break}O=(M|0)>(T|0)?T:M;K=L;do{_=N+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=O}while((K|0)<(U|0));na=O}O=S;do{K=N+(O<<2)|0;L=O;O=f[K>>2]|0;f[K>>2]=na}while((O|0)<(L|0));O=f[z+(P<<2)>>2]|0;S=na;while(1){L=f[N+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((na|0)==(O|0))oa=S;else{L=O;while(1){K=f[N+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(S|0)>(L|0)?L:S;M=O;do{T=N+(M<<2)|0;U=M;M=f[T>>2]|0;f[T>>2]=K}while((M|0)<(U|0));oa=K}K=na;do{M=N+(K<<2)|0;O=K;K=f[M>>2]|0;f[M>>2]=oa}while((K|0)<(O|0));f[z+(D<<2)>>2]=oa;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;K=f[l>>2]|0;N=f[y+(R<<2)>>2]|0;O=f[z+(P<<2)>>2]|0;M=N;while(1){S=f[K+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}if((N|0)==(O|0))pa=M;else{S=O;while(1){L=f[K+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}L=(M|0)>(S|0)?S:M;U=O;do{T=K+(U<<2)|0;_=U;U=f[T>>2]|0;f[T>>2]=L}while((U|0)<(_|0));pa=L}L=N;do{U=K+(L<<2)|0;O=L;L=f[U>>2]|0;f[U>>2]=pa}while((L|0)<(O|0));f[z+(D<<2)>>2]=pa;J=E;break a}while(0);L=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;N=f[y+(R<<2)>>2]|0;O=K;while(1){U=f[L+(O<<2)>>2]|0;if((U|0)<(O|0))O=U;else break}if((K|0)==(N|0))qa=O;else{U=N;while(1){M=f[L+(U<<2)>>2]|0;if((M|0)<(U|0))U=M;else break}M=(O|0)>(U|0)?U:O;S=N;do{_=L+(S<<2)|0;T=S;S=f[_>>2]|0;f[_>>2]=M}while((S|0)<(T|0));qa=M}M=K;do{S=L+(M<<2)|0;N=M;M=f[S>>2]|0;f[S>>2]=qa}while((M|0)<(N|0));M=f[z+(P<<2)>>2]|0;K=qa;while(1){N=f[L+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}if((qa|0)==(M|0))ra=K;else{N=M;while(1){S=f[L+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}S=(K|0)>(N|0)?N:K;O=M;do{U=L+(O<<2)|0;T=O;O=f[U>>2]|0;f[U>>2]=S}while((O|0)<(T|0));ra=S}S=qa;do{O=L+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=ra}while((S|0)<(M|0));f[z+(D<<2)>>2]=ra;J=E;break a}while(0);S=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;M=f[y+(R<<2)>>2]|0;O=L;while(1){K=f[S+(O<<2)>>2]|0;if((K|0)<(O|0))O=K;else break}if((L|0)==(M|0))sa=O;else{K=M;while(1){N=f[S+(K<<2)>>2]|0;if((N|0)<(K|0))K=N;else break}N=(O|0)>(K|0)?K:O;T=M;do{U=S+(T<<2)|0;_=T;T=f[U>>2]|0;f[U>>2]=N}while((T|0)<(_|0));sa=N}N=L;do{T=S+(N<<2)|0;M=N;N=f[T>>2]|0;f[T>>2]=sa}while((N|0)<(M|0));N=f[z+(P<<2)>>2]|0;L=sa;while(1){M=f[S+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((sa|0)==(N|0))ta=L;else{P=N;while(1){M=f[S+(P<<2)>>2]|0;if((M|0)<(P|0))P=M;else break}M=(L|0)>(P|0)?P:L;T=N;do{O=S+(T<<2)|0;K=T;T=f[O>>2]|0;f[O>>2]=M}while((T|0)<(K|0));ta=M}M=sa;do{T=S+(M<<2)|0;N=M;M=f[T>>2]|0;f[T>>2]=ta}while((M|0)<(N|0));f[z+(D<<2)>>2]=ta;J=E;break a}while(0);R=D+-2|0;if(!(b[w+D>>0]|0)){ua=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(b[w+H>>0]|0){f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}if(!(b[w+R>>0]|0)){M=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;N=f[z+(R<<2)>>2]|0;T=S;while(1){L=f[M+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}if((S|0)==(N|0))va=T;else{L=N;while(1){P=f[M+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(T|0)>(L|0)?L:T;K=N;do{O=M+(K<<2)|0;_=K;K=f[O>>2]|0;f[O>>2]=P}while((K|0)<(_|0));va=P}P=S;do{K=M+(P<<2)|0;N=P;P=f[K>>2]|0;f[K>>2]=va}while((P|0)<(N|0));f[z+(D<<2)>>2]=va;J=E;break a}do if(C){if(!(b[x+H>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);P=f[l>>2]|0;M=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;N=M;while(1){K=f[P+(N<<2)>>2]|0;if((K|0)<(N|0))N=K;else break}if((M|0)==(S|0))wa=N;else{K=S;while(1){T=f[P+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}T=(N|0)>(K|0)?K:N;L=S;do{_=P+(L<<2)|0;O=L;L=f[_>>2]|0;f[_>>2]=T}while((L|0)<(O|0));wa=T}T=M;do{L=P+(T<<2)|0;S=T;T=f[L>>2]|0;f[L>>2]=wa}while((T|0)<(S|0));f[z+(D<<2)>>2]=wa;J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(R<<2)>>2]|0;S=P;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((P|0)==(M|0))xa=S;else{R=M;while(1){L=f[T+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}L=(S|0)>(R|0)?R:S;N=M;do{K=T+(N<<2)|0;O=N;N=f[K>>2]|0;f[K>>2]=L}while((N|0)<(O|0));xa=L}L=P;do{N=T+(L<<2)|0;M=L;L=f[N>>2]|0;f[N>>2]=xa}while((L|0)<(M|0));f[z+(D<<2)>>2]=xa;J=E;break a}else ua=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(ua<<2)>>2];J=E;break}}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}L=D+2|0;if(!((L|0)>=(n|0)|B)?b[w+L>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(L<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(L<<2)>>2]|0;N=P;while(1){S=f[T+(N<<2)>>2]|0;if((S|0)<(N|0))N=S;else break}if((P|0)==(M|0))ya=N;else{L=M;while(1){S=f[T+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(N|0)>(L|0)?L:N;R=M;do{O=T+(R<<2)|0;K=R;R=f[O>>2]|0;f[O>>2]=S}while((R|0)<(K|0));ya=S}S=P;do{R=T+(S<<2)|0;M=S;S=f[R>>2]|0;f[R>>2]=ya}while((S|0)<(M|0));f[z+(D<<2)>>2]=ya;J=E;break}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(I){if(b[t+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(b[v+H>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}do if(G){if(!(b[v+F>>0]|0)){if(!u)break;if(!(b[t+F>>0]|0))break;f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}if(A){if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){if(!(b[w+D>>0]|0)){f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[y+(S<<2)>>2];J=E;break a}while(0);T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[y+(S<<2)>>2]|0;R=P;while(1){N=f[T+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((P|0)==(M|0))za=R;else{S=M;while(1){N=f[T+(S<<2)>>2]|0;if((N|0)<(S|0))S=N;else break}N=(R|0)>(S|0)?S:R;L=M;do{K=T+(L<<2)|0;O=L;L=f[K>>2]|0;f[K>>2]=N}while((L|0)<(O|0));za=N}N=P;do{L=T+(N<<2)|0;M=N;N=f[L>>2]|0;f[L>>2]=za}while((N|0)<(M|0));f[z+(D<<2)>>2]=za;J=E;break a}if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break a}}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break a}while(0);f[z+(D<<2)>>2]=0;J=E}else{F=D+-1|0;G=(D|0)>0;if(G){if(b[v+F>>0]|0){H=D|1;I=(H|0)<(n|0);if(A&I?b[w+H>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(C?b[x+D>>0]|0:0){N=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break}do if((N|0)>-1){if(!(b[w+N>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(N<<2)>>2];J=E;break a}T=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=f[z+(N<<2)>>2]|0;L=P;while(1){R=f[T+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((P|0)==(M|0))Aa=L;else{R=M;while(1){S=f[T+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}S=(L|0)>(R|0)?R:L;O=M;do{K=T+(O<<2)|0;_=O;O=f[K>>2]|0;f[K>>2]=S}while((O|0)<(_|0));Aa=S}S=P;do{O=T+(S<<2)|0;M=S;S=f[O>>2]|0;f[O>>2]=Aa}while((S|0)<(M|0));f[z+(D<<2)>>2]=Aa;J=E;break a}while(0);S=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;P=f[z+(N<<2)>>2]|0;M=T;while(1){O=f[S+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}if((T|0)==(P|0))Ba=M;else{N=P;while(1){O=f[S+(N<<2)>>2]|0;if((O|0)<(N|0))N=O;else break}O=(M|0)>(N|0)?N:M;L=P;do{R=S+(L<<2)|0;_=L;L=f[R>>2]|0;f[R>>2]=O}while((L|0)<(_|0));Ba=O}O=T;do{L=S+(O<<2)|0;P=O;O=f[L>>2]|0;f[L>>2]=Ba}while((O|0)<(P|0));f[z+(D<<2)>>2]=Ba;J=E;break}O=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;P=S;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((S|0)==(T|0))Ca=P;else{L=T;while(1){M=f[O+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(P|0)>(L|0)?L:P;N=T;do{_=O+(N<<2)|0;R=N;N=f[_>>2]|0;f[_>>2]=M}while((N|0)<(R|0));Ca=M}M=S;do{N=O+(M<<2)|0;T=M;M=f[N>>2]|0;f[N>>2]=Ca}while((M|0)<(T|0));f[z+(D<<2)>>2]=Ca;J=E;break}if(I?b[v+H>>0]|0:0){M=D+2|0;if(A&(M|0)<(n|0)?b[w+M>>0]|0:0){do if(C){if(!(b[x+H>>0]|0))break;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break a}if(!(b[x+D>>0]|0)){O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(D+-2<<2)>>2]|0;N=S;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}if((S|0)==(T|0))Da=N;else{P=T;while(1){L=f[O+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}L=(N|0)>(P|0)?P:N;R=T;do{_=O+(R<<2)|0;K=R;R=f[_>>2]|0;f[_>>2]=L}while((R|0)<(K|0));Da=L}L=S;do{R=O+(L<<2)|0;T=L;L=f[R>>2]|0;f[R>>2]=Da}while((L|0)<(T|0));f[z+(D<<2)>>2]=Da;J=E;break a}L=D+-2|0;if(b[w+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}do if((L|0)>-1){if(!(b[w+L>>0]|0))break;if(b[x+F>>0]|0){f[z+(D<<2)>>2]=f[z+(L<<2)>>2];J=E;break a}O=f[l>>2]|0;S=f[y+(M<<2)>>2]|0;T=f[z+(L<<2)>>2]|0;R=S;while(1){N=f[O+(R<<2)>>2]|0;if((N|0)<(R|0))R=N;else break}if((S|0)==(T|0))Ea=R;else{N=T;while(1){P=f[O+(N<<2)>>2]|0;if((P|0)<(N|0))N=P;else break}P=(R|0)>(N|0)?N:R;K=T;do{_=O+(K<<2)|0;U=K;K=f[_>>2]|0;f[_>>2]=P}while((K|0)<(U|0));Ea=P}P=S;do{K=O+(P<<2)|0;T=P;P=f[K>>2]|0;f[K>>2]=Ea}while((P|0)<(T|0));f[z+(D<<2)>>2]=Ea;J=E;break a}while(0);P=f[l>>2]|0;O=f[y+(M<<2)>>2]|0;S=f[z+(L<<2)>>2]|0;T=O;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((O|0)==(S|0))Fa=T;else{L=S;while(1){K=f[P+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(T|0)>(L|0)?L:T;R=S;do{N=P+(R<<2)|0;U=R;R=f[N>>2]|0;f[N>>2]=K}while((R|0)<(U|0));Fa=K}K=O;do{R=P+(K<<2)|0;S=K;K=f[R>>2]|0;f[R>>2]=Fa}while((K|0)<(S|0));f[z+(D<<2)>>2]=Fa;J=E;break a}while(0);H=f[l>>2]|0;I=f[y+(M<<2)>>2]|0;K=f[z+(D+-2<<2)>>2]|0;P=I;while(1){O=f[H+(P<<2)>>2]|0;if((O|0)<(P|0))P=O;else break}if((I|0)==(K|0))Ga=P;else{M=K;while(1){O=f[H+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(P|0)>(M|0)?M:P;S=K;do{R=H+(S<<2)|0;T=S;S=f[R>>2]|0;f[R>>2]=O}while((S|0)<(T|0));Ga=O}O=I;do{S=H+(O<<2)|0;K=O;O=f[S>>2]|0;f[S>>2]=Ga}while((O|0)<(K|0));f[z+(D<<2)>>2]=Ga;J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=f[z+(D+-2<<2)>>2];J=E;break}if(u?b[t+F>>0]|0:0){O=D|1;H=(O|0)<(n|0);if(!(B|H^1)?b[w+O>>0]|0:0){I=D+-2|0;if((I|0)>-1?b[v+I>>0]|0:0){if(b[w+F>>0]|0){K=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break}do if(C){if(!(b[x+D>>0]|0))break;f[z+(D<<2)>>2]=K;J=E;break a}while(0);S=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;M=P;while(1){T=f[S+(M<<2)>>2]|0;if((T|0)<(M|0))M=T;else break}if((P|0)==(K|0))Ha=M;else{T=K;while(1){R=f[S+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(M|0)>(T|0)?T:M;L=K;do{U=S+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Ha=R}R=P;do{L=S+(R<<2)|0;K=R;R=f[L>>2]|0;f[L>>2]=Ha}while((R|0)<(K|0));f[z+(D<<2)>>2]=Ha;J=E;break}if(!(b[w+I>>0]|0)){R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=f[z+(I<<2)>>2]|0;K=S;while(1){L=f[R+(K<<2)>>2]|0;if((L|0)<(K|0))K=L;else break}if((S|0)==(P|0))Ia=K;else{L=P;while(1){M=f[R+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}M=(K|0)>(L|0)?L:K;T=P;do{N=R+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=M}while((T|0)<(U|0));Ia=M}M=S;do{T=R+(M<<2)|0;P=M;M=f[T>>2]|0;f[T>>2]=Ia}while((M|0)<(P|0));f[z+(D<<2)>>2]=Ia;J=E;break}do if(C){if(!(b[x+F>>0]|0))break;M=f[z+(I<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=M;J=E;break a}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;P=S;while(1){T=f[R+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}if((S|0)==(M|0))Ja=P;else{T=M;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(P|0)>(T|0)?T:P;L=M;do{U=R+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=K}while((L|0)<(N|0));Ja=K}K=S;do{L=R+(K<<2)|0;M=K;K=f[L>>2]|0;f[L>>2]=Ja}while((K|0)<(M|0));f[z+(D<<2)>>2]=Ja;J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;M=R;while(1){L=f[K+(M<<2)>>2]|0;if((L|0)<(M|0))M=L;else break}if((R|0)==(S|0))Ka=M;else{L=S;while(1){P=f[K+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(M|0)>(L|0)?L:M;T=S;do{N=K+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=P}while((T|0)<(U|0));Ka=P}P=R;do{T=K+(P<<2)|0;S=P;P=f[T>>2]|0;f[T>>2]=Ka}while((P|0)<(S|0));f[z+(D<<2)>>2]=Ka;J=E;break}if(b[w+D>>0]|0){P=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;S=K;while(1){T=f[P+(S<<2)>>2]|0;if((T|0)<(S|0))S=T;else break}if((K|0)==(R|0))La=S;else{T=R;while(1){M=f[P+(T<<2)>>2]|0;if((M|0)<(T|0))T=M;else break}M=(S|0)>(T|0)?T:S;L=R;do{U=P+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=M}while((L|0)<(N|0));La=M}M=K;do{L=P+(M<<2)|0;R=M;M=f[L>>2]|0;f[L>>2]=La}while((M|0)<(R|0));f[z+(D<<2)>>2]=La;J=E;break}if(!(b[w+F>>0]|0)){M=f[l>>2]|0;P=f[y+(D<<2)>>2]|0;K=f[z+(I<<2)>>2]|0;R=P;while(1){L=f[M+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(K|0))Ma=R;else{L=K;while(1){S=f[M+(L<<2)>>2]|0;if((S|0)<(L|0))L=S;else break}S=(R|0)>(L|0)?L:R;T=K;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=S}while((T|0)<(U|0));Ma=S}S=P;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Ma}while((S|0)<(K|0));f[z+(D<<2)>>2]=Ma;J=E;break}S=f[y+(D<<2)>>2]|0;M=f[l>>2]|0;do if(C){if(!(b[x+D>>0]|0))break;P=f[z+(I<<2)>>2]|0;K=S;while(1){T=f[M+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((S|0)==(P|0))Na=K;else{T=P;while(1){R=f[M+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(K|0)>(T|0)?T:K;L=P;do{U=M+(L<<2)|0;N=L;L=f[U>>2]|0;f[U>>2]=R}while((L|0)<(N|0));Na=R}R=S;do{L=M+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Na}while((R|0)<(P|0));f[z+(D<<2)>>2]=Na;J=E;break a}while(0);R=f[y+(I<<2)>>2]|0;P=R;while(1){L=f[M+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((R|0)==(S|0))Oa=P;else{L=S;while(1){K=f[M+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(P|0)>(L|0)?L:P;T=S;do{N=M+(T<<2)|0;U=T;T=f[N>>2]|0;f[N>>2]=K}while((T|0)<(U|0));Oa=K}K=R;do{T=M+(K<<2)|0;S=K;K=f[T>>2]|0;f[T>>2]=Oa}while((K|0)<(S|0));K=f[z+(I<<2)>>2]|0;R=Oa;while(1){S=f[M+(R<<2)>>2]|0;if((S|0)<(R|0))R=S;else break}if((Oa|0)==(K|0))Pa=R;else{I=K;while(1){S=f[M+(I<<2)>>2]|0;if((S|0)<(I|0))I=S;else break}S=(R|0)>(I|0)?I:R;T=K;do{P=M+(T<<2)|0;L=T;T=f[P>>2]|0;f[P>>2]=S}while((T|0)<(L|0));Pa=S}S=Oa;do{T=M+(S<<2)|0;K=S;S=f[T>>2]|0;f[T>>2]=Pa}while((S|0)<(K|0));f[z+(D<<2)>>2]=Pa;J=E;break}if(H?b[v+O>>0]|0:0){S=D+2|0;if(!((S|0)>=(n|0)|B)?b[w+S>>0]|0:0){M=D+-2|0;do if((M|0)>-1){if(!(b[v+M>>0]|0))break;if(b[w+F>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;K=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=K;J=E;break a}T=f[l>>2]|0;R=f[y+(S<<2)>>2]|0;I=R;while(1){L=f[T+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((R|0)==(K|0))Qa=I;else{L=K;while(1){P=f[T+(L<<2)>>2]|0;if((P|0)<(L|0))L=P;else break}P=(I|0)>(L|0)?L:I;U=K;do{N=T+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=P}while((U|0)<(_|0));Qa=P}P=R;do{U=T+(P<<2)|0;K=P;P=f[U>>2]|0;f[U>>2]=Qa}while((P|0)<(K|0));f[z+(D<<2)>>2]=Qa;J=E;break a}while(0);P=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;K=T;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((T|0)==(R|0))Ra=K;else{U=R;while(1){I=f[P+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}I=(K|0)>(U|0)?U:K;L=R;do{_=P+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=I}while((L|0)<(N|0));Ra=I}I=T;do{L=P+(I<<2)|0;R=I;I=f[L>>2]|0;f[L>>2]=Ra}while((I|0)<(R|0));f[z+(D<<2)>>2]=Ra;J=E;break a}do if(C){if(!(b[x+O>>0]|0))break;if(!(b[w+M>>0]|0)){I=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;T=f[z+(M<<2)>>2]|0;R=P;while(1){L=f[I+(R<<2)>>2]|0;if((L|0)<(R|0))R=L;else break}if((P|0)==(T|0))Sa=R;else{L=T;while(1){K=f[I+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(R|0)>(L|0)?L:R;U=T;do{N=I+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=K}while((U|0)<(_|0));Sa=K}K=P;do{U=I+(K<<2)|0;T=K;K=f[U>>2]|0;f[U>>2]=Sa}while((K|0)<(T|0));f[z+(D<<2)>>2]=Sa;J=E;break a}if(!(b[x+F>>0]|0)){K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=f[z+(M<<2)>>2]|0;T=I;while(1){U=f[K+(T<<2)>>2]|0;if((U|0)<(T|0))T=U;else break}if((I|0)==(P|0))Ta=T;else{U=P;while(1){R=f[K+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(T|0)>(U|0)?U:T;L=P;do{_=K+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=R}while((L|0)<(N|0));Ta=R}R=I;do{L=K+(R<<2)|0;P=R;R=f[L>>2]|0;f[L>>2]=Ta}while((R|0)<(P|0));f[z+(D<<2)>>2]=Ta;J=E;break a}R=f[z+(M<<2)>>2]|0;if(b[w+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}if(b[x+D>>0]|0){f[z+(D<<2)>>2]=R;J=E;break a}K=f[l>>2]|0;I=f[y+(S<<2)>>2]|0;P=I;while(1){L=f[K+(P<<2)>>2]|0;if((L|0)<(P|0))P=L;else break}if((I|0)==(R|0))Ua=P;else{L=R;while(1){T=f[K+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}T=(P|0)>(L|0)?L:P;U=R;do{N=K+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=T}while((U|0)<(_|0));Ua=T}T=I;do{U=K+(T<<2)|0;R=T;T=f[U>>2]|0;f[U>>2]=Ua}while((T|0)<(R|0));f[z+(D<<2)>>2]=Ua;J=E;break a}while(0);if(!(b[w+D>>0]|0)){T=f[l>>2]|0;K=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;R=K;while(1){U=f[T+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}if((K|0)==(I|0))Va=R;else{U=I;while(1){P=f[T+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}P=(R|0)>(U|0)?U:R;L=I;do{_=T+(L<<2)|0;N=L;L=f[_>>2]|0;f[_>>2]=P}while((L|0)<(N|0));Va=P}P=K;do{L=T+(P<<2)|0;I=P;P=f[L>>2]|0;f[L>>2]=Va}while((P|0)<(I|0));f[z+(D<<2)>>2]=Va;J=E;break a}if(!(b[w+M>>0]|0)){P=f[l>>2]|0;T=f[y+(D<<2)>>2]|0;K=f[y+(S<<2)>>2]|0;I=T;while(1){L=f[P+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(K|0))Wa=I;else{L=K;while(1){R=f[P+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}R=(I|0)>(L|0)?L:I;U=K;do{N=P+(U<<2)|0;_=U;U=f[N>>2]|0;f[N>>2]=R}while((U|0)<(_|0));Wa=R}R=T;do{U=P+(R<<2)|0;K=R;R=f[U>>2]|0;f[U>>2]=Wa}while((R|0)<(K|0));R=f[z+(M<<2)>>2]|0;T=Wa;while(1){K=f[P+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}if((Wa|0)==(R|0))Xa=T;else{K=R;while(1){U=f[P+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}U=(T|0)>(K|0)?K:T;I=R;do{L=P+(I<<2)|0;_=I;I=f[L>>2]|0;f[L>>2]=U}while((I|0)<(_|0));Xa=U}U=Wa;do{I=P+(U<<2)|0;R=U;U=f[I>>2]|0;f[I>>2]=Xa}while((U|0)<(R|0));f[z+(D<<2)>>2]=Xa;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;U=f[l>>2]|0;P=f[y+(S<<2)>>2]|0;R=f[z+(M<<2)>>2]|0;I=P;while(1){T=f[U+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}if((P|0)==(R|0))Ya=I;else{T=R;while(1){K=f[U+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(I|0)>(T|0)?T:I;_=R;do{L=U+(_<<2)|0;N=_;_=f[L>>2]|0;f[L>>2]=K}while((_|0)<(N|0));Ya=K}K=P;do{_=U+(K<<2)|0;R=K;K=f[_>>2]|0;f[_>>2]=Ya}while((K|0)<(R|0));f[z+(D<<2)>>2]=Ya;J=E;break a}while(0);K=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;P=f[y+(S<<2)>>2]|0;R=U;while(1){_=f[K+(R<<2)>>2]|0;if((_|0)<(R|0))R=_;else break}if((U|0)==(P|0))Za=R;else{_=P;while(1){I=f[K+(_<<2)>>2]|0;if((I|0)<(_|0))_=I;else break}I=(R|0)>(_|0)?_:R;T=P;do{N=K+(T<<2)|0;L=T;T=f[N>>2]|0;f[N>>2]=I}while((T|0)<(L|0));Za=I}I=U;do{T=K+(I<<2)|0;P=I;I=f[T>>2]|0;f[T>>2]=Za}while((I|0)<(P|0));I=f[z+(M<<2)>>2]|0;U=Za;while(1){P=f[K+(U<<2)>>2]|0;if((P|0)<(U|0))U=P;else break}if((Za|0)==(I|0))_a=U;else{P=I;while(1){T=f[K+(P<<2)>>2]|0;if((T|0)<(P|0))P=T;else break}T=(U|0)>(P|0)?P:U;R=I;do{_=K+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=T}while((R|0)<(L|0));_a=T}T=Za;do{R=K+(T<<2)|0;I=T;T=f[R>>2]|0;f[R>>2]=_a}while((T|0)<(I|0));f[z+(D<<2)>>2]=_a;J=E;break a}while(0);if(b[w+D>>0]|0){do if(C){if(!(b[x+O>>0]|0))break;H=f[l>>2]|0;T=f[y+(S<<2)>>2]|0;K=f[z+(M<<2)>>2]|0;I=T;while(1){R=f[H+(I<<2)>>2]|0;if((R|0)<(I|0))I=R;else break}if((T|0)==(K|0))$a=I;else{R=K;while(1){U=f[H+(R<<2)>>2]|0;if((U|0)<(R|0))R=U;else break}U=(I|0)>(R|0)?R:I;P=K;do{L=H+(P<<2)|0;_=P;P=f[L>>2]|0;f[L>>2]=U}while((P|0)<(_|0));$a=U}U=T;do{P=H+(U<<2)|0;K=U;U=f[P>>2]|0;f[P>>2]=$a}while((U|0)<(K|0));f[z+(D<<2)>>2]=$a;J=E;break a}while(0);U=f[l>>2]|0;H=f[y+(D<<2)>>2]|0;T=f[y+(S<<2)>>2]|0;K=H;while(1){P=f[U+(K<<2)>>2]|0;if((P|0)<(K|0))K=P;else break}if((H|0)==(T|0))ab=K;else{P=T;while(1){I=f[U+(P<<2)>>2]|0;if((I|0)<(P|0))P=I;else break}I=(K|0)>(P|0)?P:K;R=T;do{_=U+(R<<2)|0;L=R;R=f[_>>2]|0;f[_>>2]=I}while((R|0)<(L|0));ab=I}I=H;do{R=U+(I<<2)|0;T=I;I=f[R>>2]|0;f[R>>2]=ab}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;H=ab;while(1){T=f[U+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}if((ab|0)==(I|0))bb=H;else{T=I;while(1){R=f[U+(T<<2)>>2]|0;if((R|0)<(T|0))T=R;else break}R=(H|0)>(T|0)?T:H;K=I;do{P=U+(K<<2)|0;L=K;K=f[P>>2]|0;f[P>>2]=R}while((K|0)<(L|0));bb=R}R=ab;do{K=U+(R<<2)|0;I=R;R=f[K>>2]|0;f[K>>2]=bb}while((R|0)<(I|0));f[z+(D<<2)>>2]=bb;J=E;break}if(!(b[w+F>>0]|0)){R=f[l>>2]|0;U=f[y+(S<<2)>>2]|0;I=f[z+(M<<2)>>2]|0;K=U;while(1){H=f[R+(K<<2)>>2]|0;if((H|0)<(K|0))K=H;else break}if((U|0)==(I|0))cb=K;else{H=I;while(1){T=f[R+(H<<2)>>2]|0;if((T|0)<(H|0))H=T;else break}T=(K|0)>(H|0)?H:K;L=I;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=T}while((L|0)<(_|0));cb=T}T=U;do{L=R+(T<<2)|0;I=T;T=f[L>>2]|0;f[L>>2]=cb}while((T|0)<(I|0));f[z+(D<<2)>>2]=cb;J=E;break}do if(C){if(!(b[x+O>>0]|0))break;T=f[y+(S<<2)>>2]|0;R=f[l>>2]|0;if(b[x+D>>0]|0){U=f[z+(M<<2)>>2]|0;I=T;while(1){L=f[R+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}if((T|0)==(U|0))db=I;else{L=U;while(1){K=f[R+(L<<2)>>2]|0;if((K|0)<(L|0))L=K;else break}K=(I|0)>(L|0)?L:I;H=U;do{_=R+(H<<2)|0;P=H;H=f[_>>2]|0;f[_>>2]=K}while((H|0)<(P|0));db=K}K=T;do{H=R+(K<<2)|0;U=K;K=f[H>>2]|0;f[H>>2]=db}while((K|0)<(U|0));f[z+(D<<2)>>2]=db;J=E;break a}K=f[y+(M<<2)>>2]|0;U=K;while(1){H=f[R+(U<<2)>>2]|0;if((H|0)<(U|0))U=H;else break}if((K|0)==(T|0))eb=U;else{H=T;while(1){I=f[R+(H<<2)>>2]|0;if((I|0)<(H|0))H=I;else break}I=(U|0)>(H|0)?H:U;L=T;do{P=R+(L<<2)|0;_=L;L=f[P>>2]|0;f[P>>2]=I}while((L|0)<(_|0));eb=I}I=K;do{L=R+(I<<2)|0;T=I;I=f[L>>2]|0;f[L>>2]=eb}while((I|0)<(T|0));I=f[z+(M<<2)>>2]|0;K=eb;while(1){T=f[R+(K<<2)>>2]|0;if((T|0)<(K|0))K=T;else break}if((eb|0)==(I|0))fb=K;else{T=I;while(1){L=f[R+(T<<2)>>2]|0;if((L|0)<(T|0))T=L;else break}L=(K|0)>(T|0)?T:K;U=I;do{H=R+(U<<2)|0;_=U;U=f[H>>2]|0;f[H>>2]=L}while((U|0)<(_|0));fb=L}L=eb;do{U=R+(L<<2)|0;I=L;L=f[U>>2]|0;f[U>>2]=fb}while((L|0)<(I|0));f[z+(D<<2)>>2]=fb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(M<<2)>>2]|0;R=f[y+(S<<2)>>2]|0;I=L;while(1){U=f[O+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}if((L|0)==(R|0))gb=I;else{S=R;while(1){U=f[O+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}U=(I|0)>(S|0)?S:I;K=R;do{T=O+(K<<2)|0;_=K;K=f[T>>2]|0;f[T>>2]=U}while((K|0)<(_|0));gb=U}U=L;do{K=O+(U<<2)|0;R=U;U=f[K>>2]|0;f[K>>2]=gb}while((U|0)<(R|0));U=f[z+(M<<2)>>2]|0;L=gb;while(1){R=f[O+(L<<2)>>2]|0;if((R|0)<(L|0))L=R;else break}if((gb|0)==(U|0))hb=L;else{M=U;while(1){R=f[O+(M<<2)>>2]|0;if((R|0)<(M|0))M=R;else break}R=(L|0)>(M|0)?M:L;K=U;do{I=O+(K<<2)|0;S=K;K=f[I>>2]|0;f[I>>2]=R}while((K|0)<(S|0));hb=R}R=gb;do{K=O+(R<<2)|0;U=R;R=f[K>>2]|0;f[K>>2]=hb}while((R|0)<(U|0));f[z+(D<<2)>>2]=hb;J=E;break}do if(A){R=D+-2|0;if(b[w+F>>0]|0){O=f[z+(R<<2)>>2]|0;do if((R|0)>-1){if(!(b[v+R>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);U=f[l>>2]|0;K=f[y+(R<<2)>>2]|0;L=K;while(1){M=f[U+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(O|0))ib=L;else{M=O;while(1){S=f[U+(M<<2)>>2]|0;if((S|0)<(M|0))M=S;else break}S=(L|0)>(M|0)?M:L;I=O;do{_=U+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=S}while((I|0)<(T|0));ib=S}S=K;do{I=U+(S<<2)|0;O=S;S=f[I>>2]|0;f[I>>2]=ib}while((S|0)<(O|0));f[z+(D<<2)>>2]=ib;J=E;break a}if(!(b[w+D>>0]|0)){jb=R;break}do if((R|0)>-1){if(!(b[v+R>>0]|0))break;if(!(b[w+R>>0]|0)){S=f[l>>2]|0;U=f[y+(D<<2)>>2]|0;K=f[z+(R<<2)>>2]|0;O=U;while(1){I=f[S+(O<<2)>>2]|0;if((I|0)<(O|0))O=I;else break}if((U|0)==(K|0))kb=O;else{I=K;while(1){L=f[S+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}L=(O|0)>(I|0)?I:O;M=K;do{T=S+(M<<2)|0;_=M;M=f[T>>2]|0;f[T>>2]=L}while((M|0)<(_|0));kb=L}L=U;do{M=S+(L<<2)|0;K=L;L=f[M>>2]|0;f[M>>2]=kb}while((L|0)<(K|0));f[z+(D<<2)>>2]=kb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(R<<2)>>2];J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;U=f[z+(R<<2)>>2]|0;K=S;while(1){M=f[L+(K<<2)>>2]|0;if((M|0)<(K|0))K=M;else break}if((S|0)==(U|0))lb=K;else{M=U;while(1){O=f[L+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(K|0)>(M|0)?M:K;I=U;do{_=L+(I<<2)|0;T=I;I=f[_>>2]|0;f[_>>2]=O}while((I|0)<(T|0));lb=O}O=S;do{I=L+(O<<2)|0;U=O;O=f[I>>2]|0;f[I>>2]=lb}while((O|0)<(U|0));f[z+(D<<2)>>2]=lb;J=E;break a}while(0);O=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(R<<2)>>2]|0;U=L;while(1){I=f[O+(U<<2)>>2]|0;if((I|0)<(U|0))U=I;else break}if((L|0)==(S|0))mb=U;else{R=S;while(1){I=f[O+(R<<2)>>2]|0;if((I|0)<(R|0))R=I;else break}I=(U|0)>(R|0)?R:U;K=S;do{M=O+(K<<2)|0;T=K;K=f[M>>2]|0;f[M>>2]=I}while((K|0)<(T|0));mb=I}I=L;do{K=O+(I<<2)|0;S=I;I=f[K>>2]|0;f[K>>2]=mb}while((I|0)<(S|0));f[z+(D<<2)>>2]=mb;J=E;break a}else jb=D+-2|0;while(0);f[z+(D<<2)>>2]=f[z+(jb<<2)>>2];J=E;break}if(A){I=D+-2|0;if(b[w+F>>0]|0){O=f[z+(I<<2)>>2]|0;do if((I|0)>-1){if(!(b[v+I>>0]|0))break;f[z+(D<<2)>>2]=O;J=E;break a}while(0);L=f[l>>2]|0;S=f[y+(I<<2)>>2]|0;K=S;while(1){U=f[L+(K<<2)>>2]|0;if((U|0)<(K|0))K=U;else break}if((S|0)==(O|0))nb=K;else{U=O;while(1){R=f[L+(U<<2)>>2]|0;if((R|0)<(U|0))U=R;else break}R=(K|0)>(U|0)?U:K;T=O;do{M=L+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=R}while((T|0)<(_|0));nb=R}R=S;do{T=L+(R<<2)|0;O=R;R=f[T>>2]|0;f[T>>2]=nb}while((R|0)<(O|0));f[z+(D<<2)>>2]=nb;J=E;break}if(!(b[w+D>>0]|0))ob=I;else{do if((I|0)>-1){if(!(b[v+I>>0]|0))break;if(!(b[w+I>>0]|0)){R=f[l>>2]|0;L=f[y+(D<<2)>>2]|0;S=f[z+(I<<2)>>2]|0;O=L;while(1){T=f[R+(O<<2)>>2]|0;if((T|0)<(O|0))O=T;else break}if((L|0)==(S|0))pb=O;else{T=S;while(1){K=f[R+(T<<2)>>2]|0;if((K|0)<(T|0))T=K;else break}K=(O|0)>(T|0)?T:O;U=S;do{_=R+(U<<2)|0;M=U;U=f[_>>2]|0;f[_>>2]=K}while((U|0)<(M|0));pb=K}K=L;do{U=R+(K<<2)|0;S=K;K=f[U>>2]|0;f[U>>2]=pb}while((K|0)<(S|0));f[z+(D<<2)>>2]=pb;J=E;break a}do if(C){if(!(b[x+F>>0]|0))break;f[z+(D<<2)>>2]=f[z+(I<<2)>>2];J=E;break a}while(0);K=f[l>>2]|0;R=f[y+(D<<2)>>2]|0;L=f[z+(I<<2)>>2]|0;S=R;while(1){U=f[K+(S<<2)>>2]|0;if((U|0)<(S|0))S=U;else break}if((R|0)==(L|0))qb=S;else{U=L;while(1){O=f[K+(U<<2)>>2]|0;if((O|0)<(U|0))U=O;else break}O=(S|0)>(U|0)?U:S;T=L;do{M=K+(T<<2)|0;_=T;T=f[M>>2]|0;f[M>>2]=O}while((T|0)<(_|0));qb=O}O=R;do{T=K+(O<<2)|0;L=O;O=f[T>>2]|0;f[T>>2]=qb}while((O|0)<(L|0));f[z+(D<<2)>>2]=qb;J=E;break a}while(0);O=f[l>>2]|0;K=f[y+(D<<2)>>2]|0;R=f[z+(I<<2)>>2]|0;L=K;while(1){T=f[O+(L<<2)>>2]|0;if((T|0)<(L|0))L=T;else break}if((K|0)==(R|0))rb=L;else{I=R;while(1){T=f[O+(I<<2)>>2]|0;if((T|0)<(I|0))I=T;else break}T=(L|0)>(I|0)?I:L;S=R;do{U=O+(S<<2)|0;_=S;S=f[U>>2]|0;f[U>>2]=T}while((S|0)<(_|0));rb=T}T=K;do{S=O+(T<<2)|0;R=T;T=f[S>>2]|0;f[S>>2]=rb}while((T|0)<(R|0));f[z+(D<<2)>>2]=rb;J=E;break}}else ob=D+-2|0;f[z+(D<<2)>>2]=f[z+(ob<<2)>>2];J=E;break}}T=D|1;O=(T|0)<(n|0);if(!(B|O^1)?b[w+T>>0]|0:0){if(b[w+D>>0]|0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(G?b[w+F>>0]|0:0){K=f[y+(D<<2)>>2]|0;if(C?b[x+D>>0]|0:0){f[z+(D<<2)>>2]=K;J=E;break}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;L=S;while(1){I=f[R+(L<<2)>>2]|0;if((I|0)<(L|0))L=I;else break}if((S|0)==(K|0))sb=L;else{I=K;while(1){_=f[R+(I<<2)>>2]|0;if((_|0)<(I|0))I=_;else break}_=(L|0)>(I|0)?I:L;U=K;do{M=R+(U<<2)|0;H=U;U=f[M>>2]|0;f[M>>2]=_}while((U|0)<(H|0));sb=_}_=S;do{U=R+(_<<2)|0;K=_;_=f[U>>2]|0;f[U>>2]=sb}while((_|0)<(K|0));f[z+(D<<2)>>2]=sb;J=E;break}f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(O?b[v+T>>0]|0:0){_=D+2|0;if(!((_|0)>=(n|0)|B)?b[w+_>>0]|0:0){if(b[w+D>>0]|0){if(C?b[x+T>>0]|0:0){f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}R=f[l>>2]|0;S=f[y+(D<<2)>>2]|0;K=f[y+(_<<2)>>2]|0;U=S;while(1){L=f[R+(U<<2)>>2]|0;if((L|0)<(U|0))U=L;else break}if((S|0)==(K|0))tb=U;else{O=K;while(1){L=f[R+(O<<2)>>2]|0;if((L|0)<(O|0))O=L;else break}L=(U|0)>(O|0)?O:U;I=K;do{H=R+(I<<2)|0;M=I;I=f[H>>2]|0;f[H>>2]=L}while((I|0)<(M|0));tb=L}L=S;do{I=R+(L<<2)|0;K=L;L=f[I>>2]|0;f[I>>2]=tb}while((L|0)<(K|0));f[z+(D<<2)>>2]=tb;J=E;break}if(G?b[w+F>>0]|0:0){do if(C){if(!(b[x+T>>0]|0))break;L=f[y+(_<<2)>>2]|0;if(b[x+D>>0]|0){f[z+(D<<2)>>2]=L;J=E;break a}R=f[l>>2]|0;S=f[y+(D+-2<<2)>>2]|0;K=S;while(1){I=f[R+(K<<2)>>2]|0;if((I|0)<(K|0))K=I;else break}if((S|0)==(L|0))ub=K;else{I=L;while(1){U=f[R+(I<<2)>>2]|0;if((U|0)<(I|0))I=U;else break}U=(K|0)>(I|0)?I:K;O=L;do{M=R+(O<<2)|0;H=O;O=f[M>>2]|0;f[M>>2]=U}while((O|0)<(H|0));ub=U}U=S;do{O=R+(U<<2)|0;L=U;U=f[O>>2]|0;f[O>>2]=ub}while((U|0)<(L|0));f[z+(D<<2)>>2]=ub;J=E;break a}while(0);T=f[l>>2]|0;U=f[y+(D+-2<<2)>>2]|0;R=f[y+(_<<2)>>2]|0;S=U;while(1){L=f[T+(S<<2)>>2]|0;if((L|0)<(S|0))S=L;else break}if((U|0)==(R|0))vb=S;else{L=R;while(1){O=f[T+(L<<2)>>2]|0;if((O|0)<(L|0))L=O;else break}O=(S|0)>(L|0)?L:S;K=R;do{I=T+(K<<2)|0;H=K;K=f[I>>2]|0;f[I>>2]=O}while((K|0)<(H|0));vb=O}O=U;do{K=T+(O<<2)|0;R=O;O=f[K>>2]|0;f[K>>2]=vb}while((O|0)<(R|0));f[z+(D<<2)>>2]=vb;J=E;break}f[z+(D<<2)>>2]=f[y+(_<<2)>>2];J=E;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0;break}if(A?b[w+D>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D<<2)>>2];J=E;break}if(!(B|G^1)?b[w+F>>0]|0:0){f[z+(D<<2)>>2]=f[y+(D+-2<<2)>>2];J=E;break}f[z+(D<<2)>>2]=E;f[(f[l>>2]|0)+(E<<2)>>2]=E;J=E+1|0}while(0);D=D+2|0;if((D|0)>=(n|0)){wb=J;break}else E=J}}else wb=s;a=a+2|0;if((a|0)>=(f[d>>2]|0))break;else s=wb}o=wb;p=f[g>>2]|0;q=o-j|0;r=p+(c<<2)|0;f[r>>2]=q;return}function V3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=f[a+12>>2]|0;e=f[a+8>>2]|0;g=f[c>>2]|0;if((g|0)>=(e|0))return;h=f[a+16>>2]|0;i=f[a+44>>2]|0;a=(d|0)>0;j=d+-1|0;k=g;do{g=f[i>>2]|0;l=h+(Y(g,k)|0)|0;m=l+(0-g)|0;if(a){g=0;do{n=l+(g<<2)|0;o=f[n>>2]|0;if((o|0)>0){if((g|0)>0?(p=f[m+(g+-1<<2)>>2]|0,(p|0)>0):0){q=p;while(1){r=f[b+(q<<2)>>2]|0;if((r|0)<(q|0))q=r;else break}if((p|0)==(o|0))s=q;else{r=o;while(1){t=f[b+(r<<2)>>2]|0;if((t|0)<(r|0))r=t;else break}t=(q|0)>(r|0)?r:q;u=o;do{v=b+(u<<2)|0;w=u;u=f[v>>2]|0;f[v>>2]=t}while((u|0)<(w|0));s=t}t=p;do{u=b+(t<<2)|0;q=t;t=f[u>>2]|0;f[u>>2]=s}while((t|0)<(q|0));f[n>>2]=s;x=s}else x=o;if((g|0)<(j|0)?(t=f[m+(g+1<<2)>>2]|0,(t|0)>0):0){p=t;while(1){q=f[b+(p<<2)>>2]|0;if((q|0)<(p|0))p=q;else break}if((t|0)==(x|0))y=p;else{o=x;while(1){q=f[b+(o<<2)>>2]|0;if((q|0)<(o|0))o=q;else break}q=(p|0)>(o|0)?o:p;u=x;do{r=b+(u<<2)|0;w=u;u=f[r>>2]|0;f[r>>2]=q}while((u|0)<(w|0));y=q}q=t;do{u=b+(q<<2)|0;p=q;q=f[u>>2]|0;f[u>>2]=y}while((q|0)<(p|0));f[n>>2]=y;z=y}else z=x;q=f[m+(g<<2)>>2]|0;if((q|0)>0){t=q;while(1){p=f[b+(t<<2)>>2]|0;if((p|0)<(t|0))t=p;else break}if((q|0)==(z|0))A=t;else{p=z;while(1){u=f[b+(p<<2)>>2]|0;if((u|0)<(p|0))p=u;else break}u=(t|0)>(p|0)?p:t;o=z;do{w=b+(o<<2)|0;r=o;o=f[w>>2]|0;f[w>>2]=u}while((o|0)<(r|0));A=u}u=q;do{o=b+(u<<2)|0;t=u;u=f[o>>2]|0;f[o>>2]=A}while((u|0)<(t|0));f[n>>2]=A}}g=g+1|0}while((g|0)!=(d|0))}k=f[c+(k<<2)>>2]|0}while((k|0)<(e|0));return}function W3(a){a=a|0;O5b(a);return}function X3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[b>>2]|0;d=f[b+4>>2]|0;b=(c|0)<(d|0);if((c|0)>0){if(!b)return;e=a+4|0;g=a+8|0;h=c;do{i=f[e>>2]|0;j=(f[i+16>>2]|0)+(Y(f[f[i+44>>2]>>2]|0,h)|0)|0;k=j+(f[i+12>>2]<<2)|0;if((j|0)!=(k|0)){i=f[g>>2]|0;l=j;do{f[l>>2]=f[i+(f[l>>2]<<2)>>2];l=l+4|0}while((l|0)!=(k|0))}h=h+1|0}while((h|0)!=(d|0));return}else{if(!b)return;b=a+4|0;h=a+8|0;a=c;do{c=f[b>>2]|0;g=(f[c+16>>2]|0)+(Y(f[f[c+44>>2]>>2]|0,a)|0)|0;e=g+(f[c+12>>2]<<2)|0;if((g|0)!=(e|0)){c=f[h>>2]|0;k=g;do{f[k>>2]=f[c+(f[k>>2]<<2)>>2];k=k+4|0}while((k|0)!=(e|0))}a=a+1|0}while((a|0)!=(d|0));return}}function Y3(a){a=a|0;O5b(a);return}function Z3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=a+8|0;h=f[g>>2]|0;i=(((Y(f[h+12>>2]|0,d)|0)+1|0)/2|0)+1|0;j=a+4|0;k=f[j>>2]|0;l=f[k+12>>2]|0;if((d|0)==(f[e>>2]|0)){m=i;n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}q=(l|0)>0;r=a+12|0;a=d;s=i;t=k;k=h;while(1){h=f[f[t+44>>2]>>2]|0;u=(f[t+16>>2]|0)+(Y(h,a)|0)|0;v=u+(0-h)|0;h=f[f[k+44>>2]>>2]|0;w=(f[k+16>>2]|0)+(Y(h,a)|0)|0;x=w+(0-h)|0;a:do if(q){if((a|0)>(d|0)){y=0;z=s}else{h=0;A=s;while(1){do if(!(b[u+h>>0]|0)){f[w+(h<<2)>>2]=0;B=A}else{if((h|0)>0?(C=h+-1|0,b[u+C>>0]|0):0){f[w+(h<<2)>>2]=f[w+(C<<2)>>2];B=A;break}f[w+(h<<2)>>2]=A;f[(f[r>>2]|0)+(A<<2)>>2]=A;B=A+1|0}while(0);h=h+1|0;if((h|0)==(l|0)){D=B;break a}else A=B}}while(1){do if(!(b[u+y>>0]|0)){f[w+(y<<2)>>2]=0;E=z}else{A=(y|0)>0;if(!(b[v+y>>0]|0)){if(A?(h=y+-1|0,b[u+h>>0]|0):0){f[w+(y<<2)>>2]=f[w+(h<<2)>>2];E=z;break}f[w+(y<<2)>>2]=z;f[(f[r>>2]|0)+(z<<2)>>2]=z;E=z+1|0;break}h=f[x+(y<<2)>>2]|0;if(A?(A=y+-1|0,(b[u+A>>0]|0)!=0):0){C=f[r>>2]|0;F=f[w+(A<<2)>>2]|0;A=F;while(1){G=f[C+(A<<2)>>2]|0;if((G|0)<(A|0))A=G;else break}if((F|0)==(h|0))H=A;else{G=h;while(1){I=f[C+(G<<2)>>2]|0;if((I|0)<(G|0))G=I;else break}I=(A|0)>(G|0)?G:A;J=h;do{K=C+(J<<2)|0;L=J;J=f[K>>2]|0;f[K>>2]=I}while((J|0)<(L|0));H=I}I=F;do{J=C+(I<<2)|0;A=I;I=f[J>>2]|0;f[J>>2]=H}while((I|0)<(A|0));M=H}else M=h;f[w+(y<<2)>>2]=M;E=z}while(0);y=y+1|0;if((y|0)==(l|0)){D=E;break}else z=E}}else D=s;while(0);w=a+1|0;if((w|0)==(f[e>>2]|0)){m=D;break}a=w;s=D;t=f[j>>2]|0;k=f[g>>2]|0}n=m-i|0;o=d+1|0;p=c+(o<<2)|0;f[p>>2]=n;return}function _3(a){a=a|0;O5b(a);return}function $3(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=f[c>>2]|0;e=c+4|0;c=f[a+16>>2]|0;f[c+(d<<2)>>2]=f[e>>2];g=d+1|0;h=a+8|0;i=f[h>>2]|0;j=(Y(((f[i+12>>2]|0)+1|0)/2|0,(g|0)/2|0)|0)+1|0;k=a+4|0;l=f[k>>2]|0;m=f[l+12>>2]|0;n=f[e>>2]|0;if((d|0)==(n|0)){o=j;p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}r=(m|0)>0;s=m+-1|0;t=a+12|0;a=d;u=j;v=n;n=l;l=i;while(1){i=f[f[n+44>>2]>>2]|0;w=(f[n+16>>2]|0)+(Y(i,a)|0)|0;x=w+(0-i)|0;i=f[f[l+44>>2]>>2]|0;y=(f[l+16>>2]|0)+(Y(i,a)|0)|0;z=y+(0-i)|0;if(r){i=(a|0)>(d|0);A=i^1;B=0;C=u;while(1){a:do if(!(b[w+B>>0]|0)){f[y+(B<<2)>>2]=0;D=C}else{if(i){if(b[x+B>>0]|0){f[y+(B<<2)>>2]=f[z+(B<<2)>>2];D=C;break}if(!((B|0)>=(s|0)|A)){E=B+1|0;if(!(b[x+E>>0]|0))F=0;else{do if((B|0)>0){G=B+-1|0;if(!(b[x+G>>0]|0)){H=f[z+(E<<2)>>2]|0;if(!(b[w+G>>0]|0)){I=H;break}J=f[t>>2]|0;K=f[y+(G<<2)>>2]|0;L=K;while(1){M=f[J+(L<<2)>>2]|0;if((M|0)<(L|0))L=M;else break}if((K|0)==(H|0))N=L;else{M=H;while(1){O=f[J+(M<<2)>>2]|0;if((O|0)<(M|0))M=O;else break}O=(L|0)>(M|0)?M:L;P=H;do{Q=J+(P<<2)|0;R=P;P=f[Q>>2]|0;f[Q>>2]=O}while((P|0)<(R|0));N=O}O=K;do{P=J+(O<<2)|0;H=O;O=f[P>>2]|0;f[P>>2]=N}while((O|0)<(H|0));I=N}else{O=f[t>>2]|0;J=f[z+(G<<2)>>2]|0;K=f[z+(E<<2)>>2]|0;H=J;while(1){P=f[O+(H<<2)>>2]|0;if((P|0)<(H|0))H=P;else break}if((J|0)==(K|0))S=H;else{G=K;while(1){P=f[O+(G<<2)>>2]|0;if((P|0)<(G|0))G=P;else break}P=(H|0)>(G|0)?G:H;L=K;do{M=O+(L<<2)|0;R=L;L=f[M>>2]|0;f[M>>2]=P}while((L|0)<(R|0));S=P}P=J;do{L=O+(P<<2)|0;K=P;P=f[L>>2]|0;f[L>>2]=S}while((P|0)<(K|0));f[y+(B<<2)>>2]=S;D=C;break a}}else I=f[z+(E<<2)>>2]|0;while(0);f[y+(B<<2)>>2]=I;D=C;break}}else F=A}else F=A;E=(B|0)>0;if(!(F|E^1)?(P=B+-1|0,b[x+P>>0]|0):0){f[y+(B<<2)>>2]=f[z+(P<<2)>>2];D=C;break}if(E?(E=B+-1|0,b[w+E>>0]|0):0){f[y+(B<<2)>>2]=f[y+(E<<2)>>2];D=C;break}f[y+(B<<2)>>2]=C;f[(f[t>>2]|0)+(C<<2)>>2]=C;D=C+1|0}while(0);B=B+1|0;if((B|0)==(m|0))break;else C=D}T=D;U=f[e>>2]|0}else{T=u;U=v}C=a+1|0;if((C|0)==(U|0)){o=T;break}a=C;u=T;v=U;n=f[k>>2]|0;l=f[h>>2]|0}p=o-j|0;q=c+(g<<2)|0;f[q>>2]=p;return}function a4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return b4(a,b,c,d,e,f,-1)|0}function b4(a,c,d,e,g,h,i){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;j=u;u=u+272|0;k=j+208|0;l=j+144|0;m=j+152|0;n=j+8|0;o=j;do if((yM(a)|0)==65536){p=f[a+4>>2]|0;f[k>>2]=f[p>>2];q=k+4|0;r=p+4|0;f[q>>2]=f[r>>2];s=k+8|0;f[s>>2]=f[p+8>>2];f[k+12>>2]=f[p+12>>2];f[k+16>>2]=f[p+16>>2];f[k+20>>2]=f[p+20>>2];f[k+24>>2]=f[p+24>>2];f[k+28>>2]=f[p+28>>2];f[k+32>>2]=f[p+32>>2];t=f[p+36>>2]|0;f[k+36>>2]=t;v=k+40|0;f[v>>2]=s;s=k+48|0;w=k+44|0;f[w>>2]=s;f[s>>2]=0;f[k+52>>2]=0;if(t|0){s=t+12|0;f[s>>2]=(f[s>>2]|0)+1}if((f[r>>2]|0)<3){r=f[p+44>>2]|0;s=f[w>>2]|0;f[s>>2]=f[r>>2];f[s+4>>2]=f[r+4>>2];x=v;break}else{f[q>>2]=0;jL(k,p);x=v;break}}else{yL(k,a,-1);x=k+40|0}while(0);a=f[x>>2]|0;v=f[a>>2]|0;f[l>>2]=f[a+4>>2];f[l+4>>2]=v;vM(c,l,h&7,-1,0,0);do if((yM(c)|0)==65536){l=f[c+4>>2]|0;f[m>>2]=f[l>>2];v=m+4|0;a=l+4|0;f[v>>2]=f[a>>2];p=m+8|0;f[p>>2]=f[l+8>>2];f[m+12>>2]=f[l+12>>2];f[m+16>>2]=f[l+16>>2];f[m+20>>2]=f[l+20>>2];f[m+24>>2]=f[l+24>>2];f[m+28>>2]=f[l+28>>2];f[m+32>>2]=f[l+32>>2];q=f[l+36>>2]|0;f[m+36>>2]=q;f[m+40>>2]=p;p=m+48|0;r=m+44|0;f[r>>2]=p;f[p>>2]=0;f[m+52>>2]=0;if(q|0){p=q+12|0;f[p>>2]=(f[p>>2]|0)+1}if((f[a>>2]|0)<3){a=f[l+44>>2]|0;p=f[r>>2]|0;f[p>>2]=f[a>>2];f[p+4>>2]=f[a+4>>2];break}else{f[v>>2]=0;jL(m,l);break}}else yL(m,c,-1);while(0);f[n>>2]=d;f[n+4>>2]=1124007936;d=n+12|0;c=n+44|0;l=n+8|0;v=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(v|0));f[c>>2]=d;d=n+52|0;f[n+48>>2]=d;f[d>>2]=0;f[n+56>>2]=0;f[n+60>>2]=e;f[n+64>>2]=1124007936;e=n+72|0;d=n+104|0;l=n+68|0;v=l+36|0;do{f[l>>2]=0;l=l+4|0}while((l|0)<(v|0));f[d>>2]=e;e=n+112|0;f[n+108>>2]=e;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;f[e+12>>2]=0;f[e+16>>2]=0;f[e+20>>2]=0;switch(h|0){case 2:{y=c4(k,m,g,i,n)|0;break}case 4:{y=c4(k,m,g,i,n)|0;break}default:{f[o>>2]=0;f[o+4>>2]=0;l=aD(o,37)|0;i=234956;v=l+37|0;do{b[l>>0]=b[i>>0]|0;l=l+1|0;i=i+1|0}while((l|0)<(v|0));bO(-210,o,235805,235014,4036);bD(o);y=0}}d4(n);n=m+36|0;o=f[n>>2]|0;if(o|0?(i=o+12|0,o=f[i>>2]|0,f[i>>2]=o+-1,(o|0)==1):0)kL(m);f[n>>2]=0;n=m+16|0;o=m+4|0;f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;if((f[o>>2]|0)>0){n=f[m+40>>2]|0;i=0;do{f[n+(i<<2)>>2]=0;i=i+1|0}while((i|0)<(f[o>>2]|0))}o=f[m+44>>2]|0;if((o|0)!=(m+48|0))UC(o);o=k+36|0;m=f[o>>2]|0;if(m|0?(i=m+12|0,m=f[i>>2]|0,f[i>>2]=m+-1,(m|0)==1):0)kL(k);f[o>>2]=0;o=k+16|0;m=k+4|0;f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;if((f[m>>2]|0)>0){o=f[x>>2]|0;x=0;do{f[o+(x<<2)>>2]=0;x=x+1|0}while((x|0)<(f[m>>2]|0))}m=f[k+44>>2]|0;if((m|0)==(k+48|0)){u=j;return y|0}UC(m);u=j;return y|0}function c4(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;h=u;u=u+16|0;i=h;j=h+13|0;k=h+12|0;l=h+11|0;m=h+10|0;n=h+9|0;o=h+8|0;if(!((f[c>>2]&4088|0)==0?!(f[a>>2]&4088|0):0)){f[i>>2]=0;f[i+4>>2]=0;p=aD(i,38)|0;q=235098;r=p+38|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,i,235137,235014,3932);bD(i)}s=(d|0)==8;t=(d|0)==4;switch(d|0){case 4:case 8:break;default:{f[i>>2]=0;f[i+4>>2]=0;p=aD(i,38)|0;q=267207;r=p+38|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,i,235137,235014,3933);bD(i)}}v=(e|0)==1;w=(e|0)==0;x=(e|0)==-1;switch(e|0){case 0:case 1:case -1:break;default:{f[i>>2]=0;f[i+4>>2]=0;p=aD(i,67)|0;q=235162;r=p+67|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,i,235137,235014,3934);bD(i)}}e=f[c>>2]|0;y=e&7;z=f[a>>2]&6;A=VQ()|0;B=UQ()|0;if((z|1|0)!=1){f[i>>2]=0;f[i+4>>2]=0;p=aD(i,26)|0;q=235230;r=p+26|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-215,i,235137,235014,3941);bD(i)}if((A|0)!=0&(B|0)>1)C=((f[c+8>>2]|0)/(B|0)|0|0)>1;else C=0;B=(y|0)==0;a:do if(t|w){if(!B){switch(e&7){case 2:{D=(e4(j,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=g4(l,a,c,d,g)|0;u=h;return D|0}else{D=f4(k,a,c,d,g)|0;u=h;return D|0}}}else if(!(B|s&(v|x)^1)){switch(e&7){case 2:{D=(h4(m,a,c,d,g)|0)&65535;u=h;return D|0}case 4:break;default:break a}if(C){D=j4(o,a,c,d,g)|0;u=h;return D|0}else{D=i4(n,a,c,d,g)|0;u=h;return D|0}}while(0);f[i>>2]=0;f[i+4>>2]=0;p=aD(i,28)|0;q=235257;r=p+28|0;do{b[p>>0]=b[q>>0]|0;p=p+1|0;q=q+1|0}while((p|0)<(r|0));bO(-210,i,235137,235014,3987);bD(i);D=-1;u=h;return D|0}function d4(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+120>>2]|0;if(b|0){c=a+124|0;d=f[c>>2]|0;if((d|0)!=(b|0))f[c>>2]=d+(~((d+-16-b|0)>>>4)<<4);O5b(b)}b=a+64|0;d=a+100|0;c=f[d>>2]|0;if(c|0?(e=c+12|0,c=f[e>>2]|0,f[e>>2]=c+-1,(c|0)==1):0)kL(b);f[d>>2]=0;d=a+80|0;b=a+68|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;if((f[b>>2]|0)>0){d=f[a+104>>2]|0;c=0;do{f[d+(c<<2)>>2]=0;c=c+1|0}while((c|0)<(f[b>>2]|0))}b=f[a+108>>2]|0;if((b|0)!=(a+112|0))UC(b);b=a+4|0;c=a+40|0;d=f[c>>2]|0;if(d|0?(e=d+12|0,d=f[e>>2]|0,f[e>>2]=d+-1,(d|0)==1):0)kL(b);f[c>>2]=0;c=a+20|0;b=a+8|0;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;if((f[b>>2]|0)>0){c=f[a+44>>2]|0;d=0;do{f[c+(d<<2)>>2]=0;d=d+1|0}while((d|0)<(f[b>>2]|0))}b=f[a+48>>2]|0;if((b|0)==(a+52|0))return;UC(b);return}function e4(a,c,e,g,h){a=a|0;c=c|0;e=e|0;g=g|0;h=h|0;var i=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0;a=u;u=u+16|0;i=a;k=c+8|0;if((f[e+8>>2]|0)!=(f[k>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,26)|0;m=235751;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,i,489445,235014,659);bD(i)}o=c+12|0;if((f[e+12>>2]|0)!=(f[o>>2]|0)){f[i>>2]=0;f[i+4>>2]=0;l=aD(i,26)|0;m=235778;n=l+26|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,i,489445,235014,660);bD(i)}q=(g|0)==8;switch(g|0){case 4:case 8:break;default:{f[i>>2]=0;f[i+4>>2]=0;l=aD(i,38)|0;m=267207;n=l+38|0;do{b[l>>0]=b[m>>0]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));bO(-215,i,489445,235014,661);bD(i)}}i=f[k>>2]|0;k=f[o>>2]|0;o=TC((Y(k,i)|0)+3&-2)|0;d[o>>1]=0;m=(i|0)>0;if(q)if(m){q=(k|0)>0;l=k+-1|0;n=f[c+16>>2]|0;g=f[f[c+44>>2]>>2]|0;r=f[e+16>>2]|0;s=f[f[e+44>>2]>>2]|0;t=0-g|0;v=0-s|0;w=1;x=0;while(1){y=n+(Y(g,x)|0)|0;z=y+t|0;A=r+(Y(s,x)|0)|0;B=A+v|0;if(q){C=(x|0)>0;D=0;E=w;while(1){a:do if(!(b[y+D>>0]|0)){d[A+(D<<1)>>1]=0;F=E}else{if(C){if(b[z+D>>0]|0){d[A+(D<<1)>>1]=d[B+(D<<1)>>1]|0;F=E;break}G=(D|0)>0;if((D|0)<(l|0)?(H=D+1|0,b[z+H>>0]|0):0){I=d[B+(H<<1)>>1]|0;do if(G){H=D+-1|0;if(!(b[z+H>>0]|0)){K=D+-1|0;if(!(b[y+K>>0]|0)){L=I;break}M=d[A+(K<<1)>>1]|0;K=M;while(1){N=d[o+((K&65535)<<1)>>1]|0;if((N&65535)<(K&65535))K=N;else break}if(M<<16>>16==I<<16>>16)O=K;else{N=I;while(1){P=d[o+((N&65535)<<1)>>1]|0;if((P&65535)<(N&65535))N=P;else break}P=(K&65535)>(N&65535)?N:K;Q=I;do{R=o+((Q&65535)<<1)|0;S=Q;Q=d[R>>1]|0;d[R>>1]=P}while((Q&65535)<(S&65535));O=P}P=M;do{Q=o+((P&65535)<<1)|0;K=P;P=d[Q>>1]|0;d[Q>>1]=O}while((P&65535)<(K&65535));L=O}else{P=d[B+(H<<1)>>1]|0;M=P;while(1){K=d[o+((M&65535)<<1)>>1]|0;if((K&65535)<(M&65535))M=K;else break}if(P<<16>>16==I<<16>>16)T=M;else{H=I;while(1){K=d[o+((H&65535)<<1)>>1]|0;if((K&65535)<(H&65535))H=K;else break}K=(M&65535)>(H&65535)?H:M;Q=I;do{N=o+((Q&65535)<<1)|0;S=Q;Q=d[N>>1]|0;d[N>>1]=K}while((Q&65535)<(S&65535));T=K}K=P;do{Q=o+((K&65535)<<1)|0;M=K;K=d[Q>>1]|0;d[Q>>1]=T}while((K&65535)<(M&65535));d[A+(D<<1)>>1]=T;F=E;break a}}else L=I;while(0);d[A+(D<<1)>>1]=L;F=E;break}if(G){I=D+-1|0;if(!(b[z+I>>0]|0))U=46;else{d[A+(D<<1)>>1]=d[B+(I<<1)>>1]|0;F=E;break}}}else if((D|0)>0)U=46;if((U|0)==46?(U=0,I=D+-1|0,b[y+I>>0]|0):0){d[A+(D<<1)>>1]=d[A+(I<<1)>>1]|0;F=E;break}d[A+(D<<1)>>1]=E;I=E&65535;d[o+(I<<1)>>1]=E;F=I+1&65535}while(0);D=D+1|0;if((D|0)==(k|0)){V=F;break}else E=F}}else V=w;x=x+1|0;if((x|0)==(i|0)){W=V;U=81;break}else w=V}}else U=80;else if(m){V=(k|0)>0;w=f[c+16>>2]|0;x=f[f[c+44>>2]>>2]|0;c=f[e+16>>2]|0;F=f[f[e+44>>2]>>2]|0;L=0-x|0;T=0-F|0;O=0;l=1;while(1){q=w+(Y(x,O)|0)|0;v=q+L|0;s=c+(Y(F,O)|0)|0;r=s+T|0;b:do if(V){if((O|0)>0){X=0;Z=l}else{t=0;g=l;while(1){do if(!(b[q+t>>0]|0)){d[s+(t<<1)>>1]=0;_=g}else{if((t|0)>0?(n=t+-1|0,b[q+n>>0]|0):0){d[s+(t<<1)>>1]=d[s+(n<<1)>>1]|0;_=g;break}d[s+(t<<1)>>1]=g;n=g&65535;d[o+(n<<1)>>1]=g;_=n+1&65535}while(0);t=t+1|0;if((t|0)==(k|0)){$=_;break b}else g=_}}while(1){do if(!(b[q+X>>0]|0)){d[s+(X<<1)>>1]=0;aa=Z}else{g=(X|0)>0;if(!(b[v+X>>0]|0)){if(g?(t=X+-1|0,b[q+t>>0]|0):0){d[s+(X<<1)>>1]=d[s+(t<<1)>>1]|0;aa=Z;break}d[s+(X<<1)>>1]=Z;t=Z&65535;d[o+(t<<1)>>1]=Z;aa=t+1&65535;break}t=d[r+(X<<1)>>1]|0;if(g?(g=X+-1|0,(b[q+g>>0]|0)!=0):0){G=d[s+(g<<1)>>1]|0;g=G;while(1){n=d[o+((g&65535)<<1)>>1]|0;if((n&65535)<(g&65535))g=n;else break}if(G<<16>>16==t<<16>>16)ba=g;else{n=t;while(1){E=d[o+((n&65535)<<1)>>1]|0;if((E&65535)<(n&65535))n=E;else break}E=(g&65535)>(n&65535)?n:g;D=t;do{A=o+((D&65535)<<1)|0;y=D;D=d[A>>1]|0;d[A>>1]=E}while((D&65535)<(y&65535));ba=E}E=G;do{D=o+((E&65535)<<1)|0;g=E;E=d[D>>1]|0;d[D>>1]=ba}while((E&65535)<(g&65535));ca=ba}else ca=t;d[s+(X<<1)>>1]=ca;aa=Z}while(0);X=X+1|0;if((X|0)==(k|0)){$=aa;break}else Z=aa}}else $=l;while(0);O=O+1|0;if((O|0)==(i|0)){W=$;U=81;break}else l=$}}else U=80;if((U|0)==80){l4(h,1);da=1}else if((U|0)==81){if((W&65535)>1){U=W&65535;W=1;$=1;while(1){l=o+($<<1)|0;O=j[l>>1]|0;if(O>>>0<$>>>0){d[l>>1]=d[o+(O<<1)>>1]|0;ea=W}else{d[l>>1]=W;ea=(W&65535)+1&65535}$=$+1|0;if(($|0)==(U|0)){fa=ea;break}else W=ea}}else fa=1;l4(h,fa&65535);if(m){m=f[e+16>>2]|0;ea=f[e+44>>2]|0;e=f[h+20>>2]|0;W=f[h+48>>2]|0;U=f[h+120>>2]|0;$=0;do{l=m+(Y(f[ea>>2]|0,$)|0)|0;O=l+(k<<1)|0;if((l|0)!=(O|0)){aa=(($|0)<0)<<31>>31;Z=l;l=0;while(1){X=d[o+(j[Z>>1]<<1)>>1]|0;d[Z>>1]=X;ca=X&65535;X=e+(Y(f[W>>2]|0,ca)|0)|0;ba=f[X>>2]|0;f[X>>2]=(ba|0)>(l|0)?l:ba;ba=X+8|0;_=f[ba>>2]|0;f[ba>>2]=(_|0)<(l|0)?l:_;_=X+4|0;ba=f[_>>2]|0;f[_>>2]=(ba|0)>($|0)?$:ba;ba=X+12|0;_=f[ba>>2]|0;f[ba>>2]=(_|0)<($|0)?$:_;_=X+16|0;f[_>>2]=(f[_>>2]|0)+1;_=U+(ca<<4)|0;X=_;ba=Kac(f[X>>2]|0,f[X+4>>2]|0,l|0,((l|0)<0)<<31>>31|0)|0;X=_;f[X>>2]=ba;f[X+4>>2]=J;X=U+(ca<<4)+8|0;ca=X;ba=Kac(f[ca>>2]|0,f[ca+4>>2]|0,$|0,aa|0)|0;ca=X;f[ca>>2]=ba;f[ca+4>>2]=J;Z=Z+2|0;if((Z|0)==(O|0))break;else l=l+1|0}}$=$+1|0}while(($|0)!=(i|0));da=fa}else da=fa}fa=h+12|0;if((f[fa>>2]|0)<=0){UC(o);u=a;return da|0}i=f[h+20>>2]|0;$=f[h+48>>2]|0;U=f[h+120>>2]|0;W=f[h+80>>2]|0;e=f[h+108>>2]|0;h=0;do{k=i+(Y(f[$>>2]|0,h)|0)|0;ea=k+8|0;f[ea>>2]=(f[ea>>2]|0)+1-(f[k>>2]|0);ea=k+12|0;f[ea>>2]=(f[ea>>2]|0)+1-(f[k+4>>2]|0);ea=W+(Y(f[e>>2]|0,h)|0)|0;ga=+((f[k+16>>2]|0)>>>0);k=U+(h<<4)|0;p[ea>>3]=(+((f[k>>2]|0)>>>0)+4294967296.0*+((f[k+4>>2]|0)>>>0))/ga;k=U+(h<<4)+8|0;p[ea+8>>3]=(+((f[k>>2]|0)>>>0)+4294967296.0*+((f[k+4>>2]|0)>>>0))/ga;h=h+1|0}while((h|0)<(f[fa>>2]|0));UC(o);u=a;return da|0}function f4(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0;a=u;u=u+16|0;h=a;i=c+8|0;if((f[d+8>>2]|0)!=(f[i>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,26)|0;k=235751;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,489445,235014,659);bD(h)}m=c+12|0;if((f[d+12>>2]|0)!=(f[m>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;j=aD(h,26)|0;k=235778;l=j+26|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,489445,235014,660);bD(h)}n=(e|0)==8;switch(e|0){case 4:case 8:break;default:{f[h>>2]=0;f[h+4>>2]=0;j=aD(h,38)|0;k=267207;l=j+38|0;do{b[j>>0]=b[k>>0]|0;j=j+1|0;k=k+1|0}while((j|0)<(l|0));bO(-215,h,489445,235014,661);bD(h)}}h=f[i>>2]|0;i=f[m>>2]|0;m=TC((((Y(i,h)|0)+1|0)>>>1<<2)+4|0)|0;f[m>>2]=0;k=(h|0)>0;if(n)if(k){n=(i|0)>0;j=i+-1|0;l=f[c+16>>2]|0;e=f[c+44>>2]|0;o=f[d+16>>2]|0;q=f[d+44>>2]|0;r=1;s=0;while(1){t=f[e>>2]|0;v=l+(Y(t,s)|0)|0;w=v+(0-t)|0;t=f[q>>2]|0;x=o+(Y(t,s)|0)|0;y=x+(0-t)|0;if(n){t=(s|0)>0;z=0;A=r;while(1){a:do if(!(b[v+z>>0]|0)){f[x+(z<<2)>>2]=0;B=A}else{if(t){if(b[w+z>>0]|0){f[x+(z<<2)>>2]=f[y+(z<<2)>>2];B=A;break}C=(z|0)>0;if((z|0)<(j|0)?(D=z+1|0,b[w+D>>0]|0):0){E=f[y+(D<<2)>>2]|0;do if(C){D=z+-1|0;if(!(b[w+D>>0]|0)){F=z+-1|0;if(!(b[v+F>>0]|0)){G=E;break}H=f[x+(F<<2)>>2]|0;F=H;while(1){I=f[m+(F<<2)>>2]|0;if((I|0)<(F|0))F=I;else break}if((H|0)==(E|0))K=F;else{I=E;while(1){L=f[m+(I<<2)>>2]|0;if((L|0)<(I|0))I=L;else break}L=(F|0)>(I|0)?I:F;M=E;do{N=m+(M<<2)|0;O=M;M=f[N>>2]|0;f[N>>2]=L}while((M|0)<(O|0));K=L}L=H;do{M=m+(L<<2)|0;F=L;L=f[M>>2]|0;f[M>>2]=K}while((L|0)<(F|0));G=K}else{L=f[y+(D<<2)>>2]|0;H=L;while(1){F=f[m+(H<<2)>>2]|0;if((F|0)<(H|0))H=F;else break}if((L|0)==(E|0))P=H;else{D=E;while(1){F=f[m+(D<<2)>>2]|0;if((F|0)<(D|0))D=F;else break}F=(H|0)>(D|0)?D:H;M=E;do{I=m+(M<<2)|0;O=M;M=f[I>>2]|0;f[I>>2]=F}while((M|0)<(O|0));P=F}F=L;do{M=m+(F<<2)|0;H=F;F=f[M>>2]|0;f[M>>2]=P}while((F|0)<(H|0));f[x+(z<<2)>>2]=P;B=A;break a}}else G=E;while(0);f[x+(z<<2)>>2]=G;B=A;break}if(C){E=z+-1|0;if(!(b[w+E>>0]|0))Q=46;else{f[x+(z<<2)>>2]=f[y+(E<<2)>>2];B=A;break}}}else if((z|0)>0)Q=46;if((Q|0)==46?(Q=0,E=z+-1|0,b[v+E>>0]|0):0){f[x+(z<<2)>>2]=f[x+(E<<2)>>2];B=A;break}f[x+(z<<2)>>2]=A;f[m+(A<<2)>>2]=A;B=A+1|0}while(0);z=z+1|0;if((z|0)==(i|0)){R=B;break}else A=B}}else R=r;s=s+1|0;if((s|0)==(h|0)){S=R;Q=81;break}else r=R}}else Q=80;else if(k){R=(i|0)>0;r=f[c+16>>2]|0;s=f[c+44>>2]|0;c=f[d+16>>2]|0;B=f[d+44>>2]|0;G=0;P=1;while(1){K=f[s>>2]|0;j=r+(Y(K,G)|0)|0;n=j+(0-K)|0;K=f[B>>2]|0;o=c+(Y(K,G)|0)|0;q=o+(0-K)|0;b:do if(R){if((G|0)>0){T=0;U=P}else{K=0;l=P;while(1){do if(!(b[j+K>>0]|0)){f[o+(K<<2)>>2]=0;V=l}else{if((K|0)>0?(e=K+-1|0,b[j+e>>0]|0):0){f[o+(K<<2)>>2]=f[o+(e<<2)>>2];V=l;break}f[o+(K<<2)>>2]=l;f[m+(l<<2)>>2]=l;V=l+1|0}while(0);K=K+1|0;if((K|0)==(i|0)){W=V;break b}else l=V}}while(1){do if(!(b[j+T>>0]|0)){f[o+(T<<2)>>2]=0;X=U}else{l=(T|0)>0;if(!(b[n+T>>0]|0)){if(l?(K=T+-1|0,b[j+K>>0]|0):0){f[o+(T<<2)>>2]=f[o+(K<<2)>>2];X=U;break}f[o+(T<<2)>>2]=U;f[m+(U<<2)>>2]=U;X=U+1|0;break}K=f[q+(T<<2)>>2]|0;if(l?(l=T+-1|0,(b[j+l>>0]|0)!=0):0){C=f[o+(l<<2)>>2]|0;l=C;while(1){e=f[m+(l<<2)>>2]|0;if((e|0)<(l|0))l=e;else break}if((C|0)==(K|0))Z=l;else{e=K;while(1){A=f[m+(e<<2)>>2]|0;if((A|0)<(e|0))e=A;else break}A=(l|0)>(e|0)?e:l;z=K;do{x=m+(z<<2)|0;v=z;z=f[x>>2]|0;f[x>>2]=A}while((z|0)<(v|0));Z=A}A=C;do{z=m+(A<<2)|0;l=A;A=f[z>>2]|0;f[z>>2]=Z}while((A|0)<(l|0));_=Z}else _=K;f[o+(T<<2)>>2]=_;X=U}while(0);T=T+1|0;if((T|0)==(i|0)){W=X;break}else U=X}}else W=P;while(0);G=G+1|0;if((G|0)==(h|0)){S=W;Q=81;break}else P=W}}else Q=80;if((Q|0)==80){l4(g,1);$=1}else if((Q|0)==81){if((S|0)>1){Q=1;W=1;while(1){P=m+(W<<2)|0;G=f[P>>2]|0;if((G|0)<(W|0)){f[P>>2]=f[m+(G<<2)>>2];aa=Q}else{f[P>>2]=Q;aa=Q+1|0}W=W+1|0;if((W|0)==(S|0)){ba=aa;break}else Q=aa}}else ba=1;l4(g,ba);if(k){k=f[d+16>>2]|0;aa=f[d+44>>2]|0;d=f[g+20>>2]|0;Q=f[g+48>>2]|0;S=f[g+120>>2]|0;W=0;do{P=k+(Y(f[aa>>2]|0,W)|0)|0;G=P+(i<<2)|0;if((P|0)!=(G|0)){X=((W|0)<0)<<31>>31;U=P;P=0;while(1){T=f[m+(f[U>>2]<<2)>>2]|0;f[U>>2]=T;_=d+(Y(f[Q>>2]|0,T)|0)|0;Z=f[_>>2]|0;f[_>>2]=(Z|0)>(P|0)?P:Z;Z=_+8|0;V=f[Z>>2]|0;f[Z>>2]=(V|0)<(P|0)?P:V;V=_+4|0;Z=f[V>>2]|0;f[V>>2]=(Z|0)>(W|0)?W:Z;Z=_+12|0;V=f[Z>>2]|0;f[Z>>2]=(V|0)<(W|0)?W:V;V=_+16|0;f[V>>2]=(f[V>>2]|0)+1;V=S+(T<<4)|0;_=V;Z=Kac(f[_>>2]|0,f[_+4>>2]|0,P|0,((P|0)<0)<<31>>31|0)|0;_=V;f[_>>2]=Z;f[_+4>>2]=J;_=S+(T<<4)+8|0;T=_;Z=Kac(f[T>>2]|0,f[T+4>>2]|0,W|0,X|0)|0;T=_;f[T>>2]=Z;f[T+4>>2]=J;U=U+4|0;if((U|0)==(G|0))break;else P=P+1|0}}W=W+1|0}while((W|0)!=(h|0));$=ba}else $=ba}ba=g+12|0;if((f[ba>>2]|0)<=0){UC(m);u=a;return $|0}h=f[g+20>>2]|0;W=f[g+48>>2]|0;S=f[g+120>>2]|0;Q=f[g+80>>2]|0;d=f[g+108>>2]|0;g=0;do{i=h+(Y(f[W>>2]|0,g)|0)|0;aa=i+8|0;f[aa>>2]=(f[aa>>2]|0)+1-(f[i>>2]|0);aa=i+12|0;f[aa>>2]=(f[aa>>2]|0)+1-(f[i+4>>2]|0);aa=Q+(Y(f[d>>2]|0,g)|0)|0;ca=+((f[i+16>>2]|0)>>>0);i=S+(g<<4)|0;p[aa>>3]=(+((f[i>>2]|0)>>>0)+4294967296.0*+((f[i+4>>2]|0)>>>0))/ca;i=S+(g<<4)+8|0;p[aa+8>>3]=(+((f[i>>2]|0)>>>0)+4294967296.0*+((f[i+4>>2]|0)>>>0))/ca;g=g+1|0}while((g|0)<(f[ba>>2]|0));UC(m);u=a;return $|0}function g4(a,c,d,e,g){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0;a=u;u=u+48|0;h=a+32|0;i=a+24|0;j=a;k=c+8|0;l=d+8|0;if((f[k>>2]|0)!=(f[l>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=aD(h,26)|0;n=235286;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,489445,235014,578);bD(h)}q=c+12|0;r=d+12|0;if((f[q>>2]|0)!=(f[r>>2]|0)){f[h>>2]=0;f[h+4>>2]=0;m=aD(h,26)|0;n=235313;o=m+26|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,489445,235014,579);bD(h)}s=(e|0)==8;switch(e|0){case 4:case 8:break;default:{f[h>>2]=0;f[h+4>>2]=0;m=aD(h,38)|0;n=267207;o=m+38|0;do{b[m>>0]=b[n>>0]|0;m=m+1|0;n=n+1|0}while((m|0)<(o|0));bO(-215,h,489445,235014,580);bD(h)}}n=UQ()|0;e=f[k>>2]|0;k=f[q>>2]|0;q=((Y(k,e)|0)+1|0)>>>1;t=TC(e<<2)|0;v=TC((q<<2)+4|0)|0;f[v>>2]=0;f[h>>2]=0;f[h+4>>2]=e;f[i>>2]=1;if(s){f[j>>2]=52032;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=v;f[j+16>>2]=t;RQ(h,j,+(n|0));s4(d,v,t);if((e|0)>0){s=(k+1|0)/2|0;q=0;do{w=q+1|0;x=(Y((w|0)/2|0,s)|0)+1|0;y=f[t+(w<<2)>>2]|0;w=y+x|0;if((y|0)>0){y=x;do{x=v+(y<<2)|0;z=f[x>>2]|0;if((z|0)<(y|0))f[x>>2]=f[v+(z<<2)>>2];else{f[x>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}y=y+1|0}while((y|0)<(w|0))}q=f[t+(q<<2)>>2]|0}while((q|0)<(e|0))}}else{f[j>>2]=52052;f[j+4>>2]=c;f[j+8>>2]=d;f[j+12>>2]=v;f[j+16>>2]=t;RQ(h,j,+(n|0));c=f[r>>2]|0;r=f[l>>2]|0;q=f[t>>2]|0;a:do if((q|0)<(r|0)){s=f[d+16>>2]|0;w=f[d+44>>2]|0;if((c|0)>0)A=q;else{y=q;while(1){y=f[t+(y<<2)>>2]|0;if((y|0)>=(r|0))break a}}do{y=f[w>>2]|0;x=s+(Y(y,A)|0)|0;z=x+(0-y)|0;y=0;do{B=x+(y<<2)|0;C=f[B>>2]|0;if((C|0)>0?(D=f[z+(y<<2)>>2]|0,(D|0)>0):0){E=D;while(1){F=f[v+(E<<2)>>2]|0;if((F|0)<(E|0))E=F;else break}if((D|0)==(C|0))G=E;else{F=C;while(1){H=f[v+(F<<2)>>2]|0;if((H|0)<(F|0))F=H;else break}H=(E|0)>(F|0)?F:E;I=C;do{K=v+(I<<2)|0;L=I;I=f[K>>2]|0;f[K>>2]=H}while((I|0)<(L|0));G=H}H=D;do{I=v+(H<<2)|0;C=H;H=f[I>>2]|0;f[I>>2]=G}while((H|0)<(C|0));f[B>>2]=G}y=y+1|0}while((y|0)!=(c|0));A=f[t+(A<<2)>>2]|0}while((A|0)<(r|0))}while(0);if((e|0)>0){r=0;do{A=(((Y(r,k)|0)+1|0)/2|0)+1|0;c=f[t+(r+1<<2)>>2]|0;G=c+A|0;if((c|0)>0){c=A;do{A=v+(c<<2)|0;q=f[A>>2]|0;if((q|0)<(c|0))f[A>>2]=f[v+(q<<2)>>2];else{f[A>>2]=f[i>>2];f[i>>2]=(f[i>>2]|0)+1}c=c+1|0}while((c|0)<(G|0))}r=f[t+(r<<2)>>2]|0}while((r|0)<(e|0))}}r=e*136|0;k=N5b(e>>>0>31580641|r>>>0>4294967291?-1:r+4|0)|0;f[k>>2]=e;r=k+4|0;if(e|0){G=r+(e*136|0)|0;e=r;do{f[e>>2]=0;f[e+4>>2]=1124007936;c=e+12|0;A=e+44|0;m=e+8|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[A>>2]=c;q=e+52|0;f[e+48>>2]=q;f[q>>2]=0;f[e+56>>2]=0;f[e+60>>2]=0;f[e+64>>2]=1124007936;q=e+72|0;s=e+104|0;m=e+68|0;o=m+36|0;do{f[m>>2]=0;m=m+4|0}while((m|0)<(o|0));f[s>>2]=q;c=e+112|0;f[e+108>>2]=c;f[c>>2]=0;f[c+4>>2]=0;f[c+8>>2]=0;f[c+12>>2]=0;f[c+16>>2]=0;f[c+20>>2]=0;e=e+136|0}while((e|0)!=(G|0))}l4(g,f[i>>2]|0);f[j>>2]=52072;f[j+4>>2]=d;f[j+8>>2]=v;f[j+12>>2]=g;f[j+16>>2]=r;f[j+20>>2]=i;RQ(h,j,+(n|0));n=f[l>>2]|0;l=f[g+132>>2]|0;if((l|0)<(n|0)){j=g+20|0;h=g+48|0;d=g+120|0;G=l;l=f[i>>2]|0;while(1){if((l|0)>0){e=r+(G*136|0)+120|0;m=f[r+(G*136|0)+20>>2]|0;o=f[r+(G*136|0)+48>>2]|0;c=0;A=l;while(1){w=m+(Y(f[o>>2]|0,c)|0)|0;y=w+16|0;if((f[y>>2]|0)>0){z=(f[j>>2]|0)+(Y(f[f[h>>2]>>2]|0,c)|0)|0;x=f[z>>2]|0;H=f[w>>2]|0;f[z>>2]=(x|0)>(H|0)?H:x;x=z+8|0;f[x>>2]=f[((f[x>>2]|0)<(f[w+8>>2]|0)?w:z)+8>>2];x=z+4|0;f[x>>2]=f[((f[x>>2]|0)>(f[w+4>>2]|0)?w:z)+4>>2];x=z+12|0;f[x>>2]=f[((f[x>>2]|0)<(f[w+12>>2]|0)?w:z)+12>>2];w=z+16|0;f[w>>2]=(f[w>>2]|0)+(f[y>>2]|0);y=f[e>>2]|0;w=y+(c<<4)|0;z=f[d>>2]|0;x=z+(c<<4)|0;H=x;D=Kac(f[H>>2]|0,f[H+4>>2]|0,f[w>>2]|0,f[w+4>>2]|0)|0;w=x;f[w>>2]=D;f[w+4>>2]=J;w=y+(c<<4)+8|0;y=z+(c<<4)+8|0;z=y;D=Kac(f[z>>2]|0,f[z+4>>2]|0,f[w>>2]|0,f[w+4>>2]|0)|0;w=y;f[w>>2]=D;f[w+4>>2]=J;M=f[i>>2]|0}else M=A;c=c+1|0;if((c|0)>=(M|0)){N=M;break}else A=M}}else N=l;G=f[r+(G*136|0)+132>>2]|0;if((G|0)>=(n|0))break;else l=N}}N=g+12|0;if((f[N>>2]|0)>0){l=f[g+20>>2]|0;n=f[g+48>>2]|0;G=f[g+120>>2]|0;M=f[g+80>>2]|0;d=f[g+108>>2]|0;g=0;do{h=l+(Y(f[n>>2]|0,g)|0)|0;j=h+8|0;f[j>>2]=(f[j>>2]|0)+1-(f[h>>2]|0);j=h+12|0;f[j>>2]=(f[j>>2]|0)+1-(f[h+4>>2]|0);j=M+(Y(f[d>>2]|0,g)|0)|0;O=+((f[h+16>>2]|0)>>>0);h=G+(g<<4)|0;p[j>>3]=(+((f[h>>2]|0)>>>0)+4294967296.0*+((f[h+4>>2]|0)>>>0))/O;h=G+(g<<4)+8|0;p[j+8>>3]=(+((f[h>>2]|0)>>>0)+4294967296.0*+((f[h+4>>2]|0)>>>0))/O;g=g+1|0}while((g|0)<(f[N>>2]|0))}N=r+((f[k>>2]|0)*136|0)|0;if((r|0)==(N|0)){P5b(k);UC(t);UC(v);P=f[i>>2]|0;u=a;return P|0}else Q=N;do{Q=Q+-136|0;d4(Q)}while((Q|0)!=(r|0));P5b(k);UC(t);UC(v);P=f[i>>2]|0;u=a;return P|0}
function E8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;e=u;u=u+208|0;g=e+176|0;h=e+112|0;i=e+88|0;j=e+64|0;k=e+48|0;l=e+160|0;m=e+36|0;n=e+148|0;o=e+136|0;p=e+124|0;q=e+24|0;r=e+12|0;s=e;t=c;v=t-a|0;a:do if((v|0)>1){w=a+2|0;if((v|0)>3?(b[a>>0]|0)==103:0){x=(b[a+1>>0]|0)==115;y=x?w:a;z=x}else{y=a;z=0}x=y+1|0;A=a+3|0;B=(w|0)!=(c|0);C=y+2|0;do switch(b[y>>0]|0){case 76:{D=H8b(a,c,d)|0;break a;break}case 84:{D=q8b(a,c,d)|0;break a;break}case 102:{D=I8b(a,c,d)|0;break a;break}case 97:{switch(b[x>>0]|0){case 97:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=OXb(489105)|0;if(E>>>0>4294967279)V5b(h);if(E>>>0<11){b[h+11>>0]=E;F=h}else{G=E+16&-16;H=V7b(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;F=H}VWb(F,489105,E)|0;b[g>>0]=0;PXb(F+E|0,g);E=J8b(w,c,h,d)|0;Y7b(h);D=(E|0)==(w|0)?a:E;break a;break}case 100:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=OXb(489123)|0;if(E>>>0>4294967279)V5b(h);if(E>>>0<11){b[h+11>>0]=E;I=h}else{H=E+16&-16;G=V7b(H)|0;f[h>>2]=G;f[h+8>>2]=H|-2147483648;f[h+4>>2]=E;I=G}VWb(I,489123,E)|0;b[g>>0]=0;PXb(I+E|0,g);E=K8b(w,c,h,d)|0;Y7b(h);D=(E|0)==(w|0)?a:E;break a;break}case 110:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=OXb(489123)|0;if(E>>>0>4294967279)V5b(h);if(E>>>0<11){b[h+11>>0]=E;J=h}else{G=E+16&-16;H=V7b(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;J=H}VWb(J,489123,E)|0;b[g>>0]=0;PXb(J+E|0,g);E=J8b(w,c,h,d)|0;Y7b(h);D=(E|0)==(w|0)?a:E;break a;break}case 78:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=OXb(489166)|0;if(E>>>0>4294967279)V5b(h);if(E>>>0<11){b[h+11>>0]=E;K=h}else{H=E+16&-16;G=V7b(H)|0;f[h>>2]=G;f[h+8>>2]=H|-2147483648;f[h+4>>2]=E;K=G}VWb(K,489166,E)|0;b[g>>0]=0;PXb(K+E|0,g);E=J8b(w,c,h,d)|0;Y7b(h);D=(E|0)==(w|0)?a:E;break a;break}case 83:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=OXb(489169)|0;if(E>>>0>4294967279)V5b(h);if(E>>>0<11){b[h+11>>0]=E;L=h}else{G=E+16&-16;H=V7b(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;L=H}VWb(L,489169,E)|0;b[g>>0]=0;PXb(L+E|0,g);E=J8b(w,c,h,d)|0;Y7b(h);D=(E|0)==(w|0)?a:E;break a;break}case 116:{D=L8b(a,c,d)|0;break a;break}case 122:{D=M8b(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 99:{switch(b[x>>0]|0){case 99:{D=N8b(a,c,d)|0;break a;break}case 108:{D=O8b(a,c,d)|0;break a;break}case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=OXb(489171)|0;if(E>>>0>4294967279)V5b(h);if(E>>>0<11){b[h+11>>0]=E;M=h}else{H=E+16&-16;G=V7b(H)|0;f[h>>2]=G;f[h+8>>2]=H|-2147483648;f[h+4>>2]=E;M=G}VWb(M,489171,E)|0;b[g>>0]=0;PXb(M+E|0,g);E=J8b(w,c,h,d)|0;Y7b(h);D=(E|0)==(w|0)?a:E;break a;break}case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;E=OXb(489173)|0;if(E>>>0>4294967279)V5b(h);if(E>>>0<11){b[h+11>>0]=E;N=h}else{G=E+16&-16;H=V7b(G)|0;f[h>>2]=H;f[h+8>>2]=G|-2147483648;f[h+4>>2]=E;N=H}VWb(N,489173,E)|0;b[g>>0]=0;PXb(N+E|0,g);E=K8b(w,c,h,d)|0;Y7b(h);D=(E|0)==(w|0)?a:E;break a;break}case 118:{D=P8b(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 100:{switch(b[x>>0]|0){case 97:{E=E8b(C,c,d)|0;if((E|0)==(C|0)){D=a;break a}H=d+4|0;if((f[d>>2]|0)==(f[H>>2]|0)){D=a;break a};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;b:do if(z){G=OXb(489175)|0;if(G>>>0>4294967279)V5b(j);if(G>>>0<11){b[j+11>>0]=G;O=j}else{P=G+16&-16;Q=V7b(P)|0;f[j>>2]=Q;f[j+8>>2]=P|-2147483648;f[j+4>>2]=G;O=Q}VWb(O,489175,G)|0;b[g>>0]=0;PXb(O+G|0,g)}else{G=0;while(1){if((G|0)==3)break b;f[j+(G<<2)>>2]=0;G=G+1|0}}while(0);e8b(j,489178)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];G=0;while(1){if((G|0)==3)break;f[j+(G<<2)>>2]=0;G=G+1|0}s8b(k,(f[H>>2]|0)+-24|0);G=b[k+11>>0]|0;Q=G<<24>>24<0;K7b(i,Q?f[k>>2]|0:k,Q?f[k+4>>2]|0:G&255)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];G=0;while(1){if((G|0)==3)break;f[i+(G<<2)>>2]=0;G=G+1|0}G=f[H>>2]|0;Q=G+-24|0;P=Q+11|0;if((b[P>>0]|0)<0){R=f[Q>>2]|0;b[g>>0]=0;PXb(R,g);f[G+-20>>2]=0}else{b[g>>0]=0;PXb(Q,g);b[P>>0]=0}F8b(Q);f[Q>>2]=f[h>>2];f[Q+4>>2]=f[h+4>>2];f[Q+8>>2]=f[h+8>>2];Q=0;while(1){if((Q|0)==3)break;f[h+(Q<<2)>>2]=0;Q=Q+1|0}Y7b(h);Y7b(k);Y7b(i);Y7b(j);D=E;break a;break}case 99:{D=Q8b(a,c,d)|0;break a;break}case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=OXb(489121)|0;if(Q>>>0>4294967279)V5b(h);if(Q>>>0<11){b[h+11>>0]=Q;S=h}else{H=Q+16&-16;P=V7b(H)|0;f[h>>2]=P;f[h+8>>2]=H|-2147483648;f[h+4>>2]=Q;S=P}VWb(S,489121,Q)|0;b[g>>0]=0;PXb(S+Q|0,g);Q=K8b(w,c,h,d)|0;Y7b(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 108:{Q=E8b(C,c,d)|0;if((Q|0)==(C|0)){D=a;break a}P=d+4|0;if((f[d>>2]|0)==(f[P>>2]|0)){D=a;break a};f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;c:do if(z){H=OXb(489175)|0;if(H>>>0>4294967279)V5b(j);if(H>>>0<11){b[j+11>>0]=H;T=j}else{G=H+16&-16;R=V7b(G)|0;f[j>>2]=R;f[j+8>>2]=G|-2147483648;f[j+4>>2]=H;T=R}VWb(T,489175,H)|0;b[g>>0]=0;PXb(T+H|0,g)}else{H=0;while(1){if((H|0)==3)break c;f[j+(H<<2)>>2]=0;H=H+1|0}}while(0);e8b(j,489188)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];E=0;while(1){if((E|0)==3)break;f[j+(E<<2)>>2]=0;E=E+1|0}s8b(k,(f[P>>2]|0)+-24|0);E=b[k+11>>0]|0;H=E<<24>>24<0;K7b(i,H?f[k>>2]|0:k,H?f[k+4>>2]|0:E&255)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];E=0;while(1){if((E|0)==3)break;f[i+(E<<2)>>2]=0;E=E+1|0}E=f[P>>2]|0;H=E+-24|0;R=H+11|0;if((b[R>>0]|0)<0){G=f[H>>2]|0;b[g>>0]=0;PXb(G,g);f[E+-20>>2]=0}else{b[g>>0]=0;PXb(H,g);b[R>>0]=0}F8b(H);f[H>>2]=f[h>>2];f[H+4>>2]=f[h+4>>2];f[H+8>>2]=f[h+8>>2];H=0;while(1){if((H|0)==3)break;f[h+(H<<2)>>2]=0;H=H+1|0}Y7b(h);Y7b(k);Y7b(i);Y7b(j);D=Q;break a;break}case 110:{D=R8b(a,c,d)|0;break a;break}case 115:{D=S8b(a,c,d)|0;break a;break}case 116:{D=T8b(a,c,d)|0;break a;break}case 118:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=OXb(489196)|0;if(H>>>0>4294967279)V5b(h);if(H>>>0<11){b[h+11>>0]=H;U=h}else{P=H+16&-16;R=V7b(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;U=R}VWb(U,489196,H)|0;b[g>>0]=0;PXb(U+H|0,g);H=J8b(w,c,h,d)|0;Y7b(h);D=(H|0)==(w|0)?a:H;break a;break}case 86:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=OXb(489198)|0;if(H>>>0>4294967279)V5b(h);if(H>>>0<11){b[h+11>>0]=H;V=h}else{R=H+16&-16;P=V7b(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;V=P}VWb(V,489198,H)|0;b[g>>0]=0;PXb(V+H|0,g);H=J8b(w,c,h,d)|0;Y7b(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 101:{switch(b[x>>0]|0){case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=OXb(489201)|0;if(H>>>0>4294967279)V5b(h);if(H>>>0<11){b[h+11>>0]=H;W=h}else{P=H+16&-16;R=V7b(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;W=R}VWb(W,489201,H)|0;b[g>>0]=0;PXb(W+H|0,g);H=J8b(w,c,h,d)|0;Y7b(h);D=(H|0)==(w|0)?a:H;break a;break}case 79:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=OXb(489203)|0;if(H>>>0>4294967279)V5b(h);if(H>>>0<11){b[h+11>>0]=H;X=h}else{R=H+16&-16;P=V7b(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;X=P}VWb(X,489203,H)|0;b[g>>0]=0;PXb(X+H|0,g);H=J8b(w,c,h,d)|0;Y7b(h);D=(H|0)==(w|0)?a:H;break a;break}case 113:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=OXb(489206)|0;if(H>>>0>4294967279)V5b(h);if(H>>>0<11){b[h+11>>0]=H;Y=h}else{P=H+16&-16;R=V7b(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;Y=R}VWb(Y,489206,H)|0;b[g>>0]=0;PXb(Y+H|0,g);H=J8b(w,c,h,d)|0;Y7b(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 103:{switch(b[x>>0]|0){case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=OXb(489209)|0;if(H>>>0>4294967279)V5b(h);if(H>>>0<11){b[h+11>>0]=H;Z=h}else{R=H+16&-16;P=V7b(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;Z=P}VWb(Z,489209,H)|0;b[g>>0]=0;PXb(Z+H|0,g);H=J8b(w,c,h,d)|0;Y7b(h);D=(H|0)==(w|0)?a:H;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=OXb(489139)|0;if(H>>>0>4294967279)V5b(h);if(H>>>0<11){b[h+11>>0]=H;_=h}else{P=H+16&-16;R=V7b(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=H;_=R}VWb(_,489139,H)|0;b[g>>0]=0;PXb(_+H|0,g);H=J8b(w,c,h,d)|0;Y7b(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 105:{if((b[x>>0]|0)!=120){D=a;break a}H=E8b(w,c,d)|0;if((H|0)==(w|0)){D=a;break a}R=E8b(H,c,d)|0;P=d+4|0;if((R|0)==(H|0)){H=f[P>>2]|0;E=H+-24|0;G=H;while(1){if((G|0)==(E|0)){D=a;break a}H=G+-24|0;f[P>>2]=H;H7b(H);G=f[P>>2]|0}}G=f[P>>2]|0;if(((G-(f[d>>2]|0)|0)/24|0)>>>0<2){D=a;break a}s8b(g,G+-24|0);G=f[P>>2]|0;E=G+-24|0;Q=G;while(1){if((Q|0)==(E|0))break;H=Q+-24|0;f[P>>2]=H;H7b(H);Q=f[P>>2]|0}s8b(h,G+-48|0);G8b(m,489103,h);e8b(m,489212)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];Q=0;while(1){if((Q|0)==3)break;f[m+(Q<<2)>>2]=0;Q=Q+1|0}Q=b[g+11>>0]|0;G=Q<<24>>24<0;K7b(k,G?f[g>>2]|0:g,G?f[g+4>>2]|0:Q&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];Q=0;while(1){if((Q|0)==3)break;f[k+(Q<<2)>>2]=0;Q=Q+1|0}e8b(j,489150)|0;f[l>>2]=f[j>>2];f[l+4>>2]=f[j+4>>2];f[l+8>>2]=f[j+8>>2];Q=0;while(1){if((Q|0)==3)break;f[j+(Q<<2)>>2]=0;Q=Q+1|0}v8b(i,l);w8b((f[P>>2]|0)+-24|0,i);H7b(i);Y7b(l);Y7b(j);Y7b(k);Y7b(m);Y7b(h);Y7b(g);D=R;break a;break}case 108:{switch(b[x>>0]|0){case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=OXb(489215)|0;if(Q>>>0>4294967279)V5b(h);if(Q>>>0<11){b[h+11>>0]=Q;$=h}else{G=Q+16&-16;E=V7b(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;$=E}VWb($,489215,Q)|0;b[g>>0]=0;PXb($+Q|0,g);Q=J8b(w,c,h,d)|0;Y7b(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=OXb(489218)|0;if(Q>>>0>4294967279)V5b(h);if(Q>>>0<11){b[h+11>>0]=Q;aa=h}else{E=Q+16&-16;G=V7b(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;aa=G}VWb(aa,489218,Q)|0;b[g>>0]=0;PXb(aa+Q|0,g);Q=J8b(w,c,h,d)|0;Y7b(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 83:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=OXb(489221)|0;if(Q>>>0>4294967279)V5b(h);if(Q>>>0<11){b[h+11>>0]=Q;ba=h}else{G=Q+16&-16;E=V7b(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;ba=E}VWb(ba,489221,Q)|0;b[g>>0]=0;PXb(ba+Q|0,g);Q=J8b(w,c,h,d)|0;Y7b(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=OXb(489137)|0;if(Q>>>0>4294967279)V5b(h);if(Q>>>0<11){b[h+11>>0]=Q;ca=h}else{E=Q+16&-16;G=V7b(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;ca=G}VWb(ca,489137,Q)|0;b[g>>0]=0;PXb(ca+Q|0,g);Q=J8b(w,c,h,d)|0;Y7b(h);D=(Q|0)==(w|0)?a:Q;break a;break}default:{D=a;break a}}break}case 109:{switch(b[x>>0]|0){case 105:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=OXb(489225)|0;if(Q>>>0>4294967279)V5b(h);if(Q>>>0<11){b[h+11>>0]=Q;da=h}else{G=Q+16&-16;E=V7b(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;da=E}VWb(da,489225,Q)|0;b[g>>0]=0;PXb(da+Q|0,g);Q=J8b(w,c,h,d)|0;Y7b(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 73:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=OXb(489227)|0;if(Q>>>0>4294967279)V5b(h);if(Q>>>0<11){b[h+11>>0]=Q;ea=h}else{E=Q+16&-16;G=V7b(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;ea=G}VWb(ea,489227,Q)|0;b[g>>0]=0;PXb(ea+Q|0,g);Q=J8b(w,c,h,d)|0;Y7b(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 108:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=OXb(489121)|0;if(Q>>>0>4294967279)V5b(h);if(Q>>>0<11){b[h+11>>0]=Q;fa=h}else{G=Q+16&-16;E=V7b(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;fa=E}VWb(fa,489121,Q)|0;b[g>>0]=0;PXb(fa+Q|0,g);Q=J8b(w,c,h,d)|0;Y7b(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 76:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=OXb(489230)|0;if(Q>>>0>4294967279)V5b(h);if(Q>>>0<11){b[h+11>>0]=Q;ga=h}else{E=Q+16&-16;G=V7b(E)|0;f[h>>2]=G;f[h+8>>2]=E|-2147483648;f[h+4>>2]=Q;ga=G}VWb(ga,489230,Q)|0;b[g>>0]=0;PXb(ga+Q|0,g);Q=J8b(w,c,h,d)|0;Y7b(h);D=(Q|0)==(w|0)?a:Q;break a;break}case 109:{if(B?(b[w>>0]|0)==95:0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;Q=OXb(489233)|0;if(Q>>>0>4294967279)V5b(h);if(Q>>>0<11){b[h+11>>0]=Q;ha=h}else{G=Q+16&-16;E=V7b(G)|0;f[h>>2]=E;f[h+8>>2]=G|-2147483648;f[h+4>>2]=Q;ha=E}VWb(ha,489233,Q)|0;b[g>>0]=0;PXb(ha+Q|0,g);Q=K8b(A,c,h,d)|0;Y7b(h);D=(Q|0)==(A|0)?a:Q;break a}Q=E8b(w,c,d)|0;if((Q|0)==(w|0)){D=a;break a}E=d+4|0;G=f[E>>2]|0;if((f[d>>2]|0)==(G|0)){D=a;break a}s8b(i,G+-24|0);d8b(i,0,489103)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];G=0;while(1){if((G|0)==3)break;f[i+(G<<2)>>2]=0;G=G+1|0}e8b(h,489236)|0;f[n>>2]=f[h>>2];f[n+4>>2]=f[h+4>>2];f[n+8>>2]=f[h+8>>2];G=0;while(1){if((G|0)==3)break;f[h+(G<<2)>>2]=0;G=G+1|0}v8b(g,n);w8b((f[E>>2]|0)+-24|0,g);H7b(g);Y7b(n);Y7b(h);Y7b(i);D=Q;break a;break}default:{D=a;break a}}break}case 110:{switch(b[x>>0]|0){case 119:case 97:{D=U8b(a,c,d)|0;break a;break}case 101:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=OXb(489240)|0;if(G>>>0>4294967279)V5b(h);if(G>>>0<11){b[h+11>>0]=G;ia=h}else{R=G+16&-16;P=V7b(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;ia=P}VWb(ia,489240,G)|0;b[g>>0]=0;PXb(ia+G|0,g);G=J8b(w,c,h,d)|0;Y7b(h);D=(G|0)==(w|0)?a:G;break a;break}case 103:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=OXb(489225)|0;if(G>>>0>4294967279)V5b(h);if(G>>>0<11){b[h+11>>0]=G;ja=h}else{P=G+16&-16;R=V7b(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;ja=R}VWb(ja,489225,G)|0;b[g>>0]=0;PXb(ja+G|0,g);G=K8b(w,c,h,d)|0;Y7b(h);D=(G|0)==(w|0)?a:G;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=OXb(489243)|0;if(G>>>0>4294967279)V5b(h);if(G>>>0<11){b[h+11>>0]=G;ka=h}else{R=G+16&-16;P=V7b(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;ka=P}VWb(ka,489243,G)|0;b[g>>0]=0;PXb(ka+G|0,g);G=K8b(w,c,h,d)|0;Y7b(h);D=(G|0)==(w|0)?a:G;break a;break}case 120:{G=V8b(w,c,d)|0;D=(G|0)==(w|0)?a:G;break a;break}default:{D=a;break a}}break}case 111:{switch(b[x>>0]|0){case 110:{D=R8b(a,c,d)|0;break a;break}case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=OXb(489245)|0;if(G>>>0>4294967279)V5b(h);if(G>>>0<11){b[h+11>>0]=G;la=h}else{P=G+16&-16;R=V7b(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;la=R}VWb(la,489245,G)|0;b[g>>0]=0;PXb(la+G|0,g);G=J8b(w,c,h,d)|0;Y7b(h);D=(G|0)==(w|0)?a:G;break a;break}case 114:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=OXb(489248)|0;if(G>>>0>4294967279)V5b(h);if(G>>>0<11){b[h+11>>0]=G;ma=h}else{R=G+16&-16;P=V7b(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;ma=P}VWb(ma,489248,G)|0;b[g>>0]=0;PXb(ma+G|0,g);G=J8b(w,c,h,d)|0;Y7b(h);D=(G|0)==(w|0)?a:G;break a;break}case 82:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=OXb(489250)|0;if(G>>>0>4294967279)V5b(h);if(G>>>0<11){b[h+11>>0]=G;na=h}else{P=G+16&-16;R=V7b(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;na=R}VWb(na,489250,G)|0;b[g>>0]=0;PXb(na+G|0,g);G=J8b(w,c,h,d)|0;Y7b(h);D=(G|0)==(w|0)?a:G;break a;break}default:{D=a;break a}}break}case 112:{switch(b[x>>0]|0){case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=OXb(489253)|0;if(G>>>0>4294967279)V5b(h);if(G>>>0<11){b[h+11>>0]=G;oa=h}else{R=G+16&-16;P=V7b(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;oa=P}VWb(oa,489253,G)|0;b[g>>0]=0;PXb(oa+G|0,g);G=J8b(w,c,h,d)|0;Y7b(h);D=(G|0)==(w|0)?a:G;break a;break}case 108:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=OXb(489257)|0;if(G>>>0>4294967279)V5b(h);if(G>>>0<11){b[h+11>>0]=G;pa=h}else{P=G+16&-16;R=V7b(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;pa=R}VWb(pa,489257,G)|0;b[g>>0]=0;PXb(pa+G|0,g);G=J8b(w,c,h,d)|0;Y7b(h);D=(G|0)==(w|0)?a:G;break a;break}case 76:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=OXb(489259)|0;if(G>>>0>4294967279)V5b(h);if(G>>>0<11){b[h+11>>0]=G;qa=h}else{R=G+16&-16;P=V7b(R)|0;f[h>>2]=P;f[h+8>>2]=R|-2147483648;f[h+4>>2]=G;qa=P}VWb(qa,489259,G)|0;b[g>>0]=0;PXb(qa+G|0,g);G=J8b(w,c,h,d)|0;Y7b(h);D=(G|0)==(w|0)?a:G;break a;break}case 112:{if(B?(b[w>>0]|0)==95:0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;G=OXb(489262)|0;if(G>>>0>4294967279)V5b(h);if(G>>>0<11){b[h+11>>0]=G;ra=h}else{P=G+16&-16;R=V7b(P)|0;f[h>>2]=R;f[h+8>>2]=P|-2147483648;f[h+4>>2]=G;ra=R}VWb(ra,489262,G)|0;b[g>>0]=0;PXb(ra+G|0,g);G=K8b(A,c,h,d)|0;Y7b(h);D=(G|0)==(A|0)?a:G;break a}G=E8b(w,c,d)|0;if((G|0)==(w|0)){D=a;break a}R=d+4|0;P=f[R>>2]|0;if((f[d>>2]|0)==(P|0)){D=a;break a}s8b(i,P+-24|0);d8b(i,0,489103)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];P=0;while(1){if((P|0)==3)break;f[i+(P<<2)>>2]=0;P=P+1|0}e8b(h,489265)|0;f[o>>2]=f[h>>2];f[o+4>>2]=f[h+4>>2];f[o+8>>2]=f[h+8>>2];P=0;while(1){if((P|0)==3)break;f[h+(P<<2)>>2]=0;P=P+1|0}v8b(g,o);w8b((f[R>>2]|0)+-24|0,g);H7b(g);Y7b(o);Y7b(h);Y7b(i);D=G;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;P=OXb(489257)|0;if(P>>>0>4294967279)V5b(h);if(P>>>0<11){b[h+11>>0]=P;sa=h}else{Q=P+16&-16;E=V7b(Q)|0;f[h>>2]=E;f[h+8>>2]=Q|-2147483648;f[h+4>>2]=P;sa=E}VWb(sa,489257,P)|0;b[g>>0]=0;PXb(sa+P|0,g);P=K8b(w,c,h,d)|0;Y7b(h);D=(P|0)==(w|0)?a:P;break a;break}case 116:{D=W8b(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 113:{if((b[x>>0]|0)!=117){D=a;break a}P=E8b(w,c,d)|0;if((P|0)==(w|0)){D=a;break a}E=E8b(P,c,d)|0;if((E|0)==(P|0)){P=d+4|0;Q=f[P>>2]|0;H=Q+-24|0;ta=Q;while(1){if((ta|0)==(H|0)){D=a;break a}Q=ta+-24|0;f[P>>2]=Q;H7b(Q);ta=f[P>>2]|0}}P=E8b(E,c,d)|0;ta=d+4|0;if((P|0)==(E|0)){H=f[ta>>2]|0;G=H+-24|0;R=H;while(1){if((R|0)==(G|0))break;Q=R+-24|0;f[ta>>2]=Q;H7b(Q);R=f[ta>>2]|0}R=H+-48|0;E=G;while(1){if((E|0)==(R|0)){D=a;break a}Q=E+-24|0;f[ta>>2]=Q;H7b(Q);E=f[ta>>2]|0}}E=f[ta>>2]|0;if(((E-(f[d>>2]|0)|0)/24|0)>>>0<3){D=a;break a}s8b(g,E+-24|0);E=f[ta>>2]|0;R=E+-24|0;G=E;while(1){if((G|0)==(R|0))break;H=G+-24|0;f[ta>>2]=H;H7b(H);G=f[ta>>2]|0}s8b(h,E+-48|0);G=f[ta>>2]|0;R=G+-24|0;H=G;while(1){if((H|0)==(R|0))break;Q=H+-24|0;f[ta>>2]=Q;H7b(Q);H=f[ta>>2]|0}s8b(i,G+-48|0);G8b(s,489103,i);e8b(s,489269)|0;f[r>>2]=f[s>>2];f[r+4>>2]=f[s+4>>2];f[r+8>>2]=f[s+8>>2];H=0;while(1){if((H|0)==3)break;f[s+(H<<2)>>2]=0;H=H+1|0}H=b[h+11>>0]|0;G=H<<24>>24<0;K7b(r,G?f[h>>2]|0:h,G?f[h+4>>2]|0:H&255)|0;f[q>>2]=f[r>>2];f[q+4>>2]=f[r+4>>2];f[q+8>>2]=f[r+8>>2];H=0;while(1){if((H|0)==3)break;f[r+(H<<2)>>2]=0;H=H+1|0}e8b(q,489275)|0;f[m>>2]=f[q>>2];f[m+4>>2]=f[q+4>>2];f[m+8>>2]=f[q+8>>2];H=0;while(1){if((H|0)==3)break;f[q+(H<<2)>>2]=0;H=H+1|0}H=b[g+11>>0]|0;G=H<<24>>24<0;K7b(m,G?f[g>>2]|0:g,G?f[g+4>>2]|0:H&255)|0;f[k>>2]=f[m>>2];f[k+4>>2]=f[m+4>>2];f[k+8>>2]=f[m+8>>2];H=0;while(1){if((H|0)==3)break;f[m+(H<<2)>>2]=0;H=H+1|0}e8b(k,489101)|0;f[p>>2]=f[k>>2];f[p+4>>2]=f[k+4>>2];f[p+8>>2]=f[k+8>>2];H=0;while(1){if((H|0)==3)break;f[k+(H<<2)>>2]=0;H=H+1|0}v8b(j,p);w8b((f[ta>>2]|0)+-24|0,j);H7b(j);Y7b(p);Y7b(k);Y7b(m);Y7b(q);Y7b(r);Y7b(s);Y7b(i);Y7b(h);Y7b(g);D=P;break a;break}case 114:{switch(b[x>>0]|0){case 99:{D=X8b(a,c,d)|0;break a;break}case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=OXb(489281)|0;if(H>>>0>4294967279)V5b(h);if(H>>>0<11){b[h+11>>0]=H;ua=h}else{G=H+16&-16;R=V7b(G)|0;f[h>>2]=R;f[h+8>>2]=G|-2147483648;f[h+4>>2]=H;ua=R}VWb(ua,489281,H)|0;b[g>>0]=0;PXb(ua+H|0,g);H=J8b(w,c,h,d)|0;Y7b(h);D=(H|0)==(w|0)?a:H;break a;break}case 77:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=OXb(489283)|0;if(H>>>0>4294967279)V5b(h);if(H>>>0<11){b[h+11>>0]=H;va=h}else{R=H+16&-16;G=V7b(R)|0;f[h>>2]=G;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;va=G}VWb(va,489283,H)|0;b[g>>0]=0;PXb(va+H|0,g);H=J8b(w,c,h,d)|0;Y7b(h);D=(H|0)==(w|0)?a:H;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=OXb(489286)|0;if(H>>>0>4294967279)V5b(h);if(H>>>0<11){b[h+11>>0]=H;wa=h}else{G=H+16&-16;R=V7b(G)|0;f[h>>2]=R;f[h+8>>2]=G|-2147483648;f[h+4>>2]=H;wa=R}VWb(wa,489286,H)|0;b[g>>0]=0;PXb(wa+H|0,g);H=J8b(w,c,h,d)|0;Y7b(h);D=(H|0)==(w|0)?a:H;break a;break}case 83:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;H=OXb(489289)|0;if(H>>>0>4294967279)V5b(h);if(H>>>0<11){b[h+11>>0]=H;xa=h}else{R=H+16&-16;G=V7b(R)|0;f[h>>2]=G;f[h+8>>2]=R|-2147483648;f[h+4>>2]=H;xa=G}VWb(xa,489289,H)|0;b[g>>0]=0;PXb(xa+H|0,g);H=J8b(w,c,h,d)|0;Y7b(h);D=(H|0)==(w|0)?a:H;break a;break}default:{D=a;break a}}break}case 115:{switch(b[x>>0]|0){case 99:{D=Y8b(a,c,d)|0;break a;break}case 112:{D=Z8b(a,c,d)|0;break a;break}case 114:{D=R8b(a,c,d)|0;break a;break}case 116:{D=_8b(a,c,d)|0;break a;break}case 122:{D=$8b(a,c,d)|0;break a;break}case 90:{if((t-y|0)<=2){D=a;break a}switch(b[C>>0]|0){case 84:{D=a9b(a,c,d)|0;break a;break}case 102:{D=b9b(a,c,d)|0;break a;break}default:{D=a;break a}}break}default:{D=a;break a}}break}case 116:{switch(b[x>>0]|0){case 105:case 101:{D=c9b(a,c,d)|0;break a;break}case 114:{d9b(g,489293);H=d+4|0;G=f[H>>2]|0;if(G>>>0<(f[d+8>>2]|0)>>>0){x8b(G,g);f[H>>2]=(f[H>>2]|0)+24}else y8b(d,g);H7b(g);D=w;break a;break}case 119:{D=e9b(a,c,d)|0;break a;break}default:{D=a;break a}}break}case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:{D=R8b(a,c,d)|0;break a;break}default:{D=a;break a}}while(0)}else D=a;while(0);u=e;return D|0}function F8b(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;c=a+11|0;d=b[c>>0]|0;if(d<<24>>24<0){e=f[a+4>>2]|0;g=(f[a+8>>2]&2147483647)+-1|0}else{e=d&255;g=10}h=e>>>0<11;i=h?10:(e+16&-16)+-1|0;a:do if((i|0)!=(g|0)){do if(h){j=f[a>>2]|0;if(d<<24>>24<0){k=0;l=j;m=a;n=12}else{VWb(a,j,(d&255)+1|0)|0;W7b(j);n=14}}else{j=V7b(i+1|0)|0;if(i>>>0<=g>>>0&(j|0)==0)break a;o=b[c>>0]|0;if(o<<24>>24<0){k=1;l=f[a>>2]|0;m=j;n=12;break}else{VWb(j,a,(o&255)+1|0)|0;p=j;n=13;break}}while(0);if((n|0)==12){VWb(m,l,(f[a+4>>2]|0)+1|0)|0;W7b(l);if(k){p=m;n=13}else n=14}if((n|0)==13){f[a+8>>2]=i+1|-2147483648;f[a+4>>2]=e;f[a>>2]=p;break}else if((n|0)==14){b[c>>0]=e;break}}while(0);return}function G8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;h=0;while(1){if((h|0)==3)break;f[a+(h<<2)>>2]=0;h=h+1|0}h=OXb(c)|0;i=d+11|0;j=b[i>>0]|0;k=j<<24>>24<0?f[d+4>>2]|0:j&255;j=k+h|0;if(j>>>0>4294967279)V5b(a);if(j>>>0<11){b[a+11>>0]=h;l=a}else{m=j+16&-16;j=V7b(m)|0;f[a>>2]=j;f[a+8>>2]=m|-2147483648;f[a+4>>2]=h;l=j}VWb(l,c,h)|0;b[g>>0]=0;PXb(l+h|0,g);K7b(a,(b[i>>0]|0)<0?f[d>>2]|0:d,k)|0;u=e;return}function H8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=u;u=u+112|0;g=e+88|0;h=e+48|0;i=e+72|0;j=e+36|0;k=e+24|0;l=e+12|0;m=e;a:do if((c-a|0)>3?(b[a>>0]|0)==76:0){n=a+1|0;o=a+3|0;p=a+2|0;do switch(b[n>>0]|0){case 84:{q=a;break a;break}case 119:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(490295)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;s=h}else{t=r+16&-16;v=V7b(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;s=v}VWb(s,490295,r)|0;b[g>>0]=0;PXb(s+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 98:{if((b[o>>0]|0)!=69){q=a;break a}r=a+4|0;switch(b[p>>0]|0){case 48:{d9b(g,490303);v=d+4|0;t=f[v>>2]|0;if(t>>>0<(f[d+8>>2]|0)>>>0){x8b(t,g);f[v>>2]=(f[v>>2]|0)+24}else y8b(d,g);H7b(g);q=r;break a;break}case 49:{M9b(g,490309);v=d+4|0;t=f[v>>2]|0;if(t>>>0<(f[d+8>>2]|0)>>>0){x8b(t,g);f[v>>2]=(f[v>>2]|0)+24}else y8b(d,g);H7b(g);q=r;break a;break}default:{q=a;break a}}break}case 99:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(490314)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;w=h}else{v=r+16&-16;t=V7b(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;w=t}VWb(w,490314,r)|0;b[g>>0]=0;PXb(w+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 97:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(490319)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;x=h}else{t=r+16&-16;v=V7b(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;x=v}VWb(x,490319,r)|0;b[g>>0]=0;PXb(x+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 104:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(490331)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;y=h}else{v=r+16&-16;t=V7b(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;y=t}VWb(y,490331,r)|0;b[g>>0]=0;PXb(y+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 115:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(490345)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;z=h}else{t=r+16&-16;v=V7b(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;z=v}VWb(z,490345,r)|0;b[g>>0]=0;PXb(z+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 116:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(490351)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;A=h}else{v=r+16&-16;t=V7b(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;A=t}VWb(A,490351,r)|0;b[g>>0]=0;PXb(A+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 105:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(1124530)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;B=h}else{t=r+16&-16;v=V7b(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;B=v}VWb(B,1124530,r)|0;b[g>>0]=0;PXb(B+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 106:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(490366)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;C=h}else{v=r+16&-16;t=V7b(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;C=t}VWb(C,490366,r)|0;b[g>>0]=0;PXb(C+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 108:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(490368)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;D=h}else{t=r+16&-16;v=V7b(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;D=v}VWb(D,490368,r)|0;b[g>>0]=0;PXb(D+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 109:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(490370)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;E=h}else{v=r+16&-16;t=V7b(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;E=t}VWb(E,490370,r)|0;b[g>>0]=0;PXb(E+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 120:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(490373)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;F=h}else{t=r+16&-16;v=V7b(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;F=v}VWb(F,490373,r)|0;b[g>>0]=0;PXb(F+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 121:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(490376)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;G=h}else{v=r+16&-16;t=V7b(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;G=t}VWb(G,490376,r)|0;b[g>>0]=0;PXb(G+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 110:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(490380)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;H=h}else{t=r+16&-16;v=V7b(t)|0;f[h>>2]=v;f[h+8>>2]=t|-2147483648;f[h+4>>2]=r;H=v}VWb(H,490380,r)|0;b[g>>0]=0;PXb(H+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 111:{f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;r=OXb(490389)|0;if(r>>>0>4294967279)V5b(h);if(r>>>0<11){b[h+11>>0]=r;I=h}else{v=r+16&-16;t=V7b(v)|0;f[h>>2]=t;f[h+8>>2]=v|-2147483648;f[h+4>>2]=r;I=t}VWb(I,490389,r)|0;b[g>>0]=0;PXb(I+r|0,g);r=L9b(p,c,h,d)|0;Y7b(h);q=(r|0)==(p|0)?a:r;break a;break}case 102:{r=N9b(p,c,d)|0;q=(r|0)==(p|0)?a:r;break a;break}case 100:{r=O9b(p,c,d)|0;q=(r|0)==(p|0)?a:r;break a;break}case 101:{r=P9b(p,c,d)|0;q=(r|0)==(p|0)?a:r;break a;break}case 95:{if((b[p>>0]|0)!=90){q=a;break a}r=Z7b(o,c,d)|0;if((r|0)==(o|0)|(r|0)==(c|0)){q=a;break a}q=(b[r>>0]|0)==69?r+1|0:a;break a;break}default:{r=a8b(n,c,d)|0;if((r|0)==(n|0)|(r|0)==(c|0)){q=a;break a}if((b[r>>0]|0)==69){q=r+1|0;break a}else J=r;while(1){K=J+1|0;if((J|0)==(c|0)){q=a;break a}L=b[J>>0]|0;if(((L<<24>>24)+-48|0)>>>0<10)J=K;else break}if(!((J|0)!=(r|0)&L<<24>>24==69)){q=a;break a}t=d+4|0;v=f[t>>2]|0;if((f[d>>2]|0)==(v|0)){q=a;break a}s8b(l,v+-24|0);d8b(l,0,489103)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];v=0;while(1){if((v|0)==3)break;f[l+(v<<2)>>2]=0;v=v+1|0}e8b(k,489101)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];v=0;while(1){if((v|0)==3)break;f[k+(v<<2)>>2]=0;v=v+1|0}f[m>>2]=0;f[m+4>>2]=0;f[m+8>>2]=0;v=J-r|0;if(v>>>0>4294967279)V5b(m);if(v>>>0<11){b[m+11>>0]=v;M=m}else{N=v+16&-16;O=V7b(N)|0;f[m>>2]=O;f[m+8>>2]=N|-2147483648;f[m+4>>2]=v;M=O}O=r;N=M;while(1){if((O|0)==(J|0))break;PXb(N,O);O=O+1|0;N=N+1|0}b[g>>0]=0;PXb(M+v|0,g);N=b[m+11>>0]|0;O=N<<24>>24<0;K7b(j,O?f[m>>2]|0:m,O?f[m+4>>2]|0:N&255)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];N=0;while(1){if((N|0)==3)break;f[j+(N<<2)>>2]=0;N=N+1|0}v8b(h,i);w8b((f[t>>2]|0)+-24|0,h);H7b(h);Y7b(i);Y7b(m);Y7b(j);Y7b(k);Y7b(l);q=K;break a}}while(0)}else q=a;while(0);u=e;return q|0}function I8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+80|0;g=e+64|0;h=e+60|0;i=e+24|0;j=e+48|0;k=e+12|0;l=e;a:do if((c-a|0)>2?(b[a>>0]|0)==102:0){m=a+2|0;switch(b[a+1>>0]|0){case 112:{n=b8b(m,c,h)|0;o=D8b(n,c)|0;if((o|0)!=(c|0)?(b[o>>0]|0)==95:0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;p=o-n|0;if(p>>>0>4294967279)V5b(k);if(p>>>0<11){b[k+11>>0]=p;q=k}else{r=p+16&-16;s=V7b(r)|0;f[k>>2]=s;f[k+8>>2]=r|-2147483648;f[k+4>>2]=p;q=s}s=n;n=q;while(1){if((s|0)==(o|0))break;PXb(n,s);s=s+1|0;n=n+1|0}b[g>>0]=0;PXb(q+p|0,g);d8b(k,0,490292)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];n=0;while(1){if((n|0)==3)break;f[k+(n<<2)>>2]=0;n=n+1|0}v8b(i,j);n=d+4|0;p=f[n>>2]|0;if(p>>>0<(f[d+8>>2]|0)>>>0){x8b(p,i);f[n>>2]=(f[n>>2]|0)+24}else y8b(d,i);H7b(i);Y7b(j);Y7b(k);t=o+1|0}else t=a;v=t;break a;break}case 76:break;default:{v=a;break a}}n=D8b(m,c)|0;if((((n|0)!=(c|0)?(b[n>>0]|0)==112:0)?(p=b8b(n+1|0,c,h)|0,n=D8b(p,c)|0,(n|0)!=(c|0)):0)?(b[n>>0]|0)==95:0){f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;s=n-p|0;if(s>>>0>4294967279)V5b(k);if(s>>>0<11){b[k+11>>0]=s;w=k}else{r=s+16&-16;x=V7b(r)|0;f[k>>2]=x;f[k+8>>2]=r|-2147483648;f[k+4>>2]=s;w=x}x=p;p=w;while(1){if((x|0)==(n|0))break;PXb(p,x);x=x+1|0;p=p+1|0}b[g>>0]=0;PXb(w+s|0,g);d8b(k,0,490292)|0;f[l>>2]=f[k>>2];f[l+4>>2]=f[k+4>>2];f[l+8>>2]=f[k+8>>2];p=0;while(1){if((p|0)==3)break;f[k+(p<<2)>>2]=0;p=p+1|0}v8b(i,l);p=d+4|0;s=f[p>>2]|0;if(s>>>0<(f[d+8>>2]|0)>>>0){x8b(s,i);f[p>>2]=(f[p>>2]|0)+24}else y8b(d,i);H7b(i);Y7b(l);Y7b(k);y=n+1|0}else y=a;v=y}else v=a;while(0);u=e;return v|0}function J8b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;g=u;u=u+96|0;h=g+84|0;i=g+72|0;j=g+60|0;k=g+48|0;l=g+36|0;m=g+24|0;n=g+12|0;o=g;p=E8b(a,c,e)|0;a:do if((p|0)!=(a|0)){q=E8b(p,c,e)|0;r=e+4|0;if((q|0)==(p|0)){s=f[r>>2]|0;t=s+-24|0;v=s;while(1){if((v|0)==(t|0)){w=a;break a}s=v+-24|0;f[r>>2]=s;H7b(s);v=f[r>>2]|0}}v=f[r>>2]|0;if(((v-(f[e>>2]|0)|0)/24|0)>>>0>=2){s8b(i,v+-24|0);v=f[r>>2]|0;t=v+-24|0;s=v;while(1){if((s|0)==(t|0))break;x=s+-24|0;f[r>>2]=x;H7b(x);s=f[r>>2]|0}s8b(j,v+-48|0);s=f[r>>2]|0;t=s+-24|0;x=t+11|0;if((b[x>>0]|0)<0){y=f[t>>2]|0;b[h>>0]=0;PXb(y,h);f[s+-20>>2]=0}else{b[h>>0]=0;PXb(t,h);b[x>>0]=0}x=OXb(489139)|0;s=d+11|0;y=b[s>>0]|0;z=d+4|0;if((x|0)==((y<<24>>24<0?f[z>>2]|0:y&255)|0)?(o8b(d,489139,x)|0)==0:0)x9b(t,40);G8b(o,489103,j);e8b(o,489389)|0;f[n>>2]=f[o>>2];f[n+4>>2]=f[o+4>>2];f[n+8>>2]=f[o+8>>2];x=0;while(1){if((x|0)==3)break;f[o+(x<<2)>>2]=0;x=x+1|0}x=b[s>>0]|0;r=x<<24>>24<0;K7b(n,r?f[d>>2]|0:d,r?f[z>>2]|0:x&255)|0;f[m>>2]=f[n>>2];f[m+4>>2]=f[n+4>>2];f[m+8>>2]=f[n+8>>2];x=0;while(1){if((x|0)==3)break;f[n+(x<<2)>>2]=0;x=x+1|0}e8b(m,489098)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];x=0;while(1){if((x|0)==3)break;f[m+(x<<2)>>2]=0;x=x+1|0}x=b[i+11>>0]|0;r=x<<24>>24<0;K7b(l,r?f[i>>2]|0:i,r?f[i+4>>2]|0:x&255)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];x=0;while(1){if((x|0)==3)break;f[l+(x<<2)>>2]=0;x=x+1|0}e8b(k,489101)|0;f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];x=0;while(1){if((x|0)==3)break;f[k+(x<<2)>>2]=0;x=x+1|0}x=b[h+11>>0]|0;r=x<<24>>24<0;K7b(t,r?f[h>>2]|0:h,r?f[h+4>>2]|0:x&255)|0;Y7b(h);Y7b(k);Y7b(l);Y7b(m);Y7b(n);Y7b(o);x=OXb(489139)|0;r=b[s>>0]|0;if((x|0)==((r<<24>>24<0?f[z>>2]|0:r&255)|0)?(o8b(d,489139,x)|0)==0:0)x9b(t,41);Y7b(j);Y7b(i);w=q}else w=a}else w=a;while(0);u=g;return w|0}function K8b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;g=u;u=u+64|0;h=g+48|0;i=g+36|0;j=g+24|0;k=g+12|0;l=g;m=E8b(a,c,e)|0;if((m|0)!=(a|0)?(c=e+4|0,(f[e>>2]|0)!=(f[c>>2]|0)):0){u8b(k,d,489103);s8b(l,(f[c>>2]|0)+-24|0);d=b[l+11>>0]|0;e=d<<24>>24<0;K7b(k,e?f[l>>2]|0:l,e?f[l+4>>2]|0:d&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];d=0;while(1){if((d|0)==3)break;f[k+(d<<2)>>2]=0;d=d+1|0}e8b(j,489101)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];d=0;while(1){if((d|0)==3)break;f[j+(d<<2)>>2]=0;d=d+1|0}d=f[c>>2]|0;c=d+-24|0;e=c+11|0;if((b[e>>0]|0)<0){n=f[c>>2]|0;b[h>>0]=0;PXb(n,h);f[d+-20>>2]=0}else{b[h>>0]=0;PXb(c,h);b[e>>0]=0}F8b(c);f[c>>2]=f[i>>2];f[c+4>>2]=f[i+4>>2];f[c+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}Y7b(i);Y7b(j);Y7b(l);Y7b(k);o=m}else o=a;u=g;return o|0}function L8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==97:0)?(b[a+1>>0]|0)==116:0)?(k=a+2|0,l=a8b(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){s8b(j,c+-24|0);d8b(j,0,490282)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}e8b(i,489101)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}c=f[k>>2]|0;k=c+-24|0;d=k+11|0;if((b[d>>0]|0)<0){m=f[k>>2]|0;b[g>>0]=0;PXb(m,g);f[c+-20>>2]=0}else{b[g>>0]=0;PXb(k,g);b[d>>0]=0}F8b(k);f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}Y7b(h);Y7b(i);Y7b(j);n=l}else n=a;u=e;return n|0}function M8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==97:0)?(b[a+1>>0]|0)==122:0)?(k=a+2|0,l=E8b(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){s8b(j,c+-24|0);d8b(j,0,490282)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}e8b(i,489101)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}c=f[k>>2]|0;k=c+-24|0;d=k+11|0;if((b[d>>0]|0)<0){m=f[k>>2]|0;b[g>>0]=0;PXb(m,g);f[c+-20>>2]=0}else{b[g>>0]=0;PXb(k,g);b[d>>0]=0}F8b(k);f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}Y7b(h);Y7b(i);Y7b(j);n=l}else n=a;u=e;return n|0}function N8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==99:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=a8b(n,c,d)|0,(o|0)!=(n|0)):0)?(n=E8b(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){s8b(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;H7b(q);p=f[o>>2]|0}s8b(m,c+-48|0);d8b(m,0,490270)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}e8b(l,489350)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;K7b(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}e8b(j,489101)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}v8b(h,i);w8b((f[o>>2]|0)+-24|0,h);H7b(h);Y7b(i);Y7b(j);Y7b(k);Y7b(l);Y7b(m);Y7b(g);r=n}else r=a;u=e;return r|0}function O8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+32|0;g=e+12|0;h=e;a:do if(((((c-a|0)>3?(b[a>>0]|0)==99:0)?(b[a+1>>0]|0)==108:0)?(i=a+2|0,j=E8b(i,c,d)|0,!((j|0)==(i|0)|(j|0)==(c|0))):0)?(i=d+4|0,k=f[i>>2]|0,(f[d>>2]|0)!=(k|0)):0){l=k+-12|0;m=b[l+11>>0]|0;n=m<<24>>24<0;K7b(k+-24|0,n?f[l>>2]|0:l,n?f[k+-8>>2]|0:m&255)|0;f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;m=0;while(1){if((m|0)==3)break;f[h+(m<<2)>>2]=0;m=m+1|0}m=f[i>>2]|0;k=m+-12|0;n=k+11|0;if((b[n>>0]|0)<0){l=f[k>>2]|0;b[g>>0]=0;PXb(l,g);f[m+-8>>2]=0}else{b[g>>0]=0;PXb(k,g);b[n>>0]=0}F8b(k);f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];k=0;while(1){if((k|0)==3)break;f[h+(k<<2)>>2]=0;k=k+1|0}Y7b(h);e8b((f[i>>2]|0)+-24|0,489103)|0;k=g+11|0;n=g+4|0;m=j;while(1){if((b[m>>0]|0)==69)break;l=E8b(m,c,d)|0;if((l|0)==(m|0)|(l|0)==(c|0)){o=a;break a}p=f[i>>2]|0;if((f[d>>2]|0)==(p|0)){o=a;break a}s8b(g,p+-24|0);p=f[i>>2]|0;q=p+-24|0;r=p;while(1){if((r|0)==(q|0))break;s=r+-24|0;f[i>>2]=s;H7b(s);r=f[i>>2]|0}r=b[k>>0]|0;s=r<<24>>24<0;t=s?f[n>>2]|0:r&255;if(t|0){if((f[d>>2]|0)==(q|0)){v=26;break}K7b(p+-48|0,s?f[g>>2]|0:g,t)|0}Y7b(g);m=l}if((v|0)==26){Y7b(g);o=a;break}n=f[i>>2]|0;if((f[d>>2]|0)!=(n|0)){e8b(n+-24|0,489101)|0;o=m+1|0}else o=a}else o=a;while(0);u=e;return o|0}function P8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;a:do if((((c-a|0)>2?(b[a>>0]|0)==99:0)?(b[a+1>>0]|0)==118:0)?(n=d+63|0,o=b[n>>0]|0,b[n>>0]=0,p=a+2|0,q=a8b(p,c,d)|0,b[n>>0]=o,!((q|0)==(p|0)|(q|0)==(c|0))):0){if((b[q>>0]|0)!=95){p=E8b(q,c,d)|0;if((p|0)==(q|0)){r=a;break}else s=p}else{p=q+1|0;if((p|0)==(c|0)){r=a;break}q=b[p>>0]|0;b:do if(q<<24>>24==69){o=d+4|0;n=f[o>>2]|0;if(n>>>0<(f[d+8>>2]|0)>>>0){f[n>>2]=0;f[n+4>>2]=0;f[n+8>>2]=0;f[n+12>>2]=0;f[n+16>>2]=0;f[n+20>>2]=0;D9b(n);f[o>>2]=(f[o>>2]|0)+24;t=p;break}else{E9b(d);t=p;break}}else{o=p;n=q;while(1){if(n<<24>>24==69){t=o;break b}v=E8b(o,c,d)|0;w=(v|0)==(o|0)|(v|0)==(c|0);if(w){r=a;break a}x=b[(w?o:v)>>0]|0;o=v;n=x}}while(0);s=t+1|0}q=d+4|0;p=f[q>>2]|0;if(((p-(f[d>>2]|0)|0)/24|0)>>>0>=2){s8b(g,p+-24|0);p=f[q>>2]|0;n=p+-24|0;o=p;while(1){if((o|0)==(n|0))break;x=o+-24|0;f[q>>2]=x;H7b(x);o=f[q>>2]|0}s8b(m,p+-48|0);d8b(m,0,489103)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];o=0;while(1){if((o|0)==3)break;f[m+(o<<2)>>2]=0;o=o+1|0}e8b(l,490267)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];o=0;while(1){if((o|0)==3)break;f[l+(o<<2)>>2]=0;o=o+1|0}o=b[g+11>>0]|0;p=o<<24>>24<0;K7b(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:o&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];o=0;while(1){if((o|0)==3)break;f[k+(o<<2)>>2]=0;o=o+1|0}e8b(j,489101)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];o=0;while(1){if((o|0)==3)break;f[j+(o<<2)>>2]=0;o=o+1|0}v8b(h,i);w8b((f[q>>2]|0)+-24|0,h);H7b(h);Y7b(i);Y7b(j);Y7b(k);Y7b(l);Y7b(m);Y7b(g);r=s}else r=a}else r=a;while(0);u=e;return r|0}function Q8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==100:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=a8b(n,c,d)|0,(o|0)!=(n|0)):0)?(n=E8b(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){s8b(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;H7b(q);p=f[o>>2]|0}s8b(m,c+-48|0);d8b(m,0,490253)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}e8b(l,489350)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;K7b(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}e8b(j,489101)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}v8b(h,i);w8b((f[o>>2]|0)+-24|0,h);H7b(h);Y7b(i);Y7b(j);Y7b(k);Y7b(l);Y7b(m);Y7b(g);r=n}else r=a;u=e;return r|0}function R8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=u;u=u+32|0;g=e+12|0;h=e;i=c;a:do if((i-a|0)>2){if((b[a>>0]|0)==103){j=(b[a+1>>0]|0)==115;k=j;l=j?a+2|0:a}else{k=0;l=a}j=h9b(l,c,d)|0;if((j|0)!=(l|0)){if(!k){m=j;break}n=f[d+4>>2]|0;if((f[d>>2]|0)==(n|0)){m=a;break}d8b(n+-24|0,0,489175)|0;m=j;break}if(((i-l|0)>2?(b[l>>0]|0)==115:0)?(b[l+1>>0]|0)==114:0){j=l+2|0;if((b[j>>0]|0)==78){n=l+3|0;o=i9b(n,c,d)|0;if((o|0)==(n|0)|(o|0)==(c|0)){m=a;break}n=r8b(o,c,d)|0;p=d+4|0;do if((n|0)==(o|0)){q=o;r=d}else{s=f[p>>2]|0;if(((s-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break a}s8b(g,s+-24|0);s=f[p>>2]|0;t=s+-24|0;v=s;while(1){if((v|0)==(t|0))break;w=v+-24|0;f[p>>2]=w;H7b(w);v=f[p>>2]|0}v=b[g+11>>0]|0;t=v<<24>>24<0;K7b(s+-48|0,t?f[g>>2]|0:g,t?f[g+4>>2]|0:v&255)|0;if((n|0)!=(c|0)){Y7b(g);q=n;r=d;break}v=f[p>>2]|0;t=v+-24|0;w=v;while(1){if((w|0)==(t|0))break;v=w+-24|0;f[p>>2]=v;H7b(v);w=f[p>>2]|0}Y7b(g);m=a;break a}while(0);n=h+11|0;o=h+4|0;w=q;while(1){if((b[w>>0]|0)==69)break;t=j9b(w,c,d)|0;if((t|0)==(w|0)|(t|0)==(c|0)){m=a;break a}s=f[p>>2]|0;if(((s-(f[r>>2]|0)|0)/24|0)>>>0<2){m=a;break a}s8b(g,s+-24|0);s=f[p>>2]|0;v=s+-24|0;x=s;while(1){if((x|0)==(v|0))break;s=x+-24|0;f[p>>2]=s;H7b(s);x=f[p>>2]|0}d8b(g,0,489175)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];x=0;while(1){if((x|0)==3)break;f[g+(x<<2)>>2]=0;x=x+1|0}x=b[n>>0]|0;v=x<<24>>24<0;K7b((f[p>>2]|0)+-24|0,v?f[h>>2]|0:h,v?f[o>>2]|0:x&255)|0;Y7b(h);Y7b(g);w=t}o=w+1|0;n=h9b(o,c,d)|0;if((n|0)==(o|0)){o=f[p>>2]|0;if((f[d>>2]|0)==(o|0)){m=a;break}x=o+-24|0;v=o;while(1){if((v|0)==(x|0)){m=a;break a}o=v+-24|0;f[p>>2]=o;H7b(o);v=f[p>>2]|0}}v=f[p>>2]|0;if(((v-(f[r>>2]|0)|0)/24|0)>>>0<2){m=a;break}s8b(g,v+-24|0);v=f[p>>2]|0;x=v+-24|0;w=v;while(1){if((w|0)==(x|0))break;v=w+-24|0;f[p>>2]=v;H7b(v);w=f[p>>2]|0}d8b(g,0,489175)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];w=0;while(1){if((w|0)==3)break;f[g+(w<<2)>>2]=0;w=w+1|0}w=b[h+11>>0]|0;x=w<<24>>24<0;K7b((f[p>>2]|0)+-24|0,x?f[h>>2]|0:h,x?f[h+4>>2]|0:w&255)|0;Y7b(h);Y7b(g);m=n;break}w=i9b(j,c,d)|0;if((w|0)!=(j|0)){x=r8b(w,c,d)|0;if((x|0)==(w|0))y=w;else{w=d+4|0;v=f[w>>2]|0;if(((v-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break}s8b(g,v+-24|0);v=f[w>>2]|0;o=v+-24|0;s=v;while(1){if((s|0)==(o|0))break;z=s+-24|0;f[w>>2]=z;H7b(z);s=f[w>>2]|0}w=b[g+11>>0]|0;s=w<<24>>24<0;K7b(v+-48|0,s?f[g>>2]|0:g,s?f[g+4>>2]|0:w&255)|0;Y7b(g);y=x}w=h9b(y,c,d)|0;if((w|0)==(y|0)){s=d+4|0;o=f[s>>2]|0;if((f[d>>2]|0)==(o|0)){m=a;break}n=o+-24|0;p=o;while(1){if((p|0)==(n|0)){m=a;break a}o=p+-24|0;f[s>>2]=o;H7b(o);p=f[s>>2]|0}}s=d+4|0;p=f[s>>2]|0;if(((p-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break}s8b(g,p+-24|0);p=f[s>>2]|0;n=p+-24|0;x=p;while(1){if((x|0)==(n|0))break;p=x+-24|0;f[s>>2]=p;H7b(p);x=f[s>>2]|0}d8b(g,0,489175)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];x=0;while(1){if((x|0)==3)break;f[g+(x<<2)>>2]=0;x=x+1|0}x=b[h+11>>0]|0;n=x<<24>>24<0;K7b((f[s>>2]|0)+-24|0,n?f[h>>2]|0:h,n?f[h+4>>2]|0:x&255)|0;Y7b(h);Y7b(g);m=w;break}x=j9b(j,c,d)|0;if(!((x|0)==(j|0)|(x|0)==(c|0))){if(k){n=d+4|0;p=f[n>>2]|0;if((f[d>>2]|0)==(p|0)){m=a;break}d8b(p+-24|0,0,489175)|0;A=n}else A=d+4|0;n=h+11|0;p=h+4|0;v=x;while(1){if((b[v>>0]|0)==69)break;x=j9b(v,c,d)|0;if((x|0)==(v|0)|(x|0)==(c|0)){m=a;break a}o=f[A>>2]|0;if(((o-(f[d>>2]|0)|0)/24|0)>>>0<2){m=a;break a}s8b(g,o+-24|0);o=f[A>>2]|0;z=o+-24|0;B=o;while(1){if((B|0)==(z|0))break;o=B+-24|0;f[A>>2]=o;H7b(o);B=f[A>>2]|0}d8b(g,0,489175)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];B=0;while(1){if((B|0)==3)break;f[g+(B<<2)>>2]=0;B=B+1|0}B=b[n>>0]|0;z=B<<24>>24<0;K7b((f[A>>2]|0)+-24|0,z?f[h>>2]|0:h,z?f[p>>2]|0:B&255)|0;Y7b(h);Y7b(g);v=x}p=v+1|0;n=h9b(p,c,d)|0;if((n|0)==(p|0)){p=f[A>>2]|0;if((f[d>>2]|0)==(p|0)){m=a;break}j=p+-24|0;w=p;while(1){if((w|0)==(j|0)){m=a;break a}p=w+-24|0;f[A>>2]=p;H7b(p);w=f[A>>2]|0}}w=f[A>>2]|0;if(((w-(f[d>>2]|0)|0)/24|0)>>>0>=2){s8b(g,w+-24|0);w=f[A>>2]|0;j=w+-24|0;v=w;while(1){if((v|0)==(j|0))break;w=v+-24|0;f[A>>2]=w;H7b(w);v=f[A>>2]|0}d8b(g,0,489175)|0;f[h>>2]=f[g>>2];f[h+4>>2]=f[g+4>>2];f[h+8>>2]=f[g+8>>2];v=0;while(1){if((v|0)==3)break;f[g+(v<<2)>>2]=0;v=v+1|0}v=b[h+11>>0]|0;j=v<<24>>24<0;K7b((f[A>>2]|0)+-24|0,j?f[h>>2]|0:h,j?f[h+4>>2]|0:v&255)|0;Y7b(h);Y7b(g);m=n}else m=a}else m=a}else m=a}else m=a;while(0);u=e;return m|0}function S8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+12|0;h=e;if((((((c-a|0)>2?(b[a>>0]|0)==100:0)?(b[a+1>>0]|0)==115:0)?(i=a+2|0,j=E8b(i,c,d)|0,(j|0)!=(i|0)):0)?(i=E8b(j,c,d)|0,(i|0)!=(j|0)):0)?(j=d+4|0,c=f[j>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){s8b(g,c+-24|0);c=f[j>>2]|0;d=c+-24|0;k=c;while(1){if((k|0)==(d|0))break;c=k+-24|0;f[j>>2]=c;H7b(c);k=f[j>>2]|0}G8b(h,489394,g);k=b[h+11>>0]|0;d=k<<24>>24<0;K7b((f[j>>2]|0)+-24|0,d?f[h>>2]|0:h,d?f[h+4>>2]|0:k&255)|0;Y7b(h);Y7b(g);l=i}else l=a;u=e;return l|0}function T8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+32|0;g=e+12|0;h=e;if((((((c-a|0)>2?(b[a>>0]|0)==100:0)?(b[a+1>>0]|0)==116:0)?(i=a+2|0,j=E8b(i,c,d)|0,(j|0)!=(i|0)):0)?(i=R8b(j,c,d)|0,(i|0)!=(j|0)):0)?(j=d+4|0,c=f[j>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){s8b(g,c+-24|0);c=f[j>>2]|0;d=c+-24|0;k=c;while(1){if((k|0)==(d|0))break;c=k+-24|0;f[j>>2]=c;H7b(c);k=f[j>>2]|0}G8b(h,489392,g);k=b[h+11>>0]|0;d=k<<24>>24<0;K7b((f[j>>2]|0)+-24|0,d?f[h>>2]|0:h,d?f[h+4>>2]|0:k&255)|0;Y7b(h);Y7b(g);l=i}else l=a;u=e;return l|0}function U8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;e=u;u=u+112|0;g=e+88|0;h=e+76|0;i=e+64|0;j=e+40|0;k=e+16|0;l=e;m=e+52|0;n=c;a:do if((n-a|0)>3){o=b[a>>0]|0;if(o<<24>>24==103){p=(b[a+1>>0]|0)==115;q=p?a+2|0:a;r=p;s=q;t=b[q>>0]|0}else{r=0;s=a;t=o}if(t<<24>>24==110){o=b[s+1>>0]|0;q=o<<24>>24==97;switch(o<<24>>24){case 97:case 119:break;default:{v=a;break a}}o=s+2|0;b:do if((o|0)!=(c|0)){p=0;w=o;while(1){if((b[w>>0]|0)==95)break;x=E8b(w,c,d)|0;y=(x|0)==(w|0);z=(x|0)==(c|0);if(y|z)break b;else{p=p|(y|z)^1;w=x}}x=w+1|0;z=a8b(x,c,d)|0;if(!((z|0)==(x|0)|(z|0)==(c|0))){x=b[z>>0]|0;c:do if(!((n-z|0)>2&x<<24>>24==112))if(x<<24>>24==69){A=0;B=z}else break b;else{if((b[z+1>>0]|0)!=105)break b;y=z+2|0;while(1){if((b[y>>0]|0)==69){A=1;B=y;break c}C=y;y=E8b(y,c,d)|0;if((y|0)==(C|0)|(y|0)==(c|0))break b}}while(0);f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;z=0;while(1){if((z|0)==3)break;f[h+(z<<2)>>2]=0;z=z+1|0}d:do if(A){z=d+4|0;x=f[z>>2]|0;if((f[d>>2]|0)==(x|0)){D=a;E=1}else{s8b(i,x+-24|0);x=h+11|0;if((b[x>>0]|0)<0){w=f[h>>2]|0;b[g>>0]=0;PXb(w,g);f[h+4>>2]=0}else{b[g>>0]=0;PXb(h,g);b[x>>0]=0}F8b(h);f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];x=0;while(1){if((x|0)==3)break;f[i+(x<<2)>>2]=0;x=x+1|0}Y7b(i);x=f[z>>2]|0;w=x+-24|0;y=x;while(1){if((y|0)==(w|0)){F=z;G=d;H=w;I=31;break d}x=y+-24|0;f[z>>2]=x;H7b(x);y=f[z>>2]|0}}}else{z=d+4|0;F=z;G=d;H=f[z>>2]|0;I=31}while(0);if((I|0)==31)if((f[G>>2]|0)==(H|0)){D=a;E=1}else{s8b(i,H+-24|0);z=f[F>>2]|0;y=z+-24|0;w=z;while(1){if((w|0)==(y|0))break;x=w+-24|0;f[F>>2]=x;H7b(x);w=f[F>>2]|0}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;w=0;while(1){if((w|0)==3)break;f[j+(w<<2)>>2]=0;w=w+1|0}e:do if(p)if((f[G>>2]|0)==(y|0)){J=a;K=1}else{s8b(k,z+-48|0);w=j+11|0;if((b[w>>0]|0)<0){x=f[j>>2]|0;b[g>>0]=0;PXb(x,g);f[j+4>>2]=0}else{b[g>>0]=0;PXb(j,g);b[w>>0]=0}F8b(j);f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];w=0;while(1){if((w|0)==3)break;f[k+(w<<2)>>2]=0;w=w+1|0}Y7b(k);w=f[F>>2]|0;x=w+-24|0;C=w;while(1){if((C|0)==(x|0)){I=49;break e}w=C+-24|0;f[F>>2]=w;H7b(w);C=f[F>>2]|0}}else I=49;while(0);if((I|0)==49){f[g>>2]=0;f[g+4>>2]=0;f[g+8>>2]=0;z=0;while(1){if((z|0)==3)break;f[g+(z<<2)>>2]=0;z=z+1|0}if(r)f9b(g,489175);if(q)e8b(g,489385)|0;else e8b(g,489135)|0;if(p){G8b(l,489103,j);e8b(l,489389)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];z=0;while(1){if((z|0)==3)break;f[l+(z<<2)>>2]=0;z=z+1|0}z=b[k+11>>0]|0;p=z<<24>>24<0;K7b(g,p?f[k>>2]|0:k,p?f[k+4>>2]|0:z&255)|0;Y7b(k);Y7b(l)}z=b[i+11>>0]|0;p=z<<24>>24<0;K7b(g,p?f[i>>2]|0:i,p?f[i+4>>2]|0:z&255)|0;if(A){G8b(l,489098,h);e8b(l,489101)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];z=0;while(1){if((z|0)==3)break;f[l+(z<<2)>>2]=0;z=z+1|0}z=b[k+11>>0]|0;p=z<<24>>24<0;K7b(g,p?f[k>>2]|0:k,p?f[k+4>>2]|0:z&255)|0;Y7b(k);Y7b(l)};f[m>>2]=f[g>>2];f[m+4>>2]=f[g+4>>2];f[m+8>>2]=f[g+8>>2];z=0;while(1){if((z|0)==3)break;f[g+(z<<2)>>2]=0;z=z+1|0}v8b(k,m);z=f[F>>2]|0;if(z>>>0<(f[d+8>>2]|0)>>>0){x8b(z,k);f[F>>2]=(f[F>>2]|0)+24}else y8b(d,k);H7b(k);Y7b(m);Y7b(g);J=B+1|0;K=0}Y7b(j);Y7b(i);D=J;E=K}Y7b(h);if(!E){v=D;break a}}}while(0);v=a}else v=a}else v=a;while(0);u=e;return v|0}function V8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+12|0;j=e;k=E8b(a,c,d)|0;if((k|0)!=(a|0)?(c=d+4|0,l=f[c>>2]|0,(f[d>>2]|0)!=(l|0)):0){s8b(j,l+-24|0);d8b(j,0,489374)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];l=0;while(1){if((l|0)==3)break;f[j+(l<<2)>>2]=0;l=l+1|0}e8b(i,489101)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];l=0;while(1){if((l|0)==3)break;f[i+(l<<2)>>2]=0;l=l+1|0}l=f[c>>2]|0;c=l+-24|0;d=c+11|0;if((b[d>>0]|0)<0){m=f[c>>2]|0;b[g>>0]=0;PXb(m,g);f[l+-20>>2]=0}else{b[g>>0]=0;PXb(c,g);b[d>>0]=0}F8b(c);f[c>>2]=f[h>>2];f[c+4>>2]=f[h+4>>2];f[c+8>>2]=f[h+8>>2];c=0;while(1){if((c|0)==3)break;f[h+(c<<2)>>2]=0;c=c+1|0}Y7b(h);Y7b(i);Y7b(j);n=k}else n=a;u=e;return n|0}function W8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e;if((((((c-a|0)>2?(b[a>>0]|0)==112:0)?(b[a+1>>0]|0)==116:0)?(h=a+2|0,i=E8b(h,c,d)|0,(i|0)!=(h|0)):0)?(h=E8b(i,c,d)|0,(h|0)!=(i|0)):0)?(i=d+4|0,c=f[i>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){s8b(g,c+-24|0);c=f[i>>2]|0;d=c+-24|0;j=c;while(1){if((j|0)==(d|0))break;k=j+-24|0;f[i>>2]=k;H7b(k);j=f[i>>2]|0}e8b(c+-48|0,489371)|0;c=b[g+11>>0]|0;j=c<<24>>24<0;K7b((f[i>>2]|0)+-24|0,j?f[g>>2]|0:g,j?f[g+4>>2]|0:c&255)|0;Y7b(g);l=h}else l=a;u=e;return l|0}function X8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==114:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=a8b(n,c,d)|0,(o|0)!=(n|0)):0)?(n=E8b(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){s8b(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;H7b(q);p=f[o>>2]|0}s8b(m,c+-48|0);d8b(m,0,489353)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}e8b(l,489350)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;K7b(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}e8b(j,489101)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}v8b(h,i);w8b((f[o>>2]|0)+-24|0,h);H7b(h);Y7b(i);Y7b(j);Y7b(k);Y7b(l);Y7b(m);Y7b(g);r=n}else r=a;u=e;return r|0}function Y8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+112|0;g=e+88|0;h=e+64|0;i=e+36|0;j=e+48|0;k=e+24|0;l=e+12|0;m=e;if((((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==99:0)?(n=a+2|0,o=a8b(n,c,d)|0,(o|0)!=(n|0)):0)?(n=E8b(o,c,d)|0,(n|0)!=(o|0)):0)?(o=d+4|0,c=f[o>>2]|0,((c-(f[d>>2]|0)|0)/24|0)>>>0>=2):0){s8b(g,c+-24|0);c=f[o>>2]|0;d=c+-24|0;p=c;while(1){if((p|0)==(d|0))break;q=p+-24|0;f[o>>2]=q;H7b(q);p=f[o>>2]|0}s8b(m,c+-48|0);d8b(m,0,489337)|0;f[l>>2]=f[m>>2];f[l+4>>2]=f[m+4>>2];f[l+8>>2]=f[m+8>>2];c=0;while(1){if((c|0)==3)break;f[m+(c<<2)>>2]=0;c=c+1|0}e8b(l,489350)|0;f[k>>2]=f[l>>2];f[k+4>>2]=f[l+4>>2];f[k+8>>2]=f[l+8>>2];c=0;while(1){if((c|0)==3)break;f[l+(c<<2)>>2]=0;c=c+1|0}c=b[g+11>>0]|0;p=c<<24>>24<0;K7b(k,p?f[g>>2]|0:g,p?f[g+4>>2]|0:c&255)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];c=0;while(1){if((c|0)==3)break;f[k+(c<<2)>>2]=0;c=c+1|0}e8b(j,489101)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}v8b(h,i);w8b((f[o>>2]|0)+-24|0,h);H7b(h);Y7b(i);Y7b(j);Y7b(k);Y7b(l);Y7b(m);Y7b(g);r=n}else r=a;u=e;return r|0}function Z8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0;if(((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==112:0){e=a+2|0;f=E8b(e,c,d)|0;g=(f|0)==(e|0)?a:f}else g=a;return g|0}function _8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==116:0)?(k=a+2|0,l=a8b(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){s8b(j,c+-24|0);d8b(j,0,489328)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}e8b(i,489101)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}v8b(g,h);w8b((f[k>>2]|0)+-24|0,g);H7b(g);Y7b(h);Y7b(i);Y7b(j);m=l}else m=a;u=e;return m|0}function $8b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;if(((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==122:0)?(k=a+2|0,l=E8b(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){s8b(j,c+-24|0);d8b(j,0,489328)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}e8b(i,489101)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}v8b(g,h);w8b((f[k>>2]|0)+-24|0,g);H7b(g);Y7b(h);Y7b(i);Y7b(j);m=l}else m=a;u=e;return m|0}function a9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e;j=e+12|0;if(((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==90:0)?(k=a+2|0,(b[k>>0]|0)==84):0)?(l=d+4|0,m=((f[l>>2]|0)-(f[d>>2]|0)|0)/24|0,n=q8b(k,c,d)|0,c=((f[l>>2]|0)-(f[d>>2]|0)|0)/24|0,(n|0)!=(k|0)):0){f[h>>2]=0;f[h+4>>2]=0;f[h+8>>2]=0;k=OXb(489314)|0;if(k>>>0>4294967279)V5b(h);if(k>>>0<11){b[h+11>>0]=k;o=h}else{p=k+16&-16;q=V7b(p)|0;f[h>>2]=q;f[h+8>>2]=p|-2147483648;f[h+4>>2]=k;o=q}VWb(o,489314,k)|0;b[g>>0]=0;PXb(o+k|0,g);a:do if((m|0)!=(c|0)){s8b(g,(f[d>>2]|0)+(m*24|0)|0);k=b[g+11>>0]|0;o=k<<24>>24<0;K7b(h,o?f[g>>2]|0:g,o?f[g+4>>2]|0:k&255)|0;Y7b(g);k=g+11|0;o=g+4|0;q=m;while(1){p=q+1|0;if((p|0)==(c|0))break a;s8b(i,(f[d>>2]|0)+(p*24|0)|0);d8b(i,0,489325)|0;f[g>>2]=f[i>>2];f[g+4>>2]=f[i+4>>2];f[g+8>>2]=f[i+8>>2];r=0;while(1){if((r|0)==3)break;f[i+(r<<2)>>2]=0;r=r+1|0}r=b[k>>0]|0;s=r<<24>>24<0;K7b(h,s?f[g>>2]|0:g,s?f[o>>2]|0:r&255)|0;Y7b(g);Y7b(i);q=p}}while(0);e8b(h,489101)|0;i=c;while(1){if((i|0)==(m|0))break;c=f[l>>2]|0;q=c+-24|0;o=c;while(1){if((o|0)==(q|0))break;c=o+-24|0;f[l>>2]=c;H7b(c);o=f[l>>2]|0}i=i+-1|0}f[j>>2]=f[h>>2];f[j+4>>2]=f[h+4>>2];f[j+8>>2]=f[h+8>>2];i=0;while(1){if((i|0)==3)break;f[h+(i<<2)>>2]=0;i=i+1|0}v8b(g,j);i=f[l>>2]|0;if(i>>>0<(f[d+8>>2]|0)>>>0){x8b(i,g);f[l>>2]=(f[l>>2]|0)+24}else y8b(d,g);H7b(g);Y7b(j);Y7b(h);t=n}else t=a;u=e;return t|0}function b9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;if((((((c-a|0)>2?(b[a>>0]|0)==115:0)?(b[a+1>>0]|0)==90:0)?(k=a+2|0,(b[k>>0]|0)==102):0)?(l=I8b(k,c,d)|0,(l|0)!=(k|0)):0)?(k=d+4|0,c=f[k>>2]|0,(f[d>>2]|0)!=(c|0)):0){s8b(j,c+-24|0);d8b(j,0,489314)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];c=0;while(1){if((c|0)==3)break;f[j+(c<<2)>>2]=0;c=c+1|0}e8b(i,489101)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}v8b(g,h);w8b((f[k>>2]|0)+-24|0,g);H7b(g);Y7b(h);Y7b(i);Y7b(j);m=l}else m=a;u=e;return m|0}function c9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=u;u=u+64|0;g=e+40|0;h=e+12|0;i=e+24|0;j=e;a:do if((c-a|0)>2?(b[a>>0]|0)==116:0){k=b[a+1>>0]|0;switch(k<<24>>24){case 101:case 105:break;default:{l=a;break a}}m=a+2|0;if(k<<24>>24==101)n=E8b(m,c,d)|0;else n=a8b(m,c,d)|0;if((n|0)!=(m|0)?(m=d+4|0,k=f[m>>2]|0,(f[d>>2]|0)!=(k|0)):0){s8b(j,k+-24|0);d8b(j,0,489306)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];k=0;while(1){if((k|0)==3)break;f[j+(k<<2)>>2]=0;k=k+1|0}e8b(i,489101)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];k=0;while(1){if((k|0)==3)break;f[i+(k<<2)>>2]=0;k=k+1|0}v8b(g,h);w8b((f[m>>2]|0)+-24|0,g);H7b(g);Y7b(h);Y7b(i);Y7b(j);l=n}else l=a}else l=a;while(0);u=e;return l|0}function d9b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=5;VWb(a,c,5)|0;b[e>>0]=0;PXb(a+5|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function e9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+48|0;g=e+24|0;h=e;i=e+12|0;if(((((c-a|0)>2?(b[a>>0]|0)==116:0)?(b[a+1>>0]|0)==119:0)?(j=a+2|0,k=E8b(j,c,d)|0,(k|0)!=(j|0)):0)?(j=d+4|0,c=f[j>>2]|0,(f[d>>2]|0)!=(c|0)):0){s8b(i,c+-24|0);d8b(i,0,489299)|0;f[h>>2]=f[i>>2];f[h+4>>2]=f[i+4>>2];f[h+8>>2]=f[i+8>>2];c=0;while(1){if((c|0)==3)break;f[i+(c<<2)>>2]=0;c=c+1|0}v8b(g,h);w8b((f[j>>2]|0)+-24|0,g);H7b(g);Y7b(h);Y7b(i);l=k}else l=a;u=e;return l|0}function f9b(a,b){a=a|0;b=b|0;g9b(a,b,OXb(b)|0);return}function g9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;h=a+11|0;i=b[h>>0]|0;j=i<<24>>24<0;if(j)k=(f[a+8>>2]&2147483647)+-1|0;else k=10;do if(k>>>0>=d>>>0){if(j)l=f[a>>2]|0;else l=a;a6b(l,c,d)|0;b[g>>0]=0;PXb(l+d|0,g);if((b[h>>0]|0)<0){f[a+4>>2]=d;break}else{b[h>>0]=d;break}}else{if(j)m=f[a+4>>2]|0;else m=i&255;U7b(a,k,d-k|0,m,0,m,d,c)}while(0);u=e;return}function h9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=u;u=u+16|0;g=e;a:do if((c-a|0)>1){h=b[a>>0]|0;i=h<<24>>24==111;switch(h<<24>>24){case 100:case 111:{if((b[a+1>>0]|0)==110){h=a+2|0;if(!i){i=C9b(h,c,d)|0;j=(i|0)==(h|0)?a:i;break a}i=o9b(h,c,d)|0;if((i|0)==(h|0)){j=a;break a}h=r8b(i,c,d)|0;if((h|0)==(i|0)){j=i;break a}i=d+4|0;k=f[i>>2]|0;if(((k-(f[d>>2]|0)|0)/24|0)>>>0<2){j=h;break a}s8b(g,k+-24|0);k=f[i>>2]|0;l=k+-24|0;m=k;while(1){if((m|0)==(l|0))break;n=m+-24|0;f[i>>2]=n;H7b(n);m=f[i>>2]|0}i=b[g+11>>0]|0;m=i<<24>>24<0;K7b(k+-48|0,m?f[g>>2]|0:g,m?f[g+4>>2]|0:i&255)|0;Y7b(g);j=h;break a}break}default:{}}i=k9b(a,c,d)|0;if((i|0)==(a|0)){m=o9b(a,c,d)|0;if((m|0)!=(a|0)){l=r8b(m,c,d)|0;if((l|0)!=(m|0)){n=d+4|0;o=f[n>>2]|0;if(((o-(f[d>>2]|0)|0)/24|0)>>>0<2)j=l;else{s8b(g,o+-24|0);o=f[n>>2]|0;p=o+-24|0;q=o;while(1){if((q|0)==(p|0))break;r=q+-24|0;f[n>>2]=r;H7b(r);q=f[n>>2]|0}n=b[g+11>>0]|0;q=n<<24>>24<0;K7b(o+-48|0,q?f[g>>2]|0:g,q?f[g+4>>2]|0:n&255)|0;Y7b(g);j=l}}else j=m}else j=a}else j=i}else j=a;while(0);u=e;return j|0}function i9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0;e=u;u=u+32|0;g=e+8|0;h=e;a:do if((a|0)==(c|0))i=a;else{j=d+16|0;switch(b[a>>0]|0){case 84:{k=d+4|0;l=((f[k>>2]|0)-(f[d>>2]|0)|0)/24|0;m=q8b(a,c,d)|0;n=f[k>>2]|0;o=(n-(f[d>>2]|0)|0)/24|0;p=n;if((m|0)!=(a|0)&(o|0)==(l+1|0)){f[h>>2]=f[d+12>>2];j8b(g,p+-24|0,h);n=d+20|0;q=f[n>>2]|0;if(q>>>0<(f[d+24>>2]|0)>>>0){f[q>>2]=0;r=q+4|0;f[r>>2]=0;s=f[g+12>>2]|0;f[q+8>>2]=0;f[q+12>>2]=s;f[q>>2]=f[g>>2];s=g+4|0;f[r>>2]=f[s>>2];r=g+8|0;f[q+8>>2]=f[r>>2];f[r>>2]=0;f[s>>2]=0;f[g>>2]=0;f[n>>2]=(f[n>>2]|0)+16}else k8b(j,g);I7b(g);i=m;break a}else{t=o;v=p}while(1){if((t|0)==(l|0)){i=a;break a}p=v+-24|0;o=v;while(1){if((o|0)==(p|0))break;m=o+-24|0;f[k>>2]=m;H7b(m);o=f[k>>2]|0}t=t+-1|0;v=p}break}case 68:{k=B8b(a,c,d)|0;if((k|0)==(a|0)){i=a;break a}l=f[d+4>>2]|0;if((f[d>>2]|0)==(l|0)){i=a;break a}f[h>>2]=f[d+12>>2];j8b(g,l+-24|0,h);l=d+20|0;o=f[l>>2]|0;if(o>>>0<(f[d+24>>2]|0)>>>0){f[o>>2]=0;m=o+4|0;f[m>>2]=0;n=f[g+12>>2]|0;f[o+8>>2]=0;f[o+12>>2]=n;f[o>>2]=f[g>>2];n=g+4|0;f[m>>2]=f[n>>2];m=g+8|0;f[o+8>>2]=f[m>>2];f[m>>2]=0;f[n>>2]=0;f[g>>2]=0;f[l>>2]=(f[l>>2]|0)+16}else k8b(j,g);I7b(g);i=k;break a;break}case 83:{k=A8b(a,c,d)|0;if((k|0)!=(a|0)){i=k;break a}if((c-a|0)<=2){i=a;break a}if((b[a+1>>0]|0)!=116){i=a;break a}k=a+2|0;l=l9b(k,c,d)|0;if((l|0)==(k|0)){i=a;break a}k=d+4|0;n=f[k>>2]|0;if((f[d>>2]|0)==(n|0)){i=a;break a}d8b(n+-24|0,0,489397)|0;n=(f[k>>2]|0)+-24|0;f[h>>2]=f[d+12>>2];j8b(g,n,h);n=d+20|0;k=f[n>>2]|0;if(k>>>0<(f[d+24>>2]|0)>>>0){f[k>>2]=0;m=k+4|0;f[m>>2]=0;o=f[g+12>>2]|0;f[k+8>>2]=0;f[k+12>>2]=o;f[k>>2]=f[g>>2];o=g+4|0;f[m>>2]=f[o>>2];m=g+8|0;f[k+8>>2]=f[m>>2];f[m>>2]=0;f[o>>2]=0;f[g>>2]=0;f[n>>2]=(f[n>>2]|0)+16}else k8b(j,g);I7b(g);i=l;break a;break}default:{i=a;break a}}}while(0);u=e;return i|0}function j9b(a,b,c){a=a|0;b=b|0;c=c|0;return k9b(a,b,c)|0}function k9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+16|0;g=e;if((a|0)!=(c|0)?(h=t8b(a,c,d)|0,(h|0)!=(a|0)):0){i=r8b(h,c,d)|0;if((i|0)!=(h|0)){c=d+4|0;j=f[c>>2]|0;if(((j-(f[d>>2]|0)|0)/24|0)>>>0<2)k=a;else{s8b(g,j+-24|0);j=f[c>>2]|0;d=j+-24|0;l=j;while(1){if((l|0)==(d|0))break;m=l+-24|0;f[c>>2]=m;H7b(m);l=f[c>>2]|0}c=b[g+11>>0]|0;l=c<<24>>24<0;K7b(j+-48|0,l?f[g>>2]|0:g,l?f[g+4>>2]|0:c&255)|0;Y7b(g);k=i}}else k=h}else k=a;u=e;return k|0}function l9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;a:do if((a|0)==(c|0))e=a;else switch(b[a>>0]|0){case 68:case 67:{e=m9b(a,c,d)|0;break a;break}case 85:{e=n9b(a,c,d)|0;break a;break}case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:{e=t8b(a,c,d)|0;break a;break}default:return o9b(a,c,d)|0}while(0);return e|0}function m9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+64|0;g=e+40|0;h=e+24|0;i=e;j=e+12|0;a:do if((c-a|0)>1?(k=d+4|0,l=f[k>>2]|0,(f[d>>2]|0)!=(l|0)):0){m=a+2|0;n=d+60|0;o=a+1|0;switch(b[a>>0]|0){case 67:{switch(b[o>>0]|0){case 53:case 51:case 50:case 49:break;default:{p=a;break a}}A9b(h,l+-24|0);v8b(g,h);q=f[k>>2]|0;if(q>>>0<(f[d+8>>2]|0)>>>0){x8b(q,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);Y7b(h);b[n>>0]=1;p=m;break a;break}case 68:break;default:{p=a;break a}}switch(b[o>>0]|0){case 53:case 50:case 49:case 48:break;default:{p=a;break a}}A9b(j,l+-24|0);d8b(j,0,489173)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];l=0;while(1){if((l|0)==3)break;f[j+(l<<2)>>2]=0;l=l+1|0}v8b(g,i);l=f[k>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){x8b(l,g);f[k>>2]=(f[k>>2]|0)+24}else y8b(d,g);H7b(g);Y7b(i);Y7b(j);b[n>>0]=1;p=m}else p=a;while(0);u=e;return p|0}function n9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=u;u=u+80|0;g=e+68|0;h=e+16|0;i=e+56|0;j=e+44|0;k=e;l=e+40|0;a:do if((c-a|0)>2?(b[a>>0]|0)==85:0){m=a+2|0;switch(b[a+1>>0]|0){case 116:{f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;n=OXb(489904)|0;if(n>>>0>4294967279)V5b(i);if(n>>>0<11){b[i+11>>0]=n;o=i}else{p=n+16&-16;q=V7b(p)|0;f[i>>2]=q;f[i+8>>2]=p|-2147483648;f[i+4>>2]=n;o=q}VWb(o,489904,n)|0;b[g>>0]=0;PXb(o+n|0,g);v8b(h,i);n=d+4|0;q=f[n>>2]|0;if(q>>>0<(f[d+8>>2]|0)>>>0){x8b(q,h);f[n>>2]=(f[n>>2]|0)+24}else y8b(d,h);H7b(h);Y7b(i);if((m|0)==(c|0)){q=f[n>>2]|0;p=q+-24|0;r=q;while(1){if((r|0)==(p|0)){s=a;break a}q=r+-24|0;f[n>>2]=q;H7b(q);r=f[n>>2]|0}}if(((b[m>>0]|0)+-48|0)>>>0<10){r=a+3|0;while(1){if((r|0)==(c|0)){t=c;break}if(((b[r>>0]|0)+-48|0)>>>0>=10){t=r;break}r=r+1|0}w9b((f[n>>2]|0)+-24|0,m,t);v=t}else v=m;x9b((f[n>>2]|0)+-24|0,39);if((v|0)!=(c|0)?(b[v>>0]|0)==95:0){s=v+1|0;break a}r=f[n>>2]|0;p=r+-24|0;q=r;while(1){if((q|0)==(p|0)){s=a;break a}r=q+-24|0;f[n>>2]=r;H7b(r);q=f[n>>2]|0}break}case 108:break;default:{s=a;break a}}f[j>>2]=0;f[j+4>>2]=0;f[j+8>>2]=0;n=OXb(489913)|0;if(n>>>0>4294967279)V5b(j);if(n>>>0<11){b[j+11>>0]=n;w=j}else{q=n+16&-16;p=V7b(q)|0;f[j>>2]=p;f[j+8>>2]=q|-2147483648;f[j+4>>2]=n;w=p}VWb(w,489913,n)|0;b[g>>0]=0;PXb(w+n|0,g);v8b(h,j);n=d+4|0;p=f[n>>2]|0;if(p>>>0<(f[d+8>>2]|0)>>>0){x8b(p,h);f[n>>2]=(f[n>>2]|0)+24}else y8b(d,h);H7b(h);Y7b(j);do if((b[m>>0]|0)!=118){p=a8b(m,c,d)|0;if((p|0)==(m|0)){q=f[n>>2]|0;r=q+-24|0;x=q;while(1){if((x|0)==(r|0)){s=a;break a}q=x+-24|0;f[n>>2]=q;H7b(q);x=f[n>>2]|0}}x=f[n>>2]|0;if(((x-(f[d>>2]|0)|0)/24|0)>>>0<2){s=a;break a}s8b(h,x+-24|0);x=f[n>>2]|0;r=x+-24|0;q=x;while(1){if((q|0)==(r|0))break;y=q+-24|0;f[n>>2]=y;H7b(y);q=f[n>>2]|0}q=h+11|0;r=b[q>>0]|0;y=r<<24>>24<0;z=h+4|0;K7b(x+-48|0,y?f[h>>2]|0:h,y?f[z>>2]|0:r&255)|0;r=p;while(1){y=a8b(r,c,d)|0;if((y|0)==(r|0)){A=60;break}B=f[n>>2]|0;if(((B-(f[d>>2]|0)|0)/24|0)>>>0<2){A=85;break}s8b(k,B+-24|0);if((b[q>>0]|0)<0){B=f[h>>2]|0;b[g>>0]=0;PXb(B,g);f[z>>2]=0}else{b[g>>0]=0;PXb(h,g);b[q>>0]=0}F8b(h);f[h>>2]=f[k>>2];f[h+4>>2]=f[k+4>>2];f[h+8>>2]=f[k+8>>2];B=0;while(1){if((B|0)==3)break;f[k+(B<<2)>>2]=0;B=B+1|0}Y7b(k);B=f[n>>2]|0;C=B+-24|0;D=B;while(1){if((D|0)==(C|0))break;E=D+-24|0;f[n>>2]=E;H7b(E);D=f[n>>2]|0}D=b[q>>0]|0;if(!((D<<24>>24<0?f[z>>2]|0:D&255)|0)){r=y;continue}e8b(B+-48|0,489325)|0;D=b[q>>0]|0;C=D<<24>>24<0;K7b((f[n>>2]|0)+-24|0,C?f[h>>2]|0:h,C?f[z>>2]|0:D&255)|0;r=y}if((A|0)==60){e8b((f[n>>2]|0)+-24|0,489101)|0;Y7b(h);F=r;break}else if((A|0)==85){Y7b(h);s=a;break a}}else{x9b((f[n>>2]|0)+-24|0,41);F=a+3|0}while(0);if((F|0)!=(c|0)?(b[F>>0]|0)==69:0){m=F+1|0;if((m|0)==(c|0)){z=f[n>>2]|0;q=z+-24|0;p=z;while(1){if((p|0)==(q|0)){s=a;break a}z=p+-24|0;f[n>>2]=z;H7b(z);p=f[n>>2]|0}}if(((b[m>>0]|0)+-48|0)>>>0<10){p=F+2|0;while(1){if((p|0)==(c|0)){G=c;break}if(((b[p>>0]|0)+-48|0)>>>0>=10){G=p;break}p=p+1|0}p=(f[n>>2]|0)+-24|0;if((b[p+11>>0]|0)<0)H=f[p>>2]|0;else H=p;f[l>>2]=H+7;f[g>>2]=f[l>>2];y9b(p,g,m,G)|0;I=G}else I=m;if((I|0)!=(c|0)?(b[I>>0]|0)==95:0){s=I+1|0;break}p=f[n>>2]|0;q=p+-24|0;z=p;while(1){if((z|0)==(q|0)){s=a;break a}p=z+-24|0;f[n>>2]=p;H7b(p);z=f[n>>2]|0}}z=f[n>>2]|0;q=z+-24|0;m=z;while(1){if((m|0)==(q|0)){s=a;break a}z=m+-24|0;f[n>>2]=z;H7b(z);m=f[n>>2]|0}}else s=a;while(0);u=e;return s|0}function o9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=u;u=u+32|0;g=e;a:do if((c-a|0)>1){h=a+2|0;i=a+1|0;do switch(b[a>>0]|0){case 97:{switch(b[i>>0]|0){case 97:{p9b(g,489403);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 110:case 100:{q9b(g,489414);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 78:{p9b(g,489424);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 83:{q9b(g,489435);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}default:{l=a;break a}}break}case 99:{switch(b[i>>0]|0){case 108:{p9b(g,489445);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 109:{q9b(g,489456);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 111:{q9b(g,489466);j=d+4|0;k=f[j>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[j>>2]=(f[j>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 118:{j=d+63|0;k=b[j>>0]|0;b[j>>0]=0;m=a8b(h,c,d)|0;b[j>>0]=k;if((m|0)==(h|0)){l=a;break a}k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=a;break a}d8b(k+-24|0,0,489476)|0;b[d+60>>0]=1;l=m;break a;break}default:{l=a;break a}}break}case 100:{switch(b[i>>0]|0){case 97:{r9b(g,489486);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 101:{q9b(g,489504);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 108:{s9b(g);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 118:{q9b(g,489514);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 86:{p9b(g,489524);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}default:{l=a;break a}}break}case 101:{switch(b[i>>0]|0){case 111:{q9b(g,489535);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 79:{p9b(g,489545);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 113:{p9b(g,489556);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}default:{l=a;break a}}break}case 103:{switch(b[i>>0]|0){case 101:{p9b(g,489567);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 116:{q9b(g,489578);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}default:{l=a;break a}}break}case 105:{if((b[i>>0]|0)!=120){l=a;break a}p9b(g,489588);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 108:{switch(b[i>>0]|0){case 101:{p9b(g,489599);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 105:{m=t8b(h,c,d)|0;if((m|0)==(h|0)){l=a;break a}k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=a;break a}d8b(k+-24|0,0,489610)|0;l=m;break a;break}case 115:{p9b(g,489622);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 83:{t9b(g,489633);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 116:{q9b(g,489645);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}default:{l=a;break a}}break}case 109:{switch(b[i>>0]|0){case 105:{q9b(g,489655);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 73:{p9b(g,489665);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 108:{q9b(g,489504);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 76:{p9b(g,489676);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 109:{p9b(g,489687);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}default:{l=a;break a}}break}case 110:{switch(b[i>>0]|0){case 97:{u9b(g,489698);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 101:{p9b(g,489713);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 103:{q9b(g,489655);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 116:{q9b(g,489724);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 119:{v9b(g,489734);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}default:{l=a;break a}}break}case 111:{switch(b[i>>0]|0){case 111:{p9b(g,489747);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 114:{q9b(g,489758);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 82:{p9b(g,489768);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}default:{l=a;break a}}break}case 112:{switch(b[i>>0]|0){case 109:{t9b(g,489779);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 108:{q9b(g,489791);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 76:{p9b(g,489801);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 112:{p9b(g,489812);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 115:{q9b(g,489791);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 116:{p9b(g,489823);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}default:{l=a;break a}}break}case 113:{if((b[i>>0]|0)!=117){l=a;break a}q9b(g,489834);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 114:{switch(b[i>>0]|0){case 109:{q9b(g,489844);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 77:{p9b(g,489854);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 115:{p9b(g,489865);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}case 83:{t9b(g,489876);m=d+4|0;k=f[m>>2]|0;if(k>>>0<(f[d+8>>2]|0)>>>0){x8b(k,g);f[m>>2]=(f[m>>2]|0)+24}else y8b(d,g);H7b(g);l=h;break a;break}default:{l=a;break a}}break}case 118:{if(((b[i>>0]|0)+-48|0)>>>0>=10){l=a;break a}m=t8b(h,c,d)|0;if((m|0)==(h|0)){l=a;break a}k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=a;break a}d8b(k+-24|0,0,489476)|0;l=m;break a;break}default:{l=a;break a}}while(0)}else l=a;while(0);u=e;return l|0}function p9b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=10;VWb(a,c,10)|0;b[e>>0]=0;PXb(a+10|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function q9b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=9;VWb(a,c,9)|0;b[e>>0]=0;PXb(a+9|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function r9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=V7b(32)|0;f[a>>2]=g;f[a+8>>2]=-2147483616;f[a+4>>2]=17;VWb(g,c,17)|0;b[e>>0]=0;PXb(g+17|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function s9b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=V7b(16)|0;f[a>>2]=e;f[a+8>>2]=-2147483632;f[a+4>>2]=15;VWb(e,489888,15)|0;b[d>>0]=0;PXb(e+15|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function t9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=V7b(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=11;VWb(g,c,11)|0;b[e>>0]=0;PXb(g+11|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function u9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=V7b(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=14;VWb(g,c,14)|0;b[e>>0]=0;PXb(g+14|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function v9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=V7b(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=12;VWb(g,c,12)|0;b[e>>0]=0;PXb(g+12|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function w9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+16|0;g=c;h=e+12|0;i=e;j=a+11|0;k=b[j>>0]|0;l=k<<24>>24<0;if(l){m=f[a+4>>2]|0;n=(f[a+8>>2]&2147483647)+-1|0}else{m=k&255;n=10}o=d-g|0;do if(o|0){if(l){p=f[a>>2]|0;q=p;r=f[a+4>>2]|0;s=p}else{q=a;r=k&255;s=a}if(n6b(c,s,q+r|0)|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(o>>>0>4294967279)V5b(i);if(o>>>0<11){b[i+11>>0]=o;t=i}else{p=o+16&-16;v=V7b(p)|0;f[i>>2]=v;f[i+8>>2]=p|-2147483648;f[i+4>>2]=o;t=v}v=c;p=t;while(1){if((v|0)==(d|0))break;PXb(p,v);v=v+1|0;p=p+1|0}b[h>>0]=0;PXb(t+o|0,h);p=b[i+11>>0]|0;v=p<<24>>24<0;K7b(a,v?f[i>>2]|0:i,v?f[i+4>>2]|0:p&255)|0;Y7b(i);break}p=m+o|0;if((n-m|0)>>>0<o>>>0)z9b(a,n,p-n|0,m,m,0);if((b[j>>0]|0)<0)w=f[a>>2]|0;else w=a;v=d+(m-g)|0;x=w+m|0;y=c;while(1){if((y|0)==(d|0))break;PXb(x,y);x=x+1|0;y=y+1|0}b[h>>0]=0;PXb(w+v|0,h);if((b[j>>0]|0)<0){f[a+4>>2]=p;break}else{b[j>>0]=p;break}}while(0);u=e;return}function x9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=u;u=u+16|0;e=d;g=d+1|0;b[e>>0]=c;c=a+11|0;h=b[c>>0]|0;i=h<<24>>24<0;if(i){j=f[a+4>>2]|0;k=(f[a+8>>2]&2147483647)+-1|0}else{j=h&255;k=10}if((j|0)==(k|0)){z9b(a,k,1,k,k,0);h=k+1|0;if((b[c>>0]|0)<0){l=h;m=8}else{n=h;m=7}}else{h=j+1|0;if(i){l=h;m=8}else{n=h;m=7}}if((m|0)==7){b[c>>0]=n;o=a}else if((m|0)==8){m=f[a>>2]|0;f[a+4>>2]=l;o=m}m=o+j|0;PXb(m,e);b[g>>0]=0;PXb(m+1|0,g);u=d;return}function y9b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=u;u=u+32|0;h=g+16|0;i=g;j=g+12|0;k=a+11|0;l=b[k>>0]|0;m=l<<24>>24<0;if(m)n=f[a>>2]|0;else n=a;o=f[c>>2]|0;c=o-n|0;n=e-d|0;do if(!n){p=l;q=35}else{if(m){r=f[a>>2]|0;s=r;t=f[a+4>>2]|0;v=r}else{s=a;t=l&255;v=a}if(n6b(d,v,s+t|0)|0){f[i>>2]=0;f[i+4>>2]=0;f[i+8>>2]=0;if(n>>>0>4294967279)V5b(i);if(n>>>0<11){b[i+11>>0]=n;w=i}else{r=n+16&-16;x=V7b(r)|0;f[i>>2]=x;f[i+8>>2]=r|-2147483648;f[i+4>>2]=n;w=x}x=d;r=w;while(1){if((x|0)==(e|0))break;PXb(r,x);x=x+1|0;r=r+1|0}b[h>>0]=0;PXb(w+n|0,h);f[j>>2]=o;r=b[i+11>>0]|0;x=r<<24>>24<0;y=x?f[i>>2]|0:i;z=y+(x?f[i+4>>2]|0:r&255)|0;f[h>>2]=f[j>>2];r=y9b(a,h,y,z)|0;Y7b(i);A=r;break}r=b[k>>0]|0;z=r<<24>>24<0;if(z){B=f[a+4>>2]|0;C=(f[a+8>>2]&2147483647)+-1|0}else{B=r&255;C=10}r=B+n|0;if((C-B|0)>>>0>=n>>>0){if(z)D=f[a>>2]|0;else D=a;z=B-c|0;if(!z)E=D;else{y=D+c|0;a6b(y+n|0,y,z)|0;E=D}}else{z9b(a,C,r-C|0,B,c,n);E=f[a>>2]|0}if((b[k>>0]|0)<0)f[a+4>>2]=r;else b[k>>0]=r;b[h>>0]=0;PXb(E+r|0,h);r=d;z=E+c|0;while(1){if((r|0)==(e|0))break;PXb(z,r);r=r+1|0;z=z+1|0}p=b[k>>0]|0;q=35}while(0);if((q|0)==35){if(p<<24>>24<0)F=f[a>>2]|0;else F=a;A=F+c|0}u=g;return A|0}function z9b(a,c,d,e,g,h){a=a|0;c=c|0;d=d|0;e=e|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;if((-17-c|0)>>>0<d>>>0)V5b(a);if((b[a+11>>0]|0)<0)i=f[a>>2]|0;else i=a;if(c>>>0<2147483623){j=d+c|0;d=c<<1;k=j>>>0<d>>>0?d:j;l=k>>>0<11?11:k+16&-16}else l=-17;k=V7b(l)|0;if(g|0)VWb(k,i,g)|0;j=e-g|0;if(j|0)VWb(k+g+h|0,i+g|0,j)|0;if((c|0)!=10)W7b(i);f[a>>2]=k;f[a+8>>2]=l|-2147483648;return}function A9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=u;u=u+16|0;e=d;g=c+11|0;h=b[g>>0]|0;i=c+4|0;a:do if(!((h<<24>>24<0?f[i>>2]|0:h&255)|0))B9b(a,c);else{j=OXb(489923)|0;k=b[g>>0]|0;if((j|0)==((k<<24>>24<0?f[i>>2]|0:k&255)|0)?(o8b(c,489923,j)|0)==0:0){f9b(c,489935);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=OXb(490006)|0;if(j>>>0>4294967279)V5b(a);if(j>>>0<11){b[a+11>>0]=j;l=a}else{k=j+16&-16;m=V7b(k)|0;f[a>>2]=m;f[a+8>>2]=k|-2147483648;f[a+4>>2]=j;l=m}VWb(l,490006,j)|0;b[e>>0]=0;PXb(l+j|0,e);break}j=OXb(490019)|0;m=b[g>>0]|0;if((j|0)==((m<<24>>24<0?f[i>>2]|0:m&255)|0)?(o8b(c,490019,j)|0)==0:0){f9b(c,490032);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=OXb(490082)|0;if(j>>>0>4294967279)V5b(a);if(j>>>0<11){b[a+11>>0]=j;n=a}else{m=j+16&-16;k=V7b(m)|0;f[a>>2]=k;f[a+8>>2]=m|-2147483648;f[a+4>>2]=j;n=k}VWb(n,490082,j)|0;b[e>>0]=0;PXb(n+j|0,e);break}j=OXb(490096)|0;k=b[g>>0]|0;if((j|0)==((k<<24>>24<0?f[i>>2]|0:k&255)|0)?(o8b(c,490096,j)|0)==0:0){f9b(c,490109);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=OXb(490159)|0;if(j>>>0>4294967279)V5b(a);if(j>>>0<11){b[a+11>>0]=j;o=a}else{k=j+16&-16;m=V7b(k)|0;f[a>>2]=m;f[a+8>>2]=k|-2147483648;f[a+4>>2]=j;o=m}VWb(o,490159,j)|0;b[e>>0]=0;PXb(o+j|0,e);break}j=OXb(490173)|0;m=b[g>>0]|0;k=f[i>>2]|0;do if((j|0)==((m<<24>>24<0?k:m&255)|0)){if(o8b(c,490173,j)|0){p=f[i>>2]|0;q=b[g>>0]|0;break}f9b(c,490187);f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;r=OXb(490238)|0;if(r>>>0>4294967279)V5b(a);if(r>>>0<11){b[a+11>>0]=r;s=a}else{t=r+16&-16;v=V7b(t)|0;f[a>>2]=v;f[a+8>>2]=t|-2147483648;f[a+4>>2]=r;s=v}VWb(s,490238,r)|0;b[e>>0]=0;PXb(s+r|0,e);break a}else{p=k;q=m}while(0);m=q<<24>>24<0;k=m?f[c>>2]|0:c;j=k+(m?p:q&255)|0;b:do if((b[j+-1>>0]|0)==62){m=1;r=j;c:while(1){v=r;d:while(1){w=v+-1|0;if((w|0)==(k|0))break c;x=v+-2|0;switch(b[x>>0]|0){case 60:{y=43;break d;break}case 62:{y=44;break d;break}default:v=w}}if((y|0)==43){y=0;v=m+-1|0;if(!v){z=x;break b}else{m=v;r=w;continue}}else if((y|0)==44){y=0;m=m+1|0;r=w;continue}}f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;r=0;while(1){if((r|0)==3)break a;f[a+(r<<2)>>2]=0;r=r+1|0}}else z=j;while(0);j=z;while(1){r=j+-1|0;if((r|0)==(k|0)){A=k;break}if((b[r>>0]|0)==58){A=j;break}else j=r}f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;j=z-A|0;if(j>>>0>4294967279)V5b(a);if(j>>>0<11){b[a+11>>0]=j;B=a}else{k=j+16&-16;r=V7b(k)|0;f[a>>2]=r;f[a+8>>2]=k|-2147483648;f[a+4>>2]=j;B=r}r=A;k=B;while(1){if((r|0)==(z|0))break;PXb(k,r);r=r+1|0;k=k+1|0}b[e>>0]=0;PXb(B+j|0,e)}while(0);u=d;return}function B9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;if((b[c+11>>0]|0)<0){g=f[c>>2]|0;h=f[c+4>>2]|0;if(h>>>0>4294967279)V5b(a);if(h>>>0<11){b[a+11>>0]=h;i=a}else{j=h+16&-16;k=V7b(j)|0;f[a>>2]=k;f[a+8>>2]=j|-2147483648;f[a+4>>2]=h;i=k}VWb(i,g,h)|0;b[e>>0]=0;PXb(i+h|0,e)}else{f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2]}u=d;return}function C9b(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;if((a|0)!=(b|0)){d=i9b(a,b,c)|0;if((d|0)==(a|0))e=k9b(a,b,c)|0;else e=d;if((e|0)!=(a|0)?(d=f[c+4>>2]|0,(f[c>>2]|0)!=(d|0)):0){d8b(d+-24|0,0,489173)|0;g=e}else g=a}else g=a;return g|0}function D9b(a){a=a|0;var b=0;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;f[a+(b<<2)>>2]=0;b=b+1|0}b=a+12|0;f[b>>2]=0;f[b+4>>2]=0;f[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[b+(a<<2)>>2]=0;a=a+1|0}return}function E9b(a){a=a|0;var b=0,c=0,d=0,e=0,g=0,h=0,i=0,j=0;b=u;u=u+32|0;c=b;d=a+4|0;e=(((f[d>>2]|0)-(f[a>>2]|0)|0)/24|0)+1|0;g=F9b(a)|0;if(g>>>0<e>>>0)c4b(a);else{h=f[a>>2]|0;i=((f[a+8>>2]|0)-h|0)/24|0;j=i<<1;G9b(c,i>>>0<g>>>1>>>0?(j>>>0<e>>>0?e:j):g,((f[d>>2]|0)-h|0)/24|0,a+12|0);h=c+8|0;d=f[h>>2]|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;f[d+12>>2]=0;f[d+16>>2]=0;f[d+20>>2]=0;D9b(d);f[h>>2]=d+24;H9b(a,c);I9b(c);u=b;return}}function F9b(a){a=a|0;return 178956970}function G9b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a+12>>2]=0;f[a+16>>2]=d;if(!b)e=0;else e=J9b(d,b)|0;f[a>>2]=e;d=e+(c*24|0)|0;f[a+8>>2]=d;f[a+4>>2]=d;f[a+12>>2]=e+(b*24|0);return}function H9b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=f[d>>2]|0;while(1){if((g|0)==(c|0))break;h=g+-24|0;x8b((f[e>>2]|0)+-24|0,h);f[e>>2]=(f[e>>2]|0)+-24;g=h}g=f[a>>2]|0;f[a>>2]=f[e>>2];f[e>>2]=g;g=b+8|0;c=f[d>>2]|0;f[d>>2]=f[g>>2];f[g>>2]=c;c=a+8|0;a=b+12|0;g=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=g;f[b>>2]=f[e>>2];return}function I9b(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=a+8|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-24|0;f[c>>2]=e;H7b(e)}c=f[a>>2]|0;if(c|0)X7b(f[a+16>>2]|0,c,((f[a+12>>2]|0)-c|0)/24|0);return}function J9b(a,b){a=a|0;b=b|0;return K9b(f[a>>2]|0,b*24|0)|0}function K9b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=S7b(b)|0;b=a+4096|0;d=f[b>>2]|0;if((a+4096-d|0)>>>0<c>>>0)e=OSb(c)|0;else{f[b>>2]=d+c;e=d}return e|0}function L9b(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=u;u=u+48|0;h=g+24|0;i=g;j=g+12|0;k=D8b(a,c)|0;if(!((k|0)==(a|0)|(k|0)==(c|0))?(b[k>>0]|0)==69:0){c=d+11|0;l=b[c>>0]|0;m=d+4|0;do if((l<<24>>24<0?f[m>>2]|0:l&255)>>>0<=3){n=e+4|0;o=f[n>>2]|0;if(o>>>0<(f[e+8>>2]|0)>>>0){f[o>>2]=0;f[o+4>>2]=0;f[o+8>>2]=0;f[o+12>>2]=0;f[o+16>>2]=0;f[o+20>>2]=0;D9b(o);f[n>>2]=(f[n>>2]|0)+24;break}else{E9b(e);break}}else{G8b(j,489103,d);e8b(j,489101)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];n=0;while(1){if((n|0)==3)break;f[j+(n<<2)>>2]=0;n=n+1|0}v8b(h,i);n=e+4|0;o=f[n>>2]|0;if(o>>>0<(f[e+8>>2]|0)>>>0){x8b(o,h);f[n>>2]=(f[n>>2]|0)+24}else y8b(e,h);H7b(h);Y7b(i);Y7b(j)}while(0);j=e+4|0;if((b[a>>0]|0)==110){x9b((f[j>>2]|0)+-24|0,45);p=a+1|0}else p=a;w9b((f[j>>2]|0)+-24|0,p,k);p=b[c>>0]|0;c=p<<24>>24<0;e=c?f[m>>2]|0:p&255;if(e>>>0<4)K7b((f[j>>2]|0)+-24|0,c?f[d>>2]|0:d,e)|0;q=k+1|0}else q=a;u=g;return q|0}function M9b(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=4;VWb(a,c,4)|0;b[e>>0]=0;PXb(a+4|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function N9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0;e=u;u=u+80|0;g=e;h=e+44|0;i=e+48|0;j=e+8|0;k=e+32|0;a:do if((c-a|0)>>>0>8){l=0;m=h;while(1){o=b[a+l>>0]|0;q=o<<24>>24;r=a+(l|1)|0;if((l|0)==8){s=6;break}if(!(wVb(q)|0))break;t=b[r>>0]|0;b[m>>0]=t+(((q+-48|0)>>>0<10?0:9)+q<<4)+((t+-48|0)>>>0<10?208:169);l=l+2|0;m=m+1|0}do if((s|0)==6){if(o<<24>>24==69){b:do if((h|0)!=(m|0)){l=m;t=h;while(1){q=l+-1|0;if(t>>>0>=q>>>0)break b;v=b[t>>0]|0;b[t>>0]=b[q>>0]|0;b[q>>0]=v;l=q;t=t+1|0}}while(0);t=i;l=t+24|0;do{b[t>>0]=0;t=t+1|0}while((t|0)<(l|0));p[g>>3]=+n[h>>2];t=GUb(i,24,490415,g)|0;if(t>>>0>23)break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(t>>>0<11){b[k+11>>0]=t;w=k}else{l=t+16&-16;q=V7b(l)|0;f[k>>2]=q;f[k+8>>2]=l|-2147483648;f[k+4>>2]=t;w=q}VWb(w,i,t)|0;b[g>>0]=0;PXb(w+t|0,g);v8b(j,k);t=d+4|0;q=f[t>>2]|0;if(q>>>0<(f[d+8>>2]|0)>>>0){x8b(q,j);f[t>>2]=(f[t>>2]|0)+24}else y8b(d,j);H7b(j);Y7b(k);x=r}else x=a;y=x;break a}while(0);y=a}else y=a;while(0);u=e;return y|0}function O9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+96|0;g=e+8|0;h=e;i=e+56|0;j=e+16|0;k=e+40|0;a:do if((c-a|0)>>>0>16){l=0;m=h;while(1){n=b[a+l>>0]|0;o=n<<24>>24;q=a+(l|1)|0;if((l|0)==16){r=6;break}if(!(wVb(o)|0))break;s=b[q>>0]|0;b[m>>0]=s+(((o+-48|0)>>>0<10?0:9)+o<<4)+((s+-48|0)>>>0<10?208:169);l=l+2|0;m=m+1|0}do if((r|0)==6){if(n<<24>>24==69){b:do if((h|0)!=(m|0)){l=m;s=h;while(1){o=l+-1|0;if(s>>>0>=o>>>0)break b;t=b[s>>0]|0;b[s>>0]=b[o>>0]|0;b[o>>0]=t;l=o;s=s+1|0}}while(0);s=i;l=s+32|0;do{b[s>>0]=0;s=s+1|0}while((s|0)<(l|0));p[g>>3]=+p[h>>3];s=GUb(i,32,490412,g)|0;if(s>>>0>31)break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(s>>>0<11){b[k+11>>0]=s;v=k}else{l=s+16&-16;o=V7b(l)|0;f[k>>2]=o;f[k+8>>2]=l|-2147483648;f[k+4>>2]=s;v=o}VWb(v,i,s)|0;b[g>>0]=0;PXb(v+s|0,g);v8b(j,k);s=d+4|0;o=f[s>>2]|0;if(o>>>0<(f[d+8>>2]|0)>>>0){x8b(o,j);f[s>>2]=(f[s>>2]|0)+24}else y8b(d,j);H7b(j);Y7b(k);w=q}else w=a;x=w;break a}while(0);x=a}else x=a;while(0);u=e;return x|0}function P9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0;e=u;u=u+96|0;g=e+8|0;h=e;i=e+56|0;j=e+16|0;k=e+40|0;a:do if((c-a|0)>>>0>20){l=0;m=h;while(1){n=b[a+l>>0]|0;o=n<<24>>24;q=a+(l|1)|0;if((l|0)==20){r=6;break}if(!(wVb(o)|0))break;s=b[q>>0]|0;b[m>>0]=s+(((o+-48|0)>>>0<10?0:9)+o<<4)+((s+-48|0)>>>0<10?208:169);l=l+2|0;m=m+1|0}do if((r|0)==6){if(n<<24>>24==69){b:do if((h|0)!=(m|0)){l=m;s=h;while(1){o=l+-1|0;if(s>>>0>=o>>>0)break b;t=b[s>>0]|0;b[s>>0]=b[o>>0]|0;b[o>>0]=t;l=o;s=s+1|0}}while(0);s=i;l=s+40|0;do{b[s>>0]=0;s=s+1|0}while((s|0)<(l|0));p[g>>3]=+p[h>>3];s=GUb(i,40,490407,g)|0;if(s>>>0>39)break;f[k>>2]=0;f[k+4>>2]=0;f[k+8>>2]=0;if(s>>>0<11){b[k+11>>0]=s;v=k}else{l=s+16&-16;o=V7b(l)|0;f[k>>2]=o;f[k+8>>2]=l|-2147483648;f[k+4>>2]=s;v=o}VWb(v,i,s)|0;b[g>>0]=0;PXb(v+s|0,g);v8b(j,k);s=d+4|0;o=f[s>>2]|0;if(o>>>0<(f[d+8>>2]|0)>>>0){x8b(o,j);f[s>>2]=(f[s>>2]|0)+24}else y8b(d,j);H7b(j);Y7b(k);w=q}else w=a;x=w;break a}while(0);x=a}else x=a;while(0);u=e;return x|0}function Q9b(a,c){a=a|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;g=V7b(16)|0;f[a>>2]=g;f[a+8>>2]=-2147483632;f[a+4>>2]=13;VWb(g,c,13)|0;b[e>>0]=0;PXb(g+13|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function R9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=u;u=u+48|0;g=e+36|0;h=e+24|0;i=e+8|0;j=e;a:do if((a|0)!=(c|0)?(b[a>>0]|0)==78:0){k=b8b(a+1|0,c,g)|0;b:do if((k|0)!=(c|0)){l=d+52|0;f[l>>2]=0;m=k+1|0;switch(b[k>>0]|0){case 82:{n=1;o=6;break}case 79:{n=2;o=6;break}default:p=k}if((o|0)==6){f[l>>2]=n;p=m}m=d+4|0;l=f[m>>2]|0;if(l>>>0<(f[d+8>>2]|0)>>>0){f[l>>2]=0;f[l+4>>2]=0;f[l+8>>2]=0;f[l+12>>2]=0;f[l+16>>2]=0;f[l+20>>2]=0;D9b(l);f[m>>2]=(f[m>>2]|0)+24}else E9b(d);if(((c-p|0)>1?(b[p>>0]|0)==83:0)?(b[p+1>>0]|0)==116:0){f9b((f[m>>2]|0)+-24|0,490479);q=p+2|0}else q=p;if((q|0)==(c|0)){l=f[m>>2]|0;r=l+-24|0;s=l;while(1){if((s|0)==(r|0))break b;l=s+-24|0;f[m>>2]=l;H7b(l);s=f[m>>2]|0}}s=d+16|0;r=h+11|0;l=h+4|0;t=d+12|0;v=d+20|0;w=d+24|0;x=i+12|0;y=i+4|0;z=i+8|0;A=i+12|0;B=i+4|0;C=i+8|0;D=i+11|0;E=i+4|0;F=i+11|0;G=i+4|0;H=i+12|0;I=i+4|0;J=i+8|0;K=i+12|0;L=i+4|0;M=i+8|0;N=i+11|0;O=i+4|0;P=i+12|0;Q=i+4|0;R=i+8|0;S=i+11|0;T=i+4|0;U=0;V=q;c:while(1){W=V;d:while(1){X=b[W>>0]|0;Y=W+1|0;if(X<<24>>24==69)break c;switch(X<<24>>24|0){case 83:{o=21;break d;break}case 84:{o=37;break d;break}case 68:{o=51;break d;break}case 73:break;case 76:{if((Y|0)==(c|0))break b;else{W=Y;continue d}break}default:break d}X=r8b(W,c,d)|0;if((X|0)==(W|0)|(X|0)==(c|0))break b;s8b(h,(f[m>>2]|0)+-24|0);Z=f[m>>2]|0;_=Z+-24|0;$=Z;while(1){if(($|0)==(_|0))break;aa=$+-24|0;f[m>>2]=aa;H7b(aa);$=f[m>>2]|0}$=b[r>>0]|0;_=$<<24>>24<0;K7b(Z+-48|0,_?f[h>>2]|0:h,_?f[l>>2]|0:$&255)|0;$=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];j8b(i,$,j);$=f[v>>2]|0;if($>>>0<(f[w>>2]|0)>>>0){f[$>>2]=0;_=$+4|0;f[_>>2]=0;aa=f[x>>2]|0;f[$+8>>2]=0;f[$+12>>2]=aa;f[$>>2]=f[i>>2];f[_>>2]=f[y>>2];f[$+8>>2]=f[z>>2];f[z>>2]=0;f[y>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else k8b(s,i);I7b(i);Y7b(h);W=X}e:do if((o|0)==21){o=0;if((Y|0)!=(c|0)?(b[Y>>0]|0)==116:0)break;$=A8b(W,c,d)|0;if(($|0)==(W|0)|($|0)==(c|0))break b;s8b(h,(f[m>>2]|0)+-24|0);_=f[m>>2]|0;aa=_+-24|0;ba=_;while(1){if((ba|0)==(aa|0))break;ca=ba+-24|0;f[m>>2]=ca;H7b(ca);ba=f[m>>2]|0}ba=_+-48|0;aa=b[ba+11>>0]|0;if(aa<<24>>24<0)da=f[_+-44>>2]|0;else da=aa&255;if(!da)V9b(ba,h);else{G8b(i,489175,h);ba=b[F>>0]|0;aa=ba<<24>>24<0;K7b((f[m>>2]|0)+-24|0,aa?f[i>>2]|0:i,aa?f[G>>2]|0:ba&255)|0;Y7b(i);ba=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];j8b(i,ba,j);ba=f[v>>2]|0;if(ba>>>0<(f[w>>2]|0)>>>0){f[ba>>2]=0;aa=ba+4|0;f[aa>>2]=0;X=f[H>>2]|0;f[ba+8>>2]=0;f[ba+12>>2]=X;f[ba>>2]=f[i>>2];f[aa>>2]=f[I>>2];f[ba+8>>2]=f[J>>2];f[J>>2]=0;f[I>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else k8b(s,i);I7b(i)}Y7b(h);U=1;V=$;continue c}else if((o|0)==37){o=0;ba=q8b(W,c,d)|0;if((ba|0)==(W|0)|(ba|0)==(c|0))break b;s8b(h,(f[m>>2]|0)+-24|0);aa=f[m>>2]|0;X=aa+-24|0;Z=aa;while(1){if((Z|0)==(X|0))break;ca=Z+-24|0;f[m>>2]=ca;H7b(ca);Z=f[m>>2]|0}Z=aa+-48|0;X=b[Z+11>>0]|0;if(X<<24>>24<0)ea=f[aa+-44>>2]|0;else ea=X&255;if(!ea)V9b(Z,h);else{G8b(i,489175,h);Z=b[N>>0]|0;X=Z<<24>>24<0;K7b((f[m>>2]|0)+-24|0,X?f[i>>2]|0:i,X?f[O>>2]|0:Z&255)|0;Y7b(i)}Z=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];j8b(i,Z,j);Z=f[v>>2]|0;if(Z>>>0<(f[w>>2]|0)>>>0){f[Z>>2]=0;X=Z+4|0;f[X>>2]=0;$=f[K>>2]|0;f[Z+8>>2]=0;f[Z+12>>2]=$;f[Z>>2]=f[i>>2];f[X>>2]=f[L>>2];f[Z+8>>2]=f[M>>2];f[M>>2]=0;f[L>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else k8b(s,i);I7b(i);Y7b(h);U=1;V=ba;continue c}else if((o|0)==51){o=0;if((Y|0)!=(c|0))switch(b[Y>>0]|0){case 84:case 116:break;default:break e}Z=B8b(W,c,d)|0;if((Z|0)==(W|0)|(Z|0)==(c|0))break b;s8b(h,(f[m>>2]|0)+-24|0);X=f[m>>2]|0;$=X+-24|0;_=X;while(1){if((_|0)==($|0))break;ca=_+-24|0;f[m>>2]=ca;H7b(ca);_=f[m>>2]|0}_=X+-48|0;$=b[_+11>>0]|0;if($<<24>>24<0)fa=f[X+-44>>2]|0;else fa=$&255;if(!fa)V9b(_,h);else{G8b(i,489175,h);_=b[S>>0]|0;$=_<<24>>24<0;K7b((f[m>>2]|0)+-24|0,$?f[i>>2]|0:i,$?f[T>>2]|0:_&255)|0;Y7b(i)}_=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];j8b(i,_,j);_=f[v>>2]|0;if(_>>>0<(f[w>>2]|0)>>>0){f[_>>2]=0;$=_+4|0;f[$>>2]=0;ba=f[P>>2]|0;f[_+8>>2]=0;f[_+12>>2]=ba;f[_>>2]=f[i>>2];f[$>>2]=f[Q>>2];f[_+8>>2]=f[R>>2];f[R>>2]=0;f[Q>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else k8b(s,i);I7b(i);Y7b(h);U=1;V=Z;continue c}while(0);_=l9b(W,c,d)|0;if((_|0)==(W|0)|(_|0)==(c|0))break b;s8b(h,(f[m>>2]|0)+-24|0);$=f[m>>2]|0;ba=$+-24|0;aa=$;while(1){if((aa|0)==(ba|0))break;ca=aa+-24|0;f[m>>2]=ca;H7b(ca);aa=f[m>>2]|0}aa=$+-48|0;ba=b[aa+11>>0]|0;if(ba<<24>>24<0)ga=f[$+-44>>2]|0;else ga=ba&255;if(!ga)V9b(aa,h);else{G8b(i,489175,h);aa=b[D>>0]|0;ba=aa<<24>>24<0;K7b((f[m>>2]|0)+-24|0,ba?f[i>>2]|0:i,ba?f[E>>2]|0:aa&255)|0;Y7b(i)}aa=(f[m>>2]|0)+-24|0;f[j>>2]=f[t>>2];j8b(i,aa,j);aa=f[v>>2]|0;if(aa>>>0<(f[w>>2]|0)>>>0){f[aa>>2]=0;ba=aa+4|0;f[ba>>2]=0;W=f[A>>2]|0;f[aa+8>>2]=0;f[aa+12>>2]=W;f[aa>>2]=f[i>>2];f[ba>>2]=f[B>>2];f[aa+8>>2]=f[C>>2];f[C>>2]=0;f[B>>2]=0;f[i>>2]=0;f[v>>2]=(f[v>>2]|0)+16}else k8b(s,i);I7b(i);Y7b(h);U=1;V=_}f[d+48>>2]=f[g>>2];f:do if(U?(V=f[v>>2]|0,(f[s>>2]|0)!=(V|0)):0){B=V+-16|0;C=V;while(1){if((C|0)==(B|0))break f;V=C+-16|0;f[v>>2]=V;I7b(V);C=f[v>>2]|0}}while(0);ha=Y;break a}while(0);ha=a}else ha=a;while(0);u=e;return ha|0}function S9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=u;u=u+16|0;g=e;a:do if(((((a|0)!=(c|0)?(b[a>>0]|0)==90:0)?(h=a+1|0,i=Z7b(h,c,d)|0,!((i|0)==(h|0)|(i|0)==(c|0))):0)?(b[i>>0]|0)==69:0)?(h=i+1|0,(h|0)!=(c|0)):0){j=i+2|0;switch(b[h>>0]|0){case 115:{i=U9b(j,c)|0;k=f[d+4>>2]|0;if((f[d>>2]|0)==(k|0)){l=i;break a}e8b(k+-24|0,490462)|0;l=i;break a;break}case 100:{if((j|0)==(c|0)){l=a;break a}i=D8b(j,c)|0;if((i|0)==(c|0)){l=a;break a}if((b[i>>0]|0)!=95){l=a;break a}j=i+1|0;i=z8b(j,c,d)|0;k=d+4|0;if((i|0)==(j|0)){j=f[k>>2]|0;m=j+-24|0;n=j;while(1){if((n|0)==(m|0)){l=a;break a}j=n+-24|0;f[k>>2]=j;H7b(j);n=f[k>>2]|0}}n=f[k>>2]|0;if(((n-(f[d>>2]|0)|0)/24|0)>>>0<2){l=a;break a}s8b(g,n+-24|0);n=f[k>>2]|0;m=n+-24|0;j=n;while(1){if((j|0)==(m|0))break;o=j+-24|0;f[k>>2]=o;H7b(o);j=f[k>>2]|0}e8b(n+-48|0,489175)|0;j=b[g+11>>0]|0;m=j<<24>>24<0;K7b((f[k>>2]|0)+-24|0,m?f[g>>2]|0:g,m?f[g+4>>2]|0:j&255)|0;Y7b(g);l=i;break a;break}default:{j=z8b(h,c,d)|0;if((j|0)==(h|0)){m=d+4|0;o=f[m>>2]|0;p=o+-24|0;q=o;while(1){if((q|0)==(p|0)){l=a;break a}o=q+-24|0;f[m>>2]=o;H7b(o);q=f[m>>2]|0}}m=U9b(j,c)|0;q=d+4|0;p=f[q>>2]|0;if(((p-(f[d>>2]|0)|0)/24|0)>>>0<2){l=m;break a}s8b(g,p+-24|0);p=f[q>>2]|0;h=p+-24|0;i=p;while(1){if((i|0)==(h|0))break;k=i+-24|0;f[q>>2]=k;H7b(k);i=f[q>>2]|0}e8b(p+-48|0,489175)|0;i=b[g+11>>0]|0;h=i<<24>>24<0;K7b((f[q>>2]|0)+-24|0,h?f[g>>2]|0:g,h?f[g+4>>2]|0:i&255)|0;Y7b(g);l=m;break a}}}else l=a;while(0);u=e;return l|0}function T9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;if((c-a|0)>1){if((b[a>>0]|0)==83?(b[a+1>>0]|0)==116:0){e=a+2|0;if((e|0)==(c|0)){g=0;h=c}else{g=0;h=(b[e>>0]|0)==76?a+3|0:e}}else{g=1;h=a}e=l9b(h,c,d)|0;c=(e|0)==(h|0);if(!(g|c)){g=f[d+4>>2]|0;if((f[d>>2]|0)==(g|0))i=a;else{d8b(g+-24|0,0,489397)|0;i=e}}else i=c?a:e}else i=a;return i|0}function U9b(a,c){a=a|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:do if((a|0)!=(c|0)){d=b[a>>0]|0;e=a+1|0;if(d<<24>>24!=95){if(((d<<24>>24)+-48|0)>>>0<10)f=e;else{g=a;break}while(1){if((f|0)==(c|0)){g=c;break a}if(((b[f>>0]|0)+-48|0)>>>0>=10){g=f;break a}f=f+1|0}}if((e|0)!=(c|0)){d=b[e>>0]|0;h=a+2|0;if(((d<<24>>24)+-48|0)>>>0>=10)if(d<<24>>24==95){d=h;do{i=d;d=d+1|0;if((i|0)==(c|0)){g=a;break a}j=b[i>>0]|0}while(((j<<24>>24)+-48|0)>>>0<10);return (j<<24>>24==95?d:a)|0}else g=a;else g=h}else g=a}else g=a;while(0);return g|0}function V9b(a,c){a=a|0;c=c|0;var d=0,e=0;if((a|0)!=(c|0)){d=b[c+11>>0]|0;e=d<<24>>24<0;g9b(a,e?f[c>>2]|0:c,e?f[c+4>>2]|0:d&255)}return}function W9b(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=V7b(32)|0;f[a>>2]=e;f[a+8>>2]=-2147483616;f[a+4>>2]=21;VWb(e,490494,21)|0;b[d>>0]=0;PXb(e+21|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function X9b(a,b){a=a|0;b=b|0;f[a>>2]=f[b>>2];return}function Y9b(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+32|0;d=c+20|0;e=c;g=a+4|0;h=((f[g>>2]|0)-(f[a>>2]|0)>>4)+1|0;i=_9b(a)|0;if(i>>>0<h>>>0)c4b(a);else{j=f[a>>2]|0;k=(f[a+8>>2]|0)-j|0;l=k>>3;$9b(e,k>>4>>>0<i>>>1>>>0?(l>>>0<h>>>0?h:l):i,(f[g>>2]|0)-j>>4,a+12|0);j=e+8|0;g=f[j>>2]|0;X9b(d,b);f[g>>2]=0;f[g+4>>2]=0;b=f[d>>2]|0;f[g+8>>2]=0;f[g+12>>2]=b;f[j>>2]=g+16;aac(a,e);bac(e);u=c;return}}function Z9b(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;a:do if((a|0)==(c|0))e=a;else{f=a+1|0;switch(b[a>>0]|0){case 88:{g=E8b(f,c,d)|0;if((g|0)==(f|0)|(g|0)==(c|0)){e=a;break a}e=(b[g>>0]|0)==69?g+1|0:a;break a;break}case 74:{if((f|0)==(c|0)){e=a;break a}else h=f;while(1){if((b[h>>0]|0)==69)break;g=Z9b(h,c,d)|0;if((g|0)==(h|0)){e=a;break a}else h=g}e=h+1|0;break a;break}case 76:{if((f|0)!=(c|0)?(b[f>>0]|0)==90:0){g=a+2|0;i=Z7b(g,c,d)|0;if((i|0)==(g|0)|(i|0)==(c|0)){e=a;break a}e=(b[i>>0]|0)==69?i+1|0:a;break a}e=H8b(a,c,d)|0;break a;break}default:{e=a8b(a,c,d)|0;break a}}}while(0);return e|0}function _9b(a){a=a|0;return 268435455}function $9b(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a+12>>2]=0;f[a+16>>2]=d;if(!b)e=0;else e=cac(d,b)|0;f[a>>2]=e;d=e+(c<<4)|0;f[a+8>>2]=d;f[a+4>>2]=d;f[a+12>>2]=e+(b<<4);return}function aac(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=f[d>>2]|0;while(1){if((g|0)==(c|0))break;h=f[e>>2]|0;i=h+-16|0;j=g+-16|0;f[i>>2]=0;k=h+-12|0;f[k>>2]=0;l=f[g+-4>>2]|0;f[h+-8>>2]=0;f[h+-4>>2]=l;f[i>>2]=f[j>>2];i=g+-12|0;f[k>>2]=f[i>>2];k=g+-8|0;f[h+-8>>2]=f[k>>2];f[k>>2]=0;f[i>>2]=0;f[j>>2]=0;f[e>>2]=(f[e>>2]|0)+-16;g=j}g=f[a>>2]|0;f[a>>2]=f[e>>2];f[e>>2]=g;g=b+8|0;c=f[d>>2]|0;f[d>>2]=f[g>>2];f[g>>2]=c;c=a+8|0;a=b+12|0;g=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=g;f[b>>2]=f[e>>2];return}function bac(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=a+8|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;O7b(e)}c=f[a>>2]|0;if(c|0)T7b(f[a+16>>2]|0,c,(f[a+12>>2]|0)-c>>4);return}function cac(a,b){a=a|0;b=b|0;return K9b(f[a>>2]|0,b<<4)|0}function dac(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=2;VWb(a,490519,2)|0;b[d>>0]=0;PXb(a+2|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function eac(a,c){a=a|0;c=c|0;var d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;d=u;u=u+16|0;e=d;g=a+11|0;h=b[g>>0]|0;i=h<<24>>24<0;if(i){j=f[a+4>>2]|0;k=j>>>0<11?j:11;l=j;m=(f[a+8>>2]&2147483647)+-1|0}else{j=h&255;k=j>>>0<11?j:11;l=j;m=10}if((k-l+m|0)>>>0<c>>>0)U7b(a,m,l+c-k-m|0,l,0,k,c,490522);else{if(i)n=f[a>>2]|0;else n=a;do if((k|0)!=(c|0)){i=l-k|0;if(!i){o=k;p=0;q=490522;r=c;s=17}else{if(k>>>0>c>>>0){a6b(n,490522,c)|0;a6b(n+c|0,n+k|0,i)|0;t=k;v=c;break}do if(n>>>0<490522>>>0&(n+l|0)>>>0>490522>>>0)if((n+k|0)>>>0>490522>>>0){a6b(n,490522,k)|0;w=0;x=k;y=490522+c|0;z=c-k|0;break}else{w=k;x=0;y=490522+(c-k)|0;z=c;break}else{w=k;x=0;y=490522;z=c}while(0);m=n+x|0;a6b(m+z|0,m+w|0,i)|0;o=w;p=x;q=y;r=z;s=17}}else{o=c;p=0;q=490522;r=c;s=17}while(0);if((s|0)==17){a6b(n+p|0,q,r)|0;t=o;v=r}r=v-t+l|0;if((b[g>>0]|0)<0)f[a+4>>2]=r;else b[g>>0]=r;b[e>>0]=0;PXb(n+r|0,e)}u=d;return}function fac(a,c,d,e){a=a|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=u;u=u+16|0;h=g;i=a+11|0;j=b[i>>0]|0;k=j<<24>>24<0;if(k)l=f[a+4>>2]|0;else l=j&255;if(l>>>0<c>>>0)W5b(a);if(k)m=(f[a+8>>2]&2147483647)+-1|0;else m=10;j=l+e|0;if((m-l|0)>>>0>=e>>>0){if(e|0){if(k)n=f[a>>2]|0;else n=a;k=l-c|0;o=n+c|0;if(!k)p=d;else{a6b(o+e|0,o,k)|0;p=o>>>0<=d>>>0&(n+l|0)>>>0>d>>>0?d+e|0:d}a6b(o,p,e)|0;if((b[i>>0]|0)<0)f[a+4>>2]=j;else b[i>>0]=j;b[h>>0]=0;PXb(n+j|0,h)}}else U7b(a,m,j-m|0,l,c,0,e,d);u=g;return a|0}function gac(a){a=a|0;return 268435455}function hac(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;f[a+12>>2]=0;f[a+16>>2]=d;if(!b)e=0;else e=kac(d,b)|0;f[a>>2]=e;d=e+(c<<4)|0;f[a+8>>2]=d;f[a+4>>2]=d;f[a+12>>2]=e+(b<<4);return}function iac(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=f[a>>2]|0;d=a+4|0;e=b+4|0;g=f[d>>2]|0;while(1){if((g|0)==(c|0))break;h=f[e>>2]|0;i=h+-16|0;j=g+-16|0;f[i>>2]=0;k=h+-12|0;f[k>>2]=0;l=f[g+-4>>2]|0;f[h+-8>>2]=0;f[h+-4>>2]=l;f[i>>2]=f[j>>2];i=g+-12|0;f[k>>2]=f[i>>2];k=g+-8|0;f[h+-8>>2]=f[k>>2];f[k>>2]=0;f[i>>2]=0;f[j>>2]=0;f[e>>2]=(f[e>>2]|0)+-16;g=j}g=f[a>>2]|0;f[a>>2]=f[e>>2];f[e>>2]=g;g=b+8|0;c=f[d>>2]|0;f[d>>2]=f[g>>2];f[g>>2]=c;c=a+8|0;a=b+12|0;g=f[c>>2]|0;f[c>>2]=f[a>>2];f[a>>2]=g;f[b>>2]=f[e>>2];return}function jac(a){a=a|0;var b=0,c=0,d=0,e=0;b=f[a+4>>2]|0;c=a+8|0;while(1){d=f[c>>2]|0;if((d|0)==(b|0))break;e=d+-16|0;f[c>>2]=e;I7b(e)}c=f[a>>2]|0;if(c|0)P7b(f[a+16>>2]|0,c,(f[a+12>>2]|0)-c>>4);return}function kac(a,b){a=a|0;b=b|0;return K9b(f[a>>2]|0,b<<4)|0}function lac(a){a=a|0;var b=0;if(!(F9b(a)|0))c4b(a);else{b=J9b(a+12|0,1)|0;f[a+4>>2]=b;f[a>>2]=b;f[a+8>>2]=b+24;return}}function mac(a){a=a|0;var c=0,d=0,e=0,g=0,h=0,i=0,j=0,k=0,l=0;c=u;u=u+16|0;d=c;e=a+11|0;g=b[e>>0]|0;if(g<<24>>24<0){h=f[a>>2]|0;i=f[a+4>>2]|0}else{h=a;i=g&255}j=(i|0)!=0&1;k=i-j|0;if(!k)l=g;else{a6b(h,h+j|0,k)|0;l=b[e>>0]|0}if(l<<24>>24<0)f[a+4>>2]=k;else b[e>>0]=k;b[d>>0]=0;PXb(h+k|0,d);u=c;return}function nac(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=7;VWb(a,490295,7)|0;b[d>>0]=0;PXb(a+7|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function oac(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=3;VWb(a,c,3)|0;b[e>>0]=0;PXb(a+3|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function pac(a){a=a|0;var c=0,d=0,e=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;e=V7b(32)|0;f[a>>2]=e;f[a+8>>2]=-2147483616;f[a+4>>2]=18;VWb(e,490715,18)|0;b[d>>0]=0;PXb(e+18|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function qac(a,c){a=a|0;c=c|0;var d=0,e=0;d=u;u=u+16|0;e=d;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=8;VWb(a,c,8)|0;b[e>>0]=0;PXb(a+8|0,e);e=a+12|0;f[e>>2]=0;f[e+4>>2]=0;f[e+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[e+(a<<2)>>2]=0;a=a+1|0}u=d;return}function rac(a){a=a|0;var c=0,d=0;c=u;u=u+16|0;d=c;f[a>>2]=0;f[a+4>>2]=0;f[a+8>>2]=0;b[a+11>>0]=6;VWb(a,490708,6)|0;b[d>>0]=0;PXb(a+6|0,d);d=a+12|0;f[d>>2]=0;f[d+4>>2]=0;f[d+8>>2]=0;a=0;while(1){if((a|0)==3)break;f[d+(a<<2)>>2]=0;a=a+1|0}u=c;return}function sac(a,b){a=a|0;b=b|0;f[a>>2]=b;f[a+4>>2]=f[b>>2];return}function tac(a,c){a=a|0;c=c|0;f[a>>2]=c;b[a+4>>0]=b[c>>0]|0;return}function uac(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,v=0,w=0,x=0,y=0,z=0;e=u;u=u+64|0;g=e+60|0;h=e+48|0;i=e+36|0;j=e+24|0;k=e+12|0;l=e;a:do if((c-a|0)>2){m=a+2|0;n=a+1|0;switch(b[a>>0]|0){case 84:break;case 71:{switch(b[n>>0]|0){case 86:{o=z8b(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}d8b(r+-24|0,0,490933)|0;p=o;q=60;break a;break}case 82:{o=z8b(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}d8b(r+-24|0,0,490953)|0;p=o;q=60;break a;break}default:{p=a;q=60;break a}}break}default:{p=a;q=60;break a}}switch(b[n>>0]|0){case 86:{o=a8b(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}d8b(r+-24|0,0,490782)|0;p=o;q=60;break a;break}case 84:{o=a8b(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}d8b(r+-24|0,0,490794)|0;p=o;q=60;break a;break}case 73:{o=a8b(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}d8b(r+-24|0,0,490803)|0;p=o;q=60;break a;break}case 83:{o=a8b(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}d8b(r+-24|0,0,490817)|0;p=o;q=60;break a;break}case 99:{o=xac(m,c)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=xac(o,c)|0;if((r|0)==(o|0)){p=a;q=60;break a}o=Z7b(r,c,d)|0;if((o|0)==(r|0)){p=a;q=60;break a}r=f[d+4>>2]|0;if((f[d>>2]|0)==(r|0)){s=a;break a}d8b(r+-24|0,0,490836)|0;p=o;q=60;break a;break}case 67:{o=a8b(m,c,d)|0;if((o|0)==(m|0)){p=a;q=60;break a}r=D8b(o,c)|0;if((r|0)==(o|0)|(r|0)==(c|0)){p=a;q=60;break a}if((b[r>>0]|0)!=95){p=a;q=60;break a}o=r+1|0;r=a8b(o,c,d)|0;if((r|0)==(o|0)){p=a;q=60;break a}o=d+4|0;t=f[o>>2]|0;if(((t-(f[d>>2]|0)|0)/24|0)>>>0<2){s=a;break a}s8b(h,t+-24|0);t=f[o>>2]|0;v=t+-24|0;w=t;while(1){if((w|0)==(v|0))break;t=w+-24|0;f[o>>2]=t;H7b(t);w=f[o>>2]|0}d8b(h,0,490863)|0;f[k>>2]=f[h>>2];f[k+4>>2]=f[h+4>>2];f[k+8>>2]=f[h+8>>2];w=0;while(1){if((w|0)==3)break;f[h+(w<<2)>>2]=0;w=w+1|0}e8b(k,490888)|0;f[j>>2]=f[k>>2];f[j+4>>2]=f[k+4>>2];f[j+8>>2]=f[k+8>>2];w=0;while(1){if((w|0)==3)break;f[k+(w<<2)>>2]=0;w=w+1|0}s8b(l,(f[o>>2]|0)+-24|0);w=b[l+11>>0]|0;v=w<<24>>24<0;K7b(j,v?f[l>>2]|0:l,v?f[l+4>>2]|0:w&255)|0;f[i>>2]=f[j>>2];f[i+4>>2]=f[j+4>>2];f[i+8>>2]=f[j+8>>2];w=0;while(1){if((w|0)==3)break;f[j+(w<<2)>>2]=0;w=w+1|0}w=f[o>>2]|0;v=w+-24|0;t=v+11|0;if((b[t>>0]|0)<0){x=f[v>>2]|0;b[g>>0]=0;PXb(x,g);f[w+-20>>2]=0}else{b[g>>0]=0;PXb(v,g);b[t>>0]=0}F8b(v);f[v>>2]=f[i>>2];f[v+4>>2]=f[i+4>>2];f[v+8>>2]=f[i+8>>2];v=0;while(1){if((v|0)==3)break;f[i+(v<<2)>>2]=0;v=v+1|0}Y7b(i);Y7b(l);Y7b(j);Y7b(k);Y7b(h);p=r;q=60;break a;break}default:{v=xac(n,c)|0;do if((v|0)!=(n|0)){o=Z7b(v,c,d)|0;if((o|0)!=(v|0)){t=f[d+4>>2]|0;if((f[d>>2]|0)!=(t|0)){w=t+-24|0;if((b[m>>0]|0)==118){d8b(w,0,490893)|0;y=0;z=o;break}else{d8b(w,0,490911)|0;y=0;z=o;break}}else{y=1;z=a}}else{y=0;z=a}}else{y=3;z=a}while(0);switch(y&3){case 3:case 0:{p=z;q=60;break a;break}default:{}}if(!y){p=z;q=60;break a}else{s=a;break a}}}}else{p=a;q=60}while(0);if((q|0)==60)s=p;u=e;return s|0}function vac(a){a=a|0;b[f[a>>2]>>0]=b[a+4>>0]|0;return}function wac(a){a=a|0;f[f[a>>2]>>2]=f[a+4>>2];return}function xac(a,c){a=a|0;c=c|0;var d=0,e=0,f=0;a:do if((a|0)!=(c|0)){d=a+1|0;switch(b[a>>0]|0){case 104:{e=D8b(d,c)|0;if((e|0)==(d|0)|(e|0)==(c|0)){f=a;break a}return ((b[e>>0]|0)==95?e+1|0:a)|0}case 118:break;default:{f=a;break a}}e=D8b(d,c)|0;if((!((e|0)==(d|0)|(e|0)==(c|0))?(b[e>>0]|0)==95:0)?(d=e+1|0,e=D8b(d,c)|0,!((e|0)==(d|0)|(e|0)==(c|0))):0)f=(b[e>>0]|0)==95?e+1|0:a;else f=a}else f=a;while(0);return f|0}function yac(a,b){a=a|0;b=b|0;f[a>>2]=b;return}function zac(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=0;f[a+4>>2]=0;c=f[b>>2]|0;f[a+8>>2]=0;f[a+12>>2]=c;return}function Aac(a,b){a=a|0;b=b|0;f[a>>2]=b;return}function Bac(a,b){a=a|0;b=b|0;var c=0;f[a>>2]=0;f[a+4>>2]=0;c=f[b>>2]|0;f[a+8>>2]=0;f[a+12>>2]=c;return}function Cac(a){a=a|0;var c=0;if((b[a>>0]|0)==1)c=0;else{b[a>>0]=1;c=1}return c|0}function Dac(a){a=a|0;return}function Eac(a){a=a|0;return}function Fac(){var a=0;a=f[214356]|0;f[214356]=a+0;return a|0}function Gac(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,g=0;d=u;u=u+16|0;e=d;f[e>>2]=f[c>>2];g=li[f[(f[a>>2]|0)+16>>2]&511](a,b,e)|0;if(g)f[c>>2]=f[e>>2];u=d;return g&1|0}function Hac(a){a=a|0;var b=0;if(!a)b=0;else b=(T6b(a,25352,25472,0)|0)!=0;return b&1|0}function Iac(){}function Jac(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return (J=e,a-c>>>0|0)|0}function Kac(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return (J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function Lac(a){a=a|0;return 0}function Mac(a){a=a|0;return 0}function Nac(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0;e=a+d|0;c=c&255;if((d|0)>=67){while(a&3){b[a>>0]=c;a=a+1|0}g=e&-4|0;h=g-64|0;i=c|c<<8|c<<16|c<<24;while((a|0)<=(h|0)){f[a>>2]=i;f[a+4>>2]=i;f[a+8>>2]=i;f[a+12>>2]=i;f[a+16>>2]=i;f[a+20>>2]=i;f[a+24>>2]=i;f[a+28>>2]=i;f[a+32>>2]=i;f[a+36>>2]=i;f[a+40>>2]=i;f[a+44>>2]=i;f[a+48>>2]=i;f[a+52>>2]=i;f[a+56>>2]=i;f[a+60>>2]=i;a=a+64|0}while((a|0)<(g|0)){f[a>>2]=i;a=a+4|0}}while((a|0)<(e|0)){b[a>>0]=c;a=a+1|0}return e-d|0}function Oac(a){a=a|0;var c=0;c=b[w+(a&255)>>0]|0;if((c|0)<8)return c|0;c=b[w+(a>>8&255)>>0]|0;if((c|0)<8)return c+8|0;c=b[w+(a>>16&255)>>0]|0;if((c|0)<8)return c+16|0;return (b[w+(a>>>24)>>0]|0)+24|0}function Pac(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=a;h=b;i=h;j=c;k=d;l=k;if(!i){m=(e|0)!=0;if(!l){if(m){f[e>>2]=(g>>>0)%(j>>>0);f[e+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return (J=n,o)|0}else{if(!m){n=0;o=0;return (J=n,o)|0}f[e>>2]=a|0;f[e+4>>2]=b&0;n=0;o=0;return (J=n,o)|0}}m=(l|0)==0;do if(j){if(!m){p=($(l|0)|0)-($(i|0)|0)|0;if(p>>>0<=31){q=p+1|0;r=31-p|0;s=p-31>>31;t=q;u=g>>>(q>>>0)&s|i<<r;v=i>>>(q>>>0)&s;w=0;x=g<<r;break}if(!e){n=0;o=0;return (J=n,o)|0}f[e>>2]=a|0;f[e+4>>2]=h|b&0;n=0;o=0;return (J=n,o)|0}r=j-1|0;if(r&j|0){s=($(j|0)|0)+33-($(i|0)|0)|0;q=64-s|0;p=32-s|0;y=p>>31;z=s-32|0;A=z>>31;t=s;u=p-1>>31&i>>>(z>>>0)|(i<<p|g>>>(s>>>0))&A;v=A&i>>>(s>>>0);w=g<<q&y;x=(i<<q|g>>>(z>>>0))&y|g<<p&s-33>>31;break}if(e|0){f[e>>2]=r&g;f[e+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return (J=n,o)|0}else{r=Oac(j|0)|0;n=i>>>(r>>>0)|0;o=i<<32-r|g>>>(r>>>0)|0;return (J=n,o)|0}}else{if(m){if(e|0){f[e>>2]=(i>>>0)%(j>>>0);f[e+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return (J=n,o)|0}if(!g){if(e|0){f[e>>2]=0;f[e+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return (J=n,o)|0}r=l-1|0;if(!(r&l)){if(e|0){f[e>>2]=a|0;f[e+4>>2]=r&i|b&0}n=0;o=i>>>((Oac(l|0)|0)>>>0);return (J=n,o)|0}r=($(l|0)|0)-($(i|0)|0)|0;if(r>>>0<=30){s=r+1|0;p=31-r|0;t=s;u=i<<p|g>>>(s>>>0);v=i>>>(s>>>0);w=0;x=g<<p;break}if(!e){n=0;o=0;return (J=n,o)|0}f[e>>2]=a|0;f[e+4>>2]=h|b&0;n=0;o=0;return (J=n,o)|0}while(0);if(!t){B=x;C=w;D=v;E=u;F=0;G=0}else{b=c|0|0;c=k|d&0;d=Kac(b|0,c|0,-1,-1)|0;k=J;h=x;x=w;w=v;v=u;u=t;t=0;do{a=h;h=x>>>31|h<<1;x=t|x<<1;g=v<<1|a>>>31|0;a=v>>>31|w<<1|0;Jac(d|0,k|0,g|0,a|0)|0;i=J;l=i>>31|((i|0)<0?-1:0)<<1;t=l&1;v=Jac(g|0,a|0,l&b|0,(((i|0)<0?-1:0)>>31|((i|0)<0?-1:0)<<1)&c|0)|0;w=J;u=u-1|0}while((u|0)!=0);B=h;C=x;D=w;E=v;F=0;G=t}t=C;C=0;if(e|0){f[e>>2]=E;f[e+4>>2]=D}n=(t|0)>>>31|(B|C)<<1|(C<<1|t>>>31)&0|F;o=(t<<1|0>>>31)&-2|G;return (J=n,o)|0}function Qac(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0,h=0,i=0,j=0,k=0,l=0;e=u;u=u+16|0;g=e|0;h=b>>31|((b|0)<0?-1:0)<<1;i=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;j=d>>31|((d|0)<0?-1:0)<<1;k=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;l=Jac(h^a|0,i^b|0,h|0,i|0)|0;b=J;Pac(l,b,Jac(j^c|0,k^d|0,j|0,k|0)|0,J,g)|0;k=Jac(f[g>>2]^h|0,f[g+4>>2]^i|0,h|0,i|0)|0;i=J;u=e;return (J=i,k)|0}function Rac(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function Sac(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function Tac(a){a=a|0;return 0}function Uac(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Pac(a,b,c,d,0)|0}function Vac(a,c,d){a=a|0;c=c|0;d=d|0;var e=0,g=0,h=0;if((d|0)>=8192)return od(a|0,c|0,d|0)|0;e=a|0;g=a+d|0;if((a&3)==(c&3)){while(a&3){if(!d)return e|0;b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0;d=d-1|0}h=g&-4|0;d=h-64|0;while((a|0)<=(d|0)){f[a>>2]=f[c>>2];f[a+4>>2]=f[c+4>>2];f[a+8>>2]=f[c+8>>2];f[a+12>>2]=f[c+12>>2];f[a+16>>2]=f[c+16>>2];f[a+20>>2]=f[c+20>>2];f[a+24>>2]=f[c+24>>2];f[a+28>>2]=f[c+28>>2];f[a+32>>2]=f[c+32>>2];f[a+36>>2]=f[c+36>>2];f[a+40>>2]=f[c+40>>2];f[a+44>>2]=f[c+44>>2];f[a+48>>2]=f[c+48>>2];f[a+52>>2]=f[c+52>>2];f[a+56>>2]=f[c+56>>2];f[a+60>>2]=f[c+60>>2];a=a+64|0;c=c+64|0}while((a|0)<(h|0)){f[a>>2]=f[c>>2];a=a+4|0;c=c+4|0}}else{h=g-4|0;while((a|0)<(h|0)){b[a>>0]=b[c>>0]|0;b[a+1>>0]=b[c+1>>0]|0;b[a+2>>0]=b[c+2>>0]|0;b[a+3>>0]=b[c+3>>0]|0;a=a+4|0;c=c+4|0}}while((a|0)<(g|0)){b[a>>0]=b[c>>0]|0;a=a+1|0;c=c+1|0}return e|0}function Wac(a){a=a|0;var b=0,c=0;a=a+15&-16|0;b=f[r>>2]|0;c=b+a|0;if((a|0)>0&(c|0)<(b|0)|(c|0)<0){ea()|0;Od(12);return -1}f[r>>2]=c;if((c|0)>(da()|0)?(ca()|0)==0:0){f[r>>2]=b;Od(12);return -1}return b|0}function Xac(a,c,d){a=a|0;c=c|0;d=d|0;var e=0;if((c|0)<(a|0)&(a|0)<(c+d|0)){e=a;c=c+d|0;a=a+d|0;while((d|0)>0){a=a-1|0;c=c-1|0;d=d-1|0;b[a>>0]=b[c>>0]|0}a=e}else Vac(a,c,d)|0;return a|0}function Yac(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,g=0;e=u;u=u+16|0;g=e|0;Pac(a,b,c,d,g)|0;u=e;return (J=f[g+4>>2]|0,f[g>>2]|0)|0}function Zac(a){a=a|0;return (a&255)<<24|(a>>8&255)<<16|(a>>16&255)<<8|a>>>24|0}function _ac(a,b,c){a=a|0;b=b|0;c=c|0;c=$(b)|0;if((c|0)==32)c=c+($(a)|0)|0;J=0;return c|0}function $ac(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function abc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=Jac(e^a|0,f^b|0,e|0,f|0)|0;b=J;a=g^e;e=h^f;return Jac((Pac(i,b,Jac(g^c|0,h^d|0,g|0,h|0)|0,J,0)|0)^a|0,J^e|0,a|0,e|0)|0}function bbc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=Y(d,c)|0;f=a>>>16;a=(e>>>16)+(Y(d,f)|0)|0;d=b>>>16;b=Y(d,c)|0;return (J=(a>>>16)+(Y(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function cbc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=bbc(e,a)|0;f=J;return (J=(Y(b,a)|0)+(Y(d,e)|0)+f|f&0,c|0|0)|0}function dbc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;return Rf[a&3](b|0,c|0,d|0,e|0,f|0,+g)|0}function ebc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;Sf[a&1](b|0,c|0,d|0,e|0,+f,+g,+h)}function fbc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;Tf[a&7](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)}function gbc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;Uf[a&3](b|0,c|0,d|0,e|0,f|0,+g,+h,i|0)}function hbc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;Vf[a&3](b|0,c|0,d|0,+e,f|0,g|0,h|0)}function ibc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;Wf[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,+i)}function jbc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Xf[a&127](b|0,c|0,d|0,e|0,f|0,g|0)|0}function kbc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;Yf[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0,j|0,k|0,l|0)}function lbc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;Zf[a&7](b|0,c|0,d|0,e|0,+f,+g,h|0)}function mbc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;_f[a&1](b|0,c|0,d|0,+e,+f,+g,+h,i|0)}function nbc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;$f[a&1](b|0,c|0,+d,e|0,f|0,g|0)}function obc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;ag[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0)}function pbc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;bg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,+l)}function qbc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;cg[a&1](b|0,c|0,d|0,+e,+f,+g,+h)}function rbc(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;return dg[a&1](b|0,+c,d|0)|0}function sbc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;eg[a&3](b|0,c|0,+d,+e,f|0,+g,+h)}function tbc(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;fg[a&3](b|0,+c,d|0)}function ubc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;gg[a&3](b|0,c|0,+d,+e,f|0,g|0)}function vbc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;hg[a&3](b|0,c|0,+d,+e,f|0,+g)}function wbc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;ig[a&7](b|0,c|0,d|0,e|0,f|0,+g,h|0)}function xbc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;jg[a&1](b|0,c|0,+d,+e,f|0,+g,+h,+i,+j)}function ybc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;kg[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0,k|0)}function zbc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=+j;lg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,+j)}function Abc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=+k;mg[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0,+k)}function Bbc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;ng[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,j|0)}function Cbc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;og[a&7](b|0,c|0,+d,+e,f|0)}function Dbc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;pg[a&1](b|0,c|0,d|0,+e,f|0,g|0)}function Ebc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;qg[a&3](b|0,c|0,d|0,e|0,f|0,+g,+h)}function Fbc(a,b){a=a|0;b=b|0;return +rg[a&15](b|0)}function Gbc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;sg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0,k|0,l|0)}function Hbc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;k=k|0;tg[a&3](b|0,c|0,d|0,e|0,+f,g|0,h|0,+i,+j,k|0)}function Ibc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;ug[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0,k|0,+l)}function Jbc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;j=j|0;vg[a&3](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0,j|0)}function Kbc(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;wg[a&1](+b,c|0,d|0)}function Lbc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return +xg[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function Mbc(a,b,c){a=a|0;b=b|0;c=c|0;return +yg[a&31](b|0,c|0)}function Nbc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;zg[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0,j|0)}function Obc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;Ag[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0,+j)}function Pbc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;Bg[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,+i,+j)}function Qbc(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;m=+m;n=n|0;Cg[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,+l,+m,n|0)}function Rbc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Dg[a&127](b|0,c|0,d|0,e|0)|0}function Sbc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;Eg[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0,k|0,l|0)}function Tbc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;Fg[a&1](b|0,c|0,d|0,+e,+f,+g,h|0)}function Ubc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;Gg[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,+j,+k)}function Vbc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return Hg[a&3](b|0,c|0,d|0,+e)|0}function Wbc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Ig[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Xbc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;Jg[a&1](b|0,c|0,+d,+e,f|0,g|0,h|0)}function Ybc(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;k=+k;l=l|0;m=m|0;n=n|0;return Kg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,j|0,+k,l|0,m|0,n|0)|0}function Zbc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;Lg[a&1](b|0,c|0,d|0,+e,+f,+g,h|0,i|0,j|0)}function _bc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;Mg[a&1](b|0,c|0,+d,e|0,f|0,g|0,+h)}function $bc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;Ng[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0,k|0)}function acc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;Og[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0)}function bcc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;return +Pg[a&1](b|0,c|0,d|0,+e,+f,g|0)}function ccc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=+g;h=h|0;i=i|0;Qg[a&1](b|0,c|0,d|0,+e,f|0,+g,h|0,i|0)}function dcc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return +Rg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function ecc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=+i;Sg[a&1](b|0,c|0,d|0,+e,f|0,g|0,h|0,+i)}function fcc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;Tg[a&1](b|0,c|0,d|0,+e,+f,+g,+h,i|0,j|0)}function gcc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;Ug[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function hcc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=+i;j=j|0;k=k|0;Vg[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,+i,j|0,k|0)}function icc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Wg[a&127](b|0,c|0,d|0,e|0,f|0,g|0)}function jcc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;Xg[a&3](b|0,c|0,d|0,+e,f|0,g|0,h|0,i|0)}function kcc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;Yg[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0)}function lcc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;Zg[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0,k|0)}function mcc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;j=j|0;_g[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0,j|0)}function ncc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;$g[a&15](b|0,c|0,d|0,+e,+f)}function occ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ah[a&7](b|0,c|0,d|0,+e,f|0)}function pcc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;return bh[a&1](b|0,c|0,+d,e|0,f|0,g|0,h|0)|0}function qcc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;ch[a&1](b|0,c|0,+d,+e,f|0,+g,+h,+i)}function rcc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;dh[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)}function scc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;return +eh[a&1](b|0,c|0,+d,+e,f|0)}function tcc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return +fh[a&31](b|0,c|0,d|0)}function ucc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;gh[a&3](b|0,c|0,d|0,+e,+f,+g)}function vcc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=+j;k=+k;hh[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i,+j,+k)}function wcc(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=+m;ih[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,+m)}function xcc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;jh[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i)}function ycc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;kh[a&1](b|0,c|0,d|0,+e,f|0,g|0,h|0,i|0,+j,k|0)}function zcc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;lh[a&1](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0,j|0,+k)}function Acc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;mh[a&7](b|0,c|0,d|0,+e,+f,g|0)}function Bcc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return nh[a&127](b|0,c|0,d|0,e|0,f|0)|0}function Ccc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;oh[a&63](b|0,c|0,d|0,+e)}function Dcc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=+i;ph[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,+i)}function Ecc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;qh[a&1](b|0,c|0,+d,e|0,f|0)}function Fcc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return rh[a&7](b|0,c|0,d|0,e|0,+f)|0}function Gcc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;sh[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0)}function Hcc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;th[a&511](b|0,c|0,d|0,e|0)}function Icc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;uh[a&255](b|0,c|0,d|0,e|0,f|0)}function Jcc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;vh[a&7](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0,j|0)}function Kcc(a,b,c){a=a|0;b=b|0;c=+c;wh[a&15](b|0,+c)}function Lcc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;return xh[a&3](b|0,c|0,+d,e|0)|0}function Mcc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;return yh[a&1](b|0,c|0,+d,+e)|0}function Ncc(a,b,c){a=a|0;b=b|0;c=c|0;zh[a&2047](b|0,c|0)}function Occ(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;Ah[a&15](b|0,c|0,d|0,e|0,+f)}function Pcc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=+i;j=j|0;Bh[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,+i,j|0)}function Qcc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;Ch[a&7](b|0,c|0,+d,+e)}function Rcc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;Dh[a&15](b|0,c|0,+d,e|0)}function Scc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;j=j|0;Eh[a&1](b|0,c|0,d|0,+e,f|0,g|0,+h,+i,j|0)}function Tcc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;return +Fh[a&1](b|0,c|0,d|0,+e)}function Ucc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;Gh[a&1](b|0,c|0,d|0,+e,+f,+g,h|0,i|0)}function Vcc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;Hh[a&255](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function Wcc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;Ih[a&1](b|0,c|0,d|0,+e,+f,+g,h|0,i|0,j|0,k|0)}function Xcc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;Jh[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i)}function Ycc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return +Kh[a&15](b|0,c|0,d|0,e|0)}function Zcc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=+j;k=+k;l=l|0;Lh[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,+j,+k,l|0)}function _cc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;Mh[a&7](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0)}function $cc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;i=+i;j=+j;Nh[a&1](b|0,c|0,d|0,+e,+f,g|0,+h,+i,+j)}function adc(a,b,c){a=a|0;b=b|0;c=+c;return Oh[a&1](b|0,+c)|0}function bdc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=+h;Ph[a&1](b|0,c|0,d|0,+e,+f,g|0,+h)}function cdc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Qh[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function ddc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=+g;h=h|0;Rh[a&1](b|0,c|0,+d,e|0,+f,+g,h|0)}function edc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Sh[a&7](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function fdc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;Th[a&127](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function gdc(a,b,c){a=a|0;b=b|0;c=c|0;return Uh[a&1023](b|0,c|0)|0}function hdc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Vh[a&3](b|0,c|0,d|0,+e,+f,g|0,h|0)}function idc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=+g;h=h|0;Wh[a&1](b|0,c|0,d|0,+e,f|0,+g,h|0)}function jdc(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;Xh[a&1](+b,c|0,d|0,e|0)}function kdc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;Yh[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0)}function ldc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=+h;i=i|0;j=j|0;k=k|0;Zh[a&1](b|0,c|0,d|0,e|0,+f,+g,+h,i|0,j|0,k|0)}function mdc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_h[a&255](b|0,c|0,d|0)}function ndc(a){a=a|0;$h[a&127]()}function odc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;ai[a&31](b|0,c|0,+d)}function pdc(a,b){a=a|0;b=b|0;bi[a&2047](b|0)}function qdc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=l|0;ci[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0,j|0,+k,l|0)}function rdc(a,b){a=a|0;b=b|0;return di[a&1023](b|0)|0}function sdc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=+j;k=k|0;ei[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,+i,+j,k|0)}function tdc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;fi[a&1](b|0,+c,d|0,+e,+f,g|0)}function udc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;gi[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,+i)}function vdc(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;hi[a&7](b|0,+c,d|0,e|0)}function wdc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;ii[a&7](b|0,c|0,d|0,e|0,+f,g|0)}function xdc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;ji[a&3](b|0,c|0,d|0,+e,+f,g|0,h|0,i|0)}function ydc(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ki[a&1](b|0,c|0,d|0,e|0,f|0,g|0,+h,i|0,j|0,k|0,l|0,m|0)}function zdc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return li[a&511](b|0,c|0,d|0)|0}function Adc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;mi[a&1](b|0,c|0,+d,e|0,+f,g|0,h|0)}function Bdc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;i=i|0;ni[a&1](b|0,c|0,d|0,e|0,+f,+g,h|0,i|0)}function Cdc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;return oi[a&3](b|0,c|0,+d)|0}function Ddc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;pi[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,+k,+l)}function Edc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;qi[a&7](b|0,c|0,d|0,e|0,+f,g|0,h|0)}function Fdc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return +ri[a&7](b|0,c|0,d|0,e|0,f|0)}function Gdc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return +si[a&1](b|0,c|0,d|0,e|0,+f)}function Hdc(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;return ti[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0)|0}function Idc(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;return ui[a&0](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0)|0}function Jdc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;vi[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h,+i,j|0)}function Kdc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;return wi[a&1](b|0,c|0,+d,e|0,f|0,g|0)|0}function Ldc(a){a=a|0;return xi[a&31]()|0}function Mdc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;return yi[a&1](b|0,c|0,+d,e|0,f|0)|0}function Ndc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return +zi[a&3](b|0,c|0,d|0,e|0,f|0,g|0)}function Odc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;Ai[a&1](b|0,+c,d|0,+e,+f,g|0,h|0)}function Pdc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;Bi[a&3](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,j|0)}function Qdc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;Ci[a&1](b|0,c|0,+d,e|0,+f,g|0)}function Rdc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Di[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function Sdc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=+g;h=h|0;i=i|0;Ei[a&1](b|0,c|0,+d,e|0,+f,+g,h|0,i|0)}function Tdc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=+j;Fi[a&1](b|0,c|0,d|0,e|0,f|0,+g,h|0,i|0,+j)}function Udc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;Gi[a&7](b|0,c|0,d|0,e|0,+f,+g)}function Vdc(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;Hi[a&1](b|0,+c,d|0,e|0,f|0)}function Wdc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;aa(0);return 0}function Xdc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;aa(1)}function Ydc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;aa(2)}function Zdc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;h=h|0;aa(3)}function _dc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;aa(4)}function $dc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;aa(5)}function aec(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aa(6);return 0}function bec(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;aa(7)}function cec(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;aa(8)}function dec(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;aa(9)}function eec(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;aa(10)}function fec(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;aa(11)}function gec(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;aa(12)}function hec(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;aa(13)}function iec(a,b,c){a=a|0;b=+b;c=c|0;aa(14);return 0}function jec(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;aa(15)}function kec(a,b,c){a=a|0;b=+b;c=c|0;aa(16)}function lec(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;aa(17)}function mec(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;aa(18)}function nec(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;aa(19)}function oec(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h=+h;i=+i;aa(20)}function pec(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;aa(21)}function qec(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;aa(22)}function rec(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=+j;aa(23)}function sec(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;aa(24)}function tec(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;aa(25)}function uec(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;aa(26)}function vec(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=+g;aa(27)}function wec(a){a=a|0;aa(28);return 0.0}function xec(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;aa(29)}function yec(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;j=j|0;aa(30)}function zec(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;aa(31)}function Aec(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;i=i|0;aa(32)}function Bec(a,b,c){a=+a;b=b|0;c=c|0;aa(33)}function Cec(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aa(34);return 0.0}function Dec(a,b){a=a|0;b=b|0;aa(35);return 0.0}function Eec(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;aa(36)}function Fec(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=+i;aa(37)}function Gec(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=+h;i=+i;aa(38)}function Hec(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=+k;l=+l;m=m|0;aa(39)}function Iec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aa(40);return 0}function Jec(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;aa(41)}function Kec(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;aa(42)}function Lec(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;aa(43)}function Mec(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;aa(44);return 0}function Nec(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aa(45);return 0}function Oec(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=f|0;g=g|0;aa(46)}function Pec(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=i|0;j=+j;k=k|0;l=l|0;m=m|0;aa(47);return 0}function Qec(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;i=i|0;aa(48)}function Rec(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=+g;aa(49)}function Sec(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;aa(50)}function Tec(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;aa(51)}function Uec(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;aa(52);return 0.0}function Vec(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;h=h|0;aa(53)}function Wec(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(54);return 0.0}function Xec(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=+h;aa(55)}function Yec(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=+g;h=h|0;i=i|0;aa(56)}function Zec(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;aa(57)}function _ec(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;j=j|0;aa(58)}function $ec(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aa(59)}function afc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;aa(60)}function bfc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;aa(61)}function cfc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;aa(62)}function dfc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;aa(63)}function efc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;aa(64)}function ffc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;aa(65)}function gfc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;g=g|0;aa(66);return 0}function hfc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=+d;e=e|0;f=+f;g=+g;h=+h;aa(67)}function ifc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;aa(68)}function jfc(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;aa(69);return 0.0}function kfc(a,b,c){a=a|0;b=b|0;c=c|0;aa(70);return 0.0}function lfc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;aa(71)}function mfc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;j=+j;aa(72)}function nfc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=+l;aa(73)}function ofc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;aa(74)}function pfc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=g|0;h=h|0;i=+i;j=j|0;aa(75)}function qfc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;aa(76)}function rfc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;aa(77)}function sfc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aa(78);return 0}function tfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;aa(79)}function ufc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;aa(80)}function vfc(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;aa(81)}function wfc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;aa(82);return 0}function xfc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;aa(83)}function yfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aa(84)}function zfc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aa(85)}function Afc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;aa(86)}function Bfc(a,b){a=a|0;b=+b;aa(87)}function Cfc(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;aa(88);return 0}function Dfc(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;aa(89);return 0}function Efc(a,b){a=a|0;b=b|0;aa(90)}function Ffc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;aa(91)}function Gfc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=+h;i=i|0;aa(92)}function Hfc(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;aa(93)}function Ifc(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;aa(94)}function Jfc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;g=+g;h=+h;i=i|0;aa(95)}function Kfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;aa(96);return 0.0}function Lfc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;aa(97)}function Mfc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(98)}function Nfc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=+f;g=g|0;h=h|0;i=i|0;j=j|0;aa(99)}function Ofc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;aa(100)}function Pfc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;aa(101);return 0.0}function Qfc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;j=+j;k=k|0;aa(102)}function Rfc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;aa(103)}function Sfc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;h=+h;i=+i;aa(104)}function Tfc(a,b){a=a|0;b=+b;aa(105);return 0}function Ufc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=+g;aa(106)}function Vfc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;aa(107)}function Wfc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;aa(108)}function Xfc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;aa(109)}function Yfc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;aa(110)}function Zfc(a,b){a=a|0;b=b|0;aa(111);return 0}function _fc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;aa(112)}function $fc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=+f;g=g|0;aa(113)}function agc(a,b,c,d){a=+a;b=b|0;c=c|0;d=d|0;aa(114)}function bgc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;aa(115)}function cgc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;h=h|0;i=i|0;j=j|0;aa(116)}function dgc(a,b,c){a=a|0;b=b|0;c=c|0;aa(117)}function egc(){aa(118)}function fgc(){Xe()}function ggc(a,b,c){a=a|0;b=b|0;c=+c;aa(119)}function hgc(a){a=a|0;aa(120)}function igc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=k|0;aa(121)}function jgc(a){a=a|0;aa(122);return 0}function kgc(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;i=+i;j=j|0;aa(123)}function lgc(a,b,c,d,e,f){a=a|0;b=+b;c=c|0;d=+d;e=+e;f=f|0;aa(124)}function mgc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;aa(125)}function ngc(a,b,c,d){a=a|0;b=+b;c=c|0;d=d|0;aa(126)}function ogc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;aa(127)}function pgc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;g=g|0;h=h|0;aa(128)}function qgc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;aa(129)}function rgc(a,b,c){a=a|0;b=b|0;c=c|0;aa(130);return 0}function sgc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=f|0;g=g|0;aa(131)}function tgc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;h=h|0;aa(132)}function ugc(a,b,c){a=a|0;b=b|0;c=+c;aa(133);return 0}function vgc(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=+j;k=+k;aa(134)}function wgc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;aa(135)}function xgc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;aa(136);return 0.0}function ygc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;aa(137);return 0.0}function zgc(a,b,c,d,e,f,g,h,i,j,k,l){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;aa(138);return 0}function Agc(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;aa(139);return 0}function Bgc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;h=+h;i=i|0;aa(140)}function Cgc(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;f=f|0;aa(141);return 0}function Dgc(){aa(142);return 0}function Egc(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;aa(143);return 0}function Fgc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;aa(144);return 0.0}function Ggc(a,b,c,d,e,f,g){a=a|0;b=+b;c=c|0;d=+d;e=+e;f=f|0;g=g|0;aa(145)}function Hgc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;aa(146)}function Igc(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=f|0;aa(147)}function Jgc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;aa(148);return 0}function Kgc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=+c;d=d|0;e=+e;f=+f;g=g|0;h=h|0;aa(149)}function Lgc(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=+i;aa(150)}function Mgc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;aa(151)}function Ngc(a,b,c,d,e){a=a|0;b=+b;c=c|0;d=d|0;e=e|0;aa(152)}

// EMSCRIPTEN_END_FUNCS
var Rf=[Wdc,c2b,i2b,Wdc];var Sf=[Xdc,yw];var Tf=[Ydc,Noa,qp,or,_B,Ydc,Ydc,Ydc];var Uf=[Zdc,Ew,ml,Zdc];var Vf=[_dc,Ooa,Br,_dc];var Wf=[$dc,Mq];var Xf=[aec,vG,wG,xG,yG,zG,AG,BG,sH,tH,uH,vH,wH,xH,yH,zH,AH,BH,CH,DH,EH,FH,GH,HH,IH,JH,KH,LH,MH,_7,jHb,kHb,mZb,nZb,oZb,pZb,qZb,rZb,sZb,tZb,uZb,vZb,wZb,g_b,h_b,i_b,j_b,k_b,l_b,m_b,n_b,o_b,p_b,q_b,J_b,L_b,__b,a$b,l$b,m$b,n$b,o$b,p$b,Y$b,Z$b,_$b,$$b,a0b,d2b,j2b,Pt,rm,Ex,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec,aec];var Yf=[bec,ey];var Zf=[cec,qw,sw,hl,Zw,Hy,cec,cec];var _f=[dec,Xk];var $f=[eec,uq];var ag=[fec,nx];var bg=[gec,am];var cg=[hec,Yk];var dg=[iec,hB];var eg=[jec,bl,el,jec];var fg=[kec,op,$q,kec];var gg=[lec,Ok,fp,lec];var hg=[mec,cl,fl,mec];var ig=[nec,Mx,En,xz,uA,KB,xr,nec];var jg=[oec,$k];var kg=[pec,Jy];var lg=[qec,Ow];var mg=[rec,Ey];var ng=[sec,Fz];var og=[tec,Pk,dl,gl,gp,tec,tec,tec];var pg=[uec,Cr];var qg=[vec,Fw,nl,vec];var rg=[wec,Wma,tsa,Dsa,_sa,qta,sta,uta,wta,yta,Ata,Cta,Ita,vm,Pm,ap];var sg=[xec,SB];var tg=[yec,Poa,Kq,yec];var ug=[zec,Iy];var vg=[Aec,Fy,Ky,Aec];var wg=[Bec,en];var xg=[Cec,ty,vo,Yy];var yg=[Dec,Epa,Upa,rMb,DMb,_i,Vu,bv,jv,rv,zv,Gv,Kv,Sv,Wv,Dl,um,Gx,to,$o,dp,Zp,BA,nB,igb,$gb,bhb,Dec,Dec,Dec,Dec,Dec];var zg=[Eec,eo];var Ag=[Fec,Zn];var Bg=[Gec,Lq];var Cg=[Hec,sX,pX,qX,rX,Hec,Hec,Hec];var Dg=[Iec,dL,pT,Y7,Z7,BEb,jGb,kGb,vGb,xGb,yGb,zGb,AGb,BGb,EGb,GGb,HGb,IGb,UGb,dHb,mHb,oHb,aLb,lLb,nLb,xLb,KLb,_Lb,kMb,wMb,IMb,UMb,eNb,qNb,q3b,N3b,O3b,P3b,V3b,Mt,Nt,Rt,bu,ru,tu,uk,wu,xk,zu,Ak,Cu,Dk,Fu,Gk,Jk,Kk,iw,_r,Us,mt,Ct,om,Bx,tm,cy,my,Cy,Wp,Nz,fA,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec,Iec];var Eg=[Jec,Kqa,tr,Jec];var Fg=[Kec,rn];var Gg=[Lec,rA];var Hg=[Mec,ju,os,Es];var Ig=[Nec,J0b,P0b,M1b,N1b,V1b,W1b,Dx];var Jg=[Oec,ep];var Kg=[Pec,kA];var Lg=[Qec,pn];var Mg=[Rec,wl];var Ng=[Sec,uz,HB,ur];var Og=[Tec,tq];var Pg=[Uec,Pz];var Qg=[Vec,yy];var Rg=[Wec,Xy];var Sg=[Xec,Sw];var Tg=[Yec,Wk];var Ug=[Zec,Gw,ol,Wl,Fn,vA,LB,yr];var Vg=[_ec,vw];var Wg=[$ec,AI,BI,CI,DI,xP,LX,MX,NX,OX,PX,QX,RX,EX,FX,GX,HX,IX,JX,KX,b7,W6,Q6,K6,E6,y6,s6,m6,g6,a6,W5,Q5,gaa,eaa,naa,laa,uaa,saa,Baa,zaa,Jaa,Haa,Qaa,Oaa,Xaa,Vaa,cba,aba,jba,hba,qba,oba,yba,wba,Bba,Jba,Hba,Mba,Qba,Rga,Sga,Tga,Uga,Vga,oka,kka,gka,cka,_ja,Wja,Sja,Oja,Kja,Gja,Moa,Roa,Zza,LGb,NGb,wOb,xOb,JWb,$Wb,p2b,u2b,M6b,V6b,u7b,Mw,tl,Tw,ax,Tl,gx,_l,fm,sx,jm,wx,Um,Qx,_m,Tx,jn,ay,iy,yn,py,In,sy,ho,yo,$y,cz,Uo,Cp,Ip,Dz,Rp,Iz,Qz,lq,Uz,pq,XB,UX,TX,$ec];var Xg=[afc,Iqa,Ar,afc];var Yg=[bfc,ny,Pp,VB];var Zg=[cfc,TB];var _g=[dfc,gy];var $g=[efc,Ri,pw,Sk,Uk,_k,Fl,bo,Mp,efc,efc,efc,efc,efc,efc,efc];var ah=[ffc,Xw,an,Xo,Dr,ffc,ffc,ffc];var bh=[gfc,Wz];var ch=[hfc,al];var dh=[ifc,QK,bm,ox,Yx,ifc,ifc,ifc];var eh=[jfc,dq];var fh=[kfc,qY,rY,sY,tY,uY,vY,wY,dGb,eGb,iu,Hu,Lu,Yw,nm,Nn,so,Vy,_o,nz,cp,pz,lp,Yp,kfc,kfc,kfc,kfc,kfc,kfc,kfc,kfc];var gh=[lfc,Zk,Pn,lfc];var hh=[mfc,Aw];var ih=[nfc,mx];var jh=[ofc,Cw];var kh=[pfc,$l];var lh=[qfc,co];var mh=[rfc,ow,Rk,Tk,El,ao,Lp,rfc];var nh=[sfc,gG,hG,iG,jG,kG,lG,mG,NG,OG,PG,QG,RG,SG,TG,UG,VG,WG,XG,YG,ZG,_G,$G,aH,bH,cH,dH,eH,fH,yua,iva,jbb,rbb,Abb,Rbb,hcb,Acb,Wcb,hdb,udb,Idb,Udb,geb,Beb,Veb,ifb,vfb,Kfb,Xfb,fgb,Bgb,Tgb,Chb,Vhb,cib,nib,Bib,Pib,bjb,pjb,Djb,Rjb,dkb,tkb,Ikb,Vkb,hlb,JGb,lHb,nHb,aZb,gZb,H_b,I_b,K_b,O_b,Y_b,Z_b,$_b,d$b,z2b,C2b,R2b,U2b,s3b,X3b,K2b,N2b,_2b,b3b,Ot,Pi,uu,xu,Au,Du,Gu,Ax,sm,Fx,Mz,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc,sfc];var oh=[tfc,kta,pGb,qGb,ZGb,_Gb,Ti,$i,ls,Bs,Vk,Hx,bn,io,Yo,Np,Rq,Yq,Er,_X,ZX,aY,$X,cY,bY,eY,dY,gY,fY,iY,hY,kY,jY,mY,lY,oY,nY,k3,j3,i3,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc,tfc];var ph=[ufc,xw];var qh=[vfc,vq];var rh=[wfc,M_b,N_b,b$b,c$b,wfc,wfc,wfc];var sh=[xfc,hy];var th=[yfc,bZ,cZ,dZ,eZ,fZ,gZ,hZ,iZ,YO,ZO,_O,$O,aP,bP,cP,yP,xR,YQ,eR,fR,gR,hR,yR,pR,CR,oR,FR,IR,JR,KR,PR,QR,RR,$R,fS,lS,oS,psa,fva,gva,_za,Sab,Tab,hbb,ibb,pbb,qbb,ybb,zbb,Jbb,Kbb,Tbb,ecb,fcb,jcb,ycb,zcb,Scb,Tcb,edb,fdb,sdb,tdb,Edb,Fdb,Pdb,Qdb,eeb,feb,heb,web,xeb,Teb,Ueb,gfb,hfb,qfb,rfb,Ifb,Jfb,Vfb,Wfb,cgb,dgb,xgb,ygb,Rgb,Sgb,Ahb,Bhb,Ihb,Jhb,Qhb,Rhb,aib,bib,iib,jib,wib,xib,Kib,Lib,Yib,Zib,kjb,ljb,yjb,zjb,Mjb,Njb,_jb,$jb,okb,pkb,Ekb,Fkb,Tkb,Ukb,clb,dlb,qpb,zsb,Asb,YFb,gGb,lGb,nGb,rGb,sGb,tGb,uGb,wGb,VGb,XGb,$Gb,aHb,bHb,cHb,eHb,pHb,qHb,cLb,fLb,gLb,zLb,CLb,DLb,MLb,PLb,QLb,aMb,dMb,eMb,mMb,pMb,qMb,yMb,BMb,CMb,KMb,NMb,OMb,WMb,ZMb,_Mb,gNb,jNb,kNb,sNb,vNb,wNb,oOb,pOb,uOb,wPb,xPb,KWb,aXb,bZb,hZb,O6b,X6b,w7b,Dj,Yi,Vi,Yt,Sj,au,Uj,eu,Yj,ou,fk,hk,jk,lk,nk,pk,rk,pj,qj,Xr,Rs,it,zt,kl,Iw,Rw,yl,Gl,_w,Kl,Ml,Pl,cx,Vl,hm,lm,mm,zm,Jx,Im,Lm,Nm,Qm,Wm,Zm,ln,tn,ky,An,Cn,Hn,Xn,Oy,lo,qo,Ty,Ao,Fo,Jo,gz,Wo,np,tp,zz,wp,Az,Ep,Gp,Kp,bq,iq,nq,rq,Qq,OA,ZA,oB,xB,BB,DB,sr,cC,NT,ZT,PT,$T,OT,_T,bV,jV,mV,pV,sV,wV,Q2,qpa,Xra,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc,yfc];var uh=[zfc,OC,IC,RF,SF,TF,UF,VF,WF,XF,YF,ZF,_F,$F,aG,MJ,NJ,bM,cM,dM,eM,fM,gM,hM,iM,jM,kM,XQ,K5,G5,C5,y5,u5,q5,m5,i5,e5,a5,C7,y7,u7,q7,m7,$7,x8,C8,H8,M8,R8,W8,$8,e9,j9,o9,w9,u9,E9,C9,Bja,xja,tja,pja,lja,hja,dja,$ia,Xia,Tia,Mna,Nna,Ona,Pna,Qna,Rna,Sna,sua,Wab,Nbb,glb,ZFb,mGb,oGb,FGb,KGb,MGb,QGb,RGb,SGb,TGb,WGb,YGb,vOb,N6b,W6b,v7b,$t,Hw,pl,ul,xl,Uw,Ol,bx,Ul,hx,gm,tx,km,xx,yx,Ix,Hm,Vm,Rx,Ym,$m,kn,by,sn,jy,zn,Gn,qy,Jn,Qy,po,Sy,zo,az,Eo,fz,Vo,mp,yz,Dp,Fp,Jp,Ez,Sp,aq,hq,Rz,mq,Vz,qq,wA,MB,zr,XX,WX,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc,zfc];var vh=[Afc,Jqa,pp,nr,ZB,Afc,Afc,Afc];var wh=[Bfc,Vma,usa,Esa,$sa,rta,tta,vta,xta,zta,Bta,Dta,Jta,ar,cr,Bfc];var xh=[Cfc,Zz,UA,Cfc];var yh=[Dfc,By];var zh=[Efc,$C,ZC,UK,eL,NK,EO,HWb,sT,AY,BY,DY,EY,ZZ,WZ,TZ,b_,f_,n_,l_,j_,u_,s_,q_,x_,A_,I_,F_,D_,S_,P_,M_,$_,Y_,W_,j$,g$,d$,u$,s$,p$,n$,H$,E$,B$,y$,b0,_$,S$,P$,u0,r0,m0,j0,y0,z0,A0,B0,C0,D0,E0,F0,P0,Q0,R0,S0,Y0,$0,a1,b1,c1,d1,e1,f1,g1,h1,i1,j1,k1,z1,C1,u2,q2,i2,d3,e3,U3,S3,$3,Z3,X3,r4,n4,y4,w4,u4,N4,I4,M7,K7,rea,Sea,Xea,afa,ffa,kfa,ufa,Afa,Gfa,Mfa,Sfa,bga,hga,nga,tga,zga,Iga,Kga,Mga,Oga,Qga,Zga,bha,fha,kha,pha,sha,Kha,Xha,iia,via,Iia,Sla,Ula,Wla,_la,ama,cma,Xma,Yma,rna,mna,hna,cna,wna,Xna,boa,woa,uoa,Boa,Goa,Loa,Yoa,hpa,ypa,Cpa,Rpa,mqa,Fqa,Mqa,Pqa,Qqa,Xqa,gsa,jsa,ssa,wsa,ysa,Asa,Csa,Gsa,Lsa,Ssa,Tsa,Vsa,Wsa,Xsa,Zsa,ita,jta,lta,nta,pta,Fta,Hta,Qta,Xza,zKb,CKb,DKb,uAa,yAa,zAa,AAa,CAa,SAa,WAa,XAa,YAa,ZAa,wBa,ABa,BBa,CBa,DBa,kCa,oCa,pCa,LKb,rCa,MBa,Pob,TBa,WBa,KDa,ODa,PDa,QDa,RDa,DCa,ECa,OCa,PCa,UCa,VCa,XCa,_Ca,aDa,bDa,kDa,lDa,BEa,FEa,GEa,HEa,IEa,eFa,iFa,jFa,kFa,lFa,SFa,WFa,XFa,YFa,ZFa,KGa,OGa,PGa,QGa,RGa,pGa,tGa,uGa,vGa,wGa,vHa,zHa,AHa,BHa,CHa,HIa,LIa,MIa,NIa,OIa,THa,XHa,YHa,ZHa,_Ha,nIa,rIa,sIa,tIa,uIa,wJa,AJa,BJa,CJa,DJa,kLa,oLa,pLa,qLa,rLa,VKa,ZKa,_Ka,$Ka,aLa,FKa,JKa,KKa,LKa,MKa,TJa,XJa,YJa,ZJa,_Ja,ILa,MLa,NLa,OLa,PLa,E8a,I8a,J8a,K8a,L8a,o8a,s8a,t8a,u8a,v8a,Z7a,b8a,c8a,d8a,e8a,J7a,N7a,O7a,P7a,Q7a,u7a,y7a,z7a,A7a,B7a,f7a,j7a,k7a,l7a,m7a,R6a,V6a,W6a,X6a,Y6a,A6a,E6a,F6a,G6a,H6a,l6a,p6a,q6a,r6a,s6a,C5a,G5a,H5a,I5a,J5a,j5a,n5a,o5a,p5a,q5a,T4a,X4a,Y4a,Z4a,_4a,B4a,F4a,G4a,H4a,I4a,l4a,p4a,q4a,r4a,s4a,A3a,E3a,F3a,G3a,H3a,j3a,n3a,o3a,p3a,q3a,W2a,_2a,$2a,a3a,b3a,H2a,L2a,M2a,N2a,O2a,s2a,w2a,x2a,y2a,z2a,c2a,g2a,h2a,i2a,j2a,N1a,R1a,S1a,T1a,U1a,u1a,y1a,z1a,A1a,B1a,d1a,h1a,i1a,j1a,k1a,P0a,T0a,U0a,V0a,W0a,A0a,E0a,F0a,G0a,H0a,j0a,n0a,o0a,p0a,q0a,W$a,_$a,$$a,a0a,b0a,C$a,G$a,H$a,I$a,J$a,l$a,p$a,q$a,r$a,s$a,X_a,$_a,a$a,b$a,c$a,I_a,M_a,N_a,O_a,P_a,r_a,v_a,w_a,x_a,y_a,_Za,c_a,d_a,e_a,f_a,JZa,NZa,OZa,PZa,QZa,sZa,wZa,xZa,yZa,zZa,bZa,fZa,gZa,hZa,iZa,OYa,SYa,TYa,UYa,VYa,yYa,CYa,DYa,EYa,FYa,hYa,lYa,mYa,nYa,oYa,VXa,ZXa,_Xa,$Xa,aYa,FXa,JXa,KXa,LXa,MXa,qXa,uXa,vXa,wXa,xXa,_Wa,cXa,dXa,eXa,fXa,JWa,NWa,OWa,PWa,QWa,uWa,yWa,zWa,AWa,BWa,fWa,jWa,kWa,lWa,mWa,PVa,TVa,UVa,VVa,WVa,yVa,CVa,DVa,EVa,FVa,jVa,nVa,oVa,pVa,qVa,SUa,WUa,XUa,YUa,ZUa,zUa,DUa,EUa,FUa,GUa,hUa,lUa,mUa,nUa,oUa,STa,WTa,XTa,YTa,ZTa,ATa,ETa,FTa,GTa,HTa,hTa,lTa,mTa,nTa,oTa,SSa,WSa,XSa,YSa,ZSa,CSa,GSa,HSa,ISa,JSa,nSa,rSa,sSa,tSa,uSa,ZRa,bSa,cSa,dSa,eSa,IRa,MRa,NRa,ORa,PRa,rRa,vRa,wRa,xRa,yRa,aRa,eRa,fRa,gRa,hRa,NQa,RQa,SQa,TQa,UQa,uOa,yOa,zOa,AOa,BOa,UNa,YNa,ZNa,_Na,$Na,xNa,BNa,CNa,DNa,ENa,eNa,iNa,jNa,kNa,lNa,OMa,SMa,TMa,UMa,VMa,uMa,yMa,zMa,AMa,BMa,bMa,fMa,gMa,hMa,iMa,bbb,Ybb,ocb,mcb,xdb,ieb,jeb,keb,Feb,zfb,rib,Fib,Tib,fjb,tjb,Hjb,Vjb,hkb,ykb,Nkb,rlb,Slb,oob,uob,Aob,Fob,Hub,Lub,Mub,Nub,Oub,LDb,PDb,QDb,RDb,SDb,gDb,kDb,lDb,mDb,nDb,QCb,UCb,VCb,WCb,XCb,yCb,CCb,DCb,ECb,FCb,eCb,iCb,jCb,kCb,lCb,NBb,RBb,SBb,TBb,UBb,rBb,vBb,wBb,xBb,yBb,_Ab,cBb,dBb,eBb,fBb,FAb,JAb,KAb,LAb,MAb,lAb,pAb,qAb,rAb,sAb,Tzb,Xzb,Yzb,Zzb,_zb,Azb,Ezb,Fzb,Gzb,Hzb,hzb,lzb,mzb,nzb,ozb,Ryb,Vyb,Wyb,Xyb,Yyb,zyb,Dyb,Eyb,Fyb,Gyb,hyb,lyb,myb,nyb,oyb,Rxb,Vxb,Wxb,Xxb,Yxb,uxb,yxb,zxb,Axb,Bxb,Xwb,$wb,axb,bxb,cxb,Fwb,Jwb,Kwb,Lwb,Mwb,iwb,mwb,nwb,owb,pwb,Rvb,Vvb,Wvb,Xvb,Yvb,uvb,yvb,zvb,Avb,Bvb,avb,evb,fvb,gvb,hvb,GKb,HKb,IKb,cFb,dFb,JIb,_Ib,$Ib,eJb,fJb,hJb,kJb,bLb,eLb,yLb,BLb,LLb,OLb,$Lb,cMb,lMb,oMb,xMb,AMb,JMb,MMb,VMb,YMb,fNb,iNb,rNb,uNb,ZWb,zYb,GYb,NYb,UYb,X0b,Y0b,Z0b,_0b,a1b,b1b,h1b,i1b,j1b,k1b,m1b,n1b,s1b,t1b,u1b,v1b,x1b,y1b,D1b,E1b,F1b,G1b,I1b,J1b,q2b,v2b,A3b,B3b,C3b,H3b,I3b,J3b,Ej,Fj,Gj,Hj,Ij,Jj,Kj,Lj,Mj,cj,$j,aj,fj,gj,Ui,ij,jj,kj,rj,sj,tj,oj,nj,Lr,$r,ps,Fs,Vs,nt,Jl,Rl,ym,Bm,Sm,wn,Dn,On,ko,oo,Bo,Io,Mo,Oo,Ro,jp,vp,yp,Tp,Kz,Lz,_p,$p,eq,gq,jq,sq,yq,Aq,Cq,Eq,Gq,Jq,Tq,Wq,_q,kB,fr,hr,jr,bN,cN,dN,eN,fN,gN,ON,NN,MN,LN,KN,JN,IN,HN,GN,FN,EN,DN,CN,BN,AN,zN,yN,xN,wN,vN,uN,tN,sN,rN,qN,pN,oN,nN,mN,lN,kN,jN,iN,hN,poa,qoa,moa,noa,ooa,F9a,G9a,H9a,I9a,J9a,K9a,L9a,M9a,N9a,O9a,P9a,Q9a,R9a,S9a,T9a,U9a,V9a,W9a,X9a,Y9a,Z9a,_9a,$9a,aab,bab,cab,dab,eab,fab,gab,hab,iab,jab,kab,lab,mab,nab,oab,_mb,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc,Efc];var Ah=[Ffc,iR,kR,OGb,PGb,Zt,uw,jl,Gm,Vx,Ny,Pq,NA,YA,rr,bC];var Bh=[Gfc,ww];var Ch=[Hfc,Qk,wm,Wn,hp,Hfc,Hfc,Hfc];var Dh=[Ifc,jR,LR,SR,aS,gS,pS,Cl,tz,wq,Uq,Ifc,Ifc,Ifc,Ifc,Ifc];var Eh=[Jfc,Qoa];var Fh=[Kfc,Do];var Gh=[Lfc,qn];var Hh=[Mfc,DG,EG,FG,GG,HG,IG,JG,LI,MI,NI,OI,PI,QI,RI,SI,TI,UI,VI,WI,XI,YI,ZI,_I,$I,aJ,bJ,cJ,dJ,eJ,fJ,gJ,hJ,iJ,jJ,kJ,lJ,mJ,nJ,oJ,pJ,qJ,rJ,sJ,tJ,uJ,vJ,wJ,xJ,yJ,zJ,AJ,BJ,CJ,EJ,FJ,GJ,HJ,IJ,JJ,KJ,PJ,QJ,RJ,SJ,TJ,UJ,VJ,WJ,XJ,YJ,ZJ,_J,$J,aK,bK,cK,dK,eK,fK,gK,hK,iK,jK,kK,lK,mK,nK,oK,pK,qK,rK,sK,tK,uK,vK,wK,xK,yK,zK,AK,BK,CK,DK,EK,FK,GK,HK,IK,JK,OK,PK,GP,HP,IP,JP,KP,LP,MP,NP,OP,PP,ex,jx,dm,qx,ux,Dm,Lx,Ox,gn,_x,ly,Ly,mo,Zy,So,kz,Bz,Sz,RP,xia,wia,zia,yia,Bia,Aia,Dia,Cia,Fia,Eia,kia,jia,mia,lia,oia,nia,qia,pia,sia,ria,Zha,Yha,$ha,_ha,bia,aia,dia,cia,fia,eia,Mha,Lha,Oha,Nha,Qha,Pha,Sha,Rha,Uha,Tha,zha,yha,Bha,Aha,Dha,Cha,Fha,Eha,Hha,Gha,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc,Mfc];var Ih=[Nfc,on];var Jh=[Ofc,Pw,Gz,Ofc];var Kh=[Pfc,CGb,DGb,Iu,Mu,zx,Mn,wy,Uy,mz,bp,sz,Pfc,Pfc,Pfc,Pfc];var Lh=[Qfc,qA];var Mh=[Rfc,Soa,wz,tA,JB,wr,Rfc,Rfc];var Nh=[Sfc,Bw];var Oh=[Tfc,iB];var Ph=[Ufc,Dw];var Qh=[Vfc,KF,LF,MF,NF,OF,PF,QF,Cca,Hca,Mca,Rca,Wca,$ca,eda,jda,oda,tda,yda,Dda,Ida,Cga,Dga,Ega,Fga,Gga,Eka,Jka,Oka,Tka,Yka,bla,gla,lla,qla,vla,Hna,Ina,Jna,Kna,Lna,Cna,Dna,Ena,Fna,Gna,xna,yna,zna,Ana,Bna,Aoa,Rsa,pib,Dib,Rib,djb,rjb,Fjb,Tjb,fkb,vkb,Qw,Sl,fx,Zl,kx,em,rx,im,vx,Em,Tm,Px,Sx,hn,$x,vn,xn,ry,go,My,xo,_y,To,lz,Bp,Hp,Cz,Hz,kq,Tz,oq,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc,Vfc];var Rh=[Wfc,Ww];var Sh=[Xfc,Lw,sl,ix,oy,Qp,WB,Xfc];var Th=[Yfc,qD,rD,sD,tD,uD,vD,wD,FD,GD,HD,ID,JD,KD,LD,XD,YD,ZD,_D,$D,aE,bE,kE,lE,mE,nE,oE,pE,qE,zE,AE,BE,CE,DE,EE,FE,OE,PE,QE,RE,SE,TE,UE,WE,XE,YE,ZE,_E,$E,aF,cF,dF,eF,fF,gF,hF,iF,kF,lF,mF,nF,oF,pF,qF,sF,tF,uF,vF,wF,xF,yF,AF,BF,CF,DF,EF,FF,GF,Vfa,Wfa,Xfa,Yfa,Zfa,mfa,nfa,ofa,pfa,qfa,Kea,Lea,Mea,Nea,Oea,cm,px,Kx,fn,Zx,Ry,jz,eD,iD,lD,oD,wX,tX,uX,vX,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc,Yfc];var Uh=[Zfc,oG,pG,qG,rG,sG,RK,AP,BP,wR,rR,BR,ER,HR,OR,_R,eS,kS,nS,Hoa,Fpa,pqa,Hqa,oua,pua,qua,uua,vua,wua,hva,aAa,bAa,mAa,rAa,vAa,LAa,QAa,TAa,pBa,uBa,xBa,eCa,iCa,lCa,OBa,UBa,XBa,DDa,IDa,LDa,KCa,MCa,uEa,zEa,CEa,ZEa,cFa,fFa,LFa,QFa,TFa,EGa,JGa,LGa,iGa,nGa,qGa,oHa,tHa,wHa,AIa,FIa,IIa,MHa,RHa,UHa,gIa,lIa,oIa,pJa,uJa,xJa,fLa,sKa,lLa,QKa,tKa,WKa,zKa,uKa,GKa,MJa,RJa,UJa,CLa,GLa,JLa,B8a,hOa,F8a,j8a,m8a,p8a,V7a,Z3a,_7a,G7a,_3a,K7a,r7a,$3a,v7a,d7a,Y3a,g7a,M6a,P6a,S6a,x6a,JNa,B6a,j6a,b6a,m6a,x5a,A5a,D5a,e5a,h5a,k5a,O4a,R4a,U4a,y4a,mQa,C4a,i4a,W3a,m4a,v3a,y3a,B3a,g3a,oQa,k3a,T2a,uQa,X2a,E2a,iQa,I2a,o2a,eQa,t2a,_1a,TPa,d2a,I1a,L1a,O1a,p1a,s1a,v1a,$0a,sQa,e1a,N0a,UPa,Q0a,v0a,y0a,B0a,h0a,VPa,k0a,R$a,U$a,X$a,x$a,A$a,D$a,h$a,WPa,m$a,U_a,hQa,Y_a,E_a,fQa,J_a,m_a,p_a,s_a,VZa,YZa,$Za,FZa,tQa,KZa,nZa,qZa,tZa,_Ya,XPa,cZa,KYa,iOa,PYa,uYa,jQa,zYa,fYa,YPa,iYa,RXa,ZPa,WXa,DXa,_Pa,GXa,lXa,oXa,rXa,VWa,YWa,$Wa,GWa,$Pa,KWa,rWa,dQa,vWa,bWa,nQa,gWa,KVa,NVa,QVa,vVa,aQa,zVa,fVa,cQa,kVa,NUa,QUa,TUa,uUa,xUa,AUa,cUa,fUa,iUa,OTa,kQa,TTa,vTa,yTa,BTa,cTa,fTa,iTa,OSa,qQa,TSa,zSa,lQa,DSa,jSa,rQa,oSa,VRa,pQa,_Ra,DRa,GRa,JRa,nRa,gQa,sRa,_Qa,bQa,bRa,IQa,LQa,OQa,pOa,sOa,vOa,PNa,SNa,VNa,sNa,vNa,yNa,$Ma,cNa,fNa,JMa,MMa,PMa,pMa,sMa,vMa,YLa,$La,cMa,Uab,Lbb,Obb,Pbb,Qbb,Ucb,gdb,Gdb,Rdb,Xdb,Ydb,yeb,Aeb,sfb,ufb,egb,zgb,Shb,kib,yib,Mib,_ib,mjb,Ajb,Ojb,akb,qkb,Gkb,elb,gnb,hnb,inb,pob,Gob,Cub,Fub,Iub,GDb,JDb,MDb,bDb,eDb,hDb,LCb,OCb,RCb,tCb,wCb,zCb,$Bb,cCb,fCb,IBb,LBb,OBb,mBb,pBb,sBb,VAb,YAb,$Ab,AAb,DAb,GAb,gAb,jAb,mAb,Ozb,Rzb,Uzb,vzb,yzb,Bzb,czb,fzb,izb,Myb,Pyb,Syb,uyb,xyb,Ayb,cyb,fyb,iyb,Mxb,Pxb,Sxb,pxb,sxb,vxb,Swb,Vwb,Ywb,Awb,Dwb,Gwb,dwb,gwb,jwb,Mvb,Pvb,Svb,pvb,svb,vvb,Xub,_ub,bvb,$Eb,EKb,pFb,MFb,NFb,OFb,fHb,gHb,NKb,KIb,Kob,WIb,YIb,_Kb,$Kb,hLb,iLb,oLb,vLb,wLb,ELb,ILb,JLb,RLb,YLb,ZLb,fMb,iMb,jMb,uMb,vMb,GMb,HMb,PMb,SMb,TMb,$Mb,cNb,dNb,lNb,oNb,pNb,xNb,QNb,XPb,QWb,SWb,gXb,iXb,CYb,JYb,QYb,XYb,l3b,n3b,p3b,Q3b,S3b,U3b,It,Jt,St,Ut,Vt,Wt,fu,_j,hu,lu,pu,sk,vk,yk,Bk,Ek,Hk,Lk,Pu,Tu,Zu,fv,nv,vv,xv,Bv,Cv,Dv,Mv,Qv,_v,aw,cw,dw,fw,hw,Yr,ms,Cs,Ss,jt,At,dx,qm,Nx,nn,xy,Wy,ez,iz,$z,bA,Iq,mA,xA,zA,DA,FA,WA,mB,AB,mr,QB,YB,AU,BU,CU,DU,EU,aV,eV,iV,lV,oV,rV,vV,FV,GV,HV,IV,JV,k2,P2,ppa,Wra,lgb,chb,uFb,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc,Zfc];var Vh=[_fc,nw,$n,rz];var Wh=[$fc,zy];var Xh=[agc,dn];var Yh=[bgc,UB];var Zh=[cgc,fy];var _h=[dgc,AC,xC,lC,mC,nC,oC,pC,qC,MK,lM,mM,nM,oM,pM,qM,rM,sM,tM,uM,ZQ,_Q,$Q,aR,bR,cR,dR,mR,nR,qR,MR,UR,VR,hS,Uma,Ioa,Koa,Gpa,Vpa,qqa,nua,rua,tua,eva,WCa,Vab,Ibb,Mbb,gcb,xcb,Rcb,Vcb,rdb,Hdb,Sdb,Tdb,Wdb,deb,zeb,ffb,tfb,Hfb,Agb,Thb,Uhb,lib,mib,zib,Aib,Nib,Oib,$ib,ajb,njb,ojb,Bjb,Cjb,Pjb,Qjb,bkb,ckb,rkb,skb,Hkb,blb,flb,jlb,klb,RFb,TFb,VFb,XFb,_Fb,gJb,dLb,mLb,pLb,ALb,FLb,NLb,SLb,bMb,nMb,zMb,LMb,XMb,hNb,tNb,lOb,mOb,nOb,sOb,tOb,YPb,Cj,Zi,Xi,Tt,Si,Rj,Tj,Vj,du,dj,Zj,bk,bj,ck,ej,nu,hj,ek,gk,ik,kk,mk,ok,qk,Qu,Uu,_u,gv,ov,wv,yv,Nv,Rv,$v,bw,mj,Wr,Mr,Or,as,cs,qs,ss,Qs,Gs,Is,ht,Ws,Ys,yt,ot,qt,ll,vl,zl,Hl,Il,$w,Ll,Nl,Ql,Am,Cm,Jm,Mm,Om,Rm,Xm,cn,un,Bn,Qn,Tn,Vn,Yn,jo,Py,no,ro,Co,Go,Ho,Ko,Lo,No,Po,Qo,Zo,kp,up,xp,zp,Ap,Op,Jz,Oz,cq,fq,zq,Bq,Dq,Fq,pA,yA,AA,EA,GA,Sq,PA,Zq,gB,dr,er,yB,gr,ir,CB,kr,Fr,SY,RY,UY,TY,TT,aU,VT,cU,UT,bU,K1,G1,H1,I1,J1,Q1,M1,N1,O1,P1,m3,l3,dgc];var $h=[egc,fgc,E6b,DAa,EAa,FAa,HAa,Cnb,EBa,FBa,GBa,IBa,wCa,JEa,KEa,LEa,NEa,mFa,nFa,oFa,qFa,_Fa,$Fa,aGa,cGa,eGa,DHa,EHa,FHa,HHa,cIa,fJa,gJa,iJa,jJa,EJa,FJa,GJa,IJa,QLa,RLa,SLa,ULa,Bnb,mpb,rpb,tpb,erb,frb,xtb,csb,dsb,ytb,Pub,Qub,Rub,Tub,kIb,lIb,kKb,lKb,OKb,PKb,QKb,RKb,SKb,TKb,UKb,VKb,WKb,XKb,BNb,MNb,NNb,EPb,FPb,Z6b,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc,egc];var ai=[ggc,qOb,rOb,Wu,cv,kv,sv,Av,Hv,Lv,Tv,Xv,ks,As,xm,ip,xq,CA,Vq,lB,WT,YT,XT,ggc,ggc,ggc,ggc,ggc,ggc,ggc,ggc,ggc];var bi=[hgc,fC,BC,yC,zC,hC,iC,jC,DC,PC,JC,KC,FC,GC,QQ,_C,YC,VK,WK,XK,LK,bL,YN,ZN,$N,aO,BO,CO,tP,CP,DP,EP,vP,wP,WQ,vR,AR,DR,GR,NR,ZR,dS,jS,mS,nT,oT,rT,HT,IT,nXb,oXb,pXb,qXb,GU,HU,IU,JU,xY,yY,zY,YZ,VZ,SZ,a_,e_,m_,k_,i_,t_,r_,p_,w_,z_,H_,E_,C_,R_,O_,L_,__,X_,V_,i$,f$,c$,t$,r$,o$,m$,G$,D$,A$,x$,a0,Z$,R$,O$,t0,q0,l0,i0,N0,M0,L0,K0,J0,I0,H0,G0,W0,V0,U0,T0,Z0,w1,v1,u1,t1,s1,r1,q1,p1,o1,n1,m1,l1,y1,B1,t2,p2,g2,h2,g3,f3,T3,R3,_3,Y3,W3,q4,m4,x4,v4,t4,L4,M4,H4,O7,J5,H5,I5,F5,D5,E5,B5,z5,A5,x5,v5,w5,t5,r5,s5,p5,n5,o5,l5,j5,k5,h5,f5,g5,d5,b5,c5,$4,Z4,_4,$6,a7,c7,Z6,_6,U6,V6,X6,S6,T6,O6,P6,R6,M6,N6,I6,J6,L6,G6,H6,C6,D6,F6,A6,B6,w6,x6,z6,u6,v6,q6,r6,t6,o6,p6,k6,l6,n6,i6,j6,e6,f6,h6,c6,d6,_5,$5,b6,Y5,Z5,U5,V5,X5,S5,T5,O5,P5,R5,M5,N5,e7,f7,B7,z7,A7,x7,v7,w7,t7,r7,s7,p7,n7,o7,l7,j7,k7,L7,J7,P7,Q7,R7,S7,T7,U7,V7,W7,X7,x9,y9,p9,q9,k9,l9,f9,g9,a9,b9,X8,Y8,S8,T8,N8,O8,I8,J8,D8,E8,y8,z8,t8,u8,v8,w8,A8,B8,F8,G8,K8,L8,P8,Q8,U8,V8,Z8,_8,c9,d9,h9,i9,m9,n9,s9,v9,t9,A9,D9,B9,fca,gca,dca,eca,bca,cca,$ba,aca,Zba,_ba,Xba,Yba,Vba,Wba,Tba,Uba,Rba,Sba,Nba,Oba,Cba,Dba,rba,sba,kba,lba,dba,eba,Yaa,Zaa,Raa,Saa,Kaa,Laa,Caa,Daa,vaa,waa,oaa,paa,haa,iaa,aaa,baa,caa,faa,daa,jaa,maa,kaa,qaa,taa,raa,xaa,Aaa,yaa,Faa,Iaa,Gaa,Maa,Paa,Naa,Taa,Waa,Uaa,_aa,bba,$aa,fba,iba,gba,mba,pba,nba,uba,xba,vba,Aba,Fba,Iba,Gba,Lba,Pba,Eda,Fda,zda,Ada,uda,vda,pda,qda,kda,lda,fda,gda,ada,bda,Xca,Yca,Sca,Tca,Nca,Oca,Ica,Jca,Dca,Eca,yca,zca,Aca,Bca,Fca,Gca,Kca,Lca,Pca,Qca,Uca,Vca,Zca,_ca,cda,dda,hda,ida,mda,nda,rda,sda,wda,xda,Bda,Cda,Gda,Hda,pea,qea,Cea,Dea,Qea,Rea,Vea,Wea,_ea,$ea,dfa,efa,ifa,jfa,sfa,tfa,yfa,zfa,Efa,Ffa,Kfa,Lfa,Qfa,Rfa,$fa,aga,fga,gga,lga,mga,rga,sga,xga,yga,Hga,Jga,Lga,Nga,Pga,Xga,Yga,$ga,aha,dha,eha,iha,jha,nha,oha,Hea,rha,Jha,Wha,hia,uia,Hia,Aja,yja,zja,wja,uja,vja,sja,qja,rja,oja,mja,nja,kja,ija,jja,gja,eja,fja,cja,aja,bja,_ia,Yia,Zia,Wia,Uia,Via,Sia,Qia,Ria,nka,lka,mka,jka,hka,ika,fka,dka,eka,bka,$ja,aka,Zja,Xja,Yja,Vja,Tja,Uja,Rja,Pja,Qja,Nja,Lja,Mja,Jja,Hja,Ija,Fja,Dja,Eja,rla,sla,mla,nla,hla,ila,cla,dla,Zka,_ka,Uka,Vka,Pka,Qka,Kka,Lka,Fka,Gka,Aka,Bka,Cka,Dka,Hka,Ika,Mka,Nka,Rka,Ska,Wka,Xka,$ka,ala,ela,fla,jla,kla,ola,pla,tla,ula,Qla,Rla,Ola,Tla,Mla,Vla,Yla,Zla,Jla,$la,Hla,bma,Sma,Tma,Zma,Qma,Rma,pna,qna,nna,ona,kna,lna,ina,jna,fna,gna,dna,ena,ana,bna,_ma,$ma,vna,Vna,Wna,$na,aoa,ioa,joa,voa,toa,yoa,zoa,Eoa,Foa,Woa,Xoa,fpa,gpa,vpa,wpa,Dpa,Hpa,Mpa,Npa,Opa,Ppa,Wpa,bqa,cqa,hqa,iqa,fqa,gqa,jqa,kqa,rqa,vqa,wqa,zqa,Aqa,xqa,yqa,Dqa,Eqa,Vqa,Wqa,ira,jra,Lra,Mra,fsa,esa,isa,osa,qsa,msa,nsa,Ksa,Qsa,Osa,Psa,gta,hta,Pta,Tta,Uta,lua,mua,xua,Hua,Iua,cva,dva,ava,bva,kya,mya,nya,oya,pya,qya,HXb,IXb,JXb,KXb,LXb,MXb,xXb,yXb,zXb,AXb,Oya,Pya,Sya,Tya,cAa,dAa,eAa,fAa,Uza,Wza,jAa,kAa,pAa,JKb,IAa,JAa,OAa,mBa,nBa,sBa,bCa,cCa,gCa,KBa,LBa,RBa,ADa,BDa,GDa,xCa,yCa,CCa,QIb,yDa,TIb,zDa,ICa,JCa,SCa,TCa,$Ca,eDa,fDa,jDa,WDa,rEa,sEa,xEa,WEa,XEa,aFa,IFa,JFa,OFa,BGa,CGa,HGa,fGa,gGa,lGa,lHa,mHa,rHa,xIa,yIa,DIa,JHa,KHa,PHa,dIa,eIa,jIa,mJa,nJa,sJa,cLa,dLa,iLa,NKa,OKa,TKa,wKa,xKa,CKa,JJa,KJa,PJa,zLa,ALa,ELa,y8a,z8a,C8a,g8a,h8a,k8a,S7a,T7a,W7a,D7a,E7a,b4a,o7a,p7a,s7a,a7a,b7a,a4a,J6a,K6a,N6a,u6a,v6a,y6a,g6a,h6a,c6a,u5a,v5a,y5a,b5a,c5a,f5a,L4a,M4a,P4a,v4a,w4a,z4a,f4a,g4a,j4a,s3a,t3a,w3a,d3a,e3a,h3a,Q2a,R2a,U2a,B2a,C2a,F2a,l2a,m2a,p2a,X1a,Y1a,$1a,F1a,G1a,J1a,m1a,n1a,q1a,Y0a,Z0a,a1a,K0a,L0a,xQa,s0a,t0a,w0a,e0a,f0a,yQa,O$a,P$a,S$a,u$a,v$a,y$a,e$a,f$a,i$a,R_a,S_a,V_a,B_a,C_a,F_a,j_a,k_a,n_a,SZa,TZa,WZa,CZa,DZa,GZa,kZa,lZa,oZa,XYa,YYa,$Ya,HYa,IYa,LYa,rYa,sYa,vYa,cYa,dYa,zQa,OXa,PXa,SXa,AXa,BXa,AQa,iXa,jXa,mXa,SWa,TWa,WWa,DWa,EWa,HWa,oWa,pWa,sWa,_Va,$Va,cWa,HVa,IVa,LVa,sVa,tVa,wVa,cVa,dVa,gVa,KUa,LUa,OUa,rUa,sUa,vUa,$Ta,aUa,dUa,LTa,MTa,PTa,sTa,tTa,wTa,$Sa,aTa,dTa,LSa,MSa,PSa,wSa,xSa,ASa,gSa,hSa,kSa,SRa,TRa,WRa,ARa,BRa,ERa,kRa,lRa,oRa,XQa,YQa,BQa,FQa,GQa,JQa,mOa,nOa,qOa,MNa,NNa,QNa,pNa,qNa,tNa,YMa,ZMa,aNa,GMa,HMa,KMa,mMa,nMa,qMa,VLa,WLa,ZLa,Pab,Qab,Rab,abb,ebb,fbb,gbb,mbb,nbb,obb,vbb,wbb,xbb,Gbb,Hbb,Ebb,Fbb,Wbb,Xbb,Zbb,_bb,ccb,dcb,acb,bcb,ncb,lcb,rcb,scb,vcb,wcb,tcb,ucb,Mcb,Ncb,Pcb,Qcb,bdb,cdb,ddb,mdb,ndb,pdb,qdb,wdb,Bdb,Cdb,Ddb,Ldb,Mdb,Ndb,Odb,$db,aeb,beb,ceb,seb,teb,ueb,veb,Eeb,Jeb,Keb,Reb,Seb,Zeb,_eb,bfb,efb,cfb,mfb,nfb,ofb,pfb,yfb,Cfb,Dfb,Ffb,Gfb,Qfb,Rfb,Sfb,Ufb,Tfb,$fb,agb,bgb,ugb,vgb,wgb,Ggb,Hgb,Pgb,Qgb,zhb,xhb,yhb,Fhb,Ghb,Hhb,Nhb,Ohb,Phb,Zhb,_hb,$hb,hib,fib,gib,qib,vib,tib,uib,Eib,Jib,Hib,Iib,Sib,Xib,Vib,Wib,ejb,jjb,hjb,ijb,sjb,xjb,vjb,wjb,Gjb,Ljb,Jjb,Kjb,Ujb,Zjb,Xjb,Yjb,gkb,kkb,lkb,mkb,nkb,xkb,Bkb,Ckb,Dkb,Lkb,Mkb,Qkb,Rkb,Skb,Ykb,Zkb,_kb,alb,$kb,plb,qlb,Tlb,Vlb,Wlb,lob,mob,rob,sob,xob,yob,Cob,Dob,epb,fpb,hpb,ipb,jpb,_qb,$qb,xsb,ysb,yOb,tsb,zub,Aub,Dub,DDb,EDb,HDb,_Cb,$Cb,cDb,ICb,JCb,MCb,qCb,rCb,uCb,YBb,ZBb,aCb,FBb,GBb,JBb,jBb,kBb,nBb,SAb,TAb,WAb,xAb,yAb,BAb,dAb,eAb,hAb,Lzb,Mzb,Pzb,szb,tzb,wzb,$yb,azb,dzb,Jyb,Kyb,Nyb,ryb,syb,vyb,$xb,ayb,dyb,Jxb,Kxb,Nxb,mxb,nxb,qxb,Pwb,Qwb,Twb,xwb,ywb,Bwb,awb,bwb,ewb,Jvb,Kvb,Nvb,mvb,nvb,qvb,Uub,Vub,Yub,xEb,yEb,YEb,ZEb,AKb,nFb,oFb,oQb,sFb,KFb,LFb,GIb,HIb,MIb,NIb,RIb,UIb,VIb,cJb,dJb,YKb,ZKb,uLb,HLb,XLb,hMb,tMb,FMb,RMb,bNb,nNb,ONb,PNb,jOb,kOb,tIb,vPb,Kpb,VPb,pQb,BWb,DWb,FWb,GWb,XWb,YWb,sXb,tXb,uXb,vXb,CXb,DXb,EXb,FXb,xYb,yYb,EYb,FYb,LYb,MYb,SYb,TYb,ZYb,_Yb,$Yb,eZb,fZb,kZb,lZb,e_b,f_b,F_b,G_b,W_b,X_b,i$b,j$b,V$b,W$b,H0b,I0b,N0b,O0b,T0b,U0b,d1b,e1b,o1b,p1b,z1b,A1b,K1b,L1b,T1b,U1b,a2b,b2b,g2b,h2b,m2b,n2b,r2b,s2b,dZb,H2b,w2b,W2b,X2b,g3b,h3b,j3b,k3b,w3b,x3b,D3b,E3b,K3b,L3b,Y3b,Z3b,_3b,H6b,I6b,J6b,K6b,U6b,d7b,e7b,j7b,k7b,l7b,m7b,o7b,q7b,t7b,Et,Ou,Su,Yu,av,ev,iv,mv,qv,uv,Fv,Jv,Pv,Vv,Zv,Nk,uj,Tr,hs,xs,Ns,dt,vt,Up,Vp,eA,spa,tpa,KA,RA,Xq,bB,dB,br,sB,uB,wB,FB,_H,lO,QT,dU,ST,fU,RT,eU,_U,dV,gV,vQ,IQ,kQ,uV,aZ,O2,opa,Vra,Bva,Zxa,_xa,Mxa,fya,Blb,Z5b,tza,vza,Mza,Oza,Qza,GAa,iBa,HBa,qDa,wDa,hEa,MEa,pFa,bGa,GHa,hJa,HJa,TLa,xPa,BPa,W5a,_5a,E9a,rab,Sob,Ipb,Tqb,Ktb,Qtb,Stb,Wtb,Ytb,cub,eub,gub,iub,Sub,Gvb,uwb,ixb,Gxb,bEb,BFb,FJb,EJb,xKb,yKb,HQb,OQb,VQb,aRb,hRb,oRb,vRb,yRb,sYb,EZb,GZb,z$b,B$b,D$b,v6b,l0b,n0b,p0b,O1b,PSb,_6b,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc,hgc];var ci=[igc,lx];var di=[jgc,SK,TK,_N,DO,LWb,MWb,zP,PWb,qT,CY,zpa,Spa,nqa,Gqa,Lqa,Nqa,Oqa,rsa,vsa,xsa,zsa,Bsa,Fsa,Usa,Ysa,mta,ota,Eta,Gta,Vza,$za,lAa,nAa,oAa,qAa,sAa,tAa,wAa,KKb,BAa,KAa,MAa,NAa,PAa,RAa,UAa,oBa,qBa,rBa,tBa,vBa,yBa,dCa,fCa,QBa,hCa,jCa,mCa,qCa,sCa,tCa,NBa,PBa,SBa,VBa,YBa,_Ba,$Ba,CDa,EDa,FDa,HDa,JDa,MDa,zCa,ACa,BCa,FCa,GCa,SIb,QCa,RCa,YCa,ZCa,cDa,dDa,gDa,hDa,iDa,mDa,nDa,XDa,YDa,tEa,vEa,wEa,yEa,AEa,DEa,YEa,_Ea,$Ea,bFa,dFa,gFa,KFa,MFa,NFa,PFa,RFa,UFa,DGa,FGa,GGa,IGa,zGa,MGa,hGa,jGa,kGa,mGa,oGa,rGa,nHa,pHa,qHa,sHa,uHa,xHa,zIa,BIa,CIa,EIa,GIa,JIa,LHa,NHa,OHa,QHa,SHa,VHa,fIa,hIa,iIa,kIa,mIa,pIa,oJa,qJa,rJa,tJa,vJa,yJa,eLa,gLa,hLa,jLa,qKa,mLa,PKa,RKa,SKa,UKa,rKa,XKa,yKa,AKa,BKa,DKa,EKa,HKa,LJa,NJa,OJa,QJa,SJa,VJa,BLa,DLa,FLa,HLa,KLa,A8a,D8a,gOa,G8a,i8a,l8a,n8a,q8a,U7a,X7a,Y7a,$7a,F7a,H7a,I7a,L7a,q7a,t7a,U3a,w7a,c7a,e7a,T3a,h7a,L6a,O6a,Q6a,T6a,w6a,z6a,INa,C6a,i6a,k6a,$5a,n6a,w5a,z5a,B5a,E5a,d5a,g5a,i5a,l5a,N4a,Q4a,S4a,V4a,x4a,A4a,SPa,D4a,h4a,k4a,V3a,n4a,u3a,x3a,z3a,C3a,f3a,i3a,QPa,l3a,S2a,V2a,RPa,Y2a,D2a,G2a,EPa,J2a,n2a,q2a,r2a,u2a,Z1a,a2a,b2a,e2a,H1a,K1a,M1a,P1a,o1a,r1a,t1a,w1a,_0a,b1a,c1a,f1a,M0a,O0a,FPa,R0a,u0a,x0a,z0a,C0a,g0a,i0a,GPa,l0a,Q$a,T$a,V$a,Y$a,w$a,z$a,B$a,E$a,g$a,j$a,k$a,n$a,T_a,W_a,HPa,Z_a,D_a,G_a,H_a,K_a,l_a,o_a,q_a,t_a,UZa,XZa,ZZa,a_a,EZa,HZa,IZa,LZa,mZa,pZa,rZa,uZa,ZYa,aZa,IPa,dZa,JYa,MYa,NYa,QYa,tYa,wYa,xYa,AYa,eYa,gYa,JPa,jYa,QXa,TXa,UXa,XXa,CXa,EXa,KPa,HXa,kXa,nXa,pXa,sXa,UWa,XWa,ZWa,aXa,FWa,IWa,LPa,LWa,qWa,tWa,MPa,wWa,aWa,dWa,eWa,hWa,JVa,MVa,OVa,RVa,uVa,xVa,NPa,AVa,eVa,hVa,iVa,lVa,MUa,PUa,RUa,UUa,tUa,wUa,yUa,BUa,bUa,eUa,gUa,jUa,NTa,QTa,RTa,UTa,uTa,xTa,zTa,CTa,bTa,eTa,gTa,jTa,NSa,QSa,RSa,USa,ySa,BSa,OPa,ESa,iSa,lSa,mSa,pSa,URa,XRa,YRa,$Ra,CRa,FRa,HRa,KRa,mRa,pRa,qRa,tRa,ZQa,$Qa,PPa,cRa,HQa,KQa,MQa,PQa,oOa,rOa,tOa,wOa,ONa,RNa,TNa,WNa,rNa,uNa,wNa,zNa,_Ma,bNa,dNa,gNa,IMa,LMa,NMa,QMa,oMa,rMa,tMa,wMa,XLa,_La,aMa,dMa,Jlb,Ulb,qob,vob,wob,Bob,Hob,gpb,Bub,Eub,Gub,Jub,FDb,IDb,KDb,NDb,aDb,dDb,fDb,iDb,KCb,NCb,PCb,SCb,sCb,vCb,xCb,ACb,_Bb,bCb,dCb,gCb,HBb,KBb,MBb,PBb,lBb,oBb,qBb,tBb,UAb,XAb,ZAb,aBb,zAb,CAb,EAb,HAb,fAb,iAb,kAb,nAb,Nzb,Qzb,Szb,Vzb,uzb,xzb,zzb,Czb,bzb,ezb,gzb,jzb,Lyb,Oyb,Qyb,Tyb,tyb,wyb,yyb,Byb,byb,eyb,gyb,jyb,Lxb,Oxb,Qxb,Txb,oxb,rxb,txb,wxb,Rwb,Uwb,Wwb,Zwb,zwb,Cwb,Ewb,Hwb,cwb,fwb,hwb,kwb,Lvb,Ovb,Qvb,Tvb,ovb,rvb,tvb,wvb,Wub,Zub,$ub,cvb,_Eb,aFb,BKb,FKb,bFb,hHb,iHb,LIb,aJb,bJb,iJb,jJb,VSb,OWb,bXb,cXb,eXb,fXb,AYb,HYb,OYb,PYb,VYb,WYb,k$b,r$b,s$b,t$b,u$b,v$b,w$b,x$b,X$b,c0b,d0b,e0b,f0b,g0b,h0b,i0b,V0b,W0b,$0b,f1b,g1b,l1b,q1b,r1b,w1b,B1b,C1b,H1b,A2b,B2b,D2b,S2b,T2b,V2b,y3b,z3b,F3b,G3b,L2b,M2b,O2b,$2b,a3b,c3b,f7b,n7b,Dt,Gt,Ht,Nj,Oj,Pj,Qj,Wj,Xj,ak,dk,gw,lj,jw,Sr,Vr,Nr,gs,js,bs,ws,zs,rs,Ms,Ps,Hs,ct,gt,Xs,ut,xt,pt,Km,Un,uo,dA,iA,lA,oA,JA,LA,MA,QA,SA,TA,XA,_A,aB,cB,eB,fB,jB,pB,rB,tB,vB,EB,OB,PB,Ora,ZU,$U,fV,hV,kV,wQ,nV,MQ,qV,lQ,tV,pQ,N2,R2,npa,rpa,Ura,Yra,vQa,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc,jgc];var ei=[kgc,Nw,AX,xX,yX,zX,kgc,kgc];var fi=[lgc,Bl];var gi=[mgc,Kw,rl,mgc];var hi=[ngc,lR,TR,bS,Xx,ngc,ngc,ngc];var ii=[ogc,Toa,Fm,Ux,sp,Oq,qr,aC];var ji=[pgc,_n,fo,qz];var ki=[qgc,RB];var li=[rgc,IWb,NWb,RWb,Joa,xpa,Apa,Bpa,Qpa,Tpa,lqa,oqa,zua,Yza,xAa,VAa,zBa,nCa,ZBa,NDa,NCa,LCa,EEa,hFa,VFa,NGa,sGa,yHa,KIa,WHa,qIa,zJa,nLa,YKa,IKa,WJa,LLa,H8a,r8a,a8a,M7a,x7a,i7a,U6a,D6a,o6a,F5a,m5a,W4a,E4a,o4a,D3a,m3a,Z2a,K2a,v2a,f2a,Q1a,x1a,g1a,S0a,D0a,m0a,Z$a,F$a,o$a,__a,L_a,u_a,b_a,MZa,vZa,eZa,RYa,BYa,kYa,YXa,IXa,tXa,bXa,MWa,xWa,iWa,SVa,BVa,mVa,VUa,CUa,kUa,VTa,DTa,kTa,VSa,FSa,qSa,aSa,LRa,uRa,dRa,QQa,xOa,XNa,ANa,hNa,RMa,xMa,eMa,Xab,Bbb,Sbb,icb,idb,Vdb,Ceb,Web,wfb,ggb,Cgb,Khb,Whb,oib,Cib,Qib,cjb,qjb,Ejb,Sjb,ekb,ukb,ilb,Klb,Llb,Mlb,Nlb,Olb,Plb,Qlb,Rlb,nob,tob,eSb,zob,Eob,usb,Kub,ODb,jDb,TCb,BCb,hCb,QBb,uBb,bBb,IAb,oAb,Wzb,Dzb,kzb,Uyb,Cyb,kyb,Uxb,xxb,_wb,Iwb,lwb,Uvb,xvb,dvb,zEb,AEb,CEb,Qob,tFb,PFb,QFb,SFb,UFb,WFb,$Fb,aGb,bGb,cGb,fGb,hGb,iGb,rHb,sHb,IIb,OIb,XIb,ZIb,jLb,kLb,qLb,GLb,TLb,gMb,sMb,EMb,QMb,aNb,mNb,yNb,WPb,qQb,WSb,XSb,bTb,cTb,nUb,_Wb,dXb,hXb,BYb,IYb,cZb,iZb,o2b,t2b,m3b,o3b,r3b,M3b,R3b,T3b,W3b,L6b,p7b,r7b,Kt,Lt,Qt,_t,cu,gu,ku,mu,qu,su,tk,vu,wk,yu,zk,Bu,Ck,Eu,Fk,Ik,Mk,ew,Zr,Pr,ns,ds,Ds,ts,Ts,Js,kt,Zs,Bt,rt,pm,Cx,mn,dy,Ay,Dy,dz,hz,Xp,aA,cA,Hq,gA,zB,GB,SV,Zmb,PUb,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc,rgc];var mi=[sgc,Rn];var ni=[tgc,Gy];var oi=[ugc,_z,VA,ugc];var pi=[vgc,tha,uha,vha,wha,xha,vgc,vgc];var qi=[wgc,rp,Nq,pr,$B,wgc,wgc,wgc];var ri=[xgc,Ju,Ku,Ln,vy,oz,xgc,xgc];var si=[ygc,bz];var ti=[zgc,jA];var ui=[Agc];var vi=[Bgc,Jw,ql,Bgc];var wi=[Cgc,Xz];var xi=[Dgc,Ft,Nu,Ru,Xu,$u,dv,hv,lv,pv,tv,Ev,Iv,Ov,Uv,Yv,Ur,is,ys,Os,ft,wt,hA,$A,qB,NB,Dgc,Dgc,Dgc,Dgc,Dgc,Dgc];var yi=[Egc,Yz];var zi=[Fgc,Kn,uy,wo];var Ai=[Ggc,Al];var Bi=[Hgc,vz,IB,vr];var Ci=[Igc,Sn];var Di=[Jgc,cL,q$b,b0b,x2b,y2b,P2b,Q2b,I2b,J2b,Y2b,Z2b,Jgc,Jgc,Jgc,Jgc];var Ei=[Kgc,Vw];var Fi=[Lgc,sA];var Gi=[Mgc,Xt,rw,tw,zw,il,Mgc,Mgc];var Hi=[Ngc,Wx];return{dynCall_vididdi:tdc,dynCall_iiidii:Mdc,dynCall_viiiidiidd:Pbc,dynCall_viiiddiiid:Obc,dynCall_viiiiidi:wbc,dynCall_viiidiiiidi:ycc,_bitshift64Lshr:Sac,__GLOBAL__sub_I_opencv_caffe_pb_cc:P8a,dynCall_viiiiidd:Ebc,dynCall_viiididi:idc,__GLOBAL__sub_I_versions_pb_cc:SEa,dynCall_viiidddii:Ucc,dynCall_viiiiiiiiiid:pbc,dynCall_diii:tcc,dynCall_viiiiiiiiiii:obc,_bitshift64Ashr:Rac,dynCall_viiiiidiiddi:Zcc,_sbrk:Wac,__GLOBAL__sub_I_imgwarp_cpp:sna,_memcpy:Vac,dynCall_viiiiddii:Bdc,dynCall_vi:pdc,dynCall_iiid:Cdc,__GLOBAL__sub_I_bind_cpp:LSb,dynCall_viiiiddiiid:Abc,dynCall_viiidiiii:jcc,dynCall_viiiiiidd:udc,dynCall_viiiiddiiii:ybc,dynCall_vidiii:Vdc,dynCall_viiidiiid:ecc,dynCall_iiii:zdc,dynCall_iiidd:Mcc,__GLOBAL__I_000101:oYb,dynCall_viidiiid:_bc,_emscripten_get_global_libc:dTb,dynCall_viiiiiiddi:Jdc,dynCall_iiiiiiii:Wbc,dynCall_viidiiii:acc,dynCall_viiddidd:sbc,stackSave:Ji,dynCall_viiiii:Icc,___cxa_can_catch:Gac,_free:PSb,runPostSets:Iac,dynCall_viiiiii:icc,dynCall_viiiid:Occ,dynCall_viiiiid:gcc,dynCall_diiiddi:bcc,dynCall_iiiiii:Bcc,dynCall_viiiiddd:ebc,dynCall_diiiiiiii:dcc,dynCall_viiiidiiddi:Hbc,dynCall_viiiiddi:lbc,__GLOBAL__sub_I_system_cpp:iO,dynCall_viiidddd:qbc,dynCall_viiiddddi:mbc,dynCall_viiidddi:Tbc,dynCall_vidii:vdc,dynCall_viiiddiii:xdc,setThrew:Mi,dynCall_viiiiiiiddi:sdc,dynCall_viiiiiddi:gbc,dynCall_viid:odc,__GLOBAL__sub_I_persistence_cpp:YU,dynCall_viiiiidiiiii:Sbc,dynCall_viiddi:Cbc,dynCall_iiiii:Rbc,dynCall_viiiddidddd:vcc,___cxa_is_pointer_type:Hac,_llvm_ctlz_i64:_ac,dynCall_iiiid:Vbc,dynCall_viididdi:ddc,dynCall_viiiiidiid:Tdc,__GLOBAL__sub_I_status_cc:Hpb,dynCall_iiidiii:Kdc,dynCall_viiiiidiidd:Ubc,dynCall_viiiiddddii:hcc,dynCall_viiiiiiidd:zbc,dynCall_viiiddd:ucc,stackAlloc:Ii,dynCall_viiiddi:Acc,dynCall_viiiiidiii:Pdc,dynCall_viiiiiiidi:Bbc,___divdi3:abc,getTempRet0:Oi,dynCall_viiiidddd:Dcc,dynCall_viiiidddi:Gcc,dynCall_viididii:Adc,dynCall_diiii:Ycc,dynCall_viiiidi:wdc,dynCall_viiid:Ccc,dynCall_viiiiddddi:Pcc,dynCall_vdii:Kbc,dynCall_viiiddiiiid:zcc,dynCall_viiii:Hcc,_llvm_bswap_i32:Zac,dynCall_iid:adc,__GLOBAL__sub_I_message_cc:ANb,dynCall_diiiiiii:Lbc,dynCall_vididdii:Odc,establishStackSpace:Li,dynCall_viiiidddiii:ldc,dynCall_viiidddiiii:Wcc,dynCall_viiiidii:Edc,__GLOBAL__sub_I_haar_cpp:Tra,___getTypeName:NSb,dynCall_viiiiiiiiidd:Ddc,dynCall_diiiid:Gdc,__GLOBAL__sub_I_umatrix_cpp:ZH,dynCall_viiidiiddi:Scc,dynCall_viiiiiidiiiii:ydc,dynCall_viiiiiiiiii:rcc,dynCall_iiiiiii:jbc,__GLOBAL__sub_I_graph_pb_cc:oEa,dynCall_diiiiii:Ndc,dynCall_vdiii:jdc,dynCall_iiiiiid:dbc,dynCall_viiididii:ccc,dynCall_viiddii:ubc,dynCall_diiiii:Fdc,dynCall_iiiiiiiii:Rdc,dynCall_viiiiiiiiiiid:wcc,dynCall_iii:gdc,dynCall_viiiidddii:mcc,dynCall_viiddid:vbc,_memset:Nac,dynCall_diiddi:scc,dynCall_viididi:Qdc,dynCall_viiidi:occ,__GLOBAL__sub_I_prior_box_layer_cpp:Geb,dynCall_viiidd:ncc,dynCall_viiiiiii:cdc,__GLOBAL__sub_I_color_cpp:QZ,dynCall_viiiiddiii:Jbc,__GLOBAL__sub_I_init_cpp:B9a,setTempRet0:Ni,dynCall_viiiddiddd:$cc,dynCall_i:Ldc,dynCall_viiiiiid:edc,__GLOBAL__sub_I_op_def_pb_cc:uLa,dynCall_iiiiiiiiiiiiiii:Idc,___remdi3:Qac,__GLOBAL__sub_I_iostream_cpp:pYb,dynCall_viiiddddii:fcc,dynCall_viiidddiii:Zbc,_pthread_cond_broadcast:Tac,__GLOBAL__sub_I_descriptor_pb_cc:eEb,dynCall_viiiiiidiii:lcc,__GLOBAL__sub_I_tensor_shape_pb_cc:eBa,dynCall_iiidi:Lcc,dynCall_viiiiiidiiii:Gbc,__GLOBAL__sub_I_hog_cpp:mpa,dynCall_viiiiiidi:kcc,dynCall_vidi:tbc,dynCall_iidi:rbc,_malloc:OSb,__GLOBAL__sub_I_histogram_cpp:M2,dynCall_viiddiii:Xbc,_emscripten_replace_memory:Qf,dynCall_viidiii:nbc,dynCall_dii:Mbc,dynCall_v:ndc,__GLOBAL__sub_I_attr_value_pb_cc:cHa,dynCall_viidii:Ecc,dynCall_viiiiidiiii:$bc,dynCall_iiiiiiiididiii:Ybc,dynCall_viidi:Rcc,_i64Subtract:Jac,___udivdi3:Uac,dynCall_vid:Kcc,dynCall_di:Fbc,dynCall_diiid:Tcc,__GLOBAL__sub_I_tensor_pb_cc:CFa,dynCall_iiidiiii:pcc,_bitshift64Shl:$ac,dynCall_viiiiiiiiiiddi:Qbc,_fflush:AUb,dynCall_viiiiiiid:Xcc,__GLOBAL__sub_I_types_pb_cc:eJa,_pthread_mutex_lock:Mac,___cxa_demangle:B7b,__GLOBAL__sub_I_detection_output_layer_cpp:Dgb,___muldi3:cbc,dynCall_viiiidd:Udc,dynCall_vii:Ncc,___uremdi3:Yac,dynCall_viiiiiiiii:fdc,dynCall_viiiiiiii:Vcc,_i64Add:Kac,dynCall_viiiiiidii:kdc,_pthread_mutex_unlock:Lac,dynCall_viiidii:Dbc,dynCall_viiiidiii:fbc,stackRestore:Ki,dynCall_viiiddiiii:Nbc,__GLOBAL__sub_I_function_pb_cc:$Ia,dynCall_viiiddid:bdc,dynCall_viii:mdc,dynCall_iiiiiiiiiiiii:Hdc,dynCall_viiiddii:hdc,dynCall_viiiidiid:ibc,___errno_location:ZSb,dynCall_viididdii:Sdc,dynCall_viidd:Qcc,dynCall_ii:rdc,dynCall_iiiiid:Fcc,_memmove:Xac,dynCall_viiiiidii:_cc,dynCall_viiiddidd:xcc,__GLOBAL__sub_I_bindings_cpp:dC,dynCall_viiddiddd:qcc,dynCall_viiiidiiiidi:qdc,dynCall_viiiiddiiiid:Ibc,dynCall_viiiidiiii:Jcc,dynCall_viiidiii:hbc,dynCall_viiiidddiiii:kbc,dynCall_viiddidddd:xbc}})


// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg,Module.asmLibraryArg,buffer);var __GLOBAL__sub_I_attr_value_pb_cc=Module["__GLOBAL__sub_I_attr_value_pb_cc"]=asm["__GLOBAL__sub_I_attr_value_pb_cc"];var __GLOBAL__sub_I_op_def_pb_cc=Module["__GLOBAL__sub_I_op_def_pb_cc"]=asm["__GLOBAL__sub_I_op_def_pb_cc"];var __GLOBAL__sub_I_system_cpp=Module["__GLOBAL__sub_I_system_cpp"]=asm["__GLOBAL__sub_I_system_cpp"];var __GLOBAL__sub_I_umatrix_cpp=Module["__GLOBAL__sub_I_umatrix_cpp"]=asm["__GLOBAL__sub_I_umatrix_cpp"];var stackSave=Module["stackSave"]=asm["stackSave"];var __GLOBAL__sub_I_color_cpp=Module["__GLOBAL__sub_I_color_cpp"]=asm["__GLOBAL__sub_I_color_cpp"];var ___udivdi3=Module["___udivdi3"]=asm["___udivdi3"];var getTempRet0=Module["getTempRet0"]=asm["getTempRet0"];var __GLOBAL__sub_I_graph_pb_cc=Module["__GLOBAL__sub_I_graph_pb_cc"]=asm["__GLOBAL__sub_I_graph_pb_cc"];var _bitshift64Lshr=Module["_bitshift64Lshr"]=asm["_bitshift64Lshr"];var __GLOBAL__sub_I_tensor_pb_cc=Module["__GLOBAL__sub_I_tensor_pb_cc"]=asm["__GLOBAL__sub_I_tensor_pb_cc"];var __GLOBAL__sub_I_persistence_cpp=Module["__GLOBAL__sub_I_persistence_cpp"]=asm["__GLOBAL__sub_I_persistence_cpp"];var _bitshift64Shl=Module["_bitshift64Shl"]=asm["_bitshift64Shl"];var _sbrk=Module["_sbrk"]=asm["_sbrk"];var _fflush=Module["_fflush"]=asm["_fflush"];var __GLOBAL__sub_I_types_pb_cc=Module["__GLOBAL__sub_I_types_pb_cc"]=asm["__GLOBAL__sub_I_types_pb_cc"];var ___cxa_is_pointer_type=Module["___cxa_is_pointer_type"]=asm["___cxa_is_pointer_type"];var _llvm_ctlz_i64=Module["_llvm_ctlz_i64"]=asm["_llvm_ctlz_i64"];var __GLOBAL__sub_I_haar_cpp=Module["__GLOBAL__sub_I_haar_cpp"]=asm["__GLOBAL__sub_I_haar_cpp"];var _bitshift64Ashr=Module["_bitshift64Ashr"]=asm["_bitshift64Ashr"];var _memset=Module["_memset"]=asm["_memset"];var __GLOBAL__sub_I_status_cc=Module["__GLOBAL__sub_I_status_cc"]=asm["__GLOBAL__sub_I_status_cc"];var ___cxa_demangle=Module["___cxa_demangle"]=asm["___cxa_demangle"];var __GLOBAL__sub_I_detection_output_layer_cpp=Module["__GLOBAL__sub_I_detection_output_layer_cpp"]=asm["__GLOBAL__sub_I_detection_output_layer_cpp"];var __GLOBAL__sub_I_imgwarp_cpp=Module["__GLOBAL__sub_I_imgwarp_cpp"]=asm["__GLOBAL__sub_I_imgwarp_cpp"];var _memcpy=Module["_memcpy"]=asm["_memcpy"];var _llvm_bswap_i32=Module["_llvm_bswap_i32"]=asm["_llvm_bswap_i32"];var ___muldi3=Module["___muldi3"]=asm["___muldi3"];var __GLOBAL__sub_I_prior_box_layer_cpp=Module["__GLOBAL__sub_I_prior_box_layer_cpp"]=asm["__GLOBAL__sub_I_prior_box_layer_cpp"];var __GLOBAL__sub_I_versions_pb_cc=Module["__GLOBAL__sub_I_versions_pb_cc"]=asm["__GLOBAL__sub_I_versions_pb_cc"];var ___uremdi3=Module["___uremdi3"]=asm["___uremdi3"];var ___divdi3=Module["___divdi3"]=asm["___divdi3"];var stackAlloc=Module["stackAlloc"]=asm["stackAlloc"];var _i64Subtract=Module["_i64Subtract"]=asm["_i64Subtract"];var __GLOBAL__sub_I_bind_cpp=Module["__GLOBAL__sub_I_bind_cpp"]=asm["__GLOBAL__sub_I_bind_cpp"];var __GLOBAL__sub_I_init_cpp=Module["__GLOBAL__sub_I_init_cpp"]=asm["__GLOBAL__sub_I_init_cpp"];var setTempRet0=Module["setTempRet0"]=asm["setTempRet0"];var _i64Add=Module["_i64Add"]=asm["_i64Add"];var __GLOBAL__sub_I_function_pb_cc=Module["__GLOBAL__sub_I_function_pb_cc"]=asm["__GLOBAL__sub_I_function_pb_cc"];var _pthread_mutex_unlock=Module["_pthread_mutex_unlock"]=asm["_pthread_mutex_unlock"];var __GLOBAL__I_000101=Module["__GLOBAL__I_000101"]=asm["__GLOBAL__I_000101"];var _emscripten_get_global_libc=Module["_emscripten_get_global_libc"]=asm["_emscripten_get_global_libc"];var ___getTypeName=Module["___getTypeName"]=asm["___getTypeName"];var __GLOBAL__sub_I_iostream_cpp=Module["__GLOBAL__sub_I_iostream_cpp"]=asm["__GLOBAL__sub_I_iostream_cpp"];var _pthread_cond_broadcast=Module["_pthread_cond_broadcast"]=asm["_pthread_cond_broadcast"];var __GLOBAL__sub_I_descriptor_pb_cc=Module["__GLOBAL__sub_I_descriptor_pb_cc"]=asm["__GLOBAL__sub_I_descriptor_pb_cc"];var ___errno_location=Module["___errno_location"]=asm["___errno_location"];var __GLOBAL__sub_I_message_cc=Module["__GLOBAL__sub_I_message_cc"]=asm["__GLOBAL__sub_I_message_cc"];var __GLOBAL__sub_I_tensor_shape_pb_cc=Module["__GLOBAL__sub_I_tensor_shape_pb_cc"]=asm["__GLOBAL__sub_I_tensor_shape_pb_cc"];var ___cxa_can_catch=Module["___cxa_can_catch"]=asm["___cxa_can_catch"];var _free=Module["_free"]=asm["_free"];var runPostSets=Module["runPostSets"]=asm["runPostSets"];var setThrew=Module["setThrew"]=asm["setThrew"];var __GLOBAL__sub_I_hog_cpp=Module["__GLOBAL__sub_I_hog_cpp"]=asm["__GLOBAL__sub_I_hog_cpp"];var establishStackSpace=Module["establishStackSpace"]=asm["establishStackSpace"];var _memmove=Module["_memmove"]=asm["_memmove"];var __GLOBAL__sub_I_bindings_cpp=Module["__GLOBAL__sub_I_bindings_cpp"]=asm["__GLOBAL__sub_I_bindings_cpp"];var stackRestore=Module["stackRestore"]=asm["stackRestore"];var _malloc=Module["_malloc"]=asm["_malloc"];var __GLOBAL__sub_I_histogram_cpp=Module["__GLOBAL__sub_I_histogram_cpp"]=asm["__GLOBAL__sub_I_histogram_cpp"];var _pthread_mutex_lock=Module["_pthread_mutex_lock"]=asm["_pthread_mutex_lock"];var _emscripten_replace_memory=Module["_emscripten_replace_memory"]=asm["_emscripten_replace_memory"];var ___remdi3=Module["___remdi3"]=asm["___remdi3"];var __GLOBAL__sub_I_opencv_caffe_pb_cc=Module["__GLOBAL__sub_I_opencv_caffe_pb_cc"]=asm["__GLOBAL__sub_I_opencv_caffe_pb_cc"];var dynCall_iiiiiid=Module["dynCall_iiiiiid"]=asm["dynCall_iiiiiid"];var dynCall_viiiiddd=Module["dynCall_viiiiddd"]=asm["dynCall_viiiiddd"];var dynCall_viiiidiii=Module["dynCall_viiiidiii"]=asm["dynCall_viiiidiii"];var dynCall_viiiiiddi=Module["dynCall_viiiiiddi"]=asm["dynCall_viiiiiddi"];var dynCall_viiidiii=Module["dynCall_viiidiii"]=asm["dynCall_viiidiii"];var dynCall_viiiidiid=Module["dynCall_viiiidiid"]=asm["dynCall_viiiidiid"];var dynCall_iiiiiii=Module["dynCall_iiiiiii"]=asm["dynCall_iiiiiii"];var dynCall_viiiidddiiii=Module["dynCall_viiiidddiiii"]=asm["dynCall_viiiidddiiii"];var dynCall_viiiiddi=Module["dynCall_viiiiddi"]=asm["dynCall_viiiiddi"];var dynCall_viiiddddi=Module["dynCall_viiiddddi"]=asm["dynCall_viiiddddi"];var dynCall_viidiii=Module["dynCall_viidiii"]=asm["dynCall_viidiii"];var dynCall_viiiiiiiiiii=Module["dynCall_viiiiiiiiiii"]=asm["dynCall_viiiiiiiiiii"];var dynCall_viiiiiiiiiid=Module["dynCall_viiiiiiiiiid"]=asm["dynCall_viiiiiiiiiid"];var dynCall_viiidddd=Module["dynCall_viiidddd"]=asm["dynCall_viiidddd"];var dynCall_iidi=Module["dynCall_iidi"]=asm["dynCall_iidi"];var dynCall_viiddidd=Module["dynCall_viiddidd"]=asm["dynCall_viiddidd"];var dynCall_vidi=Module["dynCall_vidi"]=asm["dynCall_vidi"];var dynCall_viiddii=Module["dynCall_viiddii"]=asm["dynCall_viiddii"];var dynCall_viiddid=Module["dynCall_viiddid"]=asm["dynCall_viiddid"];var dynCall_viiiiidi=Module["dynCall_viiiiidi"]=asm["dynCall_viiiiidi"];var dynCall_viiddidddd=Module["dynCall_viiddidddd"]=asm["dynCall_viiddidddd"];var dynCall_viiiiddiiii=Module["dynCall_viiiiddiiii"]=asm["dynCall_viiiiddiiii"];var dynCall_viiiiiiidd=Module["dynCall_viiiiiiidd"]=asm["dynCall_viiiiiiidd"];var dynCall_viiiiddiiid=Module["dynCall_viiiiddiiid"]=asm["dynCall_viiiiddiiid"];var dynCall_viiiiiiidi=Module["dynCall_viiiiiiidi"]=asm["dynCall_viiiiiiidi"];var dynCall_viiddi=Module["dynCall_viiddi"]=asm["dynCall_viiddi"];var dynCall_viiidii=Module["dynCall_viiidii"]=asm["dynCall_viiidii"];var dynCall_viiiiidd=Module["dynCall_viiiiidd"]=asm["dynCall_viiiiidd"];var dynCall_di=Module["dynCall_di"]=asm["dynCall_di"];var dynCall_viiiiiidiiii=Module["dynCall_viiiiiidiiii"]=asm["dynCall_viiiiiidiiii"];var dynCall_viiiidiiddi=Module["dynCall_viiiidiiddi"]=asm["dynCall_viiiidiiddi"];var dynCall_viiiiddiiiid=Module["dynCall_viiiiddiiiid"]=asm["dynCall_viiiiddiiiid"];var dynCall_viiiiddiii=Module["dynCall_viiiiddiii"]=asm["dynCall_viiiiddiii"];var dynCall_vdii=Module["dynCall_vdii"]=asm["dynCall_vdii"];var dynCall_diiiiiii=Module["dynCall_diiiiiii"]=asm["dynCall_diiiiiii"];var dynCall_dii=Module["dynCall_dii"]=asm["dynCall_dii"];var dynCall_viiiddiiii=Module["dynCall_viiiddiiii"]=asm["dynCall_viiiddiiii"];var dynCall_viiiddiiid=Module["dynCall_viiiddiiid"]=asm["dynCall_viiiddiiid"];var dynCall_viiiidiidd=Module["dynCall_viiiidiidd"]=asm["dynCall_viiiidiidd"];var dynCall_viiiiiiiiiiddi=Module["dynCall_viiiiiiiiiiddi"]=asm["dynCall_viiiiiiiiiiddi"];var dynCall_iiiii=Module["dynCall_iiiii"]=asm["dynCall_iiiii"];var dynCall_viiiiidiiiii=Module["dynCall_viiiiidiiiii"]=asm["dynCall_viiiiidiiiii"];var dynCall_viiidddi=Module["dynCall_viiidddi"]=asm["dynCall_viiidddi"];var dynCall_viiiiidiidd=Module["dynCall_viiiiidiidd"]=asm["dynCall_viiiiidiidd"];var dynCall_iiiid=Module["dynCall_iiiid"]=asm["dynCall_iiiid"];var dynCall_iiiiiiii=Module["dynCall_iiiiiiii"]=asm["dynCall_iiiiiiii"];var dynCall_viiddiii=Module["dynCall_viiddiii"]=asm["dynCall_viiddiii"];var dynCall_iiiiiiiididiii=Module["dynCall_iiiiiiiididiii"]=asm["dynCall_iiiiiiiididiii"];var dynCall_viiidddiii=Module["dynCall_viiidddiii"]=asm["dynCall_viiidddiii"];var dynCall_viidiiid=Module["dynCall_viidiiid"]=asm["dynCall_viidiiid"];var dynCall_viiiiidiiii=Module["dynCall_viiiiidiiii"]=asm["dynCall_viiiiidiiii"];var dynCall_viidiiii=Module["dynCall_viidiiii"]=asm["dynCall_viidiiii"];var dynCall_diiiddi=Module["dynCall_diiiddi"]=asm["dynCall_diiiddi"];var dynCall_viiididii=Module["dynCall_viiididii"]=asm["dynCall_viiididii"];var dynCall_diiiiiiii=Module["dynCall_diiiiiiii"]=asm["dynCall_diiiiiiii"];var dynCall_viiidiiid=Module["dynCall_viiidiiid"]=asm["dynCall_viiidiiid"];var dynCall_viiiddddii=Module["dynCall_viiiddddii"]=asm["dynCall_viiiddddii"];var dynCall_viiiiid=Module["dynCall_viiiiid"]=asm["dynCall_viiiiid"];var dynCall_viiiiddddii=Module["dynCall_viiiiddddii"]=asm["dynCall_viiiiddddii"];var dynCall_viiiiii=Module["dynCall_viiiiii"]=asm["dynCall_viiiiii"];var dynCall_viiidiiii=Module["dynCall_viiidiiii"]=asm["dynCall_viiidiiii"];var dynCall_viiiiiidi=Module["dynCall_viiiiiidi"]=asm["dynCall_viiiiiidi"];var dynCall_viiiiiidiii=Module["dynCall_viiiiiidiii"]=asm["dynCall_viiiiiidiii"];var dynCall_viiiidddii=Module["dynCall_viiiidddii"]=asm["dynCall_viiiidddii"];var dynCall_viiidd=Module["dynCall_viiidd"]=asm["dynCall_viiidd"];var dynCall_viiidi=Module["dynCall_viiidi"]=asm["dynCall_viiidi"];var dynCall_iiidiiii=Module["dynCall_iiidiiii"]=asm["dynCall_iiidiiii"];var dynCall_viiddiddd=Module["dynCall_viiddiddd"]=asm["dynCall_viiddiddd"];var dynCall_viiiiiiiiii=Module["dynCall_viiiiiiiiii"]=asm["dynCall_viiiiiiiiii"];var dynCall_diiddi=Module["dynCall_diiddi"]=asm["dynCall_diiddi"];var dynCall_diii=Module["dynCall_diii"]=asm["dynCall_diii"];var dynCall_viiiddd=Module["dynCall_viiiddd"]=asm["dynCall_viiiddd"];var dynCall_viiiddidddd=Module["dynCall_viiiddidddd"]=asm["dynCall_viiiddidddd"];var dynCall_viiiiiiiiiiid=Module["dynCall_viiiiiiiiiiid"]=asm["dynCall_viiiiiiiiiiid"];var dynCall_viiiddidd=Module["dynCall_viiiddidd"]=asm["dynCall_viiiddidd"];var dynCall_viiidiiiidi=Module["dynCall_viiidiiiidi"]=asm["dynCall_viiidiiiidi"];var dynCall_viiiddiiiid=Module["dynCall_viiiddiiiid"]=asm["dynCall_viiiddiiiid"];var dynCall_viiiddi=Module["dynCall_viiiddi"]=asm["dynCall_viiiddi"];var dynCall_iiiiii=Module["dynCall_iiiiii"]=asm["dynCall_iiiiii"];var dynCall_viiid=Module["dynCall_viiid"]=asm["dynCall_viiid"];var dynCall_viiiidddd=Module["dynCall_viiiidddd"]=asm["dynCall_viiiidddd"];var dynCall_viidii=Module["dynCall_viidii"]=asm["dynCall_viidii"];var dynCall_iiiiid=Module["dynCall_iiiiid"]=asm["dynCall_iiiiid"];var dynCall_viiiidddi=Module["dynCall_viiiidddi"]=asm["dynCall_viiiidddi"];var dynCall_viiii=Module["dynCall_viiii"]=asm["dynCall_viiii"];var dynCall_viiiii=Module["dynCall_viiiii"]=asm["dynCall_viiiii"];var dynCall_viiiidiiii=Module["dynCall_viiiidiiii"]=asm["dynCall_viiiidiiii"];var dynCall_vid=Module["dynCall_vid"]=asm["dynCall_vid"];var dynCall_iiidi=Module["dynCall_iiidi"]=asm["dynCall_iiidi"];var dynCall_iiidd=Module["dynCall_iiidd"]=asm["dynCall_iiidd"];var dynCall_vii=Module["dynCall_vii"]=asm["dynCall_vii"];var dynCall_viiiid=Module["dynCall_viiiid"]=asm["dynCall_viiiid"];var dynCall_viiiiddddi=Module["dynCall_viiiiddddi"]=asm["dynCall_viiiiddddi"];var dynCall_viidd=Module["dynCall_viidd"]=asm["dynCall_viidd"];var dynCall_viidi=Module["dynCall_viidi"]=asm["dynCall_viidi"];var dynCall_viiidiiddi=Module["dynCall_viiidiiddi"]=asm["dynCall_viiidiiddi"];var dynCall_diiid=Module["dynCall_diiid"]=asm["dynCall_diiid"];var dynCall_viiidddii=Module["dynCall_viiidddii"]=asm["dynCall_viiidddii"];var dynCall_viiiiiiii=Module["dynCall_viiiiiiii"]=asm["dynCall_viiiiiiii"];var dynCall_viiidddiiii=Module["dynCall_viiidddiiii"]=asm["dynCall_viiidddiiii"];var dynCall_viiiiiiid=Module["dynCall_viiiiiiid"]=asm["dynCall_viiiiiiid"];var dynCall_diiii=Module["dynCall_diiii"]=asm["dynCall_diiii"];var dynCall_viiiiidiiddi=Module["dynCall_viiiiidiiddi"]=asm["dynCall_viiiiidiiddi"];var dynCall_viiiiidii=Module["dynCall_viiiiidii"]=asm["dynCall_viiiiidii"];var dynCall_viiiddiddd=Module["dynCall_viiiddiddd"]=asm["dynCall_viiiddiddd"];var dynCall_iid=Module["dynCall_iid"]=asm["dynCall_iid"];var dynCall_viiiddid=Module["dynCall_viiiddid"]=asm["dynCall_viiiddid"];var dynCall_viiiiiii=Module["dynCall_viiiiiii"]=asm["dynCall_viiiiiii"];var dynCall_viididdi=Module["dynCall_viididdi"]=asm["dynCall_viididdi"];var dynCall_viiiiiid=Module["dynCall_viiiiiid"]=asm["dynCall_viiiiiid"];var dynCall_viiiiiiiii=Module["dynCall_viiiiiiiii"]=asm["dynCall_viiiiiiiii"];var dynCall_iii=Module["dynCall_iii"]=asm["dynCall_iii"];var dynCall_viiiddii=Module["dynCall_viiiddii"]=asm["dynCall_viiiddii"];var dynCall_viiididi=Module["dynCall_viiididi"]=asm["dynCall_viiididi"];var dynCall_vdiii=Module["dynCall_vdiii"]=asm["dynCall_vdiii"];var dynCall_viiiiiidii=Module["dynCall_viiiiiidii"]=asm["dynCall_viiiiiidii"];var dynCall_viiiidddiii=Module["dynCall_viiiidddiii"]=asm["dynCall_viiiidddiii"];var dynCall_viii=Module["dynCall_viii"]=asm["dynCall_viii"];var dynCall_v=Module["dynCall_v"]=asm["dynCall_v"];var dynCall_viid=Module["dynCall_viid"]=asm["dynCall_viid"];var dynCall_vi=Module["dynCall_vi"]=asm["dynCall_vi"];var dynCall_viiiidiiiidi=Module["dynCall_viiiidiiiidi"]=asm["dynCall_viiiidiiiidi"];var dynCall_ii=Module["dynCall_ii"]=asm["dynCall_ii"];var dynCall_viiiiiiiddi=Module["dynCall_viiiiiiiddi"]=asm["dynCall_viiiiiiiddi"];var dynCall_vididdi=Module["dynCall_vididdi"]=asm["dynCall_vididdi"];var dynCall_viiiiiidd=Module["dynCall_viiiiiidd"]=asm["dynCall_viiiiiidd"];var dynCall_vidii=Module["dynCall_vidii"]=asm["dynCall_vidii"];var dynCall_viiiidi=Module["dynCall_viiiidi"]=asm["dynCall_viiiidi"];var dynCall_viiiddiii=Module["dynCall_viiiddiii"]=asm["dynCall_viiiddiii"];var dynCall_viiiiiidiiiii=Module["dynCall_viiiiiidiiiii"]=asm["dynCall_viiiiiidiiiii"];var dynCall_iiii=Module["dynCall_iiii"]=asm["dynCall_iiii"];var dynCall_viididii=Module["dynCall_viididii"]=asm["dynCall_viididii"];var dynCall_viiiiddii=Module["dynCall_viiiiddii"]=asm["dynCall_viiiiddii"];var dynCall_iiid=Module["dynCall_iiid"]=asm["dynCall_iiid"];var dynCall_viiiiiiiiidd=Module["dynCall_viiiiiiiiidd"]=asm["dynCall_viiiiiiiiidd"];var dynCall_viiiidii=Module["dynCall_viiiidii"]=asm["dynCall_viiiidii"];var dynCall_diiiii=Module["dynCall_diiiii"]=asm["dynCall_diiiii"];var dynCall_diiiid=Module["dynCall_diiiid"]=asm["dynCall_diiiid"];var dynCall_iiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiii"]=asm["dynCall_iiiiiiiiiiiii"];var dynCall_iiiiiiiiiiiiiii=Module["dynCall_iiiiiiiiiiiiiii"]=asm["dynCall_iiiiiiiiiiiiiii"];var dynCall_viiiiiiddi=Module["dynCall_viiiiiiddi"]=asm["dynCall_viiiiiiddi"];var dynCall_iiidiii=Module["dynCall_iiidiii"]=asm["dynCall_iiidiii"];var dynCall_i=Module["dynCall_i"]=asm["dynCall_i"];var dynCall_iiidii=Module["dynCall_iiidii"]=asm["dynCall_iiidii"];var dynCall_diiiiii=Module["dynCall_diiiiii"]=asm["dynCall_diiiiii"];var dynCall_vididdii=Module["dynCall_vididdii"]=asm["dynCall_vididdii"];var dynCall_viiiiidiii=Module["dynCall_viiiiidiii"]=asm["dynCall_viiiiidiii"];var dynCall_viididi=Module["dynCall_viididi"]=asm["dynCall_viididi"];var dynCall_iiiiiiiii=Module["dynCall_iiiiiiiii"]=asm["dynCall_iiiiiiiii"];var dynCall_viididdii=Module["dynCall_viididdii"]=asm["dynCall_viididdii"];var dynCall_viiiiidiid=Module["dynCall_viiiiidiid"]=asm["dynCall_viiiiidiid"];var dynCall_viiiidd=Module["dynCall_viiiidd"]=asm["dynCall_viiiidd"];var dynCall_vidiii=Module["dynCall_vidiii"]=asm["dynCall_vidiii"];Runtime.stackAlloc=Module["stackAlloc"];Runtime.stackSave=Module["stackSave"];Runtime.stackRestore=Module["stackRestore"];Runtime.establishStackSpace=Module["establishStackSpace"];Runtime.setTempRet0=Module["setTempRet0"];Runtime.getTempRet0=Module["getTempRet0"];Module["asm"]=asm;Module["then"]=(function(func){if(Module["calledRun"]){func(Module)}else{var old=Module["onRuntimeInitialized"];Module["onRuntimeInitialized"]=(function(){if(old)old();func(Module)})}return Module});function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}ExitStatus.prototype=new Error;ExitStatus.prototype.constructor=ExitStatus;var initialStackTop;var preloadStartTime=null;var calledMain=false;dependenciesFulfilled=function runCaller(){if(!Module["calledRun"])run();if(!Module["calledRun"])dependenciesFulfilled=runCaller};Module["callMain"]=Module.callMain=function callMain(args){args=args||[];ensureInitRuntime();var argc=args.length+1;function pad(){for(var i=0;i<4-1;i++){argv.push(0)}}var argv=[allocate(intArrayFromString(Module["thisProgram"]),"i8",ALLOC_NORMAL)];pad();for(var i=0;i<argc-1;i=i+1){argv.push(allocate(intArrayFromString(args[i]),"i8",ALLOC_NORMAL));pad()}argv.push(0);argv=allocate(argv,"i32",ALLOC_NORMAL);try{var ret=Module["_main"](argc,argv,0);exit(ret,true)}catch(e){if(e instanceof ExitStatus){return}else if(e=="SimulateInfiniteLoop"){Module["noExitRuntime"]=true;return}else{var toLog=e;if(e&&typeof e==="object"&&e.stack){toLog=[e,e.stack]}Module.printErr("exception thrown: "+toLog);Module["quit"](1,e)}}finally{calledMain=true}};function run(args){args=args||Module["arguments"];if(preloadStartTime===null)preloadStartTime=Date.now();if(runDependencies>0){return}preRun();if(runDependencies>0)return;if(Module["calledRun"])return;function doRun(){if(Module["calledRun"])return;Module["calledRun"]=true;if(ABORT)return;ensureInitRuntime();preMain();if(Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();if(Module["_main"]&&shouldRunNow)Module["callMain"](args);postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout((function(){setTimeout((function(){Module["setStatus"]("")}),1);doRun()}),1)}else{doRun()}}Module["run"]=Module.run=run;function exit(status,implicit){if(implicit&&Module["noExitRuntime"]){return}if(Module["noExitRuntime"]){}else{ABORT=true;EXITSTATUS=status;STACKTOP=initialStackTop;exitRuntime();if(Module["onExit"])Module["onExit"](status)}if(ENVIRONMENT_IS_NODE){process["exit"](status)}Module["quit"](status,new ExitStatus(status))}Module["exit"]=Module.exit=exit;var abortDecorators=[];function abort(what){if(Module["onAbort"]){Module["onAbort"](what)}if(what!==undefined){Module.print(what);Module.printErr(what);what=JSON.stringify(what)}else{what=""}ABORT=true;EXITSTATUS=1;var extra="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";var output="abort("+what+") at "+stackTrace()+extra;if(abortDecorators){abortDecorators.forEach((function(decorator){output=decorator(output,what)}))}throw output}Module["abort"]=Module.abort=abort;if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}var shouldRunNow=true;if(Module["noInitialRun"]){shouldRunNow=false}run();Module["imread"]=(function(imageSource){var img=null;if(typeof imageSource==="string"){img=document.getElementById(imageSource)}else{img=imageSource}var canvas=null;var ctx=null;if(img instanceof HTMLImageElement){canvas=document.createElement("canvas");canvas.width=img.width;canvas.height=img.height;ctx=canvas.getContext("2d");ctx.drawImage(img,0,0,img.width,img.height)}else if(img instanceof HTMLCanvasElement){canvas=img;ctx=canvas.getContext("2d")}else{throw new Error("Please input the valid canvas or img id.");return}var imgData=ctx.getImageData(0,0,canvas.width,canvas.height);return cv.matFromImageData(imgData)});Module["imshow"]=(function(canvasSource,mat){var canvas=null;if(typeof canvasSource==="string"){canvas=document.getElementById(canvasSource)}else{canvas=canvasSource}if(!(canvas instanceof HTMLCanvasElement)){throw new Error("Please input the valid canvas element or id.");return}if(!(mat instanceof cv.Mat)){throw new Error("Please input the valid cv.Mat instance.");return}var img=new cv.Mat;var depth=mat.type()%8;var scale=depth<=cv.CV_8S?1:depth<=cv.CV_32S?1/256:255;var shift=depth===cv.CV_8S||depth===cv.CV_16S?128:0;mat.convertTo(img,cv.CV_8U,scale,shift);switch(img.type()){case cv.CV_8UC1:cv.cvtColor(img,img,cv.COLOR_GRAY2RGBA);break;case cv.CV_8UC3:cv.cvtColor(img,img,cv.COLOR_RGB2RGBA);break;case cv.CV_8UC4:break;default:throw new Error("Bad number of channels (Source image must have 1, 3 or 4 channels)");return}var imgData=new ImageData(new Uint8ClampedArray(img.data),img.cols,img.rows);var ctx=canvas.getContext("2d");ctx.clearRect(0,0,canvas.width,canvas.height);canvas.width=imgData.width;canvas.height=imgData.height;ctx.putImageData(imgData,0,0);img.delete()});Module["VideoCapture"]=(function(videoSource){var video=null;if(typeof videoSource==="string"){video=document.getElementById(videoSource)}else{video=videoSource}if(!(video instanceof HTMLVideoElement)){throw new Error("Please input the valid video element or id.");return}var canvas=document.createElement("canvas");canvas.width=video.width;canvas.height=video.height;var ctx=canvas.getContext("2d");this.video=video;this.read=(function(frame){if(!(frame instanceof cv.Mat)){throw new Error("Please input the valid cv.Mat instance.");return}if(frame.type()!==cv.CV_8UC4){throw new Error("Bad type of input mat: the type should be cv.CV_8UC4.");return}if(frame.cols!==video.width||frame.rows!==video.height){throw new Error("Bad size of input mat: the size should be same as the video.");return}ctx.drawImage(video,0,0,video.width,video.height);frame.data.set(ctx.getImageData(0,0,video.width,video.height).data)})});function Range(start,end){this.start=typeof start==="undefined"?0:start;this.end=typeof end==="undefined"?0:end}Module["Range"]=Range;function Point(x,y){this.x=typeof x==="undefined"?0:x;this.y=typeof y==="undefined"?0:y}Module["Point"]=Point;function Size(width,height){this.width=typeof width==="undefined"?0:width;this.height=typeof height==="undefined"?0:height}Module["Size"]=Size;function Rect(){switch(arguments.length){case 0:{this.x=0;this.y=0;this.width=0;this.height=0;break};case 1:{var rect=arguments[0];this.x=rect.x;this.y=rect.y;this.width=rect.width;this.height=rect.height;break};case 2:{var point=arguments[0];var size=arguments[1];this.x=point.x;this.y=point.y;this.width=size.width;this.height=size.height;break};case 4:{this.x=arguments[0];this.y=arguments[1];this.width=arguments[2];this.height=arguments[3];break};default:{throw new Error("Invalid arguments")}}}Module["Rect"]=Rect;function RotatedRect(){switch(arguments.length){case 0:{this.center={x:0,y:0};this.size={width:0,height:0};this.angle=0;break};case 3:{this.center=arguments[0];this.size=arguments[1];this.angle=arguments[2];break};default:{throw new Error("Invalid arguments")}}}RotatedRect.points=(function(obj){return Module.rotatedRectPoints(obj)});RotatedRect.boundingRect=(function(obj){return Module.rotatedRectBoundingRect(obj)});RotatedRect.boundingRect2f=(function(obj){return Module.rotatedRectBoundingRect2f(obj)});Module["RotatedRect"]=RotatedRect;function Scalar(v0,v1,v2,v3){this.push(typeof v0==="undefined"?0:v0);this.push(typeof v1==="undefined"?0:v1);this.push(typeof v2==="undefined"?0:v2);this.push(typeof v3==="undefined"?0:v3)}Scalar.prototype=new Array;Scalar.all=(function(v){return new Scalar(v,v,v,v)});Module["Scalar"]=Scalar;function MinMaxLoc(){switch(arguments.length){case 0:{this.minVal=0;this.maxVal=0;this.minLoc=new Point;this.maxLoc=new Point;break};case 4:{this.minVal=arguments[0];this.maxVal=arguments[1];this.minLoc=arguments[2];this.maxLoc=arguments[3];break};default:{throw new Error("Invalid arguments")}}}Module["MinMaxLoc"]=MinMaxLoc;function Circle(){switch(arguments.length){case 0:{this.center=new Point;this.radius=0;break};case 2:{this.center=arguments[0];this.radius=arguments[1];break};default:{throw new Error("Invalid arguments")}}}Module["Circle"]=Circle;function TermCriteria(){switch(arguments.length){case 0:{this.type=0;this.maxCount=0;this.epsilon=0;break};case 3:{this.type=arguments[0];this.maxCount=arguments[1];this.epsilon=arguments[2];break};default:{throw new Error("Invalid arguments")}}}Module["TermCriteria"]=TermCriteria;Module["matFromArray"]=(function(rows,cols,type,array){var mat=new cv.Mat(rows,cols,type);switch(type){case cv.CV_8U:case cv.CV_8UC1:case cv.CV_8UC2:case cv.CV_8UC3:case cv.CV_8UC4:{mat.data.set(array);break};case cv.CV_8S:case cv.CV_8SC1:case cv.CV_8SC2:case cv.CV_8SC3:case cv.CV_8SC4:{mat.data8S.set(array);break};case cv.CV_16U:case cv.CV_16UC1:case cv.CV_16UC2:case cv.CV_16UC3:case cv.CV_16UC4:{mat.data16U.set(array);break};case cv.CV_16S:case cv.CV_16SC1:case cv.CV_16SC2:case cv.CV_16SC3:case cv.CV_16SC4:{mat.data16S.set(array);break};case cv.CV_32S:case cv.CV_32SC1:case cv.CV_32SC2:case cv.CV_32SC3:case cv.CV_32SC4:{mat.data32S.set(array);break};case cv.CV_32F:case cv.CV_32FC1:case cv.CV_32FC2:case cv.CV_32FC3:case cv.CV_32FC4:{mat.data32F.set(array);break};case cv.CV_64F:case cv.CV_64FC1:case cv.CV_64FC2:case cv.CV_64FC3:case cv.CV_64FC4:{mat.data64F.set(array);break};default:{throw new Error("Type is unsupported")}}return mat});Module["matFromImageData"]=(function(imageData){var mat=new cv.Mat(imageData.height,imageData.width,cv.CV_8UC4);mat.data.set(imageData.data);return mat})





  return cv;
};
if (typeof module === "object" && module.exports) {
  module['exports'] = cv;
};

  if (typeof Module === 'undefined')
    Module = {};
  return cv(Module);
}));
    